(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = input; initialization; preserveAspect]
*)
Unprotect["Hermann`BlackScholes`*"];
Clear["Hermann`BlackScholes`*"];
Remove["Hermann`BlackScholes`Private`*"];
(*
;[s]
3:0,0;36,1;37,0;112,-1;
2:2,12,10,Courier,1,12,0,0,0;1,12,10,Courier,0,12,0,0,0;
:[font = input; initialization; preserveAspect]
*)
BeginPackage["Hermann`BlackScholes`",
				{"Hermann`Kronecker`",
				 "Miscellaneous`Calendar`", 
				 "Statistics`Common`DistributionsCommon`",
				 "Statistics`DiscreteDistributions`",
				 "Statistics`NormalDistribution`",                                       
                 "Global`"}]
                 

(*
:[font = section; inactive; initialization; preserveAspect; startGroup]
Usage 
:[font = input; initialization; preserveAspect; endGroup]
*)

Rendite::usage = "Rendite[y,DeltaT,dt], 
	(y(t+DeltaT) - y(t))/(y(t)DeltaT)"

Moment::usage = "Moment[x_,k_]:= Apply[Plus,x^k]/Length[x]"

MomenteRendite::usage = "MomenteRendite[S_,T_,dt_]; Momente der 
	Rendite mit lag Deltat = i dt als Funktion des lags"
	
DezimalJahr::usage = "DezimalJahr[{tag,monat,jahr}] oder DezimalJahr[tag,monat,jahr]"
	
BlackScholes::usage = "BlackScholes[s,x,sigma2,T,rf]"

OptionDelta::usage = "OptionDelta[SS_,KK_,sigmaqq_,tt_,rr_] = 
	D[BlackScholes[SS,KK,sigmaqq,tt,rr],SS]"
	
EXPANDDATA::usage = "EXPANDDATA[datum,S,MISS], fllt 
	datum mit Datumsangaben und S mit MISS"
	
INTERPOL1::usage = "INTERPOL1[XM_,MISS_,ORDER_], XM: T x p"
	
BinomialProzess::usage = "BinomialProzess[g_,s_,q_,T_,delta_,dt_,S0_]"
	
BinomialProzess1::usage = "BinomialProzess1[g_,s_,q_,T_,delta_,dt_,S0_]" 
	
BinomialPreis::usage = "BinomialPreis[S0_,K_,g_,s_,T_,n_,rJahr_]" 	

GBB::usage = "GBB[dt_,mue_,sigma_,T1_,S0_], exakte Simulation, 
	S0 Exp[(mue - sigma ^2/2)t + W(t)]"
	
LevyGoldstein::usage = "LevyGoldstein[y_,dt_,{lag1_,lag2_:0}]"

(*
:[font = section; inactive; initialization; preserveAspect; plain; startGroup]
Implementierung
:[font = input; initialization; preserveAspect; plain]
*)
 	
Begin["`Private`"]

Rendite[y_,DeltaT_,dt_] := 
	Module[{lag,y1,y2},
		lag = DeltaT/dt;
		y1 = Drop[y,lag];
		y2 = Drop[y,-lag];
		
		(y1/y2-1)/ DeltaT
	]
	
DezimalJahr[{tag_,monat_,jahr_}] := 
	(tag-1)/365 + (monat-1)/12 + jahr //N;	

DezimalJahr[tag_,monat_,jahr_] := 
	(tag-1)/365 + (monat-1)/12 + jahr //N;
		
BlackScholes[s_,x_,sigma2_,T_,rf_] := 
	Module[{lnsx,st,d1,d2},
		If[T == 0,Return[Max[s-x,0]]];
		lnsx = Log[s/x];
		st = Sqrt[sigma2 T];
		d1 = (lnsx + (rf + .5 sigma2)T )/st;
		(*d2 = (lnsx + (rf - .5 sigma2)T )/st;*)
		d2 = d1 - st;
		
		s GaussCumul[d1,0.,1.] - Exp[-rf T] x GaussCumul[d2,0.,1.] //N
	]
SetAttributes[BlackScholes,Listable];

OptionDelta[SS_,KK_,sigmaqq_,tt_,rr_] = 
	D[BlackScholes[SS,KK,sigmaqq,tt,rr],SS];
		
EXPANDDATA//Clear
EXPANDDATA[datum_,S_,MISS_] := 
Module[{datum1,S1,start,end,calendardate,realdate},
datum1 = datum//Rationalize;
S1 = S;
start = datum1//First//Reverse; (*amerikanisch*)
end   = datum1//Last//Reverse;
calendardate = start;

For[ i = 0, calendardate != end, i++, 

	calendardate = DaysPlus[start, i];
	realdate=datum1[[i+1]]//Reverse;
	(*Print[calendardate,realdate];*)
	If[calendardate != realdate,
		datum1 = Insert[datum1,calendardate//Reverse,i+1];
		S1 = Insert[S1,MISS,i+1];
	]
];

{datum1,S1}
]

(***************************************************************)
INTERPOL1[XM_,MISS_,ORDER_] := 
(***************************************************************)
(*ohne n*)
	Module[{XMr,Xint,tau3,T1,q,data},
		{T1,q} = XM//Dimensions;
		XMr = XM//Reverse;
		
		Xint = 
		Table[
		
							tau3 = Locate[XMr[[T1//Range,qq]] ~ne~ MISS];(*Messungen*)
							tau3//Print;
							
							If[tau3=={},
							
											Print["keine Messungen in Spalte ",qq];
							    Column[XMr,qq],
							
							(*else*)
							
							    If[First[tau3]!=1,XMr[[ 1,qq]]=XMr[[First[tau3],qq ]];
							                      tau3=Join[{1},tau3]     ];
							
							
						    	If[ Last[tau3]!=T1,XMr[[T1,qq]]=XMr[[ Last[tau3],qq ]];
							                       tau3=Join[tau3,{T1}]     ];
							    (*XMr//Print;*)
							    data = {tau3,XMr[[tau3,qq]]}//Transpose;
   			    	Interpolation[data,InterpolationOrder->ORDER][T1//Range]
   				]
   				
  ,{qq,q}];
  
		Transpose[Xint]//Reverse
	 ]	

BinomialProzess//Clear
BinomialProzess[g_,s_,q_,T_,delta_,dt_,S0_] :=
	Module[{gstern,sstern,n,y,yt,st},

	{gstern,sstern} = Log[{g,s}];
	m = delta/dt //Round;
	n = Table[Random[BernoulliDistribution[q]],{m T}];
	y = gstern n + sstern (1-n);
	yt = FoldList[Plus,Log[S0],y];
	yt = yt[[ Range[1,m T +1,m]  ]];
	st = Exp[yt];
	{yt,st}
	]
	
BinomialProzess1//Clear
BinomialProzess1[g_,s_,q_,T_,delta_,dt_,S0_] :=
	Module[{gstern,sstern,n,y,yt,st},

	{gstern,sstern} = Log[{g,s}];
	m  = delta/dt //Round;
	Bi[mm_,qq_] := Random[BinomialDistribution[mm,qq]] - mm qq;
	drift = m*(gstern q + sstern(1-q));
	drift//Print;
	yt = NestList[(# + drift + Bi[m,q])&,Log[S0],T];
	st = Exp[yt];
	{yt,st}
	]
	
BinomialPreis[S0_,K_,g_,s_,T_,n_,rJahr_] := 
	Module[{b1,b2,f,a,r,p,ps},
	r = rJahr^(T/n);
	p = (r-s)/(g-s);
 ps = p g/r;
	a = Log[K/(S0 s^n)]/Log[g/s]//Ceiling;
	(*a//Print;*)
	
	b1 = 1 - CDF[BinomialDistribution[n, ps],a-1];
	b2 = 1 - CDF[BinomialDistribution[n, p], a-1];
	
	(*S0 b1 - K r^(-n) b2*)
	S0 b1 - K rJahr^(-T) b2
	]
	
GBB//Clear
GBB[dt_,mue_,sigma_,T_,S0_] :=
	Module[{whitenoise,wt,y0,yt,st},
	whitenoise = Table[Random[NormalDistribution[0,1]],{T}];
	wt = Sqrt[dt] FoldList[Plus,0,whitenoise];
	y0 = Log[S0//N];
	yt = y0 + (mue - sigma^2/2) dt Range[0,T] + sigma wt;
	st = Exp[yt];
	{yt,st}
	]

Moment[x_,k_]:= Apply[Plus,x^k]/Length[x]

MomenteRendite[S_,T_,dt_]:= 

Module[{data,r,ri},
data = Table[
             ri = Rendite[S,i dt,dt];
             m1 = Moment[ri,1];
             rim = ri-m1;
             m2 = Moment[rim,2];
             m3 = Moment[rim,3];
             m4 = Moment[rim,4];
             {m1,m2,m3,m4}
       ,{i,1,T,1}];
       
data = AddTimeAxis[data,{dt,T dt,dt}];
data = data//Abs//Log;  (* doppelt logarithmisch *)
fitted=Map[Fit[Column[data,{1,#}],{1,x},{x}]&,{2,3,4,5}];
g1 = plot1[data,PlotJoined->False,
		   AspectRatio->1,
           dicke->.02,farbmodell->Hue,
           DisplayFunction->Identity];
g2 = plot1[data,PlotJoined->True,
		   AspectRatio->1,
           dicke->.001,farbmodell->Hue,
           DisplayFunction->Identity];
Show[g1,g2,DisplayFunction->$DisplayFunction];
clist = CoefficientList[fitted,x];
mue = clist[[1,1]]//Exp; 
s2  = clist[[2,1]]//Exp//Sqrt;
s4  = (Exp[clist[[4,1]]]/3)^(1/4);
Print[clist//MatrixForm];
Print["Rendite = ",mue];
Print["Volatilitt (2. und 4. Moment) = ",{s2,s4}];
Print["Kurtosis = ",m4/(m2^2)];
{fitted,clist}
]

LevyGoldstein//Clear
LevyGoldstein[y_,dt_,{lag1_,lag2_:0}]:=
	Module[{r,sigma2dach,sigma2dachQ},
	r = Rendite[y,dt,dt];
	sigma2dach = (r^2)*dt;
	sigma2dachQ = MovingMean[sigma2dach,{lag1,lag2},Apply[Plus,#]&];
	{sigma2dachQ,r}
	]	
				
End[ ]

Protect[Names["Hermann`BlackScholes`*"]//Evaluate];

EndPackage[ ]

(*
;[s]
7:0,0;750,1;760,0;768,1;778,0;4922,1;4946,0;4976,-1;
2:4,12,10,Courier,0,12,0,0,0;3,12,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect; startGroup]
Names["Hermann`BlackScholes`*"]
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup; endGroup]
 {"BinomialPreis", "BinomialProzess", "BinomialProzess1", "BlackSc\
  holes", "DezimalJahr", "ExpandData", "GBB", "INTERPOL1", "LevyGo\
  ldstein", "Moment", "MomenteRendite", "OptionDelta", "Rendite"}
;[o]
 {BinomialPreis, BinomialProzess, BinomialProzess1, BlackScholes, 
  DezimalJahr, ExpandData, GBB, INTERPOL1, LevyGoldstein, Moment, 
  MomenteRendite, OptionDelta, Rendite}
^*)
