(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M18, N23, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Geneva"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = input; initialization; preserveAspect; plain]
*)
(***************************************************************)			 
TimeUpEKFSmooth2Order//Clear
TimeUpEKFSmooth2Order[{Yii_,Pii_,X_,dt_},Theta_,
                      {f_,Df_,DDf_,Omega_,DDOmega_}]:=
(***************************************************************)			 
Module[{T,p,i,xi,A,DA,O,DDO,AP,Yi1i,Pi1i,Astern,Phi,F},

T = Length[X]; (* T//Print; *)

Yi1i = Yii;
Pi1i = Pii;
Phi = IdentityMatrix[Yii//Length];


Do[ 
	xi = X[[i]];
    A  =      Df[Yi1i,xi,Theta]; 
    DA =     DDf[Yi1i,xi,Theta]; 
    O  =   Omega[Yi1i,xi,Theta];
    DDO= DDOmega[Yi1i,xi,Theta];
    
   
    Yi1i = Yi1i + (f[Yi1i,xi,Theta] + .5 Map[MatrixTrace,DA.Pi1i]) dt;
	 
             (* Korrektur 2. Ordnung = Ito-Taylor Entwicklung *)
             
   	(* Yi1i = Over[Yi1i,YMAX];*)
   	
	Astern = IdPlusA[A dt];
	
	Pi1i = Astern.Pi1i.Transpose[Astern] + 
	                       (O + 0.5 Map[MatrixTrace[#.Pi1i]&,DDO,{2}]) dt; 
	
	Phi = Astern.Phi;  (* Phi//Print; *)
	
	(* {Yi1i,Pi1i,Phi}//Print; *)
	
,{i,1,T}];

F = Pii.Transpose[Phi].Inverse[Pi1i];

{Yi1i,Pi1i,F}]
(*
:[font = input; initialization; preserveAspect; plain]
*)
(***************************************************************)			 
TimeUpEKFSmooth22Order//Clear
TimeUpEKFSmooth22Order[{Yii_,_,X_,dt_},Theta_,
                       {f_,Df_,DDf_,Omega_,DDOmega_}]:=
(***************************************************************)			 
Module[{T,p,i,xi,A,DA,O,DDO,AP,Yi1i,Pi1i,Astern,Phi,Pj1j,F},

T = Length[X];  (* T//Print; *)
p = Yii//Length;


xi = X[[1]];	
Phi  = IdentityMatrix[p];    
   
Pi1i = Pj1j = Omega[Yii,xi,Theta] dt;
Yi1i = Yii + f[Yii,xi,Theta] dt;   
	
Do[ 
	xi = X[[i]];
    A  =      Df[Yi1i,xi,Theta]; 
    DA =     DDf[Yi1i,xi,Theta]; 
    O  =   Omega[Yi1i,xi,Theta];
    DDO= DDOmega[Yi1i,xi,Theta];
  	
	Yi1i = Yi1i + (f[Yi1i,xi,Theta] + .5 Map[MatrixTrace,DA.Pi1i]) dt;
	
	Astern = IdPlusA[A dt];
	Pi1i = Astern.Pi1i.Transpose[Astern] + 
	       (O + 0.5 Map[MatrixTrace[#.Pi1i]&,DDO,{2}]) dt; 
	  	
	Phi = Astern.Phi;  (* Phi//Print; *) (* Phi(t_i+1,tau_j *)
		
,{i,2,T}];

F = Pj1j.Transpose[Phi].Inverse[Pi1i]; (* Gain fr bergangsw.*)

(* Print["Korr.   ",T,Yi1i]; *)

{Yi1i,Pi1i,F}]
(*
:[font = input; initialization; preserveAspect; plain]
*)
(***************************************************************)			 
SmoothEKF12Order//Clear
SmoothEKF12Order[{Z_,Yii_,Pii_,X_,dt_},Theta_,
                 {f_,Df_,DDf_,Omega_,DDOmega_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Module[{Yi1i,Pi1i,F,Yi1i1,Pi1i1,yii,pii,liki},

	{Yi1i,Pi1i,F} = TimeUpEKFSmooth2Order[{Yii,Pii,X,dt},Theta,
	                                      {f,Df,DDf,Omega,DDOmega}];
	
	(*{Yi1i,Pi1i,F} //Print; *)
	
	(* Yi1i = Over[Yi1i,YMAX]; *)
	
	{Yi1i1,Pi1i1,liki} = MessUpEKF[{Z,{Yi1i,Pi1i},X//Last,_},Theta,{h,Dh,R},{miss}];	
	
	yii = Yii + F.(Yi1i1-Yi1i);
	pii = Pii + F.(Pi1i1-Pi1i).Transpose[F];
	
	{yii,pii,liki}
	
]
	
(*
:[font = input; initialization; preserveAspect; plain]
*)
(***************************************************************)			 
SmoothEKF2Order//Clear
SmoothEKF2Order[{Z_,Yii_,Pii_,alphaii_,X_,dt_},Theta_,
                {f_,Df_,DDf_,Omega_,DDOmega_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Module[{yiiZ,PiiZ,alphaiiZ,likZ,c},

{yiiZ,PiiZ,likZ}=
MapThread[SmoothEKF12Order[{Z,#1,#2,X,dt},Theta,
                           {f,Df,DDf,Omega,DDOmega,h,Dh,R},miss]&,
	                       {Yii,Pii}]//Transpose;
c = likZ//Max; 
alphaiiZ=alphaii*Exp[likZ-c];	
alphaiiZ=alphaiiZ/Apply[Plus,alphaiiZ];

(*alphaiiZ=alphaii;*) (*alt*)

(*Print["likZ   ",likZ];*)
(*
Print["alphaii  ",alphaii];
Print["alphaiiZ ",alphaiiZ];
Print["yiiZ     ",yiiZ];
Print["PiiZ     ",PiiZ];
*)
                 
{yiiZ,PiiZ,alphaiiZ}	        
]	
(*
:[font = input; initialization; preserveAspect; plain]
*)
(***************************************************************)			 
SmoothEKF22Order//Clear
SmoothEKF22Order[{Z_,etaj_,_,X_,dt_},Theta_,
                 {f_,Df_,DDf_,Omega_,DDOmega_,h_,Dh_,R_},miss_]:=
(***************************************************************)			 
Module[{Yi1j,Pi1j,Fj,Yi1ji1,Pi1ji1,liki,fI,OmegaI},

	{Yi1j,Pi1j,Fj} = TimeUpEKFSmooth22Order[{etaj,_,X,dt},Theta,
	                                        {f,Df,DDf,Omega,DDOmega}];
	
	(* X//Print;
	{Yi1j,Pi1j,Fj}//Print;*)
	
	(*Yi1j//Abs//Max//Print;*)
		
	(* Yi1j = Over[Yi1j,YMAX]; *)
	
	{Yi1ji1,Pi1ji1,liki} = 
	            MessUpEKF[{Z,{Yi1j,Pi1j},X//Last,_},Theta,{h,Dh,R},{miss}];	
	
	fI     = Fj.(Yi1ji1-Yi1j)/dt;
	OmegaI = Fj.(Pi1ji1-Pi1j).Transpose[Fj]/dt;
	
	
	
	{fI,OmegaI}
	
]
	
(*
:[font = input; initialization; preserveAspect; plain]
*)
loglikelihoodO//Clear
(***************************************************************)			 
loglikelihoodO[y_,x_,f1_,Omega1_,t_,dt_,Theta_]:=
(***************************************************************)			 
 Module[{omega1,omega1I,dy,dy1,F1},
	
	 omega1  = Omega1[x,t,Theta]*dt; 
	 omega1I = Inverse[omega1];
	 
	 F1 = f1[x,t,Theta];
	 
	 dy = y-x;
	 dy1 = dy - F1 dt;  
	 
	 -0.5*(  dy1.omega1I.dy1 + Log[Det[omega1]] ) 
	 ];
	 
	 	 	 	 
 
 
LogLikelihoodO//Clear
(***************************************************************)			 
LogLikelihoodO[Y_,f1_,Omega1_,time_,dt_,Theta_]:=
(***************************************************************)			 
Module[{p,out},
 p = loglikelihoodO[#1,#2,f1,Omega1,#3,dt,Theta]&;
 Apply[Plus,MapThread[p,{Drop[Y,1],Drop[Y,-1],Drop[time,-1]}]]
 ]
(*
;[s]
5:0,0;92,1;106,0;540,1;554,0;793,-1;
2:3,12,10,Courier,0,12,0,0,0;2,12,10,Courier,0,12,65535,0,0;
:[font = input; initialization; preserveAspect; plain]
*)
FIFImportanceSmooth2Order//Clear
(***************************************************************)			 
FIFImportanceSmooth2Order[{Z_,X_},Theta_,
                    {f_,Df_,DDf_,Omega_,DDOmega_,h_,Dh_,R_,p0_,dt_},
				                {{l0_,l1_,l2_:0},step_,dW_,seed_,Generator_,
				                 miss_,option_:1}]:=
(***************************************************************)			 
(* Funktional-Integral mit exaktem importance sampling
   fr lineare Systeme
   
   2. order EKF 
   
   int p(y_J|y_J-1)...p(y_1|y_0)p_i|i(y_0)
   p_{i+1|i} = 1/N sum p(y_{i+1} = y_J|y_J-1) * alpha{i+1|i}; 
   dy = fdt + gdW 
 
   option = 1: lik, 
   option = 2: YF: TxNxp,(Stichproben-Trajektorien) 
   option = 3: YF: Tx2xp (m und s)

*)

Module[{ti,T1,T,dti,dti1,n,n1,Xi,z,y0,P0,yiiR,lik,yii,Pii,alphaii,alphai1i,alphaiiZ,
        YF,Misch,likvec,xi,dwi,yJ1,y,G,Pi1i,yi1i,liki,f2g2,fI,f2,f1,g1,g2,XZ,p,
        likratio,lik2,lik1,Zi1},

{ti,T1,T,dti,dti1} = Zeiten1[Z,miss];

(*
ti//Print;
dti//Print;  
dti1//Print;
*) 

n = Length[dW]; n1 = 1./n; 

Print["FIFImportanceSmooth2Order: Monte-Carlo-Stichprobe n = ",n,"  seed = ", seed];

f2g2//Clear;
f2g2[y_,{XX_,z_},Th_]:= Module[{fI,OmegaI,F1,F2,O,G2},
		   
		  (*Print["in f2g2"];*)
		   
	   {fI,OmegaI} = SmoothEKF22Order[{z,y,_,XX,dt},Th,
	                            {f,Df,DDf,Omega,DDOmega,h,Dh,R},miss];	
	
	   F1 = f[y,XX//First,Th];
	   F2 = F1 + l0*fI;
	 
	   O = Omega[y,XX//First,Th];  
	   G2 =  CholeskyDecomposition[ O + l1*OmegaI ]//Transpose;
	   
	   (* Print[XX//First,F1,F2,O,G2]; *) 
	 
	 {F2,G2}	 ];
	 
	 
{yi1i,Pi1i,alphai1i} = p0[X[[1]],Theta,n];

{yiiR,lik,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Z[[1]],{yi1i,Pi1i,alphai1i},X[[1]]},Theta,{h,Dh,R},
		                  {miss,n,Generator,seed,False}];
		                  
likneu=lik;

{yiiZ,PiiZ,alphaiiZ} = 
        SmoothEKF2Order[{Z[[ti[[2]] ]],yii,Pii,alphaii,Take[X,dti[[1]] ],dt},Theta,
                        {f,Df,DDf,Omega,DDOmega,h,Dh,R},miss];



yiiR = RandomKDE[yiiZ,alphaiiZ,PiiZ,Generator,seed,n]; (* resampling *)

p0Z = Map[likratio0[#,{yii,Pii,alphaii},{yiiZ,PiiZ,alphaiiZ}]&,yiiR];	                
		                  				                 	
YF   = {}; Misch = {}; likvec = {lik};

Do[  

	j = ti[[i+1]];      (*Print[{i+1,j}];*)
	Zi1 = Z[[j]];
	
	Xi  = Take[ X,dti[[i]] ];
	XZ  = Table[{Drop[Xi,j-1],Zi1},{j,1,Xi//Length}];
	
	(*XZ//Print; *)
	
	
 xi  = Xi//Last;
	dwi = Map[Take[#,dti1[[i]] ]&,dW];
	 
	{y,lik2} = MapThread[RungeKutta1Lik[f2g2,#1,{XZ,#2},
	                     Length[XZ]-1,dt,Theta,EulerStep1Lik]&,{yiiR,dwi}]//Transpose;

 yJ1 = Map[Last,y];
 
 (* yJ1//Print; lik2//Print; *)
	
 Pi1i =   Map[Omega[#,xi,Theta]&,yJ1] dt;
 yi1i = yJ1 + Map[f[#,xi,Theta]&,yJ1] dt; 

 (*
 Print[Pi1i//First]; 
 yi1i//Print;
 *)
  
	yi1i = Over[yi1i,YMAX];
	(*y  = Over[y,YMAX];*)

	If[option==2,
				 YF = Join[YF,y//Transpose];
				 (*YF//Print;*)     
	  ];
	  
	If[option==3,
	    (*y//Dimensions//Print;
	    y//TensorMS//Dimensions//Print;*)
				 YF = Join[YF,y//TensorMS//Transpose];
				 (*YF//Print; *) 
	  ];
	     

	If[dti1[[i]] =!= 1,
				
				lik1=Map[LogLikelihoodO[#,f,Omega,Xi,dt,Theta]&,y];
				alphai1i = n1*Exp[lik1-lik2]*p0Z,	  
	
				alphai1i = n1*p0Z
	];
	
	

(* Print["lik1 ",lik1]; Print["lik2 ",lik2]; *)


	{yiiR,liki,yii,Pii,alphaii} = 
		    MessUpOmnibus[{Zi1,{yi1i,Pi1i,alphai1i},X[[j]]},
				                 Theta,{h,Dh,R},{miss,n,Generator,seed,False}];
				                 
	(*Print[liki1,"   ",liki];*) 

	If[i < Length[ti]-1,
	
				{yiiZ,PiiZ,alphaiiZ} = SmoothEKF2Order[{Z[[ti[[i+2]]]],
				                             yii,Pii,alphaii,Take[X,dti[[i+1]] ],dt},
				                             Theta,{f,Df,DDf,Omega,DDOmega,h,Dh,R},miss];
				                      
 		 yiiR = RandomKDE[yiiZ,alphaiiZ,PiiZ,Generator,seed,n]; (* resampling *)
 		 
 		 p0Z = Map[likratio0[#,{yii,Pii,alphaii},{yiiZ,PiiZ,alphaiiZ}]&,yiiR];	                
					
  ];
  		
	(*liki//Print;*)	
	
	likvec = Append[likvec,liki];	
	lik +=liki;
	
	likneu+=liki1;
	
,{i,1,Length[ti]-1}];



If[option==1,Return[lik] ];

If[option==2,
	YF = Join[YF,{yiiR}];
	Return[{YF,lik,likvec}] ];
	
If[option==3,
	YF = Join[YF,{yiiR//TensorMS}];
	Return[{YF,lik,Misch}] ];	
	
];
(*
;[s]
12:0,1;25,0;103,1;128,0;1054,1;1081,0;1267,1;1273,0;1851,1;1857,0;3547,1;3553,0;4225,-1;
2:6,12,10,Courier,0,12,0,0,0;6,12,10,Courier,0,12,65535,0,0;
:[font = input; preserveAspect; startGroup]
??FIFImportanceSmooth2Order
:[font = print; inactive; preserveAspect; endGroup]
Global`FIFImportanceSmooth2Order
FIFImportanceSmooth2Order[{Z_, X_}, Theta_, {f_, Df_, DDf_, Omega_, DDOmega_, h_, Dh_, R_, p0_, dt_}, {{l0_, l1_, l2_:0}, step_, dW_, seed_, Generator_, miss_, option_:1}] := 
  Module[{ti, T1, T, dti, dti1, n, n1, Xi, z, y0, P0, yiiR, lik, yii, Pii, alphaii, alphai1i, alphaiiZ, YF, Misch, likvec, xi, dwi, yJ1, y, G, Pi1i, yi1i, liki, f2g2, fI, f2, f1, g1, g2, XZ, p, likratio, lik2, lik1, Zi1}, 
   {ti, T1, T, dti, dti1} = Zeiten1[Z, miss]; n = Length[dW]; n1 = 1./n; Print["FIFImportanceSmooth2Order: Monte-Carlo-Stichprobe n = ", n, "  seed = ", seed]; Clear[f2g2]; 
    f2g2[y_, {XX_, z_}, Th_] := Module[{fI, OmegaI, F1, F2, O, G2}, {fI, OmegaI} = SmoothEKF22Order[{z, y, _, XX, dt}, Th, {f, Df, DDf, Omega, DDOmega, h, Dh, R}, miss]; F1 = f[y, First[XX], Th]; F2 = F1 + l0*fI; O = Omega[y, First[XX], Th]; G2 = Transpose[CholeskyDecomposition[O + l1*OmegaI]]; 
       {F2, G2}]; {yi1i, Pi1i, alphai1i} = p0[X[[1]], Theta, n]; {yiiR, lik, yii, Pii, alphaii} = MessUpOmnibus[{Z[[1]], {yi1i, Pi1i, alphai1i}, X[[1]]}, Theta, {h, Dh, R}, {miss, n, Generator, seed, False}]; likneu = lik; 
    {yiiZ, PiiZ, alphaiiZ} = SmoothEKF2Order[{Z[[ti[[2]]]], yii, Pii, alphaii, Take[X, dti[[1]]], dt}, Theta, {f, Df, DDf, Omega, DDOmega, h, Dh, R}, miss]; yiiR = RandomKDE[yiiZ, alphaiiZ, PiiZ, seed, Generator, n]; p0Z = (likratio0[#1, {yii, Pii, alphaii}, {yiiZ, PiiZ, alphaiiZ}] & ) /@ yiiR; 
    YF = {}; Misch = {}; likvec = {lik}; Do[j = ti[[i + 1]]; Zi1 = Z[[j]]; Xi = Take[X, dti[[i]]]; XZ = Table[{Drop[Xi, j - 1], Zi1}, {j, 1, Length[Xi]}]; xi = Last[Xi]; dwi = (Take[#1, dti1[[i]]] & ) /@ dW; 
      {y, lik2} = Transpose[MapThread[RungeKutta1Lik[f2g2, #1, {XZ, #2}, Length[XZ] - 1, dt, Theta, EulerStep1Lik] & , {yiiR, dwi}]]; yJ1 = Last /@ y; Pi1i = (Omega[#1, xi, Theta] & ) /@ yJ1*dt; yi1i = yJ1 + (f[#1, xi, Theta] & ) /@ yJ1*dt; yi1i = Over[yi1i, YMAX]; 
      If[option == 2, YF = Join[YF, Transpose[y]]; ]; If[option == 3, YF = Join[YF, Transpose[TensorMS[y]]]; ]; If[dti1[[i]] =!= 1, lik1 = (LogLikelihoodO[#1, f, Omega, Xi, dt, Theta] & ) /@ y; alphai1i = n1*Exp[lik1 - lik2]*p0Z, alphai1i = n1*p0Z]; 
      {yiiR, liki, yii, Pii, alphaii} = MessUpOmnibus[{Zi1, {yi1i, Pi1i, alphai1i}, X[[j]]}, Theta, {h, Dh, R}, {miss, n, Generator, seed, False}]; 
      If[i < Length[ti] - 1, {yiiZ, PiiZ, alphaiiZ} = SmoothEKF2Order[{Z[[ti[[i + 2]]]], yii, Pii, alphaii, Take[X, dti[[i + 1]]], dt}, Theta, {f, Df, DDf, Omega, DDOmega, h, Dh, R}, miss]; yiiR = RandomKDE[yiiZ, alphaiiZ, PiiZ, Generator, seed, n]; 
        p0Z = (likratio0[#1, {yii, Pii, alphaii}, {yiiZ, PiiZ, alphaiiZ}] & ) /@ yiiR; ]; likvec = Append[likvec, liki]; lik += liki; likneu += liki1; , {i, 1, Length[ti] - 1}]; If[option == 1, Return[lik]]; If[option == 2, YF = Join[YF, {yiiR}]; Return[{YF, lik, likvec}]]; 
    If[option == 3, YF = Join[YF, {TensorMS[yiiR]}]; Return[{YF, lik, Misch}]]; ]
^*)
