(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, O497, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M8, N9, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 256; useSolids; automaticGrouping; currentKernel; 
]
:[font = section; inactive; initialization; preserveAspect; startGroup]
ML Implementierung
:[font = input; initialization; preserveAspect]
*)
Expintegral//Clear
Expintegral[v_,St_,X_,Theta_,dt_]:=
	Exp[dt Apply[Plus,MapThread[v[#1,#2,Theta]&,
		{Drop[St,-1],Drop[X,-1]} ]]];
		
FeynmanKacFokker//Clear
FeynmanKacFokker[x_,y_,s_,t_,f_,g_,v_,h_,X_,Theta_,Prozess_,n_,T_]:=
	(*allgemeiner Fall*) 
	Module[{c,dt},
	
	dt  = (t-s)/T //N;
	Print["{n,T,dt} = ", {n,T,dt}];
	St = Table[RungeKutta[f,g,x,X,T,dt,Theta,Prozess,EulerStep],{nn,1,n}];
	x1 = Map[Expintegral[v,#,X,Theta,dt]&,St];
	ST = Map[Last,St,{1}];
	x2 = Map[h[#-y,X//Last,Theta]&,ST];
	xx = x1 x2;
	c = Apply[Plus,xx]/n //N;
	c]
	

FeynmanKacFokker[x_,y_,f_,g_,{v_,0},h_,X_,Theta_,Prozess_,n_,dt_]:=
	(*v = 0*) 
	Module[{T},
	T = Length[X]-1;
	
	St = Table[RungeKutta[f,g,x,X,T,dt,Theta,Prozess,EulerStep],{nn,1,n}];
	ST = Map[Last,St,{1}];
	sm = smoothQuickAndDirty[ST];
	Print["FeynmanKacFokker {n,T,dt,sm} = ", {n,T,dt,N[sm,12]}];
	(*ST//Print;*)
	x2 = Map[h[#-y,X//Last,{Theta,sm}//Flatten]&,ST];
	Apply[Plus,x2]/n //N
	]	  
(*
:[font = input; initialization; preserveAspect]
*)

FeynmanKacFokker1[x_,y_,f_,g_,{v_,0},h_,X_,Theta_,$dw$_,dt_]:=
	(*mit gegebenen Zufallszahlen dw*) 
	Module[{T},
	n = $dw$//Length;
	T = Length[X]-1;
	
	St = Map[RungeKutta1[f,g,x,{X,#},T,dt,Theta,EulerStep1]&,$dw$];
	ST = Map[Last,St,{1}];
	(*ST//Print;*)
	sm = smoothQuickAndDirty[ST];
	sm//Print;
	(*Print["FeynmanKacFokker1 {n,T,dt,sm} = ", {n,T,dt,N[sm,12]}];*)
	
	(*St//Dimensions//Print;*)
	(*plot1[flatten[St//Transpose,{2,3}]//AddTimeAxis];*)
	
	x2 = Map[h[#-y,X//Last,{Theta,sm}//Flatten]&,ST];
	Apply[Plus,x2]/n //N
	]
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
LikelihoodFokker//Clear
LikelihoodFokker[Theta_,Y_,time_,dt_,f_,g_,X_,$dw$_]:= 
(***************************************************************)
Module[{th,smooth,lik},
	Print["*LikelihoodFokker, mit $dw$" ];
	
	ti = time/dt + 1;
	Xi = Map[Take[X,#]&,Delta[ti,ti,List,-1]];
	
	dichte = 
		MapThread[
			FeynmanKacFokker1[#1,#2,f,g,{v,0},h,#3,Theta,$dw$,dt]&,
				{Drop[Y,-1],Drop[Y,1],Xi}];
			
	lik = Apply[Plus,Log[dichte]]; 
	lik
];
(*
:[font = input; initialization; preserveAspect]
*)
 
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
LikelihoodFokkeralt[Theta_,Y_,time_,dt_,f_,g_,X_,seed_,ns_,Prozess_]:= 
(***************************************************************)
Module[{th,smooth,lik},
	Print["*LikelihoodFokkeralt, seed = ",seed,"  Prozess = ",Prozess];
	smooth = .1;
	th = {Theta,smooth}//Flatten;
	SeedRandom[seed];
	ti = time/dt + 1;
	Xi = Map[Take[X,#]&,Delta[ti,ti,List,-1]];
	dichte = 
		MapThread[
			FeynmanKacFokker[#1,#2,f,g,{v,0},h,#3,th,Prozess,ns,dt]&,
				{Drop[Y,-1],Drop[Y,1],Xi}];
	lik = Apply[Plus,Log[dichte]];
	lik
];
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)			 
ScoreFokker[Theta_,Y_,time_,dt_,f_,g_,X_,dw_]:=
(***************************************************************)			 
(* NUMERISCHER SCORE *)
Module[{INC = $MachineEpsilon//Sqrt,i,u,LIK,LIKI,INC1,SNUM,Thetai},
(*INC = 10.^-2;*)
Print["*ScoreFokker INC = ",INC];
LIK = LikelihoodFokker[Theta,Y,time,dt,f,g,X,dw];
INC = INC Abs[Theta];
INC1=1/INC;
SNUM = {};
Do[ 
    Thetai=Theta//Flatten;
    Thetai[[i]]=Thetai[[i]]+INC[[i]];
    
    LIKI = LikelihoodFokker[Thetai,Y,time,dt,f,g,X,dw];
    SNUM = Append[SNUM,(LIKI-LIK)*INC1[[i]]]
    
  ,{i,Length[Theta]} ];
  
{SNUM,LIK}
]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)			 
ScoreFokker2[Theta_,Y_,time_,dt_,f_,g_,X_,dw_]:=
(***************************************************************)			 
(* NUMERISCHER SCORE  2-seitig*)
Module[{INC = $MachineEpsilon^(1/3),i,u,LIK,LIKI,INC1,SNUM,
		Thetaiup,Thetaido},

LIK = LikelihoodFokker[Theta,Y,time,dt,f,g,X,dw];
INC = INC Abs[Theta];
INC1=1/(2INC);
SNUM = {};
Do[ 
    Thetaiup=Theta//Flatten;
    Thetaido=Theta//Flatten;
    Thetaiup[[i]]=Thetaiup[[i]]+INC[[i]];
    Thetaido[[i]]=Thetaido[[i]]-INC[[i]];
    
    LIKIup = LikelihoodFokker[Thetaiup,Y,time,dt,f,g,X,dw];
	LIKIdo = LikelihoodFokker[Thetaido,Y,time,dt,f,g,X,dw];
    SNUM = Append[SNUM,(LIKIup-LIKIdo)*INC1[[i]]]
    
  ,{i,Length[Theta]} ];
  
{SNUM,LIK}
]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)
GRIDIJ[PSI_,I_,J_,HI_,HJ_]:= Module[{OUT},
(***************************************************************)
OUT = PSI;
OUT[[I]] = OUT[[I]] + HI[[I]];
OUT[[J]] = OUT[[J]] + HJ[[J]];
OUT
]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)
GRIDI[PSI_,I_,HI_]:= Module[{OUT},
(***************************************************************)
OUT = PSI;
OUT[[I]] = OUT[[I]] + HI[[I]];
OUT
]
(*
:[font = input; initialization; preserveAspect; startGroup]
*)
GRIDI[{1,2,3},2,{.1,.2,.4}]
(*
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{1, 2.2, 3}
;[o]
{1, 2.2, 3}
:[font = input; initialization; preserveAspect; startGroup]
*)
GRIDIJ[{1,2,3},2,3,{.1,.2,.4},{.1,.2,.1}]
(*
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{1, 2.2, 3.1}
;[o]
{1, 2.2, 3.1}
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)
HesseFokker[Theta_,Y_,time_,dt_,f_,g_,X_,dw_]:=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT NUMERISCHEM SCORE:*)
(* ZENTRALE DIFFERENZEN *)


Module[{LIK,L2,INC = $MachineEpsilon^(1/3),INK,INK2,H4,H,
		LIJ,LIMJ,LIJM,LIMJM,L2I,LM2I,I,J},

U    = Length[Theta];
LIK  = LikelihoodFokker[Theta,Y,time,dt,f,g,X,dw];
L2   = 2 LIK;
INK  = INC Abs[Theta];
INK2 = 2 INK;
H4   = .25/Outer[Times,INK,INK];

H = Shape[0,{U,U}];

Do[ 

{LIJ,LIMJ,LIJM,LIMJM} = 
	Map[LikelihoodFokker[#,Y,time,dt,f,g,X,dw]&,
			{GRIDIJ[Theta ,I,J,  INK,  INK],
			 GRIDIJ[Theta ,I,J,  INK, -INK],
			 GRIDIJ[Theta ,I,J, -INK,  INK],
			 GRIDIJ[Theta ,I,J, -INK, -INK]
			 }];
	
    H[[I,J]] = LIJ - LIMJ - LIJM + LIMJM;
    
,{I,1,U},{J,I+1,U}];

H = H + Transpose[H];

Do[ 

{L2I,LM2I} = 
	Map[LikelihoodFokker[#,Y,time,dt,f,g,X,dw]&,
			{GRIDI[Theta ,I, INK2],
			 GRIDI[Theta ,I,-INK2]
			 }];
    H[[I,I]] = L2I - L2 + LM2I;
    
,{I,1,U}];

H = H H4;
{H,LIK}
]

(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 3; leftNameWrapOffset = 1]
*)


(***************************************************************)			 
BFGSUP[F_,SNEU_,S_,STEP_] := Module[{ETA,MACHEPS2,Y,FSTEP,A,B,Fup},
(***************************************************************)			 
ETA = 10^-4; (*NOISE LEVEL*)
MACHEPS2 = 10.^-8;
Y = -SNEU+S;
FSTEP = F.STEP;
A = Y.STEP;
If[ A < MACHEPS2 Max[Abs[STEP]] Max[Abs[Y]], Return[F]  ];
If[ Max[Abs[Y-FSTEP]] < ETA, Return[F]  ];
A=1/A;
B = 1/(STEP.FSTEP);
Print["*BFGSUP ", A,"  ", B];
Fup = F + Outer[Times, A Y ,Y] - Outer[Times,B FSTEP,FSTEP];
(*Fup=.5 (F+Transpose[Fup] *)
Fup
]
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
MatPrint[F_]:=
(***************************************************************)
  Print[NumberForm[F//MatrixForm,4,NumberSigns->{"-"," "}]];
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
LikTest[LIKNEU_]:=
(***************************************************************)
	If[(LIKNEU//NumberQ//Not)||(Im[LIKNEU]!=0)||(LIKNEU>10.^10),
	 	Print["LIKNEU = ",LIKNEU," reset to -10.^10"]; -10.^10,
	 		LIKNEU]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)			 
BFGSFokker//Clear
BFGSFokker[THETA0_,F0_,KMAX_,EPS_,Y_,time_,dt_,X_,P_,Q_,T_,
			OPTION_,mue_,sigma_,
			f_,g_,PRINT_,seed_,$n$_]:= 
(***************************************************************)			 
Module[{INC,MAXSTEP,MINSTEP,BOUND,ALPHA,u,THETA,F,
        S,LIKALT,LIKI,psii,STEPL,STEP,
        LIKNEU,SNEU,likpsi,COV,k,LIKELI,TT},
INC=10.^-5;
MAXSTEP=10.^-1;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;
stepreduce = 3;

{p,r} = g[ Y[[1]],X[[1]],THETA0 ]//Dimensions;
SeedRandom[seed];
TT = Max[Delta[time]]/dt + 1//Ceiling;
dw = Table[UniC[],{nn,$n$},{tt,TT},{rr,r}] Sqrt[dt];

(*Kern-Funktion*)
h[S_,t_,Theta_] := GaussDichte[S,{0,Theta//Last} ]//N;

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: BFGSFokker *********************"];
Print["**************************************************************"];
Print["Technical Output"];
VecPrint[{KMAX,EPS,P,Q,T,OPTION,MAXSTEP,
		  MINSTEP,BOUND,stepreduce}//Spalte,
         {"KMAX","EPS","P","Q","T","OPTION","MAXSTEP",
         "MINSTEP","BOUND","stepreduce"}];
Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0]
];

u = Length[THETA0];

THETA=THETA0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{S,LIKALT} = ScoreFokker[THETA0,Y,time,dt,f,g,X,dw]; 
LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,
 	
	If[PRINT[[2]] == 1,
	Print["-----------------------------------------------------------------"];
    Print["BFGSFokker: Iteration = ",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psii=Append[psii,THETA];
    
 	STEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTLNGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-Reduction*)
   
    THETA1 = THETA + STEP;   (*VOLLER NEWTON-STEP*)
    
  	LIKNEU = LikelihoodFokker[THETA1,Y,time,dt,f,g,X,dw];
			  			
   	LIKNEU = LikTest[LIKNEU];
   	 
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          				 Max[Abs[STEP]]>MINSTEP),
         STEP=STEP/stepreduce;
         THETA1 = THETA + STEP; 
         
         LIKNEU = LikelihoodFokker[THETA1,Y,time,dt,f,g,X,dw];
			  		
		 LIKNEU = LikTest[LIKNEU];
	  		
		 If[PRINT[[3]] == 1,
         Print["STEP-HALVING:  ",half,
         			"  LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
         			"  LIKALT  ", PaddedForm[LIKALT,{20,15}]];
         ];
     ]; (*End DoWhile*)
     
	
	If[PRINT[[4]] == 1,
    Print["LIKNEU  ", PaddedForm[LIKNEU,{20,15}],"      ",
          "LIKALT  ", PaddedForm[LIKALT,{20,15}] ];
    Print["LIKNEU - LIKALT  ",PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    ];
    Print[""];
  
    If[PRINT[[5]] == 1, 
    Print[MatrixForm[{THETA1,THETA,STEP,S}//Transpose,
    	  TableHeadings->{Automatic,{"THETA1","THETA","STEP","SCORE"}}]
    	  ]];
    
    If[PRINT[[6]] == 1,
    Print[""];
    MatPrint[F];
    ];
       
    {SNEU,LIKALT} = ScoreFokker[THETA1,Y,time,dt,f,g,X,dw];
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S = SNEU;
    
    THETA = THETA1;
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ "BFGSFokker:  ENDE DER ITERATION  ",k,"  ",KMAX] ];

LIKI = Append[LIKI,LIKALT]; psii = Append[psii,THETA];
likpsi = Spalte[LIKI]~ii~psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
		TableHeadings->{Automatic,{"Likelihood","THETA"}} ]];
];
					

If[Fisher,

	{F,LIKELI} = HesseFokker[THETA,Y,time,dt,f,g,X,dw];	
	F=-F;
	
	COV = OUTPUT[THETA,F,.05,S,LIKELI];
	LKOMP[LIKELI,u,(T+1)];
	
,(* else *)
	COV = Inverse[F]; (* BFGS-UPDATE!!*)
];

{THETA,COV,likpsi,k}

]
(*
:[font = input; initialization; preserveAspect]
*)
FeynmanKacFokkerDemo//Clear
FeynmanKacFokkerDemo[x_,y_,s_,t_,f_,g_,{v_,0},h_,X_,Theta_,Prozess_,n_,T_]:=
	(*allgemeiner Fall*) 
	Module[{c,dt,yy,traj,dens},
	
	dt  = (t-s)/T //N;
	Print["{n,T,dt} = ", {n,T,dt}];
	St = Table[RungeKutta[f,g,x,X,T,dt,Theta,Prozess,EulerStep],{nn,1,n}];
	ST = Map[Last,St,{1}];
	x2 = Map[h[yy-#1,X//Last,Theta]&,ST];
	x2 = Apply[Plus,x2]/n //N;
	sm = smoothQuickAndDirty[ST];sm//Print;
	
	dens = Plot[x2/.smooth->sm//Evaluate,{yy,-6,6},
			PlotRange->{All,{0,.7}},
			DisplayFunction->Identity];
		
	traj = plot1[flatten[St//Transpose,{2,3}]//AddTimeAxis[#,{s,t,dt}]&,
			DisplayFunction->Identity,
			farbmodell->Hue,
			dicke->.001,
			PlotRange->{All,{-6,6}}];
			
	{dens,traj}
	]
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)
LikelihoodFokkerDemo//Clear
LikelihoodFokkerDemo[Theta_,Y_,time_,f_,g_,h_,X_,ns_,Ts_,Prozess_]:= 
(***************************************************************)
Module[{th,dens,traj,data},
	Print["*LikelihoodFokker"];
	
	smooth//Clear;
	th = {Theta,smooth}//Flatten;
	
	gg = 
	MapThread[
	FeynmanKacFokkerDemo[#1,#2,#3,#4,f,g,{v,0},h,X,th,Prozess,ns,Ts]&,
	{Drop[Y,-1],Drop[Y,1],Drop[time,-1],Drop[time,1]}];
	
	{dens,traj} = gg//Transpose;
	
	data = plot1[Spalte[time]~ii~Y,PlotJoined->False,
			dicke ->.01,color->{10},DisplayFunction->Identity];
			
	Show[traj,data,DisplayFunction->$DisplayFunction];
	fill = {Indeterminate};
	Show[GraphicsArray[Partition[{dens,fill}//Flatten,2]],DisplayFunction->$DisplayFunction];

];
(*
:[font = input; initialization; preserveAspect]
*)


RungeKutta1//Clear
RungeKutta1[f_,g_,Y0_,{X_,dw_},T_,dt_,Theta_,Step_] :=
	FoldList[ Step[f,g,#1,#2,Theta,dt]&,Y0,{Take[X,T],Take[dw,T]}//Transpose]
 

EulerStep1//Clear
EulerStep1[f_,g_,y_,{t_,dw_},Theta_,dt_] :=
      y + f[y,t,Theta] dt + g[y,t,Theta].dw
(*
:[font = input; initialization; preserveAspect]
*)
HeunStep1//Clear
HeunStep1[f_,g_,y_,{t_,dw_},Theta_,dt_] :=
	Module[{f1,g1,t1,f2,g2},
		f1 = f[y,t,Theta];
		g1 = g[y,t,Theta];
	
		y1 = y + f1 dt + g1.dw; (* Euler-Prdiktor *)
		t1 = t + dt;
		f2 = f[y1,t1,Theta];
		g2 = g[y1,t1,Theta];
		
        y + 0.5 ( (f1 + f2) dt + (g1 + g2).dw )
 	]
(*
:[font = input; initialization; preserveAspect]
*)
RungeKutta4Step1//Clear
RungeKutta4Step1[f_,g_,y_,{t_,dw_},Theta_,dt_]:=
	Module[{f0,f1,f2,f3,g0,g1,g2,g3,t1,t3,dth,dwh,y1,y2,y3},
		f0 = f[y,t,Theta];
		g0 = g[y,t,Theta];
		dwh = dw/2;
		dth = dt/2;
		
		t1 = t + dth;
		y1 = y + f0 dth + g0.dwh;
		f1 = f[y1,t1,Theta];
		g1 = g[y1,t1,Theta];
		
		y2 = y + f1 dth + g1.dwh;
		f2 = f[y2,t1,Theta];
		g2 = g[y2,t1,Theta];
		
		y3 = y + f2 dt + g2.dw;
		t3 = t + dt;
		f3 = f[y3,t3,Theta];
		g3 = g[y3,t3,Theta];
		
        y + (f0 + 2f1 + 2f2 + f3) dt/6. + (g0 + 2g1 + 2g2 + g3).dw/6. 
 	] 
      
(*
:[font = input; initialization; preserveAspect; plain]
*)
RungeKutta1Lik//Clear
RungeKutta1Lik[fg_,Y0_,{X_,dw_},T_,dt_,Theta_,Step_] :=
	Block[{y,l},
	{y,l}=FoldList[ Step[fg,#1,#2,Theta,dt]&,{Y0,0},
	                {Take[X,T],Take[dw,T]}//Transpose]//Transpose;
	{y,l//Last}
	]
 

EulerStep1Lik//Clear
EulerStep1Lik[fg_,{y_,l_},{t_,dw_},Theta_,dt_] := 
Module[{f,G,gdw,Omega,lik},
	
	{f,G} = fg[y,t,Theta];  
	gdw = G.dw;
	Omega = G.Transpose[G]*dt; 
	lik = -.5(Log[Det[Omega]] + gdw.Inverse[Omega].gdw);
	
    {y + f dt + gdw,l+lik}
    
    ]
(*
:[font = input; initialization; preserveAspect]
*)
smoothQuickAndDirty[ST_]:= 
	(Varianz[ST]//First//VecDiag//Max) Length[ST]^(-2/5) //N
(*
:[font = input; initialization; preserveAspect]
*)

GaussDichte1[x_,{mue_,sigma_,sigma1_}]:= 
	Module[{z = x-mue},
	(*{GaussDichte1,x,mue}//Print; *)
	Det[2 Pi sigma]^(-.5) Exp[-.5 z.sigma1.z]//N
	];

EulerTransitionDensity//Clear
EulerTransitionDensity[y_,x_,f_,g_,t_,dt_,Theta_]:= 
	 Module[{gg,omega,sigma,sigma1},
	 gg = g[x,t,Theta];
	 omega = gg.Transpose[gg];
	 sigma = omega dt;
	 sigma1 = Inverse[sigma];
	 gg = GaussDichte1[y,{x + f[x,t,Theta]dt,sigma,sigma1}];
	 (*{gggg,y,x,sigma,sigma1}//Print;*)
	 gg
	 ];
(*
:[font = input; initialization; preserveAspect; startGroup]
*)

LogEulerTransitionDensity//Clear
LogEulerTransitionDensity[y_,x_,f_,g_,t_,dt_,Theta_]:= 
     (*Konstante -p/2 Log[2Pi] und Jacobi weggelassen
       Jacobi fllt bei Likelihood-Quotient p1/p2 weg*)
	 Module[{gg,omega,sigma,sigma1,out,y1,Jacobi,dy},
	 gg = g[x,t,Theta];
	 omega = gg.Transpose[gg];
	 sigma = omega dt;
	 sigma1 = Inverse[sigma];
	 y1 = x + f[x,t,Theta]dt;
	 dy = y-y1;
	 	(*Jacobi = Log[Det[sigma]]*)
	 	(*out = -.5(  Jacobi +  dy.sigma1.dy );*)
	 
	 out = -.5 dy.sigma1.dy;
	 out
	 ];
	 
	 
EulerDensity//Clear
EulerDensity[Y_,f_,g_,time_,dt_,Theta_]:=
Module[{p,out},
 p = EulerTransitionDensity[#1,#2,f,g,#3,dt,Theta]&;
 out = Apply[Times,MapThread[p,{Drop[Y,1],Drop[Y,-1],Drop[time,-1]}]];
 (*{Theta,out,Y}//Print;*)
 out
 ]

LogEulerDensity//Clear
LogEulerDensity[Y_,f_,g_,time_,dt_,Theta_]:=
Module[{p,out},
 p = LogEulerTransitionDensity[#1,#2,f,g,#3,dt,Theta]&;
 out = Apply[Plus,MapThread[p,{Drop[Y,1],Drop[Y,-1],Drop[time,-1]}]];
 out
 ]
(*
;[s]
5:0,0;530,1;542,0;771,1;786,0;966,-1;
2:3,12,10,Courier,1,12,0,0,0;2,12,10,Courier,1,12,65535,0,0;
:[font = message; inactive; preserveAspect; endGroup]
General::spell1: Possible spelling error: new symbol name "Jacobi" is similar to existing symbol "JacobiP".
:[font = input; initialization; preserveAspect; plain]
*)
loglikelihoodRatio//Clear
loglikelihoodRatio[y_,x_,{f1_,f2_},g_,t_,dt_,Theta_]:=
 Module[{G,omega,omega1,out,Jacobi,dy,F1,F2,F12},
	 G = g[x,t,Theta];
	 omega = G.Transpose[G];
	 omega1 = Inverse[omega];
	 F1 = f1[x,t,Theta];
	 F2 = f2[x,t,Theta];
	 F12 = (F1-F2).omega1; 	
	 dy = y-x;
	   (*F12.dy - .5 F12.(F1+F2) dt*)
	 F12.( dy - (.5 dt)(F1+F2) )  
	 
	 ];

loglikelihoodRatio1//Clear
loglikelihoodRatio1[y_,x_,{f1_,f2_},g_,t_,dt_,Theta_]:=
 Module[{G,omega,omegaI,dy,dy1,dy2,F1,F2},
	 G = g[x,t,Theta];
	 omega = G.Transpose[G];
	 omegaI = Inverse[omega];
	 F1 = f1[x,t,Theta];
	 F2 = f2[x,t,Theta]; 
	 dy = y-x;
	 dy1 = dy - F1 dt;
	 dy2 = dy - F2 dt;
	 -(0.5/dt)(dy1.omegaI.dy1 - dy2.omegaI.dy2)  
	 ];
	 
loglikelihoodRatio2//Clear
loglikelihoodRatio2[y_,x_,{f1_,f2_},{g1_,g2_},t_,dt_,Theta_]:=
 Module[{G1,G2,omega1,omega2,omega1I,omega2I,dy,dy1,dy2,F1,F2},
	 G1 = g1[x,t,Theta];
	 omega1 = G1.Transpose[G1];
	 omega1I = Inverse[omega1];
	 G2 = g2[x,t,Theta];
	 omega2 = G2.Transpose[G2];
	 omega2I = Inverse[omega2];
	 F1 = f1[x,t,Theta];
	 F2 = f2[x,t,Theta];
	 dy = y-x;
	 dy1 = dy - F1 dt;
	 dy2 = dy - F2 dt;
	 -(0.5)(  (  dy1.omega1I.dy1     - dy2.omega2I.dy2)/dt 
	           + Log[Det[omega1]/Det[omega2]] ) 
	 ];


loglikelihood//Clear
loglikelihood[y_,x_,f1_,g1_,t_,dt_,Theta_]:=
 Module[{G1,omega1,omega1I,dy,dy1,F1},
	 G1 = g1[x,t,Theta];
	 omega1 = G1.Transpose[G1]*dt;
	 omega1I = Inverse[omega1];
	 
	 F1 = f1[x,t,Theta];
	 
	 dy = y-x;
	 dy1 = dy - F1 dt;
	 
	 -0.5*(  dy1.omega1I.dy1 + Log[Det[omega1]] ) 
	 ];
	 
	 	 	 	 
LogLikelihoodRatio//Clear
LogLikelihoodRatio[Y_,{f1_,f2_},g_,time_,dt_,Theta_]:=
Module[{p,out},
 p = loglikelihoodRatio1[#1,#2,{f1,f2},g,#3,dt,Theta]&;
 (* Y//Dimensions//Print; *)
 If[Length[Y]<=1, 0, (* else *)
 Apply[Plus,MapThread[p,{Drop[Y,1],Drop[Y,-1],Drop[time,-1]}]]
 ]
 ]
 
LogLikelihoodRatio2//Clear
LogLikelihoodRatio2[Y_,{f1_,f2_},{g1_,g2_},time_,dt_,Theta_]:=
Module[{p,out},
 p = loglikelihoodRatio2[#1,#2,{f1,f2},{g1,g2},#3,dt,Theta]&;
 Apply[Plus,MapThread[p,{Drop[Y,1],Drop[Y,-1],Drop[time,-1]}]]
 ]
 
LogLikelihood//Clear
LogLikelihood[Y_,f1_,g1_,time_,dt_,Theta_]:=
Module[{p,out},
 p = loglikelihood[#1,#2,f1,g1,#3,dt,Theta]&;
 Apply[Plus,MapThread[p,{Drop[Y,1],Drop[Y,-1],Drop[time,-1]}]]
 ]
(*
;[s]
15:0,0;26,1;44,0;389,1;408,0;740,1;759,0;1254,1;1267,0;1575,1;1593,0;1861,1;1880,0;2091,1;2104,0;2264,-1;
2:8,12,10,Courier,0,12,0,0,0;7,12,10,Courier,0,12,65535,0,0;
:[font = input; initialization; preserveAspect]
*)
WienerDensity//Clear
WienerDensity[Y_,a_,G_,dt_]:=
Module[{p,omega,sigma,sigma1},
 omega = G.Transpose[G];
 sigma = omega dt;
 sigma1 = Inverse[sigma];
 p = GaussDichte[#,{a dt,sigma,sigma1}]&;
 Apply[Times,Map[p,Delta[Y]] ]
 ]   
(*
:[font = input; initialization; preserveAspect]
*)

ImportanceSampler//Clear
ImportanceSampler[h_,p1_,p2_,Y2_,t_,{Theta1_,Theta2_,Theta3_},
                  log_:False]:=
	Module[{m,s,n,y,F},
	
	If[Not[log],
	F = If[(p1[#,t,Theta1]&) =!= (p2[#,t,Theta2]&),
	
		      Print["ImportanceSampler h p1/p2"]; 
		      h[#,t,Theta3] p1[#,t,Theta1]/p2[#,t,Theta2]&,
		      
	       Print["ImportanceSampler h"]; 
	       h[#,t,Theta3]&
	      ];
	      
	,(*else*)     
	F = If[(p1[#,t,Theta1]&) =!= (p2[#,t,Theta2]&),
	
		      Print["ImportanceSampler h Exp(p1 - p2)"]; 
		      h[#,t,Theta3]* Exp[ p1[#,t,Theta1]- p2[#,t,Theta2] ]&,
		      
	       Print["ImportanceSampler h"]; 
	       h[#,t,Theta3]&
	      ]; 
	];          (*F//Print;*)
	 
	y = Map[F,Y2];
	{m,s} = y//MS;
	n = Length[Y2];
	{m,s/Sqrt[n]} //N
	];

WienerSampler//Clear
WienerSampler[x_,y_,f_,g_,h_,X_,{Theta1_,Theta2_,Theta3_},$dw$_,dt_]:=
	(*mit gegebenen Zufallszahlen dw*)
	 
	Module[{T},
	n = $dw$//Length;
	T = Length[X]-1;

 Clear[a,b,p1,p2];

 a[yy_,t_,Theta_] :=  Theta[[1]];
 b[yy_,t_,Theta_] :=  Theta[[2]];
 
 p1 = EulerDensity [#1,f,g,#2,dt,#3]&;
 p2 = WienerDensity[#1,Theta2[[1]],Theta2[[2]],dt]&; 
 
	 (*Y2 = Map[RungeKutta1[a,b,x,{X,#},T,dt,Theta2,EulerStep1]&,$dw$];*)
	Y2 = Map[WienerProzess1[Theta2[[1]],Theta2[[2]],x,dt,#]&,$dw$];

 If[$SMOOTH$,sm = smoothQuickAndDirty[Y2//Transpose//Last],
 										  sm = Indeterminate];
 										  
 Print["WienerSampler {n,T,dt,sm} = ", {n,T,dt,N[sm,12]}];

 ImportanceSampler[h,p1,p2,Y2,X,{Theta1,Theta2,Append[Theta3,sm]} ]
 
	]	
(*
;[s]
7:0,0;26,1;43,0;785,1;798,0;1457,1;1462,0;1510,-1;
2:4,12,10,Courier,1,12,0,0,0;3,12,10,Courier,1,12,65535,0,0;
:[font = input; initialization; preserveAspect]
*)
EulerSampler//Clear
EulerSampler[x_,y_,f_,g_,h_,X_,{Theta1_,Theta3_},$dw$_,dt_]:=
	(*mit gegebenen Zufallszahlen dw*)
	 
	Module[{T},
	n = $dw$//Length;
	T = Length[X]-1;
 
	Y1 = Map[RungeKutta1[f,g,x,{X,#},T,dt,Theta1,EulerStep1]&,$dw$];
	
 If[$SMOOTH$,sm = smoothQuickAndDirty[Y2//Transpose//Last],
 										  sm = Indeterminate];
 
 Print["EulerSampler  {n,T,dt,sm} = ", {n,T,dt,N[sm,12]}];
 
 ImportanceSampler[h,1,1,Y1,X,{_,_,Append[Theta3,sm]} ]

	]	
(*
;[s]
5:0,0;20,1;32,0;419,1;422,0;459,-1;
2:3,12,10,Courier,1,12,0,0,0;2,12,10,Courier,1,12,65535,0,0;
:[font = input; initialization; preserveAspect]
*)
ItoSampler//Clear
ItoSampler[x_,y_,f_,g_,h_,X_,{Theta1_,Theta2_,Theta3_},$dw$_,dt_]:=
	(*mit gegebenen Zufallszahlen dw*)
	 
	Module[{T},
	
	n = $dw$//Length;
	T = Length[X]-1;

 Clear[p1,p2];

 p1 = EulerDensity[#1,f,g,#2,dt,#3]&;
 p2 = EulerDensity[#1,f,g,#2,dt,#3]&;
 
	Y2 = Map[RungeKutta1[f,g,x,{X,#},T,dt,Theta2,EulerStep1]&,$dw$];
	
 If[$SMOOTH$,sm = smoothQuickAndDirty[Y2//Transpose//Last],
 										  sm = Indeterminate];
 
 Print["ItoSampler {n,T,dt,sm} = ", {n,T,dt,N[sm,12]}];
 
 ImportanceSampler[h,p1,p2,Y2,X,{Theta1,Theta2,Append[Theta3,sm]} ]
 
	]	 
(*
;[s]
3:0,0;515,1;520,0;569,-1;
2:2,12,10,Courier,1,12,0,0,0;1,12,10,Courier,1,12,65535,0,0;
:[font = input; initialization; preserveAspect]
*)
LogItoSampler//Clear
LogItoSampler[x_,y_,f_,g_,h_,X_,{Theta1_,Theta2_,Theta3_},$dw$_,dt_]:=
	(*mit gegebenen Zufallszahlen dw*)
	 
	Module[{T},
	
	n = $dw$//Length;
	T = Length[X]-1;

 Clear[p1,p2];

 p1 = LogEulerDensity[#1,f,g,#2,dt,#3]&;
 p2 = LogEulerDensity[#1,f,g,#2,dt,#3]&;
 
	Y2 = Map[RungeKutta1[f,g,x,{X,#},T,dt,Theta2,EulerStep1]&,$dw$];
	
 If[$SMOOTH$,sm = smoothQuickAndDirty[Y2//Transpose//Last],
 										  sm = Indeterminate];
 
 Print["LogItoSampler {n,T,dt,sm} = ", {n,T,dt,N[sm,12]}];
 
 ImportanceSampler[h,p1,p2,Y2,X,{Theta1,Theta2,Append[Theta3,sm]},True]
 
	]	 
(*
;[s]
3:0,0;530,1;535,0;588,-1;
2:2,12,10,Courier,1,12,0,0,0;1,12,10,Courier,1,12,65535,0,0;
:[font = input; initialization; preserveAspect]
*)
WienerProzess1//Clear
WienerProzess1[a_,B_,x_,dt_,dW_]:= 
	CumulativeSums[Join[{x},Map[a dt + Dot[B,#]&,dW]]]
(*
:[font = input; initialization; preserveAspect]
*)
WienerProzess2//Clear
WienerProzess2[a_,B_,x_,dt_,dW_]:= 
    Module[{T = Length[dW]},
	Map[Plus[x+a#]&,Range[0,T dt,dt]] + 
		Join[{0},CumulativeSums[Map[Dot[B,#]&,dW]]]]
(*
:[font = input; preserveAspect; startGroup]
WienerProzess1[{1},{{.1}},x,dt,10//Range//Spalte]//Timing
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
 {0.08333333333333331483*Second, {x, {0.3 + x}, {0.7 + x}, {1.2 + x}, {1.8 + x}, {2.5 + x}, {3.3 + x}, {4.2 + x}, {5.2 + x}, 
  {6.3 + x}, {7.5 + x}}}
;[o]
 {0.0833333 Second, {x, {0.3 + x}, {0.7 + x}, {1.2 + x}, {1.8 + x}, {2.5 + x}, {3.3 + x}, {4.2 + x}, {5.2 + x}, {6.3 + x}, 
  {7.5 + x}}}
:[font = input; preserveAspect; startGroup]
WienerProzess2[{1},{{.1}},x,dt,10//Range//Spalte]//Timing
:[font = output; output; inactive; initialization; preserveAspect; fontLeading = 0; endGroup; endGroup]
 {0.0999999999999999778*Second, {{x}, {0.3 + x}, {0.7 + x}, {1.2 + x}, {1.8 + x}, {2.5 + x}, {3.3 + x}, {4.2 + x}, {5.2 + x}, 
  {6.3 + x}, {7.5 + x}}}
;[o]
{0.1 Second, {{x}, {0.3 + x}, {0.7 + x}, {1.2 + x}, {1.8 + x}, {2.5 + x}, {3.3 + x}, {4.2 + x}, {5.2 + x}, {6.3 + x}, {7.5 + x}}}
^*)
