(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, R65535,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M18, N23, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Geneva"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = subsection; inactive; initialization; preserveAspect; startGroup]
Num. Fourier-Trafo mit FFT
:[font = input; initialization; preserveAspect]
*)
c1//Clear
c1[{a_,b_}]:=Sqrt[Abs[b]/((2 Pi)^(1-a))]
c2//Clear
c2[{a_,b_}]:=Sqrt[Abs[b]/((2 Pi)^(1+a))]
(*
:[font = input; initialization; preserveAspect; startGroup]
*)
c1[{1,1}]
c2[{1,1}]
(*
:[font = output; output; inactive; initialization; preserveAspect]
1
;[o]
1
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
1/(2*Pi)
;[o]
 1
----
2 Pi
:[font = input; preserveAspect; startGroup]
Table[f/.x->2x//Evaluate,{x,1,2}]
:[font = output; output; inactive; preserveAspect; endGroup]
{1/(E^2*Sqrt[2*Pi]), 1/(E^8*Sqrt[2*Pi])}
;[o]
       1              1
{-------------, -------------}
  2              8
 E  Sqrt[2 Pi]  E  Sqrt[2 Pi]
:[font = input; initialization; preserveAspect]
*)
NFourierTransformFFT//Clear
NFourierTransformFFT[f_,t_,{n_,{t1_,t2_},omega1_},{a_,b_},Vz_:1]:=

Module[{dt,domega,b2pi},

dt=(t2-t1)/n;
domega=1/(n dt);
b2pi=2 Pi/b//N;

fstern=Table[f/.{t->b2pi t}//Evaluate,{t,t1,t2-dt,dt}]//N;

omegas = domega Table[s-1,{s,1,n}];
tr     =     dt Table[r-1,{r,1,n}];


faktorS=   Exp[Vz 2 Pi I t1 (omega1+omegas)];
faktorR=   Exp[Vz 2 Pi I     omega1 tr];

{omega1+omegas, 
c1[{a,b}] b2pi dt faktorS Fourier[fstern*faktorR,FourierParameters->{1,Vz}]}

]
(*
:[font = input; initialization; preserveAspect; endGroup]
*)
NInverseFourierTransformFFT//Clear
NInverseFourierTransformFFT[F_,omega_,{n_,{omega1_,omega2_},t1_},{a_,b_}]:=

Module[{},

NFourierTransformFFT[F,omega,{n,{omega1,omega2},t1},{-a,b},-1]

]
(*
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Test
:[font = input; preserveAspect]
{a,b}={0,1}
:[font = input; preserveAspect; startGroup]
f=(p2/.{mu->0,m[2]->1}//Evaluate)

:[font = output; output; inactive; preserveAspect; endGroup]
1/(E^(x^2/2)*Sqrt[2*Pi])
;[o]
       1
----------------
  2
 x /2
E     Sqrt[2 Pi]
:[font = input; preserveAspect]

:[font = input; preserveAspect]
F=NFourierTransformFFT[f,x,{100,{-2,2},-10},{a,b}];
:[font = input; preserveAspect; startGroup]
F//Transpose//plot1
:[font = print; inactive; preserveAspect]
Dimension der Daten  {100, 2}
:[font = postscript; PostScript; formatAsPostScript; output; inactive; preserveAspect; pictureLeft = 34; pictureWidth = 282; pictureHeight = 174]
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.40861 0.03848 0.0147151 1.47541 [
[.02381 -0.0125 -9 -9 ]
[.02381 -0.0125 9 0 ]
[.21621 -0.0125 -6 -9 ]
[.21621 -0.0125 6 0 ]
[.40861 -0.0125 -3 -9 ]
[.40861 -0.0125 3 0 ]
[.60101 -0.0125 -3 -9 ]
[.60101 -0.0125 3 0 ]
[.79341 -0.0125 -6 -9 ]
[.79341 -0.0125 6 0 ]
[.98581 -0.0125 -6 -9 ]
[.98581 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01472 -6 -4.5 ]
[-0.0125 .01472 0 4.5 ]
[-0.0125 .16226 -18 -4.5 ]
[-0.0125 .16226 0 4.5 ]
[-0.0125 .3098 -18 -4.5 ]
[-0.0125 .3098 0 4.5 ]
[-0.0125 .45734 -18 -4.5 ]
[-0.0125 .45734 0 4.5 ]
[-0.0125 .60488 -18 -4.5 ]
[-0.0125 .60488 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .01472 -3 -4.5 ]
[.97619 .01472 3 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(-10)] .02381 -0.0125 0 1 Mshowa
.21621 0 m
.21621 .00625 L
s
[(-5)] .21621 -0.0125 0 1 Mshowa
.40861 0 m
.40861 .00625 L
s
[(0)] .40861 -0.0125 0 1 Mshowa
.60101 0 m
.60101 .00625 L
s
[(5)] .60101 -0.0125 0 1 Mshowa
.79341 0 m
.79341 .00625 L
s
[(10)] .79341 -0.0125 0 1 Mshowa
.98581 0 m
.98581 .00625 L
s
[(15)] .98581 -0.0125 0 1 Mshowa
.125 Mabswid
.06229 0 m
.06229 .00375 L
s
.10077 0 m
.10077 .00375 L
s
.13925 0 m
.13925 .00375 L
s
.17773 0 m
.17773 .00375 L
s
.25469 0 m
.25469 .00375 L
s
.29317 0 m
.29317 .00375 L
s
.33165 0 m
.33165 .00375 L
s
.37013 0 m
.37013 .00375 L
s
.44709 0 m
.44709 .00375 L
s
.48557 0 m
.48557 .00375 L
s
.52405 0 m
.52405 .00375 L
s
.56253 0 m
.56253 .00375 L
s
.63949 0 m
.63949 .00375 L
s
.67797 0 m
.67797 .00375 L
s
.71645 0 m
.71645 .00375 L
s
.75493 0 m
.75493 .00375 L
s
.83189 0 m
.83189 .00375 L
s
.87037 0 m
.87037 .00375 L
s
.90885 0 m
.90885 .00375 L
s
.94733 0 m
.94733 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01472 m
.00625 .01472 L
s
[(0)] -0.0125 .01472 1 0 Mshowa
0 .16226 m
.00625 .16226 L
s
[(0.1)] -0.0125 .16226 1 0 Mshowa
0 .3098 m
.00625 .3098 L
s
[(0.2)] -0.0125 .3098 1 0 Mshowa
0 .45734 m
.00625 .45734 L
s
[(0.3)] -0.0125 .45734 1 0 Mshowa
0 .60488 m
.00625 .60488 L
s
[(0.4)] -0.0125 .60488 1 0 Mshowa
.125 Mabswid
0 .04422 m
.00375 .04422 L
s
0 .07373 m
.00375 .07373 L
s
0 .10324 m
.00375 .10324 L
s
0 .13275 m
.00375 .13275 L
s
0 .19176 m
.00375 .19176 L
s
0 .22127 m
.00375 .22127 L
s
0 .25078 m
.00375 .25078 L
s
0 .28029 m
.00375 .28029 L
s
0 .33931 m
.00375 .33931 L
s
0 .36881 m
.00375 .36881 L
s
0 .39832 m
.00375 .39832 L
s
0 .42783 m
.00375 .42783 L
s
0 .48685 m
.00375 .48685 L
s
0 .51635 m
.00375 .51635 L
s
0 .54586 m
.00375 .54586 L
s
0 .57537 m
.00375 .57537 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21621 .61178 m
.21621 .61803 L
s
.40861 .61178 m
.40861 .61803 L
s
.60101 .61178 m
.60101 .61803 L
s
.79341 .61178 m
.79341 .61803 L
s
.98581 .61178 m
.98581 .61803 L
s
.125 Mabswid
.06229 .61428 m
.06229 .61803 L
s
.10077 .61428 m
.10077 .61803 L
s
.13925 .61428 m
.13925 .61803 L
s
.17773 .61428 m
.17773 .61803 L
s
.25469 .61428 m
.25469 .61803 L
s
.29317 .61428 m
.29317 .61803 L
s
.33165 .61428 m
.33165 .61803 L
s
.37013 .61428 m
.37013 .61803 L
s
.44709 .61428 m
.44709 .61803 L
s
.48557 .61428 m
.48557 .61803 L
s
.52405 .61428 m
.52405 .61803 L
s
.56253 .61428 m
.56253 .61803 L
s
.63949 .61428 m
.63949 .61803 L
s
.67797 .61428 m
.67797 .61803 L
s
.71645 .61428 m
.71645 .61803 L
s
.75493 .61428 m
.75493 .61803 L
s
.83189 .61428 m
.83189 .61803 L
s
.87037 .61428 m
.87037 .61803 L
s
.90885 .61428 m
.90885 .61803 L
s
.94733 .61428 m
.94733 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01472 m
1 .01472 L
s
.99375 .16226 m
1 .16226 L
s
.99375 .3098 m
1 .3098 L
s
.99375 .45734 m
1 .45734 L
s
.99375 .60488 m
1 .60488 L
s
.125 Mabswid
.99625 .04422 m
1 .04422 L
s
.99625 .07373 m
1 .07373 L
s
.99625 .10324 m
1 .10324 L
s
.99625 .13275 m
1 .13275 L
s
.99625 .19176 m
1 .19176 L
s
.99625 .22127 m
1 .22127 L
s
.99625 .25078 m
1 .25078 L
s
.99625 .28029 m
1 .28029 L
s
.99625 .33931 m
1 .33931 L
s
.99625 .36881 m
1 .36881 L
s
.99625 .39832 m
1 .39832 L
s
.99625 .42783 m
1 .42783 L
s
.99625 .48685 m
1 .48685 L
s
.99625 .51635 m
1 .51635 L
s
.99625 .54586 m
1 .54586 L
s
.99625 .57537 m
1 .57537 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
[( )] .97619 .01472 0 0 Mshowa
.001 w
.02381 .01472 m
.03343 .01472 L
.04305 .01472 L
.05267 .01472 L
.06229 .01472 L
.07191 .01472 L
.08153 .01472 L
.09115 .01472 L
.10077 .01472 L
.11039 .01472 L
.12001 .01472 L
.12963 .01472 L
.13925 .01472 L
.14887 .01472 L
.15849 .01472 L
.16811 .01472 L
.17773 .01472 L
.18735 .01472 L
.19697 .01472 L
.20659 .01472 L
.21621 .01472 L
.22583 .01472 L
.23545 .01474 L
.24507 .01479 L
.25469 .01491 L
.26431 .01524 L
.27393 .016 L
.28355 .01771 L
.29317 .02125 L
.30279 .02813 L
.31241 .04058 L
.32203 .06154 L
.33165 .09437 L
.34127 .14201 L
.35089 .20581 L
.36051 .2842 L
.37013 .37172 L
.37975 .45902 L
.38937 .53416 L
.39899 .58521 L
.40861 .60332 L
.41823 .58521 L
.42785 .53416 L
.43747 .45902 L
.44709 .37172 L
.45671 .2842 L
.46633 .20581 L
.47595 .14201 L
.48557 .09437 L
.49519 .06154 L
Mistroke
.50481 .04058 L
.51443 .02813 L
.52405 .02125 L
.53367 .01771 L
.54329 .016 L
.55291 .01524 L
.56253 .01491 L
.57215 .01479 L
.58177 .01474 L
.59139 .01472 L
.60101 .01472 L
.61063 .01472 L
.62025 .01472 L
.62987 .01472 L
.63949 .01472 L
.64911 .01472 L
.65873 .01472 L
.66835 .01472 L
.67797 .01472 L
.68759 .01472 L
.69721 .01472 L
.70683 .01472 L
.71645 .01472 L
.72607 .01472 L
.73569 .01472 L
.74531 .01472 L
.75493 .01472 L
.76455 .01472 L
.77417 .01472 L
.78379 .01472 L
.79341 .01472 L
.80303 .01472 L
.81265 .01472 L
.82227 .01472 L
.83189 .01472 L
.84151 .01472 L
.85113 .01472 L
.86075 .01472 L
.87037 .01472 L
.87999 .01472 L
.88961 .01472 L
.89923 .01472 L
.90885 .01472 L
.91847 .01472 L
.92809 .01472 L
.93771 .01472 L
.94733 .01472 L
.95695 .01472 L
.96657 .01472 L
.97619 .01472 L
Mistroke
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd

:[font = output; output; inactive; preserveAspect; endGroup]
Graphics["<<>>"]
;[o]
-Graphics-
:[font = input; preserveAspect; startGroup]
F=NFourierTransform[f,x,0,FourierParameters->{a,b}]
:[font = output; output; inactive; preserveAspect; endGroup]
0.3989422804011691
;[o]
0.398942
:[font = input; preserveAspect; startGroup]
FourierTransform[f[t],t,omega,FourierParameters->{a,b}]
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
1/(E^(omega^2/2)*Sqrt[2*Pi])
;[o]
         1
--------------------
      2
 omega /2
E         Sqrt[2 Pi]
:[font = subsection; inactive; preserveAspect; startGroup]
Rcktrafo
:[font = input; preserveAspect; startGroup]
{a,b}={0,1}
:[font = output; output; inactive; preserveAspect; endGroup]
{0, 1}
;[o]
{0, 1}
:[font = input; preserveAspect; startGroup]
f=1/(E^((x-2)^2/2+x^4)*Sqrt[2*Pi])/.x->omega//N
:[font = output; output; inactive; preserveAspect; endGroup]
0.3989422804014327*2.718281828459045^(-0.5*(-2. + omega)^2 - 1.*omega^4)
;[o]
                                  2           4
                -0.5 (-2. + omega)  - 1. omega
0.398942 2.71828
:[font = input; preserveAspect; startGroup]
NInverseFourierTransform[f,omega,-5.,
FourierParameters->{a,b}]
:[font = output; output; inactive; preserveAspect; endGroup]
-0.008121744439469085 - 0.004022475382427523*I
;[o]
-0.00812174 - 0.00402248 I
:[font = input; preserveAspect; startGroup]
g2=Plot[NInverseFourierTransform[f,omega,t,FourierParameters->{a,b}]//Re,{t,-5,5}];
:[font = postscript; PostScript; formatAsPostScript; output; inactive; preserveAspect; pictureLeft = 34; pictureWidth = 282; pictureHeight = 174; endGroup]
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.0952381 0.122794 8.47164 [
[.11905 -0.0125 -6 -9 ]
[.11905 -0.0125 6 0 ]
[.30952 -0.0125 -6 -9 ]
[.30952 -0.0125 6 0 ]
[.5 -0.0125 -3 -9 ]
[.5 -0.0125 3 0 ]
[.69048 -0.0125 -3 -9 ]
[.69048 -0.0125 3 0 ]
[.88095 -0.0125 -3 -9 ]
[.88095 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03808 -30 -4.5 ]
[-0.0125 .03808 0 4.5 ]
[-0.0125 .12279 -6 -4.5 ]
[-0.0125 .12279 0 4.5 ]
[-0.0125 .20751 -24 -4.5 ]
[-0.0125 .20751 0 4.5 ]
[-0.0125 .29223 -24 -4.5 ]
[-0.0125 .29223 0 4.5 ]
[-0.0125 .37694 -24 -4.5 ]
[-0.0125 .37694 0 4.5 ]
[-0.0125 .46166 -24 -4.5 ]
[-0.0125 .46166 0 4.5 ]
[-0.0125 .54638 -24 -4.5 ]
[-0.0125 .54638 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11905 0 m
.11905 .00625 L
s
[(-4)] .11905 -0.0125 0 1 Mshowa
.30952 0 m
.30952 .00625 L
s
[(-2)] .30952 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(0)] .5 -0.0125 0 1 Mshowa
.69048 0 m
.69048 .00625 L
s
[(2)] .69048 -0.0125 0 1 Mshowa
.88095 0 m
.88095 .00625 L
s
[(4)] .88095 -0.0125 0 1 Mshowa
.125 Mabswid
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.07143 0 m
.07143 .00375 L
s
.02381 0 m
.02381 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03808 m
.00625 .03808 L
s
[(-0.01)] -0.0125 .03808 1 0 Mshowa
0 .12279 m
.00625 .12279 L
s
[(0)] -0.0125 .12279 1 0 Mshowa
0 .20751 m
.00625 .20751 L
s
[(0.01)] -0.0125 .20751 1 0 Mshowa
0 .29223 m
.00625 .29223 L
s
[(0.02)] -0.0125 .29223 1 0 Mshowa
0 .37694 m
.00625 .37694 L
s
[(0.03)] -0.0125 .37694 1 0 Mshowa
0 .46166 m
.00625 .46166 L
s
[(0.04)] -0.0125 .46166 1 0 Mshowa
0 .54638 m
.00625 .54638 L
s
[(0.05)] -0.0125 .54638 1 0 Mshowa
.125 Mabswid
0 .05502 m
.00375 .05502 L
s
0 .07196 m
.00375 .07196 L
s
0 .08891 m
.00375 .08891 L
s
0 .10585 m
.00375 .10585 L
s
0 .13974 m
.00375 .13974 L
s
0 .15668 m
.00375 .15668 L
s
0 .17362 m
.00375 .17362 L
s
0 .19057 m
.00375 .19057 L
s
0 .22445 m
.00375 .22445 L
s
0 .2414 m
.00375 .2414 L
s
0 .25834 m
.00375 .25834 L
s
0 .27528 m
.00375 .27528 L
s
0 .30917 m
.00375 .30917 L
s
0 .32611 m
.00375 .32611 L
s
0 .34306 m
.00375 .34306 L
s
0 .36 m
.00375 .36 L
s
0 .39389 m
.00375 .39389 L
s
0 .41083 m
.00375 .41083 L
s
0 .42777 m
.00375 .42777 L
s
0 .44472 m
.00375 .44472 L
s
0 .4786 m
.00375 .4786 L
s
0 .49555 m
.00375 .49555 L
s
0 .51249 m
.00375 .51249 L
s
0 .52943 m
.00375 .52943 L
s
0 .02113 m
.00375 .02113 L
s
0 .00419 m
.00375 .00419 L
s
0 .56332 m
.00375 .56332 L
s
0 .58026 m
.00375 .58026 L
s
0 .59721 m
.00375 .59721 L
s
0 .61415 m
.00375 .61415 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.11905 .61178 m
.11905 .61803 L
s
.30952 .61178 m
.30952 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.69048 .61178 m
.69048 .61803 L
s
.88095 .61178 m
.88095 .61803 L
s
.125 Mabswid
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.07143 .61428 m
.07143 .61803 L
s
.02381 .61428 m
.02381 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.97619 .61428 m
.97619 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03808 m
1 .03808 L
s
.99375 .12279 m
1 .12279 L
s
.99375 .20751 m
1 .20751 L
s
.99375 .29223 m
1 .29223 L
s
.99375 .37694 m
1 .37694 L
s
.99375 .46166 m
1 .46166 L
s
.99375 .54638 m
1 .54638 L
s
.125 Mabswid
.99625 .05502 m
1 .05502 L
s
.99625 .07196 m
1 .07196 L
s
.99625 .08891 m
1 .08891 L
s
.99625 .10585 m
1 .10585 L
s
.99625 .13974 m
1 .13974 L
s
.99625 .15668 m
1 .15668 L
s
.99625 .17362 m
1 .17362 L
s
.99625 .19057 m
1 .19057 L
s
.99625 .22445 m
1 .22445 L
s
.99625 .2414 m
1 .2414 L
s
.99625 .25834 m
1 .25834 L
s
.99625 .27528 m
1 .27528 L
s
.99625 .30917 m
1 .30917 L
s
.99625 .32611 m
1 .32611 L
s
.99625 .34306 m
1 .34306 L
s
.99625 .36 m
1 .36 L
s
.99625 .39389 m
1 .39389 L
s
.99625 .41083 m
1 .41083 L
s
.99625 .42777 m
1 .42777 L
s
.99625 .44472 m
1 .44472 L
s
.99625 .4786 m
1 .4786 L
s
.99625 .49555 m
1 .49555 L
s
.99625 .51249 m
1 .51249 L
s
.99625 .52943 m
1 .52943 L
s
.99625 .02113 m
1 .02113 L
s
.99625 .00419 m
1 .00419 L
s
.99625 .56332 m
1 .56332 L
s
.99625 .58026 m
1 .58026 L
s
.99625 .59721 m
1 .59721 L
s
.99625 .61415 m
1 .61415 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
.007 w
.02381 .05399 m
.04262 .04185 L
.06244 .03059 L
.08255 .02165 L
.08806 .01976 L
.09396 .01804 L
.09948 .01673 L
.10191 .01625 L
.10458 .01579 L
.10697 .01545 L
.10954 .01516 L
.11096 .01502 L
.11225 .01492 L
.11348 .01485 L
.1148 .01478 L
.11554 .01476 L
.11621 .01474 L
.11751 .01472 L
.11825 .01472 L
.11904 .01472 L
.11979 .01473 L
.12048 .01475 L
.12173 .01479 L
.12244 .01483 L
.12311 .01486 L
.12444 .01496 L
.12589 .01508 L
.1285 .01538 L
.13097 .01574 L
.13561 .01663 L
.14102 .01805 L
.14603 .01972 L
.15565 .02396 L
.16469 .0292 L
.18529 .04586 L
.20547 .06869 L
.22398 .09525 L
.2636 .16876 L
.30171 .25615 L
.34227 .35767 L
.38132 .45204 L
.40123 .49493 L
.42282 .53513 L
.44362 .56613 L
.45353 .57785 L
.4628 .5869 L
.47184 .59387 L
.47649 .59672 L
.48156 .59925 L
.48443 .60042 L
Mistroke
.48709 .60132 L
.48985 .60209 L
.49235 .60262 L
.49353 .60282 L
.49481 .603 L
.49601 .60313 L
.49712 .60322 L
.4983 .60328 L
.49959 .60332 L
.50024 .60332 L
.50094 .60331 L
.5022 .60326 L
.50342 .60318 L
.50412 .60312 L
.50477 .60305 L
.5075 .60264 L
.50986 .60215 L
.5124 .60148 L
.51818 .59936 L
.52348 .59674 L
.53329 .59014 L
.54361 .58085 L
.56339 .55662 L
.58177 .52722 L
.62087 .44704 L
.66242 .34585 L
.70246 .24603 L
.74097 .15922 L
.7605 .1215 L
.78195 .08617 L
.80258 .05881 L
.8214 .03971 L
.8314 .03185 L
.84089 .02582 L
.8509 .02093 L
.85655 .01882 L
.86179 .01726 L
.86642 .01621 L
.86884 .01577 L
.8714 .01539 L
.87365 .01513 L
.87484 .01502 L
.87611 .01492 L
.87728 .01484 L
.87835 .01479 L
.87942 .01475 L
.88043 .01473 L
.88162 .01472 L
.88293 .01472 L
.88359 .01473 L
Mistroke
.88429 .01475 L
.88557 .0148 L
.88684 .01487 L
.88805 .01495 L
.89031 .01514 L
.89297 .01545 L
.89544 .0158 L
.90103 .01683 L
.90611 .01805 L
.9116 .01965 L
.92156 .02324 L
.94018 .03196 L
.97619 .05399 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd

:[font = input; preserveAspect; startGroup]
InverseFourierTransform[f/.x->omega,omega,t,FourierParameters->{a,b}]
:[font = output; output; inactive; preserveAspect; endGroup]
0.3989422804014327*InverseFourierTransform[2.718281828459045^(-0.5*(-2. + omega)^2 - 1.*omega^4), omega, t]
;[o]
                                                          2           4
                                        -0.5 (-2. + omega)  - 1. omega
0.398942 InverseFourierTransform[2.71828                               , omega, t]
:[font = input; preserveAspect]
F=NInverseFourierTransformFFT[f,omega,{100,{-2,2},-10},{a,b}];
:[font = input; preserveAspect; startGroup]
g1=F//Re//Transpose//plot1
:[font = print; inactive; preserveAspect]
Dimension der Daten  {100, 2}
:[font = postscript; PostScript; formatAsPostScript; output; inactive; preserveAspect; pictureLeft = 34; pictureWidth = 282; pictureHeight = 174]
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.40861 0.03848 0.122791 8.4717 [
[.02381 -0.0125 -9 -9 ]
[.02381 -0.0125 9 0 ]
[.21621 -0.0125 -6 -9 ]
[.21621 -0.0125 6 0 ]
[.40861 -0.0125 -3 -9 ]
[.40861 -0.0125 3 0 ]
[.60101 -0.0125 -3 -9 ]
[.60101 -0.0125 3 0 ]
[.79341 -0.0125 -6 -9 ]
[.79341 -0.0125 6 0 ]
[.98581 -0.0125 -6 -9 ]
[.98581 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03807 -30 -4.5 ]
[-0.0125 .03807 0 4.5 ]
[-0.0125 .12279 -6 -4.5 ]
[-0.0125 .12279 0 4.5 ]
[-0.0125 .20751 -24 -4.5 ]
[-0.0125 .20751 0 4.5 ]
[-0.0125 .29222 -24 -4.5 ]
[-0.0125 .29222 0 4.5 ]
[-0.0125 .37694 -24 -4.5 ]
[-0.0125 .37694 0 4.5 ]
[-0.0125 .46166 -24 -4.5 ]
[-0.0125 .46166 0 4.5 ]
[-0.0125 .54638 -24 -4.5 ]
[-0.0125 .54638 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .11955 -3 -4.5 ]
[.97619 .11955 3 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(-10)] .02381 -0.0125 0 1 Mshowa
.21621 0 m
.21621 .00625 L
s
[(-5)] .21621 -0.0125 0 1 Mshowa
.40861 0 m
.40861 .00625 L
s
[(0)] .40861 -0.0125 0 1 Mshowa
.60101 0 m
.60101 .00625 L
s
[(5)] .60101 -0.0125 0 1 Mshowa
.79341 0 m
.79341 .00625 L
s
[(10)] .79341 -0.0125 0 1 Mshowa
.98581 0 m
.98581 .00625 L
s
[(15)] .98581 -0.0125 0 1 Mshowa
.125 Mabswid
.06229 0 m
.06229 .00375 L
s
.10077 0 m
.10077 .00375 L
s
.13925 0 m
.13925 .00375 L
s
.17773 0 m
.17773 .00375 L
s
.25469 0 m
.25469 .00375 L
s
.29317 0 m
.29317 .00375 L
s
.33165 0 m
.33165 .00375 L
s
.37013 0 m
.37013 .00375 L
s
.44709 0 m
.44709 .00375 L
s
.48557 0 m
.48557 .00375 L
s
.52405 0 m
.52405 .00375 L
s
.56253 0 m
.56253 .00375 L
s
.63949 0 m
.63949 .00375 L
s
.67797 0 m
.67797 .00375 L
s
.71645 0 m
.71645 .00375 L
s
.75493 0 m
.75493 .00375 L
s
.83189 0 m
.83189 .00375 L
s
.87037 0 m
.87037 .00375 L
s
.90885 0 m
.90885 .00375 L
s
.94733 0 m
.94733 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03807 m
.00625 .03807 L
s
[(-0.01)] -0.0125 .03807 1 0 Mshowa
0 .12279 m
.00625 .12279 L
s
[(0)] -0.0125 .12279 1 0 Mshowa
0 .20751 m
.00625 .20751 L
s
[(0.01)] -0.0125 .20751 1 0 Mshowa
0 .29222 m
.00625 .29222 L
s
[(0.02)] -0.0125 .29222 1 0 Mshowa
0 .37694 m
.00625 .37694 L
s
[(0.03)] -0.0125 .37694 1 0 Mshowa
0 .46166 m
.00625 .46166 L
s
[(0.04)] -0.0125 .46166 1 0 Mshowa
0 .54638 m
.00625 .54638 L
s
[(0.05)] -0.0125 .54638 1 0 Mshowa
.125 Mabswid
0 .05502 m
.00375 .05502 L
s
0 .07196 m
.00375 .07196 L
s
0 .0889 m
.00375 .0889 L
s
0 .10585 m
.00375 .10585 L
s
0 .13973 m
.00375 .13973 L
s
0 .15668 m
.00375 .15668 L
s
0 .17362 m
.00375 .17362 L
s
0 .19056 m
.00375 .19056 L
s
0 .22445 m
.00375 .22445 L
s
0 .24139 m
.00375 .24139 L
s
0 .25834 m
.00375 .25834 L
s
0 .27528 m
.00375 .27528 L
s
0 .30917 m
.00375 .30917 L
s
0 .32611 m
.00375 .32611 L
s
0 .34305 m
.00375 .34305 L
s
0 .36 m
.00375 .36 L
s
0 .39388 m
.00375 .39388 L
s
0 .41083 m
.00375 .41083 L
s
0 .42777 m
.00375 .42777 L
s
0 .44472 m
.00375 .44472 L
s
0 .4786 m
.00375 .4786 L
s
0 .49555 m
.00375 .49555 L
s
0 .51249 m
.00375 .51249 L
s
0 .52943 m
.00375 .52943 L
s
0 .02113 m
.00375 .02113 L
s
0 .00419 m
.00375 .00419 L
s
0 .56332 m
.00375 .56332 L
s
0 .58026 m
.00375 .58026 L
s
0 .59721 m
.00375 .59721 L
s
0 .61415 m
.00375 .61415 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21621 .61178 m
.21621 .61803 L
s
.40861 .61178 m
.40861 .61803 L
s
.60101 .61178 m
.60101 .61803 L
s
.79341 .61178 m
.79341 .61803 L
s
.98581 .61178 m
.98581 .61803 L
s
.125 Mabswid
.06229 .61428 m
.06229 .61803 L
s
.10077 .61428 m
.10077 .61803 L
s
.13925 .61428 m
.13925 .61803 L
s
.17773 .61428 m
.17773 .61803 L
s
.25469 .61428 m
.25469 .61803 L
s
.29317 .61428 m
.29317 .61803 L
s
.33165 .61428 m
.33165 .61803 L
s
.37013 .61428 m
.37013 .61803 L
s
.44709 .61428 m
.44709 .61803 L
s
.48557 .61428 m
.48557 .61803 L
s
.52405 .61428 m
.52405 .61803 L
s
.56253 .61428 m
.56253 .61803 L
s
.63949 .61428 m
.63949 .61803 L
s
.67797 .61428 m
.67797 .61803 L
s
.71645 .61428 m
.71645 .61803 L
s
.75493 .61428 m
.75493 .61803 L
s
.83189 .61428 m
.83189 .61803 L
s
.87037 .61428 m
.87037 .61803 L
s
.90885 .61428 m
.90885 .61803 L
s
.94733 .61428 m
.94733 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03807 m
1 .03807 L
s
.99375 .12279 m
1 .12279 L
s
.99375 .20751 m
1 .20751 L
s
.99375 .29222 m
1 .29222 L
s
.99375 .37694 m
1 .37694 L
s
.99375 .46166 m
1 .46166 L
s
.99375 .54638 m
1 .54638 L
s
.125 Mabswid
.99625 .05502 m
1 .05502 L
s
.99625 .07196 m
1 .07196 L
s
.99625 .0889 m
1 .0889 L
s
.99625 .10585 m
1 .10585 L
s
.99625 .13973 m
1 .13973 L
s
.99625 .15668 m
1 .15668 L
s
.99625 .17362 m
1 .17362 L
s
.99625 .19056 m
1 .19056 L
s
.99625 .22445 m
1 .22445 L
s
.99625 .24139 m
1 .24139 L
s
.99625 .25834 m
1 .25834 L
s
.99625 .27528 m
1 .27528 L
s
.99625 .30917 m
1 .30917 L
s
.99625 .32611 m
1 .32611 L
s
.99625 .34305 m
1 .34305 L
s
.99625 .36 m
1 .36 L
s
.99625 .39388 m
1 .39388 L
s
.99625 .41083 m
1 .41083 L
s
.99625 .42777 m
1 .42777 L
s
.99625 .44472 m
1 .44472 L
s
.99625 .4786 m
1 .4786 L
s
.99625 .49555 m
1 .49555 L
s
.99625 .51249 m
1 .51249 L
s
.99625 .52943 m
1 .52943 L
s
.99625 .02113 m
1 .02113 L
s
.99625 .00419 m
1 .00419 L
s
.99625 .56332 m
1 .56332 L
s
.99625 .58026 m
1 .58026 L
s
.99625 .59721 m
1 .59721 L
s
.99625 .61415 m
1 .61415 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
[( )] .97619 .11955 0 0 Mshowa
.001 w
.02381 .11942 m
.03343 .11969 L
.04305 .12046 L
.05267 .12181 L
.06229 .12376 L
.07191 .12629 L
.08153 .12929 L
.09115 .13258 L
.10077 .13589 L
.11039 .13886 L
.12001 .14107 L
.12963 .14205 L
.13925 .14133 L
.14887 .13848 L
.15849 .13316 L
.16811 .12518 L
.17773 .11453 L
.18735 .10146 L
.19697 .08645 L
.20659 .07028 L
.21621 .05398 L
.22583 .03883 L
.23545 .02623 L
.24507 .0177 L
.25469 .01472 L
.26431 .01862 L
.27393 .0305 L
.28355 .0511 L
.29317 .08067 L
.30279 .11898 L
.31241 .16519 L
.32203 .21794 L
.33165 .27536 L
.34127 .33514 L
.35089 .39467 L
.36051 .4512 L
.37013 .502 L
.37975 .54453 L
.38937 .5766 L
.39899 .59655 L
.40861 .60332 L
.41823 .59655 L
.42785 .5766 L
.43747 .54453 L
.44709 .502 L
.45671 .4512 L
.46633 .39467 L
.47595 .33514 L
.48557 .27536 L
.49519 .21794 L
Mistroke
.50481 .16519 L
.51443 .11898 L
.52405 .08067 L
.53367 .0511 L
.54329 .0305 L
.55291 .01862 L
.56253 .01472 L
.57215 .0177 L
.58177 .02623 L
.59139 .03883 L
.60101 .05398 L
.61063 .07028 L
.62025 .08645 L
.62987 .10146 L
.63949 .11453 L
.64911 .12518 L
.65873 .13316 L
.66835 .13848 L
.67797 .14133 L
.68759 .14205 L
.69721 .14107 L
.70683 .13886 L
.71645 .13589 L
.72607 .13258 L
.73569 .12929 L
.74531 .12629 L
.75493 .12376 L
.76455 .12181 L
.77417 .12046 L
.78379 .11969 L
.79341 .11942 L
.80303 .11955 L
.81265 .11997 L
.82227 .12058 L
.83189 .12127 L
.84151 .12197 L
.85113 .1226 L
.86075 .12314 L
.87037 .12354 L
.87999 .12379 L
.88961 .12387 L
.89923 .12379 L
.90885 .12354 L
.91847 .12314 L
.92809 .1226 L
.93771 .12197 L
.94733 .12127 L
.95695 .12058 L
.96657 .11997 L
.97619 .11955 L
Mistroke
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd

:[font = output; output; inactive; preserveAspect; endGroup]
Graphics["<<>>"]
;[o]
-Graphics-
:[font = input; preserveAspect; startGroup]
Show[g1,g2]
:[font = postscript; PostScript; formatAsPostScript; output; inactive; preserveAspect; pictureLeft = 34; pictureWidth = 282; pictureHeight = 174]
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.40861 0.03848 0.122794 8.47163 [
[.02381 -0.0125 -9 -9 ]
[.02381 -0.0125 9 0 ]
[.21621 -0.0125 -6 -9 ]
[.21621 -0.0125 6 0 ]
[.40861 -0.0125 -3 -9 ]
[.40861 -0.0125 3 0 ]
[.60101 -0.0125 -3 -9 ]
[.60101 -0.0125 3 0 ]
[.79341 -0.0125 -6 -9 ]
[.79341 -0.0125 6 0 ]
[.98581 -0.0125 -6 -9 ]
[.98581 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03808 -30 -4.5 ]
[-0.0125 .03808 0 4.5 ]
[-0.0125 .12279 -6 -4.5 ]
[-0.0125 .12279 0 4.5 ]
[-0.0125 .20751 -24 -4.5 ]
[-0.0125 .20751 0 4.5 ]
[-0.0125 .29223 -24 -4.5 ]
[-0.0125 .29223 0 4.5 ]
[-0.0125 .37694 -24 -4.5 ]
[-0.0125 .37694 0 4.5 ]
[-0.0125 .46166 -24 -4.5 ]
[-0.0125 .46166 0 4.5 ]
[-0.0125 .54638 -24 -4.5 ]
[-0.0125 .54638 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .11955 -3 -4.5 ]
[.97619 .11955 3 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(-10)] .02381 -0.0125 0 1 Mshowa
.21621 0 m
.21621 .00625 L
s
[(-5)] .21621 -0.0125 0 1 Mshowa
.40861 0 m
.40861 .00625 L
s
[(0)] .40861 -0.0125 0 1 Mshowa
.60101 0 m
.60101 .00625 L
s
[(5)] .60101 -0.0125 0 1 Mshowa
.79341 0 m
.79341 .00625 L
s
[(10)] .79341 -0.0125 0 1 Mshowa
.98581 0 m
.98581 .00625 L
s
[(15)] .98581 -0.0125 0 1 Mshowa
.125 Mabswid
.06229 0 m
.06229 .00375 L
s
.10077 0 m
.10077 .00375 L
s
.13925 0 m
.13925 .00375 L
s
.17773 0 m
.17773 .00375 L
s
.25469 0 m
.25469 .00375 L
s
.29317 0 m
.29317 .00375 L
s
.33165 0 m
.33165 .00375 L
s
.37013 0 m
.37013 .00375 L
s
.44709 0 m
.44709 .00375 L
s
.48557 0 m
.48557 .00375 L
s
.52405 0 m
.52405 .00375 L
s
.56253 0 m
.56253 .00375 L
s
.63949 0 m
.63949 .00375 L
s
.67797 0 m
.67797 .00375 L
s
.71645 0 m
.71645 .00375 L
s
.75493 0 m
.75493 .00375 L
s
.83189 0 m
.83189 .00375 L
s
.87037 0 m
.87037 .00375 L
s
.90885 0 m
.90885 .00375 L
s
.94733 0 m
.94733 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03808 m
.00625 .03808 L
s
[(-0.01)] -0.0125 .03808 1 0 Mshowa
0 .12279 m
.00625 .12279 L
s
[(0)] -0.0125 .12279 1 0 Mshowa
0 .20751 m
.00625 .20751 L
s
[(0.01)] -0.0125 .20751 1 0 Mshowa
0 .29223 m
.00625 .29223 L
s
[(0.02)] -0.0125 .29223 1 0 Mshowa
0 .37694 m
.00625 .37694 L
s
[(0.03)] -0.0125 .37694 1 0 Mshowa
0 .46166 m
.00625 .46166 L
s
[(0.04)] -0.0125 .46166 1 0 Mshowa
0 .54638 m
.00625 .54638 L
s
[(0.05)] -0.0125 .54638 1 0 Mshowa
.125 Mabswid
0 .05502 m
.00375 .05502 L
s
0 .07196 m
.00375 .07196 L
s
0 .08891 m
.00375 .08891 L
s
0 .10585 m
.00375 .10585 L
s
0 .13974 m
.00375 .13974 L
s
0 .15668 m
.00375 .15668 L
s
0 .17362 m
.00375 .17362 L
s
0 .19057 m
.00375 .19057 L
s
0 .22445 m
.00375 .22445 L
s
0 .2414 m
.00375 .2414 L
s
0 .25834 m
.00375 .25834 L
s
0 .27528 m
.00375 .27528 L
s
0 .30917 m
.00375 .30917 L
s
0 .32611 m
.00375 .32611 L
s
0 .34306 m
.00375 .34306 L
s
0 .36 m
.00375 .36 L
s
0 .39389 m
.00375 .39389 L
s
0 .41083 m
.00375 .41083 L
s
0 .42777 m
.00375 .42777 L
s
0 .44472 m
.00375 .44472 L
s
0 .4786 m
.00375 .4786 L
s
0 .49555 m
.00375 .49555 L
s
0 .51249 m
.00375 .51249 L
s
0 .52943 m
.00375 .52943 L
s
0 .02113 m
.00375 .02113 L
s
0 .00419 m
.00375 .00419 L
s
0 .56332 m
.00375 .56332 L
s
0 .58026 m
.00375 .58026 L
s
0 .59721 m
.00375 .59721 L
s
0 .61415 m
.00375 .61415 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21621 .61178 m
.21621 .61803 L
s
.40861 .61178 m
.40861 .61803 L
s
.60101 .61178 m
.60101 .61803 L
s
.79341 .61178 m
.79341 .61803 L
s
.98581 .61178 m
.98581 .61803 L
s
.125 Mabswid
.06229 .61428 m
.06229 .61803 L
s
.10077 .61428 m
.10077 .61803 L
s
.13925 .61428 m
.13925 .61803 L
s
.17773 .61428 m
.17773 .61803 L
s
.25469 .61428 m
.25469 .61803 L
s
.29317 .61428 m
.29317 .61803 L
s
.33165 .61428 m
.33165 .61803 L
s
.37013 .61428 m
.37013 .61803 L
s
.44709 .61428 m
.44709 .61803 L
s
.48557 .61428 m
.48557 .61803 L
s
.52405 .61428 m
.52405 .61803 L
s
.56253 .61428 m
.56253 .61803 L
s
.63949 .61428 m
.63949 .61803 L
s
.67797 .61428 m
.67797 .61803 L
s
.71645 .61428 m
.71645 .61803 L
s
.75493 .61428 m
.75493 .61803 L
s
.83189 .61428 m
.83189 .61803 L
s
.87037 .61428 m
.87037 .61803 L
s
.90885 .61428 m
.90885 .61803 L
s
.94733 .61428 m
.94733 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03808 m
1 .03808 L
s
.99375 .12279 m
1 .12279 L
s
.99375 .20751 m
1 .20751 L
s
.99375 .29223 m
1 .29223 L
s
.99375 .37694 m
1 .37694 L
s
.99375 .46166 m
1 .46166 L
s
.99375 .54638 m
1 .54638 L
s
.125 Mabswid
.99625 .05502 m
1 .05502 L
s
.99625 .07196 m
1 .07196 L
s
.99625 .08891 m
1 .08891 L
s
.99625 .10585 m
1 .10585 L
s
.99625 .13974 m
1 .13974 L
s
.99625 .15668 m
1 .15668 L
s
.99625 .17362 m
1 .17362 L
s
.99625 .19057 m
1 .19057 L
s
.99625 .22445 m
1 .22445 L
s
.99625 .2414 m
1 .2414 L
s
.99625 .25834 m
1 .25834 L
s
.99625 .27528 m
1 .27528 L
s
.99625 .30917 m
1 .30917 L
s
.99625 .32611 m
1 .32611 L
s
.99625 .34306 m
1 .34306 L
s
.99625 .36 m
1 .36 L
s
.99625 .39389 m
1 .39389 L
s
.99625 .41083 m
1 .41083 L
s
.99625 .42777 m
1 .42777 L
s
.99625 .44472 m
1 .44472 L
s
.99625 .4786 m
1 .4786 L
s
.99625 .49555 m
1 .49555 L
s
.99625 .51249 m
1 .51249 L
s
.99625 .52943 m
1 .52943 L
s
.99625 .02113 m
1 .02113 L
s
.99625 .00419 m
1 .00419 L
s
.99625 .56332 m
1 .56332 L
s
.99625 .58026 m
1 .58026 L
s
.99625 .59721 m
1 .59721 L
s
.99625 .61415 m
1 .61415 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
[( )] .97619 .11955 0 0 Mshowa
.001 w
.02381 .11942 m
.03343 .1197 L
.04305 .12047 L
.05267 .12181 L
.06229 .12376 L
.07191 .12629 L
.08153 .12929 L
.09115 .13259 L
.10077 .13589 L
.11039 .13886 L
.12001 .14107 L
.12963 .14205 L
.13925 .14133 L
.14887 .13848 L
.15849 .13317 L
.16811 .12519 L
.17773 .11454 L
.18735 .10146 L
.19697 .08645 L
.20659 .07028 L
.21621 .05399 L
.22583 .03883 L
.23545 .02624 L
.24507 .01771 L
.25469 .01472 L
.26431 .01862 L
.27393 .03051 L
.28355 .0511 L
.29317 .08068 L
.30279 .11898 L
.31241 .16519 L
.32203 .21795 L
.33165 .27536 L
.34127 .33514 L
.35089 .39467 L
.36051 .45121 L
.37013 .50201 L
.37975 .54453 L
.38937 .5766 L
.39899 .59655 L
.40861 .60332 L
.41823 .59655 L
.42785 .5766 L
.43747 .54453 L
.44709 .50201 L
.45671 .45121 L
.46633 .39467 L
.47595 .33514 L
.48557 .27536 L
.49519 .21795 L
Mistroke
.50481 .16519 L
.51443 .11898 L
.52405 .08068 L
.53367 .0511 L
.54329 .03051 L
.55291 .01862 L
.56253 .01472 L
.57215 .01771 L
.58177 .02624 L
.59139 .03883 L
.60101 .05399 L
.61063 .07028 L
.62025 .08645 L
.62987 .10146 L
.63949 .11454 L
.64911 .12519 L
.65873 .13317 L
.66835 .13848 L
.67797 .14133 L
.68759 .14205 L
.69721 .14107 L
.70683 .13886 L
.71645 .13589 L
.72607 .13259 L
.73569 .12929 L
.74531 .12629 L
.75493 .12376 L
.76455 .12181 L
.77417 .12047 L
.78379 .1197 L
.79341 .11942 L
.80303 .11955 L
.81265 .11998 L
.82227 .12058 L
.83189 .12127 L
.84151 .12197 L
.85113 .12261 L
.86075 .12314 L
.87037 .12355 L
.87999 .12379 L
.88961 .12388 L
.89923 .12379 L
.90885 .12355 L
.91847 .12314 L
.92809 .12261 L
.93771 .12197 L
.94733 .12127 L
.95695 .12058 L
.96657 .11998 L
.97619 .11955 L
Mistroke
Mfstroke
1 0 0 r
.007 w
.21621 .05399 m
.22381 .04185 L
.23182 .03059 L
.23994 .02165 L
.24217 .01976 L
.24455 .01804 L
.24678 .01673 L
.24776 .01625 L
.24884 .01579 L
.24981 .01545 L
.25085 .01516 L
.25142 .01502 L
.25194 .01492 L
.25244 .01485 L
.25297 .01478 L
.25327 .01476 L
.25354 .01474 L
.25407 .01472 L
.25437 .01472 L
.25469 .01472 L
.25499 .01473 L
.25527 .01475 L
.25578 .01479 L
.25606 .01483 L
.25633 .01486 L
.25687 .01496 L
.25745 .01508 L
.25851 .01538 L
.25951 .01574 L
.26138 .01663 L
.26357 .01805 L
.26559 .01972 L
.26948 .02396 L
.27313 .0292 L
.28146 .04586 L
.28961 .06869 L
.29709 .09525 L
.3131 .16876 L
.32849 .25615 L
.34488 .35767 L
.36066 .45204 L
.3687 .49493 L
.37742 .53513 L
.38583 .56613 L
.38983 .57785 L
.39358 .5869 L
.39723 .59387 L
.39911 .59672 L
.40116 .59925 L
.40232 .60042 L
Mistroke
.4034 .60132 L
.40451 .60208 L
.40552 .60262 L
.406 .60282 L
.40651 .603 L
.407 .60313 L
.40745 .60322 L
.40792 .60328 L
.40844 .60332 L
.40871 .60332 L
.40899 .60331 L
.4095 .60326 L
.40999 .60318 L
.41027 .60312 L
.41054 .60305 L
.41164 .60264 L
.41259 .60215 L
.41362 .60148 L
.41596 .59936 L
.4181 .59674 L
.42206 .59014 L
.42623 .58084 L
.43422 .55662 L
.44165 .52722 L
.45745 .44704 L
.47423 .34585 L
.49041 .24603 L
.50597 .15922 L
.51386 .1215 L
.52253 .08617 L
.53086 .05881 L
.53847 .03971 L
.54251 .03185 L
.54634 .02582 L
.55039 .02093 L
.55267 .01882 L
.55479 .01726 L
.55666 .01621 L
.55764 .01577 L
.55867 .01539 L
.55958 .01513 L
.56006 .01502 L
.56057 .01492 L
.56105 .01484 L
.56148 .01479 L
.56191 .01475 L
.56232 .01473 L
.5628 .01472 L
.56333 .01472 L
.56359 .01473 L
Mistroke
.56388 .01475 L
.5644 .0148 L
.56491 .01487 L
.5654 .01495 L
.56631 .01514 L
.56739 .01545 L
.56838 .0158 L
.57064 .01683 L
.57269 .01805 L
.57491 .01965 L
.57894 .02324 L
.58646 .03196 L
.60101 .05399 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd

:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
Graphics["<<>>"]
;[o]
-Graphics-
^*)
