(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)



Unprotect["code`KernDichte`*"];
Clear["code`KernDichte`*"];
Remove["code`KernDichte`Private`*"];						



BeginPackage["code`KernDichte`",

			{"code`Kronecker`",
			 "LinearAlgebra`MatrixManipulation`",
	         (*"LinearAlgebra`Cholesky`",*)
			 "Utilities`FilterOptions`",
			 "Graphics`Graphics`",
			 "Statistics`Common`DistributionsCommon`",
		     "Statistics`NormalDistribution`",
		 	 "Statistics`DescriptiveStatistics`",
	         "Statistics`DataManipulation`",                                         
		     "Global`"}]



KernDichte::usage = "KernDichte[x_,data_,Kern_,theta_] oder
					 KernDichte[x_,data_,Kern_,theta_,Op_]"
		
GaussKern::usage = "GaussKern = (2 Pi sigma)^(-.5 p) Exp[-.5 (x.x)/sigma]"

smoothQuickAndDirty::usage = "smoothQuickAndDirty[ST_]"

smoothQuickAndDirty1::usage = "smoothQuickAndDirty1[ST_]"

smoothQuickAndDirtyM::usage = "smoothQuickAndDirtyM[y_,option_]"

Mischverteilung::usage = "Mischverteilung[alpha_,mue_,Sigma_], 
	Erwartungswert, Varianz und Standardabweichung der Mischverteilung
	Sum alpha[[i]] phi(mue[[i]],Sigma[[i]]); 
	Ei[y]=mue[[i]]; Vari[y]=Sigma[[i]]; 
	Sigma -->0, alpha = 1/n: Stichprobenvarianz"
	
GaussFaktor::usage = "    "

GaussKernO::usage = "    "

KernDichteM::usage = "KernDichteM[x_,data_,Kern_,sm_,op_:Plus],
	Multivariate Kerndichte, Kern = radial-symmetrisch, z.B.
	GaussKern[#,1]& oder EpanechnikovM[#]&"

N01::usage = "N01 = (2Pi)^(-.5)Exp[-.5 (#^2)]&"

Epanechnikov::usage = "Epanechnikov = If[Abs[#]<1,.75(1-#^2),0]&"

DreiEck::usage = "DreiEck = If[Abs[#]<1,1-Abs[#],0]& "

UnitSphere::usage = "UnitSphere[p_] := 2 Pi^(p/2)/(p Gamma[p/2])"

EpanechnikovM::usage = "EpanechnikovM[x_], multivariater E. Kern" 
    
smoothEpanechnikov::usage = "smoothEpanechnikov[y_]"

	

Begin["`Private`"]


(***************************************************************)			 
smoothQuickAndDirty[ST_]:= 
(***************************************************************)			 
	(Varianz[ST]//First//VecDiag//Max) Length[ST]^(-2/5) //N

(***************************************************************)			 
smoothQuickAndDirty1[ST_]:= 
(***************************************************************)			 
	Module[{m,s,sm},
	{m,s} =  ST//MS1;
	sm = (s//Max)^2 Length[ST]^(-2/5) //N;
	{sm,m,s}]
	
	
(***************************************************************)			 
smoothQuickAndDirtyM//Clear
smoothQuickAndDirtyM[y_,option_]:= 
(***************************************************************)			 
	Module[{m,S,SML,n,p,expo,A,h,sm},
	(*Fukunaga, Silverman,S.78ff*)
	
	{SML,S,m} =  Varianz[y];
	{n,p} = y//Dimensions;
	expo = 1/(p+4);
	(*A = (4/(2p+1))^expo//N;*)
	A = (4/(p+2))^expo//N;
	h = A n^(-expo);
	sm = If[option ==1,h^2 SML,
		 If[option ==2,h^2 mean[VecDiag[SML]],
		 If[option ==3,h^2 Max[ VecDiag[SML]],
		 If[option ==4,h^2 Min[ VecDiag[SML]],
		 If[option ==5,h^2 DiagonalMatrix[VecDiag[SML]]
		 ]]]]];
		 
	sm//N]

	
(***************************************************************)			 
smoothQuickAndDirtyM[y_,option_,alpha_]:= 
(***************************************************************)			 
	Module[{m,S,SML,n,p,expo,A,h,sm},
	
	(*mit gewichteten Daten*)
	(*Fukunaga, Silverman,S.78ff*)
	
	{SML,m} =  Varianz[y,alpha];
	{n,p} = y//Dimensions;
	expo = 1/(p+4);
	(*A = (4/(2p+1))^expo//N;*)
	A = (4/(p+2))^expo//N;
	h = A n^(-expo);
	sm = If[option ==1,h^2 SML,
		 If[option ==2,h^2 mean[VecDiag[SML]],
		 If[option ==3,h^2 Max[ VecDiag[SML]],
		 If[option ==4,h^2 Min[ VecDiag[SML]],
		 If[option ==5,h^2 DiagonalMatrix[VecDiag[SML]]
		 ]]]]];
		 
	sm//N]	
		
KernDichte//Clear
KernDichte[x_,data_,Kern_,theta_,Op_:Plus]:=
	Module[{g},
	g = Kern[#-x,theta]&//Evaluate; 
	Apply[Op,Map[g,data]]/Length[data]//N
	]
	
KernDichte[x_,data_,{Kern_,Faktor_},theta_,Op_:Plus]:=
	Module[{g},
	g = Kern[#-x,theta]&; 
	Faktor*Apply[Op,Map[g,data]]/Length[data]//N
	]
		
GaussKern//Clear
GaussKern[x_?VectorQ,{sigma_?MatrixQ,sigma1_?MatrixQ}]:= 
	Det[2 Pi sigma]^(-.5) Exp[-.5 x.sigma1.x]//N

GaussKern[x_?VectorQ,sigma_?MatrixQ]:= 
	Module[{p = Length[x],sigma1=sigma//Inverse}, 
	Det[2 Pi sigma]^(-.5) Exp[-.5 x.sigma1.x]//N
	];
	
GaussKern[x_?VectorQ,sigma_?ScalarQ]:= 
	Module[{p = Length[x]}, 
	(2 Pi sigma)^(-.5 p) Exp[-.5 (x.x)/sigma]//N
	];

GaussKern[x_?VectorQ,{sigma_?ScalarQ}]:= 
	Module[{p = Length[x]}, 
	(2 Pi sigma)^(-.5 p) Exp[-.5 (x.x)/sigma]//N
	];

GaussKern[x_?ScalarQ,sigma_?ScalarQ]:= 
	Module[{}, 
	(2 Pi sigma)^(-.5) Exp[-.5 (x x)/sigma]//N
	];		
		
GaussKernO//Clear
GaussKernO[x_,{sigma_,sigma1_}]:= Exp[-.5 (x.sigma1.x)]//N 
	(*ohne Determinante*)

GaussKernO[x_,sigma_?ScalarQ]:= Exp[-.5 (x.x)/sigma]//N
	
	
GaussFaktor//Clear
GaussFaktor[sigma_]:= Det[2 Pi sigma]^(-.5)

GaussFaktor[sigma_,p_]:= (2 Pi sigma)^(-.5 p)

Mischverteilung[alpha_,mue_,Sigma_]:=
 Module[{am,m,mm,var,std},
 	am = alpha*mue;
 	m = Plus@@am;
 	mm = MapThread[Outer[Times,##]&,{mue,mue}];
 	
 	If[TensorRank[Sigma]===3,
 	var = Apply[Plus,alpha*(Sigma + mm)] - Outer[Times,m,m],
 	
 	(*gleiche Kovarianzen*)
 	var = Sigma + Apply[Plus,alpha* mm ] - Outer[Times,m,m]
 	];
 	
 	std = Transpose[var,{1,1}]//Sqrt;
 	{m,var,std} 
 	];
 	
KernDichteM//Clear
KernDichteM[x_,data_,Kern_,sm_,op_:Plus]:=
	Module[{sm1,jacobi,z},
	If[TensorRank[data]==1,Print["Warning:scalar data"]];
	jacobi = Det[sm]^(-.5);
	sm1 = sm//CholeskyDecomposition//Transpose//Inverse;
	z = Map[(sm1.(x-#))&,data];
	z = Map[Kern,z];
	jacobi Apply[op,z]/Length[data]//N
	]
	
N01 = (2Pi)^(-.5)Exp[-.5 (#^2)]&
Epanechnikov = If[Abs[#]<1,.75(1-#^2),0]&
DreiEck = If[Abs[#]<1,1-Abs[#],0]& 

UnitSphere[p_] := 2 Pi^(p/2)/(p Gamma[p/2])

EpanechnikovM[x_] := 
	Module[{d = x//Length,xx = x.x},
    If[xx < 1, .5/UnitSphere[d] (d+2) (1-xx),0]//N
    ]
    
(***************************************************************)			 
smoothEpanechnikov[y_]:= 
(***************************************************************)			 
	Module[{m,S,SML,n,p,expo,A,h,sm},
	(*Fukunaga, Silverman,S.78ff*)
	
	{SML,S,m} =  Varianz[y];
	{n,p} = y//Dimensions;
	expo = 1/(p+4);
	A = ( 8/UnitSphere[p]  (p+4)2 Pi^(p/2) )^expo//N;
	h = A n^(-expo);
	sm = h^2 SML//N
]	
	
End[]

Protect["Mischverteilung"]	

EndPackage[ ]	
	 	









































































































