(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M8, N9, bold, L-4,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-4,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, R32768, L-4,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, L-4,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M8, N9, B32768, L-4,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 256; useSolids; automaticGrouping; currentKernel; 
]
:[font = input; initialization; preserveAspect]
*)
<<Hermann`LSD`
(*
:[font = section; inactive; initialization; preserveAspect; startGroup]
Lokal linearisierte Filter
:[font = input; initialization; preserveAspect]
*)
NLTimeUp//Clear
NLTimeUp[Yii_,Pii_,Xii_,drift_,diff_,Theta_,dt_,Nonlin_] :=
	Module[{A,B,G,Omega,V,Astern,Bstern,Yi1i,Pi1i},
		A = Jacobi[Yii,Xii,Theta]; 
        B = (drift[Yii,Xii,Theta] - A.Yii) //Spalte;
        G = diff[Yii,Xii,Theta];
        Omega = G.Transpose[G];
	    {V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];

		(*Print[{Omega,A,B}//TableForm]
		Print[{V,Astern,Bstern}//TableForm];*)
			
		(*Yi1i = Astern.Yii + Flatten[Bstern];*)
		
		Yi1i = Yii + drift[Yii,Xii,Theta] dt;
		Pi1i = Astern.Pii.Transpose[Astern] + V;
			
		{Yi1i,Pi1i}
	]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 22; leftNameWrapOffset = 4]
*)
NonLinFilter//Clear
NonLinFilter[mue_,sigma_,Z_,X_,drift_,diff_,Theta_,H_,D_,R_,dt_,Nonlin_]:= 
	Module[{k,p,q,Yii,Pii,YF,PF,i,i1,ON,Yi1i,Pi1i,lik,liki,T1,T},
	
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		{T1,k} = Dimensions[Z];
		T = T1-1;
		{k,p,q,T}//Print;
		
		{Y0,P0,lik} = MNonLinMessup[mue,sigma,Z[[1]],X[[1]],
					  {H,Jacobih,R},Theta,Nonlin,-9];
		
		Yii = Y0;
		YF = Shape[1,{T1}];
		YF[[1]]  = Y0;
		Pii = P0;
		PF = Shape[1,{T1}];
		PF[[1]] = P0;
	
		Do[ 
			(*Time Update*)
			
			
			xi = X[[i]];
			A = Jacobi[Yii,xi,Theta]; 
            B = (drift[Yii,xi,Theta] - A.Yii) //Spalte;
            G =   diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
			{V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];
			(*Print[{Omega,A,B}//TableForm]
			Print[{V,Astern,Bstern}//TableForm];*)
			
			Yi1i = Astern.Yii + Flatten[Bstern];
		    Pi1i = Astern.Pii.Transpose[Astern] + V;
		    
		    If[Max[Abs[Yi1i]] > YMAX,
		    	Print["possible divergence, i = ",i];
		    	Yi1i = Y0;
		    	Pi1i = P0];
		    (*
			{Yi1i,Pi1i} = NLTimeUp[Yii,Pii,X[[i]],dr,diff,Theta,Nonlin];
			*)
			
			(*Mess-Update*)
					
			vi = H . Pi1i . Transpose[H] + R;
			vi1 = Inverse[vi];
			gain = Pi1i . Transpose[H] . vi1;
			i1 = i+1;
			inn = Z[[i1]] - H . Yi1i - D . X[[i1]];
			liki = Log[Det[vi]] + inn.vi1.inn;
			lik += liki;
			Yii = Yi1i + gain.inn;
			ikh = IdentityMatrix[p] - gain.H;
			Pii = ikh.Pi1i.Transpose[ikh] + gain.R.Transpose[gain];
									 	
	        YF[[i1]] = Yii;
	        PF[[i1]] = Pii;
	        	
		,{i,T}];
		
		lik = -.5 lik;		
		{YF,PF,lik}
	]
(*
:[font = input; initialization; preserveAspect]
*)
MNonLinMessup//Clear
MNonLinMessup[Yi1i_,Pi1i_,Zi1_,Xi1_,{h_,R_,Jacobih_},Theta_,Nonlin_,miss_] :=
	Module[{zmiss,lc,H,r,vi,vi1,gain,liki,p,k},
		
			zmiss = Zi1 ~eq~ miss;
			
			If[And @@ zmiss,
			
			(* keine Messung *)
				(*Print["  keine Messung"];*)
	        	{Yi1i,Pi1i,0},
	        	
	        (* Messung *)
	        
	        	lc = Locate[zmiss,False];
				H = Jacobih[Yi1i,Xi1,Theta];
				H = H[[lc]];
				r = R[Yi1i,Xi1,Theta][[lc,lc]];		
				vi = H . Pi1i . Transpose[H] + r;
				vi1 = Inverse[vi];
				gain = Pi1i . Transpose[H] . vi1;
				(*Print["gain ",gain//MatrixForm];*)
				inn = Zi1[[lc]] - h[Yi1i,Xi1,Theta][[lc]];
				
				liki = Log[Det[vi]] + inn.vi1.inn;
				
				Yii = Yi1i + gain.inn;
				{k,p} = H//Dimensions;
				ikh = IdentityMatrix[p] - gain.H;
				(*ikh = IdPlusA[-gain.H];*)
				Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
				{Yii,Pii,liki} 
			]
		]
							
MNonLinMessup[Yi1i_,Pi1i_,Zi1_,Xi1_,H_,D_,R_,Nonlin_,miss_] :=
	Module[{zmiss,lc,h,d,r,vi,vi1,gain,liki,p,k},
	
	(* lineares Messmodell !! *)
		
			zmiss = Zi1 ~eq~ miss;
			
			If[And @@ zmiss,
			
			(* keine Messung *)
				(*Print["  keine Messung"];*)
	        	{Yi1i,Pi1i,0},
	        	
	        (* Messung *)
	        
	        	lc = Locate[zmiss,False];
	        	
				h = H[[lc]];
				d = D[[lc]];
				r = R[[lc,lc]];
						
				vi = h . Pi1i . Transpose[h] + r;
				vi1 = Inverse[vi];
				gain = Pi1i . Transpose[h] . vi1;
				(*Print["gain ",gain//MatrixForm];*)
				inn = Zi1[[lc]] - h.Yi1i - d.Xi1;
				
				liki = Log[Det[vi]] + inn.vi1.inn;
				
				Yii = Yi1i + gain.inn;
				{k,p} = H//Dimensions;
				ikh = IdentityMatrix[p] - gain.h;
				(*ikh = IdPlusA[-gain.h];*)
				Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
				{Yii,Pii,liki} 
			]
		]					
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 22; leftNameWrapOffset = 4]
*)
MNonLinFilter//Clear
MNonLinFilter[mue_,sigma_,Z_,X_,{drift_,diff_,Jacobif_,h_,R_,Jacobih_},
			  Theta_,dt_,Nonlin_,miss_]:= 
	Module[{k,p,q,Yii,Pii,YF,PF,i,i1,Yi1i,Pi1i,lik,liki,xi,
			A,B,G,Omega,
			r,H,Y0,P0,T,T1,IP,mue0,sigma0},
	
		mue0 = mue[X[[1]],Theta];
		sigma0 = sigma[X[[1]],Theta];
		
		{p} = Dimensions[mue0];
		{T1,k} = Dimensions[Z];
		T = T1-1;
		Print["{k,p,T} = ",{k,p,T}];
		
		{Y0,P0,lik} = MNonLinMessup[mue0,sigma0,Z[[1]],X[[1]],
					  {h,R,Jacobih},Theta,Nonlin,miss];

		Yii = Y0;
		YF = Shape[1,{T1}];
		YF[[1]]  = Y0;
		Pii = P0;
		PF = Shape[1,{T1}];
		PF[[1]] = P0;
		IP = IdentityMatrix[p];
	
		Do[ 
			(*Time Update*)
			
			xi = X[[i]];
			A = Jacobif[Yii,xi,Theta];
			
		  	(*
            B = (drift[Yii,xi,Theta] - A.Yii) //Spalte;
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
			{V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];
			
			(*Print[{Omega,A,B}//TableForm]
			Print[{V,Astern,Bstern}//TableForm];*)
			
			Yi1i = Astern.Yii + Flatten[Bstern];
		    Pi1i = Astern.Pii.Transpose[Astern] + V;
		    *)  
		 
            G = diff[Yii,xi,Theta]; 
            Omega = G.Transpose[G];
            V = Omega dt;
			Astern = IP + A dt;
			
			Yi1i = Yii + drift[Yii,xi,Theta] dt;
		    Pi1i = Astern.Pii.Transpose[Astern] + V;
		 
		    
		    
		    If[Max[Abs[Yi1i]] > YMAX,
		    	Print["possible divergence, i = ",i];
		    	Yi1i = Y0;
		    	Pi1i = P0];
		    	
			(*Mess-Update*)
			
			i1 = i+1;
			z = Z[[i1]];
			zmiss = z ~eq~ miss;
			
			If[And @@ zmiss,
			
			(* keine Messung *)
				YF[[i1]] = Yii = Yi1i;
	        	PF[[i1]] = Pii = Pi1i,
	        	
	        (* Messung *)
	        	lc = Locate[zmiss,False];
				H = Jacobih[Yi1i,X[[i1]],Theta];
				H = H[[lc]];
				r = R[Yi1i,X[[i1]],Theta][[lc,lc]];		
				vi = H . Pi1i . Transpose[H] + r;
				vi1 = Inverse[vi];
				gain = Pi1i . Transpose[H] . vi1;
				inn = z[[lc]] - h[Yi1i,X[[i1]],Theta][[lc]];
				liki = Log[Det[vi]] + inn.vi1.inn;
				lik += liki;
				Yii = Yi1i + gain.inn;
				ikh = IP - gain.H;
				(*ikh = IdPlusA[-gain.H];*)
				Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
									 	
	        	YF[[i1]] = Yii;
	        	PF[[i1]] = Pii
	        ]
	        	
		,{i,T}];
		
		lik = -.5 lik;		
		{YF,PF,lik}
	]
(*
:[font = input; initialization; preserveAspect]
*)
MNonLinGlattUp//Clear
MNonLinGlattUp[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Asterni_]:=
	Module[{YGneu,PGneu,nn,pp,Pistern,Piin,Pi1in},
		
			Pistern = LinearSolve[Pi1i,Asterni.Pii]//Transpose;
			
			YGneu = Yii + Pistern.(YG - Yi1i);
			PGneu = Pii + Pistern.(PG - Pi1i).Transpose[Pistern];
	
		   {YGneu,PGneu}
	]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 22; leftNameWrapOffset = 4]
*)
MNonLinGlatt//Clear
MNonLinGlatt[mue_,sigma_,Z_,X_,{drift_,diff_,Jacobif_,h_,R_,Jacobih_},
			  Theta_,dt_,Nonlin_,miss_]:=
			   
	Module[{k,p,q,Yii,Pii,YF,PF,i,i1,Yi1i,Pi1i,Y1,P1,lik,liki,xi,
			A,Asterni,B,G,Omega,
			r,H,Y0,P0,T,T1,IP,mue0,sigma0,z,zmiss},
	
		
		mue0   = mue  [ X[[1]],Theta];
		sigma0 = sigma[ X[[1]],Theta];
		
		{p} = Dimensions[mue0];
		{T1,k} = Dimensions[Z];
		T = T1-1;
		Print["{k,p,T} = ",{k,p,T}];
		
		{Y0,P0,lik} = MNonLinMessup[mue0,sigma0,Z[[1]],X[[1]],
					  {h,R,Jacobih},Theta,Nonlin,miss];

		Yii = Y0;
		YF = Shape[1,{T1}];
		YF[[1]]  = Y0;
		Pii = P0;
		PF = Shape[1,{T1}];
		PF[[1]] = P0;
		
		Y1 = Shape[1,{T}];
		P1 = Shape[1,{T}];
		
		IP = IdentityMatrix[p];
		Asterni = {};
		
		
		Do[ 
			(*Time Update*)
			
			xi = X[[i]];
			A = Jacobif[Yii,xi,Theta]; 
			
		(*  	
            B = (drift[Yii,xi,Theta] - A.Yii) //Spalte;
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
			{V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];
			
			(*Print[{Omega,A,B}//TableForm]
			Print[{V,Astern,Bstern}//TableForm];*)
			
			Yi1i = Astern.Yii + Flatten[Bstern];
		    Pi1i = Astern.Pii.Transpose[Astern] + V;
		*)     
		 
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
            V = Omega dt;
			Astern = IP + A dt;
			AppendTo[Asterni,Astern];
			(*Astern//Print;*)
			
			Yi1i = Yii + drift[Yii,xi,Theta] dt;
		    Pi1i = Astern.Pii.Transpose[Astern] + V;
		  
		    
		    
		    If[Max[Abs[Yi1i]] > YMAX,
		    	Print["possible divergence, i = ",i];
		    	Yi1i = Y0;
		    	Pi1i = P0];
		    	
			(*Mess-Update*)
			
			i1 = i+1;
			z = Z[[i1]];
			zmiss = z ~eq~ miss;
			
			If[And @@ zmiss,
			
			(* keine Messung *)
				YF[[i1]] = Y1[[i]] = Yii = Yi1i;
	        	PF[[i1]] = P1[[i]] = Pii = Pi1i,
	        	
	        (* Messung *)
	        	lc = Locate[zmiss,False];
				H = Jacobih[Yi1i,X[[i1]],Theta];
				H = H[[lc]];
				r = R[Yi1i,X[[i1]],Theta][[lc,lc]];		
				vi = H . Pi1i . Transpose[H] + r;
				vi1 = Inverse[vi];
				gain = Pi1i . Transpose[H] . vi1;
				inn = z[[lc]] - h[Yi1i,X[[i1]],Theta][[lc]];
				liki = Log[Det[vi]] + inn.vi1.inn;
				lik += liki;
				Yii = Yi1i + gain.inn;
				ikh = IP - gain.H;
				(*ikh = IdPlusA[-gain.H];*)
				Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
									 	
	        	YF[[i1]] = Yii;
	        	PF[[i1]] = Pii;
	        	Y1[[i]] = Yi1i;
	        	P1[[i]] = Pi1i;
	        	
	        ]
	        	
		,{i,T}];  
		
		YGalt = YF[[T1]];
		PGalt = PF[[T1]];
		YG = {YGalt};
		PG = {PGalt};
		
		
		Do[	(*Print[i];*)
			Yii   = YF[[i]];
			Yi1i  = Y1[[i]];
			Pii   = PF[[i]];
			Pi1i  = P1[[i]];
			(*Pi1i//Print;*)
			
			{YGalt,PGalt} = MNonLinGlattUp[ {YGalt,PGalt},
								   {Yii,Pii,Yi1i,Pi1i},Asterni[[i]] ];
			(*{YGalt,PGalt}//Print;*)
			YG = Prepend[YG,YGalt];
			PG = Prepend[PG,PGalt];
			
		
		,{i,T,1,-1}];
		
		lik = -.5 lik;
				
		{YG,PG,YF,PF,lik}
	]
(*
:[font = input; initialization; preserveAspect]
*)
IdPlusA[A_] := Module[{out,p},
		p = Length[A];
		out = A; 
		Do[out[[i,i]] = out[[i,i]]+1 ,{i,p}];
		out]
(*
:[font = input; initialization; preserveAspect]
*)
NonLinStateSpace//Clear
NonLinStateSpace[h_,R_,f_,g_,Y0_,X_,T_,dt_,Theta_,Prozess_,Step_]:=
	Module[{Y,R2,Z,eps = 10^-16,k},
		k = Length[h[Y0,X[[1]],Theta]];
		Y = RungeKutta[f,g,Y0,X,T,dt,Theta,Prozess,Step];
		eps = eps IdentityMatrix[k];
		R2 = MapThread[(Transpose[
				CholeskyDecomposition[R[#1,#2,Theta]+eps]])&,
					{Y,Take[X,T+1]}];
						
		Z = MapThread[h[#1,#2,Theta]&,{Y,Take[X,T+1]}] 
          + MapThread[Dot,{R2,Table[Prozess[],{i,T+1},{j,k}]} ];
   
                         
     	{Z,Y}
     ]
(*
:[font = input; initialization; preserveAspect]
*)

NonLinStateSpace[h_,{R_,konstant_},f_,g_,Y0_,X_,T_,dt_,Theta_,Prozess_,Step_]:=
	Module[{Y,R2,Z,eps = 10.^-16,k},
		k = Length[h[Y0,X[[1]],Theta]];
		Y = RungeKutta[f,g,Y0,X,T,dt,Theta,Prozess,Step];
		eps = eps IdentityMatrix[k];
		R2 = CholeskyDecomposition[R[Y0,X[[1]],Theta]+eps];	
		Z = MapThread[h[#1,#2,Theta]&,{Y,Take[X,T+1]}] 
          + Table[Prozess[],{i,T+1},{j,k}].R2;
   
                         
     	{Z,Y}
     ]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 22; leftNameWrapOffset = 4]
*)
MNonLinLikn//Clear
MNonLinLikn[mue_,sigma_,Z_,X_,{drift_,diff_,Jacobif_,h_,R_,Jacobih_},
			  Theta_,dt_,Nonlin_,miss_]:= 
	Module[{k,p,q,Yii,Pii,i,i1,Yi1i,Pi1i,lik,liki,xi,
			A,B,G,Omega,
			r,H,Y0,P0,T,T1,IP,mue0,sigma0},
		  
		mue0   = mue[  X[[1]],Theta];
		sigma0 = sigma[X[[1]],Theta];
		
		{p} = Dimensions[mue0];
		{T1,k} = Dimensions[Z];
		T = T1-1;
		Print["MNonLinLikn {k,p,T} = ",{k,p,T}];
		
		{Y0,P0,lik} = MNonLinMessup[mue0,sigma0,Z[[1]],X[[1]],
					  {h,R,Jacobih},Theta,Nonlin,miss];

		Yii = Y0;
		Pii = P0;
		IP = IdentityMatrix[p];
		
		Do[ 
			(*Time Update*)
			
			xi = X[[i]];
			A = Jacobif[Yii,xi,Theta];
			
		 	(* 
            B = (drift[Yii,xi,Theta] - A.Yii) //Spalte;
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
			{V,Astern,Bstern} = STERN01[Omega,A,B,dt,Nonlin];
			
			(*Print[{Omega,A,B}//TableForm]
			Print[{V,Astern,Bstern}//TableForm];*)
			
			Yi1i = Astern.Yii + Flatten[Bstern];
		    Pi1i = Astern.Pii.Transpose[Astern] + V;
		    *) 
		 
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
            V = Omega dt;
			Astern = IP + A dt;
			
			Yi1i = Yii + drift[Yii,xi,Theta] dt;
			
		    Pi1i = Astern.Pii.Transpose[Astern] + V;
		 
		    
		    (*
		    If[Max[Abs[Yi1i]] > YMAX,
		    	Print["possible divergence, i = ",i];
		    	Yi1i = Y0;
		    	Pi1i = P0];*)
		    	
			(*Mess-Update*)
			
			i1 = i+1;
			z = Z[[i1]];
			zmiss = z ~eq~ miss;
			
			If[And @@ zmiss,
			
			(* keine Messung *)
				Yii = Yi1i;
	        	Pii = Pi1i,
	        	
	        (* Messung *)
	        	lc = Locate[zmiss,False];
	        	
				H = Jacobih[Yi1i,X[[i1]],Theta];
				H = H[[lc]];
				r = R[Yi1i,X[[i1]],Theta][[lc,lc]]; 
				vi = H . Pi1i . Transpose[H] + r;
				vi1 = PseudoInverse[vi];
				gain = Pi1i . Transpose[H] . vi1;
				
				inn = z[[lc]] - h[Yi1i,X[[i1]],Theta][[lc]];
					(*
					Print["i, vi1, inn, z  ", i,vi1//N20,inn//N20,z[[lc]]//N20];
					*)
				
				liki = Log[Det[vi]] + inn.vi1.inn;
			
				lik += liki;
				Yii = Yi1i + gain.inn; 
				ikh = IP - gain.H;
				(*ikh = IdPlusA[-gain.H];*)
				Pii = ikh.Pi1i.Transpose[ikh] + gain.r.Transpose[gain];
				
	        ]
	        	
		,{i,T}];
		
		lik = -.5 lik;	(*Print["lik  ",lik//N20];	*)
		lik
	]
(*
:[font = input; initialization; preserveAspect]
*)
(***************************************************************)			 			 
MNonLinLik//Clear			 
MNonLinLik[mue_,sigma_,Z_,X_,system_,Theta_,dt_,Nonlin_,miss_]:=
(***************************************************************)			 
Module[{},		  
Apply[Plus,
	MapThread[MNonLinLikn[mue,sigma,#1,#2,system,
	Theta,dt,Nonlin,miss]&,{Z,X}]]
]; 
(*
:[font = input; initialization; preserveAspect; startGroup]
*)
$MachineEpsilon//Sqrt
(*
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
3.292722539913596233*10^-10
;[o]
          -10
3.29272 10
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)			 
MNonLinScore[mue_,sigma_,Z_,X_,
			 {drift_,diff_,Jacobif_,h_,R_,Jacobih_},
			  Theta_,dt_,Nonlin_,miss_]:=
(***************************************************************)			 
(* NUMERISCHER SCORE (MIT MISSING DATA) *)
Module[{INC = $MachineEpsilon//Sqrt,i,u,LIK,LIKI,INC1,SNUM,Thetai},

LIK = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
			  Theta,dt,Nonlin,miss];
INC = INC Abs[Theta];
INC1=1/INC;
SNUM = {};
Do[ 
    Thetai=Theta//Flatten;
    Thetai[[i]]=Thetai[[i]]+INC[[i]];
    
    LIKI = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
			  Thetai,dt,Nonlin,miss];
    SNUM = Append[SNUM,(LIKI-LIK)*INC1[[i]]]
    
  ,{i,Length[Theta]} ];
  
{SNUM,LIK}
]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)			 
MNonLinScore2[mue_,sigma_,Z_,X_,
			 {drift_,diff_,Jacobif_,h_,R_,Jacobih_},
			  Theta_,dt_,Nonlin_,miss_]:=
(***************************************************************)			 
(* NUMERISCHER SCORE (MIT MISSING DATA) 2-seitig*)
Module[{INC = $MachineEpsilon^(1/3),i,u,LIK,LIKI,INC1,SNUM,Thetai},

LIK = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
			  Theta,dt,Nonlin,miss];
INC = INC Abs[Theta];
INC1=1/(2INC);
SNUM = {};
Do[ 
    Thetaiup=Theta//Flatten;
    Thetaido=Theta//Flatten;
    Thetaiup[[i]]=Thetaiup[[i]]+INC[[i]];
    Thetaido[[i]]=Thetaido[[i]]-INC[[i]];
    
    LIKIup = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
			  Thetaiup,dt,Nonlin,miss];
	LIKIdo = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
			  Thetaido,dt,Nonlin,miss];
    SNUM = Append[SNUM,(LIKIup-LIKIdo)*INC1[[i]]]
    
  ,{i,Length[Theta]} ];
  
{SNUM,LIK}
]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4; startGroup]
*)
(***************************************************************)
GRIDIJ[PSI_,I_,J_,HI_,HJ_]:= Module[{OUT},
(***************************************************************)
OUT = PSI;
OUT[[I]] = OUT[[I]] + HI[[I]];
OUT[[J]] = OUT[[J]] + HJ[[J]];
OUT
]
(*
:[font = message; inactive; initialization; preserveAspect; endGroup]
General::spell: Possible spelling error: new symbol name "OUT" is similar to existing symbols {out, Out}.
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4; startGroup]
*)
(***************************************************************)
GRIDI[PSI_,I_,HI_]:= Module[{OUT},
(***************************************************************)
OUT = PSI;
OUT[[I]] = OUT[[I]] + HI[[I]];
OUT
]
(*
:[font = message; inactive; initialization; preserveAspect; endGroup]
General::spell1: Possible spelling error: new symbol name "GRIDI" is similar to existing symbol "GRIDIJ".
:[font = input; initialization; preserveAspect; startGroup]
*)
GRIDI[{1,2,3},2,{.1,.2,.4}]
(*
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{1, 2.2, 3}
;[o]
{1, 2.2, 3}
:[font = input; initialization; preserveAspect; startGroup]
*)
GRIDIJ[{1,2,3},2,3,{.1,.2,.4},{.1,.2,.1}]
(*
:[font = output; output; inactive; initialization; preserveAspect; endGroup]
{1, 2.2, 3.1}
;[o]
{1, 2.2, 3.1}
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)
MNonLinHesse[mue_,sigma_,Z_,X_,
			 {drift_,diff_,Jacobif_,h_,R_,Jacobih_},
			  Theta_,dt_,Nonlin_,miss_]:=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT NUMERISCHEM SCORE:*)
(* ZENTRALE DIFFERENZEN *)


Module[{LIK,L2,INC = $MachineEpsilon^(1/3),INK,INK2,H4,H,
		LIJ,LIMJ,LIJM,LIMJM,L2I,LM2I,I,J},

U = Length[Theta];
LIK = MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
			  		Theta,dt,Nonlin,miss];
L2   = 2 LIK;
INK  =INC Abs[Theta];
INK2 = 2 INK;
H4   = .25/Outer[Times,INK,INK];

H = Shape[0,{U,U}];

Do[ 

{LIJ,LIMJ,LIJM,LIMJM} = 
	Map[MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
		#,dt,Nonlin,miss]&,
			{GRIDIJ[Theta ,I,J,  INK,  INK],
			 GRIDIJ[Theta ,I,J,  INK, -INK],
			 GRIDIJ[Theta ,I,J, -INK,  INK],
			 GRIDIJ[Theta ,I,J, -INK, -INK]
			 }];
	
    H[[I,J]] = LIJ - LIMJ - LIJM + LIMJM;
    
,{I,1,U},{J,I+1,U}];

H = H + Transpose[H];

Do[ 

{L2I,LM2I} = 
	Map[MNonLinLik[mue,sigma,Z,X,{drift,diff,Jacobif,h,R,Jacobih},
		#,dt,Nonlin,miss]&,
			{GRIDI[Theta ,I, INK2],
			 GRIDI[Theta ,I,-INK2]
			 }];
    H[[I,I]] = L2I - L2 + LM2I;
    
,{I,1,U}];

H = H H4;
{H,LIK}
]

(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 3; leftNameWrapOffset = 1]
*)


(***************************************************************)			 
BFGSUP[F_,SNEU_,S_,STEP_] := Module[{ETA,MACHEPS2,Y,FSTEP,A,B,Fup},
(***************************************************************)			 
ETA = 10^-4; (*NOISE LEVEL*)
MACHEPS2 = 10.^-8;
Y = -SNEU+S;
FSTEP = F.STEP;
A = Y.STEP;
If[ A < MACHEPS2 Max[Abs[STEP]] Max[Abs[Y]], Return[F]  ];
If[ Max[Abs[Y-FSTEP]] < ETA, Return[F]  ];
A=1/A;
B = 1/(STEP.FSTEP);
Print["*BFGSUP ", A,"  ", B];
Fup = F + Outer[Times, A Y ,Y] - Outer[Times,B FSTEP,FSTEP];
(*Fup=.5 (F+Transpose[Fup] *)
Fup
]
(*
:[font = input; initialization; preserveAspect]
*)
MatPrint[F_]:=
  Print[NumberForm[F//MatrixForm,4,NumberSigns->{"-"," "}]];
(*
:[font = input; initialization; preserveAspect]
*)
LikTest[LIKNEU_]:=
	If[(LIKNEU//NumberQ//Not)||(Im[LIKNEU]!=0)||(LIKNEU>10.^10),
	 	Print["LIKNEU = ",LIKNEU," reset to -10.^10"]; -10.^10,
	 		LIKNEU]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4]
*)
(***************************************************************)			 
MNonLinBFGS//Clear
MNonLinBFGS[THETA0_,F0_,KMAX_,EPS_,Z_,X_,K_,P_,Q_,n_,np_,T_,DT_,
			OPTION_,NONLIN_,MISS_,mue_,sigma_,
			drift_,diffusion_,Jacobif_,h_,R_,Jacobih_,PRINT_]:= 
(***************************************************************)			 
Module[{INC,MAXSTEP,MINSTEP,BOUND,ALPHA,u,THETA,F,
        S,LIKALT,LIKI,psii,STEPL,STEP,
        LIKNEU,SNEU,likpsi,COV,k,LIKELI},
INC=10.^-5;
MAXSTEP=10.^2;
MINSTEP=10.^-10;
BOUND=10.^-6;
ALPHA=10.^-4;
stepreduce = 3;

If[PRINT[[1]] == 1,
Print["***********************LSDE1**********************************"];
Print["***********************MODUL: MNonLinBFGS*********************"];
Print["**************************************************************"];
Print["Technical Output"];
VecPrint[{KMAX,EPS,K,P,Q,n,np,T,DT,OPTION,NONLIN,MISS,MAXSTEP,
		  MINSTEP,BOUND,stepreduce}//Spalte,
         {"KMAX","EPS","K","P","Q","n","np","T","DT","OPTION","NONLIN",
          "MISS","MAXSTEP","MINSTEP","BOUND","stepreduce"}];
Print[ ""];
Print[ "STARTWERT THETA0 = ", THETA0]
];

u = Length[THETA0];

THETA=THETA0;
F=F0;
If[OPTION == 1, F = SHIFT[F,BOUND] ];

{S,LIKALT} = 
	MNonLinScore[mue,sigma,Z,X,
		{drift,diffusion,Jacobif,h,R,Jacobih},THETA0,DT,Nonlin,MISS];

LIKI = {}; psii = {};

DoUntil[{KK,KMAX}, Max[Abs[S]]<EPS && Max[Abs[STEP]]<EPS,
 	
	If[PRINT[[2]] == 1,
	Print["-----------------------------------------------------------------"];
    Print["MNonLinBFGS: Iteration = ",KK];
    ];
    
    LIKI=Append[LIKI,LIKALT];
    psii=Append[psii,THETA];
    
 	STEP=LinearSolve[F,S];

    (*BEGRENZUNG DER SCHRITTLNGE*)
    STEPL=Max[Abs[STEP]];
    STEP=STEP*Min[1,MAXSTEP/STEPL];

    (*STEP-Reduction*)
   
    THETA1 = THETA + STEP;   (*VOLLER NEWTON-STEP*)
    
    Print["VOLLER NEWTON-STEP  ",THETA1,"   ",THETA];
    
  	LIKNEU = MNonLinLik[mue,sigma,Z,X,
  				{drift,diffusion,Jacobif,h,R,Jacobih},
			  			THETA1,DT,Nonlin,MISS];
			  			
   	LIKNEU = LikTest[LIKNEU];
   	 
    DoWhile[{half,100}, (LIKNEU<LIKALT+ALPHA*(S.STEP) &&
          				 Max[Abs[STEP]]>MINSTEP),
         STEP=STEP/stepreduce;
         THETA1 = THETA + STEP; 
         
         LIKNEU = 
         MNonLinLik[mue,sigma,Z,X,
         	{drift,diffusion,Jacobif,h,R,Jacobih},
			  		THETA1,DT,Nonlin,MISS];
			  		
		 LIKNEU = LikTest[LIKNEU];
	  		
		 If[PRINT[[3]] == 1,
         Print["STEP-REDUCTION:  ",half,
         			"  LIKNEU  ", PaddedForm[LIKNEU,{20,15}],
         			"  LIKALT  ", PaddedForm[LIKALT,{20,15}]];
         ];
     ]; (*End DoWhile*)
     
	
	If[PRINT[[4]] == 1,
    Print["LIKNEU  ", PaddedForm[LIKNEU,{20,15}],"      ",
          "LIKALT  ", PaddedForm[LIKALT,{20,15}] ];
    Print["LIKNEU - LIKALT  ",PaddedForm[LIKNEU-LIKALT,{20,15}] ];
    ];
    Print[""];
  
    If[PRINT[[5]] == 1, 
    Print[MatrixForm[{THETA1,THETA,STEP,S}//Transpose,
    	  TableHeadings->{Automatic,{"THETA1","THETA","STEP","SCORE"}}]
    	  ]];
    
    If[PRINT[[6]] == 1,
    Print[""];
    MatPrint[F];
    ];
       
    {SNEU,LIKALT} = 
		MNonLinScore[mue,sigma,Z,X,
			{drift,diffusion,Jacobif,h,R,Jacobih},THETA1,DT,Nonlin,MISS];
   
    
    (* BFGS-UPDATE *)
    F = BFGSUP[F,SNEU,S,STEP];
    S = SNEU;
    
    THETA = THETA1;
    k = KK;

];

If[PRINT[[7]] == 1,
Print[ "MBFGS:  ENDE DER ITERATION  ",k,"  ",KMAX] ];

LIKI = Append[LIKI,LIKALT]; psii = Append[psii,THETA];
likpsi = Spalte[LIKI]~ii~psii;

If[PRINT[[8]] == 1,
Print[MatrixForm[likpsi,
		TableHeadings->{Automatic,{"Likelihood","THETA"}} ]];
];
					

If[Fisher,

	{F,LIKELI} = MNonLinHesse[mue,sigma,Z,X,
				{drift,diffusion,Jacobif,h,R,Jacobih},THETA,DT,Nonlin,MISS];	
	F=-F;
	
	COV = OUTPUT[THETA,F,.05,S,LIKELI];
	LKOMP[LIKELI,u,(T+1)];
	
,(* else *)
	COV = Inverse[F]; (* BFGS-UPDATE!!*)
];

{THETA,COV,likpsi,k}

]
(*
:[font = input; initialization; preserveAspect; leftWrapOffset = 22; leftNameWrapOffset = 4]
*)
MBiNonLinFilter//Clear
MBiNonLinFilter[mue_,sigma_,Z_,X_,
			{drift_,diff_,Jacobif_,Jacobig_,h_,R_,Jacobih_},
			  Theta_,dt_,Nonlin_,miss_]:= 
	Module[{k,p,q,Yii,Pii,YF,PF,i,i1,Yi1i,Pi1i,lik,liki,xi,
			A,B,G,Omega,
			RR,rr,H,Y0,P0,T,T1,IP,mue0,sigma0,l},
	
		mue0 = mue[X[[1]],Theta];
		sigma0 = sigma[X[[1]],Theta];
		
		{p} = Dimensions[mue0];
		{T1,k} = Dimensions[Z];
		T = T1-1;
		Print["{k,p,T} = ",{k,p,T}];
		
		{Y0,P0,lik} = MNonLinMessup[mue0,sigma0,Z[[1]],X[[1]],
					  {h,R,Jacobih},Theta,Nonlin,miss];

		Yii = Y0;
		YF = Shape[1,{T1}];
		YF[[1]]  = Y0;
		Pii = P0;
		PF = Shape[1,{T1}];
		PF[[1]] = P0;
		IP = IdentityMatrix[p];
		{p,rr} = diff[Y0,X[[1]],Theta]//Dimensions;
		(*rr//Print;*)
		pp = p//Range;
		
		Do[ 
			(*Time Update*)
			
			xi = X[[i]];
			A = Jacobif[Yii,xi,Theta]; 
		 
            G = diff[Yii,xi,Theta];
            Omega = G.Transpose[G];
            B = Jacobig[Yii,xi,Theta];
			
			Yi1i = Yii + drift[Yii,xi,Theta] dt;
			AP = A.Pii;
			
			BPB = Sum[  Bl = B[[pp,l,pp]];
						Bl.Pii.Transpose[Bl],
						{l,rr}];
			(*
			i//Print;
			Pii//Print;
			BPB//Print;	
			Omega//Print;	
			*)
			    
		    Pi1i = Pii + (AP + Transpose[AP] + BPB + Omega) dt;
		 
		    
		    
		    If[Max[Abs[Yi1i]] > YMAX,
		    	Print["possible divergence, i = ",i];
		    	Yi1i = Y0;
		    	Pi1i = P0];
		    	
			(*Mess-Update*)
			
			i1 = i+1;
			z = Z[[i1]];
			zmiss = z ~eq~ miss;
			
			If[And @@ zmiss,
			
			(* keine Messung *)
				YF[[i1]] = Yii = Yi1i;
	        	PF[[i1]] = Pii = Pi1i,
	        	
	        (* Messung *)
	        	lc = Locate[zmiss,False];
				H = Jacobih[Yi1i,X[[i1]],Theta];
				H = H[[lc]];
				RR = R[Yi1i,X[[i1]],Theta][[lc,lc]];		
				vi = H . Pi1i . Transpose[H] + RR;
				vi1 = Inverse[vi];
				gain = Pi1i . Transpose[H] . vi1;
				inn = z[[lc]] - h[Yi1i,X[[i1]],Theta][[lc]];
				liki = Log[Det[vi]] + inn.vi1.inn;
				lik += liki;
				Yii = Yi1i + gain.inn;
				ikh = IP - gain.H;
				(*ikh = IdPlusA[-gain.H];*)
				Pii = ikh.Pi1i.Transpose[ikh] + gain.RR.Transpose[gain];
									 	
	        	YF[[i1]] = Yii;
	        	PF[[i1]] = Pii
	        ]
	        	
		,{i,T}];
		
		lik = -.5 lik;		
		{YF,PF,lik}
	]
(*
:[font = input; initialization; preserveAspect; endGroup]
*)
(***************************************************************)
Adapter//Clear
Adapter[Z_,Y_,YG_,PG_,YF_,PF_] := 
(***************************************************************)

	Module[{},
	
	{n,T1,p} = Dimensions[Z];
	
	YG1 = Shape[YG,{T+1,p,1}];
	YF1 = Shape[YF,{T+1,p,1}];
	PG1 = Shape[PG,{T+1,1,p,p}];
	PF1 = Shape[PF,{T+1,1,p,p}];
	
	Z1  = Z//Transpose[#,{3,1,2}]&;
	Y1  = Y//Transpose[#,{3,1,2}]&;
	
	{Z1,Y1,YG1,YF1,PG1,PF1}
	]
	
(***************************************************************)
ConfidenceBand[Y_,YF_,PF_,pp_,nn_,z_] := 
(***************************************************************)

	Module[{var1,conf1,conf2,yf,T,p,n,np},
	{T,p,n} = Y//Dimensions;
	{T,np,p,p} = PF//Dimensions;
	n = If[np == 1, 1, nn];
	var1 = Sqrt[PF[[T//Range,n,{pp},pp]]  ];
	yf = YF[[T//Range,{pp},nn]];
	conf1 = yf + z var1;
	conf2 = yf - z var1;
	Y[[T//Range,{pp},nn]] ~ii~ yf ~ii~ conf1 ~ii~ conf2
]



(***************************************************************)
graph//Clear
graph[Z_,Y_,YG_,PG_,tau_,DT_,pp_,nn_,plotrange_,alpha_] := 
(***************************************************************)
Module[{T1,p,n},

{T1,p,n} = Dimensions[Y];
zalphahalbe = Quantile[NormalDistribution[0,1], 1-alpha/2];
Print["Quantil = ",zalphahalbe];

g1 = plot1[{DT(tau-1),Z[[tau,pp,nn]]}//Transpose,
				PlotJoined->False,
				dicke->.01,
				color->{10},
				DisplayFunction->Identity];
				
g2 = plot1[ Y[[T1//Range,{pp},nn]]//AddTimeAxis[#,DT]&,DisplayFunction->Identity];

g3 = plot1[YG[[T1//Range,{pp},nn]]//AddTimeAxis[#,DT]&,
				color->{2},
				dicke -> .01,
				DisplayFunction->Identity];

g4 = plot1[ConfidenceBand[YG,YG,PG,pp,nn,zalphahalbe]//AddTimeAxis[#,DT]&,
					color->{1,2,5,5},
					dicke->.002,
					DisplayFunction->Identity ];

Show[g2,g3,g4,g1, DisplayFunction->Identity,
				  PlotRange->plotrange]
]
(*
^*)
