(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

PAR::usage = "System-Matrizen"
PARD::usage = "Ableitungen der System-Matrizen"
PARM::usage = "Me\[SZ]-Matrizen"
PARMD::usage = "Ableitungen der Me\[SZ]-Matrizen"

Unprotect["code`LSD`*"];
Clear["code`LSD`*"];
Remove["code`LSD`Private`*"];
Unprotect[RungeKutta];



BeginPackage["code`LSD`",{"Global`",
							 																			 "code`Kronecker`",
							 "code`PARTest`",
                             (*"LinearAlgebra`Cholesky`",*)
                             "LinearAlgebra`MatrixManipulation`",
                             "Statistics`NormalDistribution`", 
                             "Statistics`DataManipulation`"                    
                             }]



	
Panel::usage = "Panel[A,B,G,Y0,X,p,q,N,T,dt,seed,Prozess], 
	Simulation Panel-Modell; Prozess-Fehler PROZESS (Uni oder Gauss)" 	

StateSpace1::usage = "StateSpace1[H,D,R,A,B,G,Y0,X,k,p,q,N,T,dt,seed,Prozess], 
	Simulation State-Space-Modell; Prozess- und Messfehler
	PROZESS (Uni oder Gauss)" 

StateSpace::usage = "StateSpace[H,D,R,A,B,G,Y0,X,k,p,q,N,T,dt,seed,print], 
	Simulation State-Space-Modell;"

TimeUp::usage = "TimeUp[Yii,Pii,Xii,Astern,Bstern,OsternN], Time-Update"

MessUp::usage = "MessUp[Z,Yi1i,Pi1i,X,H,D,R,{n,p}], ohne missing"

MessUp::usage = "MessUp[Z,Yi1i,Pi1i,X,H,D,R,miss,par], Mess-Update"

MessUp1::usage = "MessUp1[Z,Yi1i,Pi1i,X,H,D,R,miss,par], Mess-Update"

TimeMessUp::usage = "TimeMessUp[{Yii,Pii,Lik,Yi1i,Pi1i},
	{Z,Xii,Xi1i1},Astern,Bstern,OsternN,H,D,R,miss]"

GlattUp::usage = "GlattUp[{YG,PG},{Yii,Pii,Yi1i,Pi1i},Astern,{p,np}], 
	Gl\[ADoubleDot]tter-Update, output = {YGneu,PGneu,Pisum}"

GlattUp::usage = "GlattUp[{YG,PG},{Yii,Pii,Yi1i,Pi1i},Astern], 
	Gl\[ADoubleDot]tter-Update ohne missing, output = {YGneu,PGneu,Pisum}"
	
GlattUp1::usage = "GlattUp1[{YG,PG},{Yii,Pii,Yi1i,Pi1i},Astern],
	ohne missing, output = {YGneu,PGneu}"
	
GlattUp1::usage = "GlattUp1[{YG,PG},{Yii,Pii,Yi1i,Pi1i},Astern,{p,np}], 
	Gl\[ADoubleDot]tter-Update, output = {YGneu,PGneu}"
	
MNorKorr::usage = "MNorKorr[Z,MUEN,SIGMAN,X,H,D,R,miss], 
	Normalkorrelation"
	
MFilterFold::usage = "MFilterFold[Y0,P0,Z,X,Astern,Bstern,Ostern,H,d,R,
	n,T,miss], Kalman-Filter mit missing data, mit FoldList"
	
Filter::usage = "Filter[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,n,T],
	Kalman-Filter ohne missing data"
    
MFilter::usage = "MFilter[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,N,T,miss], 
	Kalman-Filter mit missing data"
	
MFilter1::usage = "MFilter1[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,N,T,miss], 
	Kalman-Filter mit missing data, nur Likelihood"
	
Glatt::usage = "Glatt[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R], 
	Kalman-Gl\[ADoubleDot]tter" 

MGlattFold::usage = "MGlattFold[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,N,T,miss], 
	Kalman-Gl\[ADoubleDot]tter mit missing data"
	
MGlattLoop::usage = "MGlattLoop[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,N,T,miss], 
	Kalman-Gl\[ADoubleDot]tter mit missing data"
	
RungeKutta::usage = "RungeKutta[f,g,Y0,X,T,dt,Theta,Prozess,
	Step]"	
	
EulerStep::usage = "EulerStep[f,g,y,r,t,dt,dt2,Theta,Prozess]"
           
HeunStep::usage = "HeunStep[f,g,y,r,t,dt,dt2,Theta,Prozess]"

RungeKutta4Step::usage = "RungeKutta4Step[f,g,y,r,t,dt,dt2,Theta,Prozess]"

MLSchaetzer::usage = "MLSchaetzer[Phi0,Phi,u,y,x,g,dt]"

DiffusionsKoeffizient::usage = "DiffusionsKoeffizient[y,dt],
	Omega = Summe(dy.dy`)/Tdt"


	
Begin["`Private`"]



Panel[A_,B_,G_,Y0_,X_,p_,q_,N_,T_,dt_,seed_,Prozess_:"Deterministic"] := 
	Module[{Ostern,Astern,Bstern,Omega,eps = 10.^-16,Yt,Zt,t,O2,i,j,kk},
		SeedRandom[seed];
		Omega = G . Transpose[G];
		{Ostern,Astern,Bstern} = Stern[Omega,A,B,dt];
		If[Prozess =!= "Deterministic",
		
		O2 = CholeskyDecomposition[Ostern + eps IdentityMatrix[p]]//Transpose;
       	FoldList[(Astern.#1 + Bstern.#2 +
       	         O2.Table[Prozess[],{i,p},{j,N}])&, Y0, X[[T//Range]] ]
       	         
       	,(* else *)
       	FoldList[(Astern.#1 + Bstern.#2 )&, Y0, X[[T//Range]] ]
       	]
       	              
        (*Y = NestList[(Astern.#1 +
       	              O2.Table[Prozess[],{i,p},{j,N}])&, Y0, T ]*)
       
       ] (*Ende*)		
	
StateSpace1[H_,D_,R_,A_,B_,G_,Y0_,X_,k_,p_,q_,N_,T_,dt_,seed_,Prozess_] := 
	Module[{Ostern,Astern,Bstern,Z,Y,Omega,eps = 10.^-16,Yt,Zt,t,O2,R2,i,j,kk},
		SeedRandom[seed];
		Omega = G . Transpose[G];
		{Ostern,Astern,Bstern} = Stern[Omega,A,B,dt];
		Ostern=(Ostern+Transpose[Ostern])/2;
		O2 = CholeskyDecomposition[Ostern + eps IdentityMatrix[p]]//Transpose;
        R2 = CholeskyDecomposition[R + eps IdentityMatrix[k]]//Transpose;
       
       	Y = FoldList[(Astern.#1 + Bstern.#2 +
       	              O2.Table[Prozess[],{i,p},{j,N}])&, Y0, X[[T//Range]] ];
        
        
        Z = H.Transpose[Y,{2,1,3}] + D.Transpose[X,{2,1,3}] 
                                   + R2.Table[Prozess[],{i,k},{j,T+1},{kk,1,N}];
        Z = Transpose[Z,{2,1,3}];                           
     	{Z,Y}
		
	] (*Ende*)
	
StateSpace[H_,D_,R_,A_,B_,G_,Y0_,X_,k_,p_,q_,N_,T_,dt_,seed_,print_] := 
	Module[{Ostern,Astern,Bstern,Z,Y,Omega,eps = 10.^-16,Yt,Zt,t,kk},
		Omega = G . Transpose[G];
		{Ostern,Astern,Bstern} = Stern[Omega,A,B,dt];
		O2 = CholeskyDecomposition[Ostern + eps IdentityMatrix[p]]//Transpose;
        R2 = CholeskyDecomposition[R + eps IdentityMatrix[k]]//Transpose;
       
        Y = FoldList[(Astern.#1 + Bstern.#2 +
       	              O2.Table[Random[NormalDistribution[0,1]],
       	                       {i,p},{j,N}])&, Y0, X[[T//Range]] ];
       	                      
        Z = H.Transpose[Y,{2,1,3}] + D.Transpose[X,{2,1,3}] 
            + R2.Table[Random[NormalDistribution[0,1]],{i,k},{j,T+1},{kk,1,N}];
            
        Z = Transpose[Z,{2,1,3}];                           
     	{Z,Y}
		
	] (*Ende*)

TimeUp[Yii_,Pii_,Xii_,Astern_,Bstern_,OsternN_] :=
	Module[{},
		Yi1i = Astern.Yii + Bstern.Xii;
		Pi1i = Astern.Transpose[Pii,{2,1,3}].Transpose[Astern];
		Pi1i = Transpose[Pi1i,{2,1,3}] + OsternN;
		{Yi1i,Pi1i}
	]
	
MNorKorr[Z_,MUEN_,SIGMAN_,X_,H_,D_,R_,miss_] := 
	Module[{YZ,PZ,lik,k,p,q,np,n}, 
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		{k,n} = Dimensions[Z];
		np  = Length[SIGMAN];
 		{YZ,PZ,lik} = MessUp[Z,MUEN,SIGMAN,X,H,D,R,miss,{k,p,q,n,np}];
 	 	{YZ,PZ,-.5 lik}
 	 ]
 	 
MessUp[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,{n_,p_}] :=
	Module[{pi1in,vint,vi1,gain,inn,ikh,Yii,Pii,lik},		
		
	pi1in = Pi1i[[1]];
	vint = H . pi1in . Transpose[H] + R;
	vi1 = Inverse[vint];
	gain = pi1in . Transpose[H] . vi1;
	inn = Z - H . Yi1i - D . X;
	lik = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
	Yii = Yi1i + gain.inn;
	ikh = IdentityMatrix[p] - gain.H;
	Pii = {ikh.pi1in.Transpose[ikh] + gain . R . Transpose[gain]};						 	
	{Yii,Pii,lik}
	   
	](* End MessUp ohne missing *) 
		 	
MessUp[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,miss_,{k_,p_,q_,n_,np_}] :=
	Module[{nn,zmiss,lc,hnt,dnt,rnt,pi1in,vint,vi1,gain,inn,ikh,
	        Yii,Pii,lik},
		
		lik = .0;
		Yii = Yi1i;
		Pii = Pi1i;
		
		Do[ 
			zmiss = Z[[k//Range,nn]] ~eq~ miss; (*Print[zmiss,nn];*)		
			If[And @@ zmiss,
				(* keine Messung *)
				 
				If[np == 1, Return[] ]	
				
			,(*else*)
				
				lc = Locate[zmiss,False];
				hnt = H[[lc]];
				dnt = D[[lc]]; 
				rnt = R[[lc,lc]];
				
				pi1in = Pi1i[[nn]];
				vint = hnt.pi1in.Transpose[hnt] + rnt;
				vi1 = Inverse[vint];
				gain = pi1in.Transpose[hnt].vi1;
				
				If[np == 1, (*Print["Messung, simultan"];*)
				
					(* alle N simultan*)
					inn = Z[[ lc ]] - hnt.Yi1i - dnt.X;
					lik = n Log[Det[vint]] + MatrixTrace[vi1.
											  (inn.Transpose[inn])];
											 
					Yii = Yi1i + gain.inn;
					ikh = IdentityMatrix[p] - gain.hnt;
					Pii = {ikh.pi1in.Transpose[ikh] +
								 gain.rnt.Transpose[gain]}
					
					
					
				,(*else*) (*Print["Messung, einzeln"];*)
				
				    inn = Z[[lc,nn]] - hnt.Yi1i[[Range[p],nn]] 
				                     - dnt.X[[Range[q],nn]]; (*Vektor*)
					lik += Log[Det[vint]] + inn.vi1.inn;
					
					Yii = Yii//Transpose;
					Yii[[nn]] = Yi1i[[Range[p],nn]] + gain.inn;
					Yii = Yii//Transpose; (*wieder zur\[UDoubleDot]ck*)
					
					ikh = IdentityMatrix[p] - gain.hnt;
					Pii[[nn]] = ikh.pi1in.Transpose[ikh] 
					 		   + gain.rnt.Transpose[gain]
	
				](*end if*)
					
			](*end if*)
					
		,{nn,np}];
		
	   {Yii,Pii,lik}
	   
	](*End MessUp*)

MessUp1[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,miss_,{k_,p_,q_,n_,np_}] :=
	Module[{nn,zmiss,lc,hnt,dnt,rnt,pi1in,vint,vi1,gain,inn,ikh,
	        Yii,Pii,lik},
		
		lik = .0;
		Yii = Yi1i;
		Pii = Pi1i;
		
		If[np == 1,
			zmiss = Z[[k//Range,1]] ~eq~ miss; 
			If[ Not[And @@ zmiss],
				(* simultane Messung*)
				(* Print["Messung, simultan"];*)
				lc = Locate[zmiss,False]; 
				hnt = H[[lc]];
				dnt = D[[lc]]; 
				rnt = R[[lc,lc]];
				pi1in = Pi1i[[1]];
				vint = hnt.pi1in.Transpose[hnt] + rnt;
				vi1 = Inverse[vint];
				gain = pi1in.Transpose[hnt].vi1;
				inn = Z[[ lc,Range[n] ]] - hnt.Yi1i - dnt.X;
				lik = n Log[Det[vint]] + MatrixTrace[vi1.
											  (inn.Transpose[inn])];
											 
				Yii = Yi1i + gain.inn;
				ikh = IdentityMatrix[p] - gain.hnt;
				Pii = {ikh.pi1in.Transpose[ikh] + gain.rnt.Transpose[gain]};
							
			  ]
		
		,(* np > 1 *) 
		
			Do[ 
				zmiss = Z[[k//Range,nn]] ~eq~ miss; 		
				If[Not[And @@ zmiss], 
					(*Print["Messung, einzeln"];*)
					lc = Locate[zmiss,False];
					hnt = H[[lc]];
					dnt = D[[lc]]; 
					rnt = R[[lc,lc]];
					pi1in = Pi1i[[nn]];
					vint = hnt.pi1in.Transpose[hnt] + rnt;
					vi1 = Inverse[vint];
					gain = pi1in.Transpose[hnt].vi1;				
					
					
					inn = Z[[lc,nn]] - hnt.Yi1i[[Range[p],nn]] 
				                     - dnt.X[[Range[q],nn]]; (*Vektor*)
			    	lik += Log[Det[vint]] + inn.vi1.inn;
					
			   	    Yii = Yii//Transpose;
					Yii[[nn]] = Yi1i[[Range[p],nn]] + gain.inn;
			    	Yii = Yii//Transpose; (*wieder zur\[UDoubleDot]ck*)
					ikh = IdentityMatrix[p] - gain.hnt;
					Pii[[nn]] = ikh.pi1in.Transpose[ikh] + 
									gain.rnt.Transpose[gain];
	
					](*end if "Not[And @@ zmiss]" *)
			
			,{nn,np}];
				
		](*end if np = 1*);
	
	{Yii,Pii,lik}
	   
	](*End MessUp1*)


TimeMessUp[{Yii_,Pii_,Lik_,Yi1i_,Pi1i_},{Z_,Xii_,Xi1i1_},
			Astern_,Bstern_,OsternN_,H_,D_,R_,miss_,par_] := 
	Module[{yi1i,pi1i,yii,pii,lik},

		{yi1i,pi1i}   = TimeUp[Yii,Pii,Xii,Astern,Bstern,OsternN];
		{yii,pii,lik} = MessUp[Z,yi1i,pi1i,Xi1i1,H,D,R,miss,par];
		{yii,pii,{lik},yi1i,pi1i}
	]
	
TimeMessUp1[{Yii_,Pii_,Lik_},{Z_,Xii_,Xi1i1_},
			Astern_,Bstern_,OsternN_,H_,D_,R_,miss_,par_] := 
	Module[{yi1i,pi1i,yii,pii,lik},

		{yi1i,pi1i}   = TimeUp[Yii,Pii,Xii,Astern,Bstern,OsternN];
		{yii,pii,lik} = MessUp[Z,yi1i,pi1i,Xi1i1,H,D,R,miss,par];
		{yii,pii,{lik}+Lik}
	]
			
GlattUp[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Astern_,{p_,np_} ]:=
	Module[{YGneu,PGneu,Pisum,nn,pp,Pistern,Piin,Pi1in},
		
		pp = p//Range;
		YGneu = Yii//Transpose;
		PGneu = Pii;
		Pisum = J[0.0,p,p];
		
		For[nn = 1, nn <= np, nn++,
			
			Piin  = Pii[[nn]];	
			Pi1in = Pi1i[[nn]];
			PGn   = PG[[nn]];
			
			(*Pi1in = {{1,1},{2,2}};*)
			Check
			[
			Pistern = LinearSolve[Pi1in,Astern.Piin]//Transpose;
			
			,Print["Singular Gain"];
			Interrupt[ ]
			];
			
			(*Pistern = LinearSolve[Pi1in,Astern.Piin]//Transpose;*)
			
			If[np > 1,
			
			YGneu[[nn]] = Yii[[pp,nn]] 
						  + Pistern.(YG[[pp,nn]] - Yi1i[[pp,nn]]);
			PGneu[[nn]] = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]
			
			,(* else *)
			
			YGneu = Transpose[Yii + Pistern.(YG - Yi1i)];
			PGneu[[nn]] = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]
			];
					  
			Pisum += Pistern.PGn;
		];
		
		YGneu = YGneu//Transpose;
	
		{YGneu,PGneu,Pisum}
	]
	
GlattUp[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Astern_]:=
	Module[{YGneu,PGneu,nn,pp,Pistern,Piin,Pi1in},
		
			Piin  = Pii[[1]];	
			Pi1in = Pi1i[[1]];
			PGn   = PG[[1]];
			Pistern = LinearSolve[Pi1in,Astern . Piin]//Transpose;
			
			YGneu = Yii + Pistern.(YG - Yi1i);
			PGneu = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern];
			Pisum = Pistern.PGn;
			
		   {YGneu,{PGneu},Pisum}
	]
	
GlattUp1[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Astern_]:=
	Module[{YGneu,PGneu,nn,pp,Pistern,Piin,Pi1in},
		
			Piin  = Pii[[1]];	
			Pi1in = Pi1i[[1]];
			PGn   = PG[[1]];
			Pistern = LinearSolve[Pi1in,Astern . Piin]//Transpose;
			
			YGneu = Yii + Pistern.(YG - Yi1i);
			PGneu = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern];
	
		   {YGneu,{PGneu}}
	]
		
GlattUp1[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Astern_,{p_,np_}]:=
	Module[{YGneu,PGneu,nn,pp,Pistern,Piin,Pi1in},

		pp = p//Range;
		YGneu = Yii//Transpose;
		PGneu = Pii;
		
		For[nn = 1, nn <= np, nn++,
			
			Piin  = Pii[[nn]];	
			Pi1in = Pi1i[[nn]];
			PGn   = PG[[nn]];
			Pistern = LinearSolve[Pi1in,Astern.Piin]//Transpose;
			
			If[np > 1,
			
			YGneu[[nn]] = Yii[[pp,nn]] 
						  + Pistern.(YG[[pp,nn]] - Yi1i[[pp,nn]]);
			PGneu[[nn]] = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]
			
			,(* else *)
			
			YGneu = Transpose[Yii + Pistern.(YG - Yi1i)];
			PGneu[[nn]] = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]
			]
		];
		
		YGneu = YGneu//Transpose;
	
		{YGneu,PGneu}
	]

	
MFilter[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_]:= 
	Module[{np,k,p,q,Yii,Pii,YF,PF,i,ON,Yi1i,Pi1i,lik,liki},
	
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = Length[P0];
		{k,p,q,n,np}//Print;
		
		Yii = Y0;
		YF  = {Y0};
		Pii = P0;
		PF  = {P0};
		lik = 0;
		ON  = Array[1&,{np}] /. 1->Ostern;
	
		Do[ 
			(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
			(*Mess-Update*)
					
	        {Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,{k,p,q,n,np}];
	            
	        lik += liki;
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        	
		,{i,T}];
		
		lik = -.5 lik;		
		{YF,PF,lik}
	]

	
Filter[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:= 
	Module[{np,k,p,q,Yii,Pii,YF,PF,i,ON,Yi1i,Pi1i,lik,liki},
	
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = Length[P0];
		{k,p,q,n,np}//Print;
		
		Yii = Y0;
		YF  = {Y0};
		Pii = P0;
		PF  = {P0};
		lik = 0;
		ON  = Array[1&,{np}] /. 1->Ostern;
	
		Do[ 
			(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
			(*Mess-Update*)
					
	        {Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];
	          
	        lik += liki;
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        	
		,{i,T}];
		
		lik = -.5 lik;		
		{YF,PF,lik}
	]

MFilter1[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_]:= 
	Module[{np,k,p,q,Yii,Pii,i,ON,Yi1i,Pi1i,lik,liki},
		(* NUR BERECHNUNG DER LIKELIHOOD *)
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = Length[P0];
		{k,p,q,n,np}//Print;
		
		Yii = Y0;
		Pii = P0;
		lik = 0;
		ON  = Array[1&,{np}] /. 1->Ostern;
	
		Do[ 
			(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
			(*Mess-Update*)
					
	        {Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,{k,p,q,n,np}];
	        
	        lik += liki;
	        
	        	
		,{i,T}];
		
		lik = -.5 lik;		
		{lik}
	]
	
MFilterFold[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,d_,R_,n_,T_,miss_]:= 
	Module[{YF,PF,ON,lik,par,k,p,q,np},
		
		np  = Length[P0];
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[d];
		par = {k,p,q,n,np};
		par//Print;
		ON  = Array[1&,{np}] /. 1->Ostern;
		
		{YF,PF,lik}
		 = Fold[TimeMessUp1[#1,#2,Astern,Bstern,ON,H,d,R,miss,par]&,
					   {Y0,P0,{0}},
					   {Drop[Z,1],Drop[X,-1],Drop[X,1]}//Transpose];
		
		(*lik = Plus@@Flatten@lik;*)
		
		lik = -.5 lik;
		lik
	]
	
Glatt[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_]:= 
	Module[{T,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
			lik,liki},
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		{p,n} = Dimensions[Y0];
		T = Length[Z] -1;
		
		{k,p,q,n,T}//Print;
		
		Yii = Y0;
		YF  = {Y0};
		Y1  = {};
		Pii = P0;
		PF  = {P0};
		P1  = {};
		lik = 0;
		ON  = {Ostern};
	
		Do[ 
			(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
			(*Mess-Update*)
					
	        {Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];
	       
	        lik += liki;
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        Y1 = Append[Y1,Yi1i];
	        P1 = Append[P1,Pi1i];
	        	
		,{i,T}];
		
		YGalt = YF[[T+1]];
		PGalt = PF[[T+1]];
		YG = {YGalt};
		PG = {PGalt};
		
		
		Do[	(*Print[i];*)
			Yii   = YF[[i]];
			Yi1i  = Y1[[i]];
			Pii   = PF[[i]];
			Pi1i  = P1[[i]];
			
			{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
								     {Yii,Pii,Yi1i,Pi1i},Astern];
			
			YG = Prepend[YG,YGalt];
			PG = Prepend[PG,PGalt];
			
		
		,{i,T,1,-1}];
		
		lik = -.5 lik;
		{YG,PG,YF,PF,lik}
	]
	
MGlattLoop[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_]:= 
	Module[{np,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
			lik,liki},
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		np  = Length[P0];
		{k,p,q,n,np}//Print;
		
		Yii = Y0;
		YF  = {Y0};
		Y1  = {};
		Pii = P0;
		PF  = {P0};
		P1  = {};
		lik = 0;
		ON  = Array[1&,{np}] /. 1->Ostern;
	
		Do[ 
				(*Time Update*)
			
			{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
			
				(*Mess-Update*)
					
	        {Yii,Pii,liki} = 
	        	MessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,{k,p,q,n,np}];
	       
	        lik += liki;
	        YF = Append[YF,Yii];
	        PF = Append[PF,Pii];
	        Y1 = Append[Y1,Yi1i];
	        P1 = Append[P1,Pi1i];
	        	
		,{i,T}];
		
		YGalt = YF[[T+1]];
		PGalt = PF[[T+1]];
		YG = {YGalt};
		PG = {PGalt};
		
		
		Do[	(*Print[i];*)
			Yii   = YF[[i]];
			Yi1i  = Y1[[i]];
			Pii   = PF[[i]];
			Pi1i  = P1[[i]];
			
			{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
								     {Yii,Pii,Yi1i,Pi1i},Astern,{p,np}];
			
			YG = Prepend[YG,YGalt];
			PG = Prepend[PG,PGalt];
			
		
		,{i,T,1,-1}];
		
		lik = -.5 lik;
		{YG,PG,YF,PF,lik}
	]
	
MGlattFold[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_]:= 
	Module[{YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
			lik,tt,ygpg,par,k,p,q,np},
		
		np  = Length[P0];
		{k,p} = Dimensions[H];
		{k,q} = Dimensions[D];
		par = {k,p,q,n,np};
		par//Print;
		ON  = Array[1&,{np}] /. 1->Ostern;
		
		{YF,PF,lik,Y1,P1}
		 = FoldList[TimeMessUp[#1,#2,Astern,Bstern,ON,H,D,R,miss,par]&,
					   {Y0,P0,{0},{0},{0}},
					   {Drop[Z,1],Drop[X,-1],Drop[X,1]}//Transpose]
			           //Transpose;

		Y1 = Drop[Y1,1];
		P1 = Drop[P1,1];
		
		lik = Plus@@Flatten@lik;
		lik = -.5 lik;
		Yii   = Drop[YF,-1]//Reverse; 
		Yi1i  = Y1//Reverse;
		Pii   = Drop[PF,-1]//Reverse; 
		Pi1i  = P1//Reverse; 
		
		ygpg = FoldList[ GlattUp1[#1,#2,Astern,{p,np}]&, 
						 {YF[[T+1]],PF[[T+1]]},
					     {Yii,Pii,Yi1i,Pi1i}//Transpose ];
			
		{YG,PG} = ygpg//Transpose;
		YG = YG//Reverse;
		PG = PG//Reverse;
		
		{YG,PG,YF,PF,lik} 
	]
	
RungeKutta//Clear
RungeKutta[f_,g_,Y0_,X_,T_,dt_,Theta_,Prozess_,Step_] := 
	Module[{p,r,dt2,Y},
		{p,r} = g[Y0,X[[1]],Theta]//Dimensions;
		dt2 = Sqrt[dt//N];
		Y = FoldList[ Step[f,g,#1,r,#2,dt,dt2,Theta,Prozess]&,
                      Y0, X[[T//Range]]  ]
       
       ]
 
       
EulerStep//Clear
EulerStep[f_,g_,y_,r_,t_,dt_,dt2_,Theta_,Prozess_] :=
      y + f[y,t,Theta] dt + g[y,t,Theta].Table[Prozess[],{i,r}] dt2;
      
HeunStep//Clear
HeunStep[f_,g_,y_,r_,t_,dt_,dt2_,Theta_,Prozess_] :=
	Module[{f1,g1,t1,f2,g2,dw},
		f1 = f[y,t,Theta];
		g1 = g[y,t,Theta];
		dw = Table[Prozess[],{i,r}] dt2;
		y1 = y + f1 dt + g1.dw; (* Euler-Pr\[ADoubleDot]diktor *)
		t1 = t + dt;
		f2 = f[y1,t1,Theta];
		g2 = g[y1,t1,Theta];
        y + 0.5 ( (f1 + f2) dt + (g1 + g2).dw )
 	]
 	
RungeKutta4Step//Clear
RungeKutta4Step[f_,g_,y_,r_,t_,dt_,dt2_,Theta_,Prozess_] :=
	Module[{f0,f1,f2,f3,g0,g1,g2,g3,t1,t3,dth,dw,dwh,y1,y2,y3},
		f0 = f[y,t,Theta];
		g0 = g[y,t,Theta];
		dw = Table[Prozess[],{i,r}] dt2;
		dwh = dw/2;
		dth = dt/2;
		
		t1 = t + dth;
		y1 = y + f0 dth + g0.dwh;
		f1 = f[y1,t1,Theta];
		g1 = g[y1,t1,Theta];
		
		y2 = y + f1 dth + g1.dwh;
		f2 = f[y2,t1,Theta];
		g2 = g[y2,t1,Theta];
		
		y3 = y + f2 dt + g2.dw;
		t3 = t + dt;
		f3 = f[y3,t3,Theta];
		g3 = g[y3,t3,Theta];
		
        y + (f0 + 2f1 + 2f2 + f3) dt/6 + (g0 + 2g1 + 2g2 + g3).dw/6 
 	] 
      
      
       		  								
MLSchaetzer[Phi0_,Phi_,u_,y_,x_,g_,dt_]:= 
	Module[{z,n,T1,fi,gi,phiomega,omega,th,Theta},
		{T1,p} = Dimensions[y];
		Theta = {};F = {};
		n = DiagonalMatrix[Shape[10.^-12,{u}]];
		z = Shape[.0,{u,1}];
		Do[
		
		yi = y[[i]];
		xi = x[[i]];
		fi = Phi[yi,xi];
		gi = g[yi,xi];
		
		omega = gi.Transpose[gi];
		phiomega = Transpose[LinearSolve[omega,fi]];
		z += phiomega.(y[[i+1]] - yi - Phi0[yi,xi] dt);
		n += phiomega.fi;
		th = LinearSolve[n,z];
		Theta = Append[Theta,th//Flatten];
		F = Append[F,n dt]; (*n dt = Fisher-Info*)

		,{i,1,T1-1}];
		
		{Theta/dt,F}
	]

DiffusionsKoeffizient[y_,dt_] := 
	Module[{dy},
		dy = Delta[y,1];
		CuMean[Map[Outer[Times,#,#]&,dy],Plus]/dt
	]
		
											
End[ ]


Protect[Names["code`LSD`*"]//Evaluate];


EndPackage[ ]



					            
                  	












