(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





RungeKutta1//Clear
RungeKutta1[f_,g_,Y0_,{X_,dw_},T_,dt_,Theta_,Step_] :=
	FoldList[ Step[f,g,#1,#2,Theta,dt]&,Y0,{Take[X,T],Take[dw,T]}//Transpose]
 

EulerStep1//Clear
EulerStep1[f_,g_,y_,{t_,dw_},Theta_,dt_] :=
      y + f[y,t,Theta] dt + g[y,t,Theta].dw
      
HeunStep1//Clear
HeunStep1[f_,g_,y_,{t_,dw_},Theta_,dt_] :=
	Module[{f1,g1,t1,f2,g2},
		f1 = f[y,t,Theta];
		g1 = g[y,t,Theta];
	
		y1 = y + f1 dt + g1.dw; (* Euler-Pr\[ADoubleDot]diktor *)
		t1 = t + dt;
		f2 = f[y1,t1,Theta];
		g2 = g[y1,t1,Theta];
		
        y + 0.5 ( (f1 + f2) dt + (g1 + g2).dw )
 	]
 	
RungeKutta4Step1//Clear
RungeKutta4Step1[f_,g_,y_,{t_,dw_},Theta_,dt_]:=
	Module[{f0,f1,f2,f3,g0,g1,g2,g3,t1,t3,dth,dwh,y1,y2,y3},
		f0 = f[y,t,Theta];
		g0 = g[y,t,Theta];
		dwh = dw/2;
		dth = dt/2;
		
		t1 = t + dth;
		y1 = y + f0 dth + g0.dwh;
		f1 = f[y1,t1,Theta];
		g1 = g[y1,t1,Theta];
		
		y2 = y + f1 dth + g1.dwh;
		f2 = f[y2,t1,Theta];
		g2 = g[y2,t1,Theta];
		
		y3 = y + f2 dt + g2.dw;
		t3 = t + dt;
		f3 = f[y3,t3,Theta];
		g3 = g[y3,t3,Theta];
		
        y + (f0 + 2f1 + 2f2 + f3) dt/6. + (g0 + 2g1 + 2g2 + g3).dw/6. 
 	] 
      

RungeKutta1Lik//Clear
RungeKutta1Lik[fg_,Y0_,{X_,dw_},T_,dt_,Theta_,Step_] :=
	Module[{y,l},
	
	{y,l}=FoldList[ Step[fg,#1,#2,Theta,dt]&,{Y0,0},
	                {Take[X,T],Take[dw,T]}//Transpose]//Transpose;
	                
	                (*y//MatrixForm//Print;*)
	{y,l//Last}
	]
 

EulerStep1Lik//Clear
EulerStep1Lik[fg_,{y_,l_},{t_,dw_},Theta_,dt_] := 
Module[{f,G,gdw,Omega,lik},
	{f,G} = fg[y,t,Theta];
	
	(*
	f//Print;
	G//Print;
	*)
	
	gdw = G.dw;
	Omega = G.Transpose[G]*dt; 
	lik = -.5(Log[Det[Omega]] + gdw.Inverse[Omega].gdw);
	
    {y + f dt + gdw,l+lik}]







