(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, R65535,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M18, N23, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Geneva"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = input; initialization; preserveAspect]
*)
Needs["Statistics`ContinuousDistributions`"]
(*
:[font = input; preserveAspect]
MatrixRank[A_]:=Max[A//Dimensions]-Length[NullSpace[A]];
:[font = input; initialization; preserveAspect]
*)
WaldTest//Clear
WaldTest[R_,b_,THETA_,COV_,alpha_]:=
Module[{diff,W,rank,chi},

diff=R.THETA - b;
W= diff.Inverse[R.COV.(R//Transpose)].diff;
rank=R//MatrixRank;
chi=Quantile[ChiSquareDistribution[rank],1-alpha];

Print["-----------------------------------------------------------------------------------"];
Print["Wald-Test"];
Print["-----------------------------------------------------------------------------------"];
Print["W = ",W];
Print["chi^2(",1-alpha,",",rank,")-Quantil = ",chi];
Print["-----------------------------------------------------------------------------------"];
Print["       R  ",R//MatrixForm];
Print[""];
Print["-----------------------------------------------------------------------------------"];
Print["       b  ",b//MatrixForm];
Print[""];
Print["-----------------------------------------------------------------------------------"];
Print["R.ThDach  ",R.THETA//MatrixForm];
Print["-----------------------------------------------------------------------------------"];


]
(*
:[font = input; preserveAspect; startGroup]
MatrixRank[R]
:[font = output; output; inactive; preserveAspect; endGroup]
1
;[o]
1
:[font = input; preserveAspect; startGroup]
R={{0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,-1,0,0,0,0,0,0,0,0}}
b=0
:[font = output; output; inactive; preserveAspect]
{{0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0}}
;[o]
{{0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0}}
:[font = output; output; inactive; preserveAspect; endGroup]
0
;[o]
0
:[font = input; preserveAspect; startGroup]
WaldTest[R,b,THETA,COV,.05]
:[font = print; inactive; preserveAspect; endGroup]
-----------------------------------------------------------------------------------
Wald-Test
-----------------------------------------------------------------------------------
W = 0.0000181367
chi^2(0.95,1)-Quantil = 3.84146
-----------------------------------------------------------------------------------
       R      1  2  3  4  5  6  7  8  9  10 11 12 13 14 15 16 17 18 19 20 21 22 23 24

          1   0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  -1 0  0  0  0  0  0  0  0

-----------------------------------------------------------------------------------
       b  
           0

-----------------------------------------------------------------------------------
R.ThDach  
          1   -0.000096551
-----------------------------------------------------------------------------------
:[font = input; preserveAspect; startGroup]
WaldTest[R,0,THETA,COV,.05]
:[font = print; inactive; preserveAspect; endGroup]
Wald-Test
                                                                                                                                                                                                                                                                                                                                                                                                                                                                       -6             -6            -7                                                  -7                         -6
 W = RVAR1 . {1.00121, 1.00188, 1.15488, 1.00623, 1.00082, 1.41357, 0.88412, 1.01099, 1.00337, 1.00011, 1.00004, 0.999992, 0.999921, 1.00051, 1.00137, 1.00021, 1.00024, 1.00002, 1.00184, 1.01166, 0.944148, 0.999932, 1.0078, 1.00017} . Inverse[RVAR1 . {{0.0128135, 0.0138752, 0.0182837, 0.00334833, 0.000104512, 0.00213048, 0.0130282, 0.000282161, 0.0000585333, -0.000150361, -0.0000144366, 0.0000119311, 0.00147943, 0.0000380167, 0.0000309745, -4.18771 10  , -1.04911 10  , 1.97562 10  , 0.000133441, -0.00228316, 0.00050512, 7.72471 10  , 0.000254684, 7.47591 10  }, 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          -6
  {0.0138752, 1.02361, -0.928799, -0.331005, 0.0137569, -4.91923, -2.56891, -0.100556, -0.0347773, 0.000178022, -0.00219628, -0.00228931, 0.000814887, 0.00348407, -0.0137536, 0.000598831, 0.0000266678, 0.0000417125, 0.00266247, 2.41454, 0.293901, -0.000342785, -0.178162, -0.00234401}, {0.0182837, -0.928799, 4.64573, 0.393301, -0.0172549, 9.78878, 4.38498, 0.199037, 0.0828866, -0.00136652, 0.002498, 0.00398544, -0.00507975, -0.00308426, 0.0341199, -0.000797989, -0.000256034, -9.18465 10  , -0.00507943, -4.20985, -0.396292, 0.00176726, 0.345304, 0.00431674}, 
                                                                                                                                                                                                   -6                                                                                                                                                                                                               -8                                                                                 -6            -6            -6
  {0.00334833, -0.331005, 0.393301, 0.524316, 0.00283686, 3.46077, 1.8929, 0.0668285, 0.0227418, -0.000312492, 0.0026273, 0.001763, -0.000344012, 0.00163467, 0.00889774, -0.000522643, -9.70983 10  , -0.0000332024, -0.00213193, -1.70236, -0.223937, 0.000217263, 0.118858, 0.00134988}, {0.000104512, 0.0137569, -0.0172549, 0.00283686, 0.00866205, -0.156803, -0.0585665, -0.00189074, -0.000994389, -3.624 10  , 0.0000512147, -0.0000494327, 0.0000117296, 0.00285153, -0.000391458, 8.96695 10  , 3.14618 10  , 1.05245 10  , 0.0000643763, 0.0537294, 0.00530566, -0.0000183004, -0.0039536, -0.0000556335}, 
  {0.00213048, -4.91923, 9.78878, 3.46077, -0.156803, 91.594, 36.9421, 1.79321, 0.563801, -0.00280331, 0.0215397, 0.0337361, -0.0147829, -0.02513, 0.221321, -0.00777401, -0.00120223, -0.000640597, -0.042302, -34.5166, -3.73746, 0.0117868, 2.55263, 0.0300743}, {0.0130282, -2.56891, 4.38498, 1.8929, -0.0585665, 36.9421, 25.0491, 0.673864, 0.257823, -0.00130847, 0.0112627, 0.0214819, -0.00701539, -0.00925663, 0.101171, -0.00455701, -0.000321169, -0.000353826, -0.0221791, -16.9932, -2.32733, -0.00222595, 1.09962, 0.0145365}, 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                -6
  {0.000282161, -0.100556, 0.199037, 0.0668285, -0.00189074, 1.79321, 0.673864, 0.16403, 0.0216768, -0.0000512213, 0.000469289, 0.000563516, -0.000282548, -0.0000704209, 0.00838474, -0.000154951, -0.0000216978, -0.0000147052, -0.000774446, -0.695295, -0.0590798, 0.000298056, 0.0496096, 0.000442247}, {0.0000585333, -0.0347773, 0.0828866, 0.0227418, -0.000994389, 0.563801, 0.257823, 0.0216768, 0.0187051, -0.0000206948, 0.000138201, 0.000197376, -0.000115144, -0.00016652, 0.00757999, -0.0000537356, -6.96316 10  , -0.0000123208, -0.000283004, -0.231314, -0.0237391, 0.000061693, 0.0158059, 0.000132581}, 
                                                                  -8                                                                                                                            -8             -6             -6            -8             -8            -6                                      -7                           -6                                                                                                                                                                      -6                                         -6             -8             -7                                                 -6                         -6
  {-0.000150361, 0.000178022, -0.00136652, -0.000312492, -3.624 10  , -0.00280331, -0.00130847, -0.0000512213, -0.0000206948, 0.000355035, 0.0000858234, 0.0000134464, -0.0000170537, 9.18806 10  , -8.46786 10  , -4.61406 10  , 6.71889 10  , -9.08837 10  , 1.61574 10  , 0.00119751, 0.000213403, -4.88482 10  , -0.000104314, -1.36975 10  }, {-0.0000144366, -0.00219628, 0.002498, 0.0026273, 0.0000512147, 0.0215397, 0.0112627, 0.000469289, 0.000138201, 0.0000858234, 0.000517788, 0.000036936, -4.23783 10  , 0.0000214311, 0.0000535361, -4.58437 10  , -6.25227 10  , -1.24299 10  , -0.0000121667, -0.01036, -0.0012524, 1.53202 10  , 0.000739988, 8.64281 10  }, 
                                                                                                                                                                       -6             -6                           -6             -7             -7                                                     -6                                                                                                                                                                               -6             -6                          -6                           -6           -7             -8                                                   -6                           -6
  {0.0000119311, -0.00228931, 0.00398544, 0.001763, -0.0000494327, 0.0337361, 0.0214819, 0.000563516, 0.000197376, 0.0000134464, 0.000036936, 0.0000948398, -6.21941 10  , -7.20331 10  , 0.0000773648, -4.18915 10  , -3.12643 10  , -8.24689 10  , -0.0000195602, -0.0151493, -0.00203274, -1.00599 10  , 0.00100385, 0.0000123182}, {0.00147943, 0.000814887, -0.00507975, -0.000344012, 0.0000117296, -0.0147829, -0.00701539, -0.000282548, -0.000115144, -0.0000170537, -4.23783 10  , -6.21941 10  , 0.000836106, -2.05822 10  , -0.0000478103, 1.30003 10  , 3.4335 10  , -2.06559 10  , 0.0000215172, 0.00599037, 0.000618885, -1.7863 10  , -0.000437928, -4.39156 10  }, 
                                                                                                                               -8                           -6             -6                                      -6            -7            -7            -6                                      -6                                                                                                                                                       -6                                                                                                  -6            -6
  {0.0000380167, 0.00348407, -0.00308426, 0.00163467, 0.00285153, -0.02513, -0.00925663, -0.0000704209, -0.00016652, 9.18806 10  , 0.0000214311, -7.20331 10  , -2.05822 10  , 0.0014767, -0.0000672916, 1.28745 10  , 7.00279 10  , 1.76527 10  , 9.52589 10  , 0.00814423, 0.000771171, -2.33344 10  , -0.000594526, -0.0000101814}, {0.0000309745, -0.0137536, 0.0341199, 0.00889774, -0.000391458, 0.221321, 0.101171, 0.00838474, 0.00757999, -8.46786 10  , 0.0000535361, 0.0000773648, -0.0000478103, -0.0000672916, 0.00372695, -0.0000209246, -2.79331 10  , -5.7112 10  , -0.000111056, -0.0907314, -0.00923592, 0.0000243268, 0.0059893, 0.0000331317}, 
              -6                                                     -6                                                                    -6             -6             -6            -6            -6                                         -6            -6             -6                                       -6                           -6               -6                                         -6            -6                                                       -6            -8             -8             -7           -7            -7             -6             -6                                     -7                                        -7                           -7
  {-4.18771 10  , 0.000598831, -0.000797989, -0.000522643, 8.96695 10  , -0.00777401, -0.00455701, -0.000154951, -0.0000537356, -4.61406 10  , -4.58437 10  , -4.18915 10  , 1.30003 10  , 1.28745 10  , -0.0000209246, 0.000149727, -7.33853 10  , 4.50354 10  , -1.10012 10  , 0.00443025, -0.000257494, -1.01201 10  , -0.000286338, -3.44012 10  }, {-1.04911 10  , 0.0000266678, -0.000256034, -9.70983 10  , 3.14618 10  , -0.00120223, -0.000321169, -0.0000216978, -6.96316 10  , 6.71889 10  , -6.25227 10  , -3.12643 10  , 3.4335 10  , 7.00279 10  , -2.79331 10  , -7.33853 10  , 0.000851979, 0.0000265823, 2.617 10  , 0.000134098, 0.0000697692, -4.08472 10  , -0.0000176427, -3.5784 10  }, 
             -7                           -6                           -6                                                                       -8             -7             -7             -8            -7            -6            -6                                       -7                                        -8                           -6                                                                                                                                  -6                                                        -6                           -6          -7            -7                                             -6
  {1.97562 10  , 0.0000417125, -9.18465 10  , -0.0000332024, 1.05245 10  , -0.000640597, -0.000353826, -0.0000147052, -0.0000123208, -9.08837 10  , -1.24299 10  , -8.24689 10  , -2.06559 10  , 1.76527 10  , -5.7112 10  , 4.50354 10  , 0.0000265823, 0.000115645, 3.14378 10  , 0.000294191, 0.0000293519, -5.23535 10  , -0.0000888727, 2.21209 10  }, {0.000133441, 0.00266247, -0.00507943, -0.00213193, 0.0000643763, -0.042302, -0.0221791, -0.000774446, -0.000283004, 1.61574 10  , -0.0000121667, -0.0000195602, 0.0000215172, 9.52589 10  , -0.000111056, -1.10012 10  , 2.617 10  , 3.14378 10  , 0.00601872, 0.02245, 0.0065253, -2.13713 10  , -0.00152068, -0.000013983}, 
  {-0.00228316, 2.41454, -4.20985, -1.70236, 0.0537294, -34.5166, -16.9932, -0.695295, -0.231314, 0.00119751, -0.01036, -0.0151493, 0.00599037, 0.00814423, -0.0907314, 0.00443025, 0.000134098, 0.000294191, 0.02245, 18.9637, 1.18026, -0.00267075, -1.30185, -0.016785}, {0.00050512, 0.293901, -0.396292, -0.223937, 0.00530566, -3.73746, -2.32733, -0.0590798, -0.0237391, 0.000213403, -0.0012524, -0.00203274, 0.000618885, 0.000771171, -0.00923592, -0.000257494, 0.0000697692, 0.0000293519, 0.0065253, 1.18026, 2.10568, -0.000152142, -0.0923681, 0.00348043}, 
             -7                                                                                                                     -7            -6             -6            -6             -6                           -6             -7             -8             -6
  {7.72471 10  , -0.000342785, 0.00176726, 0.000217263, -0.0000183004, 0.0117868, -0.00222595, 0.000298056, 0.000061693, -4.88482 10  , 1.53202 10  , -1.00599 10  , -1.7863 10  , -2.33344 10  , 0.0000243268, -1.01201 10  , -4.08472 10  , -5.23535 10  , -2.13713 10  , -0.00267075, -0.000152142, 0.00520598, 0.00549672, 0.0000423728}, {0.000254684, -0.178162, 0.345304, 0.118858, -0.0039536, 2.55263, 1.09962, 0.0496096, 0.0158059, -0.000104314, 0.000739988, 0.00100385, -0.000437928, -0.000594526, 0.0059893, -0.000286338, -0.0000176427, -0.0000888727, -0.00152068, -1.30185, -0.0923681, 0.00549672, 0.465606, 0.00779814}, 
             -6                                                                                                                 -6            -6                           -6                                          -6            -7            -6
  {7.47591 10  , -0.00234401, 0.00431674, 0.00134988, -0.0000556335, 0.0300743, 0.0145365, 0.000442247, 0.000132581, -1.36975 10  , 8.64281 10  , 0.0000123182, -4.39156 10  , -0.0000101814, 0.0000331317, -3.44012 10  , -3.5784 10  , 2.21209 10  , -0.000013983, -0.016785, 0.00348043, 0.0000423728, 0.00779814, 0.00573519}} . Transpose[RVAR1]] . RVAR1 . {1.00121, 1.00188, 1.15488, 1.00623, 1.00082, 1.41357, 0.88412, 1.01099, 1.00337, 1.00011, 1.00004, 0.999992, 0.999921, 1.00051, 1.00137, 1.00021, 1.00024, 1.00002, 1.00184, 1.01166, 0.944148, 0.999932, 1.0078, 1.00017}
                                                                  MatrixRank[RVAR1]
chi^2(0.95,MatrixRank[RVAR1])-Quantil = 2 InverseGammaRegularized[-----------------, 0, 0.95]
                                                                          2
-----------------------------------------------------------------------------------
      R = 
           RVAR1

      b = 
           0

R.THETA = 
           RVAR1 . {1.00121, 1.00188, 1.15488, 1.00623, 1.00082, 1.41357, 0.88412, 1.01099, 1.00337, 1.00011, 1.00004, 0.999992, 0.999921, 1.00051, 1.00137, 1.00021, 1.00024, 1.00002, 1.00184, 1.01166, 0.944148, 0.999932, 1.0078, 1.00017}
-----------------------------------------------------------------------------------
^*)
