(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1501975,      39100]*)
(*NotebookOutlinePosition[   1503054,      39134]*)
(*  CellTagsIndexPosition[   1503010,      39130]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Sunspot data", "Section",
  PageWidth->Infinity],

Cell[BoxData[
    \(\(\(@\)\(ARTICLE\)\) {Singer : 
          1993  b, \[IndentingNewLine]AUTHOR = {Singer, \(\(H\)\(.\)\)}, \
\[IndentingNewLine]TITLE = {Continuous - 
              time\ dynamical\ systems\ with\ sampled\ data, \ \
\[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ errors\ of\ measurement\ and\ \
unobserved\ components}, \[IndentingNewLine]JOURNAL = {Journal\ of\ Time\ \
Series\ Analysis}, \[IndentingNewLine]VOLUME = {14, 
            5}, \[IndentingNewLine]PAGES = {\(527--\) 
              545}, \[IndentingNewLine]YEAR = {1993}}\)], "Input",
  PageWidth->Infinity,
  FontColor->RGBColor[0, 0, 1]],

Cell[CellGroupData[{

Cell["<<Miss9_1.m", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(SetDelayed::"write" \(\(:\)\(\ \)\) 
      "Tag \!\(DMS\) in \!\(DMS[\(\(Y_, X_\)\)]\) is Protected."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["data", "Subsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \($Path\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({"Macintosh HD:Mathematica 4.2 Files:AddOns:JLink", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Kernel", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Autoload", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Applications", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Kernel", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Autoload", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Applications", ":", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:StandardPackages", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:StandardPackages:StartUp", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:Autoload", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:Applications", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:ExtraPackages", 
      "Macintosh HD:Mathematica 4.2 Files:SystemFiles:Graphics:Packages", 
      "Macintosh HD:Mathematica 4.2 Files:Configuration:Kernel", 
      "Macintosh HD:Mathematica 2.2.2:Hermann.Notebooks:SDE", 
      "Macintosh HD:Mathematica 2.2.2:Hermann.Notebooks:SDE:code", 
      "Macintosh HD:Mathematica \
2.2.2:Hermann.Notebooks:SDE:applications"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{\(SetDirectory["\<Macintosh HD:Mathematica \
2.2.2:Hermann.Notebooks:SDE:data:SUNSPOT.DAT\>"]\), 
      "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
    RowBox[{
      StyleBox[\( (*use\ your\ appropriate\ path*) \),
        FontColor->RGBColor[1, 0, 0]]}]}], "Input"],

Cell[BoxData[
    \("Macintosh HD:Mathematica 2.2.2:Hermann.Notebooks:SDE:data:SUNSPOT.DAT"\
\)], "Output"]
}, Open  ]],

Cell["\<\
z  = ReadList[\"SUN.DAT\",Number];
z1 = ReadList[\"SUN1.DAT\",Number];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(z\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({80.9`, 83.4`, 47.7`, 47.8`, 30.7`, 12.2`, 9.6`, 10.2`, 32.4`, 47.6`, 
      54, 62.9`, 85.9`, 61.2`, 45.1`, 36.4`, 20.9`, 11.4`, 37.8`, 69.8`, 
      106.1`, 100.8`, 81.6`, 66.5`, 34.8`, 30.6`, 7, 19.8`, 92.5`, 154.4`, 
      125.9`, 84.8`, 68.1`, 38.5`, 22.8`, 10.2`, 24.1`, 82.9`, 132, 130.9`, 
      118.1`, 89.9`, 66.6`, 60, 46.9`, 41, 21.3`, 16, 6.4`, 4.1`, 6.8`, 
      14.5`, 34, 45, 43.1`, 47.5`, 42.2`, 28.1`, 10.1`, 8.1`, 2.5`, 0, 1.4`, 
      5, 12.2`, 13.9`, 35.4`, 45.8`, 41.1`, 30.4`, 23.9`, 15.7`, 6.6`, 4, 
      1.8`, 8.5`, 16.6`, 36.3`, 49.7`, 62.5`, 67, 71, 47.8`, 27.5`, 8.5`, 
      13.2`, 56.9`, 121.5`, 138.3`, 103.2`, 85.8`, 63.2`, 36.8`, 24.2`, 
      10.7`, 15, 40.1`, 61.5`, 98.5`, 124.3`, 95.9`, 66.5`, 64.5`, 54.2`, 39, 
      20.6`, 6.7`, 4.3`, 22.8`, 54.8`, 93.8`, 95.7`, 77.2`, 59.1`, 44, 47, 
      30.5`, 16.3`, 7.3`, 37.3`, 73.9`, 139.1`, 111.2`, 101.7`, 66.3`, 44.7`, 
      17.1`, 11.3`, 12.3`, 3.4`, 6, 32.3`, 54.3`, 59.7`, 63.7`, 63.5`, 52.2`, 
      25.4`, 13.1`, 6.8`, 6.3`, 7.1`, 35.6`, 73, 84.9`, 78, 64, 41.8`, 26.2`, 
      26.7`, 12.1`, 9.5`, 2.7`, 5, 24.4`, 42, 63.5`, 53.8`, 62, 48.5`, 43.9`, 
      18.6`, 5.7`, 3.6`, 1.4`, 9.6`, 47.4`, 57.1`, 103.9`, 80.6`, 63.6`, 
      37.6`, 26.1`, 14.2`, 5.8`, 16.7`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(z1\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({44.3`, 63.9`, 69, 77.8`, 64.9`, 35.7`, 21.2`, 11.1`, 5.7`, 8.7`, 
      36.1`, 79.7`, 114.4`, 109.6`, 88.8`, 67.8`, 47.5`, 30.6`, 16.3`, 9.6`, 
      33.2`, 92.6`, 151.6`, 136.3`, 134.7`, 83.9`, 69.4`, 31.5`, 13.9`, 4.4`, 
      38, 141.7`, 190.2`, 184.8`, 159, 112.3`, 53.9`, 37.5`, 27.9`, 10.2`, 
      15.1`, 47, 93.8`, 105.9`, 105.5`, 104.5`, 66.6`, 68.9`, 38, 34.5`, 
      15.5`, 12.6`, 27.5`, 92.5`, 155.4`}\)], "Output"]
}, Open  ]],

Cell["\<\
time  = Range[1749,1924];
time1 = Range[1925,1979];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
p1 = plot1[{time,z}//Transpose,color->{1}];
p2 = plot1[{time1,z1}//Transpose,color->{2}];
Show[p1,p2]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{176, 2}\),
      SequenceForm[ "Dimension der Daten  ", {176, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-9.49456 0.00544218 0.0147151 0.0038122 [
[.02925 -0.0125 -12 -9 ]
[.02925 -0.0125 12 0 ]
[.16531 -0.0125 -12 -9 ]
[.16531 -0.0125 12 0 ]
[.30136 -0.0125 -12 -9 ]
[.30136 -0.0125 12 0 ]
[.43741 -0.0125 -12 -9 ]
[.43741 -0.0125 12 0 ]
[.57347 -0.0125 -12 -9 ]
[.57347 -0.0125 12 0 ]
[.70952 -0.0125 -12 -9 ]
[.70952 -0.0125 12 0 ]
[.84558 -0.0125 -12 -9 ]
[.84558 -0.0125 12 0 ]
[.98163 -0.0125 -12 -9 ]
[.98163 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01472 -6 -4.5 ]
[-0.0125 .01472 0 4.5 ]
[-0.0125 .11002 -12 -4.5 ]
[-0.0125 .11002 0 4.5 ]
[-0.0125 .20533 -12 -4.5 ]
[-0.0125 .20533 0 4.5 ]
[-0.0125 .30063 -12 -4.5 ]
[-0.0125 .30063 0 4.5 ]
[-0.0125 .39594 -18 -4.5 ]
[-0.0125 .39594 0 4.5 ]
[-0.0125 .49124 -18 -4.5 ]
[-0.0125 .49124 0 4.5 ]
[-0.0125 .58655 -18 -4.5 ]
[-0.0125 .58655 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .07838 -5 -6 ]
[.97619 .07838 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02925 0 m
.02925 .00625 L
s
[(1750)] .02925 -0.0125 0 1 Mshowa
.16531 0 m
.16531 .00625 L
s
[(1775)] .16531 -0.0125 0 1 Mshowa
.30136 0 m
.30136 .00625 L
s
[(1800)] .30136 -0.0125 0 1 Mshowa
.43741 0 m
.43741 .00625 L
s
[(1825)] .43741 -0.0125 0 1 Mshowa
.57347 0 m
.57347 .00625 L
s
[(1850)] .57347 -0.0125 0 1 Mshowa
.70952 0 m
.70952 .00625 L
s
[(1875)] .70952 -0.0125 0 1 Mshowa
.84558 0 m
.84558 .00625 L
s
[(1900)] .84558 -0.0125 0 1 Mshowa
.98163 0 m
.98163 .00625 L
s
[(1925)] .98163 -0.0125 0 1 Mshowa
.125 Mabswid
.05646 0 m
.05646 .00375 L
s
.08367 0 m
.08367 .00375 L
s
.11088 0 m
.11088 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.19252 0 m
.19252 .00375 L
s
.21973 0 m
.21973 .00375 L
s
.24694 0 m
.24694 .00375 L
s
.27415 0 m
.27415 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.35578 0 m
.35578 .00375 L
s
.38299 0 m
.38299 .00375 L
s
.4102 0 m
.4102 .00375 L
s
.46463 0 m
.46463 .00375 L
s
.49184 0 m
.49184 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.54626 0 m
.54626 .00375 L
s
.60068 0 m
.60068 .00375 L
s
.62789 0 m
.62789 .00375 L
s
.6551 0 m
.6551 .00375 L
s
.68231 0 m
.68231 .00375 L
s
.73673 0 m
.73673 .00375 L
s
.76395 0 m
.76395 .00375 L
s
.79116 0 m
.79116 .00375 L
s
.81837 0 m
.81837 .00375 L
s
.87279 0 m
.87279 .00375 L
s
.9 0 m
.9 .00375 L
s
.92721 0 m
.92721 .00375 L
s
.95442 0 m
.95442 .00375 L
s
.00204 0 m
.00204 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01472 m
.00625 .01472 L
s
[(0)] -0.0125 .01472 1 0 Mshowa
0 .11002 m
.00625 .11002 L
s
[(25)] -0.0125 .11002 1 0 Mshowa
0 .20533 m
.00625 .20533 L
s
[(50)] -0.0125 .20533 1 0 Mshowa
0 .30063 m
.00625 .30063 L
s
[(75)] -0.0125 .30063 1 0 Mshowa
0 .39594 m
.00625 .39594 L
s
[(100)] -0.0125 .39594 1 0 Mshowa
0 .49124 m
.00625 .49124 L
s
[(125)] -0.0125 .49124 1 0 Mshowa
0 .58655 m
.00625 .58655 L
s
[(150)] -0.0125 .58655 1 0 Mshowa
.125 Mabswid
0 .03378 m
.00375 .03378 L
s
0 .05284 m
.00375 .05284 L
s
0 .0719 m
.00375 .0719 L
s
0 .09096 m
.00375 .09096 L
s
0 .12908 m
.00375 .12908 L
s
0 .14814 m
.00375 .14814 L
s
0 .1672 m
.00375 .1672 L
s
0 .18626 m
.00375 .18626 L
s
0 .22439 m
.00375 .22439 L
s
0 .24345 m
.00375 .24345 L
s
0 .26251 m
.00375 .26251 L
s
0 .28157 m
.00375 .28157 L
s
0 .31969 m
.00375 .31969 L
s
0 .33875 m
.00375 .33875 L
s
0 .35781 m
.00375 .35781 L
s
0 .37687 m
.00375 .37687 L
s
0 .415 m
.00375 .415 L
s
0 .43406 m
.00375 .43406 L
s
0 .45312 m
.00375 .45312 L
s
0 .47218 m
.00375 .47218 L
s
0 .5103 m
.00375 .5103 L
s
0 .52936 m
.00375 .52936 L
s
0 .54842 m
.00375 .54842 L
s
0 .56748 m
.00375 .56748 L
s
0 .60561 m
.00375 .60561 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02925 .61178 m
.02925 .61803 L
s
.16531 .61178 m
.16531 .61803 L
s
.30136 .61178 m
.30136 .61803 L
s
.43741 .61178 m
.43741 .61803 L
s
.57347 .61178 m
.57347 .61803 L
s
.70952 .61178 m
.70952 .61803 L
s
.84558 .61178 m
.84558 .61803 L
s
.98163 .61178 m
.98163 .61803 L
s
.125 Mabswid
.05646 .61428 m
.05646 .61803 L
s
.08367 .61428 m
.08367 .61803 L
s
.11088 .61428 m
.11088 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.19252 .61428 m
.19252 .61803 L
s
.21973 .61428 m
.21973 .61803 L
s
.24694 .61428 m
.24694 .61803 L
s
.27415 .61428 m
.27415 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.35578 .61428 m
.35578 .61803 L
s
.38299 .61428 m
.38299 .61803 L
s
.4102 .61428 m
.4102 .61803 L
s
.46463 .61428 m
.46463 .61803 L
s
.49184 .61428 m
.49184 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.54626 .61428 m
.54626 .61803 L
s
.60068 .61428 m
.60068 .61803 L
s
.62789 .61428 m
.62789 .61803 L
s
.6551 .61428 m
.6551 .61803 L
s
.68231 .61428 m
.68231 .61803 L
s
.73673 .61428 m
.73673 .61803 L
s
.76395 .61428 m
.76395 .61803 L
s
.79116 .61428 m
.79116 .61803 L
s
.81837 .61428 m
.81837 .61803 L
s
.87279 .61428 m
.87279 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.92721 .61428 m
.92721 .61803 L
s
.95442 .61428 m
.95442 .61803 L
s
.00204 .61428 m
.00204 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01472 m
1 .01472 L
s
.99375 .11002 m
1 .11002 L
s
.99375 .20533 m
1 .20533 L
s
.99375 .30063 m
1 .30063 L
s
.99375 .39594 m
1 .39594 L
s
.99375 .49124 m
1 .49124 L
s
.99375 .58655 m
1 .58655 L
s
.125 Mabswid
.99625 .03378 m
1 .03378 L
s
.99625 .05284 m
1 .05284 L
s
.99625 .0719 m
1 .0719 L
s
.99625 .09096 m
1 .09096 L
s
.99625 .12908 m
1 .12908 L
s
.99625 .14814 m
1 .14814 L
s
.99625 .1672 m
1 .1672 L
s
.99625 .18626 m
1 .18626 L
s
.99625 .22439 m
1 .22439 L
s
.99625 .24345 m
1 .24345 L
s
.99625 .26251 m
1 .26251 L
s
.99625 .28157 m
1 .28157 L
s
.99625 .31969 m
1 .31969 L
s
.99625 .33875 m
1 .33875 L
s
.99625 .35781 m
1 .35781 L
s
.99625 .37687 m
1 .37687 L
s
.99625 .415 m
1 .415 L
s
.99625 .43406 m
1 .43406 L
s
.99625 .45312 m
1 .45312 L
s
.99625 .47218 m
1 .47218 L
s
.99625 .5103 m
1 .5103 L
s
.99625 .52936 m
1 .52936 L
s
.99625 .54842 m
1 .54842 L
s
.99625 .56748 m
1 .56748 L
s
.99625 .60561 m
1 .60561 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .07838 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .32312 m
.02925 .33265 L
.03469 .19656 L
.04014 .19694 L
.04558 .13175 L
.05102 .06122 L
.05646 .05131 L
.0619 .0536 L
.06735 .13823 L
.07279 .19618 L
.07823 .22057 L
.08367 .2545 L
.08912 .34218 L
.09456 .24802 L
.1 .18665 L
.10544 .15348 L
.11088 .09439 L
.11633 .05817 L
.12177 .15882 L
.12721 .28081 L
.13265 .41919 L
.1381 .39898 L
.14354 .32579 L
.14898 .26823 L
.15442 .14738 L
.15986 .13137 L
.16531 .0414 L
.17075 .0902 L
.17619 .36734 L
.18163 .60332 L
.18707 .49467 L
.19252 .33799 L
.19796 .27433 L
.2034 .16148 L
.20884 .10163 L
.21429 .0536 L
.21973 .10659 L
.22517 .33075 L
.23061 .51793 L
.23605 .51373 L
.2415 .46494 L
.24694 .35743 L
.25238 .26861 L
.25782 .24345 L
.26327 .19351 L
.26871 .17102 L
.27415 .09591 L
.27959 .07571 L
.28503 .03911 L
.29048 .03035 L
Mistroke
.29592 .04064 L
.30136 .06999 L
.3068 .14433 L
.31224 .18626 L
.31769 .17902 L
.32313 .19579 L
.32857 .17559 L
.33401 .12184 L
.33946 .05322 L
.3449 .04559 L
.35034 .02425 L
.35578 .01472 L
.36122 .02005 L
.36667 .03378 L
.37211 .06122 L
.37755 .0677 L
.38299 .14967 L
.38844 .18931 L
.39388 .1714 L
.39932 .13061 L
.40476 .10583 L
.4102 .07457 L
.41565 .03988 L
.42109 .02996 L
.42653 .02158 L
.43197 .04712 L
.43741 .078 L
.44286 .1531 L
.4483 .20418 L
.45374 .25298 L
.45918 .27013 L
.46463 .28538 L
.47007 .19694 L
.47551 .11955 L
.48095 .04712 L
.48639 .06504 L
.49184 .23163 L
.49728 .4779 L
.50272 .54194 L
.50816 .40813 L
.51361 .3418 L
.51905 .25565 L
.52449 .155 L
.52993 .10697 L
.53537 .05551 L
.54082 .0719 L
.54626 .16758 L
.5517 .24917 L
.55714 .39022 L
.56259 .48857 L
Mistroke
.56803 .38031 L
.57347 .26823 L
.57891 .2606 L
.58435 .22134 L
.5898 .16339 L
.59524 .09325 L
.60068 .04026 L
.60612 .03111 L
.61156 .10163 L
.61701 .22362 L
.62245 .3723 L
.62789 .37954 L
.63333 .30902 L
.63878 .24002 L
.64422 .18245 L
.64966 .19389 L
.6551 .13099 L
.66054 .07685 L
.66599 .04254 L
.67143 .15691 L
.67687 .29644 L
.68231 .54499 L
.68776 .43863 L
.6932 .40242 L
.69864 .26746 L
.70408 .18512 L
.70952 .0799 L
.71497 .05779 L
.72041 .06161 L
.72585 .02768 L
.73129 .03759 L
.73673 .13785 L
.74218 .22172 L
.74762 .2423 L
.75306 .25755 L
.7585 .25679 L
.76395 .21371 L
.76939 .11154 L
.77483 .06465 L
.78027 .04064 L
.78571 .03873 L
.79116 .04178 L
.7966 .15043 L
.80204 .29301 L
.80748 .33837 L
.81293 .31207 L
.81837 .2587 L
.82381 .17407 L
.82925 .11459 L
.83469 .1165 L
Mistroke
.84014 .06084 L
.84558 .05093 L
.85102 .02501 L
.85646 .03378 L
.8619 .10773 L
.86735 .17483 L
.87279 .25679 L
.87823 .21981 L
.88367 .25107 L
.88912 .19961 L
.89456 .18207 L
.9 .08562 L
.90544 .03644 L
.91088 .02844 L
.91633 .02005 L
.92177 .05131 L
.92721 .19541 L
.93265 .23239 L
.9381 .4108 L
.94354 .32198 L
.94898 .25717 L
.95442 .15805 L
.95986 .11421 L
.96531 .06885 L
.97075 .03683 L
.97619 .07838 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`004@3oool3000000@0oooo00<000000?ooo`3oool0
0P3oool3000000@0oooo0P00000=0?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo0080oooo0`00000>0?ooo`<000000`3oool3000000@0oooo0P0000040?ooo`800000
3@3oool3000000<0oooo0`0000020?ooo`D000000P3oool3000000d0oooo0`0000030?ooo`<00000
0`3oool3000000@0oooo0P00000=0?ooo`<000000`3oool3000000@0oooo00<000000?ooo`3oool0
0P3oool3000000h0oooo0`0000030?ooo`8000001@3oool2000000@0oooo0P00000=0?ooo`<00000
0`3oool2000000<0oooo1@0000020?ooo`<000000`3oool00180oooo00<000000?ooo`3oool00`3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0303oool01@000000oooo0?ooo`3oool0
000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo00/0oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo000000030?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool02`3oool01@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0
oooo000000030?ooo`050000003oool0oooo0?ooo`0000003P3oool00`000000oooo0?ooo`040?oo
o`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool000000080oooo
00<000000?ooo`0000000`3oool100000040oooo0@3oool00180oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`0<0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool02`3oool0
1@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000
003oool0oooo00/0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00<0
oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00D0oooo
00D000000?ooo`3oool0oooo000000070?ooo`4000000@3oool10?ooo`004P3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool00P3oool3000000<0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000=0?ooo`030000003oool0
oooo0080oooo0`0000050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02`3oool0
0`000000oooo0?ooo`020?ooo`<000001P3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0080oooo100000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000003@3oool00`000000oooo0?ooo`020?ooo`@0
0000103oool00`000000oooo0?ooo`040?ooo`4000000@3oool10?ooo`004P3oool00`000000oooo
0?ooo`050?ooo`030000003oool0000000<000000`3oool010000000oooo0?ooo`00000=0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool00`3oool00`000000oooo00000003000000l0
oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo0?ooo`000000
0`3oool00`000000oooo000000030?ooo`030000003oool0000000<000003P3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`0000030?ooo`040000003oool0oooo0000
00d0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`0000000`00000?0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool02`3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`3oool00`000000oooo000000030000
00<0oooo000A0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3oool0
10000000oooo0?ooo`00000<0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`00
00000`3oool00`000000oooo0000000A0?ooo`8000000`3oool01@000000oooo0?ooo`3oool00000
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000<0?ooo`8000000`3o
ool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool00`000000oooo0000000@0?ooo`80
00000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3oool010000000oooo0?ooo`00
000<0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool00`000000
oooo0000000A0?ooo`8000000`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000<0?ooo`8000000`3oool01`000000oooo0?oo
o`3oool000000?ooo`0000000`3oool00`000000oooo000000060?ooo`004P3oool010000000oooo
0?ooo`3oool5000000030?ooo`000000000000<000000`3oool2000000h0oooo00@000000?ooo`3o
ool0oooo1@0000000`3oool0000000000003000000030?ooo`000000000000<000003P3oool00`00
0000oooo0?ooo`020?ooo`<00000103oool2000000@0oooo0P00000>0?ooo`030000003oool0oooo
0080oooo0`0000030?ooo`<000000P3oool5000000d0oooo00<000000?ooo`3oool00P3oool30000
0080oooo1@0000030?ooo`8000003P3oool00`000000oooo0?ooo`020?ooo`<000000P3oool50000
00030?ooo`000000000000<000003P3oool00`000000oooo0?ooo`020?ooo`<00000103oool20000
00@0oooo0P00000>0?ooo`030000003oool0oooo0080oooo0`0000030?ooo`<000000P3oool50000
0080oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo000E0?oo
ood000001`3oool000h0oooo0P0000050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool01@3oool000d0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo01l0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo01l0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0P0?ooo`03
0000003oool0oooo01l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`050?ooo`00
3@3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?T0oooo00<000000?ooo`3o
ool01@3oool000d0oooo00@000000?ooo`3oool00000103oool2000005H0oooo0`000?nO0?ooo`<0
00001`3oool000d0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`1E0?ooo`@0
003oR@3oool20000oaD0oooo00<000000?ooo`3oool01@3oool000d0oooo00@000000?ooo`3oool0
0000103oool00`000000oooo0?ooo`1D0?ooo`D0003o3P3oool20000ogT0oooo0P000?lE0?ooo`03
0000003oool0oooo00D0oooo000>0?ooo`8000001@3oool00`000000oooo0?ooo`1D0?ooo`80003o
00<0oooo0000o`000?l03P3oool20000odX0oooo0P000?lM0?ooo`80003o3@3oool30000oaD0oooo
00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0A@3oool20000o`d0oooo0P00
0?l0103oool0003o0000o`000?l<0?ooo`<0003o:`3oool20000oad0oooo0P000?lM0?ooo`80003o
3@3oool40000oa@0oooo00<000000?ooo`3oool01@3oool001D0oooo0P0000150?ooo`<0003o3@3o
ool20000o`80oooo0P000?l;0?ooo`@0003o:`3oool20000oad0oooo0`000?lL0?ooo`<0003o2`3o
ool50000oa<0oooo0P0000070?ooo`005@3oool00`000000oooo0?ooo`130?ooo`D0003o2`3oool3
0000o`80oooo0P000?l:0?ooo`H0003o:@3oool30000oa`0oooo10000?l;0?ooo`<0003o3P3oool3
0000o`/0oooo0P000?l00`3oool0003o0000o`0;0?ooo`80003o1`3oool00`000000oooo0?ooo`05
0?ooo`005@3oool00`000000oooo0?ooo`0U0?ooo`80003o703oool20000o`030?ooo`000?l0003o
00/0oooo0P000?l30?ooo`80003o2P3oool20000o`80oooo0P000?lY0?ooo`<0003o3@3oool20000
o`d0oooo10000?l:0?ooo`D0003o303oool40000o`/0oooo0P000?l00`3oool0003o0000o`0;0?oo
o`80003o1`3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0U0?ooo`80
003o703oool20000o`030?ooo`000?l0003o00/0oooo0P000?l30?ooo`80003o2P3oool20000o`80
oooo0P000?l;0?ooo`80003o703oool30000o`d0oooo0P000?l=0?ooo`@0003o2P3oool20000o`03
0?ooo`000?l0003o00`0oooo10000?l;0?ooo`80003o00@0oooo0000o`000?l0003o2P3oool20000
o`L0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool02P3oool20000oaT0
oooo0P000?lL0?ooo`80003o00<0oooo0000o`000?l02P3oool30000o`<0oooo0`000?l90?ooo`80
003o0P3oool20000o`/0oooo0P000?lL0?ooo`@0003o303oool20000o`d0oooo10000?l:0?ooo`80
003o00<0oooo0000o`000?l0303oool40000o`X0oooo0`000?l20?ooo`80003o2P3oool30000o`H0
oooo00<000000?ooo`3oool01@3oool001D0oooo0P00000;0?ooo`<0003o603oool20000o`/0oooo
0P000?l?0?ooo`80003o00@0oooo0000o`000?l0003o203oool30000o`D0oooo0P000?l90?ooo`80
003o0P3oool20000o`/0oooo0P000?l<0?ooo`80003o3P3oool40000o``0oooo0P000?l=0?ooo`@0
003o2P3oool20000o`030?ooo`000?l0003o00`0oooo1@000?l90?ooo`80003o0`3oool20000o`X0
oooo0`000?l50?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool02@3oool40000o``0oooo
0P000?l:0?ooo`<0003o2P3oool20000o`h0oooo0`000?l20?ooo`80003o203oool20000o`H0oooo
0P000?l80?ooo`<0003o0P3oool30000o`X0oooo0`000?l;0?ooo`80003o3P3oool40000o``0oooo
0P000?l;0?ooo`H0003o2@3oool30000o`030?ooo`000?l0003o00/0oooo0`000?l00`3oool0003o
0000o`090?ooo`80003o0`3oool20000o`T0oooo10000?l60?ooo`030000003oool0oooo00D0oooo
000E0?ooo`030000003oool0oooo00T0oooo10000?l<0?ooo`80003o2P3oool30000o`X0oooo0P00
0?l>0?ooo`80003o0`3oool20000o`P0oooo0P000?l60?ooo`<0003o1`3oool20000o`@0oooo0P00
0?l:0?ooo`<0003o2`3oool20000o`h0oooo10000?l;0?ooo`<0003o2`3oool30000o`030?ooo`00
0?l0003o00T0oooo0P000?l20?ooo`80003o2P3oool30000o`80oooo0P000?l90?ooo`80003o0`3o
ool20000o`T0oooo10000?l60?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0
oooo00T0oooo10000?l<0?ooo`80003o2P3oool30000o`X0oooo0P000?l>0?ooo`80003o0`3oool3
0000o`L0oooo0P000?l60?ooo`@0003o1P3oool20000o`@0oooo0P000?l90?ooo`@0003o2`3oool3
0000o`d0oooo10000?l;0?ooo`<0003o2P3oool40000o`030?ooo`000?l0003o00T0oooo0P000?l2
0?ooo`80003o2P3oool20000o`<0oooo0P000?l90?ooo`80003o0`3oool20000o`T0oooo10000?l6
0?ooo`030000003oool0oooo00D0oooo000E0?ooo`8000002P3oool40000o``0oooo0P000?l:0?oo
o`<0003o2@3oool30000o`h0oooo0P000?l40?ooo`80003o1`3oool20000o`P0oooo0P000?l60?oo
o`80003o103oool20000o`T0oooo10000?l:0?ooo`@0003o303oool50000o`/0oooo0`000?l:0?oo
o`80003o0`3oool20000o`T0oooo0P000?l20?ooo`80003o2P3oool20000o`<0oooo0P000?l90?oo
o`80003o0`3oool20000o`T0oooo1@000?l40?ooo`8000001`3oool001D0oooo00<000000?ooo`3o
ool02@3oool40000o``0oooo0P000?l:0?ooo`<0003o2@3oool30000o`h0oooo0P000?l40?ooo`80
003o1`3oool20000o`P0oooo0P000?l60?ooo`80003o103oool30000o`P0oooo10000?l:0?ooo`@0
003o303oool20000o`030?ooo`000?l0003o00/0oooo10000?l90?ooo`80003o0`3oool20000o`T0
oooo0P000?l20?ooo`80003o2P3oool20000o`<0oooo0P000?l90?ooo`80003o0`3oool20000o`T0
oooo0P000?l00`3oool0003o0000o`050?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000
003oool0oooo00T0oooo1@000?l:0?ooo`<0003o2P3oool30000o`T0oooo0`000?l>0?ooo`80003o
103oool20000o`L0oooo0P000?l80?ooo`80003o1P3oool20000o`D0oooo0P000?l80?ooo`@0003o
2P3oool40000o``0oooo0P000?l00`3oool0003o0000o`0;0?ooo`@0003o203oool30000o`<0oooo
0P000?l90?ooo`80003o0P3oool20000o`X0oooo0P000?l30?ooo`80003o203oool30000o`<0oooo
0P000?l90?ooo`80003o00<0oooo0000o`000?l01@3oool00`000000oooo0?ooo`050?ooo`005@3o
ool00`000000oooo0?ooo`080?ooo`<0003o00<0oooo0000o`000?l02P3oool30000o`X0oooo1000
0?l80?ooo`@0003o3@3oool20000o`@0oooo0P000?l70?ooo`80003o203oool20000o`H0oooo0P00
0?l50?ooo`80003o203oool40000o`X0oooo10000?l<0?ooo`80003o00<0oooo0000o`000?l02`3o
ool40000o`P0oooo0P000?l40?ooo`80003o203oool30000o`80oooo0P000?l:0?ooo`80003o0`3o
ool20000o`P0oooo0P000?l40?ooo`80003o2@3oool20000o`030?ooo`000?l0003o00D0oooo00<0
00000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0203oool20000o`80oooo0P000?l:
0?ooo`<0003o2P3oool40000o`P0oooo10000?l<0?ooo`<0003o103oool20000o`L0oooo0P000?l8
0?ooo`80003o1P3oool20000o`D0oooo0P000?l80?ooo`@0003o2P3oool40000o``0oooo0P000?l0
103oool0003o0000o`000?l:0?ooo`@0003o203oool20000o`@0oooo0P000?l80?ooo`80003o0`3o
ool20000o`X0oooo0P000?l30?ooo`80003o203oool20000o`@0oooo0P000?l80?ooo`<0003o203o
ool00`000000oooo0?ooo`050?ooo`005@3oool2000000T0oooo0P000?l20?ooo`80003o2P3oool3
0000o`T0oooo1@000?l80?ooo`@0003o303oool20000o`D0oooo0P000?l60?ooo`<0003o203oool2
0000o`H0oooo0P000?l50?ooo`80003o203oool40000o`X0oooo10000?l<0?ooo`80003o0P3oool2
0000o`X0oooo10000?l80?ooo`80003o103oool30000o`L0oooo0P000?l30?ooo`80003o2P3oool2
0000o`<0oooo0`000?l70?ooo`80003o103oool20000o`P0oooo0P000?l80?ooo`8000001`3oool0
01D0oooo00<000000?ooo`3oool0203oool20000o`80oooo0P000?l:0?ooo`<0003o2@3oool20000
o`030?ooo`000?l0003o00L0oooo1@000?l<0?ooo`80003o1@3oool20000o`H0oooo0P000?l90?oo
o`80003o1@3oool30000o`D0oooo0P000?l80?ooo`@0003o2P3oool40000o``0oooo0P000?l20?oo
o`80003o2P3oool40000o`P0oooo0P000?l50?ooo`80003o1`3oool20000o`<0oooo0P000?l90?oo
o`<0003o103oool20000o`L0oooo0P000?l40?ooo`80003o203oool20000o`T0oooo00<000000?oo
o`3oool01@3oool001D0oooo00<000000?ooo`3oool0203oool20000o`80oooo0P000?l:0?ooo`<0
003o2@3oool20000o`030?ooo`000?l0003o00L0oooo0P000?l00`3oool0003o0000o`0<0?ooo`80
003o1@3oool20000o`H0oooo0P000?l90?ooo`80003o1@3oool20000o`H0oooo0P000?l80?ooo`@0
003o2@3oool50000o``0oooo0P000?l20?ooo`80003o2P3oool40000o`P0oooo0P000?l50?ooo`80
003o1`3oool20000o`<0oooo0`000?l80?ooo`80003o1@3oool20000o`L0oooo0P000?l40?ooo`80
003o203oool20000o`T0oooo00<000000?ooo`3oool01@3oool000H0oooo1@0000020?ooo`<00000
1@3oool00`000000oooo0?ooo`080?ooo`80003o0P3oool20000o`X0oooo0`000?l90?ooo`80003o
00<0oooo0000o`000?l01`3oool20000o`030?ooo`000?l0003o00`0oooo0P000?l50?ooo`80003o
1P3oool20000o`T0oooo0P000?l50?ooo`80003o1P3oool20000o`L0oooo1@000?l90?ooo`80003o
00<0oooo0000o`000?l0303oool20000o`80oooo0P000?l:0?ooo`@0003o203oool20000o`D0oooo
0P000?l60?ooo`<0003o103oool20000o`P0oooo0P000?l50?ooo`80003o1`3oool20000o`@0oooo
0P000?l80?ooo`80003o2@3oool00`000000oooo0?ooo`050?ooo`001`3oool01P000000oooo0?oo
o`000000oooo000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`080?ooo`80
003o0P3oool20000o`X0oooo0`000?l90?ooo`80003o00<0oooo0000o`000?l01`3oool20000o`03
0?ooo`000?l0003o00`0oooo0P000?l50?ooo`80003o1P3oool20000o`T0oooo0P000?l50?ooo`80
003o1P3oool20000o`L0oooo0P000?l00`3oool0003o0000o`090?ooo`80003o00<0oooo0000o`00
0?l0303oool20000o`80oooo0P000?l90?ooo`D0003o203oool20000o`D0oooo0P000?l60?ooo`80
003o1@3oool20000o`P0oooo0P000?l50?ooo`80003o1`3oool20000o`@0oooo0P000?l70?ooo`<0
003o2@3oool00`000000oooo0?ooo`050?ooo`00203oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo0080oooo0P0000090?ooo`80003o0P3oool20000o`X0oooo10000?l80?ooo`80003o
00<0oooo0000o`000?l01`3oool20000o`030?ooo`000?l0003o00`0oooo0P000?l50?ooo`<0003o
1@3oool20000o`T0oooo0`000?l40?ooo`80003o1P3oool20000o`L0oooo0P000?l0103oool0003o
0000o`000?l80?ooo`80003o00<0oooo0000o`000?l0303oool20000o`80oooo0P000?l90?ooo`80
003o00<0oooo0000o`000?l0203oool20000o`D0oooo0P000?l60?ooo`80003o1@3oool20000o`P0
oooo0P000?l50?ooo`80003o1`3oool20000o`@0oooo0P000?l70?ooo`80003o203oool3000000L0
oooo00090?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`080?ooo`80003o0P3oool20000o`T0oooo1@000?l80?ooo`80003o00<0oooo0000o`000?l0
1`3oool20000o`030?ooo`000?l0003o00`0oooo0P000?l60?ooo`80003o1@3oool20000o`X0oooo
0P000?l30?ooo`<0003o1P3oool20000o`L0oooo0P000?l20?ooo`80003o203oool20000o`030?oo
o`000?l0003o00/0oooo0`000?l20?ooo`80003o2@3oool20000o`030?ooo`000?l0003o00P0oooo
0P000?l50?ooo`80003o1P3oool20000o`D0oooo0P000?l70?ooo`<0003o1@3oool20000o`L0oooo
0P000?l40?ooo`80003o1`3oool20000o`X0oooo00<000000?ooo`3oool01@3oool000H0oooo00H0
00000?ooo`3oool0oooo0000003oool4000000D0oooo00<000000?ooo`3oool01`3oool30000o`80
oooo0P000?l90?ooo`80003o00<0oooo0000o`000?l0203oool20000o`030?ooo`000?l0003o00L0
oooo0P000?l00`3oool0003o0000o`0;0?ooo`<0003o1P3oool20000o`D0oooo0P000?l:0?ooo`80
003o0`3oool20000o`L0oooo0`000?l60?ooo`80003o0P3oool20000o`P0oooo0P000?l00`3oool0
003o0000o`0;0?ooo`80003o0`3oool20000o`T0oooo0P000?l00`3oool0003o0000o`080?ooo`80
003o1@3oool20000o`H0oooo0P000?l50?ooo`80003o1`3oool30000o`D0oooo0P000?l70?ooo`80
003o103oool20000o`L0oooo0P000?l:0?ooo`030000003oool0oooo00D0oooo00060?ooo`070000
003oool0oooo0?ooo`000000oooo000000080?ooo`030000003oool0oooo00L0oooo0P000?l30?oo
o`<0003o203oool20000o`030?ooo`000?l0003o00P0oooo0P000?l00`3oool0003o0000o`070?oo
o`80003o00<0oooo0000o`000?l02`3oool20000o`L0oooo0P000?l50?ooo`80003o2P3oool20000
o`<0oooo0P000?l80?ooo`80003o1P3oool20000o`80oooo0P000?l80?ooo`80003o00@0oooo0000
o`000?l0003o2P3oool20000o`<0oooo0P000?l90?ooo`80003o00<0oooo0000o`000?l0203oool2
0000o`D0oooo0P000?l60?ooo`80003o1@3oool20000o`L0oooo0`000?l50?ooo`80003o1`3oool2
0000o`@0oooo0P000?l70?ooo`80003o2P3oool00`000000oooo0?ooo`050?ooo`001`3oool30000
0080oooo1@0000040?ooo`030000003oool0oooo00L0oooo0P000?l40?ooo`80003o203oool20000
o`030?ooo`000?l0003o00P0oooo0P000?l00`3oool0003o0000o`070?ooo`80003o00<0oooo0000
o`000?l02`3oool20000o`L0oooo0P000?l50?ooo`80003o2P3oool20000o`80oooo0`000?l80?oo
o`80003o1P3oool20000o`80oooo0P000?l80?ooo`80003o0P3oool20000o`X0oooo0P000?l30?oo
o`80003o2@3oool20000o`030?ooo`000?l0003o00P0oooo0P000?l50?ooo`80003o1P3oool20000
o`D0oooo0P000?l70?ooo`80003o1P3oool20000o`L0oooo0P000?l40?ooo`<0003o1P3oool20000
o`X0oooo00<000000?ooo`3oool01@3oool001D0oooo0P0000080?ooo`80003o103oool20000o`P0
oooo0P000?l00`3oool0003o0000o`080?ooo`80003o00<0oooo0000o`000?l01`3oool20000o`03
0?ooo`000?l0003o00/0oooo0P000?l70?ooo`80003o1@3oool20000o`X0oooo0P000?l20?ooo`80
003o2@3oool20000o`H0oooo0P000?l20?ooo`80003o203oool20000o`80oooo0P000?l:0?ooo`80
003o0`3oool20000o`T0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o1@3oool20000o`H0
oooo0P000?l50?ooo`80003o1`3oool20000o`H0oooo0P000?l70?ooo`80003o1@3oool20000o`H0
oooo0P000?l90?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool01`3oool20000o`@0oooo
0P000?l80?ooo`80003o00<0oooo0000o`000?l0203oool20000o`030?ooo`000?l0003o00H0oooo
0`000?l00`3oool0003o0000o`0;0?ooo`80003o1`3oool20000o`D0oooo0P000?l:0?ooo`80003o
0P3oool20000o`T0oooo0P000?l60?ooo`80003o0P3oool20000o`L0oooo0`000?l20?ooo`80003o
2P3oool20000o`<0oooo0P000?l90?ooo`80003o00@0oooo0000o`000?l0003o1P3oool30000o`D0
oooo0P000?l60?ooo`80003o1@3oool20000o`H0oooo0`000?l60?ooo`80003o1`3oool20000o`D0
oooo0P000?l60?ooo`80003o2P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo
0?ooo`070?ooo`80003o103oool20000o`P0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o
00<0oooo0000o`000?l01P3oool20000o`80oooo0P000?l;0?ooo`80003o1`3oool20000o`@0oooo
0`000?l:0?ooo`80003o0P3oool20000o`T0oooo0P000?l60?ooo`80003o0P3oool20000o`L0oooo
0P000?l30?ooo`80003o2P3oool20000o`<0oooo0P000?l90?ooo`80003o0P3oool20000o`H0oooo
0P000?l60?ooo`80003o1P3oool20000o`D0oooo0P000?l60?ooo`80003o1`3oool20000o`H0oooo
0`000?l50?ooo`80003o1@3oool30000o`X0oooo00<000000?ooo`3oool01@3oool001D0oooo00<0
00000?ooo`3oool01`3oool20000o`@0oooo0P000?l70?ooo`<0003o00<0oooo0000o`000?l01`3o
ool30000o`030?ooo`000?l0003o00H0oooo0P000?l20?ooo`80003o2`3oool20000o`L0oooo0P00
0?l40?ooo`80003o2`3oool20000o`80oooo0P000?l90?ooo`80003o1P3oool20000o`80oooo0P00
0?l70?ooo`80003o0`3oool20000o`X0oooo0P000?l30?ooo`80003o2@3oool20000o`80oooo0P00
0?l60?ooo`80003o1P3oool20000o`H0oooo0P000?l50?ooo`80003o1P3oool20000o`L0oooo0`00
0?l50?ooo`80003o1P3oool20000o`D0oooo0P000?l;0?ooo`030000003oool0oooo00D0oooo000E
0?ooo`030000003oool0oooo00L0oooo0P000?l40?ooo`80003o1`3oool20000o`80oooo0P000?l7
0?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o2`3oool20000o`L0oooo0P000?l4
0?ooo`80003o2`3oool20000o`80oooo0P000?l90?ooo`80003o1P3oool20000o`80oooo0P000?l7
0?ooo`80003o0`3oool20000o`X0oooo0P000?l30?ooo`80003o2@3oool20000o`80oooo0P000?l6
0?ooo`80003o1P3oool20000o`H0oooo0P000?l50?ooo`80003o1P3oool20000o`P0oooo0P000?l5
0?ooo`80003o1P3oool20000o`D0oooo0P000?l;0?ooo`030000003oool0oooo00D0oooo000E0?oo
o`800000203oool20000o`@0oooo0P000?l70?ooo`80003o0P3oool20000o`L0oooo0P000?l20?oo
o`80003o1P3oool20000o`80oooo0P000?l;0?ooo`80003o1`3oool20000o`@0oooo0P000?l;0?oo
o`80003o0P3oool20000o`T0oooo0P000?l60?ooo`80003o0P3oool20000o`L0oooo0P000?l30?oo
o`80003o2@3oool30000o`<0oooo0P000?l80?ooo`<0003o0P3oool20000o`H0oooo0P000?l60?oo
o`80003o1P3oool20000o`D0oooo0P000?l60?ooo`80003o203oool20000o`D0oooo0P000?l60?oo
o`80003o1@3oool20000o`X0oooo0P0000070?ooo`005@3oool00`000000oooo0?ooo`070?ooo`80
003o103oool20000o`L0oooo0P000?l20?ooo`80003o1`3oool20000o`80oooo0P000?l60?ooo`80
003o0P3oool20000o`X0oooo0`000?l70?ooo`80003o103oool20000o`/0oooo0P000?l0103oool0
003o0000o`000?l90?ooo`80003o1P3oool20000o`80oooo0P000?l70?ooo`80003o0`3oool20000
o`T0oooo0P000?l40?ooo`80003o203oool20000o`<0oooo0P000?l60?ooo`80003o1P3oool20000
o`H0oooo0P000?l50?ooo`80003o1P3oool20000o`P0oooo0P000?l50?ooo`80003o1P3oool20000
o`D0oooo0P000?l;0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00L0
oooo0P000?l40?ooo`80003o1`3oool20000o`80oooo0P000?l70?ooo`80003o0P3oool20000o`H0
oooo0P000?l20?ooo`80003o2P3oool20000o`P0oooo0P000?l40?ooo`80003o2`3oool20000o`03
0?ooo`000?l0003o00X0oooo0P000?l60?ooo`80003o0P3oool20000o`L0oooo0P000?l30?ooo`80
003o2@3oool20000o`@0oooo0P000?l80?ooo`80003o0`3oool20000o`H0oooo0P000?l60?ooo`80
003o1P3oool20000o`D0oooo0P000?l60?ooo`80003o203oool20000o`D0oooo0P000?l60?ooo`80
003o1@3oool20000o`/0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0
1`3oool20000o`@0oooo0P000?l70?ooo`80003o0P3oool20000o`L0oooo0P000?l20?ooo`80003o
1P3oool20000o`80oooo0P000?l:0?ooo`80003o203oool20000o`@0oooo0P000?l;0?ooo`D0003o
2P3oool20000o`D0oooo0`000?l20?ooo`80003o1`3oool20000o`<0oooo0P000?l90?ooo`80003o
103oool20000o`P0oooo0P000?l30?ooo`80003o1P3oool20000o`H0oooo0`000?l50?ooo`80003o
1@3oool20000o`D0oooo0`000?l80?ooo`80003o1@3oool20000o`H0oooo0P000?l50?ooo`80003o
2`3oool00`000000oooo0?ooo`050?ooo`005@3oool2000000L0oooo0`000?l40?ooo`80003o1`3o
ool20000o`80oooo0P000?l70?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o2P3o
ool20000o`P0oooo0P000?l30?ooo`<0003o303oool40000o`X0oooo0P000?l50?ooo`80003o0`3o
ool20000o`L0oooo0P000?l30?ooo`80003o2@3oool20000o`@0oooo0`000?l70?ooo`80003o0`3o
ool20000o`H0oooo0P000?l70?ooo`80003o103oool30000o`D0oooo0P000?l50?ooo`80003o2@3o
ool20000o`D0oooo0P000?l60?ooo`80003o1@3oool20000o`X0oooo0P0000070?ooo`005@3oool0
0`000000oooo0?ooo`060?ooo`80003o1@3oool30000o`H0oooo0P000?l20?ooo`80003o1`3oool2
0000o`80oooo0P000?l60?ooo`80003o0P3oool20000o`X0oooo0P000?l80?ooo`<0003o0P3oool2
0000o`d0oooo10000?l:0?ooo`<0003o103oool20000o`<0oooo0P000?l70?ooo`80003o0`3oool2
0000o`T0oooo0P000?l50?ooo`80003o1`3oool20000o`<0oooo0P000?l60?ooo`80003o1`3oool2
0000o`@0oooo0P000?l60?ooo`80003o1@3oool20000o`T0oooo0P000?l50?ooo`80003o1P3oool2
0000o`D0oooo0P000?l;0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo
00H0oooo0P000?l60?ooo`80003o1@3oool30000o`80oooo0P000?l70?ooo`80003o0P3oool20000
o`H0oooo0P000?l20?ooo`80003o2P3oool20000o`T0oooo0P000?l20?ooo`80003o3@3oool40000
o`/0oooo0P000?l40?ooo`80003o0`3oool20000o`L0oooo0P000?l30?ooo`80003o2@3oool20000
o`D0oooo0P000?l70?ooo`80003o0`3oool20000o`H0oooo0P000?l70?ooo`80003o103oool20000
o`H0oooo0P000?l50?ooo`80003o2@3oool20000o`D0oooo0P000?l60?ooo`80003o1@3oool20000
o`/0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool01P3oool20000o`H0
oooo0P000?l50?ooo`80003o0`3oool20000o`L0oooo0P000?l20?ooo`80003o1P3oool20000o`80
oooo0P000?l:0?ooo`80003o2@3oool60000o`d0oooo10000?l;0?ooo`80003o103oool20000o`<0
oooo0P000?l70?ooo`80003o0`3oool20000o`T0oooo0P000?l50?ooo`80003o1`3oool20000o`<0
oooo0P000?l60?ooo`80003o1`3oool20000o`@0oooo0P000?l60?ooo`80003o1@3oool20000o`T0
oooo0P000?l50?ooo`80003o1P3oool20000o`D0oooo0P000?l;0?ooo`030000003oool0oooo00D0
oooo000E0?ooo`030000003oool0oooo00H0oooo0P000?l60?ooo`80003o1@3oool20000o`<0oooo
0P000?l60?ooo`<0003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o2P3oool20000o`T0oooo
1P000?l=0?ooo`@0003o2`3oool20000o`@0oooo0P000?l30?ooo`80003o1P3oool30000o`<0oooo
0P000?l90?ooo`80003o1@3oool20000o`D0oooo10000?l30?ooo`80003o1P3oool20000o`L0oooo
0P000?l40?ooo`80003o1P3oool20000o`D0oooo0P000?l90?ooo`80003o1@3oool20000o`H0oooo
0P000?l50?ooo`80003o2`3oool00`000000oooo0?ooo`050?ooo`005@3oool2000000L0oooo0P00
0?l60?ooo`80003o1@3oool20000o`<0oooo0P000?l60?ooo`80003o0`3oool20000o`H0oooo0P00
0?l20?ooo`80003o2@3oool30000o`T0oooo1P000?l>0?ooo`80003o303oool20000o`@0oooo0P00
0?l30?ooo`80003o1P3oool20000o`@0oooo0P000?l90?ooo`80003o1@3oool20000o`D0oooo0`00
0?l40?ooo`80003o1P3oool20000o`L0oooo0P000?l40?ooo`80003o1P3oool20000o`D0oooo0P00
0?l90?ooo`80003o1@3oool20000o`H0oooo0P000?l50?ooo`80003o2P3oool2000000L0oooo000E
0?ooo`030000003oool0oooo00H0oooo0P000?l60?ooo`80003o1@3oool20000o`<0oooo0P000?l6
0?ooo`80003o0`3oool20000o`H0oooo0P000?l20?ooo`80003o2@3oool20000o`X0oooo1P000?l>
0?ooo`80003o303oool20000o`@0oooo0P000?l30?ooo`80003o1P3oool20000o`@0oooo0P000?l9
0?ooo`80003o1@3oool20000o`D0oooo0`000?l40?ooo`80003o1P3oool20000o`L0oooo0P000?l4
0?ooo`80003o1P3oool30000o`@0oooo0P000?l90?ooo`80003o1@3oool20000o`H0oooo0P000?l5
0?ooo`80003o2`3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`060?oo
o`80003o1P3oool20000o`D0oooo0P000?l30?ooo`<0003o1@3oool20000o`<0oooo0P000?l60?oo
o`80003o0P3oool20000o`T0oooo0P000?l=0?ooo`80003o3`3oool20000o``0oooo0P000?l40?oo
o`80003o0`3oool30000o`D0oooo0P000?l40?ooo`<0003o1`3oool30000o`D0oooo0P000?l50?oo
o`<0003o103oool20000o`H0oooo0P000?l70?ooo`80003o103oool20000o`L0oooo0P000?l40?oo
o`80003o2@3oool20000o`@0oooo0`000?l60?ooo`80003o1@3oool20000o`/0oooo00<000000?oo
o`3oool01@3oool000L0oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`040?ooo`@0
003o1P3oool20000o`D0oooo0P000?l40?ooo`80003o1@3oool20000o`<0oooo0P000?l60?ooo`80
003o0P3oool20000o`T0oooo0P000?l=0?ooo`80003o7@3oool30000o`<0oooo0P000?l40?ooo`80
003o1@3oool20000o`D0oooo0P000?l70?ooo`80003o1P3oool20000o`D0oooo0`000?l40?ooo`80
003o1P3oool20000o`L0oooo0P000?l40?ooo`80003o1`3oool20000o`@0oooo0P000?l90?ooo`<0
003o0`3oool20000o`L0oooo0P000?l50?ooo`80003o2`3oool00`000000oooo0?ooo`050?ooo`00
1P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000103oool00`00
0000oooo0?ooo`040?ooo`@0003o1P3oool20000o`D0oooo0P000?l40?ooo`80003o1@3oool20000
o`<0oooo0P000?l60?ooo`80003o0P3oool20000o`T0oooo0P000?l=0?ooo`80003o7P3oool20000
o`<0oooo0P000?l40?ooo`80003o1@3oool20000o`D0oooo0P000?l70?ooo`80003o1P3oool20000
o`D0oooo0P000?l50?ooo`80003o1P3oool20000o`L0oooo0P000?l40?ooo`80003o1`3oool20000
o`@0oooo0P000?l:0?ooo`80003o0`3oool20000o`L0oooo0P000?l50?ooo`80003o2`3oool00`00
0000oooo0?ooo`050?ooo`002P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo
0080oooo0P0000050?ooo`80003o203oool20000o`@0oooo0`000?l40?ooo`80003o1@3oool20000
o`<0oooo0P000?l60?ooo`80003o0P3oool20000o`T0oooo0P000?l]0?ooo`80003o0`3oool20000
o`@0oooo0P000?l50?ooo`80003o1@3oool20000o`L0oooo0P000?l60?ooo`80003o1@3oool20000
o`D0oooo0P000?l60?ooo`80003o1`3oool30000o`<0oooo0P000?l70?ooo`80003o103oool20000
o`X0oooo0P000?l30?ooo`80003o1`3oool20000o`D0oooo0P000?l90?ooo`<000001`3oool000X0
oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo0P000?l80?ooo`80003o103oool20000o`D0oooo0P000?l50?ooo`80003o0`3oool20000
o`H0oooo0P000?l20?ooo`80003o2@3oool20000obd0oooo0P000?l30?ooo`80003o103oool20000
o`D0oooo0P000?l50?ooo`80003o1`3oool20000o`H0oooo0P000?l50?ooo`80003o1@3oool20000
o`H0oooo0P000?l80?ooo`80003o0`3oool20000o`L0oooo0P000?l40?ooo`80003o2P3oool20000
o`<0oooo0P000?l70?ooo`<0003o0`3oool30000o`/0oooo00<000000?ooo`3oool01@3oool000H0
oooo100000030?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0103oool20000
o`P0oooo0`000?l30?ooo`80003o1@3oool20000o`D0oooo0P000?l30?ooo`80003o1P3oool20000
o`80oooo0P000?l90?ooo`80003o;@3oool20000o`<0oooo0P000?l40?ooo`80003o1@3oool20000
o`D0oooo0P000?l70?ooo`80003o1P3oool20000o`@0oooo0`000?l50?ooo`80003o1P3oool20000
o`P0oooo0P000?l30?ooo`80003o1`3oool20000o`@0oooo0P000?l:0?ooo`80003o0`3oool20000
o`P0oooo0P000?l30?ooo`80003o303oool00`000000oooo0?ooo`050?ooo`001P3oool00`000000
oooo0?ooo`040?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0103oool20000
o`T0oooo0P000?l30?ooo`80003o1@3oool20000o`D0oooo0P000?l30?ooo`80003o1P3oool20000
o`80oooo0P000?l90?ooo`80003o;@3oool20000o`<0oooo0P000?l40?ooo`80003o1@3oool20000
o`D0oooo0P000?l70?ooo`80003o1P3oool20000o`@0oooo0P000?l60?ooo`80003o1P3oool20000
o`P0oooo0P000?l30?ooo`80003o1`3oool20000o`<0oooo0`000?l:0?ooo`80003o0P3oool30000
o`P0oooo0P000?l30?ooo`80003o303oool00`000000oooo0?ooo`050?ooo`001P3oool5000000<0
oooo0P0000050?ooo`030000003oool0oooo00@0oooo0P000?l90?ooo`80003o0`3oool20000o`D0
oooo0P000?l50?ooo`80003o0`3oool20000o`D0oooo0`000?l20?ooo`<0003o1`3oool30000obd0
oooo0P000?l30?ooo`80003o103oool20000o`D0oooo0P000?l50?ooo`80003o1`3oool20000o`H0
oooo0P000?l40?ooo`80003o1P3oool20000o`H0oooo0P000?l80?ooo`80003o0`3oool20000o`L0
oooo0P000?l30?ooo`80003o2`3oool60000o`T0oooo0P000?l30?ooo`80003o303oool00`000000
oooo0?ooo`050?ooo`005@3oool2000000D0oooo0P000?l90?ooo`80003o0`3oool20000o`D0oooo
0P000?l50?ooo`80003o0`3oool20000o`D0oooo0P000?l40?ooo`80003o1`3oool20000obh0oooo
0P000?l30?ooo`80003o103oool20000o`D0oooo0P000?l50?ooo`80003o1`3oool20000o`H0oooo
0P000?l40?ooo`80003o1P3oool20000o`H0oooo0P000?l80?ooo`80003o0`3oool20000o`L0oooo
0P000?l30?ooo`80003o2`3oool60000o`T0oooo0P000?l30?ooo`80003o2`3oool2000000L0oooo
000E0?ooo`030000003oool0oooo00@0oooo0P000?l90?ooo`80003o0`3oool20000o`D0oooo0P00
0?l50?ooo`80003o0`3oool20000o`D0oooo0P000?l40?ooo`80003o1`3oool20000obh0oooo0P00
0?l30?ooo`80003o103oool20000o`D0oooo0P000?l50?ooo`80003o1`3oool20000o`H0oooo0P00
0?l40?ooo`80003o1P3oool30000o`@0oooo0`000?l80?ooo`80003o0`3oool20000o`L0oooo0P00
0?l30?ooo`80003o2`3oool60000o`T0oooo0`000?l20?ooo`80003o303oool00`000000oooo0?oo
o`050?ooo`005@3oool00`000000oooo0?ooo`040?ooo`80003o2@3oool30000o`80oooo0P000?l5
0?ooo`80003o1@3oool20000o`<0oooo0`000?l40?ooo`80003o103oool20000o`L0oooo0P000?l^
0?ooo`<0003o0P3oool20000o`@0oooo0P000?l40?ooo`<0003o1@3oool30000o`D0oooo0`000?l6
0?ooo`80003o103oool20000o`L0oooo0P000?l40?ooo`80003o2@3oool30000o`80oooo0P000?l7
0?ooo`80003o0`3oool20000o`/0oooo1P000?l:0?ooo`80003o0P3oool20000o``0oooo00<00000
0?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0103oool20000o`X0oooo0P000?l0103o
ool0003o0000o`000?l50?ooo`80003o1@3oool20000o`@0oooo0P000?l40?ooo`80003o103oool2
0000o`L0oooo0P000?l_0?ooo`80003o0P3oool20000o`@0oooo0P000?l40?ooo`80003o1`3oool2
0000o`D0oooo0P000?l70?ooo`80003o103oool20000o`L0oooo0P000?l40?ooo`80003o2P3oool2
0000o`040?ooo`000?l0003o0000o`L0oooo0P000?l30?ooo`80003o2`3oool60000o`X0oooo0P00
0?l20?ooo`80003o303oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`04
0?ooo`80003o2P3oool20000o`030?ooo`000?l0003o00H0oooo0P000?l40?ooo`<0003o103oool2
0000o`@0oooo0P000?l40?ooo`80003o1`3oool20000obl0oooo0P000?l20?ooo`80003o103oool2
0000o`@0oooo0P000?l70?ooo`80003o1@3oool20000o`L0oooo0P000?l40?ooo`80003o1`3oool2
0000o`@0oooo0P000?l:0?ooo`80003o00<0oooo0000o`000?l0203oool20000o`<0oooo0P000?l;
0?ooo`H0003o2P3oool20000o`80oooo0P000?l<0?ooo`030000003oool0oooo00D0oooo000E0?oo
o`8000001@3oool20000o`X0oooo0P000?l00`3oool0003o0000o`060?ooo`80003o103oool20000
o`D0oooo0P000?l40?ooo`80003o103oool20000o`L0oooo0P000?l_0?ooo`80003o00@0oooo0000
o`000?l0003o103oool20000o`@0oooo0P000?l70?ooo`80003o1@3oool20000o`L0oooo0P000?l4
0?ooo`80003o1`3oool20000o`@0oooo0P000?l:0?ooo`80003o00<0oooo0000o`000?l0203oool2
0000o`<0oooo0P000?l<0?ooo`D0003o2P3oool20000o`80oooo0P000?l;0?ooo`8000001`3oool0
01D0oooo00<000000?ooo`3oool0103oool20000o`X0oooo1@000?l60?ooo`80003o103oool20000
o`D0oooo0P000?l40?ooo`80003o103oool20000o`L0oooo0P000?l_0?ooo`80003o00<0oooo0000
o`000?l01@3oool20000o`@0oooo0P000?l70?ooo`80003o1@3oool20000o`L0oooo0P000?l40?oo
o`80003o1`3oool20000o`@0oooo0P000?l:0?ooo`80003o00<0oooo0000o`000?l0203oool20000
o`<0oooo0P000?l<0?ooo`@0003o2`3oool20000o`80oooo0P000?l<0?ooo`030000003oool0oooo
00D0oooo000E0?ooo`030000003oool0oooo00@0oooo0P000?l;0?ooo`@0003o1P3oool30000o`<0
oooo0P000?l50?ooo`80003o103oool20000o`@0oooo0P000?l60?ooo`<0003o;`3oool20000o`03
0?ooo`000?l0003o00D0oooo0P000?l40?ooo`80003o1`3oool20000o`@0oooo0`000?l70?ooo`80
003o103oool20000o`L0oooo0P000?l40?ooo`80003o2P3oool50000o`P0oooo0P000?l30?ooo`80
003o303oool40000o`/0oooo0P000?l20?ooo`80003o303oool00`000000oooo0?ooo`050?ooo`00
5@3oool00`000000oooo0?ooo`040?ooo`80003o2`3oool40000o`L0oooo0P000?l30?ooo`80003o
1@3oool20000o`@0oooo0P000?l40?ooo`80003o1P3oool20000oc00oooo0P000?l00`3oool0003o
0000o`050?ooo`80003o103oool20000o`L0oooo0P000?l40?ooo`80003o203oool20000o`@0oooo
0P000?l70?ooo`80003o103oool20000o`/0oooo10000?l80?ooo`80003o0`3oool20000o``0oooo
10000?l;0?ooo`80003o0P3oool20000o``0oooo00<000000?ooo`3oool01@3oool001D0oooo0P00
00050?ooo`80003o2`3oool40000o`L0oooo0P000?l30?ooo`80003o1@3oool20000o`@0oooo0P00
0?l40?ooo`80003o1P3oool20000oc00oooo0P000?l00`3oool0003o0000o`050?ooo`80003o103o
ool20000o`L0oooo0P000?l40?ooo`80003o203oool20000o`<0oooo0`000?l70?ooo`80003o103o
ool20000o`/0oooo10000?l80?ooo`<0003o0P3oool20000o``0oooo0P000?l=0?ooo`80003o0P3o
ool20000o`/0oooo0P0000070?ooo`005@3oool00`000000oooo0?ooo`040?ooo`80003o2`3oool4
0000o`L0oooo0P000?l30?ooo`80003o1@3oool20000o`@0oooo0P000?l40?ooo`80003o1@3oool3
0000oc00oooo1@000?l50?ooo`80003o103oool20000o`L0oooo0P000?l40?ooo`80003o203oool2
0000o`<0oooo0P000?l80?ooo`80003o103oool20000oaP0oooo0P000?l20?ooo`80003o6`3oool2
0000o`80oooo0P000?l<0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo
00<0oooo0`000?l;0?ooo`@0003o1`3oool20000o`<0oooo0P000?l50?ooo`80003o103oool20000
o`@0oooo0P000?l50?ooo`80003o<P3oool40000o`D0oooo0P000?l40?ooo`80003o1`3oool20000
o`<0oooo0`000?l80?ooo`80003o0`3oool20000o`P0oooo0P000?l40?ooo`80003o603oool20000
o`80oooo0P000?lK0?ooo`80003o0P3oool20000o``0oooo00<000000?ooo`3oool01@3oool001D0
oooo00<000000?ooo`3oool00`3oool20000o``0oooo10000?l70?ooo`80003o0`3oool20000o`D0
oooo0P000?l40?ooo`80003o103oool20000o`D0oooo0P000?lb0?ooo`@0003o1@3oool20000o`@0
oooo0P000?l70?ooo`80003o0`3oool20000o`T0oooo0P000?l30?ooo`80003o203oool20000o`@0
oooo0P000?lH0?ooo`80003o00@0oooo0000o`000?l0003o6`3oool20000o`80oooo0P000?l<0?oo
o`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00<0oooo0P000?l<0?ooo`@0
003o1`3oool20000o`<0oooo0P000?l50?ooo`80003o103oool20000o`@0oooo0P000?l50?ooo`80
003o<P3oool40000o`D0oooo0P000?l40?ooo`80003o1`3oool20000o`<0oooo0P000?l90?ooo`80
003o0`3oool20000o`P0oooo0P000?l40?ooo`80003o603oool20000o`030?ooo`000?l0003o01`0
oooo0P000?l0103oool0003o0000o`000?l<0?ooo`030000003oool0oooo00D0oooo000E0?ooo`80
0000103oool20000o``0oooo10000?l70?ooo`80003o0`3oool20000o`D0oooo0P000?l40?ooo`80
003o103oool20000o`D0oooo0P000?lc0?ooo`<0003o1@3oool20000o`@0oooo0P000?l70?ooo`80
003o0`3oool20000o`T0oooo0P000?l30?ooo`80003o203oool20000o`@0oooo0P000?lH0?ooo`80
003o00<0oooo0000o`000?l0703oool20000o`030?ooo`000?l0003o00`0oooo0P0000070?ooo`00
5@3oool00`000000oooo0?ooo`030?ooo`80003o303oool40000o`L0oooo0P000?l30?ooo`80003o
1@3oool20000o`@0oooo0P000?l40?ooo`80003o1@3oool20000oc<0oooo0`000?l50?ooo`80003o
103oool20000o`L0oooo0P000?l30?ooo`80003o2@3oool20000o`<0oooo0P000?l80?ooo`80003o
103oool20000oaP0oooo0P000?l00`3oool0003o0000o`0L0?ooo`80003o00<0oooo0000o`000?l0
3@3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`030?ooo`80003o303o
ool40000o`L0oooo0P000?l30?ooo`80003o1@3oool20000o`@0oooo0P000?l40?ooo`80003o1@3o
ool20000oc@0oooo0P000?l50?ooo`80003o103oool20000o`L0oooo0P000?l30?ooo`80003o2@3o
ool20000o`<0oooo0P000?l80?ooo`80003o103oool20000oaP0oooo0P000?l00`3oool0003o0000
o`0L0?ooo`80003o00<0oooo0000o`000?l03@3oool00`000000oooo0?ooo`050?ooo`00203oool0
0`000000oooo0?ooo`020?ooo`<000001@3oool00`000000oooo0?ooo`030?ooo`80003o303oool4
0000o`L0oooo0P000?l30?ooo`80003o1@3oool20000o`<0oooo0`000?l40?ooo`80003o1@3oool2
0000oc/0oooo0P000?l40?ooo`80003o1`3oool20000o`<0oooo0P000?l90?ooo`80003o0`3oool2
0000o`P0oooo0P000?l40?ooo`80003o603oool20000o`030?ooo`000?l0003o01`0oooo0P000?l0
0`3oool0003o0000o`0=0?ooo`030000003oool0oooo00D0oooo00080?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo0P000?l<
0?ooo`@0003o1`3oool20000o`<0oooo0P000?l50?ooo`80003o0`3oool20000o`D0oooo0P000?l5
0?ooo`80003o>`3oool20000o`@0oooo0P000?l70?ooo`80003o0`3oool20000o`T0oooo0P000?l2
0?ooo`<0003o203oool20000o`@0oooo0P000?lH0?ooo`80003o00<0oooo0000o`000?l0703oool2
0000o`030?ooo`000?l0003o00d0oooo00<000000?ooo`3oool01@3oool000T0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`020?ooo`800000103oool20000o``0oooo0`000?l80?oo
o`80003o0P3oool30000o`D0oooo0P000?l30?ooo`80003o1@3oool20000o`D0oooo0P000?lk0?oo
o`80003o0`3oool30000o`L0oooo0P000?l30?ooo`80003o2@3oool30000o`030?ooo`000?l0003o
00T0oooo0P000?l40?ooo`80003o603oool50000oa`0oooo0P000?l00`3oool0003o0000o`0;0?oo
o`<000001`3oool000T0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00<0oooo0P000?l=0?ooo`80003o203oool20000o`80oooo0P000?l60?ooo`80
003o0`3oool20000o`D0oooo0P000?l50?ooo`80003o>`3oool20000o`<0oooo0P000?l80?ooo`80
003o0`3oool20000o`X0oooo0P000?l00`3oool0003o0000o`090?ooo`80003o0`3oool30000oaP0
oooo10000?lM0?ooo`80003o00<0oooo0000o`000?l03@3oool00`000000oooo0?ooo`050?ooo`00
2P3oool00`000000oooo00000003000000D0oooo00<000000?ooo`3oool00`3oool20000o`d0oooo
0P000?l80?ooo`80003o0P3oool20000o`H0oooo0P000?l30?ooo`80003o1@3oool20000o`D0oooo
0P000?lk0?ooo`80003o0`3oool20000o`P0oooo0P000?l30?ooo`80003o2P3oool20000o`030?oo
o`000?l0003o00T0oooo0P000?l30?ooo`80003o6@3oool40000oad0oooo1@000?l=0?ooo`030000
003oool0oooo00D0oooo00060?ooo`070000003oool0oooo0?ooo`000000oooo000000080?ooo`03
0000003oool0oooo00<0oooo0P000?l=0?ooo`80003o203oool20000o`80oooo0P000?l60?ooo`80
003o0`3oool20000o`D0oooo0P000?l50?ooo`80003o>`3oool20000o`<0oooo0P000?l80?ooo`80
003o0`3oool20000o`X0oooo0P000?l00`3oool0003o0000o`090?ooo`80003o0`3oool20000oaT0
oooo10000?lM0?ooo`@0003o3P3oool00`000000oooo0?ooo`050?ooo`001P3oool5000000030?oo
o`000000000000<00000103oool00`000000oooo0?ooo`030?ooo`80003o3@3oool20000o`P0oooo
0P000?l20?ooo`80003o1P3oool20000o`<0oooo0P000?l50?ooo`80003o103oool30000oc/0oooo
0P000?l30?ooo`80003o203oool20000o`<0oooo0P000?l:0?ooo`80003o00<0oooo0000o`000?l0
2@3oool20000o`<0oooo0P000?lI0?ooo`@0003o7@3oool40000o`h0oooo00<000000?ooo`3oool0
1@3oool001D0oooo0P0000040?ooo`80003o3@3oool20000o`P0oooo0P000?l20?ooo`80003o1P3o
ool20000o`<0oooo0P000?l50?ooo`80003o103oool20000oc`0oooo0P000?l30?ooo`80003o203o
ool20000o`<0oooo0P000?l:0?ooo`80003o00<0oooo0000o`000?l02@3oool20000o`<0oooo0P00
0?lI0?ooo`@0003o7@3oool40000o`d0oooo0P0000070?ooo`005@3oool00`000000oooo0?ooo`02
0?ooo`<0003o3@3oool20000o`P0oooo0P000?l20?ooo`80003o1P3oool20000o`80oooo0`000?l5
0?ooo`80003o103oool20000oc`0oooo0P000?l30?ooo`80003o203oool30000o`80oooo0P000?l:
0?ooo`80003o00<0oooo0000o`000?l02@3oool20000o`<0oooo0P000?lJ0?ooo`<0003o7@3oool4
0000o`h0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool00P3oool30000
o`d0oooo0P000?l80?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o1P3oool20000
o`@0oooo0P000?ll0?ooo`80003o0`3oool20000o`T0oooo0P000?l0103oool0003o0000o`000?l:
0?ooo`80003o00<0oooo0000o`000?l02@3oool20000o`<0oooo0P000?lJ0?ooo`<0003o7P3oool3
0000o`h0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool00P3oool30000
o`d0oooo0P000?l80?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o1P3oool20000
o`@0oooo0P000?ll0?ooo`80003o0`3oool20000o`T0oooo0P000?l00`3oool0003o0000o`0;0?oo
o`80003o00<0oooo0000o`000?l02@3oool20000o`<0oooo0P000?lJ0?ooo`80003o7`3oool30000
o`h0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool00`3oool20000o`d0
oooo0P000?l80?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o1P3oool20000o`@0
oooo0P000?ll0?ooo`80003o0`3oool20000o`T0oooo0P000?l00`3oool0003o0000o`0;0?ooo`80
003o00<0oooo0000o`000?l02@3oool20000o`<0oooo0P000?lJ0?ooo`80003o7`3oool30000o`h0
oooo00<000000?ooo`3oool01@3oool001D0oooo0P00000C0?ooo`80003o203oool20000o`80oooo
0P000?l60?ooo`80003o0P3oool20000o`H0oooo0P000?l40?ooo`80003o?03oool20000o`<0oooo
0P000?l90?ooo`80003o00<0oooo0000o`000?l02`3oool20000o`030?ooo`000?l0003o00T0oooo
0P000?l30?ooo`80003o6P3oool20000oal0oooo0`000?l=0?ooo`8000001`3oool001D0oooo00<0
00000?ooo`3oool04P3oool20000o`P0oooo0P000?l20?ooo`80003o1P3oool20000o`80oooo0P00
0?l60?ooo`80003o103oool20000oc`0oooo0P000?l30?ooo`80003o2@3oool20000o`030?ooo`00
0?l0003o00/0oooo0P000?l00`3oool0003o0000o`090?ooo`80003o0`3oool20000oaX0oooo0P00
0?lO0?ooo`<0003o3P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0L
0?ooo`80003o00@0oooo0000o`000?l0003o1P3oool20000o`80oooo0P000?l60?ooo`80003o103o
ool20000oc`0oooo0P000?l30?ooo`80003o2@3oool20000o`030?ooo`000?l0003o00/0oooo1@00
0?l90?ooo`80003o0`3oool20000oc/0oooo0`000?l>0?ooo`030000003oool0oooo00D0oooo000E
0?ooo`030000003oool0oooo01`0oooo1@000?l70?ooo`80003o0P3oool20000o`H0oooo0P000?l4
0?ooo`80003o?03oool20000o`<0oooo0P000?l90?ooo`80003o00<0oooo0000o`000?l02`3oool4
0000o`X0oooo0P000?l30?ooo`80003o>`3oool30000o`h0oooo00<000000?ooo`3oool01@3oool0
01D0oooo0P00000N0?ooo`@0003o1`3oool20000o`80oooo0P000?l60?ooo`80003o103oool20000
oc`0oooo0P000?l30?ooo`80003o2@3oool20000o`030?ooo`000?l0003o00/0oooo10000?l:0?oo
o`80003o0`3oool20000oc/0oooo0`000?l=0?ooo`8000001`3oool001D0oooo00<000000?ooo`3o
ool07@3oool40000o`L0oooo0P000?l20?ooo`80003o1P3oool20000o`@0oooo0P000?ll0?ooo`<0
003o0P3oool20000o`T0oooo0P000?l00`3oool0003o0000o`0;0?ooo`@0003o2P3oool20000o`<0
oooo0P000?lk0?ooo`<0003o3P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo
0?ooo`0M0?ooo`@0003o1`3oool20000o`80oooo0P000?l60?ooo`80003o103oool20000ocd0oooo
0P000?l20?ooo`80003o2@3oool20000o`030?ooo`000?l0003o00/0oooo10000?l:0?ooo`<0003o
0P3oool20000oc/0oooo0`000?l>0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003o
ool0oooo01d0oooo10000?l70?ooo`80003o0P3oool20000o`H0oooo0P000?l40?ooo`80003o?@3o
ool20000o`80oooo0P000?l90?ooo`80003o00<0oooo0000o`000?l02`3oool40000o`/0oooo0P00
0?l20?ooo`80003o>`3oool30000o`h0oooo00<000000?ooo`3oool01@3oool001D0oooo00<00000
0?ooo`3oool07@3oool40000o`L0oooo0P000?l20?ooo`80003o1P3oool20000o`@0oooo0P000?lm
0?ooo`80003o0P3oool20000o`T0oooo0P000?l00`3oool0003o0000o`0;0?ooo`@0003o2`3oool2
0000o`040?ooo`000?l0003o0000oc/0oooo0P000?l?0?ooo`030000003oool0oooo00D0oooo000E
0?ooo`8000007P3oool40000o`L0oooo0P000?l20?ooo`80003o1P3oool20000o`@0oooo0P000?lm
0?ooo`80003o00@0oooo0000o`000?l0003o2@3oool20000o`030?ooo`000?l0003o00/0oooo1000
0?l;0?ooo`80003o00<0oooo0000o`000?l0?03oool20000o`h0oooo0P0000070?ooo`005@3oool0
0`000000oooo0?ooo`0M0?ooo`@0003o1`3oool20000o`80oooo0P000?l60?ooo`80003o103oool2
0000ocd0oooo0P000?l00`3oool0003o0000o`0:0?ooo`80003o00<0oooo0000o`000?l0303oool3
0000o`/0oooo0P000?l00`3oool0003o0000o`0l0?ooo`80003o3`3oool00`000000oooo0?ooo`05
0?ooo`005@3oool00`000000oooo0?ooo`0M0?ooo`@0003o1`3oool20000o`80oooo0P000?l60?oo
o`<0003o0`3oool20000ocd0oooo0P000?l00`3oool0003o0000o`0:0?ooo`80003o00<0oooo0000
o`000?l03@3oool20000o`/0oooo0P000?l00`3oool0003o0000o`0l0?ooo`80003o3`3oool00`00
0000oooo0?ooo`050?ooo`0000@0oooo0000000000000000103oool2000000@0oooo0P0000050?oo
o`030000003oool0oooo01d0oooo0`000?l80?ooo`80003o0P3oool20000o`L0oooo0P000?l20?oo
o`<0003o?@3oool20000o`030?ooo`000?l0003o00X0oooo0P000?l00`3oool0003o0000o`0J0?oo
o`80003o00<0oooo0000o`000?l0?03oool20000o`l0oooo00<000000?ooo`3oool01@3oool00080
oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000000@0oooo00<000000?ooo`3oool07@3oool30000o`P0oooo0P000?l20?ooo`80003o1`3oool2
0000o`80oooo0P000?ln0?ooo`80003o00<0oooo0000o`000?l02P3oool20000o`030?ooo`000?l0
003o01X0oooo0P000?l00`3oool0003o0000o`0l0?ooo`80003o3`3oool00`000000oooo0?ooo`05
0?ooo`000P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool00000103oool2000001h0oooo0`000?l80?ooo`80003o0P3oool20000o`L0oooo0P00
0?l20?ooo`80003o?P3oool20000o`030?ooo`000?l0003o00X0oooo0P000?l00`3oool0003o0000
o`0J0?ooo`80003o00<0oooo0000o`000?l0?03oool20000o`d0oooo0`0000070?ooo`000P3oool0
0`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
103oool00`000000oooo0?ooo`0M0?ooo`<0003o203oool20000o`80oooo0P000?l70?ooo`80003o
0P3oool20000och0oooo0P000?l00`3oool0003o0000o`0:0?ooo`80003o00<0oooo0000o`000?l0
6P3oool20000o`030?ooo`000?l0003o03`0oooo0P000?l?0?ooo`030000003oool0oooo00D0oooo
00020?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000040?ooo`030000003oool0oooo01d0oooo0`000?l80?ooo`80003o0P3oool20000o`L0
oooo0P000?l20?ooo`80003o?P3oool20000o`030?ooo`000?l0003o00X0oooo0P000?l00`3oool0
003o0000o`0J0?ooo`80003o00<0oooo0000o`000?l0?03oool20000o`l0oooo00<000000?ooo`3o
ool01@3oool000030?ooo`000000000000@0oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`0000040?ooo`030000003oool0oooo01d0oooo0`000?l80?ooo`80003o0P3oool20000
o`L0oooo0P000?l20?ooo`80003o?P3oool20000o`030?ooo`000?l0003o00X0oooo0P000?l00`3o
ool0003o0000o`0J0?ooo`80003o00<0oooo0000o`000?l0?03oool20000o`l0oooo00<000000?oo
o`3oool01@3oool00080oooo00<000000?ooo`3oool00`3oool2000000@0oooo0P0000050?ooo`03
0000003oool0oooo01d0oooo0`000?l80?ooo`80003o0P3oool20000o`L0oooo0P000?l20?ooo`80
003o?P3oool20000o`030?ooo`000?l0003o00X0oooo1@000?lJ0?ooo`80003o00<0oooo0000o`00
0?l0?03oool20000o`l0oooo00<000000?ooo`3oool01@3oool001D0oooo0P00000N0?ooo`80003o
2@3oool20000o`80oooo0P000?l70?ooo`80003o0P3oool20000och0oooo0P000?l00`3oool0003o
0000o`0:0?ooo`@0003o6`3oool20000o`030?ooo`000?l0003o03`0oooo0P000?l>0?ooo`800000
1`3oool001D0oooo00<000000?ooo`3oool07@3oool20000o`T0oooo0P000?l0103oool0003o0000
o`000?l70?ooo`80003o0P3oool20000och0oooo0P000?l00`3oool0003o0000o`0:0?ooo`@0003o
6`3oool20000o`030?ooo`000?l0003o04d0oooo00<000000?ooo`3oool01@3oool001D0oooo00<0
00000?ooo`3oool07@3oool20000o`T0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o0P3o
ool20000och0oooo0P000?l00`3oool0003o0000o`0:0?ooo`@0003o6`3oool50000odd0oooo00<0
00000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0:03oool20000o`030?ooo`000?l0
003o00P0oooo0P000?l20?ooo`80003o?P3oool20000o`030?ooo`000?l0003o00X0oooo10000?lK
0?ooo`@0003oCP3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0X0?oo
o`80003o00<0oooo0000o`000?l0203oool20000o`80oooo0P000?ln0?ooo`80003o00<0oooo0000
o`000?l02P3oool40000oa/0oooo10000?m>0?ooo`030000003oool0oooo00D0oooo000E0?ooo`80
0000:@3oool20000o`030?ooo`000?l0003o00P0oooo0P000?l20?ooo`80003o?P3oool20000o`03
0?ooo`000?l0003o00X0oooo10000?lK0?ooo`@0003oC@3oool2000000L0oooo000E0?ooo`030000
003oool0oooo02P0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o00@0oooo0000o`000?l0
003o?P3oool20000o`030?ooo`000?l0003o00X0oooo10000?lK0?ooo`@0003oCP3oool00`000000
oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0X0?ooo`80003o00<0oooo0000o`000?l0
203oool20000o`030?ooo`000?l0003o03l0oooo1@000?l:0?ooo`@0003o6`3oool40000odh0oooo
00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0:03oool20000o`030?ooo`00
0?l0003o00P0oooo0P000?l00`3oool0003o0000o`0o0?ooo`@0003o303oool30000oa/0oooo1000
0?m>0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000:@3oool20000o`030?ooo`000?l0
003o00P0oooo0P000?l00`3oool0003o0000o`0o0?ooo`@0003o303oool30000oa/0oooo10000?m=
0?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool0:03oool20000o`030?ooo`000?l0003o
00P0oooo0P000?l00`3oool0003o0000o`0o0?ooo`@0003o303oool30000oa/0oooo10000?m>0?oo
o`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo02P0oooo0P000?l00`3oool0
003o0000o`080?ooo`80003o00<0oooo0000o`000?l0?`3oool40000o``0oooo0`000?lK0?ooo`@0
003oCP3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0X0?ooo`80003o
00<0oooo0000o`000?l0203oool20000o`030?ooo`000?l0003o03l0oooo10000?l<0?ooo`<0003o
6`3oool40000odh0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0:03o
ool20000o`030?ooo`000?l0003o00P0oooo0P000?l00`3oool0003o0000o`0o0?ooo`@0003o303o
ool20000oa`0oooo10000?m>0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000:@3oool2
0000o`030?ooo`000?l0003o00P0oooo0P000?l00`3oool0003o0000o`0o0?ooo`@0003o303oool2
0000oa`0oooo10000?m=0?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool0:03oool20000
o`030?ooo`000?l0003o00P0oooo1@000?lo0?ooo`@0003o303oool20000oa`0oooo10000?m>0?oo
o`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo02P0oooo0P000?l00`3oool0
003o0000o`090?ooo`@0003o?`3oool40000o``0oooo0P000?lL0?ooo`@0003oCP3oool00`000000
oooo0?ooo`050?ooo`0000@0oooo00000000000000000P3oool500000080oooo0`0000050?ooo`03
0000003oool0oooo02P0oooo0P000?l00`3oool0003o0000o`090?ooo`@0003o?`3oool40000o``0
oooo0P000?lL0?ooo`@0003oCP3oool00`000000oooo0?ooo`050?ooo`000P3oool00`000000oooo
0?ooo`020?ooo`060000003oool0oooo0000003oool000000`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo02P0oooo1@000?l90?ooo`@0003o?`3oool40000o``0oooo0P000?lL0?oo
o`@0003oCP3oool00`000000oooo0?ooo`050?ooo`000P3oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool2000002X0oooo10000?l90?ooo`@0
003o?`3oool40000o``0oooo0P000?lM0?ooo`<0003oC03oool3000000L0oooo00020?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo02T0oooo10000?l90?ooo`<0003o@03oool40000ob/0oooo0`000?m>0?ooo`030000
003oool0oooo00D0oooo00020?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
00000003000000D0oooo00<000000?ooo`3oool0:@3oool40000o`T0oooo0`000?m00?ooo`@0003o
:`3oool20000odl0oooo00<000000?ooo`3oool01@3oool000030?ooo`000000000000<0oooo00L0
00000?ooo`3oool0oooo0000003oool0000000P0oooo00<000000?ooo`3oool0:@3oool40000o`T0
oooo0`000?m00?ooo`@0003o:`3oool20000odl0oooo00<000000?ooo`3oool01@3oool00080oooo
00<000000?ooo`3oool00P3oool300000080oooo1@0000040?ooo`030000003oool0oooo02T0oooo
10000?l90?ooo`<0003o@03oool40000ob/0oooo0P000?m?0?ooo`030000003oool0oooo00D0oooo
000E0?ooo`800000:P3oool40000o`T0oooo0`000?m00?ooo`@0003o:`3oool20000odh0oooo0P00
00070?ooo`005@3oool00`000000oooo0?ooo`0Y0?ooo`@0003o2@3oool30000od00oooo0`000?l/
0?ooo`80003oC`3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0Y0?oo
o`@0003o2@3oool30000od40oooo0P000?l/0?ooo`80003oC`3oool00`000000oooo0?ooo`050?oo
o`005@3oool00`000000oooo0?ooo`0Y0?ooo`@0003o2@3oool20000od80oooo0P000?l/0?ooo`80
003oC`3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0Y0?ooo`@0003o
C@3oool20000ob`0oooo0P000?m?0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000:P3o
ool30000odh0oooo0P000?l/0?ooo`80003oCP3oool2000000L0oooo000E0?ooo`030000003oool0
oooo02T0oooo0`000?m>0?ooo`80003o;03oool20000odl0oooo00<000000?ooo`3oool01@3oool0
01D0oooo00<000000?ooo`3oool0:@3oool30000odh0oooo0P000?l/0?ooo`80003oC`3oool00`00
0000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0Y0?ooo`<0003oCP3oool20000ob`0
oooo0P000?m?0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000:P3oool30000odh0oooo
0P000?l/0?ooo`80003oCP3oool2000000L0oooo000E0?ooo`030000003oool0oooo02T0oooo0`00
0?ml0?ooo`80003oC`3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0Y
0?ooo`<0003oc@3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0Y0?oo
o`<0003oc@3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0Y0?ooo`<0
003oc@3oool00`000000oooo0?ooo`050?ooo`005@3oool2000002X0oooo0`000?o<0?ooo`800000
1`3oool001D0oooo00<000000?ooo`3oool0:@3oool30000old0oooo00<000000?ooo`3oool01@3o
ool001D0oooo00<000000?ooo`3oool0:@3oool30000old0oooo00<000000?ooo`3oool01@3oool0
00040?ooo`0000000000000000<0oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`0Y
0?ooo`<0003oc@3oool00`000000oooo0?ooo`050?ooo`000P3oool01@000000oooo0?ooo`3oool0
000000<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo02T0oooo0P000?o>0?ooo`030000003oool0oooo00D0oooo00020?ooo`030000003oool0
oooo00D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`800000:P3o
ool20000ol`0oooo0`0000070?ooo`000P3oool00`000000oooo0?ooo`050?ooo`040000003oool0
oooo00000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0Y0?ooo`80003ocP3o
ool00`000000oooo0?ooo`050?ooo`000P3oool010000000oooo0?ooo`3oool4000000<0oooo00@0
00000?ooo`3oool00000103oool00`000000oooo0?ooo`0Y0?ooo`80003ocP3oool00`000000oooo
0?ooo`050?ooo`0000<0oooo0000000000000`3oool00`000000oooo0?ooo`040?ooo`040000003o
ool0oooo000000@0oooo00<000000?ooo`3oool0:@3oool20000olh0oooo00<000000?ooo`3oool0
1@3oool00080oooo00@000000?ooo`3oool0oooo1@0000030?ooo`8000001@3oool00`000000oooo
0?ooo`0Y0?ooo`80003ocP3oool00`000000oooo0?ooo`050?ooo`005@3oool2000002X0oooo0P00
0?o=0?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`050?ooo`005@3oooom000000L0oooo003o0?oooaX0oooo
003o0?oooaX0oooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {1729.2, -19.1325, \
0.729416, 1.04129}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{55, 2}\),
      SequenceForm[ "Dimension der Daten  ", {55, 2}],
      Editable->False]], "Print"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-33.9268 0.0176367 0.000776146 0.00316794 [
[.11199 -0.0125 -12 -9 ]
[.11199 -0.0125 12 0 ]
[.28836 -0.0125 -12 -9 ]
[.28836 -0.0125 12 0 ]
[.46473 -0.0125 -12 -9 ]
[.46473 -0.0125 12 0 ]
[.64109 -0.0125 -12 -9 ]
[.64109 -0.0125 12 0 ]
[.81746 -0.0125 -12 -9 ]
[.81746 -0.0125 12 0 ]
[.99383 -0.0125 -12 -9 ]
[.99383 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00078 -6 -4.5 ]
[-0.0125 .00078 0 4.5 ]
[-0.0125 .07997 -12 -4.5 ]
[-0.0125 .07997 0 4.5 ]
[-0.0125 .15917 -12 -4.5 ]
[-0.0125 .15917 0 4.5 ]
[-0.0125 .23837 -12 -4.5 ]
[-0.0125 .23837 0 4.5 ]
[-0.0125 .31757 -18 -4.5 ]
[-0.0125 .31757 0 4.5 ]
[-0.0125 .39677 -18 -4.5 ]
[-0.0125 .39677 0 4.5 ]
[-0.0125 .47597 -18 -4.5 ]
[-0.0125 .47597 0 4.5 ]
[-0.0125 .55517 -18 -4.5 ]
[-0.0125 .55517 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .49307 -5 -6 ]
[.97619 .49307 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11199 0 m
.11199 .00625 L
s
[(1930)] .11199 -0.0125 0 1 Mshowa
.28836 0 m
.28836 .00625 L
s
[(1940)] .28836 -0.0125 0 1 Mshowa
.46473 0 m
.46473 .00625 L
s
[(1950)] .46473 -0.0125 0 1 Mshowa
.64109 0 m
.64109 .00625 L
s
[(1960)] .64109 -0.0125 0 1 Mshowa
.81746 0 m
.81746 .00625 L
s
[(1970)] .81746 -0.0125 0 1 Mshowa
.99383 0 m
.99383 .00625 L
s
[(1980)] .99383 -0.0125 0 1 Mshowa
.125 Mabswid
.14727 0 m
.14727 .00375 L
s
.18254 0 m
.18254 .00375 L
s
.21781 0 m
.21781 .00375 L
s
.25309 0 m
.25309 .00375 L
s
.32363 0 m
.32363 .00375 L
s
.35891 0 m
.35891 .00375 L
s
.39418 0 m
.39418 .00375 L
s
.42945 0 m
.42945 .00375 L
s
.5 0 m
.5 .00375 L
s
.53527 0 m
.53527 .00375 L
s
.57055 0 m
.57055 .00375 L
s
.60582 0 m
.60582 .00375 L
s
.67637 0 m
.67637 .00375 L
s
.71164 0 m
.71164 .00375 L
s
.74691 0 m
.74691 .00375 L
s
.78219 0 m
.78219 .00375 L
s
.85273 0 m
.85273 .00375 L
s
.88801 0 m
.88801 .00375 L
s
.92328 0 m
.92328 .00375 L
s
.95855 0 m
.95855 .00375 L
s
.07672 0 m
.07672 .00375 L
s
.04145 0 m
.04145 .00375 L
s
.00617 0 m
.00617 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00078 m
.00625 .00078 L
s
[(0)] -0.0125 .00078 1 0 Mshowa
0 .07997 m
.00625 .07997 L
s
[(25)] -0.0125 .07997 1 0 Mshowa
0 .15917 m
.00625 .15917 L
s
[(50)] -0.0125 .15917 1 0 Mshowa
0 .23837 m
.00625 .23837 L
s
[(75)] -0.0125 .23837 1 0 Mshowa
0 .31757 m
.00625 .31757 L
s
[(100)] -0.0125 .31757 1 0 Mshowa
0 .39677 m
.00625 .39677 L
s
[(125)] -0.0125 .39677 1 0 Mshowa
0 .47597 m
.00625 .47597 L
s
[(150)] -0.0125 .47597 1 0 Mshowa
0 .55517 m
.00625 .55517 L
s
[(175)] -0.0125 .55517 1 0 Mshowa
.125 Mabswid
0 .01662 m
.00375 .01662 L
s
0 .03246 m
.00375 .03246 L
s
0 .0483 m
.00375 .0483 L
s
0 .06414 m
.00375 .06414 L
s
0 .09581 m
.00375 .09581 L
s
0 .11165 m
.00375 .11165 L
s
0 .12749 m
.00375 .12749 L
s
0 .14333 m
.00375 .14333 L
s
0 .17501 m
.00375 .17501 L
s
0 .19085 m
.00375 .19085 L
s
0 .20669 m
.00375 .20669 L
s
0 .22253 m
.00375 .22253 L
s
0 .25421 m
.00375 .25421 L
s
0 .27005 m
.00375 .27005 L
s
0 .28589 m
.00375 .28589 L
s
0 .30173 m
.00375 .30173 L
s
0 .33341 m
.00375 .33341 L
s
0 .34925 m
.00375 .34925 L
s
0 .36509 m
.00375 .36509 L
s
0 .38093 m
.00375 .38093 L
s
0 .41261 m
.00375 .41261 L
s
0 .42845 m
.00375 .42845 L
s
0 .44429 m
.00375 .44429 L
s
0 .46013 m
.00375 .46013 L
s
0 .49181 m
.00375 .49181 L
s
0 .50765 m
.00375 .50765 L
s
0 .52349 m
.00375 .52349 L
s
0 .53933 m
.00375 .53933 L
s
0 .57101 m
.00375 .57101 L
s
0 .58685 m
.00375 .58685 L
s
0 .60269 m
.00375 .60269 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.11199 .61178 m
.11199 .61803 L
s
.28836 .61178 m
.28836 .61803 L
s
.46473 .61178 m
.46473 .61803 L
s
.64109 .61178 m
.64109 .61803 L
s
.81746 .61178 m
.81746 .61803 L
s
.99383 .61178 m
.99383 .61803 L
s
.125 Mabswid
.14727 .61428 m
.14727 .61803 L
s
.18254 .61428 m
.18254 .61803 L
s
.21781 .61428 m
.21781 .61803 L
s
.25309 .61428 m
.25309 .61803 L
s
.32363 .61428 m
.32363 .61803 L
s
.35891 .61428 m
.35891 .61803 L
s
.39418 .61428 m
.39418 .61803 L
s
.42945 .61428 m
.42945 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.53527 .61428 m
.53527 .61803 L
s
.57055 .61428 m
.57055 .61803 L
s
.60582 .61428 m
.60582 .61803 L
s
.67637 .61428 m
.67637 .61803 L
s
.71164 .61428 m
.71164 .61803 L
s
.74691 .61428 m
.74691 .61803 L
s
.78219 .61428 m
.78219 .61803 L
s
.85273 .61428 m
.85273 .61803 L
s
.88801 .61428 m
.88801 .61803 L
s
.92328 .61428 m
.92328 .61803 L
s
.95855 .61428 m
.95855 .61803 L
s
.07672 .61428 m
.07672 .61803 L
s
.04145 .61428 m
.04145 .61803 L
s
.00617 .61428 m
.00617 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00078 m
1 .00078 L
s
.99375 .07997 m
1 .07997 L
s
.99375 .15917 m
1 .15917 L
s
.99375 .23837 m
1 .23837 L
s
.99375 .31757 m
1 .31757 L
s
.99375 .39677 m
1 .39677 L
s
.99375 .47597 m
1 .47597 L
s
.99375 .55517 m
1 .55517 L
s
.125 Mabswid
.99625 .01662 m
1 .01662 L
s
.99625 .03246 m
1 .03246 L
s
.99625 .0483 m
1 .0483 L
s
.99625 .06414 m
1 .06414 L
s
.99625 .09581 m
1 .09581 L
s
.99625 .11165 m
1 .11165 L
s
.99625 .12749 m
1 .12749 L
s
.99625 .14333 m
1 .14333 L
s
.99625 .17501 m
1 .17501 L
s
.99625 .19085 m
1 .19085 L
s
.99625 .20669 m
1 .20669 L
s
.99625 .22253 m
1 .22253 L
s
.99625 .25421 m
1 .25421 L
s
.99625 .27005 m
1 .27005 L
s
.99625 .28589 m
1 .28589 L
s
.99625 .30173 m
1 .30173 L
s
.99625 .33341 m
1 .33341 L
s
.99625 .34925 m
1 .34925 L
s
.99625 .36509 m
1 .36509 L
s
.99625 .38093 m
1 .38093 L
s
.99625 .41261 m
1 .41261 L
s
.99625 .42845 m
1 .42845 L
s
.99625 .44429 m
1 .44429 L
s
.99625 .46013 m
1 .46013 L
s
.99625 .49181 m
1 .49181 L
s
.99625 .50765 m
1 .50765 L
s
.99625 .52349 m
1 .52349 L
s
.99625 .53933 m
1 .53933 L
s
.99625 .57101 m
1 .57101 L
s
.99625 .58685 m
1 .58685 L
s
.99625 .60269 m
1 .60269 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 .98 .604 r
gsave
.97619 .49307 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .14112 m
.04145 .20321 L
.05908 .21936 L
.07672 .24724 L
.09436 .20638 L
.11199 .11387 L
.12963 .06794 L
.14727 .03594 L
.1649 .01883 L
.18254 .02834 L
.20018 .11514 L
.21781 .25326 L
.23545 .36319 L
.25309 .34798 L
.27072 .28209 L
.28836 .21556 L
.306 .15125 L
.32363 .09772 L
.34127 .05241 L
.35891 .03119 L
.37654 .10595 L
.39418 .29413 L
.41182 .48104 L
.42945 .43257 L
.44709 .4275 L
.46473 .26657 L
.48236 .22063 L
.5 .10057 L
.51764 .04481 L
.53527 .01472 L
.55291 .12116 L
.57055 .44967 L
.58818 .60332 L
.60582 .58621 L
.62346 .50448 L
.64109 .35654 L
.65873 .17153 L
.67637 .11957 L
.694 .08916 L
.71164 .03309 L
.72928 .04861 L
.74691 .14967 L
.76455 .29793 L
.78219 .33626 L
.79982 .33499 L
.81746 .33183 L
.8351 .21176 L
.85273 .21905 L
.87037 .12116 L
.88801 .11007 L
Mistroke
.90564 .04988 L
.92328 .04069 L
.94092 .08789 L
.95855 .29381 L
.97619 .49307 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`009@3oool3000000<0oooo0P00
00040?ooo`<00000103oool2000001L0oooo0`0000030?ooo`8000001@3oool3000000<0oooo0P00
000G0?ooo`<000000`3oool2000000@0oooo0`0000040?ooo`8000005`3oool3000000<0oooo0P00
00040?ooo`<00000103oool2000001L0oooo0`0000030?ooo`8000001@3oool00`000000oooo0?oo
o`030?ooo`8000005`3oool3000000<0oooo0P0000040?ooo`<00000103oool2000000<0oooo000V
0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`030?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo00@0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`00
00030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool010000000oooo
0?ooo`00000G0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000000`3oool01000
0000oooo0?ooo`0000020?ooo`4000000@3oool10?ooo`009P3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0E
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`000000100000020?ooo`040000003oool0
oooo000001L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`030?ooo`040000003o
ool0oooo00000080oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`050?ooo`030000
003oool0000000<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`050?ooo`030000003oool00000
00<0oooo00@000000?ooo`3oool000000P3oool100000040oooo0@3oool002H0oooo00<000000?oo
o`3oool00P3oool4000000<0oooo0P0000030?ooo`040000003oool0oooo000001L0oooo00<00000
0?ooo`3oool00P3oool4000000050?ooo`000000oooo0?ooo`0000000`3oool010000000oooo0?oo
o`00000G0?ooo`030000003oool0oooo0080oooo100000050?ooo`040000003oool0oooo00000080
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`020?ooo`@0000000<0oooo00000000
00000P0000030?ooo`040000003oool0oooo000001L0oooo00<000000?ooo`3oool00P3oool40000
00@0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo01D0oooo00<00000
0?ooo`3oool00P3oool400000080oooo0`0000030?ooo`040000003oool0oooo00000080oooo000V
0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`030?ooo`040000003o
ool0oooo00000080oooo00<000000?ooo`3oool05@3oool01@000000oooo0?ooo`3oool0000000<0
oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`040000003oool0oooo000001L0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0000000<000000`3oool010000000oooo
0?ooo`00000G0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo000000060?oo
o`040000003oool0oooo000001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003o
ool0oooo00<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0E0?ooo`050000
003oool0oooo0?ooo`0000000`3oool00`000000oooo000000030?ooo`040000003oool0oooo0000
0080oooo0@0000010?ooo`40oooo000U0?ooo`8000000`3oool01`000000oooo0?ooo`3oool00000
0?ooo`0000000`3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01@0oooo0P00
00030?ooo`050000003oool0oooo0?ooo`0000000`3oool2000000<0oooo00@000000?ooo`3oool0
00005P3oool2000000<0oooo00L000000?ooo`3oool0oooo0000003oool0000000H0oooo00@00000
0?ooo`3oool000005P3oool2000000<0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0oooo00<0oooo00@000000?ooo`3oool000005P3oool2000000<0oooo00L000000?ooo`3o
ool0oooo0000003oool0000000<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?oo
o`0D0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool010000000
oooo0?ooo`0000020?ooo`4000000@3oool10?ooo`009P3oool00`000000oooo0?ooo`020?ooo`<0
00000`3oool3000000@0oooo0P00000H0?ooo`030000003oool0oooo0080oooo0`0000050?ooo`03
0000003oool0oooo0080oooo0P00000H0?ooo`030000003oool0oooo0080oooo0`0000020?ooo`D0
00000`3oool2000001P0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P0000040?ooo`80
0000603oool00`000000oooo0?ooo`020?ooo`<000000P3oool5000000<0oooo0P00000H0?ooo`03
0000003oool0oooo0080oooo0`0000030?ooo`<00000103oool2000000<0oooo003o0?oooaX0oooo
003o0?oooaX0oooo000>0?ooo`800000o`3oool:0?ooo`003@3oool010000000oooo0?ooo`00003o
0?ooo`T0oooo000=0?ooo`040000003oool0oooo000000@0oooon@00000;0?ooo`003@3oool01000
0000oooo0?ooo`0000040?ooo`800000203oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool2000000/0oooo000=0?ooo`040000003oool0oooo
000000@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0
oooo02T0oooo0P00000;0?ooo`003@3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo0?D0oooo00<000000?ooo`3oool02@3oool000h0oooo0P0000050?ooo`800000PP3oool2003j
VW80oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0903oool4003jVUT0
oooo0P00nYYb0?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo02<0oooo
1`00nYYF0?ooo`<00?ZJLP3oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?oo
o`0R0?ooo`<00?ZJ0P3oool4003jVU@0oooo1000nYYb0?ooo`030000003oool0oooo00T0oooo000E
0?ooo`8000008P3oool3003jVPD0oooo0P00nYXZ0?ooo`800?ZJ9`3oool6003jVRT0oooo0P00nYY6
0?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo0200oooo0`00nYX60?oo
o`800?ZJ:P3oool2003jVRL0oooo0P00nYX20?ooo`800?ZJ:@3oool3003jVTD0oooo00<000000?oo
o`3oool02@3oool001D0oooo00<000000?ooo`3oool0803oool2003jVPL0oooo0P00nYXY0?ooo`<0
0?ZJ9P3oool3003jVP80oooo0P00nYXX0?ooo`D00?ZJ;`3oool3003jVQ80oooo00<000000?ooo`3o
ool02@3oool001D0oooo00<000000?ooo`3oool07`3oool3003jVPL0oooo0`00nYXW0?ooo`D00?ZJ
903oool3003jVP<0oooo0P00nYXX0?ooo`800?ZJ00@0oooo003jVP00nYX00?ZJ;@3oool4003jVQ80
oooo00<000000?ooo`3oool02@3oool001D0oooo0P00000P0?ooo`800?ZJ2@3oool2003jVRH0oooo
0`00nYX00`3oool00?ZJ003jVP0T0?ooo`800?ZJ103oool2003jVRP0oooo0P00nYX20?ooo`<00?ZJ
:`3oool6003jVQ40oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool07P3o
ool3003jVPT0oooo0P00nYXU0?ooo`<00?ZJ0P3oool2003jVR@0oooo0P00nYX40?ooo`800?ZJ9`3o
ool3003jVP<0oooo0P00nYXZ0?ooo`<00?ZJ0P3oool2003jVQ40oooo00<000000?ooo`3oool02@3o
ool001D0oooo00<000000?ooo`3oool07P3oool2003jVPX0oooo0P00nYXU0?ooo`800?ZJ0`3oool2
003jVR<0oooo0`00nYX40?ooo`800?ZJ9`3oool2003jVP@0oooo0P00nYXZ0?ooo`800?ZJ0`3oool2
003jVQ40oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool07@3oool3003j
VPX0oooo0P00nYXT0?ooo`<00?ZJ0`3oool2003jVR<0oooo0P00nYX50?ooo`<00?ZJ9P3oool2003j
VP@0oooo0P00nYXZ0?ooo`800?ZJ0`3oool3003jVQ00oooo00<000000?ooo`3oool02@3oool001D0
oooo0P00000N0?ooo`800?ZJ2`3oool3003jVR<0oooo0P00nYX40?ooo`<00?ZJ8P3oool2003jVPH0
oooo0P00nYXU0?ooo`<00?ZJ103oool3003jVRP0oooo0`00nYX40?ooo`800?ZJ403oool00`000000
oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`0L0?ooo`<00?ZJ303oool2003jVR<0oooo
0P00nYX50?ooo`800?ZJ8@3oool3003jVPH0oooo0P00nYXU0?ooo`800?ZJ1P3oool2003jVRP0oooo
0P00nYX50?ooo`<00?ZJ3`3oool00`000000oooo0?ooo`090?ooo`001P3oool500000080oooo0`00
00050?ooo`030000003oool0oooo01`0oooo0P00nYX=0?ooo`800?ZJ8P3oool3003jVPD0oooo0P00
nYXQ0?ooo`800?ZJ1`3oool2003jVRD0oooo0P00nYX60?ooo`800?ZJ:03oool2003jVPH0oooo0P00
nYX?0?ooo`030000003oool0oooo00T0oooo00070?ooo`060000003oool0oooo0000003oool00000
0`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01/0oooo0`00nYX=0?ooo`800?ZJ
8P3oool2003jVPH0oooo0P00nYXQ0?ooo`800?ZJ1`3oool2003jVR@0oooo0`00nYX60?ooo`800?ZJ
:03oool2003jVPH0oooo0`00nYX>0?ooo`030000003oool0oooo00T0oooo00080?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool00P3oool2000001`0oooo0P00nYX>0?ooo`800?ZJ8@3o
ool3003jVPH0oooo0P00nYXQ0?ooo`800?ZJ1`3oool2003jVR@0oooo0P00nYX70?ooo`800?ZJ9`3o
ool3003jVPL0oooo0P00nYX=0?ooo`8000002`3oool000T0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo01/0oooo0P00nYX>0?ooo`800?ZJ8@3oool2
003jVPL0oooo0`00nYXO0?ooo`<00?ZJ1`3oool3003jVR<0oooo0P00nYX70?ooo`800?ZJ9`3oool2
003jVPP0oooo0P00nYX>0?ooo`030000003oool0oooo00T0oooo00060?ooo`060000003oool0oooo
0?ooo`000000oooo100000050?ooo`030000003oool0oooo01X0oooo0`00nYX>0?ooo`<00?ZJ7`3o
ool3003jVPP0oooo0P00nYXO0?ooo`800?ZJ2@3oool2003jVR80oooo0`00nYX70?ooo`<00?ZJ9P3o
ool2003jVPP0oooo0`00nYX=0?ooo`030000003oool0oooo00T0oooo00060?ooo`070000003oool0
oooo0?ooo`000000oooo000000080?ooo`030000003oool0oooo01X0oooo0P00nYX@0?ooo`800?ZJ
7`3oool2003jVPT0oooo0P00nYXO0?ooo`800?ZJ2@3oool2003jVR80oooo0P00nYX90?ooo`800?ZJ
9@3oool3003jVPT0oooo0P00nYX=0?ooo`030000003oool0oooo00T0oooo00070?ooo`<000000P3o
ool5000000@0oooo0P00000J0?ooo`<00?ZJ403oool2003jVQl0oooo0P00nYX90?ooo`800?ZJ7P3o
ool3003jVPT0oooo0P00nYXQ0?ooo`<00?ZJ2@3oool2003jVRD0oooo0P00nYX:0?ooo`800?ZJ3@3o
ool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`0I0?ooo`800?ZJ4@3oool2
003jVQh0oooo0`00nYX90?ooo`800?ZJ7P3oool2003jVPX0oooo0P00nYXQ0?ooo`800?ZJ2P3oool2
003jVRD0oooo0P00nYX:0?ooo`800?ZJ3@3oool00`000000oooo0?ooo`090?ooo`005@3oool00`00
0000oooo0?ooo`0H0?ooo`<00?ZJ4@3oool2003jVQh0oooo0P00nYX:0?ooo`<00?ZJ7@3oool2003j
VPX0oooo0P00nYXP0?ooo`<00?ZJ2P3oool2003jVRD0oooo0P00nYX:0?ooo`800?ZJ3@3oool00`00
0000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`0H0?ooo`800?ZJ4P3oool3003jVQd0
oooo0P00nYX;0?ooo`800?ZJ7@3oool2003jVPX0oooo0P00nYXP0?ooo`800?ZJ2`3oool2003jVR@0
oooo0`00nYX:0?ooo`800?ZJ3@3oool00`000000oooo0?ooo`090?ooo`005@3oool2000001T0oooo
0P00nYXC0?ooo`800?ZJ703oool3003jVP/0oooo0P00nYXM0?ooo`800?ZJ2P3oool3003jVQh0oooo
0`00nYX;0?ooo`800?ZJ8`3oool3003jVP/0oooo0P00nYX=0?ooo`030000003oool0oooo00T0oooo
000E0?ooo`030000003oool0oooo01L0oooo0`00nYXC0?ooo`800?ZJ703oool2003jVP`0oooo0P00
nYXM0?ooo`800?ZJ2`3oool2003jVQh0oooo0P00nYX<0?ooo`<00?ZJ7`3oool6003jVP/0oooo0`00
nYX<0?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo01L0oooo0P00nYXD
0?ooo`800?ZJ703oool2003jVP`0oooo0P00nYXL0?ooo`<00?ZJ2`3oool2003jVQd0oooo0`00nYX=
0?ooo`800?ZJ7P3oool5003jVPh0oooo0P00nYX<0?ooo`030000003oool0oooo00T0oooo000E0?oo
o`030000003oool0oooo01L0oooo0P00nYXD0?ooo`800?ZJ6`3oool3003jVP`0oooo0P00nYXL0?oo
o`800?ZJ303oool2003jVQd0oooo0P00nYX>0?ooo`800?ZJ7P3oool2003jVQ40oooo0P00nYX<0?oo
o`030000003oool0oooo00T0oooo000E0?ooo`800000603oool2003jVQ@0oooo0P00nYXK0?ooo`80
0?ZJ3@3oool2003jVQ`0oooo0P00nYX<0?ooo`800?ZJ7@3oool2003jVPh0oooo0P00nYXN0?ooo`80
0?ZJ4@3oool2003jVP`0oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0
5P3oool3003jVQ@0oooo0`00nYXJ0?ooo`800?ZJ3@3oool3003jVQ/0oooo0P00nYX<0?ooo`800?ZJ
703oool3003jVPh0oooo0P00nYXN0?ooo`800?ZJ4@3oool2003jVP`0oooo00<000000?ooo`3oool0
2@3oool001D0oooo00<000000?ooo`3oool05P3oool2003jVQH0oooo0P00nYXI0?ooo`<00?ZJ3P3o
ool2003jVQ/0oooo0P00nYX<0?ooo`800?ZJ703oool2003jVPl0oooo0P00nYXM0?ooo`<00?ZJ4@3o
ool2003jVP`0oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool00P3oool2
003jVQ80oooo0P00nYXF0?ooo`800?ZJ6@3oool2003jVPl0oooo0P00nYXK0?ooo`800?ZJ303oool2
003jVQ`0oooo0P00nYX?0?ooo`<00?ZJ703oool2003jVQ80oooo0P00nYX<0?ooo`030000003oool0
oooo00T0oooo000E0?ooo`8000000`3oool2003jVQ80oooo0P00nYXF0?ooo`800?ZJ6@3oool2003j
VPl0oooo0P00nYXK0?ooo`800?ZJ303oool2003jVQ/0oooo0`00nYX@0?ooo`800?ZJ703oool2003j
VQ80oooo0P00nYX<0?ooo`030000003oool0oooo00T0oooo00070?ooo`<00000103oool2000000D0
oooo00<000000?ooo`3oool00P3oool2003jVQ80oooo0P00nYXF0?ooo`800?ZJ603oool3003jVPl0
oooo0P00nYXJ0?ooo`<00?ZJ303oool2003jVQ/0oooo0P00nYXA0?ooo`800?ZJ703oool2003jVQ80
oooo0P00nYX<0?ooo`030000003oool0oooo00T0oooo00060?ooo`050000003oool0oooo0?ooo`00
00000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0080oooo0`00nYXA0?oo
o`800?ZJ5P3oool2003jVQP0oooo0P00nYX@0?ooo`800?ZJ6P3oool2003jVPd0oooo0P00nYXK0?oo
o`800?ZJ4@3oool2003jVQ`0oooo0P00nYXB0?ooo`800?ZJ303oool00`000000oooo0?ooo`090?oo
o`002P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool00`3oool2003jVQ00oooo0`00nYXF0?ooo`800?ZJ603oool2003jVQ00oooo0P00nYXJ0?oo
o`800?ZJ3@3oool3003jVQT0oooo0`00nYXA0?ooo`800?ZJ703oool2003jVQ80oooo0P00nYX<0?oo
o`030000003oool0oooo00T0oooo000:0?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool00P3oool2000000@0oooo0P00nYX@0?ooo`800?ZJ5`3oool3003jVQL0oooo0P00nYX@0?oo
o`800?ZJ6P3oool2003jVPh0oooo0P00nYXI0?ooo`800?ZJ4P3oool2003jVQ/0oooo0`00nYXB0?oo
o`800?ZJ2`3oool2000000/0oooo00060?ooo`@000000`3oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo00<0oooo0P00nYX@0?ooo`800?ZJ603oool2003jVQH0oooo0`00nYX@0?oo
o`800?ZJ6P3oool2003jVPh0oooo0P00nYXI0?ooo`800?ZJ4P3oool2003jVQ/0oooo0P00nYXC0?oo
o`800?ZJ303oool00`000000oooo0?ooo`090?ooo`001P3oool00`000000oooo0?ooo`040?ooo`04
0000003oool0oooo000000@0oooo00<000000?ooo`3oool00`3oool3003jVPl0oooo0P00nYXH0?oo
o`800?ZJ5P3oool2003jVQ40oooo0`00nYXI0?ooo`800?ZJ3P3oool2003jVQP0oooo0`00nYXB0?oo
o`<00?ZJ6P3oool2003jVQ<0oooo0`00nYX;0?ooo`030000003oool0oooo00T0oooo00060?ooo`D0
00000`3oool2000000D0oooo00<000000?ooo`3oool0103oool2003jVPl0oooo0P00nYXH0?ooo`80
0?ZJ5P3oool2003jVQ80oooo0P00nYXI0?ooo`800?ZJ3P3oool2003jVQP0oooo0P00nYXD0?ooo`80
0?ZJ6P3oool2003jVQ@0oooo0P00nYX;0?ooo`030000003oool0oooo00T0oooo000E0?ooo`800000
1@3oool2003jVPh0oooo0`00nYXH0?ooo`800?ZJ5@3oool3003jVQ80oooo0P00nYXI0?ooo`800?ZJ
3P3oool2003jVQP0oooo0P00nYXD0?ooo`800?ZJ6P3oool2003jVQ@0oooo0P00nYX;0?ooo`030000
003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo00@0oooo0P00nYX>0?ooo`800?ZJ6@3o
ool2003jVQD0oooo0P00nYXC0?ooo`800?ZJ603oool3003jVPh0oooo0P00nYXH0?ooo`800?ZJ503o
ool2003jVQX0oooo0P00nYXD0?ooo`800?ZJ2`3oool00`000000oooo0?ooo`090?ooo`005@3oool0
0`000000oooo0?ooo`040?ooo`<00?ZJ3@3oool2003jVQT0oooo0P00nYXE0?ooo`800?ZJ4`3oool2
003jVQP0oooo0P00nYX?0?ooo`800?ZJ603oool2003jVQ@0oooo0P00nYXJ0?ooo`800?ZJ503oool2
003jVP/0oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool01@3oool2003j
VPd0oooo0P00nYXI0?ooo`<00?ZJ4`3oool3003jVQ<0oooo0P00nYXH0?ooo`800?ZJ3`3oool2003j
VQP0oooo0P00nYXD0?ooo`800?ZJ6@3oool3003jVQ@0oooo0P00nYX;0?ooo`030000003oool0oooo
00T0oooo000E0?ooo`8000001P3oool2003jVPd0oooo0P00nYXJ0?ooo`800?ZJ4`3oool2003jVQ@0
oooo0P00nYXH0?ooo`800?ZJ3`3oool2003jVQP0oooo0P00nYXD0?ooo`800?ZJ6@3oool2003jVQD0
oooo0P00nYX;0?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo00D0oooo
0P00nYX=0?ooo`800?ZJ6P3oool2003jVQ<0oooo0P00nYXD0?ooo`800?ZJ603oool2003jVPl0oooo
0P00nYXG0?ooo`<00?ZJ503oool3003jVQP0oooo0P00nYXE0?ooo`800?ZJ2`3oool00`000000oooo
0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`050?ooo`<00?ZJ2`3oool3003jVQX0oooo0P00
nYXB0?ooo`<00?ZJ503oool2003jVQP0oooo0P00nYX?0?ooo`800?ZJ5`3oool2003jVQH0oooo0P00
nYXH0?ooo`800?ZJ5@3oool2003jVP/0oooo00<000000?ooo`3oool02@3oool001D0oooo00<00000
0?ooo`3oool01P3oool2003jVP/0oooo0P00nYXK0?ooo`800?ZJ4P3oool2003jVQD0oooo0`00nYXG
0?ooo`800?ZJ3`3oool2003jVQL0oooo0P00nYXF0?ooo`800?ZJ603oool2003jVQD0oooo0P00nYX;
0?ooo`030000003oool0oooo00T0oooo000E0?ooo`8000001`3oool3003jVPX0oooo0P00nYXK0?oo
o`800?ZJ4P3oool2003jVQH0oooo0P00nYXF0?ooo`<00?ZJ3`3oool2003jVQL0oooo0P00nYXF0?oo
o`800?ZJ603oool2003jVQD0oooo0P00nYX;0?ooo`030000003oool0oooo00T0oooo000E0?ooo`03
0000003oool0oooo00L0oooo0`00nYX90?ooo`800?ZJ6`3oool2003jVQ40oooo0`00nYXF0?ooo`80
0?ZJ5P3oool2003jVQ00oooo0P00nYXG0?ooo`800?ZJ5P3oool2003jVQ80oooo0`00nYX20?ooo`<0
0?ZJ5@3oool2003jVP/0oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0
203oool3003jVPL0oooo0`00nYXK0?ooo`<00?ZJ403oool2003jVQL0oooo0P00nYXF0?ooo`800?ZJ
403oool2003jVQL0oooo0P00nYXF0?ooo`800?ZJ4P3oool7003jVQH0oooo0P00nYX;0?ooo`030000
003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo00T0oooo0`00nYX60?ooo`800?ZJ7@3o
ool2003jVQ00oooo0P00nYXG0?ooo`800?ZJ5P3oool2003jVQ00oooo0P00nYXG0?ooo`800?ZJ5P3o
ool2003jVQ80oooo1`00nYXF0?ooo`<00?ZJ2P3oool00`000000oooo0?ooo`090?ooo`005@3oool2
000000/0oooo0P00nYX60?ooo`800?ZJ7@3oool2003jVQ00oooo0P00nYXG0?ooo`800?ZJ5P3oool2
003jVQ00oooo0`00nYXF0?ooo`800?ZJ5P3oool3003jVQ40oooo0P00nYX30?ooo`800?ZJ5`3oool2
003jVPX0oooo00<000000?ooo`3oool02@3oool000P0oooo00<000000?ooo`3oool00P3oool30000
00D0oooo00<000000?ooo`3oool02P3oool3003jVP@0oooo0`00nYXM0?ooo`800?ZJ3`3oool3003j
VQL0oooo0P00nYXE0?ooo`<00?ZJ4@3oool2003jVQH0oooo0P00nYXG0?ooo`800?ZJ4@3oool2003j
VQ`0oooo0P00nYX:0?ooo`030000003oool0oooo00T0oooo00080?ooo`050000003oool0oooo0?oo
o`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00/0oooo0`00nYX30?oo
o`800?ZJ7P3oool2003jVPl0oooo0P00nYXH0?ooo`800?ZJ5@3oool2003jVQ80oooo0P00nYXE0?oo
o`<00?ZJ5`3oool2003jVQ00oooo0`00nYXL0?ooo`800?ZJ2P3oool00`000000oooo0?ooo`090?oo
o`002@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0303oool3003jVP040?ooo`00nYX00?ZJ003jVQh0oooo0P00nYX?0?ooo`800?ZJ603oool2003j
VQD0oooo0P00nYXB0?ooo`800?ZJ5@3oool2003jVQP0oooo0P00nYX@0?ooo`800?ZJ7@3oool2003j
VPX0oooo00<000000?ooo`3oool02@3oool000T0oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`020?ooo`8000003P3oool2003jVP030?ooo`00nYX00?ZJ01l0oooo0P00nYX?0?ooo`80
0?ZJ603oool3003jVQ<0oooo0`00nYXB0?ooo`800?ZJ5@3oool2003jVQP0oooo0P00nYX@0?ooo`80
0?ZJ7@3oool2003jVPT0oooo0P00000;0?ooo`002P3oool00`000000oooo00000003000000D0oooo
00<000000?ooo`3oool03@3oool5003jVQl0oooo0`00nYX=0?ooo`<00?ZJ6@3oool2003jVQ<0oooo
0P00nYXC0?ooo`800?ZJ5@3oool2003jVQP0oooo0P00nYX@0?ooo`800?ZJ7@3oool2003jVPX0oooo
00<000000?ooo`3oool02@3oool000H0oooo00L000000?ooo`3oool0oooo0000003oool0000000P0
oooo00<000000?ooo`3oool03P3oool4003jVR00oooo0P00nYX=0?ooo`800?ZJ6P3oool2003jVQ80
oooo0`00nYXC0?ooo`800?ZJ5@3oool2003jVQP0oooo0P00nYX@0?ooo`800?ZJ7@3oool2003jVPX0
oooo00<000000?ooo`3oool02@3oool000H0oooo1@0000000`3oool0000000000003000000@0oooo
0P00000@0?ooo`800?ZJ8@3oool2003jVPd0oooo0P00nYXJ0?ooo`800?ZJ4P3oool2003jVQ@0oooo
0P00nYXE0?ooo`800?ZJ603oool2003jVQ00oooo0P00nYXM0?ooo`800?ZJ2P3oool00`000000oooo
0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`0b0?ooo`800?ZJ3@3oool2003jVQX0oooo0P00
nYXA0?ooo`<00?ZJ503oool2003jVQD0oooo0P00nYXH0?ooo`<00?ZJ3`3oool2003jVQd0oooo0P00
nYX:0?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo0380oooo0P00nYX<
0?ooo`<00?ZJ6P3oool2003jVQ40oooo0P00nYXE0?ooo`800?ZJ5@3oool2003jVQT0oooo0P00nYX>
0?ooo`<00?ZJ7@3oool2003jVPX0oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?oo
o`3oool0<P3oool2003jVP`0oooo0P00nYXK0?ooo`800?ZJ4@3oool2003jVQD0oooo0P00nYXE0?oo
o`800?ZJ6@3oool2003jVPh0oooo0P00nYXN0?ooo`800?ZJ2P3oool00`000000oooo0?ooo`090?oo
o`005@3oool2000003<0oooo0`00nYX;0?ooo`800?ZJ6`3oool2003jVQ00oooo0`00nYXE0?ooo`80
0?ZJ503oool3003jVQT0oooo0P00nYX>0?ooo`800?ZJ7P3oool2003jVPX0oooo00<000000?ooo`3o
ool02@3oool001D0oooo00<000000?ooo`3oool0<`3oool2003jVP/0oooo0P00nYXK0?ooo`800?ZJ
403oool2003jVQH0oooo0P00nYXD0?ooo`800?ZJ6P3oool2003jVPh0oooo0P00nYXN0?ooo`<00?ZJ
2@3oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`0c0?ooo`800?ZJ2P3o
ool3003jVQ/0oooo0`00nYX?0?ooo`800?ZJ5P3oool2003jVQ@0oooo0P00nYXJ0?ooo`800?ZJ3P3o
ool2003jVQl0oooo0P00nYX90?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0
oooo03<0oooo0P00nYX:0?ooo`800?ZJ7@3oool2003jVPl0oooo0P00nYXF0?ooo`800?ZJ503oool2
003jVQX0oooo0P00nYX>0?ooo`800?ZJ7`3oool2003jVPT0oooo00<000000?ooo`3oool02@3oool0
01D0oooo0P00000d0?ooo`800?ZJ2P3oool2003jVQd0oooo0P00nYX?0?ooo`800?ZJ5P3oool2003j
VQ@0oooo0P00nYXJ0?ooo`<00?ZJ3@3oool2003jVQl0oooo0P00nYX90?ooo`030000003oool0oooo
00T0oooo000E0?ooo`030000003oool0oooo03<0oooo0P00nYX:0?ooo`800?ZJ7@3oool2003jVPl0
oooo0P00nYXF0?ooo`<00?ZJ4`3oool2003jVQ/0oooo0P00nYX=0?ooo`800?ZJ7`3oool2003jVPT0
oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0<`3oool2003jVPT0oooo
0`00nYXM0?ooo`800?ZJ3P3oool3003jVQL0oooo0P00nYXC0?ooo`800?ZJ6`3oool2003jVP`0oooo
0`00nYXO0?ooo`800?ZJ2@3oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?oo
o`0c0?ooo`<00?ZJ203oool2003jVQh0oooo0P00nYX>0?ooo`800?ZJ603oool2003jVQ<0oooo0P00
nYXK0?ooo`800?ZJ303oool2003jVR00oooo0P00nYX90?ooo`030000003oool0oooo00T0oooo000E
0?ooo`800000=@3oool2003jVPP0oooo0P00nYXN0?ooo`800?ZJ3P3oool2003jVQP0oooo0P00nYXC
0?ooo`800?ZJ6`3oool2003jVP`0oooo0P00nYXP0?ooo`800?ZJ2@3oool00`000000oooo0?ooo`09
0?ooo`005@3oool00`000000oooo0?ooo`0d0?ooo`800?ZJ203oool2003jVQh0oooo0P00nYX>0?oo
o`800?ZJ603oool2003jVQ80oooo0`00nYXK0?ooo`<00?ZJ2`3oool2003jVR00oooo0P00nYX90?oo
o`030000003oool0oooo00T0oooo0000103oool000000000000000040?ooo`800000103oool20000
00D0oooo00<000000?ooo`3oool0=03oool2003jVPL0oooo0`00nYXN0?ooo`800?ZJ3P3oool2003j
VQP0oooo0P00nYXB0?ooo`800?ZJ7@3oool2003jVP/0oooo0P00nYXP0?ooo`800?ZJ2@3oool00`00
0000oooo0?ooo`090?ooo`000P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0d0?ooo`800?ZJ1`3oool2
003jVQl0oooo0P00nYX>0?ooo`800?ZJ603oool2003jVQ80oooo0P00nYXM0?ooo`800?ZJ2`3oool2
003jVR00oooo0P00nYX90?ooo`030000003oool0oooo00T0oooo00020?ooo`030000003oool0oooo
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`800000=@3o
ool2003jVPL0oooo0P00nYXO0?ooo`800?ZJ3P3oool2003jVQP0oooo0P00nYXB0?ooo`800?ZJ7@3o
ool3003jVPX0oooo0P00nYXP0?ooo`<00?ZJ1`3oool2000000/0oooo00020?ooo`030000003oool0
oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000
003oool0oooo03@0oooo0P00nYX70?ooo`800?ZJ7`3oool3003jVPd0oooo0P00nYXH0?ooo`800?ZJ
4P3oool2003jVQh0oooo0P00nYX90?ooo`<00?ZJ8@3oool2003jVPP0oooo00<000000?ooo`3oool0
2@3oool00080oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000@0oooo00<000000?ooo`3oool0=03oool3003jVPH0oooo0P00nYXP0?ooo`80
0?ZJ3@3oool2003jVQP0oooo0P00nYXB0?ooo`800?ZJ7P3oool3003jVPP0oooo0P00nYXR0?ooo`80
0?ZJ203oool00`000000oooo0?ooo`090?ooo`0000<0oooo000000000000103oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0=@3oool2003j
VPD0oooo0`00nYXP0?ooo`800?ZJ3@3oool2003jVQP0oooo0P00nYXB0?ooo`800?ZJ7`3oool2003j
VPP0oooo0P00nYXR0?ooo`800?ZJ203oool00`000000oooo0?ooo`090?ooo`000P3oool00`000000
oooo0?ooo`030?ooo`800000103oool2000000D0oooo0P00000f0?ooo`800?ZJ1@3oool2003jVR40
oooo0P00nYX<0?ooo`<00?ZJ603oool2003jVQ80oooo0P00nYXO0?ooo`800?ZJ1P3oool4003jVR80
oooo0P00nYX80?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo03D0oooo
0P00nYX50?ooo`800?ZJ8@3oool2003jVP`0oooo0P00nYXI0?ooo`800?ZJ4P3oool2003jVQl0oooo
3000nYXR0?ooo`800?ZJ203oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?oo
o`0e0?ooo`800?ZJ1@3oool2003jVR40oooo0P00nYX<0?ooo`800?ZJ6@3oool2003jVQ40oooo0`00
nYXP0?ooo`P00?ZJ9@3oool2003jVPP0oooo00<000000?ooo`3oool02@3oool001D0oooo00<00000
0?ooo`3oool0=@3oool2003jVP@0oooo0`00nYXQ0?ooo`800?ZJ303oool2003jVQT0oooo0P00nYXA
0?ooo`800?ZJCP3oool2003jVPP0oooo00<000000?ooo`3oool02@3oool001D0oooo0P00000f0?oo
o`800?ZJ0`3oool3003jVR80oooo0P00nYX<0?ooo`800?ZJ6@3oool2003jVQ40oooo0P00nYY>0?oo
o`800?ZJ203oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`0e0?ooo`<0
0?ZJ00<0oooo003jVP00nYX00P00nYXR0?ooo`800?ZJ303oool2003jVQT0oooo0`00nYX@0?ooo`80
0?ZJCP3oool2003jVPP0oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0
=P3oool5003jVR@0oooo0P00nYX<0?ooo`800?ZJ6P3oool2003jVQ00oooo0P00nYY>0?ooo`<00?ZJ
1`3oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`0f0?ooo`@00?ZJ9@3o
ool2003jVP`0oooo0P00nYXJ0?ooo`800?ZJ403oool2003jVTl0oooo0P00nYX70?ooo`030000003o
ool0oooo00T0oooo000E0?ooo`800000=`3oool3003jVRH0oooo0P00nYX<0?ooo`800?ZJ6P3oool2
003jVQ00oooo0P00nYY?0?ooo`800?ZJ1`3oool00`000000oooo0?ooo`090?ooo`005@3oool00`00
0000oooo0?ooo`0f0?ooo`800?ZJ9`3oool3003jVP/0oooo0P00nYXJ0?ooo`800?ZJ403oool2003j
VTl0oooo0P00nYX70?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo0600
oooo0P00nYX:0?ooo`<00?ZJ6P3oool2003jVQ00oooo0P00nYY?0?ooo`800?ZJ1`3oool00`000000
oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`1P0?ooo`800?ZJ2P3oool2003jVQ/0oooo
0P00nYX@0?ooo`800?ZJC`3oool2003jVPL0oooo00<000000?ooo`3oool02@3oool001D0oooo0P00
001Q0?ooo`800?ZJ2P3oool2003jVQ/0oooo0P00nYX?0?ooo`<00?ZJC`3oool2003jVPL0oooo00<0
00000?ooo`3oool02@3oool000040?ooo`000000000000000080oooo1@0000020?ooo`<000001@3o
ool00`000000oooo0?ooo`1P0?ooo`800?ZJ2P3oool2003jVQ/0oooo0P00nYX?0?ooo`800?ZJD03o
ool2003jVPL0oooo00<000000?ooo`3oool02@3oool00080oooo00<000000?ooo`3oool00P3oool0
1P000000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`1P0?ooo`800?ZJ2P3oool2003jVQ/0oooo0P00nYX?0?ooo`800?ZJD03oool2003jVPL0oooo
00<000000?ooo`3oool02@3oool00080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0H03oool2003jVPX0oooo0P00
nYXK0?ooo`800?ZJ3`3oool2003jVU00oooo0P00nYX70?ooo`030000003oool0oooo00T0oooo0002
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02
0?ooo`800000H@3oool2003jVPX0oooo0P00nYXK0?ooo`800?ZJ3`3oool2003jVU00oooo0`00nYX5
0?ooo`8000002`3oool00080oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0
000000<000001@3oool00`000000oooo0?ooo`1P0?ooo`800?ZJ2P3oool2003jVQ/0oooo0P00nYX?
0?ooo`800?ZJD@3oool2003jVPH0oooo00<000000?ooo`3oool02@3oool000030?ooo`0000000000
00<0oooo00L000000?ooo`3oool0oooo0000003oool0000000P0oooo00<000000?ooo`3oool0H03o
ool2003jVPX0oooo0P00nYXK0?ooo`800?ZJ3`3oool2003jVU40oooo0P00nYX60?ooo`030000003o
ool0oooo00T0oooo00020?ooo`030000003oool0oooo0080oooo0`0000020?ooo`D00000103oool0
0`000000oooo0?ooo`1P0?ooo`800?ZJ2P3oool2003jVQ/0oooo0P00nYX?0?ooo`800?ZJD@3oool2
003jVPH0oooo00<000000?ooo`3oool02@3oool001D0oooo0P00001Q0?ooo`<00?ZJ203oool3003j
VQ/0oooo0P00nYX?0?ooo`800?ZJD@3oool2003jVPH0oooo00<000000?ooo`3oool02@3oool001D0
oooo00<000000?ooo`3oool0H@3oool2003jVPP0oooo0P00nYXL0?ooo`800?ZJ3P3oool3003jVU40
oooo0P00nYX60?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo0640oooo
0P00nYX80?ooo`800?ZJ703oool3003jVPd0oooo0P00nYYB0?ooo`800?ZJ1P3oool00`000000oooo
0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`1Q0?ooo`800?ZJ203oool2003jVQd0oooo0P00
nYX=0?ooo`800?ZJDP3oool2003jVPH0oooo00<000000?ooo`3oool02@3oool001D0oooo0P00001R
0?ooo`800?ZJ1P3oool4003jVQd0oooo0P00nYX=0?ooo`800?ZJDP3oool2003jVPH0oooo00<00000
0?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0H@3oool2003jVP<0oooo1`00nYXM0?oo
o`800?ZJ3@3oool2003jVU80oooo0P00nYX60?ooo`030000003oool0oooo00T0oooo000E0?ooo`03
0000003oool0oooo0640oooo0P00nYX30?ooo`@00?ZJ803oool2003jVPd0oooo0P00nYYB0?ooo`<0
0?ZJ1@3oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`1Q0?ooo`800?ZJ
0P3oool3003jVR80oooo0P00nYX=0?ooo`800?ZJD`3oool2003jVPD0oooo00<000000?ooo`3oool0
2@3oool001D0oooo0P00001R0?ooo`800?ZJ0P3oool2003jVR<0oooo0P00nYX=0?ooo`800?ZJD`3o
ool2003jVPD0oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0H@3oool2
003jVP80oooo0P00nYXS0?ooo`800?ZJ3@3oool2003jVU<0oooo0P00nYX50?ooo`030000003oool0
oooo00T0oooo000E0?ooo`030000003oool0oooo0640oooo0P00nYX0103oool00?ZJ003jVP00nYXS
0?ooo`800?ZJ303oool3003jVU<0oooo0P00nYX50?ooo`030000003oool0oooo00T0oooo000E0?oo
o`030000003oool0oooo0640oooo0P00nYX00`3oool00?ZJ003jVP0T0?ooo`800?ZJ303oool2003j
VU@0oooo0P00nYX50?ooo`030000003oool0oooo00T0oooo000E0?ooo`800000HP3oool5003jVR@0
oooo0P00nYX<0?ooo`800?ZJE03oool2003jVPD0oooo00<000000?ooo`3oool02@3oool000040?oo
o`0000000000000000<0oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`1R0?ooo`@0
0?ZJ903oool2003jVP`0oooo0P00nYYD0?ooo`800?ZJ1@3oool00`000000oooo0?ooo`090?ooo`00
0P3oool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo0680oooo0`00nYXU0?ooo`800?ZJ303oool2003j
VU@0oooo0P00nYX50?ooo`030000003oool0oooo00T0oooo00020?ooo`030000003oool0oooo00D0
oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
0680oooo0`00nYXU0?ooo`<00?ZJ2`3oool2003jVU@0oooo0P00nYX50?ooo`030000003oool0oooo
00T0oooo00020?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`020?ooo`800000H`3oool3003jVRH0oooo0P00nYX;0?ooo`800?ZJE03oool3003j
VP<0oooo0P00000;0?ooo`000P3oool010000000oooo0?ooo`3oool4000000<0oooo00@000000?oo
o`3oool00000103oool00`000000oooo0?ooo`1R0?ooo`800?ZJ9`3oool2003jVP/0oooo0P00nYYE
0?ooo`800?ZJ103oool00`000000oooo0?ooo`090?ooo`0000<0oooo0000000000000`3oool00`00
0000oooo0?ooo`040?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0HP3oool2
003jVRL0oooo0P00nYX;0?ooo`800?ZJE@3oool2003jVP@0oooo00<000000?ooo`3oool02@3oool0
0080oooo00@000000?ooo`3oool0oooo1@0000030?ooo`8000001@3oool00`000000oooo0?ooo`2;
0?ooo`800?ZJ2P3oool3003jVUD0oooo0P00nYX40?ooo`030000003oool0oooo00T0oooo000E0?oo
o`800000S03oool2003jVPX0oooo0P00nYYF0?ooo`800?ZJ103oool00`000000oooo0?ooo`090?oo
o`005@3oool00`000000oooo0?ooo`2;0?ooo`800?ZJ2P3oool2003jVUH0oooo0P00nYX40?ooo`03
0000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo08/0oooo0P00nYX:0?ooo`800?ZJ
G03oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?ooo`2;0?ooo`800?ZJ2P3o
ool2003jVU`0oooo00<000000?ooo`3oool02@3oool001D0oooo0P00002<0?ooo`<00?ZJ2@3oool2
003jVU`0oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0S03oool2003j
VPT0oooo0P00nYYL0?ooo`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo08`0
oooo0P00nYX80?ooo`<00?ZJG03oool00`000000oooo0?ooo`090?ooo`005@3oool2000008d0oooo
0P00nYX80?ooo`800?ZJG@3oool00`000000oooo0?ooo`090?ooo`005@3oool00`000000oooo0?oo
o`2<0?ooo`800?ZJ203oool2003jVUd0oooo00<000000?ooo`3oool02@3oool001D0oooo00<00000
0?ooo`3oool0S03oool2003jVPP0oooo0P00nYYM0?ooo`030000003oool0oooo00T0oooo000E0?oo
o`030000003oool0oooo08`0oooo0P00nYX70?ooo`<00?ZJG@3oool00`000000oooo0?ooo`090?oo
o`005@3oool2000008d0oooo0P00nYX70?ooo`800?ZJGP3oool00`000000oooo0?ooo`090?ooo`00
5@3oool00`000000oooo0?ooo`2<0?ooo`800?ZJ1`3oool2003jVUh0oooo00<000000?ooo`3oool0
2@3oool000040?ooo`0000000000000000@0oooo00<000000?ooo`3oool00P3oool3000000D0oooo
00<000000?ooo`3oool0S03oool2003jVPL0oooo0P00nYYN0?ooo`030000003oool0oooo00T0oooo
00020?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0S03oool3003jVPD0oooo0`00nYYN0?ooo`030000
003oool0oooo00T0oooo00020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`800000SP3oool2003jVPD0oooo0P00nYYN0?ooo`8000002`3o
ool00080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0S@3oool2003jVPD0oooo0P00nYYO0?ooo`030000003oool0
oooo00T0oooo00020?ooo`030000003oool0oooo00D0oooo00<000000?ooo`0000000`0000050?oo
o`030000003oool0oooo08d0oooo0P00nYX50?ooo`800?ZJG`3oool00`000000oooo0?ooo`090?oo
o`0000<0oooo0000000000000`3oool01`000000oooo0?ooo`3oool000000?ooo`000000203oool0
0`000000oooo0?ooo`2=0?ooo`800?ZJ103oool3003jVUl0oooo00<000000?ooo`3oool02@3oool0
0080oooo00@000000?ooo`3oool0oooo1@0000000`3oool0000000000003000000@0oooo0P00002>
0?ooo`800?ZJ103oool2003jVV00oooo00<000000?ooo`3oool02@3oool001D0oooo00<000000?oo
o`3oool0S@3oool2003jVP@0oooo0P00nYYP0?ooo`030000003oool0oooo00T0oooo000E0?ooo`03
0000003oool0oooo08d0oooo0P00nYX40?ooo`800?ZJH03oool00`000000oooo0?ooo`090?ooo`00
5@3oool00`000000oooo0?ooo`2=0?ooo`800?ZJ0`3oool3003jVV00oooo00<000000?ooo`3oool0
2@3oool001D0oooo0P00002>0?ooo`<00?ZJ0P3oool2003jVV40oooo00<000000?ooo`3oool02@3o
ool001D0oooo00<000000?ooo`3oool0SP3oool2003jVP040?ooo`00nYX00?ZJ003jVV40oooo00<0
00000?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0SP3oool5003jVV80oooo00<00000
0?ooo`3oool02@3oool001D0oooo00<000000?ooo`3oool0SP3oool4003jVV<0oooo00<000000?oo
o`3oool02@3oool001D0oooo0P00002?0?ooo`<00?ZJI03oool00`000000oooo0?ooo`090?ooo`00
5@3oool00`000000oooo0?ooo`2>0?ooo`800?ZJI@3oool00`000000oooo0?ooo`090?ooo`005@3o
ool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0:@3o
ool2000000/0oooo000E0?ooo`800000203oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool2000000/0oooo000E0?ooooT000002`3oool00?l0
oooo6P3oool00?l0oooo6P3oool00?l0oooo6P3oool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {1918.84, -20.0218, \
0.227839, 1.26844}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-7.21843 0.00414079 0.0147151 0.00309466 [
[.02795 -0.0125 -12 -9 ]
[.02795 -0.0125 12 0 ]
[.23499 -0.0125 -12 -9 ]
[.23499 -0.0125 12 0 ]
[.44203 -0.0125 -12 -9 ]
[.44203 -0.0125 12 0 ]
[.64907 -0.0125 -12 -9 ]
[.64907 -0.0125 12 0 ]
[.85611 -0.0125 -12 -9 ]
[.85611 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01472 -6 -4.5 ]
[-0.0125 .01472 0 4.5 ]
[-0.0125 .09208 -12 -4.5 ]
[-0.0125 .09208 0 4.5 ]
[-0.0125 .16945 -12 -4.5 ]
[-0.0125 .16945 0 4.5 ]
[-0.0125 .24681 -12 -4.5 ]
[-0.0125 .24681 0 4.5 ]
[-0.0125 .32418 -18 -4.5 ]
[-0.0125 .32418 0 4.5 ]
[-0.0125 .40155 -18 -4.5 ]
[-0.0125 .40155 0 4.5 ]
[-0.0125 .47891 -18 -4.5 ]
[-0.0125 .47891 0 4.5 ]
[-0.0125 .55628 -18 -4.5 ]
[-0.0125 .55628 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.74845 .0664 -5 -6 ]
[.74845 .0664 5 6 ]
[.97619 .49562 -5 -6 ]
[.97619 .49562 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02795 0 m
.02795 .00625 L
s
[(1750)] .02795 -0.0125 0 1 Mshowa
.23499 0 m
.23499 .00625 L
s
[(1800)] .23499 -0.0125 0 1 Mshowa
.44203 0 m
.44203 .00625 L
s
[(1850)] .44203 -0.0125 0 1 Mshowa
.64907 0 m
.64907 .00625 L
s
[(1900)] .64907 -0.0125 0 1 Mshowa
.85611 0 m
.85611 .00625 L
s
[(1950)] .85611 -0.0125 0 1 Mshowa
.125 Mabswid
.06936 0 m
.06936 .00375 L
s
.11077 0 m
.11077 .00375 L
s
.15217 0 m
.15217 .00375 L
s
.19358 0 m
.19358 .00375 L
s
.2764 0 m
.2764 .00375 L
s
.31781 0 m
.31781 .00375 L
s
.35921 0 m
.35921 .00375 L
s
.40062 0 m
.40062 .00375 L
s
.48344 0 m
.48344 .00375 L
s
.52484 0 m
.52484 .00375 L
s
.56625 0 m
.56625 .00375 L
s
.60766 0 m
.60766 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.73188 0 m
.73188 .00375 L
s
.77329 0 m
.77329 .00375 L
s
.8147 0 m
.8147 .00375 L
s
.89752 0 m
.89752 .00375 L
s
.93892 0 m
.93892 .00375 L
s
.98033 0 m
.98033 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01472 m
.00625 .01472 L
s
[(0)] -0.0125 .01472 1 0 Mshowa
0 .09208 m
.00625 .09208 L
s
[(25)] -0.0125 .09208 1 0 Mshowa
0 .16945 m
.00625 .16945 L
s
[(50)] -0.0125 .16945 1 0 Mshowa
0 .24681 m
.00625 .24681 L
s
[(75)] -0.0125 .24681 1 0 Mshowa
0 .32418 m
.00625 .32418 L
s
[(100)] -0.0125 .32418 1 0 Mshowa
0 .40155 m
.00625 .40155 L
s
[(125)] -0.0125 .40155 1 0 Mshowa
0 .47891 m
.00625 .47891 L
s
[(150)] -0.0125 .47891 1 0 Mshowa
0 .55628 m
.00625 .55628 L
s
[(175)] -0.0125 .55628 1 0 Mshowa
.125 Mabswid
0 .03019 m
.00375 .03019 L
s
0 .04566 m
.00375 .04566 L
s
0 .06113 m
.00375 .06113 L
s
0 .07661 m
.00375 .07661 L
s
0 .10755 m
.00375 .10755 L
s
0 .12303 m
.00375 .12303 L
s
0 .1385 m
.00375 .1385 L
s
0 .15397 m
.00375 .15397 L
s
0 .18492 m
.00375 .18492 L
s
0 .20039 m
.00375 .20039 L
s
0 .21587 m
.00375 .21587 L
s
0 .23134 m
.00375 .23134 L
s
0 .26229 m
.00375 .26229 L
s
0 .27776 m
.00375 .27776 L
s
0 .29323 m
.00375 .29323 L
s
0 .30871 m
.00375 .30871 L
s
0 .33965 m
.00375 .33965 L
s
0 .35513 m
.00375 .35513 L
s
0 .3706 m
.00375 .3706 L
s
0 .38607 m
.00375 .38607 L
s
0 .41702 m
.00375 .41702 L
s
0 .43249 m
.00375 .43249 L
s
0 .44797 m
.00375 .44797 L
s
0 .46344 m
.00375 .46344 L
s
0 .49439 m
.00375 .49439 L
s
0 .50986 m
.00375 .50986 L
s
0 .52533 m
.00375 .52533 L
s
0 .54081 m
.00375 .54081 L
s
0 .57175 m
.00375 .57175 L
s
0 .58723 m
.00375 .58723 L
s
0 .6027 m
.00375 .6027 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02795 .61178 m
.02795 .61803 L
s
.23499 .61178 m
.23499 .61803 L
s
.44203 .61178 m
.44203 .61803 L
s
.64907 .61178 m
.64907 .61803 L
s
.85611 .61178 m
.85611 .61803 L
s
.125 Mabswid
.06936 .61428 m
.06936 .61803 L
s
.11077 .61428 m
.11077 .61803 L
s
.15217 .61428 m
.15217 .61803 L
s
.19358 .61428 m
.19358 .61803 L
s
.2764 .61428 m
.2764 .61803 L
s
.31781 .61428 m
.31781 .61803 L
s
.35921 .61428 m
.35921 .61803 L
s
.40062 .61428 m
.40062 .61803 L
s
.48344 .61428 m
.48344 .61803 L
s
.52484 .61428 m
.52484 .61803 L
s
.56625 .61428 m
.56625 .61803 L
s
.60766 .61428 m
.60766 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.73188 .61428 m
.73188 .61803 L
s
.77329 .61428 m
.77329 .61803 L
s
.8147 .61428 m
.8147 .61803 L
s
.89752 .61428 m
.89752 .61803 L
s
.93892 .61428 m
.93892 .61803 L
s
.98033 .61428 m
.98033 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01472 m
1 .01472 L
s
.99375 .09208 m
1 .09208 L
s
.99375 .16945 m
1 .16945 L
s
.99375 .24681 m
1 .24681 L
s
.99375 .32418 m
1 .32418 L
s
.99375 .40155 m
1 .40155 L
s
.99375 .47891 m
1 .47891 L
s
.99375 .55628 m
1 .55628 L
s
.125 Mabswid
.99625 .03019 m
1 .03019 L
s
.99625 .04566 m
1 .04566 L
s
.99625 .06113 m
1 .06113 L
s
.99625 .07661 m
1 .07661 L
s
.99625 .10755 m
1 .10755 L
s
.99625 .12303 m
1 .12303 L
s
.99625 .1385 m
1 .1385 L
s
.99625 .15397 m
1 .15397 L
s
.99625 .18492 m
1 .18492 L
s
.99625 .20039 m
1 .20039 L
s
.99625 .21587 m
1 .21587 L
s
.99625 .23134 m
1 .23134 L
s
.99625 .26229 m
1 .26229 L
s
.99625 .27776 m
1 .27776 L
s
.99625 .29323 m
1 .29323 L
s
.99625 .30871 m
1 .30871 L
s
.99625 .33965 m
1 .33965 L
s
.99625 .35513 m
1 .35513 L
s
.99625 .3706 m
1 .3706 L
s
.99625 .38607 m
1 .38607 L
s
.99625 .41702 m
1 .41702 L
s
.99625 .43249 m
1 .43249 L
s
.99625 .44797 m
1 .44797 L
s
.99625 .46344 m
1 .46344 L
s
.99625 .49439 m
1 .49439 L
s
.99625 .50986 m
1 .50986 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .54081 m
1 .54081 L
s
.99625 .57175 m
1 .57175 L
s
.99625 .58723 m
1 .58723 L
s
.99625 .6027 m
1 .6027 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.74845 .0664 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .26507 m
.02795 .27281 L
.03209 .16233 L
.03623 .16264 L
.04037 .10972 L
.04451 .05247 L
.04865 .04442 L
.0528 .04628 L
.05694 .11498 L
.06108 .16202 L
.06522 .18183 L
.06936 .20937 L
.0735 .28055 L
.07764 .20411 L
.08178 .15428 L
.08592 .12736 L
.09006 .07939 L
.0942 .04999 L
.09834 .13169 L
.10248 .23072 L
.10663 .34306 L
.11077 .32666 L
.11491 .26724 L
.11905 .22051 L
.12319 .12241 L
.12733 .10941 L
.13147 .03638 L
.13561 .07599 L
.13975 .30097 L
.14389 .49253 L
.14803 .40433 L
.15217 .27714 L
.15631 .22546 L
.16046 .13386 L
.1646 .08527 L
.16874 .04628 L
.17288 .0893 L
.17702 .27126 L
.18116 .42321 L
.1853 .41981 L
.18944 .38019 L
.19358 .29292 L
.19772 .22082 L
.20186 .20039 L
.206 .15985 L
.21014 .1416 L
.21429 .08063 L
.21843 .06423 L
.22257 .03452 L
.22671 .0274 L
Mistroke
.23085 .03576 L
.23499 .05959 L
.23913 .11993 L
.24327 .15397 L
.24741 .14809 L
.25155 .16171 L
.25569 .14531 L
.25983 .10167 L
.26398 .04597 L
.26812 .03978 L
.27226 .02245 L
.2764 .01472 L
.28054 .01905 L
.28468 .03019 L
.28882 .05247 L
.29296 .05773 L
.2971 .12427 L
.30124 .15645 L
.30538 .14191 L
.30952 .10879 L
.31366 .08868 L
.31781 .0633 L
.32195 .03514 L
.32609 .02709 L
.33023 .02029 L
.33437 .04102 L
.33851 .06609 L
.34265 .12705 L
.34679 .16852 L
.35093 .20813 L
.35507 .22206 L
.35921 .23444 L
.36335 .16264 L
.36749 .09982 L
.37164 .04102 L
.37578 .05556 L
.37992 .1908 L
.38406 .39072 L
.3882 .44271 L
.39234 .33408 L
.39648 .28024 L
.40062 .2103 L
.40476 .1286 L
.4089 .08961 L
.41304 .04783 L
.41718 .06113 L
.42133 .13881 L
.42547 .20504 L
.42961 .31954 L
.43375 .39938 L
Mistroke
.43789 .31149 L
.44203 .22051 L
.44617 .21432 L
.45031 .18245 L
.45445 .13541 L
.45859 .07847 L
.46273 .03545 L
.46687 .02802 L
.47101 .08527 L
.47516 .1843 L
.4793 .30499 L
.48344 .31087 L
.48758 .25362 L
.49172 .19761 L
.49586 .15088 L
.5 .16016 L
.50414 .1091 L
.50828 .06516 L
.51242 .03731 L
.51656 .13015 L
.5207 .24341 L
.52484 .44518 L
.52899 .35884 L
.53313 .32944 L
.53727 .21989 L
.54141 .15305 L
.54555 .06763 L
.54969 .04968 L
.55383 .05278 L
.55797 .02524 L
.56211 .03328 L
.56625 .11467 L
.57039 .18275 L
.57453 .19947 L
.57867 .21184 L
.58282 .21123 L
.58696 .17626 L
.5911 .09332 L
.59524 .05526 L
.59938 .03576 L
.60352 .03421 L
.60766 .03669 L
.6118 .12488 L
.61594 .24063 L
.62008 .27745 L
.62422 .2561 L
.62836 .21277 L
.63251 .14407 L
.63665 .0958 L
.64079 .09734 L
Mistroke
.64493 .05216 L
.64907 .04411 L
.65321 .02307 L
.65735 .03019 L
.66149 .09022 L
.66563 .14469 L
.66977 .21123 L
.67391 .18121 L
.67805 .20658 L
.68219 .16481 L
.68634 .15057 L
.69048 .07228 L
.69462 .03235 L
.69876 .02586 L
.7029 .01905 L
.70704 .04442 L
.71118 .1614 L
.71532 .19142 L
.71946 .33625 L
.7236 .26414 L
.72774 .21154 L
.73188 .13107 L
.73602 .09549 L
.74017 .05866 L
.74431 .03266 L
.74845 .0664 L
Mfstroke
0 .98 .604 r
gsave
.97619 .49562 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.75259 .15181 m
.75673 .21246 L
.76087 .22825 L
.76501 .25548 L
.76915 .21556 L
.77329 .12519 L
.77743 .08032 L
.78157 .04907 L
.78571 .03235 L
.78986 .04164 L
.794 .12643 L
.79814 .26136 L
.80228 .36874 L
.80642 .35389 L
.81056 .28952 L
.8147 .22453 L
.81884 .16171 L
.82298 .10941 L
.82712 .06516 L
.83126 .04442 L
.8354 .11746 L
.83954 .30128 L
.84369 .48387 L
.84783 .43652 L
.85197 .43157 L
.85611 .27436 L
.86025 .22948 L
.86439 .1122 L
.86853 .05773 L
.87267 .02833 L
.87681 .13231 L
.88095 .45323 L
.88509 .60332 L
.88923 .58661 L
.89337 .50677 L
.89752 .36225 L
.90166 .18152 L
.9058 .13076 L
.90994 .10106 L
.91408 .04628 L
.91822 .06144 L
.92236 .16016 L
.9265 .30499 L
.93064 .34244 L
.93478 .3412 L
.93892 .33811 L
.94306 .22082 L
.9472 .22794 L
.95135 .13231 L
.95549 .12148 L
Mistroke
.95963 .06268 L
.96377 .05371 L
.96791 .09982 L
.97205 .30097 L
.97619 .49562 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`004@3oool3000000@0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P00000Q0?oo
o`<000000`3oool3000000@0oooo0P0000040?ooo`800000803oool3000000<0oooo0`0000030?oo
o`<00000103oool200000240oooo0`0000030?ooo`8000001@3oool2000000@0oooo0P00000Q0?oo
o`<000000`3oool2000000@0oooo0`0000040?ooo`800000703oool00180oooo00<000000?ooo`3o
ool00`3oool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3oool0
0`000000oooo0?ooo`0O0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool07P3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0O0?ooo`030000
003oool0oooo00@0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo01T0oooo000B0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01l0oooo00D000000?oo
o`3oool0oooo000000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`0N0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000
oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00`3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01T0oooo000B0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool00P3oool3000000<0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000P0?ooo`030000003oool0oooo0080oooo0`0000060?oo
o`040000003oool0oooo00000080oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`02
0?ooo`@000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000240oooo
00<000000?ooo`3oool00P3oool4000000D0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0I0?ooo`004P3oool00`000000oooo0?ooo`050?ooo`030000003oool0000000<00000
0`3oool010000000oooo0?ooo`00000Q0?ooo`050000003oool0oooo0?ooo`0000000`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool07P3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`0000030?ooo`040000
003oool0oooo00000240oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0O0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo00000003000000<0oooo00@000000?ooo`3oool0
00006`3oool00140oooo0P0000030?ooo`070000003oool0oooo0?ooo`000000oooo000000060?oo
o`040000003oool0oooo00000200oooo0P0000030?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001l0oooo0P0000030?ooo`07
0000003oool0oooo0?ooo`000000oooo000000060?ooo`040000003oool0oooo00000200oooo0P00
00030?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000200oooo0P0000030?ooo`070000003oool0oooo0?ooo`000000oooo0000
00060?ooo`040000003oool0oooo000001/0oooo000B0?ooo`040000003oool0oooo0?ooo`D00000
00<0oooo0000000000000`0000030?ooo`8000008P3oool00`000000oooo0?ooo`020?ooo`<00000
103oool2000000@0oooo0P00000Q0?ooo`030000003oool0oooo0080oooo0`0000020?ooo`D00000
0`3oool200000280oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P0000040?ooo`800000
8P3oool00`000000oooo0?ooo`020?ooo`<000000P3oool5000000<0oooo0P00000L0?ooo`00o`3o
oolJ0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`005@3ooooo000000D00000
000>0?ooo`8000001@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`020?ooo`400000000=0?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0c0?ooo`030000003o
ool0oooo0380oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0c0?ooo`030000003o
ool0oooo0280oooo0@00000000d0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?oo
o`3o0?ooo`40oooo0@00000000d0oooo00@000000?ooo`3oool00000103oool2000004@0oooo0P00
0?ni0?ooo`<00000000=0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0@`3o
ool30000o`/0oooo0P000?mO0?ooo`80003oC03oool1000000003@3oool010000000oooo0?ooo`00
00040?ooo`030000003oool0oooo0480oooo10000?l;0?ooo`80003oDP3oool20000o`/0oooo0P00
0?m<0?ooo`400000000>0?ooo`8000001@3oool00`000000oooo0?ooo`0f0?ooo`80003o2P3oool5
0000o`T0oooo0`000?lR0?ooo`80003o5@3oool20000oaL0oooo0P000?l:0?ooo`<0003o:P3oool2
003jVR00oooo0@00000001D0oooo0P00000g0?ooo`<0003o2@3oool20000o`030?ooo`000?l0003o
00T0oooo0`000?lR0?ooo`80003o5@3oool20000oaL0oooo0`000?l90?ooo`<0003o:P3oool2003j
VQl0oooo0P00000001D0oooo00<000000?ooo`3oool0=@3oool50000o`L0oooo0`000?l00`3oool0
003o0000o`080?ooo`D0003o803oool30000oaD0oooo0`000?l80?ooo`<0003o2`3oool30000o`P0
oooo1@000?l80?ooo`80003o203oool2003jVQD0oooo0P00nYXP0?ooo`400000000E0?ooo`030000
003oool0oooo01h0oooo0P000?lE0?ooo`80003o00<0oooo0000o`000?l01`3oool20000o`80oooo
0`000?l70?ooo`80003o00<0oooo0000o`000?l0803oool30000o`T0oooo0P000?l:0?ooo`<0003o
203oool40000o`T0oooo10000?l80?ooo`80003o00<0oooo0000o`000?l0203oool20000o`P0oooo
0P00nYXE0?ooo`800?ZJ803oool1000000005@3oool00`000000oooo0?ooo`0N0?ooo`80003o5@3o
ool20000o`030?ooo`000?l0003o00L0oooo0P000?l30?ooo`80003o1`3oool20000o`030?ooo`00
0?l0003o00P0oooo0P000?lF0?ooo`<0003o2@3oool20000o`T0oooo10000?l80?ooo`@0003o2@3o
ool40000o`P0oooo0P000?l00`3oool0003o0000o`070?ooo`<0003o203oool3003jVQ@0oooo0P00
nYXP0?ooo`400000000E0?ooo`8000002@3oool30000oa<0oooo0P000?l70?ooo`80003o303oool2
0000o`030?ooo`000?l0003o00H0oooo0`000?l30?ooo`80003o1`3oool20000o`030?ooo`000?l0
003o00P0oooo0P000?lF0?ooo`<0003o2@3oool20000o`T0oooo10000?l70?ooo`D0003o2@3oool4
0000o`P0oooo0P000?l00`3oool0003o0000o`070?ooo`<0003o1`3oool4003jVPT0oooo0P00nYX8
0?ooo`<00?ZJ2@3oool2003jVQ@0oooo0P00000001D0oooo00<000000?ooo`3oool0203oool30000
o`T0oooo0P000?l80?ooo`80003o1`3oool20000o``0oooo0P000?l0103oool0003o0000o`000?l5
0?ooo`80003o103oool30000o`H0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o2@3oool2
0000o`/0oooo0`000?l90?ooo`80003o203oool50000o`L0oooo0P000?l00`3oool0003o0000o`09
0?ooo`@0003o203oool20000o`030?ooo`000?l0003o00L0oooo0`000?l70?ooo`@00?ZJ2@3oool2
003jVPP0oooo0`00nYX90?ooo`800?ZJ5@3oool1000000005@3oool00`000000oooo0?ooo`070?oo
o`@0003o2@3oool20000o`P0oooo0P000?l70?ooo`80003o2`3oool30000o`80oooo0P000?l50?oo
o`80003o1@3oool20000o`D0oooo0`000?l00`3oool0003o0000o`080?ooo`<0003o203oool20000
o`/0oooo0`000?l80?ooo`<0003o203oool50000o`L0oooo0P000?l00`3oool0003o0000o`080?oo
o`D0003o203oool20000o`030?ooo`000?l0003o00H0oooo1@000?l60?ooo`@00?ZJ2@3oool2003j
VPP0oooo0`00nYX90?ooo`800?ZJ2P3oool2003jVPT0oooo0@00000001D0oooo00<000000?ooo`3o
ool01`3oool40000o`T0oooo0P000?l80?ooo`80003o1`3oool20000o`/0oooo0P000?l30?ooo`80
003o1@3oool20000o`D0oooo0`000?l40?ooo`80003o0P3oool30000o`L0oooo0`000?l80?ooo`<0
003o2@3oool50000o`L0oooo0`000?l80?ooo`D0003o1`3oool20000o`030?ooo`000?l0003o00P0
oooo0P000?l00`3oool0003o0000o`070?ooo`<0003o00<0oooo0000o`000?l01P3oool20000o`03
0?ooo`000?l0003o00H0oooo1000nYX80?ooo`<00?ZJ203oool3003jVPT0oooo0`00nYX90?ooo`80
0?ZJ2@3oool1000000005@3oool2000000P0oooo10000?l90?ooo`80003o203oool30000o`H0oooo
0`000?l:0?ooo`80003o0`3oool20000o`D0oooo0P000?l60?ooo`80003o103oool20000o`<0oooo
0P000?l70?ooo`<0003o203oool30000o`T0oooo0P000?l00`3oool0003o0000o`070?ooo`<0003o
1`3oool30000o`030?ooo`000?l0003o00L0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o
00@0oooo0000o`000?l0003o1P3oool20000o`80oooo0P000?l60?ooo`80003o00<0oooo0000o`00
0?l01P3oool4003jVPP0oooo0`00nYX80?ooo`<00?ZJ203oool4003jVPP0oooo0`00nYX80?ooo`80
0000000E0?ooo`030000003oool0oooo00L0oooo10000?l90?ooo`80003o203oool30000o`H0oooo
0`000?l:0?ooo`80003o0`3oool20000o`D0oooo0P000?l60?ooo`80003o103oool20000o`<0oooo
0P000?l70?ooo`<0003o203oool30000o`T0oooo0P000?l00`3oool0003o0000o`070?ooo`@0003o
1P3oool20000o`80oooo0P000?l70?ooo`80003o00<0oooo0000o`000?l0203oool20000o`80oooo
0P000?l60?ooo`80003o0P3oool20000o`H0oooo0P000?l00`3oool0003o0000o`060?ooo`@00?ZJ
203oool3003jVPP0oooo0`00nYX80?ooo`@00?ZJ203oool3003jVPT0oooo0@00000001D0oooo00<0
00000?ooo`3oool01`3oool40000o`P0oooo0`000?l80?ooo`<0003o1@3oool40000o`X0oooo0P00
0?l30?ooo`80003o1@3oool20000o`H0oooo0P000?l40?ooo`80003o0`3oool20000o`L0oooo0`00
0?l80?ooo`<0003o2@3oool20000o`030?ooo`000?l0003o00L0oooo10000?l60?ooo`80003o0P3o
ool20000o`L0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o0P3oool20000o`H0oooo0P00
0?l20?ooo`80003o1P3oool20000o`030?ooo`000?l0003o00D0oooo1@00nYX80?ooo`<00?ZJ203o
ool3003jVPP0oooo1000nYX80?ooo`<00?ZJ2@3oool1000000005@3oool00`000000oooo0?ooo`07
0?ooo`@0003o203oool30000o`P0oooo0`000?l50?ooo`@0003o2P3oool20000o`<0oooo0P000?l5
0?ooo`80003o1P3oool20000o`@0oooo0P000?l30?ooo`80003o1P3oool40000o`L0oooo10000?l9
0?ooo`80003o00<0oooo0000o`000?l01`3oool40000o`H0oooo0P000?l20?ooo`80003o1`3oool2
0000o`030?ooo`000?l0003o00P0oooo0P000?l20?ooo`80003o1P3oool20000o`80oooo0P000?l6
0?ooo`80003o203oool2003jVP030?ooo`00nYX00?ZJ00P0oooo0`00nYX80?ooo`<00?ZJ203oool4
003jVPP0oooo0`00nYX90?ooo`400000000E0?ooo`800000203oool40000o`P0oooo0`000?l70?oo
o`@0003o1@3oool40000o`T0oooo0`000?l30?ooo`80003o103oool30000o`H0oooo0P000?l40?oo
o`80003o0`3oool20000o`H0oooo10000?l70?ooo`@0003o2@3oool20000o`030?ooo`000?l0003o
00L0oooo10000?l60?ooo`80003o0P3oool30000o`D0oooo0`000?l00`3oool0003o0000o`070?oo
o`<0003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o1P3oool20000o`P0oooo0P00nYX00`3o
ool00?ZJ003jVP080?ooo`<00?ZJ203oool3003jVPP0oooo1000nYX80?ooo`<00?ZJ203oool20000
00001P3oool500000080oooo0`0000050?ooo`030000003oool0oooo00L0oooo10000?l80?ooo`<0
003o1`3oool40000o`D0oooo1@000?l80?ooo`80003o103oool20000o`@0oooo0P000?l70?ooo`80
003o0`3oool30000o`<0oooo0P000?l60?ooo`@0003o1`3oool40000o`T0oooo0P000?l00`3oool0
003o0000o`070?ooo`@0003o1P3oool20000o`<0oooo0P000?l50?ooo`80003o0P3oool20000o`L0
oooo0P000?l30?ooo`80003o1P3oool20000o`80oooo0P000?l50?ooo`<0003o203oool2003jVP03
0?ooo`00nYX00?ZJ00P0oooo0`00nYX80?ooo`@00?ZJ1`3oool4003jVPP0oooo1000nYX80?ooo`40
000000070?ooo`060000003oool0oooo0000003oool000000`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00H0oooo1P000?l70?ooo`<0003o1`3oool40000o`D0oooo0P000?l00`3o
ool0003o0000o`080?ooo`80003o103oool20000o`@0oooo0P000?l70?ooo`80003o0`3oool20000
o`@0oooo0`000?l50?ooo`@0003o1`3oool40000o`T0oooo0P000?l00`3oool0003o0000o`070?oo
o`@0003o1P3oool20000o`<0oooo0P000?l50?ooo`80003o0P3oool30000o`H0oooo0P000?l30?oo
o`80003o1P3oool20000o`80oooo0P000?l50?ooo`80003o2@3oool2003jVP030?ooo`00nYX00?ZJ
00P0oooo1000nYX70?ooo`@00?ZJ1`3oool4003jVPP0oooo1000nYX80?ooo`40000000080?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`060?ooo`80
003o0P3oool20000o`L0oooo0`000?l70?ooo`@0003o1@3oool20000o`030?ooo`000?l0003o00P0
oooo0P000?l40?ooo`80003o103oool20000o`L0oooo0P000?l30?ooo`80003o1@3oool20000o`D0
oooo10000?l70?ooo`@0003o2@3oool20000o`030?ooo`000?l0003o00H0oooo1@000?l60?ooo`80
003o0`3oool20000o`D0oooo0P000?l30?ooo`80003o1P3oool20000o`<0oooo0P000?l60?ooo`80
003o0P3oool20000o`D0oooo0P000?l90?ooo`800?ZJ00@0oooo003jVP00nYX00?ZJ1P3oool5003j
VPH0oooo1@00nYX60?ooo`D00?ZJ203oool4003jVPP0oooo0@00000000T0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`020?ooo`8000001`3oool20000o`80oooo0P000?l70?ooo`@0
003o1P3oool40000o`D0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o103oool30000o`<0
oooo0P000?l70?ooo`<0003o0P3oool20000o`D0oooo0P000?l50?ooo`@0003o1`3oool40000o`T0
oooo0P000?l00`3oool0003o0000o`060?ooo`80003o00<0oooo0000o`000?l01P3oool20000o`<0
oooo0P000?l50?ooo`80003o0`3oool20000o`H0oooo0P000?l30?ooo`80003o1P3oool20000o`80
oooo0P000?l50?ooo`80003o2@3oool2003jVP80oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00
nYX01P3oool2003jVP030?ooo`00nYX00?ZJ00H0oooo0P00nYX00`3oool00?ZJ003jVP080?ooo`@0
0?ZJ1P3oool3000000001P3oool01P000000oooo0?ooo`3oool000000?ooo`@000001@3oool00`00
0000oooo0?ooo`060?ooo`80003o0P3oool20000o`L0oooo10000?l60?ooo`@0003o1@3oool20000
o`030?ooo`000?l0003o00P0oooo0P000?l50?ooo`80003o0`3oool20000o`P0oooo0P000?l20?oo
o`80003o1@3oool20000o`D0oooo10000?l70?ooo`@0003o203oool30000o`030?ooo`000?l0003o
00H0oooo0P000?l00`3oool0003o0000o`060?ooo`80003o0`3oool20000o`D0oooo0P000?l30?oo
o`80003o1@3oool30000o`<0oooo0P000?l60?ooo`80003o0P3oool20000o`D0oooo0P000?l90?oo
o`800?ZJ0P3oool2003jVPH0oooo0P00nYX00`3oool00?ZJ003jVP060?ooo`800?ZJ00<0oooo003j
VP00nYX01P3oool2003jVP030?ooo`00nYX00?ZJ00L0oooo1@00nYX80?ooo`40000000060?ooo`07
0000003oool0oooo0?ooo`000000oooo000000080?ooo`030000003oool0oooo00H0oooo0P000?l2
0?ooo`80003o1`3oool40000o`H0oooo10000?l50?ooo`80003o00<0oooo0000o`000?l0203oool2
0000o`D0oooo0P000?l30?ooo`80003o203oool20000o`040?ooo`000?l0003o0000o`D0oooo0P00
0?l50?ooo`@0003o1`3oool40000o`P0oooo0P000?l20?ooo`80003o1P3oool20000o`030?ooo`00
0?l0003o00H0oooo0P000?l30?ooo`80003o1@3oool20000o`<0oooo0P000?l50?ooo`<0003o0`3o
ool20000o`H0oooo0P000?l20?ooo`80003o1@3oool20000o`T0oooo0P00nYX20?ooo`800?ZJ1P3o
ool2003jVP030?ooo`00nYX00?ZJ00H0oooo0P00nYX00`3oool00?ZJ003jVP060?ooo`800?ZJ00<0
oooo003jVP00nYX01`3oool2003jVP030?ooo`00nYX00?ZJ00P0oooo0@00000000L0oooo0`000002
0?ooo`D00000103oool00`000000oooo0?ooo`060?ooo`80003o0P3oool20000o`L0oooo10000?l6
0?ooo`@0003o1@3oool20000o`030?ooo`000?l0003o00P0oooo0P000?l50?ooo`80003o0`3oool2
0000o`P0oooo0P000?l00`3oool0003o0000o`060?ooo`80003o1@3oool40000o`L0oooo1@000?l7
0?ooo`80003o0P3oool20000o`H0oooo0P000?l00`3oool0003o0000o`060?ooo`80003o0`3oool2
0000o`D0oooo0P000?l30?ooo`80003o1@3oool20000o`@0oooo0P000?l60?ooo`80003o0P3oool2
0000o`D0oooo0P000?l90?ooo`800?ZJ0P3oool2003jVPH0oooo0P00nYX00`3oool00?ZJ003jVP06
0?ooo`800?ZJ00<0oooo003jVP00nYX01P3oool2003jVP030?ooo`00nYX00?ZJ00L0oooo0P00nYX0
0`3oool00?ZJ003jVP080?ooo`400000000E0?ooo`8000001`3oool20000o`80oooo0P000?l60?oo
o`D0003o1P3oool40000o`D0oooo0P000?l00`3oool0003o0000o`080?ooo`80003o1@3oool20000
o`<0oooo0P000?l80?ooo`80003o00<0oooo0000o`000?l01P3oool20000o`D0oooo10000?l70?oo
o`80003o00<0oooo0000o`000?l01`3oool20000o`80oooo0P000?l60?ooo`80003o00<0oooo0000
o`000?l01P3oool20000o`<0oooo0P000?l50?ooo`80003o0`3oool20000o`D0oooo0P000?l40?oo
o`80003o1P3oool20000o`80oooo0`000?l40?ooo`80003o203oool3003jVP80oooo0P00nYX60?oo
o`800?ZJ00<0oooo003jVP00nYX01P3oool2003jVP030?ooo`00nYX00?ZJ00H0oooo0P00nYX00`3o
ool00?ZJ003jVP070?ooo`800?ZJ00<0oooo003jVP00nYX01`3oool2000000005@3oool00`000000
oooo0?ooo`060?ooo`80003o0P3oool20000o`H0oooo0P000?l00`3oool0003o0000o`060?ooo`@0
003o103oool30000o`030?ooo`000?l0003o00P0oooo0P000?l50?ooo`80003o0`3oool20000o`P0
oooo0P000?l00`3oool0003o0000o`060?ooo`80003o1@3oool40000o`H0oooo0`000?l00`3oool0
003o0000o`070?ooo`80003o0P3oool20000o`H0oooo0P000?l0103oool0003o0000o`000?l50?oo
o`80003o0`3oool20000o`D0oooo0P000?l30?ooo`80003o1@3oool20000o`@0oooo0P000?l60?oo
o`80003o0`3oool20000o`@0oooo0P000?l80?ooo`800?ZJ0`3oool2003jVPH0oooo0P00nYX00`3o
ool00?ZJ003jVP060?ooo`800?ZJ00<0oooo003jVP00nYX01P3oool2003jVP030?ooo`00nYX00?ZJ
00L0oooo0P00nYX00`3oool00?ZJ003jVP080?ooo`400000000E0?ooo`030000003oool0oooo00H0
oooo0P000?l20?ooo`80003o1P3oool20000o`030?ooo`000?l0003o00H0oooo10000?l40?ooo`80
003o0P3oool20000o`L0oooo0`000?l50?ooo`80003o0`3oool20000o`P0oooo0P000?l00`3oool0
003o0000o`060?ooo`<0003o103oool40000o`H0oooo0P000?l20?ooo`80003o1`3oool20000o`80
oooo0P000?l60?ooo`80003o0P3oool20000o`@0oooo0`000?l30?ooo`80003o1@3oool20000o`<0
oooo0P000?l50?ooo`80003o103oool20000o`D0oooo0`000?l30?ooo`80003o0`3oool30000o`P0
oooo0P00nYX30?ooo`800?ZJ1P3oool2003jVP030?ooo`00nYX00?ZJ00H0oooo0P00nYX00`3oool0
0?ZJ003jVP060?ooo`800?ZJ00@0oooo003jVP00nYX00?ZJ1P3oool2003jVP030?ooo`00nYX00?ZJ
00P0oooo0@00000001D0oooo00<000000?ooo`3oool01P3oool20000o`80oooo0P000?l60?ooo`80
003o00<0oooo0000o`000?l01@3oool50000o`@0oooo0P000?l20?ooo`80003o1`3oool20000o`H0
oooo0P000?l30?ooo`80003o203oool20000o`030?ooo`000?l0003o00L0oooo0P000?l40?ooo`@0
003o1P3oool20000o`80oooo0P000?l70?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`80
003o103oool20000o`@0oooo0P000?l50?ooo`80003o0`3oool20000o`D0oooo0P000?l40?ooo`<0
003o103oool20000o`@0oooo0P000?l30?ooo`80003o2@3oool2003jVP<0oooo0P00nYX60?ooo`80
0?ZJ00<0oooo003jVP00nYX01P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo0`00nYX20?ooo`80
0?ZJ1P3oool2003jVP030?ooo`00nYX00?ZJ00P0oooo0@00000001D0oooo0P0000070?ooo`80003o
0P3oool20000o`H0oooo0P000?l00`3oool0003o0000o`050?ooo`80003o00<0oooo0000o`000?l0
103oool20000o`80oooo0P000?l70?ooo`80003o1P3oool20000o`<0oooo0P000?l80?ooo`80003o
00<0oooo0000o`000?l01`3oool20000o`@0oooo10000?l60?ooo`80003o0P3oool20000o`H0oooo
0`000?l20?ooo`80003o1P3oool20000o`80oooo0P000?l40?ooo`80003o103oool20000o`D0oooo
0P000?l30?ooo`80003o103oool30000o`D0oooo0P000?l40?ooo`80003o103oool20000o`<0oooo
0P000?l90?ooo`800?ZJ0`3oool2003jVPH0oooo0P00nYX00`3oool00?ZJ003jVP060?ooo`800?ZJ
00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00nYX0
1`3oool2000000005@3oool00`000000oooo0?ooo`060?ooo`80003o0P3oool20000o`H0oooo0P00
0?l00`3oool0003o0000o`050?ooo`80003o00<0oooo0000o`000?l0103oool20000o`80oooo0P00
0?l70?ooo`80003o1P3oool20000o`80oooo0`000?l80?ooo`D0003o1`3oool20000o`@0oooo1@00
0?l50?ooo`80003o0P3oool20000o`H0oooo0P000?l30?ooo`80003o1P3oool20000o`80oooo0P00
0?l40?ooo`80003o103oool20000o`D0oooo0P000?l30?ooo`80003o103oool20000o`H0oooo0P00
0?l40?ooo`80003o103oool20000o`<0oooo0P000?l90?ooo`800?ZJ0`3oool2003jVPH0oooo0P00
nYX00`3oool00?ZJ003jVP060?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00
nYX60?ooo`800?ZJ00<0oooo003jVP00nYX0203oool1000000005@3oool00`000000oooo0?ooo`06
0?ooo`80003o0P3oool30000o`D0oooo0P000?l00`3oool0003o0000o`050?ooo`80003o00<0oooo
0000o`000?l0103oool20000o`80oooo0P000?l70?ooo`80003o1P3oool20000o`80oooo0P000?l9
0?ooo`@0003o203oool20000o`@0oooo0P000?l00`3oool0003o0000o`050?ooo`80003o0P3oool2
0000o`H0oooo0P000?l30?ooo`80003o1P3oool20000o`80oooo0P000?l40?ooo`80003o103oool2
0000o`D0oooo0P000?l30?ooo`80003o103oool20000o`H0oooo0P000?l40?ooo`80003o103oool2
0000o`<0oooo0P000?l90?ooo`800?ZJ0`3oool2003jVPH0oooo0P00nYX00`3oool00?ZJ003jVP06
0?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX50?ooo`<00?ZJ00<0oooo
003jVP00nYX0203oool1000000005@3oool00`000000oooo0?ooo`060?ooo`80003o0`3oool20000
o`D0oooo0P000?l00`3oool0003o0000o`050?ooo`80003o00<0oooo0000o`000?l0103oool20000
o`80oooo0P000?l70?ooo`80003o1P3oool20000o`80oooo0P000?l90?ooo`@0003o203oool20000
o`<0oooo0`000?l00`3oool0003o0000o`050?ooo`80003o0P3oool20000o`H0oooo0P000?l30?oo
o`80003o1P3oool20000o`80oooo0P000?l40?ooo`80003o103oool30000o`@0oooo0P000?l30?oo
o`80003o103oool20000o`H0oooo0P000?l40?ooo`80003o103oool20000o`<0oooo0P000?l90?oo
o`800?ZJ0`3oool2003jVPH0oooo0P00nYX00`3oool00?ZJ003jVP060?ooo`800?ZJ00<0oooo003j
VP00nYX01@3oool2003jVP<0oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVPP0oooo0@00000001D0
oooo0P0000060?ooo`<0003o0`3oool20000o`D0oooo0P000?l00`3oool0003o0000o`050?ooo`80
003o00<0oooo0000o`000?l0103oool20000o`80oooo0P000?l70?ooo`80003o1P3oool30000o`03
0?ooo`000?l0003o00T0oooo10000?l80?ooo`80003o0`3oool20000o`80oooo0P000?l50?ooo`80
003o0P3oool20000o`H0oooo0P000?l30?ooo`<0003o103oool30000o`80oooo0P000?l40?ooo`80
003o1@3oool20000o`<0oooo0`000?l30?ooo`80003o103oool20000o`H0oooo0P000?l40?ooo`80
003o103oool20000o`<0oooo0P000?l90?ooo`800?ZJ0`3oool2003jVPD0oooo0`00nYX00`3oool0
0?ZJ003jVP060?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX50?ooo`80
0?ZJ0P3oool2003jVPL0oooo0P00000001D0oooo00<000000?ooo`3oool01@3oool20000o`@0oooo
0P000?l40?ooo`<0003o00<0oooo0000o`000?l01@3oool20000o`030?ooo`000?l0003o00@0oooo
0P000?l20?ooo`80003o1`3oool20000o`L0oooo0P000?l00`3oool0003o0000o`090?ooo`@0003o
203oool20000o`<0oooo0P000?l20?ooo`80003o1@3oool20000o`80oooo0P000?l60?ooo`80003o
103oool20000o`@0oooo0P000?l30?ooo`80003o103oool20000o`D0oooo0P000?l30?ooo`80003o
103oool20000o`@0oooo0P000?l60?ooo`80003o103oool20000o`@0oooo0P000?l30?ooo`80003o
2@3oool2003jVP<0oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVPH0oooo0P00nYX00`3oool00?ZJ
003jVP050?ooo`800?ZJ0`3oool2003jVPD0oooo0P00nYX20?ooo`800?ZJ203oool1000000005@3o
ool00`000000oooo0?ooo`050?ooo`80003o103oool20000o`@0oooo0P000?l20?ooo`80003o1@3o
ool20000o`030?ooo`000?l0003o00@0oooo0P000?l20?ooo`80003o1`3oool20000o`L0oooo1@00
0?l:0?ooo`<0003o203oool20000o`<0oooo0P000?l20?ooo`80003o1@3oool20000o`80oooo0P00
0?l60?ooo`80003o103oool20000o`@0oooo0P000?l30?ooo`80003o103oool20000o`D0oooo0P00
0?l30?ooo`80003o103oool20000o`@0oooo0P000?l60?ooo`80003o103oool20000o`@0oooo0P00
0?l30?ooo`80003o2@3oool2003jVP<0oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVPH0oooo0P00
nYX00`3oool00?ZJ003jVP050?ooo`800?ZJ0`3oool2003jVPD0oooo0P00nYX20?ooo`800?ZJ203o
ool1000000005@3oool00`000000oooo0?ooo`050?ooo`80003o103oool20000o`@0oooo0P000?l2
0?ooo`80003o1@3oool20000o`030?ooo`000?l0003o00@0oooo0P000?l20?ooo`80003o1`3oool2
0000o`L0oooo1@000?l:0?ooo`<0003o203oool30000o`80oooo0P000?l20?ooo`80003o1@3oool2
0000o`80oooo0P000?l60?ooo`80003o103oool20000o`<0oooo0`000?l30?ooo`80003o103oool2
0000o`D0oooo0P000?l30?ooo`80003o103oool20000o`@0oooo0P000?l60?ooo`80003o103oool2
0000o`@0oooo0P000?l30?ooo`80003o103oool2003jVP<0oooo0P00nYX30?ooo`800?ZJ1@3oool2
003jVP80oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX5
0?ooo`800?ZJ0P3oool2003jVPP0oooo0@00000001D0oooo0P0000060?ooo`80003o103oool30000
o`<0oooo0P000?l20?ooo`80003o1@3oool20000o`030?ooo`000?l0003o00@0oooo0P000?l20?oo
o`80003o1P3oool30000o`L0oooo1@000?l:0?ooo`<0003o2@3oool20000o`80oooo0P000?l20?oo
o`80003o1@3oool20000o`80oooo0P000?l60?ooo`80003o103oool20000o`<0oooo0`000?l30?oo
o`80003o103oool20000o`D0oooo0P000?l30?ooo`80003o103oool20000o`@0oooo0P000?l60?oo
o`80003o103oool20000o`@0oooo0P000?l30?ooo`80003o103oool2003jVP<0oooo0P00nYX30?oo
o`800?ZJ1@3oool2003jVP80oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003j
VP<0oooo0P00nYX50?ooo`800?ZJ0P3oool3003jVPH0oooo0P00000001D0oooo00<000000?ooo`3o
ool01@3oool20000o`D0oooo0P000?l30?ooo`80003o0P3oool20000o`D0oooo0P000?l00`3oool0
003o0000o`040?ooo`80003o0P3oool20000o`H0oooo0P000?l80?ooo`D0003o2P3oool20000o`X0
oooo0P000?l20?ooo`80003o0P3oool20000o`D0oooo0P000?l20?ooo`80003o1P3oool20000o`@0
oooo0P000?l30?ooo`<0003o0`3oool20000o`@0oooo0P000?l50?ooo`80003o0`3oool20000o`@0
oooo0P000?l40?ooo`80003o1P3oool20000o`<0oooo0`000?l40?ooo`80003o0`3oool20000o`@0
oooo0P00nYX30?ooo`800?ZJ0`3oool2003jVPD0oooo0P00nYX20?ooo`800?ZJ1P3oool2003jVP03
0?ooo`00nYX00?ZJ00@0oooo0`00nYX30?ooo`800?ZJ1@3oool2003jVP<0oooo0P00nYX70?ooo`40
000000070?ooo`<00000103oool2000000D0oooo00<000000?ooo`3oool0103oool30000o`D0oooo
0P000?l30?ooo`80003o0P3oool20000o`D0oooo0P000?l00`3oool0003o0000o`040?ooo`80003o
0P3oool20000o`H0oooo0P000?l:0?ooo`80003o2`3oool20000o`X0oooo0P000?l20?ooo`80003o
0P3oool20000o`D0oooo0P000?l20?ooo`80003o1@3oool30000o`@0oooo0P000?l30?ooo`<0003o
0`3oool20000o`@0oooo0P000?l50?ooo`80003o0`3oool20000o`@0oooo0P000?l40?ooo`80003o
1P3oool20000o`<0oooo0P000?l50?ooo`80003o0`3oool20000o`@0oooo0P00nYX30?ooo`800?ZJ
0`3oool2003jVPD0oooo0P00nYX20?ooo`800?ZJ1P3oool2003jVP030?ooo`00nYX00?ZJ00@0oooo
0P00nYX40?ooo`800?ZJ1@3oool2003jVP<0oooo0P00nYX70?ooo`40000000060?ooo`050000003o
ool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00@0
oooo0`000?l50?ooo`80003o0`3oool20000o`80oooo0P000?l50?ooo`80003o00<0oooo0000o`00
0?l0103oool20000o`80oooo0P000?l60?ooo`80003o2P3oool20000oaL0oooo0P000?l20?ooo`80
003o0P3oool20000o`D0oooo0P000?l20?ooo`80003o1@3oool20000o`D0oooo0P000?l30?ooo`<0
003o0`3oool20000o`@0oooo0P000?l50?ooo`80003o0`3oool20000o`@0oooo0P000?l40?ooo`80
003o1P3oool20000o`80oooo0`000?l50?ooo`80003o0`3oool20000o`@0oooo0P00nYX30?ooo`80
0?ZJ0`3oool3003jVP@0oooo0P00nYX20?ooo`800?ZJ1P3oool2003jVP030?ooo`00nYX00?ZJ00@0
oooo0P00nYX40?ooo`800?ZJ1@3oool2003jVP<0oooo0P00nYX70?ooo`400000000:0?ooo`040000
003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool2000000D0oooo0P000?l60?ooo`80
003o0`3oool20000o`80oooo0P000?l50?ooo`80003o00<0oooo0000o`000?l0103oool20000o`80
oooo0P000?l60?ooo`80003o8`3oool20000o`80oooo0P000?l20?ooo`80003o1@3oool20000o`80
oooo0P000?l50?ooo`80003o1@3oool20000o`<0oooo0P000?l40?ooo`80003o103oool20000o`D0
oooo0`000?l20?ooo`80003o103oool20000o`@0oooo0P000?l60?ooo`80003o0P3oool20000o`H0
oooo0P000?l30?ooo`80003o103oool2003jVP<0oooo0P00nYX40?ooo`800?ZJ103oool2003jVP80
oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00nYX0103oool2003jVP@0oooo0P00nYX50?ooo`80
0?ZJ0`3oool2003jVPD0oooo0`00000000X0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo0P000?l60?ooo`<0003o0P3oool20000o`80
oooo0P000?l40?ooo`<0003o00<0oooo0000o`000?l0103oool20000o`80oooo0P000?l60?ooo`80
003o8`3oool20000o`80oooo0P000?l20?ooo`80003o103oool30000o`80oooo0`000?l40?ooo`80
003o1@3oool20000o`<0oooo0P000?l40?ooo`80003o103oool20000o`H0oooo0P000?l20?ooo`80
003o103oool20000o`@0oooo0P000?l60?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`<0
003o103oool2003jVP80oooo0`00nYX40?ooo`800?ZJ103oool2003jVP80oooo0P00nYX50?ooo`<0
0?ZJ00<0oooo003jVP00nYX0103oool2003jVP@0oooo0P00nYX50?ooo`800?ZJ0`3oool2003jVPL0
oooo0@00000000H0oooo100000030?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3o
ool0103oool20000o`L0oooo0P000?l20?ooo`80003o0P3oool20000o`@0oooo0P000?l20?ooo`80
003o103oool20000o`80oooo0P000?l60?ooo`80003o8`3oool20000o`80oooo0P000?l20?ooo`80
003o103oool20000o`@0oooo0P000?l40?ooo`80003o1@3oool20000o`80oooo0`000?l40?ooo`80
003o103oool20000o`H0oooo0P000?l20?ooo`80003o103oool20000o`@0oooo0P000?l60?ooo`80
003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o1@3oool2003jVP80oooo0P00nYX50?ooo`80
0?ZJ103oool2003jVP80oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVP@0oooo0P00nYX40?ooo`80
0?ZJ1@3oool2003jVP<0oooo0P00nYX70?ooo`40000000060?ooo`030000003oool0oooo00@0oooo
00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`040?ooo`80003o1`3oool20000o`04
0?ooo`000?l0003o0000o`80oooo0P000?l40?ooo`80003o0P3oool20000o`@0oooo0P000?l20?oo
o`<0003o1@3oool20000ob<0oooo0P000?l20?ooo`80003o0P3oool20000o`@0oooo0P000?l40?oo
o`80003o103oool20000o`D0oooo0P000?l20?ooo`80003o1@3oool20000o`@0oooo0P000?l60?oo
o`80003o0P3oool20000o`@0oooo0P000?l30?ooo`<0003o1P3oool60000o`H0oooo0`000?l00`3o
ool0003o0000o`050?ooo`800?ZJ0P3oool2003jVPD0oooo0P00nYX40?ooo`800?ZJ0P3oool2003j
VPD0oooo0P00nYX20?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX40?ooo`<00?ZJ0`3oool2003j
VPL0oooo0@00000000H0oooo1@0000030?ooo`8000001@3oool2000000D0oooo0P000?l70?ooo`80
003o00<0oooo0000o`000?l00`3oool30000o`<0oooo0P000?l20?ooo`80003o0`3oool30000o`<0
oooo0P000?l40?ooo`<0003o8`3oool20000o`80oooo0P000?l20?ooo`80003o103oool20000o`@0
oooo0P000?l40?ooo`80003o1@3oool20000o`80oooo0P000?l50?ooo`80003o103oool20000o`H0
oooo0P000?l20?ooo`80003o103oool30000o`80oooo0P000?l80?ooo`D0003o1`3oool20000o`03
0?ooo`000?l0003o00D0oooo0`00nYX00`3oool00?ZJ003jVP050?ooo`800?ZJ103oool2003jVP80
oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVP@0oooo0P00nYX40?ooo`800?ZJ103oool2003jVP@0
oooo0P00nYX60?ooo`800000000E0?ooo`030000003oool0oooo00@0oooo0P000?l70?ooo`80003o
00<0oooo0000o`000?l0103oool20000o`<0oooo0P000?l20?ooo`80003o0`3oool20000o`@0oooo
0P000?l40?ooo`80003o903oool20000o`80oooo0P000?l20?ooo`80003o103oool20000o`@0oooo
0P000?l40?ooo`80003o1@3oool20000o`80oooo0P000?l50?ooo`<0003o0P3oool30000o`H0oooo
0P000?l20?ooo`80003o1@3oool20000o`80oooo0P000?l80?ooo`D0003o1`3oool20000o`030?oo
o`000?l0003o00H0oooo0P00nYX00`3oool00?ZJ003jVP050?ooo`800?ZJ103oool2003jVP80oooo
0P00nYX50?ooo`800?ZJ0P3oool2003jVP@0oooo0P00nYX40?ooo`800?ZJ103oool2003jVP@0oooo
0P00nYX70?ooo`400000000E0?ooo`030000003oool0oooo00@0oooo0P000?l70?ooo`80003o00<0
oooo0000o`000?l0103oool20000o`<0oooo0P000?l20?ooo`<0003o0P3oool20000o`@0oooo0P00
0?l40?ooo`80003o903oool30000o`030?ooo`000?l0003o0080oooo0P000?l40?ooo`80003o103o
ool20000o`@0oooo0P000?l50?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o1`3o
ool30000o`030?ooo`000?l0003o00D0oooo0P000?l20?ooo`80003o203oool40000o`P0oooo0P00
0?l00`3oool0003o0000o`060?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003jVP@0oooo0P00
nYX20?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYX40?ooo`800?ZJ103oool2003jVP@0oooo0P00
nYX40?ooo`800?ZJ1`3oool1000000005@3oool00`000000oooo0?ooo`040?ooo`80003o1`3oool5
0000o`@0oooo0P000?l30?ooo`80003o0`3oool20000o`80oooo0P000?l40?ooo`80003o103oool2
0000obD0oooo0P000?l00`3oool0003o0000o`020?ooo`80003o103oool20000o`@0oooo0P000?l4
0?ooo`80003o1@3oool20000o`80oooo0P000?l60?ooo`80003o0P3oool20000o`P0oooo1@000?l5
0?ooo`80003o0P3oool20000o`P0oooo10000?l80?ooo`80003o00<0oooo0000o`000?l01P3oool2
003jVP030?ooo`00nYX00?ZJ00D0oooo0P00nYX30?ooo`<00?ZJ0P3oool2003jVPD0oooo0P00nYX2
0?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX40?ooo`800?ZJ103oool2003jVPL0oooo0@000000
01D0oooo0P0000050?ooo`80003o203oool40000o`@0oooo0P000?l30?ooo`80003o0`3oool20000
o`80oooo0P000?l40?ooo`80003o103oool20000obD0oooo1@000?l20?ooo`80003o103oool20000
o`@0oooo0P000?l30?ooo`<0003o1@3oool20000o`80oooo0P000?l60?ooo`80003o0P3oool20000
o`P0oooo10000?l60?ooo`80003o0P3oool20000o`P0oooo10000?l80?ooo`80003o00<0oooo0000
o`000?l01P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo0P00nYX30?ooo`800?ZJ0`3oool2003j
VPD0oooo0P00nYX20?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX40?ooo`800?ZJ103oool2003j
VPH0oooo0P00000001D0oooo00<000000?ooo`3oool0103oool20000o`P0oooo10000?l40?ooo`80
003o0`3oool20000o`<0oooo0P000?l20?ooo`80003o103oool20000o`@0oooo0P000?lU0?ooo`@0
003o0`3oool20000o`@0oooo0P000?l40?ooo`80003o0`3oool20000o`H0oooo0P000?l20?ooo`80
003o1P3oool20000o`80oooo0P000?l80?ooo`@0003o1P3oool20000o`80oooo0P000?l80?ooo`@0
003o203oool20000o`030?ooo`000?l0003o00H0oooo0P00nYX00`3oool00?ZJ003jVP050?ooo`80
0?ZJ0`3oool2003jVP<0oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVP@0oooo0P00nYX40?ooo`80
0?ZJ103oool2003jVP@0oooo0P00nYX70?ooo`400000000E0?ooo`030000003oool0oooo00@0oooo
0P000?l80?ooo`@0003o103oool20000o`<0oooo0P000?l30?ooo`80003o0P3oool20000o`@0oooo
0P000?l40?ooo`80003o9@3oool40000o`<0oooo0P000?l40?ooo`80003o103oool20000o`<0oooo
0P000?l60?ooo`80003o0P3oool20000o`H0oooo0P000?l20?ooo`80003o203oool40000o`H0oooo
0P000?l20?ooo`80003o203oool40000o`P0oooo0P000?l00`3oool0003o0000o`060?ooo`800?ZJ
00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX30?ooo`800?ZJ1@3oool2003jVP80oooo
0P00nYX40?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX40?ooo`800?ZJ1`3oool1000000005@3o
ool00`000000oooo0?ooo`040?ooo`80003o203oool40000o`@0oooo0P000?l30?ooo`80003o0`3o
ool20000o`80oooo0P000?l40?ooo`80003o0`3oool30000obD0oooo10000?l30?ooo`80003o103o
ool20000o`@0oooo0P000?l30?ooo`80003o1P3oool20000o`80oooo0P000?l60?ooo`80003o0P3o
ool20000o`T0oooo0`000?l60?ooo`80003o0P3oool20000o`P0oooo10000?l80?ooo`80003o00<0
oooo0000o`000?l01P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo0P00nYX30?ooo`800?ZJ0`3o
ool3003jVP@0oooo0P00nYX20?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX40?ooo`800?ZJ103o
ool2003jVPL0oooo0@00000001D0oooo0P0000050?ooo`80003o203oool40000o`@0oooo0P000?l3
0?ooo`80003o0`3oool20000o`80oooo0P000?l40?ooo`80003o0`3oool20000obH0oooo10000?l3
0?ooo`80003o103oool20000o`@0oooo0P000?l30?ooo`80003o1P3oool20000o`80oooo0P000?l6
0?ooo`80003o0P3oool20000o`T0oooo0`000?l60?ooo`80003o0P3oool20000o`P0oooo0P000?l:
0?ooo`80003o00<0oooo0000o`000?l01P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo0P00nYX3
0?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX20?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX4
0?ooo`800?ZJ103oool2003jVPH0oooo0P00000001D0oooo00<000000?ooo`3oool00`3oool30000
o`P0oooo10000?l40?ooo`80003o0`3oool20000o`<0oooo0P000?l20?ooo`80003o103oool20000
o`<0oooo0P000?lV0?ooo`@0003o0`3oool20000o`@0oooo0P000?l40?ooo`80003o0P3oool30000
o`H0oooo0P000?l20?ooo`80003o1P3oool20000o`80oooo0P000?lB0?ooo`80003o0P3oool20000
oa@0oooo0P000?l00`3oool0003o0000o`060?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003j
VP<0oooo0P00nYX40?ooo`800?ZJ103oool2003jVP80oooo0P00nYX40?ooo`800?ZJ103oool2003j
VP<0oooo0`00nYX40?ooo`800?ZJ1`3oool1000000005@3oool00`000000oooo0?ooo`030?ooo`80
003o2@3oool40000o`@0oooo0P000?l30?ooo`80003o0`3oool20000o`80oooo0P000?l40?ooo`80
003o0`3oool20000obL0oooo0`000?l30?ooo`80003o103oool20000o`@0oooo0P000?l20?ooo`80
003o1`3oool20000o`80oooo0P000?l60?ooo`80003o0P3oool20000oa80oooo0P000?l20?ooo`80
003o503oool20000o`030?ooo`000?l0003o00H0oooo1@00nYX50?ooo`800?ZJ0`3oool2003jVP@0
oooo0P00nYX40?ooo`800?ZJ0P3oool2003jVP@0oooo0P00nYX40?ooo`800?ZJ0`3oool3003jVP@0
oooo0P00nYX70?ooo`400000000E0?ooo`030000003oool0oooo00<0oooo0P000?l90?ooo`@0003o
103oool20000o`<0oooo0P000?l30?ooo`80003o0P3oool20000o`@0oooo0P000?l30?ooo`80003o
9`3oool30000o`<0oooo0P000?l40?ooo`80003o103oool20000o`80oooo0P000?l70?ooo`80003o
00@0oooo0000o`000?l0003o1P3oool20000o`80oooo0P000?lB0?ooo`80003o00@0oooo0000o`00
0?l0003o503oool20000o`030?ooo`000?l0003o00L0oooo1000nYX50?ooo`800?ZJ0`3oool2003j
VP@0oooo0P00nYX40?ooo`800?ZJ0P3oool2003jVP@0oooo0P00nYX40?ooo`800?ZJ0`3oool3003j
VP@0oooo0P00nYX70?ooo`400000000E0?ooo`800000103oool20000o`T0oooo10000?l40?ooo`80
003o0`3oool20000o`<0oooo0P000?l20?ooo`80003o103oool20000o`<0oooo0P000?lW0?ooo`<0
003o0`3oool20000o`<0oooo0`000?l40?ooo`80003o0P3oool20000o`L0oooo0P000?l00`3oool0
003o0000o`070?ooo`80003o0P3oool20000oa80oooo0P000?l00`3oool0003o0000o`0E0?ooo`80
003o00<0oooo0000o`000?l01`3oool4003jVPD0oooo0`00nYX20?ooo`800?ZJ103oool2003jVP@0
oooo0P00nYX20?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX30?ooo`<00?ZJ103oool2003jVPH0
oooo0P00000001D0oooo00<000000?ooo`3oool00`3oool20000o`T0oooo10000?l40?ooo`80003o
0`3oool20000o`<0oooo0P000?l20?ooo`80003o103oool20000o`<0oooo0P000?lX0?ooo`80003o
0`3oool20000o`<0oooo0P000?l50?ooo`80003o0P3oool20000o`L0oooo0P000?l00`3oool0003o
0000o`070?ooo`80003o0P3oool20000oa80oooo0P000?l00`3oool0003o0000o`0E0?ooo`80003o
00<0oooo0000o`000?l01`3oool4003jVPH0oooo0P00nYX20?ooo`800?ZJ103oool2003jVP@0oooo
0P00nYX20?ooo`800?ZJ103oool2003jVP@0oooo0`00nYX20?ooo`800?ZJ1@3oool2003jVPL0oooo
0@00000000P0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3oool00`3o
ool20000o`T0oooo10000?l40?ooo`80003o0`3oool20000o`<0oooo0P000?l20?ooo`80003o103o
ool20000o`<0oooo0P000?lX0?ooo`80003o0`3oool20000o`<0oooo0P000?l50?ooo`80003o0P3o
ool20000o`L0oooo0P000?l00`3oool0003o0000o`070?ooo`80003o0P3oool20000oa80oooo0P00
0?l00`3oool0003o0000o`0E0?ooo`80003o00<0oooo0000o`000?l01`3oool4003jVPH0oooo0P00
nYX20?ooo`800?ZJ103oool2003jVP@0oooo0P00nYX20?ooo`800?ZJ103oool2003jVPD0oooo0P00
nYX20?ooo`800?ZJ1@3oool2003jVPL0oooo0@00000000P0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool20000o`T0oooo1000
0?l40?ooo`80003o0`3oool20000o`<0oooo0P000?l20?ooo`80003o103oool20000o`<0oooo0P00
0?l]0?ooo`80003o0`3oool20000o`D0oooo0P000?l20?ooo`80003o1`3oool20000o`030?ooo`00
0?l0003o00L0oooo0P000?l20?ooo`80003o4P3oool20000o`030?ooo`000?l0003o01D0oooo1@00
0?l70?ooo`<00?ZJ1`3oool2003jVP80oooo0P00nYX40?ooo`800?ZJ103oool2003jVP80oooo0P00
nYX40?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYX50?ooo`800?ZJ1`3oool1000000002@3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo0P0000040?ooo`80003o2@3oool4
0000o`@0oooo0P000?l20?ooo`<0003o0`3oool20000o`80oooo0P000?l40?ooo`80003o0`3oool2
0000obd0oooo0P000?l30?ooo`80003o1@3oool20000o`80oooo0P000?l70?ooo`D0003o1`3oool2
0000o`80oooo0P000?lB0?ooo`D0003o5@3oool40000o`T0oooo0P00nYX70?ooo`800?ZJ0P3oool2
003jVP@0oooo0P00nYX40?ooo`800?ZJ0P3oool2003jVP@0oooo0P00nYX50?ooo`800?ZJ0P3oool2
003jVPD0oooo0P00nYX50?ooo`<0000000090?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`030?ooo`80003o2P3oool20000o`D0oooo0P000?l20?oo
o`80003o103oool20000o`80oooo0P000?l40?ooo`80003o0`3oool20000obd0oooo0P000?l30?oo
o`80003o1@3oool20000o`80oooo0P000?l80?ooo`@0003o1`3oool20000o`80oooo0P000?lB0?oo
o`@0003o5P3oool40000o`T0oooo0P00nYX70?ooo`800?ZJ0P3oool2003jVP@0oooo0P00nYX40?oo
o`800?ZJ0P3oool2003jVP@0oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVPD0oooo0P00nYX70?oo
o`400000000:0?ooo`030000003oool0000000<000001@3oool00`000000oooo0?ooo`030?ooo`80
003o2P3oool20000o`D0oooo0P000?l20?ooo`80003o103oool20000o`040?ooo`000?l0003o0000
o`@0oooo0P000?l30?ooo`80003o;@3oool20000o`<0oooo0P000?l50?ooo`80003o0P3oool20000
o`P0oooo10000?l70?ooo`80003o0P3oool20000oa80oooo10000?lF0?ooo`@0003o2@3oool2003j
VPL0oooo0P00nYX20?ooo`800?ZJ103oool2003jVP<0oooo0`00nYX20?ooo`800?ZJ103oool2003j
VPD0oooo0P00nYX20?ooo`800?ZJ1@3oool3003jVPH0oooo0@00000000H0oooo00L000000?ooo`3o
ool0oooo0000003oool0000000P0oooo00<000000?ooo`3oool00`3oool20000o`X0oooo0P000?l5
0?ooo`80003o0P3oool20000o`@0oooo0P000?l00`3oool0003o0000o`050?ooo`80003o0P3oool3
0000obd0oooo0P000?l30?ooo`80003o1@3oool20000o`80oooo0P000?l80?ooo`@0003o1`3oool2
0000o`80oooo0P000?lB0?ooo`@0003o5P3oool40000o`T0oooo0P00nYX70?ooo`800?ZJ00@0oooo
003jVP00nYX00?ZJ103oool2003jVP<0oooo0P00nYX30?ooo`800?ZJ103oool2003jVPD0oooo0P00
nYX20?ooo`800?ZJ1P3oool2003jVPH0oooo0@00000000H0oooo1@0000000`3oool0000000000003
000000@0oooo0P0000040?ooo`80003o2P3oool20000o`D0oooo0P000?l20?ooo`80003o103oool2
0000o`030?ooo`000?l0003o00D0oooo0P000?l20?ooo`80003o;P3oool20000o`<0oooo0P000?l5
0?ooo`80003o0P3oool20000o`P0oooo10000?l70?ooo`80003o0P3oool20000oa80oooo10000?lF
0?ooo`@0003o4P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo0P00nYX30?ooo`800?ZJ0`3oool2
003jVP@0oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVPH0oooo0P00nYX50?ooo`800000000E0?oo
o`030000003oool0oooo0080oooo0`000?l:0?ooo`80003o1@3oool20000o`80oooo0P000?l40?oo
o`80003o00<0oooo0000o`000?l01@3oool20000o`80oooo0P000?l^0?ooo`80003o0P3oool30000
o`D0oooo0`000?l00`3oool0003o0000o`080?ooo`@0003o1`3oool20000o`80oooo0P000?lC0?oo
o`<0003o5P3oool40000oa80oooo0P00nYX00`3oool00?ZJ003jVP050?ooo`800?ZJ0`3oool2003j
VP<0oooo0P00nYX40?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYX60?ooo`800?ZJ1P3oool10000
00005@3oool00`000000oooo0?ooo`020?ooo`<0003o2P3oool20000o`D0oooo0P000?l20?ooo`80
003o103oool20000o`030?ooo`000?l0003o00D0oooo0P000?l20?ooo`80003o;P3oool20000o`80
oooo0P000?l70?ooo`D0003o203oool40000o`L0oooo0P000?l20?ooo`80003o4`3oool30000oaL0
oooo0`000?lB0?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX30?ooo`80
0?ZJ103oool2003jVPD0oooo0P00nYX20?ooo`800?ZJ1P3oool2003jVPH0oooo0@00000001D0oooo
00<000000?ooo`3oool00P3oool30000o`X0oooo0P000?l50?ooo`80003o0P3oool20000o`@0oooo
0P000?l00`3oool0003o0000o`050?ooo`80003o0P3oool20000obh0oooo0P000?l20?ooo`80003o
1`3oool40000o`T0oooo10000?l70?ooo`80003o0P3oool20000oa<0oooo0P000?lH0?ooo`<0003o
4P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo0P00nYX30?ooo`800?ZJ0`3oool2003jVP<0oooo
0`00nYX50?ooo`800?ZJ0P3oool2003jVPH0oooo0P00nYX60?ooo`400000000E0?ooo`800000103o
ool20000o`X0oooo0P000?l50?ooo`80003o0P3oool20000o`@0oooo0P000?l00`3oool0003o0000
o`050?ooo`80003o0P3oool20000obh0oooo0P000?l20?ooo`80003o1`3oool40000o`T0oooo1000
0?l70?ooo`80003o00@0oooo0000o`000?l0003o4`3oool20000oaP0oooo0`000?lB0?ooo`800?ZJ
00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX30?ooo`800?ZJ0`3oool2003jVPH0oooo
0P00nYX20?ooo`800?ZJ1P3oool2003jVPD0oooo0P00000001D0oooo00<000000?ooo`3oool03`3o
ool20000o`D0oooo0P000?l20?ooo`80003o103oool20000o`030?ooo`000?l0003o00D0oooo0P00
0?l20?ooo`80003o;P3oool20000o`80oooo0P000?l70?ooo`@0003o2@3oool40000o`L0oooo0P00
0?l00`3oool0003o0000o`0D0?ooo`80003o603oool30000oa80oooo0P00nYX00`3oool00?ZJ003j
VP050?ooo`800?ZJ0`3oool2003jVP<0oooo0P00nYX30?ooo`800?ZJ1P3oool2003jVP040?ooo`00
nYX00?ZJ003jVPH0oooo0P00nYX60?ooo`400000000E0?ooo`030000003oool0oooo00l0oooo0P00
0?l50?ooo`80003o00@0oooo0000o`000?l0003o103oool20000o`030?ooo`000?l0003o00D0oooo
0P000?l20?ooo`80003o;P3oool20000o`80oooo0P000?l70?ooo`@0003o2@3oool40000o`L0oooo
0P000?l00`3oool0003o0000o`0^0?ooo`<0003o4P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo
0P00nYX30?ooo`800?ZJ0`3oool2003jVP<0oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00nYX0
1`3oool2003jVPH0oooo0@00000001D0oooo00<000000?ooo`3oool05P3oool50000o`D0oooo0P00
0?l00`3oool0003o0000o`050?ooo`80003o0P3oool20000obh0oooo0P000?l20?ooo`80003o1`3o
ool40000o`T0oooo0`000?l80?ooo`80003o00<0oooo0000o`000?l0;P3oool30000oa80oooo0P00
nYX00`3oool00?ZJ003jVP050?ooo`800?ZJ0`3oool2003jVP<0oooo0P00nYX30?ooo`800?ZJ1P3o
ool2003jVP030?ooo`00nYX00?ZJ00L0oooo0P00nYX60?ooo`400000000E0?ooo`800000603oool4
0000o`D0oooo0P000?l00`3oool0003o0000o`050?ooo`80003o0P3oool20000obh0oooo0`000?l0
0`3oool0003o0000o`070?ooo`@0003o2@3oool30000o`P0oooo0P000?l00`3oool0003o0000o`0^
0?ooo`<0003o4P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo0P00nYX30?ooo`800?ZJ0`3oool2
003jVP<0oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00nYX01`3oool2003jVPD0oooo0P000000
01D0oooo00<000000?ooo`3oool05`3oool40000o`D0oooo0P000?l00`3oool0003o0000o`050?oo
o`80003o0P3oool20000obl0oooo0P000?l00`3oool0003o0000o`070?ooo`@0003o2@3oool30000
o`P0oooo0P000?l00`3oool0003o0000o`0^0?ooo`<0003o4P3oool2003jVP030?ooo`00nYX00?ZJ
00D0oooo0P00nYX30?ooo`800?ZJ0`3oool3003jVP80oooo0P00nYX60?ooo`800?ZJ00<0oooo003j
VP00nYX01`3oool2003jVPH0oooo0@00000001D0oooo00<000000?ooo`3oool05`3oool40000o`D0
oooo0P000?l00`3oool0003o0000o`050?ooo`80003o0P3oool20000obl0oooo0P000?l00`3oool0
003o0000o`070?ooo`@0003o2@3oool30000o`P0oooo0P000?l00`3oool0003o0000o`0^0?ooo`<0
003o4P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo0P00nYX30?ooo`800?ZJ103oool2003jVP80
oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00nYX01`3oool2003jVPH0oooo0@00000001D0oooo
00<000000?ooo`3oool05`3oool40000o`D0oooo0P000?l00`3oool0003o0000o`050?ooo`80003o
0P3oool20000obl0oooo0P000?l00`3oool0003o0000o`070?ooo`@0003o2@3oool30000o`P0oooo
0P000?l00`3oool0003o0000o`0^0?ooo`<0003o4P3oool2003jVP030?ooo`00nYX00?ZJ00D0oooo
0P00nYX30?ooo`800?ZJ103oool2003jVP80oooo0P00nYX60?ooo`800?ZJ00<0oooo003jVP00nYX0
1`3oool2003jVPH0oooo0@00000001D0oooo0P00000H0?ooo`@0003o1@3oool20000o`030?ooo`00
0?l0003o00D0oooo0P000?l20?ooo`80003o;`3oool20000o`030?ooo`000?l0003o00L0oooo1000
0?l90?ooo`<0003o203oool20000o`030?ooo`000?l0003o02h0oooo0P000?lC0?ooo`800?ZJ00<0
oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX40?ooo`800?ZJ0P3oool2003jVPH0oooo0P00
nYX00`3oool00?ZJ003jVP070?ooo`800?ZJ1@3oool2000000005@3oool00`000000oooo0?ooo`0G
0?ooo`@0003o1@3oool20000o`030?ooo`000?l0003o00D0oooo0P000?l20?ooo`80003o;`3oool5
0000o`L0oooo10000?l90?ooo`<0003o203oool20000o`030?ooo`000?l0003o02h0oooo0P000?lC
0?ooo`800?ZJ00<0oooo003jVP00nYX01@3oool2003jVP<0oooo0P00nYX40?ooo`800?ZJ0P3oool2
003jVPH0oooo0P00nYX00`3oool00?ZJ003jVP070?ooo`800?ZJ1P3oool10000000000@0oooo0000
000000000000103oool2000000@0oooo0P0000050?ooo`030000003oool0oooo01L0oooo10000?l5
0?ooo`80003o00<0oooo0000o`000?l01@3oool20000o`80oooo0P000?l_0?ooo`@0003o203oool4
0000o`X0oooo0P000?l80?ooo`80003o00<0oooo0000o`000?l0;P3oool20000oa<0oooo0P00nYX0
0`3oool00?ZJ003jVP050?ooo`800?ZJ0P3oool3003jVP@0oooo0P00nYX20?ooo`800?ZJ1P3oool2
003jVP030?ooo`00nYX00?ZJ00L0oooo0P00nYX60?ooo`40000000020?ooo`030000003oool0oooo
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo01L0oooo0`000?l60?ooo`80003o00<0oooo0000o`000?l01@3oool20000o`80oooo0P00
0?l_0?ooo`@0003o203oool40000oa@0oooo0P000?l00`3oool0003o0000o`0^0?ooo`80003o4`3o
ool5003jVPD0oooo0P00nYX20?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYX60?ooo`800?ZJ00<0
oooo003jVP00nYX01`3oool2003jVPH0oooo0@0000000080oooo00<000000?ooo`3oool00P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo0P00000H0?ooo`<0003o
1P3oool20000o`030?ooo`000?l0003o00D0oooo0P000?l20?ooo`80003o;`3oool40000o`P0oooo
10000?lD0?ooo`80003o00<0oooo0000o`000?l0;P3oool20000oa@0oooo1000nYX50?ooo`800?ZJ
0P3oool2003jVPD0oooo0P00nYX20?ooo`800?ZJ1P3oool2003jVP030?ooo`00nYX00?ZJ00L0oooo
0P00nYX40?ooo`<0000000020?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo01L0oooo0`000?l60?ooo`80
003o00<0oooo0000o`000?l01@3oool20000o`80oooo0P000?l_0?ooo`@0003o203oool40000oa@0
oooo0P000?l00`3oool0003o0000o`0^0?ooo`80003o503oool3003jVPH0oooo0P00nYX20?ooo`80
0?ZJ1@3oool2003jVP80oooo0P00nYX60?ooo`D00?ZJ1`3oool2003jVPH0oooo0@0000000080oooo
00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
00@0oooo00<000000?ooo`3oool05`3oool30000o`H0oooo0P000?l00`3oool0003o0000o`050?oo
o`80003o0P3oool20000obl0oooo10000?l80?ooo`@0003o503oool20000o`030?ooo`000?l0003o
02h0oooo0P000?lD0?ooo`<00?ZJ1P3oool2003jVP80oooo0P00nYX50?ooo`800?ZJ0P3oool2003j
VPL0oooo1000nYX70?ooo`800?ZJ1P3oool10000000000<0oooo000000000000103oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool05`3oool3
0000o`H0oooo0P000?l00`3oool0003o0000o`050?ooo`80003o0P3oool20000obl0oooo10000?l8
0?ooo`@0003o503oool20000o`030?ooo`000?l0003o02h0oooo0P000?lD0?ooo`<00?ZJ1P3oool2
003jVP80oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVPL0oooo1000nYX70?ooo`800?ZJ1P3oool1
000000000P3oool00`000000oooo0?ooo`030?ooo`800000103oool2000000D0oooo0P00000H0?oo
o`<0003o1P3oool20000o`030?ooo`000?l0003o00D0oooo0P000?l0103oool0003o0000o`000?l_
0?ooo`@0003o203oool40000oa@0oooo0P000?l00`3oool0003o0000o`0^0?ooo`80003o503oool3
003jVPH0oooo0P00nYX20?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYX70?ooo`@00?ZJ1`3oool2
003jVPD0oooo0P00000001D0oooo00<000000?ooo`3oool05`3oool20000o`L0oooo1@000?l50?oo
o`80003o00<0oooo0000o`000?l0<03oool40000o`P0oooo10000?lD0?ooo`80003o00<0oooo0000
o`000?l0A03oool3003jVPH0oooo0P00nYX20?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYX70?oo
o`@00?ZJ1`3oool2003jVPH0oooo0@00000001D0oooo00<000000?ooo`3oool05`3oool20000o`L0
oooo10000?l60?ooo`80003o00<0oooo0000o`000?l0<03oool40000o`P0oooo10000?lD0?ooo`D0
003oA03oool3003jVPH0oooo0P00nYX20?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYX70?ooo`<0
0?ZJ203oool2003jVPH0oooo0@00000001D0oooo00<000000?ooo`3oool0803oool40000o`H0oooo
1@000?l`0?ooo`@0003o203oool40000oaD0oooo0`000?m50?ooo`<00?ZJ1P3oool2003jVP80oooo
0P00nYX50?ooo`800?ZJ0P3oool2003jVQ80oooo0P00nYX60?ooo`400000000E0?ooo`8000008@3o
ool40000o`L0oooo10000?l`0?ooo`@0003o203oool40000oaD0oooo0`000?m50?ooo`<00?ZJ1P3o
ool2003jVP80oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVQ80oooo0P00nYX50?ooo`800000000E
0?ooo`030000003oool0oooo0200oooo10000?l70?ooo`@0003o<03oool40000o`P0oooo10000?lE
0?ooo`<0003oA@3oool3003jVPH0oooo0P00nYX20?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYXB
0?ooo`800?ZJ1P3oool1000000005@3oool00`000000oooo0?ooo`0P0?ooo`@0003o1`3oool40000
oc00oooo10000?l80?ooo`<0003o5P3oool30000odD0oooo0`00nYX60?ooo`800?ZJ0P3oool2003j
VPD0oooo0P00nYX20?ooo`800?ZJ4P3oool2003jVPH0oooo0@00000001D0oooo00<000000?ooo`3o
ool0803oool40000o`L0oooo10000?l`0?ooo`@0003o2@3oool20000oaH0oooo0`000?m50?ooo`<0
0?ZJ1P3oool2003jVP80oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVQ80oooo0P00nYX60?ooo`40
0000000E0?ooo`8000008@3oool40000o`L0oooo10000?l`0?ooo`@0003o2@3oool20000oaH0oooo
0`000?m50?ooo`800?ZJ1`3oool2003jVP80oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVQ80oooo
0P00nYX50?ooo`800000000E0?ooo`030000003oool0oooo0200oooo10000?l70?ooo`@0003o<03o
ool40000o`T0oooo0P000?lF0?ooo`<0003oA@3oool2003jVPL0oooo0P00nYX20?ooo`800?ZJ1@3o
ool2003jVP80oooo0P00nYXB0?ooo`800?ZJ1P3oool1000000005@3oool00`000000oooo0?ooo`0P
0?ooo`@0003o1`3oool40000oc00oooo10000?l90?ooo`80003o5P3oool30000odh0oooo0P00nYX2
0?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYXB0?ooo`800?ZJ1P3oool1000000005@3oool00`00
0000oooo0?ooo`0P0?ooo`@0003o1`3oool40000oc00oooo10000?l90?ooo`80003o5P3oool30000
odh0oooo0P00nYX20?ooo`800?ZJ1@3oool2003jVP80oooo0P00nYXB0?ooo`800?ZJ1P3oool10000
00005@3oool200000240oooo10000?l70?ooo`@0003o<03oool40000o`T0oooo0P000?lF0?ooo`<0
003oCP3oool2003jVP80oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVQ80oooo0P00nYX50?ooo`80
0000000E0?ooo`030000003oool0oooo0200oooo10000?l70?ooo`@0003o<03oool40000o`T0oooo
0P000?lF0?ooo`<0003oCP3oool2003jVP80oooo0P00nYX50?ooo`800?ZJ0P3oool2003jVQ80oooo
0P00nYX60?ooo`4000000000103oool000000000000000020?ooo`D000000P3oool3000000D0oooo
00<000000?ooo`3oool0803oool40000o`L0oooo10000?l`0?ooo`@0003o2@3oool20000oaH0oooo
0`000?m>0?ooo`<00?ZJ00<0oooo003jVP00nYX01@3oool2003jVP80oooo0P00nYXB0?ooo`800?ZJ
1P3oool1000000000P3oool00`000000oooo0?ooo`020?ooo`060000003oool0oooo0000003oool0
00000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0200oooo10000?l70?ooo`@0
003o<03oool30000o`X0oooo0P000?lF0?ooo`<0003oC`3oool5003jVPD0oooo0P00nYX20?ooo`80
0?ZJ4P3oool2003jVPH0oooo0@0000000080oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`050?ooo`030000003oool0oooo0080oooo0P00000Q0?ooo`@0003o1`3oool40000oc00oooo
0`000?l:0?ooo`80003o5P3oool30000odl0oooo1000nYX60?ooo`800?ZJ0P3oool2003jVQ80oooo
0`00nYX30?ooo`<0000000020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0240oooo0`000?l70?ooo`@0003o<03o
ool30000o`X0oooo0P000?lF0?ooo`<0003oC`3oool4003jVPH0oooo0P00nYX20?ooo`800?ZJ4`3o
ool2003jVPD0oooo0@0000000080oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003o
ool0000000<000001@3oool00`000000oooo0?ooo`0Q0?ooo`<0003o1`3oool30000oc40oooo0`00
0?lR0?ooo`80003oD03oool4003jVPH0oooo0P00nYX20?ooo`800?ZJ4`3oool2003jVPD0oooo0@00
000000030?ooo`000000000000<0oooo00L000000?ooo`3oool0oooo0000003oool0000000P0oooo
00<000000?ooo`3oool08@3oool30000o`L0oooo0`000?la0?ooo`<0003o8P3oool20000oe00oooo
1000nYX60?ooo`800?ZJ0P3oool2003jVQ<0oooo0P00nYX50?ooo`40000000020?ooo`030000003o
ool0oooo0080oooo0`0000020?ooo`D00000103oool200000280oooo0`000?l70?ooo`<0003o<@3o
ool30000ob80oooo0P000?m@0?ooo`@00?ZJ1P3oool2003jVP80oooo0P00nYXC0?ooo`800?ZJ103o
ool2000000005@3oool00`000000oooo0?ooo`0Q0?ooo`<0003o1`3oool30000oc40oooo0`000?lR
0?ooo`80003oD03oool4003jVPH0oooo0P00nYX20?ooo`800?ZJ4`3oool2003jVPD0oooo0@000000
01D0oooo00<000000?ooo`3oool08@3oool30000o`L0oooo0`000?lb0?ooo`80003o8P3oool20000
oe00oooo1000nYX60?ooo`800?ZJ0P3oool2003jVQ<0oooo0P00nYX50?ooo`400000000E0?ooo`03
0000003oool0oooo0240oooo0`000?l70?ooo`80003o<`3oool20000ob80oooo0P000?m@0?ooo`@0
0?ZJ1P3oool2003jVP80oooo0P00nYXC0?ooo`800?ZJ1@3oool1000000005@3oool200000280oooo
0`000?ll0?ooo`80003o8P3oool20000oe00oooo1000nYX60?ooo`800?ZJ0P3oool2003jVQ<0oooo
0P00nYX40?ooo`800000000E0?ooo`030000003oool0oooo0240oooo0`000?ll0?ooo`80003o8P3o
ool20000oe00oooo1000nYX60?ooo`800?ZJ00@0oooo003jVP00nYX00?ZJ4`3oool2003jVPD0oooo
0@00000001D0oooo00<000000?ooo`3oool08@3oool30000oc`0oooo0P000?lR0?ooo`80003oD03o
ool3003jVPL0oooo0P00nYX00`3oool00?ZJ003jVP0D0?ooo`800?ZJ1@3oool1000000005@3oool0
0`000000oooo0?ooo`0Q0?ooo`<0003o?03oool20000ob80oooo0P000?m@0?ooo`<00?ZJ1`3oool2
003jVP030?ooo`00nYX00?ZJ01@0oooo0P00nYX50?ooo`400000000E0?ooo`8000008P3oool30000
oc`0oooo0P000?lR0?ooo`80003oD03oool3003jVPL0oooo0P00nYX00`3oool00?ZJ003jVP0D0?oo
o`800?ZJ103oool2000000005@3oool00`000000oooo0?ooo`0Q0?ooo`<0003o/P3oool3003jVPL0
oooo0P00nYX00`3oool00?ZJ003jVP0D0?ooo`800?ZJ1@3oool1000000005@3oool00`000000oooo
0?ooo`0Q0?ooo`80003o/`3oool3003jVPL0oooo0P00nYX00`3oool00?ZJ003jVP0D0?ooo`800?ZJ
1@3oool1000000005@3oool00`000000oooo0?ooo`0Q0?ooo`80003o/`3oool3003jVPL0oooo0P00
nYX00`3oool00?ZJ003jVP0D0?ooo`800?ZJ1@3oool1000000005@3oool200000280oooo0P000?nc
0?ooo`<00?ZJ1`3oool2003jVP030?ooo`00nYX00?ZJ01@0oooo0P00nYX40?ooo`800000000E0?oo
o`030000003oool0oooo0240oooo0P000?nc0?ooo`800?ZJ203oool2003jVP030?ooo`00nYX00?ZJ
01@0oooo0P00nYX50?ooo`4000000000103oool000000000000000030?ooo`<00000103oool20000
00D0oooo00<000000?ooo`3oool08@3oool20000ok<0oooo0P00nYX80?ooo`800?ZJ00<0oooo003j
VP00nYX0503oool2003jVPD0oooo0@0000000080oooo00D000000?ooo`3oool0oooo000000030?oo
o`040000003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0Q
0?ooo`80003o/`3oool2003jVPP0oooo0P00nYX00`3oool00?ZJ003jVP0D0?ooo`800?ZJ1@3oool1
000000000P3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool00P3oool200000280oooo0P000?nc0?ooo`800?ZJ203oool2003jVP030?ooo`00nYX0
0?ZJ01@0oooo0P00nYX30?ooo`<0000000020?ooo`030000003oool0oooo00D0oooo00@000000?oo
o`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0240oooo0P000?nc
0?ooo`800?ZJ203oool2003jVP030?ooo`00nYX00?ZJ01@0oooo0P00nYX50?ooo`40000000020?oo
o`040000003oool0oooo0?ooo`@000000`3oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo0240oooo0P000?nc0?ooo`800?ZJ203oool2003jVP030?ooo`00nYX00?ZJ01@0oooo0P00
nYX50?ooo`40000000000`3oool00000000000030?ooo`030000003oool0oooo00@0oooo00@00000
0?ooo`3oool00000103oool00`000000oooo0?ooo`0Q0?ooo`80003o_@3oool2003jVP030?ooo`00
nYX00?ZJ01@0oooo0P00nYX50?ooo`40000000020?ooo`040000003oool0oooo0?ooo`D000000`3o
ool2000000D0oooo0P00000R0?ooo`80003o_@3oool2003jVP030?ooo`00nYX00?ZJ01@0oooo0P00
nYX40?ooo`800000000E0?ooo`030000003oool0oooo0240oooo0P000?nm0?ooo`800?ZJ00<0oooo
003jVP00nYX0503oool2003jVPD0oooo0@00000001D0oooo00<000000?ooo`3oool0h03oool2003j
VP030?ooo`00nYX00?ZJ01@0oooo0P00nYX50?ooo`400000000E0?ooo`030000003oool0oooo0>00
oooo0P00nYX00`3oool00?ZJ003jVP0K0?ooo`400000000E0?ooo`800000h@3oool2003jVP030?oo
o`00nYX00?ZJ01X0oooo0P00000001D0oooo00<000000?ooo`3oool0h03oool2003jVP030?ooo`00
nYX00?ZJ01/0oooo0@00000001D0oooo00<000000?ooo`3oool0h03oool2003jVP030?ooo`00nYX0
0?ZJ01/0oooo0@00000001D0oooo00<000000?ooo`3oool0h03oool2003jVP030?ooo`00nYX00?ZJ
01/0oooo0@00000001D0oooo0P00003Q0?ooo`800?ZJ00<0oooo003jVP00nYX06P3oool200000000
5@3oool00`000000oooo0?ooo`3P0?ooo`800?ZJ00<0oooo003jVP00nYX06`3oool1000000005@3o
ool00`000000oooo0?ooo`3P0?ooo`D00?ZJ6`3oool1000000005@3oool00`000000oooo0?ooo`3Q
0?ooo`@00?ZJ6`3oool1000000005@3oool200000>80oooo1000nYXJ0?ooo`800000000E0?ooo`03
0000003oool0oooo0>40oooo1000nYXK0?ooo`4000000000103oool000000000000000040?ooo`03
0000003oool0oooo0080oooo0`0000050?ooo`030000003oool0oooo0>40oooo1000nYXK0?ooo`40
000000020?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3oool0oooo000000030?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0h@3oool3003jVQ`0oooo0@0000000080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
0P00003R0?ooo`<00?ZJ6P3oool3000000000P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`3Q0?ooo`<00?ZJ703o
ool1000000000P3oool00`000000oooo0?ooo`050?ooo`030000003oool0000000<000001@3oool0
0`000000oooo0?ooo`3Q0?ooo`<00?ZJ703oool10000000000<0oooo0000000000000`3oool01`00
0000oooo0?ooo`3oool000000?ooo`000000203oool00`000000oooo0?ooo`3Q0?ooo`<00?ZJ703o
ool1000000000P3oool010000000oooo0?ooo`3oool5000000030?ooo`000000000000<00000103o
ool200000>80oooo0`00nYXK0?ooo`800000000E0?ooo`030000003oool0oooo0>40oooo0`00nYXL
0?ooo`400000000E0?ooo`030000003oool0oooo0>40oooo0`00nYXL0?ooo`400000000E0?ooo`03
0000003oool0oooo0>40oooo0`00nYXL0?ooo`400000000E0?ooo`800000hP3oool3003jVQ/0oooo
0P00000001D0oooo00<000000?ooo`3oool0h@3oool3003jVQ`0oooo0@00000001D0oooo00<00000
0?ooo`3oool0h@3oool3003jVQ`0oooo0@00000001D0oooo00<000000?ooo`3oool0h@3oool3003j
VQ`0oooo0@00000001D0oooo0P00003R0?ooo`800?ZJ703oool2000000005@3oool00`000000oooo
0?ooo`3Q0?ooo`800?ZJ7@3oool1000000005@3oool00`000000oooo0?ooo`3o0?ooo`40oooo0@00
000001D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool00P3oool1000000005@3ooooo000000D000000000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {1723.45, -20.3458, \
0.932174, 1.24729}}]
}, Open  ]],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["user defined modules", "Subsection",
  PageWidth->Infinity],

Cell[BoxData[
    \(Clear[t1, t2, t3, ab, c, d, r]\)], "Input"],

Cell[CellGroupData[{

Cell[TextData[{
  "PAR//Clear;\n\
(***************************************************************)\n\
PAR[{t1_,t2_,t3_}] := \n\
(***************************************************************)\n\
Module[{OMEGA,A,B,SIGMA,MUE},\n\nA={{0,        1},\n   {.1 t1,.1 t2}};  \
(*AR(2) with scaling*)\n\nB= {{0},\n    {0}};\n\nG={{.0001,0 },\n   {0    \
,t3}};\n   \nOMEGA=G.Transpose[G];\n\nMUE= {0,0};\nSIGMA={{10^4,  0},\n       \
{0  ,10^4}};\n\n{OMEGA,A,B,SIGMA,MUE}//N\n]\n\n\nPARD//Clear;\n\
(***************************************************************)\n\
PARD[{t1_,t2_,t3_}] =\n\
(***************************************************************)\n \n\t\
Module[{t},\n\tt = {t1,t2,t3};\n\tMap[DMS[#,t]&,PAR[t]]//N ",
  StyleBox["(*McDonald-Swaminathan matrix derivatives*)",
    FontColor->RGBColor[1, 0, 0]],
  "\n];\n\nPARM//Clear\n\
(***************************************************************)\n\
PARM[{phi1_,phi2_}]:= Module[{R,H,D},\n\
(***************************************************************)\nH= \
{{1,0}};\n\nD= {{phi1}};\n\nR= {{phi2}};\n\n{R,H,D}//N\n]\nPARMD//Clear\n\
(***************************************************************)\n\
PARMD[{phi1_,phi2_}] =\n\
(***************************************************************)\n\
Module[{t},\n\tt = {phi1,phi2};\n\tMap[DMS[#,t]&,PARM[t]]\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{{0}, {1}}, {{0, 0}, {0, 0}}, {{1}, {0}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(a\)], "Input"],

Cell[BoxData[
    \(a\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

PAR[{a,b,c}]
PARD[{a,b,c}]
PARM[{d,r}]
PARMD[{d,r}]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{{1.`*^-8, 0.`}, {0.`, c\^2}}, {{0.`, 1.`}, {0.1`\ a, 
          0.1`\ b}}, {{0.`}, {0.`}}, {{10000.`, 0.`}, {0.`, 10000.`}}, {0.`, 
        0.`}}\)], "Output"],

Cell[BoxData[
    \({{{0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 
          2.`\ c}}, {{0.`, 0.`, 0.1`, 0.`}, {0.`, 0.`, 0.`, 0.1`}, {0.`, 0.`, 
          0.`, 0.`}}, {{0.`, 0.`}, {0.`, 0.`}, {0.`, 0.`}}, {{0.`, 0.`, 0.`, 
          0.`}, {0.`, 0.`, 0.`, 0.`}, {0.`, 0.`, 0.`, 0.`}}, {{0.`, 
          0.`}, {0.`, 0.`}, {0.`, 0.`}}}\)], "Output"],

Cell[BoxData[
    \({{{r}}, {{1.`, 0.`}}, {{d}}}\)], "Output"],

Cell[BoxData[
    \({{{0}, {1}}, {{0, 0}, {0, 0}}, {{1}, {0}}}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML estimation", "Subsection"],

Cell[CellGroupData[{

Cell[TextData[{
  "n = 1; (*time series data*)\nnp =1;\nT1 = Length[z];\nT = T1 - 1;\ndt = 1;\
\nk = 1;\np = 2;\nq = 1;\nX = Shape[1,{T1,q,n}];\nZ = Shape[z,{T1,k,n}]; ",
  StyleBox["(*see Manual.nb, data structures, old layer*)",
    FontColor->RGBColor[1, 0, 0]],
  "\nZ//Dimensions"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({176, 1, 1}\)], "Output"]
}, Open  ]],

Cell["\<\
NONLIN = 1;
EPS = 10.^-4;
KMAX = 30;
F0 = IdentityMatrix[5];
OPTION = 1;
theta0 = {-.3996 10,-.3772 10,18.7239} -.1 //N;
phi0 = {44.5186,26.4461} - .1 //N;
PRINT = {1,1,1,1,1,1,1,1};
Fisher = True;\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{THETA,PHI,COV,likpsi,K} = 
\tBFGS[theta0,phi0,F0,KMAX,EPS,Z,X,k,p,q,n,T,dt,OPTION,NONLIN,PRINT];\
\>", \
"Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL: BFGS***************************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS\"\>", "\<\"K\"\>", \
"\<\"P\"\>", "\<\"Q\"\>", "\<\"N\"\>", "\<\"T\"\>", "\<\"DT\"\>"},
          {"1", "30", "0.0001`", "1", "2", "1", "1", "175", "1"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS", "K", "P", 
          "Q", "N", "T", "DT"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"OPTION\"\>", "\<\"NONLIN\"\>", "\<\"MAXSTEP\"\>", \
"\<\"MINSTEP\"\>", "\<\"BOUND\"\>"},
          {"1", "1", "1", "1", "1.`*^-10", "1.`*^-6"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"OPTION", "NONLIN", 
          "MAXSTEP", "MINSTEP", "BOUND"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"STEPREDUCE\"\>", "\<\"NUMABL\"\>"},
          {"1", "4", "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"STEPREDUCE", "NUMABL"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{\(-4.096`\), \
\(-3.872`\), 18.6239`}\),
      SequenceForm[ 
      "STARTWERT THETA0 = ", {-4.0960000000000001, -3.8719999999999999, 
        18.623899999999999}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT PHI0   = "\[InvisibleSpace]{44.4186`, 
          26.3461`}\),
      SequenceForm[ "STARTWERT PHI0   = ", {44.418599999999998, 26.3461}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("EIGENWERTE DER HESSE-MATRIX: "\[InvisibleSpace]{1, 
          1, 1, 1, 1}\),
      SequenceForm[ "EIGENWERTE DER HESSE-MATRIX: ", {1, 1, 1, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("{MINI,COND,BOUND} = "\[InvisibleSpace]{1, 1, 
          1.`*^-6}\),
      SequenceForm[ "{MINI,COND,BOUND} = ", {1, 1, 9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("KONTROLLE, INC = \
"\[InvisibleSpace]1.4901161193847656`*^-8\),
      SequenceForm[ "KONTROLLE, INC = ", 1.4901161193847656*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.6097640991210938`", 
              "0.6097572410152257`", \(-6.858105868090547`*^-6\)},
            {"0.3118133544921875`", "0.3118208878742459`", 
              "7.533382058388938`*^-6"},
            {"0.18115234375`", "0.18116146066904637`", 
              "9.116919046370242`*^-6"},
            {"0.007720947265625`", 
              "0.007702979738591063`", \(-0.000017967527033937135`\)},
            {"0.00580596923828125`", 
              "0.005800676667275205`", \(-5.2925710060450215`*^-6\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SNUM", "S", 
          "DS"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Likelihoods  "\[InvisibleSpace]\(-571.1091180939013`\
\)\[InvisibleSpace]"  "\[InvisibleSpace]\(-571.1091180939013`\)\),
      SequenceForm[ 
      "Likelihoods  ", -571.10911809390132, "  ", -571.10911809390132],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.063266063292900\"\>",
            -571.06326606329287,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.109118093901300\"\>",
            -571.10911809390132,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -571.06326606329287, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -571.10911809390132, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.063266063292900\"\>",
            -571.06326606329287,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.109118093901300\"\>",
            -571.10911809390132,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.06326606329287, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.10911809390132, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.045852030608444\"\>",
            0.045852030608443783,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.045852030608443783, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9435606897461937`\), \(-4.096`\), "0.15243931025380641`",
             "0.6097572410152257`"},
          {"2", \(-3.7940447780314384`\), \(-3.872`\), "0.07795522196856147`",
             "0.3118208878742459`"},
          {"3", "18.66919036516726`", "18.6239`", "0.04529036516726159`", 
            "0.18116146066904637`"},
          {"4", "44.42052574493464`", "44.4186`", "0.0019257449346477657`", 
            "0.007702979738591063`"},
          {"5", "26.34755016916682`", "26.3461`", "0.0014501691668188012`", 
            "0.005800676667275205`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.291382894663645`\
\[InvisibleSpace]"  "\[InvisibleSpace]31.875772612892714`\),
      SequenceForm[ "*BFGSUP ", 6.291382894663645, "  ", 31.875772612892714],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.056871473194300\"\>",
            -571.05687147319429,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.063266063293100\"\>",
            -571.0632660632931,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -571.05687147319429, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -571.0632660632931, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.056871473194300\"\>",
            -571.05687147319429,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.063266063293100\"\>",
            -571.0632660632931,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05687147319429, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.0632660632931, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.006394590098807\"\>",
            0.0063945900988073845,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0063945900988073845, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9644376751804193`\), \(-3.9435606897461937`\), \
\(-0.02087698543422579`\), \(-0.2739700476436291`\)},
          {"2", \(-3.759605034192029`\), \(-3.7940447780314384`\), 
            "0.034439743839409655`", "0.08847904168963408`"},
          {"3", "18.685077512966913`", "18.66919036516726`", 
            "0.01588714779965447`", "0.03052194136033112`"},
          {"4", "44.42236954351728`", "44.42052574493464`", 
            "0.0018437985826303014`", "0.007216959550201518`"},
          {"5", "26.349191880310492`", "26.34755016916682`", 
            "0.0016417111436730846`", "0.0067177986365597854`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.173\"\>",
                  5.172684944191043,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.863\"\>",
                  0.8629570640803268,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6175\"\>",
                  0.61746429923878321,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.006655\"\>",
                  -0.0066552197659493773,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01215\"\>",
                  -0.012145623089185185,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.863\"\>",
                  0.86295706408032702,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.12\"\>",
                  1.1201145204568861,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09913\"\>",
                  0.099126712511228218,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.004102\"\>",
                  -0.0041023296189185796,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.004892\"\>",
                  -0.0048921753479174088,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.6175\"\>",
                  0.61746429923878321,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09913\"\>",
                  0.099126712511228218,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.077\"\>",
                  1.0773815941495257,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00232\"\>",
                  -0.0023195149478440337,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.002963\"\>",
                  -0.0029627438484486524,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.006655\"\>",
                  -0.0066552197659493773,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.004102\"\>",
                  -0.0041023296189185796,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00232\"\>",
                  -0.0023195149478440337,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9999\"\>",
                  0.99988327502569119,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00009182\"\>",
                  -9.1822385032000033*^-05,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.01215\"\>",
                  -0.012145623089185185,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.004892\"\>",
                  -0.0048921753479174096,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.002963\"\>",
                  -0.0029627438484486528,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00009182\"\>",
                  -9.1822385032000033*^-05,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9999\"\>",
                  0.99993825731152675,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]173.62243095382482`\
\[InvisibleSpace]"  "\[InvisibleSpace]431.2154202278767`\),
      SequenceForm[ "*BFGSUP ", 173.62243095382482, "  ", 431.21542022787668],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.054196699552100\"\>",
            -571.05419669955211,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.056871473194300\"\>",
            -571.05687147319429,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05419669955211, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05687147319429, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.002674773642184\"\>",
            0.0026747736421839363,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0026747736421839363, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9973236082764583`\), \(-3.9644376751804193`\), \
\(-0.03288593309603895`\), \(-0.16514786291308126`\)},
          {
            "2", \(-3.764722827723078`\), \(-3.759605034192029`\), \
\(-0.005117793531049304`\), \(-0.0002617903530108198`\)},
          {"3", "18.699337238554477`", "18.685077512966913`", 
            "0.014259725587564089`", "0.0035202128502404323`"},
          {"4", "44.431563289460286`", "44.42236954351728`", 
            "0.009193745943008366`", "0.007473745522082809`"},
          {"5", "26.354205467399176`", "26.349191880310492`", 
            "0.005013587088682188`", "0.004874124720986451`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.206\"\>",
                  5.2058400736238521,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1604\"\>",
                  -0.16040202630487399,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3327\"\>",
                  0.33266098282057166,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05148\"\>",
                  0.051484761607752234,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.002623\"\>",
                  0.0026226446453585898,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.1604\"\>",
                  -0.16040202630487377,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.276\"\>",
                  2.2763932059984016,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4424\"\>",
                  0.44237063454145131,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02527\"\>",
                  -0.025268262422000518,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.007495\"\>",
                  0.0074948122268579109,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3327\"\>",
                  0.33266098282057177,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4424\"\>",
                  0.44237063454145126,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.179\"\>",
                  1.1788613338665443,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00946\"\>",
                  -0.009459994887681138,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0001546\"\>",
                  0.00015456191382199084,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.05148\"\>",
                  0.051484761607752234,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02527\"\>",
                  -0.025268262422000511,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00946\"\>",
                  -0.009459994887681138,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9985\"\>",
                  0.99849099591034851,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.001481\"\>",
                  -0.0014806591917233239,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.002623\"\>",
                  0.0026226446453585898,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.007495\"\>",
                  0.0074948122268579031,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0001546\"\>",
                  0.00015456191382199041,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.001481\"\>",
                  -0.0014806591917233239,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9993\"\>",
                  0.99931215798145034,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]172.48946576561306`\
\[InvisibleSpace]"  "\[InvisibleSpace]179.348803299699`\),
      SequenceForm[ "*BFGSUP ", 172.48946576561306, "  ", 179.348803299699],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.054030780294800\"\>",
            -571.05403078029485,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.054196699552100\"\>",
            -571.05419669955211,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05403078029485, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05419669955211, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000165919257256\"\>",
            0.00016591925725606416,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00016591925725606416, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.996549203510266`\), \(-3.9973236082764583`\), 
            "0.0007744047661923793`", "0.014170460967621912`"},
          {
            "2", \(-3.765446151825003`\), \(-3.764722827723078`\), \
\(-0.0007233241019252297`\), "0.002820055036074159`"},
          {"3", "18.70979201719499`", "18.699337238554477`", 
            "0.010454778640511779`", "0.012557279524768962`"},
          {"4", "44.438509421315686`", "44.431563289460286`", 
            "0.006946131855399933`", "0.006898771337447222`"},
          {"5", "26.35749841662944`", "26.354205467399176`", 
            "0.0032929492302655114`", "0.003236023661472343`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.861\"\>",
                  5.8607230422997176,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.07283\"\>",
                  -0.072832927246865659,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7164\"\>",
                  0.71644760779340722,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2551\"\>",
                  0.25506591360122877,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09632\"\>",
                  0.09632237297447005,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.07283\"\>",
                  -0.072832927246865423,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.278\"\>",
                  2.2780191799197698,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4473\"\>",
                  0.44733989172658006,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02522\"\>",
                  -0.025223004866823957,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.006853\"\>",
                  0.0068528697220220846,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.7164\"\>",
                  0.71644760779340744,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4473\"\>",
                  0.44733989172658001,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.191\"\>",
                  1.1907258304108623,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01507\"\>",
                  -0.015074783015081713,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.005476\"\>",
                  -0.0054761670177043992,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.2551\"\>",
                  0.25506591360122877,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02522\"\>",
                  -0.02522300486682395,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01507\"\>",
                  -0.015074783015081712,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9885\"\>",
                  0.98853015694689794,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.007852\"\>",
                  -0.0078515096923516773,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.09632\"\>",
                  0.09632237297447005,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.006853\"\>",
                  0.0068528697220220768,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.005476\"\>",
                  -0.0054761670177043992,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.007852\"\>",
                  -0.007851509692351679,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9955\"\>",
                  0.99551420593220663,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]15215.994439947173`\
\[InvisibleSpace]"  "\[InvisibleSpace]5030.351291796655`\),
      SequenceForm[ "*BFGSUP ", 15215.994439947173, "  ", 5030.3512917966546],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053766788504700\"\>",
            -571.05376678850473,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.054030780294600\"\>",
            -571.05403078029462,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05376678850473, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05403078029462, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000263991789893\"\>",
            0.00026399178989322536,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00026399178989322536, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9967073272179356`\), \(-3.996549203510266`\), \
\(-0.00015812370766987791`\), "0.005694948738791293`"},
          {
            "2", \(-3.7749209504213237`\), \(-3.765446151825003`\), \
\(-0.009474798596320416`\), \(-0.003531641084279595`\)},
          {"3", "18.741070015677394`", "18.70979201719499`", 
            "0.031277998482406616`", "0.0070055388727189236`"},
          {"4", "44.46451155982686`", "44.438509421315686`", 
            "0.02600213851117755`", "0.006334894815751591`"},
          {"5", "26.369046079267832`", "26.35749841662944`", 
            "0.011547662638394124`", "0.0026917711128298725`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.944\"\>",
                  5.9436490472636567,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5453\"\>",
                  0.54528278163001576,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5373\"\>",
                  0.53730568395141931,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.164\"\>",
                  -0.16397563765662632,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.06416\"\>",
                  -0.064160518920285375,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5453\"\>",
                  0.54528278163001598,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.852\"\>",
                  2.8518889960367009,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8058\"\>",
                  0.80576513708115549,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.06859\"\>",
                  -0.068590876494318373,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01355\"\>",
                  0.013547645848096583,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5373\"\>",
                  0.53730568395141942,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8058\"\>",
                  0.80576513708115538,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8665\"\>",
                  0.86649824016679333,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4032\"\>",
                  -0.40321949676522034,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1639\"\>",
                  -0.1639119071557617,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.164\"\>",
                  -0.16397563765662637,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.06859\"\>",
                  -0.068590876494318373,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4032\"\>",
                  -0.40321949676522034,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.754\"\>",
                  0.75395844455135275,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1155\"\>",
                  -0.11548237085954062,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.06416\"\>",
                  -0.064160518920285375,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01355\"\>",
                  0.013547645848096574,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1639\"\>",
                  -0.16391190715576168,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1155\"\>",
                  -0.11548237085954061,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9473\"\>",
                  0.94734426853967368,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2728.460883898488`\
\[InvisibleSpace]"  "\[InvisibleSpace]2234.71281193632`\),
      SequenceForm[ "*BFGSUP ", 2728.4608838984882, "  ", 2234.7128119363201],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053724567332400\"\>",
            -571.05372456733244,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053766788504700\"\>",
            -571.05376678850473,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05372456733244, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05376678850473, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000042221172293\"\>",
            4.2221172293466225*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 4.2221172293466225*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9975674982418234`\), \(-3.9967073272179356`\), \
\(-0.0008601710238878928`\), \(-0.005189531270405254`\)},
          {
            "2", \(-3.779023252625864`\), \(-3.7749209504213237`\), \
\(-0.004102302204540237`\), \(-0.005792542321836683`\)},
          {"3", "18.747881662703154`", "18.741070015677394`", 
            "0.006811647025759948`", \(-0.0030742586197290726`\)},
          {"4", "44.475811427316145`", "44.46451155982686`", 
            "0.01129986748928247`", "0.004200104971744651`"},
          {"5", "26.373228373120334`", "26.369046079267832`", 
            "0.004182293852502248`", "0.0010581347587668237`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.194\"\>",
                  6.1944178143574682,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6574\"\>",
                  0.65737244544641227,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7475\"\>",
                  0.74749776436141224,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1812\"\>",
                  -0.18119842284650606,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0499\"\>",
                  -0.049902012575809,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.6574\"\>",
                  0.65737244544641249,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.838\"\>",
                  2.8379635693023912,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9232\"\>",
                  0.92323433515243769,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.005426\"\>",
                  -0.0054255468105481042,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04487\"\>",
                  0.044869195686950136,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.7475\"\>",
                  0.74749776436141224,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9232\"\>",
                  0.92323433515243758,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.034\"\>",
                  1.0340419037468294,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4437\"\>",
                  -0.44368290146092704,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1611\"\>",
                  -0.16112376178387042,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.1812\"\>",
                  -0.18119842284650611,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.005426\"\>",
                  -0.0054255468105480903,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4437\"\>",
                  -0.44368290146092704,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6767\"\>",
                  0.67671191561931743,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1441\"\>",
                  -0.14407346156302719,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.0499\"\>",
                  -0.049902012575809,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04487\"\>",
                  0.044869195686950136,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1611\"\>",
                  -0.16112376178387039,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1441\"\>",
                  -0.14407346156302719,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9384\"\>",
                  0.93843399087525758,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]29505.45010828635`\
\[InvisibleSpace]"  "\[InvisibleSpace]16899.902474745308`\),
      SequenceForm[ "*BFGSUP ", 29505.45010828635, "  ", 16899.902474745308],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053691221047200\"\>",
            -571.05369122104719,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053724567332400\"\>",
            -571.05372456733232,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05369122104719, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05372456733232, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000033346285136\"\>",
            3.334628513584903*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.334628513584903*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.998258018412401`\), \(-3.9975674982418234`\), \
\(-0.0006905201705773182`\), \(-0.0027752855017317227`\)},
          {
            "2", \(-3.7813087906670333`\), \(-3.779023252625864`\), \
\(-0.002285538041169331`\), \(-0.0016074093441303533`\)},
          {"3", "18.749421293316527`", "18.747881662703154`", 
            "0.0015396306133725435`", \(-0.0034630308924504293`\)},
          {"4", "44.488738752082355`", "44.475811427316145`", 
            "0.012927324766211723`", "0.003282413607918959`"},
          {"5", "26.37730009834615`", "26.373228373120334`", 
            "0.004071725225815242`", "0.0006687004415290653`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.911\"\>",
                  5.9112575266403766,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4475\"\>",
                  0.44747286857649277,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4502\"\>",
                  0.45018380136115638,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1218\"\>",
                  0.12179130394748844,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01516\"\>",
                  0.015158394032146562,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.4475\"\>",
                  0.44747286857649293,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.788\"\>",
                  2.7877098376220211,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5743\"\>",
                  0.57427745977951417,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2924\"\>",
                  0.2924165970508853,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1004\"\>",
                  0.10036460753548815,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.4502\"\>",
                  0.45018380136115638,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5743\"\>",
                  0.57427745977951394,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8788\"\>",
                  0.87877937724551991,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2149\"\>",
                  -0.21494108340730267,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1017\"\>",
                  -0.10168155621266692,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1218\"\>",
                  0.12179130394748838,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2924\"\>",
                  0.29241659705088535,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2149\"\>",
                  -0.21494108340730267,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4034\"\>",
                  0.40343096838253822,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2086\"\>",
                  -0.20863663766708035,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.01516\"\>",
                  0.015158394032146562,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1004\"\>",
                  0.10036460753548816,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1017\"\>",
                  -0.10168155621266688,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2086\"\>",
                  -0.20863663766708035,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.924\"\>",
                  0.92398679877302115,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]41432.486416907384`\
\[InvisibleSpace]"  "\[InvisibleSpace]22019.64703430457`\),
      SequenceForm[ "*BFGSUP ", 41432.486416907384, "  ", 22019.647034304569],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053656769961500\"\>",
            -571.05365676996144,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053691221047200\"\>",
            -571.05369122104719,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05365676996144, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05369122104719, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000034451085753\"\>",
            3.4451085753062216*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.4451085753062216*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9984602145477357`\), \(-3.998258018412401`\), \
\(-0.0002021961353350659`\), "0.0006794308266721456`"},
          {"2", \(-3.7812363382305936`\), \(-3.7813087906670333`\), 
            "0.00007245243643966895`", "0.0024786300561236135`"},
          {"3", "18.746300355455883`", 
            "18.749421293316527`", \(-0.0031209378606417678`\), \
\(-0.00247126298579419`\)},
          {"4", "44.50527675204316`", "44.488738752082355`", 
            "0.016537999960806998`", "0.0022537091234612846`"},
          {"5", "26.38218654568057`", "26.37730009834615`", 
            "0.004886447334419284`", "0.0005115533692516939`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.236\"\>",
                  6.2361570042668601,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9341\"\>",
                  0.9341081990769895,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3805\"\>",
                  0.3805143544713287,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1751\"\>",
                  0.17513607385334898,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03353\"\>",
                  0.033529580696961284,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.9341\"\>",
                  0.93410819907698983,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.423\"\>",
                  3.4225613571598128,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6196\"\>",
                  0.61960603524450319,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2344\"\>",
                  0.23444197798817826,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09743\"\>",
                  0.097428805323360568,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3805\"\>",
                  0.3805143544713287,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6196\"\>",
                  0.61960603524450297,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6555\"\>",
                  0.6554600753870794,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.006912\"\>",
                  -0.0069124777067053056,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.05715\"\>",
                  -0.057147387498187194,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1751\"\>",
                  0.17513607385334889,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2344\"\>",
                  0.23444197798817834,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.006912\"\>",
                  -0.0069124777067053056,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.21\"\>",
                  0.21003124741384857,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2503\"\>",
                  -0.25027080472694752,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.03353\"\>",
                  0.03352958069696127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09743\"\>",
                  0.097428805323360596,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.05715\"\>",
                  -0.057147387498187152,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2503\"\>",
                  -0.25027080472694752,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9152\"\>",
                  0.91516367086353267,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]38232.579736406195`\
\[InvisibleSpace]"  "\[InvisibleSpace]21040.944902932162`\),
      SequenceForm[ "*BFGSUP ", 38232.579736406195, "  ", 21040.944902932162],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053631497534300\"\>",
            -571.0536314975343,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053656769961500\"\>",
            -571.05365676996144,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.0536314975343, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05365676996144, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000025272427138\"\>",
            2.5272427137679188*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.5272427137679188*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9979390598177846`\), \(-3.9984602145477357`\), 
            "0.0005211547299508835`", "0.0031386884564643365`"},
          {"2", \(-3.7784212520674525`\), \(-3.7812363382305936`\), 
            "0.0028150861631409674`", "0.004769849438822207`"},
          {"3", "18.739413052508755`", 
            "18.746300355455883`", \(-0.00688730294712596`\), \
\(-0.0010086907911922003`\)},
          {"4", "44.520084281476564`", "44.50527675204316`", 
            "0.01480752943340723`", "0.0009606470303986338`"},
          {"5", "26.38680348416137`", "26.38218654568057`", 
            "0.004616938480798338`", "0.0005370939608242824`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.458\"\>",
                  6.4576726093928158,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.114\"\>",
                  1.1141031036602131,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5534\"\>",
                  0.55335974243836494,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02134\"\>",
                  0.021338784563234903,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02862\"\>",
                  0.028617904516514917,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.114\"\>",
                  1.1141031036602134,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.494\"\>",
                  3.4940031102252029,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8766\"\>",
                  0.87660931271274856,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.003634\"\>",
                  0.0036336798383640179,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.07299\"\>",
                  0.072987242584702558,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5534\"\>",
                  0.55335974243836494,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8766\"\>",
                  0.87660931271274845,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6087\"\>",
                  0.60874404095278301,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03797\"\>",
                  0.037969904720567466,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02912\"\>",
                  -0.029119608160185759,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.02134\"\>",
                  0.021338784563234847,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.003634\"\>",
                  0.0036336798383641011,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03797\"\>",
                  0.037969904720567438,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1671\"\>",
                  0.16708521824334141,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2758\"\>",
                  -0.27579140497091481,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.02862\"\>",
                  0.0286179045165149,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.07299\"\>",
                  0.072987242584702586,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02912\"\>",
                  -0.029119608160185717,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2758\"\>",
                  -0.27579140497091481,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9097\"\>",
                  0.90968247222534537,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]37185.63318702576`\
\[InvisibleSpace]"  "\[InvisibleSpace]25829.79674810383`\),
      SequenceForm[ "*BFGSUP ", 37185.633187025764, "  ", 25829.796748103829],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053624130965600\"\>",
            -571.05362413096566,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053631497534500\"\>",
            -571.05363149753441,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05362413096566, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05363149753441, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     7.366568752331659"\[Times]10\^"-6"\),
            7.3665687523316592*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 7.3665687523316592*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9972982886995463`\), \(-3.9979390598177846`\), 
            "0.0006407711182385448`", "0.0028942566004532084`"},
          {"2", \(-3.77579041807604`\), \(-3.7784212520674525`\), 
            "0.0026308339914124772`", "0.003673761808545487`"},
          {"3", "18.734896386465035`", 
            "18.739413052508755`", \(-0.00451666604372172`\), 
            "0.00011315654409111846`"},
          {"4", "44.52368507574933`", "44.520084281476564`", 
            "0.003600794272761691`", \(-0.00017678288802222105`\)},
          {"5", "26.38877520562562`", "26.38680348416137`", 
            "0.0019717214642522244`", "0.0007298388090762841`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.205\"\>",
                  6.2054355754007879,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7374\"\>",
                  0.73736610076164877,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6249\"\>",
                  0.62493913758900554,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0462\"\>",
                  -0.046203986347568823,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01668\"\>",
                  -0.016677133859275852,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.7374\"\>",
                  0.73736610076164899,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.951\"\>",
                  2.9510125485955805,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9552\"\>",
                  0.95515924349830184,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.06836\"\>",
                  -0.068361929811615429,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.001041\"\>",
                  -0.001041043353068552,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.6249\"\>",
                  0.62493913758900554,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9552\"\>",
                  0.95515924349830172,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6293\"\>",
                  0.62926299101925509,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01555\"\>",
                  0.015549156706255916,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.007085\"\>",
                  -0.0070853523177540727,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.0462\"\>",
                  -0.046203986347568879,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.06836\"\>",
                  -0.06836192981161536,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01555\"\>",
                  0.015549156706255889,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1914\"\>",
                  0.19135717309248218,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2973\"\>",
                  -0.29727083404154886,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.01668\"\>",
                  -0.016677133859275863,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.001041\"\>",
                  -0.0010410433530685242,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.007085\"\>",
                  -0.007085352317754031,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2973\"\>",
                  -0.29727083404154886,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9036\"\>",
                  0.90361282046411562,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]112476.56681517915`\
\[InvisibleSpace]"  "\[InvisibleSpace]84666.81309791781`\),
      SequenceForm[ "*BFGSUP ", 112476.56681517915, "  ", 84666.81309791781],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053622288914800\"\>",
            -571.05362228891488,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053624130965600\"\>",
            -571.05362413096566,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05362228891488, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05362413096566, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.842050778577686"\[Times]10\^"-6"\),
            1.8420507785776863*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.8420507785776863*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.997005447860776`\), \(-3.9972982886995463`\), 
            "0.0002928408387700183`", "0.000996817352902921`"},
          {"2", \(-3.774745962845`\), \(-3.77579041807604`\), 
            "0.0010444552310404297`", "0.001124947248594894`"},
          {"3", "18.73346798633048`", 
            "18.734896386465035`", \(-0.0014284001345522509`\), 
            "0.0001841438219090384`"},
          {"4", "44.5227866729055`", 
            "44.52368507574933`", \(-0.000898402843827292`\), \
\(-0.000438421894766032`\)},
          {"5", "26.38987659149165`", "26.38877520562562`", 
            "0.0011013858660286406`", "0.0008786050190238586`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.901\"\>",
                  5.9011519314377905,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3811\"\>",
                  0.38108152751138213,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5821\"\>",
                  0.58206048733637517,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05295\"\>",
                  0.052954545580348567,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2273\"\>",
                  -0.22727160227828122,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3811\"\>",
                  0.38108152751138236,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.539\"\>",
                  2.5390037482386947,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8996\"\>",
                  0.89961161806053069,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.06163\"\>",
                  0.061632798606129524,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2707\"\>",
                  -0.27070285121081905,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5821\"\>",
                  0.58206048733637517,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8996\"\>",
                  0.89961161806053058,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6287\"\>",
                  0.62874567418077021,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01515\"\>",
                  0.015153811673737931,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01289\"\>",
                  -0.012889839194342018,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.05295\"\>",
                  0.052954545580348511,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.06163\"\>",
                  0.061632798606129621,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01515\"\>",
                  0.015153811673737904,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1964\"\>",
                  0.19641072979555058,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2907\"\>",
                  -0.29072479705283416,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.2273\"\>",
                  -0.22727160227828122,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2707\"\>",
                  -0.27070285121081905,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01289\"\>",
                  -0.012889839194341977,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2907\"\>",
                  -0.29072479705283416,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.861\"\>",
                  0.86100306117487657,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]691182.9690840477`\
\[InvisibleSpace]"  "\[InvisibleSpace]389803.1495457743`\),
      SequenceForm[ "*BFGSUP ", 691182.96908404771, "  ", 389803.14954577427],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053620275387400\"\>",
            -571.05362027538729,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053622288915000\"\>",
            -571.05362228891499,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05362027538729, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05362228891499, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.013527705457818"\[Times]10\^"-6"\),
            2.0135277054578182*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.0135277054578182*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.99676657744144`\), \(-3.997005447860776`\), 
            "0.00023887041933593866`", \(-0.000104901990030817`\)},
          {"2", \(-3.7739482087932035`\), \(-3.774745962845`\), 
            "0.0007977540517963528`", \(-0.00019070486677441947`\)},
          {"3", "18.732335643786925`", 
            "18.73346798633048`", \(-0.00113234254355584`\), \
\(-0.000013397367042341623`\)},
          {"4", "44.52136907774139`", 
            "44.5227866729055`", \(-0.0014175951641081169`\), \
\(-0.0003597976783404848`\)},
          {"5", "26.392223255223787`", "26.38987659149165`", 
            "0.002346663732137741`", "0.000913507956115107`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.353\"\>",
                  6.3527739182498362,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9458\"\>",
                  0.94582462739809015,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6609\"\>",
                  0.66093466564472458,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1634\"\>",
                  0.16343734544128427,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5952\"\>",
                  -0.5952428285922704,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.9458\"\>",
                  0.94582462739809015,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.242\"\>",
                  3.2421019882744813,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9985\"\>",
                  0.9984984142517721,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1824\"\>",
                  0.18238686899884038,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.6877\"\>",
                  -0.68771737079354578,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.6609\"\>",
                  0.66093466564472458,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9985\"\>",
                  0.99849841425177199,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6425\"\>",
                  0.64249956194060598,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03589\"\>",
                  0.035888542966956719,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.08072\"\>",
                  -0.080721514423966884,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1634\"\>",
                  0.16343734544128422,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1824\"\>",
                  0.18238686899884049,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03589\"\>",
                  0.035888542966956698,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1258\"\>",
                  0.12575793396670698,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1387\"\>",
                  -0.13867599426180702,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.5952\"\>",
                  -0.5952428285922704,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.6877\"\>",
                  -0.68771737079354578,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.08072\"\>",
                  -0.080721514423966842,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1387\"\>",
                  -0.13867599426180702,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5609\"\>",
                  0.56093778473486788,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.0455551254591114`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]401329.1564682106`\),
      SequenceForm[ "*BFGSUP ", 1045555.1254591114, "  ", 401329.15646821063],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053615547382000\"\>",
            -571.05361554738204,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053620275387400\"\>",
            -571.0536202753874,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05361554738204, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.0536202753874, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     4.728005364995624"\[Times]10\^"-6"\),
            4.7280053649956244*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 4.7280053649956244*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.996366665655622`\), \(-3.99676657744144`\), 
            "0.00039991178581818486`", \(-0.0009721960733597556`\)},
          {"2", \(-3.772650821262671`\), \(-3.7739482087932035`\), 
            "0.001297387530532658`", \(-0.0011914495935399522`\)},
          {"3", "18.730091645448812`", 
            "18.732335643786925`", \(-0.002243998338114315`\), \
\(-0.00021917940785961623`\)},
          {"4", "44.51885475724388`", 
            "44.52136907774139`", \(-0.002514320497512541`\), \
\(-0.0002421896671824192`\)},
          {"5", "26.399883591922272`", "26.392223255223787`", 
            "0.007660336698486364`", "0.0009061758985333356`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 7.135\"\>",
                  7.1348230686604186,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.845\"\>",
                  1.8452750043308854,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.847\"\>",
                  0.84697456470487009,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04164\"\>",
                  0.041642393064476868,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5501\"\>",
                  -0.5501351986302907,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.845\"\>",
                  1.8452750043308854,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.275\"\>",
                  4.274619321683593,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.213\"\>",
                  1.212789741377919,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03179\"\>",
                  0.0317923666998286,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.6101\"\>",
                  -0.61012987315628031,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.847\"\>",
                  0.84697456470487009,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.213\"\>",
                  1.212789741377919,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6867\"\>",
                  0.68670286457157992,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.00865\"\>",
                  0.0086498751247793167,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.07423\"\>",
                  -0.074232267245276512,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.04164\"\>",
                  0.041642393064476813,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03179\"\>",
                  0.031792366699828711,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.00865\"\>",
                  0.0086498751247792889,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.08827\"\>",
                  0.088265867698107112,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00767\"\>",
                  -0.0076695043056897727,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.5501\"\>",
                  -0.5501351986302907,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.6101\"\>",
                  -0.61012987315628031,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.07423\"\>",
                  -0.07423226724527647,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00767\"\>",
                  -0.0076695043056898005,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2261\"\>",
                  0.22608610164945425,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]362344.5289703582`\
\[InvisibleSpace]"  "\[InvisibleSpace]163724.30491224825`\),
      SequenceForm[ "*BFGSUP ", 362344.52897035819, "  ", 163724.30491224825],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053607943577500\"\>",
            -571.0536079435775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053615547382000\"\>",
            -571.05361554738204,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.0536079435775, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05361554738204, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     7.603804533573566"\[Times]10\^"-6"\),
            7.603804533573566*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 7.603804533573566*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9959209013117913`\), \(-3.996366665655622`\), 
            "0.00044576434383033093`", \(-0.0021794914556221056`\)},
          {"2", \(-3.7712487311518075`\), \(-3.772650821262671`\), 
            "0.0014020901108633234`", \(-0.0025671412874274987`\)},
          {"3", "18.72679254934776`", 
            "18.730091645448812`", \(-0.0032990961010542393`\), \
\(-0.0005239217297019006`\)},
          {"4", "44.516234754032084`", 
            "44.51885475724388`", \(-0.002620003211792306`\), \
\(-0.00003395434015495024`\)},
          {"5", "26.415625659621178`", "26.399883591922272`", 
            "0.015742067698904856`", "0.0008210023132788558`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 7.508\"\>",
                  7.508216219510282,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.257\"\>",
                  2.2574352306809757,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9454\"\>",
                  0.94539893658909269,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.088\"\>",
                  -0.088001427002883187,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3686\"\>",
                  -0.36863748343886793,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 2.257\"\>",
                  2.2574352306809757,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.728\"\>",
                  4.7279511703250137,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.322\"\>",
                  1.3219408107265322,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1193\"\>",
                  -0.11925136274498827,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3909\"\>",
                  -0.39090596603564653,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.9454\"\>",
                  0.94539893658909269,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.322\"\>",
                  1.3219408107265322,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7125\"\>",
                  0.71248778157409975,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02303\"\>",
                  -0.023034801693522972,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03231\"\>",
                  -0.032309135375542863,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.088\"\>",
                  -0.088001427002883215,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1193\"\>",
                  -0.11925136274498815,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02303\"\>",
                  -0.023034801693523,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09437\"\>",
                  0.094374447765031566,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02184\"\>",
                  0.021835889223409174,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.3686\"\>",
                  -0.36863748343886793,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3909\"\>",
                  -0.39090596603564653,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03231\"\>",
                  -0.032309135375542822,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02184\"\>",
                  0.021835889223409143,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09427\"\>",
                  0.094271752236609219,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]194792.0919538198`\
\[InvisibleSpace]"  "\[InvisibleSpace]98320.68639602029`\),
      SequenceForm[ "*BFGSUP ", 194792.09195381979, "  ", 98320.68639602029],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "BFGS: Iteration = ", 15],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053600087135700\"\>",
            -571.05360008713569,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053607943577600\"\>",
            -571.05360794357762,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05360008713569, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05360794357762, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     7.856441925468971"\[Times]10\^"-6"\),
            7.856441925468971*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 7.856441925468971*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9956962707330557`\), \(-3.9959209013117913`\), 
            "0.00022463057873579396`", \(-0.0030053177247139603`\)},
          {"2", \(-3.770611705937591`\), \(-3.7712487311518075`\), 
            "0.0006370252142164255`", \(-0.0034895575675694245`\)},
          {"3", "18.723687155661704`", 
            "18.72679254934776`", \(-0.0031053936860565186`\), \
\(-0.0007418793448614792`\)},
          {"4", "44.51535714262855`", 
            "44.516234754032084`", \(-0.0008776114035311267`\), 
            "0.00018466275485299835`"},
          {"5", "26.43628571378669`", "26.415625659621178`", 
            "0.02066005416550966`", "0.0005911386334681458`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 7.174\"\>",
                  7.1740210351439746,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.856\"\>",
                  1.8557088110647497,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8682\"\>",
                  0.86818984957728929,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1304\"\>",
                  -0.13044518547872835,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1557\"\>",
                  -0.15572875094878846,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.856\"\>",
                  1.8557088110647497,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.246\"\>",
                  4.2457359689119114,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.229\"\>",
                  1.2288638382544086,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1671\"\>",
                  -0.1671025310108912,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1424\"\>",
                  -0.14238067508133234,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.8682\"\>",
                  0.86818984957728929,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.229\"\>",
                  1.2288638382544086,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6948\"\>",
                  0.69475304517253322,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03407\"\>",
                  -0.034065568510883083,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01974\"\>",
                  0.019741807168342403,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.1304\"\>",
                  -0.13044518547872841,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1671\"\>",
                  -0.16710253101089109,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03407\"\>",
                  -0.034065568510883111,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1036\"\>",
                  0.10357087715473687,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01479\"\>",
                  0.014788017351031102,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.1557\"\>",
                  -0.15572875094878841,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1424\"\>",
                  -0.14238067508133234,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01974\"\>",
                  0.019741807168342451,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01479\"\>",
                  0.014788017351031071,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03829\"\>",
                  0.038291495395932858,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]138911.79400176293`\
\[InvisibleSpace]"  "\[InvisibleSpace]87285.17650896251`\),
      SequenceForm[ "*BFGSUP ", 138911.79400176293, "  ", 87285.176508962511],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]16\),
      SequenceForm[ "BFGS: Iteration = ", 16],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596639519300\"\>",
            -571.05359663951936,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053600087135700\"\>",
            -571.05360008713569,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359663951936, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05360008713569, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     3.447616336416104"\[Times]10\^"-6"\),
            3.4476163364161039*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.4476163364161039*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.995856497857351`\), \(-3.9956962707330557`\), \
\(-0.00016022712429562654`\), \(-0.0024898351083889017`\)},
          {
            "2", \(-3.7712038609303113`\), \(-3.770611705937591`\), \
\(-0.0005921549927200441`\), \(-0.00286599317225296`\)},
          {"3", "18.722987996664074`", 
            "18.723687155661704`", \(-0.0006991589976293504`\), \
\(-0.0006246803287206073`\)},
          {"4", "44.516903534701754`", "44.51535714262855`", 
            "0.0015463920732000241`", "0.00026163572740424407`"},
          {"5", "26.447191725733603`", "26.43628571378669`", 
            "0.010906011946914887`", "0.00023875181520802513`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.423\"\>",
                  6.4225789923060272,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.985\"\>",
                  0.98498049403714161,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.682\"\>",
                  0.68197251607814979,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.07649\"\>",
                  -0.07649273521637931,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02589\"\>",
                  -0.02589467624287542,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.985\"\>",
                  0.98498049403714172,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.237\"\>",
                  3.2368767534191676,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.013\"\>",
                  1.0130491265972608,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1042\"\>",
                  -0.10418928802840784,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.007148\"\>",
                  0.0071483555630132423,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.682\"\>",
                  0.68197251607814979,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.013\"\>",
                  1.0130491265972608,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6486\"\>",
                  0.64862063472879028,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02085\"\>",
                  -0.020854573919826792,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05228\"\>",
                  0.052284058366915312,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.07649\"\>",
                  -0.076492735216379365,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1042\"\>",
                  -0.10418928802840771,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02085\"\>",
                  -0.02085457391982682,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1014\"\>",
                  0.10141745351288228,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.001492\"\>",
                  0.0014919752703393043,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.02589\"\>",
                  -0.025894676242875364,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.007148\"\>",
                  0.0071483555630132423,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05228\"\>",
                  0.052284058366915361,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.001492\"\>",
                  0.0014919752703392748,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02504\"\>",
                  0.025039713194247287,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]238841.76502856307`\
\[InvisibleSpace]"  "\[InvisibleSpace]180465.55241207496`\),
      SequenceForm[ "*BFGSUP ", 238841.76502856307, "  ", 180465.55241207496],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]17\),
      SequenceForm[ "BFGS: Iteration = ", 17],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596116756300\"\>",
            -571.05359611675635,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596639519300\"\>",
            -571.05359663951936,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359611675635, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05359663951936, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.227630026638508"\[Times]10\^"-7"\),
            5.2276300266385078*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.2276300266385078*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.996043370108657`\), \(-3.995856497857351`\), \
\(-0.00018687225130569894`\), \(-0.0009773227313509816`\)},
          {
            "2", \(-3.771826746146609`\), \(-3.7712038609303113`\), \
\(-0.0006228852162972774`\), \(-0.001116806021301063`\)},
          {"3", "18.723595040333745`", "18.722987996664074`", 
            "0.0006070436696703219`", \(-0.00024891722333347056`\)},
          {"4", "44.51826267598928`", "44.516903534701754`", 
            "0.0013591412875234392`", "0.0001375567494387609`"},
          {"5", "26.447376706606292`", "26.447191725733603`", 
            "0.0001849808726886695`", "0.00001372509417980874`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.85\"\>",
                  5.8502195059523103,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3291\"\>",
                  0.32910113338454272,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.537\"\>",
                  0.53703008098755345,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.003756\"\>",
                  -0.0037557634196207501,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.00009239\"\>",
                  9.2393630996334686*^-05,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3291\"\>",
                  0.32910113338454294,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.485\"\>",
                  2.4853212743523554,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8469\"\>",
                  0.84694222840358613,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02071\"\>",
                  -0.020705462510028402,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03662\"\>",
                  0.036622481515333524,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.537\"\>",
                  0.53703008098755345,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8469\"\>",
                  0.84694222840358613,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6119\"\>",
                  0.61192233031363186,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.002495\"\>",
                  -0.0024953506469346798,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.059\"\>",
                  0.059003652840832629,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.003756\"\>",
                  -0.0037557634196208056,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02071\"\>",
                  -0.02070546251002825,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.002495\"\>",
                  -0.0024953506469347075,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09274\"\>",
                  0.092741109793207877,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.003112\"\>",
                  -0.0031122654435844811,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.00009239\"\>",
                  9.2393630996390197*^-05,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03662\"\>",
                  0.036622481515333552,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.059\"\>",
                  0.059003652840832678,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.003112\"\>",
                  -0.0031122654435845123,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02685\"\>",
                  0.026846974777087289,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.2693616304584027`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]1.0909042053136146`*^6\),
      SequenceForm[ "*BFGSUP ", 1269361.6304584027, "  ", 1090904.2053136146],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]18\),
      SequenceForm[ "BFGS: Iteration = ", 18],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596093318700\"\>",
            -571.05359609331867,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596116756600\"\>",
            -571.05359611675658,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359609331867, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05359611675658, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.343790583836380"\[Times]10\^"-8"\),
            2.3437905838363804*^-08,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.3437905838363804*^-08, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.996090203805463`\), \(-3.996043370108657`\), \
\(-0.000046833696806093264`\), \(-0.00013159637715694748`\)},
          {
            "2", \(-3.7719769690559426`\), \(-3.771826746146609`\), \
\(-0.0001502229093338786`\), \(-0.0001487218955058718`\)},
          {"3", "18.723869932310592`", "18.723595040333745`", 
            "0.000274891976846064`", \(-0.000034655815132726053`\)},
          {"4", "44.51856485816781`", "44.51826267598928`", 
            "0.00030218217853182524`", "0.00002621511021087767`"},
          {"5", "26.446334541836062`", 
            "26.447376706606292`", \(-0.0010421647702278129`\), \
\(-0.000015934720896951587`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.716\"\>",
                  5.7161465476068134,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1777\"\>",
                  0.17767096130003257,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5017\"\>",
                  0.50165973386630036,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02337\"\>",
                  0.023373616386124188,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01712\"\>",
                  -0.017115162694764409,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1777\"\>",
                  0.17767096130003324,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.314\"\>",
                  2.3143138570947261,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.807\"\>",
                  0.80697419351618671,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01006\"\>",
                  0.010061785208992105,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0169\"\>",
                  0.016896723863122839,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5017\"\>",
                  0.50165973386630047,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.807\"\>",
                  0.8069741935161866,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6026\"\>",
                  0.60260393289754177,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.004575\"\>",
                  0.0045753098939666469,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05466\"\>",
                  0.054663896974589198,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.02337\"\>",
                  0.023373616386124133,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01006\"\>",
                  0.010061785208992258,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.004575\"\>",
                  0.0045753098939666226,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.08784\"\>",
                  0.087835400045745637,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00098\"\>",
                  -0.00097996519442683982,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.01712\"\>",
                  -0.017115162694764353,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0169\"\>",
                  0.016896723863122871,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05466\"\>",
                  0.054663896974589246,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00098\"\>",
                  -0.00097996519442687191,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02776\"\>",
                  0.027758135499292617,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]19\),
      SequenceForm[ "BFGS: Iteration = ", 19],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596093027700\"\>",
            -571.05359609302764,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596093318600\"\>",
            -571.05359609331856,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359609302764, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05359609331856, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.909246177296154"\[Times]10\^"-10"\),
            2.9092461772961542*^-10,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.9092461772961542*^-10, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.996092651029894`\), \(-3.996090203805463`\), \
\(-2.4472244312955576`*^-6\), "9.052056688914692`*^-7"},
          {
            "2", \(-3.7719842035250783`\), \(-3.7719769690559426`\), \
\(-7.234469135770759`*^-6\), "1.365013999455808`*^-6"},
          {"3", "18.723896132214733`", "18.723869932310592`", 
            "0.00002619990414303645`", \(-2.4230572147832964`*^-8\)},
          {"4", "44.5185768408713`", "44.51856485816781`", 
            "0.000011982703491038868`", "1.2001717512224712`*^-6"},
          {"5", "26.446173530326345`", 
            "26.446334541836062`", \(-0.0001610115097161744`\), \
\(-3.1292872581757136`*^-6\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.716\"\>",
                  5.7161465476068134,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1777\"\>",
                  0.17767096130003257,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5017\"\>",
                  0.50165973386630036,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02337\"\>",
                  0.023373616386124188,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01712\"\>",
                  -0.017115162694764409,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1777\"\>",
                  0.17767096130003324,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.314\"\>",
                  2.3143138570947261,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.807\"\>",
                  0.80697419351618671,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01006\"\>",
                  0.010061785208992105,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0169\"\>",
                  0.016896723863122839,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5017\"\>",
                  0.50165973386630047,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.807\"\>",
                  0.8069741935161866,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6026\"\>",
                  0.60260393289754177,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.004575\"\>",
                  0.0045753098939666469,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05466\"\>",
                  0.054663896974589198,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.02337\"\>",
                  0.023373616386124133,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01006\"\>",
                  0.010061785208992258,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.004575\"\>",
                  0.0045753098939666226,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.08784\"\>",
                  0.087835400045745637,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00098\"\>",
                  -0.00097996519442683982,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.01712\"\>",
                  -0.017115162694764353,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0169\"\>",
                  0.016896723863122871,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05466\"\>",
                  0.054663896974589246,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00098\"\>",
                  -0.00097996519442687191,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02776\"\>",
                  0.027758135499292617,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]20\),
      SequenceForm[ "BFGS: Iteration = ", 20],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596093021100\"\>",
            -571.05359609302116,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596093027500\"\>",
            -571.05359609302752,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359609302116, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05359609302752, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     6.366462912410498"\[Times]10\^"-12"\),
            6.3664629124104977*^-12,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 6.3664629124104977*^-12, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.996093018481496`\), \(-3.996092651029894`\), \
\(-3.674516020549473`*^-7\), "1.2185915760493105`*^-7"},
          {
            "2", \(-3.77198528172654`\), \(-3.7719842035250783`\), \
\(-1.0782014615383481`*^-6\), "1.9946722031038977`*^-7"},
          {"3", "18.723900035966057`", "18.723896132214733`", 
            "3.903751325252666`*^-6", \(-1.4515044418766623`*^-8\)},
          {"4", "44.518578636023484`", "44.5185768408713`", 
            "1.795152185779766`*^-6", "1.797783003348212`*^-7"},
          {"5", "26.4461493694456`", 
            "26.446173530326345`", \(-0.000024160880744968157`\), \
\(-4.709550063166183`*^-7\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.716\"\>",
                  5.7161465476068134,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1777\"\>",
                  0.17767096130003257,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5017\"\>",
                  0.50165973386630036,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02337\"\>",
                  0.023373616386124188,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01712\"\>",
                  -0.017115162694764409,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1777\"\>",
                  0.17767096130003324,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.314\"\>",
                  2.3143138570947261,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.807\"\>",
                  0.80697419351618671,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01006\"\>",
                  0.010061785208992105,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0169\"\>",
                  0.016896723863122839,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5017\"\>",
                  0.50165973386630047,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.807\"\>",
                  0.8069741935161866,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6026\"\>",
                  0.60260393289754177,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.004575\"\>",
                  0.0045753098939666469,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05466\"\>",
                  0.054663896974589198,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.02337\"\>",
                  0.023373616386124133,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01006\"\>",
                  0.010061785208992258,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.004575\"\>",
                  0.0045753098939666226,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.08784\"\>",
                  0.087835400045745637,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00098\"\>",
                  -0.00097996519442683982,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.01712\"\>",
                  -0.017115162694764353,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0169\"\>",
                  0.016896723863122871,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05466\"\>",
                  0.054663896974589246,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00098\"\>",
                  -0.00097996519442687191,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02776\"\>",
                  0.027758135499292617,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS:  ENDE DER ITERATION  "\[InvisibleSpace]20\
\[InvisibleSpace]"  "\[InvisibleSpace]30\),
      SequenceForm[ "MBFGS:  ENDE DER ITERATION  ", 20, "  ", 30],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-571.1091180939013`\), \(-4.096`\), \(-3.872`\), "18.6239`", 
              "44.4186`", "26.3461`"},
            {\(-571.0632660632931`\), \(-3.9435606897461937`\), \
\(-3.7940447780314384`\), "18.66919036516726`", "44.42052574493464`", 
              "26.34755016916682`"},
            {\(-571.0568714731943`\), \(-3.9644376751804193`\), \
\(-3.759605034192029`\), "18.685077512966913`", "44.42236954351728`", 
              "26.349191880310492`"},
            {\(-571.0541966995521`\), \(-3.9973236082764583`\), \
\(-3.764722827723078`\), "18.699337238554477`", "44.431563289460286`", 
              "26.354205467399176`"},
            {\(-571.0540307802946`\), \(-3.996549203510266`\), \
\(-3.765446151825003`\), "18.70979201719499`", "44.438509421315686`", 
              "26.35749841662944`"},
            {\(-571.0537667885047`\), \(-3.9967073272179356`\), \
\(-3.7749209504213237`\), "18.741070015677394`", "44.46451155982686`", 
              "26.369046079267832`"},
            {\(-571.0537245673323`\), \(-3.9975674982418234`\), \
\(-3.779023252625864`\), "18.747881662703154`", "44.475811427316145`", 
              "26.373228373120334`"},
            {\(-571.0536912210472`\), \(-3.998258018412401`\), \
\(-3.7813087906670333`\), "18.749421293316527`", "44.488738752082355`", 
              "26.37730009834615`"},
            {\(-571.0536567699614`\), \(-3.9984602145477357`\), \
\(-3.7812363382305936`\), "18.746300355455883`", "44.50527675204316`", 
              "26.38218654568057`"},
            {\(-571.0536314975344`\), \(-3.9979390598177846`\), \
\(-3.7784212520674525`\), "18.739413052508755`", "44.520084281476564`", 
              "26.38680348416137`"},
            {\(-571.0536241309657`\), \(-3.9972982886995463`\), \
\(-3.77579041807604`\), "18.734896386465035`", "44.52368507574933`", 
              "26.38877520562562`"},
            {\(-571.053622288915`\), \(-3.997005447860776`\), \
\(-3.774745962845`\), "18.73346798633048`", "44.5227866729055`", 
              "26.38987659149165`"},
            {\(-571.0536202753874`\), \(-3.99676657744144`\), \
\(-3.7739482087932035`\), "18.732335643786925`", "44.52136907774139`", 
              "26.392223255223787`"},
            {\(-571.053615547382`\), \(-3.996366665655622`\), \
\(-3.772650821262671`\), "18.730091645448812`", "44.51885475724388`", 
              "26.399883591922272`"},
            {\(-571.0536079435776`\), \(-3.9959209013117913`\), \
\(-3.7712487311518075`\), "18.72679254934776`", "44.516234754032084`", 
              "26.415625659621178`"},
            {\(-571.0536000871357`\), \(-3.9956962707330557`\), \
\(-3.770611705937591`\), "18.723687155661704`", "44.51535714262855`", 
              "26.43628571378669`"},
            {\(-571.0535966395194`\), \(-3.995856497857351`\), \
\(-3.7712038609303113`\), "18.722987996664074`", "44.516903534701754`", 
              "26.447191725733603`"},
            {\(-571.0535961167566`\), \(-3.996043370108657`\), \
\(-3.771826746146609`\), "18.723595040333745`", "44.51826267598928`", 
              "26.447376706606292`"},
            {\(-571.0535960933186`\), \(-3.996090203805463`\), \
\(-3.7719769690559426`\), "18.723869932310592`", "44.51856485816781`", 
              "26.446334541836062`"},
            {\(-571.0535960930275`\), \(-3.996092651029894`\), \
\(-3.7719842035250783`\), "18.723896132214733`", "44.5185768408713`", 
              "26.446173530326345`"},
            {\(-571.0535960930212`\), \(-3.996093018481496`\), \
\(-3.77198528172654`\), "18.723900035966057`", "44.518578636023484`", 
              "26.4461493694456`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", 
          "PSI"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("INKREMENT   "\[InvisibleSpace]6.055454452393343`*^-6\
\),
      SequenceForm[ "INKREMENT   ", 6.0554544523933429*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*GlattDeJong5 {k,p,q,n} "\[InvisibleSpace]{1, 2, 1, 
          1}\),
      SequenceForm[ "*GlattDeJong5 {k,p,q,n} ", {1, 2, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"4.698160570631422`*^-9", "1.6266126738953557`*^-8", 
              "1.1567966168322135`*^-8", \(-3.996093018481496`\), 
              "0.00002419815926094173`"},
            {"2.2397831285638782`*^-8", "2.8942569394938`*^-8", 
              "6.544738109299218`*^-9", \(-3.77198528172654`\), 
              "0.000022841085068593134`"},
            {\(-6.016146193883462`*^-9\), \(-3.704990545315577`*^-9\), 
              "2.311155648567885`*^-9", "18.723900035966057`", 
              "0.00011338172383895853`"},
            {"2.593565798190222`*^-8", "2.695446994600128`*^-8", 
              "1.0188119640990614`*^-9", "44.518578636023484`", 
              "0.00026958022521573154`"},
            {\(-7.099062473607604`*^-8\), \(-7.085078967410981`*^-8\), 
              "1.3983506196622747`*^-10", "26.4461493694456`", 
              "0.00016014345294786876`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SNUM", "S", "DS", "PSI", 
          "INK"}}]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", \(-3.996093018481496`\), "1.6266126738953557`*^-8"},
              {"2", \(-3.77198528172654`\), "2.8942569394938`*^-8"},
              {"3", "18.723900035966057`", \(-3.704990545315577`*^-9\)},
              {"4", "44.518578636023484`", "2.695446994600128`*^-8"},
              {"5", "26.4461493694456`", \(-7.085078967410981`*^-8\)}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", 
        "\[InvisibleSpace]", \(-571.0535960930212`\)}],
      SequenceForm[ 
        TableForm[ {{-3.996093018481496, 
          1.6266126738953557*^-08}, {-3.7719852817265398, 
          2.8942569394938*^-08}, {
          18.723900035966057, -3.7049905453155771*^-09}, {44.518578636023484, 
          2.6954469946001281*^-08}, {
          26.4461493694456, -7.0850789674109814*^-08}}, TableHeadings -> {
          Automatic, {"THETA", "SCORE"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}], "   Likelihood = ", -571.05359609302116],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "367.35518784724525`", "5", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.5758293035489004`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.5758293035489004],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", \(-3.996093018481496`\), "1.1934512670737099`", 
            "0.46332700129989535`"},
          {"2", \(-3.77198528172654`\), "2.64313898579262`", 
            "1.0261312665986766`"},
          {"3", "18.723900035966057`", "6.219874990567637`", 
            "2.4147077533430026`"},
          {"4", "44.518578636023484`", "9.200793176863007`", 
            "3.571973175468743`"},
          {"5", "26.4461493694456`", "20.367593280685373`", 
            "7.90719837398523`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1.`", "0.29130230132352286`", \(-0.40224191014646504`\), 
              "0.006245698371995175`", "0.2866506989880333`"},
            {"0.2913023013235227`", "1.`", \(-0.76009699285259`\), 
              "0.03125255509499482`", "0.4036025448166923`"},
            {\(-0.40224191014646504`\), \(-0.7600969928525908`\), 
              "1.`", \(-0.024322972669206605`\), \(-0.5717094988348961`\)},
            {"0.006245698371995153`", 
              "0.03125255509499476`", \(-0.024322972669206553`\), "1.`", 
              "0.015717486818735568`"},
            {"0.28665069898803325`", 
              "0.4036025448166924`", \(-0.5717094988348959`\), 
              "0.015717486818735592`", "1.0000000000000002`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.21467191013355322`", 
              "0.13849511232872777`", \(-0.4500279684566541`\), 
              "0.010336578467409152`", "1.0501788070902118`"},
            {"0.1384951123287277`", 
              "1.0529453762914043`", \(-1.8833737448879209`\), 
              "0.11455040768632493`", "3.2747598058291008`"},
            {\(-0.45002796845665416`\), \(-1.8833737448879226`\), 
              "5.830813534054811`", \(-0.20979223861825053`\), \
\(-10.915977177078592`\)},
            {"0.010336578467409116`", 
              "0.11455040768632473`", \(-0.2097922386182501`\), 
              "12.758992366268254`", "0.443929420577163`"},
            {"1.0501788070902116`", 
              "3.274759805829101`", \(-10.915977177078588`\), 
              "0.44392942057716367`", "62.523786125554665`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({0.17765331981351543`, 0.39497110964547116`, 4.2750023607910865`, 
      12.75722888694629`, 64.77635363510613`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"5.591597511976734`", "0.07074181621802912`", 
              "0.4036339115767216`", 
              "0.0024171126766520125`", \(-0.02717132514257139`\)},
            {"0.07074181621802912`", "2.258555456172901`", 
              "0.7592784037029818`", \(-0.008307183431716237`\), 
              "0.013137965510759046`"},
            {"0.4036339115767216`", "0.7592784037029818`", 
              "0.5359338934289889`", "0.000032388427574329474`", 
              "0.04702027460993494`"},
            {"0.0024171126766520125`", \(-0.008307183431716237`\), 
              "0.000032388427574329474`", 
              "0.078454710172994`", \(-0.000156887057003898`\)},
            {\(-0.02717132514257139`\), "0.013137965510759046`", 
              "0.04702027460993494`", \(-0.000156887057003898`\), 
              "0.023972523940132964`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({5.6289406865557625`, 2.5318307480706803`, 0.23391799947800512`, 
      0.07838692939210648`, 0.015437732195194773`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]5\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]176\),
      SequenceForm[ "U =  ", 5, "  Nue = ", 176],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "5", "12.926209987595378`", 
            "24.669138997505488`"},
          {"\<\"komp. Lik.\"\>", \(-571.0535960930212`\), \
\(-576.0535960930212`\), \(-583.9798060806165`\), \(-595.7227350905266`\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("DELTA-THEOREM"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH{TZTE STANDARDARDABWEICHUNGEN DER SYSTEM-MATRIZEN"\)], "Print"],

Cell[BoxData[
    \("A, B, OMEGA, SIGMA UND MUE"\)], "Print"],

Cell[BoxData[
    \("UND DER MESS-MODELL-MATRIZEN H, D UND R"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" A     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "1.`"},
                {\(-0.39960930184814963`\), \(-0.377198528172654`\)}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDA   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.04633270012998954`", "0.10261312665986766`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " A     ", 
        MatrixForm[ {{0.0, 
          1.0}, {-0.39960930184814963, -0.37719852817265398}}, TableHeadings -> 
          None], "   STDA   ", 
        MatrixForm[ {{0.0, 0.0}, {0.046332700129989537, 0.10261312665986766}},
           TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" B     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDB   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " B     ", 
        MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None], "   STDB   ", 
        MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"OMEGA  \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"1.`*^-8", "0.`"},
                {"0.`", "350.5844325568497`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDO   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.`", "90.42549317933313`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "OMEGA  ", 
        MatrixForm[ {{1*^-08, 0.0}, {0.0, 350.58443255684972}}, TableHeadings -> 
          None], "   STDO   ", 
        MatrixForm[ {{0.0, 0.0}, {0.0, 90.425493179333131}}, TableHeadings -> 
          None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"MUE    \"\>", "\[InvisibleSpace]", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {0.0, 0.0}, TableHeadings -> None]], 
        "\[InvisibleSpace]", "\<\"   STDMUE \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "MUE    ", 
        MatrixForm[ {0.0, 0.0}, TableHeadings -> None], "   STDMUE ", 
        MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"SIGMA  \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"10000.`", "0.`"},
                {"0.`", "10000.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDSIG \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.`", "0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "SIGMA  ", 
        MatrixForm[ {{10000.0, 0.0}, {0.0, 10000.0}}, TableHeadings -> None], 
        "   STDSIG ", 
        MatrixForm[ {{0.0, 0.0}, {0.0, 0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" H     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"1.`", "0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDH   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " H     ", 
        MatrixForm[ {{1.0, 0.0}}, TableHeadings -> None], "   STDH   ", 
        MatrixForm[ {{0.0, 0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" D     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"44.518578636023484`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDD   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3.571973175468743`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " D     ", 
        MatrixForm[ {{44.518578636023484}}, TableHeadings -> None], 
        "   STDD   ", 
        MatrixForm[ {{3.5719731754687429}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" R     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"26.4461493694456`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDR   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"7.90719837398523`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " R     ", 
        MatrixForm[ {{26.4461493694456}}, TableHeadings -> None], 
        "   STDR   ", 
        MatrixForm[ {{7.9071983739852296}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("DELTA-THEOREM"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE STANDARDABWEICHUNGEN DER \
SYSTEM-MATRIZEN"\)], "Print"],

Cell[BoxData[
    \("A*, B*, OMEGA*, SIGMA UND MUE"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" A*     \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"      0.8288\"\>",
                      0.82877938755091463,
                      AutoDelete->True], 
                    InterpretationBox["\<\"      0.7788\"\>",
                      0.77878031704553252,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"     -0.3112\"\>",
                      -0.3112078587876459,
                      AutoDelete->True], 
                    InterpretationBox["\<\"      0.5350\"\>",
                      0.53502459819150694,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " A*     ", 
        PaddedForm[ 
          
          MatrixForm[ {{0.82877938755091463, 
            0.77878031704553252}, {-0.3112078587876459, 0.53502459819150694}},
             TableHeadings -> None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" STDA   \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"      0.0184\"\>",
                      0.018371870748726492,
                      AutoDelete->True], 
                    InterpretationBox["\<\"      0.0396\"\>",
                      0.039618773044386386,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"      0.0326\"\>",
                      0.03257021939437757,
                      AutoDelete->True], 
                    InterpretationBox["\<\"      0.0672\"\>",
                      0.067240992233745356,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " STDA   ", 
        PaddedForm[ 
          
          MatrixForm[ {{0.018371870748726492, 0.039618773044386386}, {
            0.03257021939437757, 0.067240992233745356}}, TableHeadings -> 
            None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" B*     \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " B*     ", 
        PaddedForm[ 
          MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" STDB   \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " STDB   ", 
        PaddedForm[ 
          MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" OMEGA* \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"     82.2921\"\>",
                      82.292111816952655,
                      AutoDelete->True], 
                    InterpretationBox["\<\"    106.3145\"\>",
                      106.31451570351274,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"    106.3145\"\>",
                      106.31451570351277,
                      AutoDelete->True], 
                    InterpretationBox["\<\"    219.0632\"\>",
                      219.06320490902368,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " OMEGA* ", 
        PaddedForm[ 
          
          MatrixForm[ {{82.292111816952655, 106.31451570351274}, {
            106.31451570351277, 219.06320490902368}}, TableHeadings -> 
            None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" STDO   \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"     16.9261\"\>",
                      16.926118692274297,
                      AutoDelete->True], 
                    InterpretationBox["\<\"     20.1583\"\>",
                      20.158334931566088,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"     20.1583\"\>",
                      20.158334931566099,
                      AutoDelete->True], 
                    InterpretationBox["\<\"     42.9130\"\>",
                      42.912992499570983,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " STDO   ", 
        PaddedForm[ 
          
          MatrixForm[ {{16.926118692274297, 20.158334931566088}, {
            20.158334931566099, 42.912992499570983}}, TableHeadings -> 
            None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" MUE    \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            MatrixForm[ {0.0, 0.0}, TableHeadings -> None]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " MUE    ", 
        PaddedForm[ 
          MatrixForm[ {0.0, 0.0}, TableHeadings -> None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" STDMUE \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " STDMUE ", 
        PaddedForm[ 
          MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" SIGMA  \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"  10000.0000\"\>",
                      10000.0,
                      AutoDelete->True], 
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True], 
                    InterpretationBox["\<\"  10000.0000\"\>",
                      10000.0,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " SIGMA  ", 
        PaddedForm[ 
          
          MatrixForm[ {{10000.0, 0.0}, {0.0, 10000.0}}, TableHeadings -> 
            None], {10, 4}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" STDSIG \"\>", "\[InvisibleSpace]", 
        TagBox[
          TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True], 
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]},
                  {
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True], 
                    InterpretationBox["\<\"      0.0000\"\>",
                      0.0,
                      AutoDelete->True]}
                  }], "\[NoBreak]", ")"}],
            Function[ BoxForm`e$, 
              MatrixForm[ BoxForm`e$, TableHeadings -> None]]],
          (PaddedForm[ #, {10, 4}]&)]}],
      SequenceForm[ " STDSIG ", 
        PaddedForm[ 
          MatrixForm[ {{0.0, 0.0}, {0.0, 0.0}}, TableHeadings -> None], {10, 
          4}]],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g = Table[plot1[ColumnSelect[likpsi,{i}]//AddTimeAxis,color->{i},
\t\t\tDisplayFunction->Identity],{i,6}];
Show[GraphicsArray[Partition[g,3]]]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 2}\),
      SequenceForm[ "Dimension der Daten  ", {21, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 -87.3179 4.68927 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -3 -9 ]
[.2619 -0.0125 3 0 ]
[.5 -0.0125 -6 -9 ]
[.5 -0.0125 6 0 ]
[.7381 -0.0125 -6 -9 ]
[.7381 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09021 -30 -4.5 ]
[-0.0125 .09021 0 4.5 ]
[-0.0125 .184 -30 -4.5 ]
[-0.0125 .184 0 4.5 ]
[-0.0125 .27778 -30 -4.5 ]
[-0.0125 .27778 0 4.5 ]
[-0.0125 .37157 -24 -4.5 ]
[-0.0125 .37157 0 4.5 ]
[-0.0125 .46535 -30 -4.5 ]
[-0.0125 .46535 0 4.5 ]
[-0.0125 .55914 -30 -4.5 ]
[-0.0125 .55914 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .48364 -5 -6 ]
[.97619 .48364 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(10)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(15)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(20)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09021 m
.00625 .09021 L
s
[(18.64)] -0.0125 .09021 1 0 Mshowa
0 .184 m
.00625 .184 L
s
[(18.66)] -0.0125 .184 1 0 Mshowa
0 .27778 m
.00625 .27778 L
s
[(18.68)] -0.0125 .27778 1 0 Mshowa
0 .37157 m
.00625 .37157 L
s
[(18.7)] -0.0125 .37157 1 0 Mshowa
0 .46535 m
.00625 .46535 L
s
[(18.72)] -0.0125 .46535 1 0 Mshowa
0 .55914 m
.00625 .55914 L
s
[(18.74)] -0.0125 .55914 1 0 Mshowa
.125 Mabswid
0 .01987 m
.00375 .01987 L
s
0 .04332 m
.00375 .04332 L
s
0 .06677 m
.00375 .06677 L
s
0 .11366 m
.00375 .11366 L
s
0 .13711 m
.00375 .13711 L
s
0 .16055 m
.00375 .16055 L
s
0 .20744 m
.00375 .20744 L
s
0 .23089 m
.00375 .23089 L
s
0 .25434 m
.00375 .25434 L
s
0 .30123 m
.00375 .30123 L
s
0 .32468 m
.00375 .32468 L
s
0 .34812 m
.00375 .34812 L
s
0 .39502 m
.00375 .39502 L
s
0 .41846 m
.00375 .41846 L
s
0 .44191 m
.00375 .44191 L
s
0 .4888 m
.00375 .4888 L
s
0 .51225 m
.00375 .51225 L
s
0 .53569 m
.00375 .53569 L
s
0 .58259 m
.00375 .58259 L
s
0 .60603 m
.00375 .60603 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09021 m
1 .09021 L
s
.99375 .184 m
1 .184 L
s
.99375 .27778 m
1 .27778 L
s
.99375 .37157 m
1 .37157 L
s
.99375 .46535 m
1 .46535 L
s
.99375 .55914 m
1 .55914 L
s
.125 Mabswid
.99625 .01987 m
1 .01987 L
s
.99625 .04332 m
1 .04332 L
s
.99625 .06677 m
1 .06677 L
s
.99625 .11366 m
1 .11366 L
s
.99625 .13711 m
1 .13711 L
s
.99625 .16055 m
1 .16055 L
s
.99625 .20744 m
1 .20744 L
s
.99625 .23089 m
1 .23089 L
s
.99625 .25434 m
1 .25434 L
s
.99625 .30123 m
1 .30123 L
s
.99625 .32468 m
1 .32468 L
s
.99625 .34812 m
1 .34812 L
s
.99625 .39502 m
1 .39502 L
s
.99625 .41846 m
1 .41846 L
s
.99625 .44191 m
1 .44191 L
s
.99625 .4888 m
1 .4888 L
s
.99625 .51225 m
1 .51225 L
s
.99625 .53569 m
1 .53569 L
s
.99625 .58259 m
1 .58259 L
s
.99625 .60603 m
1 .60603 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 1 0 r
gsave
.97619 .48364 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07143 .22709 L
.11905 .30159 L
.16667 .36846 L
.21429 .41749 L
.2619 .56416 L
.30952 .5961 L
.35714 .60332 L
.40476 .58868 L
.45238 .55639 L
.5 .53521 L
.54762 .52851 L
.59524 .5232 L
.64286 .51268 L
.69048 .49721 L
.7381 .48264 L
.78571 .47937 L
.83333 .48221 L
.88095 .4835 L
.92857 .48362 L
.97619 .48364 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 -248.783 5.60121 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -3 -9 ]
[.2619 -0.0125 3 0 ]
[.5 -0.0125 -6 -9 ]
[.5 -0.0125 6 0 ]
[.7381 -0.0125 -6 -9 ]
[.7381 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02256 -30 -4.5 ]
[-0.0125 .02256 0 4.5 ]
[-0.0125 .13458 -30 -4.5 ]
[-0.0125 .13458 0 4.5 ]
[-0.0125 .24661 -30 -4.5 ]
[-0.0125 .24661 0 4.5 ]
[-0.0125 .35863 -30 -4.5 ]
[-0.0125 .35863 0 4.5 ]
[-0.0125 .47065 -24 -4.5 ]
[-0.0125 .47065 0 4.5 ]
[-0.0125 .58268 -30 -4.5 ]
[-0.0125 .58268 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .57472 -5 -6 ]
[.97619 .57472 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(10)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(15)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(20)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02256 m
.00625 .02256 L
s
[(44.42)] -0.0125 .02256 1 0 Mshowa
0 .13458 m
.00625 .13458 L
s
[(44.44)] -0.0125 .13458 1 0 Mshowa
0 .24661 m
.00625 .24661 L
s
[(44.46)] -0.0125 .24661 1 0 Mshowa
0 .35863 m
.00625 .35863 L
s
[(44.48)] -0.0125 .35863 1 0 Mshowa
0 .47065 m
.00625 .47065 L
s
[(44.5)] -0.0125 .47065 1 0 Mshowa
0 .58268 m
.00625 .58268 L
s
[(44.52)] -0.0125 .58268 1 0 Mshowa
.125 Mabswid
0 .05056 m
.00375 .05056 L
s
0 .07857 m
.00375 .07857 L
s
0 .10657 m
.00375 .10657 L
s
0 .16259 m
.00375 .16259 L
s
0 .19059 m
.00375 .19059 L
s
0 .2186 m
.00375 .2186 L
s
0 .27461 m
.00375 .27461 L
s
0 .30262 m
.00375 .30262 L
s
0 .33062 m
.00375 .33062 L
s
0 .38664 m
.00375 .38664 L
s
0 .41464 m
.00375 .41464 L
s
0 .44265 m
.00375 .44265 L
s
0 .49866 m
.00375 .49866 L
s
0 .52667 m
.00375 .52667 L
s
0 .55467 m
.00375 .55467 L
s
0 .61068 m
.00375 .61068 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02256 m
1 .02256 L
s
.99375 .13458 m
1 .13458 L
s
.99375 .24661 m
1 .24661 L
s
.99375 .35863 m
1 .35863 L
s
.99375 .47065 m
1 .47065 L
s
.99375 .58268 m
1 .58268 L
s
.125 Mabswid
.99625 .05056 m
1 .05056 L
s
.99625 .07857 m
1 .07857 L
s
.99625 .10657 m
1 .10657 L
s
.99625 .16259 m
1 .16259 L
s
.99625 .19059 m
1 .19059 L
s
.99625 .2186 m
1 .2186 L
s
.99625 .27461 m
1 .27461 L
s
.99625 .30262 m
1 .30262 L
s
.99625 .33062 m
1 .33062 L
s
.99625 .38664 m
1 .38664 L
s
.99625 .41464 m
1 .41464 L
s
.99625 .44265 m
1 .44265 L
s
.99625 .49866 m
1 .49866 L
s
.99625 .52667 m
1 .52667 L
s
.99625 .55467 m
1 .55467 L
s
.99625 .61068 m
1 .61068 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
.541 .169 .886 r
gsave
.97619 .57472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.541 0.169 0.886 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07143 .0255 L
.11905 .03583 L
.16667 .08733 L
.21429 .12623 L
.2619 .27188 L
.30952 .33517 L
.35714 .40758 L
.40476 .50021 L
.45238 .58315 L
.5 .60332 L
.54762 .59829 L
.59524 .59035 L
.64286 .57626 L
.69048 .56159 L
.7381 .55667 L
.78571 .56533 L
.83333 .57295 L
.88095 .57464 L
.92857 .57471 L
.97619 .57472 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 -153.105 5.81184 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -3 -9 ]
[.2619 -0.0125 3 0 ]
[.5 -0.0125 -6 -9 ]
[.5 -0.0125 6 0 ]
[.7381 -0.0125 -6 -9 ]
[.7381 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0955 -30 -4.5 ]
[-0.0125 .0955 0 4.5 ]
[-0.0125 .21174 -30 -4.5 ]
[-0.0125 .21174 0 4.5 ]
[-0.0125 .32797 -24 -4.5 ]
[-0.0125 .32797 0 4.5 ]
[-0.0125 .44421 -30 -4.5 ]
[-0.0125 .44421 0 4.5 ]
[-0.0125 .56045 -30 -4.5 ]
[-0.0125 .56045 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .59619 -5 -6 ]
[.97619 .59619 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(10)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(15)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(20)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0955 m
.00625 .0955 L
s
[(26.36)] -0.0125 .0955 1 0 Mshowa
0 .21174 m
.00625 .21174 L
s
[(26.38)] -0.0125 .21174 1 0 Mshowa
0 .32797 m
.00625 .32797 L
s
[(26.4)] -0.0125 .32797 1 0 Mshowa
0 .44421 m
.00625 .44421 L
s
[(26.42)] -0.0125 .44421 1 0 Mshowa
0 .56045 m
.00625 .56045 L
s
[(26.44)] -0.0125 .56045 1 0 Mshowa
.125 Mabswid
0 .12456 m
.00375 .12456 L
s
0 .15362 m
.00375 .15362 L
s
0 .18268 m
.00375 .18268 L
s
0 .2408 m
.00375 .2408 L
s
0 .26985 m
.00375 .26985 L
s
0 .29891 m
.00375 .29891 L
s
0 .35703 m
.00375 .35703 L
s
0 .38609 m
.00375 .38609 L
s
0 .41515 m
.00375 .41515 L
s
0 .47327 m
.00375 .47327 L
s
0 .50233 m
.00375 .50233 L
s
0 .53139 m
.00375 .53139 L
s
0 .06644 m
.00375 .06644 L
s
0 .03738 m
.00375 .03738 L
s
0 .00832 m
.00375 .00832 L
s
0 .58951 m
.00375 .58951 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0955 m
1 .0955 L
s
.99375 .21174 m
1 .21174 L
s
.99375 .32797 m
1 .32797 L
s
.99375 .44421 m
1 .44421 L
s
.99375 .56045 m
1 .56045 L
s
.125 Mabswid
.99625 .12456 m
1 .12456 L
s
.99625 .15362 m
1 .15362 L
s
.99625 .18268 m
1 .18268 L
s
.99625 .2408 m
1 .2408 L
s
.99625 .26985 m
1 .26985 L
s
.99625 .29891 m
1 .29891 L
s
.99625 .35703 m
1 .35703 L
s
.99625 .38609 m
1 .38609 L
s
.99625 .41515 m
1 .41515 L
s
.99625 .47327 m
1 .47327 L
s
.99625 .50233 m
1 .50233 L
s
.99625 .53139 m
1 .53139 L
s
.99625 .06644 m
1 .06644 L
s
.99625 .03738 m
1 .03738 L
s
.99625 .00832 m
1 .00832 L
s
.99625 .58951 m
1 .58951 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 .38 .01 r
gsave
.97619 .59619 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07143 .02314 L
.11905 .03268 L
.16667 .06182 L
.21429 .08096 L
.2619 .14807 L
.30952 .17238 L
.35714 .19605 L
.40476 .22444 L
.45238 .25128 L
.5 .26274 L
.54762 .26914 L
.59524 .28278 L
.64286 .3273 L
.69048 .41879 L
.7381 .53886 L
.78571 .60224 L
.83333 .60332 L
.88095 .59726 L
.92857 .59633 L
.97619 .59619 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 6054.5 10.6013 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -3 -9 ]
[.2619 -0.0125 3 0 ]
[.5 -0.0125 -6 -9 ]
[.5 -0.0125 6 0 ]
[.7381 -0.0125 -6 -9 ]
[.7381 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00537 -42 -4.5 ]
[-0.0125 .00537 0 4.5 ]
[-0.0125 .11138 -36 -4.5 ]
[-0.0125 .11138 0 4.5 ]
[-0.0125 .21739 -42 -4.5 ]
[-0.0125 .21739 0 4.5 ]
[-0.0125 .3234 -42 -4.5 ]
[-0.0125 .3234 0 4.5 ]
[-0.0125 .42942 -42 -4.5 ]
[-0.0125 .42942 0 4.5 ]
[-0.0125 .53543 -42 -4.5 ]
[-0.0125 .53543 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .60332 -5 -6 ]
[.97619 .60332 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(10)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(15)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(20)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00537 m
.00625 .00537 L
s
[(-571.11)] -0.0125 .00537 1 0 Mshowa
0 .11138 m
.00625 .11138 L
s
[(-571.1)] -0.0125 .11138 1 0 Mshowa
0 .21739 m
.00625 .21739 L
s
[(-571.09)] -0.0125 .21739 1 0 Mshowa
0 .3234 m
.00625 .3234 L
s
[(-571.08)] -0.0125 .3234 1 0 Mshowa
0 .42942 m
.00625 .42942 L
s
[(-571.07)] -0.0125 .42942 1 0 Mshowa
0 .53543 m
.00625 .53543 L
s
[(-571.06)] -0.0125 .53543 1 0 Mshowa
.125 Mabswid
0 .02657 m
.00375 .02657 L
s
0 .04777 m
.00375 .04777 L
s
0 .06897 m
.00375 .06897 L
s
0 .09018 m
.00375 .09018 L
s
0 .13258 m
.00375 .13258 L
s
0 .15378 m
.00375 .15378 L
s
0 .17499 m
.00375 .17499 L
s
0 .19619 m
.00375 .19619 L
s
0 .23859 m
.00375 .23859 L
s
0 .2598 m
.00375 .2598 L
s
0 .281 m
.00375 .281 L
s
0 .3022 m
.00375 .3022 L
s
0 .34461 m
.00375 .34461 L
s
0 .36581 m
.00375 .36581 L
s
0 .38701 m
.00375 .38701 L
s
0 .40821 m
.00375 .40821 L
s
0 .45062 m
.00375 .45062 L
s
0 .47182 m
.00375 .47182 L
s
0 .49302 m
.00375 .49302 L
s
0 .51423 m
.00375 .51423 L
s
0 .55663 m
.00375 .55663 L
s
0 .57783 m
.00375 .57783 L
s
0 .59904 m
.00375 .59904 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00537 m
1 .00537 L
s
.99375 .11138 m
1 .11138 L
s
.99375 .21739 m
1 .21739 L
s
.99375 .3234 m
1 .3234 L
s
.99375 .42942 m
1 .42942 L
s
.99375 .53543 m
1 .53543 L
s
.125 Mabswid
.99625 .02657 m
1 .02657 L
s
.99625 .04777 m
1 .04777 L
s
.99625 .06897 m
1 .06897 L
s
.99625 .09018 m
1 .09018 L
s
.99625 .13258 m
1 .13258 L
s
.99625 .15378 m
1 .15378 L
s
.99625 .17499 m
1 .17499 L
s
.99625 .19619 m
1 .19619 L
s
.99625 .23859 m
1 .23859 L
s
.99625 .2598 m
1 .2598 L
s
.99625 .281 m
1 .281 L
s
.99625 .3022 m
1 .3022 L
s
.99625 .34461 m
1 .34461 L
s
.99625 .36581 m
1 .36581 L
s
.99625 .38701 m
1 .38701 L
s
.99625 .40821 m
1 .40821 L
s
.99625 .45062 m
1 .45062 L
s
.99625 .47182 m
1 .47182 L
s
.99625 .49302 m
1 .49302 L
s
.99625 .51423 m
1 .51423 L
s
.99625 .55663 m
1 .55663 L
s
.99625 .57783 m
1 .57783 L
s
.99625 .59904 m
1 .59904 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07143 .5008 L
.11905 .5686 L
.16667 .59695 L
.21429 .59871 L
.2619 .60151 L
.30952 .60196 L
.35714 .60231 L
.40476 .60268 L
.45238 .60294 L
.5 .60302 L
.54762 .60304 L
.59524 .60306 L
.64286 .60311 L
.69048 .60319 L
.7381 .60328 L
.78571 .60331 L
.83333 .60332 L
.88095 .60332 L
.92857 .60332 L
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 15.8303 3.86123 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -3 -9 ]
[.2619 -0.0125 3 0 ]
[.5 -0.0125 -6 -9 ]
[.5 -0.0125 6 0 ]
[.7381 -0.0125 -6 -9 ]
[.7381 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0958 -36 -4.5 ]
[-0.0125 .0958 0 4.5 ]
[-0.0125 .19233 -30 -4.5 ]
[-0.0125 .19233 0 4.5 ]
[-0.0125 .28886 -36 -4.5 ]
[-0.0125 .28886 0 4.5 ]
[-0.0125 .38539 -12 -4.5 ]
[-0.0125 .38539 0 4.5 ]
[-0.0125 .48192 -36 -4.5 ]
[-0.0125 .48192 0 4.5 ]
[-0.0125 .57846 -30 -4.5 ]
[-0.0125 .57846 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .40048 -5 -6 ]
[.97619 .40048 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(10)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(15)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(20)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0958 m
.00625 .0958 L
s
[(-4.075)] -0.0125 .0958 1 0 Mshowa
0 .19233 m
.00625 .19233 L
s
[(-4.05)] -0.0125 .19233 1 0 Mshowa
0 .28886 m
.00625 .28886 L
s
[(-4.025)] -0.0125 .28886 1 0 Mshowa
0 .38539 m
.00625 .38539 L
s
[(-4)] -0.0125 .38539 1 0 Mshowa
0 .48192 m
.00625 .48192 L
s
[(-3.975)] -0.0125 .48192 1 0 Mshowa
0 .57846 m
.00625 .57846 L
s
[(-3.95)] -0.0125 .57846 1 0 Mshowa
.125 Mabswid
0 .01858 m
.00375 .01858 L
s
0 .03788 m
.00375 .03788 L
s
0 .05719 m
.00375 .05719 L
s
0 .07649 m
.00375 .07649 L
s
0 .11511 m
.00375 .11511 L
s
0 .13441 m
.00375 .13441 L
s
0 .15372 m
.00375 .15372 L
s
0 .17303 m
.00375 .17303 L
s
0 .21164 m
.00375 .21164 L
s
0 .23094 m
.00375 .23094 L
s
0 .25025 m
.00375 .25025 L
s
0 .26956 m
.00375 .26956 L
s
0 .30817 m
.00375 .30817 L
s
0 .32748 m
.00375 .32748 L
s
0 .34678 m
.00375 .34678 L
s
0 .36609 m
.00375 .36609 L
s
0 .4047 m
.00375 .4047 L
s
0 .42401 m
.00375 .42401 L
s
0 .44331 m
.00375 .44331 L
s
0 .46262 m
.00375 .46262 L
s
0 .50123 m
.00375 .50123 L
s
0 .52054 m
.00375 .52054 L
s
0 .53984 m
.00375 .53984 L
s
0 .55915 m
.00375 .55915 L
s
0 .59776 m
.00375 .59776 L
s
0 .61707 m
.00375 .61707 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0958 m
1 .0958 L
s
.99375 .19233 m
1 .19233 L
s
.99375 .28886 m
1 .28886 L
s
.99375 .38539 m
1 .38539 L
s
.99375 .48192 m
1 .48192 L
s
.99375 .57846 m
1 .57846 L
s
.125 Mabswid
.99625 .01858 m
1 .01858 L
s
.99625 .03788 m
1 .03788 L
s
.99625 .05719 m
1 .05719 L
s
.99625 .07649 m
1 .07649 L
s
.99625 .11511 m
1 .11511 L
s
.99625 .13441 m
1 .13441 L
s
.99625 .15372 m
1 .15372 L
s
.99625 .17303 m
1 .17303 L
s
.99625 .21164 m
1 .21164 L
s
.99625 .23094 m
1 .23094 L
s
.99625 .25025 m
1 .25025 L
s
.99625 .26956 m
1 .26956 L
s
.99625 .30817 m
1 .30817 L
s
.99625 .32748 m
1 .32748 L
s
.99625 .34678 m
1 .34678 L
s
.99625 .36609 m
1 .36609 L
s
.99625 .4047 m
1 .4047 L
s
.99625 .42401 m
1 .42401 L
s
.99625 .44331 m
1 .44331 L
s
.99625 .46262 m
1 .46262 L
s
.99625 .50123 m
1 .50123 L
s
.99625 .52054 m
1 .52054 L
s
.99625 .53984 m
1 .53984 L
s
.99625 .55915 m
1 .55915 L
s
.99625 .59776 m
1 .59776 L
s
.99625 .61707 m
1 .61707 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 .98 .604 r
gsave
.97619 .40048 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07143 .60332 L
.11905 .52271 L
.16667 .39573 L
.21429 .39872 L
.2619 .39811 L
.30952 .39479 L
.35714 .39212 L
.40476 .39134 L
.45238 .39335 L
.5 .39583 L
.54762 .39696 L
.59524 .39788 L
.64286 .39942 L
.69048 .40114 L
.7381 .40201 L
.78571 .40139 L
.83333 .40067 L
.88095 .40049 L
.92857 .40048 L
.97619 .40048 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 20.2921 5.23692 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -3 -9 ]
[.2619 -0.0125 3 0 ]
[.5 -0.0125 -6 -9 ]
[.5 -0.0125 6 0 ]
[.7381 -0.0125 -6 -9 ]
[.7381 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07756 -30 -4.5 ]
[-0.0125 .07756 0 4.5 ]
[-0.0125 .1823 -30 -4.5 ]
[-0.0125 .1823 0 4.5 ]
[-0.0125 .28704 -30 -4.5 ]
[-0.0125 .28704 0 4.5 ]
[-0.0125 .39177 -24 -4.5 ]
[-0.0125 .39177 0 4.5 ]
[-0.0125 .49651 -30 -4.5 ]
[-0.0125 .49651 0 4.5 ]
[-0.0125 .60125 -30 -4.5 ]
[-0.0125 .60125 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .53848 -5 -6 ]
[.97619 .53848 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(10)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(15)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(20)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07756 m
.00625 .07756 L
s
[(-3.86)] -0.0125 .07756 1 0 Mshowa
0 .1823 m
.00625 .1823 L
s
[(-3.84)] -0.0125 .1823 1 0 Mshowa
0 .28704 m
.00625 .28704 L
s
[(-3.82)] -0.0125 .28704 1 0 Mshowa
0 .39177 m
.00625 .39177 L
s
[(-3.8)] -0.0125 .39177 1 0 Mshowa
0 .49651 m
.00625 .49651 L
s
[(-3.78)] -0.0125 .49651 1 0 Mshowa
0 .60125 m
.00625 .60125 L
s
[(-3.76)] -0.0125 .60125 1 0 Mshowa
.125 Mabswid
0 .10374 m
.00375 .10374 L
s
0 .12993 m
.00375 .12993 L
s
0 .15611 m
.00375 .15611 L
s
0 .20848 m
.00375 .20848 L
s
0 .23467 m
.00375 .23467 L
s
0 .26085 m
.00375 .26085 L
s
0 .31322 m
.00375 .31322 L
s
0 .3394 m
.00375 .3394 L
s
0 .36559 m
.00375 .36559 L
s
0 .41796 m
.00375 .41796 L
s
0 .44414 m
.00375 .44414 L
s
0 .47033 m
.00375 .47033 L
s
0 .5227 m
.00375 .5227 L
s
0 .54888 m
.00375 .54888 L
s
0 .57507 m
.00375 .57507 L
s
0 .05137 m
.00375 .05137 L
s
0 .02519 m
.00375 .02519 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07756 m
1 .07756 L
s
.99375 .1823 m
1 .1823 L
s
.99375 .28704 m
1 .28704 L
s
.99375 .39177 m
1 .39177 L
s
.99375 .49651 m
1 .49651 L
s
.99375 .60125 m
1 .60125 L
s
.125 Mabswid
.99625 .10374 m
1 .10374 L
s
.99625 .12993 m
1 .12993 L
s
.99625 .15611 m
1 .15611 L
s
.99625 .20848 m
1 .20848 L
s
.99625 .23467 m
1 .23467 L
s
.99625 .26085 m
1 .26085 L
s
.99625 .31322 m
1 .31322 L
s
.99625 .3394 m
1 .3394 L
s
.99625 .36559 m
1 .36559 L
s
.99625 .41796 m
1 .41796 L
s
.99625 .44414 m
1 .44414 L
s
.99625 .47033 m
1 .47033 L
s
.99625 .5227 m
1 .5227 L
s
.99625 .54888 m
1 .54888 L
s
.99625 .57507 m
1 .57507 L
s
.99625 .05137 m
1 .05137 L
s
.99625 .02519 m
1 .02519 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .53848 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07143 .42296 L
.11905 .60332 L
.16667 .57652 L
.21429 .57273 L
.2619 .52311 L
.30952 .50163 L
.35714 .48966 L
.40476 .49004 L
.45238 .50478 L
.5 .51856 L
.54762 .52403 L
.59524 .5282 L
.64286 .535 L
.69048 .54234 L
.7381 .54568 L
.78571 .54258 L
.83333 .53931 L
.88095 .53853 L
.92857 .53849 L
.97619 .53848 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{589.125, 242.75},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009=0000lR000`400?l00000o`00003oo`3ooooo
0?ooodl0oooo003o0?ooool0ooooC`3oool00?l0ooooo`3ooom?0?ooo`00o`3ooooo0?ooodl0oooo
003o0?ooool0ooooC`3oool00?l0ooooo`3ooom?0?ooo`00o`3ooooo0?ooodl0oooo003o0?ooool0
ooooC`3oool00?l0ooooo`3ooom?0?ooo`00o`3ooooo0?ooodl0oooo003o0?ooojH0oooo0P00000Q
0?ooo`<000007`3oool3000000@0oooo0P00000K0?ooo`<000000`3oool3000001X0oooo1@000003
0?ooo`8000004P3oool00?l0ooooY@3oool010000000oooo0?ooo`00000O0?ooo`050000003oool0
oooo0?ooo`0000007`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000001/0oooo
00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01P0oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`00000A0?ooo`00<@3oool200000240oooo0`00000N0?oo
o`<00000103oool2000001/0oooo0`0000030?ooo`<000006P3oool5000000<0oooo0P00000U0?oo
o`8000008@3oool3000001h0oooo0`0000040?ooo`8000006`3oool3000000<0oooo0`00000K0?oo
o`D000000`3oool2000002<0oooo00@000000?ooo`3oool000008`3oool00`000000oooo0?ooo`0M
0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000006`3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool00P3oool010000000oooo0?oo
o`00000A0?ooo`00<03oool010000000oooo0?ooo`00000O0?ooo`050000003oool0oooo0?ooo`00
00007P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000001/0oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01P0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`00000S0?ooo`040000003oool0oooo000001l0oooo00D000000?ooo`3o
ool0oooo0000000N0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000006`3oool0
1@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06@3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000280oooo00@000000?ooo`3oool000008`3oool00`00
0000oooo0?ooo`0M0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000006`3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo01X0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`030000003oool0oooo00l0oooo000`0?ooo`040000003oool0oooo000002<0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000001/0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0080oooo
00@000000?ooo`3oool000008`3oool010000000oooo0?ooo`00000S0?ooo`030000003oool0oooo
01`0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00000K0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`020?ooo`040000003oool0
oooo00000280oooo00@000000?ooo`3oool000007`3oool400000200oooo00<000000?ooo`3oool0
0P3oool010000000oooo0?ooo`00000K0?ooo`040000003oool0oooo0?ooo`@000006P3oool01@00
0000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000004@3oool00300oooo00@00000
0?ooo`3oool000008`3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0080oooo00@0
00000?ooo`3oool000006`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01X0oooo
00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0240oooo00@000000?ooo`3o
ool000008`3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0080oooo00@000000?oo
o`3oool000006`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01/0oooo00D00000
0?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0200oooo00@000000?ooo`3oool00000
7`3oool00`000000oooo0?ooo`0P0?ooo`800000103oool010000000oooo0?ooo`00000J0?ooo`80
00000`3oool00`000000oooo0?ooo`0K0?ooo`050000003oool0oooo0?ooo`0000000P3oool01000
0000oooo0?ooo`00000A0?ooo`00<03oool010000000oooo0?ooo`00000O0?ooo`@000007`3oool0
0`000000oooo0?ooo`020?ooo`040000003oool0oooo000001/0oooo00@000000?ooo`3oool0oooo
1000000J0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`00000S0?oo
o`040000003oool0oooo000001l0oooo1000000O0?ooo`030000003oool0oooo0080oooo00@00000
0?ooo`3oool000006`3oool010000000oooo0?ooo`3oool4000001/0oooo00D000000?ooo`3oool0
oooo000000020?ooo`040000003oool0oooo000002<0oooo0P00000P0?ooo`D000007`3oool00`00
0000oooo0?ooo`030?ooo`800000703oool010000000oooo0?ooo`3oool5000001X0oooo0`000004
0?ooo`8000004P3oool00300oooo00@000000?ooo`3oool000007`3oool00`000000oooo0?ooo`0O
0?ooo`800000103oool010000000oooo0?ooo`00000J0?ooo`8000000`3oool00`000000oooo0?oo
o`0K0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`00000S0?ooo`04
0000003oool0oooo000001l0oooo00<000000?ooo`3oool07`3oool2000000@0oooo00@000000?oo
o`3oool000006P3oool2000000<0oooo00<000000?ooo`3oool0703oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool00000b`3oool00340oooo0P00000P0?ooo`D000007P3o
ool00`000000oooo0?ooo`030?ooo`800000703oool010000000oooo0?ooo`3oool5000001X0oooo
0`0000040?ooo`8000009@3oool200000200oooo1@00000N0?ooo`030000003oool0oooo00<0oooo
0P00000L0?ooo`040000003oool0oooo0?ooo`D000006`3oool3000000@0oooo0P00003<0?ooo`00
o`3ooooo0?ooodl0oooo003o0?oooj@0ooooV@00000A0?ooo`00o`3ooonT0?ooo`040000003oool0
oooo000000H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool000000140oooo
000^0?oooiT000000`3oool3000000<0oooo0`0000030?ooo`030000003oool0oooo00<0oooo0`00
00000`3oool0000000000003000000<0ooooV@00000R0?ooo`030000003oool0oooo00<0of42T@3o
ool200000140oooo000^0?ooo`050000003oool0oooo0?ooo`0000008`3oool00`000000oooo0?oo
o`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool01@000000oooo0?oo
o`3oool0000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`090?ooo`050000
003oool0oooo0?ooo`0000000P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool08P3oool010000000oooo0?ooo`00000R0?ooo`030000003oool0oooo00<0oooo0`3oH@:?
0?ooo`030000003oool0oooo00l0oooo000^0?ooo`050000003oool0oooo0?ooo`3oo`00T`3oool0
0`000000oooo00000004000000030?ooo`000000000000<000001`3oool5000000<0oooo00<00000
0?ooo`3oool00`3oool010000000oooo0?ooo`3oool508X[hXl0oooo00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`060?ooo`H0of42R@3oool00`000000oooo0?ooo`0?0?ooo`00;P3oool2
00000080oooo00<0ool00?ooo`3oool0T03oool2000000050?ooo`000000oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3o
ool00P3oool2000000L0oooo1@2::n:90?ooo`8000008P3oool00`000000oooo0?ooo`0<0?ooo`D0
of42Q03oool00`000000oooo0?ooo`0?0?ooo`00;P3oool01@000000oooo0?ooo`3oool0ool009<0
oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003oool0000000T0oooo00<00000
0?ooo`0000000P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool02`3o
ool308X[hXL0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0A0?ooo`030?mQ0P3o
ool0oooo0800oooo0P00000A0?ooo`00;P3oool00`000000oooo0?ooo`020?ooo`030?oo003oool0
oooo0900oooo00@000000?ooo`3oool0oooo0P0000040?ooo`8000002P3oool200000080oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00h0oooo0P2::n:50?ooo`030000
003oool0oooo0200oooo00<000000?ooo`3oool04P3oool20?mQ0X40oooo00<000000?ooo`3oool0
3`3oool002h0oooo0P0000030?ooo`030?oo003oool0oooo08l0oooo0P0000040?ooo`030000003o
ool0oooo00<0oooo00<000000?ooo`3oool02@3oool010000000oooo0?ooo`3oool3000000@0oooo
00<000000?ooo`3oool0403oool00`2::n80oooo0?ooo`220?ooo`030000003oool0oooo0200oooo
00<000000?ooo`3oool0503oool00`3oH@80oooo0?ooo`1n0?ooo`030000003oool0oooo00l0oooo
000^0?ooo`030000003oool0oooo0080oooo00<0ool00?ooo`3oool0T03oool00`000000oooo0?oo
o`0O0?ooo`8000004P3oool00`2::n80oooo0?ooo`210?ooo`030000003oool0oooo0200oooo00<0
00000?ooo`3oool05@3oool00`3oH@80oooo0?ooo`1m0?ooo`030000003oool0oooo00l0oooo000^
0?ooo`030000003oool0oooo0080oooo00<0ool00?ooo`3oool0T03oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo0180oooo00<0RR_R0?ooo`3oool0P03oool00`000000oooo0?ooo`0P
0?ooo`030000003oool0oooo01H0oooo0P3oH@9l0?ooo`8000004@3oool002h0oooo00<000000?oo
o`3oool00P3oool00`3oo`00oooo0?ooo`2@0?ooo`030000003oool0oooo01l0oooo00<000000?oo
o`3oool04`3oool00`2::n80oooo0?ooo`1o0?ooo`030000003oool0oooo0200oooo00<000000?oo
o`3oool0603oool30?mQ0WX0oooo00<000000?ooo`3oool03`3oool002h0oooo0P0000040?ooo`03
0?oo003oool0oooo08h0oooo0P00000Q0?ooo`030000003oool0oooo01@0oooo00<0RR_R0?ooo`3o
ool0OP3oool00`000000oooo0?ooo`0500000080oooo0`0000040?ooo`030000003oool0oooo0080
oooo0`0000030?ooo`<00000103oool00`000000oooo0?ooo`0K0?ooo`80of42N03oool00`000000
oooo0?ooo`0?0?ooo`003`3oool3000000<0oooo0`0000040?ooo`030000003oool0oooo0080oooo
0`0000040?ooo`<000000`3oool00`000000oooo0?ooo`030?ooo`030?oo003oool0oooo08l0oooo
00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0E0?ooo`0308X[hP3oool0oooo07d0oooo
00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0000000<0oooo00<000000?ooo`3o
ool01@3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool01@000000oooo0?ooo`3o
ool0000001l0oooo00<0of420?ooo`3oool0M@3oool00`000000oooo0?ooo`0?0?ooo`00403oool0
1@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01@3oool01@000000oooo0?oo
o`3oool0000000@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030?oo
003oool0oooo08l0oooo00<000000?ooo`3oool07`3oool2000001L0oooo00<0RR_R0?ooo`3oool0
O03oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0000000<0oooo00D000000?ooo`3oool0oooo0000000O0?oo
o`030?mQ0P3oool0oooo07D0oooo00<000000?ooo`3oool03`3oool00100oooo00D000000?ooo`3o
ool0oooo000000030?ooo`030000003oool0oooo00D0oooo00H000000?ooo`3oool0oooo0000003o
ool5000000<0oooo0P0000040?ooo`030?oo003oool0oooo08h0oooo0P00000Q0?ooo`030000003o
ool0oooo01L0oooo0P2::n9l0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01000
000:0?ooo`8000000P3oool4000000@0oooo0P00000O0?ooo`030?mQ0P3oool0oooo07<0oooo0P00
000A0?ooo`00403oool00`000000oooo0?ooo`020?ooo`<00000203oool400000080oooo00@00000
0?ooo`3oool00000103oool00`000000oooo0?ooo`040?ooo`030?oo003oool0oooo08h0oooo00<0
00000?ooo`3oool07`3oool00`000000oooo0?ooo`0I0?ooo`0308X[hP3oool0oooo07T0oooo00@0
00000?ooo`3oool000000`3oool00`000000oooo0000000?0?ooo`030000003oool0000000L0oooo
00<000000?ooo`3oool07`3oool00`3oH@80oooo0?ooo`1c0?ooo`030000003oool0oooo00l0oooo
000@0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`000000103oool00`000000oooo0?ooo`040?ooo`030?oo
003oool0oooo08h0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0J0?ooo`0308X[
hP3oool0oooo07P0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`00000:0?oo
o`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo01l0oooo00<0of420?ooo`3oool0L`3oool00`000000oooo0?ooo`0?0?ooo`003`3oool20000
00<0oooo00D000000?ooo`3oool0oooo000000080?ooo`030000003oool0oooo00@0oooo0P000004
0?ooo`030000003oool0oooo00@0oooo00<0ool00?ooo`3oool0SP3oool00`000000oooo0?ooo`0O
0?ooo`800000703oool00`2::n80oooo0?ooo`1g0?ooo`040000003oool0oooo0?ooo`<00000103o
ool2000000T0oooo0`0000040?ooo`800000103oool00`000000oooo0?ooo`0P0?ooo`030?mQ0P3o
ool0oooo0780oooo00<000000?ooo`3oool03`3oool00100oooo00<000000?ooo`3oool00P3oool3
000000X0oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030?oo003oool0
oooo08d0oooo0P00000Q0?ooo`030000003oool0oooo01`0oooo00<0RR_R0?ooo`3oool0MP3oool0
0`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0240oooo00<0of420?ooo`3oool0L03oool2
00000140oooo000^0?ooo`030000003oool0oooo00@0oooo00<0ool00?ooo`3oool0SP3oool01000
0000oooo0?ooo`3oool3000000<0oooo0`0000030?ooo`030000003oool0oooo00<0oooo0`000003
0?ooo`<000000`3oool00`000000oooo0?ooo`0M0?ooo`0308X[hP3oool0oooo07D0oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`0R0?ooo`030?mQ0P3oool0oooo0700oooo00<00000
0?ooo`3oool03`3oool002h0oooo00<000000?ooo`3oool01@3oool00`3oo`00oooo0?ooo`2=0?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0N0?oo
o`0308X[hP3oool0oooo07@0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0R0?oo
o`030?mQ0P3oool0oooo0700oooo00<000000?ooo`3oool03`3oool002h0oooo0P0000060?ooo`03
0?oo003oool0oooo08`0oooo0P0000000`3oool0000000000003000000030?ooo`000000000000<0
00001`3oool5000000030?ooo`000000000000<000000`3oool2000001l0oooo00<0RR_R0?ooo`3o
ool0L`3oool200000280oooo00<000000?ooo`3oool08`3oool00`3oH@80oooo0?ooo`1_0?ooo`03
0000003oool0oooo00l0oooo000^0?ooo`030000003oool0oooo00D0oooo00<0ool00?ooo`3oool0
S@3oool00`000000oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3o
ool01P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<00000
0?ooo`3oool07P3oool00`2::n80oooo0?ooo`1d0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool0903oool20?mQ0Vl0oooo00<000000?ooo`3oool03`3oool002h0oooo00<000000?oo
o`3oool01@3oool00`3oo`00oooo0?ooo`2=0?ooo`060000003oool0oooo0000003oool000000`3o
ool00`000000oooo000000090?ooo`030000003oool0000000<0oooo00<000000?ooo`000000103o
ool00`000000oooo0?ooo`0O0?ooo`0308X[hP3oool0oooo07<0oooo00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`0V0?ooo`<0of42J`3oool200000140oooo000^0?ooo`030000003oool0
oooo00D0oooo00<0ool00?ooo`3oool0S@3oool010000000oooo0?ooo`3oool2000000@0oooo0P00
000:0?ooo`800000103oool2000000@0oooo00<000000?ooo`3oool07`3oool00`2::n80oooo0?oo
o`1c0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0:@3oool30?mQ0VT0oooo00<0
00000?ooo`3oool03`3oool002h0oooo0P0000070?ooo`030?oo003oool0oooo08/0oooo0P000004
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo0080oooo0P00000P0?ooo`0308X[hP3oool0oooo07<0oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`0/0?ooo`80of42I`3oool00`000000oooo0?ooo`0?
0?ooo`003`3oool3000000<0oooo0`0000040?ooo`030000003oool0oooo0080oooo0`0000030?oo
o`<00000103oool00`000000oooo0?ooo`060?ooo`030?oo003oool0oooo08`0oooo00<000000?oo
o`3oool07`3oool00`000000oooo0?ooo`0P0?ooo`0308X[hP3oool0oooo0780oooo00<000000?oo
o`3oool0803oool00`000000oooo0?ooo`0^0?ooo`80of42I@3oool00`000000oooo0?ooo`0?0?oo
o`00403oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01@3oool01`00
0000oooo0?ooo`3oool000000?ooo`0000000`3oool01@000000oooo0?ooo`3oool0000000P0oooo
00<0ool00?ooo`3oool0S03oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0200oooo
00<0RR_R0?ooo`3oool0LP3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0300oooo
00<0of420?ooo`3oool0H@3oool200000140oooo000@0?ooo`050000003oool0oooo0?ooo`000000
0`3oool00`000000oooo0?ooo`050?ooo`070000003oool0oooo0?ooo`000000oooo000000030?oo
o`050000003oool0oooo0?ooo`000000203oool00`3oo`00oooo0?ooo`2<0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool0803oool00`2::n80oooo0?ooo`1b0?ooo`030000003oool0
oooo0200oooo00<000000?ooo`3oool0<@3oool20?mQ0V80oooo00<000000?ooo`3oool03`3oool0
0100oooo00<000000?ooo`3oool00P3oool3000000P0oooo100000020?ooo`@00000103oool20000
00P0oooo00<0ool00?ooo`3oool0RP3oool200000240oooo00<000000?ooo`3oool08@3oool00`2:
:n80oooo0?ooo`1a0?ooo`030000003oool0oooo00D000000P3oool3000000@0oooo00<000000?oo
o`3oool00P3oool3000000<0oooo0`0000040?ooo`030000003oool0oooo03<0oooo0P3oH@9P0?oo
o`030000003oool0oooo00l0oooo000@0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`070?ooo`030?oo003oool0oooo08/0oooo00<000000?ooo`3oool07`3oool20000
0280oooo00<0RR_R0?ooo`3oool0L@3oool01@000000oooo0?ooo`3oool000000080oooo00<00000
0?ooo`0000000`3oool00`000000oooo0?ooo`050?ooo`070000003oool0oooo0?ooo`000000oooo
000000030?ooo`050000003oool0oooo0?ooo`000000=`3oool20?mQ0Uh0oooo00<000000?ooo`3o
ool03`3oool000l0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000203oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01`3oool00`3oo`00
oooo0?ooo`2;0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool08@3oool00`2::n80
oooo0?ooo`1a0?ooo`030000003oool0oooo0080oooo00D000000?ooo`3oool0oooo000000030?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`3oool2
000003P0oooo00<0of420?ooo`3oool0FP3oool200000140oooo000@0?ooo`030000003oool0oooo
0080oooo0`00000:0?ooo`800000103oool2000000@0oooo0P0000080?ooo`030?oo003oool0oooo
08X0oooo0P00000Q0?ooo`030000003oool0oooo0280oooo00<0RR_R0?ooo`3oool0L03oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo00@000002P3oool2000000<0oooo0`0000040?oo
o`030000003oool0oooo03P0oooo0P3oH@9K0?ooo`030000003oool0oooo00l0oooo000^0?ooo`03
0000003oool0oooo00L0oooo00<0ool00?ooo`3oool0R`3oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo0280oooo00<0RR_R0?ooo`3oool0L03oool010000000oooo0?ooo`0000030?oo
o`030000003oool0000000l0oooo00<000000?ooo`0000000`3oool01@000000oooo0?ooo`3oool0
000003`0oooo0P3oH@9I0?ooo`030000003oool0oooo00l0oooo000^0?ooo`030000003oool0oooo
00P0oooo00<0ool00?ooo`3oool0RP3oool00`000000oooo0?ooo`0O0?ooo`8000008`3oool00`2:
:n80oooo0?ooo`1`0?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool000002P3o
ool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool01@000000oooo0?ooo`3oool00000
03h0oooo0P3oH@9G0?ooo`030000003oool0oooo00l0oooo000^0?ooo`030000003oool0oooo00P0
oooo00<0ool00?ooo`3oool0RP3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo02<0
oooo00<0RR_R0?ooo`3oool0K`3oool010000000oooo0?ooo`3oool3000000@0oooo0P0000090?oo
o`<000000`3oool3000000@0oooo00<000000?ooo`3oool0?P3oool00`3oH@80oooo0?ooo`1D0?oo
o`030000003oool0oooo00l0oooo000^0?ooo`8000002@3oool00`3oo`00oooo0?ooo`290?ooo`80
00000`3oool3000000<0oooo0`0000030?ooo`030000003oool0oooo00<0oooo0`0000020?ooo`<0
0000103oool00`000000oooo0?ooo`0S0?ooo`0308X[hP3oool0oooo06l0oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`0o0?ooo`80of42D`3oool200000140oooo000^0?ooo`030000
003oool0oooo00T0oooo00<0ool00?ooo`3oool0R@3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool010000000oooo0?ooo`0000030?ooo`05
0000003oool0oooo0?ooo`0000009@3oool00`2::n80oooo0?ooo`1_0?ooo`030000003oool0oooo
0200oooo00<000000?ooo`3oool0@@3oool30?mQ0U40oooo00<000000?ooo`3oool03`3oool002h0
oooo00<000000?ooo`3oool02P3oool00`3oo`00oooo0?ooo`280?ooo`030000003oool0000000@0
000000<0oooo0000000000000`0000070?ooo`D0000000<0oooo0000003oool00P3oool010000000
oooo0?ooo`3oool2000002D0oooo00<0RR_R0?ooo`3oool0K@3oool200000280oooo00<000000?oo
o`3oool0A03oool40?mQ0Td0oooo00<000000?ooo`3oool03`3oool002h0oooo0P00000;0?ooo`03
0?oo003oool0oooo08L0oooo0P0000001@3oool000000?ooo`3oool000000080oooo00@000000?oo
o`3oool00000203oool010000000oooo0?ooo`0000020?ooo`@00000103oool00`000000oooo0?oo
o`0T0?ooo`0308X[hP3oool0oooo06h0oooo00<000000?ooo`3oool0803oool00`000000oooo0?oo
o`180?ooo`H0of42A`3oool00`000000oooo0?ooo`0?0?ooo`003`3oool3000000<0oooo0`000004
0?ooo`030000003oool0oooo0080oooo0`0000030?ooo`<00000103oool00`000000oooo0?ooo`0;
0?ooo`030?oo003oool0oooo08L0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000
003oool0000000T0oooo00<000000?ooo`0000000P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo02@0oooo00<0RR_R0?ooo`3oool0KP3oool00`000000oooo0?ooo`0P0?ooo`030000
003oool0oooo04h0oooo1@3oH@910?ooo`8000004@3oool00100oooo00D000000?ooo`3oool0oooo
000000030?ooo`030000003oool0oooo00D0oooo00L000000?ooo`3oool0oooo0000003oool00000
00<0oooo00D000000?ooo`3oool0oooo0000000>0?ooo`030?oo003oool0oooo08H0oooo00@00000
0?ooo`3oool0oooo0P0000040?ooo`8000002P3oool2000000<0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`0U0?ooo`0308X[hP3oool0oooo06d0oooo00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`1C0?ooo`<0of42?`3oool00`000000oooo0?ooo`0?0?ooo`00403oool0
1@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01@3oool01`000000oooo0?oo
o`3oool000000?ooo`0000000`3oool01@000000oooo0?ooo`3oool0000000h0oooo00<0ool00?oo
o`3oool0QP3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`020?ooo`800000103oool2000002H0oooo00<0RR_R0?oo
o`3oool0K@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo05H0oooo0P3oH@8m0?oo
o`030000003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo0080oooo0`0000080?ooo`@0
00000`3oool3000000@0oooo0P00000>0?ooo`030?oo003oool0oooo08@0oooo0P00000Q0?ooo`03
0000003oool0oooo02D0oooo00<0RR_R0?ooo`3oool0K@3oool00`000000oooo0?ooo`0P0?ooo`03
0000003oool0oooo05P0oooo00<0of420?ooo`3oool0>P3oool00`000000oooo0?ooo`0?0?ooo`00
403oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`030?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0=0?oo
o`030?oo003oool0oooo08D0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0V0?oo
o`0308X[hP3oool0oooo06`0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1I0?oo
o`030?mQ0P3oool0oooo03T0oooo00<000000?ooo`3oool03`3oool000l0oooo0P0000030?ooo`05
0000003oool0oooo0?ooo`000000203oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0>0?ooo`030?oo003oool0oooo08@0oooo00<00000
0?ooo`3oool07`3oool00`000000oooo0?ooo`0W0?ooo`0308X[hP3oool0oooo06/0oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`1J0?ooo`030?mQ0P3oool0oooo03L0oooo0P00000A
0?ooo`00403oool00`000000oooo0?ooo`020?ooo`<000002P3oool2000000<0oooo0`0000040?oo
o`800000403oool00`3oo`00oooo0?ooo`220?ooo`8000008@3oool00`000000oooo0?ooo`0W0?oo
o`0308X[hP3oool0oooo06/0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1K0?oo
o`030?mQ0P3oool0oooo03L0oooo00<000000?ooo`3oool03`3oool002h0oooo00<000000?ooo`3o
ool03`3oool00`3oo`00oooo0?ooo`230?ooo`030000003oool0oooo01l0oooo0P00000Y0?ooo`03
08X[hP3oool0oooo06X0oooo00<000000?ooo`3oool01P3oool500000080oooo0`0000040?ooo`03
0000003oool0oooo00<0oooo0`0000030?ooo`030000003oool0oooo05`0oooo00<0of420?ooo`3o
ool0=P3oool00`000000oooo0?ooo`0?0?ooo`00;P3oool00`000000oooo0?ooo`0@0?ooo`030?oo
003oool0oooo0880oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0Y0?ooo`0308X[
hP3oool0oooo06T0oooo00<000000?ooo`3oool01`3oool01P000000oooo0?ooo`000000oooo0000
00<0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
05d0oooo00<0of420?ooo`3oool0=@3oool00`000000oooo0?ooo`0?0?ooo`00;P3oool00`000000
oooo0?ooo`0A0?ooo`030?oo003oool0oooo0840oooo00<000000?ooo`3oool07`3oool00`000000
oooo0?ooo`0Z0?ooo`0308X[hP3oool0oooo06P0oooo00<000000?ooo`3oool0203oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01@3oool5000000<0oooo0P00001O0?oo
o`030?mQ0P3oool0oooo03<0oooo0P00000A0?ooo`00;P3oool200000180oooo00<0ool00?ooo`3o
ool0P03oool200000240oooo00<000000?ooo`3oool0:P3oool00`2::n80oooo0?ooo`1X0?ooo`03
0000003oool0oooo00T0oooo00<000000?ooo`3oool0100000080?ooo`040000003oool0oooo0000
00@0oooo00<000000?ooo`3oool0GP3oool00`3oH@80oooo0?ooo`0d0?ooo`030000003oool0oooo
00l0oooo000^0?ooo`030000003oool0oooo0180oooo00<0ool00?ooo`3oool0P03oool00`000000
oooo0?ooo`0O0?ooo`800000;03oool00`2::n80oooo0?ooo`1W0?ooo`030000003oool0oooo00H0
oooo00L000000?ooo`3oool0oooo0000003oool0000000`0oooo00<000000?ooo`000000103oool0
0`000000oooo0?ooo`1O0?ooo`030?mQ0P3oool0oooo03<0oooo00<000000?ooo`3oool03`3oool0
02h0oooo00<000000?ooo`3oool04`3oool00`3oo`00oooo0?ooo`1o0?ooo`030000003oool0oooo
01l0oooo00<000000?ooo`3oool0;03oool00`2::n80oooo0?ooo`1V0?ooo`030000003oool0oooo
00H0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00X0oooo0P000004
0?ooo`030000003oool0oooo05l0oooo00<0of420?ooo`3oool0<`3oool00`000000oooo0?ooo`0?
0?ooo`00;P3oool2000001@0oooo00<0ool00?ooo`3oool0OP3oool2000000<0oooo0`0000030?oo
o`<000000`3oool00`000000oooo0?ooo`030?ooo`<000000P3oool3000000@0oooo00<000000?oo
o`3oool0;03oool00`2::n80oooo0?ooo`1V0?ooo`030000003oool0oooo00L0oooo0`0000040?oo
o`8000002`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0600oooo00<0of420?oo
o`3oool0<@3oool200000140oooo000^0?ooo`030000003oool0oooo01@0oooo00<0ool00?ooo`3o
ool0OP3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool02@3oool010000000oooo0?ooo`0000030?ooo`050000003oool0oooo0?ooo`000000;`3oool0
0`2::n80oooo0?ooo`1U0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0H@3oool0
0`3oH@80oooo0?ooo`0a0?ooo`030000003oool0oooo00l0oooo000E0?ooo`<000000`3oool30000
00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo
01@0oooo00<0ool00?ooo`3oool0OP3oool00`000000oooo00000004000000030?ooo`0000000000
00<000001`3oool5000000030?ooo`000000oooo0080oooo00@000000?ooo`3oool0oooo0P00000_
0?ooo`0308X[hP3oool0oooo06<0oooo0P00000R0?ooo`030000003oool0oooo0640oooo00<0of42
0?ooo`3oool0<@3oool00`000000oooo0?ooo`0?0?ooo`005P3oool01@000000oooo0?ooo`3oool0
000000<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo01D0oooo00<0ool00?ooo`3oool0O@3oool00`000000oooo000000020?ooo`040000003oool0
oooo00000080oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`0000030?ooo`<00000
103oool00`000000oooo0?ooo`0_0?ooo`0308X[hP3oool0oooo06<0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`1R0?ooo`030?mQ0P3oool0oooo0300oooo00<000000?ooo`3oool0
3`3oool001H0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool00P3oool2000001L0oooo0P3oo`1l0?ooo`8000000P3oool00`000000oooo
000000030?ooo`030000003oool0000000T0oooo00<000000?ooo`0000000P3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0;`3oool00`2::n80oooo0?ooo`1S0?ooo`03
0000003oool0oooo0200oooo00<000000?ooo`3oool0HP3oool00`3oH@80oooo0?ooo`0`0?ooo`03
0000003oool0oooo00l0oooo000F0?ooo`030000003oool0oooo0080oooo0`00000;0?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0603oool00`3oo`00oooo0?ooo`1j0?ooo`040000
003oool0oooo0?ooo`800000103oool2000000X0oooo0P0000020?ooo`050000003oool0oooo0?oo
o`0000000`3oool00`000000oooo0?ooo`0`0?ooo`0308X[hP3oool0oooo0680oooo00<000000?oo
o`3oool0803oool00`000000oooo0?ooo`1S0?ooo`030?mQ0P3oool0oooo02h0oooo0P00000A0?oo
o`005P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool02@3oool01@00
0000oooo0?ooo`3oool0000001/0oooo00<0ool00?ooo`3oool0N@3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool010000000oooo0?ooo`3o
ool3000000@0oooo0P00000b0?ooo`0308X[hP3oool0oooo0640oooo00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`1S0?ooo`030?mQ0P3oool0oooo02l0oooo00<000000?ooo`3oool03`3o
ool001D0oooo0P0000030?ooo`050000003oool0oooo0?ooo`0000001`3oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool06P3oool00`3oo`00oooo0?ooo`1h0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool0<@3oool00`2::n80oooo0?ooo`1Q0?ooo`030000
003oool0oooo0200oooo00<000000?ooo`3oool0I03oool00`3oH@80oooo0?ooo`0^0?ooo`030000
003oool0oooo00l0oooo000F0?ooo`030000003oool0oooo0080oooo0`0000080?ooo`D000000`3o
ool2000001`0oooo00<0ool00?ooo`3oool0MP3oool200000240oooo00<000000?ooo`3oool0<P3o
ool00`2::n80oooo0?ooo`1P0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0I@3o
ool00`3oH@80oooo0?ooo`0]0?ooo`030000003oool0oooo00l0oooo000^0?ooo`030000003oool0
oooo01`0oooo00<0ool00?ooo`3oool0MP3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0
oooo03<0oooo00<0RR_R0?ooo`3oool0G`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo06D0oooo00<0of420?ooo`3oool0;03oool200000140oooo000^0?ooo`030000003oool0oooo
01d0oooo00<0ool00?ooo`3oool0M@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo
03@0oooo00<0RR_R0?ooo`3oool0GP3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo
06H0oooo00<0of420?ooo`3oool0;03oool00`000000oooo0?ooo`0?0?ooo`00;P3oool2000001l0
oooo00<0ool00?ooo`3oool0L`3oool200000240oooo0P00000e0?ooo`0308X[hP3oool0oooo05h0
oooo00<000000?ooo`3oool01@0000020?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`<0
000000<0oooo0000000000000`0000030?ooo`030000003oool0oooo06H0oooo00<0of420?ooo`3o
ool0;03oool00`000000oooo0?ooo`0?0?ooo`00;P3oool00`000000oooo0?ooo`0N0?ooo`030?oo
003oool0oooo07@0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0e0?ooo`0308X[
hP3oool0oooo05d0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0000000<0
oooo00<000000?ooo`3oool0203oool01@000000oooo0?ooo`3oool000000080oooo00D000000?oo
o`3oool0oooo0000001Y0?ooo`030?mQ0P3oool0oooo02/0oooo00<000000?ooo`3oool03`3oool0
02h0oooo00<000000?ooo`3oool07P3oool00`3oo`00oooo0?ooo`1d0?ooo`030000003oool0oooo
01l0oooo00<000000?ooo`3oool0=@3oool00`2::n80oooo0?ooo`1M0?ooo`030000003oool0oooo
0080oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00D0oooo1@000003
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0I`3oool00`3oH@80oooo0?ooo`0[
0?ooo`030000003oool0oooo00l0oooo000^0?ooo`030000003oool0oooo01l0oooo00<0ool00?oo
o`3oool0L`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo03H0oooo00<0RR_R0?oo
o`3oool0G03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@00000203oool01000
0000oooo0?ooo`0000050?ooo`030000003oool0oooo0080oooo0P00001X0?ooo`030?mQ0P3oool0
oooo02X0oooo0P00000A0?ooo`00;P3oool200000200oooo00<0ool00?ooo`3oool0LP3oool20000
0240oooo0P00000g0?ooo`0308X[hP3oool0oooo05`0oooo00@000000?ooo`3oool000000`3oool0
0`000000oooo0000000<0?ooo`030000003oool000000080oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo06P0oooo00<0of420?ooo`3oool0:P3oool00`000000oooo0?oo
o`0?0?ooo`003`3oool3000000<0oooo0`0000040?ooo`030000003oool0oooo00<0oooo00@00000
0?ooo`3oool0oooo1@0000030?ooo`030000003oool0oooo01l0oooo00<0ool00?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo03L0oooo00<0RR_R0?ooo`3oool0F`3o
ool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo000000`0oooo0P0000020?ooo`05
0000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`1X0?ooo`030?mQ0P3oool0oooo
02X0oooo00<000000?ooo`3oool03`3oool00100oooo00D000000?ooo`3oool0oooo000000030?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`000003
0?ooo`030000003oool0oooo0200oooo00<0ool00?ooo`3oool0LP3oool00`000000oooo0?ooo`07
0?ooo`<000000`3oool3000000<0oooo00<000000?ooo`3oool00P3oool3000000@0oooo00<00000
0?ooo`3oool0=`3oool00`2::n80oooo0?ooo`1K0?ooo`040000003oool0oooo0?ooo`<00000103o
ool2000000/0oooo00@000000?ooo`3oool0oooo0`0000040?ooo`030000003oool0oooo06T0oooo
00<0of420?ooo`3oool0:@3oool00`000000oooo0?ooo`0?0?ooo`00403oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00<0oooo0P00000Q0?ooo`030?oo003oool0oooo0740oooo0P00000:0?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3oool0000000<0
oooo00<000000?ooo`3oool0>03oool00`2::n80oooo0?ooo`1J0?ooo`030000003oool0oooo0200
oooo00<000000?ooo`3oool0J@3oool00`3oH@80oooo0?ooo`0X0?ooo`8000004@3oool00100oooo
00<000000?ooo`3oool00P3oool3000000/0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo0200oooo00<0ool00?ooo`3oool0LP3oool00`000000oooo
0?ooo`050?ooo`D0000000<0oooo0000000000000`00000;0?ooo`040000003oool0oooo0?ooo`80
0000>@3oool00`2::n80oooo0?ooo`1I0?ooo`8000008P3oool00`000000oooo0?ooo`1Y0?ooo`03
0?mQ0P3oool0oooo02T0oooo00<000000?ooo`3oool03`3oool00100oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo00T0oooo00<000000?ooo`0000000`3oool01@000000
oooo0?ooo`3oool0000002<0oooo00<0ool00?ooo`3oool0C@3oool80?oo01`0oooo00<000000?oo
o`3oool01@3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000`0oooo00D0
00000?ooo`3oool0oooo0000000k0?ooo`0308X[hP3oool0oooo05T0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`1Z0?ooo`030?mQ0P3oool0oooo02P0oooo00<000000?ooo`3oool0
3`3oool000l0oooo0P0000030?ooo`050000003oool0oooo0?ooo`0000001`3oool01`000000oooo
0?ooo`3oool000000?ooo`0000000`3oool01@000000oooo0?ooo`3oool0000002<0oooo00<0ool0
0?ooo`3oool0A`3oool60?oo00P0oooo6@3oo`030?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`0000000`3oool00`000000oooo000000080?ooo`@00000103oool00`000000oooo0?ooo`0i
0?ooo`0308X[hP3oool0oooo05T0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1Z
0?ooo`030?mQ0P3oool0oooo02P0oooo00<000000?ooo`3oool03`3oool00100oooo00<000000?oo
o`3oool00P3oool3000000P0oooo1@0000020?ooo`<00000103oool200000280oooo00<0ool00?oo
o`3oool0A03oool30?oo02T0oooo0P0000090?ooo`800000103oool2000000P0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0j0?ooo`0308X[hP3oool0oooo05P0oooo00<000000?oo
o`3oool0803oool00`000000oooo0?ooo`1Z0?ooo`030?mQ0P3oool0oooo02P0oooo00<000000?oo
o`3oool03`3oool002h0oooo00<000000?ooo`3oool08P3oool00`3oo`00oooo0?ooo`0o0?ooo`@0
ool0;@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool01P3oool5000000<0oooo0P00000k0?ooo`0308X[hP3oool0oooo05P0oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`1[0?ooo`030?mQ0P3oool0oooo02H0oooo0P00000A0?ooo`00
;P3oool00`000000oooo0?ooo`0R0?ooo`030?oo003oool0oooo03`0oooo0`3oo`0a0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool0>`3oool00`2::n80oooo0?ooo`1G0?ooo`030000
003oool0oooo0200oooo00<000000?ooo`3oool0J`3oool00`3oH@80oooo0?ooo`0W0?ooo`030000
003oool0oooo00l0oooo000^0?ooo`8000008`3oool00`3oo`00oooo0?ooo`0h0?ooo`@0ool0<`3o
ool200000240oooo00<000000?ooo`3oool0>`3oool00`2::n80oooo0?ooo`1G0?ooo`030000003o
ool0oooo0200oooo00<000000?ooo`3oool0K03oool00`3oH@80oooo0?ooo`0V0?ooo`030000003o
ool0oooo00l0oooo000^0?ooo`030000003oool0oooo02<0oooo00<0ool00?ooo`3oool0<`3oool4
0?oo03P0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0l0?ooo`0308X[hP3oool0
oooo05H0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1/0?ooo`030?mQ0P3oool0
oooo02H0oooo00<000000?ooo`3oool03`3oool002h0oooo00<000000?ooo`3oool08`3oool00`3o
o`00oooo0?ooo`0^0?ooo`D0ool0?03oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo
03`0oooo00<0RR_R0?ooo`3oool0EP3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo
06`0oooo00<0of420?ooo`3oool09@3oool200000140oooo000^0?ooo`030000003oool0oooo02<0
oooo00<0ool00?ooo`3oool09`3oool70?oo0440oooo00<000000?ooo`3oool07`3oool2000003h0
oooo00<0RR_R0?ooo`3oool0E@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo06d0
oooo00<0of420?ooo`3oool09@3oool00`000000oooo0?ooo`0?0?ooo`00;P3oool2000002D0oooo
00<0ool00?ooo`3oool08@3oool50?oo04L0oooo0P00000Q0?ooo`030000003oool0oooo03h0oooo
00<0RR_R0?ooo`3oool0E03oool00`000000oooo0?ooo`0500000080oooo0`0000040?ooo`030000
003oool0oooo00<0oooo0`0000030?ooo`<000000`3oool00`000000oooo0?ooo`1]0?ooo`030?mQ
0P3oool0oooo02D0oooo00<000000?ooo`3oool03`3oool000l0oooo0`0000030?ooo`<00000103o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo0`0000030?ooo`030000003o
ool0oooo02@0oooo00<0ool00?ooo`3oool07P3oool30?oo04d0oooo00<000000?ooo`3oool07`3o
ool00`000000oooo0?ooo`0n0?ooo`0308X[hP3oool0oooo05@0oooo00D000000?ooo`3oool0oooo
000000020?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0KP3oool00`3oH@80oooo
0?ooo`0T0?ooo`030000003oool0oooo00l0oooo000@0?ooo`050000003oool0oooo0?ooo`000000
0`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`0T0?ooo`030?oo003oool0oooo01`0oooo0P3oo`1@0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool0?`3oool00`2::n80oooo0?ooo`1C0?ooo`030000
003oool0oooo0080oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00D0
oooo1@0000000`3oool0000000000003000000<0oooo0P00001`0?ooo`030?mQ0P3oool0oooo0280
oooo0P00000A0?ooo`00403oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`05000000<0oooo00<000000?ooo`3oool09@3oool00`3oo`00
oooo0?ooo`0I0?ooo`80ool0DP3oool00`000000oooo0?ooo`0O0?ooo`800000@03oool00`2::n80
oooo0?ooo`0X0?ooo`H0RR_R9@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0
0000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<00000
0?ooo`3oool0K`3oool00`3oH@80oooo0?ooo`0S0?ooo`030000003oool0oooo00l0oooo000@0?oo
o`030000003oool0oooo0080oooo0`00000;0?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool00P3oool2000002H0oooo0P3oo`0I0?ooo`030?oo003oool0oooo0540oooo0P00000Q
0?ooo`030000003oool0oooo0400oooo00<0RR_R0?ooo`3oool08@3oool608X[hPH0oooo102::n8Q
0?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`000000303oool00`000000oooo0000
00030?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool0L03oool00`3oH@80oooo0?oo
o`0R0?ooo`030000003oool0oooo00l0oooo000@0?ooo`050000003oool0oooo0?ooo`0000000`3o
ool00`000000oooo0?ooo`090?ooo`060000003oool0oooo0000003oool00000103oool00`000000
oooo0?ooo`0W0?ooo`030?oo003oool0oooo01@0oooo0P3oo`1E0?ooo`040000003oool0oooo0?oo
o`<000000`3oool3000000<0oooo00<000000?ooo`3oool00P3oool300000080oooo1@0000030?oo
o`030000003oool0oooo0440oooo00<0RR_R0?ooo`3oool07@3oool308X[hQ00oooo1P2::n8K0?oo
o`040000003oool0oooo000000<0oooo00@000000?ooo`3oool00000303oool2000000@0oooo0P00
00040?ooo`030000003oool0oooo0740oooo00<0of420?ooo`3oool08@3oool00`000000oooo0?oo
o`0?0?ooo`003`3oool2000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`050000003o
ool0oooo0?ooo`0000000`3oool2000000@0oooo00<000000?ooo`3oool0:03oool20?oo01<0oooo
00<0ool00?ooo`3oool0E@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3o
ool000000`3oool00`000000oooo0?ooo`110?ooo`0308X[hP3oool0oooo01T0oooo102::n8I0?oo
oaT0RR_R0P3oool010000000oooo0?ooo`3oool3000000@0oooo0P00000;0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1b0?ooo`030?mQ0P3oool0
oooo0200oooo00<000000?ooo`3oool03`3oool00100oooo00<000000?ooo`3oool00P3oool30000
00P0oooo1@0000040?ooo`030000003oool0oooo0080oooo0P00000[0?ooo`030?oo003oool0oooo
00l0oooo00<0ool00?ooo`3oool0E@3oool2000000030?ooo`000000000000<0000000<0oooo0000
000000000`00000;0?ooo`050000003oool0oooo0?ooo`0000001@3oool2000004<0oooo0P2::n8F
0?ooo`<0RR_R=`3oool200000280oooo00<000000?ooo`3oool0LP3oool00`3oH@80oooo0?ooo`0O
0?ooo`8000004@3oool002h0oooo00<000000?ooo`3oool0:`3oool00`3oo`00oooo0?ooo`0;0?oo
o`<0ool0F@3oool00`000000oooo000000020?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool02P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0A03oool308X[hPl0oooo102::n8k0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool0L`3oool00`3oH@80oooo0?ooo`090?oooa<0of420`3oool00`000000oooo0?ooo`0?
0?ooo`00;P3oool00`000000oooo0?ooo`0/0?ooo`D0ool0103oool40?oo05`0oooo00H000000?oo
o`3oool000000?ooo`0000030?ooo`030000003oool0000000P0oooo100000020?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`170?ooo`80RR_R2P3oool308X[hSl0oooo
00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1d0?ooo`/0of425P3oool00`000000oooo
0?ooo`0?0?ooo`00;P3oool00`000000oooo0?ooo`0a0?ooo`@0ool0H03oool010000000oooo0?oo
o`3oool2000000@0oooo0P0000080?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo04T0oooo2P2::n920?ooo`030000003oool0oooo0200
oooo00@000000?ooo`3oool000008`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool08@3oool01@000000oooo0?ooo`3oool000000140oooo000^0?oo
o`800000U@3oool2000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`060?oo
o`D000000P3oool3000000@0oooo0P00002F0?ooo`030000003oool0oooo0200ooooV@00000A0?oo
o`00;P3oool01@000000oooo0?ooo`3oool0000000H0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool01@00
0000oooo0?ooo`3oool000000240oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00D0oooo00@000000?ooo`3oool00000c03oool002h0ooooV@00000Q0?oooiT00000c03o
ool00?l0ooooo`3ooom?0?ooo`00o`3ooooo0?ooodl0oooo003o0?ooool0ooooC`3oool00?l0oooo
o`3ooom?0?ooo`00o`3ooooo0?ooodl0oooo003o0?ooool0ooooC`3oool00?l0ooooo`3ooom?0?oo
o`00o`3ooooo0?ooodl0oooo003o0?ooool0ooooC`3oool00?l0ooooYP3oool200000240oooo0`00
000O0?ooo`<00000103oool2000001/0oooo0`0000030?ooo`<000006P3oool5000000<0oooo0P00
000B0?ooo`00o`3ooonU0?ooo`040000003oool0oooo000001l0oooo00D000000?ooo`3oool0oooo
0000000O0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000006`3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0603oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000140oooo003o0?ooojD0oooo00@000000?ooo`3oool000008`3o
ool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000
6`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0
0P3oool010000000oooo0?ooo`00000A0?ooo`00?03oool2000001h0oooo0`00000L0?ooo`<00000
103oool2000001P0oooo0`0000030?ooo`<000005`3oool5000000<0oooo0P00000[0?ooo`800000
7`3oool3000001d0oooo0`0000040?ooo`8000006P3oool3000000<0oooo0`00000I0?ooo`D00000
0`3oool2000002<0oooo00@000000?ooo`3oool000008`3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000006`3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo01X0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0
oooo00l0oooo000k0?ooo`040000003oool0oooo000001`0oooo00D000000?ooo`3oool0oooo0000
000L0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000603oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool05@3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo000002T0oooo00@000000?ooo`3oool000007@3oool01@000000oooo0?oo
o`3oool0000001d0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00000J0?ooo`05
0000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0G0?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000008P3oool010000000oooo0?ooo`00000O0?ooo`@00000
803oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000001/0oooo00@000000?ooo`3o
ool0oooo1000000J0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`00
000A0?ooo`00>`3oool010000000oooo0?ooo`00000P0?ooo`030000003oool0oooo01X0oooo00<0
00000?ooo`3oool00P3oool010000000oooo0?ooo`00000H0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000002T0
oooo00@000000?ooo`3oool000008@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
0080oooo00@000000?ooo`3oool000006P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo01P0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00000R0?ooo`040000003o
ool0oooo000001l0oooo00<000000?ooo`3oool0803oool2000000@0oooo00@000000?ooo`3oool0
00006P3oool2000000<0oooo00<000000?ooo`3oool06`3oool01@000000oooo0?ooo`3oool00000
0080oooo00@000000?ooo`3oool000004@3oool003/0oooo00@000000?ooo`3oool00000803oool0
0`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000603o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01L0oooo00D000000?ooo`3oool0oooo
000000020?ooo`030000003oool0oooo02L0oooo00@000000?ooo`3oool000008@3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000006P3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo01T0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`030000003oool0oooo0240oooo0P00000P0?ooo`D000007`3oool00`000000oooo0?ooo`03
0?ooo`800000703oool010000000oooo0?ooo`3oool5000001X0oooo0`0000040?ooo`8000004P3o
ool003/0oooo00@000000?ooo`3oool00000703oool4000001d0oooo00<000000?ooo`3oool00P3o
ool010000000oooo0?ooo`00000H0?ooo`040000003oool0oooo0?ooo`@000005`3oool01@000000
oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000:@3oool010000000oooo0?ooo`00
000M0?ooo`@000007P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000001X0oooo
00@000000?ooo`3oool0oooo1000000I0?ooo`050000003oool0oooo0?ooo`0000000P3oool01000
0000oooo0?ooo`00003;0?ooo`00>`3oool010000000oooo0?ooo`00000L0?ooo`030000003oool0
oooo01d0oooo0P0000040?ooo`040000003oool0oooo000001L0oooo0P0000030?ooo`030000003o
ool0oooo01P0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo000002T0
oooo00@000000?ooo`3oool000007@3oool00`000000oooo0?ooo`0N0?ooo`800000103oool01000
0000oooo0?ooo`00000I0?ooo`8000000`3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0
oooo0?ooo`0000000P3oool010000000oooo0?ooo`00003;0?ooo`00?03oool2000001d0oooo1@00
000L0?ooo`030000003oool0oooo00<0oooo0P00000I0?ooo`040000003oool0oooo0?ooo`D00000
5`3oool3000000@0oooo0P00000[0?ooo`8000007P3oool5000001d0oooo00<000000?ooo`3oool0
0`3oool2000001/0oooo00@000000?ooo`3oool0oooo1@00000I0?ooo`<00000103oool200000<`0
oooo003o0?oooj@0ooooV@00000A0?ooo`005@3oool3000000@0oooo00<000000?ooo`3oool00P3o
ool3000000@0oooo00<000000?ooo`3oool00P3oool3000000<0oooo0`00003o0?ooofh0oooo00@0
00000?ooo`3oool000008`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool01@000000oooo0?ooo`3oool000000140oooo000D0?ooo`050000
003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooohd000009`3ooonC00000280
oooo00@000000?ooo`3oool0o`00U03oool00`000000oooo0?ooo`0?0?ooo`003P3oool5000000D0
oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`80000000<0oooo0000003o
ool01@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo008000009`3oool01@000000
oooo0?ooo`3oool0000000H0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`00000R
0?ooo`040000003oool0oooo0?l009@0oooo00<000000?ooo`3oool03`3oool001P0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo0000ohP0oooo00<0
00000?ooo`3oool09@3oool00`000000oooo0?ooo`2?0?ooo`030000003oool0oooo0200oooo00@0
00000?ooo`3oool0o`00T`3oool200000140oooo000D0?ooo`@000001P3oool01@000000oooo0?oo
o`3oool0000000/0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`040000
003oool0oooo0000ohP0oooo00<000000?ooo`3oool09@3oool200000080oooo00<00?ZJ0?ooo`3o
ool0R`3oool00`000000oooo0?ooo`0P0?ooo`040000003oool0oooo0?l009@0oooo00<000000?oo
o`3oool03`3oool001@0oooo00<000000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool00000
0080oooo0P00000:0?ooo`800000103oool2000000D0oooo00@000000?ooo`3oool0003oQ`3oool2
000002L0oooo00D000000?ooo`3oool0oooo003jVP2=0?ooo`030000003oool0oooo0200oooo00@0
00000?ooo`3oool0o`00U03oool00`000000oooo0?ooo`0?0?ooo`00503oool5000000030?ooo`00
0000000000<000000`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool00`3oool010000000oooo0?ooo`000?n80?ooo`030000003oool0oooo02D0oooo
00D000000?ooo`3oool0oooo003jVP2=0?ooo`030000003oool0oooo0200oooo00D000000?ooo`3o
ool0oooo0?l0002C0?ooo`030000003oool0oooo00l0oooo000j0?ooo`040000003oool0oooo0000
ohP0oooo00<000000?ooo`3oool09@3oool200000080oooo00<00?ZJ0?ooo`3oool0R`3oool00`00
0000oooo0?ooo`0P0?ooo`050000003oool0oooo0?ooo`3o0000TP3oool200000140oooo000j0?oo
o`040000003oool0oooo0000ohL0oooo0P00000W0?ooo`050000003oool0oooo0?ooo`00nYX0S@3o
ool00`000000oooo0?ooo`070?ooo`<00000103oool00`000000oooo0?ooo`020?ooo`<000000`3o
ool3000000@0oooo00D000000?ooo`3oool0oooo0?l0002C0?ooo`030000003oool0oooo00l0oooo
000j0?ooo`050000003oool0oooo0?ooo`000?l0Q`3oool00`000000oooo0?ooo`0U0?ooo`050000
003oool0oooo0?ooo`00nYX0S@3oool00`000000oooo0?ooo`060?ooo`050000003oool0oooo0?oo
o`0000001`3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool01@000000oooo0?oo
o`3oool0000000<0oooo00<0o`000?ooo`3oool0T@3oool00`000000oooo0?ooo`0?0?ooo`00>P3o
ool01@000000oooo0?ooo`3oool0003o08L0oooo00<000000?ooo`3oool09@3oool200000080oooo
00<00?ZJ0?ooo`3oool0R`3oool00`000000oooo0?ooo`05000000D0oooo00<000000?ooo`3oool0
1@3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool010000000oooo0?ooo`3oool2
00000080oooo00<0o`000?ooo`3oool0T03oool200000140oooo000j0?ooo`050000003oool0oooo
0?ooo`000?l0QP3oool2000002L0oooo00<000000?ooo`3oool00P3oool00`00nYX0oooo0?ooo`2:
0?ooo`030000003oool0oooo00P0oooo0P0000090?ooo`<000000P3oool4000000@0oooo00D00000
0?ooo`3oool0oooo0?l0002C0?ooo`030000003oool0oooo00l0oooo000j0?ooo`050000003oool0
oooo0?ooo`000?l0Q`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo0080oooo00<0
0?ZJ0?ooo`3oool0RP3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00D0oooo00L0
00000?ooo`3oool0oooo0000003oool0000000L0oooo00D000000?ooo`3oool0oooo0?l0002C0?oo
o`030000003oool0oooo00l0oooo000j0?ooo`050000003oool0oooo0?ooo`000?l0Q`3oool00`00
0000oooo0?ooo`070?ooo`<000000`3oool00`000000oooo0?ooo`030?ooo`800000103oool00`00
0000oooo0?ooo`020?ooo`<00000103oool2000000<0oooo00<00?ZJ0?ooo`3oool0RP3oool00`00
0000oooo0?ooo`060?ooo`050000003oool0oooo0?ooo`0000001`3oool01@000000oooo0?ooo`3o
ool000000080oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool0o`0009<0oooo
00<000000?ooo`3oool03`3oool001/0oooo0`0000040?ooo`030000003oool0oooo0080oooo0`00
00040?ooo`030000003oool0oooo0080oooo0`0000040?ooo`050000003oool0oooo0?ooo`000?l0
QP3oool2000000X0oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`05
0000003oool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3oool0000000@0oooo00<00?ZJ
0?ooo`3oool0RP3oool00`000000oooo0?ooo`070?ooo`<000002@3oool3000000@0oooo0P000004
0?ooo`050000003oool0oooo0?ooo`3o0000TP3oool200000140oooo000J0?ooo`050000003oool0
oooo0?ooo`0000000`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool0003o08L0oooo00<000000?ooo`000000
100000000`3oool0000000000003000000P0oooo00@000000?ooo`3oool00000103oool00`000000
oooo0?ooo`040?ooo`040000003oool0oooo0?ooo`8000000`3oool00`00nYX0oooo0?ooo`290?oo
o`8000008P3oool00`000000oooo0?ooo`020?ooo`030?l0003oool0oooo0900oooo00<000000?oo
o`3oool03`3oool001@0oooo1@0000050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3o
ool0oooo0000o`270?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool000002@3oool0
10000000oooo0?ooo`0000040?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo
000000040?ooo`03003jVP3oool0oooo08X0oooo00<000000?ooo`3oool0803oool00`000000oooo
0?ooo`020?ooo`030?l0003oool0oooo0900oooo00<000000?ooo`3oool03`3oool001h0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool00`3oool200000080oooo00<0003o0?ooo`3oool0Q03oool2000000P0oooo00<0
00000?ooo`0000002@3oool010000000oooo0?ooo`0000050?ooo`030000003oool0000000<00000
103oool00`000000oooo0?ooo`020?ooo`03003jVP3oool0oooo08X0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`020?ooo`030?l0003oool0oooo0900oooo00<000000?ooo`3oool0
3`3oool001X0oooo100000060?ooo`050000003oool0oooo0?ooo`0000002`3oool00`000000oooo
0?ooo`030?ooo`050000003oool0oooo0?ooo`000?l0Q`3oool00`000000oooo0?ooo`070?ooo`80
00002@3oool01P000000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`0000001`3oool2
000000<0oooo00<00?ZJ0?ooo`3oool0RP3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo0080oooo00<0o`000?ooo`3oool0S`3oool200000140oooo000J0?ooo`030000003oool0oooo
00<0oooo00D000000?ooo`3oool0oooo000000020?ooo`8000002P3oool2000000D0oooo00<00000
0?ooo`3oool00P3oool00`000?l0oooo0?ooo`240?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool0203oool200000080oooo1@0000000`3oool0000000000003000000<0oooo00<00000
0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`2:0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool00P3oool00`3o0000oooo0?ooo`2@0?ooo`030000003oool0oooo00l0oooo000J0?oo
o`D0000000<0oooo0000000000000`0000030?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000o`3oool0oooo08<0oooo0P00000W0?oo
o`030000003oool0oooo0080oooo00<00?ZJ0?ooo`3oool0RP3oool00`000000oooo0?ooo`0P0?oo
o`030000003oool0oooo0080oooo00<0o`000?ooo`3oool0T03oool00`000000oooo0?ooo`0?0?oo
o`00>P3oool00`000000oooo0?ooo`020?ooo`030000o`3oool0oooo08@0oooo00<000000?ooo`3o
ool09@3oool2000000<0oooo00<00?ZJ0?ooo`3oool0RP3oool00`000000oooo0?ooo`0P0?ooo`03
0000003oool0oooo0080oooo00<0o`000?ooo`3oool0T03oool00`000000oooo0?ooo`0?0?ooo`00
>P3oool00`000000oooo0?ooo`020?ooo`030000o`3oool0oooo08@0oooo00<000000?ooo`3oool0
9@3oool00`000000oooo0?ooo`020?ooo`03003jVP3oool0oooo08X0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`020?ooo`030?l0003oool0oooo08l0oooo0P00000A0?ooo`00>P3o
ool00`000000oooo0?ooo`020?ooo`030000o`3oool0oooo08<0oooo0P00000W0?ooo`030000003o
ool0oooo00<0oooo00<00?ZJ0?ooo`3oool0R@3oool00`000000oooo0?ooo`0P0?ooo`030000003o
ool0oooo0080oooo00<0o`000?ooo`3oool0T03oool00`000000oooo0?ooo`0?0?ooo`00>P3oool0
0`000000oooo0?ooo`020?ooo`030000o`3oool0oooo08@0oooo00<000000?ooo`3oool09@3oool2
000000@0oooo00<00?ZJ0?ooo`3oool0R@3oool00`000000oooo0?ooo`070?ooo`<00000103oool0
0`000000oooo0?ooo`020?ooo`<00000103oool3000000<0oooo00<000000?ooo`3oool00`3oool0
0`3o0000oooo0?ooo`2?0?ooo`030000003oool0oooo00l0oooo000j0?ooo`030000003oool0oooo
0080oooo00<0003o0?ooo`3oool0Q03oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo
00<0oooo00<00?ZJ0?ooo`3oool0R@3oool00`000000oooo0?ooo`060?ooo`050000003oool0oooo
0?ooo`0000001`3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`030?ooo`030?l0003oool0oooo08l0oooo00<000000?ooo`3oool03`3o
ool003X0oooo00<000000?ooo`3oool00P3oool00`000?l0oooo0?ooo`230?ooo`8000009`3oool0
0`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo08T0oooo00<000000?ooo`3oool01@000005
0?ooo`030000003oool0oooo00D0oooo00H000000?ooo`3oool0oooo0000003oool5000000<0oooo
0P0000040?ooo`030?l0003oool0oooo08h0oooo0P00000A0?ooo`00>P3oool00`000000oooo0?oo
o`020?ooo`030000o`3oool0oooo08@0oooo00<000000?ooo`3oool03@3oool3000000<0oooo00<0
00000?ooo`3oool00`3oool2000000<0oooo0`0000040?ooo`800000103oool00`00nYX0oooo0?oo
o`290?ooo`030000003oool0oooo00P0oooo0P0000090?ooo`<000000P3oool010000000oooo0?oo
o`0000040?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool0S`3oool00`000000oooo
0?ooo`0?0?ooo`00>P3oool00`000000oooo0?ooo`030?ooo`030000o`3oool0oooo08<0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`070?ooo`060000003oool0oooo0000003oool0
00000`3oool01@000000oooo0?ooo`3oool0000000D0oooo00<00?ZJ0?ooo`3oool0R@3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool00`3oool00`3o0000oooo0?ooo`2?
0?ooo`030000003oool0oooo00l0oooo000E0?ooo`<00000103oool00`000000oooo0?ooo`020?oo
o`<00000103oool00`000000oooo0?ooo`030?ooo`8000000`3oool2000000D0oooo00<000000?oo
o`3oool00`3oool00`000?l0oooo0?ooo`220?ooo`8000001`3oool5000000030?ooo`0000000000
00<00000203oool010000000oooo0?ooo`0000050?ooo`050000003oool0oooo0?ooo`0000001@3o
ool00`00nYX0oooo0?ooo`290?ooo`030000003oool0oooo00H0oooo00D000000?ooo`3oool0oooo
000000070?ooo`050000003oool0oooo0?ooo`0000000`3oool2000000@0oooo00<000000?ooo`3o
ool00`3oool00`3o0000oooo0?ooo`2?0?ooo`030000003oool0oooo00l0oooo000D0?ooo`050000
003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00P0
oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00<0oooo00<0003o0?ooo`3oool0P`3oool00`000000oooo0?ooo`0;0?ooo`040000003oool0oooo
000000T0oooo00@000000?ooo`3oool000001@3oool010000000oooo0?ooo`3oool2000000@0oooo
00<00?ZJ0?ooo`3oool0R03oool2000000T0oooo0`0000090?ooo`<000001@3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool0SP3oool200000140oooo
000>0?ooo`D000001@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0203oool010000000oooo0?ooo`0000050?ooo`050000003oool0oooo0?ooo`00
00001@3oool00`000?l0oooo0?ooo`230?ooo`030000003oool0oooo00`0oooo00<000000?ooo`00
00002@3oool01@000000oooo0?ooo`000000oooo00@00000103oool00`000000oooo0?ooo`030?oo
o`03003jVP3oool0oooo08T0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`030?oo
o`030?l0003oool0oooo08l0oooo00<000000?ooo`3oool03`3oool001P0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00P0oooo00@000000?ooo`3o
ool000000P3oool4000000<0oooo0P0000040?ooo`030000o`3oool0oooo0880oooo0P00000?0?oo
o`8000002@3oool01P000000oooo0?ooo`000000oooo000000L0oooo0P0000040?ooo`03003jVP3o
ool0oooo08T0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`030?ooo`030?l0003o
ool0oooo08l0oooo00<000000?ooo`3oool03`3oool001@0oooo100000060?ooo`050000003oool0
oooo0?ooo`0000002P3oool01P000000oooo0?ooo`000000oooo000000<0oooo00D000000?ooo`3o
ool0oooo000000050?ooo`030000o`3oool0oooo08<0oooo00<000000?ooo`3oool03P3oool00`00
0000oooo0?ooo`080?ooo`8000000P3oool5000000<0oooo00<000000?ooo`3oool00`3oool00`00
nYX0oooo0?ooo`290?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0103oool00`3o
0000oooo0?ooo`2>0?ooo`030000003oool0oooo00l0oooo000D0?ooo`030000003oool0oooo00<0
oooo00D000000?ooo`3oool0oooo000000020?ooo`8000002P3oool01P000000oooo0?ooo`000000
oooo000000<0oooo00D000000?ooo`3oool0oooo000000050?ooo`030000o`3oool0oooo08<0oooo
00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo08T0oooo
00<000000?ooo`3oool0803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo08d0oooo
0P00000A0?ooo`00503oool5000000030?ooo`000000000000<000000`3oool00`000000oooo0?oo
o`090?ooo`8000000`3oool3000000@0oooo00<000000?ooo`3oool00`3oool00`000?l0oooo0?oo
o`220?ooo`8000009`3oool2000000@0oooo00<00?ZJ0?ooo`3oool0R@3oool00`000000oooo0?oo
o`0P0?ooo`030000003oool0oooo00@0oooo00<0o`000?ooo`3oool0SP3oool00`000000oooo0?oo
o`0?0?ooo`00>P3oool00`000000oooo0?ooo`030?ooo`030000o`3oool0oooo08<0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`040?ooo`03003jVP3oool0oooo08P0oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo08h0oooo00<00000
0?ooo`3oool03`3oool003X0oooo00<000000?ooo`3oool00`3oool00`000?l0oooo0?ooo`230?oo
o`030000003oool0oooo02D0oooo00<000000?ooo`3oool0103oool00`00nYX0oooo0?ooo`280?oo
o`030000003oool0oooo0200oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`2>0?oo
o`030000003oool0oooo00l0oooo000j0?ooo`030000003oool0oooo00@0oooo00<0003o0?ooo`3o
ool0P@3oool2000002L0oooo0P0000050?ooo`03003jVP3oool0oooo08P0oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo08d0oooo0P00000A0?ooo`00
>P3oool00`000000oooo0?ooo`040?ooo`030000o`3oool0oooo0880oooo00<000000?ooo`3oool0
9@3oool00`000000oooo0?ooo`040?ooo`03003jVP3oool0oooo08P0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo08h0oooo00<000000?ooo`3oool0
3`3oool003X0oooo00<000000?ooo`3oool0103oool00`000?l0oooo0?ooo`220?ooo`030000003o
ool0oooo02D0oooo00<000000?ooo`3oool0103oool00`00nYX0oooo0?ooo`280?ooo`030000003o
ool0oooo00L0oooo0`0000040?ooo`030000003oool0oooo0080oooo0`0000020?ooo`D000000`3o
ool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo08h0oooo00<000000?ooo`3oool03`3o
ool003X0oooo00<000000?ooo`3oool0103oool00`000?l0oooo0?ooo`210?ooo`8000002@3oool3
000000<0oooo00<000000?ooo`3oool00`3oool200000080oooo1@0000020?ooo`<00000103oool2
000000D0oooo00<00?ZJ0?ooo`3oool0R03oool00`000000oooo0?ooo`060?ooo`050000003oool0
oooo0?ooo`0000001`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0
00000`3oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo08h0oooo00<000000?ooo`3o
ool03`3oool003X0oooo00<000000?ooo`3oool0103oool00`000?l0oooo0?ooo`220?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000020?ooo`06
0000003oool0oooo0000003oool000000`3oool01@000000oooo0?ooo`3oool0000000H0oooo00<0
0?ZJ0?ooo`3oool0R03oool00`000000oooo0?ooo`05000000D0oooo00<000000?ooo`3oool01@3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00`3oool2000000H0oooo
00<0o`000?ooo`3oool0S03oool200000140oooo000j0?ooo`030000003oool0oooo00@0oooo00<0
003o0?ooo`3oool0PP3oool00`000000oooo00000004000000030?ooo`000000000000<00000203o
ool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0
oooo000000060?ooo`03003jVP3oool0oooo08P0oooo00<000000?ooo`3oool0203oool2000000T0
oooo0`0000050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01@3oool00`3o0000
oooo0?ooo`2=0?ooo`030000003oool0oooo00l0oooo000E0?ooo`<00000103oool00`000000oooo
0?ooo`020?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`8000000`3oool3000000@0oooo
00<000000?ooo`3oool0103oool00`000?l0oooo0?ooo`210?ooo`8000001`3oool010000000oooo
0?ooo`0000090?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0103oool01000
0000oooo0?ooo`3oool2000000D0oooo00<00?ZJ0?ooo`3oool0Q`3oool2000000`0oooo00<00000
0?ooo`3oool01@3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool01@000000oooo
0?ooo`3oool0000000L0oooo00<0o`000?ooo`3oool0S@3oool00`000000oooo0?ooo`0?0?ooo`00
503oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`080?ooo`060000003oool0oooo0000003oool000000`3oool01@000000oooo0?ooo`3o
ool0000000H0oooo00<0003o0?ooo`3oool0PP3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0000000T0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003oool0000000<0
0000103oool00`000000oooo0?ooo`040?ooo`03003jVP3oool0oooo08P0oooo00<000000?ooo`3o
ool01P3oool01@000000oooo0?ooo`3oool0000000L0oooo00L000000?ooo`3oool0oooo0000003o
ool0000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`030?l0003oool0oooo08d0oooo
00<000000?ooo`3oool03`3oool000h0oooo1@0000050?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`080?ooo`060000003oool0oooo0000003oool0
00000`3oool01@000000oooo0?ooo`3oool0000000H0oooo00<0003o0?ooo`3oool0PP3oool00`00
0000oooo0?ooo`070?ooo`8000002@3oool01P000000oooo0?ooo`000000oooo000000<0oooo00<0
00000?ooo`0000001`3oool2000000D0oooo00<00?ZJ0?ooo`3oool0R03oool00`000000oooo0?oo
o`070?ooo`<000002@3oool3000000<0oooo0`0000040?ooo`030000003oool0oooo00D0oooo00<0
o`000?ooo`3oool0S03oool200000140oooo000H0?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo00000080oooo0`00
00040?ooo`8000001@3oool00`000?l0oooo0?ooo`210?ooo`8000002P3oool00`000000oooo0?oo
o`080?ooo`8000000`3oool300000080oooo1@0000030?ooo`030000003oool0oooo00@0oooo00<0
0?ZJ0?ooo`3oool0R03oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00D0oooo00<0
o`000?ooo`3oool0S@3oool00`000000oooo0?ooo`0?0?ooo`00503oool4000000H0oooo00D00000
0?ooo`3oool0oooo0000000:0?ooo`060000003oool0oooo0000003oool000000`3oool01@000000
oooo0?ooo`3oool0000000L0oooo00<0003o0?ooo`3oool0P@3oool00`000000oooo0?ooo`0U0?oo
o`030000003oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0Q`3oool00`000000oooo0?ooo`0P0?oo
o`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0S@3oool00`000000oooo0?ooo`0?0?oo
o`00503oool00`000000oooo0?ooo`030?ooo`050000003oool0oooo0?ooo`0000000P3oool20000
00X0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`050000003oool0oooo0?ooo`000000
1`3oool00`000?l0oooo0?ooo`210?ooo`030000003oool0oooo02D0oooo0P0000060?ooo`03003j
VP3oool0oooo08L0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`050?ooo`030?l0
003oool0oooo08d0oooo00<000000?ooo`3oool03`3oool001@0oooo1@0000000`3oool000000000
0003000000<0oooo00<000000?ooo`3oool02@3oool2000000<0oooo0`0000040?ooo`030000003o
ool0oooo00D0oooo00<0003o0?ooo`3oool0P03oool2000002L0oooo00<000000?ooo`3oool01@3o
ool00`00nYX0oooo0?ooo`270?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01@3o
ool00`3o0000oooo0?ooo`2<0?ooo`8000004@3oool003X0oooo00<000000?ooo`3oool01@3oool0
0`000?l0oooo0?ooo`210?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool01@3oool0
0`00nYX0oooo0?ooo`270?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01P3oool0
0`3o0000oooo0?ooo`2<0?ooo`030000003oool0oooo00l0oooo000j0?ooo`030000003oool0oooo
00D0oooo00<0003o0?ooo`3oool0P@3oool00`000000oooo0?ooo`0U0?ooo`8000001P3oool00`00
nYX0oooo0?ooo`270?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01P3oool00`3o
0000oooo0?ooo`2<0?ooo`030000003oool0oooo00l0oooo000j0?ooo`030000003oool0oooo00D0
oooo00<0003o0?ooo`3oool0P03oool2000002L0oooo00<000000?ooo`3oool01@3oool00`00nYX0
oooo0?ooo`270?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01P3oool00`3o0000
oooo0?ooo`2<0?ooo`030000003oool0oooo00l0oooo000j0?ooo`030000003oool0oooo00D0oooo
00<0003o0?ooo`3oool0P@3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo00D0oooo
00<00?ZJ0?ooo`3oool0Q`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00H0oooo
00<0o`000?ooo`3oool0R`3oool200000140oooo000j0?ooo`030000003oool0oooo00D0oooo00<0
003o0?ooo`3oool0P03oool200000240oooo0`0000030?ooo`8000001P3oool00`00nYX0oooo0?oo
o`270?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01P3oool00`3o0000oooo0?oo
o`2<0?ooo`030000003oool0oooo00l0oooo000j0?ooo`030000003oool0oooo00D0oooo00<0003o
0?ooo`3oool0P@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`270?ooo`030000003oool0oooo00d0oooo0`000004
0?ooo`030000003oool0oooo0080oooo0`0000040?ooo`030000003oool0oooo00H0oooo00<0o`00
0?ooo`3oool0S03oool00`000000oooo0?ooo`0?0?ooo`00>P3oool00`000000oooo0?ooo`060?oo
o`030000o`3oool0oooo0800oooo00<000000?ooo`3oool05`3oool5000000030?ooo`0000000000
00<000000`3oool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo08L0oooo00<000000?oo
o`3oool0303oool01@000000oooo0?ooo`3oool0000000L0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo00H0oooo00<0o`000?ooo`3oool0S03oool00`000000oooo0?oo
o`0?0?ooo`00>P3oool00`000000oooo0?ooo`060?ooo`030000o`3oool0oooo07l0oooo0P00000O
0?ooo`040000003oool0oooo000000@0oooo0P0000060?ooo`03003jVP3oool0oooo08H0oooo0P00
00080?ooo`D000001@3oool00`000000oooo0?ooo`050?ooo`050000003oool0oooo0?ooo`000000
0`3oool2000000L0oooo00<0o`000?ooo`3oool0R`3oool200000140oooo000E0?ooo`<00000103o
ool00`000000oooo0?ooo`020?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`800000103o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo00<0003o0?ooo`3oool0P03o
ool00`000000oooo0?ooo`0N0?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool01@3o
ool00`00nYX0oooo0?ooo`0>0?ooo`@00?ZJ3@3oool[003jVSd0oooo00<000000?ooo`3oool03P3o
ool2000000T0oooo0`0000040?ooo`030000003oool0oooo00H0oooo00<0o`000?ooo`3oool0S03o
ool00`000000oooo0?ooo`0?0?ooo`00503oool01@000000oooo0?ooo`3oool0000000<0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo000000<0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`030000o`3oool0oooo0800oooo
00<000000?ooo`3oool07`3oool2000000@0oooo00<000000?ooo`3oool01P3oool00`00nYX0oooo
0?ooo`0=0?ooo`04003jVP3oool0oooo0?ooo`d00?ZJ:`3ooolk003jVP80oooo00<000000?ooo`3o
ool0403oool00`000000oooo0?ooo`050?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`070?ooo`030?l0003oool0oooo08/0oooo00<000000?ooo`3oool03`3oool000h0
oooo1@0000050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`080?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool00P3oool20000
00L0oooo00<0003o0?ooo`3oool0O`3oool200000280oooo00<000000?ooo`3oool00P3oool20000
00L0oooo00<00?ZJ0?ooo`3oool0303oool00`00nYX0oooo0?ooo`1g0?ooo`030000003oool0oooo
00`0oooo00D000000?ooo`3oool0oooo000000070?ooo`050000003oool0oooo0?ooo`0000000`3o
ool00`000000oooo0?ooo`070?ooo`030?l0003oool0oooo08/0oooo00<000000?ooo`3oool03`3o
ool001P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo00P0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00H0oooo00<0003o0?ooo`3oool0P03oool00`000000oooo0?ooo`0U0?ooo`030000003o
ool0oooo00H0oooo00<00?ZJ0?ooo`3oool0303oool00`00nYX0oooo0?ooo`1g0?ooo`030000003o
ool0oooo00d0oooo0`0000090?ooo`<00000103oool00`000000oooo0?ooo`070?ooo`030?l0003o
ool0oooo08X0oooo0P00000A0?ooo`00503oool4000000H0oooo00D000000?ooo`3oool0oooo0000
000:0?ooo`040000003oool0oooo000000D0oooo00D000000?ooo`3oool0oooo000000080?ooo`03
0000o`3oool0oooo0800oooo00<000000?ooo`3oool09@3oool2000000L0oooo00<00?ZJ0?ooo`3o
ool0303oool00`00nYX0oooo0?ooo`1g0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3o
ool01`3oool00`3o0000oooo0?ooo`2;0?ooo`030000003oool0oooo00l0oooo000D0?ooo`030000
003oool0oooo00<0oooo00D000000?ooo`3oool0oooo000000020?ooo`8000002P3oool01P000000
oooo0?ooo`000000oooo000000<0oooo00D000000?ooo`3oool0oooo000000080?ooo`030000o`3o
ool0oooo07l0oooo0P00000W0?ooo`030000003oool0oooo00H0oooo00<00?ZJ0?ooo`3oool02`3o
ool00`00nYX0oooo0?ooo`1h0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01`3o
ool00`3o0000oooo0?ooo`2;0?ooo`030000003oool0oooo00l0oooo000D0?ooo`D0000000<0oooo
0000000000000`0000030?ooo`030000003oool0oooo00T0oooo0P0000020?ooo`D000000`3oool0
0`000000oooo0?ooo`060?ooo`030000o`3oool0oooo0800oooo00<000000?ooo`3oool09@3oool0
0`000000oooo0?ooo`060?ooo`03003jVP3oool0oooo00/0oooo00<00?ZJ0?ooo`3oool0N03oool0
0`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00L0oooo00<0o`000?ooo`3oool0R`3oool0
0`000000oooo0?ooo`0?0?ooo`00>P3oool00`000000oooo0?ooo`060?ooo`030000o`3oool0oooo
0800oooo00<000000?ooo`3oool09@3oool2000000L0oooo00<00?ZJ0?ooo`3oool02`3oool00`00
nYX0oooo0?ooo`1h0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0203oool00`3o
0000oooo0?ooo`290?ooo`8000004@3oool003X0oooo00<000000?ooo`3oool01`3oool00`000?l0
oooo0?ooo`1n0?ooo`8000009`3oool00`000000oooo0?ooo`060?ooo`03003jVP3oool0oooo00X0
oooo00<00?ZJ0?ooo`3oool0N@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00P0
oooo00<0o`000?ooo`3oool0RP3oool00`000000oooo0?ooo`0?0?ooo`00>P3oool00`000000oooo
0?ooo`070?ooo`030000o`3oool0oooo07l0oooo00<000000?ooo`3oool09@3oool00`000000oooo
0?ooo`060?ooo`03003jVP3oool0oooo00X0oooo00<00?ZJ0?ooo`3oool0N@3oool00`000000oooo
0?ooo`0P0?ooo`030000003oool0oooo00P0oooo00<0o`000?ooo`3oool0RP3oool00`000000oooo
0?ooo`0?0?ooo`00>P3oool00`000000oooo0?ooo`070?ooo`030000o`3oool0oooo07l0oooo00<0
00000?ooo`3oool01P3oool3000000@0oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<0
00000?ooo`3oool00P3oool3000000@0oooo0P0000070?ooo`03003jVP3oool0oooo00T0oooo00<0
0?ZJ0?ooo`3oool0NP3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00T0oooo00<0
o`000?ooo`3oool0R@3oool00`000000oooo0?ooo`0?0?ooo`00>P3oool00`000000oooo0?ooo`07
0?ooo`030000o`3oool0oooo07h0oooo0P0000070?ooo`050000003oool0oooo0?ooo`0000002P3o
ool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo
0?ooo`3oool0000000P0oooo00<00?ZJ0?ooo`3oool02@3oool00`00nYX0oooo0?ooo`1j0?ooo`03
0000003oool0oooo0200oooo00<000000?ooo`3oool02@3oool00`3o0000oooo0?ooo`280?ooo`80
00004@3oool003X0oooo00<000000?ooo`3oool01`3oool00`000?l0oooo0?ooo`1o0?ooo`030000
003oool0000000@000001@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool0000000P0oooo00<00?ZJ0?ooo`3o
ool02@3oool00`00nYX0oooo0?ooo`1j0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3o
ool02@3oool00`3o0000oooo0?ooo`290?ooo`030000003oool0oooo00l0oooo000j0?ooo`030000
003oool0oooo00L0oooo00<0003o0?ooo`3oool0O`3oool00`000000oooo0?ooo`070?ooo`800000
2@3oool4000000@0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`3oool2000000L0
oooo00<00?ZJ0?ooo`3oool0203oool00`00nYX0oooo0?ooo`1j0?ooo`8000002@3oool3000000@0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`<00000103oool00`000000
oooo0?ooo`0:0?ooo`030?l0003oool0oooo08P0oooo00<000000?ooo`3oool03`3oool003X0oooo
00<000000?ooo`3oool0203oool00`000?l0oooo0?ooo`1m0?ooo`8000002`3oool00`000000oooo
0?ooo`050?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo00000003000000@0
oooo00<000000?ooo`3oool01`3oool00`00nYX0oooo0?ooo`070?ooo`03003jVP3oool0oooo07/0
oooo00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3oool0000000T0oooo00D000000?oo
o`3oool0oooo000000030?ooo`050000003oool0oooo0?ooo`000000303oool00`3o0000oooo0?oo
o`0T0?ooo``0o`00F03oool00`000000oooo0?ooo`0?0?ooo`005@3oool3000000@0oooo00<00000
0?ooo`3oool00P3oool3000000@0oooo00<000000?ooo`3oool00`3oool2000000<0oooo0`000004
0?ooo`030000003oool0oooo00T0oooo00<0003o0?ooo`3oool0O@3oool00`000000oooo0?ooo`05
0?ooo`050000003oool0oooo0?ooo`0000001`3oool01`000000oooo0?ooo`3oool000000?ooo`00
00000`3oool00`000000oooo000000070?ooo`030000003oool0oooo00L0oooo00<00?ZJ0?ooo`3o
ool01`3oool00`00nYX0oooo0?ooo`1k0?ooo`030000003oool0oooo00D000001@3oool00`000000
oooo0?ooo`080?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool0oooo0P00000;
0?ooo`030?l0003oool0oooo0240oooo0`3o000<0?ooo`<0o`00E03oool200000140oooo000D0?oo
o`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo00P0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`050000003oool0oooo0?ooo`00
00002`3oool00`000?l0oooo0?ooo`1m0?ooo`030000003oool0oooo00H0oooo0`0000090?ooo`<0
00000P3oool5000000030?ooo`000000000000<000000`3oool2000000P0oooo00<00?ZJ0?ooo`3o
ool01P3oool00`00nYX0oooo0?ooo`1l0?ooo`030000003oool0oooo00P0oooo0P00000;0?ooo`04
0000003oool0oooo0?ooo`<00000103oool00`000000oooo0?ooo`0:0?ooo`030?l0003oool0oooo
01h0oooo0`3o000B0?ooo`<0o`00DP3oool00`000000oooo0?ooo`0?0?ooo`003P3oool5000000D0
oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00P0
oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`040000003oool0oooo0?ooo`8000002`3o
ool00`000?l0oooo0?ooo`1k0?ooo`8000009`3oool00`000000oooo0?ooo`070?ooo`03003jVP3o
ool0oooo00H0oooo00<00?ZJ0?ooo`3oool0O03oool00`000000oooo0?ooo`0:0?ooo`030000003o
ool0oooo00T0oooo00<000000?ooo`0000000`3oool01@000000oooo0?ooo`3oool0000000d0oooo
00<0o`000?ooo`3oool06P3oool30?l001P0oooo0`3o001?0?ooo`030000003oool0oooo00l0oooo
000H0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`080?ooo`050000003oool0oooo0000003oool0100000040?ooo`030000003oool0oooo00/0oooo
00<0003o0?ooo`3oool0N`3oool00`000000oooo0?ooo`0U0?ooo`800000203oool00`00nYX0oooo
0?ooo`060?ooo`03003jVP3oool0oooo07`0oooo00<000000?ooo`3oool01P3oool01@000000oooo
0?ooo`3oool0000000L0oooo00L000000?ooo`3oool0oooo0000003oool0000000<0oooo00D00000
0?ooo`3oool0oooo0000000=0?ooo`030?l0003oool0oooo01L0oooo0`3o000N0?ooo`<0o`00C03o
ool00`000000oooo0?ooo`0?0?ooo`00503oool4000000H0oooo00D000000?ooo`3oool0oooo0000
000:0?ooo`060000003oool0oooo0000003oool000001`3oool00`000000oooo0?ooo`0<0?ooo`03
0000o`3oool0oooo07X0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`070?ooo`03
003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0O@3oool00`000000oooo0?ooo`070?ooo`<0
0000203oool500000080oooo0`0000040?ooo`030000003oool0oooo00/0oooo00<0o`000?ooo`3o
ool05P3oool00`3o0000oooo0?ooo`0R0?ooo``0o`00?`3oool200000140oooo000D0?ooo`030000
003oool0oooo00<0oooo00D000000?ooo`3oool0oooo000000020?ooo`8000002P3oool010000000
oooo0?ooo`0000020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0303oool00`00
0?l0oooo0?ooo`1i0?ooo`8000009`3oool00`000000oooo0?ooo`070?ooo`03003jVP3oool0oooo
00D0oooo00<00?ZJ0?ooo`3oool0O@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo
00`0oooo00<0o`000?ooo`3oool05@3oool00`3o0000oooo0?ooo`0^0?ooo`L0o`00>@3oool00`00
0000oooo0?ooo`0?0?ooo`00503oool5000000030?ooo`000000000000<000000`3oool00`000000
oooo0?ooo`090?ooo`800000103oool2000000@0oooo00<000000?ooo`3oool03@3oool00`000?l0
oooo0?ooo`1i0?ooo`030000003oool0oooo02D0oooo0P0000080?ooo`03003jVP3oool0oooo00@0
oooo00<00?ZJ0?ooo`3oool0OP3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00`0
oooo00<0o`000?ooo`3oool0503oool00`3o0000oooo0?ooo`0f0?ooo`L0o`00<P3oool00`000000
oooo0?ooo`0?0?ooo`00>P3oool00`000000oooo0?ooo`0>0?ooo`80003oN@3oool00`000000oooo
0?ooo`0U0?ooo`030000003oool0oooo00L0oooo00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo
0?ooo`1n0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0303oool00`3o0000oooo
0?ooo`0C0?ooo`030?l0003oool0oooo03h0oooo203o00060?ooob40o`000`3oool00`000000oooo
0?ooo`0?0?ooo`00>P3oool00`000000oooo0?ooo`0@0?ooo`030000o`3oool0oooo07D0oooo0P00
000W0?ooo`030000003oool0oooo00L0oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX0oooo0?oo
o`1o0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0303oool00`3o0000oooo0?oo
o`0B0?ooo`030?l0003oool0oooo04L0oooo1P3o000S0?ooo`8000004@3oool003X0oooo00<00000
0?ooo`3oool04@3oool20000ogH0oooo00<000000?ooo`3oool0303oool3000000@0oooo00<00000
0?ooo`3oool00P3oool2000000@0oooo0`0000040?ooo`800000203oool00`00nYX0oooo0?ooo`02
0?ooo`03003jVP3oool0oooo0800oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0=
0?ooo`030?l0003oool0oooo0100oooo00<0o`000?ooo`3oool0LP3oool00`000000oooo0?ooo`0?
0?ooo`00>P3oool00`000000oooo0?ooo`0C0?ooo`030000o`3oool0oooo07<0oooo00<000000?oo
o`3oool02`3oool01@000000oooo0?ooo`3oool0000000X0oooo00@000000?ooo`3oool000000`3o
ool01@000000oooo0?ooo`3oool0000000T0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo
0?ooo`200?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool03@3oool00`3o0000oooo
0?ooo`0?0?ooo`030?l0003oool0oooo07<0oooo00<000000?ooo`3oool03`3oool003X0oooo00<0
00000?ooo`3oool0503ooolB0000of80oooo0P0000070?ooo`D000001@3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3oool0oooo0000000:0?ooo`04003j
VP3oool0oooo003jVX<0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0=0?ooo`03
0?l0003oool0oooo00h0oooo00<0o`000?ooo`3oool0M03oool00`000000oooo0?ooo`0?0?ooo`00
>P3oool00`000000oooo0?ooo`0V0?ooof00003o0`3oool00`000000oooo0?ooo`0=0?ooo`800000
2@3oool4000000D0oooo00@000000?ooo`3oool0oooo0P0000090?ooo`04003jVP3oool0oooo003j
VX80oooo0P00000R0?ooo`030000003oool0oooo00h0oooo00<0o`000?ooo`3oool0103oool90?l0
07H0oooo0P00000A0?ooo`00>P3oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00<0oooo00D000000?ooo`3oool0oooo0000000A0?ooo`030000003oool0oooo00D0oooo00H00000
0?ooo`3oool0oooo0000003oool4000000@0oooo00<000000?ooo`3oool0203oool00`00nYX0oooo
003jVP240?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool03P3oool00`3o0000oooo
0?ooo`020?ooo`80o`00P03oool00`000000oooo0?ooo`0?0?ooo`00>P3ooon=000000d0oooo00D0
00000?ooo`3oool0oooo000000070?ooo`070000003oool0oooo0?ooo`000000oooo000000070?oo
o`030000003oool0oooo00P0oooo0P00nYZ50?ooo`030000003oool0oooo00L0oooo0`0000040?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool3000000@0oooo00<000000?oo
o`3oool03P3oool01@3o0000oooo0?ooo`3oool0o`000880oooo00<000000?ooo`3oool03`3oool0
0=D0oooo0`0000090?ooo`<000000P3oool5000000<0oooo0P0000090?ooo`800?ZJQ@3oool00`00
0000oooo0?ooo`060?ooo`050000003oool0oooo0?ooo`0000002@3oool01@000000oooo0?ooo`3o
ool0000000<0oooo00D000000?ooo`3oool0oooo0000000A0?ooo`<0o`00P`3oool00`000000oooo
0?ooo`0?0?ooo`00kP3oool00`000000oooo0?ooo`080?ooo`03003jVP3oool0oooo08@0oooo00<0
00000?ooo`3oool01@0000050?ooo`030000003oool0oooo00P0oooo00@000000?ooo`3oool00000
0`3oool010000000oooo0?ooo`3oool200000100oooo00<0o`000?ooo`3oool0PP3oool200000140
oooo003^0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`04
0000003oool0oooo000000X0oooo0P00000;0?ooo`030000003oool0oooo00@00000103oool00`00
0000oooo0?ooo`2E0?ooo`030000003oool0oooo00l0oooo003^0?oooi<00000303oool00`000000
oooo0?ooo`090?ooo`030000003oool0000000L0oooo00@000000?ooo`3oool000001P3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`040?ooo`050000003oool0oooo0?ooo`0000004@3oool00?l0ooooRP3oool01@00
0000oooo0?ooo`3oool0000000L0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003o
ool0oooo00@0ooooV@00000A0?ooo`00o`3ooon;0?ooo`<00000203oool5000000<0oooo0P00002^
0?ooo`00o`3ooooo0?ooodl0oooo003o0?ooool0ooooC`3oool00?l0ooooo`3ooom?0?ooo`00o`3o
oooo0?ooodl0oooo003o0?ooool0ooooC`3oool00?l0ooooo`3ooom?0?ooo`00o`3ooooo0?ooodl0
oooo003o0?ooool0ooooC`3oool00?l0ooooo`3ooom?0?ooo`00o`3ooooo0?ooodl0oooo0000\
\>"],
  ImageRangeCache->{{{0, 588.125}, {241.75, 0}} -> {-0.0787245, -0.0309082, \
0.00536868, 0.00536868}, {{14.625, 200.875}, {235.938, 120.875}} -> \
{-6.92923, 18.5901, 0.138188, 0.00140328}, {{200.875, 387.188}, {235.938, \
120.875}} -> {-32.6535, 44.3903, 0.13813, 0.00117432}, {{387.188, 573.438}, \
{235.938, 120.875}} -> {-58.4128, 26.3204, 0.138188, 0.00113223}, {{14.625, \
200.875}, {120.875, 5.75}} -> {-9.26668, -571.203, 0.150182, 0.000674591}, \
{{200.875, 387.188}, {120.875, 5.75}} -> {-34.8426, -4.34599, 0.143873, \
0.00177433}, {{387.188, 573.438}, {120.875, 5.75}} -> {-58.4128, -4.04564, \
0.138188, 0.00125653}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(likpsi // MatrixForm\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-571.1091180939013`\), \(-4.096`\), \(-3.872`\), "18.6239`", 
              "44.4186`", "26.3461`"},
            {\(-571.0632660632931`\), \(-3.9435606897461937`\), \
\(-3.7940447780314384`\), "18.66919036516726`", "44.42052574493464`", 
              "26.34755016916682`"},
            {\(-571.0568714731943`\), \(-3.9644376751804193`\), \
\(-3.759605034192029`\), "18.685077512966913`", "44.42236954351728`", 
              "26.349191880310492`"},
            {\(-571.0541966995521`\), \(-3.9973236082764583`\), \
\(-3.764722827723078`\), "18.699337238554477`", "44.431563289460286`", 
              "26.354205467399176`"},
            {\(-571.0540307802946`\), \(-3.996549203510266`\), \
\(-3.765446151825003`\), "18.70979201719499`", "44.438509421315686`", 
              "26.35749841662944`"},
            {\(-571.0537667885047`\), \(-3.9967073272179356`\), \
\(-3.7749209504213237`\), "18.741070015677394`", "44.46451155982686`", 
              "26.369046079267832`"},
            {\(-571.0537245673323`\), \(-3.9975674982418234`\), \
\(-3.779023252625864`\), "18.747881662703154`", "44.475811427316145`", 
              "26.373228373120334`"},
            {\(-571.0536912210472`\), \(-3.998258018412401`\), \
\(-3.7813087906670333`\), "18.749421293316527`", "44.488738752082355`", 
              "26.37730009834615`"},
            {\(-571.0536567699614`\), \(-3.9984602145477357`\), \
\(-3.7812363382305936`\), "18.746300355455883`", "44.50527675204316`", 
              "26.38218654568057`"},
            {\(-571.0536314975344`\), \(-3.9979390598177846`\), \
\(-3.7784212520674525`\), "18.739413052508755`", "44.520084281476564`", 
              "26.38680348416137`"},
            {\(-571.0536241309657`\), \(-3.9972982886995463`\), \
\(-3.77579041807604`\), "18.734896386465035`", "44.52368507574933`", 
              "26.38877520562562`"},
            {\(-571.053622288915`\), \(-3.997005447860776`\), \
\(-3.774745962845`\), "18.73346798633048`", "44.5227866729055`", 
              "26.38987659149165`"},
            {\(-571.0536202753874`\), \(-3.99676657744144`\), \
\(-3.7739482087932035`\), "18.732335643786925`", "44.52136907774139`", 
              "26.392223255223787`"},
            {\(-571.053615547382`\), \(-3.996366665655622`\), \
\(-3.772650821262671`\), "18.730091645448812`", "44.51885475724388`", 
              "26.399883591922272`"},
            {\(-571.0536079435776`\), \(-3.9959209013117913`\), \
\(-3.7712487311518075`\), "18.72679254934776`", "44.516234754032084`", 
              "26.415625659621178`"},
            {\(-571.0536000871357`\), \(-3.9956962707330557`\), \
\(-3.770611705937591`\), "18.723687155661704`", "44.51535714262855`", 
              "26.43628571378669`"},
            {\(-571.0535966395194`\), \(-3.995856497857351`\), \
\(-3.7712038609303113`\), "18.722987996664074`", "44.516903534701754`", 
              "26.447191725733603`"},
            {\(-571.0535961167566`\), \(-3.996043370108657`\), \
\(-3.771826746146609`\), "18.723595040333745`", "44.51826267598928`", 
              "26.447376706606292`"},
            {\(-571.0535960933186`\), \(-3.996090203805463`\), \
\(-3.7719769690559426`\), "18.723869932310592`", "44.51856485816781`", 
              "26.446334541836062`"},
            {\(-571.0535960930275`\), \(-3.996092651029894`\), \
\(-3.7719842035250783`\), "18.723896132214733`", "44.5185768408713`", 
              "26.446173530326345`"},
            {\(-571.0535960930212`\), \(-3.996093018481496`\), \
\(-3.77198528172654`\), "18.723900035966057`", "44.518578636023484`", 
              "26.4461493694456`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YG,PG,YF,PF,LIK} = \
GLATT1[Z,X,k,p,q,n,T,dt,THETA,PHI,NONLIN];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1, 2, 1, 1, 175}\)], "Print"]
}, Open  ]],

Cell["\<\
zalphahalbe//Clear
zalphahalbe[alpha_] := Quantile[NormalDistribution[0,1], 1-alpha/2]\
\>", \
"Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["z = zalphahalbe[.01]", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(2.5758293035489004`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
plot1[(time//Spalte)~ii~ConfidenceBand[YG,YG,PG,1,1,z],
\t\tcolor->{1,1,3,3},dicke->.001];
plot1[(time//Spalte)~ii~ConfidenceBand[YG,YG,PG,2,1,z],
\t\tcolor->{2,2,3,3},dicke->.001];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{176, 5}\),
      SequenceForm[ "Dimension der Daten  ", {176, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-9.49456 0.00544218 0.208667 0.00354159 [
[.02925 -0.0125 -12 -9 ]
[.02925 -0.0125 12 0 ]
[.16531 -0.0125 -12 -9 ]
[.16531 -0.0125 12 0 ]
[.30136 -0.0125 -12 -9 ]
[.30136 -0.0125 12 0 ]
[.43741 -0.0125 -12 -9 ]
[.43741 -0.0125 12 0 ]
[.57347 -0.0125 -12 -9 ]
[.57347 -0.0125 12 0 ]
[.70952 -0.0125 -12 -9 ]
[.70952 -0.0125 12 0 ]
[.84558 -0.0125 -12 -9 ]
[.84558 -0.0125 12 0 ]
[.98163 -0.0125 -12 -9 ]
[.98163 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03159 -18 -4.5 ]
[-0.0125 .03159 0 4.5 ]
[-0.0125 .12013 -18 -4.5 ]
[-0.0125 .12013 0 4.5 ]
[-0.0125 .20867 -6 -4.5 ]
[-0.0125 .20867 0 4.5 ]
[-0.0125 .29721 -12 -4.5 ]
[-0.0125 .29721 0 4.5 ]
[-0.0125 .38575 -12 -4.5 ]
[-0.0125 .38575 0 4.5 ]
[-0.0125 .47429 -12 -4.5 ]
[-0.0125 .47429 0 4.5 ]
[-0.0125 .56283 -18 -4.5 ]
[-0.0125 .56283 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .10857 -5 -6 ]
[.97619 .10857 5 6 ]
[.97619 .10857 -5 -6 ]
[.97619 .10857 5 6 ]
[.97619 .15277 -5 -6 ]
[.97619 .15277 5 6 ]
[.97619 .06438 -5 -6 ]
[.97619 .06438 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02925 0 m
.02925 .00625 L
s
[(1750)] .02925 -0.0125 0 1 Mshowa
.16531 0 m
.16531 .00625 L
s
[(1775)] .16531 -0.0125 0 1 Mshowa
.30136 0 m
.30136 .00625 L
s
[(1800)] .30136 -0.0125 0 1 Mshowa
.43741 0 m
.43741 .00625 L
s
[(1825)] .43741 -0.0125 0 1 Mshowa
.57347 0 m
.57347 .00625 L
s
[(1850)] .57347 -0.0125 0 1 Mshowa
.70952 0 m
.70952 .00625 L
s
[(1875)] .70952 -0.0125 0 1 Mshowa
.84558 0 m
.84558 .00625 L
s
[(1900)] .84558 -0.0125 0 1 Mshowa
.98163 0 m
.98163 .00625 L
s
[(1925)] .98163 -0.0125 0 1 Mshowa
.125 Mabswid
.05646 0 m
.05646 .00375 L
s
.08367 0 m
.08367 .00375 L
s
.11088 0 m
.11088 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.19252 0 m
.19252 .00375 L
s
.21973 0 m
.21973 .00375 L
s
.24694 0 m
.24694 .00375 L
s
.27415 0 m
.27415 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.35578 0 m
.35578 .00375 L
s
.38299 0 m
.38299 .00375 L
s
.4102 0 m
.4102 .00375 L
s
.46463 0 m
.46463 .00375 L
s
.49184 0 m
.49184 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.54626 0 m
.54626 .00375 L
s
.60068 0 m
.60068 .00375 L
s
.62789 0 m
.62789 .00375 L
s
.6551 0 m
.6551 .00375 L
s
.68231 0 m
.68231 .00375 L
s
.73673 0 m
.73673 .00375 L
s
.76395 0 m
.76395 .00375 L
s
.79116 0 m
.79116 .00375 L
s
.81837 0 m
.81837 .00375 L
s
.87279 0 m
.87279 .00375 L
s
.9 0 m
.9 .00375 L
s
.92721 0 m
.92721 .00375 L
s
.95442 0 m
.95442 .00375 L
s
.00204 0 m
.00204 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03159 m
.00625 .03159 L
s
[(-50)] -0.0125 .03159 1 0 Mshowa
0 .12013 m
.00625 .12013 L
s
[(-25)] -0.0125 .12013 1 0 Mshowa
0 .20867 m
.00625 .20867 L
s
[(0)] -0.0125 .20867 1 0 Mshowa
0 .29721 m
.00625 .29721 L
s
[(25)] -0.0125 .29721 1 0 Mshowa
0 .38575 m
.00625 .38575 L
s
[(50)] -0.0125 .38575 1 0 Mshowa
0 .47429 m
.00625 .47429 L
s
[(75)] -0.0125 .47429 1 0 Mshowa
0 .56283 m
.00625 .56283 L
s
[(100)] -0.0125 .56283 1 0 Mshowa
.125 Mabswid
0 .0493 m
.00375 .0493 L
s
0 .067 m
.00375 .067 L
s
0 .08471 m
.00375 .08471 L
s
0 .10242 m
.00375 .10242 L
s
0 .13784 m
.00375 .13784 L
s
0 .15554 m
.00375 .15554 L
s
0 .17325 m
.00375 .17325 L
s
0 .19096 m
.00375 .19096 L
s
0 .22638 m
.00375 .22638 L
s
0 .24408 m
.00375 .24408 L
s
0 .26179 m
.00375 .26179 L
s
0 .2795 m
.00375 .2795 L
s
0 .31491 m
.00375 .31491 L
s
0 .33262 m
.00375 .33262 L
s
0 .35033 m
.00375 .35033 L
s
0 .36804 m
.00375 .36804 L
s
0 .40345 m
.00375 .40345 L
s
0 .42116 m
.00375 .42116 L
s
0 .43887 m
.00375 .43887 L
s
0 .45658 m
.00375 .45658 L
s
0 .49199 m
.00375 .49199 L
s
0 .5097 m
.00375 .5097 L
s
0 .52741 m
.00375 .52741 L
s
0 .54512 m
.00375 .54512 L
s
0 .01388 m
.00375 .01388 L
s
0 .58053 m
.00375 .58053 L
s
0 .59824 m
.00375 .59824 L
s
0 .61595 m
.00375 .61595 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02925 .61178 m
.02925 .61803 L
s
.16531 .61178 m
.16531 .61803 L
s
.30136 .61178 m
.30136 .61803 L
s
.43741 .61178 m
.43741 .61803 L
s
.57347 .61178 m
.57347 .61803 L
s
.70952 .61178 m
.70952 .61803 L
s
.84558 .61178 m
.84558 .61803 L
s
.98163 .61178 m
.98163 .61803 L
s
.125 Mabswid
.05646 .61428 m
.05646 .61803 L
s
.08367 .61428 m
.08367 .61803 L
s
.11088 .61428 m
.11088 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.19252 .61428 m
.19252 .61803 L
s
.21973 .61428 m
.21973 .61803 L
s
.24694 .61428 m
.24694 .61803 L
s
.27415 .61428 m
.27415 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.35578 .61428 m
.35578 .61803 L
s
.38299 .61428 m
.38299 .61803 L
s
.4102 .61428 m
.4102 .61803 L
s
.46463 .61428 m
.46463 .61803 L
s
.49184 .61428 m
.49184 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.54626 .61428 m
.54626 .61803 L
s
.60068 .61428 m
.60068 .61803 L
s
.62789 .61428 m
.62789 .61803 L
s
.6551 .61428 m
.6551 .61803 L
s
.68231 .61428 m
.68231 .61803 L
s
.73673 .61428 m
.73673 .61803 L
s
.76395 .61428 m
.76395 .61803 L
s
.79116 .61428 m
.79116 .61803 L
s
.81837 .61428 m
.81837 .61803 L
s
.87279 .61428 m
.87279 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.92721 .61428 m
.92721 .61803 L
s
.95442 .61428 m
.95442 .61803 L
s
.00204 .61428 m
.00204 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03159 m
1 .03159 L
s
.99375 .12013 m
1 .12013 L
s
.99375 .20867 m
1 .20867 L
s
.99375 .29721 m
1 .29721 L
s
.99375 .38575 m
1 .38575 L
s
.99375 .47429 m
1 .47429 L
s
.99375 .56283 m
1 .56283 L
s
.125 Mabswid
.99625 .0493 m
1 .0493 L
s
.99625 .067 m
1 .067 L
s
.99625 .08471 m
1 .08471 L
s
.99625 .10242 m
1 .10242 L
s
.99625 .13784 m
1 .13784 L
s
.99625 .15554 m
1 .15554 L
s
.99625 .17325 m
1 .17325 L
s
.99625 .19096 m
1 .19096 L
s
.99625 .22638 m
1 .22638 L
s
.99625 .24408 m
1 .24408 L
s
.99625 .26179 m
1 .26179 L
s
.99625 .2795 m
1 .2795 L
s
.99625 .31491 m
1 .31491 L
s
.99625 .33262 m
1 .33262 L
s
.99625 .35033 m
1 .35033 L
s
.99625 .36804 m
1 .36804 L
s
.99625 .40345 m
1 .40345 L
s
.99625 .42116 m
1 .42116 L
s
.99625 .43887 m
1 .43887 L
s
.99625 .45658 m
1 .45658 L
s
.99625 .49199 m
1 .49199 L
s
.99625 .5097 m
1 .5097 L
s
.99625 .52741 m
1 .52741 L
s
.99625 .54512 m
1 .54512 L
s
.99625 .01388 m
1 .01388 L
s
.99625 .58053 m
1 .58053 L
s
.99625 .59824 m
1 .59824 L
s
.99625 .61595 m
1 .61595 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .10857 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .3431 m
.02925 .3283 L
.03469 .24466 L
.04014 .20764 L
.04558 .15808 L
.05102 .10043 L
.05646 .07939 L
.0619 .09631 L
.06735 .16097 L
.07279 .21544 L
.07823 .24441 L
.08367 .28786 L
.08912 .33183 L
.09456 .27882 L
.1 .21537 L
.10544 .17254 L
.11088 .12067 L
.11633 .10178 L
.12177 .17942 L
.12721 .30564 L
.13265 .41245 L
.1381 .41041 L
.14354 .34719 L
.14898 .27475 L
.15442 .19046 L
.15986 .1367 L
.16531 .07821 L
.17075 .14156 L
.17619 .37887 L
.18163 .56481 L
.18707 .50624 L
.19252 .36717 L
.19796 .27803 L
.2034 .19211 L
.20884 .12319 L
.21429 .08573 L
.21973 .1504 L
.22517 .34018 L
.23061 .50207 L
.23605 .52287 L
.2415 .46408 L
.24694 .36891 L
.25238 .29171 L
.25782 .25568 L
.26327 .22253 L
.26871 .18779 L
.27415 .13568 L
.27959 .10316 L
.28503 .07664 L
.29048 .06575 L
Mistroke
.29592 .07451 L
.30136 .10881 L
.3068 .16869 L
.31224 .2064 L
.31769 .21184 L
.32313 .21732 L
.32857 .1994 L
.33401 .14898 L
.33946 .09545 L
.3449 .07563 L
.35034 .06169 L
.35578 .05322 L
.36122 .05719 L
.36667 .07104 L
.37211 .08874 L
.37755 .11233 L
.38299 .17263 L
.38844 .21078 L
.39388 .19798 L
.39932 .16313 L
.40476 .13496 L
.4102 .10621 L
.41565 .07804 L
.42109 .06367 L
.42653 .06081 L
.43197 .07881 L
.43741 .11549 L
.44286 .17564 L
.4483 .22906 L
.45374 .27076 L
.45918 .29507 L
.46463 .29253 L
.47007 .22642 L
.47551 .1431 L
.48095 .07917 L
.48639 .10347 L
.49184 .26245 L
.49728 .46677 L
.50272 .52625 L
.50816 .43562 L
.51361 .34949 L
.51905 .26948 L
.52449 .187 L
.52993 .12954 L
.53537 .09146 L
.54082 .10822 L
.54626 .18284 L
.5517 .27847 L
.55714 .40338 L
.56259 .47052 L
Mistroke
.56803 .3951 L
.57347 .29934 L
.57891 .27029 L
.58435 .24202 L
.5898 .18899 L
.59524 .12417 L
.60068 .07381 L
.60612 .0681 L
.61156 .13184 L
.61701 .25243 L
.62245 .37162 L
.62789 .38917 L
.63333 .32779 L
.63878 .2579 L
.64422 .21623 L
.64966 .20643 L
.6551 .16134 L
.66054 .1032 L
.66599 .08604 L
.67143 .17449 L
.67687 .33757 L
.68231 .49972 L
.68776 .47315 L
.6932 .39813 L
.69864 .2937 L
.70408 .1999 L
.70952 .11968 L
.71497 .09217 L
.72041 .08634 L
.72585 .06544 L
.73129 .08151 L
.73673 .16222 L
.74218 .23763 L
.74762 .26691 L
.75306 .27891 L
.7585 .27505 L
.76395 .22951 L
.76939 .14905 L
.77483 .09709 L
.78027 .07482 L
.78571 .06689 L
.79116 .08543 L
.7966 .18067 L
.80204 .30109 L
.80748 .35153 L
.81293 .33075 L
.81837 .27388 L
.82381 .20033 L
.82925 .15146 L
.83469 .13497 L
Mistroke
.84014 .10269 L
.84558 .08017 L
.85102 .06178 L
.85646 .0742 L
.8619 .13411 L
.86735 .20682 L
.87279 .26117 L
.87823 .25819 L
.88367 .25921 L
.88912 .2334 L
.89456 .19547 L
.9 .124 L
.90544 .07442 L
.91088 .05841 L
.91633 .05566 L
.92177 .09792 L
.92721 .19725 L
.93265 .28547 L
.9381 .38573 L
.94354 .35216 L
.94898 .27145 L
.95442 .19046 L
.95986 .13939 L
.96531 .09857 L
.97075 .07796 L
.97619 .10857 L
Mfstroke
gsave
.97619 .10857 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3431 m
.02925 .3283 L
.03469 .24466 L
.04014 .20764 L
.04558 .15808 L
.05102 .10043 L
.05646 .07939 L
.0619 .09631 L
.06735 .16097 L
.07279 .21544 L
.07823 .24441 L
.08367 .28786 L
.08912 .33183 L
.09456 .27882 L
.1 .21537 L
.10544 .17254 L
.11088 .12067 L
.11633 .10178 L
.12177 .17942 L
.12721 .30564 L
.13265 .41245 L
.1381 .41041 L
.14354 .34719 L
.14898 .27475 L
.15442 .19046 L
.15986 .1367 L
.16531 .07821 L
.17075 .14156 L
.17619 .37887 L
.18163 .56481 L
.18707 .50624 L
.19252 .36717 L
.19796 .27803 L
.2034 .19211 L
.20884 .12319 L
.21429 .08573 L
.21973 .1504 L
.22517 .34018 L
.23061 .50207 L
.23605 .52287 L
.2415 .46408 L
.24694 .36891 L
.25238 .29171 L
.25782 .25568 L
.26327 .22253 L
.26871 .18779 L
.27415 .13568 L
.27959 .10316 L
.28503 .07664 L
.29048 .06575 L
Mistroke
.29592 .07451 L
.30136 .10881 L
.3068 .16869 L
.31224 .2064 L
.31769 .21184 L
.32313 .21732 L
.32857 .1994 L
.33401 .14898 L
.33946 .09545 L
.3449 .07563 L
.35034 .06169 L
.35578 .05322 L
.36122 .05719 L
.36667 .07104 L
.37211 .08874 L
.37755 .11233 L
.38299 .17263 L
.38844 .21078 L
.39388 .19798 L
.39932 .16313 L
.40476 .13496 L
.4102 .10621 L
.41565 .07804 L
.42109 .06367 L
.42653 .06081 L
.43197 .07881 L
.43741 .11549 L
.44286 .17564 L
.4483 .22906 L
.45374 .27076 L
.45918 .29507 L
.46463 .29253 L
.47007 .22642 L
.47551 .1431 L
.48095 .07917 L
.48639 .10347 L
.49184 .26245 L
.49728 .46677 L
.50272 .52625 L
.50816 .43562 L
.51361 .34949 L
.51905 .26948 L
.52449 .187 L
.52993 .12954 L
.53537 .09146 L
.54082 .10822 L
.54626 .18284 L
.5517 .27847 L
.55714 .40338 L
.56259 .47052 L
Mistroke
.56803 .3951 L
.57347 .29934 L
.57891 .27029 L
.58435 .24202 L
.5898 .18899 L
.59524 .12417 L
.60068 .07381 L
.60612 .0681 L
.61156 .13184 L
.61701 .25243 L
.62245 .37162 L
.62789 .38917 L
.63333 .32779 L
.63878 .2579 L
.64422 .21623 L
.64966 .20643 L
.6551 .16134 L
.66054 .1032 L
.66599 .08604 L
.67143 .17449 L
.67687 .33757 L
.68231 .49972 L
.68776 .47315 L
.6932 .39813 L
.69864 .2937 L
.70408 .1999 L
.70952 .11968 L
.71497 .09217 L
.72041 .08634 L
.72585 .06544 L
.73129 .08151 L
.73673 .16222 L
.74218 .23763 L
.74762 .26691 L
.75306 .27891 L
.7585 .27505 L
.76395 .22951 L
.76939 .14905 L
.77483 .09709 L
.78027 .07482 L
.78571 .06689 L
.79116 .08543 L
.7966 .18067 L
.80204 .30109 L
.80748 .35153 L
.81293 .33075 L
.81837 .27388 L
.82381 .20033 L
.82925 .15146 L
.83469 .13497 L
Mistroke
.84014 .10269 L
.84558 .08017 L
.85102 .06178 L
.85646 .0742 L
.8619 .13411 L
.86735 .20682 L
.87279 .26117 L
.87823 .25819 L
.88367 .25921 L
.88912 .2334 L
.89456 .19547 L
.9 .124 L
.90544 .07442 L
.91088 .05841 L
.91633 .05566 L
.92177 .09792 L
.92721 .19725 L
.93265 .28547 L
.9381 .38573 L
.94354 .35216 L
.94898 .27145 L
.95442 .19046 L
.95986 .13939 L
.96531 .09857 L
.97075 .07796 L
.97619 .10857 L
Mfstroke
1 0 0 r
gsave
.97619 .15277 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38864 m
.02925 .36899 L
.03469 .28327 L
.04014 .24616 L
.04558 .19659 L
.05102 .13894 L
.05646 .1179 L
.0619 .13482 L
.06735 .19948 L
.07279 .25395 L
.07823 .28292 L
.08367 .32637 L
.08912 .37034 L
.09456 .31733 L
.1 .25388 L
.10544 .21105 L
.11088 .15917 L
.11633 .14029 L
.12177 .21793 L
.12721 .34415 L
.13265 .45096 L
.1381 .44892 L
.14354 .3857 L
.14898 .31326 L
.15442 .22897 L
.15986 .17521 L
.16531 .11672 L
.17075 .18007 L
.17619 .41738 L
.18163 .60332 L
.18707 .54475 L
.19252 .40568 L
.19796 .31654 L
.2034 .23062 L
.20884 .1617 L
.21429 .12424 L
.21973 .1889 L
.22517 .37869 L
.23061 .54058 L
.23605 .56138 L
.2415 .50259 L
.24694 .40742 L
.25238 .33022 L
.25782 .29419 L
.26327 .26104 L
.26871 .2263 L
.27415 .17419 L
.27959 .14167 L
.28503 .11515 L
.29048 .10426 L
Mistroke
.29592 .11302 L
.30136 .14731 L
.3068 .2072 L
.31224 .24491 L
.31769 .25035 L
.32313 .25583 L
.32857 .23791 L
.33401 .18749 L
.33946 .13396 L
.3449 .11414 L
.35034 .1002 L
.35578 .09173 L
.36122 .0957 L
.36667 .10955 L
.37211 .12724 L
.37755 .15084 L
.38299 .21114 L
.38844 .24929 L
.39388 .23649 L
.39932 .20164 L
.40476 .17347 L
.4102 .14471 L
.41565 .11655 L
.42109 .10218 L
.42653 .09932 L
.43197 .11732 L
.43741 .154 L
.44286 .21415 L
.4483 .26757 L
.45374 .30927 L
.45918 .33358 L
.46463 .33104 L
.47007 .26493 L
.47551 .18161 L
.48095 .11767 L
.48639 .14198 L
.49184 .30096 L
.49728 .50528 L
.50272 .56476 L
.50816 .47413 L
.51361 .388 L
.51905 .30799 L
.52449 .22551 L
.52993 .16805 L
.53537 .12997 L
.54082 .14673 L
.54626 .22135 L
.5517 .31698 L
.55714 .44189 L
.56259 .50903 L
Mistroke
.56803 .43361 L
.57347 .33785 L
.57891 .3088 L
.58435 .28053 L
.5898 .2275 L
.59524 .16268 L
.60068 .11232 L
.60612 .10661 L
.61156 .17035 L
.61701 .29094 L
.62245 .41013 L
.62789 .42767 L
.63333 .3663 L
.63878 .29641 L
.64422 .25474 L
.64966 .24494 L
.6551 .19985 L
.66054 .14171 L
.66599 .12455 L
.67143 .213 L
.67687 .37608 L
.68231 .53823 L
.68776 .51165 L
.6932 .43664 L
.69864 .33221 L
.70408 .23841 L
.70952 .15819 L
.71497 .13068 L
.72041 .12484 L
.72585 .10395 L
.73129 .12002 L
.73673 .20073 L
.74218 .27614 L
.74762 .30542 L
.75306 .31742 L
.7585 .31356 L
.76395 .26802 L
.76939 .18756 L
.77483 .1356 L
.78027 .11333 L
.78571 .1054 L
.79116 .12393 L
.7966 .21918 L
.80204 .3396 L
.80748 .39004 L
.81293 .36926 L
.81837 .31239 L
.82381 .23883 L
.82925 .18997 L
.83469 .17348 L
Mistroke
.84014 .1412 L
.84558 .11868 L
.85102 .10029 L
.85646 .11271 L
.8619 .17262 L
.86735 .24533 L
.87279 .29968 L
.87823 .2967 L
.88367 .29772 L
.88912 .27191 L
.89456 .23398 L
.9 .16251 L
.90544 .11293 L
.91088 .09692 L
.91633 .09416 L
.92177 .13642 L
.92721 .23576 L
.93265 .32398 L
.9381 .42424 L
.94354 .39067 L
.94898 .30996 L
.95442 .22897 L
.95986 .17791 L
.96531 .13714 L
.97075 .11732 L
.97619 .15277 L
Mfstroke
gsave
.97619 .06438 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29757 m
.02925 .28761 L
.03469 .20605 L
.04014 .16912 L
.04558 .11957 L
.05102 .06192 L
.05646 .04088 L
.0619 .0578 L
.06735 .12246 L
.07279 .17694 L
.07823 .2059 L
.08367 .24935 L
.08912 .29332 L
.09456 .24031 L
.1 .17686 L
.10544 .13403 L
.11088 .08216 L
.11633 .06327 L
.12177 .14091 L
.12721 .26713 L
.13265 .37394 L
.1381 .3719 L
.14354 .30868 L
.14898 .23624 L
.15442 .15195 L
.15986 .09819 L
.16531 .0397 L
.17075 .10306 L
.17619 .34036 L
.18163 .5263 L
.18707 .46773 L
.19252 .32866 L
.19796 .23952 L
.2034 .1536 L
.20884 .08468 L
.21429 .04722 L
.21973 .11189 L
.22517 .30167 L
.23061 .46356 L
.23605 .48436 L
.2415 .42557 L
.24694 .3304 L
.25238 .2532 L
.25782 .21717 L
.26327 .18402 L
.26871 .14928 L
.27415 .09717 L
.27959 .06465 L
.28503 .03813 L
.29048 .02724 L
Mistroke
.29592 .036 L
.30136 .0703 L
.3068 .13018 L
.31224 .16789 L
.31769 .17333 L
.32313 .17881 L
.32857 .1609 L
.33401 .11048 L
.33946 .05695 L
.3449 .03712 L
.35034 .02318 L
.35578 .01472 L
.36122 .01869 L
.36667 .03253 L
.37211 .05023 L
.37755 .07382 L
.38299 .13412 L
.38844 .17227 L
.39388 .15947 L
.39932 .12462 L
.40476 .09646 L
.4102 .0677 L
.41565 .03953 L
.42109 .02516 L
.42653 .02231 L
.43197 .0403 L
.43741 .07698 L
.44286 .13713 L
.4483 .19056 L
.45374 .23225 L
.45918 .25656 L
.46463 .25402 L
.47007 .18791 L
.47551 .10459 L
.48095 .04066 L
.48639 .06496 L
.49184 .22394 L
.49728 .42826 L
.50272 .48774 L
.50816 .39711 L
.51361 .31098 L
.51905 .23097 L
.52449 .14849 L
.52993 .09103 L
.53537 .05295 L
.54082 .06971 L
.54626 .14433 L
.5517 .23996 L
.55714 .36488 L
.56259 .43201 L
Mistroke
.56803 .35659 L
.57347 .26083 L
.57891 .23178 L
.58435 .20351 L
.5898 .15048 L
.59524 .08566 L
.60068 .0353 L
.60612 .02959 L
.61156 .09333 L
.61701 .21392 L
.62245 .33311 L
.62789 .35066 L
.63333 .28928 L
.63878 .21939 L
.64422 .17772 L
.64966 .16792 L
.6551 .12283 L
.66054 .06469 L
.66599 .04753 L
.67143 .13598 L
.67687 .29906 L
.68231 .46121 L
.68776 .43464 L
.6932 .35962 L
.69864 .25519 L
.70408 .16139 L
.70952 .08117 L
.71497 .05366 L
.72041 .04783 L
.72585 .02693 L
.73129 .043 L
.73673 .12371 L
.74218 .19912 L
.74762 .2284 L
.75306 .2404 L
.7585 .23654 L
.76395 .191 L
.76939 .11054 L
.77483 .05858 L
.78027 .03631 L
.78571 .02839 L
.79116 .04692 L
.7966 .14217 L
.80204 .26258 L
.80748 .31302 L
.81293 .29224 L
.81837 .23537 L
.82381 .16182 L
.82925 .11295 L
.83469 .09646 L
Mistroke
.84014 .06418 L
.84558 .04166 L
.85102 .02327 L
.85646 .03569 L
.8619 .0956 L
.86735 .16831 L
.87279 .22266 L
.87823 .21968 L
.88367 .2207 L
.88912 .1949 L
.89456 .15696 L
.9 .08549 L
.90544 .03591 L
.91088 .0199 L
.91633 .01715 L
.92177 .05941 L
.92721 .15874 L
.93265 .24696 L
.9381 .34722 L
.94354 .31365 L
.94898 .23294 L
.95442 .15195 L
.95986 .10088 L
.96531 .05999 L
.97075 .03859 L
.97619 .06438 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.938},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`004@3oool3000000@0oooo00<000000?ooo`3oool0
0P3oool3000000@0oooo0P00000=0?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo0080oooo0`00000>0?ooo`<000000`3oool3000000@0oooo0P0000040?ooo`800000
3@3oool3000000<0oooo0`0000020?ooo`D000000P3oool3000000d0oooo0`0000030?ooo`<00000
0`3oool3000000@0oooo0P00000=0?ooo`<000000`3oool3000000@0oooo00<000000?ooo`3oool0
0P3oool3000000h0oooo0`0000030?ooo`8000001@3oool2000000@0oooo0P00000=0?ooo`<00000
0`3oool2000000<0oooo1@0000020?ooo`<000000`3oool00180oooo00<000000?ooo`3oool00`3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0303oool01@000000oooo0?ooo`3oool0
000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo00/0oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo000000030?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool02`3oool01@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0
oooo000000030?ooo`050000003oool0oooo0?ooo`0000003P3oool00`000000oooo0?ooo`040?oo
o`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool000000080oooo
00<000000?ooo`0000000`3oool100000040oooo0@3oool00180oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`0<0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool02`3oool0
1@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000
003oool0oooo00/0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00<0
oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00D0oooo
00D000000?ooo`3oool0oooo000000070?ooo`4000000@3oool10?ooo`004P3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool00P3oool3000000<0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000=0?ooo`030000003oool0
oooo0080oooo0`0000050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02`3oool0
0`000000oooo0?ooo`020?ooo`<000001P3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0080oooo100000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000003@3oool00`000000oooo0?ooo`020?ooo`@0
0000103oool00`000000oooo0?ooo`040?ooo`4000000@3oool10?ooo`004P3oool00`000000oooo
0?ooo`050?ooo`030000003oool0000000<000000`3oool010000000oooo0?ooo`00000=0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool00`3oool00`000000oooo00000003000000l0
oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo0?ooo`000000
0`3oool00`000000oooo000000030?ooo`030000003oool0000000<000003P3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`0000030?ooo`040000003oool0oooo0000
00d0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`0000000`00000?0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool02`3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`3oool00`000000oooo000000030000
00<0oooo000A0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3oool0
10000000oooo0?ooo`00000<0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`00
00000`3oool00`000000oooo0000000A0?ooo`8000000`3oool01@000000oooo0?ooo`3oool00000
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000<0?ooo`8000000`3o
ool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool00`000000oooo0000000@0?ooo`80
00000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3oool010000000oooo0?ooo`00
000<0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool00`000000
oooo0000000A0?ooo`8000000`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000<0?ooo`8000000`3oool01`000000oooo0?oo
o`3oool000000?ooo`0000000`3oool00`000000oooo000000060?ooo`004P3oool010000000oooo
0?ooo`3oool5000000030?ooo`000000000000<000000`3oool2000000h0oooo00@000000?ooo`3o
ool0oooo1@0000000`3oool0000000000003000000030?ooo`000000000000<000003P3oool00`00
0000oooo0?ooo`020?ooo`<00000103oool2000000@0oooo0P00000>0?ooo`030000003oool0oooo
0080oooo0`0000030?ooo`<000000P3oool5000000d0oooo00<000000?ooo`3oool00P3oool30000
0080oooo1@0000030?ooo`8000003P3oool00`000000oooo0?ooo`020?ooo`<000000P3oool50000
00030?ooo`000000000000<000003P3oool00`000000oooo0?ooo`020?ooo`<00000103oool20000
00@0oooo0P00000>0?ooo`030000003oool0oooo0080oooo0`0000030?ooo`<000000P3oool50000
0080oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo000E0?oo
ood000001`3oool001D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`050?ooo`00
5@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`3i0?ooo`030000003o
ool0oooo00D0oooo000E0?ooo`800000E`3oool20?l00:00oooo0P0000070?ooo`005@3oool00`00
0000oooo0?ooo`1F0?ooo`030?l0003oool0o`0008T0oooo0P3o000E0?ooo`030000003oool0oooo
00D0oooo00070?ooo`<00000103oool2000000D0oooo00<000000?ooo`3oool0E@3oool0103o0000
oooo0?ooo`3o000?0?ooo`030?l0003oool0oooo06P0oooo00<0o`000?ooo`3oool0303oool20?l0
01D0oooo00<000000?ooo`3oool01@3oool000H0oooo00D000000?ooo`3oool0oooo000000020?oo
o`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0AP3oool00`3o0000oooo0?ooo`0<
0?ooo`050?l0003oool0oooo0?ooo`3o00003@3oool20?l004/0oooo00<0o`000?ooo`3oool0303o
ool00`3o0000oooo0?ooo`0=0?ooo`030?l0003oool0oooo00`0oooo0P3o000E0?ooo`030000003o
ool0oooo00D0oooo0005000000D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?oo
o`020?ooo`800000A`3oool00`3o0000oooo0?ooo`0<0?ooo`050?l0003oool0oooo0?ooo`3o0000
3@3oool20?l002`0oooo00<0o`000?ooo`3oool0703oool00`3o0000oooo0?ooo`0;0?ooo`80o`00
3`3oool20?l000`0oooo00@0o`000?ooo`3oool0o`004P3oool3000000L0oooo000:0?ooo`040000
003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`150?ooo`03
0?l0003oool0o`0000`0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`0:0?ooo`04
0?l0003oool0oooo0?l002X0oooo0P3o000M0?ooo`80o`00303oool00`3o0000oooo0?l0000>0?oo
o`030?l0003oool0o`0000`0oooo00@0o`000?ooo`3oool0o`00503oool00`000000oooo0?ooo`05
0?ooo`001P3oool4000000<0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0V
0?ooo`030?l0003oool0oooo01/0oooo00@0o`000?ooo`3oool0o`00303oool00`3o0000oooo0?oo
o`020?ooo`030?l0003oool0oooo00T0oooo00D0o`000?ooo`3oool0oooo0?l0000Z0?ooo`80o`00
7@3oool00`3o0000oooo0?l0000;0?ooo`040?l0003oool0oooo0?l000d0oooo00<0o`000?ooo`3o
0000303oool0103o0000oooo0?ooo`3o000<0?ooo`030?l0003oool0oooo00D0oooo00<000000?oo
o`3oool01@3oool000H0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo00/0oooo00<0o`000?ooo`3oool0603oool00`3o0000oooo0?ooo`0K0?oo
o`040?l0003oool0oooo0?l000`0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`08
0?ooo`050?l0003oool0oooo0?ooo`3o0000303oool00`3o0000oooo0?ooo`0K0?ooo`80o`007@3o
ool00`3o0000oooo0?l0000;0?ooo`040?l0003oool0oooo0?l000d0oooo00<0o`000?ooo`3o0000
303oool0103o0000oooo0?ooo`3o000<0?ooo`030?l0003oool0oooo00D0oooo00<000000?ooo`3o
ool01@3oool000H0oooo1@0000030?ooo`8000001@3oool00`000000oooo0?ooo`0;0?ooo`030?l0
003oool0oooo01P0oooo00<0o`000?ooo`3oool02P3oool00`3o0000oooo0?ooo`0>0?ooo`050?l0
003oool0oooo0?ooo`3o00002P3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00P0
oooo00D0o`000?ooo`3oool0oooo0?l0000<0?ooo`030?l0003oool0oooo01/0oooo0P3o000>0?oo
o`030?l0003oool0oooo00/0oooo00@0o`000?ooo`3oool0o`002`3oool0103o0000oooo0?ooo`3o
000=0?ooo`030?l0003oool0o`0000`0oooo00@0o`000?ooo`3oool0o`00303oool20?l000H0oooo
00<000000?ooo`3oool01@3oool001D0oooo0P00000<0?ooo`030?l0003oool0oooo01P0oooo00<0
o`000?ooo`3oool02P3oool00`3o0000oooo0?ooo`0>0?ooo`050?l0003oool0oooo0?ooo`3o0000
2P3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00P0oooo00<0o`000?ooo`3oool0
0P3oool00`3o0000oooo0?ooo`090?ooo`030?l0003oool0oooo01/0oooo00<0o`000?ooo`3o0000
3@3oool00`3o0000oooo0?ooo`0;0?ooo`040?l0003oool0oooo0?l000X0oooo00D0o`000?ooo`3o
ool0oooo0?l0000<0?ooo`040?l0003oool0oooo0?l000/0oooo00<0o`000?ooo`3oool00P3oool0
0`3o0000oooo0?ooo`080?ooo`030?l0003oool0o`0000D0oooo0P0000070?ooo`005@3oool00`00
0000oooo0?ooo`0:0?ooo`030?l0003oool0o`0001T0oooo00<0o`000?ooo`3oool02P3oool00`3o
0000oooo0?ooo`0=0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool0203oool00`3o
0000oooo0?ooo`020000o`80oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?ooo`030?oo
o`030?l0003oool0oooo00T0oooo00<0o`000?ooo`3oool02`3oool00`3o0000oooo0?ooo`0=0?oo
o`030?l0003oool0o`0000d0oooo00<0o`000?ooo`3oool02P3oool01@3o0000oooo0?ooo`3oool0
o`0000X0oooo00D0o`000?ooo`3oool0oooo0?l0000<0?ooo`050?l0003oool0oooo0?ooo`3o0000
2P3oool01P3o0000oooo0?ooo`000?l0oooo0?l000X0oooo00<0o`000?ooo`3o00001P3oool00`00
0000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0:0?ooo`030?l0003oool0o`0001T0
oooo0P3o000:0?ooo`80o`003`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00L0
oooo00L0o`000?ooo`3oool0oooo0000o`3oool0003o0080oooo00<0o`000?ooo`3oool01P3oool0
0`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00T0oooo0P3o000<0?ooo`030?l0003oool0
oooo00d0oooo00<0o`000?ooo`3o0000303oool20?l000`0oooo00D0o`000?ooo`3oool0oooo0?l0
000:0?ooo`050?l0003oool0oooo0?ooo`3o0000303oool01@3o0000oooo0?ooo`3oool0o`0000X0
oooo00H0o`000?ooo`000?l0003o0?ooo`3o000:0?ooo`040?l0003oool0oooo0?l000D0oooo00<0
00000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool02P3oool00`3o0000oooo0?l0000=
0?ooo`030?l0003oool0oooo00T0oooo0P3o000:0?ooo`80o`003`3oool00`3o0000oooo0?ooo`02
0?ooo`030?l0003oool0oooo00L0oooo00@0o`000?ooo`3oool0003o0P3oool010000?l0oooo0?oo
o`3o00080?ooo`030?l0003oool0oooo0080003o00<0oooo0?l0003oool02@3oool00`3o0000oooo
0?l0000<0?ooo`030?l0003oool0oooo00`0oooo00@0o`000?ooo`3oool0o`00303oool20?l000`0
oooo00D0o`000?ooo`3oool0oooo0?l0000:0?ooo`050?l0003oool0oooo0?ooo`3o00002`3oool0
1P3o0000oooo0?ooo`000?l0oooo0?l000X0oooo00H0o`000?ooo`000?l0003o0?ooo`3o000:0?oo
o`040?l0003oool0oooo0?l000D0oooo00<000000?ooo`3oool01@3oool001D0oooo0P00000;0?oo
o`030?l0003oool0o`0000d0oooo00<0o`000?ooo`3oool02@3oool20?l000X0oooo0P3o000?0?oo
o`040?l0003oool0oooo0000o`80oooo00<0o`000?ooo`3oool01P3oool0103o0000oooo0?ooo`00
0?l30?ooo`030000o`3oool0o`0000P0oooo00<0o`000?ooo`3oool00P000?l00`3oool0o`000?oo
o`090?ooo`030?l0003oool0o`0000/0oooo00<0o`000?ooo`3o00003@3oool0103o0000oooo0000
o`3o000<0?ooo`80o`002`3oool01P3o0000oooo0?ooo`3oool0003o0?l000X0oooo00D0o`000?oo
o`3oool0003o0?l0000;0?ooo`060?l0003oool0oooo0000o`3oool0o`002P3oool01P3o0000oooo
0000o`000?l0oooo0?l000X0oooo00<0o`000?ooo`3oool01@3oool2000000L0oooo000E0?ooo`03
0000003oool0oooo00X0oooo00<0o`000?ooo`3o00003@3oool00`3o0000oooo0?ooo`080?ooo`03
0?l0003oool0o`0000X0oooo0P3o000?0?ooo`040?l0003oool0oooo0000o`80oooo00<0o`000?oo
o`3oool01P3oool00`3o0000oooo0000o`040?ooo`040000o`3oool0oooo0?l000L0oooo00D0o`00
0?ooo`000?l0oooo0000o`020?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3o00002`3o
ool00`3o0000oooo0?l0000=0?ooo`040?l0003oool0003o0?l000`0oooo0P3o000;0?ooo`060?l0
003oool0oooo0?ooo`000?l0o`002P3oool01@3o0000oooo0000o`000?l0o`0000/0oooo00<0o`00
0?ooo`3oool00P000?l00`3o0000oooo0?ooo`080?ooo`060?l000000?l0oooo0?ooo`000?l0o`00
2P3oool00`3o0000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003o
ool0oooo00X0oooo00<0o`000?ooo`3o0000303oool20?l000X0oooo00<0o`000?ooo`3o00002P3o
ool20?l000l0oooo00L0o`000?ooo`000?l0oooo0000o`3oool0o`0000P0oooo00<0o`000?ooo`00
0?l0103oool010000?l0oooo0?ooo`3o00070?ooo`030?l0003oool0003o0080oooo00<0003o0?oo
o`3o00002@3oool00`3o0000oooo0?l0000;0?ooo`030?l0003oool0o`0000d0oooo00@0o`000000
o`000?l0o`00303oool00`3o0000oooo0?l0000:0?ooo`030?l0003oool0oooo0080003o00<0o`00
0?ooo`3oool01`3oool01P3o0000oooo0000o`3oool0003o0?l000/0oooo00H0o`000?ooo`000?l0
oooo0000o`3o000:0?ooo`060?l000000?l0oooo0?ooo`000?l0o`002@3oool00`3o0000oooo0?oo
o`070?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00T0oooo00D0o`00
0?ooo`000?l0oooo0?l0000;0?ooo`80o`002P3oool00`3o0000003o0?l000090?ooo`030?l0003o
ool0o`0000l0oooo00L0o`000000o`3oool0oooo0000o`3oool0o`0000P0oooo00<0o`000?ooo`00
0?l0103oool010000?l0oooo0?ooo`3o00070?ooo`030?l000000?l0oooo0080oooo00<0003o0?oo
o`3o00002@3oool00`3o0000003o0?l0000;0?ooo`030?l0003oool0o`0000d0oooo00@0o`000000
o`000?l0o`00303oool00`3o0000oooo0?l000090?ooo`070?l0003oool0oooo0?ooo`000?l0oooo
0?l000090?ooo`030?l0003oool0003o0080oooo00<0o`000?ooo`3oool02@3oool01P3o0000oooo
0000o`3oool0003o0?l000T0oooo00<0o`000?ooo`000?l00P3oool00`000?l0o`000?ooo`080?oo
o`030?l0003oool0003o00L0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3o
ool02@3oool01@3o0000oooo0000o`3oool0o`0000/0oooo0P3o000:0?ooo`030?l000000?l0o`00
00T0oooo00@0o`000?ooo`3oool0o`003P3oool01`3o0000003o0?ooo`3oool0003o0?ooo`3o0000
203oool00`3o0000003o0?ooo`050?ooo`030000o`3oool0o`0000L0oooo00<0o`000000o`3oool0
0P3oool00`000?l0oooo0?l000090?ooo`030?l000000?l0o`0000/0oooo00<0o`000?ooo`3o0000
3@3oool01@3o0000003o0000o`3oool0o`0000/0oooo00<0o`000?ooo`3o00002@3oool01`3o0000
oooo0?ooo`3oool0003o0?ooo`3o00002@3oool00`3o0000oooo0000o`020?ooo`030?l0003oool0
oooo00P0oooo00P0o`000?ooo`3oool0003o0?ooo`000?l0oooo0?l000P0oooo00<0o`000?ooo`00
0?l00P3oool00`000?l0o`000?ooo`080?ooo`030?l0003oool0003o00L0oooo00<000000?ooo`3o
ool01@3oool001D0oooo0P00000:0?ooo`050?l0003oool0003o0?ooo`3o00002`3oool20?l000X0
oooo00<0o`000000o`3o00002@3oool0103o0000oooo0000o`3o000=0?ooo`030?l0003oool0003o
00<0oooo00<0003o0?l0003oool01P3oool00`3o0000oooo0000o`060?ooo`030000o`3oool0o`00
00H0oooo00<0o`000?ooo`000?l00`3oool00`000?l0oooo0?l000090?ooo`030?l000000?l0o`00
00X0oooo00@0o`000?ooo`3oool0o`003@3oool01@3o0000003o0?ooo`000?l0o`0000/0oooo00<0
o`000000o`3o00002@3oool0103o0000oooo0?ooo`000?l20?ooo`030000o`3o0000oooo00L0oooo
00<0o`000?ooo`000?l00P3oool00`3o0000oooo0?ooo`080?ooo`030?l0003oool0003o0080oooo
00<0003o0?ooo`3o0000203oool00`3o0000oooo0000o`020?ooo`030000o`3o0000oooo00P0oooo
00<0o`000?ooo`000?l01P3oool2000000L0oooo000E0?ooo`030000003oool0oooo00T0oooo00D0
o`000?ooo`000?l0003o0?l0000;0?ooo`80o`002P3oool0103o0000003o0?ooo`3o00080?ooo`04
0?l0003oool0003o0?l000d0oooo00<0o`000?ooo`000?l00`3oool00`000?l0o`000?ooo`060?oo
o`030?l0003oool0003o0080oooo0P3o00020?ooo`030000o`3oool0o`0000H0oooo00<0o`000?oo
o`000?l0103oool00`000?l0o`000?ooo`080?ooo`030?l000000?l0o`0000X0oooo00@0o`000?oo
o`000?l0o`003@3oool01@3o0000003o0?ooo`000?l0o`0000/0oooo00<0o`000000o`3o00002@3o
ool00`3o0000oooo0000o`030?ooo`030000o`3o0000oooo00L0oooo00<0o`000000o`3oool00P3o
ool00`3o0000oooo0?ooo`080?ooo`030?l0003oool0003o0080oooo00<0003o0?ooo`3o0000203o
ool00`3o0000003o0?ooo`030?ooo`030?l0003oool0oooo00L0oooo00@0o`000000o`3oool0003o
1P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`090?ooo`050?l00000
0?l0oooo0000o`3o00002`3oool20?l000X0oooo00@0o`000000o`3oool0o`00203oool0103o0000
oooo0000o`3o000=0?ooo`030?l000000?l0oooo00<0oooo00<0003o0?l0003oool01P3oool00`3o
0000003o0?ooo`020?ooo`070?l0003oool0o`000?ooo`000?l0oooo0?l000060?ooo`030?l00000
0?l0oooo00@0oooo00<0003o0?l0003oool01`3oool0103o0000oooo0000o`3o000:0?ooo`040?l0
003oool0003o0?l000d0oooo00D0o`000000o`3oool0003o0?l0000;0?ooo`030?l000000?l0o`00
00T0oooo00<0o`000?ooo`000?l00`3oool00`000?l0o`000?ooo`070?ooo`030?l000000?l0oooo
0080oooo00<0o`000?ooo`3oool0203oool00`3o0000oooo0000o`030?ooo`030000o`3o0000oooo
00L0oooo00L0o`000000o`3oool0oooo0?l0003oool0o`0000P0oooo00D0o`000?ooo`000?l0oooo
0000o`060?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00T0oooo00D0
o`000000o`3oool0003o0?l0000:0?ooo`030?l0003oool0o`0000X0oooo00@0o`000000o`000?l0
o`00203oool0103o0000003o0000o`3o000=0?ooo`030?l000000?l0oooo00<0oooo00<0003o0?l0
003oool01P3oool01@3o0000003o0?ooo`3oool0o`000080oooo00D0o`000?ooo`3oool0003o0?l0
00060?ooo`030?l000000?l0oooo0080oooo00@0o`000?ooo`000?l0o`00203oool0103o0000003o
0?ooo`3o000:0?ooo`040?l0003oool0003o0?l000d0oooo00D0o`000000o`3oool0003o0?l0000:
0?ooo`040?l000000?l0003o0?l000T0oooo00<0o`000?ooo`000?l00`3oool00`000?l0o`000?oo
o`070?ooo`030?l000000?l0oooo0080oooo00<0003o0?l0003oool0203oool00`3o0000003o0?oo
o`030?ooo`030000o`3o0000oooo00L0oooo00<0o`000000o`3oool00P3o00000`3oool0o`000?oo
o`070?ooo`050?l0003oool0003o0?ooo`000?l01P3oool00`000000oooo0?ooo`050?ooo`005@3o
ool2000000X0oooo00D0o`000000o`3oool0003o0?l0000:0?ooo`030?l0003oool0o`0000X0oooo
00@0o`000000o`000?l0o`00203oool0103o0000003o0000o`3o000=0?ooo`030?l000000?l0oooo
00<0oooo00<0003o0?ooo`3o00001P3oool01@3o0000003o0?ooo`3oool0o`000080oooo00D0o`00
0?ooo`3oool0003o0?l000060?ooo`040?l000000?l0oooo0?ooo`80o`0000<0oooo0000o`3o0000
203oool0103o0000003o0?ooo`3o000:0?ooo`040?l000000?l0oooo0?l000d0oooo00D0o`000?oo
o`3oool0003o0?l0000:0?ooo`040?l000000?l0003o0?l000T0oooo00<0o`000000o`3oool00P3o
ool00`3o0000003o0?l000070?ooo`030?l0003oool0003o00<0oooo00<0003o0?l0003oool0203o
ool0203o0000003o0?ooo`3oool0o`000?ooo`000?l0o`00203oool00`3o0000003o0?ooo`020?l0
00030?ooo`3o0000oooo00L0oooo00D0o`000?ooo`000?l0oooo0000o`050?ooo`8000001`3oool0
01D0oooo00<000000?ooo`3oool0203oool01P3o0000oooo0000o`3oool0003o0?l000X0oooo00@0
o`000?ooo`000?l0o`002@3oool0103o0000003o0000o`3o00080?ooo`040?l000000?l0003o0?l0
00d0oooo00D0o`000000o`3oool0oooo0?l000020?ooo`030000o`3o0000oooo00D0oooo00D0o`00
0000o`3oool0oooo0?l000030?ooo`050?l0003oool0003o0?ooo`3o00001@3oool0103o0000003o
0?ooo`3oool20?l000030?ooo`000?l0o`0000P0oooo00@0o`000000o`3oool0o`002P3oool0103o
0000003o0?ooo`3o000<0?ooo`060?l000000?l0oooo0?l000000?l0o`002P3oool0103o0000003o
0000o`3o00090?ooo`030?l000000?l0oooo0080oooo00<0o`000000o`3o00001`3oool00`3o0000
oooo0000o`020?ooo`030?l000000?l0o`0000T0oooo00P0o`000000o`3oool0oooo0?l0003oool0
003o0?l000P0oooo00<0o`000000o`3oool00P3o00000`3oool0o`000?ooo`070?ooo`030?l0003o
ool0003o0080oooo00<0003o0?ooo`3oool00`3oool00`000000oooo0?ooo`050?ooo`001P3oool5
00000080oooo0`0000050?ooo`030000003oool0oooo00P0oooo00L0o`000?ooo`000?l0oooo0000
o`3oool0o`0000T0oooo00@0o`000?ooo`000?l0o`002@3oool0103o0000oooo0000o`3o00080?oo
o`040?l000000?l0003o0?l000d0oooo00<0o`000000o`3oool00P3o00020?ooo`030000o`3o0000
oooo00D0oooo00@0o`000000o`3oool0o`00103oool01@3o0000oooo0?ooo`000?l0o`0000@0oooo
00D0o`000?ooo`000?l0oooo0?l000020?ooo`040?l0003oool0003o0?l000L0oooo00D0o`000000
o`3oool0003o0?l000090?ooo`050?l000000?l0oooo0000o`3o00002`3oool01P3o0000003o0?oo
o`3o0000003o0?l000X0oooo00@0o`000000o`3oool0o`002@3oool0103o0000003o0?ooo`3oool2
0?l000030000o`3o0000oooo00H0oooo00@0o`000?ooo`000?l0oooo0P3o00000`000?l0o`000?oo
o`070?ooo`030?l0003oool0003o0080oooo0P3o00000`000?l0o`000?ooo`070?ooo`030?l00000
0?l0o`000080oooo00<0o`000000o`3o00001`3oool00`3o0000003o0?ooo`020?ooo`030000o`3o
ool0oooo00<0oooo00<000000?ooo`3oool01@3oool000L0oooo00H000000?ooo`3oool000000?oo
o`0000030?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0203oool01`3o0000oooo
0000o`3oool0003o0?ooo`3o00002@3oool0103o0000003o0000o`3o00090?ooo`040?l0003oool0
003o0?l000P0oooo00@0o`000000o`000?l0o`00303oool0103o0000oooo0000o`3o00020?ooo`04
0?l0003oool0003o0?l000H0oooo00@0o`000000o`3oool0o`00103oool01@3o0000oooo0?ooo`00
0?l0o`0000@0oooo00D0o`000?ooo`000?l0oooo0?l000020?ooo`040?l0003oool0003o0?l000L0
oooo00D0o`000000o`3oool0003o0?l000090?ooo`050?l000000?l0oooo0000o`3o00002`3oool0
1P3o0000003o0?l0003o0000003o0?l000X0oooo00@0o`000000o`3oool0o`002@3oool01P3o0000
oooo0?ooo`3oool0o`000?ooo`80o`001`3oool0203o0000003o0?ooo`3o0000oooo0?l000000?l0
o`00203oool02@3o0000oooo0000o`3oool0o`000?ooo`3o0000003o0?l000080?ooo`030?l0003o
ool0o`000080oooo00<0o`000000o`3o00001`3oool00`3o0000003o0?ooo`080?ooo`030000003o
ool0oooo00D0oooo0005000000<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00P0oooo00L0o`000000o`3oool0o`000?ooo`000?l0o`0000T0oooo
00@0o`000000o`000?l0o`002@3oool20?l000030000o`3o0000oooo00L0oooo00@0o`000?ooo`00
0?l0o`00303oool0103o0000oooo0000o`3o00020?ooo`040?l0003oool0003o0?l000H0oooo00@0
o`000000o`3oool0o`00103oool01@3o0000oooo0?ooo`000?l0o`0000@0oooo00@0o`000?ooo`00
0?l0o`000`3oool0103o0000oooo0000o`3o00070?ooo`050?l000000?l0o`000000o`3o00002@3o
ool01@3o0000003o0?ooo`000?l0o`0000/0oooo00H0o`000000o`3o0000o`000?ooo`3o000:0?oo
o`050?l000000?l0oooo0000o`3o0000203oool01P3o0000oooo0?ooo`3oool0o`000?ooo`80o`00
1`3oool0103o0000003o0?ooo`3o00020?ooo`80o`00203oool02@3o0000oooo0000o`3oool0o`00
0?ooo`3o0000003o0?l000080?ooo`030?l0003oool0o`000080oooo00<0o`000000o`3o00001`3o
ool0103o0000003o0?ooo`3o00070?ooo`030000003oool0oooo00D0oooo00090?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00P3oool2000000T0oooo00L0o`000000o`3oool0o`00
0?ooo`000?l0o`0000T0oooo00@0o`000000o`000?l0o`002@3oool20?l000030000o`3o0000oooo
00H0oooo00D0o`000000o`3oool0oooo0?l0000<0?ooo`040?l000000?l0oooo0?l00080oooo00@0
o`000?ooo`000?l0o`001P3oool00`3o0000003o0?l000060?ooo`040?l0003oool0003o0?l000<0
oooo00D0o`000?ooo`000?l0oooo0?l000030?ooo`040?l0003oool0003o0?l000L0oooo00D0o`00
0000o`3o0000003o0?l000080?ooo`060?l000000?l0oooo0?ooo`000?l0o`002`3oool01P3o0000
003o0?l0003o0000oooo0?l000X0oooo00D0o`000000o`3oool0003o0?l000080?ooo`040?l0003o
ool0oooo0?l00080oooo0P3o00070?ooo`040?l000000?l0oooo0?l00080oooo0P3o00080?ooo`09
0?l000000?l0oooo0?ooo`3o0000oooo0?l0003oool0o`0000P0oooo00<0o`000?ooo`3o00000P3o
ool00`3o0000003o0?l000070?ooo`040?l000000?l0oooo0?l000D0oooo0`0000070?ooo`001P3o
ool01P000000oooo0?ooo`3oool000000?ooo`@000001@3oool00`000000oooo0?ooo`080?ooo`07
0?l000000?l0oooo0?l0003oool0003o0?l000080?ooo`050?l0003oool0003o0000o`3o00002@3o
ool20?l000030000o`3o0000oooo00H0oooo00<0o`000000o`3oool00P3o000<0?ooo`040?l00000
0?l0oooo0?l000<0oooo00<0o`000000o`3o00001@3oool0103o0000003o0?ooo`3o00060?ooo`04
0?l0003oool0003o0?l000<0oooo00D0o`000?ooo`000?l0oooo0?l000030?ooo`040?l0003oool0
003o0?l000L0oooo00D0o`000000o`3o0000003o0?l000080?ooo`060?l000000?l0oooo0?ooo`00
0?l0o`002`3oool0103o0000003o0?l0003oool20?l000X0oooo00D0o`000000o`3o0000003o0?l0
00070?ooo`050?l000000?l0oooo0?ooo`3o00000P3oool20?l000L0oooo00<0o`000000o`3o0000
0`3oool20?l000P0oooo00@0o`000000o`3oool0o`000P3oool00`3o0000oooo0?l000070?ooo`04
0?l000000?l0oooo0?l00080oooo00<0o`000000o`3o00001`3oool0103o0000003o0?ooo`3o0007
0?ooo`030000003oool0oooo00D0oooo00060?ooo`070000003oool0oooo0?ooo`000000oooo0000
00080?ooo`030000003oool0oooo00P0oooo00L0o`000000o`3o0000oooo0?l000000?l0o`0000P0
oooo00D0o`000?ooo`000?l0003o0?l000080?ooo`050?l000000?l0o`000?ooo`3o00001`3oool0
0`3o0000003o0?ooo`020?l000`0oooo00<0o`000000o`3o0000103oool00`3o0000003o0?l00005
0?ooo`040?l000000?l0oooo0?l000H0oooo00@0o`000?ooo`000?l0o`000`3oool01@3o0000oooo
0000o`3oool0o`0000@0oooo00<0o`000000o`3o00001`3oool01@3o0000oooo0?l000000?l0o`00
00P0oooo00H0o`000000o`3oool0o`000000o`3o000;0?ooo`040?l000000?l0o`000?ooo`80o`00
2P3oool01@3o0000003o0?l000000?l0o`0000L0oooo00@0o`000000o`3oool0o`000`3oool20?l0
00L0oooo00<0o`000000o`3o00000`3oool20?l000L0oooo00D0o`000?ooo`000?l0oooo0?l00002
0?ooo`030?l0003oool0o`0000L0oooo00<0o`000000o`3o0000103oool20?l000H0oooo00H0o`00
0000o`3oool0o`000?ooo`3o00060?ooo`030000003oool0oooo00D0oooo00070?ooo`<000000P3o
ool5000000@0oooo00<000000?ooo`3oool0203oool01`3o0000003o0?l0003oool0o`000000o`3o
0000203oool01@3o0000oooo0000o`000?l0o`0000P0oooo00D0o`000000o`3o0000oooo0?l00007
0?ooo`030?l000000?l0oooo0080o`00303oool00`3o0000003o0?l000040?ooo`030?l000000?l0
o`0000D0oooo00<0o`000000o`3o0000203oool00`3o0000003o0?l000030?ooo`040?l0003oool0
003o0?l000D0oooo00<0o`000000o`3o00001`3oool00`3o0000oooo0?l000020?l000P0oooo00H0
o`000000o`3oool0o`000000o`3o000;0?ooo`040?l000000?l0o`000?ooo`80o`002P3oool01@3o
0000oooo0?l000000?l0o`0000L0oooo00@0o`000000o`3oool0o`000`3oool20?l000L0oooo00<0
o`000000o`3o00000`3oool20?l000L0oooo00D0o`000?ooo`000?l0oooo0?l000030?ooo`030?l0
00000?l0o`0000H0oooo00<0o`000000o`3o0000103oool20?l000H0oooo00H0o`000000o`3oool0
o`000?ooo`3o00060?ooo`030000003oool0oooo00D0oooo000E0?ooo`8000002@3oool01`3o0000
003o0?l0003oool0o`000000o`3o0000203oool01@3o0000003o0?ooo`000?l0o`0000P0oooo00<0
o`000000o`3o00000P3o00070?ooo`030?l000000?l0o`000080o`00303oool00`3o0000003o0?l0
00040?ooo`030?l000000?l0o`0000D0oooo00<0o`000000o`3o0000203oool00`3o0000003o0?l0
00030?ooo`040?l0003oool0003o0?l000D0oooo00<0o`000000o`3o00001`3oool20?l000030?oo
o`3o0000o`0000P0oooo00H0o`000000o`3oool0o`000000o`3o000:0?ooo`050?l0003oool0003o
0?l0003oool00P3o00090?ooo`060?l000000?l0o`000?l000000?l0o`001`3oool0103o0000003o
0?ooo`3o00030?ooo`80o`001`3oool00`3o0000003o0?l000030?ooo`80o`001`3oool0103o0000
oooo0000o`3o00040?ooo`030?l000000?l0o`0000H0oooo00<0o`000000o`3o0000103oool20?l0
00H0oooo00H0o`000000o`3oool0o`000?ooo`3o00050?ooo`8000001`3oool001D0oooo00<00000
0?ooo`3oool0203oool01`3o0000003o0?l0003oool0o`000000o`3o0000203oool00`3o0000003o
0?ooo`020?l000P0oooo00<0o`000000o`3o00000P3o00070?ooo`030?l000000?l0o`000080o`00
2`3oool0103o0000oooo0000o`3o00050?ooo`80o`001@3oool00`3o0000003o0?l000080?ooo`03
0?l000000?l0o`0000<0oooo00@0o`000?ooo`000?l0o`001@3oool00`3o0000003o0?l000070?oo
o`80o`0000<0oooo0?l0003o0000203oool0103o0000003o0?l0003oool20?l000X0oooo00<0o`00
0?ooo`3o00000P3oool20?l000T0oooo00H0o`000000o`3o0000o`000000o`3o00070?ooo`030?l0
00000?l0o`0000@0oooo0P3o00070?ooo`030?l0003oool0o`0000<0oooo0P3o00070?ooo`040?l0
003oool0003o0?l000@0oooo00<0o`000000o`3o00001P3oool00`3o0000003o0?l000040?ooo`80
o`001P3oool01P3o0000003o0?ooo`3o0000oooo0?l000H0oooo00<000000?ooo`3oool01@3oool0
01D0oooo00<000000?ooo`3oool01`3oool0203o0000003o0?ooo`3o0000oooo0?l000000?l0o`00
203oool00`3o0000003o0?ooo`020?l000P0oooo00<0o`000000o`3o00000P3o00070?ooo`030?l0
00000?l0o`000080o`002`3oool0103o0000oooo0000o`3o00050?ooo`80o`001@3oool00`3o0000
003o0?l000090?ooo`090?l000000?l0o`000?ooo`3o0000oooo0000o`3oool0o`0000D0oooo00<0
o`000000o`3o00001`3oool20?l000030?ooo`3o0000o`0000P0oooo00@0o`000000o`3o0000oooo
0P3o000:0?ooo`030?l000000?l0o`000080oooo0P3o00090?ooo`060?l000000?l0o`000?l00000
0?l0o`001`3oool00`3o0000003o0?l000040?ooo`030?l000000?l0o`0000H0oooo00<0o`000?oo
o`3o00000`3oool20?l000L0oooo00@0o`000000o`3oool0o`00103oool00`3o0000003o0?l00006
0?ooo`030?l000000?l0o`0000@0oooo0P3o00060?ooo`060?l000000?l0oooo0?l0003oool0o`00
1P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`070?ooo`080?l00000
0?l0oooo0?l0003oool0o`000?ooo`3o00080?ooo`030?l000000?l0oooo0080o`00203oool20?l0
00030?ooo`3o0000o`0000L0oooo00<0o`000000o`3o00000P3o000;0?ooo`040?l000000?l0oooo
0?l000D0oooo0P3o00050?ooo`030?l000000?l0o`0000T0oooo00T0o`000000o`3o0000oooo0?l0
003oool0003o0?ooo`3o00001P3oool20?l000H0oooo00@0o`000000o`3o0000oooo0P3o00080?oo
o`040?l000000?l0o`000?ooo`80o`002P3oool00`3o0000003o0?l000020?ooo`80o`002@3oool0
103o0000003o0?l0003oool20?l000L0oooo00<0o`000000o`3o0000103oool00`3o0000003o0?l0
00060?ooo`80o`00103oool20?l000L0oooo00@0o`000000o`3oool0o`00103oool00`3o0000003o
0?l000060?ooo`030?l000000?l0o`0000@0oooo0P3o00060?ooo`030?l000000?l0o`0000<0oooo
00<0o`000?ooo`3oool00`3oool00`000000oooo0?ooo`050?ooo`005@3oool2000000P0oooo00@0
o`000000o`3oool0o`000P3oool00`3o0000003o0?l000070?ooo`030?l000000?l0o`000080o`00
203oool20?l000030?ooo`3o0000o`0000L0oooo00<0o`000000o`3o00000P3o000;0?ooo`040?l0
00000?l0oooo0?l000D0oooo00<0o`000000o`3o00000`3oool0103o0000oooo0000o`3o00090?oo
o`090?l000000?l0o`000?ooo`3o0000oooo0000o`3oool0o`0000H0oooo00<0o`000000o`3o0000
1@3oool0103o0000003o0?l0003oool20?l000P0oooo00@0o`000000o`3o0000oooo0P3o000:0?oo
o`030?l000000?l0o`000080oooo0P3o00090?ooo`040?l000000?l0o`000?ooo`80o`001`3oool2
0?l000D0oooo00<0o`000000o`3o00001@3oool00`3o0000003o0?l000040?ooo`80o`001P3oool0
1@3o0000oooo0000o`3oool0o`0000@0oooo00<0o`000000o`3o00001P3oool20?l000D0oooo0P3o
00060?ooo`030?l000000?l0o`0000<0oooo00<0o`000?ooo`3oool00P3oool2000000L0oooo000E
0?ooo`030000003oool0oooo00L0oooo00<0o`000000o`3o00000`3oool00`3o0000003o0?l00006
0?ooo`030?l0003oool0003o00<0o`00203oool20?l000030?ooo`3o0000o`0000L0oooo0P3o0000
0`3oool0o`000?l0000;0?ooo`040?l000000?l0oooo0?l000D0oooo00<0o`000000o`3o00000`3o
ool0103o0000oooo0000o`3o00090?ooo`060?l000000?l0o`000?ooo`3o0000003o0P3oool00`3o
0000oooo0?ooo`040?ooo`030?l000000?l0o`0000D0oooo00@0o`000000o`3o0000oooo0P3o0008
0?ooo`040?l000000?l0o`000?ooo`80o`002P3oool00`3o0000003o0?l000030?ooo`80o`00203o
ool0103o0000003o0?l0003oool20?l000L0oooo0P3o00050?ooo`030?l000000?l0o`0000D0oooo
00<0o`000000o`3o0000103oool20?l000H0oooo00D0o`000?ooo`000?l0oooo0?l000040?ooo`03
0?l000000?l0o`0000H0oooo0P3o00050?ooo`80o`001P3oool00`3o0000003o0?l000090?ooo`03
0000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00L0oooo00<0o`000000o`3o0000
0`3oool00`3o0000003o0?l000060?ooo`030?l0003oool0003o00<0o`00203oool20?l000030?oo
o`3o0000o`0000L0oooo0P3o00020?ooo`030?l0003oool0oooo00T0oooo00<0o`000000o`3o0000
1P3oool00`3o0000003o0?l000030?ooo`030?l0003oool0o`0000X0oooo00P0o`000000o`3o0000
oooo0?l000000?l0oooo0?l000L0oooo00<0o`000000o`3o00001@3oool0103o0000003o0?l0003o
ool20?l000P0oooo0P3o00020?ooo`80o`002P3oool00`3o0000003o0?l000030?ooo`80o`001`3o
ool01@3o0000oooo0000o`3o0000oooo0080o`001`3oool20?l000H0oooo0P3o00050?ooo`030?l0
00000?l0o`0000@0oooo0P3o00060?ooo`040?l0003oool0003o0?l000H0oooo0P3o00060?ooo`80
o`001@3oool20?l000H0oooo00<0o`000000o`3o00002@3oool00`000000oooo0?ooo`050?ooo`00
5@3oool00`000000oooo0?ooo`070?ooo`030?l000000?l0o`0000<0oooo00<0o`000000o`3o0000
1P3oool00`3o0000003o0?ooo`030?l000P0oooo0P3o00000`3oool0o`000?l000070?ooo`80o`00
0P3oool00`3o0000oooo0?ooo`090?ooo`030?l000000?l0o`0000H0oooo00<0o`000000o`3o0000
0`3oool00`3o0000003o0?l0000:0?ooo`030?l000000?l0oooo0080o`0000<0003o0?ooo`3o0000
1`3oool00`3o0000003o0?l000050?ooo`040?l000000?l0o`000?ooo`80o`00203oool20?l00080
oooo0P3o000:0?ooo`030?l000000?l0o`0000<0oooo0P3o00070?ooo`050?l0003oool0003o0?l0
003oool00P3o00070?ooo`80o`001P3oool20?l000D0oooo00<0o`000000o`3o0000103oool20?l0
00H0oooo00@0o`000000o`3oool0o`001P3oool20?l000H0oooo0P3o00050?ooo`80o`001P3oool0
0`3o0000oooo0?l000090?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo
00L0oooo00<0o`000000o`3o00000`3oool00`3o0000003o0?l000060?ooo`030?l000000?l0oooo
00<0o`00203oool20?l00080oooo00<0o`000?ooo`3oool01@3oool20?l00080oooo00<0o`000?oo
o`3oool0203oool0103o0000oooo0000o`3o00060?ooo`040?l000000?l0o`000?l00080oooo00<0
o`000000o`3o00002P3oool0203o0000003o0?ooo`3o0000oooo0000o`3oool0o`001`3oool00`3o
0000003o0?l000050?ooo`80o`000P3oool20?l000P0oooo0P3o00020?ooo`80o`002P3oool00`3o
0000003o0?l000030?ooo`80o`001`3oool01@3o0000oooo0000o`3o0000oooo0080o`001`3oool2
0?l000H0oooo0P3o00050?ooo`030?l000000?l0o`0000@0oooo0P3o00060?ooo`040?l000000?l0
oooo0?l000H0oooo0P3o00060?ooo`80o`001@3oool20?l000H0oooo0P3o000:0?ooo`030000003o
ool0oooo00D0oooo000E0?ooo`800000203oool00`3o0000003o0?l000030?ooo`030?l000000?l0
o`0000H0oooo00@0o`000000o`3o0000oooo0P3o00080?ooo`80o`000P3oool00`3o0000oooo0?oo
o`050?ooo`80o`000P3oool00`3o0000oooo0?ooo`080?ooo`040?l0003oool0003o0?l000H0oooo
00@0o`000000o`3oool0oooo0P3o00000`3oool0003o0?l0000:0?ooo`080?l000000?l0oooo0?l0
003oool0003o0?ooo`3o00070?ooo`030?l000000?l0o`0000D0oooo0P3o00020?ooo`80o`001`3o
ool00`3o0000003o0?l000020?ooo`030?l000000?l0o`0000T0oooo00<0o`000000o`3o00000`3o
ool20?l000L0oooo00<0o`000?ooo`3o00000P3oool20?l000L0oooo0P3o00060?ooo`80o`001@3o
ool00`3o0000003o0?l000050?ooo`80o`001@3oool0103o0000003o0?ooo`3o00060?ooo`80o`00
1P3oool20?l000D0oooo0P3o00060?ooo`80o`002@3oool2000000L0oooo000E0?ooo`030000003o
ool0oooo00L0oooo00<0o`000000o`3o00000`3oool00`3o0000003o0?l000060?ooo`070?l00000
0?l0o`000?ooo`3o0000003o0?l000060?ooo`030?l000000?l0o`000080oooo00<0o`000?ooo`3o
ool01@3oool20?l00080oooo00<0o`000?ooo`3oool0203oool0103o0000003o0?ooo`3o00070?oo
o`080?l0003oool0oooo0?ooo`3o0000oooo0000o`3o000:0?ooo`030?l000000?l0oooo0080oooo
00<0003o0?ooo`3o00001`3oool00`3o0000003o0?l000050?ooo`80o`000P3oool20?l000L0oooo
00<0o`000000o`3o00000P3oool00`3o0000003o0?l000090?ooo`030?l0003oool0o`0000<0oooo
0P3o00060?ooo`040?l0003oool0003o0?l00080oooo0P3o00070?ooo`80o`001P3oool20?l000D0
oooo0P3o00060?ooo`80o`001@3oool0103o0000003o0?ooo`3o00060?ooo`80o`001@3oool00`3o
0000003o0?l000050?ooo`80o`001P3oool20?l000X0oooo00<000000?ooo`3oool01@3oool001D0
oooo00<000000?ooo`3oool01P3oool0103o0000oooo0000o`3o00030?ooo`030?l000000?l0o`00
00H0oooo00<0o`000000o`3o00000P3oool20?l000H0oooo00<0o`000000o`3o00000P3oool00`3o
0000oooo0?ooo`050?ooo`80o`000P3oool00`3o0000oooo0?ooo`080?ooo`040?l000000?l0oooo
0?l000L0oooo00<0o`000?ooo`3oool00`3oool00`000?l0o`000?ooo`0:0?ooo`040?l0003oool0
oooo0000o`80oooo00<0o`000?ooo`3oool01@3oool0103o0000003o0?ooo`3o00040?ooo`80o`00
0P3oool20?l000L0oooo00<0o`000000o`3o00000P3oool00`3o0000003o0?l000080?ooo`030?l0
00000?l0o`0000@0oooo0P3o00060?ooo`040?l0003oool0003o0?l00080oooo0P3o00070?ooo`80
o`001P3oool00`3o0000oooo0?l000040?ooo`80o`001P3oool20?l000D0oooo00@0o`000000o`3o
ool0o`001P3oool20?l000D0oooo00<0o`000000o`3o00001@3oool00`3o0000003o0?l000050?oo
o`80o`002P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`060?ooo`03
0?l000000?l0o`0000@0oooo00<0o`000000o`3o00001P3oool00`3o0000003o0?l000020?ooo`80
o`001P3oool00`3o0000003o0?l000020?ooo`030?l0003oool0oooo00D0oooo0P3o00020?ooo`03
0?l0003oool0oooo00P0oooo00@0o`000000o`3oool0o`001`3oool00`3o0000oooo0?ooo`030?oo
o`030000o`3o0000oooo00X0oooo00H0o`000000o`3oool0003o0?ooo`3o00090?ooo`030?l0003o
ool0o`0000@0oooo0P3o00030?ooo`030?l0003oool0oooo00D0oooo00<0o`000000o`3o00000`3o
ool20?l000P0oooo00<0o`000000o`3o0000103oool20?l000H0oooo00@0o`000?ooo`000?l0o`00
0P3oool20?l000L0oooo0P3o00060?ooo`030?l000000?l0o`0000@0oooo0P3o00060?ooo`80o`00
1@3oool00`3o0000003o0?l000070?ooo`030?l000000?l0o`0000@0oooo00<0o`000000o`3o0000
1@3oool00`3o0000003o0?l000050?ooo`80o`002P3oool00`000000oooo0?ooo`050?ooo`005@3o
ool2000000L0oooo00<0o`000000o`3o00001@3oool20?l000H0oooo00<0o`000000o`3o00000P3o
ool20?l000H0oooo00<0o`000000o`3o00000P3oool00`3o0000oooo0?ooo`050?ooo`80o`000P3o
ool00`3o0000oooo0?ooo`080?ooo`030?l000000?l0o`0000P0oooo00<0o`000000o`3oool00P3o
ool00`000?l0oooo0?l0000;0?ooo`060?l000000?l0oooo0000o`3oool0o`002@3oool00`3o0000
oooo0?l000040?ooo`80o`000`3oool20?l000H0oooo00<0o`000000o`3o00000`3oool20?l000P0
oooo00<0o`000000o`3o0000103oool20?l000H0oooo00@0o`000?ooo`000?l0o`000P3oool20?l0
00L0oooo0P3o00060?ooo`030?l000000?l0o`0000@0oooo0P3o00060?ooo`80o`001@3oool00`3o
0000003o0?l000070?ooo`030?l000000?l0o`0000@0oooo00<0o`000000o`3o00001P3oool20?l0
00D0oooo0P3o00090?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool01P3oool00`3o0000
003o0?l000050?ooo`030?l000000?l0o`0000D0oooo00<0o`000000o`3o00000P3oool20?l000H0
oooo00<0o`000000o`3o00000P3oool00`3o0000oooo0?ooo`050?ooo`80o`000P3oool00`3o0000
oooo0?ooo`080?ooo`030?l000000?l0o`0000P0oooo00<0o`000000o`3oool00P3oool00`000?l0
oooo0?l0000;0?ooo`060?l000000?l0oooo0000o`3oool0o`002@3oool00`3o0000003o0?l00004
0?ooo`80o`000`3oool20?l000H0oooo00<0o`000000o`3o00000`3oool20?l000P0oooo00<0o`00
0000o`3o0000103oool20?l000H0oooo00@0o`000?ooo`000?l0o`000`3oool00`3o0000oooo0?oo
o`050?ooo`80o`001P3oool00`3o0000003o0?l000040?ooo`80o`001P3oool20?l000D0oooo00<0
o`000?ooo`3o00001`3oool00`3o0000003o0?l000040?ooo`030?l000000?l0o`0000H0oooo0P3o
00050?ooo`80o`002P3oool00`000000oooo0?ooo`050?ooo`003P3oool2000000D0oooo00<00000
0?ooo`3oool01P3oool00`3o0000003o0?l000050?ooo`030?l000000?l0o`0000@0oooo00@0o`00
0000o`3oool0o`000P3oool20?l000H0oooo00<0o`000000o`3o00000P3oool00`3o0000oooo0?oo
o`050?ooo`050?l0003oool0oooo0?ooo`3o00002P3oool00`3o0000003o0?l000080?ooo`030?l0
00000?l0oooo0080oooo00<0003o0?ooo`3o00002`3oool01@3o0000003o0?ooo`000?l0o`0000X0
oooo00<0o`000000o`3o0000103oool20?l000<0oooo0P3o00060?ooo`030?l000000?l0o`0000<0
oooo0P3o00080?ooo`030?l000000?l0o`0000@0oooo0P3o00060?ooo`040?l000000?l0oooo0?l0
00<0oooo00<0o`000?ooo`3oool01@3oool20?l000H0oooo00<0o`000000o`3o0000103oool20?l0
00H0oooo0P3o00050?ooo`030?l0003oool0o`0000L0oooo00<0o`000000o`3o0000103oool00`3o
0000003o0?l000060?ooo`80o`00103oool00`3o0000003o0?l0000:0?ooo`030000003oool0oooo
00D0oooo000=0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool01@3oool0103o
0000oooo0000o`3o00050?ooo`030?l000000?l0o`0000@0oooo00<0o`000000o`3o00000`3oool2
0?l000H0oooo00<0o`000000o`3o00000P3oool00`3o0000oooo0?ooo`040?ooo`80o`000`3oool0
0`3o0000oooo0?ooo`080?ooo`030?l000000?l0o`0000P0oooo00<0o`000000o`3oool00P3oool0
0`000?l0o`000?ooo`0;0?ooo`050?l000000?l0oooo0000o`3o00002P3oool00`3o0000003o0?l0
00040?ooo`80o`000`3oool20?l000H0oooo0P3o00040?ooo`80o`00203oool00`3o0000003o0?l0
00040?ooo`80o`001@3oool01@3o0000oooo0000o`3oool0o`0000<0oooo00<0o`000?ooo`3oool0
1@3oool00`3o0000oooo0?ooo`050?ooo`030?l000000?l0o`0000@0oooo0P3o00060?ooo`80o`00
103oool0103o0000003o0?ooo`3o00070?ooo`030?l000000?l0o`0000@0oooo0P3o00070?ooo`80
o`00103oool00`3o0000003o0?l0000:0?ooo`030000003oool0oooo00D0oooo000=0?ooo`040000
003oool0oooo000000@0oooo00<000000?ooo`3oool01@3oool0103o0000oooo0000o`3o00050?oo
o`030?l000000?l0o`0000@0oooo00<0o`000000o`3o00000`3oool20?l000H0oooo0P3o00030?oo
o`030?l0003oool0oooo00@0oooo0P3o00030?ooo`030?l0003oool0oooo00L0oooo00@0o`000?oo
o`000?l0o`00203oool00`3o0000003o0?ooo`020?ooo`030000o`3o0000oooo00/0oooo00D0o`00
0?ooo`000?l0oooo0?l0000:0?ooo`030?l000000?l0o`0000@0oooo0P3o00030?ooo`80o`001P3o
ool20?l000@0oooo0P3o00080?ooo`030?l000000?l0o`0000@0oooo0P3o00050?ooo`050?l0003o
ool0003o0?ooo`3o00000`3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00D0oooo
00<0o`000000o`3o0000103oool20?l000H0oooo0P3o00040?ooo`030?l000000?l0o`0000P0oooo
00<0o`000000o`3o00000`3oool00`3o0000oooo0?l000070?ooo`80o`00103oool20?l000/0oooo
00<000000?ooo`3oool01@3oool000d0oooo00@000000?ooo`3oool00000103oool2000000H0oooo
00@0o`000?ooo`000?l0o`001@3oool00`3o0000003o0?l000040?ooo`030?l000000?l0o`0000<0
oooo0P3o00060?ooo`80o`000`3oool00`3o0000oooo0?ooo`040?ooo`80o`000`3oool20?l000P0
oooo00@0o`000000o`3oool0o`00203oool01`3o0000oooo0000o`3oool0003o0?ooo`3o0000303o
ool01@3o0000oooo0000o`3oool0o`0000X0oooo00<0o`000000o`3o0000103oool20?l000<0oooo
0P3o00060?ooo`80o`00103oool20?l000P0oooo00<0o`000000o`3o0000103oool20?l000D0oooo
00D0o`000?ooo`000?l0oooo0?l000030?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3o
ool01@3oool00`3o0000003o0?l000040?ooo`80o`001P3oool20?l000@0oooo00<0o`000000o`3o
0000203oool00`3o0000003o0?l000030?ooo`030?l0003oool0o`0000L0oooo0P3o00040?ooo`80
o`002@3oool3000000L0oooo000=0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3o
ool01@3oool0103o0000oooo0000o`3o00050?ooo`030?l000000?l0o`0000@0oooo00<0o`000000
o`3o00000`3oool20?l000H0oooo0P3o00030?ooo`030?l0003oool0oooo00@0oooo0P3o00030?oo
o`80o`00203oool0103o0000003o0?ooo`3o00080?ooo`030?l0003oool0oooo0080003o00<0oooo
0?l0003oool02`3oool01@3o0000oooo0?ooo`3oool0o`0000X0oooo00@0o`000000o`3oool0o`00
0`3oool20?l000<0oooo0P3o00050?ooo`030?l000000?l0o`0000@0oooo0P3o00080?ooo`030?l0
00000?l0o`0000@0oooo0P3o00050?ooo`050?l000000?l0oooo0?ooo`3o00000`3oool00`3o0000
oooo0?ooo`040?ooo`80o`001`3oool00`3o0000003o0?l000040?ooo`80o`001P3oool20?l000@0
oooo00<0o`000000o`3o00002@3oool00`3o0000oooo0?l000020?ooo`030?l0003oool0o`0000L0
oooo0P3o00040?ooo`80o`002`3oool00`000000oooo0?ooo`050?ooo`003@3oool010000000oooo
0?ooo`0000040?ooo`030000003oool0oooo00D0oooo00@0o`000?ooo`000?l0o`001@3oool00`3o
0000003o0?l000040?ooo`030?l000000?l0o`0000<0oooo0P3o00060?ooo`80o`000`3oool00`3o
0000oooo0?ooo`040?ooo`80o`000`3oool20?l000P0oooo00<0o`000000o`3o00002@3oool01`3o
0000oooo0?ooo`3oool0003o0?ooo`3o0000303oool01@3o0000oooo0?ooo`3oool0o`0000X0oooo
00@0o`000000o`3oool0o`000`3oool20?l000<0oooo0P3o00050?ooo`030?l000000?l0o`0000@0
oooo0P3o00070?ooo`030?l000000?l0o`0000D0oooo0P3o00050?ooo`040?l000000?l0oooo0?l0
00@0oooo00<0o`000?ooo`3oool0103oool20?l000L0oooo00@0o`000000o`3oool0o`000P3oool0
0`3o0000003o0?l000060?ooo`80o`00103oool00`3o0000003o0?l000090?ooo`080?l0003oool0
o`000?ooo`3o0000oooo0000o`3o00070?ooo`80o`00103oool20?l000/0oooo00<000000?ooo`3o
ool01@3oool000h0oooo0P0000050?ooo`030000003oool0oooo00D0oooo00@0o`000000o`3oool0
o`001@3oool0103o0000003o0?ooo`3o00030?ooo`030?l000000?l0o`0000<0oooo0P3o00050?oo
o`030?l000000?l0o`0000<0oooo00<0o`000?ooo`3oool0103oool20?l000<0oooo0P3o00080?oo
o`030?l000000?l0o`0000T0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`0;0?oo
o`030?l0003oool0o`0000/0oooo00@0o`000?ooo`000?l0o`000`3oool20?l000<0oooo0P3o0005
0?ooo`030?l000000?l0o`0000@0oooo00<0o`000000o`3o00001P3oool00`3o0000003o0?l00005
0?ooo`80o`001@3oool0103o0000003o0?ooo`3o00040?ooo`80o`001@3oool20?l000L0oooo00@0
o`000?ooo`000?l0o`000P3oool00`3o0000003o0?l000060?ooo`80o`00103oool00`3o0000003o
0?l000090?ooo`030?l000000?l0o`000080o`0000<0oooo0000o`3o00001`3oool20?l000@0oooo
0P3o000;0?ooo`030000003oool0oooo00D0oooo000E0?ooo`8000001P3oool00`3o0000003o0?l0
00060?ooo`040?l000000?l0oooo0?l000<0oooo00<0o`000000o`3o00000`3oool20?l000D0oooo
00<0o`000000o`3o00000`3oool20?l000D0oooo0P3o00030?ooo`80o`00203oool00`3o0000003o
0?l000090?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool02`3oool00`3o0000oooo
0?l0000;0?ooo`040?l0003oool0003o0?l00080oooo0P3o00040?ooo`80o`001@3oool00`3o0000
003o0?l000040?ooo`030?l000000?l0o`0000H0oooo00<0o`000000o`3o00001@3oool20?l000D0
oooo00@0o`000000o`3oool0o`00103oool20?l000D0oooo0P3o00080?ooo`030?l000000?l0o`00
0080oooo00<0o`000000o`3o00001P3oool20?l000@0oooo00<0o`000000o`3o00002@3oool00`3o
0000003o0?ooo`030?ooo`030000o`3o0000oooo00H0oooo00<0o`000000o`3o00000`3oool20?l0
00X0oooo0P0000070?ooo`005@3oool00`000000oooo0?ooo`050?ooo`030?l000000?l0o`0000L0
oooo00<0o`000?ooo`3o00000P3oool0103o0000oooo0000o`3o00030?ooo`80o`001@3oool00`3o
0000003o0?l000030?ooo`80o`001@3oool20?l000<0oooo0P3o00070?ooo`040?l0003oool0003o
0?l000X0oooo00D0o`000?ooo`3oool0oooo0?l0000>0?ooo`030?l0003oool0o`0000`0oooo00<0
o`000000o`3o00000P3oool20?l000@0oooo0P3o00050?ooo`030?l000000?l0o`0000@0oooo00<0
o`000000o`3o00001@3oool0103o0000oooo0000o`3o00050?ooo`80o`001@3oool0103o0000003o
0?ooo`3o00040?ooo`80o`001@3oool20?l000P0oooo00<0o`000000o`3o00000P3oool00`3o0000
003o0?l000060?ooo`80o`00103oool20?l000X0oooo00<0o`000000o`3oool00`3oool00`000?l0
o`000?ooo`060?ooo`030?l000000?l0o`0000<0oooo0P3o000;0?ooo`030000003oool0oooo00D0
oooo000E0?ooo`030000003oool0oooo00D0oooo00<0o`000000o`3o00001`3oool00`3o0000003o
0?l000020?ooo`030?l0003oool0o`0000@0oooo0P3o00050?ooo`030?l000000?l0o`0000<0oooo
0P3o00050?ooo`80o`000`3oool20?l000L0oooo00@0o`000?ooo`000?l0o`002P3oool01@3o0000
oooo0?ooo`3oool0o`0000h0oooo00<0o`000?ooo`3o0000303oool00`3o0000003o0?l000020?oo
o`80o`00103oool20?l000D0oooo00<0o`000000o`3o0000103oool00`3o0000003o0?l000050?oo
o`040?l0003oool0003o0?l000H0oooo00<0o`000?ooo`3oool00`3oool0103o0000003o0?ooo`3o
00040?ooo`80o`001@3oool20?l000P0oooo00<0o`000000o`3o00000P3oool20?l000L0oooo00<0
o`000000o`3o00000`3oool20?l000X0oooo00<0o`000000o`3oool00`3oool00`000?l0o`000?oo
o`060?ooo`030?l000000?l0o`0000<0oooo0P3o000;0?ooo`030000003oool0oooo00D0oooo000E
0?ooo`030000003oool0oooo00D0oooo00<0o`000000o`3o00001`3oool00`3o0000003o0?l00002
0?ooo`030?l000000?l0o`0000@0oooo0P3o00050?ooo`030?l000000?l0o`0000<0oooo0P3o0005
0?ooo`80o`000`3oool20?l000L0oooo00@0o`000?ooo`000?l0o`002P3oool01@3o0000oooo0?oo
o`3oool0o`0000h0oooo00<0o`000?ooo`3o0000303oool00`3o0000003o0?l000020?ooo`80o`00
103oool20?l000D0oooo00<0o`000000o`3o0000103oool00`3o0000003o0?l000050?ooo`040?l0
003oool0003o0?l000H0oooo00<0o`000?ooo`3oool00`3oool00`3o0000003o0?l000050?ooo`80
o`001@3oool20?l000P0oooo00<0o`000000o`3oool0103o00070?ooo`030?l000000?l0o`0000<0
oooo0P3o000:0?ooo`030?l000000?l0oooo00<0oooo00<0003o0?l0003oool01P3oool00`3o0000
003o0?l000030?ooo`80o`002`3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo
0?ooo`050?ooo`030?l0003oool0o`0000L0oooo00P0o`000000o`3oool0o`000?ooo`3o0000003o
0?l000@0oooo00<0o`000000o`3o0000103oool00`3o0000003o0?l000030?ooo`80o`001@3oool2
0?l000<0oooo0P3o00070?ooo`040?l000000?l0oooo0?l000X0oooo00D0o`000?ooo`3oool0oooo
0?l0000?0?ooo`80o`00303oool00`3o0000003o0?l000020?ooo`80o`00103oool20?l000D0oooo
00<0o`000000o`3o0000103oool00`3o0000003o0?l000050?ooo`040?l0003oool0003o0?l000H0
oooo00<0o`000?ooo`3oool00P3oool0103o0000003o0?ooo`3o00050?ooo`80o`001@3oool20?l0
00P0oooo00@0o`000000o`3oool0o`000P3oool00`3o0000oooo0?ooo`050?ooo`030?l000000?l0
o`0000<0oooo0P3o000:0?ooo`030?l000000?l0oooo00<0oooo00<0003o0?l0003oool01P3oool0
0`3o0000003o0?l000030?ooo`80o`002`3oool00`000000oooo0?ooo`050?ooo`005@3oool20000
00H0oooo00<0o`000?ooo`3o00001`3oool0203o0000003o0?ooo`3o0000oooo0?l000000?l0o`00
103oool00`3o0000003o0?l000040?ooo`030?l000000?l0o`0000<0oooo0P3o00050?ooo`80o`00
0`3oool20?l000L0oooo00<0o`000000o`3o00002`3oool20?l00080oooo00<0o`000?ooo`3oool0
3@3oool00`3o0000oooo0?ooo`0;0?ooo`030?l000000?l0o`000080oooo0P3o00040?ooo`80o`00
1@3oool00`3o0000003o0?l000040?ooo`030?l000000?l0o`0000D0oooo00@0o`000?ooo`000?l0
o`001P3oool00`3o0000oooo0?ooo`020?ooo`040?l000000?l0oooo0?l000D0oooo0P3o00050?oo
o`80o`00203oool00`3o0000003o0?ooo`030?ooo`030?l0003oool0oooo00D0oooo00<0o`000000
o`3o00000`3oool20?l000X0oooo00<0o`000000o`3oool00P3oool00`000?l0oooo0?l000070?oo
o`030?l000000?l0o`0000<0oooo0P3o000:0?ooo`8000001`3oool001D0oooo00<000000?ooo`3o
ool0103oool0103o0000003o0?ooo`3o00070?ooo`080?l000000?l0oooo0?l0003oool0o`000000
o`3o00040?ooo`030?l000000?l0o`0000@0oooo00<0o`000000o`3o00000`3oool20?l000D0oooo
0P3o00030?ooo`80o`001P3oool0103o0000oooo0000o`3o000=0?ooo`80o`00403oool00`3o0000
oooo0?ooo`0;0?ooo`050?l000000?l0oooo0?l0003oool00P3o00040?ooo`80o`001@3oool20?l0
00H0oooo0P3o00040?ooo`050?l0003oool0oooo0000o`3o00001P3oool00`3o0000oooo0?ooo`02
0?ooo`040?l000000?l0oooo0?l000D0oooo0P3o00050?ooo`80o`00203oool00`3o0000003o0?oo
o`030?ooo`030?l0003oool0oooo00D0oooo00<0o`000000o`3o00000`3oool20?l000X0oooo00<0
o`000?ooo`000?l00P3oool00`000?l0oooo0?l000070?ooo`030?l000000?l0o`0000<0oooo0P3o
000;0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00@0oooo00@0o`00
0000o`3oool0o`001`3oool0203o0000003o0?ooo`3o0000oooo0?l000000?l0o`001@3oool20?l0
00@0oooo0P3o00040?ooo`80o`001@3oool20?l000<0oooo0P3o00060?ooo`040?l0003oool0003o
0?l000d0oooo0P3o000N0?ooo`030?l0003oool0003o00@0o`00103oool20?l000D0oooo0P3o0006
0?ooo`80o`00103oool01@3o0000oooo0000o`3oool0o`0000H0oooo00<0o`000?ooo`3oool00P3o
ool00`3o0000003o0?l000060?ooo`80o`001@3oool20?l000P0oooo00<0o`000?ooo`000?l00`3o
ool00`3o0000oooo0?ooo`060?ooo`80o`000P3oool00`3o0000003o0?l0000:0?ooo`030?l0003o
ool0003o0080oooo00<0003o0?ooo`3o00001`3oool00`3o0000003o0?l000030?ooo`80o`002`3o
ool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`040?ooo`030?l000000?l0
o`0000P0oooo00P0o`000000o`3oool0o`000?ooo`3o0000003o0?l000D0oooo0P3o00040?ooo`80
o`00103oool20?l000D0oooo0P3o00030?ooo`80o`001P3oool0103o0000oooo0000o`3o000>0?oo
o`030?l0003oool0oooo01d0oooo00<0o`000000o`3o00000P3oool00`3o0000oooo0?ooo`020?oo
o`80o`001@3oool20?l000H0oooo0P3o00040?ooo`040?l0003oool0003o0?l000L0oooo00<0o`00
0?ooo`3oool00P3oool00`3o0000003o0?l000060?ooo`80o`001@3oool20?l000P0oooo00<0o`00
0?ooo`000?l00P3oool00`000?l0o`000?ooo`070?ooo`80o`000P3oool00`3o0000003o0?l0000:
0?ooo`030?l0003oool0003o0080003o00<0oooo0?l0003oool01`3oool00`3o0000003o0?l00002
0?ooo`030?l000000?l0o`0000/0oooo00<000000?ooo`3oool01@3oool001D0oooo0P0000050?oo
o`030?l000000?l0o`0000P0oooo00P0o`000?ooo`000?l0o`000?ooo`3o0000003o0?l000D0oooo
0P3o00040?ooo`80o`00103oool20?l000D0oooo0P3o00030?ooo`80o`001P3oool0103o0000oooo
0000o`3o000^0?ooo`060?l000000?l0oooo0?ooo`000?l0o`00103oool20?l000D0oooo0P3o0006
0?ooo`80o`00103oool0103o0000oooo0000o`3o00070?ooo`030?l0003oool0oooo0080oooo00<0
o`000000o`3o00001P3oool20?l000D0oooo0P3o00090?ooo`060?l000000?l0oooo0?ooo`000?l0
o`00203oool20?l00080oooo00<0o`000000o`3o00002`3oool01P3o0000003o0?ooo`000?l0oooo
0?l000T0oooo0P3o00020?ooo`030?l000000?l0o`0000X0oooo0P0000070?ooo`005@3oool00`00
0000oooo0?ooo`040?ooo`030?l000000?l0o`0000P0oooo00P0o`000?ooo`000?l0o`000?ooo`3o
0000oooo0?l000D0oooo0P3o00040?ooo`80o`00103oool20?l000@0oooo00<0o`000000o`3o0000
0`3oool20?l000H0oooo00@0o`000?ooo`000?l0o`00;P3oool01P3o0000003o0?ooo`3oool0003o
0?l000D0oooo00<0o`000?ooo`3oool00`3oool20?l000H0oooo0P3o00040?ooo`040?l000000?l0
oooo0?l000L0oooo00<0o`000?ooo`3oool00P3oool00`3o0000003o0?l000060?ooo`80o`001@3o
ool20?l000T0oooo00H0o`000000o`3oool0oooo0000o`3o00080?ooo`80o`000P3oool00`3o0000
003o0?l0000;0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool01`3oool20?l00080
oooo00<0o`000000o`3o00002`3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo
0?ooo`040?ooo`030?l000000?l0o`0000P0oooo00<0o`000?ooo`000?l00P3o00000`000?l0oooo
0?l000050?ooo`80o`00103oool20?l000@0oooo0P3o00040?ooo`030?l000000?l0o`0000<0oooo
0P3o00060?ooo`040?l000000?l0oooo0?l002h0oooo00H0o`000000o`3oool0oooo0000o`3o0005
0?ooo`030?l0003oool0oooo00<0oooo0P3o00060?ooo`80o`00103oool0103o0000003o0?ooo`3o
00070?ooo`030?l0003oool0oooo0080oooo00<0o`000000o`3o00001P3oool20?l000D0oooo0P3o
00090?ooo`060?l000000?l0oooo0?ooo`000?l0o`00203oool20?l00080oooo00<0o`000000o`3o
00002`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00L0oooo0P3o00020?ooo`03
0?l000000?l0o`0000/0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0
103oool00`3o0000003o0?l000090?ooo`060?l000000?l0oooo0?l000000?l0o`001P3oool20?l0
00@0oooo0P3o00040?ooo`80o`00103oool00`3o0000003o0?l000030?ooo`80o`001P3oool0103o
0000003o0?ooo`3o000^0?ooo`060?l000000?l0oooo0?ooo`000?l0o`001@3oool00`3o0000oooo
0?ooo`020?ooo`030?l000000?l0o`0000H0oooo0P3o00040?ooo`040?l000000?l0oooo0?l000L0
oooo00<0o`000?ooo`3oool00P3oool00`3o0000003o0?l000060?ooo`80o`001@3oool20?l000T0
oooo00H0o`000000o`3oool0oooo0000o`3o00080?ooo`80o`000P3oool00`3o0000003o0?l0000;
0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool01`3oool20?l00080oooo0P3o000<
0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00@0oooo0P3o000:0?oo
o`060?l000000?l0oooo0?l000000?l0o`001P3oool20?l000<0oooo00<0o`000000o`3o0000103o
ool20?l000@0oooo0P3o00040?ooo`80o`001P3oool0103o0000003o0?ooo`3o000^0?ooo`060?l0
00000?l0oooo0?ooo`000?l0o`001@3oool00`3o0000oooo0?ooo`020?ooo`030?l000000?l0o`00
00H0oooo0P3o00040?ooo`040?l000000?l0oooo0?l000L0oooo0P3o00020?ooo`030?l000000?l0
o`0000L0oooo0P3o00050?ooo`80o`002@3oool00`3o0000oooo0000o`020000o`030?l0003oool0
oooo00H0oooo0P3o00020?ooo`80o`00303oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0
oooo00L0oooo0P3o00020?ooo`80o`00303oool00`000000oooo0?ooo`050?ooo`005@3oool20000
00D0oooo0P3o000:0?ooo`060?l0003oool0003o0?l000000?l0o`001P3oool20?l000<0oooo00<0
o`000000o`3o0000103oool20?l000@0oooo0P3o00040?ooo`80o`001P3oool00`3o0000003o0?l0
000_0?ooo`060?l000000?l0oooo0?ooo`000?l0o`001@3oool00`3o0000oooo0?ooo`020?ooo`03
0?l000000?l0o`0000H0oooo0P3o00040?ooo`040?l000000?l0oooo0?l000L0oooo0P3o00020?oo
o`030?l000000?l0o`0000L0oooo0P3o00050?ooo`80o`002@3oool00`3o0000oooo0000o`020?oo
o`030?l0003oool0oooo00H0oooo0P3o0000103oool0o`000?ooo`3o000<0?ooo`050?l0003oool0
oooo0?ooo`3o00002P3oool20?l00080oooo0P3o000;0?ooo`8000001`3oool001D0oooo00<00000
0?ooo`3oool0103oool20?l000X0oooo00H0o`000?ooo`000?l0o`000000o`3o00060?ooo`80o`00
0`3oool00`3o0000003o0?l000040?ooo`80o`00103oool20?l000@0oooo0P3o00060?ooo`030?l0
00000?l0o`0002l0oooo00H0o`000?ooo`000?l0oooo0000o`3o00050?ooo`030?l0003oool0oooo
0080oooo00<0o`000000o`3o00001P3oool20?l000@0oooo00@0o`000000o`3oool0o`001`3oool2
0?l00080oooo00<0o`000000o`3o00001`3oool20?l000@0oooo00<0o`000000o`3o00002@3oool0
0`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00H0oooo0P3o0000103oool0o`000?ooo`3o
000<0?ooo`050?l0003oool0oooo0?ooo`3o00002P3oool20?l00080oooo0P3o000<0?ooo`030000
003oool0oooo00D0oooo00060?ooo`D000000P3oool3000000D0oooo00<000000?ooo`3oool0103o
ool20?l000X0oooo00H0o`000?ooo`000?l0o`000000o`3o00060?ooo`80o`000`3oool00`3o0000
003o0?l000040?ooo`80o`00103oool20?l000D0oooo00<0o`000?ooo`3oool0103oool00`3o0000
oooo0?l0000_0?ooo`060?l0003oool0003o0?ooo`000?l0o`001@3oool00`3o0000oooo0?ooo`02
0?ooo`030?l000000?l0o`0000H0oooo0P3o00040?ooo`040?l0003oool0oooo0?l000L0oooo0P3o
00020?ooo`030?l000000?l0o`0000L0oooo0P3o00040?ooo`80o`002P3oool00`3o0000oooo0?oo
o`020?ooo`030?l0003oool0oooo00H0oooo00H0o`000000o`3o0000o`000?ooo`3o000=0?ooo`04
0?l0003oool0oooo0?l000X0oooo0P3o00020?ooo`80o`00303oool00`000000oooo0?ooo`050?oo
o`001`3oool01P000000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`040?ooo`80o`002P3oool01P3o0000oooo0000o`3o0000003o0?l000H0oooo
0P3o00030?ooo`030?l000000?l0o`0000@0oooo0P3o00040?ooo`80o`001@3oool00`3o0000oooo
0?ooo`030?ooo`040?l000000?l0oooo0?l00300oooo00D0o`000000o`000?l0003o0?l000050?oo
o`030?l0003oool0oooo0080oooo0P3o00070?ooo`80o`00103oool00`3o0000oooo0?l000080?oo
o`80o`000P3oool00`3o0000003o0?l000070?ooo`80o`00103oool20?l000/0oooo00@0o`000?oo
o`3oool0o`002@3oool01P3o0000003o0?l0003o0000003o0?l000d0oooo00<0o`000?ooo`3o0000
2`3oool20?l00080oooo0P3o000<0?ooo`030000003oool0oooo00D0oooo00080?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool00P3oool2000000@0oooo00<0o`000000o`3o00002`3o
ool01@3o0000003o0?ooo`000?l0o`0000H0oooo0P3o00030?ooo`80o`001@3oool20?l000@0oooo
0P3o00050?ooo`030?l0003oool0oooo00<0oooo00@0o`000000o`3oool0o`00<03oool01@3o0000
003o0?ooo`3oool0o`0000D0oooo00<0o`000?ooo`3oool00P3oool20?l000P0oooo00<0o`000?oo
o`3oool00P3oool00`3o0000oooo0?l000080?ooo`80o`000P3oool00`3o0000003o0?l000080?oo
o`030?l0003oool0oooo0080oooo0P3o000;0?ooo`040?l0003oool0oooo0?l000T0oooo00H0o`00
0000o`3o0000o`000000o`3o000=0?ooo`<0o`002`3oool20?l000040?ooo`3o0000003o0?l000X0
oooo0`0000070?ooo`002@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000?l0o`000?ooo`0:0?ooo`050?l000000?l0oooo0000o`3o
00001P3oool20?l000<0oooo0P3o00060?ooo`030?l0003oool0oooo0080oooo0P3o00050?ooo`03
0?l0003oool0oooo00<0oooo00@0o`000000o`3oool0o`00<03oool0103o0000oooo0?ooo`3o0006
0?ooo`030?l0003oool0oooo0080oooo0P3o00080?ooo`030?l0003oool0oooo0080oooo00<0o`00
0?ooo`3o0000203oool20?l00080oooo00<0o`000000o`3o0000203oool00`3o0000oooo0?ooo`02
0?ooo`80o`002`3oool0103o0000oooo0?ooo`3o00090?ooo`060?l000000?l0o`000?l000000?l0
o`003@3oool00`3o0000oooo0?ooo`0;0?ooo`060?l000000?l0o`000?l000000?l0o`00303oool0
0`000000oooo0?ooo`050?ooo`001P3oool01P000000oooo0?ooo`3oool000000?ooo`@000001@3o
ool00`000000oooo0?ooo`040?ooo`030000o`3o0000oooo00X0oooo00@0o`000000o`3oool0o`00
1`3oool20?l000<0oooo0P3o00060?ooo`030?l0003oool0oooo0080oooo0P3o00050?ooo`030?l0
003oool0oooo00<0oooo00<0o`000000o`3o0000<@3oool0103o0000oooo0?ooo`3o00060?ooo`03
0?l0003oool0oooo0080oooo0P3o00080?ooo`80o`000`3oool20?l000T0oooo0P3o00020?ooo`03
0?l000000?l0o`0000P0oooo00<0o`000?ooo`3oool00P3oool20?l000/0oooo00@0o`000?ooo`3o
ool0o`002@3oool01P3o0000003o0?l0003oool0003o0?l001`0oooo0`3o00000`000?l0o`000?oo
o`0;0?ooo`030000003oool0oooo00D0oooo00060?ooo`070000003oool0oooo0?ooo`000000oooo
000000080?ooo`030000003oool0oooo00@0oooo00<0003o0?l0003oool02P3oool0103o0000003o
0000o`3o00070?ooo`80o`000`3oool20?l000H0oooo00L0o`000?ooo`3oool0oooo0?l000000?l0
o`0000D0oooo00<0o`000?ooo`3oool00`3oool00`3o0000003o0?l0000a0?ooo`040?l0003oool0
oooo0?l000H0oooo00<0o`000?ooo`3oool00P3oool20?l000P0oooo0P3o00030?ooo`80o`002@3o
ool20?l00080oooo00<0o`000000o`3o0000203oool00`3o0000oooo0?ooo`020?ooo`80o`002`3o
ool0103o0000oooo0?ooo`3o00090?ooo`060?l000000?l0o`000?ooo`000?l0o`00703oool30?l0
00030000o`3o0000oooo00/0oooo00<000000?ooo`3oool01@3oool000L0oooo0`0000020?ooo`D0
0000103oool00`000000oooo0?ooo`040?ooo`030000o`3o0000oooo00X0oooo00@0o`000?ooo`00
0?l0o`001`3oool20?l000<0oooo0P3o00060?ooo`070?l0003oool0oooo0?ooo`3o0000003o0?l0
00050?ooo`030?l0003oool0oooo00<0oooo00<0o`000000o`3o0000<@3oool0103o0000oooo0?oo
o`3o00060?ooo`030?l0003oool0oooo0080oooo0P3o00080?ooo`80o`000P3oool00`3o0000003o
0?l000090?ooo`80o`000P3oool00`3o0000oooo0?l000080?ooo`030?l0003oool0oooo0080oooo
0P3o000<0?ooo`<0o`002P3oool20?l000030?ooo`000?l0o`0001`0oooo0`3o00000`000?l0o`00
0?ooo`0;0?ooo`030000003oool0oooo00D0oooo000E0?ooo`8000001@3oool00`000?l0o`000?oo
o`0;0?ooo`030?l000000?l0o`0000P0oooo00@0o`000?ooo`3oool0oooo0P3o00060?ooo`070?l0
003oool0oooo0?ooo`3o0000003o0?l000050?ooo`030?l0003oool0oooo00<0oooo00<0o`000000
o`3o0000<@3oool0103o0000oooo0?ooo`3o00060?ooo`030?l0003oool0oooo0080oooo0P3o0008
0?ooo`80o`000P3oool00`3o0000003o0?l000090?ooo`80o`000P3oool20?l000T0oooo00<0o`00
0?ooo`3oool00P3oool20?l000`0oooo00<0o`000?ooo`3oool02P3oool01@3o0000oooo0?ooo`00
0?l0o`0001`0oooo0`3o00000`000?l0o`000?ooo`0:0?ooo`8000001`3oool001D0oooo00<00000
0?ooo`3oool0103oool00`000?l0o`000?ooo`0;0?ooo`030?l000000?l0o`0000P0oooo00@0o`00
0?ooo`3oool0oooo0P3o00060?ooo`070?l0003oool0oooo0?ooo`3o0000003o0?l000050?ooo`03
0?l0003oool0oooo00<0oooo00<0o`000000o`3o0000<@3oool0103o0000oooo0?ooo`3o00060?oo
o`030?l0003oool0oooo0080oooo0P3o00080?ooo`80o`000P3oool00`3o0000003o0?l000090?oo
o`80o`000P3oool20?l000T0oooo00<0o`000?ooo`3oool00P3oool20?l001T0oooo00D0o`000?oo
o`000?l0oooo0?l0000L0?ooo`<0o`0000<0003o0?l0003oool02`3oool00`000000oooo0?ooo`05
0?ooo`005@3oool00`000000oooo0?ooo`040?ooo`030000o`3o0000oooo00/0oooo00<0o`000000
o`3o0000203oool20?l00080oooo0P3o00060?ooo`070?l0003oool0oooo0?ooo`3o0000003o0?l0
00050?ooo`030?l0003oool0oooo00<0oooo0P3o000c0?ooo`030?l0003oool0o`0000H0oooo00<0
o`000?ooo`3oool00P3oool20?l000P0oooo0P3o00020?ooo`80o`002P3oool20?l000040?ooo`3o
0000003o0?l000T0oooo00<0o`000?ooo`3oool00P3oool20?l001T0oooo00D0o`000?ooo`000?l0
oooo0?l0000L0?ooo`<0o`0000<0003o0?l0003oool02`3oool00`000000oooo0?ooo`050?ooo`00
5@3oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo00/0oooo00<0o`000000o`3o0000
203oool20?l000040?ooo`3o0000003o0?l000H0oooo00L0o`000?ooo`3oool0oooo0?l000000?l0
o`0000D0oooo00<0o`000?ooo`3oool00`3oool20?l003<0oooo00<0o`000?ooo`3o00001P3oool2
0?l000<0oooo0P3o00080?ooo`80o`000P3oool20?l000X0oooo0P3o0000103oool0o`000000o`3o
00090?ooo`030?l0003oool0oooo0080oooo0P3o000I0?ooo`040?l000000?l0003o0?l001d0oooo
0`3o00000`000?l0o`000?ooo`0;0?ooo`030000003oool0oooo00D0oooo000E0?ooo`8000001@3o
ool00`3o0000oooo0?ooo`0;0?ooo`030?l000000?l0o`0000P0oooo0P3o0000103oool0o`000000
o`3o00060?ooo`070?l0003oool0oooo0?ooo`3o0000003o0?l000050?ooo`030?l0003oool0oooo
00<0oooo0P3o000c0?ooo`<0o`001P3oool20?l000<0oooo0P3o00080?ooo`80o`000P3oool20?l0
00X0oooo0P3o0000103oool0o`000000o`3o00090?ooo`030?l0003oool0oooo0080oooo0P3o000I
0?ooo`040?l000000?l0003o0?l001d0oooo0P3o00000`3oool0o`000?ooo`0;0?ooo`8000001`3o
ool001D0oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`0;0?ooo`030?l0003oool0
o`0000P0oooo0P3o0000103oool0o`000000o`3o00060?ooo`070?l0003oool0oooo0?ooo`3o0000
003o0?l000050?ooo`030?l0003oool0oooo00<0oooo0P3o000l0?ooo`80o`000`3oool20?l000P0
oooo0P3o00020?ooo`80o`002P3oool20?l000040?ooo`3o0000003o0?l000T0oooo00L0o`000?oo
o`3oool0oooo0?l000000?l0o`0001T0oooo00@0o`000000o`000?l0o`007@3oool20?l000030000
o`3o0000oooo00`0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool00`3o
ool00`000?l0o`000?ooo`0<0?ooo`030?l0003oool0o`0000P0oooo0P3o0000103oool0o`000000
o`3o00060?ooo`040?l0003oool0oooo0?ooo`80o`001P3oool00`3o0000oooo0?ooo`030?ooo`80
o`00?03oool20?l000<0oooo0P3o00080?ooo`80o`000P3oool20?l000X0oooo00H0o`000000o`3o
0000o`000000o`3o00090?ooo`070?l0003oool0oooo0?ooo`3o0000003o0?l0000I0?ooo`040?l0
00000?l0003o0?l001d0oooo0P3o00000`000?l0o`000?ooo`0<0?ooo`030000003oool0oooo00D0
oooo000E0?ooo`030000003oool0oooo00<0oooo00<0003o0?l0003oool0303oool00`3o0000oooo
0?l000080?ooo`80o`0000@0oooo0?l000000?l0o`001P3oool0103o0000oooo0?ooo`3oool20?l0
00H0oooo0P3o00040?ooo`80o`00?03oool20?l000<0oooo0P3o00080?ooo`80o`000P3oool20?l0
00X0oooo00H0o`000000o`3o0000o`000000o`3o00090?ooo`80o`000P3oool00`3o0000003o0?l0
000I0?ooo`040?l000000?l0oooo0?l001d0oooo0P3o00000`000?l0o`000?ooo`0<0?ooo`030000
003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00@0oooo00<0o`000?ooo`3oool02`3o
ool20?l000T0oooo0P3o0000103oool0o`000000o`3o00060?ooo`040?l0003oool0oooo0?ooo`80
o`001P3oool20?l000@0oooo0P3o000l0?ooo`80o`000`3oool20?l000P0oooo0P3o00020?ooo`80
o`002P3oool01P3o0000003o0?l0003o0000003o0?l000T0oooo0P3o00020?ooo`030?l000000?l0
o`0001T0oooo00@0o`000000o`3oool0o`007@3oool20?l000030000o`3o0000oooo00`0oooo00<0
00000?ooo`3oool01@3oool001D0oooo0P0000050?ooo`030?l0003oool0oooo00`0oooo00<0o`00
0?ooo`3oool01`3oool20?l000030?ooo`3o0000o`0000L0oooo00@0o`000?ooo`3oool0oooo0P3o
00060?ooo`80o`00103oool20?l003`0oooo0P3o00030?ooo`030?l0003oool0oooo00L0oooo0P3o
00020?ooo`80o`002P3oool00`3o0000003o0?ooo`020?l000X0oooo0P3o00020?ooo`030?l00000
0?l0o`0001T0oooo00@0o`000000o`3oool0o`007@3oool0103o0000003o0000o`3o000<0?ooo`80
00001`3oool001D0oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`0<0?ooo`030?l0
003oool0oooo00L0oooo0P3o00000`3oool0o`000?l000070?ooo`040?l0003oool0oooo0?ooo`80
o`001P3oool20?l000<0oooo00<0o`000000o`3o0000?03oool20?l00080oooo0P3o00090?ooo`80
o`000P3oool20?l000/0oooo00@0o`000?ooo`3oool0o`002P3oool20?l00080oooo00<0o`000000
o`3o00006@3oool00`3o0000oooo0?l0000N0?ooo`040?l000000?l0003o0?l000d0oooo00<00000
0?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`0<0?oo
o`030?l0003oool0oooo00L0oooo0`3o00000`3oool0o`000?ooo`060?ooo`040?l0003oool0oooo
0?ooo`80o`001P3oool20?l000<0oooo00<0o`000000o`3o0000?03oool20?l00080oooo0P3o0009
0?ooo`80o`000P3oool20?l000/0oooo00@0o`000?ooo`000?l0o`002P3oool20?l00080oooo0P3o
000J0?ooo`030?l0003oool0o`0001h0oooo00@0o`000000o`000?l0o`003@3oool00`000000oooo
0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo00`0oooo00<0
o`000?ooo`3oool01`3oool30?l000030?ooo`3o0000oooo00H0oooo00@0o`000?ooo`3oool0oooo
0P3o00060?ooo`80o`000`3oool00`3o0000003o0?l0000l0?ooo`80o`000P3oool20?l000T0oooo
0P3o00020?ooo`80o`002`3oool0103o0000oooo0000o`3o000:0?ooo`80o`000P3oool20?l001X0
oooo00<0o`000?ooo`3o00007P3oool0103o0000003o0000o`3o000=0?ooo`030000003oool0oooo
00D0oooo000E0?ooo`8000001@3oool00`3o0000oooo0?ooo`0<0?ooo`030?l0003oool0oooo00L0
oooo0`3o00000`000?l0o`000?ooo`060?ooo`040?l0003oool0oooo0?ooo`80o`001P3oool20?l0
00<0oooo00<0o`000000o`3o0000?03oool20?l00080oooo0P3o00090?ooo`80o`000P3oool20?l0
00/0oooo00@0o`000?ooo`000?l0o`002P3oool20?l00080oooo0P3o000K0?ooo`80o`007P3oool0
103o0000003o0000o`3o000<0?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool0103oool0
0`3o0000oooo0?ooo`0<0?ooo`030?l0003oool0oooo00L0oooo0`3o00000`000?l0o`000?ooo`06
0?ooo`040?l0003oool0oooo0?ooo`80o`001P3oool20?l000<0oooo0P3o000m0?ooo`80o`000P3o
ool20?l000T0oooo0P3o00020?ooo`80o`002`3oool0103o0000oooo0000o`3o000:0?ooo`80o`00
0P3oool20?l001/0oooo0P3o000N0?ooo`040?l000000?l0oooo0?l000d0oooo00<000000?ooo`3o
ool01@3oool000L0oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`040?ooo`030?l0
003oool0oooo01H0oooo00D0o`000000o`3oool0003o0?l000070?ooo`040?l0003oool0oooo0?oo
o`80o`001P3oool20?l000<0oooo0P3o000m0?ooo`80o`000P3oool20?l000T0oooo0P3o00020?oo
o`80o`002`3oool0103o0000oooo0000o`3o000:0?ooo`80o`000P3oool20?l001/0oooo0P3o000O
0?ooo`80o`003P3oool00`000000oooo0?ooo`050?ooo`001P3oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`030?ooo`030?l0003o
ool0oooo01L0oooo00D0o`000000o`3oool0003o0?l000070?ooo`040?l0003oool0oooo0?ooo`80
o`001P3oool20?l000<0oooo0P3o000m0?ooo`80o`000P3oool20?l000T0oooo0P3o0000103oool0
o`000000o`3o000;0?ooo`040?l000000?l0003o0?l000X0oooo0P3o00020?ooo`80o`006`3oool2
0?l001l0oooo0P3o000>0?ooo`030000003oool0oooo00D0oooo000:0?ooo`040000003oool0oooo
00000080oooo00<000000?ooo`3oool00P3oool2000000@0oooo00<0o`000?ooo`3oool05`3oool0
1@3o0000003o0?ooo`000?l0o`0000L0oooo00D0o`000?ooo`3oool0oooo0?l000070?ooo`80o`00
0`3oool20?l003d0oooo0P3o00020?ooo`80o`002P3oool01@3o0000oooo0?l000000?l0o`0000/0
oooo00@0o`000000o`000?l0o`002P3oool20?l00080oooo0P3o000K0?ooo`030?l0003oool0oooo
01h0oooo0P3o000<0?ooo`<000001`3oool000X0oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool05`3oool01@3o
0000003o0?ooo`000?l0o`0000L0oooo00D0o`000?ooo`3oool0oooo0?l000070?ooo`80o`000`3o
ool20?l003d0oooo0P3o00020?ooo`80o`002P3oool0103o0000oooo0?l0003o000<0?ooo`040?l0
003oool0003o0?l000X0oooo0P3o00020?ooo`80o`006`3oool00`3o0000oooo0?ooo`0N0?ooo`80
o`003P3oool00`000000oooo0?ooo`050?ooo`001P3oool4000000<0oooo00@000000?ooo`3oool0
0000103oool00`000000oooo0?ooo`0M0?ooo`050?l000000?l0oooo0000o`3o00001`3oool01@3o
0000oooo0?ooo`3oool0o`0000L0oooo0P3o00030?ooo`80o`00?@3oool20?l00080oooo0P3o000:
0?ooo`040?l0003oool0o`000?l000`0oooo00@0o`000?ooo`3oool0o`002P3oool20?l00080oooo
0P3o000K0?ooo`030?l0003oool0oooo01h0oooo0P3o000>0?ooo`030000003oool0oooo00D0oooo
00060?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool00000103oool00`000000oooo
0?ooo`0M0?ooo`050?l000000?l0oooo0000o`3o00001`3oool01@3o0000oooo0?ooo`3oool0o`00
00L0oooo0P3o00030?ooo`80o`00?@3oool20?l00080oooo0P3o000:0?ooo`040?l0003oool0o`00
0?l000`0oooo00@0o`000?ooo`3oool0o`002P3oool20?l00080oooo0P3o000l0?ooo`80o`003P3o
ool00`000000oooo0?ooo`050?ooo`001P3oool5000000<0oooo0P0000050?ooo`030000003oool0
oooo01h0oooo00@0o`000000o`3oool0o`001`3oool00`3o0000oooo0?ooo`020?l000L0oooo0P3o
00030?ooo`80o`00?@3oool20?l00080oooo0P3o000:0?ooo`@0o`00303oool00`3o0000oooo0?l0
000;0?ooo`80o`0000@0oooo0?l000000?l0o`00?03oool20?l000h0oooo00<000000?ooo`3oool0
1@3oool001D0oooo0P00000O0?ooo`030?l000000?l0o`0000P0oooo00<0o`000?ooo`3oool00P3o
00070?ooo`80o`000P3oool00`3o0000003o0?l0000m0?ooo`80o`000P3oool20?l000X0oooo103o
000<0?ooo`030?l0003oool0o`0000/0oooo0P3o0000103oool0o`000000o`3o000l0?ooo`80o`00
3@3oool2000000L0oooo000E0?ooo`030000003oool0oooo01h0oooo00<0o`000000o`3o0000203o
ool00`3o0000oooo0?ooo`020?l000L0oooo0P3o00020?ooo`030?l000000?l0o`0003h0oooo00<0
o`000?ooo`3oool00P3o000:0?ooo`@0o`00303oool00`3o0000oooo0?l0000;0?ooo`80o`0000@0
oooo0?l000000?l0o`00?03oool20?l000h0oooo00<000000?ooo`3oool01@3oool001D0oooo00<0
00000?ooo`3oool07P3oool00`3o0000003o0?l000080?ooo`030?l0003oool0oooo0080o`001`3o
ool20?l00080oooo00<0o`000000o`3o0000?P3oool00`3o0000oooo0?ooo`020?l000X0oooo103o
000<0?ooo`030?l0003oool0o`0000/0oooo0P3o00000`3oool0o`000?l0000m0?ooo`030?l0003o
ool0oooo00d0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool07P3oool0
0`3o0000oooo0?l000080?ooo`030?l0003oool0oooo0080o`001`3oool20?l00080oooo00<0o`00
0000o`3o0000?P3oool00`3o0000oooo0?ooo`020?l000X0oooo0P3o00000`3oool0o`000?ooo`0;
0?ooo`030?l0003oool0o`0000/0oooo0P3o00000`3oool0o`000?l0000m0?ooo`030?l0003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool001D0oooo0P00000O0?ooo`030?l0003oool0o`00
00P0oooo00<0o`000?ooo`3oool00P3o00070?ooo`80o`000P3oool00`3o0000003o0?l0000n0?oo
o`030?l0003oool0oooo0080o`002P3oool20?l000030000o`3o0000oooo00`0oooo0P3o000<0?oo
o`040?l0003oool0o`000?l003d0oooo00<0o`000?ooo`3oool0303oool2000000L0oooo000E0?oo
o`030000003oool0oooo01h0oooo00<0o`000?ooo`3o0000203oool00`3o0000oooo0?ooo`020?l0
00P0oooo00H0o`000?ooo`3oool0o`000000o`3o000n0?ooo`050?l0003oool0o`000000o`3o0000
2P3oool20?l000030000o`3o0000oooo00`0oooo0P3o000<0?ooo`@0o`00?@3oool00`3o0000oooo
0?ooo`0=0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo01h0oooo00<0
o`000?ooo`3o0000203oool00`3o0000oooo0?ooo`020?l000P0oooo0P3o0000103oool0o`000000
o`3o000n0?ooo`050?l0003oool0o`000000o`3o00002P3oool20?l000030000o`3o0000oooo00d0
oooo00<0o`000?ooo`3oool02P3oool40?l004d0oooo00<000000?ooo`3oool01@3oool001D0oooo
00<000000?ooo`3oool07P3oool00`3o0000oooo0?l000080?ooo`030?l0003oool0oooo0080o`00
203oool20?l000040?ooo`3o0000003o0?l003h0oooo00D0o`000?ooo`3o0000003o0?l0000:0?oo
o`80o`0000<0003o0?l0003oool06P3oool40?l004d0oooo00<000000?ooo`3oool01@3oool001D0
oooo00<000000?ooo`3oool07P3oool20?l000T0oooo0P3o00000`3oool0o`000?l000080?ooo`80
o`0000<0oooo0?l0003o0000?`3oool0103o0000oooo0?l0003o000;0?ooo`040?l0003oool0003o
0?l001/0oooo103o001=0?ooo`030000003oool0oooo00D0oooo000E0?ooo`8000007`3oool20?l0
00T0oooo0P3o00000`3oool0o`000?l000080?ooo`80o`0000<0oooo0?l0003o0000?`3oool0103o
0000oooo0?l0003o000;0?ooo`040?l000000?l0003o0?l001/0oooo103o001<0?ooo`8000001`3o
ool001D0oooo00<000000?ooo`3oool07P3oool20?l000T0oooo0P3o00000`3oool0o`000?l00008
0?ooo`80o`0000<0oooo0?l0003o0000?`3oool0103o0000oooo0?l0003o000;0?ooo`040?l00000
0?l0003o0?l001/0oooo103o001=0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003o
ool0oooo01h0oooo0P3o00090?ooo`80o`0000<0oooo0?l0003o0000203oool20?l000030?ooo`3o
0000o`0003l0oooo00@0o`000?ooo`3o0000o`002`3oool0103o0000003o0000o`3o000K0?ooo`@0
o`00C@3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0N0?ooo`030?l0
003oool0oooo00P0oooo0P3o00000`3oool0o`000?l000080?ooo`80o`0000<0oooo0?l0003o0000
?`3oool0103o0000oooo0?l0003o000;0?ooo`040?l000000?l0003o0?l001/0oooo0P3o00000`00
0?l0o`000?ooo`1<0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000:P3oool20?l00003
0?ooo`3o0000o`0000P0oooo0`3o00000`000?l0o`000?ooo`0n0?ooo`040?l0003oool0o`000?l0
00/0oooo00<0o`000000o`3o0000703oool20?l000030000o`3o0000oooo04/0oooo0P0000070?oo
o`005@3oool00`000000oooo0?ooo`0Y0?ooo`80o`0000<0oooo0?l0003o0000203oool30?l00003
0000o`3o0000oooo03h0oooo103o000;0?ooo`030?l000000?l0o`0001`0oooo0P3o00000`000?l0
o`000?ooo`1<0?ooo`030000003oool0oooo00D0oooo00080?ooo`030000003oool0oooo0080oooo
0`0000050?ooo`030000003oool0oooo02T0oooo0P3o00000`3oool0o`000?l000080?ooo`<0o`00
00<0003o0?l0003oool0?P3oool40?l000/0oooo00<0o`000000o`3o0000703oool0103o0000003o
0000o`3o001=0?ooo`030000003oool0oooo00D0oooo00080?ooo`050000003oool0oooo0?ooo`00
00000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo02T0oooo0P3o00000`3oool0
o`000?l000080?ooo`<0o`0000<0003o0?l0003oool0?P3oool20?l000030000o`3o0000oooo00X0
oooo00<0o`000000o`3o0000703oool0103o0000003o0000o`3o001=0?ooo`030000003oool0oooo
00D0oooo00090?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`0Y0?ooo`80o`0000<0oooo0?l0003o0000203oool30?l000030000o`3o0000oooo03h0
oooo0P3o00000`000?l0o`000?ooo`0:0?ooo`030?l000000?l0o`0001`0oooo00@0o`000000o`00
0?l0o`00C@3oool00`000000oooo0?ooo`050?ooo`002@3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo0P00000Z0?ooo`80o`0000<0oooo0?l0003oool0203oool01@3o0000
003o0?l000000?l0o`0003l0oooo0P3o00000`000?l0o`000?ooo`0:0?ooo`030?l0003oool0o`00
01`0oooo00<0o`000000o`3o0000C03oool3000000L0oooo000:0?ooo`030000003oool0000000<0
00001@3oool00`000000oooo0?ooo`0Y0?ooo`80o`0000<0oooo0?l0003oool0203oool01@3o0000
003o0?l000000?l0o`0003l0oooo0P3o00000`000?l0o`000?ooo`0;0?ooo`80o`00703oool00`3o
0000003o0?l0001>0?ooo`030000003oool0oooo00D0oooo00060?ooo`070000003oool0oooo0?oo
o`000000oooo000000080?ooo`030000003oool0oooo02T0oooo0P3o00000`3oool0o`000?ooo`08
0?ooo`040?l000000?l0o`000?l00400oooo0P3o00000`000?l0o`000?ooo`0;0?ooo`80o`00703o
ool00`3o0000003o0?l0001>0?ooo`030000003oool0oooo00D0oooo00060?ooo`D0000000<0oooo
0000000000000`0000040?ooo`030000003oool0oooo02T0oooo103o00090?ooo`040?l000000?l0
oooo0?l00400oooo0P3o00000`000?l0o`000?ooo`0;0?ooo`80o`00703oool00`3o0000003o0?l0
001>0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000:P3oool40?l000T0oooo00@0o`00
0000o`3oool0o`00@03oool0103o0000oooo0000o`3o000<0?ooo`030?l0003oool0oooo01/0oooo
00<0o`000000o`3o0000C@3oool2000000L0oooo000E0?ooo`030000003oool0oooo02T0oooo103o
00090?ooo`040?l000000?l0003o0?l00400oooo00@0o`000?ooo`000?l0o`00303oool00`3o0000
oooo0?ooo`0K0?ooo`030?l000000?l0o`0004h0oooo00<000000?ooo`3oool01@3oool001D0oooo
00<000000?ooo`3oool0:@3oool40?l000T0oooo00@0o`000000o`000?l0o`00@03oool0103o0000
003o0000o`3o000<0?ooo`030?l0003oool0oooo01/0oooo00<0o`000000o`3o0000CP3oool00`00
0000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0Y0?ooo`@0o`002P3oool00`3o0000
003o0?l000100?ooo`030?l000000?l0o`0000d0oooo00<0o`000?ooo`3oool0703oool20?l004h0
oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0:@3oool40?l000X0oooo
00<0o`000000o`3o0000@03oool00`3o0000003o0?l0000=0?ooo`030?l0003oool0oooo01`0oooo
0P3o001>0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000:`3oool30?l000X0oooo00<0
o`000000o`3o0000@03oool00`3o0000003o0?l0000/0?ooo`80o`00C@3oool2000000L0oooo000E
0?ooo`030000003oool0oooo02X0oooo00<0o`000?ooo`3o00002P3oool00`3o0000003o0?l00010
0?ooo`030?l000000?l0o`0002`0oooo0P3o001>0?ooo`030000003oool0oooo00D0oooo000E0?oo
o`030000003oool0oooo02X0oooo00<0o`000?ooo`3o00002P3oool00`3o0000003o0?l000100?oo
o`030?l000000?l0o`0002`0oooo0P3o001>0?ooo`030000003oool0oooo00D0oooo000E0?ooo`03
0000003oool0oooo02X0oooo00<0o`000?ooo`3o00002P3oool00`3o0000003o0?l000100?ooo`03
0?l000000?l0o`0002`0oooo0P3o001>0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000
:`3oool00`3o0000003o0?l0000:0?ooo`030?l0003oool0o`000400oooo00<0o`000000o`3o0000
;03oool00`3o0000oooo0?ooo`1<0?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool0:P3o
ool00`3o0000003o0?l0000:0?ooo`030?l0003oool0o`000400oooo00<0o`000?ooo`3o0000;03o
ool00`3o0000oooo0?ooo`1=0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0
oooo02X0oooo00<0o`000000o`3o00002P3oool20?l00440oooo00<0o`000?ooo`3o0000;03oool0
0`3o0000oooo0?ooo`1=0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo
02X0oooo00<0o`000000o`3o00002P3oool20?l00480oooo0P3o000/0?ooo`030?l0003oool0oooo
04d0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0:P3oool00`3o0000
003o0?l0000:0?ooo`80o`00@P3oool20?l007`0oooo00<000000?ooo`3oool01@3oool001D0oooo
0P00000[0?ooo`030?l000000?l0o`0000X0oooo0P3o00120?ooo`030?l0003oool0oooo07X0oooo
0P0000070?ooo`005@3oool00`000000oooo0?ooo`0Z0?ooo`030?l000000?l0o`0000X0oooo0P3o
00120?ooo`030?l0003oool0oooo07/0oooo00<000000?ooo`3oool01@3oool000040?ooo`000000
0000000000@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`0Z0?ooo`030?l0003o
ool0o`0000/0oooo00<0o`000?ooo`3oool0@03oool00`3o0000oooo0?ooo`1k0?ooo`030000003o
ool0oooo00D0oooo00020?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo02X0oooo00<0o`000?ooo`3o0000
2`3oool00`3o0000oooo0?ooo`100?ooo`030?l0003oool0oooo07/0oooo00<000000?ooo`3oool0
1@3oool00080oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000@0oooo0P00000[0?ooo`80o`00303oool00`3o0000oooo0?ooo`100?ooo`03
0?l0003oool0oooo07T0oooo0`0000070?ooo`000P3oool00`000000oooo0?ooo`020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0Z0?oo
o`80o`00C`3oool00`3o0000oooo0?ooo`1k0?ooo`030000003oool0oooo00D0oooo00020?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000004
0?ooo`030000003oool0oooo02X0oooo0P3o003=0?ooo`030000003oool0oooo00D0oooo00000`3o
ool00000000000040?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103o
ool00`000000oooo0?ooo`0Z0?ooo`80o`00c@3oool00`000000oooo0?ooo`050?ooo`000P3oool0
0`000000oooo0?ooo`030?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool0:P3oool2
0?l00<d0oooo00<000000?ooo`3oool01@3oool001D0oooo0P00000[0?ooo`80o`00c03oool20000
00L0oooo000E0?ooo`030000003oool0oooo02X0oooo0P3o003=0?ooo`030000003oool0oooo00D0
oooo000E0?ooo`030000003oool0oooo02X0oooo00<0o`000?ooo`3oool0c03oool00`000000oooo
0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0Z0?ooo`030?l0003oool0oooo0<`0oooo00<0
00000?ooo`3oool01@3oool001D0oooo0P00000[0?ooo`030?l0003oool0oooo0</0oooo0P000007
0?ooo`005@3oool00`000000oooo0?ooo`0Z0?ooo`030?l0003oool0oooo0<`0oooo00<000000?oo
o`3oool01@3oool001D0oooo00<000000?ooo`3oool0n@3oool00`000000oooo0?ooo`050?ooo`00
5@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`050?ooo`005@3oool2000000D0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`040000003oool0oooo0?ooo`8000001`3oool001D0ooooo@00
00070?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.938, 0}} -> {1729.2, -75.3935, \
0.729416, 1.12086}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{176, 5}\),
      SequenceForm[ "Dimension der Daten  ", {176, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-9.49456 0.00544218 0.242739 0.0037592 [
[.02925 -0.0125 -12 -9 ]
[.02925 -0.0125 12 0 ]
[.16531 -0.0125 -12 -9 ]
[.16531 -0.0125 12 0 ]
[.30136 -0.0125 -12 -9 ]
[.30136 -0.0125 12 0 ]
[.43741 -0.0125 -12 -9 ]
[.43741 -0.0125 12 0 ]
[.57347 -0.0125 -12 -9 ]
[.57347 -0.0125 12 0 ]
[.70952 -0.0125 -12 -9 ]
[.70952 -0.0125 12 0 ]
[.84558 -0.0125 -12 -9 ]
[.84558 -0.0125 12 0 ]
[.98163 -0.0125 -12 -9 ]
[.98163 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05478 -18 -4.5 ]
[-0.0125 .05478 0 4.5 ]
[-0.0125 .14876 -18 -4.5 ]
[-0.0125 .14876 0 4.5 ]
[-0.0125 .24274 -6 -4.5 ]
[-0.0125 .24274 0 4.5 ]
[-0.0125 .33672 -12 -4.5 ]
[-0.0125 .33672 0 4.5 ]
[-0.0125 .4307 -12 -4.5 ]
[-0.0125 .4307 0 4.5 ]
[-0.0125 .52468 -12 -4.5 ]
[-0.0125 .52468 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .29506 -5 -6 ]
[.97619 .29506 5 6 ]
[.97619 .29506 -5 -6 ]
[.97619 .29506 5 6 ]
[.97619 .41065 -5 -6 ]
[.97619 .41065 5 6 ]
[.97619 .17948 -5 -6 ]
[.97619 .17948 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02925 0 m
.02925 .00625 L
s
[(1750)] .02925 -0.0125 0 1 Mshowa
.16531 0 m
.16531 .00625 L
s
[(1775)] .16531 -0.0125 0 1 Mshowa
.30136 0 m
.30136 .00625 L
s
[(1800)] .30136 -0.0125 0 1 Mshowa
.43741 0 m
.43741 .00625 L
s
[(1825)] .43741 -0.0125 0 1 Mshowa
.57347 0 m
.57347 .00625 L
s
[(1850)] .57347 -0.0125 0 1 Mshowa
.70952 0 m
.70952 .00625 L
s
[(1875)] .70952 -0.0125 0 1 Mshowa
.84558 0 m
.84558 .00625 L
s
[(1900)] .84558 -0.0125 0 1 Mshowa
.98163 0 m
.98163 .00625 L
s
[(1925)] .98163 -0.0125 0 1 Mshowa
.125 Mabswid
.05646 0 m
.05646 .00375 L
s
.08367 0 m
.08367 .00375 L
s
.11088 0 m
.11088 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.19252 0 m
.19252 .00375 L
s
.21973 0 m
.21973 .00375 L
s
.24694 0 m
.24694 .00375 L
s
.27415 0 m
.27415 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.35578 0 m
.35578 .00375 L
s
.38299 0 m
.38299 .00375 L
s
.4102 0 m
.4102 .00375 L
s
.46463 0 m
.46463 .00375 L
s
.49184 0 m
.49184 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.54626 0 m
.54626 .00375 L
s
.60068 0 m
.60068 .00375 L
s
.62789 0 m
.62789 .00375 L
s
.6551 0 m
.6551 .00375 L
s
.68231 0 m
.68231 .00375 L
s
.73673 0 m
.73673 .00375 L
s
.76395 0 m
.76395 .00375 L
s
.79116 0 m
.79116 .00375 L
s
.81837 0 m
.81837 .00375 L
s
.87279 0 m
.87279 .00375 L
s
.9 0 m
.9 .00375 L
s
.92721 0 m
.92721 .00375 L
s
.95442 0 m
.95442 .00375 L
s
.00204 0 m
.00204 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05478 m
.00625 .05478 L
s
[(-50)] -0.0125 .05478 1 0 Mshowa
0 .14876 m
.00625 .14876 L
s
[(-25)] -0.0125 .14876 1 0 Mshowa
0 .24274 m
.00625 .24274 L
s
[(0)] -0.0125 .24274 1 0 Mshowa
0 .33672 m
.00625 .33672 L
s
[(25)] -0.0125 .33672 1 0 Mshowa
0 .4307 m
.00625 .4307 L
s
[(50)] -0.0125 .4307 1 0 Mshowa
0 .52468 m
.00625 .52468 L
s
[(75)] -0.0125 .52468 1 0 Mshowa
.125 Mabswid
0 .07358 m
.00375 .07358 L
s
0 .09237 m
.00375 .09237 L
s
0 .11117 m
.00375 .11117 L
s
0 .12996 m
.00375 .12996 L
s
0 .16756 m
.00375 .16756 L
s
0 .18635 m
.00375 .18635 L
s
0 .20515 m
.00375 .20515 L
s
0 .22394 m
.00375 .22394 L
s
0 .26154 m
.00375 .26154 L
s
0 .28033 m
.00375 .28033 L
s
0 .29913 m
.00375 .29913 L
s
0 .31792 m
.00375 .31792 L
s
0 .35552 m
.00375 .35552 L
s
0 .37431 m
.00375 .37431 L
s
0 .39311 m
.00375 .39311 L
s
0 .4119 m
.00375 .4119 L
s
0 .4495 m
.00375 .4495 L
s
0 .46829 m
.00375 .46829 L
s
0 .48709 m
.00375 .48709 L
s
0 .50588 m
.00375 .50588 L
s
0 .54348 m
.00375 .54348 L
s
0 .56227 m
.00375 .56227 L
s
0 .58107 m
.00375 .58107 L
s
0 .59986 m
.00375 .59986 L
s
0 .03598 m
.00375 .03598 L
s
0 .01719 m
.00375 .01719 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02925 .61178 m
.02925 .61803 L
s
.16531 .61178 m
.16531 .61803 L
s
.30136 .61178 m
.30136 .61803 L
s
.43741 .61178 m
.43741 .61803 L
s
.57347 .61178 m
.57347 .61803 L
s
.70952 .61178 m
.70952 .61803 L
s
.84558 .61178 m
.84558 .61803 L
s
.98163 .61178 m
.98163 .61803 L
s
.125 Mabswid
.05646 .61428 m
.05646 .61803 L
s
.08367 .61428 m
.08367 .61803 L
s
.11088 .61428 m
.11088 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.19252 .61428 m
.19252 .61803 L
s
.21973 .61428 m
.21973 .61803 L
s
.24694 .61428 m
.24694 .61803 L
s
.27415 .61428 m
.27415 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.35578 .61428 m
.35578 .61803 L
s
.38299 .61428 m
.38299 .61803 L
s
.4102 .61428 m
.4102 .61803 L
s
.46463 .61428 m
.46463 .61803 L
s
.49184 .61428 m
.49184 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.54626 .61428 m
.54626 .61803 L
s
.60068 .61428 m
.60068 .61803 L
s
.62789 .61428 m
.62789 .61803 L
s
.6551 .61428 m
.6551 .61803 L
s
.68231 .61428 m
.68231 .61803 L
s
.73673 .61428 m
.73673 .61803 L
s
.76395 .61428 m
.76395 .61803 L
s
.79116 .61428 m
.79116 .61803 L
s
.81837 .61428 m
.81837 .61803 L
s
.87279 .61428 m
.87279 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.92721 .61428 m
.92721 .61803 L
s
.95442 .61428 m
.95442 .61803 L
s
.00204 .61428 m
.00204 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05478 m
1 .05478 L
s
.99375 .14876 m
1 .14876 L
s
.99375 .24274 m
1 .24274 L
s
.99375 .33672 m
1 .33672 L
s
.99375 .4307 m
1 .4307 L
s
.99375 .52468 m
1 .52468 L
s
.125 Mabswid
.99625 .07358 m
1 .07358 L
s
.99625 .09237 m
1 .09237 L
s
.99625 .11117 m
1 .11117 L
s
.99625 .12996 m
1 .12996 L
s
.99625 .16756 m
1 .16756 L
s
.99625 .18635 m
1 .18635 L
s
.99625 .20515 m
1 .20515 L
s
.99625 .22394 m
1 .22394 L
s
.99625 .26154 m
1 .26154 L
s
.99625 .28033 m
1 .28033 L
s
.99625 .29913 m
1 .29913 L
s
.99625 .31792 m
1 .31792 L
s
.99625 .35552 m
1 .35552 L
s
.99625 .37431 m
1 .37431 L
s
.99625 .39311 m
1 .39311 L
s
.99625 .4119 m
1 .4119 L
s
.99625 .4495 m
1 .4495 L
s
.99625 .46829 m
1 .46829 L
s
.99625 .48709 m
1 .48709 L
s
.99625 .50588 m
1 .50588 L
s
.99625 .54348 m
1 .54348 L
s
.99625 .56227 m
1 .56227 L
s
.99625 .58107 m
1 .58107 L
s
.99625 .59986 m
1 .59986 L
s
.99625 .03598 m
1 .03598 L
s
.99625 .01719 m
1 .01719 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 .98 .604 r
gsave
.97619 .29506 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .27066 m
.02925 .17458 L
.03469 .17222 L
.04014 .20827 L
.04558 .17713 L
.05102 .19743 L
.05646 .2388 L
.0619 .29046 L
.06735 .31587 L
.07279 .28278 L
.07823 .27438 L
.08367 .30564 L
.08912 .23973 L
.09456 .16336 L
.1 .1905 L
.10544 .19346 L
.11088 .1909 L
.11633 .2724 L
.12177 .36266 L
.12721 .38351 L
.13265 .30332 L
.1381 .1936 L
.14354 .16924 L
.14898 .15408 L
.15442 .17153 L
.15986 .17727 L
.16531 .21796 L
.17075 .41933 L
.17619 .51986 L
.18163 .31093 L
.18707 .09817 L
.19252 .11895 L
.19796 .15609 L
.2034 .15698 L
.20884 .17934 L
.21429 .24276 L
.21973 .39078 L
.22517 .46176 L
.23061 .34161 L
.23605 .2097 L
.2415 .15354 L
.24694 .14179 L
.25238 .1861 L
.25782 .21043 L
.26327 .20909 L
.26871 .19395 L
.27415 .19488 L
.27959 .21334 L
.28503 .2206 L
.29048 .24138 L
Mistroke
.29592 .26351 L
.30136 .29771 L
.3068 .30233 L
.31224 .2609 L
.31769 .24716 L
.32313 .24146 L
.32857 .20455 L
.33401 .1791 L
.33946 .20367 L
.3449 .22925 L
.35034 .2289 L
.35578 .24005 L
.36122 .25298 L
.36667 .26123 L
.37211 .2591 L
.37755 .28947 L
.38299 .30667 L
.38844 .25499 L
.39388 .21029 L
.39932 .20778 L
.40476 .21437 L
.4102 .21031 L
.41565 .21943 L
.42109 .23299 L
.42653 .25018 L
.43197 .27084 L
.43741 .29675 L
.44286 .30701 L
.4483 .2935 L
.45374 .27807 L
.45918 .26069 L
.46463 .20568 L
.47007 .15452 L
.47551 .15613 L
.48095 .20781 L
.48639 .34122 L
.49184 .46703 L
.49728 .40695 L
.50272 .20396 L
.50816 .13172 L
.51361 .16106 L
.51905 .15271 L
.52449 .16709 L
.52993 .18999 L
.53537 .22517 L
.54082 .29712 L
.54626 .33426 L
.5517 .3641 L
.55714 .36798 L
.56259 .23439 L
Mistroke
.56803 .12405 L
.57347 .17769 L
.57891 .22471 L
.58435 .19916 L
.5898 .17634 L
.59524 .17644 L
.60068 .20724 L
.60612 .27191 L
.61156 .34597 L
.61701 .38778 L
.62245 .32447 L
.62789 .20698 L
.63333 .16301 L
.63878 .1785 L
.64422 .22386 L
.64966 .21984 L
.6551 .17938 L
.66054 .18954 L
.66599 .27762 L
.67143 .38284 L
.67687 .44856 L
.68231 .31832 L
.68776 .16639 L
.6932 .1465 L
.69864 .13302 L
.70408 .14662 L
.70952 .1828 L
.71497 .23552 L
.72041 .22682 L
.72585 .22837 L
.73129 .29927 L
.73673 .33953 L
.74218 .29754 L
.74762 .25974 L
.75306 .25065 L
.7585 .22047 L
.76395 .16724 L
.76939 .16504 L
.77483 .20681 L
.78027 .22845 L
.78571 .23997 L
.79116 .30074 L
.7966 .37517 L
.80204 .34343 L
.80748 .25239 L
.81293 .19705 L
.81837 .16826 L
.82381 .17071 L
.82925 .21491 L
.83469 .21904 L
Mistroke
.84014 .21049 L
.84558 .22068 L
.85102 .23306 L
.85646 .2837 L
.8619 .31902 L
.86735 .31933 L
.87279 .26552 L
.87823 .2379 L
.88367 .23259 L
.88912 .20971 L
.89456 .18234 L
.9 .16902 L
.90544 .21169 L
.91088 .23245 L
.91633 .25522 L
.92177 .32772 L
.92721 .34208 L
.93265 .35709 L
.9381 .28747 L
.94354 .16281 L
.94898 .15167 L
.95442 .17184 L
.95986 .19718 L
.96531 .20393 L
.97075 .2473 L
.97619 .29506 L
Mfstroke
gsave
.97619 .29506 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27066 m
.02925 .17458 L
.03469 .17222 L
.04014 .20827 L
.04558 .17713 L
.05102 .19743 L
.05646 .2388 L
.0619 .29046 L
.06735 .31587 L
.07279 .28278 L
.07823 .27438 L
.08367 .30564 L
.08912 .23973 L
.09456 .16336 L
.1 .1905 L
.10544 .19346 L
.11088 .1909 L
.11633 .2724 L
.12177 .36266 L
.12721 .38351 L
.13265 .30332 L
.1381 .1936 L
.14354 .16924 L
.14898 .15408 L
.15442 .17153 L
.15986 .17727 L
.16531 .21796 L
.17075 .41933 L
.17619 .51986 L
.18163 .31093 L
.18707 .09817 L
.19252 .11895 L
.19796 .15609 L
.2034 .15698 L
.20884 .17934 L
.21429 .24276 L
.21973 .39078 L
.22517 .46176 L
.23061 .34161 L
.23605 .2097 L
.2415 .15354 L
.24694 .14179 L
.25238 .1861 L
.25782 .21043 L
.26327 .20909 L
.26871 .19395 L
.27415 .19488 L
.27959 .21334 L
.28503 .2206 L
.29048 .24138 L
Mistroke
.29592 .26351 L
.30136 .29771 L
.3068 .30233 L
.31224 .2609 L
.31769 .24716 L
.32313 .24146 L
.32857 .20455 L
.33401 .1791 L
.33946 .20367 L
.3449 .22925 L
.35034 .2289 L
.35578 .24005 L
.36122 .25298 L
.36667 .26123 L
.37211 .2591 L
.37755 .28947 L
.38299 .30667 L
.38844 .25499 L
.39388 .21029 L
.39932 .20778 L
.40476 .21437 L
.4102 .21031 L
.41565 .21943 L
.42109 .23299 L
.42653 .25018 L
.43197 .27084 L
.43741 .29675 L
.44286 .30701 L
.4483 .2935 L
.45374 .27807 L
.45918 .26069 L
.46463 .20568 L
.47007 .15452 L
.47551 .15613 L
.48095 .20781 L
.48639 .34122 L
.49184 .46703 L
.49728 .40695 L
.50272 .20396 L
.50816 .13172 L
.51361 .16106 L
.51905 .15271 L
.52449 .16709 L
.52993 .18999 L
.53537 .22517 L
.54082 .29712 L
.54626 .33426 L
.5517 .3641 L
.55714 .36798 L
.56259 .23439 L
Mistroke
.56803 .12405 L
.57347 .17769 L
.57891 .22471 L
.58435 .19916 L
.5898 .17634 L
.59524 .17644 L
.60068 .20724 L
.60612 .27191 L
.61156 .34597 L
.61701 .38778 L
.62245 .32447 L
.62789 .20698 L
.63333 .16301 L
.63878 .1785 L
.64422 .22386 L
.64966 .21984 L
.6551 .17938 L
.66054 .18954 L
.66599 .27762 L
.67143 .38284 L
.67687 .44856 L
.68231 .31832 L
.68776 .16639 L
.6932 .1465 L
.69864 .13302 L
.70408 .14662 L
.70952 .1828 L
.71497 .23552 L
.72041 .22682 L
.72585 .22837 L
.73129 .29927 L
.73673 .33953 L
.74218 .29754 L
.74762 .25974 L
.75306 .25065 L
.7585 .22047 L
.76395 .16724 L
.76939 .16504 L
.77483 .20681 L
.78027 .22845 L
.78571 .23997 L
.79116 .30074 L
.7966 .37517 L
.80204 .34343 L
.80748 .25239 L
.81293 .19705 L
.81837 .16826 L
.82381 .17071 L
.82925 .21491 L
.83469 .21904 L
Mistroke
.84014 .21049 L
.84558 .22068 L
.85102 .23306 L
.85646 .2837 L
.8619 .31902 L
.86735 .31933 L
.87279 .26552 L
.87823 .2379 L
.88367 .23259 L
.88912 .20971 L
.89456 .18234 L
.9 .16902 L
.90544 .21169 L
.91088 .23245 L
.91633 .25522 L
.92177 .32772 L
.92721 .34208 L
.93265 .35709 L
.9381 .28747 L
.94354 .16281 L
.94898 .15167 L
.95442 .17184 L
.95986 .19718 L
.96531 .20393 L
.97075 .2473 L
.97619 .29506 L
Mfstroke
1 0 0 r
gsave
.97619 .41065 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .40824 m
.02925 .25884 L
.03469 .25617 L
.04014 .29174 L
.04558 .26059 L
.05102 .28088 L
.05646 .32226 L
.0619 .37392 L
.06735 .39933 L
.07279 .36624 L
.07823 .35784 L
.08367 .3891 L
.08912 .32319 L
.09456 .24682 L
.1 .27396 L
.10544 .27692 L
.11088 .27436 L
.11633 .35586 L
.12177 .44612 L
.12721 .46696 L
.13265 .38678 L
.1381 .27706 L
.14354 .2527 L
.14898 .23754 L
.15442 .25499 L
.15986 .26073 L
.16531 .30141 L
.17075 .50279 L
.17619 .60332 L
.18163 .39439 L
.18707 .18163 L
.19252 .20241 L
.19796 .23955 L
.2034 .24044 L
.20884 .2628 L
.21429 .32622 L
.21973 .47424 L
.22517 .54522 L
.23061 .42507 L
.23605 .29316 L
.2415 .237 L
.24694 .22525 L
.25238 .26956 L
.25782 .29389 L
.26327 .29255 L
.26871 .27741 L
.27415 .27834 L
.27959 .2968 L
.28503 .30406 L
.29048 .32484 L
Mistroke
.29592 .34697 L
.30136 .38117 L
.3068 .38579 L
.31224 .34436 L
.31769 .33062 L
.32313 .32492 L
.32857 .28801 L
.33401 .26256 L
.33946 .28713 L
.3449 .31271 L
.35034 .31236 L
.35578 .32351 L
.36122 .33644 L
.36667 .34469 L
.37211 .34256 L
.37755 .37293 L
.38299 .39013 L
.38844 .33845 L
.39388 .29375 L
.39932 .29124 L
.40476 .29783 L
.4102 .29377 L
.41565 .30289 L
.42109 .31644 L
.42653 .33363 L
.43197 .35429 L
.43741 .38021 L
.44286 .39047 L
.4483 .37696 L
.45374 .36153 L
.45918 .34415 L
.46463 .28914 L
.47007 .23798 L
.47551 .23959 L
.48095 .29127 L
.48639 .42468 L
.49184 .55049 L
.49728 .49041 L
.50272 .28741 L
.50816 .21518 L
.51361 .24452 L
.51905 .23617 L
.52449 .25055 L
.52993 .27344 L
.53537 .30863 L
.54082 .38058 L
.54626 .41772 L
.5517 .44756 L
.55714 .45144 L
.56259 .31785 L
Mistroke
.56803 .2075 L
.57347 .26115 L
.57891 .30817 L
.58435 .28262 L
.5898 .2598 L
.59524 .2599 L
.60068 .2907 L
.60612 .35537 L
.61156 .42943 L
.61701 .47124 L
.62245 .40793 L
.62789 .29044 L
.63333 .24647 L
.63878 .26195 L
.64422 .30731 L
.64966 .3033 L
.6551 .26284 L
.66054 .273 L
.66599 .36108 L
.67143 .4663 L
.67687 .53202 L
.68231 .40178 L
.68776 .24984 L
.6932 .22996 L
.69864 .21648 L
.70408 .23008 L
.70952 .26626 L
.71497 .31898 L
.72041 .31028 L
.72585 .31183 L
.73129 .38273 L
.73673 .42299 L
.74218 .381 L
.74762 .3432 L
.75306 .33411 L
.7585 .30393 L
.76395 .2507 L
.76939 .2485 L
.77483 .29026 L
.78027 .31191 L
.78571 .32343 L
.79116 .3842 L
.7966 .45863 L
.80204 .42689 L
.80748 .33585 L
.81293 .28051 L
.81837 .25172 L
.82381 .25417 L
.82925 .29837 L
.83469 .3025 L
Mistroke
.84014 .29395 L
.84558 .30413 L
.85102 .31652 L
.85646 .36715 L
.8619 .40248 L
.86735 .40279 L
.87279 .34898 L
.87823 .32136 L
.88367 .31605 L
.88912 .29317 L
.89456 .26579 L
.9 .25248 L
.90544 .29515 L
.91088 .31591 L
.91633 .33868 L
.92177 .41118 L
.92721 .42554 L
.93265 .44055 L
.9381 .37093 L
.94354 .24627 L
.94898 .23513 L
.95442 .2553 L
.95986 .28064 L
.96531 .28762 L
.97075 .331 L
.97619 .41065 L
Mfstroke
gsave
.97619 .17948 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13307 m
.02925 .09033 L
.03469 .08827 L
.04014 .12481 L
.04558 .09367 L
.05102 .11397 L
.05646 .15534 L
.0619 .20701 L
.06735 .23242 L
.07279 .19932 L
.07823 .19092 L
.08367 .22218 L
.08912 .15627 L
.09456 .0799 L
.1 .10704 L
.10544 .11 L
.11088 .10744 L
.11633 .18894 L
.12177 .2792 L
.12721 .30005 L
.13265 .21986 L
.1381 .11015 L
.14354 .08578 L
.14898 .07062 L
.15442 .08807 L
.15986 .09381 L
.16531 .1345 L
.17075 .33587 L
.17619 .4364 L
.18163 .22747 L
.18707 .01472 L
.19252 .03549 L
.19796 .07263 L
.2034 .07352 L
.20884 .09588 L
.21429 .1593 L
.21973 .30732 L
.22517 .3783 L
.23061 .25816 L
.23605 .12624 L
.2415 .07008 L
.24694 .05833 L
.25238 .10264 L
.25782 .12697 L
.26327 .12563 L
.26871 .11049 L
.27415 .11143 L
.27959 .12988 L
.28503 .13714 L
.29048 .15793 L
Mistroke
.29592 .18006 L
.30136 .21425 L
.3068 .21887 L
.31224 .17745 L
.31769 .1637 L
.32313 .158 L
.32857 .12109 L
.33401 .09564 L
.33946 .12021 L
.3449 .1458 L
.35034 .14544 L
.35578 .15659 L
.36122 .16952 L
.36667 .17777 L
.37211 .17564 L
.37755 .20601 L
.38299 .22322 L
.38844 .17153 L
.39388 .12683 L
.39932 .12432 L
.40476 .13091 L
.4102 .12685 L
.41565 .13597 L
.42109 .14953 L
.42653 .16672 L
.43197 .18738 L
.43741 .21329 L
.44286 .22355 L
.4483 .21004 L
.45374 .19462 L
.45918 .17723 L
.46463 .12222 L
.47007 .07106 L
.47551 .07268 L
.48095 .12435 L
.48639 .25776 L
.49184 .38357 L
.49728 .32349 L
.50272 .1205 L
.50816 .04826 L
.51361 .0776 L
.51905 .06925 L
.52449 .08363 L
.52993 .10653 L
.53537 .14171 L
.54082 .21367 L
.54626 .2508 L
.5517 .28064 L
.55714 .28452 L
.56259 .15093 L
Mistroke
.56803 .04059 L
.57347 .09423 L
.57891 .14125 L
.58435 .1157 L
.5898 .09289 L
.59524 .09298 L
.60068 .12379 L
.60612 .18845 L
.61156 .26251 L
.61701 .30433 L
.62245 .24101 L
.62789 .12352 L
.63333 .07955 L
.63878 .09504 L
.64422 .1404 L
.64966 .13639 L
.6551 .09592 L
.66054 .10608 L
.66599 .19416 L
.67143 .29938 L
.67687 .3651 L
.68231 .23486 L
.68776 .08293 L
.6932 .06304 L
.69864 .04956 L
.70408 .06316 L
.70952 .09934 L
.71497 .15206 L
.72041 .14336 L
.72585 .14491 L
.73129 .21581 L
.73673 .25607 L
.74218 .21408 L
.74762 .17628 L
.75306 .16719 L
.7585 .13701 L
.76395 .08378 L
.76939 .08158 L
.77483 .12335 L
.78027 .145 L
.78571 .15652 L
.79116 .21729 L
.7966 .29172 L
.80204 .25997 L
.80748 .16893 L
.81293 .11359 L
.81837 .0848 L
.82381 .08726 L
.82925 .13145 L
.83469 .13558 L
Mistroke
.84014 .12703 L
.84558 .13722 L
.85102 .1496 L
.85646 .20024 L
.8619 .23557 L
.86735 .23587 L
.87279 .18206 L
.87823 .15444 L
.88367 .14913 L
.88912 .12625 L
.89456 .09888 L
.9 .08556 L
.90544 .12824 L
.91088 .14899 L
.91633 .17176 L
.92177 .24426 L
.92721 .25862 L
.93265 .27363 L
.9381 .20401 L
.94354 .07936 L
.94898 .06821 L
.95442 .08838 L
.95986 .11372 L
.96531 .12023 L
.97075 .1636 L
.97619 .17948 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.938},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`004@3oool3000000@0oooo00<000000?ooo`3oool0
0P3oool3000000@0oooo0P00000=0?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo0080oooo0`00000>0?ooo`<000000`3oool3000000@0oooo0P0000040?ooo`800000
3@3oool3000000<0oooo0`0000020?ooo`D000000P3oool3000000d0oooo0`0000030?ooo`<00000
0`3oool3000000@0oooo0P00000=0?ooo`<000000`3oool3000000@0oooo00<000000?ooo`3oool0
0P3oool3000000h0oooo0`0000030?ooo`8000001@3oool2000000@0oooo0P00000=0?ooo`<00000
0`3oool2000000<0oooo1@0000020?ooo`<000000`3oool00180oooo00<000000?ooo`3oool00`3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0303oool01@000000oooo0?ooo`3oool0
000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo00/0oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo000000030?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool02`3oool01@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0
oooo000000030?ooo`050000003oool0oooo0?ooo`0000003P3oool00`000000oooo0?ooo`040?oo
o`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool000000080oooo
00<000000?ooo`0000000`3oool100000040oooo0@3oool00180oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`040?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`0<0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool02`3oool0
1@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000
003oool0oooo00/0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00<0
oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00D0oooo
00D000000?ooo`3oool0oooo000000070?ooo`4000000@3oool10?ooo`004P3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool00P3oool3000000<0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000=0?ooo`030000003oool0
oooo0080oooo0`0000050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02`3oool0
0`000000oooo0?ooo`020?ooo`<000001P3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0080oooo100000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000003@3oool00`000000oooo0?ooo`020?ooo`@0
0000103oool00`000000oooo0?ooo`040?ooo`4000000@3oool10?ooo`004P3oool00`000000oooo
0?ooo`050?ooo`030000003oool0000000<000000`3oool010000000oooo0?ooo`00000=0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool00`3oool00`000000oooo00000003000000l0
oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo0?ooo`000000
0`3oool00`000000oooo000000030?ooo`030000003oool0000000<000003P3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`0000030?ooo`040000003oool0oooo0000
00d0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`0000000`00000?0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool02`3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`3oool00`000000oooo000000030000
00<0oooo000A0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3oool0
10000000oooo0?ooo`00000<0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`00
00000`3oool00`000000oooo0000000A0?ooo`8000000`3oool01@000000oooo0?ooo`3oool00000
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000<0?ooo`8000000`3o
ool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool00`000000oooo0000000@0?ooo`80
00000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3oool010000000oooo0?ooo`00
000<0?ooo`8000000`3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool00`000000
oooo0000000A0?ooo`8000000`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000<0?ooo`8000000`3oool01`000000oooo0?oo
o`3oool000000?ooo`0000000`3oool00`000000oooo000000060?ooo`004P3oool010000000oooo
0?ooo`3oool5000000030?ooo`000000000000<000000`3oool2000000h0oooo00@000000?ooo`3o
ool0oooo1@0000000`3oool0000000000003000000030?ooo`000000000000<000003P3oool00`00
0000oooo0?ooo`020?ooo`<00000103oool2000000@0oooo0P00000>0?ooo`030000003oool0oooo
0080oooo0`0000030?ooo`<000000P3oool5000000d0oooo00<000000?ooo`3oool00P3oool30000
0080oooo1@0000030?ooo`8000003P3oool00`000000oooo0?ooo`020?ooo`<000000P3oool50000
00030?ooo`000000000000<000003P3oool00`000000oooo0?ooo`020?ooo`<00000103oool20000
00@0oooo0P00000>0?ooo`030000003oool0oooo0080oooo0`0000030?ooo`<000000P3oool50000
0080oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo000E0?oo
ood000001`3oool001D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`050?ooo`00
5@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`3i0?ooo`030000003o
ool0oooo00D0oooo000E0?ooo`030000003oool0oooo02`0oooo00<0o`000?ooo`3oool0bP3oool0
0`000000oooo0?ooo`050?ooo`005@3oool2000002d0oooo00<0o`000?ooo`3oool0b@3oool20000
00L0oooo000E0?ooo`030000003oool0oooo02`0oooo00<0o`000?ooo`3oool0bP3oool00`000000
oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0/0?ooo`80o`00b`3oool00`000000oooo
0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`0/0?ooo`80o`00b`3oool00`000000oooo0?oo
o`050?ooo`005@3oool2000002d0oooo0P3o003:0?ooo`8000001`3oool001D0oooo00<000000?oo
o`3oool0;03oool20?l005h0oooo00<0o`000?ooo`3oool0JP3oool00`000000oooo0?ooo`050?oo
o`005@3oool00`000000oooo0?ooo`0/0?ooo`80o`00GP3oool00`3o0000oooo0?ooo`1Z0?ooo`03
0000003oool0oooo00D0oooo00070?ooo`<00000103oool2000000D0oooo00<000000?ooo`3oool0
;03oool00`3o0000oooo0?l0001>0?ooo`030?l0003oool0oooo00`0oooo00<0o`000?ooo`3oool0
JP3oool00`000000oooo0?ooo`050?ooo`001P3oool01@000000oooo0?ooo`3oool000000080oooo
00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0/0?ooo`030?l0003oool0o`0004h0
oooo00<0o`000?ooo`3oool0303oool00`3o0000oooo0?ooo`0N0?ooo`030?l0003oool0oooo04T0
oooo00<000000?ooo`3oool01@3oool000D000001@3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0oooo0080oooo0P00000]0?ooo`030?l0003oool0o`0004h0oooo00<0o`000?ooo`3o
ool0303oool00`3o0000oooo0?ooo`0N0?ooo`030?l0003oool0oooo04L0oooo0`0000070?ooo`00
2P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0;03oool00`3o0000oooo0?l0000<0?ooo`030?l0003oool0oooo03l0oooo00<0o`000?ooo`3o
ool0303oool00`3o0000oooo0?ooo`0M0?ooo`030?l0003oool0o`0004X0oooo00<000000?ooo`3o
ool01@3oool000H0oooo100000030?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3o
ool0;03oool00`3o0000oooo0?l0000<0?ooo`030?l0003oool0oooo03l0oooo00<0o`000?ooo`3o
ool0303oool00`3o0000oooo0?ooo`0L0?ooo`040?l0003oool0oooo0?l004X0oooo00<000000?oo
o`3oool01@3oool000H0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo02`0oooo00@0o`000?ooo`3oool0o`002P3oool20?l00440oooo0P3o000=
0?ooo`030?l0003oool0oooo01`0oooo00@0o`000?ooo`3oool0o`00?@3oool00`3o0000oooo0?oo
o`0:0?ooo`030000003oool0oooo00D0oooo00060?ooo`D000000`3oool2000000D0oooo00<00000
0?ooo`3oool08P3oool00`3o0000oooo0?ooo`060?ooo`050?l0003oool0oooo0?ooo`3o00002@3o
ool00`3o0000oooo0?l0000g0?ooo`030?l0003oool0oooo00H0oooo00@0o`000?ooo`3o0000o`00
2`3oool00`3o0000oooo0?l0000M0?ooo`040?l0003oool0oooo0?l003d0oooo00<0o`000?ooo`3o
ool02P3oool00`000000oooo0?ooo`050?ooo`005@3oool2000002<0oooo00<0o`000?ooo`3oool0
1P3oool0103o0000oooo0?ooo`3oool20?l000P0oooo00<0o`000?ooo`3o0000=`3oool20?l000L0
oooo00@0o`000?ooo`3o0000o`002`3oool00`3o0000oooo0?l0000L0?ooo`050?l0003oool0oooo
0?ooo`3o0000?03oool20?l000/0oooo0P0000070?ooo`005@3oool00`000000oooo0?ooo`0D0?oo
o`030?l0003oool0oooo00/0oooo0P3o00070?ooo`030?l0003oool0oooo0080oooo00<0o`000?oo
o`3oool01P3oool00`3o0000oooo0?l0000g0?ooo`80o`001`3oool01@3o0000oooo0?l0003oool0
o`0000X0oooo00<0o`000?ooo`3o00003P3oool00`3o0000oooo0?ooo`0;0?ooo`050?l0003oool0
oooo0?ooo`3o0000>`3oool00`3o0000oooo0?l0000<0?ooo`030000003oool0oooo00D0oooo000E
0?ooo`030000003oool0oooo01@0oooo00<0o`000?ooo`3oool02P3oool00`3o0000oooo0?l00007
0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool01P3oool0103o0000oooo0?ooo`3o
000f0?ooo`80o`001`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00L0oooo00<0
o`000?ooo`3o00003P3oool00`3o0000oooo0?ooo`0;0?ooo`030?l0003oool0oooo0080oooo00<0
o`000?ooo`3oool02`3oool20?l002/0oooo00@0o`000?ooo`3oool0o`002`3oool00`000000oooo
0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`050?ooo`030?l0003oool0oooo00`0oooo00<0
o`000?ooo`3oool02P3oool0103o0000oooo0?ooo`3o00060?ooo`030?l0003oool0oooo00<0oooo
00<0o`000?ooo`3oool01@3oool0103o0000oooo0?ooo`3o000f0?ooo`80o`001`3oool00`3o0000
oooo0?ooo`020?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3o00003P3oool20?l000`0
oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`0;0?ooo`80o`00303oool20?l00180
oooo00<0o`000?ooo`3oool0203oool0103o0000oooo0?ooo`3o000;0?ooo`030000003oool0oooo
00D0oooo000E0?ooo`030000003oool0oooo00@0oooo0P3o000>0?ooo`80o`002`3oool0103o0000
oooo0?ooo`3o00060?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool01@3oool0103o
0000oooo0?ooo`3o000f0?ooo`030?l0003oool0o`0000H0oooo00<0o`000?ooo`3oool00P3oool0
0`3o0000oooo0?ooo`070?ooo`030?l0003oool0o`0000h0oooo0P3o000<0?ooo`030?l0003oool0
oooo0080oooo00<0o`000?ooo`3oool02`3oool20?l000`0oooo0P3o000B0?ooo`030?l0003oool0
oooo00P0oooo00@0o`000?ooo`3oool0o`002`3oool00`000000oooo0?ooo`050?ooo`005@3oool2
000000D0oooo0P3o00020?ooo`030?l0003oool0oooo00T0oooo0P3o000:0?ooo`030?l0003oool0
oooo0080oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0
oooo00D0oooo00@0o`000?ooo`3oool0o`00503oool00`3o0000oooo0?ooo`0O0?ooo`030?l0003o
ool0o`0000H0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`070?ooo`030?l0003o
ool0o`0000<0oooo0`3o00080?ooo`030?l0003oool0o`0000<0oooo00<0o`000?ooo`3oool01@3o
ool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00/0oooo00<0o`000?ooo`3o00002`3o
ool20?l00140oooo0P3o000:0?ooo`040?l0003oool0oooo0?l000X0oooo0P0000070?ooo`005@3o
ool00`000000oooo0?ooo`040?ooo`050?l0003oool0o`000?ooo`3o00002`3oool20?l000X0oooo
00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`030?ooo`030?l00000nYX0oooo00<0oooo
00<0o`000?ooo`3oool01@3oool0103o0000oooo0?ooo`3o000D0?ooo`030?l0003oool0oooo01h0
oooo00@0o`000?ooo`3oool0o`001P3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo
00H0oooo00<0o`000?ooo`3o00000`3oool00`3o0000oooo0?l000080?ooo`030?l0003oool0o`00
00<0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo
00/0oooo00<0o`000?ooo`3o00002P3oool00`3o0000oooo0?l0000A0?ooo`80o`002P3oool0103o
0000oooo0?ooo`3o000;0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo
00@0oooo00@0o`000?ooo`3o0000oooo0P3o000:0?ooo`030?l0003oool0o`0000T0oooo00<0o`00
0?ooo`3oool00P3oool00`3o0000oooo0?ooo`030?ooo`030?l00000nYX0oooo00<0oooo00<0o`00
0?ooo`3oool0103oool01@3o0000oooo0?ooo`3oool0o`0001@0oooo00<0o`000?ooo`3oool07P3o
ool0103o0000oooo0?ooo`3o00060?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool0
1P3oool00`3o0000oooo0?l000030?ooo`030?l0003oool0o`0000L0oooo00@0o`000?ooo`3oool0
o`000`3oool20?l000H0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`0;0?ooo`03
0?l0003oool0o`0000X0oooo00@0o`000?ooo`3oool0o`00403oool00`3o0000oooo0?l000090?oo
o`040?l0003oool0oooo0?l000/0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?oo
o`3oool0103oool0103o0000oooo0?l0003oool20?l000X0oooo00@0o`000?ooo`3o0000oooo0P3o
00050?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool00`3oool00`3o00000?ZJ0?oo
o`030?ooo`030?l0003oool0oooo00@0oooo00D0o`000?ooo`3oool0oooo0?l0000C0?ooo`80o`00
803oool0103o0000oooo0?ooo`3o00050?ooo`030?l0003oool0oooo00@0oooo00<0o`000?ooo`3o
ool01P3oool00`3o0000oooo0?l000020?ooo`040?l0003oool0oooo0?l000L0oooo00@0o`000?oo
o`3oool0o`000`3oool20?l000H0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`0;
0?ooo`030?l0003oool0o`0000X0oooo00@0o`000?ooo`3oool0o`00403oool00`3o0000oooo0?l0
00090?ooo`050?l0003oool0oooo0?ooo`3o00002P3oool00`000000oooo0?ooo`050?ooo`005@3o
ool2000000D0oooo00@0o`000?ooo`3o0000oooo0P3o000:0?ooo`060?l0003oool0oooo0?l0003o
ool0o`001@3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00<0oooo00<0o`00003j
VP00nYX00`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo0080oooo00<0o`000?oo
o`3oool00`3o000=0?ooo`030?l0003oool0o`0001l0oooo00@0o`000?ooo`3oool0o`001@3oool0
0`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3o00000P3oool0
1@3o0000oooo0?ooo`3oool0o`0000H0oooo00@0o`000?ooo`3oool0o`000P3oool00`3o0000oooo
0?l000060?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool02`3oool00`3o0000oooo
0?l000090?ooo`050?l0003oool0oooo0?ooo`3o0000403oool00`3o0000oooo0?l000090?ooo`05
0?l0003oool0oooo0?ooo`3o00002@3oool2000000L0oooo000E0?ooo`030000003oool0oooo00<0
oooo00<0o`000?ooo`3oool00P3o00020?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3o
ool00P3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3o
ool00`3oool00`3o00000?ZJ003jVP040?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3o
ool00P3oool01P3o0000oooo0?ooo`3o0000oooo0?l000d0oooo00<0o`000?ooo`3o00007`3oool0
103o0000oooo0?ooo`3o00050?ooo`030?l0003oool0oooo00@0oooo00<0o`000?ooo`3oool01P3o
ool00`3o0000oooo0?l000020?ooo`050?l0003oool0oooo0?ooo`3o00001P3oool0103o0000oooo
0?ooo`3o00020?ooo`030?l0003oool0o`0000H0oooo00<0o`000?ooo`3oool00`3oool00`3o0000
oooo0?ooo`090?ooo`050?l0003oool0oooo0?ooo`3o0000203oool01@3o0000oooo0?ooo`3oool0
o`0000l0oooo00@0o`000?ooo`3oool0o`002@3oool01@3o0000oooo0?ooo`3oool0o`0000X0oooo
00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool00`3oool01@3o0000oooo0?oo
o`3oool0o`000080oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?ooo`020?ooo`030?l0
003oool0oooo00<0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`020?ooo`030?l0
0000nYX00?ZJ00@0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`020?ooo`060?l0
003oool0oooo0?l0003oool0o`00303oool0103o0000oooo0?ooo`3o000O0?ooo`050?l0003oool0
oooo0?ooo`3o0000103oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00D0oooo00<0
o`000?ooo`3o00000P3oool01@3o0000oooo0?ooo`3oool0o`0000H0oooo00@0o`000?ooo`3oool0
o`000P3oool00`3o0000oooo0?l000060?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3o
ool02@3oool01@3o0000oooo0?ooo`3oool0o`0000P0oooo00D0o`000?ooo`3oool0oooo0?l0000?
0?ooo`040?l0003oool0oooo0?l000T0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?oo
o`070?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00<0oooo00D0o`00
0?ooo`3oool0oooo0?l000020?ooo`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool00`3o
ool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00@0oooo00<0o`000?ooo`3oool00P3o
ool00`3o00000?ZJ003jVP040?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool00`3o
ool20?l000<0oooo00<0o`000?ooo`3oool02@3oool0103o0000oooo0?ooo`3o000O0?ooo`050?l0
003oool0oooo0?ooo`3o0000103oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00D0
oooo00H0o`000?ooo`3oool0o`000?ooo`3o00030?ooo`030?l0003oool0oooo00@0oooo00T0o`00
0?ooo`3oool0oooo0?l0003oool0o`000?ooo`3o00001P3oool00`3o0000oooo0?ooo`030?ooo`03
0?l0003oool0oooo00T0oooo00D0o`000?ooo`3oool0oooo0?l000080?ooo`030?l0003oool0oooo
0080oooo00<0o`000?ooo`3oool0303oool01@3o0000oooo0?ooo`3oool0o`0000P0oooo00<0o`00
0?ooo`3oool00`3oool00`3o0000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo000E0?oo
o`030000003oool0oooo00<0oooo00D0o`000?ooo`3oool0oooo0?l000020?ooo`030?l0003oool0
oooo00H0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0
oooo00@0oooo00<0o`000?ooo`3oool00P3oool00`3o00000?ZJ003jVP040?ooo`030?l0003oool0
oooo00<0oooo00<0o`000?ooo`3oool00`3oool20?l000<0oooo00<0o`000?ooo`3oool02@3oool0
103o0000oooo0?ooo`3o000=0?ooo`<0o`0000<0oooo0?l0003oool0303oool01@3o0000oooo0?oo
o`3oool0o`0000@0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`040?ooo`040?l0
003oool00?ZJ0?ooo`80o`00103oool00`3o0000oooo0?ooo`040?ooo`090?l0003oool0oooo0?oo
o`3o0000oooo0?l0003oool0o`0000H0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?oo
o`090?ooo`050?l0003oool0oooo0?ooo`3o0000203oool00`3o0000oooo0?ooo`020?ooo`030?l0
003oool0o`0000`0oooo00D0o`000?ooo`3oool0oooo0?l000080?ooo`030?l0003oool0oooo00<0
oooo00<0o`000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`005@3oool2000000@0oooo
00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo00<0oooo
00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo0080oooo
00@0o`00003jVP3oool00?ZJ0`3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00P0
oooo00<0o`000?ooo`3oool02@3oool01@3o0000oooo0?ooo`3oool0o`0000`0oooo00<0o`000?oo
o`3oool00P3o000=0?ooo`050?l0003oool0oooo0?ooo`3o0000103oool00`3o0000oooo003jVP05
0?ooo`030?l0003oool0oooo00@0oooo00@0o`000?ooo`00nYX0oooo0P3o00040?ooo`030?l0003o
ool0oooo00@0oooo00@0o`000?ooo`3oool0oooo0P3o00020?ooo`030?l0003oool0oooo00@0oooo
00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`090?ooo`050?l0003oool0oooo0?ooo`3o
0000203oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0o`0000`0oooo00D0o`000?ooo`3o
ool0oooo0?l000080?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool01@3oool20000
00L0oooo000E0?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool0103oool00`3o0000
oooo0?ooo`060?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool00`3oool00`3o0000
oooo0?ooo`040?ooo`030?l0003oool0oooo0080oooo00@0o`00003jVP3oool00?ZJ0`3oool00`3o
0000oooo0?ooo`030?ooo`030?l0003oool0oooo00P0oooo00<0o`000?ooo`3oool02@3oool01@3o
0000oooo0?ooo`3oool0o`0000`0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`0:
0?ooo`050?l0003oool0oooo0?ooo`3o0000103oool00`3o0000oooo003jVP050?ooo`030?l0003o
ool0oooo00@0oooo00@0o`000?ooo`00nYX0oooo0P3o00040?ooo`030?l0003oool0oooo00@0oooo
00@0o`000?ooo`3oool0oooo0P3o00020?ooo`030?l0003oool0oooo00@0oooo00@0o`000?ooo`3o
ool00?ZJ0P3oool00`3o0000oooo0?ooo`090?ooo`050?l0003oool0oooo0?ooo`3o0000203oool0
0`3o0000oooo0?ooo`030?ooo`030?l0003oool0o`0000X0oooo00<0o`000?ooo`3oool00P3oool0
0`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool01P3oool0
0`000000oooo0?ooo`050?ooo`001P3oool500000080oooo0`0000050?ooo`030000003oool0oooo
00/0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo
00<0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`020?ooo`040?l00000nYX0oooo
003jVP<0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`090?ooo`030?l0003oool0
oooo00P0oooo00D0o`000?ooo`3oool0oooo0?l0000<0?ooo`030?l0003oool0oooo0080oooo00<0
o`000?ooo`3oool02@3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo0080oooo00<0
o`000?ooo`00nYX01P3oool00`3o0000oooo0?ooo`030?ooo`050?l0003oool00?ZJ0?ooo`3o0000
1@3oool00`3o0000oooo0?ooo`040?ooo`040?l0003oool0oooo0?ooo`80o`000P3oool00`3o0000
oooo0?ooo`040?ooo`040?l0003oool0oooo003jVP80oooo00<0o`000?ooo`3oool02@3oool00`3o
0000oooo0?ooo`020?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool01P3oool00`3o
0000oooo0?ooo`070?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool01P3oool00`3o
0000oooo0?ooo`030?ooo`030?l0003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool000L0
oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool02`3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00<0oooo00<0o`00
0?ooo`3oool00`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo0080oooo00@0o`00
003jVP3oool00?ZJ0`3oool00`3o0000oooo0?ooo`030?ooo`040?l0003oool0oooo003jVPP0oooo
00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00T0oooo
00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`090?ooo`030?l0003oool0oooo0080oooo
00<0o`000?ooo`3oool00P3oool00`3o0000oooo003jVP060?ooo`030?l0003oool0oooo00<0oooo
00D0o`000?ooo`00nYX0oooo0?l000050?ooo`030?l0003oool0oooo00@0oooo00D0o`000?ooo`3o
ool0oooo0?l000030?ooo`030?l0003oool0oooo00@0oooo00D0o`000?ooo`00nYX0oooo003jVP02
0?ooo`<0o`00203oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00D0oooo00<0o`00
0?ooo`3oool01P3oool00`3o0000oooo0?ooo`070?ooo`030?l0003oool0oooo00<0oooo00<0o`00
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00H0oooo00<00000
0?ooo`3oool01@3oool000D000000`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool02`3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo
00<0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo
0080oooo00@0o`00003jVP3oool00?ZJ103oool00`3o0000oooo0?ooo`020?ooo`040?l0003oool0
oooo003jVPT0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`030?ooo`80o`002P3o
ool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00P0oooo00<0o`000?ooo`3oool00P3o
ool00`3o0000oooo0?ooo`020?ooo`030?l0003oool00?ZJ00H0oooo00<0o`000?ooo`3oool00`3o
ool00`3o0000oooo003jVP070?ooo`030?l0003oool0oooo00@0oooo00<0o`000?ooo`3oool01@3o
ool00`3o0000oooo0?ooo`040?ooo`050?l00000nYX0oooo0?ooo`00nYX00P3oool20?l000030?oo
o`3o0000oooo00H0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`040?ooo`030?l0
003oool0oooo00P0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`040?ooo`030?l0
003oool0oooo00@0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`050?ooo`030000
003oool0oooo00D0oooo00090?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3o
ool2000000`0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`040?ooo`030?l0003o
ool0oooo0080oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`020?ooo`050?l00000
nYX0oooo0?ooo`00nYX00`3oool00`3o0000oooo0?ooo`020?ooo`040?l0003oool00?ZJ003jVPT0
oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00L0
oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`070?ooo`030?l0003oool0oooo0080
oooo00<0o`000?ooo`3oool00P3oool0103o0000oooo003jVP00nYX50?ooo`030?l0003oool0oooo
00<0oooo00<0o`000?ooo`00nYX01`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo
00D0oooo00<0o`000?ooo`3oool0103oool01@3o00000?ZJ0?ooo`3oool00?ZJ0080oooo00@0o`00
0?ooo`3oool0o`001P3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00@0oooo00<0
o`000?ooo`3oool0203oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00@0oooo00<0
o`000?ooo`3oool0103oool0103o0000oooo0?ooo`00nYX40?ooo`030?l0003oool0oooo00<0oooo
0`0000070?ooo`001P3oool01P000000oooo0?ooo`3oool000000?ooo`@000001@3oool00`000000
oooo0?ooo`0;0?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool0103oool00`3o0000
oooo0?ooo`020?ooo`040?l0003oool0oooo003jVP<0oooo00<0o`000?ooo`3oool00P3oool01@3o
0000oooo0?ooo`3oool00?ZJ00<0oooo00<0o`000?ooo`3oool00P3oool0103o00000?ZJ0?ooo`00
nYX90?ooo`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?oo
o`060?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo003j
VP020?ooo`030?l0003oool0oooo0080oooo00<0o`00003jVP3oool00P00nYX40?ooo`030?l0003o
ool0oooo00<0oooo00@0o`000?ooo`00nYX00?ZJ1P3oool00`3o0000oooo0?ooo`030?ooo`030?l0
003oool0oooo00L0oooo00<0o`000?ooo`3oool00`3oool01@3o00000?ZJ0?ooo`3oool00?ZJ0080
oooo00@0o`000?ooo`3oool0o`001P3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo
00<0oooo00<0o`000?ooo`3oool0203oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo
00D0oooo00<0o`000?ooo`3oool0103oool0103o0000oooo0?ooo`00nYX40?ooo`030?l0003oool0
oooo00D0oooo00<000000?ooo`3oool01@3oool000H0oooo00L000000?ooo`3oool0oooo0000003o
ool0000000P0oooo00<000000?ooo`3oool02`3oool00`3o0000oooo0?ooo`050?ooo`030?l0003o
ool0oooo00@0oooo00<0o`000?ooo`3oool00P3oool0103o0000oooo0?ooo`00nYX30?ooo`030?l0
003oool0oooo0080oooo00@0o`000?ooo`3oool0oooo0P00nYX20?ooo`030?l0003oool0oooo0080
oooo00@0o`00003jVP3oool00?ZJ2P3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo
00D0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo
00L0oooo00H0o`000?ooo`00nYX00?ZJ0?ooo`3o00040?ooo`030?l00000nYX0oooo00800?ZJ103o
ool00`3o0000oooo0?ooo`030?ooo`040?l00000nYX0oooo003jVPL0oooo00<0o`000?ooo`3oool0
0P3oool00`3o0000oooo0?ooo`070?ooo`030?l0003oool0oooo00<0oooo00D0o`000?ooo`3oool0
oooo003jVP050?ooo`030?l0003oool0oooo00@0oooo00<0o`000?ooo`3oool01@3oool00`3o0000
oooo0?ooo`020?ooo`030?l0003oool0oooo00P0oooo00<0o`000?ooo`3oool0103oool00`3o0000
oooo0?ooo`050?ooo`030?l0003oool0oooo00@0oooo00@0o`000?ooo`00nYX00?ZJ103oool00`3o
0000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00070?ooo`<000000P3oool5000000@0
oooo00<000000?ooo`3oool02`3oool00`3o0000oooo0?ooo`050?ooo`030?l00000nYX0oooo00@0
oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`02003jVP80oooo00<0o`000?ooo`3o
ool00P3oool00`3o0000oooo0?ooo`020?ooo`04003jVP3oool0oooo0?l000@0oooo00@0o`00003j
VP3oool00?ZJ2P3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00H0oooo00<0o`00
0?ooo`3oool01P3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo00H0oooo00H0o`00
0?ooo`00nYX00?ZJ0?ooo`3o00040?ooo`060?l00000nYX0oooo003jVP3oool00?ZJ0`3oool00`3o
0000oooo0?ooo`030?ooo`040?l00000nYX0oooo003jVPL0oooo00<0o`000?ooo`3oool00P3oool0
0`3o0000oooo003jVP070?ooo`030?l0003oool0oooo0080oooo00<0o`00003jVP3oool00P3oool0
0`00nYX0oooo0?ooo`030?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool01P3oool0
0`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00P0oooo00<0o`000?ooo`3oool0103oool0
0`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00@0oooo00@0o`00003jVP3oool00?ZJ103o
ool00`3o0000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000303oool0
0`3o0000oooo0?ooo`050?ooo`030?l00000nYX0oooo00@0oooo00<0o`000?ooo`3oool00P3oool0
1@3o0000oooo003jVP3oool00?ZJ0080oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?oo
o`020?ooo`04003jVP3oool0oooo0?l000@0oooo00D0o`00003jVP3oool0oooo003jVP090?ooo`03
0?l0003oool0oooo00@0oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?ooo`050?ooo`03
0?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`02003jVP03
0?ooo`3o0000oooo00<0oooo00<0o`00003jVP3oool00`3oool01000nYX0oooo0?ooo`3o00050?oo
o`040?l00000nYX0oooo003jVPL0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo003jVP07
0?ooo`030?l0003oool0oooo0080oooo00<0o`00003jVP3oool00`3oool00`00nYX0oooo0?ooo`02
0?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool00P00nYX40?ooo`030?l0003oool0
oooo0080oooo00<0o`000?ooo`3oool0203oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0
oooo00H0oooo00<0o`000?ooo`3oool00`3oool01@3o00000?ZJ0?ooo`3oool00?ZJ00<0oooo00<0
o`000?ooo`3oool0103oool2000000L0oooo000E0?ooo`030000003oool0oooo00/0oooo00<0o`00
0?ooo`3oool01@3oool00`3o00000?ZJ0?ooo`040?ooo`050?l0003oool0oooo0?ooo`3o00000P3o
ool01P00nYX0oooo0?ooo`00nYX0oooo0?l000@0oooo00<0o`000?ooo`3oool00`3oool00`00nYX0
oooo0?l000040?ooo`050?l00000nYX0oooo0?ooo`00nYX02@3oool00`3o0000oooo0?ooo`030?oo
o`030?l0003oool0oooo00T0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`060?oo
o`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool00P00nYX00`3oool0o`000?ooo`030?oo
o`030?l00000nYX0oooo00<0oooo00@00?ZJ0?ooo`3oool0o`001@3oool0103o00000?ZJ0?ooo`00
nYX70?ooo`030?l0003oool0oooo0080oooo00@0o`000?ooo`00nYX00?ZJ1P3oool00`3o0000oooo
0?ooo`020?ooo`030?l00000nYX0oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool00`3o0000oooo
0?ooo`030?ooo`030?l0003oool0oooo00800?ZJ103oool00`3o0000oooo0?ooo`020?ooo`030?l0
003oool0oooo00800?ZJ1P3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00<0oooo
00D00?ZJ0?ooo`3oool0oooo0?l000050?ooo`050?l00000nYX0oooo0?ooo`00nYX0103oool00`3o
0000oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00@0
oooo0P00nYX50?ooo`030?l0003oool0oooo00D0oooo00<0o`00003jVP00nYX0103oool01@3o0000
oooo0?ooo`3oool0o`000080oooo00H00?ZJ0?ooo`3oool00?ZJ0?ooo`3o00040?ooo`030?l0003o
ool0oooo00<0oooo00<00?ZJ0?ooo`3o0000103oool01@3o00000?ZJ0?ooo`3oool00?ZJ00X0oooo
00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`090?ooo`030?l0003oool0oooo00@0oooo
00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`050?ooo`070?l0003oool0oooo003jVP3o
ool00?ZJ0?l000040?ooo`030?l00000nYX0oooo00<0oooo00@00?ZJ0?ooo`3oool0o`001@3oool0
103o00000?ZJ0?ooo`00nYX70?ooo`030?l0003oool0oooo0080oooo00@0o`000?ooo`00nYX00?ZJ
1P3oool00`3o0000oooo0?ooo`020?ooo`030?l00000nYX0oooo00<0oooo00<00?ZJ0?ooo`3oool0
0P3oool00`3o0000oooo0?ooo`020?ooo`040?l0003oool0oooo0?ooo`800?ZJ103oool00`3o0000
oooo0?ooo`020?ooo`030?l0003oool0oooo00800?ZJ1P3oool00`3o0000oooo0?ooo`030?ooo`03
0?l0003oool0oooo00<0oooo00D00?ZJ0?ooo`3oool0oooo0?l000050?ooo`050?l00000nYX0oooo
0?ooo`00nYX0103oool00`3o0000oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo000E0?oo
o`030000003oool0oooo00@0oooo0P00nYX20?ooo`04003jVP3oool0oooo0?l000L0oooo00<0o`00
003jVP00nYX0103oool01`3o0000oooo0?ooo`3oool0o`000?ooo`00nYX0103oool00`00nYX0o`00
0?ooo`020?ooo`030?l00000nYX0oooo00@0oooo00<00?ZJ0?ooo`3o0000103oool01@3o00000?ZJ
0?ooo`3oool00?ZJ00X0oooo00D0o`000?ooo`3oool0oooo0?l000050?ooo`03003jVP3oool0oooo
00D0oooo0P3o00040?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3oool0103oool01`3o
0000oooo0?ooo`00nYX0oooo003jVP3o0000103oool00`3o00000?ZJ0?ooo`030?ooo`04003jVP3o
ool0oooo0?l000D0oooo00@0o`00003jVP3oool00?ZJ0`3oool3003jVP030?ooo`3o0000oooo00<0
oooo00D0o`000?ooo`00nYX0oooo003jVP030?ooo`03003jVP3oool0o`0000@0oooo00<0o`00003j
VP3oool00`3oool00`00nYX0oooo0?ooo`020?ooo`030?l0003oool0oooo0080oooo00L0o`000?oo
o`3oool0oooo003jVP3oool00?ZJ00<0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?oo
o`02003jVPL0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`020?ooo`800?ZJ0`3o
ool00`3o0000oooo0?ooo`030?ooo`050?l00000nYX0oooo0?ooo`00nYX01@3oool00`3o0000oooo
0?ooo`030?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00@0oooo0P00
nYX20?ooo`05003jVP3oool0oooo0?ooo`3o00001P3oool00`3o00000?ZJ003jVP040?ooo`070?l0
003oool0oooo0?ooo`3o0000oooo003jVP040?ooo`03003jVP3o0000oooo0080oooo00<0o`00003j
VP3o0000103oool00`00nYX0oooo0?l000040?ooo`050?l00000nYX0oooo0?ooo`00nYX02P3oool0
1@3o0000oooo0?ooo`3oool0o`0000D0oooo00<00?ZJ0?ooo`3oool01P3oool00`3o0000oooo0?oo
o`020?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo003j
VP020?ooo`03003jVP3o0000oooo00<0oooo00<0o`00003jVP3oool0103oool01000nYX0oooo0?oo
o`3o00040?ooo`040?l00000nYX0oooo003jVP<0oooo00D00?ZJ0?ooo`00nYX0oooo0?l000040?oo
o`050?l0003oool00?ZJ0?ooo`00nYX00`3oool00`00nYX0oooo0?l000040?ooo`030?l00000nYX0
oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool00`3o0000oooo0?ooo`020?ooo`070?l0003oool0
oooo0?ooo`00nYX0oooo003jVP030?ooo`030?l0003oool0oooo0080oooo00D0o`000?ooo`00nYX0
oooo003jVP070?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00P3oool2003jVP<0
oooo00<0o`000?ooo`3oool00`3oool01@3o00000?ZJ0?ooo`3oool00?ZJ00/0oooo00<000000?oo
o`3oool01@3oool001D0oooo0P0000050?ooo`04003jVP3oool00?ZJ0?ooo`800?ZJ0P3oool00`3o
0000oooo0?ooo`040?ooo`040?l00000nYX0oooo003jVP<0oooo00L0o`000?ooo`3oool0oooo0?l0
003oool00?ZJ00@0oooo00<00?ZJ0?l0003oool00P3oool00`3o00000?ZJ0?l000040?ooo`03003j
VP3oool0o`0000@0oooo00D0o`000?ooo`3oool0oooo003jVP0:0?ooo`050?l0003oool0oooo0?oo
o`3o00001@3oool00`00nYX0oooo0?ooo`060?ooo`050?l0003oool0oooo0?ooo`3o00002P3oool0
0`3o0000oooo0?ooo`040?ooo`030?l0003oool00?ZJ0080oooo00<00?ZJ0?l0003oool00`3oool0
0`3o00000?ZJ0?ooo`040?ooo`04003jVP3oool0oooo0?l000@0oooo00@0o`00003jVP3oool00?ZJ
0`3oool01@00nYX0oooo003jVP3oool0o`0000@0oooo00D0o`00003jVP3oool0oooo003jVP030?oo
o`800?ZJ00<0o`000?ooo`3oool00P3oool00`3o00000?ZJ0?ooo`030?ooo`03003jVP3oool0oooo
00<0oooo00D0o`000?ooo`3oool0oooo0?l000030?ooo`03003jVP3oool00?ZJ00<0oooo00<0o`00
0?ooo`3oool00P3oool00`3o0000oooo003jVP020?ooo`03003jVP3oool0oooo00@0oooo00<0o`00
0?ooo`3oool00P3oool00`3o0000oooo0?ooo`020?ooo`03003jVP3oool00?ZJ0080oooo00<0o`00
0?ooo`3oool00`3oool01@3o00000?ZJ0?ooo`3oool00?ZJ00X0oooo0P0000070?ooo`005@3oool0
0`000000oooo0?ooo`040?ooo`04003jVP3oool00?ZJ0?ooo`800?ZJ0P3oool01@3o0000oooo0?oo
o`3oool0o`000080oooo00D0o`00003jVP3oool00?ZJ0?ooo`02003jVP060?l0003oool0oooo0?oo
o`3o00000?ZJ1@3oool00`00nYX0oooo0?l000020?ooo`030?l00000nYX0o`0000@0oooo00<00?ZJ
0?ooo`3o0000103oool01@3o0000oooo0?ooo`3oool00?ZJ00X0oooo00D0o`000?ooo`3oool0oooo
0?l000040?ooo`800?ZJ2@3oool0103o0000oooo0?ooo`3o000:0?ooo`030?l0003oool0oooo00<0
oooo00@0o`000?ooo`3oool00?ZJ0P3oool00`00nYX0o`000?ooo`030?ooo`030?l0003oool0oooo
00@0oooo00@00?ZJ0?ooo`3oool0o`00103oool0103o00000?ZJ0?ooo`00nYX20?ooo`06003jVP3o
ool0oooo003jVP3oool0o`00103oool01@3o00000?ZJ0?ooo`3oool00?ZJ00<0oooo0P00nYX00`3o
0000oooo0?ooo`020?ooo`030?l00000nYX0oooo00<0oooo00<00?ZJ0?ooo`3oool00`3oool01@3o
0000oooo0?ooo`3oool0o`0000<0oooo00<00?ZJ0?ooo`00nYX0103oool01`3o0000oooo0?ooo`3o
ool0o`000?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`040?ooo`030?l0003oool0oooo0080oooo
00<0o`000?ooo`3oool00P3oool00`00nYX0oooo003jVP020?ooo`030?l0003oool0oooo00<0oooo
00<0o`00003jVP3oool00P3oool00`00nYX0oooo0?ooo`080?ooo`030000003oool0oooo00D0oooo
000E0?ooo`030000003oool0oooo00@0oooo00@00?ZJ0?ooo`00nYX0oooo0P00nYX20?ooo`090?l0
003oool0oooo0?ooo`3o0000oooo0?l0003oool00?ZJ0080oooo00@00?ZJ0?ooo`00nYX0o`000`3o
ool00`3o00000?ZJ0?ooo`040?ooo`03003jVP3oool0o`000080oooo00@0o`00003jVP3o0000o`00
0`3oool00`00nYX0oooo0?l000030?ooo`030?l00000nYX0oooo00<0oooo00<00?ZJ0?ooo`3oool0
0`00nYX50?ooo`040?l0003oool0oooo0?l000@0oooo00<00?ZJ0?ooo`00nYX0203oool0103o0000
oooo0?ooo`3o000:0?ooo`030?l0003oool0oooo00<0oooo00@0o`000?ooo`3oool00?ZJ0P3oool0
0`00nYX0oooo0?l000030?ooo`030?l0003oool0oooo00@0oooo00@00?ZJ0?ooo`3oool0o`00103o
ool0103o00000?ZJ0?ooo`00nYX20?ooo`06003jVP3oool0oooo0?ooo`00nYX0o`00103oool01@3o
00000?ZJ0?ooo`3oool00?ZJ0080oooo00@00?ZJ0?ooo`00nYX0o`00103oool00`3o00000?ZJ0?oo
o`030?ooo`03003jVP3oool0oooo00<0oooo00D0o`000?ooo`3oool0oooo0?l000030?ooo`03003j
VP3oool00?ZJ00@0oooo00H0o`000?ooo`3oool0oooo0?l00000nYX30?ooo`03003jVP3oool0oooo
00@0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`020?ooo`03003jVP3oool00?ZJ
00<0oooo00<0o`000?ooo`3oool00P3oool00`3o00000?ZJ0?ooo`020?ooo`03003jVP3oool0oooo
00P0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0103oool01000nYX0
oooo003jVP00nYX20?ooo`03003jVP3oool0o`000080oooo0P3o0000103oool0o`000?ooo`00nYX4
0?ooo`03003jVP3o0000oooo0080oooo00<0o`00003jVP3oool0103oool00`00nYX0oooo0?l00002
0?ooo`040?l00000nYX0o`000?l000@0oooo00<00?ZJ0?l0003oool00P3oool00`3o00000?ZJ0?oo
o`030?ooo`06003jVP3oool0oooo003jVP3oool00?ZJ1@3oool0103o0000oooo0?ooo`3o00040?oo
o`03003jVP3oool00?ZJ00P0oooo00@0o`000?ooo`3oool0o`002`3oool00`3o0000oooo0?ooo`02
0?ooo`040?l0003oool0oooo003jVP80oooo00<00?ZJ0?ooo`3o00000`3oool00`3o0000oooo0?oo
o`040?ooo`04003jVP3oool0oooo0?l000@0oooo00@0o`00003jVP3oool00?ZJ0P3oool01P00nYX0
oooo0?ooo`3oool00?ZJ0?l000@0oooo00D0o`00003jVP3oool0oooo003jVP020?ooo`04003jVP3o
ool00?ZJ0?l000@0oooo00<0o`00003jVP3oool0103oool00`00nYX0oooo0?ooo`020?ooo`040?l0
003oool0oooo0?l000<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP030?ooo`060?l0003oool0oooo
0?ooo`3o00000?ZJ0`3oool00`00nYX0oooo0?ooo`040?ooo`050?l0003oool0oooo0?ooo`3o0000
103oool01000nYX0oooo0?ooo`00nYX30?ooo`030?l0003oool0oooo0080oooo00<0o`00003jVP3o
ool00P3oool00`00nYX0oooo0?ooo`080?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000
003oool0oooo00@0oooo00@00?ZJ0?ooo`00nYX00?ZJ0P3oool00`00nYX0oooo0?l000020?ooo`06
0?l0003oool0o`000?l0003oool00?ZJ103oool00`00nYX0o`000?ooo`020?ooo`030?l00000nYX0
oooo00D0oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX20?l000@0oooo00<00?ZJ0?l0003oool0
0P3oool00`3o00000?ZJ0?ooo`030?ooo`06003jVP3oool0oooo003jVP3oool00?ZJ1@3oool00`3o
0000oooo0?l000040?ooo`04003jVP3oool0oooo003jVPT0oooo00<0o`000?ooo`3o00002`3oool0
0`3o0000oooo0?ooo`020?ooo`040?l0003oool0oooo003jVP<0oooo00<00?ZJ0?l0003oool00P3o
ool00`3o0000oooo0?ooo`050?ooo`03003jVP3oool0o`0000@0oooo00@0o`00003jVP3oool00?ZJ
0P3oool01P00nYX0oooo0?ooo`3oool00?ZJ0?l000@0oooo00D0o`00003jVP3oool0oooo003jVP02
0?ooo`04003jVP3oool00?ZJ0?l000@0oooo00<0o`00003jVP3oool0103oool00`00nYX0oooo0?oo
o`020?ooo`040?l0003oool0oooo0?l000<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP030?ooo`06
0?l0003oool0oooo0?ooo`3o00000?ZJ0`3oool00`00nYX0oooo0?ooo`040?ooo`050?l0003oool0
oooo0?ooo`3o0000103oool01000nYX0oooo0?ooo`00nYX30?ooo`030?l0003oool0oooo0080oooo
00<0o`00003jVP3oool00`3oool00`00nYX0oooo0?ooo`070?ooo`030000003oool0oooo00D0oooo
000E0?ooo`8000001@3oool01000nYX0oooo0?ooo`00nYX20?ooo`03003jVP3oool0o`000080oooo
00D0o`000?ooo`3o0000o`00003jVP050?ooo`03003jVP3o0000oooo0080oooo00<0o`00003jVP3o
ool01@3oool01P00nYX0o`000?ooo`3oool0o`00003jVP80o`00103oool00`00nYX0o`000?ooo`02
0?ooo`030?l00000nYX0oooo00@0oooo0P00nYX30?ooo`03003jVP3oool0oooo0080oooo00<0o`00
0?ooo`3o0000103oool01000nYX0oooo0?ooo`00nYX90?ooo`030?l0003oool0o`0000/0oooo00D0
o`000?ooo`3oool0oooo0?l000030?ooo`06003jVP3oool0oooo0?ooo`00nYX0o`000`3oool00`3o
0000oooo0?ooo`050?ooo`03003jVP3oool0o`0000@0oooo00L0o`00003jVP3oool0oooo003jVP3o
ool00?ZJ00<0oooo00<00?ZJ0?l0003oool00`3oool00`3o00000?ZJ0?ooo`020?ooo`06003jVP3o
ool00?ZJ0?ooo`00nYX0o`00103oool00`3o00000?ZJ0?ooo`040?ooo`03003jVP3oool0oooo0080
oooo00@0o`000?ooo`3oool0o`000`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00<0oooo00H0o`00
0?ooo`3oool0oooo0?l00000nYX40?ooo`03003jVP3oool0oooo00<0oooo00D0o`000?ooo`3oool0
oooo0?l000040?ooo`05003jVP3oool0oooo0?ooo`00nYX00P3oool00`3o0000oooo0?ooo`020?oo
o`030?l00000nYX0oooo00@0oooo00<00?ZJ0?ooo`3oool01@3oool2000000L0oooo000E0?ooo`03
0000003oool0oooo00@0oooo00@00?ZJ0?ooo`3oool00?ZJ0P3oool00`00nYX0oooo0?l000020?oo
o`050?l0003oool0o`000?l00000nYX01@3oool00`00nYX0o`000?ooo`020?ooo`030?l00000nYX0
oooo00D0oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX20?l000@0oooo00<00?ZJ0?l0003oool0
0P3oool00`3o00000?ZJ0?ooo`040?ooo`800?ZJ0`3oool00`00nYX0oooo0?ooo`030?ooo`80o`00
103oool01000nYX0oooo0?ooo`00nYX90?ooo`040?l0003oool0o`000?ooo`<00?ZJ00<0oooo003j
VP3oool01@3oool0103o0000oooo0?ooo`3o00030?ooo`06003jVP3oool0oooo0?ooo`00nYX0o`00
0`3oool00`3o0000oooo0?ooo`050?ooo`03003jVP3oool0o`0000@0oooo00@0o`000?ooo`3o0000
oooo0P00nYX40?ooo`03003jVP3oool0o`0000<0oooo00<0o`00003jVP3oool00P3oool01P00nYX0
oooo003jVP3oool00?ZJ0?l000@0oooo00<0o`00003jVP3oool0103oool00`00nYX0oooo0?ooo`02
0?ooo`040?l0003oool0oooo0?l000<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP030?ooo`060?l0
003oool0oooo0?ooo`3o00000?ZJ103oool00`00nYX0oooo003jVP030?ooo`050?l0003oool0oooo
0?ooo`3o0000103oool01@00nYX0oooo0?ooo`3oool00?ZJ0080oooo00<0o`000?ooo`3oool00P3o
ool00`3o00000?ZJ0?ooo`040?ooo`03003jVP3oool0oooo00H0oooo00<000000?ooo`3oool01@3o
ool001D0oooo00<000000?ooo`3oool0103oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0
o`000080oooo00D0o`000?ooo`3o0000o`00003jVP050?ooo`03003jVP3o0000oooo0080oooo00<0
o`00003jVP3oool01@3oool02@00nYX0o`000?ooo`3oool0o`00003jVP3o0000oooo0?l000030?oo
o`03003jVP3o0000oooo0080oooo00<0o`00003jVP3oool02@3oool00`00nYX0oooo0?ooo`030?oo
o`80o`00103oool01@00nYX0oooo0?ooo`3oool00?ZJ00P0oooo0P3o00020?ooo`03003jVP3oool0
oooo00800?ZJ1P3oool0103o0000oooo0?ooo`3o00030?ooo`06003jVP3oool0oooo0?ooo`00nYX0
o`000`3oool00`3o0000oooo0?l000050?ooo`03003jVP3oool0o`0000@0oooo00@0o`000?ooo`3o
0000oooo0P00nYX40?ooo`03003jVP3oool0o`000080oooo00<0o`000?ooo`00nYX00`3oool2003j
VP80oooo00<00?ZJ0?l0003oool00`3oool00`3o00000?ZJ0?ooo`040?ooo`03003jVP3oool0oooo
0080oooo00@0o`000?ooo`3oool0o`000`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00<0oooo00H0
o`000?ooo`3oool0oooo0?l00000nYX40?ooo`03003jVP3oool00?ZJ00@0oooo00@0o`000?ooo`3o
ool0o`00103oool01@00nYX0oooo0?ooo`3oool00?ZJ0080oooo00<0o`000?ooo`3oool00P3oool0
0`3o00000?ZJ0?ooo`040?ooo`03003jVP3oool0oooo00H0oooo00<000000?ooo`3oool01@3oool0
01D0oooo00<000000?ooo`3oool0103oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo
0080o`000`3oool00`3o00000?ZJ0?ooo`040?ooo`03003jVP3o0000oooo0080oooo00<0o`00003j
VP3oool01@3oool02@00nYX0o`000?ooo`3oool0o`00003jVP3o0000oooo0?l000030?ooo`03003j
VP3o0000oooo0080oooo00<0o`00003jVP3oool02@3oool00`00nYX0oooo0?ooo`040?ooo`030?l0
003oool0oooo0080oooo00D00?ZJ0?ooo`3oool0oooo003jVP090?ooo`040?l0003oool0oooo003j
VP@0oooo00<00?ZJ0?ooo`3oool00`3oool00`3o0000oooo0?l000040?ooo`06003jVP3oool0oooo
0?ooo`00nYX0o`000`3oool00`3o0000oooo0?l000050?ooo`03003jVP3oool0o`0000@0oooo00@0
o`000?ooo`3o0000oooo0P00nYX40?ooo`03003jVP3oool0o`000080oooo00<0o`000?ooo`00nYX0
0`3oool2003jVP80oooo00<00?ZJ0?l0003oool00`3oool01@3o00000?ZJ0?ooo`3oool0o`000080
oooo00<00?ZJ0?ooo`3oool00P3oool0103o0000oooo0?ooo`3o00030?ooo`05003jVP3oool0oooo
0?ooo`00nYX00`3oool01P3o0000oooo0?ooo`3o0000oooo003jVPD0oooo00<00?ZJ0?ooo`00nYX0
0`3oool0103o0000oooo0?ooo`3o00030?ooo`03003jVP3oool0oooo0080oooo00@00?ZJ0?ooo`3o
ool0o`00103oool00`3o00000?ZJ0?ooo`040?ooo`03003jVP3oool0oooo00H0oooo00<000000?oo
o`3oool01@3oool001D0oooo00<000000?ooo`3oool0103oool00`00nYX0oooo0?ooo`040?ooo`04
003jVP3oool0o`000?l000<0oooo00<0o`00003jVP3oool0103oool00`00nYX0o`000?ooo`020?oo
o`030?l00000nYX0oooo00D0oooo00T00?ZJ0?l0003oool0oooo0?l00000nYX0o`000?ooo`3o0000
0`3oool00`00nYX0o`000?ooo`020?ooo`030?l00000nYX0oooo00X0oooo00<00?ZJ0?ooo`3oool0
203oool01@00nYX0oooo0?ooo`3oool00?ZJ00T0oooo00@0o`000?ooo`3oool00?ZJ103oool00`00
nYX0oooo0?ooo`040?ooo`80o`000`3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3o0000oooo
0080oooo00<0o`000?ooo`3o00001P3oool00`00nYX0o`000?ooo`020?ooo`060?l00000nYX0oooo
0?l0003oool00?ZJ1@3oool00`00nYX0oooo0?l000020?ooo`030?l0003oool00?ZJ00<0oooo0P00
nYX20?ooo`03003jVP3o0000oooo00<0oooo00D0o`00003jVP3oool0oooo0?l000020?ooo`03003j
VP3oool0oooo0080oooo00@0o`000?ooo`3oool0o`000`3oool00`00nYX0oooo0?ooo`020?ooo`04
003jVP3oool0oooo0?l00080oooo00<0o`000?ooo`00nYX0203oool01000nYX0oooo0?ooo`3o0002
0?ooo`050?l0003oool0oooo0?ooo`00nYX0103oool01000nYX0oooo0?ooo`3o00040?ooo`030?l0
0000nYX0oooo00@0oooo00<00?ZJ0?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`005@3o
ool2000000@0oooo00<00?ZJ0?ooo`3oool01@3oool01000nYX0oooo0?l0003o00040?ooo`03003j
VP3oool0oooo00<0oooo00<00?ZJ0?l0003oool00P3oool00`3o00000?ZJ0?ooo`050?ooo`09003j
VP3o0000oooo0?ooo`3o00000?ZJ0?l0003oool0o`0000<0oooo00<00?ZJ0?l0003oool00P3oool0
1@3o00000?ZJ0?ooo`3oool0o`0000P0oooo00<00?ZJ0?ooo`3oool01`3oool00`00nYX0oooo0?oo
o`030?ooo`03003jVP3oool0oooo00T0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?oo
o`040?ooo`030?l0003oool0oooo0080oooo00<00?ZJ0?ooo`3oool00P3oool02000nYX0o`000?oo
o`3oool0o`00003jVP3oool0o`001P3oool00`00nYX0o`000?ooo`020?ooo`060?l00000nYX0oooo
0?l0003oool00?ZJ1@3oool00`00nYX0oooo0?l000020?ooo`030?l0003oool00?ZJ00<0oooo00L0
0?ZJ0?ooo`3oool0oooo003jVP3oool0o`0000<0oooo00H0o`00003jVP3oool0o`000?ooo`3o0002
0?ooo`<00?ZJ00D0oooo0?l0003oool0oooo0?l000030?ooo`03003jVP3oool0oooo0080oooo00@0
0?ZJ0?ooo`3oool0o`000P3oool00`3o0000oooo003jVP080?ooo`06003jVP3oool0oooo0?l0003o
ool0o`00103oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0o`0000@0oooo00<0o`00003j
VP3oool0103oool00`00nYX0oooo0?ooo`050?ooo`8000001`3oool001D0oooo00<000000?ooo`3o
ool00`3oool00`00nYX0oooo0?ooo`050?ooo`04003jVP3oool0oooo0?l000@0oooo00<00?ZJ0?oo
o`3oool00`3oool00`00nYX0o`000?ooo`020?ooo`030?l00000nYX0oooo00D0oooo00T00?ZJ0?l0
003oool0oooo0?l00000nYX0o`000?ooo`3o0000103oool01P3o0000oooo0?ooo`3oool0o`00003j
VP80oooo00<0o`000?ooo`3oool01`3oool00`00nYX0oooo0?ooo`060?ooo`03003jVP3oool0oooo
00<0oooo0P00nYX:0?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool0203oool00`00
nYX0oooo0?ooo`020?ooo`08003jVP3o0000oooo0?ooo`3o00000?ZJ0?ooo`3o00060?ooo`03003j
VP3o0000oooo0080oooo00@0o`00003jVP3oool0o`001`3oool00`00nYX0oooo0?l000020?ooo`03
0?l0003oool00?ZJ00L0oooo00<00?ZJ0?ooo`3o00000`3oool00`3o00000?ZJ0?l000020?ooo`03
0?l0003oool0oooo00800?ZJ00D0oooo003jVP3o0000oooo0?l000040?ooo`03003jVP3oool0oooo
0080oooo00@00?ZJ0?ooo`3oool0o`000P3oool00`3o00000?ZJ0?ooo`090?ooo`05003jVP3oool0
o`000?ooo`3o00000`3oool00`00nYX0oooo0?ooo`040?ooo`04003jVP3oool0oooo0?l000<0oooo
00<0o`000?ooo`3oool01@3oool00`00nYX0oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo
000>0?ooo`8000001@3oool00`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo00D0oooo00@0
0?ZJ0?ooo`3oool0o`00103oool00`00nYX0oooo0?ooo`040?ooo`060?l0003oool0oooo0?ooo`3o
00000?ZJ1P3oool01`00nYX0o`000?ooo`3oool0o`00003jVP3o00000P3oool01@3o0000oooo0?oo
o`3oool0o`0000<0oooo00<0o`00003jVP3oool00P3o00090?ooo`03003jVP3oool0oooo00H0oooo
00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?ooo`070?ooo`03003jVP3oool0oooo00D0oooo
00<00?ZJ0?ooo`3oool01`3oool00`00nYX0oooo0?ooo`020?ooo`07003jVP3o0000oooo0?ooo`3o
00000?ZJ0?ooo`020?l000D0oooo00<00?ZJ0?ooo`3o00000P3oool0103o00000?ZJ0?ooo`3o0007
0?ooo`03003jVP3oool0o`000080oooo00<0o`000?ooo`00nYX01`3oool00`00nYX0oooo0?l00003
0?ooo`030?l00000nYX0o`000080oooo00@0o`000?ooo`3oool00?ZJ0P3oool01000nYX0o`000?oo
o`3o00030?ooo`03003jVP3oool0oooo00<0oooo00@00?ZJ0?ooo`3oool0o`000P3oool00`3o0000
0?ZJ0?ooo`090?ooo`03003jVP3oool0oooo0080o`000`3oool00`00nYX0oooo0?ooo`040?ooo`04
003jVP3oool0oooo0?l000<0oooo00@0o`000?ooo`3oool0o`00103oool00`00nYX0oooo0?ooo`05
0?ooo`030000003oool0oooo00D0oooo000=0?ooo`040000003oool0oooo000000@0oooo00<00000
0?ooo`3oool00`3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ
0?ooo`3oool0103oool01P00nYX0o`000?ooo`3oool0o`00003jVP80oooo00H0o`000?ooo`3oool0
oooo003jVP3o00020?ooo`80o`000`3oool01P3o0000oooo0?ooo`3oool00?ZJ0?l00080oooo00D0
o`00003jVP3o0000oooo0?l000090?ooo`03003jVP3oool0oooo00H0oooo00<00?ZJ0?ooo`3oool0
1@3oool00`00nYX0oooo0?ooo`060?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool0
1`3oool00`00nYX0oooo0?l000020?ooo`08003jVP3o0000oooo0?ooo`3o00000?ZJ0?l0003oool2
0?l000@0oooo00<00?ZJ0?ooo`3o00000P3oool00`3o00000?ZJ0?ooo`020?l000H0oooo00<00?ZJ
0?ooo`3o00000P3oool00`3o00000?ZJ0?ooo`080?ooo`03003jVP3o0000oooo0080oooo00<0o`00
003jVP3o00000P3oool0103o0000oooo0?ooo`00nYX20?ooo`04003jVP3o0000oooo0?l000<0oooo
00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?l000020?ooo`030?l00000nYX0oooo00T0oooo
00<00?ZJ0?ooo`3oool00P3o00020?ooo`03003jVP3oool0oooo00D0oooo00@00?ZJ0?ooo`3oool0
o`000`3oool0103o0000oooo0?ooo`3o00040?ooo`03003jVP3oool0oooo00D0oooo00<000000?oo
o`3oool01@3oool000d0oooo00@000000?ooo`3oool00000103oool2000000@0oooo00<00?ZJ0?oo
o`3oool01@3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo00@0oooo00H00?ZJ0?l0
003oool0oooo0?l00000nYX20?ooo`060?l0003oool0oooo0?ooo`00nYX0o`000P3oool20?l000<0
oooo0P3o00020?ooo`09003jVP3o0000oooo0?ooo`3o00000?ZJ0?l0003oool0o`0000X0oooo00<0
0?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo00H0oooo00<0
0?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`070?ooo`07003jVP3oool0o`000?l0003oool0
0?ZJ0?l000020?ooo`040?l00000nYX0o`000?ooo`80o`00103oool00`00nYX0oooo0?l000020?oo
o`050?l00000nYX0o`000?ooo`3o00001`3oool01P00nYX0o`000?ooo`3oool0o`00003jVPT0oooo
00<00?ZJ0?l0003oool00P3oool20?l000<0oooo00<0o`000?ooo`3oool00`3oool01000nYX0oooo
0?l0003o00030?ooo`03003jVP3oool0oooo00D0oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX:
0?ooo`03003jVP3oool0oooo00@0oooo00<00?ZJ0?ooo`3oool01@3oool01000nYX0oooo0?ooo`3o
00020?ooo`030?l00000nYX0oooo0080o`00103oool00`00nYX0oooo0?ooo`030?ooo`<000001`3o
ool000d0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`030?ooo`03003jVP3o
ool0oooo00D0oooo00<00?ZJ0?ooo`3oool01@3oool00`00nYX0o`000?ooo`040?ooo`06003jVP3o
0000oooo0?ooo`3o00000?ZJ0P3oool20?l00080oooo00@00?ZJ0?l0003oool0oooo0P3o00040?oo
o`050?l0003oool0oooo003jVP3o00000P3oool01@3o00000?ZJ0?l0003oool0o`0000X0oooo00<0
0?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo00H0oooo00<0
0?ZJ0?ooo`3oool01P3oool00`00nYX0oooo0?ooo`060?ooo`07003jVP3oool0o`000?l0003oool0
0?ZJ0?l000020?ooo`070?l00000nYX0o`000?ooo`3o0000oooo0?l000030?ooo`03003jVP3oool0
o`000080oooo00D0o`00003jVP3o0000oooo0?l000070?ooo`08003jVP3oool0o`000?ooo`3o0000
0?ZJ0?ooo`3o00070?ooo`03003jVP3o0000oooo0080oooo0P3o00030?ooo`030?l0003oool0oooo
00<0oooo00@00?ZJ0?ooo`3o0000o`000P3oool00`00nYX0oooo0?ooo`060?ooo`06003jVP3o0000
oooo0?ooo`3o00000?ZJ2P3oool00`00nYX0oooo0?ooo`040?ooo`03003jVP3oool0oooo00D0oooo
00@00?ZJ0?ooo`3oool0o`000P3oool01@3o00000?ZJ0?l0003oool0o`0000@0oooo00<00?ZJ0?oo
o`3oool01@3oool00`000000oooo0?ooo`050?ooo`003@3oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo00<0oooo00<00?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`050?oo
o`03003jVP3o0000oooo00@0oooo00X00?ZJ0?l0003oool0oooo0?l00000nYX0oooo0?l0003oool0
o`000P3oool01000nYX0o`000?ooo`3oool20?l000@0oooo00D0o`000?ooo`3oool00?ZJ0?l00002
0?ooo`030?l00000nYX0o`000080oooo00<0o`000?ooo`3oool01`3oool00`00nYX0oooo0?ooo`04
0?ooo`03003jVP3oool0oooo00L0oooo00<00?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`06
0?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool00P3o00000`3oool00?ZJ0?l00002
0?ooo`030?l00000nYX0o`0000@0oooo00H0o`000?ooo`3oool00?ZJ0?ooo`3o00020?ooo`050?l0
0000nYX0o`000?ooo`3o00001`3oool02000nYX0oooo0?l0003oool0o`00003jVP3oool0o`001`3o
ool00`00nYX0o`000?ooo`020?ooo`80o`00103oool00`3o0000oooo0?ooo`020?ooo`03003jVP3o
ool0o`0000<0oooo00<00?ZJ0?ooo`3oool00P3o00040?ooo`06003jVP3o0000oooo0?ooo`3o0000
0?ZJ2P3oool00`00nYX0oooo0?ooo`040?ooo`03003jVP3oool0oooo00H0oooo00<00?ZJ0?ooo`3o
00000P3oool00`3o00000?ZJ0?l000020?ooo`050?l0003oool0oooo0?ooo`00nYX01`3oool00`00
0000oooo0?ooo`050?ooo`003@3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo
00<0oooo00<00?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3o0000oooo
00@0oooo00D00?ZJ0?l0003oool0oooo0?l000020?ooo`070?l0003oool0oooo0?l0003oool00?ZJ
0?l000020?ooo`80o`001@3oool0103o0000oooo003jVP3o00020?ooo`030?l00000nYX0o`000080
oooo00<0o`000?ooo`3oool01`3oool00`00nYX0oooo0?ooo`040?ooo`03003jVP3oool0oooo00P0
oooo00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?ooo`060?ooo`03003jVP3oool0oooo00D0
oooo00<00?ZJ0?ooo`3oool00P3o00000`3oool00?ZJ0?l000020?ooo`030?l00000nYX0o`0000@0
oooo00H0o`000?ooo`3oool00?ZJ0?ooo`3o00020?ooo`050?l00000nYX0o`000?ooo`3o00001`3o
ool01`00nYX0oooo0?l0003oool0o`00003jVP3oool00P3o00060?ooo`03003jVP3o0000oooo0080
oooo0P3o00040?ooo`030?l0003oool0oooo0080oooo00<00?ZJ0?ooo`3o00000`3oool00`00nYX0
oooo0?ooo`020?l000@0oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX20?ooo`80o`001P3oool0
0`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo00<0oooo00D0o`000?ooo`3oool0oooo003j
VP020?ooo`050?l0003oool0o`00003jVP3o00000P3oool01@3o0000oooo0?ooo`3oool00?ZJ00L0
oooo00<000000?ooo`3oool01@3oool000h0oooo0P0000050?ooo`030000003oool0oooo00<0oooo
00<00?ZJ0?l0003o00001@3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3o0000o`0000@0oooo
00D00?ZJ0?l0003oool0oooo0?l000020?ooo`070?l0003oool0oooo0?l0003oool00?ZJ0?l00002
0?ooo`80o`001@3oool0103o0000oooo003jVP3o00020?ooo`030?l00000nYX0o`000080oooo00<0
o`000?ooo`3oool0203oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00T0oooo00<0
0?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?ooo`060?ooo`03003jVP3oool0oooo00D0oooo00P0
0?ZJ0?ooo`3oool0o`000?ooo`3o00000?ZJ0?l00080oooo00<0o`00003jVP3o0000103oool01P3o
0000oooo0?ooo`00nYX0oooo0?l00080oooo00D0o`00003jVP3o0000oooo0?l000070?ooo`07003j
VP3oool0o`000?ooo`3o00000?ZJ0?ooo`020?l000H0oooo00<00?ZJ0?l0003oool00P3oool20?l0
00@0oooo00<0o`000?ooo`3oool00P3oool00`00nYX0oooo0?l000020?ooo`04003jVP3oool0oooo
0?ooo`80o`00103oool01P00nYX0oooo0?l0003oool0o`00003jVP80oooo0P3o00060?ooo`03003j
VP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00`3oool01@3o0000oooo0?ooo`3oool00?ZJ0080
oooo00D0o`000?ooo`3o00000?ZJ0?l000020?ooo`050?l0003oool0oooo0?ooo`00nYX01`3oool0
0`000000oooo0?ooo`050?ooo`005@3oool2000000@0oooo00<00?ZJ0?l0003o00000P3oool0103o
0000oooo0?ooo`00nYX70?ooo`03003jVP3o0000o`0000@0oooo00L00?ZJ0?l0003oool0oooo0?l0
003oool0o`0000@0oooo00<0o`00003jVP3o00000P3oool20?l000D0oooo00@0o`000?ooo`00nYX0
o`000P3oool00`3o00000?ZJ0?l000020?ooo`030?l0003oool0oooo00P0oooo00D00?ZJ0?ooo`3o
ool0oooo003jVP050?ooo`030?l0003oool0oooo00D0oooo0P00nYX40?ooo`03003jVP3oool0oooo
00L0oooo00<00?ZJ0?ooo`3oool0103oool02000nYX0oooo0?ooo`3o0000oooo0?l00000nYX0o`00
0P3oool00`3o00000?ZJ0?l000040?ooo`040?l0003oool0oooo003jVP80oooo00L0o`000?ooo`3o
00000?ZJ0?l0003oool0o`0000<0oooo0`3o00002`3oool00?ZJ0?ooo`3o0000oooo0?l00000nYX0
oooo0?l0003oool0o`0000<0oooo00@0o`000?ooo`00nYX0o`000`3oool20?l000@0oooo00<0o`00
0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`020?ooo`07003jVP3oool0oooo0?ooo`3o0000oooo
0?l000030?ooo`06003jVP3oool0o`000?ooo`3o00000?ZJ0P3oool20?l000L0oooo00<00?ZJ0?oo
o`3oool00P3oool00`00nYX0oooo0?ooo`020?ooo`80o`000`3oool02000nYX0oooo0?ooo`3o0000
oooo0?l00000nYX0o`000P3oool01@3o0000oooo0?ooo`3oool00?ZJ00H0oooo0P0000070?ooo`00
5@3oool00`000000oooo0?ooo`030?ooo`03003jVP3o0000o`000080oooo00D0o`000?ooo`3oool0
oooo003jVP060?ooo`03003jVP3o0000o`0000@0oooo00L00?ZJ0?l0003oool0o`00003jVP3oool0
o`0000@0oooo00<0o`00003jVP3o00000P3oool20?l000D0oooo00@0o`000?ooo`00nYX0o`000P3o
ool00`3o00000?ZJ0?l000020?ooo`030?l0003oool0oooo00P0oooo00D00?ZJ0?ooo`3oool0oooo
003jVP050?ooo`030?l0003oool0oooo00H0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo
0?ooo`070?ooo`03003jVP3oool0oooo00@0oooo00<00?ZJ0?ooo`3o00000P3oool00`3o00000?ZJ
0?l000020?ooo`030?l00000nYX0o`0000D0oooo00`0o`000?ooo`3oool00?ZJ0?ooo`3o0000oooo
0?l00000nYX0o`000?ooo`3o00030?ooo`0>0?l0003oool0o`000?ooo`00nYX0oooo0?l0003oool0
o`00003jVP3oool0o`000?ooo`3o00030?ooo`040?l0003oool00?ZJ0?l000<0oooo0P3o00040?oo
o`030?l0003oool0oooo0080oooo00<00?ZJ0?ooo`3oool00P3oool01`00nYX0oooo0?ooo`3oool0
o`000?ooo`3o00000`3oool02P00nYX0oooo0?l0003oool0o`00003jVP3oool0o`000?ooo`3o0007
0?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool00P3oool20?l000<0oooo00@00?ZJ
0?ooo`3oool0oooo0P3o00001@00nYX0o`000?ooo`3oool0o`0000@0oooo00<00?ZJ0?ooo`3oool0
103oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`030?ooo`05003jVP3o
0000oooo0?l0003oool00P3o00020?ooo`03003jVP3oool0oooo00@0oooo00@00?ZJ0?l0003oool0
o`000`3oool01`00nYX0o`000?ooo`3o00000?ZJ0?ooo`3o0000103oool00`3o00000?ZJ0?l00002
0?ooo`80o`001@3oool0103o0000oooo003jVP3o00020?ooo`80o`000`3oool00`3o0000oooo0?oo
o`080?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool00`3o0000oooo0?ooo`060?ooo`05003j
VP3oool0oooo0?ooo`00nYX02P3oool00`00nYX0oooo0?ooo`040?ooo`03003jVP3oool0o`000080
oooo00<0o`00003jVP3o00000P3oool00`3o00000?ZJ0?l000050?ooo`0<0?l0003oool0oooo003j
VP3oool0o`000?ooo`3o00000?ZJ0?l0003oool0o`000`3oool02`3o0000oooo0?l0003oool00?ZJ
0?ooo`3o0000oooo0?l00000nYX0o`000080oooo00@0o`000?ooo`3oool0oooo0P3o00001`00nYX0
o`000?ooo`3oool0o`00003jVP3o0000103oool00`3o0000oooo0?ooo`030?ooo`05003jVP3oool0
oooo0?ooo`00nYX00`3oool00`3o0000oooo0?l000030?ooo`08003jVP3oool0o`000?ooo`3o0000
0?ZJ0?ooo`3o00020?ooo`030?l0003oool0oooo00@0oooo00<00?ZJ0?ooo`3oool00P3oool00`00
nYX0oooo0?ooo`020?ooo`030?l0003oool0o`000080oooo00@00?ZJ0?ooo`3oool0oooo0P3o0000
1@00nYX0o`000?ooo`3oool0o`0000@0oooo00<00?ZJ0?ooo`3oool0103oool00`000000oooo0?oo
o`050?ooo`005@3oool00`000000oooo0?ooo`040?ooo`040?l0003oool0o`000?ooo`80o`000P3o
ool01@00nYX0oooo0?ooo`3oool00?ZJ0080oooo00D00?ZJ0?l0003oool0o`000?ooo`020?l00006
003jVP3o0000oooo0?l00000nYX0o`001@3oool00`3o0000oooo0?l000020?ooo`80o`001@3oool0
103o0000oooo003jVP3o00020?ooo`80o`000`3oool00`3o0000oooo0?ooo`080?ooo`05003jVP3o
ool0oooo0?ooo`00nYX0103oool20?l000T0oooo00@00?ZJ0?ooo`3oool00?ZJ2P3oool00`00nYX0
oooo0?ooo`030?ooo`04003jVP3oool0oooo0?l00080oooo00<0o`00003jVP3o00000P3oool20?l0
00H0oooo00`0o`000?ooo`3oool00?ZJ0?ooo`3o0000oooo0?l00000nYX0o`000?ooo`3o00020?oo
o`0<0?l0003oool0oooo0?l0003oool00?ZJ0?ooo`3o0000oooo0?l00000nYX0o`000P3oool0103o
0000oooo0?ooo`3oool20?l00007003jVP3o0000oooo0?ooo`3o00000?ZJ0?l000040?ooo`030?l0
003oool0oooo00<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP030?ooo`030?l0003oool0o`0000@0
oooo00L00?ZJ0?l0003o0000oooo003jVP3oool0o`000080oooo00<0o`000?ooo`3oool0103oool0
0`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo0080oooo00<0o`000?ooo`3o00000P3oool0
0`00nYX0oooo0?ooo`020?ooo`030?l00000nYX0o`0000<0oooo00D0o`000?ooo`3oool0oooo003j
VP060?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00@0oooo00@0o`00
0?ooo`3o0000oooo0P3o00020?ooo`09003jVP3oool0oooo0?ooo`00nYX0oooo003jVP3oool0o`00
0080oooo00T0o`000?ooo`3o00000?ZJ0?l0003oool0o`00003jVP3o00001@3oool00`3o0000oooo
0?l000020?ooo`80o`001@3oool0103o0000oooo003jVP3o00020?ooo`80o`00103oool00`3o0000
oooo0?ooo`030?l000D0oooo00@00?ZJ0?ooo`3oool00?ZJ103oool00`3o0000oooo0?l000080?oo
o`04003jVP3oool0oooo003jVPX0oooo00<00?ZJ0?ooo`3oool00`3oool01000nYX0oooo0?ooo`3o
00020?ooo`030?l0003oool0o`000080oooo0P3o00060?ooo`040?l0003oool0oooo003jVP80oooo
0P3o00001000nYX0o`000?ooo`3o00020?ooo`070?l0003oool0oooo0?ooo`3o00000?ZJ0?ooo`02
0?l000030?ooo`00nYX0o`000080oooo00d0o`000?ooo`3oool0o`000?ooo`3o00000?ZJ0?ooo`3o
0000oooo0?l00000nYX0o`0000@0oooo00<0o`000?ooo`3oool00`3oool01@00nYX0oooo0?ooo`3o
ool00?ZJ00<0oooo00<0o`000?ooo`3o0000103oool01P00nYX0o`000?l0003oool00?ZJ0?l000<0
oooo00<0o`000?ooo`3oool0103oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo0080
oooo00<0o`000?ooo`3o00000`3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3o0000oooo0080
oooo00D0o`000?ooo`3oool0oooo003jVP060?ooo`030000003oool0oooo00D0oooo000E0?ooo`80
00001@3oool0103o0000oooo0?l0003o00020?ooo`030?l0003oool00?ZJ0080oooo0P00nYX0103o
ool00?ZJ0?ooo`3o00040?ooo`070?l00000nYX0o`000?ooo`3o00000?ZJ0?l000050?ooo`030?l0
003oool0o`000080oooo0P3o00060?ooo`030?l00000nYX0o`000080oooo0P3o00040?ooo`060?l0
003oool0oooo0?l0003oool0o`001@3oool01000nYX0oooo0?ooo`00nYX40?ooo`030?l0003oool0
o`0000P0oooo00@00?ZJ0?ooo`3oool00?ZJ2`3oool00`00nYX0oooo0?ooo`020?ooo`04003jVP3o
ool0oooo0?l00080oooo00<0o`000?ooo`3o00000P3oool20?l000H0oooo00@0o`000?ooo`3oool0
0?ZJ0P3oool20?l00004003jVP3o0000oooo0?l00080oooo00L0o`000?ooo`3oool0oooo0?l00000
nYX0oooo0080o`0000<0oooo003jVP3o00000P3oool03@3o0000oooo0?ooo`3o0000oooo0?l00000
nYX0oooo0?l0003oool0o`00003jVP3o00001@3oool00`3o0000oooo0?ooo`020?ooo`04003jVP3o
ool0oooo003jVP<0oooo00D0o`000?ooo`3oool0oooo0?l000030?ooo`06003jVP3o0000o`000?oo
o`00nYX0o`000`3oool00`3o0000oooo0?ooo`040?ooo`05003jVP3oool0oooo0?ooo`00nYX0103o
ool0103o0000oooo0?ooo`3o00030?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?l0003oool0
0P3oool01@3o0000oooo0?ooo`3oool00?ZJ00D0oooo0P0000070?ooo`005@3oool00`000000oooo
0?ooo`040?ooo`040?l0003oool0o`000?l00080oooo00<0o`000?ooo`00nYX00P3oool01P00nYX0
oooo003jVP00nYX0oooo0?l000@0oooo00L0o`00003jVP3o0000oooo0?l00000nYX0o`0000H0oooo
0P3o00020?ooo`80o`001P3oool00`3o00000?ZJ0?l000020?ooo`80o`00103oool01P3o0000oooo
0?ooo`3o0000oooo0?l000D0oooo00<00?ZJ0?ooo`00nYX0103oool0103o0000oooo0?ooo`3o0009
0?ooo`03003jVP3oool00?ZJ00/0oooo00<00?ZJ0?ooo`3oool00P3oool01000nYX0oooo0?ooo`3o
00030?ooo`80o`000P3oool20?l000L0oooo00<0o`000?ooo`00nYX00`3oool01@3o00000?ZJ0?l0
003oool0o`000080oooo00H0o`000?ooo`3oool0oooo0?l00000nYX20?ooo`040?l0003oool00?ZJ
0?l00080oooo00d0o`000?ooo`3oool0o`000?ooo`3o00000?ZJ0?ooo`3o0000oooo0?l00000nYX0
o`0000D0oooo00<0o`000?ooo`3oool00P3oool01000nYX0oooo0?ooo`00nYX30?ooo`050?l0003o
ool0oooo0?ooo`3o00000`3oool01P00nYX0o`000?l0003oool00?ZJ0?l000<0oooo00<0o`000?oo
o`3oool0103oool01@00nYX0oooo0?ooo`3oool00?ZJ00@0oooo00@0o`000?ooo`3oool0o`000`3o
ool00`00nYX0oooo0?ooo`020?ooo`03003jVP3o0000oooo00<0oooo00@0o`000?ooo`3oool00?ZJ
1P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`040?ooo`040?l0003o
ool0oooo0?l00080oooo00<0o`000?ooo`00nYX00P3oool01@00nYX0oooo003jVP00nYX0o`0000D0
oooo00<0o`00003jVP3oool00P3o00000`00nYX0o`000?ooo`050?ooo`040?l00000nYX0o`000?oo
o`80o`001P3oool00`3o00000?ZJ0?l000020?ooo`80o`001@3oool20?l000<0oooo00<0o`000?oo
o`3oool00P3oool00`00nYX0oooo003jVP040?ooo`040?l0003oool0oooo0?l000T0oooo00<00?ZJ
0?ooo`00nYX02`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00<0oooo00@0o`000?ooo`3oool0oooo
0P3o00020?ooo`80o`001`3oool00`3o0000oooo003jVP040?ooo`07003jVP3o0000oooo0?ooo`3o
0000oooo0?l000030?ooo`080?l00000nYX0oooo0?ooo`3o0000oooo003jVP3o00030?ooo`0<0?l0
003oool0o`000?ooo`3o00000?ZJ0?ooo`3o0000oooo0?l00000nYX0o`001@3oool00`3o0000oooo
0?ooo`020?ooo`04003jVP3oool0oooo003jVP<0oooo00D0o`000?ooo`3oool0oooo0?l000030?oo
o`06003jVP3o0000oooo0?ooo`00nYX0o`00103oool00`3o0000oooo0?ooo`030?ooo`05003jVP3o
ool0oooo0?ooo`00nYX0103oool01@3o0000oooo0?ooo`3oool0o`000080oooo00<00?ZJ0?ooo`3o
ool00P3oool00`00nYX0o`000?ooo`040?ooo`040?l0003oool0oooo003jVPD0oooo00<000000?oo
o`3oool01@3oool001D0oooo00<000000?ooo`3oool0103oool0103o0000oooo0?ooo`3o00020?oo
o`030?l0003oool00?ZJ0080oooo00D00?ZJ0?ooo`00nYX00?ZJ0?l000050?ooo`030?l00000nYX0
oooo0080o`0000<00?ZJ0?l0003oool01@3oool0103o00000?ZJ0?l0003oool20?l000H0oooo00L0
o`00003jVP3o0000oooo0?l00000nYX0o`0000D0oooo0P3o00030?ooo`030?l0003oool0oooo00<0
oooo0P00nYX40?ooo`040?l0003oool0oooo0?l000T0oooo00@00?ZJ0?ooo`00nYX0oooo0`3o0000
0`3oool0o`000?ooo`050?ooo`04003jVP3oool0oooo003jVP<0oooo00P0o`000?ooo`3oool0oooo
0?l00000nYX0o`000?ooo`80o`001`3oool00`3o0000oooo003jVP040?ooo`040?l0003oool0oooo
0?ooo`80o`00103oool0203o0000oooo003jVP3oool0o`000?ooo`00nYX0o`000`3oool0303o0000
oooo0?l0003oool0o`00003jVP3oool0o`000?ooo`3o00000?ZJ0?l000D0oooo00<0o`000?ooo`3o
ool00P3oool01000nYX0oooo0?ooo`00nYX30?ooo`050?l0003oool0oooo0?ooo`3o00000`3oool0
1P00nYX0o`000?ooo`3oool00?ZJ0?l000@0oooo00<0o`000?ooo`3o00000`3oool01@00nYX0oooo
0?ooo`3oool00?ZJ00@0oooo00D0o`000?ooo`3oool0oooo0?l000020?ooo`03003jVP3oool0oooo
0080oooo00<00?ZJ0?l0003oool0103oool0103o0000oooo0?ooo`00nYX50?ooo`030000003oool0
oooo00D0oooo000E0?ooo`030000003oool0oooo00@0oooo00<0o`000?ooo`3oool00`3oool00`3o
0000oooo003jVP020?ooo`05003jVP3oool00?ZJ003jVP3o00001@3oool00`3o00000?ZJ0?ooo`02
0?l00003003jVP3o0000oooo00D0oooo00@0o`00003jVP3o0000oooo0P3o00060?ooo`070?l00000
nYX0o`000?ooo`3o00000?ZJ0?l0000:0?ooo`030?l0003oool0oooo00<0oooo0P00nYX40?ooo`05
0?l0003oool0oooo0?ooo`3o0000203oool2003jVP80oooo00<0o`000?ooo`3oool00P3o00060?oo
o`04003jVP3oool0oooo003jVP<0oooo00P0o`000?ooo`3oool0oooo0?l00000nYX0o`000?ooo`80
o`001`3oool00`3o0000oooo003jVP040?ooo`040?l0003oool0oooo0?ooo`80o`00103oool0203o
0000oooo003jVP3oool0o`00003jVP3oool0o`000`3oool20?l00080oooo00P0o`00003jVP3oool0
o`000?ooo`3o00000?ZJ0?l000D0oooo00<0o`000?ooo`3oool00P3oool01000nYX0oooo0?ooo`00
nYX30?ooo`050?l0003oool0oooo0?ooo`3o00000`3oool01P00nYX0oooo0?ooo`3oool00?ZJ0?l0
00@0oooo00<0o`000?ooo`3o0000103oool01000nYX0oooo0?ooo`00nYX40?ooo`050?l0003oool0
oooo0?ooo`3o00000P3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3o0000oooo00@0oooo00@0
o`000?ooo`3oool00?ZJ1@3oool00`000000oooo0?ooo`050?ooo`005@3oool2000000D0oooo00<0
o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`02003jVP<0oooo00<00?ZJ0?l0003oool0103o
ool01`3o00000?ZJ0?ooo`3oool0o`00003jVP3o00001P3oool0103o00000?ZJ0?l0003oool20?l0
00H0oooo00L0o`00003jVP3o0000oooo0?l00000nYX0o`0000X0oooo00<0o`000?ooo`3oool0103o
ool00`00nYX0oooo0?ooo`020?ooo`050?l0003oool0oooo0?ooo`3o00002@3oool01000nYX0oooo
0?ooo`3o00040?ooo`030?l0003oool0oooo00<0oooo00<00?ZJ0?ooo`00nYX0103oool0203o0000
oooo0?ooo`3oool0o`00003jVP3o0000oooo0P3o00070?ooo`030?l0003oool00?ZJ00@0oooo00@0
o`000?ooo`3oool0oooo0P3o00040?ooo`080?l0003oool00?ZJ0?ooo`3o00000?ZJ0?ooo`3o0003
0?ooo`80o`000P3oool0203o00000?ZJ0?ooo`3o0000oooo0?l00000nYX0o`001@3oool00`3o0000
oooo0?ooo`020?ooo`04003jVP3oool0oooo003jVP<0oooo00D0o`000?ooo`3oool0oooo0?l00003
0?ooo`06003jVP3oool0oooo003jVP3oool0o`001@3oool00`3o0000oooo0?l000030?ooo`04003j
VP3oool0oooo003jVP<0oooo00<0o`000?ooo`3oool00P3oool0103o0000oooo0?ooo`00nYX40?oo
o`03003jVP3o0000oooo00@0oooo00<0o`000?ooo`3oool01@3oool2000000L0oooo000E0?ooo`03
0000003oool0oooo00@0oooo00<0o`000?ooo`3oool0103oool0103o0000oooo003jVP00nYX30?oo
o`03003jVP3o0000oooo00@0oooo00<0o`00003jVP3oool00P3oool00`00nYX0o`000?ooo`050?oo
o`040?l00000nYX0o`000?ooo`80o`001P3oool01`3o00000?ZJ0?l0003oool0o`00003jVP3o0000
2`3oool00`3o0000oooo0?ooo`080?ooo`050?l0003oool0oooo0?ooo`3o00002@3oool01000nYX0
oooo0?ooo`3o00040?ooo`030?l0003oool0oooo00@0oooo0P00nYX30?ooo`030?l0003oool0oooo
0080oooo00@0o`00003jVP3o0000oooo0P3o00080?ooo`030?l00000nYX0oooo0080oooo00<00?ZJ
0?l0003oool00P3oool00`3o0000oooo0?ooo`030?ooo`080?l0003oool00?ZJ0?ooo`3o00000?ZJ
0?ooo`3o00030?ooo`80o`000P3oool0203o00000?ZJ0?ooo`3o0000oooo0?l00000nYX0o`001@3o
ool00`3o0000oooo0?ooo`020?ooo`04003jVP3oool0oooo003jVP<0oooo00<0o`000?ooo`3oool0
0P3oool0103o0000oooo0?ooo`00nYX20?ooo`03003jVP3oool0o`0000P0oooo00@0o`000?ooo`3o
ool00?ZJ0P3oool01@00nYX0oooo0?ooo`3oool0o`0000@0oooo00@0o`000?ooo`3oool00?ZJ103o
ool00`00nYX0o`000?ooo`040?ooo`030?l0003oool0oooo00H0oooo00<000000?ooo`3oool01@3o
ool001D0oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`040?ooo`040?l0003oool0
0?ZJ003jVP@0oooo00<0o`000?ooo`3oool00`3oool00`3o00000?ZJ0?ooo`020?ooo`03003jVP3o
0000oooo00D0oooo00@0o`00003jVP3o0000oooo0P3o00060?ooo`070?l00000nYX0o`000?ooo`3o
00000?ZJ0?l0000;0?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3oool00`3oool00`3o
0000oooo0?ooo`060?ooo`04003jVP3oool0oooo0?l000@0oooo00<0o`000?ooo`3oool0103oool0
0`00nYX0oooo0?ooo`020?ooo`030?l0003oool0oooo0080oooo00@0o`00003jVP3o0000oooo0P3o
00080?ooo`030?l00000nYX0oooo0080oooo00<00?ZJ0?l0003oool00P3oool00`3o0000oooo0?oo
o`030?ooo`030?l0003oool00?ZJ0080oooo00<00?ZJ0?ooo`3o00000`3oool0303o0000oooo0?oo
o`3oool0o`000?ooo`00nYX0o`000?ooo`3o00000?ZJ0?l000H0oooo0`3o00001@3oool00?ZJ0?oo
o`3oool00?ZJ00<0oooo00<0o`000?ooo`3oool00P3oool0103o0000oooo0?ooo`00nYX20?ooo`03
003jVP3oool0o`0000P0oooo00H0o`000?ooo`3oool00?ZJ0?ooo`00nYX40?ooo`030?l0003oool0
oooo00<0oooo00<0o`000?ooo`00nYX0103oool00`00nYX0o`000?ooo`040?ooo`030?l0003oool0
oooo00H0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0103oool00`3o
0000oooo0?ooo`040?ooo`040?l0003oool0oooo003jVP@0oooo00<0o`000?ooo`3oool00`3oool0
0`3o00000?ZJ0?ooo`020?ooo`03003jVP3o0000oooo00D0oooo00@0o`00003jVP3o0000oooo0P3o
00070?ooo`80o`0000@0oooo0?l00000nYX0o`00303oool00`3o0000oooo0?ooo`060?ooo`030?l0
003oool0oooo00<0oooo0P3o000:0?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool0
203oool00`3o0000oooo0?ooo`020?ooo`040?l00000nYX0o`000?ooo`80o`00203oool00`3o0000
0?ZJ0?ooo`020?ooo`03003jVP3o0000oooo00P0oooo00<0o`000?ooo`00nYX00P3oool00`00nYX0
oooo0?l000070?ooo`080?l0003oool00?ZJ0?l0003oool0o`00003jVP3o00060?ooo`80o`0000D0
oooo0?l00000nYX0oooo003jVP040?ooo`030?l0003oool0oooo0080oooo00@0o`000?ooo`3oool0
0?ZJ0P3oool00`00nYX0o`000?ooo`090?ooo`050?l0003oool00?ZJ0?ooo`00nYX00`3oool00`3o
0000oooo0?ooo`040?ooo`040?l0003oool0oooo003jVP<0oooo00<0o`000?ooo`3oool01@3oool0
0`3o0000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo000E0?ooo`8000001@3oool00`3o
0000oooo0?ooo`040?ooo`040?l0003oool0oooo003jVP@0oooo00<0o`000?ooo`3oool0103oool0
1P3o0000oooo0?ooo`3oool00?ZJ0?l000H0oooo00@0o`00003jVP3o0000oooo0P3o00070?ooo`80
o`0000@0oooo0?l00000nYX0o`00303oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo
00@0oooo00<0o`000?ooo`3oool0203oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo
00L0oooo00<0o`000?ooo`3oool00P3oool0103o00000?ZJ0?l0003oool20?l000P0oooo00<0o`00
0?ooo`00nYX00P3oool00`00nYX0o`000?ooo`080?ooo`030?l0003oool00?ZJ0080oooo00<00?ZJ
0?ooo`3o00001`3oool0203o0000oooo003jVP3o0000oooo0?l00000nYX0o`001P3oool01`3o0000
oooo0?ooo`3o00000?ZJ0?ooo`00nYX00`3oool00`3o0000oooo0?ooo`030?ooo`040?l0003oool0
oooo003jVP80oooo00<00?ZJ0?l0003oool02@3oool00`3o0000oooo0?ooo`02003jVP<0oooo00<0
o`000?ooo`3oool0103oool0103o0000oooo0?ooo`00nYX30?ooo`030?l0003oool0oooo00D0oooo
00<0o`000?ooo`3oool0103oool2000000L0oooo000E0?ooo`030000003oool0oooo00@0oooo00<0
o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00@0oooo00H0
o`00003jVP3oool0oooo003jVP3o00060?ooo`040?l00000nYX0o`000?ooo`80o`001`3oool20?l0
00040?ooo`3o00000?ZJ0?l000`0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`05
0?ooo`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`07
0?ooo`030?l0003oool0oooo0080oooo00@0o`00003jVP3o0000oooo0P3o00080?ooo`030?l0003o
ool00?ZJ0080oooo00<00?ZJ0?l0003oool0203oool00`3o0000oooo003jVP020?ooo`03003jVP3o
0000oooo00P0oooo00L0o`00003jVP3o0000oooo0?l00000nYX0o`0000H0oooo00L0o`000?ooo`3o
ool0o`00003jVP3oool00?ZJ00<0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo003jVP02
0?ooo`03003jVP3o0000oooo00T0oooo00<0o`000?ooo`3oool00P00nYX20?ooo`030?l0003oool0
oooo00D0oooo00@0o`000?ooo`3oool00?ZJ0`3oool00`3o0000oooo0?ooo`050?ooo`030?l0003o
ool0oooo00D0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0103oool0
0`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool0103oool0
1P3o00000?ZJ0?ooo`3oool00?ZJ0?l000H0oooo00@0o`00003jVP3o0000oooo0P3o00070?ooo`80
o`0000@0oooo0?l00000nYX0o`003@3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo
00D0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo
00L0oooo00<0o`000?ooo`3oool00P3oool0103o00000?ZJ0?l0003oool20?l000P0oooo00<0o`00
0?ooo`00nYX00P3oool00`00nYX0o`000?ooo`090?ooo`060?l00000nYX0oooo0?ooo`00nYX0o`00
2@3oool01`3o00000?ZJ0?l0003oool0o`00003jVP3o00002@3oool0103o0000oooo003jVP00nYX3
0?ooo`030?l0003oool0oooo00D0oooo00H0o`00003jVP3oool0oooo003jVP3o000:0?ooo`030?l0
003oool0oooo00@0oooo00<0o`000?ooo`3oool01@3oool0103o0000oooo0?ooo`00nYX20?ooo`03
003jVP3o0000oooo00H0oooo00<0o`000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`00
1P3oool500000080oooo0`0000050?ooo`030000003oool0oooo00@0oooo00<0o`000?ooo`3oool0
103oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00@0oooo00H0o`00003jVP3oool0
oooo003jVP3o00060?ooo`040?l00000nYX0o`000?ooo`80o`001`3oool20?l000040?ooo`3o0000
0?ZJ0?l000d0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`050?ooo`030?l0003o
ool0oooo00H0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`060?ooo`030?l0003o
ool0oooo0080oooo00@0o`00003jVP3o0000oooo0P3o00080?ooo`030?l0003oool00?ZJ0080oooo
00<00?ZJ0?l0003oool02@3oool01P3o0000oooo003jVP3oool00?ZJ0?l000T0oooo00@0o`00003j
VP3o0000oooo0P3o000:0?ooo`040?l0003oool00?ZJ003jVP80oooo00<0o`000?ooo`3oool01P3o
ool01P3o00000?ZJ0?ooo`3oool00?ZJ0?l000X0oooo00<0o`000?ooo`3oool0103oool00`3o0000
oooo0?ooo`050?ooo`040?l0003oool0oooo003jVP80oooo00<00?ZJ0?l0003oool01P3oool00`3o
0000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00070?ooo`060000003oool0oooo0000
003oool000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<0o`00
0?ooo`3oool0103oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00@0oooo00H0o`00
003jVP3oool0oooo003jVP3o00060?ooo`040?l00000nYX0o`000?ooo`80o`001`3oool20?l00004
0?ooo`3o00000?ZJ0?l000d0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`070?oo
o`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`050?oo
o`030?l0003oool0oooo00<0oooo00@0o`00003jVP3o0000oooo0P3o00080?ooo`030?l0003oool0
0?ZJ0080oooo00<00?ZJ0?l0003oool02@3oool01P3o0000oooo003jVP3oool00?ZJ0?l000T0oooo
00@0o`00003jVP3o0000oooo0P3o000:0?ooo`030?l0003oool00?ZJ00<0oooo00<0o`000?ooo`3o
ool01P3oool01P3o00000?ZJ0?ooo`3oool00?ZJ0?l000X0oooo00<0o`000?ooo`3oool0103oool0
0`3o0000oooo0?ooo`060?ooo`030?l0003oool00?ZJ0080oooo00<00?ZJ0?l0003oool01P3oool0
0`3o0000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00080?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool00P3oool2000000@0oooo00<0o`000?ooo`3oool01@3oool00`3o
0000oooo0?ooo`050?ooo`030?l0003oool0oooo00@0oooo00D0o`00003jVP3oool0oooo0?l00007
0?ooo`060?l00000nYX0o`000?l00000nYX0o`001`3oool20?l000040?ooo`3o00000?ZJ0?l000d0
oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`080?ooo`030?l0003oool0oooo00@0
oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00<0
oooo00@0o`00003jVP3o0000oooo0P3o00080?ooo`030?l0003oool00?ZJ0080oooo00<00?ZJ0?l0
003oool02@3oool01P3o0000oooo003jVP3oool00?ZJ0?l000T0oooo00H0o`00003jVP3oool0o`00
0?ooo`3o000:0?ooo`030?l0003oool00?ZJ00<0oooo00<0o`000?ooo`3oool01P3oool01P3o0000
0?ZJ0?ooo`3oool00?ZJ0?l000X0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`07
0?ooo`070?l0003oool0oooo003jVP3oool00?ZJ0?l000070?ooo`030?l0003oool0oooo00<0oooo
0`0000070?ooo`002@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool00`3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00D0oooo00<0
o`000?ooo`3oool0103oool01@3o00000?ZJ0?ooo`3oool0o`0000L0oooo00H0o`00003jVP3o0000
o`00003jVP3o00070?ooo`80o`0000@0oooo0?l00000nYX0o`003P3oool00`3o0000oooo0?ooo`02
0?ooo`030?l0003oool0oooo00T0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`06
0?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool00`3oool0103o00000?ZJ0?l0003o
ool20?l000P0oooo00<0o`000?ooo`00nYX00P3oool00`00nYX0o`000?ooo`090?ooo`060?l0003o
ool00?ZJ0?ooo`00nYX0o`002@3oool01P3o00000?ZJ0?ooo`3o0000oooo0?l000X0oooo00<0o`00
0?ooo`00nYX00P3oool00`3o0000oooo0?ooo`070?ooo`060?l0003oool00?ZJ0?ooo`00nYX0o`00
2P3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00L0oooo00L0o`000?ooo`3oool0
0?ZJ0?ooo`00nYX0o`0000L0oooo00<0o`000?ooo`3oool01@3oool00`000000oooo0?ooo`050?oo
o`001P3oool01P000000oooo0?ooo`3oool000000?ooo`@000001@3oool00`000000oooo0?ooo`03
0?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool01@3oool00`3o0000oooo0?ooo`04
0?ooo`050?l00000nYX0oooo0?ooo`3o00001`3oool00`3o00000?ZJ0?l000020?l000P0oooo0P3o
0000103oool0o`00003jVP3o000>0?ooo`050?l0003oool0oooo0?ooo`3o00003@3oool20?l000@0
oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00<0
oooo00@0o`00003jVP3o0000oooo0P3o00080?ooo`070?l0003oool0oooo003jVP3oool00?ZJ0?l0
000:0?ooo`060?l0003oool00?ZJ0?ooo`00nYX0o`002@3oool01P3o00000?ZJ0?ooo`3o0000oooo
0?l000X0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`070?ooo`060?l0003oool0
0?ZJ0?ooo`00nYX0o`002`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00L0oooo
00L0o`000?ooo`3oool00?ZJ0?ooo`00nYX0o`0000L0oooo00<0o`000?ooo`3oool01@3oool00`00
0000oooo0?ooo`050?ooo`001P3oool01`000000oooo0?ooo`3oool000000?ooo`000000203oool0
0`000000oooo0?ooo`030?ooo`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool0103oool0
0`3o0000oooo0?ooo`040?ooo`050?l00000nYX0oooo003jVP3o00001`3oool00`3o00000?ZJ0?l0
00020?l000P0oooo00H0o`00003jVP3o0000o`00003jVP3o000>0?ooo`050?l0003oool0oooo0?oo
o`3o00003P3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00L0oooo00<0o`000?oo
o`3oool0103oool00`3o0000oooo0?ooo`030?ooo`040?l00000nYX0o`000?ooo`80o`002@3oool0
1P3o0000oooo003jVP3oool00?ZJ0?l000X0oooo00H0o`000?ooo`00nYX0oooo003jVP3o00090?oo
o`060?l00000nYX0oooo0?l0003oool0o`002P3oool00`3o0000oooo0?ooo`020?ooo`030?l0003o
ool0oooo00L0oooo00H0o`000?ooo`00nYX0oooo003jVP3o000;0?ooo`030?l0003oool0oooo0080
oooo00<0o`000?ooo`3oool01`3oool0103o0000oooo0?ooo`3oool2003jVP030?l0003oool0oooo
00D0oooo00<0o`000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`001`3oool300000080
oooo1@0000040?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool01P3oool00`3o0000
oooo0?ooo`040?ooo`030?l0003oool0oooo00@0oooo00D0o`00003jVP3oool00?ZJ0?l000070?oo
o`030?l00000nYX0o`000080o`00203oool01P3o00000?ZJ0?l0003oool00?ZJ0?l000h0oooo00D0
o`000?ooo`3oool0oooo0?l0000>0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool0
1`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00<0oooo00@0o`00003jVP3o0000
oooo0P3o00090?ooo`060?l0003oool00?ZJ0?ooo`00nYX0o`002P3oool01P3o0000oooo003jVP3o
ool00?ZJ0?l000T0oooo00H0o`00003jVP3oool0o`00003jVP3o000;0?ooo`050?l0003oool0oooo
0?ooo`3o00002@3oool01P3o0000oooo003jVP3oool00?ZJ0?l000/0oooo00<0o`000?ooo`3oool0
0P3oool00`3o0000oooo0?ooo`070?ooo`040?l0003oool0oooo0?ooo`800?ZJ00<0o`000?ooo`3o
ool01@3oool00`3o0000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000
103oool00`3o0000oooo0?ooo`060?ooo`050?l0003oool0oooo0?ooo`3o00000P3oool00`3o0000
oooo0?ooo`040?ooo`050?l00000nYX0oooo003jVP3o0000203oool40?l000P0oooo00H0o`00003j
VP3o0000oooo003jVP3o000>0?ooo`050?l0003oool0oooo0?ooo`3o00003`3oool0103o0000oooo
0?ooo`3o000:0?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool0103oool01P3o0000
0?ZJ0?ooo`3o00000?ZJ0?l000T0oooo00H0o`000?ooo`00nYX0oooo003jVP3o000:0?ooo`060?l0
003oool00?ZJ0?ooo`00nYX0o`002@3oool01P3o00000?ZJ0?ooo`3o00000?ZJ0?l000/0oooo00D0
o`000?ooo`3oool0oooo0?l0000:0?ooo`050?l00000nYX00?ZJ0?ooo`3o00002`3oool00`3o0000
oooo0?ooo`020?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3oool00P3oool00`00nYX0
o`000?ooo`070?ooo`030?l0003oool0oooo00<0oooo0P0000070?ooo`005@3oool00`000000oooo
0?ooo`030?ooo`030?l0003oool0oooo00H0oooo00L0o`000?ooo`3oool0oooo0?l0003oool0o`00
00L0oooo00D0o`00003jVP3oool00?ZJ0?l000080?ooo`@0o`00203oool01@3o00000?ZJ0?l0003o
ool0o`000100oooo00@0o`000?ooo`3oool0o`003`3oool0103o0000oooo0?ooo`3o000:0?ooo`03
0?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool01@3oool01@3o0000oooo0?l00000nYX0o`00
00T0oooo00<0o`000?ooo`3oool00P00nYX00`3o0000oooo0?ooo`080?ooo`060?l0003oool00?ZJ
003jVP3oool0o`002@3oool01P3o0000oooo003jVP3o00000?ZJ0?l000/0oooo00D0o`000?ooo`3o
ool0oooo0?l0000:0?ooo`050?l00000nYX00?ZJ0?ooo`3o00002`3oool00`3o0000oooo0?ooo`02
0?ooo`030?l0003oool0oooo00P0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`06
0?ooo`030?l0003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?oo
o`3oool00`3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo0080o`0000<0oooo0?l0
003oool01P3oool01@3o00000?ZJ0?ooo`00nYX0o`0000P0oooo103o00080?ooo`050?l00000nYX0
o`000?ooo`3o0000403oool0103o0000oooo0?ooo`3o000?0?ooo`040?l0003oool0oooo0?l000/0
oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`050?ooo`050?l0003oool0o`00003j
VP3o00002@3oool00`3o0000oooo0?ooo`02003jVP030?l0003oool0oooo00P0oooo00H0o`000?oo
o`00nYX00?ZJ0?ooo`3o00090?ooo`060?l0003oool00?ZJ0?l00000nYX0o`002`3oool0103o0000
oooo0?ooo`3o000;0?ooo`050?l00000nYX00?ZJ0?ooo`3o00002`3oool01@3o0000oooo0?ooo`3o
ool0o`0000/0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`060?ooo`030?l0003o
ool0oooo00@0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool00`3oool0
0`3o0000oooo0?ooo`060?ooo`050?l0003oool0oooo0?l0003oool00P3o00070?ooo`050?l00000
nYX0oooo003jVP3o0000203oool40?l000P0oooo00D0o`00003jVP3o0000oooo0?l0000@0?ooo`03
0?l0003oool0o`000140oooo00<0o`000?ooo`3o00002`3oool00`3o0000oooo0?ooo`020?ooo`03
0?l0003oool0oooo00D0oooo00D0o`000?ooo`3o00000?ZJ0?l000090?ooo`060?l0003oool0oooo
0?ooo`00nYX0o`002P3oool01P3o0000oooo0?ooo`00nYX0oooo0?l000T0oooo00H0o`000?ooo`00
nYX0oooo003jVP3o000;0?ooo`040?l0003oool0oooo0?l000/0oooo00D0o`00003jVP00nYX0oooo
0?l0000;0?ooo`050?l0003oool0oooo0?ooo`3o00002`3oool00`3o0000oooo0?ooo`020?ooo`03
0?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool0103oool00`000000oooo0?ooo`050?ooo`00
5@3oool00`000000oooo0?ooo`030?ooo`030?l0003oool0oooo00H0oooo00D0o`000?ooo`3oool0
o`000?ooo`020?l000L0oooo00D0o`000?ooo`00nYX00?ZJ0?l000080?ooo`@0o`00203oool01@3o
00000?ZJ0?l0003oool0o`000100oooo00<0o`000?ooo`3o00004@3oool00`3o0000oooo0?l0000;
0?ooo`050?l0003oool0oooo0?ooo`3o0000203oool01@3o0000oooo0?l00000nYX0o`0000T0oooo
00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`080?ooo`060?l0003oool0oooo003jVP3o
ool0o`002@3oool01P3o0000oooo003jVP3oool00?ZJ0?l000/0oooo00@0o`000?ooo`3oool0o`00
2`3oool01@3o00000?ZJ0?ooo`3oool0o`0000/0oooo00D0o`000?ooo`3oool0oooo0?l0000;0?oo
o`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`040?oo
o`030000003oool0oooo00D0oooo000E0?ooo`800000103oool00`3o0000oooo0?ooo`060?ooo`05
0?l0003oool0oooo0?l0003oool00P3o00070?ooo`050?l0003oool00?ZJ003jVP3o0000203oool4
0?l000P0oooo00D0o`00003jVP3o00000?ZJ0?l0000A0?ooo`80o`004@3oool00`3o0000oooo0?l0
000<0?ooo`040?l0003oool0oooo0?l000P0oooo00D0o`00003jVP3o00000?ZJ0?l000090?ooo`03
0?l0003oool0oooo0080oooo00<0o`000?ooo`3oool02@3oool01@3o0000oooo003jVP3oool0o`00
00T0oooo00H0o`000?ooo`00nYX0oooo003jVP3o000;0?ooo`040?l0003oool0oooo0?l000/0oooo
00D0o`00003jVP3oool0oooo0?l0000;0?ooo`050?l0003oool0oooo0?ooo`3o00002`3oool00`3o
0000oooo0?ooo`020?ooo`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool00`3oool20000
00L0oooo000E0?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool01P3oool01@3o0000
oooo0?ooo`3o0000oooo0080o`001`3oool01@3o0000oooo003jVP00nYX0o`0000P0oooo103o0008
0?ooo`050?l00000nYX0o`00003jVP3o00004@3oool20?l00140oooo00<0o`000?ooo`3o0000303o
ool0103o0000oooo0?ooo`3o00080?ooo`050?l00000nYX0o`00003jVP3o00002@3oool00`3o0000
oooo0?ooo`020?ooo`030?l0003oool0oooo00T0oooo00@0o`000?ooo`00nYX0o`002P3oool01P3o
0000oooo003jVP3oool00?ZJ0?l000/0oooo00@0o`000?ooo`3oool0o`002`3oool01@3o0000oooo
0?ooo`3oool0o`0000`0oooo00@0o`000?ooo`3oool0o`002`3oool00`3o0000oooo0?ooo`020?oo
o`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool0103oool00`000000oooo0?ooo`050?oo
o`005@3oool00`000000oooo0?ooo`030?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3o
00000P3oool00`3o0000oooo0?ooo`050?ooo`050?l0003oool0oooo003jVP3o0000203oool40?l0
00P0oooo00D0o`00003jVP3oool00?ZJ0?l0000B0?ooo`030?l0003oool0oooo0100oooo00<0o`00
0?ooo`3oool02`3oool00`3o0000oooo0?l000090?ooo`050?l00000nYX0o`00003jVP3o00002@3o
ool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00T0oooo00@0o`000?ooo`00nYX0o`00
2P3oool01P3o0000oooo003jVP3oool00?ZJ0?l000/0oooo00@0o`000?ooo`3oool0o`002`3oool0
103o0000oooo0?ooo`3o000=0?ooo`040?l0003oool0oooo0?l000/0oooo00<0o`000?ooo`3oool0
0P3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo00@0oooo00<000000?ooo`3oool0
1@3oool001D0oooo00<000000?ooo`3oool00`3oool00`3o0000oooo0?ooo`070?ooo`80o`000`3o
ool00`3o0000oooo0?ooo`050?ooo`050?l0003oool0oooo0?ooo`3o0000203oool0103o00000?ZJ
0?l0003o00080?ooo`050?l00000nYX0oooo003jVP3o00009@3oool00`3o0000oooo0?ooo`0<0?oo
o`80o`002@3oool01@3o00000?ZJ0?ooo`00nYX0o`0000T0oooo00D0o`000?ooo`3oool0oooo0?l0
000<0?ooo`040?l0003oool00?ZJ0?l000X0oooo00H0o`000?ooo`00nYX0oooo003jVP3o000;0?oo
o`040?l0003oool0oooo0?l000/0oooo00@0o`000?ooo`3oool0o`003@3oool0103o0000oooo0?oo
o`3o000;0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo
0?ooo`040?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000103oool00`3o0000oooo0?oo
o`070?ooo`80o`002`3oool01@3o0000oooo0?ooo`3oool0o`0000P0oooo00@0o`00003jVP3o0000
o`00203oool01@3o00000?ZJ0?ooo`00nYX0o`0002D0oooo00<0o`000?ooo`3oool0303oool00`3o
0000oooo0?ooo`080?ooo`040?l00000nYX0oooo0?l000X0oooo00D0o`000?ooo`3oool0oooo0?l0
000<0?ooo`040?l0003oool0oooo0?l000/0oooo00D0o`00003jVP3oool00?ZJ0?l0000;0?ooo`04
0?l0003oool0oooo0?l000/0oooo00@0o`000?ooo`3oool0o`003@3oool00`3o0000oooo0?l0000<
0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`03
0?ooo`8000001`3oool001D0oooo00<000000?ooo`3oool00`3oool00`3o0000oooo0?ooo`080?oo
o`030?l0003oool0oooo00T0oooo00D0o`000?ooo`3oool0oooo0?l000080?ooo`040?l00000nYX0
o`000?l000P0oooo00D0o`00003jVP3oool00?ZJ0?l0000o0?ooo`040?l00000nYX0oooo0?l000X0
oooo00D0o`000?ooo`3oool0oooo0?l0000<0?ooo`040?l0003oool0oooo0?l000/0oooo00D0o`00
003jVP3oool00?ZJ0?l0000;0?ooo`030?l0003oool0o`0000`0oooo00@0o`000?ooo`3oool0o`00
3@3oool00`3o0000oooo0?l0000=0?ooo`050?l0003oool0oooo0?ooo`3o00002@3oool00`3o0000
oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo00<0oooo
00<0o`000?ooo`3oool0203oool00`3o0000oooo0?ooo`090?ooo`050?l0003oool0oooo0?ooo`3o
0000203oool0103o00000?ZJ0?l0003o00080?ooo`050?l00000nYX0oooo003jVP3o0000?`3oool0
103o00000?ZJ0?ooo`3o000;0?ooo`040?l0003oool0oooo0?l000`0oooo00@0o`000?ooo`3oool0
o`002`3oool01@3o00000?ZJ0?ooo`00nYX0o`0000/0oooo00<0o`000?ooo`3o0000303oool0103o
0000oooo0?ooo`3o000>0?ooo`80o`003@3oool01@3o0000oooo0?ooo`3oool0o`0000T0oooo00<0
o`000?ooo`3oool00`3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?ooo`03
0?ooo`030?l0003oool0oooo01D0oooo00@0o`000?ooo`3oool0o`00203oool0103o00000?ZJ0?l0
003o00090?ooo`040?l0003oool00?ZJ0?l003l0oooo00@0o`00003jVP3oool0o`002`3oool0103o
0000oooo0?ooo`3o000<0?ooo`040?l0003oool0oooo0?l000/0oooo00D0o`00003jVP3oool00?ZJ
0?l0000;0?ooo`030?l0003oool0o`0000`0oooo00@0o`000?ooo`3oool0o`003P3oool20?l000d0
oooo00D0o`000?ooo`3oool0oooo0?l000090?ooo`030?l0003oool0oooo00<0oooo00<000000?oo
o`3oool01@3oool001D0oooo00<000000?ooo`3oool00`3oool00`3o0000oooo0?ooo`0E0?ooo`04
0?l0003oool0oooo0?l000P0oooo00@0o`00003jVP3o0000o`002@3oool0103o0000oooo003jVP3o
000o0?ooo`040?l00000nYX0oooo0?l000/0oooo00@0o`000?ooo`3oool0o`00303oool0103o0000
oooo0?ooo`3o000;0?ooo`050?l00000nYX0oooo003jVP3o0000303oool20?l000`0oooo00@0o`00
0?ooo`3oool0o`007@3oool0103o0000oooo0?ooo`3o000:0?ooo`030?l0003oool0oooo00<0oooo
00<000000?ooo`3oool01@3oool001D0oooo0P00000L0?ooo`040?l0003oool0oooo0?l000P0oooo
00@0o`00003jVP3o0000o`002@3oool0103o0000oooo003jVP3o000o0?ooo`040?l00000nYX0oooo
0?l000/0oooo00@0o`000?ooo`3oool0o`003@3oool00`3o0000oooo0?l0000;0?ooo`050?l00000
nYX0oooo003jVP3o0000303oool20?l000`0oooo00@0o`000?ooo`3oool0o`007@3oool0103o0000
oooo0?ooo`3o000:0?ooo`030?l0003oool0oooo0080oooo0P0000070?ooo`005@3oool00`000000
oooo0?ooo`0K0?ooo`040?l0003oool0oooo0?l000P0oooo00@0o`00003jVP3o0000o`002@3oool0
103o0000oooo003jVP3o000o0?ooo`040?l00000nYX0oooo0?l000/0oooo00@0o`000?ooo`3oool0
o`003@3oool00`3o0000oooo0?l0000;0?ooo`050?l00000nYX0oooo003jVP3o0000303oool00`3o
0000oooo0?ooo`0;0?ooo`040?l0003oool0oooo0?l001d0oooo00@0o`000?ooo`3oool0o`00403o
ool00`000000oooo0?ooo`050?ooo`001`3oool3000000@0oooo0P0000050?ooo`030000003oool0
oooo01/0oooo00@0o`000?ooo`3oool0o`00203oool0103o00000?ZJ0?l0003o00090?ooo`040?l0
003oool00?ZJ0?l003l0oooo00@0o`00003jVP3oool0o`002`3oool0103o0000oooo0?ooo`3o000=
0?ooo`030?l0003oool0o`0000/0oooo00D0o`000?ooo`00nYX0oooo0?l0000<0?ooo`030?l0003o
ool0oooo00/0oooo00@0o`000?ooo`3oool0o`007P3oool00`3o0000oooo0?l0000@0?ooo`030000
003oool0oooo00D0oooo00060?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo
0?ooo`0000040?ooo`030000003oool0oooo01/0oooo00@0o`000?ooo`3oool0o`00203oool0103o
00000?ZJ0?l0003o00090?ooo`040?l0003oool00?ZJ0?l003l0oooo00@0o`00003jVP3oool0o`00
2`3oool0103o0000oooo0?ooo`3o000=0?ooo`030?l0003oool0o`0000/0oooo00D0o`000?ooo`00
nYX0oooo0?l0000<0?ooo`030?l0003oool0oooo00`0oooo00<0o`000?ooo`3o00007P3oool00`3o
0000oooo0?l0000@0?ooo`030000003oool0oooo00D0oooo000:0?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0K0?ooo`040?l0003oool0oooo
0?l000P0oooo00@0o`00003jVP3o0000o`002@3oool0103o0000oooo003jVP3o000o0?ooo`040?l0
0000nYX0oooo0?l000`0oooo00<0o`000?ooo`3o00003@3oool00`3o0000oooo0?l0000;0?ooo`05
0?l0003oool00?ZJ0?ooo`3o00006`3oool00`3o0000oooo0?l0000N0?ooo`030?l0003oool0o`00
0100oooo00<000000?ooo`3oool01@3oool000X0oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`020?ooo`800000703oool00`3o0000oooo0?l000090?ooo`040?l00000nYX0o`00
0?l000T0oooo00@0o`00003jVP00nYX0o`00?`3oool0103o00000?ZJ0?ooo`3o000<0?ooo`030?l0
003oool0o`0000d0oooo00<0o`000?ooo`3o00002`3oool01@3o0000oooo003jVP3oool0o`0001/0
oooo00<0o`000?ooo`3o00007`3oool20?l000h0oooo0`0000070?ooo`001P3oool4000000<0oooo
00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0K0?ooo`030?l0003oool0o`0000T0
oooo00@0o`00003jVP3o0000o`002@3oool0103o00000?ZJ0?ooo`3o000o0?ooo`040?l00000nYX0
oooo0?l000`0oooo00<0o`000?ooo`3o00003@3oool00`3o0000oooo0?l0000;0?ooo`040?l0003o
ool00?ZJ0?l001`0oooo00<0o`000?ooo`3o00007`3oool20?l00100oooo00<000000?ooo`3oool0
1@3oool000H0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000040?ooo`030000
003oool0oooo01/0oooo00<0o`000?ooo`3o00002@3oool0103o00000?ZJ003jVP3o00090?ooo`04
0?l00000nYX0oooo0?l003l0oooo00@0o`000?ooo`00nYX0o`00303oool00`3o0000oooo0?l0000=
0?ooo`030?l0003oool0o`0000/0oooo00@0o`000?ooo`00nYX0o`00703oool20?l00240oooo00<0
o`000?ooo`3oool03P3oool00`000000oooo0?ooo`050?ooo`001P3oool5000000<0oooo0P000005
0?ooo`030000003oool0oooo01/0oooo00<0o`000?ooo`3o00002@3oool0103o00000?ZJ003jVP3o
00090?ooo`040?l00000nYX0oooo0?l003l0oooo00@0o`000?ooo`00nYX0o`003@3oool20?l000d0
oooo0P3o000=0?ooo`030?l00000nYX0o`0001`0oooo0P3o000b0?ooo`030000003oool0oooo00D0
oooo000E0?ooo`800000703oool00`3o0000oooo0?l000090?ooo`040?l00000nYX00?ZJ0?l000T0
oooo00@0o`00003jVP3oool0o`00?`3oool0103o0000oooo003jVP3o000=0?ooo`80o`003@3oool2
0?l000d0oooo00<0o`00003jVP3o0000703oool20?l00340oooo0P0000070?ooo`005@3oool00`00
0000oooo0?ooo`0K0?ooo`030?l0003oool0o`0000T0oooo00@0o`00003jVP00nYX0o`002@3oool0
103o00000?ZJ0?ooo`3o000o0?ooo`040?l0003oool00?ZJ0?l000h0oooo00<0o`000?ooo`3oool0
303oool00`3o0000oooo0?ooo`0;0?ooo`030?l0003oool0o`0001`0oooo0P3o000b0?ooo`030000
003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo01`0oooo0P3o000:0?ooo`030?l00000
nYX0o`0000T0oooo00@0o`00003jVP3oool0o`00?`3oool0103o0000oooo003jVP3o000M0?ooo`03
0?l0003oool0oooo00/0oooo00<0o`000?ooo`3o0000703oool00`3o0000oooo0?ooo`0a0?ooo`03
0000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo01`0oooo0P3o000:0?ooo`030?l0
0000nYX0o`0000T0oooo00<0o`00003jVP3o0000@@3oool00`3o00000?ZJ0?l0000M0?ooo`030?l0
003oool0oooo00/0oooo00<0o`000?ooo`3o0000703oool00`3o0000oooo0?ooo`0a0?ooo`030000
003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo01`0oooo0P3o000:0?ooo`030?l00000
nYX0o`0000T0oooo00<0o`00003jVP3o0000@@3oool00`3o00000?ZJ0?l0000M0?ooo`030?l0003o
ool0oooo00/0oooo00<0o`000?ooo`3o0000D03oool00`000000oooo0?ooo`050?ooo`005@3oool2
000001h0oooo00<0o`000?ooo`3oool0203oool00`3o00000?ZJ0?l000090?ooo`030?l0003oool0
o`000440oooo00<0o`00003jVP3o00007@3oool00`3o0000oooo0?ooo`0;0?ooo`030?l0003oool0
o`0004l0oooo0P0000070?ooo`005@3oool00`000000oooo0?ooo`0X0?ooo`030?l00000nYX0o`00
00T0oooo00<0o`000?ooo`3o0000@@3oool00`3o0000oooo0?l0000M0?ooo`030?l0003oool0oooo
00/0oooo00<0o`000?ooo`3o0000D03oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000
oooo0?ooo`0X0?ooo`030?l00000nYX0o`0000T0oooo00<0o`000?ooo`3o0000@@3oool00`3o0000
oooo0?l0000[0?ooo`030?l0003oool0o`000500oooo00<000000?ooo`3oool01@3oool001D0oooo
00<000000?ooo`3oool0:03oool00`3o00000?ZJ0?l000090?ooo`030?l0003oool0o`000440oooo
00<0o`000?ooo`3o0000:`3oool00`3o0000oooo0?l0001@0?ooo`030000003oool0oooo00D0oooo
000E0?ooo`030000003oool0oooo02P0oooo00<0o`00003jVP3o00002@3oool00`3o0000oooo0?l0
00110?ooo`030?l0003oool0o`0002/0oooo00<0o`000?ooo`3o0000D03oool00`000000oooo0?oo
o`050?ooo`005@3oool2000002T0oooo00<0o`00003jVP3o00002@3oool00`3o0000oooo0?l00011
0?ooo`030?l0003oool0o`0002/0oooo00<0o`000?ooo`3o0000C`3oool2000000L0oooo000E0?oo
o`030000003oool0oooo02P0oooo00<0o`00003jVP3o00002@3oool00`3o0000oooo0?l000110?oo
o`030?l0003oool0o`0002/0oooo00<0o`000?ooo`3o0000D03oool00`000000oooo0?ooo`050?oo
o`005@3oool00`000000oooo0?ooo`0X0?ooo`030?l00000nYX0o`0000T0oooo00<0o`000?ooo`3o
0000@@3oool00`3o0000oooo0?l0000[0?ooo`030?l0003oool0o`000500oooo00<000000?ooo`3o
ool01@3oool001D0oooo00<000000?ooo`3oool0:03oool00`3o00000?ZJ0?l000090?ooo`030?l0
003oool0o`000440oooo00<0o`000?ooo`3o0000:`3oool00`3o0000oooo0?l0001@0?ooo`030000
003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo02P0oooo0P3o000:0?ooo`030?l0003o
ool0o`000440oooo00<0o`000?ooo`3o0000;03oool00`3o0000oooo0?ooo`1?0?ooo`030000003o
ool0oooo00D0oooo000E0?ooo`800000:@3oool20?l000X0oooo00<0o`000?ooo`3o0000@@3oool0
0`3o0000oooo0?l0000/0?ooo`030?l0003oool0oooo04h0oooo0P0000070?ooo`005@3oool00`00
0000oooo0?ooo`0X0?ooo`80o`002P3oool00`3o0000oooo0?l000110?ooo`030?l0003oool0o`00
02`0oooo00<0o`000?ooo`3oool0C`3oool00`000000oooo0?ooo`050?ooo`00203oool00`000000
oooo0?ooo`020?ooo`<000001@3oool00`000000oooo0?ooo`0X0?ooo`80o`002`3oool20?l00440
oooo00<0o`000?ooo`3o0000;03oool00`3o0000oooo0?ooo`1?0?ooo`030000003oool0oooo00D0
oooo00080?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo02P0oooo0P3o000;0?ooo`030?l0003oool0oooo0400oooo00<0o`000?ooo`3o
0000;03oool00`3o0000oooo0?ooo`1?0?ooo`030000003oool0oooo00D0oooo00090?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool2000002T0oooo0P3o000;0?ooo`030?l0
003oool0oooo0440oooo00<0o`000?ooo`3oool0:`3oool00`3o0000oooo0?ooo`1=0?ooo`<00000
1`3oool000T0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo02P0oooo0P3o000;0?ooo`030?l0003oool0oooo0440oooo00<0o`000?ooo`3oool0:`3o
ool00`3o0000oooo0?ooo`1?0?ooo`030000003oool0oooo00D0oooo000:0?ooo`030000003oool0
000000<000001@3oool00`000000oooo0?ooo`0X0?ooo`80o`002`3oool00`3o0000oooo0?ooo`11
0?ooo`030?l0003oool0oooo02/0oooo00<0o`000?ooo`3oool0C`3oool00`000000oooo0?ooo`05
0?ooo`001P3oool01`000000oooo0?ooo`3oool000000?ooo`000000203oool00`000000oooo0?oo
o`0X0?ooo`80o`002`3oool00`3o0000oooo0?ooo`110?ooo`030?l0003oool0oooo07d0oooo00<0
00000?ooo`3oool01@3oool000H0oooo1@0000000`3oool0000000000003000000@0oooo00<00000
0?ooo`3oool0:03oool20?l000/0oooo00<0o`000?ooo`3oool0@@3oool00`3o0000oooo0?ooo`1m
0?ooo`030000003oool0oooo00D0oooo000E0?ooo`800000:@3oool20?l000/0oooo00<0o`000?oo
o`3oool0@@3oool00`3o0000oooo0?ooo`1l0?ooo`8000001`3oool001D0oooo00<000000?ooo`3o
ool0:03oool20?l000/0oooo00<0o`000?ooo`3oool0@@3oool00`3o0000oooo0?ooo`1m0?ooo`03
0000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo02P0oooo0P3o001?0?ooo`030?l0
003oool0oooo07d0oooo00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0:@3o
ool00`3o0000oooo0?ooo`3=0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0
oooo02T0oooo00<0o`000?ooo`3oool0c@3oool00`000000oooo0?ooo`050?ooo`005@3oool20000
02X0oooo00<0o`000?ooo`3oool0c03oool2000000L0oooo000E0?ooo`030000003oool0oooo02T0
oooo00<0o`000?ooo`3oool0c@3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo
0?ooo`0Y0?ooo`030?l0003oool0oooo0<d0oooo00<000000?ooo`3oool01@3oool001D0oooo00<0
00000?ooo`3oool0:@3oool00`3o0000oooo0?ooo`3=0?ooo`030000003oool0oooo00D0oooo000E
0?ooo`030000003oool0oooo02T0oooo00<0o`000?ooo`3oool0c@3oool00`000000oooo0?ooo`05
0?ooo`005@3oool2000002X0oooo00<0o`000?ooo`3oool0c03oool2000000L0oooo000E0?ooo`03
0000003oool0oooo02T0oooo00<0o`000?ooo`3oool0c@3oool00`000000oooo0?ooo`050?ooo`00
5@3oool00`000000oooo0?ooo`0Y0?ooo`030?l0003oool0oooo0<d0oooo00<000000?ooo`3oool0
1@3oool001D0oooo00<000000?ooo`3oool0:@3oool00`3o0000oooo0?ooo`3=0?ooo`030000003o
ool0oooo00D0oooo000E0?ooo`800000:P3oool00`3o0000oooo0?ooo`3<0?ooo`8000001`3oool0
01D0oooo00<000000?ooo`3oool0:@3oool00`3o0000oooo0?ooo`3=0?ooo`030000003oool0oooo
00D0oooo000E0?ooo`030000003oool0oooo0?T0oooo00<000000?ooo`3oool01@3oool001D0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0200oooo
00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo
00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`050?ooo`005@3oooom000000L0oooo003o0?oooaX0oooo003o0?oooaX0oooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.938, 0}} -> {1729.2, -80.0928, \
0.729416, 1.05597}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["prediction from  1925", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["z1//Dimensions", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({55}\)], "Output"]
}, Open  ]],

Cell["\<\
Z2 = join[Z,Shape[-9,{55,1,1}],1]; (*join Z  with missing data*)
X2 = join[X,Shape[ 1,{55,1,1}],1]; (*dummy controls*)\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YG,PG,YF,PF,LIK} = 
\tMGLATT1[Z2,X2,k,p,q,n,np,Length[Z2]-1,dt,THETA,PHI,NONLIN,-9];\
\>", "Input",\

  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{80.9`}}\)], "Print"],

Cell[BoxData[
    \({{36.28546029368992`}, {0.`}}\)], "Print"],

Cell[BoxData[
    \({{{26.376393963985706`, 0.`}, {0.`, 10000.`}}}\)], "Print"],

Cell[BoxData[
    \({1, 2, 1, 1, 1}\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
meanlevel=PHI[[1]];

p3=plot1[(Join[time,time1]//Spalte)~ii~(ConfidenceBand[YG,YG,PG,1,1,z]+\
meanlevel),
\t\tcolor->{1,1,3,3},dicke->.001,PlotLabel->\"predicted number of \
sunspots\"];
\t\t
   plot1[(Join[time,time1]//Spalte)~ii~ConfidenceBand[YG,YG,PG,2,1,z],
\t\tcolor->{2,2,3,3},dicke->.001,PlotLabel->\"change in number of \
sunspots\"];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{231, 5}\),
      SequenceForm[ "Dimension der Daten  ", {231, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-7.21843 0.00414079 0.152729 0.00288928 [
[.02795 -0.0125 -12 -9 ]
[.02795 -0.0125 12 0 ]
[.23499 -0.0125 -12 -9 ]
[.23499 -0.0125 12 0 ]
[.44203 -0.0125 -12 -9 ]
[.44203 -0.0125 12 0 ]
[.64907 -0.0125 -12 -9 ]
[.64907 -0.0125 12 0 ]
[.85611 -0.0125 -12 -9 ]
[.85611 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00827 -18 -4.5 ]
[-0.0125 .00827 0 4.5 ]
[-0.0125 .15273 -6 -4.5 ]
[-0.0125 .15273 0 4.5 ]
[-0.0125 .29719 -12 -4.5 ]
[-0.0125 .29719 0 4.5 ]
[-0.0125 .44166 -18 -4.5 ]
[-0.0125 .44166 0 4.5 ]
[-0.0125 .58612 -18 -4.5 ]
[-0.0125 .58612 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -86 0 ]
[.5 .63053 86 12 ]
[.97619 .28136 -5 -6 ]
[.97619 .28136 5 6 ]
[.97619 .28136 -5 -6 ]
[.97619 .28136 5 6 ]
[.97619 .53515 -5 -6 ]
[.97619 .53515 5 6 ]
[.97619 .02756 -5 -6 ]
[.97619 .02756 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02795 0 m
.02795 .00625 L
s
[(1750)] .02795 -0.0125 0 1 Mshowa
.23499 0 m
.23499 .00625 L
s
[(1800)] .23499 -0.0125 0 1 Mshowa
.44203 0 m
.44203 .00625 L
s
[(1850)] .44203 -0.0125 0 1 Mshowa
.64907 0 m
.64907 .00625 L
s
[(1900)] .64907 -0.0125 0 1 Mshowa
.85611 0 m
.85611 .00625 L
s
[(1950)] .85611 -0.0125 0 1 Mshowa
.125 Mabswid
.06936 0 m
.06936 .00375 L
s
.11077 0 m
.11077 .00375 L
s
.15217 0 m
.15217 .00375 L
s
.19358 0 m
.19358 .00375 L
s
.2764 0 m
.2764 .00375 L
s
.31781 0 m
.31781 .00375 L
s
.35921 0 m
.35921 .00375 L
s
.40062 0 m
.40062 .00375 L
s
.48344 0 m
.48344 .00375 L
s
.52484 0 m
.52484 .00375 L
s
.56625 0 m
.56625 .00375 L
s
.60766 0 m
.60766 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.73188 0 m
.73188 .00375 L
s
.77329 0 m
.77329 .00375 L
s
.8147 0 m
.8147 .00375 L
s
.89752 0 m
.89752 .00375 L
s
.93892 0 m
.93892 .00375 L
s
.98033 0 m
.98033 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00827 m
.00625 .00827 L
s
[(-50)] -0.0125 .00827 1 0 Mshowa
0 .15273 m
.00625 .15273 L
s
[(0)] -0.0125 .15273 1 0 Mshowa
0 .29719 m
.00625 .29719 L
s
[(50)] -0.0125 .29719 1 0 Mshowa
0 .44166 m
.00625 .44166 L
s
[(100)] -0.0125 .44166 1 0 Mshowa
0 .58612 m
.00625 .58612 L
s
[(150)] -0.0125 .58612 1 0 Mshowa
.125 Mabswid
0 .03716 m
.00375 .03716 L
s
0 .06605 m
.00375 .06605 L
s
0 .09494 m
.00375 .09494 L
s
0 .12384 m
.00375 .12384 L
s
0 .18162 m
.00375 .18162 L
s
0 .21052 m
.00375 .21052 L
s
0 .23941 m
.00375 .23941 L
s
0 .2683 m
.00375 .2683 L
s
0 .32609 m
.00375 .32609 L
s
0 .35498 m
.00375 .35498 L
s
0 .38387 m
.00375 .38387 L
s
0 .41276 m
.00375 .41276 L
s
0 .47055 m
.00375 .47055 L
s
0 .49944 m
.00375 .49944 L
s
0 .52834 m
.00375 .52834 L
s
0 .55723 m
.00375 .55723 L
s
0 .61501 m
.00375 .61501 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02795 .61178 m
.02795 .61803 L
s
.23499 .61178 m
.23499 .61803 L
s
.44203 .61178 m
.44203 .61803 L
s
.64907 .61178 m
.64907 .61803 L
s
.85611 .61178 m
.85611 .61803 L
s
.125 Mabswid
.06936 .61428 m
.06936 .61803 L
s
.11077 .61428 m
.11077 .61803 L
s
.15217 .61428 m
.15217 .61803 L
s
.19358 .61428 m
.19358 .61803 L
s
.2764 .61428 m
.2764 .61803 L
s
.31781 .61428 m
.31781 .61803 L
s
.35921 .61428 m
.35921 .61803 L
s
.40062 .61428 m
.40062 .61803 L
s
.48344 .61428 m
.48344 .61803 L
s
.52484 .61428 m
.52484 .61803 L
s
.56625 .61428 m
.56625 .61803 L
s
.60766 .61428 m
.60766 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.73188 .61428 m
.73188 .61803 L
s
.77329 .61428 m
.77329 .61803 L
s
.8147 .61428 m
.8147 .61803 L
s
.89752 .61428 m
.89752 .61803 L
s
.93892 .61428 m
.93892 .61803 L
s
.98033 .61428 m
.98033 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00827 m
1 .00827 L
s
.99375 .15273 m
1 .15273 L
s
.99375 .29719 m
1 .29719 L
s
.99375 .44166 m
1 .44166 L
s
.99375 .58612 m
1 .58612 L
s
.125 Mabswid
.99625 .03716 m
1 .03716 L
s
.99625 .06605 m
1 .06605 L
s
.99625 .09494 m
1 .09494 L
s
.99625 .12384 m
1 .12384 L
s
.99625 .18162 m
1 .18162 L
s
.99625 .21052 m
1 .21052 L
s
.99625 .23941 m
1 .23941 L
s
.99625 .2683 m
1 .2683 L
s
.99625 .32609 m
1 .32609 L
s
.99625 .35498 m
1 .35498 L
s
.99625 .38387 m
1 .38387 L
s
.99625 .41276 m
1 .41276 L
s
.99625 .47055 m
1 .47055 L
s
.99625 .49944 m
1 .49944 L
s
.99625 .52834 m
1 .52834 L
s
.99625 .55723 m
1 .55723 L
s
.99625 .61501 m
1 .61501 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -147 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(predicted) show
123.000 13.000 moveto
(number) show
165.000 13.000 moveto
(of) show
183.000 13.000 moveto
(sunspots) show
231.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 1 r
gsave
.97619 .28136 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .39103 m
.02795 .37895 L
.03209 .31072 L
.03623 .28052 L
.04037 .24009 L
.04451 .19306 L
.04865 .17589 L
.0528 .18969 L
.05694 .24244 L
.06108 .28689 L
.06522 .31051 L
.06936 .34596 L
.0735 .38183 L
.07764 .33859 L
.08178 .28683 L
.08592 .25189 L
.09006 .20956 L
.0942 .19415 L
.09834 .2575 L
.10248 .36047 L
.10663 .4476 L
.11077 .44594 L
.11491 .39437 L
.11905 .33527 L
.12319 .26651 L
.12733 .22264 L
.13147 .17493 L
.13561 .22661 L
.13975 .42021 L
.14389 .5719 L
.14803 .52412 L
.15217 .41066 L
.15631 .33795 L
.16046 .26785 L
.1646 .21162 L
.16874 .18106 L
.17288 .23382 L
.17702 .38865 L
.18116 .52072 L
.1853 .53769 L
.18944 .48973 L
.19358 .41208 L
.19772 .3491 L
.20186 .31971 L
.206 .29267 L
.21014 .26432 L
.21429 .22181 L
.21843 .19528 L
.22257 .17365 L
.22671 .16476 L
Mistroke
.23085 .17191 L
.23499 .19989 L
.23913 .24874 L
.24327 .27951 L
.24741 .28394 L
.25155 .28842 L
.25569 .2738 L
.25983 .23267 L
.26398 .189 L
.26812 .17282 L
.27226 .16145 L
.2764 .15454 L
.28054 .15778 L
.28468 .16908 L
.28882 .18351 L
.29296 .20276 L
.2971 .25196 L
.30124 .28308 L
.30538 .27263 L
.30952 .24421 L
.31366 .22123 L
.31781 .19777 L
.32195 .17479 L
.32609 .16307 L
.33023 .16074 L
.33437 .17542 L
.33851 .20534 L
.34265 .25441 L
.34679 .298 L
.35093 .33201 L
.35507 .35185 L
.35921 .34977 L
.36335 .29584 L
.36749 .22786 L
.37164 .17571 L
.37578 .19554 L
.37992 .32523 L
.38406 .49192 L
.3882 .54044 L
.39234 .46651 L
.39648 .39624 L
.40062 .33097 L
.40476 .26368 L
.4089 .21681 L
.41304 .18574 L
.41718 .19941 L
.42133 .26029 L
.42547 .33831 L
.42961 .44021 L
.43375 .49498 L
Mistroke
.43789 .43345 L
.44203 .35533 L
.44617 .33163 L
.45031 .30857 L
.45445 .2653 L
.45859 .21242 L
.46273 .17134 L
.46687 .16668 L
.47101 .21868 L
.47516 .31706 L
.4793 .4143 L
.48344 .42861 L
.48758 .37854 L
.49172 .32152 L
.49586 .28752 L
.5 .27953 L
.50414 .24275 L
.50828 .19531 L
.51242 .18131 L
.51656 .25347 L
.5207 .38652 L
.52484 .5188 L
.52899 .49712 L
.53313 .43592 L
.53727 .35073 L
.54141 .2742 L
.54555 .20876 L
.54969 .18632 L
.55383 .18156 L
.55797 .16451 L
.56211 .17762 L
.56625 .24346 L
.57039 .30499 L
.57453 .32887 L
.57867 .33866 L
.58282 .33551 L
.58696 .29836 L
.5911 .23272 L
.59524 .19033 L
.59938 .17216 L
.60352 .1657 L
.60766 .18081 L
.6118 .25852 L
.61594 .35676 L
.62008 .3979 L
.62422 .38096 L
.62836 .33456 L
.63251 .27455 L
.63665 .23468 L
.64079 .22123 L
Mistroke
.64493 .1949 L
.64907 .17653 L
.65321 .16152 L
.65735 .17165 L
.66149 .22053 L
.66563 .27985 L
.66977 .32419 L
.67391 .32176 L
.67805 .32259 L
.68219 .30154 L
.68634 .27059 L
.69048 .21228 L
.69462 .17183 L
.69876 .15877 L
.7029 .15653 L
.70704 .191 L
.71118 .27204 L
.71532 .34401 L
.71946 .4258 L
.7236 .39842 L
.72774 .33258 L
.73188 .26651 L
.73602 .22484 L
.74017 .19153 L
.74431 .17472 L
.74845 .1997 L
.75259 .245 L
.75673 .28777 L
.76087 .31504 L
.76501 .32289 L
.76915 .31491 L
.77329 .29863 L
.77743 .2819 L
.78157 .27026 L
.78571 .26584 L
.78986 .26781 L
.794 .27352 L
.79814 .27996 L
.80228 .28483 L
.80642 .28704 L
.81056 .28673 L
.8147 .28479 L
.81884 .28235 L
.82298 .28036 L
.82712 .27931 L
.83126 .27925 L
.8354 .27989 L
.83954 .2808 L
.84369 .2816 L
.84783 .28207 L
Mistroke
.85197 .28217 L
.85611 .28197 L
.86025 .28164 L
.86439 .28132 L
.86853 .28111 L
.87267 .28105 L
.87681 .28111 L
.88095 .28122 L
.88509 .28135 L
.88923 .28144 L
.89337 .28147 L
.89752 .28146 L
.90166 .28142 L
.9058 .28137 L
.90994 .28133 L
.91408 .28131 L
.91822 .28132 L
.92236 .28133 L
.9265 .28135 L
.93064 .28136 L
.93478 .28137 L
.93892 .28137 L
.94306 .28137 L
.9472 .28136 L
.95135 .28135 L
.95549 .28135 L
.95963 .28135 L
.96377 .28135 L
.96791 .28135 L
.97205 .28136 L
.97619 .28136 L
Mfstroke
gsave
.97619 .28136 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .39103 m
.02795 .37895 L
.03209 .31072 L
.03623 .28052 L
.04037 .24009 L
.04451 .19306 L
.04865 .17589 L
.0528 .18969 L
.05694 .24244 L
.06108 .28689 L
.06522 .31051 L
.06936 .34596 L
.0735 .38183 L
.07764 .33859 L
.08178 .28683 L
.08592 .25189 L
.09006 .20956 L
.0942 .19415 L
.09834 .2575 L
.10248 .36047 L
.10663 .4476 L
.11077 .44594 L
.11491 .39437 L
.11905 .33527 L
.12319 .26651 L
.12733 .22264 L
.13147 .17493 L
.13561 .22661 L
.13975 .42021 L
.14389 .5719 L
.14803 .52412 L
.15217 .41066 L
.15631 .33795 L
.16046 .26785 L
.1646 .21162 L
.16874 .18106 L
.17288 .23382 L
.17702 .38865 L
.18116 .52072 L
.1853 .53769 L
.18944 .48973 L
.19358 .41208 L
.19772 .3491 L
.20186 .31971 L
.206 .29267 L
.21014 .26432 L
.21429 .22181 L
.21843 .19528 L
.22257 .17365 L
.22671 .16476 L
Mistroke
.23085 .17191 L
.23499 .19989 L
.23913 .24874 L
.24327 .27951 L
.24741 .28394 L
.25155 .28842 L
.25569 .2738 L
.25983 .23267 L
.26398 .189 L
.26812 .17282 L
.27226 .16145 L
.2764 .15454 L
.28054 .15778 L
.28468 .16908 L
.28882 .18351 L
.29296 .20276 L
.2971 .25196 L
.30124 .28308 L
.30538 .27263 L
.30952 .24421 L
.31366 .22123 L
.31781 .19777 L
.32195 .17479 L
.32609 .16307 L
.33023 .16074 L
.33437 .17542 L
.33851 .20534 L
.34265 .25441 L
.34679 .298 L
.35093 .33201 L
.35507 .35185 L
.35921 .34977 L
.36335 .29584 L
.36749 .22786 L
.37164 .17571 L
.37578 .19554 L
.37992 .32523 L
.38406 .49192 L
.3882 .54044 L
.39234 .46651 L
.39648 .39624 L
.40062 .33097 L
.40476 .26368 L
.4089 .21681 L
.41304 .18574 L
.41718 .19941 L
.42133 .26029 L
.42547 .33831 L
.42961 .44021 L
.43375 .49498 L
Mistroke
.43789 .43345 L
.44203 .35533 L
.44617 .33163 L
.45031 .30857 L
.45445 .2653 L
.45859 .21242 L
.46273 .17134 L
.46687 .16668 L
.47101 .21868 L
.47516 .31706 L
.4793 .4143 L
.48344 .42861 L
.48758 .37854 L
.49172 .32152 L
.49586 .28752 L
.5 .27953 L
.50414 .24275 L
.50828 .19531 L
.51242 .18131 L
.51656 .25347 L
.5207 .38652 L
.52484 .5188 L
.52899 .49712 L
.53313 .43592 L
.53727 .35073 L
.54141 .2742 L
.54555 .20876 L
.54969 .18632 L
.55383 .18156 L
.55797 .16451 L
.56211 .17762 L
.56625 .24346 L
.57039 .30499 L
.57453 .32887 L
.57867 .33866 L
.58282 .33551 L
.58696 .29836 L
.5911 .23272 L
.59524 .19033 L
.59938 .17216 L
.60352 .1657 L
.60766 .18081 L
.6118 .25852 L
.61594 .35676 L
.62008 .3979 L
.62422 .38096 L
.62836 .33456 L
.63251 .27455 L
.63665 .23468 L
.64079 .22123 L
Mistroke
.64493 .1949 L
.64907 .17653 L
.65321 .16152 L
.65735 .17165 L
.66149 .22053 L
.66563 .27985 L
.66977 .32419 L
.67391 .32176 L
.67805 .32259 L
.68219 .30154 L
.68634 .27059 L
.69048 .21228 L
.69462 .17183 L
.69876 .15877 L
.7029 .15653 L
.70704 .191 L
.71118 .27204 L
.71532 .34401 L
.71946 .4258 L
.7236 .39842 L
.72774 .33258 L
.73188 .26651 L
.73602 .22484 L
.74017 .19153 L
.74431 .17472 L
.74845 .1997 L
.75259 .245 L
.75673 .28777 L
.76087 .31504 L
.76501 .32289 L
.76915 .31491 L
.77329 .29863 L
.77743 .2819 L
.78157 .27026 L
.78571 .26584 L
.78986 .26781 L
.794 .27352 L
.79814 .27996 L
.80228 .28483 L
.80642 .28704 L
.81056 .28673 L
.8147 .28479 L
.81884 .28235 L
.82298 .28036 L
.82712 .27931 L
.83126 .27925 L
.8354 .27989 L
.83954 .2808 L
.84369 .2816 L
.84783 .28207 L
Mistroke
.85197 .28217 L
.85611 .28197 L
.86025 .28164 L
.86439 .28132 L
.86853 .28111 L
.87267 .28105 L
.87681 .28111 L
.88095 .28122 L
.88509 .28135 L
.88923 .28144 L
.89337 .28147 L
.89752 .28146 L
.90166 .28142 L
.9058 .28137 L
.90994 .28133 L
.91408 .28131 L
.91822 .28132 L
.92236 .28133 L
.9265 .28135 L
.93064 .28136 L
.93478 .28137 L
.93892 .28137 L
.94306 .28137 L
.9472 .28136 L
.95135 .28135 L
.95549 .28135 L
.95963 .28135 L
.96377 .28135 L
.96791 .28135 L
.97205 .28136 L
.97619 .28136 L
Mfstroke
1 0 0 r
gsave
.97619 .53515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42818 m
.02795 .41215 L
.03209 .34222 L
.03623 .31194 L
.04037 .2715 L
.04451 .22447 L
.04865 .20731 L
.0528 .22111 L
.05694 .27386 L
.06108 .3183 L
.06522 .34193 L
.06936 .37738 L
.0735 .41325 L
.07764 .37001 L
.08178 .31824 L
.08592 .2833 L
.09006 .24098 L
.0942 .22557 L
.09834 .28891 L
.10248 .39189 L
.10663 .47902 L
.11077 .47736 L
.11491 .42578 L
.11905 .36669 L
.12319 .29792 L
.12733 .25406 L
.13147 .20635 L
.13561 .25803 L
.13975 .45162 L
.14389 .60332 L
.14803 .55554 L
.15217 .44208 L
.15631 .36936 L
.16046 .29926 L
.1646 .24304 L
.16874 .21248 L
.17288 .26523 L
.17702 .42006 L
.18116 .55213 L
.1853 .5691 L
.18944 .52114 L
.19358 .4435 L
.19772 .38052 L
.20186 .35112 L
.206 .32408 L
.21014 .29574 L
.21429 .25323 L
.21843 .2267 L
.22257 .20506 L
.22671 .19618 L
Mistroke
.23085 .20333 L
.23499 .2313 L
.23913 .28016 L
.24327 .31092 L
.24741 .31536 L
.25155 .31983 L
.25569 .30522 L
.25983 .26408 L
.26398 .22041 L
.26812 .20424 L
.27226 .19287 L
.2764 .18596 L
.28054 .1892 L
.28468 .20049 L
.28882 .21493 L
.29296 .23418 L
.2971 .28338 L
.30124 .3145 L
.30538 .30405 L
.30952 .27562 L
.31366 .25265 L
.31781 .22918 L
.32195 .20621 L
.32609 .19448 L
.33023 .19215 L
.33437 .20683 L
.33851 .23676 L
.34265 .28583 L
.34679 .32941 L
.35093 .36343 L
.35507 .38326 L
.35921 .38119 L
.36335 .32726 L
.36749 .25928 L
.37164 .20712 L
.37578 .22695 L
.37992 .35665 L
.38406 .52334 L
.3882 .57186 L
.39234 .49793 L
.39648 .42766 L
.40062 .36238 L
.40476 .2951 L
.4089 .24822 L
.41304 .21715 L
.41718 .23082 L
.42133 .2917 L
.42547 .36972 L
.42961 .47163 L
.43375 .52639 L
Mistroke
.43789 .46487 L
.44203 .38674 L
.44617 .36305 L
.45031 .33999 L
.45445 .29672 L
.45859 .24384 L
.46273 .20276 L
.46687 .19809 L
.47101 .2501 L
.47516 .34848 L
.4793 .44571 L
.48344 .46003 L
.48758 .40995 L
.49172 .35294 L
.49586 .31894 L
.5 .31095 L
.50414 .27416 L
.50828 .22673 L
.51242 .21273 L
.51656 .28489 L
.5207 .41793 L
.52484 .55022 L
.52899 .52854 L
.53313 .46734 L
.53727 .38215 L
.54141 .30562 L
.54555 .24017 L
.54969 .21773 L
.55383 .21297 L
.55797 .19593 L
.56211 .20904 L
.56625 .27488 L
.57039 .3364 L
.57453 .36029 L
.57867 .37008 L
.58282 .36693 L
.58696 .32977 L
.5911 .26414 L
.59524 .22175 L
.59938 .20358 L
.60352 .19711 L
.60766 .21223 L
.6118 .28994 L
.61594 .38817 L
.62008 .42932 L
.62422 .41237 L
.62836 .36598 L
.63251 .30597 L
.63665 .2661 L
.64079 .25265 L
Mistroke
.64493 .22631 L
.64907 .20794 L
.65321 .19294 L
.65735 .20307 L
.66149 .25194 L
.66563 .31126 L
.66977 .35561 L
.67391 .35318 L
.67805 .354 L
.68219 .33295 L
.68634 .30201 L
.69048 .2437 L
.69462 .20325 L
.69876 .19019 L
.7029 .18794 L
.70704 .22242 L
.71118 .30346 L
.71532 .37543 L
.71946 .45722 L
.7236 .42983 L
.72774 .36399 L
.73188 .29792 L
.73602 .25626 L
.74017 .22301 L
.74431 .20683 L
.74845 .23575 L
.75259 .35248 L
.75673 .4688 L
.76087 .53745 L
.76501 .55805 L
.76915 .55057 L
.77329 .53635 L
.77743 .5255 L
.78157 .51917 L
.78571 .51697 L
.78986 .51915 L
.794 .52502 L
.79814 .53217 L
.80228 .53782 L
.80642 .54044 L
.81056 .54019 L
.8147 .53825 L
.81884 .5359 L
.82298 .53402 L
.82712 .53305 L
.83126 .533 L
.8354 .53364 L
.83954 .53456 L
.84369 .53538 L
.84783 .53586 L
Mistroke
.85197 .53595 L
.85611 .53576 L
.86025 .53543 L
.86439 .53511 L
.86853 .53491 L
.87267 .53485 L
.87681 .5349 L
.88095 .53502 L
.88509 .53514 L
.88923 .53523 L
.89337 .53527 L
.89752 .53525 L
.90166 .53521 L
.9058 .53516 L
.90994 .53513 L
.91408 .53511 L
.91822 .53511 L
.92236 .53513 L
.9265 .53514 L
.93064 .53516 L
.93478 .53517 L
.93892 .53517 L
.94306 .53516 L
.9472 .53516 L
.95135 .53515 L
.95549 .53515 L
.95963 .53515 L
.96377 .53515 L
.96791 .53515 L
.97205 .53515 L
.97619 .53515 L
Mfstroke
gsave
.97619 .02756 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35388 m
.02795 .34576 L
.03209 .27922 L
.03623 .2491 L
.04037 .20867 L
.04451 .16164 L
.04865 .14448 L
.0528 .15827 L
.05694 .21102 L
.06108 .25547 L
.06522 .2791 L
.06936 .31454 L
.0735 .35042 L
.07764 .30717 L
.08178 .25541 L
.08592 .22047 L
.09006 .17815 L
.0942 .16274 L
.09834 .22608 L
.10248 .32906 L
.10663 .41619 L
.11077 .41453 L
.11491 .36295 L
.11905 .30385 L
.12319 .23509 L
.12733 .19123 L
.13147 .14351 L
.13561 .1952 L
.13975 .38879 L
.14389 .54049 L
.14803 .4927 L
.15217 .37925 L
.15631 .30653 L
.16046 .23643 L
.1646 .18021 L
.16874 .14964 L
.17288 .2024 L
.17702 .35723 L
.18116 .4893 L
.1853 .50627 L
.18944 .45831 L
.19358 .38067 L
.19772 .31768 L
.20186 .28829 L
.206 .26125 L
.21014 .23291 L
.21429 .1904 L
.21843 .16387 L
.22257 .14223 L
.22671 .13335 L
Mistroke
.23085 .1405 L
.23499 .16847 L
.23913 .21732 L
.24327 .24809 L
.24741 .25253 L
.25155 .257 L
.25569 .24238 L
.25983 .20125 L
.26398 .15758 L
.26812 .14141 L
.27226 .13004 L
.2764 .12313 L
.28054 .12637 L
.28468 .13766 L
.28882 .1521 L
.29296 .17135 L
.2971 .22054 L
.30124 .25166 L
.30538 .24122 L
.30952 .21279 L
.31366 .18981 L
.31781 .16635 L
.32195 .14337 L
.32609 .13165 L
.33023 .12932 L
.33437 .144 L
.33851 .17392 L
.34265 .223 L
.34679 .26658 L
.35093 .30059 L
.35507 .32043 L
.35921 .31835 L
.36335 .26442 L
.36749 .19645 L
.37164 .14429 L
.37578 .16412 L
.37992 .29382 L
.38406 .4605 L
.3882 .50902 L
.39234 .43509 L
.39648 .36483 L
.40062 .29955 L
.40476 .23227 L
.4089 .18539 L
.41304 .15432 L
.41718 .16799 L
.42133 .22887 L
.42547 .30689 L
.42961 .40879 L
.43375 .46356 L
Mistroke
.43789 .40204 L
.44203 .32391 L
.44617 .30022 L
.45031 .27715 L
.45445 .23388 L
.45859 .181 L
.46273 .13992 L
.46687 .13526 L
.47101 .18726 L
.47516 .28564 L
.4793 .38288 L
.48344 .39719 L
.48758 .34712 L
.49172 .2901 L
.49586 .25611 L
.5 .24811 L
.50414 .21133 L
.50828 .1639 L
.51242 .1499 L
.51656 .22205 L
.5207 .3551 L
.52484 .48738 L
.52899 .4657 L
.53313 .40451 L
.53727 .31931 L
.54141 .24279 L
.54555 .17734 L
.54969 .1549 L
.55383 .15014 L
.55797 .13309 L
.56211 .1462 L
.56625 .21205 L
.57039 .27357 L
.57453 .29745 L
.57867 .30724 L
.58282 .3041 L
.58696 .26694 L
.5911 .20131 L
.59524 .15891 L
.59938 .14075 L
.60352 .13428 L
.60766 .1494 L
.6118 .2271 L
.61594 .32534 L
.62008 .36649 L
.62422 .34954 L
.62836 .30314 L
.63251 .24313 L
.63665 .20327 L
.64079 .18982 L
Mistroke
.64493 .16348 L
.64907 .14511 L
.65321 .13011 L
.65735 .14024 L
.66149 .18911 L
.66563 .24843 L
.66977 .29277 L
.67391 .29034 L
.67805 .29117 L
.68219 .27012 L
.68634 .23917 L
.69048 .18087 L
.69462 .14042 L
.69876 .12736 L
.7029 .12511 L
.70704 .15959 L
.71118 .24063 L
.71532 .3126 L
.71946 .39439 L
.7236 .367 L
.72774 .30116 L
.73188 .23509 L
.73602 .19342 L
.74017 .16006 L
.74431 .14261 L
.74845 .16364 L
.75259 .13752 L
.75673 .10675 L
.76087 .09262 L
.76501 .08774 L
.76915 .07924 L
.77329 .0609 L
.77743 .0383 L
.78157 .02134 L
.78571 .01472 L
.78986 .01647 L
.794 .02203 L
.79814 .02775 L
.80228 .03183 L
.80642 .03365 L
.81056 .03328 L
.8147 .03133 L
.81884 .0288 L
.82298 .02669 L
.82712 .02558 L
.83126 .02551 L
.8354 .02614 L
.83954 .02704 L
.84369 .02783 L
.84783 .02829 L
Mistroke
.85197 .02838 L
.85611 .02818 L
.86025 .02785 L
.86439 .02753 L
.86853 .02732 L
.87267 .02725 L
.87681 .02731 L
.88095 .02743 L
.88509 .02755 L
.88923 .02764 L
.89337 .02767 L
.89752 .02766 L
.90166 .02762 L
.9058 .02757 L
.90994 .02754 L
.91408 .02752 L
.91822 .02752 L
.92236 .02753 L
.9265 .02755 L
.93064 .02757 L
.93478 .02757 L
.93892 .02758 L
.94306 .02757 L
.9472 .02756 L
.95135 .02756 L
.95549 .02755 L
.95963 .02755 L
.96377 .02756 L
.96791 .02756 L
.97205 .02756 L
.97619 .02756 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00703oool3000000@0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P00000L0?oo
o`<000000`3oool3000000@0oooo0P0000040?ooo`8000006`3oool3000000<0oooo0`0000030?oo
o`<00000103oool2000001`0oooo0`0000030?ooo`8000001@3oool2000000@0oooo0P00000L0?oo
o`<000000`3oool2000000@0oooo0`0000040?ooo`8000009@3oool001d0oooo00<000000?ooo`3o
ool00`3oool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3oool0
0`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06@3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo00@0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0280oooo000M0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01X0oooo00D000000?oo
o`3oool0oooo000000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`0I0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000
oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06P3oool00`00
0000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00`3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0280oooo000M0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo01X0oooo00<000000?ooo`3oool00P3oool3000000<0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000K0?ooo`030000003oool0oooo0080oooo0`0000060?oo
o`040000003oool0oooo00000080oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`02
0?ooo`@000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001`0oooo
00<000000?ooo`3oool00P3oool4000000D0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0R0?ooo`007@3oool00`000000oooo0?ooo`050?ooo`030000003oool0000000<00000
0`3oool010000000oooo0?ooo`00000L0?ooo`050000003oool0oooo0?ooo`0000000`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06@3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`0000030?ooo`040000
003oool0oooo000001`0oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo00000003000000<0oooo00@000000?ooo`3oool0
0000903oool001`0oooo0P0000030?ooo`070000003oool0oooo0?ooo`000000oooo000000060?oo
o`040000003oool0oooo000001/0oooo0P0000030?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001X0oooo0P0000030?ooo`07
0000003oool0oooo0?ooo`000000oooo000000060?ooo`040000003oool0oooo000001/0oooo0P00
00030?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000001/0oooo0P0000030?ooo`070000003oool0oooo0?ooo`000000oooo0000
00060?ooo`040000003oool0oooo000002@0oooo000M0?ooo`040000003oool0oooo0?ooo`D00000
00<0oooo0000000000000`0000030?ooo`8000007@3oool00`000000oooo0?ooo`020?ooo`<00000
103oool2000000@0oooo0P00000L0?ooo`030000003oool0oooo0080oooo0`0000020?ooo`D00000
0`3oool2000001d0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P0000040?ooo`800000
7@3oool00`000000oooo0?ooo`020?ooo`<000000P3oool5000000<0oooo0P00000U0?ooo`00o`3o
oolJ0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`004P3oool3000000@0oooo0P00003n0?ooo`00
4@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000103oooo]0000
00`0oooo000;0?ooo`D000001@3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo
02d0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo
01l0oooo00<000000?ooo`3oool02P3oool001D0oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`020?ooo`<00000j03oool2000000`0oooo000A0?ooo`@000000`3oool010000000
oooo0?ooo`0000040?ooo`030000003oool0oooo0;L0oooo0P3o000`0?ooo`030000003oool0oooo
00X0oooo000A0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool00000103oool00`00
0000oooo0?ooo`2g0?ooo`80o`00<03oool00`000000oooo0?ooo`0:0?ooo`004@3oool5000000<0
oooo0P0000050?ooo`030000003oool0oooo0;H0oooo00@0o`000?ooo`3oool0o`00;`3oool00`00
0000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`2f0?ooo`050?l0003oool0oooo0?oo
o`3o00000`3ooolW0?l000@0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3o
ool0]P3oool00`3o0000oooo0?ooo`020?ooo`<0o`00:`3oool00`000000oooo0?ooo`0:0?ooo`00
803oool200000;H0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?ooo`0Y0?ooo`800000
303oool00200oooo00<000000?ooo`3oool0]@3oool00`3o0000oooo0?ooo`0a0?ooo`030000003o
ool0oooo00X0oooo000P0?ooo`030000003oool0oooo0;D0oooo00<0o`000?ooo`3oool0<@3oool0
0`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`2e0?ooo`030?l0003oool0oooo
0340oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0]03oool00`3o0000
oooo0?ooo`0b0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo0;@0oooo
00<0o`000?ooo`3oool0<P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?oo
o`2d0?ooo`030?l0003oool0oooo0380oooo00<000000?ooo`3oool02P3oool00200oooo0P00002e
0?ooo`030?l0003oool0oooo0340oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`2d0?oo
o`030?l0003oool0oooo0380oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3o
ool0/`3oool00`3o0000oooo0?ooo`0c0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000
003oool0oooo0;<0oooo00<0o`000?ooo`3oool0<`3oool00`000000oooo0?ooo`0:0?ooo`00803o
ool00`000000oooo0?ooo`2c0?ooo`030?l0003oool0oooo03<0oooo00<000000?ooo`3oool02P3o
ool00200oooo00<000000?ooo`3oool0/P3oool00`3o0000oooo0?ooo`0d0?ooo`030000003oool0
oooo00X0oooo000P0?ooo`030000003oool0oooo0;40oooo00<0o`000?ooo`3oool0=@3oool00`00
0000oooo0?ooo`0:0?ooo`00803oool200000;80oooo00<0o`000?ooo`3oool0=03oool2000000`0
oooo000P0?ooo`030000003oool0oooo0;40oooo00<0o`000?ooo`3oool0=@3oool00`000000oooo
0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`2`0?ooo`030?l0003oool0oooo03H0oooo00<0
00000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0/03oool00`3o0000oooo0?ooo`0f
0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo0;00oooo00<0o`000?oo
o`3oool0=P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`2`0?ooo`03
0?l0003oool0oooo03H0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0
/03oool00`3o0000oooo0?ooo`0f0?ooo`030000003oool0oooo00X0oooo000P0?ooo`800000?`3o
ool20?l006<0oooo00<0o`000?ooo`3oool02@3oool00`3o0000oooo0?ooo`0f0?ooo`800000303o
ool00200oooo00<000000?ooo`3oool0?@3oool00`3o0000oooo0?l0000;0?ooo`030?l0003oool0
oooo04T0oooo00<0o`000?ooo`3oool0203oool20?l000/0oooo00<0o`000?ooo`3oool0=`3oool0
0`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0c0?ooo`030?l0003oool0oooo
00L0oooo00@0o`000?ooo`3oool0o`002@3oool20?l003D0oooo00<0o`000?ooo`3oool0203oool0
0`3o0000oooo0?ooo`080?ooo`030?l0003oool0oooo00P0oooo0P3o000;0?ooo`030?l0003oool0
oooo03L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0<`3oool00`3o
0000oooo0?ooo`060?ooo`050?l0003oool0oooo0?ooo`3o00002@3oool20?l001l0oooo00<0o`00
0?ooo`3oool04`3oool00`3o0000oooo0?ooo`080?ooo`030?l0003oool0oooo00P0oooo0P3o0008
0?ooo`030?l0003oool0o`0000/0oooo00<0o`000?ooo`3oool0=`3oool00`000000oooo0?ooo`0:
0?ooo`006@3oool2000000D0oooo00<000000?ooo`3oool0703oool00`3o0000oooo0?ooo`0C0?oo
o`030?l0003oool0o`0000L0oooo00D0o`000?ooo`3oool0oooo0?l000080?ooo`040?l0003oool0
oooo0?l001d0oooo0P3o000E0?ooo`80o`00203oool20?l000T0oooo00<0o`000?ooo`3o0000203o
ool00`3o0000oooo0?l000090?ooo`030?l0003oool0o`0003T0oooo00<000000?ooo`3oool02P3o
ool001P0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`090?ooo`030?l0003o
ool0oooo0100oooo00<0o`000?ooo`3oool04`3oool00`3o0000oooo0?l000070?ooo`030?l0003o
ool0oooo0080oooo00<0o`000?ooo`3oool01@3oool0103o0000oooo0?ooo`3o00080?ooo`030?l0
003oool0oooo0180oooo0P3o000D0?ooo`030?l0003oool0o`0000P0oooo00<0o`000?ooo`3o0000
203oool00`3o0000oooo0?l000080?ooo`040?l0003oool0oooo0?l000P0oooo00<0o`000?ooo`3o
0000>@3oool00`000000oooo0?ooo`0:0?ooo`00603oool010000000oooo0?ooo`0000040?ooo`03
0000003oool0oooo00T0oooo00<0o`000?ooo`3oool0403oool00`3o0000oooo0?ooo`060?ooo`03
0?l0003oool0oooo00X0oooo00<0o`000?ooo`3o00001`3oool00`3o0000oooo0?ooo`020?ooo`03
0?l0003oool0oooo00D0oooo00@0o`000?ooo`3oool0o`00203oool00`3o0000oooo0?ooo`0B0?oo
o`80o`002P3oool00`3o0000oooo0?ooo`070?ooo`030?l0003oool0o`0000P0oooo00<0o`000?oo
o`3o0000203oool00`3o0000oooo0?l000080?ooo`040?l0003oool0oooo0?l000P0oooo00<0o`00
0?ooo`3o0000>@3oool00`000000oooo0?ooo`0:0?ooo`00603oool010000000oooo0?ooo`000004
0?ooo`<000002@3oool20?l00140oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?ooo`09
0?ooo`040?l0003oool0oooo0?l000H0oooo00@0o`000?ooo`3oool0003o0P3oool00`3o0000oooo
0?ooo`050?ooo`040?l0003oool0oooo0?l000P0oooo00<0o`000?ooo`3oool01`3oool00`3o0000
oooo0?ooo`080?ooo`80o`002P3oool00`3o0000oooo0?ooo`060?ooo`040?l0003oool0oooo0?l0
00L0oooo00@0o`000?ooo`3oool0o`00203oool00`3o0000oooo0?l000080?ooo`040?l0003oool0
oooo0?l000L0oooo00<0o`000?ooo`3o0000>@3oool2000000`0oooo000H0?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool0203oool00`3o0000oooo0?l0000A0?ooo`030?l0003o
ool0oooo00H0oooo00<0o`000?ooo`3oool02@3oool01@3o0000oooo0?ooo`3oool0o`0000D0oooo
00<0o`000?ooo`3oool00P000?l00`3oool0o`000?ooo`050?ooo`050?l0003oool0oooo0?ooo`3o
0000203oool20?l000P0oooo00<0o`000?ooo`3oool0203oool20?l000T0oooo0P3o00080?ooo`04
0?l0003oool0oooo0?l000L0oooo00@0o`000?ooo`3oool0o`001`3oool0103o0000oooo0?ooo`3o
00080?ooo`040?l000000?l0003o0?l000L0oooo00<0o`000?ooo`3o0000>P3oool00`000000oooo
0?ooo`0:0?ooo`00603oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00P0oooo
00<0o`000?ooo`3o0000203oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo00H0oooo
00<0o`000?ooo`3oool02@3oool01@3o0000oooo0000o`3oool0o`0000D0oooo00D0o`000?ooo`00
0?l0oooo0000o`020?ooo`030?l0003oool0oooo00<0oooo00H0o`000?ooo`000?l0003o0?ooo`3o
00070?ooo`80o`00203oool20?l000P0oooo00<0o`000?ooo`3o00002@3oool20?l000P0oooo00@0
o`000?ooo`000?l0o`001`3oool0103o0000oooo0?ooo`3o00070?ooo`040?l0003oool0003o0?l0
00L0oooo00D0o`000?ooo`000?l0003o0?l000070?ooo`030?l0003oool0o`0003X0oooo00<00000
0?ooo`3oool02P3oool001T0oooo0P0000050?ooo`030000003oool0oooo00P0oooo00<0o`000?oo
o`3o0000203oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo00D0oooo0P3o000;0?oo
o`050?l0003oool0003o0?ooo`3o00001@3oool00`3o0000oooo0000o`020?ooo`030000o`3oool0
o`0000D0oooo00H0o`000?ooo`000?l0003o0?ooo`3o00070?ooo`80o`00203oool20?l000P0oooo
00@0o`000?ooo`000?l0o`00203oool20?l000L0oooo00D0o`000?ooo`3oool0003o0?l000070?oo
o`040?l0003oool0003o0?l000L0oooo00D0o`000?ooo`000?l0oooo0?l000060?ooo`050?l00000
0?l0oooo0000o`3o00001`3oool00`3o0000oooo0?ooo`0j0?ooo`030000003oool0oooo00X0oooo
000P0?ooo`030000003oool0oooo00P0oooo00<0o`000?ooo`3o0000203oool00`3o0000oooo0?oo
o`050?ooo`030?l0003oool0o`0000H0oooo0P3o000;0?ooo`050?l000000?l0oooo0000o`3o0000
1@3oool00`3o0000003o0?ooo`020?ooo`030000o`3oool0o`0000D0oooo00H0o`000000o`3oool0
oooo0000o`3o00070?ooo`80o`001`3oool00`3o0000oooo0?l000080?ooo`040?l000000?l0003o
0?l000P0oooo0P3o00070?ooo`050?l0003oool0oooo0000o`3o00001`3oool0103o0000003o0000
o`3o00070?ooo`050?l000000?l0oooo0000o`3o00001P3oool01@3o0000003o0?ooo`000?l0o`00
00L0oooo00<0o`000?ooo`3oool0>P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000
oooo0?ooo`080?ooo`030?l000000?l0o`0000L0oooo0P3o00070?ooo`030?l000000?l0o`0000H0
oooo0P3o000;0?ooo`050?l000000?l0oooo0000o`3o00001@3oool00`3o0000003o0?ooo`020?oo
o`030000o`3oool0o`0000D0oooo00H0o`000000o`3oool0oooo0000o`3o00060?ooo`030?l00000
0?l0o`0000L0oooo00<0o`000?ooo`3o0000203oool0103o0000003o0000o`3o00080?ooo`80o`00
1`3oool01@3o0000oooo0000o`3oool0o`0000L0oooo00@0o`000000o`3oool0o`001`3oool01@3o
0000003o0?ooo`000?l0o`0000H0oooo00D0o`000000o`3oool0003o0?l000070?ooo`030?l00000
0?l0oooo03X0oooo00<000000?ooo`3oool02P3oool00200oooo0P0000090?ooo`030?l000000?l0
o`0000L0oooo0P3o00070?ooo`030?l000000?l0o`0000H0oooo00<0o`000000o`3o00002@3oool0
1P3o0000oooo0000o`3oool0003o0?l000D0oooo00<0o`000000o`3oool00`3oool00`000?l0o`00
0?ooo`030?ooo`030?l0003oool0003o0080oooo00<0003o0?l0003oool01@3oool00`3o0000003o
0?l000070?ooo`030?l0003oool0o`0000P0oooo00@0o`000000o`000?l0o`00203oool20?l000L0
oooo00D0o`000?ooo`000?l0oooo0?l000070?ooo`040?l000000?l0oooo0?l000H0oooo00H0o`00
0?ooo`000?l0oooo0000o`3o00060?ooo`050?l000000?l0oooo0?ooo`3o00001P3oool00`3o0000
oooo0000o`0j0?ooo`800000303oool00200oooo00<000000?ooo`3oool0203oool00`3o0000003o
0?l000070?ooo`80o`001`3oool00`3o0000003o0?l000060?ooo`030?l000000?l0o`0000T0oooo
00H0o`000?ooo`000?l0oooo0000o`3o00040?ooo`050?l000000?l0oooo0?ooo`3o00000P3oool0
0`000?l0o`000?ooo`030?ooo`030?l0003oool0003o0080oooo00<0003o0?l0003oool01@3oool0
0`3o0000003o0?l000070?ooo`030?l000000?l0o`0000P0oooo00@0o`000000o`000?l0o`00203o
ool20?l000L0oooo00H0o`000?ooo`000?l0oooo0000o`3o00050?ooo`050?l000000?l0oooo0?oo
o`3o00001P3oool01P3o0000oooo0000o`3oool0003o0?l000H0oooo00D0o`000000o`3oool0oooo
0?l000060?ooo`030?l0003oool0003o03/0oooo00<000000?ooo`3oool02P3oool00200oooo00<0
00000?ooo`3oool01`3oool0103o0000003o0?ooo`3o00070?ooo`80o`001`3oool00`3o0000003o
0?l000060?ooo`030?l000000?l0o`0000T0oooo00<0o`000000o`3oool00P3oool00`3o0000oooo
0?ooo`020?ooo`040?l000000?l0oooo0?ooo`80o`0000<0oooo0000o`3o0000103oool00`3o0000
003o0?ooo`020?ooo`030000o`3o0000oooo00D0oooo00<0o`000000o`3o00001`3oool00`3o0000
003o0?l000080?ooo`040?l000000?l0003o0?l000L0oooo00@0o`000?ooo`000?l0o`001P3oool0
1P3o0000003o0?ooo`3oool0003o0?l000D0oooo00D0o`000000o`3oool0oooo0?l000060?ooo`06
0?l000000?l0oooo0?ooo`000?l0o`001P3oool00`3o0000003o0?l000020?l000H0oooo00<0o`00
0000o`000?l0>`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`070?oo
o`040?l000000?l0oooo0?l000L0oooo0P3o00070?ooo`030?l000000?l0o`0000H0oooo00<0o`00
0000o`3o00002@3oool00`3o0000003o0?ooo`020?ooo`030?l0003oool0oooo0080oooo00T0o`00
0000o`3oool0o`000?ooo`3o0000oooo0000o`3o0000103oool01`3o0000003o0?ooo`3oool0o`00
0?ooo`3o00001P3oool00`3o0000003o0?l000070?ooo`030?l000000?l0o`0000P0oooo00@0o`00
0000o`000?l0o`001`3oool0103o0000003o0000o`3o00060?ooo`060?l000000?l0oooo0?ooo`00
0?l0o`001@3oool01P3o0000003o0?ooo`3oool0003o0?l000D0oooo00H0o`000000o`3oool0o`00
0000o`3o00060?ooo`030?l000000?l0o`000080o`001P3oool0103o0000003o0?ooo`000?lj0?oo
o`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00L0oooo00@0o`000000o`3o
ool0o`001`3oool00`3o0000003o0?l000060?ooo`030?l000000?l0o`0000H0oooo00<0o`000000
o`3o00002@3oool01`3o0000003o0?ooo`3o0000oooo0000o`3o00000`3oool0103o0000003o0?oo
o`3o00020?ooo`030?l0003oool0o`0000@0oooo00<0o`000000o`3oool00P3o00000`3oool0o`00
0?ooo`050?ooo`030?l000000?l0o`0000L0oooo00<0o`000000o`3o0000203oool0103o0000oooo
0?l0003o00070?ooo`040?l000000?l0003o0?l000H0oooo00H0o`000000o`3oool0o`000000o`3o
00050?ooo`060?l000000?l0oooo0?l000000?l0o`001@3oool01P3o0000003o0?ooo`3o0000003o
0?l000H0oooo00<0o`000?ooo`3o00000P3o00060?ooo`040?l000000?l0oooo0000ocX0oooo00<0
00000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool01`3oool0103o0000003o0?ooo`3o
00070?ooo`030?l000000?l0o`0000H0oooo00<0o`000000o`3o00001P3oool00`3o0000003o0?l0
00090?ooo`070?l000000?l0oooo0?l0003oool0003o0?l000030?ooo`030?l000000?l0o`0000<0
oooo00@0o`000?ooo`000?l0o`000`3oool0203o0000003o0?ooo`3o0000oooo0?l000000?l0o`00
1@3oool00`3o0000003o0?l000070?ooo`040?l000000?l0003o0?l000L0oooo103o00070?ooo`04
0?l000000?l0003o0?l000H0oooo00H0o`000?ooo`3oool0o`000000o`3o00050?ooo`060?l00000
0?l0oooo0?l000000?l0o`00103oool0103o0000oooo0000o`3oool30?l000H0oooo0P3o0000103o
ool0o`000000o`3o00050?ooo`040?l000000?l0oooo0000ocX0oooo00<000000?ooo`3oool02P3o
ool00200oooo00<000000?ooo`3oool01`3oool0103o0000003o0?ooo`3o00060?ooo`040?l00000
0?l0003o0?l000H0oooo0`3o00060?ooo`030?l000000?l0o`0000T0oooo00L0o`000000o`3o0000
oooo0?l000000?l0o`0000<0oooo00<0o`000000o`3o00000`3oool0103o0000oooo0000o`3o0002
0?ooo`040?l0003oool0003o0?l00080oooo00<0o`000000o`3o00001@3oool30?l000L0oooo00@0
o`000?ooo`000?l0o`001`3oool40?l000L0oooo00@0o`000000o`000?l0o`001P3oool00`3o0000
oooo0?ooo`030?l000D0oooo00H0o`000000o`3o0000o`000000o`3o00040?ooo`050?l0003oool0
003o0?l0003oool00P3o00060?ooo`80o`0000@0oooo0?l000000?l0o`001@3oool0103o0000003o
0?l000000?lj0?ooo`030000003oool0oooo00X0oooo000P0?ooo`800000203oool0103o0000003o
0?l0003o00060?ooo`040?l000000?l0003o0?l000H0oooo0`3o00050?ooo`040?l000000?l0oooo
0?l000T0oooo00L0o`000000o`3o0000oooo0?l000000?l0o`0000<0oooo00<0o`000000o`3o0000
103oool00`3o0000003o0?l000020?ooo`040?l0003oool0003o0?l00080oooo00<0o`000000o`3o
00001@3oool30?l000H0oooo00D0o`000000o`3oool0003o0?l000060?ooo`030?l000000?l0o`00
0080o`001`3oool0103o0000003o0000o`3o00060?ooo`040?l0003oool0o`000?ooo`80o`001@3o
ool0103o0000003o0?l0003oool20?l000@0oooo00D0o`000?ooo`000?l0o`000?ooo`020?l000H0
oooo0P3o00020?ooo`80o`001@3oool0103o0000003o0?l000000?li0?ooo`800000303oool00200
oooo00<000000?ooo`3oool01`3oool0103o0000003o0?l0003o00060?ooo`040?l000000?l0003o
0?l000H0oooo0`3o00050?ooo`040?l000000?l0o`000?l000T0oooo00L0o`000?ooo`3o0000oooo
0?l000000?l0o`0000<0oooo00<0o`000?ooo`3o0000103oool00`3o0000003o0?l000020?ooo`04
0?l000000?l0oooo0?l00080oooo00<0o`000000o`3o00001@3oool30?l000H0oooo00D0o`000000
o`3oool0003o0?l000060?ooo`030?l000000?l0o`000080o`001`3oool0103o0000003o0?l0003o
00050?ooo`050?l000000?l0oooo0?l0003oool00P3o00050?ooo`040?l000000?l0o`000?ooo`80
o`00103oool01@3o0000003o0?ooo`3o0000oooo0080o`001@3oool00`3o0000003o0?l000020?oo
o`80o`001@3oool0103o0000oooo0?l000000?lj0?ooo`030000003oool0oooo00X0oooo000P0?oo
o`030000003oool0oooo00L0oooo00@0o`000?ooo`3o0000o`001P3oool0103o0000003o0000o`3o
00050?ooo`040?l000000?l0o`000?l000D0oooo00@0o`000000o`3o0000o`00203oool00`3o0000
003o0?l000020?ooo`030?l000000?l0o`0000<0oooo0P3o00050?ooo`030?l000000?l0o`000080
oooo00@0o`000000o`3oool0o`000P3oool00`3o0000003o0?l000050?ooo`<0o`001P3oool01@3o
0000003o0?l000000?l0o`0000H0oooo00<0o`000000o`3o00000P3o00070?ooo`040?l000000?l0
o`000?l000D0oooo00<0o`000000o`3o00000P3oool20?l000D0oooo0P3o00020?ooo`80o`00103o
ool01@3o0000003o0?ooo`3o0000oooo0080o`001@3oool00`3o0000003o0?l000020?ooo`80o`00
103oool01@3o0000003o0?l0003o0000003o03X0oooo00<000000?ooo`3oool02P3oool00200oooo
00<000000?ooo`3oool01`3oool20?l000030?ooo`3o0000oooo00D0oooo00@0o`000000o`000?l0
o`001@3oool0103o0000003o0?l0003o00050?ooo`040?l000000?l0o`000?l000P0oooo00<0o`00
0000o`3o00000`3oool20?l000<0oooo0P3o00050?ooo`030?l000000?l0o`000080oooo00<0o`00
0000o`3o0000103oool20?l000D0oooo0`3o00060?ooo`050?l000000?l0o`000000o`3o00001P3o
ool00`3o0000003o0?l000020?l000L0oooo103o00050?ooo`030?l000000?l0o`000080oooo0P3o
00050?ooo`80o`000P3oool20?l000@0oooo00<0o`000000o`3o00000P3oool00`3o0000003o0?l0
00040?ooo`030?l000000?l0o`000080oooo0P3o00040?ooo`050?l000000?l0o`000?ooo`3o0000
>P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`070?ooo`80o`0000<0
oooo0?l0003oool01@3oool0103o0000003o0?l0003o00050?ooo`040?l000000?l0o`000?l000D0
oooo00@0o`000000o`3o0000o`00203oool00`3o0000003o0?l000030?ooo`80o`000P3oool00`3o
0000003o0?l000060?ooo`80o`000P3oool00`3o0000003o0?l000040?ooo`80o`001@3oool30?l0
00H0oooo00<0o`000000o`3o00000P3o00060?ooo`80o`000P3oool00`3o0000oooo0?ooo`050?oo
o`@0o`001@3oool00`3o0000003o0?l000020?ooo`80o`001@3oool20?l00080oooo0P3o00030?oo
o`040?l0003oool0003o0?l00080oooo00<0o`000000o`3o0000103oool20?l000<0oooo0P3o0004
0?ooo`060?l000000?l0o`000?ooo`3o0000003o>@3oool00`000000oooo0?ooo`0:0?ooo`00803o
ool00`000000oooo0?ooo`060?ooo`050?l000000?l0o`000?ooo`3o00001P3oool0103o0000003o
0?l0003o00050?ooo`040?l000000?l0o`000?l000D0oooo103o00080?ooo`030?l000000?l0o`00
00<0oooo0P3o00020?ooo`030?l000000?l0o`0000H0oooo0P3o00001@3oool0o`000?ooo`000?l0
o`0000@0oooo0P3o00050?ooo`@0o`001@3oool00`3o0000003o0?l000020?l000H0oooo0P3o0002
0?ooo`030?l0003oool0oooo00@0oooo00<0o`000000o`3o00000P3o00050?ooo`80o`000`3oool2
0?l000D0oooo0P3o00020?ooo`80o`000`3oool0103o0000003o0?ooo`3o00030?ooo`80o`00103o
ool20?l000<0oooo0P3o00040?ooo`060?l000000?l0o`000?ooo`3o0000003o>@3oool00`000000
oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`060?ooo`040?l000000?l0o`000?ooo`80
o`001@3oool40?l000D0oooo0P3o00000`3oool0o`000?ooo`040?ooo`@0o`00203oool00`3o0000
003o0?l000030?ooo`80o`000P3oool00`3o0000003o0?l000060?ooo`80o`0000D0oooo0?l00000
0?l0oooo0?l000040?ooo`80o`00103oool20?l000030?ooo`3o0000o`0000D0oooo0P3o00000`3o
ool0o`000?l000060?ooo`80o`000P3oool00`3o0000oooo0?ooo`040?ooo`030?l000000?l0o`00
0080o`001@3oool20?l000<0oooo0P3o00050?ooo`80o`000P3oool20?l000<0oooo00@0o`000000
o`3oool0o`000`3oool20?l000@0oooo0P3o00030?ooo`80o`00103oool01P3o0000003o0?l0003o
ool0o`000000ocT0oooo00<000000?ooo`3oool02P3oool00200oooo0P0000070?ooo`040?l00000
0?l0o`000?ooo`80o`001@3oool40?l000D0oooo0P3o00000`3oool0o`000?ooo`040?ooo`@0o`00
203oool00`3o0000003o0?l000030?ooo`80o`000P3oool00`3o0000003o0?l000060?ooo`070?l0
00000?l0o`000?l000000?l0oooo0?l000040?ooo`80o`00103oool20?l000030?ooo`3o0000o`00
00D0oooo0P3o00000`3oool0o`000?l000060?ooo`80o`000P3oool20?l000D0oooo00<0o`000000
o`3o00000P3o00050?ooo`80o`000`3oool20?l000@0oooo00<0o`000000o`3o00000P3oool20?l0
00<0oooo00@0o`000000o`3oool0o`000`3oool20?l000@0oooo0P3o00030?ooo`80o`00103oool0
1P3o0000003o0?l0003oool0o`000000ocP0oooo0P00000<0?ooo`00803oool00`000000oooo0?oo
o`060?ooo`040?l000000?l0o`000?ooo`80o`00103oool00`3o0000003o0?l000020?l000D0oooo
0P3o00000`3oool0o`000?ooo`040?ooo`80o`0000<0oooo0?l0003oool01`3oool20?l000@0oooo
0P3o00020?ooo`030?l000000?l0o`0000H0oooo00H0o`000000o`3o0000o`000000o`3o00050?oo
o`80o`00103oool20?l000030?ooo`3o0000o`0000D0oooo0P3o00000`3oool0o`000?l000060?oo
o`80o`000P3oool20?l000D0oooo00<0o`000000o`3o00000P3o00050?ooo`80o`00103oool00`3o
0000oooo0?ooo`020?ooo`030?l000000?l0o`000080oooo0P3o00030?ooo`030?l000000?l0o`00
00@0oooo0P3o00040?ooo`80o`000`3oool20?l000@0oooo0P3o00020?ooo`030?l000000?l0oooo
03P0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool01P3oool0103o0000
003o0?l0003oool20?l000@0oooo00<0o`000000o`3o00000P3o00050?ooo`80o`0000<0oooo0?l0
003oool0103oool20?l000030?ooo`3o0000oooo00L0oooo0P3o00040?ooo`80o`000P3oool20?l0
00L0oooo00H0o`000000o`3o0000o`000000o`3o00050?ooo`030?l000000?l0o`0000<0oooo0P3o
00000`3oool0o`000?l000050?ooo`80o`0000<0oooo0?l0003o00001P3oool20?l00080oooo0P3o
00050?ooo`030?l000000?l0o`000080o`001@3oool20?l000@0oooo0P3o00030?ooo`80o`000`3o
ool20?l000<0oooo00<0o`000000o`3o0000103oool20?l000@0oooo0P3o00030?ooo`80o`00103o
ool20?l00080oooo00<0o`000000o`3oool0>03oool00`000000oooo0?ooo`0:0?ooo`00803oool0
0`000000oooo0?ooo`060?ooo`80o`000P3oool20?l000@0oooo00<0o`000000o`3o00000P3o0005
0?ooo`80o`0000<0oooo0?l0003oool0103oool20?l000030?ooo`3o0000oooo00H0oooo00<0o`00
0000o`3o0000103oool01P3o0000003o0?l0003o0000oooo0?l000L0oooo00H0o`000000o`3o0000
oooo0000o`3o00050?ooo`030?l000000?l0o`0000<0oooo0P3o00000`3oool0o`000?l000050?oo
o`80o`0000<0oooo0?l0003o00001P3oool20?l00080oooo0P3o00050?ooo`80o`000P3oool00`3o
0000oooo0?ooo`030?ooo`80o`00103oool20?l000<0oooo0P3o00030?ooo`80o`000`3oool00`3o
0000003o0?l000040?ooo`80o`00103oool20?l000<0oooo0P3o00040?ooo`80o`000P3oool00`3o
0000003o0?ooo`0h0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00H0
oooo0P3o00020?ooo`80o`00103oool00`3o0000003o0?l000020?l000D0oooo0P3o00000`3oool0
o`000?ooo`040?ooo`80o`0000<0oooo0?l0003oool01P3oool00`3o0000003o0?l000040?ooo`06
0?l000000?l0oooo0?l000000?l0o`001`3oool01P3o0000003o0?ooo`3oool0003o0?l000D0oooo
00<0o`000000o`3o00000`3oool20?l000030?ooo`3o0000o`0000D0oooo0P3o00000`3oool0o`00
0?l000060?ooo`80o`000P3oool20?l000@0oooo00<0o`000?ooo`3o00000P3oool00`3o0000oooo
0?ooo`030?ooo`80o`00103oool20?l000<0oooo0P3o00040?ooo`070?l0003oool0oooo0?ooo`3o
0000oooo0?l000040?ooo`80o`000`3oool00`3o0000003o0?l000030?ooo`80o`00103oool20?l0
0080oooo00<0o`000000o`3oool0>03oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000
oooo0?ooo`060?ooo`80o`000P3oool20?l000@0oooo00D0o`000000o`3o0000oooo0?l000050?oo
o`80o`0000<0oooo0?l0003oool0103oool20?l000030?ooo`3o0000oooo00H0oooo00<0o`000000
o`3o00001@3oool01@3o0000oooo0?ooo`000?l0o`0000L0oooo00H0o`000000o`3oool0003o0?oo
o`3o00050?ooo`030?l000000?l0o`0000<0oooo0P3o00000`3oool0o`000?l000050?ooo`80o`00
00<0oooo0?l0003o00001@3oool00`3o0000003o0?l000020?ooo`80o`00103oool00`3o0000oooo
0?l000020?ooo`030?l0003oool0oooo00<0oooo0P3o00040?ooo`80o`000`3oool20?l000@0oooo
00@0o`000?ooo`3oool0oooo0P3o00050?ooo`80o`000`3oool00`3o0000003o0?l000030?ooo`80
o`00103oool20?l00080oooo00<0o`000000o`3oool0>03oool00`000000oooo0?ooo`0:0?ooo`00
803oool00`000000oooo0?ooo`060?ooo`80o`000P3oool20?l000@0oooo0P3o00020?ooo`030?l0
003oool0oooo00<0oooo0P3o00000`3oool0o`000?ooo`040?ooo`80o`0000<0oooo0?l0003oool0
1P3oool00`3o0000003o0?l000050?ooo`050?l0003oool0oooo0000o`3o0000203oool01@3o0000
oooo0000o`3oool0o`0000H0oooo0P3o00030?ooo`80o`0000<0oooo0?l0003o00001@3oool20?l0
0080oooo00<0o`000?ooo`3oool00`3oool00`3o0000003o0?l000020?ooo`80o`00103oool00`3o
0000003o0?l000020?ooo`030?l0003oool0oooo00<0oooo0P3o00040?ooo`80o`000`3oool20?l0
00@0oooo00@0o`000?ooo`3oool0oooo0P3o00050?ooo`80o`000`3oool00`3o0000003o0?l00004
0?ooo`030?l0003oool0oooo0080oooo0P3o00020?ooo`030?l000000?l0oooo00H0oooo00<0003o
0?ooo`3oool0;`3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000H0oooo00<0o`000000
o`3o00000P3oool00`3o0000003o0?l000030?ooo`80o`000P3oool00`3o0000oooo0?ooo`030?oo
o`80o`0000<0oooo0?l0003oool0103oool20?l000030?ooo`3o0000oooo00H0oooo00<0o`000000
o`3o00001@3oool01@3o0000oooo0?ooo`000?l0o`0000P0oooo00@0o`000000o`000?l0o`001`3o
ool20?l000<0oooo0P3o00000`3oool0o`000?l000040?ooo`030?l000000?l0o`000080oooo00<0
o`000?ooo`3oool00`3oool00`3o0000003o0?l000020?ooo`80o`00103oool00`3o0000003o0?l0
00020?ooo`030?l0003oool0oooo00<0oooo0P3o00040?ooo`80o`000`3oool20?l000@0oooo00@0
o`000?ooo`3oool0oooo0P3o00050?ooo`80o`000`3oool00`3o0000003o0?l000040?ooo`030?l0
003oool0oooo0080oooo0P3o00020?ooo`030?l0003oool0003o00D0oooo00<0003o0?ooo`000?l0
;`3oool2000000`0oooo000P0?ooo`030000003oool0oooo00D0oooo00<0o`000000o`3o00000P3o
ool00`3o0000003o0?l000030?ooo`80o`000P3oool00`3o0000oooo0?ooo`020?ooo`050?l00000
0?l0o`000?ooo`3o0000103oool20?l00080oooo00<0o`000?ooo`3oool01@3oool00`3o0000003o
0?l000050?ooo`050?l0003oool0oooo0000o`3o0000203oool0103o0000003o0000o`3o00070?oo
o`80o`000`3oool20?l000030?ooo`3o0000o`0000@0oooo0P3o00030?ooo`80o`00103oool20?l0
00<0oooo0P3o00040?ooo`030?l000000?l0o`000080oooo00<0o`000?ooo`3oool00`3oool20?l0
00@0oooo0P3o00030?ooo`80o`00103oool0103o0000oooo0?ooo`3oool20?l000D0oooo00<0o`00
0000o`3o00000P3oool00`3o0000003o0?l000040?ooo`070?l0003oool0oooo0?ooo`3o0000003o
0?l000020?ooo`030?l0003oool0003o00D0oooo00@0003o0?ooo`3oool0003o;`3oool00`000000
oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`050?ooo`030?l000000?l0o`000080oooo
00<0o`000000o`3o00000`3oool20?l00080oooo00<0o`000?ooo`3oool00P3oool01@3o0000003o
0?l0003oool0o`0000@0oooo0P3o00020?ooo`030?l0003oool0oooo00@0oooo00<0o`000?ooo`3o
00001P3oool01@3o0000oooo0?ooo`000?l0o`0000P0oooo00@0o`000000o`000?l0o`001`3oool2
0?l000<0oooo0P3o00000`3oool0o`000?l000040?ooo`80o`000`3oool20?l000@0oooo0P3o0003
0?ooo`80o`000`3oool0103o0000oooo0000o`3o00020?ooo`030?l0003oool0oooo00<0oooo00<0
o`000?ooo`3oool00`3oool20?l000<0oooo0P3o00040?ooo`80o`0000@0oooo0?l000000?l0o`00
1@3oool00`3o0000003o0?l000020?ooo`80o`001@3oool20?l00080oooo00<0o`000000o`3o0000
0P3oool00`3o0000oooo0000o`040?ooo`050000o`3oool0oooo0?ooo`000?l0;`3oool00`000000
oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`050?ooo`030?l000000?l0o`000080oooo
00<0o`000000o`3o00000`3oool20?l00080oooo0P3o00030?ooo`80o`000P3oool00`3o0000oooo
0?ooo`020?ooo`80o`000P3oool20?l000D0oooo00<0o`000000o`3o00001P3oool01@3o0000oooo
0?ooo`000?l0o`0000P0oooo00@0o`000000o`3oool0o`001`3oool20?l000<0oooo0P3o00000`3o
ool0o`000?l000040?ooo`80o`000`3oool20?l000@0oooo0P3o00030?ooo`80o`000`3oool0103o
0000oooo0000o`3o00020?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool00`3oool2
0?l000<0oooo0P3o00040?ooo`80o`0000@0oooo0?l000000?l0o`001@3oool01`3o0000003o0?l0
003oool0o`000?ooo`3o00001@3oool20?l00080oooo0P3o00030?ooo`030?l0003oool0003o00@0
oooo00<0003o0?ooo`3oool00P3oool010000?l0oooo0?ooo`3ooolW0000o`@0oooo00<000000?oo
o`3oool02P3oool00180oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`050?ooo`03
0?l000000?l0o`000080oooo00<0o`000000o`3o00000P3oool00`3o0000003o0?l000020?ooo`80
o`000`3oool20?l00080oooo00<0o`000?ooo`3oool00P3oool20?l00080oooo0P3o00050?ooo`03
0?l000000?l0o`0000H0oooo00D0o`000000o`000?l0oooo0?l000080?ooo`040?l0003oool0oooo
0?l000L0oooo0P3o00030?ooo`80o`0000<0oooo0?l0003o0000103oool20?l000<0oooo0P3o0004
0?ooo`80o`000`3oool20?l000<0oooo00@0o`000000o`3oool0o`000P3oool00`3o0000oooo0?oo
o`020?ooo`80o`001@3oool20?l000<0oooo0P3o00040?ooo`80o`0000@0oooo0?l000000?l0o`00
1P3oool20?l000040?ooo`3o0000oooo0?l000D0oooo0P3o00020?ooo`80o`000`3oool00`3o0000
oooo0000o`040?ooo`030000o`3oool0oooo00<0oooo0`000?l[0?ooo`030000003oool0oooo00X0
oooo000A0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo00D0oooo00<0o`000000o`3o00000P3oool00`3o0000003o0?l000020?oo
o`030?l000000?l0o`000080oooo0P3o00030?ooo`80o`000P3oool00`3o0000oooo0?ooo`020?oo
o`80o`000P3oool20?l000D0oooo00<0o`000000o`3o00001P3oool0103o0000oooo0000o`3o0009
0?ooo`040?l0003oool0oooo0?l000L0oooo00<0o`000000o`3o00000P3oool20?l000030?ooo`3o
0000o`0000@0oooo0P3o00030?ooo`80o`000`3oool00`3o0000003o0?l000030?ooo`80o`000`3o
ool0103o0000003o0?ooo`3o00020?ooo`80o`000`3oool20?l000D0oooo00L0o`000000o`3o0000
oooo0?l000000?l0o`0000@0oooo0P3o00000`3oool0o`000?l000070?ooo`@0o`0000<0003o0?l0
003oool0103oool20?l00080oooo0P3o00030?ooo`030?l0003oool0003o00@0oooo00<0003o0?oo
o`3oool0<@3oool00`000000oooo0?ooo`0:0?ooo`005@3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool01@3oool20?l000<0oooo00<0o`000000
o`3o00000P3oool00`3o0000003o0?l000020?ooo`80o`000`3oool20?l00080oooo0P3o00030?oo
o`80o`000P3oool20?l000D0oooo00<0o`000000o`3o00001P3oool0103o0000oooo0?ooo`3o0009
0?ooo`030?l0003oool0o`0000P0oooo00L0o`000000o`3o0000oooo0?l000000?l0o`000080oooo
00<0o`000?ooo`3oool00P3oool20?l000<0oooo0P3o00030?ooo`030?l000000?l0o`0000<0oooo
0P3o00030?ooo`030?l000000?l0o`0000<0oooo0P3o00030?ooo`80o`001@3oool01`3o0000003o
0?l0003oool0o`000000o`3o0000103oool20?l000030?ooo`3o0000o`0000L0oooo0P3o00020?oo
o`030000o`3o0000oooo00@0oooo0P3o00020?ooo`80o`000`3oool00`3o0000oooo0000o`030?oo
o`030000o`3oool0oooo0380oooo00<000000?ooo`3oool02P3oool001D0oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`020?ooo`<000001@3oool20?l000@0oooo00L0o`000?oo
o`3o0000oooo0?l000000?l0o`000080oooo0P3o00030?ooo`80o`000P3oool20?l000<0oooo0P3o
00020?ooo`80o`001@3oool00`3o0000003o0?l000060?ooo`040?l0003oool0oooo0?l000T0oooo
00<0o`000?ooo`3o0000203oool0103o0000003o0?l0003oool20?l000<0oooo00<0o`000?ooo`3o
ool00P3oool20?l000<0oooo0P3o00030?ooo`030?l000000?l0o`0000<0oooo0P3o00030?ooo`03
0?l000000?l0o`0000<0oooo0P3o00030?ooo`80o`001@3oool0103o0000003o0?l0003oool20?l0
00D0oooo0P3o00000`3oool0o`000?l000070?ooo`060?l0003oool0oooo0?ooo`000?l0o`001@3o
ool20?l00080oooo0P3o00040?ooo`030?l000000?l0oooo0080oooo00<0003o0?ooo`3oool0<@3o
ool2000000`0oooo000A0?ooo`@000000`3oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo00D0oooo0P3o00040?ooo`040?l000000?l0o`000?ooo`80o`000`3oool20?l000<0oooo
0P3o00020?ooo`80o`000`3oool20?l00080oooo0P3o00050?ooo`030?l000000?l0o`0000H0oooo
00@0o`000?ooo`3oool0o`002P3oool20?l000P0oooo00@0o`000000o`3o0000oooo0P3o00030?oo
o`030?l0003oool0oooo0080oooo0P3o00030?ooo`80o`000`3oool00`3o0000003o0?l000040?oo
o`070?l0003oool0oooo0?ooo`3o0000003o0?l000030?ooo`80o`000`3oool20?l000D0oooo00@0
o`000000o`3o0000oooo0P3o00050?ooo`80o`0000<0oooo0?l0003o00001`3oool01P3o0000oooo
0?ooo`3oool0003o0?l000D0oooo0P3o00020?ooo`80o`00103oool00`3o0000003o0?ooo`020?oo
o`030000o`3oool0oooo0380oooo00<000000?ooo`3oool02P3oool00140oooo00<000000?ooo`3o
ool0103oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00D0oooo0P3o00040?oo
o`040?l000000?l0o`000?ooo`80o`000`3oool20?l000<0oooo0P3o00020?ooo`80o`000`3oool2
0?l00080oooo0P3o00040?ooo`040?l0003oool0003o0?l000H0oooo00@0o`000?ooo`3oool0o`00
2P3oool20?l000P0oooo00@0o`000000o`3o0000oooo0P3o00030?ooo`030?l0003oool0oooo0080
oooo0P3o00030?ooo`80o`000`3oool00`3o0000003o0?l000040?ooo`070?l0003oool0oooo0?oo
o`3o0000oooo0?l000030?ooo`80o`000`3oool20?l000H0oooo00D0o`000?ooo`3o0000oooo0?l0
00050?ooo`80o`0000<0oooo0?l0003o00001`3oool01P3o0000003o0?ooo`3oool0003o0?l000D0
oooo0P3o00020?ooo`80o`00103oool00`3o0000oooo0000o`020?ooo`030000o`3oool0oooo0380
oooo00<000000?ooo`3oool02P3oool00140oooo1@0000030?ooo`8000001@3oool00`000000oooo
0?ooo`050?ooo`80o`00103oool0103o0000003o0?l0003oool20?l000<0oooo0P3o00030?ooo`80
o`000P3oool20?l000<0oooo0P3o00020?ooo`80o`00103oool00`3o0000003o0?l000070?ooo`04
0?l0003oool0oooo0?l000X0oooo00<0o`000?ooo`3oool0203oool20?l000030?ooo`3o0000o`00
00<0oooo00<0o`000?ooo`3oool00P3oool20?l000<0oooo0P3o00030?ooo`030?l000000?l0o`00
00@0oooo00L0o`000?ooo`3oool0oooo0?l0003oool0o`0000<0oooo0P3o00030?ooo`80o`001P3o
ool01@3o0000oooo0?ooo`3oool0o`0000D0oooo0P3o00000`3oool0o`000?l000070?ooo`060?l0
00000?l0oooo0?ooo`000?l0o`001@3oool20?l00080oooo0P3o00040?ooo`050?l0003oool0003o
0?ooo`000?l0=@3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?oo
o`030?l000000?l0o`0000@0oooo00@0o`000000o`3o0000oooo0P3o00030?ooo`80o`000`3oool2
0?l00080oooo0P3o00030?ooo`80o`000P3oool20?l000@0oooo00<0o`000000o`3o0000203oool2
0?l000/0oooo00<0o`000?ooo`3oool0203oool00`3o0000oooo0?l000020?l000<0oooo00<0o`00
0?ooo`3oool00P3oool20?l000<0oooo0P3o00020?ooo`040?l0003oool0003o0?l000@0oooo00L0
o`000?ooo`3oool0oooo0?l0003oool0o`0000<0oooo0P3o00030?ooo`80o`001P3oool01@3o0000
oooo0?ooo`3oool0o`0000D0oooo0P3o00000`3oool0o`000?l000070?ooo`060?l000000?l0oooo
0000o`3oool0o`001@3oool20?l00080oooo0P3o00040?ooo`050?l0003oool0003o0?ooo`000?l0
=@3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?ooo`030?l00000
0?l0o`0000@0oooo00@0o`000000o`3o0000oooo0P3o00030?ooo`80o`000`3oool20?l00080oooo
0P3o00030?ooo`80o`000P3oool20?l000@0oooo00<0o`000000o`3o00002@3oool00`3o0000oooo
0?ooo`0D0?ooo`030?l000000?l0o`000080o`000`3oool00`3o0000oooo0?ooo`020?ooo`80o`00
0`3oool20?l00080oooo00@0o`000?ooo`000?l0o`00103oool0103o0000oooo0?ooo`3oool20?l0
00@0oooo0P3o00030?ooo`80o`001P3oool01@3o0000003o0?ooo`000?l0o`0000D0oooo0P3o0000
0`3oool0o`000?l000070?ooo`050?l000000?l0oooo0000o`3o00001P3oool20?l00080oooo0P3o
00040?ooo`050?l0003oool0003o0?ooo`000?l0=@3oool00`000000oooo0?ooo`0:0?ooo`00803o
ool00`000000oooo0?ooo`040?ooo`030?l000000?l0o`0000@0oooo00@0o`000000o`3o0000oooo
0P3o00030?ooo`80o`000`3oool20?l00080oooo0P3o00030?ooo`80o`000P3oool20?l000@0oooo
00<0o`000000o`3o0000803oool01@3o0000003o0?ooo`000?l0o`0000<0oooo00<0o`000?ooo`3o
ool00P3oool20?l000<0oooo0P3o00020?ooo`030?l000000?l0o`0000D0oooo00H0o`000?ooo`3o
ool0o`000000o`3o00040?ooo`80o`000`3oool20?l000H0oooo00D0o`000000o`3oool0003o0?l0
00050?ooo`80o`0000<0oooo0?l0003o00001`3oool01@3o0000003o0000o`000?l0o`0000H0oooo
0P3o00020?ooo`80o`00103oool0103o0000oooo0?ooo`000?lf0?ooo`030000003oool0oooo00X0
oooo000P0?ooo`8000001@3oool20?l000D0oooo00@0o`000000o`3o0000oooo0P3o00030?ooo`80
o`000`3oool20?l00080oooo0P3o00030?ooo`80o`000P3oool20?l000@0oooo00<0o`000000o`3o
0000803oool01@3o0000003o0?ooo`000?l0o`0000<0oooo00<0o`000?ooo`3oool00P3oool20?l0
00<0oooo0P3o00020?ooo`030?l000000?l0o`0000D0oooo00H0o`000?ooo`3oool0o`000000o`3o
00040?ooo`80o`000`3oool20?l000H0oooo00D0o`000000o`3oool0003o0?l000050?ooo`<0o`00
00<0003o0?l0003oool01P3oool01@3o0000oooo0?ooo`3oool0o`0000H0oooo0P3o00020?ooo`80
o`00103oool00`3o0000oooo0?ooo`0f0?ooo`800000303oool00200oooo00<000000?ooo`3oool0
103oool20?l000H0oooo0`3o00000`000?l0o`000?ooo`020?ooo`80o`000`3oool20?l00080oooo
0P3o00030?ooo`80o`000P3oool20?l000@0oooo00<0o`000000o`3o0000803oool01@3o0000003o
0?ooo`000?l0o`0000<0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`030?ooo`06
0?l0003oool0oooo0?l000000?l0o`001@3oool01P3o0000oooo0?ooo`3o0000003o0?l000@0oooo
0P3o00030?ooo`80o`001P3oool01@3o0000003o0?ooo`000?l0o`0000D0oooo0`3o00000`000?l0
o`000?ooo`060?ooo`050?l0003oool0oooo0?ooo`3o00001P3oool20?l00080oooo0P3o00040?oo
o`030?l0003oool0oooo03L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3o
ool0103oool20?l000H0oooo00D0o`000000o`3o0000003o0?l000030?ooo`80o`000P3oool20?l0
00<0oooo0P3o00030?ooo`040?l0003oool0oooo0?ooo`80o`00103oool00`3o0000oooo0?l0000P
0?ooo`050?l000000?l0oooo0000o`3o00000`3oool0103o0000oooo0?ooo`3oool20?l000D0oooo
00H0o`000?ooo`3oool0o`000000o`3o00050?ooo`80o`0000@0oooo0?l000000?l0o`00103oool2
0?l000<0oooo0P3o00060?ooo`050?l0003oool0003o0000o`3o00001@3oool30?l000030000o`3o
0000oooo00L0oooo00@0o`000?ooo`3oool0o`001P3oool20?l000030?ooo`3o0000o`0000D0oooo
00<0o`000?ooo`3oool0=`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?oo
o`040?ooo`80o`001P3oool01@3o0000003o0?l000000?l0o`0000<0oooo0P3o00020?ooo`80o`00
0`3oool20?l000<0oooo00@0o`000?ooo`3oool0oooo0P3o00040?ooo`80o`008@3oool01@3o0000
003o0?ooo`000?l0o`0000<0oooo00@0o`000?ooo`3oool0oooo0P3o00050?ooo`060?l0003oool0
oooo0?l000000?l0o`001@3oool20?l000030?ooo`3o0000o`0000D0oooo0P3o00030?ooo`80o`00
1P3oool01@3o0000oooo0000o`3oool0o`0000H0oooo0`3o00090?ooo`040?l0003oool0oooo0?l0
00L0oooo00@0o`000?ooo`3o0000o`001@3oool00`3o0000oooo0?ooo`0g0?ooo`030000003oool0
oooo00X0oooo000P0?ooo`030000003oool0oooo00@0oooo0P3o00060?ooo`050?l000000?l0o`00
0000o`3o0000103oool00`3o0000oooo0?ooo`020?l000<0oooo0P3o00020?ooo`80o`00103oool0
0`3o0000oooo0?ooo`020?ooo`80o`008@3oool01@3o0000oooo0000o`000?l0o`0000<0oooo00@0
o`000?ooo`3oool0oooo0P3o00050?ooo`060?l0003oool0oooo0?l0003oool0o`001@3oool20?l0
00030?ooo`3o0000o`0000D0oooo0P3o00030?ooo`80o`001P3oool01@3o0000oooo0?ooo`3oool0
o`0000H0oooo0`3o00090?ooo`030?l0003oool0o`0000P0oooo00@0o`000?ooo`3o0000o`001@3o
ool00`3o0000oooo0?ooo`0g0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0
oooo00@0oooo0P3o00060?ooo`040?l000000?l0o`000?l000D0oooo00<0o`000?ooo`3oool00P3o
00030?ooo`80o`000P3oool20?l000@0oooo00<0o`000?ooo`3oool00P3oool20?l00280oooo00@0
o`000000o`000?l0o`000`3oool0103o0000oooo0?ooo`3oool20?l000D0oooo00H0o`000?ooo`3o
ool0o`000?ooo`3o00050?ooo`80o`0000<0oooo0?l0003o00001@3oool20?l000<0oooo00<0o`00
0?ooo`3oool01@3oool0103o0000oooo0?ooo`3o00070?ooo`<0o`002@3oool00`3o0000oooo0?l0
00080?ooo`040?l0003oool0o`000?l000D0oooo00<0o`000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0:0?ooo`00803oool2000000@0oooo00<0o`000000o`3o00001P3oool0103o0000003o0?oo
o`3o00050?ooo`030?l0003oool0oooo0080o`000`3oool20?l00080oooo0P3o00040?ooo`070?l0
003oool0oooo0?ooo`3o0000003o0?l0000R0?ooo`040?l000000?l0oooo0?l000<0oooo00@0o`00
0?ooo`3oool0oooo0P3o00050?ooo`030?l0003oool0oooo0080o`001P3oool20?l000030?ooo`3o
0000o`0000H0oooo00D0o`000?ooo`3oool0oooo0?l000080?ooo`030?l0003oool0o`0000L0oooo
0`3o00090?ooo`<0o`00203oool0103o0000oooo0?l0003o00050?ooo`030?l0003oool0oooo03H0
oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`040?ooo`030000o`3o0000oooo00D0oooo
00@0o`000000o`3oool0o`001@3oool00`3o0000oooo0?ooo`020?l000@0oooo00<0o`000?ooo`3o
ool00P3o00040?ooo`070?l0003oool0oooo0?ooo`3o0000003o0?l0000R0?ooo`030?l0003oool0
o`0000@0oooo00@0o`000?ooo`3oool0oooo0P3o00050?ooo`030?l0003oool0oooo0080o`001P3o
ool20?l000030?ooo`3o0000o`0000H0oooo00D0o`000?ooo`3oool0oooo0?l000080?ooo`030?l0
003oool0o`0000L0oooo0`3o00090?ooo`030?l0003oool0oooo00P0oooo103o00050?ooo`030?l0
003oool0oooo03L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0103o
ool00`000?l0o`000?ooo`060?ooo`030?l0003oool0o`0000D0oooo00<0o`000?ooo`3oool00P3o
00040?ooo`030?l0003oool0oooo0080o`00103oool01`3o0000oooo0?ooo`3oool0o`000000o`3o
00008P3oool00`3o0000oooo0?l000040?ooo`040?l0003oool0oooo0?ooo`80o`001@3oool20?l0
00030?ooo`3o0000o`0000H0oooo0P3o00000`3oool0o`000?l000060?ooo`050?l0003oool0oooo
0?ooo`3o0000203oool00`3o0000oooo0?l000070?ooo`030?l000000?l0o`0001@0oooo103o0005
0?ooo`030?l0003oool0oooo03L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?oo
o`3oool0103oool00`000?l0o`000?ooo`060?ooo`030?l000000?l0o`0000D0oooo00<0o`000?oo
o`3oool00P3o00040?ooo`030?l0003oool0oooo0080o`00103oool01`3o0000oooo0?ooo`3oool0
o`000000o`3o00008P3oool00`3o0000oooo0?l000040?ooo`040?l0003oool0oooo0?ooo`80o`00
1@3oool30?l000030000o`3o0000oooo00D0oooo0P3o00000`3oool0o`000?l000060?ooo`030?l0
003oool0oooo0080o`00203oool00`3o0000oooo0?l000070?ooo`030?l000000?l0o`0001@0oooo
103o00050?ooo`030?l0003oool0oooo03L0oooo00<000000?ooo`3oool02P3oool00200oooo00<0
00000?ooo`3oool0103oool00`000?l0o`000?ooo`060?ooo`030?l000000?l0o`0000D0oooo00<0
o`000?ooo`3oool00P3o00040?ooo`030?l0003oool0oooo0080o`00103oool0103o0000oooo0?oo
o`3oool20?l002<0oooo00<0o`000?ooo`3o0000103oool0103o0000oooo0?ooo`3oool20?l000D0
oooo0`3o00000`000?l0o`000?ooo`050?ooo`80o`0000<0oooo0?l0003o00001P3oool00`3o0000
oooo0?ooo`020?l000T0oooo00<0o`000?ooo`3oool01P3oool00`3o0000003o0?l0000D0?ooo`@0
o`001@3oool00`3o0000oooo0?ooo`0g0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000
003oool0oooo00@0oooo00<0003o0?l0003oool01P3oool00`3o0000003o0?l000050?ooo`80o`00
00<0oooo0?l0003o0000103oool00`3o0000oooo0?ooo`020?l000@0oooo00@0o`000?ooo`3oool0
oooo0P3o000T0?ooo`80o`00103oool0103o0000oooo0?ooo`3oool20?l000D0oooo0`3o00000`00
0?l0o`000?ooo`050?ooo`<0o`0000<0003o0?l0003oool01@3oool00`3o0000oooo0?ooo`020?l0
0180oooo00<0o`000000o`3o0000503oool40?l000D0oooo00<0o`000?ooo`3oool0=`3oool00`00
0000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo00H0
oooo00<0o`000000o`3o00001@3oool20?l000030?ooo`3o0000o`0000@0oooo00<0o`000?ooo`3o
ool00P3o00040?ooo`040?l0003oool0oooo0?ooo`80o`00903oool20?l000@0oooo0P3o00020?oo
o`80o`001@3oool40?l000L0oooo0`3o00000`000?l0o`000?ooo`050?ooo`030?l0003oool0oooo
0080o`004P3oool00`3o0000003o0?l0000D0?ooo`@0o`001@3oool00`3o0000oooo0?ooo`0g0?oo
o`030000003oool0oooo00X0oooo000P0?ooo`8000001@3oool00`3o0000oooo0?ooo`060?ooo`03
0?l000000?l0o`0000D0oooo0P3o00000`3oool0o`000?l000040?ooo`030?l0003oool0oooo0080
o`00103oool0103o0000oooo0?ooo`3oool20?l002@0oooo0P3o00040?ooo`80o`000P3oool20?l0
00D0oooo103o00070?ooo`@0o`001`3oool00`3o0000oooo0?ooo`020?l00180oooo00<0o`000000
o`3o0000503oool20?l000030000o`3o0000oooo00@0oooo00<0o`000?ooo`3oool0=P3oool20000
00`0oooo000P0?ooo`030000003oool0oooo00<0oooo00<0003o0?l0003oool01`3oool00`3o0000
oooo0?l000050?ooo`80o`0000<0oooo0?l0003o0000103oool00`3o0000oooo0?ooo`020?l000@0
oooo00@0o`000?ooo`3oool0oooo0P3o000Z0?ooo`80o`000P3oool20?l000D0oooo103o00070?oo
o`@0o`001`3oool00`3o0000oooo0?ooo`020?l00180oooo00<0o`000000o`3o0000503oool20?l0
00030000o`3o0000oooo00@0oooo00<0o`000?ooo`3oool0=`3oool00`000000oooo0?ooo`0:0?oo
o`00803oool00`000000oooo0?ooo`030?ooo`030000o`3o0000oooo00L0oooo00<0o`000?ooo`3o
00001@3oool30?l000030000o`3o0000oooo00<0oooo00<0o`000?ooo`3oool00P3o00040?ooo`04
0?l0003oool0oooo0?ooo`80o`00:P3oool20?l00080oooo0P3o00050?ooo`@0o`001`3oool0103o
0000003o0?l0003o00070?ooo`030?l0003oool0oooo0080o`004P3oool20?l001D0oooo0P3o0000
0`000?l0o`000?ooo`040?ooo`030?l0003oool0oooo03L0oooo00<000000?ooo`3oool02P3oool0
0200oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`060?ooo`80o`001P3oool30?l0
00030000o`3o0000oooo00<0oooo00<0o`000?ooo`3oool00P3o00040?ooo`040?l0003oool0oooo
0?ooo`80o`00:P3oool20?l00080oooo0P3o00050?ooo`@0o`001`3oool0103o0000003o0?l0003o
00070?ooo`030?l0003oool0oooo0080o`004P3oool20?l001D0oooo0P3o00000`000?l0o`000?oo
o`040?ooo`030?l0003oool0oooo03L0oooo00<000000?ooo`3oool02P3oool00200oooo00<00000
0?ooo`3oool0103oool00`3o0000oooo0?ooo`070?ooo`030?l0003oool0oooo00@0oooo103o0005
0?ooo`030?l0003oool0oooo0080o`00103oool0103o0000oooo0?ooo`3oool20?l002X0oooo0P3o
00020?ooo`030?l0003oool0oooo00@0oooo103o00080?ooo`030?l0003oool0o`0000L0oooo00<0
o`000?ooo`3oool00P3o000B0?ooo`80o`005@3oool00`3o0000003o0?l000060?ooo`030?l0003o
ool0oooo03L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0103oool0
0`3o0000oooo0?ooo`070?ooo`030?l0003oool0oooo00@0oooo103o00050?ooo`030?l0003oool0
oooo0080o`00103oool0103o0000oooo0?ooo`3oool20?l002X0oooo0P3o00000`3oool0o`000?l0
00060?ooo`@0o`00203oool00`3o0000oooo0?l000070?ooo`030?l0003oool0oooo0080o`004P3o
ool20?l001D0oooo00<0o`000000o`3o00001P3oool00`3o0000oooo0?ooo`0g0?ooo`030000003o
ool0oooo00X0oooo000P0?ooo`030000003oool0oooo00@0oooo00<0o`000?ooo`3oool01`3oool0
0`3o0000oooo0?ooo`040?ooo`@0o`001@3oool0103o0000oooo0?ooo`3o00050?ooo`040?l0003o
ool0oooo0?ooo`80o`00:P3oool20?l000030?ooo`3o0000o`0000H0oooo103o00080?ooo`030?l0
00000?l0o`0000L0oooo00<0o`000?ooo`3oool00P3o000B0?ooo`80o`005@3oool00`3o0000003o
0?l000060?ooo`030?l0003oool0oooo03L0oooo00<000000?ooo`3oool02P3oool00200oooo0P00
00050?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3oool0103oool40?l000D0oooo00@0
o`000?ooo`3oool0o`001@3oool01@3o0000oooo0?ooo`3oool0o`0002/0oooo0P3o00000`3oool0
o`000?l000060?ooo`@0o`00203oool00`3o0000003o0?l000070?ooo`030?l0003oool0oooo0080
o`004P3oool20?l001D0oooo00<0o`000000o`3o00001`3oool00`3o0000oooo0?ooo`0e0?ooo`80
0000303oool00200oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`0>0?ooo`80o`00
00<0oooo0?l0003oool0103oool0103o0000oooo0?ooo`3o00050?ooo`050?l0003oool0oooo0?oo
o`3o0000:`3oool20?l000030?ooo`3o0000o`0000H0oooo103o00080?ooo`030?l000000?l0o`00
00L0oooo00<0o`000?ooo`3oool00P3o000B0?ooo`80o`005@3oool00`3o0000003o0?l000070?oo
o`030?l0003oool0oooo03H0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3o
ool0103oool00`3o0000oooo0?ooo`0>0?ooo`040?l000000?l0oooo0?l000D0oooo00@0o`000?oo
o`3oool0o`001@3oool00`3o0000oooo0?ooo`020?l002/0oooo0P3o00000`3oool0o`000?l00006
0?ooo`@0o`00203oool00`3o0000003o0?l000070?ooo`030?l0003oool0oooo0080o`004P3oool2
0?l001H0oooo0P3o00070?ooo`030?l0003oool0oooo03H0oooo00<000000?ooo`3oool02P3oool0
0200oooo00<000000?ooo`3oool00`3oool00`3o0000oooo0?ooo`0?0?ooo`040?l000000?l0003o
0?l000D0oooo00@0o`000?ooo`3oool0o`001@3oool20?l000030?ooo`3o0000o`0002/0oooo0P3o
00000`3oool0o`000?l000070?ooo`<0o`00203oool00`3o0000003o0?l000070?ooo`80o`0000<0
oooo0?l0003o00004P3oool00`3o0000oooo0?ooo`0E0?ooo`80o`001`3oool00`3o0000oooo0?oo
o`0f0?ooo`030000003oool0oooo00X0oooo000<0?ooo`<00000103oool2000000@0oooo0P000005
0?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool03`3oool0103o0000003o0000o`3o
00050?ooo`040?l0003oool0oooo0?l000D0oooo0P3o00000`3oool0o`000?l0000[0?ooo`80o`00
00<0oooo0?l0003o00001`3oool20?l000T0oooo00<0o`000000o`3o00001`3oool20?l000030?oo
o`3o0000oooo0180oooo00<0o`000?ooo`3oool05@3oool20?l000L0oooo00<0o`000?ooo`3oool0
=P3oool00`000000oooo0?ooo`0:0?ooo`003@3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0E0?ooo`04
0?l000000?l0003o0?l000D0oooo00@0o`000?ooo`3oool0o`001@3oool20?l000030?ooo`3o0000
o`0002/0oooo0P3o00000`3oool0o`000?l000070?ooo`80o`002@3oool00`3o0000oooo0?l00007
0?ooo`80o`0000<0oooo0?l0003oool0:P3oool20?l000L0oooo00<0o`000?ooo`3oool0=P3oool0
0`000000oooo0?ooo`0:0?ooo`003@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0F0?ooo`030?l00000
0?l0o`0000D0oooo00@0o`000?ooo`3o0000o`001@3oool20?l000030?ooo`3o0000o`0002/0oooo
0P3o00000`3oool0o`000?l000070?ooo`80o`002@3oool20?l000P0oooo103o000[0?ooo`80o`00
1`3oool00`3o0000oooo0?ooo`0f0?ooo`030000003oool0oooo00X0oooo000=0?ooo`030000003o
ool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`<0
00005P3oool00`3o0000003o0?l000050?ooo`040?l0003oool0o`000?l000D0oooo0P3o00000`3o
ool0o`000?l0000/0?ooo`040?l0003oool0o`000?l000L0oooo0P3o00090?ooo`80o`00203oool4
0?l002/0oooo0P3o00070?ooo`030?l0003oool0oooo03D0oooo0P00000<0?ooo`003@3oool00`00
0000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103o
ool00`000000oooo0?ooo`0F0?ooo`030?l000000?l0o`0000D0oooo00@0o`000?ooo`3o0000o`00
1@3oool20?l000030?ooo`3o0000o`0002`0oooo00@0o`000?ooo`3o0000o`001`3oool20?l000T0
oooo0P3o00080?ooo`@0o`00:`3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo03H0
oooo00<000000?ooo`3oool02P3oool000`0oooo0P0000040?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0F0?ooo`030?l0003oool0o`00
00D0oooo00@0o`000?ooo`3o0000o`001@3oool20?l000030?ooo`3o0000o`0002`0oooo00@0o`00
0?ooo`3o0000o`001`3oool20?l000T0oooo0P3o00080?ooo`@0o`00:`3oool00`3o0000oooo0?oo
o`060?ooo`030?l0003oool0oooo03H0oooo00<000000?ooo`3oool02P3oool000d0oooo00<00000
0?ooo`3oool00`3oool2000000@0oooo0P0000050?ooo`030000003oool0oooo01H0oooo0P3o0006
0?ooo`040?l0003oool0o`000?l000D0oooo0P3o00000`3oool0o`000?l0000/0?ooo`040?l0003o
ool0o`000?l000L0oooo0P3o000:0?ooo`030?l0003oool0oooo00H0oooo103o000[0?ooo`030?l0
003oool0oooo00H0oooo00<0o`000?ooo`3oool0=P3oool00`000000oooo0?ooo`0:0?ooo`00803o
ool00`000000oooo0?ooo`0F0?ooo`80o`001P3oool0103o0000oooo0?l0003o00050?ooo`80o`00
00<0oooo0?l0003o0000;03oool0103o0000oooo0?l0003o00070?ooo`80o`002P3oool00`3o0000
oooo0?ooo`060?ooo`@0o`00:`3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo03H0
oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool05P3oool20?l000H0oooo
00@0o`000?ooo`3o0000o`001@3oool20?l000030?ooo`3o0000o`0002`0oooo00@0o`000?ooo`3o
0000o`001`3oool20?l001<0oooo103o000d0?ooo`030?l0003oool0oooo03H0oooo00<000000?oo
o`3oool02P3oool00200oooo00<000000?ooo`3oool05P3oool20?l000H0oooo103o00050?ooo`80
o`0000<0oooo0?l0003o0000;03oool00`3o0000oooo0?l000080?ooo`80o`004`3oool40?l003@0
oooo00<0o`000?ooo`3oool0=P3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000001L0oooo
0P3o00060?ooo`@0o`001@3oool20?l000030?ooo`3o0000o`0002`0oooo00<0o`000?ooo`3o0000
203oool20?l001<0oooo103o000d0?ooo`030?l0003oool0oooo03D0oooo0P00000<0?ooo`00803o
ool00`000000oooo0?ooo`0F0?ooo`80o`001P3oool40?l000D0oooo0P3o00000`3oool0o`000?l0
000/0?ooo`<0o`00203oool20?l001<0oooo103o000d0?ooo`030?l0003oool0oooo03H0oooo00<0
00000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool05P3oool00`3o0000oooo0?ooo`05
0?ooo`@0o`001@3oool20?l000030?ooo`3o0000o`0002`0oooo0`3o00080?ooo`80o`004`3oool2
0?l000030000o`3o0000oooo03<0oooo00<0o`000?ooo`3oool0=P3oool00`000000oooo0?ooo`0:
0?ooo`00803oool00`000000oooo0?ooo`0N0?ooo`@0o`001@3oool40?l002d0oooo0`3o00080?oo
o`80o`004`3oool20?l000030000o`3o0000oooo03<0oooo00<0o`000?ooo`3oool0=P3oool00`00
0000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0N0?ooo`@0o`001P3oool30?l002d0
oooo0`3o00080?ooo`80o`00503oool00`3o0000003o0?l0000d0?ooo`030?l0003oool0oooo03H0
oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool07P3oool40?l000H0oooo
0`3o000]0?ooo`<0o`00203oool20?l001@0oooo00<0o`000000o`3o0000=03oool00`3o0000oooo
0?ooo`0f0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo01h0oooo103o
00060?ooo`<0o`00;@3oool30?l000P0oooo00<0o`000?ooo`3oool04`3oool00`3o0000003o0?l0
000d0?ooo`030?l0003oool0oooo03H0oooo00<000000?ooo`3oool02P3oool00200oooo0P00000O
0?ooo`<0o`001`3oool30?l002d0oooo0`3o00080?ooo`030?l0003oool0oooo01<0oooo0P3o000e
0?ooo`030?l0003oool0oooo03D0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`0N0?oo
o`<0o`001`3oool30?l002d0oooo0`3o00080?ooo`030?l0003oool0oooo01<0oooo0P3o000f0?oo
o`030?l0003oool0oooo03D0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3o
ool07P3oool30?l000L0oooo00<0o`000?ooo`3o0000;@3oool30?l000P0oooo00<0o`000?ooo`3o
ool04`3oool20?l003H0oooo00<0o`000?ooo`3oool0=@3oool00`000000oooo0?ooo`0:0?ooo`00
803oool00`000000oooo0?ooo`0N0?ooo`<0o`001`3oool00`3o0000oooo0?l0000]0?ooo`030?l0
00000?l0o`0000P0oooo00<0o`000?ooo`3oool04`3oool20?l003H0oooo00<0o`000?ooo`3oool0
=@3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0N0?ooo`<0o`001`3o
ool00`3o0000003o0?l0000]0?ooo`030?l000000?l0o`0000P0oooo00<0o`000?ooo`3oool04`3o
ool20?l003H0oooo00<0o`000?ooo`3oool00P3oool30?l00300oooo00<000000?ooo`3oool02P3o
ool00200oooo00<000000?ooo`3oool07P3oool30?l000L0oooo00<0o`000000o`3o0000;@3oool0
0`3o0000003o0?l000080?ooo`030?l0003oool0oooo01<0oooo0P3o000f0?ooo`030?l0003oool0
oooo0080oooo00<0o`000?ooo`3o0000<03oool00`000000oooo0?ooo`0:0?ooo`00803oool20000
01l0oooo0`3o00070?ooo`030?l000000?l0o`0002d0oooo00<0o`000000o`3o0000203oool00`3o
0000oooo0?ooo`0C0?ooo`80o`00=P3oool01@3o0000oooo0?ooo`3oool0o`0000<0oooo00<0o`00
0?ooo`3oool0;03oool2000000`0oooo000P0?ooo`030000003oool0oooo01l0oooo0P3o00070?oo
o`030?l000000?l0o`0002d0oooo00<0o`000000o`3o00007P3oool20?l003H0oooo00D0o`000?oo
o`3oool0oooo0?l000040?ooo`030?l0003oool0oooo00<0oooo0P3o000W0?ooo`030000003oool0
oooo00X0oooo000P0?ooo`030000003oool0oooo01l0oooo0P3o00070?ooo`030?l000000?l0o`00
02d0oooo00<0o`000000o`3o00007P3oool20?l003H0oooo00@0o`000?ooo`3oool0o`001@3oool0
103o0000oooo0?ooo`3oool20?l00080oooo8`3o00040?ooo`030000003oool0oooo00X0oooo000P
0?ooo`030000003oool0oooo01l0oooo0P3o00070?ooo`030?l000000?l0o`0002d0oooo0P3o000O
0?ooo`80o`00=P3oool0103o0000oooo0?ooo`3o00060?ooo`<0o`00:`3oool00`000000oooo0?oo
o`0:0?ooo`00803oool00`000000oooo0?ooo`0O0?ooo`80o`001`3oool00`3o0000oooo0?l0000]
0?ooo`80o`007`3oool00`3o0000oooo0?ooo`0e0?ooo`040?l0003oool0oooo0?l003@0oooo00<0
00000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool07`3oool20?l000L0oooo0P3o000^
0?ooo`80o`007`3oool00`3o0000oooo0?ooo`0e0?ooo`030?l0003oool0o`0003D0oooo00<00000
0?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool07`3oool20?l000L0oooo0P3o000_0?oo
o`030?l0003oool0oooo01d0oooo00<0o`000?ooo`3oool0=P3oool20?l003D0oooo00<000000?oo
o`3oool02P3oool00200oooo0P00000P0?ooo`80o`001`3oool20?l002l0oooo00<0o`000?ooo`3o
ool0EP3oool00`3o0000oooo0?ooo`0c0?ooo`800000303oool00200oooo00<000000?ooo`3oool0
7`3oool20?l000L0oooo0P3o000_0?ooo`030?l0003oool0oooo08d0oooo00<000000?ooo`3oool0
2P3oool00200oooo00<000000?ooo`3oool07`3oool20?l000P0oooo00<0o`000?ooo`3oool0;@3o
ool00`3o0000oooo0?ooo`2=0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0
oooo01l0oooo0P3o00080?ooo`030?l0003oool0oooo02d0oooo00<0o`000?ooo`3oool0S@3oool0
0`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0O0?ooo`80o`00>03oool00`3o
0000oooo0?ooo`2=0?ooo`030000003oool0oooo00X0oooo000<0?ooo`<000000`3oool3000000@0
oooo0P0000050?ooo`030000003oool0oooo01l0oooo0P3o00380?ooo`030000003oool0oooo00X0
oooo000=0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool07`3oool00`3o0000oooo0?ooo`370?oo
o`030000003oool0oooo00X0oooo000=0?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`020?ooo`<000007`3oool00`3o0000oooo0?ooo`360?oo
o`800000303oool000d0oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool07`3oool00`3o0000oooo0?ooo`370?oo
o`030000003oool0oooo00X0oooo000=0?ooo`040000003oool0oooo0?ooo`@000000`3oool01000
0000oooo0?ooo`0000040?ooo`030000003oool0oooo01l0oooo00<0o`000?ooo`3oool0a`3oool0
0`000000oooo0?ooo`0:0?ooo`00303oool2000000<0oooo00<000000?ooo`3oool0103oool01000
0000oooo0?ooo`0000040?ooo`030000003oool0oooo01l0oooo00<0o`000?ooo`3oool0a`3oool0
0`000000oooo0?ooo`0:0?ooo`003@3oool010000000oooo0?ooo`3oool5000000<0oooo0P000005
0?ooo`030000003oool0oooo01l0oooo00<0o`000?ooo`3oool0a`3oool00`000000oooo0?ooo`0:
0?ooo`00803oool00`000000oooo0?ooo`3Y0?ooo`030000003oool0oooo00X0oooo000P0?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0]0?ooo`03
0000003oool0oooo02h0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo00X0oooo000P0?ooo`8000001@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool00P00000<0?ooo`00803oooo]000000`0oooo003o
0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo00120?ooo`<0<c<cS@3oool303<c<d@0oooo
00130?ooo`0303<c<`3oool0oooo08d0oooo00<0<c<c0?ooo`3oool0@`3oool004<0oooo0`0c<c<2
0?ooo`<0<c<c103oool303<c<`<0oooo100c<c<00`3oool0<c<c03<c<`0303<c<`80oooo0`0c<c<4
0?ooo`80<c<c0`3oool303<c<`<0oooo100c<c<70?ooo`<0<c<c00<0oooo03<c<`0c<c<00P3oool2
03<c<`080?ooo`0c<c<0<c<c0?ooo`0c<c<0oooo03<c<`3oool403<c<`<0oooo0`0c<c<20?ooo`<0
<c<c2P3oool303<c<`80oooo1@0c<c<70?ooo`@0<c<c103oool203<c<`030?ooo`0c<c<0<c<c0080
<c<c00<0oooo03<c<`0c<c<0100c<c<30?ooo`<0<c<c0`3oool303<c<`@0oooo0P0c<c<20?ooo`@0
<c<c<@3oool004<0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo0?ooo`020?ooo`03
03<c<`3oool0oooo00<0oooo00@0<c<c0?ooo`3oool0<c<c103oool01@0c<c<0oooo0?ooo`3oool0
<c<c00<0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo03<c<`050?ooo`0403<c<`3o
ool0oooo03<c<`T0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool02P0c<c<0oooo0?ooo`0c<c<0oooo
03<c<`3oool0<c<c0?ooo`0c<c<20?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c1P3oool00`0c
<c<0oooo0?ooo`080?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3oool00`0c<c<0oooo0?ooo`0;
0?ooo`0403<c<`3oool0oooo03<c<`80oooo00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo
0?ooo`030?ooo`0403<c<`3oool0oooo03<c<`80oooo00<0<c<c0?ooo`0c<c<00`3oool0100c<c<0
oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00<0oooo00<0<c<c0?ooo`3oool0;P3oool004<0
oooo00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo0?ooo`020?ooo`D0<c<c00D0oooo03<c
<`3oool0oooo03<c<`040?ooo`0503<c<`3oool0oooo0?ooo`0c<c<01P3oool00`0c<c<0oooo0?oo
o`020?ooo`D0<c<c00D0oooo03<c<`3oool0oooo03<c<`090?ooo`0403<c<`3oool0oooo03<c<`80
oooo00X0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<0oooo03<c<`3oool0<c<c0P3oool01@0c<c<0oooo
0?ooo`0c<c<0oooo00D0<c<c0P3oool00`0c<c<0oooo0?ooo`080?ooo`0503<c<`3oool0oooo0?oo
o`0c<c<00`3oool00`0c<c<0oooo0?ooo`080?ooo`<0<c<c0`3oool0100c<c<0oooo0?ooo`0c<c<2
0?ooo`0403<c<`3oool0oooo03<c<`80oooo0`0c<c<30?ooo`0603<c<`3oool0oooo03<c<`3oool0
<c<c0`3oool0100c<c<0oooo0?ooo`0c<c<50?ooo`<0<c<c<@3oool004<0oooo00@0<c<c0?ooo`3o
ool0<c<c0P3oool203<c<`<0oooo00L0<c<c0?ooo`3oool0oooo03<c<`3oool0<c<c0080oooo00<0
<c<c0?ooo`3oool00P3oool01@0c<c<0oooo0?ooo`3oool0<c<c00<0oooo00@0<c<c0?ooo`3oool0
<c<c103oool01`0c<c<0oooo0?ooo`3oool0<c<c0?ooo`0c<c<00P3oool00`0c<c<0oooo0?ooo`07
0?ooo`0403<c<`3oool0oooo03<c<`80oooo00X0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<0oooo03<c
<`3oool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`<0oooo00<0<c<c0?ooo`3oool0
0P0c<c<90?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3oool00`0c<c<0oooo0?ooo`070?ooo`03
03<c<`3oool0oooo00@0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0
oooo03<c<`H0oooo00H0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<30?ooo`0403<c<`3oool0oooo03<c
<`@0oooo00<0<c<c0?ooo`3oool0<P3oool00480oooo100c<c<20?ooo`80<c<c00<0oooo03<c<`0c
<c<00P3oool303<c<`<0oooo0`0c<c<20?ooo`<0<c<c103oool303<c<`80oooo100c<c<30?ooo`<0
<c<c0`3oool303<c<`P0oooo100c<c<20?ooo`80<c<c00@0oooo03<c<`0c<c<0oooo0P0c<c<00`3o
ool0<c<c0?ooo`020?ooo`<0<c<c0`3oool303<c<`80oooo0P0c<c<00`3oool0<c<c03<c<`080?oo
o`<0<c<c0`3oool403<c<`P0oooo100c<c<0103oool0<c<c03<c<`3oool203<c<`030?ooo`0c<c<0
<c<c0080<c<c0`3oool403<c<`030?ooo`0c<c<0<c<c0080<c<c0`3oool303<c<`80oooo100c<c<3
0?ooo`@0<c<c<03oool005L0oooo00<0<c<c0?ooo`3oool03@3oool00`0c<c<0oooo0?ooo`0;0?oo
o`0303<c<`3oool0oooo01T0oooo00<0<c<c0?ooo`3oool0703oool00`0c<c<0oooo0?ooo`0/0?oo
o`0303<c<`3oool0oooo03L0oooo001F0?ooo`80<c<c103oool00`0c<c<0oooo0?ooo`080?ooo`03
03<c<`3oool0oooo00X0oooo0P0c<c<J0?ooo`80<c<c7`3oool203<c<b`0oooo00<0<c<c0?ooo`3o
ool0=`3oool00?l0oooo6P3oool00?l0oooo6P3oool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {1709.98, -70.3767, \
1.02251, 1.46541}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{231, 5}\),
      SequenceForm[ "Dimension der Daten  ", {231, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-7.21843 0.00414079 0.242739 0.0037592 [
[.02795 -0.0125 -12 -9 ]
[.02795 -0.0125 12 0 ]
[.23499 -0.0125 -12 -9 ]
[.23499 -0.0125 12 0 ]
[.44203 -0.0125 -12 -9 ]
[.44203 -0.0125 12 0 ]
[.64907 -0.0125 -12 -9 ]
[.64907 -0.0125 12 0 ]
[.85611 -0.0125 -12 -9 ]
[.85611 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05478 -18 -4.5 ]
[-0.0125 .05478 0 4.5 ]
[-0.0125 .14876 -18 -4.5 ]
[-0.0125 .14876 0 4.5 ]
[-0.0125 .24274 -6 -4.5 ]
[-0.0125 .24274 0 4.5 ]
[-0.0125 .33672 -12 -4.5 ]
[-0.0125 .33672 0 4.5 ]
[-0.0125 .4307 -12 -4.5 ]
[-0.0125 .4307 0 4.5 ]
[-0.0125 .52468 -12 -4.5 ]
[-0.0125 .52468 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -86 0 ]
[.5 .63053 86 12 ]
[.97619 .24274 -5 -6 ]
[.97619 .24274 5 6 ]
[.97619 .24274 -5 -6 ]
[.97619 .24274 5 6 ]
[.97619 .45148 -5 -6 ]
[.97619 .45148 5 6 ]
[.97619 .034 -5 -6 ]
[.97619 .034 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02795 0 m
.02795 .00625 L
s
[(1750)] .02795 -0.0125 0 1 Mshowa
.23499 0 m
.23499 .00625 L
s
[(1800)] .23499 -0.0125 0 1 Mshowa
.44203 0 m
.44203 .00625 L
s
[(1850)] .44203 -0.0125 0 1 Mshowa
.64907 0 m
.64907 .00625 L
s
[(1900)] .64907 -0.0125 0 1 Mshowa
.85611 0 m
.85611 .00625 L
s
[(1950)] .85611 -0.0125 0 1 Mshowa
.125 Mabswid
.06936 0 m
.06936 .00375 L
s
.11077 0 m
.11077 .00375 L
s
.15217 0 m
.15217 .00375 L
s
.19358 0 m
.19358 .00375 L
s
.2764 0 m
.2764 .00375 L
s
.31781 0 m
.31781 .00375 L
s
.35921 0 m
.35921 .00375 L
s
.40062 0 m
.40062 .00375 L
s
.48344 0 m
.48344 .00375 L
s
.52484 0 m
.52484 .00375 L
s
.56625 0 m
.56625 .00375 L
s
.60766 0 m
.60766 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.73188 0 m
.73188 .00375 L
s
.77329 0 m
.77329 .00375 L
s
.8147 0 m
.8147 .00375 L
s
.89752 0 m
.89752 .00375 L
s
.93892 0 m
.93892 .00375 L
s
.98033 0 m
.98033 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05478 m
.00625 .05478 L
s
[(-50)] -0.0125 .05478 1 0 Mshowa
0 .14876 m
.00625 .14876 L
s
[(-25)] -0.0125 .14876 1 0 Mshowa
0 .24274 m
.00625 .24274 L
s
[(0)] -0.0125 .24274 1 0 Mshowa
0 .33672 m
.00625 .33672 L
s
[(25)] -0.0125 .33672 1 0 Mshowa
0 .4307 m
.00625 .4307 L
s
[(50)] -0.0125 .4307 1 0 Mshowa
0 .52468 m
.00625 .52468 L
s
[(75)] -0.0125 .52468 1 0 Mshowa
.125 Mabswid
0 .07358 m
.00375 .07358 L
s
0 .09237 m
.00375 .09237 L
s
0 .11117 m
.00375 .11117 L
s
0 .12996 m
.00375 .12996 L
s
0 .16756 m
.00375 .16756 L
s
0 .18635 m
.00375 .18635 L
s
0 .20515 m
.00375 .20515 L
s
0 .22394 m
.00375 .22394 L
s
0 .26154 m
.00375 .26154 L
s
0 .28033 m
.00375 .28033 L
s
0 .29913 m
.00375 .29913 L
s
0 .31792 m
.00375 .31792 L
s
0 .35552 m
.00375 .35552 L
s
0 .37431 m
.00375 .37431 L
s
0 .39311 m
.00375 .39311 L
s
0 .4119 m
.00375 .4119 L
s
0 .4495 m
.00375 .4495 L
s
0 .46829 m
.00375 .46829 L
s
0 .48709 m
.00375 .48709 L
s
0 .50588 m
.00375 .50588 L
s
0 .54348 m
.00375 .54348 L
s
0 .56227 m
.00375 .56227 L
s
0 .58107 m
.00375 .58107 L
s
0 .59986 m
.00375 .59986 L
s
0 .03598 m
.00375 .03598 L
s
0 .01719 m
.00375 .01719 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02795 .61178 m
.02795 .61803 L
s
.23499 .61178 m
.23499 .61803 L
s
.44203 .61178 m
.44203 .61803 L
s
.64907 .61178 m
.64907 .61803 L
s
.85611 .61178 m
.85611 .61803 L
s
.125 Mabswid
.06936 .61428 m
.06936 .61803 L
s
.11077 .61428 m
.11077 .61803 L
s
.15217 .61428 m
.15217 .61803 L
s
.19358 .61428 m
.19358 .61803 L
s
.2764 .61428 m
.2764 .61803 L
s
.31781 .61428 m
.31781 .61803 L
s
.35921 .61428 m
.35921 .61803 L
s
.40062 .61428 m
.40062 .61803 L
s
.48344 .61428 m
.48344 .61803 L
s
.52484 .61428 m
.52484 .61803 L
s
.56625 .61428 m
.56625 .61803 L
s
.60766 .61428 m
.60766 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.73188 .61428 m
.73188 .61803 L
s
.77329 .61428 m
.77329 .61803 L
s
.8147 .61428 m
.8147 .61803 L
s
.89752 .61428 m
.89752 .61803 L
s
.93892 .61428 m
.93892 .61803 L
s
.98033 .61428 m
.98033 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05478 m
1 .05478 L
s
.99375 .14876 m
1 .14876 L
s
.99375 .24274 m
1 .24274 L
s
.99375 .33672 m
1 .33672 L
s
.99375 .4307 m
1 .4307 L
s
.99375 .52468 m
1 .52468 L
s
.125 Mabswid
.99625 .07358 m
1 .07358 L
s
.99625 .09237 m
1 .09237 L
s
.99625 .11117 m
1 .11117 L
s
.99625 .12996 m
1 .12996 L
s
.99625 .16756 m
1 .16756 L
s
.99625 .18635 m
1 .18635 L
s
.99625 .20515 m
1 .20515 L
s
.99625 .22394 m
1 .22394 L
s
.99625 .26154 m
1 .26154 L
s
.99625 .28033 m
1 .28033 L
s
.99625 .29913 m
1 .29913 L
s
.99625 .31792 m
1 .31792 L
s
.99625 .35552 m
1 .35552 L
s
.99625 .37431 m
1 .37431 L
s
.99625 .39311 m
1 .39311 L
s
.99625 .4119 m
1 .4119 L
s
.99625 .4495 m
1 .4495 L
s
.99625 .46829 m
1 .46829 L
s
.99625 .48709 m
1 .48709 L
s
.99625 .50588 m
1 .50588 L
s
.99625 .54348 m
1 .54348 L
s
.99625 .56227 m
1 .56227 L
s
.99625 .58107 m
1 .58107 L
s
.99625 .59986 m
1 .59986 L
s
.99625 .03598 m
1 .03598 L
s
.99625 .01719 m
1 .01719 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -147 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(change) show
105.000 13.000 moveto
(in) show
123.000 13.000 moveto
(number) show
165.000 13.000 moveto
(of) show
183.000 13.000 moveto
(sunspots) show
231.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .98 .604 r
gsave
.97619 .24274 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .27066 m
.02795 .17458 L
.03209 .17222 L
.03623 .20827 L
.04037 .17713 L
.04451 .19743 L
.04865 .2388 L
.0528 .29046 L
.05694 .31587 L
.06108 .28278 L
.06522 .27438 L
.06936 .30564 L
.0735 .23973 L
.07764 .16336 L
.08178 .1905 L
.08592 .19346 L
.09006 .1909 L
.0942 .2724 L
.09834 .36266 L
.10248 .38351 L
.10663 .30332 L
.11077 .1936 L
.11491 .16924 L
.11905 .15408 L
.12319 .17153 L
.12733 .17727 L
.13147 .21796 L
.13561 .41933 L
.13975 .51986 L
.14389 .31093 L
.14803 .09817 L
.15217 .11895 L
.15631 .15609 L
.16046 .15698 L
.1646 .17934 L
.16874 .24276 L
.17288 .39078 L
.17702 .46176 L
.18116 .34161 L
.1853 .2097 L
.18944 .15354 L
.19358 .14179 L
.19772 .1861 L
.20186 .21043 L
.206 .20909 L
.21014 .19395 L
.21429 .19488 L
.21843 .21334 L
.22257 .2206 L
.22671 .24138 L
Mistroke
.23085 .26351 L
.23499 .29771 L
.23913 .30233 L
.24327 .2609 L
.24741 .24716 L
.25155 .24146 L
.25569 .20455 L
.25983 .1791 L
.26398 .20367 L
.26812 .22925 L
.27226 .2289 L
.2764 .24005 L
.28054 .25298 L
.28468 .26123 L
.28882 .2591 L
.29296 .28947 L
.2971 .30667 L
.30124 .25499 L
.30538 .21029 L
.30952 .20778 L
.31366 .21437 L
.31781 .21031 L
.32195 .21943 L
.32609 .23299 L
.33023 .25018 L
.33437 .27084 L
.33851 .29675 L
.34265 .30701 L
.34679 .2935 L
.35093 .27807 L
.35507 .26069 L
.35921 .20568 L
.36335 .15452 L
.36749 .15613 L
.37164 .20781 L
.37578 .34122 L
.37992 .46703 L
.38406 .40695 L
.3882 .20396 L
.39234 .13172 L
.39648 .16106 L
.40062 .15271 L
.40476 .16709 L
.4089 .18999 L
.41304 .22517 L
.41718 .29712 L
.42133 .33426 L
.42547 .3641 L
.42961 .36798 L
.43375 .23439 L
Mistroke
.43789 .12405 L
.44203 .17769 L
.44617 .22471 L
.45031 .19916 L
.45445 .17634 L
.45859 .17644 L
.46273 .20724 L
.46687 .27191 L
.47101 .34597 L
.47516 .38778 L
.4793 .32447 L
.48344 .20698 L
.48758 .16301 L
.49172 .1785 L
.49586 .22386 L
.5 .21984 L
.50414 .17938 L
.50828 .18954 L
.51242 .27762 L
.51656 .38284 L
.5207 .44856 L
.52484 .31832 L
.52899 .16639 L
.53313 .1465 L
.53727 .13302 L
.54141 .14662 L
.54555 .1828 L
.54969 .23552 L
.55383 .22682 L
.55797 .22837 L
.56211 .29927 L
.56625 .33953 L
.57039 .29754 L
.57453 .25974 L
.57867 .25065 L
.58282 .22047 L
.58696 .16724 L
.5911 .16504 L
.59524 .20681 L
.59938 .22845 L
.60352 .23997 L
.60766 .30074 L
.6118 .37517 L
.61594 .34343 L
.62008 .25239 L
.62422 .19705 L
.62836 .16826 L
.63251 .17071 L
.63665 .21491 L
.64079 .21904 L
Mistroke
.64493 .21049 L
.64907 .22068 L
.65321 .23306 L
.65735 .2837 L
.66149 .31902 L
.66563 .31933 L
.66977 .26552 L
.67391 .2379 L
.67805 .23259 L
.68219 .20971 L
.68634 .18234 L
.69048 .16902 L
.69462 .21169 L
.69876 .23245 L
.7029 .25522 L
.70704 .32772 L
.71118 .34208 L
.71532 .35709 L
.71946 .28747 L
.7236 .16281 L
.72774 .15167 L
.73188 .17184 L
.73602 .19718 L
.74017 .20393 L
.74431 .2473 L
.74845 .29506 L
.75259 .3038 L
.75673 .29013 L
.76087 .2655 L
.76501 .24128 L
.76915 .22514 L
.77329 .21974 L
.77743 .22344 L
.78157 .23219 L
.78571 .24159 L
.78986 .24841 L
.794 .25125 L
.79814 .25047 L
.80228 .24744 L
.80642 .24385 L
.81056 .24103 L
.8147 .23965 L
.81884 .23969 L
.82298 .24071 L
.82712 .24206 L
.83126 .2432 L
.8354 .24384 L
.83954 .24392 L
.84369 .2436 L
.84783 .2431 L
Mistroke
.85197 .24264 L
.85611 .24236 L
.86025 .24229 L
.86439 .24238 L
.86853 .24257 L
.87267 .24274 L
.87681 .24287 L
.88095 .24291 L
.88509 .24288 L
.88923 .24282 L
.89337 .24275 L
.89752 .2427 L
.90166 .24268 L
.9058 .24268 L
.90994 .2427 L
.91408 .24273 L
.91822 .24275 L
.92236 .24276 L
.9265 .24276 L
.93064 .24275 L
.93478 .24274 L
.93892 .24274 L
.94306 .24273 L
.9472 .24273 L
.95135 .24273 L
.95549 .24274 L
.95963 .24274 L
.96377 .24274 L
.96791 .24274 L
.97205 .24274 L
.97619 .24274 L
Mfstroke
gsave
.97619 .24274 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27066 m
.02795 .17458 L
.03209 .17222 L
.03623 .20827 L
.04037 .17713 L
.04451 .19743 L
.04865 .2388 L
.0528 .29046 L
.05694 .31587 L
.06108 .28278 L
.06522 .27438 L
.06936 .30564 L
.0735 .23973 L
.07764 .16336 L
.08178 .1905 L
.08592 .19346 L
.09006 .1909 L
.0942 .2724 L
.09834 .36266 L
.10248 .38351 L
.10663 .30332 L
.11077 .1936 L
.11491 .16924 L
.11905 .15408 L
.12319 .17153 L
.12733 .17727 L
.13147 .21796 L
.13561 .41933 L
.13975 .51986 L
.14389 .31093 L
.14803 .09817 L
.15217 .11895 L
.15631 .15609 L
.16046 .15698 L
.1646 .17934 L
.16874 .24276 L
.17288 .39078 L
.17702 .46176 L
.18116 .34161 L
.1853 .2097 L
.18944 .15354 L
.19358 .14179 L
.19772 .1861 L
.20186 .21043 L
.206 .20909 L
.21014 .19395 L
.21429 .19488 L
.21843 .21334 L
.22257 .2206 L
.22671 .24138 L
Mistroke
.23085 .26351 L
.23499 .29771 L
.23913 .30233 L
.24327 .2609 L
.24741 .24716 L
.25155 .24146 L
.25569 .20455 L
.25983 .1791 L
.26398 .20367 L
.26812 .22925 L
.27226 .2289 L
.2764 .24005 L
.28054 .25298 L
.28468 .26123 L
.28882 .2591 L
.29296 .28947 L
.2971 .30667 L
.30124 .25499 L
.30538 .21029 L
.30952 .20778 L
.31366 .21437 L
.31781 .21031 L
.32195 .21943 L
.32609 .23299 L
.33023 .25018 L
.33437 .27084 L
.33851 .29675 L
.34265 .30701 L
.34679 .2935 L
.35093 .27807 L
.35507 .26069 L
.35921 .20568 L
.36335 .15452 L
.36749 .15613 L
.37164 .20781 L
.37578 .34122 L
.37992 .46703 L
.38406 .40695 L
.3882 .20396 L
.39234 .13172 L
.39648 .16106 L
.40062 .15271 L
.40476 .16709 L
.4089 .18999 L
.41304 .22517 L
.41718 .29712 L
.42133 .33426 L
.42547 .3641 L
.42961 .36798 L
.43375 .23439 L
Mistroke
.43789 .12405 L
.44203 .17769 L
.44617 .22471 L
.45031 .19916 L
.45445 .17634 L
.45859 .17644 L
.46273 .20724 L
.46687 .27191 L
.47101 .34597 L
.47516 .38778 L
.4793 .32447 L
.48344 .20698 L
.48758 .16301 L
.49172 .1785 L
.49586 .22386 L
.5 .21984 L
.50414 .17938 L
.50828 .18954 L
.51242 .27762 L
.51656 .38284 L
.5207 .44856 L
.52484 .31832 L
.52899 .16639 L
.53313 .1465 L
.53727 .13302 L
.54141 .14662 L
.54555 .1828 L
.54969 .23552 L
.55383 .22682 L
.55797 .22837 L
.56211 .29927 L
.56625 .33953 L
.57039 .29754 L
.57453 .25974 L
.57867 .25065 L
.58282 .22047 L
.58696 .16724 L
.5911 .16504 L
.59524 .20681 L
.59938 .22845 L
.60352 .23997 L
.60766 .30074 L
.6118 .37517 L
.61594 .34343 L
.62008 .25239 L
.62422 .19705 L
.62836 .16826 L
.63251 .17071 L
.63665 .21491 L
.64079 .21904 L
Mistroke
.64493 .21049 L
.64907 .22068 L
.65321 .23306 L
.65735 .2837 L
.66149 .31902 L
.66563 .31933 L
.66977 .26552 L
.67391 .2379 L
.67805 .23259 L
.68219 .20971 L
.68634 .18234 L
.69048 .16902 L
.69462 .21169 L
.69876 .23245 L
.7029 .25522 L
.70704 .32772 L
.71118 .34208 L
.71532 .35709 L
.71946 .28747 L
.7236 .16281 L
.72774 .15167 L
.73188 .17184 L
.73602 .19718 L
.74017 .20393 L
.74431 .2473 L
.74845 .29506 L
.75259 .3038 L
.75673 .29013 L
.76087 .2655 L
.76501 .24128 L
.76915 .22514 L
.77329 .21974 L
.77743 .22344 L
.78157 .23219 L
.78571 .24159 L
.78986 .24841 L
.794 .25125 L
.79814 .25047 L
.80228 .24744 L
.80642 .24385 L
.81056 .24103 L
.8147 .23965 L
.81884 .23969 L
.82298 .24071 L
.82712 .24206 L
.83126 .2432 L
.8354 .24384 L
.83954 .24392 L
.84369 .2436 L
.84783 .2431 L
Mistroke
.85197 .24264 L
.85611 .24236 L
.86025 .24229 L
.86439 .24238 L
.86853 .24257 L
.87267 .24274 L
.87681 .24287 L
.88095 .24291 L
.88509 .24288 L
.88923 .24282 L
.89337 .24275 L
.89752 .2427 L
.90166 .24268 L
.9058 .24268 L
.90994 .2427 L
.91408 .24273 L
.91822 .24275 L
.92236 .24276 L
.9265 .24276 L
.93064 .24275 L
.93478 .24274 L
.93892 .24274 L
.94306 .24273 L
.9472 .24273 L
.95135 .24273 L
.95549 .24274 L
.95963 .24274 L
.96377 .24274 L
.96791 .24274 L
.97205 .24274 L
.97619 .24274 L
Mfstroke
1 0 0 r
gsave
.97619 .45148 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .40824 m
.02795 .25884 L
.03209 .25617 L
.03623 .29174 L
.04037 .26059 L
.04451 .28088 L
.04865 .32226 L
.0528 .37392 L
.05694 .39933 L
.06108 .36624 L
.06522 .35784 L
.06936 .3891 L
.0735 .32319 L
.07764 .24682 L
.08178 .27396 L
.08592 .27692 L
.09006 .27436 L
.0942 .35586 L
.09834 .44612 L
.10248 .46696 L
.10663 .38678 L
.11077 .27706 L
.11491 .2527 L
.11905 .23754 L
.12319 .25499 L
.12733 .26073 L
.13147 .30141 L
.13561 .50279 L
.13975 .60332 L
.14389 .39439 L
.14803 .18163 L
.15217 .20241 L
.15631 .23955 L
.16046 .24044 L
.1646 .2628 L
.16874 .32622 L
.17288 .47424 L
.17702 .54522 L
.18116 .42507 L
.1853 .29316 L
.18944 .237 L
.19358 .22525 L
.19772 .26956 L
.20186 .29389 L
.206 .29255 L
.21014 .27741 L
.21429 .27834 L
.21843 .2968 L
.22257 .30406 L
.22671 .32484 L
Mistroke
.23085 .34697 L
.23499 .38117 L
.23913 .38579 L
.24327 .34436 L
.24741 .33062 L
.25155 .32492 L
.25569 .28801 L
.25983 .26256 L
.26398 .28713 L
.26812 .31271 L
.27226 .31236 L
.2764 .32351 L
.28054 .33644 L
.28468 .34469 L
.28882 .34256 L
.29296 .37293 L
.2971 .39013 L
.30124 .33845 L
.30538 .29375 L
.30952 .29124 L
.31366 .29783 L
.31781 .29377 L
.32195 .30289 L
.32609 .31644 L
.33023 .33363 L
.33437 .35429 L
.33851 .38021 L
.34265 .39047 L
.34679 .37696 L
.35093 .36153 L
.35507 .34415 L
.35921 .28914 L
.36335 .23798 L
.36749 .23959 L
.37164 .29127 L
.37578 .42468 L
.37992 .55049 L
.38406 .49041 L
.3882 .28741 L
.39234 .21518 L
.39648 .24452 L
.40062 .23617 L
.40476 .25055 L
.4089 .27344 L
.41304 .30863 L
.41718 .38058 L
.42133 .41772 L
.42547 .44756 L
.42961 .45144 L
.43375 .31785 L
Mistroke
.43789 .2075 L
.44203 .26115 L
.44617 .30817 L
.45031 .28262 L
.45445 .2598 L
.45859 .2599 L
.46273 .2907 L
.46687 .35537 L
.47101 .42943 L
.47516 .47124 L
.4793 .40793 L
.48344 .29044 L
.48758 .24647 L
.49172 .26195 L
.49586 .30731 L
.5 .3033 L
.50414 .26284 L
.50828 .273 L
.51242 .36108 L
.51656 .4663 L
.5207 .53202 L
.52484 .40178 L
.52899 .24984 L
.53313 .22996 L
.53727 .21648 L
.54141 .23008 L
.54555 .26626 L
.54969 .31898 L
.55383 .31028 L
.55797 .31183 L
.56211 .38273 L
.56625 .42299 L
.57039 .381 L
.57453 .3432 L
.57867 .33411 L
.58282 .30393 L
.58696 .2507 L
.5911 .2485 L
.59524 .29026 L
.59938 .31191 L
.60352 .32343 L
.60766 .3842 L
.6118 .45863 L
.61594 .42689 L
.62008 .33585 L
.62422 .28051 L
.62836 .25172 L
.63251 .25417 L
.63665 .29837 L
.64079 .3025 L
Mistroke
.64493 .29395 L
.64907 .30413 L
.65321 .31652 L
.65735 .36715 L
.66149 .40248 L
.66563 .40279 L
.66977 .34898 L
.67391 .32136 L
.67805 .31605 L
.68219 .29317 L
.68634 .26579 L
.69048 .25248 L
.69462 .29515 L
.69876 .31591 L
.7029 .33868 L
.70704 .41118 L
.71118 .42554 L
.71532 .44055 L
.71946 .37093 L
.7236 .24627 L
.72774 .23513 L
.73188 .2553 L
.73602 .28064 L
.74017 .28762 L
.74431 .331 L
.74845 .41065 L
.75259 .45873 L
.75673 .44571 L
.76087 .42934 L
.76501 .42353 L
.76915 .4217 L
.77329 .42153 L
.77743 .42558 L
.78157 .4349 L
.78571 .44634 L
.78986 .45519 L
.794 .45897 L
.79814 .4583 L
.80228 .45531 L
.80642 .45197 L
.81056 .44945 L
.8147 .44823 L
.81884 .44831 L
.82298 .44932 L
.82712 .4507 L
.83126 .45189 L
.8354 .45255 L
.83954 .45264 L
.84369 .45232 L
.84783 .45183 L
Mistroke
.85197 .45137 L
.85611 .4511 L
.86025 .45103 L
.86439 .45112 L
.86853 .4513 L
.87267 .45148 L
.87681 .45161 L
.88095 .45165 L
.88509 .45162 L
.88923 .45156 L
.89337 .45149 L
.89752 .45144 L
.90166 .45142 L
.9058 .45142 L
.90994 .45145 L
.91408 .45147 L
.91822 .45149 L
.92236 .4515 L
.9265 .4515 L
.93064 .4515 L
.93478 .45149 L
.93892 .45148 L
.94306 .45147 L
.9472 .45147 L
.95135 .45147 L
.95549 .45148 L
.95963 .45148 L
.96377 .45148 L
.96791 .45148 L
.97205 .45148 L
.97619 .45148 L
Mfstroke
gsave
.97619 .034 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13307 m
.02795 .09033 L
.03209 .08827 L
.03623 .12481 L
.04037 .09367 L
.04451 .11397 L
.04865 .15534 L
.0528 .20701 L
.05694 .23242 L
.06108 .19932 L
.06522 .19092 L
.06936 .22218 L
.0735 .15627 L
.07764 .0799 L
.08178 .10704 L
.08592 .11 L
.09006 .10744 L
.0942 .18894 L
.09834 .2792 L
.10248 .30005 L
.10663 .21986 L
.11077 .11015 L
.11491 .08578 L
.11905 .07062 L
.12319 .08807 L
.12733 .09381 L
.13147 .1345 L
.13561 .33587 L
.13975 .4364 L
.14389 .22747 L
.14803 .01472 L
.15217 .03549 L
.15631 .07263 L
.16046 .07352 L
.1646 .09588 L
.16874 .1593 L
.17288 .30732 L
.17702 .3783 L
.18116 .25816 L
.1853 .12624 L
.18944 .07008 L
.19358 .05833 L
.19772 .10264 L
.20186 .12697 L
.206 .12563 L
.21014 .11049 L
.21429 .11143 L
.21843 .12988 L
.22257 .13714 L
.22671 .15793 L
Mistroke
.23085 .18006 L
.23499 .21425 L
.23913 .21887 L
.24327 .17745 L
.24741 .1637 L
.25155 .158 L
.25569 .12109 L
.25983 .09564 L
.26398 .12021 L
.26812 .1458 L
.27226 .14544 L
.2764 .15659 L
.28054 .16952 L
.28468 .17777 L
.28882 .17564 L
.29296 .20601 L
.2971 .22322 L
.30124 .17153 L
.30538 .12683 L
.30952 .12432 L
.31366 .13091 L
.31781 .12685 L
.32195 .13597 L
.32609 .14953 L
.33023 .16672 L
.33437 .18738 L
.33851 .21329 L
.34265 .22355 L
.34679 .21004 L
.35093 .19462 L
.35507 .17723 L
.35921 .12222 L
.36335 .07106 L
.36749 .07268 L
.37164 .12435 L
.37578 .25776 L
.37992 .38357 L
.38406 .32349 L
.3882 .1205 L
.39234 .04826 L
.39648 .0776 L
.40062 .06925 L
.40476 .08363 L
.4089 .10653 L
.41304 .14171 L
.41718 .21367 L
.42133 .2508 L
.42547 .28064 L
.42961 .28452 L
.43375 .15093 L
Mistroke
.43789 .04059 L
.44203 .09423 L
.44617 .14125 L
.45031 .1157 L
.45445 .09289 L
.45859 .09298 L
.46273 .12379 L
.46687 .18845 L
.47101 .26251 L
.47516 .30433 L
.4793 .24101 L
.48344 .12352 L
.48758 .07955 L
.49172 .09504 L
.49586 .1404 L
.5 .13639 L
.50414 .09592 L
.50828 .10608 L
.51242 .19416 L
.51656 .29938 L
.5207 .3651 L
.52484 .23486 L
.52899 .08293 L
.53313 .06304 L
.53727 .04956 L
.54141 .06316 L
.54555 .09934 L
.54969 .15206 L
.55383 .14336 L
.55797 .14491 L
.56211 .21581 L
.56625 .25607 L
.57039 .21408 L
.57453 .17628 L
.57867 .16719 L
.58282 .13701 L
.58696 .08378 L
.5911 .08158 L
.59524 .12335 L
.59938 .145 L
.60352 .15652 L
.60766 .21729 L
.6118 .29172 L
.61594 .25997 L
.62008 .16893 L
.62422 .11359 L
.62836 .0848 L
.63251 .08726 L
.63665 .13145 L
.64079 .13558 L
Mistroke
.64493 .12703 L
.64907 .13722 L
.65321 .1496 L
.65735 .20024 L
.66149 .23557 L
.66563 .23587 L
.66977 .18206 L
.67391 .15444 L
.67805 .14913 L
.68219 .12625 L
.68634 .09888 L
.69048 .08556 L
.69462 .12824 L
.69876 .14899 L
.7029 .17176 L
.70704 .24426 L
.71118 .25862 L
.71532 .27363 L
.71946 .20401 L
.7236 .07936 L
.72774 .06821 L
.73188 .08838 L
.73602 .11372 L
.74017 .12023 L
.74431 .1636 L
.74845 .17948 L
.75259 .14887 L
.75673 .13455 L
.76087 .10165 L
.76501 .05902 L
.76915 .02858 L
.77329 .01795 L
.77743 .02131 L
.78157 .02948 L
.78571 .03684 L
.78986 .04162 L
.794 .04354 L
.79814 .04263 L
.80228 .03957 L
.80642 .03573 L
.81056 .03261 L
.8147 .03106 L
.81884 .03108 L
.82298 .03209 L
.82712 .03341 L
.83126 .03451 L
.8354 .03512 L
.83954 .0352 L
.84369 .03487 L
.84783 .03437 L
Mistroke
.85197 .03391 L
.85611 .03362 L
.86025 .03355 L
.86439 .03365 L
.86853 .03383 L
.87267 .034 L
.87681 .03413 L
.88095 .03417 L
.88509 .03414 L
.88923 .03408 L
.89337 .03401 L
.89752 .03396 L
.90166 .03394 L
.9058 .03394 L
.90994 .03396 L
.91408 .03399 L
.91822 .03401 L
.92236 .03402 L
.9265 .03402 L
.93064 .03401 L
.93478 .034 L
.93892 .03399 L
.94306 .03399 L
.9472 .03399 L
.95135 .03399 L
.95549 .034 L
.95963 .034 L
.96377 .034 L
.96791 .034 L
.97205 .034 L
.97619 .034 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00703oool3000000@0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P00000L0?oo
o`<000000`3oool3000000@0oooo0P0000040?ooo`8000006`3oool3000000<0oooo0`0000030?oo
o`<00000103oool2000001`0oooo0`0000030?ooo`8000001@3oool2000000@0oooo0P00000L0?oo
o`<000000`3oool2000000@0oooo0`0000040?ooo`8000009@3oool001d0oooo00<000000?ooo`3o
ool00`3oool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3oool0
0`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06@3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo00@0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0280oooo000M0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01X0oooo00D000000?oo
o`3oool0oooo000000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`0I0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000
oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06P3oool00`00
0000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00`3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0280oooo000M0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo01X0oooo00<000000?ooo`3oool00P3oool3000000<0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000K0?ooo`030000003oool0oooo0080oooo0`0000060?oo
o`040000003oool0oooo00000080oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`02
0?ooo`@000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001`0oooo
00<000000?ooo`3oool00P3oool4000000D0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0R0?ooo`007@3oool00`000000oooo0?ooo`050?ooo`030000003oool0000000<00000
0`3oool010000000oooo0?ooo`00000L0?ooo`050000003oool0oooo0?ooo`0000000`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06@3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`0000030?ooo`040000
003oool0oooo000001`0oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo00000003000000<0oooo00@000000?ooo`3oool0
0000903oool001`0oooo0P0000030?ooo`070000003oool0oooo0?ooo`000000oooo000000060?oo
o`040000003oool0oooo000001/0oooo0P0000030?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001X0oooo0P0000030?ooo`07
0000003oool0oooo0?ooo`000000oooo000000060?ooo`040000003oool0oooo000001/0oooo0P00
00030?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000001/0oooo0P0000030?ooo`070000003oool0oooo0?ooo`000000oooo0000
00060?ooo`040000003oool0oooo000002@0oooo000M0?ooo`040000003oool0oooo0?ooo`D00000
00<0oooo0000000000000`0000030?ooo`8000007@3oool00`000000oooo0?ooo`020?ooo`<00000
103oool2000000@0oooo0P00000L0?ooo`030000003oool0oooo0080oooo0`0000020?ooo`D00000
0`3oool2000001d0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P0000040?ooo`800000
7@3oool00`000000oooo0?ooo`020?ooo`<000000P3oool5000000<0oooo0P00000U0?ooo`00o`3o
oolJ0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`00803oooo]000000`0oooo
000P0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?oo
o`0]0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?oo
o`0O0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo0>T0oooo00<00000
0?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0803oool00`3o0000oooo0?ooo`360?oo
o`030000003oool0oooo00X0oooo000P0?ooo`8000008@3oool00`3o0000oooo0?ooo`2A0?ooo`03
0?l0003oool0oooo0340oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`0P0?ooo`030?l0
003oool0oooo0940oooo0P3o000c0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003o
ool0oooo0200oooo0P3o002A0?ooo`030?l0003oool0o`0003<0oooo00<000000?ooo`3oool02P3o
ool00200oooo00<000000?ooo`3oool0803oool20?l00940oooo00@0o`000?ooo`3oool0o`001@3o
ool50?l002P0oooo00<000000?ooo`3oool02P3oool00200oooo0P00000Q0?ooo`80o`00T@3oool0
1@3o0000oooo0?ooo`3oool0o`0000@0oooo00<0o`000?ooo`3oool00P3ooolT0?l000<0oooo0P00
000<0?ooo`00803oool00`000000oooo0?ooo`0P0?ooo`80o`00@P3oool00`3o0000oooo0?ooo`1<
0?ooo`030?l0003oool0oooo0080oooo00@0o`000?ooo`3oool0o`00;@3oool00`000000oooo0?oo
o`0:0?ooo`004P3oool3000000@0oooo0P0000050?ooo`030000003oool0oooo0200oooo0P3o0012
0?ooo`030?l0003oool0oooo04`0oooo00<0o`000?ooo`3oool00`3oool20?l002h0oooo00<00000
0?ooo`3oool02P3oool00140oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool0803oool20?l003P0oooo00<0o`000?ooo`3oool01`3o
ool00`3o0000oooo0?ooo`0E0?ooo`030?l0003oool0oooo03<0oooo00<0o`000?ooo`3oool0=03o
ool00`000000oooo0?ooo`0:0?ooo`002`3oool5000000D0oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0200oooo0P3o000h0?ooo`030?l0003o
ool0oooo00L0oooo00<0o`000?ooo`3oool05@3oool00`3o0000oooo0?ooo`0c0?ooo`030?l0003o
ool0oooo03@0oooo00<000000?ooo`3oool02P3oool001D0oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`020?ooo`<00000803oool00`3o0000oooo0?l000080?ooo`030?l0003o
ool0oooo02`0oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?ooo`0D0?ooo`030?l0003o
ool0o`0003@0oooo00<0o`000?ooo`3oool0<`3oool2000000`0oooo000A0?ooo`@000000`3oool0
10000000oooo0?ooo`0000040?ooo`030000003oool0oooo0200oooo00<0o`000?ooo`3o0000203o
ool00`3o0000oooo0?ooo`0/0?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3oool0503o
ool00`3o0000oooo0?l0000d0?ooo`030?l0003oool0oooo03@0oooo00<000000?ooo`3oool02P3o
ool00140oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo0200oooo00<0o`000?ooo`3o00001`3oool20?l002h0oooo0P3o00080?ooo`030?l0003o
ool0oooo01@0oooo00<0o`000?ooo`3o0000=03oool00`3o0000oooo0?ooo`0d0?ooo`030000003o
ool0oooo00X0oooo000A0?ooo`D000000`3oool2000000D0oooo00<000000?ooo`3oool06@3oool0
0`3o0000oooo0?ooo`040?ooo`030?l0003oool0o`0000L0oooo0P3o000W0?ooo`030?l0003oool0
oooo00@0oooo0`3o00070?ooo`80o`005@3oool00`3o0000oooo0?l0000[0?ooo`030?l0003oool0
oooo00H0oooo00<0o`000?ooo`3oool0=03oool00`000000oooo0?ooo`0:0?ooo`00803oool20000
01X0oooo00<0o`000?ooo`3oool0103oool0103o0000oooo0?l0003o00060?ooo`80o`009`3oool2
0?l000D0oooo0`3o00070?ooo`80o`00503oool0103o0000oooo0?ooo`3o000[0?ooo`030?l0003o
ool0oooo00H0oooo00<0o`000?ooo`3oool0<`3oool2000000`0oooo000P0?ooo`030000003oool0
oooo00l0oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?ooo`040?ooo`040?l0003oool0
oooo0?l000H0oooo0P3o000W0?ooo`80o`001@3oool20?l000030?ooo`3o0000oooo00D0oooo0P3o
000:0?ooo`030?l0003oool0oooo00L0oooo00@0o`000?ooo`3oool0o`00:P3oool20?l000P0oooo
00<0o`000?ooo`3oool0=03oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?oo
o`0?0?ooo`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3o00001@3oool0103o0000oooo0?oo
o`3o00060?ooo`030?l0003oool0o`0002H0oooo0P3o00050?ooo`040?l0003oool0oooo0?l000H0
oooo0P3o000:0?ooo`030?l0003oool0oooo00L0oooo00D0o`000?ooo`3oool0oooo0?l000090?oo
o`80o`007P3oool00`3o0000oooo0?l000070?ooo`030?l0003oool0oooo03@0oooo00<000000?oo
o`3oool02P3oool00200oooo00<000000?ooo`3oool01@3oool00`3o0000oooo0?ooo`070?ooo`03
0?l0003oool0oooo00H0oooo00<0o`000?ooo`3o00001@3oool01@3o0000oooo0?ooo`3oool0o`00
00D0oooo00<0o`000?ooo`3o00009P3oool20?l000@0oooo00D0o`000?ooo`3oool0oooo0?l00006
0?ooo`80o`002P3oool00`3o0000oooo0?ooo`070?ooo`050?l0003oool0oooo0?ooo`3o00002@3o
ool20?l000L0oooo0P3o000=0?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3o00001P3o
ool00`3o0000oooo0?ooo`0e0?ooo`030000003oool0oooo00X0oooo000P0?ooo`8000001@3oool2
0?l000T0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?l000050?ooo`050?l0003oool0
oooo0?ooo`3o00001@3oool00`3o0000oooo0?l0000V0?ooo`80o`00103oool01@3o0000oooo0?oo
o`3oool0o`0000H0oooo0P3o000:0?ooo`80o`00203oool01@3o0000oooo0?ooo`3oool0o`0000T0
oooo0P3o00070?ooo`80o`003@3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0o`0000H0
oooo00<0o`000?ooo`3oool0=03oool2000000`0oooo000P0?ooo`030000003oool0oooo00@0oooo
0P3o00000`3oool0o`000?ooo`060?ooo`80o`001`3oool0103o0000oooo0?ooo`3o00040?ooo`05
0?l0003oool0oooo0?ooo`3o00001@3oool00`3o0000oooo0?l0000=0?ooo`030?l0003oool0oooo
01H0oooo0P3o00040?ooo`050?l0003oool0oooo0?ooo`3o00001P3oool20?l00080oooo0P3o0006
0?ooo`80o`000P3oool00`3o0000oooo0?ooo`030?ooo`050?l0003oool0oooo0?ooo`3o00002@3o
ool20?l000L0oooo0P3o000<0?ooo`80o`001`3oool00`3o0000oooo0?l000060?ooo`030?l0003o
ool0oooo03D0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0103oool2
0?l000030?ooo`3o0000oooo00H0oooo0P3o00070?ooo`040?l0003oool0oooo0?l000@0oooo00D0
o`000?ooo`3oool0oooo0?l000040?ooo`040?l0003oool0oooo0?l000d0oooo00<0o`000?ooo`3o
ool05@3oool00`3o0000oooo0?l000040?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3o
ool00P3oool00`3o0000oooo0?l000020?ooo`80o`001P3oool20?l00080oooo00<0o`000?ooo`3o
ool00`3oool01@3o0000oooo0?ooo`3oool0o`0000T0oooo0P3o00070?ooo`80o`00303oool20?l0
00L0oooo00<0o`000?ooo`3o00001P3oool00`3o0000oooo0?ooo`0e0?ooo`030000003oool0oooo
00X0oooo000P0?ooo`030000003oool0oooo00@0oooo0P3o00000`3oool0o`000?ooo`060?ooo`80
o`001P3oool01@3o0000oooo0?ooo`3oool0o`0000@0oooo00D0o`000?ooo`3oool0oooo0?l00004
0?ooo`040?l0003oool0oooo0?l000d0oooo00<0o`000?ooo`3oool05@3oool0103o0000oooo0?oo
o`3o00030?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo
0?l000020?ooo`80o`001@3oool00`3o0000oooo0?l000020?ooo`80o`00103oool01@3o0000oooo
0?ooo`3oool0o`0000T0oooo0P3o00060?ooo`030?l0003oool0o`0000`0oooo0P3o00070?ooo`04
0?l0003oool0oooo0?l000D0oooo00<0o`000?ooo`3oool0=@3oool00`000000oooo0?ooo`0:0?oo
o`00803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0o`000080o`001P3oool20?l00003
0?ooo`3o0000oooo00<0oooo00D0o`000?ooo`3oool0oooo0?l000040?ooo`050?l0003oool0oooo
0?ooo`3o0000103oool0103o0000oooo0?ooo`3o000=0?ooo`030?l0003oool0oooo01D0oooo00@0
o`000?ooo`3oool0o`000`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo0080oooo
00L0o`000?ooo`3o0000oooo0?l0003oool0o`0000D0oooo00<0o`000?ooo`3o00000P3oool20?l0
00@0oooo00D0o`000?ooo`3oool0oooo0?l000090?ooo`030?l0003oool0o`0000D0oooo00<0o`00
0?ooo`3o0000303oool20?l000L0oooo00@0o`000?ooo`3oool0o`001@3oool00`3o0000oooo0?oo
o`0e0?ooo`030000003oool0oooo00X0oooo000P0?ooo`8000001@3oool01@3o0000oooo0?l0003o
ool0o`0000H0oooo00@0o`000?ooo`3o0000o`00103oool01@3o0000oooo0?ooo`3oool0o`0000@0
oooo00D0o`00003jVP3oool0oooo0?l000040?ooo`040?l0003oool0oooo0?l00080oooo0P3o0008
0?ooo`030?l0003oool0o`0001H0oooo00@0o`000?ooo`3oool0o`000`3oool00`3o0000oooo0?oo
o`020?ooo`030?l0003oool0oooo0080oooo00D0o`000?ooo`3o0000oooo0?l000020?ooo`030?l0
003oool0oooo0080oooo00<0o`000?ooo`3o00000P3oool20?l000@0oooo00D0o`000?ooo`3oool0
oooo0?l000080?ooo`040?l0003oool0oooo0?l000D0oooo00@0o`000?ooo`3oool0o`002`3oool0
0`3o0000oooo0?l000060?ooo`040?l0003oool0oooo0?l000D0oooo00<0o`000?ooo`3oool0=03o
ool2000000`0oooo000P0?ooo`030000003oool0oooo00<0oooo00H0o`000?ooo`3oool0o`000?oo
o`3o00060?ooo`040?l0003oool0oooo0?l000@0oooo00<0o`000?ooo`3oool00P3oool01P3o0000
oooo0?ooo`3oool0o`00003jVP80oooo00<0o`000?ooo`3oool00P3oool0103o0000oooo0?ooo`3o
00020?ooo`80o`00203oool00`3o0000oooo0?l0000F0?ooo`040?l0003oool0oooo0?l000<0oooo
00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`020?ooo`050?l0003oool0o`000?ooo`3o
00000P3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0o`000080oooo0P3o00040?ooo`05
0?l0003oool0oooo0?ooo`3o0000203oool0103o0000oooo0?ooo`3o00050?ooo`040?l0003oool0
oooo0?l000X0oooo00@0o`000?ooo`3oool0o`001P3oool0103o0000oooo0?ooo`3o00050?ooo`03
0?l0003oool0oooo03D0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0
0`3oool01P3o0000oooo0?ooo`3o0000oooo0?l000D0oooo00D0o`000?ooo`3oool0oooo0?l00004
0?ooo`030?l0003oool0oooo0080oooo00H0o`000?ooo`3oool0oooo0?l00000nYX20?ooo`030?l0
003oool0oooo0080oooo00@0o`000?ooo`3oool0oooo0P3o00000`3oool0o`000?ooo`070?ooo`03
0?l0003oool0o`0001H0oooo00@0o`000?ooo`3oool0o`000`3oool00`3o0000oooo0?ooo`020?oo
o`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00P3o00020?ooo`030?l0003oool0oooo
0080oooo00<0o`000?ooo`3oool00P3o00000`3oool0o`000?ooo`030?ooo`050?l0003oool0oooo
0?ooo`3o0000203oool0103o0000oooo0?ooo`3o00050?ooo`040?l0003oool0oooo0?l000X0oooo
00@0o`000?ooo`3oool0o`001P3oool01@3o0000oooo0?ooo`3oool0o`0000<0oooo00<0o`000?oo
o`3oool0=P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`030?ooo`06
0?l0003oool0oooo0?l0003oool0o`001@3oool01@3o0000oooo0?ooo`3oool0o`0000@0oooo00<0
o`000?ooo`3oool00P3oool0103o0000oooo0?ooo`3o0002003jVP80oooo00<0o`000?ooo`3oool0
0P3oool0103o0000oooo0?ooo`3oool20?l00080oooo00<0o`000?ooo`3oool01@3oool00`3o0000
oooo0?l0000:0?ooo`030?l0003oool0oooo00T0oooo00@0o`000?ooo`3oool0o`000`3oool00`3o
0000oooo0?ooo`020?ooo`030?l0003oool0oooo0080oooo00<0o`00003jVP3oool00P3o00020?oo
o`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00P3o00000`3oool0o`000?ooo`030?oo
o`050?l0003oool0oooo0?ooo`3o0000203oool0103o0000oooo0?ooo`3o00050?ooo`040?l0003o
ool0oooo0?l000X0oooo00@0o`000?ooo`3oool0o`001P3oool01@3o0000oooo0?ooo`3oool0o`00
00<0oooo00<0o`000?ooo`3oool0=P3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000@0
oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`030?ooo`050?l0003oool0oooo0?oo
o`3o0000103oool00`3o0000oooo0?ooo`020?ooo`040?l0003oool0oooo0?l000800?ZJ0`3oool0
1@3o0000oooo0?ooo`3oool0o`0000<0oooo00D0o`000?ooo`3oool0oooo0?l000070?ooo`030?l0
003oool0o`0000T0oooo00@0o`000?ooo`3o0000o`002@3oool0103o0000oooo0?ooo`3o00030?oo
o`030?l0003oool0oooo00<0oooo00L0o`000?ooo`3oool0oooo0?l00000nYX0oooo0080o`000P3o
ool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo0080o`0000<0oooo0?l0003oool00`3o
ool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00D0oooo00@0o`000?ooo`3oool0o`00
1@3oool01P3o0000oooo0?ooo`3o0000oooo0?l000P0oooo00@0o`000?ooo`3oool0o`001P3oool0
1@3o0000oooo0?ooo`3oool0o`0000<0oooo00<0o`000?ooo`3oool0=@3oool2000000`0oooo000P
0?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`03
0?ooo`050?l0003oool0oooo0?ooo`3o0000103oool00`3o0000oooo0?ooo`020?ooo`040?l0003o
ool0oooo0?l000800?ZJ0`3oool01@3o0000oooo0?ooo`3oool0o`0000L0oooo00<0o`000?ooo`3o
ool01@3oool00`3o0000oooo0?l000090?ooo`040?l0003oool0oooo0?l000T0oooo00@0o`000?oo
o`3oool0o`000`3oool00`3o00000?ZJ0?ooo`030?ooo`080?l0003oool0oooo0?ooo`3o00000?ZJ
0?ooo`3o00030?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00P3o00000`3oool0
o`000?ooo`030?ooo`030?l0003oool00?ZJ0080oooo00<0o`000?ooo`3oool01@3oool0103o0000
oooo0?ooo`3o00050?ooo`060?l0003oool0oooo0?l0003oool0o`00203oool0103o0000oooo0?oo
o`3o00060?ooo`050?l0003oool0oooo0?ooo`3o00000`3oool00`3o0000oooo0?ooo`0f0?ooo`03
0000003oool0oooo00X0oooo000A0?ooo`D000000P3oool3000000D0oooo00<000000?ooo`3oool0
2@3oool00`3o0000oooo0?ooo`020?ooo`050?l0003oool0oooo0?ooo`3o0000103oool00`3o0000
oooo0?ooo`020?ooo`040?l0003oool0oooo0?l000800?ZJ0`3oool01@3o0000oooo0?ooo`3oool0
o`0000P0oooo00<0o`000?ooo`3oool0103oool0103o0000oooo0?ooo`3o00080?ooo`050?l0003o
ool0oooo0?ooo`3o0000203oool0103o0000oooo0?ooo`3o00030?ooo`030?l00000nYX0oooo00<0
oooo00P0o`000?ooo`3oool0oooo0?l00000nYX0oooo0?l000<0oooo00<0o`000?ooo`3oool00P3o
ool00`3o0000oooo0?ooo`020?l000030?ooo`3o0000oooo00<0oooo00<0o`000?ooo`00nYX00P3o
ool00`3o0000oooo0?ooo`050?ooo`050?l0003oool0oooo0?ooo`3o0000103oool01`3o0000oooo
0?ooo`3oool0o`000?ooo`3o00001`3oool0103o0000oooo0?ooo`3o00060?ooo`050?l0003oool0
oooo0?ooo`3o00000`3oool00`3o0000oooo0?ooo`0f0?ooo`030000003oool0oooo00X0oooo000B
0?ooo`060000003oool0oooo0000003oool000000`3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00T0oooo00<0o`000?ooo`3oool00P3oool01@3o0000oooo0?ooo`3oool0o`0000@0
oooo00<0o`000?ooo`3oool00P3oool01`3o0000oooo0?ooo`3o00000?ZJ0?ooo`00nYX00P3oool0
1`3o0000oooo0?ooo`3oool0o`000?ooo`00nYX01P3oool00`3o0000oooo0?ooo`030?ooo`050?l0
003oool0oooo0?ooo`3o0000203oool01@3o0000oooo0?ooo`3oool0o`0000P0oooo00@0o`000?oo
o`3oool0o`000`3oool00`3o00000?ZJ0?ooo`030?ooo`080?l0003oool0oooo0?ooo`3o00000?ZJ
0?ooo`3o00030?ooo`030?l0003oool0oooo0080oooo00@0o`000?ooo`3oool0o`000P3oool00`3o
0000oooo0?ooo`020?ooo`050?l00000nYX0oooo003jVP3oool00P3o00060?ooo`050?l0003oool0
oooo0?ooo`3o00000`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00@0oooo00<0
o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`030?ooo`050?l0003oool0oooo0?ooo`3o0000
0`3oool00`3o0000oooo0?ooo`0f0?ooo`030000003oool0oooo00X0oooo000;0?ooo`D000000`3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool02@3o
ool00`3o0000oooo0?ooo`020?ooo`050?l0003oool0oooo0?ooo`3o0000103oool00`3o0000oooo
0?ooo`020?ooo`070?l0003oool0oooo0?l00000nYX0oooo003jVP020?ooo`070?l0003oool0oooo
0?ooo`3o0000oooo003jVP060?ooo`030?l0003oool0oooo00<0oooo00@0o`000?ooo`3oool0oooo
0P3o00070?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool01@3oool0103o0000oooo
0?ooo`3o00030?ooo`030?l00000nYX0oooo00<0oooo00H0o`000?ooo`3oool0oooo0?l00000nYX5
0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`02
0?ooo`050?l00000nYX0oooo003jVP3oool00`3o00050?ooo`050?l0003oool0oooo0?ooo`3o0000
0`3oool00`3o0000oooo0?ooo`050?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool0
0P3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3o0000
>@3oool00`000000oooo0?ooo`0:0?ooo`00503oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0080oooo0`0000090?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00P3o
ool01@3o0000oooo0?ooo`3oool0o`0000@0oooo00L0o`000?ooo`3oool0o`00003jVP3oool00?ZJ
0080oooo00D0o`000?ooo`3oool0oooo0?l00002003jVPL0oooo00<0o`000?ooo`3oool00P3oool0
0`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool00P3oool0
0`3o0000oooo0?ooo`040?ooo`050?l0003oool0oooo0?ooo`3o00000`3oool00`3o00000?ZJ003j
VP030?ooo`060?l0003oool0oooo0?ooo`3o00000?ZJ1@3oool00`3o0000oooo0?ooo`020?ooo`03
0?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool00P3oool0203o00000?ZJ0?ooo`00nYX0oooo
0?l0003oool0o`001@3oool01@3o0000oooo0?ooo`3oool0o`0000<0oooo00<0o`000?ooo`3oool0
1@3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool0
0P3oool00`3o0000oooo003jVP030?ooo`030?l0003oool0o`0003P0oooo0P00000<0?ooo`004@3o
ool01P000000oooo0?ooo`3oool000000?ooo`@000001@3oool00`000000oooo0?ooo`090?ooo`03
0?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00P3oool01`3o0000oooo0?ooo`3oool0o`00
0?ooo`00nYX00P3oool01`3o0000oooo0?ooo`3o00000?ZJ0?ooo`00nYX00P3oool01@3o0000oooo
0?ooo`3oool0o`0000800?ZJ1`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00<0
oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo00@0
oooo00D0o`000?ooo`00nYX00?ZJ0?l000030?ooo`040?l00000nYX00?ZJ003jVP80oooo00D0o`00
0?ooo`3oool0oooo0?l00002003jVP@0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?oo
o`040?ooo`080?l0003oool0oooo0?ooo`3o00000?ZJ0?ooo`00nYX30?ooo`030?l0003oool0oooo
0080oooo00<0o`000?ooo`3oool00`3oool0103o0000oooo0?ooo`3o00070?ooo`030?l0003oool0
oooo0080oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0
0?ZJ00<0oooo00<0o`000?ooo`3o0000>@3oool00`000000oooo0?ooo`0:0?ooo`004@3oool01`00
0000oooo0?ooo`3oool000000?ooo`000000203oool00`000000oooo0?ooo`090?ooo`030?l0003o
ool0oooo0080oooo00<0o`000?ooo`3oool00P3oool01`3o0000oooo0?ooo`3oool0o`000?ooo`00
nYX00P3oool01@3o0000oooo0?ooo`3o00000?ZJ0080oooo00<00?ZJ0?ooo`3o00000`3oool00`3o
00000?ZJ003jVP070?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00`3oool00`3o
0000oooo0?ooo`030?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool0103oool01@3o
0000oooo003jVP00nYX0o`0000<0oooo00@0o`00003jVP00nYX00?ZJ0P3oool01@3o0000oooo0?oo
o`3oool0o`0000800?ZJ1@3oool01@3o0000oooo0?ooo`3oool0o`0000H0oooo00D0o`000?ooo`3o
ool0oooo0?l000020?ooo`05003jVP3oool0oooo0?ooo`3o0000103oool00`3o0000oooo0?ooo`03
0?ooo`040?l0003oool0oooo0?l000L0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?oo
o`030?ooo`030?l0003oool0oooo0080oooo00<0o`00003jVP00nYX00`3oool00`3o0000oooo0?l0
000i0?ooo`030000003oool0oooo00X0oooo000B0?ooo`<000000P3oool5000000@0oooo00<00000
0?ooo`3oool02@3oool00`3o0000oooo0?ooo`020?ooo`030?l00000nYX0oooo0080oooo00L0o`00
0?ooo`3oool0oooo0?l0003oool00?ZJ0080oooo00D0o`000?ooo`3oool0o`00003jVP020?ooo`03
003jVP3oool0o`0000<0oooo00<0o`00003jVP00nYX01`3oool01@3o0000oooo0?ooo`3oool0o`00
00H0oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo
00<0oooo00D0o`000?ooo`00nYX00?ZJ0?l000030?ooo`070?l00000nYX00?ZJ0?ooo`00nYX0oooo
0?l000030?ooo`030?l00000nYX00?ZJ00D0oooo00H0o`000?ooo`3oool0oooo0?l00000nYX50?oo
o`050?l0003oool0oooo0?l00000nYX00P3oool01@00nYX0oooo0?ooo`3oool0o`0000@0oooo00<0
o`000?ooo`3oool00`3oool0103o0000oooo0?ooo`3o00070?ooo`030?l0003oool0oooo0080oooo
00<0o`000?ooo`3oool0103oool0203o0000oooo0?ooo`3oool0o`00003jVP3oool00?ZJ0P3oool0
0`3o0000oooo0?l0000i0?ooo`030000003oool0oooo00X0oooo000P0?ooo`8000002P3oool00`3o
0000oooo0?ooo`020?ooo`030?l00000nYX0oooo0080oooo00X0o`000?ooo`3oool0oooo0?l00000
nYX0oooo003jVP3oool0o`000P3oool01`3o00000?ZJ0?ooo`3oool00?ZJ0?ooo`3o00000`3oool0
103o00000?ZJ0?ooo`00nYX60?ooo`050?l0003oool0oooo0?ooo`3o00001`3oool00`3o0000oooo
0?ooo`020?ooo`030?l0003oool0oooo00@0oooo00<0o`000?ooo`3oool00`3oool01@3o0000oooo
003jVP00nYX0o`0000<0oooo00L0o`00003jVP3oool0oooo003jVP3oool0o`0000<0oooo00<0o`00
003jVP00nYX01@3oool01P3o0000oooo0?ooo`3oool0o`00003jVPD0oooo00D0o`000?ooo`3oool0
o`00003jVP030?ooo`04003jVP3oool0oooo0?l000@0oooo00@0o`000?ooo`00nYX00?ZJ0P3oool0
1P3o0000oooo0?ooo`3o0000oooo003jVPD0oooo00<0o`000?ooo`3oool00P3oool01@3o0000oooo
0?ooo`3oool00?ZJ0080oooo00P0o`000?ooo`3oool0oooo0?l00000nYX0oooo003jVP80oooo0P3o
000i0?ooo`800000303oool00200oooo00<000000?ooo`3oool01@3oool01@00nYX0oooo0?ooo`3o
ool0o`0000@0oooo00<0o`00003jVP3oool00P3oool02P3o0000oooo0?ooo`3o0000oooo003jVP3o
ool00?ZJ0?ooo`3o00020?ooo`030?l00000nYX0oooo0080oooo00<00?ZJ0?l0003oool00P3oool0
103o00000?ZJ0?ooo`00nYX70?ooo`030?l0003oool0o`0000P0oooo00<0o`000?ooo`3oool00P3o
ool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00<0oooo00D0o`000?ooo`00nYX00?ZJ
0?l000030?ooo`070?l0003oool0oooo0?ooo`00nYX0oooo0?l000030?ooo`030?l00000nYX00?ZJ
00D0oooo00H0o`000?ooo`3oool0oooo0?l00000nYX50?ooo`050?l0003oool0oooo0?l00000nYX0
0`3oool01000nYX0oooo0?ooo`3o00040?ooo`040?l0003oool00?ZJ003jVP80oooo00D0o`000?oo
o`3oool0o`000?ooo`02003jVP@0oooo00D0o`000?ooo`3oool0oooo0?l000040?ooo`04003jVP3o
ool0oooo0?l000<0oooo00@0o`00003jVP3oool00?ZJ0P3oool20?l003X0oooo00<000000?ooo`3o
ool02P3oool00200oooo00<000000?ooo`3oool0103oool2003jVP040?ooo`00nYX0oooo0?l000@0
oooo00<0o`00003jVP3oool00P3oool01P3o0000oooo0?ooo`3o0000oooo003jVP80oooo00H00?ZJ
0?l0003oool0oooo0?l00000nYX30?ooo`03003jVP3o0000oooo0080oooo00@0o`00003jVP3oool0
0?ZJ1`3oool00`3o0000oooo0?l000080?ooo`030?l0003oool0o`000080oooo00<0o`000?ooo`3o
ool0103oool00`3o0000oooo0?ooo`030?ooo`050?l0003oool00?ZJ003jVP3o00000`3oool01`3o
0000oooo0?ooo`3oool00?ZJ0?ooo`3o00000`3oool00`3o00000?ZJ003jVP020?ooo`800?ZJ00<0
oooo0?l0003oool00P3oool00`3o00000?ZJ003jVP040?ooo`050?l0003oool0oooo0?l00000nYX0
0`3oool01000nYX0oooo0?ooo`3o00030?ooo`030?l0003oool0oooo00800?ZJ0P3oool01@3o0000
oooo0?ooo`3o0000oooo00800?ZJ103oool01@3o0000oooo0?ooo`3oool0o`0000@0oooo00@00?ZJ
0?ooo`3oool0o`000`3oool0103o00000?ZJ0?ooo`00nYX30?ooo`030?l0003oool0oooo03P0oooo
00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0103oool2003jVP040?ooo`00
nYX0oooo0?l000@0oooo00<0o`00003jVP00nYX00P3oool01P3o0000oooo0?ooo`3o0000oooo003j
VP80oooo00@00?ZJ0?l0003oool0oooo0P3o00030?ooo`03003jVP3o0000oooo0080oooo00@0o`00
003jVP3oool00?ZJ1`3oool00`3o0000oooo0?l000030?ooo`03003jVP3oool0oooo00<0oooo0P3o
00020?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool00P3oool01@3o0000oooo003j
VP00nYX0o`0000<0oooo00<0o`000?ooo`3oool00P3oool00`00nYX0oooo0?l000020?ooo`030?l0
0000nYX00?ZJ0080oooo0P00nYX00`3oool0o`000?ooo`020?ooo`030?l00000nYX00?ZJ0080oooo
00<00?ZJ0?ooo`3o00000P3oool00`3o00000?ZJ0?ooo`020?ooo`04003jVP3oool0oooo0?l000<0
oooo00<0o`000?ooo`3oool00P00nYX20?ooo`050?l0003oool0oooo0?l0003oool00P00nYX50?oo
o`040?l0003oool0oooo0?l000<0oooo0P00nYX20?ooo`080?l0003oool0oooo0?ooo`3o00000?ZJ
0?ooo`00nYX30?ooo`030?l0003oool0oooo03P0oooo00<000000?ooo`3oool02P3oool00200oooo
00<000000?ooo`3oool0103oool2003jVP050?ooo`00nYX0oooo0?ooo`3o00000`3oool00`3o0000
0?ZJ003jVP020?ooo`050?l0003oool0oooo0?l00000nYX00`3oool01000nYX0o`000?ooo`3oool2
0?l000<0oooo00<00?ZJ0?l0003oool00P3oool0103o0000oooo0?ooo`00nYX70?ooo`030?l0003o
ool0o`0000<0oooo00<00?ZJ0?ooo`3oool0103oool0103o0000oooo0?ooo`3o00070?ooo`030?l0
003oool0oooo0080oooo00D0o`00003jVP3oool0oooo0?l000030?ooo`030?l0003oool0oooo0080
oooo00<00?ZJ0?ooo`3o00000P3oool00`3o0000oooo003jVP020?ooo`800?ZJ00H0oooo0?l0003o
ool0oooo0?l0003oool2003jVP80oooo00<00?ZJ0?ooo`3o00000P3oool00`3o00000?ZJ0?ooo`02
0?ooo`05003jVP3oool0oooo0?ooo`3o00000P3oool00`3o0000oooo0?ooo`02003jVP80oooo00L0
o`000?ooo`3oool0o`00003jVP3oool00?ZJ00D0oooo00@0o`000?ooo`3oool0o`000`3oool2003j
VP80oooo00P0o`000?ooo`3oool0oooo0?l00000nYX0oooo003jVSh0oooo00<000000?ooo`3oool0
2P3oool00200oooo0P0000050?ooo`800?ZJ00D0oooo003jVP00nYX0oooo0?l000030?ooo`030?l0
0000nYX00?ZJ0080oooo00D0o`000?ooo`3oool0o`00003jVP030?ooo`04003jVP3o0000oooo0?oo
o`80o`000`3oool00`00nYX0o`000?ooo`020?ooo`040?l0003oool0oooo003jVPL0oooo00<0o`00
0?ooo`3o00000`3oool00`00nYX0oooo0?ooo`040?ooo`040?l0003oool0oooo0?l000L0oooo00L0
o`000?ooo`3oool0oooo0?l0003oool00?ZJ0080oooo00D0o`000?ooo`3oool0oooo0?l000040?oo
o`03003jVP3oool0o`000080oooo00<0o`000?ooo`00nYX00P3oool2003jVP080?ooo`3o0000oooo
0?ooo`3o00000?ZJ0?ooo`00nYX20?ooo`800?ZJ00D0o`000?ooo`3oool0o`00003jVP030?ooo`05
003jVP3oool0oooo0?ooo`3o00000P3oool0203o0000oooo0?ooo`00nYX0oooo003jVP3oool0o`00
0P3oool0103o00000?ZJ0?ooo`00nYX50?ooo`040?l0003oool0oooo0?l000<0oooo0P00nYX20?oo
o`060?l0003oool0oooo0?ooo`3o00000?ZJ0P3oool00`00nYX0oooo0?ooo`0j0?ooo`800000303o
ool00200oooo00<000000?ooo`3oool0103oool00`00nYX0oooo003jVP02003jVP030?ooo`3o0000
oooo0080o`0000<0oooo003jVP00nYX00P00nYX01@3o0000oooo0?ooo`3o00000?ZJ00<0oooo00@0
0?ZJ0?l0003oool0oooo0`3o00020?ooo`03003jVP3o0000oooo0080oooo00@0o`000?ooo`3oool0
0?ZJ0P3oool00`00nYX0oooo0?ooo`020?ooo`030?l0003oool0o`0000<0oooo00<00?ZJ0?ooo`3o
ool01@3oool00`3o0000oooo0?l000070?ooo`070?l0003oool0oooo0?ooo`3o0000oooo003jVP02
0?ooo`05003jVP3o0000oooo0?ooo`3o0000103oool00`00nYX0oooo0?l000020?ooo`090?l0003o
ool00?ZJ0?ooo`00nYX0oooo003jVP3oool0o`000080oooo00@0o`00003jVP3oool00?ZJ0P3oool2
003jVP050?l0003oool0oooo0?l00000nYX00`3oool01@00nYX0oooo0?ooo`3oool0o`000080oooo
00H0o`000?ooo`3oool00?ZJ0?ooo`00nYX20?ooo`060?l0003oool0o`00003jVP3oool00?ZJ1@3o
ool0103o0000oooo0?ooo`3o00030?ooo`05003jVP3oool00?ZJ0?ooo`3o00000`3oool01@3o0000
0?ZJ0?ooo`3oool00?ZJ03d0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3o
ool0103oool02000nYX0oooo003jVP3oool00?ZJ0?ooo`3o0000oooo0P3o00001P3oool00?ZJ0?oo
o`3oool00?ZJ0?l00080oooo00<0o`00003jVP3oool00P3oool01000nYX0o`000?ooo`3oool30?l0
0080oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX20?ooo`03003jVP3oool0oooo00800?ZJ0`3o
ool00`3o0000oooo0?l000020?ooo`03003jVP3oool00?ZJ00H0oooo00<0o`000?ooo`3o00001`3o
ool01`3o0000oooo0?ooo`3oool0o`000?ooo`00nYX00P3oool01@00nYX0o`000?ooo`3oool0o`00
00@0oooo00<00?ZJ0?ooo`3o00000P3oool01@3o0000oooo003jVP3oool00?ZJ0080oooo00P00?ZJ
0?l0003oool0oooo0?l00000nYX0oooo003jVP80oooo0P00nYX01@3o0000oooo0?ooo`3o00000?ZJ
00<0oooo00L00?ZJ0?ooo`3oool0oooo0?l0003oool0o`000080oooo00@00?ZJ0?ooo`3oool00?ZJ
0P3oool0103o0000oooo0?l00000nYX20?ooo`03003jVP3oool0oooo0080oooo00@0o`000?ooo`3o
ool0o`000`3oool01@00nYX0oooo003jVP3oool0o`0000<0oooo00D0o`00003jVP3oool0oooo003j
VP0m0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00@0oooo00H00?ZJ
0?ooo`00nYX0oooo003jVP3oool40?l000060?ooo`00nYX0oooo0?ooo`00nYX0o`000P3oool00`3o
00000?ZJ0?ooo`030?ooo`030?l0003oool0oooo00<0o`000P3oool01P00nYX0o`000?ooo`3oool0
o`00003jVP<0oooo00@00?ZJ0?ooo`00nYX00?ZJ103oool20?l00080oooo00<00?ZJ0?ooo`00nYX0
1P3oool20?l000P0oooo00L0o`000?ooo`3oool0oooo0?l0003oool00?ZJ0080oooo00D00?ZJ0?l0
003oool0oooo0?l000040?ooo`03003jVP3oool0o`000080oooo00D0o`000?ooo`00nYX0oooo003j
VP020?ooo`0=003jVP3o0000oooo0?ooo`3o00000?ZJ0?ooo`00nYX0oooo003jVP3oool00?ZJ0?l0
00020?ooo`030?l00000nYX0oooo0080oooo00L00?ZJ0?ooo`3oool0oooo0?l0003oool0o`000080
oooo00@00?ZJ0?ooo`3oool00?ZJ0P3oool0103o0000oooo0?l00000nYX20?ooo`03003jVP3oool0
oooo0080oooo00@0o`000?ooo`3oool0o`000P3oool01P00nYX0oooo0?ooo`00nYX0oooo0?l000<0
oooo00D0o`00003jVP3oool0oooo003jVP0m0?ooo`030000003oool0oooo00X0oooo000P0?ooo`80
00001@3oool01P00nYX0oooo003jVP3oool00?ZJ0?ooo`@0o`0000H00?ZJ0?ooo`3oool0oooo003j
VP3o00020?ooo`030?l00000nYX0oooo00<0oooo00<0o`000?ooo`3oool00`3o00020?ooo`06003j
VP3o0000oooo0?ooo`3o00000?ZJ0`3oool2003jVP030?ooo`00nYX0oooo00<0oooo0P3o00020?oo
o`03003jVP3oool00?ZJ00H0oooo0P3o00090?ooo`030?l0003oool0o`000080oooo00D00?ZJ0?oo
o`3oool00?ZJ0?l000020?ooo`030?l0003oool0oooo0080oooo00<00?ZJ0?ooo`3o00000P3oool0
0`3o0000oooo0?ooo`02003jVP80oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX20?ooo`800?ZJ
00<0oooo003jVP3o00000P3oool00`3o00000?ZJ0?ooo`020?ooo`07003jVP3oool0oooo0?ooo`3o
0000oooo0?l000020?ooo`04003jVP3oool0oooo003jVP80oooo00@0o`000?ooo`3o00000?ZJ0P3o
ool00`00nYX0oooo0?ooo`020?ooo`040?l0003oool0oooo0?l00080oooo00H00?ZJ0?ooo`3oool0
0?ZJ0?ooo`3o00030?ooo`030?l00000nYX0oooo0080oooo00<00?ZJ0?ooo`3oool0>@3oool20000
00`0oooo000P0?ooo`030000003oool0oooo00@0oooo00H00?ZJ0?ooo`00nYX0oooo003jVP3oool2
0?l000030?ooo`3o00000?ZJ00<0oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX40?ooo`030?l0
003oool0oooo00<0o`000P3oool01P00nYX0o`000?ooo`3oool0o`00003jVP<0oooo0P00nYX20?oo
o`04003jVP3oool0oooo0?ooo`80o`000P3oool00`00nYX0oooo003jVP060?ooo`80o`0000D0oooo
003jVP00nYX0oooo003jVP040?ooo`030?l0003oool0o`000080oooo00D00?ZJ0?ooo`3oool00?ZJ
0?l000020?ooo`030?l0003oool0oooo00<0oooo00@00?ZJ0?l0003oool0oooo0P3o00000`3oool0
0?ZJ003jVP020?ooo`06003jVP3o0000oooo0?ooo`3o00000?ZJ0P3oool2003jVP030?ooo`00nYX0
o`000080oooo00<0o`00003jVP3oool00P3oool01`00nYX0oooo0?ooo`3oool0o`000?ooo`3o0000
0P3oool01000nYX0oooo0?ooo`00nYX20?ooo`040?l0003oool0o`00003jVP80oooo00<00?ZJ0?oo
o`00nYX00P3oool0103o0000oooo0?ooo`3o00020?ooo`04003jVP3oool0oooo003jVP80oooo00D0
o`000?ooo`3oool0o`00003jVP030?ooo`03003jVP3oool0oooo03X0oooo00<000000?ooo`3oool0
2P3oool00200oooo00<000000?ooo`3oool0103oool01P00nYX0oooo0?ooo`3oool00?ZJ0?ooo`80
o`0000<0oooo0?l00000nYX00`3oool01P00nYX0o`000?ooo`3oool0o`00003jVP@0oooo00<0o`00
0?ooo`3oool00`3o00030?ooo`050?l0003oool0oooo0?l00000nYX01`3oool01000nYX0oooo0?oo
o`3oool20?l00080oooo00<00?ZJ0?ooo`00nYX01P3oool20?l000030?ooo`00nYX0oooo00800?ZJ
103oool00`3o0000oooo0?l000020?ooo`05003jVP3oool0oooo003jVP3o00000P3oool20?l000@0
oooo00@00?ZJ0?l0003oool0oooo0P3o00000`3oool00?ZJ003jVP020?ooo`06003jVP3o0000oooo
0?ooo`3o00000?ZJ0P3oool2003jVP030?ooo`00nYX0o`000080oooo00<0o`00003jVP3oool00`3o
ool01P00nYX0oooo0?ooo`3o0000oooo0?l00080oooo00@00?ZJ0?ooo`3oool00?ZJ0P3oool0103o
0000oooo0?l00000nYX20?ooo`03003jVP3oool00?ZJ0080oooo00<0o`000?ooo`3o00000`3oool0
1000nYX0oooo0?ooo`00nYX20?ooo`050?l0003oool0oooo0?l00000nYX00`3oool00`00nYX0oooo
0?ooo`0j0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00@0oooo00L0
0?ZJ0?ooo`3oool0oooo003jVP3oool0o`000080oooo00<0o`00003jVP3oool00P3oool01P00nYX0
o`000?ooo`3oool0o`00003jVP@0oooo00<0o`000?ooo`3oool00`3o00030?ooo`050?l0003oool0
oooo0?l00000nYX01`3oool00`00nYX0oooo0?ooo`020?ooo`060?l0003oool0oooo003jVP3oool0
0?ZJ1`3oool00`3o0000oooo003jVP030?ooo`04003jVP3oool0oooo0?ooo`80o`000`3oool01@00
nYX0oooo0?ooo`00nYX0o`000080oooo0P3o00040?ooo`04003jVP3o0000oooo0?ooo`80o`0000<0
oooo003jVP3oool00P3oool01P00nYX0o`000?ooo`3oool0o`00003jVP80oooo0P00nYX00`3oool0
0?ZJ0?l000020?ooo`040?l00000nYX0oooo0?l00080oooo00H00?ZJ0?ooo`3oool0o`000?ooo`3o
00020?ooo`04003jVP3oool0oooo003jVP80oooo00@0o`000?ooo`3o00000?ZJ0`3oool01`00nYX0
oooo003jVP3oool0o`000?ooo`3o00000`3oool01000nYX0oooo0?ooo`00nYX20?ooo`050?l0003o
ool0oooo0?l00000nYX00`3oool00`00nYX0oooo0?ooo`050?ooo`03003jVP3oool0oooo0380oooo
00<000000?ooo`3oool02P3oool00200oooo0P0000050?ooo`03003jVP3oool0oooo0080oooo00H0
0?ZJ0?l0003oool0oooo0?l00000nYX30?ooo`06003jVP3o0000oooo0?ooo`3o00000?ZJ103oool0
0`3o0000oooo0?ooo`020?l000050?ooo`3o0000oooo0?ooo`3o00000P3oool00`3o00000?ZJ0?oo
o`070?ooo`03003jVP3oool0oooo00@0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool00`3o0000oooo
003jVP030?ooo`03003jVP3oool0oooo0080oooo00D0o`000?ooo`3oool0oooo003jVP020?ooo`04
003jVP3o0000oooo0?ooo`80o`00103oool01000nYX0o`000?ooo`3oool20?l000030?ooo`00nYX0
oooo0080oooo00H00?ZJ0?l0003oool0oooo0?l00000nYX20?ooo`05003jVP3oool0oooo003jVP3o
00000P3oool0103o00000?ZJ0?ooo`3o00020?ooo`06003jVP3oool0oooo0?l0003oool0o`000P3o
ool02P00nYX0oooo0?ooo`3oool00?ZJ0?ooo`3o0000oooo0?l00000nYX50?ooo`03003jVP3oool0
oooo0080o`000`3oool01000nYX0oooo0?ooo`00nYX20?ooo`050?l0003oool0oooo0?l00000nYX0
0`3oool00`00nYX0oooo0?ooo`050?ooo`800?ZJ<P3oool2000000`0oooo000P0?ooo`030000003o
ool0oooo00<0oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX0o`000?ooo`020?ooo`06003jVP3o
ool0oooo0?ooo`00nYX0o`000P3oool00`3o00000?ZJ0?ooo`030?ooo`030?l0003oool0oooo0080
o`0000D0oooo0?l0003oool0oooo0?l000020?ooo`040?l00000nYX0oooo0?l000H0oooo00<00?ZJ
0?ooo`3oool00`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00P0oooo00D00?ZJ0?ooo`3oool0oooo
003jVP080?ooo`09003jVP3oool0oooo003jVP3o0000oooo0?l00000nYX0o`0000@0oooo00@00?ZJ
0?l0003oool0oooo0P3o00000`3oool00?ZJ0?ooo`020?ooo`06003jVP3o0000oooo0?ooo`3o0000
0?ZJ1@3oool02P00nYX0o`000?ooo`3oool0o`00003jVP3o0000oooo0?l0003oool2003jVP040?oo
o`3o0000oooo0?l00080oooo00T00?ZJ0?ooo`3oool0oooo003jVP3oool0o`000?ooo`3o00001P3o
ool00`00nYX0oooo0?ooo`020?l00080oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?l0
00020?ooo`030?l0003oool0oooo0080oooo00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo003j
VP0c0?ooo`030000003oool0oooo00X0oooo000I0?ooo`8000001@3oool00`000000oooo0?ooo`03
0?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?l0003oool00P3oool01P00nYX0oooo0?ooo`3o
ool00?ZJ0?l00080oooo00<0o`00003jVP3oool00`3oool00`3o0000oooo0?ooo`020?l000050?oo
o`3o0000oooo0?ooo`3o00000P3oool0103o00000?ZJ0?ooo`3o00060?ooo`03003jVP3oool0oooo
00<0oooo00@00?ZJ0?ooo`3oool0oooo0P00nYX70?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ
0?ooo`3oool01@3oool02000nYX0oooo0?ooo`00nYX0o`000?ooo`3o00000?ZJ0P3o00030?ooo`04
003jVP3o0000oooo0?ooo`80o`001@3oool01P00nYX0oooo0?l0003oool0o`00003jVPD0oooo00X0
0?ZJ0?l0003oool0oooo0?l00000nYX0o`000?ooo`3o0000oooo0`00nYX00`3o0000oooo0?l00002
0?ooo`09003jVP3oool0oooo0?ooo`00nYX0oooo0?l0003oool0o`0000L0oooo00@00?ZJ0?ooo`3o
0000o`000P3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0o`000080oooo00<0o`000?oo
o`3oool00`3oool00`00nYX0oooo0?ooo`030?ooo`04003jVP3oool0oooo003jVS80oooo00<00000
0?ooo`3oool02P3oool001P0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`03
0?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`02
0?ooo`050?l0003oool0oooo0?l00000nYX0103oool00`3o0000oooo0?ooo`020?l000090?ooo`3o
0000oooo0?ooo`00nYX0o`000?ooo`3o00000?ZJ0080o`001`3oool00`00nYX0oooo0?ooo`020?oo
o`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?ooo`030?oo
o`03003jVP3oool0oooo00@0oooo00T00?ZJ0?ooo`3oool0oooo003jVP3o0000oooo0?l00000nYX0
0`3o00020?ooo`04003jVP3oool0o`000?ooo`80o`001@3oool01P00nYX0oooo0?l0003oool0o`00
003jVPH0oooo00l0o`000?ooo`3oool0o`00003jVP3o0000oooo0?l0003oool00?ZJ0?ooo`00nYX0
o`000?ooo`3o00000P3oool02@00nYX0oooo0?ooo`3oool00?ZJ0?ooo`3o0000oooo0?l000070?oo
o`04003jVP3oool0o`000?l00080oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?l00002
0?ooo`030?l0003oool0o`0000<0oooo00<00?ZJ0?ooo`3oool00`3oool01000nYX0oooo0?ooo`00
nYXb0?ooo`030000003oool0oooo00X0oooo000H0?ooo`040000003oool0oooo000000@0oooo00<0
00000?ooo`3oool00`3oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo0080oooo00<0
0?ZJ0?ooo`3oool00P3oool01`00nYX0o`000?ooo`3o00000?ZJ0?ooo`3o00000P3oool00`00nYX0
o`000?ooo`020?l000090?ooo`3o0000o`000?ooo`00nYX0o`000?ooo`3o00000?ZJ0080o`001`3o
ool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00`3o
ool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo00@0oooo00T00?ZJ0?ooo`3o0000o`00
003jVP3o0000oooo0?l00000nYX00`3o00020?ooo`04003jVP3oool0o`000?ooo`<0o`00103oool0
1P00nYX0oooo0?l0003oool0o`00003jVPH0oooo00P0o`000?ooo`3oool0o`00003jVP3o0000oooo
0?l000<0oooo00<00?ZJ0?ooo`3o00000P3oool00`00nYX0oooo0?ooo`030?ooo`04003jVP3o0000
oooo0?l000L0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3o
ool0o`000080oooo00<0o`000?ooo`3o00000`3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3o
ool0oooo0080oooo00<00?ZJ0?ooo`3oool00`3oool3003jVRT0oooo00<000000?ooo`3oool02P3o
ool001P0oooo00@000000?ooo`3oool00000103oool3000000<0oooo00<00?ZJ0?ooo`3oool00`3o
ool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo0080oooo00L00?ZJ0?l0003oool0o`00
003jVP3oool0o`000080oooo00<00?ZJ0?l0003oool00P3o00020?ooo`070?l0003oool00?ZJ0?l0
003oool0o`00003jVP020?l000L0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`03
0?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX0oooo0?ooo`04
0?ooo`09003jVP3oool0o`000?l00000nYX0o`000?ooo`3o00000?ZJ00<0o`000P3oool01000nYX0
oooo0?l0003oool30?l000D0oooo00D00?ZJ0?l0003oool0o`00003jVP060?ooo`030?l0003oool0
oooo0080o`000P3oool01`3o0000oooo0?ooo`3oool00?ZJ0?ooo`3o00000P3oool00`00nYX0oooo
0?ooo`030?ooo`04003jVP3o0000oooo0?l000L0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0
oooo0?ooo`030?ooo`06003jVP3oool0o`000?ooo`3o00000?ZJ0P3o00030?ooo`03003jVP3oool0
oooo0080oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`020?ooo`04003jVP3oool0
oooo0?ooobD00?ZJ0`3oool2000000`0oooo000H0?ooo`040000003oool0oooo000000@0oooo00<0
00000?ooo`3oool00`3oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo0080oooo00<0
0?ZJ0?l0003oool00P3oool01@00nYX0o`000?ooo`3o00000?ZJ0080o`000P3oool00`00nYX0o`00
0?ooo`020?l00080oooo00L0o`000?ooo`00nYX0o`000?ooo`3o00000?ZJ0080o`001`3oool01@00
nYX0oooo0?ooo`3oool00?ZJ00L0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`04
0?ooo`03003jVP3oool0oooo00<0oooo00X00?ZJ0?ooo`3o0000o`00003jVP3o0000oooo0?l00000
nYX0o`000P3oool01P3o0000oooo003jVP3oool0o`000?ooo`<0o`001@3oool01P00nYX0o`000?oo
o`3o00000?ZJ0?l000D0oooo00<00?ZJ0?l0003oool00P3o00020?ooo`070?l0003oool0oooo0?oo
o`00nYX0oooo0?l000020?ooo`04003jVP3oool0oooo0?l00080oooo00@00?ZJ0?l0003oool0o`00
1`3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00@0oooo00P00?ZJ0?l0003oool0
o`00003jVP3o0000oooo0?l00080oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`03
0?ooo`04003jVP3oool0oooo003jVRd0oooo00<000000?ooo`3oool02P3oool001P0oooo00@00000
0?ooo`3oool00000103oool00`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo00<0oooo00<0
0?ZJ0?ooo`3oool00P3oool00`00nYX0o`000?ooo`020?ooo`0<003jVP3o0000oooo0?l0003oool0
o`000?ooo`3o0000oooo003jVP3o0000oooo0P3o00020?ooo`0:0?l0003oool00?ZJ0?l0003oool0
o`00003jVP3o0000oooo0?l000H0oooo00D00?ZJ0?ooo`3oool0oooo003jVP070?ooo`03003jVP3o
ool0oooo0080oooo00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?ooo`030?ooo`07003jVP3o
ool0o`000?l00000nYX0o`000?ooo`020?l000<0oooo00H0o`000?ooo`00nYX0oooo0?l0003oool3
0?l000D0oooo00H00?ZJ0?l0003oool0o`00003jVP3o00050?ooo`03003jVP3o0000oooo0080o`00
0`3oool01P3o0000oooo0?ooo`00nYX0oooo0?l00080oooo00@00?ZJ0?ooo`3o0000o`000P3oool0
1P00nYX0o`000?ooo`3o0000oooo0?l000D0oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo
0?ooo`3oool0o`000080oooo00P00?ZJ0?l0003oool0o`00003jVP3o0000oooo0?l00080oooo00<0
0?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`040?ooo`800?ZJ;P3oool00`000000oooo0?oo
o`0:0?ooo`006@3oool2000000D0oooo00<000000?ooo`3oool00`3oool00`00nYX0oooo0?l00003
0?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?l0003oool00P3oool03000nYX0o`000?ooo`3o
0000oooo0?l0003oool0o`000?ooo`00nYX0o`000?ooo`80o`000`3oool02@3o00000?ZJ0?l0003o
ool0o`00003jVP3o0000oooo0?l000070?ooo`03003jVP3oool00?ZJ00P0oooo00<00?ZJ0?ooo`3o
ool00P3oool00`00nYX0oooo0?ooo`040?ooo`03003jVP3oool0oooo00<0oooo00L00?ZJ0?ooo`3o
0000o`00003jVP3o0000oooo0080o`000`3oool01P3o0000oooo003jVP3oool0o`000?ooo`<0o`00
1@3oool01@00nYX0o`000?ooo`3o00000?ZJ0080o`00103oool00`00nYX0o`000?ooo`020?l000<0
oooo00H0o`000?ooo`3oool00?ZJ0?ooo`3o00020?ooo`04003jVP3oool0o`000?l00080oooo00D0
0?ZJ0?ooo`3o0000o`000?ooo`020?l000@0oooo00D00?ZJ0?ooo`3oool0oooo003jVP040?ooo`05
0?l0003oool0oooo003jVP3oool00P3o00001000nYX0o`000?ooo`3o00020?ooo`05003jVP3oool0
oooo0?ooo`00nYX0=`3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000@0oooo00L00?ZJ
0?l0003o0000oooo0?l0003oool00?ZJ00@0oooo00<00?ZJ0?l0003oool00P3oool01P00nYX0o`00
0?ooo`3o0000oooo0?l00080oooo00@0o`00003jVP3o0000oooo0P3o00030?ooo`090?l00000nYX0
o`000?ooo`3o00000?ZJ0?l0003oool0o`0000L0oooo00<00?ZJ0?ooo`00nYX02@3oool2003jVP80
oooo00<00?ZJ0?ooo`3oool0103oool00`00nYX0oooo0?ooo`030?ooo`07003jVP3oool0o`000?l0
0000nYX0o`000?ooo`020?l000<0oooo00H0o`000?ooo`00nYX0oooo0?l0003oool30?l00080oooo
0P3o00001P3oool00?ZJ0?l0003oool0o`00003jVP80o`00103oool00`00nYX0o`000?ooo`020?l0
00<0oooo00@0o`000?ooo`3oool00?ZJ0`3oool00`00nYX0oooo0?ooo`020?l00080oooo00D00?ZJ
0?ooo`3o0000o`000?ooo`020?l000@0oooo00D00?ZJ0?ooo`3oool0oooo003jVP030?ooo`80o`00
0P3oool02000nYX0oooo0?l0003o00000?ZJ0?l0003oool0o`000P3oool01@00nYX0oooo0?ooo`3o
ool00?ZJ03H0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`030?ooo`07003jVP3o0000
o`000?ooo`3o0000oooo003jVP040?ooo`03003jVP3o0000o`000080oooo00H00?ZJ0?l0003o0000
0?ZJ0?ooo`3o00020?ooo`040?l00000nYX0o`000?ooo`80o`000`3oool02@3o00000?ZJ0?l0003o
ool0o`00003jVP3o0000oooo0?l000070?ooo`03003jVP3oool00?ZJ00<0oooo00<0o`000?ooo`3o
ool0103oool01000nYX0oooo0?ooo`00nYX70?ooo`03003jVP3oool0oooo0080oooo00L00?ZJ0?oo
o`3o0000o`00003jVP3o0000oooo0080o`00103oool01@3o0000oooo003jVP3o0000oooo00<0o`00
0P3oool20?l000060?ooo`00nYX0o`000?ooo`3o00000?ZJ0P3o00020?ooo`050?l0003oool00?ZJ
0?l0003oool00P3o00030?ooo`040?l0003oool0oooo003jVP<0oooo00<00?ZJ0?ooo`3oool00P3o
00020?ooo`05003jVP3oool0o`000?l0003oool00P3o00050?ooo`04003jVP3oool0oooo003jVP<0
oooo0P3o00020?ooo`08003jVP3oool0o`000?l00000nYX0o`000?ooo`3o00020?ooo`05003jVP3o
ool0oooo0?ooo`00nYX0=`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?oo
o`030?ooo`05003jVP3o0000o`000?ooo`3o00000P3oool01@00nYX0oooo0?ooo`3oool00?ZJ0080
o`000P3oool01@00nYX0o`000?l00000nYX0o`0000<0oooo00@0o`00003jVP3o0000oooo0P3o0003
0?ooo`040?l00000nYX0o`000?ooo`80o`000P3oool00`3o0000oooo0?ooo`050?ooo`03003jVP3o
ool00?ZJ00<0oooo00<0o`000?ooo`3oool0103oool01000nYX0oooo0?ooo`00nYX70?ooo`03003j
VP3oool0oooo0080oooo00@00?ZJ0?l0003oool0oooo0P3o00000`3oool0o`000?l000040?ooo`04
0?l0003oool00?ZJ0?ooo`80o`0000@0oooo0?l0003oool0oooo0P3o00001P3oool00?ZJ0?l0003o
ool0o`000?ooo`80o`000P3oool01@3o0000oooo003jVP3o0000oooo0080o`000`3oool01@3o0000
oooo0?ooo`3oool00?ZJ0080oooo00<00?ZJ0?ooo`3oool00P3o00020?ooo`03003jVP3oool0o`00
0080o`0000<0oooo0?l0003oool0103oool01000nYX0oooo0?ooo`00nYX30?ooo`80o`000P3oool0
2000nYX0oooo0?ooo`3o00000?ZJ0?l0003oool0o`000P3oool01@00nYX0oooo0?ooo`3oool00?ZJ
03L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool00`3oool01000nYX0
o`000?l0003oool20?l000060?ooo`00nYX0oooo003jVP3oool00?ZJ0P3o00000`3oool0o`00003j
VP020?l00003003jVP3o0000oooo0080oooo00@0o`00003jVP3o0000oooo0P3o00030?ooo`040?l0
0000nYX0o`000?ooo`80o`000P3oool00`3o0000oooo0?ooo`050?ooo`03003jVP3oool00?ZJ00<0
oooo00<0o`000?ooo`3oool0103oool01000nYX0oooo0?ooo`00nYX70?ooo`07003jVP3oool0oooo
0?ooo`00nYX0oooo0?l000020?ooo`80o`0000<0oooo0?l0003o0000103oool0103o0000oooo003j
VP3oool20?l000080?ooo`3o0000oooo0?l0003oool0o`000?ooo`00nYX20?l00004003jVP3o0000
oooo0?l00080oooo0P3o00000`00nYX0o`000?ooo`020?l000<0oooo00D0o`000?ooo`3oool0oooo
003jVP020?ooo`06003jVP3oool0oooo0?l0003oool0o`000P3oool01P00nYX0o`000?l0003o0000
oooo0?l000D0oooo00@00?ZJ0?ooo`3oool00?ZJ0`3oool20?l00080oooo00H00?ZJ0?ooo`3oool0
o`00003jVP3o00020?ooo`040?l0003oool0oooo003jVP80oooo00<00?ZJ0?ooo`3oool0=@3oool0
0`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?ooo`080?l0003oool0o`00
0?ooo`3o0000oooo003jVP3oool2003jVP030?ooo`3o0000oooo0080o`0000D00?ZJ0?l0003o0000
0?ZJ0?l000030?ooo`040?l00000nYX0o`000?ooo`80o`000`3oool0103o00000?ZJ0?l0003oool2
0?l00080oooo00<0o`000?ooo`3oool00P3o00030?ooo`03003jVP3oool00?ZJ00<0oooo0P3o0006
0?ooo`03003jVP3oool00?ZJ00L0oooo00L00?ZJ0?ooo`3oool0oooo003jVP3oool0o`000080oooo
0P3o00000`3oool0o`000?l000040?ooo`040?l0003oool00?ZJ0?ooo`80o`0000@0oooo0?l0003o
ool0o`000P3oool0203o00000?ZJ0?l0003o00000?ZJ0?l0003oool0o`000P3oool20?l00003003j
VP3o0000oooo0080o`000`3oool01@3o0000oooo0?ooo`3oool00?ZJ0080oooo00H00?ZJ0?ooo`3o
ool0o`000?ooo`3o00020?ooo`06003jVP3o00000?ZJ0?l0003oool0o`001@3oool01000nYX0oooo
0?ooo`00nYX30?ooo`050?l0003oool0o`000?ooo`00nYX00`3oool01@00nYX0o`000?ooo`3oool0
o`000080oooo00@00?ZJ0?ooo`3oool00?ZJ=`3oool00`000000oooo0?ooo`0:0?ooo`00803oool2
000000D0oooo00H0o`000?ooo`3o0000oooo0?l0003oool4003jVP060?ooo`3o0000oooo0?ooo`3o
00000?ZJ0P3o00000`00nYX0o`000?ooo`020?ooo`040?l00000nYX0o`000?ooo`80o`000`3oool0
103o00000?ZJ0?l0003oool20?l00080oooo00<0o`000?ooo`3oool00P3o00030?ooo`03003jVP3o
ool00?ZJ0080oooo00<0o`000?ooo`3o00001P3oool00`00nYX0oooo003jVP070?ooo`07003jVP3o
ool0oooo0?ooo`00nYX0oooo0?l000020?ooo`80o`0000<0oooo0?l0003o0000103oool0103o0000
oooo003jVP3oool20?l000040?ooo`3o0000oooo0?l00080oooo00P0o`00003jVP3o0000o`00003j
VP3o0000oooo0?l00080oooo0P3o00000`00nYX0o`000?ooo`020?l000<0oooo00L0o`000?ooo`3o
ool0oooo003jVP3oool00?ZJ0080oooo00@0o`000?ooo`3oool0o`000P3oool01000nYX0o`00003j
VP3o00020?ooo`030?l0003oool0oooo0080oooo00@00?ZJ0?ooo`3oool00?ZJ0P3oool01P3o0000
oooo0?ooo`3o0000oooo003jVP<0oooo00D00?ZJ0?l0003oool0oooo0?l000020?ooo`03003jVP3o
ool00?ZJ03L0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`040?ooo`060?l0003oool0
o`000?ooo`3o0000oooo1000nYX01P3oool0o`000?ooo`3oool0o`00003jVP80o`0000<00?ZJ0?l0
003oool00`3oool20?l000030?ooo`3o0000o`0000<0oooo00@0o`00003jVP3o0000oooo0P3o0003
0?ooo`040?l0003oool0o`000?l000@0oooo0P00nYX20?ooo`030?l0003oool0o`0000H0oooo0P00
nYX80?ooo`07003jVP3oool0oooo0?ooo`00nYX0oooo0?l000020?ooo`80o`0000<0oooo0?l0003o
0000103oool00`3o0000oooo003jVP020?ooo`030?l0003oool0oooo0080o`000P3oool01P3o0000
0?ZJ0?ooo`3o00000?ZJ0?l00080oooo0P3o00001@3oool0o`00003jVP3o0000oooo0080o`000`3o
ool01`3o0000oooo0?ooo`3oool00?ZJ0?ooo`00nYX00P3oool0103o0000oooo0?ooo`3o00020?oo
o`04003jVP3o00000?ZJ0?l00080oooo00<0o`000?ooo`3oool00P3oool01000nYX0oooo0?ooo`00
nYX20?ooo`060?l0003oool0oooo0?l0003oool00?ZJ0`3oool01@00nYX0o`000?ooo`3oool0o`00
0080oooo00<00?ZJ0?ooo`00nYX0>03oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000
oooo0?ooo`040?ooo`060?l0003oool0o`000?ooo`3o0000oooo1000nYX01P3o0000oooo0?ooo`3o
ool0o`00003jVP80o`0000<00?ZJ0?l0003oool00`3oool20?l000030?ooo`3o0000oooo00<0oooo
00@0o`00003jVP3o0000oooo0P3o00030?ooo`80o`000P3oool0103o0000oooo0?ooo`3oool2003j
VP80oooo00<0o`000?ooo`3o00001P3oool2003jVP80oooo00<0o`000?ooo`3oool0103oool00`00
nYX0oooo003jVP020?ooo`030?l0003oool0oooo0080o`0000<0oooo0?l0003o0000103oool00`3o
0000oooo003jVP020?ooo`030?l0003oool0oooo0080o`000P3oool01P3o00000?ZJ0?ooo`3o0000
0?ZJ0?l00080oooo0P3o00001@3oool0o`00003jVP3o0000oooo0080o`000`3oool01`3o0000oooo
0?ooo`3oool00?ZJ0?ooo`00nYX00P3oool0103o0000oooo0?ooo`3o00020?ooo`04003jVP3o0000
0?ZJ0?l00080oooo00<0o`000?ooo`3oool00P3oool01000nYX0oooo0?ooo`00nYX20?ooo`060?l0
003oool0oooo0?l0003oool00?ZJ0`3oool00`00nYX0o`000?ooo`020?ooo`050?l0003oool00?ZJ
0?ooo`00nYX0>03oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?oo
o`060?l0003oool0oooo0?ooo`3o0000oooo0P00nYX00`3oool00?ZJ0?l000030?ooo`060?l00000
nYX0oooo0?l00000nYX0o`00103oool20?l000030?ooo`3o0000oooo00<0oooo00@0o`00003jVP3o
0000oooo0P3o00030?ooo`80o`000P3oool0103o0000oooo0?ooo`3oool2003jVP80oooo00<0o`00
0?ooo`3o00001P3oool2003jVP050?ooo`3o0000o`000?ooo`3o0000103oool00`00nYX0oooo003j
VP020?ooo`030?l0003oool0oooo0080o`0000<0oooo0?l0003o00001@3oool01@3o00000?ZJ0?oo
o`3oool0o`000080oooo0P3o00020?ooo`060?l00000nYX0oooo0?l00000nYX0o`000P3oool20?l0
00050?ooo`3o00000?ZJ0?l0003oool00P3o00040?ooo`060?l0003oool0oooo003jVP3oool00?ZJ
0P3oool0103o0000oooo0?ooo`3o00020?ooo`04003jVP3oool00?ZJ0?l00080oooo00<0o`000?oo
o`3o00000P3oool00`00nYX0oooo003jVP030?ooo`040?l0003oool0oooo0?l00080oooo00D00?ZJ
0?ooo`3oool00?ZJ0?l000030?ooo`050?l0003oool00?ZJ0?ooo`00nYX0>03oool00`000000oooo
0?ooo`0:0?ooo`00803oool2000000D0oooo00H0o`000?ooo`3oool0oooo0?l0003oool2003jVP03
0?ooo`00nYX0o`0000<0oooo00H0o`00003jVP3oool0o`00003jVP3o00040?ooo`80o`0000<0oooo
0?l0003oool0103oool20?l000030?ooo`3o0000o`0000L0oooo00@0o`000?ooo`3oool0oooo0P00
nYX20?ooo`030?l0003oool0o`0000H0oooo0P00nYX00`3oool0o`000?ooo`020?l000@0oooo00<0
0?ZJ0?ooo`00nYX00P3oool00`3o0000oooo0?ooo`020?l000030?ooo`3o0000o`0000D0oooo00D0
o`00003jVP3oool0oooo0?l000020?ooo`0:0?l0003oool0oooo0?ooo`3o00000?ZJ0?ooo`3o0000
0?ZJ0?l00080oooo0P3o00001@3oool0o`00003jVP3o0000oooo0080o`00103oool01P3o0000oooo
0?ooo`00nYX0oooo003jVP80oooo00@0o`000?ooo`3oool0o`000P3oool01000nYX0oooo003jVP3o
00020?ooo`030?l0003oool0o`000080oooo00<00?ZJ0?ooo`00nYX00`3oool0103o0000oooo0?oo
o`3o00020?ooo`05003jVP3oool0oooo003jVP3o00000`3oool0103o0000oooo003jVP00nYXh0?oo
o`800000303oool00200oooo00<000000?ooo`3oool0103oool01`3o0000oooo0?ooo`3oool0o`00
0?ooo`00nYX00P3oool00`00nYX0o`000?ooo`020?ooo`060?l00000nYX0oooo0?ooo`00nYX0o`00
103oool20?l000030?ooo`3o0000oooo00@0oooo0P3o00000`3oool0o`000?l000080?ooo`050?l0
003oool0oooo0?ooo`00nYX00P3oool0103o0000oooo0?ooo`3o00060?ooo`03003jVP3oool0o`00
00<0oooo00@0o`000?ooo`3oool0oooo0P00nYX30?ooo`030?l0003oool0oooo0080o`0000<0oooo
0?l0003o00001@3oool01@3o00000?ZJ0?ooo`3oool0o`000080oooo00X0o`000?ooo`3oool0oooo
0?l00000nYX0oooo0?l00000nYX0o`000P3oool20?l000030?ooo`3o00000?ZJ0080o`0000<00?ZJ
0?l0003oool00`3oool01P3o0000oooo0?ooo`00nYX0oooo003jVP80oooo00X0o`000?ooo`3oool0
oooo0?l0003oool00?ZJ0?ooo`00nYX0o`000`3oool01`3o0000oooo0?l0003oool00?ZJ0?ooo`00
nYX00`3oool0103o0000oooo0?ooo`3o00020?ooo`05003jVP3oool0oooo003jVP3o00000`3oool0
103o0000oooo0?ooo`00nYXi0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0
oooo00@0oooo00<0o`000?ooo`3oool00P3oool01P3o00000?ZJ0?ooo`3oool00?ZJ0?l000<0oooo
00H0o`00003jVP3oool0oooo003jVP3o00040?ooo`80o`0000<0oooo0?l0003oool0103oool20?l0
00030?ooo`3o0000o`0000P0oooo00<0o`000?ooo`3oool0103oool0103o0000oooo0?ooo`3o0006
0?ooo`03003jVP3oool0o`0000<0oooo00<0o`000?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3o
ool0o`000080oooo0P3o00000`3oool0o`000?l000050?ooo`050?l00000nYX0oooo0?ooo`3o0000
0P3oool01P3o0000oooo0?ooo`3oool0o`00003jVP80oooo00D00?ZJ0?l0003oool0oooo0?l00002
0?ooo`060?l00000nYX0o`000?l00000nYX0o`00103oool01P3o0000oooo0?ooo`00nYX0oooo003j
VP80oooo00X0o`000?ooo`3oool0oooo0?l0003oool00?ZJ0?ooo`00nYX0o`001@3oool00`3o0000
oooo0?ooo`02003jVP80oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo003jVP020?ooo`03
003jVP3o0000oooo0080oooo00<0o`000?ooo`3oool0>P3oool00`000000oooo0?ooo`0:0?ooo`00
803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo0080oooo00<0o`00003jVP3oool0
0P3oool01P3o0000oooo0?ooo`3oool0o`00003jVP80oooo00<00?ZJ0?l0003oool00`3oool20?l0
00030?ooo`3o0000oooo00@0oooo0P3o00000`3oool0o`000?l000080?ooo`030?l0003oool0oooo
00<0oooo00@0o`000?ooo`3oool0oooo0P3o00070?ooo`030?l0003oool0oooo0080oooo00<0o`00
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`020?l000030?ooo`3o0000o`0000D0oooo00D0o`00
003jVP3oool0oooo0?l000060?ooo`060?l0003oool00?ZJ0?ooo`00nYX0o`001@3oool01P3o0000
0?ZJ0?l0003o00000?ZJ0?l000@0oooo0`3o00000`00nYX0oooo003jVP020?ooo`090?l0003oool0
oooo0?ooo`3o0000oooo003jVP3oool0o`0000L0oooo00@0o`000?ooo`00nYX00?ZJ0P3oool00`3o
0000oooo0?ooo`020?ooo`030?l0003oool00?ZJ0080oooo00<0o`000?ooo`3oool00P3oool00`3o
0000oooo0?ooo`0j0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00@0
oooo00<0o`000?ooo`3oool00P3oool00`3o00000?ZJ0?ooo`020?ooo`060?l0003oool0oooo0?oo
o`3o00000?ZJ0P3oool00`00nYX0o`000?ooo`030?ooo`80o`0000<0oooo0?l0003oool0103oool2
0?l000030?ooo`3o0000o`0000T0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`02
0?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`05
0?ooo`030?l0003oool0oooo0080o`0000<0oooo0?l0003o00001@3oool01@3o00000?ZJ0?ooo`3o
ool0o`0000H0oooo00H0o`000?ooo`00nYX0oooo003jVP3o00050?ooo`060?l00000nYX0o`000?l0
0000nYX0o`00103oool30?l00003003jVP3oool00?ZJ0080oooo00T0o`000?ooo`3oool0oooo0?l0
003oool00?ZJ0?ooo`3o00001`3oool0103o0000oooo003jVP00nYX20?ooo`030?l0003oool0oooo
0080oooo00<0o`000?ooo`00nYX00P3oool00`3o0000oooo0?ooo`030?ooo`030?l0003oool0oooo
03T0oooo00<000000?ooo`3oool02P3oool00200oooo0P0000050?ooo`030?l0003oool0oooo0080
oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`020?ooo`050?l00000nYX0oooo003j
VP3o0000103oool20?l000030?ooo`3o0000oooo00@0oooo0P3o00000`3oool0o`000?l000090?oo
o`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`030?oo
o`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool0103oool0103o0000oooo0?ooo`3oool2
0?l000030?ooo`3o0000o`0000D0oooo00D0o`000?ooo`00nYX0oooo0?l000060?ooo`060?l0003o
ool00?ZJ0?ooo`00nYX0o`001P3oool30?l00003003jVP3o0000oooo00<0oooo00P0o`000?ooo`3o
00000?ZJ0?ooo`00nYX0oooo0?l000D0oooo00@0o`00003jVP3oool0o`001`3oool01P3o0000oooo
003jVP00nYX0oooo0?l000D0oooo00<0o`000?ooo`00nYX00P3oool00`3o0000oooo0?ooo`030?oo
o`030?l0003oool0oooo03P0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`040?ooo`03
0?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`020?ooo`05
0?l00000nYX0oooo003jVP3o0000103oool20?l000030?ooo`3o0000oooo00@0oooo0`3o00000`00
nYX0o`000?ooo`080?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool00`3oool00`3o
0000oooo0?ooo`030?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool0103oool01P3o
0000oooo0?ooo`3oool0o`00003jVP<0o`001@3oool01@3o0000oooo003jVP3oool0o`0000H0oooo
00H0o`000?ooo`00nYX0oooo003jVP3o00060?ooo`<0o`0000<00?ZJ0?l0003oool01@3oool00`3o
0000oooo003jVP020?ooo`030?l0003oool0oooo00<0oooo00@0o`00003jVP3oool0o`001`3oool0
0`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00<0oooo00H0o`000?ooo`00nYX0oooo003j
VP3o00050?ooo`030?l0003oool0oooo03T0oooo00<000000?ooo`3oool02P3oool00140oooo1@00
00020?ooo`<000001@3oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo0080oooo00<0
o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`020?ooo`050?l00000nYX0oooo003jVP3o0000
103oool20?l000030?ooo`3o0000oooo00@0oooo0`3o00000`00nYX0o`000?ooo`080?ooo`030?l0
003oool0oooo0080oooo00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`030?ooo`030?l0
003oool0oooo00@0oooo00<0o`000?ooo`3oool00`3oool01P3o0000oooo0?ooo`3oool0o`00003j
VP<0o`001@3oool01@3o0000oooo003jVP3oool0o`0000L0oooo00D0o`00003jVP3oool00?ZJ0?l0
00060?ooo`@0o`001`3oool00`3o0000oooo003jVP020?ooo`030?l0003oool0oooo00<0oooo00@0
o`00003jVP3oool0o`001`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00<0oooo
00H0o`000?ooo`00nYX0oooo003jVP3o00050?ooo`030?l0003oool0oooo03T0oooo00<000000?oo
o`3oool02P3oool00180oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0
oooo0080oooo00<0o`000?ooo`3oool00P3oool01@3o00000?ZJ0?ooo`00nYX0o`0000@0oooo0P3o
00000`3oool0o`000?ooo`040?ooo`<0o`0000<00?ZJ0?l0003oool0203oool01@3o0000oooo0?oo
o`3oool0o`0000L0oooo00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`040?ooo`030?l0
003oool0oooo00<0oooo00H0o`000?ooo`3oool0oooo0?l00000nYX30?l000D0oooo00D0o`000?oo
o`00nYX0oooo0?l000070?ooo`050?l00000nYX0oooo003jVP3o00001P3oool40?l000L0oooo00<0
o`000?ooo`00nYX00P3oool00`3o0000oooo0?ooo`030?ooo`040?l00000nYX0oooo0?l000L0oooo
00<0o`000?ooo`3oool00P3oool00`3o0000oooo0?ooo`040?ooo`050?l00000nYX0oooo003jVP3o
00001@3oool00`3o0000oooo0?ooo`0i0?ooo`030000003oool0oooo00X0oooo000C0?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool3000000<0oooo00<0o`000?ooo`3oool0
0`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo0080oooo00@0o`00003jVP3oool0
o`001@3oool40?l000D0oooo0`3o00000`00nYX0o`000?ooo`080?ooo`050?l0003oool0oooo0?oo
o`3o00001`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo00@0oooo00<0o`000?oo
o`3oool00`3oool01P3o0000oooo0?ooo`3oool0o`00003jVP<0o`001@3oool01@3o0000oooo003j
VP3oool0o`0000L0oooo00D0o`00003jVP3oool00?ZJ0?l000060?ooo`040?l00000nYX0o`000?l0
00L0oooo00<0o`000?ooo`00nYX00P3oool00`3o0000oooo0?ooo`030?ooo`040?l00000nYX0oooo
0?l000L0oooo00D0o`000?ooo`3oool0oooo0?l000070?ooo`050?l0003oool00?ZJ003jVP3o0000
1@3oool00`3o0000oooo0?ooo`0h0?ooo`800000303oool001@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool00`3o
ool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo0080oooo00@0o`00003jVP3oool0o`00
1@3oool40?l000D0oooo0`3o00000`00nYX0o`000?ooo`090?ooo`030?l0003oool0o`0000P0oooo
00<0o`000?ooo`3o00000P3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo00<0oooo
00H0o`000?ooo`3oool0oooo0?l00000nYX30?l000D0oooo00D0o`000?ooo`00nYX0oooo0?l00007
0?ooo`050?l00000nYX0oooo003jVP3o00001P3oool0103o00000?ZJ0?l0003o00070?ooo`050?l0
003oool00?ZJ0?ooo`3o00001P3oool0103o0000oooo003jVP3o00070?ooo`050?l0003oool0oooo
0?ooo`3o00001`3oool01@3o0000oooo003jVP00nYX0o`0000D0oooo00<0o`000?ooo`3oool0>@3o
ool00`000000oooo0?ooo`0:0?ooo`004@3oool01P000000oooo0?ooo`3oool000000?ooo`@00000
1@3oool00`000000oooo0?ooo`030?ooo`030?l0003oool0oooo00<0oooo00<0o`000?ooo`3oool0
0P3oool00`3o0000oooo0?ooo`020?ooo`040?l00000nYX00?ZJ0?l000D0oooo103o00050?ooo`05
0?l00000nYX0o`00003jVP3o00002P3oool00`3o0000oooo0?l000090?ooo`80o`000P3oool00`3o
0000oooo0?ooo`050?ooo`030?l0003oool0oooo0080oooo00H0o`000?ooo`3oool0oooo0?l00000
nYX30?l000H0oooo00@0o`00003jVP3oool0o`001`3oool01@3o00000?ZJ0?ooo`00nYX0o`0000H0
oooo00@0o`00003jVP3o0000o`001`3oool01@3o0000oooo0?ooo`3oool0o`0000H0oooo00@0o`00
0?ooo`00nYX0o`00203oool0103o0000oooo0?ooo`3o00070?ooo`050?l0003oool00?ZJ003jVP3o
00001@3oool00`3o0000oooo0?ooo`0i0?ooo`030000003oool0oooo00X0oooo000A0?ooo`070000
003oool0oooo0?ooo`000000oooo000000080?ooo`030000003oool0oooo00<0oooo00<0o`000?oo
o`3oool00`3oool00`3o0000oooo0?ooo`020?ooo`030?l0003oool0oooo0080oooo00@0o`00003j
VP00nYX0o`001@3oool40?l000D0oooo00D0o`00003jVP3o00000?ZJ0?l0000:0?ooo`030?l0003o
ool0o`0000X0oooo00@0o`000?ooo`3oool0o`001`3oool00`3o0000oooo0?ooo`020?ooo`060?l0
003oool0oooo0?ooo`3o00000?ZJ0`3o00060?ooo`040?l00000nYX0oooo0?l000L0oooo00D0o`00
003jVP3oool00?ZJ0?l000060?ooo`040?l00000nYX0o`000?l000P0oooo00@0o`000?ooo`3oool0
o`001P3oool0103o0000oooo003jVP3o00080?ooo`040?l0003oool0oooo0?l000L0oooo00D0o`00
0?ooo`00nYX00?ZJ0?l000050?ooo`030?l0003oool0oooo03T0oooo00<000000?ooo`3oool02P3o
ool00180oooo0`0000020?ooo`D00000103oool00`000000oooo0?ooo`030?ooo`030?l0003oool0
oooo00@0oooo00D0o`000?ooo`3oool0oooo0?l000040?ooo`040?l00000nYX00?ZJ0?l000D0oooo
103o00050?ooo`050?l00000nYX0o`00003jVP3o00002P3oool00`3o0000oooo0?l0000:0?ooo`04
0?l0003oool0oooo0?l000L0oooo00<0o`000?ooo`3oool00P3oool01P3o0000oooo0?ooo`3oool0
o`00003jVP<0o`001P3oool0103o0000oooo003jVP3o00070?ooo`040?l00000nYX0oooo0?l000L0
oooo00@0o`00003jVP3o0000o`00203oool0103o0000oooo0?ooo`3o00060?ooo`040?l0003oool0
0?ZJ0?l000P0oooo00@0o`000?ooo`3oool0o`001`3oool01@3o0000oooo0?ooo`00nYX0o`0000D0
oooo00<0o`000?ooo`3oool0>@3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000@0oooo
00<0o`000?ooo`3oool0103oool0103o0000oooo0?l0003o00050?ooo`040?l00000nYX00?ZJ0?l0
00D0oooo103o00050?ooo`050?l00000nYX0o`00003jVP3o00002P3oool00`3o0000oooo0?l0000:
0?ooo`040?l0003oool0oooo0?l000L0oooo00D0o`000?ooo`3oool0oooo0?l000040?ooo`050?l0
0000nYX0o`00003jVP3o00001P3oool0103o0000oooo003jVP3o00070?ooo`040?l00000nYX00?ZJ
0?l000L0oooo00@0o`00003jVP3o0000o`00203oool0103o0000oooo0?ooo`3o00070?ooo`030?l0
0000nYX0o`0000P0oooo00@0o`000?ooo`3oool0o`001`3oool01@3o0000oooo0?ooo`00nYX0o`00
00D0oooo00<0o`000?ooo`3oool0>03oool2000000`0oooo000P0?ooo`030000003oool0oooo00<0
oooo00<0o`000?ooo`3oool0103oool0103o0000oooo0?l0003o00050?ooo`040?l00000nYX00?ZJ
0?l000D0oooo103o00050?ooo`040?l00000nYX0o`000?l000/0oooo00<0o`000?ooo`3o00002`3o
ool00`3o0000oooo0?l000070?ooo`050?l0003oool0oooo0?ooo`3o00001@3oool20?l00003003j
VP3o0000oooo00D0oooo00@0o`000?ooo`00nYX0o`001`3oool0103o00000?ZJ003jVP3o00070?oo
o`040?l00000nYX0o`000?l000P0oooo00@0o`000?ooo`3oool0o`001`3oool00`3o00000?ZJ0?l0
00080?ooo`040?l0003oool0oooo0?l000L0oooo00D0o`000?ooo`3oool0oooo0?l000050?ooo`03
0?l0003oool0oooo03T0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0
0`3oool00`3o0000oooo0?ooo`040?ooo`@0o`001@3oool0103o00000?ZJ003jVP3o00050?ooo`@0
o`001@3oool0103o00000?ZJ0?l0003o000;0?ooo`030?l0003oool0o`0000/0oooo00<0o`000?oo
o`3o00001`3oool01@3o0000oooo0?ooo`3oool0o`0000D0oooo0P3o00000`00nYX0o`000?ooo`05
0?ooo`040?l0003oool00?ZJ0?l000L0oooo00@0o`00003jVP00nYX0o`001`3oool0103o00000?ZJ
0?l0003o00080?ooo`030?l0003oool0o`0000P0oooo00<0o`00003jVP3o0000203oool0103o0000
oooo0?ooo`3o00070?ooo`050?l0003oool0oooo0?ooo`3o00001@3oool00`3o0000oooo0?ooo`0i
0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00<0oooo00<0o`000?oo
o`3oool0103oool40?l000D0oooo00@0o`00003jVP00nYX0o`001@3oool40?l000D0oooo00@0o`00
003jVP3o0000o`00303oool20?l000/0oooo0P3o00090?ooo`040?l0003oool0oooo0?l000D0oooo
0P3o00000`00nYX0o`000?ooo`050?ooo`040?l0003oool0oooo0?l000L0oooo00@0o`000?ooo`00
nYX0o`001`3oool0103o00000?ZJ0?ooo`3o00080?ooo`030?l0003oool0o`0000P0oooo00<0o`00
003jVP3o0000203oool0103o0000oooo0?ooo`3o00070?ooo`050?l0003oool0oooo0?ooo`3o0000
1@3oool00`3o0000oooo0?ooo`0i0?ooo`030000003oool0oooo00X0oooo000P0?ooo`800000103o
ool00`3o0000oooo0?ooo`040?ooo`80o`0000<0oooo0?l0003oool0103oool0103o0000oooo003j
VP3o00050?ooo`@0o`001@3oool0103o00000?ZJ0?l0003o000<0?ooo`80o`002`3oool20?l000T0
oooo00<0o`000?ooo`3o00001P3oool20?l00003003jVP3o0000oooo00D0oooo00@0o`000?ooo`3o
ool0o`001`3oool0103o0000oooo003jVP3o00070?ooo`040?l00000nYX0oooo0?l000P0oooo00<0
o`000?ooo`3o0000203oool00`3o00000?ZJ0?l000080?ooo`040?l0003oool0oooo0?l000L0oooo
00D0o`000?ooo`3oool0oooo0?l000060?ooo`030?l0003oool0oooo03L0oooo0P00000<0?ooo`00
803oool00`000000oooo0?ooo`030?ooo`030?l0003oool0oooo00@0oooo0P3o00000`3oool0o`00
0?ooo`040?ooo`040?l0003oool00?ZJ0?l000D0oooo103o00050?ooo`040?l00000nYX0o`000?l0
00`0oooo0P3o000;0?ooo`80o`002@3oool00`3o0000oooo0?l000060?ooo`80o`0000<00?ZJ0?l0
003oool01@3oool0103o0000oooo0?ooo`3o00070?ooo`040?l0003oool00?ZJ0?l000L0oooo00@0
o`00003jVP3oool0o`00203oool00`3o0000oooo0?l000080?ooo`030?l0003oool0o`0000P0oooo
00<0o`000?ooo`3o00002@3oool0103o0000oooo0?ooo`3o00060?ooo`030?l0003oool0oooo03P0
oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool00`3oool00`3o0000oooo
0?ooo`040?ooo`80o`0000<0oooo0?l0003oool0103oool0103o0000oooo003jVP3o00050?ooo`@0
o`001@3oool0103o00000?ZJ0?ooo`3o000<0?ooo`80o`002`3oool20?l000T0oooo00<0o`000?oo
o`3o00001P3oool20?l00003003jVP3o0000oooo00D0oooo00@0o`000?ooo`3oool0o`001`3oool0
103o0000oooo003jVP3o00070?ooo`040?l00000nYX0oooo0?l000P0oooo00<0o`000?ooo`3o0000
203oool00`3o0000oooo0?l000080?ooo`030?l0003oool0o`0000T0oooo00@0o`000?ooo`3oool0
o`001P3oool00`3o0000oooo0?ooo`0h0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000
003oool0oooo00<0oooo00<0o`000?ooo`3oool0103oool0103o0000oooo0?ooo`3o00050?ooo`04
0?l0003oool0oooo0?l000D0oooo103o00050?ooo`040?l00000nYX0oooo0?l000d0oooo00<0o`00
0?ooo`3oool02P3oool00`3o0000oooo0?ooo`080?ooo`030?l0003oool0oooo00D0oooo00@0o`00
0?ooo`00nYX0o`001P3oool0103o0000oooo0?ooo`3o00070?ooo`040?l0003oool00?ZJ0?l000L0
oooo00@0o`00003jVP00nYX0o`00203oool00`3o0000oooo0?l000080?ooo`030?l0003oool0o`00
00T0oooo0P3o00090?ooo`040?l0003oool0oooo0?l000H0oooo00<0o`000?ooo`3oool0>03oool0
0`000000oooo0?ooo`0:0?ooo`00803oool2000000@0oooo00<0o`000?ooo`3oool0103oool00`3o
0000oooo0?ooo`060?ooo`040?l0003oool0oooo0?l000D0oooo00@0o`00003jVP3o0000o`001@3o
ool0103o00000?ZJ0?ooo`3o000J0?ooo`030?l0003oool0oooo00P0oooo00<0o`000?ooo`3oool0
1@3oool00`3o0000oooo0?l000070?ooo`040?l0003oool0oooo0?l000L0oooo00@0o`000?ooo`3o
ool0o`001`3oool0103o00000?ZJ003jVP3o00080?ooo`030?l0003oool0o`0000P0oooo00<0o`00
0?ooo`3o00002@3oool20?l000T0oooo00@0o`000?ooo`3oool0o`001P3oool00`3o0000oooo0?oo
o`0g0?ooo`800000303oool00200oooo00<000000?ooo`3oool00`3oool00`3o0000oooo0?ooo`04
0?ooo`030?l0003oool0oooo00H0oooo00@0o`000?ooo`3oool0o`001@3oool0103o00000?ZJ0?l0
003o00050?ooo`040?l00000nYX0oooo0?l002d0oooo00<0o`000?ooo`3o00001`3oool0103o0000
oooo0?ooo`3o00080?ooo`030?l0003oool0o`0000L0oooo00@0o`00003jVP00nYX0o`00203oool0
0`3o0000oooo0?l000080?ooo`030?l0003oool0o`0000T0oooo0P3o00090?ooo`040?l0003oool0
oooo0?l000H0oooo00<0o`000?ooo`3oool0>03oool00`000000oooo0?ooo`0:0?ooo`00803oool0
0`000000oooo0?ooo`030?ooo`030?l0003oool0oooo00@0oooo00<0o`000?ooo`3oool01P3oool0
103o0000oooo0?ooo`3o00050?ooo`040?l00000nYX0o`000?l000D0oooo00@0o`00003jVP3oool0
o`00;@3oool00`3o0000oooo0?l000080?ooo`030?l0003oool0o`0000P0oooo00<0o`000?ooo`3o
00001`3oool0103o00000?ZJ003jVP3o00080?ooo`030?l0003oool0o`0000P0oooo00<0o`000?oo
o`3o00002@3oool20?l000T0oooo00@0o`000?ooo`3oool0o`001P3oool00`3o0000oooo0?ooo`0h
0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00<0oooo00<0o`000?oo
o`3oool03P3oool00`3o0000oooo0?l000060?ooo`<0o`001P3oool00`3o00000?ZJ0?l0000]0?oo
o`030?l0003oool0o`0000P0oooo00<0o`000?ooo`3o0000203oool00`3o0000oooo0?l000070?oo
o`040?l00000nYX00?ZJ0?l000T0oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?l00009
0?ooo`80o`002@3oool0103o0000oooo0?ooo`3o00060?ooo`030?l0003oool0oooo03P0oooo00<0
00000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool00`3oool00`3o0000oooo0?ooo`0>
0?ooo`030?l0003oool0o`0000H0oooo0`3o00060?ooo`030?l00000nYX0o`0002d0oooo00<0o`00
003jVP3o0000203oool00`3o0000oooo0?l000080?ooo`030?l0003oool0o`0000L0oooo00@0o`00
003jVP00nYX0o`002@3oool00`3o0000oooo0?ooo`070?ooo`030?l0003oool0o`0001@0oooo00<0
o`000?ooo`3o00001`3oool00`3o0000oooo0?ooo`0h0?ooo`030000003oool0oooo00X0oooo000P
0?ooo`8000005@3oool00`3o0000oooo0?l000060?ooo`<0o`001P3oool00`3o00000?ZJ0?l0000]
0?ooo`030?l00000nYX0o`0000P0oooo00<0o`000?ooo`3o0000203oool00`3o0000oooo0?l00007
0?ooo`040?l00000nYX00?ZJ0?l000T0oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?l0
000D0?ooo`030?l0003oool0o`0000L0oooo00<0o`000?ooo`3oool0=`3oool2000000`0oooo000P
0?ooo`030000003oool0oooo01@0oooo00<0o`000?ooo`3o00001P3oool30?l000H0oooo00<0o`00
003jVP3o0000;@3oool00`3o00000?ZJ0?l000080?ooo`030?l0003oool0o`0000P0oooo00<0o`00
0?ooo`3o0000203oool00`3o00000?ZJ0?l000090?ooo`030?l0003oool0oooo00L0oooo00<0o`00
0?ooo`3o0000503oool00`3o0000oooo0?l000070?ooo`030?l0003oool0oooo03P0oooo00<00000
0?ooo`3oool02P3oool00180oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`0D0?oo
o`030?l0003oool0o`0000H0oooo0`3o00060?ooo`030?l00000nYX0o`0002d0oooo00<0o`00003j
VP3o0000203oool00`3o0000oooo0?l000080?ooo`030?l0003oool0o`0000P0oooo00<0o`00003j
VP3o00002@3oool00`3o0000oooo0?ooo`070?ooo`030?l0003oool0o`0001D0oooo0P3o00070?oo
o`030?l0003oool0oooo0080oooo0P3o000d0?ooo`030000003oool0oooo00X0oooo000A0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo01@0oooo00<0o`000?ooo`3o00001P3oool30?l000H0oooo00<0o`00003jVP3o0000;@3oool0
0`3o00000?ZJ0?l000080?ooo`030?l0003oool0o`0000P0oooo00<0o`000?ooo`3o0000203oool0
0`3o00000?ZJ0?l0000D0?ooo`80o`005@3oool20?l000L0oooo00D0o`000?ooo`3oool0oooo0?l0
00020?ooo`030?l0003oool0oooo0340oooo00<000000?ooo`3oool02P3oool001D0oooo00@00000
0?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`<00000503oool20?l000L0oooo0`3o
00060?ooo`030?l00000nYX0o`0002d0oooo00<0o`00003jVP3o0000203oool00`3o0000oooo0?l0
00080?ooo`030?l0003oool0o`0000P0oooo00<0o`00003jVP3o0000503oool20?l001D0oooo0P3o
00070?ooo`040?l0003oool0oooo0?l000<0oooo00<0o`000?ooo`3oool0<03oool2000000`0oooo
000E0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`0D0?ooo`80o`001`3oool30?l000H0oooo00<0o`00003jVP3o0000;@3oool00`3o00000?ZJ
0?l000090?ooo`80o`00203oool00`3o0000oooo0?l000080?ooo`030?l00000nYX0o`0001@0oooo
0P3o000E0?ooo`80o`001`3oool0103o0000oooo0?ooo`3o00040?ooo`030?l0003oool0oooo0300
oooo00<000000?ooo`3oool02P3oool00140oooo100000030?ooo`040000003oool0oooo000000@0
oooo00<000000?ooo`3oool0503oool20?l000L0oooo0`3o00060?ooo`030?l00000nYX0o`0002d0
oooo00<0o`00003jVP3o00002@3oool20?l000P0oooo00<0o`000?ooo`3o0000203oool00`3o0000
0?ZJ0?l0000D0?ooo`80o`005P3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0o`0000@0
oooo00<0o`000?ooo`3oool0<03oool00`000000oooo0?ooo`0:0?ooo`004@3oool00`000000oooo
0?ooo`040?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0503oool20?l000L0
oooo00<0o`00003jVP3o00001P3oool00`3o00000?ZJ0?l0000]0?ooo`030?l00000nYX0o`0000T0
oooo0P3o00080?ooo`80o`002@3oool00`3o00000?ZJ0?l0000D0?ooo`80o`005P3oool00`3o0000
oooo0?ooo`060?ooo`80o`001P3oool00`3o0000oooo0?ooo`0_0?ooo`030000003oool0oooo00X0
oooo000A0?ooo`D000000`3oool2000000D0oooo00<000000?ooo`3oool0503oool20?l000L0oooo
00<0o`00003jVP3o00001P3oool00`3o00000?ZJ0?l0000]0?ooo`030?l00000nYX0o`0000T0oooo
0P3o00080?ooo`80o`002@3oool00`3o00000?ZJ0?l0000D0?ooo`030?l0003oool0oooo01h0oooo
0P3o00060?ooo`030?l0003oool0oooo00<0oooo0P3o000Z0?ooo`030000003oool0oooo00X0oooo
000P0?ooo`8000005@3oool20?l000L0oooo00<0o`00003jVP3o00001P3oool00`3o00000?ZJ0?l0
000]0?ooo`030?l00000nYX0o`0000X0oooo00<0o`000?ooo`3oool01P3oool20?l000T0oooo00<0
o`00003jVP3o0000503oool00`3o0000oooo0?ooo`0N0?ooo`80o`001P3oool00`3o0000oooo0?oo
o`020?ooo`030?l0003oool0oooo02H0o`000`3oool2000000`0oooo000P0?ooo`030000003oool0
oooo01@0oooo0P3o00070?ooo`030?l00000nYX0o`0000H0oooo00<0o`00003jVP3o0000;@3oool0
0`3o00000?ZJ0?l0000D0?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3o0000503oool0
0`3o0000oooo0?ooo`0N0?ooo`030?l0003oool0oooo00H0oooo00@0o`000?ooo`3oool0o`00;@3o
ool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0E0?ooo`030?l0003oool0
oooo00D0oooo00<0o`00003jVP3o00001P3oool00`3o00000?ZJ0?l0000]0?ooo`030?l00000nYX0
o`0001@0oooo00<0o`000?ooo`3oool01`3oool00`3o0000oooo0?l0000D0?ooo`030?l0003oool0
oooo01h0oooo00<0o`000?ooo`3oool01`3oool20?l002h0oooo00<000000?ooo`3oool02P3oool0
0200oooo00<000000?ooo`3oool05@3oool00`3o0000oooo0?ooo`050?ooo`030?l00000nYX0o`00
00H0oooo00<0o`00003jVP3o0000;@3oool00`3o00000?ZJ0?l0000D0?ooo`030?l0003oool0oooo
00L0oooo00<0o`000?ooo`3o0000K`3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000001H0
oooo00<0o`000?ooo`3oool01@3oool00`3o00000?ZJ0?l000060?ooo`030?l0003oool0o`0002d0
oooo00<0o`00003jVP3o0000503oool00`3o0000oooo0?ooo`070?ooo`80o`00K`3oool2000000`0
oooo000P0?ooo`030000003oool0oooo01d0oooo00<0o`00003jVP3o00001P3oool00`3o0000oooo
0?l0000]0?ooo`030?l0003oool0o`0001@0oooo00<0o`000?ooo`3oool01`3oool20?l00700oooo
00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool07@3oool00`3o00000?ZJ0?l0
00060?ooo`030?l0003oool0o`0002d0oooo00<0o`000?ooo`3o00007P3oool20?l00700oooo00<0
00000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool07@3oool00`3o00000?ZJ0?l00006
0?ooo`030?l0003oool0o`0002d0oooo00<0o`000?ooo`3o00007P3oool20?l00700oooo00<00000
0?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool07@3oool00`3o00000?ZJ0?l000060?oo
o`030?l0003oool0o`0002d0oooo00<0o`000?ooo`3o00007P3oool20?l00700oooo00<000000?oo
o`3oool02P3oool00200oooo0P00000N0?ooo`030?l00000nYX0o`0000H0oooo0P3o000^0?ooo`03
0?l0003oool0o`0001h0oooo0P3o001_0?ooo`800000303oool00200oooo00<000000?ooo`3oool0
7@3oool00`3o00000?ZJ0?l000060?ooo`80o`00;`3oool20?l001h0oooo0P3o001`0?ooo`030000
003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo01d0oooo00<0o`00003jVP3o00001P3o
ool20?l002l0oooo0P3o000N0?ooo`80o`00L03oool00`000000oooo0?ooo`0:0?ooo`00803oool0
0`000000oooo0?ooo`0M0?ooo`80o`001`3oool20?l002l0oooo0P3o000O0?ooo`030?l0003oool0
oooo06h0oooo00<000000?ooo`3oool02P3oool00200oooo0P00000N0?ooo`80o`001`3oool20?l0
02l0oooo0P3o000O0?ooo`030?l0003oool0oooo06d0oooo0P00000<0?ooo`00803oool00`000000
oooo0?ooo`0M0?ooo`80o`001`3oool20?l002l0oooo0P3o000O0?ooo`030?l0003oool0oooo06h0
oooo00<000000?ooo`3oool02P3oool001<0oooo00<000000?ooo`3oool00P3oool3000000D0oooo
00<000000?ooo`3oool07@3oool20?l000P0oooo00<0o`000?ooo`3oool0;@3oool20?l001l0oooo
00<0o`000?ooo`3oool0KP3oool00`000000oooo0?ooo`0:0?ooo`004`3oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0M0?ooo`80o`00
203oool00`3o0000oooo0?ooo`0]0?ooo`80o`007`3oool00`3o0000oooo0?ooo`1^0?ooo`030000
003oool0oooo00X0oooo000D0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3o
ool3000001d0oooo0P3o00080?ooo`030?l0003oool0oooo02d0oooo00<0o`000?ooo`3oool07P3o
ool00`3o0000oooo0?ooo`1]0?ooo`800000303oool001@0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo01d0oooo0P3o00080?ooo`030?l0003oool0
oooo02d0oooo00<0o`000?ooo`3oool07P3oool00`3o0000oooo0?ooo`1^0?ooo`030000003oool0
oooo00X0oooo000E0?ooo`030000003oool0000000<000001@3oool00`000000oooo0?ooo`0M0?oo
o`80o`00203oool00`3o0000oooo0?ooo`0]0?ooo`030?l0003oool0oooo01h0oooo00<0o`000?oo
o`3oool0KP3oool00`000000oooo0?ooo`0:0?ooo`004@3oool01`000000oooo0?ooo`3oool00000
0?ooo`000000203oool00`000000oooo0?ooo`0M0?ooo`80o`00203oool00`3o0000oooo0?ooo`0]
0?ooo`030?l0003oool0oooo08l0oooo00<000000?ooo`3oool02P3oool00140oooo1@0000000`3o
ool0000000000003000000@0oooo00<000000?ooo`3oool07@3oool20?l000P0oooo00<0o`000?oo
o`3oool0;@3oool00`3o0000oooo0?ooo`2?0?ooo`030000003oool0oooo00X0oooo000P0?ooo`80
00007P3oool20?l000P0oooo00<0o`000?ooo`3oool0;@3oool00`3o0000oooo0?ooo`2>0?ooo`80
0000303oool00200oooo00<000000?ooo`3oool07@3oool20?l003P0oooo00<0o`000?ooo`3oool0
S`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0M0?ooo`80o`00>03o
ool00`3o0000oooo0?ooo`2?0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0
oooo01h0oooo00<0o`000?ooo`3oool0b03oool00`000000oooo0?ooo`0:0?ooo`00803oool20000
01l0oooo00<0o`000?ooo`3oool0a`3oool2000000`0oooo000P0?ooo`030000003oool0oooo01h0
oooo00<0o`000?ooo`3oool0b03oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo
0?ooo`0N0?ooo`030?l0003oool0oooo0<P0oooo00<000000?ooo`3oool02P3oool00200oooo00<0
00000?ooo`3oool07P3oool00`3o0000oooo0?ooo`380?ooo`030000003oool0oooo00X0oooo000P
0?ooo`030000003oool0oooo01h0oooo00<0o`000?ooo`3oool0b03oool00`000000oooo0?ooo`0:
0?ooo`00803oool2000001l0oooo00<0o`000?ooo`3oool0a`3oool2000000`0oooo000P0?ooo`03
0000003oool0oooo01h0oooo00<0o`000?ooo`3oool0b03oool00`000000oooo0?ooo`0:0?ooo`00
803oool00`000000oooo0?ooo`0N0?ooo`030?l0003oool0oooo0<P0oooo00<000000?ooo`3oool0
2P3oool00200oooo00<000000?ooo`3oool07P3oool00`3o0000oooo0?ooo`380?ooo`030000003o
ool0oooo00X0oooo000P0?ooo`8000007`3oool00`3o0000oooo0?ooo`370?ooo`800000303oool0
0200oooo00<000000?ooo`3oool07P3oool00`3o0000oooo0?ooo`380?ooo`030000003oool0oooo
00X0oooo000P0?ooo`030000003oool0oooo0>T0oooo00<000000?ooo`3oool02P3oool00200oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo02d0oooo
00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo01l0oooo
00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00D000000?ooo`3oool0oooo0000000<0?ooo`00803o
ooo]000000`0oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo001K0?ooo`<0<c<c
M03oool303<c<d@0oooo001N0?ooo`0303<c<`3oool0oooo0780oooo00<0<c<c0?ooo`3oool0@`3o
ool004<0oooo0`0c<c<20?ooo`H0<c<c00<0oooo03<c<`0c<c<00P0c<c<01@3oool0<c<c03<c<`0c
<c<0oooo0080<c<c00<0oooo03<c<`0c<c<00P0c<c<20?ooo`<0<c<c203oool503<c<`050?ooo`0c
<c<0<c<c03<c<`3oool00P0c<c<60?ooo`<0<c<c00<0oooo03<c<`0c<c<00P3oool203<c<`080?oo
o`0c<c<0<c<c0?ooo`0c<c<0oooo03<c<`3oool403<c<`<0oooo0`0c<c<20?ooo`<0<c<c2P3oool3
03<c<`80oooo1@0c<c<70?ooo`@0<c<c103oool203<c<`030?ooo`0c<c<0<c<c0080<c<c00<0oooo
03<c<`0c<c<0100c<c<30?ooo`<0<c<c0`3oool303<c<`@0oooo0P0c<c<20?ooo`@0<c<c<@3oool0
0480oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c
0P3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00<0<c<c0?ooo`0c<c<00`3oool00`0c<c<0
oooo03<c<`0=0?ooo`0303<c<`3oool0oooo0080oooo00@0<c<c0?ooo`3oool0<c<c203oool0100c
<c<0oooo0?ooo`0c<c<20?ooo`0:03<c<`3oool0oooo03<c<`3oool0<c<c0?ooo`0c<c<0oooo03<c
<`80oooo00H0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<60?ooo`0303<c<`3oool0oooo00P0oooo00D0
<c<c0?ooo`3oool0oooo03<c<`030?ooo`0303<c<`3oool0oooo00/0oooo00@0<c<c0?ooo`3oool0
<c<c0P3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00<0oooo00@0<c<c0?oo
o`3oool0<c<c0P3oool00`0c<c<0oooo03<c<`030?ooo`0403<c<`3oool0oooo03<c<`80oooo00<0
<c<c0?ooo`3oool00`3oool00`0c<c<0oooo0?ooo`0^0?ooo`00@P3oool00`0c<c<0oooo0?ooo`04
0?ooo`0403<c<`3oool0oooo03<c<`80oooo0`0c<c<30?ooo`0603<c<`3oool0oooo03<c<`3oool0
<c<c0`3oool00`0c<c<0oooo03<c<`0403<c<`T0oooo00<0<c<c0?ooo`3oool00P3oool0100c<c<0
oooo0?ooo`0c<c<80?ooo`0403<c<`3oool0oooo03<c<`80oooo00X0<c<c0?ooo`3oool0<c<c0?oo
o`0c<c<0oooo03<c<`3oool0<c<c0P3oool01@0c<c<0oooo0?ooo`0c<c<0oooo00D0<c<c0P3oool0
0`0c<c<0oooo0?ooo`080?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3oool00`0c<c<0oooo0?oo
o`080?ooo`<0<c<c0`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0403<c<`3oool0oooo03<c<`80
oooo0`0c<c<30?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c0`3oool0100c<c<0oooo0?ooo`0c
<c<50?ooo`<0<c<c<@3oool00480oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`0603<c<`3o
ool0oooo03<c<`3oool0<c<c0P3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00<0<c<c0?oo
o`0c<c<00`3oool00`0c<c<0oooo03<c<`030?ooo`0303<c<`3oool0oooo00L0oooo00<0<c<c0?oo
o`3oool00P3oool0100c<c<0oooo0?ooo`0c<c<80?ooo`0403<c<`3oool0oooo03<c<`80oooo00X0
<c<c0?ooo`3oool0<c<c0?ooo`0c<c<0oooo03<c<`3oool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c
<c<0oooo03<c<`<0oooo00<0<c<c0?ooo`3oool00P0c<c<90?ooo`0503<c<`3oool0oooo0?ooo`0c
<c<00`3oool00`0c<c<0oooo0?ooo`070?ooo`0303<c<`3oool0oooo00@0oooo00@0<c<c0?ooo`3o
ool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`H0oooo00H0<c<c0?ooo`3oool0<c<c
0?ooo`0c<c<30?ooo`0403<c<`3oool0oooo03<c<`@0oooo00<0<c<c0?ooo`3oool0<P3oool004<0
oooo0`0c<c<30?ooo`<0<c<c0`3oool203<c<`<0oooo100c<c<30?ooo`D0<c<c00@0oooo03<c<`0c
<c<0<c<c203oool303<c<`<0oooo100c<c<80?ooo`@0<c<c0P3oool203<c<`040?ooo`0c<c<0<c<c
0?ooo`80<c<c00<0oooo03<c<`3oool00P3oool303<c<`<0oooo0`0c<c<20?ooo`80<c<c00<0oooo
03<c<`0c<c<0203oool303<c<`<0oooo100c<c<80?ooo`@0<c<c00@0oooo03<c<`0c<c<0oooo0P0c
<c<00`3oool0<c<c03<c<`0203<c<`<0oooo100c<c<00`3oool0<c<c03<c<`0203<c<`<0oooo0`0c
<c<20?ooo`@0<c<c0`3oool403<c<c00oooo00190?ooo`0303<c<`3oool0oooo04D0oooo00<0<c<c
0?ooo`3oool0703oool00`0c<c<0oooo0?ooo`0/0?ooo`0303<c<`3oool0oooo03L0oooo00180?oo
o`80<c<c903oool00`0c<c<0oooo0?ooo`0O0?ooo`80<c<c7`3oool203<c<b`0oooo00<0<c<c0?oo
o`3oool0=`3oool00?l0oooo6P3oool00?l0oooo6P3oool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {1709.98, -78.0347, \
1.02251, 1.1263}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Show[p3,plot1[{time1,z1}//Transpose,
\t\t\tcolor->{2},
\t\t\tDisplayFunction->Identity,
\t\t\tdicke->.001]];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{55, 2}\),
      SequenceForm[ "Dimension der Daten  ", {55, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-7.21843 0.00414079 0.132867 0.00247346 [
[.02795 -0.0125 -12 -9 ]
[.02795 -0.0125 12 0 ]
[.23499 -0.0125 -12 -9 ]
[.23499 -0.0125 12 0 ]
[.44203 -0.0125 -12 -9 ]
[.44203 -0.0125 12 0 ]
[.64907 -0.0125 -12 -9 ]
[.64907 -0.0125 12 0 ]
[.85611 -0.0125 -12 -9 ]
[.85611 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00919 -18 -4.5 ]
[-0.0125 .00919 0 4.5 ]
[-0.0125 .13287 -6 -4.5 ]
[-0.0125 .13287 0 4.5 ]
[-0.0125 .25654 -12 -4.5 ]
[-0.0125 .25654 0 4.5 ]
[-0.0125 .38021 -18 -4.5 ]
[-0.0125 .38021 0 4.5 ]
[-0.0125 .50389 -18 -4.5 ]
[-0.0125 .50389 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -86 0 ]
[.5 .63053 86 12 ]
[.97619 .24298 -5 -6 ]
[.97619 .24298 5 6 ]
[.97619 .24298 -5 -6 ]
[.97619 .24298 5 6 ]
[.97619 .46025 -5 -6 ]
[.97619 .46025 5 6 ]
[.97619 .02571 -5 -6 ]
[.97619 .02571 5 6 ]
[.97619 .51724 -5 -6 ]
[.97619 .51724 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02795 0 m
.02795 .00625 L
s
[(1750)] .02795 -0.0125 0 1 Mshowa
.23499 0 m
.23499 .00625 L
s
[(1800)] .23499 -0.0125 0 1 Mshowa
.44203 0 m
.44203 .00625 L
s
[(1850)] .44203 -0.0125 0 1 Mshowa
.64907 0 m
.64907 .00625 L
s
[(1900)] .64907 -0.0125 0 1 Mshowa
.85611 0 m
.85611 .00625 L
s
[(1950)] .85611 -0.0125 0 1 Mshowa
.125 Mabswid
.06936 0 m
.06936 .00375 L
s
.11077 0 m
.11077 .00375 L
s
.15217 0 m
.15217 .00375 L
s
.19358 0 m
.19358 .00375 L
s
.2764 0 m
.2764 .00375 L
s
.31781 0 m
.31781 .00375 L
s
.35921 0 m
.35921 .00375 L
s
.40062 0 m
.40062 .00375 L
s
.48344 0 m
.48344 .00375 L
s
.52484 0 m
.52484 .00375 L
s
.56625 0 m
.56625 .00375 L
s
.60766 0 m
.60766 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.73188 0 m
.73188 .00375 L
s
.77329 0 m
.77329 .00375 L
s
.8147 0 m
.8147 .00375 L
s
.89752 0 m
.89752 .00375 L
s
.93892 0 m
.93892 .00375 L
s
.98033 0 m
.98033 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00919 m
.00625 .00919 L
s
[(-50)] -0.0125 .00919 1 0 Mshowa
0 .13287 m
.00625 .13287 L
s
[(0)] -0.0125 .13287 1 0 Mshowa
0 .25654 m
.00625 .25654 L
s
[(50)] -0.0125 .25654 1 0 Mshowa
0 .38021 m
.00625 .38021 L
s
[(100)] -0.0125 .38021 1 0 Mshowa
0 .50389 m
.00625 .50389 L
s
[(150)] -0.0125 .50389 1 0 Mshowa
.125 Mabswid
0 .03393 m
.00375 .03393 L
s
0 .05866 m
.00375 .05866 L
s
0 .0834 m
.00375 .0834 L
s
0 .10813 m
.00375 .10813 L
s
0 .1576 m
.00375 .1576 L
s
0 .18234 m
.00375 .18234 L
s
0 .20707 m
.00375 .20707 L
s
0 .23181 m
.00375 .23181 L
s
0 .28127 m
.00375 .28127 L
s
0 .30601 m
.00375 .30601 L
s
0 .33074 m
.00375 .33074 L
s
0 .35548 m
.00375 .35548 L
s
0 .40495 m
.00375 .40495 L
s
0 .42968 m
.00375 .42968 L
s
0 .45442 m
.00375 .45442 L
s
0 .47915 m
.00375 .47915 L
s
0 .52862 m
.00375 .52862 L
s
0 .55335 m
.00375 .55335 L
s
0 .57809 m
.00375 .57809 L
s
0 .60282 m
.00375 .60282 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02795 .61178 m
.02795 .61803 L
s
.23499 .61178 m
.23499 .61803 L
s
.44203 .61178 m
.44203 .61803 L
s
.64907 .61178 m
.64907 .61803 L
s
.85611 .61178 m
.85611 .61803 L
s
.125 Mabswid
.06936 .61428 m
.06936 .61803 L
s
.11077 .61428 m
.11077 .61803 L
s
.15217 .61428 m
.15217 .61803 L
s
.19358 .61428 m
.19358 .61803 L
s
.2764 .61428 m
.2764 .61803 L
s
.31781 .61428 m
.31781 .61803 L
s
.35921 .61428 m
.35921 .61803 L
s
.40062 .61428 m
.40062 .61803 L
s
.48344 .61428 m
.48344 .61803 L
s
.52484 .61428 m
.52484 .61803 L
s
.56625 .61428 m
.56625 .61803 L
s
.60766 .61428 m
.60766 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.73188 .61428 m
.73188 .61803 L
s
.77329 .61428 m
.77329 .61803 L
s
.8147 .61428 m
.8147 .61803 L
s
.89752 .61428 m
.89752 .61803 L
s
.93892 .61428 m
.93892 .61803 L
s
.98033 .61428 m
.98033 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00919 m
1 .00919 L
s
.99375 .13287 m
1 .13287 L
s
.99375 .25654 m
1 .25654 L
s
.99375 .38021 m
1 .38021 L
s
.99375 .50389 m
1 .50389 L
s
.125 Mabswid
.99625 .03393 m
1 .03393 L
s
.99625 .05866 m
1 .05866 L
s
.99625 .0834 m
1 .0834 L
s
.99625 .10813 m
1 .10813 L
s
.99625 .1576 m
1 .1576 L
s
.99625 .18234 m
1 .18234 L
s
.99625 .20707 m
1 .20707 L
s
.99625 .23181 m
1 .23181 L
s
.99625 .28127 m
1 .28127 L
s
.99625 .30601 m
1 .30601 L
s
.99625 .33074 m
1 .33074 L
s
.99625 .35548 m
1 .35548 L
s
.99625 .40495 m
1 .40495 L
s
.99625 .42968 m
1 .42968 L
s
.99625 .45442 m
1 .45442 L
s
.99625 .47915 m
1 .47915 L
s
.99625 .52862 m
1 .52862 L
s
.99625 .55335 m
1 .55335 L
s
.99625 .57809 m
1 .57809 L
s
.99625 .60282 m
1 .60282 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -147 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(predicted) show
123.000 13.000 moveto
(number) show
165.000 13.000 moveto
(of) show
183.000 13.000 moveto
(sunspots) show
231.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 1 r
gsave
.97619 .24298 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .33687 m
.02795 .32653 L
.03209 .26812 L
.03623 .24227 L
.04037 .20765 L
.04451 .16739 L
.04865 .1527 L
.0528 .16451 L
.05694 .20967 L
.06108 .24771 L
.06522 .26794 L
.06936 .29829 L
.0735 .329 L
.07764 .29198 L
.08178 .24766 L
.08592 .21775 L
.09006 .18152 L
.0942 .16833 L
.09834 .22256 L
.10248 .31071 L
.10663 .3853 L
.11077 .38388 L
.11491 .33973 L
.11905 .28914 L
.12319 .23027 L
.12733 .19272 L
.13147 .15187 L
.13561 .19612 L
.13975 .36185 L
.14389 .49171 L
.14803 .45081 L
.15217 .35368 L
.15631 .29143 L
.16046 .23142 L
.1646 .18328 L
.16874 .15712 L
.17288 .20228 L
.17702 .33483 L
.18116 .44789 L
.1853 .46242 L
.18944 .42137 L
.19358 .3549 L
.19772 .30098 L
.20186 .27581 L
.206 .25266 L
.21014 .2284 L
.21429 .19201 L
.21843 .1693 L
.22257 .15077 L
.22671 .14317 L
Mistroke
.23085 .14929 L
.23499 .17324 L
.23913 .21506 L
.24327 .2414 L
.24741 .2452 L
.25155 .24903 L
.25569 .23651 L
.25983 .2013 L
.26398 .16391 L
.26812 .15007 L
.27226 .14033 L
.2764 .13442 L
.28054 .13719 L
.28468 .14686 L
.28882 .15922 L
.29296 .1757 L
.2971 .21782 L
.30124 .24446 L
.30538 .23551 L
.30952 .21118 L
.31366 .19151 L
.31781 .17142 L
.32195 .15175 L
.32609 .14172 L
.33023 .13972 L
.33437 .15229 L
.33851 .17791 L
.34265 .21992 L
.34679 .25723 L
.35093 .28635 L
.35507 .30333 L
.35921 .30155 L
.36335 .25538 L
.36749 .19719 L
.37164 .15254 L
.37578 .16951 L
.37992 .28054 L
.38406 .42324 L
.3882 .46478 L
.39234 .40149 L
.39648 .34133 L
.40062 .28545 L
.40476 .22785 L
.4089 .18772 L
.41304 .16112 L
.41718 .17283 L
.42133 .22494 L
.42547 .29174 L
.42961 .37897 L
.43375 .42586 L
Mistroke
.43789 .37319 L
.44203 .30631 L
.44617 .28602 L
.45031 .26628 L
.45445 .22924 L
.45859 .18397 L
.46273 .1488 L
.46687 .14481 L
.47101 .18932 L
.47516 .27355 L
.4793 .35679 L
.48344 .36904 L
.48758 .32618 L
.49172 .27737 L
.49586 .24826 L
.5 .24142 L
.50414 .20993 L
.50828 .16932 L
.51242 .15734 L
.51656 .21911 L
.5207 .33301 L
.52484 .44625 L
.52899 .42769 L
.53313 .3753 L
.53727 .30237 L
.54141 .23686 L
.54555 .18083 L
.54969 .16162 L
.55383 .15754 L
.55797 .14295 L
.56211 .15417 L
.56625 .21054 L
.57039 .26321 L
.57453 .28366 L
.57867 .29204 L
.58282 .28934 L
.58696 .25754 L
.5911 .20135 L
.59524 .16505 L
.59938 .1495 L
.60352 .14397 L
.60766 .15691 L
.6118 .22343 L
.61594 .30753 L
.62008 .34276 L
.62422 .32825 L
.62836 .28853 L
.63251 .23716 L
.63665 .20302 L
.64079 .19151 L
Mistroke
.64493 .16896 L
.64907 .15324 L
.65321 .1404 L
.65735 .14907 L
.66149 .19091 L
.66563 .24169 L
.66977 .27965 L
.67391 .27757 L
.67805 .27828 L
.68219 .26026 L
.68634 .23377 L
.69048 .18385 L
.69462 .14922 L
.69876 .13804 L
.7029 .13612 L
.70704 .16563 L
.71118 .23501 L
.71532 .29662 L
.71946 .36664 L
.7236 .3432 L
.72774 .28683 L
.73188 .23027 L
.73602 .1946 L
.74017 .16609 L
.74431 .15169 L
.74845 .17308 L
.75259 .21186 L
.75673 .24847 L
.76087 .27182 L
.76501 .27854 L
.76915 .2717 L
.77329 .25777 L
.77743 .24345 L
.78157 .23348 L
.78571 .2297 L
.78986 .23139 L
.794 .23628 L
.79814 .24179 L
.80228 .24595 L
.80642 .24785 L
.81056 .24759 L
.8147 .24592 L
.81884 .24383 L
.82298 .24213 L
.82712 .24123 L
.83126 .24118 L
.8354 .24173 L
.83954 .2425 L
.84369 .24319 L
.84783 .2436 L
Mistroke
.85197 .24367 L
.85611 .24351 L
.86025 .24322 L
.86439 .24295 L
.86853 .24277 L
.87267 .24272 L
.87681 .24277 L
.88095 .24287 L
.88509 .24297 L
.88923 .24305 L
.89337 .24308 L
.89752 .24307 L
.90166 .24303 L
.9058 .24299 L
.90994 .24296 L
.91408 .24295 L
.91822 .24295 L
.92236 .24296 L
.9265 .24297 L
.93064 .24299 L
.93478 .24299 L
.93892 .24299 L
.94306 .24299 L
.9472 .24299 L
.95135 .24298 L
.95549 .24298 L
.95963 .24298 L
.96377 .24298 L
.96791 .24298 L
.97205 .24298 L
.97619 .24298 L
Mfstroke
gsave
.97619 .24298 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33687 m
.02795 .32653 L
.03209 .26812 L
.03623 .24227 L
.04037 .20765 L
.04451 .16739 L
.04865 .1527 L
.0528 .16451 L
.05694 .20967 L
.06108 .24771 L
.06522 .26794 L
.06936 .29829 L
.0735 .329 L
.07764 .29198 L
.08178 .24766 L
.08592 .21775 L
.09006 .18152 L
.0942 .16833 L
.09834 .22256 L
.10248 .31071 L
.10663 .3853 L
.11077 .38388 L
.11491 .33973 L
.11905 .28914 L
.12319 .23027 L
.12733 .19272 L
.13147 .15187 L
.13561 .19612 L
.13975 .36185 L
.14389 .49171 L
.14803 .45081 L
.15217 .35368 L
.15631 .29143 L
.16046 .23142 L
.1646 .18328 L
.16874 .15712 L
.17288 .20228 L
.17702 .33483 L
.18116 .44789 L
.1853 .46242 L
.18944 .42137 L
.19358 .3549 L
.19772 .30098 L
.20186 .27581 L
.206 .25266 L
.21014 .2284 L
.21429 .19201 L
.21843 .1693 L
.22257 .15077 L
.22671 .14317 L
Mistroke
.23085 .14929 L
.23499 .17324 L
.23913 .21506 L
.24327 .2414 L
.24741 .2452 L
.25155 .24903 L
.25569 .23651 L
.25983 .2013 L
.26398 .16391 L
.26812 .15007 L
.27226 .14033 L
.2764 .13442 L
.28054 .13719 L
.28468 .14686 L
.28882 .15922 L
.29296 .1757 L
.2971 .21782 L
.30124 .24446 L
.30538 .23551 L
.30952 .21118 L
.31366 .19151 L
.31781 .17142 L
.32195 .15175 L
.32609 .14172 L
.33023 .13972 L
.33437 .15229 L
.33851 .17791 L
.34265 .21992 L
.34679 .25723 L
.35093 .28635 L
.35507 .30333 L
.35921 .30155 L
.36335 .25538 L
.36749 .19719 L
.37164 .15254 L
.37578 .16951 L
.37992 .28054 L
.38406 .42324 L
.3882 .46478 L
.39234 .40149 L
.39648 .34133 L
.40062 .28545 L
.40476 .22785 L
.4089 .18772 L
.41304 .16112 L
.41718 .17283 L
.42133 .22494 L
.42547 .29174 L
.42961 .37897 L
.43375 .42586 L
Mistroke
.43789 .37319 L
.44203 .30631 L
.44617 .28602 L
.45031 .26628 L
.45445 .22924 L
.45859 .18397 L
.46273 .1488 L
.46687 .14481 L
.47101 .18932 L
.47516 .27355 L
.4793 .35679 L
.48344 .36904 L
.48758 .32618 L
.49172 .27737 L
.49586 .24826 L
.5 .24142 L
.50414 .20993 L
.50828 .16932 L
.51242 .15734 L
.51656 .21911 L
.5207 .33301 L
.52484 .44625 L
.52899 .42769 L
.53313 .3753 L
.53727 .30237 L
.54141 .23686 L
.54555 .18083 L
.54969 .16162 L
.55383 .15754 L
.55797 .14295 L
.56211 .15417 L
.56625 .21054 L
.57039 .26321 L
.57453 .28366 L
.57867 .29204 L
.58282 .28934 L
.58696 .25754 L
.5911 .20135 L
.59524 .16505 L
.59938 .1495 L
.60352 .14397 L
.60766 .15691 L
.6118 .22343 L
.61594 .30753 L
.62008 .34276 L
.62422 .32825 L
.62836 .28853 L
.63251 .23716 L
.63665 .20302 L
.64079 .19151 L
Mistroke
.64493 .16896 L
.64907 .15324 L
.65321 .1404 L
.65735 .14907 L
.66149 .19091 L
.66563 .24169 L
.66977 .27965 L
.67391 .27757 L
.67805 .27828 L
.68219 .26026 L
.68634 .23377 L
.69048 .18385 L
.69462 .14922 L
.69876 .13804 L
.7029 .13612 L
.70704 .16563 L
.71118 .23501 L
.71532 .29662 L
.71946 .36664 L
.7236 .3432 L
.72774 .28683 L
.73188 .23027 L
.73602 .1946 L
.74017 .16609 L
.74431 .15169 L
.74845 .17308 L
.75259 .21186 L
.75673 .24847 L
.76087 .27182 L
.76501 .27854 L
.76915 .2717 L
.77329 .25777 L
.77743 .24345 L
.78157 .23348 L
.78571 .2297 L
.78986 .23139 L
.794 .23628 L
.79814 .24179 L
.80228 .24595 L
.80642 .24785 L
.81056 .24759 L
.8147 .24592 L
.81884 .24383 L
.82298 .24213 L
.82712 .24123 L
.83126 .24118 L
.8354 .24173 L
.83954 .2425 L
.84369 .24319 L
.84783 .2436 L
Mistroke
.85197 .24367 L
.85611 .24351 L
.86025 .24322 L
.86439 .24295 L
.86853 .24277 L
.87267 .24272 L
.87681 .24277 L
.88095 .24287 L
.88509 .24297 L
.88923 .24305 L
.89337 .24308 L
.89752 .24307 L
.90166 .24303 L
.9058 .24299 L
.90994 .24296 L
.91408 .24295 L
.91822 .24295 L
.92236 .24296 L
.9265 .24297 L
.93064 .24299 L
.93478 .24299 L
.93892 .24299 L
.94306 .24299 L
.9472 .24299 L
.95135 .24298 L
.95549 .24298 L
.95963 .24298 L
.96377 .24298 L
.96791 .24298 L
.97205 .24298 L
.97619 .24298 L
Mfstroke
1 0 0 r
gsave
.97619 .46025 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36867 m
.02795 .35495 L
.03209 .29509 L
.03623 .26917 L
.04037 .23455 L
.04451 .19428 L
.04865 .17959 L
.0528 .1914 L
.05694 .23656 L
.06108 .27461 L
.06522 .29484 L
.06936 .32518 L
.0735 .35589 L
.07764 .31887 L
.08178 .27456 L
.08592 .24465 L
.09006 .20842 L
.0942 .19522 L
.09834 .24945 L
.10248 .33761 L
.10663 .4122 L
.11077 .41078 L
.11491 .36662 L
.11905 .31603 L
.12319 .25716 L
.12733 .21961 L
.13147 .17877 L
.13561 .22301 L
.13975 .38875 L
.14389 .51861 L
.14803 .4777 L
.15217 .38057 L
.15631 .31832 L
.16046 .25831 L
.1646 .21018 L
.16874 .18401 L
.17288 .22918 L
.17702 .36173 L
.18116 .47479 L
.1853 .48932 L
.18944 .44826 L
.19358 .38179 L
.19772 .32787 L
.20186 .30271 L
.206 .27956 L
.21014 .25529 L
.21429 .2189 L
.21843 .19619 L
.22257 .17767 L
.22671 .17006 L
Mistroke
.23085 .17618 L
.23499 .20013 L
.23913 .24196 L
.24327 .26829 L
.24741 .27209 L
.25155 .27592 L
.25569 .26341 L
.25983 .22819 L
.26398 .19081 L
.26812 .17696 L
.27226 .16723 L
.2764 .16131 L
.28054 .16409 L
.28468 .17376 L
.28882 .18612 L
.29296 .20259 L
.2971 .24471 L
.30124 .27135 L
.30538 .26241 L
.30952 .23807 L
.31366 .2184 L
.31781 .19832 L
.32195 .17865 L
.32609 .16861 L
.33023 .16662 L
.33437 .17919 L
.33851 .2048 L
.34265 .24681 L
.34679 .28412 L
.35093 .31324 L
.35507 .33022 L
.35921 .32844 L
.36335 .28227 L
.36749 .22408 L
.37164 .17943 L
.37578 .19641 L
.37992 .30744 L
.38406 .45014 L
.3882 .49167 L
.39234 .42838 L
.39648 .36823 L
.40062 .31235 L
.40476 .25475 L
.4089 .21462 L
.41304 .18802 L
.41718 .19972 L
.42133 .25184 L
.42547 .31863 L
.42961 .40587 L
.43375 .45275 L
Mistroke
.43789 .40009 L
.44203 .3332 L
.44617 .31292 L
.45031 .29317 L
.45445 .25613 L
.45859 .21086 L
.46273 .17569 L
.46687 .1717 L
.47101 .21622 L
.47516 .30044 L
.4793 .38368 L
.48344 .39594 L
.48758 .35307 L
.49172 .30426 L
.49586 .27516 L
.5 .26831 L
.50414 .23682 L
.50828 .19622 L
.51242 .18423 L
.51656 .24601 L
.5207 .3599 L
.52484 .47315 L
.52899 .45459 L
.53313 .4022 L
.53727 .32927 L
.54141 .26375 L
.54555 .20772 L
.54969 .18851 L
.55383 .18444 L
.55797 .16985 L
.56211 .18107 L
.56625 .23744 L
.57039 .29011 L
.57453 .31055 L
.57867 .31893 L
.58282 .31624 L
.58696 .28443 L
.5911 .22824 L
.59524 .19195 L
.59938 .1764 L
.60352 .17086 L
.60766 .1838 L
.6118 .25033 L
.61594 .33442 L
.62008 .36965 L
.62422 .35514 L
.62836 .31542 L
.63251 .26405 L
.63665 .22992 L
.64079 .21841 L
Mistroke
.64493 .19586 L
.64907 .18013 L
.65321 .16729 L
.65735 .17596 L
.66149 .2178 L
.66563 .26859 L
.66977 .30655 L
.67391 .30446 L
.67805 .30517 L
.68219 .28715 L
.68634 .26066 L
.69048 .21075 L
.69462 .17612 L
.69876 .16494 L
.7029 .16301 L
.70704 .19253 L
.71118 .2619 L
.71532 .32352 L
.71946 .39354 L
.7236 .37009 L
.72774 .31373 L
.73188 .25716 L
.73602 .2215 L
.74017 .19303 L
.74431 .17918 L
.74845 .20394 L
.75259 .30387 L
.75673 .40345 L
.76087 .46222 L
.76501 .47985 L
.76915 .47345 L
.77329 .46127 L
.77743 .45199 L
.78157 .44657 L
.78571 .44469 L
.78986 .44656 L
.794 .45158 L
.79814 .4577 L
.80228 .46254 L
.80642 .46478 L
.81056 .46456 L
.8147 .46291 L
.81884 .46089 L
.82298 .45929 L
.82712 .45845 L
.83126 .45841 L
.8354 .45896 L
.83954 .45974 L
.84369 .46044 L
.84783 .46086 L
Mistroke
.85197 .46094 L
.85611 .46077 L
.86025 .46049 L
.86439 .46022 L
.86853 .46004 L
.87267 .45999 L
.87681 .46004 L
.88095 .46014 L
.88509 .46024 L
.88923 .46032 L
.89337 .46035 L
.89752 .46034 L
.90166 .4603 L
.9058 .46026 L
.90994 .46023 L
.91408 .46022 L
.91822 .46022 L
.92236 .46023 L
.9265 .46025 L
.93064 .46026 L
.93478 .46026 L
.93892 .46027 L
.94306 .46026 L
.9472 .46026 L
.95135 .46025 L
.95549 .46025 L
.95963 .46025 L
.96377 .46025 L
.96791 .46025 L
.97205 .46025 L
.97619 .46025 L
Mfstroke
gsave
.97619 .02571 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30507 m
.02795 .29811 L
.03209 .24115 L
.03623 .21536 L
.04037 .18076 L
.04451 .14049 L
.04865 .1258 L
.0528 .13761 L
.05694 .18277 L
.06108 .22082 L
.06522 .24105 L
.06936 .27139 L
.0735 .3021 L
.07764 .26508 L
.08178 .22077 L
.08592 .19086 L
.09006 .15463 L
.0942 .14143 L
.09834 .19566 L
.10248 .28382 L
.10663 .35841 L
.11077 .35699 L
.11491 .31283 L
.11905 .26224 L
.12319 .20337 L
.12733 .16582 L
.13147 .12498 L
.13561 .16922 L
.13975 .33496 L
.14389 .46482 L
.14803 .42391 L
.15217 .32678 L
.15631 .26453 L
.16046 .20452 L
.1646 .15639 L
.16874 .13022 L
.17288 .17539 L
.17702 .30794 L
.18116 .421 L
.1853 .43553 L
.18944 .39447 L
.19358 .328 L
.19772 .27408 L
.20186 .24892 L
.206 .22577 L
.21014 .2015 L
.21429 .16511 L
.21843 .1424 L
.22257 .12388 L
.22671 .11627 L
Mistroke
.23085 .12239 L
.23499 .14634 L
.23913 .18817 L
.24327 .2145 L
.24741 .2183 L
.25155 .22213 L
.25569 .20962 L
.25983 .1744 L
.26398 .13702 L
.26812 .12317 L
.27226 .11344 L
.2764 .10752 L
.28054 .1103 L
.28468 .11997 L
.28882 .13233 L
.29296 .1488 L
.2971 .19092 L
.30124 .21756 L
.30538 .20862 L
.30952 .18428 L
.31366 .16461 L
.31781 .14453 L
.32195 .12486 L
.32609 .11482 L
.33023 .11283 L
.33437 .1254 L
.33851 .15101 L
.34265 .19302 L
.34679 .23033 L
.35093 .25945 L
.35507 .27643 L
.35921 .27465 L
.36335 .22848 L
.36749 .17029 L
.37164 .12564 L
.37578 .14262 L
.37992 .25365 L
.38406 .39635 L
.3882 .43788 L
.39234 .37459 L
.39648 .31444 L
.40062 .25856 L
.40476 .20096 L
.4089 .16083 L
.41304 .13423 L
.41718 .14593 L
.42133 .19805 L
.42547 .26484 L
.42961 .35208 L
.43375 .39896 L
Mistroke
.43789 .34629 L
.44203 .27941 L
.44617 .25913 L
.45031 .23938 L
.45445 .20234 L
.45859 .15707 L
.46273 .1219 L
.46687 .11791 L
.47101 .16243 L
.47516 .24665 L
.4793 .32989 L
.48344 .34215 L
.48758 .29928 L
.49172 .25047 L
.49586 .22137 L
.5 .21452 L
.50414 .18303 L
.50828 .14243 L
.51242 .13044 L
.51656 .19221 L
.5207 .30611 L
.52484 .41936 L
.52899 .4008 L
.53313 .34841 L
.53727 .27548 L
.54141 .20996 L
.54555 .15393 L
.54969 .13472 L
.55383 .13065 L
.55797 .11606 L
.56211 .12728 L
.56625 .18365 L
.57039 .23632 L
.57453 .25676 L
.57867 .26514 L
.58282 .26245 L
.58696 .23064 L
.5911 .17445 L
.59524 .13816 L
.59938 .12261 L
.60352 .11707 L
.60766 .13001 L
.6118 .19654 L
.61594 .28063 L
.62008 .31586 L
.62422 .30135 L
.62836 .26163 L
.63251 .21026 L
.63665 .17613 L
.64079 .16462 L
Mistroke
.64493 .14207 L
.64907 .12634 L
.65321 .1135 L
.65735 .12217 L
.66149 .16401 L
.66563 .21479 L
.66977 .25276 L
.67391 .25067 L
.67805 .25138 L
.68219 .23336 L
.68634 .20687 L
.69048 .15696 L
.69462 .12233 L
.69876 .11115 L
.7029 .10922 L
.70704 .13874 L
.71118 .20811 L
.71532 .26973 L
.71946 .33975 L
.7236 .3163 L
.72774 .25993 L
.73188 .20337 L
.73602 .1677 L
.74017 .13914 L
.74431 .1242 L
.74845 .14221 L
.75259 .11985 L
.75673 .0935 L
.76087 .08141 L
.76501 .07723 L
.76915 .06996 L
.77329 .05426 L
.77743 .0349 L
.78157 .02039 L
.78571 .01472 L
.78986 .01622 L
.794 .02098 L
.79814 .02587 L
.80228 .02936 L
.80642 .03093 L
.81056 .03061 L
.8147 .02894 L
.81884 .02677 L
.82298 .02497 L
.82712 .02402 L
.83126 .02395 L
.8354 .0245 L
.83954 .02527 L
.84369 .02594 L
.84783 .02633 L
Mistroke
.85197 .02641 L
.85611 .02624 L
.86025 .02596 L
.86439 .02568 L
.86853 .0255 L
.87267 .02545 L
.87681 .0255 L
.88095 .0256 L
.88509 .02571 L
.88923 .02578 L
.89337 .02581 L
.89752 .0258 L
.90166 .02576 L
.9058 .02572 L
.90994 .02569 L
.91408 .02568 L
.91822 .02568 L
.92236 .02569 L
.9265 .0257 L
.93064 .02572 L
.93478 .02572 L
.93892 .02572 L
.94306 .02572 L
.9472 .02571 L
.95135 .02571 L
.95549 .02571 L
.95963 .02571 L
.96377 .02571 L
.96791 .02571 L
.97205 .02571 L
.97619 .02571 L
Mfstroke
0 .98 .604 r
gsave
.97619 .51724 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.75259 .24244 m
.75673 .29092 L
.76087 .30354 L
.76501 .3253 L
.76915 .29339 L
.77329 .22117 L
.77743 .1853 L
.78157 .16032 L
.78571 .14697 L
.78986 .15439 L
.794 .22216 L
.79814 .33 L
.80228 .41583 L
.80642 .40396 L
.81056 .35251 L
.8147 .30057 L
.81884 .25036 L
.82298 .20855 L
.82712 .17318 L
.83126 .15661 L
.8354 .21499 L
.83954 .36191 L
.84369 .50784 L
.84783 .47 L
.85197 .46604 L
.85611 .34039 L
.86025 .30452 L
.86439 .21078 L
.86853 .16725 L
.87267 .14375 L
.87681 .22686 L
.88095 .48336 L
.88509 .60332 L
.88923 .58996 L
.89337 .52615 L
.89752 .41064 L
.90166 .26619 L
.9058 .22562 L
.90994 .20188 L
.91408 .1581 L
.91822 .17022 L
.92236 .24912 L
.9265 .36488 L
.93064 .39481 L
.93478 .39382 L
.93892 .39134 L
.94306 .2976 L
.9472 .30329 L
.95135 .22686 L
.95549 .2182 L
Mistroke
.95963 .17121 L
.96377 .16403 L
.96791 .20089 L
.97205 .36166 L
.97619 .51724 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00703oool3000000@0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P00000L0?oo
o`<000000`3oool3000000@0oooo0P0000040?ooo`8000006`3oool3000000<0oooo0`0000030?oo
o`<00000103oool2000001`0oooo0`0000030?ooo`8000001@3oool2000000@0oooo0P00000L0?oo
o`<000000`3oool2000000@0oooo0`0000040?ooo`8000009@3oool001d0oooo00<000000?ooo`3o
ool00`3oool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3oool0
0`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06@3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo00@0oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo0280oooo000M0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01X0oooo00D000000?oo
o`3oool0oooo000000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`0I0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000
oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06P3oool00`00
0000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00`3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0280oooo000M0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo01X0oooo00<000000?ooo`3oool00P3oool3000000<0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000K0?ooo`030000003oool0oooo0080oooo0`0000060?oo
o`040000003oool0oooo00000080oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`02
0?ooo`@000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001`0oooo
00<000000?ooo`3oool00P3oool4000000D0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0R0?ooo`007@3oool00`000000oooo0?ooo`050?ooo`030000003oool0000000<00000
0`3oool010000000oooo0?ooo`00000L0?ooo`050000003oool0oooo0?ooo`0000000`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06@3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`0000000`0000030?ooo`040000
003oool0oooo000001`0oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo00000003000000<0oooo00@000000?ooo`3oool0
0000903oool001`0oooo0P0000030?ooo`070000003oool0oooo0?ooo`000000oooo000000060?oo
o`040000003oool0oooo000001/0oooo0P0000030?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001X0oooo0P0000030?ooo`07
0000003oool0oooo0?ooo`000000oooo000000060?ooo`040000003oool0oooo000001/0oooo0P00
00030?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000001/0oooo0P0000030?ooo`070000003oool0oooo0?ooo`000000oooo0000
00060?ooo`040000003oool0oooo000002@0oooo000M0?ooo`040000003oool0oooo0?ooo`D00000
00<0oooo0000000000000`0000030?ooo`8000007@3oool00`000000oooo0?ooo`020?ooo`<00000
103oool2000000@0oooo0P00000L0?ooo`030000003oool0oooo0080oooo0`0000020?ooo`D00000
0`3oool2000001d0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0P0000040?ooo`800000
7@3oool00`000000oooo0?ooo`020?ooo`<000000P3oool5000000<0oooo0P00000U0?ooo`00o`3o
oolJ0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`004P3oool3000000@0oooo0P00003n0?ooo`00
4@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000103oooo]0000
00`0oooo000;0?ooo`D000001@3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo
02d0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo
01l0oooo00<000000?ooo`3oool02P3oool001D0oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`020?ooo`<00000j03oool2000000`0oooo000A0?ooo`@000000`3oool010000000
oooo0?ooo`0000040?ooo`030000003oool0oooo0;L0oooo0P3o000`0?ooo`030000003oool0oooo
00X0oooo000A0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool00000103oool00`00
0000oooo0?ooo`2f0?ooo`030?l0003oool0o`000300oooo00<000000?ooo`3oool02P3oool00140
oooo1@0000030?ooo`8000001@3oool00`000000oooo0?ooo`2f0?ooo`040?l0003oool0oooo0?l0
00D0oooo103o000V0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo0;H0
oooo00D0o`000?ooo`3oool0oooo0?l000020?ooo`80o`00103ooolR0?l000@0oooo00<000000?oo
o`3oool02P3oool00200oooo00<000000?ooo`3oool0]@3oool00`3o0000oooo0?ooo`030?ooo`80
o`00;03oool00`000000oooo0?ooo`0:0?ooo`00803oool200000;H0oooo00<0o`000?ooo`3oool0
<03oool2000000`0oooo000P0?ooo`030000003oool0oooo0;D0oooo00<0o`000?ooo`3oool0<@3o
ool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`2e0?ooo`030?l0003oool0
oooo0340oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0]03oool00`3o
0000oooo0?ooo`0b0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo0;@0
oooo00<0o`000?ooo`3oool0<P3oool00`000000oooo0?ooo`0:0?ooo`00803oool200000;D0oooo
00<0o`000?ooo`3oool0<@3oool2000000`0oooo000P0?ooo`030000003oool0oooo0;@0oooo00<0
o`000?ooo`3oool0<P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`2c
0?ooo`030?l0003oool0oooo03<0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?oo
o`3oool0/`3oool00`3o0000oooo0?ooo`0c0?ooo`030000003oool0oooo00X0oooo000P0?ooo`03
0000003oool0oooo0;<0oooo00<0o`000?ooo`3oool0<`3oool00`000000oooo0?ooo`0:0?ooo`00
803oool00`000000oooo0?ooo`2b0?ooo`030?l0003oool0oooo03@0oooo00<000000?ooo`3oool0
2P3oool00200oooo0P00002b0?ooo`030?l0003oool0oooo03@0oooo0P00000<0?ooo`00803oool0
0`000000oooo0?ooo`2a0?ooo`030?l0003oool0oooo03D0oooo00<000000?ooo`3oool02P3oool0
0200oooo00<000000?ooo`3oool0/03oool00`3o0000oooo0?ooo`0f0?ooo`030000003oool0oooo
00X0oooo000P0?ooo`030000003oool0oooo0;00oooo00<0o`000?ooo`3oool0=P3oool00`000000
oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`2`0?ooo`030?l0003oool0oooo03H0oooo
00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0/03oool00`3o0000oooo0?oo
o`0f0?ooo`030000003oool0oooo00X0oooo000P0?ooo`800000?`3oool00`3o0000oooo0?ooo`1R
0?ooo`030?l0003oool0oooo00X0oooo00<0o`000?ooo`3oool0=@3oool2000000`0oooo000P0?oo
o`030000003oool0oooo03d0oooo00<0o`000?ooo`3o00002`3oool00`3o0000oooo0?ooo`190?oo
o`030?l0003oool0oooo00P0oooo0P3o000;0?ooo`030?l0003oool0oooo03L0oooo00<000000?oo
o`3oool02P3oool00200oooo00<000000?ooo`3oool0<`3oool00`3o0000oooo0?ooo`070?ooo`03
0?l0003oool0o`0000X0oooo0P3o000O0?ooo`030?l0003oool0oooo01<0oooo00<0o`000?ooo`3o
ool0203oool00`3o0000oooo0?ooo`080?ooo`030?l0003oool0oooo00P0oooo0P3o000;0?ooo`03
0?l0003oool0oooo03L0oooo00<000000?ooo`3oool02P3oool001T0oooo0P0000050?ooo`030000
003oool0oooo03<0oooo0P3o00070?ooo`050?l0003oool0oooo0?ooo`3o00002@3oool00`3o0000
oooo0?l0000M0?ooo`80o`005@3oool00`3o0000oooo0?ooo`080?ooo`030?l0003oool0oooo00L0
oooo00<0o`000?ooo`3o0000203oool00`3o0000oooo0?l0000;0?ooo`030?l0003oool0oooo03L0
oooo00<000000?ooo`3oool02P3oool001P0oooo00@000000?ooo`3oool00000103oool00`000000
oooo0?ooo`090?ooo`030?l0003oool0oooo0100oooo00<0o`000?ooo`3oool04`3oool00`3o0000
oooo0?l000070?ooo`050?l0003oool0oooo0?ooo`3o0000203oool0103o0000oooo0?ooo`3o0008
0?ooo`030?l0003oool0oooo0180oooo0P3o000D0?ooo`030?l0003oool0o`0000P0oooo00<0o`00
0?ooo`3o0000203oool00`3o0000oooo0?l000080?ooo`040?l0003oool0oooo0?l000P0oooo00<0
o`000?ooo`3o0000>@3oool00`000000oooo0?ooo`0:0?ooo`00603oool010000000oooo0?ooo`00
00040?ooo`030000003oool0oooo00T0oooo00<0o`000?ooo`3oool0403oool00`3o0000oooo0?oo
o`060?ooo`030?l0003oool0oooo00X0oooo00<0o`000?ooo`3o00001`3oool00`3o0000oooo0?oo
o`020?ooo`030?l0003oool0oooo00D0oooo00@0o`000?ooo`3oool0o`00203oool00`3o0000oooo
0?ooo`0B0?ooo`80o`002P3oool00`3o0000oooo0?ooo`070?ooo`030?l0003oool0o`0000P0oooo
00<0o`000?ooo`3o0000203oool00`3o0000oooo0?l000080?ooo`040?l0003oool0oooo0?l000P0
oooo00<0o`000?ooo`3o0000>@3oool00`000000oooo0?ooo`0:0?ooo`00603oool010000000oooo
0?ooo`0000040?ooo`<000002@3oool20?l00140oooo00<0o`000?ooo`3oool01P3oool00`3o0000
oooo0?ooo`0:0?ooo`030?l0003oool0o`0000H0oooo00@0o`000?ooo`3oool0003o0P3oool00`3o
0000oooo0?ooo`050?ooo`040?l0003oool0oooo0?l000P0oooo00<0o`000?ooo`3oool01`3oool0
0`3o0000oooo0?ooo`080?ooo`80o`002P3oool00`3o0000oooo0?ooo`060?ooo`040?l0003oool0
oooo0?l000L0oooo00@0o`000?ooo`3oool0o`00203oool00`3o0000oooo0?l000080?ooo`040?l0
003oool0oooo0?l000L0oooo0`3o000i0?ooo`800000303oool001P0oooo00@000000?ooo`3oool0
0000103oool00`000000oooo0?ooo`080?ooo`030?l0003oool0o`000140oooo00<0o`000?ooo`3o
ool01P3oool00`3o0000oooo0?ooo`090?ooo`050?l0003oool0oooo0?ooo`3o00001@3oool00`3o
0000oooo0?ooo`020000o`030?ooo`3o0000oooo00D0oooo00D0o`000?ooo`3oool0oooo0?l00008
0?ooo`80o`00203oool00`3o0000oooo0?ooo`080?ooo`80o`002@3oool20?l000P0oooo00@0o`00
0?ooo`3oool0o`001`3oool0103o0000oooo0?ooo`3o00070?ooo`040?l0003oool0oooo0?l000P0
oooo00@0o`000000o`000?l0o`001`3oool00`3o0000oooo0?l0000j0?ooo`030000003oool0oooo
00X0oooo000H0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0203oool00`3o
0000oooo0?l000080?ooo`030?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool01P3oool00`3o
0000oooo0?ooo`090?ooo`050?l0003oool0003o0?ooo`3o00001@3oool01`3o0000oooo0000o`3o
ool0003o0?ooo`3o00001P3oool01P3o0000oooo0000o`000?l0oooo0?l000L0oooo0P3o00080?oo
o`80o`00203oool0103o0000oooo0?ooo`3o00080?ooo`80o`00203oool0103o0000oooo0000o`3o
00070?ooo`040?l0003oool0oooo0?l000L0oooo00@0o`000?ooo`000?l0o`001`3oool01@3o0000
oooo0000o`000?l0o`0000L0oooo00<0o`000?ooo`3o0000>P3oool00`000000oooo0?ooo`0:0?oo
o`006@3oool2000000D0oooo00<000000?ooo`3oool0203oool00`3o0000oooo0?l000080?ooo`03
0?l0003oool0oooo00H0oooo00<0o`000?ooo`3oool01@3oool20?l000/0oooo00D0o`000?ooo`00
0?l0oooo0?l000050?ooo`030?l0003oool0003o0080oooo00<0003o0?ooo`3o00001@3oool01P3o
0000oooo0000o`000?l0oooo0?l000L0oooo0P3o00080?ooo`80o`00203oool0103o0000oooo0000
o`3o00080?ooo`80o`001`3oool01@3o0000oooo0?ooo`000?l0o`0000L0oooo00@0o`000?ooo`00
0?l0o`001`3oool01@3o0000oooo0000o`3oool0o`0000H0oooo00D0o`000000o`3oool0003o0?l0
00070?ooo`030?l0003oool0oooo00P0oooo00<00?ZJ0?ooo`3oool04@3oool00`00nYX0oooo0?oo
o`0K0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00P0oooo00<0o`00
0?ooo`3o00001`3oool20?l000L0oooo00<0o`000000o`3o00001P3oool20?l000/0oooo00D0o`00
0000o`3oool0003o0?l000050?ooo`030?l000000?l0oooo0080oooo00<0003o0?ooo`3o00001@3o
ool01P3o0000003o0?ooo`3oool0003o0?l000H0oooo00<0o`000?ooo`3o00001`3oool00`3o0000
oooo0?l000080?ooo`040?l000000?l0003o0?l000P0oooo0P3o00070?ooo`050?l0003oool0oooo
0000o`3o00001`3oool0103o0000003o0000o`3o00070?ooo`050?l000000?l0oooo0000o`3o0000
1P3oool01@3o0000003o0?ooo`000?l0o`0000L0oooo00<0o`000000o`3oool0203oool00`00nYX0
oooo0?ooo`0A0?ooo`03003jVP3oool0oooo01/0oooo00<000000?ooo`3oool02P3oool00200oooo
00<000000?ooo`3oool0203oool00`3o0000003o0?l000070?ooo`80o`001`3oool00`3o0000003o
0?l000060?ooo`030?l0003oool0o`0000X0oooo00D0o`000000o`3oool0003o0?l000050?ooo`03
0?l000000?l0oooo00<0oooo00<0003o0?l0003oool0103oool01P3o0000003o0?ooo`3oool0003o
0?l000H0oooo00<0o`000000o`3o00001`3oool00`3o0000oooo0?l000080?ooo`040?l000000?l0
003o0?l000P0oooo0P3o00070?ooo`050?l0003oool0003o0?ooo`3o00001`3oool0103o0000003o
0?ooo`3o00060?ooo`060?l0003oool0003o0?ooo`000?l0o`001P3oool01@3o0000003o0?ooo`3o
ool0o`0000H0oooo00<0o`000?ooo`000?l0203oool00`00nYX0oooo003jVP0B0?ooo`03003jVP3o
ool0oooo01/0oooo00<000000?ooo`3oool02P3oool00200oooo0P0000090?ooo`030?l000000?l0
o`0000L0oooo0P3o00070?ooo`030?l000000?l0o`0000H0oooo00<0o`000000o`3o00002@3oool0
1P3o0000oooo0000o`3oool0003o0?l000@0oooo00<0o`000000o`3oool0103oool00`000?l0o`00
0?ooo`030?ooo`030?l0003oool0003o0080oooo00<0003o0?l0003oool01@3oool00`3o0000003o
0?l000070?ooo`030?l0003oool0o`0000P0oooo00@0o`000000o`000?l0o`00203oool20?l000L0
oooo00H0o`000?ooo`000?l0oooo0000o`3o00050?ooo`050?l0003oool0003o0?ooo`3o00001P3o
ool01P3o0000oooo0000o`3oool0003o0?l000H0oooo00D0o`000000o`3oool0oooo0?l000060?oo
o`030?l0003oool0003o00P0oooo00<00?ZJ0?ooo`00nYX0203oool00`00nYX0oooo0?ooo`060?oo
o`800?ZJ2@3oool00`00nYX0oooo0?ooo`0@0?ooo`800000303oool00200oooo00<000000?ooo`3o
ool01`3oool0103o0000003o0?ooo`3o00070?ooo`80o`001`3oool00`3o0000003o0?l000060?oo
o`030?l000000?l0o`0000T0oooo00<0o`000000o`3oool00P3oool00`3o0000oooo0?ooo`020?oo
o`040?l000000?l0oooo0?ooo`80o`0000<0oooo0000o`3o0000103oool00`3o0000003o0?ooo`02
0?ooo`030000o`3o0000oooo00D0oooo00<0o`000000o`3o00001`3oool00`3o0000003o0?l00008
0?ooo`040?l000000?l0003o0?l000P0oooo00<0o`000000o`3o00001P3oool01P3o0000003o0?oo
o`3oool0003o0?l000D0oooo00D0o`000000o`3oool0oooo0?l000060?ooo`060?l000000?l0oooo
0?ooo`000?l0o`001P3oool00`3o0000003o0?ooo`020?l000H0oooo00@0o`000000o`3oool0003o
1`3oool00`00nYX0oooo003jVP080?ooo`03003jVP3oool0oooo00H0oooo0P00nYX90?ooo`03003j
VP3oool0oooo00T0oooo00<00?ZJ0?ooo`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`00803o
ool00`000000oooo0?ooo`070?ooo`040?l000000?l0oooo0?l000L0oooo0P3o00070?ooo`030?l0
00000?l0o`0000H0oooo00<0o`000000o`3o00002@3oool00`3o0000003o0?ooo`020?ooo`030?l0
003oool0oooo0080oooo00T0o`000000o`3oool0o`000?ooo`3o0000oooo0000o`3o0000103oool0
0`3o0000003o0?ooo`020?l000030000o`3o0000oooo00D0oooo00<0o`000000o`3o00001`3oool0
0`3o0000003o0?l000080?ooo`040?l000000?l0003o0?l000L0oooo00@0o`000000o`000?l0o`00
1P3oool01P3o0000003o0?ooo`3oool0003o0?l000D0oooo00H0o`000000o`3oool0oooo0000o`3o
00050?ooo`060?l000000?l0oooo0?l000000?l0o`001P3oool00`3o0000003o0?l000020?l000H0
oooo00@0o`000000o`3oool0003o1`3oool00`00nYX0oooo003jVP070?ooo`800?ZJ203oool2003j
VPT0oooo0P00nYX:0?ooo`03003jVP3oool0oooo00D0oooo00<000000?ooo`3oool02P3oool00200
oooo00<000000?ooo`3oool01`3oool0103o0000003o0?ooo`3o00070?ooo`030?l000000?l0o`00
00H0oooo00<0o`000000o`3o00001P3oool00`3o0000003o0?l000090?ooo`070?l000000?l0oooo
0?l0003oool0003o0?l000030?ooo`040?l000000?l0oooo0?l00080oooo00<0o`000?ooo`3o0000
103oool00`3o0000003o0?ooo`020?l000030?ooo`3o0000oooo00D0oooo00<0o`000000o`3o0000
1`3oool00`3o0000003o0?l000080?ooo`040?l0003oool0o`000?l000L0oooo00@0o`000000o`00
0?l0o`001P3oool01P3o0000003o0?ooo`3o0000003o0?l000D0oooo00H0o`000000o`3oool0o`00
0000o`3o00040?ooo`070?l0003oool0003o0?ooo`3o0000003o0?l000060?ooo`030?l0003oool0
o`000080o`001P3oool0103o0000003o0?ooo`000?l70?ooo`03003jVP3oool00?ZJ00L0oooo0P00
nYX80?ooo`800?ZJ2@3oool2003jVPT0oooo0P00nYX70?ooo`030000003oool0oooo00X0oooo000P
0?ooo`030000003oool0oooo00L0oooo00@0o`000000o`3oool0o`001P3oool0103o0000003o0000
o`3o00060?ooo`030?l0003oool0o`0000H0oooo00<0o`000000o`3o00002@3oool00`3o0000003o
0?ooo`020?l000030000o`3o0000oooo0080oooo00<0o`000000o`3o00000`3oool0103o0000oooo
0000o`3o00020?ooo`040?l0003oool0003o0?l00080oooo00<0o`000000o`3o00001@3oool00`3o
0000003o0?l000070?ooo`040?l000000?l0003o0?l000L0oooo103o00070?ooo`040?l000000?l0
003o0?l000H0oooo00H0o`000?ooo`3oool0o`000000o`3o00050?ooo`060?l000000?l0o`000?l0
00000?l0o`00103oool01@3o0000oooo0000o`3o0000oooo0080o`001P3oool20?l000040?ooo`3o
0000003o0?l000D0oooo00@0o`000000o`3oool0003o1P3oool01000nYX0oooo0?ooo`00nYX70?oo
o`800?ZJ203oool2003jVPT0oooo0P00nYX90?ooo`800?ZJ1`3oool00`000000oooo0?ooo`0:0?oo
o`00803oool00`000000oooo0?ooo`070?ooo`040?l000000?l0o`000?l000H0oooo00@0o`000000
o`000?l0o`001P3oool30?l000H0oooo00<0o`000000o`3o00002@3oool01`3o0000003o0?l0003o
ool0o`000000o`3o00000`3oool00`3o0000003o0?l000030?ooo`040?l0003oool0003o0?l00080
oooo00@0o`000?ooo`000?l0o`000P3oool00`3o0000003o0?l000050?ooo`<0o`001`3oool0103o
0000oooo0000o`3o00070?ooo`@0o`001`3oool0103o0000003o0000o`3o00060?ooo`040?l0003o
ool0o`000?ooo`80o`001@3oool0103o0000003o0?l0003oool20?l000@0oooo00D0o`000?ooo`00
0?l0o`000?ooo`020?l000H0oooo0P3o00020?ooo`80o`001@3oool0103o0000003o0?l000000?l6
0?ooo`04003jVP3oool0oooo003jVPL0oooo0P00nYX80?ooo`800?ZJ2@3oool2003jVPT0oooo0P00
nYX70?ooo`030000003oool0oooo00X0oooo000P0?ooo`800000203oool0103o0000003o0?l0003o
00060?ooo`040?l000000?l0003o0?l000H0oooo0`3o00050?ooo`040?l000000?l0o`000?l000T0
oooo00L0o`000?ooo`3o0000oooo0?l000000?l0o`0000<0oooo00<0o`000?ooo`3o0000103oool0
0`3o0000003o0?l000020?ooo`040?l000000?l0oooo0?l00080oooo00<0o`000000o`3o00001@3o
ool30?l000H0oooo00D0o`000000o`3oool0003o0?l000060?ooo`030?l000000?l0o`000080o`00
1`3oool0103o0000003o0?l0003o00050?ooo`050?l000000?l0oooo0?l0003oool00P3o00050?oo
o`040?l000000?l0o`000?ooo`80o`00103oool01@3o0000003o0?ooo`3o0000oooo0080o`001@3o
ool00`3o0000003o0?l000020?ooo`80o`001@3oool0103o0000oooo0?l000000?l60?ooo`04003j
VP3oool0oooo003jVPL0oooo0P00nYX80?ooo`800?ZJ203oool00`00nYX0oooo003jVP090?ooo`03
003jVP3oool00?ZJ00D0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`070?ooo`80o`00
00<0oooo0?l0003oool01@3oool0103o0000003o0000o`3o00050?ooo`040?l000000?l0o`000?l0
00D0oooo00@0o`000000o`3o0000o`00203oool0203o0000003o0?ooo`3o0000oooo0?l000000?l0
o`000`3oool20?l000D0oooo00<0o`000000o`3o00000P3oool0103o0000003o0?ooo`3o00020?oo
o`030?l000000?l0o`0000D0oooo0`3o00060?ooo`050?l000000?l0o`000000o`3o00001P3oool0
0`3o0000003o0?l000020?l000L0oooo00@0o`000000o`3o0000o`001@3oool00`3o0000003o0?l0
00020?ooo`80o`001@3oool20?l00080oooo0P3o00040?ooo`050?l000000?l0oooo0?l0003oool0
0P3o00050?ooo`030?l000000?l0o`000080oooo0P3o00040?ooo`050?l000000?l0o`000?l00000
0?l01P3oool01000nYX0oooo0?ooo`00nYX70?ooo`03003jVP3oool00?ZJ00L0oooo00<00?ZJ0?oo
o`00nYX01`3oool00`00nYX0oooo003jVP090?ooo`03003jVP3oool00?ZJ00H0oooo00<000000?oo
o`3oool02P3oool00200oooo00<000000?ooo`3oool01`3oool20?l000030?ooo`3o0000oooo00D0
oooo00@0o`000000o`000?l0o`001@3oool0103o0000003o0?l0003o00050?ooo`040?l000000?l0
o`000?l000P0oooo00<0o`000000o`3o00000`3oool20?l000<0oooo0P3o00050?ooo`030?l00000
0?l0o`000080oooo00<0o`000000o`3o00000`3oool00`3o0000003o0?l000050?ooo`<0o`001P3o
ool01@3o0000003o0?l000000?l0o`0000H0oooo00<0o`000000o`3o00000P3o00070?ooo`@0o`00
1@3oool00`3o0000003o0?l000020?ooo`80o`001@3oool20?l00080oooo0P3o00040?ooo`030?l0
00000?l0o`000080oooo00<0o`000000o`3o0000103oool00`3o0000003o0?l000020?ooo`80o`00
103oool01@3o0000003o0?l0003o0000003o00H0oooo00D00?ZJ0?ooo`3oool0oooo003jVP050?oo
o`04003jVP3oool0oooo003jVPH0oooo00@00?ZJ0?ooo`3oool00?ZJ1`3oool00`00nYX0oooo003j
VP090?ooo`03003jVP3oool00?ZJ00H0oooo00<000000?ooo`3oool02P3oool00200oooo00<00000
0?ooo`3oool01`3oool20?l000030?ooo`3o0000oooo00D0oooo00@0o`000000o`3o0000o`001@3o
ool0103o0000003o0?l0003o00050?ooo`040?l000000?l0o`000?l000P0oooo00<0o`000000o`3o
00000`3oool20?l00080oooo00<0o`000000o`3o00001P3oool20?l00080oooo00<0o`000000o`3o
0000103oool20?l000D0oooo0`3o00060?ooo`030?l000000?l0o`000080o`001P3oool20?l00080
oooo00<0o`000?ooo`3oool01@3oool40?l000D0oooo00<0o`000000o`3o00000P3oool20?l000D0
oooo0P3o00020?ooo`80o`000`3oool0103o0000oooo0000o`3o00020?ooo`030?l000000?l0o`00
00@0oooo0P3o00030?ooo`80o`00103oool01P3o0000003o0?l0003oool0o`000000o`D0oooo00D0
0?ZJ0?ooo`3oool0oooo003jVP050?ooo`04003jVP3oool0oooo003jVPH0oooo00@00?ZJ0?ooo`3o
ool00?ZJ1`3oool00`00nYX0oooo003jVP080?ooo`04003jVP3oool0oooo003jVPH0oooo00<00000
0?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool01P3oool01@3o0000003o0?l0003oool0
o`0000H0oooo00@0o`000?ooo`3o0000o`001@3oool40?l000D0oooo103o00080?ooo`030?l00000
0?l0o`0000<0oooo0P3o00020?ooo`030?l000000?l0o`0000H0oooo0P3o00001@3oool0o`000?oo
o`000?l0o`0000@0oooo0P3o00050?ooo`@0o`001@3oool00`3o0000003o0?l000020?l000H0oooo
0P3o00020?ooo`030?l0003oool0oooo00@0oooo00<0o`000000o`3o00000P3o00050?ooo`80o`00
0`3oool20?l000D0oooo0P3o00020?ooo`80o`000`3oool0103o0000003o0?ooo`3o00030?ooo`80
o`00103oool20?l000<0oooo0P3o00040?ooo`060?l000000?l0o`000?ooo`3o0000003o1@3oool0
1@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool01000nYX0oooo
0?ooo`00nYX70?ooo`03003jVP3oool00?ZJ00P0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool00`00
0000oooo0?ooo`0:0?ooo`00803oool2000000L0oooo00@0o`000000o`3o0000oooo0P3o00050?oo
o`@0o`001@3oool20?l000030?ooo`3o0000oooo00@0oooo103o00080?ooo`030?l000000?l0o`00
00<0oooo0P3o00020?ooo`030?l000000?l0o`0000H0oooo0P3o00001@3oool0o`000000o`3oool0
o`0000@0oooo0P3o00040?ooo`80o`0000<0oooo0?l0003o00001@3oool20?l000030?ooo`3o0000
o`0000H0oooo0P3o00020?ooo`030?l0003oool0oooo00@0oooo00<0o`000000o`3o00000P3o0005
0?ooo`80o`000`3oool20?l000@0oooo00<0o`000000o`3o00000P3oool20?l000<0oooo00@0o`00
0000o`3oool0o`000`3oool20?l000@0oooo0P3o00030?ooo`80o`00103oool01P3o0000003o0?l0
003oool0o`000000o`@0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`030?ooo`04
003jVP3oool0oooo003jVPH0oooo00@00?ZJ0?ooo`3oool00?ZJ1`3oool00`00nYX0oooo003jVP08
0?ooo`04003jVP3oool0oooo003jVPD0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`06
0?ooo`040?l000000?l0o`000?ooo`80o`00103oool00`3o0000003o0?l000020?l000D0oooo0P3o
00000`3oool0o`000?ooo`040?ooo`80o`0000<0oooo0?l0003oool01`3oool20?l000@0oooo0P3o
00020?ooo`030?l000000?l0o`0000H0oooo00H0o`000000o`3o0000o`000000o`3o00050?ooo`80
o`00103oool20?l000030?ooo`3o0000o`0000D0oooo0P3o00000`3oool0o`000?l000060?ooo`80
o`000P3oool20?l000D0oooo00<0o`000000o`3o00000P3o00050?ooo`80o`000`3oool20?l000@0
oooo00<0o`000000o`3o00000P3oool20?l000<0oooo00<0o`000000o`3o0000103oool20?l000@0
oooo0P3o00030?ooo`80o`00103oool20?l00080oooo00<0o`000000o`3oool00`3oool00`00nYX0
oooo0?ooo`020?ooo`03003jVP3oool0oooo00<0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool01000
nYX0oooo0?ooo`00nYX70?ooo`03003jVP3oool00?ZJ00P0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3o
ool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`060?ooo`040?l000000?l0
o`000?ooo`80o`00103oool00`3o0000003o0?l000020?l000D0oooo0P3o00000`3oool0o`000?oo
o`040?ooo`80o`0000<0oooo0?l0003oool01`3oool20?l000@0oooo0P3o00020?ooo`80o`001`3o
ool01P3o0000003o0?l0003o0000003o0?l000D0oooo00<0o`000000o`3o00000`3oool20?l00003
0?ooo`3o0000o`0000D0oooo0P3o00000`3oool0o`000?l000060?ooo`80o`000P3oool20?l000D0
oooo00<0o`000000o`3o00000P3o00050?ooo`80o`00103oool20?l000<0oooo0P3o00030?ooo`80
o`000`3oool00`3o0000003o0?l000040?ooo`80o`00103oool20?l000<0oooo0P3o00040?ooo`80
o`000P3oool00`3o0000003o0?ooo`030?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3o
ool00`3oool01000nYX0oooo0?ooo`00nYX60?ooo`04003jVP3oool0oooo003jVPL0oooo00@00?ZJ
0?ooo`3oool00?ZJ1`3oool01000nYX0oooo0?ooo`00nYX60?ooo`030000003oool0oooo00X0oooo
000P0?ooo`030000003oool0oooo00H0oooo0P3o00020?ooo`80o`00103oool00`3o0000003o0?l0
00020?l000D0oooo0P3o00000`3oool0o`000?ooo`040?ooo`80o`0000<0oooo0?l0003oool01P3o
ool00`3o0000003o0?l000040?ooo`060?l000000?l0o`000?l0003oool0o`001`3oool01P3o0000
003o0?l0003oool0003o0?l000D0oooo00<0o`000000o`3o00000`3oool20?l000030?ooo`3o0000
o`0000D0oooo0P3o00000`3oool0o`000?l000060?ooo`80o`000P3oool20?l000D0oooo00D0o`00
0000o`3o0000oooo0?l000050?ooo`80o`00103oool20?l000<0oooo0P3o00030?ooo`80o`000`3o
ool00`3o0000003o0?l000040?ooo`80o`00103oool20?l000<0oooo0P3o00040?ooo`80o`000P3o
ool00`3o0000003o0?ooo`030?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool00`3o
ool01000nYX0oooo0?ooo`00nYX60?ooo`04003jVP3oool0oooo003jVPH0oooo00D00?ZJ0?ooo`3o
ool0oooo003jVP070?ooo`04003jVP3oool0oooo003jVPH0oooo00<000000?ooo`3oool02P3oool0
0200oooo00<000000?ooo`3oool01P3oool20?l00080oooo0P3o00040?ooo`030?l000000?l0o`00
0080o`001@3oool20?l000030?ooo`3o0000oooo00@0oooo0P3o00000`3oool0o`000?ooo`060?oo
o`030?l000000?l0o`0000@0oooo00H0o`000000o`3oool0o`000000o`3o00070?ooo`060?l00000
0?l0oooo0?ooo`000?l0o`001@3oool00`3o0000003o0?l000030?ooo`80o`0000<0oooo0?l0003o
00001@3oool20?l000030?ooo`3o0000o`0000D0oooo00<0o`000000o`3o00000P3oool20?l000@0
oooo00<0o`000?ooo`3o00000P3oool00`3o0000oooo0?ooo`030?ooo`80o`00103oool20?l000<0
oooo0P3o00040?ooo`070?l0003oool0oooo0?ooo`3o0000003o0?l000040?ooo`80o`000`3oool0
0`3o0000003o0?l000030?ooo`80o`00103oool20?l00080oooo00<0o`000000o`3oool00`3oool0
0`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00<0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3o
ool01000nYX0oooo0?ooo`00nYX60?ooo`05003jVP3oool0oooo0?ooo`00nYX01`3oool01000nYX0
oooo0?ooo`00nYX60?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00H0
oooo0P3o00020?ooo`80o`00103oool01@3o0000003o0?l0003oool0o`0000D0oooo0P3o00000`3o
ool0o`000?ooo`040?ooo`80o`0000<0oooo0?l0003oool01P3oool00`3o0000003o0?l000050?oo
o`050?l0003oool0oooo0000o`3o0000203oool01@3o0000oooo0000o`3oool0o`0000D0oooo00<0
o`000000o`3o00000`3oool20?l000030?ooo`3o0000o`0000D0oooo0P3o00000`3oool0o`000?l0
00050?ooo`030?l000000?l0o`000080oooo0P3o00040?ooo`030?l0003oool0o`000080oooo00<0
o`000?ooo`3oool00`3oool20?l000@0oooo0P3o00030?ooo`80o`00103oool0103o0000oooo0?oo
o`3oool20?l000D0oooo0P3o00030?ooo`030?l000000?l0o`0000<0oooo0P3o00040?ooo`80o`00
0P3oool00`3o0000003o0?ooo`030?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool0
0`3oool01000nYX0oooo0?ooo`00nYX60?ooo`04003jVP3oool0oooo003jVPH0oooo00D00?ZJ0?oo
o`3oool0oooo003jVP060?ooo`05003jVP3oool0oooo0?ooo`00nYX01P3oool00`000000oooo0?oo
o`0:0?ooo`00803oool2000000H0oooo00<0o`000000o`3o00000P3oool20?l000@0oooo0P3o0002
0?ooo`030?l0003oool0oooo00<0oooo0P3o00000`3oool0o`000?ooo`040?ooo`80o`0000<0oooo
0?l0003oool01P3oool00`3o0000003o0?l000050?ooo`050?l0003oool0oooo0000o`3o0000203o
ool0103o0000oooo0000o`3o00070?ooo`80o`000`3oool20?l000030?ooo`3o0000o`0000D0oooo
0P3o00020?ooo`030?l0003oool0oooo00<0oooo00<0o`000000o`3o00000P3oool20?l000@0oooo
00<0o`000000o`3o00000P3oool00`3o0000oooo0?ooo`030?ooo`80o`00103oool20?l000<0oooo
0P3o00040?ooo`040?l0003oool0oooo0?ooo`80o`001@3oool20?l000<0oooo00<0o`000000o`3o
0000103oool00`3o0000oooo0?ooo`020?ooo`80o`000P3oool00`3o0000003o0?ooo`030?ooo`03
003jVP3oool0oooo0080003o00<00?ZJ0?ooo`3oool00`3oool01000nYX0oooo0?ooo`00nYX60?oo
o`04003jVP3oool0oooo003jVPH0oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`05003jVP3o
ool0oooo0?ooo`00nYX01@3oool2000000`0oooo000P0?ooo`030000003oool0oooo00D0oooo00<0
o`000000o`3o00000P3oool00`3o0000003o0?l000030?ooo`80o`000P3oool00`3o0000oooo0?oo
o`030?ooo`80o`0000<0oooo0?l0003oool0103oool20?l000030?ooo`3o0000oooo00H0oooo00<0
o`000000o`3o00001@3oool01@3o0000oooo0?ooo`000?l0o`0000P0oooo00@0o`000000o`000?l0
o`001`3oool20?l000<0oooo0P3o00000`3oool0o`000?l000040?ooo`030?l000000?l0o`000080
oooo0P3o00040?ooo`80o`000`3oool20?l000@0oooo00<0o`000000o`3o00000P3oool00`3o0000
oooo0?ooo`030?ooo`80o`00103oool20?l000<0oooo0P3o00040?ooo`040?l0003oool0oooo0?oo
o`80o`001@3oool00`3o0000003o0?l000020?ooo`030?l000000?l0o`0000@0oooo00L0o`000?oo
o`3oool0oooo0?l000000?l0o`000080oooo00<0o`000?ooo`000?l00`3oool00`00nYX0oooo0000
o`020?ooo`03003jVP3oool0oooo0080oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`04003j
VP3oool0oooo003jVPH0oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`05003jVP3oool0oooo
0?ooo`00nYX01P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`050?oo
o`030?l000000?l0o`000080oooo00<0o`000000o`3o00000`3oool20?l00080oooo00<0o`000?oo
o`3oool00P3oool20?l00080oooo00<0o`000?ooo`3oool00P3oool20?l00080oooo00<0o`000?oo
o`3oool0103oool00`3o0000oooo0?l000060?ooo`050?l0003oool0oooo0000o`3o0000203oool0
103o0000003o0000o`3o00070?ooo`80o`000`3oool20?l000030?ooo`3o0000o`0000@0oooo0P3o
00030?ooo`80o`00103oool20?l000<0oooo0P3o00030?ooo`040?l0003oool0003o0?l00080oooo
00<0o`000?ooo`3oool00`3oool00`3o0000oooo0?ooo`030?ooo`80o`000`3oool20?l000@0oooo
00H0o`000?ooo`3oool0o`000000o`3o00050?ooo`030?l000000?l0o`000080oooo0P3o00050?oo
o`070?l0003oool0oooo0?ooo`3o0000003o0?l000020?ooo`030?l0003oool0003o00<0oooo00<0
0?ZJ0?ooo`000?l00P3oool00`00nYX0oooo0?ooo`020?ooo`05003jVP3oool0oooo0?ooo`00nYX0
1P3oool01000nYX0oooo0?ooo`00nYX60?ooo`05003jVP3oool0oooo0?ooo`00nYX01P3oool01@00
nYX0oooo0?ooo`3oool00?ZJ00H0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?oo
o`3oool01@3oool00`3o0000003o0?l000020?ooo`030?l000000?l0o`0000<0oooo0P3o00020?oo
o`80o`000`3oool20?l00080oooo00<0o`000?ooo`3oool00P3oool20?l00080oooo0P3o00050?oo
o`030?l000000?l0o`0000H0oooo00D0o`000000o`000?l0oooo0?l000080?ooo`040?l000000?l0
oooo0?l000L0oooo0P3o00030?ooo`80o`0000<0oooo0?l0003o0000103oool20?l000<0oooo0P3o
00040?ooo`80o`000`3oool20?l000<0oooo00@0o`000?ooo`000?l0o`000P3oool00`3o0000oooo
0?ooo`030?ooo`030?l0003oool0oooo00<0oooo0P3o00030?ooo`80o`00103oool20?l000040?oo
o`3o0000003o0?l000D0oooo00<0o`000000o`3o00000P3oool20?l000D0oooo0P3o00020?ooo`80
o`000`3oool00`3o00000?ZJ0000o`030?ooo`03003jVP000?l0oooo0080oooo00<00?ZJ0000o`3o
ool00P3oool01@00nYX0003o0000o`000?l00?ZJ00H0003o00@00?ZJ0000o`000?l00?ZJ1P000?l0
1@00nYX0003o0000o`000?l00?ZJ00H0003o00D00?ZJ0000o`000?l0003o003jVP020000o`@0oooo
00<000000?ooo`3oool02P3oool00180oooo0`0000040?ooo`8000001@3oool00`000000oooo0?oo
o`050?ooo`030?l000000?l0o`000080oooo00<0o`000000o`3o00000P3oool00`3o0000003o0?l0
00020?ooo`80o`000`3oool20?l00080oooo00<0o`000?ooo`3oool00P3oool20?l00080oooo0P3o
00050?ooo`030?l000000?l0o`0000H0oooo00@0o`000?ooo`000?l0o`002@3oool0103o0000oooo
0?ooo`3o00070?ooo`030?l000000?l0o`000080oooo0P3o00000`3oool0o`000?l000040?ooo`80
o`000`3oool20?l000@0oooo0P3o00030?ooo`80o`000`3oool0103o0000003o0?ooo`3o00020?oo
o`030?l0003oool0oooo0080oooo0P3o00050?ooo`030?l000000?l0o`000080oooo0P3o00040?oo
o`80o`0000@0oooo0?l000000?l0o`001P3oool20?l000040?ooo`3o0000oooo0?l000D0oooo0P3o
00020?ooo`80o`000`3oool00`3o00000?ZJ0000o`030?ooo`03003jVP000?l0oooo0080oooo00<0
0?ZJ0?ooo`000?l00P000?l01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo00@00?ZJ0?ooo`3oool0
0?ZJ1@3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00@0oooo00D00?ZJ0?ooo`3o
ool0oooo003jVP060?ooo`030000003oool0oooo00X0oooo000A0?ooo`050000003oool0oooo0?oo
o`0000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00D0oooo00<0o`00
0000o`3o00000P3oool00`3o0000003o0?l000020?ooo`030?l000000?l0o`000080oooo0P3o0003
0?ooo`80o`000P3oool00`3o0000oooo0?ooo`020?ooo`80o`000P3oool20?l000D0oooo00<0o`00
0000o`3o00001P3oool0103o0000oooo0?ooo`3o00090?ooo`040?l0003oool0oooo0?l000L0oooo
00<0o`000000o`3o00000P3oool20?l000030?ooo`3o0000o`0000@0oooo0P3o00030?ooo`80o`00
0`3oool00`3o0000003o0?l000030?ooo`80o`000`3oool0103o0000003o0?ooo`3o00020?ooo`80
o`000`3oool20?l000D0oooo00L0o`000000o`3o0000oooo0?l000000?l0o`0000@0oooo0P3o0000
0`3oool0o`000?l000070?ooo`@0o`0000<0003o0?l0003oool0103oool20?l00080oooo0P3o0003
0?ooo`030?l00000nYX0003o00<0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`02
0?ooo`05003jVP3oool0oooo0?ooo`00nYX01P3oool01000nYX0oooo0?ooo`00nYX50?ooo`03003j
VP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool0103oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0
oooo00<000000?ooo`3oool02P3oool001D0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`020?ooo`<000001@3oool20?l000@0oooo0P3o00020?ooo`030?l000000?l0o`000080
oooo0P3o00030?ooo`80o`000P3oool20?l000<0oooo0P3o00020?ooo`80o`001@3oool00`3o0000
003o0?l000060?ooo`040?l0003oool0oooo0?l000T0oooo00<0o`000?ooo`3o0000203oool0103o
0000003o0?l0003oool20?l000<0oooo00<0o`000?ooo`3oool00P3oool20?l000<0oooo0P3o0003
0?ooo`030?l000000?l0o`0000<0oooo0P3o00030?ooo`030?l000000?l0o`0000<0oooo0P3o0003
0?ooo`80o`001@3oool01`3o0000003o0?l0003oool0o`000000o`3o0000103oool20?l000030?oo
o`3o0000o`0000L0oooo00H0o`000?ooo`3oool0oooo0000o`3o00050?ooo`80o`000P3oool20?l0
00@0oooo00<00?ZJ0000o`3oool00P3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo
0080oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`04003jVP3oool0oooo003jVPD0oooo00<0
0?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`040?ooo`05003jVP3oool0oooo0?ooo`00nYX0
1@3oool2000000`0oooo000E0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`050?ooo`80o`00103oool0103o0000003o0?l0003oool20?l000<0
oooo0P3o00030?ooo`80o`000P3oool20?l000<0oooo0P3o00020?ooo`80o`001@3oool00`3o0000
003o0?l000060?ooo`040?l0003oool0oooo0?l000X0oooo0P3o00080?ooo`040?l000000?l0o`00
0?ooo`80o`000`3oool00`3o0000oooo0?ooo`020?ooo`80o`000`3oool20?l000<0oooo00<0o`00
0000o`3o00000`3oool20?l000<0oooo00<0o`000000o`3o00000`3oool20?l000<0oooo0P3o0005
0?ooo`040?l000000?l0o`000?ooo`80o`001@3oool20?l000030?ooo`3o0000o`0000L0oooo00H0
o`000?ooo`3oool0oooo0000o`3o00050?ooo`80o`000P3oool20?l000@0oooo00H00?ZJ0000o`3o
ool0oooo003jVP000?l40?ooo`03003jVP3oool0oooo0080oooo00D00?ZJ0?ooo`3oool0oooo003j
VP050?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool00`00nYX0oooo0?ooo`020?ooo`03003j
VP3oool0oooo00@0oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`030000003oool0oooo00X0
oooo000A0?ooo`@000000`3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00D0
oooo0P3o00040?ooo`040?l000000?l0o`000?ooo`80o`000`3oool20?l000<0oooo0P3o00020?oo
o`80o`000`3oool20?l00080oooo0P3o00040?ooo`040?l0003oool0003o0?l000H0oooo00@0o`00
0?ooo`3oool0o`002P3oool20?l000P0oooo00@0o`000000o`3o0000oooo0P3o00030?ooo`030?l0
003oool0oooo0080oooo0P3o00030?ooo`80o`000`3oool00`3o0000003o0?l000040?ooo`070?l0
003oool0oooo0?ooo`3o0000oooo0?l000030?ooo`80o`000`3oool20?l000D0oooo00<0o`000000
o`3oool00`3o00050?ooo`80o`0000<0oooo0?l0003o00001`3oool01P3o0000003o0?ooo`3oool0
003o0?l000D0oooo0P3o00020?ooo`80o`00103oool01P00nYX0oooo0000o`3oool00?ZJ0000o`@0
oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00D00?ZJ0?oo
o`3oool0oooo003jVP050?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool0103oool0
1@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo00<000000?ooo`3oool02P3oool00140oooo00<00000
0?ooo`3oool0103oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00D0oooo0P3o
00040?ooo`040?l000000?l0o`000?ooo`80o`000`3oool20?l000<0oooo0P3o00020?ooo`80o`00
0`3oool20?l00080oooo0P3o00040?ooo`040?l000000?l0oooo0?l000H0oooo00@0o`000?ooo`3o
ool0o`002P3oool20?l000T0oooo0P3o00000`3oool0o`000?l000030?ooo`030?l0003oool0oooo
0080oooo0P3o00030?ooo`80o`000`3oool00`3o0000003o0?l000040?ooo`070?l0003oool0oooo
0?ooo`3o0000oooo0?l000030?ooo`80o`000`3oool20?l000H0oooo00D0o`000?ooo`3oool0oooo
0?l000050?ooo`80o`0000<0oooo0?l0003o00001`3oool01P3o0000003o0?ooo`3oool0003o0?l0
00D0oooo0P3o00020?ooo`80o`00103oool01@3o00000?ZJ0000o`3oool00?ZJ00D0oooo00<00?ZJ
0?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00D00?ZJ0?ooo`3oool0oooo
003jVP050?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX0oooo
0?ooo`020?ooo`03003jVP3oool0oooo00@0oooo00<000000?ooo`3oool02P3oool00140oooo1@00
00030?ooo`8000001@3oool00`000000oooo0?ooo`040?ooo`030?l000000?l0o`0000@0oooo00@0
o`000000o`3o0000oooo0P3o00030?ooo`80o`000`3oool20?l00080oooo0P3o00030?ooo`80o`00
0P3oool20?l000@0oooo00<0o`000000o`3o0000203oool20?l000/0oooo00<0o`000?ooo`3oool0
203oool00`3o0000003o0?l000020?l000<0oooo00<0o`000?ooo`3oool00P3oool20?l000<0oooo
0P3o00020?ooo`040?l0003oool0003o0?l000@0oooo00L0o`000?ooo`3oool0oooo0?l0003oool0
o`0000<0oooo0P3o00030?ooo`80o`001P3oool01@3o0000oooo0?ooo`3oool0o`0000D0oooo0P3o
00000`3oool0o`000?l000070?ooo`060?l000000?l0oooo0000o`3oool0o`001@3oool20?l00080
oooo0P3o00040?ooo`050?l00000nYX0003o0?ooo`00nYX01@3oool00`00nYX0oooo0?ooo`020?oo
o`05003jVP3oool0oooo0?ooo`00nYX01@3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00<0
0?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo0080oooo00<0
0?ZJ0?ooo`3oool0103oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`04
0?ooo`030?l000000?l0o`0000@0oooo00@0o`000000o`3o0000oooo0P3o00030?ooo`80o`000`3o
ool20?l00080oooo0P3o00030?ooo`80o`000P3oool20?l000@0oooo00<0o`000000o`3o00002@3o
ool00`3o0000oooo0?ooo`0D0?ooo`050?l000000?l0o`000?ooo`3o00000`3oool00`3o0000oooo
0?ooo`020?ooo`80o`000`3oool20?l00080oooo00<0o`000000o`3o00001@3oool01P3o0000oooo
0?ooo`3o0000003o0?l000@0oooo0P3o00030?ooo`80o`001P3oool01@3o0000003o0?ooo`000?l0
o`0000D0oooo0P3o00000`3oool0o`000?l000070?ooo`050?l000000?l0003o0000o`3o00001P3o
ool20?l00080oooo0P3o00040?ooo`050?l00000nYX0oooo0000o`00nYX01@3oool00`00nYX0oooo
0?ooo`020?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool01@00nYX0oooo0?ooo`3oool00?ZJ
00D0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo
0080oooo00<00?ZJ0?ooo`3oool0103oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000D0
oooo00<0o`000000o`3o0000103oool0103o0000003o0?l0003oool20?l000<0oooo0P3o00030?oo
o`80o`000P3oool20?l000<0oooo0P3o00020?ooo`80o`00103oool00`3o0000003o0?l0000P0?oo
o`050?l000000?l0oooo0000o`3o00000`3oool00`3o0000oooo0?ooo`020?ooo`80o`000`3oool2
0?l00080oooo00<0o`000000o`3o00001@3oool01P3o0000oooo0?ooo`3o0000003o0?l000@0oooo
0P3o00030?ooo`80o`001P3oool01@3o0000003o0?ooo`000?l0o`0000D0oooo0P3o00000`3oool0
o`000?l000070?ooo`050?l000000?l0oooo0?ooo`3o00001P3oool20?l00080oooo0P3o00040?oo
o`050?l00000nYX0oooo0?ooo`00nYX01P3oool01000nYX0oooo0?ooo`00nYX40?ooo`03003jVP3o
ool0oooo00<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP050?ooo`03003jVP3oool0oooo0080oooo
00<00?ZJ0?ooo`3oool00`3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00<0oooo
0P00000<0?ooo`00803oool00`000000oooo0?ooo`040?ooo`80o`001P3oool30?l000030000o`3o
0000oooo0080oooo0P3o00030?ooo`80o`000P3oool20?l000<0oooo0P3o00020?ooo`80o`00103o
ool00`3o0000003o0?l0000P0?ooo`050?l000000?l0oooo0000o`3o00000`3oool00`3o0000oooo
0?ooo`020?ooo`030?l0003oool0oooo0080oooo0P3o00020?ooo`030?l000000?l0o`0000D0oooo
00H0o`000?ooo`3oool0o`000000o`3o00040?ooo`80o`000`3oool20?l000H0oooo00D0o`000000
o`3oool0003o0?l000050?ooo`<0o`0000<0003o0?l0003oool01P3oool01@3o0000oooo0?ooo`3o
ool0o`0000H0oooo0P3o00020?ooo`80o`00103oool01@3o00000?ZJ0?ooo`3oool00?ZJ00H0oooo
00@00?ZJ0?ooo`3oool00?ZJ103oool00`00nYX0oooo0?ooo`030?ooo`05003jVP3oool0oooo0?oo
o`00nYX01@3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?oo
o`3oool00`3oool00`00nYX0oooo0?ooo`030?ooo`030000003oool0oooo00X0oooo000P0?ooo`03
0000003oool0oooo00@0oooo0P3o00060?ooo`050?l000000?l0o`000000o`3o00000`3oool20?l0
0080oooo0P3o00030?ooo`80o`000`3oool20?l00080oooo0P3o00040?ooo`030?l000000?l0o`00
0200oooo00D0o`000000o`3oool0003o0?l000030?ooo`040?l0003oool0oooo0?ooo`80o`001@3o
ool01P3o0000oooo0?ooo`3o0000003o0?l000D0oooo0P3o0000103oool0o`000000o`3o00040?oo
o`80o`000`3oool20?l000H0oooo00D0o`000000o`3oool0003o0?l000050?ooo`<0o`0000<0003o
0?l0003oool01`3oool0103o0000oooo0?ooo`3o00060?ooo`80o`0000<0oooo0?l0003o00001@3o
ool01@3o00000?ZJ0?ooo`3oool00?ZJ00H0oooo00@00?ZJ0?ooo`3oool00?ZJ1@3oool00`00nYX0
oooo0?ooo`020?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool00`00nYX0oooo0?ooo`020?oo
o`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX0oooo0?ooo`030?oo
o`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00@0oooo0P3o00060?ooo`05
0?l000000?l0o`000000o`3o0000103oool00`3o0000oooo0?ooo`020?l000<0oooo0P3o00030?oo
o`040?l0003oool0oooo0?ooo`80o`00103oool20?l00240oooo00D0o`000000o`3oool0003o0?l0
00030?ooo`040?l0003oool0oooo0?ooo`80o`001@3oool01P3o0000oooo0?ooo`3o0000003o0?l0
00D0oooo0P3o00000`3oool0o`000?l000050?ooo`80o`000`3oool20?l000H0oooo00D0o`000?oo
o`000?l0oooo0?l000050?ooo`@0o`002@3oool0103o0000oooo0?ooo`3o00070?ooo`040?l0003o
ool0o`000?l000D0oooo00D0o`00003jVP3oool0oooo003jVP060?ooo`04003jVP3oool0oooo003j
VPD0oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00<00?ZJ
0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ
0?ooo`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?oo
o`80o`001P3oool0103o0000003o0?l0003o00050?ooo`030?l0003oool0oooo0080o`000`3oool2
0?l00080oooo0P3o00040?ooo`030?l0003oool0oooo0080oooo0P3o000Q0?ooo`050?l0003oool0
003o0000o`3o00000`3oool0103o0000oooo0?ooo`3oool20?l000D0oooo00H0o`000?ooo`3oool0
o`000?ooo`3o00050?ooo`80o`0000<0oooo0?l0003o00001@3oool20?l000<0oooo00<0o`000?oo
o`3oool01@3oool01@3o0000oooo0?ooo`3oool0o`0000H0oooo0`3o00090?ooo`030?l0003oool0
o`0000P0oooo00@0o`000?ooo`3o0000o`001@3oool01@3o0000oooo003jVP3oool00?ZJ00H0oooo
00@00?ZJ0?ooo`3oool00?ZJ1@3oool00`00nYX0oooo0?ooo`020?ooo`05003jVP3oool0oooo0?oo
o`00nYX01@3oool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo0080oooo0P00nYX50?oo
o`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3o
ool0103oool20?l000H0oooo00@0o`000000o`3o0000o`001@3oool00`3o0000oooo0?ooo`020?l0
00<0oooo0P3o00020?ooo`80o`00103oool01`3o0000oooo0?ooo`3oool0o`000000o`3o00008P3o
ool0103o0000003o0000o`3o00030?ooo`040?l0003oool0oooo0?ooo`80o`001@3oool01P3o0000
oooo0?ooo`3o0000oooo0?l000D0oooo0P3o00000`3oool0o`000?l000050?ooo`80o`000`3oool0
0`3o0000oooo0?ooo`060?ooo`030?l0003oool0o`0000L0oooo0`3o00090?ooo`<0o`00203oool0
103o0000oooo0?l0003o00050?ooo`050?l0003oool00?ZJ0?ooo`00nYX01P3oool01000nYX0oooo
0?ooo`00nYX50?ooo`03003jVP3oool0oooo0080oooo00D00?ZJ0?ooo`3oool0oooo003jVP050?oo
o`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool00P3oool2003jVPD0oooo00<00?ZJ0?oo
o`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000@0oooo00<0o`000000o`3o
00001P3oool0103o0000003o0?ooo`3o00050?ooo`030?l0003oool0oooo0080o`00103oool00`3o
0000oooo0?ooo`020?l000@0oooo00L0o`000?ooo`3oool0oooo0?l000000?l0o`000280oooo00<0
o`000?ooo`3o0000103oool0103o0000oooo0?ooo`3oool20?l000D0oooo00<0o`000?ooo`3oool0
0P3o00060?ooo`80o`0000<0oooo0?l0003o00001P3oool01@3o0000oooo0?ooo`3oool0o`0000P0
oooo00<0o`000?ooo`3o00001`3oool30?l000T0oooo00<0o`000?ooo`3o0000203oool40?l000D0
oooo00D0o`000?ooo`00nYX0oooo003jVP060?ooo`04003jVP3oool0oooo003jVPD0oooo00<00?ZJ
0?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00<00?ZJ0?ooo`3oool00P3o
ool00`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo00@0oooo00<00?ZJ0?ooo`3oool00P3o
ool2000000`0oooo000P0?ooo`030000003oool0oooo00@0oooo00<0003o0?l0003oool01P3oool0
0`3o0000oooo0?l000050?ooo`030?l0003oool0oooo0080o`00103oool00`3o0000oooo0?ooo`02
0?l000@0oooo00L0o`000?ooo`3oool0oooo0?l000000?l0o`000280oooo00<0o`000?ooo`3o0000
103oool0103o0000oooo0?ooo`3oool20?l000D0oooo0P3o00000`3oool0o`000?l000060?ooo`80
o`0000<0oooo0?l0003o00001P3oool01@3o0000oooo0?ooo`3oool0o`0000P0oooo00<0o`000?oo
o`3o00001`3oool00`3o0000003o0?l0000D0?ooo`@0o`001@3oool0103o0000oooo003jVP00nYX7
0?ooo`04003jVP3oool0oooo003jVPD0oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo0?oo
o`3oool00?ZJ00D0oooo00<00?ZJ0?ooo`3oool00`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0
oooo00<00?ZJ0?ooo`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo
0?ooo`040?ooo`030000o`3o0000oooo00H0oooo00<0o`000000o`3o00001@3oool00`3o0000oooo
0?ooo`020?l000@0oooo00<0o`000?ooo`3oool00P3o00040?ooo`070?l0003oool0oooo0?ooo`3o
0000003o0?l0000R0?ooo`030?l0003oool0o`0000@0oooo00@0o`000?ooo`3oool0oooo0P3o0005
0?ooo`<0o`0000<0003o0?l0003oool01@3oool20?l000030?ooo`3o0000o`0000H0oooo00<0o`00
0?ooo`3oool00P3o00080?ooo`030?l0003oool0o`0000L0oooo00<0o`000000o`3o0000503oool4
0?l000D0oooo00@0o`000?ooo`3oool00?ZJ1`3oool01000nYX0oooo0?ooo`00nYX50?ooo`03003j
VP3oool0oooo0080oooo00D00?ZJ0?ooo`3oool0oooo003jVP050?ooo`03003jVP3oool0oooo00<0
oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`03003jVP3oool0oooo00<0oooo00<000000?oo
o`3oool02P3oool00200oooo00<000000?ooo`3oool0103oool00`000?l0o`000?ooo`060?ooo`03
0?l000000?l0o`0000D0oooo00<0o`000?ooo`3oool00P3o00040?ooo`030?l0003oool0oooo0080
o`00103oool0103o0000oooo0?ooo`3oool20?l002<0oooo00<0o`000?ooo`3o0000103oool0103o
0000oooo0?ooo`3oool20?l000D0oooo0`3o00000`000?l0o`000?ooo`050?ooo`80o`0000<0oooo
0?l0003o00001P3oool00`3o0000oooo0?ooo`020?l000T0oooo00<0o`000?ooo`3oool01P3oool0
0`3o0000003o0?l0000D0?ooo`@0o`001@3oool0103o0000oooo0?ooo`00nYX70?ooo`04003jVP3o
ool0oooo003jVPD0oooo00<00?ZJ0?ooo`3oool00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0
oooo00<00?ZJ0?ooo`3oool00`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo00<00?ZJ0?oo
o`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?ooo`03
0000o`3o0000oooo00H0oooo00<0o`000000o`3o00001@3oool20?l000030?ooo`3o0000o`0000@0
oooo00<0o`000?ooo`3oool00P3o00040?ooo`040?l0003oool0oooo0?ooo`80o`008`3oool00`3o
0000oooo0?l000040?ooo`040?l0003oool0oooo0?ooo`80o`001@3oool40?l000L0oooo0`3o0000
0`000?l0o`000?ooo`050?ooo`030?l0003oool0oooo0080o`004P3oool00`3o0000003o0?l0000D
0?ooo`@0o`001@3oool0103o0000oooo0?ooo`00nYX70?ooo`04003jVP3oool0oooo003jVPD0oooo
00D00?ZJ0?ooo`3oool0oooo003jVP040?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3o
ool00`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo00<00?ZJ0?ooo`3oool00`3oool00`00
0000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo00H0
oooo00<0o`000000o`3o00001@3oool20?l000030?ooo`3o0000o`0000@0oooo00<0o`000?ooo`3o
ool00P3o00040?ooo`040?l0003oool0oooo0?ooo`80o`00903oool20?l000@0oooo0P3o00020?oo
o`80o`001@3oool40?l000L0oooo0`3o00000`000?l0o`000?ooo`050?ooo`030?l0003oool0oooo
0080o`004P3oool00`3o0000003o0?l0000D0?ooo`@0o`001@3oool00`3o0000oooo0?ooo`080?oo
o`04003jVP3oool0oooo003jVPD0oooo00D00?ZJ0?ooo`3oool0oooo003jVP040?ooo`03003jVP3o
ool0oooo00<0oooo00<00?ZJ0?ooo`3oool00`3oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo
00<00?ZJ0?ooo`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000D0oooo00<0
o`000?ooo`3oool01P3oool00`3o0000oooo0?l000050?ooo`80o`0000<0oooo0?l0003o0000103o
ool00`3o0000oooo0?ooo`020?l000@0oooo00@0o`000?ooo`3oool0oooo0P3o000T0?ooo`030?l0
003oool0oooo00<0oooo0P3o00020?ooo`80o`001@3oool40?l000L0oooo103o00070?ooo`030?l0
003oool0oooo0080o`004P3oool00`3o0000003o0?l0000D0?ooo`80o`0000<0003o0?l0003oool0
103oool00`3o0000oooo0?ooo`080?ooo`03003jVP3oool00?ZJ00H0oooo00D00?ZJ0?ooo`3oool0
oooo003jVP040?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool00`3oool01@00nYX0
oooo0?ooo`3oool00?ZJ00H0oooo00<00?ZJ0?ooo`3oool00P3oool2000000`0oooo000P0?ooo`03
0000003oool0oooo00<0oooo00<0003o0?l0003oool01`3oool00`3o0000oooo0?l000050?ooo`<0
o`0000<0003o0?l0003oool00`3oool00`3o0000oooo0?ooo`020?l000@0oooo00@0o`000?ooo`3o
ool0oooo0P3o000Z0?ooo`80o`000P3oool20?l000D0oooo103o00070?ooo`040?l000000?l0o`00
0?l000L0oooo00<0o`000?ooo`3oool00P3o000B0?ooo`80o`005@3oool20?l000030000o`3o0000
oooo00@0oooo00<0o`000?ooo`3oool0203oool00`00nYX0oooo003jVP060?ooo`05003jVP3oool0
oooo0?ooo`00nYX0103oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0oooo00<0oooo00D0
0?ZJ0?ooo`3oool0oooo003jVP060?ooo`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool0
2P3oool00200oooo00<000000?ooo`3oool0103oool00`3o0000oooo0?ooo`060?ooo`80o`001P3o
ool30?l000030000o`3o0000oooo00<0oooo00<0o`000?ooo`3oool00P3o00040?ooo`040?l0003o
ool0oooo0?ooo`80o`00:P3oool20?l00080oooo0P3o00050?ooo`@0o`001`3oool0103o0000003o
0?l0003o00070?ooo`030?l0003oool0oooo0080o`004P3oool20?l001D0oooo0P3o00000`000?l0
o`000?ooo`040?ooo`030?l0003oool0oooo00P0oooo00<00?ZJ0?ooo`00nYX01P3oool01@00nYX0
oooo0?ooo`3oool00?ZJ00@0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`040?oo
o`05003jVP3oool0oooo0?ooo`00nYX01P3oool00`00nYX0oooo0?ooo`030?ooo`030000003oool0
oooo00X0oooo000P0?ooo`030000003oool0oooo00@0oooo00<0o`000?ooo`3oool01`3oool00`3o
0000oooo0?ooo`040?ooo`@0o`001@3oool00`3o0000oooo0?ooo`020?l000@0oooo00@0o`000?oo
o`3oool0oooo0P3o000Z0?ooo`80o`000P3oool00`3o0000oooo0?ooo`040?ooo`@0o`00203oool0
0`3o0000oooo0?l000070?ooo`030?l0003oool0oooo0080o`004P3oool20?l001D0oooo00<0o`00
0000o`3o00001P3oool00`3o0000oooo0?ooo`080?ooo`03003jVP3oool00?ZJ00H0oooo00D00?ZJ
0?ooo`3oool0oooo003jVP040?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool0103o
ool01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo00<00?ZJ0?ooo`3oool00`3oool00`000000oooo
0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo00L0oooo00<0
o`000?ooo`3oool0103oool40?l000D0oooo00<0o`000?ooo`3oool00P3o00040?ooo`040?l0003o
ool0oooo0?ooo`80o`00:P3oool20?l000030?ooo`3o0000o`0000H0oooo103o00080?ooo`030?l0
003oool0o`0000L0oooo00<0o`000?ooo`3oool00P3o000B0?ooo`80o`005@3oool00`3o0000003o
0?l000060?ooo`030?l0003oool0oooo00P0oooo00<00?ZJ0?ooo`00nYX01P3oool01@00nYX0oooo
0?ooo`3oool00?ZJ00@0oooo00<00?ZJ0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`040?ooo`04
003jVP3oool0oooo003jVPL0oooo00<00?ZJ0?ooo`3oool00`3oool00`000000oooo0?ooo`0:0?oo
o`00803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3o
ool0103oool40?l000D0oooo00@0o`000?ooo`3oool0o`001@3oool0103o0000oooo0?ooo`3oool2
0?l002X0oooo0P3o00000`3oool0o`000?l000060?ooo`@0o`00203oool00`3o0000003o0?l00007
0?ooo`030?l0003oool0oooo0080o`004P3oool20?l001D0oooo00<0o`000000o`3o00001P3oool0
0`3o0000oooo0?ooo`080?ooo`03003jVP3oool00?ZJ00H0oooo00D00?ZJ0?ooo`3oool0oooo003j
VP040?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0?ooo`3oool0103oool01000nYX0oooo0?oo
o`00nYX70?ooo`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool02P3oool00200oooo0P00
00050?ooo`030?l0003oool0oooo00L0oooo00<0o`000?ooo`3oool0103oool40?l000D0oooo00@0
o`000?ooo`3oool0o`001@3oool01@3o0000oooo0?ooo`3oool0o`0002/0oooo0P3o00000`3oool0
o`000?l000060?ooo`@0o`00203oool00`3o0000003o0?l000070?ooo`030?l0003oool0oooo0080
o`004P3oool20?l001D0oooo00<0o`000000o`3o00001`3oool00`3o0000oooo0?ooo`070?ooo`03
003jVP3oool00?ZJ00H0oooo00D00?ZJ0?ooo`3oool0oooo003jVP050?ooo`05003jVP3oool0oooo
0?ooo`00nYX01P3oool01000nYX0oooo0?ooo`00nYX70?ooo`03003jVP3oool0oooo0080oooo0P00
000<0?ooo`00803oool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo00h0oooo00@0o`00
0000o`3oool0o`001@3oool0103o0000oooo0?ooo`3o00050?ooo`050?l0003oool0oooo0?ooo`3o
0000:`3oool20?l000030?ooo`3o0000o`0000H0oooo103o00080?ooo`030?l000000?l0o`0000L0
oooo00<0o`000?ooo`3oool00P3o000B0?ooo`80o`005P3oool20?l000L0oooo00<0o`000?ooo`3o
ool01`3oool00`00nYX0oooo003jVP060?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool01@00
nYX0oooo0?ooo`3oool00?ZJ00H0oooo00@00?ZJ0?ooo`3oool00?ZJ1`3oool00`00nYX0oooo0?oo
o`030?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00<0oooo00<0o`00
0?ooo`3oool03`3oool0103o0000003o0000o`3o00050?ooo`040?l0003oool0oooo0?l000D0oooo
0P3o00000`3oool0o`000?l0000[0?ooo`80o`0000<0oooo0?l0003o00001`3oool30?l000P0oooo
00<0o`000000o`3o00001`3oool20?l000030?ooo`3o0000o`000180oooo00<0o`000?ooo`3oool0
5@3oool20?l000L0oooo00<0o`000?ooo`3oool01`3oool00`00nYX0oooo003jVP060?ooo`05003j
VP3oool0oooo0?ooo`00nYX01@3oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo00@00?ZJ0?oo
o`3oool00?ZJ1`3oool00`00nYX0oooo0?ooo`030?ooo`030000003oool0oooo00X0oooo000<0?oo
o`<00000103oool2000000@0oooo0P0000050?ooo`030000003oool0oooo00<0oooo00<0o`000?oo
o`3oool03`3oool0103o0000003o0000o`3o00050?ooo`040?l0003oool0oooo0?l000D0oooo0P3o
00000`3oool0o`000?l0000[0?ooo`80o`0000<0oooo0?l0003o00001`3oool20?l000T0oooo00<0
o`000000o`3o00001`3oool20?l000030?ooo`3o0000oooo0180oooo00<0o`000?ooo`3oool05@3o
ool20?l000L0oooo00<0o`000?ooo`3oool01`3oool00`00nYX0oooo003jVP060?ooo`05003jVP3o
ool0oooo0?ooo`00nYX01@3oool01@00nYX0oooo0?ooo`3oool00?ZJ00H0oooo00@00?ZJ0?ooo`3o
ool00?ZJ1`3oool00`00nYX0oooo0?ooo`030?ooo`030000003oool0oooo00X0oooo000=0?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000004
0?ooo`030000003oool0oooo01D0oooo00@0o`000000o`000?l0o`001@3oool0103o0000oooo0?oo
o`3o00050?ooo`80o`0000<0oooo0?l0003o0000:`3oool20?l000030?ooo`3o0000o`0000L0oooo
0P3o00090?ooo`030?l0003oool0o`0000L0oooo0P3o00000`3oool0o`000?ooo`0Z0?ooo`80o`00
1`3oool00`3o0000oooo0?ooo`070?ooo`03003jVP3oool00?ZJ00H0oooo00D00?ZJ0?ooo`3oool0
oooo003jVP050?ooo`05003jVP3oool0oooo0?ooo`00nYX01P3oool01000nYX0oooo0?ooo`00nYX7
0?ooo`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool02P3oool000d0oooo00<000000?oo
o`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo0`00
000F0?ooo`030?l000000?l0o`0000D0oooo00@0o`000?ooo`3o0000o`001@3oool20?l000030?oo
o`3o0000o`0002/0oooo0P3o00000`3oool0o`000?l000070?ooo`80o`002@3oool20?l000P0oooo
103o000[0?ooo`80o`001`3oool00`3o0000oooo0?ooo`080?ooo`800?ZJ1P3oool01@00nYX0oooo
0?ooo`3oool00?ZJ00D0oooo00D00?ZJ0?ooo`3oool0oooo003jVP060?ooo`04003jVP3oool0oooo
003jVPL0oooo00<00?ZJ0?ooo`3oool00P3oool2000000`0oooo000=0?ooo`030000003oool0oooo
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo01H0oooo00<0o`000000o`3o00001@3oool0103o0000oooo0?l0003o00050?ooo`80o`00
00<0oooo0?l0003o0000;03oool0103o0000oooo0?l0003o00070?ooo`80o`002@3oool20?l000P0
oooo103o000[0?ooo`80o`001`3oool00`3o0000oooo0?ooo`080?ooo`800?ZJ1P3oool01@00nYX0
oooo0?ooo`3oool00?ZJ00D0oooo00D00?ZJ0?ooo`3oool0oooo003jVP070?ooo`03003jVP3oool0
0?ZJ00L0oooo00<00?ZJ0?ooo`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`003@3oool00`00
0000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103o
ool00`000000oooo0?ooo`0F0?ooo`030?l0003oool0o`0000D0oooo00@0o`000?ooo`3o0000o`00
1@3oool20?l000030?ooo`3o0000o`0002`0oooo00@0o`000?ooo`3o0000o`001`3oool20?l000T0
oooo0P3o00080?ooo`@0o`00:`3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo00P0
oooo0P00nYX60?ooo`05003jVP3oool0oooo0?ooo`00nYX01@3oool01@00nYX0oooo0?ooo`3oool0
0?ZJ00L0oooo00<00?ZJ0?ooo`00nYX01`3oool00`00nYX0oooo0?ooo`030?ooo`030000003oool0
oooo00X0oooo000<0?ooo`800000103oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool05P3oool20?l000H0oooo00@0o`000?ooo`3o0000o`00
1@3oool20?l000030?ooo`3o0000o`0002`0oooo00@0o`000?ooo`3o0000o`001`3oool20?l000X0
oooo00<0o`000?ooo`3oool01P3oool40?l002/0oooo00<0o`000?ooo`3oool01P3oool00`3o0000
oooo0?ooo`080?ooo`800?ZJ1P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00D00?ZJ0?oo
o`3oool0oooo003jVP070?ooo`03003jVP3oool00?ZJ00L0oooo00<00?ZJ0?ooo`3oool00`3oool0
0`000000oooo0?ooo`0:0?ooo`003@3oool00`000000oooo0?ooo`030?ooo`800000103oool20000
00D0oooo00<000000?ooo`3oool05P3oool20?l000H0oooo00@0o`000?ooo`3o0000o`001@3oool2
0?l000030?ooo`3o0000o`0002`0oooo00@0o`000?ooo`3o0000o`001`3oool20?l000X0oooo00<0
o`000?ooo`3oool01P3oool40?l002/0oooo00<0o`000?ooo`3oool01P3oool00`3o0000oooo0?oo
o`080?ooo`800?ZJ1P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00D00?ZJ0?ooo`3oool0
oooo003jVP070?ooo`800?ZJ203oool00`00nYX0oooo0?ooo`030?ooo`030000003oool0oooo00X0
oooo000P0?ooo`030000003oool0oooo01H0oooo0P3o00060?ooo`040?l0003oool0o`000?l000D0
oooo0P3o00000`3oool0o`000?l0000/0?ooo`040?l0003oool0o`000?l000L0oooo0P3o000C0?oo
o`@0o`00=03oool00`3o0000oooo0?ooo`080?ooo`800?ZJ1P3oool01@00nYX0oooo0?ooo`3oool0
0?ZJ00D0oooo00D00?ZJ0?ooo`3oool0oooo003jVP0A0?ooo`03003jVP3oool0oooo00<0oooo00<0
00000?ooo`3oool02P3oool00200oooo0P00000G0?ooo`80o`001P3oool40?l000D0oooo0P3o0000
0`3oool0o`000?l0000/0?ooo`030?l0003oool0o`0000P0oooo0P3o000C0?ooo`@0o`00=03oool0
0`3o0000oooo0?ooo`080?ooo`800?ZJ1P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00D0oooo00D0
0?ZJ0?ooo`3oool0oooo003jVP0A0?ooo`03003jVP3oool0oooo0080oooo0P00000<0?ooo`00803o
ool00`000000oooo0?ooo`0F0?ooo`80o`001P3oool40?l000D0oooo0P3o00000`3oool0o`000?l0
000/0?ooo`<0o`00203oool20?l001<0oooo103o000d0?ooo`030?l0003oool0oooo00P0oooo0P00
nYX60?ooo`04003jVP3oool0oooo003jVPH0oooo00D00?ZJ0?ooo`3oool0oooo003jVP0A0?ooo`03
003jVP3oool0oooo00<0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0
5P3oool20?l000H0oooo103o00050?ooo`80o`0000<0oooo0?l0003o0000;03oool30?l000P0oooo
0P3o000C0?ooo`80o`0000<0003o0?l0003oool0<`3oool00`3o0000oooo0?ooo`080?ooo`03003j
VP3oool0oooo00D0oooo00@00?ZJ0?ooo`3oool00?ZJ1P3oool01@00nYX0oooo0?ooo`3oool00?ZJ
0140oooo00<00?ZJ0?ooo`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000
oooo0?ooo`0N0?ooo`@0o`001@3oool40?l002d0oooo0`3o00080?ooo`80o`004`3oool20?l00003
0000o`3o0000oooo03<0oooo00<0o`000?ooo`3oool0203oool00`00nYX0oooo0?ooo`050?ooo`04
003jVP3oool0oooo003jVPH0oooo00D00?ZJ0?ooo`3oool0oooo003jVP0A0?ooo`03003jVP3oool0
oooo00<0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool07P3oool40?l0
00H0oooo0`3o000]0?ooo`<0o`00203oool20?l001@0oooo00<0o`000000o`3o0000=03oool00`3o
0000oooo0?ooo`0@0?ooo`04003jVP3oool0oooo003jVPH0oooo00D00?ZJ0?ooo`3oool0oooo003j
VP0A0?ooo`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool02P3oool00200oooo00<00000
0?ooo`3oool07P3oool40?l000H0oooo0`3o000]0?ooo`<0o`00203oool20?l001@0oooo00<0o`00
0000o`3o0000=03oool00`3o0000oooo0?ooo`0@0?ooo`04003jVP3oool0oooo003jVPH0oooo00D0
0?ZJ0?ooo`3oool0oooo003jVP0A0?ooo`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool0
2P3oool00200oooo0P00000O0?ooo`<0o`001`3oool30?l002d0oooo0`3o00080?ooo`030?l0003o
ool0oooo01<0oooo00<0o`000000o`3o0000=03oool00`3o0000oooo0?ooo`0@0?ooo`04003jVP3o
ool0oooo003jVPH0oooo00D00?ZJ0?ooo`3oool0oooo003jVP0A0?ooo`03003jVP3oool0oooo0080
oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`0N0?ooo`<0o`001`3oool30?l002d0oooo
0`3o00080?ooo`030?l0003oool0oooo01<0oooo0P3o000e0?ooo`030?l0003oool0oooo0100oooo
00@00?ZJ0?ooo`3oool00?ZJ1P3oool01@00nYX0oooo0?ooo`3oool00?ZJ0140oooo00<00?ZJ0?oo
o`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0N0?ooo`<0
o`001`3oool00`3o0000oooo0?l0000]0?ooo`<0o`00203oool00`3o0000oooo0?ooo`0C0?ooo`80
o`00=P3oool00`3o0000oooo0?ooo`0@0?ooo`03003jVP3oool00?ZJ00H0oooo00D00?ZJ0?ooo`3o
ool0oooo003jVP0A0?ooo`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool02P3oool00200
oooo00<000000?ooo`3oool07P3oool30?l000L0oooo00<0o`000?ooo`3o0000;@3oool00`3o0000
003o0?l000080?ooo`030?l0003oool0oooo01<0oooo0P3o000f0?ooo`030?l0003oool0oooo0100
oooo00<00?ZJ0?ooo`00nYX01P3oool01@00nYX0oooo0?ooo`3oool00?ZJ0180oooo00<00?ZJ0?oo
o`3oool00P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0N0?ooo`<0
o`001`3oool00`3o0000003o0?l0000]0?ooo`030?l000000?l0o`0000P0oooo00<0o`000?ooo`3o
ool04`3oool20?l003H0oooo00<0o`000?ooo`3oool00P3oool30?l000/0oooo00<00?ZJ0?ooo`00
nYX01P3oool01@00nYX0oooo0?ooo`3oool00?ZJ0180oooo00<00?ZJ0?ooo`3oool00P3oool00`00
0000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0N0?ooo`<0o`001`3oool00`3o0000
003o0?l0000]0?ooo`030?l000000?l0o`0000P0oooo00<0o`000?ooo`3oool04`3oool20?l003H0
oooo00D0o`000?ooo`3oool0oooo0?l000030?ooo`030?l0003oool0oooo00P0oooo00<00?ZJ0?oo
o`00nYX01P3oool01@00nYX0oooo0?ooo`3oool00?ZJ0180oooo00<00?ZJ0?ooo`3oool00P3oool0
0`000000oooo0?ooo`0:0?ooo`00803oool200000200oooo0P3o00070?ooo`030?l000000?l0o`00
02d0oooo00<0o`000000o`3o0000203oool00`3o0000oooo0?ooo`0C0?ooo`80o`00=P3oool01@3o
0000oooo0?ooo`3oool0o`0000<0oooo00<0o`000?ooo`3oool0203oool00`00nYX0oooo003jVP06
0?ooo`05003jVP3oool0oooo0?ooo`00nYX04P3oool01000nYX0oooo0?ooo`3oool2000000`0oooo
000P0?ooo`030000003oool0oooo01l0oooo0P3o00070?ooo`030?l000000?l0o`0002d0oooo00<0
o`000000o`3o00007P3oool20?l003H0oooo00@0o`000?ooo`3oool0o`001@3oool0103o0000oooo
0?ooo`3oool60?l00003003jVP3o00000?ZJ00H0o`0000D00?ZJ0?l0003o0000o`00003jVP0B0?l0
0003003jVP3oool0oooo0080oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3o
ool07`3oool20?l000L0oooo00<0o`000000o`3o0000;@3oool20?l001l0oooo0P3o000f0?ooo`04
0?l0003oool0oooo0?l000H0oooo0`3o00060?ooo`03003jVP3oool00?ZJ00H0oooo00D00?ZJ0?oo
o`3oool0oooo003jVP0B0?ooo`03003jVP3oool0oooo0080oooo00<000000?ooo`3oool02P3oool0
0200oooo00<000000?ooo`3oool07`3oool20?l000L0oooo00<0o`000?ooo`3o0000;@3oool20?l0
01l0oooo00<0o`000?ooo`3oool0=@3oool0103o0000oooo0?ooo`3o000?0?ooo`03003jVP3oool0
0?ZJ00H0oooo00D00?ZJ0?ooo`3oool0oooo003jVP0B0?ooo`03003jVP3oool0oooo0080oooo00<0
00000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool07`3oool20?l000L0oooo0P3o000^
0?ooo`80o`007`3oool00`3o0000oooo0?ooo`0e0?ooo`030?l0003oool0o`000100oooo0P00nYX7
0?ooo`04003jVP3oool0oooo003jVQ<0oooo00<00?ZJ0?ooo`3oool00P3oool00`000000oooo0?oo
o`0:0?ooo`00803oool00`000000oooo0?ooo`0O0?ooo`80o`001`3oool20?l002l0oooo00<0o`00
0?ooo`3oool0EP3oool20?l00100oooo0P00nYX70?ooo`04003jVP3oool0oooo003jVQ<0oooo00<0
0?ZJ0?ooo`3oool00P3oool00`000000oooo0?ooo`0:0?ooo`00803oool200000200oooo0P3o0007
0?ooo`80o`00;`3oool00`3o0000oooo0?ooo`1F0?ooo`030?l0003oool0oooo00l0oooo0P00nYX7
0?ooo`04003jVP3oool0oooo003jVQ<0oooo00@00?ZJ0?ooo`3oool0oooo0P00000<0?ooo`00803o
ool00`000000oooo0?ooo`0O0?ooo`80o`00203oool00`3o0000oooo0?ooo`0]0?ooo`030?l0003o
ool0oooo06P0oooo0P00nYX70?ooo`04003jVP3oool0oooo003jVQ<0oooo00<00?ZJ0?ooo`3oool0
0P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`0O0?ooo`80o`00203o
ool00`3o0000oooo0?ooo`0]0?ooo`030?l0003oool0oooo06P0oooo0P00nYX70?ooo`04003jVP3o
ool0oooo003jVQ<0oooo00<00?ZJ0?ooo`3oool00P3oool00`000000oooo0?ooo`0:0?ooo`00303o
ool3000000<0oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`0O0?ooo`80o`00>03o
ool00`3o0000oooo0?ooo`1X0?ooo`03003jVP3oool0oooo00H0oooo00@00?ZJ0?ooo`3oool00?ZJ
4`3oool00`00nYX0oooo0?ooo`020?ooo`030000003oool0oooo00X0oooo000=0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool07`3oool20?l00:<0oooo00<00?ZJ0?ooo`3oool01P3oool01000nYX0
oooo0?ooo`00nYXC0?ooo`03003jVP3oool0oooo0080oooo00<000000?ooo`3oool02P3oool000d0
oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool07`3oool00`3o0000oooo0?ooo`2R0?ooo`03003jVP3oool0oooo
00H0oooo00@00?ZJ0?ooo`3oool00?ZJ4`3oool00`00nYX0oooo0?ooo`020?ooo`030000003oool0
oooo00X0oooo000=0?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool000000P3oool0
0`000000oooo0?ooo`020?ooo`<000007`3oool00`3o0000oooo0?ooo`2R0?ooo`03003jVP3oool0
oooo00H0oooo00@00?ZJ0?ooo`3oool00?ZJ4`3oool01000nYX0oooo0?ooo`3oool2000000`0oooo
000=0?ooo`040000003oool0oooo0?ooo`@000000`3oool010000000oooo0?ooo`0000040?ooo`03
0000003oool0oooo01l0oooo00<0o`000?ooo`3oool0XP3oool00`00nYX0oooo0?ooo`060?ooo`04
003jVP3oool0oooo003jVQ<0oooo00<00?ZJ0?ooo`3oool00P3oool00`000000oooo0?ooo`0:0?oo
o`00303oool2000000<0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo01l0oooo00<0o`000?ooo`3oool0Z`3oool01000nYX0oooo0?ooo`00nYXC
0?ooo`03003jVP3oool0oooo0080oooo00<000000?ooo`3oool02P3oool000d0oooo00@000000?oo
o`3oool0oooo1@0000030?ooo`8000001@3oool00`000000oooo0?ooo`0O0?ooo`030?l0003oool0
oooo0:/0oooo00@00?ZJ0?ooo`3oool00?ZJ4`3oool00`00nYX0oooo0?ooo`020?ooo`030000003o
ool0oooo00X0oooo000P0?ooo`030000003oool0oooo0<d0oooo00@00?ZJ0?ooo`3oool00?ZJ603o
ool00`000000oooo0?ooo`0:0?ooo`00803oool200000<h0oooo00@00?ZJ0?ooo`3oool00?ZJ5`3o
ool2000000`0oooo000P0?ooo`030000003oool0oooo0<d0oooo00@00?ZJ0?ooo`3oool00?ZJ603o
ool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`3=0?ooo`04003jVP3oool0
oooo003jVQP0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0c@3oool0
1000nYX0oooo0?ooo`00nYXH0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0
oooo0<d0oooo00@00?ZJ0?ooo`3oool00?ZJ603oool00`000000oooo0?ooo`0:0?ooo`00803oool0
0`000000oooo0?ooo`3>0?ooo`03003jVP3oool00?ZJ01P0oooo00<000000?ooo`3oool02P3oool0
0200oooo0P00003?0?ooo`03003jVP3oool00?ZJ01L0oooo0P00000<0?ooo`00803oool00`000000
oooo0?ooo`3>0?ooo`03003jVP3oool00?ZJ01P0oooo00<000000?ooo`3oool02P3oool00200oooo
00<000000?ooo`3oool0cP3oool2003jVQT0oooo00<000000?ooo`3oool02P3oool00200oooo00<0
00000?ooo`3oool0cP3oool2003jVQT0oooo00<000000?ooo`3oool02P3oool00200oooo00<00000
0?ooo`3oool0cP3oool2003jVQT0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?oo
o`3oool0cP3oool2003jVQT0oooo00<000000?ooo`3oool02P3oool00200oooo0P00003?0?ooo`80
0?ZJ603oool2000000`0oooo000P0?ooo`030000003oool0oooo0<h0oooo0P00nYXI0?ooo`030000
003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo0<h0oooo0P00nYXI0?ooo`030000003o
ool0oooo00X0oooo000P0?ooo`030000003oool0oooo0<h0oooo0P00nYXI0?ooo`030000003oool0
oooo00X0oooo000P0?ooo`030000003oool0oooo0<h0oooo0P00nYXI0?ooo`030000003oool0oooo
00X0oooo000P0?ooo`030000003oool0oooo0<h0oooo00<00?ZJ0?ooo`3oool0603oool00`000000
oooo0?ooo`0:0?ooo`00803oool200000<l0oooo00<00?ZJ0?ooo`3oool05`3oool2000000`0oooo
000P0?ooo`030000003oool0oooo0>T0oooo00<000000?ooo`3oool02P3oool00200oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo02d0oooo00<00000
0?ooo`3oool0;P3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo01l0oooo00<00000
0?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00L0oooo00D000000?ooo`3oool0oooo0000000<0?ooo`00803oooo]0000
00`0oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo00120?ooo`<0<c<cS@3oool3
03<c<d@0oooo00130?ooo`0303<c<`3oool0oooo08d0oooo00<0<c<c0?ooo`3oool0@`3oool004<0
oooo0`0c<c<20?ooo`<0<c<c103oool303<c<`<0oooo100c<c<00`3oool0<c<c03<c<`0303<c<`80
oooo0`0c<c<40?ooo`80<c<c0`3oool303<c<`<0oooo100c<c<70?ooo`<0<c<c00<0oooo03<c<`0c
<c<00P3oool203<c<`080?ooo`0c<c<0<c<c0?ooo`0c<c<0oooo03<c<`3oool403<c<`<0oooo0`0c
<c<20?ooo`<0<c<c2P3oool303<c<`80oooo1@0c<c<70?ooo`@0<c<c103oool203<c<`030?ooo`0c
<c<0<c<c0080<c<c00<0oooo03<c<`0c<c<0100c<c<30?ooo`<0<c<c0`3oool303<c<`@0oooo0P0c
<c<20?ooo`@0<c<c<@3oool004<0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo0?oo
o`020?ooo`0303<c<`3oool0oooo00<0oooo00@0<c<c0?ooo`3oool0<c<c103oool01@0c<c<0oooo
0?ooo`3oool0<c<c00<0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo03<c<`050?oo
o`0403<c<`3oool0oooo03<c<`T0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool02P0c<c<0oooo0?oo
o`0c<c<0oooo03<c<`3oool0<c<c0?ooo`0c<c<20?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c
1P3oool00`0c<c<0oooo0?ooo`080?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3oool00`0c<c<0
oooo0?ooo`0;0?ooo`0403<c<`3oool0oooo03<c<`80oooo00@0<c<c0?ooo`3oool0<c<c0P3oool0
0`0c<c<0oooo0?ooo`030?ooo`0403<c<`3oool0oooo03<c<`80oooo00<0<c<c0?ooo`0c<c<00`3o
ool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00<0oooo00<0<c<c0?ooo`3oool0
;P3oool004<0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo0?ooo`020?ooo`D0<c<c
00D0oooo03<c<`3oool0oooo03<c<`040?ooo`0503<c<`3oool0oooo0?ooo`0c<c<01P3oool00`0c
<c<0oooo0?ooo`020?ooo`D0<c<c00D0oooo03<c<`3oool0oooo03<c<`090?ooo`0403<c<`3oool0
oooo03<c<`80oooo00X0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<0oooo03<c<`3oool0<c<c0P3oool0
1@0c<c<0oooo0?ooo`0c<c<0oooo00D0<c<c0P3oool00`0c<c<0oooo0?ooo`080?ooo`0503<c<`3o
ool0oooo0?ooo`0c<c<00`3oool00`0c<c<0oooo0?ooo`080?ooo`<0<c<c0`3oool0100c<c<0oooo
0?ooo`0c<c<20?ooo`0403<c<`3oool0oooo03<c<`80oooo0`0c<c<30?ooo`0603<c<`3oool0oooo
03<c<`3oool0<c<c0`3oool0100c<c<0oooo0?ooo`0c<c<50?ooo`<0<c<c<@3oool004<0oooo00@0
<c<c0?ooo`3oool0<c<c0P3oool203<c<`<0oooo00L0<c<c0?ooo`3oool0oooo03<c<`3oool0<c<c
0080oooo00<0<c<c0?ooo`3oool00P3oool01@0c<c<0oooo0?ooo`3oool0<c<c00<0oooo00@0<c<c
0?ooo`3oool0<c<c103oool01`0c<c<0oooo0?ooo`3oool0<c<c0?ooo`0c<c<00P3oool00`0c<c<0
oooo0?ooo`070?ooo`0403<c<`3oool0oooo03<c<`80oooo00X0<c<c0?ooo`3oool0<c<c0?ooo`0c
<c<0oooo03<c<`3oool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`<0oooo00<0<c<c
0?ooo`3oool00P0c<c<90?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3oool00`0c<c<0oooo0?oo
o`070?ooo`0303<c<`3oool0oooo00@0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool01P0c<c<0oooo
0?ooo`0c<c<0oooo03<c<`H0oooo00H0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<30?ooo`0403<c<`3o
ool0oooo03<c<`@0oooo00<0<c<c0?ooo`3oool0<P3oool00480oooo100c<c<20?ooo`80<c<c00<0
oooo03<c<`0c<c<00P3oool303<c<`<0oooo0`0c<c<20?ooo`<0<c<c103oool303<c<`80oooo100c
<c<30?ooo`<0<c<c0`3oool303<c<`P0oooo100c<c<20?ooo`80<c<c00@0oooo03<c<`0c<c<0oooo
0P0c<c<00`3oool0<c<c0?ooo`020?ooo`<0<c<c0`3oool303<c<`80oooo0P0c<c<00`3oool0<c<c
03<c<`080?ooo`<0<c<c0`3oool403<c<`P0oooo100c<c<0103oool0<c<c03<c<`3oool203<c<`03
0?ooo`0c<c<0<c<c0080<c<c0`3oool403<c<`030?ooo`0c<c<0<c<c0080<c<c0`3oool303<c<`80
oooo100c<c<30?ooo`@0<c<c<03oool005L0oooo00<0<c<c0?ooo`3oool03@3oool00`0c<c<0oooo
0?ooo`0;0?ooo`0303<c<`3oool0oooo01T0oooo00<0<c<c0?ooo`3oool0703oool00`0c<c<0oooo
0?ooo`0/0?ooo`0303<c<`3oool0oooo03L0oooo001F0?ooo`80<c<c103oool00`0c<c<0oooo0?oo
o`080?ooo`0303<c<`3oool0oooo00X0oooo0P0c<c<J0?ooo`80<c<c7`3oool203<c<b`0oooo00<0
<c<c0?ooo`3oool0=`3oool00?l0oooo6P3oool00?l0oooo6P3oool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {1709.98, -74.1779, \
1.02251, 1.71177}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["diagnostic tests", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["<<prognose.filter.m", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
THETA
PHI\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({\(-3.996093018481496`\), \(-3.77198528172654`\), 
      18.723900035966057`}\)], "Output"],

Cell[BoxData[
    \({44.518578636023484`, 26.4461493694456`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DIAGNOSE[maxlag=30,pq=4,Z,X,
 \t\t dt,Nselect={1},tselect={1,T1},THETA,PHI,NONLIN=1,PRINT={0,0,0}];\
\>", \
"Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("**********************************************************************\
"\)], "Print"],

Cell[BoxData[
    \("***********************MODUL: \
DIAGNOSE********************************"\)], "Print"],

Cell[BoxData[
    \("**********************************************************************\
"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("{k,p,q,n,T} = "\[InvisibleSpace]{1, 2, 1, 1, 175}\),
      SequenceForm[ "{k,p,q,n,T} = ", {1, 2, 1, 1, 175}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Analyse der standardisierten Innovationen Gamma^-.5 nue"\)], "Print"],

Cell[BoxData[
    \("---------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Selektion {t1, t2} = "\[InvisibleSpace]{1, 176}\),
      SequenceForm[ "Selektion {t1, t2} = ", {1, 176}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("---------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("---------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("2-Norm der Innovation (Summe nue_tpn^2)^(1/2): "\
\[InvisibleSpace]13.19743466266146`\),
      SequenceForm[ 
      "2-Norm der Innovation (Summe nue_tpn^2)^(1/2): ", 13.197434662661459],
      Editable->False]], "Print"],

Cell[BoxData[
    \("---------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("getrennte Analyse der Einheiten  \
"\[InvisibleSpace]{1}\),
      SequenceForm[ "getrennte Analyse der Einheiten  ", {1}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("---------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("---------------Statistische Einheit----------------: \
 "\[InvisibleSpace]1\),
      SequenceForm[ 
      "---------------Statistische Einheit----------------:  ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    \("---------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Multivariate Portmanteau-Statistik (Hosking 1980)"\)], "Print"],

Cell[BoxData[
    \("---------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\(" K = "\[InvisibleSpace]1\[InvisibleSpace]", u = "\
\[InvisibleSpace]4\[InvisibleSpace]", maxlag = "\[InvisibleSpace]30\
\[InvisibleSpace]", df = K^2 lag - u"\),
      SequenceForm[ 
      " K = ", 1, ", u = ", 4, ", maxlag = ", 30, ", df = K^2 lag - u"],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"lag\"\>", "\<\"df\"\>", "\<\"P\"\>", "\<\"prob\"\>", \
"\<\"Pmod\"\>", "\<\"probmod\"\>"},
          {"5", "1", "3.011085879492367`", "0.0826968746861163`", 
            "3.0798725454025973`", "0.07926673754689462`"},
          {"6", "2", "3.27855216021252`", "0.19412051914335393`", 
            "3.356778812501109`", "0.18667439065829217`"},
          {"7", "3", "4.10896654744933`", "0.24993556884046697`", 
            "4.22158906193116`", "0.2385092797541758`"},
          {"8", "4", "5.2049226233820125`", "0.26690993431494214`", 
            "5.369733522432066`", "0.2514195067652779`"},
          {"9", "5", "8.139507395731881`", "0.14871284781134242`", 
            "8.462469569938515`", "0.13252274031215494`"},
          {"10", "6", "9.326997138752494`", "0.15600589125760433`", 
            "9.721494839647116`", "0.13688110272257514`"},
          {"11", "7", "13.834154240198815`", "0.054210937568445305`", 
            "14.52912908118986`", "0.04253191922223465`"},
          {"12", "8", "16.276230567748943`", "0.03859279162480311`", 
            "17.14989392051195`", "0.028585546814665297`"},
          {"13", "9", "16.276402372008228`", "0.06132917383122016`", 
            "17.150079426951418`", "0.046416966591433906`"},
          {"14", "10", "16.39459539722292`", "0.08888013539650363`", 
            "17.278486664221703`", "0.06842446458253537`"},
          {"15", "11", "16.396039162131817`", "0.12705319750146105`", 
            "17.280064941389195`", "0.09985997017949266`"},
          {"16", "12", "17.1478679776881`", "0.14411916610420727`", 
            "18.107076638501102`", "0.11247777572103701`"},
          {"17", "13", "18.443669882924755`", "0.14138844457189714`", 
            "19.54142340153036`", "0.10724947367098625`"},
          {"18", "14", "19.48165342419835`", "0.14734883884470507`", 
            "20.69765823231613`", "0.10963511036846352`"},
          {"19", "15", "19.634876415755244`", "0.1863910929778413`", 
            "20.869424133679278`", "0.1410533998899517`"},
          {"20", "16", "20.09376888507743`", "0.21602700163430333`", 
            "21.387148970863283`", "0.16410446632311393`"},
          {"21", "17", "20.76065623443593`", "0.23717959308973824`", 
            "22.14438879981229`", "0.17922977837038934`"},
          {"22", "18", "22.21092047367754`", "0.22275544099772226`", 
            "23.801833644659844`", "0.1616278319587321`"},
          {"23", "19", "22.35252862654578`", "0.2670643187944761`", 
            "23.96472929763246`", "0.1975087766139494`"},
          {"24", "20", "22.380000098236213`", "0.3202517971980462`", 
            "23.996538370116127`", "0.2425434059595466`"},
          {"25", "21", "22.38003458407988`", "0.37790105863477663`", 
            "23.996578565536556`", "0.2932243398603389`"},
          {"26", "22", "24.209044829108052`", "0.33636782915182817`", 
            "26.142617253036274`", "0.2456091539824753`"},
          {"27", "23", "29.586578241857087`", "0.16164122552229532`", 
            "32.49460302916936`", "0.09028642785008412`"},
          {"28", "24", "29.6229933490512`", "0.19756279766050866`", 
            "32.53790748096776`", "0.11420508325828338`"},
          {"29", "25", "30.19525296615901`", "0.21706123880904304`", 
            "33.22306185247099`", "0.12558502677812478`"},
          {"30", "26", "32.85752315548259`", "0.16627180849130663`", 
            "36.43237386151859`", "0.08399935346184739`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> {Column, Row}, TableSpacing -> 
          Automatic, TableHeadings -> {None, {"lag", "df", "P", "prob", 
          "Pmod", "probmod"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{26, 3}\),
      SequenceForm[ "Dimension der Daten  ", {26, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0380952 -0.0383151 0.0176116 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04974 -6 -4.5 ]
[-0.0125 .04974 0 4.5 ]
[-0.0125 .1378 -12 -4.5 ]
[-0.0125 .1378 0 4.5 ]
[-0.0125 .22586 -12 -4.5 ]
[-0.0125 .22586 0 4.5 ]
[-0.0125 .31392 -12 -4.5 ]
[-0.0125 .31392 0 4.5 ]
[-0.0125 .40198 -12 -4.5 ]
[-0.0125 .40198 0 4.5 ]
[-0.0125 .49003 -12 -4.5 ]
[-0.0125 .49003 0 4.5 ]
[-0.0125 .57809 -12 -4.5 ]
[-0.0125 .57809 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -149 0 ]
[.5 .63053 149 12 ]
[.97619 .54036 -5 -6 ]
[.97619 .54036 5 6 ]
[.97619 .60332 -5 -6 ]
[.97619 .60332 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(5)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(10)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(15)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(20)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(25)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04974 m
.00625 .04974 L
s
[(5)] -0.0125 .04974 1 0 Mshowa
0 .1378 m
.00625 .1378 L
s
[(10)] -0.0125 .1378 1 0 Mshowa
0 .22586 m
.00625 .22586 L
s
[(15)] -0.0125 .22586 1 0 Mshowa
0 .31392 m
.00625 .31392 L
s
[(20)] -0.0125 .31392 1 0 Mshowa
0 .40198 m
.00625 .40198 L
s
[(25)] -0.0125 .40198 1 0 Mshowa
0 .49003 m
.00625 .49003 L
s
[(30)] -0.0125 .49003 1 0 Mshowa
0 .57809 m
.00625 .57809 L
s
[(35)] -0.0125 .57809 1 0 Mshowa
.125 Mabswid
0 .06735 m
.00375 .06735 L
s
0 .08497 m
.00375 .08497 L
s
0 .10258 m
.00375 .10258 L
s
0 .12019 m
.00375 .12019 L
s
0 .15541 m
.00375 .15541 L
s
0 .17302 m
.00375 .17302 L
s
0 .19064 m
.00375 .19064 L
s
0 .20825 m
.00375 .20825 L
s
0 .24347 m
.00375 .24347 L
s
0 .26108 m
.00375 .26108 L
s
0 .27869 m
.00375 .27869 L
s
0 .29631 m
.00375 .29631 L
s
0 .33153 m
.00375 .33153 L
s
0 .34914 m
.00375 .34914 L
s
0 .36675 m
.00375 .36675 L
s
0 .38436 m
.00375 .38436 L
s
0 .41959 m
.00375 .41959 L
s
0 .4372 m
.00375 .4372 L
s
0 .45481 m
.00375 .45481 L
s
0 .47242 m
.00375 .47242 L
s
0 .50765 m
.00375 .50765 L
s
0 .52526 m
.00375 .52526 L
s
0 .54287 m
.00375 .54287 L
s
0 .56048 m
.00375 .56048 L
s
0 .03213 m
.00375 .03213 L
s
0 .01452 m
.00375 .01452 L
s
0 .5957 m
.00375 .5957 L
s
0 .61332 m
.00375 .61332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04974 m
1 .04974 L
s
.99375 .1378 m
1 .1378 L
s
.99375 .22586 m
1 .22586 L
s
.99375 .31392 m
1 .31392 L
s
.99375 .40198 m
1 .40198 L
s
.99375 .49003 m
1 .49003 L
s
.99375 .57809 m
1 .57809 L
s
.125 Mabswid
.99625 .06735 m
1 .06735 L
s
.99625 .08497 m
1 .08497 L
s
.99625 .10258 m
1 .10258 L
s
.99625 .12019 m
1 .12019 L
s
.99625 .15541 m
1 .15541 L
s
.99625 .17302 m
1 .17302 L
s
.99625 .19064 m
1 .19064 L
s
.99625 .20825 m
1 .20825 L
s
.99625 .24347 m
1 .24347 L
s
.99625 .26108 m
1 .26108 L
s
.99625 .27869 m
1 .27869 L
s
.99625 .29631 m
1 .29631 L
s
.99625 .33153 m
1 .33153 L
s
.99625 .34914 m
1 .34914 L
s
.99625 .36675 m
1 .36675 L
s
.99625 .38436 m
1 .38436 L
s
.99625 .41959 m
1 .41959 L
s
.99625 .4372 m
1 .4372 L
s
.99625 .45481 m
1 .45481 L
s
.99625 .47242 m
1 .47242 L
s
.99625 .50765 m
1 .50765 L
s
.99625 .52526 m
1 .52526 L
s
.99625 .54287 m
1 .54287 L
s
.99625 .56048 m
1 .56048 L
s
.99625 .03213 m
1 .03213 L
s
.99625 .01452 m
1 .01452 L
s
.99625 .5957 m
1 .5957 L
s
.99625 .61332 m
1 .61332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -210 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(Portmanteau) show
129.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(-) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(Statistiken) show
207.000 13.000 moveto
(P) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
219.000 13.000 moveto
(H) show
225.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(blau) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
249.000 13.000 moveto
(L) show
261.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(und) show
285.000 13.000 moveto
(Pmod) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
315.000 13.000 moveto
(H) show
321.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(gruen) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
351.000 13.000 moveto
(L) show
357.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 1 r
gsave
.97619 .54036 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.0619 .01943 L
.1 .03405 L
.1381 .05335 L
.17619 .10504 L
.21429 .12595 L
.25238 .20533 L
.29048 .24834 L
.32857 .24834 L
.36667 .25042 L
.40476 .25045 L
.44286 .26369 L
.48095 .28651 L
.51905 .30479 L
.55714 .30749 L
.59524 .31557 L
.63333 .32731 L
.67143 .35286 L
.70952 .35535 L
.74762 .35583 L
.78571 .35583 L
.82381 .38805 L
.8619 .48275 L
.9 .48339 L
.9381 .49347 L
.97619 .54036 L
s
0 .98 .604 r
gsave
.97619 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01593 m
.0619 .0208 L
.1 .03603 L
.1381 .05625 L
.17619 .11072 L
.21429 .1329 L
.25238 .21757 L
.29048 .26372 L
.32857 .26373 L
.36667 .26599 L
.40476 .26602 L
.44286 .28058 L
.48095 .30584 L
.51905 .3262 L
.55714 .32923 L
.59524 .33835 L
.63333 .35168 L
.67143 .38087 L
.70952 .38374 L
.74762 .3843 L
.78571 .3843 L
.82381 .4221 L
.8619 .53397 L
.9 .53473 L
.9381 .5468 L
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{416, 257.125},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006P00010B000`400?l00000o`00003oo`3ooonQ
0?ooo`00:03oool2000004<0oooo0`00000o0?ooo`<00000103oool2000003d0oooo0`0000030?oo
o`<00000?03oool5000000<0oooo0P00000k0?ooo`D000000P3oool3000001L0oooo000W0?ooo`04
0000003oool0oooo00000440oooo00D000000?ooo`3oool0oooo0000000o0?ooo`030000003oool0
oooo0080oooo00@000000?ooo`3oool00000?@3oool01@000000oooo0?ooo`3oool0000000<0oooo
00<000000?ooo`3oool0>P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
03/0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003oool0oooo01@0oooo000W
0?ooo`040000003oool0oooo000004D0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?oo
o`020?ooo`040000003oool0oooo000003d0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0k0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000?03oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo01@0oooo000W0?ooo`040000003oool0oooo000004D0
oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
03d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0l0?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0503oool002L0oooo00@000000?ooo`3oool00000@@3oool400000400oooo00<00000
0?ooo`3oool00P3oool010000000oooo0?ooo`00000m0?ooo`040000003oool0oooo0?ooo`@00000
?03oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000>P3oool01P00
0000oooo0?ooo`3oool000000?ooo`@000005`3oool002L0oooo00@000000?ooo`3oool00000@@3o
ool00`000000oooo0?ooo`100?ooo`800000103oool010000000oooo0?ooo`00000l0?ooo`800000
0`3oool00`000000oooo0?ooo`0m0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000
oooo0?ooo`00000j0?ooo`070000003oool0oooo0?ooo`000000oooo0000000J0?ooo`00:03oool2
00000480oooo1@00000o0?ooo`030000003oool0oooo00<0oooo0P00000n0?ooo`040000003oool0
oooo0?ooo`D00000?03oool3000000@0oooo0P00000l0?ooo`<000000P3oool5000001H0oooo003o
0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo003o
0?oooj40oooo000P0?ooool00000L000000A0?ooo`00803oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0:0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0?0?ooo`00
803oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0
@P3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0
@P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003o
ool0oooo0?l0ooooK03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`05
0?ooo`L0003oo`3ooomP0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<000001@3oool7003j
VPL0003oo`3ooomH0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool01@3oool>003jVP@0
003oo`3ooomE0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00D0oooo
4P00nYX30000ool0ooooDP3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?oo
o`0:0?oooa000?ZJ0`000?oo0?ooodl0oooo00<000000?ooo`3oool03`3oool00200oooo00<00000
0?ooo`3oool04@3oool<003jVP<0003oo`3ooom<0?ooo`030000003oool0oooo00l0oooo000P0?oo
o`030000003oool0oooo01D0oooo2`00nYX30000ool0ooooB@3oool00`000000oooo0?ooo`0?0?oo
o`00803oool00`000000oooo0?ooo`0H0?ooo`/00?ZJ0P000?oo0?ooodL0oooo00<000000?ooo`3o
ool03`3oool00200oooo0`00000K0?ooo`X00?ZJ0P000?oo0?oood@0oooo0P00000A0?ooo`00803o
ool00`000000oooo0?ooo`0N0?ooo`T00?ZJ0P000?oo0?oood<0oooo00<000000?ooo`3oool03`3o
ool00200oooo00<000000?ooo`3oool08@3oool7003jVP<0003oo`3ooom10?ooo`030000003oool0
oooo00l0oooo000P0?ooo`030000003oool0oooo02<0oooo1`00nYX30000ool0oooo?`3oool00`00
0000oooo0?ooo`0?0?ooo`005`3oool3000000H0oooo00<000000?ooo`3oool09@3oool7003jVP<0
003oo`3ooolm0?ooo`030000003oool0oooo00l0oooo000F0?ooo`050000003oool0oooo0?ooo`00
00001@3oool00`000000oooo0?ooo`0V0?ooo`P00?ZJ0`000?oo0?oooc/0oooo00<000000?ooo`3o
ool03`3oool001X0oooo00<000000?ooo`3oool00`3oool4000002L0oooo1`00nYX30000ool0oooo
>03oool300000140oooo000J0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0:P3o
ool7003jVP030000o`3oool0oooo0?l0oooo>03oool00`000000oooo0?ooo`0?0?ooo`005P3oool4
000000H0oooo00<000000?ooo`3oool0;03oool6003jVP030000o`3oool0oooo0?l0oooo=`3oool0
0`000000oooo0?ooo`0?0?ooo`005P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
02d0oooo1@00nYX20000ool0oooo>03oool00`000000oooo0?ooo`0?0?ooo`005P3oool5000000D0
oooo00<000000?ooo`3oool0;`3oool4003jVP80003oo`3ooolg0?ooo`030000003oool0oooo00l0
oooo000P0?ooo`030000003oool0oooo02l0oooo1@00nYX00`000?l0oooo0?ooo`3o0?ooocD0oooo
00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0<03oool5003jVP030000o`3o
ool0oooo0?l0oooo=03oool00`000000oooo0?ooo`0?0?ooo`00803oool300000340oooo1000nYX2
0000ool0oooo=03oool200000140oooo000P0?ooo`030000003oool0oooo0380oooo1000nYX20000
ool0oooo=03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0b0?ooo`D0
0?ZJ00<0003o0?ooo`3oool0o`3ooolb0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000
003oool0oooo03<0oooo1@00nYX00`000?l0oooo0?ooo`3o0?oooc40oooo00<000000?ooo`3oool0
3`3oool00200oooo00<000000?ooo`3oool0=03oool4003jVP80003oo`3ooolb0?ooo`030000003o
ool0oooo00l0oooo000P0?ooo`030000003oool0oooo03D0oooo1000nYX00`000?l0oooo0?ooo`3o
0?oooc00oooo00<000000?ooo`3oool03`3oool00200oooo0`00000e0?ooo`D00?ZJ00<0003o0?oo
o`3oool0o`3oool^0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0=P3oool4003jVP80
003oo`3oool`0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03L0oooo
1000nYX20000ool0oooo;`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?oo
o`0g0?ooo`D00?ZJ00<0003o0?ooo`3oool0o`3oool]0?ooo`030000003oool0oooo00l0oooo000P
0?ooo`030000003oool0oooo03P0oooo1@00nYX00`000?l0oooo0?ooo`3o0?ooob`0oooo00<00000
0?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0>@3oool4003jVP80003oo`3oool]0?oo
o`030000003oool0oooo00l0oooo000P0?ooo`<00000>P3oool4003jVP<0003oo`3ooolZ0?ooo`80
00004@3oool00200oooo00<000000?ooo`3oool0>P3oool5003jVP@0003oo`3ooolY0?ooo`030000
003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03/0oooo1P00nYX30000ool0oooo:03o
ool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0l0?ooo`H00?ZJ10000?oo
0?ooobH0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0?@3oool7003j
VP@0003oo`3ooolT0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03l0
oooo1P00nYX50000ool0oooo8P3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo
0?ooo`100?ooo`L00?ZJ10000?oo0?ooob40oooo00<000000?ooo`3oool03`3oool00200oooo0`00
00120?ooo`L00?ZJ10000?oo0?oooah0oooo0P00000A0?ooo`00803oool00`000000oooo0?ooo`13
0?ooo`L00?ZJ10000?oo0?oooah0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?oo
o`3oool0A@3oool7003jVP80003oo`3ooolN0?ooo`030000003oool0oooo00l0oooo000P0?ooo`03
0000003oool0oooo04L0oooo1P00nYX20000ool0oooo7@3oool00`000000oooo0?ooo`0?0?ooo`00
4@3oool3000000@0oooo0P0000060?ooo`030000003oool0oooo04P0oooo1P00nYX00`000?l0oooo
0?ooo`3o0?oooa/0oooo00<000000?ooo`3oool03`3oool00180oooo00<000000?ooo`3oool00P3o
ool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo04X0oooo1000nYX20000ool0oooo
703oool00`000000oooo0?ooo`0?0?ooo`004P3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo000000D0oooo1000001:0?ooo`@00?ZJ00<0003o0?ooo`3oool0o`3ooolH0?ooo`<00000
4@3oool00180oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000050?ooo`030000
003oool0oooo04/0oooo1000nYX20000ool0oooo6`3oool00`000000oooo0?ooo`0?0?ooo`004P3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0
C03oool4003jVP030000o`3oool0oooo0?l0oooo6@3oool00`000000oooo0?ooo`0?0?ooo`004@3o
ool2000000@0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`1<0?ooo`@00?ZJ
0P000?oo0?oooaX0oooo00<000000?ooo`3oool03`3oool00180oooo00<000000?ooo`3oool00`3o
ool2000000H0oooo00<000000?ooo`3oool0C@3oool4003jVP030000o`3oool0oooo0?l0oooo603o
ool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`1=0?ooo`@00?ZJ0P000?oo
0?oooaT0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0CP3oool4003j
VP030000o`3oool0oooo0?l0oooo5`3oool00`000000oooo0?ooo`0?0?ooo`00803oool3000004h0
oooo1000nYX20000ool0oooo5`3oool200000140oooo000P0?ooo`030000003oool0oooo04l0oooo
0`00nYX20000ool0oooo603oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?oo
o`1?0?ooo`@00?ZJ0P000?oo0?oooaL0oooo00<000000?ooo`3oool03`3oool00200oooo00<00000
0?ooo`3oool0C`3oool4003jVP80003oo`3ooolG0?ooo`030000003oool0oooo00l0oooo000P0?oo
o`030000003oool0oooo0500oooo1000nYX00`000?l0oooo0?ooo`3o0?oooaD0oooo00<000000?oo
o`3oool03`3oool00200oooo00<000000?ooo`3oool0D03oool4003jVP80003oo`3ooolF0?ooo`03
0000003oool0oooo00l0oooo000P0?ooo`<00000D@3oool4003jVP030000o`3oool0oooo0?l0oooo
4`3oool200000140oooo000P0?ooo`030000003oool0oooo0540oooo1000nYX20000ool0oooo5@3o
ool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`1B0?ooo`@00?ZJ00<0003o
0?ooo`3oool0o`3ooolC0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo
0580oooo1000nYX20000ool0oooo503oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000
oooo0?ooo`1C0?ooo`@00?ZJ00<0003o0?ooo`3oool0o`3ooolB0?ooo`030000003oool0oooo00l0
oooo000P0?ooo`030000003oool0oooo05<0oooo1000nYX20000ool0oooo4`3oool00`000000oooo
0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`1D0?ooo`@00?ZJ00<0003o0?ooo`3oool0o`3o
oolA0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000E03oool4003jVP80003oo`3ooolA
0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0E@3oool4003jVP030000o`3oool0oooo
0?l0oooo403oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`1E0?ooo`@0
0?ZJ0P000?oo0?oooa40oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0
EP3oool3003jVP80003oo`3ooolA0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003o
ool0oooo05H0oooo1000nYX20000ool0oooo403oool00`000000oooo0?ooo`0?0?ooo`00803oool0
0`000000oooo0?ooo`1F0?ooo`@00?ZJ0P000?oo0?oooa00oooo00<000000?ooo`3oool03`3oool0
0200oooo0`00001G0?ooo`@00?ZJ0P000?oo0?ooo`h0oooo0P00000A0?ooo`00803oool00`000000
oooo0?ooo`1G0?ooo`@00?ZJ0`000?oo0?ooo`h0oooo00<000000?ooo`3oool03`3oool00200oooo
00<000000?ooo`3oool0F03oool4003jVP<0003oo`3oool=0?ooo`030000003oool0oooo00l0oooo
000P0?ooo`030000003oool0oooo05P0oooo1000nYX40000ool0oooo303oool00`000000oooo0?oo
o`0?0?ooo`004@3oool3000000<0oooo0`0000060?ooo`030000003oool0oooo05T0oooo1000nYX4
0000ool0oooo2`3oool00`000000oooo0?ooo`0?0?ooo`004P3oool01@000000oooo0?ooo`3oool0
000000<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1I0?ooo`D00?ZJ10000?oo
0?ooo`X0oooo00<000000?ooo`3oool03`3oool00180oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo05X0oooo1@00nYX40000ool0oooo2@3oool00`00
0000oooo0?ooo`0?0?ooo`004P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00<0
oooo1000001J0?ooo`D00?ZJ0`000?oo0?ooo`L0oooo0`00000A0?ooo`004P3oool010000000oooo
0?ooo`3oool4000000H0oooo00<000000?ooo`3oool0G03oool5003jVP<0003oo`3oool80?ooo`03
0000003oool0oooo00l0oooo000A0?ooo`8000000`3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo05d0oooo1000nYX40000ool0oooo1`3oool00`000000oooo0?ooo`0?0?ooo`004P3o
ool010000000oooo0?ooo`3oool5000000D0oooo00<000000?ooo`3oool0GP3oool4003jVP@0003o
o`3oool60?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo05h0oooo1@00
nYX40000ool0oooo1@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`1O
0?ooo`D00?ZJ10000?oo0?ooo`@0oooo00<000000?ooo`3oool03`3oool00200oooo0`00001P0?oo
o`D00?ZJ10000?oo0?ooo`80oooo0P00000A0?ooo`00803oool00`000000oooo0?ooo`1Q0?ooo`@0
0?ZJ6P000?o/0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0680oooo
1000nYX_0000omH0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0HP3o
ool5003jVS40003od`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`1S
0?ooo`D00?ZJ5@3ooolO0000oll0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?oo
o`3oool0I03oool5003jVRX0oooo30000?o<0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<0
0000I@3ooolJ003jVQL0oooo30000?o80?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0
IP3oool^003jVPH0oooo2@000?o80?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003o
ool0oooo06L0oooo<000nYX60?ooo`P0003oaP3oool00`000000oooo0?ooo`0?0?ooo`00803oool0
0`000000oooo0?ooo`1m0?oooa`00?ZJ1`3oool60000olD0oooo00<000000?ooo`3oool03`3oool0
0200oooo00<000000?ooo`3oool0TP3oool9003jVPH0oooo1`000?o30?ooo`030000003oool0oooo
00l0oooo000P0?ooo`030000003oool0oooo09D0oooo2@00nYX50?ooo`L0003o`@3oool00`000000
oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`2G0?ooo`T00?ZJ103oool70000ol00oooo
00<000000?ooo`3oool03`3oool00200oooo0`00002I0?ooo`T00?ZJ103oool70000okd0oooo0P00
000A0?ooo`00803oool00`000000oooo0?ooo`2L0?ooo`L00?ZJ1@3oool60000okd0oooo00<00000
0?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0WP3oool7003jVP@0oooo1`000?nk0?oo
o`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0:00oooo1P00nYX50?ooo`P0
003o^03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`2Q0?ooo`L00?ZJ
103oool90000okH0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0X`3o
ool7003jVP@0oooo2@000?nd0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000Y03oool7
003jVPH0oooo2@000?n`0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0YP3oool7003j
VPH0oooo2@000?n_0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0:P0
oooo1P00nYX70?ooo`l0003oY`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo
0?ooo`2Y0?ooo`L00?ZJ203ooolE0000oih0oooo00<000000?ooo`3oool03`3oool00100oooo1@00
00030?ooo`8000001P3oool00`000000oooo0?ooo`2[0?ooo`L00?ZJ203ooolH0000oiT0oooo00<0
00000?ooo`3oool03`3oool00140oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000050?ooo`030000003oool0oooo0:`0oooo2000nYX>0?oooaD0003oU03oool00`000000oooo
0?ooo`0?0?ooo`004P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000D0oooo
00<000000?ooo`3oool0[P3oool8003jVQD0oooo3`000?nA0?ooo`030000003oool0oooo00l0oooo
000C0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`030?ooo`@00000
[`3oool8003jVQP0oooo3@000?n<0?ooo`<000004@3oool00100oooo00D000000?ooo`3oool0oooo
000000020?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0/P3oool8003jVQ/0
oooo2`000?n;0?ooo`030000003oool0oooo00l0oooo000@0?ooo`050000003oool0oooo0?ooo`00
00000P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo0;@0oooo2000nYXL0?oo
o`/0003oR03oool00`000000oooo0?ooo`0?0?ooo`004@3oool3000000@0oooo0P0000060?ooo`03
0000003oool0oooo0;H0oooo3P00nYXG0?ooo`/0003oQ@3oool00`000000oooo0?ooo`0?0?ooo`00
803oool00`000000oooo0?ooo`2h0?oooaD00?ZJ4@3oool:0000oh<0oooo00<000000?ooo`3oool0
3`3oool00200oooo00<000000?ooo`3oool0^P3ooolF003jVQ40oooo20000?n20?ooo`030000003o
ool0oooo00l0oooo000P0?ooo`<00000`P3ooolB003jVQ00oooo1`000?mo0?ooo`8000004@3oool0
0200oooo00<000000?ooo`3oool0b`3oool<003jVPl0oooo1P000?mo0?ooo`030000003oool0oooo
00l0oooo000P0?ooo`030000003oool0oooo0<h0oooo3000nYX=0?ooo`L0003oO@3oool00`000000
oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3B0?ooo`/00?ZJ303oool70000og/0oooo
00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0e@3oool;003jVPX0oooo1`00
0?mj0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0=P0oooo2`00nYX9
0?ooo`L0003oN03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3K0?oo
o`/00?ZJ203oool60000ogL0oooo00<000000?ooo`3oool03`3oool00200oooo0`00003N0?ooo`X0
0?ZJ1`3oool=0000ofh0oooo0P00000A0?ooo`00803oool00`000000oooo0?ooo`3Q0?ooo`P00?ZJ
203oool_0000od/0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0i03o
ool7003jVPL0oooo;`000?m:0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0
oooo0>H0oooo1P00nYX>0?ooobP0003oB@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`00
0000oooo0?ooo`3W0?ooo`H00?ZJ<@3oool50000odP0oooo00<000000?ooo`3oool03`3oool00200
oooo00<000000?ooo`3oool0j@3oool6003jVS00oooo1@000?m70?ooo`030000003oool0oooo00l0
oooo000P0?ooo`<00000jP3oool6003jVS00oooo1@000?m50?ooo`8000004@3oool00200oooo00<0
00000?ooo`3oool0j`3oool7003jVRl0oooo1P000?m40?ooo`030000003oool0oooo00l0oooo000P
0?ooo`030000003oool0oooo0>d0oooo1P00nYX_0?ooo`H0003o@`3oool00`000000oooo0?ooo`0?
0?ooo`00803oool00`000000oooo0?ooo`3^0?ooo`H00?ZJ;`3oool60000od80oooo00<000000?oo
o`3oool03`3oool00200oooo00<000000?ooo`3oool0l03oool<003jVRT0oooo1@000?m10?ooo`03
0000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0?40oooo;P00nYX70?ooo`D0003o
@03oool00`000000oooo0?ooo`0?0?ooo`00803oool300000?80oooo;P00nYX70?ooo`D0003o?P3o
ool200000140oooo000P0?ooo`030000003oool0oooo0?X0oooo9`00nYX70?ooo`D0003o?P3oool0
0`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?oooah0oooo1@00nYX70?oo
o`@0003o?P3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?oooal0
oooo1@00nYX70?ooo`@0003o?@3oool00`000000oooo0?ooo`0?0?ooo`00403oool500000080oooo
0`0000060?ooo`030000003oool0oooo0?l0oooo803oool5003jVPH0oooo10000?lm0?ooo`030000
003oool0oooo00l0oooo000A0?ooo`060000003oool0oooo0000003oool000000`3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo0?l0oooo8@3oool5003jVPH0oooo0`000?lm0?ooo`03
0000003oool0oooo00l0oooo000B0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`3o0?ooob80oooo1@00nYX50?ooo`@0003o?03oool00`000000oooo
0?ooo`0?0?ooo`004`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo1000
003o0?ooob80oooo1@00nYX40?ooo`@0003o>P3oool300000140oooo000@0?ooo`060000003oool0
oooo0?ooo`000000oooo100000060?ooo`030000003oool0oooo0?l0oooo903oool5003jVP@0oooo
10000?lk0?ooo`030000003oool0oooo00l0oooo000@0?ooo`070000003oool0oooo0?ooo`000000
oooo000000090?ooo`030000003oool0oooo0?l0oooo9@3oool5003jVP<0oooo10000?lk0?ooo`03
0000003oool0oooo00l0oooo000A0?ooo`<000000P3oool5000000D0oooo00<000000?ooo`3oool0
o`3ooolV0?ooo`D00?ZJ0`3oool40000ocX0oooo00<000000?ooo`3oool03`3oool00200oooo00<0
00000?ooo`3oool0o`3ooolW0?ooo`D00?ZJ0P3oool40000ocX0oooo00<000000?ooo`3oool03`3o
ool00200oooo00<000000?ooo`3oool0o`3ooolX0?ooo`D00?ZJ0P3oool30000ocX0oooo00<00000
0?ooo`3oool03`3oool00200oooo0`00003o0?ooobT0oooo1@00nYX00`3oool0003o0000o`020000
ocP0oooo0P00000A0?ooo`00803oool00`000000oooo0?ooo`3o0?ooobX0oooo1000nYX00`3oool0
003o0000o`020000ocT0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0
o`3oool[0?ooo`@00?ZJ00<0oooo0000o`000?l00P000?lh0?ooo`030000003oool0oooo00l0oooo
000P0?ooo`030000003oool0oooo0?l0oooo:`3oool4003jVP030?ooo`000?l0003o0080003o>03o
ool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?ooob`0oooo0`00nYX2
0?ooo`<0003o>03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?oo
ob`0oooo1000nYX00`3oool0003o0000o`020000ocL0oooo00<000000?ooo`3oool03`3oool00200
oooo00<000000?ooo`3oool0o`3oool/0?ooo`@00?ZJ00<0oooo0000o`000?l00P000?lg0?ooo`03
0000003oool0oooo00l0oooo000P0?ooo`<00000o`3oool]0?ooo`<00?ZJ0P3oool40000ocD0oooo
0P00000A0?ooo`00803oool00`000000oooo0?ooo`3o0?ooobd0oooo1000nYX00`3oool0003o0000
o`020000ocH0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0o`3oool]
0?ooo`@00?ZJ0P3oool30000ocH0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?oo
o`3oool0o`3oool^0?ooo`<00?ZJ0P3oool40000ocD0oooo00<000000?ooo`3oool03`3oool00200
oooo00<000000?ooo`3oool0o`3oool^0?ooo`@00?ZJ00<0oooo0000o`000?l00P000?le0?ooo`03
0000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0?l0oooo;P3oool4003jVP80oooo
10000?ld0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000o`3oool_0?ooo`<00?ZJ0P3o
ool40000oc<0oooo0P00000A0?ooo`00803oool00`000000oooo0?ooo`3o0?ooobl0oooo1000nYX2
0?ooo`@0003o<`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?oo
obl0oooo1000nYX20?ooo`@0003o<`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000
oooo0?ooo`3o0?oooc00oooo0`00nYX30?ooo`<0003o<`3oool00`000000oooo0?ooo`0?0?ooo`00
803oool00`000000oooo0?ooo`3o0?oooc00oooo1000nYX20?ooo`@0003o<P3oool00`000000oooo
0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?oooc00oooo1000nYX20?ooo`@0003o<P3o
ool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?oooc40oooo0`00nYX3
0?ooo`@0003o<@3oool00`000000oooo0?ooo`0?0?ooo`00803oool300000?l0oooo<@3oool4003j
VP80oooo10000?l`0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0o`3ooola0?ooo`@0
0?ZJ0`3oool30000oc40oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0
o`3ooolb0?ooo`<00?ZJ0`3oool;0000obT0oooo00<000000?ooo`3oool03`3oool00200oooo00<0
00000?ooo`3oool0o`3ooolb0?ooo`@00?ZJ0P3ooolC0000ob40oooo00<000000?ooo`3oool03`3o
ool00140oooo0`0000040?ooo`8000001P3oool00`000000oooo0?ooo`3o0?oooc80oooo1000nYX3
0?oooaL0003o703oool00`000000oooo0?ooo`0?0?ooo`00403oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`3o0?oooc<0oooo0`00
nYX;0?oooa@0003o5`3oool00`000000oooo0?ooo`0?0?ooo`00503oool010000000oooo0?ooo`00
00020?ooo`030000003oool0oooo00<0oooo1000003o0?oooc80oooo1000nYXB0?ooo`h0003o4`3o
ool300000140oooo000B0?ooo`8000000`3oool010000000oooo0?ooo`0000050?ooo`030000003o
ool0oooo0?l0oooo<`3oool4003jVQL0oooo2@000?lE0?ooo`030000003oool0oooo00l0oooo000D
0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`3o0?oooc@0oooo0`00nYXL0?ooo`D0003o503oool00`000000oooo0?ooo`0?0?ooo`00403oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000001@3oool00`000000oooo
0?ooo`3o0?oooc@0oooo1000nYXL0?ooo`D0003o4`3oool00`000000oooo0?ooo`0?0?ooo`004@3o
ool3000000@0oooo0P0000060?ooo`030000003oool0oooo0?l0oooo=03oool4003jVQd0oooo1@00
0?lB0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0?l0oooo=@3oool3
003jVQh0oooo1@000?lA0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo
0?l0oooo=@3oool4003jVQh0oooo10000?lA0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<0
0000o`3ooole0?ooo`@00?ZJ7`3oool40000o`l0oooo0P00000A0?ooo`00803oool00`000000oooo
0?ooo`3o0?ooocH0oooo0`00nYXO0?ooo`D0003o3`3oool00`000000oooo0?ooo`0?0?ooo`00803o
ool00`000000oooo0?ooo`3o0?ooocH0oooo1000nYXO0?ooo`D0003o3P3oool00`000000oooo0?oo
o`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?ooocH0oooo1000nYXP0?ooo`@0003o3P3oool0
0`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?ooocL0oooo0`00nYXQ0?oo
o`@0003o3@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?ooocL0
oooo1000nYXP0?ooo`D0003o303oool00`000000oooo0?ooo`0?0?ooo`00803oool300000?l0oooo
=`3oool4003jVR40oooo1@000?l:0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0o`3o
oolh0?ooo`<00?ZJ8P3oool50000o`X0oooo00<000000?ooo`3oool03`3oool00200oooo00<00000
0?ooo`3oool0o`3ooolh0?oooa800?ZJ503oool40000o`X0oooo00<000000?ooo`3oool03`3oool0
0200oooo00<000000?ooo`3oool0o`3ooolh0?oooaD00?ZJ4P3oool40000o`T0oooo00<000000?oo
o`3oool03`3oool00200oooo00<000000?ooo`3oool0o`3oooli0?oooaL00?ZJ3`3oool50000o`P0
oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0o`3ooom80?ooo`/00?ZJ
3@3oool50000o`L0oooo00<000000?ooo`3oool03`3oool00200oooo0`00003o0?oood/0oooo2`00
nYX;0?ooo`@0003o1P3oool200000140oooo000P0?ooo`030000003oool0oooo0?l0ooooCP3oool9
003jVP/0oooo0`000?l70?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo
0?l0ooooD@3oool6003jVQD0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3o
ool0o`3ooomD0?ooo`@00?ZJ503oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo
0?ooo`3o0?oooe@0oooo1@00nYXC0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003o
ool0oooo0?l0ooooE@3oool4003jVQ<0oooo00<000000?ooo`3oool03`3oool00200oooo00<00000
0?ooo`3oool0o`3ooomF0?ooo`@00?ZJ4P3oool00`000000oooo0?ooo`0?0?ooo`00803oool30000
0?l0ooooEP3oool5003jVQ00oooo0P00000A0?ooo`00803oool00`000000oooo0?ooo`3o0?oooeL0
oooo1000nYXA0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0?l0oooo
F03oool4003jVQ00oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0o`3o
oomH0?ooo`D00?ZJ3`3oool00`000000oooo0?ooo`0?0?ooo`004@3oool3000000<0oooo0`000006
0?ooo`030000003oool0oooo0?l0ooooF@3oool4003jVPl0oooo00<000000?ooo`3oool03`3oool0
0100oooo00L000000?ooo`3oool0oooo0000003oool0000000<0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`3o0?oooeX0oooo1000nYX>0?ooo`030000003oool0oooo00l0oooo000D
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool400000?l0ooooF@3oool5
003jVP/0oooo0`00000A0?ooo`004P3oool2000000H0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`3o0?oooe/0oooo1000nYX=0?ooo`030000003oool0oooo00l0oooo000D0?ooo`03
0000003oool0000000<000001P3oool00`000000oooo0?ooo`3o0?oooe`0oooo1000nYX<0?ooo`03
0000003oool0oooo00l0oooo000@0?ooo`070000003oool0oooo0?ooo`000000oooo000000090?oo
o`030000003oool0oooo0?l0ooooG03oool5003jVP/0oooo00<000000?ooo`3oool03`3oool00140
oooo0`0000020?ooo`D000001@3oool00`000000oooo0?ooo`3o0?oooed0oooo1000nYX;0?ooo`03
0000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0?l0ooooGP3oool4003jVPX0oooo
00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0o`3ooomN0?ooo`D00?ZJ2@3o
ool00`000000oooo0?ooo`0?0?ooo`00803oool300000?l0ooooG`3oool4003jVPP0oooo0P00000A
0?ooo`00803oool00`000000oooo0?ooo`3o0?ooof00oooo1000nYX80?ooo`030000003oool0oooo
00l0oooo000P0?ooo`030000003oool0oooo0?l0ooooH03oool5003jVPL0oooo00<000000?ooo`3o
ool03`3oool00200oooo00<000000?ooo`3oool0o`3ooomQ0?ooo`@00?ZJ1`3oool00`000000oooo
0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?ooof80oooo0`00nYX70?ooo`030000003o
ool0oooo00l0oooo000P0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`0?
0?ooo`00803oool3000000H0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`120?oo
o`030000003oool0oooo04<0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`120?oo
o`030000003oool0oooo00D0oooo0P00000A0?ooo`00803oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0:0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0?0?ooo`00
803ooooo0000070000004@3oool00?l0ooooX@3oool00?l0ooooX@3oool00?l0ooooX@3oool00?l0
ooooX@3oool00?l0ooooX@3oool00>@0oooo00<0<c<c0?ooo`3oool0603oool00`0c<c<0oooo0?oo
o`120?ooo`0303<c<`3oool0oooo00<0<c<c6`3oool00`0c<c<0oooo0?ooo`0h0?ooo`00h`3oool0
0`0c<c<0oooo0?ooo`0J0?ooo`0303<c<`3oool0oooo0400oooo00<0<c<c0?ooo`3oool0103oool0
0`0c<c<0oooo0?ooo`0I0?ooo`0303<c<`3oool0oooo03L0oooo00140?ooo`<0<c<c103oool303<c
<`80oooo0`0c<c<50?ooo`80<c<c0P3oool01@0c<c<0oooo03<c<`3oool0<c<c0080oooo100c<c<0
1@3oool0<c<c03<c<`0c<c<0oooo0080<c<c0P3oool203<c<`<0oooo0`0c<c<30?ooo`@0<c<c0`3o
ool203<c<`030?ooo`0c<c<0oooo00H0oooo0`0c<c<40?ooo`80<c<c0`3oool403<c<`<0oooo0P0c
<c<20?ooo`D0<c<c00<0oooo03<c<`0c<c<00P0c<c<40?ooo`80<c<c0P3oool503<c<`040?ooo`0c
<c<0<c<c0?ooo`80<c<c0P3oool303<c<`80oooo0`0c<c<00`3oool0<c<c03<c<`060?ooo`<0<c<c
2`3oool0100c<c<0oooo0?ooo`3oool403<c<`80oooo1@0c<c<20?ooo`@0<c<c0`3oool203<c<`03
0?ooo`0c<c<0oooo0080oooo00<0<c<c0?ooo`3oool0203oool203<c<`030?ooo`0c<c<0<c<c0080
<c<c00@0oooo03<c<`0c<c<0oooo100c<c<70?ooo`<0<c<c0`3oool01@0c<c<0oooo03<c<`3oool0
<c<c0080oooo0`0c<c<30?ooo`@0<c<c2@3oool00`0c<c<0oooo0?ooo`020?ooo`@0<c<c00@0oooo
03<c<`0c<c<0<c<c1@3oool203<c<`030?ooo`0c<c<0oooo00<0<c<c0P3oool303<c<`030?ooo`0c
<c<0<c<c00<0oooo00<0<c<c0?ooo`3oool0=P3oool004D0oooo00<0<c<c0?ooo`3oool00P3oool0
1@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00<0<c<c0?ooo`3oool00`3oool0300c<c<0oooo0?oo
o`0c<c<0oooo03<c<`3oool0<c<c0?ooo`0c<c<0oooo03<c<`80oooo00D0<c<c0?ooo`3oool0oooo
03<c<`020?ooo`0403<c<`3oool0oooo03<c<`80oooo00<0<c<c0?ooo`0c<c<01@3oool0100c<c<0
oooo0?ooo`0c<c<30?ooo`0403<c<`3oool0oooo03<c<`P0oooo00@0<c<c0?ooo`3oool0<c<c0P3o
ool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`80oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?oo
o`0503<c<`3oool0oooo0?ooo`0c<c<01`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0503<c<`3o
ool0oooo0?ooo`0c<c<0103oool00`0c<c<0oooo03<c<`020?ooo`0303<c<`3oool0oooo00@0oooo
00@0<c<c0?ooo`3oool0<c<c203oool00`0c<c<0oooo0?ooo`0:0?ooo`0303<c<`3oool0oooo0080
oooo00@0<c<c0?ooo`3oool0<c<c0`3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00D0<c<c
0?ooo`3oool0oooo03<c<`020?ooo`0303<c<`3oool0oooo0080oooo00<0<c<c0?ooo`3oool01`3o
ool0100c<c<0oooo0?ooo`0c<c<20?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c0P3oool00`0c
<c<0oooo0?ooo`070?ooo`0303<c<`3oool0oooo0080oooo00L0<c<c0?ooo`0c<c<0oooo03<c<`3o
ool0<c<c00<0oooo00<0<c<c0?ooo`0c<c<00P3oool00`0c<c<0oooo0?ooo`080?ooo`0503<c<`3o
ool0oooo0?ooo`0c<c<00`3oool0100c<c<0oooo0?ooo`0c<c<50?ooo`0603<c<`3oool0oooo03<c
<`3oool0<c<c1P3oool0100c<c<0oooo0?ooo`0c<c<40?ooo`0303<c<`3oool0oooo03H0oooo0015
0?ooo`0303<c<`3oool0oooo0080oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`0303<c<`3o
ool0oooo00<0oooo00<0<c<c0?ooo`3oool00P3oool01@0c<c<0oooo03<c<`3oool0<c<c0080oooo
0`0c<c<30?ooo`0403<c<`3oool0oooo03<c<`80oooo00<0<c<c0?ooo`3oool00P3oool503<c<`80
oooo0`0c<c<30?ooo`0403<c<`3oool0oooo03<c<`80oooo100c<c<50?ooo`0403<c<`3oool0oooo
03<c<`D0oooo0`0c<c<30?ooo`0303<c<`3oool0oooo00@0oooo00<0<c<c0?ooo`3oool00P3oool3
03<c<`<0oooo00<0<c<c0?ooo`3oool0103oool00`0c<c<0oooo0?ooo`020?ooo`80<c<c0`3oool5
03<c<`80oooo00@0<c<c0?ooo`3oool0<c<c203oool00`0c<c<0oooo0?ooo`0:0?ooo`0303<c<`3o
ool0oooo0080oooo00@0<c<c0?ooo`3oool0<c<c0`3oool00`0c<c<0oooo0?ooo`020?ooo`<0<c<c
0`3oool0100c<c<0oooo0?ooo`0c<c<40?ooo`0303<c<`3oool0oooo00L0oooo00@0<c<c0?ooo`3o
ool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`80oooo00<0<c<c0?ooo`3oool01`3o
ool00`0c<c<0oooo0?ooo`020?ooo`0703<c<`3oool0<c<c0?ooo`0c<c<0oooo03<c<`030?ooo`03
03<c<`3oool0<c<c0080oooo00<0<c<c0?ooo`3oool0203oool01@0c<c<0oooo0?ooo`3oool0<c<c
00<0oooo00@0<c<c0?ooo`3oool0<c<c1@3oool01@0c<c<0oooo0?ooo`0c<c<0oooo00D0<c<c0P3o
ool0100c<c<0oooo0?ooo`0c<c<40?ooo`0303<c<`3oool0oooo03H0oooo00150?ooo`<0<c<c0P3o
ool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo0P0c<c<40?ooo`0303<c<`3oool0oooo0080oooo
00L0<c<c0?ooo`0c<c<0oooo03<c<`3oool0<c<c0080oooo00D0<c<c0?ooo`3oool0oooo03<c<`02
0?ooo`0403<c<`3oool0oooo03<c<`@0oooo00L0<c<c0?ooo`3oool0oooo03<c<`3oool0<c<c0080
oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`0303<c<`3oool0oooo00L0oooo0P0c<c<30?oo
o`0303<c<`3oool0oooo0080oooo00@0<c<c0?ooo`3oool0<c<c0`3oool00`0c<c<0oooo0?ooo`04
0?ooo`0503<c<`3oool0oooo0?ooo`0c<c<01P3oool00`0c<c<0oooo0?ooo`040?ooo`0303<c<`3o
ool0oooo0080oooo00<0<c<c0?ooo`0c<c<00P3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo
00@0<c<c0?ooo`3oool0<c<c203oool303<c<`X0oooo00<0<c<c0?ooo`3oool00P3oool0100c<c<0
oooo0?ooo`0c<c<30?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00P3oool01@0c<c<0oooo0?ooo`3o
ool0<c<c0080oooo00<0<c<c0?ooo`3oool00P3oool00`0c<c<0oooo0?ooo`070?ooo`0403<c<`3o
ool0oooo03<c<`80oooo00H0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo
00L0oooo0`0c<c<20?ooo`0703<c<`3oool0<c<c0?ooo`0c<c<0oooo03<c<`030?ooo`0303<c<`3o
ool0<c<c0080oooo00<0<c<c0?ooo`3oool0203oool01@0c<c<0oooo0?ooo`3oool0<c<c00<0oooo
00<0<c<c0?ooo`3oool00P0c<c<40?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c0`3oool0100c
<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo0080oooo00<0<c<c0?ooo`3oool0=P3oool0
04D0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool303<c<`80oooo0P0c<c<0103oool0<c<c03<c<`3o
ool403<c<`80oooo0P0c<c<00`3oool0<c<c0?ooo`020?ooo`80<c<c0`3oool403<c<`80oooo100c
<c<30?ooo`<0<c<c0`3oool203<c<`<0oooo0P0c<c<00`3oool0<c<c03<c<`080?ooo`0303<c<`3o
ool0oooo0080oooo100c<c<30?ooo`80<c<c0`3oool403<c<`80oooo0`0c<c<40?ooo`@0<c<c00<0
oooo03<c<`0c<c<00P0c<c<20?ooo`<0<c<c103oool0100c<c<0oooo03<c<`0c<c<20?ooo`<0<c<c
0P3oool403<c<`T0oooo00@0<c<c0?ooo`3oool0<c<c2P3oool0100c<c<0oooo0?ooo`3oool303<c
<`@0oooo00<0<c<c0?ooo`3oool00P3oool203<c<`<0oooo0P0c<c<00`3oool0<c<c03<c<`030?oo
o`0303<c<`3oool0oooo00L0oooo0P0c<c<0103oool0<c<c03<c<`3oool403<c<`<0oooo0`0c<c<9
0?ooo`0503<c<`3oool0oooo03<c<`3oool00P0c<c<00`3oool0<c<c0?ooo`020?ooo`<0<c<c0`3o
ool303<c<`/0oooo00@0<c<c0?ooo`3oool0oooo1`0c<c<0103oool0<c<c03<c<`3oool203<c<`03
0?ooo`0c<c<0<c<c0080oooo0`0c<c<20?ooo`@0<c<c103oool00`0c<c<0oooo0?ooo`0g0?ooo`00
A@3oool0100c<c<0oooo0?ooo`0c<c<>0?ooo`0303<c<`3oool0oooo01D0oooo00<0<c<c0?ooo`3o
ool06`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00T0oooo00<0<c<c0?oo
o`3oool03`3oool00`0c<c<0oooo0?ooo`090?ooo`0303<c<`3oool0oooo01D0oooo00@0<c<c0?oo
o`3oool0<c<c2`3oool0100c<c<0oooo0?ooo`0c<c<60?ooo`0303<c<`3oool0oooo00h0oooo00<0
<c<c0?ooo`3oool05`3oool00`0c<c<0oooo0?ooo`070?ooo`0403<c<`3oool0oooo03<c<a00oooo
00<0<c<c0?ooo`3oool02P3oool00`0c<c<0oooo0?ooo`0N0?ooo`0303<c<`3oool0oooo03P0oooo
00140?ooo`@0<c<c3`3oool00`0c<c<0oooo0?ooo`0E0?ooo`0303<c<`3oool0oooo01`0oooo0`0c
<c<20?ooo`0303<c<`3oool0oooo00T0oooo00<0<c<c0?ooo`3oool0103oool00`0c<c<0oooo0?oo
o`080?ooo`0303<c<`3oool0oooo00@0oooo00@0<c<c0?ooo`3oool0oooo0P0c<c<F0?ooo`@0<c<c
3P3oool203<c<`@0oooo0`0c<c<Y0?ooo`80<c<c203oool403<c<a00oooo0P0c<c=X0?ooo`00o`3o
oonQ0?ooo`00o`3ooonQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 415}, {256.125, 0}} -> {-2.98682, 0.0680262, \
0.0717904, 0.155288}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{26, 3}\),
      SequenceForm[ "Dimension der Daten  ", {26, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0380952 -0.0334521 1.68502 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0508 -24 -4.5 ]
[-0.0125 .0508 0 4.5 ]
[-0.0125 .13505 -18 -4.5 ]
[-0.0125 .13505 0 4.5 ]
[-0.0125 .2193 -24 -4.5 ]
[-0.0125 .2193 0 4.5 ]
[-0.0125 .30355 -18 -4.5 ]
[-0.0125 .30355 0 4.5 ]
[-0.0125 .3878 -24 -4.5 ]
[-0.0125 .3878 0 4.5 ]
[-0.0125 .47205 -18 -4.5 ]
[-0.0125 .47205 0 4.5 ]
[-0.0125 .55631 -24 -4.5 ]
[-0.0125 .55631 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -185 0 ]
[.5 .63053 185 12 ]
[.97619 .24672 -5 -6 ]
[.97619 .24672 5 6 ]
[.97619 .10809 -5 -6 ]
[.97619 .10809 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(5)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(10)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(15)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(20)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(25)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0508 m
.00625 .0508 L
s
[(0.05)] -0.0125 .0508 1 0 Mshowa
0 .13505 m
.00625 .13505 L
s
[(0.1)] -0.0125 .13505 1 0 Mshowa
0 .2193 m
.00625 .2193 L
s
[(0.15)] -0.0125 .2193 1 0 Mshowa
0 .30355 m
.00625 .30355 L
s
[(0.2)] -0.0125 .30355 1 0 Mshowa
0 .3878 m
.00625 .3878 L
s
[(0.25)] -0.0125 .3878 1 0 Mshowa
0 .47205 m
.00625 .47205 L
s
[(0.3)] -0.0125 .47205 1 0 Mshowa
0 .55631 m
.00625 .55631 L
s
[(0.35)] -0.0125 .55631 1 0 Mshowa
.125 Mabswid
0 .06765 m
.00375 .06765 L
s
0 .0845 m
.00375 .0845 L
s
0 .10135 m
.00375 .10135 L
s
0 .1182 m
.00375 .1182 L
s
0 .1519 m
.00375 .1519 L
s
0 .16875 m
.00375 .16875 L
s
0 .1856 m
.00375 .1856 L
s
0 .20245 m
.00375 .20245 L
s
0 .23615 m
.00375 .23615 L
s
0 .253 m
.00375 .253 L
s
0 .26985 m
.00375 .26985 L
s
0 .2867 m
.00375 .2867 L
s
0 .3204 m
.00375 .3204 L
s
0 .33725 m
.00375 .33725 L
s
0 .3541 m
.00375 .3541 L
s
0 .37095 m
.00375 .37095 L
s
0 .40465 m
.00375 .40465 L
s
0 .4215 m
.00375 .4215 L
s
0 .43835 m
.00375 .43835 L
s
0 .4552 m
.00375 .4552 L
s
0 .4889 m
.00375 .4889 L
s
0 .50575 m
.00375 .50575 L
s
0 .5226 m
.00375 .5226 L
s
0 .53945 m
.00375 .53945 L
s
0 .03395 m
.00375 .03395 L
s
0 .0171 m
.00375 .0171 L
s
0 .00025 m
.00375 .00025 L
s
0 .57316 m
.00375 .57316 L
s
0 .59001 m
.00375 .59001 L
s
0 .60686 m
.00375 .60686 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0508 m
1 .0508 L
s
.99375 .13505 m
1 .13505 L
s
.99375 .2193 m
1 .2193 L
s
.99375 .30355 m
1 .30355 L
s
.99375 .3878 m
1 .3878 L
s
.99375 .47205 m
1 .47205 L
s
.99375 .55631 m
1 .55631 L
s
.125 Mabswid
.99625 .06765 m
1 .06765 L
s
.99625 .0845 m
1 .0845 L
s
.99625 .10135 m
1 .10135 L
s
.99625 .1182 m
1 .1182 L
s
.99625 .1519 m
1 .1519 L
s
.99625 .16875 m
1 .16875 L
s
.99625 .1856 m
1 .1856 L
s
.99625 .20245 m
1 .20245 L
s
.99625 .23615 m
1 .23615 L
s
.99625 .253 m
1 .253 L
s
.99625 .26985 m
1 .26985 L
s
.99625 .2867 m
1 .2867 L
s
.99625 .3204 m
1 .3204 L
s
.99625 .33725 m
1 .33725 L
s
.99625 .3541 m
1 .3541 L
s
.99625 .37095 m
1 .37095 L
s
.99625 .40465 m
1 .40465 L
s
.99625 .4215 m
1 .4215 L
s
.99625 .43835 m
1 .43835 L
s
.99625 .4552 m
1 .4552 L
s
.99625 .4889 m
1 .4889 L
s
.99625 .50575 m
1 .50575 L
s
.99625 .5226 m
1 .5226 L
s
.99625 .53945 m
1 .53945 L
s
.99625 .03395 m
1 .03395 L
s
.99625 .0171 m
1 .0171 L
s
.99625 .00025 m
1 .00025 L
s
.99625 .57316 m
1 .57316 L
s
.99625 .59001 m
1 .59001 L
s
.99625 .60686 m
1 .60686 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -246 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(p) show
69.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(-) show
75.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(Werte) show
111.000 13.000 moveto
(der) show
135.000 13.000 moveto
(Portmanteau) show
201.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(-) show
207.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(Statistiken) show
279.000 13.000 moveto
(P) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
291.000 13.000 moveto
(H) show
297.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(blau) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
321.000 13.000 moveto
(L) show
333.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(und) show
357.000 13.000 moveto
(Pmod) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
387.000 13.000 moveto
(H) show
393.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(gruen) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
423.000 13.000 moveto
(L) show
429.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 1 r
gsave
.97619 .24672 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .10589 m
.0619 .29364 L
.1 .38769 L
.1381 .4163 L
.17619 .21713 L
.21429 .22942 L
.25238 .05789 L
.29048 .03158 L
.32857 .06989 L
.36667 .11631 L
.40476 .18064 L
.44286 .20939 L
.48095 .20479 L
.51905 .21483 L
.55714 .28062 L
.59524 .33056 L
.63333 .3662 L
.67143 .3419 L
.70952 .41656 L
.74762 .50618 L
.78571 .60332 L
.82381 .53333 L
.8619 .23892 L
.9 .29945 L
.9381 .3323 L
.97619 .24672 L
s
0 .98 .604 r
gsave
.97619 .10809 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .10011 m
.0619 .2811 L
.1 .36844 L
.1381 .39019 L
.17619 .18985 L
.21429 .1972 L
.25238 .03822 L
.29048 .01472 L
.32857 .04476 L
.36667 .08184 L
.40476 .13481 L
.44286 .15608 L
.48095 .14727 L
.51905 .15129 L
.55714 .20423 L
.59524 .24307 L
.63333 .26855 L
.67143 .23889 L
.70952 .29935 L
.74762 .37524 L
.78571 .46064 L
.82381 .3804 L
.8619 .11868 L
.9 .15899 L
.9381 .17816 L
.97619 .10809 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{416, 257.125},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006P00010B000`400?l00000o`00003oo`3ooonQ
0?ooo`00;@3oool2000004<0oooo0`00000o0?ooo`<00000103oool2000003d0oooo0`0000030?oo
o`<00000?03oool5000000<0oooo0P00000k0?ooo`D000000P3oool300000180oooo000/0?ooo`04
0000003oool0oooo00000440oooo00D000000?ooo`3oool0oooo0000000o0?ooo`030000003oool0
oooo0080oooo00@000000?ooo`3oool00000?@3oool01@000000oooo0?ooo`3oool0000000<0oooo
00<000000?ooo`3oool0>P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
03/0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003oool0oooo00l0oooo000/
0?ooo`040000003oool0oooo000004D0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?oo
o`020?ooo`040000003oool0oooo000003d0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0k0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000?03oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00l0oooo000/0?ooo`040000003oool0oooo000004D0
oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
03d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0l0?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool03`3oool002`0oooo00@000000?ooo`3oool00000@@3oool400000400oooo00<00000
0?ooo`3oool00P3oool010000000oooo0?ooo`00000m0?ooo`040000003oool0oooo0?ooo`@00000
?03oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000>P3oool01P00
0000oooo0?ooo`3oool000000?ooo`@000004P3oool002`0oooo00@000000?ooo`3oool00000@@3o
ool00`000000oooo0?ooo`100?ooo`800000103oool010000000oooo0?ooo`00000l0?ooo`800000
0`3oool00`000000oooo0?ooo`0m0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000
oooo0?ooo`00000j0?ooo`070000003oool0oooo0?ooo`000000oooo0000000E0?ooo`00;@3oool2
00000480oooo1@00000o0?ooo`030000003oool0oooo00<0oooo0P00000n0?ooo`040000003oool0
oooo0?ooo`D00000?03oool3000000@0oooo0P00000l0?ooo`<000000P3oool500000140oooo003o
0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo003o
0?oooj40oooo000U0?ooool00000L000000<0?ooo`009@3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0:0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0:0?ooo`00
9@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0
@P3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0
@P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003o
ool0oooo0?l0ooooK03oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`1V
0?ooo`D00?ZJo`3oool10?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo
06D0oooo1`00nY[o0?ooo`030000003oool0oooo00X0oooo000U0?ooo`<00000H`3oool:003jV_d0
oooo0P00000<0?ooo`009@3oool00`000000oooo0?ooo`1R0?ooo`H00?ZJ00<0oooo003jVP00nYX0
0`00nY[m0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo0600oooo1`00
nYX30?ooo`H00?ZJn`3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`1N
0?ooo`L00?ZJ1P3oool6003jV_X0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?oo
o`3oool0G@3oool7003jVP80oooo10000?l20?ooo`H00?ZJn@3oool00`000000oooo0?ooo`0:0?oo
o`009@3oool00`000000oooo0?ooo`1K0?ooo`L00?ZJ0`3oool60000o`<0oooo1P00nY[g0?ooo`03
0000003oool0oooo00X0oooo000U0?ooo`<00000FP3oool6003jVP<0oooo2@000?l30?ooo`H00?ZJ
m@3oool2000000`0oooo000U0?ooo`030000003oool0oooo05T0oooo1P00nYX30?ooo`/0003o0`3o
ool6003jV_D0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0F@3oool4
003jVP@0oooo1P000?l20?ooo`D0003o103oool5003jV_@0oooo00<000000?ooo`3oool02P3oool0
02D0oooo00<000000?ooo`3oool0F@3oool3003jVP<0oooo1P000?l50?ooo`D0003o103oool5003j
V_<0oooo00<000000?ooo`3oool02P3oool000/0oooo0P0000040?ooo`030000003oool0oooo00<0
oooo0P0000030?ooo`<000001P3oool00`000000oooo0?ooo`1H0?ooo`@00?ZJ0P3oool60000o`L0
oooo1@000?l40?ooo`@00?ZJl`3oool00`000000oooo0?ooo`0:0?ooo`002P3oool010000000oooo
0?ooo`0000080?ooo`060000003oool0oooo0000003oool000000`3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo05P0oooo1000nYX70000o`T0oooo1@000?l40?ooo`@00?ZJlP3oool0
0`000000oooo0?ooo`0:0?ooo`002P3oool010000000oooo0?ooo`0000080?ooo`040000003oool0
oooo000000D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1H0?ooo`<00?ZJ1P00
0?l<0?ooo`D0003o0`3oool5003jV_40oooo00<000000?ooo`3oool02P3oool000X0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo00<0oooo
1000001G0?ooo`<00?ZJ1@000?l>0?ooo`D0003o0`3oool5003jV^h0oooo0`00000<0?ooo`002P3o
ool010000000oooo0?ooo`0000080?ooo`050000003oool0oooo0000003oool0100000060?ooo`03
0000003oool0oooo05L0oooo1000nYX30000oa40oooo1@000?l30?ooo`D00?ZJk`3oool00`000000
oooo0?ooo`0:0?ooo`002P3oool010000000oooo0?ooo`0000080?ooo`060000003oool0oooo0000
003oool000002@3oool00`000000oooo0?ooo`1G0?ooo`@00?ZJ0P000?lC0?ooo`D0003o0`3oool5
003jV^h0oooo00<000000?ooo`3oool02P3oool000/0oooo0P00000:0?ooo`8000000P3oool50000
00D0oooo00<000000?ooo`3oool0E`3oool3003jVP80003o5@3oool50000o`<0oooo1@00nY[]0?oo
o`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo05L0oooo0`00nYX20000oaH0
oooo1@000?l30?ooo`D00?ZJk03oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo
0?ooo`1F0?ooo`@00?ZJ0P000?lG0?ooo`D0003o0`3oool5003jV^/0oooo00<000000?ooo`3oool0
2P3oool002D0oooo0`00001F0?ooo`@00?ZJ00<0003o0?ooo`3oool05`3oool40000o`@0oooo1@00
nY[Y0?ooo`800000303oool002D0oooo00<000000?ooo`3oool0EP3oool3003jVP80003o6P3oool4
0000o`@0oooo1@00nY[Y0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo
05H0oooo0`00nYX20000oaX0oooo1@000?l40?ooo`D00?ZJj03oool00`000000oooo0?ooo`0:0?oo
o`009@3oool00`000000oooo0?ooo`1E0?ooo`@00?ZJ0P000?lK0?ooo`D0003o103oool5003jV^L0
oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0E@3oool4003jVP80003o
703oool40000o`D0oooo1@00nY[V0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003o
ool0oooo05D0oooo0`00nYX20000oah0oooo10000?l50?ooo`@00?ZJiP3oool00`000000oooo0?oo
o`0:0?ooo`009@3oool3000005D0oooo0`00nYX20000oah0oooo1@000?l50?ooo`@00?ZJi03oool2
000000`0oooo000U0?ooo`030000003oool0oooo05D0oooo0`00nYX20000oal0oooo1@000?l40?oo
o`D00?ZJi03oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`1D0?ooo`@0
0?ZJ0P000?lP0?ooo`D0003o103oool5003jV^<0oooo00<000000?ooo`3oool02P3oool002D0oooo
00<000000?ooo`3oool0E03oool4003jVP030000o`3oool0oooo0200oooo10000?l50?ooo`@00?ZJ
h`3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`1D0?ooo`<00?ZJ0P00
0?lS0?ooo`@0003o1@3oool4003jV^80oooo00<000000?ooo`3oool02P3oool002D0oooo00<00000
0?ooo`3oool01@3oool3003jVT`0oooo0`00nYX20000ob<0oooo1@000?l40?ooo`D00?ZJh@3oool0
0`000000oooo0?ooo`0:0?ooo`009@3oool3000000D0oooo0`00nYY;0?ooo`@00?ZJ0P000?lT0?oo
o`D0003o103oool5003jV]l0oooo0P00000<0?ooo`009@3oool00`000000oooo0?ooo`050?ooo`<0
0?ZJB`3oool4003jVP80003o9@3oool40000o`D0oooo1000nY[F0?ooo`<00?ZJ1`3oool00`000000
oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`050?ooo`@00?ZJBP3oool3003jVP80003o
9`3oool40000o`D0oooo1000nY[E0?ooo`<00?ZJ1`3oool00`000000oooo0?ooo`0:0?ooo`009@3o
ool00`000000oooo0?ooo`050?ooo`@00?ZJBP3oool3003jVP80003o9`3oool50000o`@0oooo1@00
nY[C0?ooo`@00?ZJ1`3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`05
0?ooo`040000o`00nYX00?ZJ003jVTT0oooo1000nYX20000obP0oooo1@000?l40?ooo`@00?ZJd`3o
ool4003jVPL0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool01@3oool0
10000?l00?ZJ003jVP00nYY90?ooo`@00?ZJ0P000?lY0?ooo`@0003o1@3oool4003jVZX0oooo0`00
nYXT0?ooo`@00?ZJ203oool00`000000oooo0?ooo`0:0?ooo`009@3oool3000000H0oooo0`00nYY9
0?ooo`<00?ZJ0P000?l[0?ooo`@0003o103oool5003jVZT0oooo0`00nYXT0?ooo`@00?ZJ1`3oool2
000000`0oooo000U0?ooo`030000003oool0oooo00H0oooo1000nYY80?ooo`<00?ZJ0P000?l[0?oo
o`@0003o1@3oool5003jVZP0oooo1000nYXR0?ooo`@00?ZJ2@3oool00`000000oooo0?ooo`0:0?oo
o`009@3oool00`000000oooo0?ooo`060?ooo`@00?ZJA`3oool4003jVP80003o;03oool40000o`D0
oooo1000nYZX0?ooo`D00?ZJ803oool5003jVPT0oooo00<000000?ooo`3oool02P3oool002D0oooo
00<000000?ooo`3oool01P3oool010000?l00?ZJ003jVP00nYY70?ooo`@00?ZJ0P000?l/0?ooo`D0
003o1@3oool4003jVZH0oooo1`00nYXO0?ooo`@00?ZJ2P3oool00`000000oooo0?ooo`0:0?ooo`00
4@3oool2000000@0oooo00<000000?ooo`3oool00P3oool3000000H0oooo00<000000?ooo`3oool0
1P3oool010000?l00?ZJ003jVP00nYY70?ooo`<00?ZJ0`000?l]0?ooo`@0003o1@3oool5003jVZD0
oooo2000nYXM0?ooo`@00?ZJ2`3oool00`000000oooo0?ooo`0:0?ooo`00403oool010000000oooo
0?ooo`0000090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01`3oool3003jVTL0
oooo0`00nYX20000obl0oooo10000?l50?ooo`H00?ZJX`3oool3003jVP030?ooo`00nYX00?ZJ00<0
0?ZJ703oool4003jVP/0oooo00<000000?ooo`3oool02P3oool00100oooo00@000000?ooo`3oool0
00002@3oool00`000000oooo0?ooo`050?ooo`@000001P3oool4003jVTD0oooo1000nYX20000obl0
oooo10000?l60?ooo`L00?ZJX@3oool3003jVP80oooo1@00nYXJ0?ooo`@00?ZJ2P3oool3000000`0
oooo000@0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`070?ooo`@00?ZJA@3oool4003jVP80003o<03oool40000o`H0oooo1`00nYZP0?ooo`<0
0?ZJ0`3oool5003jVQT0oooo1000nYX<0?ooo`030000003oool0oooo00X0oooo000@0?ooo`040000
003oool0oooo000000T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`070?ooo`04
0000o`00nYX00?ZJ003jVTD0oooo0`00nYX30000oc00oooo1@000?l70?ooo`L00?ZJWP3oool3003j
VP@0oooo1000nYXH0?ooo`@00?ZJ3@3oool00`000000oooo0?ooo`0:0?ooo`00403oool010000000
oooo0?ooo`0000080?ooo`8000001`3oool00`000000oooo0?ooo`070?ooo`040000o`00nYX00?ZJ
003jVTD0oooo0`00nYX20000oc80oooo10000?l90?ooo`L00?ZJW03oool3003jVPD0oooo1000nYXG
0?ooo`@00?ZJ3@3oool00`000000oooo0?ooo`0:0?ooo`004@3oool2000000X0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`080?ooo`@00?ZJ@`3oool4003jVP80003o<`3oool40000
o`T0oooo2000nYX=0?ooo``00?ZJP03oool4003jVPD0oooo1@00nYXE0?ooo`@00?ZJ3P3oool00`00
0000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`080?ooo`@00?ZJ@`3oool4003jVP80
003o<`3oool40000o`/0oooo1`00nYX70?oooaP00?ZJN@3oool4003jVPH0oooo1@00nYXD0?ooo`@0
0?ZJ3P3oool00`000000oooo0?ooo`0:0?ooo`009@3oool3000000P0oooo00@0003o003jVP00nYX0
0?ZJ@`3oool3003jVP<0003o=03oool40000o``0oooo9000nYYi0?ooo`<00?ZJ203oool5003jVQ80
oooo1000nYX>0?ooo`800000303oool002D0oooo00<000000?ooo`3oool0203oool010000?l00?ZJ
003jVP00nYY30?ooo`<00?ZJ0`000?ld0?ooo`@0003o3P3ooolA003jVPP0oooo2P00nYYh0?ooo`<0
0?ZJ2@3oool5003jVQ40oooo1000nYX?0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000
003oool0oooo00P0oooo00@0003o003jVP00nYX00?ZJ@P3oool4003jVP80003o=P3oool40000o`h0
oooo2`00nYXC0?ooo`D00?ZJM`3oool3003jVPX0oooo1P00nYX>0?ooo`@00?ZJ403oool00`000000
oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`090?ooo`@00?ZJ@@3oool4003jVP80003o
=P3oool50000o`l0oooo1000nYXI0?ooo`@00?ZJM`3oool3003jVP/0oooo1`00nYX;0?ooo`D00?ZJ
403oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`090?ooo`@00?ZJ@@3o
ool3003jVP<0003o=`3oool40000obd0oooo1000nYYf0?ooo`<00?ZJ303oool8003jVPT0oooo1000
nYXA0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo00T0oooo00@0003o
003jVP00nYX00?ZJ@@3oool3003jVP<0003o>03oool40000ob`0oooo1@00nYYd0?ooo`@00?ZJ3P3o
ool8003jVPH0oooo1000nYXB0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0
oooo00T0oooo00@0003o003jVP00nYX00?ZJ@@3oool3003jVP80003o>@3oool40000obd0oooo1@00
nYYc0?ooo`@00?ZJ403oool8003jVP@0oooo1000nYXB0?ooo`030000003oool0oooo00X0oooo000U
0?ooo`<000002@3oool010000?l00?ZJ003jVP00nYY00?ooo`@00?ZJ0P000?lj0?ooo`@0003o;@3o
ool4003jVW<0oooo0`00nYXC0?ooo`P00?ZJ00<0oooo003jVP00nYX00P00nYXB0?ooo`800000303o
ool002D0oooo00<000000?ooo`3oool02P3oool4003jVSl0oooo1000nYX20000ocX0oooo1@000?l]
0?ooo`@00?ZJLP3oool3003jVQD0oooo2`00nYXC0?ooo`030000003oool0oooo00X0oooo000U0?oo
o`030000003oool0oooo00X0oooo1000nYXo0?ooo`<00?ZJ0`000?lk0?ooo`@0003o;@3oool5003j
VW40oooo0`00nYXG0?ooo`P00?ZJ503oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000
oooo0?ooo`0:0?ooo`040000o`00nYX00?ZJ003jVSl0oooo0`00nYX30000oc`0oooo1@000?l/0?oo
o`@00?ZJL@3oool3003jVQT0oooo1P00nYXD0?ooo`030000003oool0oooo00X0oooo000U0?ooo`03
0000003oool0oooo00X0oooo00@0003o003jVP00nYX00?ZJ?P3oool4003jVP80003o?@3oool60000
ob`0oooo1000nYY`0?ooo`<00?ZJ6`3oool3003jVQD0oooo00<000000?ooo`3oool02P3oool002D0
oooo00<000000?ooo`3oool02P3oool010000?l00?ZJ003jVP00nYXn0?ooo`@00?ZJ0P000?ln0?oo
o`H0003o:`3oool5003jVVh0oooo1000nYXc0?ooo`030000003oool0oooo00X0oooo000U0?ooo`<0
00002`3oool4003jVRh0oooo1@00nYX:0?ooo`<00?ZJ0`000?m00?ooo`D0003o:`3oool4003jVVh0
oooo1000nYXb0?ooo`800000303oool002D0oooo00<000000?ooo`3oool02`3oool4003jVRh0oooo
2P00nYX50?ooo`<00?ZJ0`000?m10?ooo`H0003o:P3oool4003jVVd0oooo0`00nYXd0?ooo`030000
003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo00/0oooo00@0003o003jVP00nYX00?ZJ
;P3ooolB003jVP80003o@`3oool60000obT0oooo1@00nYY/0?ooo`<00?ZJ=03oool00`000000oooo
0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0;0?ooo`040000o`00nYX00?ZJ003jVRh0oooo
4P00nYX20000od@0oooo1P000?lY0?ooo`D00?ZJJ`3oool3003jVS@0oooo00<000000?ooo`3oool0
2P3oool002D0oooo00<000000?ooo`3oool02`3oool00`000?l00?ZJ003jVP02003jVR`0oooo1000
nYX50?ooo`T00?ZJ0`000?m60?ooo`H0003o:03oool4003jVV/0oooo0`00nYXd0?ooo`030000003o
ool0oooo00X0oooo000U0?ooo`030000003oool0oooo00`0oooo1000nYX/0?ooo`@00?ZJ2P3oool4
003jVP<0003oA`3oool60000obP0oooo1000nYYZ0?ooo`<00?ZJ=03oool00`000000oooo0?ooo`0:
0?ooo`009@3oool3000000`0oooo00@0003o003jVP00nYX00?ZJ;03oool3003jVPh0oooo10000?m8
0?ooo`H0003o2P3oool80000oaD0oooo1@00nYYX0?ooo`@00?ZJ<`3oool2000000`0oooo000U0?oo
o`030000003oool0oooo00`0oooo00@0003o003jVP00nYX00?ZJ;03oool3003jVPh0oooo0`000?m;
0?ooo`D0003o0P3ooolD0000oa40oooo1@00nYYW0?ooo`@00?ZJ=03oool00`000000oooo0?ooo`0:
0?ooo`009@3oool00`000000oooo0?ooo`0<0?ooo`040000o`00nYX00?ZJ003jVR`0oooo0`00nYX>
0?ooo`<0003oC03ooolO0000o`d0oooo1@00nYYV0?ooo`<00?ZJ=@3oool00`000000oooo0?ooo`0:
0?ooo`009@3oool00`000000oooo0?ooo`0=0?ooo`@00?ZJ:P3oool4003jVPd0oooo10000?m=0?oo
o`h0003o103oool>0000o``0oooo1@00nYYU0?ooo`<00?ZJ=@3oool00`000000oooo0?ooo`0:0?oo
o`002`3oool2000000@0oooo00<000000?ooo`3oool00P3oool3000000<0oooo0`0000060?ooo`03
0000003oool0oooo00d0oooo1000nYXZ0?ooo`@00?ZJ0P000?l;0?ooo`@0003oCP3oool60000oa00
oooo2@000?l=0?ooo`D00?ZJI03oool3003jVSD0oooo00<000000?ooo`3oool02P3oool000X0oooo
00@000000?ooo`3oool000002@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`0=0?ooo`040000o`00nYX00?ZJ003jVRX0oooo0`00nYX6
0000o`P0oooo0`000?mZ0?ooo`D0003o3@3oool5003jVV<0oooo0`00nYXe0?ooo`030000003oool0
oooo00X0oooo000:0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`030?ooo`@00000303oool010000?l00?ZJ003jVP00nYXZ0?ooo`<00?ZJ2@00
0?l50?ooo`<0003oJ`3oool40000o`h0oooo1@00nYYR0?ooo`<00?ZJ<`3oool3000000`0oooo000:
0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00d0oooo00@0003o003jVP00nYX00?ZJ:P3oool3003jVP`0003o
0P3oool30000of`0oooo10000?l>0?ooo`D00?ZJH03oool4003jVSD0oooo00<000000?ooo`3oool0
2P3oool000X0oooo00@000000?ooo`3oool000002@3oool010000000oooo0?ooo`3oool4000000H0
oooo00<000000?ooo`3oool03P3oool4003jVRP0oooo1000nYX20000o`80oooo3@000?m/0?ooo`D0
003o3P3oool5003jVUl0oooo1000nYXe0?ooo`030000003oool0oooo00X0oooo000:0?ooo`040000
003oool0oooo000000P0oooo0P0000030?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool03P3oool4003jVRP0oooo1000nYX20000o`D0oooo2P000?m]0?ooo`@0003o3`3oool5003jVUh0
oooo0`00nYXf0?ooo`030000003oool0oooo00X0oooo000;0?ooo`8000002P3oool010000000oooo
0?ooo`3oool5000000D0oooo00<000000?ooo`3oool03P3oool010000?l00?ZJ003jVP00nYXX0?oo
o`<00?ZJ0P000?l90?ooo`H0003oK`3oool40000o`l0oooo1@00nYYM0?ooo`<00?ZJ=P3oool00`00
0000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0>0?ooo`040000o`00nYX00?ZJ003j
VRP0oooo0`00nYX20000o``0oooo0`000?m_0?ooo`@0003o403oool5003jVU`0oooo0`00nYXf0?oo
o`030000003oool0oooo00X0oooo000U0?ooo`<000003P3oool00`000?l00?ZJ003jVP02003jVRL0
oooo0`00nYX20000ogl0oooo10000?l@0?ooo`D00?ZJ6P3oool4003jVSd0oooo0`00nYX30?ooo`<0
003o;`3oool2000000`0oooo000U0?ooo`030000003oool0oooo00l0oooo1000nYXV0?ooo`@00?ZJ
0P000?mo0?ooo`@0003o4@3oool5003jVQP0oooo1@00nYXm0?ooo`<00?ZJ0`3oool30000oc00oooo
00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool03`3oool010000?l00?ZJ003j
VP00nYXV0?ooo`@00?ZJ0P000?n00?ooo`@0003o4@3oool6003jVQD0oooo1`00nYXk0?ooo`@00?ZJ
0`3oool40000obl0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool03`3o
ool010000?l00?ZJ003jVP00nYXV0?ooo`<00?ZJ0P000?n10?ooo`@0003o4P3oool6003jVQ<0oooo
2@00nYXj0?ooo`@00?ZJ0`3oool40000obD0oooo0`000?l70?ooo`030000003oool0oooo00X0oooo
000U0?ooo`030000003oool0oooo00l0oooo00@0003o003jVP00nYX00?ZJ9P3oool3003jVP80003o
PP3oool40000oa80oooo1`00nYX?0?ooo`H00?ZJ00<0oooo003jVP00nYX00P00nYXj0?ooo`<00?ZJ
103oool50000ob@0oooo0`000?l70?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003o
ool0oooo00l0oooo00<0003o003jVP00nYX00P00nYXU0?ooo`<00?ZJ0P000?n20?ooo`D0003o4`3o
ool6003jVPd0oooo1P00nYX30?ooo`@00?ZJ>@3oool3003jVP<0oooo1`000?lR0?ooo`@0003o1`3o
ool00`000000oooo0?ooo`0:0?ooo`009@3oool300000100oooo1000nYXU0?ooo`<00?ZJ0P000?n3
0?ooo`@0003o503oool7003jVPX0oooo1P00nYX40?ooo`D00?ZJ>03oool3003jVP<0oooo1`000?lR
0?ooo`@0003o1P3oool2000000`0oooo000U0?ooo`030000003oool0oooo0100oooo00@0003o003j
VP00nYX00?ZJ903oool4003jVP80003oQ03oool40000oaD0oooo1`00nYX60?ooo`H00?ZJ1`3oool4
003jVSP0oooo0`00nYX30?ooo`<0003o00<0oooo0000o`000?l00P000?lP0?ooo`@0003o203oool0
0`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0@0?ooo`040000o`00nYX00?ZJ
003jVR@0oooo1000nYX00`000?l0oooo0?ooo`230?ooo`@0003o5P3oool7003jVP@0oooo1P00nYX9
0?ooo`@00?ZJ=P3oool4003jVP<0oooo0`000?l00`3oool0003o0000o`020000ob00oooo10000?l8
0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo0100oooo00@0003o003j
VP00nYX00?ZJ903oool3003jVP80003oQP3oool40000oaL0oooo1`00nYX00`3oool00?ZJ003jVP04
003jVPX0oooo1000nYXf0?ooo`@00?ZJ0`3oool30000o`80oooo10000?lO0?ooo`<0003o2@3oool0
0`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0@0?ooo`030000o`00nYX00?ZJ
00800?ZJ8`3oool3003jVP80003oQP3oool40000oaT0oooo2P00nYX=0?ooo`@00?ZJ=@3oool3003j
VP@0oooo0`000?l20?ooo`D0003o7@3oool40000o`T0oooo00<000000?ooo`3oool02P3oool002D0
oooo00<000000?ooo`3oool04@3oool4003jVR<0oooo0`00nYX20000ohL0oooo10000?lI0?ooo`P0
0?ZJ3P3oool5003jVS@0oooo0`00nYX40?ooo`<0003o0`3oool40000oad0oooo10000?l90?ooo`03
0000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo0140oooo00@0003o003jVP00nYX0
0?ZJ8P3oool4003jVP80003oQ`3oool40000oa/0oooo1@00nYX@0?ooo`@00?ZJ=03oool3003jVP@0
oooo0`000?l40?ooo`@0003o6`3oool40000o`X0oooo00<000000?ooo`3oool02P3oool002D0oooo
0`00000A0?ooo`040000o`00nYX00?ZJ003jVR80oooo1000nYX00`000?l0oooo0?ooo`270?ooo`@0
003o6`3oool3003jVQ80oooo1000nYXc0?ooo`<00?ZJ0`3oool40000o`@0oooo10000?lK0?ooo`@0
003o2@3oool2000000`0oooo000U0?ooo`030000003oool0oooo0140oooo00@0003o003jVP00nYX0
0?ZJ8P3oool3003jVP80003oR@3oool50000obl0oooo1@00nYXb0?ooo`<00?ZJ0`3oool40000o`D0
oooo10000?lI0?ooo`@0003o2`3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo
0?ooo`0A0?ooo`030000o`00nYX00?ZJ00800?ZJ8@3oool3003jVP80003oRP3oool40000oc00oooo
1000nYXa0?ooo`@00?ZJ0`3oool30000o`H0oooo1@000?lH0?ooo`@0003o2`3oool00`000000oooo
0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0B0?ooo`@00?ZJ8@3oool3003jVP80003oR`3o
ool40000oc00oooo1000nYX`0?ooo`@00?ZJ0`3oool30000o`L0oooo10000?lG0?ooo`@0003o303o
ool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0B0?ooo`040000o`00nYX0
0?ZJ003jVR00oooo1000nYX20000oh/0oooo10000?l`0?ooo`D00?ZJ;`3oool3003jVP@0oooo0`00
0?l80?ooo`@0003o5P3oool40000o``0oooo00<000000?ooo`3oool02P3oool002D0oooo00<00000
0?ooo`3oool04P3oool00`000?l00?ZJ003jVP02003jVQl0oooo1000nYX00`000?l0oooo0?ooo`2;
0?ooo`@0003o<03oool4003jVRl0oooo0`00nYX40?ooo`<0003o203oool40000oaD0oooo10000?l=
0?ooo`030000003oool0oooo00X0oooo000U0?ooo`<000004P3oool00`000?l00?ZJ003jVP02003j
VQl0oooo0`00nYX20000ohd0oooo1@000?l`0?ooo`@00?ZJ;P3oool3003jVP@0oooo0`000?l90?oo
o`@0003o503oool40000o``0oooo0P00000<0?ooo`009@3oool00`000000oooo0?ooo`0B0?ooo`80
003o1000nYXN0?ooo`<00?ZJ0P000?n>0?ooo`D0003o;`3oool4003jVRh0oooo0`00nYX30?ooo`@0
003o2@3oool50000oa<0oooo0`000?l>0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000
003oool0oooo01<0oooo00<0003o003jVP00nYX00P00nYXN0?ooo`<00?ZJ0P000?n?0?ooo`D0003o
;`3oool4003jVRd0oooo0`00nYX30?ooo`@0003o2P3oool40000oa80oooo10000?l>0?ooo`030000
003oool0oooo00X0oooo000A0?ooo`800000103oool010000000oooo0?ooo`3oool5000000D0oooo
00<000000?ooo`3oool04`3oool20000o`<00?ZJ7P3oool3003jVP80003oT03oool40000obl0oooo
1@00nYX[0?ooo`@00?ZJ0`3oool30000o``0oooo1@000?l@0?ooo`@0003o3P3oool00`000000oooo
0?ooo`0:0?ooo`00403oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000D0
oooo00<000000?ooo`3oool04`3oool20000o`@00?ZJ703oool4003jVP80003oT@3oool40000obl0
oooo1000nYX[0?ooo`@00?ZJ0`3oool30000o``0oooo1P000?l>0?ooo`@0003o3`3oool00`000000
oooo0?ooo`0:0?ooo`00403oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0503oool00`000?l00?ZJ003jVP02003jVQ`0oooo1000nYX00`000?l0
oooo0?ooo`2@0?ooo`D0003o;`3oool4003jVRX0oooo0`00nYX40?ooo`<0003o3@3oool60000o`d0
oooo10000?l?0?ooo`030000003oool0oooo00X0oooo000@0?ooo`040000003oool0oooo000000X0
oooo00<000000?ooo`3oool0103oool4000001<0oooo0P000?l4003jVQ/0oooo0`00nYX20000oi<0
oooo1@000?l^0?ooo`@00?ZJ:P3oool3003jVP@0oooo0`000?l?0?ooo`D0003o2`3oool40000o`h0
oooo0`00000<0?ooo`00403oool010000000oooo0?ooo`0000070?ooo`050000003oool0oooo0?oo
o`0000001@3oool00`000000oooo0?ooo`0D0?ooo`80003o1000nYXK0?ooo`<00?ZJ0P000?nD0?oo
o`@0003o;`3oool4003jVRT0oooo0`00nYX40?ooo`<0003o403oool50000o`X0oooo10000?l@0?oo
o`030000003oool0oooo00X0oooo000@0?ooo`040000003oool0oooo000000L0oooo00D000000?oo
o`3oool0oooo000000050?ooo`030000003oool0oooo01D0oooo0P000?l4003jVQX0oooo0`00nYX2
0000oiD0oooo10000?l^0?ooo`@00?ZJ:@3oool3003jVP@0oooo0`000?lA0?ooo`D0003o203oool4
0000oa40oooo00<000000?ooo`3oool02P3oool00140oooo0P0000090?ooo`<000001P3oool00`00
0000oooo0?ooo`0E0?ooo`80003o1000nYXI0?ooo`@00?ZJ0P000?nE0?ooo`D0003o;P3oool4003j
VRP0oooo0`00nYX30?ooo`@0003o4P3oool60000o`H0oooo10000?lA0?ooo`030000003oool0oooo
00X0oooo000U0?ooo`030000003oool0oooo01H0oooo0P000?l3003jVQT0oooo1000nYX00`000?l0
oooo0?ooo`2E0?ooo`D0003o;@3oool4003jVRL0oooo1000nYX30?ooo`@0003o4`3oool60000o`@0
oooo10000?lB0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo01H0oooo
0P000?l4003jVQP0oooo0`00nYX20000oiP0oooo1@000?l]0?ooo`@00?ZJ9P3oool4003jVP<0oooo
0`000?lE0?ooo`H0003o0`3oool40000oa80oooo00<000000?ooo`3oool02P3oool002D0oooo0`00
000F0?ooo`80003o1000nYXH0?ooo`<00?ZJ0P000?nI0?ooo`@0003o;@3oool4003jVRH0oooo0`00
nYX40?ooo`<0003o5`3oool50000o`80oooo0`000?lB0?ooo`800000303oool002D0oooo00<00000
0?ooo`3oool05`3oool20000o`@00?ZJ5`3oool3003jVP80003oVP3oool40000obd0oooo1000nYXU
0?ooo`<00?ZJ103oool30000oaP0oooo2@000?lC0?ooo`030000003oool0oooo00X0oooo000U0?oo
o`030000003oool0oooo01L0oooo0P000?l4003jVQH0oooo1000nYX20000oiX0oooo1@000?l/0?oo
o`@00?ZJ9@3oool3003jVP@0oooo0`000?lI0?ooo`P0003o4`3oool00`000000oooo0?ooo`0:0?oo
o`009@3oool00`000000oooo0?ooo`0H0?ooo`80003o1000nYXE0?ooo`@00?ZJ00<0003o0?ooo`3o
ool0VP3oool60000ob/0oooo1000nYXT0?ooo`<00?ZJ103oool30000oaX0oooo1P000?lD0?ooo`03
0000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo01P0oooo0P000?l4003jVQD0oooo
0`00nYX20000oid0oooo1P000?lZ0?ooo`@00?ZJ903oool3003jVP@0oooo0`000?lK0?ooo`D0003o
503oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0H0?ooo`<0003o1000
nYXD0?ooo`<00?ZJ0P000?nN0?ooo`H0003o:P3oool4003jVR80oooo1000nYX30?ooo`@0003o703o
ool30000oaD0oooo00<000000?ooo`3oool02P3oool002D0oooo0`00000I0?ooo`80003o1000nYXD
0?ooo`<00?ZJ0P000?nP0?ooo`D0003o:@3oool4003jVR80oooo1000nYX30?ooo`@0003o<`3oool2
000000`0oooo000U0?ooo`030000003oool0oooo01T0oooo0`000?l3003jVQ<0oooo1000nYX20000
oj40oooo1@000?lC0?ooo`@0003o4P3oool4003jVR40oooo0`00nYX40?ooo`<0003o=@3oool00`00
0000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0J0?ooo`80003o1000nYXB0?ooo`@0
0?ZJ00<0003o0?ooo`3oool0X@3oool50000oa40oooo1@000?lB0?ooo`@00?ZJ8@3oool3003jVP@0
oooo0`000?le0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo01X0oooo
0P000?l4003jVQ80oooo0`00nYX20000oj@0oooo1@000?l>0?ooo`P0003o4P3oool4003jVR00oooo
0`00nYX40?ooo`<0003o=@3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?oo
o`0J0?ooo`<0003o1000nYXA0?ooo`<00?ZJ0P000?nU0?ooo`D0003o303oool90000oa80oooo1000
nYXP0?ooo`<00?ZJ103oool30000ocD0oooo00<000000?ooo`3oool02P3oool002D0oooo00<00000
0?ooo`3oool06`3oool20000o`@00?ZJ4@3oool3003jVP80003oYP3oool50000o`T0oooo1`000?l0
0`3oool0003o0000o`020000oa80oooo1000nYXO0?ooo`<00?ZJ103oool30000ocD0oooo00<00000
0?ooo`3oool02P3oool002D0oooo0`00000K0?ooo`<0003o1000nYX@0?ooo`<00?ZJ0P000?nW0?oo
o`D0003o1P3oool70000o`<0oooo10000?lB0?ooo`@00?ZJ7P3oool4003jVP<0oooo10000?ld0?oo
o`800000303oool002D0oooo00<000000?ooo`3oool0703oool20000o`@00?ZJ3`3oool4003jVP80
003oZ03oool50000o`@0oooo1`000?l50?ooo`@0003o4P3oool4003jVQd0oooo1000nYX30?ooo`@0
003o=@3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0L0?ooo`<0003o
0`00nYX?0?ooo`@00?ZJ00<0003o0?ooo`3oool0Z03oool50000o`030?ooo`000?l0003o00D0003o
1`3oool40000oa80oooo1000nYXM0?ooo`<00?ZJ103oool30000ocH0oooo00<000000?ooo`3oool0
2P3oool002D0oooo00<000000?ooo`3oool0703oool30000o`@00?ZJ3P3oool3003jVP80003oZ`3o
ool:0000o`X0oooo10000?lB0?ooo`@00?ZJ703oool3003jVP@0oooo0`000?lf0?ooo`030000003o
ool0oooo00X0oooo000U0?ooo`030000003oool0oooo01d0oooo0P000?l4003jVPh0oooo0`00nYX2
0000oj`0oooo20000?l;0?ooo`@0003o4P3oool4003jVQ`0oooo0`00nYX40?ooo`<0003o=P3oool0
0`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`0M0?ooo`<0003o1@00nYX<0?oo
o`<00?ZJ0P000?n]0?ooo`D0003o3P3oool40000oa80oooo1000nYXK0?ooo`<00?ZJ103oool30000
ocH0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool07P3oool20000o`L0
0?ZJ2@3oool4003jVP80003o[P3oool30000o`l0oooo10000?lB0?ooo`@00?ZJ6`3oool3003jVP@0
oooo0`000?lf0?ooo`030000003oool0oooo00X0oooo000U0?ooo`<000007P3oool30000o`L00?ZJ
203oool4003jVP030000o`3oool0oooo0<00oooo10000?lB0?ooo`@00?ZJ6@3oool4003jVP@0oooo
0`000?le0?ooo`800000303oool002D0oooo00<000000?ooo`3oool07P3oool40000o`030?ooo`00
nYX00?ZJ00D00?ZJ1P3oool3003jVP80003o`P3oool40000oa80oooo1000nYXI0?ooo`@00?ZJ0`3o
ool40000ocH0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool07`3oool4
0000o`80oooo1`00nYX40?ooo`<00?ZJ0P000?o30?ooo`@0003o4P3oool4003jVQP0oooo0`00nYX4
0?ooo`@0003o=P3oool00`000000oooo0?ooo`0:0?ooo`002`3oool2000000@0oooo00@000000?oo
o`3oool0oooo1@0000020?ooo`<000001P3oool00`000000oooo0?ooo`0O0?ooo`@0003o0`3oool8
003jVP80oooo0`00nYX20000ol<0oooo1@000?lA0?ooo`@00?ZJ603oool3003jVP@0oooo0`000?lg
0?ooo`030000003oool0oooo00X0oooo000:0?ooo`040000003oool0oooo000000P0oooo00H00000
0?ooo`3oool000000?ooo`0000030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
803oool30000o`D0oooo2`00nYX20000ol@0oooo10000?lB0?ooo`@00?ZJ5P3oool4003jVP@0oooo
0`000?lg0?ooo`030000003oool0oooo00X0oooo000:0?ooo`040000003oool0oooo000000T0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0200oooo
1@000?l50?ooo`T00?ZJ00<0003o0?ooo`3oool0a03oool40000oa40oooo1000nYXF0?ooo`@00?ZJ
103oool30000ocL0oooo00<000000?ooo`3oool02P3oool000X0oooo00@000000?ooo`3oool00000
2P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo1000000O0?ooo`H0003o
1P3oool6003jVP80003oaP3oool40000oa80oooo0`00nYXE0?ooo`@00?ZJ1@3oool30000ocD0oooo
0`00000<0?ooo`002P3oool010000000oooo0?ooo`0000070?ooo`060000003oool0oooo0?ooo`00
0000oooo100000060?ooo`030000003oool0oooo0240oooo1`000?l50?ooo`D00?ZJ0P000?o70?oo
o`@0003o4@3oool4003jVQ@0oooo1000nYX50?ooo`<0003o=`3oool00`000000oooo0?ooo`0:0?oo
o`002P3oool010000000oooo0?ooo`0000070?ooo`070000003oool0oooo0?ooo`000000oooo0000
00090?ooo`030000003oool0oooo02<0oooo1P000?l60?ooo`<00?ZJ0P000?o70?ooo`@0003o4@3o
ool4003jVQ<0oooo1000nYX60?ooo`<0003o=`3oool00`000000oooo0?ooo`0:0?ooo`002`3oool2
000000T0oooo0`0000020?ooo`D000001@3oool00`000000oooo0?ooo`0T0?ooo`H0003o1P3oool4
0000olP0oooo10000?lA0?ooo`@00?ZJ4P3oool4003jVPD0oooo10000?lg0?ooo`030000003oool0
oooo00X0oooo000U0?ooo`030000003oool0oooo02H0oooo1P000?l40?ooo`<0003ob@3oool40000
oa40oooo1000nYXA0?ooo`@00?ZJ1P3oool40000ocL0oooo00<000000?ooo`3oool02P3oool002D0
oooo00<000000?ooo`3oool09`3oool60000o`<0oooo0`000?o:0?ooo`@0003o4@3oool4003jVQ00
oooo1000nYX60?ooo`<0003o>03oool00`000000oooo0?ooo`0:0?ooo`009@3oool3000002P0oooo
1`000?l0103oool0003o0000o`000?o:0?ooo`@0003o4@3oool4003jVPl0oooo1000nYX70?ooo`<0
003o=`3oool2000000`0oooo000U0?ooo`030000003oool0oooo02X0oooo2@000?o;0?ooo`@0003o
4@3oool4003jVPh0oooo1000nYX70?ooo`<0003o>03oool00`000000oooo0?ooo`0:0?ooo`009@3o
ool00`000000oooo0?ooo`0[0?ooo`P0003ob`3oool40000oa40oooo1000nYX=0?ooo`@00?ZJ203o
ool30000ocP0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0;@3oool5
0000old0oooo10000?lA0?ooo`@00?ZJ303oool4003jVPP0oooo0`000?lh0?ooo`030000003oool0
oooo00X0oooo000U0?ooo`030000003oool0oooo02h0oooo10000?o=0?ooo`@0003o4@3oool4003j
VP/0oooo1000nYX90?ooo`<0003o>03oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000
oooo0?ooo`0_0?ooo`<0003ocP3oool40000oa40oooo0`00nYX;0?ooo`@00?ZJ203oool40000ocP0
oooo00<000000?ooo`3oool02P3oool002D0oooo0`00003o0?ooo`40oooo10000?lA0?ooo`@00?ZJ
2P3oool3003jVPT0oooo10000?lg0?ooo`800000303oool002D0oooo00<000000?ooo`3oool0o`3o
ool20?ooo`<0003o4@3oool4003jVPT0oooo1000nYX90?ooo`<0003o>@3oool00`000000oooo0?oo
o`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?ooo`80oooo10000?lA0?ooo`@00?ZJ203oool4
003jVPT0oooo0`000?li0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo
0?l0oooo0P3oool40000oa40oooo1000nYX70?ooo`@00?ZJ2P3oool30000ocT0oooo00<000000?oo
o`3oool02P3oool002D0oooo00<000000?ooo`3oool0o`3oool30?ooo`@0003o4@3oool4003jVPH0
oooo1000nYX:0?ooo`<0003o>@3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo
0?ooo`3o0?ooo`<0oooo10000?lA0?ooo`@00?ZJ1@3oool4003jVP/0oooo0`000?li0?ooo`030000
003oool0oooo00X0oooo000U0?ooo`<00000o`3oool40?ooo`@0003o4@3oool4003jVP@0oooo1000
nYX:0?ooo`@0003o>03oool2000000`0oooo000U0?ooo`030000003oool0oooo0?l0oooo103oool4
0000oa40oooo1000nYX30?ooo`@00?ZJ2`3oool40000ocT0oooo00<000000?ooo`3oool02P3oool0
02D0oooo00<000000?ooo`3oool0o`3oool50?ooo`<0003o4P3oool4003jVP80oooo1000nYX;0?oo
o`<0003o>P3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?ooo`D0
oooo10000?lA0?ooo`@00?ZJ00<0oooo003jVP00nYX00P00nYX<0?ooo`<0003o>P3oool00`000000
oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?ooo`D0oooo10000?lB0?ooo`<00?ZJ
00<0oooo003jVP00nYX00P00nYX<0?ooo`<0003o>P3oool00`000000oooo0?ooo`0:0?ooo`009@3o
ool00`000000oooo0?ooo`3o0?ooo`H0oooo10000?lA0?ooo`L00?ZJ3@3oool30000ocX0oooo00<0
00000?ooo`3oool02P3oool002D0oooo0`00003o0?ooo`H0oooo10000?lA0?ooo`L00?ZJ3@3oool3
0000ocT0oooo0P00000<0?ooo`009@3oool00`000000oooo0?ooo`3o0?ooo`L0oooo10000?lA0?oo
o`D00?ZJ3P3oool30000ocX0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3o
ool0o`3oool70?ooo`@0003o4@3oool5003jVPd0oooo10000?lj0?ooo`030000003oool0oooo00X0
oooo000U0?ooo`030000003oool0oooo0?l0oooo203oool30000oa80oooo0`00nYX>0?ooo`@0003o
>P3oool00`000000oooo0?ooo`0:0?ooo`004@3oool2000000@0oooo00<000000?ooo`3oool00P3o
ool3000000H0oooo00<000000?ooo`3oool0o`3oool80?ooo`@0003o8P3oool30000oc/0oooo00<0
00000?ooo`3oool02P3oool00100oooo00@000000?ooo`3oool000001`3oool01@000000oooo0?oo
o`3oool0000000D0oooo00<000000?ooo`3oool0o`3oool80?ooo`@0003o8P3oool30000oc/0oooo
00<000000?ooo`3oool02P3oool00100oooo00@000000?ooo`3oool000002`3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo0?l0oooo2@3oool40000ob40oooo0`000?lk0?ooo`030000
003oool0oooo00X0oooo000@0?ooo`040000003oool0oooo000000T0oooo0P0000060?ooo`@00000
o`3oool80?ooo`@0003o8@3oool30000ocT0oooo0`00000<0?ooo`00403oool010000000oooo0?oo
o`00000;0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0o`3oool:0?ooo`@0003o
803oool30000oc/0oooo00<000000?ooo`3oool02P3oool00100oooo00@000000?ooo`3oool00000
1`3oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0o`3oool:0?ooo`@0
003o803oool30000oc/0oooo00<000000?ooo`3oool02P3oool00140oooo0P0000090?ooo`<00000
1P3oool00`000000oooo0?ooo`3o0?ooo`/0oooo0`000?lO0?ooo`@0003o>`3oool00`000000oooo
0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?ooo`/0oooo10000?lN0?ooo`@0003o>`3o
ool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?ooo`/0oooo10000?lN
0?ooo`<0003o?03oool00`000000oooo0?ooo`0:0?ooo`009@3oool300000?l0oooo303oool40000
oad0oooo0`000?lk0?ooo`800000303oool002D0oooo00<000000?ooo`3oool0o`3oool<0?ooo`@0
003o7@3oool30000oc`0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0
o`3oool=0?ooo`@0003o703oool30000oc`0oooo00<000000?ooo`3oool02P3oool002D0oooo00<0
00000?ooo`3oool0o`3oool=0?ooo`@0003o703oool30000oc`0oooo00<000000?ooo`3oool02P3o
ool002D0oooo00<000000?ooo`3oool0o`3oool>0?ooo`<0003o6`3oool40000oc`0oooo00<00000
0?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0o`3oool>0?ooo`@0003o6P3oool40000
oc`0oooo00<000000?ooo`3oool02P3oool002D0oooo0`00003o0?ooo`h0oooo10000?lJ0?ooo`<0
003o?03oool2000000`0oooo000U0?ooo`030000003oool0oooo0?l0oooo3`3oool40000oaT0oooo
0`000?lm0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo0?l0oooo3`3o
ool40000oaT0oooo0`000?lm0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0
oooo0?l0oooo403oool30000oaT0oooo0`000?lm0?ooo`030000003oool0oooo00X0oooo000U0?oo
o`030000003oool0oooo0?l0oooo403oool40000oaP0oooo0`000?lm0?ooo`030000003oool0oooo
00X0oooo000U0?ooo`030000003oool0oooo0?l0oooo403oool40000oaP0oooo0`000?lm0?ooo`03
0000003oool0oooo00X0oooo000U0?ooo`<00000o`3ooolA0?ooo`@0003o5P3oool40000oc`0oooo
0P00000<0?ooo`009@3oool00`000000oooo0?ooo`3o0?oooa40oooo10000?lF0?ooo`@0003o?@3o
ool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?oooa80oooo0`000?lF
0?ooo`<0003o?P3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?oo
oa80oooo10000?lE0?ooo`<0003o?P3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000
oooo0?ooo`3o0?oooa80oooo10000?lE0?ooo`<0003o?P3oool00`000000oooo0?ooo`0:0?ooo`00
9@3oool00`000000oooo0?ooo`3o0?oooa<0oooo0`000?lD0?ooo`@0003o?P3oool00`000000oooo
0?ooo`0:0?ooo`009@3oool300000?l0oooo4`3oool40000oa<0oooo10000?lm0?ooo`800000303o
ool002D0oooo00<000000?ooo`3oool0o`3ooolC0?ooo`@0003o4P3oool40000ocl0oooo00<00000
0?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0o`3ooolD0?ooo`@0003o4@3oool40000
ocl0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0o`3ooolD0?ooo`@0
003o403oool40000od00oooo00<000000?ooo`3oool02P3oool000/0oooo0P0000040?ooo`030000
003oool0oooo0080oooo0`0000030?ooo`<000001P3oool00`000000oooo0?ooo`3o0?oooaD0oooo
0`000?l?0?ooo`D0003o@03oool00`000000oooo0?ooo`0:0?ooo`002P3oool010000000oooo0?oo
o`0000070?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0o`3ooolE0?ooo`@0003o3P3oool40000od40oooo00<000000?oo
o`3oool02P3oool000X0oooo00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo00<0oooo1000003o0?oooa@0oooo10000?l=0?ooo`@0003o@03oool30000
00`0oooo000:0?ooo`040000003oool0oooo000000T0oooo0P0000060?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0o`3ooolF0?ooo`@0003o303oool40000od80oooo00<000000?oo
o`3oool02P3oool000X0oooo00@000000?ooo`3oool000002`3oool00`000000oooo000000030000
00H0oooo00<000000?ooo`3oool0o`3ooolF0?ooo`@0003o2`3oool40000od<0oooo00<000000?oo
o`3oool02P3oool000X0oooo00@000000?ooo`3oool000001`3oool01`000000oooo0?ooo`3oool0
00000?ooo`0000002@3oool00`000000oooo0?ooo`3o0?oooaL0oooo0`000?l;0?ooo`@0003o@`3o
ool00`000000oooo0?ooo`0:0?ooo`002`3oool2000000T0oooo0`0000020?ooo`D000001@3oool0
0`000000oooo0?ooo`3o0?oooaL0oooo10000?l90?ooo`@0003oA03oool00`000000oooo0?ooo`0:
0?ooo`009@3oool00`000000oooo0?ooo`3o0?oooaL0oooo10000?l90?ooo`@0003oA03oool00`00
0000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?oooaP0oooo10000?l70?ooo`@0
003oA@3oool00`000000oooo0?ooo`0:0?ooo`009@3oool300000?l0oooo603oool40000o`L0oooo
10000?m40?ooo`800000303oool002D0oooo00<000000?ooo`3oool0o`3ooolI0?ooo`<0003o1P3o
ool40000odH0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0o`3ooolI
0?ooo`@0003o1@3oool40000odH0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?oo
o`3oool0o`3ooolI0?ooo`@0003o103oool40000odL0oooo00<000000?ooo`3oool02P3oool002D0
oooo00<000000?ooo`3oool0o`3ooolJ0?ooo`<0003o0`3oool50000odL0oooo00<000000?ooo`3o
ool02P3oool002D0oooo00<000000?ooo`3oool0o`3ooolJ0?ooo`@0003o0P3oool40000odP0oooo
00<000000?ooo`3oool02P3oool002D0oooo0`00003o0?oooaX0oooo10000?l00`3oool0003o0000
o`020000odP0oooo0P00000<0?ooo`009@3oool00`000000oooo0?ooo`3o0?oooa/0oooo20000?m9
0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo0?l0oooo6`3oool70000
odX0oooo00<000000?ooo`3oool02P3oool002D0oooo00<000000?ooo`3oool0o`3ooolL0?ooo`H0
003oBP3oool00`000000oooo0?ooo`0:0?ooo`009@3oool00`000000oooo0?ooo`3o0?oooa`0oooo
1@000?m;0?ooo`030000003oool0oooo00X0oooo000U0?ooo`030000003oool0oooo0?l0oooo703o
ool50000od/0oooo00<000000?ooo`3oool02P3oool002D0oooo0`00003o0?oooad0oooo0`000?m;
0?ooo`800000303oool002D0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo
00X0oooo000U0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0@`3oool00`000000
oooo0?ooo`120?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0@`3oool00`000000
oooo0?ooo`120?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool02P3oool002D0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool02P3oool002D0ooooo`00001`000000`0oooo003o0?oooj40oooo003o0?oo
oj40oooo003o0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo000U0?ooo`<0<c<ci@3oool0
0`0c<c<0oooo0?ooo`0H0?ooo`0303<c<`3oool0oooo0480oooo00<0<c<c0?ooo`3oool00`0c<c<K
0?ooo`0303<c<`3oool0oooo00l0oooo000V0?ooo`0303<c<`3oool0oooo0><0oooo00<0<c<c0?oo
o`3oool06P3oool00`0c<c<0oooo0?ooo`100?ooo`0303<c<`3oool0oooo00@0oooo00<0<c<c0?oo
o`3oool06@3oool00`0c<c<0oooo0?ooo`0>0?ooo`009P3oool303<c<`T0oooo00<0<c<c0?ooo`0c
<c<00`3oool303<c<`80oooo0`0c<c<50?ooo`80<c<c0`3oool303<c<`T0oooo100c<c<20?ooo`<0
<c<c0P3oool303<c<`T0oooo0`0c<c<40?ooo`<0<c<c0P3oool303<c<`D0oooo0P0c<c<20?ooo`05
03<c<`3oool0<c<c0?ooo`0c<c<00P3oool403<c<`050?ooo`0c<c<0<c<c03<c<`3oool00P0c<c<2
0?ooo`80<c<c0`3oool303<c<`<0oooo100c<c<30?ooo`80<c<c00<0oooo03<c<`3oool01P3oool3
03<c<`@0oooo0P0c<c<30?ooo`@0<c<c0`3oool203<c<`80oooo1@0c<c<00`3oool0<c<c03<c<`02
03<c<`@0oooo0P0c<c<20?ooo`D0<c<c00@0oooo03<c<`0c<c<0oooo0P0c<c<20?ooo`<0<c<c0P3o
ool303<c<`030?ooo`0c<c<0<c<c00H0oooo0`0c<c<;0?ooo`0403<c<`3oool0oooo0?ooo`@0<c<c
0P3oool503<c<`80oooo100c<c<30?ooo`80<c<c00<0oooo03<c<`3oool00P3oool00`0c<c<0oooo
0?ooo`080?ooo`80<c<c00<0oooo03<c<`0c<c<00P0c<c<0103oool0<c<c03<c<`3oool403<c<`L0
oooo0`0c<c<30?ooo`0503<c<`3oool0<c<c0?ooo`0c<c<00P3oool303<c<`<0oooo100c<c<90?oo
o`0303<c<`3oool0oooo0080oooo100c<c<0103oool0<c<c03<c<`0c<c<50?ooo`80<c<c00<0oooo
03<c<`3oool00`0c<c<20?ooo`<0<c<c00<0oooo03<c<`0c<c<00`3oool00`0c<c<0oooo0?ooo`0=
0?ooo`009P3oool0100c<c<0oooo0?ooo`0c<c<80?ooo`0303<c<`3oool0<c<c0080oooo00<0<c<c
0?ooo`3oool0103oool00`0c<c<0oooo0?ooo`030?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c
2`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00@0oooo00<0<c<c0?ooo`3o
ool02@3oool00`0c<c<0oooo0?ooo`020?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00P3oool00`0c
<c<0oooo0?ooo`030?ooo`0<03<c<`3oool0oooo03<c<`3oool0<c<c0?ooo`0c<c<0oooo03<c<`3o
ool0<c<c0P3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00@0<c<c0?ooo`3oool0<c<c0P3o
ool00`0c<c<0oooo03<c<`050?ooo`0403<c<`3oool0oooo03<c<`<0oooo00@0<c<c0?ooo`3oool0
<c<c203oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c0P3o
ool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00D0<c<c0?ooo`3oool0oooo03<c<`070?ooo`04
03<c<`3oool0oooo03<c<`80oooo00D0<c<c0?ooo`3oool0oooo03<c<`040?ooo`0303<c<`3oool0
<c<c0080oooo00<0<c<c0?ooo`3oool0103oool0100c<c<0oooo0?ooo`0c<c<80?ooo`0303<c<`3o
ool0oooo00X0oooo00<0<c<c0?ooo`3oool00P3oool0100c<c<0oooo0?ooo`0c<c<30?ooo`0503<c
<`3oool0oooo0?ooo`0c<c<00P3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00<0<c<c0?oo
o`3oool00P3oool00`0c<c<0oooo0?ooo`070?ooo`0403<c<`3oool0oooo03<c<`80oooo00H0<c<c
0?ooo`3oool0<c<c0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00L0oooo00<0<c<c0?ooo`3oool0
0P3oool01`0c<c<0oooo03<c<`3oool0<c<c0?ooo`0c<c<00`3oool00`0c<c<0oooo03<c<`020?oo
o`0303<c<`3oool0oooo00P0oooo00D0<c<c0?ooo`3oool0oooo03<c<`030?ooo`0403<c<`3oool0
oooo03<c<`D0oooo00H0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<60?ooo`0403<c<`3oool0oooo03<c
<`@0oooo00<0<c<c0?ooo`3oool03@3oool002H0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool403<c
<`80oooo00<0<c<c0?ooo`0c<c<00P3oool503<c<`80oooo00<0<c<c0?ooo`3oool00`3oool00`0c
<c<0oooo0?ooo`020?ooo`D0<c<c1`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`D0<c<c0P3oool0
0`0c<c<0oooo0?ooo`090?ooo`0303<c<`3oool0oooo0080oooo00D0<c<c0?ooo`3oool0oooo03<c
<`020?ooo`0303<c<`3oool0oooo00<0oooo00<0<c<c0?ooo`3oool00P3oool01@0c<c<0oooo03<c
<`3oool0<c<c0080oooo0`0c<c<30?ooo`0403<c<`3oool0oooo03<c<`80oooo00<0<c<c0?ooo`3o
ool00P3oool503<c<`80oooo0`0c<c<30?ooo`0403<c<`3oool0oooo03<c<`80oooo100c<c<50?oo
o`0403<c<`3oool0oooo03<c<`D0oooo0`0c<c<30?ooo`0303<c<`3oool0oooo00@0oooo00<0<c<c
0?ooo`3oool00P3oool303<c<`<0oooo00<0<c<c0?ooo`3oool0103oool00`0c<c<0oooo0?ooo`02
0?ooo`80<c<c0`3oool503<c<`80oooo00@0<c<c0?ooo`3oool0<c<c203oool00`0c<c<0oooo0?oo
o`0:0?ooo`0303<c<`3oool0oooo0080oooo00@0<c<c0?ooo`3oool0<c<c0`3oool00`0c<c<0oooo
0?ooo`020?ooo`<0<c<c0`3oool0100c<c<0oooo0?ooo`0c<c<40?ooo`0303<c<`3oool0oooo00L0
oooo00@0<c<c0?ooo`3oool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`80oooo00<0
<c<c0?ooo`3oool01`3oool00`0c<c<0oooo0?ooo`020?ooo`0703<c<`3oool0<c<c0?ooo`0c<c<0
oooo03<c<`030?ooo`0303<c<`3oool0<c<c0080oooo00<0<c<c0?ooo`3oool0203oool01@0c<c<0
oooo0?ooo`3oool0<c<c00<0oooo00@0<c<c0?ooo`3oool0<c<c1@3oool01@0c<c<0oooo0?ooo`0c
<c<0oooo00D0<c<c0P3oool0100c<c<0oooo0?ooo`0c<c<40?ooo`0303<c<`3oool0oooo00d0oooo
000V0?ooo`0403<c<`3oool0oooo03<c<`L0oooo00L0<c<c0?ooo`0c<c<0oooo03<c<`3oool0<c<c
00<0oooo00<0<c<c0?ooo`3oool00P0c<c<40?ooo`0303<c<`3oool0oooo0080oooo00D0<c<c0?oo
o`3oool0oooo03<c<`070?ooo`0403<c<`3oool0oooo03<c<`80oooo00D0<c<c0?ooo`3oool0oooo
03<c<`020?ooo`80<c<c2P3oool303<c<`80oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`80
<c<c103oool00`0c<c<0oooo0?ooo`020?ooo`0703<c<`3oool0<c<c0?ooo`0c<c<0oooo03<c<`02
0?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00P3oool0100c<c<0oooo0?ooo`0c<c<40?ooo`0703<c
<`3oool0oooo0?ooo`0c<c<0oooo03<c<`020?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00P3oool0
0`0c<c<0oooo0?ooo`070?ooo`80<c<c0`3oool00`0c<c<0oooo0?ooo`020?ooo`0403<c<`3oool0
oooo03<c<`<0oooo00<0<c<c0?ooo`3oool0103oool01@0c<c<0oooo0?ooo`3oool0<c<c00H0oooo
00<0<c<c0?ooo`3oool0103oool00`0c<c<0oooo0?ooo`020?ooo`0303<c<`3oool0<c<c0080oooo
00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`0403<c<`3oool0oooo03<c<`P0oooo0`0c<c<:0?oo
o`0303<c<`3oool0oooo0080oooo00@0<c<c0?ooo`3oool0<c<c0`3oool01@0c<c<0oooo0?ooo`3o
ool0<c<c0080oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`0303<c<`3oool0oooo0080oooo
00<0<c<c0?ooo`3oool01`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0603<c<`3oool0oooo03<c
<`3oool0<c<c0P3oool00`0c<c<0oooo0?ooo`070?ooo`<0<c<c0P3oool01`0c<c<0oooo03<c<`3o
ool0<c<c0?ooo`0c<c<00`3oool00`0c<c<0oooo03<c<`020?ooo`0303<c<`3oool0oooo00P0oooo
00D0<c<c0?ooo`3oool0oooo03<c<`030?ooo`0303<c<`3oool0oooo0080<c<c103oool01P0c<c<0
oooo0?ooo`0c<c<0oooo03<c<`<0oooo00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo0?oo
o`020?ooo`0303<c<`3oool0oooo00d0oooo000U0?ooo`@0<c<c203oool01@0c<c<0oooo03<c<`3o
ool0<c<c0080oooo0`0c<c<20?ooo`80<c<c00@0oooo03<c<`0c<c<0oooo100c<c<30?ooo`<0<c<c
2@3oool303<c<`<0oooo0`0c<c<20?ooo`80<c<c00<0oooo03<c<`0c<c<0203oool0100c<c<0oooo
0?ooo`0c<c<20?ooo`<0<c<c0P3oool203<c<`040?ooo`0c<c<0<c<c0?ooo`@0<c<c0P3oool203<c
<`030?ooo`0c<c<0oooo0080oooo0P0c<c<30?ooo`@0<c<c0P3oool403<c<`<0oooo0`0c<c<30?oo
o`80<c<c0`3oool203<c<`030?ooo`0c<c<0<c<c00P0oooo00<0<c<c0?ooo`3oool00P3oool403<c
<`<0oooo0P0c<c<30?ooo`@0<c<c0P3oool303<c<`@0oooo100c<c<00`3oool0<c<c03<c<`0203<c
<`80oooo0`0c<c<40?ooo`0403<c<`3oool0<c<c03<c<`80oooo0`0c<c<20?ooo`@0<c<c2@3oool0
100c<c<0oooo0?ooo`0c<c<:0?ooo`0403<c<`3oool0oooo0?ooo`<0<c<c103oool00`0c<c<0oooo
0?ooo`020?ooo`80<c<c0`3oool203<c<`030?ooo`0c<c<0<c<c00<0oooo00<0<c<c0?ooo`3oool0
1`3oool203<c<`040?ooo`0c<c<0<c<c0?ooo`@0<c<c0`3oool303<c<`T0oooo00D0<c<c0?ooo`3o
ool0<c<c0?ooo`0203<c<`030?ooo`0c<c<0oooo0080oooo0`0c<c<30?ooo`<0<c<c2`3oool0100c
<c<0oooo0?ooo`3oool703<c<`040?ooo`0c<c<0<c<c0?ooo`80<c<c00<0oooo03<c<`0c<c<00P3o
ool303<c<`80oooo100c<c<40?ooo`0303<c<`3oool0oooo00h0oooo000a0?ooo`0503<c<`3oool0
<c<c0?ooo`0c<c<03P3oool00`0c<c<0oooo0?ooo`0A0?ooo`0303<c<`3oool0oooo01<0oooo00@0
<c<c0?ooo`3oool0<c<c3P3oool00`0c<c<0oooo0?ooo`0E0?ooo`0303<c<`3oool0oooo01/0oooo
00@0<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo0?ooo`090?ooo`0303<c<`3oool0oooo00l0
oooo00<0<c<c0?ooo`3oool02@3oool00`0c<c<0oooo0?ooo`0E0?ooo`0403<c<`3oool0oooo03<c
<`/0oooo00@0<c<c0?ooo`3oool0<c<c1P3oool00`0c<c<0oooo0?ooo`0>0?ooo`0303<c<`3oool0
oooo01L0oooo00<0<c<c0?ooo`3oool01`3oool0100c<c<0oooo0?ooo`0c<c<@0?ooo`0303<c<`3o
ool0oooo00X0oooo00<0<c<c0?ooo`3oool07P3oool00`0c<c<0oooo0?ooo`0?0?ooo`00<@3oool6
03<c<`d0oooo00<0<c<c0?ooo`3oool0403oool203<c<a@0oooo100c<c<?0?ooo`0303<c<`3oool0
oooo01D0oooo00<0<c<c0?ooo`3oool0703oool303<c<`80oooo00<0<c<c0?ooo`3oool02@3oool0
0`0c<c<0oooo0?ooo`040?ooo`0303<c<`3oool0oooo00P0oooo00<0<c<c0?ooo`3oool0103oool0
100c<c<0oooo0?ooo`3oool203<c<aH0oooo100c<c<>0?ooo`80<c<c103oool303<c<bT0oooo0P0c
<c<80?ooo`@0<c<c403oool203<c<cl0oooo003o0?oooj40oooo003o0?oooj40oooo0000\
\>"],
  ImageRangeCache->{{{0, 415}, {256.125, 0}} -> {-3.34394, -0.00217502, \
0.0717904, 0.00162305}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{176, 2}\),
      SequenceForm[ "Dimension der Daten  ", {176, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00544218 0.249604 0.0919705 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -6 -9 ]
[.15986 -0.0125 6 0 ]
[.29592 -0.0125 -6 -9 ]
[.29592 -0.0125 6 0 ]
[.43197 -0.0125 -6 -9 ]
[.43197 -0.0125 6 0 ]
[.56803 -0.0125 -9 -9 ]
[.56803 -0.0125 9 0 ]
[.70408 -0.0125 -9 -9 ]
[.70408 -0.0125 9 0 ]
[.84014 -0.0125 -9 -9 ]
[.84014 -0.0125 9 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06566 -12 -4.5 ]
[-0.0125 .06566 0 4.5 ]
[-0.0125 .15763 -12 -4.5 ]
[-0.0125 .15763 0 4.5 ]
[-0.0125 .2496 -6 -4.5 ]
[-0.0125 .2496 0 4.5 ]
[-0.0125 .34157 -6 -4.5 ]
[-0.0125 .34157 0 4.5 ]
[-0.0125 .43355 -6 -4.5 ]
[-0.0125 .43355 0 4.5 ]
[-0.0125 .52552 -6 -4.5 ]
[-0.0125 .52552 0 4.5 ]
[-0.0125 .61749 -6 -4.5 ]
[-0.0125 .61749 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -59 0 ]
[.5 .63053 59 12 ]
[.97619 .27327 -5 -6 ]
[.97619 .27327 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(25)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(50)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(75)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(100)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(125)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(150)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(175)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05102 0 m
.05102 .00375 L
s
.07823 0 m
.07823 .00375 L
s
.10544 0 m
.10544 .00375 L
s
.13265 0 m
.13265 .00375 L
s
.18707 0 m
.18707 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2415 0 m
.2415 .00375 L
s
.26871 0 m
.26871 .00375 L
s
.32313 0 m
.32313 .00375 L
s
.35034 0 m
.35034 .00375 L
s
.37755 0 m
.37755 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45918 0 m
.45918 .00375 L
s
.48639 0 m
.48639 .00375 L
s
.51361 0 m
.51361 .00375 L
s
.54082 0 m
.54082 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.62245 0 m
.62245 .00375 L
s
.64966 0 m
.64966 .00375 L
s
.67687 0 m
.67687 .00375 L
s
.73129 0 m
.73129 .00375 L
s
.7585 0 m
.7585 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.81293 0 m
.81293 .00375 L
s
.86735 0 m
.86735 .00375 L
s
.89456 0 m
.89456 .00375 L
s
.92177 0 m
.92177 .00375 L
s
.94898 0 m
.94898 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06566 m
.00625 .06566 L
s
[(-2)] -0.0125 .06566 1 0 Mshowa
0 .15763 m
.00625 .15763 L
s
[(-1)] -0.0125 .15763 1 0 Mshowa
0 .2496 m
.00625 .2496 L
s
[(0)] -0.0125 .2496 1 0 Mshowa
0 .34157 m
.00625 .34157 L
s
[(1)] -0.0125 .34157 1 0 Mshowa
0 .43355 m
.00625 .43355 L
s
[(2)] -0.0125 .43355 1 0 Mshowa
0 .52552 m
.00625 .52552 L
s
[(3)] -0.0125 .52552 1 0 Mshowa
0 .61749 m
.00625 .61749 L
s
[(4)] -0.0125 .61749 1 0 Mshowa
.125 Mabswid
0 .08406 m
.00375 .08406 L
s
0 .10245 m
.00375 .10245 L
s
0 .12085 m
.00375 .12085 L
s
0 .13924 m
.00375 .13924 L
s
0 .17603 m
.00375 .17603 L
s
0 .19442 m
.00375 .19442 L
s
0 .21282 m
.00375 .21282 L
s
0 .23121 m
.00375 .23121 L
s
0 .268 m
.00375 .268 L
s
0 .28639 m
.00375 .28639 L
s
0 .30479 m
.00375 .30479 L
s
0 .32318 m
.00375 .32318 L
s
0 .35997 m
.00375 .35997 L
s
0 .37836 m
.00375 .37836 L
s
0 .39676 m
.00375 .39676 L
s
0 .41515 m
.00375 .41515 L
s
0 .45194 m
.00375 .45194 L
s
0 .47033 m
.00375 .47033 L
s
0 .48873 m
.00375 .48873 L
s
0 .50712 m
.00375 .50712 L
s
0 .54391 m
.00375 .54391 L
s
0 .5623 m
.00375 .5623 L
s
0 .5807 m
.00375 .5807 L
s
0 .59909 m
.00375 .59909 L
s
0 .04727 m
.00375 .04727 L
s
0 .02888 m
.00375 .02888 L
s
0 .01048 m
.00375 .01048 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05102 .61428 m
.05102 .61803 L
s
.07823 .61428 m
.07823 .61803 L
s
.10544 .61428 m
.10544 .61803 L
s
.13265 .61428 m
.13265 .61803 L
s
.18707 .61428 m
.18707 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.2415 .61428 m
.2415 .61803 L
s
.26871 .61428 m
.26871 .61803 L
s
.32313 .61428 m
.32313 .61803 L
s
.35034 .61428 m
.35034 .61803 L
s
.37755 .61428 m
.37755 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45918 .61428 m
.45918 .61803 L
s
.48639 .61428 m
.48639 .61803 L
s
.51361 .61428 m
.51361 .61803 L
s
.54082 .61428 m
.54082 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.62245 .61428 m
.62245 .61803 L
s
.64966 .61428 m
.64966 .61803 L
s
.67687 .61428 m
.67687 .61803 L
s
.73129 .61428 m
.73129 .61803 L
s
.7585 .61428 m
.7585 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.81293 .61428 m
.81293 .61803 L
s
.86735 .61428 m
.86735 .61803 L
s
.89456 .61428 m
.89456 .61803 L
s
.92177 .61428 m
.92177 .61803 L
s
.94898 .61428 m
.94898 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06566 m
1 .06566 L
s
.99375 .15763 m
1 .15763 L
s
.99375 .2496 m
1 .2496 L
s
.99375 .34157 m
1 .34157 L
s
.99375 .43355 m
1 .43355 L
s
.99375 .52552 m
1 .52552 L
s
.99375 .61749 m
1 .61749 L
s
.125 Mabswid
.99625 .08406 m
1 .08406 L
s
.99625 .10245 m
1 .10245 L
s
.99625 .12085 m
1 .12085 L
s
.99625 .13924 m
1 .13924 L
s
.99625 .17603 m
1 .17603 L
s
.99625 .19442 m
1 .19442 L
s
.99625 .21282 m
1 .21282 L
s
.99625 .23121 m
1 .23121 L
s
.99625 .268 m
1 .268 L
s
.99625 .28639 m
1 .28639 L
s
.99625 .30479 m
1 .30479 L
s
.99625 .32318 m
1 .32318 L
s
.99625 .35997 m
1 .35997 L
s
.99625 .37836 m
1 .37836 L
s
.99625 .39676 m
1 .39676 L
s
.99625 .41515 m
1 .41515 L
s
.99625 .45194 m
1 .45194 L
s
.99625 .47033 m
1 .47033 L
s
.99625 .48873 m
1 .48873 L
s
.99625 .50712 m
1 .50712 L
s
.99625 .54391 m
1 .54391 L
s
.99625 .5623 m
1 .5623 L
s
.99625 .5807 m
1 .5807 L
s
.99625 .59909 m
1 .59909 L
s
.99625 .04727 m
1 .04727 L
s
.99625 .02888 m
1 .02888 L
s
.99625 .01048 m
1 .01048 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -120 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(Innovations) show
129.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(-) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(Prozess) show
177.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 1 r
gsave
.97619 .27327 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .28302 m
.02925 .2599 L
.03469 .10094 L
.04014 .38893 L
.04558 .17639 L
.05102 .16517 L
.05646 .24599 L
.0619 .20265 L
.06735 .31022 L
.07279 .23495 L
.07823 .22546 L
.08367 .29401 L
.08912 .39221 L
.09456 .09571 L
.1 .26246 L
.10544 .27777 L
.11088 .17818 L
.11633 .20237 L
.12177 .3845 L
.12721 .33538 L
.13265 .38162 L
.1381 .19229 L
.14354 .24976 L
.14898 .31407 L
.15442 .16961 L
.15986 .32412 L
.16531 .11107 L
.17075 .33321 L
.17619 .60332 L
.18163 .43888 L
.18707 .02538 L
.19252 .24336 L
.19796 .41308 L
.2034 .20099 L
.20884 .24872 L
.21429 .20033 L
.21973 .31432 L
.22517 .51518 L
.23061 .39452 L
.23605 .2021 L
.2415 .32888 L
.24694 .28578 L
.25238 .31053 L
.25782 .35104 L
.26327 .2322 L
.26871 .26336 L
.27415 .15143 L
.27959 .2444 L
.28503 .16585 L
.29048 .19478 L
Mistroke
.29592 .19888 L
.30136 .21165 L
.3068 .27754 L
.31224 .22041 L
.31769 .18918 L
.32313 .27807 L
.32857 .2126 L
.33401 .17692 L
.33946 .16444 L
.3449 .24337 L
.35034 .15992 L
.35578 .16915 L
.36122 .18221 L
.36667 .18249 L
.37211 .20101 L
.37755 .1687 L
.38299 .30916 L
.38844 .21735 L
.39388 .17369 L
.39932 .19403 L
.40476 .22838 L
.4102 .18977 L
.41565 .16951 L
.42109 .19585 L
.42653 .17034 L
.43197 .21358 L
.43741 .20404 L
.44286 .27935 L
.4483 .23918 L
.45374 .27807 L
.45918 .26196 L
.46463 .29739 L
.47007 .14832 L
.47551 .2171 L
.48095 .19125 L
.48639 .28383 L
.49184 .43943 L
.49728 .49517 L
.50272 .24004 L
.50816 .13128 L
.51361 .39342 L
.51905 .287 L
.52449 .21245 L
.52993 .2616 L
.53537 .18512 L
.54082 .25908 L
.54626 .33128 L
.5517 .27257 L
.55714 .41203 L
.56259 .3688 L
Mistroke
.56803 .12502 L
.57347 .26928 L
.57891 .41235 L
.58435 .24728 L
.5898 .20673 L
.59524 .18754 L
.60068 .19362 L
.60612 .21926 L
.61156 .29446 L
.61701 .32976 L
.62245 .3753 L
.62789 .2005 L
.63333 .21569 L
.63878 .2811 L
.64422 .26701 L
.64966 .32781 L
.6551 .14853 L
.66054 .19039 L
.66599 .20217 L
.67143 .39516 L
.67687 .34814 L
.68231 .54428 L
.68776 .01472 L
.6932 .39302 L
.69864 .21738 L
.70408 .29386 L
.70952 .17958 L
.71497 .26589 L
.72041 .22212 L
.72585 .12621 L
.73129 .21377 L
.73673 .32869 L
.74218 .25943 L
.74762 .20513 L
.75306 .27608 L
.7585 .27474 L
.76395 .21944 L
.76939 .14558 L
.77483 .24242 L
.78027 .20913 L
.78571 .1967 L
.79116 .18115 L
.7966 .34314 L
.80204 .35292 L
.80748 .22391 L
.81293 .22704 L
.81837 .25869 L
.82381 .21418 L
.82925 .23831 L
.83469 .28315 L
Mistroke
.84014 .12933 L
.84558 .21839 L
.85102 .15843 L
.85646 .20507 L
.8619 .28335 L
.86735 .24289 L
.87279 .29813 L
.87823 .14436 L
.88367 .34373 L
.88912 .18496 L
.89456 .27235 L
.9 .12252 L
.90544 .21342 L
.91088 .22175 L
.91633 .16637 L
.92177 .21946 L
.92721 .37899 L
.93265 .17143 L
.9381 .49798 L
.94354 .05963 L
.94898 .27747 L
.95442 .21751 L
.95986 .26927 L
.96531 .19414 L
.97075 .18326 L
.97619 .27327 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{416, 257.125},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006P00010B000`400?l00000o`00003oo`3ooonQ
0?ooo`00:03oool2000002/0oooo1@0000020?ooo`<00000:@3oool3000000@0oooo0P00000Y0?oo
o`030000003oool0oooo0080oooo0`00000V0?ooo`<00000103oool2000000@0oooo0P00000S0?oo
o`<000000P3oool500000080oooo0`00000S0?ooo`<000000`3oool3000000@0oooo0P00000R0?oo
o`<00000103oool00`000000oooo0?ooo`020?ooo`<00000503oool002L0oooo00@000000?ooo`3o
ool00000:`3oool01P000000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`3oool09@3o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000:03oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008`3oool00`000000oooo0?oo
o`020?ooo`060000003oool0oooo0000003oool000000`3oool00`000000oooo0?ooo`0Q0?ooo`05
0000003oool0oooo0?ooo`0000000`3oool010000000oooo0?ooo`0000020?ooo`030000003oool0
oooo0200oooo00<000000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<0
00000?ooo`3oool04@3oool002L0oooo00@000000?ooo`3oool00000;03oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo02T0oooo00@000000?ooo`3oool000000P3oool00`000000oooo
0?ooo`0W0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0903oool00`000000oooo
0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008`3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0803oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool04@3oool0
02L0oooo00@000000?ooo`3oool00000;@3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo02T0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0W0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000008`3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`050?ooo`04
0000003oool0oooo00000080oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool04@3oool002L0oooo00@000000?ooo`3o
ool00000:P3oool01P000000oooo0?ooo`3oool000000?ooo`@00000:03oool4000000<0oooo00@0
00000?ooo`3oool00000:P3oool00`000000oooo00000003000002L0oooo00<000000?ooo`3oool0
0P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000002<0oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0000000<00000903oool010000000oooo0?ooo`3o
ool4000000<0oooo00@000000?ooo`3oool000008P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0000000<00000503oool002L0oooo00@000000?ooo`3oool00000:P3oool01`000000oooo
0?ooo`3oool000000?ooo`000000:`3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo
000002H0oooo00L000000?ooo`3oool0oooo0000003oool0000002T0oooo0P0000040?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000008P3oool2000000<0oooo00L000000?oo
o`3oool0oooo0000003oool0000002H0oooo0P0000030?ooo`030000003oool0oooo00@0oooo00@0
00000?ooo`3oool000008@3oool2000000<0oooo00L000000?ooo`3oool0oooo0000003oool00000
01L0oooo000X0?ooo`800000;03oool300000080oooo1@00000W0?ooo`D000000`3oool2000002L0
oooo1@0000000`3oool0000000000003000002H0oooo00<000000?ooo`3oool00`3oool2000000@0
oooo0P00000T0?ooo`030000003oool0oooo0080oooo0`0000020?ooo`D000008`3oool010000000
oooo0?ooo`3oool5000000<0oooo0P00000S0?ooo`040000003oool0oooo0?ooo`D0000000<0oooo
0000000000000`00000C0?ooo`00o`3ooonQ0?ooo`00o`3ooonQ0?ooo`00o`3ooonQ0?ooo`00o`3o
oonQ0?ooo`00o`3ooonQ0?ooo`00o`3ooonQ0?ooo`00803ooooo0000070000004@3oool00200oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?oo
o`0^0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?oo
o`0_0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`0?0?ooo`00803oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool03`3oool0
0200oooo0`00003h0?ooo`<0003oK`3oool200000140oooo000P0?ooo`030000003oool0oooo0?P0
oooo0`000?m`0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0?P0oooo
0`000?m`0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0?P0oooo0`00
0?m`0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo0440oooo0`000?nd
0?ooo`<0003oL03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`110?oo
o`<0003o]03oool30000og00oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3o
ool0@@3oool30000ok@0oooo0`000?m`0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000
@@3oool30000ok@0oooo0`000?m_0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0@@3o
ool30000ok@0oooo0`000?m`0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0
oooo0440oooo0`000?nd0?ooo`<0003oL03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`00
0000oooo0?ooo`110?ooo`<0003o]03oool30000og00oooo00<000000?ooo`3oool03`3oool00200
oooo00<000000?ooo`3oool0@@3oool30000ok@0oooo0`000?m`0?ooo`030000003oool0oooo00l0
oooo000P0?ooo`030000003oool0oooo0440oooo0`000?nd0?ooo`<0003oL03oool00`000000oooo
0?ooo`0?0?ooo`00803oool300000440oooo0`000?nd0?ooo`<0003oK`3oool200000140oooo000P
0?ooo`030000003oool0oooo0440oooo0`000?nd0?ooo`<0003oL03oool00`000000oooo0?ooo`0?
0?ooo`00803oool00`000000oooo0?ooo`110?ooo`<0003o]03oool30000og00oooo00<000000?oo
o`3oool03`3oool00200oooo00<000000?ooo`3oool0@@3oool30000ok@0oooo0`000?m`0?ooo`03
0000003oool0oooo00l0oooo000F0?ooo`D000001@3oool00`000000oooo0?ooo`110?ooo`<0003o
]03oool30000oeX0oooo0`000?lC0?ooo`030000003oool0oooo00l0oooo000G0?ooo`040000003o
ool0oooo000000D0oooo00<000000?ooo`3oool0@@3oool30000ok@0oooo0`000?mJ0?ooo`<0003o
4`3oool00`000000oooo0?ooo`0?0?ooo`00403oool5000000<0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`110?ooo`<0003o]03oool30000oeX0oooo0`000?lC0?ooo`030000003o
ool0oooo00l0oooo000I0?ooo`030000003oool0oooo00@0oooo100000100?ooo`<0003o]03oool3
0000oeX0oooo0`000?lA0?ooo`<000004@3oool001H0oooo00D000000?ooo`3oool0oooo00000005
0?ooo`030000003oool0oooo0440oooo0`000?nd0?ooo`<0003oFP3oool30000oa<0oooo00<00000
0?ooo`3oool03`3oool001H0oooo00D000000?ooo`3oool0oooo000000050?ooo`030000003oool0
oooo0440oooo0`000?nd0?ooo`<0003oFP3oool30000oa<0oooo00<000000?ooo`3oool03`3oool0
01L0oooo0`0000060?ooo`030000003oool0oooo0440oooo0`000?nd0?ooo`<0003oFP3oool30000
oa<0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0@@3oool30000ok@0
oooo0`000?mJ0?ooo`<0003o4`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo
0?ooo`110?ooo`@0003o/`3oool30000oeX0oooo0`000?lC0?ooo`030000003oool0oooo00l0oooo
000P0?ooo`030000003oool0oooo0440oooo10000?nc0?ooo`<0003oFP3oool30000oa<0oooo00<0
00000?ooo`3oool03`3oool00200oooo0`0000110?ooo`@0003o/`3oool30000oeX0oooo0`000?lB
0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0@@3oool40000ok<0oooo0`000?mJ0?oo
o`<0003o4`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`110?ooo`@0
003o/`3oool30000oeX0oooo0`000?lC0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000
003oool0oooo01l0oooo0`000?lO0?ooo`@0003o/`3oool30000oeX0oooo0`000?lC0?ooo`030000
003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo01l0oooo0`000?lO0?ooo`@0003o/`3o
ool30000oeX0oooo0`000?lC0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0
oooo00T0oooo0`000?lC0?ooo`<0003o7`3oool40000ok<0oooo0`000?mJ0?ooo`<0003o4`3oool0
0`000000oooo0?ooo`0?0?ooo`00803oool3000000T0oooo0`000?lC0?ooo`<0003o7`3oool40000
ok<0oooo0`000?mJ0?ooo`<0003o4P3oool200000140oooo000P0?ooo`030000003oool0oooo00T0
oooo0`000?lC0?ooo`<0003o7`3oool40000ok<0oooo0`000?mJ0?ooo`<0003o4`3oool00`000000
oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`090?ooo`<0003o4`3oool30000oal0oooo
10000?nc0?ooo`<0003oFP3oool30000oa<0oooo00<000000?ooo`3oool03`3oool00200oooo00<0
00000?ooo`3oool02@3oool30000oa<0oooo0`000?lG0?ooo`<0003o1@3oool40000ok<0oooo1000
0?mI0?ooo`<0003o4`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`09
0?ooo`<0003o4`3oool30000oaL0oooo0`000?l50?ooo`@0003o/`3oool40000oeT0oooo0`000?lC
0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00T0oooo0`000?lC0?oo
o`<0003o5`3oool30000o`D0oooo10000?nc0?ooo`@0003oF@3oool40000oa80oooo00<000000?oo
o`3oool03`3oool00200oooo00<000000?ooo`3oool02@3oool30000oa<0oooo0`000?lG0?ooo`<0
003o1@3oool40000ok<0oooo10000?mI0?ooo`@0003o4P3oool00`000000oooo0?ooo`0?0?ooo`00
803oool3000000T0oooo0`000?lC0?ooo`<0003o5`3oool30000o`D0oooo10000?nc0?ooo`@0003o
B@3oool30000o`d0oooo10000?lA0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool02@3o
ool30000oa<0oooo0`000?lG0?ooo`<0003o1@3oool40000ohL0oooo0`000?lY0?ooo`@0003o2P3o
ool30000oc`0oooo0`000?l=0?ooo`@0003o4P3oool00`000000oooo0?ooo`0?0?ooo`00803oool0
0`000000oooo0?ooo`090?ooo`<0003o4`3oool30000oaL0oooo0`000?l50?ooo`@0003oQ`3oool3
0000obT0oooo10000?l:0?ooo`<0003o9`3oool30000oa80oooo0`000?l=0?ooo`@0003o4P3oool0
0`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`090?ooo`<0003o4`3oool30000
oaL0oooo0`000?l40?ooo`D0003oL@3oool30000oa<0oooo0`000?lY0?ooo`@0003o2P3oool30000
obL0oooo0`000?lB0?ooo`<0003o3@3oool40000oa80oooo00<000000?ooo`3oool03`3oool00200
oooo00<000000?ooo`3oool02@3oool30000oa<0oooo0`000?lG0?ooo`<0003o103oool50000og40
oooo0`000?lC0?ooo`<0003o:@3oool40000o`X0oooo0`000?lW0?ooo`<0003o4P3oool30000o`d0
oooo10000?lB0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00T0oooo
0`000?lC0?ooo`<0003o5`3oool30000o`@0oooo1@000?ma0?ooo`<0003o4`3oool30000obT0oooo
10000?l:0?ooo`<0003o9`3oool30000oa80oooo0`000?l=0?ooo`@0003o4P3oool00`000000oooo
0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`090?ooo`<0003o4`3oool40000oaH0oooo0`00
0?l40?ooo`D0003oL@3oool30000oa<0oooo0`000?lY0?ooo`@0003o2P3oool30000obL0oooo0`00
0?lB0?ooo`<0003o3@3oool40000oa80oooo00<000000?ooo`3oool03`3oool00200oooo0`000008
0?ooo`@0003o4`3oool40000oaH0oooo0`000?l40?ooo`D0003oL@3oool30000oa<0oooo0`000?lY
0?ooo`@0003o2P3oool30000obL0oooo0`000?lB0?ooo`<0003o3@3oool40000oa40oooo0P00000A
0?ooo`00803oool00`000000oooo0?ooo`080?ooo`@0003o4`3oool40000oaH0oooo0`000?l40?oo
o`D0003oL@3oool30000oa<0oooo0`000?lY0?ooo`@0003o2P3oool30000o`d0oooo0`000?lG0?oo
o`<0003o2P3oool30000o`D0oooo0`000?l=0?ooo`@0003o4P3oool00`000000oooo0?ooo`0?0?oo
o`00803oool00`000000oooo0?ooo`080?ooo`@0003o4`3oool40000oaH0oooo0`000?l40?ooo`D0
003oH`3oool30000o`/0oooo0`000?lC0?ooo`<0003o7@3oool30000o`P0oooo1@000?l:0?ooo`<0
003o3@3oool30000oaL0oooo0`000?l:0?ooo`<0003o1@3oool40000o``0oooo10000?lB0?ooo`03
0000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00P0oooo10000?lC0?ooo`@0003o
5P3oool30000o`@0oooo1@000?lL0?ooo`<0003oA03oool30000o`/0oooo0`000?lC0?ooo`<0003o
7@3oool30000o`P0oooo1@000?l:0?ooo`@0003o303oool30000oaL0oooo0`000?l:0?ooo`<0003o
1@3oool40000o``0oooo10000?lB0?ooo`030000003oool0oooo00l0oooo000G0?ooo`<000001P3o
ool00`000000oooo0?ooo`080?ooo`@0003o4`3oool40000oaH0oooo0`000?l40?ooo`D0003o703o
ool30000od@0oooo0`000?l;0?ooo`<0003o4`3oool30000oad0oooo0`000?l80?ooo`D0003o2@3o
ool50000o``0oooo0`000?lG0?ooo`@0003o2@3oool30000o`D0oooo10000?l<0?ooo`@0003o4P3o
ool00`000000oooo0?ooo`0?0?ooo`00603oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00P0oooo10000?lC0?ooo`@0003o5P3oool30000o`@0oooo1@000?lL0?ooo`<0003oA03oool3
0000o`/0oooo0`000?lC0?ooo`<0003o7@3oool30000o`P0oooo1@000?l90?ooo`D0003o303oool3
0000oaL0oooo10000?l90?ooo`<0003o1@3oool40000o``0oooo10000?lB0?ooo`030000003oool0
oooo00l0oooo000@0?ooo`D000000`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
00P0oooo10000?lC0?ooo`@0003o5P3oool30000o`@0oooo1@000?lL0?ooo`<0003o603oool30000
obT0oooo0`000?l;0?ooo`<0003o4`3oool30000oad0oooo0`000?l80?ooo`D0003o2@3oool50000
o``0oooo0`000?lG0?ooo`H0003o1`3oool30000o`D0oooo10000?l<0?ooo`@0003o4P3oool00`00
0000oooo0?ooo`0?0?ooo`00603oool00`000000oooo0?ooo`050?ooo`@000001`3oool40000oa<0
oooo10000?lF0?ooo`<0003o103oool50000oa`0oooo0`000?lH0?ooo`<0003o:@3oool30000o`X0
oooo10000?lC0?ooo`<0003o7@3oool40000o`L0oooo1@000?l90?ooo`D0003o303oool30000oaL0
oooo1P000?l70?ooo`<0003o1@3oool40000o``0oooo10000?l@0?ooo`<000004@3oool001P0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`080?ooo`@0003o0`3oool30000o`d0oooo
10000?lF0?ooo`<0003o103oool50000oa`0oooo0`000?lD0?ooo`<0003o00<0oooo0000o`000?l0
0P000?lX0?ooo`<0003o2P3oool40000oa<0oooo10000?lL0?ooo`@0003o1`3oool50000o`T0oooo
1@000?l<0?ooo`<0003o5`3oool60000o`L0oooo0`000?l40?ooo`D0003o303oool40000oa80oooo
00<000000?ooo`3oool03`3oool001L0oooo0P0000070?ooo`030000003oool0oooo00P0oooo1000
0?l30?ooo`<0003o3@3oool40000oaD0oooo10000?l40?ooo`D0003o703oool30000o`040?ooo`00
0?l0003o0000oa00oooo0`000?l00`3oool0003o0000o`020000obP0oooo10000?l90?ooo`@0003o
4`3oool40000oa`0oooo10000?l70?ooo`D0003o2@3oool50000o`/0oooo10000?lG0?ooo`H0003o
1`3oool30000o`@0oooo1@000?l20?ooo`<0003o1`3oool40000oa80oooo00<000000?ooo`3oool0
3`3oool001P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`080?ooo`@0003o0P3o
ool40000o`d0oooo10000?lB0?ooo`P0003o0`3oool50000oa`0oooo0`000?l0103oool0003o0000
o`000?l?0?ooo`@0003o00<0oooo0000o`000?l00`000?l50?ooo`<0003o2`3oool30000o`040?oo
o`000?l0003o0000o`d0oooo10000?l90?ooo`@0003o4`3oool40000oa`0oooo10000?l70?ooo`D0
003o2@3oool50000o`/0oooo10000?lF0?ooo`L0003o1`3oool30000o`@0oooo1@000?l20?ooo`<0
003o1`3oool40000oa80oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0
203oool40000o`80oooo10000?l<0?ooo`D0003o4P3oool80000o`<0oooo1@000?lL0?ooo`<0003o
00@0oooo0000o`000?l0003o3`3oool40000o`030?ooo`000?l0003o00<0003o1@3oool30000o`<0
oooo0`000?l50?ooo`<0003o00@0oooo0000o`000?l0003o3@3oool40000o`T0oooo10000?lC0?oo
o`@0003o703oool40000o`L0oooo1@000?l90?ooo`D0003o2`3oool50000oaD0oooo20000?l60?oo
o`<0003o103oool50000o`80oooo0`000?l30?ooo`P0003o4P3oool00`000000oooo0?ooo`0?0?oo
o`00803oool00`000000oooo0?ooo`080?ooo`X0003o303oool50000oa80oooo20000?l30?ooo`D0
003o703oool80000o`h0oooo10000?l00`3oool0003o0000o`040000o`@0oooo0`000?l30?ooo`<0
003o1@3oool30000o`040?ooo`000?l0003o0000o`d0oooo10000?l90?ooo`@0003o4`3oool40000
oa`0oooo10000?l70?ooo`D0003o2@3oool50000o`/0oooo1@000?lE0?ooo`P0003o1P3oool30000
o`@0oooo1@000?l20?ooo`<0003o0`3oool80000oa80oooo00<000000?ooo`3oool03`3oool00200
oooo0`0000080?ooo`X0003o303oool50000o`80oooo0`000?l=0?ooo`P0003o0`3oool50000oa`0
oooo20000?l=0?ooo`D0003o00<0oooo0000o`000?l010000?l40?ooo`<0003o0`3oool30000o`@0
oooo20000?l=0?ooo`@0003o2@3oool40000oa<0oooo10000?lL0?ooo`@0003o1`3oool50000o`T0
oooo1@000?l;0?ooo`D0003o5@3oool80000o`H0oooo0`000?l40?ooo`D0003o0P3oool30000o`<0
oooo20000?lA0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0203oool:0000o``0oooo
1@000?l20?ooo`<0003o3@3oool80000o`<0oooo1@000?lK0?ooo`T0003o3@3oool50000o`030?oo
o`000?l0003o00@0003o0`3oool40000o`<0oooo10000?l30?ooo`P0003o3@3oool40000o`T0oooo
10000?lC0?ooo`@0003o703oool40000o`L0oooo1@000?l40?ooo`<0003o0P3oool50000o`/0oooo
1@000?l40?ooo`<0003o3P3oool80000o`H0oooo0`000?l40?ooo`D0003o0P3oool30000o`<0oooo
20000?lB0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00P0oooo2P00
0?l<0?ooo`D0003o0P3oool30000o`d0oooo20000?l30?ooo`D0003o6`3oool90000o`d0oooo4`00
0?l30?ooo`@0003o0`3oool90000o``0oooo10000?l90?ooo`@0003o4`3oool40000oa`0oooo1@00
0?l60?ooo`D0003o103oool30000o`80oooo1@000?l;0?ooo`D0003o103oool30000o`h0oooo2000
0?l60?ooo`<0003o103oool50000o`030?ooo`000?l0003o00<0003o0P3oool80000o`H0oooo0`00
0?l90?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00P0oooo2`000?l;
0?ooo`D0003o0P3oool40000o``0oooo20000?l30?ooo`D0003o6`3oool90000o`d0oooo4`000?l2
0?ooo`D0003o0P3oool:0000o``0oooo10000?l90?ooo`@0003o1`3oool30000o`T0oooo10000?lL
0?ooo`D0003o1P3oool50000o`@0oooo0`000?l20?ooo`D0003o2`3oool50000o`<0oooo10000?l>
0?ooo`P0003o1@3oool40000o`030?ooo`000?l0003o00H0003o00<0oooo0000o`000?l00`000?l2
0?ooo`P0003o1P3oool30000o`T0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?oo
o`3oool0203oool;0000o`/0oooo1@000?l20?ooo`@0003o303oool80000o`<0oooo1@000?lK0?oo
o`X0003o1P3oool30000o`80oooo2@000?l20?ooo`T0003o0P3oool50000o`80oooo2P000?l;0?oo
o`D0003o2@3oool40000o`L0oooo0`000?l80?ooo`D0003o1P3oool30000oa<0oooo1@000?l60?oo
o`D0003o103oool30000o`80oooo1@000?l;0?ooo`D0003o0`3oool40000o`h0oooo20000?l50?oo
o`@0003o00<0oooo0000o`000?l01P000?l00`3oool0003o0000o`030000o`80oooo20000?l50?oo
o`@0003o2@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`080?ooo`/0
003o2`3oool50000o`80oooo10000?l60?ooo`<0003o0`3oool80000o`<0oooo1P000?lJ0?ooo`X0
003o1P3oool30000o`80oooo2@000?l40?ooo`L0003o0P3oool60000o`030?ooo`000?l0003o00P0
003o2`3oool80000o`H0oooo10000?l70?ooo`<0003o203oool50000o`H0oooo10000?lB0?ooo`D0
003o1P3oool50000o`@0oooo0`000?l20?ooo`D0003o2`3oool50000o`<0oooo10000?l>0?ooo`P0
003o1@3oool40000o`030?ooo`000?l0003o00H0003o00<0oooo0000o`000?l00`000?l20?ooo`P0
003o1@3oool40000o`T0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0
203oool;0000o`/0oooo1@000?l20?ooo`@0003o1P3oool30000o`<0oooo20000?l30?ooo`H0003o
6P3oool:0000o`H0oooo0`000?l20?ooo`<0003o00<0oooo0000o`000?l00`000?l50?ooo`H0003o
0P3oool60000o`030?ooo`000?l0003o00P0003o2`3oool80000o`H0oooo10000?l70?ooo`<0003o
203oool50000o`H0oooo1@000?l@0?ooo`H0003o1P3oool50000o`@0oooo0`000?l20?ooo`H0003o
2P3oool50000o`80oooo1@000?l>0?ooo`P0003o1@3oool40000o`030?ooo`000?l0003o00`0003o
0P3oool80000o`@0oooo1@000?l90?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000203o
ool;0000o`/0oooo1@000?l20?ooo`@0003o1P3oool30000o`<0oooo20000?l30?ooo`H0003o6P3o
ool;0000o`D0oooo0`000?l20?ooo`<0003o00<0oooo0000o`000?l00`000?l50?ooo`H0003o0P3o
ool60000o`050?ooo`000?l0003o0000o`3oool01P000?l;0?ooo`P0003o1P3oool40000o`L0oooo
0`000?l80?ooo`D0003o1@3oool60000oa00oooo1`000?l50?ooo`D0003o103oool30000o`80oooo
1P000?l:0?ooo`D0003o0P3oool50000o`h0oooo2@000?l40?oooa<0003o0P3oool80000o`@0oooo
1@000?l80?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0203oool;0000o`/0oooo1@00
0?l20?ooo`D0003o1@3oool30000o`<0oooo20000?l30?ooo`H0003o00D0oooo0000o`000?l0003o
0?ooo`030000oa80oooo30000?l30?ooo`@0003o0P3oool30000o`030?ooo`000?l0003o00<0003o
1@3oool60000o`80oooo2P000?l00`3oool0003o0000o`040000o`/0oooo20000?l60?ooo`D0003o
1P3oool30000o`P0oooo1@000?l50?ooo`H0003o1`3oool30000o`H0oooo1`000?l50?ooo`D0003o
103oool30000o`030?ooo`000?l0003o00D0003o2P3oool50000o`80oooo1@000?l>0?ooo`T0003o
103ooolC0000o`80oooo20000?l40?ooo`D0003o2@3oool00`000000oooo0?ooo`0?0?ooo`00803o
ool00`000000oooo0?ooo`080?ooo`h0003o203oool50000o`80oooo1@000?l50?ooo`<0003o0`3o
ool80000o`<0oooo1P000?l01@3oool0003o0000o`000?l0oooo00<0003o1@3oool30000o`X0oooo
1`000?l00`3oool0003o0000o`020000o`<0oooo10000?l20?ooo`<0003o00<0oooo0000o`000?l0
0`000?l60?ooo`D0003o0P3oool:0000o`030?ooo`000?l0003o00@0003o2`3oool80000o`H0oooo
1@000?l60?ooo`<0003o203oool50000o`D0oooo1`000?l60?ooo`<0003o1P3oool30000o`030?oo
o`000?l0003o0080003o103oool50000o`@0oooo0`000?l00`3oool0003o0000o`050000o`T0oooo
1P000?l00`3oool0003o0000o`040000o`h0oooo2@000?l40?oooa<0003o0P3oool80000o`@0oooo
1@000?l90?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00P0oooo3P00
0?l80?ooo`D0003o00<0oooo0000o`000?l010000?l50?ooo`<0003o0`3oool80000o`<0oooo1P00
0?l01@3oool0003o0000o`000?l0oooo00<0003o1@3oool30000o`X0oooo1`000?l20?ooo`@0003o
0P3oool40000o`80oooo0`000?l00`3oool0003o0000o`030000o`H0oooo1@000?l20?ooo`T0003o
1@3oool60000o`P0oooo20000?l60?ooo`D0003o1P3oool30000o`P0oooo1@000?l40?ooo`P0003o
1P3oool40000o`D0oooo0`000?l00`3oool0003o0000o`020000o`@0oooo1@000?l40?ooo`L0003o
00@0oooo0000o`000?l0003o0`3oool30000o`<0oooo1P000?l00`3oool0003o0000o`040000o`h0
oooo2@000?l40?oooa<0003o0P3oool80000o`@0oooo1@000?l90?ooo`030000003oool0oooo00l0
oooo000P0?ooo`030000003oool0oooo00P0oooo3P000?l80?ooo`D0003o00<0oooo0000o`000?l0
10000?l50?ooo`@0003o00<0oooo0000o`000?l01`000?l30?ooo`H0003o00D0oooo0000o`000?l0
003o0?ooo`030000o`D0oooo0`000?l:0?ooo`L0003o0P3oool40000o`80oooo10000?l00`3oool0
003o0000o`020000o`030?ooo`000?l0003o00<0003o203oool>0000o`D0oooo1P000?l80?ooo`P0
003o1P3oool50000o`D0oooo1@000?l70?ooo`D0003o103oool40000o`040?ooo`000?l0003o0000
o`H0oooo10000?l50?ooo`<0003o0P3oool30000o`@0oooo1@000?l40?ooo`L0003o00@0oooo0000
o`000?l0003o0`3oool30000o`<0oooo3@000?l>0?ooo`T0003o103ooolD0000o`030?ooo`000?l0
003o00H0003o103oool60000o`P0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?oo
o`3oool0203oool>0000o`P0oooo1@000?l00`3oool0003o0000o`040000o`D0oooo10000?l00`3o
ool0003o0000o`070000o`<0oooo1P000?l01@3oool0003o0000o`000?l0oooo00<0003o1@3oool3
0000o`X0oooo1`000?l30?ooo`@0003o00<0oooo0000o`000?l00P000?l00`3oool0003o0000o`02
0000o`030?ooo`000?l0003o00<0003o203oool80000o`030?ooo`000?l0003o00<0003o1P3oool5
0000o`P0oooo20000?l60?ooo`D0003o1@3oool50000o`L0oooo1@000?l40?ooo`<0003o0P3oool3
0000o`H0oooo10000?l50?ooo`<0003o0P3oool30000o`@0oooo1@000?l30?ooo`P0003o00@0oooo
0000o`000?l0003o0`3oool30000o`<0oooo3@000?l>0?ooo`T0003o103ooolD0000o`030?ooo`00
0?l0003o00H0003o103oool60000o`P0oooo00<000000?ooo`3oool03`3oool00200oooo00<00000
0?ooo`3oool0203oool>0000o`P0oooo1@000?l00`3oool0003o0000o`040000o`D0oooo10000?l0
0`3oool0003o0000o`070000o`<0oooo1P000?l00`3oool0003o0000o`050000o`D0oooo0`000?l:
0?ooo`L0003o0`3oool40000o`030?ooo`000?l0003o00H0003o0P3oool50000o`T0oooo1P000?l2
0?ooo`D0003o1P3oool50000o`P0oooo20000?l60?ooo`D0003o0P3oool80000o`L0oooo1@000?l4
0?ooo`<0003o0P3oool30000o`H0oooo1@000?l40?ooo`<0003o0P3oool30000o`@0oooo1@000?l3
0?ooo`P0003o00@0oooo0000o`000?l0003o0`3oool30000o`<0oooo2@000?l0103oool0003o0000
o`000?l90?ooo`<0003o0P3oool90000o`@0oooo50000?l00`3oool0003o0000o`060000o`@0oooo
1P000?l80?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000203oool>0000o`P0oooo1@00
0?l00`3oool0003o0000o`040000o`D0oooo10000?l00`3oool0003o0000o`070000o`<0oooo1P00
0?l00`3oool0003o0000o`050000o`D0oooo0`000?l:0?ooo`L0003o103oool<0000o`80oooo1@00
0?l90?ooo`H0003o0P3oool50000o`H0oooo1@000?l80?ooo`T0003o103oool60000o`80oooo2000
0?l70?ooo`D0003o103oool30000o`80oooo10000?l50?ooo`D0003o103oool30000o`80oooo0`00
0?l40?oooa00003o00@0oooo0000o`000?l0003o0`3oool30000o`<0oooo2@000?l0103oool0003o
0000o`000?l90?ooo`<0003o0P3oool90000o`@0oooo40000?l01@3oool0003o0000o`000?l0oooo
0180003o1`3oool200000140oooo000P0?ooo`030000003oool0oooo00P0oooo3P000?l80?ooo`D0
003o00<0oooo0000o`000?l010000?l50?ooo`@0003o00<0oooo0000o`000?l01`000?l30?ooo`H0
003o00<0oooo0000o`000?l01@000?l50?ooo`<0003o2P3oool70000o`@0oooo30000?l20?ooo`D0
003o2@3oool60000o`80oooo1@000?l60?ooo`D0003o203oool90000o`@0oooo1P000?l20?ooo`P0
003o1`3oool50000o`<0oooo10000?l20?ooo`@0003o1@3oool50000o`@0oooo0`000?l20?ooo`<0
003o103oool@0000o`040?ooo`000?l0003o0000o`<0oooo0`000?l30?ooo`T0003o00@0oooo0000
o`000?l0003o2@3oool30000o`80oooo2@000?l40?oooa00003o00D0oooo0000o`000?l0003o0?oo
o`0B0000o`P0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool01`3oool?
0000o`P0oooo1@000?l00`3oool0003o0000o`040000o`D0oooo10000?l00`3oool0003o0000o`07
0000o`<0oooo1P000?l00`3oool0003o0000o`050000o`D0oooo0`000?l:0?ooo`L0003o103oool<
0000o`80oooo1@000?l90?ooo`H0003o0P3oool50000o`P0oooo0`000?l80?ooo`T0003o103oool6
0000o`80oooo20000?l70?ooo`D0003o0`3oool40000o`<0oooo0`000?l50?ooo`D0003o103oool3
0000o`80oooo0`000?l40?oooa00003o00@0oooo0000o`000?l0003o0P3oool40000o`<0oooo2@00
0?l0103oool0003o0000o`000?l90?ooo`@0003o00<0oooo0000o`000?l01`000?l40?oooa00003o
00D0oooo0000o`000?l0003o0?ooo`0>0000o`040?ooo`000?l0003o0000o`P0oooo00<000000?oo
o`3oool03`3oool00200oooo00<000000?ooo`3oool01`3oool?0000o`<0oooo0`000?l20?ooo``0
003o1@3oool40000o`030?ooo`000?l0003o00L0003o0`3oool60000o`030?ooo`000?l0003o00D0
003o1@3oool30000o`X0oooo1`000?l40?ooo``0003o0P3oool50000o`T0oooo1P000?l20?ooo`@0
003o2@3oool30000o`P0oooo0`000?l30?ooo`<0003o103oool60000o`80oooo20000?l70?ooo`D0
003o0`3oool30000o`@0oooo0`000?l50?ooo`D0003o103oool30000o`80oooo0`000?l40?oooa00
003o00@0oooo0000o`000?l0003o0P3oool50000o`80oooo20000?l20?ooo`@0003o0P3oool40000
o`80oooo10000?l00`3oool0003o0000o`070000o`@0oooo2`000?l00`3oool0003o0000o`020000
o`050?ooo`000?l0003o0000o`3oool03P000?l0103oool0003o0000o`000?l80?ooo`030000003o
ool0oooo00l0oooo000P0?ooo`030000003oool0oooo00L0oooo3`000?l30?ooo`<0003o0P3oool<
0000o`D0oooo10000?l00`3oool0003o0000o`070000o`<0oooo1P000?l00`3oool0003o0000o`05
0000o`D0oooo0`000?l:0?ooo`L0003o103oool<0000o`80oooo1@000?l90?ooo`H0003o0`3oool3
0000o`T0oooo10000?l70?ooo`<0003o0`3oool30000o`@0oooo1P000?l20?ooo`P0003o1`3oool5
0000o`<0oooo0`000?l40?ooo`<0003o1@3oool50000o`@0oooo0`000?l20?ooo`<0003o103oool@
0000o`040?ooo`000?l0003o0000o`80oooo1@000?l20?ooo`<0003o00<0oooo0000o`000?l00P00
0?l20?ooo`@0003o0P3oool:0000o`040?ooo`000?l0003o0000o`<0oooo10000?l30?ooo`/0003o
0P3oool30000o`030?ooo`000?l0003o0100003o00@0oooo0000o`000?l0003o203oool00`000000
oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`070?ooo`l0003o0P3oool40000o`80oooo
30000?l50?ooo`@0003o00<0oooo0000o`000?l01`000?l30?ooo`H0003o00<0oooo0000o`000?l0
1P000?l40?ooo`<0003o2P3oool70000o`@0oooo30000?l20?ooo`@0003o2P3oool60000o`<0oooo
0`000?l90?ooo`@0003o1`3oool30000o`<0oooo0`000?l40?ooo`H0003o0P3oool80000o`L0oooo
1@000?l30?ooo`<0003o103oool30000o`D0oooo1@000?l40?ooo`<0003o0P3oool30000o`@0oooo
40000?l0103oool0003o0000o`000?l20?ooo`D0003o0P3oool30000o`030?ooo`000?l0003o0080
003o0`3oool30000o`80oooo2P000?l0103oool0003o0000o`000?l30?ooo`@0003o0`3oool;0000
o`H0oooo4P000?l0103oool0003o0000o`000?l80?ooo`030000003oool0oooo00l0oooo000P0?oo
o`<000001`3oool90000o`030?ooo`000?l0003o00@0003o00<0oooo0000o`000?l00P000?l20?oo
o``0003o1@3oool40000o`030?ooo`000?l0003o00L0003o0`3oool60000o`030?ooo`000?l0003o
00H0003o103oool30000o`L0oooo2@000?l50?ooo``0003o0`3oool30000o`X0oooo1P000?l30?oo
o`<0003o2P3oool30000o`L0oooo0`000?l30?ooo`<0003o103oool60000o`80oooo20000?l70?oo
o`D0003o0`3oool30000o`@0oooo0`000?l50?ooo`D0003o103oool30000o`80oooo0`000?l40?oo
oa00003o00@0oooo0000o`000?l0003o0P3oool50000o`80oooo0`000?l00`3oool0003o0000o`02
0000o`<0oooo0`000?l20?ooo`X0003o00@0oooo0000o`000?l0003o103oool30000o`<0oooo2`00
0?l60?oooa80003o00@0oooo0000o`000?l0003o1`3oool200000140oooo000P0?ooo`030000003o
ool0oooo00L0oooo20000?l20?ooo`/0003o0P3oool<0000o`D0oooo10000?l00`3oool0003o0000
o`070000o`<0oooo1P000?l00`3oool0003o0000o`060000o`@0oooo10000?l60?ooo`T0003o1@3o
ool<0000o`<0oooo0`000?l:0?ooo`H0003o403oool30000o`L0oooo0`000?l30?ooo`<0003o103o
ool60000o`030?ooo`000?l0003o00L0003o1`3oool60000o`80oooo0`000?l40?ooo`<0003o1@3o
ool60000o`<0oooo0`000?l20?ooo`<0003o103oool@0000o`040?ooo`000?l0003o0000o`80oooo
1@000?l00`3oool0003o0000o`020000o`030?ooo`000?l0003o0080003o0`3oool30000o`80oooo
3P000?l40?ooo`<0003o0`3oool;0000o`H0oooo4P000?l0103oool0003o0000o`000?l80?ooo`03
0000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00L0oooo20000?l20?ooo`/0003o
0P3oool<0000o`D0oooo3P000?l30?ooo`H0003o00<0oooo0000o`000?l01P000?l40?ooo`@0003o
1P3oool90000o`D0oooo2`000?l40?ooo`<0003o2P3oool60000oa00oooo1P000?l40?ooo`<0003o
0`3oool30000o`@0oooo1P000?l00`3oool0003o0000o`070000o`L0oooo1P000?l00`3oool0003o
0000o`020000o`@0oooo0`000?l50?ooo`H0003o0`3oool30000o`80oooo0`000?l40?oooa00003o
00@0oooo0000o`000?l0003o0P3oool50000o`030?ooo`000?l0003o0080003o00<0oooo0000o`00
0?l00P000?l30?ooo`<0003o0P3oool>0000o`@0oooo0`000?l30?ooo`/0003o1P3ooolB0000o`04
0?ooo`000?l0003o0000o`P0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3o
ool01`3oool80000o`80oooo2`000?l20?ooo``0003o103oool?0000o`<0oooo1P000?l00`3oool0
003o0000o`060000o`@0oooo10000?l60?ooo`T0003o1@3oool;0000o`@0oooo0`000?l:0?ooo`H0
003o403oool60000o`@0oooo0`000?l30?ooo`<0003o103oool60000o`030?ooo`000?l0003o00L0
003o1`3oool60000o`030?ooo`000?l0003o0080003o103oool40000o`@0oooo1P000?l30?ooo`<0
003o0P3oool30000o`@0oooo3`000?l20?ooo`<0003o0P3oool50000o`040?ooo`000?l0003o0000
o`80oooo10000?l30?ooo`<0003o0P3oool>0000o`@0oooo0`000?l30?ooo`/0003o1P3ooolB0000
o`040?ooo`000?l0003o0000o`P0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?oo
o`3oool01`3oool80000o`80oooo30000?l00`3oool0003o0000o`0:0000o`@0oooo3`000?l30?oo
o`H0003o00<0oooo0000o`000?l01P000?l40?ooo`@0003o1P3oool50000o`040?ooo`000?l0003o
0000o`D0oooo1@000?l00`3oool0003o0000o`030000o`@0oooo0`000?l:0?ooo`H0003o403oool6
0000o`@0oooo0`000?l30?ooo`<0003o103oool60000o`030?ooo`000?l0003o00P0003o1P3oool6
0000o`040?ooo`000?l0003o0000o`D0oooo10000?l40?ooo`H0003o0`3oool30000o`80oooo0`00
0?l40?ooo`l0003o0P3oool40000o`030?ooo`000?l0003o00<0003o00@0oooo0000o`000?l0003o
0P3oool30000o`@0oooo0`000?l20?ooo`h0003o103oool@0000o`L0oooo4P000?l0103oool0003o
0000o`000?l80?ooo`030000003oool0oooo00l0oooo000H0?ooo`8000001P3oool00`000000oooo
0?ooo`070?ooo`P0003o0P3oool<0000o`030?ooo`000?l0003o00X0003o103oool?0000o`<0oooo
1P000?l00`3oool0003o0000o`060000o`@0oooo10000?l60?ooo`D0003o00@0oooo0000o`000?l0
003o1@3oool50000o`030?ooo`000?l0003o00<0003o103oool30000o`X0oooo1@000?lA0?ooo`H0
003o103oool30000o`<0oooo0`000?l40?ooo`H0003o00<0oooo0000o`000?l020000?l60?ooo`H0
003o00@0oooo0000o`000?l0003o1P3oool30000o`<0oooo1`000?l30?ooo`<0003o0P3oool30000
o`@0oooo3`000?l20?ooo`@0003o00<0oooo0000o`000?l00`000?l0103oool0003o0000o`000?l2
0?ooo`<0003o103oool30000o`80oooo3P000?l40?oooa00003o1`3ooolB0000o`040?ooo`000?l0
003o0000o`P0oooo00<000000?ooo`3oool03`3oool001L0oooo00@000000?ooo`3oool000001@3o
ool00`000000oooo0?ooo`070?ooo`P0003o0P3oool<0000o`030?ooo`000?l0003o00X0003o103o
ool?0000o`<0oooo1P000?l00`3oool0003o0000o`060000o`@0oooo10000?l60?ooo`D0003o00@0
oooo0000o`000?l0003o1@3oool50000o`030?ooo`000?l0003o00<0003o103oool30000o`X0oooo
1@000?lA0?ooo`H0003o103oool30000o`<0oooo0`000?l40?ooo`H0003o00<0oooo0000o`000?l0
20000?l60?ooo`H0003o00@0oooo0000o`000?l0003o1P3oool30000o`<0oooo1`000?l30?ooo`<0
003o0P3oool30000o`@0oooo3`000?l30?ooo`T0003o00@0oooo0000o`000?l0003o0P3oool30000
o`@0oooo0`000?l20?ooo`h0003o103oool@0000o`L0oooo4P000?l0103oool0003o0000o`000?l8
0?ooo`030000003oool0oooo00l0oooo000G0?ooo`040000003oool0oooo000000D0oooo10000006
0?ooo`P0003o0P3oool<0000o`030?ooo`000?l0003o00/0003o0`3oool?0000o`<0oooo1P000?l0
0`3oool0003o0000o`060000o`<0oooo1@000?l60?ooo`D0003o2P3oool40000o`030?ooo`000?l0
003o00<0003o4@3oool50000oa40oooo1`000?l30?ooo`<0003o0`3oool30000o`@0oooo1P000?l0
0`3oool0003o0000o`040000o`040?ooo`000?l0003o0000o`H0oooo1P000?l0103oool0003o0000
o`000?l60?ooo`<0003o0`3oool30000o`040?ooo`000?l0003o0000o`<0oooo0`000?l20?ooo`@0
003o0`3oool?0000o`<0oooo2@000?l0103oool0003o0000o`000?l90?ooo`<0003o0P3oool=0000
o`D0oooo40000?l70?oooa80003o00@0oooo0000o`000?l0003o1P3oool300000140oooo000G0?oo
o`040000003oool0oooo000000D0oooo00<000000?ooo`3oool01`3oool80000o`D0oooo2@000?l0
0`3oool0003o0000o`0;0000o`<0oooo3`000?l30?ooo`l0003o0`3oool50000o`H0oooo1@000?l:
0?ooo`@0003o00<0oooo0000o`000?l00`000?lA0?ooo`D0003o4@3oool70000o`<0oooo0`000?l3
0?ooo`<0003o103oool60000o`030?ooo`000?l0003o00@0003o00@0oooo0000o`000?l0003o1P3o
ool60000o`040?ooo`000?l0003o0000o`H0oooo0`000?l30?ooo`<0003o00@0oooo0000o`000?l0
003o0`3oool30000o`80oooo10000?l30?ooo`l0003o0`3oool90000o`040?ooo`000?l0003o0000
o`T0oooo0`000?l20?ooo`d0003o1@3oool@0000o`L0oooo4P000?l00`3oool0003o0000o`020000
o`L0oooo00<000000?ooo`3oool03`3oool001L0oooo00@000000?ooo`3oool000001@3oool00`00
0000oooo0?ooo`070?ooo`P0003o1@3oool90000o`030?ooo`000?l0003o00L0003o00@0oooo0000
o`000?l0003o0`3oool?0000o`<0oooo2P000?l20?ooo`<0003o0`3oool50000o`H0oooo1@000?l:
0?ooo`@0003o00<0oooo0000o`000?l00`000?lA0?ooo`D0003o4@3oool70000o`<0oooo0`000?l3
0?ooo`<0003o103oool60000o`030?ooo`000?l0003o00@0003o00@0oooo0000o`000?l0003o1P3o
ool60000o`040?ooo`000?l0003o0000o`H0oooo0`000?l30?ooo`<0003o00@0oooo0000o`000?l0
003o0`3oool30000o`<0oooo0`000?l30?ooo`l0003o0`3oool90000o`040?ooo`000?l0003o0000
o`T0oooo0`000?l20?ooo`L0003o0P3oool40000o`D0oooo40000?l70?oooa40003o0P3oool40000
o`L0oooo00<000000?ooo`3oool03`3oool001L0oooo00@000000?ooo`3oool000001@3oool00`00
0000oooo0?ooo`070?ooo`P0003o1@3oool90000o`030?ooo`000?l0003o00L0003o00@0oooo0000
o`000?l0003o0`3oool?0000o`<0oooo2@000?l30?ooo`<0003o0`3oool50000o`H0oooo1@000?l:
0?ooo`@0003o00<0oooo0000o`000?l00`000?lA0?ooo`D0003o4@3oool70000o`<0oooo0`000?l3
0?ooo`<0003o103oool60000o`030?ooo`000?l0003o00@0003o00@0oooo0000o`000?l0003o1P3o
ool60000o`040?ooo`000?l0003o0000o`H0oooo0`000?l30?ooo`<0003o00@0oooo0000o`000?l0
003o0`3oool30000o`<0oooo0`000?l30?ooo`l0003o0`3oool=0000o`T0oooo0`000?l00`3oool0
003o0000o`020000o`040?ooo`000?l0003o0000o`80oooo10000?l50?oooa00003o1`3ooolA0000
o`<0oooo0`000?l70?ooo`030000003oool0oooo00l0oooo000H0?ooo`8000001P3oool00`000000
oooo0?ooo`070?ooo`P0003o1@3oool50000o`050?ooo`000?l0003o0000o`3oool020000?l20?oo
o`<0003o0`3oool?0000o`<0oooo2@000?l30?ooo`<0003o0`3oool50000o`H0oooo1@000?l:0?oo
o`@0003o00<0oooo0000o`000?l00`000?lA0?ooo`D0003o4@3oool=0000o`<0oooo10000?l30?oo
o`H0003o00<0oooo0000o`000?l010000?l0103oool0003o0000o`000?l60?ooo`H0003o00@0oooo
0000o`000?l0003o1P3oool30000o`<0oooo0`000?l0103oool0003o0000o`000?l30?ooo`<0003o
0`3oool30000o`<0oooo3P000?l40?ooo`d0003o2@3oool30000o`030?ooo`000?l0003o0080003o
00@0oooo0000o`000?l0003o0P3oool40000o`D0oooo40000?l70?oooa40003o0`3oool30000o`L0
oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool01`3oool80000o`D0oooo
1@000?l01@3oool0003o0000o`000?l0oooo00P0003o0P3oool30000o`<0oooo3`000?l30?ooo`T0
003o0`3oool30000o`<0oooo1@000?l50?ooo`H0003o2P3oool40000o`80oooo10000?lA0?ooo`D0
003o4@3oool=0000o`<0oooo10000?l30?ooo`H0003o00<0oooo0000o`000?l010000?l0103oool0
003o0000o`000?l60?ooo`H0003o00@0oooo0000o`000?l0003o1P3oool30000o`<0oooo0`000?l0
103oool0003o0000o`000?l30?ooo`<0003o0`3oool30000o`<0oooo3P000?l40?ooo`H0003o00<0
oooo0000o`000?l010000?l90?ooo`<0003o00@0oooo0000o`000?l0003o0P3oool30000o`80oooo
10000?l50?oooa00003o1`3ooolA0000o`<0oooo0`000?l70?ooo`030000003oool0oooo00l0oooo
000P0?ooo`030000003oool0oooo00H0oooo2@000?l50?ooo`D0003o00D0oooo0000o`000?l0003o
0?ooo`080000o`80oooo0`000?l30?ooo`l0003o0`3oool90000o`<0oooo0`000?l30?ooo`D0003o
1@3oool60000o`X0oooo10000?l20?ooo`@0003o4@3oool50000oa80oooo2`000?l50?ooo`<0003o
0`3oool60000o`030?ooo`000?l0003o00@0003o00@0oooo0000o`000?l0003o1P3oool60000o`04
0?ooo`000?l0003o0000o`H0oooo0`000?l30?ooo`<0003o00<0oooo0000o`000?l01`000?l30?oo
o`<0003o0`3oool>0000o`@0oooo1P000?l00`3oool0003o0000o`030000o`X0oooo0`000?l0103o
ool0003o0000o`000?l70?ooo`@0003o1@3oool@0000o`P0oooo30000?l0103oool0003o0000o`00
0?l30?ooo`<0003o1`3oool00`000000oooo0?ooo`0?0?ooo`00803oool3000000H0oooo2@000?l5
0?ooo`D0003o00D0oooo0000o`000?l0003o0?ooo`080000o`80oooo0`000?l30?ooo`l0003o0`3o
ool90000o`<0oooo0`000?l30?ooo`D0003o1@3oool30000o`d0oooo0`000?l30?ooo`<0003o4P3o
ool50000oa80oooo2`000?l50?ooo`<0003o0`3oool:0000o`@0oooo0`000?l60?ooo`H0003o00@0
oooo0000o`000?l0003o1P3oool30000o`<0oooo0`000?l00`3oool0003o0000o`070000o`<0oooo
0`000?l30?ooo`h0003o103oool60000o`030?ooo`000?l0003o00<0003o2P3oool30000o`040?oo
o`000?l0003o0000o`L0oooo10000?l50?oooa00003o203oool<0000o`040?ooo`000?l0003o0000
o`<0oooo0`000?l60?ooo`8000004@3oool00200oooo00<000000?ooo`3oool01P3oool30000o`03
0?ooo`000?l0003o00<0003o1@3oool50000o`050?ooo`000?l0003o0000o`3oool00`000?l00`3o
ool0003o0000o`020000o`80oooo0`000?l30?ooo`<0003o00<0oooo0000o`000?l02@000?l30?oo
o`T0003o0`3oool30000o`<0oooo1@000?l50?ooo`<0003o3@3oool30000o`<0oooo0`000?lB0?oo
o`D0003o4P3oool;0000o`D0oooo0`000?l30?ooo`X0003o103oool30000o`040?ooo`000?l0003o
0000o`80oooo1P000?l0103oool0003o0000o`000?l60?ooo`<0003o0`3oool30000o`80oooo2000
0?l30?ooo`<0003o0`3oool:0000o`P0oooo1P000?l00`3oool0003o0000o`030000o`X0oooo0`00
0?l0103oool0003o0000o`000?l70?ooo`@0003o1P3oool?0000o`P0oooo30000?l0103oool0003o
0000o`000?l30?ooo`<0003o1`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo
0?ooo`060?ooo`<0003o00<0oooo0000o`000?l00`000?l50?ooo`D0003o00D0oooo0000o`000?l0
003o0?ooo`030000o`030?ooo`000?l0003o0080003o0P3oool30000o`<0oooo0`000?l00`3oool0
003o0000o`090000o`<0oooo2@000?l30?ooo`<0003o0`3oool50000o`D0oooo0`000?l=0?ooo`<0
003o0`3oool30000oa80oooo1@000?lB0?ooo`<0003o00<0oooo0000o`000?l01@000?l50?ooo`<0
003o0`3oool90000o`D0oooo0`000?l0103oool0003o0000o`000?l20?ooo`H0003o00@0oooo0000
o`000?l0003o1P3oool30000o`<0oooo0`000?l20?ooo`P0003o0`3oool30000o`<0oooo2P000?l8
0?ooo`H0003o00<0oooo0000o`000?l00`000?l:0?ooo`<0003o00@0oooo0000o`000?l0003o1`3o
ool40000o`H0oooo3`000?l80?ooo``0003o1`3oool30000o`L0oooo00<000000?ooo`3oool03`3o
ool00200oooo00<000000?ooo`3oool01@3oool40000o`030?ooo`000?l0003o00<0003o1@3oool5
0000o`030?ooo`000?l0003o00D0003o00<0oooo0000o`000?l00P000?l20?ooo`<0003o0`3oool3
0000o`030?ooo`000?l0003o00T0003o0`3oool90000o`<0oooo0`000?l30?ooo`D0003o1@3oool3
0000o`d0oooo0`000?l30?ooo`<0003o4P3oool50000oa80oooo0`000?l00`3oool0003o0000o`05
0000o`D0oooo0`000?l30?ooo`T0003o1@3oool70000o`80oooo1P000?l0103oool0003o0000o`00
0?l60?ooo`@0003o0P3oool30000o`80oooo20000?l30?ooo`<0003o0`3oool:0000o`P0oooo1P00
0?l00`3oool0003o0000o`030000o`X0oooo0`000?l0103oool0003o0000o`000?l80?ooo`<0003o
1P3oool?0000o`P0oooo30000?l70?ooo`<0003o1`3oool00`000000oooo0?ooo`0?0?ooo`00803o
ool00`000000oooo0?ooo`050?ooo`@0003o00<0oooo0000o`000?l00`000?l50?ooo`D0003o00<0
oooo0000o`000?l01@000?l20?ooo`<0003o0P3oool30000o`<0oooo0`000?l00`3oool0003o0000
o`0:0000o`80oooo2@000?l30?ooo`<0003o0`3oool50000o`D0oooo0`000?l=0?ooo`<0003o0`3o
ool30000oa<0oooo10000?lB0?ooo`<0003o00<0oooo0000o`000?l01@000?l50?ooo`<0003o0`3o
ool90000o`D0oooo1`000?l20?ooo`H0003o00@0oooo0000o`000?l0003o1P3oool40000o`80oooo
0`000?l20?ooo`P0003o0`3oool30000o`<0oooo2P000?l80?ooo`H0003o00@0oooo0000o`000?l0
003o303oool30000o`040?ooo`000?l0003o0000o`P0oooo0`000?l60?ooo``0003o2`3oool<0000
oa40oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool01@3oool30000o`80
oooo1@000?l50?ooo`D0003o0P3oool60000o`80oooo0`000?l20?ooo`<0003o0`3oool30000o`03
0?ooo`000?l0003o00X0003o0P3oool90000o`<0oooo0`000?l30?ooo`P0003o0P3oool30000oa<0
oooo0`000?lC0?ooo`@0003o4P3oool30000o`030?ooo`000?l0003o00D0003o1@3oool30000o`<0
oooo2@000?l60?ooo`H0003o0P3oool60000o`040?ooo`000?l0003o0000o`L0oooo0`000?l20?oo
o`<0003o0P3oool80000o`<0oooo0`000?l30?ooo`X0003o203oool50000oa40oooo0`000?l0103o
ool0003o0000o`000?l80?ooo`<0003o1P3oool<0000o`/0oooo2@000?lD0?ooo`030000003oool0
oooo00l0oooo000P0?ooo`030000003oool0oooo00D0oooo0`000?l20?ooo`D0003o1@3oool50000
o`80oooo1P000?l70?ooo`<0003o0`3oool30000o`030?ooo`000?l0003o00H0003o00@0oooo0000
o`000?l0003o0P3oool90000o`<0oooo10000?l20?ooo`P0003o0P3oool30000obT0oooo10000?lI
0?ooo`@0003o1@3oool30000o`<0oooo2@000?l60?ooo`H0003o0P3oool60000o`040?ooo`000?l0
003o0000o`L0oooo0`000?l20?ooo`<0003o0P3oool80000o`<0oooo0`000?l30?ooo`X0003o203o
ool50000oa40oooo0`000?l0103oool0003o0000o`000?l80?ooo`<0003o1P3oool<0000o`/0oooo
2@000?lD0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<000002P3oool50000o`H0oooo1000
0?l20?ooo`H0003o1`3oool30000o`<0oooo0`000?l00`3oool0003o0000o`060000o`040?ooo`00
0?l0003o0000o`80oooo2@000?l30?ooo`@0003o0P3oool80000o`80oooo0`000?lY0?ooo`@0003o
6@3oool40000o`D0oooo0`000?l30?ooo`T0003o1P3oool60000o`80oooo2P000?l70?ooo`<0003o
0P3oool30000o`D0oooo10000?l40?ooo`<0003o0`3oool:0000o`P0oooo1@000?lA0?ooo`<0003o
00@0oooo0000o`000?l0003o4@3oool<0000o`/0oooo2@000?lC0?ooo`8000004@3oool00200oooo
00<000000?ooo`3oool02P3oool50000o`H0oooo10000?l20?ooo`H0003o1`3oool30000o`<0oooo
0`000?l00`3oool0003o0000o`020000o`050?ooo`000?l0003o0000o`3oool00`000?l20?ooo`<0
003o00<0oooo0000o`000?l00`000?l40?ooo`<0003o0P3oool90000o`040?ooo`000?l0003o0000
obT0oooo0`000?lJ0?ooo`@0003o1@3oool30000o`<0oooo2@000?l60?ooo`H0003o0P3oool:0000
o`L0oooo0`000?l20?ooo`<0003o1@3oool40000o`@0oooo0`000?l30?ooo`X0003o203oool50000
oa40oooo0`000?l0103oool0003o0000o`000?lE0?ooo`P0003o2`3oool90000oa@0oooo00<00000
0?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02P3oool50000o`H0oooo10000?l20?oo
o`H0003o1`3oool30000o`<0oooo0`000?l00`3oool0003o0000o`020000o`050?ooo`000?l0003o
0000o`3oool00`000?l20?ooo`<0003o00<0oooo0000o`000?l00`000?l40?ooo`<0003o0P3oool9
0000o`040?ooo`000?l0003o0000obT0oooo0`000?lJ0?ooo`@0003o1@3oool30000o`<0oooo2@00
0?l60?ooo`H0003o0P3oool90000o`P0oooo0`000?l20?ooo`<0003o1@3oool40000o`@0oooo0`00
0?l30?ooo`X0003o203oool50000oa40oooo0`000?l0103oool0003o0000o`000?lE0?ooo`P0003o
2`3oool90000oa@0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02P3o
ool50000o`H0oooo0`000?l30?ooo`H0003o1`3oool30000o`<0oooo0`000?l00`3oool0003o0000
o`020000o`050?ooo`000?l0003o0000o`3oool00`000?l20?ooo`<0003o00<0oooo0000o`000?l0
0`000?l40?ooo`<0003o0P3oool90000o`040?ooo`000?l0003o0000obT0oooo0`000?lK0?ooo`<0
003o1@3oool30000o`<0oooo2@000?l60?ooo`H0003o0P3oool90000o`P0oooo0`000?l20?ooo`<0
003o1@3oool40000o`@0oooo0`000?l30?ooo`X0003o203oool50000oa40oooo0`000?l0103oool0
003o0000o`000?lE0?ooo`P0003o2`3oool90000oa@0oooo00<000000?ooo`3oool03`3oool00200
oooo00<000000?ooo`3oool02P3oool50000o`H0oooo0`000?l30?ooo`H0003o1`3oool30000o`<0
oooo0`000?l00`3oool0003o0000o`020000o`050?ooo`000?l0003o0000o`3oool00`000?l20?oo
o`<0003o00<0oooo0000o`000?l00`000?l40?ooo`<0003o0P3oool90000o`040?ooo`000?l0003o
0000obT0oooo0`000?lK0?ooo`<0003o1@3oool30000o`<0oooo2@000?l60?ooo`H0003o0P3oool9
0000o`P0oooo0`000?l20?ooo`<0003o1@3oool40000o`@0oooo0`000?l30?ooo`L0003o2`3oool5
0000oa40oooo0`000?l0103oool0003o0000o`000?lE0?ooo`P0003o2`3oool90000oa@0oooo00<0
00000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02P3oool50000o`H0oooo0`000?l3
0?ooo`H0003o1`3oool30000o`<0oooo0`000?l00`3oool0003o0000o`020000o`050?ooo`000?l0
003o0000o`3oool00`000?l20?ooo`<0003o00<0oooo0000o`000?l00`000?l40?ooo`<0003o0P3o
ool90000o`040?ooo`000?l0003o0000obT0oooo0`000?lK0?ooo`<0003o1@3oool30000o`<0oooo
2@000?l60?ooo`H0003o0P3oool90000o`P0oooo0`000?l20?ooo`<0003o1@3oool40000o`@0oooo
0`000?l30?ooo`L0003o2`3oool50000oa40oooo1`000?lE0?ooo`<0003o00<0oooo0000o`000?l0
0P000?l;0?ooo`T0003o503oool00`000000oooo0?ooo`0?0?ooo`00803oool3000000X0oooo1@00
0?l60?ooo`<0003o0`3oool60000o`L0oooo0`000?l30?ooo`<0003o0P3oool30000o`050?ooo`00
0?l0003o0000o`3oool00`000?l20?ooo`<0003o00<0oooo0000o`000?l00`000?l40?ooo`<0003o
0P3oool=0000obT0oooo0`000?lS0?ooo`<0003o0P3oool:0000o`H0oooo1P000?l20?ooo`T0003o
203oool40000o`040?ooo`000?l0003o0000o`D0oooo10000?l40?ooo`<0003o0`3oool70000o``0
oooo10000?lA0?ooo`L0003o6@3oool40000o`/0oooo2@000?lC0?ooo`8000004@3oool00200oooo
00<000000?ooo`3oool02P3oool50000o`H0oooo0`000?l30?ooo`H0003o1`3oool30000o`<0oooo
0`000?l20?ooo`<0003o00D0oooo0000o`000?l0003o0?ooo`030000o`80oooo0`000?l00`3oool0
003o0000o`030000o`@0oooo0`000?l20?ooo`d0003o:@3oool30000ob<0oooo0`000?l20?ooo`X0
003o1P3oool60000o`80oooo2@000?l80?ooo`@0003o00@0oooo0000o`000?l0003o1@3oool40000
o`@0oooo0`000?l30?ooo`L0003o303oool40000oa80oooo1P000?lI0?ooo`@0003o2`3oool90000
oa@0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02P3oool50000o`H0
oooo0`000?l30?ooo`H0003o1`3oool30000o`<0oooo0`000?l20?ooo`<0003o00D0oooo0000o`00
0?l0003o0?ooo`030000o`80oooo0`000?l00`3oool0003o0000o`030000o`@0oooo0`000?l20?oo
o`d0003o:@3oool30000ob<0oooo0`000?l20?ooo`<0003o00<0oooo0000o`000?l010000?l60?oo
o`/0003o00<0oooo0000o`000?l00`000?l90?ooo`<0003o00@0oooo0000o`000?l0003o1@3oool4
0000o`@0oooo0`000?l30?ooo`L0003o303oool40000oa80oooo1P000?lI0?ooo`<0003o303oool9
0000oa@0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02P3oool50000
o`H0oooo0`000?l30?ooo`H0003o1`3oool30000o`<0oooo0`000?l20?ooo`<0003o00D0oooo0000
o`000?l0003o0?ooo`030000o`80oooo0`000?l00`3oool0003o0000o`030000o`@0oooo0`000?l2
0?ooo`d0003o:@3oool30000ob<0oooo0`000?l20?ooo`<0003o00<0oooo0000o`000?l010000?l6
0?ooo`/0003o00<0oooo0000o`000?l00`000?l90?ooo`<0003o00@0oooo0000o`000?l0003o1@3o
ool40000o`@0oooo0`000?l30?ooo`L0003o303oool40000oa80oooo1P000?lI0?ooo`<0003o303o
ool90000oa@0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02P3oool5
0000o``0oooo1P000?l70?ooo`<0003o0`3oool30000o`80oooo0`000?l01@3oool0003o0000o`00
0?l0oooo00<0003o0P3oool30000o`030?ooo`000?l0003o00<0003o103oool30000o`80oooo3@00
0?m?0?ooo`<0003o0P3oool30000o`030?ooo`000?l0003o00@0003o1P3oool:0000o`80oooo1@00
0?l90?ooo`<0003o00@0oooo0000o`000?l0003o1@3oool40000o`@0oooo0`000?l30?ooo`L0003o
303oool40000oa80oooo1P000?lI0?ooo`<0003o303oool90000oa@0oooo00<000000?ooo`3oool0
3`3oool00200oooo00<000000?ooo`3oool02P3oool50000o``0oooo1P000?l70?ooo`<0003o0`3o
ool30000o`80oooo0`000?l01@3oool0003o0000o`000?l0oooo00<0003o0P3oool30000o`030?oo
o`000?l0003o00<0003o103oool30000o`80oooo3@000?m?0?ooo`<0003o0P3oool30000o`030?oo
o`000?l0003o00@0003o1`3oool90000o`80oooo1@000?l90?ooo`<0003o00@0oooo0000o`000?l0
003o1P3oool30000o`@0oooo0`000?l30?ooo`L0003o303oool30000oa<0oooo1P000?lI0?ooo`<0
003o303oool90000oa@0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0
2P3oool50000o``0oooo1P000?l70?ooo`<0003o0`3oool30000o`H0oooo0`000?l0103oool0003o
0000o`000?l20?ooo`<0003o00<0oooo0000o`000?l00`000?l40?ooo`<0003o0P3oool=0000odl0
oooo0`000?l20?ooo`<0003o00<0oooo0000o`000?l00`000?l80?ooo`T0003o0P3oool50000o`T0
oooo0`000?l0103oool0003o0000o`000?l60?ooo`<0003o103oool30000o`<0oooo1`000?l<0?oo
o`<0003o4`3oool60000oaT0oooo0`000?l<0?ooo`T0003o503oool00`000000oooo0?ooo`0?0?oo
o`00803oool3000000/0oooo10000?l=0?ooo`@0003o203oool30000o`<0oooo0`000?l60?ooo`<0
003o00@0oooo0000o`000?l0003o0P3oool30000o`030?ooo`000?l0003o00<0003o103oool30000
o`80oooo1P000?l00`3oool0003o0000o`040000odl0oooo10000?l01@3oool0003o0000o`000?l0
oooo00D0003o203oool90000o`80oooo1@000?l90?ooo`L0003o1P3oool30000o`@0oooo0`000?l3
0?ooo`L0003o303oool30000oa<0oooo1P000?lI0?ooo`<0003o303oool90000oa<0oooo0P00000A
0?ooo`00803oool00`000000oooo0?ooo`0;0?ooo`@0003o3@3oool40000o`P0oooo0`000?l30?oo
o`<0003o1P3oool30000o`040?ooo`000?l0003o0000o`80oooo0`000?l00`3oool0003o0000o`03
0000o`@0oooo0`000?l20?ooo`H0003o0P3oool40000oe00oooo10000?l01@3oool0003o0000o`00
0?l0oooo00D0003o203oool90000o`80oooo1@000?l90?ooo`L0003o1P3oool30000o`@0oooo0`00
0?l30?ooo`L0003o303oool30000oa<0oooo1@000?lJ0?ooo`<0003o303oool90000oa@0oooo00<0
00000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02`3oool40000o`d0oooo10000?l8
0?ooo`<0003o0`3oool30000o`X0oooo0`000?l20?ooo`<0003o00<0oooo0000o`000?l00`000?l4
0?ooo`<0003o0P3oool60000o`80oooo10000?mA0?ooo`<0003o00D0oooo0000o`000?l0003o0?oo
o`050000o`P0oooo2@000?l20?ooo`D0003o2P3oool60000o`H0oooo0`000?l40?ooo`<0003o0`3o
ool70000o``0oooo0`000?lC0?ooo`D0003o6P3oool30000o``0oooo2@000?lD0?ooo`030000003o
ool0oooo00l0oooo000P0?ooo`030000003oool0oooo00/0oooo10000?l=0?ooo`@0003o203oool3
0000o`<0oooo0`000?l:0?ooo`<0003o0P3oool30000o`030?ooo`000?l0003o00<0003o103oool3
0000o`80oooo1P000?l20?ooo`@0003oD@3oool30000o`050?ooo`000?l0003o0000o`3oool01@00
0?l80?ooo`T0003o0P3oool50000o`X0oooo1P000?l60?ooo`<0003o103oool30000o`<0oooo1`00
0?l<0?ooo`<0003o4`3oool50000oaX0oooo0`000?l<0?ooo`T0003o503oool00`000000oooo0?oo
o`0?0?ooo`005`3oool3000000H0oooo00<000000?ooo`3oool02`3oool40000o`d0oooo10000?l8
0?ooo`T0003o2P3oool30000o`030?ooo`000?l0003o0080003o00<0oooo0000o`000?l00`000?l4
0?ooo`<0003o0P3oool30000o`D0oooo10000?mA0?ooo`<0003o00@0oooo0000o`000?l0003o0P3o
ool40000o`P0oooo2@000?l20?ooo`D0003o2P3oool60000o`d0oooo0`000?l30?ooo`L0003o8P3o
ool50000oaX0oooo0`000?l<0?ooo`T0003o503oool00`000000oooo0?ooo`0?0?ooo`00603oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00/0oooo10000?l=0?ooo`@0003o203oool9
0000o`X0oooo0`000?l00`3oool0003o0000o`020000o`030?ooo`000?l0003o00<0003o103oool3
0000o`80oooo0`000?l50?ooo`@0003oD@3oool30000o`040?ooo`000?l0003o0000o`80oooo1000
0?l;0?ooo`H0003o0P3oool50000o`X0oooo1@000?l>0?ooo`<0003o0`3oool70000ob80oooo1@00
0?lJ0?ooo`<0003o303oool90000oa@0oooo00<000000?ooo`3oool03`3oool001P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0;0?ooo`<0003o3P3oool40000o`P0oooo20000?l;
0?ooo`<0003o00@0oooo0000o`000?l0003o0P3oool50000o`@0oooo0`000?l20?ooo`<0003o1@3o
ool40000oe40oooo0`000?l0103oool0003o0000o`000?l20?ooo`@0003o2`3oool60000o`80oooo
1@000?l:0?ooo`D0003o3P3oool30000o`<0oooo1`000?lR0?ooo`D0003o6P3oool30000o``0oooo
2@000?lD0?ooo`030000003oool0oooo00l0oooo000H0?ooo`030000003oool0oooo00D0oooo1000
000:0?ooo`<0003o3P3oool40000o`P0oooo20000?l;0?ooo`<0003o00@0oooo0000o`000?l0003o
0P3oool50000o`@0oooo0`000?l20?ooo`<0003o1@3oool40000oe40oooo0`000?l0103oool0003o
0000o`000?l20?ooo`@0003o2`3oool60000o`80oooo1@000?l:0?ooo`D0003o3P3oool30000o`<0
oooo1`000?lR0?ooo`D0003o6P3oool30000o``0oooo2@000?lB0?ooo`<000004@3oool001P0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0;0?ooo`<0003o3P3oool40000o`T0oooo
1`000?l;0?ooo`<0003o00@0oooo0000o`000?l0003o0P3oool50000o`@0oooo0`000?l00`3oool0
003o0000o`020000o`H0oooo0`000?mA0?ooo`<0003o00@0oooo0000o`000?l0003o0P3oool40000
o`/0oooo1P000?l20?ooo`D0003o2P3oool50000o`h0oooo3@000?lR0?ooo`D0003o6P3oool30000
o`d0oooo20000?lD0?ooo`030000003oool0oooo00l0oooo000G0?ooo`8000001`3oool00`000000
oooo0?ooo`0;0?ooo`<0003o3P3oool40000o`T0oooo1`000?l;0?ooo`<0003o00@0oooo0000o`00
0?l0003o0P3oool50000o`@0oooo0`000?l00`3oool0003o0000o`020000o`H0oooo0`000?mA0?oo
o`<0003o00@0oooo0000o`000?l0003o0P3oool40000o`/0oooo1P000?l20?ooo`D0003o2`3oool4
0000o`h0oooo3@000?lR0?ooo`D0003o6P3oool30000o`d0oooo20000?lD0?ooo`030000003oool0
oooo00l0oooo000H0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool02`3oool30000
o`h0oooo10000?l90?ooo`L0003o2`3oool30000o`040?ooo`000?l0003o0000o`80oooo1@000?l4
0?ooo`<0003o00@0oooo0000o`000?l0003o1`3oool30000oe40oooo0`000?l0103oool0003o0000
o`000?l20?ooo`@0003o2`3oool60000o`80oooo1@000?l;0?ooo`@0003o3`3oool<0000ob<0oooo
10000?lZ0?ooo`P0003o503oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?oo
o`0;0?ooo`<0003o3P3oool40000o`T0oooo1`000?l;0?ooo`<0003o00@0oooo0000o`000?l0003o
0P3oool50000o`@0oooo0`000?l0103oool0003o0000o`000?l70?ooo`<0003oD@3oool30000o`04
0?ooo`000?l0003o0000o`80oooo10000?l;0?ooo`H0003o0P3oool50000o`/0oooo10000?l?0?oo
o``0003o8`3oool40000obX0oooo20000?lD0?ooo`030000003oool0oooo00l0oooo000P0?ooo`03
0000003oool0oooo00/0oooo0`000?l>0?ooo`@0003o2@3oool70000o`/0oooo0`000?l0103oool0
003o0000o`000?l20?ooo`D0003o103oool30000o`040?ooo`000?l0003o0000oe/0oooo0`000?l0
103oool0003o0000o`000?l20?ooo`@0003o2`3oool60000o`80oooo1@000?l;0?ooo`@0003o3`3o
ool;0000obD0oooo0`000?lZ0?ooo`P0003o503oool00`000000oooo0?ooo`0?0?ooo`00803oool0
0`000000oooo0?ooo`0;0?ooo`<0003o3P3oool40000o`T0oooo1`000?l;0?ooo`<0003o00@0oooo
0000o`000?l0003o0P3oool50000o`@0oooo0`000?l0103oool0003o0000o`000?mK0?ooo`<0003o
00@0oooo0000o`000?l0003o0P3oool40000o`/0oooo1P000?l20?ooo`D0003o2`3oool40000o`l0
oooo2`000?mB0?ooo`P0003o503oool00`000000oooo0?ooo`0?0?ooo`00803oool3000000/0oooo
0`000?l>0?ooo`@0003o2@3oool70000o`/0oooo0`000?l0103oool0003o0000o`000?l20?ooo`D0
003o103oool30000o`040?ooo`000?l0003o0000oe/0oooo0`000?l0103oool0003o0000o`000?l2
0?ooo`@0003o2`3oool60000o`80oooo1@000?l;0?ooo`@0003o3`3oool;0000oe80oooo20000?lC
0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool02`3oool30000o`h0oooo10000?l90?oo
o`L0003o2`3oool30000o`040?ooo`000?l0003o0000o`80oooo10000?l50?ooo`L0003oF`3oool3
0000o`040?ooo`000?l0003o0000o`80oooo10000?l;0?ooo`H0003o0P3oool50000o`/0oooo1000
0?l?0?ooo`/0003oDP3oool80000oa@0oooo00<000000?ooo`3oool03`3oool00200oooo00<00000
0?ooo`3oool02`3oool30000o`h0oooo10000?l90?ooo`L0003o2`3oool30000o`040?ooo`000?l0
003o0000o`80oooo10000?l50?ooo`L0003oF`3oool30000o`040?ooo`000?l0003o0000o`80oooo
10000?l;0?ooo`H0003o0P3oool50000o`/0oooo10000?l?0?ooo`/0003oDP3oool80000oa@0oooo
00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02`3oool30000o`h0oooo1000
0?l90?ooo`L0003o2`3oool30000o`040?ooo`000?l0003o0000o`80oooo10000?l60?ooo`H0003o
F`3oool30000o`040?ooo`000?l0003o0000o`80oooo10000?l;0?ooo`H0003o0P3oool50000o``0
oooo0`000?l?0?ooo`/0003oDP3oool80000oa@0oooo00<000000?ooo`3oool03`3oool00200oooo
00<000000?ooo`3oool02`3oool30000o`l0oooo0`000?l90?ooo`L0003o2`3oool30000o`040?oo
o`000?l0003o0000o`80oooo10000?l60?ooo`H0003oF`3oool30000o`040?ooo`000?l0003o0000
o`80oooo0`000?l<0?ooo`H0003o0P3oool50000o``0oooo0`000?l?0?ooo`/0003oDP3oool80000
oa@0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool02`3oool30000o`l0
oooo0`000?l90?ooo`L0003o2`3oool30000o`040?ooo`000?l0003o0000o`<0oooo0`000?l60?oo
o`H0003oF`3oool30000o`040?ooo`000?l0003o0000o`80oooo0`000?l<0?ooo`H0003o0P3oool5
0000o``0oooo0`000?l?0?ooo`/0003oDP3oool80000oa@0oooo00<000000?ooo`3oool03`3oool0
0200oooo0`00000;0?ooo`<0003o3`3oool30000o`T0oooo0`000?l0103oool0003o0000o`000?l;
0?ooo`<0003o00@0oooo0000o`000?l0003o0`3oool30000o`H0oooo1P000?mK0?ooo`<0003o00@0
oooo0000o`000?l0003o0P3oool30000o``0oooo1P000?l20?ooo`@0003o3@3oool30000o`l0oooo
2`000?mB0?ooo`P0003o4`3oool200000140oooo000P0?ooo`030000003oool0oooo00/0oooo0`00
0?l?0?ooo`<0003o2@3oool30000o`040?ooo`000?l0003o0000o`/0oooo0`000?l0103oool0003o
0000o`000?l30?ooo`<0003o1P3oool60000oe/0oooo0`000?l0103oool0003o0000o`000?l20?oo
o`<0003o303oool60000o`80oooo10000?lO0?ooo`/0003oDP3oool80000oa@0oooo00<000000?oo
o`3oool03`3oool00200oooo00<000000?ooo`3oool02`3oool30000o`l0oooo0`000?l90?ooo`<0
003o00@0oooo0000o`000?l0003o2`3oool30000o`040?ooo`000?l0003o0000o`<0oooo0`000?l6
0?ooo`H0003oF`3oool30000o`040?ooo`000?l0003o0000o`80oooo0`000?l=0?ooo`D0003o0`3o
ool30000oal0oooo2`000?mB0?ooo`P0003o503oool00`000000oooo0?ooo`0?0?ooo`00803oool0
0`000000oooo0?ooo`0;0?ooo`<0003o3`3oool30000o`T0oooo0`000?l?0?ooo`<0003o00@0oooo
0000o`000?l0003o0`3oool30000o`H0oooo1P000?mK0?ooo`<0003o00@0oooo0000o`000?l0003o
0P3oool30000o`d0oooo10000?l40?ooo`<0003o7`3oool;0000oeD0oooo1@000?lD0?ooo`030000
003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo00/0oooo0`000?l?0?ooo`<0003o2@3o
ool30000o`l0oooo0`000?l0103oool0003o0000o`000?l30?ooo`<0003o1P3oool60000oe/0oooo
0`000?l0103oool0003o0000o`000?l20?ooo`<0003o3@3oool40000o`@0oooo0`000?lO0?ooo`/0
003oE@3oool50000oa@0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0
2`3oool30000o`l0oooo0`000?lK0?ooo`<0003o00@0oooo0000o`000?l0003o0`3oool30000o`H0
oooo1P000?mK0?ooo`<0003o00@0oooo0000o`000?l0003o0P3oool30000o`d0oooo10000?l40?oo
o`<0003o7`3oool;0000oeD0oooo1@000?lD0?ooo`030000003oool0oooo00l0oooo000P0?ooo`03
0000003oool0oooo01d0oooo0`000?lK0?ooo`<0003o00@0oooo0000o`000?l0003o0`3oool30000
o`H0oooo1P000?mK0?ooo`<0003o00@0oooo0000o`000?l0003o0P3oool30000o`d0oooo10000?l4
0?ooo`<0003o7`3oool;0000oeD0oooo10000?lE0?ooo`030000003oool0oooo00l0oooo000P0?oo
o`<00000>`3oool30000o`040?ooo`000?l0003o0000o`<0oooo0`000?l60?ooo`H0003oF`3oool3
0000o`040?ooo`000?l0003o0000o`80oooo0`000?l=0?ooo`@0003o103oool30000oal0oooo2`00
0?mE0?ooo`@0003o503oool200000140oooo000P0?ooo`030000003oool0oooo03/0oooo0`000?l0
103oool0003o0000o`000?l30?ooo`<0003o1P3oool60000oe/0oooo0`000?l0103oool0003o0000
o`000?lB0?ooo`@0003o103oool30000ob40oooo1P000?mH0?ooo`@0003o5@3oool00`000000oooo
0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0k0?ooo`L0003o0`3oool30000o`H0oooo1P00
0?mK0?ooo`L0003o4P3oool40000o`@0oooo0`000?lR0?ooo`D0003oF03oool40000oaD0oooo00<0
00000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0>`3oool70000o`<0oooo0`000?l6
0?ooo`H0003oF`3oool70000oa80oooo10000?l40?ooo`<0003o8P3oool50000oeP0oooo10000?lE
0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03`0oooo1P000?l30?oo
o`<0003o1P3oool60000oe`0oooo1P000?lB0?ooo`<0003o1@3oool30000ob80oooo1@000?mH0?oo
o`@0003o5@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0l0?ooo`H0
003o0`3oool30000o`H0oooo1P000?mL0?ooo`H0003o4P3oool30000o`D0oooo0`000?lR0?ooo`D0
003oF03oool40000oaD0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0
?03oool60000o`<0oooo0`000?l60?ooo`H0003oG03oool60000oa80oooo0`000?l50?ooo`<0003o
8P3oool50000oeP0oooo10000?lE0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000?03o
ool60000o`<0oooo0`000?l60?ooo`H0003oG03oool60000oa80oooo0`000?l50?ooo`<0003o8P3o
ool40000oeT0oooo10000?lD0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0?03oool6
0000o``0oooo1P000?mL0?ooo`H0003o?`3oool40000oeT0oooo10000?lE0?ooo`030000003oool0
oooo00l0oooo000P0?ooo`030000003oool0oooo03`0oooo1P000?l<0?ooo`H0003oG03oool60000
ocl0oooo10000?mJ0?ooo`<0003o5@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000
oooo0?ooo`0l0?ooo`H0003o303oool60000oe`0oooo1P000?lo0?ooo`@0003oFP3oool30000oaD0
oooo00<000000?ooo`3oool03`3oool001H0oooo1@0000050?ooo`030000003oool0oooo03`0oooo
1P000?l<0?ooo`H0003oG03oool60000ocl0oooo10000?mJ0?ooo`<0003o5@3oool00`000000oooo
0?ooo`0?0?ooo`005`3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo03`0oooo
1P000?l<0?ooo`D0003oG@3oool60000ocl0oooo10000?mJ0?ooo`<0003o5@3oool00`000000oooo
0?ooo`0?0?ooo`00603oool00`000000oooo0?ooo`050?ooo`@00000>`3oool60000o``0oooo1@00
0?mM0?ooo`H0003o?`3oool40000oeX0oooo0`000?lC0?ooo`<000004@3oool001T0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`0l0?ooo`H0003o303oool50000oed0oooo1P000?lo
0?ooo`@0003oFP3oool30000oaD0oooo00<000000?ooo`3oool03`3oool001H0oooo00D000000?oo
o`3oool0oooo000000050?ooo`030000003oool0oooo03`0oooo1P000?l<0?ooo`D0003oG@3oool5
0000od00oooo10000?mJ0?ooo`<0003o5@3oool00`000000oooo0?ooo`0?0?ooo`005P3oool01@00
0000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0?03oool60000o``0oooo1@000?mM
0?ooo`D0003o@03oool40000oeX0oooo0`000?lE0?ooo`030000003oool0oooo00l0oooo000G0?oo
o`<000001P3oool00`000000oooo0?ooo`0l0?ooo`H0003o303oool50000oed0oooo1@000?m00?oo
o`@0003oFP3oool30000oaD0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3o
ool0?03oool60000o``0oooo1@000?mM0?ooo`D0003o@03oool40000oeX0oooo0`000?lE0?ooo`03
0000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03`0oooo1P000?l<0?ooo`D0003o
G@3oool50000od00oooo10000?mJ0?ooo`<0003o5@3oool00`000000oooo0?ooo`0?0?ooo`00803o
ool3000003`0oooo1P000?l<0?ooo`D0003oG@3oool50000od00oooo10000?mJ0?ooo`<0003o503o
ool200000140oooo000P0?ooo`030000003oool0oooo03`0oooo1P000?l<0?ooo`D0003oG@3oool5
0000od00oooo10000?mJ0?ooo`<0003o5@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`00
0000oooo0?ooo`0l0?ooo`H0003o303oool50000oed0oooo1@000?m00?ooo`@0003oFP3oool30000
oaD0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0?03oool60000o``0
oooo1@000?mN0?ooo`@0003o@03oool40000oeX0oooo0`000?lE0?ooo`030000003oool0oooo00l0
oooo000P0?ooo`030000003oool0oooo03`0oooo1P000?l<0?ooo`D0003oGP3oool40000od00oooo
10000?mJ0?ooo`<0003o5@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?oo
o`0l0?ooo`H0003o303oool50000oeh0oooo10000?m00?ooo`@0003oFP3oool30000oaD0oooo00<0
00000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0?03oool60000o``0oooo1@000?mN
0?ooo`@0003o@03oool40000oeX0oooo0`000?lE0?ooo`030000003oool0oooo00l0oooo000P0?oo
o`<00000?03oool60000o`d0oooo10000?mN0?ooo`@0003o@03oool40000oeX0oooo0`000?lD0?oo
o`8000004@3oool00200oooo00<000000?ooo`3oool0?03oool60000o`d0oooo10000?mN0?ooo`@0
003o@03oool40000oeX0oooo0`000?lE0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000
003oool0oooo03`0oooo1P000?l=0?ooo`@0003oGP3oool40000od00oooo10000?mJ0?ooo`<0003o
5@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0l0?ooo`H0003o3@3o
ool40000oeh0oooo10000?m00?ooo`@0003oFP3oool30000oaD0oooo00<000000?ooo`3oool03`3o
ool00200oooo00<000000?ooo`3oool0?03oool60000o`d0oooo10000?mN0?ooo`@0003o@03oool4
0000oeX0oooo0`000?lE0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo
03`0oooo1@000?l>0?ooo`@0003oGP3oool40000od00oooo10000?mJ0?ooo`<0003o5@3oool00`00
0000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0l0?ooo`D0003o3P3oool40000oel0
oooo0`000?m00?ooo`@0003oFP3oool30000oaD0oooo00<000000?ooo`3oool03`3oool00200oooo
0`00000l0?ooo`D0003o3P3oool30000of00oooo0`000?m00?ooo`@0003oFP3oool30000oa@0oooo
0P00000A0?ooo`00803oool00`000000oooo0?ooo`0l0?ooo`D0003o3P3oool30000of00oooo0`00
0?m00?ooo`@0003oFP3oool30000oaD0oooo00<000000?ooo`3oool03`3oool00200oooo00<00000
0?ooo`3oool0?03oool50000o`h0oooo0`000?mP0?ooo`<0003o@03oool40000oeX0oooo0`000?lE
0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03`0oooo1@000?l>0?oo
o`<0003oH03oool30000od00oooo10000?mJ0?ooo`<0003o5@3oool00`000000oooo0?ooo`0?0?oo
o`00803oool00`000000oooo0?ooo`0l0?ooo`D0003o3P3oool30000oj@0oooo0`000?mJ0?ooo`<0
003o5@3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0l0?ooo`D0003o
3P3oool30000oj@0oooo0`000?mb0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000?03o
ool50000o`h0oooo0`000?nT0?ooo`<0003oL@3oool200000140oooo000P0?ooo`030000003oool0
oooo03`0oooo1@000?l>0?ooo`<0003oY03oool30000og80oooo00<000000?ooo`3oool03`3oool0
0200oooo00<000000?ooo`3oool0?03oool50000o`h0oooo0`000?nT0?ooo`<0003oLP3oool00`00
0000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0l0?ooo`D0003o3P3oool30000oj@0
oooo0`000?mb0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03`0oooo
1@000?l>0?ooo`<0003oY03oool30000og80oooo00<000000?ooo`3oool03`3oool001L0oooo0`00
00060?ooo`030000003oool0oooo03`0oooo1@000?ne0?ooo`<0003oLP3oool00`000000oooo0?oo
o`0?0?ooo`005P3oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0?03o
ool50000okD0oooo0`000?mb0?ooo`030000003oool0oooo00l0oooo000J0?ooo`030000003oool0
oooo00<0oooo1000000k0?ooo`D0003o]@3oool30000og00oooo0`00000A0?ooo`00603oool20000
00H0oooo00<000000?ooo`3oool0?03oool50000okD0oooo0`000?mb0?ooo`030000003oool0oooo
00l0oooo000J0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0?03oool50000okD0
oooo0`000?mb0?ooo`030000003oool0oooo00l0oooo000F0?ooo`050000003oool0oooo0?ooo`00
00001@3oool00`000000oooo0?ooo`0l0?ooo`D0003o]@3oool30000og80oooo00<000000?ooo`3o
ool03`3oool001L0oooo0`0000060?ooo`030000003oool0oooo03`0oooo1@000?ne0?ooo`<0003o
LP3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0l0?ooo`D0003o]@3o
ool30000og80oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0?@3oool4
0000okD0oooo0`000?mb0?ooo`030000003oool0oooo00l0oooo000P0?ooo`<00000?@3oool40000
okD0oooo0`000?ma0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0?@3oool40000okD0
oooo0`000?mb0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03d0oooo
10000?oo0?ooob/0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0?@3o
ool40000ool0oooo:`3oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0m
0?ooo`@0003oo`3oool[0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo
03d0oooo10000?oo0?ooob/0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3o
ool0?@3oool40000ool0oooo:`3oool00`000000oooo0?ooo`0?0?ooo`00803oool3000003d0oooo
10000?oo0?ooobX0oooo0P00000A0?ooo`00803oool00`000000oooo0?ooo`0m0?ooo`@0003oo`3o
ool[0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03d0oooo0`000?oo
0?ooob`0oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0?@3oool30000
ool0oooo;03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0m0?ooo`<0
003oo`3oool/0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03d0oooo
0`000?oo0?ooob`0oooo00<000000?ooo`3oool03`3oool00200oooo0`00000m0?ooo`<0003oo`3o
ool[0?ooo`8000004@3oool00200oooo00<000000?ooo`3oool0?@3oool30000ool0oooo;03oool0
0`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0m0?ooo`<0003oo`3oool/0?oo
o`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03d0oooo0`000?oo0?ooob`0
oooo00<000000?ooo`3oool03`3oool00200oooo00<000000?ooo`3oool0?@3oool30000ool0oooo
;03oool00`000000oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0m0?ooo`<0003oo`3o
ool/0?ooo`030000003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03d0oooo0`000?oo
0?ooob`0oooo00<000000?ooo`3oool03`3oool00200oooo0`00000m0?ooo`<0003oo`3oool[0?oo
o`8000004@3oool00200oooo00<000000?ooo`3oool0?@3oool30000ool0oooo;03oool00`000000
oooo0?ooo`0?0?ooo`00803oool00`000000oooo0?ooo`0m0?ooo`<0003oo`3oool/0?ooo`030000
003oool0oooo00l0oooo000P0?ooo`030000003oool0oooo03d0oooo0`000?oo0?ooob`0oooo00<0
00000?ooo`3oool03`3oool001P0oooo0`0000050?ooo`030000003oool0oooo0?l0ooooK03oool0
0`000000oooo0?ooo`0?0?ooo`006@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo
02h0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo
02l0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00l0oooo000F0?ooo`D000001@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00l0
oooo000F0?ooo`040000003oool0oooo000000H0ooooo`00001`00000140oooo000G0?ooo`030000
003oool000000?l0ooooQ`3oool001P0oooo0P00003o0?ooohL0oooo000I0?ooo`030000003oool0
oooo0?l0ooooQ@3oool00?l0ooooX@3oool00?l0ooooX@3oool00?l0ooooX@3oool00?l0ooooX@3o
ool009h0oooo1@0c<c<01@3oool0<c<c03<c<`0c<c<0oooo00D0<c<c00@0oooo03<c<`0c<c<0oooo
0`0c<c<40?ooo`0303<c<`3oool0oooo0080oooo100c<c<30?ooo`80<c<c0P3oool503<c<`80oooo
0`0c<c<20?ooo`<0<c<c00<0oooo03<c<`0c<c<0100c<c<80?ooo`<0<c<c0`3oool303<c<`@0oooo
0`0c<c<20?ooo`D0<c<c0P3oool303<c<`80oooo100c<c<20?ooo`@0<c<cTP3oool00:00oooo00<0
<c<c0?ooo`3oool00P3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0603<c<`3oool0oooo03<c<`3o
ool0<c<c0`3oool01@0c<c<0oooo0?ooo`3oool0<c<c00<0oooo00@0<c<c0?ooo`3oool0<c<c0`3o
ool0100c<c<0oooo0?ooo`0c<c<30?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3oool0100c<c<0
oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00<0oooo00<0<c<c0?ooo`3oool01P3oool00`0c
<c<0oooo0?ooo`030?ooo`0303<c<`3oool0oooo0080oooo00D0<c<c0?ooo`3oool0oooo03<c<`02
0?ooo`0603<c<`3oool0oooo03<c<`3oool0<c<c2@3oool00`0c<c<0oooo0?ooo`030?ooo`0303<c
<`3oool0oooo08l0oooo002P0?ooo`0303<c<`3oool0oooo0080oooo00@0<c<c0?ooo`3oool0<c<c
0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`<0oooo00H0<c<c0?ooo`3oool0<c<c0?ooo`0c
<c<30?ooo`<0<c<c0`3oool00`0c<c<0oooo0?ooo`040?ooo`0503<c<`3oool0oooo0?ooo`0c<c<0
0`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00<0<c<c0`3oool403<c<`80
oooo00<0<c<c0?ooo`3oool00`3oool00`0c<c<0oooo0?ooo`020?ooo`0503<c<`3oool0oooo0?oo
o`0c<c<00`3oool0100c<c<0oooo0?ooo`3oool503<c<`80oooo0`0c<c<30?ooo`<0<c<cTP3oool0
0:00oooo00<0<c<c0?ooo`3oool00P3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0603<c<`3oool0
oooo03<c<`3oool0<c<c0`3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`80oooo00@0<c<c0?oo
o`3oool0<c<c0`3oool00`0c<c<0oooo0?ooo`040?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3o
ool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0<c<c00`0oooo0`0c<c<30?ooo`80<c<c
0`3oool01`0c<c<0oooo0?ooo`3oool0<c<c0?ooo`0c<c<00P3oool0100c<c<0oooo0?ooo`0c<c<3
0?ooo`0303<c<`3oool0<c<c00D0oooo00<0<c<c0?ooo`3oool0T`3oool00:00oooo00@0<c<c0?oo
o`3oool0oooo100c<c<20?ooo`@0<c<c0`3oool303<c<`80oooo0P0c<c<00`3oool0<c<c03<c<`02
0?ooo`80<c<c0`3oool403<c<`80oooo0`0c<c<40?ooo`<0<c<c0P3oool403<c<`<0oooo100c<c<8
0?ooo`0503<c<`3oool0oooo03<c<`3oool00P0c<c<00`3oool0<c<c03<c<`020?ooo`<0<c<c0P3o
ool503<c<`80oooo0`0c<c<30?ooo`@0<c<c0P3oool403<c<i40oooo002P0?ooo`0303<c<`3oool0
oooo0200oooo00<0<c<c0?ooo`3oool08@3oool0100c<c<0oooo0?ooo`0c<c>e0?ooo`00WP3oool5
03<c<b00oooo00<0<c<c0?ooo`3oool0103oool00`0c<c<0oooo0?ooo`0I0?ooo`@0<c<c]P3oool0
0?l0ooooX@3oool00?l0ooooX@3oool00001\
\>"],
  ImageRangeCache->{{{0, 415}, {256.125, 0}} -> {-20.8652, -3.11753, \
0.502532, 0.0297364}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{31, 2}\),
      SequenceForm[ "Dimension der Daten  ", {31, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.00793651 0.031746 0.309017 0.309017 [
[.15079 -0.0125 -3 -9 ]
[.15079 -0.0125 3 0 ]
[.30952 -0.0125 -6 -9 ]
[.30952 -0.0125 6 0 ]
[.46825 -0.0125 -6 -9 ]
[.46825 -0.0125 6 0 ]
[.62698 -0.0125 -6 -9 ]
[.62698 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.94444 -0.0125 -6 -9 ]
[.94444 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -30 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -24 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -30 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -24 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -18 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -24 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -137 0 ]
[.5 .63053 137 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
0 .3548 m
1 .3548 L
s
0 .26323 m
1 .26323 L
s
0 g
.15079 0 m
.15079 .00625 L
s
[(5)] .15079 -0.0125 0 1 Mshowa
.30952 0 m
.30952 .00625 L
s
[(10)] .30952 -0.0125 0 1 Mshowa
.46825 0 m
.46825 .00625 L
s
[(15)] .46825 -0.0125 0 1 Mshowa
.62698 0 m
.62698 .00625 L
s
[(20)] .62698 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(25)] .78571 -0.0125 0 1 Mshowa
.94444 0 m
.94444 .00625 L
s
[(30)] .94444 -0.0125 0 1 Mshowa
.125 Mabswid
.02381 0 m
.02381 .00375 L
s
.05556 0 m
.05556 .00375 L
s
.0873 0 m
.0873 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.18254 0 m
.18254 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.24603 0 m
.24603 .00375 L
s
.27778 0 m
.27778 .00375 L
s
.34127 0 m
.34127 .00375 L
s
.37302 0 m
.37302 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.43651 0 m
.43651 .00375 L
s
.5 0 m
.5 .00375 L
s
.53175 0 m
.53175 .00375 L
s
.56349 0 m
.56349 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.65873 0 m
.65873 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.72222 0 m
.72222 .00375 L
s
.75397 0 m
.75397 .00375 L
s
.81746 0 m
.81746 .00375 L
s
.84921 0 m
.84921 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.9127 0 m
.9127 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-0.75)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-0.5)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-0.25)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(0.25)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(0.5)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(0.75)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(1)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.15079 .61178 m
.15079 .61803 L
s
.30952 .61178 m
.30952 .61803 L
s
.46825 .61178 m
.46825 .61803 L
s
.62698 .61178 m
.62698 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.94444 .61178 m
.94444 .61803 L
s
.125 Mabswid
.02381 .61428 m
.02381 .61803 L
s
.05556 .61428 m
.05556 .61803 L
s
.0873 .61428 m
.0873 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.18254 .61428 m
.18254 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.24603 .61428 m
.24603 .61803 L
s
.27778 .61428 m
.27778 .61803 L
s
.34127 .61428 m
.34127 .61803 L
s
.37302 .61428 m
.37302 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.43651 .61428 m
.43651 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.53175 .61428 m
.53175 .61803 L
s
.56349 .61428 m
.56349 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.65873 .61428 m
.65873 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.72222 .61428 m
.72222 .61803 L
s
.75397 .61428 m
.75397 .61803 L
s
.81746 .61428 m
.81746 .61803 L
s
.84921 .61428 m
.84921 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.9127 .61428 m
.9127 .61803 L
s
.97619 .61428 m
.97619 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -198 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(Autokorrelation) show
159.000 13.000 moveto
(der) show
183.000 13.000 moveto
(Innovation) show
243.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(:) show
255.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(C) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
261.000 13.000 moveto
(H) show
267.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(t) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
273.000 13.000 moveto
(L) show
279.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(C) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
285.000 13.000 moveto
(H) show
291.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(0) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
297.000 13.000 moveto
(L) show
303.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(^) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
309.000 13.000 moveto
(H) show
315.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(-) show
321.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
327.000 13.000 moveto
(L) show
333.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.200 0.200 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.97619 .27101 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .61803 m
.05556 .30737 L
.0873 .30343 L
.11905 .29984 L
.15079 .34743 L
.18254 .31536 L
.21429 .32106 L
.24603 .28779 L
.27778 .3334 L
.30952 .34892 L
.34127 .3344 L
.37302 .35847 L
.40476 .34542 L
.43651 .30871 L
.46825 .30101 L
.5 .30813 L
.53175 .28882 L
.56349 .33553 L
.59524 .28529 L
.62698 .2999 L
.65873 .29324 L
.69048 .29 L
.72222 .33707 L
.75397 .31778 L
.78571 .31288 L
.81746 .30888 L
.84921 .27752 L
.88095 .255 L
.9127 .31346 L
.94444 .2914 L
.97619 .27101 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{416, 257.125},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006P00010B000`400?l00000o`00003oo`3ooonQ
0?ooo`00G`3oool3000003@0oooo0`0000040?ooo`800000<@3oool3000000<0oooo0`00000`0?oo
o`D000000`3oool200000300oooo1@0000020?ooo`<00000<@3oool3000000@0oooo0P00000I0?oo
o`00GP3oool01@000000oooo0?ooo`3oool0000003@0oooo00<000000?ooo`3oool00P3oool01000
0000oooo0?ooo`00000a0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?oo
o`0^0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000<03oool01P000000
oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`3oool0;@3oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool00000603oool00680oooo00<000000?ooo`3oool0<P3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000340oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
0000<@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0340oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`0F0?ooo`00HP3oool00`000000oooo0?ooo`0b0?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool00000<@3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo0300oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0
oooo0300oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0_0?ooo`8000000`3oool0
10000000oooo0?ooo`00000H0?ooo`00GP3oool4000003D0oooo00<000000?ooo`3oool00P3oool0
10000000oooo0?ooo`00000a0?ooo`040000003oool0oooo0?ooo`@00000<03oool01@000000oooo
0?ooo`3oool000000080oooo00@000000?ooo`3oool00000;`3oool01P000000oooo0?ooo`3oool0
00000?ooo`@00000=03oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01H0oooo
001N0?ooo`030000003oool0oooo03D0oooo0P0000040?ooo`040000003oool0oooo00000300oooo
0P0000030?ooo`030000003oool0oooo0340oooo00D000000?ooo`3oool0oooo000000020?ooo`04
0000003oool0oooo000002l0oooo00L000000?ooo`3oool0oooo0000003oool0000003<0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo000001P0oooo001N0?ooo`D00000
=03oool00`000000oooo0?ooo`030?ooo`800000<P3oool010000000oooo0?ooo`3oool500000300
oooo0`0000040?ooo`800000<@3oool300000080oooo1@00000`0?ooo`<00000103oool2000001T0
oooo003o0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo003o0?oooj40oooo003o0?oooj40
oooo003o0?oooj40oooo000Y0?ooool00000L00000080?ooo`00:@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?oo
o`3oool0=@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo00<000000?oo
o`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo00<000000?oo
o`3oool04@3oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0
oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000
003oool0oooo00H0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?oo
o`060?ooo`00:@3oool300000?l0ooooJ`3oool2000000P0oooo000Y0?ooo`030000003oool0oooo
0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0
oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000
003oool0oooo00H0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?oo
o`060?ooo`00:@3oool300000?l0ooooJ`3oool2000000P0oooo000Y0?ooo`030000003oool0oooo
0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0
oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000
003oool0oooo00H0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?oo
o`060?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool0
02T0oooo0`00003o0?ooof/0oooo0P0000080?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0
oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000
003oool0oooo00H0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?oo
o`060?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool0
02T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`<0
0000o`3ooom[0?ooo`800000203oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000
003oool0oooo00H0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?oo
o`060?ooo`003`3oool2000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`02
0?ooo`<000001P3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool0
00h0oooo00@000000?ooo`3oool000002@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3o
ool000L0oooo1@0000020?ooo`040000003oool0oooo000000X0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`030?ooo`@00000o`3ooomY0?ooo`<00000203oool000h0oooo00@00000
0?ooo`3oool000002P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000>0?ooo`040000003oool0
oooo000000/0oooo00<000000?ooo`0000000`0000060?ooo`030000003oool0oooo0?l0ooooK03o
ool00`000000oooo0?ooo`060?ooo`003P3oool010000000oooo0?ooo`0000070?ooo`070000003o
ool0oooo0?ooo`000000oooo000000090?ooo`030000003oool0oooo0?l0ooooK03oool00`000000
oooo0?ooo`060?ooo`003`3oool2000000P0oooo1@0000000`3oool0000000000003000000D0oooo
00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000003o
ool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`00:@3oool300000?l0ooooJ`3oool2
000000P0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?oo
o`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0oooo
00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000003o
ool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`00:@3oool300000?l0ooooJ`3oool2
000000P0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?oo
o`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0oooo
00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000003o
ool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`3o
0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0oooo0`00003o0?ooof/0oooo0P0000080?oo
o`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0oooo
00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000003o
ool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`3o
0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?oo
o`030000003oool0oooo00H0oooo000Y0?ooo`<00000o`3ooom[0?ooo`800000203oool002T0oooo
00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000003o
ool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`005@3oool2000000@0oooo00<00000
0?ooo`3oool00P3oool3000000H0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0
oooo00H0oooo000D0?ooo`040000003oool0oooo000000L0oooo00D000000?ooo`3oool0oooo0000
00050?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`003@3oool5
00000080oooo00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`030?ooo`@00000o`3o
oomY0?ooo`<00000203oool001@0oooo00@000000?ooo`3oool000002`3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`00503oool0
10000000oooo0?ooo`0000070?ooo`@000001P3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<0
00000?ooo`3oool01P3oool001@0oooo00@000000?ooo`3oool000001`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`005@3oool2
000000P0oooo1@0000050?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`06
0?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0
oooo0`00003o0?ooof/0oooo0P0000080?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo
00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003o
ool0oooo00H0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`06
0?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0
oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`<00000
o`3ooom[0?ooo`800000203oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003o
ool0oooo00H0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`06
0?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0
oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`<00000
o`3ooom[0?ooo`800000203oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003o
ool0oooo00H0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`06
0?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool002T0
oooo00<000000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000
003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`060?ooo`00:@3oool300000?l0ooooJ`3o
ool2000000P0oooo000Y0?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`06
0?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool000l0
oooo0P0000040?ooo`040000003oool0oooo0?ooo`D000000P3oool3000000H0oooo00<000000?oo
o`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000>0?ooo`040000003oool0oooo0000
00P0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo00070?ooo`D000000P3oool0
10000000oooo0?ooo`0000090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`3o0?ooof`0oooo00<000000?ooo`3oool01P3oool000h0oooo00@00000
0?ooo`3oool000002P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo1000
003o0?ooofT0oooo0`0000080?ooo`003P3oool010000000oooo0?ooo`0000070?ooo`060000003o
ool0oooo0?ooo`000000oooo100000060?ooo`030000003oool0oooo0?l0ooooK03oool00`000000
oooo0?ooo`060?ooo`003P3oool010000000oooo0?ooo`0000070?ooo`070000003oool0oooo0?oo
o`000000oooo000000090?ooo`030000003oool0oooo0?l0ooooK03oool00`000000oooo0?ooo`06
0?ooo`003`3oool2000000T0oooo0`0000020?ooo`D000001@3oool00`000000oooo0?ooo`3o0?oo
of`0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`03
0000003oool0oooo00H0oooo000Y0?ooo`<00000o`3ooom[0?ooo`800000203oool002T0oooo00<0
00000?ooo`3oool0o`3ooom/0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000003oool0
oooo0?l0oooo?`3oool40000obT0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?oo
o`3oool0o`3oooln0?ooo`D0003o:@3oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000
oooo0?ooo`3o0?oooc`0oooo20000?lX0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000
003oool0oooo0?l0oooo>`3oool90000obP0oooo00<000000?ooo`3oool01P3oool002T0oooo0`00
003o0000OcT0001o1`000?l00`0007l0003o0000o`020000obH0001o0P0000080?ooo`00:@3oool0
0`000000oooo0?ooo`3o0?ooocP0oooo1P000?l30?ooo`@0003o9`3oool00`000000oooo0?ooo`06
0?ooo`00:@3oool00`000000oooo0?ooo`3o0?ooocH0oooo1`000?l50?ooo`@0003o6`3oool40000
o`L0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0o`3ooole0?ooo`H0
003o1`3oool40000oaX0oooo1@000?l70?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000
003oool0oooo0?l0oooo=03oool60000o`T0oooo10000?lG0?ooo`L0003o1`3oool00`000000oooo
0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`3o0?oooc<0oooo1@000?l;0?ooo`@0003o5@3o
ool70000o`T0oooo00<000000?ooo`3oool01P3oool002T0oooo0`00003o0?oooc80oooo1@000?l=
0?ooo`@0003o4`3oool70000o`T0oooo0P0000080?ooo`00:@3oool00`000000oooo0?ooo`3F0?oo
o`@0003oEP3oool50000o`h0oooo10000?lA0?ooo`L0003o303oool00`000000oooo0?ooo`060?oo
o`00:@3oool00`000000oooo0?ooo`1F0?ooo`<0003oO@3oool60000oe<0oooo1@000?l@0?ooo`@0
003o3`3oool60000o`h0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0
EP3oool30000ofD0oooo10000?lC0?ooo`T0003o5@3oool90000oc80oooo1@000?lA0?ooo`@0003o
3@3oool70000o`l0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0E@3o
ool50000of80oooo1P000?lB0?ooo``0003o2`3ooolA0000oc40oooo1@000?lC0?ooo`@0003o2`3o
ool60000oa40oooo00<000000?ooo`3oool01P3oool002T0oooo0`00001D0?ooo`L0003oH03oool8
0000oa40oooo10000?l20?ooo`P0003o1@3ooolF0000obl0oooo1@000?lD0?ooo`@0003o2P3oool6
0000oa40oooo0P0000080?ooo`00:@3oool00`000000oooo0?ooo`1C0?ooo`P0003oGP3oool;0000
o`l0oooo10000?l50?oooaT0003o103oool50000obd0oooo1@000?lF0?ooo`@0003o1`3oool60000
oa@0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool08P3oool90000obL0
oooo1@000?l00`3oool0003o0000o`020000odX0oooo1`000?l:0?ooo`L0003o0P3oool40000o`l0
oooo10000?l70?ooo`l0003o3@3oool40000ob`0oooo1@000?lG0?ooo`@0003o1P3oool60000oaD0
oooo00<000000?ooo`3oool01P3oool00240oooo0P0000060?ooo`030000003oool0oooo01L0oooo
50000?lV0?ooo`D0003o0P3oool50000odD0oooo3`000?l50?ooo`L0003o103oool40000o`d0oooo
10000?l:0?ooo`T0003o4P3oool40000obX0oooo1@000?lI0?ooo`@0003o103oool60000oaH0oooo
00<000000?ooo`3oool01P3oool00200oooo00@000000?ooo`3oool000001@3oool00`000000oooo
0?ooo`0A0?oooa/0003o903oool50000o`@0oooo1@000?m00?oooad0003o1P3oool50000o`/0oooo
1@000?l<0?ooo`@0003o5@3oool50000obP0oooo1@000?lJ0?ooo`@0003o0P3oool60000oaP0oooo
00<000000?ooo`3oool01P3oool00200oooo00@000000?ooo`3oool000001@3oool00`000000oooo
0?ooo`0A0?oooa<0003o103oool50000ob80oooo1@000?l60?ooo`@0003o?P3oool<0000o`<0oooo
3P000?l90?ooo`@0003o2`3oool40000obL0oooo10000?lR0?ooo`X0003o703oool:0000oaT0oooo
00<000000?ooo`3oool01P3oool00200oooo00@000000?ooo`3oool000001@3oool400000100oooo
20000?l@0?ooo`@0003o8@3oool50000o`P0oooo10000?lm0?ooo`P0003o2`3oool90000o`/0oooo
10000?l90?ooo`@0003o:@3oool40000oaP0oooo4P000?lM0?ooo`T0003o603oool3000000P0oooo
000P0?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool04@3oool30000oaH0oooo
10000?lA0?ooo`H0003o203oool50000o`T0oooo1@000?lk0?ooo`D0003o4P3oool40000o`d0oooo
1@000?l70?ooo`D0003o:@3oool50000oa40oooo5`000?lO0?ooo`H0003o703oool00`000000oooo
0?ooo`060?ooo`00803oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo0140oooo
0`000?lF0?ooo`D0003o403oool<0000o`030?ooo`000?l0003o00<0003o2`3oool40000ocX0oooo
1@000?lU0?ooo`@0003o1`3oool40000ob/0oooo10000?l=0?oooaD0003o9@3oool50000oad0oooo
00<000000?ooo`3oool01P3oool00240oooo0P0000060?ooo`030000003oool0oooo0140oooo0`00
0?lG0?ooo`D0003o3P3ooolB0000o`d0oooo10000?lh0?ooo`D0003o9`3oool40000o`D0oooo1000
0?l]0?ooo`@0003o2P3oool>0000obl0oooo0`000?lN0?ooo`030000003oool0oooo00H0oooo000Y
0?ooo`030000003oool0oooo0100oooo10000?lH0?ooo`@0003o3@3oool50000o`030?ooo`000?l0
003o00X0003o3P3oool50000ocH0oooo1@000?lX0?ooo`@0003o103oool50000obd0oooo10000?l9
0?ooo`T0003oEP3oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`0@0?oo
o`@0003o6@3oool40000o`/0oooo1@000?l80?ooo`D0003o403oool50000oc@0oooo1@000?lZ0?oo
o`@0003o0`3oool40000obl0oooo10000?l60?ooo`L0003oFP3oool00`000000oooo0?ooo`060?oo
o`00:@3oool300000100oooo0`000?lJ0?ooo`D0003o2@3oool50000oal0oooo10000?lc0?ooo`D0
003o:`3oool50000o`030?ooo`000?l0003o0080003o<03oool50000o`<0oooo1`000?mK0?ooo`80
0000203oool002T0oooo00<000000?ooo`3oool0403oool30000oa/0oooo10000?l80?ooo`D0003o
8@3oool40000oc40oooo1@000?l]0?ooo`@0003o00<0oooo0000o`000?l00P000?la0?ooo`@0003o
0P3oool70000oed0oooo00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool0403o
ool30000oa`0oooo10000?l60?ooo`D0003o8P3oool60000oa80oooo1@000?lG0?ooo`D0003o;`3o
ool70000oc<0oooo2P000?mO0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000003oool0
oooo0100oooo0`000?lL0?ooo`D0003o103oool50000ob@0oooo1`000?l>0?ooo`P0003o5@3oool5
0000oc00oooo1`000?lc0?ooo`P0003oH@3oool00`000000oooo0?ooo`060?ooo`00:@3oool00`00
0000oooo0?ooo`0@0?ooo`<0003o7@3oool50000o`80oooo1@000?lV0?ooo`P0003o2P3oool;0000
oa<0oooo1@000?lb0?ooo`D0003o=@3oool60000of80oooo00<000000?ooo`3oool01P3oool002T0
oooo0`00000@0?ooo`<0003o7P3oool40000o`030?ooo`000?l0003o00<0003o:@3oool80000o`L0
oooo1`000?l00`3oool0003o0000o`040000oa00oooo1@000?ld0?ooo`<0003o=`3oool30000of<0
oooo0P0000080?ooo`00:@3oool00`000000oooo0?ooo`0@0?ooo`<0003o7`3oool80000ob`0oooo
20000?l30?ooo`L0003o103oool60000o`d0oooo1P000?oF0?ooo`030000003oool0oooo00H0oooo
000Y0?ooo`030000003oool0oooo00l0oooo10000?lO0?ooo`L0003o;`3oool>0000o`L0oooo1P00
0?l:0?ooo`L0003oe`3oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`0?
0?ooo`@0003o803oool50000oc80oooo2`000?l:0?ooo`H0003o1@3oool90000omP0oooo00<00000
0?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool03`3oool30000ob80oooo0`000?le0?oo
o`L0003o3@3oool60000o`80oooo2@000?oJ0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`03
0000003oool0oooo00l0oooo0`000?mL0?ooo`<0003o403oool>0000om`0oooo00<000000?ooo`3o
ool01P3oool002T0oooo0`00000?0000O`<0003oL@0007l90000omh0001o0P0000080?ooo`00:@3o
ool00`000000oooo0?ooo`0?0?ooo`<0003oLP3oool60000on40oooo00<000000?ooo`3oool01P3o
ool002T0oooo00<000000?ooo`3oool03`3oool30000og<0oooo0`000?oS0?ooo`030000003oool0
oooo00H0oooo000Y0?ooo`030000003oool0oooo00l0oooo0`000?oo0?oooeX0oooo00<000000?oo
o`3oool01P3oool002T0oooo00<000000?ooo`3oool03`3oool30000ool0ooooFP3oool00`000000
oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`0?0?ooo`<0003oo`3ooomJ0?ooo`030000
003oool0oooo00H0oooo000Y0?ooo`<000003P3oool40000ool0ooooF@3oool2000000P0oooo000Y
0?ooo`030000003oool0oooo00h0oooo10000?oo0?oooeX0oooo00<000000?ooo`3oool01P3oool0
02T0oooo00<000000?ooo`3oool03P3oool30000ool0ooooF`3oool00`000000oooo0?ooo`060?oo
o`003`3oool2000000@0oooo00@000000?ooo`3oool0oooo1@0000020?ooo`<000001P3oool00`00
0000oooo0?ooo`0>0?ooo`<0003oo`3ooomK0?ooo`030000003oool0oooo00H0oooo000>0?ooo`04
0000003oool0oooo000000P0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003o
ool0oooo00<0oooo00<000000?ooo`3oool03P3oool30000ool0ooooF`3oool00`000000oooo0?oo
o`060?ooo`003P3oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool00`3oool4000000d0oooo0`000?oo0?oooeT0oooo0`0000080?ooo`003P3oool0
10000000oooo0?ooo`00000:0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0>0?ooo`<0003oo`3ooomK0?ooo`030000003oool0oooo00H0oooo000>
0?ooo`040000003oool0oooo000000L0oooo00H000000?ooo`3oool0oooo0000003oool4000000H0
oooo00<000000?ooo`3oool03P3oool30000ool0ooooF`3oool00`000000oooo0?ooo`060?ooo`00
3P3oool010000000oooo0?ooo`0000070?ooo`070000003oool0oooo0?ooo`000000oooo00000009
0?ooo`030000003oool0oooo00h0oooo0`000?oo0?oooe/0oooo00<000000?ooo`3oool01P3oool0
00l0oooo0P0000090?ooo`<000000P3oool5000000D0oooo00<000000?ooo`3oool03@3oool40000
ool0ooooF`3oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`0=0?ooo`@0
003oo`3ooomK0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`<000003@3oool30000ool0oooo
F`3oool2000000P0oooo000Y0?ooo`030000003oool0oooo00d0oooo0`000?oo0?oooe`0oooo00<0
00000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool03@3oool30000ool0ooooG03oool0
0`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`0=0?ooo`<0003oo`3ooomL0?oo
o`030000003oool0oooo00H0oooo000Y0?ooo`030000003oool0oooo00d0oooo0`000?oo0?oooe`0
oooo00<000000?ooo`3oool01P3oool002T0oooo0`00000=0?ooo`<0003oo`3ooomK0?ooo`800000
203oool002T0oooo00<000000?ooo`3oool03@3oool30000ool0ooooG03oool00`000000oooo0?oo
o`060?ooo`00:@3oool00`000000oooo0?ooo`0=0?ooo`<0003oo`3ooomL0?ooo`030000003oool0
oooo00H0oooo000Y0?ooo`030000003oool0oooo00`0oooo10000?oo0?oooe`0oooo00<000000?oo
o`3oool01P3oool002T0oooo00<000000?ooo`3oool0303oool40000ool0ooooG03oool00`000000
oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`0<0?ooo`<0003oo`3ooomM0?ooo`030000
003oool0oooo00H0oooo000Y0?ooo`<00000303oool30000ool0ooooG03oool2000000P0oooo000Y
0?ooo`030000003oool0oooo00`0oooo0`000?oo0?oooed0oooo00<000000?ooo`3oool01P3oool0
02T0oooo00<000000?ooo`3oool0303oool30000ool0ooooG@3oool00`000000oooo0?ooo`060?oo
o`00:@3oool00`000000oooo0?ooo`0<0?ooo`<0003oo`3ooomM0?ooo`030000003oool0oooo00H0
oooo000Y0?ooo`030000003oool0oooo00`0oooo0`000?oo0?oooed0oooo00<000000?ooo`3oool0
1P3oool002T0oooo00<000000?ooo`3oool0303oool30000ool0ooooG@3oool00`000000oooo0?oo
o`060?ooo`00:@3oool3000000/0oooo10000?oo0?oooe`0oooo0P0000080?ooo`00:@3oool00`00
0000oooo0?ooo`0;0?ooo`@0003oo`3ooomM0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`03
0000003oool0oooo00/0oooo0`000?oo0?oooeh0oooo00<000000?ooo`3oool01P3oool001D0oooo
0P0000040?ooo`030000003oool0oooo0080oooo0`0000060?ooo`030000003oool0oooo00/0oooo
0`000?oo0?oooeh0oooo00<000000?ooo`3oool01P3oool001@0oooo00@000000?ooo`3oool00000
1`3oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool02`3oool30000ool0
ooooGP3oool00`000000oooo0?ooo`060?ooo`00503oool010000000oooo0?ooo`00000;0?ooo`03
0000003oool0oooo00<0oooo1000000:0?ooo`<0003oo`3ooomL0?ooo`<00000203oool001@0oooo
00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00/0
oooo0`000?oo0?oooeh0oooo00<000000?ooo`3oool01P3oool001@0oooo00@000000?ooo`3oool0
00001`3oool4000000H0oooo00<000000?ooo`3oool02`3oool30000ool0ooooGP3oool00`000000
oooo0?ooo`060?ooo`00503oool010000000oooo0?ooo`0000070?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool02`3oool30000ool0ooooGP3oool00`000000oooo0?ooo`060?ooo`00
5@3oool2000000P0oooo1@0000050?ooo`030000003oool0oooo00/0oooo0`000?oo0?oooeh0oooo
00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool02P3oool40000ool0ooooGP3o
ool00`000000oooo0?ooo`060?ooo`00:@3oool3000000X0oooo10000?oo0?oooed0oooo0P000008
0?ooo`00:@3oool00`000000oooo0?ooo`0:0?ooo`<0003oo`3ooomO0?ooo`030000003oool0oooo
00H0oooo000Y0?ooo`030000003oool0oooo00X0oooo0`000?oo0?oooel0oooo00<000000?ooo`3o
ool01P3oool002T0oooo00<000000?ooo`3oool02P3oool30000ool0ooooG`3oool00`000000oooo
0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`0:0?ooo`<0003oo`3ooomO0?ooo`030000003o
ool0oooo00H0oooo000Y0?ooo`030000003oool0oooo00X0oooo0`000?oo0?oooel0oooo00<00000
0?ooo`3oool01P3oool002T0oooo0`00000:0?ooo`<0003oo`3ooomN0?ooo`800000203oool002T0
oooo00<000000?ooo`3oool02P3oool30000ool0ooooG`3oool00`000000oooo0?ooo`060?ooo`00
:@3oool00`000000oooo0?ooo`090?ooo`@0003oo`3ooomO0?ooo`030000003oool0oooo00H0oooo
000Y0?ooo`030000003oool0oooo00T0oooo10000?oo0?oooel0oooo00<000000?ooo`3oool01P3o
ool002T0oooo00<000000?ooo`3oool02@3oool30000ool0ooooH03oool00`000000oooo0?ooo`06
0?ooo`00:@3oool3000000T0oooo0`000?oo0?oooel0oooo0P0000080?ooo`00:@3oool00`000000
oooo0?ooo`090?ooo`<0003oo`3ooomP0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000
003oool0oooo00T0oooo0`000?oo0?ooof00oooo00<000000?ooo`3oool01P3oool002T0oooo00<0
00000?ooo`3oool02@3oool30000ool0ooooH03oool00`000000oooo0?ooo`060?ooo`00:@3oool0
0`000000oooo0?ooo`090?ooo`<0003oo`3ooomP0?ooo`030000003oool0oooo00H0oooo000Y0?oo
o`030000003oool0oooo00T0oooo0`000?oo0?ooof00oooo00<000000?ooo`3oool01P3oool002T0
oooo0`0000090?ooo`<0003oo`3ooomO0?ooo`800000203oool002T0oooo00<000000?ooo`3oool0
203oool40000ool0ooooH03oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?oo
o`080?ooo`@0003oo`3ooomP0?ooo`030000003oool0oooo00H0oooo000?0?ooo`800000103oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0`0000060?ooo`030000003oool0
oooo00P0oooo0`000?oo0?ooof40oooo00<000000?ooo`3oool01P3oool000h0oooo00@000000?oo
o`3oool000002@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`080?ooo`<0003oo`3ooomQ0?ooo`030000003oool0oooo00H0oooo000>
0?ooo`040000003oool0oooo000000X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00P0oooo0`000?oo0?ooof40oooo00<000000?ooo`3oool01P3o
ool000h0oooo00@000000?ooo`3oool000002P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00<0oooo100000070?ooo`<0003oo`3ooomO0?ooo`<00000203oool000h0oooo00@00000
0?ooo`3oool000002`3oool00`000000oooo00000003000000H0oooo00<000000?ooo`3oool0203o
ool30000ool0ooooH@3oool00`000000oooo0?ooo`060?ooo`003P3oool010000000oooo0?ooo`00
00070?ooo`070000003oool0oooo0?ooo`000000oooo000000090?ooo`030000003oool0oooo00P0
oooo0`000?oo0?ooof40oooo00<000000?ooo`3oool01P3oool000l0oooo0P0000080?ooo`D00000
00<0oooo0000000000000`0000050?ooo`030000003oool0oooo00P0oooo0`000?oo0?ooof40oooo
00<000000?ooo`3oool01P3oool002T0oooo00<000000?ooo`3oool01`3oool40000ool0ooooH@3o
ool00`000000oooo0?ooo`060?ooo`00:@3oool3000000L0oooo10000?oo0?ooof00oooo0P000008
0?ooo`00:@3oool00`000000oooo0?ooo`070?ooo`<0003oo`3ooomR0?ooo`030000003oool0oooo
00H0oooo000Y0?ooo`030000003oool0oooo00L0oooo0`000?oo0?ooof80oooo00<000000?ooo`3o
ool01P3oool002T0oooo00<000000?ooo`3oool01`3oool30000ool0ooooHP3oool00`000000oooo
0?ooo`060?ooo`00:@3oool00`000000oooo0?ooo`070?ooo`<0003oo`3ooomR0?ooo`030000003o
ool0oooo00H0oooo000Y0?ooo`030000003oool0oooo00L0oooo0`000?oo0?ooof80oooo00<00000
0?ooo`3oool01P3oool002T0oooo0`0000070?ooo`<0003oo`3ooomQ0?ooo`800000203oool002T0
oooo00<000000?ooo`3oool01`3oool30000ool0ooooHP3oool00`000000oooo0?ooo`060?ooo`00
:@3oool00`000000oooo0?ooo`070?ooo`<0003oo`3ooomR0?ooo`030000003oool0oooo00H0oooo
000Y0?ooo`030000003oool0oooo00H0oooo10000?oo0?ooof80oooo00<000000?ooo`3oool01P3o
ool002T0oooo00<000000?ooo`3oool01P3oool40000ool0ooooHP3oool00`000000oooo0?ooo`06
0?ooo`00:@3oool00`000000oooo0?ooo`060?ooo`<0003oo`3ooomS0?ooo`030000003oool0oooo
00H0oooo000Y0?ooo`<000001P3oool30000ool0ooooHP3oool2000000P0oooo000Y0?ooo`030000
003oool0oooo00H0oooo0`000?oo0?ooof<0oooo00<000000?ooo`3oool01P3oool002T0oooo00<0
00000?ooo`3oool01P3oool30000ool0ooooH`3oool00`000000oooo0?ooo`060?ooo`00:@3oool0
0`000000oooo0?ooo`060?ooo`<0003oo`3ooomS0?ooo`030000003oool0oooo00H0oooo000Y0?oo
o`030000003oool0oooo00H0oooo0`000?oo0?ooof<0oooo00<000000?ooo`3oool01P3oool002T0
oooo0`0000060?ooo`<0003oo`3ooomR0?ooo`800000203oool002T0oooo00<000000?ooo`3oool0
1@3oool40000ool0ooooH`3oool00`000000oooo0?ooo`060?ooo`00:@3oool00`000000oooo0?oo
o`050?ooo`@0003oo`3ooomS0?ooo`030000003oool0oooo00H0oooo000P0?ooo`<000001P3oool0
0`000000oooo0?ooo`050?ooo`<0003oo`3ooomT0?ooo`030000003oool0oooo00H0oooo000Q0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool30000obd0oooo00<000000?oo
o`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo00<000000?oo
o`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool01P3oool00240oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`<0
003o2P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`060?ooo`008@3oool00`000000oooo0?ooo`050?ooo`P00000
0`000?oo000006D00000203oool00240oooo00<000000?ooo`3oool03@3oool30000ool0ooooK@3o
ool00200oooo0P00003o0?ooogl0oooo000Q0?ooo`030000003oool0oooo0?l0ooooO@3oool00?l0
ooooX@3oool00?l0ooooX@3oool00?l0oooo903oool00`0c<c<0oooo0?ooo`060?ooo`0303<c<`3o
ool0oooo00`0oooo00<0<c<c0?ooo`3oool01P3oool00`0c<c<0oooo0?ooo`0<0?ooo`0303<c<`3o
ool0oooo00`0oooo00<0<c<c0?ooo`3oool0>`3oool00?l0oooo8`3oool00`0c<c<0oooo0?ooo`08
0?ooo`0303<c<`3oool0oooo00X0oooo00<0<c<c0?ooo`3oool0203oool00`0c<c<0oooo0?ooo`0:
0?ooo`0303<c<`3oool0oooo00h0oooo00<0<c<c0?ooo`3oool0>P3oool005T0oooo0P0c<c<0103o
ool0<c<c03<c<`0c<c<20?ooo`80<c<c00@0oooo03<c<`3oool0oooo0P0c<c<30?ooo`<0<c<c0P3o
ool203<c<`030?ooo`0c<c<0<c<c0080oooo0`0c<c<20?ooo`<0<c<c0`3oool303<c<`@0oooo0`0c
<c<20?ooo`D0<c<c0P3oool403<c<`<0oooo0P0c<c<20?ooo`D0<c<c0P3oool303<c<`80oooo0`0c
<c<00`3oool0<c<c03<c<`070?ooo`@0<c<c0P3oool303<c<`80oooo0`0c<c<90?ooo`D0<c<c00D0
oooo03<c<`0c<c<0<c<c0?ooo`0503<c<`040?ooo`0c<c<0<c<c0?ooo`<0<c<c103oool00`0c<c<0
oooo0?ooo`020?ooo`@0<c<c0`3oool203<c<`80oooo1@0c<c<20?ooo`<0<c<c0P3oool303<c<`03
0?ooo`0c<c<0<c<c0080oooo00<0<c<c0?ooo`3oool02@3oool203<c<`@0oooo00<0<c<c0?ooo`3o
ool00`3oool203<c<`D0oooo00<0<c<c0?ooo`3oool00P3oool203<c<`@0oooo00<0<c<c0?ooo`3o
ool00`3oool203<c<`D0oooo00<0<c<c0?ooo`3oool0203oool00`0c<c<0oooo0?ooo`080?ooo`<0
<c<c1@3oool00`0c<c<0oooo0?ooo`0i0?ooo`00F@3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080
oooo00@0<c<c0?ooo`3oool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`<0oooo00H0
<c<c0?ooo`3oool0<c<c0?ooo`0c<c<20?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00P3oool00`0c
<c<0oooo0?ooo`030?ooo`0303<c<`3oool0oooo0080oooo00<0<c<c0?ooo`3oool01@3oool01@0c
<c<0oooo0?ooo`3oool0<c<c0080oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`0503<c<`3o
ool0oooo0?ooo`0c<c<00`3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00@0<c<c0?ooo`3o
ool0<c<c1`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00@0oooo00<0<c<c
0?ooo`3oool02P3oool00`0c<c<0oooo0?ooo`020?ooo`0403<c<`3oool0oooo03<c<`80oooo00H0
<c<c0?ooo`3oool0<c<c0?ooo`0c<c<30?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3oool0100c
<c<0oooo0?ooo`0c<c<30?ooo`0403<c<`3oool0oooo03<c<`<0oooo00D0<c<c0?ooo`3oool0oooo
03<c<`030?ooo`0403<c<`3oool0oooo03<c<`80oooo00<0<c<c0?ooo`3oool0303oool0100c<c<0
oooo0?ooo`0c<c<30?ooo`0303<c<`3oool0oooo0080oooo00@0<c<c0?ooo`3oool0<c<c103oool0
1@0c<c<0oooo0?ooo`3oool0<c<c0080oooo00D0<c<c0?ooo`3oool0oooo03<c<`040?ooo`0403<c
<`3oool0oooo03<c<`@0oooo00<0<c<c0?ooo`3oool0203oool00`0c<c<0oooo0?ooo`090?ooo`03
03<c<`3oool0oooo00@0oooo00<0<c<c0?ooo`3oool0>@3oool005T0oooo1@0c<c<20?ooo`0403<c
<`3oool0oooo03<c<`80oooo00<0<c<c0?ooo`3oool00P3oool01@0c<c<0oooo0?ooo`3oool0<c<c
0080oooo0P0c<c<30?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00P3oool00`0c<c<0oooo0?ooo`03
0?ooo`0303<c<`3oool0oooo0080oooo1@0c<c<30?ooo`0303<c<`3oool0oooo0080oooo0`0c<c<3
0?ooo`0303<c<`3oool0oooo00@0oooo00D0<c<c0?ooo`3oool0oooo03<c<`030?ooo`0403<c<`3o
ool0oooo03<c<`80oooo00<0<c<c0?ooo`3oool01@3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`D0
<c<c0P3oool00`0c<c<0oooo0?ooo`0:0?ooo`0303<c<`3oool0oooo0080oooo00@0<c<c0?ooo`3o
ool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c<`<0oooo00H0<c<c0?ooo`3oool0<c<c
0?ooo`0c<c<30?ooo`<0<c<c0`3oool00`0c<c<0oooo0?ooo`040?ooo`0503<c<`3oool0oooo0?oo
o`0c<c<00`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00/0oooo00<0<c<c
0?ooo`3oool01@3oool00`0c<c<0oooo0?ooo`020?ooo`0303<c<`3oool0oooo00D0oooo00@0<c<c
0?ooo`3oool0<c<c1`3oool00`0c<c<0oooo0?ooo`020?ooo`0403<c<`3oool0oooo03<c<`@0oooo
00<0<c<c0?ooo`3oool0203oool00`0c<c<0oooo0?ooo`020?ooo`@0<c<c0`3oool00`0c<c<0oooo
0?ooo`040?ooo`0303<c<`3oool0oooo03T0oooo001J0?ooo`0303<c<`3oool0<c<c00<0oooo00@0
<c<c0?ooo`3oool0<c<c0P3oool00`0c<c<0oooo0?ooo`020?ooo`0503<c<`3oool0oooo0?ooo`0c
<c<00P3oool00`0c<c<0oooo03<c<`020?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00P3oool203<c
<`@0oooo0P0c<c<30?ooo`0503<c<`3oool0oooo0?ooo`0c<c<00`3oool01@0c<c<0oooo0?ooo`3o
ool0<c<c0080oooo00D0<c<c0?ooo`3oool0oooo03<c<`060?ooo`0503<c<`3oool0oooo0?ooo`0c
<c<00`3oool0100c<c<0oooo0?ooo`0c<c<20?ooo`0303<c<`3oool0oooo00D0oooo00@0<c<c0?oo
o`3oool0<c<c0P3oool01@0c<c<0oooo0?ooo`3oool0<c<c0080oooo0P0c<c<;0?ooo`0303<c<`3o
ool0oooo0080oooo00@0<c<c0?ooo`3oool0<c<c0P3oool01P0c<c<0oooo0?ooo`0c<c<0oooo03<c
<`<0oooo00H0<c<c0?ooo`3oool0<c<c0?ooo`0c<c<20?ooo`0403<c<`3oool0oooo03<c<`<0oooo
00<0<c<c0?ooo`3oool0103oool01@0c<c<0oooo0?ooo`3oool0<c<c00<0oooo00@0<c<c0?ooo`3o
ool0<c<c0P3oool00`0c<c<0oooo0?ooo`0;0?ooo`0303<c<`3oool0oooo00D0oooo00<0<c<c0?oo
o`3oool00P3oool00`0c<c<0oooo0?ooo`050?ooo`0403<c<`3oool0oooo03<c<`L0oooo00<0<c<c
0?ooo`3oool00P3oool0100c<c<0oooo0?ooo`0c<c<40?ooo`0303<c<`3oool0oooo00P0oooo00<0
<c<c0?ooo`3oool02@3oool00`0c<c<0oooo0?ooo`040?ooo`0303<c<`3oool0oooo03T0oooo001J
0?ooo`0303<c<`3oool0<c<c0080oooo0P0c<c<0103oool0<c<c03<c<`3oool403<c<`<0oooo0`0c
<c<30?ooo`0403<c<`3oool0<c<c03<c<`80oooo0`0c<c<20?ooo`80<c<c00@0oooo03<c<`0c<c<0
oooo0P0c<c<00`3oool0<c<c03<c<`020?ooo`<0<c<c103oool00`0c<c<0oooo0?ooo`020?ooo`80
<c<c0`3oool403<c<`80oooo0`0c<c<40?ooo`<0<c<c0P3oool403<c<`T0oooo0`0c<c<30?ooo`<0
<c<c0P3oool203<c<`030?ooo`0c<c<0<c<c00T0oooo00@0<c<c0?ooo`3oool0oooo100c<c<20?oo
o`@0<c<c0`3oool303<c<`80oooo0P0c<c<00`3oool0<c<c03<c<`020?ooo`80<c<c0`3oool403<c
<`80oooo0`0c<c<40?ooo`<0<c<c0P3oool403<c<`@0oooo00<0<c<c0?ooo`3oool01`3oool00`0c
<c<0oooo0?ooo`060?ooo`0303<c<`3oool0oooo00@0<c<c103oool01@0c<c<0oooo0?ooo`3oool0
<c<c00P0oooo00D0<c<c0?ooo`3oool0oooo03<c<`020?ooo`0503<c<`3oool0oooo0?ooo`0c<c<0
103oool01@0c<c<0oooo0?ooo`3oool0<c<c00<0oooo00<0<c<c0?ooo`3oool0203oool00`0c<c<0
oooo0?ooo`030?ooo`0303<c<`3oool0oooo03X0oooo001K0?ooo`0303<c<`3oool0oooo00P0oooo
00<0<c<c0?ooo`3oool02@3oool00`0c<c<0oooo0?ooo`0L0?ooo`0303<c<`3oool0oooo00P0oooo
00<0<c<c0?ooo`3oool07@3oool00`0c<c<0oooo0?ooo`0D0?ooo`0303<c<`3oool0oooo0200oooo
00<0<c<c0?ooo`3oool08@3oool0100c<c<0oooo0?ooo`0c<c<50?ooo`0403<c<`3oool0oooo03<c
<`D0oooo00<0<c<c0?ooo`3oool00`3oool0100c<c<0oooo0?ooo`0c<c<50?ooo`0403<c<`3oool0
oooo03<c<`80oooo00@0<c<c0?ooo`3oool0<c<c1P3oool00`0c<c<0oooo03<c<`050?ooo`0303<c
<`3oool0oooo00H0oooo0P0c<c<40?ooo`0303<c<`3oool0oooo03/0oooo001J0?ooo`80<c<c2P3o
ool00`0c<c<0oooo0?ooo`080?ooo`80<c<c703oool303<c<`X0oooo00<0<c<c0?ooo`3oool0103o
ool00`0c<c<0oooo0?ooo`0E0?ooo`80<c<c503oool503<c<b00oooo00<0<c<c0?ooo`3oool0103o
ool00`0c<c<0oooo0?ooo`0K0?ooo`<0<c<c203oool00`0c<c<0oooo0?ooo`0:0?ooo`<0<c<c2@3o
ool203<c<`/0oooo00<0<c<c0?ooo`3oool03P3oool00`0c<c<0oooo0?ooo`100?ooo`00o`3ooonQ
0?ooo`00o`3ooonQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 415}, {256.125, 0}} -> {-3.35952, -1.12011, \
0.0861485, 0.00885023}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML estimation with missing data module MBFGS, same results", \
"Subsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[TextData[{
  "n = 1; (*time series data*)\nnp =1;\nT1 = Length[z];\nT = T1 - 1;\ndt = 1;\
\nk = 1;\np = 2;\nq = 1;\nX = Shape[1,{T1,q,n}];\nZ = Shape[z,{T1,k,n}]; ",
  StyleBox["(*see Manual.nb, data structures, old layer*)",
    FontColor->RGBColor[1, 0, 0]],
  "\nZ//Dimensions"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({176, 1, 1}\)], "Output"]
}, Open  ]],

Cell["\<\

NONLIN = 1;
EPS = 10.^-4;
KMAX = 20;
F0 = IdentityMatrix[5];
OPTION = 1;
MISS = -9;
theta0 = {-.3996 10,-.3772 10,18.7239}- .1 //N;
phi0 = {44.5186,26.4461}-.1 //N;
PRINT = {1,1,1,1,1,1,1,1};
Fisher = True;\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{THETA,PHI,COV,likpsi,KK} = 
\t\t\tMBFGS[theta0,phi0,F0,KMAX,EPS,Z,X,
\t\t\t\t\t\t\tk,p,q,n,np,T,dt,OPTION,NONLIN,MISS,PRINT];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL: MBFGS***************************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS\"\>", "\<\"K\"\>", \
"\<\"P\"\>", "\<\"Q\"\>", "\<\"N\"\>", "\<\"NP\"\>", "\<\"T\"\>", \
"\<\"DT\"\>", "\<\"OPTION\"\>", "\<\"NONLIN\"\>", "\<\"MISS\"\>", \
"\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>"},
          {"1", "20", "0.0001`", "1", "2", "1", "1", "1", "175", "1", "1", 
            "1", \(-9\), "10.`", "1.`*^-10", "1.`*^-6"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS", "K", "P", 
          "Q", "N", "NP", "T", "DT", "OPTION", "NONLIN", "MISS", "MAXSTEP", 
          "MINSTEP", "BOUND"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{\(-4.096`\), \
\(-3.872`\), 18.6239`}\),
      SequenceForm[ 
      "STARTWERT THETA0 = ", {-4.0960000000000001, -3.8719999999999999, 
        18.623899999999999}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT PHI0   = "\[InvisibleSpace]{44.4186`, 
          26.3461`}\),
      SequenceForm[ "STARTWERT PHI0   = ", {44.418599999999998, 26.3461}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("EIGENWERTE DER HESSE-MATRIX: "\[InvisibleSpace]{1, 
          1, 1, 1, 1}\),
      SequenceForm[ "EIGENWERTE DER HESSE-MATRIX: ", {1, 1, 1, 1, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("{MINI,COND,BOUND} = "\[InvisibleSpace]{1, 1, 
          1.`*^-6}\),
      SequenceForm[ "{MINI,COND,BOUND} = ", {1, 1, 9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"KONTROLLE\"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.6097479854361154`", "0.6097572410152435`", 
                  "9.25557912812014`*^-6"},
                {"0.31184299587039277`", 
                  "0.3118208878742391`", \(-0.000022107996153652998`\)},
                {"0.18114860722562298`", "0.18116146066902805`", 
                  "0.000012853443405069775`"},
                {"0.007673861546209082`", "0.007702979738494212`", 
                  "0.00002911819228513038`"},
                {"0.0057980287238024175`", "0.0058006766677013485`", 
                  "2.6479438989309573`*^-6"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"SNUM", "S", 
              "DS"}}]]]}],
      SequenceForm[ "KONTROLLE", 
        MatrixForm[ {{0.60974798543611541, 0.60975724101524353, 
          9.2555791281201394*^-06}, {0.31184299587039277, 
          0.31182088787423912, -2.2107996153652998*^-05}, {
          0.18114860722562298, 0.18116146066902805, 
          1.2853443405069775*^-05}, {0.007673861546209082, 
          0.0077029797384942124, 2.9118192285130379*^-05}, {
          0.0057980287238024175, 0.0058006766677013485, 
          2.6479438989309573*^-06}}, TableHeadings -> {Automatic, {"SNUM", 
          "S", "DS"}}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Likelihoods  "\[InvisibleSpace]\(-571.1091180939013`\
\)\[InvisibleSpace]"  "\[InvisibleSpace]\(-571.1091180939013`\)\),
      SequenceForm[ 
      "Likelihoods  ", -571.10911809390132, "  ", -571.10911809390132],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "MBFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.175391662895700\"\>",
            -571.17539166289566,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.109118093901300\"\>",
            -571.10911809390132,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -571.17539166289566, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -571.10911809390132, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.063266063293000\"\>",
            -571.06326606329299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.109118093901300\"\>",
            -571.10911809390132,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 2, "  LIKNEU  ", 
        PaddedForm[ -571.06326606329299, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -571.10911809390132, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.063266063293000\"\>",
            -571.06326606329299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.109118093901300\"\>",
            -571.10911809390132,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.06326606329299, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.10911809390132, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.045852030608330\"\>",
            0.045852030608330097,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.045852030608330097, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9435606897461892`\), \(-4.096`\), "0.15243931025381088`",
             "0.6097572410152435`"},
          {"2", \(-3.79404477803144`\), \(-3.872`\), "0.07795522196855978`", 
            "0.3118208878742391`"},
          {"3", "18.669190365167257`", "18.6239`", "0.04529036516725701`", 
            "0.18116146066902805`"},
          {"4", "44.42052574493462`", "44.4186`", "0.001925744934623553`", 
            "0.007702979738494212`"},
          {"5", "26.347550169166926`", "26.3461`", "0.0014501691669253371`", 
            "0.0058006766677013485`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.291382894663463`\
\[InvisibleSpace]"  "\[InvisibleSpace]31.875772612891804`\),
      SequenceForm[ "*BFGSUP ", 6.2913828946634629, "  ", 31.875772612891804],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "MBFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-HALVING:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.056226291448500\"\>",
            -571.05622629144852,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.063266063293000\"\>",
            -571.06326606329299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-HALVING:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -571.05622629144852, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -571.06326606329299, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.056226291448500\"\>",
            -571.05622629144852,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.063266063293000\"\>",
            -571.06326606329299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05622629144852, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.06326606329299, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.007039771844461\"\>",
            0.0070397718444610291,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0070397718444610291, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.985314660614644`\), \(-3.9435606897461892`\), \
\(-0.04175397086845506`\), \(-0.2739700476436991`\)},
          {"2", \(-3.7251652903526002`\), \(-3.79404477803144`\), 
            "0.06887948767884006`", "0.08847904168965978`"},
          {"3", "18.70096466076664`", "18.669190365167257`", 
            "0.03177429559938238`", "0.030521941360505556`"},
          {"4", "44.42421334209983`", "44.42052574493462`", 
            "0.0036875971652100977`", "0.007216959550099579`"},
          {"5", "26.35083359145458`", "26.347550169166926`", 
            "0.0032834222876552475`", "0.006717798637224687`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.173\"\>",
                  5.1726849441918565,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.863\"\>",
                  0.86295706408024186,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6175\"\>",
                  0.61746429923779267,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.006655\"\>",
                  -0.0066552197658032476,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01215\"\>",
                  -0.012145623091030681,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.863\"\>",
                  0.86295706408024186,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.12\"\>",
                  1.1201145204567995,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09913\"\>",
                  0.099126712510937492,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.004102\"\>",
                  -0.0041023296188511423,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.004892\"\>",
                  -0.004892175348517218,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.6175\"\>",
                  0.61746429923779267,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09913\"\>",
                  0.099126712510937492,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.077\"\>",
                  1.0773815941491713,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00232\"\>",
                  -0.0023195149478044985,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.002963\"\>",
                  -0.0029627438488273239,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.006655\"\>",
                  -0.0066552197658032476,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.004102\"\>",
                  -0.0041023296188511414,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00232\"\>",
                  -0.002319514947804498,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9999\"\>",
                  0.99988327502569418,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00009182\"\>",
                  -9.1822385038177248*^-05,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.01215\"\>",
                  -0.012145623091030681,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.004892\"\>",
                  -0.004892175348517218,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.002963\"\>",
                  -0.0029627438488273239,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00009182\"\>",
                  -9.1822385038177248*^-05,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9999\"\>",
                  0.99993825731151964,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]43.48270982474199`\
\[InvisibleSpace]"  "\[InvisibleSpace]107.80385505686`\),
      SequenceForm[ "*BFGSUP ", 43.482709824741988, "  ", 107.80385505686],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "MBFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.054192553444100\"\>",
            -571.05419255344418,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.056226291448500\"\>",
            -571.05622629144852,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05419255344418, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05622629144852, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.002033738004343\"\>",
            0.0020337380043429221,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0020337380043429221, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9974109097535684`\), \(-3.985314660614644`\), \
\(-0.012096249138924361`\), \(-0.05664254725846057`\)},
          {
            "2", \(-3.764743584524182`\), \(-3.7251652903526002`\), \
\(-0.03957829417158195`\), \(-0.088862059968013`\)},
          {"3", "18.69976572639378`", 
            "18.70096466076664`", \(-0.00119893437285963`\), \
\(-0.022918981435209068`\)},
          {"4", "44.431571504086996`", "44.42421334209983`", 
            "0.007358161987163061`", "0.007730875635159916`"},
          {"5", "26.354222247810497`", "26.35083359145458`", 
            "0.003388656355915194`", "0.0030497250974186618`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.203\"\>",
                  5.2034991436107623,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1596\"\>",
                  -0.15960660323332865,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3378\"\>",
                  0.33781477899034495,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05149\"\>",
                  0.051489555742777901,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.002794\"\>",
                  0.0027937151879332232,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.1596\"\>",
                  -0.15960660323332865,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.277\"\>",
                  2.2766532125010848,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4384\"\>",
                  0.43844170374474423,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02527\"\>",
                  -0.025274805043461607,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.007374\"\>",
                  0.0073741041575537151,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3378\"\>",
                  0.33781477899034495,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4384\"\>",
                  0.43844170374474423,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.176\"\>",
                  1.1764580477470949,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00945\"\>",
                  -0.0094503707552936848,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.00003493\"\>",
                  3.4932044734348709*^-05,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.05149\"\>",
                  0.051489555742777901,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02527\"\>",
                  -0.025274805043461607,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00945\"\>",
                  -0.0094503707552936848,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9985\"\>",
                  0.99849103162207375,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00148\"\>",
                  -0.0014804296674167585,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.002794\"\>",
                  0.0027937151879332302,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.007374\"\>",
                  0.0073741041575537082,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.00003493\"\>",
                  3.4932044734347842*^-05,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00148\"\>",
                  -0.0014804296674167587,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9993\"\>",
                  0.99930704173533291,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]220.93981693886371`\
\[InvisibleSpace]"  "\[InvisibleSpace]232.72759911849678`\),
      SequenceForm[ "*BFGSUP ", 220.93981693886371, "  ", 232.72759911849678],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "MBFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.054029342104400\"\>",
            -571.0540293421044,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.054192553444100\"\>",
            -571.05419255344418,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.0540293421044, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05419255344418, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000163211339782\"\>",
            0.00016321133978181024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00016321133978181024, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9959910582826885`\), \(-3.9974109097535684`\), 
            "0.001419851470879708`", "0.014487829230321495`"},
          {
            "2", \(-3.767015342322515`\), \(-3.764743584524182`\), \
\(-0.0022717577983328565`\), "0.0025470748999393044`"},
          {"3", "18.70942962105977`", "18.69976572639378`", 
            "0.00966389466598844`", "0.012376861984169893`"},
          {"4", "44.438420553151445`", "44.431571504086996`", 
            "0.006849049064449624`", "0.006898136553273346`"},
          {"5", "26.35742543560743`", "26.354222247810497`", 
            "0.0032031877969307633`", "0.003213145746057661`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.575\"\>",
                  5.5746727308911135,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1055\"\>",
                  0.10553169968884835,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5904\"\>",
                  0.59038322543928201,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1403\"\>",
                  0.14031321618800968,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04556\"\>",
                  0.045564300131863467,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1055\"\>",
                  0.10553169968884857,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.285\"\>",
                  2.2850190569668238,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6773\"\>",
                  0.67729412429848446,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1178\"\>",
                  0.11778682825516759,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.07374\"\>",
                  0.073744843234789137,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5904\"\>",
                  0.59038322543928201,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6773\"\>",
                  0.67729412429848446,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.329\"\>",
                  1.329457026469504,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02529\"\>",
                  0.025291274967492654,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01758\"\>",
                  0.017576194541867575,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1403\"\>",
                  0.14031321618800965,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1178\"\>",
                  0.11778682825516759,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02529\"\>",
                  0.025291274967492654,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9847\"\>",
                  0.98473494366182424,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.006998\"\>",
                  -0.0069975258332458041,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.04556\"\>",
                  0.04556430013186348,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.07374\"\>",
                  0.073744843234789137,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01758\"\>",
                  0.017576194541867575,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.006998\"\>",
                  -0.0069975258332458049,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9971\"\>",
                  0.99714838397608319,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]17417.55928198705`\
\[InvisibleSpace]"  "\[InvisibleSpace]5210.208361509134`\),
      SequenceForm[ "*BFGSUP ", 17417.559281987051, "  ", 5210.2083615091342],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "MBFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053757040766200\"\>",
            -571.05375704076619,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.054029342104400\"\>",
            -571.0540293421044,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05375704076619, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.0540293421044, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000272301338214\"\>",
            0.00027230133821376512,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00027230133821376512, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9962130482595897`\), \(-3.9959910582826885`\), \
\(-0.0002219899769012776`\), "0.002824636866191922`"},
          {
            "2", \(-3.77732611532504`\), \(-3.767015342322515`\), \
\(-0.010310773002524962`\), "0.0002541874970645114`"},
          {"3", "18.742486712840886`", "18.70942962105977`", 
            "0.03305709178111623`", "0.008170560981910569`"},
          {"4", "44.46630888234648`", "44.438420553151445`", 
            "0.02788832919503447`", "0.006325970228989064`"},
          {"5", "26.369737894661824`", "26.35742543560743`", 
            "0.012312459054396424`", "0.0027466840444333534`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.85\"\>",
                  6.8503761728893666,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3791\"\>",
                  0.37905385506816824,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5106\"\>",
                  0.51060689750236155,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2642\"\>",
                  -0.26415757149079849,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1022\"\>",
                  -0.10221969358300986,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3791\"\>",
                  0.37905385506816847,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.343\"\>",
                  2.3427872614202463,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.681\"\>",
                  0.68102832591057083,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04909\"\>",
                  0.049093421880425786,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04973\"\>",
                  0.049732706579872943,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5106\"\>",
                  0.51060689750236132,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.681\"\>",
                  0.68102832591057083,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8395\"\>",
                  0.83949065687056379,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3776\"\>",
                  -0.37762325854587142,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1555\"\>",
                  -0.15545220227970888,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.2642\"\>",
                  -0.26415757149079844,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04909\"\>",
                  0.049093421880425786,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3776\"\>",
                  -0.37762325854587142,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7425\"\>",
                  0.74251295025287622,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1178\"\>",
                  -0.11783168907705611,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.1022\"\>",
                  -0.10221969358300985,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04973\"\>",
                  0.049732706579872943,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1555\"\>",
                  -0.15545220227970885,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1178\"\>",
                  -0.11783168907705611,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9471\"\>",
                  0.94714642678328886,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2444.9766740795394`\
\[InvisibleSpace]"  "\[InvisibleSpace]2096.0570604560603`\),
      SequenceForm[ "*BFGSUP ", 2444.9766740795394, "  ", 2096.0570604560603],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "MBFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053722803393300\"\>",
            -571.05372280339338,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053757040766200\"\>",
            -571.05375704076619,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05372280339338, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05375704076619, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000034237372802\"\>",
            3.4237372801726451*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.4237372801726451*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.997436611256887`\), \(-3.9962130482595897`\), \
\(-0.0012235629972972921`\), \(-0.008338082451125859`\)},
          {
            "2", \(-3.7797231006824554`\), \(-3.77732611532504`\), \
\(-0.002396985357415493`\), \(-0.001471279554673393`\)},
          {"3", "18.747935263963328`", "18.742486712840886`", 
            "0.005448551122440821`", \(-0.0022406866782415614`\)},
          {"4", "44.47632822731903`", "44.46630888234648`", 
            "0.010019344972546924`", "0.00403662942159691`"},
          {"5", "26.373337171035335`", "26.369737894661824`", 
            "0.00359927637350916`", "0.001020033968988492`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 7.138\"\>",
                  7.1383121309234454,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4246\"\>",
                  0.42464137451601214,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7464\"\>",
                  0.74638217037194465,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2391\"\>",
                  -0.23912907487405066,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.07136\"\>",
                  -0.071356961530640958,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.4246\"\>",
                  0.42464137451601236,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.35\"\>",
                  2.3499311063926727,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7206\"\>",
                  0.72059732890171979,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05538\"\>",
                  0.055381101900857814,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05555\"\>",
                  0.055553561437003032,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.7464\"\>",
                  0.74638217037194443,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7206\"\>",
                  0.72059732890171979,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9646\"\>",
                  0.96458293162737796,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4277\"\>",
                  -0.42768582435292934,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1585\"\>",
                  -0.15853948635542703,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.2391\"\>",
                  -0.23912907487405061,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05538\"\>",
                  0.055381101900857814,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4277\"\>",
                  -0.42768582435292934,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6714\"\>",
                  0.67144747140537375,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1446\"\>",
                  -0.14458688088468108,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.07136\"\>",
                  -0.071356961530640944,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05555\"\>",
                  0.055553561437003039,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1585\"\>",
                  -0.158539486355427,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1446\"\>",
                  -0.14458688088468105,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9386\"\>",
                  0.93862245863166593,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]43871.7786858241`\
\[InvisibleSpace]"  "\[InvisibleSpace]21912.48887299256`\),
      SequenceForm[ "*BFGSUP ", 43871.778685824102, "  ", 21912.488872992559],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "MBFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053685371863900\"\>",
            -571.05368537186393,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053722803393300\"\>",
            -571.05372280339338,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05368537186393, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05372280339338, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000037431529449\"\>",
            3.743152944934991*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.743152944934991*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.99869560427483`\), \(-3.997436611256887`\), \
\(-0.0012589930179429355`\), \(-0.0034768157295261377`\)},
          {
            "2", \(-3.7809282585194555`\), \(-3.7797231006824554`\), \
\(-0.001205157836999876`\), \(-0.00007694769238084098`\)},
          {"3", "18.749571569354405`", "18.747935263963328`", 
            "0.0016363053910770065`", \(-0.0030190399801983433`\)},
          {"4", "44.491492056562926`", "44.47632822731903`", 
            "0.015163829243896972`", "0.003235607813387893`"},
          {"5", "26.378055906594255`", "26.373337171035335`", 
            "0.004718735558922367`", "0.0006764016760095457`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.652\"\>",
                  6.6516507110215324,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4532\"\>",
                  0.45319915263929306,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.171\"\>",
                  0.17098918689342768,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3276\"\>",
                  0.32756015925869963,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04172\"\>",
                  0.041724256652948585,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.4532\"\>",
                  0.45319915263929328,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.388\"\>",
                  2.3877917570563194,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6007\"\>",
                  0.60074565460899443,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1365\"\>",
                  0.13651965111023995,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.06742\"\>",
                  0.067418228998535473,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.171\"\>",
                  0.17098918689342746,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6007\"\>",
                  0.60074565460899443,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8811\"\>",
                  0.88114641647383851,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2021\"\>",
                  -0.20213818730260685,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.09672\"\>",
                  -0.096722548665366032,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3276\"\>",
                  0.32756015925869969,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1365\"\>",
                  0.13651965111023992,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2021\"\>",
                  -0.20213818730260685,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3425\"\>",
                  0.34254681056549907,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2227\"\>",
                  -0.22273552531520197,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.04172\"\>",
                  0.041724256652948599,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.06742\"\>",
                  0.067418228998535487,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.09672\"\>",
                  -0.096722548665366004,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2227\"\>",
                  -0.22273552531520194,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.921\"\>",
                  0.92100370466415127,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]34828.873814828294`\
\[InvisibleSpace]"  "\[InvisibleSpace]19310.270181154658`\),
      SequenceForm[ "*BFGSUP ", 34828.873814828294, "  ", 19310.270181154658],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "MBFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053651209988000\"\>",
            -571.05365120998795,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053685371863900\"\>",
            -571.05368537186393,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05365120998795, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05368537186393, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000034161875988\"\>",
            3.4161875987592794*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.4161875987592794*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.999014291617963`\), \(-3.99869560427483`\), \
\(-0.0003186873431332637`\), "0.003043602464689968`"},
          {"2", \(-3.7799344889620983`\), \(-3.7809282585194555`\), 
            "0.0009937695573571518`", "0.001550815353940662`"},
          {"3", "18.745988351749094`", 
            "18.749571569354405`", \(-0.0035832176053119794`\), \
\(-0.0027002748370626864`\)},
          {"4", "44.50861986857235`", "44.491492056562926`", 
            "0.017127812009429567`", "0.002042781251215809`"},
          {"5", "26.38309571163426`", "26.378055906594255`", 
            "0.00503980504000548`", "0.0004698386643488062`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 7.899\"\>",
                  7.8990026776739048,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8177\"\>",
                  0.81769609028492718,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04069\"\>",
                  0.040687311262228465,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2739\"\>",
                  0.27390370139500297,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04023\"\>",
                  0.040226465504732647,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.8177\"\>",
                  0.8176960902849274,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.48\"\>",
                  2.4799604426016693,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6143\"\>",
                  0.61433152254724188,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0737\"\>",
                  0.073702278733690077,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05671\"\>",
                  0.056712572637209135,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.04069\"\>",
                  0.040687311262228243,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6143\"\>",
                  0.61433152254724188,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7087\"\>",
                  0.70867998573361568,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02675\"\>",
                  -0.026750213303352671,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.05958\"\>",
                  -0.059582670897202226,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.2739\"\>",
                  0.27390370139500309,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0737\"\>",
                  0.073702278733690049,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02675\"\>",
                  -0.026750213303352671,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1899\"\>",
                  0.18994029042004723,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2564\"\>",
                  -0.25641579369698925,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.04023\"\>",
                  0.040226465504732661,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05671\"\>",
                  0.056712572637209149,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.05958\"\>",
                  -0.059582670897202199,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2564\"\>",
                  -0.25641579369698925,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9137\"\>",
                  0.91365497283466757,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]37189.62153557143`\
\[InvisibleSpace]"  "\[InvisibleSpace]21007.019212408974`\),
      SequenceForm[ "*BFGSUP ", 37189.62153557143, "  ", 21007.019212408974],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "MBFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053629181878900\"\>",
            -571.05362918187893,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053651209988000\"\>",
            -571.05365120998795,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05362918187893, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05365120998795, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000022028109015\"\>",
            2.2028109015082009*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.2028109015082009*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.998186427592385`\), \(-3.999014291617963`\), 
            "0.0008278640255778188`", "0.006279149181471492`"},
          {"2", \(-3.777143731016819`\), \(-3.7799344889620983`\), 
            "0.0027907579452789806`", "0.0021266768722241654`"},
          {"3", "18.738766755022567`", 
            "18.745988351749094`", \(-0.007221596726525736`\), \
\(-0.0016492143126042873`\)},
          {"4", "44.52178299162898`", "44.50861986857235`", 
            "0.013163123056626305`", "0.0007111796583084175`"},
          {"5", "26.38727492302585`", "26.38309571163426`", 
            "0.004179211391586051`", "0.0004982588490967145`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 8.094\"\>",
                  8.0937331372843939,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7878\"\>",
                  0.78783428623201623,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3398\"\>",
                  0.33980763258199181,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.01694\"\>",
                  -0.016935600662304928,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01361\"\>",
                  0.013606149091741442,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.7878\"\>",
                  0.78783428623201646,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.442\"\>",
                  2.4417706593876614,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7248\"\>",
                  0.72481068540213489,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02137\"\>",
                  -0.02136514056312605,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04201\"\>",
                  0.042014813622416575,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3398\"\>",
                  0.33980763258199165,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7248\"\>",
                  0.72481068540213489,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5966\"\>",
                  0.59659206177550095,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03708\"\>",
                  0.037075625908093712,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03182\"\>",
                  -0.031820298071787462,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.01694\"\>",
                  -0.016935600662304817,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02137\"\>",
                  -0.021365140563126078,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03708\"\>",
                  0.037075625908093712,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1682\"\>",
                  0.16822219305016417,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.278\"\>",
                  -0.2779852780347965,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.01361\"\>",
                  0.013606149091741453,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.04201\"\>",
                  0.042014813622416589,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03182\"\>",
                  -0.031820298071787434,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.278\"\>",
                  -0.2779852780347965,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.909\"\>",
                  0.90904774588807125,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]40122.498161158655`\
\[InvisibleSpace]"  "\[InvisibleSpace]28996.46942988608`\),
      SequenceForm[ "*BFGSUP ", 40122.498161158655, "  ", 28996.469429886081],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "MBFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053623825420900\"\>",
            -571.0536238254208,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053629181878900\"\>",
            -571.05362918187893,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.0536238254208, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05362918187893, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.356458132155240"\[Times]10\^"-6"\),
            5.3564581321552396*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.3564581321552396*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.997316288566697`\), \(-3.998186427592385`\), 
            "0.0008701390256881803`", "0.004454734870588613`"},
          {"2", \(-3.775353824599881`\), \(-3.777143731016819`\), 
            "0.0017899064169383196`", "0.001307856171136594`"},
          {"3", "18.734668646698328`", 
            "18.738766755022567`", \(-0.0040981083242391655`\), \
\(-0.00043270950086296843`\)},
          {"4", "44.52363248038622`", "44.52178299162898`", 
            "0.0018494887572390202`", \(-0.00029872348737647325`\)},
          {"5", "26.38878316181583`", "26.38727492302585`", 
            "0.0015082387899818203`", "0.0007256729263350678`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 7.084\"\>",
                  7.0840158574605026,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4606\"\>",
                  0.46056123789114528,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.551\"\>",
                  0.55103706451218315,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0725\"\>",
                  -0.072497355757997747,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.09376\"\>",
                  -0.093760136769949834,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.4606\"\>",
                  0.4605612378911455,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.338\"\>",
                  2.3375275708803702,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7865\"\>",
                  0.7865453413657012,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03204\"\>",
                  -0.032042349936185578,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.003818\"\>",
                  0.0038178584732676268,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.551\"\>",
                  0.55103706451218304,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7865\"\>",
                  0.7865453413657012,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5771\"\>",
                  0.5771009783258495,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02179\"\>",
                  0.021792650604030392,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.003107\"\>",
                  0.0031070357911363936,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.0725\"\>",
                  -0.072497355757997636,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03204\"\>",
                  -0.032042349936185613,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02179\"\>",
                  0.021792650604030399,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1945\"\>",
                  0.19447757099989937,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2975\"\>",
                  -0.29747500352045747,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.09376\"\>",
                  -0.09376013676994982,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.003818\"\>",
                  0.0038178584732676407,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.003107\"\>",
                  0.0031070357911364282,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2975\"\>",
                  -0.29747500352045747,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9039\"\>",
                  0.903924049612012,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]157400.8665444791`\
\[InvisibleSpace]"  "\[InvisibleSpace]117199.33604996017`\),
      SequenceForm[ "*BFGSUP ", 157400.8665444791, "  ", 117199.33604996017],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "MBFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053622202192800\"\>",
            -571.05362220219286,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053623825420900\"\>",
            -571.0536238254208,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05362220219286, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.0536238254208, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.623227944946848"\[Times]10\^"-6"\),
            1.6232279449468479*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.6232279449468479*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.996924358229743`\), \(-3.997316288566697`\), 
            "0.000391930336953897`", "0.0011586902668881483`"},
          {"2", \(-3.7747123288874658`\), \(-3.775353824599881`\), 
            "0.0006414957124151215`", "0.0003132885262570641`"},
          {"3", "18.733290000817803`", 
            "18.734668646698328`", \(-0.001378645880526495`\), \
\(-0.00001832831735819473`\)},
          {"4", "44.52253246937256`", 
            "44.52363248038622`", \(-0.0011000110136595046`\), \
\(-0.0004306356968744908`\)},
          {"5", "26.38990725846634`", "26.38878316181583`", 
            "0.0011240966505095225`", "0.0008829053231464387`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.468\"\>",
                  6.4682234097224409,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2937\"\>",
                  0.29372200363927187,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.562\"\>",
                  0.56197014717147198,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1519\"\>",
                  0.15189986878604372,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5542\"\>",
                  -0.55420035479755847,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.2937\"\>",
                  0.29372200363927209,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.293\"\>",
                  2.2927549372867086,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.788\"\>",
                  0.78800136186401926,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0344\"\>",
                  0.034396252411842514,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.132\"\>",
                  -0.13202726968011705,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.562\"\>",
                  0.56197014717147187,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.788\"\>",
                  0.78800136186401926,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5822\"\>",
                  0.58218444686483906,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00196\"\>",
                  -0.0019604294605829464,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05016\"\>",
                  0.050163599226914678,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1519\"\>",
                  0.15189986878604378,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0344\"\>",
                  0.034396252411842479,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00196\"\>",
                  -0.0019604294605829395,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1868\"\>",
                  0.18675810952036584,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2753\"\>",
                  -0.27533368467327013,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.5542\"\>",
                  -0.55420035479755847,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.132\"\>",
                  -0.13202726968011702,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05016\"\>",
                  0.050163599226914712,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2753\"\>",
                  -0.27533368467327013,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.8461\"\>",
                  0.84609800748654207,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]955391.5946578479`\
\[InvisibleSpace]"  "\[InvisibleSpace]465865.49952490506`\),
      SequenceForm[ "*BFGSUP ", 955391.59465784789, "  ", 465865.49952490506],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "MBFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053619715407900\"\>",
            -571.05361971540788,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053622202192800\"\>",
            -571.05362220219286,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05361971540788, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05362220219286, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.486784978827927"\[Times]10\^"-6"\),
            2.4867849788279273*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.4867849788279273*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9965052733534563`\), \(-3.996924358229743`\), 
            "0.0004190848762868071`", \(-0.00048712962973770924`\)},
          {"2", \(-3.7740282410056403`\), \(-3.7747123288874658`\), 
            "0.0006840878818253263`", \(-0.00013978033127295605`\)},
          {"3", "18.73173722841333`", 
            "18.733290000817803`", \(-0.0015527724044728352`\), 
            "0.000022279556136842088`"},
          {"4", "44.52076534055842`", 
            "44.52253246937256`", \(-0.0017671288141375744`\), \
\(-0.0003397641304056613`\)},
          {"5", "26.392995404642647`", "26.38990725846634`", 
            "0.0030881461763074105`", "0.0009228848490344097`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 8.431\"\>",
                  8.4306608770788376,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.837\"\>",
                  0.83701739553489807,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.508\"\>",
                  0.50801173798917154,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2415\"\>",
                  0.24146767873026481,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.094\"\>",
                  -1.0936510981355512,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.837\"\>",
                  0.83701739553489829,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.443\"\>",
                  2.4431449382574852,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7731\"\>",
                  0.7730989354250607,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05791\"\>",
                  0.057913167637247798,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2782\"\>",
                  -0.27819304514191323,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.508\"\>",
                  0.50801173798917143,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7731\"\>",
                  0.7730989354250607,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5836\"\>",
                  0.58360339012060247,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.002112\"\>",
                  -0.0021119340371973773,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05925\"\>",
                  0.059253375971093064,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.2415\"\>",
                  0.2414676787302649,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05791\"\>",
                  0.057913167637247763,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.002112\"\>",
                  -0.0021119340371973708,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1083\"\>",
                  0.10825398341813011,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.09474\"\>",
                  -0.094735767576862279,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.094\"\>",
                  -1.0936510981355512,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2782\"\>",
                  -0.27819304514191323,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05925\"\>",
                  0.059253375971093092,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.09474\"\>",
                  -0.094735767576862279,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.4845\"\>",
                  0.48447275233627685,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]794541.703766224`\
\[InvisibleSpace]"  "\[InvisibleSpace]320919.6755593018`\),
      SequenceForm[ "*BFGSUP ", 794541.70376622397, "  ", 320919.6755593018],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "MBFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053614392674800\"\>",
            -571.05361439267483,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053619715407900\"\>",
            -571.05361971540788,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05361439267483, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05361971540788, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.322733045431960"\[Times]10\^"-6"\),
            5.3227330454319599*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.3227330454319599*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.995912027514863`\), \(-3.9965052733534563`\), 
            "0.0005932458385931412`", \(-0.002162920143692902`\)},
          {"2", \(-3.772949604249319`\), \(-3.7740282410056403`\), 
            "0.0010786367563212981`", \(-0.0005902910502298599`\)},
          {"3", "18.729003912603908`", 
            "18.73173722841333`", \(-0.002733315809421916`\), 
            "0.00002039603166337907`"},
          {"4", "44.51804306234372`", 
            "44.52076534055842`", \(-0.0027222782146962003`\), \
\(-0.000195991862813185`\)},
          {"5", "26.402012705441734`", "26.392995404642647`", 
            "0.009017300799088794`", "0.0009238691413480816`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 10.59\"\>",
                  10.585798840808238,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.415\"\>",
                  1.4150140760622345,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.514\"\>",
                  0.51400257490686296,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.003078\"\>",
                  -0.0030781544556836016,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.9507\"\>",
                  -0.95068755796026916,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.415\"\>",
                  1.4150140760622345,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.598\"\>",
                  2.5981347470305867,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7748\"\>",
                  0.77477256426049701,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.008791\"\>",
                  -0.0087912786662404929,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2371\"\>",
                  -0.23714636495614883,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.514\"\>",
                  0.51400257490686285,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7748\"\>",
                  0.77477256426049701,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5834\"\>",
                  0.58344691122173675,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0001022\"\>",
                  0.00010220103388129198,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05265\"\>",
                  0.052653324326259243,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.003078\"\>",
                  -0.0030781544556835183,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.008791\"\>",
                  -0.0087912786662405276,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0001022\"\>",
                  0.00010220103388129849,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.08763\"\>",
                  0.087630670223064505,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.006005\"\>",
                  0.0060052613535151317,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.9507\"\>",
                  -0.95068755796026916,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2371\"\>",
                  -0.23714636495614883,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05265\"\>",
                  0.052653324326259271,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.006005\"\>",
                  0.0060052613535151317,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2111\"\>",
                  0.21114095705093727,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]319263.7516679901`\
\[InvisibleSpace]"  "\[InvisibleSpace]145164.24797686402`\),
      SequenceForm[ "*BFGSUP ", 319263.75166799012, "  ", 145164.24797686402],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "MBFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053606242378800\"\>",
            -571.05360624237881,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053614392674800\"\>",
            -571.05361439267483,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05360624237881, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05361439267483, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     8.150296025633000"\[Times]10\^"-6"\),
            8.150296025632997*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 8.150296025632997*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.995385653560062`\), \(-3.995912027514863`\), 
            "0.0005263739548012638`", \(-0.004200945767333153`\)},
          {"2", \(-3.771732454778493`\), \(-3.772949604249319`\), 
            "0.0012171494708257923`", \(-0.0011339464862537875`\)},
          {"3", "18.725376208081393`", 
            "18.729003912603908`", \(-0.0036277045225156746`\), 
            "2.0064392856328404`*^-6"},
          {"4", "44.515512529588115`", 
            "44.51804306234372`", \(-0.0025305327556078274`\), 
            "0.00002648191756371779`"},
          {"5", "26.419620850371`", "26.402012705441734`", 
            "0.017608144929266756`", "0.0008372158728416658`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 11.23\"\>",
                  11.232765496120004,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.583\"\>",
                  1.583414309339108,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5324\"\>",
                  0.5323720078238019,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2094\"\>",
                  -0.20937192452302836,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.6042\"\>",
                  -0.60422986458807881,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.583\"\>",
                  1.583414309339108,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.642\"\>",
                  2.6419151930423954,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7797\"\>",
                  0.77971215488580015,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0642\"\>",
                  -0.064200313116248492,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1429\"\>",
                  -0.14294043537008722,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5324\"\>",
                  0.53237200782380178,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7797\"\>",
                  0.77971215488580015,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5835\"\>",
                  0.58349449086145599,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0006237\"\>",
                  -0.00062368377999103843,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05043\"\>",
                  0.050426708666912942,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.2094\"\>",
                  -0.20937192452302825,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0642\"\>",
                  -0.06420031311624852,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0006237\"\>",
                  -0.00062368377999103171,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09786\"\>",
                  0.097856329746303081,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02614\"\>",
                  0.026135480584779526,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.6042\"\>",
                  -0.60422986458807881,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1429\"\>",
                  -0.14294043537008722,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05043\"\>",
                  0.05042670866691297,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02614\"\>",
                  0.026135480584779523,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.08964\"\>",
                  0.089635592316756177,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]170910.7362056624`\
\[InvisibleSpace]"  "\[InvisibleSpace]90284.68617069018`\),
      SequenceForm[ "*BFGSUP ", 170910.7362056624, "  ", 90284.686170690184],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "MBFGS: Iteration = ", 15],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053599023161200\"\>",
            -571.05359902316127,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053606242378800\"\>",
            -571.05360624237881,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359902316127, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05360624237881, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     7.219217536658107"\[Times]10\^"-6"\),
            7.2192175366581068*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 7.2192175366581068*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {"1", \(-3.9953731596656326`\), \(-3.995385653560062`\), 
            "0.00001249389442922008`", \(-0.005282063928313975`\)},
          {"2", \(-3.7711685890169555`\), \(-3.771732454778493`\), 
            "0.0005638657615378825`", \(-0.0014185035229976849`\)},
          {"3", "18.722830156551034`", 
            "18.725376208081393`", \(-0.0025460515303583502`\), \
\(-0.000019729091124334312`\)},
          {"4", "44.51530682524937`", 
            "44.515512529588115`", \(-0.0002057043387496423`\), 
            "0.0002366383020965014`"},
          {"5", "26.43950959886786`", "26.419620850371`", 
            "0.019888748496859347`", "0.000582638851803634`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 9.839\"\>",
                  9.8391895742786257,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.206\"\>",
                  1.2059088137864613,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5371\"\>",
                  0.53714918839202963,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2382\"\>",
                  -0.23815941756503603,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2397\"\>",
                  -0.23965033943079145,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.206\"\>",
                  1.2059088137864613,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.54\"\>",
                  2.5396631216658934,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.781\"\>",
                  0.78097465271535604,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.07171\"\>",
                  -0.071709861927072072,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.04485\"\>",
                  -0.044846885197909025,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5371\"\>",
                  0.53714918839202952,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.781\"\>",
                  0.78097465271535604,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5836\"\>",
                  0.58357487131356145,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.001409\"\>",
                  -0.0014091773976809161,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05122\"\>",
                  0.051220758147285786,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.2382\"\>",
                  -0.23815941756503592,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.07171\"\>",
                  -0.071709861927072099,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.001409\"\>",
                  -0.0014091773976809096,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1053\"\>",
                  0.10534140714262225,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01499\"\>",
                  0.014989878468148185,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.2397\"\>",
                  -0.23965033943079145,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.04485\"\>",
                  -0.044846885197909039,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05122\"\>",
                  0.051220758147285814,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01499\"\>",
                  0.014989878468148185,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03743\"\>",
                  0.037428941984053006,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]142711.1890230578`\
\[InvisibleSpace]"  "\[InvisibleSpace]93251.63795035619`\),
      SequenceForm[ "*BFGSUP ", 142711.18902305781, "  ", 93251.637950356191],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]16\),
      SequenceForm[ "MBFGS: Iteration = ", 16],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596414667000\"\>",
            -571.05359641466703,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053599023161200\"\>",
            -571.05359902316127,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359641466703, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05359902316127, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.608494241940207"\[Times]10\^"-6"\),
            2.6084942419402068*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.6084942419402068*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9957975302055657`\), \(-3.9953731596656326`\), \
\(-0.00042437053993326474`\), \(-0.00382387905635077`\)},
          {
            "2", \(-3.7715322660151065`\), \(-3.7711685890169555`\), \
\(-0.00036367699815117413`\), \(-0.0010231613694479096`\)},
          {"3", "18.72291856733933`", "18.722830156551034`", 
            "0.00008841078829781438`", \(-0.00002466223071816626`\)},
          {"4", "44.51720158841645`", "44.51530682524937`", 
            "0.0018947631670829105`", "0.000260691458619601`"},
          {"5", "26.447730158879644`", "26.43950959886786`", 
            "0.008220560011783808`", "0.00021781400852420064`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 7.541\"\>",
                  7.5408975330174748,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5895\"\>",
                  0.58947956378564925,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5264\"\>",
                  0.52640482242694075,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1166\"\>",
                  -0.11659514712797439,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.02858\"\>",
                  -0.028584891442029636,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5895\"\>",
                  0.58947956378564925,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.374\"\>",
                  2.3743317340317525,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7781\"\>",
                  0.77808660590333034,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03905\"\>",
                  -0.039050800333681315,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01164\"\>",
                  0.011639960872676866,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5264\"\>",
                  0.52640482242694064,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7781\"\>",
                  0.77808660590333034,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5835\"\>",
                  0.58354204732275705,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0009908\"\>",
                  -0.00099075109797274082,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05255\"\>",
                  0.052549521540553742,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.1166\"\>",
                  -0.11659514712797427,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.03905\"\>",
                  -0.039050800333681343,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0009908\"\>",
                  -0.00099075109797273431,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1002\"\>",
                  0.10020209737750387,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0008805\"\>",
                  0.0008805221223862382,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.02858\"\>",
                  -0.028584891442029636,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01164\"\>",
                  0.011639960872676852,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05255\"\>",
                  0.05254952154055377,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0008805\"\>",
                  0.0008805221223862382,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02477\"\>",
                  0.024767446857216262,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]299661.0975924093`\
\[InvisibleSpace]"  "\[InvisibleSpace]233799.82483694615`\),
      SequenceForm[ "*BFGSUP ", 299661.09759240929, "  ", 233799.82483694615],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]17\),
      SequenceForm[ "MBFGS: Iteration = ", 17],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596103990200\"\>",
            -571.05359610399023,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596414667000\"\>",
            -571.05359641466703,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359610399023, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05359641466703, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     3.106767962890444"\[Times]10\^"-7"\),
            3.1067679628904443*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.1067679628904443*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.996050652966105`\), \(-3.9957975302055657`\), \
\(-0.00025312276053936943`\), \(-0.0012419342376888591`\)},
          {
            "2", \(-3.7719011312004334`\), \(-3.7715322660151065`\), \
\(-0.00036886518532688254`\), \(-0.0003310734189861213`\)},
          {"3", "18.723670828432056`", "18.72291856733933`", 
            "0.0007522610927252926`", \(-0.00001149195360285155`\)},
          {"4", "44.51837596556214`", "44.51720158841645`", 
            "0.0011743771456936667`", "0.00011138707100626782`"},
          {"5", "26.447084207567926`", 
            "26.447730158879644`", \(-0.0006459513117183316`\), 
            "0.000010045519871380946`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 6.12\"\>",
                  6.1199370034117351,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2102\"\>",
                  0.21022480396822252,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5145\"\>",
                  0.51454619361740384,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0009508\"\>",
                  0.00095075661115430476,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.005393\"\>",
                  0.0053934505937538457,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.2102\"\>",
                  0.21022480396822241,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.273\"\>",
                  2.2731096291994719,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7749\"\>",
                  0.77491843957755913,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.007654\"\>",
                  -0.0076540172671591827,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02065\"\>",
                  0.020654839714865689,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5145\"\>",
                  0.51454619361740372,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7749\"\>",
                  0.77491843957755913,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5835\"\>",
                  0.58345182235347015,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00007685\"\>",
                  -7.6845209263023875*^-05,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05299\"\>",
                  0.052985459397888825,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.0009508\"\>",
                  0.00095075661115444354,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.007654\"\>",
                  -0.0076540172671592105,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.00007685\"\>",
                  -7.6845209263017369*^-05,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.09099\"\>",
                  0.09099303802859629,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.003099\"\>",
                  -0.0030994472699270425,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.005393\"\>",
                  0.0053934505937538735,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02065\"\>",
                  0.020654839714865675,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05299\"\>",
                  0.052985459397888852,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.003099\"\>",
                  -0.0030994472699270425,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02661\"\>",
                  0.026610989065987703,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.0705899693092376`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]1.8110697639918951`*^6\),
      SequenceForm[ "*BFGSUP ", 2070589.9693092376, "  ", 1811069.7639918951],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]18\),
      SequenceForm[ "MBFGS: Iteration = ", 18],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596093126000\"\>",
            -571.05359609312598,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596103990200\"\>",
            -571.05359610399023,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359609312598, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05359610399023, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.086425527319079"\[Times]10\^"-8"\),
            1.0864255273190793*^-08,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.0864255273190793*^-08, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9960922573031388`\), \(-3.996050652966105`\), \
\(-0.00004160433703349901`\), \(-0.0001244233050916952`\)},
          {
            "2", \(-3.77198133286859`\), \(-3.7719011312004334`\), \
\(-0.00008020166815646123`\), \(-0.00003296081452047045`\)},
          {"3", "18.723884680487075`", "18.723670828432056`", 
            "0.00021385205501788041`", \(-2.1058714473070227`*^-6\)},
          {"4", "44.518574339894336`", "44.51837596556214`", 
            "0.00019837433218998694`", "0.00001667819541062085`"},
          {"5", "26.446257098914305`", 
            "26.447084207567926`", \(-0.0008271086536212085`\), \
\(-0.000011689596386592078`\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.912\"\>",
                  5.9123581095260347,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1554\"\>",
                  0.15536950852950127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5104\"\>",
                  0.51041667254706224,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03234\"\>",
                  0.032338324495062395,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0223\"\>",
                  -0.022304905381273599,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1554\"\>",
                  0.15536950852950115,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.259\"\>",
                  2.2586146407974468,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7738\"\>",
                  0.77382163524827285,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0006725\"\>",
                  0.00067249294544081961,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01326\"\>",
                  0.013261691090268569,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5104\"\>",
                  0.51041667254706213,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7738\"\>",
                  0.77382163524827285,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5834\"\>",
                  0.58339505937898795,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0004008\"\>",
                  0.00040078259664862127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05277\"\>",
                  0.052772118024650622,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.03234\"\>",
                  0.032338324495062562,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0006725\"\>",
                  0.00067249294544078492,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0004008\"\>",
                  0.00040078259664862777,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0871\"\>",
                  0.087095669429510539,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0008636\"\>",
                  -0.00086360065670319352,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.0223\"\>",
                  -0.022304905381273568,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01326\"\>",
                  0.013261691090268556,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05277\"\>",
                  0.052772118024650649,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0008636\"\>",
                  -0.00086360065670319439,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02741\"\>",
                  0.027406407881214508,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS: Iteration = "\[InvisibleSpace]19\),
      SequenceForm[ "MBFGS: Iteration = ", 19],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596093023400\"\>",
            -571.05359609302343,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], "\[InvisibleSpace]", "\<\"      \"\>",
         "\[InvisibleSpace]", "\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -571.053596093126000\"\>",
            -571.05359609312598,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -571.05359609302343, {20, 15}], "      ", "LIKALT  ", 
        PaddedForm[ -571.05359609312598, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.025455276248977"\[Times]10\^"-10"\),
            1.0254552762489766*^-10,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.0254552762489766*^-10, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"PSI1\"\>", "\<\"PSI\"\>", "\<\"STEP\"\>", \
"\<\"SCORE\"\>"},
          {
            "1", \(-3.9960929737425444`\), \(-3.9960922573031388`\), \
\(-7.164394057555128`*^-7\), "4.6162437406134516`*^-6"},
          {
            "2", \(-3.771984929278842`\), \(-3.77198133286859`\), \
\(-3.5964102523017977`*^-6\), "1.2644314593603795`*^-6"},
          {"3", "18.723898617588077`", "18.723884680487075`", 
            "0.00001393710100358027`", \(-1.4501740812086978`*^-7\)},
          {"4", "44.51857834054261`", "44.518574339894336`", 
            "4.000648276984044`*^-6", "4.123691272998886`*^-7"},
          {"5", "26.446159911342953`", 
            "26.446257098914305`", \(-0.00009718757135079124`\), \
\(-1.9632412134643583`*^-6\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"PSI1", "PSI", "STEP", 
          "SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("Fisher Information"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.912\"\>",
                  5.9123581095260347,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1554\"\>",
                  0.15536950852950127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5104\"\>",
                  0.51041667254706224,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.03234\"\>",
                  0.032338324495062395,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0223\"\>",
                  -0.022304905381273599,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.1554\"\>",
                  0.15536950852950115,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.259\"\>",
                  2.2586146407974468,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7738\"\>",
                  0.77382163524827285,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0006725\"\>",
                  0.00067249294544081961,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01326\"\>",
                  0.013261691090268569,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.5104\"\>",
                  0.51041667254706213,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7738\"\>",
                  0.77382163524827285,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5834\"\>",
                  0.58339505937898795,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0004008\"\>",
                  0.00040078259664862127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05277\"\>",
                  0.052772118024650622,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.03234\"\>",
                  0.032338324495062562,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0006725\"\>",
                  0.00067249294544078492,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0004008\"\>",
                  0.00040078259664862777,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.0871\"\>",
                  0.087095669429510539,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0008636\"\>",
                  -0.00086360065670319352,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.0223\"\>",
                  -0.022304905381273568,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.01326\"\>",
                  0.013261691090268556,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.05277\"\>",
                  0.052772118024650649,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.0008636\"\>",
                  -0.00086360065670319439,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02741\"\>",
                  0.027406407881214508,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MBFGS:  ENDE DER ITERATION  "\[InvisibleSpace]19\
\[InvisibleSpace]"  "\[InvisibleSpace]20\),
      SequenceForm[ "MBFGS:  ENDE DER ITERATION  ", 19, "  ", 20],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-571.1091180939013`\), \(-4.096`\), \(-3.872`\), "18.6239`", 
              "44.4186`", "26.3461`"},
            {\(-571.063266063293`\), \(-3.9435606897461892`\), \
\(-3.79404477803144`\), "18.669190365167257`", "44.42052574493462`", 
              "26.347550169166926`"},
            {\(-571.0562262914485`\), \(-3.985314660614644`\), \
\(-3.7251652903526002`\), "18.70096466076664`", "44.42421334209983`", 
              "26.35083359145458`"},
            {\(-571.0541925534442`\), \(-3.9974109097535684`\), \
\(-3.764743584524182`\), "18.69976572639378`", "44.431571504086996`", 
              "26.354222247810497`"},
            {\(-571.0540293421044`\), \(-3.9959910582826885`\), \
\(-3.767015342322515`\), "18.70942962105977`", "44.438420553151445`", 
              "26.35742543560743`"},
            {\(-571.0537570407662`\), \(-3.9962130482595897`\), \
\(-3.77732611532504`\), "18.742486712840886`", "44.46630888234648`", 
              "26.369737894661824`"},
            {\(-571.0537228033934`\), \(-3.997436611256887`\), \
\(-3.7797231006824554`\), "18.747935263963328`", "44.47632822731903`", 
              "26.373337171035335`"},
            {\(-571.0536853718639`\), \(-3.99869560427483`\), \
\(-3.7809282585194555`\), "18.749571569354405`", "44.491492056562926`", 
              "26.378055906594255`"},
            {\(-571.053651209988`\), \(-3.999014291617963`\), \
\(-3.7799344889620983`\), "18.745988351749094`", "44.50861986857235`", 
              "26.38309571163426`"},
            {\(-571.0536291818789`\), \(-3.998186427592385`\), \
\(-3.777143731016819`\), "18.738766755022567`", "44.52178299162898`", 
              "26.38727492302585`"},
            {\(-571.0536238254208`\), \(-3.997316288566697`\), \
\(-3.775353824599881`\), "18.734668646698328`", "44.52363248038622`", 
              "26.38878316181583`"},
            {\(-571.0536222021929`\), \(-3.996924358229743`\), \
\(-3.7747123288874658`\), "18.733290000817803`", "44.52253246937256`", 
              "26.38990725846634`"},
            {\(-571.0536197154079`\), \(-3.9965052733534563`\), \
\(-3.7740282410056403`\), "18.73173722841333`", "44.52076534055842`", 
              "26.392995404642647`"},
            {\(-571.0536143926748`\), \(-3.995912027514863`\), \
\(-3.772949604249319`\), "18.729003912603908`", "44.51804306234372`", 
              "26.402012705441734`"},
            {\(-571.0536062423788`\), \(-3.995385653560062`\), \
\(-3.771732454778493`\), "18.725376208081393`", "44.515512529588115`", 
              "26.419620850371`"},
            {\(-571.0535990231613`\), \(-3.9953731596656326`\), \
\(-3.7711685890169555`\), "18.722830156551034`", "44.51530682524937`", 
              "26.43950959886786`"},
            {\(-571.053596414667`\), \(-3.9957975302055657`\), \
\(-3.7715322660151065`\), "18.72291856733933`", "44.51720158841645`", 
              "26.447730158879644`"},
            {\(-571.0535961039902`\), \(-3.996050652966105`\), \
\(-3.7719011312004334`\), "18.723670828432056`", "44.51837596556214`", 
              "26.447084207567926`"},
            {\(-571.053596093126`\), \(-3.9960922573031388`\), \
\(-3.77198133286859`\), "18.723884680487075`", "44.518574339894336`", 
              "26.446257098914305`"},
            {\(-571.0535960930234`\), \(-3.9960929737425444`\), \
\(-3.771984929278842`\), "18.723898617588077`", "44.51857834054261`", 
              "26.446159911342953`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", 
          "PSI"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("INKREMENT   "\[InvisibleSpace]1.`*^-6\),
      SequenceForm[ "INKREMENT   ", 9.9999999999999995*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    \("KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"5.689899532800035`*^-7", "6.008281485678571`*^-7", 
              "3.1838195287853575`*^-8", \(-3.9960929737425444`\), 
              "3.996092973742544`*^-6"},
            {"1.8083874647402407`*^-7", 
              "1.6574505815047935`*^-7", \(-1.5093688323544718`*^-8\), \
\(-3.771984929278842`\), "3.771984929278842`*^-6"},
            {\(-2.1251126175821613`*^-8\), \(-2.4885280245500606`*^-8\), \
\(-3.6341540696789923`*^-9\), "18.723898617588077`", 
              "0.000018723898617588076`"},
            {"5.490442646926971`*^-8", 
              "5.4655786698581954`*^-8", \(-2.486397706877553`*^-10\), 
              "44.51857834054261`", "0.00004451857834054261`"},
            {\(-2.5147998911789125`*^-7\), \(-2.6033474622138425`*^-7\), \
\(-8.854757103493001`*^-9\), "26.446159911342953`", 
              "0.00002644615991134295`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SNUM", "S", "DS", "PSI", 
          "INK"}}]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", \(-3.9960929737425444`\), "6.008281485678571`*^-7"},
              {"2", \(-3.771984929278842`\), "1.6574505815047935`*^-7"},
              {"3", "18.723898617588077`", \(-2.4885280245500606`*^-8\)},
              {"4", "44.51857834054261`", "5.4655786698581954`*^-8"},
              {"5", "26.446159911342953`", \(-2.6033474622138425`*^-7\)}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", 
        "\[InvisibleSpace]", \(-571.0535960930234`\)}],
      SequenceForm[ 
        TableForm[ {{-3.9960929737425444, 
          6.008281485678571*^-07}, {-3.7719849292788421, 
          1.6574505815047935*^-07}, {
          18.723898617588077, -2.4885280245500606*^-08}, {44.518578340542611, 
          5.4655786698581954*^-08}, {
          26.446159911342953, -2.6033474622138425*^-07}}, TableHeadings -> {
          Automatic, {"THETA", "SCORE"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}], "   Likelihood = ", -571.05359609302343],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "367.3551916669009`", "5", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.5758293035489004`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.5758293035489004],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", \(-3.9960929737425444`\), "1.1934512020239392`", 
            "0.4633269760459817`"},
          {"2", \(-3.771984929278842`\), "2.6431386990359593`", 
            "1.0261311552727201`"},
          {"3", "18.723898617588077`", "6.219874284855817`", 
            "2.4147074793683965`"},
          {"4", "44.51857834054261`", "9.200792626138487`", 
            "3.571972961664001`"},
          {"5", "26.446159911342953`", "20.36760046663318`", 
            "7.9072011637461035`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.9999999999999999`", 
              "0.29130230065105095`", \(-0.4022419323468295`\), 
              "0.006245702603722514`", "0.28665068278863876`"},
            {"0.2913023006510509`", 
              "0.9999999999999998`", \(-0.7600969602754326`\), 
              "0.03125259397607349`", "0.4036024362918096`"},
            {\(-0.4022419323468295`\), \(-0.760096960275433`\), 
              "1.`", \(-0.024323022895762887`\), \(-0.571709401759655`\)},
            {"0.006245702603722688`", 
              "0.031252593976073745`", \(-0.024323022895763234`\), "1.`", 
              "0.015717513492124215`"},
            {"0.28665068278863876`", 
              "0.40360243629180953`", \(-0.5717094017596548`\), 
              "0.015717513492123705`", "1.`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.21467188673191373`", 
              "0.13849508943478767`", \(-0.4500279177048423`\), 
              "0.010336584288772006`", "1.0501790610176875`"},
            {"0.1384950894347876`", 
              "1.0529451478213272`", \(-1.8833732461500021`\), 
              "0.11455053091340399`", "3.2747597253724225`"},
            {\(-0.45002791770484235`\), \(-1.8833732461500032`\), 
              "5.830812210917674`", \(-0.20979263547529672`\), \
\(-10.915977936325866`\)},
            {"0.010336584288772294`", 
              "0.11455053091340493`", \(-0.20979263547529972`\), 
              "12.758990838858693`", "0.44393030400063604`"},
            {"1.0501790610176875`", 
              "3.274759725372422`", \(-10.915977936325863`\), 
              "0.4439303040006216`", "62.52383024394773`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({0.17765329606883642`, 0.39497107238315404`, 4.275002257581005`, 
      12.757227356959184`, 64.77639634528524`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"5.591598249225602`", "0.07074183824040914`", 
              "0.4036340231607234`", 
              "0.0024171249540506493`", \(-0.027171317863009532`\)},
            {"0.07074183824040914`", "2.258555687603877`", 
              "0.7592784597194555`", \(-0.008307184738720576`\), 
              "0.013137965494637182`"},
            {"0.4036340231607234`", "0.7592784597194555`", 
              "0.5359339320083216`", "0.000032395254915558366`", 
              "0.04702024915549092`"},
            {"0.0024171249540506493`", \(-0.008307184738720576`\), 
              "0.000032395254915558366`", 
              "0.07845471977115163`", \(-0.00015688708886094543`\)},
            {\(-0.027171317863009532`\), "0.013137965494637182`", 
              "0.04702024915549092`", \(-0.00015688708886094543`\), 
              "0.023972503159702716`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({5.6289414389053825`, 2.531830986928376`, 0.23391800512541636`, 
      0.07838693879312975`, 0.0154377220163589`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]5\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]176\),
      SequenceForm[ "U =  ", 5, "  Nue = ", 176],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "5", "12.926209987595378`", 
            "24.669138997505488`"},
          {"\<\"komp. Lik.\"\>", \(-571.0535960930234`\), \
\(-576.0535960930234`\), \(-583.9798060806188`\), \(-595.7227350905289`\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("DELTA-THEOREM"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH{TZTE STANDARDARDABWEICHUNGEN DER SYSTEM-MATRIZEN"\)], "Print"],

Cell[BoxData[
    \("A, B, OMEGA, SIGMA UND MUE"\)], "Print"],

Cell[BoxData[
    \("UND DER MESS-MODELL-MATRIZEN H, D UND R"\)], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" A     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "1.`"},
                {\(-0.39960929737425444`\), \(-0.3771984929278842`\)}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDA   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.046332697604598176`", "0.10261311552727202`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " A     ", 
        MatrixForm[ {{0.0, 
          1.0}, {-0.39960929737425444, -0.37719849292788421}}, TableHeadings -> 
          None], "   STDA   ", 
        MatrixForm[ {{0.0, 0.0}, {0.046332697604598176, 0.10261311552727202}},
           TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" B     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDB   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " B     ", 
        MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None], "   STDB   ", 
        MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"OMEGA  \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"1.`*^-8", "0.`"},
                {"0.`", "350.5843794417167`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDO   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.`", "90.42547606965101`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "OMEGA  ", 
        MatrixForm[ {{1*^-08, 0.0}, {0.0, 350.58437944171669}}, TableHeadings -> 
          None], "   STDO   ", 
        MatrixForm[ {{0.0, 0.0}, {0.0, 90.425476069651012}}, TableHeadings -> 
          None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"MUE    \"\>", "\[InvisibleSpace]", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {0.0, 0.0}, TableHeadings -> None]], 
        "\[InvisibleSpace]", "\<\"   STDMUE \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`"},
                {"0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "MUE    ", 
        MatrixForm[ {0.0, 0.0}, TableHeadings -> None], "   STDMUE ", 
        MatrixForm[ {{0.0}, {0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"SIGMA  \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"10000.`", "0.`"},
                {"0.`", "10000.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDSIG \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"},
                {"0.`", "0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ "SIGMA  ", 
        MatrixForm[ {{10000.0, 0.0}, {0.0, 10000.0}}, TableHeadings -> None], 
        "   STDSIG ", 
        MatrixForm[ {{0.0, 0.0}, {0.0, 0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" H     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"1.`", "0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDH   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0.`", "0.`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " H     ", 
        MatrixForm[ {{1.0, 0.0}}, TableHeadings -> None], "   STDH   ", 
        MatrixForm[ {{0.0, 0.0}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" D     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"44.51857834054261`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDD   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3.571972961664001`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " D     ", 
        MatrixForm[ {{44.518578340542611}}, TableHeadings -> None], 
        "   STDD   ", 
        MatrixForm[ {{3.571972961664001}}, TableHeadings -> None]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("----------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\" R     \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"26.446159911342953`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]], 
        "\[InvisibleSpace]", "\<\"   STDR   \"\>", "\[InvisibleSpace]", 
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"7.9072011637461035`"}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ BoxForm`e$, TableHeadings -> None]]]}],
      SequenceForm[ " R     ", 
        MatrixForm[ {{26.446159911342953}}, TableHeadings -> None], 
        "   STDR   ", 
        MatrixForm[ {{7.9072011637461035}}, TableHeadings -> None]],
      Editable->False]], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell["likpsi//MatrixForm", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-571.1091180939013`\), \(-4.096`\), \(-3.872`\), "18.6239`", 
              "44.4186`", "26.3461`"},
            {\(-571.063266063293`\), \(-3.9435606897461892`\), \
\(-3.79404477803144`\), "18.669190365167257`", "44.42052574493462`", 
              "26.347550169166926`"},
            {\(-571.0562262914485`\), \(-3.985314660614644`\), \
\(-3.7251652903526002`\), "18.70096466076664`", "44.42421334209983`", 
              "26.35083359145458`"},
            {\(-571.0541925534442`\), \(-3.9974109097535684`\), \
\(-3.764743584524182`\), "18.69976572639378`", "44.431571504086996`", 
              "26.354222247810497`"},
            {\(-571.0540293421044`\), \(-3.9959910582826885`\), \
\(-3.767015342322515`\), "18.70942962105977`", "44.438420553151445`", 
              "26.35742543560743`"},
            {\(-571.0537570407662`\), \(-3.9962130482595897`\), \
\(-3.77732611532504`\), "18.742486712840886`", "44.46630888234648`", 
              "26.369737894661824`"},
            {\(-571.0537228033934`\), \(-3.997436611256887`\), \
\(-3.7797231006824554`\), "18.747935263963328`", "44.47632822731903`", 
              "26.373337171035335`"},
            {\(-571.0536853718639`\), \(-3.99869560427483`\), \
\(-3.7809282585194555`\), "18.749571569354405`", "44.491492056562926`", 
              "26.378055906594255`"},
            {\(-571.053651209988`\), \(-3.999014291617963`\), \
\(-3.7799344889620983`\), "18.745988351749094`", "44.50861986857235`", 
              "26.38309571163426`"},
            {\(-571.0536291818789`\), \(-3.998186427592385`\), \
\(-3.777143731016819`\), "18.738766755022567`", "44.52178299162898`", 
              "26.38727492302585`"},
            {\(-571.0536238254208`\), \(-3.997316288566697`\), \
\(-3.775353824599881`\), "18.734668646698328`", "44.52363248038622`", 
              "26.38878316181583`"},
            {\(-571.0536222021929`\), \(-3.996924358229743`\), \
\(-3.7747123288874658`\), "18.733290000817803`", "44.52253246937256`", 
              "26.38990725846634`"},
            {\(-571.0536197154079`\), \(-3.9965052733534563`\), \
\(-3.7740282410056403`\), "18.73173722841333`", "44.52076534055842`", 
              "26.392995404642647`"},
            {\(-571.0536143926748`\), \(-3.995912027514863`\), \
\(-3.772949604249319`\), "18.729003912603908`", "44.51804306234372`", 
              "26.402012705441734`"},
            {\(-571.0536062423788`\), \(-3.995385653560062`\), \
\(-3.771732454778493`\), "18.725376208081393`", "44.515512529588115`", 
              "26.419620850371`"},
            {\(-571.0535990231613`\), \(-3.9953731596656326`\), \
\(-3.7711685890169555`\), "18.722830156551034`", "44.51530682524937`", 
              "26.43950959886786`"},
            {\(-571.053596414667`\), \(-3.9957975302055657`\), \
\(-3.7715322660151065`\), "18.72291856733933`", "44.51720158841645`", 
              "26.447730158879644`"},
            {\(-571.0535961039902`\), \(-3.996050652966105`\), \
\(-3.7719011312004334`\), "18.723670828432056`", "44.51837596556214`", 
              "26.447084207567926`"},
            {\(-571.053596093126`\), \(-3.9960922573031388`\), \
\(-3.77198133286859`\), "18.723884680487075`", "44.518574339894336`", 
              "26.446257098914305`"},
            {\(-571.0535960930234`\), \(-3.9960929737425444`\), \
\(-3.771984929278842`\), "18.723898617588077`", "44.51857834054261`", 
              "26.446159911342953`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g = Table[plot1[ColumnSelect[likpsi,{i}]//AddTimeAxis,color->{i},
\t\t\t\t\t\t\t\t\tDisplayFunction->Identity],{i,6}];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{20, 2}\),
      SequenceForm[ "Dimension der Daten  ", {20, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{20, 2}\),
      SequenceForm[ "Dimension der Daten  ", {20, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{20, 2}\),
      SequenceForm[ "Dimension der Daten  ", {20, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{20, 2}\),
      SequenceForm[ "Dimension der Daten  ", {20, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{20, 2}\),
      SequenceForm[ "Dimension der Daten  ", {20, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{20, 2}\),
      SequenceForm[ "Dimension der Daten  ", {20, 2}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Show[GraphicsArray[Partition[g,3]],PlotLabel->\"convergence of ML \
estimates\"]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41202 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.31746 0.00981006 0.31746 [
[.5 .42452 -83 0 ]
[.5 .42452 83 12 ]
[ 0 0 0 0 ]
[ 1 .41202 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .42452 -144 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(convergence) show
135.000 13.000 moveto
(of) show
153.000 13.000 moveto
(ML) show
171.000 13.000 moveto
(estimates) show
225.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41202 L
0 .41202 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981006 0.34127 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0501253 -87.2134 4.68367 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.14912 -0.0125 -9 -9 ]
[.14912 -0.0125 9 0 ]
[.27444 -0.0125 -3 -9 ]
[.27444 -0.0125 3 0 ]
[.39975 -0.0125 -9 -9 ]
[.39975 -0.0125 9 0 ]
[.52506 -0.0125 -6 -9 ]
[.52506 -0.0125 6 0 ]
[.65038 -0.0125 -12 -9 ]
[.65038 -0.0125 12 0 ]
[.77569 -0.0125 -6 -9 ]
[.77569 -0.0125 6 0 ]
[.901 -0.0125 -12 -9 ]
[.901 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09012 -30 -4.5 ]
[-0.0125 .09012 0 4.5 ]
[-0.0125 .1838 -30 -4.5 ]
[-0.0125 .1838 0 4.5 ]
[-0.0125 .27747 -30 -4.5 ]
[-0.0125 .27747 0 4.5 ]
[-0.0125 .37114 -24 -4.5 ]
[-0.0125 .37114 0 4.5 ]
[-0.0125 .46482 -30 -4.5 ]
[-0.0125 .46482 0 4.5 ]
[-0.0125 .55849 -30 -4.5 ]
[-0.0125 .55849 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .48308 -5 -6 ]
[.97619 .48308 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.14912 0 m
.14912 .00625 L
s
[(2.5)] .14912 -0.0125 0 1 Mshowa
.27444 0 m
.27444 .00625 L
s
[(5)] .27444 -0.0125 0 1 Mshowa
.39975 0 m
.39975 .00625 L
s
[(7.5)] .39975 -0.0125 0 1 Mshowa
.52506 0 m
.52506 .00625 L
s
[(10)] .52506 -0.0125 0 1 Mshowa
.65038 0 m
.65038 .00625 L
s
[(12.5)] .65038 -0.0125 0 1 Mshowa
.77569 0 m
.77569 .00625 L
s
[(15)] .77569 -0.0125 0 1 Mshowa
.901 0 m
.901 .00625 L
s
[(17.5)] .901 -0.0125 0 1 Mshowa
.125 Mabswid
.04887 0 m
.04887 .00375 L
s
.07393 0 m
.07393 .00375 L
s
.099 0 m
.099 .00375 L
s
.12406 0 m
.12406 .00375 L
s
.17419 0 m
.17419 .00375 L
s
.19925 0 m
.19925 .00375 L
s
.22431 0 m
.22431 .00375 L
s
.24937 0 m
.24937 .00375 L
s
.2995 0 m
.2995 .00375 L
s
.32456 0 m
.32456 .00375 L
s
.34962 0 m
.34962 .00375 L
s
.37469 0 m
.37469 .00375 L
s
.42481 0 m
.42481 .00375 L
s
.44987 0 m
.44987 .00375 L
s
.47494 0 m
.47494 .00375 L
s
.5 0 m
.5 .00375 L
s
.55013 0 m
.55013 .00375 L
s
.57519 0 m
.57519 .00375 L
s
.60025 0 m
.60025 .00375 L
s
.62531 0 m
.62531 .00375 L
s
.67544 0 m
.67544 .00375 L
s
.7005 0 m
.7005 .00375 L
s
.72556 0 m
.72556 .00375 L
s
.75063 0 m
.75063 .00375 L
s
.80075 0 m
.80075 .00375 L
s
.82581 0 m
.82581 .00375 L
s
.85088 0 m
.85088 .00375 L
s
.87594 0 m
.87594 .00375 L
s
.92607 0 m
.92607 .00375 L
s
.95113 0 m
.95113 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09012 m
.00625 .09012 L
s
[(18.64)] -0.0125 .09012 1 0 Mshowa
0 .1838 m
.00625 .1838 L
s
[(18.66)] -0.0125 .1838 1 0 Mshowa
0 .27747 m
.00625 .27747 L
s
[(18.68)] -0.0125 .27747 1 0 Mshowa
0 .37114 m
.00625 .37114 L
s
[(18.7)] -0.0125 .37114 1 0 Mshowa
0 .46482 m
.00625 .46482 L
s
[(18.72)] -0.0125 .46482 1 0 Mshowa
0 .55849 m
.00625 .55849 L
s
[(18.74)] -0.0125 .55849 1 0 Mshowa
.125 Mabswid
0 .01987 m
.00375 .01987 L
s
0 .04329 m
.00375 .04329 L
s
0 .0667 m
.00375 .0667 L
s
0 .11354 m
.00375 .11354 L
s
0 .13696 m
.00375 .13696 L
s
0 .16038 m
.00375 .16038 L
s
0 .20721 m
.00375 .20721 L
s
0 .23063 m
.00375 .23063 L
s
0 .25405 m
.00375 .25405 L
s
0 .30089 m
.00375 .30089 L
s
0 .32431 m
.00375 .32431 L
s
0 .34772 m
.00375 .34772 L
s
0 .39456 m
.00375 .39456 L
s
0 .41798 m
.00375 .41798 L
s
0 .4414 m
.00375 .4414 L
s
0 .48823 m
.00375 .48823 L
s
0 .51165 m
.00375 .51165 L
s
0 .53507 m
.00375 .53507 L
s
0 .58191 m
.00375 .58191 L
s
0 .60533 m
.00375 .60533 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.14912 .61178 m
.14912 .61803 L
s
.27444 .61178 m
.27444 .61803 L
s
.39975 .61178 m
.39975 .61803 L
s
.52506 .61178 m
.52506 .61803 L
s
.65038 .61178 m
.65038 .61803 L
s
.77569 .61178 m
.77569 .61803 L
s
.901 .61178 m
.901 .61803 L
s
.125 Mabswid
.04887 .61428 m
.04887 .61803 L
s
.07393 .61428 m
.07393 .61803 L
s
.099 .61428 m
.099 .61803 L
s
.12406 .61428 m
.12406 .61803 L
s
.17419 .61428 m
.17419 .61803 L
s
.19925 .61428 m
.19925 .61803 L
s
.22431 .61428 m
.22431 .61803 L
s
.24937 .61428 m
.24937 .61803 L
s
.2995 .61428 m
.2995 .61803 L
s
.32456 .61428 m
.32456 .61803 L
s
.34962 .61428 m
.34962 .61803 L
s
.37469 .61428 m
.37469 .61803 L
s
.42481 .61428 m
.42481 .61803 L
s
.44987 .61428 m
.44987 .61803 L
s
.47494 .61428 m
.47494 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.55013 .61428 m
.55013 .61803 L
s
.57519 .61428 m
.57519 .61803 L
s
.60025 .61428 m
.60025 .61803 L
s
.62531 .61428 m
.62531 .61803 L
s
.67544 .61428 m
.67544 .61803 L
s
.7005 .61428 m
.7005 .61803 L
s
.72556 .61428 m
.72556 .61803 L
s
.75063 .61428 m
.75063 .61803 L
s
.80075 .61428 m
.80075 .61803 L
s
.82581 .61428 m
.82581 .61803 L
s
.85088 .61428 m
.85088 .61803 L
s
.87594 .61428 m
.87594 .61803 L
s
.92607 .61428 m
.92607 .61803 L
s
.95113 .61428 m
.95113 .61803 L
s
.97619 .61428 m
.97619 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09012 m
1 .09012 L
s
.99375 .1838 m
1 .1838 L
s
.99375 .27747 m
1 .27747 L
s
.99375 .37114 m
1 .37114 L
s
.99375 .46482 m
1 .46482 L
s
.99375 .55849 m
1 .55849 L
s
.125 Mabswid
.99625 .01987 m
1 .01987 L
s
.99625 .04329 m
1 .04329 L
s
.99625 .0667 m
1 .0667 L
s
.99625 .11354 m
1 .11354 L
s
.99625 .13696 m
1 .13696 L
s
.99625 .16038 m
1 .16038 L
s
.99625 .20721 m
1 .20721 L
s
.99625 .23063 m
1 .23063 L
s
.99625 .25405 m
1 .25405 L
s
.99625 .30089 m
1 .30089 L
s
.99625 .32431 m
1 .32431 L
s
.99625 .34772 m
1 .34772 L
s
.99625 .39456 m
1 .39456 L
s
.99625 .41798 m
1 .41798 L
s
.99625 .4414 m
1 .4414 L
s
.99625 .48823 m
1 .48823 L
s
.99625 .51165 m
1 .51165 L
s
.99625 .53507 m
1 .53507 L
s
.99625 .58191 m
1 .58191 L
s
.99625 .60533 m
1 .60533 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 1 0 r
gsave
.97619 .48308 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07393 .22684 L
.12406 .37566 L
.17419 .37004 L
.22431 .41531 L
.27444 .57014 L
.32456 .59565 L
.37469 .60332 L
.42481 .58654 L
.47494 .55271 L
.52506 .53352 L
.57519 .52706 L
.62531 .51979 L
.67544 .50699 L
.72556 .49 L
.77569 .47807 L
.82581 .47849 L
.87594 .48201 L
.92607 .48301 L
.97619 .48308 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.00981006 0.65873 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0501253 -248.908 5.60402 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.14912 -0.0125 -9 -9 ]
[.14912 -0.0125 9 0 ]
[.27444 -0.0125 -3 -9 ]
[.27444 -0.0125 3 0 ]
[.39975 -0.0125 -9 -9 ]
[.39975 -0.0125 9 0 ]
[.52506 -0.0125 -6 -9 ]
[.52506 -0.0125 6 0 ]
[.65038 -0.0125 -12 -9 ]
[.65038 -0.0125 12 0 ]
[.77569 -0.0125 -6 -9 ]
[.77569 -0.0125 6 0 ]
[.901 -0.0125 -12 -9 ]
[.901 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02256 -30 -4.5 ]
[-0.0125 .02256 0 4.5 ]
[-0.0125 .13464 -30 -4.5 ]
[-0.0125 .13464 0 4.5 ]
[-0.0125 .24672 -30 -4.5 ]
[-0.0125 .24672 0 4.5 ]
[-0.0125 .3588 -30 -4.5 ]
[-0.0125 .3588 0 4.5 ]
[-0.0125 .47088 -24 -4.5 ]
[-0.0125 .47088 0 4.5 ]
[-0.0125 .58296 -30 -4.5 ]
[-0.0125 .58296 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .575 -5 -6 ]
[.97619 .575 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.14912 0 m
.14912 .00625 L
s
[(2.5)] .14912 -0.0125 0 1 Mshowa
.27444 0 m
.27444 .00625 L
s
[(5)] .27444 -0.0125 0 1 Mshowa
.39975 0 m
.39975 .00625 L
s
[(7.5)] .39975 -0.0125 0 1 Mshowa
.52506 0 m
.52506 .00625 L
s
[(10)] .52506 -0.0125 0 1 Mshowa
.65038 0 m
.65038 .00625 L
s
[(12.5)] .65038 -0.0125 0 1 Mshowa
.77569 0 m
.77569 .00625 L
s
[(15)] .77569 -0.0125 0 1 Mshowa
.901 0 m
.901 .00625 L
s
[(17.5)] .901 -0.0125 0 1 Mshowa
.125 Mabswid
.04887 0 m
.04887 .00375 L
s
.07393 0 m
.07393 .00375 L
s
.099 0 m
.099 .00375 L
s
.12406 0 m
.12406 .00375 L
s
.17419 0 m
.17419 .00375 L
s
.19925 0 m
.19925 .00375 L
s
.22431 0 m
.22431 .00375 L
s
.24937 0 m
.24937 .00375 L
s
.2995 0 m
.2995 .00375 L
s
.32456 0 m
.32456 .00375 L
s
.34962 0 m
.34962 .00375 L
s
.37469 0 m
.37469 .00375 L
s
.42481 0 m
.42481 .00375 L
s
.44987 0 m
.44987 .00375 L
s
.47494 0 m
.47494 .00375 L
s
.5 0 m
.5 .00375 L
s
.55013 0 m
.55013 .00375 L
s
.57519 0 m
.57519 .00375 L
s
.60025 0 m
.60025 .00375 L
s
.62531 0 m
.62531 .00375 L
s
.67544 0 m
.67544 .00375 L
s
.7005 0 m
.7005 .00375 L
s
.72556 0 m
.72556 .00375 L
s
.75063 0 m
.75063 .00375 L
s
.80075 0 m
.80075 .00375 L
s
.82581 0 m
.82581 .00375 L
s
.85088 0 m
.85088 .00375 L
s
.87594 0 m
.87594 .00375 L
s
.92607 0 m
.92607 .00375 L
s
.95113 0 m
.95113 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02256 m
.00625 .02256 L
s
[(44.42)] -0.0125 .02256 1 0 Mshowa
0 .13464 m
.00625 .13464 L
s
[(44.44)] -0.0125 .13464 1 0 Mshowa
0 .24672 m
.00625 .24672 L
s
[(44.46)] -0.0125 .24672 1 0 Mshowa
0 .3588 m
.00625 .3588 L
s
[(44.48)] -0.0125 .3588 1 0 Mshowa
0 .47088 m
.00625 .47088 L
s
[(44.5)] -0.0125 .47088 1 0 Mshowa
0 .58296 m
.00625 .58296 L
s
[(44.52)] -0.0125 .58296 1 0 Mshowa
.125 Mabswid
0 .05058 m
.00375 .05058 L
s
0 .0786 m
.00375 .0786 L
s
0 .10662 m
.00375 .10662 L
s
0 .16266 m
.00375 .16266 L
s
0 .19068 m
.00375 .19068 L
s
0 .2187 m
.00375 .2187 L
s
0 .27474 m
.00375 .27474 L
s
0 .30276 m
.00375 .30276 L
s
0 .33078 m
.00375 .33078 L
s
0 .38682 m
.00375 .38682 L
s
0 .41484 m
.00375 .41484 L
s
0 .44286 m
.00375 .44286 L
s
0 .4989 m
.00375 .4989 L
s
0 .52692 m
.00375 .52692 L
s
0 .55494 m
.00375 .55494 L
s
0 .61098 m
.00375 .61098 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.14912 .61178 m
.14912 .61803 L
s
.27444 .61178 m
.27444 .61803 L
s
.39975 .61178 m
.39975 .61803 L
s
.52506 .61178 m
.52506 .61803 L
s
.65038 .61178 m
.65038 .61803 L
s
.77569 .61178 m
.77569 .61803 L
s
.901 .61178 m
.901 .61803 L
s
.125 Mabswid
.04887 .61428 m
.04887 .61803 L
s
.07393 .61428 m
.07393 .61803 L
s
.099 .61428 m
.099 .61803 L
s
.12406 .61428 m
.12406 .61803 L
s
.17419 .61428 m
.17419 .61803 L
s
.19925 .61428 m
.19925 .61803 L
s
.22431 .61428 m
.22431 .61803 L
s
.24937 .61428 m
.24937 .61803 L
s
.2995 .61428 m
.2995 .61803 L
s
.32456 .61428 m
.32456 .61803 L
s
.34962 .61428 m
.34962 .61803 L
s
.37469 .61428 m
.37469 .61803 L
s
.42481 .61428 m
.42481 .61803 L
s
.44987 .61428 m
.44987 .61803 L
s
.47494 .61428 m
.47494 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.55013 .61428 m
.55013 .61803 L
s
.57519 .61428 m
.57519 .61803 L
s
.60025 .61428 m
.60025 .61803 L
s
.62531 .61428 m
.62531 .61803 L
s
.67544 .61428 m
.67544 .61803 L
s
.7005 .61428 m
.7005 .61803 L
s
.72556 .61428 m
.72556 .61803 L
s
.75063 .61428 m
.75063 .61803 L
s
.80075 .61428 m
.80075 .61803 L
s
.82581 .61428 m
.82581 .61803 L
s
.85088 .61428 m
.85088 .61803 L
s
.87594 .61428 m
.87594 .61803 L
s
.92607 .61428 m
.92607 .61803 L
s
.95113 .61428 m
.95113 .61803 L
s
.97619 .61428 m
.97619 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02256 m
1 .02256 L
s
.99375 .13464 m
1 .13464 L
s
.99375 .24672 m
1 .24672 L
s
.99375 .3588 m
1 .3588 L
s
.99375 .47088 m
1 .47088 L
s
.99375 .58296 m
1 .58296 L
s
.125 Mabswid
.99625 .05058 m
1 .05058 L
s
.99625 .0786 m
1 .0786 L
s
.99625 .10662 m
1 .10662 L
s
.99625 .16266 m
1 .16266 L
s
.99625 .19068 m
1 .19068 L
s
.99625 .2187 m
1 .2187 L
s
.99625 .27474 m
1 .27474 L
s
.99625 .30276 m
1 .30276 L
s
.99625 .33078 m
1 .33078 L
s
.99625 .38682 m
1 .38682 L
s
.99625 .41484 m
1 .41484 L
s
.99625 .44286 m
1 .44286 L
s
.99625 .4989 m
1 .4989 L
s
.99625 .52692 m
1 .52692 L
s
.99625 .55494 m
1 .55494 L
s
.99625 .61098 m
1 .61098 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
.541 .169 .886 r
gsave
.97619 .575 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.541 0.169 0.886 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07393 .02551 L
.12406 .04617 L
.17419 .08741 L
.22431 .12579 L
.27444 .28208 L
.32456 .33823 L
.37469 .4232 L
.42481 .51919 L
.47494 .59295 L
.52506 .60332 L
.57519 .59715 L
.62531 .58725 L
.67544 .572 L
.72556 .55781 L
.77569 .55666 L
.82581 .56728 L
.87594 .57386 L
.92607 .57497 L
.97619 .575 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.00981006 0.97619 0.206011 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0501253 -152.572 5.79163 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.14912 -0.0125 -9 -9 ]
[.14912 -0.0125 9 0 ]
[.27444 -0.0125 -3 -9 ]
[.27444 -0.0125 3 0 ]
[.39975 -0.0125 -9 -9 ]
[.39975 -0.0125 9 0 ]
[.52506 -0.0125 -6 -9 ]
[.52506 -0.0125 6 0 ]
[.65038 -0.0125 -12 -9 ]
[.65038 -0.0125 12 0 ]
[.77569 -0.0125 -6 -9 ]
[.77569 -0.0125 6 0 ]
[.901 -0.0125 -12 -9 ]
[.901 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09522 -30 -4.5 ]
[-0.0125 .09522 0 4.5 ]
[-0.0125 .21105 -30 -4.5 ]
[-0.0125 .21105 0 4.5 ]
[-0.0125 .32688 -24 -4.5 ]
[-0.0125 .32688 0 4.5 ]
[-0.0125 .44272 -30 -4.5 ]
[-0.0125 .44272 0 4.5 ]
[-0.0125 .55855 -30 -4.5 ]
[-0.0125 .55855 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .59422 -5 -6 ]
[.97619 .59422 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.14912 0 m
.14912 .00625 L
s
[(2.5)] .14912 -0.0125 0 1 Mshowa
.27444 0 m
.27444 .00625 L
s
[(5)] .27444 -0.0125 0 1 Mshowa
.39975 0 m
.39975 .00625 L
s
[(7.5)] .39975 -0.0125 0 1 Mshowa
.52506 0 m
.52506 .00625 L
s
[(10)] .52506 -0.0125 0 1 Mshowa
.65038 0 m
.65038 .00625 L
s
[(12.5)] .65038 -0.0125 0 1 Mshowa
.77569 0 m
.77569 .00625 L
s
[(15)] .77569 -0.0125 0 1 Mshowa
.901 0 m
.901 .00625 L
s
[(17.5)] .901 -0.0125 0 1 Mshowa
.125 Mabswid
.04887 0 m
.04887 .00375 L
s
.07393 0 m
.07393 .00375 L
s
.099 0 m
.099 .00375 L
s
.12406 0 m
.12406 .00375 L
s
.17419 0 m
.17419 .00375 L
s
.19925 0 m
.19925 .00375 L
s
.22431 0 m
.22431 .00375 L
s
.24937 0 m
.24937 .00375 L
s
.2995 0 m
.2995 .00375 L
s
.32456 0 m
.32456 .00375 L
s
.34962 0 m
.34962 .00375 L
s
.37469 0 m
.37469 .00375 L
s
.42481 0 m
.42481 .00375 L
s
.44987 0 m
.44987 .00375 L
s
.47494 0 m
.47494 .00375 L
s
.5 0 m
.5 .00375 L
s
.55013 0 m
.55013 .00375 L
s
.57519 0 m
.57519 .00375 L
s
.60025 0 m
.60025 .00375 L
s
.62531 0 m
.62531 .00375 L
s
.67544 0 m
.67544 .00375 L
s
.7005 0 m
.7005 .00375 L
s
.72556 0 m
.72556 .00375 L
s
.75063 0 m
.75063 .00375 L
s
.80075 0 m
.80075 .00375 L
s
.82581 0 m
.82581 .00375 L
s
.85088 0 m
.85088 .00375 L
s
.87594 0 m
.87594 .00375 L
s
.92607 0 m
.92607 .00375 L
s
.95113 0 m
.95113 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09522 m
.00625 .09522 L
s
[(26.36)] -0.0125 .09522 1 0 Mshowa
0 .21105 m
.00625 .21105 L
s
[(26.38)] -0.0125 .21105 1 0 Mshowa
0 .32688 m
.00625 .32688 L
s
[(26.4)] -0.0125 .32688 1 0 Mshowa
0 .44272 m
.00625 .44272 L
s
[(26.42)] -0.0125 .44272 1 0 Mshowa
0 .55855 m
.00625 .55855 L
s
[(26.44)] -0.0125 .55855 1 0 Mshowa
.125 Mabswid
0 .12418 m
.00375 .12418 L
s
0 .15313 m
.00375 .15313 L
s
0 .18209 m
.00375 .18209 L
s
0 .24001 m
.00375 .24001 L
s
0 .26897 m
.00375 .26897 L
s
0 .29793 m
.00375 .29793 L
s
0 .35584 m
.00375 .35584 L
s
0 .3848 m
.00375 .3848 L
s
0 .41376 m
.00375 .41376 L
s
0 .47167 m
.00375 .47167 L
s
0 .50063 m
.00375 .50063 L
s
0 .52959 m
.00375 .52959 L
s
0 .06626 m
.00375 .06626 L
s
0 .0373 m
.00375 .0373 L
s
0 .00834 m
.00375 .00834 L
s
0 .58751 m
.00375 .58751 L
s
0 .61646 m
.00375 .61646 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.14912 .61178 m
.14912 .61803 L
s
.27444 .61178 m
.27444 .61803 L
s
.39975 .61178 m
.39975 .61803 L
s
.52506 .61178 m
.52506 .61803 L
s
.65038 .61178 m
.65038 .61803 L
s
.77569 .61178 m
.77569 .61803 L
s
.901 .61178 m
.901 .61803 L
s
.125 Mabswid
.04887 .61428 m
.04887 .61803 L
s
.07393 .61428 m
.07393 .61803 L
s
.099 .61428 m
.099 .61803 L
s
.12406 .61428 m
.12406 .61803 L
s
.17419 .61428 m
.17419 .61803 L
s
.19925 .61428 m
.19925 .61803 L
s
.22431 .61428 m
.22431 .61803 L
s
.24937 .61428 m
.24937 .61803 L
s
.2995 .61428 m
.2995 .61803 L
s
.32456 .61428 m
.32456 .61803 L
s
.34962 .61428 m
.34962 .61803 L
s
.37469 .61428 m
.37469 .61803 L
s
.42481 .61428 m
.42481 .61803 L
s
.44987 .61428 m
.44987 .61803 L
s
.47494 .61428 m
.47494 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.55013 .61428 m
.55013 .61803 L
s
.57519 .61428 m
.57519 .61803 L
s
.60025 .61428 m
.60025 .61803 L
s
.62531 .61428 m
.62531 .61803 L
s
.67544 .61428 m
.67544 .61803 L
s
.7005 .61428 m
.7005 .61803 L
s
.72556 .61428 m
.72556 .61803 L
s
.75063 .61428 m
.75063 .61803 L
s
.80075 .61428 m
.80075 .61803 L
s
.82581 .61428 m
.82581 .61803 L
s
.85088 .61428 m
.85088 .61803 L
s
.87594 .61428 m
.87594 .61803 L
s
.92607 .61428 m
.92607 .61803 L
s
.95113 .61428 m
.95113 .61803 L
s
.97619 .61428 m
.97619 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09522 m
1 .09522 L
s
.99375 .21105 m
1 .21105 L
s
.99375 .32688 m
1 .32688 L
s
.99375 .44272 m
1 .44272 L
s
.99375 .55855 m
1 .55855 L
s
.125 Mabswid
.99625 .12418 m
1 .12418 L
s
.99625 .15313 m
1 .15313 L
s
.99625 .18209 m
1 .18209 L
s
.99625 .24001 m
1 .24001 L
s
.99625 .26897 m
1 .26897 L
s
.99625 .29793 m
1 .29793 L
s
.99625 .35584 m
1 .35584 L
s
.99625 .3848 m
1 .3848 L
s
.99625 .41376 m
1 .41376 L
s
.99625 .47167 m
1 .47167 L
s
.99625 .50063 m
1 .50063 L
s
.99625 .52959 m
1 .52959 L
s
.99625 .06626 m
1 .06626 L
s
.99625 .0373 m
1 .0373 L
s
.99625 .00834 m
1 .00834 L
s
.99625 .58751 m
1 .58751 L
s
.99625 .61646 m
1 .61646 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 .38 .01 r
gsave
.97619 .59422 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07393 .02311 L
.12406 .04213 L
.17419 .06176 L
.22431 .08031 L
.27444 .15162 L
.32456 .17246 L
.37469 .19979 L
.42481 .22898 L
.47494 .25318 L
.52506 .26192 L
.57519 .26843 L
.62531 .28632 L
.67544 .33854 L
.72556 .44052 L
.77569 .55571 L
.82581 .60332 L
.87594 .59958 L
.92607 .59479 L
.97619 .59422 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.206011 0.34127 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0501253 6054.5 10.6013 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.14912 -0.0125 -9 -9 ]
[.14912 -0.0125 9 0 ]
[.27444 -0.0125 -3 -9 ]
[.27444 -0.0125 3 0 ]
[.39975 -0.0125 -9 -9 ]
[.39975 -0.0125 9 0 ]
[.52506 -0.0125 -6 -9 ]
[.52506 -0.0125 6 0 ]
[.65038 -0.0125 -12 -9 ]
[.65038 -0.0125 12 0 ]
[.77569 -0.0125 -6 -9 ]
[.77569 -0.0125 6 0 ]
[.901 -0.0125 -12 -9 ]
[.901 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00537 -42 -4.5 ]
[-0.0125 .00537 0 4.5 ]
[-0.0125 .11138 -36 -4.5 ]
[-0.0125 .11138 0 4.5 ]
[-0.0125 .21739 -42 -4.5 ]
[-0.0125 .21739 0 4.5 ]
[-0.0125 .3234 -42 -4.5 ]
[-0.0125 .3234 0 4.5 ]
[-0.0125 .42942 -42 -4.5 ]
[-0.0125 .42942 0 4.5 ]
[-0.0125 .53543 -42 -4.5 ]
[-0.0125 .53543 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .60332 -5 -6 ]
[.97619 .60332 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.14912 0 m
.14912 .00625 L
s
[(2.5)] .14912 -0.0125 0 1 Mshowa
.27444 0 m
.27444 .00625 L
s
[(5)] .27444 -0.0125 0 1 Mshowa
.39975 0 m
.39975 .00625 L
s
[(7.5)] .39975 -0.0125 0 1 Mshowa
.52506 0 m
.52506 .00625 L
s
[(10)] .52506 -0.0125 0 1 Mshowa
.65038 0 m
.65038 .00625 L
s
[(12.5)] .65038 -0.0125 0 1 Mshowa
.77569 0 m
.77569 .00625 L
s
[(15)] .77569 -0.0125 0 1 Mshowa
.901 0 m
.901 .00625 L
s
[(17.5)] .901 -0.0125 0 1 Mshowa
.125 Mabswid
.04887 0 m
.04887 .00375 L
s
.07393 0 m
.07393 .00375 L
s
.099 0 m
.099 .00375 L
s
.12406 0 m
.12406 .00375 L
s
.17419 0 m
.17419 .00375 L
s
.19925 0 m
.19925 .00375 L
s
.22431 0 m
.22431 .00375 L
s
.24937 0 m
.24937 .00375 L
s
.2995 0 m
.2995 .00375 L
s
.32456 0 m
.32456 .00375 L
s
.34962 0 m
.34962 .00375 L
s
.37469 0 m
.37469 .00375 L
s
.42481 0 m
.42481 .00375 L
s
.44987 0 m
.44987 .00375 L
s
.47494 0 m
.47494 .00375 L
s
.5 0 m
.5 .00375 L
s
.55013 0 m
.55013 .00375 L
s
.57519 0 m
.57519 .00375 L
s
.60025 0 m
.60025 .00375 L
s
.62531 0 m
.62531 .00375 L
s
.67544 0 m
.67544 .00375 L
s
.7005 0 m
.7005 .00375 L
s
.72556 0 m
.72556 .00375 L
s
.75063 0 m
.75063 .00375 L
s
.80075 0 m
.80075 .00375 L
s
.82581 0 m
.82581 .00375 L
s
.85088 0 m
.85088 .00375 L
s
.87594 0 m
.87594 .00375 L
s
.92607 0 m
.92607 .00375 L
s
.95113 0 m
.95113 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00537 m
.00625 .00537 L
s
[(-571.11)] -0.0125 .00537 1 0 Mshowa
0 .11138 m
.00625 .11138 L
s
[(-571.1)] -0.0125 .11138 1 0 Mshowa
0 .21739 m
.00625 .21739 L
s
[(-571.09)] -0.0125 .21739 1 0 Mshowa
0 .3234 m
.00625 .3234 L
s
[(-571.08)] -0.0125 .3234 1 0 Mshowa
0 .42942 m
.00625 .42942 L
s
[(-571.07)] -0.0125 .42942 1 0 Mshowa
0 .53543 m
.00625 .53543 L
s
[(-571.06)] -0.0125 .53543 1 0 Mshowa
.125 Mabswid
0 .02657 m
.00375 .02657 L
s
0 .04777 m
.00375 .04777 L
s
0 .06897 m
.00375 .06897 L
s
0 .09018 m
.00375 .09018 L
s
0 .13258 m
.00375 .13258 L
s
0 .15378 m
.00375 .15378 L
s
0 .17499 m
.00375 .17499 L
s
0 .19619 m
.00375 .19619 L
s
0 .23859 m
.00375 .23859 L
s
0 .2598 m
.00375 .2598 L
s
0 .281 m
.00375 .281 L
s
0 .3022 m
.00375 .3022 L
s
0 .34461 m
.00375 .34461 L
s
0 .36581 m
.00375 .36581 L
s
0 .38701 m
.00375 .38701 L
s
0 .40821 m
.00375 .40821 L
s
0 .45062 m
.00375 .45062 L
s
0 .47182 m
.00375 .47182 L
s
0 .49302 m
.00375 .49302 L
s
0 .51423 m
.00375 .51423 L
s
0 .55663 m
.00375 .55663 L
s
0 .57783 m
.00375 .57783 L
s
0 .59904 m
.00375 .59904 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.14912 .61178 m
.14912 .61803 L
s
.27444 .61178 m
.27444 .61803 L
s
.39975 .61178 m
.39975 .61803 L
s
.52506 .61178 m
.52506 .61803 L
s
.65038 .61178 m
.65038 .61803 L
s
.77569 .61178 m
.77569 .61803 L
s
.901 .61178 m
.901 .61803 L
s
.125 Mabswid
.04887 .61428 m
.04887 .61803 L
s
.07393 .61428 m
.07393 .61803 L
s
.099 .61428 m
.099 .61803 L
s
.12406 .61428 m
.12406 .61803 L
s
.17419 .61428 m
.17419 .61803 L
s
.19925 .61428 m
.19925 .61803 L
s
.22431 .61428 m
.22431 .61803 L
s
.24937 .61428 m
.24937 .61803 L
s
.2995 .61428 m
.2995 .61803 L
s
.32456 .61428 m
.32456 .61803 L
s
.34962 .61428 m
.34962 .61803 L
s
.37469 .61428 m
.37469 .61803 L
s
.42481 .61428 m
.42481 .61803 L
s
.44987 .61428 m
.44987 .61803 L
s
.47494 .61428 m
.47494 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.55013 .61428 m
.55013 .61803 L
s
.57519 .61428 m
.57519 .61803 L
s
.60025 .61428 m
.60025 .61803 L
s
.62531 .61428 m
.62531 .61803 L
s
.67544 .61428 m
.67544 .61803 L
s
.7005 .61428 m
.7005 .61803 L
s
.72556 .61428 m
.72556 .61803 L
s
.75063 .61428 m
.75063 .61803 L
s
.80075 .61428 m
.80075 .61803 L
s
.82581 .61428 m
.82581 .61803 L
s
.85088 .61428 m
.85088 .61803 L
s
.87594 .61428 m
.87594 .61803 L
s
.92607 .61428 m
.92607 .61803 L
s
.95113 .61428 m
.95113 .61803 L
s
.97619 .61428 m
.97619 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00537 m
1 .00537 L
s
.99375 .11138 m
1 .11138 L
s
.99375 .21739 m
1 .21739 L
s
.99375 .3234 m
1 .3234 L
s
.99375 .42942 m
1 .42942 L
s
.99375 .53543 m
1 .53543 L
s
.125 Mabswid
.99625 .02657 m
1 .02657 L
s
.99625 .04777 m
1 .04777 L
s
.99625 .06897 m
1 .06897 L
s
.99625 .09018 m
1 .09018 L
s
.99625 .13258 m
1 .13258 L
s
.99625 .15378 m
1 .15378 L
s
.99625 .17499 m
1 .17499 L
s
.99625 .19619 m
1 .19619 L
s
.99625 .23859 m
1 .23859 L
s
.99625 .2598 m
1 .2598 L
s
.99625 .281 m
1 .281 L
s
.99625 .3022 m
1 .3022 L
s
.99625 .34461 m
1 .34461 L
s
.99625 .36581 m
1 .36581 L
s
.99625 .38701 m
1 .38701 L
s
.99625 .40821 m
1 .40821 L
s
.99625 .45062 m
1 .45062 L
s
.99625 .47182 m
1 .47182 L
s
.99625 .49302 m
1 .49302 L
s
.99625 .51423 m
1 .51423 L
s
.99625 .55663 m
1 .55663 L
s
.99625 .57783 m
1 .57783 L
s
.99625 .59904 m
1 .59904 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07393 .5008 L
.12406 .57544 L
.17419 .597 L
.22431 .59873 L
.27444 .60161 L
.32456 .60198 L
.37469 .60237 L
.42481 .60273 L
.47494 .60297 L
.52506 .60302 L
.57519 .60304 L
.62531 .60307 L
.67544 .60312 L
.72556 .60321 L
.77569 .60329 L
.82581 .60332 L
.87594 .60332 L
.92607 .60332 L
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.34127 0.206011 0.65873 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0501253 15.8303 3.86123 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.14912 -0.0125 -9 -9 ]
[.14912 -0.0125 9 0 ]
[.27444 -0.0125 -3 -9 ]
[.27444 -0.0125 3 0 ]
[.39975 -0.0125 -9 -9 ]
[.39975 -0.0125 9 0 ]
[.52506 -0.0125 -6 -9 ]
[.52506 -0.0125 6 0 ]
[.65038 -0.0125 -12 -9 ]
[.65038 -0.0125 12 0 ]
[.77569 -0.0125 -6 -9 ]
[.77569 -0.0125 6 0 ]
[.901 -0.0125 -12 -9 ]
[.901 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0958 -36 -4.5 ]
[-0.0125 .0958 0 4.5 ]
[-0.0125 .19233 -30 -4.5 ]
[-0.0125 .19233 0 4.5 ]
[-0.0125 .28886 -36 -4.5 ]
[-0.0125 .28886 0 4.5 ]
[-0.0125 .38539 -12 -4.5 ]
[-0.0125 .38539 0 4.5 ]
[-0.0125 .48192 -36 -4.5 ]
[-0.0125 .48192 0 4.5 ]
[-0.0125 .57846 -30 -4.5 ]
[-0.0125 .57846 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .40048 -5 -6 ]
[.97619 .40048 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.14912 0 m
.14912 .00625 L
s
[(2.5)] .14912 -0.0125 0 1 Mshowa
.27444 0 m
.27444 .00625 L
s
[(5)] .27444 -0.0125 0 1 Mshowa
.39975 0 m
.39975 .00625 L
s
[(7.5)] .39975 -0.0125 0 1 Mshowa
.52506 0 m
.52506 .00625 L
s
[(10)] .52506 -0.0125 0 1 Mshowa
.65038 0 m
.65038 .00625 L
s
[(12.5)] .65038 -0.0125 0 1 Mshowa
.77569 0 m
.77569 .00625 L
s
[(15)] .77569 -0.0125 0 1 Mshowa
.901 0 m
.901 .00625 L
s
[(17.5)] .901 -0.0125 0 1 Mshowa
.125 Mabswid
.04887 0 m
.04887 .00375 L
s
.07393 0 m
.07393 .00375 L
s
.099 0 m
.099 .00375 L
s
.12406 0 m
.12406 .00375 L
s
.17419 0 m
.17419 .00375 L
s
.19925 0 m
.19925 .00375 L
s
.22431 0 m
.22431 .00375 L
s
.24937 0 m
.24937 .00375 L
s
.2995 0 m
.2995 .00375 L
s
.32456 0 m
.32456 .00375 L
s
.34962 0 m
.34962 .00375 L
s
.37469 0 m
.37469 .00375 L
s
.42481 0 m
.42481 .00375 L
s
.44987 0 m
.44987 .00375 L
s
.47494 0 m
.47494 .00375 L
s
.5 0 m
.5 .00375 L
s
.55013 0 m
.55013 .00375 L
s
.57519 0 m
.57519 .00375 L
s
.60025 0 m
.60025 .00375 L
s
.62531 0 m
.62531 .00375 L
s
.67544 0 m
.67544 .00375 L
s
.7005 0 m
.7005 .00375 L
s
.72556 0 m
.72556 .00375 L
s
.75063 0 m
.75063 .00375 L
s
.80075 0 m
.80075 .00375 L
s
.82581 0 m
.82581 .00375 L
s
.85088 0 m
.85088 .00375 L
s
.87594 0 m
.87594 .00375 L
s
.92607 0 m
.92607 .00375 L
s
.95113 0 m
.95113 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0958 m
.00625 .0958 L
s
[(-4.075)] -0.0125 .0958 1 0 Mshowa
0 .19233 m
.00625 .19233 L
s
[(-4.05)] -0.0125 .19233 1 0 Mshowa
0 .28886 m
.00625 .28886 L
s
[(-4.025)] -0.0125 .28886 1 0 Mshowa
0 .38539 m
.00625 .38539 L
s
[(-4)] -0.0125 .38539 1 0 Mshowa
0 .48192 m
.00625 .48192 L
s
[(-3.975)] -0.0125 .48192 1 0 Mshowa
0 .57846 m
.00625 .57846 L
s
[(-3.95)] -0.0125 .57846 1 0 Mshowa
.125 Mabswid
0 .01858 m
.00375 .01858 L
s
0 .03788 m
.00375 .03788 L
s
0 .05719 m
.00375 .05719 L
s
0 .07649 m
.00375 .07649 L
s
0 .11511 m
.00375 .11511 L
s
0 .13441 m
.00375 .13441 L
s
0 .15372 m
.00375 .15372 L
s
0 .17303 m
.00375 .17303 L
s
0 .21164 m
.00375 .21164 L
s
0 .23094 m
.00375 .23094 L
s
0 .25025 m
.00375 .25025 L
s
0 .26956 m
.00375 .26956 L
s
0 .30817 m
.00375 .30817 L
s
0 .32748 m
.00375 .32748 L
s
0 .34678 m
.00375 .34678 L
s
0 .36609 m
.00375 .36609 L
s
0 .4047 m
.00375 .4047 L
s
0 .42401 m
.00375 .42401 L
s
0 .44331 m
.00375 .44331 L
s
0 .46262 m
.00375 .46262 L
s
0 .50123 m
.00375 .50123 L
s
0 .52054 m
.00375 .52054 L
s
0 .53984 m
.00375 .53984 L
s
0 .55915 m
.00375 .55915 L
s
0 .59776 m
.00375 .59776 L
s
0 .61707 m
.00375 .61707 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.14912 .61178 m
.14912 .61803 L
s
.27444 .61178 m
.27444 .61803 L
s
.39975 .61178 m
.39975 .61803 L
s
.52506 .61178 m
.52506 .61803 L
s
.65038 .61178 m
.65038 .61803 L
s
.77569 .61178 m
.77569 .61803 L
s
.901 .61178 m
.901 .61803 L
s
.125 Mabswid
.04887 .61428 m
.04887 .61803 L
s
.07393 .61428 m
.07393 .61803 L
s
.099 .61428 m
.099 .61803 L
s
.12406 .61428 m
.12406 .61803 L
s
.17419 .61428 m
.17419 .61803 L
s
.19925 .61428 m
.19925 .61803 L
s
.22431 .61428 m
.22431 .61803 L
s
.24937 .61428 m
.24937 .61803 L
s
.2995 .61428 m
.2995 .61803 L
s
.32456 .61428 m
.32456 .61803 L
s
.34962 .61428 m
.34962 .61803 L
s
.37469 .61428 m
.37469 .61803 L
s
.42481 .61428 m
.42481 .61803 L
s
.44987 .61428 m
.44987 .61803 L
s
.47494 .61428 m
.47494 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.55013 .61428 m
.55013 .61803 L
s
.57519 .61428 m
.57519 .61803 L
s
.60025 .61428 m
.60025 .61803 L
s
.62531 .61428 m
.62531 .61803 L
s
.67544 .61428 m
.67544 .61803 L
s
.7005 .61428 m
.7005 .61803 L
s
.72556 .61428 m
.72556 .61803 L
s
.75063 .61428 m
.75063 .61803 L
s
.80075 .61428 m
.80075 .61803 L
s
.82581 .61428 m
.82581 .61803 L
s
.85088 .61428 m
.85088 .61803 L
s
.87594 .61428 m
.87594 .61803 L
s
.92607 .61428 m
.92607 .61803 L
s
.95113 .61428 m
.95113 .61803 L
s
.97619 .61428 m
.97619 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0958 m
1 .0958 L
s
.99375 .19233 m
1 .19233 L
s
.99375 .28886 m
1 .28886 L
s
.99375 .38539 m
1 .38539 L
s
.99375 .48192 m
1 .48192 L
s
.99375 .57846 m
1 .57846 L
s
.125 Mabswid
.99625 .01858 m
1 .01858 L
s
.99625 .03788 m
1 .03788 L
s
.99625 .05719 m
1 .05719 L
s
.99625 .07649 m
1 .07649 L
s
.99625 .11511 m
1 .11511 L
s
.99625 .13441 m
1 .13441 L
s
.99625 .15372 m
1 .15372 L
s
.99625 .17303 m
1 .17303 L
s
.99625 .21164 m
1 .21164 L
s
.99625 .23094 m
1 .23094 L
s
.99625 .25025 m
1 .25025 L
s
.99625 .26956 m
1 .26956 L
s
.99625 .30817 m
1 .30817 L
s
.99625 .32748 m
1 .32748 L
s
.99625 .34678 m
1 .34678 L
s
.99625 .36609 m
1 .36609 L
s
.99625 .4047 m
1 .4047 L
s
.99625 .42401 m
1 .42401 L
s
.99625 .44331 m
1 .44331 L
s
.99625 .46262 m
1 .46262 L
s
.99625 .50123 m
1 .50123 L
s
.99625 .52054 m
1 .52054 L
s
.99625 .53984 m
1 .53984 L
s
.99625 .55915 m
1 .55915 L
s
.99625 .59776 m
1 .59776 L
s
.99625 .61707 m
1 .61707 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 .98 .604 r
gsave
.97619 .40048 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07393 .60332 L
.12406 .4421 L
.17419 .39539 L
.22431 .40087 L
.27444 .40002 L
.32456 .39529 L
.37469 .39043 L
.42481 .3892 L
.47494 .3924 L
.52506 .39576 L
.57519 .39727 L
.62531 .39889 L
.67544 .40118 L
.72556 .40321 L
.77569 .40326 L
.82581 .40162 L
.87594 .40064 L
.92607 .40048 L
.97619 .40048 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.65873 0.206011 0.97619 0.402213 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0501253 15.5361 4.00861 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.14912 -0.0125 -9 -9 ]
[.14912 -0.0125 9 0 ]
[.27444 -0.0125 -3 -9 ]
[.27444 -0.0125 3 0 ]
[.39975 -0.0125 -9 -9 ]
[.39975 -0.0125 9 0 ]
[.52506 -0.0125 -6 -9 ]
[.52506 -0.0125 6 0 ]
[.65038 -0.0125 -12 -9 ]
[.65038 -0.0125 12 0 ]
[.77569 -0.0125 -6 -9 ]
[.77569 -0.0125 6 0 ]
[.901 -0.0125 -12 -9 ]
[.901 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06282 -30 -4.5 ]
[-0.0125 .06282 0 4.5 ]
[-0.0125 .14299 -30 -4.5 ]
[-0.0125 .14299 0 4.5 ]
[-0.0125 .22316 -30 -4.5 ]
[-0.0125 .22316 0 4.5 ]
[-0.0125 .30334 -24 -4.5 ]
[-0.0125 .30334 0 4.5 ]
[-0.0125 .38351 -30 -4.5 ]
[-0.0125 .38351 0 4.5 ]
[-0.0125 .46368 -30 -4.5 ]
[-0.0125 .46368 0 4.5 ]
[-0.0125 .54385 -30 -4.5 ]
[-0.0125 .54385 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .41564 -5 -6 ]
[.97619 .41564 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.14912 0 m
.14912 .00625 L
s
[(2.5)] .14912 -0.0125 0 1 Mshowa
.27444 0 m
.27444 .00625 L
s
[(5)] .27444 -0.0125 0 1 Mshowa
.39975 0 m
.39975 .00625 L
s
[(7.5)] .39975 -0.0125 0 1 Mshowa
.52506 0 m
.52506 .00625 L
s
[(10)] .52506 -0.0125 0 1 Mshowa
.65038 0 m
.65038 .00625 L
s
[(12.5)] .65038 -0.0125 0 1 Mshowa
.77569 0 m
.77569 .00625 L
s
[(15)] .77569 -0.0125 0 1 Mshowa
.901 0 m
.901 .00625 L
s
[(17.5)] .901 -0.0125 0 1 Mshowa
.125 Mabswid
.04887 0 m
.04887 .00375 L
s
.07393 0 m
.07393 .00375 L
s
.099 0 m
.099 .00375 L
s
.12406 0 m
.12406 .00375 L
s
.17419 0 m
.17419 .00375 L
s
.19925 0 m
.19925 .00375 L
s
.22431 0 m
.22431 .00375 L
s
.24937 0 m
.24937 .00375 L
s
.2995 0 m
.2995 .00375 L
s
.32456 0 m
.32456 .00375 L
s
.34962 0 m
.34962 .00375 L
s
.37469 0 m
.37469 .00375 L
s
.42481 0 m
.42481 .00375 L
s
.44987 0 m
.44987 .00375 L
s
.47494 0 m
.47494 .00375 L
s
.5 0 m
.5 .00375 L
s
.55013 0 m
.55013 .00375 L
s
.57519 0 m
.57519 .00375 L
s
.60025 0 m
.60025 .00375 L
s
.62531 0 m
.62531 .00375 L
s
.67544 0 m
.67544 .00375 L
s
.7005 0 m
.7005 .00375 L
s
.72556 0 m
.72556 .00375 L
s
.75063 0 m
.75063 .00375 L
s
.80075 0 m
.80075 .00375 L
s
.82581 0 m
.82581 .00375 L
s
.85088 0 m
.85088 .00375 L
s
.87594 0 m
.87594 .00375 L
s
.92607 0 m
.92607 .00375 L
s
.95113 0 m
.95113 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06282 m
.00625 .06282 L
s
[(-3.86)] -0.0125 .06282 1 0 Mshowa
0 .14299 m
.00625 .14299 L
s
[(-3.84)] -0.0125 .14299 1 0 Mshowa
0 .22316 m
.00625 .22316 L
s
[(-3.82)] -0.0125 .22316 1 0 Mshowa
0 .30334 m
.00625 .30334 L
s
[(-3.8)] -0.0125 .30334 1 0 Mshowa
0 .38351 m
.00625 .38351 L
s
[(-3.78)] -0.0125 .38351 1 0 Mshowa
0 .46368 m
.00625 .46368 L
s
[(-3.76)] -0.0125 .46368 1 0 Mshowa
0 .54385 m
.00625 .54385 L
s
[(-3.74)] -0.0125 .54385 1 0 Mshowa
.125 Mabswid
0 .08286 m
.00375 .08286 L
s
0 .1029 m
.00375 .1029 L
s
0 .12295 m
.00375 .12295 L
s
0 .16303 m
.00375 .16303 L
s
0 .18308 m
.00375 .18308 L
s
0 .20312 m
.00375 .20312 L
s
0 .24321 m
.00375 .24321 L
s
0 .26325 m
.00375 .26325 L
s
0 .28329 m
.00375 .28329 L
s
0 .32338 m
.00375 .32338 L
s
0 .34342 m
.00375 .34342 L
s
0 .36346 m
.00375 .36346 L
s
0 .40355 m
.00375 .40355 L
s
0 .42359 m
.00375 .42359 L
s
0 .44364 m
.00375 .44364 L
s
0 .48372 m
.00375 .48372 L
s
0 .50377 m
.00375 .50377 L
s
0 .52381 m
.00375 .52381 L
s
0 .04278 m
.00375 .04278 L
s
0 .02273 m
.00375 .02273 L
s
0 .00269 m
.00375 .00269 L
s
0 .5639 m
.00375 .5639 L
s
0 .58394 m
.00375 .58394 L
s
0 .60398 m
.00375 .60398 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.14912 .61178 m
.14912 .61803 L
s
.27444 .61178 m
.27444 .61803 L
s
.39975 .61178 m
.39975 .61803 L
s
.52506 .61178 m
.52506 .61803 L
s
.65038 .61178 m
.65038 .61803 L
s
.77569 .61178 m
.77569 .61803 L
s
.901 .61178 m
.901 .61803 L
s
.125 Mabswid
.04887 .61428 m
.04887 .61803 L
s
.07393 .61428 m
.07393 .61803 L
s
.099 .61428 m
.099 .61803 L
s
.12406 .61428 m
.12406 .61803 L
s
.17419 .61428 m
.17419 .61803 L
s
.19925 .61428 m
.19925 .61803 L
s
.22431 .61428 m
.22431 .61803 L
s
.24937 .61428 m
.24937 .61803 L
s
.2995 .61428 m
.2995 .61803 L
s
.32456 .61428 m
.32456 .61803 L
s
.34962 .61428 m
.34962 .61803 L
s
.37469 .61428 m
.37469 .61803 L
s
.42481 .61428 m
.42481 .61803 L
s
.44987 .61428 m
.44987 .61803 L
s
.47494 .61428 m
.47494 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.55013 .61428 m
.55013 .61803 L
s
.57519 .61428 m
.57519 .61803 L
s
.60025 .61428 m
.60025 .61803 L
s
.62531 .61428 m
.62531 .61803 L
s
.67544 .61428 m
.67544 .61803 L
s
.7005 .61428 m
.7005 .61803 L
s
.72556 .61428 m
.72556 .61803 L
s
.75063 .61428 m
.75063 .61803 L
s
.80075 .61428 m
.80075 .61803 L
s
.82581 .61428 m
.82581 .61803 L
s
.85088 .61428 m
.85088 .61803 L
s
.87594 .61428 m
.87594 .61803 L
s
.92607 .61428 m
.92607 .61803 L
s
.95113 .61428 m
.95113 .61803 L
s
.97619 .61428 m
.97619 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06282 m
1 .06282 L
s
.99375 .14299 m
1 .14299 L
s
.99375 .22316 m
1 .22316 L
s
.99375 .30334 m
1 .30334 L
s
.99375 .38351 m
1 .38351 L
s
.99375 .46368 m
1 .46368 L
s
.99375 .54385 m
1 .54385 L
s
.125 Mabswid
.99625 .08286 m
1 .08286 L
s
.99625 .1029 m
1 .1029 L
s
.99625 .12295 m
1 .12295 L
s
.99625 .16303 m
1 .16303 L
s
.99625 .18308 m
1 .18308 L
s
.99625 .20312 m
1 .20312 L
s
.99625 .24321 m
1 .24321 L
s
.99625 .26325 m
1 .26325 L
s
.99625 .28329 m
1 .28329 L
s
.99625 .32338 m
1 .32338 L
s
.99625 .34342 m
1 .34342 L
s
.99625 .36346 m
1 .36346 L
s
.99625 .40355 m
1 .40355 L
s
.99625 .42359 m
1 .42359 L
s
.99625 .44364 m
1 .44364 L
s
.99625 .48372 m
1 .48372 L
s
.99625 .50377 m
1 .50377 L
s
.99625 .52381 m
1 .52381 L
s
.99625 .04278 m
1 .04278 L
s
.99625 .02273 m
1 .02273 L
s
.99625 .00269 m
1 .00269 L
s
.99625 .5639 m
1 .5639 L
s
.99625 .58394 m
1 .58394 L
s
.99625 .60398 m
1 .60398 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .41564 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.07393 .32721 L
.12406 .60332 L
.17419 .44466 L
.22431 .43556 L
.27444 .39423 L
.32456 .38462 L
.37469 .37979 L
.42481 .38377 L
.47494 .39496 L
.52506 .40213 L
.57519 .4047 L
.62531 .40745 L
.67544 .41177 L
.72556 .41665 L
.77569 .41891 L
.82581 .41745 L
.87594 .41597 L
.92607 .41565 L
.97619 .41564 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{565.188, 232.875},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008e0000j2000`400?l00000o`00003oo`3ooooo
0?ooocL0oooo003o0?ooool0oooo=`3oool00?l0ooooo`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo
003o0?ooool0oooo=`3oool00?l0ooooo`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo003o0?ooool0
oooo=`3oool00?l0ooooo`3ooolg0?ooo`00o`3ooon?0?ooo`8000001P3oool5000000<0oooo00<0
00000?ooo`3oool00P3oool3000000L0oooo0`0000090?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool00P3oool3000000@0oooo0`0000040?ooo`8000000P3oool300000080oooo1@00
00030?ooo`030000003oool0oooo0080oooo0`000000103oool000000000000000030?ooo`<00000
00@0oooo0000000000000000103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080
oooo0`00000Z0?ooo`00o`3ooon>0?ooo`040000003oool0oooo000000H0oooo00@000000?ooo`3o
ool000001`3oool01@000000oooo0?ooo`3oool0000000D0oooo00D000000?ooo`3oool0oooo0000
00080?ooo`030000003oool0oooo00L0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000
003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`04
0000003oool0oooo000000L0oooo00L000000?ooo`3oool0oooo0000003oool0000000<0oooo00L0
00000?ooo`3oool0oooo0000003oool0000000D0oooo00<000000?ooo`3oool01`3oool01@000000
oooo0?ooo`3oool0000002T0oooo00150?ooo`8000001P3oool5000000<0oooo00<000000?ooo`3o
ool00P3oool3000000P0oooo0`0000080?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool00P3oool3000000@0oooo0`0000040?ooo`8000000P3oool300000080oooo1@0000030?ooo`03
0000003oool0oooo0080oooo0`000000103oool000000000000000030?ooo`<000000P3oool30000
00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`<000009P3oool20000
00L0oooo1@0000030?ooo`030000003oool0oooo0080oooo0`0000070?ooo`<00000203oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0`0000050?ooo`<00000103oool20000
00040?ooo`000000000000000080oooo1@0000030?ooo`030000003oool0oooo0080oooo0`000002
0?ooo`<000000`3oool3000000040?ooo`0000000000000000@0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`020?ooo`<000009P3oool010000000oooo0?ooo`0000070?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`040000
003oool0oooo00000080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0000000L0oooo00<000000?ooo`0000001P3oool00`000000oooo0?ooo`0:0?ooo`03
0000003oool0oooo02L0oooo00140?ooo`040000003oool0oooo000000H0oooo00@000000?ooo`3o
ool000001`3oool01@000000oooo0?ooo`3oool0000000H0oooo00D000000?ooo`3oool0oooo0000
00070?ooo`030000003oool0oooo00L0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000
003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`04
0000003oool0oooo000000L0oooo00L000000?ooo`3oool0oooo0000003oool0000000<0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
1`3oool01@000000oooo0?ooo`3oool0000002@0oooo00@000000?ooo`3oool000001`3oool01000
0000oooo0?ooo`0000070?ooo`050000003oool0oooo0?ooo`0000001@3oool01@000000oooo0?oo
o`3oool0000000L0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool0000000D0
oooo00<000000?ooo`3oool00P3oool01P000000oooo0?ooo`000000oooo000000@0oooo00@00000
0?ooo`3oool000001`3oool01@000000oooo0?ooo`3oool000000080oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0000000D0oooo00<000000?ooo`3oool01`3oool01@000000
oooo0?ooo`3oool0000002D0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00
00020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02P3oool00`000000oooo0000
00070?ooo`030000003oool0000000H0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?oo
o`0W0?ooo`00A03oool010000000oooo0?ooo`0000070?ooo`030000003oool0oooo00/0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00X0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0000000L0oooo
00@000000?ooo`3oool000001P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0280
oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool00P3oool01P000000oooo0?ooo`000000oooo000000D0oooo00<0
00000?ooo`3oool02`3oool010000000oooo0?ooo`0000070?ooo`030000003oool0000000H0oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0S0?ooo`040000003oool0oooo000000D0
oooo00D000000?ooo`3oool0oooo000000070?ooo`@000001P3oool4000000/0oooo00<000000?oo
o`3oool01@3oool4000000D0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`000002
0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`050?ooo`@000000P3o
ool010000000oooo0?ooo`3oool400000080oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`050?ooo`@00000:P3oool004@0oooo00@000000?ooo`3oool00000203oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool010000000oooo
0?ooo`0000020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02P3oool00`000000
oooo000000070?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`0R0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool02P3oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool02P3oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00H000000?ooo`3oool000000?oo
o`0000060?ooo`030000003oool0oooo00X0oooo00@000000?ooo`3oool000001`3oool00`000000
oooo000000060?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool08`3oool010000000
oooo0?ooo`0000050?ooo`050000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00P0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000003o
ool0oooo00D0oooo0P0000040?ooo`050000003oool0oooo0000003oool00P0000030?ooo`050000
003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`020?ooo`8000000`3oool00`000000
oooo0?ooo`020?ooo`8000000`3oool01@000000oooo0?ooo`3oool0000000L0oooo00<000000?oo
o`3oool0:`3oool004@0oooo00@000000?ooo`3oool000001@3oool01@000000oooo0?ooo`3oool0
000000L0oooo100000070?ooo`@000002P3oool00`000000oooo0?ooo`050?ooo`@000001@3oool0
0`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00D000000?ooo`3oool0oooo
000000030?ooo`030000003oool0oooo00D0oooo100000020?ooo`040000003oool0oooo0?ooo`@0
00000`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo1000000U0?ooo`04
0000003oool0oooo000000H0oooo00D000000?ooo`3oool0oooo000000070?ooo`@000001P3oool4
000000X0oooo00<000000?ooo`3oool01@3oool4000000H0oooo00<000000?ooo`3oool00P3oool0
1P000000oooo0?ooo`000000oooo000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`@0
00000`3oool010000000oooo0?ooo`3oool400000080oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`050?ooo`@000009`3oool2000000L0oooo0`0000080?ooo`D000001@3oool50000
00H0oooo1@0000070?ooo`D00000103oool00`000000oooo0?ooo`030?ooo`8000000`3oool00`00
0000oooo0?ooo`020?ooo`<00000203oool5000000030?ooo`000000oooo0080oooo1@0000000`3o
ool000000?ooo`020?ooo`D000001`3oool5000002T0oooo00140?ooo`040000003oool0oooo0000
00D0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool01`3oool01@000000oooo0?ooo`3oool0000000L0oooo00<000000?ooo`3oool01@3o
ool2000000@0oooo00D000000?ooo`3oool000000?ooo`02000000<0oooo00D000000?ooo`3oool0
oooo000000070?ooo`030000003oool0oooo0080oooo0P0000030?ooo`030000003oool0oooo00<0
oooo0P0000030?ooo`050000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`0V0?oo
o`040000003oool0oooo000000H0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool0000000L0oooo
00<000000?ooo`3oool01P3oool2000000@0oooo00<000000?ooo`3oool00`0000030?ooo`050000
003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`030?ooo`8000000`3oool00`000000
oooo0?ooo`020?ooo`8000000`3oool01@000000oooo0?ooo`3oool0000000L0oooo00<000000?oo
o`3oool0c`3oool004D0oooo0P0000070?ooo`<00000203oool5000000H0oooo1@0000050?ooo`D0
00001`3oool5000000@0oooo00<000000?ooo`3oool00`3oool2000000<0oooo00<000000?ooo`3o
ool00P3oool3000000P0oooo1@0000000`3oool000000?ooo`020?ooo`D000000P3oool010000000
oooo0?ooo`3oool5000000L0oooo1@00000U0?ooo`800000203oool3000000P0oooo1@0000050?oo
o`D000001@3oool5000000L0oooo1@0000050?ooo`030000003oool0oooo00<0oooo0P0000020?oo
o`030000003oool0oooo0080oooo0`0000080?ooo`D000000P3oool010000000oooo0?ooo`3oool5
000000030?ooo`000000oooo0080oooo1@0000070?ooo`D00000c@3oool00?l0ooooo`3ooolg0?oo
o`00o`3ooon<0?oooh@000009P3oool004<0ooooP`00000Q0?oooh@00000803oool200000080oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo02@0oooo
00130?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000`3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool000000P3o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool01@000000
oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000000<0oooo00@000000?ooo`3oool000000P3oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000P3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool0oooo0`0000030?ooo`<000000`3oool00`000000oooo
0?ooo`030?ooo`<0000000<0oooo0000000000000`0000030?ooo`040000003oool0oooo00000080
oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo000000<0oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?ooo`050000003oool0
oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`050000003oool0oooo0?ooo`00
00000P3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000`3oool010000000oooo0?ooo`0000020?ooo`050000003oool0oooo0?ooo`00
00000P3oool010000000oooo0?ooo`0000020?ooo`050000003oool0oooo0?ooo`0000000P3oool0
10000000oooo0?ooo`0000020?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`0N0?ooo`040000003oool0oooo0?ooo`@0of42N`3oool00`000000oooo0?ooo`0T0?ooo`00
@`3oool010000000oooo0?ooo`3oo`1n0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`090?ooo`050000003oool0oooo0?ooo`0000000P3oool01@00
0000oooo0?ooo`3oool000000080oooo0`2::n9m0?ooo`030000003oool0oooo01h0oooo00<00000
0?ooo`3oool01@3oool50?mQ0WH0oooo00<000000?ooo`3oool0903oool004<0oooo00@000000?oo
o`3oool0ool0OP3oool00`000000oooo00000004000000030?ooo`000000000000<000001`3oool5
000000<0oooo00<000000?ooo`3oool00`3oool2000000@0oooo0`2::n9i0?ooo`800000803oool0
0`000000oooo0?ooo`0:0?ooo`<0of42L`3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool01000
0000oooo0?ooo`3oo`1n0?ooo`030000003oool000000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`060?ooo`@0RR_RMP3oool00`000000oooo0?ooo`0N0?ooo`800000
3P3oool30?mQ0W00oooo00<000000?ooo`3oool0903oool004<0oooo00D000000?ooo`3oool0oooo
0?oo001m0?ooo`060000003oool0oooo0000003oool000000`3oool00`000000oooo000000090?oo
o`030000003oool000000080oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0
oooo00X0oooo0`2::n9c0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0403oool2
0?mQ0Vh0oooo00<000000?ooo`3oool0903oool004<0oooo00D000000?ooo`3oool0oooo0?oo001m
0?ooo`040000003oool0oooo0?ooo`800000103oool2000000X0oooo0P0000020?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0=0?ooo`80RR_RL@3oool00`000000oooo
0?ooo`0N0?ooo`030000003oool0oooo0180oooo0P3oH@9/0?ooo`030000003oool0oooo02@0oooo
00130?ooo`050000003oool0oooo0?ooo`3oo`00O@3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool010000000oooo0?ooo`3oool3000000@0
oooo0P00000@0?ooo`0308X[hP3oool0oooo06d0oooo0P00000P0?ooo`030000003oool0oooo01@0
oooo0`3oH@9Y0?ooo`030000003oool0oooo02@0oooo00130?ooo`050000003oool0oooo0?ooo`3o
o`00O@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0100oooo00<0RR_R0?ooo`3o
ool0K@3oool00`000000oooo0?ooo`0N0?ooo`800000603oool30?mQ0VH0oooo00<000000?ooo`3o
ool0903oool004<0oooo00D000000?ooo`3oool0oooo0?oo001m0?ooo`030000003oool0oooo01l0
oooo00<000000?ooo`3oool04@3oool00`2::n80oooo0?ooo`1/0?ooo`030000003oool0000000@0
00000P3oool3000000@0oooo00<000000?ooo`3oool00P3oool3000000<0oooo0`0000030?ooo`03
0000003oool0oooo01X0oooo0P3oH@9T0?ooo`030000003oool0oooo02@0oooo000T0?ooo`<00000
0`3oool3000000@0oooo00<000000?ooo`3oool00P3oool3000000@0oooo0`0000030?ooo`030000
003oool0oooo0080oooo00<0ool00?ooo`3oool0NP3oool00`000000oooo0?ooo`0O0?ooo`030000
003oool0oooo0180oooo00<0RR_R0?ooo`3oool0J`3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0000000<0oooo00<000000?ooo`3oool01@3oool01`000000oooo0?ooo`3oool00000
0?ooo`0000000`3oool010000000oooo0?ooo`00000M0?ooo`030?mQ0P3oool0oooo0680oooo00<0
00000?ooo`3oool0903oool002D0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003o
ool0oooo00D0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`3oo`00oooo0?ooo`1j0?ooo`030000003oool0oooo01l0oooo
0P00000D0?ooo`0308X[hP3oool0oooo06T0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00000`3oool00`000000oooo0?ooo`090?ooo`030000003oool0000000<0oooo00<000000?ooo`3o
ool00P00000M0?ooo`030?mQ0P3oool0oooo0600oooo0P00000V0?ooo`009@3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01@3oool01P000000oooo0?ooo`3oool00000
0?ooo`D000000`3oool00`000000oooo0?ooo`020?ooo`030?oo003oool0oooo07X0oooo00<00000
0?ooo`3oool07`3oool00`000000oooo0?ooo`0D0?ooo`80RR_RJP3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@000002P3oool200000080oooo100000030?ooo`030000003oool0
oooo01d0oooo00<0of420?ooo`3oool0H03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`00
0000oooo0?ooo`020?ooo`<00000203oool400000080oooo00@000000?ooo`3oool00000103oool0
0`000000oooo0?ooo`020?ooo`030?oo003oool0oooo07X0oooo00<000000?ooo`3oool07`3oool0
0`000000oooo0?ooo`0F0?ooo`0308X[hP3oool0oooo06L0oooo00<000000?ooo`0000000`3oool0
0`000000oooo0000000?0?ooo`030000003oool0000000H0oooo00<000000?ooo`3oool07@3oool0
0`3oH@80oooo0?ooo`1P0?ooo`030000003oool0oooo02@0oooo000U0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`000000103oool00`000000oooo0?ooo`020?ooo`030?oo003oool0oooo07X0oooo00<00000
0?ooo`3oool07`3oool2000001P0oooo00<0RR_R0?ooo`3oool0I@3oool2000000030?ooo`000000
oooo0080oooo00@000000?ooo`3oool000002P3oool01@000000oooo0?ooo`3oool000000080oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0N0?ooo`030?mQ0P3oool0oooo05l0oooo
00<000000?ooo`3oool0903oool002@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000
203oool00`000000oooo0?ooo`040?ooo`800000103oool00`000000oooo0?ooo`030?ooo`030?oo
003oool0oooo07T0oooo00@000000?ooo`3oool0oooo0`0000030?ooo`<000000`3oool00`000000
oooo0?ooo`030?ooo`<000000`3oool3000000<0oooo00<000000?ooo`3oool0603oool00`2::n80
oooo0?ooo`1U0?ooo`030000003oool0oooo00<00000103oool2000000T0oooo0`0000040?ooo`80
00000`3oool2000001l0oooo00<0of420?ooo`3oool0G`3oool00`000000oooo0?ooo`0T0?ooo`00
9@3oool00`000000oooo0?ooo`020?ooo`<000002P3oool2000000D0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`030?ooo`030?oo003oool0oooo07T0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01T0oooo00<0RR_R0?ooo`3oool0
I03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01l0oooo00<0of420?ooo`3oool0
GP3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo0?ooo`030?ooo`030?oo003o
ool0oooo07T0oooo00<000000?ooo`000000100000000`3oool0000000000003000000L0oooo1@00
00000`3oool0000000000003000000<0oooo00<000000?ooo`3oool06P3oool00`2::n80oooo0?oo
o`1S0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0803oool00`3oH@80oooo0?oo
o`1M0?ooo`030000003oool0oooo02@0oooo00130?ooo`030000003oool0oooo00<0oooo00<0ool0
0?ooo`3oool0N@3oool00`000000oooo000000020?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool01P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0
oooo0P00000K0?ooo`0308X[hP3oool0oooo0680oooo0P00000P0?ooo`030000003oool0oooo0200
oooo00<0of420?ooo`3oool0G@3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo
0?ooo`040?ooo`030?oo003oool0oooo07P0oooo00H000000?ooo`3oool000000?ooo`0000030?oo
o`030000003oool0000000T0oooo00<000000?ooo`0000000`3oool00`000000oooo000000040?oo
o`030000003oool0oooo01/0oooo00<0RR_R0?ooo`3oool0HP3oool00`000000oooo0?ooo`0N0?oo
o`8000008P3oool20?mQ0Ud0oooo00<000000?ooo`3oool0903oool004<0oooo00<000000?ooo`3o
ool0103oool00`3oo`00oooo0?ooo`1h0?ooo`040000003oool0oooo0?ooo`800000103oool20000
00X0oooo0P0000040?ooo`800000103oool00`000000oooo0?ooo`0K0?ooo`0308X[hP3oool0oooo
0680oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0S0?ooo`<0of42FP3oool00`00
0000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo0?ooo`040?ooo`030?oo003oool0oooo07P0
oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01/0
oooo00<0RR_R0?ooo`3oool0HP3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02H0
oooo0P3oH@9H0?ooo`030000003oool0oooo02@0oooo000T0?ooo`<000000`3oool3000000@0oooo
00<000000?ooo`3oool00P3oool3000000<0oooo0`0000040?ooo`030000003oool0oooo00@0oooo
00<0ool00?ooo`3oool0N03oool00`000000oooo0?ooo`0O0?ooo`8000007@3oool00`2::n80oooo
0?ooo`1P0?ooo`800000803oool00`000000oooo0?ooo`0X0?ooo`80of42EP3oool00`000000oooo
0?ooo`0T0?ooo`009@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
1@3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool01@000000oooo0?ooo`3oool0
000000H0oooo00<0ool00?ooo`3oool0N03oool00`000000oooo0?ooo`0O0?ooo`030000003oool0
oooo01`0oooo00<0RR_R0?ooo`3oool0H@3oool00`000000oooo0?ooo`0N0?ooo`800000:`3oool2
0?mQ0U@0oooo00<000000?ooo`3oool0903oool002D0oooo00D000000?ooo`3oool0oooo00000003
0?ooo`030000003oool0oooo00D0oooo00L000000?ooo`3oool0oooo0000003oool0000000<0oooo
00D000000?ooo`3oool0oooo000000070?ooo`030?oo003oool0oooo07L0oooo00<000000?ooo`3o
ool07`3oool00`000000oooo0?ooo`0L0?ooo`0308X[hP3oool0oooo0640oooo00<000000?ooo`00
0000100000020?ooo`<00000103oool00`000000oooo0?ooo`020?ooo`<000000`3oool3000000<0
oooo00<000000?ooo`3oool0;03oool20?mQ0U80oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool00P3oool3000000P0oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`050?ooo`030?oo003oool0oooo07L0oooo00<000000?ooo`3oool07`3oool2000001h0oooo
00<0RR_R0?ooo`3oool0G`3oool200000080oooo00H000000?ooo`3oool000000?ooo`0000030?oo
o`030000003oool0oooo00D0oooo00L000000?ooo`3oool0oooo0000003oool0000000<0oooo00@0
00000?ooo`3oool00000<03oool20?mQ0U00oooo00<000000?ooo`3oool0903oool002D0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<0ool00?ooo`3oool0
M`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01d0oooo00<0RR_R0?ooo`3oool0
H03oool01@000000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo0000000;0?oo
o`030000003oool0000000<0oooo00@000000?ooo`3oool00000<P3oool20?mQ0Th0oooo00<00000
0?ooo`3oool0903oool002@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000203oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool0
0`3oo`00oooo0?ooo`1g0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool07@3oool0
0`2::n80oooo0?ooo`1P0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01000000:
0?ooo`8000000`3oool3000000<0oooo0P00000c0?ooo`030?mQ0P3oool0oooo04X0oooo0P00000V
0?ooo`009@3oool00`000000oooo0?ooo`020?ooo`<000002P3oool2000000@0oooo0P0000040?oo
o`030000003oool0oooo00D0oooo00<0ool00?ooo`3oool0M`3oool00`000000oooo0?ooo`0O0?oo
o`030000003oool0oooo01h0oooo00<0RR_R0?ooo`3oool0G`3oool00`000000oooo000000030?oo
o`030000003oool0000000l0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`00000e
0?ooo`80of42B`3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo0?ooo`060?oo
o`030?oo003oool0oooo07H0oooo00<000000?ooo`3oool07`3oool2000001l0oooo00<0RR_R0?oo
o`3oool0GP3oool2000000030?ooo`000000oooo0080oooo00@000000?ooo`3oool000002P3oool0
1`000000oooo0?ooo`3oool000000?ooo`0000000`3oool010000000oooo0?ooo`00000g0?ooo`80
of42B@3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo0?ooo`060?ooo`030?oo
003oool0oooo07H0oooo00@000000?ooo`3oool0oooo0`0000030?ooo`<000000`3oool00`000000
oooo0?ooo`030?ooo`<000000P3oool3000000@0oooo00<000000?ooo`3oool07P3oool00`2::n80
oooo0?ooo`1O0?ooo`030000003oool0oooo00<00000103oool2000000T0oooo0`0000030?ooo`<0
00000`3oool2000003P0oooo0`3oH@960?ooo`030000003oool0oooo02@0oooo00130?ooo`030000
003oool0oooo00H0oooo00<0ool00?ooo`3oool0MP3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool010000000oooo0?ooo`0000030?ooo`05
0000003oool0oooo0?ooo`0000008@3oool00`2::n80oooo0?ooo`1N0?ooo`030000003oool0oooo
01h0oooo00<000000?ooo`3oool0>P3oool20?mQ0T@0oooo00<000000?ooo`3oool0903oool004<0
oooo00<000000?ooo`3oool01`3oool00`3oo`00oooo0?ooo`1e0?ooo`030000003oool0000000@0
000000<0oooo0000000000000`0000070?ooo`D0000000<0oooo0000003oool00P3oool01@000000
oooo0?ooo`3oool000000240oooo00<0RR_R0?ooo`3oool0GP3oool00`000000oooo0?ooo`0N0?oo
o`030000003oool0oooo03`0oooo103oH@900?ooo`030000003oool0oooo02@0oooo00130?ooo`03
0000003oool0oooo00L0oooo00<0ool00?ooo`3oool0M@3oool00`000000oooo000000020?ooo`04
0000003oool0oooo00000080oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`000002
0?ooo`@00000103oool200000200oooo00<0RR_R0?ooo`3oool0G@3oool200000200oooo00<00000
0?ooo`3oool0@03oool70?mQ0ST0oooo00<000000?ooo`3oool0903oool002@0oooo0`0000030?oo
o`<00000103oool00`000000oooo0?ooo`020?ooo`<000000`3oool3000000@0oooo00<000000?oo
o`3oool01`3oool00`3oo`00oooo0?ooo`1e0?ooo`060000003oool0oooo0000003oool000000`3o
ool00`000000oooo000000090?ooo`030000003oool000000080oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`0P0?ooo`0308X[hP3oool0oooo05d0oooo00<000000?ooo`3oool07P3o
ool2000004P0oooo1@3oH@8d0?ooo`030000003oool0oooo02@0oooo000U0?ooo`050000003oool0
oooo0?ooo`0000000`3oool00`000000oooo0?ooo`050?ooo`070000003oool0oooo0?ooo`000000
oooo000000030?ooo`050000003oool0oooo0?ooo`0000002P3oool00`3oo`00oooo0?ooo`1d0?oo
o`040000003oool0oooo0?ooo`800000103oool2000000X0oooo0P0000030?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0803oool00`2::n80oooo0?ooo`1M0?ooo`030000003oool0
oooo01h0oooo00<000000?ooo`3oool0C03oool30?mQ0S40oooo00<000000?ooo`3oool0903oool0
02D0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00D0oooo00L00000
0?ooo`3oool0oooo0000003oool0000000<0oooo00D000000?ooo`3oool0oooo0000000:0?ooo`03
0?oo003oool0oooo07@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00T0oooo00<000000?ooo`3oool00P3oool2000000@0oooo0P00000Q0?ooo`03
08X[hP3oool0oooo05`0oooo0P00000P0?ooo`030000003oool0oooo04l0oooo00<0of420?ooo`3o
ool0;P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`020?ooo`<00000
203oool4000000<0oooo0`0000040?ooo`030000003oool0oooo00P0oooo00<0ool00?ooo`3oool0
M03oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0240oooo00<0RR_R0?ooo`3oool0
G03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo0500oooo00<0of420?ooo`3oool0
;@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool01@000000oooo0?ooo`3oool0000000<0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`030?ooo`050000003oool0oooo0?ooo`00
00000`3oool00`000000oooo0?ooo`090?ooo`030?oo003oool0oooo07<0oooo00<000000?ooo`3o
ool07`3oool00`000000oooo0?ooo`0Q0?ooo`0308X[hP3oool0oooo05`0oooo00<000000?ooo`3o
ool07P3oool200000580oooo00<0of420?ooo`3oool0;03oool00`000000oooo0?ooo`0T0?ooo`00
903oool2000000<0oooo00D000000?ooo`3oool0oooo000000080?ooo`030000003oool0oooo0080
oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00T0oooo00<0ool00?oo
o`3oool0L`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0280oooo00<0RR_R0?oo
o`3oool0F`3oool00`000000oooo0?ooo`050?ooo`D000000P3oool3000000@0oooo00<000000?oo
o`3oool00`3oool300000080oooo00<000000?ooo`3oool0DP3oool00`3oH@80oooo0?ooo`0[0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0080oooo0`00000:0?ooo`80
00000`3oool3000000@0oooo00<000000?ooo`3oool02@3oool00`3oo`00oooo0?ooo`1c0?ooo`03
0000003oool0oooo01l0oooo0P00000T0?ooo`0308X[hP3oool0oooo05T0oooo0P0000080?ooo`06
0000003oool0oooo0000003oool000000`3oool00`000000oooo0?ooo`080?ooo`050000003oool0
oooo0?ooo`000000E@3oool00`3oH@80oooo0?ooo`0Z0?ooo`030000003oool0oooo02@0oooo0013
0?ooo`030000003oool0oooo00X0oooo00<0ool00?ooo`3oool0LP3oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo02@0oooo00<0RR_R0?ooo`3oool0F@3oool00`000000oooo0?ooo`07
0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`050?ooo`D000000P3o
ool00`000000oooo0?ooo`1D0?ooo`030?mQ0P3oool0oooo02T0oooo00<000000?ooo`3oool0903o
ool004<0oooo00<000000?ooo`3oool02P3oool00`3oo`00oooo0?ooo`1b0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool0903oool00`2::n80oooo0?ooo`1I0?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0100000080?ooo`040000003oool0oooo000000<0oooo0P00
001F0?ooo`030?mQ0P3oool0oooo02L0oooo0P00000V0?ooo`00@`3oool00`000000oooo0?ooo`0:
0?ooo`030?oo003oool0oooo0780oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0U
0?ooo`0308X[hP3oool0oooo05P0oooo00<000000?ooo`3oool01@3oool01`000000oooo0?ooo`3o
ool000000?ooo`000000303oool00`000000oooo000000030?ooo`030000003oool0oooo05H0oooo
00<0of420?ooo`3oool09`3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo0?oo
o`0;0?ooo`030?oo003oool0oooo0740oooo00<000000?ooo`3oool07`3oool2000002L0oooo00<0
RR_R0?ooo`3oool0EP3oool2000000L0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0oooo00X0oooo0P0000030?ooo`030000003oool0oooo05H0oooo00<0of420?ooo`3oool0
9`3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo0?ooo`0;0?ooo`030?oo003o
ool0oooo0740oooo00@000000?ooo`3oool0oooo0`0000030?ooo`<000000`3oool00`000000oooo
0?ooo`030?ooo`<000000P3oool3000000@0oooo00<000000?ooo`3oool09`3oool00`2::n80oooo
0?ooo`1F0?ooo`030000003oool0oooo00H0oooo0`0000040?ooo`8000002`3oool01@000000oooo
0?ooo`3oool0000005T0oooo00<0of420?ooo`3oool09P3oool00`000000oooo0?ooo`0T0?ooo`00
@`3oool00`000000oooo0?ooo`0;0?ooo`030?oo003oool0oooo0740oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00T0oooo00@000000?ooo`3oool0
00000`3oool01@000000oooo0?ooo`3oool0000002T0oooo00<0RR_R0?ooo`3oool0EP3oool00`00
0000oooo0?ooo`0N0?ooo`800000F03oool00`3oH@80oooo0?ooo`0V0?ooo`030000003oool0oooo
02@0oooo000Z0?ooo`<000000`3oool3000000@0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo00`0oooo00<0ool00?ooo`3oool0L03oool00`000000
oooo00000004000000030?ooo`000000000000<000001`3oool5000000030?ooo`000000oooo0080
oooo00@000000?ooo`3oool0oooo0P00000Y0?ooo`0308X[hP3oool0oooo05@0oooo0P00000P0?oo
o`030000003oool0oooo05P0oooo00<0of420?ooo`3oool09@3oool00`000000oooo0?ooo`0T0?oo
o`00:`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo00`0oooo00<0ool00?ooo`3oool0L03oool00`00
0000oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01P3oool0
10000000oooo0?ooo`0000030?ooo`<00000103oool00`000000oooo0?ooo`0Y0?ooo`0308X[hP3o
ool0oooo05@0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1H0?ooo`030?mQ0P3o
ool0oooo02D0oooo00<000000?ooo`3oool0903oool002/0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`0<0?ooo`040?oo003oool0oooo0?ooo`D0ool0JP3oool01P000000oooo0?ooo`000000oooo0000
00<0oooo00<000000?ooo`0000002@3oool00`000000oooo000000020?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0Y0?ooo`0308X[hP3oool0oooo05@0oooo00<00000
0?ooo`3oool07P3oool2000005T0oooo00<0of420?ooo`3oool09@3oool00`000000oooo0?ooo`0T
0?ooo`00:`3oool00`000000oooo0?ooo`020?ooo`<000002`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00d0oooo0`3oo`050?ooo`030?oo003oool0oooo06L0oooo00@000000?oo
o`3oool0oooo0P0000040?ooo`8000002P3oool200000080oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02X0oooo00<0RR_R0?ooo`3oool0D`3oool00`000000oooo0?oo
o`0N0?ooo`030000003oool0oooo05T0oooo00<0of420?ooo`3oool0903oool00`000000oooo0?oo
o`0T0?ooo`00:`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool02@3o
ool01@000000oooo0?ooo`3oool0000001P0oooo00<0ool00?ooo`3oool0IP3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool010000000oooo
0?ooo`3oool3000000@0oooo0P00000/0?ooo`0308X[hP3oool0oooo0540oooo0P00000P0?ooo`03
0000003oool0oooo05T0oooo00<0of420?ooo`3oool0903oool00`000000oooo0?ooo`0T0?ooo`00
:P3oool2000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`050000003oool0oooo0?oo
o`0000000`3oool00`000000oooo0?ooo`0G0?ooo`030?oo003oool0oooo06D0oooo00<000000?oo
o`3oool07`3oool00`000000oooo0?ooo`0[0?ooo`0308X[hP3oool0oooo0580oooo00<000000?oo
o`3oool07P3oool00`000000oooo0?ooo`1J0?ooo`030?mQ0P3oool0oooo02<0oooo00<000000?oo
o`3oool0903oool002/0oooo00<000000?ooo`3oool00P3oool3000000P0oooo1@0000030?ooo`03
0000003oool0oooo01P0oooo00<0ool00?ooo`3oool0I03oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo02`0oooo00<0RR_R0?ooo`3oool0D@3oool00`000000oooo0?ooo`0N0?ooo`80
0000F`3oool00`3oH@80oooo0?ooo`0S0?ooo`030000003oool0oooo02@0oooo00130?ooo`030000
003oool0oooo01T0oooo00<0ool00?ooo`3oool0H`3oool00`000000oooo0?ooo`0O0?ooo`030000
003oool0oooo02`0oooo00<0RR_R0?ooo`3oool0D@3oool00`000000oooo0000000400000080oooo
0`0000040?ooo`030000003oool0oooo00<0oooo0`0000000`3oool000000000000300000080oooo
00<000000?ooo`3oool0F`3oool00`3oH@80oooo0?ooo`0R0?ooo`030000003oool0oooo02@0oooo
00130?ooo`030000003oool0oooo01X0oooo00<0ool00?ooo`3oool0HP3oool00`000000oooo0?oo
o`0O0?ooo`800000;P3oool00`2::n80oooo0?ooo`1?0?ooo`8000000P3oool01P000000oooo0?oo
o`000000oooo000000<0oooo00<000000?ooo`3oool0203oool01@000000oooo0?ooo`3oool00000
0080oooo00@000000?ooo`3oool00000G@3oool00`3oH@80oooo0?ooo`0R0?ooo`030000003oool0
oooo02@0oooo00130?ooo`030000003oool0oooo01X0oooo00<0ool00?ooo`3oool0HP3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo02h0oooo00<0RR_R0?ooo`3oool0C`3oool01@00
0000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`D000000`3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo05/0oooo00<0of420?ooo`3oool08P3o
ool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo0?ooo`0K0?ooo`030?oo003oool0
oooo0640oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0^0?ooo`0308X[hP3oool0
oooo04l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`04000000P0oooo00@00000
0?ooo`3oool000001@3oool010000000oooo0?ooo`3oool2000005d0oooo00<0of420?ooo`3oool0
803oool2000002H0oooo00130?ooo`030000003oool0oooo01/0oooo00<0ool00?ooo`3oool0H@3o
ool00`000000oooo0?ooo`0O0?ooo`800000<03oool00`2::n80oooo0?ooo`1=0?ooo`80000000<0
oooo0000003oool00P3oool00`000000oooo0000000<0?ooo`030000003oool000000080oooo00D0
00000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo05`0oooo00<0of420?ooo`3oool0
8@3oool00`000000oooo0?ooo`0T0?ooo`00903oool3000000<0oooo0`0000040?ooo`030000003o
ool0oooo00<0oooo00@000000?ooo`3oool0oooo1@0000030?ooo`030000003oool0oooo01/0oooo
00<0ool00?ooo`3oool0H@3oool00`000000oooo0?ooo`070?ooo`<000000`3oool3000000<0oooo
00<000000?ooo`3oool00P3oool3000000@0oooo00<000000?ooo`3oool0;`3oool00`2::n80oooo
0?ooo`1>0?ooo`030000003oool0000000<0oooo00@000000?ooo`3oool00000303oool200000080
oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo05d0oooo00<0of420?oo
o`3oool0803oool00`000000oooo0?ooo`0T0?ooo`009@3oool01@000000oooo0?ooo`3oool00000
00<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo
000000<0oooo00<000000?ooo`3oool0703oool00`3oo`00oooo0?ooo`1P0?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`050000003oool0
oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0`0?ooo`0308X[hP3oool0oooo04d0oooo00<0
00000?ooo`3oool00`0000040?ooo`8000002`3oool010000000oooo0?ooo`3oool3000000<0oooo
00<000000?ooo`3oool0G@3oool00`3oH@80oooo0?ooo`0P0?ooo`030000003oool0oooo02@0oooo
000U0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0L0?ooo`030?oo
003oool0oooo0600oooo00<000000?ooo`3oool01@3oool5000000030?ooo`000000000000<00000
2`3oool01@000000oooo0?ooo`3oool0000003<0oooo00<0RR_R0?ooo`3oool0C03oool00`000000
oooo0?ooo`0N0?ooo`800000G`3oool00`3oH@80oooo0?ooo`0O0?ooo`030000003oool0oooo02@0
oooo000U0?ooo`030000003oool0oooo0080oooo0`00000;0?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0L0?ooo`030?oo003oool0oooo0600oooo
00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
00`0oooo00@000000?ooo`3oool0oooo0P00000b0?ooo`0308X[hP3oool0oooo04/0oooo0P00000P
0?ooo`030000003oool0oooo05h0oooo00<0of420?ooo`3oool07`3oool00`000000oooo0?ooo`0T
0?ooo`009@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool02@3oool0
0`000000oooo000000030?ooo`050000003oool0oooo0?ooo`0000007`3oool00`3oo`00oooo0?oo
o`110?ooo``0ool04P3oool00`000000oooo0?ooo`060?ooo`030000003oool0000000<0oooo00<0
00000?ooo`000000203oool4000000@0oooo00<000000?ooo`3oool0<P3oool00`2::n80oooo0?oo
o`1;0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0G`3oool00`3oH@80oooo0?oo
o`0N0?ooo`030000003oool0oooo02@0oooo000T0?ooo`8000000`3oool01@000000oooo0?ooo`3o
ool0000000L0oooo00L000000?ooo`3oool0oooo0000003oool0000000<0oooo00D000000?ooo`3o
ool0oooo0000000O0?ooo`030?oo003oool0oooo03h0oooo0`3oo`0<0?oooa00ool00P3oool00`00
0000oooo0?ooo`070?ooo`800000103oool2000000P0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`0b0?ooo`0308X[hP3oool0oooo04/0oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`1O0?ooo`030?mQ0P3oool0oooo01h0oooo00<000000?ooo`3oool0903oool002D0
oooo00<000000?ooo`3oool00P3oool3000000P0oooo1@0000020?ooo`<00000103oool00`000000
oooo0?ooo`0M0?ooo`030?oo003oool0oooo03X0oooo103oo`0Q0?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`D000000`3oool00`000000
oooo0?ooo`0c0?ooo`0308X[hP3oool0oooo04X0oooo00<000000?ooo`3oool07P3oool200000640
oooo00<0of420?ooo`3oool07@3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo
0?ooo`0N0?ooo`030?oo003oool0oooo03H0oooo0`3oo`0U0?ooo`030000003oool0oooo01l0oooo
0P00000e0?ooo`0308X[hP3oool0oooo04P0oooo0P00000P0?ooo`030000003oool0oooo0600oooo
00<0of420?ooo`3oool07@3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool00`000000oooo0?oo
o`0N0?ooo`030?oo003oool0oooo0340oooo1@3oo`0X0?ooo`030000003oool0oooo01l0oooo00<0
00000?ooo`3oool0=03oool00`2::n80oooo0?ooo`190?ooo`030000003oool0oooo01h0oooo00<0
00000?ooo`3oool0H03oool00`3oH@80oooo0?ooo`0M0?ooo`030000003oool0oooo02@0oooo0013
0?ooo`030000003oool0oooo01h0oooo00<0ool00?ooo`3oool0:P3oool70?oo02d0oooo00<00000
0?ooo`3oool07`3oool00`000000oooo0?ooo`0e0?ooo`0308X[hP3oool0oooo04P0oooo00<00000
0?ooo`3oool07P3oool200000680oooo00<0of420?ooo`3oool0703oool00`000000oooo0?ooo`0T
0?ooo`00@`3oool00`000000oooo0?ooo`0O0?ooo`030?oo003oool0oooo02<0oooo1P3oo`0d0?oo
o`030000003oool0oooo01l0oooo0P00000f0?ooo`0308X[hP3oool0oooo04L0oooo0P00000P0?oo
o`030000003oool0oooo0640oooo00<0of420?ooo`3oool0703oool00`000000oooo0?ooo`0T0?oo
o`00@`3oool00`000000oooo0?ooo`0O0?ooo`030?oo003oool0oooo01h0oooo1@3oo`0j0?ooo`03
0000003oool0oooo01l0oooo00<000000?ooo`3oool0=P3oool00`2::n80oooo0?ooo`170?ooo`03
0000003oool0000000@000000P3oool3000000@0oooo00<000000?ooo`3oool00`3oool3000000<0
oooo0`0000020?ooo`030000003oool0oooo0680oooo00<0of420?ooo`3oool06`3oool00`000000
oooo0?ooo`0T0?ooo`00903oool3000000<0oooo0`0000040?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool00`3oool3000000<0oooo00<000000?ooo`3oool07`3oool00`3oo`00oooo
0?ooo`0L0?ooo`80ool0?`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo03L0oooo
00<0RR_R0?ooo`3oool0AP3oool010000000oooo0?ooo`0000020?ooo`030000003oool0000000<0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`030?ooo`050000003oool0oooo0?oo
o`000000I03oool00`3oH@80oooo0?ooo`0K0?ooo`030000003oool0oooo02@0oooo000U0?ooo`05
0000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0P0?ooo`030?oo003oool0oooo
01T0oooo0P3oo`110?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0=`3oool00`2:
:n80oooo0?ooo`160?ooo`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3o
ool0000000L0oooo1@0000000`3oool000000000000300000080oooo0P00001T0?ooo`80of426P3o
ool2000002H0oooo000U0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo00D000000`3oool00`000000oooo0?ooo`0P0?ooo`030?oo003o
ool0oooo01L0oooo0P3oo`130?ooo`030000003oool0oooo01l0oooo0P00000i0?ooo`0308X[hP3o
ool0oooo01l0oooo3@2::n8H0?ooo`800000103oool00`000000oooo0?ooo`04000000P0oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo06D0
oooo00<0of420?ooo`3oool0603oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo
0?ooo`020?ooo`<000002`3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool0803oool00`3oo`00oooo0?ooo`0E0?ooo`80ool0A@3oool010000000
oooo0?ooo`3oool3000000<0oooo0`0000030?ooo`030000003oool0oooo0080oooo0`0000020?oo
o`D000000`3oool00`000000oooo0?ooo`0h0?ooo`0308X[hP3oool0oooo01`0oooo0`2::n8=0?oo
o`L0RR_R4P3oool00`000000oooo000000030?ooo`030000003oool0000000`0oooo00<000000?oo
o`0000000`3oool00`000000oooo000000030?ooo`030000003oool0oooo06H0oooo00<0of420?oo
o`3oool05`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool01@000000oooo0?ooo`3oool00000
00<0oooo00<000000?ooo`3oool02@3oool01P000000oooo0?ooo`000000oooo000000@0oooo00<0
00000?ooo`3oool08@3oool20?oo01@0oooo00<0ool00?ooo`3oool0A@3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01P3oool01@000000oooo0?oo
o`3oool000000080oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`0i0?ooo`03
08X[hP3oool0oooo01P0oooo0`2::n8G0?oooa00RR_R0P3oool00`000000oooo000000030?ooo`04
0000003oool0oooo000000`0oooo0P0000040?ooo`8000000`3oool00`000000oooo0?ooo`1W0?oo
o`030?mQ0P3oool0oooo01H0oooo00<000000?ooo`3oool0903oool002@0oooo0P0000030?ooo`05
0000003oool0oooo0?ooo`0000001`3oool01@000000oooo0?ooo`3oool0000000<0oooo0P000004
0?ooo`030000003oool0oooo02<0oooo0P3oo`0@0?ooo`80ool0B03oool00`000000oooo00000004
000000030?ooo`000000000000<000002`3oool01@000000oooo0?ooo`3oool0000000D0oooo00<0
00000?ooo`3oool0>P3oool00`2::n80oooo0?ooo`0D0?ooo`<0RR_R;03oool00`000000oooo0?oo
o`03000000@0oooo0P00000;0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool0oooo
0P00001Y0?ooo`030?mQ0P3oool0oooo01D0oooo00<000000?ooo`3oool0903oool002D0oooo00<0
00000?ooo`3oool00P3oool3000000P0oooo1@0000040?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool09@3oool20?oo00`0oooo0P3oo`1:0?ooo`030000003oool000000080oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool2000003/0oooo00<0RR_R0?ooo`3oool03`3oool508X[hRh0oooo
0P00000P0?ooo`030000003oool0oooo06T0oooo00@0of420?ooo`3oool0oooo4@3oH@820?ooo`03
0000003oool0oooo02@0oooo00130?ooo`030000003oool0oooo02L0oooo1@3oo`040?ooo`<0ool0
C03oool01P000000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`000000203oool40000
0080oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03/0oooo1@2::n85
0?ooo`L0RR_R=03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo06X0oooo0`3oH@8C
0?ooo`030000003oool0oooo02@0oooo00130?ooo`030000003oool0oooo02`0oooo103oo`1?0?oo
o`040000003oool0oooo0?ooo`800000103oool2000000P0oooo00<000000?ooo`3oool00`3oool0
1@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0@03oool508X[hS/0oooo00<0
00000?ooo`3oool07P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0
00000P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000`3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool000000P3oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool01@000000oooo
0?ooo`3oool000000080oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool000000P3oool01@000000oooo
0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0T0?ooo`00@`3oool0
0`000000oooo0?ooo`1o0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`060?ooo`D000000P3oool3000000@0oooo0P0000000`3oool000000?ooo`0?
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0>
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00T0oooo0P00000P0?oooh@000009P3oool004<0ooooP`00000Q0?oo
oh@00000bP3oool00?l0ooooo`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo003o0?ooool0oooo=`3o
ool00?l0ooooo`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo003o0?ooool0oooo=`3oool00?l0oooo
o`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo003o0?ooool0oooo=`3oool00?l0ooooo`3ooolg0?oo
o`00o`3ooon?0?ooo`8000001P3oool5000000<0oooo00<000000?ooo`3oool00P3oool3000000L0
oooo0`0000090?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool3000000@0
oooo0`0000040?ooo`8000000P3oool300000080oooo1@0000030?ooo`030000003oool0oooo0080
oooo0`000000103oool000000000000000030?ooo`<0000000@0oooo0000000000000000103oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0`00000Z0?ooo`00o`3ooon>0?oo
o`040000003oool0oooo000000H0oooo00@000000?ooo`3oool000001`3oool01@000000oooo0?oo
o`3oool0000000D0oooo00D000000?ooo`3oool0oooo000000080?ooo`030000003oool0oooo00L0
oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo0080oooo00@000000?oo
o`3oool000000P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000L0oooo00L0
00000?ooo`3oool0oooo0000003oool0000000<0oooo00L000000?ooo`3oool0oooo0000003oool0
000000D0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool0000002T0oooo001@
0?ooo`8000001@3oool5000000<0oooo00<000000?ooo`3oool00P3oool3000000H0oooo0`000007
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool3000000<0oooo0`000004
0?ooo`D000000P3oool5000000<0oooo00<000000?ooo`3oool00P3oool6000000<0oooo1@000004
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool3000002`0oooo0P000006
0?ooo`D000000`3oool00`000000oooo0?ooo`020?ooo`<000001P3oool3000000P0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`<000000`3oool3000000@0oooo0P000000
103oool000000000000000020?ooo`D000000`3oool00`000000oooo0?ooo`020?ooo`<0000000@0
oooo00000000000000000`3oool6000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`020?ooo`<000009P3oool010000000oooo0?ooo`0000070?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool00000
00L0oooo00<000000?ooo`0000001P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
02L0oooo001?0?ooo`040000003oool0oooo000000D0oooo00@000000?ooo`3oool000001`3oool0
1@000000oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000
003oool0oooo00L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool00P0000040?ooo`040000003oool0oooo000000L0oooo00@000000?oo
o`3oool0oooo0P0000030?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?oo
o`070?ooo`050000003oool0oooo0?ooo`000000:P3oool010000000oooo0?ooo`0000060?ooo`04
0000003oool0oooo000000L0oooo00D000000?ooo`3oool0oooo000000040?ooo`050000003oool0
oooo0?ooo`0000001`3oool00`000000oooo0?ooo`070?ooo`050000003oool0oooo0?ooo`000000
0`3oool00`000000oooo0?ooo`020?ooo`060000003oool0oooo0000003oool00000103oool01000
0000oooo0?ooo`0000070?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`040000
003oool0oooo0?ooo`8000001@3oool00`000000oooo0?ooo`070?ooo`050000003oool0oooo0?oo
o`0000009@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00X0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00X0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`0:0?ooo`030000003oool0000000L0oooo00<0
00000?ooo`0000001P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo02L0oooo001?
0?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool02P3oool01@000000oooo0?oo
o`3oool0000000@0oooo00<000000?ooo`3oool00P0000050?ooo`030000003oool0oooo00/0oooo
0P0000070?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02P3oool00`000000oooo
0?ooo`0X0?ooo`040000003oool0oooo000000L0oooo00<000000?ooo`3oool02`3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool02P3oool01@000000
oooo0?ooo`3oool0000000@0oooo00H000000?ooo`3oool000000?ooo`0000050?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`0000001`3oool2000000H0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0?ooo`0S0?ooo`040000003oool0oooo000000D0oooo00D000000?ooo`3oool0
oooo000000070?ooo`@000001P3oool4000000/0oooo00<000000?ooo`3oool01@3oool4000000D0
oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`050?ooo`@000000P3oool010000000oooo0?ooo`3o
ool400000080oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`@00000:P3o
ool004l0oooo00@000000?ooo`3oool000001`3oool00`000000oooo0?ooo`0:0?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`050000003o
ool0oooo0?ooo`000000103oool00`000000oooo0?ooo`02000000H0oooo00<000000?ooo`3oool0
2P3oool2000000L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0:0?ooo`030000
003oool0oooo02P0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`0:0?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0:0?ooo`05
0000003oool0oooo0?ooo`000000103oool01P000000oooo0?ooo`000000oooo000000H0oooo00<0
00000?ooo`3oool02P3oool00`000000oooo000000070?ooo`8000001P3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo02<0oooo00@000000?ooo`3oool000001@3oool01@000000oooo
0?ooo`3oool0000000L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`05
0000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`050?ooo`800000103oool01@00
0000oooo0?ooo`000000oooo008000000`3oool01@000000oooo0?ooo`3oool0000000L0oooo00<0
00000?ooo`3oool00P3oool2000000<0oooo00<000000?ooo`3oool00P3oool2000000<0oooo00D0
00000?ooo`3oool0oooo000000070?ooo`030000003oool0oooo02/0oooo001?0?ooo`040000003o
ool0oooo000000@0oooo00D000000?ooo`3oool0oooo000000070?ooo`@000001@3oool4000000T0
oooo00<000000?ooo`3oool01@3oool4000000@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`02000000<0oooo00D000000?ooo`3oool0oooo000000070?ooo`@0000000<0oooo0000
003oool00P3oool5000000L0oooo00<000000?ooo`3oool01@3oool4000002/0oooo00@000000?oo
o`3oool000001@3oool01@000000oooo0?ooo`3oool0000000L0oooo100000050?ooo`@000002P3o
ool00`000000oooo0?ooo`050?ooo`@00000103oool00`000000oooo0?ooo`020?ooo`060000003o
ool0oooo0000003oool000000`3oool01@000000oooo0?ooo`3oool0000000L0oooo100000020?oo
o`040000003oool0oooo0?ooo`@0000000<0oooo0000003oool01P3oool00`000000oooo0?ooo`05
0?ooo`@000009`3oool2000000L0oooo0`0000080?ooo`D000001@3oool5000000H0oooo1@000007
0?ooo`D00000103oool00`000000oooo0?ooo`030?ooo`8000000`3oool00`000000oooo0?ooo`02
0?ooo`<00000203oool5000000030?ooo`000000oooo0080oooo1@0000000`3oool000000?ooo`02
0?ooo`D000001`3oool5000002T0oooo001?0?ooo`040000003oool0oooo000000@0oooo00D00000
0?ooo`3oool0oooo000000070?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3o
ool01@000000oooo0?ooo`3oool0000000L0oooo00<000000?ooo`3oool0103oool2000000@0oooo
00<000000?ooo`3oool00P0000030?ooo`050000003oool0oooo0?ooo`0000001`3oool010000000
oooo0?ooo`3oool2000000<0oooo00<000000?ooo`3oool00P0000030?ooo`050000003oool0oooo
0?ooo`0000001`3oool00`000000oooo0?ooo`0/0?ooo`040000003oool0oooo000000D0oooo00D0
00000?ooo`3oool0oooo000000070?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1`3oool01@000000oooo0?ooo`3oool0000000L0oooo00<000000?ooo`3oool0103oool2000000@0
oooo00<000000?ooo`3oool00`0000030?ooo`050000003oool0oooo0?ooo`0000001`3oool00`00
0000oooo0?ooo`020?ooo`8000000`3oool010000000oooo0?ooo`3oool2000000<0oooo00D00000
0?ooo`3oool0oooo000000070?ooo`030000003oool0oooo0<l0oooo001@0?ooo`8000001P3oool3
000000P0oooo1@0000040?ooo`D00000103oool5000000L0oooo1@0000030?ooo`030000003oool0
oooo00<0oooo0P0000000`3oool000000?ooo`030?ooo`<00000203oool6000000<0oooo1@000003
0?ooo`D000001`3oool5000002/0oooo0P0000070?ooo`<00000203oool5000000@0oooo1@000005
0?ooo`D000001`3oool5000000<0oooo00<000000?ooo`3oool00`3oool200000080oooo00<00000
0?ooo`3oool00P3oool3000000P0oooo1@0000000`3oool000000?ooo`020?ooo`H000000`3oool5
000000L0oooo1@00003=0?ooo`00o`3ooooo0?ooocL0oooo000Z0?ooo`<00000103oool00`000000
oooo0?ooo`020?ooo`<00000103oool00`000000oooo0?ooo`020?ooo`<000000`3oool300000?l0
oooo@@3ooon4000002H0oooo000Y0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`3o0?oood00oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000080oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo
00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo000000<0oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080oooo
00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00D000000?oo
o`3oool0oooo000000020?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080oooo00D000000?oo
o`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00D000000?ooo`3oool0oooo
000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0903oool002<0oooo
1@0000050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3ooomh000002L0oooo
OP00000P0?ooo`050000003oool0oooo0?ooo`3o0000OP3oool00`000000oooo0?ooo`0T0?ooo`00
;@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
003oL`3oool00`000000oooo0?ooo`0U0?ooo`040000003oool0oooo000000l0oooo00<000000?oo
o`3oool0303oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool02P3oool00`000000oooo0?ooo`0N0?ooo`8000000P3oool00`3o0000oooo0?ooo`1l0?oo
o`030000003oool0oooo02@0oooo000Y0?ooo`@000001P3oool01@000000oooo0?ooo`3oool00000
00/0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo
0000og<0oooo00<000000?ooo`3oool09@3oool010000000oooo0?ooo`00nYYh0?ooo`800000803o
ool01@000000oooo0?ooo`3oool0o`0007h0oooo00<000000?ooo`3oool0903oool002T0oooo00<0
00000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool000000080oooo0P00000:0?ooo`800000
103oool2000000@0oooo0P0000000`3oool0003o0?ooo`1b0?ooo`030000003oool0oooo02D0oooo
00@000000?ooo`3oool00?ZJN@3oool00`000000oooo0?ooo`0N0?ooo`050000003oool0oooo0?oo
o`3o0000OP3oool00`000000oooo0?ooo`0T0?ooo`00:@3oool5000000030?ooo`000000000000<0
00000`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool00P3oool010000000oooo0?ooo`000?mc0?ooo`030000003oool0oooo02D0oooo00@000000?oo
o`3oool00?ZJN@3oool00`000000oooo0?ooo`060?ooo`<00000103oool00`000000oooo0?ooo`02
0?ooo`<000000`3oool3000000<0oooo0P0000030?ooo`030?l0003oool0oooo07/0oooo00<00000
0?ooo`3oool0903oool004h0oooo0P0000000`3oool0003o0?ooo`1b0?ooo`030000003oool0oooo
02D0oooo00@000000?ooo`3oool00?ZJN03oool2000000L0oooo00D000000?ooo`3oool0oooo0000
00070?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`040000003oool0oooo0000
00@0oooo00<0o`000?ooo`3oool0N`3oool00`000000oooo0?ooo`0T0?ooo`00CP3oool010000000
oooo0?ooo`000?mc0?ooo`030000003oool0oooo02D0oooo00@000000?ooo`3oool00?ZJN@3oool0
0`000000oooo00000004000000D0oooo00<000000?ooo`3oool01@3oool01`000000oooo0?ooo`3o
ool000000?ooo`0000000`3oool00`000000oooo0?ooo`02000000<0oooo00<0o`000?ooo`3oool0
NP3oool2000002H0oooo001>0?ooo`050000003oool0oooo0?ooo`000?l0LP3oool00`000000oooo
0?ooo`0U0?ooo`040000003oool0oooo003jVWP0oooo0P0000090?ooo`8000002@3oool300000080
oooo100000030?ooo`030000003oool0oooo0080oooo00<0o`000?ooo`3oool0N`3oool00`000000
oooo0?ooo`0T0?ooo`00CP3oool200000080oooo00<0003o0?ooo`3oool0L03oool00`000000oooo
0?ooo`0U0?ooo`040000003oool0oooo003jVWT0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`050?ooo`070000003oool0oooo0?ooo`000000oooo000000060?ooo`030000003oool0
oooo0080oooo00<0o`000?ooo`3oool0N`3oool00`000000oooo0?ooo`0T0?ooo`00CP3oool01@00
0000oooo0?ooo`3oool0003o0780oooo00<000000?ooo`3oool01`3oool3000000<0oooo00<00000
0?ooo`3oool00`3oool2000000@0oooo00<000000?ooo`3oool00P3oool3000000@0oooo00D00000
0?ooo`3oool0oooo003jVP1g0?ooo`8000001`3oool01@000000oooo0?ooo`3oool0000000L0oooo
00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00<0oooo0P0000030?ooo`03
0?l0003oool0oooo07/0oooo00<000000?ooo`3oool0903oool00300oooo0`0000040?ooo`030000
003oool0oooo0080oooo0`0000040?ooo`030000003oool0oooo0080oooo0`0000030?ooo`800000
0P3oool00`000?l0oooo0?ooo`1`0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0
1`3oool010000000oooo0?ooo`0000030?ooo`050000003oool0oooo0?ooo`0000000`3oool01@00
0000oooo0?ooo`3oool0000000<0oooo00<00?ZJ0?ooo`3oool0MP3oool00`000000oooo0?ooo`06
0?ooo`<000002@3oool3000000@0oooo0P0000030?ooo`030000003oool0oooo0080oooo00<0o`00
0?ooo`3oool0N`3oool00`000000oooo0?ooo`0T0?ooo`00;`3oool01@000000oooo0?ooo`3oool0
000000<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo0080oooo00D000000?ooo`3oool0oooo0000o`1b0?ooo`030000003oool0000000@0000000<0
oooo0000000000000`0000080?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0
103oool01@000000oooo0?ooo`3oool0000000<0oooo00<00?ZJ0?ooo`3oool0MP3oool00`000000
oooo0?ooo`0N0?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool0NP3oool00`000000
oooo0?ooo`0T0?ooo`00:@3oool5000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00P3oool01@000000oooo
0?ooo`3oool0003o0780oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000090?oo
o`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`3o
ool200000080oooo00<00?ZJ0?ooo`3oool0M@3oool200000200oooo0P0000040?ooo`030?l0003o
ool0oooo07X0oooo00<000000?ooo`3oool0903oool003<0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00P3oool2
00000080oooo00<0003o0?ooo`3oool0K`3oool2000000P0oooo00<000000?ooo`0000002@3oool0
10000000oooo0?ooo`0000050?ooo`030000003oool0000000<00000103oool01@000000oooo0?oo
o`3oool00?ZJ07P0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`030?ooo`030?l0
003oool0oooo07X0oooo00<000000?ooo`3oool0903oool002l0oooo100000060?ooo`050000003o
ool0oooo0?ooo`0000002`3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`00
0?l0LP3oool00`000000oooo0?ooo`070?ooo`8000002@3oool01P000000oooo0?ooo`000000oooo
000000<0oooo00<000000?ooo`0000001`3oool01@000000oooo0?ooo`3oool00?ZJ07L0oooo0P00
00080?ooo`<00000103oool00`000000oooo0?ooo`020?ooo`<00000103oool300000080oooo0P00
00040?ooo`030?l0003oool0oooo07X0oooo00<000000?ooo`3oool0903oool002l0oooo00<00000
0?ooo`3oool00`3oool01@000000oooo0?ooo`3oool000000080oooo0P00000:0?ooo`800000103o
ool200000080oooo00<0003o0?ooo`3oool0L03oool00`000000oooo0?ooo`080?ooo`030000003o
ool0oooo00P0oooo0P0000020?ooo`D0000000<0oooo0000000000000`0000030?ooo`050000003o
ool0oooo0?ooo`00nYX0N03oool00`000000oooo0?ooo`050?ooo`050000003oool0oooo0?ooo`00
00001`3oool01@000000oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3oool0oooo00000005
0?ooo`030?l0003oool0oooo07X0oooo00<000000?ooo`3oool0903oool002l0oooo1@0000000`3o
ool0000000000003000000<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo0080oooo00<0003o0?ooo`3oool0K`3oool00`000000oooo0?ooo`0U0?oo
o`050000003oool0oooo0?ooo`00nYX0N03oool00`000000oooo00000004000000D0oooo00<00000
0?ooo`3oool01@3oool01P000000oooo0?ooo`3oool000000?ooo`D000000P3oool00`000000oooo
0?ooo`030?ooo`030?l0003oool0oooo07X0oooo00<000000?ooo`3oool0903oool004h0oooo00<0
00000?ooo`3oool00P3oool00`000?l0oooo0?ooo`1_0?ooo`030000003oool0oooo02D0oooo00D0
00000?ooo`3oool0oooo003jVP1g0?ooo`8000002@3oool2000000T0oooo0`0000020?ooo`040000
003oool0oooo000000<0oooo0P0000040?ooo`030?l0003oool0oooo07T0oooo0P00000V0?ooo`00
CP3oool2000000<0oooo00<0003o0?ooo`3oool0K`3oool00`000000oooo0?ooo`0U0?ooo`050000
003oool0oooo0?ooo`00nYX0N03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0
oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0000000<0oooo00<000000?oo
o`3oool0103oool00`3o0000oooo0?ooo`1i0?ooo`030000003oool0oooo02@0oooo001>0?ooo`03
0000003oool0oooo0080oooo00<0003o0?ooo`3oool0K`3oool00`000000oooo0?ooo`0U0?ooo`05
0000003oool0oooo0?ooo`00nYX0M`3oool2000000L0oooo00D000000?ooo`3oool0oooo00000007
0?ooo`050000003oool0oooo0?ooo`0000000`3oool2000000<0oooo0P0000050?ooo`030?l0003o
ool0oooo07T0oooo00<000000?ooo`3oool0903oool004h0oooo0P0000030?ooo`030000o`3oool0
oooo06l0oooo00<000000?ooo`3oool09@3oool01@000000oooo0?ooo`3oool00?ZJ07P0oooo00<0
00000?ooo`3oool01P3oool3000000T0oooo0`0000050?ooo`050000003oool0oooo0?ooo`000000
1P3oool00`3o0000oooo0?ooo`1i0?ooo`030000003oool0oooo02@0oooo001>0?ooo`030000003o
ool0oooo0080oooo00<0003o0?ooo`3oool0K`3oool00`000000oooo0?ooo`0=0?ooo`<000000`3o
ool00`000000oooo0?ooo`030?ooo`8000000`3oool3000000@0oooo00<000000?ooo`3oool00P3o
ool00`00nYX0oooo0?ooo`1d0?ooo`800000803oool00`000000oooo0?ooo`040?ooo`030?l0003o
ool0oooo07T0oooo00<000000?ooo`3oool0903oool004h0oooo00<000000?ooo`3oool00P3oool0
0`000?l0oooo0?ooo`1_0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool01`3oool0
1P000000oooo0?ooo`000000oooo000000<0oooo00D000000?ooo`3oool0oooo000000040?ooo`03
003jVP3oool0oooo07D0oooo00<000000?ooo`3oool07P3oool2000000D0oooo00<0o`000?ooo`3o
ool0N@3oool00`000000oooo0?ooo`0T0?ooo`00:P3oool3000000@0oooo00<000000?ooo`3oool0
0P3oool3000000@0oooo00<000000?ooo`3oool00`3oool2000000<0oooo0P0000040?ooo`800000
0`3oool00`000?l0oooo0?ooo`1_0?ooo`030000003oool0oooo00D0oooo1@0000000`3oool00000
00000003000000P0oooo00@000000?ooo`3oool000001@3oool01@000000oooo0?ooo`3oool00000
00@0oooo00<00?ZJ0?ooo`3oool0M@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
00@0oooo00<0o`000?ooo`3oool0N@3oool00`000000oooo0?ooo`0T0?ooo`00:@3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`080?oo
o`040000003oool0oooo000000@0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000o`3o
ool0oooo06l0oooo00<000000?ooo`3oool02`3oool010000000oooo0?ooo`0000090?ooo`040000
003oool0oooo000000D0oooo00@000000?ooo`3oool0oooo0P0000030?ooo`03003jVP3oool0oooo
07@0oooo0P00000P0?ooo`030000003oool0oooo00@0oooo00<0o`000?ooo`3oool0N@3oool00`00
0000oooo0?ooo`0T0?ooo`008`3oool5000000D0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00P0oooo00@000000?ooo`3oool000001@3oool00`00
0000oooo0?ooo`02000000<0oooo00<0003o0?ooo`3oool0KP3oool2000000h0oooo00<000000?oo
o`0000002@3oool01@000000oooo0?ooo`000000oooo00@00000103oool00`000000oooo0?ooo`02
0?ooo`03003jVP3oool0oooo07D0oooo00<000000?ooo`3oool01P3oool3000000@0oooo00<00000
0?ooo`3oool00P3oool300000080oooo1@0000020?ooo`8000001P3oool00`3o0000oooo0?ooo`1h
0?ooo`030000003oool0oooo02@0oooo000]0?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo00000080oooo10000002
0?ooo`030000003oool0oooo00<0oooo00<0003o0?ooo`3oool0KP3oool00`000000oooo0?ooo`0=
0?ooo`8000002@3oool01P000000oooo0?ooo`000000oooo000000L0oooo00<000000?ooo`3oool0
0P3oool00`00nYX0oooo0?ooo`1d0?ooo`8000001`3oool01@000000oooo0?ooo`3oool0000000L0
oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`1h0?ooo`030000003oool0oooo02@0oooo000Y0?oo
o`@000001P3oool01@000000oooo0?ooo`3oool0000000X0oooo00H000000?ooo`3oool000000?oo
o`0000030?ooo`040000003oool0oooo000000D0oooo00<0003o0?ooo`3oool0KP3oool00`000000
oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0P0000020?ooo`D000000`3oool00`000000
oooo0?ooo`020?ooo`03003jVP3oool0oooo07D0oooo00<000000?ooo`000000100000050?ooo`03
0000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo
0080oooo0P0000060?ooo`030?l0003oool0oooo07L0oooo0P00000V0?ooo`00:@3oool00`000000
oooo0?ooo`030?ooo`050000003oool0oooo0?ooo`0000000P3oool2000000X0oooo00H000000?oo
o`3oool000000?ooo`0000030?ooo`030000003oool0oooo00800000103oool00`000?l0oooo0?oo
o`1^0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool00P3oool00`00nYX0oooo0?oo
o`1e0?ooo`030000003oool0oooo00L0oooo0P0000090?ooo`<000001@3oool01@000000oooo0?oo
o`3oool0000000L0oooo00<0o`000?ooo`3oool0N03oool00`000000oooo0?ooo`0T0?ooo`00:@3o
ool5000000030?ooo`000000000000<000000`3oool00`000000oooo0?ooo`090?ooo`8000000`3o
ool3000000<0oooo00<000000?ooo`3oool00`3oool00`000?l0oooo0?ooo`1^0?ooo`030000003o
ool0oooo02D0oooo00<000000?ooo`3oool00P3oool00`00nYX0oooo0?ooo`1d0?ooo`8000002`3o
ool00`000000oooo0?ooo`050?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`04
0000003oool0oooo000000L0oooo00<0o`000?ooo`3oool0N03oool00`000000oooo0?ooo`0T0?oo
o`00CP3oool2000000@0oooo00<0003o0?ooo`3oool0KP3oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo0080oooo00<00?ZJ0?ooo`3oool0M@3oool00`000000oooo0?ooo`050?ooo`05
0000003oool0oooo0?ooo`0000001`3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3o
ool00`000000oooo0?ooo`02000000H0oooo00<0o`000?ooo`3oool0N03oool00`000000oooo0?oo
o`0T0?ooo`00CP3oool00`000000oooo0?ooo`030?ooo`030000o`3oool0oooo06h0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`020?ooo`03003jVP3oool0oooo07@0oooo0P000008
0?ooo`<000002@3oool3000000<0oooo0`0000030?ooo`030000003oool0oooo00D0oooo00<0o`00
0?ooo`3oool0N03oool00`000000oooo0?ooo`0T0?ooo`00CP3oool00`000000oooo0?ooo`030?oo
o`030000o`3oool0oooo06h0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`020?oo
o`03003jVP3oool0oooo07D0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`060?oo
o`030?l0003oool0oooo07L0oooo00<000000?ooo`3oool0903oool004h0oooo0P0000040?ooo`03
0000o`3oool0oooo06h0oooo00<000000?ooo`3oool01`3oool3000000<0oooo00<000000?ooo`3o
ool00`3oool200000080oooo1@0000020?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`03
003jVP3oool0oooo07@0oooo00<000000?ooo`3oool07P3oool2000000L0oooo00<0o`000?ooo`3o
ool0M`3oool00`000000oooo0?ooo`0T0?ooo`00CP3oool00`000000oooo0?ooo`030?ooo`030000
o`3oool0oooo06h0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`040000
003oool0oooo00000080oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`050000003oool0
oooo0?ooo`0000001@3oool00`00nYX0oooo0?ooo`1c0?ooo`800000803oool00`000000oooo0?oo
o`060?ooo`030?l0003oool0oooo07L0oooo00<000000?ooo`3oool0903oool004h0oooo0P000004
0?ooo`030000o`3oool0oooo06h0oooo00<000000?ooo`000000100000000`3oool0000000000003
000000P0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`050?ooo`050000003o
ool0oooo0?ooo`0000001@3oool00`00nYX0oooo0?ooo`1d0?ooo`030000003oool0oooo00`0oooo
0`0000040?ooo`030000003oool0oooo0080oooo0`0000030?ooo`8000001`3oool00`3o0000oooo
0?ooo`1g0?ooo`030000003oool0oooo02@0oooo000Z0?ooo`<00000103oool00`000000oooo0?oo
o`020?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`8000000`3oool3000000<0oooo00<0
00000?ooo`3oool0103oool00`000?l0oooo0?ooo`1]0?ooo`030000003oool0oooo00D0oooo00@0
00000?ooo`3oool000002@3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00@0
oooo00@000000?ooo`3oool0oooo0P0000040?ooo`03003jVP3oool0oooo07<0oooo0P00000=0?oo
o`050000003oool0oooo0?ooo`0000001`3oool01@000000oooo0?ooo`3oool000000080oooo00<0
00000?ooo`3oool01P3oool00`3o0000oooo0?ooo`1g0?ooo`030000003oool0oooo02@0oooo000Y
0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo00P0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`040000003oool0oooo0000
00H0oooo00<0003o0?ooo`3oool0K@3oool00`000000oooo0?ooo`060?ooo`030000003oool00000
00T0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`030000003oool0000000<00000103o
ool00`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo07@0oooo00<000000?ooo`3oool01@3o
ool5000000D0oooo00<000000?ooo`3oool01@3oool01@000000oooo0?ooo`3oool000000080oooo
00<000000?ooo`3oool01P3oool00`3o0000oooo0?ooo`1g0?ooo`030000003oool0oooo02@0oooo
000S0?ooo`D000001@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0203oool01P000000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`3o
ool00P0000050?ooo`030000o`3oool0oooo06`0oooo0P0000090?ooo`8000002@3oool01P000000
oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`0000001`3oool00`000000oooo0?ooo`03
0?ooo`03003jVP3oool0oooo07<0oooo0P00000?0?ooo`8000002@3oool3000000<0oooo0P000007
0?ooo`030?l0003oool0oooo07H0oooo0P00000V0?ooo`00;@3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0203oool010000000oooo0?ooo`000002
0?ooo`<000000`3oool00`000000oooo0?ooo`040?ooo`030000o`3oool0oooo06d0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`8000000`3oool300000080oooo1@000003
0?ooo`030000003oool0oooo00<0oooo00<00?ZJ0?ooo`3oool0M03oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003o
ool0oooo00L0oooo00<0o`000?ooo`3oool0MP3oool00`000000oooo0?ooo`0T0?ooo`00:@3oool4
000000H0oooo00D000000?ooo`3oool0oooo0000000:0?ooo`060000003oool0oooo0000003oool0
00000`3oool010000000oooo0?ooo`0000060?ooo`030000o`3oool0oooo06d0oooo00<000000?oo
o`3oool09@3oool00`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo07@0oooo00<000000?oo
o`3oool02`3oool01@000000oooo0?ooo`3oool0000000L0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`800000203oool00`3o0000oooo0?ooo`1f0?ooo`030000003oool0oooo02@0oooo000Y
0?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3oool0oooo000000020?ooo`8000002P3o
ool01P000000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`3oool00P0000050?ooo`03
0000o`3oool0oooo06d0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`030?ooo`03
003jVP3oool0oooo07<0oooo0P00000>0?ooo`<000002@3oool3000000<0oooo00<000000?ooo`3o
ool01`3oool00`3o0000oooo0?ooo`1f0?ooo`030000003oool0oooo02@0oooo000Y0?ooo`D00000
00<0oooo0000000000000`0000030?ooo`030000003oool0oooo00T0oooo0P0000030?ooo`<00000
0`3oool00`000000oooo0?ooo`040?ooo`030000o`3oool0oooo06d0oooo00<000000?ooo`3oool0
9@3oool00`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo07@0oooo00<000000?ooo`3oool0
7P3oool00`000000oooo0?ooo`070?ooo`030?l0003oool0oooo07H0oooo00<000000?ooo`3oool0
903oool004h0oooo0P0000050?ooo`030000o`3oool0oooo06d0oooo00<000000?ooo`3oool09@3o
ool00`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo07<0oooo0P00000P0?ooo`800000203o
ool00`3o0000oooo0?ooo`1f0?ooo`030000003oool0oooo02@0oooo001>0?ooo`030000003oool0
oooo00@0oooo00<0003o0?ooo`3oool0K@3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0
oooo00<0oooo00<00?ZJ0?ooo`3oool0M03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0
oooo00L0oooo00<0o`000?ooo`3oool0MP3oool00`000000oooo0?ooo`0T0?ooo`00CP3oool00`00
0000oooo0?ooo`050?ooo`030000o`3oool0oooo06`0oooo00<000000?ooo`3oool07`3oool30000
00<0oooo00<000000?ooo`3oool00`3oool00`00nYX0oooo0?ooo`1d0?ooo`030000003oool0oooo
01h0oooo00<000000?ooo`3oool0203oool00`3o0000oooo0?ooo`1e0?ooo`030000003oool0oooo
02@0oooo001>0?ooo`8000001P3oool00`000?l0oooo0?ooo`1/0?ooo`030000003oool0oooo0200
oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03003jVP3oool0oooo0780
oooo0P0000080?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080
oooo0`0000030?ooo`8000002@3oool00`3o0000oooo0?ooo`1e0?ooo`030000003oool0oooo02@0
oooo001>0?ooo`030000003oool0oooo00D0oooo00<0003o0?ooo`3oool0K03oool00`000000oooo
0?ooo`0G0?ooo`D0000000<0oooo0000000000000`0000030?ooo`030000003oool0oooo00@0oooo
00<00?ZJ0?ooo`3oool0L`3oool00`000000oooo0?ooo`050?ooo`050000003oool0oooo0?ooo`00
00002@3oool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000002P3oool0
0`3o0000oooo0?ooo`1e0?ooo`030000003oool0oooo02@0oooo000Z0?ooo`<00000103oool00`00
0000oooo0?ooo`020?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`800000103oool00`00
0000oooo0?ooo`020?ooo`8000001P3oool00`000?l0oooo0?ooo`1/0?ooo`030000003oool0oooo
01d0oooo00@000000?ooo`3oool00000103oool2000000D0oooo00<00?ZJ0?ooo`3oool0:03oool7
003jVT<0oooo0P0000000`3oool0000000000003000000D0oooo00<000000?ooo`3oool0203oool0
10000000oooo0?ooo`0000030?ooo`030000003oool0oooo008000002@3oool00`3o0000oooo0?oo
o`0K0?oooa80o`00A`3oool2000002H0oooo000Y0?ooo`050000003oool0oooo0?ooo`0000000`3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00P0oooo00@000000?ooo`3oool00000
0`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00D0oooo00<0003o0?ooo`3oool0
K03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool0
103oool00`00nYX0oooo0?ooo`0;0?ooo`D00?ZJ2`3oool=003jVPL0oooo4`00nYXa0?ooo`030000
003oool0oooo00L0oooo0P00000;0?ooo`040000003oool0oooo0?ooo`<000000`3oool00`000000
oooo0?ooo`080?ooo`030?l0003oool0oooo01P0oooo0`3o000B0?ooo`<0o`00A@3oool00`000000
oooo0?ooo`0T0?ooo`008`3oool5000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00P0oooo00@000000?ooo`3oool00000103oool01@000000
oooo0?ooo`3oool0000000L0oooo00<0003o0?ooo`3oool0K03oool00`000000oooo0?ooo`0O0?oo
o`800000103oool00`000000oooo0?ooo`040?ooo`03003jVP3oool0oooo00X0oooo00<00?ZJ0?oo
o`3oool00`3oool;003jVRL0oooo;`00nYX00`3oool000000000000;0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`00000;0?ooo`030?l0003oool0
oooo01@0oooo0`3o000H0?ooo`D0o`00@03oool00`000000oooo0?ooo`0T0?ooo`00;@3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0203oool01000
0000oooo0?ooo`0000040?ooo`040000003oool0oooo0?ooo`8000001P3oool00`000?l0oooo0?oo
o`1[0?ooo`8000008P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<0
0?ZJ0?ooo`3oool02@3oool00`00nYX0oooo0?ooo`1W0?ooo`030000003oool0oooo00D0oooo00D0
00000?ooo`3oool0oooo000000070?ooo`070000003oool0oooo0?ooo`000000oooo000000030?oo
o`030000003oool0oooo008000002P3oool00`3o0000oooo0?ooo`0C0?ooo`030?l0003oool0oooo
01h0oooo503o000/0?ooo`030000003oool0oooo02@0oooo000Y0?ooo`@000001P3oool01@000000
oooo0?ooo`3oool0000000X0oooo00@000000?ooo`3oool000001@3oool010000000oooo0?ooo`00
00070?ooo`030000o`3oool0oooo06`0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?oo
o`040?ooo`03003jVP3oool0oooo00P0oooo00<00?ZJ0?ooo`3oool0J03oool00`000000oooo0?oo
o`060?ooo`<00000203oool500000080oooo0`0000030?ooo`030000003oool0oooo00T0oooo00<0
o`000?ooo`3oool04P3oool00`3o0000oooo0?ooo`0c0?ooo`H0o`006P3oool:0?l00080oooo00<0
00000?ooo`3oool0903oool002T0oooo00<000000?ooo`3oool00`3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000:0?ooo`060000003oool0oooo0000003oool000000`3oool00`000000
oooo0?ooo`02000000H0oooo00<0003o0?ooo`3oool0K03oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo00@0oooo00<00?ZJ0?ooo`3oool01`3oool00`00nYX0oooo0?ooo`1X0?ooo`80
0000803oool00`000000oooo0?ooo`090?ooo`030?l0003oool0oooo0140oooo00<0o`000?ooo`3o
ool0>P3ooolJ0?l000`0oooo00<000000?ooo`3oool0903oool002T0oooo1@0000000`3oool00000
00000003000000<0oooo00<000000?ooo`3oool02@3oool200000080oooo1@0000020?ooo`030000
003oool0oooo00D0oooo00<0003o0?ooo`3oool0K03oool00`000000oooo0?ooo`0U0?ooo`030000
003oool0oooo00@0oooo00<00?ZJ0?ooo`3oool01P3oool00`00nYX0oooo0?ooo`1Z0?ooo`030000
003oool0oooo01h0oooo0P00000:0?ooo`030?l0003oool0oooo0100oooo00<0o`000?ooo`3oool0
H@3oool00`000000oooo0?ooo`0T0?ooo`00CP3oool00`000000oooo0?ooo`060?ooo`030000o`3o
ool0oooo06/0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`040?ooo`03003jVP3o
ool0oooo00D0oooo00<00?ZJ0?ooo`3oool0JP3oool200000200oooo00<000000?ooo`3oool02P3o
ool00`3o0000oooo0?ooo`0;0?ooo`@0o`00I03oool00`000000oooo0?ooo`0T0?ooo`00CP3oool2
000000L0oooo00<0003o0?ooo`3oool0J`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0
oooo00@0oooo00<00?ZJ0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`1[0?ooo`030000003oool0
oooo00H0oooo0`0000040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool3
000000<0oooo0P00000;0?ooo`030?l0003oool0oooo00L0oooo103o001X0?ooo`030000003oool0
oooo02@0oooo001>0?ooo`030000003oool0oooo00H0oooo00<0003o0?ooo`3oool0J`3oool00`00
0000oooo0?ooo`0U0?ooo`030000003oool0oooo00@0oooo00<00?ZJ0?ooo`3oool01@3oool00`00
nYX0oooo0?ooo`1[0?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo00000009
0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000oooo0?ooo`00000<0?ooo`030?l0
003oool0oooo00L0oooo00<0o`000?ooo`3oool0J@3oool00`000000oooo0?ooo`0T0?ooo`00CP3o
ool2000000L0oooo00<0003o0?ooo`3oool0J`3oool00`000000oooo0?ooo`060?ooo`<00000103o
ool00`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`<00000103o
ool00`000000oooo0?ooo`050?ooo`03003jVP3oool0oooo00<0oooo00<00?ZJ0?ooo`3oool0J`3o
ool2000000030?ooo`000000000000<000001@3oool00`000000oooo0?ooo`080?ooo`040000003o
ool0oooo000000<0oooo00@000000?ooo`3oool00000303oool00`3o0000oooo0?ooo`070?ooo`03
0?l0003oool0oooo06T0oooo00<000000?ooo`3oool0903oool004h0oooo00<000000?ooo`3oool0
1P3oool00`000?l0oooo0?ooo`1[0?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0
oooo0000000:0?ooo`030000003oool0oooo0080oooo00D000000?ooo`3oool0oooo000000030?oo
o`050000003oool0oooo0?ooo`0000001`3oool00`00nYX0oooo0?ooo`030?ooo`03003jVP3oool0
oooo06`0oooo00<000000?ooo`3oool01`3oool2000000/0oooo00<000000?ooo`3oool010000003
0?ooo`8000002`3oool00`3o0000oooo0?ooo`060?ooo`030?l0003oool0oooo06T0oooo0P00000V
0?ooo`00CP3oool00`000000oooo0?ooo`060?ooo`030000o`3oool0oooo06/0oooo00<000000?oo
o`000000100000050?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`040?ooo`040000003oool0oooo0?ooo`8000001P3oool00`00nYX0oooo0?ooo`03
0?ooo`03003jVP3oool0oooo06/0oooo0P00000;0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`0000001P3oool00`000000oooo0?ooo`0;0?ooo`030?l0003oool0oooo00D0oooo00<0o`00
0?ooo`3oool0JP3oool00`000000oooo0?ooo`0T0?ooo`00:P3oool3000000@0oooo00<000000?oo
o`3oool00P3oool3000000@0oooo00<000000?ooo`3oool00`3oool2000000<0oooo0`0000030?oo
o`800000203oool00`000?l0oooo0?ooo`1Z0?ooo`030000003oool0oooo00L0oooo0P0000090?oo
o`@00000103oool00`000000oooo0?ooo`040?ooo`050000003oool0oooo0?ooo`0000001`3oool0
0`00nYX0oooo0?ooo`020?ooo`03003jVP3oool0oooo06d0oooo00<000000?ooo`3oool01@3oool0
1@000000oooo0?ooo`3oool0000000L0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0oooo00<0oooo0P00000<0?ooo`030?l0003oool0oooo00D0oooo00<0o`000?ooo`3oool0
JP3oool00`000000oooo0?ooo`0T0?ooo`00:@3oool01@000000oooo0?ooo`3oool0000000<0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`080?ooo`060000003oool0oooo0000003o
ool000000`3oool010000000oooo0?ooo`00000:0?ooo`030000o`3oool0oooo06T0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`050000003oool0oooo0?ooo`0000001@3o
ool00`000000oooo00000003000000@0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo0?oo
o`020?ooo`03003jVP3oool0oooo06`0oooo0P0000080?ooo`<00000203oool5000000<0oooo0P00
00030?ooo`030000003oool0oooo00/0oooo00<0o`000?ooo`3oool0103oool00`3o0000oooo0?oo
o`1[0?ooo`030000003oool0oooo02@0oooo000S0?ooo`D000001@3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0203oool01P000000oooo0?ooo`00
0000oooo000000<0oooo00<000000?ooo`3oool00P0000090?ooo`030000o`3oool0oooo06P0oooo
0P0000070?ooo`050000003oool0oooo0?ooo`0000001`3oool01`000000oooo0?ooo`3oool00000
0?ooo`0000000`3oool00`000000oooo000000070?ooo`030000003oool0oooo00D0oooo00<00?ZJ
0?ooo`3oool00P3oool00`00nYX0oooo0?ooo`1]0?ooo`030000003oool0oooo01h0oooo00<00000
0?ooo`3oool02`3oool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo06/0oooo00<00000
0?ooo`3oool0903oool002d0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00P0oooo00D000000?ooo`3oool000000?ooo`04000000<0oooo00<00000
0?ooo`3oool02@3oool00`000?l0oooo0?ooo`1X0?ooo`030000003oool0oooo00H0oooo0`000009
0?ooo`<000000P3oool5000000030?ooo`000000000000<000000`3oool00`000000oooo0?ooo`05
0?ooo`05003jVP3oool0oooo0?ooo`00nYX0L03oool00`000000oooo0?ooo`0N0?ooo`800000303o
ool00`3o0000oooo0?ooo`040?ooo`030?l0003oool0oooo06/0oooo00<000000?ooo`3oool0903o
ool002T0oooo100000060?ooo`050000003oool0oooo0?ooo`0000002P3oool01P000000oooo0?oo
o`000000oooo000000H0oooo00<000000?ooo`3oool02P3oool00`000?l0oooo0?ooo`1W0?ooo`03
0000003oool0oooo02D0oooo00<000000?ooo`3oool01@3oool01@00nYX0oooo0?ooo`3oool00?ZJ
06l0oooo0P00000P0?ooo`030000003oool0oooo00`0oooo00<0o`000?ooo`3oool00`3oool00`3o
0000oooo0?ooo`1[0?ooo`030000003oool0oooo02@0oooo000Y0?ooo`030000003oool0oooo00<0
oooo00D000000?ooo`3oool0oooo000000020?ooo`8000002P3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo00<0oooo0P00000;0?ooo`030000o`3oool0oooo06L0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`050?ooo`05003jVP3oool0oooo0?ooo`00nYX0L03o
ool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo00`0oooo00<0o`000?ooo`3oool00P3o
ool00`3o0000oooo0?ooo`1/0?ooo`030000003oool0oooo02@0oooo000Y0?ooo`D0000000<0oooo
0000000000000`0000030?ooo`030000003oool0oooo00T0oooo0P0000040?ooo`8000000`3oool0
0`000000oooo0?ooo`0;0?ooo`030000o`3oool0oooo06H0oooo00<000000?ooo`3oool09@3oool0
0`000000oooo0?ooo`050?ooo`05003jVP3oool0oooo0?ooo`00nYX0K`3oool2000000P0oooo0`00
00040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool300000080oooo0P00
000=0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool0K03oool00`000000oooo0?oo
o`0T0?ooo`00CP3oool2000000d0oooo0P000?mV0?ooo`030000003oool0oooo02D0oooo00<00000
0?ooo`3oool01@3oool01000nYX0oooo0?ooo`00nYYa0?ooo`030000003oool0oooo00D0oooo00D0
00000?ooo`3oool0oooo000000090?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0
oooo0000000>0?ooo`030?l0003oool0oooo0080oooo00<0o`000?ooo`3oool0K03oool00`000000
oooo0?ooo`0T0?ooo`00CP3oool00`000000oooo0?ooo`0>0?ooo`80003oI03oool00`000000oooo
0?ooo`0U0?ooo`030000003oool0oooo00D0oooo00@00?ZJ0?ooo`3oool00?ZJL@3oool00`000000
oooo00000004000000D0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0500000080
oooo0P00000=0?ooo`050?l0003oool0oooo0?ooo`3o0000KP3oool2000002H0oooo001>0?ooo`03
0000003oool0oooo0100oooo0P000?mR0?ooo`030000003oool0oooo00`0oooo0`0000040?ooo`03
0000003oool0oooo0080oooo0P0000040?ooo`<00000103oool00`000000oooo0?ooo`060?ooo`03
003jVP3oool00?ZJ0700oooo0P0000090?ooo`8000002`3oool010000000oooo0?ooo`0000020?oo
o`050000003oool0oooo0?ooo`0000003`3oool0103o0000oooo0?ooo`3o001_0?ooo`030000003o
ool0oooo02@0oooo001>0?ooo`8000004`3ooomP0000o`80oooo00<000000?ooo`3oool02`3oool0
1@000000oooo0?ooo`3oool0000000X0oooo00@000000?ooo`3oool000000`3oool01@000000oooo
0?ooo`3oool0000000P0oooo0P00nYYb0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool02@3oool01P000000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`3oool03@3oool0
103o0000oooo0?ooo`3o001_0?ooo`030000003oool0oooo02@0oooo001>0?ooo`040000003oool0
oooo000000h0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0<0?ooo`030000003o
ool0oooo00`0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0<0?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`D000001@3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool0oooo
0P0000070?ooo`800?ZJL@3oool2000000L0oooo00D000000?ooo`3oool0oooo000000070?ooo`05
0000003oool0oooo0?ooo`0000000`3oool2000000<0oooo0P00000>0?ooo`040?l0003oool0oooo
0?l006l0oooo00<000000?ooo`3oool0903oool004h0ooooN000000?0?ooo`8000002@3oool40000
00D0oooo00D000000?ooo`3oool0oooo000000080?ooo`800?ZJLP3oool00`000000oooo0?ooo`06
0?ooo`<00000203oool5000000@0oooo00D000000?ooo`3oool0oooo0000000?0?ooo`030?l0003o
ool0o`000700oooo00<000000?ooo`3oool0903oool00=L0oooo00<000000?ooo`3oool01@3oool0
1P000000oooo0?ooo`3oool000000?ooo`@00000103oool00`000000oooo0?ooo`060?ooo`03003j
VP3oool0oooo0700oooo0P00000P0?ooo`8000003P3oool00`3o0000oooo0?l0001`0?ooo`030000
003oool0oooo02@0oooo003C0?ooo`050000003oool0oooo0?ooo`0000001`3oool01`000000oooo
0?ooo`3oool000000?ooo`0000001`3oool00`000000oooo0?ooo`060?ooo`03003jVP3oool0oooo
0740oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0>0?ooo`80o`00L03oool00`00
0000oooo0?ooo`0T0?ooo`00e03oool3000000T0oooo0`0000020?ooo`D000000`3oool010000000
oooo0?ooo`00000?0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool03@3oool00`00
0000oooo0?ooo`0<0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool03@3oool00`00
0000oooo0?ooo`0<0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`0>0?ooo`030?l0003oool0oooo06l0oooo00<000000?ooo`3oool0903oool00>d0
ooooOP00000P0?ooo`8000003`3oool00`3o0000oooo0?ooo`1_0?ooo`030000003oool0oooo02@0
oooo003o0?oooh`0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo0000
0080oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo00000080oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00D000000?ooo`3oool0oooo0000
00020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0903oool00?l0ooooS03o
oon4000002H0oooo003o0?ooool0oooo=`3oool00?l0ooooo`3ooolg0?ooo`00o`3ooooo0?ooocL0
oooo003o0?ooool0oooo=`3oool00?l0ooooo`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo003o0?oo
ool0oooo=`3oool00?l0ooooo`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo003o0?ooool0oooo=`3o
ool00?l0ooooo`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo003o0?ooool0oooo=`3oool00?l0oooo
o`3ooolg0?ooo`00o`3ooooo0?ooocL0oooo003o0?ooool0oooo=`3oool00?l0ooooo`3ooolg0?oo
o`00kP3oool300000?l0ooooA@3oool00?40oooo00<000000?ooo`3oool0o`3ooom20?ooo`00bP3o
ool3000000<0oooo0`0000020?ooo`<0000000<0oooo0000000000000P3oool00`000000oooo0?oo
o`020?ooo`<000000P3oool3000000@0oooo100000020?ooo`<000000P3oool3000000040?ooo`00
000000000?ooo`<000000`3oool3000000T0oooo0`0000020?ooo`D000001`3oool2000000030?oo
o`000000000000H00000203oool300000080oooo100000040?ooo`8000000P3oool5000000060?oo
o`000000oooo0000003oool000000P3oool4000000<0oooo0P0000030?ooo`<000000P3oool40000
0<`0oooo00390?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`040000003oool0
oooo00000080oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3oool01P00
0000oooo0?ooo`000000oooo000000<0oooo00<000000?ooo`0000002`3oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool000001`3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo
00000080oooo00D000000?ooo`3oool0oooo000000030?ooo`070000003oool000000?ooo`000000
oooo000000020?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo000000090?oo
o`030000003oool0oooo0<T0oooo00390?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`0000000P3oool5
00000080oooo00<000000?ooo`3oool00P3oool01P000000oooo0?ooo`3oool000000?ooo`D00000
0P3oool01P000000oooo0?ooo`000000oooo000000D0oooo1@0000070?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`070?ooo`050000003oool0oooo0?ooo`0000000P3o
ool00`000000oooo0?ooo`080?ooo`D000000P3oool3000000<0oooo00<000000?ooo`3oool0103o
ool02@000000oooo0?ooo`3oool000000?ooo`000000oooo000000020?ooo`<000000`3oool00`00
0000oooo0?ooo`020?ooo`D000000P3oool300000<`0oooo00390?ooo`070000003oool0oooo0?oo
o`000000oooo000000030?ooo`040000003oool0oooo00000080oooo00H000000?ooo`3oool00000
0?ooo`0000020?ooo`050000003oool0oooo0?ooo`0000000P3oool2000000<0oooo00L000000?oo
o`3oool0oooo0000003oool0000000<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo
000000030?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool01@3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool0203oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3o
ool00`000000oooo0?ooo`040?ooo`0;0000003oool0oooo0?ooo`000000oooo0000003oool00000
0?ooo`0000000P3oool01@000000oooo0?ooo`3oool0000000@0oooo00L000000?ooo`3oool0oooo
0000003oool000000<l0oooo003:0?ooo`<000000`3oool300000080oooo100000020?ooo`800000
00<0oooo0000000000000P3oool300000080oooo0P0000000`3oool00000000000020?ooo`D00000
00@0oooo00000000000000000P3oool4000000<0oooo0`0000030?ooo`<000002@3oool3000000<0
oooo100000070?ooo`050000003oool000000?ooo`0000000P3oool00`000000oooo0?ooo`090?oo
o`<000000`3oool4000000030?ooo`0000000000008000000P3oool3000000<0oooo0P0000000`3o
ool000000?ooo`020?ooo`8000000`3oool4000000<0oooo0`0000030?ooo`@00000b`3oool00?l0
oooo6P3oool00`000000oooo0?ooo`070?ooo`80000000<0oooo0000000000000P3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0f03oool00?l0oooo
6`3oool2000000L0oooo00@000000?ooo`3oool0oooo1@00000F0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`3H0?ooo`00o`3ooooo0?ooocL0oooo
003o0?ooool0oooo=`3oool00001\
\>"],
  ImageRangeCache->{{{0, 564.188}, {231.875, 0}} -> {-0.215658, -0.0309084, \
0.00608188, 0.00608188}, {{35.4375, 199.875}, {226.75, 125.125}} -> \
{-10.6963, 18.5868, 0.152387, 0.00163087}, {{199.875, 364.25}, {226.75, \
125.125}} -> {-35.7713, 44.3878, 0.15246, 0.00136369}, {{364.25, 528.688}, \
{226.75, 125.125}} -> {-60.803, 26.318, 0.152387, 0.00131887}, {{35.4375, \
199.875}, {125.125, 23.5}} -> {-13.7307, -571.208, 0.167958, 0.000794143}, \
{{199.875, 364.25}, {125.125, 23.5}} -> {-38.435, -4.35775, 0.159875, \
0.00207545}, {{364.25, 528.688}, {125.125, 23.5}} -> {-60.803, -4.10896, \
0.152387, 0.00190551}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
AutoGeneratedPackage->None,
WindowToolbars->{},
WindowSize->{843, 675},
WindowMargins->{{23, Automatic}, {Automatic, 11}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FontColor->GrayLevel[0],
MacintoshSystemPageSetup->"\<\
00<0001804P000000`d26_oRon<3;08f0dL5N`?P0080001804P000000`82C`01
0000I00000400`<300000Gd000400@0000000000000004P801T1T00000000000
00000000000000000000000000000000\>"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 54, 1, 56, "Section"],
Cell[1833, 56, 618, 11, 139, "Input"],

Cell[CellGroupData[{
Cell[2476, 71, 85, 2, 39, "Input"],
Cell[2564, 75, 136, 2, 21, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2737, 82, 49, 1, 46, "Subsection"],

Cell[CellGroupData[{
Cell[2811, 87, 61, 2, 39, "Input"],
Cell[2875, 91, 1196, 18, 278, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4108, 114, 299, 6, 71, "Input"],
Cell[4410, 122, 107, 2, 38, "Output"]
}, Open  ]],
Cell[4532, 127, 152, 5, 54, "Input"],

Cell[CellGroupData[{
Cell[4709, 136, 57, 2, 39, "Input"],
Cell[4769, 140, 1290, 17, 173, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6096, 162, 58, 2, 39, "Input"],
Cell[6157, 166, 449, 6, 68, "Output"]
}, Open  ]],
Cell[6621, 175, 133, 5, 54, "Input"],

Cell[CellGroupData[{
Cell[6779, 184, 183, 6, 69, "Input"],
Cell[6965, 192, 179, 3, 22, "Print"],
Cell[7147, 197, 63513, 1407, 182, 10088, 742, "GraphicsData", "PostScript", \
"Graphics"],
Cell[70663, 1606, 177, 3, 22, "Print"],

Cell[CellGroupData[{
Cell[70865, 1613, 40500, 1016, 182, 8025, 610, "GraphicsData", "PostScript", \
"Graphics"],
Cell[111368, 2631, 66226, 1477, 182, 11452, 796, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[177609, 4111, 130, 3, 38, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[177788, 4120, 65, 1, 46, "Subsection"],
Cell[177856, 4123, 63, 1, 39, "Input"],

Cell[CellGroupData[{
Cell[177944, 4128, 1484, 28, 849, "Input",
  InitializationCell->True],
Cell[179431, 4158, 76, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[179544, 4164, 34, 1, 39, "Input"],
Cell[179581, 4167, 35, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[179653, 4173, 224, 10, 99, "Input",
  InitializationCell->True],
Cell[179880, 4185, 181, 3, 40, "Output"],
Cell[180064, 4190, 363, 5, 68, "Output"],
Cell[180430, 4197, 62, 1, 38, "Output"],
Cell[180495, 4200, 76, 1, 38, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[180620, 4207, 35, 0, 30, "Subsection"],

Cell[CellGroupData[{
Cell[180680, 4211, 355, 8, 189, "Input"],
Cell[181038, 4221, 45, 1, 38, "Output"]
}, Open  ]],
Cell[181098, 4225, 279, 12, 159, "Input"],

Cell[CellGroupData[{
Cell[181402, 4241, 181, 6, 54, "Input"],
Cell[181586, 4249, 99, 2, 22, "Print"],
Cell[181688, 4253, 98, 2, 22, "Print"],
Cell[181789, 4257, 99, 2, 22, "Print"],
Cell[181891, 4261, 51, 1, 22, "Print"],
Cell[181945, 4264, 607, 14, 31, "Print"],
Cell[182555, 4280, 45, 1, 22, "Print"],
Cell[182603, 4283, 582, 14, 33, "Print"],
Cell[183188, 4299, 45, 1, 22, "Print"],
Cell[183236, 4302, 474, 13, 31, "Print"],
Cell[183713, 4317, 45, 1, 22, "Print"],
Cell[183761, 4320, 275, 6, 22, "Print"],
Cell[184039, 4328, 219, 4, 22, "Print"],
Cell[184261, 4334, 220, 4, 22, "Print"],
Cell[184484, 4340, 218, 4, 24, "Print"],
Cell[184705, 4346, 204, 4, 22, "Print"],
Cell[184912, 4352, 203, 4, 24, "Print"],
Cell[185118, 4358, 766, 17, 97, "Print"],
Cell[185887, 4377, 286, 5, 22, "Print"],
Cell[186176, 4384, 102, 2, 22, "Print"],
Cell[186281, 4388, 159, 3, 22, "Print"],
Cell[186443, 4393, 828, 18, 22, "Print"],
Cell[187274, 4413, 45, 1, 22, "Print"],
Cell[187322, 4416, 764, 17, 22, "Print"],
Cell[188089, 4435, 416, 10, 22, "Print"],
Cell[188508, 4447, 45, 1, 22, "Print"],
Cell[188556, 4450, 1051, 23, 101, "Print"],
Cell[189610, 4475, 53, 1, 22, "Print"],
Cell[189666, 4478, 2986, 87, 85, "Print"],
Cell[192655, 4567, 204, 4, 22, "Print"],
Cell[192862, 4573, 257, 4, 22, "Print"],
Cell[193122, 4579, 102, 2, 22, "Print"],
Cell[193227, 4583, 159, 3, 22, "Print"],
Cell[193389, 4588, 826, 18, 22, "Print"],
Cell[194218, 4608, 45, 1, 22, "Print"],
Cell[194266, 4611, 762, 17, 22, "Print"],
Cell[195031, 4630, 418, 10, 22, "Print"],
Cell[195452, 4642, 45, 1, 22, "Print"],
Cell[195500, 4645, 1119, 24, 101, "Print"],
Cell[196622, 4671, 53, 1, 22, "Print"],
Cell[196678, 4674, 3651, 87, 85, "Print"],
Cell[200332, 4763, 204, 4, 22, "Print"],
Cell[200539, 4769, 265, 5, 22, "Print"],
Cell[200807, 4776, 102, 2, 22, "Print"],
Cell[200912, 4780, 159, 3, 22, "Print"],
Cell[201074, 4785, 45, 1, 22, "Print"],
Cell[201122, 4788, 764, 17, 22, "Print"],
Cell[201889, 4807, 418, 10, 22, "Print"],
Cell[202310, 4819, 45, 1, 22, "Print"],
Cell[202358, 4822, 1132, 25, 101, "Print"],
Cell[203493, 4849, 53, 1, 22, "Print"],
Cell[203549, 4852, 3636, 87, 85, "Print"],
Cell[207188, 4941, 204, 4, 22, "Print"],
Cell[207395, 4947, 255, 4, 22, "Print"],
Cell[207653, 4953, 102, 2, 22, "Print"],
Cell[207758, 4957, 159, 3, 22, "Print"],
Cell[207920, 4962, 45, 1, 22, "Print"],
Cell[207968, 4965, 764, 17, 22, "Print"],
Cell[208735, 4984, 420, 10, 22, "Print"],
Cell[209158, 4996, 45, 1, 22, "Print"],
Cell[209206, 4999, 1122, 24, 101, "Print"],
Cell[210331, 5025, 53, 1, 22, "Print"],
Cell[210387, 5028, 3626, 87, 85, "Print"],
Cell[214016, 5117, 204, 4, 22, "Print"],
Cell[214223, 5123, 265, 5, 22, "Print"],
Cell[214491, 5130, 102, 2, 22, "Print"],
Cell[214596, 5134, 159, 3, 22, "Print"],
Cell[214758, 5139, 45, 1, 22, "Print"],
Cell[214806, 5142, 764, 17, 22, "Print"],
Cell[215573, 5161, 420, 10, 22, "Print"],
Cell[215996, 5173, 45, 1, 22, "Print"],
Cell[216044, 5176, 1130, 25, 101, "Print"],
Cell[217177, 5203, 53, 1, 22, "Print"],
Cell[217233, 5206, 3602, 87, 85, "Print"],
Cell[220838, 5295, 204, 4, 22, "Print"],
Cell[221045, 5301, 263, 5, 22, "Print"],
Cell[221311, 5308, 102, 2, 22, "Print"],
Cell[221416, 5312, 159, 3, 22, "Print"],
Cell[221578, 5317, 45, 1, 22, "Print"],
Cell[221626, 5320, 764, 17, 22, "Print"],
Cell[222393, 5339, 422, 10, 22, "Print"],
Cell[222818, 5351, 45, 1, 22, "Print"],
Cell[222866, 5354, 1138, 25, 101, "Print"],
Cell[224007, 5381, 53, 1, 22, "Print"],
Cell[224063, 5384, 3600, 87, 85, "Print"],
Cell[227666, 5473, 204, 4, 22, "Print"],
Cell[227873, 5479, 257, 4, 22, "Print"],
Cell[228133, 5485, 102, 2, 22, "Print"],
Cell[228238, 5489, 159, 3, 22, "Print"],
Cell[228400, 5494, 45, 1, 22, "Print"],
Cell[228448, 5497, 764, 17, 22, "Print"],
Cell[229215, 5516, 420, 10, 22, "Print"],
Cell[229638, 5528, 45, 1, 22, "Print"],
Cell[229686, 5531, 1141, 25, 101, "Print"],
Cell[230830, 5558, 53, 1, 22, "Print"],
Cell[230886, 5561, 3590, 87, 85, "Print"],
Cell[234479, 5650, 204, 4, 22, "Print"],
Cell[234686, 5656, 265, 5, 22, "Print"],
Cell[234954, 5663, 102, 2, 22, "Print"],
Cell[235059, 5667, 159, 3, 22, "Print"],
Cell[235221, 5672, 45, 1, 22, "Print"],
Cell[235269, 5675, 764, 17, 22, "Print"],
Cell[236036, 5694, 422, 10, 22, "Print"],
Cell[236461, 5706, 45, 1, 22, "Print"],
Cell[236509, 5709, 1135, 25, 101, "Print"],
Cell[237647, 5736, 53, 1, 22, "Print"],
Cell[237703, 5739, 3601, 87, 85, "Print"],
Cell[241307, 5828, 204, 4, 22, "Print"],
Cell[241514, 5834, 266, 5, 22, "Print"],
Cell[241783, 5841, 102, 2, 22, "Print"],
Cell[241888, 5845, 159, 3, 22, "Print"],
Cell[242050, 5850, 45, 1, 22, "Print"],
Cell[242098, 5853, 762, 17, 22, "Print"],
Cell[242863, 5872, 422, 10, 22, "Print"],
Cell[243288, 5884, 45, 1, 22, "Print"],
Cell[243336, 5887, 1128, 24, 101, "Print"],
Cell[244467, 5913, 53, 1, 22, "Print"],
Cell[244523, 5916, 3608, 87, 85, "Print"],
Cell[248134, 6005, 204, 4, 22, "Print"],
Cell[248341, 6011, 264, 5, 22, "Print"],
Cell[248608, 6018, 102, 2, 22, "Print"],
Cell[248713, 6022, 161, 3, 22, "Print"],
Cell[248877, 6027, 45, 1, 22, "Print"],
Cell[248925, 6030, 764, 17, 22, "Print"],
Cell[249692, 6049, 434, 10, 24, "Print"],
Cell[250129, 6061, 45, 1, 22, "Print"],
Cell[250177, 6064, 1141, 24, 101, "Print"],
Cell[251321, 6090, 53, 1, 22, "Print"],
Cell[251377, 6093, 3621, 87, 85, "Print"],
Cell[255001, 6182, 204, 4, 22, "Print"],
Cell[255208, 6188, 257, 4, 22, "Print"],
Cell[255468, 6194, 102, 2, 22, "Print"],
Cell[255573, 6198, 161, 3, 22, "Print"],
Cell[255737, 6203, 45, 1, 22, "Print"],
Cell[255785, 6206, 764, 17, 22, "Print"],
Cell[256552, 6225, 434, 10, 24, "Print"],
Cell[256989, 6237, 45, 1, 22, "Print"],
Cell[257037, 6240, 1136, 25, 101, "Print"],
Cell[258176, 6267, 53, 1, 22, "Print"],
Cell[258232, 6270, 3605, 87, 85, "Print"],
Cell[261840, 6359, 204, 4, 22, "Print"],
Cell[262047, 6365, 264, 5, 22, "Print"],
Cell[262314, 6372, 102, 2, 22, "Print"],
Cell[262419, 6376, 161, 3, 22, "Print"],
Cell[262583, 6381, 45, 1, 22, "Print"],
Cell[262631, 6384, 764, 17, 22, "Print"],
Cell[263398, 6403, 434, 10, 24, "Print"],
Cell[263835, 6415, 45, 1, 22, "Print"],
Cell[263883, 6418, 1138, 25, 101, "Print"],
Cell[265024, 6445, 53, 1, 22, "Print"],
Cell[265080, 6448, 3595, 87, 85, "Print"],
Cell[268678, 6537, 204, 4, 22, "Print"],
Cell[268885, 6543, 268, 5, 24, "Print"],
Cell[269156, 6550, 102, 2, 22, "Print"],
Cell[269261, 6554, 161, 3, 22, "Print"],
Cell[269425, 6559, 45, 1, 22, "Print"],
Cell[269473, 6562, 762, 17, 22, "Print"],
Cell[270238, 6581, 434, 10, 24, "Print"],
Cell[270675, 6593, 45, 1, 22, "Print"],
Cell[270723, 6596, 1143, 25, 101, "Print"],
Cell[271869, 6623, 53, 1, 22, "Print"],
Cell[271925, 6626, 3598, 87, 85, "Print"],
Cell[275526, 6715, 204, 4, 22, "Print"],
Cell[275733, 6721, 265, 5, 22, "Print"],
Cell[276001, 6728, 102, 2, 22, "Print"],
Cell[276106, 6732, 161, 3, 22, "Print"],
Cell[276270, 6737, 45, 1, 22, "Print"],
Cell[276318, 6740, 762, 17, 22, "Print"],
Cell[277083, 6759, 432, 10, 24, "Print"],
Cell[277518, 6771, 45, 1, 22, "Print"],
Cell[277566, 6774, 1147, 25, 101, "Print"],
Cell[278716, 6801, 53, 1, 22, "Print"],
Cell[278772, 6804, 3598, 87, 85, "Print"],
Cell[282373, 6893, 204, 4, 22, "Print"],
Cell[282580, 6899, 256, 4, 22, "Print"],
Cell[282839, 6905, 102, 2, 22, "Print"],
Cell[282944, 6909, 161, 3, 22, "Print"],
Cell[283108, 6914, 45, 1, 22, "Print"],
Cell[283156, 6917, 764, 17, 22, "Print"],
Cell[283923, 6936, 432, 10, 24, "Print"],
Cell[284358, 6948, 45, 1, 22, "Print"],
Cell[284406, 6951, 1155, 25, 101, "Print"],
Cell[285564, 6978, 53, 1, 22, "Print"],
Cell[285620, 6981, 3597, 87, 85, "Print"],
Cell[289220, 7070, 204, 4, 22, "Print"],
Cell[289427, 7076, 265, 5, 22, "Print"],
Cell[289695, 7083, 102, 2, 22, "Print"],
Cell[289800, 7087, 161, 3, 22, "Print"],
Cell[289964, 7092, 45, 1, 22, "Print"],
Cell[290012, 7095, 764, 17, 22, "Print"],
Cell[290779, 7114, 434, 10, 24, "Print"],
Cell[291216, 7126, 45, 1, 22, "Print"],
Cell[291264, 7129, 1149, 26, 101, "Print"],
Cell[292416, 7157, 53, 1, 22, "Print"],
Cell[292472, 7160, 3613, 87, 85, "Print"],
Cell[296088, 7249, 204, 4, 22, "Print"],
Cell[296295, 7255, 266, 5, 22, "Print"],
Cell[296564, 7262, 102, 2, 22, "Print"],
Cell[296669, 7266, 161, 3, 22, "Print"],
Cell[296833, 7271, 45, 1, 22, "Print"],
Cell[296881, 7274, 764, 17, 22, "Print"],
Cell[297648, 7293, 434, 10, 24, "Print"],
Cell[298085, 7305, 45, 1, 22, "Print"],
Cell[298133, 7308, 1146, 25, 101, "Print"],
Cell[299282, 7335, 53, 1, 22, "Print"],
Cell[299338, 7338, 3638, 87, 85, "Print"],
Cell[302979, 7427, 204, 4, 22, "Print"],
Cell[303186, 7433, 272, 5, 24, "Print"],
Cell[303461, 7440, 102, 2, 22, "Print"],
Cell[303566, 7444, 161, 3, 22, "Print"],
Cell[303730, 7449, 45, 1, 22, "Print"],
Cell[303778, 7452, 764, 17, 22, "Print"],
Cell[304545, 7471, 434, 10, 24, "Print"],
Cell[304982, 7483, 45, 1, 22, "Print"],
Cell[305030, 7486, 1159, 26, 101, "Print"],
Cell[306192, 7514, 53, 1, 22, "Print"],
Cell[306248, 7517, 3621, 87, 85, "Print"],
Cell[309872, 7606, 204, 4, 22, "Print"],
Cell[310079, 7612, 102, 2, 22, "Print"],
Cell[310184, 7616, 161, 3, 22, "Print"],
Cell[310348, 7621, 45, 1, 22, "Print"],
Cell[310396, 7624, 764, 17, 22, "Print"],
Cell[311163, 7643, 435, 10, 24, "Print"],
Cell[311601, 7655, 45, 1, 22, "Print"],
Cell[311649, 7658, 1152, 26, 115, "Print"],
Cell[312804, 7686, 53, 1, 22, "Print"],
Cell[312860, 7689, 3621, 87, 85, "Print"],
Cell[316484, 7778, 204, 4, 22, "Print"],
Cell[316691, 7784, 102, 2, 22, "Print"],
Cell[316796, 7788, 161, 3, 22, "Print"],
Cell[316960, 7793, 45, 1, 22, "Print"],
Cell[317008, 7796, 764, 17, 22, "Print"],
Cell[317775, 7815, 435, 10, 24, "Print"],
Cell[318213, 7827, 45, 1, 22, "Print"],
Cell[318261, 7830, 1148, 26, 115, "Print"],
Cell[319412, 7858, 53, 1, 22, "Print"],
Cell[319468, 7861, 3621, 87, 85, "Print"],
Cell[323092, 7950, 204, 4, 22, "Print"],
Cell[323299, 7956, 233, 4, 22, "Print"],
Cell[323535, 7962, 3851, 69, 341, "Print"],
Cell[327389, 8033, 192, 4, 24, "Print"],
Cell[327584, 8039, 204, 4, 22, "Print"],
Cell[327791, 8045, 204, 4, 22, "Print"],
Cell[327998, 8051, 204, 4, 22, "Print"],
Cell[328205, 8057, 204, 4, 22, "Print"],
Cell[328412, 8063, 204, 4, 22, "Print"],
Cell[328619, 8069, 204, 4, 22, "Print"],
Cell[328826, 8075, 204, 4, 22, "Print"],
Cell[329033, 8081, 204, 4, 22, "Print"],
Cell[329240, 8087, 204, 4, 22, "Print"],
Cell[329447, 8093, 204, 4, 22, "Print"],
Cell[329654, 8099, 204, 4, 22, "Print"],
Cell[329861, 8105, 86, 1, 22, "Print"],
Cell[329950, 8108, 1141, 22, 99, "Print"],
Cell[331094, 8132, 91, 1, 22, "Print"],
Cell[331188, 8135, 80, 1, 22, "Print"],
Cell[331271, 8138, 91, 1, 22, "Print"],
Cell[331365, 8141, 1504, 30, 85, "Print"],
Cell[332872, 8173, 89, 1, 22, "Print"],
Cell[332964, 8176, 45, 1, 22, "Print"],
Cell[333012, 8179, 89, 1, 22, "Print"],
Cell[333104, 8182, 542, 14, 31, "Print"],
Cell[333649, 8198, 67, 1, 22, "Print"],
Cell[333719, 8201, 89, 1, 22, "Print"],
Cell[333811, 8204, 66, 1, 22, "Print"],
Cell[333880, 8207, 89, 1, 22, "Print"],
Cell[333972, 8210, 89, 1, 22, "Print"],
Cell[334064, 8213, 208, 4, 22, "Print"],
Cell[334275, 8219, 949, 22, 71, "Print"],
Cell[335227, 8243, 90, 1, 22, "Print"],
Cell[335320, 8246, 74, 1, 22, "Print"],
Cell[335397, 8249, 90, 1, 22, "Print"],
Cell[335490, 8252, 904, 17, 85, "Print"],
Cell[336397, 8271, 91, 1, 22, "Print"],
Cell[336491, 8274, 97, 2, 22, "Print"],
Cell[336591, 8278, 91, 1, 22, "Print"],
Cell[336685, 8281, 992, 20, 85, "Print"],
Cell[337680, 8303, 45, 1, 22, "Print"],
Cell[337728, 8306, 145, 2, 22, "Print"],
Cell[337876, 8310, 91, 1, 22, "Print"],
Cell[337970, 8313, 108, 2, 22, "Print"],
Cell[338081, 8317, 91, 1, 22, "Print"],
Cell[338175, 8320, 1024, 20, 85, "Print"],
Cell[339202, 8342, 45, 1, 22, "Print"],
Cell[339250, 8345, 149, 2, 22, "Print"],
Cell[339402, 8349, 91, 1, 22, "Print"],
Cell[339496, 8352, 58, 1, 22, "Print"],
Cell[339557, 8355, 91, 1, 22, "Print"],
Cell[339651, 8358, 199, 4, 22, "Print"],
Cell[339853, 8364, 109, 2, 22, "Print"],
Cell[339965, 8368, 743, 17, 41, "Print"],
Cell[340711, 8387, 93, 1, 22, "Print"],
Cell[340807, 8390, 48, 1, 22, "Print"],
Cell[340858, 8393, 93, 1, 22, "Print"],
Cell[340954, 8396, 89, 1, 22, "Print"],
Cell[341046, 8399, 61, 1, 22, "Print"],
Cell[341110, 8402, 74, 1, 22, "Print"],
Cell[341187, 8405, 93, 1, 22, "Print"],
Cell[341283, 8408, 1085, 24, 37, "Print"],
Cell[342371, 8434, 93, 1, 22, "Print"],
Cell[342467, 8437, 865, 21, 37, "Print"],
Cell[343335, 8460, 93, 1, 22, "Print"],
Cell[343431, 8463, 1002, 23, 39, "Print"],
Cell[344436, 8488, 93, 1, 22, "Print"],
Cell[344532, 8491, 836, 20, 37, "Print"],
Cell[345371, 8513, 93, 1, 22, "Print"],
Cell[345467, 8516, 938, 22, 37, "Print"],
Cell[346408, 8540, 93, 1, 22, "Print"],
Cell[346504, 8543, 825, 19, 23, "Print"],
Cell[347332, 8564, 93, 1, 22, "Print"],
Cell[347428, 8567, 871, 20, 23, "Print"],
Cell[348302, 8589, 93, 1, 22, "Print"],
Cell[348398, 8592, 866, 20, 23, "Print"],
Cell[349267, 8614, 93, 1, 22, "Print"],
Cell[349363, 8617, 48, 1, 22, "Print"],
Cell[349414, 8620, 93, 1, 22, "Print"],
Cell[349510, 8623, 107, 2, 22, "Print"],
Cell[349620, 8627, 64, 1, 22, "Print"],
Cell[349687, 8630, 93, 1, 22, "Print"],
Cell[349783, 8633, 1257, 30, 37, "Print"],
Cell[351043, 8665, 45, 1, 22, "Print"],
Cell[351091, 8668, 1263, 30, 37, "Print"],
Cell[352357, 8700, 93, 1, 22, "Print"],
Cell[352453, 8703, 820, 21, 37, "Print"],
Cell[353276, 8726, 45, 1, 22, "Print"],
Cell[353324, 8729, 820, 21, 37, "Print"],
Cell[354147, 8752, 93, 1, 22, "Print"],
Cell[354243, 8755, 1249, 30, 37, "Print"],
Cell[355495, 8787, 45, 1, 22, "Print"],
Cell[355543, 8790, 1249, 30, 37, "Print"],
Cell[356795, 8822, 93, 1, 22, "Print"],
Cell[356891, 8825, 789, 20, 37, "Print"],
Cell[357683, 8847, 45, 1, 22, "Print"],
Cell[357731, 8850, 820, 21, 37, "Print"],
Cell[358554, 8873, 93, 1, 22, "Print"],
Cell[358650, 8876, 1132, 29, 37, "Print"],
Cell[359785, 8907, 45, 1, 22, "Print"],
Cell[359833, 8910, 1103, 28, 37, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[360973, 8943, 224, 6, 69, "Input"],
Cell[361200, 8951, 177, 3, 22, "Print"],
Cell[361380, 8956, 177, 3, 22, "Print"],
Cell[361560, 8961, 177, 3, 22, "Print"],
Cell[361740, 8966, 177, 3, 22, "Print"],
Cell[361920, 8971, 177, 3, 22, "Print"],
Cell[362100, 8976, 177, 3, 22, "Print"],
Cell[362280, 8981, 115060, 3591, 251, 34799, 2595, "GraphicsData", \
"PostScript", "Graphics"],
Cell[477343, 12574, 135, 3, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[477515, 12582, 53, 1, 39, "Input"],
Cell[477571, 12585, 3779, 67, 357, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[481387, 12657, 146, 5, 39, "Input"],
Cell[481536, 12664, 50, 1, 22, "Print"]
}, Open  ]],
Cell[481601, 12668, 170, 6, 54, "Input"],

Cell[CellGroupData[{
Cell[481796, 12678, 94, 2, 39, "Input"],
Cell[481893, 12682, 53, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[481983, 12688, 263, 7, 84, "Input"],
Cell[482249, 12697, 179, 3, 22, "Print"],
Cell[482431, 12702, 98796, 2372, 182, 21695, 1415, "GraphicsData", \
"PostScript", "Graphics"],
Cell[581230, 15076, 179, 3, 22, "Print"],
Cell[581412, 15081, 115172, 2556, 182, 21442, 1394, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[696633, 17643, 100, 2, 30, "Subsection"],

Cell[CellGroupData[{
Cell[696758, 17649, 88, 2, 39, "Input"],
Cell[696849, 17653, 38, 1, 38, "Output"]
}, Open  ]],
Cell[696902, 17657, 200, 5, 42, "Input"],

Cell[CellGroupData[{
Cell[697127, 17666, 169, 6, 54, "Input"],
Cell[697299, 17674, 42, 1, 22, "Print"],
Cell[697344, 17677, 62, 1, 22, "Print"],
Cell[697409, 17680, 79, 1, 22, "Print"],
Cell[697491, 17683, 48, 1, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[697576, 17689, 425, 13, 129, "Input"],
Cell[698004, 17704, 179, 3, 22, "Print"],
Cell[698186, 17709, 83419, 2254, 182, 24701, 1524, "GraphicsData", \
"PostScript", "Graphics"],
Cell[781608, 19965, 179, 3, 22, "Print"],
Cell[781790, 19970, 102629, 2548, 182, 25359, 1589, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[884456, 22523, 190, 7, 84, "Input"],
Cell[884649, 22532, 177, 3, 22, "Print"],
Cell[884829, 22537, 92643, 2456, 182, 26785, 1638, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[977521, 24999, 95, 2, 30, "Subsection"],
Cell[977619, 25003, 93, 2, 39, "Input"],

Cell[CellGroupData[{
Cell[977737, 25009, 91, 5, 54, "Input"],
Cell[977831, 25016, 111, 2, 38, "Output"],
Cell[977945, 25020, 74, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[978056, 25026, 183, 6, 54, "Input"],
Cell[978242, 25034, 107, 2, 22, "Print"],
Cell[978352, 25038, 107, 2, 22, "Print"],
Cell[978462, 25042, 107, 2, 22, "Print"],
Cell[978572, 25046, 183, 3, 22, "Print"],
Cell[978758, 25051, 90, 1, 22, "Print"],
Cell[978851, 25054, 86, 1, 22, "Print"],
Cell[978940, 25057, 179, 3, 22, "Print"],
Cell[979122, 25062, 86, 1, 22, "Print"],
Cell[979211, 25065, 86, 1, 22, "Print"],
Cell[979300, 25068, 260, 5, 22, "Print"],
Cell[979563, 25075, 86, 1, 22, "Print"],
Cell[979652, 25078, 195, 4, 22, "Print"],
Cell[979850, 25084, 86, 1, 22, "Print"],
Cell[979939, 25087, 240, 5, 22, "Print"],
Cell[980182, 25094, 86, 1, 22, "Print"],
Cell[980271, 25097, 84, 1, 22, "Print"],
Cell[980358, 25100, 86, 1, 22, "Print"],
Cell[980447, 25103, 327, 6, 22, "Print"],
Cell[980777, 25111, 45, 1, 22, "Print"],
Cell[980825, 25114, 3856, 65, 437, "Print"],
Cell[984684, 25181, 177, 3, 22, "Print"],
Cell[984864, 25186, 44201, 1126, 266, 11588, 718, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1029068, 26314, 177, 3, 22, "Print"],
Cell[1029248, 26319, 57492, 1313, 266, 12114, 748, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1086743, 27634, 179, 3, 22, "Print"],
Cell[1086925, 27639, 78665, 1642, 266, 11863, 812, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1165593, 29283, 177, 3, 22, "Print"],
Cell[1165773, 29288, 45208, 1176, 266, 11950, 760, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1211030, 30470, 105, 2, 30, "Subsection"],

Cell[CellGroupData[{
Cell[1211160, 30476, 355, 8, 189, "Input"],
Cell[1211518, 30486, 45, 1, 38, "Output"]
}, Open  ]],
Cell[1211578, 30490, 289, 14, 177, "Input"],

Cell[CellGroupData[{
Cell[1211892, 30508, 208, 6, 57, "Input"],
Cell[1212103, 30516, 99, 2, 22, "Print"],
Cell[1212205, 30520, 99, 2, 22, "Print"],
Cell[1212307, 30524, 99, 2, 22, "Print"],
Cell[1212409, 30528, 51, 1, 22, "Print"],
Cell[1212463, 30531, 875, 18, 33, "Print"],
Cell[1213341, 30551, 45, 1, 22, "Print"],
Cell[1213389, 30554, 275, 6, 22, "Print"],
Cell[1213667, 30562, 219, 4, 22, "Print"],
Cell[1213889, 30568, 220, 4, 22, "Print"],
Cell[1214112, 30574, 218, 4, 24, "Print"],
Cell[1214333, 30580, 1499, 30, 91, "Print"],
Cell[1215835, 30612, 286, 5, 22, "Print"],
Cell[1216124, 30619, 102, 2, 22, "Print"],
Cell[1216229, 30623, 161, 3, 22, "Print"],
Cell[1216393, 30628, 828, 18, 22, "Print"],
Cell[1217224, 30648, 828, 18, 22, "Print"],
Cell[1218055, 30668, 45, 1, 22, "Print"],
Cell[1218103, 30671, 764, 17, 22, "Print"],
Cell[1218870, 30690, 416, 10, 22, "Print"],
Cell[1219289, 30702, 45, 1, 22, "Print"],
Cell[1219337, 30705, 1051, 23, 101, "Print"],
Cell[1220391, 30730, 53, 1, 22, "Print"],
Cell[1220447, 30733, 2986, 87, 85, "Print"],
Cell[1223436, 30822, 265, 5, 22, "Print"],
Cell[1223704, 30829, 102, 2, 22, "Print"],
Cell[1223809, 30833, 161, 3, 22, "Print"],
Cell[1223973, 30838, 828, 18, 22, "Print"],
Cell[1224804, 30858, 45, 1, 22, "Print"],
Cell[1224852, 30861, 764, 17, 22, "Print"],
Cell[1225619, 30880, 418, 10, 22, "Print"],
Cell[1226040, 30892, 45, 1, 22, "Print"],
Cell[1226088, 30895, 1116, 24, 101, "Print"],
Cell[1227207, 30921, 53, 1, 22, "Print"],
Cell[1227263, 30924, 3650, 87, 85, "Print"],
Cell[1230916, 31013, 252, 4, 22, "Print"],
Cell[1231171, 31019, 102, 2, 22, "Print"],
Cell[1231276, 31023, 161, 3, 22, "Print"],
Cell[1231440, 31028, 45, 1, 22, "Print"],
Cell[1231488, 31031, 764, 17, 22, "Print"],
Cell[1232255, 31050, 418, 10, 22, "Print"],
Cell[1232676, 31062, 45, 1, 22, "Print"],
Cell[1232724, 31065, 1132, 26, 101, "Print"],
Cell[1233859, 31093, 53, 1, 22, "Print"],
Cell[1233915, 31096, 3640, 87, 85, "Print"],
Cell[1237558, 31185, 266, 5, 22, "Print"],
Cell[1237827, 31192, 102, 2, 22, "Print"],
Cell[1237932, 31196, 161, 3, 22, "Print"],
Cell[1238096, 31201, 45, 1, 22, "Print"],
Cell[1238144, 31204, 762, 17, 22, "Print"],
Cell[1238909, 31223, 420, 10, 22, "Print"],
Cell[1239332, 31235, 45, 1, 22, "Print"],
Cell[1239380, 31238, 1121, 24, 101, "Print"],
Cell[1240504, 31264, 53, 1, 22, "Print"],
Cell[1240560, 31267, 3604, 87, 85, "Print"],
Cell[1244167, 31356, 264, 5, 22, "Print"],
Cell[1244434, 31363, 102, 2, 22, "Print"],
Cell[1244539, 31367, 161, 3, 22, "Print"],
Cell[1244703, 31372, 45, 1, 22, "Print"],
Cell[1244751, 31375, 762, 17, 22, "Print"],
Cell[1245516, 31394, 420, 10, 22, "Print"],
Cell[1245939, 31406, 45, 1, 22, "Print"],
Cell[1245987, 31409, 1124, 25, 101, "Print"],
Cell[1247114, 31436, 53, 1, 22, "Print"],
Cell[1247170, 31439, 3597, 87, 85, "Print"],
Cell[1250770, 31528, 266, 5, 22, "Print"],
Cell[1251039, 31535, 102, 2, 22, "Print"],
Cell[1251144, 31539, 161, 3, 22, "Print"],
Cell[1251308, 31544, 45, 1, 22, "Print"],
Cell[1251356, 31547, 764, 17, 22, "Print"],
Cell[1252123, 31566, 422, 10, 22, "Print"],
Cell[1252548, 31578, 45, 1, 22, "Print"],
Cell[1252596, 31581, 1133, 25, 101, "Print"],
Cell[1253732, 31608, 53, 1, 22, "Print"],
Cell[1253788, 31611, 3601, 87, 85, "Print"],
Cell[1257392, 31700, 263, 5, 22, "Print"],
Cell[1257658, 31707, 102, 2, 22, "Print"],
Cell[1257763, 31711, 161, 3, 22, "Print"],
Cell[1257927, 31716, 45, 1, 22, "Print"],
Cell[1257975, 31719, 764, 17, 22, "Print"],
Cell[1258742, 31738, 420, 10, 22, "Print"],
Cell[1259165, 31750, 45, 1, 22, "Print"],
Cell[1259213, 31753, 1141, 25, 101, "Print"],
Cell[1260357, 31780, 53, 1, 22, "Print"],
Cell[1260413, 31783, 3597, 87, 85, "Print"],
Cell[1264013, 31872, 266, 5, 22, "Print"],
Cell[1264282, 31879, 102, 2, 22, "Print"],
Cell[1264387, 31883, 161, 3, 22, "Print"],
Cell[1264551, 31888, 45, 1, 22, "Print"],
Cell[1264599, 31891, 764, 17, 22, "Print"],
Cell[1265366, 31910, 422, 10, 22, "Print"],
Cell[1265791, 31922, 45, 1, 22, "Print"],
Cell[1265839, 31925, 1131, 25, 101, "Print"],
Cell[1266973, 31952, 53, 1, 22, "Print"],
Cell[1267029, 31955, 3608, 87, 85, "Print"],
Cell[1270640, 32044, 257, 4, 22, "Print"],
Cell[1270900, 32050, 102, 2, 22, "Print"],
Cell[1271005, 32054, 161, 3, 22, "Print"],
Cell[1271169, 32059, 45, 1, 22, "Print"],
Cell[1271217, 32062, 764, 17, 22, "Print"],
Cell[1271984, 32081, 422, 10, 22, "Print"],
Cell[1272409, 32093, 45, 1, 22, "Print"],
Cell[1272457, 32096, 1126, 24, 101, "Print"],
Cell[1273586, 32122, 53, 1, 22, "Print"],
Cell[1273642, 32125, 3608, 87, 85, "Print"],
Cell[1277253, 32214, 265, 5, 22, "Print"],
Cell[1277521, 32221, 102, 2, 22, "Print"],
Cell[1277626, 32225, 163, 3, 22, "Print"],
Cell[1277792, 32230, 45, 1, 22, "Print"],
Cell[1277840, 32233, 762, 17, 22, "Print"],
Cell[1278605, 32252, 434, 10, 24, "Print"],
Cell[1279042, 32264, 45, 1, 22, "Print"],
Cell[1279090, 32267, 1132, 24, 101, "Print"],
Cell[1280225, 32293, 53, 1, 22, "Print"],
Cell[1280281, 32296, 3611, 87, 85, "Print"],
Cell[1283895, 32385, 257, 4, 22, "Print"],
Cell[1284155, 32391, 102, 2, 22, "Print"],
Cell[1284260, 32395, 163, 3, 22, "Print"],
Cell[1284426, 32400, 45, 1, 22, "Print"],
Cell[1284474, 32403, 762, 17, 22, "Print"],
Cell[1285239, 32422, 434, 10, 24, "Print"],
Cell[1285676, 32434, 45, 1, 22, "Print"],
Cell[1285724, 32437, 1137, 25, 101, "Print"],
Cell[1286864, 32464, 53, 1, 22, "Print"],
Cell[1286920, 32467, 3596, 87, 85, "Print"],
Cell[1290519, 32556, 265, 5, 22, "Print"],
Cell[1290787, 32563, 102, 2, 22, "Print"],
Cell[1290892, 32567, 163, 3, 22, "Print"],
Cell[1291058, 32572, 45, 1, 22, "Print"],
Cell[1291106, 32575, 764, 17, 22, "Print"],
Cell[1291873, 32594, 434, 10, 24, "Print"],
Cell[1292310, 32606, 45, 1, 22, "Print"],
Cell[1292358, 32609, 1158, 25, 101, "Print"],
Cell[1293519, 32636, 53, 1, 22, "Print"],
Cell[1293575, 32639, 3599, 87, 85, "Print"],
Cell[1297177, 32728, 255, 4, 22, "Print"],
Cell[1297435, 32734, 102, 2, 22, "Print"],
Cell[1297540, 32738, 163, 3, 22, "Print"],
Cell[1297706, 32743, 45, 1, 22, "Print"],
Cell[1297754, 32746, 764, 17, 22, "Print"],
Cell[1298521, 32765, 434, 10, 24, "Print"],
Cell[1298958, 32777, 45, 1, 22, "Print"],
Cell[1299006, 32780, 1151, 25, 101, "Print"],
Cell[1300160, 32807, 53, 1, 22, "Print"],
Cell[1300216, 32810, 3626, 87, 85, "Print"],
Cell[1303845, 32899, 265, 5, 22, "Print"],
Cell[1304113, 32906, 102, 2, 22, "Print"],
Cell[1304218, 32910, 163, 3, 22, "Print"],
Cell[1304384, 32915, 45, 1, 22, "Print"],
Cell[1304432, 32918, 764, 17, 22, "Print"],
Cell[1305199, 32937, 432, 10, 24, "Print"],
Cell[1305634, 32949, 45, 1, 22, "Print"],
Cell[1305682, 32952, 1159, 25, 103, "Print"],
Cell[1306844, 32979, 53, 1, 22, "Print"],
Cell[1306900, 32982, 3609, 87, 85, "Print"],
Cell[1310512, 33071, 256, 4, 22, "Print"],
Cell[1310771, 33077, 102, 2, 22, "Print"],
Cell[1310876, 33081, 163, 3, 22, "Print"],
Cell[1311042, 33086, 45, 1, 22, "Print"],
Cell[1311090, 33089, 764, 17, 22, "Print"],
Cell[1311857, 33108, 434, 10, 24, "Print"],
Cell[1312294, 33120, 45, 1, 22, "Print"],
Cell[1312342, 33123, 1152, 25, 101, "Print"],
Cell[1313497, 33150, 53, 1, 22, "Print"],
Cell[1313553, 33153, 3611, 87, 85, "Print"],
Cell[1317167, 33242, 264, 5, 22, "Print"],
Cell[1317434, 33249, 102, 2, 22, "Print"],
Cell[1317539, 33253, 163, 3, 22, "Print"],
Cell[1317705, 33258, 45, 1, 22, "Print"],
Cell[1317753, 33261, 764, 17, 22, "Print"],
Cell[1318520, 33280, 434, 10, 24, "Print"],
Cell[1318957, 33292, 45, 1, 22, "Print"],
Cell[1319005, 33295, 1145, 25, 101, "Print"],
Cell[1320153, 33322, 53, 1, 22, "Print"],
Cell[1320209, 33325, 3629, 87, 85, "Print"],
Cell[1323841, 33414, 265, 5, 22, "Print"],
Cell[1324109, 33421, 102, 2, 22, "Print"],
Cell[1324214, 33425, 163, 3, 22, "Print"],
Cell[1324380, 33430, 45, 1, 22, "Print"],
Cell[1324428, 33433, 764, 17, 22, "Print"],
Cell[1325195, 33452, 434, 10, 24, "Print"],
Cell[1325632, 33464, 45, 1, 22, "Print"],
Cell[1325680, 33467, 1166, 26, 101, "Print"],
Cell[1326849, 33495, 53, 1, 22, "Print"],
Cell[1326905, 33498, 3650, 87, 85, "Print"],
Cell[1330558, 33587, 272, 5, 24, "Print"],
Cell[1330833, 33594, 102, 2, 22, "Print"],
Cell[1330938, 33598, 163, 3, 22, "Print"],
Cell[1331104, 33603, 45, 1, 22, "Print"],
Cell[1331152, 33606, 764, 17, 22, "Print"],
Cell[1331919, 33625, 434, 10, 24, "Print"],
Cell[1332356, 33637, 45, 1, 22, "Print"],
Cell[1332404, 33640, 1161, 26, 103, "Print"],
Cell[1333568, 33668, 53, 1, 22, "Print"],
Cell[1333624, 33671, 3639, 87, 85, "Print"],
Cell[1337266, 33760, 102, 2, 22, "Print"],
Cell[1337371, 33764, 163, 3, 22, "Print"],
Cell[1337537, 33769, 45, 1, 22, "Print"],
Cell[1337585, 33772, 764, 17, 22, "Print"],
Cell[1338352, 33791, 435, 10, 24, "Print"],
Cell[1338790, 33803, 45, 1, 22, "Print"],
Cell[1338838, 33806, 1153, 26, 115, "Print"],
Cell[1339994, 33834, 53, 1, 22, "Print"],
Cell[1340050, 33837, 3639, 87, 85, "Print"],
Cell[1343692, 33926, 233, 4, 22, "Print"],
Cell[1343928, 33932, 3673, 66, 325, "Print"],
Cell[1347604, 34000, 175, 3, 24, "Print"],
Cell[1347782, 34005, 86, 1, 22, "Print"],
Cell[1347871, 34008, 1122, 22, 99, "Print"],
Cell[1348996, 34032, 91, 1, 22, "Print"],
Cell[1349090, 34035, 80, 1, 22, "Print"],
Cell[1349173, 34038, 91, 1, 22, "Print"],
Cell[1349267, 34041, 1517, 30, 85, "Print"],
Cell[1350787, 34073, 89, 1, 22, "Print"],
Cell[1350879, 34076, 45, 1, 22, "Print"],
Cell[1350927, 34079, 89, 1, 22, "Print"],
Cell[1351019, 34082, 541, 14, 31, "Print"],
Cell[1351563, 34098, 67, 1, 22, "Print"],
Cell[1351633, 34101, 89, 1, 22, "Print"],
Cell[1351725, 34104, 66, 1, 22, "Print"],
Cell[1351794, 34107, 89, 1, 22, "Print"],
Cell[1351886, 34110, 89, 1, 22, "Print"],
Cell[1351978, 34113, 208, 4, 22, "Print"],
Cell[1352189, 34119, 954, 22, 71, "Print"],
Cell[1353146, 34143, 90, 1, 22, "Print"],
Cell[1353239, 34146, 74, 1, 22, "Print"],
Cell[1353316, 34149, 90, 1, 22, "Print"],
Cell[1353409, 34152, 951, 19, 85, "Print"],
Cell[1354363, 34173, 91, 1, 22, "Print"],
Cell[1354457, 34176, 97, 2, 22, "Print"],
Cell[1354557, 34180, 91, 1, 22, "Print"],
Cell[1354651, 34183, 993, 20, 85, "Print"],
Cell[1355647, 34205, 45, 1, 22, "Print"],
Cell[1355695, 34208, 145, 2, 22, "Print"],
Cell[1355843, 34212, 91, 1, 22, "Print"],
Cell[1355937, 34215, 108, 2, 22, "Print"],
Cell[1356048, 34219, 91, 1, 22, "Print"],
Cell[1356142, 34222, 1032, 20, 85, "Print"],
Cell[1357177, 34244, 45, 1, 22, "Print"],
Cell[1357225, 34247, 146, 2, 22, "Print"],
Cell[1357374, 34251, 91, 1, 22, "Print"],
Cell[1357468, 34254, 58, 1, 22, "Print"],
Cell[1357529, 34257, 91, 1, 22, "Print"],
Cell[1357623, 34260, 199, 4, 22, "Print"],
Cell[1357825, 34266, 109, 2, 22, "Print"],
Cell[1357937, 34270, 743, 17, 41, "Print"],
Cell[1358683, 34289, 93, 1, 22, "Print"],
Cell[1358779, 34292, 48, 1, 22, "Print"],
Cell[1358830, 34295, 93, 1, 22, "Print"],
Cell[1358926, 34298, 89, 1, 22, "Print"],
Cell[1359018, 34301, 61, 1, 22, "Print"],
Cell[1359082, 34304, 74, 1, 22, "Print"],
Cell[1359159, 34307, 93, 1, 22, "Print"],
Cell[1359255, 34310, 1087, 24, 37, "Print"],
Cell[1360345, 34336, 93, 1, 22, "Print"],
Cell[1360441, 34339, 865, 21, 37, "Print"],
Cell[1361309, 34362, 93, 1, 22, "Print"],
Cell[1361405, 34365, 1002, 23, 39, "Print"],
Cell[1362410, 34390, 93, 1, 22, "Print"],
Cell[1362506, 34393, 836, 20, 37, "Print"],
Cell[1363345, 34415, 93, 1, 22, "Print"],
Cell[1363441, 34418, 938, 22, 37, "Print"],
Cell[1364382, 34442, 93, 1, 22, "Print"],
Cell[1364478, 34445, 825, 19, 23, "Print"],
Cell[1365306, 34466, 93, 1, 22, "Print"],
Cell[1365402, 34469, 869, 20, 23, "Print"],
Cell[1366274, 34491, 93, 1, 22, "Print"],
Cell[1366370, 34494, 872, 20, 23, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[1367279, 34519, 92, 2, 24, "Input"],
Cell[1367374, 34523, 3601, 64, 329, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1371012, 34592, 200, 5, 42, "Input"],
Cell[1371215, 34599, 177, 3, 22, "Print"],
Cell[1371395, 34604, 177, 3, 22, "Print"],
Cell[1371575, 34609, 177, 3, 22, "Print"],
Cell[1371755, 34614, 177, 3, 22, "Print"],
Cell[1371935, 34619, 177, 3, 22, "Print"],
Cell[1372115, 34624, 177, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1372329, 34632, 162, 5, 27, "Input"],
Cell[1372494, 34639, 129303, 4451, 241, 45048, 3405, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1501800, 39092, 135, 3, 26, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

