(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1100893,      27630]*)
(*NotebookOutlinePosition[   1105973,      27785]*)
(*  CellTagsIndexPosition[   1105811,      27777]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Pakete", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
<<code`LSD`
<<code`Kronecker`
<<Feynman.Fokker.impl.m
<<Kuba.Impl.m
<<Kalman.exakt.impl.m\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(Clear::"wrsym" \(\(:\)\(\ \)\) 
      "Symbol \!\(RandomMultinomial\) is Protected."\)], "Message"],

Cell[BoxData[
    \(SetDelayed::"write" \(\(:\)\(\ \)\) 
      "Tag \!\(RandomMultinomial\) in \!\(RandomMultinomial[\(\(xij_, pij_, \
n_\)\)]\) is Protected."\)], "Message"],

Cell[BoxData[
    \(Clear::"wrsym" \(\(:\)\(\ \)\) 
      "Symbol \!\(RandomNumbers\) is Protected."\)], "Message"],

Cell[BoxData[
    \(SetDelayed::"write" \(\(:\)\(\ \)\) 
      "Tag \!\(RandomNumbers\) in \!\(RandomNumbers[\(\(\(\({x1_, x2_, dx_}\)\
\), density_, n_\)\)]\) is Protected."\)], "Message"]
}, Open  ]],

Cell["SetOptions[plot1,dicke->.01];", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Model", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["system functions", "Subsubsection"],

Cell[BoxData[
    \(\(\(Clear[f, g, Omega, v, h, R, mue, sigma, Theta, S];\)\(\n\)
    \)\)], "Input"],

Cell["phi4[{S_},t_,{a_,b_,sigma_}]:= a/2 S^2 + b/4 S^4;", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\

Grad[pot_,var_] := Map[D[pot,#]&,var]
f[{S_},t_,Theta_]  = -Grad[ phi4[{S},t,{Theta[[1]],Theta[[2]]//Abs,_}],{S}]\t\
\t\t\t\t\t\t         
g[{S_},t_,Theta_] := {{Theta[[3]]}}
Omega[{S_},t_,Theta_] := g[{S},t,Theta]^2

h[{S_},t_,Theta_] := {S}
R[{S_},t_,Theta_] := {{Theta[[4]]//Abs}}+10^-4;
mue[t_,Theta_] := {0}
sigma[t_,Theta_] := {{10}}\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Grad\)\" is similar to \
existing symbols \!\({Gray, Grid}\)."\)], "Message"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 1 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 2 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 1 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \(\(:\)\(\ \)\) 
      "Further output of \!\(Part :: \"partd\"\) will be suppressed during \
this calculation."\)], "Message"],

Cell[BoxData[
    \({\(-S\^3\)\ Abs[Theta\[LeftDoubleBracket]2\[RightDoubleBracket]] - 
        S\ Theta\[LeftDoubleBracket]1\[RightDoubleBracket]}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[
      Table[phi4[{S}, _, {a,  .1, _}], {a, 0, \(-5\), \(-1\)}] // 
        Evaluate, {S, \(-10\), 10}, PlotLabel -> "\<Potential\>"]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0.132435 0.00188354 [
[.02381 -0.0125 -9 -9 ]
[.02381 -0.0125 9 0 ]
[.2619 -0.0125 -6 -9 ]
[.2619 -0.0125 6 0 ]
[.5 -0.0125 -3 -9 ]
[.5 -0.0125 3 0 ]
[.7381 -0.0125 -3 -9 ]
[.7381 -0.0125 3 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03826 -18 -4.5 ]
[-0.0125 .03826 0 4.5 ]
[-0.0125 .13244 -6 -4.5 ]
[-0.0125 .13244 0 4.5 ]
[-0.0125 .22661 -12 -4.5 ]
[-0.0125 .22661 0 4.5 ]
[-0.0125 .32079 -18 -4.5 ]
[-0.0125 .32079 0 4.5 ]
[-0.0125 .41497 -18 -4.5 ]
[-0.0125 .41497 0 4.5 ]
[-0.0125 .50914 -18 -4.5 ]
[-0.0125 .50914 0 4.5 ]
[-0.0125 .60332 -18 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -29 0 ]
[.5 .63053 29 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(-10)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(-5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(0)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(5)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03826 m
.00625 .03826 L
s
[(-50)] -0.0125 .03826 1 0 Mshowa
0 .13244 m
.00625 .13244 L
s
[(0)] -0.0125 .13244 1 0 Mshowa
0 .22661 m
.00625 .22661 L
s
[(50)] -0.0125 .22661 1 0 Mshowa
0 .32079 m
.00625 .32079 L
s
[(100)] -0.0125 .32079 1 0 Mshowa
0 .41497 m
.00625 .41497 L
s
[(150)] -0.0125 .41497 1 0 Mshowa
0 .50914 m
.00625 .50914 L
s
[(200)] -0.0125 .50914 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(250)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .05709 m
.00375 .05709 L
s
0 .07593 m
.00375 .07593 L
s
0 .09476 m
.00375 .09476 L
s
0 .1136 m
.00375 .1136 L
s
0 .15127 m
.00375 .15127 L
s
0 .17011 m
.00375 .17011 L
s
0 .18894 m
.00375 .18894 L
s
0 .20778 m
.00375 .20778 L
s
0 .24545 m
.00375 .24545 L
s
0 .26428 m
.00375 .26428 L
s
0 .28312 m
.00375 .28312 L
s
0 .30195 m
.00375 .30195 L
s
0 .33962 m
.00375 .33962 L
s
0 .35846 m
.00375 .35846 L
s
0 .37729 m
.00375 .37729 L
s
0 .39613 m
.00375 .39613 L
s
0 .4338 m
.00375 .4338 L
s
0 .45264 m
.00375 .45264 L
s
0 .47147 m
.00375 .47147 L
s
0 .49031 m
.00375 .49031 L
s
0 .52798 m
.00375 .52798 L
s
0 .54681 m
.00375 .54681 L
s
0 .56565 m
.00375 .56565 L
s
0 .58448 m
.00375 .58448 L
s
0 .01942 m
.00375 .01942 L
s
0 .00059 m
.00375 .00059 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03826 m
1 .03826 L
s
.99375 .13244 m
1 .13244 L
s
.99375 .22661 m
1 .22661 L
s
.99375 .32079 m
1 .32079 L
s
.99375 .41497 m
1 .41497 L
s
.99375 .50914 m
1 .50914 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .05709 m
1 .05709 L
s
.99625 .07593 m
1 .07593 L
s
.99625 .09476 m
1 .09476 L
s
.99625 .1136 m
1 .1136 L
s
.99625 .15127 m
1 .15127 L
s
.99625 .17011 m
1 .17011 L
s
.99625 .18894 m
1 .18894 L
s
.99625 .20778 m
1 .20778 L
s
.99625 .24545 m
1 .24545 L
s
.99625 .26428 m
1 .26428 L
s
.99625 .28312 m
1 .28312 L
s
.99625 .30195 m
1 .30195 L
s
.99625 .33962 m
1 .33962 L
s
.99625 .35846 m
1 .35846 L
s
.99625 .37729 m
1 .37729 L
s
.99625 .39613 m
1 .39613 L
s
.99625 .4338 m
1 .4338 L
s
.99625 .45264 m
1 .45264 L
s
.99625 .47147 m
1 .47147 L
s
.99625 .49031 m
1 .49031 L
s
.99625 .52798 m
1 .52798 L
s
.99625 .54681 m
1 .54681 L
s
.99625 .56565 m
1 .56565 L
s
.99625 .58448 m
1 .58448 L
s
.99625 .01942 m
1 .01942 L
s
.99625 .00059 m
1 .00059 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -90 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Potential) show
117.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
1 0 0 r
.007 w
.02381 .60332 m
.06244 .46811 L
.10458 .35632 L
.14415 .27928 L
.18221 .22584 L
.20178 .20487 L
.22272 .18657 L
.24259 .17264 L
.26416 .16077 L
.28492 .15203 L
.30409 .14592 L
.32282 .14146 L
.33359 .13946 L
.34344 .13794 L
.36285 .13568 L
.37356 .13478 L
.38373 .13411 L
.39332 .13362 L
.40354 .13323 L
.41318 .13296 L
.42192 .13278 L
.4268 .1327 L
.43195 .13263 L
.4364 .13259 L
.44117 .13254 L
.4463 .13251 L
.4511 .13249 L
.45402 .13248 L
.45679 .13247 L
.45947 .13246 L
.46199 .13245 L
.46658 .13245 L
.46902 .13244 L
.47164 .13244 L
.47425 .13244 L
.47699 .13244 L
.47934 .13244 L
.48066 .13244 L
.4819 .13244 L
.48305 .13244 L
.4843 .13244 L
.4854 .13244 L
.48657 .13244 L
.48762 .13244 L
.48877 .13244 L
.48982 .13244 L
.49081 .13244 L
.49203 .13244 L
.4932 .13244 L
.49425 .13244 L
Mistroke
.49539 .13244 L
.49663 .13244 L
.49795 .13244 L
.49919 .13244 L
.50032 .13244 L
.50153 .13244 L
.50265 .13244 L
.50389 .13244 L
.50521 .13244 L
.50588 .13244 L
.5066 .13244 L
.50791 .13244 L
.50919 .13244 L
.51037 .13244 L
.51147 .13244 L
.5125 .13244 L
.51363 .13244 L
.51485 .13244 L
.51606 .13244 L
.51733 .13244 L
.5196 .13244 L
.52091 .13244 L
.5221 .13244 L
.52477 .13244 L
.52723 .13244 L
.52956 .13244 L
.53228 .13245 L
.53478 .13245 L
.53774 .13245 L
.54044 .13246 L
.54513 .13247 L
.55016 .13249 L
.55482 .13252 L
.55924 .13255 L
.56437 .13259 L
.56913 .13264 L
.57431 .13271 L
.57989 .13281 L
.5895 .13302 L
.59853 .1333 L
.60927 .13374 L
.61913 .13428 L
.62891 .13496 L
.63803 .13576 L
.64867 .13691 L
.65872 .13825 L
.67915 .14187 L
.69773 .14643 L
.71772 .15301 L
.73617 .16092 L
Mistroke
.75491 .1711 L
.77554 .18522 L
.79659 .2033 L
.81584 .22357 L
.85464 .27729 L
.89436 .35394 L
.93258 .4531 L
.97324 .59177 L
.97619 .60332 L
Mfstroke
1 .6 0 r
.02381 .50914 m
.06244 .3886 L
.10458 .29138 L
.12507 .25502 L
.14415 .22669 L
.18221 .18389 L
.20262 .16732 L
.2212 .15548 L
.24035 .14606 L
.25024 .14216 L
.26113 .13855 L
.28097 .13359 L
.29183 .13164 L
.302 .13023 L
.30696 .12968 L
.31238 .12916 L
.31715 .12879 L
.32224 .12846 L
.32728 .1282 L
.33185 .12801 L
.33406 .12794 L
.33644 .12788 L
.33871 .12783 L
.34077 .12779 L
.34314 .12776 L
.34445 .12775 L
.34569 .12774 L
.34683 .12773 L
.34788 .12773 L
.34904 .12773 L
.35027 .12773 L
.35151 .12773 L
.3522 .12773 L
.35283 .12774 L
.354 .12774 L
.35523 .12775 L
.35785 .12778 L
.36071 .12782 L
.36598 .12793 L
.37162 .12808 L
.38177 .12842 L
.42327 .13031 L
.44407 .13123 L
.45321 .13157 L
.46325 .13189 L
.47291 .13214 L
.47754 .13223 L
.48194 .1323 L
.48432 .13233 L
.48692 .13236 L
Mistroke
.48931 .13239 L
.49147 .13241 L
.49405 .13242 L
.49546 .13243 L
.49611 .13243 L
.49679 .13243 L
.49802 .13243 L
.49916 .13243 L
.50038 .13244 L
.50107 .13243 L
.50172 .13243 L
.50299 .13243 L
.50362 .13243 L
.50433 .13243 L
.50674 .13242 L
.5081 .13241 L
.50956 .1324 L
.5122 .13237 L
.51737 .13231 L
.52211 .13223 L
.53116 .13204 L
.54068 .13177 L
.56046 .13104 L
.57884 .13021 L
.59761 .12931 L
.61794 .12843 L
.62335 .12824 L
.62907 .12806 L
.63437 .12792 L
.63696 .12787 L
.63932 .12782 L
.64154 .12779 L
.64396 .12776 L
.64528 .12775 L
.64651 .12774 L
.64768 .12773 L
.64893 .12773 L
.65018 .12773 L
.65088 .12773 L
.65152 .12773 L
.6527 .12773 L
.65395 .12774 L
.65461 .12774 L
.65532 .12775 L
.65659 .12776 L
.65949 .1278 L
.66207 .12784 L
.66481 .12791 L
.66971 .12807 L
.67499 .1283 L
Mistroke
.68081 .12865 L
.69121 .12949 L
.70095 .1306 L
.71134 .13215 L
.72122 .13404 L
.73974 .13882 L
.75957 .14602 L
.77796 .15501 L
.79849 .16813 L
.81711 .18327 L
.83799 .2045 L
.85719 .22852 L
.89576 .29205 L
.93527 .38247 L
.97326 .49882 L
.97619 .50914 L
Mfstroke
.8 1 0 r
.02381 .41497 m
.06244 .30908 L
.08255 .26578 L
.10458 .22644 L
.14415 .1741 L
.16372 .15561 L
.18466 .14039 L
.19488 .13448 L
.20597 .12907 L
.21555 .12518 L
.22611 .12166 L
.23566 .11911 L
.24594 .11697 L
.25161 .11605 L
.2568 .11534 L
.26172 .11479 L
.26697 .11433 L
.26963 .11415 L
.27214 .114 L
.27457 .11387 L
.27682 .11378 L
.27895 .11371 L
.28121 .11366 L
.28238 .11364 L
.28347 .11362 L
.28467 .11361 L
.28596 .1136 L
.28663 .1136 L
.28734 .1136 L
.28862 .1136 L
.28934 .11361 L
.29 .11361 L
.29152 .11363 L
.29285 .11365 L
.29406 .11368 L
.2968 .11375 L
.30161 .11393 L
.30668 .11418 L
.31623 .11483 L
.32642 .11572 L
.34479 .11774 L
.38629 .12323 L
.40709 .12595 L
.42627 .12819 L
.44614 .1301 L
.46474 .13142 L
.47378 .13187 L
.47886 .13207 L
.4835 .13221 L
.48856 .13233 L
Mistroke
.49143 .13237 L
.4928 .13239 L
.49409 .13241 L
.49532 .13242 L
.49596 .13242 L
.49664 .13243 L
.49785 .13243 L
.49896 .13243 L
.50024 .13244 L
.50143 .13243 L
.50274 .13243 L
.50347 .13243 L
.50414 .13242 L
.50643 .1324 L
.50774 .13239 L
.50896 .13237 L
.51408 .13227 L
.5185 .13215 L
.52326 .13199 L
.53411 .13148 L
.54404 .13086 L
.563 .12928 L
.58371 .12706 L
.62433 .12178 L
.66342 .11678 L
.67369 .11571 L
.68481 .11475 L
.68991 .11439 L
.69531 .11408 L
.69991 .11387 L
.70254 .11377 L
.70497 .1137 L
.70748 .11365 L
.7088 .11363 L
.70947 .11362 L
.7102 .11361 L
.71142 .1136 L
.71256 .1136 L
.71322 .1136 L
.71392 .1136 L
.71516 .11361 L
.71627 .11362 L
.71746 .11363 L
.71858 .11365 L
.7196 .11368 L
.7221 .11374 L
.72446 .11383 L
.72967 .1141 L
.73449 .11445 L
.73977 .11495 L
Mistroke
.74537 .11562 L
.75479 .11711 L
.76491 .11925 L
.78322 .12473 L
.79333 .12877 L
.80437 .13408 L
.82446 .14649 L
.84415 .16252 L
.86513 .18447 L
.88512 .21069 L
.90673 .24565 L
.94682 .33162 L
.97619 .41497 L
Mfstroke
.2 1 0 r
.02381 .32079 m
.04262 .27257 L
.06244 .22957 L
.08426 .19066 L
.10458 .16151 L
.12414 .13918 L
.14264 .12267 L
.16305 .10902 L
.18163 .10023 L
.19132 .09686 L
.2016 .0941 L
.21038 .09236 L
.21537 .0916 L
.22004 .09104 L
.22501 .09058 L
.22782 .09039 L
.23042 .09025 L
.23171 .0902 L
.23293 .09016 L
.23403 .09012 L
.2352 .0901 L
.23647 .09007 L
.23764 .09006 L
.23891 .09006 L
.23962 .09006 L
.24029 .09006 L
.24144 .09007 L
.24269 .09009 L
.24387 .09011 L
.24497 .09014 L
.24703 .0902 L
.24923 .0903 L
.25379 .09056 L
.25881 .09095 L
.26891 .09201 L
.27816 .0933 L
.29902 .09705 L
.33864 .1062 L
.37675 .11562 L
.398 .12046 L
.41731 .12434 L
.43763 .12773 L
.45636 .1301 L
.46568 .13098 L
.47554 .13169 L
.48066 .13197 L
.48545 .13217 L
.48814 .13226 L
.4907 .13233 L
.49211 .13236 L
Mistroke
.49365 .13238 L
.49504 .1324 L
.49634 .13242 L
.49763 .13243 L
.49828 .13243 L
.49899 .13243 L
.50026 .13244 L
.50143 .13243 L
.50215 .13243 L
.50282 .13243 L
.50409 .13241 L
.50545 .1324 L
.50693 .13238 L
.50945 .13232 L
.51211 .13225 L
.5169 .13208 L
.52147 .13186 L
.52576 .13161 L
.53552 .13088 L
.54538 .12991 L
.55574 .12865 L
.57426 .12584 L
.61242 .11815 L
.65303 .10828 L
.69213 .09892 L
.71208 .09492 L
.72258 .09318 L
.73368 .0917 L
.73847 .0912 L
.74361 .09075 L
.74656 .09053 L
.74925 .09037 L
.75199 .09024 L
.75319 .0902 L
.75452 .09015 L
.75562 .09012 L
.75681 .0901 L
.75806 .09007 L
.75924 .09006 L
.76054 .09006 L
.7612 .09006 L
.76192 .09006 L
.76319 .09007 L
.76438 .09009 L
.76559 .09011 L
.76674 .09014 L
.76889 .09022 L
.7712 .09034 L
.77372 .09049 L
.7786 .0909 L
Mistroke
.78316 .09141 L
.78818 .09212 L
.79357 .09307 L
.80455 .09565 L
.8146 .09883 L
.8336 .1072 L
.84435 .11346 L
.85433 .12036 L
.87487 .13819 L
.89348 .15905 L
.91436 .18848 L
.93357 .22182 L
.97214 .30975 L
.97619 .32079 L
Mfstroke
0 1 .4 r
.02381 .22661 m
.04262 .18568 L
.06244 .15005 L
.08426 .11888 L
.10458 .09657 L
.12297 .08134 L
.14264 .06963 L
.15285 .06523 L
.15823 .06333 L
.16394 .06162 L
.16892 .06037 L
.17441 .05924 L
.17941 .05843 L
.18408 .05785 L
.18666 .05761 L
.18904 .05742 L
.19167 .05727 L
.19313 .0572 L
.19446 .05716 L
.19573 .05713 L
.1969 .05711 L
.19819 .0571 L
.19883 .05709 L
.19954 .0571 L
.20074 .05711 L
.20202 .05713 L
.20323 .05716 L
.20433 .05719 L
.2067 .05729 L
.20889 .05742 L
.21384 .05781 L
.21821 .05826 L
.22285 .05886 L
.23222 .0604 L
.24232 .0625 L
.2606 .06731 L
.30174 .08129 L
.34137 .09643 L
.37948 .11024 L
.40073 .11695 L
.42004 .12219 L
.44035 .12664 L
.45908 .12968 L
.4684 .13079 L
.47827 .13165 L
.48338 .13198 L
.48817 .1322 L
.49092 .1323 L
.49342 .13236 L
.49481 .13239 L
Mistroke
.49554 .1324 L
.49632 .13241 L
.49707 .13242 L
.49774 .13243 L
.49906 .13243 L
.50027 .13244 L
.5014 .13243 L
.50263 .13242 L
.50396 .13241 L
.50534 .13239 L
.50666 .13236 L
.50912 .1323 L
.51142 .13222 L
.51354 .13213 L
.51835 .13188 L
.52316 .13155 L
.52846 .1311 L
.53918 .12991 L
.5493 .12845 L
.55857 .12684 L
.57944 .12232 L
.61912 .11071 L
.65728 .09695 L
.69789 .08142 L
.73699 .06802 L
.74726 .0651 L
.75837 .06235 L
.76798 .06036 L
.77307 .05948 L
.77854 .05867 L
.78392 .05803 L
.78883 .05758 L
.7912 .05741 L
.79377 .05727 L
.79495 .05722 L
.7962 .05717 L
.79727 .05714 L
.79845 .05712 L
.79908 .05711 L
.79978 .0571 L
.8005 .0571 L
.80117 .05709 L
.80238 .0571 L
.80367 .05711 L
.8044 .05713 L
.80519 .05715 L
.80662 .05719 L
.80802 .05725 L
.80931 .05732 L
.81166 .05747 L
Mistroke
.81426 .05769 L
.81951 .05828 L
.82471 .05908 L
.82965 .06005 L
.83893 .06244 L
.84892 .06592 L
.85981 .07085 L
.8795 .08313 L
.90048 .10156 L
.92191 .12689 L
.94208 .15755 L
.97619 .22661 L
Mfstroke
0 1 1 r
.02381 .13244 m
.04262 .0988 L
.06244 .07054 L
.08255 .04866 L
.09409 .0389 L
.10458 .03163 L
.11396 .02635 L
.12415 .02183 L
.12975 .01986 L
.13491 .01834 L
.13982 .01716 L
.14509 .01616 L
.14768 .01577 L
.15014 .01546 L
.15253 .01521 L
.15476 .01502 L
.15685 .01489 L
.15802 .01483 L
.15909 .01479 L
.16026 .01475 L
.16152 .01473 L
.16272 .01472 L
.16381 .01472 L
.16501 .01473 L
.16629 .01475 L
.16749 .01479 L
.1686 .01483 L
.17129 .01497 L
.17384 .01516 L
.17892 .01568 L
.18444 .01646 L
.19384 .01825 L
.20421 .02085 L
.22522 .02785 L
.26542 .0459 L
.30411 .06624 L
.34525 .08796 L
.38488 .10652 L
.42298 .12044 L
.4426 .12569 L
.4535 .12799 L
.46355 .12969 L
.47379 .13101 L
.47918 .13154 L
.48489 .13196 L
.48728 .1321 L
.48985 .13222 L
.49227 .13231 L
.49449 .13237 L
.49583 .1324 L
Mistroke
.49708 .13242 L
.4978 .13243 L
.49845 .13243 L
.4992 .13243 L
.4999 .13244 L
.50119 .13243 L
.50237 .13242 L
.50367 .13241 L
.50433 .1324 L
.50504 .13238 L
.50756 .13232 L
.5103 .13221 L
.51289 .13209 L
.51527 .13195 L
.52459 .13118 L
.52942 .13064 L
.53475 .12994 L
.54552 .12817 L
.56491 .12385 L
.58578 .11765 L
.62697 .10134 L
.66664 .08183 L
.7048 .06144 L
.74542 .04058 L
.76419 .03211 L
.78451 .02435 L
.79565 .02089 L
.8059 .01831 L
.8157 .01644 L
.82064 .01574 L
.82324 .01544 L
.82606 .01517 L
.82878 .01497 L
.82997 .0149 L
.83129 .01483 L
.83253 .01479 L
.8337 .01475 L
.83493 .01473 L
.83562 .01472 L
.83625 .01472 L
.83737 .01472 L
.83841 .01473 L
.83956 .01475 L
.84078 .01478 L
.84207 .01483 L
.84328 .0149 L
.84555 .01505 L
.84808 .01527 L
.85077 .01557 L
.85558 .01628 L
Mistroke
.86076 .01729 L
.86646 .01872 L
.8766 .02213 L
.88588 .02627 L
.89659 .03237 L
.90676 .03955 L
.92658 .05781 L
.94498 .0803 L
.97619 .13244 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00903oool3000000@0oooo0P00000d0?ooo`<00000=03oool2000003L0oooo0`00000d0?oo
o`<00000103oool2000000l0oooo000U0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3o
ool00000<P3oool01@000000oooo0?ooo`3oool000000380oooo00@000000?ooo`3oool00000=@3o
ool01@000000oooo0?ooo`3oool0000003@0oooo00<000000?ooo`3oool00P3oool010000000oooo
0?ooo`00000>0?ooo`007@3oool5000000<0oooo00<000000?ooo`3oool00P3oool010000000oooo
0?ooo`00000/0?ooo`D000001@3oool00`000000oooo0?ooo`0`0?ooo`040000003oool0oooo0000
03T0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo
000000h0oooo000U0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000=P3oool0
0`000000oooo0?ooo`0`0?ooo`040000003oool0oooo000003T0oooo00<000000?ooo`3oool0<P3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000h0oooo000U0?ooo`030000003o
ool0oooo0080oooo00@000000?ooo`3oool00000<P3oool4000003<0oooo00@000000?ooo`3oool0
0000=@3oool4000003D0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00000>0?oo
o`00903oool2000000@0oooo00@000000?ooo`3oool00000<P3oool00`000000oooo0?ooo`0d0?oo
o`040000003oool0oooo000003D0oooo00<000000?ooo`3oool0=@3oool2000000@0oooo00@00000
0?ooo`3oool000003P3oool002D0oooo00<000000?ooo`3oool00`3oool2000003<0oooo1@00000c
0?ooo`800000=P3oool5000003@0oooo00<000000?ooo`3oool00`3oool2000000l0oooo003o0?oo
ob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo000P0?oooo@00000303oool0
0200oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000
oooo0?ooo`3`0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo0240oooo
2@00oonJ0?ooo`T00?oo8`3oool00`000000oooo0?ooo`0:0?ooo`00803oool2000001d0oooo1@00
ool90?ooo`D00?ooT@3oool4003oo`T0oooo1@00oolM0?ooo`800000303oool00200oooo00<00000
0?ooo`3oool06P3oool2003ooa<0oooo1000oon70?ooo`H00?oo4P3oool2003ooa`0oooo00<00000
0?ooo`3oool02P3oool00180oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`0H0?oo
o`800?oo6@3oool3003ooh40oooo0`00oolJ0?ooo`<00?oo6@3oool00`000000oooo0?ooo`0:0?oo
o`004@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000103oool0
0`000000oooo0?ooo`0F0?ooo`800?oo7P3oool2003oogd0oooo0P00oolP0?ooo`03003oo`3oool0
oooo01H0oooo00<000000?ooo`3oool02P3oool000/0oooo1@0000050?ooo`040000003oool0oooo
00000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0E0?ooo`03003oo`3oool0
oooo0200oooo0P00oomi0?ooo`800?oo8`3oool00`00ool0oooo0?ooo`0E0?ooo`030000003oool0
oooo00X0oooo000E0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool3
000001<0oooo0P00oolU0?ooo`800?ooM@3oool2003oobH0oooo00<00?oo0?ooo`3oool04P3oool3
000000`0oooo000A0?ooo`@000000`3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo0180oooo00<00?oo0?ooo`3oool09`3oool2003oog40oooo0P00oolY0?ooo`03003oo`3oool0
oooo01<0oooo00<000000?ooo`3oool02P3oool00140oooo00<000000?ooo`3oool0103oool01000
0000oooo0?ooo`0000040?ooo`030000003oool0oooo0140oooo00<00?oo0?ooo`3oool0:P3oool2
003oofd0oooo0P00ool/0?ooo`03003oo`3oool0oooo0180oooo00<000000?ooo`3oool02P3oool0
0140oooo1@0000030?ooo`8000001@3oool00`000000oooo0?ooo`0A0?ooo`03003oo`3oool0oooo
02`0oooo0P00oomY0?ooo`800?oo;`3oool00`00ool0oooo0?ooo`0A0?ooo`030000003oool0oooo
00X0oooo000P0?ooo`8000004@3oool00`00ool0oooo0?ooo`0I0?ooo`@00?mV4P3oool2003oofD0
oooo0P00oolC0?ooo`@00?mV6`3oool00`00ool0oooo0?ooo`0?0?ooo`800000303oool00200oooo
00<000000?ooo`3oool03`3oool00`00ool0oooo0?ooo`0D0?ooo`H00?mV103oool8003oIP`0oooo
00<00?oo0?ooo`3oool0H03oool2003oo`d0oooo2000ofH40?ooo`L00?mV5@3oool00`00ool0oooo
0?ooo`0?0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00h0oooo00<0
0?oo0?ooo`3oool0403oool5003oIQ80oooo0`00ofH:0?ooo`800?ooGP3oool2003oo`X0oooo1@00
ofHC0?ooo`800?mV4`3oool00`00ool0oooo0?ooo`0?0?ooo`030000003oool0oooo00X0oooo000P
0?ooo`030000003oool0oooo00d0oooo00<00?oo0?ooo`3oool03`3oool2003oIQX0oooo1000ofH8
0?ooo`800?ooFP3oool2003oo`T0oooo0`00ofHJ0?ooo`<00?mV4@3oool00`00ool0oooo0?ooo`0>
0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00`0oooo00<00?oo0?oo
o`3oool03P3oool2003oIR00oooo0`00ofH70?ooo`800?ooE`3oool00`00ool0oooo0?ooo`060?oo
o`<00?mV803oool2003oIQ00oooo00<00?oo0?ooo`3oool03@3oool00`000000oooo0?ooo`0:0?oo
o`00803oool2000000d0oooo00<00?oo0?ooo`3oool03@3oool00`00ofH0oooo0?ooo`0S0?ooo`<0
0?mV1P3oool2003ooe<0oooo0P00ool60?ooo`<00?mV9@3oool00`00ofH0oooo0?ooo`0>0?ooo`03
003oo`3oool0oooo00/0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`0;0?ooo`03003o
o`3oool0oooo00d0oooo00<00?mV0?ooo`3oool09`3oool3003oIPD0oooo0P00oom?0?ooo`800?oo
1@3oool3003oIRT0oooo00<00?mV0?ooo`3oool03P3oool00`00ool0oooo0?ooo`0;0?ooo`030000
003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00X0oooo00<00?oo0?ooo`3oool03@3o
ool00`00ofH0oooo0?ooo`0[0?ooo`<00?mV103oool2003ood/0oooo0P00ool50?ooo`800?mV;@3o
ool2003oIPh0oooo00<00?oo0?ooo`3oool02`3oool00`000000oooo0?ooo`0:0?ooo`00803oool0
0`000000oooo0?ooo`090?ooo`03003oo`3oool0oooo00d0oooo00<00?mV0?ooo`3oool06@3oool6
03?o0100oooo0P00ofH40?ooo`800?ooA`3oool2003oo`@0oooo0`00ofHA0?ooo`D0<ol06`3oool0
0`00ofH0oooo0?ooo`0<0?ooo`03003oo`3oool0oooo00X0oooo00<000000?ooo`3oool02P3oool0
0200oooo00<000000?ooo`3oool02@3oool00`00ool0oooo0?ooo`0<0?ooo`03003oIP3oool0oooo
0180oooo200co`060?ooo`X0<ol0203oool3003oIP<0oooo0P00oom30?ooo`800?oo103oool2003o
IP/0oooo2@0co`040?ooo`P0<ol05@3oool2003oIPd0oooo00<00?oo0?ooo`3oool02@3oool00`00
0000oooo0?ooo`0:0?ooo`00803oool2000000T0oooo00<00?oo0?ooo`3oool0303oool00`00ofH0
oooo0?ooo`0A0?ooo`80<ol0603oool403?o00L0oooo0`00ofH20?ooo`<00?oo?P3oool2003oo`<0
oooo0`00ofH:0?ooo`<0<ol05@3oool303?o01@0oooo00<00?mV0?ooo`3oool02P3oool00`00ool0
oooo0?ooo`080?ooo`800000303oool00200oooo00<000000?ooo`3oool01`3oool00`00ool0oooo
0?ooo`0<0?ooo`03003oIP3oool0oooo00l0oooo0`0co`0N0?ooo`D0<ol01@3oool3003oIP80oooo
0P00oolj0?ooo`800?oo0P3oool3003oIPP0oooo1@0co`0K0?ooo`80<ol04`3oool00`00ofH0oooo
0?ooo`0:0?ooo`03003oo`3oool0oooo00P0oooo00<000000?ooo`3oool02P3oool00200oooo00<0
00000?ooo`3oool01`3oool00`00ool0oooo0?ooo`0;0?ooo`03003oIP3oool0oooo00h0oooo0P0c
o`0V0?ooo`@0<ol0103oool3003oIP030?ooo`00ool00?oo03D0oooo0`00ool0103oool00?mV003o
IP00ofH60?ooo`D0<ol08P3oool203?o0140oooo00<00?mV0?ooo`3oool02P3oool00`00ool0oooo
0?ooo`080?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00H0oooo00<0
0?oo0?ooo`3oool02`3oool00`00ofH0oooo0?ooo`0=0?ooo`80<ol0;03oool303?o00@0oooo0P00
ofH0103oool00?oo003oo`00ool`0?ooo`800?oo00@0oooo003oIP00ofH00?mV1@3oool403?o02T0
oooo0`0co`0?0?ooo`03003oIP3oool0oooo00X0oooo00<00?oo0?ooo`3oool01`3oool00`000000
oooo0?ooo`0:0?ooo`00803oool2000000L0oooo00<00?oo0?ooo`3oool02P3oool00`00ofH0oooo
0?ooo`0<0?ooo`80<ol0603oool@0<co00T0oooo0`0co`030?ooo`<00?mV00<0oooo003oo`00ool0
:`3oool3003oo`<00?mV0`3oool503?o00P0oooo403<o`0H0?ooo`0303?o003oool0oooo00d0oooo
00<00?mV0?ooo`3oool02P3oool00`00ool0oooo0?ooo`050?ooo`800000303oool00200oooo00<0
00000?ooo`3oool01@3oool00`00ool0oooo0?ooo`0:0?ooo`03003oIP3oool0oooo00`0oooo00<0
<ol00?ooo`3oool04@3oool70<co0100oooo2`3<o`000`3oool0<ol003?o000303?o00040?ooo`00
ofH00?mV003oIP<00?oo9P3oool2003oo`<00?mV00<0oooo03?o000co`000`0co`050?ooo`P0c?l0
403oool50<co01@0oooo00<0<ol00?ooo`3oool03@3oool00`00ofH0oooo0?ooo`090?ooo`03003o
o`3oool0oooo00H0oooo00<000000?ooo`3oool02P3oool001T0oooo0P0000050?ooo`030000003o
ool0oooo00D0oooo00<00?oo0?ooo`3oool02P3oool00`00ofH0oooo0?ooo`0:0?ooo`80<ol04P3o
ool20<co0280oooo1P3<o`0403?o00030?ooo`00ofH00?mV00<00?oo803oool3003oo`800?mV100c
o`0:0<co01d0oooo0`3<o`0B0?ooo`80<ol03P3oool00`00ofH0oooo0?ooo`090?ooo`03003oo`3o
ool0oooo00D0oooo00<000000?ooo`3oool02P3oool001P0oooo00@000000?ooo`3oool00000103o
ool00`000000oooo0?ooo`040?ooo`03003oo`3oool0oooo00X0oooo00<00?mV0?ooo`3oool02P3o
ool00`0co`00oooo0?ooo`0?0?ooo`<0c?l0;03oool20<co00D0<ol000<0oooo003oo`00ool00P00
oolI0?ooo`<00?oo00@00?mV03?o000co`00<ol01@3<o`0Z0?ooo`@0c?l0403oool00`0co`00oooo
0?ooo`0<0?ooo`03003oIP3oool0oooo00P0oooo00<00?oo0?ooo`3oool01@3oool00`000000oooo
0?ooo`0:0?ooo`00603oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00@0oooo
00<00?oo0?ooo`3oool02@3oool00`00ofH0oooo0?ooo`0:0?ooo`0303?o003oool0oooo00h0oooo
0P3<o`0E0?oooal0oiT00P3<o`0503?o00P00?oo203oool9003oo`80<ol00`3<o`0Q0?nI01@0oooo
0P3<o`0?0?ooo`0303?o003oool0oooo00/0oooo00<00?mV0?ooo`3oool02@3oool00`00ool0oooo
0?ooo`040?ooo`030000003oool0oooo00X0oooo000H0?ooo`040000003oool0oooo000000@0oooo
0`0000030?ooo`03003oo`3oool0oooo00T0oooo00<00?mV0?ooo`3oool02P3oool00`0co`00oooo
0?ooo`0=0?ooo`80c?l04@3oool60?nI00h0oooo6P3o00030?nI000303?o0000ofH00?mV00P00?oo
00<00?mV03?o000co`001@3oV@0E0?l00180oooo1P3oV@0@0?ooo`80c?l03P3oool00`0co`00oooo
0?ooo`0;0?ooo`03003oIP3oool0oooo00T0oooo00@00?oo0?ooo`3oool0oooo0`00000<0?ooo`00
603oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00l0oooo00<00?mV0?ooo`3o
ool02@3oool00`0co`00oooo0?ooo`0=0?ooo`030<co003oool0oooo00d0oooo103oV@0>0?ooo`H0
o`00A@3oool90?l000l0oooo0`3oV@0?0?ooo`80c?l03@3oool00`0co`00oooo0?ooo`0;0?ooo`03
003oIP3oool0oooo00h0oooo00<000000?ooo`3oool02P3oool001P0oooo00@000000?ooo`3oool0
0000103oool00`000000oooo0?ooo`0>0?ooo`03003oIP3oool0oooo00X0oooo00<0<ol00?ooo`3o
ool02`3oool20<co00h0oooo0P3oV@0>0?ooo`@0o`00E03oool40?l000h0oooo0P3oV@0?0?ooo`03
0<co003oool0oooo00/0oooo00<0<ol00?ooo`3oool02P3oool00`00ofH0oooo0?ooo`0>0?ooo`03
0000003oool0oooo00X0oooo000I0?ooo`8000001@3oool00`000000oooo0?ooo`0=0?ooo`03003o
IP3oool0oooo00X0oooo00<0<ol00?ooo`3oool02P3oool20<co00d0oooo0`3oV@0<0?ooo`@0o`00
G03oool30?l000d0oooo0P3oV@0>0?ooo`80c?l0303oool00`0co`00oooo0?ooo`0:0?ooo`03003o
IP3oool0oooo00d0oooo00<000000?ooo`3oool02P3oool00200oooo0P00000=0?ooo`03003oIP3o
ool0oooo00X0oooo00<0<ol00?ooo`3oool02P3oool00`3<o`00oooo0?ooo`0;0?ooo`80oiT02`3o
ool40?l006<0oooo0`3o000<0?ooo`<0oiT03@3oool00`3<o`00oooo0?ooo`0:0?ooo`0303?o003o
ool0oooo00T0oooo00<00?mV0?ooo`3oool0303oool2000000`0oooo000P0?ooo`030000003oool0
oooo00`0oooo00<00?mV0?ooo`3oool02P3oool00`0co`00oooo0?ooo`090?ooo`030<co003oool0
oooo00X0oooo0P3oV@0;0?ooo`80o`00JP3oool20?l000d0oooo0P3oV@0<0?ooo`030<co003oool0
oooo00X0oooo00<0<ol00?ooo`3oool02@3oool00`00ofH0oooo0?ooo`0<0?ooo`030000003oool0
oooo00X0oooo000P0?ooo`030000003oool0oooo00/0oooo00<00?mV0?ooo`3oool02P3oool00`0c
o`00oooo0?ooo`090?ooo`030<co003oool0oooo00T0oooo0P3oV@0<0?ooo`030?l0003oool0oooo
06`0oooo0`3o000<0?ooo`80oiT02`3oool00`3<o`00oooo0?ooo`0:0?ooo`0303?o003oool0oooo
00T0oooo00<00?mV0?ooo`3oool02`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000
oooo0?ooo`0;0?ooo`03003oIP3oool0oooo00T0oooo00<0<ol00?ooo`3oool02@3oool00`3<o`00
oooo0?ooo`090?ooo`030?nI003oool0oooo00X0oooo0P3o001b0?ooo`80o`00303oool00`3oV@00
oooo0?ooo`090?ooo`030<co003oool0oooo00T0oooo00<0<ol00?ooo`3oool02@3oool00`00ofH0
oooo0?ooo`0;0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00X0oooo
00<00?mV0?ooo`3oool02P3oool00`0co`00oooo0?ooo`080?ooo`030<co003oool0oooo00P0oooo
0P3oV@0:0?ooo`<0o`00MP3oool20?l000/0oooo00<0oiT00?ooo`3oool02@3oool00`3<o`00oooo
0?ooo`090?ooo`0303?o003oool0oooo00T0oooo00<00?mV0?ooo`3oool02P3oool00`000000oooo
0?ooo`0:0?ooo`00803oool2000000X0oooo00<00?mV0?ooo`3oool02P3oool00`0co`00oooo0?oo
o`080?ooo`030<co003oool0oooo00P0oooo00<0oiT00?ooo`3oool0203oool20?l007/0oooo0P3o
000:0?ooo`030?nI003oool0oooo00T0oooo00<0c?l00?ooo`3oool02@3oool00`0co`00oooo0?oo
o`080?ooo`03003oIP3oool0oooo00T0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`09
0?ooo`03003oIP3oool0oooo00T0oooo00<0<ol00?ooo`3oool0203oool00`3<o`00oooo0?ooo`08
0?ooo`030?nI003oool0oooo00P0oooo00<0o`000?ooo`3oool0O@3oool00`3o0000oooo0?ooo`08
0?ooo`030?nI003oool0oooo00T0oooo00<0c?l00?ooo`3oool02@3oool00`0co`00oooo0?ooo`08
0?ooo`03003oIP3oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?oo
o`3oool0203oool00`00ofH0oooo0?ooo`090?ooo`0303?o003oool0oooo00T0oooo00<0c?l00?oo
o`3oool01`3oool00`3oV@00oooo0?ooo`080?ooo`030?l0003oool0oooo07l0oooo00<0o`000?oo
o`3oool0203oool00`3oV@00oooo0?ooo`090?ooo`030<co003oool0oooo00P0oooo00<0<ol00?oo
o`3oool0203oool00`00ofH0oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo000P0?ooo`03
0000003oool0oooo00P0oooo00<00?mV0?ooo`3oool02@3oool00`0co`00oooo0?ooo`080?ooo`03
0<co003oool0oooo00L0oooo00<0oiT00?ooo`3oool0203oool00`3o0000oooo0?ooo`210?ooo`03
0?l0003oool0oooo00P0oooo00<0oiT00?ooo`3oool02@3oool00`3<o`00oooo0?ooo`080?ooo`03
03?o003oool0oooo00P0oooo00<00?mV0?ooo`3oool0203oool00`000000oooo0?ooo`0:0?ooo`00
803oool2000000P0oooo00<00?mV0?ooo`3oool02@3oool00`0co`00oooo0?ooo`080?ooo`030<co
003oool0oooo00P0oooo00<0oiT00?ooo`3oool01P3oool20?l008D0oooo0P3o00090?ooo`030?nI
003oool0oooo00P0oooo00<0c?l00?ooo`3oool02@3oool00`0co`00oooo0?ooo`070?ooo`03003o
IP3oool0oooo00L0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`070?ooo`03003oIP3o
ool0oooo00P0oooo00<0<ol00?ooo`3oool02@3oool00`3<o`00oooo0?ooo`070?ooo`030?nI003o
ool0oooo00H0oooo00<0o`000?ooo`3oool0Q`3oool00`3o0000oooo0?ooo`070?ooo`030?nI003o
ool0oooo00P0oooo00<0c?l00?ooo`3oool0203oool00`0co`00oooo0?ooo`080?ooo`03003oIP3o
ool0oooo00L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool01P3oool0
0`00ofH0oooo0?ooo`090?ooo`0303?o003oool0oooo00P0oooo00<0c?l00?ooo`3oool01`3oool0
0`3oV@00oooo0?ooo`060?ooo`030?l0003oool0oooo08T0oooo00<0o`000?ooo`3oool01`3oool0
0`3oV@00oooo0?ooo`080?ooo`030<co003oool0oooo00P0oooo00<0<ol00?ooo`3oool01`3oool0
0`00ofH0oooo0?ooo`070?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo
00H0oooo00<00?mV0?ooo`3oool0203oool00`0co`00oooo0?ooo`080?ooo`030<co003oool0oooo
00L0oooo00<0oiT00?ooo`3oool01P3oool00`3o0000oooo0?ooo`2;0?ooo`030?l0003oool0oooo
00L0oooo00<0oiT00?ooo`3oool0203oool00`3<o`00oooo0?ooo`080?ooo`0303?o003oool0oooo
00H0oooo00<00?mV0?ooo`3oool01`3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000
oooo0?ooo`060?ooo`03003oIP3oool0oooo00L0oooo00<0<ol00?ooo`3oool0203oool00`3<o`00
oooo0?ooo`070?ooo`030?nI003oool0oooo00H0oooo00<0o`000?ooo`3oool0S@3oool00`3o0000
oooo0?ooo`070?ooo`030?nI003oool0oooo00L0oooo00<0c?l00?ooo`3oool0203oool00`0co`00
oooo0?ooo`070?ooo`03003oIP3oool0oooo00H0oooo00<000000?ooo`3oool02P3oool00200oooo
0P0000060?ooo`03003oIP3oool0oooo00P0oooo00<0<ol00?ooo`3oool0203oool00`3<o`00oooo
0?ooo`060?ooo`030?nI003oool0oooo00H0oooo00<0o`000?ooo`3oool0S`3oool00`3o0000oooo
0?ooo`060?ooo`030?nI003oool0oooo00P0oooo00<0c?l00?ooo`3oool0203oool00`0co`00oooo
0?ooo`060?ooo`03003oIP3oool0oooo00D0oooo0P00000<0?ooo`00803oool00`000000oooo0?oo
o`050?ooo`03003oIP3oool0oooo00L0oooo00<0<ol00?ooo`3oool0203oool00`3<o`00oooo0?oo
o`070?ooo`030?nI003oool0oooo00D0oooo00<0o`000?ooo`3oool0T@3oool00`3o0000oooo0?oo
o`060?ooo`030?nI003oool0oooo00P0oooo00<0c?l00?ooo`3oool01`3oool00`0co`00oooo0?oo
o`070?ooo`03003oIP3oool0oooo00D0oooo00<000000?ooo`3oool02P3oool00180oooo0`000004
0?ooo`8000001@3oool00`000000oooo0?ooo`040?ooo`03003oIP3oool0oooo00L0oooo00<0<ol0
0?ooo`3oool0203oool00`3<o`00oooo0?ooo`070?ooo`030?nI003oool0oooo00D0oooo00<0o`00
0?ooo`3oool0T`3oool00`3o0000oooo0?ooo`060?ooo`030?nI003oool0oooo00L0oooo00<0c?l0
0?ooo`3oool0203oool00`0co`00oooo0?ooo`060?ooo`03003oIP3oool0oooo00D0oooo00<00000
0?ooo`3oool02P3oool00140oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool0103oool00`00ofH0oooo0?ooo`070?ooo`0303?o003o
ool0oooo00P0oooo00<0c?l00?ooo`3oool01P3oool00`3oV@00oooo0?ooo`050?ooo`030?l0003o
ool0oooo09D0oooo00<0o`000?ooo`3oool01P3oool00`3oV@00oooo0?ooo`070?ooo`030<co003o
ool0oooo00P0oooo00<0<ol00?ooo`3oool01P3oool00`00ofH0oooo0?ooo`040?ooo`030000003o
ool0oooo00X0oooo000E0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`040?ooo`03003oIP3oool0oooo00H0oooo00<0<ol00?ooo`3oool0203o
ool00`3<o`00oooo0?ooo`060?ooo`030?nI003oool0oooo00D0oooo00<0o`000?ooo`3oool0U`3o
ool00`3o0000oooo0?ooo`060?ooo`030?nI003oool0oooo00L0oooo00<0c?l00?ooo`3oool01`3o
ool00`0co`00oooo0?ooo`060?ooo`03003oIP3oool0oooo00@0oooo00<000000?ooo`3oool02P3o
ool001D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`<000000`3o
ool00`00ofH0oooo0?ooo`060?ooo`0303?o003oool0oooo00P0oooo00<0c?l00?ooo`3oool01P3o
ool00`3oV@00oooo0?ooo`060?ooo`030?l0003oool0oooo09L0oooo00<0o`000?ooo`3oool01`3o
ool00`3oV@00oooo0?ooo`060?ooo`030<co003oool0oooo00P0oooo00<0<ol00?ooo`3oool01P3o
ool01000ofH0oooo0?ooo`3oool3000000`0oooo000A0?ooo`@000000`3oool010000000oooo0?oo
o`0000040?ooo`030000003oool0oooo00`0oooo00<0<ol00?ooo`3oool0203oool00`3<o`00oooo
0?ooo`060?ooo`030?nI003oool0oooo00D0oooo00<0o`000?ooo`3oool0V@3oool00`3o0000oooo
0?ooo`060?ooo`030?nI003oool0oooo00L0oooo00<0c?l00?ooo`3oool01`3oool00`0co`00oooo
0?ooo`0<0?ooo`030000003oool0oooo00X0oooo000A0?ooo`030000003oool0oooo00@0oooo00@0
00000?ooo`3oool00000103oool00`000000oooo0?ooo`0;0?ooo`0303?o003oool0oooo00P0oooo
00<0c?l00?ooo`3oool01P3oool00`3oV@00oooo0?ooo`050?ooo`030?l0003oool0oooo09/0oooo
00<0o`000?ooo`3oool01P3oool00`3oV@00oooo0?ooo`060?ooo`030<co003oool0oooo00L0oooo
00<0<ol00?ooo`3oool0303oool00`000000oooo0?ooo`0:0?ooo`004@3oool5000000<0oooo0P00
00050?ooo`030000003oool0oooo00/0oooo00<0<ol00?ooo`3oool01`3oool00`3<o`00oooo0?oo
o`060?ooo`030?nI003oool0oooo00H0oooo00<0o`000?ooo`3oool0V`3oool00`3o0000oooo0?oo
o`070?ooo`030?nI003oool0oooo00H0oooo00<0c?l00?ooo`3oool01`3oool00`0co`00oooo0?oo
o`0;0?ooo`030000003oool0oooo00X0oooo000P0?ooo`8000002`3oool00`0co`00oooo0?ooo`08
0?ooo`030<co003oool0oooo00D0oooo00<0oiT00?ooo`3oool01P3oool00`3o0000oooo0?ooo`2M
0?ooo`030?l0003oool0oooo00H0oooo00<0oiT00?ooo`3oool01`3oool00`3<o`00oooo0?ooo`06
0?ooo`0303?o003oool0oooo00X0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`0:0?oo
o`0303?o003oool0oooo00L0oooo00<0c?l00?ooo`3oool01@3oool00`3oV@00oooo0?ooo`060?oo
o`030?l0003oool0oooo09l0oooo00<0o`000?ooo`3oool01P3oool00`3oV@00oooo0?ooo`060?oo
o`030<co003oool0oooo00L0oooo00<0<ol00?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?oo
o`00803oool00`000000oooo0?ooo`090?ooo`0303?o003oool0oooo00L0oooo00<0c?l00?ooo`3o
ool01@3oool00`3oV@00oooo0?ooo`060?ooo`030?l0003oool0oooo0:40oooo00<0o`000?ooo`3o
ool01@3oool00`3oV@00oooo0?ooo`070?ooo`030<co003oool0oooo00H0oooo00<0<ol00?ooo`3o
ool02P3oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`090?ooo`0303?o
003oool0oooo00L0oooo00<0c?l00?ooo`3oool01@3oool00`3oV@00oooo0?ooo`060?ooo`030?l0
003oool0oooo0:40oooo00<0o`000?ooo`3oool01P3oool00`3oV@00oooo0?ooo`060?ooo`030<co
003oool0oooo00H0oooo00<0<ol00?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`00803o
ool00`000000oooo0?ooo`090?ooo`0303?o003oool0oooo00H0oooo00<0c?l00?ooo`3oool01@3o
ool00`3oV@00oooo0?ooo`060?ooo`030?l0003oool0oooo0:<0oooo00<0o`000?ooo`3oool01P3o
ool00`3oV@00oooo0?ooo`060?ooo`030<co003oool0oooo00H0oooo00<0<ol00?ooo`3oool02@3o
ool00`000000oooo0?ooo`0:0?ooo`00803oool2000000T0oooo00<0<ol00?ooo`3oool01P3oool0
0`3<o`00oooo0?ooo`060?ooo`030?nI003oool0oooo00D0oooo00<0o`000?ooo`3oool0Y@3oool0
0`3o0000oooo0?ooo`050?ooo`030?nI003oool0oooo00H0oooo00<0c?l00?ooo`3oool01P3oool0
0`0co`00oooo0?ooo`080?ooo`800000303oool00200oooo00<000000?ooo`3oool0203oool00`0c
o`00oooo0?ooo`060?ooo`030<co003oool0oooo00D0oooo00<0oiT00?ooo`3oool01P3oool00`3o
0000oooo0?ooo`2U0?ooo`030?l0003oool0oooo00H0oooo00<0oiT00?ooo`3oool01P3oool00`3<
o`00oooo0?ooo`060?ooo`0303?o003oool0oooo00P0oooo00<000000?ooo`3oool02P3oool00200
oooo00<000000?ooo`3oool01`3oool00`0co`00oooo0?ooo`060?ooo`030<co003oool0oooo00H0
oooo00<0oiT00?ooo`3oool01@3oool00`3o0000oooo0?ooo`2W0?ooo`030?l0003oool0oooo00D0
oooo00<0oiT00?ooo`3oool01P3oool00`3<o`00oooo0?ooo`060?ooo`0303?o003oool0oooo00P0
oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool01`3oool00`0co`00oooo
0?ooo`060?ooo`030<co003oool0oooo00H0oooo00<0oiT00?ooo`3oool0103oool00`3o0000oooo
0?ooo`2Y0?ooo`030?l0003oool0oooo00D0oooo00<0oiT00?ooo`3oool01P3oool00`3<o`00oooo
0?ooo`060?ooo`0303?o003oool0oooo00L0oooo00<000000?ooo`3oool02P3oool00200oooo0P00
00070?ooo`0303?o003oool0oooo00H0oooo00<0c?l00?ooo`3oool01P3oool00`3oV@00oooo0?oo
o`050?ooo`030?l0003oool0oooo0:T0oooo00<0o`000?ooo`3oool01P3oool00`3oV@00oooo0?oo
o`050?ooo`030<co003oool0oooo00H0oooo00<0<ol00?ooo`3oool01P3oool2000000`0oooo000P
0?ooo`030000003oool0oooo00H0oooo00<0<ol00?ooo`3oool01P3oool00`3<o`00oooo0?ooo`06
0?ooo`030?nI003oool0oooo00@0oooo00<0o`000?ooo`3oool0Z`3oool00`3o0000oooo0?ooo`05
0?ooo`030?nI003oool0oooo00H0oooo00<0c?l00?ooo`3oool01@3oool00`0co`00oooo0?ooo`07
0?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00H0oooo00<0<ol00?oo
o`3oool01@3oool00`3<o`00oooo0?ooo`060?ooo`030?nI003oool0oooo00D0oooo00<0o`000?oo
o`3oool0Z`3oool00`3o0000oooo0?ooo`060?ooo`030?nI003oool0oooo00D0oooo00<0c?l00?oo
o`3oool01P3oool00`0co`00oooo0?ooo`060?ooo`030000003oool0oooo00X0oooo000P0?ooo`03
0000003oool0oooo00D0oooo00<0<ol00?ooo`3oool01P3oool00`3<o`00oooo0?ooo`060?ooo`03
0?nI003oool0oooo00@0oooo00<0o`000?ooo`3oool0[@3oool00`3o0000oooo0?ooo`050?ooo`03
0?nI003oool0oooo00D0oooo00<0c?l00?ooo`3oool01P3oool00`0co`00oooo0?ooo`060?ooo`03
0000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00D0oooo00<0<ol00?ooo`3oool0
1P3oool00`3<o`00oooo0?ooo`050?ooo`030?nI003oool0oooo00D0oooo00<0o`000?ooo`3oool0
[P3oool00`3o0000oooo0?ooo`050?ooo`030?nI003oool0oooo00D0oooo00<0c?l00?ooo`3oool0
1P3oool00`0co`00oooo0?ooo`050?ooo`030000003oool0oooo00X0oooo000P0?ooo`8000001P3o
ool00`0co`00oooo0?ooo`050?ooo`030<co003oool0oooo00H0oooo00<0oiT00?ooo`3oool0103o
ool00`3o0000oooo0?ooo`2_0?ooo`030?l0003oool0oooo00D0oooo00<0oiT00?ooo`3oool01@3o
ool00`3<o`00oooo0?ooo`060?ooo`0303?o003oool0oooo00@0oooo0P00000<0?ooo`00803oool0
0`000000oooo0?ooo`040?ooo`0303?o003oool0oooo00H0oooo00<0c?l00?ooo`3oool01@3oool0
0`3oV@00oooo0?ooo`050?ooo`030?l0003oool0oooo0;00oooo00<0o`000?ooo`3oool01@3oool0
0`3oV@00oooo0?ooo`050?ooo`030<co003oool0oooo00D0oooo00<0<ol00?ooo`3oool01@3oool0
0`000000oooo0?ooo`0:0?ooo`00303oool3000000@0oooo0P0000040?ooo`8000001@3oool00`00
0000oooo0?ooo`040?ooo`0303?o003oool0oooo00D0oooo00<0c?l00?ooo`3oool01P3oool00`3o
V@00oooo0?ooo`040?ooo`030?l0003oool0oooo0;40oooo00<0o`000?ooo`3oool01@3oool00`3o
V@00oooo0?ooo`050?ooo`030<co003oool0oooo00H0oooo00<0<ol00?ooo`3oool0103oool00`00
0000oooo0?ooo`0:0?ooo`003@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`040?ooo`0303?o003oool0
oooo00D0oooo00<0c?l00?ooo`3oool01@3oool00`3oV@00oooo0?ooo`050?ooo`030?l0003oool0
oooo0;80oooo00<0o`000?ooo`3oool01@3oool00`3oV@00oooo0?ooo`050?ooo`030<co003oool0
oooo00D0oooo00<0<ol00?ooo`3oool0103oool00`000000oooo0?ooo`0:0?ooo`003@3oool00`00
0000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103o
ool3000000<0oooo00<0<ol00?ooo`3oool01@3oool00`3<o`00oooo0?ooo`060?ooo`030?nI003o
ool0oooo00@0oooo00<0o`000?ooo`3oool0/`3oool00`3o0000oooo0?ooo`050?ooo`030?nI003o
ool0oooo00D0oooo00<0c?l00?ooo`3oool01P3oool0100co`00oooo0?ooo`3oool3000000`0oooo
000=0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000040?ooo`030000003oool0oooo00/0oooo00<0c?l00?ooo`3oool01P3oool00`3oV@00
oooo0?ooo`040?ooo`030?l0003oool0oooo0;@0oooo00<0o`000?ooo`3oool0103oool00`3oV@00
oooo0?ooo`060?ooo`030<co003oool0oooo00/0oooo00<000000?ooo`3oool02P3oool000d0oooo
00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
00@0oooo00<000000?ooo`3oool02`3oool00`3<o`00oooo0?ooo`050?ooo`030?nI003oool0oooo
00D0oooo00<0o`000?ooo`3oool0]03oool00`3o0000oooo0?ooo`050?ooo`030?nI003oool0oooo
00D0oooo00<0c?l00?ooo`3oool02`3oool00`000000oooo0?ooo`0:0?ooo`00303oool2000000@0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo00X0oooo00<0c?l00?ooo`3oool01P3oool00`3oV@00oooo0?ooo`040?ooo`030?l0003oool0
oooo0;H0oooo00<0o`000?ooo`3oool0103oool00`3oV@00oooo0?ooo`060?ooo`030<co003oool0
oooo00X0oooo00<000000?ooo`3oool02P3oool000d0oooo00<000000?ooo`3oool00`3oool20000
00@0oooo0P0000050?ooo`030000003oool0oooo00X0oooo00<0c?l00?ooo`3oool01@3oool00`3o
V@00oooo0?ooo`050?ooo`030?l0003oool0oooo0;L0oooo00<0o`000?ooo`3oool0103oool00`3o
V@00oooo0?ooo`050?ooo`030<co003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00200
oooo0P00000;0?ooo`030<co003oool0oooo00D0oooo00<0oiT00?ooo`3oool0103oool00`3o0000
oooo0?ooo`2h0?ooo`030?l0003oool0oooo00@0oooo00<0oiT00?ooo`3oool01P3oool00`3<o`00
oooo0?ooo`080?ooo`800000303oool00200oooo00<000000?ooo`3oool02@3oool00`3<o`00oooo
0?ooo`050?ooo`030?nI003oool0oooo00D0oooo00<0o`000?ooo`3oool0^@3oool00`3o0000oooo
0?ooo`040?ooo`030?nI003oool0oooo00D0oooo00<0c?l00?ooo`3oool02@3oool00`000000oooo
0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`090?ooo`030<co003oool0oooo00D0oooo00<0
oiT00?ooo`3oool0103oool00`3o0000oooo0?ooo`2j0?ooo`030?l0003oool0oooo00@0oooo00<0
oiT00?ooo`3oool01@3oool00`3<o`00oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo000P
0?ooo`030000003oool0oooo00T0oooo00<0c?l00?ooo`3oool0103oool00`3oV@00oooo0?ooo`05
0?ooo`030?l0003oool0oooo0;/0oooo00<0o`000?ooo`3oool0103oool00`3oV@00oooo0?ooo`05
0?ooo`030<co003oool0oooo00P0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?oo
o`3oool0203oool00`3<o`00oooo0?ooo`050?ooo`030?nI003oool0oooo00@0oooo00<0o`000?oo
o`3oool0_03oool00`3o0000oooo0?ooo`040?ooo`030?nI003oool0oooo00D0oooo00<0c?l00?oo
o`3oool0203oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000T0oooo00<0c?l00?ooo`3o
ool0103oool00`3oV@00oooo0?ooo`050?ooo`030?l0003oool0oooo0;d0oooo00<0o`000?ooo`3o
ool0103oool00`3oV@00oooo0?ooo`040?ooo`030<co003oool0oooo00L0oooo0P00000<0?ooo`00
803oool00`000000oooo0?ooo`070?ooo`030<co003oool0oooo00D0oooo00<0oiT00?ooo`3oool0
103oool00`3o0000oooo0?ooo`2n0?ooo`030?l0003oool0oooo00@0oooo00<0oiT00?ooo`3oool0
1@3oool00`3<o`00oooo0?ooo`070?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003o
ool0oooo00L0oooo00<0c?l00?ooo`3oool01@3oool00`3oV@00oooo0?ooo`040?ooo`030?l0003o
ool0oooo0;h0oooo00<0o`000?ooo`3oool0103oool00`3oV@00oooo0?ooo`050?ooo`030<co003o
ool0oooo00L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool01`3oool0
0`3<o`00oooo0?ooo`040?ooo`030?nI003oool0oooo00D0oooo00<0o`000?ooo`3oool0_`3oool0
0`3o0000oooo0?ooo`040?ooo`030?nI003oool0oooo00@0oooo00<0c?l00?ooo`3oool01`3oool0
0`000000oooo0?ooo`0:0?ooo`00803oool2000000L0oooo00<0c?l00?ooo`3oool01@3oool00`3o
V@00oooo0?ooo`040?ooo`030?l0003oool0oooo0<00oooo00<0o`000?ooo`3oool0103oool00`3o
V@00oooo0?ooo`050?ooo`030<co003oool0oooo00D0oooo0P00000<0?ooo`00803oool00`000000
oooo0?ooo`060?ooo`030<co003oool0oooo00@0oooo00<0oiT00?ooo`3oool01@3oool00`3o0000
oooo0?ooo`300?ooo`030?l0003oool0oooo00D0oooo00<0oiT00?ooo`3oool0103oool00`3<o`00
oooo0?ooo`060?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00H0oooo
00<0c?l00?ooo`3oool0103oool00`3oV@00oooo0?ooo`040?ooo`030?l0003oool0oooo0<80oooo
00<0o`000?ooo`3oool0103oool00`3oV@00oooo0?ooo`040?ooo`030<co003oool0oooo00H0oooo
00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool01@3oool00`3<o`00oooo0?oo
o`040?ooo`030?nI003oool0oooo00D0oooo00<0o`000?ooo`3oool0`P3oool00`3o0000oooo0?oo
o`040?ooo`030?nI003oool0oooo00D0oooo00<0c?l00?ooo`3oool01@3oool00`000000oooo0?oo
o`0:0?ooo`00803oool00`000000oooo0?ooo`050?ooo`030<co003oool0oooo00@0oooo00<0oiT0
0?ooo`3oool01@3oool00`3o0000oooo0?ooo`330?ooo`030?l0003oool0oooo00@0oooo00<0oiT0
0?ooo`3oool0103oool00`3<o`00oooo0?ooo`050?ooo`030000003oool0oooo00X0oooo000P0?oo
o`8000001P3oool00`3<o`00oooo0?ooo`040?ooo`030?nI003oool0oooo00@0oooo00<0o`000?oo
o`3oool0a03oool00`3o0000oooo0?ooo`040?ooo`030?nI003oool0oooo00@0oooo00<0c?l00?oo
o`3oool0103oool2000000`0oooo000P0?ooo`030000003oool0oooo00@0oooo00<0c?l00?ooo`3o
ool0103oool00`3oV@00oooo0?ooo`050?ooo`030?l0003oool0oooo0<@0oooo00<0o`000?ooo`3o
ool0103oool00`3oV@00oooo0?ooo`050?ooo`030<co003oool0oooo00@0oooo00<000000?ooo`3o
ool02P3oool000`0oooo0`0000030?ooo`<00000103oool2000000D0oooo00<000000?ooo`3oool0
103oool00`3<o`00oooo0?ooo`040?ooo`030?nI003oool0oooo00@0oooo00<0o`000?ooo`3oool0
aP3oool00`3o0000oooo0?ooo`040?ooo`030?nI003oool0oooo00@0oooo00<0c?l00?ooo`3oool0
103oool00`000000oooo0?ooo`0:0?ooo`003@3oool01@000000oooo0?ooo`3oool0000000<0oooo
00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0
oooo00<0c?l00?ooo`3oool0103oool00`3oV@00oooo0?ooo`040?ooo`030?l0003oool0oooo0<H0
oooo00<0o`000?ooo`3oool0103oool00`3oV@00oooo0?ooo`040?ooo`030<co003oool0oooo00@0
oooo00<000000?ooo`3oool02P3oool000d0oooo00<000000?ooo`3oool01@3oool010000000oooo
0?ooo`0000020?ooo`030000003oool0oooo0080oooo0`0000030?ooo`030<co003oool0oooo00@0
oooo00<0oiT00?ooo`3oool0103oool00`3o0000oooo0?ooo`370?ooo`030?l0003oool0oooo00@0
oooo00<0oiT00?ooo`3oool01@3oool0103<o`00oooo0?ooo`3oool3000000`0oooo000=0?ooo`03
0000003oool0oooo00D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00X0oooo00<0oiT00?ooo`3oool0103oool00`3o0000oooo0?ooo`380?oo
o`030?l0003oool0oooo00@0oooo00<0oiT00?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?oo
o`003@3oool010000000oooo0?ooo`3oool4000000<0oooo00@000000?ooo`3oool00000103oool0
0`000000oooo0?ooo`0:0?ooo`030?nI003oool0oooo00@0oooo00<0o`000?ooo`3oool0b03oool0
0`3o0000oooo0?ooo`040?ooo`030?nI003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool0
00`0oooo0P0000030?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool00000103oool0
0`000000oooo0?ooo`090?ooo`030?nI003oool0oooo00@0oooo00<0o`000?ooo`3oool0bP3oool0
0`3o0000oooo0?ooo`030?ooo`030?nI003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool0
00d0oooo00@000000?ooo`3oool0oooo1@0000030?ooo`8000001@3oool00`000000oooo0?ooo`09
0?ooo`030?nI003oool0oooo00@0oooo00<0o`000?ooo`3oool0bP3oool00`3o0000oooo0?ooo`04
0?ooo`030?nI003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00200oooo0P00000:0?oo
o`030?nI003oool0oooo00<0oooo00<0o`000?ooo`3oool0b`3oool00`3o0000oooo0?ooo`040?oo
o`030?nI003oool0oooo00P0oooo0P00000<0?ooo`00803oool00`000000oooo0?ooo`080?ooo`03
0?nI003oool0oooo00@0oooo00<0o`000?ooo`3oool0c03oool00`3o0000oooo0?ooo`030?ooo`03
0?nI003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool0
203oool00`3oV@00oooo0?ooo`040?ooo`030?l0003oool0oooo0<`0oooo00<0o`000?ooo`3oool0
103oool00`3oV@00oooo0?ooo`080?ooo`030000003oool0oooo00X0oooo000P0?ooo`030000003o
ool0oooo00P0oooo00<0oiT00?ooo`3oool00`3oool00`3o0000oooo0?ooo`3=0?ooo`030?l0003o
ool0oooo00@0oooo00<0oiT00?ooo`3oool0203oool00`000000oooo0?ooo`0:0?ooo`00803oool2
000000P0oooo00<0oiT00?ooo`3oool0103oool00`3o0000oooo0?ooo`3>0?ooo`030?l0003oool0
oooo00<0oooo00<0oiT00?ooo`3oool01`3oool2000000`0oooo000P0?ooo`030000003oool0oooo
00L0oooo00<0oiT00?ooo`3oool00`3oool00`3o0000oooo0?ooo`3?0?ooo`030?l0003oool0oooo
00<0oooo00<0oiT00?ooo`3oool0203oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000
oooo0?ooo`070?ooo`030?nI003oool0oooo00<0oooo00<0o`000?ooo`3oool0c`3oool00`3o0000
oooo0?ooo`040?ooo`030?nI003oool0oooo00L0oooo00<000000?ooo`3oool02P3oool00200oooo
00<000000?ooo`3oool01`3oool00`3oV@00oooo0?ooo`030?ooo`030?l0003oool0oooo0=00oooo
00<0o`000?ooo`3oool00`3oool00`3oV@00oooo0?ooo`070?ooo`030000003oool0oooo00X0oooo
000P0?ooo`030000003oool0oooo00H0oooo00<0oiT00?ooo`3oool00`3oool00`3o0000oooo0?oo
o`3A0?ooo`030?l0003oool0oooo00<0oooo00<0oiT00?ooo`3oool01`3oool00`000000oooo0?oo
o`0:0?ooo`00803oool2000000L0oooo00<0oiT00?ooo`3oool00`3oool00`3o0000oooo0?ooo`3A
0?ooo`030?l0003oool0oooo00@0oooo00<0oiT00?ooo`3oool01@3oool2000000`0oooo000P0?oo
o`030000003oool0oooo00H0oooo00<0oiT00?ooo`3oool00`3oool00`3o0000oooo0?ooo`3B0?oo
o`030?l0003oool0oooo00<0oooo00<0oiT00?ooo`3oool01P3oool00`000000oooo0?ooo`0:0?oo
o`00803oool00`000000oooo0?ooo`050?ooo`030?nI003oool0oooo00<0oooo00<0o`000?ooo`3o
ool0d`3oool00`3o0000oooo0?ooo`030?ooo`030?nI003oool0oooo00H0oooo00<000000?ooo`3o
ool02P3oool00200oooo00<000000?ooo`3oool01@3oool00`3oV@00oooo0?ooo`030?ooo`030?l0
003oool0oooo0=<0oooo00<0o`000?ooo`3oool0103oool00`3oV@00oooo0?ooo`050?ooo`030000
003oool0oooo00X0oooo000P0?ooo`8000001P3oool00`3oV@00oooo0?ooo`030?ooo`030?l0003o
ool0oooo0=@0oooo00<0o`000?ooo`3oool00`3oool00`3oV@00oooo0?ooo`040?ooo`800000303o
ool00200oooo00<000000?ooo`3oool0103oool00`3oV@00oooo0?ooo`030?ooo`030?l0003oool0
oooo0=D0oooo00<0o`000?ooo`3oool00`3oool00`3oV@00oooo0?ooo`050?ooo`030000003oool0
oooo00X0oooo000P0?ooo`030000003oool0oooo00@0oooo00<0oiT00?ooo`3oool00`3oool00`3o
0000oooo0?ooo`3E0?ooo`030?l0003oool0oooo00@0oooo00<0oiT00?ooo`3oool0103oool00`00
0000oooo0?ooo`0:0?ooo`002`3oool5000000<0oooo0P0000040?ooo`8000001@3oool00`000000
oooo0?ooo`040?ooo`030?nI003oool0oooo00<0oooo00<0o`000?ooo`3oool0e@3oool00`3o0000
oooo0?ooo`040?ooo`030?nI003oool0oooo00@0oooo00<000000?ooo`3oool02P3oool000`0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000000@0oooo00<000000?ooo`3oool00`3oool00`3oV@00oooo0?ooo`040?ooo`030?l0003oool0
oooo0=H0oooo00<0o`000?ooo`3oool00`3oool00`3oV@00oooo0?ooo`040?ooo`030000003oool0
oooo00X0oooo000=0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000040?ooo`<000000`3oool00`3oV@00oooo0?ooo`030?ooo`030?l0003o
ool0oooo0=L0oooo00<0o`000?ooo`3oool0103oool0103oV@00oooo0?ooo`3oool3000000`0oooo
000>0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool02@3oool00`3o0000oooo0?ooo`3G0?ooo`03
0?l0003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool000/0oooo00D000000?ooo`3oool0
oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool0
0`000000oooo0?ooo`090?ooo`030?l0003oool0oooo0=P0oooo00<0o`000?ooo`3oool02@3oool0
0`000000oooo0?ooo`0:0?ooo`002`3oool01@000000oooo0?ooo`3oool000000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00T0oooo
00<0o`000?ooo`3oool0f03oool00`3o0000oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo
000<0?ooo`<00000103oool2000000@0oooo0P0000050?ooo`030000003oool0oooo00P0oooo00<0
o`000?ooo`3oool0f@3oool00`3o0000oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo000P
0?ooo`8000002@3oool00`3o0000oooo0?ooo`3I0?ooo`030?l0003oool0oooo00P0oooo0P00000<
0?ooo`00803oool00`000000oooo0?ooo`080?ooo`030?l0003oool0oooo0=X0oooo00<0o`000?oo
o`3oool0203oool00`000000oooo0?ooo`0:0?ooo`00803oool00`000000oooo0?ooo`070?ooo`03
0?l0003oool0oooo0=/0oooo00<0o`000?ooo`3oool0203oool00`000000oooo0?ooo`0:0?ooo`00
803oool00`000000oooo0?ooo`070?ooo`030?l0003oool0oooo0=/0oooo00<0o`000?ooo`3oool0
203oool00`000000oooo0?ooo`0:0?ooo`00803oool2000000P0oooo00<0o`000?ooo`3oool0g03o
ool00`3o0000oooo0?ooo`060?ooo`800000303oool00200oooo00<000000?ooo`3oool01`3oool0
0`3o0000oooo0?ooo`3L0?ooo`030?l0003oool0oooo00L0oooo00<000000?ooo`3oool02P3oool0
0200oooo00<000000?ooo`3oool01P3oool00`3o0000oooo0?ooo`3M0?ooo`030?l0003oool0oooo
00L0oooo00<000000?ooo`3oool02P3oool00200oooo00<000000?ooo`3oool01P3oool00`3o0000
oooo0?ooo`3N0?ooo`030?l0003oool0oooo00H0oooo00<000000?ooo`3oool02P3oool00200oooo
00<000000?ooo`3oool01P3oool00`3o0000oooo0?ooo`3N0?ooo`030?l0003oool0oooo00H0oooo
00<000000?ooo`3oool02P3oool00200oooo0P0000070?ooo`030?l0003oool0oooo0=h0oooo00<0
o`000?ooo`3oool01@3oool2000000`0oooo000P0?ooo`030000003oool0oooo00D0oooo00<0o`00
0?ooo`3oool0g`3oool00`3o0000oooo0?ooo`060?ooo`030000003oool0oooo00X0oooo000P0?oo
o`030000003oool0oooo00D0oooo00<0o`000?ooo`3oool0h03oool00`3o0000oooo0?ooo`050?oo
o`030000003oool0oooo00X0oooo000P0?ooo`030000003oool0oooo00D0oooo00<0o`000?ooo`3o
ool0h03oool00`3o0000oooo0?ooo`050?ooo`030000003oool0oooo00X0oooo000P0?ooo`800000
1@3oool00`3o0000oooo0?ooo`3Q0?ooo`030?l0003oool0oooo00@0oooo0P00000<0?ooo`00803o
ool00`000000oooo0?ooo`040?ooo`030?l0003oool0oooo0>80oooo00<0o`000?ooo`3oool0103o
ool00`000000oooo0?ooo`0:0?ooo`002`3oool500000080oooo0`0000040?ooo`8000001@3oool0
0`000000oooo0?ooo`040?ooo`030?l0003oool0oooo0>80oooo00<0o`000?ooo`3oool0103oool0
0`000000oooo0?ooo`0:0?ooo`00303oool01P000000oooo0?ooo`000000oooo000000<0oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<0o`000?ooo`3oool0hP3oool00`3o0000oooo0?ooo`040?ooo`030000003oool0oooo00X0oooo
000=0?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00<0oooo00<0o`000?ooo`3oool0i03oool00`3o0000oooo
0?ooo`030?ooo`030000003oool0oooo00X0oooo000>0?ooo`030000003oool0oooo00@0oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`<000000`3oool00`3o0000oooo
0?ooo`3T0?ooo`040?l0003oool0oooo0?ooo`<00000303oool000/0oooo00H000000?ooo`3oool0
oooo0000003oool4000000<0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3`
0?ooo`030000003oool0oooo00X0oooo000;0?ooo`070000003oool0oooo0?ooo`000000oooo0000
00060?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`0g0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0g0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool02P3oool000`0oooo0`00
00020?ooo`D000000`3oool2000000D0oooom000000<0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00OP3oool30000
00@0oooo0`0000040?ooo`8000000`3oool300000080oooo0`0000000`3oool00000000000020?oo
o`8000000P3oool500000080oooo100000000`3oool0000000000003000006d0oooo001o0?ooo`03
0000003oool0oooo0080oooo00D000000?ooo`3oool0oooo000000020?ooo`060000003oool0oooo
0000003oool000001P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000<0
oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool0K@3oool007l0oooo00<000000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool00P3oool500000080oooo00@000000?ooo`3oool000000P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo0`0000040?ooo`030000003oool0
oooo06d0oooo001o0?ooo`<000000P3oool01@000000oooo0?ooo`3oool000000080oooo00<00000
0?ooo`3oool00P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`040?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo06d0oooo001o0?ooo`040000003oool0oooo00000080
oooo0`0000020?ooo`@000000`3oool300000080oooo100000020?ooo`@000000P3oool3000000@0
oooo0P0000050?ooo`030000003oool0oooo06d0oooo001o0?ooo`040000003oool0oooo000000P0
oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo06d0
oooo001n0?ooo`@000002@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool01`3oool3000006l0oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-13.3275, -96.6538, \
0.0865972, 2.18932}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Jacobi", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Clear[Df,DDf,DDDf,DDDDf,Dh,Dg];
Df[{S_},t_,Theta_] = Outer[D,f[{S},t,Theta],{S}]
DDf[{S_},t_,Theta_] = Outer[D,Df[{S},t,Theta],{S}]
DDDf[{S_},t_,Theta_] = Outer[D,DDf[{S},t,Theta],{S}]
DDDDf[{S_},t_,Theta_] = Outer[D,DDDf[{S},t,Theta],{S}]


Dh[{S_},t_,Theta_] = Outer[D,h[{S},t,Theta],{S}]
Dg[{S_},t_,Theta_] = Outer[D,g[{S},t,Theta],{S}]
DOmega[{S_},t_,Theta_] = Outer[D,Omega[{S},t,Theta],{S}]
DDOmega[{S_},t_,Theta_] = Outer[D,DOmega[{S},t,Theta],{S}]
DDDOmega[{S_},t_,Theta_] = Outer[D,DDOmega[{S},t,Theta],{S}]
DDDDOmega[{S_},t_,Theta_] = Outer[D,DDDOmega[{S},t,Theta],{S}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 2 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 1 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \({{\(-3\)\ S\^2\ Abs[Theta\[LeftDoubleBracket]2\[RightDoubleBracket]] - 
          Theta\[LeftDoubleBracket]1\[RightDoubleBracket]}}\)], "Output"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 2 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 1 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \({{{\(-6\)\ S\ Abs[
              Theta\[LeftDoubleBracket]2\[RightDoubleBracket]]}}}\)], "Output"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 2 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \({{{{\(-6\)\ Abs[
                Theta\[LeftDoubleBracket]2\[RightDoubleBracket]]}}}}\)], \
"Output"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 2 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \({{{{{0}}}}}\)], "Output"],

Cell[BoxData[
    \({{1}}\)], "Output"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 3 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \({{{0}}}\)], "Output"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DOmega\)\" is similar \
to existing symbols \!\({DDOmega, Omega}\)."\)], "Message"],

Cell[BoxData[
    \(Part::"partd" \(\(:\)\(\ \)\) 
      "Part specification \!\(Theta \[LeftDoubleBracket] 3 \
\[RightDoubleBracket]\) is longer than depth of object."\)], "Message"],

Cell[BoxData[
    \({{{0}}}\)], "Output"],

Cell[BoxData[
    \({{{{0}}}}\)], "Output"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DDDOmega\)\" is similar \
to existing symbols \!\({DDDDOmega, DDOmega}\)."\)], "Message"],

Cell[BoxData[
    \({{{{{0}}}}}\)], "Output"],

Cell[BoxData[
    \({{{{{{0}}}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
 f[{1},_,{1,2,3,4}]
Df[{1},_,{1,2,3,4}]
DDf[{1},_,{1,2,3,4}]
DDDf[{1},_,{1,2,3,4}]
DDDDf[{1},_,{1,2,3,4}]
Dh[{1},_,{1,2,3,4}]
Dg[{1},_,{1,2,3,4}]
DDDDOmega[{1},_,{1,2,3,4}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({\(-3\)}\)], "Output"],

Cell[BoxData[
    \({{\(-7\)}}\)], "Output"],

Cell[BoxData[
    \({{{\(-12\)}}}\)], "Output"],

Cell[BoxData[
    \({{{{\(-12\)}}}}\)], "Output"],

Cell[BoxData[
    \({{{{{0}}}}}\)], "Output"],

Cell[BoxData[
    \({{1}}\)], "Output"],

Cell[BoxData[
    \({{{0}}}\)], "Output"],

Cell[BoxData[
    \({{{{{{0}}}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
h1=h[{#1},#2,#3][[1]]&
R1=R[{#1},#2,#3][[1,1]]&

f1=f[{#1},#2,#3][[1]]&
Df1=Df[{#1},#2,#3][[1,1]]&
DDf1=DDf[{#1},#2,#3][[1,1,1]]&
DDDf1=DDDf[{#1},#2,#3][[1,1,1,1]]&
DDDDf1=DDDDf[{#1},#2,#3][[1,1,1,1,1]]&


g1=g[{#1},#2,#3][[1,1]]&
Omega1=Omega[{#1},#2,#3][[1,1]]&
DOmega1=DOmega[{#1},#2,#3][[1,1,1]]&
DDOmega1=DDOmega[{#1},#2,#3][[1,1,1,1]]&
DDDOmega1=DDDOmega[{#1},#2,#3][[1,1,1,1,1]]&
DDDDOmega1=DDDDOmega[{#1},#2,#3][[1,1,1,1,1,1]]&\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(\(h[{#1}, #2, #3]\)\[LeftDoubleBracket]1\[RightDoubleBracket] &\)], \
"Output"],

Cell[BoxData[
    \(\(R[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(\(f[{#1}, #2, #3]\)\[LeftDoubleBracket]1\[RightDoubleBracket] &\)], \
"Output"],

Cell[BoxData[
    \(\(Df[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DDf1\)\" is similar to \
existing symbol \"\!\(Df1\)\"."\)], "Message"],

Cell[BoxData[
    \(\(DDf[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DDDf1\)\" is similar to \
existing symbol \"\!\(DDf1\)\"."\)], "Message"],

Cell[BoxData[
    \(\(DDDf[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 1, 1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DDDDf1\)\" is similar \
to existing symbol \"\!\(DDDf1\)\"."\)], "Message"],

Cell[BoxData[
    \(\(DDDDf[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 1, 1, 1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(\(g[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Omega1\)\" is similar \
to existing symbol \"\!\(omega1\)\"."\)], "Message"],

Cell[BoxData[
    \(\(Omega[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DOmega1\)\" is similar \
to existing symbol \"\!\(Omega1\)\"."\)], "Message"],

Cell[BoxData[
    \(\(DOmega[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DDOmega1\)\" is similar \
to existing symbol \"\!\(DOmega1\)\"."\)], "Message"],

Cell[BoxData[
    \(\(DDOmega[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 1, 1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DDDOmega1\)\" is \
similar to existing symbol \"\!\(DDOmega1\)\"."\)], "Message"],

Cell[BoxData[
    \(\(DDDOmega[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 1, 1, 1, 
        1\[RightDoubleBracket] &\)], "Output"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(DDDDOmega1\)\" is \
similar to existing symbol \"\!\(DDDOmega1\)\"."\)], "Message"],

Cell[BoxData[
    \(\(DDDDOmega[{#1}, #2, #3]\)\[LeftDoubleBracket]1, 1, 1, 1, 1, 
        1\[RightDoubleBracket] &\)], "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
n=10; (*panel data*)
T = 200;
dt = .1;
k = 1; p = 1; q = 1;
X = Shape[0,{n,T+1,q}];
Theta = {-1., 0.1, 2.,1}//N;
SeedRandom[99999];
Y0 = RandomGauss[_,Theta,{mue,sigma},n];
Prozess = UniC;
{zt,yt} = MapThread[NonLinStateSpace[
   \t\t\t\t\t h,{R,konstant},f,g,#1,#2,T,dt,Theta,Prozess,EulerStep]&,{Y0,X}]/\
/Transpose;
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["zt//Dimensions", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({10, 201, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["irregular data", "Subsubsection"],

Cell[CellGroupData[{

Cell["\<\
miss = -9;
time = {0,4,6,8,10,11,12,13.5,13.7,15,15.1,17,19,20}
sel = time/dt + 1
ZM = Shape[miss,{n,T+1,k}];
Map[(ZM[[All,#]] = zt[[All,#]])&,sel];

ZM\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0, 4, 6, 8, 10, 11, 12, 13.5`, 13.7`, 15, 15.1`, 17, 19, 
      20}\)], "Output"],

Cell[BoxData[
    \({1, 41.`, 61.`, 81.`, 101.`, 111.`, 121.`, 136.`, 138.`, 151.`, 152.`, 
      171.`, 191.`, 201.`}\)], "Output"],

Cell[BoxData[
    \({{{1.3195441435829123`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{0.9514688384546759`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-2.5806078165889472`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-0.8642375197989837`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-3.279908644321249`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-1.7702592500855916`\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-0.4715858354621105`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-5.028314516699051`\)}, {\(-9\)}, \
{\(-2.4735427334802425`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-1.5694111903574435`\)}, {\(-2.6769793541943216`\)}, {\(-9\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {3.7946235492738025`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {3.558337076997535`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {5.474408406307022`}}, \
{{3.2606539506633827`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{4.0969373072691235`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.799543204388158`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.621685078309501`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.8333560363186452`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {0.371011458002307`}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-0.8719083599522928`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-2.2861740019952994`\)}, {\(-9\)}, \
{\(-3.107915848822861`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-2.142938122779859`\)}, {0.5667997344737405`}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {5.600400497756814`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {2.9712984187759686`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {1.5368979886435672`}}, \
{{2.21816676880307`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {3.745177935141397`}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {3.1700347542130154`}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {3.816859676454266`}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {1.3284597966780745`}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.5882277164196243`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {3.5339665358601686`}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.247294617745963`}, {\(-9\)}, {6.104021201304022`}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {3.3669942537661095`}, {2.0538027382077453`}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {5.553783949170329`}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {4.650607674973237`}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.9463551262130876`}}, {{\(-3.444239357033006`\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {1.338061042177439`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.1071972969844928`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.6366322553085775`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.1616219200494955`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {0.27696729303042206`}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {5.222379700932132`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {5.992399361480528`}, {\(-9\)}, {2.470403736288051`}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {4.935992583239287`}, \
{3.8423413276740983`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{4.385455805115114`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{2.002204185275592`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {0.6505782278438601`}}, \
{{0.5826598082728234`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{5.057444755685431`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.6903025183578166`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-2.9907345092440547`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-0.9443544441106131`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {0.7977059115438646`}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-0.3210235887873609`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-0.8034935405792722`\)}, {\(-9\)}, \
{\(-2.367641870228918`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-2.6727899485515967`\)}, {\(-0.7285943967090791`\)}, {\(-9\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {2.13302222497793`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {4.194978044698766`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {3.151688125311499`}}, \
{{\(-1.945016523950144`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.5412796613694457`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{0.051222032500901404`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-4.307087385645733`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-1.19042406966964`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-3.622535240821648`\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-5.794199347249113`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-3.4719653962319788`\)}, {\(-9\)}, \
{\(-1.9020791314471264`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-1.2403540704592841`\)}, {\(-0.4753474257493122`\)}, {\(-9\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-4.075106819414587`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {4.212701525524192`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.1659303390848301`}}, {{3.7592691880998315`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {1.800915491569389`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{2.0550676177418294`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.330806281431474`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{0.8170367081888472`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {3.1099491228342915`}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {1.258866819791963`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {2.83329825023288`}, {\(-9\)}, \
{\(-1.1216173300810575`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-1.0759967950408085`\)}, {\(-3.3291573567595467`\)}, {\(-9\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-4.1337682431563305`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {0.773790090439439`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {4.389177522481372`}}, \
{{\(-0.3828656631129297`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-4.039025631949475`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-4.2280969398490535`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-5.552828081436674`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-0.025600718674548495`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {2.565794643526539`}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {3.01931051119341`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {1.675109772297647`}, {\(-9\)}, \
{2.1111435897287585`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.1050807056140233`}, {1.9865046385900578`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {3.635223051579509`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.3750417932050705`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {3.15464164075976`}}, \
{{1.971891134629841`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{2.00424057704006`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{1.7149663782085398`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{2.6196132304164577`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{0.4028045942324413`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {2.0572499059386136`}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {3.439478290614865`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {2.621276856131924`}, {\(-9\)}, {3.778435419207433`}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {0.22622901465698075`}, \
{2.4065785543729863`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{0.2393208212840061`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.5433470587605314`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {3.334974856457891`}}, \
{{\(-1.6511858457802373`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-3.13316196103606`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-4.447826757886122`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.0920358219321806`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{3.887694281112937`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\
\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {1.5909803138062268`}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-0.7163131759958046`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-0.6962665935399839`\)}, {\(-9\)}, \
{\(-0.48004859867142535`\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {0.7118342856534056`}, {\(-2.08201819079752`\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-4.301785512379422`\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-2.6040325528398367`\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-1.4689662538266877`\)}}}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
nn=2;
plot1[zt[[nn]]~ii~yt[[nn]]//AddTimeAxis,GridLines->{time/dt,None},PlotRange->{\
-6,6}];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{201, 3}\),
      SequenceForm[ "Dimension der Daten  ", {201, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0047619 0.309017 0.0515028 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -6 -9 ]
[.2619 -0.0125 6 0 ]
[.5 -0.0125 -9 -9 ]
[.5 -0.0125 9 0 ]
[.7381 -0.0125 -9 -9 ]
[.7381 -0.0125 9 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10301 -12 -4.5 ]
[-0.0125 .10301 0 4.5 ]
[-0.0125 .20601 -12 -4.5 ]
[-0.0125 .20601 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .41202 -6 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .51503 -6 -4.5 ]
[-0.0125 .51503 0 4.5 ]
[-0.0125 .61803 -6 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .61803 L
s
.21429 0 m
.21429 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.40476 0 m
.40476 .61803 L
s
.5 0 m
.5 .61803 L
s
.54762 0 m
.54762 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.66667 0 m
.66667 .61803 L
s
.67619 0 m
.67619 .61803 L
s
.7381 0 m
.7381 .61803 L
s
.74286 0 m
.74286 .61803 L
s
.83333 0 m
.83333 .61803 L
s
.92857 0 m
.92857 .61803 L
s
.97619 0 m
.97619 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(50)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(100)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(150)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(200)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10301 m
.00625 .10301 L
s
[(-4)] -0.0125 .10301 1 0 Mshowa
0 .20601 m
.00625 .20601 L
s
[(-2)] -0.0125 .20601 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(2)] -0.0125 .41202 1 0 Mshowa
0 .51503 m
.00625 .51503 L
s
[(4)] -0.0125 .51503 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(6)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .02575 m
.00375 .02575 L
s
0 .0515 m
.00375 .0515 L
s
0 .07725 m
.00375 .07725 L
s
0 .12876 m
.00375 .12876 L
s
0 .15451 m
.00375 .15451 L
s
0 .18026 m
.00375 .18026 L
s
0 .23176 m
.00375 .23176 L
s
0 .25751 m
.00375 .25751 L
s
0 .28327 m
.00375 .28327 L
s
0 .33477 m
.00375 .33477 L
s
0 .36052 m
.00375 .36052 L
s
0 .38627 m
.00375 .38627 L
s
0 .43777 m
.00375 .43777 L
s
0 .46353 m
.00375 .46353 L
s
0 .48928 m
.00375 .48928 L
s
0 .54078 m
.00375 .54078 L
s
0 .56653 m
.00375 .56653 L
s
0 .59228 m
.00375 .59228 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .10301 m
1 .10301 L
s
.99375 .20601 m
1 .20601 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .51503 m
1 .51503 L
s
.125 Mabswid
.99625 .02575 m
1 .02575 L
s
.99625 .0515 m
1 .0515 L
s
.99625 .07725 m
1 .07725 L
s
.99625 .12876 m
1 .12876 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .18026 m
1 .18026 L
s
.99625 .23176 m
1 .23176 L
s
.99625 .25751 m
1 .25751 L
s
.99625 .28327 m
1 .28327 L
s
.99625 .33477 m
1 .33477 L
s
.99625 .36052 m
1 .36052 L
s
.99625 .38627 m
1 .38627 L
s
.99625 .43777 m
1 .43777 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .48928 m
1 .48928 L
s
.99625 .54078 m
1 .54078 L
s
.99625 .56653 m
1 .56653 L
s
.99625 .59228 m
1 .59228 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.97619 .38817 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .47695 m
.02857 .46402 L
.03333 .50343 L
.0381 .396 L
.04286 .4938 L
.04762 .51108 L
.05238 .36884 L
.05714 .33678 L
.0619 .42417 L
.06667 .4552 L
.07143 .43353 L
.07619 .49076 L
.08095 .50069 L
.08571 .51824 L
.09048 .43496 L
.09524 .4884 L
.1 .37937 L
.10476 .47748 L
.10952 .40579 L
.11429 .47543 L
.11905 .45056 L
.12381 .46861 L
.12857 .36977 L
.13333 .30921 L
.1381 .40511 L
.14286 .31716 L
.14762 .41924 L
.15238 .34593 L
.15714 .46873 L
.1619 .31555 L
.16667 .32565 L
.17143 .23121 L
.17619 .32043 L
.18095 .36638 L
.18571 .2752 L
.19048 .35745 L
.19524 .31798 L
.2 .28557 L
.20476 .40508 L
.20952 .49967 L
.21429 .52002 L
.21905 .33727 L
.22381 .30113 L
.22857 .27539 L
.23333 .26995 L
.2381 .3109 L
.24286 .43389 L
.24762 .4188 L
.25238 .37828 L
.25714 .38967 L
Mistroke
.2619 .53797 L
.26667 .47608 L
.27143 .43332 L
.27619 .53925 L
.28095 .44155 L
.28571 .42299 L
.29048 .52698 L
.29524 .45302 L
.3 .48186 L
.30476 .49113 L
.30952 .4017 L
.31429 .50579 L
.31905 .50506 L
.32381 .49452 L
.32857 .44912 L
.33333 .50162 L
.3381 .48548 L
.34286 .45049 L
.34762 .36123 L
.35238 .43581 L
.35714 .35817 L
.3619 .4023 L
.36667 .4072 L
.37143 .41597 L
.37619 .31491 L
.38095 .36826 L
.38571 .29868 L
.39048 .43712 L
.39524 .48918 L
.4 .43715 L
.40476 .49554 L
.40952 .55797 L
.41429 .46794 L
.41905 .50641 L
.42381 .41936 L
.42857 .5099 L
.43333 .50513 L
.4381 .61477 L
.44286 .49555 L
.44762 .48439 L
.45238 .45453 L
.45714 .38518 L
.4619 .44785 L
.46667 .41811 L
.47143 .52272 L
.47619 .3493 L
.48095 .35076 L
.48571 .44722 L
.49048 .43051 L
.49524 .45267 L
Mistroke
.5 .40344 L
.50476 .41493 L
.50952 .40268 L
.51429 .41171 L
.51905 .42394 L
.52381 .43083 L
.52857 .42925 L
.53333 .33724 L
.5381 .31346 L
.54286 .27718 L
.54762 .32813 L
.55238 .34853 L
.55714 .35995 L
.5619 .27723 L
.56667 .30147 L
.57143 .26912 L
.57619 .27226 L
.58095 .15324 L
.58571 .30102 L
.59048 .20217 L
.59524 .26411 L
.6 .28818 L
.60476 .22983 L
.60952 .35289 L
.61429 .23488 L
.61905 .18584 L
.62381 .19153 L
.62857 .24525 L
.63333 .23618 L
.6381 .13474 L
.64286 .10292 L
.64762 .13922 L
.65238 .2126 L
.65714 .20008 L
.6619 .23185 L
.66667 .19127 L
.67143 .19825 L
.67619 .14895 L
.68095 .21225 L
.68571 .14087 L
.69048 .19581 L
.69524 .38218 L
.7 .24067 L
.70476 .20613 L
.70952 .24936 L
.71429 .28312 L
.71905 .25343 L
.72381 .33217 L
.72857 .26202 L
.73333 .29172 L
Mistroke
.7381 .19865 L
.74286 .33821 L
.74762 .21123 L
.75238 .39194 L
.75714 .39436 L
.7619 .38508 L
.76667 .42159 L
.77143 .38155 L
.77619 .47062 L
.78095 .38099 L
.78571 .52388 L
.79048 .40406 L
.79524 .4755 L
.8 .38798 L
.80476 .525 L
.80952 .44596 L
.81429 .416 L
.81905 .47359 L
.82381 .4389 L
.82857 .55248 L
.83333 .59745 L
.8381 .61268 L
.84286 .50713 L
.84762 .50801 L
.85238 .58549 L
.85714 .51307 L
.8619 .45045 L
.86667 .5272 L
.87143 .55863 L
.87619 .46898 L
.88095 .47934 L
.88571 .38078 L
.89048 .40191 L
.89524 .46656 L
.9 .45687 L
.90476 .36246 L
.90952 .43522 L
.91429 .35688 L
.91905 .44857 L
.92381 .48676 L
.92857 .46205 L
.93333 .55189 L
.9381 .55218 L
.94286 .40299 L
.94762 .55153 L
.95238 .35512 L
.95714 .50106 L
.9619 .55564 L
.96667 .36478 L
.97143 .45851 L
Mistroke
.97619 .38817 L
Mfstroke
0 .98 .604 r
gsave
.97619 .40352 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .39571 m
.02857 .42236 L
.03333 .46221 L
.0381 .47244 L
.04286 .42619 L
.04762 .4555 L
.05238 .40879 L
.05714 .42025 L
.0619 .45538 L
.06667 .45593 L
.07143 .47511 L
.07619 .47905 L
.08095 .51178 L
.08571 .4697 L
.09048 .42185 L
.09524 .4424 L
.1 .40661 L
.10476 .40459 L
.10952 .40484 L
.11429 .41028 L
.11905 .39412 L
.12381 .40458 L
.12857 .38134 L
.13333 .34442 L
.1381 .3407 L
.14286 .38401 L
.14762 .38282 L
.15238 .39391 L
.15714 .38272 L
.1619 .34877 L
.16667 .33849 L
.17143 .28492 L
.17619 .29243 L
.18095 .30964 L
.18571 .33567 L
.19048 .33366 L
.19524 .36809 L
.2 .36659 L
.20476 .38946 L
.20952 .43267 L
.21429 .45368 L
.21905 .40197 L
.22381 .37566 L
.22857 .36275 L
.23333 .34927 L
.2381 .35042 L
.24286 .40764 L
.24762 .38174 L
.25238 .4328 L
.25714 .45156 L
Mistroke
.2619 .45893 L
.26667 .48026 L
.27143 .48465 L
.27619 .47871 L
.28095 .43889 L
.28571 .46266 L
.29048 .5171 L
.29524 .53843 L
.3 .50793 L
.30476 .46538 L
.30952 .43092 L
.31429 .42098 L
.31905 .45755 L
.32381 .44657 L
.32857 .45546 L
.33333 .44132 L
.3381 .45265 L
.34286 .40439 L
.34762 .37746 L
.35238 .4252 L
.35714 .4408 L
.3619 .48247 L
.36667 .45812 L
.37143 .43269 L
.37619 .38737 L
.38095 .35505 L
.38571 .38749 L
.39048 .42516 L
.39524 .4751 L
.4 .47347 L
.40476 .50503 L
.40952 .54981 L
.41429 .51699 L
.41905 .47926 L
.42381 .48883 L
.42857 .49735 L
.43333 .51249 L
.4381 .54636 L
.44286 .46947 L
.44762 .44293 L
.45238 .40551 L
.45714 .45208 L
.4619 .49474 L
.46667 .47647 L
.47143 .48028 L
.47619 .42524 L
.48095 .43594 L
.48571 .39966 L
.49048 .40481 L
.49524 .45262 L
Mistroke
.5 .48902 L
.50476 .46854 L
.50952 .48027 L
.51429 .46455 L
.51905 .41083 L
.52381 .40338 L
.52857 .36857 L
.53333 .32802 L
.5381 .32008 L
.54286 .35149 L
.54762 .3493 L
.55238 .31851 L
.55714 .30344 L
.5619 .3038 L
.56667 .28246 L
.57143 .26141 L
.57619 .25807 L
.58095 .21066 L
.58571 .23525 L
.59048 .20773 L
.59524 .25395 L
.6 .30395 L
.60476 .27897 L
.60952 .26928 L
.61429 .22836 L
.61905 .23722 L
.62381 .25229 L
.62857 .19802 L
.63333 .15356 L
.6381 .12435 L
.64286 .13515 L
.64762 .19041 L
.65238 .21257 L
.65714 .20458 L
.6619 .15369 L
.66667 .18328 L
.67143 .16552 L
.67619 .21609 L
.68095 .24231 L
.68571 .2298 L
.69048 .26648 L
.69524 .3027 L
.7 .24729 L
.70476 .20028 L
.70952 .24098 L
.71429 .27708 L
.71905 .30012 L
.72381 .32072 L
.72857 .34937 L
.73333 .32351 L
Mistroke
.7381 .27379 L
.74286 .28478 L
.74762 .292 L
.75238 .34492 L
.75714 .34806 L
.7619 .36967 L
.76667 .41318 L
.77143 .41924 L
.77619 .41328 L
.78095 .46278 L
.78571 .45899 L
.79048 .46382 L
.79524 .47731 L
.8 .47006 L
.80476 .47864 L
.80952 .49599 L
.81429 .50041 L
.81905 .47231 L
.82381 .49014 L
.82857 .51934 L
.83333 .54596 L
.8381 .53364 L
.84286 .56022 L
.84762 .53229 L
.85238 .54807 L
.85714 .57667 L
.8619 .51199 L
.86667 .50929 L
.87143 .47829 L
.87619 .45879 L
.88095 .46008 L
.88571 .41439 L
.89048 .46813 L
.89524 .46377 L
.9 .4133 L
.90476 .42553 L
.90952 .41041 L
.91429 .36123 L
.91905 .36214 L
.92381 .41059 L
.92857 .44205 L
.93333 .46831 L
.9381 .50373 L
.94286 .44916 L
.94762 .49381 L
.95238 .43978 L
.95714 .48874 L
.9619 .48832 L
.96667 .4337 L
.97143 .39036 L
Mistroke
.97619 .40352 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00603oool2000003L0oooo0`0000040?ooo`800000<03oool3000000@0oooo0P0000040?oo
o`800000;@3oool3000000<0oooo0`0000040?ooo`800000;03oool5000000<0oooo0P0000040?oo
o`800000203oool001L0oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool00000<03oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool00000;@3oool01@000000oooo0?ooo`3oool00000
00<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0Z0?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000070?ooo`00
5`3oool010000000oooo0?ooo`00000i0?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool0;P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool00000;@3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000001`3oool001L0oooo00@000000?ooo`3oool00000>@3oool01000
0000oooo0?ooo`0000020?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool00P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000002d0oooo00<000000?ooo`3oool0
1@3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo02`0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01@3oool0
01L0oooo00@000000?ooo`3oool00000=@3oool4000000<0oooo00@000000?ooo`3oool00000<03o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
0000;@3oool010000000oooo0?ooo`3oool4000000<0oooo00@000000?ooo`3oool00000:`3oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000070?ooo`005`3oool010000000oooo0?ooo`00000e0?ooo`030000003oool0oooo00@0
oooo00@000000?ooo`3oool00000;`3oool2000000@0oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000/0?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`040000003o
ool0oooo000002/0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000001`3oool001P0oooo0P00000f0?ooo`D000000`3oool20000
0340oooo00<000000?ooo`3oool00`3oool2000000@0oooo0P00000^0?ooo`040000003oool0oooo
0?ooo`D000000`3oool2000002d0oooo0`0000040?ooo`800000103oool2000000P0oooo003o0?oo
oaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo000C0?ooooh00000203oool0
01<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00<0oooo00<0001o0?ooo`0007l00`3oool00`000000oooo0?ooo`090?ooo`030000000007l0oooo
00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo
00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0
oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0
oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0
oooo0000O`0?0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0
oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo
0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo
0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000OaH0oooo
00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?oo
o`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?oo
o`0?0?ooo`030000O`3oool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C
0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E
0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`09
0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?
0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o
0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool2000000@0oooo00<0001o0?oo
o`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?oo
o`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0001o0?oo
o`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E0?oo
o`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00P3oool2000000P0oooo000C0?ooo`03
0000003oool0oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`03
0000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`03
0000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80
001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000
O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000
O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000
O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000OaH0oooo00<0001o0?ooo`3oool0
5@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool0
1P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3o
ool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3o
ool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3o
ool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3o
ool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0
oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0
oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0
oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o5P3oool0
0`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool0
0`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo
02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo
01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo
00l0oooo00<0001o0?ooo`0007l03`3oool20000OaH0oooo00<0001o0?ooo`3oool05@3oool00`00
07l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0
oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0
oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0
oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0
oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0
oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`800000103oool00`0007l0oooo
0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo
0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo
0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo
00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`020?ooo`800000203oool001<0oooo00<0
00000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0
001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P00
07lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?oo
o`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o
0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o
0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0001o
0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E
0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`06
0?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?oo
o`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?oo
o`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?oo
o`0007l03`3oool20000OaH0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?oo
o`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3o
ool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3o
ool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3o
ool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P0007lF0?ooo`03
0000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`03
0000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0
;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0
5@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool0
3`3oool00`0007l0oooo0000O`0?0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000
O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3o
ool2000000@0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3o
ool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3o
ool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o5P3o
ool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00P3o
ool2000000P0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0;P3oool0
0`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool0
0`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool0
0`0007l0oooo0000O`0?0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0
oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`00
07l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`00
07l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000
OaH0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo
00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0
oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0
oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0
oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0
oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0
oooo000<0?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo
00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo
00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo
00<0001o0?ooo`0007l03`3oool20000OaH0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo
0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool000d0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0
001o0?ooo`0007l03`3oool20000OaH0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?oo
o`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool000@0oooo1@000000
0`3oool0000000000003000000@0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^
0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E
0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?
0?ooo`030000O`3oool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o
0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000:0?oo
o`040000003oool0oooo000000D0oooo0`0000030?ooo`030000O`3oool0oooo02h0oooo00<0001o
0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o
0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00P0oooo0P000?l5
0?ooo`030000O`3oool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o
0?ooo`3oool02@3oool00`0007l0oooo0?ooo`020?ooo`800000203oool000/0oooo00<000000?oo
o`0000001@3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?oo
o`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?oo
o`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00P0oooo0P000?l50?oo
o`030000O`3oool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?oo
o`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000<0?ooo`80
00001@3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3o
ool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3o
ool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00P0oooo0P000?l50?ooo`03
0000O`3oool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3o
ool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000=0?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000
O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000
O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`080?ooo`80003o
1@3oool00`0007l0oooo0000O`0?0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000
O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3o
ool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3o
ool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3o
ool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00P0oooo0P000?l50?ooo`030000O`3o
ool0001o00l0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3o
ool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0
oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0
oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0
oooo00T0oooo00<0001o0?ooo`3oool01`3oool2003jVP80003o103oool00`0007l0oooo0000O`0?
0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o
0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool2000000@0oooo00<0001o0?oo
o`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?oo
o`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0001o0?oo
o`3oool01`3oool2003jVP80003o103oool00`0007l0oooo0000O`0?0?ooo`80001o5P3oool00`00
07l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00P3oool20000
00P0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0
oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0
oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool01`3oool3003jVP03
0000o`3oool0oooo0080oooo00<0001o0?ooo`0007l03`3oool20000OaH0oooo00<0001o0?ooo`3o
ool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3o
ool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000
O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000
O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`070?ooo`<00?ZJ
00<0003o0?ooo`3oool00P3oool00`0007l0oooo0000O`0?0?ooo`80001o5P3oool00`0007l0oooo
0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00L0oooo0`00
nYX00`000?l0oooo0?ooo`020?ooo`040000O`3oool0001o0?ooo`80003o303oool20000OaH0oooo
00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?oo
o`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?oo
o`060?ooo`@00?ZJ00<0003o0?ooo`3oool00P3oool0100007l0oooo0000O`3oool20000o``0oooo
0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo
0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0
001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0
001o0?ooo`3oool01P3oool4003jVP030000o`3oool0oooo0080oooo00@0001o0000o`000?l0oooo
0P000?l<0?ooo`80001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo
00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo0?oo
o`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?oo
o`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?oo
o`090?ooo`030000O`3oool0oooo00H0oooo1000nYX00`000?l0oooo0?ooo`020?ooo`040000O`00
0?l0003o0?ooo`80003o303oool20000OaH0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo
0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo0P00
00040?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?oo
o`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?oo
o`040?ooo`80003o0`3oool00`0007l0oooo0?ooo`060?ooo`@00?ZJ00<0003o0?ooo`3oool00P00
nYX0100007l0003o0000o`3oool20000o``0oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo
00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`020?ooo`800000203oool001<0oooo00<0
00000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0
001o0?ooo`3oool0103oool20000o`<0oooo00<0001o0?ooo`3oool01P3oool4003jVP030000o`3o
ool0oooo00800?ZJ00@0001o0000o`000?l0oooo0P000?l<0?ooo`80001o5P3oool00`0007l0oooo
0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`040?ooo`80003o0`3oool00`0007l0oooo0?oo
o`060?ooo`@00?ZJ00<0003o0?ooo`3oool00P00nYX0100007l0003o0000o`3oool20000o``0oooo
0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo
0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0
001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00@0oooo0P00
0?l30?ooo`030000O`3oool0oooo00H0oooo1@00nYX20?ooo`@00?ZJ10000?l<0?ooo`80001o5P3o
ool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3o
ool00`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0
oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0
oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`040?ooo`80003o0`3oool0
0`0007l0oooo0?ooo`050?ooo`<00?ZJ00<0003o003jVP00nYX00P3oool4003jVPD0003o2`3oool2
0000OaH0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0
oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`00
07l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`00
07l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool0103oool20000
o`<0oooo00<0001o0?ooo`3oool01@3oool2003jVP80003o0P00nYX20?ooo`@00?ZJ1@000?l;0?oo
o`80001o5P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?oo
o`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool2000000@0oooo00<0001o0?ooo`3o
ool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3o
ool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00@0oooo0P000?l30?ooo`03
0000O`3oool0oooo00D0oooo0P00nYX20000o`800?ZJ00<0003o0?ooo`00nYX00`00nYX50000o`/0
oooo0P0007lF0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0
oooo0?ooo`020?ooo`800000203oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo
0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo
0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool0103oool20000o`<0oooo
00<0001o0?ooo`3oool01@3oool2003jVP80003o0P00nYX00`000?l00?ZJ003jVP03003jVPD0003o
2`3oool20000OaH0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000
O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3o
ool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3o
ool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool0103o
ool20000o`<0oooo00<0001o0?ooo`3oool00P3oool20000o`030?ooo`00nYX00?ZJ0080003o0P00
nYX00`000?l00?ZJ003jVP03003jVPD0003o2`3oool20000OaH0oooo00<0001o0?ooo`3oool05@3o
ool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3o
ool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0
oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0
oooo00T0oooo00<0001o0?ooo`3oool0103oool20000o`<0oooo00<0001o0?ooo`3oool00P3oool2
0000o`<00?ZJ00D0003o0?ooo`00nYX00?ZJ0000o`02003jVP030000o`00nYX00?ZJ00D0003o2`3o
ool20000OaH0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3o
ool0oooo00<0oooo00<000000?ooo`3oool01P3oool000X0oooo1@0000040?ooo`030000003oool0
oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0
oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0
oooo00@0oooo0P000?l30?ooo`030000O`3oool0oooo0080oooo0P000?l2003jVP80003o00@0oooo
003jVP00nYX0003o0P00nYX010000?l00?ZJ003jVP00nYX40000o`/0oooo0P0007lF0?ooo`030000
O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000
003oool0oooo00H0oooo000;0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0
0`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0
5@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool0
103oool20000o`<0oooo00<0001o0?ooo`3oool00P3oool20000o`800?ZJ0P000?l0103oool00?ZJ
003jVP000?l2003jVP80003o0P00nYX40000o`80oooo0P00nYX60?ooo`80003o00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`060?ooo`00103oool5000000<0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool0
5@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0
2@3oool00`0007l0oooo0?ooo`040?ooo`80003o00@0oooo0000o`000?l0001o103oool20000o`80
0?ZJ0P000?l0103oool00?ZJ003jVP000?l2003jVP80003o0P00nYX40000o`80oooo0P00nYX60?oo
o`80003o00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo
00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`003@3oool00`000000
oooo0?ooo`030?ooo`<000000`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0
oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0
oooo00<0001o0?ooo`3oool0103oool20000o`040?ooo`00nYX00?ZJ0000O`@0oooo0P000?l2003j
VP80003o00<0oooo003jVP00nYX00`00nYX20000o`800?ZJ10000?l20?ooo`800?ZJ1P3oool20000
o`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?oo
o`030000O`3oool0oooo0080oooo0P0000080?ooo`002P3oool01@000000oooo0?ooo`3oool00000
00@0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo
01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo
00T0oooo00<0001o0?ooo`3oool0103oool2003jVP040?ooo`00nYX00?ZJ0000O`@0oooo0P000?l2
003jVP80003o0P3oool4003jVP80003o0P00nYX40000o`80oooo0P00nYX60?ooo`@0003o5@3oool0
0`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool0
0`000000oooo0?ooo`060?ooo`002P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<00000
0?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o
0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o
0?ooo`3oool0103oool2003jVP040?ooo`00nYX00?ZJ0000O`<0oooo0`000?l2003jVP80003o0P3o
ool3003jVP<0003o0P00nYX40000o`040?ooo`00nYX00?ZJ003jVPH0oooo10000?lE0?ooo`030000
O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000
003oool0oooo00H0oooo000;0?ooo`<000001@3oool00`000000oooo0?ooo`030?ooo`030000O`3o
ool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3o
ool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000o`00
nYX00?ZJ00<00?ZJ00@0001o0?ooo`3oool0oooo0`000?l2003jVP80003o0P3oool2003jVP<0003o
00<0001o003jVP00nYX00P3oool20000o`040?ooo`00nYX00?ZJ003jVPH0oooo10000?lE0?ooo`03
0000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`03
0000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0
;P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0
5@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<0003o003jVP00nYX0
0`00nYX0100007l0oooo0?ooo`3oool30000o`800?ZJ0P000?l50?ooo`80003o00<0001o003jVP00
nYX00P3oool20000o`030?ooo`00nYX00?ZJ00800?ZJ1@3oool40000oaD0oooo00<0001o0?ooo`3o
ool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3o
ool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000
O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000
O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000?l00?ZJ003jVP03003jVP040000
O`3oool0oooo0?ooo`80003o00<0oooo003jVP00nYX00P000?l50?ooo`80003o00D0001o003jVP00
nYX00?ZJ0?ooo`020000o`030?ooo`00nYX00?ZJ00800?ZJ1@3oool40000oaD0oooo00<0001o0?oo
o`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?oo
o`3oool01P3oool001<0oooo0P0000040?ooo`030000O`3oool0oooo0280oooo0P000?l:0?ooo`03
0000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`03
0000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000?l00?ZJ003jVP03003jVP04
0000O`000?l0003o0?ooo`D00?ZJ0P000?l50?ooo`80003o00<0001o0?ooo`00nYX00`00nYX00`00
0?l0oooo003jVP03003jVPD0oooo10000?lE0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?oo
o`3oool02@3oool00`0007l0oooo0?ooo`020?ooo`800000203oool001<0oooo00<000000?ooo`3o
ool00`3oool00`0007l0oooo0?ooo`0R0?ooo`80003o2P3oool00`0007l0oooo0?ooo`0E0?ooo`03
0000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`03
0000O`3oool0oooo00<0oooo00<0003o003jVP00nYX01000nYX20000o`030?ooo`00nYX00?ZJ0080
0?ZJ0`000?l50?ooo`80003o00<0001o0?ooo`00nYX00`00nYX00`000?l0oooo003jVP03003jVPD0
oooo10000?lE0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0
oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo
00<0001o0?ooo`3oool08P3oool20000o`X0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo
0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo
0?ooo`030?ooo`@00?ZJ00<0003o003jVP00nYX00P000?l00`3oool00?ZJ003jVP02003jVP<0003o
1`3oool00`0007l0oooo003jVP03003jVP030000o`00nYX00?ZJ00<00?ZJ1@3oool40000oaD0oooo
00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0R0?ooo`80003o2P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo0P00
nYX30000o`800?ZJ0P000?l5003jVP<0003o1`3oool00`0007l0oooo0000O`03003jVP040000o`00
nYX00?ZJ0?ooo`800?ZJ1@3oool40000oaD0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo
0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<0
00000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0R0?ooo`80003o2P3oool00`0007l0oooo0?oo
o`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?oo
o`090?ooo`030000O`3oool0oooo00<0oooo0P00nYX30000o`800?ZJ0P000?l5003jVP80003o203o
ool00`0007l0oooo0000O`03003jVP040000o`00nYX00?ZJ0?ooo`800?ZJ1@3oool40000oaD0oooo
00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0R0?ooo`80003o2P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo0P00
nYX30000o`800?ZJ0P000?l5003jVP030000o`3oool0oooo00L0oooo00@0001o0?ooo`0007l0oooo
1@00nYX00`3oool00?ZJ003jVP040?ooo`D0003o5@3oool00`0007l0oooo0?ooo`0E0?ooo`030000
O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3o
ool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo0280oooo0P000?l:0?ooo`030000O`3o
ool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3o
ool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool2003jVP<0003o0P00nYX20000o`800?ZJ00<0
003o003jVP00nYX02P3oool00`0007l0oooo0000O`020?ooo`@00?ZJ00<0oooo003jVP00nYX00P00
0?l20?ooo`D0003o5@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0
001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool2000000@0oooo00<0001o
0?ooo`3oool08P3oool20000o`X0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E
0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`03
0?ooo`800?ZJ0`000?l2003jVP80003o0P00nYX00`000?l00?ZJ003jVP0:0?ooo`030000O`3oool0
001o0080oooo1000nYX00`3oool00?ZJ003jVP020000o`80oooo1P000?lD0?ooo`030000O`3oool0
oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`020?ooo`800000203oool0
01<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0R0?ooo`80003o2P3oool00`00
07l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`00
07l0oooo0?ooo`090?ooo`030000O`3oool0oooo0080oooo0`00nYX30000o`800?ZJ00D0003o003j
VP00nYX00?ZJ0000o`0<0?ooo`030000O`3oool0001o0080oooo1000nYX01P3oool00?ZJ003jVP00
nYX0003o0?ooo`L0003o503oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo
00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo0?oo
o`030?ooo`030000O`3oool0oooo0280oooo0P000?l:0?ooo`030000O`3oool0oooo01D0oooo00<0
001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0
001o0?ooo`3oool00P3oool2003jVP@0003o0P00nYX00`000?l00?ZJ003jVP020000o``0oooo00<0
001o0?ooo`0007l00P3oool4003jVP060?ooo`000?l00?ZJ003jVP000?l0oooo1`000?lD0?ooo`03
0000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`03
0000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0
8P3oool20000o`X0oooo00<0001o0?ooo`3oool00P000?lC0?ooo`030000O`3oool0oooo01D0oooo
00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo0080oooo
0P00nYX40000o`800?ZJ00@0003o003jVP00nYX0003o3@3oool00`0007l0oooo0000O`020?ooo`@0
0?ZJ00H0oooo0000o`00nYX00?ZJ0000o`3oool70000oa@0oooo00<0001o0?ooo`3oool05@3oool0
0`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool0
01<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0R0?ooo`80003o00<0oooo0000
o`000?l01`3oool00`0007l0oooo0000o`020000oa<0oooo00<0001o0?ooo`3oool05@3oool00`00
07l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00@0001o0?ooo`3oool0oooo0`00nYX4
0000o`800?ZJ00@0003o003jVP00nYX0003o3@3oool00`0007l0oooo0000O`020?ooo`@00?ZJ0P3o
ool2003jVP040000o`3oool0003o0000o`800?ZJ0`000?lD0?ooo`030000O`3oool0oooo01D0oooo
00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo
000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool08P3oool50000o`L0oooo00<0
001o0?ooo`000?l00P000?lC0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3o
ool00`0007l0oooo0?ooo`070?ooo`80003o00@0001o0?ooo`000?l0003o0P00nYX50000o`D00?ZJ
00<0003o0?ooo`3oool02`3oool00`0007l0oooo0000O`020?ooo`@00?ZJ0P3oool2003jVP040000
o`3oool0003o0000o`800?ZJ0`000?lD0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3o
ool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`800000
103oool00`0007l0oooo0?ooo`0Q0?ooo`H0003o1`3oool00`0007l0oooo0000o`030000oa80oooo
00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00L0oooo
0P000?l0100007l0oooo0000o`000?l2003jVP030000o`3oool0003o0080003o1000nYX20000o`d0
oooo00<0001o0?ooo`0007l00P3oool3003jVP030000o`3oool0oooo00800?ZJ10000?l3003jVP80
003o503oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3o
ool00P3oool2000000P0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0
8@3oool00`000?l00?ZJ003jVP030000o`80oooo0P000?l30?ooo`030000O`3oool0003o00<0003o
4P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0
1`3oool20000o`040000O`3oool0003o0000o`800?ZJ00@0003o0?ooo`000?l0003o0P3oool3003j
VP80003o3@3oool00`0007l0oooo0000O`020?ooo`<00?ZJ00<0003o0?ooo`3oool00P00nYX40000
o`<00?ZJ0P000?lD0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0
oooo00<0001o0?ooo`3oool08@3oool00`000?l00?ZJ003jVP030000o`80oooo0P000?l30?ooo`03
0000O`000?l0003o00<0003o4P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0
oooo00<0001o0?ooo`3oool01P3oool30000o`030000O`3oool0003o00<00?ZJ00@0003o0?ooo`00
0?l0003o0P3oool3003jVP80003o3@3oool00`0007l0oooo0000O`020?ooo`040000o`00nYX00?ZJ
0000o`80oooo0P00nYX40000o`<00?ZJ0P000?lD0?ooo`030000O`3oool0oooo01D0oooo00<0001o
0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?oo
o`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool08@3oool010000?l00?ZJ003jVP00nYX2
0000o`80oooo0P000?l30?ooo`040000O`000?l0003o0?ooo`80003o4P3oool00`0007l0oooo0?oo
o`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool01P3oool30000o`030000O`3o
ool0003o00800?ZJ00<0003o0?ooo`3oool00P000?l20?ooo`<00?ZJ0P000?l=0?ooo`030000O`3o
ool0001o00<0oooo0P00nYX00`000?l0oooo0?ooo`03003jVP<0003o1000nYX00`000?l0oooo0?oo
o`0B0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?oo
o`030?ooo`030000003oool0oooo00H0oooo000<0?ooo`8000001@3oool00`000000oooo0?ooo`03
0?ooo`030000O`3oool0oooo0240oooo00@0003o003jVP00nYX00?ZJ0`000?l00`3oool0003o0000
o`030?ooo`040000O`000?l0003o0?ooo`80003o4P3oool00`0007l0oooo0?ooo`0?0?ooo`80003o
103oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00H0oooo0`000?l00`0007l0oooo
0000o`02003jVP030000o`3oool0oooo0080003o0P3oool2003jVP<0003o3@3oool00`0007l0oooo
0000O`030?ooo`800?ZJ00@0003o0?ooo`3oool0oooo0P00nYX30000o`@00?ZJ00<0003o0?ooo`3o
ool04P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`060?ooo`002`3oool010000000oooo0?ooo`0000040?ooo`03
0000003oool0oooo00<0oooo00<0001o0?ooo`3oool08@3oool010000?l00?ZJ003jVP00nYX30000
o`030?ooo`000?l0003o00<0oooo00@0001o0000o`000?l0oooo0`000?lA0?ooo`030000O`3oool0
oooo00l0oooo0P000?l40?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool01P3oool3
0000o`030000O`00nYX00?ZJ00800?ZJ00<0003o0?ooo`3oool00P000?l20?ooo`800?ZJ0`000?l=
0?ooo`030000O`3oool0001o00<0oooo0P00nYX010000?l0oooo0?ooo`3oool2003jVP80003o1@00
nYX00`000?l0oooo0?ooo`0B0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3o
ool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000;0?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Q0?ooo`030000o`00
nYX00?ZJ00800?ZJ1@000?l30?ooo`030000O`000?l0003o0080oooo0P000?lA0?ooo`030000O`3o
ool0oooo00l0oooo0P000?l40?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool01P3o
ool40000o`<00?ZJ0P000?l20?ooo`80003o0P3oool2003jVP<0003o3@3oool00`0007l0oooo0000
O`030?ooo`800?ZJ00@0003o0?ooo`3oool0oooo0P00nYX20000o`800?ZJ00@0003o003jVP00nYX0
003o503oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`060?ooo`002`3oool010000000oooo0?ooo`0000040?ooo`<0
00000`3oool00`0007l0oooo0?ooo`0H0?ooo`80003o1`3oool00`000?l00?ZJ003jVP02003jVPD0
003o0`3oool00`0007l0003o0000o`020?ooo`80003o4@3oool00`0007l0oooo0?ooo`0?0?ooo`80
003o103oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00D0oooo1@000?l3003jVPP0
oooo0P00nYX30000o`d0oooo00<0001o0?ooo`0007l00`3oool30000o`<0oooo0P00nYX20000o`80
0?ZJ00@0003o003jVP00nYX00?ZJ503oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo
00T0oooo00<0001o0?ooo`3oool00P3oool2000000P0oooo000;0?ooo`040000003oool0oooo0000
00@0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0H0?ooo`80003o1`3oool5003j
VPD0003o0`3oool00`0007l0003o0000o`020?ooo`80003o4@3oool00`0007l0oooo0?ooo`0=0?oo
o`@0003o103oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00D0oooo0P000?l00`3o
ool0003o003jVP02003jVP030000o`3oool0oooo00H0oooo00<0001o0?ooo`000?l00P000?l=0?oo
o`030000O`3oool0001o00<0oooo0`000?l30?ooo`<00?ZJ00<0003o003jVP00nYX00P000?l2003j
VQ@0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo
00<0oooo00<000000?ooo`3oool01P3oool000/0oooo00@000000?ooo`3oool00000103oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0oooo01P0oooo0P000?l00`3oool0003o0000o`020?oo
o`80003o0P00nYX00`000?l00?ZJ003jVP050000o`<0oooo00<0001o0000o`000?l00P3oool20000
oa40oooo00<0001o0?ooo`3oool03@3oool40000o`@0oooo00<0001o0?ooo`3oool05@3oool00`00
07l0oooo0?ooo`050?ooo`80003o00@0oooo0000o`00nYX00?ZJ0P000?l80?ooo`030000O`3oool0
003o0080003o3@3oool00`0007l0oooo0000O`030?ooo`80003o1@3oool2003jVP030000o`00nYX0
0?ZJ0080003o0P00nYXD0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool0
0`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000<0?ooo`8000001@3oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0oooo01P0oooo0P000?l00`3oool0003o0000o`020?oo
o`80003o0P00nYX00`000?l00?ZJ003jVP050000o`<0oooo0`000?l20?ooo`80003o4@3oool00`00
07l0oooo0?ooo`0=0?ooo`@0003o103oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo
00D0oooo0P00nYX0103oool0003o003jVP00nYX20000o`P0oooo00<0001o0?ooo`000?l00P000?l=
0?ooo`030000O`3oool0001o00<0oooo0P000?l50?ooo`800?ZJ00<0oooo003jVP00nYX00P000?l2
003jVQ@0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0
oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`00
07l0oooo0?ooo`0H0?ooo`80003o00<0oooo0000o`000?l00P3oool20000o`800?ZJ00@0003o003j
VP00nYX00?ZJ10000?l30?ooo`80003o0`3oool20000oa40oooo00<0001o0?ooo`3oool03@3oool4
0000o`@0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`050?ooo`800?ZJ00D0oooo
0000o`00nYX00?ZJ0000o`090?ooo`030000O`3oool0003o0080003o3@3oool00`0007l0oooo0000
O`030?ooo`80003o1@3oool2003jVP030?ooo`00nYX00?ZJ0080003o0P00nYXD0?ooo`030000O`3o
ool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003o
ool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0603oool2
0000o`030?ooo`000?l0003o0080oooo0P000?l2003jVP80003o0P00nYX40000o`<0oooo0P000?l3
0?ooo`80003o4@3oool00`0007l0oooo0?ooo`0=0?ooo`@0003o103oool00`0007l0oooo0?ooo`0E
0?ooo`030000O`3oool0oooo00@0oooo0`00nYX01@3oool0003o003jVP00nYX0003o00T0oooo00@0
001o0?ooo`000?l0003o3P3oool00`0007l0oooo0000O`030?ooo`80003o1@3oool2003jVP030?oo
o`00nYX00?ZJ0080003o0P00nYXD0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0
2@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`800000103o
ool00`0007l0oooo0?ooo`0H0?ooo`80003o00<0oooo0000o`000?l00P3oool20000o`800?ZJ0P00
0?l4003jVP80003o0`3oool20000o`<0oooo0P000?lA0?ooo`030000O`3oool0oooo00d0oooo1000
0?l40?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0103oool4003jVP040000o`00
nYX00?ZJ0000o`T0oooo00@0001o0?ooo`000?l0003o3P3oool00`0007l0oooo0000O`030?ooo`80
003o1@3oool5003jVP80003o0P00nYXD0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3o
ool02@3oool00`0007l0oooo0?ooo`020?ooo`800000203oool001<0oooo00<000000?ooo`3oool0
0`3oool00`0007l0oooo0?ooo`050?ooo`80003o4@3oool20000o`030?ooo`000?l0003o0080oooo
0P000?l2003jVP80003o1000nYX20000o`<0oooo0P000?l30?ooo`80003o4@3oool00`0007l0oooo
0?ooo`0=0?ooo`@0003o103oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00@0oooo
1`00nYX00`000?l0oooo0?ooo`070?ooo`040000O`3oool0003o0000o`h0oooo00<0001o0?ooo`00
07l00`3oool20000o`D0oooo00<0003o003jVP00nYX00P00nYX20000o`<00?ZJ4`3oool00`0007l0
oooo0?ooo`0E0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000
oooo0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00D0oooo
0P000?l@0?ooo`80003o0P00nYX20000o`80oooo0P000?l2003jVP80003o1000nYX20000o`<0oooo
0P000?l30?ooo`80003o4@3oool00`0007l0oooo0?ooo`0<0?ooo`D0003o103oool00`0007l0oooo
0?ooo`0E0?ooo`030000O`3oool0oooo00@0oooo1P00nYX20000o`T0oooo00@0001o0?ooo`000?l0
003o3P3oool00`0007l0oooo0000O`030?ooo`80003o1P3oool4003jVP<0003o0P00nYXC0?ooo`03
0000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`03
0000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0
1@3oool20000oa00oooo00@0003o003jVP00nYX00?ZJ1@000?l3003jVP<0003o00<0oooo003jVP00
nYX00P000?l30?ooo`80003o0`3oool20000oa40oooo00<0001o0?ooo`3oool0303oool50000o`@0
oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`040?ooo`H00?ZJ0P000?l90?ooo`04
0000O`3oool0003o0000o`h0oooo00<0001o0?ooo`0007l00`3oool20000o`H0oooo0`00nYX0103o
ool0001o0000O`000?l2003jVQ<0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`09
0?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?oo
o`3oool00`3oool00`0007l0oooo0?ooo`050?ooo`80003o403oool010000?l00?ZJ003jVP00nYX4
0000o`<00?ZJ0P3oool20000o`030?ooo`00nYX00?ZJ00<0003o0P3oool20000o`030?ooo`00nYX0
0?ZJ00800?ZJ4@3oool00`0007l0oooo0?ooo`0<0?ooo`D0003o103oool00`0007l0oooo0?ooo`0>
0?ooo`<0003o103oool00`0007l0oooo0?ooo`040?ooo`H00?ZJ0P000?l90?ooo`040000O`3oool0
003o0000o`h0oooo00<0001o0?ooo`0007l00`3oool20000o`L0oooo0P00nYX0103oool0001o0000
O`000?l3003jVQ80oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?ooo`090?ooo`030000
O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3o
ool00`0007l0oooo0?ooo`050?ooo`80003o403oool010000?l00?ZJ003jVP00nYX40000o`800?ZJ
0`3oool20000o`040?ooo`00nYX00?ZJ003jVP80003o0P3oool20000o`030?ooo`00nYX00?ZJ0080
0?ZJ4@3oool00`0007l0oooo0?ooo`0<0?ooo`D0003o103oool00`0007l0oooo0?ooo`0>0?ooo`<0
003o103oool00`0007l0oooo0?ooo`030?ooo`<00?ZJ00@0oooo003jVP00nYX00?ZJ0P000?l90?oo
o`040000O`3oool0003o0000o`h0oooo00<0001o0?ooo`0007l00`3oool20000o`L0oooo0P00nYX0
1@3oool0001o0000O`3oool0003o00800?ZJ4P3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3o
ool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool0
0`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00@0oooo0`000?l@0?ooo`030000o`00nYX0
0?ZJ00800?ZJ0`000?l2003jVP<0oooo0P000?l0103oool0003o003jVP00nYX20000o`80oooo0P00
0?l5003jVQ40oooo00<0001o0?ooo`3oool0203oool20000o`80oooo0P000?l2003jVP030000o`3o
ool0oooo0080oooo00<0001o0?ooo`3oool03P3oool30000o`@0oooo00<0001o0?ooo`3oool00`3o
ool2003jVP040000o`3oool00?ZJ003jVP<0003o2@3oool0100007l0oooo0000o`000?l>0?ooo`03
0000O`3oool0001o00<0oooo0P000?l:0?ooo`80001o00@0oooo0000o`00nYX00?ZJ4P3oool00`00
07l0oooo0?ooo`0A0?ooo`80003o0P3oool00`0007l0oooo0?ooo`020?ooo`80003o1@3oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`800000103oool00`0007l0
oooo0?ooo`040?ooo`<0003o403oool00`000?l00?ZJ003jVP02003jVP<0003o0P00nYX30?ooo`80
003o00@0oooo0000o`00nYX00?ZJ0P000?l20?ooo`80003o0P00nYX00`3oool00?ZJ003jVP0A0?oo
o`030000O`3oool0oooo00D0oooo0P000?l00`3oool0003o0000o`020?ooo`80003o0P00nYX00`00
0?l0oooo0?ooo`020?ooo`030000O`3oool0oooo00h0oooo0`000?l40?ooo`030000O`3oool0oooo
00<0oooo0P00nYX01@000?l0oooo0?ooo`3oool0001o0080003o2@3oool00`0007l0oooo0?ooo`0?
0?ooo`030000O`3oool0001o00<0oooo0P000?l:0?ooo`80001o00<0oooo0000o`00nYX00P00nYXA
0?ooo`030000O`3oool0oooo00h0oooo0P000?l01P3oool00?ZJ003jVP00nYX0oooo0000O`@0oooo
0P000?l50?ooo`030000O`3oool0oooo0080oooo0P0000080?ooo`004`3oool00`000000oooo0?oo
o`030?ooo`030000O`3oool0oooo00@0oooo0`000?l@0?ooo`D00?ZJ0`000?l2003jVP<0oooo0P00
0?l20?ooo`<00?ZJ00<0003o0?ooo`3oool00P000?l2003jVP030?ooo`00nYX00?ZJ0140oooo00<0
001o0?ooo`3oool01@3oool20000o`030?ooo`000?l0003o0080oooo0P000?l2003jVP030000o`3o
ool0oooo0080oooo00<0001o0?ooo`3oool03P3oool30000o`@0oooo00<0001o0?ooo`3oool00`3o
ool2003jVP050000o`3oool0oooo0?ooo`0007l00P000?l90?ooo`030000O`3oool0oooo00l0oooo
00<0001o0?ooo`0007l00`3oool20000o`X0oooo0P0007l00`3oool0003o0000o`02003jVQ40oooo
00<0001o0?ooo`3oool03P3oool20000o`060?ooo`00nYX00?ZJ003jVP3oool0001o103oool20000
o`80oooo0P000?l00`3oool0001o0?ooo`040?ooo`030000003oool0oooo00H0oooo000C0?ooo`03
0000003oool0oooo00<0oooo00<0001o0?ooo`3oool0103oool30000oa00oooo0P00nYX00`000?l0
0?ZJ003jVP020000o`<00?ZJ0`3oool20000o`80oooo0`00nYX00`000?l0oooo0?ooo`020000o`80
0?ZJ00<0oooo003jVP00nYX04@3oool00`0007l0oooo0?ooo`050?ooo`80003o00<0oooo0000o`00
0?l00P3oool20000o`800?ZJ0P000?l30?ooo`030000O`3oool0oooo00h0oooo0`000?l40?ooo`03
0000O`3oool0oooo00<0oooo0P00nYX01@000?l0oooo0?ooo`3oool0001o00/0oooo00<0001o0?oo
o`3oool03`3oool00`0007l0oooo0000O`030?ooo`80003o2P3oool20000O`030?ooo`000?l0003o
00800?ZJ4@3oool00`0007l0oooo0?ooo`0>0?ooo`80003o00H0oooo003jVP00nYX00?ZJ0?ooo`00
07l40?ooo`80003o0P3oool20000o`030?ooo`0007l0oooo00@0oooo00<000000?ooo`3oool01P3o
ool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`040?ooo`<0003o403oool2
003jVP030000o`00nYX00?ZJ0080003o0P00nYX00`000?l0oooo0?ooo`050?ooo`<00?ZJ00@0003o
0?ooo`3oool0003o0`00nYX0103oool00?ZJ003jVP000?l@0?ooo`030000O`3oool0oooo00D0oooo
0P000?l00`3oool0003o0000o`020?ooo`80003o0P00nYX20000o`<0oooo00<0001o0?ooo`3oool0
3P3oool30000o`@0oooo00<0001o0?ooo`3oool00`3oool2003jVP050000o`3oool0oooo0?ooo`00
07l02`3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00<0oooo0P000?l:0?ooo`80
001o00<0oooo0000o`000?l00P00nYXA0?ooo`030000O`3oool0oooo00h0oooo0P000?l01P3oool0
0?ZJ003jVP00nYX0oooo0000O`@0oooo0P000?l20?ooo`80003o00<0oooo0000O`3oool0103oool0
0`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo
00@0oooo0`000?l@0?ooo`800?ZJ00D0003o003jVP00nYX00?ZJ0000o`02003jVP030000o`3oool0
oooo00H0oooo0P00nYX010000?l0oooo0?ooo`000?l2003jVP80oooo0P00nYX30000o`h0oooo00<0
001o0?ooo`3oool01@3oool2003jVP030?ooo`000?l0003o0080oooo00<0003o003jVP00nYX00P00
nYX01@000?l0oooo0?ooo`3oool0001o0100oooo0`000?l40?ooo`030000O`3oool0oooo00<0oooo
0P00nYX01@000?l0oooo0?ooo`3oool0001o00/0oooo00<0001o0?ooo`3oool03`3oool00`0007l0
oooo0000O`030?ooo`80003o2P3oool20000O`030?ooo`000?l0003o00800?ZJ4@3oool00`0007l0
oooo0?ooo`0>0?ooo`80003o1000nYX00`3oool0001o0?ooo`030?ooo`80003o0P3oool20000o`03
0?ooo`0007l0oooo00@0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool0
0`3oool00`0007l0oooo0?ooo`040?ooo`<0003o2@3oool20000o`D0oooo0P00nYX20000o`800?ZJ
00@0003o003jVP00nYX0003o203oool3003jVP80oooo00<0003o003jVP00nYX00P3oool4003jVP03
0000o`3oool0oooo00`0oooo00<0001o0?ooo`3oool01@3oool2003jVP@0003o00<0oooo0000o`00
nYX00`00nYX01@000?l0oooo0?ooo`3oool0001o0100oooo0`000?l40?ooo`030000O`3oool0oooo
00<0oooo0P00nYX01@000?l0oooo0?ooo`3oool0001o00/0oooo00<0001o0?ooo`3oool03`3oool0
0`0007l0oooo0000O`030?ooo`80003o2P3oool20000O`030?ooo`000?l0003o00800?ZJ0P000?l0
0`3oool0003o0000o`0<0?ooo`030000O`3oool0oooo00T0oooo0P000?l30?ooo`80003o1000nYX0
0`3oool0001o0?ooo`030?ooo`80003o0P3oool20000o`030?ooo`0007l0oooo00@0oooo00<00000
0?ooo`3oool01P3oool001<0oooo0P0000040?ooo`030000O`3oool0oooo00@0oooo10000?l80?oo
o`80003o1@3oool2003jVP80003o1@00nYX00`000?l0oooo0?ooo`070?ooo`800?ZJ0P3oool00`00
0?l00?ZJ003jVP030?ooo`<00?ZJ0P000?l=0?ooo`030000O`3oool0oooo00D0oooo0P00nYX40000
o`030?ooo`000?l00?ZJ00<00?ZJ00D0003o0?ooo`3oool0oooo0000O`0;0?ooo`80003o0`3oool3
0000o`@0oooo00<0001o0?ooo`3oool00`3oool2003jVP050000o`3oool0oooo0?ooo`0007l02`3o
ool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00<0oooo0P000?l:0?ooo`80001o00<0
oooo0000o`000?l00P00nYX20000o`030?ooo`000?l0003o00`0oooo00<0001o0?ooo`3oool02@3o
ool20000o`<0oooo0P000?l4003jVP030?ooo`0007l0oooo00<0oooo0P000?l20?ooo`80003o00<0
oooo0000O`3oool00`3oool2000000P0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o
0?ooo`3oool0103oool40000o`P0oooo0P000?l50?ooo`800?ZJ0P000?l5003jVP030000o`3oool0
oooo00L0oooo0P00nYX20?ooo`030000o`00nYX00?ZJ00<0oooo0`00nYX20000o`d0oooo00<0001o
0?ooo`3oool01@3oool2003jVP@0003o00<0oooo0000o`00nYX00`00nYX01@000?l0oooo0?ooo`3o
ool0001o00/0oooo0P000?l30?ooo`<0003o103oool00`0007l0oooo0?ooo`020?ooo`<00?ZJ103o
ool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3o
ool20000O`030?ooo`000?l0003o00800?ZJ0P000?l00`3oool0003o0000o`030?ooo`80003o1`3o
ool00`0007l0oooo0?ooo`090?ooo`<0003o0P3oool20000o`D00?ZJ00<0001o0?ooo`3oool00P3o
ool20000o`80oooo00@0003o003jVP00nYX0003o1@3oool00`000000oooo0?ooo`060?ooo`004`3o
ool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00@0oooo10000?l80?ooo`80003o0`3o
ool4003jVP80003o00<0oooo003jVP00nYX00P00nYX00`000?l0oooo0?ooo`070?ooo`800?ZJ0P3o
ool3003jVP<0oooo0`00nYX20000o`d0oooo00<0001o0?ooo`3oool0103oool3003jVPH0003o1000
nYX01@000?l0oooo0?ooo`3oool0001o00/0oooo0P000?l30?ooo`<0003o103oool00`0007l0oooo
0?ooo`020?ooo`800?ZJ00<0003o0?ooo`3oool00P3oool00`0007l0oooo0?ooo`090?ooo`030000
O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000O`030?ooo`000?l0003o00<00?ZJ
00@0003o0?ooo`000?l0003o0`3oool20000o`L0oooo00<0001o0?ooo`3oool02@3oool30000o`80
oooo0P000?l2003jVP040000o`00nYX00?ZJ0000O`@0oooo0P000?l20?ooo`040000o`00nYX00?ZJ
0000o`D0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00P3oool2003j
VP80oooo0P000?l20?ooo`@0003o203oool20000o`<0oooo1000nYX20000o`040?ooo`000?l00?ZJ
003jVP80003o2@3oool2003jVP80oooo0P00nYX40?ooo`<00?ZJ0P000?l=0?ooo`030000O`3oool0
oooo00@0oooo0`00nYX60000o`@00?ZJ00D0003o0?ooo`3oool0oooo0000O`0;0?ooo`80003o0`3o
ool30000o`@0oooo00<0001o0?ooo`3oool00P3oool2003jVP030000o`3oool0oooo0080oooo00<0
001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P00
07l0103oool0003o0000o`000?l2003jVP040000o`3oool0003o0000o`<0oooo0P000?l70?ooo`03
0000O`3oool0oooo00T0oooo0`000?l20?ooo`80003o0P00nYX010000?l00?ZJ003jVP0007l40?oo
o`80003o0P3oool010000?l00?ZJ003jVP000?l50?ooo`030000003oool0oooo00H0oooo000:0?oo
o`D00000103oool00`000000oooo0?ooo`020?ooo`800?ZJ0P3oool20000o`80oooo10000?l80?oo
o`80003o0P3oool4003jVP<0003o00<0oooo0000o`000?l00P000?l:0?ooo`800?ZJ0P3oool2003j
VP@0oooo0`00nYX20000o``0oooo0P000?l60?ooo`<00?ZJ1P000?l4003jVP050000o`3oool0oooo
0?ooo`0007l02`3oool20000o`<0oooo0P000?l2003jVP<0oooo00<0001o0?ooo`3oool00P3oool2
003jVP030000o`3oool0oooo0080oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?
0?ooo`030000O`3oool0001o00l0oooo0P0007l30?ooo`050000o`00nYX00?ZJ0000o`3oool00P00
0?l30?ooo`80003o1`3oool00`0007l0oooo0?ooo`090?ooo`@0003o00<0oooo0000o`000?l00P00
nYX010000?l00?ZJ003jVP0007l40?ooo`80003o0P3oool010000?l00?ZJ003jVP00nYX50?ooo`03
0000003oool0oooo00H0oooo000;0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3o
ool00P3oool2003jVP80oooo0P000?l20?ooo`@0003o203oool00`000?l00?ZJ003jVP05003jVP<0
003o00<0oooo0000o`000?l00P000?l:0?ooo`800?ZJ0P3oool2003jVP@0oooo0`00nYX20000o``0
oooo0P000?l60?ooo`@00?ZJ10000?l5003jVP050000o`3oool0oooo0?ooo`0007l02P3oool2003j
VP040000o`3oool0oooo0?ooo`80003o0`00nYX00`3oool0003o0000o`020000o`80oooo0P00nYX0
0`000?l0oooo0?ooo`020?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool0
0`0007l0oooo0000O`0?0?ooo`80001o0`3oool01@000?l00?ZJ003jVP000?l0oooo00@0003o00<0
oooo0000o`000?l01`3oool00`0007l0oooo0?ooo`090?ooo`@0003o00<0oooo0000o`00nYX00P00
nYX010000?l00?ZJ003jVP0007l20?ooo`@0003o0P3oool010000?l00?ZJ003jVP00nYX50?ooo`03
0000003oool0oooo00H0oooo000<0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
0P3oool3003jVP050?ooo`000?l0003o0?ooo`000?l00P00nYX20000o`P0oooo2000nYX30000o`03
0?ooo`000?l0003o0080003o2P3oool2003jVP80oooo0P00nYX40?ooo`@00?ZJ00<0003o0?ooo`3o
ool02P3oool20000o`H0oooo1000nYX40000o`800?ZJ00@0oooo003jVP00nYX00?ZJ0`3oool00`00
07l0oooo0?ooo`080?ooo`800?ZJ00@0003o0?ooo`3oool0oooo0P000?l3003jVP030?ooo`000?l0
003o0080003o0P3oool2003jVP030000o`3oool0oooo0080oooo00<0001o0?ooo`3oool02@3oool0
0`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P0007l40?ooo`800?ZJ1P000?l0
0`3oool0003o0000o`070?ooo`030000O`3oool0oooo00T0oooo10000?l0103oool0003o003jVP00
nYX20000o`800?ZJ00<0001o0?ooo`3oool010000?l20?ooo`040000o`00nYX00?ZJ003jVPD0oooo
00<000000?ooo`3oool01P3oool000d0oooo00<000000?ooo`3oool00`3oool3000000<0oooo0P00
nYX01@3oool0003o0000o`3oool0003o00800?ZJ0P000?l80?ooo`800?ZJ00<0003o003jVP00nYX0
0P3oool20000o`<0oooo10000?l:0?ooo`<00?ZJ00<0oooo003jVP00nYX0103oool4003jVP030000
o`3oool0oooo00X0oooo0P000?l60?ooo`@00?ZJ00@0003o0?ooo`000?l0003o0P00nYX20?ooo`80
0?ZJ0`3oool00`0007l0oooo0?ooo`080?ooo`800?ZJ00@0003o0?ooo`3oool0oooo0P000?l3003j
VP030?ooo`000?l0003o00<0003o0`00nYX00`000?l0oooo0?ooo`020?ooo`030000O`3oool0oooo
00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o103oool2003j
VP030000o`00nYX00?ZJ00H0003o1`3oool00`0007l0oooo0?ooo`090?ooo`@0003o1000nYX20000
o`800?ZJ00<0001o0?ooo`3oool010000?l20?ooo`<00?ZJ00<0003o0?ooo`3oool00P3oool20000
00P0oooo000:0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`030?oo
o`800?ZJ00D0oooo0000o`000?l0oooo0000o`03003jVP030000o`3oool0oooo00H0oooo0P00nYX2
0000o`<0oooo0P000?l30?ooo`@0003o2P3oool010000?l00?ZJ003jVP3oool2003jVP@0oooo0P00
0?l2003jVP030000o`3oool0oooo00X0oooo0P000?l60?ooo`@00?ZJ00@0003o0?ooo`000?l0003o
0P00nYX20?ooo`800?ZJ0`3oool00`0007l0oooo0?ooo`080?ooo`800?ZJ0`000?l00`3oool0003o
0000o`03003jVP030?ooo`000?l0003o00<0003o0P00nYX20000o`@0oooo00<0001o0?ooo`3oool0
2@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P0007l40?ooo`D00?ZJ
1P000?l00`3oool0003o0000o`040?ooo`030000O`3oool0oooo00T0oooo0P00nYX20000o`@00?ZJ
0P000?l2003jVP030000O`3oool0oooo00@0003o0P3oool2003jVP80003o1@3oool00`000000oooo
0?ooo`060?ooo`002P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0
0`3oool3003jVP80003o00<0oooo0000o`00nYX00P00nYX00`000?l0oooo0?ooo`030?ooo`800?ZJ
00<0oooo003jVP00nYX00P000?l20?ooo`<0003o0`3oool40000o`X0oooo00@0003o003jVP00nYX0
oooo0P00nYX40?ooo`80003o0P00nYX00`000?l0oooo0?ooo`0:0?ooo`030000o`00nYX00?ZJ00D0
oooo1000nYX010000?l0oooo0?ooo`000?l2003jVP80oooo0P00nYX30?ooo`040000O`3oool0oooo
0?ooo`80003o1@3oool2003jVP<0003o00<0oooo0000o`00nYX01000nYX50000o`800?ZJ0P000?l4
0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?
0?ooo`80001o103oool5003jVPH0003o00<0oooo0000o`000?l0103oool00`0007l0oooo0?ooo`09
0?ooo`800?ZJ0P000?l4003jVP80003o0P00nYX00`0007l0oooo0?ooo`040000o`80oooo0P00nYX2
0000o`D0oooo00<000000?ooo`3oool01P3oool000/0oooo0`0000050?ooo`030000003oool0oooo
00<0oooo00<0001o003jVP00nYX00P000?l00`3oool00?ZJ003jVP02003jVP030000o`3oool0oooo
00<0oooo0P00nYX00`3oool00?ZJ003jVP020000o`80oooo0P000?l40?ooo`@0003o2P3oool01000
0?l00?ZJ003jVP3oool2003jVP@0oooo0P000?l2003jVP030000o`3oool0oooo00@0oooo0P000?l4
0?ooo`030000o`00nYX00?ZJ00D0oooo1000nYX30?ooo`<00?ZJ0P3oool2003jVP<0oooo00@0001o
0?ooo`3oool0oooo0P000?l50?ooo`800?ZJ0`000?l01@3oool00?ZJ003jVP00nYX0003o00800?ZJ
0P000?l20?ooo`030000o`00nYX00?ZJ0080003o103oool00`0007l0oooo0?ooo`090?ooo`030000
O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000O`@0oooo00<0003o003jVP00nYX0
0P00nYX60000o`030?ooo`000?l0003o00@0oooo00<0001o0?ooo`3oool02@3oool2003jVP80003o
0`00nYX00`000?l0oooo0000o`02003jVP030000O`3oool0oooo00@0003o0P3oool2003jVP80003o
1@3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`040000O`00
nYX00?ZJ0000o`H00?ZJ00<0003o0?ooo`3oool00`3oool5003jVP80003o0P3oool20000o`H0oooo
0P000?l:0?ooo`030000o`00nYX00?ZJ00<00?ZJ103oool20000o`800?ZJ0P000?l50?ooo`80003o
0`3oool010000?l00?ZJ003jVP00nYX50?ooo`@00?ZJ0`3oool2003jVP<0oooo0P00nYX30?ooo`04
0000O`3oool0oooo0?ooo`80003o103oool3003jVP<0003o00D0oooo003jVP00nYX00?ZJ0000o`02
003jVP80003o0P3oool3003jVP80003o103oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0
oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000O`H0oooo00<0003o003jVP00nYX01P000?l0
0`3oool0003o0000o`040?ooo`030000O`3oool0oooo00T0oooo0P00nYX20000o`<00?ZJ00<0003o
0?ooo`000?l00P00nYX00`0007l0oooo0?ooo`040000o`80oooo0P00nYX20000o`D0oooo00<00000
0?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool0100007l00?ZJ003jVP000?l6
003jVP<0003o0`3oool4003jVP<0003o0P3oool20000o`H0oooo0P000?l:0?ooo`030000o`00nYX0
0?ZJ00800?ZJ00<0003o0?ooo`3oool00P3oool20000o`800?ZJ0P000?l0103oool0003o0000o`3o
ool30000o`<0oooo00@0003o003jVP00nYX00?ZJ103oool6003jVP80oooo0P00nYX30?ooo`800?ZJ
0`3oool0100007l0oooo0?ooo`3oool20000o`@0oooo1000nYX20000o`050?ooo`00nYX00?ZJ003j
VP000?l00P00nYX20000o`80oooo0P00nYX30000o`@0oooo00<0001o0?ooo`3oool02@3oool00`00
07l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P0007l60?ooo`030000o`00nYX00?ZJ
00H0003o00<0oooo0000o`000?l0103oool00`0007l0oooo0?ooo`080?ooo`050000o`00nYX00?ZJ
003jVP000?l00P00nYX20000o`030?ooo`000?l00?ZJ00800?ZJ0P3oool50000o`050?ooo`00nYX0
0?ZJ0000o`0007l01@3oool00`000000oooo0?ooo`060?ooo`004`3oool2000000@0oooo00@0001o
003jVP00nYX0003o1P00nYX30000o`<0oooo1000nYX30000o`80oooo0P000?l60?ooo`80003o2P3o
ool00`000?l00?ZJ003jVP02003jVPD0oooo0P000?l2003jVP80003o00@0oooo0000o`000?l0oooo
0`000?l30?ooo`040000o`00nYX00?ZJ003jVP@0oooo0P00nYX20000o`800?ZJ0P3oool2003jVP<0
oooo0P00nYX0103oool0003o0000o`0007l30?ooo`80003o103oool4003jVP80003o00D0oooo003j
VP00nYX00?ZJ0000o`02003jVP040000o`0007l0oooo0?ooo`800?ZJ0P000?l50?ooo`030000O`3o
ool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o1P3o
ool00`000?l00?ZJ003jVP090000o`@0oooo00<0001o0?ooo`3oool0203oool01@000?l00?ZJ003j
VP00nYX0003o00800?ZJ0P000?l00`3oool0003o0000o`02003jVP80oooo1@000?l01@3oool00?ZJ
003jVP000?l0001o00@0oooo0P0000080?ooo`004`3oool00`000000oooo0?ooo`030?ooo`040000
O`00nYX00?ZJ0000o`L00?ZJ0P000?l30?ooo`@00?ZJ0`000?l20?ooo`80003o1P3oool20000o`X0
oooo00<0003o003jVP00nYX00P00nYX70?ooo`800?ZJ0P000?l00`3oool0003o0000o`02003jVP80
003o0`3oool00`000?l00?ZJ003jVP02003jVP80oooo0`00nYX20000o`<00?ZJ00<0oooo003jVP00
nYX00`3oool2003jVP040?ooo`000?l0003o0000O`<0oooo0P000?l40?ooo`@00?ZJ0`000?l3003j
VP050000o`00nYX00?ZJ0000o`0007l00P3oool2003jVPL0oooo00<0001o0?ooo`3oool02@3oool0
0`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P0007l60?ooo`040000o`00nYX0
0?ZJ003jVPP0003o00D0oooo0000o`000?l0oooo0000O`0:0?ooo`L00?ZJ0P000?l00`3oool0003o
0000o`02003jVP80oooo0P000?l2003jVP060000o`3oool00?ZJ003jVP000?l0001o1@3oool00`00
0000oooo0?ooo`060?ooo`004`3oool00`000000oooo0?ooo`030?ooo`040000O`00nYX00?ZJ0000
o`@00?ZJ00<0oooo003jVP00nYX00P000?l30?ooo`@00?ZJ10000?l00`3oool0003o0000o`060?oo
o`80003o2P3oool20000o`<00?ZJ1`3oool3003jVP040000o`3oool0003o0000o`800?ZJ0P000?l3
0?ooo`D00?ZJ0P3oool3003jVP030000o`3oool0oooo00800?ZJ00<0oooo003jVP00nYX00`3oool2
003jVP040?ooo`000?l0003o0000O`80oooo0`000?l40?ooo`@00?ZJ0`000?l2003jVP80003o0`00
nYX00`0007l0oooo0?ooo`02003jVPL0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?oo
o`0?0?ooo`030000O`3oool0001o00l0oooo0P0007l60?ooo`80003o0P00nYX80000o`050?ooo`00
0?l0003o0?ooo`0007l02P3oool6003jVP040000o`3oool0oooo0?ooo`80003o0P00nYX20?ooo`80
003o0P00nYX01P000?l0oooo003jVP00nYX0003o0000O`D0oooo00<000000?ooo`3oool01P3oool0
01<0oooo00<000000?ooo`3oool00`3oool00`0007l00?ZJ003jVP05003jVP030?ooo`00nYX00?ZJ
0080003o0P3oool5003jVP@0003o00<0oooo0000o`000?l01P3oool20000o`X0oooo0P000?l3003j
VPP0oooo0P00nYX010000?l0oooo0000o`000?l3003jVP040000o`3oool0oooo0?ooo`800?ZJ00<0
003o003jVP00nYX01@00nYX00`000?l0oooo0?ooo`05003jVP<0oooo0P00nYX0103oool0003o0000
o`0007l20?ooo`<0003o103oool4003jVP<0003o0P00nYX30000o`800?ZJ00<0001o0?ooo`3oool0
0P00nYX70?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo
0000O`0?0?ooo`80001o1P3oool20000o`800?ZJ2`000?l00`3oool0001o0?ooo`090?ooo`H00?ZJ
00@0003o0?ooo`3oool0oooo0P000?l2003jVP80oooo1000nYX01P000?l0oooo003jVP00nYX0003o
0000O`D0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`00
07l0oooo003jVP04003jVP040000o`3oool00?ZJ003jVP<0003o00<0oooo003jVP00nYX02P000?l6
0?ooo`80003o2P3oool20000o`<00?ZJ203oool2003jVP040000o`3oool0003o0000o`<00?ZJ0`00
0?l0103oool00?ZJ003jVP000?l7003jVP030000o`3oool0oooo00@00?ZJ103oool3003jVP80003o
00<0001o0?ooo`3oool00`000?l30?ooo`D00?ZJ0`000?l2003jVP<0003o0P00nYX00`0007l0oooo
0?ooo`02003jVPL0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000
O`3oool0001o00l0oooo0P0007l60?ooo`80003o0P00nYX;0000o`030?ooo`0007l0oooo00@0oooo
0P000?l30?ooo`H00?ZJ00@0003o0?ooo`3oool0oooo0P000?l2003jVP80oooo1000nYX01P000?l0
oooo003jVP00nYX0003o0000O`D0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?oo
o`3oool00`3oool00`0007l0oooo003jVP04003jVP030000o`3oool00?ZJ00800?ZJ0P000?l00`3o
ool00?ZJ003jVP0:0000o`H0oooo0P000?l:0?ooo`<0003o0P00nYX80?ooo`<00?ZJ0`000?l3003j
VP<0003o00@0oooo003jVP00nYX0003o1`00nYX00`000?l0oooo0?ooo`04003jVP@0oooo00<0003o
003jVP00nYX00P000?l00`0007l0oooo0?ooo`030000o`<0oooo0P00nYX01@000?l00?ZJ003jVP3o
ool0003o00<00?ZJ0`3oool2003jVP030000O`3oool00?ZJ00800?ZJ1`3oool00`0007l0oooo0?oo
o`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000O`L0oooo00<0
003o003jVP00nYX02`000?l00`3oool0001o0?ooo`040?ooo`80003o0`3oool6003jVP040000o`3o
ool0oooo0?ooo`80003o0P00nYX20?ooo`@00?ZJ00H0003o0?ooo`00nYX00?ZJ0000o`0007l50?oo
o`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`00
nYX01000nYX00`000?l0oooo003jVP02003jVP80003o00<0oooo003jVP00nYX02P000?l60?ooo`80
003o2`3oool40000o`T0oooo0`00nYX20000o`@00?ZJ0P000?l3003jVP030000o`00nYX00?ZJ0080
0?ZJ0P3oool20000o`80oooo1000nYX40?ooo`030000o`00nYX00?ZJ0080003o00<0001o0?ooo`3o
ool00`000?l30?ooo`800?ZJ00D0003o003jVP00nYX0oooo0000o`02003jVP@0oooo0P00nYX01000
07l0oooo003jVP00nYX80?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool0
0`0007l0oooo0000O`0?0?ooo`80001o1`3oool010000?l00?ZJ003jVP00nYX:0000o`030?ooo`00
07l0oooo00@0oooo0P000?l20?ooo`L00?ZJ00@0003o0?ooo`3oool0oooo0P000?l3003jVP030?oo
o`00nYX00?ZJ00800?ZJ00H0003o0?ooo`00nYX00?ZJ0000o`0007l50?ooo`030000003oool0oooo
00H0oooo000C0?ooo`800000103oool00`0007l0003o003jVP02003jVP<0003o0P3oool2003jVP80
003o00<0oooo003jVP00nYX02P000?l60?ooo`80003o2`3oool40000o`T0oooo00@0003o003jVP00
nYX0003o1@00nYX20000o`800?ZJ0`000?l01@3oool0003o0000o`000?l0oooo0080003o0P3oool4
003jVP@0oooo00<0003o003jVP00nYX00P000?l00`0007l0oooo0?ooo`030000o`80oooo0`00nYX0
1@000?l00?ZJ003jVP3oool0003o00800?ZJ103oool2003jVP040000O`3oool00?ZJ003jVPP0oooo
00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo
0P0007l70?ooo`030000o`00nYX00?ZJ00800?ZJ00<0003o0?ooo`000?l01P000?l00`3oool0001o
0?ooo`040?ooo`80003o0P3oool3003jVP050?ooo`00nYX00?ZJ003jVP000?l00`3oool30000o`80
0?ZJ00<0oooo003jVP00nYX00P00nYX01P000?l00?ZJ003jVP00nYX0003o0000O`@0oooo0P000008
0?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`000?l00?ZJ00800?ZJ0`000?l20?oo
o`<00?ZJ00@0003o0?ooo`00nYX00?ZJ2P000?l60?ooo`80003o2`3oool40000o`T0oooo00@0003o
003jVP00nYX0003o0P00nYX00`000?l00?ZJ003jVP020000o`800?ZJ0`000?l01@3oool0003o0000
o`000?l0oooo0080003o0`3oool3003jVPD0oooo0P00nYX90000o`050?ooo`00nYX00?ZJ0?ooo`00
0?l00P00nYX0103oool0003o003jVP00nYX40?ooo`H00?ZJ203oool00`0007l0oooo0?ooo`090?oo
o`030000O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000O`L0oooo00<0003o003j
VP00nYX00P00nYX00`000?l0oooo0000o`060000o`030?ooo`0007l0oooo00@0oooo0P000?l20?oo
o`800?ZJ00<0003o0?ooo`00nYX00P00nYX40?ooo`<0003o0P00nYX00`3oool00?ZJ003jVP05003j
VP80oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000
oooo0?ooo`030?ooo`80003o0`00nYX30000o`<0oooo0P00nYX010000?l0oooo003jVP00nYX:0000
o`H0oooo0P000?l;0?ooo`@0003o2@3oool00`000?l00?ZJ003jVP03003jVP030000o`00nYX00?ZJ
0080003o0P00nYX30000o`030?ooo`000?l0003o00@0003o0`3oool3003jVPD0oooo1000nYX70000
o`030?ooo`00nYX00?ZJ0080003o0P00nYX0103oool0003o003jVP00nYX40?ooo`H00?ZJ203oool0
0`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool2
0000O`L0oooo0`000?l5003jVP80003o0P00nYX20000o`030?ooo`0007l0oooo00@0oooo0P000?l0
1P3oool00?ZJ003jVP00nYX0003o0?ooo`800?ZJ00<0003o0?ooo`3oool00P3oool30000o`800?ZJ
00<0oooo003jVP00nYX01@00nYX20?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool0
1P3oool001<0oooo00<000000?ooo`3oool00P3oool40000o`800?ZJ0`000?l30?ooo`<00?ZJ00<0
oooo003jVP00nYX01`000?lF0?ooo`@0003o2@3oool20000o`@00?ZJ00<0003o003jVP00nYX00P00
0?l2003jVP030?ooo`000?l0003o00H0003o103oool3003jVPD0oooo1000nYX70000o`030?ooo`00
nYX00?ZJ0080003o1P00nYX50?ooo`D00?ZJ203oool00`0007l0oooo0?ooo`090?ooo`030000O`3o
ool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000O`L0oooo10000?l4003jVP80003o0P00
nYX20000o`030?ooo`0007l0oooo00@0oooo0P000?l00`3oool00?ZJ003jVP020000o`T0oooo0P00
0?l2003jVP030?ooo`00nYX00?ZJ00D00?ZJ0P3oool00`0007l0oooo0?ooo`030?ooo`030000003o
ool0oooo00H0oooo000C0?ooo`030000003oool0oooo0080oooo2@000?l30?ooo`H00?ZJ1`000?lF
0?ooo`@0003o2@3oool20000o`@00?ZJ00<0003o003jVP00nYX00P000?l2003jVP030?ooo`000?l0
003o00H0003o103oool2003jVPH0oooo1000nYX20000o`800?ZJ0`000?l00`3oool00?ZJ003jVP02
0000o`030?ooo`00nYX00?ZJ00<00?ZJ1@3oool4003jVPT0oooo00<0001o0?ooo`3oool02@3oool0
0`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P0007l90?ooo`80003o1@00nYX0
1`000?l00?ZJ003jVP00nYX0003o0?ooo`0007l01@3oool20000o`030?ooo`00nYX00?ZJ0080003o
2@3oool20000o`X00?ZJ0P3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo
000C0?ooo`030000003oool0oooo00<0oooo00<0001o0000o`000?l010000?l60?ooo`@00?ZJ00<0
oooo0000o`000?l06P3oool40000o`T0oooo0P000?l4003jVP030000o`00nYX00?ZJ0080003o0P00
nYX00`3oool0003o0000o`060000o`@0oooo0P00nYX60?ooo`80003o0P00nYX20000o`<00?ZJ0P00
0?l00`3oool00?ZJ003jVP020000o`030?ooo`00nYX00?ZJ00<00?ZJ1@3oool4003jVPT0oooo00<0
001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo0P00
07l90?ooo`80003o0`3oool2003jVP070000o`00nYX00?ZJ003jVP000?l0oooo0000O`040?ooo`<0
003o00<0oooo003jVP00nYX00P000?l90?ooo`<0003o2@00nYX20?ooo`030000O`3oool0oooo00<0
oooo00<000000?ooo`3oool01P3oool001<0oooo0P0000040?ooo`030000O`000?l0003o00@0003o
1P3oool4003jVP030?ooo`000?l0003o01X0oooo10000?l90?ooo`<0003o0P00nYX20000o`800?ZJ
00D0003o003jVP00nYX00?ZJ0?ooo`080000o`@0oooo0P00nYX60?ooo`80003o0P00nYX20000o`@0
0?ZJ00@0003o0?ooo`00nYX00?ZJ0P000?l0103oool00?ZJ003jVP00nYX20000o`D0oooo0P00nYX;
0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?
0?ooo`80001o2@3oool20000o`<0oooo1P00nYX00`000?l0oooo0000O`040?ooo`<0003o00@0oooo
003jVP00nYX0003o2P3oool30000o`T00?ZJ0P3oool00`0007l0oooo0?ooo`020?ooo`800000203o
ool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0000o`040000o`H0oooo1000nYX0
0`3oool0003o0000o`0J0?ooo`@0003o2@3oool70000o`D00?ZJ00<0003o0?ooo`000?l01`000?l<
0?ooo`80003o0`00nYX00`000?l00?ZJ003jVP02003jVP040000o`3oool00?ZJ003jVP80003o00<0
oooo003jVP00nYX00`000?l50?ooo`800?ZJ2`3oool00`0007l0oooo0?ooo`090?ooo`030000O`3o
ool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000O`T0oooo0P000?l30?ooo`L00?ZJ00<0
oooo0000O`3oool00`3oool30000o`<00?ZJ00<0003o0?ooo`3oool0203oool30000o`T00?ZJ0P3o
ool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0
oooo00<0oooo00<0001o0?ooo`000?l010000?l60?ooo`@00?ZJ7@3oool40000o`T0oooo1P000?l2
0?ooo`@00?ZJ00<0003o0?ooo`000?l00`000?l0103oool0003o0000o`000?l?0?ooo`800?ZJ00<0
003o003jVP00nYX00`00nYX0103oool00?ZJ003jVP000?l20?ooo`800?ZJ0`000?l60?ooo`030000
O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000
O`3oool0001o00l0oooo0P0007l90?ooo`80003o0`3oool01@000?l00?ZJ003jVP00nYX0oooo0080
0?ZJ00<0oooo0000O`3oool00`3oool30000o`800?ZJ0P000?l;0?ooo`80003o1@00nYX40000o`80
oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0003o00@0003o1P3oool3003jVP030000o`3oool0oooo01/0oooo
10000?l90?ooo`H0003o0P3oool4003jVP80oooo10000?l00`3oool0003o0000o`0@0?ooo`D00?ZJ
00@0oooo003jVP00nYX0oooo0P00nYX30?ooo`800?ZJ0`000?l60?ooo`030000O`3oool0oooo00T0
oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0
oooo0P0007l90?ooo`80003o0`3oool01@000?l00?ZJ003jVP00nYX0oooo00800?ZJ00<0003o0000
O`3oool00`3oool30000o`800?ZJ0P000?l;0?ooo`80003o1@00nYX40000o`80oooo00<0001o0?oo
o`3oool00`3oool00`000000oooo0?ooo`060?ooo`00303oool3000000@0oooo00<000000?ooo`3o
ool00`3oool00`0007l0oooo0000o`040000o`L0oooo0P00nYX00`000?l0oooo0?ooo`0K0?ooo`@0
003o2@3oool60000o`80oooo1000nYX20?ooo`@0003o00<0oooo0000o`000?l0403oool4003jVP05
0000o`3oool00?ZJ003jVP000?l00P00nYX60?ooo`80003o1P3oool00`0007l0oooo0?ooo`090?oo
o`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?oo
o`80001o2@3oool20000o`<0oooo0P000?l2003jVP050?ooo`00nYX00?ZJ0000o`0007l0103oool3
0000o`800?ZJ0P000?l;0?ooo`80003o00<0oooo003jVP00nYX01P000?l20?ooo`030000O`3oool0
oooo00<0oooo00<000000?ooo`3oool01P3oool000d0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0003o00@0003o1`3oool2003jVP030000o`3oool0oooo
01/0oooo10000?l:0?ooo`D0003o0P3oool4003jVP80oooo0`000?l20?ooo`80003o403oool4003j
VP030000o`3oool00?ZJ00@00?ZJ1P3oool20000o`H0oooo00<0001o0?ooo`3oool02@3oool00`00
07l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3oool20000
O`T0oooo0P000?l30?ooo`80003o0`3oool3003jVP030000O`000?l0003o00@0003o0`00nYX20000
o`/0oooo0P000?l00`3oool00?ZJ003jVP060000o`80oooo00<0001o0?ooo`3oool00`3oool00`00
0000oooo0?ooo`060?ooo`002P3oool5000000@0oooo00<000000?ooo`3oool00`3oool00`0007l0
oooo0?ooo`020?ooo`80003o1`3oool2003jVP030000o`3oool0oooo01`0oooo0`000?l:0?ooo`D0
003o0P3oool4003jVP80oooo0P000?lE0?ooo`@00?ZJ00<0003o0?ooo`000?l01000nYX60?ooo`80
003o1P3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3o
ool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o2@3oool20000o`<0oooo0P000?l40?ooo`80
0?ZJ00<0001o0000o`000?l00`000?l3003jVP030?ooo`000?l0003o00/0oooo2`000?l20?ooo`03
0000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool000X0oooo00@000000?ooo`3oool0
00001@3oool3000000<0oooo00<0001o0?ooo`3oool00P3oool20000o`L0oooo0P00nYX00`000?l0
oooo0?ooo`0L0?ooo`<0003o2P3oool20000o`030?ooo`000?l0003o0080oooo1000nYX20?ooo`03
0000O`3oool0oooo01@0oooo1000nYX20?ooo`050000o`00nYX00?ZJ003jVP000?l01P3oool20000
o`H0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo
00l0oooo00<0001o0?ooo`0007l03`3oool20000O`T0oooo0P000?l30?ooo`80003o103oool2003j
VP030000O`000?l0003o00<0003o0`00nYX30000o``0oooo2P000?l20?ooo`030000O`3oool0oooo
0080oooo0P0000080?ooo`002`3oool00`000000oooo000000050?ooo`030000003oool0oooo00<0
oooo00<0001o0?ooo`3oool0303oool20000oah0oooo0`000?l:0?ooo`80003o00<0oooo0000o`00
0?l00P3oool4003jVP80oooo00<0001o0?ooo`3oool0503oool4003jVP<0oooo0`00nYX00`000?l0
oooo0?ooo`040?ooo`80003o1P3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0
oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o2@3oool20000o`<0
oooo0P000?l40?ooo`800?ZJ00<0001o0000o`000?l00`000?l2003jVP<0003o3@3oool60000o`04
0?ooo`000?l0003o0000o`80oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?oo
o`00303oool2000000D0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0<0?ooo`80
003o7`3oool20000o`X0oooo0P000?l00`3oool0003o0000o`020?ooo`@00?ZJ0P3oool00`0007l0
oooo0?ooo`0D0?ooo`@00?ZJ0`3oool3003jVP030000o`3oool0oooo00@0oooo0P000?l60?ooo`03
0000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`03
0000O`3oool0001o00l0oooo0P0007l90?ooo`80003o0`3oool20000o`@0oooo0P00nYX00`0007l0
003o0000o`030000o`800?ZJ0`000?l=0?ooo`H0003o00@0oooo0000o`000?l0003o0P3oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000=0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo00P0
oooo0P000?l00`3oool0003o0000o`020?ooo`@00?ZJ0P3oool00`0007l0oooo0?ooo`0D0?ooo`@0
0?ZJ0`3oool3003jVP030000o`3oool0oooo00@0oooo0P000?l60?ooo`030000O`3oool0oooo00T0
oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0
oooo0P0007l90?ooo`80003o0`3oool20000o`@0oooo0P00nYX00`0007l0003o0000o`030000o`80
0?ZJ0`000?l=0?ooo`H0003o00@0oooo0000o`000?l0003o0P3oool00`0007l0oooo0?ooo`030?oo
o`030000003oool0oooo00H0oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3o
ool0;P3oool00`0007l0oooo0?ooo`080?ooo`80003o00<0oooo0000o`000?l00P3oool3003jVP<0
oooo00<0001o0?ooo`3oool0503oool4003jVP<0oooo0`00nYX00`000?l0oooo0?ooo`0<0?ooo`03
0000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`03
0000O`3oool0001o00l0oooo0P0007lD0?ooo`800?ZJ00<0001o0000o`000?l00P00nYX00`000?l0
0?ZJ003jVP030000o`d0oooo1P000?l0103oool0003o0000o`000?l20?ooo`030000O`3oool0oooo
00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0
oooo0?ooo`0^0?ooo`030000O`3oool0oooo00P0oooo0P000?l00`3oool0003o0000o`030?ooo`80
0?ZJ0`3oool00`0007l0oooo0?ooo`0E0?ooo`<00?ZJ0`3oool010000?l00?ZJ003jVP000?l>0?oo
o`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?oo
o`030000O`3oool0001o00l0oooo0P0007lD0?ooo`@00?ZJ00@0003o003jVP00nYX0003o0P00nYX3
0000o`d0oooo1P000?l0103oool0003o0000o`000?l20?ooo`030000O`3oool0oooo00<0oooo00<0
00000?ooo`3oool01P3oool001<0oooo0P0000040?ooo`030000O`3oool0oooo02h0oooo00<0001o
0?ooo`3oool0203oool20000o`030?ooo`000?l0003o00<0oooo0P00nYX30?ooo`030000O`3oool0
oooo01D0oooo0P00nYX40?ooo`040000o`00nYX00?ZJ0000o`h0oooo00<0001o0?ooo`3oool02@3o
ool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?ooo`0007l03`3o
ool20000Oa@0oooo00D0003o003jVP00nYX00?ZJ0000o`02003jVP030000o`00nYX00?ZJ00<0003o
3@3oool60000o`040?ooo`000?l0003o0000o`80oooo00<0001o0?ooo`3oool00P3oool2000000P0
oooo000C0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0oooo
0?ooo`080?ooo`80003o00<0oooo0000o`000?l00`3oool2003jVP<0oooo00<0001o0?ooo`3oool0
5@3oool2003jVP@0oooo00@0003o003jVP00nYX0003o3P3oool00`0007l0oooo0?ooo`090?ooo`03
0000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80
001o503oool00`000?l00?ZJ003jVP07003jVP<0003o3@3oool60000o`040?ooo`000?l0003o0000
o`80oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000
oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0
oooo0?ooo`0E0?ooo`800?ZJ103oool010000?l00?ZJ003jVP000?l>0?ooo`030000O`3oool0oooo
00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o
00l0oooo0P0007lD0?ooo`030000o`00nYX00?ZJ00L00?ZJ0`000?l=0?ooo`H0003o0P3oool20000
o`80oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`004`3oool00`000000
oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0
oooo0?ooo`0E0?ooo`800?ZJ103oool010000?l00?ZJ003jVP000?l>0?ooo`030000O`3oool0oooo
00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o
00l0oooo0P0007lD0?ooo`030000o`00nYX00?ZJ00H00?ZJ00@0oooo0000o`000?l0003o3@3oool6
0000o`80oooo0P000?l20?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool0
01<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo
01D0oooo00<0001o0?ooo`3oool05@3oool2003jVP@0oooo10000?l>0?ooo`030000O`3oool0oooo
00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o
00l0oooo0P0007lD0?ooo`80003o00<0001o003jVP00nYX01000nYX0103oool0003o0000o`000?l=
0?ooo`H0003o0P3oool20000o`80oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`06
0?ooo`004`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?oo
o`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`80003o103oool40000o`h0oooo00<0001o0?oo
o`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o0?oo
o`0007l03`3oool20000Oa@0oooo0P000?l0100007l00?ZJ003jVP3oool3003jVP80oooo0P000?l=
0?ooo`030000O`3oool0oooo00D0oooo0P000?l20?ooo`030000O`3oool0oooo00<0oooo00<00000
0?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0^0?oo
o`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool20000o`@0oooo0`000?l?0?oo
o`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?oo
o`030000O`3oool0001o00l0oooo0P0007lD0?ooo`<0003o0P00nYX0103oool00?ZJ003jVP00nYX2
0?ooo`80003o3@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo00<00000
0?ooo`3oool01P3oool001<0oooo0P0000040?ooo`030000O`3oool0oooo02h0oooo00<0001o0?oo
o`3oool05@3oool00`0007l0oooo0?ooo`0E0?ooo`030000O`3oool0oooo00@0oooo0P000?l?0?oo
o`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?oo
o`030000O`3oool0001o00l0oooo0P0007lD0?ooo`@0003o0P3oool3003jVQ40oooo00<0001o0?oo
o`3oool02@3oool00`0007l0oooo0?ooo`020?ooo`800000203oool001<0oooo00<000000?ooo`3o
ool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3o
ool05@3oool00`0007l0oooo0?ooo`040?ooo`80003o3`3oool00`0007l0oooo0?ooo`090?ooo`03
0000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80
001o503oool40000o`80oooo00<0003o003jVP00nYX04@3oool00`0007l0oooo0?ooo`090?ooo`03
0000O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool0
0`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0
5@3oool00`0007l0oooo0?ooo`040?ooo`80003o3`3oool00`0007l0oooo0?ooo`090?ooo`030000
O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o
503oool40000o`80oooo00<0003o003jVP00nYX04@3oool00`0007l0oooo0?ooo`090?ooo`030000
O`3oool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3o
ool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3o
ool00`0007l0oooo0?ooo`040?ooo`80003o3`3oool00`0007l0oooo0?ooo`090?ooo`030000O`3o
ool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o503o
ool40000o`80oooo00<0003o003jVP00nYX04@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3o
ool0oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool0
0`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool0
0`0007l0oooo0?ooo`040?ooo`80003o3`3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0
oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o5@3oool3
0000o`80oooo00<0003o003jVP00nYX04@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0
oooo00<0oooo00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`00
07l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`00
07l0oooo0?ooo`040?ooo`80003o3`3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo
00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o5@3oool30000
o`80oooo0P000?lB0?ooo`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool00`3oool00`00
0000oooo0?ooo`060?ooo`004`3oool2000000@0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0
oooo0?ooo`0E0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0103oool20000o`l0
oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0
oooo00<0001o0?ooo`0007l03`3oool20000OaD0oooo0`000?l20?ooo`80003o4P3oool00`0007l0
oooo0?ooo`090?ooo`030000O`3oool0oooo0080oooo0P0000080?ooo`004`3oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0oooo02h0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo
0?ooo`0E0?ooo`030000O`3oool0oooo00@0oooo0P000?l?0?ooo`030000O`3oool0oooo00T0oooo
00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`0?0?ooo`030000O`3oool0001o00l0oooo
0P0007lE0?ooo`<0003o5P3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool01P3oool001<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool05@3oool00`0007l0oooo0?oo
o`040?ooo`80003o3`3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00T0oooo00<0
001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?ooo`80001o5@3oool30000oaH0oooo00<0
001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo000C
0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0;P3oool00`0007l0oooo0?ooo`0E
0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0103oool20000o`l0oooo00<0001o
0?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo00l0oooo00<0001o
0?ooo`0007l03`3oool20000OaD0oooo0`000?lF0?ooo`030000O`3oool0oooo00T0oooo00<0001o
0?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`002`3oool3000000D0oooo00<000000?oo
o`3oool00`3oool00`0007l0oooo0?ooo`0^0?ooo`030000O`3oool0oooo01D0oooo00<0001o0?oo
o`3oool05@3oool00`0007l0oooo0?ooo`040?ooo`80003o3`3oool00`0007l0oooo0?ooo`090?oo
o`030000O`3oool0oooo00T0oooo00<0001o0?ooo`3oool03`3oool00`0007l0oooo0000O`0?0?oo
o`80001o5@3oool30000oaH0oooo00<0001o0?ooo`3oool02@3oool00`0007l0oooo0?ooo`030?oo
o`030000003oool0oooo00H0oooo000:0?ooo`050000003oool0oooo0?ooo`000000103oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo02h0oooo00<0001o0?ooo`3oool02@3oool00`00
0000oooo0?ooo`090?ooo`030000O`3oool0oooo01D0oooo00<0001o0?ooo`3oool0103oool20000
o`l0oooo00<000000?ooo`3oool02@3oool00`0007l0oooo0?ooo`090?ooo`030000O`3oool0oooo
00l0oooo00<0001o0?ooo`0007l03`3oool00`000000001o0?ooo`0D0?ooo`<0003o5P3oool00`00
07l0oooo0?ooo`090?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01P3oool000X0
oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00@0oooo0P000?l30?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0000O`030?oo
o`030000003oool0oooo00T0oooo00<000000000O`3oool02@3oool00`000000oooo0?ooo`090?oo
o`80003o2P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`060?ooo`002P3oool4000000D0ooooKP0000020000of<0
00000P000?lY000000P0oooo000:0?ooo`030000003oool0oooo0?l0oooo3@3oool000/0oooo00<0
00000?ooo`3oool0o`3oool<0?ooo`00303oool200000?l0oooo303oool00?l0oooo6P3oool00001
\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-21.5559, -6.93413, \
0.830825, 0.0768173}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["data structure for BFGS: \n\n\
{{Z1,X1},{Z2,X2},...{ZN,XN}} = {Z={Z1,...,ZN},X={X1,...,XN}}//Transpose : N x \
2 x T1 x k",
  FontColor->RGBColor[1, 0, 0]]], "Subsubsection"],

Cell[CellGroupData[{

Cell["\<\
data={ZM,X}//Transpose;
data//Dimensions\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({10, 2, 201, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(data[\([1]\)] // Dimensions\)], "Input"],

Cell[BoxData[
    \({2, 201, 1}\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EKF", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Filter", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[StyleBox["data[[nn=10]] == {Z10,X10}",
  FontColor->RGBColor[1, 0, 0]]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?EKF\)\)], "Input"],

Cell["Global`EKF", "Print",
  CellTags->"Info3374910237-9666275"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(EKF[{Z_, X_}, 
                      Theta_, {f_, Df_, g_, h_, Dh_, R_, mue_, sigma_, 
                        dt_}, {miss_, option_ : 1}] := 
                    Block[{T1, ti, dti, dti1, Xi, Yii, Pii, lik, liki, YF, 
                        PF, Yi1i, Pi1i, Y, P, j, Y0, P0, p, IP, inno, 
                        likvec}, OVERFLOW = False; ti = messind[Z, miss]; 
                      T1 = Length[Z]; ti = ti \[Union] {1, T1}; 
                      dti = Delta[ti, ti, List, \(-1\)]; 
                      dti1 = Delta[ti] + 1; 
                      Xi = X\[LeftDoubleBracket]1\[RightDoubleBracket]; 
                      Yi1i = mue[Xi, Theta]; 
                      Pi1i = sigma[Xi, Theta]; {Yii, Pii, lik} = 
                        MessUpEKF[{Z\[LeftDoubleBracket]1\[RightDoubleBracket]\
, {Yi1i, Pi1i}, Xi, _}, Theta, {h, Dh, R}, {miss}]; 
                      If[option == 4, inno = {Yii - Yi1i}]; 
                      If[option == 5, likvec = {lik}]; Y0 = Yii; P0 = Pii; 
                      p = Length[Y0]; IP = IdentityMatrix[p]; YF = {}; 
                      PF = {}; 
                      Do[Xi = 
                          Take[X, 
                            dti\[LeftDoubleBracket]
                              i\[RightDoubleBracket]]; {Yi1i, Pi1i, Y, P} = 
                          TimeUpEKF[{Yii, Pii, Xi, dt}, Theta, {f, Df, g}]; 
                        If[option == 2, YF = Join[YF, Drop[Y, \(-1\)]]; 
                          PF = Join[PF, Drop[P, \(-1\)]]; ]; 
                        j = ti\[LeftDoubleBracket]
                            i + 1\[RightDoubleBracket]; {Yii, Pii, liki} = 
                          MessUpEKF[{Z\[LeftDoubleBracket]
                                j\[RightDoubleBracket], {Yi1i, Pi1i}, 
                              X\[LeftDoubleBracket]
                                j\[RightDoubleBracket], _}, 
                            Theta, {h, Dh, R}, {miss}]; 
                        If[option == 4, inno = Join[inno, {Yii - Yi1i}]]; 
                        If[option == 5, likvec = Append[likvec, liki]]; 
                        lik += liki; , {i, 1, Length[ti] - 1}]; 
                      If[option == 2, YF = Join[YF, {Yii}]; 
                        PF = Join[PF, {Pii}]; Return[N[{YF, PF, lik}]]]; 
                      If[option == 1, Return[N[lik]]]; 
                      If[option == 4, Return[N[{lik, inno}]]]; 
                      If[option == 5, Return[N[{lik, likvec}]]]; ]\)},
                {" "},
                {\(EKF[{Z_, X_}, 
                      Theta_, {f_, Df_, g_, Dg_, h_, Dh_, R_, mue_, sigma_, 
                        dt_}, {miss_, option_ : 1}] := 
                    Module[{ti, dti, dti1, Xi, Yii, Pii, lik, liki, YF, PF, 
                        Yi1i, Pi1i, Y, P, j}, ti = messind[Z, miss]; 
                      T1 = Length[Z]; ti = ti \[Union] {1, T1}; 
                      dti = Delta[ti, ti, List, \(-1\)]; 
                      dti1 = Delta[ti] + 1; 
                      Xi = X\[LeftDoubleBracket]1\[RightDoubleBracket]; {Yii, 
                          Pii, lik} = 
                        MessUpEKF[{Z\[LeftDoubleBracket]1\[RightDoubleBracket]\
, {mue[Xi, Theta], sigma[Xi, Theta]}, Xi, _}, Theta, {h, Dh, R}, {miss}]; 
                      YF = {}; PF = {}; 
                      Do[Xi = 
                          Take[X, 
                            dti\[LeftDoubleBracket]i\[RightDoubleBracket]]; \
{Yi1i, Pi1i, Y, P} = TimeUpEKF[{Yii, Pii, Xi, dt}, Theta, {f, Df, g, Dg}]; 
                        Yi1i = Over[Yi1i, YMAX]; 
                        If[option == 2, YF = Join[YF, Drop[Y, \(-1\)]]; 
                          PF = Join[PF, Drop[P, \(-1\)]]; ]; 
                        j = ti\[LeftDoubleBracket]i + 
                              1\[RightDoubleBracket]; {Yii, Pii, liki} = 
                          MessUpEKF[{Z\[LeftDoubleBracket]j\
\[RightDoubleBracket], {Yi1i, Pi1i}, 
                              X\[LeftDoubleBracket]j\[RightDoubleBracket], \
_}, Theta, {h, Dh, R}, {miss}]; lik += liki; , {i, 1, Length[ti] - 1}]; 
                      If[option == 2, YF = Join[YF, {Yii}]; 
                        PF = Join[PF, {Pii}]; Return[N[{YF, PF, lik}]], 
                        Return[N[lik]]]; ]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "EKF"],
      Editable->False]], "Print",
  CellTags->"Info3374910237-9666275"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(EKF[{Z_, X_}, 
                      Theta_, {f_, Df_, g_, h_, Dh_, R_, mue_, sigma_, 
                        dt_}, {miss_, option_ : 1}] := 
                    Block[{T1, ti, dti, dti1, Xi, Yii, Pii, lik, liki, YF, 
                        PF, Yi1i, Pi1i, Y, P, j, Y0, P0, p, IP, inno, 
                        likvec}, OVERFLOW = False; ti = messind[Z, miss]; 
                      T1 = Length[Z]; ti = ti \[Union] {1, T1}; 
                      dti = Delta[ti, ti, List, \(-1\)]; 
                      dti1 = Delta[ti] + 1; 
                      Xi = X\[LeftDoubleBracket]1\[RightDoubleBracket]; 
                      Yi1i = mue[Xi, Theta]; 
                      Pi1i = sigma[Xi, Theta]; {Yii, Pii, lik} = 
                        MessUpEKF[{Z\[LeftDoubleBracket]1\[RightDoubleBracket]\
, {Yi1i, Pi1i}, Xi, _}, Theta, {h, Dh, R}, {miss}]; 
                      If[option == 4, inno = {Yii - Yi1i}]; 
                      If[option == 5, likvec = {lik}]; Y0 = Yii; P0 = Pii; 
                      p = Length[Y0]; IP = IdentityMatrix[p]; YF = {}; 
                      PF = {}; 
                      Do[Xi = 
                          Take[X, 
                            dti\[LeftDoubleBracket]
                              i\[RightDoubleBracket]]; {Yi1i, Pi1i, Y, P} = 
                          TimeUpEKF[{Yii, Pii, Xi, dt}, Theta, {f, Df, g}]; 
                        If[option == 2, YF = Join[YF, Drop[Y, \(-1\)]]; 
                          PF = Join[PF, Drop[P, \(-1\)]]; ]; 
                        j = ti\[LeftDoubleBracket]
                            i + 1\[RightDoubleBracket]; {Yii, Pii, liki} = 
                          MessUpEKF[{Z\[LeftDoubleBracket]
                                j\[RightDoubleBracket], {Yi1i, Pi1i}, 
                              X\[LeftDoubleBracket]
                                j\[RightDoubleBracket], _}, 
                            Theta, {h, Dh, R}, {miss}]; 
                        If[option == 4, inno = Join[inno, {Yii - Yi1i}]]; 
                        If[option == 5, likvec = Append[likvec, liki]]; 
                        lik += liki; , {i, 1, Length[ti] - 1}]; 
                      If[option == 2, YF = Join[YF, {Yii}]; 
                        PF = Join[PF, {Pii}]; Return[N[{YF, PF, lik}]]]; 
                      If[option == 1, Return[N[lik]]]; 
                      If[option == 4, Return[N[{lik, inno}]]]; 
                      If[option == 5, Return[N[{lik, likvec}]]]; ]\)},
                {" "},
                {\(EKF[{Z_, X_}, 
                      Theta_, {f_, Df_, g_, Dg_, h_, Dh_, R_, mue_, sigma_, 
                        dt_}, {miss_, option_ : 1}] := 
                    Module[{ti, dti, dti1, Xi, Yii, Pii, lik, liki, YF, PF, 
                        Yi1i, Pi1i, Y, P, j}, ti = messind[Z, miss]; 
                      T1 = Length[Z]; ti = ti \[Union] {1, T1}; 
                      dti = Delta[ti, ti, List, \(-1\)]; 
                      dti1 = Delta[ti] + 1; 
                      Xi = X\[LeftDoubleBracket]1\[RightDoubleBracket]; {Yii, 
                          Pii, lik} = 
                        MessUpEKF[{Z\[LeftDoubleBracket]1\[RightDoubleBracket]\
, {mue[Xi, Theta], sigma[Xi, Theta]}, Xi, _}, Theta, {h, Dh, R}, {miss}]; 
                      YF = {}; PF = {}; 
                      Do[Xi = 
                          Take[X, 
                            dti\[LeftDoubleBracket]i\[RightDoubleBracket]]; \
{Yi1i, Pi1i, Y, P} = TimeUpEKF[{Yii, Pii, Xi, dt}, Theta, {f, Df, g, Dg}]; 
                        Yi1i = Over[Yi1i, YMAX]; 
                        If[option == 2, YF = Join[YF, Drop[Y, \(-1\)]]; 
                          PF = Join[PF, Drop[P, \(-1\)]]; ]; 
                        j = ti\[LeftDoubleBracket]i + 
                              1\[RightDoubleBracket]; {Yii, Pii, liki} = 
                          MessUpEKF[{Z\[LeftDoubleBracket]j\
\[RightDoubleBracket], {Yi1i, Pi1i}, 
                              X\[LeftDoubleBracket]j\[RightDoubleBracket], \
_}, Theta, {h, Dh, R}, {miss}]; lik += liki; , {i, 1, Length[ti] - 1}]; 
                      If[option == 2, YF = Join[YF, {Yii}]; 
                        PF = Join[PF, {Pii}]; Return[N[{YF, PF, lik}]], 
                        Return[N[lik]]]; ]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "EKF"],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False,
  CellTags->"Info3374499539-9666275"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,lik} = 
\tEKF[data[[nn=10]],Theta,system={f,Df,g,h,Dh,R,mue,sigma,dt},{miss,2}];//\
Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.5`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["std = Map[VecDiag,PF]//Sqrt;", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(std\)\" is similar to \
existing symbol \"\!\(Std\)\"."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g2 = plot1[yt[[nn]]~ii~YF~ii~(YF+std)~ii~(YF-std)//AddTimeAxis,
\t\tGridLines->{time/dt,None},color->{1,2,3,3},
\t\tDisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{201, 5}\),
      SequenceForm[ "Dimension der Daten  ", {201, 5}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g3 = plot1[Spalte[time/dt]~ii~ZM[[nn,time/dt+1]],
\t\t\tPlotJoined->False,dicke->.02,
\t\t\tDisplayFunction->Identity,color->{10}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{14, 2}\),
      SequenceForm[ "Dimension der Daten  ", {14, 2}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gEKF=Show[g2,g3,DisplayFunction->$DisplayFunction,GridLines->{time/\
dt,None},
\t\t\tPlotLabel->\"EKF, panel unit = \
\"<>ToString[nn],PlotRange->{All,{-5,5}}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0047619 0.309017 0.0618034 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -6 -9 ]
[.2619 -0.0125 6 0 ]
[.5 -0.0125 -9 -9 ]
[.5 -0.0125 9 0 ]
[.7381 -0.0125 -9 -9 ]
[.7381 -0.0125 9 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -6 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -6 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -62 0 ]
[.5 .63053 62 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .61803 L
s
.21429 0 m
.21429 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.40476 0 m
.40476 .61803 L
s
.5 0 m
.5 .61803 L
s
.54762 0 m
.54762 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.66667 0 m
.66667 .61803 L
s
.67619 0 m
.67619 .61803 L
s
.7381 0 m
.7381 .61803 L
s
.74286 0 m
.74286 .61803 L
s
.83333 0 m
.83333 .61803 L
s
.92857 0 m
.92857 .61803 L
s
.97619 0 m
.97619 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(50)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(100)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(150)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(200)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(-4)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(-2)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(2)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(4)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -123 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(panel) show
129.000 13.000 moveto
(unit) show
159.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
171.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
183.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.97619 .19163 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .27669 m
.02857 .29846 L
.03333 .2618 L
.0381 .26628 L
.04286 .26754 L
.04762 .20714 L
.05238 .16017 L
.05714 .12555 L
.0619 .06686 L
.06667 .05446 L
.07143 .11893 L
.07619 .12641 L
.08095 .13619 L
.08571 .16112 L
.09048 .16386 L
.09524 .19665 L
.1 .24045 L
.10476 .20446 L
.10952 .19228 L
.11429 .214 L
.11905 .14632 L
.12381 .17878 L
.12857 .16414 L
.13333 .17391 L
.1381 .14817 L
.14286 .08782 L
.14762 .05453 L
.15238 .0119 L
.15714 .09454 L
.1619 .03251 L
s
.1619 .03251 m
.16578 0 L
s
.16707 0 m
.17143 .07962 L
.17619 .12078 L
.18095 .14606 L
.18571 .0944 L
.19048 .05835 L
.19524 .02722 L
.2 .12327 L
.20476 .13342 L
.20952 .11797 L
.21429 .0862 L
.21905 .1208 L
.22381 .0684 L
.22857 .10722 L
.23333 .07035 L
.2381 .14024 L
.24286 .16002 L
.24762 .0962 L
.25238 .14833 L
.25714 .18874 L
.2619 .17714 L
.26667 .105 L
.27143 .04362 L
.27619 .11036 L
.28095 .10684 L
.28571 .07526 L
.29048 .05732 L
.29524 .02388 L
.3 .03087 L
s
.3 .03087 m
.30464 0 L
s
.31443 0 m
.31905 .07609 L
.32381 .10542 L
.32857 .15738 L
.33333 .14317 L
.3381 .15243 L
.34286 .20764 L
.34762 .22096 L
.35238 .2153 L
.35714 .26563 L
.3619 .3122 L
.36667 .35278 L
.37143 .38037 L
.37619 .38052 L
.38095 .43467 L
.38571 .47781 L
.39048 .5289 L
.39524 .58891 L
.4 .57273 L
.40476 .54716 L
.40952 .56473 L
.41429 .56986 L
.41905 .55525 L
.42381 .51756 L
.42857 .52404 L
.43333 .57999 L
.4381 .60893 L
.44286 .56255 L
.44762 .49508 L
.45238 .47568 L
.45714 .54105 L
.4619 .57277 L
.46667 .56729 L
.47143 .53704 L
.47619 .47122 L
.48095 .40953 L
.48571 .47737 L
.49048 .54448 L
.49524 .49601 L
.5 .46279 L
.50476 .41459 L
.50952 .48668 L
.51429 .50639 L
.51905 .54283 L
.52381 .51727 L
.52857 .48803 L
.53333 .43407 L
.5381 .43381 L
.54286 .48406 L
.54762 .46833 L
Mistroke
.55238 .4306 L
.55714 .50386 L
.5619 .5293 L
.56667 .45758 L
.57143 .42766 L
.57619 .39203 L
.58095 .34028 L
.58571 .35624 L
.59048 .31438 L
.59524 .27082 L
.6 .21584 L
.60476 .22649 L
.60952 .27894 L
.61429 .33442 L
.61905 .27197 L
.62381 .28934 L
.62857 .26229 L
.63333 .21177 L
.6381 .22268 L
.64286 .19539 L
.64762 .15191 L
.65238 .17558 L
.65714 .21152 L
.6619 .27075 L
.66667 .2065 L
.67143 .23019 L
.67619 .17363 L
.68095 .2312 L
.68571 .26797 L
.69048 .27059 L
.69524 .20779 L
.7 .18438 L
.70476 .19891 L
.70952 .17433 L
.71429 .22716 L
.71905 .25426 L
.72381 .2796 L
.72857 .26895 L
.73333 .32226 L
.7381 .26879 L
.74286 .25272 L
.74762 .2182 L
.75238 .1823 L
.75714 .20821 L
.7619 .15684 L
.76667 .15996 L
.77143 .14959 L
.77619 .17866 L
.78095 .12033 L
.78571 .16473 L
Mistroke
.79048 .13629 L
.79524 .17001 L
.8 .13643 L
.80476 .10406 L
.80952 .07563 L
.81429 .07138 L
.81905 .10182 L
.82381 .16059 L
.82857 .13162 L
.83333 .14816 L
.8381 .19935 L
.84286 .18811 L
.84762 .16852 L
.85238 .16849 L
.85714 .16259 L
.8619 .1141 L
.86667 .06294 L
.87143 .11855 L
.87619 .09475 L
.88095 .1156 L
.88571 .13599 L
.89048 .07134 L
.89524 .04327 L
.9 .10437 L
.90476 .08131 L
.90952 .05875 L
.91429 .12972 L
.91905 .12629 L
.92381 .06173 L
.92857 .12778 L
.93333 .09344 L
.9381 .10901 L
.94286 .13808 L
.94762 .09789 L
.95238 .08094 L
.95714 .03611 L
.9619 .03459 L
.96667 .08602 L
.97143 .13909 L
.97619 .19163 L
Mfstroke
0 .98 .604 r
gsave
.97619 .17107 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21625 m
.02857 .20906 L
.03333 .20168 L
.0381 .19418 L
.04286 .18666 L
.04762 .17922 L
.05238 .17197 L
.05714 .165 L
.0619 .15842 L
.06667 .1523 L
.07143 .14671 L
.07619 .14167 L
.08095 .13721 L
.08571 .1333 L
.09048 .12993 L
.09524 .12706 L
.1 .12464 L
.10476 .12261 L
.10952 .12093 L
.11429 .11954 L
.11905 .1184 L
.12381 .11747 L
.12857 .11672 L
.13333 .1161 L
.1381 .11561 L
.14286 .11521 L
.14762 .11489 L
.15238 .11463 L
.15714 .11442 L
.1619 .11425 L
.16667 .11412 L
.17143 .11401 L
.17619 .11392 L
.18095 .11385 L
.18571 .1138 L
.19048 .11376 L
.19524 .11372 L
.2 .11369 L
.20476 .11367 L
.20952 .11365 L
.21429 .11455 L
.21905 .11436 L
.22381 .1142 L
.22857 .11408 L
.23333 .11398 L
.2381 .1139 L
.24286 .11383 L
.24762 .11378 L
.25238 .11374 L
.25714 .11371 L
Mistroke
.2619 .11368 L
.26667 .11366 L
.27143 .11365 L
.27619 .11363 L
.28095 .11362 L
.28571 .11361 L
.29048 .11361 L
.29524 .1136 L
.3 .1136 L
.30476 .11359 L
.30952 .07176 L
.31429 .083 L
.31905 .09063 L
.32381 .09606 L
.32857 .10005 L
.33333 .10304 L
.3381 .10532 L
.34286 .10708 L
.34762 .10844 L
.35238 .10951 L
.35714 .11035 L
.3619 .11101 L
.36667 .11153 L
.37143 .11195 L
.37619 .11228 L
.38095 .11254 L
.38571 .11275 L
.39048 .11292 L
.39524 .11305 L
.4 .11316 L
.40476 .31588 L
.40952 .31657 L
.41429 .31732 L
.41905 .31815 L
.42381 .31906 L
.42857 .32006 L
.43333 .32116 L
.4381 .32237 L
.44286 .3237 L
.44762 .32516 L
.45238 .32676 L
.45714 .32852 L
.4619 .33045 L
.46667 .33257 L
.47143 .33489 L
.47619 .33744 L
.48095 .34022 L
.48571 .34326 L
.49048 .34658 L
.49524 .35019 L
Mistroke
.5 .54725 L
.50476 .53568 L
.50952 .52786 L
.51429 .5223 L
.51905 .51823 L
.52381 .51518 L
.52857 .51285 L
.53333 .51106 L
.5381 .50967 L
.54286 .50859 L
.54762 .45705 L
.55238 .46336 L
.55714 .46916 L
.5619 .47443 L
.56667 .47912 L
.57143 .48324 L
.57619 .48682 L
.58095 .48988 L
.58571 .49248 L
.59048 .49466 L
.59524 .36239 L
.6 .36733 L
.60476 .37265 L
.60952 .37833 L
.61429 .38439 L
.61905 .39081 L
.62381 .39756 L
.62857 .40459 L
.63333 .41187 L
.6381 .4193 L
.64286 .42682 L
.64762 .43432 L
.65238 .4417 L
.65714 .44885 L
.6619 .45568 L
.66667 .29285 L
.67143 .29125 L
.67619 .28258 L
.68095 .27999 L
.68571 .27715 L
.69048 .27404 L
.69524 .27066 L
.7 .26697 L
.70476 .26296 L
.70952 .25861 L
.71429 .25391 L
.71905 .24883 L
.72381 .24339 L
.72857 .23756 L
.73333 .23137 L
Mistroke
.7381 .34662 L
.74286 .24759 L
.74762 .24205 L
.75238 .23614 L
.75714 .22987 L
.7619 .22325 L
.76667 .21632 L
.77143 .20914 L
.77619 .20176 L
.78095 .19426 L
.78571 .18675 L
.79048 .1793 L
.79524 .17205 L
.8 .16508 L
.80476 .15849 L
.80952 .15237 L
.81429 .14677 L
.81905 .14172 L
.82381 .13725 L
.82857 .13334 L
.83333 .06706 L
.8381 .07995 L
.84286 .08851 L
.84762 .09453 L
.85238 .09891 L
.85714 .10218 L
.8619 .10467 L
.86667 .10657 L
.87143 .10805 L
.87619 .1092 L
.88095 .11011 L
.88571 .11082 L
.89048 .11138 L
.89524 .11183 L
.9 .11218 L
.90476 .11247 L
.90952 .11269 L
.91429 .11287 L
.91905 .11301 L
.92381 .11312 L
.92857 .13147 L
.93333 .12837 L
.9381 .12574 L
.94286 .12353 L
.94762 .12169 L
.95238 .12016 L
.95714 .11891 L
.9619 .11789 L
.96667 .11706 L
.97143 .11638 L
Mistroke
.97619 .17107 L
Mfstroke
1 0 0 r
gsave
.97619 .21647 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27518 m
.02857 .28137 L
.03333 .28525 L
.0381 .28717 L
.04286 .28722 L
.04762 .28547 L
.05238 .28196 L
.05714 .27682 L
.0619 .27026 L
.06667 .26256 L
.07143 .25409 L
.07619 .24524 L
.08095 .23638 L
.08571 .22786 L
.09048 .21994 L
.09524 .21283 L
.1 .2066 L
.10476 .20128 L
.10952 .19683 L
.11429 .19317 L
.11905 .19021 L
.12381 .18782 L
.12857 .18593 L
.13333 .18442 L
.1381 .18323 L
.14286 .18229 L
.14762 .18155 L
.15238 .18096 L
.15714 .1805 L
.1619 .18014 L
.16667 .17985 L
.17143 .17962 L
.17619 .17944 L
.18095 .17929 L
.18571 .17918 L
.19048 .17908 L
.19524 .17901 L
.2 .17895 L
.20476 .17891 L
.20952 .17887 L
.21429 .15941 L
.21905 .16751 L
.22381 .17206 L
.22857 .17474 L
.23333 .17637 L
.2381 .17735 L
.24286 .17795 L
.24762 .17831 L
.25238 .17853 L
.25714 .17865 L
Mistroke
.2619 .17872 L
.26667 .17876 L
.27143 .17877 L
.27619 .17878 L
.28095 .17877 L
.28571 .17877 L
.29048 .17876 L
.29524 .17876 L
.3 .17875 L
.30476 .17875 L
.30952 .1166 L
.31429 .13197 L
.31905 .14258 L
.32381 .15035 L
.32857 .15625 L
.33333 .16082 L
.3381 .1644 L
.34286 .16724 L
.34762 .1695 L
.35238 .17132 L
.35714 .17277 L
.3619 .17394 L
.36667 .17487 L
.37143 .17563 L
.37619 .17624 L
.38095 .17673 L
.38571 .17712 L
.39048 .17744 L
.39524 .17769 L
.4 .1779 L
.40476 .36061 L
.40952 .37939 L
.41429 .39669 L
.41905 .41377 L
.42381 .43121 L
.42857 .44939 L
.43333 .46858 L
.4381 .48901 L
.44286 .51089 L
.44762 .53444 L
.45238 .55984 L
.45714 .5873 L
.4619 .61701 L
Mfstroke
.4619 .61701 m
.46206 .61803 L
s
.49985 .61803 m
.5 .60873 L
.50476 .59176 L
.50952 .58312 L
.51429 .57823 L
.51905 .57527 L
.52381 .57339 L
.52857 .57216 L
.53333 .57134 L
.5381 .57079 L
.54286 .57041 L
.54762 .50096 L
.55238 .51982 L
.55714 .53386 L
.5619 .54448 L
.56667 .55241 L
.57143 .55821 L
.57619 .56232 L
.58095 .56513 L
.58571 .567 L
.59048 .56818 L
.59524 .40941 L
.6 .43132 L
.60476 .45167 L
.60952 .47136 L
.61429 .49066 L
.61905 .50958 L
.62381 .52796 L
.62857 .54553 L
.63333 .56197 L
.6381 .57687 L
.64286 .58984 L
.64762 .60054 L
.65238 .60868 L
.65714 .61413 L
.6619 .61691 L
.66667 .35027 L
.67143 .36542 L
.67619 .33359 L
.68095 .34814 L
.68571 .36129 L
.69048 .3739 L
.69524 .38634 L
.7 .39881 L
.70476 .4114 L
.70952 .4241 L
.71429 .43687 L
.71905 .44957 L
.72381 .46201 L
.72857 .4739 L
Mistroke
.73333 .4849 L
.7381 .40686 L
.74286 .29563 L
.74762 .30664 L
.75238 .31525 L
.75714 .32226 L
.7619 .32791 L
.76667 .3322 L
.77143 .335 L
.77619 .33616 L
.78095 .33548 L
.78571 .3328 L
.79048 .32804 L
.79524 .32122 L
.8 .31246 L
.80476 .30205 L
.80952 .29039 L
.81429 .27795 L
.81905 .26525 L
.82381 .25279 L
.82857 .24101 L
.83333 .11967 L
.8381 .13154 L
.84286 .14131 L
.84762 .14898 L
.85238 .155 L
.85714 .15974 L
.8619 .1635 L
.86667 .1665 L
.87143 .16889 L
.87619 .17082 L
.88095 .17236 L
.88571 .17361 L
.89048 .17461 L
.89524 .17541 L
.9 .17606 L
.90476 .17659 L
.90952 .17701 L
.91429 .17735 L
.91905 .17762 L
.92381 .17784 L
.92857 .17619 L
.93333 .18297 L
.9381 .18615 L
.94286 .1874 L
.94762 .18754 L
.95238 .18706 L
.95714 .18626 L
.9619 .18534 L
.96667 .1844 L
Mistroke
.97143 .18352 L
.97619 .21647 L
Mfstroke
gsave
.97619 .12568 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15732 m
.02857 .13675 L
.03333 .1181 L
.0381 .1012 L
.04286 .0861 L
.04762 .07298 L
.05238 .06198 L
.05714 .05318 L
.0619 .04658 L
.06667 .04204 L
.07143 .03932 L
.07619 .03811 L
.08095 .03804 L
.08571 .03875 L
.09048 .03993 L
.09524 .0413 L
.1 .04268 L
.10476 .04394 L
.10952 .04502 L
.11429 .0459 L
.11905 .04659 L
.12381 .04712 L
.12857 .04751 L
.13333 .04779 L
.1381 .04799 L
.14286 .04813 L
.14762 .04822 L
.15238 .04829 L
.15714 .04834 L
.1619 .04837 L
.16667 .04839 L
.17143 .0484 L
.17619 .04841 L
.18095 .04842 L
.18571 .04842 L
.19048 .04843 L
.19524 .04843 L
.2 .04843 L
.20476 .04843 L
.20952 .04843 L
.21429 .0697 L
.21905 .06121 L
.22381 .05635 L
.22857 .05341 L
.23333 .05159 L
.2381 .05044 L
.24286 .04972 L
.24762 .04925 L
.25238 .04896 L
.25714 .04877 L
Mistroke
.2619 .04865 L
.26667 .04857 L
.27143 .04852 L
.27619 .04849 L
.28095 .04847 L
.28571 .04845 L
.29048 .04845 L
.29524 .04844 L
.3 .04844 L
.30476 .04843 L
.30952 .02692 L
.31429 .03403 L
.31905 .03868 L
.32381 .04176 L
.32857 .04384 L
.33333 .04526 L
.3381 .04624 L
.34286 .04692 L
.34762 .04738 L
.35238 .04771 L
.35714 .04793 L
.3619 .04809 L
.36667 .0482 L
.37143 .04827 L
.37619 .04832 L
.38095 .04836 L
.38571 .04838 L
.39048 .0484 L
.39524 .04841 L
.4 .04842 L
.40476 .27115 L
.40952 .25374 L
.41429 .23794 L
.41905 .22253 L
.42381 .2069 L
.42857 .19073 L
.43333 .17375 L
.4381 .15574 L
.44286 .13651 L
.44762 .11588 L
.45238 .09369 L
.45714 .06975 L
.4619 .0439 L
.46667 .01597 L
Mfstroke
.46667 .01597 m
.46919 0 L
s
.49664 0 m
.5 .48577 L
.50476 .47959 L
.50952 .47259 L
.51429 .46637 L
.51905 .46119 L
.52381 .45697 L
.52857 .45355 L
.53333 .45079 L
.5381 .44856 L
.54286 .44677 L
.54762 .41313 L
.55238 .40689 L
.55714 .40447 L
.5619 .40438 L
.56667 .40582 L
.57143 .40828 L
.57619 .41132 L
.58095 .41464 L
.58571 .41797 L
.59048 .42114 L
.59524 .31538 L
.6 .30334 L
.60476 .29362 L
.60952 .28531 L
.61429 .27813 L
.61905 .27204 L
.62381 .26716 L
.62857 .26366 L
.63333 .26177 L
.6381 .26174 L
.64286 .2638 L
.64762 .2681 L
.65238 .27472 L
.65714 .28357 L
.6619 .29444 L
.66667 .23543 L
.67143 .21707 L
.67619 .23158 L
.68095 .21184 L
.68571 .193 L
.69048 .17419 L
.69524 .15497 L
.7 .13513 L
.70476 .11453 L
.70952 .09312 L
.71429 .07095 L
.71905 .0481 L
.72381 .02477 L
.72857 .00122 L
Mistroke
Mfstroke
.72857 .00122 m
.72882 0 L
s
.73368 0 m
.7381 .28637 L
.74286 .19954 L
.74762 .17746 L
.75238 .15703 L
.75714 .13747 L
.7619 .11859 L
.76667 .10045 L
.77143 .08328 L
.77619 .06736 L
.78095 .05305 L
.78571 .04069 L
.79048 .03056 L
.79524 .02288 L
.8 .01769 L
.80476 .01493 L
.80952 .01435 L
.81429 .01558 L
.81905 .0182 L
.82381 .02172 L
.82857 .02568 L
.83333 .01444 L
.8381 .02835 L
.84286 .03571 L
.84762 .04007 L
.85238 .04283 L
.85714 .04463 L
.8619 .04583 L
.86667 .04665 L
.87143 .0472 L
.87619 .04759 L
.88095 .04785 L
.88571 .04803 L
.89048 .04816 L
.89524 .04824 L
.9 .0483 L
.90476 .04834 L
.90952 .04837 L
.91429 .04839 L
.91905 .0484 L
.92381 .04841 L
.92857 .08675 L
.93333 .07377 L
.9381 .06532 L
.94286 .05965 L
.94762 .05583 L
.95238 .05327 L
.95714 .05156 L
.9619 .05044 L
.96667 .04971 L
Mistroke
.97143 .04924 L
.97619 .12568 L
Mfstroke
0 0 0 r
gsave
.97619 .21823 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.02381 .20697 Mdot
.21429 .11538 Mdot
.30952 .03413 Mdot
.40476 .50012 Mdot
.5 .54929 Mdot
.54762 .40734 Mdot
.59524 .26475 Mdot
.66667 .26599 Mdot
.67619 .27935 Mdot
.7381 .35301 Mdot
.74286 .18034 Mdot
.83333 .04315 Mdot
.92857 .14808 Mdot
.97619 .21823 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00803oool200000380oooo0`0000040?ooo`800000;@3oool3000000@0oooo0P0000040?oo
o`800000:@3oool3000000<0oooo0`0000040?ooo`800000:03oool5000000<0oooo0P0000040?oo
o`800000403oool001l0oooo00@000000?ooo`3oool00000<03oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool00000;@3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool00000:@3oool01@000000oooo0?ooo`3oool00000
00<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0V0?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`00
7`3oool010000000oooo0?ooo`00000d0?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool0:`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool00000:@3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000003`3oool001l0oooo00@000000?ooo`3oool00000=03oool01000
0000oooo0?ooo`0000020?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool00P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000002T0oooo00<000000?ooo`3oool0
1@3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo02P0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool03@3oool0
01l0oooo00@000000?ooo`3oool00000<03oool4000000<0oooo00@000000?ooo`3oool00000;@3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
0000:@3oool010000000oooo0?ooo`3oool4000000<0oooo00@000000?ooo`3oool000009`3oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000?0?ooo`007`3oool010000000oooo0?ooo`00000`0?ooo`030000003oool0oooo00@0
oooo00@000000?ooo`3oool00000;03oool2000000@0oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000X0?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`040000003o
ool0oooo000002L0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000003`3oool00200oooo0P00000a0?ooo`D000000`3oool20000
02h0oooo00<000000?ooo`3oool00`3oool2000000@0oooo0P00000Z0?ooo`040000003oool0oooo
0?ooo`D000000`3oool2000002T0oooo0`0000040?ooo`800000103oool200000100oooo003o0?oo
oaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo000K0?ooobL000000P000?lN
00000080003o00<000000000o`000?l08P0000020?l000D000000P3o000d000000@0o`00?`00000@
0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01h0oooo0P000?l:0?oo
o`030000O`3oool0oooo00P0oooo00<000000?ooo`3oool01P3oool20000o`030?ooo`000?l0003o
01@0oooo00<0001o0?ooo`3oool02`3oool20?l000D0oooo0P3o00000`000000oooo0?ooo`080?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`0:0?oo
o`@0o`0000<000000000O`3oool04`3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo
00P0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000
oooo0?ooo`030?ooo`030000O`3oool0oooo01X0oooo0P000?l20?ooo`80003o2P3oool00`0007l0
oooo0?ooo`0A0?ooo`80003o00<0oooo0000o`000?l0503oool00`0007l0oooo0?ooo`0;0?ooo`80
o`001@3oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`0>0?ooo`030000O`3oool0001o00X0oooo103o00020000Oa@0oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3o
ool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0J0?ooo`80003o
0P3oool20000o`X0oooo00<0001o0?ooo`3oool04@3oool20000o`030?ooo`000?l0003o01@0oooo
00<0001o0?ooo`3oool02`3oool20?l000D0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`090?ooo`D0o`00
0P0007l<0?ooo`D0o`000P3oool20?l001H0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo
0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0
001o0?ooo`3oool06P3oool20000o`040?ooo`000?l0003o0000o`X0oooo00<0001o0?ooo`3oool0
403oool30000o`030?ooo`000?l0003o01@0oooo00<0001o0?ooo`3oool02`3oool20?l000D0oooo
0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
3P3oool00`0007l0oooo0000O`090?ooo`80o`0000<0oooo0?l0003o00000P0007l;0?ooo`L0o`00
00<0oooo0?l0003o00005P3oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0J0?ooo`80003o00@0oooo0000o`000?l0003o2P3oool00`0007l0oooo0?ooo`0?0?ooo`<0003o
0P3oool20000oa@0oooo00<0001o0?ooo`3oool02`3oool20?l000D0oooo0P3o00000`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo
0000O`090?ooo`80o`0000<0oooo0?l0003o00000P0007l:0?ooo`<0o`000`3oool60?l001D0oooo
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo
000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool06P3oool20000o`040?ooo`00
0?l0003o0000o`D0oooo0P000?l30?ooo`030000O`3oool0oooo00l0oooo0`000?l0103oool00000
000000000?lD0?ooo`030000O`3oool0oooo00/0oooo0P3o00050?ooo`80o`0000<0001o0?ooo`3o
ool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`00
07l02@3oool20?l000030?ooo`3o0000o`000080001o2P3oool20?l000D0oooo1@3o000E0?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`00
6`3oool2000000@0oooo00<0001o0?ooo`3oool06P3oool20000o`040?ooo`000?l0003o0000o`D0
oooo0P000?l30?ooo`030000O`3oool0oooo00l0oooo0`000?l4000001@0oooo00<0001o0?ooo`3o
ool02P3oool30?l000D0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`090?ooo`80o`0000<0oooo0?l0003o
00000P0007l90?ooo`<0o`001P3oool40?l001D0oooo00<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`020?ooo`800000403oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo
0?ooo`0I0?ooo`L0003o1@3oool20000o`<0oooo00<0001o0?ooo`3oool03`3oool30000o`@00000
503oool00`0007l0oooo0?ooo`0:0?ooo`80o`001P3oool20?l000030000O`3oool0oooo00P0oooo
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00T0oooo
0P3o00000`3oool0o`000?l000020000O`T0oooo0P3o00090?ooo`@0o`004`3oool00`0007l0oooo
0?ooo`020?ooo`@0003o0P3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo
000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool01`3oool80?l000X0oooo1`00
0?l40?ooo`<0003o0`3oool00`0007l0oooo0?ooo`0?0?ooo`80003o00@0oooo0?l0000000000000
0`3o000B0?ooo`030000O`3oool0oooo00X0oooo0P3o00060?ooo`80o`0000<0001o0?ooo`3oool0
203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l0
203oool30?l000030?ooo`3o0000o`000080001o203oool30?l000P0oooo0P0000040?l00180oooo
00<0001o0?ooo`3oool00P3oool40000o`80oooo00<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00H0oooo3P3o
00050?ooo`P0003o0`3oool30000o`<0oooo00<0001o0?ooo`3oool02P3oool20000o`80oooo0`00
0?l0103oool0o`000?l000000?l60?l000l0oooo00<0001o0?ooo`3oool02P3oool20?l000H0oooo
0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
3P3oool00`0007l0oooo0000O`080?ooo`80o`000P3oool20?l00080001o203oool20?l000P0oooo
100000000`3oool0o`000?l000030?l000H0oooo0P000?l70?ooo`030000O`3oool0oooo0080oooo
10000?l20?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00<0
00000?ooo`3oool00`3oool00`0007l0oooo0?ooo`050?ooo`<0o`001P3ooolL0?l000030000O`3o
ool0oooo0080oooo4P3o00000`0007l0003o0000o`0C0?l000030000O`3oool0oooo00X0oooo0P3o
00060?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3o
ool0oooo00h0oooo00<0001o0?ooo`0007l0203oool20?l00080oooo0P3o00020000O`L0oooo0`3o
00080?ooo`@000000P3ooolC0?l000030000O`3oool0oooo0080oooo00<0003o0?l0003o00000`3o
00000`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000D0?ooo`<00000103oool0
0`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00@0oooo0`3o00000`000?l0oooo0?ooo`09
0?oooaL0o`0000<0001o0?ooo`3o00004`3o0000103oool0001o0000o`000?l30?oooa00o`0000<0
001o0?ooo`3oool02@3oool30?l000H0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3o
ool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`080?ooo`80o`000P3o
ool20?l00080001o1`3oool20?l000X0oooo0P0000060?oooa00o`0000@0001o0?ooo`3oool0oooo
1`3o00000`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000E0?ooo`030000003o
ool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`040?ooo`80o`000P00
0?lA0?ooo`P0003o0P3oool40000o`040?ooo`3o0000o`000000O`D0o`001`3oool20000o`80oooo
0P000?l40?ooo`030000O`000?l0003o0140oooo0P3o00000`0007l0oooo0?ooo`090?ooo`80o`00
1`3oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo
0?ooo`0>0?ooo`030000O`3oool0001o00P0oooo0P3o00020?ooo`80o`000P0007l70?ooo`80o`00
2`3oool00`0007l0oooo0?ooo`0;0?ooo`80003o00<0oooo0000o`000?l00P3oool20?l000030000
O`3oool0oooo00@0o`000P000?l20?l000030000O`3oool0oooo00<0oooo00<000000?ooo`3oool0
3P3oool000`0oooo1@0000000`3oool0000000000003000000@0oooo0`0000030?ooo`030000O`3o
ool0oooo00<0oooo0`3o00020000oa40oooo20000?l20?ooo`@0003o00<0oooo0?l0003o00000`3o
00090?ooo`<0003o0P3oool20000o`@0oooo00<0001o0000o`000?l04@3oool20?l000030000O`3o
ool0oooo00T0oooo0P3o00070?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?oo
o`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l01`3oool30?l00080oooo0P3o
00020000O`H0oooo0`3o000;0?ooo`030000O`3oool0oooo00@0oooo0P000?l40?ooo`<0003o00<0
oooo0000o`000?l00P3oool20?l000030000O`3oool0o`000080o`0010000?l20?l000040000O`3o
ool0oooo0?ooo`<00000403oool00180oooo00@000000?ooo`3oool000001@3oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0oooo00<0oooo0P3o00030000oa40oooo20000?l20?ooo`@0003o
0P3oool30?l000X0oooo0`000?l20?ooo`80003o103oool00`0007l0003o0000o`0A0?ooo`80o`00
00<0001o0?ooo`3oool0203oool30?l000L0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`070?ooo`80o`00
0`3oool20?l00080001o1P3oool20?l000/0oooo0P00nYX60?ooo`80003o103oool30000o`030?oo
o`000?l0003o0080oooo0P3o0000100007l0o`000?l0003o00020000o`030?ooo`000?l0003o0080
o`0000<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`004`3oool00`000000oooo
000000050?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool00P3oool30?l000<0003o
4@3oool50000o`030?ooo`000?l0003o0080oooo10000?l20?ooo`<0o`0000@0003o0?ooo`000?l0
003o1P3oool30000o`040?ooo`000?l0003o0000o`@0oooo00<0001o0000o`000?l04@3oool20?l0
00030000O`3oool0oooo00P0oooo0P3o00080?ooo`80o`0000<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l01`3oool20?l0
00<0oooo0P3o00020000O`H0oooo0P3o00070?ooo`80003o0P3oool2003jVPH0oooo0P000?l40?oo
o`<0003o00<0oooo0000o`000?l00P3oool50?l000030?ooo`000?l0003o0080oooo00@0003o0?l0
003o0000001o1@3oool00`000000oooo0?ooo`0>0?ooo`00503oool2000000D0oooo00<000000?oo
o`3oool00`3oool00`0007l0oooo0?ooo`020?ooo`80o`0000@0oooo0000o`000?l0003o403oool6
0000o`030?ooo`000?l0003o0080oooo10000?l20?ooo`80o`000P000?l00`3oool0003o0000o`06
0?ooo`<0003o00<0oooo0000o`000?l0103oool2003jVP80003o4@3oool20?l000030000O`3oool0
oooo00P0oooo0P3o00080?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l01`3oool20?l000<0oooo0P3o0002
0000O`H0oooo0P3o00060?ooo`<0003o0P3oool3003jVPD0oooo0P000?l40?ooo`H0003o0P3oool0
0`000?l0o`000?l000020?l000030?ooo`000?l0003o0080oooo00@0003o0?l0003o0000001o1@3o
ool00`000000oooo0?ooo`0>0?ooo`005@3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo00<0oooo00<0001o0?ooo`3oool00P3oool20?l000040?ooo`000?l0003o0000oa00oooo0P00
0?l01@3oool0003o0000o`000?l0oooo0080003o00<0oooo0000o`000?l010000?l20?ooo`040000
O`000?l0003o0?ooo`80003o1P3oool30000o`030?ooo`000?l0003o00@0oooo0P00nYX20000oa40
oooo0P3o00000`0007l0oooo0?ooo`080?ooo`80o`00203oool20?l000030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00L0
oooo0P3o00030?ooo`80o`000P0007l50?ooo`<0o`001P3oool30000o`80oooo0`00nYX50?ooo`80
003o103oool60000o`80oooo00@0003o0?l0003o0000o`000P3oool20000o`80oooo00@0003o0?l0
003o0000001o1@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?oo
o`040000O`3oool0oooo0?ooo`<0o`0000@0oooo0000o`000?l0003o403oool20000o`80oooo0P00
0?l0103oool0003o0000o`3oool20000o`80oooo0P000?l20?ooo`030000O`000?l0003o00<0003o
1P3oool60000o`@0oooo0`00nYX00`000?l0oooo0?ooo`0?0?ooo`80o`0000<0001o0?ooo`3oool0
203oool20?l000P0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo
00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`070?ooo`80o`000`3oool20?l00080001o
1@3oool20?l000L0oooo0`000?l20?ooo`<00?ZJ1@3oool20000o`@0oooo1P000?l00`3oool0003o
0000o`030?l00080oooo0P000?l20?ooo`040000o`3o0000o`000000O`D0oooo00<000000?ooo`3o
ool03P3oool001/0oooo00<000000?ooo`3oool00`3oool0100007l0oooo0?ooo`3oool20?l00080
oooo0`000?l@0?ooo`80003o0P3oool20000o`040?ooo`000?l0003o0?ooo`80003o0P3oool20000
o`030?ooo`000?l0003o00D0003o1P3oool60000o`<0oooo1000nYX00`000?l0oooo0?ooo`0?0?oo
o`80o`0000<0001o0?ooo`3oool01`3oool30?l000P0oooo0P3o00000`0007l0oooo0?ooo`080?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`060?oo
o`<0o`000`3oool20?l00080001o1@3oool20?l000H0oooo10000?l20?ooo`@00?ZJ103oool20000
o`@0oooo1P000?l00`3oool0003o0000o`020?l000<0oooo0P000?l20?ooo`040000o`3o0000o`00
0000O`D0oooo00<000000?ooo`3oool03P3oool001/0oooo0P0000040?ooo`040000O`3oool0oooo
0?ooo`80o`000P3oool40000o`l0oooo0P000?l20?ooo`80003o00@0oooo0000o`000?l0oooo0P00
0?l20?ooo`80003o00<0oooo0000o`000?l01@000?l50?ooo`L0003o0`3oool5003jVQ40oooo0P3o
00000`0007l0oooo0?ooo`070?ooo`80o`002@3oool20?l000030000O`3oool0oooo00P0oooo00<0
001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00H0oooo0P3o
00040?ooo`80o`000P0007l40?ooo`<0o`001P3oool50000o`030?ooo`00nYX00?ZJ00<00?ZJ0P3o
ool30000o`@0oooo1P000?l00`3oool0003o0000o`020?l000<0oooo0P000?l20?ooo`040000o`3o
0000o`000?l000@0oooo0P00000@0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3o
ool0oooo00<0o`000P3oool40000o`l0oooo0P000?l20?ooo`80003o00@0oooo0000o`000?l0oooo
0P000?l20?ooo`80003o00<0oooo0000o`000?l01@000?l00`3oool0003o0000o`020?ooo`80003o
00<0oooo0000o`000?l00P000?l30?ooo`800?ZJ00@0001o003jVP00nYX00?ZJ403oool20?l00003
0000O`3oool0oooo00L0oooo0P3o00090?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l01P3oool20?l000@0
oooo0P3o00020000O`@0oooo0P3o00070?ooo`80003o00@0oooo0000o`000?l0oooo0P00nYX01@3o
ool00?ZJ003jVP00nYX0oooo00D0003o0P3oool<0000o`040?ooo`000?l0003o0000o`80oooo0P00
0?l20?l000D0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool0
0`0007l0oooo0?l000020?l00080oooo1@000?l?0?ooo`80003o0P3oool20000o`040?ooo`000?l0
003o0?ooo`80003o0P3oool20000o`030?ooo`000?l0003o00D0003o00<0oooo0000o`000?l00P3o
ool20000o`040?ooo`000?l0003o0000o`@0oooo0P00nYX00`0007l0oooo003jVP02003jVPl0oooo
0P3o00000`0007l0oooo0?ooo`070?ooo`80o`002@3oool20?l000030000O`3oool0oooo00P0oooo
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00H0oooo
0P3o00040?ooo`80o`000P0007l30?ooo`<0o`001P3oool30000o`040?ooo`000?l0003o0?ooo`80
0?ZJ0P3oool3003jVPD0003o0P3oool40000o`030?ooo`000?l0003o00D0003o00<0oooo0000o`00
0?l00`3oool20000o`80o`001@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo
0?ooo`030?ooo`040000O`3oool0o`000?l000<0oooo0P000?l00`3oool0003o0000o`0?0?ooo`80
003o1@3oool50000o`80oooo2P000?l00`3oool0003o0000o`020?ooo`80003o00@0oooo0000o`00
0?l0003o103oool2003jVP030000O`3oool0003o00@00?ZJ3@3oool20?l000030000O`3oool0oooo
00L0oooo0P3o00090?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?oo
o`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l01P3oool20?l000@0oooo0P3o00020000
O`<0oooo0P3o00070?ooo`80003o0P3oool20000o`<00?ZJ0`3oool4003jVP<0003o0P3oool40000
o`030?ooo`000?l0003o00P0003o0`3oool20000o`80o`001@3oool00`000000oooo0?ooo`0>0?oo
o`006`3oool00`000000oooo0?ooo`030?ooo`040000O`3oool0o`000?l000<0oooo0P000?l00`3o
ool0003o0000o`0?0?ooo`80003o1P3oool40000o`80oooo3@000?l20?ooo`80003o00@0oooo0000
o`000?l0003o0`3oool3003jVP040000O`3oool0003o0000o`L00?ZJ2@3oool20?l000030000O`3o
ool0oooo00H0oooo0`3o00090?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?oo
o`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l01@3oool30?l000@0oooo0P3o
00020000O`<0oooo0P3o00070?ooo`80003o0P3oool20000o`800?ZJ00<0001o0?ooo`3oool00P3o
ool6003jVPH0003o00<0oooo0000o`000?l020000?l30?ooo`80003o0P3o00050?ooo`030000003o
ool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00@0001o0?l0003o0000o`000`3o
ool20000o`030?ooo`000?l0003o00l0oooo0P000?l60?ooo`T00?ZJ0P0000020000oa<00?ZJ00<0
oooo0000O`3oool00P000?l20?ooo`h00?ZJ0P3o00000`0007l0oooo0?ooo`060?ooo`80o`002P3o
ool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?oo
o`0>0?ooo`030000O`3oool0001o00D0oooo0P3o00050?ooo`80o`000P0007l20?ooo`<0o`001`3o
ool20000o`80oooo0P000?l2003jVP030000O`3oool0oooo00<0oooo00<0003o003jVP00nYX03P00
nYX50000o`<0oooo0P000?l20?l000D0oooo00<000000?ooo`3oool03P3oool001/0oooo00<00000
0?ooo`3oool00`3oool00`0007l0o`000?l000040?ooo`80003o00<0oooo0000o`000?l02`3ooolD
003jVP@000005000nYX20?l000030?ooo`000?l0003o00H0oooo2P00nYX20?l000030000O`3oool0
oooo00H0oooo0P3o000:0?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l01@3oool20?l000D0oooo0P3o0002
0000O`80oooo0P3o00080?ooo`80003o0P3oool20000o`800?ZJ00<0001o0?ooo`3oool00`3oool4
0000o`d00?ZJ1@000?l00`3oool00?ZJ003jVP02003jVP80o`001@3oool00`000000oooo0?ooo`0>
0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3o0000o`0000@0oooo0P000?l00`3o
ool0003o0000o`070?oooa400?ZJ0`000?l20?ooo`80003o10000002003jVP030?ooo`000?l0003o
0080003o0P3oool20000o`T0oooo0P3o00000`3oool0003o0000o`0@0?ooo`80o`0000<0001o0?oo
o`3oool01P3oool20?l000X0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo
00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`050?ooo`80o`001@3oool20?l0
0080001o0P3oool20?l000<0oooo0P000?l30?ooo`80003o0P3oool20000o`03003jVP3o0000o`00
00D0oooo20000?l40?ooo`<0003o0P00nYX30000o`L00?ZJ0P3o00050?ooo`030000003oool0oooo
00h0oooo000K0?ooo`800000103oool00`0007l0o`000?l000040?ooo`80003o00@0oooo0000o`00
0?l0003o103oool7003jVP80oooo0P000?l70?ooo`@0003o0P3oool30000o`80000000@0003o0?oo
o`3oool0oooo1@000?l00`3oool0003o0000o`090?ooo`80o`0000<0oooo0000o`000?l0403oool2
0?l000030000O`3oool0oooo00H0oooo0P3o000:0?ooo`80o`0000<0001o0?ooo`3oool0203oool0
0`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l01@3oool2
0?l000D0oooo0P3o00020000O`80oooo0P3o00030?ooo`80003o0P3oool30000o`80oooo0P000?l0
0`00nYX0o`000?l000050?ooo`P0003o103oool30000o`T00?ZJ0P3oool00`00nYX0o`000?l00004
0?ooo`800000403oool001/0oooo00<000000?ooo`3oool00`3oool30?l000@0oooo0P000?l20?oo
o`80003o0P3oool5003jVPH0oooo0P000?l70?ooo`<0003o0`3oool40000o`030000O`3oool0oooo
0080oooo1@000?l00`3oool0003o0000o`090?ooo`<0o`000P000?l@0?ooo`80o`0000<0001o0?oo
o`3oool01@3oool30?l000X0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo
00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`040?ooo`<0o`001@3oool20?l0
0080001o0P3oool20?l000<0oooo0P000?l20?ooo`80003o0`3oool20000o`04003jVP3o0000o`00
0?l000@0oooo0P000?l30?ooo`<0003o103oool30000o`030?ooo`00nYX00?ZJ00<00?ZJ1@3oool0
0`00nYX0o`000?l000050?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo
00<0oooo0P3o00050?ooo`80003o0P3oool30000o`@00?ZJ203oool20000o`L0oooo0`000?l30?oo
o`<0003o00<0oooo0000O`3oool00`3oool50000o`030?ooo`000?l0003o00T0oooo0`3o00030000
o`l0oooo0P3o00000`0007l0oooo0?ooo`050?ooo`80o`002`3oool20?l000030000O`3oool0oooo
00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o
00@0oooo0P3o00060?ooo`80o`000P0007l0103oool0o`000?l0003o00030?ooo`80003o0P3oool2
0000o`<0oooo0P000?l01000nYX0o`000?l0003o00040?ooo`80003o0`3oool30000o`@0oooo0P00
0?l20?ooo`<00?ZJ0P000?l50?ooo`800?ZJ00<0001o0?ooo`3oool00`3oool00`000000oooo0?oo
o`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`80o`001@3oool20000o`<0oooo1000nYX:
0?ooo`80003o1`3oool30000o`@0oooo0P000?l00`3oool0001o0?ooo`030?ooo`D0003o00<0oooo
0000o`000?l0203oool40?l000030?ooo`000?l0003o00l0oooo0P3o00000`0007l0oooo0?ooo`05
0?ooo`80o`002`3oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool0
0`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00@0oooo0P3o00060?ooo`80o`000P0007l0
0`3oool0o`000?l000040?ooo`H0003o0`3oool00`000?l00?ZJ003jVP030?l000@0oooo0P000?l3
0?ooo`<0003o203oool2003jVP030?ooo`000?l0003o00D0oooo0P00nYX00`0007l0oooo0?ooo`03
0?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo0P3o00050?oo
o`80003o0P3oool4003jVP/0oooo0P000?l80?ooo`80003o1`3oool00`0007l0oooo0?ooo`020?oo
o`P0003o203oool50?l000<0003o3P3oool20?l000030000O`3oool0oooo00D0oooo0P3o000;0?oo
o`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo
00h0oooo00<0001o0?ooo`0007l0103oool20?l000H0oooo0P3o00020000O`030?ooo`3o0000o`00
00@0oooo1P000?l30?ooo`<00?ZJ103o00020?ooo`<0003o103oool20000o`P0oooo0P0000000`3o
ool0003o0000o`050?ooo`800?ZJ00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?oo
o`006`3oool00`000000oooo0?ooo`030?ooo`80o`00103oool30000o`040?ooo`00nYX00?ZJ003j
VP80003o1`3oool20000o`80oooo0P000?l80?ooo`80003o1`3oool00`0007l0oooo0?ooo`020?oo
o`L0003o2@3oool20?l000030000O`3o0000o`0000<0003o3P3oool20?l000030000O`3oool0oooo
00D0oooo0P3o000;0?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?oo
o`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l00`3oool30?l000H0oooo0`3o00001000
07l0oooo0?l0003o00040?ooo`H0003o0P3oool3003jVP030000o`3o0000o`0000<0o`0000<0oooo
0000o`000?l03P3oool4000000L0oooo0`00nYX50?ooo`030000003oool0oooo00h0oooo000K0?oo
o`030000003oool0oooo0080oooo0`3o00040?ooo`80003o0P3oool2003jVP030?ooo`000?l0003o
00L0oooo0P000?l20?ooo`80003o203oool20000o`L0oooo00<0001o0?ooo`3oool00P3oool70000
o`T0oooo0P3o0000100007l0o`000?l0003o00030000o`d0oooo0P3o00000`0007l0oooo0?ooo`04
0?ooo`<0o`002`3oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool0
0`0007l0oooo0?ooo`080?ooo`80003o103oool00`0007l0oooo0000O`030?ooo`80o`00203oool2
0?l000040000O`3o0000o`000?l00080oooo20000?l20?ooo`800?ZJ0P000?l20?l000040?ooo`3o
0000o`000?l00080003o3P3oool4000000L0oooo00<0003o003jVP00nYX01@3oool00`000000oooo
0?ooo`0>0?ooo`006`3oool2000000<0oooo0P3o00050?ooo`80003o00D0oooo003jVP00nYX00?ZJ
0?ooo`030000o`H0oooo0P000?l20?ooo`80003o4@3oool00`0007l0oooo0?ooo`020?ooo`L0003o
2@3oool20?l000030000O`3oool0o`000080o`000P000?l=0?ooo`80o`0000<0001o0?ooo`3oool0
103oool20?l000`0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo
00<0001o0?ooo`3oool0203oool20000o`@0oooo00<0001o0?ooo`0007l00`3oool20?l000P0oooo
0P3o00000`0007l0o`000?l000020?ooo`T0003o1000nYX20000o`80o`000P3oool30?l000030000
o`3oool0oooo00d0oooo0P0000080?ooo`030000o`00nYX00?ZJ00@0oooo0P00000@0?ooo`006`3o
ool00`000000oooo0?ooo`020?ooo`80o`001@3oool20000o`<00?ZJ0`3oool20000o`H0oooo0P00
0?l20?ooo`80003o403oool20?l000D0oooo1P000?l90?ooo`80o`0000<0001o0?ooo`3oool00P3o
00020000o`d0oooo0P3o00000`0007l0oooo0?ooo`040?ooo`80o`00303oool20?l000030000O`3o
ool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`80003o103o
ool00`0007l0oooo0000O`030?ooo`80o`00203oool20?l000030000O`3o0000o`0000X0003o1000
nYX00`3oool0003o0000o`020?l000<0oooo0`3o000@0?ooo`030000O`3oool0oooo00H0oooo00<0
003o003jVP00nYX01@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`02
0?ooo`80o`001@3oool20000o`800?ZJ103oool30000o`D0oooo1P000?l@0?ooo`80o`001@3oool6
0000o`T0oooo0P3o00000`0007l0oooo0?ooo`040?l000d0oooo0`3o00060?ooo`80o`00303oool2
0?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`08
0?ooo`80003o103oool00`0007l0oooo0000O`020?ooo`<0o`00203oool20?l000030000O`3o0000
o`0000X0003o0P00nYX30?ooo`80003o0P3o00040?ooo`<0o`003`3oool00`0007l0oooo0?ooo`06
0?ooo`030000o`00nYX00?ZJ00D0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?oo
o`3oool00`3oool00`0007l0oooo0?ooo`030?ooo`040000o`00nYX00?ZJ003jVP@0oooo0`000?l4
0?ooo`L0003o403oool30?l000H0oooo10000?l80?ooo`<0o`0000@0001o0?ooo`3oool0oooo1@3o
000;0?ooo`03003jVP3o0000o`0000D0oooo0`3o000<0?ooo`80o`0000<0001o0?ooo`3oool0203o
ool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo0`000?l30?ooo`030000O`3o
ool0001o0080oooo0P3o00090?ooo`80o`0000<0001o0?l0003o00000P000?l00`3oool0003o0000
o`040000o`<00?ZJ0`3oool20000o`80o`000P3oool30000o`@0o`003@3oool00`0007l0oooo0?oo
o`060?ooo`030000o`00nYX00?ZJ00D0oooo00<000000?ooo`3oool03P3oool001/0oooo00<00000
0?ooo`3oool00`3oool00`0007l0oooo0?ooo`030?ooo`<00?ZJ1P3oool20000o`@0oooo1P000?l@
0?ooo`D0o`001@3oool40000o`P0oooo0P3o00000`3oool0001o0?ooo`030?ooo`030000o`3o0000
o`0000@0o`00203oool00`00nYX0o`000?l000050?ooo`80o`003@3oool20?l000030000O`3oool0
oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`<0003o0`3oool0
0`0007l0oooo0000O`020?ooo`80o`002@3oool50?l00080003o0P3oool20000o`80oooo0`00nYX6
0?ooo`80o`000P3oool30000o`030?ooo`3o0000o`0000@0o`002P3oool00`0007l0oooo0?ooo`07
0?ooo`800?ZJ1@3oool00`000000oooo0?ooo`0>0?ooo`004P3oool5000000@0oooo00<000000?oo
o`3oool00`3oool00`0007l0oooo0?ooo`030?ooo`800?ZJ1`3oool20000o`@0oooo1P000?l@0?oo
o`80o`0000<0001o0?l0003o0000103o00020?ooo`<0003o203oool20?l000030?ooo`0007l0oooo
00<0oooo0P000?l00`3oool0o`000?l0000:0?l00003003jVP3o0000o`0000D0oooo0P3o000=0?oo
o`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo
00L0oooo10000?l30?ooo`040000O`000?l0003o0?ooo`<0o`000P3oool20000o`D0oooo00D0o`00
000000000000o`000?ooo`020000o`80oooo0P000?l20?ooo`800?ZJ1`3oool20?l000040?ooo`00
0?l0003o0000o`@0oooo2`3o00020?ooo`80o`002@3oool2003jVPD0oooo00<000000?ooo`3oool0
3P3oool001<0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`030?ooo`030000
O`3oool0oooo0080oooo0`00nYX70?ooo`80003o103oool60000o`030?ooo`3o0000o`0000l0o`00
00<0001o0?ooo`3o00004`3o00000`3oool0001o0?ooo`030?ooo`80003o103oool<0?l000D0oooo
0P3o000=0?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00L0oooo10000?l30?ooo`040000O`000?l0003o0?ooo`80o`000`3oool20000o`D0
oooo100000000`3oool0003o0000o`020?ooo`80003o00@0oooo003jVP00nYX00?ZJ1`3oool20?l0
00<0003o203oool<0?l000T0oooo0P000?l50?ooo`030000003oool0oooo00h0oooo000<0?ooo`D0
00000`3oool00`000000oooo0?ooo`040?ooo`<000000`3oool00`0007l0oooo0?ooo`020?ooo`80
0?ZJ00<0003o0?ooo`3oool01@3oool30000o`<0oooo0`000?lE0?l000030000O`3oool0oooo00<0
oooo403o00000`3oool0001o0?ooo`030?ooo`<0003o2`3oool40?l000D0oooo0P3o000=0?ooo`80
o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00L0
oooo10000?l30?ooo`040000O`000?l0003o0?ooo`80o`0000<0oooo0000o`000?l00P000?l50?oo
o`@000000`000?l20?ooo`80003o00<0oooo003jVP00nYX01`3oool30?l000<0003o3`3oool60?l0
00@0oooo1@3o000010000?l0oooo0?ooo`3oool300000100oooo000E0?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`04003jVPT0oooo0P000?l30?oo
o`80003o1P3o000@0?ooo`030000O`3oool0oooo00H0oooo0P000?l<0?ooo`030000O`3oool0oooo
00<0oooo0P000?l<0?ooo`<0o`00103oool30?l000d0oooo0P3o00000`0007l0oooo0?ooo`080?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01`3oool50000o`80oooo00<0001o0000
o`000?l00`3o00000`3oool0003o0000o`020000o`D0oooo00@0o`00000000000000o`000`000?l4
0?ooo`<00?ZJ1`3oool20?l000@0003o4`3oool;0?l000030000o`3oool0oooo00<0oooo00<00000
0?ooo`3oool03P3oool00180oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0
oooo00<0oooo00<0001o0?ooo`00nYX00`00nYX00`000?l0oooo0?ooo`070?ooo`80003o00<0oooo
0000o`3o0000103o000D0?ooo`030000O`3oool0oooo00H0oooo0P000?l<0?ooo`030000O`3oool0
oooo00<0oooo0P000?l<0?ooo`<0o`00103oool20?l000h0oooo0P3o00000`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01`3oool20000o`030?ooo`000?l0
003o0080oooo00<0001o0000o`000?l00P3o00020?ooo`@0003o1@3oool40?l00080003o103oool3
003jVPP0oooo0P3o00030000oa@0oooo00<0001o0?l0003o0000103o00020?ooo`80o`0000<0003o
0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`004P3oool01@000000oooo0?ooo`3oool0
000000@0oooo00<000000?ooo`3oool00`3oool01@0007l0oooo003jVP00nYX0oooo0080003o2@3o
ool20000o`030?ooo`3o0000o`0000<0o`005@3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3o
ool0oooo00<0oooo0P000?l<0?ooo`<0o`00103oool20?l000h0oooo0P3o00000`0007l0oooo0?oo
o`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01`3oool20000o`030?ooo`00
0?l0003o0080oooo00<0001o0000o`000?l00P3o00020?ooo`@0003o1@3oool30?l000<0003o103o
ool2003jVPT0oooo0P3o00030000oa@0oooo00<0001o0?ooo`3oool01P3oool20?l000030000o`3o
ool0oooo00<0oooo00<000000?ooo`3oool03P3oool001<0oooo0`0000050?ooo`030000003oool0
oooo0080oooo0P000003003jVP030?ooo`000?l0003o00T0oooo0P000?l30?l00080003o5P3oool0
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00<0oooo0P000?l<0?ooo`<0o`000`3oool3
0?l000h0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o
0?ooo`3oool01`3oool20000o`030?ooo`000?l0003o0080oooo00<0001o0000o`000?l00P3o0000
0`3oool0003o0000o`030000o`D0oooo0`3o00030000o`<0oooo0`00nYX90?ooo`80o`000P000?lE
0?ooo`030000O`3oool0oooo00H0oooo0P3o00000`0007l0oooo0?ooo`030?ooo`030000003oool0
oooo00h0oooo000K0?ooo`040000003oool0oooo0?ooo`@0000000<00?ZJ0?ooo`3oool00P000?l9
0?ooo`040000o`3o0000o`000?l00080003o5`3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3o
ool0oooo00<0oooo0P000?l<0?ooo`<0o`000`3oool20?l000l0oooo0P3o00000`0007l0oooo0?oo
o`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01`3oool20000o`040?ooo`00
0?l0003o0?ooo`<0003o0`3o00000`3oool0003o0000o`040000o`@0oooo0`3o00030000o`<0oooo
0P00nYX:0?ooo`80o`000P000?lE0?ooo`030000O`3oool0oooo00H0oooo0`3o00050?ooo`030000
003oool0oooo00h0oooo000K0?ooo`040000003oool0oooo0?ooo`@0000000<00?ZJ0?ooo`3oool0
0P000?l90?ooo`030000o`3o0000o`0000<0003o5`3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00<0oooo0P000?l<0?ooo`<0o`000`3oool20?l000l0oooo0P3o00000`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01`3oool20000o`030?oo
o`000?l0003o00@0003o0P3o00020?ooo`80003o0P3oool20000o`@0oooo0`3o00030000o`80oooo
0`00nYX:0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`070?ooo`80o`00
1@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`020?ooo`80000000@0
0?ZJ0?ooo`3oool0oooo0P000?l90?ooo`<0o`000`000?lG0?ooo`030000O`3oool0oooo01@0oooo
00<0001o0?ooo`3oool00`3oool20000o`030?ooo`000?l0003o00T0oooo0`3o00020?ooo`<0o`00
3`3oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo
0?ooo`050?ooo`@0003o0P3oool50000o`80o`000P3oool20000o`80oooo0P000?l40?ooo`<0o`00
0`000?l0103oool00?ZJ003jVP00nYX;0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0
oooo0?ooo`070?ooo`8000001@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool2000000<0oooo
0`00nYX30?ooo`80003o2@3oool20?l000@0003o5`3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00<0oooo1@000?l90?ooo`<0o`000P3oool20?l00100oooo0P3o00000`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo00P0oooo0P000?l60?ooo`<0003o0`3oool30000o`@0o`00
0P3oool20000o`80oooo0P000?l40?ooo`<0o`0000<0003o0?ooo`3oool00`00nYX<0?ooo`80o`00
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`060?ooo`@000000`3oool200000100oooo
000K0?ooo`030000003oool0oooo0080oooo0P00nYX40?ooo`80003o203oool30?l00080003o6@3o
ool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00@0oooo10000?l90?ooo`<0o`0000@0
oooo0?l0003o0000o`00403oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
203oool20000o`H0oooo0`000?l30?ooo`<0003o103o00020?ooo`80003o0P3oool20000o`@0oooo
0`3o00000`000?l0oooo003jVP02003jVPd0oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00H0oooo100000040?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003o
ool0oooo00<0oooo00<0001o0?ooo`3oool00P3oool20000o`L0oooo0`3o00030000oaT0oooo00<0
001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`050?ooo`<0003o2@3oool30?l000030?ooo`3o
0000o`000140oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo0`00
0?l50?ooo`<0003o0`3oool30000o`@0o`0000@0oooo0000o`000?l0003o0P3oool20000o`@0oooo
0`3o000010000?l0oooo003jVP00nYX>0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0
oooo0?ooo`070?ooo`8000001@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0oooo0080oooo0P000?l70?ooo`80o`0000<0oooo0000o`000?l0
6P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00H0oooo0P000?l90?ooo`<0o`00
00<0oooo0?l0003o00004@3oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
203oool30000o`D0oooo0P000?l40?ooo`80003o103o000010000?l0oooo0000o`000?l30?ooo`80
003o0`3oool01@00nYX0o`000?l0003o0000003o00<00?ZJ3P3oool20?l000030000O`3oool0oooo
01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo
00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool00P3oool20000o`H0
oooo0`3o00000`3oool0003o0000o`0J0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool01P3oool20000o`T0oooo1P3o000A0?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`080?ooo`<0003o1@3oool20000o`@0oooo0P000?l40?l000040000o`3oool0003o0000
o`<0oooo0P000?l20?ooo`800?ZJ0`3o0003003jVPl0oooo0P3o00000`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?oo
o`006`3oool00`000000oooo0?ooo`030?ooo`040000O`3oool0oooo0?ooo`<0003o1@3oool30?l0
0080oooo0P000?lJ0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool01P3oool20000
o`T0oooo1@3o000B0?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?oo
o`<0003o1@3oool20000o`@0oooo0P000?l20?l000040?ooo`000?l0003o0?ooo`80003o0`3oool2
0000o`040?ooo`00nYX00?ZJ003jVP<0o`000P00nYX@0?ooo`80o`0000<0001o0?ooo`3oool0503o
ool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3o
ool001/0oooo00<000000?ooo`3oool00`3oool0100007l0oooo0?ooo`3oool20000o`D0oooo0`3o
00030?ooo`80003o6P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00H0oooo0`00
0?l80?ooo`D0o`004P3oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203o
ool30000o`@0oooo0`000?l40?ooo`80003o0P3o0000103oool0003o0000o`3oool20000o`<0oooo
0P000?l4003jVP<0o`000P00nYX@0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo0P00
00040?ooo`040000O`3oool0oooo0?ooo`80003o1@3oool20?l00200oooo00<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`070?ooo`80003o203oool50?l00180oooo0`3o000:0?ooo`030000
O`3oool0oooo00L0oooo10000?l40?ooo`80003o1@3oool20000o`80o`0000@0oooo0000o`000?l0
oooo0P000?l40?ooo`<00?ZJ00<0oooo003jVP3o00000P3o00000`00nYX0oooo0?ooo`0>0?ooo`<0
o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo0080
oooo0P00000@0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`040000O`3oool0oooo0?ooo`80
003o103oool30?l00200oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`070?ooo`80
003o203oool50?l001<0oooo0P3o000:0?ooo`030000O`3oool0oooo00L0oooo10000?l40?ooo`80
003o1P3oool010000?l0o`000?l0003oool50000o`@0oooo0P00nYX20?ooo`04003jVP3o0000o`00
003jVQ40oooo0P3o00000`3oool0001o0?ooo`0E0?ooo`030000O`3oool0oooo00P0oooo00<0001o
0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?oo
o`040000O`3oool0oooo0?ooo`80003o103oool20?l00240oooo00<0001o0?ooo`3oool0503oool0
0`0007l0oooo0?ooo`070?ooo`80003o203oool40?l001@0oooo0P3o000:0?ooo`030000O`3oool0
oooo00L0oooo1@000?l30?ooo`80003o1P3oool01@000?l0o`000?l0003oool0001o00@0003o0`3o
ool3003jVP80oooo00@00?ZJ0?l0003o00000?ZJ4@3oool20?l000030?ooo`0007l0oooo01D0oooo
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo
000K0?ooo`030000003oool0oooo00<0oooo00@0001o0000o`000?l0oooo0P000?l40?ooo`80o`00
8@3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00L0oooo0P000?l80?ooo`@0o`00
503oool20?l000X0oooo00<0001o0?ooo`3oool01`3oool2000000030?ooo`000?l0003o00<0oooo
00@0003o0?l0003o0000o`00103oool01@000?l000000000003oool0001o00<0003o0`3oool3003j
VP040000o`3oool0oooo003jVP80o`0000<00?ZJ0?ooo`3oool03P3oool30?l000030?ooo`0007l0
oooo01D0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0
oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0000o`000?l00`000?l30?oo
o`<0o`008@3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00L0oooo0P000?l80?oo
o`@0o`00503oool20?l000X0oooo00<0001o0?ooo`3oool01P3oool400000080003o0`3oool50?l0
00<0oooo10000000100007l0003o0000o`000?l20?ooo`<00?ZJ0P000?l20?ooo`04003jVP3o0000
o`00003jVQ00oooo0P3o00020?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203o
ool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0
oooo00<0oooo00<0001o0000o`000?l00`000?l20?ooo`<0o`008P3oool00`0007l0oooo0?ooo`0D
0?ooo`030000O`3oool0oooo00L0oooo0P000?l80?ooo`@0o`00503oool20?l000X0oooo00<0001o
0?ooo`3oool01P3oool400000080003o0P3oool30?l000040?ooo`3o0000o`000?l00080oooo1000
00001@0007l0003o0000o`000?l0oooo00<00?ZJ00<0oooo0000o`000?l00P000?l01000nYX0o`00
0?l00000nYX@0?ooo`80o`000P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo
0?ooo`030?ooo`040000O`000?l0003o0?ooo`80003o0P3oool20?l002<0oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`070?ooo`80003o203oool30?l001D0oooo0P3o000:0?ooo`03
0000O`3oool0oooo00L0oooo0P000000103oool0003o0000o`3oool30?l000030000o`3oool0oooo
00<0o`0000<0oooo0?l0000000000`0000000`000?l00?ZJ003jVP03003jVP80oooo10000?l01000
nYX0o`000?l00000nYX?0?ooo`<0o`000P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0
oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool20000
00<0oooo0P3o00020000o`@0oooo0`3o000S0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool01`3oool20000o`T0oooo0P3o000E0?ooo`80o`002P3oool00`0007l0oooo0?ooo`070?oo
o`80003o00<0oooo0000o`000?l00`3o00020000o`<0oooo0P3o00000`3oool0o`000?l000040000
00@00?ZJ103oool30000o`04003jVP3o0000o`00003jVPl0oooo0P3o00030?ooo`030000O`3oool0
oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`020?ooo`800000403oool0
01/0oooo00<000000?ooo`3oool00P3oool30?l000040000o`3oool0oooo0?ooo`<0o`00903oool0
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00L0oooo0P000?l90?ooo`80o`005@3oool2
0?l000X0oooo00<0001o0?ooo`3oool01`3oool20000o`030?ooo`000?l0o`000080o`000`000?l3
0?ooo`D0o`00100000000`00nYX0oooo0?ooo`050?ooo`<0003o00@00?ZJ0?l0003o00000?ZJ3`3o
ool20?l000<0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3o
ool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00P3oool0
0`000?l0o`000?l000060?l002D0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`07
0?ooo`80003o2@3oool20?l001D0oooo0P3o000:0?ooo`030000O`3oool0oooo00L0oooo0P000?l0
103oool0o`000?l0003o00030000o`D0oooo103o0000100007l0000000000000nYX80?ooo`<0003o
00@00?ZJ0?l0003o00000?ZJ3P3oool30?l000<0oooo00<0001o0?ooo`3oool0503oool00`0007l0
oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo
00<000000?ooo`3oool00P3oool20000o`H0o`009P3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00L0oooo0`000?l80?ooo`80o`005@3oool20?l000X0oooo00<0001o0?ooo`3oool0
1`3oool20000o`040?ooo`3o0000o`000?ooo`<0003o1P3oool30?l000<00?ZJ2`3oool01@000?l0
0?ZJ0?l0003o00000?ZJ00h0oooo0P3o00040?ooo`030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`03
0000003oool0oooo00<0oooo0P000?l[0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool0203oool20000o`P0oooo0P3o000E0?ooo`80o`002P3oool00`0007l0oooo0?ooo`070?ooo`80
003o0`3o00040000o`H0oooo0`3o0002003jVP030000O`3oool0oooo00T0oooo0P000?l00`00nYX0
o`000?l0000>0?ooo`80o`00103oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`00503oool2000000D0oooo
00<000000?ooo`3oool00`3oool20000ob/0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`080?ooo`80003o203oool20?l001D0oooo0P3o000:0?ooo`030000O`3oool0oooo00H0oooo
0`000?l20?l000@0003o203oool20?l00003003jVP3oool0001o00/0oooo0P000?l00`00nYX0o`00
0?l0000=0?ooo`<0o`00103oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo
00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`004`3oool010000000oooo0?oo
o`0000040?ooo`030000003oool0oooo00<0oooo0P000?l[0?ooo`030000O`3oool0oooo01@0oooo
00<0001o0?ooo`3oool0203oool20000o`P0oooo0P3o000E0?ooo`80o`002P3oool00`0007l0oooo
0?ooo`060?ooo`80003o0`3o00040000o`T0oooo0P00nYX00`3oool0001o0?ooo`0:0?ooo`80003o
00@00?ZJ0?l0003o0000o`002`3oool30?l000D0oooo00<0001o0?ooo`3oool0503oool00`0007l0
oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001<0oooo
00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0
oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`80003o203oool20?l001D0
oooo0P3o000:0?ooo`030000O`3oool0oooo00H0oooo0P000?l20?l000030?ooo`000?l0003o0080
003o2@3oool2003jVP030?ooo`0007l0oooo00X0oooo0P000?l01000nYX0o`000?l0003o000;0?oo
o`80o`001P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?oo
o`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`004`3oool010000000oooo0?ooo`0000040?oo
o`<000000`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool0203oool20000o`P0oooo0P3o000E0?ooo`80o`002P3oool00`0007l0oooo0?ooo`060?oo
o`050000o`3o0000o`000?l0003oool00`000?l:0?ooo`800?ZJ00<0oooo0000O`3oool02P3oool2
0000o`04003jVP3o0000o`000?l000X0oooo0`3o00060?ooo`030000O`3oool0oooo01@0oooo00<0
001o0?ooo`3oool0203oool0100007l0oooo0?ooo`3oool300000100oooo000C0?ooo`040000003o
ool0oooo000000@0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool20000o`P0oooo0P3o00000`00nYX0oooo
0?ooo`0B0?ooo`80o`002P3oool00`0007l0oooo0?ooo`060?ooo`030000o`3o0000o`000080oooo
0`000?l:0?ooo`800?ZJ00<0oooo0000O`3oool02P3oool20000o`03003jVP3o0000o`000080o`00
2@3oool20?l000L0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001<0oooo00@000000?ooo`3oool00000
103oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`080?ooo`80003o203oool20?l000L00?ZJ3P3oool20?l000X0oooo
00<0001o0?ooo`3oool01P3oool00`000?l0o`000?l000020?ooo`<0003o2P3oool2003jVP030?oo
o`0007l0oooo00/0oooo00<0003o003jVP3o00000`3o00080?ooo`<0o`001`3oool00`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`00503oool2000000D0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool20000o`P0oooo0P3o
000:003jVP/0oooo0P3o000:0?ooo`030000O`3oool0oooo00H0oooo00<0003o0?l0003o00000P3o
ool30000o`X0oooo0P00nYX00`3oool0001o0?ooo`0;0?ooo`030000o`00nYX0o`0000@0o`001`3o
ool20?l000P0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3o
ool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool0
0`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool2
0000o`P0oooo0P3o00060?ooo`L00?ZJ203oool20?l000X0oooo00<0001o0?ooo`3oool01P3oool0
0`000?l0o`000?l000030?ooo`80003o2P3oool2003jVP030?ooo`0007l0oooo00/0oooo00D0003o
003jVP3o0000o`000?ooo`030?l000D0oooo0`3o00080?ooo`030000O`3oool0oooo01@0oooo00<0
001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K
0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D
0?ooo`030000O`3oool0oooo00P0oooo0P000?l80?ooo`80o`002@3oool6003jVPH0oooo0P3o000:
0?ooo`030000O`3oool0oooo00H0oooo00<0003o0?l0003o00000`3oool20000o`X0oooo0P00nYX2
0?l000d0oooo00<00?ZJ0?l0003o00000P3oool40?l00080oooo0`3o00090?ooo`030000O`3oool0
oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0
oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`00
07l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo0`000?l70?ooo`80o`00303oool5003j
VP@0oooo0P3o000:0?ooo`030000O`3oool0oooo00H0oooo00<0003o0?l0003o00000`3oool20000
o`X0oooo0P00nYX20?l000d0oooo00<00?ZJ0?l0003o00000`3oool70?l000X0oooo00<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?oo
o`3oool03P3oool001/0oooo0P0000040?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`090?ooo`80003o1`3oool20?l000h0oooo1000nYX30?ooo`80
o`002P3oool00`0007l0oooo0?ooo`040?ooo`<0003o0P3o00030?ooo`80003o2P3oool2003jVP80
o`003@3oool00`00nYX0o`000?l000050?ooo`@0o`002`3oool00`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00P3oool200000100oooo000K0?ooo`030000
003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00T0oooo0P000?l70?ooo`80o`00403oool4003jVP030?ooo`3o0000o`0000X0oooo
00<0001o0?ooo`3oool0103oool30000o`80o`003`3oool2003jVP<0o`00303oool00`00nYX0o`00
0?l0000D0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo
0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0
001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00T0oooo0P00
0?l70?ooo`80o`004@3oool4003jVP80o`002P3oool00`0007l0oooo0?ooo`040?ooo`<0003o0P3o
000?0?ooo`D0o`00303oool2000000030?l0003oool0oooo0180oooo00<0001o0?ooo`3oool0503o
ool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3o
ool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0
oooo01@0oooo00<0001o0?ooo`3oool02@3oool20000o`L0oooo0P3o000C0?ooo`800?ZJ0P3o000:
0?ooo`030000O`3oool0oooo00@0oooo0`000?l20?l000l0oooo1@3o000;0?ooo`@00000503oool0
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool0
0`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo
02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`090?ooo`80003o1`3oool20?l0
01<0oooo0P00nYX20?l000X0oooo00<0001o0?ooo`3oool0103oool30000o`80o`003`3oool60?l0
00X0oooo1000000D0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0
oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00T0
oooo0P000?l70?ooo`80o`004`3oool2003jVP80o`002P3oool00`0007l0oooo0?ooo`040?ooo`<0
003o0P3o000?0?ooo`<0o`0000<0001o0?l0003o00002`3oool2000000030000O`3oool0oooo0180
oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0
oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo
0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool02@3oool20000o`L0oooo
0P3o000C0?ooo`800?ZJ0P3o000:0?ooo`030000O`3oool0oooo00@0oooo0P000?l0103oool0o`00
0?l00000nYX>0?ooo`<0o`0000<0001o0?l0003o00002`3oool20?l000030000O`3oool0oooo0180
oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0
oooo00<000000?ooo`3oool03P3oool001/0oooo0P0000040?ooo`030000O`3oool0oooo02X0oooo
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`090?ooo`<0003o1P3oool20?l001<0oooo
0P00nYX20?l000X0oooo00<0001o0?ooo`3oool00`3oool30000o`<0o`0000<00?ZJ0?ooo`3oool0
303oool30?l000040000O`3o0000o`000?l000X0oooo0P3o00000`0007l0oooo0?ooo`0B0?ooo`03
0000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`020?ooo`80
0000403oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool02P3oool20000o`H0oooo0`3o000B0?ooo`800?ZJ
0P3o000:0?ooo`030000O`3oool0oooo00<0oooo0P000?l00`3oool0o`000?l00003003jVPd0oooo
0P3o00000`3oool0001o0?ooo`020?l000X0oooo0P3o00000`0007l0oooo0?ooo`0B0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000
003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3o
ool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00X0oooo0`000?l60?ooo`80o`004P3o
ool2003jVP80o`002P3oool00`0007l0oooo0?ooo`030?ooo`80003o00<0oooo0?l0003o00001@00
nYX:0?ooo`06003jVP3o0000o`000?ooo`0007l0oooo0P3o000:0?ooo`80o`0000<0001o0?ooo`3o
ool04P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000
O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0:0?ooo`<0003o
1P3oool20?l00180oooo0P00nYX20?l000X0oooo00<0001o0?ooo`3oool00`3oool20000o`050?oo
o`3o0000o`00003jVP3oool01000nYX90?ooo`06003jVP3o0000o`000?ooo`0007l0oooo0`3o0009
0?ooo`80o`0000<0001o0?ooo`3oool04P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0
oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`00
07l0oooo0?ooo`0;0?ooo`80003o1P3oool20?l00180oooo0P00nYX20?l000X0oooo00<0001o0?oo
o`3oool00`3oool20000o`040?ooo`3o0000o`00003jVP<0oooo0P00nYX90?ooo`05003jVP3o0000
o`000?ooo`0007l00P3oool30?l000P0oooo0P3o00000`0007l0oooo0?ooo`0B0?ooo`030000O`3o
ool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003o
ool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool0
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00/0oooo0P000?l60?ooo`<0o`004@3oool2
003jVP80o`002P3oool00`0007l0oooo0?ooo`030?ooo`80003o00@0oooo0?l0003o00000?ZJ0`3o
ool3003jVPP0oooo00D00?ZJ0?l0003o0000oooo0000O`030?ooo`80o`00203oool20?l000030000
O`3oool0oooo0180oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3o
ool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool02`3o
ool20000o`H0oooo00<0001o0?l0003o00004@3oool2003jVP80o`002P3oool00`0007l0oooo0?oo
o`030?ooo`80003o00@0oooo0?l0003o00000?ZJ103oool3003jVPL0oooo00D00?ZJ0?l0003o0000
oooo0000O`030?ooo`<0o`001`3oool20?l000030000O`3oool0oooo0180oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3o
ool03P3oool001/0oooo0P0000040?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`0;0?ooo`80003o1P3oool00`0007l0o`000?l0000A0?ooo`800?ZJ
0P3o000:0?ooo`030000O`3oool0oooo00<0oooo0P000?l0103oool0o`000?l00000nYX50?ooo`80
0?ZJ1`3oool01@00nYX0o`000?l0003oool0001o00@0oooo0P3o00070?ooo`80o`0000<0001o0?oo
o`3oool04P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?oo
o`3oool00P3oool200000100oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3o
ool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00/0oooo0P000?l60?ooo`03
0000O`3o0000o`000140oooo0P00nYX20?l000T0oooo0P0000040?l000<0003o00@0oooo0?l0003o
00000?ZJ1@3oool3003jVPH0oooo00D00?ZJ0?l0003o0000oooo0000O`040?ooo`80o`001`3oool2
0?l000030000O`3oool0oooo0180oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?oo
o`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool02`3oool30000o`D0oooo00@0001o0?l0003o0000o`003@3oool20000o`80oooo00<00?ZJ
0?l0003o0000203oool4000000D0o`000P3oool30?l000H0oooo0P00nYX60?ooo`05003jVP3o0000
o`000?ooo`0007l0103oool30?l000H0oooo0P3o00000`0007l0oooo0?ooo`0B0?ooo`030000O`3o
ool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003o
ool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool0
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00`0oooo0P000?l50?ooo`040000O`3oool0
o`000?l000d0oooo0P000?l20?ooo`04003jVP3o0000o`000000o`L0oooo100000020?ooo`@0o`00
00@0oooo0?l0003o0000o`001P3oool3003jVPD0oooo00D00?ZJ0?l0003o0000oooo0000O`050?oo
o`80o`001P3oool20?l000030000O`3oool0oooo0180oooo00<0001o0?ooo`3oool0503oool00`00
07l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0
oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0
oooo00<0001o0?ooo`3oool0303oool20000o`D0oooo00@0001o0?ooo`3o0000o`003@3oool20000
o`80oooo00@00?ZJ0?l0003o0000003o203oool2000000@0oooo00<0003o0?l0003o0000103o0007
0?ooo`800?ZJ1@3oool01@00nYX0o`000?l0003oool0001o00D0oooo0P3o00060?ooo`80o`0000<0
001o0?ooo`3oool04P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0
001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`004P3oool5000000@0oooo00<00000
0?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o
0?ooo`3oool0303oool20000o`D0oooo00<0001o0?ooo`3o00000P3o000<0?ooo`80003o0P3oool0
1000nYX0o`000?l000000?l80?ooo`80o`00103oool20000o`H0o`001P3oool3003jVP@0oooo00D0
0?ZJ0?l0003o0000oooo0000O`050?ooo`<0o`001@3oool20?l000030000O`3oool0oooo0180oooo
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool03P3oool001<0oooo00@000000?ooo`3oool00000103oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`0<0?ooo`80003o1@3oool00`0007l0oooo0?ooo`020?l000`0oooo0P000?l20?ooo`04003j
VP3o0000o`000000o`P0oooo0P3o00030?ooo`<0003o0P3oool40?l000L0oooo0`00nYX30?ooo`05
003jVP3o0000o`000?ooo`0007l01P3oool20?l000D0oooo0P3o00000`0007l0oooo0?ooo`0B0?oo
o`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?oo
o`030000003oool0oooo00h0oooo000D0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool0303oool20000o`D0oooo00<0001o0?ooo`3oool00`3o000;0?ooo`80003o0P3oool01000nYX0
o`000?l000000?l80?ooo`80o`0000<0003o0?ooo`3oool00P000?l30?ooo`04003jVP3o0000o`00
0?l000P0oooo0P00nYX30?ooo`05003jVP3o0000o`000?ooo`0007l01P3oool20?l000D0oooo0P3o
00000`0007l0oooo0?ooo`0B0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203o
ool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000E0?ooo`030000003oool0
oooo00<0oooo0`0000030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool0
0`0007l0oooo0?ooo`0<0?ooo`80003o1@3oool0100007l0oooo0?ooo`3oool20?l000/0oooo0P00
0?l20?ooo`04003jVP3o0000o`000000o`@0oooo0`000?l30?l000030000o`3oool0oooo0080003o
0`3oool01000nYX0o`000?l0003o00080?ooo`<00?ZJ0P3oool01@00nYX0o`000?l0003oool0001o
00H0oooo0`3o00040?ooo`80o`0000<0001o0?ooo`3oool04P3oool00`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo00P0oooo00@0001o0?ooo`3oool0oooo0`00000@0?ooo`004P3oool01@00
0000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z
0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0303oool20000o`D0oooo00@0001o
0?ooo`3oool0oooo0P3o000;0?ooo`80003o0P3oool01000nYX0o`000?l000000?l40?ooo`<0003o
0P3o00020000o`80oooo0P000?l30?ooo`04003jVP3o0000o`000?l000T0oooo0P00nYX20?ooo`05
003jVP3o0000o`000?ooo`0007l01`3oool20?l000@0oooo0P3o00000`0007l0oooo0?ooo`0B0?oo
o`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?oo
o`030000003oool0oooo00h0oooo000B0?ooo`050000003oool0oooo0?ooo`000000103oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`00
07l0oooo0?ooo`0<0?ooo`80003o1@3oool0100007l0oooo0?ooo`3oool30?l000T0oooo0`000?l2
0?ooo`04003jVP3o0000o`000000o`@0oooo0`000?l20?l00080003o0P3oool20000o`<0oooo00<0
0?ZJ0?l0003o00000P3o00080?ooo`<00?ZJ00H0oooo003jVP3o0000o`000?ooo`0007l70?ooo`80
o`00103oool20?l000030000O`3oool0oooo0180oooo00<0001o0?ooo`3oool0503oool00`0007l0
oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001<0oooo
0`0000050?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00`0oooo0`000?l40?ooo`030000O`3oool0oooo0080oooo
0P3o00090?ooo`@0003o00D0oooo003jVP3o0000o`000000o`040?ooo`<0003o0P3o00020000o`04
0?ooo`000?l0003o0000o`<0oooo00<00?ZJ0?l0003o00000P3o00090?ooo`@00?ZJ0P3o00000`3o
ool0001o0?ooo`060?ooo`<0o`000`3oool20?l000030000O`3oool0oooo0180oooo00<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?oo
o`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`03
0000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03@3oool20000o`@0oooo00<0001o0?ooo`3o
ool00P3oool20?l000T0oooo10000?l01@3oool00?ZJ0?l0003o0000003o00@0oooo1@3o00020000
o`030?ooo`000?l0003o00@0oooo00<00?ZJ0?l0003o00000P3o000:0?ooo`<00?ZJ0P3o00000`3o
ool0001o0?ooo`070?ooo`80o`000P3oool30?l000030000O`3oool0oooo0180oooo00<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?oo
o`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`03
0000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03@3oool20000o`@0oooo00<0001o0?ooo`3o
ool00P3oool20?l000T0oooo10000?l0103oool00?ZJ0?l0003o00020000o`80oooo1@3o00030000
o`030?ooo`000?l0003o00@0oooo00<00?ZJ0?l0003o00000P3o000;0?ooo`800?ZJ0P3o00000`3o
ool0001o0?ooo`070?ooo`80o`000P3oool20?l00080001o503oool00`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?oo
o`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`0=0?ooo`80003o103oool00`0007l0oooo0?ooo`020?ooo`80
o`002@3oool40000o`040?ooo`00nYX0o`000?l00080003o00@0oooo0?l0003o0000o`000`000?l2
003jVP040000o`3oool0003o0000o`@0oooo00<00?ZJ0?l0003o00000P3o000<0?ooo`05003jVP3o
0000o`000?ooo`0007l0203oool30?l000030?ooo`3o0000o`000080001o503oool00`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`006`3oool2000000@0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?oo
o`0D0?ooo`030000O`3oool0oooo00d0oooo0P000?l40?ooo`030000O`3oool0oooo0080oooo0`3o
00080?ooo`@0003o00@0oooo003jVP3o0000o`000P000?l30?l000@0003o0`00nYX00`3oool0003o
0000o`040?ooo`03003jVP3o0000o`0000<0o`00303oool20?l000030?ooo`0007l0oooo00P0oooo
0P3o00000`3oool0o`000?l000020000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo0080oooo0P00000@0?ooo`006`3oool00`000000oooo0?oo
o`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?oo
o`0=0?ooo`<0003o0`3oool00`0007l0oooo0?ooo`030?ooo`80o`00203oool40000o`050?ooo`00
nYX0o`000?l000000?l00`3o00020000o`80oooo00<0003o003jVP00nYX00P00nYX20000o`@0oooo
00@00?ZJ0?l0003o0000oooo0P3o000<0?ooo`80o`0000<0oooo0000O`3oool0203oool20?l00003
0?ooo`3o0000o`000080001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`0>0?ooo`80003o0`3oool00`0007l0oooo0?ooo`030?ooo`80o`00203oool40000o`030?oo
o`00nYX0o`0000@0o`0000<0oooo0000o`000?l00P3oool00`000?l00?ZJ003jVP02003jVP80003o
103oool01000nYX0o`000?l0003oool20?l000`0oooo0P3o00000`3oool0001o0?ooo`080?ooo`D0
o`000P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo
00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00h0oooo
0P000?l30?ooo`030000O`3oool0oooo00<0oooo0P3o00020?ooo`80003o103oool40000o`030?oo
o`00nYX0o`0000<0o`000P3oool20000o`80oooo00<0003o003jVP00nYX00`00nYX00`000?l0oooo
0?ooo`020?ooo`04003jVP3o0000o`000?ooo`80o`00303oool20?l000030?ooo`0007l0oooo00T0
oooo103o00020000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`03
0000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool0
0`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0
3P3oool20000o`<0oooo00<0001o0?ooo`3oool00`3oool30?l000030?ooo`000?l0003o00@0oooo
10000?l00`3oool00?ZJ0?l000030?l00080oooo0P000?l20?ooo`040000o`00nYX00?ZJ0000o`<0
0?ZJ103oool01000nYX0o`000?l0003oool30?l000/0oooo0P3o00000`3oool0001o0?ooo`090?oo
o`@0o`000P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0
oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00h0
oooo0P000?l30?ooo`030000O`3oool0oooo00@0oooo0P3o00000`3oool0003o0000o`040?ooo`@0
003o00<0oooo003jVP3o00000P3o00000`000?l0oooo0?ooo`020000o`80oooo00<0003o003jVP00
nYX00P000?l4003jVP80oooo00<00?ZJ0?l0003o00000P3oool20?l000X0oooo0`3o00000`3oool0
001o0?ooo`0:0?ooo`<0o`000P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000
003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00h0oooo0P000?l30?ooo`030000O`3oool0oooo00@0oooo0P3o00030000o`@0oooo
10000?l0103oool00?ZJ0?l0003o00020000o`80oooo0P000?l20?ooo`<00?ZJ0`000?l6003jVP80
o`000P3oool30?l000T0oooo0P3o00000`0007l0oooo0000O`0<0?ooo`80o`000P0007lD0?ooo`03
0000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`03
0000003oool0oooo00h0oooo000K0?ooo`800000103oool00`0007l0oooo0?ooo`0Z0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03P3oool20000o`<0oooo00<0001o0?ooo`3oool0
103oool20?l000<0003o103oool50000o`800?ZJ00<0001o0000o`000?l00P3oool20000o`80oooo
0P00nYX00`0007l0003o0000o`020000o`040?ooo`00nYX00?ZJ003jVP<0o`000`3oool20?l000T0
oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00P3oool200000100oooo000K0?ooo`030000
003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00h0oooo0P000?l20?ooo`8000001P3oool20?l000<0003o103oool50000o`800?ZJ
00<0001o0000o`000?l00P3oool20000o`80oooo0P00nYX00`0007l0003o0000o`020000o`<0oooo
00@00?ZJ0?l0003o0000001o0`3oool20?l000T0oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80
001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000
O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0>0?ooo`80003o
00<0oooo0000000000000P0000050?ooo`<0o`000P000?l40?ooo`D0003o0`00nYX30000o`030?oo
o`000?l0003o0080oooo00<00?ZJ0?l0003o00000`000?l50?ooo`80o`0000@0001o0?ooo`3oool0
oooo0`3o00080?ooo`80o`0000<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3o
ool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03P3oool30000o`@000001P3oool20?l00080003o
0`3oool70000o`800?ZJ00<0oooo0000o`000?l00`000?l20?ooo`03003jVP3o0000o`0000<0003o
1@3oool20?l000030000O`3oool0oooo0080oooo0P3o00080?ooo`80o`0000<0001o0?ooo`0007l0
3P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3o
ool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03`3o
ool20000o`030?ooo`000000000000L0oooo0P3o00030000o`80oooo0P000?l00`3oool0003o0000
o`020000o`800?ZJ00<0oooo0000o`000?l00P000?l4003jVP80o`000`000?l50?ooo`80o`0000<0
001o0?ooo`3oool00P3oool20?l000P0oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503o
ool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3o
ool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0
oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0?0?ooo`80003o0P3oool0
0`0007l0oooo0?ooo`050?ooo`80o`000`000?l20?ooo`80003o00<0oooo0000o`000?l00P000?l2
003jVP030?ooo`000?l0003o00H00?ZJ0`3o00020000o`D0oooo0P3o00000`0007l0oooo0?ooo`02
0?ooo`80o`00203oool20?l000030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0
oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0
oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`00
07l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00l0oooo0P000?l20?ooo`040000O`3oool0oooo
0?ooo`80003o0P3oool20?l000<0003o0P3oool20000o`80oooo0`000?l2003jVP030?ooo`000?l0
0?ZJ00<00?ZJ0`3oool30?l00080003o1@3oool20?l000030000O`3oool0oooo0080oooo0P3o0008
0?ooo`80o`0000<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool0
0`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool0
01/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo
01@0oooo00<0001o0?ooo`3oool03`3oool20000o`80oooo00@0001o0?ooo`3oool0oooo0`000?l0
0`3oool0o`000?l000030000o`80oooo0P000?l20?ooo`<0003o0P00nYX01@3oool00?ZJ003jVP00
nYX0003o00@0oooo0`3o00020000o`D0oooo0P3o00000`0007l0oooo0?ooo`020?ooo`<0o`001`3o
ool20?l000030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0
001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K
0?ooo`800000103oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o
0?ooo`3oool03`3oool20000o`80oooo00@0001o0?ooo`3oool0oooo0`000?l0103oool0o`000?l0
003o00020000o`80oooo0P000?l20?ooo`80003o00<0oooo003jVP00nYX00`00nYX20000o`@0oooo
0`3o00020000o`D0oooo0P3o00000`0007l0oooo0?ooo`030?ooo`80o`001`3oool20?l000030000
O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0
203oool00`0007l0oooo0?ooo`020?ooo`800000403oool001/0oooo00<000000?ooo`3oool00`3o
ool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03`3o
ool20000o`80oooo00<0001o0?ooo`3oool010000?l0103oool0003o0?l0003o00020000o`80oooo
0P000?l20?ooo`80003o00<0oooo003jVP00nYX00P00nYX30000o`@0oooo103o00000`000?l0oooo
0?ooo`030?ooo`80o`0000<0001o0?ooo`3oool00`3oool20?l000L0oooo0P3o00000`0007l0oooo
0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo
00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?oo
o`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?oo
o`0?0?ooo`80003o0P3oool00`0007l0oooo0?ooo`040000o`040?ooo`000?l0o`000?l00080003o
0P3oool20000o`80oooo0P000?l00`3oool00?ZJ003jVP02003jVP<0003o103oool40?l000030000
o`3oool0oooo00<0oooo0P3o00000`0007l0oooo0?ooo`030?ooo`80o`001`3oool20?l000030000
O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0
203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003o
ool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3o
ool0oooo00l0oooo0P000?l20?ooo`030000O`3oool0oooo00@0003o00@0oooo0000o`3o0000o`00
0P000?l20?ooo`80003o0P3oool20000o`050?ooo`00nYX00?ZJ003jVP3oool00P000?l40?ooo`D0
o`001P3oool20?l000030000O`3oool0oooo00<0oooo0`3o00060?ooo`80o`0000<0001o0?ooo`00
07l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`03
0000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001@0oooo0`0000040?ooo`030000
003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00l0oooo0P000?l20?ooo`030000O`3oool0oooo00@0003o00@0oooo0000o`3o0000
o`000P000?l20?ooo`80003o0P3oool20000o`050?ooo`0000000000003jVP3oool00P000?l40?oo
o`80o`0000@0001o0?l0003o0000o`001@3oool20?l000030000O`3oool0oooo00@0oooo0P3o0006
0?ooo`80o`0000<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool0
0`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool0
01D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo
02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0?0?ooo`80003o00<0oooo0000
o`000?l00P3oool40000o`040?ooo`000?l0o`000?l00080003o0P3oool20000o`80oooo0P000?l4
000000030?ooo`000?l0003o00@0oooo0P3o0000100007l0oooo0?l0003o00050?ooo`80o`0000<0
001o0?ooo`3oool0103oool20?l000H0oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503o
ool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3o
ool00`000000oooo0?ooo`0>0?ooo`004P3oool5000000@0oooo00<000000?ooo`3oool00`3oool0
0`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03`3oool2
0000o`040?ooo`000?l0003o0?ooo`D0003o00<0oooo0000o`3o00000P3o00020000o`030?ooo`00
0?l0003o00@0oooo100000070?ooo`80o`0000<0001o0?ooo`3o00000P3o00040?ooo`80o`0000<0
001o0?ooo`3oool0103oool20?l000H0oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503o
ool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3o
ool00`000000oooo0?ooo`0>0?ooo`004P3oool010000000oooo0?ooo`0000050?ooo`<000000`3o
ool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03`3o
ool20000o`040?ooo`000?l0003o0?ooo`80003o00<0oooo0000o`000?l00`000?l20?l000D0003o
1@3oool2000000P0oooo0P3o00000`0007l0oooo0?ooo`040?l00080oooo0P3o00000`0007l0oooo
0?ooo`040?ooo`<0o`001@3oool20?l000030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool0100007l0oooo0?ooo`3oool300000100
oooo000C0?ooo`030000003oool0000000D0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo
0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03`3oool80000o`80oooo
10000?l20?l000@0003o1`3oool00`0007l0oooo0?ooo`060?ooo`80o`0000@0001o0?ooo`3oool0
oooo103o0000103oool0o`000?l0000007l70?ooo`80o`001@3oool20?l000030000O`3oool0001o
00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000D0?ooo`8000001@3oool00`000000
oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0
oooo0?ooo`0@0?ooo`L0003o0P3oool40000o`80o`0010000?l70?ooo`030000O`3oool0oooo00H0
oooo0P3o00000`0007l0oooo0?ooo`030?ooo`D0o`0000<0001o0?ooo`3oool01@3oool20?l000D0
oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`00
5@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0
:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo0100oooo1P000?l30?ooo`@0003o
0P3o00040000o`L0oooo00<0001o0?ooo`3oool0103oool40?l000030000O`3oool0oooo00@0oooo
103o00000`0007l0oooo0?ooo`050?ooo`80o`001@3oool20?l000030000O`3oool0001o00h0oooo
0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo
0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0
001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo0100oooo0`00
0?l00`0007l0003o0000o`030?ooo`@0003o0P3o0000103oool0003o0000o`000?l70?ooo`030000
O`3oool0oooo00P0o`0000<0001o0?ooo`3oool01P3oool20?l000030000O`3oool0oooo00D0oooo
0`3o00040?ooo`80o`0000<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool0
3P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3o
ool0oooo01@0oooo00<0001o0?ooo`3oool0403oool30000o`030000O`3oool0oooo00<0oooo1000
0?l30?l00080003o203oool00`0007l0oooo0?l000050?l000<0oooo00<0001o0?ooo`3oool0203o
ool00`0007l0oooo0?ooo`060?ooo`80o`00103oool20?l000030000O`3oool0001o00h0oooo0P00
07lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?oo
o`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o
0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo0100oooo0`000?l0
0`0007l0oooo0?ooo`030?ooo`@0003o00<0oooo0?l0003o00002P3oool0100007l0o`000?l0003o
00070?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01P3oool20?l000@0oooo0P3o
00000`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3o
ool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool2
000000@0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0
oooo0100oooo0`000?l00`0007l0oooo0?ooo`030?ooo`@0003o00<0oooo0?l0003o00002P3oool0
0`0007l0o`000?l000080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01P3oool3
0?l000<0oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00P3oool200000100oooo000K0?oo
o`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo0100oooo0P000?l00`3oool0001o0?ooo`040?ooo`<0003o0P3oool20?l0
00X0oooo0`3o00080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01`3oool20?l0
00<0oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?oo
o`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`0@0?ooo`80003o00<0oooo0000O`3oool0103oool30000o`80
oooo0P3o000:0?ooo`80o`002@3oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00L0
oooo0P3o00030?ooo`80o`0000<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3o
ool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool04`3oool00`0007l0oooo0?ooo`030?ooo`<0003o
0P3oool30?l000T0oooo0P3o00090?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
1`3oool30?l00080oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0
001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0C0?ooo`030000O`3oool0oooo00@0oooo0P00
0?l30?ooo`80o`00203oool30?l000T0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?oo
o`080?ooo`80o`000P3oool20?l000030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3o
ool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003o
ool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool0
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo01<0oooo00<0001o0?ooo`3oool0103oool2
0000o`<0oooo0P3o00080?ooo`80o`002P3oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0
oooo00P0oooo0`3o00001P3oool0o`000?l0000007l0oooo0000O`h0oooo0P0007lD0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000
003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0:P3o
ool00`0007l0oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<0001o0?ooo`3oool04`3o
ool00`0007l0oooo0?ooo`040?ooo`80003o0`3oool30?l000L0oooo0P3o000:0?ooo`030000O`3o
ool0oooo00P0oooo00<0001o0?ooo`3oool02@3oool50?l000030000O`3oool0001o00h0oooo00<0
00000000O`3oool04`3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`08
0?ooo`040000003oool0o`000?l000H0oooo0`3o000:0?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?l000030?l000030000O`3oool0001o0080oooo00<0
00000?ooo`3oool02@3oool00`000000001o0?ooo`080?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3ooom]00000080o`001P000002
0?l002@000000`3o001@00000100oooo00280?ooo`80o`001P3oool20?l008L0oooo003o0?oooaX0
oooo003o0?oooaX0oooo001Z0?ooo`030000003oool0oooo00L0oooo0`00002R0?ooo`00J`3oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo0:40oooo001F0?ooo`D0000000D0oooo0000
0000000000000?ooo`05000000H0oooo00<000000?ooo`3oool01`3oool3000000<0oooo10000000
1@3oool00000000000000000oooo0080000000@0oooo00000000000000000P3oool5000000T0oooo
0P0000000`3oool0000000000002000000030?ooo`000000000000D000000`3oool2000000T0oooo
100000080?ooo`<00000103oool2000004d0oooo001G0?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0?0?ooo`060000003oool0oooo0000
003oool000000P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`0000001`3o
ool00`000000oooo0?ooo`080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000001D0oooo00<000000?oo
o`3oool00P3oool010000000oooo0?ooo`00001<0?ooo`00E`3oool00`000000oooo0?ooo`030?oo
o`030000003oool0000000<0oooo00<000000?ooo`3oool03`3oool010000000oooo0?ooo`000002
0?ooo`<000000`3oool01@000000oooo0?ooo`000000oooo00D000000`3oool00`000000oooo0?oo
o`080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000`3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00T0oooo100000090?ooo`030000003oool0oooo0080
oooo00@000000?ooo`3oool00000C03oool005L0oooo0`0000030?ooo`800000103oool3000000l0
oooo00H000000?ooo`3oool000000?ooo`0000020?ooo`050000003oool0oooo0?ooo`0000000P3o
ool00`000000oooo000000030?ooo`050000003oool0oooo0?ooo`0000002P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`0F0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000C03oool0
05L0oooo00<000000?ooo`3oool00`3oool00`000000oooo000000030?ooo`030000003oool0oooo
00h0oooo100000030?ooo`8000000`3oool4000000<0oooo0`0000040?ooo`030000003oool0oooo
00L0oooo0P000000103oool000000000003oool400000080oooo0`0000030?ooo`@000005P3oool0
0`000000oooo0?ooo`020?ooo`040000003oool0oooo000004`0oooo001G0?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000W0?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool2000000@0oooo00@000000?ooo`3o
ool00000C03oool005H0oooo1@0000001@3oool00000000000000000oooo00L000009@3oool30000
01L0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo
00<0oooo0P00001=0?ooo`00o`3ooolJ0?ooo`00o`3ooolJ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-29.8199, -5.81887, \
0.889138, 0.0685073}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["data//Dimensions", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({10, 2, 201, 1}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(FISHER = True\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

SCALING={1,0.1,1,1};
THETA0=Theta/SCALING; (*scaled parameter*)
F0=IdentityMatrix[THETA0//Length];
misc={miss,option=1}; (*compute likelihood*)
MAXSTEP=1;
STEPREDUCE=2; (*step halving*)

system={f,Df,g,h,Dh,R,mue,sigma,dt};
LikN=EKF;
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(SetDirectory::"cdir" \(\(:\)\(\ \)\) 
      "Cannot set current directory to \!\(\"/Mathematica \
2.2.2/Hermann.Notebooks/UKF.20.3.2006/Panel/Simulation\"\)."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "EST={};\nDo[\n\nSeedRandom[99999*m];\n\
Print[\"**********************************************************************\
***\"];\nPrint[\"Replikation m = \",m];\n\
Print[\"**********************************************************************\
***\"];\n\nn = 10;\nT = 200;\ndt = .1;\nk = 1; p = 1; q = 1;\nX = \
Shape[0,{n,T+1,q}];\nTheta = {-1., 0.1, 2.,1}//N;\nY0 = \
RandomGauss[_,Theta,{mue,sigma},n];\nProzess = UniC;\n\n",
  StyleBox["(*simulation of panel data*)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\n{zt,yt} = \
MapThread[NonLinStateSpace[h,{R,konstant},f,g,#1,#2,T,dt,Theta,Prozess,\
EulerStep]&,{Y0,X}]//Transpose;\n\n\n",
  StyleBox["(*selection*)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nmiss = -9;\ntime = {0,4,6,8,10,11,12,13.5,13.7,15,15.1,17,19,20};\nsel \
= time/dt + 1;\nZM = Shape[miss,{n,T+1,k}];\nMap[(ZM[[All,#]] = \
zt[[All,#]])&,sel];\ndata={ZM,X}//Transpose;\n\n",
  StyleBox["(*ML estimation*)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\n{THETA,COV,LIKI,psii,scoreii,k,ReturnCode}=\n\nBFGS[data,\n\t \
{THETA0,F0},\n\t {system,{Lik,LikN,Score,Hesse}},\n\t \
{misc,KMAX=50,{EPS1=10.^-4,EPS2=10.^-4},OPTION=0,PRINT={1,1,1,1,1,1,1,1}}];\n\
\n\n,{m,1,1}] \n"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(est\)\" is similar to \
existing symbol \"\!\(EST\)\"."\)], "Message"],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Replikation m = "\[InvisibleSpace]1\),
      SequenceForm[ "Replikation m = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print"],

Cell[BoxData[
    \({201, 201, 201, 201, 201, 201, 201, 201, 201, 201}\)], "Print"],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    \(EKF\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "50", "0.0001`", "0.0001`", "1", "1", "10", "200", "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "1", "1.`*^-10", "1.`*^-6", "2", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1000.`", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("    SCALING"\)], "Print"],

Cell[BoxData[
    TagBox[\({{1, 0.1`, 1, 1}}\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{\(-1.`\), 1.`, 
          2.`, 1.`}\),
      SequenceForm[ "STARTWERT THETA0 = ", {-1.0, 1.0, 2.0, 1.0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{203.24713897705078`, 79.97084999084473`, 92.33173942565918`, 
        3.514730453491211`}, \(-248.15958287828698`\)}\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -187.947471474954100\"\>",
            -187.94747147495409,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -187.94747147495409, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -248.159582878287000\"\>",
            -248.15958287828698,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -248.15958287828698, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    60.212111403332900\"\>",
            60.212111403332898,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 60.212111403332898, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-1.0000\"\>",
                -1.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 203.2500\"\>",
                203.24713897705078,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 1.3935\"\>",
                1.3934660551353417,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.3935\"\>",
                0.39346605513534172,
                AutoDelete->True], 
              InterpretationBox["\<\" 79.9710\"\>",
                79.970849990844727,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.4543\"\>",
                2.4542830953998553,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0000\"\>",
                2.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.4543\"\>",
                0.45428309539985512,
                AutoDelete->True], 
              InterpretationBox["\<\" 92.3320\"\>",
                92.33173942565918,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172928901788283,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0173\"\>",
                0.017292890178828391,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.5147\"\>",
                3.5147304534912109,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 2.0764262305726733`*^-8, 
          3.657166801988863`*^-8, 1.515884533790988`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 2.0764262305726733*^-08, 
        3.657166801988863*^-08, 1.5158845337909882*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.370581083572688`*^-6\),
      SequenceForm[ "NOISE  ", 3.3705810835726879*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.0033225898950397796`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.7344906543450676`\),
      SequenceForm[ 
      "*BFGSUP ", 0.0033225898950397796, "  ", 0.73449065434506755],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1221018212232747`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.1221018212232747, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -185.933167267430000\"\>",
            -185.93316726743006,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -187.947471474954100\"\>",
            -187.94747147495409,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -185.93316726743006, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -187.94747147495409, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -185.933167267430000\"\>",
            -185.93316726743006,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -185.93316726743006, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -187.947471474954100\"\>",
            -187.94747147495409,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -187.94747147495409, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.014304207524020\"\>",
            2.0143042075240203,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.0143042075240203, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2130\"\>",
                -0.2129513790798217,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.2130\"\>",
                -0.2129513790798217,
                AutoDelete->True], 
              InterpretationBox["\<\"-22.9490\"\>",
                -22.948728561401367,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 1.4174\"\>",
                1.4173707062981509,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.3935\"\>",
                1.3934660551353417,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0239\"\>",
                0.023904651162809092,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.6371\"\>",
                -6.6371203513485444,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.9543\"\>",
                2.9542830953998553,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.4543\"\>",
                2.4542830953998553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5000\"\>",
                0.5,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8314\"\>",
                2.8314075551746347,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0898\"\>",
                1.0897718034084267,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172928901788283,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0725\"\>",
                0.072478913229598388,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.2951\"\>",
                1.2950824611583034,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 170.3\"\>",
                  170.26439424467358,
                  AutoDelete->True], 
                InterpretationBox["\<\" 64.8\"\>",
                  64.80175160663498,
                  AutoDelete->True], 
                InterpretationBox["\<\" 66.93\"\>",
                  66.930854019870253,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.655\"\>",
                  1.6554885306645524,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 64.8\"\>",
                  64.80175160663498,
                  AutoDelete->True], 
                InterpretationBox["\<\" 25.81\"\>",
                  25.80883863288205,
                  AutoDelete->True], 
                InterpretationBox["\<\" 25.62\"\>",
                  25.623576638966668,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6337\"\>",
                  0.63373445242780146,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 66.93\"\>",
                  66.930854019870253,
                  AutoDelete->True], 
                InterpretationBox["\<\" 25.62\"\>",
                  25.623576638966668,
                  AutoDelete->True], 
                InterpretationBox["\<\" 27.46\"\>",
                  27.46339394909652,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6543\"\>",
                  0.65429309523972079,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.655\"\>",
                  1.6554885306645524,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6337\"\>",
                  0.63373445242780146,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6543\"\>",
                  0.6542930952397209,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.016\"\>",
                  1.0161502144675079,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 2.112046936598645`*^-8, 
          4.402224861681246`*^-8, 1.6238865307099025`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 2.112046936598645*^-08, 
        4.4022248616812458*^-08, 1.6238865307099025*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.735956563057698`*^-7\),
      SequenceForm[ "NOISE  ", 5.7359565630576981*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.1411642106409688`\
\[InvisibleSpace]"  "\[InvisibleSpace]3.2743564179357523`\),
      SequenceForm[ 
      "*BFGSUP ", 0.14116421064096879, "  ", 3.2743564179357523],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1239684095017997`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.1239684095017997, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.104362843339800\"\>",
            -184.10436284333974,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -184.10436284333974, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -185.933167267430000\"\>",
            -185.93316726743006,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -185.93316726743006, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.828804424090322\"\>",
            1.8288044240903218,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.8288044240903218, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.7328\"\>",
                -0.73276946840352664,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2130\"\>",
                -0.2129513790798217,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5198\"\>",
                -0.51981808932370488,
                AutoDelete->True], 
              InterpretationBox["\<\"-15.5450\"\>",
                -15.544624328613281,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 2.4174\"\>",
                2.4173707062981507,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.4174\"\>",
                1.4173707062981509,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                0.99999999999999978,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.0242\"\>",
                -2.0242226363568769,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 3.2356\"\>",
                3.2356382149110776,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.9543\"\>",
                2.9542830953998553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2814\"\>",
                0.28135511951122227,
                AutoDelete->True], 
              InterpretationBox["\<\"-7.8022\"\>",
                -7.8021767973646572,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.4919\"\>",
                0.4919465226305616,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0898\"\>",
                1.0897718034084267,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5978\"\>",
                -0.59782528077786512,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.8539\"\>",
                -2.8538737857997032,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 173.9\"\>",
                  173.86962359410811,
                  AutoDelete->True], 
                InterpretationBox["\<\" 68.43\"\>",
                  68.427656204573765,
                  AutoDelete->True], 
                InterpretationBox["\<\" 56.33\"\>",
                  56.326679857635924,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.448\"\>",
                  -2.447709005351606,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 68.43\"\>",
                  68.427656204573765,
                  AutoDelete->True], 
                InterpretationBox["\<\" 28.47\"\>",
                  28.466898910300063,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.85\"\>",
                  18.846737878667341,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.001\"\>",
                  -2.0005016637018289,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 56.33\"\>",
                  56.326679857635924,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.85\"\>",
                  18.846737878667341,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.36\"\>",
                  43.362348715650739,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.853\"\>",
                  6.8534340914456662,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-2.448\"\>",
                  -2.447709005351606,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.001\"\>",
                  -2.0005016637018289,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.853\"\>",
                  6.8534340914456662,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.433\"\>",
                  3.4329638275985084,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 3.60216305598341`*^-8, 
          4.821476660536345`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 3.6021630559834103*^-08, 
        4.8214766605363453*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.061458926367777`*^-7\),
      SequenceForm[ "NOISE  ", 3.0614589263677772*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.09486256852792684`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.6015392441100986`\),
      SequenceForm[ 
      "*BFGSUP ", 0.094862568527926835, "  ", 0.60153924411009863],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.04764937118990221`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.047649371189902208, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.737129224832800\"\>",
            -183.73712922483281,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.104362843339800\"\>",
            -184.10436284333974,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -183.73712922483281, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -184.10436284333974, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.737129224832800\"\>",
            -183.73712922483281,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.73712922483281, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.104362843339800\"\>",
            -184.10436284333974,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -184.10436284333974, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.367233618506930\"\>",
            0.36723361850692982,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.36723361850692982, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.7574\"\>",
                -0.7574297202522704,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.7328\"\>",
                -0.73276946840352664,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0247\"\>",
                -0.024660251848743819,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.1897\"\>",
                -2.1897125244140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 2.5573\"\>",
                2.5573051194310898,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.4174\"\>",
                2.4173707062981507,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1399\"\>",
                0.13993441313293903,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.6289\"\>",
                -3.6289250547908183,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 3.1040\"\>",
                3.1039925786345299,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.2356\"\>",
                3.2356382149110776,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1316\"\>",
                -0.13164563627654766,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7971\"\>",
                1.7970512257653801,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9919\"\>",
                0.99194652263056149,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.4919\"\>",
                0.4919465226305616,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5000\"\>",
                0.49999999999999989,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.0005\"\>",
                5.0004787445068359,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 177.8\"\>",
                  177.82766502774012,
                  AutoDelete->True], 
                InterpretationBox["\<\" 64.71\"\>",
                  64.706900063385902,
                  AutoDelete->True], 
                InterpretationBox["\<\" 61.98\"\>",
                  61.982337839183359,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.123\"\>",
                  5.1232742621934815,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 64.71\"\>",
                  64.706900063385902,
                  AutoDelete->True], 
                InterpretationBox["\<\" 28.49\"\>",
                  28.491392618728224,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.54\"\>",
                  16.538346948458383,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.506\"\>",
                  -3.5060049180023709,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 61.98\"\>",
                  61.982337839183359,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.54\"\>",
                  16.538346948458383,
                  AutoDelete->True], 
                InterpretationBox["\<\" 48.84\"\>",
                  48.838266751132146,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.81\"\>",
                  12.811319910606674,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 5.123\"\>",
                  5.1232742621934815,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.506\"\>",
                  -3.5060049180023709,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.81\"\>",
                  12.811319910606674,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.848\"\>",
                  8.8482497961811468,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 3.81068158064945`*^-8, 
          4.625309375873998`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 3.8106815806494502*^-08, 
        4.6253093758739977*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.2020875107365418`*^-7\),
      SequenceForm[ "NOISE  ", 1.2020875107365418*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.32978096920079086`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.302884077358218`\),
      SequenceForm[ "*BFGSUP ", 0.32978096920079086, "  ", 1.302884077358218],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.042681718849013735`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.042681718849013735, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.024725928203200\"\>",
            -183.0247259282032,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.737129224832800\"\>",
            -183.73712922483281,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -183.0247259282032, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -183.73712922483281, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.024725928203200\"\>",
            -183.0247259282032,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.0247259282032, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.737129224832800\"\>",
            -183.73712922483281,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.73712922483281, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.712403296629617\"\>",
            0.71240329662961699,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.71240329662961699, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.5747\"\>",
                -0.57469320122301604,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.7574\"\>",
                -0.7574297202522704,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1827\"\>",
                0.18273651902925436,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6830\"\>",
                -0.68303680419921875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 2.0573\"\>",
                2.0573051194310898,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.5573\"\>",
                2.5573051194310898,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5000\"\>",
                -0.49999999999999989,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.0666\"\>",
                -3.0665939829048772,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 3.0923\"\>",
                3.0922518866858391,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.1040\"\>",
                3.1039925786345299,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0117\"\>",
                -0.011740691948690768,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0906\"\>",
                2.090591827835274,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.8987\"\>",
                0.89866614542557222,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9919\"\>",
                0.99194652263056149,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0933\"\>",
                -0.093280377204989259,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0699\"\>",
                -1.0699348449707031,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 177.5\"\>",
                  177.45276858486253,
                  AutoDelete->True], 
                InterpretationBox["\<\" 63.12\"\>",
                  63.124336556999076,
                  AutoDelete->True], 
                InterpretationBox["\<\" 63.05\"\>",
                  63.050241952409614,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.673\"\>",
                  4.6727529461003368,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 63.12\"\>",
                  63.124336556999076,
                  AutoDelete->True], 
                InterpretationBox["\<\" 25.51\"\>",
                  25.509903517164883,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.12\"\>",
                  18.120863211626197,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3797\"\>",
                  -0.37969968996605363,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 63.05\"\>",
                  63.050241952409614,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.12\"\>",
                  18.120863211626197,
                  AutoDelete->True], 
                InterpretationBox["\<\" 48.11\"\>",
                  48.109974143527964,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.12\"\>",
                  10.118060083985156,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 4.673\"\>",
                  4.6727529461003368,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3797\"\>",
                  -0.37969968996605363,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.12\"\>",
                  10.118060083985156,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.14\"\>",
                  15.141552729756116,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 3.0656235209570674`*^-8, 
          4.6078143815485225`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 3.0656235209570674*^-08, 
        4.6078143815485225*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.6208705989439613`*^-7\),
      SequenceForm[ "NOISE  ", 1.6208705989439613*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.6468017605906546`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.4792831120979753`\),
      SequenceForm[ 
      "*BFGSUP ", 0.64680176059065464, "  ", 1.4792831120979753],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.04601041391150339`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.046010413911503387, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -182.697123355260600\"\>",
            -182.69712335526054,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -182.69712335526054, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.024725928203200\"\>",
            -183.0247259282032,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.0247259282032, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.327602572942652\"\>",
            0.32760257294265216,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.32760257294265216, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.6118\"\>",
                -0.61182350763498683,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5747\"\>",
                -0.57469320122301604,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0371\"\>",
                -0.037130306411970834,
                AutoDelete->True], 
              InterpretationBox["\<\"-7.8109\"\>",
                -7.8108844757080078,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 2.0128\"\>",
                2.0128319766398581,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0573\"\>",
                2.0573051194310898,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0445\"\>",
                -0.044473142791231761,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.4858\"\>",
                -2.4858217345669114,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 3.1271\"\>",
                3.1271043513722354,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.0923\"\>",
                3.0922518866858391,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0349\"\>",
                0.034852464686396481,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.7233\"\>",
                -2.7232721345418778,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.8146\"\>",
                0.81459465674153109,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8987\"\>",
                0.89866614542557222,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0841\"\>",
                -0.084071488684041087,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9661\"\>",
                -0.96613311767578125,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 210.2\"\>",
                  210.17105746463983,
                  AutoDelete->True], 
                InterpretationBox["\<\" 59.8\"\>",
                  59.803618427513854,
                  AutoDelete->True], 
                InterpretationBox["\<\" 85.68\"\>",
                  85.682096802593904,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.97\"\>",
                  3.9697893977105476,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 59.8\"\>",
                  59.803618427513854,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.84\"\>",
                  22.84041073930771,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.28\"\>",
                  18.28116637538248,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.348\"\>",
                  -1.3482107508848902,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 85.68\"\>",
                  85.682096802593904,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.28\"\>",
                  18.28116637538248,
                  AutoDelete->True], 
                InterpretationBox["\<\" 61.76\"\>",
                  61.756437833040479,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.48\"\>",
                  10.481707724770311,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 3.97\"\>",
                  3.9697893977105476,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.348\"\>",
                  -1.3482107508848902,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.48\"\>",
                  10.48170772477031,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.8\"\>",
                  14.797003811726286,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 2.9993533740041526`*^-8, 
          4.65974860097801`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 2.9993533740041526*^-08, 
        4.65974860097801*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.0576757719936722`*^-7\),
      SequenceForm[ "NOISE  ", 2.0576757719936722*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]8.180693541701727`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.5847517985663977`\),
      SequenceForm[ "*BFGSUP ", 8.1806935417017268, "  ", 2.5847517985663977],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.04133974427349034`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.041339744273490339, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -182.237141052941100\"\>",
            -182.23714105294115,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -182.23714105294115, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -182.697123355260600\"\>",
            -182.69712335526054,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -182.69712335526054, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.459982302319389\"\>",
            0.45998230231938919,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.45998230231938919, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.6321\"\>",
                -0.6320544026398659,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6118\"\>",
                -0.61182350763498683,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0202\"\>",
                -0.020230895004879058,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.9979\"\>",
                -5.9979438781738281,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 1.6472\"\>",
                1.6472480106479068,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0128\"\>",
                2.0128319766398581,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3656\"\>",
                -0.36558396599195142,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.1482\"\>",
                -2.1482205591348382,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 3.1221\"\>",
                3.1221441281656812,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.1271\"\>",
                3.1271043513722354,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0050\"\>",
                -0.0049602232065543818,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.4152\"\>",
                -2.4152223624051867,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.6436\"\>",
                0.64358630881109458,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8146\"\>",
                0.81459465674153109,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1710\"\>",
                -0.17100834793043651,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3637\"\>",
                -0.36371612548828125,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 79.36\"\>",
                  79.363490628320363,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.62\"\>",
                  14.623872643235146,
                  AutoDelete->True], 
                InterpretationBox["\<\" 35.27\"\>",
                  35.270137794578162,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.601\"\>",
                  -6.6011495735270582,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 14.62\"\>",
                  14.623872643235146,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.801\"\>",
                  7.8008197835443642,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.634\"\>",
                  1.6342860509409292,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.892\"\>",
                  -5.8920780366681207,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 35.27\"\>",
                  35.270137794578162,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.634\"\>",
                  1.6342860509409292,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.36\"\>",
                  43.363676954739326,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.199\"\>",
                  5.1992410067396353,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-6.601\"\>",
                  -6.6011495735270564,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.892\"\>",
                  -5.8920780366681198,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.199\"\>",
                  5.1992410067396335,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.35\"\>",
                  15.353187033716816,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 2.454590813290934`*^-8, 
          4.652357292422177`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 2.454590813290934*^-08, 
        4.6523572924221772*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.2220794122170693`*^-7\),
      SequenceForm[ "NOISE  ", 1.2220794122170693*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.8362478541741849`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.0194955062848965`\),
      SequenceForm[ "*BFGSUP ", 0.8362478541741849, "  ", 1.0194955062848965],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.03774749678161022`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.037747496781610219, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -182.046363821103300\"\>",
            -182.04636382110334,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -182.04636382110334, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -182.237141052941100\"\>",
            -182.23714105294115,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -182.23714105294115, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.190777231837814\"\>",
            0.19077723183781359,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.19077723183781359, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.6102\"\>",
                -0.61022030096005031,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6321\"\>",
                -0.6320544026398659,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0218\"\>",
                0.021834101679815556,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3888\"\>",
                -0.38876724243164062,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 1.6539\"\>",
                1.6538604138703912,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.6472\"\>",
                1.6472480106479068,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0066124032224842951,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2522\"\>",
                0.25223116782838828,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 3.0419\"\>",
                3.0418856916042132,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.1221\"\>",
                3.1221441281656812,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0803\"\>",
                -0.080258436561467958,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.2033\"\>",
                -2.2032922289936958,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.7222\"\>",
                0.72216097845129346,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6436\"\>",
                0.64358630881109458,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0786\"\>",
                0.078574669640198908,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8276\"\>",
                0.82757759094238281,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 69.\"\>",
                  68.997553853242437,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.75\"\>",
                  12.747476038089836,
                  AutoDelete->True], 
                InterpretationBox["\<\" 21.5\"\>",
                  21.495443137226097,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.237\"\>",
                  -3.2372728047061985,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 12.75\"\>",
                  12.747476038089836,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.915\"\>",
                  7.9146003831178859,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.23\"\>",
                  -3.2298726149042958,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.297\"\>",
                  -4.2972827902092039,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 21.5\"\>",
                  21.495443137226097,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.23\"\>",
                  -3.2298726149042958,
                  AutoDelete->True], 
                InterpretationBox["\<\" 37.45\"\>",
                  37.454214331501305,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.515\"\>",
                  4.5147881179936249,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-3.237\"\>",
                  -3.2372728047061958,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.297\"\>",
                  -4.297282790209203,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.515\"\>",
                  4.5147881179936231,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.41\"\>",
                  16.405105395346624,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 2.4644440619206297`*^-8, 
          4.532762902385314`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 2.4644440619206297*^-08, 
        4.5327629023853141*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.927001869311971`*^-8\),
      SequenceForm[ "NOISE  ", 5.9270018693119709*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]11.147817555472427`\
\[InvisibleSpace]"  "\[InvisibleSpace]4.2546149452948585`\),
      SequenceForm[ "*BFGSUP ", 11.147817555472427, "  ", 4.2546149452948585],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.029646678009641353`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.029646678009641353, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.719126097236000\"\>",
            -181.71912609723603,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.71912609723603, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -182.046363821103300\"\>",
            -182.04636382110334,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -182.04636382110334, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.327237723867313\"\>",
            0.32723772386731298,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.32723772386731298, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.5024\"\>",
                -0.50238205573693551,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6102\"\>",
                -0.61022030096005031,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1078\"\>",
                0.10783824522311479,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.7901\"\>",
                -0.79013252258300781,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 1.4128\"\>",
                1.4128185542389464,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.6539\"\>",
                1.6538604138703912,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2410\"\>",
                -0.24104185963144464,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2016\"\>",
                -0.2015605669056561,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.7416\"\>",
                2.7416461216875798,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.0419\"\>",
                3.0418856916042132,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3002\"\>",
                -0.30023956991663342,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.7743\"\>",
                -1.7742513947603324,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.8714\"\>",
                0.87138098384648799,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7222\"\>",
                0.72216097845129346,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1492\"\>",
                0.1492200053951945,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2739\"\>",
                0.273895263671875,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 70.15\"\>",
                  70.150358986732499,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.2\"\>",
                  15.195101891103429,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.93\"\>",
                  15.931399252313906,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.609\"\>",
                  0.60895279477639264,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 15.2\"\>",
                  15.195101891103429,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.94\"\>",
                  9.9395553294013759,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.036\"\>",
                  -3.0358436740580577,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.384\"\>",
                  -2.3844335644617325,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 15.93\"\>",
                  15.931399252313906,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.036\"\>",
                  -3.0358436740580581,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.85\"\>",
                  18.852246429793954,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.624\"\>",
                  9.6244428983645918,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.609\"\>",
                  0.6089527947763953,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.384\"\>",
                  -2.3844335644617316,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.624\"\>",
                  9.62444289836459,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.91\"\>",
                  16.908705720281546,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 2.105263701437334`*^-8, 
          4.0853710795753894`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 2.1052637014373339*^-08, 
        4.0853710795753894*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.7473447356890835`*^-8\),
      SequenceForm[ "NOISE  ", 3.7473447356890835*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.4690715929594886`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.8623737199846133`\),
      SequenceForm[ "*BFGSUP ", 2.4690715929594886, "  ", 1.8623737199846133],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00407524019859172`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0040752401985917203, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.600952588801700\"\>",
            -181.60095258880165,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.60095258880165, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.719126097236000\"\>",
            -181.71912609723603,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.71912609723603, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.118173508434381\"\>",
            0.11817350843438135,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.11817350843438135, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.3989\"\>",
                -0.39886429588054995,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5024\"\>",
                -0.50238205573693551,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1035\"\>",
                0.10351775985638557,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7405\"\>",
                0.74054908752441406,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 1.1738\"\>",
                1.1737841632851147,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.4128\"\>",
                1.4128185542389464,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2390\"\>",
                -0.23903439095383175,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2171\"\>",
                -0.21710116095202994,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.5637\"\>",
                2.5637304238184382,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.7416\"\>",
                2.7416461216875798,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1779\"\>",
                -0.17791569786914149,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2445\"\>",
                -0.24454085566400832,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9000\"\>",
                0.89997175162946175,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8714\"\>",
                0.87138098384648799,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0286\"\>",
                0.028590767782973713,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.4937\"\>",
                -0.49371528625488281,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 74.77\"\>",
                  74.772662209173703,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.84\"\>",
                  14.839767535348493,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.1\"\>",
                  19.10187982974157,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.889\"\>",
                  -1.8890827993157111,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 14.84\"\>",
                  14.839767535348493,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.864\"\>",
                  9.8644896071540362,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.761\"\>",
                  -3.7605603965179455,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.252\"\>",
                  -2.2521645972811504,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 19.1\"\>",
                  19.10187982974157,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.761\"\>",
                  -3.7605603965179464,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.77\"\>",
                  18.767216451019884,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.63\"\>",
                  7.6302422127625134,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.889\"\>",
                  -1.8890827993157084,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.252\"\>",
                  -2.2521645972811495,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.63\"\>",
                  7.6302422127625116,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.22\"\>",
                  18.223834093015746,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.7490747023897092`*^-8, 
          3.8202560302889916`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.7490747023897092*^-08, 
        3.8202560302889916*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.6178006490008556`*^-8\),
      SequenceForm[ "NOISE  ", 1.6178006490008556*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]14.639748680964594`\
\[InvisibleSpace]"  "\[InvisibleSpace]6.3312543576376`\),
      SequenceForm[ "*BFGSUP ", 14.639748680964594, "  ", 6.3312543576375999],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.001955095614261895`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0019550956142618948, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.524212347765300\"\>",
            -181.52421234776531,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.52421234776531, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.600952588801700\"\>",
            -181.60095258880165,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.60095258880165, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.076740241036333\"\>",
            0.076740241036333146,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.076740241036333146, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2607\"\>",
                -0.26067510479009809,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3989\"\>",
                -0.39886429588054995,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1382\"\>",
                0.13818919109045186,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.3451\"\>",
                0.3451385498046875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.8492\"\>",
                0.84921659569053842,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1738\"\>",
                1.1737841632851147,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3246\"\>",
                -0.32456756759457622,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1491\"\>",
                -0.14911254165463814,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3217\"\>",
                2.3217440475177482,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.5637\"\>",
                2.5637304238184382,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2420\"\>",
                -0.24198637630069011,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1385\"\>",
                -0.13848851761229192,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9470\"\>",
                0.94697384257096207,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9000\"\>",
                0.89997175162946175,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0470\"\>",
                0.047002090941500291,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2228\"\>",
                -0.22282981872558594,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 73.59\"\>",
                  73.58943761205046,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.46\"\>",
                  15.464102583912105,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.63\"\>",
                  19.634528894609126,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.142\"\>",
                  -1.1423246766118527,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 15.46\"\>",
                  15.464102583912105,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.634\"\>",
                  9.633750680206127,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.991\"\>",
                  -3.9911296049647516,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.661\"\>",
                  -2.6611653125309682,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 19.63\"\>",
                  19.634528894609126,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.991\"\>",
                  -3.9911296049647524,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.55\"\>",
                  18.553260677739264,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.286\"\>",
                  7.2864185883968631,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.142\"\>",
                  -1.1423246766118498,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.661\"\>",
                  -2.6611653125309673,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.286\"\>",
                  7.2864185883968613,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.75\"\>",
                  17.754809744477722,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.459668230291826`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4596682302918258*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.102486326368995`*^-8\),
      SequenceForm[ "NOISE  ", 1.102486326368995*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]8.431200292007063`\
\[InvisibleSpace]"  "\[InvisibleSpace]8.39416450840823`\),
      SequenceForm[ "*BFGSUP ", 8.4312002920070626, "  ", 8.3941645084082293],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.005048672078953449`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0050486720789534494, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.519405474931200\"\>",
            -181.51940547493123,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.51940547493123, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.524212347765300\"\>",
            -181.52421234776531,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.52421234776531, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.004806872834081\"\>",
            0.0048068728340808775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0048068728340808775, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2405\"\>",
                -0.24047459235666507,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2607\"\>",
                -0.26067510479009809,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0202\"\>",
                0.020200512433433022,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2208\"\>",
                0.22077178955078125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.7973\"\>",
                0.79732198809142785,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8492\"\>",
                0.84921659569053842,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0519\"\>",
                -0.051894607599110576,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1478\"\>",
                -0.14784431457519531,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3013\"\>",
                2.3012612640897387,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3217\"\>",
                2.3217440475177482,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0205\"\>",
                -0.02048278342800958,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.3947\"\>",
                0.39472749957687747,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9687\"\>",
                0.96873997148131852,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9470\"\>",
                0.94697384257096207,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0218\"\>",
                0.021766128910356491,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.3734\"\>",
                0.37335014343261719,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 72.72\"\>",
                  72.719925686132001,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.89\"\>",
                  15.894774135425715,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.48\"\>",
                  19.476641315844418,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.122\"\>",
                  -1.1218844158715138,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 15.89\"\>",
                  15.894774135425715,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.447\"\>",
                  9.4471237698169421,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.159\"\>",
                  -4.1587707422371825,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.934\"\>",
                  -2.9337011120611196,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 19.48\"\>",
                  19.476641315844418,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.159\"\>",
                  -4.1587707422371833,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.79\"\>",
                  20.789421555279873,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.708\"\>",
                  9.707597016088684,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.122\"\>",
                  -1.1218844158715109,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.934\"\>",
                  -2.9337011120611187,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.708\"\>",
                  9.7075970160886804,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.33\"\>",
                  20.334719352744369,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.429146504535882`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4291465045358818*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.404882669575782`*^-9\),
      SequenceForm[ "NOISE  ", 9.4048826695757821*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]66.58025558360194`\
\[InvisibleSpace]"  "\[InvisibleSpace]82.14702464169808`\),
      SequenceForm[ "*BFGSUP ", 66.580255583601939, "  ", 82.147024641698081],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0013024695173117012`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0013024695173117012, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.517984441180600\"\>",
            -181.51798444118057,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.51798444118057, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.519405474931200\"\>",
            -181.51940547493123,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.51940547493123, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.001421033750660\"\>",
            0.001421033750659717,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.001421033750659717, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2464\"\>",
                -0.24641752004483888,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2405\"\>",
                -0.24047459235666507,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0059\"\>",
                -0.005942927688173812,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2310\"\>",
                0.23096656799316406,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.8290\"\>",
                0.82904291880294023,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7973\"\>",
                0.79732198809142785,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0317\"\>",
                0.031720930711512364,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2364\"\>",
                0.23642349243164062,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3144\"\>",
                2.3143639502896756,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3013\"\>",
                2.3012612640897387,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0131\"\>",
                0.013102686199936727,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0710\"\>",
                -0.071037976661198307,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9831\"\>",
                0.98308690556704459,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9687\"\>",
                0.96873997148131852,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0143\"\>",
                0.014346934085726123,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1517\"\>",
                0.15171432495117188,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 68.72\"\>",
                  68.722984586634169,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.84\"\>",
                  18.836870844425718,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.\"\>",
                  12.001815711026438,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.043\"\>",
                  -8.0433076065066942,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 18.84\"\>",
                  18.836870844425718,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.48\"\>",
                  17.482915811534209,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.28\"\>",
                  -11.281263017740519,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.07\"\>",
                  -4.0698491923118016,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 12.\"\>",
                  12.001815711026438,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.28\"\>",
                  -11.281263017740521,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.43\"\>",
                  22.433862951645636,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.475\"\>",
                  4.4745617334636236,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-8.043\"\>",
                  -8.0433076065066906,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.07\"\>",
                  -4.0698491923118008,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.475\"\>",
                  4.4745617334636192,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.15\"\>",
                  12.154802858212674,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.448671028449648`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.448671028449648*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0947417194984155`*^-8\),
      SequenceForm[ "NOISE  ", 1.0947417194984155*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]85.78855990586023`\
\[InvisibleSpace]"  "\[InvisibleSpace]135.63363063680214`\),
      SequenceForm[ "*BFGSUP ", 85.788559905860225, "  ", 135.63363063680214],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0027448808490888946`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0027448808490888946, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516610734338500\"\>",
            -181.51661073433849,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.51661073433849, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.517984441180600\"\>",
            -181.51798444118057,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.51798444118057, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.001373706842088\"\>",
            0.0013737068420880405,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0013737068420880405, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2461\"\>",
                -0.24610596318163155,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2464\"\>",
                -0.24641752004483888,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0003\"\>",
                0.00031155686320732929,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.4982\"\>",
                -0.4982452392578125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.8187\"\>",
                0.81874238563107882,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8290\"\>",
                0.82904291880294023,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0103\"\>",
                -0.010300533171861432,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1671\"\>",
                -0.16713142395019531,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3053\"\>",
                2.3053052619532894,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3144\"\>",
                2.3143639502896756,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0091\"\>",
                -0.0090586883363862544,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1145\"\>",
                -0.11453747609854954,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9833\"\>",
                0.9833056059732812,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9831\"\>",
                0.98308690556704459,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00021870040623659168,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0308\"\>",
                -0.030841827392578125,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 107.1\"\>",
                  107.10558791701185,
                  AutoDelete->True], 
                InterpretationBox["\<\" 36.68\"\>",
                  36.676072195212292,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.95\"\>",
                  16.948453651890564,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.376\"\>",
                  -1.375683702914869,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 36.68\"\>",
                  36.676072195212292,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.87\"\>",
                  23.87275985856996,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.497\"\>",
                  -7.4973200211288509,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.615\"\>",
                  -2.6147027818308732,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 16.95\"\>",
                  16.948453651890564,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.497\"\>",
                  -7.4973200211288527,
                  AutoDelete->True], 
                InterpretationBox["\<\" 21.91\"\>",
                  21.911731860926508,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.618\"\>",
                  6.6176059352463428,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.376\"\>",
                  -1.3756837029148663,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.615\"\>",
                  -2.6147027818308723,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.618\"\>",
                  6.6176059352463383,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.89\"\>",
                  11.89194530102122,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.435172530939116`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4351725309391162*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]7.813468982931226`*^-9\),
      SequenceForm[ "NOISE  ", 7.8134689829312265*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]406.20593838230843`\
\[InvisibleSpace]"  "\[InvisibleSpace]385.04111698994814`\),
      SequenceForm[ "*BFGSUP ", 406.20593838230843, "  ", 385.04111698994814],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00014383139912273906`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00014383139912273906, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "BFGS: Iteration = ", 15],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516593416931000\"\>",
            -181.51659341693099,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.51659341693099, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516610734338500\"\>",
            -181.51661073433849,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.51661073433849, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000017317407497\"\>",
            1.731740749733035*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.731740749733035*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2446\"\>",
                -0.24457922749139677,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2461\"\>",
                -0.24610596318163155,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0015\"\>",
                0.001526735690234794,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0261\"\>",
                -0.0261077880859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.8148\"\>",
                0.81483210756627711,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8187\"\>",
                0.81874238563107882,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.003910278064801701,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0171\"\>",
                -0.017057418823242188,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3023\"\>",
                2.3022915579554555,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3053\"\>",
                2.3053052619532894,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0030\"\>",
                -0.0030137039978339543,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0039\"\>",
                0.0038522513182702922,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9853\"\>",
                0.98534190275847677,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9833\"\>",
                0.9833056059732812,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0020\"\>",
                0.0020362967851956103,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0121\"\>",
                0.012115478515625,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 102.1\"\>",
                  102.06867635100279,
                  AutoDelete->True], 
                InterpretationBox["\<\" 33.39\"\>",
                  33.39470883833512,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.68\"\>",
                  17.680400789222492,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.946\"\>",
                  0.9460373756594338,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 33.39\"\>",
                  33.39470883833512,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.27\"\>",
                  22.266094120604151,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.651\"\>",
                  -7.6509390344322785,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.981\"\>",
                  -1.980732291920875,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 17.68\"\>",
                  17.680400789222496,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.651\"\>",
                  -7.6509390344322803,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.55\"\>",
                  22.553875830153277,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.323\"\>",
                  7.3232738953542382,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.946\"\>",
                  0.94603737565943646,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.981\"\>",
                  -1.9807322919208736,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.323\"\>",
                  7.3232738953542338,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.28\"\>",
                  12.27527119521922,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.4306817620328895`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4306817620328895*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.298090854921611`*^-10\),
      SequenceForm[ "NOISE  ", 5.298090854921611*^-10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]22085.955040443212`\
\[InvisibleSpace]"  "\[InvisibleSpace]25062.202157277603`\),
      SequenceForm[ "*BFGSUP ", 22085.955040443212, "  ", 25062.202157277603],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0000690785876710917`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 6.9078587671091699*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]16\),
      SequenceForm[ "BFGS: Iteration = ", 16],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516593107589400\"\>",
            -181.51659310758944,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.51659310758944, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516593416931000\"\>",
            -181.51659341693099,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.51659341693099, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     3.093415443800040"\[Times]10\^"-7"\),
            3.0934154438000405*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 3.0934154438000405*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2454\"\>",
                -0.24535828124346215,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2446\"\>",
                -0.24457922749139677,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.0007790537520653754,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0094\"\>",
                -0.0094470977783203125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.8161\"\>",
                0.8161164636891205,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8148\"\>",
                0.81483210756627711,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0012843561228434329,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0042\"\>",
                -0.004207611083984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3036\"\>",
                2.3035785110219438,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3023\"\>",
                2.3022915579554555,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0012869530664884961,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054462736784061019,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9854\"\>",
                0.98536772948857054,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9853\"\>",
                0.98534190275847677,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                2.5826730093764979*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0044\"\>",
                0.0044231414794921875,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 91.12\"\>",
                  91.116451873119019,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.96\"\>",
                  26.962029869350111,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.79\"\>",
                  20.787548756484231,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.043\"\>",
                  6.0428929185692306,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 26.96\"\>",
                  26.962029869350111,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.62\"\>",
                  18.620886618794767,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.552\"\>",
                  -5.551731174536819,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.016\"\>",
                  1.0155047388447616,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 20.79\"\>",
                  20.787548756484235,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.552\"\>",
                  -5.5517311745368207,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.24\"\>",
                  22.238075118650009,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.883\"\>",
                  5.8827614833332253,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 6.043\"\>",
                  6.0428929185692333,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.016\"\>",
                  1.0155047388447629,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.883\"\>",
                  5.8827614833332209,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.903\"\>",
                  9.9033915867920257,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.4325994715421554`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4325994715421554*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.603020104492316`*^-10\),
      SequenceForm[ "NOISE  ", 3.603020104492316*^-10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]57038.735475700276`\
\[InvisibleSpace]"  "\[InvisibleSpace]110143.56348822924`\),
      SequenceForm[ "*BFGSUP ", 57038.735475700276, "  ", 110143.56348822924],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0000811626121205983`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 8.1162612120598302*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]17\),
      SequenceForm[ "BFGS: Iteration = ", 17],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516590909360700\"\>",
            -181.5165909093607,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.5165909093607, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516593107589400\"\>",
            -181.51659310758944,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.51659310758944, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.198228742145147"\[Times]10\^"-6"\),
            2.1982287421451474*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.1982287421451474*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2451\"\>",
                -0.24507415649482375,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2454\"\>",
                -0.24535828124346215,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0003\"\>",
                0.00028412474863839294,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0147\"\>",
                0.01473236083984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.8158\"\>",
                0.8157945198218477,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8161\"\>",
                0.8161164636891205,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0003\"\>",
                -0.00032194386727279388,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.0084323883056640625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3031\"\>",
                2.3031125747806551,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3036\"\>",
                2.3035785110219438,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0005\"\>",
                -0.00046593624128854125,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0060\"\>",
                -0.0059913628474110112,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9853\"\>",
                0.98532788508347335,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9854\"\>",
                0.98536772948857054,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0000\"\>",
                -3.984440509723914*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0037\"\>",
                -0.00368499755859375,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 114.6\"\>",
                  114.6338779968592,
                  AutoDelete->True], 
                InterpretationBox["\<\" 40.02\"\>",
                  40.016508959491539,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.68\"\>",
                  10.680201617338708,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5371\"\>",
                  -0.53713226364933764,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 40.02\"\>",
                  40.016508959491539,
                  AutoDelete->True], 
                InterpretationBox["\<\" 25.78\"\>",
                  25.783961029707434,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.27\"\>",
                  -11.273891158116154,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.78\"\>",
                  -2.7803505284727787,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 10.68\"\>",
                  10.68020161733871,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.27\"\>",
                  -11.273891158116157,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.43\"\>",
                  26.432788612051571,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.519\"\>",
                  8.5190980389579103,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.5371\"\>",
                  -0.53713226364933497,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.78\"\>",
                  -2.7803505284727779,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.519\"\>",
                  8.5190980389579067,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.5\"\>",
                  11.498358932717757,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.4319051724384056`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4319051724384056*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.2095036911196075`*^-10\),
      SequenceForm[ "NOISE  ", 2.2095036911196075*^-10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]226119.19591338883`\
\[InvisibleSpace]"  "\[InvisibleSpace]226783.48109299227`\),
      SequenceForm[ "*BFGSUP ", 226119.19591338883, "  ", 226783.48109299227],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]5.253923686140965`*^-7\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 5.2539236861409649*^-07, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 1"\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]18\),
      SequenceForm[ "BFGS: Iteration = ", 18],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516590908792400\"\>",
            -181.51659090879235,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -181.51659090879235, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -181.516590909360700\"\>",
            -181.5165909093607,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -181.5165909093607, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.683489234797889"\[Times]10\^"-10"\),
            5.6834892347978894*^-10,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.6834892347978894*^-10, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.2451\"\>",
                -0.2450662835306246,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2451\"\>",
                -0.24507415649482375,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -9.1552734375*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.8158\"\>",
                0.81577363377311507,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8158\"\>",
                0.8157945198218477,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0000\"\>",
                -2.0886048732585211*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0001\"\>",
                -9.5367431640625*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3031\"\>",
                2.3030986338197286,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3031\"\>",
                2.3031125747806551,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0000\"\>",
                -1.3940960926498363*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                3.395461203313532*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9853\"\>",
                0.98533741388077978,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9853\"\>",
                0.98532788508347335,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0000\"\>",
                4.57763671875*^-05,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 115.1\"\>",
                  115.10156889851757,
                  AutoDelete->True], 
                InterpretationBox["\<\" 40.43\"\>",
                  40.42822026435163,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.5\"\>",
                  10.500988955492351,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.7308\"\>",
                  -0.73079634563516205,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 40.43\"\>",
                  40.428220264351623,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.1\"\>",
                  26.102462365621815,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.44\"\>",
                  -11.435004976476616,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.927\"\>",
                  -2.927443840336073,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 10.5\"\>",
                  10.500988955492357,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.44\"\>",
                  -11.435004976476618,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.5\"\>",
                  26.501204689151223,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.595\"\>",
                  8.5950920329043292,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.7308\"\>",
                  -0.73079634563516116,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.927\"\>",
                  -2.9274438403360721,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.595\"\>",
                  8.5950920329043257,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.57\"\>",
                  11.566098489569924,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.431884398787809`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4318843987878093*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.5347723092418164`*^-12\),
      SequenceForm[ "NOISE  ", 1.5347723092418164*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]7.379356122565241`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]8.104442078619413`*^8\),
      SequenceForm[ "*BFGSUP ", 737935612.25652409, "  ", 810444207.86194134],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]4.203138948925933`*^-8\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 4.2031389489259329*^-08, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 1"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 3"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]18\
\[InvisibleSpace]"  "\[InvisibleSpace]50\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 18, "  ", 50],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1.9073486328125`*^-6"},
            {"7.62939453125`*^-6"},
            {\(-1.656332564141319`*^-6\)},
            {"0.`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 114.8\"\>",
                  114.75421450053223,
                  AutoDelete->True], 
                InterpretationBox["\<\" 40.46\"\>",
                  40.45554705552815,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.56\"\>",
                  10.564367612453768,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4913\"\>",
                  -0.49134659074200027,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 40.46\"\>",
                  40.455547055528143,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.56\"\>",
                  26.559791683509761,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.52\"\>",
                  -11.517264372869873,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.869\"\>",
                  -2.8686231947278742,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 10.56\"\>",
                  10.564367612453774,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.52\"\>",
                  -11.517264372869874,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.5\"\>",
                  26.50263606170159,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.538\"\>",
                  8.5383414935963433,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.4913\"\>",
                  -0.49134659074199893,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.869\"\>",
                  -2.8686231947278729,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.538\"\>",
                  8.5383414935963398,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.41\"\>",
                  11.414158482702694,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"Likelihood\"\>", "\<\"THETA\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>"},
          {"1", \(-248.15958287828698`\), \(-1.`\), "1.`", "2.`", "1.`"},
          {"2", \(-187.94747147495409`\), "0.`", "1.3934660551353417`", 
            "2.4542830953998553`", "1.0172928901788283`"},
          {"3", \(-185.93316726743006`\), \(-0.2129513790798217`\), 
            "1.4173707062981509`", "2.9542830953998553`", 
            "1.0897718034084267`"},
          {"4", \(-184.10436284333974`\), \(-0.7327694684035266`\), 
            "2.4173707062981507`", "3.2356382149110776`", 
            "0.4919465226305616`"},
          {"5", \(-183.7371292248328`\), \(-0.7574297202522704`\), 
            "2.55730511943109`", "3.10399257863453`", "0.9919465226305615`"},
          {"6", \(-183.0247259282032`\), \(-0.574693201223016`\), 
            "2.05730511943109`", "3.092251886685839`", 
            "0.8986661454255722`"},
          {"7", \(-182.69712335526054`\), \(-0.6118235076349868`\), 
            "2.012831976639858`", "3.1271043513722354`", 
            "0.8145946567415311`"},
          {"8", \(-182.23714105294115`\), \(-0.6320544026398659`\), 
            "1.6472480106479068`", "3.122144128165681`", 
            "0.6435863088110946`"},
          {"9", \(-182.04636382110334`\), \(-0.6102203009600503`\), 
            "1.6538604138703912`", "3.041885691604213`", 
            "0.7221609784512935`"},
          {"10", \(-181.71912609723603`\), \(-0.5023820557369355`\), 
            "1.4128185542389464`", "2.74164612168758`", 
            "0.871380983846488`"},
          {"11", \(-181.60095258880165`\), \(-0.39886429588054995`\), 
            "1.1737841632851147`", "2.563730423818438`", 
            "0.8999717516294617`"},
          {"12", \(-181.5242123477653`\), \(-0.2606751047900981`\), 
            "0.8492165956905384`", "2.321744047517748`", 
            "0.9469738425709621`"},
          {"13", \(-181.51940547493123`\), \(-0.24047459235666507`\), 
            "0.7973219880914278`", "2.3012612640897387`", 
            "0.9687399714813185`"},
          {"14", \(-181.51798444118057`\), \(-0.24641752004483888`\), 
            "0.8290429188029402`", "2.3143639502896756`", 
            "0.9830869055670446`"},
          {"15", \(-181.51661073433849`\), \(-0.24610596318163155`\), 
            "0.8187423856310788`", "2.3053052619532894`", 
            "0.9833056059732812`"},
          {"16", \(-181.516593416931`\), \(-0.24457922749139677`\), 
            "0.8148321075662771`", "2.3022915579554555`", 
            "0.9853419027584768`"},
          {"17", \(-181.51659310758944`\), \(-0.24535828124346215`\), 
            "0.8161164636891205`", "2.3035785110219438`", 
            "0.9853677294885705`"},
          {"18", \(-181.5165909093607`\), \(-0.24507415649482375`\), 
            "0.8157945198218477`", "2.303112574780655`", 
            "0.9853278850834734`"},
          {"19", \(-181.51659090879235`\), \(-0.2450662835306246`\), 
            "0.8157736337731151`", "2.3030986338197286`", 
            "0.9853374138807798`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{6.055454452393343`*^-6, 
          6.055454452393343`*^-6, 0.0000139463088764647`, 
          6.055454452393343`*^-6}\),
      SequenceForm[ 
      "INK: ", {6.0554544523933429*^-06, 6.0554544523933429*^-06, 
        1.39463088764647*^-05, 6.0554544523933429*^-06}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Observed Fisher Information = -Hesse-Matrix"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", \(-0.2450662835306246`\), "1.9073486328125`*^-6"},
              {"2", "0.8157736337731151`", "7.62939453125`*^-6"},
              {"3", "2.3030986338197286`", \(-1.656332564141319`*^-6\)},
              {"4", "0.9853374138807798`", "0.`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", 
        "\[InvisibleSpace]", \(-181.51659090879235`\)}],
      SequenceForm[ 
        TableForm[ {{-0.2450662835306246, 1.9073486328125*^-06}, {
          0.81577363377311507, 7.62939453125*^-06}, {
          2.3030986338197286, -1.6563325641413191*^-06}, {0.98533741388077978,
           0.0}}, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 1}], 
        "   Likelihood = ", -181.51659090879235],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "140.16827432947272`", "4", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.497705474412375`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.497705474412375],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", \(-0.2450662835306246`\), "0.7194219134417488`", 
            "0.2880331251269745`"},
          {"2", "0.8157736337731151`", "1.6235360317548575`", 
            "0.6500109994501334`"},
          {"3", "2.3030986338197286`", "1.260934082223303`", 
            "0.504836977434242`"},
          {"4", "0.9853374138807798`", "0.9864817928127626`", 
            "0.3949552110602024`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1.`", \(-0.9431043601683109`\), \(-0.8768145865159577`\), 
              "0.4901157159292226`"},
            {\(-0.9431043601683106`\), "1.0000000000000002`", 
              "0.8910122544264918`", \(-0.47357952915251006`\)},
            {\(-0.8768145865159576`\), "0.8910122544264921`", 
              "1.0000000000000002`", \(-0.6265133428579572`\)},
            {
              "0.4901157159292226`", \(-0.4735795291525101`\), \
\(-0.6265133428579573`\), "0.9999999999999999`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {
              "0.08296308117041135`", \(-0.17657243046598958`\), \
\(-0.12749740936587153`\), "0.0557556538915269`"},
            {\(-0.17657243046598953`\), "0.42251429940616136`", 
              "0.2923853044259294`", \(-0.12157981424552684`\)},
            {\(-0.12749740936587153`\), "0.29238530442592947`", 
              "0.2548603737849415`", \(-0.12491923925661545`\)},
            {
              "0.0557556538915269`", \(-0.12157981424552687`\), \
\(-0.12491923925661547`\), "0.15598961874360906`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({0.007579014710804551`, 0.026238054991209334`, 0.11158473960793829`, 
      0.7709255637951739`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"115.90062312063847`", "40.59964213969443`", 
              "10.878422270590143`", \(-1.071185670810571`\)},
            {"40.59964213969443`", 
              "26.402944059689787`", \(-11.533087986104755`\), \
\(-3.168795093119621`\)},
            {"10.878422270590143`", \(-11.533087986104755`\), 
              "26.8077643368782`", "8.590836338302928`"},
            {\(-1.071185670810571`\), \(-3.168795093119621`\), 
              "8.590836338302928`", "11.203462722368808`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({131.9432720686519`, 38.11258114730818`, 8.96179892979612`, 
      1.2971420938191753`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]4\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]2010\),
      SequenceForm[ "U =  ", 4, "  Nue = ", 2010],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "4", "15.211780002106243`", 
            "20.309518702205914`"},
          {"\<\"komp. Lik.\"\>", \(-181.51659090879235`\), \
\(-185.51659090879235`\), \(-196.7283709108986`\), \(-201.82610961099826`\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF/ Gauss-Hermite/m=4", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Filter", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,lik} = 
\tGHF[data[[nn=10]],Theta,system={f,Omega,h,R,mue,sigma,dt,m=4},{miss,2}];//\
Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1, 41, 61, 81, 101, 111, 121, 136, 138, 151, 152, 171, 191, 
      201}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("GHF: "\[InvisibleSpace]"m = "\[InvisibleSpace]4\),
      SequenceForm[ "GHF: ", "m = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Genauigkeit x^"\[InvisibleSpace]7\),
      SequenceForm[ "Genauigkeit x^", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"Stuetzstellen:\"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
        "1.`*^-16", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox["\[Infinity]",
          DirectedInfinity[ 1]], "\[InvisibleSpace]", "\<\": \"\>", 
        "\[InvisibleSpace]", "4"}],
      SequenceForm[ 
      "Stuetzstellen:", 4, "; weight > ", 9.9999999999999998*^-17, 
        " und |vals| < ", 
        DirectedInfinity[ 1], ": ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    \({1.4333333333324845`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell["std = Map[VecDiag,PF]//Sqrt;", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["std//Dimensions", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({201, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g2 = plot1[yt[[nn]]~ii~YF~ii~(YF+std)~ii~(YF-std)//AddTimeAxis,
\t\tGridLines->{time/dt,None},color->{1,2,3,3},
\t\tDisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{201, 5}\),
      SequenceForm[ "Dimension der Daten  ", {201, 5}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g3 = plot1[Spalte[time/dt]~ii~ZM[[nn,time/dt+1]],
\t\t\tPlotJoined->False,dicke->.02,
\t\t\tDisplayFunction->Identity,color->{10}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{14, 2}\),
      SequenceForm[ "Dimension der Daten  ", {14, 2}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gGHF=Show[g2,g3,DisplayFunction->$DisplayFunction,GridLines->{time/\
dt,None},
\t\t\t\tPlotLabel->\"GHF, m = \"<>ToString[m]<>\" panel unit = \
\"<>ToString[nn],PlotRange->{All,{-5,5}}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(gGHF\)\" is similar to \
existing symbol \"\!\(GHF\)\"."\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0047619 0.309017 0.0618034 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -6 -9 ]
[.2619 -0.0125 6 0 ]
[.5 -0.0125 -9 -9 ]
[.5 -0.0125 9 0 ]
[.7381 -0.0125 -9 -9 ]
[.7381 -0.0125 9 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -6 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -6 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -80.0625 0 ]
[.5 .63053 80.0625 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .61803 L
s
.21429 0 m
.21429 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.40476 0 m
.40476 .61803 L
s
.5 0 m
.5 .61803 L
s
.54762 0 m
.54762 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.66667 0 m
.66667 .61803 L
s
.67619 0 m
.67619 .61803 L
s
.7381 0 m
.7381 .61803 L
s
.74286 0 m
.74286 .61803 L
s
.83333 0 m
.83333 .61803 L
s
.92857 0 m
.92857 .61803 L
s
.97619 0 m
.97619 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(50)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(100)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(150)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(200)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(-4)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(-2)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(2)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(4)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -141.062 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GHF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
105.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
117.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
129.125 13.000 moveto
(panel) show
165.125 13.000 moveto
(unit) show
195.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
207.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
219.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.97619 .19163 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .27669 m
.02857 .29846 L
.03333 .2618 L
.0381 .26628 L
.04286 .26754 L
.04762 .20714 L
.05238 .16017 L
.05714 .12555 L
.0619 .06686 L
.06667 .05446 L
.07143 .11893 L
.07619 .12641 L
.08095 .13619 L
.08571 .16112 L
.09048 .16386 L
.09524 .19665 L
.1 .24045 L
.10476 .20446 L
.10952 .19228 L
.11429 .214 L
.11905 .14632 L
.12381 .17878 L
.12857 .16414 L
.13333 .17391 L
.1381 .14817 L
.14286 .08782 L
.14762 .05453 L
.15238 .0119 L
.15714 .09454 L
.1619 .03251 L
s
.1619 .03251 m
.16578 0 L
s
.16707 0 m
.17143 .07962 L
.17619 .12078 L
.18095 .14606 L
.18571 .0944 L
.19048 .05835 L
.19524 .02722 L
.2 .12327 L
.20476 .13342 L
.20952 .11797 L
.21429 .0862 L
.21905 .1208 L
.22381 .0684 L
.22857 .10722 L
.23333 .07035 L
.2381 .14024 L
.24286 .16002 L
.24762 .0962 L
.25238 .14833 L
.25714 .18874 L
.2619 .17714 L
.26667 .105 L
.27143 .04362 L
.27619 .11036 L
.28095 .10684 L
.28571 .07526 L
.29048 .05732 L
.29524 .02388 L
.3 .03087 L
s
.3 .03087 m
.30464 0 L
s
.31443 0 m
.31905 .07609 L
.32381 .10542 L
.32857 .15738 L
.33333 .14317 L
.3381 .15243 L
.34286 .20764 L
.34762 .22096 L
.35238 .2153 L
.35714 .26563 L
.3619 .3122 L
.36667 .35278 L
.37143 .38037 L
.37619 .38052 L
.38095 .43467 L
.38571 .47781 L
.39048 .5289 L
.39524 .58891 L
.4 .57273 L
.40476 .54716 L
.40952 .56473 L
.41429 .56986 L
.41905 .55525 L
.42381 .51756 L
.42857 .52404 L
.43333 .57999 L
.4381 .60893 L
.44286 .56255 L
.44762 .49508 L
.45238 .47568 L
.45714 .54105 L
.4619 .57277 L
.46667 .56729 L
.47143 .53704 L
.47619 .47122 L
.48095 .40953 L
.48571 .47737 L
.49048 .54448 L
.49524 .49601 L
.5 .46279 L
.50476 .41459 L
.50952 .48668 L
.51429 .50639 L
.51905 .54283 L
.52381 .51727 L
.52857 .48803 L
.53333 .43407 L
.5381 .43381 L
.54286 .48406 L
.54762 .46833 L
Mistroke
.55238 .4306 L
.55714 .50386 L
.5619 .5293 L
.56667 .45758 L
.57143 .42766 L
.57619 .39203 L
.58095 .34028 L
.58571 .35624 L
.59048 .31438 L
.59524 .27082 L
.6 .21584 L
.60476 .22649 L
.60952 .27894 L
.61429 .33442 L
.61905 .27197 L
.62381 .28934 L
.62857 .26229 L
.63333 .21177 L
.6381 .22268 L
.64286 .19539 L
.64762 .15191 L
.65238 .17558 L
.65714 .21152 L
.6619 .27075 L
.66667 .2065 L
.67143 .23019 L
.67619 .17363 L
.68095 .2312 L
.68571 .26797 L
.69048 .27059 L
.69524 .20779 L
.7 .18438 L
.70476 .19891 L
.70952 .17433 L
.71429 .22716 L
.71905 .25426 L
.72381 .2796 L
.72857 .26895 L
.73333 .32226 L
.7381 .26879 L
.74286 .25272 L
.74762 .2182 L
.75238 .1823 L
.75714 .20821 L
.7619 .15684 L
.76667 .15996 L
.77143 .14959 L
.77619 .17866 L
.78095 .12033 L
.78571 .16473 L
Mistroke
.79048 .13629 L
.79524 .17001 L
.8 .13643 L
.80476 .10406 L
.80952 .07563 L
.81429 .07138 L
.81905 .10182 L
.82381 .16059 L
.82857 .13162 L
.83333 .14816 L
.8381 .19935 L
.84286 .18811 L
.84762 .16852 L
.85238 .16849 L
.85714 .16259 L
.8619 .1141 L
.86667 .06294 L
.87143 .11855 L
.87619 .09475 L
.88095 .1156 L
.88571 .13599 L
.89048 .07134 L
.89524 .04327 L
.9 .10437 L
.90476 .08131 L
.90952 .05875 L
.91429 .12972 L
.91905 .12629 L
.92381 .06173 L
.92857 .12778 L
.93333 .09344 L
.9381 .10901 L
.94286 .13808 L
.94762 .09789 L
.95238 .08094 L
.95714 .03611 L
.9619 .03459 L
.96667 .08602 L
.97143 .13909 L
.97619 .19163 L
Mfstroke
0 .98 .604 r
gsave
.97619 .19481 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21625 m
.02857 .21159 L
.03333 .20813 L
.0381 .20586 L
.04286 .20463 L
.04762 .20425 L
.05238 .20452 L
.05714 .20525 L
.0619 .20631 L
.06667 .2076 L
.07143 .20906 L
.07619 .21063 L
.08095 .2123 L
.08571 .21403 L
.09048 .21581 L
.09524 .21764 L
.1 .2195 L
.10476 .2214 L
.10952 .22332 L
.11429 .22528 L
.11905 .22726 L
.12381 .22925 L
.12857 .23127 L
.13333 .2333 L
.1381 .23534 L
.14286 .23739 L
.14762 .23945 L
.15238 .24151 L
.15714 .24357 L
.1619 .24562 L
.16667 .24766 L
.17143 .24969 L
.17619 .2517 L
.18095 .25369 L
.18571 .25565 L
.19048 .25759 L
.19524 .2595 L
.2 .26138 L
.20476 .26321 L
.20952 .26501 L
.21429 .14276 L
.21905 .14225 L
.22381 .14278 L
.22857 .14391 L
.23333 .14535 L
.2381 .14693 L
.24286 .14855 L
.24762 .15018 L
.25238 .15178 L
.25714 .15334 L
Mistroke
.2619 .15487 L
.26667 .15635 L
.27143 .1578 L
.27619 .15922 L
.28095 .1606 L
.28571 .16196 L
.29048 .1633 L
.29524 .16462 L
.3 .16592 L
.30476 .16721 L
.30952 .08028 L
.31429 .09324 L
.31905 .10253 L
.32381 .1097 L
.32857 .1155 L
.33333 .12034 L
.3381 .1245 L
.34286 .12813 L
.34762 .13135 L
.35238 .13426 L
.35714 .1369 L
.3619 .13933 L
.36667 .14158 L
.37143 .14368 L
.37619 .14566 L
.38095 .14753 L
.38571 .1493 L
.39048 .151 L
.39524 .15263 L
.4 .1542 L
.40476 .3678 L
.40952 .37206 L
.41429 .37565 L
.41905 .37841 L
.42381 .38024 L
.42857 .38117 L
.43333 .38132 L
.4381 .38083 L
.44286 .37986 L
.44762 .37853 L
.45238 .37695 L
.45714 .37522 L
.4619 .37337 L
.46667 .37146 L
.47143 .36951 L
.47619 .36755 L
.48095 .36558 L
.48571 .36362 L
.49048 .36168 L
.49524 .35976 L
Mistroke
.5 .51379 L
.50476 .50678 L
.50952 .50116 L
.51429 .49648 L
.51905 .49246 L
.52381 .48894 L
.52857 .48581 L
.53333 .48299 L
.5381 .48041 L
.54286 .47804 L
.54762 .4369 L
.55238 .44203 L
.55714 .4455 L
.5619 .44754 L
.56667 .44848 L
.57143 .44865 L
.57619 .44829 L
.58095 .44759 L
.58571 .44669 L
.59048 .44565 L
.59524 .32427 L
.6 .32548 L
.60476 .32654 L
.60952 .32736 L
.61429 .32792 L
.61905 .32818 L
.62381 .32817 L
.62857 .32793 L
.63333 .3275 L
.6381 .32695 L
.64286 .32631 L
.64762 .32564 L
.65238 .32494 L
.65714 .32424 L
.6619 .32355 L
.66667 .27567 L
.67143 .27326 L
.67619 .27654 L
.68095 .27402 L
.68571 .27184 L
.69048 .27014 L
.69524 .26899 L
.7 .26844 L
.70476 .26842 L
.70952 .26886 L
.71429 .26966 L
.71905 .2707 L
.72381 .27191 L
.72857 .27322 L
.73333 .27458 L
Mistroke
.7381 .3393 L
.74286 .24926 L
.74762 .24487 L
.75238 .24114 L
.75714 .23826 L
.7619 .23632 L
.76667 .23529 L
.77143 .23507 L
.77619 .2355 L
.78095 .23643 L
.78571 .23773 L
.79048 .23929 L
.79524 .24102 L
.8 .24286 L
.80476 .24477 L
.80952 .24672 L
.81429 .2487 L
.81905 .25068 L
.82381 .25266 L
.82857 .25462 L
.83333 .08333 L
.8381 .09635 L
.84286 .10528 L
.84762 .11208 L
.85238 .11755 L
.85714 .12214 L
.8619 .12608 L
.86667 .12954 L
.87143 .13262 L
.87619 .13541 L
.88095 .13796 L
.88571 .14031 L
.89048 .1425 L
.89524 .14454 L
.9 .14647 L
.90476 .1483 L
.90952 .15004 L
.91429 .15171 L
.91905 .15331 L
.92381 .15486 L
.92857 .15124 L
.93333 .14867 L
.9381 .14771 L
.94286 .14782 L
.94762 .14859 L
.95238 .14972 L
.95714 .15105 L
.9619 .15247 L
.96667 .15392 L
.97143 .15537 L
Mistroke
.97619 .19481 L
Mfstroke
1 0 0 r
gsave
.97619 .24342 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27518 m
.02857 .28266 L
.03333 .28858 L
.0381 .29344 L
.04286 .29757 L
.04762 .30117 L
.05238 .30443 L
.05714 .30745 L
.0619 .31032 L
.06667 .31312 L
.07143 .31587 L
.07619 .3186 L
.08095 .32134 L
.08571 .32409 L
.09048 .32686 L
.09524 .32965 L
.1 .33246 L
.10476 .3353 L
.10952 .33816 L
.11429 .34104 L
.11905 .34394 L
.12381 .34685 L
.12857 .34977 L
.13333 .3527 L
.1381 .35563 L
.14286 .35855 L
.14762 .36146 L
.15238 .36436 L
.15714 .36723 L
.1619 .37008 L
.16667 .3729 L
.17143 .37568 L
.17619 .37842 L
.18095 .38111 L
.18571 .38375 L
.19048 .38634 L
.19524 .38886 L
.2 .39132 L
.20476 .39371 L
.20952 .39604 L
.21429 .1987 L
.21905 .20444 L
.22381 .20899 L
.22857 .21285 L
.23333 .21628 L
.2381 .2194 L
.24286 .2223 L
.24762 .22505 L
.25238 .22766 L
.25714 .23016 L
Mistroke
.2619 .23258 L
.26667 .23491 L
.27143 .23719 L
.27619 .23941 L
.28095 .24158 L
.28571 .24371 L
.29048 .2458 L
.29524 .24787 L
.3 .24991 L
.30476 .25193 L
.30952 .13036 L
.31429 .14513 L
.31905 .15675 L
.32381 .16621 L
.32857 .17413 L
.33333 .18092 L
.3381 .18685 L
.34286 .19212 L
.34762 .19686 L
.35238 .20116 L
.35714 .20512 L
.3619 .20877 L
.36667 .21219 L
.37143 .21539 L
.37619 .21841 L
.38095 .22128 L
.38571 .22402 L
.39048 .22664 L
.39524 .22917 L
.4 .2316 L
.40476 .4163 L
.40952 .43645 L
.41429 .45305 L
.41905 .46653 L
.42381 .47702 L
.42857 .48478 L
.43333 .49019 L
.4381 .49372 L
.44286 .49581 L
.44762 .49686 L
.45238 .49716 L
.45714 .49695 L
.4619 .49638 L
.46667 .49558 L
.47143 .4946 L
.47619 .49352 L
.48095 .49236 L
.48571 .49116 L
.49048 .48992 L
.49524 .48867 L
Mistroke
.5 .56957 L
.50476 .56433 L
.50952 .56058 L
.51429 .55769 L
.51905 .55536 L
.52381 .55342 L
.52857 .55175 L
.53333 .55029 L
.5381 .549 L
.54286 .54783 L
.54762 .4835 L
.55238 .50133 L
.55714 .51347 L
.5619 .52149 L
.56667 .52657 L
.57143 .52963 L
.57619 .53136 L
.58095 .53224 L
.58571 .53257 L
.59048 .53258 L
.59524 .37482 L
.6 .39255 L
.60476 .40784 L
.60952 .42101 L
.61429 .43201 L
.61905 .44081 L
.62381 .4475 L
.62857 .45234 L
.63333 .45566 L
.6381 .4578 L
.64286 .45907 L
.64762 .45973 L
.65238 .45997 L
.65714 .45992 L
.6619 .45969 L
.66667 .33197 L
.67143 .34492 L
.67619 .32649 L
.68095 .34033 L
.68571 .35207 L
.69048 .36227 L
.69524 .37109 L
.7 .3786 L
.70476 .3849 L
.70952 .39015 L
.71429 .39453 L
.71905 .39823 L
.72381 .40138 L
.72857 .40413 L
.73333 .40657 L
Mistroke
.7381 .39533 L
.74286 .29602 L
.74762 .30782 L
.75238 .31728 L
.75714 .32524 L
.7619 .33206 L
.76667 .33792 L
.77143 .34303 L
.77619 .34753 L
.78095 .35157 L
.78571 .35527 L
.79048 .35873 L
.79524 .362 L
.8 .36514 L
.80476 .36818 L
.80952 .37113 L
.81429 .37401 L
.81905 .37683 L
.82381 .37958 L
.82857 .38228 L
.83333 .13901 L
.8381 .15117 L
.84286 .16134 L
.84762 .16991 L
.85238 .17723 L
.85714 .18359 L
.8619 .1892 L
.86667 .19422 L
.87143 .19876 L
.87619 .2029 L
.88095 .20672 L
.88571 .21027 L
.89048 .21358 L
.89524 .21671 L
.9 .21966 L
.90476 .22247 L
.90952 .22516 L
.91429 .22774 L
.91905 .23022 L
.92381 .23263 L
.92857 .19983 L
.93333 .20697 L
.9381 .2121 L
.94286 .21619 L
.94762 .21967 L
.95238 .22276 L
.95714 .2256 L
.9619 .22826 L
.96667 .23078 L
.97143 .2332 L
Mistroke
.97619 .24342 L
Mfstroke
gsave
.97619 .1462 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15732 m
.02857 .14052 L
.03333 .12769 L
.0381 .11828 L
.04286 .1117 L
.04762 .10733 L
.05238 .10461 L
.05714 .10305 L
.0619 .10229 L
.06667 .10209 L
.07143 .10225 L
.07619 .10267 L
.08095 .10325 L
.08571 .10396 L
.09048 .10476 L
.09524 .10562 L
.1 .10654 L
.10476 .1075 L
.10952 .10849 L
.11429 .10952 L
.11905 .11057 L
.12381 .11166 L
.12857 .11277 L
.13333 .1139 L
.1381 .11506 L
.14286 .11624 L
.14762 .11744 L
.15238 .11866 L
.15714 .1199 L
.1619 .12115 L
.16667 .12241 L
.17143 .12369 L
.17619 .12497 L
.18095 .12626 L
.18571 .12756 L
.19048 .12885 L
.19524 .13014 L
.2 .13143 L
.20476 .13271 L
.20952 .13398 L
.21429 .08682 L
.21905 .08006 L
.22381 .07657 L
.22857 .07497 L
.23333 .07442 L
.2381 .07445 L
.24286 .0748 L
.24762 .07531 L
.25238 .0759 L
.25714 .07653 L
Mistroke
.2619 .07716 L
.26667 .07779 L
.27143 .07842 L
.27619 .07903 L
.28095 .07963 L
.28571 .08022 L
.29048 .0808 L
.29524 .08137 L
.3 .08193 L
.30476 .08249 L
.30952 .0302 L
.31429 .04135 L
.31905 .04831 L
.32381 .05319 L
.32857 .05686 L
.33333 .05977 L
.3381 .06214 L
.34286 .06413 L
.34762 .06585 L
.35238 .06735 L
.35714 .06868 L
.3619 .06988 L
.36667 .07097 L
.37143 .07197 L
.37619 .0729 L
.38095 .07377 L
.38571 .07458 L
.39048 .07536 L
.39524 .07609 L
.4 .0768 L
.40476 .3193 L
.40952 .30767 L
.41429 .29825 L
.41905 .29028 L
.42381 .28345 L
.42857 .27757 L
.43333 .27245 L
.4381 .26794 L
.44286 .2639 L
.44762 .26019 L
.45238 .25675 L
.45714 .25348 L
.4619 .25036 L
.46667 .24735 L
.47143 .24442 L
.47619 .24158 L
.48095 .2388 L
.48571 .23609 L
.49048 .23344 L
.49524 .23086 L
Mistroke
.5 .45801 L
.50476 .44923 L
.50952 .44175 L
.51429 .43527 L
.51905 .42956 L
.52381 .42447 L
.52857 .41988 L
.53333 .41568 L
.5381 .41182 L
.54286 .40824 L
.54762 .3903 L
.55238 .38273 L
.55714 .37753 L
.5619 .37358 L
.56667 .37039 L
.57143 .36766 L
.57619 .36522 L
.58095 .36295 L
.58571 .3608 L
.59048 .35872 L
.59524 .27372 L
.6 .25841 L
.60476 .24523 L
.60952 .23371 L
.61429 .22382 L
.61905 .21556 L
.62381 .20884 L
.62857 .20351 L
.63333 .19934 L
.6381 .1961 L
.64286 .19356 L
.64762 .19154 L
.65238 .18991 L
.65714 .18856 L
.6619 .18741 L
.66667 .21937 L
.67143 .2016 L
.67619 .22659 L
.68095 .2077 L
.68571 .19161 L
.69048 .178 L
.69524 .1669 L
.7 .15827 L
.70476 .15194 L
.70952 .14757 L
.71429 .14478 L
.71905 .14317 L
.72381 .14243 L
.72857 .1423 L
.73333 .14258 L
Mistroke
.7381 .28326 L
.74286 .2025 L
.74762 .18192 L
.75238 .16501 L
.75714 .15128 L
.7619 .14058 L
.76667 .13265 L
.77143 .1271 L
.77619 .12347 L
.78095 .1213 L
.78571 .1202 L
.79048 .11985 L
.79524 .12003 L
.8 .12057 L
.80476 .12136 L
.80952 .12231 L
.81429 .12339 L
.81905 .12453 L
.82381 .12573 L
.82857 .12697 L
.83333 .02764 L
.8381 .04154 L
.84286 .04923 L
.84762 .05425 L
.85238 .05788 L
.85714 .06068 L
.8619 .06296 L
.86667 .06486 L
.87143 .06649 L
.87619 .06793 L
.88095 .0692 L
.88571 .07035 L
.89048 .07141 L
.89524 .07238 L
.9 .07328 L
.90476 .07412 L
.90952 .07492 L
.91429 .07568 L
.91905 .0764 L
.92381 .07709 L
.92857 .10266 L
.93333 .09038 L
.9381 .08332 L
.94286 .07945 L
.94762 .0775 L
.95238 .07667 L
.95714 .07649 L
.9619 .07668 L
.96667 .07706 L
.97143 .07755 L
Mistroke
.97619 .1462 L
Mfstroke
0 0 0 r
gsave
.97619 .21823 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.02381 .20697 Mdot
.21429 .11538 Mdot
.30952 .03413 Mdot
.40476 .50012 Mdot
.5 .54929 Mdot
.54762 .40734 Mdot
.59524 .26475 Mdot
.66667 .26599 Mdot
.67619 .27935 Mdot
.7381 .35301 Mdot
.74286 .18034 Mdot
.83333 .04315 Mdot
.92857 .14808 Mdot
.97619 .21823 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003oo`3ooolJ
0?ooo`00803oool200000380oooo0`0000040?ooo`800000;@3oool3000000@0oooo0P0000040?oo
o`800000:@3oool3000000<0oooo0`0000040?ooo`800000:03oool5000000<0oooo0P0000040?oo
o`800000403oool001l0oooo00@000000?ooo`3oool00000<03oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool00000;@3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool00000:@3oool01@000000oooo0?ooo`3oool00000
00<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0V0?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000?0?ooo`00
7`3oool010000000oooo0?ooo`00000d0?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool0:`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool00000:@3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000003`3oool001l0oooo00@000000?ooo`3oool00000=03oool01000
0000oooo0?ooo`0000020?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool00P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000002T0oooo00<000000?ooo`3oool0
1@3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo02P0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool03@3oool0
01l0oooo00@000000?ooo`3oool00000<03oool4000000<0oooo00@000000?ooo`3oool00000;@3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
0000:@3oool010000000oooo0?ooo`3oool4000000<0oooo00@000000?ooo`3oool000009`3oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000?0?ooo`007`3oool010000000oooo0?ooo`00000`0?ooo`030000003oool0oooo00@0
oooo00@000000?ooo`3oool00000;03oool2000000@0oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000X0?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`040000003o
ool0oooo000002L0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000003`3oool00200oooo0P00000a0?ooo`D000000`3oool20000
02h0oooo00<000000?ooo`3oool00`3oool2000000@0oooo0P00000Z0?ooo`040000003oool0oooo
0?ooo`D000000`3oool2000002T0oooo0`0000040?ooo`800000103oool200000100oooo003o0?oo
oaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0oooo000K0?ooobL000000P000?lN
00000080003o00<000000000o`000?l0XP00000@0?ooo`006`3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo01h0oooo0P000?l:0?ooo`030000O`3oool0oooo00P0oooo00<000000?oo
o`3oool01P3oool20000o`030?ooo`000?l0003o01@0oooo00<0001o0?ooo`3oool0503oool00`00
0000oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`00
07l0oooo0000O`0>0?ooo`030000000007l0oooo01<0oooo00<0001o0?ooo`3oool0503oool00`00
07l0oooo0?ooo`080?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0
oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0J0?ooo`80003o0P3oool20000o`X0
oooo00<0001o0?ooo`3oool04@3oool20000o`030?ooo`000?l0003o01@0oooo00<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3o
ool03P3oool00`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`00
6`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo01X0oooo0P000?l20?ooo`80003o
2P3oool00`0007l0oooo0?ooo`0A0?ooo`80003o00<0oooo0000o`000?l0503oool00`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo
0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo
000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool06P3oool20000o`040?ooo`00
0?l0003o0000o`X0oooo00<0001o0?ooo`3oool0403oool30000o`030?ooo`000?l0003o01@0oooo
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo
00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo01X0oooo0P00
0?l0103oool0003o0000o`000?l:0?ooo`030000O`3oool0oooo00l0oooo0`000?l20?ooo`80003o
503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000
003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool06P3o
ool20000o`040?ooo`000?l0003o0000o`D0oooo0P000?l30?ooo`030000O`3oool0oooo00l0oooo
0`000?l0103oool00000000000000?lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`00
07l03P3oool20000Oa<0oooo0P3o000F0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool2000000@0oooo00<0001o0?ooo`3oool0
6P3oool20000o`040?ooo`000?l0003o0000o`D0oooo0P000?l30?ooo`030000O`3oool0oooo00l0
oooo0`000?l4000001@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`0>0?ooo`80
001o4`3oool20?l001H0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`020?ooo`80
0000403oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0I0?ooo`L0003o
1@3oool20000o`<0oooo00<0001o0?ooo`3oool03`3oool30000o`@00000503oool00`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo
0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lC0?ooo`<0o`005@3oool00`0007l0oooo
0?ooo`020?ooo`@0003o0P3oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo
000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool06@3oool70000o`@0oooo0`00
0?l30?ooo`030000O`3oool0oooo00l0oooo0P000?l20?ooo`80000000<0o`000?ooo`3oool04P3o
ool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203o
ool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lC0?ooo`80000000<0
o`000?ooo`3oool04`3oool00`0007l0oooo0?ooo`020?ooo`@0003o0P3oool00`0007l0oooo0?oo
o`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o
0?ooo`3oool06@3oool80000o`<0oooo0`000?l30?ooo`030000O`3oool0oooo00X0oooo0P000?l2
0?ooo`<0003o0P3oool30?l000030000o`3oool0oooo0140oooo00<0001o0?ooo`3oool0503oool0
0`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool0
0`0007l0oooo0000O`0>0?ooo`80001o4P3oool4000000`0oooo0P000?l70?ooo`030000O`3oool0
oooo0080oooo10000?l20?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool0
01/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0I0?ooo`P0003o0`3oool30000
o`<0oooo00<0001o0?ooo`3oool02P3oool20000o`80oooo0P000?l20?ooo`D0o`004`3oool00`00
07l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lB0?ooo`@000000P3o000:0?oo
o`80003o1`3oool00`0007l0oooo0?ooo`020?ooo`@0003o0P3oool00`0007l0oooo0?ooo`030?oo
o`030000003oool0oooo00h0oooo000D0?ooo`<00000103oool00`000000oooo0?ooo`030?ooo`03
0000O`3oool0oooo00H0oooo0P000?lA0?ooo`P0003o0P3oool40000o`<0oooo00<0001o0?ooo`3o
ool02P3oool20000o`80oooo0P000?l20?ooo`80o`0000@0001o0?l0003o0000o`004P3oool00`00
07l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lC0?ooo`800000103o00090?oo
o`80003o1`3oool00`0007l0oooo0?ooo`020?ooo`@0003o0P3oool00`0007l0oooo0?ooo`030?oo
o`030000003oool0oooo00h0oooo000E0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool00`3oool00`0007l0oooo0?ooo`060?ooo`80003o4@3oool80000o`80oooo10000?l30?ooo`03
0000O`3oool0oooo00X0oooo0P000?l20?ooo`80003o0P3oool20?l000030000O`000?l0o`000080
o`004@3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3o
ool0203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lC0?ooo`80
o`000P3oool30?l000P0oooo0P000?l00`3oool0003o0000o`040?ooo`030000O`3oool0oooo0080
oooo10000?l20?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool000`0oooo
1@0000000`3oool0000000000003000000@0oooo0`0000030?ooo`030000O`3oool0oooo00D0oooo
0`000?lA0?ooo`P0003o0P3oool40000o`<0oooo00<0001o0?ooo`3oool02@3oool30000o`80oooo
0P000?l20?ooo`80o`0000<0001o0000o`000?l0103o000?0?ooo`030000O`3oool0oooo01@0oooo
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo
00<0001o0?ooo`0007l03P3oool20000Oa<0oooo0P3o00030?ooo`@0o`0000<0003o0?ooo`3oool0
0P3oool30000o`030?ooo`000?l0003o0080oooo0P000?l0100007l0oooo0?ooo`3oool50000o`80
oooo00@0001o0?ooo`3oool0oooo0`00000@0?ooo`004P3oool010000000oooo0?ooo`0000050?oo
o`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool01@3oool30000oa40oooo20000?l20?oo
o`@0003o0`3oool00`0007l0oooo0?ooo`090?ooo`<0003o0P3oool20000o`80oooo0P3o00001000
07l0003o0000o`3oool70?l000/0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`0>
0?ooo`80001o4`3oool20?l000@0oooo1@3o00030?ooo`<0003o00<0oooo0000o`000?l00P3oool2
0000o`040000O`3oool0oooo0?ooo`80003o00H0oooo0000o`000?l0003o0?ooo`0007l50?ooo`03
0000003oool0oooo00h0oooo000C0?ooo`030000003oool0000000D0oooo00<000000?ooo`3oool0
0`3oool00`0007l0oooo0?ooo`050?ooo`<0003o4@3oool50000o`030?ooo`000?l0003o0080oooo
10000?l30?ooo`040000O`000?l0003o0?ooo`80003o1P3oool30000o`040?ooo`000?l0003o0000
o`80oooo0P3o00000`0007l0003o0000o`030?ooo`P0o`00203oool00`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?oo
o`030000O`3oool0001o00h0oooo0P0007l?0?ooo`80003o0P3oool20?l000H0oooo203o00001000
0?l0oooo0000o`000?l20?ooo`80003o00@0001o0?ooo`3oool0oooo0P000?l20?ooo`80003o00<0
oooo0000O`3oool0103oool00`000000oooo0?ooo`0>0?ooo`00503oool2000000D0oooo00<00000
0?ooo`3oool00`3oool00`0007l0oooo0?ooo`050?ooo`<0003o403oool60000o`030?ooo`000?l0
003o0080oooo10000?l30?ooo`030000O`000?l0o`0000H0o`000`3oool30000o`030?ooo`000?l0
003o0080oooo0`3o00000`0007l0003o0000o`070?ooo`X0o`000P3oool00`0007l0oooo0?ooo`0D
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>
0?ooo`030000O`3oool0001o00h0oooo0P0007l>0?ooo`<0003o0P3oool20?l000H0oooo0P000?l;
0?l000040?ooo`000?l0003o0000O`<0oooo0P000?l20?ooo`80003o00<0oooo0000O`3oool0103o
ool00`000000oooo0?ooo`0>0?ooo`005@3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo00<0oooo00<0001o0?ooo`3oool01@3oool30000oa00oooo0P000?l01@3oool0003o0000o`00
0?l0oooo0080003o00<0oooo0000o`000?l010000?l20?oooa40o`0000<0003o0?ooo`3oool00P3o
0000103oool0001o0000o`000?l:0?ooo`T0o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo
0000O`0>0?ooo`80001o3P3oool30000o`80oooo0P3o00060?ooo`80003o103oool00`000?l0o`00
0?l000070?l000030000O`3oool0o`0000P0o`0000<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00D0oooo0`00
0?l@0?ooo`80003o0P3oool20000o`040?ooo`000?l0003o0?ooo`80003o0P3oool20000o`80oooo
0`3o00030000o`80oooo3P3o0002003jVP80003o403oool30?l000030000O`3oool0oooo01@0oooo
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo
00<0001o0?ooo`0007l03P3oool20000O`h0oooo0`000?l0103oool0o`000?l0003o00060?ooo`80
003o103oool60000o`@0o`0000<0001o0?l0003o0000203o00000`0007l0oooo0?ooo`030?ooo`03
0000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0
1@3oool30000oa00oooo0P000?l20?ooo`80003o00@0oooo0000o`000?l0oooo0P000?l20?ooo`80
003o00@0oooo0?l0003o0000o`0010000?l60?ooo`@0003o1P3o0002003jVP80003o4@3oool20?l0
00030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?oo
o`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000O`d0oooo10000?l0103o
ool0o`000?l00000nYX60?ooo`80003o103oool60000o`050?ooo`000?l0o`000?l0000007l00P3o
00000`3oool0003o0000o`020?ooo`040000o`3o0000o`000000O`D0oooo00<000000?ooo`3oool0
3P3oool001/0oooo0P0000040?ooo`030000O`3oool0oooo00D0oooo10000?l?0?ooo`80003o0P3o
ool20000o`040?ooo`000?l0003o0?ooo`80003o0P3oool20000o`030?ooo`3o0000o`0000D0003o
1@3oool70000o`@0oooo0`00nYX00`000?l0oooo0?ooo`0?0?ooo`80o`0000<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
3P3oool00`0007l0oooo0000O`0>0?ooo`80001o3@3oool50000o`80o`000P00nYX40?ooo`<0003o
103oool60000o`030?ooo`000?l0o`0000@0o`0000<0oooo0000o`000?l00P3oool010000?l0o`00
0?l0000007l40?ooo`800000403oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo
0?ooo`050?ooo`@0003o3`3oool20000o`80oooo0P000?l0103oool0003o0000o`3oool20000o`80
oooo0P000?l00`3oool0o`000?l000050000o`030?ooo`000?l0003o0080oooo0P000?l00`3oool0
003o0000o`020000o`@0oooo0`00nYX20000oa00oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?ooo`03
0000O`3oool0001o00h0oooo0P0007l=0?ooo`80003o00<0oooo0000o`000?l00P3o0002003jVP@0
oooo1@000?l20?ooo`P0003o103o0000103oool0003o0000o`000?l20?ooo`040000o`3o0000o`00
0000O`D0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`00
07l0oooo0?ooo`040?ooo`D0003o3`3oool20000o`80oooo0P000?l0103oool0003o0000o`3oool2
0000o`80oooo0P000?l00`3oool0o`000?l000050000o`030?ooo`000?l0003o0080oooo0P000?l0
103oool0003o0000o`000?l50?ooo`<00?ZJ0P000?l@0?ooo`80o`0000<0001o0?ooo`3oool0503o
ool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3o
ool00`0007l0oooo0000O`0>0?ooo`80001o303oool30000o`030?ooo`000?l0003o0080o`000P00
nYX40?ooo`D0003o0P3oool40000o`030?ooo`000?l0003o0080003o0`3o00000`3oool0003o0000
o`030?ooo`040000o`3o0000o`000000O`D0oooo00<000000?ooo`3oool03P3oool001/0oooo00<0
00000?ooo`3oool00`3oool00`0007l0oooo0?ooo`030?ooo`/0o`002P3oool20000o`D0oooo1@00
0?l20?ooo`<0003o0P3o00050000o`030?ooo`000?l0003o0080oooo0P000?l0103oool0003o0000
o`000?l50?ooo`@00?ZJ00<0003o0?ooo`3oool03P3oool20?l000030000O`3oool0oooo01@0oooo
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo
00<0001o0?ooo`0007l03P3oool20000O``0oooo0P000?l20?ooo`80003o0P3o0003003jVP<0oooo
1@000?l20?ooo`@0003o00<0oooo0000o`000?l00P000?l20?l000@0003o0`3oool010000?l0o`00
0?l0000007l50?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo
00<0001o0?ooo`3oool00P3ooolB0?l000@0oooo0P000?l60?ooo`@0003o0P3oool30000o`80o`00
20000?l20?ooo`80003o00@0oooo0000o`000?l0003o103oool6003jVQ00oooo0P3o00000`0007l0
oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007l<0?ooo`80003o0P3oool20000o`80
o`001000nYX20?ooo`/0003o00<0oooo0000o`000?l00P000?l20?l000@0003o0`3oool010000?l0
o`000?l0000007l50?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0
oooo00@0001o0?ooo`3oool0oooo0`3o00020000o`030?ooo`000?l0003o00@0oooo2`3o00020000
o`H0oooo10000?l20?ooo`80003o00<0o`000000000000000`000?l00`3oool0003o0000o`020000
o`80oooo0P000?l0103oool0003o0000o`000?l40?ooo`800?ZJ00@0001o0?ooo`00nYX00?ZJ403o
ool20?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?oo
o`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000O``0oooo0P00
0?l20?ooo`80003o0P3o00000`00nYX0oooo003jVP02003jVP030?ooo`000?l0003o00H0003o103o
ool:0000o`<0oooo00@0003o0?l0003o0000001o1@3oool00`000000oooo0?ooo`0>0?ooo`006`3o
ool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00<0o`0000@0oooo0000o`000?l0oooo
0P000?l:0?ooo`P0o`001@3oool40000o`80oooo0P000?l4000000<0oooo10000?l20?ooo`80003o
00<0oooo0000o`000?l01@3oool2003jVP030000O`3oool00?ZJ00800?ZJ3`3oool20?l000030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000O``0oooo0P000?l20?ooo`80003o
0P3o00000`00nYX0oooo0?ooo`03003jVPP0003o103oool30000o`030?ooo`000?l0003o00@0003o
0`3oool010000?l0o`000?l0003o00050?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000
003oool0oooo00<0oooo00<0001o0?ooo`3o00000P3o00020?ooo`80003o00<0oooo0000o`000?l0
3P3oool90?l000@0003o0P3oool20000o`@000000`3oool40000o`80oooo0P000?l80?ooo`800?ZJ
00<0001o0?ooo`000?l00`00nYX>0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo
0000O`0>0?ooo`80001o1`3oool90?l00080003o0P3o00001000nYX0oooo0?ooo`3oool3003jVPL0
003o103oool30000o`030?ooo`000?l0003o00@0003o103oool00`000?l0o`000?l000050?ooo`03
0000003oool0oooo00h0oooo000K0?ooo`800000103oool0100007l0oooo0?l0003o00030?ooo`80
003o00@0oooo0000o`000?l0003o3@3oool20000o`030?ooo`3o0000o`0000L0o`0000<0003o0?oo
o`3oool00P000?l0103o00000000000000000?l30?ooo`D0003o00<0oooo0000o`000?l0203oool2
003jVP040000O`3oool0003o0000o`<00?ZJ3@3oool20?l000030000O`3oool0oooo01@0oooo00<0
001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0
001o0?ooo`0007l03P3oool20000O`H0oooo3P3o00000`00nYX0oooo0?ooo`020?ooo`<00?ZJ1P00
0?l40?ooo`<0003o00<0oooo0000o`000?l00`000?l50?ooo`030000o`3o0000o`0000@0oooo0P00
000@0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`040000O`3o0000o`000?l000<0oooo0P00
0?l20?ooo`80003o3@3oool20000o`H0oooo203o000010000?l0o`000?l0000007l40?ooo`D0003o
00<0oooo0000o`000?l0203oool01000nYX0o`000?l0003oool20000o`030?ooo`00nYX00?ZJ0080
0?ZJ2`3oool20?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000O`@0
oooo103o00000`000?l0oooo0?ooo`020000o`80oooo1@3o00000`00nYX0oooo0?ooo`030?ooo`<0
0?ZJ0P3oool30000o`@0oooo0`000?l0103oool0003o0000o`3oool20000o`D0oooo00<0003o0?l0
003o00001@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`03
0000O`3o0000o`0000@0oooo0P000?l20?ooo`<0003o303oool20000o`L0oooo0P000?l80?l00003
0000O`3oool0oooo0080oooo1@000?l00`3oool0003o0000o`080?ooo`04003jVP3o0000o`000?oo
o`<0003o00<0oooo003jVP00nYX00`00nYX90?ooo`80o`0000<0001o0?ooo`3oool0503oool00`00
07l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`00
07l0oooo0000O`0>0?ooo`80001o0`3oool40?l00080003o0P3oool20000o`<0oooo0P000?l20?l0
0003003jVP3oool0oooo00<0oooo00D0003o003jVP00nYX00?ZJ0?ooo`030000o`@0oooo0P000?l2
0?ooo`80003o00<0oooo0000o`000?l01@3oool00`000?l0o`000?l000050?ooo`030000003oool0
oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo0`3o00040?ooo`80003o0`3oool30000
o`/0oooo0P000?l70?ooo`<0003o0`3oool40?l000030000O`3oool0oooo0080oooo1@000?l00`3o
ool0003o0000o`080?ooo`03003jVP3o0000o`000080oooo0P000?l30?ooo`D00?ZJ1`3oool20?l0
00030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?oo
o`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000O`<0oooo0P3o00020?oo
o`H0003o0`3oool30000o`80o`001@3oool20000o`D00?ZJ00<0003o0?ooo`3oool01`3oool01000
07l0oooo0000o`000?l50?ooo`030000o`3o0000o`0000D0oooo00<000000?ooo`3oool03P3oool0
01/0oooo00<000000?ooo`3oool00`3oool20?l000D0oooo0P000?l40?ooo`80003o2`3oool20000
o`P0oooo0P000?l60?ooo`@00?ZJ0P3oool80000o`P0oooo00D00?ZJ0?l0003o0000o`000?ooo`03
0000o`@0oooo1000nYX60?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`08
0?ooo`H0o`000P0007l20?ooo`<0o`000P3oool60000o`@0oooo0P000?l20?l000@0oooo0`000?l0
0`3oool00?ZJ003jVP04003jVPL0oooo0P0000000`3oool0003o0000o`050?ooo`030000o`3o0000
o`0000D0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool20?l0
00@0oooo0`000?l40?ooo`80003o1`3oool20000o`80oooo0P000?l80?ooo`80003o1P3oool8003j
VPD0003o2@3oool01@00nYX0o`000?l0003o0000oooo00<0003o1P3oool6003jVP80oooo0P3o0000
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool0
0`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00H0oooo203o00020000O`80oooo0P3o0003
0?ooo`H0003o103oool20000o`<0o`000`3oool20000o`D0oooo1@00nYX40?ooo`@000000P00nYX5
0?ooo`030000o`3o0000o`0000D0oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?oo
o`3oool00`3oool20?l000@0oooo0P000?l50?ooo`80003o1`3oool20000o`80oooo0P000?l80?oo
o`80003o1P3oool2003jVP030?ooo`00nYX00?ZJ00H00?ZJ0P000?l80?ooo`800?ZJ0`3o00000`3o
ool0003o0000o`020000o`H0oooo1`00nYX20?l000030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo0P000?l40?oo
o`030000O`3oool0001o00D0oooo103o00030?ooo`80o`000P0007l01@3oool0o`000?l0003o0000
oooo00P0003o103oool20000o`<0o`000`3oool20000o`L0oooo1P00nYX00`3oool0000000000002
000000H00?ZJ00@0oooo0000o`3o0000o`001@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool2
000000<0oooo0`3o00040?ooo`80003o1@3oool30000o`H0oooo0P000?l20?ooo`80003o403oool2
003jVP@0oooo00<0003o003jVP00nYX01000nYX80?ooo`800?ZJ103o00040000o`X0oooo0`00nYX2
0?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00P0oooo0P000?l40?ooo`030000O`3oool0001o00D0oooo0P3o0005
0?ooo`80o`000P0007l0103oool0o`000?l0003oool90000o`@0oooo0P000?l30?l000<0oooo0P00
0?l90?ooo`H00?ZJ0P0000000`00nYX0oooo003jVP07003jVP030000O`3oool0oooo0080oooo0P00
000@0?ooo`006`3oool00`000000oooo0?ooo`020?ooo`80o`001@3oool20000o`H0oooo0P000?l6
0?ooo`80003o0P3oool20000oa00oooo0P00nYX50?ooo`<0003o1`00nYX40?ooo`800?ZJ103o0004
0000o``0oooo00@00?ZJ0?l0003o0000001o5P3oool00`0007l0oooo0?ooo`080?ooo`030000O`3o
ool0oooo00P0oooo00<0001o0?ooo`3oool0203oool20000o`@0oooo00<0001o0?ooo`0007l0103o
ool30?l000D0oooo0P3o00020000O`030?ooo`3o0000o`0000X0003o103oool20000o`@0o`000P3o
ool20000o``0oooo1000nYX00`0007l0oooo0?ooo`040?ooo`@00?ZJ00<0001o0?ooo`3oool00`3o
ool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`020?ooo`80o`001@3oool2
0000o`H0oooo0`000?l50?ooo`H0003o403oool2003jVPD0oooo1@000?l:003jVPD0o`0010000?l=
0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0
oooo00P0oooo00<0001o0?ooo`3oool0203oool20000o`@0oooo00<0001o0?ooo`0007l0103oool2
0?l000H0oooo0P3o00020000O`<0o`002@000?l50?ooo`80003o103o00020?ooo`80003o403oool0
0`0007l0oooo0?ooo`060?ooo`800?ZJ00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>
0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00<0oooo0P000?l60?oo
o`<0003o103oool70000oa00oooo0P00nYX70?ooo`@0003o0`3oool6003jVP80o`0000D0001o0?l0
003o0000o`000?ooo`020000o`d0oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0
oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`<0003o0`3oool0
0`0007l0oooo0000O`030?ooo`<0o`001P3oool20?l00080001o0P3o00020000o`030?ooo`000?l0
003o00D0003o1@3oool20000o`D0o`000`000?l@0?ooo`030000O`3oool0oooo00H0oooo0P00nYX0
0`000?l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo
00<0oooo00<0001o0?ooo`3oool00`3oool20000o`L0oooo0P000?l40?ooo`H0003o4@3oool2003j
VPL0oooo10000?l70?ooo`800?ZJ0P3o00001@0007l0oooo0?l0003o0000oooo0080003o3@3oool2
0?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00P0oooo0`000?l30?ooo`030000O`3oool0001o00<0oooo0P3o0007
0?ooo`80o`000P0007l20?l00080003o0P3oool20000o`80oooo0P000?l60?ooo`04003jVP3o0000
o`000?ooo`<0o`0000<0003o0?ooo`3oool03`3oool00`0007l0oooo0?ooo`060?ooo`800?ZJ00<0
003o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`004P3oool5000000@0oooo00<00000
0?ooo`3oool00`3oool00`0007l0oooo0?ooo`030?ooo`80003o1`3oool20000o`@0oooo1P000?lA
0?ooo`800?ZJ203oool30000o`T0oooo0P3o00000`0007l0oooo0?l000020?l00080003o3@3oool2
0?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00L0oooo10000?l30?ooo`030000O`000?l0003o0080oooo0`3o0000
0`3oool0003o0000o`040?ooo`80o`000P0000020?l00080003o0P3oool20000o`80oooo0P000?l6
0?ooo`05003jVP3o0000o`000?ooo`000?l00`3o000A0?ooo`030000O`3oool0oooo00H0oooo0P00
nYX00`000?l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000C0?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`030?ooo`80003o1`3o
ool20000o`@0oooo1P000?lA0?ooo`800?ZJ203oool30000o`T0oooo0P3o00000`0007l0oooo0?oo
o`030?l000030000o`3oool0oooo00/0oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3o
ool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`070?ooo`@0003o0`3o
ool0100007l0003o0000o`3oool30?l00080oooo0P000?l40?ooo`030?l000000000000000800000
00<0o`000000o`000?l00P3oool20000o`X0oooo00<00?ZJ0?l0003o00000`000?l20?l00140oooo
00<0001o0?ooo`3oool01P3oool3003jVPD0oooo00<000000?ooo`3oool03P3oool000`0oooo1@00
00030?ooo`030000003oool0oooo00@0oooo0`0000030?ooo`030000O`3oool0oooo0080oooo0`00
0?l70?ooo`<0003o0`3oool40000oa<0oooo0P00nYX80?ooo`<0003o2@3oool20?l000040000O`3o
ool0oooo0?ooo`80o`000P000?l<0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01`3oool40000o`<0oooo
00@0001o0000o`000?l0oooo0P3o00000`3oool0003o0000o`020000o`@0oooo00<0o`0000000000
00000P0000030000o`80oooo0P000?l:0?ooo`03003jVP3o0000o`0000<0003o0`3o000@0?ooo`03
0000O`3oool0oooo00L0oooo0P00nYX30?ooo`<00000403oool001D0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo0080oooo0P000?l90?ooo`80003o
0`3oool20000oaD0oooo0P00nYX80?ooo`80003o2P3oool20?l000040000O`3oool0oooo0?ooo`<0
o`0000<0003o0?ooo`3oool02P3oool20?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00L0oooo0P000?l50?l00003
0000O`000?l0003o00<0o`0000<0oooo0000o`000?l00P000?l40?ooo`80o`000P000000103o0000
003o0000o`000?l>0?ooo`03003jVP3o0000o`0000<0003o00@0oooo0?l0003o0000o`003`3oool0
0`0007l0oooo0?ooo`070?ooo`800?ZJ1@3oool00`000000oooo0?ooo`0>0?ooo`004P3oool01@00
0000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`02
0?ooo`80003o2@3oool20000o`030?ooo`000?l0003o0080003o5@3oool2003jVPP0oooo0P000?l:
0?ooo`80o`0000<0001o0?ooo`3oool00P3oool40?l000/0oooo0P3o00000`0007l0oooo0?ooo`0D
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`07
0?ooo`L0o`0000<0001o0000o`000?l00P3o00020?ooo`@0003o103oool20?l000030000O`3o0000
o`000080003o3`3oool00`00nYX0o`000?l000020000o`<0oooo0`3o000>0?ooo`030000O`3oool0
oooo00L0oooo0P00nYX50?ooo`030000003oool0oooo00h0oooo000B0?ooo`050000003oool0oooo
0?ooo`000000103oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo0080oooo0P000?l9
0?ooo`80003o00<0oooo0000o`000?l00P000?lE0?ooo`800?ZJ503oool20?l000030000O`3oool0
oooo00<0oooo103o000:0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01P3oool40?l00080003o0P3o0000
0`0007l0003o0000o`020?l00080oooo10000?l40?ooo`D0o`000P000?l?0?ooo`03003jVP3o0000
o`000080003o103oool20?l000h0oooo00<0001o0?ooo`3oool01`3oool2003jVPD0oooo00<00000
0?ooo`3oool03P3oool001<0oooo0`0000050?ooo`030000003oool0oooo0080oooo0P0000040?oo
o`80003o2@3oool70000oaD0oooo0P3o000D0?ooo`80o`0000<0001o0?ooo`3oool00`3oool20000
o`<0o`002@3oool30?l001H0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?oo
o`030000O`3oool0oooo00D0oooo0`3o000010000?l0oooo0000o`000?l40?l000040000o`3o0000
o`000?ooo`D0003o103oool40?l000<0003o3`3oool01000nYX0o`000?l000000?l50?ooo`@0o`00
2`3oool20?l000T0oooo0P00nYX50?ooo`030000003oool0oooo00h0oooo000K0?ooo`040000003o
ool0oooo0?ooo`@000002000nYX60?ooo`H0003o5@3oool01000nYX0o`000?l0003o000C0?ooo`80
o`0000<0001o0?ooo`3oool00`3oool20000o`040?ooo`3o0000o`000?l000P0oooo00<00?ZJ0?l0
003o00005P3oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?oo
o`3oool0103oool30?l00080003o00<0oooo0000o`000?l01`3o00000`3oool0003o0000o`040000
o`<0oooo103o00030000o`l0oooo00@00?ZJ0?l0003o0000003o1P3oool50?l000T0oooo0`3o0009
0?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00@000000?oo
o`3oool0oooo1000000<003jVP80oooo1P000?lE0?ooo`03003jVP3o0000o`000080o`004P3oool2
0?l000030000O`3oool0oooo00<0oooo0P000?l20?ooo`<0o`001`3oool00`00nYX0o`000?l0000F
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`03
0?ooo`<0o`0000@0oooo0000o`000?l0oooo0`000?l50?l00080oooo0P000?l20?ooo`80003o0`3o
ool40?l000<0003o3`3oool00`00nYX0o`000?l000090?ooo`@0o`00203oool30?l000T0oooo00<0
001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`02
0?ooo`8000000P00nYX20?ooo`80003o0P3oool7003jVPH0003o5@3oool00`00nYX0o`000?l00004
0?l00100oooo0P3o00000`0007l0oooo0?ooo`030?ooo`80003o00<0oooo0000o`000?l0103o0005
0?ooo`03003jVP3o0000o`0001H0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo0080oooo0`3o00040000o`80oooo0P000?l50?l00080oooo0P000?l2
0?ooo`80003o0`3oool40?l000<0003o3`3oool00`00nYX0o`000?l0000;0?ooo`<0o`001`3oool4
0?l000L0oooo0P0000050?ooo`030000003oool0oooo00h0oooo000K0?ooo`8000000`3oool3003j
VP<0oooo0P000?l60?ooo`H00?ZJ0`000?lE0?ooo`04003jVP3o0000o`000?ooo`D0o`003P3oool2
0?l000030000O`3oool0oooo00<0oooo1@000?l00`3oool0o`000?l000020?l000@0oooo00<00?ZJ
0?l0003o00005P3oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo0P000?l3
0?ooo`80o`0000@0oooo0000o`000?l0003o0`3oool20000o`D0o`000P3oool20000o`80oooo0P00
0?l40?ooo`<0o`0000<0003o0?ooo`3oool03`3oool00`00nYX0o`000?l0000<0?ooo`@0o`001@3o
ool60?l000@0oooo100000030?ooo`800000403oool001/0oooo00<000000?ooo`3oool00P3oool2
003jVP@0oooo0P000?l80?ooo`H00?ZJ5P3oool00`00nYX0o`000?l000030?ooo`@0o`003@3oool2
0?l000030000O`3oool0oooo00@0oooo10000?l30?ooo`D0o`0000@0oooo003jVP3o0000o`005P3o
ool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo0P000?l20?ooo`<0o`0000@0
oooo0000o`000?l0003o0`3oool20000o`D0o`000P3oool20000o`80oooo0P000?l40?ooo`<0o`00
00<0003o0?ooo`3oool03`3oool00`00nYX0o`000?l0000=0?ooo`@0o`000`3oool30?l000030?oo
o`3o0000o`000080o`000`3oool4000000@0oooo00<000000?ooo`3oool03P3oool001/0oooo00<0
00000?ooo`3oool00`3oool00`0007l0oooo0?ooo`020?ooo`80003o2P3oool00`000?l00?ZJ003j
VP04003jVQ<0oooo00<00?ZJ0?l0003o00001@3oool40?l000X0oooo0`3o00000`0007l0oooo0?oo
o`050?ooo`<0003o103oool50?l00003003jVP3o0000o`0001H0oooo00<0001o0?ooo`3oool0203o
ool00`0007l0oooo0?ooo`080?ooo`<0003o00<0oooo0?l0003o00000P3oool30000o`<0oooo1000
0?l20?l000030000o`3oool0003o0080003o0P3oool20000o`@0oooo0`3o00000`000?l0oooo0?oo
o`0?0?ooo`03003jVP3o0000o`0000l0oooo103o0000103oool0o`000?l0000007l30?ooo`D0o`00
00<0oooo0000000000001@3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?oo
o`030?ooo`030000O`3oool0oooo0080oooo0P000?l:0?ooo`80003o00<0oooo003jVP00nYX01000
nYXA0?ooo`03003jVP3o0000o`0000H0oooo103o00090?ooo`80o`0000<0oooo0000O`3oool01`3o
ool20000o`L0oooo1@3o000C0?ooo`80o`0000<0oooo0000O`3oool02@3oool00`0007l0oooo0?oo
o`080?ooo`<0003o0`3o00020?ooo`80003o103oool40000o`80o`0000@0003o0?ooo`000?l0003o
0`3oool20000o`@0oooo0`3o00000`000?l0oooo0?ooo`0?0?ooo`03003jVP3o0000o`000100oooo
1P3o00000`0007l0oooo0?ooo`020?ooo`D0o`0000<0oooo0000O`3oool0103oool00`000000oooo
0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo0080oooo0P00
0?l:0?ooo`80003o103oool5003jVPl0oooo00<00?ZJ0?l0003o0000203oool50?l000H0oooo0P3o
00000`3oool0001o0?ooo`070?ooo`80003o203oool40?l00140oooo103o00000`3oool0001o0?oo
o`090?ooo`030000O`3oool0oooo00P0oooo0P000?l30?l000<0oooo0P000?l40?ooo`L0003o00<0
oooo0000o`000?l00`3oool20000o`@0oooo0`3o00000`000?l0oooo003jVP06003jVPT0oooo00<0
0?ZJ0?l0003o00004P3oool40?l000030000O`3oool0oooo00D0oooo0`3o00000`0007l0oooo0?oo
o`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00@0001o
0?ooo`3oool0oooo0`000?l:0?ooo`80003o1P3oool5003jVPd0oooo00<00?ZJ0?l0003o00002@3o
ool60?l000@0oooo0P3o00000`3oool0001o0?ooo`070?ooo`80003o2@3oool30?l00100oooo1@3o
00000`3oool0001o0?ooo`090?ooo`030000O`3oool0oooo00P0oooo0P000?l20?l000@0oooo0P00
0?l40?ooo`@0003o00@0oooo0000o`000?l0oooo0P000?l30?ooo`80003o103oool30?l000030000
o`00nYX00?ZJ00P00?ZJ1`3oool00`00nYX0o`000?l0000D0?ooo`80o`0000<0001o0?ooo`3oool0
1P3oool20?l000030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo00<0
00000?ooo`3oool00`3oool0100007l0oooo0?ooo`3oool20000o`/0oooo0P000?l80?ooo`H00?ZJ
2P3oool00`00nYX0o`000?l0000<0?ooo`D0o`000P3oool20?l000030?ooo`0007l0oooo00L0oooo
0`000?l80?ooo`<0o`003P3oool40?l000050?ooo`3o0000o`000?ooo`0007l02P3oool00`0007l0
oooo0?ooo`080?ooo`040000o`3o0000o`000?l000<0oooo0`000?l40?ooo`@0003o00@0oooo0000
o`000?l0oooo0P000?l30?ooo`<0003o0`3oool30?l000<00?ZJ1@3oool7003jVP<0oooo00<00?ZJ
0?l0003o00005P3oool00`0007l0oooo0?ooo`060?ooo`<0o`001@3oool00`000000oooo0?ooo`0>
0?ooo`006`3oool2000000@0oooo00@0001o0?ooo`3oool0oooo0P000?lG0?ooo`H00?ZJ203oool0
0`00nYX0o`000?l0000>0?ooo`L0o`0000<0oooo0000O`3oool0203oool20000o`P0oooo0`3o000=
0?ooo`@0o`000P3oool20?l000030?ooo`0007l0oooo00T0oooo00<0001o0?ooo`3oool01`3oool2
0000o`80o`00103oool20000o`D0oooo0`000?l01@0007l0oooo0000o`000?l0oooo0080003o103o
ool20000o`<0oooo0P3o0003003jVPP0oooo1`00nYX0103oool00?ZJ0?l0003o000F0?ooo`030000
O`3oool0oooo00L0oooo0P3o00040?ooo`800000403oool001/0oooo00<000000?ooo`3oool00`3o
ool0100007l0oooo0?ooo`3oool20000oaX0oooo1P00nYX50?ooo`03003jVP3o0000o`000100oooo
1@3o00000`3oool0001o0?ooo`080?ooo`80003o203oool30?l000X0oooo1@3o00040?ooo`80o`00
00<0oooo0000O`3oool02@3oool00`0007l0oooo0?ooo`070?ooo`80003o0P3o00040?ooo`80003o
1P3oool20000o`030000O`3oool0003o00@0003o103oool20000o`<0oooo0P3o00000`00nYX0oooo
0?ooo`0<0?ooo`D00?ZJ0P3o000F0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
0`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`040000O`3o
ool0oooo0?ooo`80003o703oool7003jVP80oooo00<00?ZJ0?l0003o00004P3oool30?l000030?oo
o`0007l0oooo00P0oooo0P000?l80?ooo`<0o`002@3oool50?l000D0oooo0P3o00000`3oool0001o
0?ooo`090?ooo`030000O`3oool0oooo00L0oooo00D0003o0?l0003o0000o`000000o`030?ooo`80
003o1P3oool20000o`030000O`3oool0001o00@0003o103oool20000o`<0oooo0P3o00000`00nYX0
oooo0?ooo`0>0?ooo`<00?ZJ0P3o000F0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`040000
O`000?l0003o0?ooo`80003o7`3oool7003jVP80o`005P3oool00`0007l0oooo0?ooo`070?ooo`80
003o203oool30?l000P0oooo0`3o00080?ooo`80o`0000<0oooo0000O`3oool02@3oool00`0007l0
oooo0?ooo`070?ooo`80000000<0o`000000o`000?l00`3oool20000o`H0oooo00D0003o00000000
0000oooo0000O`030000o`D0oooo0P000?l30?ooo`80o`0000<00?ZJ0?ooo`3oool0403oool00`00
nYX0o`000?l0000F0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`00
0000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`000?l0003o00<0
003o8P3oool4003jVP80o`005P3oool00`0007l0oooo0?ooo`070?ooo`80003o203oool30?l000L0
oooo0`3o00090?ooo`80o`0000<0oooo0000O`3oool02@3oool00`0007l0oooo0?ooo`060?ooo`@0
00000P000?l30?ooo`80003o1P3oool4000000040000O`000?l0003o0000o`D0oooo0P000?l30?oo
o`80o`0000<00?ZJ0?ooo`3oool0403oool30?l001H0oooo00<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0
oooo00<0001o0000o`000?l00`000?lT0?ooo`800?ZJ0P3o000F0?ooo`030000O`3oool0oooo00L0
oooo0P000?l80?ooo`<0o`001P3oool30?l000X0oooo0P3o00000`3oool0001o0?ooo`090?ooo`03
0000O`3oool0oooo00H0oooo100000020000o`<0oooo0P000?l60?ooo`@0000000<0001o0000o`00
nYX01`00nYX30000o`040?ooo`3o0000o`00003jVQ80oooo0P3o00000`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?oo
o`006`3oool00`000000oooo0?ooo`030?ooo`040000O`000?l0003o0?ooo`80003o9P3oool20?l0
01H0oooo00<0001o0?ooo`3oool01`3oool20000o`P0oooo0`3o00050?ooo`<0o`002`3oool20?l0
00030?ooo`0007l0oooo00T0oooo00<0001o0?ooo`3oool01`3oool2000000040?ooo`000?l0003o
0?ooo`@0003o1P3oool00`000?l0000000000002000000d00?ZJ0P3o00000`00nYX0oooo0?ooo`0@
0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0
oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo0P0000030?ooo`80o`000P000?lY0?oo
o`80o`005P3oool00`0007l0oooo0?ooo`070?ooo`80003o203oool30?l000@0oooo0`3o000<0?oo
o`80o`0000<0oooo0000O`3oool02@3oool00`0007l0oooo0?ooo`070?ooo`80o`0000@0oooo0000
o`000?l0oooo10000?l60?ooo`030000o`00nYX0000000<0000000<00?ZJ0?ooo`3oool0103oool5
003jVP80o`0000<00?ZJ0?ooo`3oool0403oool20?l000030000O`3oool0oooo01@0oooo00<0001o
0?ooo`3oool0203oool00`0007l0oooo0?ooo`020?ooo`800000403oool001/0oooo00<000000?oo
o`3oool00P3oool30?l000030000o`3oool0oooo02L0oooo0P3o000F0?ooo`030000O`3oool0oooo
00L0oooo0P000?l80?ooo`<0o`00103oool20?l000d0oooo0P3o00000`3oool0001o0?ooo`090?oo
o`030000O`3oool0oooo00L0oooo0P3o0000103oool0003o0000o`3oool40000o`L0oooo00<00?ZJ
0000000000000P0000080?ooo`<0003o00@00?ZJ0?l0003o00000?ZJ4P3oool20?l000030000O`3o
ool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003o
ool0oooo00h0oooo000K0?ooo`030000003oool0oooo0080oooo00<0003o0?l0003o0000:P3oool2
0?l001H0oooo00<0001o0?ooo`3oool01`3oool20000o`P0oooo0`3o00020?ooo`@0o`003@3oool2
0?l000030?ooo`0007l0oooo00T0oooo00<0001o0?ooo`3oool01`3oool20?l000040?ooo`000?l0
003o0?ooo`<0003o203oool2003jVP8000002@3oool30000o`04003jVP3o0000o`00003jVQ80oooo
0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
0`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`020?ooo`040000o`3o
0000o`000?l002T0oooo0P3o000F0?ooo`030000O`3oool0oooo00L0oooo0`000?l70?ooo`<0o`00
00<0oooo0?l0003o00000P3o000>0?ooo`<0o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo
0?ooo`070?ooo`80o`0000@0oooo0000o`000?l0oooo0`000?l80?ooo`800?ZJ00<0oooo0000O`3o
ool02P3oool00`000?l00?ZJ003jVP02003jVQ80oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`00
6`3oool00`000000oooo0?ooo`030?ooo`030000o`3o0000o`000080o`009`3oool20?l001H0oooo
00<0001o0?ooo`3oool0203oool20000o`L0oooo0`3o00000`3oool0o`000?l0000A0?ooo`80o`00
00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`070?ooo`80o`0000<0oooo0000o`000?l0
10000?l80?ooo`800?ZJ00<0oooo0000O`3oool02P3oool00`000?l00?ZJ003jVP020?l00180oooo
0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
0`3oool00`000000oooo0?ooo`0>0?ooo`00503oool2000000D0oooo00<000000?ooo`3oool00`3o
ool20000o`@0o`009P3oool20?l001H0oooo00<0001o0?ooo`3oool0203oool20000o`L0oooo1P3o
000A0?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`060?ooo`030000o`3o
0000o`000080oooo10000?l90?ooo`800?ZJ00<0oooo0000O`3oool02P3oool00`000?l00?ZJ003j
VP020?l00180oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0
001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`004`3oool010000000oooo0?ooo`00
00040?ooo`030000003oool0oooo00<0oooo0P000?l20?ooo`@0o`008`3oool30?l001H0oooo00<0
001o0?ooo`3oool0203oool20000o`L0oooo1@3o000B0?ooo`80o`0000<0001o0?ooo`3oool0203o
ool00`0007l0oooo0?ooo`060?ooo`030000o`3o0000o`000080oooo10000?l80?ooo`<00?ZJ00<0
oooo0000O`3oool02P3oool00`000?l00?ZJ003jVP030?l00140oooo0P3o00000`0007l0oooo0?oo
o`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?oo
o`0>0?ooo`004`3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00<0oooo00<0
001o0?ooo`3oool00P3oool40?l00280oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3o
ool0oooo00P0oooo0P000?l70?ooo`D0o`004P3oool20?l000030000O`3oool0oooo00P0oooo00<0
001o0?ooo`3oool01P3oool00`000?l0o`000?l000020?ooo`@0003o203oool2003jVP030000O`3o
ool0001o00/0oooo00<0003o003jVP00nYX00`3o000A0?ooo`80o`0000<0001o0?ooo`3oool0503o
ool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3o
ool001<0oooo00@000000?ooo`3oool00000103oool3000000<0oooo00<0001o0?ooo`3oool0103o
ool30?l00240oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo0P00
0?l70?ooo`@0o`004`3oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool01P3o
ool00`000?l0o`000?l000020?ooo`<0003o2@3oool2003jVP030000O`3oool0001o00/0oooo00<0
003o003jVP00nYX00`3o000A0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?oo
o`080?ooo`040000O`3oool0oooo0?ooo`<00000403oool001<0oooo00@000000?ooo`3oool00000
103oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00D0oooo103o000O0?ooo`80o`00
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`80003o1`3oool40?l001<0oooo
0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00H0oooo00<0003o0?l0003o0000
0P3oool30000o`T0oooo0P00nYX00`0007l0oooo0000O`0;0?ooo`80003o00<00?ZJ0?l0003o0000
0P3o000@0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001<0oooo00@000000?ooo`3oool00000
103oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo00H0oooo1P3o000L0?ooo`80o`00
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`80003o1`3oool30?l001@0oooo
0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00H0oooo0`3o00020?ooo`<0003o
2@3oool2003jVP030000O`3oool0001o00`0oooo00<0003o003jVP3o00000`3o000@0?ooo`80o`00
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool03P3oool001@0oooo0P0000050?ooo`030000003oool0oooo00<0oooo00<0
001o0?ooo`3oool0203oool50?l001/0oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3o
ool0oooo00P0oooo0P000?l70?ooo`<0o`00503oool20?l000030000O`3oool0oooo00P0oooo00<0
001o0?ooo`3oool01P3oool20?l000800?ZJ00@0oooo0000o`000?l0003o1@3oool6003jVP030000
O`3oool0001o00`0oooo00<0003o003jVP3o0000103o000?0?ooo`80o`0000<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool0
3P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0;0?ooo`@0o`006@3o
ool20?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool20000o`L0oooo0`3o
000D0?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`060?ooo`80o`004@00
nYX00`0007l0o`000?l0000<0?ooo`050000o`00nYX0o`000?l0003oool00P3o000?0?ooo`80o`00
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0<0?ooo`@0o`00603oool20?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203o
ool20000o`P0oooo0P3o000D0?ooo`80o`0000<0001o0?ooo`3oool0203oool00`0007l0oooo0?oo
o`060?ooo`80o`003000nYX40?ooo`@0o`003@3oool01000nYX0o`000?l0003oool30?l000h0oooo
0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
0`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3o
ool0oooo00h0oooo103o000F0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?oo
o`080?ooo`<0003o1`3oool20?l001@0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3o
ool0oooo00H0oooo0P3o00001000nYX0oooo0?ooo`3oool20000o`X0oooo1@3o000<0?ooo`03003j
VP3o0000o`000080oooo0`3o000=0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0oooo0P00
00040?ooo`030000O`3oool0oooo00l0oooo1@3o000D0?ooo`80o`0000<0001o0?ooo`3oool0503o
ool00`0007l0oooo0?ooo`090?ooo`80003o1`3oool20?l001@0oooo0P3o00000`0007l0oooo0?oo
o`080?ooo`030000O`3oool0oooo00@0oooo0P000?l20?l00004003jVP3oool0oooo0?ooo`80003o
2P3oool50?l000`0oooo00<00?ZJ0?l0003o00000`3oool30?l000`0oooo0P3o00000`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00P3oool200000100oooo
000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool04@3oool50?l00180oooo0P3o
00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00T0oooo0P000?l70?ooo`80o`00503o
ool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0103oool20000o`80o`0000<0
0?ZJ0?ooo`3oool03@3oool50?l000`0oooo00<00?ZJ0?l0003o0000103oool30?l000/0oooo0P3o
00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3o
ool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0
oooo01<0oooo103o000A0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`09
0?ooo`80003o1`3oool20?l001@0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0
oooo00@0oooo0P000?l20?l00003003jVP3oool0oooo00d0oooo1P3o000;0?ooo`80000000<0o`00
0?ooo`3oool00`3oool30?l000X0oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0
oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0oooo01D0oooo0`3o000@0?ooo`80o`0000<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`090?ooo`80003o1`3oool20?l001@0oooo0P3o00000`00
07l0oooo0?ooo`080?ooo`030000O`3oool0oooo00@0oooo0P000?l20?l00003003jVP3oool0oooo
00d0oooo0P3o0000103oool0001o0?l0003o000:0?ooo`@000001P3oool40?l000P0oooo0P3o0000
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool0
0`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo
01H0oooo103o000>0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`090?oo
o`80003o1`3oool20?l001@0oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo
00@0oooo0P000?l20?l00003003jVP3oool0oooo00d0oooo0P3o0000103oool0001o0?l0003o000:
0?ooo`@000001`3oool40?l000L0oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0
oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0oooo01L0oooo103o000=0?ooo`80o`0000<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`090?ooo`80003o1`3oool20?l00140oooo0`00nYX20?l0
00030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0103oool40?l00003003jVP3oool0oooo
00d0oooo0P3o00000`3oool0001o0?l000020?l000X0oooo0P0000000`0007l0oooo0?ooo`070?oo
o`<0o`001P3oool20?l000030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0
oooo00<0001o0?ooo`3oool06@3oool50?l000X0oooo0P3o00000`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00T0oooo0P000?l70?ooo`80o`003`3oool5003jVP80o`0000<0001o0?ooo`3o
ool0203oool0100007l0oooo0?ooo`3oool60?l000800?ZJ3`3oool20?l000030?ooo`0007l0oooo
00<0o`002@3oool20?l000030000O`3oool0oooo00P0oooo0`3o00050?ooo`80o`0000<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?oo
o`3oool03P3oool001/0oooo0P0000040?ooo`030000O`3oool0oooo01X0oooo1@3o00090?ooo`80
o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`090?ooo`<0003o1P3oool20?l00003
003jVP3oool0oooo00X0oooo1@00nYX01@3oool00?ZJ0?l0003o0000001o00X0oooo00<0001o0?oo
o`3oool01@3o000010000?l0oooo003jVP00nYX?0?ooo`80o`0000@0oooo0000O`3oool0oooo0`3o
00080?ooo`80o`0000<0001o0?ooo`3oool02@3oool50?l00080oooo0P3o00000`0007l0oooo0?oo
o`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00P3oool200000100oooo000K
0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool07@3oool40?l000L0oooo0P3o0000
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00X0oooo0P000?l60?ooo`80o`000P00nYX8
0?ooo`H00?ZJ0`3oool01000nYX0o`000?l0000007l:0?ooo`030000O`3oool0o`000080o`0000<0
oooo0000o`000?l00P3oool20?l000l0oooo0P3o00000`3oool0001o0?ooo`020?ooo`80o`00203o
ool20?l000030000O`3oool0oooo00X0oooo1@3o0000103oool0o`000?l0000007lF0?ooo`030000
O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3o
ool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo01h0oooo103o00060?ooo`80o`0000<0
001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0:0?ooo`<0003o1@3oool20?l000D00?ZJ0P3o
ool7003jVPD0oooo00@00?ZJ0?l0003o0000001o2P3oool0100007l0o`000?l0003o00020?ooo`80
003o0P3oool20?l000l0oooo0P3o00000`3oool0001o0?ooo`020?ooo`<0o`001`3oool20?l00003
0000O`3oool0oooo00d0oooo1@3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0oooo0200oooo103o00040?ooo`80o`0000<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`0:0?ooo`<0003o1@3oool20?l000030?ooo`00nYX00?ZJ00P00?ZJ
203oool01000nYX0o`000?l0000007l:0?ooo`<0o`000`3oool20000o`80oooo0P3o000?0?ooo`80
o`0000<0oooo0000O`3oool00`3oool30?l000H0oooo0P3o00000`0007l0oooo0?ooo`0>0?ooo`@0
o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0
oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo
0?ooo`0Q0?ooo`H0o`0000@0oooo0?l0003o0000001o5P3oool00`0007l0oooo0?ooo`0;0?ooo`80
003o1@3oool20?l000@0oooo1000nYX;0?ooo`04003jVP3o0000o`000000O`X0oooo0P3o00040?oo
o`80003o00<0oooo003jVP3o00000P3o000>0?ooo`80o`0000<0oooo0000O`3oool0103oool20?l0
00H0oooo0P3o00000`0007l0oooo0?ooo`0@0?ooo`80o`0000<0001o0?ooo`3oool0503oool00`00
07l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001/0
oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0S0?ooo`L0o`0000<0001o0?ooo`3o
ool0503oool00`0007l0oooo0?ooo`0;0?ooo`80003o1@3oool20?l001<0oooo00@00?ZJ0?l0003o
0000001o2@3oool30?l000@0oooo0P000?l00`3oool00?ZJ0?l000020?l000h0oooo0P3o00000`3o
ool0001o0?ooo`040?ooo`<0o`001@3oool20?l000030000O`3oool0oooo0180oooo00<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?oo
o`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0V0?ooo`@0
o`0000<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0;0?ooo`80003o1@3oool20?l001<0
oooo00@00?ZJ0?l0003o0000001o2@3oool20?l000D0oooo0P000?l00`3oool00?ZJ0?l000020?l0
00h0oooo0P3o00000`3oool0001o0?ooo`050?ooo`<0o`00103oool20?l000030000O`3oool0oooo
0180oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo
00<0oooo00<000000?ooo`3oool03P3oool001/0oooo0P0000040?ooo`030000O`3oool0oooo02L0
oooo0`3o00000`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00/0oooo0P000?l50?ooo`80
o`004`3oool01000nYX0o`000?l0000007l90?ooo`80o`001@3oool20000o`030?ooo`00nYX0o`00
0080o`003@3oool30?l000030?ooo`0007l0oooo00H0oooo103o00020?ooo`80o`0000<0001o0?oo
o`3oool04P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?oo
o`3oool00P3oool200000100oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3o
ool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00/0oooo0P000?l50?ooo`80
o`004`3oool01000nYX0o`000?l0003o00080?ooo`030?l000000000000000@0oooo0`000?l00`3o
ool00?ZJ0?l000030?l000`0oooo0P3o00000`0007l0oooo0000O`080?ooo`L0o`0000<0001o0?oo
o`3oool04P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?oo
o`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`03
0000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0;0?ooo`<0
003o103oool20?l00100oooo0P000?l20?ooo`03003jVP3o0000o`0000P0oooo100000030?ooo`80
003o0P3oool00`00nYX0o`000?l000020?l000`0oooo0P3o00000`0007l0oooo0000O`0:0?ooo`@0
o`000P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo
00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00`0oooo
0P000?l40?ooo`80o`00403oool20000o`80oooo00@00?ZJ0?l0003o0000003o1@3oool20?l000@0
00000`3oool20000o`80oooo00<00?ZJ0?l0003o00000P3o000<0?ooo`80o`0000<0001o0?ooo`00
07l0303oool20?l00080001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo
0?ooo`0<0?ooo`80003o103oool20?l00100oooo0P000?l20?ooo`04003jVP3o0000o`000000o`@0
oooo103o0002000000@0oooo0P000?l20?ooo`03003jVP3o0000o`0000<0o`002`3oool20?l00003
0000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000B0?ooo`D00000
103oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`0<0?ooo`80003o103oool20?l00100oooo0P000?l20?ooo`04003j
VP3o0000o`000000o`<0oooo0`3o00030?ooo`030000O`3oool0oooo0080oooo0P000?l20?ooo`04
003jVP3o0000o`000?ooo`80o`002`3oool20?l000030000O`3oool0001o00h0oooo0P0007lD0?oo
o`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?oo
o`030000003oool0oooo00h0oooo000C0?ooo`040000003oool0oooo000000@0oooo00<000000?oo
o`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool0303oool20000o`@0oooo0P3o000@0?ooo`80003o0P3oool01000nYX0o`000?l000000?l2
0?ooo`<0o`00103oool0100007l0oooo0?ooo`3oool30000o`80oooo00@00?ZJ0?l0003o0000oooo
0P3o000;0?ooo`80o`0000<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool0
3P3oool001@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000O`3o
ool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0<0?ooo`80003o103o
ool30?l000l0oooo0P000?l20?ooo`05003jVP3o0000o`000000o`3oool00`3o00050?ooo`80003o
0P3oool20000o`<0oooo00@00?ZJ0?l0003o0000oooo0`3o000:0?ooo`80o`0000<0001o0?ooo`00
07l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`03
0000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001D0oooo00<000000?ooo`3oool0
0`3oool3000000<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00`0oooo0P000?l50?ooo`80o`003`3oool20000o`80oooo00@00?ZJ0?l0003o0000
003o0`3o00000`3oool0003o0000o`020000o`030?ooo`000?l0003o0080oooo0P000?l30?ooo`03
003jVP3o0000o`000080oooo0`3o00090?ooo`80o`0000<0001o0?ooo`0007l03P3oool20000Oa@0
oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`040000O`3oool0oooo0?oo
o`<00000403oool00180oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo
00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo
00`0oooo0P000?l50?ooo`80o`003`3oool20000o`80oooo00@00?ZJ0?l0003o0000003o0P3o0002
0?ooo`@0003o0P00nYX00`000?l0oooo0?ooo`020000o`<0oooo00<00?ZJ0?l0003o00000`3oool2
0?l000T0oooo0P3o00000`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>
0?ooo`004P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool00`3oool0
0`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0303oool2
0000o`D0oooo0P3o000>0?ooo`<0003o0P3oool00`00nYX0o`000?l000030?l00080oooo10000?l3
003jVP80oooo0P000?l30?ooo`03003jVP3o0000o`0000<0oooo0`3o00080?ooo`80o`0000<0001o
0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`08
0?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001<0oooo0`0000050?oo
o`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo00`0oooo0`000?l40?ooo`80o`003P3oool40000o`030?ooo`00nYX0o`00
00<0o`000`3oool40000o`/00?ZJ0P3o00040?ooo`<0o`001`3oool20?l000030000O`3oool0001o
00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`00
07l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0
oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00d0
oooo0P000?l40?ooo`<0o`003@3oool40000o`030?ooo`00nYX0o`0000<0o`000`3oool40000o`/0
0?ZJ0P3o00050?ooo`<0o`001P3oool20?l000030000O`3oool0001o00h0oooo0P0007lD0?ooo`03
0000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`03
0000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0
:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00d0oooo0P000?l40?ooo`030000
O`3o0000o`0000d0oooo10000?l00`3oool00?ZJ0?l000020?l000040000o`3oool0oooo0?ooo`@0
003o0P00nYX00`000?l0oooo0000o`02003jVP<0oooo0`3o00060?ooo`<0o`001@3oool20?l00003
0000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000
003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00d0oooo0P000?l40?ooo`030000O`3o0000o`0000d0oooo10000?l00`3oool00?ZJ
0?l000020?l000040000o`3oool0oooo0?ooo`<0003o0`00nYX010000?l0oooo0000o`000?l40?oo
o`80o`0000<0001o0?ooo`3oool01@3oool90?l000030000O`3oool0001o00h0oooo0P0007lD0?oo
o`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?oo
o`030000003oool0oooo00h0oooo000K0?ooo`800000103oool00`0007l0oooo0?ooo`0Z0?ooo`03
0000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03@3oool20000o`@0oooo00@0001o0?l0003o
0000o`00303oool40000o`040?ooo`00nYX0o`000?l00080003o0P3oool40000o`800?ZJ0P000?l0
0`3oool0003o0000o`040?ooo`80o`0000<0001o0?ooo`3oool01P3oool80?l000030000O`3oool0
001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool0
0`0007l0oooo0?ooo`020?ooo`800000403oool001/0oooo00<000000?ooo`3oool00`3oool00`00
07l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03@3oool30000
o`<0oooo00@0001o0?ooo`3o0000o`00303oool40000o`030?ooo`00nYX00?ZJ00<0003o0P3oool2
0000o`80oooo0P00nYX20000o`030?ooo`000?l0003o00@0oooo0P3o00000`0007l0oooo0?ooo`0>
0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o
0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?oo
o`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?oo
o`030000O`3oool0oooo00h0oooo0P000?l30?ooo`030000O`3oool0o`000080o`002`3oool40000
o`030?ooo`00nYX00?ZJ00<0003o0P3oool20000o`80oooo0P00nYX50000o`@0oooo0P3o00000`00
07l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo
01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo
00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0
oooo0?ooo`0D0?ooo`030000O`3oool0oooo00h0oooo0P000?l30?ooo`030000O`3oool0oooo00<0
o`00103oool20000o`@0oooo10000?l00`3oool00?ZJ003jVP030000o`80oooo0P000?l20?ooo`80
0?ZJ1@000?l40?ooo`80o`0000<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`0>0?ooo`80
001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3o
ool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000
O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0>0?ooo`80003o
0`3oool0100007l0oooo0?ooo`3oool20?l000@0oooo0P000?l40?ooo`@0003o00@0oooo003jVP00
nYX00?ZJ0P000?l20?ooo`80003o1000nYX50000o`@0oooo0P3o00000`0007l0oooo0?ooo`0>0?oo
o`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`03
0000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00h0oooo0P000?l30?ooo`040000O`3oool0oooo0?ooo`<0o`000`3oool20000
o`@0oooo10000?l0103oool0003o003jVP00nYX20000o`80oooo1@00nYX20?l000@0003o103oool2
0?l000030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o
0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<00000
0?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?oo
o`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03P3oool20000o`<0oooo00<0001o0?oo
o`3oool00P3oool30?l000040?ooo`000?l0003o0000o`@0oooo0`000?l30?l000800?ZJ0P000?l0
0`3oool00?ZJ003jVP02003jVP040?ooo`000?l0o`000?l000@0003o103oool20?l000030000O`3o
ool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503o
ool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3o
ool001/0oooo0P0000040?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool0
0`0007l0oooo0?ooo`0>0?ooo`80003o0`3oool00`0007l0oooo0?ooo`030?ooo`<0o`000`000?l3
0?ooo`L0o`000P00nYX20000o`<00?ZJ00@0003o0?ooo`3oool0oooo0P3o00040000o`@0oooo0P3o
00000`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3o
ool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`020?ooo`800000403o
ool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0
oooo01@0oooo00<0001o0?ooo`3oool03P3oool20000o`80oooo0P0000060?ooo`l0o`000P00nYX0
10000?l00?ZJ003jVP00nYX20000o`<0oooo0`3o00030000o`@0oooo0P3o00000`0007l0oooo0?oo
o`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0
001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K
0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D
0?ooo`030000O`3oool0oooo00h0oooo0P000?l00`3oool0000000000002000000H0oooo203o0004
0000o`80o`001@00nYX00`3oool0003o0000o`030?ooo`<0o`000P000?l50?ooo`80o`0000<0001o
0?ooo`3oool03P3oool00`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D
0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>
0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`0>0?ooo`<0003o100000070?ooo`<0003o0`3oool50000
o`80o`001000nYX40000o`<0oooo0`3o00020000o`D0oooo0P3o00000`0007l0oooo0?ooo`0>0?oo
o`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`03
0000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00l0oooo0P000?l00`3oool00000000000080?ooo`@0003o0P3oool20000o`03
0?ooo`000?l0003o0080o`000`00nYX40000o`@0oooo103o00000`000?l0oooo0?ooo`030?ooo`80
o`0000<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0
oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000
oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0?0?ooo`80003o0P3oool00`0007l0oooo
0?ooo`060?ooo`@0003o0P3oool20000o`030?ooo`000?l0003o00<0o`000P00nYX40000o`@0oooo
103o00000`000?l0oooo0?ooo`030?ooo`80o`0000<0001o0?ooo`3oool03P3oool00`0007l0oooo
0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo
00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?oo
o`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?oo
o`0?0?ooo`80003o0P3oool0100007l0oooo0?ooo`3oool20000o`<0oooo10000?l20?ooo`80003o
0P3oool20000o`80o`0000<00?ZJ0?ooo`000?l00`000?l30?ooo`D0o`0000<0003o0?ooo`3oool0
0`3oool20?l000030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000Oa@0oooo
00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo
00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?oo
o`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool03`3oool20000o`80oooo00@0
001o0?ooo`3oool0oooo0`000?l20?ooo`@0003o0P3oool20000o`80oooo0P000?l20?l000030000
O`3oool0003o00<0003o0`3oool20?l000040000O`3o0000o`000?l000D0oooo0P3o00000`0007l0
oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0
oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0
oooo000K0?ooo`800000103oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo
00<0001o0?ooo`3oool03`3oool20000o`80oooo00@0001o0?ooo`3oool0oooo0`000?l20?ooo`@0
003o0P3oool20000o`80oooo0P000?l20?l000030000O`3oool0003o00<0003o0`3oool20?l00003
0000O`3oool0o`000080o`00103oool20?l000030000O`3oool0oooo00h0oooo00<0001o0?ooo`00
07l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`03
0000O`3oool0oooo0080oooo0P00000@0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000
O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0?0?ooo`80003o
0P3oool00`0007l0oooo0?ooo`040000o`030?ooo`000?l0003o00<0003o0P3oool20000o`80oooo
0P000?l20?l000030000O`3oool0oooo00<0003o0`3oool20?l000030000O`3oool0003o00P0o`00
00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo
0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0
001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0?0?ooo`80003o0P3oool00`0007l0oooo0?oo
o`040000o`040?ooo`000?l0003o0?ooo`80003o0P3oool20000o`80oooo0P000?l20?l000030000
O`3oool0oooo00<0003o0`3oool20?l000040000O`3oool0003o0000o`L0o`0000<0001o0?ooo`3o
ool03P3oool00`0007l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`03
0000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`00
6`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`0?0?ooo`80003o0P3oool00`0007l0oooo0?ooo`040000o`040?oo
o`000?l0003o0?ooo`80003o0P3oool20000o`80oooo0P000?l20?l000030000O`3oool0oooo0080
003o103oool20?l000030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0
oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`00503oool3000000@0oooo
00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo
00<0001o0?ooo`3oool03`3oool20000o`80oooo00<0001o0?ooo`3oool010000?l0103oool0003o
0000o`3oool20000o`80oooo0P000?l20?ooo`80003o00<0o`000000000000000P3oool20000o`@0
oooo0P3o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`00
07l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`03
0000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool001D0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0
503oool00`0007l0oooo0?ooo`0?0?ooo`80003o00<0oooo0000o`000?l00P3oool40000o`040?oo
o`000?l0003o0?ooo`80003o0P3oool20000o`80oooo0P000?l4000000030?ooo`000?l0003o0080
oooo103o00000`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`00
07l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`03
0000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool00180oooo1@0000040?ooo`030000
003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000
O`3oool0oooo00l0oooo0P000?l0103oool0003o0000o`3oool50000o`040?ooo`000?l0003o0?oo
o`<0003o00<0oooo0000o`000?l0103oool400000080oooo1`3o00000`0007l0oooo0?ooo`080?oo
o`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?oo
o`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?oo
o`3oool03P3oool00180oooo00@000000?ooo`3oool000001@3oool3000000<0oooo00<0001o0?oo
o`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00l0oooo0P000?l0103o
ool0003o0000o`3oool20000o`030?ooo`000?l0003o00<0003o0P3oool50000o`D0oooo0P000000
0`3oool0o`000?l000040?l000<0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>
0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o
0?ooo`3oool0203oool0100007l0oooo0?ooo`3oool300000100oooo000C0?ooo`030000003oool0
000000D0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0
oooo01@0oooo00<0001o0?ooo`3oool03`3oool80000o`80oooo10000?l20?ooo`@0003o1P3oool6
0?l000H0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0
001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool0
0`0007l0oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000D0?ooo`8000001@3oool00`00
0000oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`00
07l0oooo0?ooo`0@0?ooo`L0003o0P3oool40000o`80oooo10000?l60?ooo`@0o`00203oool00`00
07l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000
Oa@0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo
00<0oooo00<000000?ooo`3oool03P3oool001D0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`030?ooo`030000O`3oool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0
oooo0?ooo`0@0?ooo`H0003o0`3oool40000o`80oooo10000?l60?ooo`<0o`002@3oool00`0007l0
oooo0?ooo`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000Oa@0
oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0
oooo00<000000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo
0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0403oool30000o`030000
O`000?l0003o00<0oooo10000?l30?ooo`<0003o1P3oool20?l000X0oooo00<0001o0?ooo`3oool0
203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000
O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000
003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3o
ool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo0100oooo0`000?l00`0007l0oooo0?oo
o`030?ooo`@0003o0`3oool20000o`P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?oo
o`080?ooo`030000O`3oool0oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0
001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<0
00000?ooo`3oool03P3oool001/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z
0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0403oool30000o`030000O`3oool0
oooo00<0oooo10000?l=0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool0
0`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0
oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003oool0
oooo00h0oooo000K0?ooo`800000103oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo
01@0oooo00<0001o0?ooo`3oool0403oool30000o`030000O`3oool0oooo00<0oooo10000?l=0?oo
o`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?oo
o`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?oo
o`3oool0203oool00`0007l0oooo0?ooo`020?ooo`800000403oool001/0oooo00<000000?ooo`3o
ool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3o
ool0403oool20000o`030?ooo`0007l0oooo00@0oooo0`000?l>0?ooo`030000O`3oool0oooo00P0
oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0
oooo0P0007lD0?ooo`030000O`3oool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0
oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo
00<0001o0?ooo`3oool0:P3oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo0100oooo
0P000?l00`3oool0001o0?ooo`040?ooo`<0003o3P3oool00`0007l0oooo0?ooo`080?ooo`030000
O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`0007l0oooo0000O`0>0?ooo`80001o
503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0
0`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000O`3o
ool0oooo02X0oooo00<0001o0?ooo`3oool0503oool00`0007l0oooo0?ooo`0C0?ooo`030000O`3o
ool0oooo00<0oooo0`000?l>0?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool0203o
ool00`0007l0oooo0?ooo`0>0?ooo`030000O`3oool0001o00h0oooo0P0007lD0?ooo`030000O`3o
ool0oooo01@0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`030?ooo`030000003o
ool0oooo00h0oooo000K0?ooo`030000003oool0oooo00<0oooo00<0001o0?ooo`3oool0:P3oool0
0`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo01<0oooo00<0001o0?ooo`3oool0103oool2
0000o`h0oooo00<0001o0?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0
oooo00h0oooo00<0001o0?ooo`0007l03P3oool20000Oa@0oooo00<0001o0?ooo`3oool0503oool0
0`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00<0oooo00<000000?ooo`3oool03P3oool0
01/0oooo00<000000?ooo`3oool00`3oool00`0007l0oooo0?ooo`0Z0?ooo`030000O`3oool0oooo
01@0oooo00<0001o0?ooo`3oool04`3oool00`0007l0oooo0?ooo`040?ooo`80003o3P3oool00`00
07l0oooo0?ooo`080?ooo`030000O`3oool0oooo00P0oooo00<0001o0?ooo`3oool03P3oool00`00
07l0oooo0000O`0>0?ooo`80001o503oool00`0007l0oooo0?ooo`0D0?ooo`030000O`3oool0oooo
00P0oooo00<0001o0?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`006`3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo02X0oooo00<0001o0?ooo`3oool0203oool00`000000
oooo0?ooo`090?ooo`030000O`3oool0oooo01<0oooo00<0001o0?ooo`3oool0103oool20000o`h0
oooo00<000000?ooo`3oool0203oool00`0007l0oooo0?ooo`080?ooo`030000O`3oool0oooo00h0
oooo00<0001o0?ooo`0007l03P3oool00`000000001o0?ooo`0C0?ooo`030000O`3oool0oooo01@0
oooo00<0001o0?ooo`3oool0203oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00h0
oooo000K0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`080?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`080?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`030?ooo`030000O`3oool0001o0080oooo00<000000?ooo`3oool02@3oool00`000000001o
0?ooo`080?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`006`3oooo^00000100oooo003o0?oooaX0oooo003o0?oooaX0oooo003o0?oooaX0
oooo001G0?ooo`030000003oool0oooo02`0oooo0`00002@0?ooo`00F03oool00`000000oooo0?oo
o`0/0?ooo`030000003oool0oooo08l0oooo00140?ooo`<000000P3oool3000000030?ooo`000000
000000<000001P3oool00`000000oooo0?ooo`060?ooo`050000003oool000000?ooo`0000002@3o
ool4000000T0oooo0`0000080?ooo`<000000`3oool4000000050?ooo`00000000000000003oool0
0P000000103oool000000000000000020?ooo`D000002@3oool2000000030?ooo`00000000000080
000000<0oooo0000000000001@0000030?ooo`8000002@3oool4000000P0oooo0`0000040?ooo`80
0000>`3oool004<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool03P3oool01@000000oooo0000003oool0000001L0oooo00<00000
0?ooo`3oool01`3oool01P000000oooo0?ooo`000000oooo00000080oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0000000L0oooo00<000000?ooo`3oool0203oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3oool0
10000000oooo0?ooo`00000E0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000
>P3oool004<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080
oooo00<000000?ooo`3oool03P3oool01@000000oooo0000003oool0000000T0oooo100000070?oo
o`D00000203oool010000000oooo0?ooo`0000020?ooo`<000000`3oool01@000000oooo0?ooo`00
0000oooo00D000000`3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00T0
oooo100000090?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000>P3oool004<0
oooo00<000000?ooo`0000000`0000000`3oool000000000000200000080oooo0`00000>0?ooo`05
0000003oool000000?ooo`000000503oool010000000oooo0?ooo`0000090?ooo`060000003oool0
oooo0000003oool000000P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`00
00000`3oool01@000000oooo0?ooo`3oool0000000X0oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000030?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool05P3o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000003X0oooo00130?ooo`030000003o
ool0oooo00@0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0>0?ooo`800000
00<0oooo0000003oool05@3oool00`000000oooo000000080?ooo`@000000`3oool2000000<0oooo
100000030?ooo`<00000103oool00`000000oooo0?ooo`070?ooo`80000000@0oooo000000000000
oooo100000020?ooo`<000000`3oool4000001H0oooo00<000000?ooo`3oool00P3oool010000000
oooo0?ooo`00000j0?ooo`00@`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000X0?ooo`8000008P3oool00`000000oooo0?oo
o`0J0?ooo`030000003oool0oooo01D0oooo0P0000040?ooo`040000003oool0oooo000003X0oooo
00140?ooo`<000000P3oool3000000030?ooo`000000000000D00000:@3oool00`000000oooo0?oo
o`0N0?ooo`<000005`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01H0oooo00<0
00000?ooo`3oool00`3oool2000003/0oooo003o0?oooaX0oooo003o0?oooaX0oooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-29.8199, -5.81887, \
0.889138, 0.0685073}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\

SCALING={1,0.1,1,1};
THETA0=Theta/SCALING;
F0=IdentityMatrix[THETA0//Length];
MAXSTEP=.5;
FISHER=True;
STEPREDUCE=2;
FDIGITS=16

SetDirectory[\"/Mathematica \
2.2.2/Hermann.Notebooks/UKF.20.3.2006/Panel/Simulation\"];
filename=\"GHF4.n10\";
system={f,Omega,h,R,mue,sigma,dt,m=4};
misc={miss,1};
LikN=GHF;
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(16\)], "Output"],

Cell[BoxData[
    \(SetDirectory::"cdir" \(\(:\)\(\ \)\) 
      "Cannot set current directory to \!\(\"/Mathematica \
2.2.2/Hermann.Notebooks/UKF.20.3.2006/Panel/Simulation\"\)."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "EST={};\nDo[\n\nSeedRandom[99999*m];\n\
Print[\"**********************************************************************\
***\"];\nPrint[\"Replikation m = \",m];\n\
Print[\"**********************************************************************\
***\"];\n\nn=10;\nT = 200;\ndt = .1;\nk = 1; p = 1; q = 1;\nX = \
Shape[0,{n,T+1,q}];\nTheta = {-1., 0.1, 2.,1}//N;\nY0 = \
RandomGauss[_,Theta,{mue,sigma},n];\nProzess = UniC;\n{zt,yt} = \
MapThread[NonLinStateSpace[h,{R,konstant},f,g,#1,#2,T,dt,Theta,Prozess,\
EulerStep]&,{Y0,X}]//Transpose;\nmiss = -9;\ntime = \
{0,4,6,8,10,11,12,13.5,13.7,15,15.1,17,19,20};\nsel = time/dt + 1;\nZM = \
Shape[miss,{n,T+1,k}];\nMap[(ZM[[All,#]] = zt[[All,#]])&,sel];\n\
data={ZM,X}//Transpose;\n\n{THETA,COV,LIKI,psii,scoreii,k,ReturnCode}=\n\n\
BFGS[data,\n\t {THETA0,F0},\n\t {system,{Lik,LikN,Score,",
  StyleBox["FisherInformation",
    FontColor->RGBColor[1, 0, 0]],
  "}},\n\t \
{misc,KMAX=50,{EPS1=10.^-4,EPS2=10.^-4},OPTION=0,PRINT={1,1,1,1,1,1,1,1}}];\n\
\n\n,{m,1,1}] \n"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Replikation m = "\[InvisibleSpace]1\),
      SequenceForm[ "Replikation m = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print"],

Cell[BoxData[
    \({201, 201, 201, 201, 201, 201, 201, 201, 201, 201}\)], "Print"],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    \(GHF\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "50", "0.0001`", "0.0001`", "1", "1", "10", "200", "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "0.5`", "1.`*^-10", "1.`*^-6", "2", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1000.`", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("    SCALING"\)], "Print"],

Cell[BoxData[
    TagBox[\({{1, 0.1`, 1, 1}}\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{\(-1.`\), 1.`, 
          2.`, 1.`}\),
      SequenceForm[ "STARTWERT THETA0 = ", {-1.0, 1.0, 2.0, 1.0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{32.563377380371094`, 12.79312515258789`, 37.26086616516113`, 
        8.682975769042969`}, \(-191.5026283950059`\)}\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -189.167231817810900\"\>",
            -189.16723181781086,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -191.502628395005900\"\>",
            -191.5026283950059,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -189.16723181781086, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -191.5026283950059, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -189.167231817810900\"\>",
            -189.16723181781086,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -189.16723181781086, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -191.502628395005900\"\>",
            -191.5026283950059,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -191.5026283950059, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.335396577195041\"\>",
            2.3353965771950413,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.3353965771950413, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.7815\"\>",
                -0.78151757640286812,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0000\"\>",
                -1.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2185\"\>",
                0.21848242359713188,
                AutoDelete->True], 
              InterpretationBox["\<\" 32.5630\"\>",
                32.563377380371094,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 1.0858\"\>",
                1.0858348615399973,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0858\"\>",
                0.085834861539997212,
                AutoDelete->True], 
              InterpretationBox["\<\" 12.7930\"\>",
                12.793125152587891,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.2500\"\>",
                2.25,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0000\"\>",
                2.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2500\"\>",
                0.25,
                AutoDelete->True], 
              InterpretationBox["\<\" 37.2610\"\>",
                37.260866165161133,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0583\"\>",
                1.0582580107676183,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1.0,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0583\"\>",
                0.058258010767618315,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6830\"\>",
                8.6829757690429688,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.618020030170675`*^-8, 
          3.3527612686157227`*^-8, 1.576927320312885`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.6180200301706751*^-08, 
        3.3527612686157227*^-08, 1.5769273203128849*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]8.952975722110029`*^-7\),
      SequenceForm[ "NOISE  ", 8.9529757221100291*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.04036181555442019`\
\[InvisibleSpace]"  "\[InvisibleSpace]8.264723135372362`\),
      SequenceForm[ 
      "*BFGSUP ", 0.040361815554420193, "  ", 8.2647231353723623],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.13099742521585891`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.13099742521585891, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.320416743569500\"\>",
            -184.32041674356944,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -184.32041674356944, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -189.167231817810900\"\>",
            -189.16723181781086,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -189.16723181781086, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     4.846815074241420\"\>",
            4.8468150742414196,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 4.8468150742414196, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.8939\"\>",
                -0.89392878602220782,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.7815\"\>",
                -0.78151757640286812,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1124\"\>",
                -0.1124112096193397,
                AutoDelete->True], 
              InterpretationBox["\<\"-22.4560\"\>",
                -22.455730438232422,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.6966\"\>",
                0.6966475969006114,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0858\"\>",
                1.0858348615399973,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3892\"\>",
                -0.38918726463938597,
                AutoDelete->True], 
              InterpretationBox["\<\"-22.8220\"\>",
                -22.821536847877237,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.7500\"\>",
                2.75,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2500\"\>",
                2.25,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5000\"\>",
                0.5,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1885\"\>",
                -0.1885316636827257,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.2478\"\>",
                1.2477731896626889,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0583\"\>",
                1.0582580107676183,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1895\"\>",
                0.18951517889507058,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.9180\"\>",
                2.9180113442990292,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 122.8\"\>",
                  122.78482867583607,
                  AutoDelete->True], 
                InterpretationBox["\<\" 78.93\"\>",
                  78.93345826074767,
                  AutoDelete->True], 
                InterpretationBox["\<\" 82.71\"\>",
                  82.711370601967502,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.7\"\>",
                  12.696893485128578,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 78.93\"\>",
                  78.93345826074767,
                  AutoDelete->True], 
                InterpretationBox["\<\" 52.13\"\>",
                  52.134202958815564,
                  AutoDelete->True], 
                InterpretationBox["\<\" 53.66\"\>",
                  53.655126134231324,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.246\"\>",
                  8.2456490429133886,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 82.71\"\>",
                  82.711370601967502,
                  AutoDelete->True], 
                InterpretationBox["\<\" 53.66\"\>",
                  53.655126134231317,
                  AutoDelete->True], 
                InterpretationBox["\<\" 57.09\"\>",
                  57.089181614674914,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.594\"\>",
                  8.5935202348539388,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 12.7\"\>",
                  12.69689348512858,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.246\"\>",
                  8.2456490429133886,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.594\"\>",
                  8.5935202348539406,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.313\"\>",
                  2.3133670299288198,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          4.0978193283081055`*^-8, 1.859326943252517`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        4.0978193283081055*^-08, 1.8593269432525171*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.2333602131970004`*^-7\),
      SequenceForm[ "NOISE  ", 4.2333602131970004*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.06753094250598014`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.4891528044318667`\),
      SequenceForm[ 
      "*BFGSUP ", 0.067530942505980143, "  ", 2.4891528044318667],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.08337205672983086`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.083372056729830862, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.087401216689800\"\>",
            -184.08740121668976,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.320416743569500\"\>",
            -184.32041674356944,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -184.08740121668976, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -184.32041674356944, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.087401216689800\"\>",
            -184.08740121668976,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -184.08740121668976, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.320416743569500\"\>",
            -184.32041674356944,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -184.32041674356944, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.233015526879683\"\>",
            0.23301552687968297,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23301552687968297, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.8301\"\>",
                -0.83011409724228102,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.8939\"\>",
                -0.89392878602220782,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0638\"\>",
                0.063814688779926784,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.5258\"\>",
                -2.5258159637451172,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.6063\"\>",
                0.6063098848444255,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6966\"\>",
                0.6966475969006114,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0903\"\>",
                -0.090337712056185959,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3475\"\>",
                -0.34745407104492188,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.7625\"\>",
                2.7625335727389442,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.7500\"\>",
                2.75,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0125\"\>",
                0.012533572738944308,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.5881\"\>",
                -5.5880626331676142,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.9978\"\>",
                0.99777318966268891,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.2478\"\>",
                1.2477731896626889,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2500\"\>",
                -0.24999999999999994,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.9986\"\>",
                -2.9986051045042856,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 148.2\"\>",
                  148.16916627655306,
                  AutoDelete->True], 
                InterpretationBox["\<\" 107.7\"\>",
                  107.71851378372386,
                  AutoDelete->True], 
                InterpretationBox["\<\" 75.43\"\>",
                  75.432136090834618,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.921\"\>",
                  4.9208006739956867,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 107.7\"\>",
                  107.71851378372386,
                  AutoDelete->True], 
                InterpretationBox["\<\" 84.76\"\>",
                  84.756708293666449,
                  AutoDelete->True], 
                InterpretationBox["\<\" 45.45\"\>",
                  45.448000942188258,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5439\"\>",
                  -0.54393191643609917,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 75.43\"\>",
                  75.432136090834618,
                  AutoDelete->True], 
                InterpretationBox["\<\" 45.45\"\>",
                  45.448000942188258,
                  AutoDelete->True], 
                InterpretationBox["\<\" 59.06\"\>",
                  59.057940397244678,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.75\"\>",
                  10.752498110722083,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 4.921\"\>",
                  4.9208006739956884,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5439\"\>",
                  -0.54393191643609917,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.75\"\>",
                  10.752498110722085,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.653\"\>",
                  4.6530793994195578,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          4.1164958070798877`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        4.1164958070798877*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.851253495549992`*^-7\),
      SequenceForm[ "NOISE  ", 1.8512534955499921*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.425820038664527`\
\[InvisibleSpace]"  "\[InvisibleSpace]8.196978726002241`\),
      SequenceForm[ "*BFGSUP ", 1.425820038664527, "  ", 8.1969787260022411],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.05866072453231292`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.05866072453231292, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.779246931005600\"\>",
            -183.77924693100562,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.087401216689800\"\>",
            -184.08740121668976,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -183.77924693100562, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -184.08740121668976, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.779246931005600\"\>",
            -183.77924693100562,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.77924693100562, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -184.087401216689800\"\>",
            -184.08740121668976,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -184.08740121668976, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.308154285684140\"\>",
            0.3081542856841395,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.3081542856841395, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.9228\"\>",
                -0.92278436399064634,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.8301\"\>",
                -0.83011409724228102,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0927\"\>",
                -0.092670266748365288,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.1082\"\>",
                2.1082477569580078,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.7124\"\>",
                0.71239841544042393,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6063\"\>",
                0.6063098848444255,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1061\"\>",
                0.10608853059599838,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.8355\"\>",
                6.8354892730712891,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.8026\"\>",
                2.8025644527623563,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.7625\"\>",
                2.7625335727389442,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0400\"\>",
                0.040030880023412305,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.9090\"\>",
                -3.9089842886271651,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.7478\"\>",
                0.74777318966268891,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9978\"\>",
                0.99777318966268891,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2500\"\>",
                -0.24999999999999994,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.5217\"\>",
                -1.5216999053955078,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 176.2\"\>",
                  176.2133836742085,
                  AutoDelete->True], 
                InterpretationBox["\<\" 154.8\"\>",
                  154.82450141595456,
                  AutoDelete->True], 
                InterpretationBox["\<\" 80.83\"\>",
                  80.830340326392445,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.62\"\>",
                  11.62267072227192,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 154.8\"\>",
                  154.82450141595456,
                  AutoDelete->True], 
                InterpretationBox["\<\" 158.3\"\>",
                  158.27271019838395,
                  AutoDelete->True], 
                InterpretationBox["\<\" 61.86\"\>",
                  61.860870311285552,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.16\"\>",
                  14.161455659879223,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 80.83\"\>",
                  80.830340326392445,
                  AutoDelete->True], 
                InterpretationBox["\<\" 61.86\"\>",
                  61.860870311285552,
                  AutoDelete->True], 
                InterpretationBox["\<\" 50.48\"\>",
                  50.475963033806025,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.526\"\>",
                  7.5260640838849762,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 11.62\"\>",
                  11.62267072227192,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.16\"\>",
                  14.161455659879222,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.526\"\>",
                  7.5260640838849788,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.134\"\>",
                  4.1344691279073693,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          4.176146466675932`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        4.1761464666759317*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.5347253905294388`*^-7\),
      SequenceForm[ "NOISE  ", 1.5347253905294388*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.085254351225916`\
\[InvisibleSpace]"  "\[InvisibleSpace]6.575032844148646`\),
      SequenceForm[ "*BFGSUP ", 1.0852543512259161, "  ", 6.5750328441486463],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.05282284508807743`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.052822845088077428, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.367064954909100\"\>",
            -183.3670649549091,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.3670649549091, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.779246931005600\"\>",
            -183.77924693100562,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.77924693100562, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.412181976096520\"\>",
            0.41218197609651952,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.41218197609651952, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.6699\"\>",
                -0.66988507795057139,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9228\"\>",
                -0.92278436399064634,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2529\"\>",
                0.252899286040075,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.8624\"\>",
                -1.8623924255371094,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.6344\"\>",
                0.63442910470910319,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7124\"\>",
                0.71239841544042393,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0780\"\>",
                -0.077969310731320754,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0016\"\>",
                -0.0015964508056640625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3431\"\>",
                2.3430728348581669,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8026\"\>",
                2.8025644527623563,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.4595\"\>",
                -0.45949161790418946,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.4639\"\>",
                -3.4638784779674103,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.1101\"\>",
                1.1100933848813503,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7478\"\>",
                0.74777318966268891,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.3623\"\>",
                0.36232019521866143,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8058\"\>",
                0.80583953857421875,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 192.1\"\>",
                  192.13360843883254,
                  AutoDelete->True], 
                InterpretationBox["\<\" 180.4\"\>",
                  180.42866744617854,
                  AutoDelete->True], 
                InterpretationBox["\<\" 81.12\"\>",
                  81.118508613315953,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.452\"\>",
                  2.4517782595568818,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 180.4\"\>",
                  180.42866744617854,
                  AutoDelete->True], 
                InterpretationBox["\<\" 196.5\"\>",
                  196.49543384123371,
                  AutoDelete->True], 
                InterpretationBox["\<\" 65.71\"\>",
                  65.711264967005661,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3243\"\>",
                  -0.32426742418342336,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 81.12\"\>",
                  81.118508613315953,
                  AutoDelete->True], 
                InterpretationBox["\<\" 65.71\"\>",
                  65.711264967005661,
                  AutoDelete->True], 
                InterpretationBox["\<\" 46.6\"\>",
                  46.600375071420828,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.058\"\>",
                  7.0579901868727823,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 2.452\"\>",
                  2.4517782595568818,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.3243\"\>",
                  -0.32426742418342691,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.058\"\>",
                  7.057990186872785,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.394\"\>",
                  9.3938760098964202,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.4914506001147134`*^-8, 1.6541680468340968`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4914506001147134*^-08, 1.6541680468340968*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.1169762841110974`*^-7\),
      SequenceForm[ "NOISE  ", 1.1169762841110974*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.48242125233010996`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.707853437749881`\),
      SequenceForm[ 
      "*BFGSUP ", 0.48242125233010996, "  ", 0.70785343774988096],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.021988804135507016`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.021988804135507016, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.252015868521000\"\>",
            -183.25201586852094,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.25201586852094, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.367064954909100\"\>",
            -183.3670649549091,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.3670649549091, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.115049086388154\"\>",
            0.11504908638815436,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.11504908638815436, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.7231\"\>",
                -0.72311421884356264,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6699\"\>",
                -0.66988507795057139,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0532\"\>",
                -0.053229140892991265,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.2772\"\>",
                -2.2772426605224609,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.6277\"\>",
                0.62770222558116728,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6344\"\>",
                0.63442910470910319,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0067\"\>",
                -0.0067268791279358892,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.0320\"\>",
                -4.0320224761962891,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.4671\"\>",
                2.4670655294197235,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3431\"\>",
                2.3430728348581669,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1240\"\>",
                0.12399269456155659,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6911\"\>",
                0.69110055430032946,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0171\"\>",
                1.0170699301121882,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1101\"\>",
                1.1100933848813503,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0930\"\>",
                -0.093023454769162142,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2237\"\>",
                -0.22372863721039701,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 189.8\"\>",
                  189.76143990739536,
                  AutoDelete->True], 
                InterpretationBox["\<\" 181.2\"\>",
                  181.23318236189249,
                  AutoDelete->True], 
                InterpretationBox["\<\" 75.72\"\>",
                  75.720527933062854,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.72\"\>",
                  3.7201673579855337,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 181.2\"\>",
                  181.23318236189249,
                  AutoDelete->True], 
                InterpretationBox["\<\" 204.3\"\>",
                  204.33204396272768,
                  AutoDelete->True], 
                InterpretationBox["\<\" 57.63\"\>",
                  57.628562395151697,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.678\"\>",
                  1.6784976599685977,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 75.72\"\>",
                  75.720527933062854,
                  AutoDelete->True], 
                InterpretationBox["\<\" 57.63\"\>",
                  57.628562395151697,
                  AutoDelete->True], 
                InterpretationBox["\<\" 46.44\"\>",
                  46.435676584880561,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.97\"\>",
                  6.9701247654946705,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 3.72\"\>",
                  3.7201673579855337,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.678\"\>",
                  1.6784976599685941,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.97\"\>",
                  6.9701247654946732,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.446\"\>",
                  9.4455836667845414,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.6762141129668407`*^-8, 1.5155522974017086`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.6762141129668407*^-08, 1.5155522974017086*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.515011288363736`*^-8\),
      SequenceForm[ "NOISE  ", 6.5150112883637364*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3.632811626416834`\
\[InvisibleSpace]"  "\[InvisibleSpace]3.9239995225689093`\),
      SequenceForm[ "*BFGSUP ", 3.6328116264168342, "  ", 3.9239995225689093],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.004579033121103266`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.004579033121103266, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.245495319741700\"\>",
            -183.24549531974174,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.24549531974174, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.252015868521000\"\>",
            -183.25201586852094,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.25201586852094, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.006520548779207\"\>",
            0.0065205487792070471,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0065205487792070471, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.6970\"\>",
                -0.69696094893960259,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.7231\"\>",
                -0.72311421884356264,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0262\"\>",
                0.026153269903960101,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1196\"\>",
                -0.11959075927734375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.6110\"\>",
                0.6109998731490589,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6277\"\>",
                0.62770222558116728,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0167\"\>",
                -0.016702352432108384,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1677\"\>",
                -0.16773796081542969,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.4392\"\>",
                2.4392159833041034,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.4671\"\>",
                2.4670655294197235,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0278\"\>",
                -0.02784954611562028,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.3401\"\>",
                -0.34012758889637867,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0145\"\>",
                1.0145259226187788,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0171\"\>",
                1.0170699301121882,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0025\"\>",
                -0.0025440074934092718,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1532\"\>",
                -0.15321313838760303,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 186.3\"\>",
                  186.32464472590325,
                  AutoDelete->True], 
                InterpretationBox["\<\" 175.5\"\>",
                  175.49302343802961,
                  AutoDelete->True], 
                InterpretationBox["\<\" 73.81\"\>",
                  73.813012955493221,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.274\"\>",
                  2.2736754876860479,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 175.5\"\>",
                  175.49302343802961,
                  AutoDelete->True], 
                InterpretationBox["\<\" 194.8\"\>",
                  194.78644566972193,
                  AutoDelete->True], 
                InterpretationBox["\<\" 54.09\"\>",
                  54.086311243892979,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.8713\"\>",
                  -0.87134756385194567,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 73.81\"\>",
                  73.813012955493221,
                  AutoDelete->True], 
                InterpretationBox["\<\" 54.09\"\>",
                  54.086311243892972,
                  AutoDelete->True], 
                InterpretationBox["\<\" 48.42\"\>",
                  48.424742282987992,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.313\"\>",
                  7.3126803670131775,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 2.274\"\>",
                  2.2736754876860479,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.8713\"\>",
                  -0.87134756385194923,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.313\"\>",
                  7.3126803670131801,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.267\"\>",
                  9.2672337422519035,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.634715055382406`*^-8, 1.5117614308279437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.6347150553824058*^-08, 1.5117614308279437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]7.3999278051617404`*^-9\),
      SequenceForm[ "NOISE  ", 7.3999278051617404*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]166.68901358602992`\
\[InvisibleSpace]"  "\[InvisibleSpace]104.86463390880671`\),
      SequenceForm[ "*BFGSUP ", 166.68901358602992, "  ", 104.86463390880671],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0008538990795763458`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00085389907957634582, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.240945661774600\"\>",
            -183.24094566177462,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.24094566177462, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.245495319741700\"\>",
            -183.24549531974174,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.24549531974174, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.004549657967118\"\>",
            0.004549657967118037,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.004549657967118037, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.6575\"\>",
                -0.65747793344740191,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6970\"\>",
                -0.69696094893960259,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0395\"\>",
                0.039483015492200721,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1565\"\>",
                0.15647315979003906,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.5844\"\>",
                0.58443603860441284,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6110\"\>",
                0.6109998731490589,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0266\"\>",
                -0.026563834544646052,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0223\"\>",
                -0.022275924682617188,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.4050\"\>",
                2.4050443872476324,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.4392\"\>",
                2.4392159833041034,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0342\"\>",
                -0.034171596056470861,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0312\"\>",
                0.031186572260574186,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0265\"\>",
                1.026521787515178,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0145\"\>",
                1.0145259226187788,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0120\"\>",
                0.011995864896399241,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0232\"\>",
                0.023154564351674789,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 197.5\"\>",
                  197.52846032859014,
                  AutoDelete->True], 
                InterpretationBox["\<\" 180.1\"\>",
                  180.08314898609672,
                  AutoDelete->True], 
                InterpretationBox["\<\" 86.63\"\>",
                  86.6342246708777,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.468\"\>",
                  8.4681350971652556,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 180.1\"\>",
                  180.08314898609672,
                  AutoDelete->True], 
                InterpretationBox["\<\" 195.4\"\>",
                  195.3629787015754,
                  AutoDelete->True], 
                InterpretationBox["\<\" 57.11\"\>",
                  57.106767825258032,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.71\"\>",
                  0.71004122519218349,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 86.63\"\>",
                  86.6342246708777,
                  AutoDelete->True], 
                InterpretationBox["\<\" 57.11\"\>",
                  57.106767825258025,
                  AutoDelete->True], 
                InterpretationBox["\<\" 59.28\"\>",
                  59.275406236319597,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.76\"\>",
                  12.76407400619107,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 8.468\"\>",
                  8.4681350971652538,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.71\"\>",
                  0.71004122519217994,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.76\"\>",
                  12.76407400619107,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.99\"\>",
                  11.990569664032254,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.5837954092735534`*^-8, 1.52963666247603`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.5837954092735534*^-08, 1.52963666247603*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]7.143796665332047`*^-9\),
      SequenceForm[ "NOISE  ", 7.1437966653320473*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]355.5100036904238`\
\[InvisibleSpace]"  "\[InvisibleSpace]167.17291513155888`\),
      SequenceForm[ "*BFGSUP ", 355.51000369042379, "  ", 167.17291513155888],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.002976485244482357`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0029764852444823572, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.236086570942200\"\>",
            -183.23608657094215,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.23608657094215, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.240945661774600\"\>",
            -183.24094566177462,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.24094566177462, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.004859090832468\"\>",
            0.0048590908324683824,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0048590908324683824, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.5908\"\>",
                -0.59083250615224281,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6575\"\>",
                -0.65747793344740191,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0666\"\>",
                0.066645427295159154,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.3229\"\>",
                0.32293891906738281,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.5382\"\>",
                0.53815855578800775,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5844\"\>",
                0.58443603860441284,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046277482816405112,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0980\"\>",
                0.097988128662109375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3564\"\>",
                2.3563576750512545,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.4050\"\>",
                2.4050443872476324,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0487\"\>",
                -0.048686712196378046,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2268\"\>",
                0.22677917041333498,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0466\"\>",
                1.0466009122990168,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0265\"\>",
                1.026521787515178,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0201\"\>",
                0.020079124783838855,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0642\"\>",
                0.064248320715175736,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 203.3\"\>",
                  203.28690782924446,
                  AutoDelete->True], 
                InterpretationBox["\<\" 187.8\"\>",
                  187.78310014262564,
                  AutoDelete->True], 
                InterpretationBox["\<\" 97.39\"\>",
                  97.393661425739495,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.29\"\>",
                  10.294394758193034,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 187.8\"\>",
                  187.78310014262564,
                  AutoDelete->True], 
                InterpretationBox["\<\" 200.4\"\>",
                  200.42192319527643,
                  AutoDelete->True], 
                InterpretationBox["\<\" 65.59\"\>",
                  65.585480494134401,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.553\"\>",
                  2.5532338275910438,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 97.39\"\>",
                  97.393661425739495,
                  AutoDelete->True], 
                InterpretationBox["\<\" 65.59\"\>",
                  65.585480494134401,
                  AutoDelete->True], 
                InterpretationBox["\<\" 72.71\"\>",
                  72.713369294908475,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.5\"\>",
                  15.500816020054611,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 10.29\"\>",
                  10.294394758193032,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.553\"\>",
                  2.5532338275910402,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.5\"\>",
                  15.500816020054611,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.5\"\>",
                  12.501291215262691,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.511246554629884`*^-8, 1.5595568899795663`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.5112465546298839*^-08, 1.5595568899795663*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0203365263805608`*^-8\),
      SequenceForm[ "NOISE  ", 1.0203365263805608*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]207.47846437775084`\
\[InvisibleSpace]"  "\[InvisibleSpace]138.1849868899526`\),
      SequenceForm[ "*BFGSUP ", 207.47846437775084, "  ", 138.1849868899526],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0034047483147729616`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0034047483147729616, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234665477339300\"\>",
            -183.23466547733929,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.23466547733929, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.236086570942200\"\>",
            -183.23608657094215,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.23608657094215, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.001421093602858\"\>",
            0.0014210936028575816,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0014210936028575816, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.5550\"\>",
                -0.55500088671982617,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5908\"\>",
                -0.59083250615224281,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0358\"\>",
                0.035831619432416612,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.3618\"\>",
                0.36179733276367188,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.5132\"\>",
                0.51322411379637201,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5382\"\>",
                0.53815855578800775,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0249\"\>",
                -0.024934441991635792,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2143\"\>",
                0.21431159973144531,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3347\"\>",
                2.3347366417520798,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3564\"\>",
                2.3563576750512545,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0216\"\>",
                -0.021621033299174579,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2648\"\>",
                0.26476148488129569,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0565\"\>",
                1.0565294068134292,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0466\"\>",
                1.0466009122990168,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0099\"\>",
                0.0099284945144125312,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0554\"\>",
                0.055427145759821134,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 189.2\"\>",
                  189.18894592577814,
                  AutoDelete->True], 
                InterpretationBox["\<\" 184.3\"\>",
                  184.34818235544293,
                  AutoDelete->True], 
                InterpretationBox["\<\" 87.58\"\>",
                  87.579794783304962,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.356\"\>",
                  7.3561746924595912,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 184.3\"\>",
                  184.34818235544293,
                  AutoDelete->True], 
                InterpretationBox["\<\" 201.9\"\>",
                  201.90253829508512,
                  AutoDelete->True], 
                InterpretationBox["\<\" 63.43\"\>",
                  63.431468338377336,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.47\"\>",
                  1.470384531582466,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 87.58\"\>",
                  87.579794783304962,
                  AutoDelete->True], 
                InterpretationBox["\<\" 63.43\"\>",
                  63.431468338377336,
                  AutoDelete->True], 
                InterpretationBox["\<\" 65.91\"\>",
                  65.90600242375595,
                  AutoDelete->True], 
                InterpretationBox["\<\" 13.42\"\>",
                  13.417920389686499,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 7.356\"\>",
                  7.3561746924595894,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.47\"\>",
                  1.4703845315824624,
                  AutoDelete->True], 
                InterpretationBox["\<\" 13.42\"\>",
                  13.417920389686499,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.95\"\>",
                  11.947029319326784,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.479028704393029`*^-8, 1.5743514996967155`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.479028704393029*^-08, 1.5743514996967155*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]8.400746764891664`*^-9\),
      SequenceForm[ "NOISE  ", 8.4007467648916645*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]477.06720689120175`\
\[InvisibleSpace]"  "\[InvisibleSpace]408.8415385447042`\),
      SequenceForm[ "*BFGSUP ", 477.06720689120175, "  ", 408.84153854470418],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0017663370299585259`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0017663370299585259, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234357637833500\"\>",
            -183.23435763783354,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.23435763783354, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234665477339300\"\>",
            -183.23466547733929,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.23466547733929, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000307839505751\"\>",
            0.00030783950575141716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00030783950575141716, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.5555\"\>",
                -0.55546156595167939,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5550\"\>",
                -0.55500088671982617,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0005\"\>",
                -0.00046067923185324984,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2020\"\>",
                0.20196723937988281,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.5137\"\>",
                0.51366568956153846,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5132\"\>",
                0.51322411379637201,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.00044157576516642283,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1636\"\>",
                0.16358375549316406,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3382\"\>",
                2.3382365612643059,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3347\"\>",
                2.3347366417520798,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0035\"\>",
                0.0034999195122262547,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1386\"\>",
                0.13862556016673661,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0554\"\>",
                1.0554178825729266,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0565\"\>",
                1.0565294068134292,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0011\"\>",
                -0.0011115242405025873,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0190\"\>",
                0.01904407070715082,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 147.9\"\>",
                  147.85968438466654,
                  AutoDelete->True], 
                InterpretationBox["\<\" 156.5\"\>",
                  156.51566940089552,
                  AutoDelete->True], 
                InterpretationBox["\<\" 58.03\"\>",
                  58.034690137972134,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.932\"\>",
                  1.9317128620449884,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 156.5\"\>",
                  156.51566940089552,
                  AutoDelete->True], 
                InterpretationBox["\<\" 184.4\"\>",
                  184.35231028545761,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.29\"\>",
                  43.285767526742418,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.506\"\>",
                  -2.5056214711722253,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 58.03\"\>",
                  58.034690137972142,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.29\"\>",
                  43.285767526742418,
                  AutoDelete->True], 
                InterpretationBox["\<\" 44.84\"\>",
                  44.837033798472248,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.608\"\>",
                  9.607544620790863,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.932\"\>",
                  1.9317128620449866,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.506\"\>",
                  -2.5056214711722289,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.608\"\>",
                  9.6075446207908612,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.32\"\>",
                  11.32250651974152,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.484243990874746`*^-8, 1.5726951995088556`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4842439908747463*^-08, 1.5726951995088556*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.2053898141602986`*^-9\),
      SequenceForm[ "NOISE  ", 4.2053898141602986*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3697.0553222833037`\
\[InvisibleSpace]"  "\[InvisibleSpace]2256.3030989285103`\),
      SequenceForm[ "*BFGSUP ", 3697.0553222833037, "  ", 2256.3030989285103],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0006621484935791568`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00066214849357915681, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234287746821700\"\>",
            -183.23428774682171,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.23428774682171, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234357637833500\"\>",
            -183.23435763783354,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.23435763783354, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000069891011833\"\>",
            6.9891011833078664*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 6.9891011833078664*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.5601\"\>",
                -0.56010260135954404,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5555\"\>",
                -0.55546156595167939,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0046\"\>",
                -0.0046410354078646344,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0803\"\>",
                0.080251693725585938,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.5170\"\>",
                0.51699133821179677,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5137\"\>",
                0.51366568956153846,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.0033256486502583477,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0717\"\>",
                0.071653366088867188,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3437\"\>",
                2.3436741865869903,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3382\"\>",
                2.3382365612643059,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054376253226846322,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0519\"\>",
                0.051888827628387008,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0529\"\>",
                1.0529076404582485,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0554\"\>",
                1.0554178825729266,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0025\"\>",
                -0.0025102421146781782,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0032\"\>",
                0.0032023540941947355,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 110.6\"\>",
                  110.59402270037305,
                  AutoDelete->True], 
                InterpretationBox["\<\" 123.3\"\>",
                  123.33833893703851,
                  AutoDelete->True], 
                InterpretationBox["\<\" 33.89\"\>",
                  33.893703006383063,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3819\"\>",
                  0.3819429115307047,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 123.3\"\>",
                  123.33833893703851,
                  AutoDelete->True], 
                InterpretationBox["\<\" 155.2\"\>",
                  155.21898119283202,
                  AutoDelete->True], 
                InterpretationBox["\<\" 21.6\"\>",
                  21.599194746685878,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.151\"\>",
                  -4.1505321655454228,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 33.89\"\>",
                  33.89370300638307,
                  AutoDelete->True], 
                InterpretationBox["\<\" 21.6\"\>",
                  21.599194746685875,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.29\"\>",
                  29.291464786821113,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.731\"\>",
                  8.7308869556902273,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.3819\"\>",
                  0.38194291153070292,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.151\"\>",
                  -4.1505321655454264,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.731\"\>",
                  8.7308869556902238,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.43\"\>",
                  11.432011066727529,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492346684019253`*^-8, 1.5689546472702153`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4923466840192532*^-08, 1.5689546472702153*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.2295515716687078`*^-9\),
      SequenceForm[ "NOISE  ", 1.2295515716687078*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]7120.345125207418`\
\[InvisibleSpace]"  "\[InvisibleSpace]7145.08809140066`\),
      SequenceForm[ "*BFGSUP ", 7120.3451252074183, "  ", 7145.0880914006602],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000012345481330662484`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.2345481330662484*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234287656405200\"\>",
            -183.23428765640523,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.23428765640523, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234287746821700\"\>",
            -183.23428774682171,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.23428774682171, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     9.041647786034450"\[Times]10\^"-8"\),
            9.0416477860344457*^-08,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 9.0416477860344457*^-08, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.5600\"\>",
                -0.5599706575015454,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5601\"\>",
                -0.56010260135954404,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00013194385799861308,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0016\"\>",
                0.001552581787109375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.5169\"\>",
                0.51691400213194405,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5170\"\>",
                0.51699133821179677,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0001\"\>",
                -7.7336079852706498*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0023\"\>",
                0.002262115478515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3436\"\>",
                2.3435740383714534,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3437\"\>",
                2.3436741865869903,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0001\"\>",
                -0.00010014821553683574,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067466375046959764,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0529\"\>",
                1.0528524740891705,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0529\"\>",
                1.0529076404582485,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0001\"\>",
                -5.5166369077980119*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0011\"\>",
                -0.0011412488545993449,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 108.7\"\>",
                  108.67748157740539,
                  AutoDelete->True], 
                InterpretationBox["\<\" 121.1\"\>",
                  121.13632728809867,
                  AutoDelete->True], 
                InterpretationBox["\<\" 33.6\"\>",
                  33.595100280788728,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9797\"\>",
                  0.97969807641798656,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 121.1\"\>",
                  121.13632728809867,
                  AutoDelete->True], 
                InterpretationBox["\<\" 152.8\"\>",
                  152.82013404043425,
                  AutoDelete->True], 
                InterpretationBox["\<\" 21.\"\>",
                  21.004768976372176,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.644\"\>",
                  -3.6439108772331532,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 33.6\"\>",
                  33.595100280788728,
                  AutoDelete->True], 
                InterpretationBox["\<\" 21.\"\>",
                  21.004768976372169,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.73\"\>",
                  29.726617674030326,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.169\"\>",
                  9.1692945353691595,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.9797\"\>",
                  0.97969807641798479,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.644\"\>",
                  -3.6439108772331568,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.169\"\>",
                  9.169294535369156,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.49\"\>",
                  11.49307641959345,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492197451548954`*^-8, 1.5688724429744042`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921974515489539*^-08, 1.5688724429744042*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.6650597921600274`*^-11\),
      SequenceForm[ "NOISE  ", 3.6650597921600274*^-11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]7.141031089654962`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]6.233037808784049`*^6\),
      SequenceForm[ "*BFGSUP ", 7141031.0896549616, "  ", 6233037.808784049],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.4677174270508941`*^-6\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.4677174270508941*^-06, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234287654477400\"\>",
            -183.23428765447744,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -183.23428765447744, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -183.234287656405200\"\>",
            -183.23428765640523,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ -183.23428765640523, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.927787707245443"\[Times]10\^"-9"\),
            1.927787707245443*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.927787707245443*^-09, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.5600\"\>",
                -0.55996651947580001,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5600\"\>",
                -0.5599706575015454,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0000\"\>",
                4.1961669921875*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 0.5169\"\>",
                0.51691116245896762,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.5169\"\>",
                0.51691400213194405,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                9.72747802734375*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 2.3436\"\>",
                2.3435732734201156,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.3436\"\>",
                2.3435740383714534,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -0.00011475470918488492,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.0528\"\>",
                1.0528314229182232,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0529\"\>",
                1.0528524740891705,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0000\"\>",
                -2.1051170947414951*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0002\"\>",
                -0.00019746451292373038,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
            TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", 
            "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 109.9\"\>",
                  109.94832145448366,
                  AutoDelete->True], 
                InterpretationBox["\<\" 122.6\"\>",
                  122.59812550545463,
                  AutoDelete->True], 
                InterpretationBox["\<\" 34.08\"\>",
                  34.084069937233387,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.843\"\>",
                  1.8429414761091047,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 122.6\"\>",
                  122.59812550545463,
                  AutoDelete->True], 
                InterpretationBox["\<\" 154.4\"\>",
                  154.39133607186687,
                  AutoDelete->True], 
                InterpretationBox["\<\" 21.86\"\>",
                  21.861684638678113,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.143\"\>",
                  -2.1426176462667494,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 34.08\"\>",
                  34.084069937233387,
                  AutoDelete->True], 
                InterpretationBox["\<\" 21.86\"\>",
                  21.861684638678106,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.13\"\>",
                  29.128218448422977,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.144\"\>",
                  8.1436687659213334,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.843\"\>",
                  1.8429414761091012,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.143\"\>",
                  -2.1426176462667512,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.144\"\>",
                  8.143668765921328,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.736\"\>",
                  9.7355855321082228,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.965632076635664`*^-12\),
      SequenceForm[ "NOISE  ", 3.965632076635664*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.3005362454650718`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]2.4142629489115855`*^8\),
      SequenceForm[ "*BFGSUP ", 230053624.54650718, "  ", 241426294.89115855],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]3.747363643573624`*^-7\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.7473636435736238*^-07, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 1"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 3"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]14\
\[InvisibleSpace]"  "\[InvisibleSpace]50\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 14, "  ", 50],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.0000438690185546875`"},
            {"0.00006866455078125`"},
            {"8.138634513564805`*^-7"},
            {"9.05818629313769`*^-6"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print"],

Cell[BoxData[
    \("BFGS update"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 109.5\"\>",
                  109.52405937245852,
                  AutoDelete->True], 
                InterpretationBox["\<\" 121.6\"\>",
                  121.60011475120378,
                  AutoDelete->True], 
                InterpretationBox["\<\" 35.3\"\>",
                  35.297320407842392,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.934\"\>",
                  3.9340060465638262,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 121.6\"\>",
                  121.60011475120378,
                  AutoDelete->True], 
                InterpretationBox["\<\" 152.3\"\>",
                  152.29517733035578,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.8\"\>",
                  23.796004100445831,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.135\"\>",
                  1.1354661159427804,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 35.3\"\>",
                  35.297320407842392,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.8\"\>",
                  23.79600410044582,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.02\"\>",
                  29.02157975277073,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.164\"\>",
                  8.1637656928323139,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 3.934\"\>",
                  3.9340060465638227,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.135\"\>",
                  1.1354661159427777,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.164\"\>",
                  8.1637656928323068,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.13\"\>",
                  10.133995971926273,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"Likelihood\"\>", "\<\"THETA\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>"},
          {"1", \(-191.5026283950059`\), \(-1.`\), "1.`", "2.`", "1.`"},
          {"2", \(-189.16723181781086`\), \(-0.7815175764028681`\), 
            "1.0858348615399973`", "2.25`", "1.0582580107676183`"},
          {"3", \(-184.32041674356944`\), \(-0.8939287860222078`\), 
            "0.6966475969006114`", "2.75`", "1.247773189662689`"},
          {"4", \(-184.08740121668976`\), \(-0.830114097242281`\), 
            "0.6063098848444255`", "2.762533572738944`", 
            "0.9977731896626889`"},
          {"5", \(-183.77924693100562`\), \(-0.9227843639906463`\), 
            "0.7123984154404239`", "2.8025644527623563`", 
            "0.7477731896626889`"},
          {"6", \(-183.3670649549091`\), \(-0.6698850779505714`\), 
            "0.6344291047091032`", "2.343072834858167`", 
            "1.1100933848813503`"},
          {"7", \(-183.25201586852094`\), \(-0.7231142188435626`\), 
            "0.6277022255811673`", "2.4670655294197235`", 
            "1.0170699301121882`"},
          {"8", \(-183.24549531974174`\), \(-0.6969609489396026`\), 
            "0.6109998731490589`", "2.4392159833041034`", 
            "1.0145259226187788`"},
          {"9", \(-183.24094566177462`\), \(-0.6574779334474019`\), 
            "0.5844360386044128`", "2.4050443872476324`", 
            "1.026521787515178`"},
          {"10", \(-183.23608657094215`\), \(-0.5908325061522428`\), 
            "0.5381585557880078`", "2.3563576750512545`", 
            "1.0466009122990168`"},
          {"11", \(-183.2346654773393`\), \(-0.5550008867198262`\), 
            "0.513224113796372`", "2.33473664175208`", 
            "1.0565294068134292`"},
          {"12", \(-183.23435763783354`\), \(-0.5554615659516794`\), 
            "0.5136656895615385`", "2.338236561264306`", 
            "1.0554178825729266`"},
          {"13", \(-183.2342877468217`\), \(-0.560102601359544`\), 
            "0.5169913382117968`", "2.3436741865869903`", 
            "1.0529076404582485`"},
          {"14", \(-183.23428765640523`\), \(-0.5599706575015454`\), 
            "0.516914002131944`", "2.3435740383714534`", 
            "1.0528524740891705`"},
          {"15", \(-183.23428765447744`\), \(-0.5599665194758`\), 
            "0.5169111624589676`", "2.3435732734201156`", 
            "1.0528314229182232`"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableDirections -> Column, TableSpacing -> Automatic, 
          TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          3.492196311682635`*^-8, 1.5688410742852437`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        3.4921963116826349*^-08, 1.5688410742852437*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Fisher Information = BHHH (OPG)"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", \(-0.5599665194758`\), "0.0000438690185546875`"},
              {"2", "0.5169111624589676`", "0.00006866455078125`"},
              {"3", "2.3435732734201156`", "8.138634513564805`*^-7"},
              {"4", "1.0528314229182232`", "9.05818629313769`*^-6"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", 
        "\[InvisibleSpace]", \(-183.23428765447744`\)}],
      SequenceForm[ 
        TableForm[ {{-0.55996651947580001, 4.38690185546875*^-05}, {
          0.51691116245896762, 6.866455078125*^-05}, {2.3435732734201156, 
          8.1386345135648052*^-07}, {1.0528314229182232, 
          9.0581862931376904*^-06}}, TableHeadings -> {Automatic, {"THETA", 
          "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          1}], "   Likelihood = ", -183.23428765447744],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "291.6527659387002`", "4", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.497705474412375`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.497705474412375],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", \(-0.5599665194758`\), "2.2013608599969774`", 
            "0.8813532590406331`"},
          {"2", "0.5169111624589676`", "1.4964245451070783`", 
            "0.5991196962320532`"},
          {"3", "2.3435732734201156`", "1.6963279425420332`", 
            "0.679154511979088`"},
          {"4", "1.0528314229182232`", "1.1830185918305034`", 
            "0.4736421503455396`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {
              "1.0000000000000002`", \(-0.9875519711204194`\), \
\(-0.9361907460142956`\), "0.12837961712540213`"},
            {\(-0.9875519711204187`\), "0.9999999999999999`", 
              "0.8982153790100216`", \(-0.10779117738066471`\)},
            {\(-0.9361907460142951`\), "0.8982153790100214`", 
              "1.`", \(-0.36099203335651503`\)},
            {
              "0.12837961712540139`", \(-0.10779117738066395`\), \
\(-0.3609920333565144`\), "0.9999999999999999`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {
              "0.7767835672215454`", \(-0.5214630882467588`\), \
\(-0.5603804156069435`\), "0.053591564432319314`"},
            {\(-0.5214630882467585`\), "0.35894441041318764`", 
              "0.3654792073394424`", \(-0.030587723605371653`\)},
            {\(-0.5603804156069432`\), "0.36547920733944234`", 
              "0.46125085114155323`", \(-0.11612254677327427`\)},
            {
              "0.05359156443231901`", \(-0.030587723605371438`\), \
\(-0.11612254677327409`\), "0.2243368865839467`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({0.003099404612550173`, 0.027372267477865954`, 0.2379163586936084`, 
      1.5529276845761266`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"143.58909929640504`", "143.2449473540387`", 
              "65.80262260269194`", "19.29036538614533`"},
            {"143.2449473540387`", "162.8962638234453`", "48.21707214141172`",
               "12.949249353050417`"},
            {"65.80262260269194`", "48.21707214141172`", 
              "47.838808090144774`", "15.617356869257048`"},
            {"19.29036538614533`", "12.949249353050417`", 
              "15.617356869257048`", "9.698870690641344`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({322.64261205225654`, 36.53332705478749`, 4.20315780508314`, 
      0.6439449885092049`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]4\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]2010\),
      SequenceForm[ "U =  ", 4, "  Nue = ", 2010],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "4", "15.211780002106243`", 
            "20.309518702205914`"},
          {"\<\"komp. Lik.\"\>", \(-183.23428765447744`\), \
\(-187.23428765447744`\), \(-198.4460676565837`\), \(-203.54380635668335`\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF / kappa=0", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Filter", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,lik} = 
\tUKF[data[[nn=10]],Theta,system={f,g,h,R,mue,sigma,dt,kappa=0},{miss,2}];//\
Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.29000000000000004`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell["std = Map[VecDiag,PF]//Sqrt;", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["std//Dimensions", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({201, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g2 = plot1[yt[[nn]]~ii~YF~ii~(YF+std)~ii~(YF-std)//AddTimeAxis,
\t\tGridLines->{time/dt,None},color->{1,2,3,3},
\t\tDisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{201, 5}\),
      SequenceForm[ "Dimension der Daten  ", {201, 5}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g3 = plot1[Spalte[time/dt]~ii~ZM[[nn,time/dt+1]],
\t\t\tPlotJoined->False,dicke->.02,
\t\t\tDisplayFunction->Identity,color->{10}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{14, 2}\),
      SequenceForm[ "Dimension der Daten  ", {14, 2}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gUKF=Show[g2,g3,DisplayFunction->$DisplayFunction,GridLines->{time/\
dt,None},
\t\t\t\tPlotLabel->\"UKF, kappa = \"<>ToString[kappa]<>\" panel unit = \
\"<>ToString[nn],PlotRange->{All,{-5,5}}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gUKF\\)\\\" is similar to existing symbols \
\\!\\({gEKF, UKF}\\). \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0047619 0.309017 0.0618034 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -6 -9 ]
[.2619 -0.0125 6 0 ]
[.5 -0.0125 -9 -9 ]
[.5 -0.0125 9 0 ]
[.7381 -0.0125 -9 -9 ]
[.7381 -0.0125 9 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -6 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -6 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -92 0 ]
[.5 .63053 92 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .61803 L
s
.21429 0 m
.21429 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.40476 0 m
.40476 .61803 L
s
.5 0 m
.5 .61803 L
s
.54762 0 m
.54762 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.66667 0 m
.66667 .61803 L
s
.67619 0 m
.67619 .61803 L
s
.7381 0 m
.7381 .61803 L
s
.74286 0 m
.74286 .61803 L
s
.83333 0 m
.83333 .61803 L
s
.92857 0 m
.92857 .61803 L
s
.97619 0 m
.97619 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(50)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(100)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(150)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(200)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(-4)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(-2)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(2)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(4)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -153 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
129.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
141.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
153.000 13.000 moveto
(panel) show
189.000 13.000 moveto
(unit) show
219.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
231.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
243.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.97619 .19163 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .27669 m
.02857 .29846 L
.03333 .2618 L
.0381 .26628 L
.04286 .26754 L
.04762 .20714 L
.05238 .16017 L
.05714 .12555 L
.0619 .06686 L
.06667 .05446 L
.07143 .11893 L
.07619 .12641 L
.08095 .13619 L
.08571 .16112 L
.09048 .16386 L
.09524 .19665 L
.1 .24045 L
.10476 .20446 L
.10952 .19228 L
.11429 .214 L
.11905 .14632 L
.12381 .17878 L
.12857 .16414 L
.13333 .17391 L
.1381 .14817 L
.14286 .08782 L
.14762 .05453 L
.15238 .0119 L
.15714 .09454 L
.1619 .03251 L
s
.1619 .03251 m
.16578 0 L
s
.16707 0 m
.17143 .07962 L
.17619 .12078 L
.18095 .14606 L
.18571 .0944 L
.19048 .05835 L
.19524 .02722 L
.2 .12327 L
.20476 .13342 L
.20952 .11797 L
.21429 .0862 L
.21905 .1208 L
.22381 .0684 L
.22857 .10722 L
.23333 .07035 L
.2381 .14024 L
.24286 .16002 L
.24762 .0962 L
.25238 .14833 L
.25714 .18874 L
.2619 .17714 L
.26667 .105 L
.27143 .04362 L
.27619 .11036 L
.28095 .10684 L
.28571 .07526 L
.29048 .05732 L
.29524 .02388 L
.3 .03087 L
s
.3 .03087 m
.30464 0 L
s
.31443 0 m
.31905 .07609 L
.32381 .10542 L
.32857 .15738 L
.33333 .14317 L
.3381 .15243 L
.34286 .20764 L
.34762 .22096 L
.35238 .2153 L
.35714 .26563 L
.3619 .3122 L
.36667 .35278 L
.37143 .38037 L
.37619 .38052 L
.38095 .43467 L
.38571 .47781 L
.39048 .5289 L
.39524 .58891 L
.4 .57273 L
.40476 .54716 L
.40952 .56473 L
.41429 .56986 L
.41905 .55525 L
.42381 .51756 L
.42857 .52404 L
.43333 .57999 L
.4381 .60893 L
.44286 .56255 L
.44762 .49508 L
.45238 .47568 L
.45714 .54105 L
.4619 .57277 L
.46667 .56729 L
.47143 .53704 L
.47619 .47122 L
.48095 .40953 L
.48571 .47737 L
.49048 .54448 L
.49524 .49601 L
.5 .46279 L
.50476 .41459 L
.50952 .48668 L
.51429 .50639 L
.51905 .54283 L
.52381 .51727 L
.52857 .48803 L
.53333 .43407 L
.5381 .43381 L
.54286 .48406 L
.54762 .46833 L
Mistroke
.55238 .4306 L
.55714 .50386 L
.5619 .5293 L
.56667 .45758 L
.57143 .42766 L
.57619 .39203 L
.58095 .34028 L
.58571 .35624 L
.59048 .31438 L
.59524 .27082 L
.6 .21584 L
.60476 .22649 L
.60952 .27894 L
.61429 .33442 L
.61905 .27197 L
.62381 .28934 L
.62857 .26229 L
.63333 .21177 L
.6381 .22268 L
.64286 .19539 L
.64762 .15191 L
.65238 .17558 L
.65714 .21152 L
.6619 .27075 L
.66667 .2065 L
.67143 .23019 L
.67619 .17363 L
.68095 .2312 L
.68571 .26797 L
.69048 .27059 L
.69524 .20779 L
.7 .18438 L
.70476 .19891 L
.70952 .17433 L
.71429 .22716 L
.71905 .25426 L
.72381 .2796 L
.72857 .26895 L
.73333 .32226 L
.7381 .26879 L
.74286 .25272 L
.74762 .2182 L
.75238 .1823 L
.75714 .20821 L
.7619 .15684 L
.76667 .15996 L
.77143 .14959 L
.77619 .17866 L
.78095 .12033 L
.78571 .16473 L
Mistroke
.79048 .13629 L
.79524 .17001 L
.8 .13643 L
.80476 .10406 L
.80952 .07563 L
.81429 .07138 L
.81905 .10182 L
.82381 .16059 L
.82857 .13162 L
.83333 .14816 L
.8381 .19935 L
.84286 .18811 L
.84762 .16852 L
.85238 .16849 L
.85714 .16259 L
.8619 .1141 L
.86667 .06294 L
.87143 .11855 L
.87619 .09475 L
.88095 .1156 L
.88571 .13599 L
.89048 .07134 L
.89524 .04327 L
.9 .10437 L
.90476 .08131 L
.90952 .05875 L
.91429 .12972 L
.91905 .12629 L
.92381 .06173 L
.92857 .12778 L
.93333 .09344 L
.9381 .10901 L
.94286 .13808 L
.94762 .09789 L
.95238 .08094 L
.95714 .03611 L
.9619 .03459 L
.96667 .08602 L
.97143 .13909 L
.97619 .19163 L
Mfstroke
0 .98 .604 r
gsave
.97619 .19823 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21625 m
.02857 .21159 L
.03333 .20822 L
.0381 .20622 L
.04286 .20555 L
.04762 .20608 L
.05238 .20766 L
.05714 .21013 L
.0619 .21335 L
.06667 .2172 L
.07143 .22159 L
.07619 .22647 L
.08095 .23177 L
.08571 .23743 L
.09048 .24339 L
.09524 .24957 L
.1 .25588 L
.10476 .26219 L
.10952 .26839 L
.11429 .27433 L
.11905 .27988 L
.12381 .28494 L
.12857 .28943 L
.13333 .29332 L
.1381 .29659 L
.14286 .2993 L
.14762 .30148 L
.15238 .30323 L
.15714 .30459 L
.1619 .30565 L
.16667 .30647 L
.17143 .30709 L
.17619 .30757 L
.18095 .30793 L
.18571 .3082 L
.19048 .3084 L
.19524 .30856 L
.2 .30867 L
.20476 .30876 L
.20952 .30882 L
.21429 .1306 L
.21905 .13256 L
.22381 .13486 L
.22857 .13729 L
.23333 .13972 L
.2381 .14211 L
.24286 .14444 L
.24762 .14671 L
.25238 .14892 L
.25714 .15109 L
Mistroke
.2619 .15323 L
.26667 .15535 L
.27143 .15745 L
.27619 .15956 L
.28095 .16168 L
.28571 .16383 L
.29048 .16601 L
.29524 .16824 L
.3 .17052 L
.30476 .17288 L
.30952 .07557 L
.31429 .09048 L
.31905 .10062 L
.32381 .10827 L
.32857 .11439 L
.33333 .11949 L
.3381 .12386 L
.34286 .12769 L
.34762 .13112 L
.35238 .13423 L
.35714 .13711 L
.3619 .13978 L
.36667 .14231 L
.37143 .14471 L
.37619 .14702 L
.38095 .14926 L
.38571 .15144 L
.39048 .15358 L
.39524 .1557 L
.4 .15781 L
.40476 .38153 L
.40952 .38636 L
.41429 .39028 L
.41905 .39306 L
.42381 .39456 L
.42857 .39475 L
.43333 .39368 L
.4381 .39147 L
.44286 .38827 L
.44762 .38422 L
.45238 .37949 L
.45714 .37421 L
.4619 .36851 L
.46667 .36254 L
.47143 .35645 L
.47619 .35039 L
.48095 .34451 L
.48571 .33896 L
.49048 .33385 L
.49524 .32929 L
Mistroke
.5 .52928 L
.50476 .51731 L
.50952 .50911 L
.51429 .50284 L
.51905 .49773 L
.52381 .4934 L
.52857 .48962 L
.53333 .48624 L
.5381 .48317 L
.54286 .48033 L
.54762 .43735 L
.55238 .44244 L
.55714 .44583 L
.5619 .4477 L
.56667 .44834 L
.57143 .44805 L
.57619 .44708 L
.58095 .44561 L
.58571 .44379 L
.59048 .44169 L
.59524 .31471 L
.6 .31516 L
.60476 .31554 L
.60952 .31583 L
.61429 .31598 L
.61905 .31596 L
.62381 .31577 L
.62857 .3154 L
.63333 .31488 L
.6381 .31424 L
.64286 .31355 L
.64762 .31284 L
.65238 .31217 L
.65714 .31157 L
.6619 .31104 L
.66667 .26976 L
.67143 .26707 L
.67619 .27466 L
.68095 .27203 L
.68571 .26979 L
.69048 .26812 L
.69524 .26721 L
.7 .26718 L
.70476 .2681 L
.70952 .26995 L
.71429 .27262 L
.71905 .27592 L
.72381 .27964 L
.72857 .28355 L
.73333 .28742 L
Mistroke
.7381 .34709 L
.74286 .24936 L
.74762 .24501 L
.75238 .24136 L
.75714 .23865 L
.7619 .23708 L
.76667 .23675 L
.77143 .23769 L
.77619 .23981 L
.78095 .243 L
.78571 .24707 L
.79048 .25185 L
.79524 .25713 L
.8 .26271 L
.80476 .26841 L
.80952 .27403 L
.81429 .27941 L
.81905 .28439 L
.82381 .28886 L
.82857 .29278 L
.83333 .06519 L
.8381 .08543 L
.84286 .0974 L
.84762 .10594 L
.85238 .11257 L
.85714 .11799 L
.8619 .12257 L
.86667 .12657 L
.87143 .13011 L
.87619 .13332 L
.88095 .13626 L
.88571 .13899 L
.89048 .14156 L
.89524 .144 L
.9 .14633 L
.90476 .14859 L
.90952 .15079 L
.91429 .15294 L
.91905 .15506 L
.92381 .15717 L
.92857 .15201 L
.93333 .1495 L
.9381 .1486 L
.94286 .14883 L
.94762 .14978 L
.95238 .15118 L
.95714 .15284 L
.9619 .15467 L
.96667 .1566 L
.97143 .15859 L
Mistroke
.97619 .19823 L
Mfstroke
1 0 0 r
gsave
.97619 .24817 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27518 m
.02857 .28345 L
.03333 .29078 L
.0381 .29774 L
.04286 .30465 L
.04762 .31171 L
.05238 .31906 L
.05714 .32681 L
.0619 .33502 L
.06667 .34376 L
.07143 .35307 L
.07619 .36297 L
.08095 .37345 L
.08571 .38449 L
.09048 .396 L
.09524 .40788 L
.1 .41996 L
.10476 .43203 L
.10952 .44387 L
.11429 .45521 L
.11905 .4658 L
.12381 .47545 L
.12857 .48399 L
.13333 .49136 L
.1381 .49756 L
.14286 .50266 L
.14762 .50677 L
.15238 .51002 L
.15714 .51257 L
.1619 .51453 L
.16667 .51604 L
.17143 .51718 L
.17619 .51804 L
.18095 .51869 L
.18571 .51918 L
.19048 .51954 L
.19524 .51981 L
.2 .52002 L
.20476 .52017 L
.20952 .52028 L
.21429 .18992 L
.21905 .19593 L
.22381 .20115 L
.22857 .20588 L
.23333 .21026 L
.2381 .21439 L
.24286 .21833 L
.24762 .22213 L
.25238 .22583 L
.25714 .22946 L
Mistroke
.2619 .23305 L
.26667 .23662 L
.27143 .24019 L
.27619 .24378 L
.28095 .24741 L
.28571 .25111 L
.29048 .25488 L
.29524 .25876 L
.3 .26276 L
.30476 .2669 L
.30952 .12751 L
.31429 .14264 L
.31905 .15475 L
.32381 .16467 L
.32857 .17304 L
.33333 .18026 L
.3381 .18663 L
.34286 .19234 L
.34762 .19755 L
.35238 .20236 L
.35714 .20685 L
.3619 .21109 L
.36667 .21514 L
.37143 .21903 L
.37619 .2228 L
.38095 .22648 L
.38571 .23009 L
.39048 .23367 L
.39524 .23724 L
.4 .24081 L
.40476 .43141 L
.40952 .4518 L
.41429 .46887 L
.41905 .48309 L
.42381 .49464 L
.42857 .50371 L
.43333 .51059 L
.4381 .51562 L
.44286 .51916 L
.44762 .52156 L
.45238 .5231 L
.45714 .52401 L
.4619 .52447 L
.46667 .52462 L
.47143 .52455 L
.47619 .52434 L
.48095 .52404 L
.48571 .5237 L
.49048 .52334 L
.49524 .52298 L
Mistroke
.5 .58825 L
.50476 .57459 L
.50952 .56722 L
.51429 .56255 L
.51905 .55925 L
.52381 .55675 L
.52857 .55475 L
.53333 .55309 L
.5381 .55168 L
.54286 .55044 L
.54762 .48415 L
.55238 .50217 L
.55714 .51477 L
.5619 .52341 L
.56667 .52914 L
.57143 .53278 L
.57619 .53499 L
.58095 .53624 L
.58571 .53686 L
.59048 .53705 L
.59524 .36693 L
.6 .38432 L
.60476 .40029 L
.60952 .41541 L
.61429 .42982 L
.61905 .44343 L
.62381 .45607 L
.62857 .46755 L
.63333 .47774 L
.6381 .48653 L
.64286 .49392 L
.64762 .49999 L
.65238 .50486 L
.65714 .50869 L
.6619 .51166 L
.66667 .32889 L
.67143 .34188 L
.67619 .32546 L
.68095 .33955 L
.68571 .35237 L
.69048 .36475 L
.69524 .37706 L
.7 .38946 L
.70476 .40197 L
.70952 .41455 L
.71429 .42705 L
.71905 .43929 L
.72381 .45105 L
.72857 .46208 L
.73333 .47218 L
Mistroke
.7381 .40586 L
.74286 .29693 L
.74762 .30905 L
.75238 .31952 L
.75714 .32942 L
.7619 .33921 L
.76667 .34917 L
.77143 .35946 L
.77619 .37017 L
.78095 .38133 L
.78571 .3929 L
.79048 .40482 L
.79524 .41696 L
.8 .42911 L
.80476 .44107 L
.80952 .45258 L
.81429 .46339 L
.81905 .47328 L
.82381 .4821 L
.82857 .48975 L
.83333 .12424 L
.8381 .13915 L
.84286 .15163 L
.84762 .16198 L
.85238 .1707 L
.85714 .17821 L
.8619 .1848 L
.86667 .19069 L
.87143 .19603 L
.87619 .20095 L
.88095 .20553 L
.88571 .20984 L
.89048 .21394 L
.89524 .21787 L
.9 .22167 L
.90476 .22537 L
.90952 .22901 L
.91429 .2326 L
.91905 .23617 L
.92381 .23973 L
.92857 .2018 L
.93333 .20896 L
.9381 .21444 L
.94286 .21907 L
.94762 .22325 L
.95238 .22715 L
.95714 .23089 L
.9619 .23454 L
.96667 .23816 L
.97143 .24176 L
Mistroke
.97619 .24817 L
Mfstroke
gsave
.97619 .1483 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15732 m
.02857 .13973 L
.03333 .12566 L
.0381 .1147 L
.04286 .10644 L
.04762 .10045 L
.05238 .09626 L
.05714 .09346 L
.0619 .09167 L
.06667 .09063 L
.07143 .09012 L
.07619 .08997 L
.08095 .09008 L
.08571 .09037 L
.09048 .09078 L
.09524 .09127 L
.1 .0918 L
.10476 .09235 L
.10952 .0929 L
.11429 .09344 L
.11905 .09396 L
.12381 .09444 L
.12857 .09488 L
.13333 .09528 L
.1381 .09563 L
.14286 .09594 L
.14762 .0962 L
.15238 .09643 L
.15714 .09662 L
.1619 .09677 L
.16667 .0969 L
.17143 .09701 L
.17619 .09709 L
.18095 .09716 L
.18571 .09722 L
.19048 .09726 L
.19524 .0973 L
.2 .09733 L
.20476 .09735 L
.20952 .09737 L
.21429 .07128 L
.21905 .06919 L
.22381 .06857 L
.22857 .06869 L
.23333 .06918 L
.2381 .06983 L
.24286 .07055 L
.24762 .07129 L
.25238 .07202 L
.25714 .07272 L
Mistroke
.2619 .07341 L
.26667 .07407 L
.27143 .07472 L
.27619 .07534 L
.28095 .07595 L
.28571 .07655 L
.29048 .07713 L
.29524 .07771 L
.3 .07829 L
.30476 .07886 L
.30952 .02362 L
.31429 .03832 L
.31905 .04649 L
.32381 .05187 L
.32857 .05574 L
.33333 .05871 L
.3381 .06108 L
.34286 .06304 L
.34762 .06469 L
.35238 .06611 L
.35714 .06736 L
.3619 .06847 L
.36667 .06948 L
.37143 .0704 L
.37619 .07125 L
.38095 .07204 L
.38571 .07278 L
.39048 .07349 L
.39524 .07416 L
.4 .07481 L
.40476 .33165 L
.40952 .32092 L
.41429 .3117 L
.41905 .30304 L
.42381 .29449 L
.42857 .28579 L
.43333 .27678 L
.4381 .26732 L
.44286 .25737 L
.44762 .24689 L
.45238 .23588 L
.45714 .2244 L
.4619 .21255 L
.46667 .20047 L
.47143 .18836 L
.47619 .17644 L
.48095 .16498 L
.48571 .15421 L
.49048 .14437 L
.49524 .13561 L
Mistroke
.5 .4703 L
.50476 .46003 L
.50952 .45101 L
.51429 .44314 L
.51905 .43622 L
.52381 .43005 L
.52857 .42448 L
.53333 .41938 L
.5381 .41465 L
.54286 .41022 L
.54762 .39055 L
.55238 .38272 L
.55714 .37689 L
.5619 .37199 L
.56667 .36755 L
.57143 .36332 L
.57619 .35916 L
.58095 .35499 L
.58571 .35072 L
.59048 .34632 L
.59524 .2625 L
.6 .246 L
.60476 .2308 L
.60952 .21624 L
.61429 .20213 L
.61905 .1885 L
.62381 .17548 L
.62857 .16325 L
.63333 .15202 L
.6381 .14196 L
.64286 .13318 L
.64762 .1257 L
.65238 .11949 L
.65714 .11444 L
.6619 .11043 L
.66667 .21062 L
.67143 .19226 L
.67619 .22386 L
.68095 .2045 L
.68571 .1872 L
.69048 .17149 L
.69524 .15736 L
.7 .14491 L
.70476 .13424 L
.70952 .12535 L
.71429 .11818 L
.71905 .11255 L
.72381 .10824 L
.72857 .10502 L
.73333 .10266 L
Mistroke
.7381 .28831 L
.74286 .20179 L
.74762 .18098 L
.75238 .16319 L
.75714 .14788 L
.7619 .13495 L
.76667 .12433 L
.77143 .11591 L
.77619 .10946 L
.78095 .10467 L
.78571 .10124 L
.79048 .09887 L
.79524 .0973 L
.8 .09631 L
.80476 .09576 L
.80952 .09549 L
.81429 .09543 L
.81905 .09549 L
.82381 .09563 L
.82857 .09581 L
.83333 .00613 L
.8381 .03172 L
.84286 .04317 L
.84762 .04989 L
.85238 .05443 L
.85714 .05776 L
.8619 .06035 L
.86667 .06245 L
.87143 .0642 L
.87619 .06569 L
.88095 .06699 L
.88571 .06815 L
.89048 .06918 L
.89524 .07013 L
.9 .071 L
.90476 .0718 L
.90952 .07256 L
.91429 .07328 L
.91905 .07396 L
.92381 .07462 L
.92857 .10222 L
.93333 .09004 L
.9381 .08277 L
.94286 .07859 L
.94762 .07631 L
.95238 .07521 L
.95714 .0748 L
.9619 .0748 L
.96667 .07504 L
.97143 .07542 L
Mistroke
.97619 .1483 L
Mfstroke
0 g
gsave
.97619 .21823 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.02381 .20697 Mdot
.21429 .11538 Mdot
.30952 .03412 Mdot
.40476 .50012 Mdot
.5 .54929 Mdot
.54762 .40735 Mdot
.59524 .26475 Mdot
.66667 .26598 Mdot
.67619 .27934 Mdot
.7381 .35301 Mdot
.74286 .18034 Mdot
.83333 .04316 Mdot
.92857 .14808 Mdot
.97619 .21823 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{281.812, 174.188},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[R000`400?l00000o`00003ooooooolJ
ooooo`008?ooool2o`0003;ooooo0ol00004ooooo`;o0000;Oooool3o`0000Cooooo0_l00004oooo
o`;o0000:Oooool3o`0000?ooooo0ol00004ooooo`;o0000:?ooool5o`0000?ooooo0_l00004oooo
o`;o00004?ooool001oooooo00Co0000oooooooooooo0000<?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo0000;Oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo0000:Oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Vooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000?ooooo`00
7oooool01?l0003oooooooooool0000dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo0000:Oooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00003oooool001oooooo00Co0000oooooooooooo0000=?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0002Wooooo00?o0000ooooooooool0
1Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo02Sooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03Oooool0
01oooooo00Co0000oooooooooooo0000<?ooool4o`0000?ooooo00Co0000oooooooooooo0000;Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
0000:Oooool01?l0003oooooooooooooool4o`0000?ooooo00Co0000oooooooooooo00009oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000?ooooo`007oooool01?l0003oooooooooool0000`ooooo`03o`000?oooooooooo00Co
oooo00Co0000oooooooooooo0000;?ooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Xooooo`;o00000oooool00ol0003oooooooooo`04ooooo`04o`000?oo
ooooooooo`0002Oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00003oooool0023ooooo0_l0000aooooo`Go00000oooool2o`00
02kooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l0000Zooooo`04o`000?oooooooooo
ooooo`Go00000oooool2o`0002Wooooo0ol00004ooooo`;o00001?ooool2o`00013ooooo003ooooo
oa[ooooo003ooooooa[ooooo003ooooooa[ooooo003ooooooa[ooooo000KooooobOo00000_l00?lN
o`0000;o003o00?o0000o`00ool00?l0X_l0000@ooooo`006oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07oooo
o`;o003o2_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooo
oooo003oo`00o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00?o001oooooool007l00oooool00ol0
003oooooooooo`08ooooo`03o`000?l007oooooo00Sooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool07_ooool2o`00o`[ooooo00?o001oooooooooool02?ooool00ol0003o
ooooooooo`06ooooo`;o003o00?oooooo`00ool00?l05?ooool00ol007ooooooooooo`0Dooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo00?o0000o`00Ooooool04oooool2ool001Gooooo00?o001ooooooooo
ool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`00
0?oooooooooo00?ooooo00?o001oooooooooool06_ooool2o`00o`;ooooo0_l00?l:ooooo`03o`00
Oooooooooooo017ooooo0_l00?l00ooooooo003oo`00o`0Dooooo`03o`00Oooooooooooo01Cooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooool007l03_ooool2o`00OaCooooo0_oo000Eooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003ooooooooo
o`03ooooo`03o`00Oooooooooooo01[ooooo0_l00?l2ooooo`;o003o2_ooool00ol007oooooooooo
o`0Aooooo`;o003o00?oooooo`00ool00?l05?ooool00ol007ooooooooooo`0Dooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooo001o00kooooo0_l007lDooooo`;oo`005Oooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool0
0ol007ooooooooooo`0Jooooo`;o003o00Coooooo`00ool00?oo003o2_ooool00ol007oooooooooo
o`0@ooooo`?o003o00?oooooo`00ool00?l05?ooool00ol007ooooooooooo`0Dooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooo001o00kooooo0_l007lDooooo`;oo`005Oooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool0
0ol007ooooooooooo`0Jooooo`;o003o00Coooooo`00ool00?oo003o2_ooool00ol007oooooooooo
o`0?ooooo`?o003o00Coooooool00?oo003o003o5?ooool00ol007ooooooooooo`0Dooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooo001o00kooooo0_l007lDooooo`?oo`005?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00ooo
ool00ol007ooooooooooo`0Jooooo`;o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`?ooooo
00?o001oooooooooool03oooool3o`00o`04ooooool0003o0000o`00oaCooooo00?o001ooooooooo
ool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5?ooool3ool001Cooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`;o0000
1?ooool00ol007ooooooooooo`0Jooooo`;o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`?o
oooo00?o001oooooooooool03oooool3o`00o`Co00005?ooool00ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo0_l007lCooooo`Coo`005?ooool00ol007ooooooooooo`04ooooo`;o
003o0_ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool0
0oooool00ol007ooooooooooo`0Iooooo`Oo003o1Oooool2o`00o`?ooooo00?o001oooooooooool0
3oooool3o`00o`Co00005?ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo
0_l007lCooooo`04ool00?l0003o0000ool001Cooooo00?o001oooooooooool00oooool3o`00o`;o
oooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003ooooo
ooooo`03ooooo`03o`00Oooooooooooo01Wooooo2?l00?l3ooooo`?o003o0oooool00ol007oooooo
ooooo`0?ooooo`;o003o00Koooooool00?l0003o0000ool00?l00?lCooooo`03o`00Oooooooooooo
01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooool007l03_ooool2o`00Oa?ooooo1?l000000ooo003oooooooooo`0Aoooo
o`03o`00Oooooooooooo00?ooooo0ol00?l2ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooo
ooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Iooooo`So
003o0oooool3o`00o`?ooooo00?o001oooooooooool02_ooool2o`00o`;ooooo0ol00?l00ooooooo
o`00ool00003ool001?ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o
001o4oooool4o`000003ool00?oooooooooo00Sooooo0_l00?l7ooooo`03o`00Oooooooooooo00?o
oooo0ol00?l2ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001Cooooo
0ol00004ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool06Oooool8o`00o`?ooooo
0ol00?l3ooooo`03o`00Oooooooooooo00[ooooo0_l00?l2ooooo`;o003o0_ooool2ool00003o`00
Oooo003oo`0001?ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o
4oooool00ooo003o0000o`000003ool000Wooooo0_l00?l7ooooo`03o`00Oooooooooooo00?ooooo
0ol00?l2ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001Gooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00Kooooo0_l0
0?lAooooo`So003o0_ooool4o`00o`?ooooo00?o001oooooooooool02_ooool2o`00o`;ooooo0_l0
0?l2ooooo`;oo`0000?o001oool00?oo00000_oo000Aooooo`03o`00Oooooooooooo01Cooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooool007l03_ooool2o`00Oa?ooooo0_oo00000ol007ooooooool00002ool000Sooooo0_l0
0?l7ooooo`03o`00Oooooooooooo00?ooooo0ol00?l2ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool000cooooo1Ol000000ooooooo0000o`000003o`0000Cooooo00?o0000
ooooooooool00oooool00ol007ooooooooooo`06ooooo`;o003o4Oooool8o`00o`;ooooo1?l00?l3
ooooo`03o`00Oooooooooooo00[ooooo0_l00?l2ooooo`;o003o0_ooool2ool00003o`00Ool00?oo
o`0000?oo`004?ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001o
ooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lC
ooooo`;oo`0000?o001oooooooooool00ooo0007ooooo`;o003o0_ooool2o`00o`?ooooo00?o001o
ooooooooool00oooool3o`00o`;ooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>
ooooo`004_ooool01?l0003oooooooooool00005ooooo`?o00000oooool00ol007ooooooooooo`05
ooooo`?o003o4Oooool8o`00o`;ooooo1?l00?l3ooooo`03o`00Oooooooooooo00Wooooo0ol00?l2
ooooo`;o003o0_ooool2ool00004o`00Ool00?oo003oooooo`Goo`003Oooool00ol007oooooooooo
o`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lCooooo`;oo`0000Co001ooooooooooooooooo
1_oo0002ooooo`?o003o0_ooool2o`00o`04ooooool00?oo003oo`00O`Cooooo1Ol00?l00ooooooo
001oooooo`03ooooo`;o00004?ooool001?ooooo00?o0000ooooool000001Oooool00ol0003ooooo
ooooo`03ooooo`03o`00Oooooooooooo00Gooooo0ol00?lAooooo`So003o0_ooool4o`00o`?ooooo
00?o001oool00?oo00002Oooool3o`00o`;ooooo0_l00?l2ooooo`;oo`0000?o001oo`00ool00?l0
0_ooool8ool000Wooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o
4oooool2ool00003o`3jV_oooooooooo00;ooooo2?oo0002o`00o`05ooooool00?oo003oo`00oooo
ool00_l00?l00ol007ooooooooooo`02ooooo`;o003o00Goooooo`00ool00?ooooooo`00O`05oooo
o`03o`000?oooooooooo00kooooo000Dooooo`;o00001Oooool00ol0003oooooooooo`03ooooo`03
o`00Oooooooooooo00Gooooo0ol00?lAooooo`Go003o00?oooooo`00ool00?l00_ooool4o`00o`;o
oooo3?oo00001Ooooooo003oo`00ool00?oooooo00?o003o00Goooooool00?oo003oo`00o`00O`02
o`00o`Gooooo2ooo0003ooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2
o`00O`oooooo0_l00?l2ooooo`;oo`0000?o0?ZJooooooooool00oooool2o`00o`03oooooooo003o
o`0000Soo`0000Coooooo`00ool00?oo001o1?ooool2o`00o`05ooooool00?oo003oooooool007l0
1Oooool00ol0003oooooooooo`0>ooooo`005Oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00?ooooo00?o001oooooooooool01Oooool3o`00oa3ooooo1_l00?l00ooooooo003oo`00
o`02ooooo`Co003o0_oooolCool000;ooooo0_oo0002o`3jVP;o003o2Oooool:ool00003o`00Oooo
oooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooool007l03_ooool2o`00O`kooooo0ol00?l2ooooo`;oo`0000?o
0?ZJooooooooool00oooool2o`00o`Cooooo2_oo00001?l007ooooooooooooooool7ool00003o`00
Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00ooo
ool00ol007ooooooooooo`05ooooo`?o003o4?ooool2o`00o`05ooooool00?oo003oo`00ooooool0
0_l00?l00ooooooo003oo`00o`04o`00o`03oooooooo003oo`0000;o003o00?oooooo`00ool00?l0
1?ooool<ool000;o0?ZJ0_l00?l?ooooo`Coo`0000?o001oooooooooool05?ooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007oooooo
o`00O`0>ooooo`;o001o3_ooool3o`00o`04oooooooo003oo`00ool000;o0?ZJ1?ooool3o`00o`?o
oooo1_l00?l4ool00003o`00Ooooooooo`0000Soo`0000?o001oooooooooool00oooool00ol0003o
ooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00Gooooo
0ol00?l@ooooo`;o003o0_ooool2o`00o`04ooooool00?oo003oooooo`;o003o0_ooool2o`00o`03
oooooooo003oo`0000Go003o1_ooool5o`00o`Goo`000_l0nYX2o`00oa7ooooo0_oo00000ol007oo
ooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007l>ooooo`?o003o00?oooooool00?oo
00000ol0nYX4ooooo`?o003o0oooool7o`00o`04oooooooo003oo`00o`00O`Coo`000_l00?l01Ooo
oooo003oool00?oo003o001o00Gooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000oooo
ooooool00oooool00ol007ooooooooooo`05ooooo`Co003o3oooool2o`00o`;ooooo0_l00?l01?oo
oooo003oo`00ooooool2o`00o`;ooooo0_l00?l3ool000Go003o1_ooool6o`00o`Cooooo0ol0nYX0
0ol00?ooooooooooo`0?ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>
ooooo`;o001o3_ooool4o`00o`;oo`000ol0nYX4ooooo`?o003o0oooool7o`00o`04oooooooo003o
o`00o`00O`;oo`000_ooool2o`00o`05ooooool00?ooo`00ool00?l007l01Oooool00ol0003ooooo
ooooo`0>ooooo`006oooool2o`0000Cooooo00?o001oooooooooool01?ooool@ool000Cooooo0_l0
0?l2ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l2ooooo`;o003o0_oo0006o`00o`Gooooo
1ol00?l4ooooo`?o0?ZJ0_l00?l@ooooo`;oo`0000?o001oooooooooool05?ooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007oooooo
o`00O`0>ooooo`;o001o3Oooool5o`00o`;oo`001?l0nYX2ooooo`Co003o0oooool7o`00o`03oooo
oooo003oo`0000?oo`0000Koooooo`00ool00?oo003oooooool00?l2ool00003o`00Oooooooooooo
00;ooooo0_l0000@ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00?o
oooo9ooo0006o`00o`03ooooool00?oo003o00;ooooo0_l00?l00ooooooo003oo`00o`02o`00o`Co
oooo0ol0nYX2o`00oa3ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00ko
oooo0_l007l:ooooo`[oo`001?l0nYX2ooooo`Ko003o00?oooooo`00ool00?l01ol00?l3ool000;o
oooo0_l00?l2ooooo`04o`00oooo003oo`00o`00O`Gooooo00?o0000ooooooooool03_ooool001_o
oooo00?o0000ooooooooool00oooool00ol007ooooooooooo`02ooooo`?oo`001?l00?l:oooooaOo
o`001_l00?l00ooooooo003oo`00o`02ooooo`;o003o00Coooooo`00ool00?oo003o1Oooool4o`3j
VP03o`00oooooooooooo00kooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo
00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o
00kooooo0_l007l8ooooo`coo`001?l0nYX2ooooo`Ko003o00?oooooo`00ool00?l00_l00?l2oooo
o`?o003o0ooo0002ooooo`;o003o0_ooool01?l00?ooo`00ool00?l007l5ooooo`03o`000?oooooo
oooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00Co001ooooooooooooooooo0ooo0002
o`00o`03ooooool00?oo003o00oooooo0_l00?l5ooooo`Go003o0_ooool:o`00o`03ooooool00?oo
003o00;ooooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`Go0?ZJ00?o003oooooooooool03_oo
ool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l02oooool3ool000;o001o1ooo
ool4ool000;ooooo0_l00?l00ooooooo003oo`00o`02ooooo`Go0?ZJ00?oooooo`00ool00?l02Ol0
0?l2ooooo`?o003o0_oo0002o`00o`03ooooool00?oo003o00;ooooo00Co003oool00?oo003o001o
1Oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooo
oooooooo00?oo`0000Coooooo`00ool00?oooooo0_l00?l?ooooo`;o003o1_ooool4o`00o`;ooooo
0ol00?l2o`0000So003o0_ooool2o`00o`04ooooool00?oo003oo`00o`Cooooo0_l0nYX01?l007oo
0?ZJo`3jV_l0nYX@ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08oooo
o`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03?ooool2ool00003o`00Oooooooo001o
00[ooooo1?oo0002o`00O`Kooooo0ooo0004ooooo`;o003o00?oooooo`00ool00?l00_ooool2o`3j
VP04ooooool0nY[o0?ZJooooo`So003o00?oooooo`00ool00?l00_ooool7o`00o`03ooooool00?oo
003o00;ooooo00Co003oool00?oo003o001o1Oooool00ol0003oooooooooo`0>ooooo`006oooool0
0ol0003oooooooooo`03ooooo`03o`00Ooooooooo`0000;oo`000_ooool2o`00o`03ooooool00?oo
003o00oooooo0_l00?l6ooooo`Co003o0_ooool2o`00o`Co00000_l00?l00ooooooo003oo`00o`02
o`00o`;ooooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`;o0?ZJ00?o001oooooool0nYX00_l0
nYX?ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool02oooool3ool00003o`00Oooooooo001o00Sooooo1_oo
0002o`00O`Kooooo0_oo0005ooooo`;o003o00?oooooo`00ool00?l00_ooool2o`3jVP04ooooool0
nY[o0?ZJo`3jVP;o003o00?oooooo`00ool00?l00ol00?l5ooooo`Oo003o00?oooooo`00ool00?l0
0_ooool01?l00?ooo`00ool00?oo0005ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`00
0?oooooooooo00?ooooo00Co001ooooooooo003oo`000oooool2o`00o`03ooooool00?oo003o00oo
oooo0_l00?l6ooooo`Co003o0_ooool2o`00o`Co00000oooool4o`00o`;ooooo0_l00?l8ooooo`;o
0?ZJ00?o001oooooool00?l00_l0nYX?ooooo`;oo`0000?o001oooooooooool05?ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02oooool3ool00003
o`00Oooooooo001o00Oooooo1?oo00000oooooooo`00ool00002o`00O`Gooooo0ooo0005ooooo`;o
003o00?oooooo`00ool00?l00_ooool2o`3jVP;ooooo0ol0nYX00ol00?ooooooo`00o`04o`00o`Go
oooo1ol00?l00ooooooo003oo`00o`02ooooo`;o003o0_oo0005ooooo`03o`000?oooooooooo00ko
oooo000Kooooo`03o`000?oooooooooo00?ooooo00Co001oool00?oo003oo`000oooool2o`00o`03
ooooool00?oo003o00kooooo0ol00?l6ooooo`Co003o0_ooool3o`00o`;o000000Co003ooooooooo
oooooooo1?l00?l2ooooo`;o003o2?ooool2o`3jVP03o`00Oooooooo003o00?o0?ZJ3_ooool2ool0
0003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08oooo
o`03o`00Oooooooooooo00[ooooo1?oo00000ol007ooooooo`00O`07ooooo`;oo`000oooool2ool0
00;o001o1Oooool2ool000;o003o1?ooool2o`00o`03ooooool00?oo003o00;ooooo0_l0nYX3oooo
o`?o0?ZJ00?oooooo`00ool00?l00ol00?l5ooooo`[o003o0oooool00ol00?ooo`00ool00005oooo
o`03o`000?oooooooooo00kooooo000Kooooo`;o00001?ooool00ol007ooo`00ool00004ooooo`;o
003o00Coooooo`00ool00?oo003o3Oooool2o`00o`Oooooo1?l00?l2ooooo`Ko003o0oooool5o`00
o`03ooooool00?oo003o00Sooooo00Co0?ZJool00?oo003ooooo0_l00?l5o`3jVP_ooooo0_oo0000
0ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`09ooooo`Goo`0000?o001oooooool007l01_ooool3ool000?ooooo0_oo0002
o`00O`Cooooo0ooo0002o`00o`?ooooo0ol00?l01Ooooooo003oo`00oooooooo0?ZJ00;oo`001?oo
ool4o`3jVP04ooooool00?oo003oo`00o`Gooooo1Ol00?l01?oooooo003oo`00ool00?l4ooooo`03
o`00oooo003oo`0000Cooooo0_l0000@ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00
Oooo003oo`0000Cooooo0_l00?l2ooooo`;o003o3Oooool2o`00o`Oooooo0ol00?l3ooooo`?o003o
0_l0nYX4ooooo`Go003o00?oooooo`00ool00?l02?ooool01?l0nY[oo`00ool00?ooool2o`00o`03
ooooool0nY[o0?ZJ00?o0?ZJ2_ooool2ool00003o`00Oooooooooooo01Cooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Wooooo0_oo00001_oooooo
o`00ool00?l007ooooooo`00O`Kooooo0_oo0004ooooo`;oo`000_l007l4ooooo`;oo`0000?ooooo
o`00ool00?l00oooool2o`00o`;ooooo0ol00?l00ol0nY[oo`00ool00004ooooo`03o`00ool0nY[o
0?ZJ00;o0?ZJ0ol00?l5ooooo`Go003o00Coooooo`00ool00?oo003o1?ooool00ol00?ooo`00ool0
0005ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo0ooo0004
ooooo`;o003o0_ooool3o`00o`cooooo0_l00?l7ooooo`?o003o1?ooool2o`00o`Co0?ZJ0_ooool5
o`00o`03ooooool00?oo003o00Sooooo00Co0?ZJool00?oo003ooooo0ol00?l3ooooo`?o0?ZJ2Ooo
ool2ool00003o`00Oooooooooooo01;ooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool02?ooool3ool00006oooooooo003oo`00o`00Oooooooo
001o1Oooool3ool000Cooooo0_oo0002o`00O`?ooooo0ooo00000ooooooo003oo`00o`03ooooo`;o
003o0_ooool3o`00o`04o`3jV_oo003oo`00ool000?ooooo0_l00?l01?oooooo0?ZJo`3jV_l0nYX2
o`00o`Gooooo0_l00?l01?oooooo003oo`00ooooool3o`00o`Cooooo00?o003oool00?oo00001Ooo
ool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`;oo`001Oooool2
o`00o`?ooooo0ol00?l;ooooo`;o003o1oooool3o`00o`Cooooo0_l00?l7o`3jVPCo003o00?ooooo
o`00ool00?l02?ooool01Ol0nY[oo`00ool00?oo003ooooo00;o003o1?ooool4o`3jVPOooooo0_oo
00000ol007ooooooooooo`0Aooooo`?oo`0000?o001oooooooooool02?ooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00Oooooo0ooo0002ooooo`;oo`0000?o001oooooool007l01Ooo
ool2ool000Gooooo0_oo0002o`00O`?ooooo0_oo0002ooooo`Co003o00?oooooo`00ool00?l00ooo
ool2o`00o`04o`3jV_oo003oo`00ool000?ooooo0_l00?l2ooooo`Co0?ZJ2Oooool00ol007oooooo
ooooo`02o`00o`Cooooo00?o003oool00?oo00001Oooool00ol0003oooooooooo`0>ooooo`006ooo
ool00ol0003oooooooooo`03ooooo`;oo`001Oooool2o`00o`Cooooo0_l00?l;ooooo`;o003o2?oo
ool2o`00o`Kooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3jVPGo003o2?ooool01Ol0nY[oo`00ool0
0?oo003ooooo00?o003o1?ooool4o`3jVPKooooo0_oo00000ol007ooooooooooo`0@ooooo`Coo`00
00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo
0ooo0003ooooo`;oo`0000?o001oooooool007l01?ooool3ool000Gooooo0_oo0002o`00O`;ooooo
0ooo0002ooooo`Co003o00?oooooo`00ool00?l00oooool2o`00o`04o`3jV_oo003oo`00ool000;o
oooo0ol00?l3ooooo`Go0?ZJ1_ooool2o`0000;ooooo0_l00?l4ooooo`03o`00oooo003oo`0000Go
oooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool2ool000Cooooo
0ol00?l4ooooo`;o003o1oooool2o`00o`;ooooo0_l00?l8ooooo`;o003o1_ooool2o`3jVPCooooo
1?l0nYX3o`00o`Wooooo00Go0?ZJool00?oo003oo`00ooooo`03o`00o`Kooooo1Ol0nYX3ooooo`;o
o`0000?o001oooooooooool04?ooool4ool00003o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`06ooooo`;oo`001?ooool2ool00003o`00Oooooooo001o00Co
oooo0_oo0006ooooo`;oo`000_l007l2ooooo`;oo`000oooool4o`00o`03ooooool00?oo003o00?o
oooo0_l00?l00ol0nY[oo`00ool00002ool00003ooooool00?oo003o00Kooooo1_l0nYX2ooooo`Co
00000ol0nYX4ooooo`03o`00oooo003oo`0000Gooooo00?o0000ooooooooool03_ooool001_ooooo
00?o0000ooooooooool00_ooool3ool000Cooooo0_l00?l5ooooo`?o003o1_ooool2o`00o`;ooooo
0_l00?l8ooooo`;o003o1_ooool2o`3jVPCooooo0_l00?l4o`3jVP03o`00oooooooooooo00Kooooo
0_l0nYX4ool000Co003o1_ooool6o`3jVP04oooooooo003oo`00o`00Oa7ooooo1Ooo00000ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool01Oooool3ool00004
ooooool00?oo003oooooo`;oo`0000?o001oooooool007l01?ooool2ool000Kooooo0_oo0002o`00
O`;ooooo0_oo00000ooooooo003oo`00o`07o`00o`?ooooo0_l00?l00ol0nY[oo`00ool00002ool0
0003ooooool00?oo003o00Sooooo1_l0nYX4o`0000Ko0?ZJ00Coooooo`00oooo003oo`001Oooool0
0ol0003oooooooooo`0>ooooo`006oooool2o`0000?ooooo0_oo0005ooooo`;o003o1_ooool2o`00
o`Kooooo0_l00?l2ooooo`;o003o4?ooool2o`3jVPGooooo0_l00?l6o`3jVPKooooo0_l0nYX4ool0
00Co003o2Oooool4o`3jVP;oo`0000?o001oooooooooool03oooool2ool00004oooooooo003oo`00
o`00O`[ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`05ooooo`;oo`000_ooool2
o`00o`06oooooooo003oo`00o`00Oooooooo001o0oooool3ool000Kooooo0_oo0002o`00O`04oooo
oooo003oo`00ool000[o003o0oooool2o`00o`03o`3jV_oo003oo`0000;oo`0000?oooooo`00ool0
0?l02oooool4o`3jVP;o000000?o0?ZJooooooooool01_l0nYX00ol00?oo001oooooo`03ooooo`;o
00004?ooool001_ooooo00?o0000ooooooooool00_ooool2ool000Gooooo0_l00?l6ooooo`;o003o
1_ooool2o`00o`;ooooo0_l00?l@ooooo`;o0?ZJ1Oooool4o`00o`Ko0?ZJ1?ooool2o`3jVPCoo`00
1?l00?l;ooooo`;o0?ZJ0_oo00000ol007ooooooooooo`0?ooooo`;oo`0000Coooooool00?oo003o
001o2_ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Cooooo0ooo0002ooooo`;o
003o00Koooooool00?oo003o001oooooool007l3ooooo`;oo`001oooool2ool000;o001o00?ooooo
ool00?oo00002ol00?l3ooooo`;o003o00?o0?ZJool00?oo00000ooo0002o`00o`gooooo0ol0nYX0
0ol007ooooooooooo`04ooooo`Co0?ZJ00?o001oooooooooool00oooool00ol0003oooooooooo`0>
ooooo`006oooool00ol0003oooooooooo`02ooooo`;oo`001Oooool2o`00o`Kooooo0ol00?l5oooo
o`Ko003o4?ooool2o`3jVPGooooo1_l00?l00ooooooo0?ZJo`3jVP03o`3jVP;ooooo00?o0?ZJool0
0?oo00001?oo0003o`00o`gooooo0_oo00000ol007ooooooooooo`0>ooooo`?oo`0000Coooooool0
0?oo003o001o2_ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Cooooo0_oo0003
ooooo`;o003o00Koooooool00?oo003oo`00ooooool007l3ooooo`;oo`001oooool2ool000;o001o
0ooo000:o`00o`Cooooo0_l00?l01?l0nY[oo`00ool00?ooool2ool000;o003o4?ooool00ol007oo
ooooooooo`06ooooo`;o0?ZJ00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
6oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00?ooooo0_l00?l7ooooo`;o003o
1?ooool6o`00oa7ooooo0_l0nYX7ooooo`Co003o0oooool6o`3jVP;oo`0000Go001ooooooooo003o
o`00ooooo`03o`00o`cooooo0_oo00000ol007ooooooooooo`0>ooooo`;oo`000_ooool2ool00003
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`04ooooo`;o
o`000oooool3o`00o`05oooooooo003oo`00ooooool007l00_ooool3ool000Oooooo0_oo0002o`00
O`;oo`0000?oooooo`00ool00?l02?l00?l6ooooo`04o`3jV_oo003oo`00ooooo`;oo`000_l00?l@
ooooo`03o`00Oooooooooooo00Kooooo0_l0nYX00ol00?ooooooooooo`03ooooo`03o`000?oooooo
oooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool00oooool2o`00
o`Oooooo0_l00?l4ooooo`Ko003o4Oooool2o`3jVPOooooo1?l00?l5ooooo`Co0?ZJ0_oo00000ol0
07ooooooool00002ool00003ooooool00?oo003o00cooooo0_oo00000ol007ooooooooooo`0=oooo
o`?oo`000_ooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`?oo`000oooool3o`00o`03oooooooo003oo`0000;o003o0_ooool2ool0
00Sooooo0_oo0002o`00O`;oo`0000Coooooo`00ool00?oooooo0_l00?l3ooooo`;o003o1_ooool0
1?l0nY[oo`00ool00?ooool3ool0017ooooo00?o001oooooooooool01_ooool2o`3jVP03o`00oooo
oooooooo00?ooooo00?o0000ooooooooool03_ooool001;ooooo1Ol00004ooooo`03o`000?oooooo
oooo00?ooooo00?o001oooooooooool00oooool2o`00o`Oooooo0_l00?l4ooooo`Ko003o4Oooool2
o`3jVPSooooo0ol00?l7ooooo`;o0?ZJ0_oo00000ol007ooooooooooo`02ool00003ooooool00?oo
003o00cooooo0_oo00000ol007ooooooooooo`0=ooooo`;oo`000oooool2ool00003o`00Oooooooo
oooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`;oo`000oooool4
o`00o`03oooooooo003oo`0000;o003o0_ooool2ool000;ooooo0_l00?l4ooooo`;oo`000_l00002
ool00004ooooool00?oo003oooooo`;o003o0oooool2o`00o`Kooooo00?o0?ZJool00?oo00000_l0
0?l3ool0013ooooo00?o001oooooooooool01_ooool2o`3jVP03o`00oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001?ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooooooo
o`03ooooo`03o`00Oooooooooooo00?ooooo0_l00?l7ooooo`;o003o1?ooool4o`00oa?ooooo0_l0
nYX8ooooo`?o003o2Oooool2ool00003o`00Oooooooooooo00?oo`000_l00?l<ooooo`;oo`0000?o
001oooooooooool03Oooool2ool000?ooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00oooool2ool000?ooooo1?l00?l00oooooooo`00ool0
0002o`00o`;ooooo0_oo0002ooooo`;o003o1?ooool00ooo003o0000o`000002o`000005o`00oooo
oooo003oo`00ooooool00_l00?l;ooooo`03o`3jV_oo003oo`0000?o003o0_oo000@ooooo`03o`00
Oooooooooooo00Kooooo0ol0nYX5ooooo`03o`000?oooooooooo00kooooo000<ooooo`Go00000ooo
ool00ol0003oooooooooo`04ooooo`?o00000oooool00ol007ooooooooooo`02ooooo`?o003o1ooo
ool3o`00o`?ooooo1?l00?lCooooo`;o0?ZJ2?ooool3o`00o`Wooooo0_oo00001?l007oooooooooo
ooooool3ool00003o`00oooooooooooo00[ooooo0_oo00000ol007ooooooooooo`0<ooooo`?oo`00
0oooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`02ooooo`?oo`000oooool4o`00o`03oooooooo003oo`0000;o003o00Coooooool00?oo003o
o`001?l00?l4ooooo`03ool00?l0003o000000;o00001?l00?l00ooooooo003oo`00o`0;ooooo`03
o`3jV_oo003oo`0000;o003o00Coooooool00?oo003oo`003oooool00ol007ooooooooooo`07oooo
o`;o0?ZJ1?ooool2o`00013ooooo000Eooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol007ooooooooooo`02ooooo`;o003o2Oooool2o`00o`?ooooo0_l00?lEooooo`;o
o`002?ooool2o`00o`[ooooo0_oo00000ol007ooooooooooo`02ooooo`?oo`003?ooool2ool00003
o`00Oooooooooooo00cooooo0_oo0004ooooo`;oo`0000?o001oooooooooool02?ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_oo0004ooooo`Co003o00?oooooool00?oo
00000ol00?l2ool00003ooooool00?oo003o00;o003o1?ooool2ool000;o000000Coo`00o`00ool0
0?oo003o3oooool00ol0nY[oo`00ool00002o`00o`;ooooo0ooo000>ooooo`03o`00Oooooooooooo
00Oooooo0_l0nYX5ooooo`03o`000?oooooooooo00kooooo000Booooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00;ooooo0_l00?l9oooo
o`;o003o00?oooooo`00ool00?l00_l00?lEooooo`;oo`002?ooool2o`00o`[ooooo0_oo00000ol0
07ooooooooooo`03ooooo`?oo`002oooool2ool00003o`00Oooooooooooo00cooooo0_oo0004oooo
o`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00;ooooo0_oo0004ooooo`Co003o00Coooooool00?oo003oo`000_l00?l2ool00003ooooool00?oo
003o00;o003o1?ooool5ool000?o003o3oooool00ol0nY[oo`00ool00002o`00o`?ooooo0ooo000=
ooooo`03o`00Oooooooooooo00Oooooo0_l0nYX5ooooo`03o`000?oooooooooo00kooooo000Boooo
o`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`03ooooo`03o`00Oooooooo
oooo00;ooooo0_l00?l9ooooo`;o003o00?oooooo`00ool00?l00_l00?lEooooo`?oo`004oooool2
ool00003o`00Oooooooooooo00?ooooo00Co003oool00?oo003oo`002_ooool2ool00003o`00Oooo
oooooooo00_ooooo0ooo0004ooooo`;oo`0000?o001oooooooooool02?ooool00ol007oooooooooo
o`08ooooo`04o`00Ooooooooooooooooo`?oo`001?ooool5o`00o`?oo`000_l00?l2ool000Go003o
1?ooool4ool000Co003o3oooool00ol0nY[oo`00ool00002o`00o`Cooooo0ooo000<ooooo`03o`00
Oooooooooooo00Oooooo0_l0nYX5ooooo`03o`000?oooooooooo00kooooo000Cooooo`?o00001Ooo
ool00ol0003oooooooooo`02ooooo`;o00001?ooool2o`00o`Wooooo1ol00?lEooooo`Coo`004_oo
ool2ool00003o`00Oooooooooooo00Cooooo00Co003oool00?oo003oo`002Oooool2ool00003o`00
Oooooooooooo00_ooooo0_oo0005ooooo`;oo`0000?o001oooooooooool02?ooool00ol007oooooo
ooooo`08ooooo`04o`00Ooooooooooooooooo`;oo`001Oooool2o`00o`03ooooool00?oo003o00?o
o`0000Co003oool00?oo003oo`001Ol00?l4ooooo`Coo`001?l00?l?ooooo`04o`3jV_oo003oo`00
o`00o`Kooooo0ooo000:ooooo`;oo`002Oooool2o`3jVPGooooo00?o0000ooooooooool03_ooool0
01_ooooo00Co0000oooooooooooooooo1?l00006o`3jVPSooooo1_l00?lFooooo`Koo`004?ooool2
ool00003o`00Oooooooooooo00Cooooo0_l00?l3ool000Sooooo0ooo000=ooooo`;oo`001Oooool2
ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool01?l007oooooooooooooo
ool2ool000Cooooo0ol00?l00ooooooo003oo`00o`03ool00004o`00oooo003oo`00ooooo`;o003o
00Coooooo`00ool00?oo003o1?ooool3ool000Co003o3oooool00ol0nY[oo`00ool00008ooooo`?o
o`002Oooool2ool000[ooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
6oooool01?l0003oooooooooooooool4o`0000Oo0?ZJ1oooool6o`00oaKooooo0_oo00000ooooooo
o`00ool00002ool000oooooo0_oo00000ol007ooooooooooo`04ooooo`;o003o00Coooooool00?oo
003oo`001oooool00ol0nY[oo`00ool0000<ooooo`?oo`001Oooool2ool00003o`00Oooooooooooo
00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ool000;ooooo1?l00?l2oooo
o`;o003o1_oo00000ooooooo003oo`00o`02ooooo`;o003o1?ooool3ool00004o`00oooooooo003o
o`00o`oooooo00?o0?ZJool00?oo00002Oooool3ool000Sooooo0ooo0009ooooo`03o`00Oooooooo
oooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo0_l00003ooooo`;o00000_l0nYX2oooo
o`;o003o0ol0nYX6ooooo`Ko003o5_ooool2ool000?ooooo0ooo000>ooooo`;oo`0000?o001ooooo
ooooool01?ooool4o`00o`?oo`001_ooool00ol0nY[oo`00ool0000<ooooo`;oo`001_ooool2ool0
0003o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool2o`00o`03oooooooo003oo`00
00?ooooo1?l00?l2ooooo`;o003o1_oo00000ooooooo003oo`00o`02ooooo`;o003o1?ooool3ool0
0004o`00oooooooo003oo`00o`oooooo00?o0?ZJool00?oo00002_ooool3ool000Oooooo1Ooo0007
ooooo`;o00000oooool2o`00013ooooo000Kooooo`03o`000?oooooooooo00;ooooo0_l0nYX4oooo
o`;o003o00Coooooo`3jV_l0nY[o0?ZJ1Oooool6o`00oaKooooo0_oo0004ooooo`?oo`003Oooool2
ool00003o`00Oooooooooooo00Cooooo1?l00?l01?ooooooo`00ool00?oo0005ooooo`03o`3jV_oo
003oo`0000cooooo0_oo0006ooooo`;oo`0000?o001oooooooooool02?ooool00ol007oooooooooo
o`08ooooo`;o003o00?oooooool00?oo00000oooool4o`00o`;ooooo1?l00?l3ool00004o`00oooo
oooo003oo`00o`;ooooo0_l00?l4ooooo`?oo`0000?o003oooooooooool04?ooool3ool000_ooooo
0ooo0006ooooo`Koo`001Oooool4o`0000?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o
0000ooooooooool00oooool00ol007ooooooooooo`02ooooo`;o003o0_ooool3o`3jVPCooooo1?l0
0?lGooooo`03o`3jV_oo003oo`0000Gooooo0ooo000<ooooo`;oo`0000?o001oooooooooool01Ooo
ool3o`00o`;ooooo1?oo0003ooooo`03o`3jV_oo003oo`0000_ooooo0ooo0006ooooo`;oo`0000?o
001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`;o003o0ooo0003ooooo`?o003o0ooo
ool4o`00o`?oo`0000Co003oooooool00?oo003o0_ooool2o`00o`Cooooo0ooo00000ol00?oooooo
ooooo`0@ooooo`;oo`0000?o001oooooooooool02_ooool3ool000Cooooo0ooo0002ooooo`?oo`00
1?ooool4o`0000?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00ooo
ool00ol007ooooooooooo`02ooooo`;o003o0oooool4o`3jVP?ooooo0ol00?lGooooo`03o`3jV_oo
003oo`0000Kooooo0ooo000;ooooo`;oo`0000?o001oooooooooool01Oooool3o`00o`?ooooo1?oo
0002ooooo`03o`3jV_oo003oo`0000_ooooo0_oo0007ooooo`;oo`0000?o001oooooooooool02?oo
ool00ol007ooooooooooo`08ooooo`;o003o0_oo0004ooooo`?o003o0oooool4o`00o`;oo`000_l0
0?l00ooooooo003oo`00o`02ooooo`;o003o1?ooool3ool00003o`00oooooooooooo013ooooo0_oo
00000ol007ooooooooooo`0;ooooo`Goo`0000Coooooool00?oo003o001o0oooool3ool000Cooooo
0_l00004ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o
001oooooooooool00_ooool2o`00o`Cooooo1?l0nYX2ooooo`;o003o6?ooool00ol0nY[oo`00ool0
0007ooooo`Coo`002Oooool2ool00003o`00Oooooooooooo00Kooooo0_l00?l5ooooo`?oo`0000Co
ooooo`3jV_oo003oo`002_ooool3ool000Oooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00Sooooo00Co003oool00?oo003oo`001?ooool2o`00o`Cooooo1Ol00?l01?l007oo
003oo`00ooooool2o`00o`;ooooo0_l00?l4ooooo`?oo`0000?o003oooooooooool04?ooool2ool0
0003o`00Oooooooooooo00cooooo1ooo00000ol007ooooooooooo`02ooooo`?oo`000oooool00ol0
07ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o001oooooooooool00_ooool2o`00o`Kooooo0ol0nYX00ooooooo003oo`00o`0Hooooo`03
o`3jV_oo003oo`0000Sooooo1Ooo0006ooooo`?oo`0000?o001oooooooooool01_ooool2o`00o`Ko
oooo1_oo0009ooooo`?oo`002?ooool2ool00003o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool02?ooool00ol00?ooo`00ool00005ooooo`;o003o1?ooool5o`00o`04o`00Ool00?oo003ooooo
o`;o003o0_ooool3o`00o`?ooooo0ooo00000ol00?ooooooooooo`03o`3jVPgooooo0_oo00000ol0
07ooooooooooo`0?ooooo`Coo`0000?o001oooooooooool00oooool3ool000;ooooo00?o001ooooo
ooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`04
o`00Ooooooooooooooooo`?o003o1oooool2o`3jVP03ooooool00?oo003o01Sooooo00?o0?ZJool0
0?oo00002_ooool4ool000Gooooo0_oo00000ooooooo001oooooo`07ooooo`;o003o1oooool5ool0
00Wooooo0_oo0009ooooo`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`08oooo
o`?oo`001?ooool3o`00o`Cooooo1?l00?l00ooooooo001oo`00o`04o`00o`?ooooo0_l00?l3oooo
o`?oo`002?l0nYX:ooooo`04o`3jV_oo003oo`00o`00Oa;ooooo0ooo00000ol007ooooooooooo`04
ooooo`Coo`0000?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0
003oooooooooo`03ooooo`04o`00Ooooooooooooooooo`;o003o2?ooool3o`3jVP;o003o6?ooool0
0ol0nY[oo`00ool0000<ooooo`?oo`001?ooool2ool00003ooooool007oooooo00Oooooo0ol00?l8
ooooo`?oo`002?ooool3ool000Wooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00Oooooo00?o003oool00?oo00000_l00?l3ooooo`;o003o1Oooool3o`00o`03o`00Oooooooo
001o00Co003o1?ooool2o`00o`?ooooo0ooo0004o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2Oooool0
1?l0nY[oo`00ool00?l007lCooooo`;oo`0000?o001oooooooooool01Oooool3ool00003o`00Oooo
oooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo0_l00004ooooo`04o`00Oooooooo
ooooooooo`;o003o2Oooool3o`3jVQWooooo00?o0?ZJool00?oo00003Oooool3ool000?ooooo0_oo
00000ooooooo001oooooo`08ooooo`;o003o2?ooool3ool000Sooooo0_oo000:ooooo`;oo`0000?o
001oooooooooool02?ooool00ol007ooooooooooo`07ooooo`03o`00oooo003oo`0000;o003o0ooo
ool2o`00o`Kooooo0_l00?l00ol007ooooooo`00O`04o`00o`Cooooo0ol00?l2ooooo`?oo`0000?o
0?ZJooooooooool01?ooool3o`3jVPSooooo00Co0?ZJool00?oo003o001o5Oooool00ol007oooooo
ooooo`06ooooo`?oo`001?ooool2o`00013ooooo000Kooooo`03o`000?oooooooooo00?ooooo00Co
001ooooooooooooooooo0_l00?l:ooooo`;o0?ZJ6Oooool00ol0nY[oo`00ool0000>ooooo`?oo`00
0_ooool2ool00003ooooool007oooooo00Sooooo0_l00?l8ooooo`?oo`002?ooool2ool000[ooooo
0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Oooooo00?o003oool00?oo0000
0_l00?l3ooooo`;o003o1_ooool2o`00o`03o`00Oooooooo001o00Co003o1Oooool2o`00o`;ooooo
0_oo00000ol0nY[oooooooooo`06ooooo`Co0?ZJ1_ooool01?l0nY[oo`00ool00?l007lEooooo`03
o`00Oooooooooooo00Oooooo0_oo0005ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`00
0?oooooooooo00?ooooo00Co001ooooooooooooooooo0_l00?l:ooooo`?o0?ZJ6?ooool00ol0nY[o
o`00ool0000?ooooo`?oo`0000Goooooool00?oo003oooooo`00O`09ooooo`;o003o2?ooool3ool0
00Oooooo0ooo000:ooooo`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`07oooo
o`?oo`000_l00?l3ooooo`;o003o1_ooool2o`00o`04o`00Oooooooo001oooooo`?o003o1Oooool2
o`00o`;ooooo0_oo00000ol0nY[oooooooooo`07ooooo`Co0?ZJ1Oooool01?l0nY[oo`00ool00?l0
07lEooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003ooooooooo
o`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`04o`00Ool00?oo003oooooo`;o003o2ooo
ool3o`3jVQOooooo00?o0?ZJool00?oo00004?ooool5ool00003ooooool007oooooo00Sooooo0_l0
0?l8ooooo`?oo`001oooool2ool000_ooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00Oooooo0_l000000ooooooo003oo`00o`03ooooo`;o003o1_ooool01_l00?oo0000o`00
0?oooooo001oooooo`?o003o1Oooool2o`00o`;ooooo0_oo00000ol0nY[oooooooooo`09ooooo`?o
0?ZJ1?ooool01?l0nY[oo`00ool00?l007lEooooo`03o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03
o`00Ool00?oo003o00?o003o3?ooool2o`3jVQOooooo00?o0?ZJool00?oo00004Oooool4ool00003
ooooool007oooooo00Sooooo0_l00?l8ooooo`?oo`001_ooool3ool000_ooooo0_oo00000ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo1?l00002o`00o`?ooooo0_l00?l6ooooo`Co
000000?o001oooooool00?l00_l00?l5ooooo`;o003o0_ooool2ool00003o`3jV_oooooooooo00[o
oooo0_l0nYX4ooooo`04o`3jV_oo003oo`00o`00OaGooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o001oo`00ool00?l00ol00?l<ooooo`?o0?ZJ5_ooool00ol0nY[oo`00ool0000Cooooo`;o
o`0000?oooooo`00Ooooool02?ooool2o`00o`Sooooo0ooo0006ooooo`;oo`003?ooool2ool00003
o`00Oooooooooooo00Sooooo00?o001oooooooooool01_ooool4o`0000?o003o0_ooool2o`00o`Ko
oooo1?l000000ol007ooooooo`3jVP06o`3jVP03ooooool00?oo003o00;o003o0_oo00000ol0nY[o
ooooooooo`0:ooooo`?o0?ZJ0oooool01?l0nY[oo`00ool00?l007lEooooo`03o`00Oooooooooooo
00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003o
ooooooooo`02ooooo`;oo`000_l00?l00ooooooo003oo`00o`0=ooooo`?o0?ZJ5Oooool00ol0nY[o
o`00ool0000Fooooo`03o`00Oooooooooooo00Oooooo0_l00?l8ooooo`?oo`001_ooool2ool000co
oooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Oooooo0_l00002ooooo`Ko
003o1_ooool01?l00?oo0000o`000?l0nYX2o`0000Wo0?ZJ0ol00?l2ool00003o`3jV_oooooooooo
00_ooooo0ol0nYX2ooooo`04o`3jV_oo003oo`00o`00OaGooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`;o00000oooool2ool0
00;o003o4Oooool3o`3jVQCooooo00?o0?ZJool00?oo00005_ooool00ol007ooooooooooo`07oooo
o`;o003o2?ooool3ool000Gooooo0ooo000<ooooo`;oo`0000?o001oooooooooool02?ooool00ol0
07ooooooooooo`07ooooo`;oo`000_ooool6o`00o`Oooooo0_l0nYX4o`0000Gooooo1Ol0nYX01?l0
0?ooo`00ool00?l0nYX>ooooo`?o0?ZJ00Goooooo`3jV_oo003oo`00o`00O`0Eooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00_ooool2o`00013ooooo000Kooooo`03o`000?oooooo
oooo00;ooooo0ooo00000ol00?ooooooooooo`0@ooooo`?o0?ZJ4oooool00ol0nY[oo`00ool0000F
ooooo`03o`00Oooooooooooo00Oooooo0_l00?l8ooooo`?oo`001Oooool2ool000gooooo0_oo0000
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Oooooo0_oo0002ooooo`Go003o2?ooool2
o`3jVPCo00001oooool4o`3jVP;oo`0000?o0?ZJooooooooool03Oooool2o`3jVP05ooooool0nY[o
o`00ool00?l007l05Oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00_ooool00ol00?ooo`00ool0000D
ooooo`?o0?ZJ4_ooool00ol0nY[oo`00ool0000Fooooo`03o`00Oooooooooooo00Oooooo0_l00?l8
ooooo`?oo`001?ooool3ool000gooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00Oooooo0_oo0002ooooo`Go003o2?ooool2o`3jVP03ooooool0003o000000[ooooo0_l0nYX2
ool00003o`3jV_oooooooooo00gooooo1?l0nYX2ool00003o`00Oooooooooooo01?ooooo00?o001o
ooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Koooo
o`03o`000?oooooooooo00;ooooo00Co003oool00?oo003oo`005?ooool3o`3jVQ7ooooo00?o0?ZJ
ool00?oo00005_ooool00ol007ooooooooooo`07ooooo`?o003o1oooool3ool000Cooooo0_oo000>
ooooo`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`07ooooo`;oo`000_ooool5
o`00o`Sooooo0_l0nYX00ooooooo001oooooo`0:ooooo`05o`00ool0nY[oo`00ool00?l0nYX04?oo
ool3o`3jVP;oo`0000?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool0
0ol00?ooo`00ool0000Eooooo`Co0?ZJ3oooool00ol0nY[oo`00ool0000Fooooo`03o`00Oooooooo
oooo00Sooooo0_l00?l7ooooo`?oo`000oooool3ool000kooooo0_oo00000ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00Kooooo00?o003oool00?oo00000_ooool5o`00o`Oooooo0ol0nYX0
0ooooooo001oooooo`0:ooooo`05o`00ool0nY[oo`00ool00?l0nYX04Oooool2o`3jVP;oo`0000?o
001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001Cooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o003o
ool00?oo00000_oo000Dooooo`Co0?ZJ3_ooool00ol0nY[oo`00ool0000Fooooo`03o`00Oooooooo
oooo00Sooooo0_l00?l7ooooo`?oo`000oooool2ool000oooooo0_oo00000ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00Kooooo00?o003oool00?oo00000_ooool4o`00o`Sooooo0_l0nYX0
0ol007ooooooo`00O`0;ooooo`03o`00ool0nY[o0?ZJ00;oo`004_ooool01?l0nY[oo`00ool00?l0
07lEooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003ooooooooo
o`0>ooooo`004oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00?ooooo0_l0
0?l4ool001Gooooo1_l0nYX:ooooo`03o`3jV_oo003oo`0001Kooooo00?o001oooooooooool02?oo
ool2o`00o`Oooooo0ooo0002ooooo`?oo`003oooool2ool00003o`00Oooooooooooo00Sooooo00?o
001oooooooooool01_ooool00ol00?ooo`00ool00002ooooo`Co003o2?ooool2o`3jVP03o`00Oooo
oooo001o00cooooo0_l0nYX2ool001?ooooo0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`004oooool0
1?l0003oooooooooool00004ooooo`?o00000oooool01?l007ooooooooooooooool2ool001Kooooo
4?l0nYX2ool001Kooooo00?o001oooooooooool02?ooool2o`00o`Oooooo0ooo00001?ooooooo`00
ool00?oo000@ooooo`?oo`002_ooool00ol007ooooooooooo`06ooooo`?oo`000_ooool4o`00o`So
oooo0_l0nYX00ol007ooooooo`00O`0<ooooo`;o0?ZJ0ooo000Booooo`;oo`0000?o001ooooooooo
ool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0000@ooooo`00
4oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00?ooooo00Co001ooooooooo
oooooooo0ooo000Iooooo`co0?ZJ0_oo000Fooooo`03o`00Oooooooooooo00Sooooo0_l00?l7oooo
o`Koo`004_ooool2ool000[ooooo00?o001oooooooooool01_ooool2ool00004o`00Oooooooooooo
ooooo`;o003o1?ooool7o`3jVP03o`00Oooooooo001o00cooooo0_l0nYX3ool001;ooooo0_oo0000
0ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`004oooool01?l0003oooooooooool00004ooooo`03o`000?oooooo
oooo00?ooooo00?o001oooooooooool00_ooool2ool002Gooooo0_oo000Fooooo`03o`00Oooooooo
oooo00Sooooo0_l00?l7ooooo`Goo`004oooool2ool000[ooooo00?o001oooooooooool01_ooool2
ool0017o0?ZJ00?o001oooooool007l03?ooool2o`3jVPCoo`004Oooool2ool00003o`00Oooooooo
oooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooo
oooo00kooooo000Cooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00oooool0
0ol007ooooooooooo`02ooooo`?oo`009?ooool2ool001Kooooo00?o001oooooooooool02?ooool2
o`00o`Oooooo1Ooo000Cooooo`;oo`002_ooool00ol007ooooooooooo`06ooooo`;oo`002ol0nYX6
ooooo`03o`00Oooooooo001o00cooooo0_l0nYX4ool0017ooooo0_oo00000ol007ooooooooooo`0C
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>
ooooo`005?ooool2o`0000Gooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`03oooo
o`;oo`009?ooool2ool001Kooooo00?o001oooooooooool02?ooool2o`00o`Oooooo1?oo000Doooo
o`;oo`002_ooool00ol007ooooooooooo`06ooooo`;oo`0000Co0?ZJoooooooooooooooo0_l00?l;
ooooo`03o`00Oooo003oo`0000cooooo00?o003oo`3jV_oo00001?oo000@ooooo`;oo`0000?o001o
ooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000
ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`03oooo
o`?oo`008oooool2ool001Kooooo00?o001oooooooooool02?ooool2o`00o`Oooooo1?oo000Boooo
o`;o0?ZJ0_oo000:ooooo`03o`00Oooooooooooo00Kooooo0_oo00001?l0nY[oooooooooooooool2
o`00o`[ooooo1?oo000<ooooo`05o`00ool0nY[oo`00ool00?ooool00ooo000?ooooo`;oo`0000?o
001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`04
ooooo`;oo`008oooool2ool001Kooooo00?o001oooooooooool02?ooool2o`00o`Oooooo0ooo000B
ooooo`?o0?ZJ0_oo000:ooooo`03o`00Oooooooooooo00Kooooo0_oo00001?l0nY[ooooooooooooo
ool2o`00o`[ooooo1Ooo000<ooooo`03o`3jV_oo003oo`0000;ooooo0_oo000?ooooo`;oo`0000?o
001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`04
ooooo`?oo`008_ooool2ool001Kooooo00?o001oooooooooool02?ooool3o`00o`Kooooo0ooo000A
ooooo`Co0?ZJ0_oo000:ooooo`03o`00Oooooooooooo00Kooooo0_oo00001?l0nY[ooooooooooooo
ool2o`00o`[ooooo1Ooo000<ooooo`03o`3jV_oo003oo`0000;ooooo0ooo000>ooooo`;oo`0000?o
001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001_ooooo0_l00004ooooo`03o`00Oooooooooooo00Gooooo0_oo000R
ooooo`;oo`005_ooool00ol007ooooooooooo`09ooooo`;o003o1oooool2ool0017ooooo0_l0nYX0
1?oooooo0?ZJool00?oo000:ooooo`03o`00Oooooooooooo00Cooooo0_l00?l2ool00003o`3jV_oo
oooooooo00gooooo1_oo000;ooooo`03o`3jV_oo003oo`0000?ooooo0_oo000>ooooo`;oo`0000?o
001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0
000@ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00Gooooo0ooo000Q
ooooo`;oo`005_ooool00ol007ooooooooooo`09ooooo`;o003o1oooool2ool0013ooooo0ol0nYX0
1?oooooo0?ZJool00?oo000:ooooo`03o`00Oooooooooooo00Cooooo0_l00?l2ool00003o`3jV_oo
oooooooo00gooooo0ooo00000ol007ooo`00ool0000;ooooo`03o`3jV_oo003oo`0000?ooooo0_oo
000>ooooo`;oo`0000?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool0
0ol007ooooooooooo`06ooooo`;oo`008Oooool2ool001Kooooo00?o001oooooooooool02Oooool2
o`00o`Oooooo0_oo000?ooooo`?o0?ZJ0_ooool00ol0nY[oo`00ool0000:ooooo`03o`00Oooooooo
oooo00Cooooo00Go003oool00?oo003oo`00o`3jVP0?ooooo`;oo`0000?oooooo`00Oooo00000_oo
000:ooooo`;o000000Coo`00oooooooooooooooo0ooo000=ooooo`;oo`0000?o001oooooooooool0
4oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool0
3_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`06ooooo`?oo`008?oo
ool2ool001Kooooo00?o001oooooooooool02Oooool2o`00o`Oooooo0_oo000?ooooo`;o0?ZJ0ooo
ool00ol0nY[oo`00ool0000:ooooo`03o`00Oooooooooooo00Cooooo0ooo0002o`3jVPoooooo0_oo
00000ooooooo001oooooo`02ool000Wooooo1?l00004ooooo`;oo`003Oooool2ool00003o`00Oooo
oooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool01oooool2
ool001oooooo0ooo000Fooooo`03o`00Oooooooooooo00Wooooo0_l00?l7ooooo`;oo`003_ooool3
o`3jVP?ooooo00?o0?ZJool00?oo00002_ooool00ol007ooooooooooo`03ooooo`?oo`0000?o003o
o`3jV_l0nYX03oooool2ool00003ooooool007oooooo00;oo`002Oooool4o`0000Cooooo0ooo000<
ooooo`;oo`0000?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol0
07ooooooooooo`07ooooo`?oo`007_ooool2ool00003o`00Oooooooooooo01Cooooo00?o001ooooo
ooooool02Oooool2o`00o`Oooooo0_oo000=ooooo`?o0?ZJ1?ooool00ol0nY[oo`00ool0000:oooo
o`04o`00Ooooooooooooooooo`Coo`000_l00?l2o`3jVPoooooo0_oo00000ooooooo001oooooo`03
ool000Wooooo0_l000000ol007ooooooooooo`03ooooo`;oo`003?ooool2ool00003o`00Oooooooo
oooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooo
oooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool02?ooool2ool0
01kooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Wooooo0_l00?l7oooo
o`;oo`003?ooool3o`3jVPGooooo00?o0?ZJool00?oo00002_ooool00ol007ooooooooooo`04ool0
00;o003o00?oooooool00?oo00003oooool2ool00004ooooool007ooooooooooo`;oo`002Oooool2
ool00003o`00Oooooooooooo00?ooooo0ooo000;ooooo`;oo`0000?o001oooooooooool04oooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool0
01_ooooo0_l00004ooooo`03o`00Oooooooooooo00Sooooo0ooo000Mooooo`;oo`0000?o001ooooo
ooooool05?ooool00ol007ooooooooooo`09ooooo`?o003o1_ooool2ool000cooooo0_l0nYX6oooo
o`03o`3jV_oo003oo`0000[ooooo00?o001ooooooooo00000_oo00001Ooooooo003oo`00ool00?oo
oooo00;oo`003oooool2ool00004ooooool007ooooooooooo`;oo`002Oooool2ool00003o`00Oooo
oooooooo00Cooooo0_oo000;ooooo`;oo`0000?o001oooooooooool04oooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00;ooooo0_l0000@ooooo`006oooool00ol0003oooooooooo`03
ooooo`03o`00Oooooooooooo00Wooooo0ooo000Looooo`;oo`0000?o001oooooooooool05?ooool0
0ol007ooooooooooo`0:ooooo`;o003o1_ooool2ool000[ooooo1?l0nYX6ooooo`03o`3jV_oo003o
o`0000[ooooo00Co001oool00?oo003oo`000_ooool2o`00o`;ooooo0_oo000?ooooo`;oo`0000Co
ooooo`00Oooooooooooo0ooo0008ooooo`;oo`0000?o001oooooooooool01?ooool2ool000_ooooo
0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooo
oooooooo00[ooooo0_oo000Looooo`;oo`0000?o001oooooooooool05?ooool00ol007oooooooooo
o`0:ooooo`?o003o1Oooool2ool000Wooooo1?l0nYX7ooooo`03o`3jV_oo003oo`0000[ooooo00?o
001oool00?oo00000oooool2o`00o`;ooooo0ooo000>ooooo`;oo`0000?oooooo`00Ooooool00_oo
ool2ool000Sooooo0_oo00000ol007ooooooooooo`04ooooo`?oo`002_ooool2ool00003o`00Oooo
oooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool02_ooool3
ool001_ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00[ooooo0ol00?l5
ooooo`;oo`002?ooool3o`3jVPWooooo00?o0?ZJool00?oo00002_ooool3ool000?ooooo0_l00?l0
0ooooooo0?ZJool00002ool000kooooo0_oo00000ooooooo001oooooo`02ooooo`;oo`002?ooool2
ool00003o`00Oooooooooooo00Gooooo0_oo000:ooooo`;oo`0000?o001oooooooooool04oooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool0
01_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0;ooooo`;oo`006oooool2ool0
0003o`00Oooooooooooo01Cooooo00?o001oooooooooool02oooool2o`00o`Gooooo0_oo00000ol0
nY[oooooooooo`04ooooo`?o0?ZJ2_ooool00ol0nY[oo`00ool0000:ooooo`;oo`001?ooool2o`00
o`03ooooool0nY[oo`0000;oo`003_ooool2ool00003ooooool007oooooo00;ooooo0ooo0007oooo
o`;oo`0000?o001oooooooooool01Oooool2ool000[ooooo0_oo00000ol007ooooooooooo`0Coooo
o`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>oooo
o`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00_ooooo0ooo000Jooooo`;o
o`0000?o001oooooooooool05?ooool00ol007ooooooooooo`0;ooooo`;o003o1Oooool2ool000Co
0?ZJ00?oooooo`3jV_l0nYX00_l0nYX;ooooo`03o`3jV_oo003oo`0000Wooooo0ooo0004ooooo`;o
003o00?oooooo`3jV_oo00000_oo000>ooooo`;oo`0000?oooooo`00Ooooool00oooool2ool000Oo
oooo0_oo00000ol007ooooooooooo`05ooooo`?oo`002Oooool2ool00003o`00Oooooooooooo01?o
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00ko
oooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool03?ooool2ool001[ooooo
0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00_ooooo0ol00?l4ooooo`;oo`00
2?l0nYX<ooooo`03o`3jV_oo003oo`0000Wooooo0_oo0005ooooo`;o003o00?oooooo`3jV_oo0000
0ooo000=ooooo`;oo`0000?oooooo`00Ooooool00oooool3ool000Kooooo0_oo00000ol007oooooo
ooooo`06ooooo`;oo`002Oooool2ool00003o`00Oooooooooooo01?ooooo00?o001oooooooooool0
2?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`;o00001?oo
ool00ol007ooooooooooo`0<ooooo`;oo`006_ooool2ool00003o`00Oooooooooooo01Cooooo00?o
001oooooooooool03?ooool2o`00o`Cooooo0_oo0003ooooo`?o0?ZJ3_ooool00ol0nY[oo`00ool0
0009ooooo`;o00001Oooool2o`00o`03ooooool0nY[oo`0000?oo`003Oooool2ool00003ooooool0
07oooooo00Cooooo0_oo0006ooooo`;oo`0000?o001oooooooooool01_ooool3ool000Oooooo0ooo
00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00_oo
ool2o`00013ooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool03?ooool3
ool001Wooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00cooooo0_l00?l4
ooooo`;oo`005?ooool00ol0nY[oo`00ool00008ooooo`Co00001?ooool2o`00o`03ooooool0nY[o
o`0000?oo`003Oooool2ool00003ooooool007oooooo00Cooooo0_oo0006ooooo`;oo`0000?o001o
ooooooooool01oooool2ool000Oooooo0_oo00000ooooooo001oooooo`0Dooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0
003oooooooooo`03ooooo`03o`00Oooooooooooo00gooooo0_oo000Iooooo`;oo`0000?o001ooooo
ooooool05?ooool00ol007ooooooooooo`0<ooooo`;o003o1?ooool2ool0013ooooo0_l00?l2oooo
o`03o`3jV_oo003oo`0000Sooooo1?l00004ooooo`;o003o00?oooooo`3jV_oo00001?oo000<oooo
o`;oo`0000?oooooo`00Ooooool01?ooool3ool000Gooooo0_oo00000ol007ooooooooooo`07oooo
o`;oo`001oooool2ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o001oooooooooool03Oooool2ool001Wooooo0_oo00000ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00cooooo0_l00?l4ooooo`;oo`004?ooool2o`00o`;ooooo00Co0?ZJool00?oo
003o003o1_ooool2ool000;o00001?ooool3o`00o`05ooooool0nY[oo`00ool00?ooool00_oo000<
ooooo`;oo`0000?oooooo`00Ooooool01Oooool2ool000Gooooo0_oo00000ol007ooooooooooo`07
ooooo`?oo`001_ooool2ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo
00?ooooo00?o001oooooooooool03Oooool3ool001Sooooo0_oo00000ol007ooooooooooo`0Doooo
o`03o`00Oooooooooooo00cooooo0_l00?l4ooooo`;oo`004?ooool2o`00o`;ooooo00Co0?ZJool0
0?oo003o003o1_ooool2ool00003ooooool007oooooo00?ooooo0_l00?l2ooooo`04o`3jV_oo003o
o`00ooooo`?oo`002oooool2ool00003ooooool007oooooo00Gooooo0_oo0005ooooo`;oo`0000?o
001oooooooooool02?ooool3ool000Gooooo0_oo00000ooooooo001oooooo`0Dooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`004_ooool5
o`0000Cooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0>ooooo`;oo`006?ooool2
ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool03?ooool2o`00o`Cooooo0_oo000@
ooooo`;o003o0_ooool01?l0nY[oo`00ool00?l00?l4ooooo`Coo`0000?oooooo`00Ooooool00ooo
ool2o`00o`;ooooo00?o0?ZJool00?oo00000_ooool2ool000[ooooo0ooo00000ooooooo001ooooo
o`05ooooo`?oo`001?ooool2ool00003o`00Oooooooooooo00Wooooo0_oo0005ooooo`;oo`0000?o
ooooo`00Ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001?ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooooooo
o`03ooooo`03o`00Oooooooooooo00kooooo0_oo000Hooooo`;oo`0000?o001oooooooooool05?oo
ool00ol007ooooooooooo`0<ooooo`?o003o0oooool2ool0013ooooo0_l00?l2ooooo`04o`3jV_oo
003oo`00o`00o`?ooooo1?oo0002ooooo`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`3j
V_oo003oo`0000;ooooo0ooo0009ooooo`;oo`0000?o001oooooool007l01oooool2ool000Cooooo
0_oo00000ol007ooooooooooo`09ooooo`?oo`001?ooool2ool00003ooooool007oooooo01Cooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo
000Dooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol007oooooooooo
o`0>ooooo`?oo`005oooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool03Ooo
ool2o`00o`?ooooo0_oo000@ooooo`;o003o0_ooool01?l0nY[oo`00ool00?l00?l2ooooo`?oo`00
1?ooool2o`00o`?ooooo0_l00?l2ooooo`03o`3jV_oo003oo`0000?ooooo0_oo0009ooooo`;oo`00
00?o001oooooool007l01oooool2ool000Cooooo0_oo00000ol007ooooooooooo`0:ooooo`;oo`00
1?ooool2ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`03ooooo`03o`000?oooooooooo00kooooo000Eooooo`03o`000?oooooooooo00?ooooo0ol0
0003ooooo`03o`00Oooooooooooo00oooooo0_oo000Gooooo`;oo`0000?o001oooooooooool05?oo
ool00ol007ooooooooooo`0=ooooo`;o003o0oooool2ool0013ooooo0_l00?l2ooooo`04o`3jV_oo
003oo`00o`00o`;ooooo0_oo00001Ooooooo003oo`00ool00?oooooo00;o003o0oooool2o`00o`;o
oooo00?o0?ZJool00?oo00000oooool2ool000Wooooo0_oo00000ol007ooooooo`00O`07ooooo`?o
o`000oooool2ool00003o`00Oooooooooooo00[ooooo0_oo0004ooooo`;oo`0000?oooooo`00Oooo
ool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0000@ooooo`00
4_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00oooool00ol007oo
ooooooooo`0?ooooo`;oo`005oooool2ool00003o`00Oooooooooooo01Cooooo00?o001ooooooooo
ool03Oooool2o`00o`?ooooo0_oo000@ooooo`;o003o0oooool2ool00003o`00ooooooooo`0000;o
o`0000Coooooo`00ool00?oo003o0_l0nYX00ol00?ooooooooooo`03o`00o`;ooooo00?o0?ZJool0
0?oo00000oooool3ool000Sooooo0_oo00000ol007ooooooo`00O`08ooooo`?oo`000_ooool2ool0
0003o`00Oooooooooooo00[ooooo0ooo0003ooooo`;oo`0000?oooooo`00Ooooool05?ooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001;o
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00?ooooo00?o001ooooo
ooooool03oooool3ool001Kooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo
00gooooo0_l00?l3ooooo`?oo`003_ooool3o`00o`?ooooo0_oo00001?l00?ooo`00ool00?oo0002
ooooo`?o003o0ol0nYX2ooooo`;o003o0_ooool2o`3jVP;oo`001?ooool2ool000Sooooo0_oo0000
0ol007ooooooo`00O`09ooooo`;oo`0000Goooooool00?oo003oo`00o`00O`0=ooooo`;oo`000ooo
ool2ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`03ooooo`03o`000?oooooooooo00kooooo000Cooooo`?o00001Oooool00ol0003oooooooooo`03
ooooo`03o`00Oooooooooooo013ooooo0_oo000Fooooo`;oo`0000?o001oooooooooool05?ooool0
0ol007ooooooooooo`0=ooooo`;o003o1?ooool2ool000kooooo1?l00?l2ooooo`;oo`0000?o003o
ool00?oo00000oooool3o`00o`_o0?ZJ0_oo0004ooooo`;oo`002?ooool2ool00003o`00Oooooooo
001o00Wooooo1Ooo0002o`00O`gooooo0_oo0003ooooo`;oo`0000?oooooo`00Ooooool05?ooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool0
01_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0@ooooo`?oo`005Oooool2ool0
0003o`00Oooooooooooo01Cooooo00?o001oooooooooool03Oooool2o`00o`Cooooo0_oo000>oooo
o`Co003o0_ooool5ool000;ooooo1?l00?l:o`3jVP03oooooooo003oo`0000Cooooo0ooo0007oooo
o`;oo`0000?o001oooooool007l02_ooool4ool000;o001o3Oooool3ool000;ooooo0_oo00000ooo
oooo001oooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0
003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo017o
oooo0_oo000Eooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`0=ooooo`;o
003o1?ooool2ool000kooooo1?l00?l2ooooo`Coo`000oooool4o`00o`;o0?ZJ00?o003oooooool0
0?l00_l00?l3ooooo`?oo`001Oooool2ool000Oooooo0_oo00000ol007ooooooo`00O`0:ooooo`Co
o`000_l007l>ooooo`;oo`000_ooool2ool00003ooooool007oooooo01Cooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`00
0?oooooooooo00?ooooo00?o001oooooooooool04Oooool2ool001Gooooo0_oo00000ol007oooooo
ooooo`0Dooooo`03o`00Oooooooooooo00gooooo0ol00?l3ooooo`;oo`003_ooool4o`00o`;ooooo
1?oo0003ooooo`Co003o0_l0nYX01?l00?ooooooo`00ool00?l4ooooo`;oo`0000?o001ooooooooo
ool00oooool2ool000Oooooo0_oo00000ol007ooooooo`00O`0:ooooo`Coo`000_l007l>ooooo`?o
o`0000Goooooool00?oo003oooooo`00O`0Eooooo`03o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool2o`0000Cooooo00?o001ooooooooo
ool04Oooool3ool001Cooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00ko
oooo0_l00?l3ooooo`?oo`003Oooool4o`00o`;ooooo0ooo00001?l00?ooooooooooooooool3o`00
o`?o0?ZJ00Co003oooooool00?oo003o1?ooool2ool00003o`00Oooooooooooo00?ooooo0ooo0006
ooooo`;oo`0000?o001oooooool007l02oooool3ool000;o001o3oooool2ool00005oooooooo003o
o`00ooooool007l05Oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0
000@ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01;ooooo0ooo000C
ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`0>ooooo`;o003o0oooool0
0ol007ooo`00ool0000=ooooo`Co003o0_ooool3ool00004o`00ooooooooooooooooo`;o003o00?o
ooooo`3jV_l0nYX00_l00?l00ooooooo003oo`00o`04ooooo`;oo`0000?o001oooooooooool01?oo
ool2ool000Kooooo0_oo00000ol007ooooooo`00O`0;ooooo`?oo`000_l007l?ooooo`;oo`0000Go
ooooool00?oo003oooooo`00O`0Eooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooo
oooooooo01?ooooo0_oo000Cooooo`;oo`0000?o001oooooooooool05?ooool00ol007oooooooooo
o`0>ooooo`;o003o0oooool00ol007ooo`00ool0000=ooooo`Co003o0_ooool2ool000;o003o0ooo
ool2o`00o`03ooooool0nY[o0?ZJ00Go003o1?ooool2ool00003o`00Oooooooooooo00Cooooo0_oo
0006ooooo`;oo`0000?o001oooooool007l02oooool3ool000;o001o3oooool5ool00003ooooool0
07oooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool04oooool3
ool001;ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00kooooo0_l00?l3
ooooo`04o`00Oooo003oo`00ool000Kooooo0_l00?l4ooooo`Co003o0_ooool2ool000;o003o0ooo
ool2o`00o`03ooooool0nY[o0?ZJ00Go003o1?ooool2ool00003o`00Oooooooooooo00Cooooo0ooo
0005ooooo`;oo`0000?o001oooooool007l03?ooool2ool000;o001o4?ooool4ool00003ooooool0
07oooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool05?ooool2
ool001;ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00kooooo0_l00?l3
ooooo`04o`00Ooooooooo`00ool000Kooooo0_l00?l4ooooo`Co003o0_ooool2o`3jVP;o003o0_oo
ool3o`00o`03ooooool0nY[o0?ZJ00Go003o1?ooool2ool00003o`00Oooooooooooo00Gooooo0_oo
0005ooooo`;oo`0000?o001oooooool007l03_ooool2o`00Oa3ooooo1?oo00000ooooooo001ooooo
o`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003ooooooooo
o`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Cooooo0ooo000A
ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`0>ooooo`;o003o0oooool0
0ol007ooooooool00002ool000Gooooo0_l00?l4ooooo`Co003o00Coooooo`00ool0nY[o0?ZJ0_l0
0?l2ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_oo0004o`00o`Cooooo0_oo00000ol007oooooooooo
o`05ooooo`?oo`001?ooool2ool00003o`00Oooooooo001o00kooooo0_l007lAooooo`?oo`0000?o
ooooo`00Ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0E
ooooo`;oo`004Oooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool03_ooool2
o`00o`?ooooo00?o001oooooooooool00_oo0004ooooo`?o003o1?ooool4o`00o`04ooooool00?oo
0?ZJo`3jVP;o003o0_ooool5o`3jVP;oo`001?l00?l4ooooo`;oo`0000?o001oooooooooool01_oo
ool3ool000?ooooo0_oo00000ol007ooooooo`00O`0>ooooo`;o001o4Oooool3ool00003ooooool0
07oooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`;o00001?ooool00ol007ooooooooooo`0Eooooo`?oo`004?ooool2
ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool03_ooool2o`00o`;ooooo0_l00002
ooooo`?oo`000oooool3o`00o`Cooooo1?l00?l01?oooooo003oo`3jV_l0nYX2o`00o`04ooooool0
nY[o0?ZJo`3jVP?ooooo0_oo0004o`00o`Cooooo0_oo00000ol007ooooooooooo`07ooooo`?oo`00
0_ooool2ool00003o`00Oooooooo001o00kooooo0_l007lBooooo`;oo`0000?oooooo`00Ooooool0
5?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0000@ooooo`006ooo
ool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Kooooo0ooo000?ooooo`;oo`0000?o
001oooooooooool05?ooool00ol007ooooooooooo`0>ooooo`;o003o00?oooooo`000?l000000_l0
0002ooooo`;oo`000oooool4o`00o`?ooooo1?l00?l01?oooooo003oo`3jV_l0nYX2o`00o`?o0?ZJ
00Co003ooooooooooooooooo0ooo0003o`00o`Cooooo0_oo00000ol007ooooooooooo`08ooooo`;o
o`000_ooool2ool00003o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?o
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00ko
oooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool05oooool3ool000kooooo
0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00kooooo0_l00?l00ooooooo0000
o`000002o`0000;ooooo0ooo0002ooooo`Co003o0oooool4o`00o`05ooooool00?oo0?ZJo`3jV_oo
ool00ol0nYX2o`00o`?ooooo0ooo0002o`00o`Gooooo0_oo00000ol007ooooooooooo`08ooooo`?o
o`0000Koooooool00?oo003o001oooooool007l>ooooo`;o001o5Oooool00ol007ooooooooooo`0C
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>
ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Sooooo0ooo000=oooo
o`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`0>ooooo`?o003o00?oooooo`00
0?l000001?ooool2ool000;ooooo1?l00?l2ooooo`Go003o00Goooooo`00ool0nY[o0?ZJooooo`02
o`3jVP?o003o0oooool3ool000;o003o1Oooool2ool00003o`00Oooooooooooo00Wooooo1Ooo0000
0ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0
003oooooooooo`03ooooo`03o`00Oooooooooooo01Wooooo1?oo000;ooooo`;oo`0000?o001ooooo
ooooool05?ooool00ol007ooooooooooo`0?ooooo`;o003o0_ooool00ol007ooooooooooo`02oooo
o`?oo`0000?oooooo`00ool00?l00_l00?l2ooooo`;o003o00Goooooo`00ool00?ooooooo`00o`05
o`3jVP;o003o1?ooool4ool00003o`00oooooooooooo00?ooooo0_oo00000ol007ooooooooooo`0:
ooooo`Coo`0000?o001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool0
01_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Jooooo`Koo`002?ooool2ool0
0003o`00Oooooooooooo01Cooooo00?o001oooooooooool03oooool2o`00o`;ooooo00?o001ooooo
ooooool00oooool3ool000Co003o0_ooool2o`00o`03ooooool00?oo003o00;o003o1?l0nYX3o`00
o`Cooooo1?oo00000ol00?ooooooooooo`03ooooo`;oo`0000?o001oooooooooool02oooool3ool0
0003o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooo
ooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03
o`000?oooooooooo00?ooooo00?o001oooooooooool07?ooool>ool00003o`00Oooooooooooo01Co
oooo00?o001oooooooooool03oooool2o`00o`;ooooo00Co001ooooooooooooooooo0_l00?l01?oo
ooooo`00ool00?oo0003o`00o`;ooooo0_l00?l2ooooo`?o003o1?l0nYX3o`00o`Cooooo1?oo0000
0ol00?ooooooooooo`03ooooo`;oo`0000?o001oooooooooool03_ooool00ol007ooooooo`00O`0>
ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001o
ooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03oooo
o`03o`00Oooooooooooo01oooooo2ooo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo
00oooooo0_l00?l2ooooo`04o`00Ooooooooooooooooo`?o003o00?oooooool00?oo00003Ooo0002
o`3jVPCo003o0oooool6ool000Gooooo0_oo00000ol007ooooooooooo`0>ooooo`03o`00Oooooooo
001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`;o00001?ooool00ol0
07ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03oooool2o`00
o`;ooooo00Co001ooooooooooooooooo0ol00?l2ooooo`koo`000_l0nYX4o`00o`?ooooo0_oo0000
1?l007ooooooool00?oo0005ooooo`;oo`0000?o001oooooooooool03_ooool00ol007ooooooo`00
O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool00_ooool2o`00013ooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001o
ooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00oooooo0_l00?l2
ooooo`04o`00Ooooooooooooooooo`?o003o00Goooooo`00ool00?oo003oooooo`02o`00o`03oooo
ool00?oo003o00;ooooo0_l00?l2ool00003o`3jV_oooooooooo00?o003o0oooool2ool00003o`00
Ooooooooo`0000Coo`000_ooool2ool00003o`00Oooooooooooo00kooooo00?o001oooooool007l0
3_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00ooo
ool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03ooo
ool2o`00o`;ooooo00Co001ooooooooooooooooo0ol00?l00ooooooo003oo`00o`02ooooo`;o003o
00?oooooo`00ool00?l00_ooool2o`00o`;oo`0000?o0?ZJooooooooool00ol00?l3ooooo`;oo`00
00?o001oooooool00?l02?oo00000ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo
0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o
001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00oooooo0_l0
0?l2ooooo`03o`00Oooooooooooo00Co003o00?oooooo`00ool00?l00_ooool2o`00o`03ooooool0
0?oo003o00;ooooo0_l00?l2ool00003o`00Oooooooooooo00;o003o1?ooool2ool00003o`00Oooo
oooooooo00?ooooo1Ooo00000ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l0
07lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`03ooooo`03o`000?oooooooooo00kooooo000Dooooo`?o00001?ooool00ol0003oooooooooo`03
ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0?
ooooo`;o003o0_ooool00ol007ooooooooooo`04o`00o`03ooooool00?oo003o00;ooooo0_l00?l0
0ooooooo003oo`00o`02ooooo`;o003o00?oo`00o`000?l000000_ooool2o`00o`Cooooo0_oo0000
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2
o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00?ooooo00?o0000ooooooooool03_ooool001Gooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol0
07ooooooooooo`0?ooooo`;o003o00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo003o
00;ooooo0_l00?l00ooooooo003oo`00o`02ooooo`;o003o1?l000000ooooooo003oo`00o`04oooo
o`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o
00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Booooo`Go00001?ooool00ol0003o
ooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007oo
ooooooooo`0?ooooo`;o003o00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo003o00;o
oooo0_l00?l00ooooooo003oo`00o`04ooooo`Co00001?ooool5ool00003o`00Oooooooooooo00So
oooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007oo
ooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003o
ooooooooo`0>ooooo`004_ooool01?l0003oooooooooool00005ooooo`?o00000oooool00ol007oo
ooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03oooool2o`00o`03
ooooool00?oo003o00;ooooo1ol00?l2ooooo`Go003o1?ooool00ooo003o0000o`000003ooooo`Oo
o`0000?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00ko
oooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`02ooooo`;o00004?ooool001?ooooo00?o0000ooooool000001Oooool00ol0003ooooo
ooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007oooooo
ooooo`0?ooooo`Ko003o00Coooooo`00ool00?oooooo1?l00?l2ooooo`Co003o1_ooool2ool00003
oooooooo003oo`0000?oo`001?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001Cooooo
0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007oooooo
ooooo`0Dooooo`03o`00Oooooooooooo013ooooo2?l00?l00ooooooo003oo`00o`02o`00o`?ooooo
0ol00?l6ooooo`;oo`0000Coooooool00?oo003oo`001_ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001ooooooooo
ool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooooooo
ool03_ooool001Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0@ooooo`Oo003o
0_ooool4o`00o`?ooooo0ol00?l6ooooo`Goo`001oooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool0
4oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool0
3_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooo
oooooooo01Cooooo00?o001oooooooooool04?ooool3o`00o`03o`00Ool00?oo003o00?ooooo1?l0
0?l3ooooo`?o003o1_ooool4ool000Sooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000K
ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0D
ooooo`03o`00Oooooooooooo013ooooo0ol00?l00ol007ooooooooooo`03ooooo`Co003o0oooool2
o`00o`Oooooo0ooo0009ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool0
0ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0
003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol0
07ooooooooooo`0@ooooo`?o003o00?o001oooooooooool00oooool4o`00o`cooooo0ooo0009oooo
o`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>oooo
o`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool2o`0000Cooooo00?o001ooooooooo
ool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo013ooooo0ol00?l00ol007oo
ooooooooo`03ooooo`Co003o3?ooool2ool000[ooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?o
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo
00?o0000ooooooooool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo
00?o001oooooooooool04?ooool2o`00o`03ooooool007oooooo00Cooooo0ol00?l=ooooo`;oo`00
2_ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l0
3_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00ooo
ool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool04?oo
ool2o`00o`03ooooool007oooooo00Cooooo0ol00?l>ooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l0
07lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001o
ooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo01?ooooo00?o001o
ooooooooool00oooool3o`00o`kooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001o
ooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000
ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Zoooo
o`03o`00Oooooooooooo01Cooooo00?o001oooooooooool04oooool00ol007ooooooooooo`04oooo
o`;o003o3_ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Coooo
o`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>oooo
o`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001ooooooooo
ool05?ooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Cooooo0_l00?l>ooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0:_ooool00ol007ooooooooooo`08ooooo`03o`00
0?oooooooooo00Wooooo00?o001oooooooooool04oooool00ol007ooooooooooo`04ooooo`;o003o
3_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
3_ooool00ol007ooooooo`00O`0>ooooo`03o`000?l007oooooo01Cooooo00?o001oooooooooool0
4oooool00ol007ooooooooooo`08ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
3_ooool001_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00;ooooo00?o001oooooool007l00oooool00ol0003oooooooooo`08ooooo`03o`000?l0
07oooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooonko00004?ooool00?oooooo6_ooool00?oooooo6_ooool00?oooooo
6_ooool004cooooo00?o0000ooooooooool04oooool3o`0000?ooooo0ol0000Wooooo`?o0000Q?oo
ool004gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo02Oooooo00?o0000ooooooooool0Poooool003[ooooo0_l00002ooooo`?o000000?oooooo`00
0?l000000ol00006ooooo`03o`000?oooooooooo00Kooooo0_l000000ooooooo0000o`000002oooo
o`Co00000_ooool3o`0000?ooooo0ol00003ooooo`Co00002?ooool4o`0000Wooooo0_l00009oooo
o`?o00000oooool4o`000005ooooool0003o0000o`000?ooool00_l000001?oooooo0000o`000?l0
0002ooooo`Go00002Oooool2o`000003ooooool0003o000000;o000000?oooooo`000?l000001Ol0
0003ooooo`;o00002Oooool4o`0000Sooooo0ol00004ooooo`;o0000;oooool003Wooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooool000000_ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`00
00;ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo01?ooooo00Co
0000oooooooooooo00002?ooool01_l0003oooooooooool0003oooooo`0000;ooooo00Go0000oooo
ooooooooooooo`000002ooooo`03o`000?oooooo000000Oooooo00?o0000ooooooooool02?ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool0000Eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo0000;_ooool003Wooooo00Co0000oooooooooooo00000_ooool00ol0003oooooo`000003oooo
o`03o`000?oooooooooo00oooooo0_l00004ooooo`?o00000oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000;ooooo0ol00009ooooo`Co00002?ooool01?l0003ooooooooo
ool00008ooooo`04o`000?ooooooooooo`0000;ooooo0ol00003ooooo`05o`000?ooooooooooo`00
0?ooool01Ol00003ooooo`03o`000?oooooooooo00Sooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Ooo
ool4o`0000Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000^ooooo`00>Ooo
ool01?l0003oooooooooool00002ooooo`;o00001?ooool3o`0000oooooo00?o0000ooooool00000
0_ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooo
oooooooo0000ooooool00002ooooo`03o`000?oooooooooo01?ooooo00Co0000oooooooooooo0000
2?ooool01_l0003oooooooooool0003oooooo`0000;ooooo00Go0000ooooooooooooooooo`000002
ooooo`03o`000?oooooo000000?ooooo00Go0000ooooooooooooooooo`00000:ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000^oooo
o`00>Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000000?ooooo00?o0000oooo
ooooool03oooool01?l0003oooooo`000?l00002ooooo`;o00000oooool4o`0000;ooooo1?l00003
ooooo`;o00005_ooool01?l0003oooooooooool00007ooooo`Co00000oooool2o`0000?ooooo1?l0
0003ooooo`?o00001?ooool00ol0003oooooooooo`07ooooo`;o000000Coooooo`000?l0003ooooo
1?l00002ooooo`?o00000oooool4o`0001Kooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool0000^ooooo`00>Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00003_ooool00ol0003oooooooooo`0]ooooo`04o`000?oooooo
ooooo`00027ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Eooooo`;o00001?oo
ool01?l0003oooooooooool0000^ooooo`00>?ooool3o`000003ooooool0003o000000?o000000?o
ooooo`000?l000001Ol0000=ooooo`;o0000<?ooool2o`00023ooooo0ol0000Gooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`03ooooo`;o0000;ooo
ool00?oooooo6_ooool00?oooooo6_ooool00001\
\>"],
  ImageRangeCache->{{{0, 280.812}, {173.188, 0}} -> {-29.7276, -5.81761, \
0.887312, 0.0683666}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\

SCALING={1,0.1,1,1};
THETA0=Theta/SCALING
F0=IdentityMatrix[THETA0//Length];
misc={miss,1};
MAXSTEP=1;
FISHER=False;
STEPREDUCE=4;

SetDirectory[\"/Mathematica \
2.2.2/Hermann.Notebooks/UKF.20.3.2006/Panel/Simulation\"];
filename=\"UKF0.n10\";
system={f,g,h,R,mue,sigma,dt,kappa=0};
LikN=UKF;
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({\(-1.`\), 1.`, 2.`, 1.`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
EST={};
Do[

SeedRandom[99999*m];
Print[\"**********************************************************************\
***\"];
Print[\"Replikation m = \",m];
Print[\"**********************************************************************\
***\"];

n=10;
T = 200;
dt = .1;
k = 1; p = 1; q = 1;
X = Shape[0,{n,T+1,q}];
Theta = {-1., 0.1, 2.,1}//N;
Y0 = RandomGauss[_,Theta,{mue,sigma},n];
Prozess = UniC;
{zt,yt} = \
MapThread[NonLinStateSpace[h,{R,konstant},f,g,#1,#2,T,dt,Theta,Prozess,\
EulerStep]&,{Y0,X}]//Transpose;
miss = -9;
time = {0,4,6,8,10,11,12,13.5,13.7,15,15.1,17,19,20};
sel = time/dt + 1;
ZM = Shape[miss,{n,T+1,k}];
Map[(ZM[[All,#]] = zt[[All,#]])&,sel];
data={ZM,X}//Transpose;

{THETA,COV,LIKI,psii,scoreii,k,ReturnCode}=

BFGS[data,
\t {THETA0,F0},
\t {system,{Lik,LikN,Score,Hesse}},
\t {misc,KMAX=50,{EPS1=10.^-4,EPS2=10.^-4},OPTION=0,PRINT=0{1,1,1,1,1,1,1,1}}]\
;
\t 
est = {m,THETA,ReturnCode}//Flatten;
EST = Append[EST,est];
PutAppend[est,filename];


,{m,1,100}] 
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Replikation m = "\[InvisibleSpace]1\),
      SequenceForm[ "Replikation m = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print"],

Cell[BoxData[
    \({201, 201, 201, 201, 201, 201, 201, 201, 201, 201}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]33\),
      SequenceForm[ "Warnung: Overflow", 33],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]33\),
      SequenceForm[ "Warnung: Overflow", 33],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]40\),
      SequenceForm[ "Warnung: Overflow", 40],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]1\),
      SequenceForm[ "Warnung: Overflow", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Closed]],

Cell[" ", "Input"],

Cell[CellGroupData[{

Cell["filename", "Input"],

Cell[BoxData[
    \("UKF0.n10"\)], "Output"]
}, Open  ]],

Cell["cum=ReadList[filename];", "Input"],

Cell[CellGroupData[{

Cell["cum//MatrixForm", "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", 
                "6"},
              {"1", "1", \(-0.10685599783946015`\), \(-0.2294970816050316`\), 
                "1.8072273540280999`", "1.1981989710574064`", "3"},
              {"2", "2", \(-2.1149421340629138`\), "1.9713159641872446`", 
                "2.2617694600429403`", "2.1781103674201887`", "3"},
              {"3", "3", \(-0.301192740810266`\), "0.33632252798631823`", 
                "1.7963289989920816`", "0.8908038936555484`", "3"},
              {"4", "4", \(-0.5650687708610395`\), "0.610094635223779`", 
                "1.677923212792653`", "0.8355402703616941`", "3"},
              {"5", "5", \(-0.6104541736835024`\), "0.7443994944456622`", 
                "1.426684678689558`", "1.1478726357741007`", "3"},
              {"6", "6", \(-0.32920666653096325`\), "0.361237564667454`", 
                "1.925976220467439`", "1.0559363267958415`", "3"},
              {"7", "7", \(-0.3475485443186273`\), "0.30680842643558726`", 
                "1.8461511521142913`", "0.9369221895337206`", "3"},
              {"8", "8", \(-0.5843989700990503`\), "0.5222630704261976`", 
                "1.57790857806023`", "1.0101599828015002`", "3"},
              {"9", "9", \(-0.35906943616079956`\), "0.39597824101588214`", 
                "1.2745708649871035`", "1.5457163552011308`", "3"},
              {"10", "10", \(-2.303416627348959`\), "2.1153059871697053`", 
                "2.4252021616888775`", "1.2395336215125274`", "3"},
              {"11", "11", \(-0.48784366881168983`\), "0.6194245731325678`", 
                "1.3486019251372707`", "1.4020473414885344`", "3"},
              {"12", "12", \(-0.08131623375288509`\), "0.12147067660121552`", 
                "1.7468786292518557`", "0.7987400713467022`", "3"},
              {"13", "13", \(-4.493207850342953`\), "3.117548497246637`", 
                "3.7671285948182045`", "0.04503119400853091`", "3"},
              {"14", "14", \(-0.6936155261780121`\), "0.6131506462085806`", 
                "1.8539075327175318`", "0.6621914722107177`", "3"},
              {"15", "15", "0.06241533408601497`", \(-0.17324620047650302`\), 
                "2.0051928595162263`", "0.8731063525759369`", "3"},
              {"16", "16", \(-3.957072013679156`\), "3.647199376288317`", 
                "2.8822560593631303`", "0.9497066713456322`", "3"},
              {"17", "17", \(-1.2658008464478945`\), "1.2703603074785437`", 
                "1.8354416503072744`", "1.3310062345711633`", "3"},
              {"18", "18", \(-0.3332211378618655`\), "0.310258554820469`", 
                "1.411791710310085`", "1.7131626564516438`", "3"},
              {"19", "19", \(-3.7008225829094075`\), "3.432740564081983`", 
                "2.8035487817756035`", "1.3675032179449693`", "3"},
              {"20", "20", \(-0.22201701416403974`\), "0.32227569406218043`", 
                "1.6409092764022881`", "1.0923452239124054`", "3"},
              {"21", "21", \(-0.2938930632873956`\), "0.34686042530322053`", 
                "1.9558973927815515`", "0.8414411265939422`", "3"},
              {"22", 
                "22", \(-0.09657096901895133`\), \(-0.1725818375878033`\), 
                "1.8083837795645277`", "0.8898595349149401`", "3"},
              {"23", "23", \(-0.8154997306498744`\), "1.1651392370260643`", 
                "1.3048552011589445`", "2.476634193941876`", "3"},
              {"24", "24", \(-0.4780912554765057`\), "0.5920959385301742`", 
                "2.0262741273289597`", \(-0.3510222791284822`\), "3"},
              {"25", "25", \(-0.24203285098512053`\), "0.2905977761302793`", 
                "1.6427357297244272`", "0.8572252346034624`", "3"},
              {"26", "26", \(-3.6332007710180254`\), "3.1430439743352903`", 
                "2.7735770724110114`", "1.5572282820885812`", "4"},
              {"27", 
                "27", \(-0.19266618902089191`\), \(-0.30956582552793216`\), 
                "1.7671119307097212`", "1.1568137242095506`", "3"},
              {"28", "28", \(-0.44966627457317165`\), "0.4830994713195238`", 
                "1.4167066201114584`", "1.7197933206820508`", "3"},
              {"29", "29", \(-1.2981966736876211`\), "1.5473789229304782`", 
                "1.6163954776256237`", "2.33948816377513`", "3"},
              {"30", "30", \(-0.26924452293311746`\), "0.2754431266559094`", 
                "1.406114775181314`", "1.3067165617976357`", "3"},
              {"31", "31", \(-0.361413844718438`\), "0.43973941870559463`", 
                "1.6787708336682967`", "0.9718144422786106`", "3"},
              {"32", "32", \(-0.2041250212771772`\), "0.25575428380324977`", 
                "1.6556193923939566`", "0.6923676395295593`", "3"},
              {"33", "33", \(-0.9939931804406642`\), "1.0377801021298927`", 
                "1.7936322435187018`", "0.6277720057635332`", "3"},
              {"34", "34", \(-0.08896581947979312`\), "0.2271951772262029`", 
                "1.8625718582860729`", "0.7407039282754393`", "3"},
              {"35", "35", \(-0.40259193633393714`\), "0.4622146020888325`", 
                "1.4941677189787659`", "1.6322662299533128`", "3"},
              {"36", "36", \(-0.5127198673485267`\), "0.6708326899477902`", 
                "1.9141809760195356`", \(-0.1899084599532905`\), "3"},
              {"37", "37", \(-0.3721652691151379`\), "0.47074095725812326`", 
                "1.6654464657431873`", "0.8196095043258284`", "3"},
              {"38", "38", \(-0.16302651596016357`\), "0.26218093237581835`", 
                "1.844794514261599`", "0.7754167913270469`", "3"},
              {"39", "39", \(-0.29873447979792583`\), "0.2655992047706411`", 
                "1.847842595259746`", \(-0.375754674676768`\), "3"},
              {"40", "40", \(-0.3233999955613653`\), "0.37636144881333256`", 
                "1.6464083261807794`", "0.823967999236349`", "3"},
              {"41", "41", \(-0.31301457537219124`\), "0.40512881679317275`", 
                "1.6834790093233107`", "0.7749194922754223`", "3"},
              {"42", "42", "0.08722902182032458`", "0.07393874800813202`", 
                "1.761788357559588`", "1.136529393257219`", "3"},
              {"43", "43", \(-0.7293253262934893`\), "0.7578141624806318`", 
                "1.9468000855422232`", "0.7206205982170003`", "3"},
              {"44", "44", \(-0.3478097672069131`\), "0.3635283427550183`", 
                "1.729606231707466`", "1.0821014248530314`", "3"},
              {"45", "45", \(-0.08237484225116552`\), "0.15149864872197247`", 
                "1.5580071548667218`", "0.965543852268094`", "3"},
              {"46", "46", \(-0.2247007073537832`\), "0.3074004210341701`", 
                "1.4767747064501657`", "0.9090843027778656`", "3"},
              {"47", "47", \(-0.43391212073212515`\), "0.462694831237918`", 
                "1.9400498909680797`", "0.7257188905928508`", "3"},
              {"48", "48", \(-0.4374659018194732`\), "0.6176914103102397`", 
                "1.6693453375714484`", "1.015725574297777`", "3"},
              {"49", "49", \(-0.1488443786029344`\), "0.24317910845766336`", 
                "1.897868102587632`", "0.8799910193926895`", "3"},
              {"50", "50", \(-0.5975285275043883`\), "0.6109888879624569`", 
                "1.7130357983867026`", "0.8144300673911813`", "3"},
              {"51", "51", \(-0.29996770084030433`\), "0.3568989092811395`", 
                "1.7119310390139642`", "1.1309710052651192`", "3"},
              {"52", "52", \(-0.36548427758415836`\), "0.44988575489220684`", 
                "1.5562824507944766`", "1.2216229933016995`", "3"},
              {"53", "53", \(-0.4222789764334621`\), "0.4783117496867328`", 
                "1.7508228277548676`", "1.3102056191260671`", "3"},
              {"54", "54", \(-0.1913813275604124`\), "0.2188166248132839`", 
                "1.4106468611072813`", "1.3078629077454675`", "3"},
              {"55", "55", \(-0.20625963188118532`\), "0.25605037265716796`", 
                "1.6006326372570936`", "0.7833281919631667`", "3"},
              {"56", "56", \(-0.8098954659897379`\), "0.6651078515400018`", 
                "2.1417034851405155`", "0.5779250668609921`", "3"},
              {"57", "57", \(-0.28750490353455505`\), "0.36641360319158994`", 
                "1.949080462892772`", "0.608804114903784`", "3"},
              {"58", "58", \(-0.08374343050799445`\), "0.23874952451619808`", 
                "1.6838743747540033`", "1.032450188870273`", "3"},
              {"59", "59", \(-0.3027775727841263`\), "0.33288098539918665`", 
                "1.1254412098440836`", "2.13440282692292`", "3"},
              {"60", "60", "0.07246794625025754`", \(-0.10837792292327718`\), 
                "1.7847283069783193`", \(-0.3719976118527602`\), "3"},
              {"61", "61", \(-2.813340925250062`\), "2.9663292256901843`", 
                "2.2864455802735497`", "1.1287100481864736`", "3"},
              {"62", "62", \(-0.26667244051883054`\), "0.40394663980760337`", 
                "1.3589708378061391`", "0.9393956520684724`", "3"},
              {"63", "63", \(-0.8333271179918434`\), "0.8825751093990318`", 
                "1.9825602341683253`", "0.9907332055024485`", "3"},
              {"64", "64", \(-0.39574805161255605`\), "0.4913907741321705`", 
                "1.6063008897277498`", "1.7795501005804581`", "3"},
              {"65", "65", \(-0.3017542944789302`\), "0.49389490548818066`", 
                "2.1702616569658417`", "0.6818471034046505`", "3"},
              {"66", "66", \(-0.17785983558109983`\), "0.2546467654654524`", 
                "1.6863588077734573`", "0.8472228764192175`", "3"},
              {"67", "67", \(-0.2832767224617695`\), "0.367988203135818`", 
                "1.6212615702792945`", "1.5594144686607032`", "3"},
              {"68", "68", \(-0.15010195178787547`\), "0.2643632970261394`", 
                "1.9264882273679602`", "0.7759043534264644`", "3"},
              {"69", "69", \(-3.2574571990482757`\), "3.301206845078216`", 
                "2.613930316885747`", "1.661291779218769`", "3"},
              {"70", "70", \(-0.013583236778705645`\), "0.10271509781378584`",
                 "1.637355108457932`", "1.0592960477532662`", "3"},
              {"71", "71", \(-0.6322972128793279`\), "0.7035188948421095`", 
                "1.7640469992712056`", "0.6708535296155954`", "3"},
              {"72", "72", \(-1.690635792709325`\), "1.663518742645086`", 
                "1.8589141483173472`", "1.6884869400413824`", "3"},
              {"73", "73", \(-0.3561519532827715`\), "0.41707795784516544`", 
                "1.673042736387732`", "1.0787927901434242`", "3"},
              {"74", "74", \(-0.20701947170239424`\), "0.235911839140212`", 
                "1.6970140195545715`", "0.702605718185495`", "3"},
              {"75", "75", \(-0.8789781543399144`\), "0.9303690236911575`", 
                "1.9190377020100788`", "0.9457780970207957`", "3"},
              {"76", "76", \(-1.0564177830044261`\), "1.0196015113435333`", 
                "2.088383497846262`", "0.5964325580901839`", "3"},
              {"77", "77", \(-2.3105028382491364`\), "2.6932463605904124`", 
                "2.0859888577541597`", "1.6482887022763024`", "3"},
              {"78", "78", \(-0.23169683999795668`\), "0.28554657173189835`", 
                "1.6075452120219547`", "0.7556728483520695`", "3"},
              {"79", "79", \(-0.7661549272676103`\), "0.8018903394267621`", 
                "1.6534302455116079`", "1.1039794533676064`", "3"},
              {"80", "80", \(-0.02501396067848394`\), "0.20414417721195782`", 
                "1.2491580440584042`", "1.7987324499153041`", "3"},
              {"81", "81", \(-0.7516451323238066`\), "0.797217744562337`", 
                "1.5847417323670345`", "1.4757449164965977`", "3"},
              {"82", "82", \(-0.5946357256317479`\), "0.7394224689627994`", 
                "1.600108228562311`", "1.279579255727669`", "3"},
              {"83", "83", \(-0.4828205730263597`\), "0.7144258108318546`", 
                "1.5324204952275107`", "1.6065379328466491`", "3"},
              {"84", "84", \(-2.8937136852788683`\), "2.833436948429578`", 
                "2.496522788671417`", "0.7925700819537052`", "3"},
              {"85", "85", \(-0.6454074349057336`\), "0.6450591415937079`", 
                "1.7323847753309323`", "0.8905822539508955`", "3"},
              {"86", "86", \(-0.10543357378463519`\), "0.3915566693142204`", 
                "1.5401669887150435`", "0.951470092231717`", "3"},
              {"87", "87", \(-0.25621465289789863`\), "0.3419829732701837`", 
                "1.7417138748629835`", "1.0489415623742502`", "3"},
              {"88", "88", \(-0.5324638239208418`\), "0.5989924641899098`", 
                "1.7571950027172984`", "0.8879792941985408`", "3"},
              {"89", "89", \(-3.964827418289368`\), "3.0570357931425374`", 
                "3.3851751009877358`", "0.5944554748709727`", "3"},
              {"90", "90", \(-2.31907718325497`\), "2.870915204996627`", 
                "2.0236654989683984`", "1.0220303286581676`", "3"},
              {"91", "91", "0.11112743792864441`", "0.06159479365300367`", 
                "1.5551198676598192`", "1.2481832478060426`", "3"},
              {"92", "92", \(-0.21721397324603575`\), "0.33426234793152704`", 
                "1.7357011234587418`", "1.2802766225728124`", "3"},
              {"93", "93", \(-0.5113401607467701`\), "0.4827156568992985`", 
                "1.9158700326520606`", \(-0.4649611755062615`\), "3"},
              {"94", "94", \(-0.1933718079935908`\), "0.2805174589360815`", 
                "1.8237070980891161`", "0.8909147710419492`", "3"},
              {"95", "95", \(-0.3379958030378148`\), "0.3938722078886238`", 
                "1.4894004151126292`", "0.8892071018816984`", "3"},
              {"96", "96", \(-0.4513810232851858`\), "0.4932497807491883`", 
                "1.5304527364002438`", "1.4896495276892634`", "3"},
              {"97", "97", \(-0.12597648711866868`\), "0.25713613888569437`", 
                "1.3523125553296775`", "1.5911366632074948`", "3"},
              {"98", "98", \(-0.12706835356845225`\), "0.24646766384174199`", 
                "1.3074816266572784`", "1.7076263046950588`", "3"},
              {"99", "99", \(-0.3460383344577538`\), "0.3532608072146825`", 
                "1.3039053916971528`", "1.6672055018718546`", "3"},
              {"100", "100", \(-2.391174157889295`\), "2.6463557915511533`", 
                "2.4269096312552008`", "0.7846149119456814`", "3"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell["cum//Dimensions", "Input"],

Cell[BoxData[
    \({100, 6}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
sel=Position[cum[[All,6]],3]//Flatten;
sel//Length\
\>", "Input"],

Cell[BoxData[
    \(99\)], "Output"]
}, Open  ]],

Cell["cum1=cum[[sel,{2,3,4,5}]];", "Input"],

Cell["cum1=Map[{#[[1]],#[[2]]//Abs,#[[3]],#[[4]]//Abs}&,cum1];", "Input"],

Cell[CellGroupData[{

Cell["\<\
{SML,S,MEAN} = Varianz[cum1//N];
STD = VecDiag[SML]//Sqrt;
bias=MEAN-THETA0;
rmse=Sqrt[STD^2+bias^2];

{{\"alpha\",\"beta\",sigma,R},
 Theta,MEAN*SCALING,STD*SCALING,bias*SCALING,rmse*SCALING }//Transpose//
MatrixForm[#,TableHeadings->{None,{\"parameter\",\"value\",\"mean\",\"std\",\"\
bias\",\"RMSE\"}}]&\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-0.7127362434745`\), 
                "0.9525498033823069`", "0.28726375652549996`", 
                "0.9949229084390475`"},
              {"\<\"beta\"\>", "0.1`", "0.07612199624919447`", 
                "0.08537850686354594`", \(-0.023878003750805545`\), 
                "0.08865465863321592`"},
              {"sigma", "2.`", "1.7987541176527528`", 
                "0.40394402119716666`", \(-0.20124588234724716`\), 
                "0.45129887815355696`"},
              {"R", "1.`", "1.0741727449578626`", "0.4419995536696189`", 
                "0.07417274495786264`", "0.44817987632057565`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF / kappa=1", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Filter", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,lik} = 
\tUKF[data[[nn=10]],Theta,system={f,g,h,R,mue,sigma,dt,kappa=1},{miss,2}];//\
Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.2599999999999909`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell["std = Map[VecDiag,PF]//Sqrt;", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["std//Dimensions", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({201, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g2 = plot1[yt[[nn]]~ii~YF~ii~(YF+std)~ii~(YF-std)//AddTimeAxis,
\t\tGridLines->{time/dt,None},color->{1,2,3,3},
\t\tDisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{201, 5}\),
      SequenceForm[ "Dimension der Daten  ", {201, 5}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g3 = plot1[Spalte[time/dt]~ii~ZM[[nn,time/dt+1]],
\t\t\tPlotJoined->False,dicke->.02,
\t\t\tDisplayFunction->Identity,color->{10}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{14, 2}\),
      SequenceForm[ "Dimension der Daten  ", {14, 2}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gUKF=Show[g2,g3,DisplayFunction->$DisplayFunction,GridLines->{time/\
dt,None},
\t\t\t\tPlotLabel->\"UKF, kappa = \"<>ToString[kappa]<>\" panel unit = \
\"<>ToString[nn],PlotRange->{All,{-5,5}}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0047619 0.309017 0.0618034 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -6 -9 ]
[.2619 -0.0125 6 0 ]
[.5 -0.0125 -9 -9 ]
[.5 -0.0125 9 0 ]
[.7381 -0.0125 -9 -9 ]
[.7381 -0.0125 9 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -6 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -6 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -92 0 ]
[.5 .63053 92 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .61803 L
s
.21429 0 m
.21429 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.40476 0 m
.40476 .61803 L
s
.5 0 m
.5 .61803 L
s
.54762 0 m
.54762 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.66667 0 m
.66667 .61803 L
s
.67619 0 m
.67619 .61803 L
s
.7381 0 m
.7381 .61803 L
s
.74286 0 m
.74286 .61803 L
s
.83333 0 m
.83333 .61803 L
s
.92857 0 m
.92857 .61803 L
s
.97619 0 m
.97619 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(50)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(100)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(150)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(200)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(-4)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(-2)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(2)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(4)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -153 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
129.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
141.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
153.000 13.000 moveto
(panel) show
189.000 13.000 moveto
(unit) show
219.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
231.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
243.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.97619 .19163 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .27669 m
.02857 .29846 L
.03333 .2618 L
.0381 .26628 L
.04286 .26754 L
.04762 .20714 L
.05238 .16017 L
.05714 .12555 L
.0619 .06686 L
.06667 .05446 L
.07143 .11893 L
.07619 .12641 L
.08095 .13619 L
.08571 .16112 L
.09048 .16386 L
.09524 .19665 L
.1 .24045 L
.10476 .20446 L
.10952 .19228 L
.11429 .214 L
.11905 .14632 L
.12381 .17878 L
.12857 .16414 L
.13333 .17391 L
.1381 .14817 L
.14286 .08782 L
.14762 .05453 L
.15238 .0119 L
.15714 .09454 L
.1619 .03251 L
s
.1619 .03251 m
.16578 0 L
s
.16707 0 m
.17143 .07962 L
.17619 .12078 L
.18095 .14606 L
.18571 .0944 L
.19048 .05835 L
.19524 .02722 L
.2 .12327 L
.20476 .13342 L
.20952 .11797 L
.21429 .0862 L
.21905 .1208 L
.22381 .0684 L
.22857 .10722 L
.23333 .07035 L
.2381 .14024 L
.24286 .16002 L
.24762 .0962 L
.25238 .14833 L
.25714 .18874 L
.2619 .17714 L
.26667 .105 L
.27143 .04362 L
.27619 .11036 L
.28095 .10684 L
.28571 .07526 L
.29048 .05732 L
.29524 .02388 L
.3 .03087 L
s
.3 .03087 m
.30464 0 L
s
.31443 0 m
.31905 .07609 L
.32381 .10542 L
.32857 .15738 L
.33333 .14317 L
.3381 .15243 L
.34286 .20764 L
.34762 .22096 L
.35238 .2153 L
.35714 .26563 L
.3619 .3122 L
.36667 .35278 L
.37143 .38037 L
.37619 .38052 L
.38095 .43467 L
.38571 .47781 L
.39048 .5289 L
.39524 .58891 L
.4 .57273 L
.40476 .54716 L
.40952 .56473 L
.41429 .56986 L
.41905 .55525 L
.42381 .51756 L
.42857 .52404 L
.43333 .57999 L
.4381 .60893 L
.44286 .56255 L
.44762 .49508 L
.45238 .47568 L
.45714 .54105 L
.4619 .57277 L
.46667 .56729 L
.47143 .53704 L
.47619 .47122 L
.48095 .40953 L
.48571 .47737 L
.49048 .54448 L
.49524 .49601 L
.5 .46279 L
.50476 .41459 L
.50952 .48668 L
.51429 .50639 L
.51905 .54283 L
.52381 .51727 L
.52857 .48803 L
.53333 .43407 L
.5381 .43381 L
.54286 .48406 L
.54762 .46833 L
Mistroke
.55238 .4306 L
.55714 .50386 L
.5619 .5293 L
.56667 .45758 L
.57143 .42766 L
.57619 .39203 L
.58095 .34028 L
.58571 .35624 L
.59048 .31438 L
.59524 .27082 L
.6 .21584 L
.60476 .22649 L
.60952 .27894 L
.61429 .33442 L
.61905 .27197 L
.62381 .28934 L
.62857 .26229 L
.63333 .21177 L
.6381 .22268 L
.64286 .19539 L
.64762 .15191 L
.65238 .17558 L
.65714 .21152 L
.6619 .27075 L
.66667 .2065 L
.67143 .23019 L
.67619 .17363 L
.68095 .2312 L
.68571 .26797 L
.69048 .27059 L
.69524 .20779 L
.7 .18438 L
.70476 .19891 L
.70952 .17433 L
.71429 .22716 L
.71905 .25426 L
.72381 .2796 L
.72857 .26895 L
.73333 .32226 L
.7381 .26879 L
.74286 .25272 L
.74762 .2182 L
.75238 .1823 L
.75714 .20821 L
.7619 .15684 L
.76667 .15996 L
.77143 .14959 L
.77619 .17866 L
.78095 .12033 L
.78571 .16473 L
Mistroke
.79048 .13629 L
.79524 .17001 L
.8 .13643 L
.80476 .10406 L
.80952 .07563 L
.81429 .07138 L
.81905 .10182 L
.82381 .16059 L
.82857 .13162 L
.83333 .14816 L
.8381 .19935 L
.84286 .18811 L
.84762 .16852 L
.85238 .16849 L
.85714 .16259 L
.8619 .1141 L
.86667 .06294 L
.87143 .11855 L
.87619 .09475 L
.88095 .1156 L
.88571 .13599 L
.89048 .07134 L
.89524 .04327 L
.9 .10437 L
.90476 .08131 L
.90952 .05875 L
.91429 .12972 L
.91905 .12629 L
.92381 .06173 L
.92857 .12778 L
.93333 .09344 L
.9381 .10901 L
.94286 .13808 L
.94762 .09789 L
.95238 .08094 L
.95714 .03611 L
.9619 .03459 L
.96667 .08602 L
.97143 .13909 L
.97619 .19163 L
Mfstroke
0 .98 .604 r
gsave
.97619 .19637 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21625 m
.02857 .21159 L
.03333 .20818 L
.0381 .20603 L
.04286 .20507 L
.04762 .2051 L
.05238 .20594 L
.05714 .2074 L
.0619 .20934 L
.06667 .21165 L
.07143 .21423 L
.07619 .21704 L
.08095 .22002 L
.08571 .22315 L
.09048 .22641 L
.09524 .22977 L
.1 .23322 L
.10476 .23673 L
.10952 .2403 L
.11429 .2439 L
.11905 .24752 L
.12381 .25112 L
.12857 .25469 L
.13333 .2582 L
.1381 .26164 L
.14286 .26498 L
.14762 .26821 L
.15238 .27131 L
.15714 .27427 L
.1619 .27707 L
.16667 .27972 L
.17143 .2822 L
.17619 .28451 L
.18095 .28666 L
.18571 .28865 L
.19048 .29049 L
.19524 .29218 L
.2 .29373 L
.20476 .29515 L
.20952 .29644 L
.21429 .13978 L
.21905 .13994 L
.22381 .14098 L
.22857 .14249 L
.23333 .14423 L
.2381 .14608 L
.24286 .14796 L
.24762 .14983 L
.25238 .15168 L
.25714 .15349 L
Mistroke
.2619 .15528 L
.26667 .15703 L
.27143 .15877 L
.27619 .16049 L
.28095 .16219 L
.28571 .1639 L
.29048 .1656 L
.29524 .1673 L
.3 .16902 L
.30476 .17075 L
.30952 .07818 L
.31429 .09202 L
.31905 .10169 L
.32381 .10908 L
.32857 .11502 L
.33333 .11998 L
.3381 .12423 L
.34286 .12795 L
.34762 .13127 L
.35238 .13427 L
.35714 .13702 L
.3619 .13956 L
.36667 .14193 L
.37143 .14417 L
.37619 .1463 L
.38095 .14833 L
.38571 .15028 L
.39048 .15217 L
.39524 .154 L
.4 .1558 L
.40476 .37388 L
.40952 .37842 L
.41429 .38219 L
.41905 .38498 L
.42381 .38669 L
.42857 .3873 L
.43333 .38692 L
.4381 .3857 L
.44286 .38378 L
.44762 .38135 L
.45238 .37853 L
.45714 .37544 L
.4619 .37216 L
.46667 .36877 L
.47143 .36533 L
.47619 .36188 L
.48095 .35845 L
.48571 .35509 L
.49048 .35181 L
.49524 .34864 L
Mistroke
.5 .51956 L
.50476 .51079 L
.50952 .5042 L
.51429 .49891 L
.51905 .49446 L
.52381 .49062 L
.52857 .48723 L
.53333 .48417 L
.5381 .48139 L
.54286 .47881 L
.54762 .4369 L
.55238 .44202 L
.55714 .44545 L
.5619 .44742 L
.56667 .44823 L
.57143 .44818 L
.57619 .44755 L
.58095 .44652 L
.58571 .44521 L
.59048 .44372 L
.59524 .31984 L
.6 .3207 L
.60476 .32144 L
.60952 .32201 L
.61429 .32235 L
.61905 .32245 L
.62381 .32228 L
.62857 .32189 L
.63333 .32132 L
.6381 .32061 L
.64286 .31983 L
.64762 .31901 L
.65238 .3182 L
.65714 .31742 L
.6619 .31667 L
.66667 .27273 L
.67143 .27016 L
.67619 .27554 L
.68095 .27296 L
.68571 .27074 L
.69048 .26905 L
.69524 .26801 L
.7 .26768 L
.70476 .26806 L
.70952 .26908 L
.71429 .27061 L
.71905 .27252 L
.72381 .27468 L
.72857 .27696 L
.73333 .27929 L
Mistroke
.7381 .34275 L
.74286 .24936 L
.74762 .24499 L
.75238 .2413 L
.75714 .23851 L
.7619 .23673 L
.76667 .23602 L
.77143 .23631 L
.77619 .23746 L
.78095 .23931 L
.78571 .2417 L
.79048 .24448 L
.79524 .24754 L
.8 .25078 L
.80476 .25411 L
.80952 .25748 L
.81429 .26083 L
.81905 .26413 L
.82381 .26735 L
.82857 .27046 L
.83333 .07663 L
.8381 .0922 L
.84286 .10228 L
.84762 .10974 L
.85238 .11565 L
.85714 .12056 L
.8619 .12476 L
.86667 .12844 L
.87143 .13171 L
.87619 .13468 L
.88095 .13739 L
.88571 .13991 L
.89048 .14227 L
.89524 .14449 L
.9 .1466 L
.90476 .14861 L
.90952 .15056 L
.91429 .15244 L
.91905 .15427 L
.92381 .15605 L
.92857 .15166 L
.93333 .14911 L
.9381 .14817 L
.94286 .14833 L
.94762 .14918 L
.95238 .15043 L
.95714 .1519 L
.9619 .1535 L
.96667 .15515 L
.97143 .15684 L
Mistroke
.97619 .19637 L
Mfstroke
1 0 0 r
gsave
.97619 .24558 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27518 m
.02857 .28305 L
.03333 .28964 L
.0381 .29547 L
.04286 .30083 L
.04762 .3059 L
.05238 .31082 L
.05714 .31568 L
.0619 .32054 L
.06667 .32545 L
.07143 .33044 L
.07619 .33553 L
.08095 .34074 L
.08571 .34605 L
.09048 .35146 L
.09524 .35697 L
.1 .36254 L
.10476 .36817 L
.10952 .37383 L
.11429 .37948 L
.11905 .38509 L
.12381 .39063 L
.12857 .39606 L
.13333 .40134 L
.1381 .40645 L
.14286 .41136 L
.14762 .41603 L
.15238 .42045 L
.15714 .42461 L
.1619 .42849 L
.16667 .43209 L
.17143 .43542 L
.17619 .43848 L
.18095 .44128 L
.18571 .44384 L
.19048 .44616 L
.19524 .44826 L
.2 .45016 L
.20476 .45187 L
.20952 .45341 L
.21429 .1973 L
.21905 .20304 L
.22381 .20779 L
.22857 .21194 L
.23333 .21572 L
.2381 .21923 L
.24286 .22256 L
.24762 .22574 L
.25238 .22881 L
.25714 .23179 L
Mistroke
.2619 .23471 L
.26667 .23757 L
.27143 .2404 L
.27619 .2432 L
.28095 .24599 L
.28571 .24878 L
.29048 .25157 L
.29524 .25437 L
.3 .25719 L
.30476 .26005 L
.30952 .12921 L
.31429 .14409 L
.31905 .15591 L
.32381 .16556 L
.32857 .17368 L
.33333 .18067 L
.3381 .1868 L
.34286 .19227 L
.34762 .19723 L
.35238 .20176 L
.35714 .20596 L
.3619 .20988 L
.36667 .21357 L
.37143 .21707 L
.37619 .22042 L
.38095 .22364 L
.38571 .22675 L
.39048 .22977 L
.39524 .23272 L
.4 .23561 L
.40476 .42299 L
.40952 .44331 L
.41429 .46022 L
.41905 .47414 L
.42381 .48522 L
.42857 .49364 L
.43333 .4997 L
.4381 .50379 L
.44286 .50632 L
.44762 .50765 L
.45238 .50809 L
.45714 .50788 L
.4619 .5072 L
.46667 .50618 L
.47143 .50492 L
.47619 .50348 L
.48095 .50192 L
.48571 .50027 L
.49048 .49858 L
.49524 .49686 L
Mistroke
.5 .57668 L
.50476 .56839 L
.50952 .56325 L
.51429 .55966 L
.51905 .55696 L
.52381 .55481 L
.52857 .55302 L
.53333 .55149 L
.5381 .55015 L
.54286 .54896 L
.54762 .48365 L
.55238 .50158 L
.55714 .51396 L
.5619 .52229 L
.56667 .52767 L
.57143 .53099 L
.57619 .53291 L
.58095 .53392 L
.58571 .53433 L
.59048 .53437 L
.59524 .37116 L
.6 .38874 L
.60476 .40435 L
.60952 .41841 L
.61429 .43086 L
.61905 .44157 L
.62381 .45042 L
.62857 .45742 L
.63333 .46271 L
.6381 .46652 L
.64286 .46913 L
.64762 .47081 L
.65238 .47181 L
.65714 .47233 L
.6619 .47252 L
.66667 .33021 L
.67143 .34316 L
.67619 .32587 L
.68095 .33983 L
.68571 .35207 L
.69048 .36327 L
.69524 .37363 L
.7 .38317 L
.70476 .3919 L
.70952 .3998 L
.71429 .40691 L
.71905 .41327 L
.72381 .41894 L
.72857 .424 L
.73333 .42851 L
Mistroke
.7381 .39995 L
.74286 .29648 L
.74762 .30844 L
.75238 .31839 L
.75714 .32726 L
.7619 .33541 L
.76667 .34304 L
.77143 .35024 L
.77619 .35712 L
.78095 .36373 L
.78571 .37011 L
.79048 .37631 L
.79524 .38234 L
.8 .3882 L
.80476 .39388 L
.80952 .39936 L
.81429 .40464 L
.81905 .40969 L
.82381 .4145 L
.82857 .41904 L
.83333 .13376 L
.8381 .14679 L
.84286 .15776 L
.84762 .16697 L
.85238 .17482 L
.85714 .18164 L
.8619 .18765 L
.86667 .19303 L
.87143 .19791 L
.87619 .20239 L
.88095 .20654 L
.88571 .21043 L
.89048 .21409 L
.89524 .21757 L
.9 .22089 L
.90476 .22409 L
.90952 .22719 L
.91429 .2302 L
.91905 .23314 L
.92381 .23603 L
.92857 .2008 L
.93333 .20795 L
.9381 .21324 L
.94286 .21758 L
.94762 .22137 L
.95238 .22482 L
.95714 .22804 L
.9619 .23112 L
.96667 .2341 L
.97143 .237 L
Mistroke
.97619 .24558 L
Mfstroke
gsave
.97619 .14717 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15732 m
.02857 .14013 L
.03333 .12671 L
.0381 .1166 L
.04286 .1093 L
.04762 .10429 L
.05238 .10106 L
.05714 .09913 L
.0619 .09815 L
.06667 .09785 L
.07143 .09802 L
.07619 .09854 L
.08095 .0993 L
.08571 .10026 L
.09048 .10136 L
.09524 .10257 L
.1 .10389 L
.10476 .10529 L
.10952 .10678 L
.11429 .10833 L
.11905 .10994 L
.12381 .1116 L
.12857 .11331 L
.13333 .11506 L
.1381 .11683 L
.14286 .11861 L
.14762 .1204 L
.15238 .12218 L
.15714 .12393 L
.1619 .12566 L
.16667 .12734 L
.17143 .12897 L
.17619 .13054 L
.18095 .13204 L
.18571 .13347 L
.19048 .13482 L
.19524 .1361 L
.2 .1373 L
.20476 .13843 L
.20952 .13947 L
.21429 .08226 L
.21905 .07685 L
.22381 .07417 L
.22857 .07303 L
.23333 .07275 L
.2381 .07293 L
.24286 .07337 L
.24762 .07393 L
.25238 .07455 L
.25714 .0752 L
Mistroke
.2619 .07585 L
.26667 .0765 L
.27143 .07714 L
.27619 .07777 L
.28095 .0784 L
.28571 .07902 L
.29048 .07963 L
.29524 .08024 L
.3 .08085 L
.30476 .08146 L
.30952 .02715 L
.31429 .03995 L
.31905 .04748 L
.32381 .05259 L
.32857 .05635 L
.33333 .05928 L
.3381 .06165 L
.34286 .06363 L
.34762 .06531 L
.35238 .06678 L
.35714 .06808 L
.3619 .06924 L
.36667 .0703 L
.37143 .07127 L
.37619 .07217 L
.38095 .07301 L
.38571 .07381 L
.39048 .07457 L
.39524 .07529 L
.4 .07598 L
.40476 .32476 L
.40952 .31353 L
.41429 .30416 L
.41905 .29582 L
.42381 .28815 L
.42857 .28097 L
.43333 .27415 L
.4381 .2676 L
.44286 .26125 L
.44762 .25505 L
.45238 .24897 L
.45714 .243 L
.4619 .23713 L
.46667 .23137 L
.47143 .22574 L
.47619 .22027 L
.48095 .21498 L
.48571 .2099 L
.49048 .20504 L
.49524 .20043 L
Mistroke
.5 .46245 L
.50476 .45319 L
.50952 .44515 L
.51429 .43815 L
.51905 .43197 L
.52381 .42644 L
.52857 .42144 L
.53333 .41686 L
.5381 .41262 L
.54286 .40867 L
.54762 .39015 L
.55238 .38246 L
.55714 .37695 L
.5619 .37255 L
.56667 .36878 L
.57143 .36538 L
.57619 .36219 L
.58095 .35911 L
.58571 .35608 L
.59048 .35307 L
.59524 .26853 L
.6 .25266 L
.60476 .23853 L
.60952 .2256 L
.61429 .21384 L
.61905 .20332 L
.62381 .19415 L
.62857 .18637 L
.63333 .17993 L
.6381 .17471 L
.64286 .17053 L
.64762 .16722 L
.65238 .16459 L
.65714 .1625 L
.6619 .16083 L
.66667 .21524 L
.67143 .19717 L
.67619 .22521 L
.68095 .20609 L
.68571 .18941 L
.69048 .17483 L
.69524 .16239 L
.7 .15219 L
.70476 .14422 L
.70952 .13836 L
.71429 .13432 L
.71905 .13178 L
.72381 .13042 L
.72857 .12993 L
.73333 .13007 L
Mistroke
.7381 .28556 L
.74286 .20225 L
.74762 .18155 L
.75238 .16422 L
.75714 .14975 L
.7619 .13805 L
.76667 .12901 L
.77143 .12237 L
.77619 .11779 L
.78095 .11489 L
.78571 .11328 L
.79048 .11266 L
.79524 .11275 L
.8 .11336 L
.80476 .11434 L
.80952 .11559 L
.81429 .11702 L
.81905 .11857 L
.82381 .1202 L
.82857 .12187 L
.83333 .01949 L
.8381 .03761 L
.84286 .0468 L
.84762 .0525 L
.85238 .05648 L
.85714 .05949 L
.8619 .06187 L
.86667 .06384 L
.87143 .06551 L
.87619 .06696 L
.88095 .06825 L
.88571 .0694 L
.89048 .07044 L
.89524 .0714 L
.9 .0723 L
.90476 .07313 L
.90952 .07392 L
.91429 .07467 L
.91905 .07539 L
.92381 .07608 L
.92857 .10251 L
.93333 .09026 L
.9381 .0831 L
.94286 .07908 L
.94762 .07698 L
.95238 .07603 L
.95714 .07576 L
.9619 .07587 L
.96667 .07621 L
.97143 .07667 L
Mistroke
.97619 .14717 L
Mfstroke
0 g
gsave
.97619 .21823 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.02381 .20697 Mdot
.21429 .11538 Mdot
.30952 .03412 Mdot
.40476 .50012 Mdot
.5 .54929 Mdot
.54762 .40735 Mdot
.59524 .26475 Mdot
.66667 .26598 Mdot
.67619 .27934 Mdot
.7381 .35301 Mdot
.74286 .18034 Mdot
.83333 .04316 Mdot
.92857 .14808 Mdot
.97619 .21823 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{281.812, 174.188},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[R000`400?l00000o`00003ooooooolJ
ooooo`008?ooool2o`0003;ooooo0ol00004ooooo`;o0000;Oooool3o`0000Cooooo0_l00004oooo
o`;o0000:Oooool3o`0000?ooooo0ol00004ooooo`;o0000:?ooool5o`0000?ooooo0_l00004oooo
o`;o00004?ooool001oooooo00Co0000oooooooooooo0000<?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo0000;Oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo0000:Oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Vooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000?ooooo`00
7oooool01?l0003oooooooooool0000dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo0000:Oooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00003oooool001oooooo00Co0000oooooooooooo0000=?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0002Wooooo00?o0000ooooooooool0
1Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo02Sooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03Oooool0
01oooooo00Co0000oooooooooooo0000<?ooool4o`0000?ooooo00Co0000oooooooooooo0000;Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
0000:Oooool01?l0003oooooooooooooool4o`0000?ooooo00Co0000oooooooooooo00009oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000?ooooo`007oooool01?l0003oooooooooool0000`ooooo`03o`000?oooooooooo00Co
oooo00Co0000oooooooooooo0000;?ooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Xooooo`;o00000oooool00ol0003oooooooooo`04ooooo`04o`000?oo
ooooooooo`0002Oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00003oooool0023ooooo0_l0000aooooo`Go00000oooool2o`00
02kooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l0000Zooooo`04o`000?oooooooooo
ooooo`Go00000oooool2o`0002Wooooo0ol00004ooooo`;o00001?ooool2o`00013ooooo003ooooo
oa[ooooo003ooooooa[ooooo003ooooooa[ooooo003ooooooa[ooooo000KooooobOo00000_l00?lN
o`0000;o003o00?o0000o`00ool00?l0X_l0000@ooooo`006oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07oooo
o`;o003o2_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooo
oooo003oo`00o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00?o001oooooool007l00oooool00ol0
003oooooooooo`08ooooo`03o`000?l007oooooo00Sooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool07_ooool2o`00o`[ooooo00?o001oooooooooool02?ooool00ol0003o
ooooooooo`06ooooo`;o003o00?oooooo`00ool00?l05?ooool00ol007ooooooooooo`0Dooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo00?o0000o`00Ooooool05?ooool00ol007ooooooooooo`0Cooooo`03
o`00Oooooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
6oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01[ooooo0_l00?l2ooooo`;o003o
2_ooool00ol007ooooooooooo`0Aooooo`;o003o00?oooooo`00ool00?l05?ooool00ol007oooooo
ooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo
000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool06_ooool2o`00o`;ooooo0_l0
0?l:ooooo`03o`00Oooooooooooo017ooooo0_l00?l00ooooooo003oo`00o`0Dooooo`03o`00Oooo
oooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04ooo
ool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_oo
ool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Jooooo`;o003o00Cooooo
o`00ool00?oo003o2_ooool00ol007ooooooooooo`0@ooooo`?o003o00?oooooo`00ool00?l05?oo
ool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lDooooo`;oo`005Ooo
ool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_oo
ool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Jooooo`;o003o00Cooooo
o`00ool00?oo003o2_ooool00ol007ooooooooooo`0?ooooo`?o003o0_ooool2o`00oaCooooo00?o
001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5?ooool2ool001Gooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000K
ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool06_ooool2o`00o`04ooooool00?oo
003oo`00o`Gooooo0_l00?l3ooooo`03o`00Oooooooooooo00oooooo0ol00?l01?oooooo0000o`00
0?l00?lDooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaCooooo
0_oo000Eooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003ooooo
ooooo`0>ooooo`006oooool2o`0000Cooooo00?o001oooooooooool06_ooool2o`00o`04ooooool0
0?oo003oo`00o`Gooooo0_l00?l3ooooo`03o`00Oooooooooooo00oooooo0ol00?l4o`0001Cooooo
00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5?ooool3ool001Cooooo
00?o001oooooooooool01?ooool2o`00o`;ooooo00?o001oooooooooool00_ooool2o`00013ooooo
000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool06Oooool7o`00o`Gooooo0_l0
0?l3ooooo`03o`00Oooooooooooo00oooooo0ol00?l4o`0001Cooooo00?o001oooooooooool05?oo
ool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_oo
ool00ol007ooooooo`00O`0>ooooo`;o001o5?ooool2o`000003ool00?oooooooooo01;ooooo00?o
001oooooooooool00oooool3o`00o`;ooooo00?o001oooooooooool00oooool00ol0003ooooooooo
o`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Wooooo2?l00?l3
ooooo`?o003o0oooool00ol007ooooooooooo`0?ooooo`;o003o0_ooool2o`000003ool00?l00?oo
oooo01;ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o4oooool4
o`0001Cooooo00?o001oooooooooool00oooool3o`00o`;ooooo00?o001oooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo
01Wooooo2?l00?l3ooooo`?o003o0oooool00ol007ooooooooooo`0:ooooo`;o003o0_ooool3o`00
o`03oooooooo003oo`0000;oo`0000?o003oooooooooool04Oooool00ol007ooooooooooo`0Doooo
o`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooo001o00kooooo0_l007lCooooo`Co000000?oo`00ooooooooool02?ooool2o`00
o`Oooooo00?o001oooooooooool00oooool3o`00o`;ooooo00?o001oooooooooool00oooool00ol0
003oooooooooo`0>ooooo`005?ooool3o`0000Cooooo00?o0000ooooooooool00oooool00ol007oo
ooooooooo`0Iooooo`So003o0oooool3o`00o`?ooooo00?o001oooooooooool02_ooool2o`00o`;o
oooo0_l00?l2ooooo`Goo`004oooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00ko
oooo0_l007lCooooo`03ool00?l0003o000000;oo`002_ooool2o`00o`Oooooo00?o001ooooooooo
ool00oooool3o`00o`;ooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
5Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0
1_ooool2o`00oa7ooooo2?l00?l2ooooo`Co003o0oooool00ol007ooooooooooo`0:ooooo`;o003o
0_ooool2o`00o`;ooooo0_oo00001?l007ooo`00ool00?oo000Booooo`03o`00Oooooooooooo01Co
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooool007l03_ooool2o`00Oa?ooooo0_oo00001?l007ooo`00ool00?oo0009oooo
o`;o003o1oooool00ol007ooooooooooo`03ooooo`?o003o0_ooool00ol007ooooooooooo`03oooo
o`03o`000?oooooooooo00kooooo000<ooooo`Go000000?oooooo`000?l000000ol00004ooooo`03
o`000?oooooooooo00?ooooo00?o001oooooooooool01_ooool2o`00oa7ooooo2?l00?l2ooooo`Co
003o0oooool00ol007ooooooooooo`0:ooooo`;o003o0_ooool2o`00o`;ooooo0_oo00000ol007oo
003oool00003ool0013ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o
001o4oooool2ool00003o`00Ooooooooo`0000?oo`001oooool2o`00o`;ooooo0_l00?l3ooooo`03
o`00Oooooooooooo00?ooooo0ol00?l2ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooooooo
ool03_ooool001;ooooo00Co0000oooooooooooo00001Oooool3o`0000?ooooo00?o001ooooooooo
ool01Oooool3o`00oa7ooooo2?l00?l2ooooo`Co003o0oooool00ol007ooooooooooo`09ooooo`?o
003o0_ooool2o`00o`;ooooo0_oo00000ol007oo003oo`00o`06ool000gooooo00?o001ooooooooo
ool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o4oooool2ool00003o`00Oooooooooooo00Ko
o`000oooool3o`00o`;ooooo0_l00?l01?oooooo003oo`00ool007l4ooooo`Go003o00?oooooo`00
Ooooool00oooool2o`00013ooooo000Cooooo`03o`000?oooooo000000Gooooo00?o0000oooooooo
ool00oooool00ol007ooooooooooo`05ooooo`?o003o4Oooool8o`00o`;ooooo1?l00?l3ooooo`03
o`00Ool00?oo003o00Wooooo0ol00?l2ooooo`;o003o0_ooool2ool00003o`00Ool00?oo003o00;o
oooo1ooo000:ooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00Oa?o
oooo0_oo00000ol007ooooooooooo`02ooooo`Ooo`000ol00?l01Ooooooo003oo`00ool00?oooooo
00;o003o00?o001oooooooooool00_ooool2o`00o`05ooooool00?oo003oooooool007l01Oooool0
0ol0003oooooooooo`0>ooooo`005?ooool2o`0000Gooooo00?o0000ooooooooool00oooool00ol0
07ooooooooooo`05ooooo`?o003o4Oooool5o`00o`03ooooool00?oo003o00;ooooo1?l00?l3oooo
o`03o`00Ool00?oo003o00?oo`001_ooool3o`00o`04ooooool00?oo003oo`00o`;ooooo0_oo0000
0ol007oo003oo`00o`05ooooo`Woo`001Oooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
001o00kooooo0_l007l?ooooo`;o003o0_ooool2ool00003o`00Oooooooooooo00?ooooo0_l00?l8
ool000?o003o00Coooooo`00ool00?oo001o1?ooool2o`00o`05ooooool00?oo003oooooool007l0
1Oooool00ol0003oooooooooo`0>ooooo`005Oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00?ooooo00?o001oooooooooool01Oooool3o`00oa3ooooo1_l00?l00ooooooo003oo`00
o`02ooooo`Co003o0oooool>ool00004o`00oooooooo003oo`00o`;ooooo0ooo00000ol007oo003o
o`00o`08ooooo`_oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o
3_ooool3o`00o`;ooooo0_oo00000ol0nY[oooooooooo`03ooooo`;o003o0oooool;ool00004o`00
Ooooooooooooooooo`Ooo`0000?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
6oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00Gooooo0ol00?l@ooooo`;o003o
00Goooooo`00ool00?oo003oooooo`02o`00o`03ooooool00?oo003o00Co003o0_ooool4ool00003
o`00oooo003oo`0000ooo`000_l0nYX2o`00o`gooooo1_oo00000ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo0_l007l>ooooo`?o003o0_ooool2ool00003o`3jV_oooooooooo00?o
oooo0ol00?l3ooooo`?o003o1ooo00000ol007ooooooool00008ool00003o`00Oooooooooooo00?o
oooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oooooo
ooooo`05ooooo`?o003o4?ooool2o`00o`;ooooo0_l00?l01?oooooo003oo`00ooooool2o`00o`;o
oooo0_l00?l01?ooooooo`00ool00?oo0004o`00o`Kooooo00?o003oool00?oo00001ooo0002o`3j
VP;o003o4Oooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00
O`kooooo0ol00?l2ooooo`;oo`0000?o0?ZJooooooooool00oooool3o`00o`?ooooo1ol00?l01?oo
ooooo`00ool00?l007l4ool000;o003o00Goooooo`00oooo003oo`00o`00O`05ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool01Oooool4
o`00o`oooooo0_l00?l2ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l2ooooo`;o003o00?o
ooooool00?oo00001Ol00?l6ooooo`Ko003o0_ooool2ool000?o0?ZJ00?o003oooooooooool03ooo
ool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00O`kooooo1?l0
0?l00oooooooo`00ool00002o`3jVPCooooo0ol00?l3ooooo`Oo003o00Coooooool00?oo003o001o
0_oo0002ooooo`;o003o00Goooooo`00oooo003oo`00o`00O`05ooooo`03o`000?oooooooooo00ko
oooo000Kooooo`;o00001?ooool00ol007ooooooooooo`05ooooo`Co003o3oooool2o`00o`;ooooo
0_l00?l01?oooooo003oo`00ooooool2o`00o`;ooooo0_l00?l00oooooooo`00ool00005o`00o`Go
oooo1ol00?l4ooooo`?o0?ZJ0_l00?l@ooooo`;oo`0000?o001oooooooooool05?ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007oo
ooooo`00O`0>ooooo`;o001o3Oooool5o`00o`03oooooooo003oo`0000;o0?ZJ0oooool4o`00o`?o
oooo1ol00?l00oooooooo`00ool00003ool00006ooooool00?oo003oo`00oooooooo003o0_oo0000
0ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool00oooool00ol0
07ooooooooooo`05ooooo`Coo`003oooool2o`00o`;ooooo0_l00?l01?oooooo003oo`00ooooool2
o`00o`;ooooo0_l00?l00oooooooo`00ool00005o`00o`03ooooool00?oo003o00;ooooo0_l00?l0
0ooooooo003oo`00o`02o`00o`Cooooo0ol0nYX2o`00oa3ooooo0_oo00000ol007ooooooooooo`0D
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooo001o00kooooo0_l007l=ooooo`;o003o00Coooooo`00ool00?oooooo0_oo
0002o`3jVP?ooooo1_l00?l00ooooooo003oo`00o`07o`00o`?oo`000_ooool2o`00o`;ooooo00Co
003oool00?oo003o001o1Oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003ooooooooo
o`03ooooo`03o`00Oooooooooooo00?ooooo2ooo000:ooooo`;o003o0_ooool2o`00o`04ooooool0
0?oo003oooooo`;o003o0_ooool2o`00o`03oooooooo003oo`0000Go003o00?oooooo`00ool00?l0
0_ooool2o`00o`04ooooool00?oo003oo`00o`Gooooo1?l0nYX00ol00?ooooooooooo`0>ooooo`;o
o`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o3Oooool2o`00o`03
ooooool00?oo003o00?oo`000ol0nYX2ooooo`Ko003o00?oooooo`00ool00?l00_l00?l2ooooo`?o
003o0ooo0002ooooo`;o003o0_ooool01?l00?ooo`00ool00?l007l5ooooo`03o`000?oooooooooo
00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool00_ooool4ool00003
ooooool00?ooo`0000Soo`001oooool2o`00o`Gooooo1Ol00?l2ooooo`?o003o0_oo0005o`00o`03
ooooool00?oo003o00;ooooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`Go0?ZJ00?o003ooooo
ooooool03_ooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00
O`gooooo0_l00?l00ooooooo003oo`00o`02ool000Co0?ZJ0_ooool;o`00o`;ooooo0ol00?l2ool0
00;o003o00?oooooo`00ool00?l00_ooool01?l00?ooo`00ool00?l007l5ooooo`03o`000?oooooo
oooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00Co001ooooooooooooooooo0ooo0002
o`00o`03ooooool00?oo003o00Cooooo2?oo0003ooooo`;o003o1_ooool4o`00o`;ooooo0ol00?l2
o`0000So003o0_ooool2o`00o`04ooooool00?oo003oo`00o`Cooooo0_l0nYX01?l007oo0?ZJo`3j
V_l0nYX@ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o
3Oooool2o`00o`03ooooool00?oo003o00;oo`001Ol0nYX00ooooooo003oo`00o`06o`00o`03oooo
ool00?oo003o00;ooooo0ol00?l2ool000;o003o00?oooooo`00ool00?l00_ooool01?l00?ooo`00
ool00?l007l5ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo
00?o001oooooooooool00ooo00001?oooooo003oo`00ooooool2o`00o`Oooooo1ooo00000ooooooo
003oo`00o`06ooooo`Co003o0_ooool2o`00o`Co00000_l00?l00ooooooo003oo`00o`02o`00o`;o
oooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`;o0?ZJ00?o001oooooool0nYX00_l0nYX?oooo
o`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o1oooool8ool0
0003ooooool00?oo003o00;oo`000_l0nYX01?oooooo0?ZJo`3jV_ooool2o`00o`03ooooool00?oo
003o00?o003o1Oooool7o`00o`03ooooool00?oo003o00;ooooo00Co003oool00?oo003oo`001Ooo
ool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooo
o`0000;oo`000_ooool2o`00o`03ooooool00?oo003o00_ooooo1_oo0006ooooo`Co003o0_ooool2
o`00o`Co00000oooool4o`00o`;ooooo0_l00?l8ooooo`;o0?ZJ00?o001oooooool00?l00_l0nYX?
ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o1_ooool>
ool000;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_l00?l00ooooooo003oo`00o`03o`00o`Gooooo1ol0
0?l00ooooooo003oo`00o`02ooooo`;o003o0_oo0005ooooo`03o`000?oooooooooo00kooooo000K
ooooo`03o`000?oooooooooo00?ooooo00Co001ooooooooo003oo`000oooool2o`00o`03ooooool0
0?oo003o00gooooo1ooo0003ooooo`Co003o0_ooool2o`00o`04ool00?l0003o0000o`00o`?ooooo
1?l00?l2ooooo`;o003o2?ooool2o`3jVP03o`00Oooooooo003o00?o0?ZJ3_ooool2ool00003o`00
Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00O`Gooooo0ooo00000ol00?oooooo
ooooo`02ooooo`03o`00oooo003oo`0000Coo`000_l0nYX2ooooo`?o0?ZJ00?o003oooooool00?l0
1?l00?l5ooooo`[o003o0oooool00ol00?ooo`00ool00005ooooo`03o`000?oooooooooo00kooooo
000Kooooo`;o00001?ooool01?l007ooo`00ool00?oo0003ooooo`;o003o00Coooooo`00ool00?oo
003o3Oooool2o`00o`Ooo`001?l00?l2ooooo`;o003o0_oo0002o`00o`?ooooo1Ol00?l00ooooooo
003oo`00o`08ooooo`;o0?ZJ00Co001oooooool00?oo003o1?l0nYX<ooooo`;oo`0000?o001ooooo
ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o1Oooool2ool000;o003o0oooool3o`00
o`03ooooool00?ooo`0000;oo`000_l0nYX3ooooo`?o0?ZJ0oooool3o`00o`Gooooo1Ol00?l01?oo
oooo003oo`00ool00?l4ooooo`03o`00oooo003oo`0000Cooooo0_l0000@ooooo`006oooool00ol0
003oooooooooo`03ooooo`03o`00Oooo003oo`0000Cooooo0_l00?l2ooooo`;o003o3Oooool2o`00
o`?ooooo1_oo00001?l00?ooooooooooooooool2o`00o`;oo`0000?o001oooooooooool00_ooool5
o`00o`03ooooool00?oo003o00Sooooo00Co0?ZJool00?oo003ooooo0_l00?l00ooooooo0?ZJo`3j
VP03o`3jVP[ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00Sooooo1_oo
0002o`00O`Cooooo0ooo0002o`00o`?ooooo0_l00?l2ooooo`?o003o0_l0nYX00ol007oooooooooo
o`02ooooo`Go0?ZJ0ol00?l5ooooo`Go003o00Coooooo`00ool00?oo003o1?ooool00ol00?ooo`00
ool00005ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo0ooo
0004ooooo`;o003o0_ooool3o`00o`cooooo0_l00?l6ooooo`Soo`0000Co003oool00?oo003o001o
1?ooool5o`00o`03ooooool00?oo003o00Sooooo00Co0?ZJool00?oo003ooooo0ol00?l2ooooo`Co
0?ZJ2Oooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l01oooool7ool000;o
001o1?ooool2ool00003ooooool00?oo003o00?ooooo0_l00?l2ooooo`?o003o00?o0?ZJool00?oo
00001?ooool00ol00?oo0?ZJo`3jVP03o`3jVP;o003o1Oooool2o`00o`04ooooool00?oo003ooooo
o`?o003o1?ooool00ol00?ooo`00ool00005ooooo`03o`000?oooooooooo00kooooo000Kooooo`03
o`000?oooooooooo00?ooooo0_oo0005ooooo`;o003o0oooool3o`00o`_ooooo0_l00?l7ooooo`03
o`00oooo003oo`0000Ooo`000_l0nYX3ooooo`Go003o00?oooooo`00ool00?l02?ooool01Ol0nY[o
o`00ool00?oo003ooooo00;o003o1?ooool4o`3jVPOooooo0_oo00000ol007ooooooooooo`0Doooo
o`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooo001o00Kooooo0ooo0003ooooo`;oo`000_l007l3ooooo`?oo`0000?oooooo`00
ool00?l00_l00?l00ooooooo003oo`00o`03ooooo`;o003o00?o0?ZJool00?oo00001?ooool2o`00
o`;ooooo1?l0nYX9ooooo`03o`00Oooooooooooo00;o003o1?ooool00ol00?ooo`00ool00005oooo
o`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo0_oo0005ooooo`;o
003o1?ooool2o`00o`_ooooo0_l00?l8ooooo`;o003o0oooool4ool000Ko0?ZJ1ol00?l8ooooo`05
o`3jV_oo003oo`00ool00?ooool00ol00?l4ooooo`Go0?ZJ1Oooool2ool00003o`00Oooooooooooo
01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooool007l01Oooool3ool000Cooooo0_oo0002o`00O`?ooooo0_oo0002oooo
o`Co003o00?oooooo`00ool00?l00oooool2o`00o`04o`3jV_oo003oo`00ool000;ooooo0ol00?l3
ooooo`Go0?ZJ1_ooool2o`0000;ooooo0_l00?l4ooooo`03o`00oooo003oo`0000Gooooo00?o0000
ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool2ool000Cooooo0ol00?l4oooo
o`;o003o1oooool2o`00o`;ooooo0_l00?l8ooooo`;o003o1_ooool9o`3jVPCo003o2Oooool01Ol0
nY[oo`00ool00?oo003ooooo00?o003o1_ooool6o`3jVP;ooooo0_oo00000ol007ooooooooooo`0D
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooo001o00Gooooo0_oo0005ooooo`;oo`000_l007l2ooooo`?oo`000_ooool4
o`00o`03ooooool00?oo003o00?ooooo0_l00?l01?l0nY[oo`00ool00?oo0002ooooo`;o003o1_oo
ool6o`3jVP;ooooo1?l00003o`3jVPCooooo00?o003oool00?oo00001Oooool00ol0003ooooooooo
o`0>ooooo`006oooool00ol0003oooooooooo`02ooooo`?oo`001?ooool2o`00o`Gooooo0ol00?l6
ooooo`;o003o0_ooool2o`00o`Sooooo0_l00?l6ooooo`;o0?ZJ1?ooool5o`3jVP;o003o2?ooool2
o`3jVPCoo`001?l00?l7ooooo`Ko0?ZJ0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`09ooooo`;o003o0oooool0
0ol007ooooooo`00O`04ooooo`?oo`001Oooool2ool000;o001o0_ooool2ool00003ooooool00?oo
003o00Oo003o0oooool2o`00o`04o`3jV_oo003oo`00ool000;ooooo0_l00?l8ooooo`Ko0?ZJ1?l0
0006o`3jVP04ooooool00?ooo`00ool000Gooooo00?o0000ooooooooool03_ooool001_ooooo0_l0
0003ooooo`;oo`001Oooool2o`00o`Kooooo0_l00?l6ooooo`;o003o0_ooool2o`00oa3ooooo0_l0
nYX5ooooo`03o`00ool0nY[o0?ZJ00Go0?ZJ1_ooool2o`3jVPCoo`001?l00?l:ooooo`?o0?ZJ0_oo
00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`09ooooo`;o003o0oooool00ol007ooooooo`00O`04ooooo`;oo`001_oo
ool2ool000;o001o0_ooool2ool000[o003o0oooool2o`00o`03o`3jV_oo003oo`0000;oo`0000?o
ooooo`00ool00?l02oooool4o`3jVP;o000000?o0?ZJooooooooool01ol0nYX00ol007oooooooooo
o`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool00_ooool2ool000Gooooo0_l00?l6
ooooo`;o003o1_ooool2o`00o`;ooooo0_l00?l@ooooo`;o0?ZJ1Oooool3o`00o`Oo0?ZJ1?ooool2
o`3jVPCoo`001?l00?l<ooooo`04o`3jV_oo003oo`00o`00OaKooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Wooooo0_l00?l01_ooooooo`00ool0
0?l007ooooooo`00O`?ooooo0ooo0006ooooo`;oo`000_l007l01?ooooooo`00ool00?oo000:o`00
o`?ooooo0_l00?l00ol0nY[oo`00ool00002ool00003ooooool00?oo003o00gooooo0ol0nYX00ol0
07ooooooooooo`04ooooo`Co0?ZJ00?o001oooooooooool00oooool00ol0003oooooooooo`0>oooo
o`006oooool00ol0003oooooooooo`02ooooo`;oo`001Oooool2o`00o`Kooooo0ol00?l5ooooo`Ko
003o4?ooool2o`3jVPGooooo1_l00?l00ooooooo0?ZJo`3jVP04o`3jVP03ooooool0nY[o0?ZJ00Go
o`000ol00?l=ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02Oooool00ol00?ooo`00ool00002ool00003
o`00Oooooooo001o00?ooooo0_oo0007ooooo`;oo`000_l007l3ool000[o003o1?ooool2o`00o`03
o`3jV_oo003oo`0000;oo`0000?oooooo`00ool00?l04?ooool00ol007ooooooooooo`06ooooo`;o
0?ZJ00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003ooooo
ooooo`03ooooo`03o`00Oooooooooooo00?ooooo0_l00?l7ooooo`;o003o1?ooool6o`00oa7ooooo
0_l0nYX7ooooo`Co003o0oooool6o`3jVP?oo`0000Coooooool00?oo003ooooo0ol00?l<ooooo`;o
o`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool02Oooool5ool00003o`00Oooooooo001o00?ooooo0_oo0007ooooo`;o
o`000_l007l2ool00003ooooool00?oo003o00So003o1_ooool00ol0nY[oo`00ool00003ool000;o
003o4?ooool00ol007ooooooooooo`06ooooo`;o0?ZJ00?o003oooooooooool00oooool00ol0003o
ooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00?ooooo
0_l00?l7ooooo`;o003o1?ooool6o`00oa7ooooo0_l0nYX7ooooo`Co003o1_ooool3o`3jVP;oo`00
00?o001ooooooooo00000_oo00000ooooooo003oo`00o`0<ooooo`;oo`0000?o001oooooooooool0
5?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
1oooool4ool00004o`00oooo003oo`00o`00O`;o003o0_ooool3ool000Oooooo0_oo0002o`00O`;o
o`0000Coooooo`00ool00?oooooo0_l00?l3ooooo`;o003o1_ooool01?l0nY[oo`00ool00?ooool2
ool00003o`00oooooooooooo00oooooo00?o001oooooooooool01_ooool2o`3jVP03o`00oooooooo
oooo00?ooooo00?o0000ooooooooool03_ooool001;ooooo1Ol00004ooooo`03o`000?oooooooooo
00?ooooo00?o001oooooooooool00oooool2o`00o`Oooooo0_l00?l4ooooo`Ko003o4Oooool2o`3j
VPSooooo0ol00?l8ooooo`04o`3jV_oo003oo`00o`00O`;ooooo0_oo00000ooooooo003oo`00o`0<
ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool01_ooool4ool000;o003o0_oo00000ol007oo003oo`00o`02
ooooo`;oo`000_ooool2o`00o`Cooooo0_oo0002o`0000;oo`0000Coooooo`00ool00?oooooo0_l0
0?l3ooooo`;o003o1_ooool01?l0nY[oo`00ool00?l00?l3ool0017ooooo00?o001oooooooooool0
1_ooool2o`3jVP03o`00oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001?ooooo00Co
0000oooooooooooo00001?ooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00?ooooo
0_l00?l7ooooo`;o003o1?ooool4o`00oa?ooooo0_l0nYX8ooooo`?o003o2Oooool2ool00003o`00
Oooooooooooo00?oo`000_l00?l<ooooo`;oo`0000?o001oooooooooool05?ooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool01Oooool3ool000Co003o
0_oo00000ol007oo003oo`00o`02ooooo`;oo`000_ooool2o`00o`Cooooo00?oo`00o`000?l00000
0_l000001Ol00?ooooooo`00ool00?oooooo00;o003o2oooool00ol0nY[oo`00ool00002o`00o`?o
o`004?ooool00ol007ooooooooooo`06ooooo`?o0?ZJ1Oooool00ol0003oooooooooo`0>ooooo`00
3?ooool5o`0000?ooooo00?o0000ooooooooool01?ooool3o`0000?ooooo00?o001oooooooooool0
0_ooool3o`00o`Oooooo0ol00?l3ooooo`Co003o4oooool2o`3jVPSooooo0ol00?l9ooooo`;oo`00
00Co001ooooooooooooooooo0ooo00000ol00?ooooooooooo`0:ooooo`;oo`0000?o001ooooooooo
ool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool01?ooool3ool00003ooooool00?oo003o00;o003o0_oo00001?l007oo003oo`00ooooool3ool0
00Co003o1?ooool00ooo003o0000o`000002o`0000Co003o00?oooooo`00ool00?l02oooool00ol0
nY[oo`00ool00002o`00o`03oooooooo003oo`00013ooooo00?o001oooooooooool01oooool2o`3j
VPCooooo0_l0000@ooooo`005Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o001oooooooooool00_ooool2o`00o`Wooooo0_l00?l3ooooo`;o003o5Oooool2o`3jVPSo
oooo0_l00?l:ooooo`;oo`0000?o001oooooooooool00_ooool3ool000cooooo0_oo00000ol007oo
ooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`04ooooo`;oo`000_ooool4o`00o`?oo`000ol00?l2ool00003ooooool00?oo003o00;o
003o1?ooool2ool000;o000000Coo`00o`00ool00?oo003o3oooool00ol0nY[oo`00ool00002o`00
o`04oooooooo003oo`00ool000oooooo00?o001oooooooooool01oooool2o`3jVPGooooo00?o0000
ooooooooool03_ooool001;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooo
oooo00?ooooo00?o001oooooooooool00_ooool2o`00o`Wooooo0_l00?l00ooooooo003oo`00o`02
o`00oaGooooo0_l0nYX8ooooo`;o003o2_ooool2ool00003o`00Oooooooooooo00?ooooo0ooo000;
ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool00oooool3ool000;ooooo1?l00?l00oooooooo`00ool00003
o`00o`;oo`0000?oooooo`00ool00?l00_l00?l4ooooo`Goo`000ol00?l?ooooo`03o`3jV_oo003o
o`0000;o003o0_ooool4ool000gooooo00?o001oooooooooool01oooool2o`3jVPGooooo00?o0000
ooooooooool03_ooool001;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooo
oooo00?ooooo00?o001oooooooooool00_ooool2o`00o`Wooooo0_l00?l00ooooooo003oo`00o`02
o`00oaGooooo0_oo000Dooooo`;oo`0000?o001oooooooooool00oooool01?l00?ooo`00ool00?oo
000:ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00oooool2ool000?ooooo1Ol00?l3ool000;o003o0_oo
0005o`00o`Cooooo1?oo0004o`00o`oooooo00?o0?ZJool00?oo00000_l00?l3ooooo`Coo`003?oo
ool00ol007ooooooooooo`07ooooo`;o0?ZJ1Oooool00ol0003oooooooooo`0>ooooo`004oooool3
o`0000Gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l00?l9ooooo`Oo003o5Oooool3
ool001?ooooo0_oo00000ol007ooooooooooo`04ooooo`04o`00oooo003oo`00ool000Wooooo0ooo
000Cooooo`?oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00;ooooo0ooo0003ooooo`;o003o00?oooooo`00ool00?l00ooo00001?l00?ooo`00ool0
0?oo0005o`00o`Cooooo1?oo0004o`00o`oooooo00Co0?ZJool00?oo003o003o1_ooool3ool000[o
oooo0_oo0009ooooo`;o0?ZJ1Oooool00ol0003oooooooooo`0>ooooo`006oooool01?l0003ooooo
ooooooooool4o`0000Oo0?ZJ1oooool6o`00oaKooooo1?oo000Booooo`;oo`0000?o001ooooooooo
ool01?ooool2o`00o`?oo`002?ooool00ol0nY[oo`00ool0000Booooo`Coo`0000?o001ooooooooo
ool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_oo0003ooooo`?o
003o00?oooooo`00ool00?l00ooo00001?l00?ooo`00ool00?ooool2o`00o`04ooooool00?oo003o
o`00o`?ooooo1?oo0004o`00o`oooooo00?o0?ZJool00?oo00002?ooool3ool000Wooooo0ooo0009
ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00Co0000oooo
oooooooooooo1?l00009o`3jVPGooooo1_l00?lFooooo`Koo`004?ooool2ool00003o`00Oooooooo
oooo00Cooooo0_l00?l01?ooooooo`00ool00?oo0007ooooo`03o`3jV_oo003oo`00017ooooo1Ooo
00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00Co001ooooooooooooooooo
0ooo00000ooooooo003oo`00o`02o`00o`;ooooo0_l00?l3ool00004o`00oooo003oo`00ooooo`;o
003o0_ooool2o`00o`?ooooo1?oo00001?l00?ooooooo`00ool00?l?ooooo`?oo`002Oooool3ool0
00Sooooo0ooo0009ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_o
oooo0_l00003ooooo`;o00000_l0nYX2ooooo`;o003o00?oooooo`3jV_l0nYX00_l0nYX4ooooo`Ko
003o5_ooool2ool00003oooooooo003oo`0000;oo`003oooool2ool00003o`00Oooooooooooo00Co
oooo1?l00?l3ool000Kooooo00?o0?ZJool00?oo00004?ooool3ool00004oooooooo003oo`00o`00
O`[ooooo00?o001oooooooooool02?ooool2o`00o`;ooooo0_oo0002ooooo`Co003o0_ooool2o`00
o`Koo`0000?oooooo`00ool00?l00_ooool2o`00o`Cooooo0ooo00001?l00?ooooooo`00ool00?l?
ooooo`;oo`0000?o001oooooooooool02?ooool3ool000Oooooo1Ooo0007ooooo`;o00000oooool2
o`00013ooooo000Kooooo`03o`000?oooooooooo00;ooooo0_l0nYX4ooooo`;o003o0oooool5o`3j
VP03ooooool00?oo003o00Co003o5Oooool00ol0nY[oo`00ool00003ooooo`?oo`003_ooool2ool0
0003o`00Oooooooooooo00Cooooo1?l00?l00oooooooo`00ool00003ool000?ooooo00?o0?ZJool0
0?oo00003oooool3ool000;ooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00Sooooo0_l00?l2ooooo`;oo`000_ooool4o`00o`;ooooo0_l00?l5ool00004o`00oooooooo003o
o`00o`;ooooo0_l00?l4ooooo`?oo`0000?o003oooooooooool04?ooool2ool00003o`00Oooooooo
oooo00Wooooo0ooo0006ooooo`Koo`001Oooool4o`0000?ooooo00?o0000ooooooooool03_ooool0
01_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`02ooooo`;o003o1?ooool5o`3j
VPCo003o5oooool00ol0nY[oo`00ool00004ooooo`?oo`003Oooool2ool00003o`00Oooooooooooo
00Gooooo0ol00?l2ooooo`Goo`000_ooool00ol0nY[oo`00ool0000?ooooo`;oo`000oooool2ool0
0003o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool3o`00o`?oo`000_ooool3o`00
o`?ooooo1?l00?l3ool00004o`00oooooooo003oo`00o`;ooooo0_l00?l4ooooo`?oo`0000?o003o
ooooooooool03oooool01?l0nY[oo`00ool00?l007l<ooooo`Goo`000_ooool3ool000;ooooo1?oo
0003ooooo`Co00000oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03
ooooo`03o`00Oooooooooooo00;ooooo0_l00?l7ooooo`?o0?ZJ0ol00?lGooooo`03o`3jV_oo003o
o`0000Gooooo1?oo000;ooooo`;oo`0000?o001oooooooooool01Oooool3o`00o`Gooooo0ooo0000
1?oooooo0?ZJool00?oo000>ooooo`?oo`000oooool2ool00003o`00Oooooooooooo00Sooooo00?o
001oooooooooool02?ooool3o`00o`;oo`000oooool3o`00o`?ooooo1?l00?l3ool00004o`00oooo
oooo003oo`00o`;ooooo0_l00?l4ooooo`?oo`0000?o003oooooooooool03oooool01?l0nY[oo`00
ool00?l007l=ooooo`Goo`0000Coooooool00?oo003o001o0oooool4ool000?ooooo0_l00004oooo
o`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001ooooooooo
ool00_ooool2o`00o`Sooooo1?l0nYXHooooo`03o`3jV_oo003oo`0000Kooooo1?oo0009ooooo`?o
o`0000?o001oooooooooool01_ooool2o`00o`Kooooo1_oo000=ooooo`?oo`001?ooool2ool00003
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool3o`00o`;oo`000oooool2o`00o`Co
oooo1?l00?l2ool000;o003o00?oooooo`00ool00?l00_ooool2o`00o`Cooooo0ooo00000ol00?oo
ooooooooo`0?ooooo`04o`3jV_oo003oo`00o`00Oa3ooooo1Ooo00000ol007ooooooooooo`03oooo
o`?oo`000_ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03
o`000?oooooooooo00?ooooo00?o001oooooooooool00_ooool2o`00o`Wooooo1?l0nYXGooooo`03
o`3jV_oo003oo`0000Sooooo1Ooo0006ooooo`;oo`0000?oooooo`00Ooooool01oooool2o`00o`Oo
oooo1Ooo000<ooooo`?oo`001Oooool2ool00003o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool02?ooool2o`00o`?oo`000oooool2o`00o`Cooooo1Ol00?l01?l007oo003oo`00ooooool2o`00
o`;ooooo0ol00?l3ooooo`?oo`0000?o003oooooooooool01Ol0nYX:ooooo`04o`3jV_oo003oo`00
o`00Oa7ooooo1?oo00000ol007ooooooooooo`04ooooo`Coo`0000?o001oooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`04o`00Oooooooooooo
ooooo`?o003o2_ooool01?l00?oo0?ZJo`3jV_l0nYXFooooo`03o`3jV_oo003oo`0000Wooooo1Ooo
0005ooooo`;oo`0000?oooooo`00Ooooool01oooool2o`00o`Wooooo0ooo000<ooooo`;oo`001_oo
ool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool01?l00?ooo`00ool0
0?oo0003ooooo`?o003o1?ooool4o`00o`03ooooool007oo003o00Co003o0oooool2o`00o`?ooooo
0ooo000:o`3jVPSooooo00Co0?ZJool00?oo003o001o4oooool2ool00003o`00Oooooooooooo00Go
oooo0ooo00000ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`00
0?oooooooooo00?ooooo00Co001ooooooooooooooooo0_l00?l;ooooo`;o003o1?l0nYXDooooo`03
o`3jV_oo003oo`0000cooooo1?oo0003ooooo`;oo`0000?oooooo`00Ooooool01oooool3o`00o`So
oooo0ooo000:ooooo`Coo`001_ooool2ool00003o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool01oooool2o`00o`;oo`0000Co003ooooooooooooooooo0_l00?l5ooooo`?o003o00?o001ooooo
ool007l01?l00?l4ooooo`;o003o0oooool3ool000Co0?ZJ0oooool5o`3jVPKooooo00Co0?ZJool0
0?oo003o001o5Oooool00ol007ooooooooooo`06ooooo`?oo`001Oooool00ol0003oooooooooo`0>
ooooo`006oooool2o`0000Cooooo00Co001ooooooooooooooooo0_l00?l>ooooo`Co0?ZJ4oooool0
0ol0nY[oo`00ool0000=ooooo`Coo`000_ooool2ool00003ooooool007oooooo00Sooooo0_l00?l8
ooooo`?oo`002Oooool4ool000Oooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00Oooooo00Go003oool00?oo003oo`00o`00o`03ooooo`;o003o1_ooool2o`00o`03o`00Oooo
oooo001o00Co003o1?ooool3o`00o`;ooooo0ooo00000ol0nY[oooooooooo`06ooooo`Co0?ZJ1Ooo
ool01?l0nY[oo`00ool00?l007lEooooo`03o`00Oooooooooooo00Oooooo0_oo0004ooooo`;o0000
4?ooool001_ooooo00?o0000ooooooooool00oooool01?l007ooooooooooooooool2o`00oa3ooooo
0ol0nYXBooooo`03o`3jV_oo003oo`0000oooooo1_oo00000ooooooo001oooooo`08ooooo`;o003o
2?ooool3ool000Wooooo0_oo0009ooooo`;oo`0000?o001oooooooooool02?ooool00ol007oooooo
ooooo`07ooooo`03o`00oooo003oo`0000;o003o0oooool2o`00o`Kooooo0_l00?l00ol007oooooo
o`00O`04o`00o`Gooooo0_l00?l2ooooo`;oo`0000?o0?ZJooooooooool02Oooool4o`3jVP?ooooo
00Co0?ZJool00?oo003o001o5Oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?o
oooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool01?l007oooooo
ooooooooool2o`00oa7ooooo1?l0nYX@ooooo`03o`3jV_oo003oo`00013ooooo1Ooo00000ooooooo
001oooooo`08ooooo`;o003o2?ooool3ool000Sooooo0ooo0009ooooo`;oo`0000?o001ooooooooo
ool02?ooool00ol007ooooooooooo`07ooooo`03o`00oooo003oo`0000;o003o0oooool2o`00o`Ko
oooo0_l00?l01?l007ooooooo`00Ooooool3o`00o`Gooooo0_l00?l2ooooo`;oo`0000?o0?ZJoooo
ooooool02_ooool4o`3jVP;ooooo00Co0?ZJool00?oo003o001o5Oooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000oooo
ooooool00oooool01?l007oo003oo`00ooooool2o`00oa;ooooo1?l0nYX?ooooo`03o`3jV_oo003o
o`0001;ooooo0ooo00000ooooooo001oooooo`08ooooo`;o003o2?ooool3ool000Oooooo0ooo000:
ooooo`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`07ooooo`;o000000?oo`00
o`00ool00?l00oooool2o`00o`Kooooo00Ko003oo`000?l0003oooooo`00Ooooool3o`00o`Gooooo
0_l00?l2ooooo`;oo`0000?o0?ZJooooooooool03?ooool3o`3jVP05ooooool0nY[oo`00ool00?l0
07l05Oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooooooo
ool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oo003oo`00o`03o`00oaCooooo
0ol0nYX>ooooo`03o`3jV_oo003oo`0001?ooooo0_oo00000ooooooo001oooooo`08ooooo`;o003o
2?ooool3ool000Oooooo0_oo000;ooooo`;oo`0000?o001oooooooooool02?ooool00ol007oooooo
ooooo`06ooooo`Co00000_l00?l3ooooo`;o003o1_ooool4o`000003o`00Oooooooo003o00;o003o
1Oooool2o`00o`;ooooo0_oo00000ol0nY[oooooooooo`0=ooooo`Co0?ZJ0_oo00000ol007oooooo
ooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003ooooo
ooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Ool00?oo003o00?o003o5Ooo
ool5o`3jVP_ooooo00?o0?ZJool00?oo00005_ooool00ol007ooooooooooo`07ooooo`;o003o2?oo
ool3ool000Kooooo0ooo000;ooooo`;oo`0000?o001oooooooooool02?ooool00ol007oooooooooo
o`06ooooo`Co00000ol00?l2ooooo`;o003o1_ooool4o`000003o`00Oooooooo0?ZJ00So0?ZJ0ol0
0?l2ool00003o`3jV_oooooooooo00kooooo0ol0nYX2ool00003o`00Oooooooooooo01?ooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000K
ooooo`03o`000?oooooooooo00;ooooo0_oo0002o`00o`03ooooool00?oo003o01Kooooo1Ol0nYX:
ooooo`03o`3jV_oo003oo`0001Kooooo00?o001oooooooooool01oooool2o`00o`Sooooo0ooo0005
ooooo`?oo`003?ooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool01oooool2
o`0000;ooooo1_l00?l6ooooo`04o`00ool0003o0000o`3jVP;o00002ol0nYX01?l00?ooo`00ool0
0?l0nYXAooooo`;o0?ZJ0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool2o`0000?ooooo0_oo
0002o`00oacooooo1?l0nYX8ooooo`03o`3jV_oo003oo`0001Kooooo00?o001oooooooooool01ooo
ool2o`00o`Sooooo0ooo0005ooooo`;oo`003Oooool2ool00003o`00Oooooooooooo00Sooooo00?o
001oooooooooool01oooool2ool000;ooooo1_l00?l7ooooo`;o0?ZJ1?l00007ooooo`Co0?ZJ0_oo
00000ol0nY[oooooooooo`0Aooooo`;oo`0000?o001oooooooooool04oooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00;ooooo0_l0000@ooooo`006oooool00ol0003oooooooooo`02
ooooo`?oo`0000?o003oooooooooool06oooool4o`3jVPOooooo00?o0?ZJool00?oo00005_ooool0
0ol007ooooooooooo`07ooooo`;o003o2?ooool3ool000Cooooo0ooo000=ooooo`;oo`0000?o001o
ooooooooool02?ooool00ol007ooooooooooo`07ooooo`;oo`000_ooool5o`00o`Sooooo0_l0nYX4
o`0000Sooooo00?o003oo`3jV_l0nYX00_oo00000ol0nY[oooooooooo`0Aooooo`;oo`0000?o001o
ooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000
ooooooooool03_ooool001_ooooo00?o0000ooooooooool00_ooool00ol00?ooo`00ool0000Poooo
o`Co0?ZJ1Oooool00ol0nY[oo`00ool0000Fooooo`03o`00Oooooooooooo00Oooooo0_l00?l8oooo
o`?oo`000oooool3ool000kooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00Oooooo0_oo0002ooooo`Go003o2?ooool2o`3jVP03ooooool0003o000000[ooooo00Go003oo`3j
V_oo003oo`00o`3jVP0Cooooo`;oo`0000?o001oooooooooool04oooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000oooo
ooooool00_ooool01?l00?ooo`00ool00?oo000Pooooo`Oo0?ZJ00Coooooo`3jV_oo003oo`005_oo
ool00ol007ooooooooooo`07ooooo`?o003o1oooool3ool000?ooooo0_oo000?ooooo`;oo`0000?o
001oooooooooool02?ooool00ol007ooooooooooo`07ooooo`;oo`000_ooool5o`00o`Sooooo0_l0
nYX00ooooooo001oooooo`0:ooooo`05o`00ool0nY[oo`00ool00?l0nYX04oooool2ool00003o`00
Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`00
0?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o003oool00?oo00000_oo
000Pooooo`Oo0?ZJ0_oo000Fooooo`03o`00Oooooooooooo00Sooooo0_l00?l7ooooo`?oo`000_oo
ool3ool000oooooo0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o
003oool00?oo00000_ooool5o`00o`Sooooo0_l0nYX00ooooooo001oooooo`0:ooooo`03o`00ool0
nY[o0?ZJ00;oo`004oooool2ool00003o`00Oooooooooooo01?ooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Dooooo`;o00001Oooool0
0ol0003oooooooooo`03ooooo`;o003o1?oo000Sooooo`?o0?ZJ0_oo000Fooooo`03o`00Oooooooo
oooo00Sooooo0_l00?l7ooooo`?oo`0000Coooooool00?oo003oo`004?ooool2ool00003o`00Oooo
oooooooo00Sooooo00?o001oooooooooool01_ooool00ol00?ooo`00ool00002ooooo`Co003o2?oo
ool3o`3jVP03ooooool007oooooo00[ooooo00?o003oo`3jV_l0nYX00_oo000Cooooo`;oo`0000?o
001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001?ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooooooo
o`03ooooo`;o003o0_ooool2ool002Kooooo0_oo000Fooooo`03o`00Oooooooooooo00Sooooo0_l0
0?l7ooooo`Koo`004Oooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool01_oo
ool00ol00?ooo`00ool00002ooooo`Co003o2?ooool2o`3jVP03o`00Oooooooo001o00cooooo0_l0
nYX3ool001;ooooo0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`004oooool01?l0003oooooooooool0
0004ooooo`?o00000oooool01?l007ooooooooooooooool3ool002Gooooo0_oo000Fooooo`03o`00
Oooooooooooo00Sooooo0_l00?l7ooooo`Goo`004_ooool2ool00003o`00Oooooooooooo00Sooooo
00?o001oooooooooool01_ooool00ol00?ooo`00ool00002ooooo`Co003o2?ooool2o`3jVP03o`00
Oooooooo001o00cooooo0_l0nYX3ool001;ooooo0_oo00000ol007ooooooooooo`0Cooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool00_ooool2o`00013ooooo000Cooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`02ooooo`?oo`00
9?ooool2ool001Kooooo00?o001oooooooooool02?ooool2o`00o`Oooooo1Ooo000Booooo`;oo`00
00?o001oooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00oooo003oo`0000?ooooo
0_l00?l9ooooo`;o0?ZJ00?o001oooooool007l03?ooool2o`3jVP?oo`004_ooool2ool00003o`00
Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`00
0?oooooooooo00kooooo000Cooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0
0oooool00ol007ooooooooooo`03ooooo`?oo`008oooool2ool001Kooooo00?o001oooooooooool0
2?ooool2o`00o`Oooooo1?oo000Cooooo`;oo`0000?o001oooooooooool02?ooool00ol007oooooo
ooooo`06ooooo`?oo`000oooool2o`00o`Sooooo0ol0nYX00ol007ooooooo`00O`0<ooooo`03o`00
ool0nY[oo`0000?oo`004Oooool2ool00003o`00Oooooooooooo01?ooooo00?o001oooooooooool0
2?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Cooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`04ooooo`?oo`00
8_ooool2ool001Kooooo00?o001oooooooooool02?ooool2o`00o`Oooooo1?oo000Cooooo`;oo`00
00?o001oooooooooool02?ooool00ol007ooooooooooo`06ooooo`;oo`001Ol0nYX00ol00?oooooo
o`3jVP09o`3jVP03o`00Oooooooo001o00cooooo00?o003oo`3jV_oo00000ooo000Aooooo`;oo`00
00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo
00?o0000ooooooooool03_ooool001Cooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o
001oooooooooool01Oooool3ool0027ooooo0_oo000Fooooo`03o`00Oooooooooooo00Sooooo0_l0
0?l7ooooo`?oo`005?ooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool01_oo
ool2ool000oo0?ZJ0_ooool00ol007ooo`00ool0000<ooooo`03o`00ool0nY[oo`0000Coo`004?oo
ool2ool00003o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001o
ooooooooool01_ooool3ool001oooooo0ooo000Fooooo`03o`00Oooooooooooo00Sooooo0_l00?l7
ooooo`?oo`005?ooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool01_ooool2
ool00004o`3jV_ooooooooooooooo`Co0?ZJ2?ooool4ool000cooooo00Go003oo`3jV_oo003oo`00
ooooo`03ool000oooooo0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003ooooooooo
o`03ooooo`03o`00Oooooooooooo00Oooooo0_oo000Oooooo`;oo`0000?o001oooooooooool05?oo
ool00ol007ooooooooooo`08ooooo`;o003o1oooool3ool001Cooooo0_oo00000ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00Kooooo0_oo00001?l0nY[oooooooooooooool2o`00o`[ooooo
1Ooo000<ooooo`03o`3jV_oo003oo`0000;ooooo0_oo000?ooooo`;oo`0000?o001oooooooooool0
4oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool0
3_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`07ooooo`Coo`007Ooo
ool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool3o`00o`Oooooo0_oo
000Dooooo`?oo`002_ooool00ol007ooooooooooo`06ooooo`;oo`0000Co0?ZJoooooooooooooooo
0_l00?l:ooooo`Goo`003?ooool00ol0nY[oo`00ool00002ooooo`?oo`003_ooool2ool00003o`00
Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`00
0?oooooooooo00kooooo000Kooooo`;o00001?ooool00ol007ooooooooooo`08ooooo`Coo`007?oo
ool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02Oooool2o`00o`Oooooo0_oo
000Eooooo`;oo`002_ooool00ol007ooooooooooo`04ooooo`;o003o0_oo00000ol0nY[ooooooooo
o`0=ooooo`Koo`002oooool00ol0nY[oo`00ool00003ooooo`?oo`003Oooool2ool00003o`00Oooo
oooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o00004?oo
ool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0:ooooo`?oo`006oooool2
ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02Oooool2o`00o`Oooooo0_oo000E
ooooo`;oo`002_ooool00ol007ooooooooooo`04ooooo`;o003o0_oo00000ol0nY[oooooooooo`0=
ooooo`?oo`0000?o001oool00?oo00002oooool00ol0nY[oo`00ool00004ooooo`;oo`003Oooool2
ool00003o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03
ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001ooooo
ooooool02oooool3ool001[ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo
00Wooooo0_l00?l7ooooo`;oo`004oooool2o`3jVP;oo`002_ooool00ol007ooooooooooo`04oooo
o`;o003o0_oo00000ol0nY[oooooooooo`0=ooooo`;oo`0000?oooooo`00Oooo00000_oo000:oooo
o`;o000000?oo`00ooooooooool00_ooool3ool000_ooooo0ooo00000ol007ooooooooooo`0Coooo
o`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>oooo
o`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00cooooo0_oo000Jooooo`;o
o`0000?o001oooooooooool05?ooool00ol007ooooooooooo`09ooooo`;o003o1oooool2ool0017o
oooo1?l0nYX2ool000[ooooo00?o001oooooooooool01?ooool2o`00o`;oo`0000?o0?ZJoooooooo
ool03Oooool2ool00003ooooool007oooooo00;oo`002Oooool4o`0000Gooooo0_oo000;ooooo`;o
o`0000?oooooo`00Ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?o
oooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oooooo
ooooo`0<ooooo`?oo`006Oooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool0
2Oooool2o`00o`Oooooo0_oo000@ooooo`Go0?ZJ0_oo000:ooooo`03o`00Oooooooooooo00Cooooo
1?oo00000ol0nY[oooooooooo`0=ooooo`;oo`0000?oooooo`00Ooooool00_oo0009ooooo`Co0000
1Oooool3ool000[ooooo0_oo00000ooooooo001oooooo`0Dooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003ooooooooo
o`03ooooo`03o`00Oooooooooooo00gooooo0ooo000Hooooo`;oo`0000?o001oooooooooool05?oo
ool00ol007ooooooooooo`09ooooo`;o003o1oooool2ool000oooooo0ol0nYX2ooooo`03o`3jV_oo
003oo`0000[ooooo00?o001oooooooooool00oooool4ool000;o0?ZJ3oooool2ool00003ooooool0
07oooooo00?oo`002Oooool2o`000003o`00Oooooooooooo00Cooooo0ooo0009ooooo`;oo`0000?o
ooooo`00Ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0>
ooooo`?oo`005oooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02Oooool2
o`00o`Oooooo0_oo000>ooooo`?o0?ZJ0oooool00ol0nY[oo`00ool0000:ooooo`04o`00Oooooooo
ooooooooo`Coo`0000Co003oooooool0nY[o0?ZJ3oooool2ool00004ooooool007ooooooooooo`;o
o`002Oooool2ool00003o`00Oooooooooooo00Gooooo0_oo0009ooooo`;oo`0000?oooooo`00Oooo
ool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooooooo
ool03_ooool001_ooooo0_l00004ooooo`03o`00Oooooooooooo00oooooo0_oo000Gooooo`;oo`00
00?o001oooooooooool05?ooool00ol007ooooooooooo`09ooooo`?o003o1_ooool2ool000cooooo
1?l0nYX4ooooo`03o`3jV_oo003oo`0000[ooooo00?o001ooooooooo00001?oo0002o`00o`03oooo
oooo003oo`0000oooooo0_oo00001?oooooo001oooooooooool3ool000Sooooo0_oo00000ol007oo
ooooooooo`05ooooo`?oo`002?ooool2ool00003ooooool007oooooo01Cooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool0
0oooool00ol007ooooooooooo`0?ooooo`?oo`005_ooool2ool00003o`00Oooooooooooo01Cooooo
00?o001oooooooooool02_ooool2o`00o`Kooooo0_oo000:ooooo`Go0?ZJ1Oooool00ol0nY[oo`00
ool0000:ooooo`03o`00Oooo003oo`0000;oo`0000?oooooo`00ool00?l00_ooool2ool000oooooo
0_oo00000ooooooo001oooooo`02ooooo`;oo`002?ooool2ool00003o`00Oooooooooooo00Kooooo
0ooo0007ooooo`;oo`0000?oooooo`00Ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00ooo
ool00ol007ooooooooooo`0@ooooo`Coo`005?ooool2ool00003o`00Oooooooooooo01Cooooo00?o
001oooooooooool02_ooool3o`00o`Gooooo0_oo00000ol0nY[oooooooooo`06ooooo`Co0?ZJ1ooo
ool00ol0nY[oo`00ool0000:ooooo`03o`00Oooo003oo`0000?ooooo0_l00?l2ooooo`;oo`003ooo
ool2ool00003ooooool007oooooo00;ooooo0_oo0008ooooo`;oo`0000?o001oooooooooool01ooo
ool3ool000Kooooo0_oo00000ooooooo001oooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03
ooooo`03o`00Oooooooooooo017ooooo1?oo000Cooooo`;oo`0000?o001oooooooooool05?ooool0
0ol007ooooooooooo`0:ooooo`?o003o1Oooool2ool000Co0?ZJ0oooool4o`3jVPWooooo00?o0?ZJ
ool00?oo00002_ooool3ool000?ooooo0_l00?l00ooooooo0?ZJool00002ool000kooooo0_oo0000
0ooooooo001oooooo`02ooooo`?oo`001oooool2ool00003o`00Oooooooooooo00Sooooo0ooo0005
ooooo`;oo`0000?oooooo`00Ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol0
07ooooooooooo`0Cooooo`;oo`004oooool2ool00003o`00Oooooooooooo01Cooooo00?o001ooooo
ooooool02oooool2o`00o`Gooooo0_oo000:o`3jVP[ooooo00?o0?ZJool00?oo00002_ooool2ool0
00Cooooo0_l00?l00ooooooo0?ZJool00002ool000kooooo0_oo00000ooooooo001oooooo`03oooo
o`;oo`001oooool2ool00003o`00Oooooooooooo00Wooooo0ooo0004ooooo`;oo`0000?oooooo`00
Ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooo
ooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Cooooo`?o
o`004_ooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02oooool2o`00o`Go
oooo0_oo0003ooooo`Go0?ZJ3?ooool00ol0nY[oo`00ool00009ooooo`?oo`001?ooool2o`00o`03
ooooool0nY[oo`0000;oo`003_ooool2ool00003ooooool007oooooo00?ooooo0ooo0006ooooo`;o
o`0000?o001oooooooooool02_ooool3ool000?ooooo0_oo00000ooooooo001oooooo`0Dooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
6oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Cooooo0ooo000Aooooo`;oo`00
00?o001oooooooooool05?ooool00ol007ooooooooooo`0;ooooo`?o003o1?ooool2ool001Cooooo
00?o0?ZJool00?oo00002Oooool2ool000Gooooo0_l00?l00ooooooo0?ZJool00002ool000kooooo
0_oo00000ooooooo001oooooo`04ooooo`;oo`001_ooool2ool00003o`00Oooooooooooo00_ooooo
0_oo0003ooooo`;oo`0000?oooooo`00Ooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo0_l00004ooooo`03o`00Oooo
oooooooo01Gooooo0ooo000@ooooo`;oo`0000?o001oooooooooool05?ooool00ol007oooooooooo
o`0<ooooo`;o003o1?ooool2ool001Cooooo00?o0?ZJool00?oo00002Oooool2o`0000Gooooo0_l0
0?l00ooooooo0?ZJool00003ool000gooooo0_oo00000ooooooo001oooooo`04ooooo`?oo`001Ooo
ool2ool00003o`00Oooooooooooo00_ooooo0ooo0002ooooo`;oo`0000?oooooo`00Ooooool05?oo
ool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0000@ooooo`006oooool0
0ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Kooooo0ooo000?ooooo`;oo`0000?o001o
ooooooooool05?ooool00ol007ooooooooooo`0<ooooo`;o003o1?ooool2ool001Cooooo00?o0?ZJ
ool00?oo00002?ooool4o`0000Cooooo0_l00?l00ooooooo0?ZJool00003ool000cooooo0ooo0000
0ooooooo001oooooo`05ooooo`;oo`001Oooool2ool00003o`00Oooooooooooo00cooooo0ooo0000
1Oooooooo`00ool00?oooooo001o01Gooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001o
ooooooooool05oooool2ool000oooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo00cooooo0_l00?l4ooooo`;oo`004?ooool2o`00o`;ooooo00?o0?ZJool00?oo00002?ooool4
o`0000Cooooo0_l00?l00ooooooo0?ZJool00003ool000cooooo0_oo00000ol007ooooooo`00O`06
ooooo`Coo`000oooool2ool00003o`00Oooooooooooo00gooooo1Ooo00000ooooooo001oooooo`0D
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>
ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Oooooo0ooo000>oooo
o`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`0<ooooo`;o003o1?ooool2ool0
013ooooo0_l00?l2ooooo`04o`3jV_oo003oo`00o`00o`Kooooo0_oo0002o`0000Cooooo0ol00?l0
0ooooooo0?ZJool00004ool000_ooooo0_oo00000ol007ooooooo`00O`07ooooo`Coo`000_ooool2
ool00003o`00Oooooooooooo00kooooo1?oo00000ooooooo001oooooo`0Dooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0
003oooooooooo`03ooooo`03o`00Oooooooooooo01Sooooo0ooo000=ooooo`;oo`0000?o001ooooo
ooooool05?ooool00ol007ooooooooooo`0<ooooo`;o003o1?ooool2ool0013ooooo0_l00?l2oooo
o`04o`3jV_oo003oo`00o`00o`Cooooo1?oo00000ooooooo001oooooo`03ooooo`;o003o0_ooool0
1?l0nY[oo`00ool00?ooool3ool000[ooooo0_oo00000ol007ooooooo`00O`09ooooo`Koo`0000?o
001oooooooooool03oooool3ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Booooo`Go00001?ooool0
0ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Wooooo1?oo000;ooooo`;oo`0000?o001o
ooooooooool05?ooool00ol007ooooooooooo`0<ooooo`;o003o1?ooool2ool0013ooooo0_l00?l2
ooooo`04o`3jV_oo003oo`00o`00o`?ooooo1?oo0002ooooo`03o`00Oooooooooooo00;ooooo0_l0
0?l2ooooo`03o`3jV_oo003oo`0000;ooooo0_oo000:ooooo`;oo`0000?o001oooooool007l02_oo
ool4ool000;o001o4_ooool2ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Cooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Jooooo`Coo`002_oo
ool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool03?ooool3o`00o`?ooooo0_oo
000@ooooo`;o003o0_ooool01?l0nY[oo`00ool00?l00?l2ooooo`?oo`001?ooool00ol007oooooo
ooooo`02ooooo`;o003o0_ooool00ol0nY[oo`00ool00002ooooo`?oo`002Oooool2ool00003o`00
Oooooooo001o00[ooooo1?oo0002o`00OaGooooo00?o001oooooooooool04oooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01cooooo0ooo
0009ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`0=ooooo`;o003o0ooo
ool2ool0013ooooo0_l00?l2ooooo`04o`3jV_oo003oo`00o`00o`;ooooo0_oo0005ooooo`;o003o
0oooool2o`00o`;ooooo00?o0?ZJool00?oo00000oooool2ool000Wooooo0_oo00000ol007oooooo
o`00O`0;ooooo`?oo`000_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool0
2?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Eooooo`03o`000?oo
oooooooo00?ooooo0ol00003ooooo`03o`00Oooooooooooo01gooooo1?oo0007ooooo`;oo`0000?o
001oooooooooool05?ooool00ol007ooooooooooo`0=ooooo`;o003o0oooool3ool000oooooo0_l0
0?l2ooooo`05o`3jV_oo003oo`00o`00ooooool00ooo00001Ooooooo003oo`00ool00?oooooo00;o
003o0oooool2o`00o`;ooooo00?o0?ZJool00?oo00000oooool2ool000Wooooo0_oo00000ol007oo
ooooo`00O`0<ooooo`;oo`000_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001;ooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool07_ooool4ool000Ko
oooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00gooooo0_l00?l4ooooo`;o
o`003oooool2o`00o`;ooooo00Co0?ZJool00?oo003o003o0ooo0002ooooo`?o003o0_l0nYX00ol0
0?ooooooooooo`03o`00o`;ooooo00?o0?ZJool00?oo00000oooool3ool000Sooooo0_oo00000ol0
07ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo
00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`004_ooool01Ol0003o
oooooooooooooooo000000Cooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Poooo
o`Coo`001?ooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool03Oooool2o`00
o`Cooooo0_oo000>ooooo`?o003o0oooool2ool00003o`00oooo003oo`0000?ooooo0ol00?l3o`3j
VP;ooooo0_l00?l3ooooo`03o`3jV_oo003oo`0000Cooooo0_oo0008ooooo`;oo`0000?o001ooooo
ool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08oooo
o`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001?ooooo0ol00005ooooo`03
o`000?oooooooooo00?ooooo00?o001oooooooooool08Oooool6ool00004oooooooo003oo`00o`00
OaKooooo00?o001oooooooooool03Oooool2o`00o`Cooooo0_oo000>ooooo`Co003o0_ooool5ool0
00?ooooo0ol00?l;o`3jVP;oo`001?ooool2ool000Sooooo0_oo00000ol007ooooooo`00O`0>oooo
o`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03
o`00Oooooooooooo02?ooooo1ooo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00go
oooo0_l00?l4ooooo`;oo`003_ooool4o`00o`;ooooo1?oo0003ooooo`Co003o2ol0nYX2ool000Co
oooo0ooo0007ooooo`;oo`0000?o001oooooool007l03_ooool2o`00OaGooooo00?o001ooooooooo
ool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooooooo
ool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Vooooo`Coo`00
00?o001oooooooooool05?ooool00ol007ooooooooooo`0=ooooo`;o003o1?ooool3ool000gooooo
1?l00?l2ooooo`Coo`000oooool4o`00o`;o0?ZJ00?o003oooooool00?l00_l00?l3ooooo`?oo`00
1Oooool2ool000Oooooo0_oo00000ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007oooooo
ooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003ooooo
ooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02Sooooo0_oo
00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00gooooo0ol00?l3ooooo`03o`00Oooo
003oo`0000gooooo1?l00?l2ooooo`?oo`0000Co003ooooooooooooooooo1?l00?l2o`3jVP04o`00
oooooooo003oo`00o`Cooooo0_oo00000ol007ooooooooooo`03ooooo`?oo`001_ooool2ool00003
o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`;o0000
1?ooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool0
3_ooool2o`00o`?ooooo00?o001oool00?oo00003Oooool4o`00o`;ooooo0ooo00001?l00?oooooo
ooooooooool3o`00o`?o0?ZJ00Co003oooooool00?oo003o1?ooool2ool00003o`00Oooooooooooo
00Cooooo0ooo0005ooooo`;oo`0000?o001oooooool007l03_ooool2o`00OaGooooo00?o001ooooo
ooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0000@oooo
o`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001ooooooooo
ool05?ooool00ol007ooooooooooo`0>ooooo`;o003o0oooool01?l007ooo`00ool00?oo000<oooo
o`Co003o0_ooool2ool000;o003o0oooool2o`00o`03ooooool0nY[o0?ZJ00;o003o00?oooooo`00
ool00?l01?ooool2ool00003o`00Oooooooooooo00Gooooo1Ooo0002ooooo`;oo`0000?o001ooooo
ool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08oooo
o`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000oooooooo
ool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001ooooooooo
ool03_ooool2o`00o`?ooooo00?o001ooooooooo00000_oo000;ooooo`Co003o0_ooool2o`3jVP;o
003o0oooool2o`00o`03ooooool0nY[o0?ZJ00Go003o1?ooool2ool00003o`00Oooooooooooo00Ko
oooo2?oo00000ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
6oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool0
5?ooool00ol007ooooooooooo`0>ooooo`;o003o0oooool00ol007ooooooooooo`02ool000Gooooo
0_l00?l4ooooo`Co003o0_ooool2o`3jVP;o003o0oooool2o`00o`03ooooool0nY[o0?ZJ00Go003o
1?ooool2ool00003o`00Oooooooooooo00Wooooo1Ooo00000ol007ooooooo`00O`0>ooooo`;o001o
5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooo
oooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0>ooooo`;o003o0ooo
ool00ol007ooooooooooo`03ool000Cooooo0_l00?l4ooooo`Co003o0_ooool2o`3jVP;o003o0_oo
ool3o`00o`?o0?ZJ1Ol00?l4ooooo`;oo`0000?o001oooooooooool03_ooool00ol007ooooooo`00
O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03
ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0>
ooooo`;o003o0oooool01?l007ooooooooooooooool2ool000Cooooo0_l00?l4ooooo`Co003o00Co
ooooo`00ool0nY[o0?ZJ0_l00?l2ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_oo0004o`00o`Cooooo
0_oo00000ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00
Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`00
0?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_oo
ool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00kooooo0_l00?l3ooooo`04o`00Oooo
ooooooooooooo`;oo`000oooool3o`00o`Cooooo1?l00?l01?oooooo003oo`3jV_l0nYX2o`00o`03
ooooool0nY[o0?ZJ00?o0?ZJ00?o003oool00?oo00001?l00?l4ooooo`;oo`0000?o001ooooooooo
ool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
6oooool2o`0000Cooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00
Oooooooooooo00kooooo0_l00?l2ooooo`;o00000oooool3ool000;ooooo0ol00?l4ooooo`Co003o
00Coooooo`00ool0nY[o0?ZJ0_l00?l4o`3jVP?ooooo0_oo0004o`00o`Cooooo0_oo00000ol007oo
ooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?o
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo
00?o0000ooooooooool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo
00?o001oooooooooool03_ooool2o`00o`03ooooool0003o000000;o00000oooool2ool000;ooooo
1?l00?l3ooooo`?o003o1?oo00000ol0nY[o003oo`3jVP02o`3jVP;o003o0oooool3ool000?o003o
1?ooool2ool00003o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo
00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo
00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oooooooooo
o`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03_ooool2o`00o`03ooooool0
003o000000;o00000oooool3ool00003ooooool00?oo003o00;o003o0oooool7ool00005o`3jV_oo
oooo0?ZJo`3jV_ooool00_l00?l3ooooo`?oo`000_l00?l5ooooo`;oo`0000?o001oooooooooool0
3_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006ooo
ool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?oo
ool00ol007ooooooooooo`0>ooooo`?o003o00?oooooo`000?l000001Oooool>ool00003oooooooo
003oo`0000Co0?ZJ0ol00?l3ooooo`?oo`000_l00?l5ooooo`;oo`0000?o001oooooooooool03_oo
ool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool0
0ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool0
0ol007ooooooooooo`0?ooooo`;o003o0_ooool00ol007ooooooooooo`04ooooo`[oo`0000Cooooo
o`00ool00?oooooo0_oo0003o`3jVP?o003o1?ooool4ool00003o`00oooooooooooo00?ooooo0_oo
00000ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooo
oooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool0
0ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00oooooo0_l00?l2ooooo`03o`00Oooooooo
oooo00Kooooo00Co003oool00?oo003o003o0_ooool2o`00o`04ooooool00?oo003oo`00o`;oo`00
0_l0nYX4o`00o`Cooooo1?oo00000ol00?ooooooooooo`03ooooo`;oo`0000?o001oooooooooool0
3_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006ooo
ool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?oo
ool00ol007ooooooooooo`0?ooooo`;o003o0_ooool01?l007ooooooooooooooool2o`00o`?ooooo
1?l00?l2ooooo`;o003o0_ooool2o`00o`;oo`000_l0nYX4o`00o`?ooooo1Ooo00000ol00?oooooo
ooooo`03ooooo`;oo`0000?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o
5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooo
oooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0?ooooo`;o003o0_oo
ool01?l007ooooooooooooooool3o`00o`;ooooo1?l00?l2ooooo`;o003o0_ooool2o`00o`;oo`00
00?o0?ZJooooool00?l00ol00?l3ooooo`;oo`0000Co001oool00?oo003oo`001Oooool2ool00003
o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001ooooooooo
ool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooooooo
ool03_ooool001_ooooo0_l00004ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool0
5?ooool00ol007ooooooooooo`0?ooooo`;o003o0_ooool01?l007ooooooooooooooool3o`00o`;o
oooo1Ol00?l00ooooooo003oo`00o`02ooooo`;o003o0_oo00000ol007ooooooo`00o`03o`00o`?o
oooo0_oo00000ol007ooooooool00003ool000?ooooo0_oo00000ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool0
0oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool0
3oooool2o`00o`;ooooo00Co001ooooooooooooooooo0ol00?l01Ooooooo003oo`00ool00?oooooo
00;o003o00?oooooo`00ool00?l00_ooool2o`00o`;oo`0000?o001oooooooooool00ol00?l3oooo
o`;oo`0000?o001oooooool00?l01Ooo00001?ooooooo`00ool00?l007l@ooooo`03o`00Oooooooo
001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo
00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo
00oooooo0_l00?l2ooooo`04o`00Ooooooooooooooooo`?o003o00?oooooo`00ool00?l00_ooool2
o`00o`03ooooool00?oo003o00;ooooo0_l00?l2ool00003o`00Oooooooooooo00?o003o0oooool2
ool00005o`00Oooooooo003oo`00ooooool01_oo00000ol007ooooooooooo`0>ooooo`03o`00Oooo
oooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooo
oooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo00oooooo0_l00?l2ooooo`03o`00Oooooooooooo00Co003o00?oooooo`00ool00?l00_ooool2
o`00o`03ooooool00?oo003o00;ooooo0_l00?l3ool000;ooooo0_l00?l4ooooo`;oo`0000?o001o
ooooooooool01?ooool4ool00003o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2
o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00?ooooo00?o0000ooooooooool03_ooool001Cooooo0ol00004ooooo`03o`000?oooooooooo
00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo
00oooooo0_l00?l2ooooo`03o`00Oooooooooooo00Co003o00?oooooo`00ool00?l00_ooool2o`00
o`03ooooool00?oo003o00;ooooo0_l00?l00ooooooo0000o`000002ooooo`;o003o1?ooool2ool0
0003o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>oooo
o`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool00oooool00ol0003oooooooooo`0>ooooo`005Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00oooooo0_l00?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00ool0
0?l00_ooool2o`00o`03ooooool00?oo003o00;ooooo0_l00?l4o`000003ooooool00?oo003o00?o
oooo0ooo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool0
07l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001;ooooo1Ol00004ooooo`03o`00
0?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00
Oooooooooooo00oooooo0_l00?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l0
0_ooool2o`00o`03ooooool00?oo003o00Cooooo1?l00003ooooo`Koo`0000?o001oooooooooool0
2?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00
Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`00
0?oooooooooo00kooooo000Booooo`04o`000?ooooooooooo`0000Gooooo0ol00003ooooo`03o`00
Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0?ooooo`;o003o
00?oooooo`00ool00?l00_ooool7o`00o`;ooooo1Ol00?l5ooooo`;o00000_ooool6ool000;ooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo
0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`02ooooo`;o00004?ooool001?ooooo00?o0000ooooool000001Oooool00ol0003ooooooooo
o`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007oooooooooo
o`0?ooooo`Ko003o00Coooooo`00ool00?oooooo1?l00?l2ooooo`Co003o1_ooool2ool00003oooo
oooo003oo`0000;oo`001Oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001Cooooo0_l0
0005ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007oooooooooo
o`0Dooooo`03o`00Oooooooooooo013ooooo2?l00?l00ooooooo003oo`00o`02o`00o`?ooooo0ol0
0?l6ooooo`Goo`001oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001Gooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001o
ooooooooool05?ooool00ol007ooooooooooo`0@ooooo`Oo003o0_ooool4o`00o`?ooooo0ol00?l6
ooooo`Coo`002?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000oooo
ooooool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001ooooo
ooooool04?ooool3o`00o`03o`00Ool00?oo003o00?ooooo1?l00?l3ooooo`?o003o1_ooool3ool0
00Wooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o
00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo013o
oooo0ol00?l00ol007ooooooooooo`03ooooo`Co003o0oooool2o`00o`Oooooo0ooo0009ooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o
001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00
Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0@ooooo`?o003o
00?o001oooooooooool00oooool4o`00o`cooooo0_oo000:ooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007oooooo
ooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003ooooo
ooooo`0>ooooo`006oooool2o`0000Cooooo00?o001oooooooooool0:_ooool00ol007oooooooooo
o`0Dooooo`03o`00Oooooooooooo013ooooo0ol00?l00ol007ooooooooooo`03ooooo`Co003o3Ooo
ool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_oo
ool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00_ooool2o`00013ooooo000Kooooo`03o`000?oooooo
oooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo013ooooo0_l00?l00ooooooo001oooooo`04ooooo`?o003o3_ooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>
ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001o
ooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03oooo
o`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0@oooo
o`;o003o00?oooooo`00Ooooool01?ooool3o`00o`kooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00
OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oo
ooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool04oooool00ol007oo
ooooooooo`03ooooo`?o003o3_ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007oo
ooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003o
ooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02[ooooo
00?o001oooooooooool05?ooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Cooooo
0_l00?l>ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo
000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007oooooooooo
o`0Dooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool01?ooool2o`00o`kooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`0Zooooo`03o`00Oooooooooooo00Sooooo00?o0000
ooooooooool02Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Cooooo0_l00?l>
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooo001o00kooooo00?o0000o`00Ooooool05?ooool00ol007ooooooooooo`0C
ooooo`03o`00Oooooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00_ooool00ol007ooooooo`00O`03ooooo`03o`000?oooooooooo00Sooooo00?o0000o`00
Ooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool03_ooool001_oooook_l0000@ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJ
ooooo`00C?ooool00ol0003oooooooooo`0Cooooo`?o00000oooool3o`0002Oooooo0ol00024oooo
o`00COooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool09oooool00ol0003oooooooooo`23ooooo`00>_ooool2o`0000;ooooo0ol000000ooooooo0000
o`000003o`0000Kooooo00?o0000ooooooooool01_ooool2o`000003ooooool0003o000000;ooooo
1?l00002ooooo`?o00000oooool3o`0000?ooooo1?l00008ooooo`Co00002?ooool3o`0000Wooooo
0ol00003ooooo`Co000000Goooooo`000?l0003o0000ooooo`02o`000004ooooool0003o0000o`00
00;ooooo1Ol00009ooooo`;o000000?oooooo`000?l000000_l000000ooooooo0000o`000005o`00
00?ooooo0_l00009ooooo`Co00002?ooool3o`0000Cooooo0_l0000_ooooo`00>Oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03oooool0
0ol0003oooooo`000002ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0000
0_ooool01_l0003oooooooooool0003oooooo`0000;ooooo00?o0000ooooooooool05?ooool00ol0
003oooooooooo`08ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooool000001oooool00ol0003oooooooooo`08ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0001Gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
000^ooooo`00>Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000000?ooooo00?o
0000ooooooooool03oooool2o`0000Cooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool3o`0000Wooooo1?l00009ooooo`03o`000?oooooooooo00So
oooo00Co0000oooooooooooo00000_ooool3o`0000?ooooo00Go0000oooooooooooo0000ooooo`05
o`0000?ooooo00?o0000ooooooooool02?ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`Co0000
2Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0002kooooo000iooooo`04o`00
0?ooooooooooo`0000;ooooo0_l00004ooooo`?o00003oooool00ol0003oooooo`000002ooooo`04
o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0
003oooooo`0000;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`08ooooo`06o`00
0?ooooooooooo`000?oooooo00000_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000
ooooool000000oooool01Ol0003ooooooooooooooooo000000[ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0002kooooo000iooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooool000000oooool00ol0003oooooooooo`0?oooo
o`04o`000?oooooo0000o`0000;ooooo0_l00003ooooo`Co00000_ooool4o`0000?ooooo0_l0000G
ooooo`03o`000?oooooooooo00Oooooo1?l00003ooooo`;o00000oooool4o`0000?ooooo0ol00004
ooooo`03o`000?oooooooooo00Oooooo0_l000001?oooooo0000o`000?ooool4o`0000;ooooo0ol0
0003ooooo`Co00005_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0002kooooo
000iooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000>ooooo`03o`000?oooooooooo02gooooo0_l0000Sooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool05Oooool2o`0000Cooooo00Co0000oooooooooooo0000;_ooool0
03Sooooo0ol000000ooooooo0000o`000003o`000003ooooool0003o000000Go00003Oooool2o`00
033ooooo00?o0000ooooooooool07oooool3o`0001Oooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo00?ooooo0_l0000_ooooo`00oooooolJooooo`00
oooooolJooooo`00\
\>"],
  ImageRangeCache->{{{0, 280.812}, {173.188, 0}} -> {-29.7276, -5.81761, \
0.887312, 0.0683666}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\

SCALING={1,0.1,1,1};
THETA0=Theta/SCALING;
F0=IdentityMatrix[THETA0//Length];
misc={miss,1};
MAXSTEP=.1;
FISHER=False;

SetDirectory[\"/Mathematica \
2.2.2/Hermann.Notebooks/UKF.20.3.2006/Panel/Simulation\"];
filename=\"UKF1.n10\";
system={f,g,h,R,mue,sigma,dt,kappa=1};
LikN=UKF;
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
EST={};
Do[

SeedRandom[99999*m];
Print[\"**********************************************************************\
***\"];
Print[\"Replikation m = \",m];
Print[\"**********************************************************************\
***\"];

n=10;
T = 200;
dt = .1;
k = 1; p = 1; q = 1;
X = Shape[0,{n,T+1,q}];
Theta = {-1., 0.1, 2.,1}//N;
Y0 = RandomGauss[_,Theta,{mue,sigma},n];
Prozess = UniC;
{zt,yt} = \
MapThread[NonLinStateSpace[h,{R,konstant},f,g,#1,#2,T,dt,Theta,Prozess,\
EulerStep]&,{Y0,X}]//Transpose;
miss = -9;
time = {0,4,6,8,10,11,12,13.5,13.7,15,15.1,17,19,20};
sel = time/dt + 1;
ZM = Shape[miss,{n,T+1,k}];
Map[(ZM[[All,#]] = zt[[All,#]])&,sel];
data={ZM,X}//Transpose;

{THETA,COV,LIKI,psii,scoreii,k,ReturnCode}=

BFGS[data,
\t {THETA0,F0},
\t {system,{Lik,LikN,Score,Hesse}},
\t {misc,KMAX=50,{EPS1=10.^-4,EPS2=10.^-4},OPTION=0,PRINT={1,1,1,1,1,1,1,1}}];\

\t 
est = {m,THETA,k,ReturnCode}//Flatten;
EST = Append[EST,est];
PutAppend[est,filename];


,{m,1,100}] 
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Replikation m = "\[InvisibleSpace]1\),
      SequenceForm[ "Replikation m = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print"],

Cell[BoxData[
    \({201, 201, 201, 201, 201, 201, 201, 201, 201, 201}\)], "Print"],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    \(LikFIF\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "50", "0.0001`", "0.0001`", "1", "1", "10", "200", "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1000.`", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("    SCALING"\)], "Print"],

Cell[BoxData[
    TagBox[\({{1, 0.1`, 1, 1}}\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{\(-1.`\), 1.`, 
          2.`, 1.`}\),
      SequenceForm[ "STARTWERT THETA0 = ", {-1.0, 1.0, 2.0, 1.0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{22.205524444580078`, 27.88530731201172`, 22.85108184814453`, 
        20.235258102416992`}, \(-196.58974460829876`\)}\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Auswertung", "Subsubsection"],

Cell[CellGroupData[{

Cell["filename", "Input",
  CellTags->""],

Cell[BoxData[
    \("UKF1.n10"\)], "Output",
  CellTags->""]
}, Open  ]],

Cell["cum=ReadList[filename];", "Input",
  CellTags->""],

Cell[CellGroupData[{

Cell["cum//MatrixForm", "Input",
  CellTags->""],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7"},
              {"1", "1", \(-0.23269747979244004`\), "0.3080664429021796`", 
                "1.9761900298819257`", "1.1548311598955352`", "17", "3"},
              {"2", "2", \(-1.9388278027320225`\), "1.6850311404579015`", 
                "2.4460654830837503`", "1.618412955004938`", "25", "3"},
              {"3", "3", \(-0.46134087981020494`\), "0.4236876461162408`", 
                "2.08690591994356`", "0.7350943396969603`", "13", "3"},
              {"4", "4", \(-2.196734856793321`\), "2.046562920349191`", 
                "2.495136784823525`", "0.7665990352276102`", "29", "3"},
              {"5", "5", \(-1.0772021163947112`\), "1.158124352335972`", 
                "1.8479566806927212`", "1.0922334470787733`", "10", "3"},
              {"6", "6", \(-0.5574235236652321`\), "0.48587983330854784`", 
                "2.1697279017201456`", "1.0466984903724297`", "16", "3"},
              {"7", "7", \(-0.6648214892979565`\), "0.4906711940699281`", 
                "2.1920343319237805`", "0.8565997370060401`", "15", "3"},
              {"8", "8", \(-0.7156579779596572`\), "0.5920504377052299`", 
                "1.7934336353982459`", "0.97053507608248`", "10", "3"},
              {"9", "9", \(-0.5133701167727109`\), "0.5203192573910789`", 
                "1.5108035649820934`", "1.4656767424214132`", "15", "3"},
              {"10", "10", \(-2.5466100473640663`\), "2.124225230136499`", 
                "2.7132338681964074`", "1.24940575593756`", "24", "3"},
              {"11", "11", \(-0.772636429660337`\), "0.8630477890606004`", 
                "1.640042100842583`", "1.299159723163756`", "12", "3"},
              {"12", "12", \(-0.12718862950289042`\), "0.14510892074157136`", 
                "1.8564493529602601`", "0.7592334375989439`", "22", "3"},
              {"13", "13", \(-5.158693915478232`\), "3.447610610176224`", 
                "3.6589648875315417`", "0.2476877535044683`", "50", "0"},
              {"14", "14", \(-0.7730482975535816`\), "0.6250248508119584`", 
                "2.0638938907516433`", "0.6266012562670794`", "13", "3"},
              {"15", "15", "0.05656602320748934`", "0.16325856048258153`", 
                "2.0886160448957196`", "0.8612701846519859`", "34", "3"},
              {"16", "16", \(-3.6783844574401394`\), "2.976493946628856`", 
                "2.9970051139516385`", "0.7006896253921057`", "37", "3"},
              {"17", "17", \(-1.4660055761479953`\), "1.3227362451403397`", 
                "2.135972934229492`", "1.3902135472133001`", "16", "3"},
              {"18", "18", \(-0.5573874102166396`\), "0.4695780564936312`", 
                "1.6481435965024556`", "1.7156868157884113`", "16", "3"},
              {"19", "19", \(-4.01577131269546`\), "3.3911498545637366`", 
                "2.907179170903962`", "1.0041967673583154`", "41", "3"},
              {"20", "20", \(-0.4609603173200597`\), "0.49170957819963496`", 
                "1.9016389402977103`", "0.9912624277184728`", "13", "3"},
              {"21", "21", \(-0.3697877828079874`\), "0.37276662389714765`", 
                "2.1651842025833385`", "0.7807719006264873`", "16", "3"},
              {"22", "22", \(-0.14478058009585673`\), "0.19368980473314645`", 
                "1.9027648558112589`", "0.8894528482204668`", "18", "3"},
              {"23", "23", \(-0.5890624776535031`\), "0.7541558049874207`", 
                "1.4222016557216675`", "2.2828754238719977`", "29", "3"},
              {"24", "24", \(-2.094914304304813`\), "1.798820727224184`", 
                "2.921298445685245`", \(-1.1177646184916936`*^-9\), "30", 
                "4"},
              {"25", "25", \(-0.4980527393579539`\), "0.4715833854147921`", 
                "1.882398246217456`", "0.8319108650760006`", "13", "3"},
              {"26", "26", \(-4.537305666284209`\), "3.8030182263007752`", 
                "2.8889665807338196`", "1.4392683122860241`", "50", "0"},
              {"27", "27", \(-0.29288366379549596`\), "0.3697929411997969`", 
                "1.9375989944187049`", "1.1651312248968226`", "17", "3"},
              {"28", "28", \(-0.9298855108562701`\), "0.8684815002794984`", 
                "1.8648482694279331`", "1.6028689304851917`", "12", "3"},
              {"29", "29", \(-1.5785000423293334`\), "1.6804637530087931`", 
                "1.9285540825100786`", "2.2910894638181265`", "23", "3"},
              {"30", "30", \(-0.37601468986802244`\), "0.3496850025087487`", 
                "1.5634811479442925`", "1.2747395056267408`", "17", "3"},
              {"31", "31", \(-0.5132249380450223`\), "0.5369389760369739`", 
                "1.9122321007624967`", "0.8959876888725682`", "13", "3"},
              {"32", "32", \(-0.3495059360406555`\), "0.3500204685032463`", 
                "1.8479653650427172`", "0.6267230557589661`", "16", "3"},
              {"33", "33", \(-1.5201075728036526`\), "1.4070118528907574`", 
                "2.276827859949619`", "0.4724439406386143`", "14", "3"},
              {"34", "34", \(-0.309868159639505`\), "0.3776228018474223`", 
                "2.089714003827799`", "0.6465202829683315`", "15", "3"},
              {"35", "35", \(-1.2397284148374188`\), "1.1834453500243625`", 
                "2.077410008764638`", "1.544382297193319`", "13", "3"},
              {"36", "36", \(-0.9297240476020396`\), "0.9543738756683793`", 
                "2.3136105635049025`", "0.06969566442896269`", "17", "3"},
              {"37", "37", \(-0.6542948540084135`\), "0.6818598305917695`", 
                "1.9793091316057054`", "0.7239229350849874`", "12", "3"},
              {"38", "38", \(-0.25363906733075836`\), "0.3137133197512462`", 
                "2.011421827741036`", "0.7573595893612862`", "16", "3"},
              {"39", "39", \(-0.34440251495289703`\), "0.2856640430670114`", 
                "1.992300534689961`", "0.34589914811567873`", "19", "3"},
              {"40", "40", \(-2.836259246118217`\), "2.2817803666466836`", 
                "2.984032715441226`", "0.40523667615938735`", "34", "3"},
              {"41", "41", \(-0.5279705250412394`\), "0.5626005210258305`", 
                "1.9332596170885747`", "0.7307007189082237`", "13", "3"},
              {"42", "42", "0.08132123778994392`", "0.07716239337017407`", 
                "1.8147055981069808`", "1.1109581739643464`", "22", "3"},
              {"43", "43", \(-2.884234271704349`\), "2.1300656030830396`", 
                "3.2373682495199176`", "0.04383374395152707`", "29", "3"},
              {"44", "44", \(-1.29141116318865`\), "1.0218958785591046`", 
                "2.46098318785359`", "0.9152981874846743`", "15", "3"},
              {"45", "45", \(-0.1606279288896106`\), "0.20287101385336564`", 
                "1.6798653259475473`", "0.9285478402524335`", "19", "3"},
              {"46", "46", \(-0.359441086507751`\), "0.4025384152757206`", 
                "1.6419474720118756`", "0.8585677600525391`", "15", "3"},
              {"47", "47", \(-2.5878379338699067`\), "1.8509781675007115`", 
                "3.26343516427179`", "0.25425974785846783`", "30", "3"},
              {"48", "48", \(-0.6669030231742221`\), "0.7765264614600405`", 
                "1.9452513359913044`", "0.9187267179808234`", "10", "3"},
              {"49", "49", \(-0.269758993311547`\), "0.31551302665990766`", 
                "2.0851494493761966`", "0.8433799485413946`", "17", "3"},
              {"50", "50", \(-3.3873618163493684`\), "2.7058144043838364`", 
                "3.047209902493`", "0.3574057041042463`", "35", "3"},
              {"51", "51", \(-1.1493091448096366`\), "0.9715159174850564`", 
                "2.3136313768857613`", "0.9995474445402228`", "10", "3"},
              {"52", "52", \(-0.6296620300415994`\), "0.6443615910492825`", 
                "1.8713927515820823`", "1.1047188324750135`", "12", "3"},
              {"53", "53", \(-0.8694503049287686`\), "0.8034725822369555`", 
                "2.1618493100047678`", "1.1583977516251855`", "12", "3"},
              {"54", "54", \(-0.569808349945786`\), "0.4838750684369842`", 
                "1.7775570603382742`", "1.1587107155713094`", "14", "3"},
              {"55", "55", \(-0.30699925745995665`\), "0.32580125213205446`", 
                "1.7750633808043403`", "0.7430551780045686`", "17", "3"},
              {"56", "56", \(-1.1739563852166792`\), "0.8526380410740958`", 
                "2.564440887856847`", "0.4785279416926721`", "16", "3"},
              {"57", "57", \(-0.3693662492351348`\), "0.40193380122326694`", 
                "2.14803686193551`", "0.5676782137483818`", "16", "3"},
              {"58", "58", \(-0.16952853151721617`\), "0.29790415920374314`", 
                "1.8378561061042822`", "0.9735976583495382`", "17", "3"},
              {"59", "59", \(-0.397701911197073`\), "0.4106125540830268`", 
                "1.2768392833734872`", "2.087535926807613`", "21", "3"},
              {"60", "60", "0.024635127157824125`", "0.138658408717893`", 
                "1.8414658041669536`", "0.36166816261489737`", "19", "3"},
              {"61", "61", \(-3.115502932098847`\), "3.0395146030449447`", 
                "2.4610331360047`", "0.8738616790783134`", "36", "3"},
              {"62", "62", \(-0.4834379583308`\), "0.6053912358840626`", 
                "1.5566673959325876`", "0.906552432988911`", "13", "3"},
              {"63", "63", \(-2.1402466278933514`\), "1.851698865400869`", 
                "2.718295336562872`", "0.8994223687958743`", "23", "3"},
              {"64", "64", \(-0.8618674734420119`\), "0.853268269085502`", 
                "2.0413788802290616`", "1.6372708783340912`", "15", "3"},
              {"65", "65", \(-1.1139268004313019`\), "1.048323810313253`", 
                "2.677572488594807`", "0.6069141438795698`", "25", "3"},
              {"66", "66", \(-0.3101312023446386`\), "0.33559130159312683`", 
                "1.8552717185658127`", "0.8068065975612962`", "16", "3"},
              {"67", "67", \(-0.39533211281136243`\), "0.4236908248281507`", 
                "1.7903486031308105`", "1.5117923490019576`", "15", "3"},
              {"68", "68", \(-0.34580216050849033`\), "0.389131598504145`", 
                "2.146922303012085`", "0.7233976276387944`", "13", "3"},
              {"69", "69", \(-4.082965070993238`\), "3.7317084929607804`", 
                "2.883050370857644`", "1.643255834711009`", "43", "3"},
              {"70", "70", \(-0.04940716517943346`\), "0.12470998633902836`", 
                "1.7199422836121594`", "1.0213425329770451`", "22", "3"},
              {"71", "71", \(-1.1279706801428406`\), "1.0557110273795476`", 
                "2.202505924485373`", "0.5414646442932212`", "12", "3"},
              {"72", "72", \(-1.5433196268372273`\), "1.430314713023231`", 
                "1.947121034252742`", "1.5489375576364277`", "15", "3"},
              {"73", "73", \(-0.7261430335509138`\), "0.69058776616403`", 
                "2.089388162819133`", "0.9437752350702401`", "13", "3"},
              {"74", "74", \(-0.2631730698100991`\), "0.26116662562543685`", 
                "1.8090021409602697`", "0.6889057427385469`", "16", "3"},
              {"75", "75", \(-1.7270617028331867`\), "1.5277469331052536`", 
                "2.508068631359459`", "0.7846646101828654`", "15", "3"},
              {"76", "76", \(-1.6116341692189204`\), "1.3213691363107725`", 
                "2.6007275040501505`", "0.4385956713500784`", "14", "3"},
              {"77", "77", \(-2.83818976788419`\), "3.0204765821221544`", 
                "2.372815751214112`", "1.59171035153218`", "33", "3"},
              {"78", "78", \(-0.244155214055512`\), "0.2818281249171577`", 
                "1.7014154675896238`", "0.7391552583935525`", "19", "3"},
              {"79", "79", \(-1.477463445704778`\), "1.3661932449725689`", 
                "2.21044702986955`", "1.0117414252889725`", "11", "3"},
              {"80", "80", \(-0.0944656759048088`\), "0.27622466848497046`", 
                "1.3443105041668688`", "1.7638629741159555`", "19", "3"},
              {"81", "81", \(-1.5164327748780864`\), "1.4393287415386702`", 
                "2.1308668694293673`", "1.4623994996299343`", "25", "3"},
              {"82", "82", \(-1.0060521328009875`\), "1.0664603143678912`", 
                "1.9612115301559625`", "1.2254029877004495`", "10", "3"},
              {"83", "83", \(-2.452859034936089`\), "2.864521588886192`", 
                "2.322050363854479`", "1.8260643424813428`", "29", "3"},
              {"84", "84", \(-3.358589388181925`\), "3.0165846303664137`", 
                "2.747700788345221`", "0.7312611632008592`", "32", "3"},
              {"85", "85", \(-0.8186173008405084`\), "0.7397216700428705`", 
                "2.0151827198268495`", "0.7712339337408983`", "10", "3"},
              {"86", "86", \(-0.3523483710577965`\), "0.6304795933655614`", 
                "1.726772936613376`", "0.8956946923027538`", "12", "3"},
              {"87", "87", \(-1.9886819737601071`\), "1.5625010316670345`", 
                "2.866948710662445`", "0.5651911038603422`", "24", "3"},
              {"88", "88", \(-0.8349775835509827`\), "0.7999241750080328`", 
                "2.098833701340659`", "0.8403400422782769`", "12", "3"},
              {"89", "89", \(-5.461047226839513`\), "3.5135770214560202`", 
                "3.730679836164045`", "0.40348572663624716`", "50", "0"},
              {"90", "90", \(-2.161323866690904`\), "2.436319388889205`", 
                "2.1212766192857573`", "0.872988176660178`", "27", "3"},
              {"91", "91", \(-3.1902744134134013`\), "2.705138791790802`", 
                "3.1018598614664246`", "0.5377259936031751`", "34", "3"},
              {"92", "92", \(-1.8237013152565014`\), "1.547153014038057`", 
                "2.6285821809065166`", "0.7987926191521765`", "17", "3"},
              {"93", "93", \(-1.3334046622668323`\), "1.014675704732673`", 
                "2.56251043584903`", "0.29913643910697707`", "15", "3"},
              {"94", "94", \(-0.41596911841756967`\), "0.42559637588293586`", 
                "2.076423680999209`", "0.8345434457966364`", "15", "3"},
              {"95", "95", \(-0.7379778616593763`\), "0.7198862684868329`", 
                "1.8660224963091756`", "0.8029195750803726`", "11", "3"},
              {"96", "96", \(-0.565111430748309`\), "0.5686527540164463`", 
                "1.7174084135070824`", "1.4620878496845706`", "13", "3"},
              {"97", "97", \(-0.22965827772345782`\), "0.34730579776902415`", 
                "1.4909115467743261`", "1.5573263405634663`", "16", "3"},
              {"98", "98", \(-0.22077964850034706`\), "0.32776022526335374`", 
                "1.4531128674470535`", "1.6597797863937318`", "17", "3"},
              {"99", "99", \(-0.49611080411115216`\), "0.46223886466399877`", 
                "1.5432183240537498`", "1.5772740886450067`", "16", "3"},
              {"100", "100", \(-2.8209898507443834`\), "2.595960179461477`", 
                "2.829907951734038`", "0.6073783805137047`", "28", "3"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellTags->""]
}, Open  ]],

Cell[CellGroupData[{

Cell["cum//Dimensions", "Input"],

Cell[BoxData[
    \({100, 7}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
sel=Position[cum[[All,7]],3]//Flatten;
sel//Length\
\>", "Input",
  CellTags->""],

Cell[BoxData[
    \(96\)], "Output",
  CellTags->""]
}, Open  ]],

Cell["cum1=cum[[sel,{2,3,4,5}]];", "Input",
  CellTags->""],

Cell["cum1=Map[{#[[1]],#[[2]]//Abs,#[[3]],#[[4]]//Abs}&,cum1];", "Input",
  CellTags->""],

Cell[CellGroupData[{

Cell["\<\
{SML,S,MEAN} = Varianz[cum1//N];
STD = VecDiag[SML]//Sqrt;
bias=MEAN-THETA0;
rmse=Sqrt[STD^2+bias^2];

{{\"alpha\",\"beta\",sigma,R},
 Theta,MEAN*SCALING,STD*SCALING,bias*SCALING,rmse*SCALING }//Transpose//
MatrixForm[#,TableHeadings->{None,{\"parameter\",\"value\",\"mean\",\"std\",\"\
bias\",\"RMSE\"}}]&\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  CellTags->""],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-1.0934443039271908`\), 
                "1.0089284323253818`", \(-0.09344430392719083`\), 
                "1.0132464751929757`"},
              {"\<\"beta\"\>", "0.1`", "0.10208059597819102`", 
                "0.08668501927259509`", "0.002080595978191013`", 
                "0.08670998469561994`"},
              {"sigma", "2.`", "2.116632080244688`", "0.4399068220190152`", 
                "0.11663208024468785`", "0.4551055418263689`"},
              {"R", "1.`", "0.984557278224707`", 
                "0.45091746927157755`", \(-0.015442721775293045`\), 
                "0.4511818278145887`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output",
  CellTags->""]
}, Open  ]],

Cell[" ", "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF / kappa=2", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}},
  CellTags->""],

Cell[CellGroupData[{

Cell["Filter", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,lik} = 
\tUKF[data[[nn=10]],Theta,system={f,g,h,R,mue,sigma,dt,kappa=2},{miss,2}];//\
Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.2599999999999909`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell["std = Map[VecDiag,PF]//Sqrt;", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["std//Dimensions", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({201, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g2 = plot1[yt[[nn]]~ii~YF~ii~(YF+std)~ii~(YF-std)//AddTimeAxis,
\t\tGridLines->{time/dt,None},color->{1,2,3,3},
\t\tDisplayFunction->Identity];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{201, 5}\),
      SequenceForm[ "Dimension der Daten  ", {201, 5}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
g3 = plot1[Spalte[time/dt]~ii~ZM[[nn,time/dt+1]],
\t\t\tPlotJoined->False,dicke->.02,
\t\t\tDisplayFunction->Identity,color->{10}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{14, 2}\),
      SequenceForm[ "Dimension der Daten  ", {14, 2}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
gUKF=Show[g2,g3,DisplayFunction->$DisplayFunction,GridLines->{time/\
dt,None},
\t\t\t\tPlotLabel->\"UKF, kappa = \"<>ToString[kappa]<>\" panel unit = \
\"<>ToString[nn],PlotRange->{All,{-5,5}}];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0047619 0.309017 0.0618034 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -6 -9 ]
[.2619 -0.0125 6 0 ]
[.5 -0.0125 -9 -9 ]
[.5 -0.0125 9 0 ]
[.7381 -0.0125 -9 -9 ]
[.7381 -0.0125 9 0 ]
[.97619 -0.0125 -9 -9 ]
[.97619 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0618 -12 -4.5 ]
[-0.0125 .0618 0 4.5 ]
[-0.0125 .18541 -12 -4.5 ]
[-0.0125 .18541 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .43262 -6 -4.5 ]
[-0.0125 .43262 0 4.5 ]
[-0.0125 .55623 -6 -4.5 ]
[-0.0125 .55623 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -92 0 ]
[.5 .63053 92 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .61803 L
s
.21429 0 m
.21429 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.40476 0 m
.40476 .61803 L
s
.5 0 m
.5 .61803 L
s
.54762 0 m
.54762 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.66667 0 m
.66667 .61803 L
s
.67619 0 m
.67619 .61803 L
s
.7381 0 m
.7381 .61803 L
s
.74286 0 m
.74286 .61803 L
s
.83333 0 m
.83333 .61803 L
s
.92857 0 m
.92857 .61803 L
s
.97619 0 m
.97619 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(50)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(100)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(150)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(200)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0618 m
.00625 .0618 L
s
[(-4)] -0.0125 .0618 1 0 Mshowa
0 .18541 m
.00625 .18541 L
s
[(-2)] -0.0125 .18541 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .43262 m
.00625 .43262 L
s
[(2)] -0.0125 .43262 1 0 Mshowa
0 .55623 m
.00625 .55623 L
s
[(4)] -0.0125 .55623 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12361 m
.00375 .12361 L
s
0 .15451 m
.00375 .15451 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .27812 m
.00375 .27812 L
s
0 .33992 m
.00375 .33992 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .46353 m
.00375 .46353 L
s
0 .49443 m
.00375 .49443 L
s
0 .52533 m
.00375 .52533 L
s
0 .0309 m
.00375 .0309 L
s
0 .58713 m
.00375 .58713 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0618 m
1 .0618 L
s
.99375 .18541 m
1 .18541 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .43262 m
1 .43262 L
s
.99375 .55623 m
1 .55623 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .15451 m
1 .15451 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .46353 m
1 .46353 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .58713 m
1 .58713 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -153 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
129.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
141.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
153.000 13.000 moveto
(panel) show
189.000 13.000 moveto
(unit) show
219.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
231.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
243.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.97619 .19163 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .27669 m
.02857 .29846 L
.03333 .2618 L
.0381 .26628 L
.04286 .26754 L
.04762 .20714 L
.05238 .16017 L
.05714 .12555 L
.0619 .06686 L
.06667 .05446 L
.07143 .11893 L
.07619 .12641 L
.08095 .13619 L
.08571 .16112 L
.09048 .16386 L
.09524 .19665 L
.1 .24045 L
.10476 .20446 L
.10952 .19228 L
.11429 .214 L
.11905 .14632 L
.12381 .17878 L
.12857 .16414 L
.13333 .17391 L
.1381 .14817 L
.14286 .08782 L
.14762 .05453 L
.15238 .0119 L
.15714 .09454 L
.1619 .03251 L
s
.1619 .03251 m
.16578 0 L
s
.16707 0 m
.17143 .07962 L
.17619 .12078 L
.18095 .14606 L
.18571 .0944 L
.19048 .05835 L
.19524 .02722 L
.2 .12327 L
.20476 .13342 L
.20952 .11797 L
.21429 .0862 L
.21905 .1208 L
.22381 .0684 L
.22857 .10722 L
.23333 .07035 L
.2381 .14024 L
.24286 .16002 L
.24762 .0962 L
.25238 .14833 L
.25714 .18874 L
.2619 .17714 L
.26667 .105 L
.27143 .04362 L
.27619 .11036 L
.28095 .10684 L
.28571 .07526 L
.29048 .05732 L
.29524 .02388 L
.3 .03087 L
s
.3 .03087 m
.30464 0 L
s
.31443 0 m
.31905 .07609 L
.32381 .10542 L
.32857 .15738 L
.33333 .14317 L
.3381 .15243 L
.34286 .20764 L
.34762 .22096 L
.35238 .2153 L
.35714 .26563 L
.3619 .3122 L
.36667 .35278 L
.37143 .38037 L
.37619 .38052 L
.38095 .43467 L
.38571 .47781 L
.39048 .5289 L
.39524 .58891 L
.4 .57273 L
.40476 .54716 L
.40952 .56473 L
.41429 .56986 L
.41905 .55525 L
.42381 .51756 L
.42857 .52404 L
.43333 .57999 L
.4381 .60893 L
.44286 .56255 L
.44762 .49508 L
.45238 .47568 L
.45714 .54105 L
.4619 .57277 L
.46667 .56729 L
.47143 .53704 L
.47619 .47122 L
.48095 .40953 L
.48571 .47737 L
.49048 .54448 L
.49524 .49601 L
.5 .46279 L
.50476 .41459 L
.50952 .48668 L
.51429 .50639 L
.51905 .54283 L
.52381 .51727 L
.52857 .48803 L
.53333 .43407 L
.5381 .43381 L
.54286 .48406 L
.54762 .46833 L
Mistroke
.55238 .4306 L
.55714 .50386 L
.5619 .5293 L
.56667 .45758 L
.57143 .42766 L
.57619 .39203 L
.58095 .34028 L
.58571 .35624 L
.59048 .31438 L
.59524 .27082 L
.6 .21584 L
.60476 .22649 L
.60952 .27894 L
.61429 .33442 L
.61905 .27197 L
.62381 .28934 L
.62857 .26229 L
.63333 .21177 L
.6381 .22268 L
.64286 .19539 L
.64762 .15191 L
.65238 .17558 L
.65714 .21152 L
.6619 .27075 L
.66667 .2065 L
.67143 .23019 L
.67619 .17363 L
.68095 .2312 L
.68571 .26797 L
.69048 .27059 L
.69524 .20779 L
.7 .18438 L
.70476 .19891 L
.70952 .17433 L
.71429 .22716 L
.71905 .25426 L
.72381 .2796 L
.72857 .26895 L
.73333 .32226 L
.7381 .26879 L
.74286 .25272 L
.74762 .2182 L
.75238 .1823 L
.75714 .20821 L
.7619 .15684 L
.76667 .15996 L
.77143 .14959 L
.77619 .17866 L
.78095 .12033 L
.78571 .16473 L
Mistroke
.79048 .13629 L
.79524 .17001 L
.8 .13643 L
.80476 .10406 L
.80952 .07563 L
.81429 .07138 L
.81905 .10182 L
.82381 .16059 L
.82857 .13162 L
.83333 .14816 L
.8381 .19935 L
.84286 .18811 L
.84762 .16852 L
.85238 .16849 L
.85714 .16259 L
.8619 .1141 L
.86667 .06294 L
.87143 .11855 L
.87619 .09475 L
.88095 .1156 L
.88571 .13599 L
.89048 .07134 L
.89524 .04327 L
.9 .10437 L
.90476 .08131 L
.90952 .05875 L
.91429 .12972 L
.91905 .12629 L
.92381 .06173 L
.92857 .12778 L
.93333 .09344 L
.9381 .10901 L
.94286 .13808 L
.94762 .09789 L
.95238 .08094 L
.95714 .03611 L
.9619 .03459 L
.96667 .08602 L
.97143 .13909 L
.97619 .19163 L
Mfstroke
0 .98 .604 r
gsave
.97619 .19469 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21625 m
.02857 .21159 L
.03333 .20813 L
.0381 .20586 L
.04286 .20461 L
.04762 .20421 L
.05238 .20443 L
.05714 .2051 L
.0619 .20609 L
.06667 .2073 L
.07143 .20866 L
.07619 .21012 L
.08095 .21166 L
.08571 .21326 L
.09048 .2149 L
.09524 .21658 L
.1 .21829 L
.10476 .22002 L
.10952 .22179 L
.11429 .22357 L
.11905 .22537 L
.12381 .22719 L
.12857 .22902 L
.13333 .23087 L
.1381 .23272 L
.14286 .23459 L
.14762 .23646 L
.15238 .23833 L
.15714 .24021 L
.1619 .24208 L
.16667 .24395 L
.17143 .24581 L
.17619 .24765 L
.18095 .24949 L
.18571 .25131 L
.19048 .25311 L
.19524 .25489 L
.2 .25664 L
.20476 .25837 L
.20952 .26008 L
.21429 .14302 L
.21905 .14244 L
.22381 .14291 L
.22857 .144 L
.23333 .14541 L
.2381 .14697 L
.24286 .14858 L
.24762 .15018 L
.25238 .15177 L
.25714 .15331 L
Mistroke
.2619 .15481 L
.26667 .15628 L
.27143 .15771 L
.27619 .1591 L
.28095 .16046 L
.28571 .16179 L
.29048 .1631 L
.29524 .16439 L
.3 .16566 L
.30476 .16692 L
.30952 .08044 L
.31429 .09334 L
.31905 .10259 L
.32381 .10974 L
.32857 .11553 L
.33333 .12037 L
.3381 .12451 L
.34286 .12814 L
.34762 .13136 L
.35238 .13425 L
.35714 .13688 L
.3619 .1393 L
.36667 .14155 L
.37143 .14364 L
.37619 .1456 L
.38095 .14746 L
.38571 .14922 L
.39048 .15091 L
.39524 .15252 L
.4 .15407 L
.40476 .36732 L
.40952 .37156 L
.41429 .37514 L
.41905 .37788 L
.42381 .37972 L
.42857 .38067 L
.43333 .38085 L
.4381 .38042 L
.44286 .37952 L
.44762 .37829 L
.45238 .37684 L
.45714 .37525 L
.4619 .37356 L
.46667 .37181 L
.47143 .37004 L
.47619 .36825 L
.48095 .36646 L
.48571 .36468 L
.49048 .36292 L
.49524 .36117 L
Mistroke
.5 .513 L
.50476 .50623 L
.50952 .50074 L
.51429 .49614 L
.51905 .49218 L
.52381 .4887 L
.52857 .48561 L
.53333 .48281 L
.5381 .48026 L
.54286 .4779 L
.54762 .43686 L
.55238 .44199 L
.55714 .44546 L
.5619 .4475 L
.56667 .44846 L
.57143 .44863 L
.57619 .4483 L
.58095 .44763 L
.58571 .44675 L
.59048 .44574 L
.59524 .32459 L
.6 .32583 L
.60476 .32691 L
.60952 .32775 L
.61429 .32832 L
.61905 .3286 L
.62381 .3286 L
.62857 .32838 L
.63333 .32798 L
.6381 .32746 L
.64286 .32687 L
.64762 .32624 L
.65238 .32559 L
.65714 .32494 L
.6619 .3243 L
.66667 .27612 L
.67143 .27374 L
.67619 .2767 L
.68095 .27419 L
.68571 .27202 L
.69048 .27032 L
.69524 .26918 L
.7 .26861 L
.70476 .26857 L
.70952 .26896 L
.71429 .26969 L
.71905 .27065 L
.72381 .27176 L
.72857 .27295 L
.73333 .27418 L
Mistroke
.7381 .33882 L
.74286 .2492 L
.74762 .24481 L
.75238 .24107 L
.75714 .23819 L
.7619 .23624 L
.76667 .23519 L
.77143 .23493 L
.77619 .23531 L
.78095 .23617 L
.78571 .23737 L
.79048 .2388 L
.79524 .24039 L
.8 .24208 L
.80476 .24383 L
.80952 .24562 L
.81429 .24742 L
.81905 .24923 L
.82381 .25103 L
.82857 .25282 L
.83333 .08421 L
.8381 .09691 L
.84286 .10569 L
.84762 .11239 L
.85238 .11781 L
.85714 .12235 L
.8619 .12626 L
.86667 .12969 L
.87143 .13276 L
.87619 .13553 L
.88095 .13805 L
.88571 .14039 L
.89048 .14256 L
.89524 .14459 L
.9 .1465 L
.90476 .14831 L
.90952 .15003 L
.91429 .15168 L
.91905 .15327 L
.92381 .15479 L
.92857 .15122 L
.93333 .14864 L
.9381 .14768 L
.94286 .14779 L
.94762 .14855 L
.95238 .14968 L
.95714 .151 L
.9619 .1524 L
.96667 .15384 L
.97143 .15528 L
Mistroke
.97619 .19469 L
Mfstroke
1 0 0 r
gsave
.97619 .24326 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27518 m
.02857 .28265 L
.03333 .28853 L
.0381 .29334 L
.04286 .29737 L
.04762 .30086 L
.05238 .30396 L
.05714 .30681 L
.0619 .3095 L
.06667 .31209 L
.07143 .31463 L
.07619 .31714 L
.08095 .31965 L
.08571 .32216 L
.09048 .32468 L
.09524 .32721 L
.1 .32976 L
.10476 .33233 L
.10952 .33491 L
.11429 .33751 L
.11905 .34012 L
.12381 .34274 L
.12857 .34537 L
.13333 .34801 L
.1381 .35064 L
.14286 .35327 L
.14762 .3559 L
.15238 .35851 L
.15714 .36111 L
.1619 .36369 L
.16667 .36625 L
.17143 .36878 L
.17619 .37129 L
.18095 .37376 L
.18571 .37619 L
.19048 .37858 L
.19524 .38092 L
.2 .38322 L
.20476 .38548 L
.20952 .38767 L
.21429 .19868 L
.21905 .20447 L
.22381 .20903 L
.22857 .21287 L
.23333 .21627 L
.2381 .21937 L
.24286 .22225 L
.24762 .22496 L
.25238 .22753 L
.25714 .23 L
Mistroke
.2619 .23237 L
.26667 .23467 L
.27143 .2369 L
.27619 .23907 L
.28095 .2412 L
.28571 .24328 L
.29048 .24532 L
.29524 .24733 L
.3 .24931 L
.30476 .25127 L
.30952 .13044 L
.31429 .14521 L
.31905 .15681 L
.32381 .16625 L
.32857 .17415 L
.33333 .18093 L
.3381 .18685 L
.34286 .1921 L
.34762 .19682 L
.35238 .20111 L
.35714 .20504 L
.3619 .20868 L
.36667 .21207 L
.37143 .21525 L
.37619 .21825 L
.38095 .2211 L
.38571 .22381 L
.39048 .2264 L
.39524 .22889 L
.4 .23129 L
.40476 .41577 L
.40952 .43592 L
.41429 .45252 L
.41905 .46598 L
.42381 .47642 L
.42857 .4841 L
.43333 .4894 L
.4381 .49281 L
.44286 .4948 L
.44762 .49575 L
.45238 .49599 L
.45714 .49574 L
.4619 .49516 L
.46667 .49436 L
.47143 .49341 L
.47619 .49237 L
.48095 .49127 L
.48571 .49013 L
.49048 .48896 L
.49524 .48778 L
Mistroke
.5 .56858 L
.50476 .56376 L
.50952 .5602 L
.51429 .55742 L
.51905 .55515 L
.52381 .55324 L
.52857 .5516 L
.53333 .55015 L
.5381 .54887 L
.54286 .5477 L
.54762 .48345 L
.55238 .50128 L
.55714 .51342 L
.5619 .52143 L
.56667 .52649 L
.57143 .52952 L
.57619 .53123 L
.58095 .53209 L
.58571 .53241 L
.59048 .53241 L
.59524 .37508 L
.6 .39284 L
.60476 .40814 L
.60952 .42126 L
.61429 .43216 L
.61905 .44078 L
.62381 .44723 L
.62857 .45179 L
.63333 .45482 L
.6381 .4567 L
.64286 .45775 L
.64762 .45824 L
.65238 .45835 L
.65714 .45821 L
.6619 .45793 L
.66667 .33223 L
.67143 .34524 L
.67619 .32662 L
.68095 .34047 L
.68571 .3522 L
.69048 .36237 L
.69524 .37109 L
.7 .37842 L
.70476 .38448 L
.70952 .38942 L
.71429 .39346 L
.71905 .3968 L
.72381 .3996 L
.72857 .40202 L
.73333 .40415 L
Mistroke
.7381 .39469 L
.74286 .29592 L
.74762 .30772 L
.75238 .31715 L
.75714 .32507 L
.7619 .3318 L
.76667 .33752 L
.77143 .34243 L
.77619 .34669 L
.78095 .35045 L
.78571 .35386 L
.79048 .357 L
.79524 .35996 L
.8 .36278 L
.80476 .36551 L
.80952 .36815 L
.81429 .37073 L
.81905 .37325 L
.82381 .37572 L
.82857 .37813 L
.83333 .13969 L
.8381 .15174 L
.84286 .16181 L
.84762 .1703 L
.85238 .17755 L
.85714 .18386 L
.8619 .18943 L
.86667 .19441 L
.87143 .19891 L
.87619 .20302 L
.88095 .20681 L
.88571 .21032 L
.89048 .21361 L
.89524 .2167 L
.9 .21962 L
.90476 .2224 L
.90952 .22505 L
.91429 .22759 L
.91905 .23004 L
.92381 .23241 L
.92857 .19976 L
.93333 .2069 L
.9381 .21204 L
.94286 .21611 L
.94762 .21957 L
.95238 .22263 L
.95714 .22544 L
.9619 .22806 L
.96667 .23055 L
.97143 .23293 L
Mistroke
.97619 .24326 L
Mfstroke
gsave
.97619 .14613 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15732 m
.02857 .14054 L
.03333 .12773 L
.0381 .11837 L
.04286 .11186 L
.04762 .10756 L
.05238 .1049 L
.05714 .1034 L
.0619 .10269 L
.06667 .1025 L
.07143 .10268 L
.07619 .10309 L
.08095 .10367 L
.08571 .10436 L
.09048 .10512 L
.09524 .10595 L
.1 .10682 L
.10476 .10772 L
.10952 .10866 L
.11429 .10963 L
.11905 .11062 L
.12381 .11163 L
.12857 .11267 L
.13333 .11373 L
.1381 .11481 L
.14286 .11591 L
.14762 .11702 L
.15238 .11816 L
.15714 .1193 L
.1619 .12047 L
.16667 .12164 L
.17143 .12283 L
.17619 .12402 L
.18095 .12522 L
.18571 .12643 L
.19048 .12764 L
.19524 .12885 L
.2 .13006 L
.20476 .13127 L
.20952 .13248 L
.21429 .08736 L
.21905 .0804 L
.22381 .0768 L
.22857 .07513 L
.23333 .07455 L
.2381 .07457 L
.24286 .07491 L
.24762 .07541 L
.25238 .076 L
.25714 .07662 L
Mistroke
.2619 .07726 L
.26667 .07789 L
.27143 .07851 L
.27619 .07912 L
.28095 .07972 L
.28571 .08031 L
.29048 .08088 L
.29524 .08145 L
.3 .08201 L
.30476 .08256 L
.30952 .03045 L
.31429 .04147 L
.31905 .04838 L
.32381 .05324 L
.32857 .05691 L
.33333 .05981 L
.3381 .06218 L
.34286 .06417 L
.34762 .06589 L
.35238 .06739 L
.35714 .06873 L
.3619 .06993 L
.36667 .07102 L
.37143 .07202 L
.37619 .07296 L
.38095 .07383 L
.38571 .07464 L
.39048 .07542 L
.39524 .07615 L
.4 .07686 L
.40476 .31887 L
.40952 .3072 L
.41429 .29775 L
.41905 .28979 L
.42381 .28301 L
.42857 .27724 L
.43333 .2723 L
.4381 .26802 L
.44286 .26424 L
.44762 .26083 L
.45238 .2577 L
.45714 .25476 L
.4619 .25196 L
.46667 .24927 L
.47143 .24666 L
.47619 .24413 L
.48095 .24165 L
.48571 .23924 L
.49048 .23687 L
.49524 .23457 L
Mistroke
.5 .45742 L
.50476 .4487 L
.50952 .44128 L
.51429 .43486 L
.51905 .42921 L
.52381 .42417 L
.52857 .41962 L
.53333 .41547 L
.5381 .41165 L
.54286 .4081 L
.54762 .39026 L
.55238 .3827 L
.55714 .3775 L
.5619 .37358 L
.56667 .37043 L
.57143 .36775 L
.57619 .36536 L
.58095 .36317 L
.58571 .36109 L
.59048 .35908 L
.59524 .27411 L
.6 .25882 L
.60476 .24568 L
.60952 .23424 L
.61429 .22449 L
.61905 .21642 L
.62381 .20997 L
.62857 .20496 L
.63333 .20113 L
.6381 .19822 L
.64286 .19598 L
.64762 .19423 L
.65238 .19283 L
.65714 .19167 L
.6619 .19067 L
.66667 .22001 L
.67143 .20223 L
.67619 .22678 L
.68095 .2079 L
.68571 .19183 L
.69048 .17827 L
.69524 .16727 L
.7 .1588 L
.70476 .15266 L
.70952 .14851 L
.71429 .14592 L
.71905 .1445 L
.72381 .14391 L
.72857 .14388 L
.73333 .14421 L
Mistroke
.7381 .28295 L
.74286 .20248 L
.74762 .18189 L
.75238 .16499 L
.75714 .1513 L
.7619 .14068 L
.76667 .13285 L
.77143 .12743 L
.77619 .12394 L
.78095 .12189 L
.78571 .12088 L
.79048 .1206 L
.79524 .12082 L
.8 .12138 L
.80476 .12216 L
.80952 .12309 L
.81429 .12412 L
.81905 .12521 L
.82381 .12635 L
.82857 .12751 L
.83333 .02874 L
.8381 .04209 L
.84286 .04957 L
.84762 .05449 L
.85238 .05807 L
.85714 .06084 L
.8619 .06309 L
.86667 .06498 L
.87143 .0666 L
.87619 .06803 L
.88095 .0693 L
.88571 .07045 L
.89048 .0715 L
.89524 .07247 L
.9 .07337 L
.90476 .07422 L
.90952 .07502 L
.91429 .07577 L
.91905 .07649 L
.92381 .07718 L
.92857 .10267 L
.93333 .09038 L
.9381 .08333 L
.94286 .07947 L
.94762 .07753 L
.95238 .07672 L
.95714 .07655 L
.9619 .07674 L
.96667 .07713 L
.97143 .07762 L
Mistroke
.97619 .14613 L
Mfstroke
0 g
gsave
.97619 .21823 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02 w
.02381 .20697 Mdot
.21429 .11538 Mdot
.30952 .03412 Mdot
.40476 .50012 Mdot
.5 .54929 Mdot
.54762 .40735 Mdot
.59524 .26475 Mdot
.66667 .26598 Mdot
.67619 .27934 Mdot
.7381 .35301 Mdot
.74286 .18034 Mdot
.83333 .04316 Mdot
.92857 .14808 Mdot
.97619 .21823 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{281.812, 174.188},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[R000`400?l00000o`00003ooooooolJ
ooooo`008?ooool2o`0003;ooooo0ol00004ooooo`;o0000;Oooool3o`0000Cooooo0_l00004oooo
o`;o0000:Oooool3o`0000?ooooo0ol00004ooooo`;o0000:?ooool5o`0000?ooooo0_l00004oooo
o`;o00004?ooool001oooooo00Co0000oooooooooooo0000<?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo0000;Oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo0000:Oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Vooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000?ooooo`00
7oooool01?l0003oooooooooool0000dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo0000:Oooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00003oooool001oooooo00Co0000oooooooooooo0000=?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0002Wooooo00?o0000ooooooooool0
1Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo02Sooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03Oooool0
01oooooo00Co0000oooooooooooo0000<?ooool4o`0000?ooooo00Co0000oooooooooooo0000;Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
0000:Oooool01?l0003oooooooooooooool4o`0000?ooooo00Co0000oooooooooooo00009oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000?ooooo`007oooool01?l0003oooooooooool0000`ooooo`03o`000?oooooooooo00Co
oooo00Co0000oooooooooooo0000;?ooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Xooooo`;o00000oooool00ol0003oooooooooo`04ooooo`04o`000?oo
ooooooooo`0002Oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00003oooool0023ooooo0_l0000aooooo`Go00000oooool2o`00
02kooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l0000Zooooo`04o`000?oooooooooo
ooooo`Go00000oooool2o`0002Wooooo0ol00004ooooo`;o00001?ooool2o`00013ooooo003ooooo
oa[ooooo003ooooooa[ooooo003ooooooa[ooooo003ooooooa[ooooo000KooooobOo00000_l00?lN
o`0000;o003o00?o0000o`00ool00?l0X_l0000@ooooo`006oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07oooo
o`;o003o2_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooo
oooo003oo`00o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00?o001oooooool007l00oooool00ol0
003oooooooooo`08ooooo`03o`000?l007oooooo00Sooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool07_ooool2o`00o`[ooooo00?o001oooooooooool02?ooool00ol0003o
ooooooooo`06ooooo`;o003o00?oooooo`00ool00?l05?ooool00ol007ooooooooooo`0Dooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo00?o0000o`00Ooooool05?ooool00ol007ooooooooooo`0Cooooo`03
o`00Oooooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
6oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01[ooooo0_l00?l2ooooo`;o003o
2_ooool00ol007ooooooooooo`0Aooooo`;o003o00?oooooo`00ool00?l05?ooool00ol007oooooo
ooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo
000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool06_ooool2o`00o`;ooooo0_l0
0?l:ooooo`03o`00Oooooooooooo017ooooo0_l00?l00ooooooo003oo`00o`0Dooooo`03o`00Oooo
oooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04ooo
ool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_oo
ool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Jooooo`;o003o00Cooooo
o`00ool00?oo003o2_ooool00ol007ooooooooooo`0@ooooo`?o003o00?oooooo`00ool00?l05?oo
ool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooo
oooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool06_ooool2
o`00o`04ooooool00?oo003oo`00o`[ooooo00?o001oooooooooool03oooool3o`00o`;ooooo0_l0
0?lDooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o
001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0J
ooooo`;o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`?ooooo00?o001oooooooooool03ooo
ool3o`00o`04ooooool0003o0000o`00oaCooooo00?o001oooooooooool05?ooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007oooooo
o`00O`0>ooooo`;o001o5?ooool2ool001Gooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`;o00001?ooool00ol007oooooooooo
o`0Jooooo`;o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`?ooooo00?o001oooooooooool0
3oooool3o`00o`Co00005?ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo
0_l007lDooooo`;oo`005Oooool00ol007ooooooooooo`04ooooo`;o003o0_ooool00ol007oooooo
ooooo`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool00oooool00ol007oooooooooo
o`0Iooooo`Oo003o1Oooool2o`00o`?ooooo00?o001oooooooooool03oooool3o`00o`Co00005?oo
ool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lDooooo`;o000000?o
o`00ooooooooool04_ooool00ol007ooooooooooo`03ooooo`?o003o0_ooool00ol007oooooooooo
o`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001o
ooooooooool06Oooool8o`00o`?ooooo0ol00?l3ooooo`03o`00Oooooooooooo00oooooo0_l00?l2
ooooo`;o000000?oo`00o`00ooooool04_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
001o00kooooo0_l007lCooooo`Co00005?ooool00ol007ooooooooooo`03ooooo`?o003o0_ooool0
0ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo
00?ooooo00?o001oooooooooool06Oooool8o`00o`?ooooo0ol00?l3ooooo`03o`00Oooooooooooo
00[ooooo0_l00?l2ooooo`?o003o00?oooooool00?oo00000_oo00000ol00?ooooooooooo`0Aoooo
o`03o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00Oa?ooooo1?l0000;oooo
o`;o003o1oooool00ol007ooooooooooo`03ooooo`?o003o0_ooool00ol007ooooooooooo`03oooo
o`03o`000?oooooooooo00kooooo000Dooooo`?o00001?ooool00ol0003oooooooooo`03ooooo`03
o`00Oooooooooooo01Wooooo2?l00?l3ooooo`?o003o0oooool00ol007ooooooooooo`0:ooooo`;o
003o0_ooool2o`00o`;ooooo1Ooo000Cooooo`03o`00Oooooooooooo01Cooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool0
07l03_ooool2o`00OaCooooo0_l00002ool000[ooooo0_l00?l7ooooo`03o`00Oooooooooooo00?o
oooo0ol00?l2ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001Gooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00Kooooo
0_l00?lAooooo`So003o0_ooool4o`00o`?ooooo00?o001oooooooooool02_ooool2o`00o`;ooooo
0_l00?l2ooooo`;oo`0000Co001oool00?oo003oo`004_ooool00ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo0_l007lDooooo`Goo`002Oooool2o`00o`Oooooo00?o001ooooooooo
ool00oooool3o`00o`;ooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`00
3?ooool5o`000003ooooool0003o000000?o00001?ooool00ol0003oooooooooo`03ooooo`03o`00
Oooooooooooo00Kooooo0_l00?lAooooo`So003o0_ooool4o`00o`?ooooo00?o001oooooooooool0
2_ooool2o`00o`;ooooo0_l00?l2ooooo`;oo`0000?o001oo`00oooo00000ooo000@ooooo`03o`00
Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00Oa?ooooo0ooo00001?ooooooo`00
ool00?oo0008ooooo`;o003o0_ooool2o`00o`?ooooo00?o001oooooooooool00oooool3o`00o`;o
oooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`004_ooool01?l0003ooooo
ooooool00005ooooo`?o00000oooool00ol007ooooooooooo`05ooooo`?o003o4Oooool8o`00o`;o
oooo1?l00?l3ooooo`03o`00Oooooooooooo00Wooooo0ol00?l2ooooo`;o003o0_ooool2ool00003
o`00Ool00?oo003o00Koo`003Oooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00ko
oooo0_l007lCooooo`;oo`0000?o001oooooooooool01?oo00000ol00?ooooooooooo`02ooooo`?o
003o0_ooool2o`00o`04ooooool00?oo003oo`00O`Cooooo1Ol00?l00ooooooo001oooooo`03oooo
o`;o00004?ooool001?ooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`03ooooo`03
o`00Oooooooooooo00Gooooo0ol00?lAooooo`So003o0_ooool4o`00o`?ooooo00?o001oo`00ool0
0?l02Oooool3o`00o`;ooooo0_l00?l2ooooo`;oo`0000?o001oo`00ool00?l00_ooool6ool000_o
oooo00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o4oooool2ool00004
o`00Ooooooooooooooooo`Ooo`0000Goooooo`00ool00?oo003oooooo`03o`00o`04ooooool00?oo
003oo`00O`Cooooo0_l00?l01Ooooooo003oo`00oooooooo001o00Gooooo00?o0000ooooooooool0
3_ooool001Cooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool01Ooo
ool3o`00oa7ooooo1Ol00?l00ooooooo003oo`00o`02ooooo`Co003o0oooool01?l007oo003oo`00
ooooool2o`00o`Kooooo0ol00?l01?oooooo003oo`00ool00?l2ooooo`;oo`0000?o001oo`00ool0
0?l01Oooool7ool000Oooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o
001o3oooool2o`00o`;ooooo0_oo00000ol007ooooooooooo`03ooooo`Woo`0000Goooooo`00ool0
0?oo003oooooo`02o`00o`03o`00Oooooooooooo00;ooooo0_l00?l01Ooooooo003oo`00oooooooo
001o00Gooooo00?o0000ooooooooool03_ooool001Gooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`00Oooooooooooo00Gooooo0ol00?l@ooooo`Ko003o00?oooooo`00
ool00?l00_ooool4o`00o`?ooooo00?o001oool00?oo00002?oo00001Ooooooo003oo`00ool00?oo
oooo00;o003o0_ooool3ool00003o`00Ool00?oo003o00Oooooo3?oo00000ol007ooooooooooo`0D
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooo001o00kooooo0_l007l>ooooo`?o003o0_ooool2ool00003o`00Oooooooo
oooo00?ooooo0_l00?l2ooooo`_oo`0000?o003oo`00Ooooool00oooool4ool00003o`00oooooooo
001o00Gooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol0
07ooooooooooo`05ooooo`?o003o4?ooool2o`00o`05ooooool00?oo003oo`00ooooool00_l00?l0
0ooooooo003oo`00o`04o`00o`;ooooo4ooo00000oooooooo`00ool00002o`3jVP;o003o2oooool8
ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00O`kooooo0ol00?l2
ooooo`;oo`0000?o001oooooooooool00oooool3o`00o`?ooooo0_l00?l8ool00003o`00Oooooooo
o`0000Soo`0000?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0
003oooooooooo`03ooooo`03o`00Oooooooooooo00Gooooo0ol00?l@ooooo`;o003o0_ooool2o`00
o`04ooooool00?oo003oooooo`;o003o0_ooool2o`00o`;ooooo0_oo0004o`00o`Cooooo3?oo0002
o`3jVP;o003o4Oooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2
o`00O`kooooo0ol00?l2ooooo`;oo`0000?o0?ZJooooooooool00oooool3o`00o`?ooooo1ol00?l0
1?ooooooo`00ool00?l007l5ool00003o`00ooooooooo`0000;oo`0000?o001oooooooooool00ooo
ool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooo
oooo00Gooooo1?l00?l?ooooo`;o003o0_ooool2o`00o`04ooooool00?oo003oooooo`;o003o0_oo
ool2o`00o`04oooooooo003oo`00ool000Co003o1_ooool6o`00o`Coo`000ol0nYX00ol00?oooooo
ooooo`0?ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00
Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o
3_ooool4o`00o`04oooooooo003oo`00o`3jVPGooooo0ol00?l3ooooo`Oo003o00Coooooool00?oo
003o001o0_oo0002ooooo`;o003o00Goooooo`00oooo003oo`00o`00O`05ooooo`03o`000?oooooo
oooo00kooooo000Kooooo`;o00001?ooool00ol007ooooooooooo`05ooooo`Co003o3oooool2o`00
o`;ooooo0_l00?l01?oooooo003oo`00ooooool2o`00o`;ooooo0_l00?l00oooooooo`00ool00005
o`00o`Gooooo1ol00?l4ooooo`?o0?ZJ0_l00?l@ooooo`;oo`0000?o001oooooooooool05?ooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool0
0ol007ooooooo`00O`0>ooooo`;o001o3Oooool5o`00o`03oooooooo003oo`0000;o0?ZJ0oooool4
o`00o`?ooooo1ol00?l00oooooooo`00ool00003ool00006ooooool00?oo003oo`00oooooooo003o
0_oo00000ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool00ooo
ool00ol007ooooooooooo`05ooooo`Co003o3oooool2o`00o`;ooooo0_l00?l01?oooooo003oo`00
ooooool2o`00o`;ooooo0_l00?l00oooooooo`00ool00005o`00o`03ooooool00?oo003o00;ooooo
0_l00?l00ooooooo003oo`00o`02o`00o`Cooooo0ol0nYX2o`00oa3ooooo0_oo00000ol007oooooo
ooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007l=ooooo`;o003o00Coooooo`00ool00?oo
oooo0_oo0002o`3jVP?ooooo1_l00?l00ooooooo003oo`00o`06o`00o`Coo`000_ooool2o`00o`;o
oooo00Co003oool00?oo003o001o1Oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003o
ooooooooo`03ooooo`03o`00Oooooooooooo00Cooooo1Ol00?l?ooooo`;o003o0_ooool2o`00o`04
ooooool00?oo003oooooo`;o003o0_ooool2o`00o`03oooooooo003oo`0000Go003o00?oooooo`00
ool00?l00_ooool2o`00o`04ooooool00?oo003oo`00o`Gooooo1?l0nYX00ol00?ooooooooooo`0>
ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o3Oooool2
o`00o`04ooooool00?oo003oooooo`;oo`000_l0nYX3ooooo`Ko003o00?oooooo`00ool00?l00_l0
0?l2ooooo`?o003o0ooo0002ooooo`;o003o0_ooool01?l00?ooo`00ool00?l007l5ooooo`03o`00
0?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool00ooo
ool<ool000Wooooo0_l00?l5ooooo`Go003o0_ooool3o`00o`;oo`001Ol00?l00ooooooo003oo`00
o`02ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool5o`3jVP03o`00oooooooooooo00kooooo
0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
2?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007l=ooooo`;o003o
00?oooooo`00ool00?l00ooo0003o`3jVP;ooooo2ol00?l2ooooo`?o003o0_oo0002o`00o`03oooo
ool00?oo003o00;ooooo00Co003oool00?oo003o001o1Oooool00ol0003oooooooooo`0>ooooo`00
6oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00;ooooo4ooo0003ooooo`;o003o
1_ooool4o`00o`;ooooo0ol00?l2o`0000So003o0_ooool2o`00o`04ooooool00?oo003oo`00o`Co
oooo0_l0nYX01?l007oo0?ZJo`3jV_l0nYX@ooooo`;oo`0000?o001oooooooooool05?ooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol0
07ooooooo`00O`0>ooooo`;o001o3Oooool2o`00o`03ooooool00?oo003o00;oo`001?l0nYX2oooo
o`So003o00?oooooo`00ool00?l00_ooool3o`00o`;oo`000_l00?l00ooooooo003oo`00o`02oooo
o`04o`00oooo003oo`00o`00O`Gooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000oooo
ooooool00oooool00ol007ooooooooooo`04ool000;o003o00?oooooo`00ool00?l01Oooool;ool0
0003o`00oooooooooooo00Cooooo1?l00?l2ooooo`;o003o1?l00002o`00o`03ooooool00?oo003o
00;o003o0_ooool2o`00o`04ooooool00?oo003oo`00o`Cooooo0_l0nYX01?l007ooooooo`3jV_l0
nYX@ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o3Ooo
ool2o`00o`03ooooool00?oo003o00;oo`001Ol0nYX01?oooooo003oo`00ooooool5o`00o`Gooooo
1ol00?l00ooooooo003oo`00o`02ooooo`04o`00oooo003oo`00o`00O`Gooooo00?o0000oooooooo
ool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooool00003ool00004oooo
ool00?oo003oooooo`;o003o2oooool9ool000?ooooo1?l00?l2ooooo`;o003o1?l00003ooooo`Co
003o0_ooool2o`00o`Sooooo0_l0nYX00ol007ooooooo`3jVP02o`3jVPoooooo0_oo00000ol007oo
ooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007l=ooooo`;o003o00?oooooo`00ool0
0?l00_oo0002o`3jVP04ooooool0nY[o0?ZJo`3jVP;o003o00?oooooo`00ool00?l00ol00?l5oooo
o`Oo003o00?oooooo`00ool00?l00_ooool01?l00?ooo`00ool00?oo0005ooooo`03o`000?oooooo
oooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00Co001ooooooooo003oo`000oooool2
o`00o`03ooooool00?oo003o00kooooo00?o003oool00?oo00001ooo0003o`00o`;ooooo0_l00?l0
1?oo003o0000o`000?l00?l3ooooo`Co003o0_ooool2o`00o`Sooooo0_l0nYX00ol007ooooooo`00
o`03o`3jVPkooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l0
07l7ooooo`Woo`000_l00?l2ool000;o0?ZJ0_ooool3o`3jVP03o`00oooooooo003o00Co003o1Ooo
ool:o`00o`?ooooo00?o003oool00?oo00001Oooool00ol0003oooooooooo`0>ooooo`006oooool2
o`0000Cooooo00Co001oool00?oo003oo`000oooool2o`00o`04ooooool00?oo003oo`00o`gooooo
0_l00?l3ooooo`[oo`000_l00?l2ool000;o003o0oooool5o`00o`03ooooool00?oo003o00Sooooo
0_l0nYX01?l007ooooooo`00ool00?l4o`3jVPcooooo0_oo00000ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo0_l007l5ooooo`ooo`000_l0nYX3ooooo`?o0?ZJ0oooool3o`00o`Go
oooo1Ol00?l01?oooooo003oo`00ool00?l4ooooo`03o`00oooo003oo`0000Cooooo0_l0000@oooo
o`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooo003oo`0000Cooooo0_l00?l2ooooo`;o
003o3Oooool2o`00o`Oooooo2_oo00000ol007ooooooooooo`02ooooo`Go003o00?oooooo`00ool0
0?l02?ooool01?l0nY[oo`00ool00?ooool2o`00o`03ooooool0nY[o0?ZJ00?o0?ZJ2_ooool2ool0
0003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00O`Gooooo0ooo00001?l0
0?ooooooooooooooool2o`00o`03oooooooo003oo`0000?oo`000_l0nYX4ooooo`Co0?ZJ00Cooooo
o`00ool00?oo003o1Oooool5o`00o`04ooooool00?oo003oo`00o`Cooooo00?o003oool00?oo0000
1Oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooo
003oo`0000Cooooo0_l00?l2ooooo`?o003o3?ooool2o`00o`Oooooo0ol00?l2ooooo`Goo`0000?o
001oooooooooool00_ooool5o`00o`03ooooool00?oo003o00Sooooo00Co0?ZJool00?oo003ooooo
0ol00?l2ooooo`Co0?ZJ2Oooool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool0
2?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l0
3_ooool2o`00O`Cooooo0ooo0002o`00o`?ooooo0_l00?l2ooooo`?o003o0_l0nYX00ol007oooooo
ooooo`02ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ0_l00?l5ooooo`;o003o00Coooooo`00ool00?oo
oooo0ol00?l4ooooo`03o`00oooo003oo`0000Gooooo00?o0000ooooooooool03_ooool001_ooooo
00?o0000ooooooooool00oooool3ool000Cooooo0_l00?l3ooooo`?o003o2oooool2o`00o`Oooooo
0ol00?l4ooooo`04o`00oooo003oo`00o`00O`Cooooo1Ol00?l00ooooooo003oo`00o`08ooooo`03
o`3jV_oo003oo`0000;ooooo0_l00?l4ooooo`Co0?ZJ1oooool2ool00003o`00Oooooooooooo01Co
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooool007l03_ooool2o`00O`Cooooo0_oo00000ooooooo003oo`00o`02o`00o`03
ooooool00?oo003o00?ooooo0_l00?l00ol0nY[oo`00ool00004ooooo`;o003o00?oooooo`3jV_l0
nYX00ol0nYX9ooooo`03o`00Oooooooooooo00;o003o1?ooool00ol00?ooo`00ool00005ooooo`03
o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo0_oo0005ooooo`;o003o
1?ooool2o`00o`_ooooo0_l00?l8ooooo`;o003o1_ooool6o`3jVPSo003o2?ooool01Ol0nY[oo`00
ool00?oo003ooooo00?o003o1?ooool5o`3jVPGooooo0_oo00000ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00Sooooo1_oo0002o`00O`?ooooo0ooo00000ooooooo003oo`00o`02o`00o`03
ooooool00?oo003o00?ooooo0_l00?l00ol0nY[oo`00ool00003ooooo`?o003o0oooool5o`3jVPKo
oooo0_l00002ooooo`;o003o1?ooool00ol00?ooo`00ool00005ooooo`03o`000?oooooooooo00ko
oooo000Kooooo`03o`000?oooooooooo00?ooooo0_oo0004ooooo`?o003o1?ooool2o`00o`Oooooo
0_l00?l2ooooo`;o003o2?ooool2o`00o`Kooooo2Ol0nYX4o`00o`Wooooo00Go0?ZJool00?oo003o
o`00ooooo`03o`00o`Kooooo1_l0nYX2ooooo`;oo`0000?o001oooooooooool05?ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007oo
ooooo`00O`06ooooo`Soo`000_l007l3ooooo`;oo`000_ooool4o`00o`03ooooool00?oo003o00?o
oooo0_l00?l01?l0nY[oo`00ool00?oo0002ooooo`;o003o1_ooool6o`3jVP;ooooo1?l00004o`3j
VP?ooooo00?o003oool00?oo00001Oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003o
ooooooooo`03ooooo`;oo`001?ooool2o`00o`Gooooo0ol00?l6ooooo`;o003o0_ooool2o`00o`So
oooo0_l00?l6ooooo`;o0?ZJ0oooool6o`3jVP;o003o2?ooool2o`3jVP?oo`0000?oooooo`00ool0
0?l00_l00?l7ooooo`Ko0?ZJ0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`09ooooo`;o003o0oooool00ol007oo
ooooo`00O`05ooooo`Coo`000oooool2ool000;o001o0_ooool3ool000Wo003o0oooool2o`00o`04
o`3jV_oo003oo`00ool000;ooooo0_l00?l8ooooo`Ko0?ZJ1?l00007o`3jVP03o`00oooo003oo`00
00Gooooo00?o0000ooooooooool03_ooool001_ooooo0_l00003ooooo`?oo`001?ooool2o`00o`Ko
oooo0_l00?l6ooooo`;o003o0_ooool2o`00oa3ooooo0_l0nYX5ooooo`03o`00ool0nY[o0?ZJ00Go
0?ZJ1_ooool2o`3jVPCoo`001?l00?l:ooooo`?o0?ZJ0_oo00000ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`09ooooo`;o
003o0oooool00ol007ooooooo`00O`05ooooo`;oo`001Oooool2ool000;o001o0_ooool2ool000[o
003o0oooool2o`00o`04o`3jV_oo003oo`00ool000;ooooo0_l00?l;ooooo`Co0?ZJ0_l00004oooo
o`Ko0?ZJ00?o001oooooooooool00_ooool2o`00013ooooo000Kooooo`03o`000?oooooooooo00;o
oooo0_oo0005ooooo`;o003o1_ooool2o`00o`Kooooo0_l00?l2ooooo`;o003o4?ooool2o`3jVPGo
oooo0ol00?l8o`3jVP?ooooo0_l0nYX4ool000Co003o3Oooool2ool00003o`00Oooooooooooo01Co
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Wo
oooo0_l00?l3ooooo`03o`00Oooooooo001o00Cooooo0ooo0005ooooo`;oo`000_l007l01?oooooo
o`00ool00?oo000:o`00o`?ooooo0_l00?l00ol0nY[oo`00ool00002ool00003ooooool00?oo003o
00gooooo0ol0nYX00ol007ooooooooooo`05ooooo`?o0?ZJ00?o001oooooooooool00oooool00ol0
003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`02ooooo`;oo`001Oooool2o`00o`Ko
oooo0ol00?l5ooooo`Ko003o4?ooool2o`3jVPGooooo1_l00?l00ooooooo0?ZJo`3jVP06o`3jVPKo
o`000ol00?l=ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02Oooool2o`00o`?ooooo00?o001oooooool0
07l01?ooool2ool000Kooooo0_oo0002o`00O`?oo`002_l00?l4ooooo`;o003o00?o0?ZJool00?oo
00000_oo00000ooooooo003oo`00o`0@ooooo`03o`00Oooooooooooo00Kooooo0_l0nYX00ol007oo
ooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo
00?o001oooooooooool00oooool2o`00o`Oooooo0_l00?l4ooooo`Ko003o4Oooool2o`3jVPOooooo
1?l00?l4ooooo`Go0?ZJ0_oo00001Ol007ooooooool00?oo003ooooo00?o003o3?ooool2ool00003
o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Wooooo0ol00?l2ooooo`03o`00Oooooooo001o00?ooooo0ooo0006ooooo`;o
o`000_l007l2ool00003ooooool00?oo003o00So003o1_ooool00ol0nY[oo`00ool00002ool000?o
003o4?ooool00ol007ooooooooooo`06ooooo`;o0?ZJ00?o003oooooooooool00oooool00ol0003o
ooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00?ooooo
0_l00?l7ooooo`;o003o1?ooool6o`00oa7ooooo0_l0nYX7ooooo`Co003o2?ooool01Ol0nY[oo`00
ool00?l007oooooo00?oo`0000?oooooo`00ool00?l03?ooool2ool00003o`00Oooooooooooo01Co
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Wo
oooo0ol00?l2ooooo`03o`00Ool00?oo003o00?ooooo0_oo0007ooooo`;oo`000_l007l2ool00004
ooooool00?oo003oooooo`;o003o0oooool2o`00o`Kooooo00?o0?ZJool00?oo00000ooo00000ol0
0?ooooooooooo`0?ooooo`03o`00Oooooooooooo00Kooooo0_l0nYX00ol00?ooooooooooo`03oooo
o`03o`000?oooooooooo00kooooo000Booooo`Go00001?ooool00ol0003oooooooooo`03ooooo`03
o`00Oooooooooooo00?ooooo0_l00?l7ooooo`;o003o1?ooool6o`00oa7ooooo0_l0nYX8ooooo`?o
003o2Oooool2ool00003o`00Oooooooooooo00;oo`0000?oooooo`00ool00?l03?ooool2ool00003
o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Sooooo1?l00?l2ooooo`03o`00Ool00?oo003o00;ooooo0ooo00000ooooooo
003oo`00o`04ooooo`;oo`000_l00002ool00004ooooool00?oo003oooooo`;o003o0oooool2o`00
o`Kooooo00Co0?ZJool00?oo003o003o0ooo000Aooooo`03o`00Oooooooooooo00Kooooo0ol0nYX5
ooooo`03o`000?oooooooooo00kooooo000Cooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ooooooooool00oooool00ol007ooooooooooo`03ooooo`;o003o1oooool2o`00o`Cooooo1?l00?lC
ooooo`;o0?ZJ2?ooool3o`00o`Wooooo0_oo00000ol007ooooooooooo`03ool000;o003o3?ooool2
ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00Sooooo1?l00?l2ooooo`03o`00Ool00?oo003o00;ooooo0_oo0002
ooooo`;o003o1?ooool00ooo003o0000o`000002o`000005o`00oooooooo003oo`00ooooool00_l0
0?l;ooooo`03o`3jV_oo003oo`0000;o003o0_oo000Aooooo`03o`00Oooooooooooo00Oooooo0_l0
nYX5ooooo`03o`000?oooooooooo00kooooo000<ooooo`Go00000oooool00ol0003oooooooooo`04
ooooo`?o00000oooool00ol007ooooooooooo`02ooooo`?o003o1oooool3o`00o`?ooooo1?l00?lC
ooooo`;o0?ZJ2?ooool3o`00o`Wooooo0_oo00001?l007ooooooooooooooool3ool00003o`00oooo
oooooooo00[ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`Co003o0_ooool00ol007oo003oo`00
o`02ooooo`;oo`001?l00?l4ooooo`03ool00?l0003o000000;o00001?l00?l00ooooooo003oo`00
o`0;ooooo`03o`3jV_oo003oo`0000;o003o0ooo000@ooooo`03o`00Oooooooooooo00Oooooo0_l0
nYX4ooooo`;o00004?ooool001Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`00Oooooooooooo00;ooooo0_l00?l9ooooo`;o003o0oooool2o`00oaGooooo0_l0nYX8
ooooo`;o003o2_ooool2ool00003o`00Oooooooooooo00;ooooo0ooo000<ooooo`;oo`0000?o001o
ooooooooool05?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001o
ooooooooool02?ooool4o`00o`;oo`0000Co001oo`00ool00?oo003o0ooo0004o`00o`Cooooo0_oo
0002o`000004ool00?l00?oo003oo`00o`oooooo00?o0?ZJool00?oo00000_l00?l01?ooooooo`00
ool00?oo000?ooooo`03o`00Oooooooooooo00Oooooo0_l0nYX5ooooo`03o`000?oooooooooo00ko
oooo000Booooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`03ooooo`03
o`00Oooooooooooo00;ooooo0_l00?l9ooooo`;o003o00?oooooo`00ool00?l00_l00?lEooooo`;o
0?ZJ2?ooool2o`00o`[ooooo0_oo00000ol007ooooooooooo`03ooooo`?oo`002oooool2ool00003
o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Sooooo00?o003oool00?oo00000ooo00001?l007oo003oo`00ool00?l2ool0
0003ooooool00?oo003o00;o003o1?ooool5ool000?o003o3oooool00ol0nY[oo`00ool00002o`00
o`;ooooo1?oo000=ooooo`03o`00Oooooooooooo00Oooooo0_l0nYX5ooooo`03o`000?oooooooooo
00kooooo000Booooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`03oooo
o`03o`00Oooooooooooo00;ooooo0_l00?l9ooooo`;o003o00?oooooo`00ool00?l00_l00?lEoooo
o`;oo`005?ooool2ool00003o`00Oooooooooooo00?ooooo00Co003oool00?oo003oo`002_ooool2
ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00Kooooo2?oo00001?l007oo003oo`00ool00?l2ool000Go003o1?oo
ool4ool000Co003o3oooool00ol0nY[oo`00ool00002o`00o`?ooooo1?oo000<ooooo`03o`00Oooo
oooooooo00Oooooo0_l0nYX5ooooo`03o`000?oooooooooo00kooooo000Cooooo`?o00001Oooool0
0ol0003oooooooooo`02ooooo`;o00001?ooool2o`00o`Wooooo1ol00?lEooooo`;oo`005?ooool2
ool00003o`00Oooooooooooo00Cooooo00Co003oool00?oo003oo`002Oooool3ool001Kooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo1Ooo
00000ooooooo003oool00003ool00004o`00oooo003oo`00ool000Go003o1?ooool4ool000Co003o
3oooool3ool00003o`00oooooooooooo00Cooooo0ooo000:ooooo`;oo`002_ooool00ol007oooooo
ooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`04o`000?ooooooooooooooo`Co0000
2Ol0nYX5ooooo`Ko003o5Oooool01?l0nY[oo`00ool00?oo000Cooooo`;oo`0000?o001ooooooooo
ool01?ooool2o`00o`?oo`002?ooool00ol0nY[oo`00ool0000Fooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`04ooooo`?oo`000ol00?l00ooooooo
003oool00003ool00004o`00oooo003oo`00ooooo`;o003o00Coooooo`00ool00?oo003o0oooool4
ool000Co003o3oooool2ool00003o`00Oooooooooooo00Kooooo0ooo0009ooooo`?oo`002Oooool0
0ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`04o`000?oooooooooo
ooooo`Co00003Ol0nYX00ooooooo003oo`00o`04o`00oaGooooo00?o0?ZJool00?oo00000_oo000B
ooooo`;oo`0000?o001oooooooooool01?ooool2o`00o`03oooooooo003oo`0000;oo`001_ooool0
0ol0nY[oo`00ool0000Fooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`03ooooo`?oo`000ol00?l2ooooo`;o003o0ooo00001?l00?ooo`00ool00?oo
ool2o`00o`;ooooo0_l00?l3ooooo`Coo`0000Co003oooooool00?oo003o3oooool2ool00003o`00
Oooooooooooo00Oooooo0ooo0008ooooo`Goo`001oooool00ol007ooooooooooo`03ooooo`03o`00
0?oooooooooo00kooooo000Kooooo`;o00000oooool2o`0000;o0?ZJ0_ooool2o`00o`?ooooo1ol0
nYX5o`00oaGooooo00?o0?ZJool00?oo00001Ooo000?ooooo`;oo`0000?o001oooooooooool01?oo
ool4o`00o`Coo`001Oooool00ol0nY[oo`00ool0000Fooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool02?ooool2o`00o`?ooooo0ooo0004o`00o`;ooooo0_l00?l6ool00003ooooool0
0?oo003o00;ooooo0_l00?l3ooooo`Coo`0000Co003oooooool00?oo003o3_ooool01?l0nY[oo`00
ool00?l007l:ooooo`?oo`001oooool6ool000Kooooo0_l00003ooooo`;o00004?ooool001_ooooo
00?o0000ooooooooool00_ooool2o`3jVPCooooo0_l00?l7ooooo`Ko0?ZJ0_l00?lEooooo`04o`3j
V_oo003oo`00ooooo`Goo`003_ooool2ool00003o`00Oooooooooooo00Cooooo1?l00?l2ooooo`Co
o`000oooool00ol0nY[oo`00ool0000Fooooo`03o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool02?ooool2o`00o`?ooooo0_oo00000ooooooo003oo`00o`02o`00o`;ooooo0_l00?l5ool00004
o`00oooooooo003oo`00o`;ooooo0_l00?l4ooooo`?oo`0000?o003oooooooooool03oooool01?l0
nY[oo`00ool00?l007l;ooooo`Coo`001?ooool3ool000;ooooo0ooo0004ooooo`Co00000oooool0
0ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo
00;ooooo0_l00?l9ooooo`Oo0?ZJ5?ooool00ol0nY[oo`00ool00004ooooo`?oo`003Oooool2ool0
0003o`00Oooooooooooo00Gooooo0ol00?l3ooooo`Goo`0000Coooooo`3jV_oo003oo`005_ooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo0ol00?l01Oooooooo`00ool00?oo
003ooooo00?o003o0oooool2o`00o`Goo`0000Co003oooooool00?oo003o0_ooool2o`00o`Cooooo
0ooo00000ol00?ooooooooooo`0?ooooo`04o`3jV_oo003oo`00o`00O`cooooo1Ooo0002ooooo`;o
o`0000Co001ooooooooooooooooo0ooo0003ooooo`Co00000oooool00ol0003oooooooooo`0>oooo
o`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo00;ooooo0_l00?l:ooooo`;o
003o1ol0nYXAooooo`03o`3jV_oo003oo`0000Gooooo1?oo000:ooooo`?oo`0000?o001ooooooooo
ool01Oooool3o`00o`Gooooo1ooo000Fooooo`03o`00Oooooooooooo00Sooooo00?o001ooooooooo
ool02?ooool3o`00o`03oooooooo003oo`0000;ooooo0ol00?l3ooooo`Co003o0ooo00001?l00?oo
ooooo`00ool00?l2ooooo`;o003o1?ooool3ool00003o`00oooooooooooo00oooooo00Co0?ZJool0
0?oo003o001o3_ooool7ool00003o`00Oooooooooooo00;ooooo1?oo0002ooooo`;o00001?ooool0
0ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo
00;ooooo0_l00?l:ooooo`;o003o0oooool6o`3jVPoooooo00?o0?ZJool00?oo00001_ooool5ool0
00Sooooo0_oo00000ooooooo001oooooo`07ooooo`;o003o1oooool5ool001Kooooo00?o001ooooo
ooooool02?ooool00ol007ooooooooooo`08ooooo`?o003o0ooo0002ooooo`;o003o1?ooool4o`00
o`;oo`000_l00?l00ooooooo003oo`00o`02ooooo`;o003o1?ooool3ool00003o`00oooooooooooo
00oooooo00Co0?ZJool00?oo003o001o4?ooool5ool00003o`00Oooooooooooo00?ooooo1Ooo0000
0ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo
00?ooooo00?o001oooooooooool00_ooool2o`00o`[ooooo0_l00?l6ooooo`Go0?ZJ3Oooool00ol0
nY[oo`00ool00008ooooo`Koo`001Oooool2ool00003ooooool007oooooo00Oooooo0_l00?l9oooo
o`?oo`004_ooool4ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool3o`00
o`;oo`000oooool2o`00o`Cooooo1Ol00?l01?l007oo003oo`00ooooool2o`00o`;ooooo0ol00?l3
ooooo`?oo`0000?o003oooooooooool01ol0nYX8ooooo`04o`3jV_oo003oo`00o`00Oa;ooooo0ooo
00000ol007ooooooooooo`05ooooo`?oo`0000?o001oooooooooool00oooool00ol0003ooooooooo
o`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`04o`00Ooooooooooooooooo`?o003o2_oo
ool2o`00o`Sooooo1_l0nYX:ooooo`03o`3jV_oo003oo`0000[ooooo1_oo0003ooooo`;oo`0000?o
ooooo`00Ooooool01oooool2o`00o`Wooooo0ooo000@ooooo`Koo`0000?o001oooooooooool02?oo
ool00ol007ooooooooooo`08ooooo`;o003o0ooo0002ooooo`?o003o1?ooool4o`00o`03ooooool0
07oo003o00Co003o0oooool2o`00o`?ooooo0ooo000=o`3jVPGooooo00Co0?ZJool00?oo003o001o
5Oooool00ol007ooooooooooo`06ooooo`?oo`001Oooool00ol0003oooooooooo`0>ooooo`006ooo
ool00ol0003oooooooooo`03ooooo`04o`00Ooooooooooooooooo`;o003o2oooool2o`00o`[ooooo
1ol0nYX7ooooo`03o`3jV_oo003oo`0000gooooo1Ooo00001Oooooooo`00ool00?oooooo001o00So
oooo0ol00?l8ooooo`?oo`003oooool4ool00004oooooooo003oo`00o`00O`[ooooo00?o001ooooo
ooooool01oooool2o`00o`?oo`000oooool2o`00o`Gooooo0ol00?l00ol007ooooooo`00O`04o`00
o`Cooooo0_l00?l3ooooo`?oo`001?l0nYX5ooooo`Oo0?ZJ0_ooool01?l0nY[oo`00ool00?l007lE
ooooo`03o`00Oooooooooooo00Oooooo0_oo0005ooooo`03o`000?oooooooooo00kooooo000Koooo
o`;o00001?ooool01?l007ooooooooooooooool2o`00oa[ooooo1_l0nYX5ooooo`03o`3jV_oo003o
o`0000oooooo1_oo00000ooooooo001oooooo`08ooooo`;o003o2?ooool3ool000gooooo1?oo0003
ooooo`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`07ooooo`;o003o0_oo0000
1?l00?ooooooooooooooool2o`00o`Kooooo0_l00?l00ol007ooooooo`00O`04o`00o`Cooooo0ol0
0?l2ooooo`;oo`000_l0nYX;ooooo`Oo0?ZJ0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooo
oooooooo00Oooooo0_oo0004ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool00oooool0
1?l007ooooooooooooooool2o`00oagooooo1_l0nYX2ooooo`03o`3jV_oo003oo`00017ooooo1?oo
00000ooooooo001oooooo`08ooooo`;o003o2?ooool3ool000cooooo1?oo0004ooooo`;oo`0000?o
001oooooooooool02?ooool00ol007ooooooooooo`07ooooo`;o003o0_oo00001?l00?oooooooooo
ooooool2o`00o`Kooooo0_l00?l00ol007ooooooo`00O`04o`00o`Gooooo0_l00?l2ooooo`;oo`00
00?o0?ZJooooooooool03Oooool4o`3jVP;oo`0000?o001oooooooooool04oooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o
0000ooooooooool00oooool01?l007ooooooooooooooool2o`00oaoooooo1ol0nYX2ool001?ooooo
0_oo00000ooooooo001oooooo`08ooooo`;o003o2?ooool3ool000Wooooo1Ooo0006ooooo`;oo`00
00?o001oooooooooool02?ooool00ol007ooooooooooo`07ooooo`05o`00oooo003oo`00ool00?l0
0?l00oooool2o`00o`Kooooo0_l00?l01?l007ooooooo`00Ooooool3o`00o`Gooooo0_l00?l2oooo
o`;oo`0000?o0?ZJooooooooool03oooool2o`3jVP;oo`0000?o001oooooooooool04oooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_o
oooo00?o0000ooooooooool00oooool01?l007oo003oo`00ooooool2o`00ob;ooooo1?l0nYX2ool0
01Kooooo00?o001oooooooooool01oooool2o`00o`Sooooo0ooo0008ooooo`Goo`001oooool2ool0
0003o`00Oooooooooooo00Sooooo00?o001oooooooooool01oooool2o`000003ool00?l00?oo003o
00?ooooo0_l00?l6ooooo`06o`00ool0003o0000ooooool007oooooo0ol00?l5ooooo`;o003o0_oo
ool2ool00003o`3jV_oooooooooo017ooooo0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool0
0ol0003oooooooooo`03ooooo`03o`00Ool00?oo003o00?o003o9Oooool00ol0nY[oo`00ool0000F
ooooo`03o`00Oooooooooooo00Oooooo0_l00?l8ooooo`?oo`001oooool3ool000[ooooo0_oo0000
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo1?l00002o`00o`?ooooo0_l00?l6
ooooo`Co000000?o001oooooool00?l00_l00?l5ooooo`;o003o0_ooool2ool00003o`3jV_oooooo
oooo017ooooo0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001o
ooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03oooo
o`03o`00Ool00?oo003o00?o003o9_ooool2ool001Kooooo00?o001oooooooooool01oooool2o`00
o`Sooooo0ooo0006ooooo`?oo`002oooool2ool00003o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool01_ooool4o`0000?o003o0_ooool2o`00o`Kooooo1?l000000ol007ooooooo`00o`09o`3j
VP;o003o0_oo00000ol0nY[oooooooooo`0Aooooo`;oo`0000?o001oooooooooool04oooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_o
oooo00?o0000ooooooooool00_ooool2ool000;o003o00?oooooo`00ool00?l09_ooool2ool001Ko
oooo00?o001oooooooooool01oooool2o`00o`Sooooo0ooo0005ooooo`?oo`003?ooool2ool00003
o`00Oooooooooooo00Sooooo00?o001oooooooooool01oooool2o`0000;ooooo1_l00?l6ooooo`04
o`00ool0003o0000o`3jVP;o00003?l0nYX2ool00003o`3jV_oooooooooo017ooooo0_oo00000ol0
07ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0
003oooooooooo`0>ooooo`006oooool2o`0000?ooooo0_oo0002o`00obWooooo0_oo000Fooooo`03
o`00Oooooooooooo00Oooooo0_l00?l8ooooo`?oo`001?ooool3ool000gooooo0_oo00000ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00Oooooo0_oo0002ooooo`Ko003o1oooool2o`3jVPCo
000000?o0?ZJooooooooool01Oooool3o`3jVP;oo`0000?o0?ZJooooooooool04Oooool2ool00003
o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o
00004?ooool001_ooooo00?o0000ooooooooool00_ooool3ool00003o`00oooooooooooo02Oooooo
0_oo000Fooooo`03o`00Oooooooooooo00Oooooo0_l00?l8ooooo`?oo`000oooool3ool000kooooo
0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Oooooo0_oo0002ooooo`Go003o
2?ooool2o`3jVPCo00002?ooool2o`00o`04o`3jV_oo003oo`00o`3jVQ?ooooo0_oo00000ol007oo
ooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003o
ooooooooo`0>ooooo`006oooool00ol0003oooooooooo`02ooooo`03o`00oooo003oo`0002[ooooo
0_oo000Fooooo`03o`00Oooooooooooo00Oooooo0_l00?l8ooooo`?oo`000oooool2ool000oooooo
0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Oooooo0_oo0002ooooo`Go003o
2?ooool2o`3jVP03ooooool0003o000000[ooooo00Go003oo`3jV_oo003oo`00o`3jVP0Cooooo`;o
o`0000?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?o
oooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00_ooool01?l00?ooo`00
ool00?oo000Yooooo`;oo`005_ooool00ol007ooooooooooo`07ooooo`?o003o1oooool3ool000;o
oooo0ooo000?ooooo`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`07ooooo`;o
o`000_ooool5o`00o`Sooooo0_l0nYX00ooooooo001oooooo`0:ooooo`03o`00ool0nY[o0?ZJ00;o
0?ZJ4oooool2ool00003o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo
00?o003oool00?oo00000_oo000Vooooo`?oo`005_ooool00ol007ooooooooooo`08ooooo`;o003o
1oooool3ool00004oooooooo003oo`00ool0013ooooo0_oo00000ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00Kooooo00?o003oool00?oo00000_ooool5o`00o`Sooooo0_l0nYX00ooooooo
001oooooo`0:ooooo`03o`00ool0nY[o0?ZJ00;oo`004oooool2ool00003o`00Oooooooooooo01?o
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00ko
oooo000Dooooo`;o00001Oooool00ol0003oooooooooo`03ooooo`;o003o1Ooo000Tooooo`;oo`00
00?o001oooooooooool05?ooool00ol007ooooooooooo`08ooooo`;o003o1oooool6ool0017ooooo
0_oo00000ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o003oool00?oo0000
0_ooool4o`00o`Wooooo0_l0nYX00ooooooo001oooooo`0:ooooo`03o`00ool0nY[o0?ZJ00;oo`00
4oooool2ool00003o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`03ooooo`03o`000?oooooooooo00kooooo000Cooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool00oooool2o`00o`;ooooo1?oo000Sooooo`;oo`0000?o001oooooooooool0
5?ooool00ol007ooooooooooo`08ooooo`;o003o1oooool5ool001;ooooo0_oo00000ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o003oool00?oo00000_ooool4o`00o`Sooooo
0ol0nYX00ooooooo001oooooo`0;ooooo`;o0?ZJ0ooo000Booooo`;oo`0000?o001oooooooooool0
4oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool0
3_ooool001?ooooo00Co0000oooooooooooo00001?ooool3o`0000?ooooo00?o001oooooooooool0
0oooool3ool002;ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo
0_l00?l7ooooo`Goo`004_ooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool0
1_ooool00ol00?ooo`00ool00002ooooo`Co003o2?ooool2o`3jVP03o`00Oooooooo001o00cooooo
0_l0nYX3ool001;ooooo0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool00_ooool2o`00013ooooo000Cooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool00oooool00ol007ooooooooooo`04ooooo`Coo`008?ooool2ool00003o`00
Oooooooooooo01Cooooo00?o001oooooooooool02?ooool2o`00o`Oooooo1?oo000Cooooo`;oo`00
00?o001oooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00oooo003oo`0000?ooooo
0_l00?l9ooooo`;o0?ZJ00?o001oooooool007l03?ooool00ol00?oo0?ZJool00002ool001;ooooo
0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`004oooool01?l0003oooooooooool00004ooooo`03o`00
0?oooooooooo00?ooooo00?o001oooooooooool01Oooool6ool001gooooo0_oo00000ol007oooooo
ooooo`0Dooooo`03o`00Oooooooooooo00Sooooo0_l00?l7ooooo`Coo`004oooool2ool00003o`00
Oooooooooooo00Sooooo00?o001oooooooooool01_ooool00ol00?ooo`00ool00003ooooo`;o003o
2Oooool2o`3jVP03o`00Oooooooo001o00cooooo00?o003oo`3jV_oo00000ooo000Aooooo`;oo`00
00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo
00?o0000ooooooooool03_ooool001?ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooo
ooooo`03ooooo`03o`00Oooooooooooo00Oooooo1Ooo000Looooo`;oo`0000?o001oooooooooool0
5?ooool00ol007ooooooooooo`08ooooo`;o003o1oooool3ool001Cooooo0_oo00000ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00Kooooo0ooo0003ooooo`;o003o2Oooool2o`3jVP03o`00
Oooooooo001o00cooooo00?o003oo`3jV_oo00001?oo000@ooooo`;oo`0000?o001oooooooooool0
4oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool0
3_ooool001Cooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool02_oo
ool4ool001[ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo0_l0
0?l7ooooo`?oo`005?ooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool01_oo
ool2ool000;o0?ZJ0_ooool2o`00o`Kooooo1Ol0nYX00ol007ooooooo`00O`0<ooooo`05o`00ool0
nY[oo`00ool00?ooool00ooo000>ooooo`?oo`0000?o001oooooooooool04oooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o
0000ooooooooool00oooool00ol007ooooooooooo`0;ooooo`Goo`006?ooool2ool00003o`00Oooo
oooooooo01Cooooo00?o001oooooooooool02?ooool2o`00o`Oooooo0ooo000Dooooo`;oo`0000?o
001oooooooooool02?ooool00ol007ooooooooooo`06ooooo`;oo`004Ol0nYX00ol007ooo`00ool0
000<ooooo`04o`00ool0nY[oo`00ool000;ooooo0_oo000>ooooo`;oo`0000?oooooo`00Ooooool0
5?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool0
3_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0=ooooo`Coo`005ooo
ool2ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02?ooool2o`00o`Sooooo0_oo
000Dooooo`;oo`0000?o001oooooooooool02?ooool00ol007ooooooooooo`06ooooo`;oo`003Ol0
nYX3ooooo`Coo`003Oooool00ol0nY[oo`00ool00002ooooo`?oo`003Oooool2ool00003ooooool0
07oooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool03oooool5
ool001Cooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Sooooo0ol00?l7
ooooo`;oo`005?ooool2ool00003o`00Oooooooooooo00Sooooo00?o001oooooooooool01_ooool2
ool00004o`3jV_ooooooooooooooo`;o003o2_ooool5ool000cooooo00?o0?ZJool00?oo00000ooo
ool3ool000cooooo0_oo00000ooooooo001oooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o
001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool2o`0000Cooooo00?o001o
ooooooooool04?ooool6ool001;ooooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo00Wooooo0_l00?l7ooooo`;oo`005?ooool2ool00003o`00Oooooooooooo00Sooooo00?o001o
ooooooooool01?ooool2o`00o`;oo`0000?o0?ZJooooooooool03Oooool6ool000_ooooo00?o0?ZJ
ool00?oo00001?ooool3ool000_ooooo0_oo00000ooooooo001oooooo`0Dooooo`03o`00Oooooooo
oooo00Sooooo00?o001oooooooooool00_ooool2o`00013ooooo000Kooooo`03o`000?oooooooooo
00?ooooo00?o001oooooooooool04oooool4ool0017ooooo0_oo00000ol007ooooooooooo`0Doooo
o`03o`00Oooooooooooo00Wooooo0_l00?l7ooooo`;oo`005?ooool2ool00003o`00Oooooooooooo
00Sooooo00?o001oooooooooool01?ooool2o`00o`;oo`0000?o0?ZJooooooooool03Oooool3ool0
0003o`00Oooo003oo`0000cooooo0_oo0005ooooo`?oo`002_ooool2ool00003ooooool007oooooo
01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo
00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool05Oooool4ool000oo
oooo0_oo00000ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00Wooooo0_l00?l7ooooo`;o
o`005?ooool3ool000[ooooo00?o001oooooooooool01?ooool2o`00o`;oo`0000?o0?ZJoooooooo
ool03Oooool3ool00004o`00Oooo003oo`00ool000[ooooo0_l000000ooo003oooooooooo`04oooo
o`?oo`002Oooool2ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o001oooooooooool05_ooool4ool000kooooo0_oo00000ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00Wooooo0_l00?l7ooooo`;oo`005Oooool2ool000[ooooo00?o001ooooooooo
ool01?ooool2o`00o`;oo`0000?o0?ZJooooooooool03Oooool2ool00003ooooool007oooooo00;o
o`002Oooool4o`0000Oooooo0ooo0008ooooo`;oo`0000?oooooo`00Ooooool05?ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo
00?o0000ooooooooool00oooool00ol007ooooooooooo`0Hooooo`Goo`002oooool2ool00003o`00
Oooooooooooo01Cooooo00?o001oooooooooool02Oooool2o`00o`Oooooo0_oo000Eooooo`;oo`00
2_ooool00ol007ooooooooooo`04ooooo`;o003o0_oo00000ol0nY[oooooooooo`0=ooooo`;oo`00
00?oooooo`00Ooooool00_oo0009ooooo`Co00002?ooool5ool000Gooooo0_oo00000ooooooo001o
ooooo`0Dooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003ooooo
ooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo01Wooooo1_oo
0009ooooo`;oo`0000?o001oooooooooool05?ooool00ol007ooooooooooo`09ooooo`;o003o1ooo
ool2ool001;ooooo0ol0nYX2ool000[ooooo00?o001oooooooooool01?ooool4ool00003o`3jV_oo
oooooooo00gooooo0_oo00000ooooooo001oooooo`03ool000Wooooo0_l000000ol007oooooooooo
o`07ooooo`Goo`001?ooool2ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooo
oooo00?ooooo00?o001oooooooooool07?ooool4ool000Sooooo0_oo00000ol007ooooooooooo`0D
ooooo`03o`00Oooooooooooo00Wooooo0_l00?l7ooooo`;oo`003oooool6o`3jVP;oo`002_ooool0
1?l007ooooooooooooooool6ool000;o0?ZJ3oooool2ool00004ooooool007ooooooooooo`;oo`00
2Oooool2ool00003o`00Oooooooooooo00[ooooo1?oo0002ooooo`;oo`0000?oooooo`00Ooooool0
5?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool0
3_ooool001_ooooo0_l00004ooooo`03o`00Oooooooooooo01kooooo1?oo0006ooooo`;oo`0000?o
001oooooooooool05?ooool00ol007ooooooooooo`09ooooo`?o003o1_ooool2ool00003o`3jV_oo
oooooooo00[ooooo1_l0nYX01?oooooo0?ZJool00?oo000:ooooo`03o`00Oooooooooooo00Goo`00
00Co003oooooool0nY[o0?ZJ3oooool2ool00004ooooool007ooooooooooo`?oo`002?ooool2ool0
0003o`00Oooooooooooo00_ooooo1?oo00001Oooooooo`00ool00?oooooo001o01Gooooo00?o001o
ooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000oooo
ooooool00oooool00ol007ooooooooooo`0Oooooo`Goo`001?ooool2ool00003o`00Oooooooooooo
01Cooooo00?o001oooooooooool02_ooool2o`00o`Kooooo0_oo0003o`3jVPKooooo1ol0nYX4oooo
o`03o`3jV_oo003oo`0000[ooooo00?o001ooooooooo00000_oo00000ooooooo003oo`00o`02oooo
o`;oo`003oooool2ool00003ooooool007oooooo00;ooooo0_oo0008ooooo`;oo`0000?o001ooooo
ooooool03Oooool5ool00003ooooool007oooooo01Cooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?o
oooo00?o001oooooooooool08Oooool6ool00004oooooooo003oo`00o`00OaKooooo00?o001ooooo
ooooool02_ooool3o`00o`Gooooo0_oo000>o`3jVPKooooo00?o0?ZJool00?oo00002_ooool01?l0
07ooo`00ool00?oo0002ooooo`;o003o0_ooool2ool000oooooo0_oo00000ooooooo001oooooo`02
ooooo`?oo`001oooool2ool00003o`00Oooooooooooo00kooooo1?oo00000ooooooo001oooooo`0D
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>
ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo02?ooooo1ooo00000ol0
07ooooooooooo`0Dooooo`03o`00Oooooooooooo00[ooooo0ol00?l5ooooo`;oo`000_ooool8o`3j
VP[ooooo00?o0?ZJool00?oo00002_ooool3ool000?ooooo0_l00?l2ooooo`;oo`003oooool2ool0
0003ooooool007oooooo00?ooooo0ooo0006ooooo`;oo`0000?o001oooooooooool04?ooool2ool0
0003ooooool007oooooo01Cooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03oooo
o`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001ooooooooo
ool09_ooool4ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool02oooool2o`00o`Go
oooo0_oo000Dooooo`03o`3jV_oo003oo`0000[ooooo0_oo0004ooooo`;o003o00?oooooo`3jV_oo
00000_oo000>ooooo`;oo`0000?oooooo`00Ooooool01?ooool3ool000Gooooo0_oo00000ol007oo
ooooooooo`0Cooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oo
ooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo
00?o001oooooooooool09oooool3ool00003o`00Oooooooooooo01Cooooo00?o001oooooooooool0
2oooool2o`00o`Gooooo0_oo000Dooooo`03o`3jV_oo003oo`0000Wooooo0ooo0004ooooo`;o003o
00?oooooo`3jV_oo00000_oo000>ooooo`;oo`0000?oooooo`00Ooooool01Oooool4ool000?ooooo
0_oo00000ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool0
2?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oo
oooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooo
oooooooo00_ooooo0ol00?l4ooooo`;oo`005?ooool00ol0nY[oo`00ool00009ooooo`;oo`001Ooo
ool2o`00o`03ooooool0nY[oo`0000;oo`003_ooool2ool00003ooooool007oooooo00Kooooo1?oo
0002ooooo`;oo`0000?o001oooooooooool04oooool00ol007ooooooooooo`0Cooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool2
o`0000Cooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo00cooooo0_l00?l4ooooo`;oo`005?ooool00ol0nY[oo`00ool00009ooooo`;o00001Oooool2
o`00o`03ooooool0nY[oo`0000;oo`003Oooool3ool00003ooooool007oooooo00Sooooo1_oo0000
0ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool00oooool00ol0
07ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03?ooool2o`00
o`Cooooo0_oo000Dooooo`03o`3jV_oo003oo`0000Sooooo1?l00004ooooo`;o003o00?oooooo`3j
V_oo00000ooo000<ooooo`;oo`0000?o001oooooool007l02_ooool5ool00003o`00Oooooooooooo
01?ooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oo
ooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03?ooool2o`00o`Co
oooo0_oo000@ooooo`;o003o0_ooool00ol0nY[oo`00ool00008ooooo`Co00001?ooool2o`00o`03
ooooool0nY[oo`0000?oo`003?ooool2ool00003o`00Oooooooo001o00cooooo0_oo0002o`00OaGo
oooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?o
oooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oooooo
ooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03?ooool2o`00o`Cooooo
0_oo000@ooooo`;o003o0_ooool01?l0nY[oo`00ool00?l00?l6ooooo`;oo`000_l00004ooooo`?o
003o00?oooooo`3jV_oo00000ooo000<ooooo`;oo`0000?o001oooooool007l03_ooool2o`00OaGo
oooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?o
oooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oooooo
ooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03?ooool2o`00o`Cooooo
0_oo000@ooooo`;o003o0_ooool01?l0nY[oo`00ool00?l00?l4ooooo`Coo`0000?oooooo`00Oooo
ool00oooool2o`00o`;ooooo00?o0?ZJool00?oo00000ooo000;ooooo`;oo`0000?o001oooooool0
07l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03
o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001;ooooo1Ol00004ooooo`03o`00
0?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00
Oooooooooooo00cooooo0_l00?l4ooooo`;oo`004?ooool2o`00o`;ooooo00Co0?ZJool00?oo003o
003o0oooool4ool000;ooooo00?o001oooooooooool00_ooool2o`00o`;ooooo00Co0?ZJool00?oo
003ooooo0ooo000:ooooo`;oo`0000?o001oooooool007l03_ooool2o`00OaGooooo00?o001ooooo
ooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000oooo
ooooool03_ooool001?ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`03oooo
o`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0<oooo
o`?o003o0oooool2ool0013ooooo0_l00?l2ooooo`04o`3jV_oo003oo`00o`00o`;ooooo0ooo0004
ooooo`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`3jV_oo003oo`0000;ooooo0_oo000:
ooooo`;oo`0000?o001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool0
0ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool0
01Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`00Oooooooooooo
02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0=ooooo`;o003o0oooool3ool0
00oooooo0_l00?l2ooooo`05o`3jV_oo003oo`00o`00ooooool00ooo0005ooooo`;o003o0oooool2
o`00o`;ooooo00?o0?ZJool00?oo00000_ooool3ool000Wooooo0_oo00000ol007ooooooo`00O`0>
ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001o
ooooooooool00oooool00ol0003oooooooooo`0>ooooo`005Oooool00ol0003oooooooooo`03oooo
o`?o00000oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001ooooo
ooooool03Oooool2o`00o`Cooooo0_oo000?ooooo`;o003o0_ooool01?l0nY[oo`00ool00?l00?l3
ool000;ooooo0ol00?l00ooooooo003oo`00o`03ooooo`;o003o0_ooool00ol0nY[oo`00ool00003
ooooo`;oo`002Oooool2ool00003o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooo
oooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool0
01;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00?ooooo00?o001o
ooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00gooooo0_l00?l4
ooooo`;oo`003oooool2o`00o`;ooooo00Co0?ZJool00?oo003o003o0_oo0003ooooo`?o003o0_l0
nYX00ol00?ooooooooooo`03o`00o`;ooooo00?o0?ZJool00?oo00000oooool2ool000Wooooo0_oo
00000ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`004_ooool0
1Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00oooool00ol007oooooooooo
o`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03Oooool2o`00o`Cooooo0_oo
000>ooooo`?o003o0_ooool00ol0nY[oo`00ool00003ool000?ooooo0ol00?l3o`3jVP;ooooo0_l0
0?l3ooooo`03o`3jV_oo003oo`0000?ooooo0ooo0008ooooo`;oo`0000?o001oooooool007l03_oo
ool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00?ooooo00?o0000ooooooooool03_ooool001?ooooo0ol00005ooooo`03o`000?oooooo
oooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooo
oooo00gooooo0_l00?l4ooooo`?oo`003Oooool4o`00o`;ooooo1?oo0004ooooo`?o003o2ol0nYX2
ool000Cooooo0ooo0007ooooo`;oo`0000?o001oooooool007l03_ooool2o`00OaGooooo00?o001o
ooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000
ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Zoooo
o`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03Oooool2o`00o`Cooooo00?o001oool0
0?oo00003Oooool4o`00o`;ooooo0ooo00001?l00?ooooooooooooooool4o`00o`_o0?ZJ0_oo0005
ooooo`?oo`001_ooool2ool00003o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooo
oooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooo
oooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol0
07ooooooooooo`0Dooooo`03o`00Oooooooooooo00gooooo0_l00?l4ooooo`03o`00Oooo003oo`00
00gooooo1?l00?l2ooooo`?oo`0000Co003ooooooooooooooooo1?l00?l2o`3jVP03o`00oooooooo
003o00;o003o0oooool3ool000Kooooo1Ooo0003ooooo`;oo`0000?o001oooooool007l03_ooool2
o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooo
oooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol0
07ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03Oooool3o`00
o`?ooooo00Co001oool00?oo003oo`003?ooool4o`00o`;ooooo0_oo0002o`00o`?ooooo0ol00?l3
o`3jVP04o`00oooooooo003oo`00o`Cooooo0_oo00000ol007ooooooooooo`05ooooo`Woo`0000?o
001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo0_l00004
ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0>
ooooo`;o003o0oooool01?l007ooooooool00?oo000<ooooo`Co003o0_ooool2ool000;o003o0ooo
ool3o`00o`;o0?ZJ0_l00?l00ooooooo003oo`00o`04ooooo`;oo`0000?o001oooooooooool02?oo
ool6ool00003o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o
001oooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000
ooooooooool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001o
ooooooooool03_ooool2o`00o`?ooooo00?o001ooooooooo00000_oo000;ooooo`Co003o0_ooool2
o`3jVP;o003o0oooool2o`00o`03ooooool0nY[o0?ZJ00;o003o00?oooooo`00ool00?l01?ooool2
ool00003o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001o
ooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000
ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Zoooo
o`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03_ooool2o`00o`?ooooo00?o001ooooo
ooooool00_oo000;ooooo`Co003o0_ooool2o`3jVP;o003o0oooool2o`00o`03ooooool0nY[o0?ZJ
00Go003o1?ooool2ool00003o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00
OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oo
ooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03_ooool2o`00o`?o
oooo00?o001oooooooooool00ooo0004ooooo`;o003o1?ooool4o`00o`;ooooo0_l0nYX2o`00o`?o
oooo0_l00?l00ooooooo0?ZJo`3jVP05o`00o`Cooooo0_oo00000ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`00
0?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00
Oooooooooooo00kooooo0_l00?l3ooooo`04o`00Ooooooooooooooooo`;oo`001?ooool2o`00o`Co
oooo1?l00?l2ooooo`;o0?ZJ0_l00?l2ooooo`?o003o0ol0nYX5o`00o`Cooooo0_oo00000ol007oo
ooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?o
oooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00ko
oooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007oooooo
ooooo`0Dooooo`03o`00Oooooooooooo00kooooo0_l00?l3ooooo`04o`00Ooooooooooooooooo`?o
o`000oooool2o`00o`Cooooo1?l00?l01?oooooo003oo`3jV_l0nYX2o`00o`;ooooo1Ol0nYX2ool0
00Co003o1?ooool2ool00003o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00
OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oo
ooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03_ooool2o`00o`?o
oooo00?o001oooooooooool00_ooool3ool00004ooooool00?oo003oo`00o`Cooooo0_l00?l5ool0
0004o`3jV_l00?oo003oooooo`Go0?ZJ00?o003oool00?oo00001?l00?l4ooooo`;oo`0000?o001o
ooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0C
ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>
ooooo`006oooool2o`0000Cooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Doooo
o`03o`00Oooooooooooo00kooooo0_l00?l2ooooo`;o00001Oooool4ool000;o003o00?oooooool0
0?oo00002?oo00000ol0nY[o003oo`00o`03o`3jVP04o`00ooooooooooooooooo`;oo`001?l00?l4
ooooo`;oo`0000?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool0
0ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00_ooool2
o`00013ooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol0
07ooooooooooo`0Dooooo`03o`00Oooooooooooo00kooooo0_l00?l00ooooooo0000o`000002o`00
00Gooooo3?oo00001_l00?ooooooool00?oo003o0?ZJo`00o`?o0?ZJ0_l00?l3ooooo`?oo`000ol0
0?l4ooooo`;oo`0000?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Ooo
ool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00ooo
ool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooo
oooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0>ooooo`;o003o00?ooooo
o`000?l000000_l00007ooooo`Goo`000_ooool4o`00o`03oooooooo003oo`0000Co0?ZJ00?ooooo
o`00ool00?l00oooool3ool000;o003o1Oooool2ool00003o`00Oooooooooooo00kooooo00?o001o
ooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000oooo
ooooool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001ooooo
ooooool03_ooool3o`00o`03ooooool0003o000000Sooooo1?l00?l2ooooo`Go003o00?oooooool0
0?oo00000ol0nYX4o`00o`?ooooo0ooo0002o`00o`Gooooo0_oo00000ol007ooooooooooo`0>oooo
o`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooo
ooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03
o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00oooooo0_l00?l2ooooo`03o`00Oooooooooooo00Kooooo1?l00?l2ooooo`;o
003o00Coooooo`00ool00?oooooo0_oo0002o`3jVPCo003o1?ooool4ool00003o`00oooooooooooo
00?ooooo0_oo00000ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEoooo
o`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03oooo
o`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001ooooooooo
ool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00oooooo0_l00?l2ooooo`03
o`00Oooooooooooo00Kooooo1?l00?l2ooooo`;o003o00Coooooo`00ool00?oo003o0_oo0002o`3j
VPCo003o1?ooool4ool00003o`00oooooooooooo00?ooooo0_oo00000ol007ooooooooooo`0>oooo
o`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooo
ooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03
o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03
o`00Oooooooooooo00oooooo0_l00?l2ooooo`04o`00Ooooooooooooooooo`;o003o0oooool4o`00
o`;ooooo0_l00?l2ooooo`;o003o0_oo00000ol0nY[oooooo`00o`03o`00o`?ooooo1Ooo00000ol0
0?ooooooooooo`03ooooo`;oo`0000?o001oooooooooool03_ooool00ol007ooooooo`00O`0>oooo
o`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03
o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0?ooooo`;o
003o0_ooool01?l007ooooooooooooooool3o`00o`;ooooo1?l00?l2ooooo`;o003o0_ooool2o`00
o`;oo`0000?o001oooooool00?l00ol00?l3ooooo`;oo`0000Co001oool00?oo003oo`001Oooool2
ool00003o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001o
ooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000
ooooooooool03_ooool001_ooooo0_l00004ooooo`03o`00Oooooooooooo02[ooooo00?o001ooooo
ooooool05?ooool00ol007ooooooooooo`0?ooooo`;o003o0_ooool01?l007ooooooooooooooool3
o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`02ooooo`;o003o0_oo00000ol007ooooooo`00o`03
o`00o`?ooooo0_oo00000ol007ooooooool00003ool000?ooooo0_oo00000ol007ooooooooooo`0>
ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001o
ooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000oooo
ooooool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001ooooo
ooooool03oooool2o`00o`;ooooo00Co001ooooooooooooooooo0ol00?l01Ooooooo003oo`00ool0
0?oooooo00;o003o00?oooooo`00ool00?l00_ooool2o`00o`?oo`000_ooool3o`00o`?ooooo0_oo
00000ol007ooooooo`00o`08ool00003o`00Oooooooooooo00kooooo00?o001oooooool007l03_oo
ool2o`00OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00?ooooo00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool0
0ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03oooool2
o`00o`;ooooo00Co001ooooooooooooooooo0ol00?l00ooooooo003oo`00o`02ooooo`;o003o00?o
ooooo`00ool00?l00_ooool3o`00o`;oo`000_ooool3o`00o`?ooooo0_oo00001Ol007ooooooo`00
ool00?oooooo00Koo`0000?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o
5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooo
oooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0?ooooo`;o003o0_oo
ool00ol007ooooooooooo`04o`00o`03ooooool00?oo003o00;ooooo0_l00?l00ooooooo003oo`00
o`02ooooo`;o003o00?oooooool00?oo00000_ooool2o`00o`Cooooo0_oo00000ol007oooooooooo
o`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o
001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o
0000ooooooooool03_ooool001Cooooo0ol00004ooooo`03o`000?oooooooooo00?ooooo00?o001o
ooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00oooooo0_l00?l2
ooooo`03o`00Oooooooooooo00Co003o00?oooooo`00ool00?l00_ooool2o`00o`03ooooool00?oo
003o00;ooooo0_l00?l00ooooooo0000o`000002ooooo`;o003o1?ooool2ool00003o`00Oooooooo
oooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool0
0ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`005Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo
00oooooo0_l00?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l00_ooool2o`00
o`03ooooool00?oo003o00;ooooo0_l00?l4o`000004ooooool00?oo003oooooo`Goo`0000?o001o
ooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lE
ooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03
ooooo`03o`000?oooooooooo00kooooo000Booooo`Go00001?ooool00ol0003oooooooooo`03oooo
o`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0?oooo
o`;o003o00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo003o00;ooooo0_l00?l00ooo
oooo003oo`00o`04ooooo`Co00000_ooool7ool00003o`00Oooooooooooo00Sooooo00?o001ooooo
ooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Coooo
o`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>oooo
o`004_ooool01?l0003oooooooooool00005ooooo`?o00000oooool00ol007ooooooooooo`0Zoooo
o`03o`00Oooooooooooo01Cooooo00?o001oooooooooool03oooool2o`00o`03ooooool00?oo003o
00;ooooo1ol00?l2ooooo`Go003o1Oooool2o`000003oooooooo003oo`0000?oo`001?ooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00
OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00;ooooo0_l0000@ooooo`004oooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo00?o
oooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo00oo
oooo1_l00?l01?oooooo003oo`00ooooool4o`00o`;ooooo1?l00?l6ooooo`Koo`001_ooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00
OaGooooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00?ooooo00?o0000ooooooooool03_ooool001Cooooo0_l00005ooooo`03o`000?oooooooooo00?o
oooo00?o001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo013o
oooo2?l00?l00ooooooo003oo`00o`02o`00o`?ooooo0ol00?l6ooooo`Coo`002?ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGo
oooo00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?o
oooo00?o0000ooooooooool03_ooool001Gooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`00Oooooooooooo02[ooooo00?o001oooooooooool05?ooool00ol007oooooo
ooooo`0@ooooo`Oo003o0_ooool4o`00o`?ooooo0ol00?l6ooooo`?oo`002Oooool00ol007oooooo
ooooo`08ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo
00?o001oooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo
00?o0000ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007oooooooooo
o`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool04?ooool3o`00o`03o`00Ool0
0?oo003o00?ooooo1?l00?l3ooooo`?o003o1_ooool2ool000[ooooo00?o001oooooooooool02?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooo
oooooooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oo
oooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool0
0ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo013ooooo0ol00?l00ol007ooooooooooo`03
ooooo`Co003o0oooool2o`00o`Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001o
ooooooooool04oooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000
ooooooooool03_ooool001_ooooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Zoooo
o`03o`00Oooooooooooo01Cooooo00?o001oooooooooool04?ooool3o`00o`03o`00Oooooooooooo
00?ooooo1?l00?l=ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo
01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooooooo
00kooooo000Kooooo`;o00001?ooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Co
oooo00?o001oooooooooool04?ooool3o`00o`03o`00Oooooooooooo00?ooooo1?l00?l=ooooo`03
o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001ooooooooo
ool02?ooool00ol007ooooooooooo`02ooooo`;o00004?ooool001_ooooo00?o0000ooooooooool0
0oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Cooooo00?o001oooooooooool0
4?ooool2o`00o`03ooooool007oooooo00Cooooo0ol00?l>ooooo`03o`00Oooooooooooo00Sooooo
00?o001oooooooooool02?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo
0_l007lEooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool02?ooool00ol007oooooo
ooooo`03ooooo`03o`000?oooooooooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o
001oooooooooool0:_ooool00ol007ooooooooooo`0Dooooo`03o`00Oooooooooooo013ooooo0_l0
0?l00ooooooo001oooooo`04ooooo`?o003o3_ooool00ol007ooooooooooo`08ooooo`03o`00Oooo
oooooooo00Sooooo00?o001oooooooooool03_ooool00ol007ooooooo`00O`0>ooooo`;o001o5Ooo
ool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool00ooo
ool00ol0003oooooooooo`0>ooooo`006oooool00ol0003oooooooooo`03ooooo`03o`00Oooooooo
oooo02[ooooo00?o001oooooooooool05?ooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooo
oooo00?ooooo0ol00?l>ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool02?ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooo001o00kooooo0_l007lEooooo`03o`00Oooooooo
oooo01?ooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`000?oooooo
oooo00kooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o001oooooooooool0:_ooool00ol0
07ooooooooooo`0Dooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool01?ooool2o`00
o`kooooo00?o001oooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooool007l03_ooool2o`00OaGooooo00?o001oooooooooool04oooool00ol0
07ooooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo00?o0000ooooooooool03_ooool001_o
oooo00?o0000ooooooooool00oooool00ol007ooooooooooo`0Zooooo`03o`00Oooooooooooo01Co
oooo00?o001oooooooooool04oooool00ol007ooooooooooo`04ooooo`;o003o3_ooool00ol007oo
ooooooooo`08ooooo`03o`00Oooooooooooo00Sooooo00?o001oooooooooool03_ooool00ol007oo
ooooo`00O`0>ooooo`;o001o5Oooool00ol007ooooooooooo`0Cooooo`03o`00Oooooooooooo00So
oooo00?o001oooooooooool00oooool00ol0003oooooooooo`0>ooooo`006oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo02[ooooo00?o001oooooooooool02?ooool00ol0003ooooo
ooooo`09ooooo`03o`00Oooooooooooo01?ooooo00?o001oooooooooool01?ooool2o`00o`kooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`08ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooool007l03_ooool00ol0003o001oooooo`0Dooooo`03o`00Oooooooooooo01?ooooo
00?o001oooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00kooooo
000Kooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`00Oooooooo001o00?ooooo00?o0000ooooooooool02?ooool00ol0003o001ooooo
o`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0>ooooo`006oooooo^o`00013ooooo003ooooooa[ooooo003ooooooa[ooooo003ooooooa[ooooo
001<ooooo`03o`000?oooooooooo01?ooooo0ol00003ooooo`?o00009oooool3o`0008Cooooo001=
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0W
ooooo`03o`000?oooooooooo08?ooooo000jooooo`;o00000_ooool3o`000003ooooool0003o0000
00?o00001_ooool00ol0003oooooooooo`06ooooo`;o000000?oooooo`000?l000000_ooool4o`00
00;ooooo0ol00003ooooo`?o00000oooool4o`0000Sooooo1?l00007ooooo`Go00002?ooool3o`00
00?ooooo1?l000001Ooooooo0000o`000?l0003ooooo00;o000000Coooooo`000?l0003o00000_oo
ool5o`0000Wooooo0_l000000ooooooo0000o`000002o`000003ooooool0003o000000Go00000ooo
ool2o`0000Wooooo1?l00008ooooo`?o00001?ooool2o`0002oooooo000iooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooo000000;ooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00002oooo
o`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`0Cooooo`04o`000?oo
ooooooooo`0000Sooooo00Ko0000oooooooooooo0000ooooool00002ooooo`05o`000?oooooooooo
ooooool000000_ooool00ol0003oooooo`000007ooooo`03o`000?oooooooooo00Sooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00005Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
02kooooo000iooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooool000000oooool00ol0
003oooooooooo`0?ooooo`;o00001?ooool3o`0000?ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00002ooooo`?o00002Oooool4o`0000Wooooo00?o0000ooooooooool02?oo
ool01?l0003oooooooooool00002ooooo`?o00000oooool01Ol0003oooooooooool0003ooooo00Go
00000oooool00ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo1?l00009
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000;_ooool003Wooooo00Co0000
oooooooooooo00000_ooool2o`0000Cooooo0ol0000?ooooo`03o`000?oooooo000000;ooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`00
0?oooooo00000_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00Oooooo00Ko0000
oooooooooooo0000ooooool00002ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003o
ooooo`000003ooooo`05o`000?ooooooooooooooool000002_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000;_ooool003Wooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00oooooo
00Co0000ooooool0003o00000_ooool2o`0000?ooooo1?l00002ooooo`Co00000oooool2o`0001Go
oooo00Go0000ooooooooooooooooo`000007ooooo`Co00000oooool2o`0000?ooooo1?l00003oooo
o`?o00001?ooool00ol0003oooooooooo`07ooooo`;o000000Coooooo`000?l0003ooooo1?l00002
ooooo`?o00000oooool4o`0001Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
000^ooooo`00>Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00003_ooool00ol0003oooooooooo`0/ooooo`05o`000?oooooooooooooo
ool000008Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Gooooo0_l00004oooo
o`04o`000?ooooooooooo`0002kooooo000hooooo`?o000000?oooooo`000?l000000ol000000ooo
oooo0000o`000005o`0000gooooo0_l0000_ooooo`?o00008?ooool3o`0001Oooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00?ooooo0_l0000_oooo
o`00oooooolJooooo`00oooooolJooooo`00\
\>"],
  ImageRangeCache->{{{0, 280.812}, {173.188, 0}} -> {-29.7276, -5.81761, \
0.887312, 0.0683666}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\

SCALING={1,0.1,1,1};
THETA0=Theta/SCALING;
F0=IdentityMatrix[THETA0//Length];
misc={miss,1};
MAXSTEP=.1;
FISHER=False;

SetDirectory[\"/Mathematica \
2.2.2/Hermann.Notebooks/UKF.20.3.2006/Panel/Simulation\"];
filename=\"UKF2.n10\";
system={f,g,h,R,mue,sigma,dt,kappa=2};
LikN=UKF;
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
EST={};
Do[

SeedRandom[99999*m];
Print[\"**********************************************************************\
***\"];
Print[\"Replikation m = \",m];
Print[\"**********************************************************************\
***\"];

n=10;
T = 200;
dt = .1;
k = 1; p = 1; q = 1;
X = Shape[0,{n,T+1,q}];
Theta = {-1., 0.1, 2.,1}//N;
Y0 = RandomGauss[_,Theta,{mue,sigma},n];
Prozess = UniC;
{zt,yt} = \
MapThread[NonLinStateSpace[h,{R,konstant},f,g,#1,#2,T,dt,Theta,Prozess,\
EulerStep]&,{Y0,X}]//Transpose;
miss = -9;
time = {0,4,6,8,10,11,12,13.5,13.7,15,15.1,17,19,20};
sel = time/dt + 1;
ZM = Shape[miss,{n,T+1,k}];
Map[(ZM[[All,#]] = zt[[All,#]])&,sel];
data={ZM,X}//Transpose;

{THETA,COV,LIKI,psii,scoreii,k,ReturnCode}=

BFGS[data,
\t {THETA0,F0},
\t {system,{Lik,LikN,Score,Hesse}},
\t {misc,KMAX=50,{EPS1=10.^-4,EPS2=10.^-4},OPTION=0,PRINT={1,1,1,1,1,1,1,1}}];\

\t 
est = {m,THETA,k,ReturnCode}//Flatten;
EST = Append[EST,est];
PutAppend[est,filename];


,{m,36,100}] 
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Replikation m = "\[InvisibleSpace]36\),
      SequenceForm[ "Replikation m = ", 36],
      Editable->False]], "Print"],

Cell[BoxData[
    \("***********************************************************************\
**"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print"],

Cell[BoxData[
    \({201, 201, 201, 201, 201, 201, 201, 201, 201, 201}\)], "Print"],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    \(UKF\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "50", "0.0001`", "0.0001`", "1", "1", "10", "200", "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "0.1`", "1.`*^-10", "1.`*^-6", "4", "1000000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1000.`", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("    SCALING"\)], "Print"],

Cell[BoxData[
    TagBox[\({{1, 0.1`, 1, 1}}\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{\(-1.`\), 1.`, 
          2.`, 1.`}\),
      SequenceForm[ "STARTWERT THETA0 = ", {-1.0, 1.0, 2.0, 1.0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Auswertung", "Subsubsection"],

Cell[CellGroupData[{

Cell["filename", "Input"],

Cell[BoxData[
    \("UKF2.n10"\)], "Output"]
}, Open  ]],

Cell["cum=ReadList[filename];", "Input"],

Cell[CellGroupData[{

Cell["cum//MatrixForm", "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7"},
              {"1", "1", \(-0.6970936764248702`\), "0.6059010840199359`", 
                "2.4576989588971165`", "1.0149347978147376`", "14", "3"},
              {"2", "2", \(-1.2748475690808976`\), "0.9843856557564891`", 
                "2.5622225195428716`", "0.9860889663145452`", "11", "3"},
              {"3", "3", \(-0.682154320677017`\), "0.5278488995662439`", 
                "2.4972525824422545`", "0.5358147745586443`", "12", "3"},
              {"4", "4", \(-3.026863218293682`\), "2.433192847002924`", 
                "2.9503057858856083`", "0.5578976329334921`", "26", "3"},
              {"5", "5", \(-1.8667557026522401`\), "1.8058417479708946`", 
                "2.3977710948663478`", "1.0193194945136632`", "14", "3"},
              {"6", "6", \(-0.5817054701658786`\), "0.4669711988113802`", 
                "2.3740946440229544`", "0.9996275479190165`", "14", "3"},
              {"7", "7", \(-1.4403677790325486`\), "0.9083944098236583`", 
                "2.9058713712691557`", "0.6411307005905269`", "16", "3"},
              {"8", "8", \(-0.8369045764674294`\), "0.649044586416499`", 
                "2.035834563651113`", "0.9161863418184386`", "12", "3"},
              {"9", "9", \(-0.663255612694941`\), "0.6286156019651311`", 
                "1.7597828726430396`", "1.4057058182234907`", "12", "3"},
              {"10", "10", \(-1.9741709510291652`\), "1.5063783304105534`", 
                "2.829571419958687`", "0.892624338296396`", "18", "3"},
              {"11", "11", \(-2.868307486552082`\), "2.7316574413293804`", 
                "2.57114673405297`", "1.094240019137399`", "18", "3"},
              {"12", "12", \(-0.16614655030550263`\), "0.1640249058570958`", 
                "1.980228492574038`", \(-0.7202667467219094`\), "19", "3"},
              {"13", "13", \(-5.733177556571992`\), "3.529075627867248`", 
                "3.212653145064792`", \(-0.5583113709687542`\), "39", "3"},
              {"14", "14", \(-0.7200028543969121`\), "0.5546203777172108`", 
                "2.1834081467230644`", "0.6206233218021225`", "14", "3"},
              {"15", "15", "0.06837778928641342`", "0.14511155198410758`", 
                "2.159050440949588`", "0.8535253091542424`", "19", "3"},
              {"16", "16", \(-4.085308610666346`\), "3.020177925433763`", 
                "3.097338376751118`", "0.48949761932253005`", "22", "3"},
              {"17", "17", \(-1.4923132305989057`\), "1.2678348932455268`", 
                "2.3414234763538126`", "1.3438996007484585`", "12", "3"},
              {"18", "18", \(-1.0659556707567792`\), "0.8403023448447712`", 
                "2.0712619108060633`", "1.782756400863925`", "14", "3"},
              {"19", "19", \(-3.3341319171890724`\), "2.65121612230823`", 
                "2.8478961535094895`", "0.7821852665099897`", "25", "3"},
              {"20", "20", \(-2.3147846187641825`\), "1.6817553309033058`", 
                "3.049992560366333`", "0.5615555642315049`", "19", "3"},
              {"21", "21", \(-0.4206695156786683`\), "0.38283201352957963`", 
                "2.38683875149165`", "0.7178688260465799`", "16", "3"},
              {"22", "22", \(-0.14070534528914494`\), "0.1819810337857164`", 
                "1.9718471789715706`", "0.8910248128308236`", "15", "3"},
              {"23", "23", \(-0.6730315314768546`\), "0.8212504731102153`", 
                "1.5355407180725924`", "2.416885047353424`", "17", "3"},
              {"24", "24", \(-4.850046195868337`\), "3.3938825182430468`", 
                "3.3077169690825565`", "0.0007564416489390422`", "50", "0"},
              {"25", "25", \(-0.7873512500495229`\), "0.6614844248652227`", 
                "2.179200167875486`", "0.8662068870399582`", "13", "3"},
              {"26", "26", \(-5.282870233243837`\), "4.215664798874235`", 
                "2.7148684630835107`", "1.4437662838460912`", "50", "0"},
              {"27", "27", \(-0.25809821804495936`\), "0.32669463774657603`", 
                "2.0213918885322593`", "1.195346646660752`", "20", "3"},
              {"28", "28", \(-2.462203141787256`\), "1.9739241910213752`", 
                "2.7698229759866657`", "1.348645076954207`", "29", "3"},
              {"29", "29", \(-1.704358728190595`\), "1.6689430766469004`", 
                "2.1940640459655825`", "2.1500756102689396`", "22", "3"},
              {"30", "30", \(-0.7440234786644712`\), "0.6167110059782583`", 
                "1.9426731841656943`", "1.237006883083731`", "15", "3"},
              {"31", "31", \(-0.701702745803853`\), "0.647654638427938`", 
                "2.2120360960742587`", "0.805609882609641`", "15", "3"},
              {"32", "32", \(-0.5902458373117248`\), "0.49946418376359036`", 
                "2.1588858386325636`", "0.5340425631170905`", "16", "3"},
              {"33", "33", \(-1.3497061970454654`\), "1.1873672804846562`", 
                "2.4040355864620007`", "0.41615608543057514`", "14", "3"},
              {"34", "34", \(-0.7624022779225147`\), "0.6617996700265136`", 
                "2.535683381122446`", "0.5044680595801165`", "17", "3"},
              {"35", "35", \(-1.779874602242324`\), "1.5032762422846173`", 
                "2.565807321999823`", "1.3752484849534308`", "17", "3"},
              {"36", "36", \(-1.160848966023003`\), "1.0585515484892813`", 
                "2.652246597336558`", \(-2.682211723046974`*^-11\), "40", 
                "4"},
              {"37", "37", \(-0.859405584412264`\), "0.8000770569476978`", 
                "2.279364947751443`", "0.6701521791517749`", "14", "3"},
              {"38", "38", \(-0.28121547919044815`\), "0.3176685139821863`", 
                "2.153038707487242`", "0.7540586770634299`", "18", "3"},
              {"39", "39", \(-0.31886212726289326`\), "0.2633453912804173`", 
                "2.067767122157236`", "0.3381359703742417`", "21", "3"},
              {"40", "40", \(-5.183109605455227`\), "3.7353087398481226`", 
                "3.092407720291133`", "0.4418427873857984`", "50", "0"},
              {"41", "41", \(-0.6120448884626782`\), "0.6005187825877442`", 
                "2.146591051958455`", "0.695207971959574`", "14", "3"},
              {"42", "42", "0.0761950775950255`", "0.07988506180305473`", 
                "1.870871772812066`", "1.0850034762376328`", "23", "3"},
              {"43", "43", \(-2.7075782384280584`\), "1.9380944504283815`", 
                "3.227146013185342`", "0.32365891410872233`", "29", "3"},
              {"44", "44", \(-1.9394531405628845`\), "1.3450116703784396`", 
                "3.0133265700744474`", "0.756557942960083`", "21", "3"},
              {"45", "45", \(-1.6482519837676952`\), "1.107513365039387`", 
                "2.9620556509591025`", "0.5300152435778701`", "29", "3"},
              {"46", "46", \(-0.5535543373303956`\), "0.5322288969294989`", 
                "1.890046927962947`", "0.7974332326927102`", "14", "3"},
              {"47", "47", \(-2.4786477704554053`\), "1.6512275660770122`", 
                "3.4139135835062975`", "0.27723491267031763`", "35", "3"},
              {"48", "48", \(-1.177180734902526`\), "1.1404641006151812`", 
                "2.401145622058218`", "0.8073794766350755`", "12", "3"},
              {"49", "49", \(-0.8863386135582242`\), "0.6977618243577719`", 
                "2.66893615215864`", "0.7322043711823515`", "24", "3"},
              {"50", "50", \(-3.957238175671033`\), "2.799464184848914`", 
                "3.2269665432630306`", "0.23767593616379074`", "41", "3"},
              {"51", "51", \(-1.8799464079594106`\), "1.3727696546427595`", 
                "2.9072193553441394`", "0.8766105987312169`", "18", "3"},
              {"52", "52", \(-2.279960008483594`\), "1.6782877517785768`", 
                "3.1058574180483864`", "0.4494936297756272`", "22", "3"},
              {"53", "53", \(-3.9839504319886427`\), "2.9374665779587157`", 
                "3.216102551363352`", "0.6889567936453401`", "46", "3"},
              {"54", "54", \(-2.117289430130947`\), "1.409852614151923`", 
                "2.936668803533543`", "0.7032756816928917`", "20", "3"},
              {"55", "55", \(-0.3756091215980229`\), "0.3657368374201594`", 
                "1.9472516788194718`", "0.7134528292177839`", "17", "3"},
              {"56", "56", \(-1.2119992589615616`\), "0.8218315824460755`", 
                "2.8265565639034667`", "0.3929185075237571`", "21", "3"},
              {"57", "57", \(-0.31174087286127866`\), "0.34416537812425935`", 
                "2.264914717723862`", "0.550420629940835`", "20", "3"},
              {"58", "58", \(-0.3079977023372974`\), "0.39065192133707743`", 
                "2.0630838655139705`", "0.9116351982473967`", "16", "3"},
              {"59", "59", \(-0.5462098083855517`\), "0.5294557213081498`", 
                "1.5013450599421048`", "2.0037764785340344`", "20", "3"},
              {"60", "60", \(-0.012509450656614579`\), "0.1587069598598965`", 
                "1.911198055500087`", "0.3492439788472354`", "21", "3"},
              {"61", "61", \(-3.3141115682714815`\), "2.7842925888585235`", 
                "2.8549491708635295`", "0.35115462390928537`", "32", "3"},
              {"62", "62", \(-0.8834614948419542`\), "0.9602217735636387`", 
                "1.8953843545353126`", "0.8766460845727005`", "9", "3"},
              {"63", "63", \(-3.3306635612491475`\), "2.4160200850116924`", 
                "3.277694617209258`", "0.6133812023051967`", "36", "3"},
              {"64", "64", \(-3.1118450605466172`\), "2.673130145274022`", 
                "2.8465839153888775`", "1.7322814191887264`", "39", "3"},
              {"65", "65", \(-2.017363981629057`\), "1.5439562701389693`", 
                "3.276872306937921`", "0.5370067194043503`", "29", "3"},
              {"66", "66", \(-0.6877756156888807`\), "0.5720097916665634`", 
                "2.260403768255715`", "0.7176226992308924`", "13", "3"},
              {"67", "67", \(-0.6212812822169813`\), "0.5595432719568807`", 
                "2.0652805884104053`", "1.4482674858123084`", "13", "3"},
              {"68", "68", \(-0.5070867033668415`\), "0.4707937677192604`", 
                "2.3922458680119556`", "0.701304988288511`", "14", "3"},
              {"69", "69", \(-5.361917247363493`\), "5.0170299568865735`", 
                "2.5706161023870138`", "1.6520513863232467`", "50", "0"},
              {"70", "70", \(-0.5862002229257567`\), "0.46767531563122317`", 
                "2.309396799267735`", "0.807998189518559`", "26", "3"},
              {"71", "71", \(-2.1094669532476873`\), "1.741796885108308`", 
                "2.7706909486690443`", "0.43698843786025704`", "21", "3"},
              {"72", "72", \(-1.9546284283014317`\), "1.6699299156347924`", 
                "2.308118613473811`", "1.4081066660951598`", "20", "3"},
              {"73", "73", \(-1.3067033460902728`\), "1.054453781663634`", 
                "2.7071350226755233`", "0.7174028205037968`", "18", "4"},
              {"74", "74", \(-0.32796374944973894`\), "0.29137199039607253`", 
                "1.943082885547025`", "0.6773893957501084`", "21", "3"},
              {"75", "75", \(-2.1697733053116086`\), "1.6943730043943`", 
                "2.903545310130846`", "0.7347561938644851`", "23", "3"},
              {"76", "76", \(-1.9669219612076303`\), "1.4502102019830312`", 
                "2.9872958890166497`", "0.29784405319807605`", "22", "3"},
              {"77", "77", \(-2.91858667821429`\), "2.8802194775849292`", 
                "2.511648397468877`", "1.504614973605901`", "31", "3"},
              {"78", "78", \(-0.2151390523843583`\), "0.24937259173638857`", 
                "1.7537056744132076`", "0.7373001027880208`", "18", "3"},
              {"79", "79", \(-1.7365189041121376`\), "1.4768977010834208`", 
                "2.553024048848802`", "0.8845236046462418`", "16", "3"},
              {"80", "80", \(-0.3860495069720115`\), "0.5820703272757181`", 
                "1.6396803331711536`", "1.660953432212946`", "18", "3"},
              {"81", "81", \(-0.30267268869459707`\), "0.31984698565670017`", 
                "1.7720750025427543`", "1.0413488993658155`", "18", "3"},
              {"82", "82", \(-3.6413420860514605`\), "3.4598682141643806`", 
                "2.715108652836736`", "1.3418519772843045`", "47", "3"},
              {"83", "83", \(-3.0591247893899114`\), "2.9539656452313388`", 
                "2.7894059098089126`", "1.4116116171532764`", "33", "3"},
              {"84", "84", \(-3.8652671423087988`\), "3.2176201787062326`", 
                "2.8815022214077075`", "0.7125222153089555`", "37", "3"},
              {"85", "85", \(-1.032092395100492`\), "0.8462625223681485`", 
                "2.3482128939688534`", "0.6475959989841912`", "13", "3"},
              {"86", "86", \(-0.8086670931011235`\), "1.0372677371430494`", 
                "2.086731938867913`", "0.8454593506301056`", "10", "3"},
              {"87", "87", \(-2.843186535069904`\), "1.987169007241877`", 
                "3.329218828873901`", "0.5361512121331733`", "33", "3"},
              {"88", "88", \(-0.7341948108761421`\), "0.682122658192559`", 
                "2.1805844049725227`", "0.8508008488299671`", "14", "3"},
              {"89", "89", \(-5.483792946130982`\), "3.618586137777833`", 
                "3.195203075054758`", "0.7440815367485465`", "50", "0"},
              {"90", "90", \(-1.2027722019834524`\), "1.296760330307119`", 
                "1.85991809984271`", "0.6874553714057603`", "14", "3"},
              {"91", "91", \(-3.1598850735172257`\), "2.4225639291540637`", 
                "3.2364108730714594`", "0.6095669078005989`", "34", "3"},
              {"92", "92", \(-2.84621171499575`\), "2.1061831340182513`", 
                "3.1410397045055527`", "0.5987413238161081`", "28", "3"},
              {"93", "93", \(-1.8158121491727521`\), "1.2599568547125304`", 
                "3.004445805359137`", "0.21083535157299552`", "23", "3"},
              {"94", "94", \(-0.8814167249688044`\), "0.7048826179612822`", 
                "2.578644539119702`", "0.7149130441116776`", "19", "3"},
              {"95", "95", \(-3.1341520554216094`\), "2.4817003441150405`", 
                "3.0164908874860457`", "0.5223396102221629`", "41", "3"},
              {"96", "96", \(-0.6486447735735925`\), "0.6154699622132522`", 
                "1.8884607585317759`", "1.447484515179738`", "12", "3"},
              {"97", "97", \(-0.46063183701952154`\), "0.5415067385155946`", 
                "1.7797118926446347`", "1.4736754158657648`", "13", "3"},
              {"98", "98", \(-0.40677334207808463`\), "0.48233927936551485`", 
                "1.7066726771799927`", "1.5924531017701327`", "15", "3"},
              {"99", "99", \(-0.8266448713772683`\), "0.698713879238913`", 
                "1.9676928101257836`", "1.4362400711010066`", "20", "3"},
              {"100", "100", \(-2.794481153313937`\), "2.3360871208884086`", 
                "3.028206891051666`", "0.5576783477164196`", "27", "3"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["cum//Dimensions", "Input"],

Cell[BoxData[
    \({100, 7}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
sel=Position[cum[[All,7]],3]//Flatten;
sel//Length\
\>", "Input"],

Cell[BoxData[
    \(93\)], "Output"]
}, Open  ]],

Cell["cum1=cum[[sel,{2,3,4,5}]];", "Input"],

Cell["cum1=Map[{#[[1]],#[[2]]//Abs,#[[3]],#[[4]]//Abs}&,cum1];", "Input"],

Cell[CellGroupData[{

Cell["\<\
{SML,S,MEAN} = Varianz[cum1//N];
STD = VecDiag[SML]//Sqrt;
bias=MEAN-THETA0;
rmse=Sqrt[STD^2+bias^2];

{{\"alpha\",\"beta\",sigma,R},
 Theta,MEAN*SCALING,STD*SCALING,bias*SCALING,rmse*SCALING }//Transpose//
MatrixForm[#,TableHeadings->{None,{\"parameter\",\"value\",\"mean\",\"std\",\"\
bias\",\"RMSE\"}}]&\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-1.5140843269921056`\), 
                "1.1957053594955227`", \(-0.5140843269921056`\), 
                "1.3015352480763798`"},
              {"\<\"beta\"\>", "0.1`", "0.12414203426174278`", 
                "0.08981907199585065`", "0.024142034261742773`", 
                "0.09300700786763849`"},
              {"sigma", "2.`", "2.46262515486589`", "0.48934095890590834`", 
                "0.46262515486588995`", "0.6734067180966066`"},
              {"R", "1.`", "0.8736144578689317`", 
                "0.437204119557505`", \(-0.12638554213106834`\), 
                "0.45510520477996863`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]],

Cell[" ", "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["together", "Subsection"],

Cell[CellGroupData[{

Cell["EKF/100", "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-0.2541690324072564`\), 
                "0.4137986265476171`", "0.7458309675927436`", 
                "0.8529320814420234`"},
              {"\<\"beta\"\>", "0.1`", "0.06588082761249875`", 
                "0.07305644206852109`", \(-0.03411917238750125`\), 
                "0.0806310216487377`"},
              {"sigma", "2.`", "2.0177670694516765`", "0.6380361436758832`", 
                "0.017767069451676498`", "0.6382834710328108`"},
              {"R", "1.`", "0.9518565106109488`", 
                "0.44405682424487847`", \(-0.04814348938905122`\), 
                "0.446658996023813`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SNF/84", "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-0.11992584478973035`\), 
                "0.09532361606356712`", "0.8800741552102697`", 
                "0.8852215036071505`"},
              {"\<\"beta\"\>", "0.1`", "0.023157190740658327`", 
                "0.007959545105780256`", \(-0.07684280925934167`\), 
                "0.07725394289716556`"},
              {"sigma", "2.`", "1.4676499278591089`", 
                "0.2152045834639737`", \(-0.5323500721408911`\), 
                "0.5742034587603199`"},
              {"R", "1.`", "1.1504971879557302`", "0.39945936414238414`", 
                "0.1504971879557302`", "0.42686905156455207`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["LL, M=65", "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-0.08853853623192687`\), 
                "0.11733825221858515`", "0.9114614637680731`", 
                "0.918983278067643`"},
              {"\<\"beta\"\>", "0.1`", "0.016374772207926307`", 
                "0.00790205716198141`", \(-0.0836252277920737`\), 
                "0.08399774539038196`"},
              {"sigma", "2.`", "1.4807272939671272`", 
                "0.2461376043359035`", \(-0.5192727060328728`\), 
                "0.574654560148025`"},
              {"R", "1.`", "1.250618656450399`", "0.37084218654497125`", 
                "0.25061865645039894`", "0.447586459002569`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF, kappa=0 /99", "Input",
  CellTags->""],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-0.7127362434745`\), 
                "0.9525498033823069`", "0.28726375652549996`", 
                "0.9949229084390475`"},
              {"\<\"beta\"\>", "0.1`", "0.07612199624919447`", 
                "0.08537850686354594`", \(-0.023878003750805545`\), 
                "0.08865465863321592`"},
              {"sigma", "2.`", "1.7987541176527528`", 
                "0.40394402119716666`", \(-0.20124588234724716`\), 
                "0.45129887815355696`"},
              {"R", "1.`", "1.0741727449578626`", "0.4419995536696189`", 
                "0.07417274495786264`", "0.44817987632057565`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF, kappa=1 /96", "Input",
  CellTags->""],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-1.0934443039271908`\), 
                "1.0089284323253818`", \(-0.09344430392719083`\), 
                "1.0132464751929757`"},
              {"\<\"beta\"\>", "0.1`", "0.10208059597819102`", 
                "0.08668501927259509`", "0.002080595978191013`", 
                "0.08670998469561994`"},
              {"sigma", "2.`", "2.116632080244688`", "0.4399068220190152`", 
                "0.11663208024468785`", "0.4551055418263689`"},
              {"R", "1.`", "0.984557278224707`", 
                "0.45091746927157755`", \(-0.015442721775293045`\), 
                "0.4511818278145887`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output",
  CellTags->""]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF, kappa=2 /93", "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-1.5140843269921056`\), 
                "1.1957053594955227`", \(-0.5140843269921056`\), 
                "1.3015352480763798`"},
              {"\<\"beta\"\>", "0.1`", "0.12414203426174278`", 
                "0.08981907199585065`", "0.024142034261742773`", 
                "0.09300700786763849`"},
              {"sigma", "2.`", "2.46262515486589`", "0.48934095890590834`", 
                "0.46262515486588995`", "0.6734067180966066`"},
              {"R", "1.`", "0.8736144578689317`", 
                "0.437204119557505`", \(-0.12638554213106834`\), 
                "0.45510520477996863`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["GHF, m=4 /96", "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-1.4520996528071093`\), 
                "1.1499301280264116`", \(-0.4520996528071093`\), 
                "1.2356105354888927`"},
              {"\<\"beta\"\>", "0.1`", "0.1225605594799477`", 
                "0.0894279076852383`", "0.022560559479947707`", 
                "0.09222976481054129`"},
              {"sigma", "2.`", "2.394970525168616`", "0.44032273379281717`", 
                "0.39497052516861597`", "0.5915114754987872`"},
              {"R", "1.`", "0.8919530765257153`", 
                "0.4330762472860989`", \(-0.10804692347428468`\), 
                "0.4463509534387355`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "GGHF, {\"psd\",MessupHermite4},m=20,",
  StyleBox["eps=10^-16,ksigma=3",
    FontColor->RGBColor[1, 0, 0]],
  "}"
}], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"parameter\"\>",
                  HoldForm], 
                TagBox["\<\"value\"\>",
                  HoldForm], 
                TagBox["\<\"mean\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"bias\"\>",
                  HoldForm], 
                TagBox["\<\"RMSE\"\>",
                  HoldForm]},
              {"\<\"alpha\"\>", \(-1.`\), \(-2.1511586619644354`\), 
                "1.1197369427871209`", \(-1.1511586619644354`\), 
                "1.605919389651298`"},
              {"\<\"beta\"\>", "0.1`", "0.1834849127159023`", 
                "0.09039922395154956`", "0.0834849127159023`", 
                "0.12305181974365205`"},
              {"sigma", "2.`", "2.7180267452555693`", "0.44892321865663243`", 
                "0.7180267452555693`", "0.8468143026374418`"},
              {"R", "1.`", "0.6848099818412684`", 
                "0.4089403994246574`", \(-0.3151900181587316`\), 
                "0.5163109507152641`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"parameter", "value", "mean", 
          "std", "bias", "RMSE"}}]]]], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
AutoGeneratedPackage->None,
WindowToolbars->{},
WindowSize->{975, 672},
WindowMargins->{{34, Automatic}, {Automatic, 3}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowSelection->True,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
Magnification->1,
MacintoshSystemPageSetup->"\<\
0000001804P000000bd2=_oaoo43?095o`85N@?NW0002008ool000001@050001
0000I24A4R060`410@000BL?0040000000000000000004E3<34100;o00000001
000A0S<R<3`00Q3400018NOWinOWia4A\>"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Info3374910237-9666275"->{
    Cell[186817, 4415, 65, 1, 22, "Print",
      CellTags->"Info3374910237-9666275"],
    Cell[186885, 4418, 4663, 82, 313, "Print",
      CellTags->"Info3374910237-9666275"]},
  "Info3374499539-9666275"->{
    Cell[191551, 4502, 4715, 84, 313, "Print",
      CellTags->"Info3374499539-9666275"]},
  ""->{
    Cell[815350, 20764, 110, 2, 23, "Print",
      CellTags->""],
    Cell[815463, 20768, 155, 3, 23, "Print",
      CellTags->""],
    Cell[815621, 20773, 110, 2, 23, "Print",
      CellTags->""],
    Cell[815734, 20777, 157, 3, 23, "Print",
      CellTags->""],
    Cell[815894, 20782, 67, 1, 23, "Print",
      CellTags->""],
    Cell[815964, 20785, 83, 1, 23, "Print",
      CellTags->""],
    Cell[816050, 20788, 159, 3, 23, "Print",
      CellTags->""],
    Cell[816212, 20793, 159, 3, 23, "Print",
      CellTags->""],
    Cell[816374, 20798, 159, 3, 23, "Print",
      CellTags->""],
    Cell[816536, 20803, 157, 3, 23, "Print",
      CellTags->""],
    Cell[816696, 20808, 42, 1, 27, "Output",
      CellTags->""],
    Cell[816983, 20828, 15151, 219, 1025, "Output",
      CellTags->""],
    Cell[943489, 23887, 41, 1, 27, "Input",
      CellTags->""],
    Cell[943533, 23890, 60, 2, 26, "Output",
      CellTags->""],
    Cell[943608, 23895, 56, 1, 27, "Input",
      CellTags->""],
    Cell[943689, 23900, 48, 1, 27, "Input",
      CellTags->""],
    Cell[943740, 23903, 15657, 219, 1029, "Output",
      CellTags->""],
    Cell[959548, 24135, 91, 4, 42, "Input",
      CellTags->""],
    Cell[959642, 24141, 52, 2, 26, "Output",
      CellTags->""],
    Cell[959709, 24146, 59, 1, 27, "Input",
      CellTags->""],
    Cell[959771, 24149, 89, 1, 27, "Input",
      CellTags->""],
    Cell[959885, 24154, 381, 12, 162, "Input",
      CellTags->""],
    Cell[960269, 24168, 1611, 39, 65, "Output",
      CellTags->""],
    Cell[961962, 24216, 85, 2, 30, "Subsection",
      CellTags->""],
    Cell[1064665, 26791, 110, 2, 23, "Print",
      CellTags->""],
    Cell[1064778, 26795, 157, 3, 23, "Print",
      CellTags->""],
    Cell[1064938, 26800, 110, 2, 23, "Print",
      CellTags->""],
    Cell[1065051, 26804, 157, 3, 23, "Print",
      CellTags->""],
    Cell[1065211, 26809, 67, 1, 23, "Print",
      CellTags->""],
    Cell[1065281, 26812, 83, 1, 23, "Print",
      CellTags->""],
    Cell[1065367, 26815, 99, 2, 23, "Print",
      CellTags->""],
    Cell[1065469, 26819, 99, 2, 23, "Print",
      CellTags->""],
    Cell[1065571, 26823, 99, 2, 23, "Print",
      CellTags->""],
    Cell[1065673, 26827, 51, 1, 23, "Print",
      CellTags->""],
    Cell[1065727, 26830, 36, 1, 23, "Print",
      CellTags->""],
    Cell[1065766, 26833, 99, 2, 23, "Print",
      CellTags->""],
    Cell[1065868, 26837, 630, 14, 31, "Print",
      CellTags->""],
    Cell[1066501, 26853, 45, 1, 23, "Print",
      CellTags->""],
    Cell[1066549, 26856, 595, 14, 33, "Print",
      CellTags->""],
    Cell[1067147, 26872, 45, 1, 23, "Print",
      CellTags->""],
    Cell[1067195, 26875, 657, 15, 31, "Print",
      CellTags->""],
    Cell[1067855, 26892, 45, 1, 23, "Print",
      CellTags->""],
    Cell[1067903, 26895, 46, 1, 23, "Print",
      CellTags->""],
    Cell[1067952, 26898, 201, 5, 23, "Print",
      CellTags->""],
    Cell[1068156, 26905, 45, 1, 23, "Print",
      CellTags->""],
    Cell[1068204, 26908, 99, 2, 23, "Print",
      CellTags->""],
    Cell[1068306, 26912, 45, 1, 23, "Print",
      CellTags->""],
    Cell[1068354, 26915, 216, 4, 23, "Print",
      CellTags->""],
    Cell[1068573, 26921, 374, 7, 25, "Print",
      CellTags->""],
    Cell[1068950, 26930, 42, 1, 27, "Output",
      CellTags->""],
    Cell[1092417, 27398, 49, 1, 27, "Input",
      CellTags->""],
    Cell[1094101, 27444, 49, 1, 27, "Input",
      CellTags->""],
    Cell[1094153, 27447, 1611, 39, 65, "Output",
      CellTags->""]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Info3374910237-9666275", 1101948, 27658},
  {"Info3374499539-9666275", 1102155, 27663},
  {"", 1102254, 27666}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 62, 1, 46, "Subsection"],

Cell[CellGroupData[{
Cell[1863, 58, 148, 7, 99, "Input"],
Cell[2014, 67, 119, 2, 21, "Message"],
Cell[2136, 71, 174, 3, 21, "Message"],
Cell[2313, 76, 115, 2, 21, "Message"],
Cell[2431, 80, 189, 3, 21, "Message"]
}, Open  ]],
Cell[2635, 86, 80, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2752, 92, 61, 1, 46, "Subsection"],

Cell[CellGroupData[{
Cell[2838, 97, 41, 0, 42, "Subsubsection"],
Cell[2882, 99, 102, 2, 55, "Input"],
Cell[2987, 103, 100, 1, 39, "Input"],

Cell[CellGroupData[{
Cell[3112, 108, 427, 14, 174, "Input",
  InitializationCell->True],
Cell[3542, 124, 185, 3, 70, "Message"],
Cell[3730, 129, 183, 3, 70, "Message"],
Cell[3916, 134, 183, 3, 70, "Message"],
Cell[4102, 139, 183, 3, 70, "Message"],
Cell[4288, 144, 163, 3, 70, "Message"],
Cell[4454, 149, 161, 2, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4652, 156, 171, 3, 39, "Input"],
Cell[4826, 161, 55289, 1645, 70, 17227, 1171, "GraphicsData", "PostScript", \
"Graphics"],
Cell[60118, 1808, 130, 3, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[60297, 1817, 65, 1, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[60387, 1822, 638, 15, 219, "Input"],
Cell[61028, 1839, 183, 3, 70, "Message"],
Cell[61214, 1844, 183, 3, 70, "Message"],
Cell[61400, 1849, 165, 2, 70, "Output"],
Cell[61568, 1853, 183, 3, 70, "Message"],
Cell[61754, 1858, 183, 3, 70, "Message"],
Cell[61940, 1863, 118, 2, 70, "Output"],
Cell[62061, 1867, 183, 3, 70, "Message"],
Cell[62247, 1872, 121, 3, 70, "Output"],
Cell[62371, 1877, 183, 3, 70, "Message"],
Cell[62557, 1882, 45, 1, 70, "Output"],
Cell[62605, 1885, 39, 1, 70, "Output"],
Cell[62647, 1888, 183, 3, 70, "Message"],
Cell[62833, 1893, 41, 1, 70, "Output"],
Cell[62877, 1896, 191, 3, 70, "Message"],
Cell[63071, 1901, 183, 3, 70, "Message"],
Cell[63257, 1906, 41, 1, 70, "Output"],
Cell[63301, 1909, 43, 1, 70, "Output"],
Cell[63347, 1912, 197, 3, 70, "Message"],
Cell[63547, 1917, 45, 1, 70, "Output"],
Cell[63595, 1920, 47, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[63679, 1926, 231, 10, 144, "Input"],
Cell[63913, 1938, 42, 1, 70, "Output"],
Cell[63958, 1941, 44, 1, 70, "Output"],
Cell[64005, 1944, 47, 1, 70, "Output"],
Cell[64055, 1947, 49, 1, 70, "Output"],
Cell[64107, 1950, 45, 1, 70, "Output"],
Cell[64155, 1953, 39, 1, 70, "Output"],
Cell[64197, 1956, 41, 1, 70, "Output"],
Cell[64241, 1959, 47, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[64325, 1965, 494, 18, 264, "Input"],
Cell[64822, 1985, 99, 2, 70, "Output"],
Cell[64924, 1989, 109, 2, 70, "Output"],
Cell[65036, 1993, 99, 2, 70, "Output"],
Cell[65138, 1997, 110, 2, 70, "Output"],
Cell[65251, 2001, 180, 3, 70, "Message"],
Cell[65434, 2006, 114, 2, 70, "Output"],
Cell[65551, 2010, 182, 3, 70, "Message"],
Cell[65736, 2015, 118, 2, 70, "Output"],
Cell[65857, 2019, 184, 3, 70, "Message"],
Cell[66044, 2024, 122, 2, 70, "Output"],
Cell[66169, 2028, 109, 2, 70, "Output"],
Cell[66281, 2032, 185, 3, 70, "Message"],
Cell[66469, 2037, 113, 2, 70, "Output"],
Cell[66585, 2041, 186, 3, 70, "Message"],
Cell[66774, 2046, 117, 2, 70, "Output"],
Cell[66894, 2050, 188, 3, 70, "Message"],
Cell[67085, 2055, 121, 2, 70, "Output"],
Cell[67209, 2059, 190, 3, 70, "Message"],
Cell[67402, 2064, 125, 2, 70, "Output"],
Cell[67530, 2068, 192, 3, 70, "Message"],
Cell[67725, 2073, 129, 2, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[67915, 2082, 89, 2, 30, "Subsection"],
Cell[68007, 2086, 401, 16, 204, "Input"],

Cell[CellGroupData[{
Cell[68433, 2106, 88, 2, 27, "Input"],
Cell[68524, 2110, 46, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[68607, 2116, 39, 0, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[68671, 2120, 234, 10, 129, "Input"],
Cell[68908, 2132, 102, 2, 38, "Output"],
Cell[69013, 2136, 132, 2, 38, "Output"],
Cell[69148, 2140, 22779, 310, 1673, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[91964, 2455, 175, 6, 51, "Input"],
Cell[92142, 2463, 179, 3, 22, "Print"],
Cell[92324, 2468, 93526, 1894, 182, 13144, 896, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[185899, 4368, 198, 3, 74, "Subsubsection"],

Cell[CellGroupData[{
Cell[186122, 4375, 122, 5, 54, "Input"],
Cell[186247, 4382, 49, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[186333, 4388, 60, 1, 39, "Input"],
Cell[186396, 4391, 45, 1, 38, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[186502, 4399, 59, 1, 30, "Subsection"],

Cell[CellGroupData[{
Cell[186586, 4404, 65, 1, 42, "Subsubsection"],
Cell[186654, 4407, 94, 1, 30, "Text"],

Cell[CellGroupData[{
Cell[186773, 4412, 41, 1, 39, "Input"],
Cell[186817, 4415, 65, 1, 22, "Print",
  CellTags->"Info3374910237-9666275"],
Cell[186885, 4418, 4663, 82, 313, "Print",
  CellTags->"Info3374910237-9666275"],
Cell[191551, 4502, 4715, 84, 313, "Print",
  CellTags->"Info3374499539-9666275"]
}, Closed]],

Cell[CellGroupData[{
Cell[196303, 4591, 156, 5, 51, "Input"],
Cell[196462, 4598, 54, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[196553, 4604, 79, 1, 39, "Input"],
Cell[196635, 4607, 179, 3, 21, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[196851, 4615, 202, 5, 69, "Input"],
Cell[197056, 4622, 179, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[197272, 4630, 190, 5, 69, "Input"],
Cell[197465, 4637, 177, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[197679, 4645, 218, 6, 54, "Input"],
Cell[197900, 4653, 99806, 2419, 182, 24332, 1483, "GraphicsData", \
"PostScript", "Graphics"],
Cell[297709, 7074, 130, 3, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[297876, 7082, 67, 1, 39, "Input"],
Cell[297946, 7085, 49, 1, 38, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[298044, 7092, 61, 1, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[298130, 7097, 46, 1, 39, "Input"],
Cell[298179, 7100, 38, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[298254, 7106, 294, 13, 177, "Input"],
Cell[298551, 7121, 193, 3, 21, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[298781, 7129, 1254, 25, 672, "Input"],
Cell[300038, 7156, 179, 3, 21, "Message"],
Cell[300220, 7161, 110, 2, 22, "Print"],
Cell[300333, 7165, 155, 3, 22, "Print"],
Cell[300491, 7170, 110, 2, 22, "Print"],
Cell[300604, 7174, 157, 3, 22, "Print"],
Cell[300764, 7179, 67, 1, 22, "Print"],
Cell[300834, 7182, 83, 1, 22, "Print"],
Cell[300920, 7185, 99, 2, 22, "Print"],
Cell[301022, 7189, 99, 2, 22, "Print"],
Cell[301124, 7193, 99, 2, 22, "Print"],
Cell[301226, 7197, 51, 1, 22, "Print"],
Cell[301280, 7200, 36, 1, 22, "Print"],
Cell[301319, 7203, 99, 2, 22, "Print"],
Cell[301421, 7207, 630, 14, 31, "Print"],
Cell[302054, 7223, 45, 1, 22, "Print"],
Cell[302102, 7226, 589, 14, 33, "Print"],
Cell[302694, 7242, 45, 1, 22, "Print"],
Cell[302742, 7245, 657, 15, 31, "Print"],
Cell[303402, 7262, 45, 1, 22, "Print"],
Cell[303450, 7265, 46, 1, 22, "Print"],
Cell[303499, 7268, 201, 5, 22, "Print"],
Cell[303703, 7275, 45, 1, 22, "Print"],
Cell[303751, 7278, 99, 2, 22, "Print"],
Cell[303853, 7282, 45, 1, 22, "Print"],
Cell[303901, 7285, 216, 4, 22, "Print"],
Cell[304120, 7291, 374, 7, 24, "Print"],
Cell[304497, 7300, 151, 2, 22, "Print"],
Cell[304651, 7304, 102, 2, 22, "Print"],
Cell[304756, 7308, 159, 3, 22, "Print"],
Cell[304918, 7313, 396, 10, 22, "Print"],
Cell[305317, 7325, 396, 10, 22, "Print"],
Cell[305716, 7337, 412, 10, 22, "Print"],
Cell[306131, 7349, 45, 1, 22, "Print"],
Cell[306179, 7352, 2914, 79, 85, "Print"],
Cell[309096, 7433, 46, 1, 22, "Print"],
Cell[309145, 7436, 2016, 59, 69, "Print"],
Cell[311164, 7497, 371, 7, 24, "Print"],
Cell[311538, 7506, 180, 3, 24, "Print"],
Cell[311721, 7511, 273, 5, 22, "Print"],
Cell[311997, 7518, 295, 6, 22, "Print"],
Cell[312295, 7526, 102, 2, 22, "Print"],
Cell[312400, 7530, 159, 3, 22, "Print"],
Cell[312562, 7535, 832, 18, 22, "Print"],
Cell[313397, 7555, 396, 10, 22, "Print"],
Cell[313796, 7567, 396, 10, 22, "Print"],
Cell[314195, 7579, 412, 10, 22, "Print"],
Cell[314610, 7591, 45, 1, 22, "Print"],
Cell[314658, 7594, 2975, 79, 85, "Print"],
Cell[317636, 7675, 46, 1, 22, "Print"],
Cell[317685, 7678, 2369, 59, 69, "Print"],
Cell[320057, 7739, 371, 7, 24, "Print"],
Cell[320431, 7748, 180, 3, 24, "Print"],
Cell[320614, 7753, 267, 5, 22, "Print"],
Cell[320884, 7760, 295, 6, 22, "Print"],
Cell[321182, 7768, 102, 2, 22, "Print"],
Cell[321287, 7772, 159, 3, 22, "Print"],
Cell[321449, 7777, 396, 10, 22, "Print"],
Cell[321848, 7789, 396, 10, 22, "Print"],
Cell[322247, 7801, 412, 10, 22, "Print"],
Cell[322662, 7813, 45, 1, 22, "Print"],
Cell[322710, 7816, 3013, 79, 85, "Print"],
Cell[325726, 7897, 46, 1, 22, "Print"],
Cell[325775, 7900, 2370, 59, 69, "Print"],
Cell[328148, 7961, 371, 7, 24, "Print"],
Cell[328522, 7970, 180, 3, 24, "Print"],
Cell[328705, 7975, 270, 5, 22, "Print"],
Cell[328978, 7982, 298, 6, 22, "Print"],
Cell[329279, 7990, 102, 2, 22, "Print"],
Cell[329384, 7994, 159, 3, 22, "Print"],
Cell[329546, 7999, 832, 18, 22, "Print"],
Cell[330381, 8019, 396, 10, 22, "Print"],
Cell[330780, 8031, 396, 10, 22, "Print"],
Cell[331179, 8043, 414, 10, 22, "Print"],
Cell[331596, 8055, 45, 1, 22, "Print"],
Cell[331644, 8058, 3012, 79, 85, "Print"],
Cell[334659, 8139, 46, 1, 22, "Print"],
Cell[334708, 8142, 2370, 59, 69, "Print"],
Cell[337081, 8203, 371, 7, 24, "Print"],
Cell[337455, 8212, 181, 3, 24, "Print"],
Cell[337639, 8217, 266, 5, 22, "Print"],
Cell[337908, 8224, 299, 6, 22, "Print"],
Cell[338210, 8232, 102, 2, 22, "Print"],
Cell[338315, 8236, 159, 3, 22, "Print"],
Cell[338477, 8241, 830, 18, 22, "Print"],
Cell[339310, 8261, 394, 10, 22, "Print"],
Cell[339707, 8273, 396, 10, 22, "Print"],
Cell[340106, 8285, 414, 10, 22, "Print"],
Cell[340523, 8297, 45, 1, 22, "Print"],
Cell[340571, 8300, 3016, 79, 85, "Print"],
Cell[343590, 8381, 46, 1, 22, "Print"],
Cell[343639, 8384, 2374, 59, 69, "Print"],
Cell[346016, 8445, 374, 7, 24, "Print"],
Cell[346393, 8454, 181, 3, 24, "Print"],
Cell[346577, 8459, 267, 5, 22, "Print"],
Cell[346847, 8466, 298, 6, 22, "Print"],
Cell[347148, 8474, 102, 2, 22, "Print"],
Cell[347253, 8478, 159, 3, 22, "Print"],
Cell[347415, 8483, 396, 10, 22, "Print"],
Cell[347814, 8495, 394, 10, 22, "Print"],
Cell[348211, 8507, 414, 10, 22, "Print"],
Cell[348628, 8519, 45, 1, 22, "Print"],
Cell[348676, 8522, 3021, 79, 85, "Print"],
Cell[351700, 8603, 46, 1, 22, "Print"],
Cell[351749, 8606, 2361, 59, 69, "Print"],
Cell[354113, 8667, 370, 7, 24, "Print"],
Cell[354486, 8676, 181, 3, 24, "Print"],
Cell[354670, 8681, 265, 5, 22, "Print"],
Cell[354938, 8688, 298, 6, 22, "Print"],
Cell[355239, 8696, 102, 2, 22, "Print"],
Cell[355344, 8700, 159, 3, 22, "Print"],
Cell[355506, 8705, 396, 10, 22, "Print"],
Cell[355905, 8717, 396, 10, 22, "Print"],
Cell[356304, 8729, 414, 10, 22, "Print"],
Cell[356721, 8741, 45, 1, 22, "Print"],
Cell[356769, 8744, 3020, 79, 85, "Print"],
Cell[359792, 8825, 46, 1, 22, "Print"],
Cell[359841, 8828, 2372, 59, 69, "Print"],
Cell[362216, 8889, 371, 7, 24, "Print"],
Cell[362590, 8898, 181, 3, 24, "Print"],
Cell[362774, 8903, 266, 5, 22, "Print"],
Cell[363043, 8910, 298, 6, 22, "Print"],
Cell[363344, 8918, 102, 2, 22, "Print"],
Cell[363449, 8922, 159, 3, 22, "Print"],
Cell[363611, 8927, 396, 10, 22, "Print"],
Cell[364010, 8939, 396, 10, 22, "Print"],
Cell[364409, 8951, 414, 10, 22, "Print"],
Cell[364826, 8963, 45, 1, 22, "Print"],
Cell[364874, 8966, 3019, 79, 85, "Print"],
Cell[367896, 9047, 46, 1, 22, "Print"],
Cell[367945, 9050, 2367, 59, 69, "Print"],
Cell[370315, 9111, 373, 7, 24, "Print"],
Cell[370691, 9120, 180, 3, 24, "Print"],
Cell[370874, 9125, 266, 5, 22, "Print"],
Cell[371143, 9132, 299, 6, 22, "Print"],
Cell[371445, 9140, 102, 2, 22, "Print"],
Cell[371550, 9144, 159, 3, 22, "Print"],
Cell[371712, 9149, 396, 10, 22, "Print"],
Cell[372111, 9161, 396, 10, 22, "Print"],
Cell[372510, 9173, 414, 10, 22, "Print"],
Cell[372927, 9185, 45, 1, 22, "Print"],
Cell[372975, 9188, 3013, 79, 85, "Print"],
Cell[375991, 9269, 46, 1, 22, "Print"],
Cell[376040, 9272, 2368, 59, 69, "Print"],
Cell[378411, 9333, 373, 7, 24, "Print"],
Cell[378787, 9342, 181, 3, 24, "Print"],
Cell[378971, 9347, 266, 5, 22, "Print"],
Cell[379240, 9354, 299, 6, 22, "Print"],
Cell[379542, 9362, 102, 2, 22, "Print"],
Cell[379647, 9366, 161, 3, 22, "Print"],
Cell[379811, 9371, 396, 10, 22, "Print"],
Cell[380210, 9383, 396, 10, 22, "Print"],
Cell[380609, 9395, 414, 10, 22, "Print"],
Cell[381026, 9407, 45, 1, 22, "Print"],
Cell[381074, 9410, 3019, 79, 85, "Print"],
Cell[384096, 9491, 46, 1, 22, "Print"],
Cell[384145, 9494, 2368, 59, 69, "Print"],
Cell[386516, 9555, 374, 7, 24, "Print"],
Cell[386893, 9564, 181, 3, 24, "Print"],
Cell[387077, 9569, 263, 5, 22, "Print"],
Cell[387343, 9576, 300, 6, 22, "Print"],
Cell[387646, 9584, 102, 2, 22, "Print"],
Cell[387751, 9588, 161, 3, 22, "Print"],
Cell[387915, 9593, 396, 10, 22, "Print"],
Cell[388314, 9605, 396, 10, 22, "Print"],
Cell[388713, 9617, 416, 10, 22, "Print"],
Cell[389132, 9629, 45, 1, 22, "Print"],
Cell[389180, 9632, 3019, 79, 85, "Print"],
Cell[392202, 9713, 46, 1, 22, "Print"],
Cell[392251, 9716, 2372, 59, 69, "Print"],
Cell[394626, 9777, 373, 7, 24, "Print"],
Cell[395002, 9786, 179, 3, 24, "Print"],
Cell[395184, 9791, 263, 5, 22, "Print"],
Cell[395450, 9798, 300, 6, 22, "Print"],
Cell[395753, 9806, 102, 2, 22, "Print"],
Cell[395858, 9810, 161, 3, 22, "Print"],
Cell[396022, 9815, 396, 10, 22, "Print"],
Cell[396421, 9827, 396, 10, 22, "Print"],
Cell[396820, 9839, 418, 10, 22, "Print"],
Cell[397241, 9851, 45, 1, 22, "Print"],
Cell[397289, 9854, 3021, 79, 85, "Print"],
Cell[400313, 9935, 46, 1, 22, "Print"],
Cell[400362, 9938, 2373, 59, 69, "Print"],
Cell[402738, 9999, 373, 7, 24, "Print"],
Cell[403114, 10008, 180, 3, 24, "Print"],
Cell[403297, 10013, 264, 5, 22, "Print"],
Cell[403564, 10020, 301, 6, 22, "Print"],
Cell[403868, 10028, 102, 2, 22, "Print"],
Cell[403973, 10032, 161, 3, 22, "Print"],
Cell[404137, 10037, 396, 10, 22, "Print"],
Cell[404536, 10049, 396, 10, 22, "Print"],
Cell[404935, 10061, 416, 10, 22, "Print"],
Cell[405354, 10073, 45, 1, 22, "Print"],
Cell[405402, 10076, 3022, 79, 85, "Print"],
Cell[408427, 10157, 46, 1, 22, "Print"],
Cell[408476, 10160, 2368, 59, 69, "Print"],
Cell[410847, 10221, 372, 7, 24, "Print"],
Cell[411222, 10230, 181, 3, 24, "Print"],
Cell[411406, 10235, 265, 5, 22, "Print"],
Cell[411674, 10242, 301, 6, 22, "Print"],
Cell[411978, 10250, 102, 2, 22, "Print"],
Cell[412083, 10254, 161, 3, 22, "Print"],
Cell[412247, 10259, 396, 10, 22, "Print"],
Cell[412646, 10271, 396, 10, 22, "Print"],
Cell[413045, 10283, 418, 10, 22, "Print"],
Cell[413466, 10295, 45, 1, 22, "Print"],
Cell[413514, 10298, 3029, 79, 85, "Print"],
Cell[416546, 10379, 46, 1, 22, "Print"],
Cell[416595, 10382, 2371, 59, 69, "Print"],
Cell[418969, 10443, 373, 7, 24, "Print"],
Cell[419345, 10452, 180, 3, 24, "Print"],
Cell[419528, 10457, 266, 5, 22, "Print"],
Cell[419797, 10464, 303, 6, 22, "Print"],
Cell[420103, 10472, 102, 2, 22, "Print"],
Cell[420208, 10476, 161, 3, 22, "Print"],
Cell[420372, 10481, 396, 10, 22, "Print"],
Cell[420771, 10493, 396, 10, 22, "Print"],
Cell[421170, 10505, 420, 10, 22, "Print"],
Cell[421593, 10517, 45, 1, 22, "Print"],
Cell[421641, 10520, 3024, 79, 85, "Print"],
Cell[424668, 10601, 46, 1, 22, "Print"],
Cell[424717, 10604, 2369, 59, 69, "Print"],
Cell[427089, 10665, 374, 7, 24, "Print"],
Cell[427466, 10674, 180, 3, 24, "Print"],
Cell[427649, 10679, 266, 5, 22, "Print"],
Cell[427918, 10686, 303, 6, 22, "Print"],
Cell[428224, 10694, 102, 2, 22, "Print"],
Cell[428329, 10698, 161, 3, 22, "Print"],
Cell[428493, 10703, 396, 10, 22, "Print"],
Cell[428892, 10715, 396, 10, 22, "Print"],
Cell[429291, 10727, 434, 10, 24, "Print"],
Cell[429728, 10739, 45, 1, 22, "Print"],
Cell[429776, 10742, 3034, 79, 85, "Print"],
Cell[432813, 10823, 46, 1, 22, "Print"],
Cell[432862, 10826, 2369, 59, 69, "Print"],
Cell[435234, 10887, 374, 7, 24, "Print"],
Cell[435611, 10896, 180, 3, 24, "Print"],
Cell[435794, 10901, 266, 5, 22, "Print"],
Cell[436063, 10908, 303, 6, 22, "Print"],
Cell[436369, 10916, 102, 2, 22, "Print"],
Cell[436474, 10920, 161, 3, 22, "Print"],
Cell[436638, 10925, 394, 10, 22, "Print"],
Cell[437035, 10937, 396, 10, 22, "Print"],
Cell[437434, 10949, 434, 10, 24, "Print"],
Cell[437871, 10961, 45, 1, 22, "Print"],
Cell[437919, 10964, 3034, 79, 85, "Print"],
Cell[440956, 11045, 46, 1, 22, "Print"],
Cell[441005, 11048, 2373, 59, 69, "Print"],
Cell[443381, 11109, 374, 7, 24, "Print"],
Cell[443758, 11118, 182, 3, 24, "Print"],
Cell[443943, 11123, 266, 5, 22, "Print"],
Cell[444212, 11130, 303, 6, 24, "Print"],
Cell[444518, 11138, 49, 1, 22, "Print"],
Cell[444570, 11141, 102, 2, 22, "Print"],
Cell[444675, 11145, 161, 3, 22, "Print"],
Cell[444839, 11150, 396, 10, 22, "Print"],
Cell[445238, 11162, 394, 10, 22, "Print"],
Cell[445635, 11174, 435, 10, 24, "Print"],
Cell[446073, 11186, 45, 1, 22, "Print"],
Cell[446121, 11189, 2988, 79, 85, "Print"],
Cell[449112, 11270, 46, 1, 22, "Print"],
Cell[449161, 11273, 2372, 59, 69, "Print"],
Cell[451536, 11334, 373, 7, 24, "Print"],
Cell[451912, 11343, 182, 3, 24, "Print"],
Cell[452097, 11348, 270, 5, 24, "Print"],
Cell[452370, 11355, 303, 6, 24, "Print"],
Cell[452676, 11363, 49, 1, 22, "Print"],
Cell[452728, 11366, 49, 1, 22, "Print"],
Cell[452780, 11369, 49, 1, 22, "Print"],
Cell[452832, 11372, 231, 4, 22, "Print"],
Cell[453066, 11378, 366, 10, 77, "Print"],
Cell[453435, 11390, 46, 1, 22, "Print"],
Cell[453484, 11393, 2375, 59, 69, "Print"],
Cell[455862, 11454, 3443, 65, 325, "Print"],
Cell[459308, 11521, 363, 7, 24, "Print"],
Cell[459674, 11530, 78, 1, 22, "Print"],
Cell[459755, 11533, 91, 1, 22, "Print"],
Cell[459849, 11536, 80, 1, 22, "Print"],
Cell[459932, 11539, 91, 1, 22, "Print"],
Cell[460026, 11542, 1317, 27, 69, "Print"],
Cell[461346, 11571, 89, 1, 22, "Print"],
Cell[461438, 11574, 45, 1, 22, "Print"],
Cell[461486, 11577, 89, 1, 22, "Print"],
Cell[461578, 11580, 542, 14, 31, "Print"],
Cell[462123, 11596, 67, 1, 22, "Print"],
Cell[462193, 11599, 89, 1, 22, "Print"],
Cell[462285, 11602, 66, 1, 22, "Print"],
Cell[462354, 11605, 89, 1, 22, "Print"],
Cell[462446, 11608, 89, 1, 22, "Print"],
Cell[462538, 11611, 206, 4, 22, "Print"],
Cell[462747, 11617, 856, 20, 61, "Print"],
Cell[463606, 11639, 90, 1, 22, "Print"],
Cell[463699, 11642, 74, 1, 22, "Print"],
Cell[463776, 11645, 90, 1, 22, "Print"],
Cell[463869, 11648, 673, 14, 69, "Print"],
Cell[464545, 11664, 91, 1, 22, "Print"],
Cell[464639, 11667, 97, 2, 22, "Print"],
Cell[464739, 11671, 91, 1, 22, "Print"],
Cell[464833, 11674, 702, 15, 69, "Print"],
Cell[465538, 11691, 45, 1, 22, "Print"],
Cell[465586, 11694, 129, 2, 22, "Print"],
Cell[465718, 11698, 91, 1, 22, "Print"],
Cell[465812, 11701, 108, 2, 22, "Print"],
Cell[465923, 11705, 91, 1, 22, "Print"],
Cell[466017, 11708, 672, 14, 69, "Print"],
Cell[466692, 11724, 45, 1, 22, "Print"],
Cell[466740, 11727, 120, 2, 22, "Print"],
Cell[466863, 11731, 91, 1, 22, "Print"],
Cell[466957, 11734, 58, 1, 22, "Print"],
Cell[467018, 11737, 91, 1, 22, "Print"],
Cell[467112, 11740, 201, 4, 22, "Print"],
Cell[467316, 11746, 109, 2, 22, "Print"],
Cell[467428, 11750, 746, 17, 41, "Print"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[468235, 11774, 78, 1, 30, "Subsection"],

Cell[CellGroupData[{
Cell[468338, 11779, 65, 1, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[468428, 11784, 158, 5, 54, "Input"],
Cell[468589, 11791, 105, 2, 22, "Print"],
Cell[468697, 11795, 164, 3, 22, "Print"],
Cell[468864, 11800, 151, 3, 22, "Print"],
Cell[469018, 11805, 611, 13, 24, "Print"],
Cell[469632, 11820, 69, 1, 38, "Output"]
}, Open  ]],
Cell[469716, 11824, 79, 1, 39, "Input"],

Cell[CellGroupData[{
Cell[469820, 11829, 66, 1, 39, "Input"],
Cell[469889, 11832, 42, 1, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[469968, 11838, 202, 5, 69, "Input"],
Cell[470173, 11845, 179, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[470389, 11853, 190, 5, 69, "Input"],
Cell[470582, 11860, 177, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[470796, 11868, 245, 6, 54, "Input"],
Cell[471044, 11876, 180, 3, 21, "Message"],
Cell[471227, 11881, 98059, 2408, 182, 24837, 1500, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[569335, 14295, 61, 1, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[569421, 14300, 365, 18, 249, "Input"],
Cell[569789, 14320, 36, 1, 38, "Output"],
Cell[569828, 14323, 193, 3, 21, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[570058, 14331, 1078, 20, 549, "Input"],
Cell[571139, 14353, 110, 2, 22, "Print"],
Cell[571252, 14357, 155, 3, 22, "Print"],
Cell[571410, 14362, 110, 2, 22, "Print"],
Cell[571523, 14366, 157, 3, 22, "Print"],
Cell[571683, 14371, 67, 1, 22, "Print"],
Cell[571753, 14374, 83, 1, 22, "Print"],
Cell[571839, 14377, 99, 2, 22, "Print"],
Cell[571941, 14381, 99, 2, 22, "Print"],
Cell[572043, 14385, 99, 2, 22, "Print"],
Cell[572145, 14389, 51, 1, 22, "Print"],
Cell[572199, 14392, 36, 1, 22, "Print"],
Cell[572238, 14395, 99, 2, 22, "Print"],
Cell[572340, 14399, 630, 14, 31, "Print"],
Cell[572973, 14415, 45, 1, 22, "Print"],
Cell[573021, 14418, 592, 14, 33, "Print"],
Cell[573616, 14434, 45, 1, 22, "Print"],
Cell[573664, 14437, 657, 15, 31, "Print"],
Cell[574324, 14454, 45, 1, 22, "Print"],
Cell[574372, 14457, 46, 1, 22, "Print"],
Cell[574421, 14460, 201, 5, 22, "Print"],
Cell[574625, 14467, 45, 1, 22, "Print"],
Cell[574673, 14470, 99, 2, 22, "Print"],
Cell[574775, 14474, 45, 1, 22, "Print"],
Cell[574823, 14477, 216, 4, 22, "Print"],
Cell[575042, 14483, 374, 7, 24, "Print"],
Cell[575419, 14492, 150, 2, 22, "Print"],
Cell[575572, 14496, 102, 2, 22, "Print"],
Cell[575677, 14500, 159, 3, 22, "Print"],
Cell[575839, 14505, 830, 18, 22, "Print"],
Cell[576672, 14525, 396, 10, 22, "Print"],
Cell[577071, 14537, 394, 10, 22, "Print"],
Cell[577468, 14549, 412, 10, 22, "Print"],
Cell[577883, 14561, 45, 1, 22, "Print"],
Cell[577931, 14564, 2922, 79, 85, "Print"],
Cell[580856, 14645, 46, 1, 22, "Print"],
Cell[580905, 14648, 2016, 59, 69, "Print"],
Cell[582924, 14709, 372, 7, 24, "Print"],
Cell[583299, 14718, 180, 3, 24, "Print"],
Cell[583482, 14723, 268, 5, 22, "Print"],
Cell[583753, 14730, 297, 6, 22, "Print"],
Cell[584053, 14738, 102, 2, 22, "Print"],
Cell[584158, 14742, 159, 3, 22, "Print"],
Cell[584320, 14747, 396, 10, 22, "Print"],
Cell[584719, 14759, 396, 10, 22, "Print"],
Cell[585118, 14771, 412, 10, 22, "Print"],
Cell[585533, 14783, 45, 1, 22, "Print"],
Cell[585581, 14786, 2969, 79, 85, "Print"],
Cell[588553, 14867, 46, 1, 22, "Print"],
Cell[588602, 14870, 2363, 59, 69, "Print"],
Cell[590968, 14931, 373, 7, 24, "Print"],
Cell[591344, 14940, 181, 3, 24, "Print"],
Cell[591528, 14945, 269, 5, 22, "Print"],
Cell[591800, 14952, 298, 6, 22, "Print"],
Cell[592101, 14960, 102, 2, 22, "Print"],
Cell[592206, 14964, 159, 3, 22, "Print"],
Cell[592368, 14969, 832, 18, 22, "Print"],
Cell[593203, 14989, 396, 10, 22, "Print"],
Cell[593602, 15001, 396, 10, 22, "Print"],
Cell[594001, 15013, 414, 10, 22, "Print"],
Cell[594418, 15025, 45, 1, 22, "Print"],
Cell[594466, 15028, 3004, 79, 85, "Print"],
Cell[597473, 15109, 46, 1, 22, "Print"],
Cell[597522, 15112, 2374, 59, 69, "Print"],
Cell[599899, 15173, 374, 7, 24, "Print"],
Cell[600276, 15182, 180, 3, 24, "Print"],
Cell[600459, 15187, 256, 4, 22, "Print"],
Cell[600718, 15193, 297, 6, 22, "Print"],
Cell[601018, 15201, 102, 2, 22, "Print"],
Cell[601123, 15205, 159, 3, 22, "Print"],
Cell[601285, 15210, 832, 18, 22, "Print"],
Cell[602120, 15230, 396, 10, 22, "Print"],
Cell[602519, 15242, 396, 10, 22, "Print"],
Cell[602918, 15254, 412, 10, 22, "Print"],
Cell[603333, 15266, 45, 1, 22, "Print"],
Cell[603381, 15269, 3016, 79, 85, "Print"],
Cell[606400, 15350, 46, 1, 22, "Print"],
Cell[606449, 15353, 2365, 59, 69, "Print"],
Cell[608817, 15414, 373, 7, 24, "Print"],
Cell[609193, 15423, 181, 3, 24, "Print"],
Cell[609377, 15428, 264, 5, 22, "Print"],
Cell[609644, 15435, 298, 6, 22, "Print"],
Cell[609945, 15443, 102, 2, 22, "Print"],
Cell[610050, 15447, 159, 3, 22, "Print"],
Cell[610212, 15452, 394, 10, 22, "Print"],
Cell[610609, 15464, 396, 10, 22, "Print"],
Cell[611008, 15476, 414, 10, 22, "Print"],
Cell[611425, 15488, 45, 1, 22, "Print"],
Cell[611473, 15491, 3018, 79, 85, "Print"],
Cell[614494, 15572, 46, 1, 22, "Print"],
Cell[614543, 15575, 2372, 59, 69, "Print"],
Cell[616918, 15636, 374, 7, 24, "Print"],
Cell[617295, 15645, 181, 3, 24, "Print"],
Cell[617479, 15650, 268, 5, 22, "Print"],
Cell[617750, 15657, 299, 6, 22, "Print"],
Cell[618052, 15665, 102, 2, 22, "Print"],
Cell[618157, 15669, 159, 3, 22, "Print"],
Cell[618319, 15674, 396, 10, 22, "Print"],
Cell[618718, 15686, 394, 10, 22, "Print"],
Cell[619115, 15698, 414, 10, 22, "Print"],
Cell[619532, 15710, 45, 1, 22, "Print"],
Cell[619580, 15713, 3021, 79, 85, "Print"],
Cell[622604, 15794, 46, 1, 22, "Print"],
Cell[622653, 15797, 2364, 59, 69, "Print"],
Cell[625020, 15858, 374, 7, 24, "Print"],
Cell[625397, 15867, 180, 3, 24, "Print"],
Cell[625580, 15872, 265, 5, 22, "Print"],
Cell[625848, 15879, 299, 6, 22, "Print"],
Cell[626150, 15887, 102, 2, 22, "Print"],
Cell[626255, 15891, 159, 3, 22, "Print"],
Cell[626417, 15896, 396, 10, 22, "Print"],
Cell[626816, 15908, 396, 10, 22, "Print"],
Cell[627215, 15920, 418, 10, 22, "Print"],
Cell[627636, 15932, 45, 1, 22, "Print"],
Cell[627684, 15935, 3023, 79, 85, "Print"],
Cell[630710, 16016, 46, 1, 22, "Print"],
Cell[630759, 16019, 2374, 59, 69, "Print"],
Cell[633136, 16080, 373, 7, 24, "Print"],
Cell[633512, 16089, 181, 3, 24, "Print"],
Cell[633696, 16094, 266, 5, 22, "Print"],
Cell[633965, 16101, 302, 6, 22, "Print"],
Cell[634270, 16109, 102, 2, 22, "Print"],
Cell[634375, 16113, 159, 3, 22, "Print"],
Cell[634537, 16118, 396, 10, 22, "Print"],
Cell[634936, 16130, 396, 10, 22, "Print"],
Cell[635335, 16142, 416, 10, 22, "Print"],
Cell[635754, 16154, 45, 1, 22, "Print"],
Cell[635802, 16157, 3021, 79, 85, "Print"],
Cell[638826, 16238, 46, 1, 22, "Print"],
Cell[638875, 16241, 2361, 59, 69, "Print"],
Cell[641239, 16302, 370, 7, 24, "Print"],
Cell[641612, 16311, 180, 3, 24, "Print"],
Cell[641795, 16316, 265, 5, 22, "Print"],
Cell[642063, 16323, 300, 6, 22, "Print"],
Cell[642366, 16331, 102, 2, 22, "Print"],
Cell[642471, 16335, 159, 3, 22, "Print"],
Cell[642633, 16340, 396, 10, 22, "Print"],
Cell[643032, 16352, 396, 10, 22, "Print"],
Cell[643431, 16364, 418, 10, 22, "Print"],
Cell[643852, 16376, 45, 1, 22, "Print"],
Cell[643900, 16379, 3020, 79, 85, "Print"],
Cell[646923, 16460, 46, 1, 22, "Print"],
Cell[646972, 16463, 2365, 59, 69, "Print"],
Cell[649340, 16524, 373, 7, 24, "Print"],
Cell[649716, 16533, 181, 3, 24, "Print"],
Cell[649900, 16538, 257, 4, 22, "Print"],
Cell[650160, 16544, 301, 6, 22, "Print"],
Cell[650464, 16552, 102, 2, 22, "Print"],
Cell[650569, 16556, 161, 3, 22, "Print"],
Cell[650733, 16561, 396, 10, 22, "Print"],
Cell[651132, 16573, 396, 10, 22, "Print"],
Cell[651531, 16585, 418, 10, 22, "Print"],
Cell[651952, 16597, 45, 1, 22, "Print"],
Cell[652000, 16600, 3021, 79, 85, "Print"],
Cell[655024, 16681, 46, 1, 22, "Print"],
Cell[655073, 16684, 2364, 59, 69, "Print"],
Cell[657440, 16745, 372, 7, 24, "Print"],
Cell[657815, 16754, 180, 3, 24, "Print"],
Cell[657998, 16759, 265, 5, 22, "Print"],
Cell[658266, 16766, 301, 6, 22, "Print"],
Cell[658570, 16774, 102, 2, 22, "Print"],
Cell[658675, 16778, 161, 3, 22, "Print"],
Cell[658839, 16783, 396, 10, 22, "Print"],
Cell[659238, 16795, 396, 10, 22, "Print"],
Cell[659637, 16807, 420, 10, 22, "Print"],
Cell[660060, 16819, 45, 1, 22, "Print"],
Cell[660108, 16822, 3025, 79, 85, "Print"],
Cell[663136, 16903, 46, 1, 22, "Print"],
Cell[663185, 16906, 2368, 59, 69, "Print"],
Cell[665556, 16967, 373, 7, 24, "Print"],
Cell[665932, 16976, 181, 3, 24, "Print"],
Cell[666116, 16981, 266, 5, 22, "Print"],
Cell[666385, 16988, 302, 6, 22, "Print"],
Cell[666690, 16996, 102, 2, 22, "Print"],
Cell[666795, 17000, 161, 3, 22, "Print"],
Cell[666959, 17005, 396, 10, 22, "Print"],
Cell[667358, 17017, 396, 10, 22, "Print"],
Cell[667757, 17029, 422, 10, 22, "Print"],
Cell[668182, 17041, 45, 1, 22, "Print"],
Cell[668230, 17044, 3028, 79, 85, "Print"],
Cell[671261, 17125, 46, 1, 22, "Print"],
Cell[671310, 17128, 2370, 59, 69, "Print"],
Cell[673683, 17189, 373, 7, 24, "Print"],
Cell[674059, 17198, 181, 3, 24, "Print"],
Cell[674243, 17203, 263, 5, 22, "Print"],
Cell[674509, 17210, 305, 6, 22, "Print"],
Cell[674817, 17218, 102, 2, 22, "Print"],
Cell[674922, 17222, 161, 3, 22, "Print"],
Cell[675086, 17227, 396, 10, 22, "Print"],
Cell[675485, 17239, 396, 10, 22, "Print"],
Cell[675884, 17251, 434, 10, 24, "Print"],
Cell[676321, 17263, 45, 1, 22, "Print"],
Cell[676369, 17266, 3038, 79, 85, "Print"],
Cell[679410, 17347, 46, 1, 22, "Print"],
Cell[679459, 17350, 2366, 59, 69, "Print"],
Cell[681828, 17411, 373, 7, 24, "Print"],
Cell[682204, 17420, 182, 3, 24, "Print"],
Cell[682389, 17425, 262, 4, 24, "Print"],
Cell[682654, 17431, 304, 6, 24, "Print"],
Cell[682961, 17439, 102, 2, 22, "Print"],
Cell[683066, 17443, 161, 3, 22, "Print"],
Cell[683230, 17448, 396, 10, 22, "Print"],
Cell[683629, 17460, 396, 10, 22, "Print"],
Cell[684028, 17472, 432, 10, 24, "Print"],
Cell[684463, 17484, 45, 1, 22, "Print"],
Cell[684511, 17487, 2971, 79, 85, "Print"],
Cell[687485, 17568, 46, 1, 22, "Print"],
Cell[687534, 17571, 2369, 59, 69, "Print"],
Cell[689906, 17632, 373, 7, 24, "Print"],
Cell[690282, 17641, 180, 3, 24, "Print"],
Cell[690465, 17646, 272, 5, 24, "Print"],
Cell[690740, 17653, 303, 6, 24, "Print"],
Cell[691046, 17661, 49, 1, 22, "Print"],
Cell[691098, 17664, 49, 1, 22, "Print"],
Cell[691150, 17667, 49, 1, 22, "Print"],
Cell[691202, 17670, 231, 4, 22, "Print"],
Cell[691436, 17676, 385, 10, 75, "Print"],
Cell[691824, 17688, 46, 1, 22, "Print"],
Cell[691873, 17691, 2362, 59, 69, "Print"],
Cell[694238, 17752, 2772, 53, 261, "Print"],
Cell[697013, 17807, 373, 7, 24, "Print"],
Cell[697389, 17816, 373, 7, 24, "Print"],
Cell[697765, 17825, 373, 7, 24, "Print"],
Cell[698141, 17834, 373, 7, 24, "Print"],
Cell[698517, 17843, 373, 7, 24, "Print"],
Cell[698893, 17852, 373, 7, 24, "Print"],
Cell[699269, 17861, 373, 7, 24, "Print"],
Cell[699645, 17870, 373, 7, 24, "Print"],
Cell[700021, 17879, 373, 7, 24, "Print"],
Cell[700397, 17888, 373, 7, 24, "Print"],
Cell[700773, 17897, 66, 1, 22, "Print"],
Cell[700842, 17900, 91, 1, 22, "Print"],
Cell[700936, 17903, 80, 1, 22, "Print"],
Cell[701019, 17906, 91, 1, 22, "Print"],
Cell[701113, 17909, 1356, 27, 67, "Print"],
Cell[702472, 17938, 89, 1, 22, "Print"],
Cell[702564, 17941, 45, 1, 22, "Print"],
Cell[702612, 17944, 89, 1, 22, "Print"],
Cell[702704, 17947, 541, 14, 31, "Print"],
Cell[703248, 17963, 67, 1, 22, "Print"],
Cell[703318, 17966, 89, 1, 22, "Print"],
Cell[703410, 17969, 66, 1, 22, "Print"],
Cell[703479, 17972, 89, 1, 22, "Print"],
Cell[703571, 17975, 89, 1, 22, "Print"],
Cell[703663, 17978, 206, 4, 22, "Print"],
Cell[703872, 17984, 854, 20, 61, "Print"],
Cell[704729, 18006, 90, 1, 22, "Print"],
Cell[704822, 18009, 74, 1, 22, "Print"],
Cell[704899, 18012, 90, 1, 22, "Print"],
Cell[704992, 18015, 679, 15, 69, "Print"],
Cell[705674, 18032, 91, 1, 22, "Print"],
Cell[705768, 18035, 97, 2, 22, "Print"],
Cell[705868, 18039, 91, 1, 22, "Print"],
Cell[705962, 18042, 702, 15, 69, "Print"],
Cell[706667, 18059, 45, 1, 22, "Print"],
Cell[706715, 18062, 128, 2, 22, "Print"],
Cell[706846, 18066, 91, 1, 22, "Print"],
Cell[706940, 18069, 108, 2, 22, "Print"],
Cell[707051, 18073, 91, 1, 22, "Print"],
Cell[707145, 18076, 652, 13, 69, "Print"],
Cell[707800, 18091, 45, 1, 22, "Print"],
Cell[707848, 18094, 121, 2, 22, "Print"],
Cell[707972, 18098, 91, 1, 22, "Print"],
Cell[708066, 18101, 58, 1, 22, "Print"],
Cell[708127, 18104, 91, 1, 22, "Print"],
Cell[708221, 18107, 201, 4, 22, "Print"],
Cell[708425, 18113, 109, 2, 22, "Print"],
Cell[708537, 18117, 746, 17, 41, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[709344, 18141, 69, 1, 46, "Subsection"],

Cell[CellGroupData[{
Cell[709438, 18146, 65, 1, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[709528, 18151, 158, 5, 72, "Input"],
Cell[709689, 18158, 70, 1, 26, "Output"]
}, Open  ]],
Cell[709774, 18162, 79, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[709878, 18167, 66, 1, 27, "Input"],
Cell[709947, 18170, 42, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[710026, 18176, 202, 5, 72, "Input"],
Cell[710231, 18183, 179, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[710447, 18191, 190, 5, 57, "Input"],
Cell[710640, 18198, 177, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[710854, 18206, 253, 6, 87, "Input"],
Cell[711110, 18214, 354, 5, 49, "Message"],
Cell[711467, 18221, 102250, 2460, 183, 24848, 1500, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[813766, 20687, 61, 1, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[813852, 20692, 353, 17, 237, "Input"],
Cell[814208, 20711, 59, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[814304, 20717, 1043, 45, 672, "Input"],
Cell[815350, 20764, 110, 2, 23, "Print",
  CellTags->""],
Cell[815463, 20768, 155, 3, 23, "Print",
  CellTags->""],
Cell[815621, 20773, 110, 2, 23, "Print",
  CellTags->""],
Cell[815734, 20777, 157, 3, 23, "Print",
  CellTags->""],
Cell[815894, 20782, 67, 1, 23, "Print",
  CellTags->""],
Cell[815964, 20785, 83, 1, 23, "Print",
  CellTags->""],
Cell[816050, 20788, 159, 3, 23, "Print",
  CellTags->""],
Cell[816212, 20793, 159, 3, 23, "Print",
  CellTags->""],
Cell[816374, 20798, 159, 3, 23, "Print",
  CellTags->""],
Cell[816536, 20803, 157, 3, 23, "Print",
  CellTags->""],
Cell[816696, 20808, 42, 1, 27, "Output",
  CellTags->""]
}, Closed]],
Cell[816753, 20812, 18, 0, 24, "Input"],

Cell[CellGroupData[{
Cell[816796, 20816, 25, 0, 27, "Input"],
Cell[816824, 20818, 44, 1, 26, "Output"]
}, Open  ]],
Cell[816883, 20822, 40, 0, 27, "Input"],

Cell[CellGroupData[{
Cell[816948, 20826, 32, 0, 27, "Input"],
Cell[816983, 20828, 15151, 219, 1025, "Output",
  CellTags->""]
}, Closed]],

Cell[CellGroupData[{
Cell[832171, 21052, 32, 0, 24, "Input"],
Cell[832206, 21054, 42, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[832285, 21060, 75, 3, 42, "Input"],
Cell[832363, 21065, 36, 1, 26, "Output"]
}, Open  ]],
Cell[832414, 21069, 43, 0, 27, "Input"],
Cell[832460, 21071, 73, 0, 27, "Input"],

Cell[CellGroupData[{
Cell[832558, 21075, 365, 11, 162, "Input"],
Cell[832926, 21088, 1595, 38, 65, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[834582, 21133, 69, 1, 30, "Subsection"],

Cell[CellGroupData[{
Cell[834676, 21138, 65, 1, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[834766, 21143, 158, 5, 42, "Input"],
Cell[834927, 21150, 69, 1, 27, "Output"]
}, Open  ]],
Cell[835011, 21154, 79, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[835115, 21159, 66, 1, 27, "Input"],
Cell[835184, 21162, 42, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[835263, 21168, 202, 5, 57, "Input"],
Cell[835468, 21175, 179, 3, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[835684, 21183, 190, 5, 57, "Input"],
Cell[835877, 21190, 177, 3, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[836091, 21198, 253, 6, 57, "Input"],
Cell[836347, 21206, 100760, 2442, 183, 24840, 1500, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[937156, 23654, 61, 1, 28, "Subsubsection"],
Cell[937220, 23657, 341, 16, 222, "Input"],

Cell[CellGroupData[{
Cell[937586, 23677, 1044, 45, 672, "Input"],
Cell[938633, 23724, 110, 2, 37, "Print"],
Cell[938746, 23728, 155, 3, 22, "Print"],
Cell[938904, 23733, 110, 2, 37, "Print"],
Cell[939017, 23737, 157, 3, 22, "Print"],
Cell[939177, 23742, 67, 1, 22, "Print"],
Cell[939247, 23745, 83, 1, 22, "Print"],
Cell[939333, 23748, 99, 2, 22, "Print"],
Cell[939435, 23752, 99, 2, 22, "Print"],
Cell[939537, 23756, 99, 2, 22, "Print"],
Cell[939639, 23760, 51, 1, 22, "Print"],
Cell[939693, 23763, 39, 1, 22, "Print"],
Cell[939735, 23766, 99, 2, 22, "Print"],
Cell[939837, 23770, 630, 14, 31, "Print"],
Cell[940470, 23786, 45, 1, 22, "Print"],
Cell[940518, 23789, 592, 14, 33, "Print"],
Cell[941113, 23805, 45, 1, 22, "Print"],
Cell[941161, 23808, 657, 15, 31, "Print"],
Cell[941821, 23825, 45, 1, 22, "Print"],
Cell[941869, 23828, 46, 1, 22, "Print"],
Cell[941918, 23831, 201, 5, 22, "Print"],
Cell[942122, 23838, 45, 1, 22, "Print"],
Cell[942170, 23841, 99, 2, 22, "Print"],
Cell[942272, 23845, 45, 1, 22, "Print"],
Cell[942320, 23848, 216, 4, 22, "Print"],
Cell[942539, 23854, 374, 7, 24, "Print"],
Cell[942916, 23863, 152, 2, 22, "Print"],
Cell[943071, 23867, 102, 2, 22, "Print"],
Cell[943176, 23871, 159, 3, 22, "Print"],
Cell[943338, 23876, 42, 1, 26, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[943429, 23883, 35, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[943489, 23887, 41, 1, 27, "Input",
  CellTags->""],
Cell[943533, 23890, 60, 2, 26, "Output",
  CellTags->""]
}, Open  ]],
Cell[943608, 23895, 56, 1, 27, "Input",
  CellTags->""],

Cell[CellGroupData[{
Cell[943689, 23900, 48, 1, 27, "Input",
  CellTags->""],
Cell[943740, 23903, 15657, 219, 1029, "Output",
  CellTags->""]
}, Open  ]],

Cell[CellGroupData[{
Cell[959434, 24127, 32, 0, 27, "Input"],
Cell[959469, 24129, 42, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[959548, 24135, 91, 4, 42, "Input",
  CellTags->""],
Cell[959642, 24141, 52, 2, 26, "Output",
  CellTags->""]
}, Open  ]],
Cell[959709, 24146, 59, 1, 27, "Input",
  CellTags->""],
Cell[959771, 24149, 89, 1, 27, "Input",
  CellTags->""],

Cell[CellGroupData[{
Cell[959885, 24154, 381, 12, 162, "Input",
  CellTags->""],
Cell[960269, 24168, 1611, 39, 65, "Output",
  CellTags->""]
}, Open  ]],
Cell[961895, 24210, 18, 0, 27, "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[961962, 24216, 85, 2, 30, "Subsection",
  CellTags->""],

Cell[CellGroupData[{
Cell[962072, 24222, 65, 1, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[962162, 24227, 158, 5, 42, "Input"],
Cell[962323, 24234, 69, 1, 27, "Output"]
}, Open  ]],
Cell[962407, 24238, 79, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[962511, 24243, 66, 1, 27, "Input"],
Cell[962580, 24246, 42, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[962659, 24252, 202, 5, 57, "Input"],
Cell[962864, 24259, 179, 3, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[963080, 24267, 190, 5, 57, "Input"],
Cell[963273, 24274, 177, 3, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[963487, 24282, 253, 6, 57, "Input"],
Cell[963743, 24290, 99395, 2425, 183, 24832, 1500, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1063187, 26721, 61, 1, 28, "Subsubsection"],
Cell[1063251, 26724, 341, 16, 222, "Input"],

Cell[CellGroupData[{
Cell[1063617, 26744, 1045, 45, 672, "Input"],
Cell[1064665, 26791, 110, 2, 23, "Print",
  CellTags->""],
Cell[1064778, 26795, 157, 3, 23, "Print",
  CellTags->""],
Cell[1064938, 26800, 110, 2, 23, "Print",
  CellTags->""],
Cell[1065051, 26804, 157, 3, 23, "Print",
  CellTags->""],
Cell[1065211, 26809, 67, 1, 23, "Print",
  CellTags->""],
Cell[1065281, 26812, 83, 1, 23, "Print",
  CellTags->""],
Cell[1065367, 26815, 99, 2, 23, "Print",
  CellTags->""],
Cell[1065469, 26819, 99, 2, 23, "Print",
  CellTags->""],
Cell[1065571, 26823, 99, 2, 23, "Print",
  CellTags->""],
Cell[1065673, 26827, 51, 1, 23, "Print",
  CellTags->""],
Cell[1065727, 26830, 36, 1, 23, "Print",
  CellTags->""],
Cell[1065766, 26833, 99, 2, 23, "Print",
  CellTags->""],
Cell[1065868, 26837, 630, 14, 31, "Print",
  CellTags->""],
Cell[1066501, 26853, 45, 1, 23, "Print",
  CellTags->""],
Cell[1066549, 26856, 595, 14, 33, "Print",
  CellTags->""],
Cell[1067147, 26872, 45, 1, 23, "Print",
  CellTags->""],
Cell[1067195, 26875, 657, 15, 31, "Print",
  CellTags->""],
Cell[1067855, 26892, 45, 1, 23, "Print",
  CellTags->""],
Cell[1067903, 26895, 46, 1, 23, "Print",
  CellTags->""],
Cell[1067952, 26898, 201, 5, 23, "Print",
  CellTags->""],
Cell[1068156, 26905, 45, 1, 23, "Print",
  CellTags->""],
Cell[1068204, 26908, 99, 2, 23, "Print",
  CellTags->""],
Cell[1068306, 26912, 45, 1, 23, "Print",
  CellTags->""],
Cell[1068354, 26915, 216, 4, 23, "Print",
  CellTags->""],
Cell[1068573, 26921, 374, 7, 25, "Print",
  CellTags->""],
Cell[1068950, 26930, 42, 1, 27, "Output",
  CellTags->""]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1069041, 26937, 35, 0, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[1069101, 26941, 25, 0, 27, "Input"],
Cell[1069129, 26943, 44, 1, 26, "Output"]
}, Open  ]],
Cell[1069188, 26947, 40, 0, 27, "Input"],

Cell[CellGroupData[{
Cell[1069253, 26951, 32, 0, 27, "Input"],
Cell[1069288, 26953, 15634, 218, 1029, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1084959, 27176, 32, 0, 27, "Input"],
Cell[1084994, 27178, 42, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1085073, 27184, 75, 3, 42, "Input"],
Cell[1085151, 27189, 36, 1, 26, "Output"]
}, Open  ]],
Cell[1085202, 27193, 43, 0, 27, "Input"],
Cell[1085248, 27195, 73, 0, 27, "Input"],

Cell[CellGroupData[{
Cell[1085346, 27199, 365, 11, 162, "Input"],
Cell[1085714, 27212, 1593, 38, 65, "Output"]
}, Open  ]],
Cell[1087322, 27253, 18, 0, 27, "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1087389, 27259, 30, 0, 30, "Subsection"],

Cell[CellGroupData[{
Cell[1087444, 27263, 24, 0, 27, "Input"],
Cell[1087471, 27265, 1593, 38, 65, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1089101, 27308, 23, 0, 27, "Input"],
Cell[1089127, 27310, 1597, 38, 65, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1090761, 27353, 25, 0, 27, "Input"],
Cell[1090789, 27355, 1591, 38, 65, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1092417, 27398, 49, 1, 27, "Input",
  CellTags->""],
Cell[1092469, 27401, 1595, 38, 65, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1094101, 27444, 49, 1, 27, "Input",
  CellTags->""],
Cell[1094153, 27447, 1611, 39, 65, "Output",
  CellTags->""]
}, Open  ]],

Cell[CellGroupData[{
Cell[1095801, 27491, 33, 0, 27, "Input"],
Cell[1095837, 27493, 1593, 38, 65, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1097467, 27536, 29, 0, 27, "Input"],
Cell[1097499, 27538, 1592, 38, 65, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1099128, 27581, 145, 5, 27, "Input"],
Cell[1099276, 27588, 1589, 38, 65, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

