(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1771161,      60511]*)
(*NotebookOutlinePosition[   1773183,      60570]*)
(*  CellTagsIndexPosition[   1772907,      60560]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    RowBox[{\(\(\(@\)\(ARTICLE\)\) {Scott : 
            1987, \[IndentingNewLine]AUTHOR = {Scott, 
              L . O . }, \[IndentingNewLine]TITLE = {Option\ Pricing\ when\ \
the\ Variance\ Changes\ \(Randomly : \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \
\ Theory\), Estimation, and\ an\ Application}, \[IndentingNewLine]JOURNAL = 
            JoFQA, \[IndentingNewLine]VOLUME = {22}, \[IndentingNewLine]PAGES \
= {\(419--\) 438}, \[IndentingNewLine]YEAR = 1987}\), "\[IndentingNewLine]", 
      "\[IndentingNewLine]"}], "\[IndentingNewLine]", \(\(\(@\)\(TECHREPORT\)\
\) {Singer : 
          2006  c, \[IndentingNewLine]AUTHOR = {Singer, \(\(H\)\(.\)\)}, \
\[IndentingNewLine]TITLE = {{Continuous - 
                Discrete\ Unscented\ Kalman\ Filtering}}, \
\[IndentingNewLine]INSTITUTION = {{FernUniversit \*"\\\"" 
                at\ in\ Hagen}}, \[IndentingNewLine]TYPE = {{Diskussionsbeitr \
\*"\\\"" age\ Fachbereich\ Wirtschaftswissenschaft}}, \[IndentingNewLine]NOTE \
= {\(\(http\)\(:\)\) // 
              www . fernuni - \(\(\(\(hagen . de/FBWIWI\)/forschung\)/
                      beitraege\)/pdf\)/
                  db384 . 
                    pdf}, \[IndentingNewLine]NUMBER = {384}, \
\[IndentingNewLine]YEAR = {2006}}\), "\[IndentingNewLine]", 
    RowBox[{
      StyleBox[\(\(=\)\(\ \)\(UKF . tex\)\),
        FontColor->RGBColor[0, 1, 0]], "\[IndentingNewLine]", 
      "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
    RowBox[{\(\(\(@\)\(TECHREPORT\)\) {Singer : 
            2006  f, \[IndentingNewLine]AUTHOR = {Singer, \(\(H\)\(.\)\)}, \
\[IndentingNewLine]TITLE = {{Generalized\ Gauss - 
                  Hermite\ Filtering\ for\ Multivariate\ Diffusion\ \
Processes}}, \[IndentingNewLine]INSTITUTION = {{FernUniversit \*"\\\"" 
                  at\ in\ Hagen}}, \[IndentingNewLine]TYPE = \
{{Diskussionsbeitr \*"\\\"" 
                  age\ Fachbereich\ Wirtschaftswissenschaft}}, \
\[IndentingNewLine]NOTE = {\(\(http\)\(:\)\) // 
                www . fernuni - \(\(\(\(hagen . de/FBWIWI\)/forschung\)/
                        beitraege\)/pdf\)/
                    db402 . 
                      pdf}, \[IndentingNewLine]NUMBER = {402}, \
\[IndentingNewLine]YEAR = {2006}}\), " "}], "\[IndentingNewLine]", 
    RowBox[{
      StyleBox[\(\(=\)\(\ \)\(GGHF . pdf\)\),
        FontColor->RGBColor[0, 1, 0]], "\[IndentingNewLine]", 
      "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
    RowBox[{\(\(\(@\)\(ARTICLE\)\) {Singer : 
            2003  a, \[IndentingNewLine]AUTHOR = {Singer, \(\(H\)\(.\)\)}, \
\[IndentingNewLine]TITLE = {{Simulated\ Maximum\ Likelihood\ in\ Nonlinear\ \
Continuous - 
                  Discrete\ State\ Space\ \(Models : \[IndentingNewLine]\ \ \ \
\ \ \ Importance\ Sampling\ by\ Approximate\ Smoothing\)}}, \
\[IndentingNewLine]JOURNAL = {Computational\ Statistics}, \
\[IndentingNewLine]VOLUME = {18, 
              1}, \[IndentingNewLine]PAGES = {\(79--\) 
                106}, \[IndentingNewLine]YEAR = {2003}}\), 
      " "}], "\[IndentingNewLine]", 
    RowBox[{"=", " ", 
      StyleBox[\(SML . pdf\),
        FontColor->RGBColor[0, 1, 0]]}]}], "Input",
  PageWidth->Infinity,
  FontSize->14,
  FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell["\<\
Stochastic Volatility  (Scott, 1987) 

Model:
 dS = mue S dt + sigma S dW ;
 d log S = (mue-sigma^2/2) dt + sigma dW ;     
 d sigma = lambda (sigma-sigma0) dt + gamma dV;
 (dW,dV) = rho;\
\>", "Section",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["load packages", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \($Path\)], "Input",
  FontSize->14],

Cell[BoxData[
    \({"/Applications/Mathematica 5.2.app/AddOns/JLink", 
      "/Applications/Mathematica 5.2.app/AddOns/NETLink", 
      "/Users/hermannsinger/Library/Mathematica/Kernel", 
      "/Users/hermannsinger/Library/Mathematica/Autoload", 
      "/Users/hermannsinger/Library/Mathematica/Applications", 
      "/Library/Mathematica/Kernel", "/Library/Mathematica/Autoload", 
      "/Library/Mathematica/Applications", ".", "/Users/hermannsinger", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages/StartUp", 
      "/Applications/Mathematica 5.2.app/AddOns/Autoload", 
      "/Applications/Mathematica 5.2.app/AddOns/Applications", 
      "/Applications/Mathematica 5.2.app/AddOns/ExtraPackages", 
      "/Applications/Mathematica 5.2.app/SystemFiles/Graphics/Packages", 
      "/Applications/Mathematica 5.2.app/Configuration/Kernel", "/SDE/", 
      "/SDE/code/"}\)], "Output",
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Unprotect[RungeKutta];

<<code`LSD`
<<code`Kronecker`
<<Kuba.Impl.m
<<Kalman.exakt.impl.m\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Remove::"rmnsm"\), \(\(:\)\(\ \)\), "\<\"There are no symbols \
matching \\\"\\!\\(\\\"code`LSD`Private`*\\\"\\)\\\". \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Remove::rmnsm\\\"]\\)\"\>"}]], \
"Message",
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Remove::"rmnsm"\), \(\(:\)\(\ \)\), "\<\"There are no symbols \
matching \\\"\\!\\(\\\"code`Kronecker`Private`*\\\"\\)\\\". \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Remove::rmnsm\\\"]\\)\"\>"}]], \
"Message",
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Remove::"rmnsm"\), \(\(:\)\(\ \)\), "\<\"There are no symbols \
matching \\\"\\!\\(\\\"code`KernDichte`Private`*\\\"\\)\\\". \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Remove::rmnsm\\\"]\\)\"\>"}]], \
"Message",
  FontSize->14],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Remove :: \\\"rmnsm\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message",
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomMultinomial\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message",
  FontSize->14],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomMultinomial\\) in \\!\\(RandomMultinomial[\\(\\(xij_, pij_, n_\\)\
\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message",
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomNumbers\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\
\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message",
  FontSize->14],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomNumbers\\) in \\!\\(RandomNumbers[\\(\\(\\(\\({x1_, x2_, \
dx_}\\)\\), density_, n_\\)\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message",
  FontSize->14]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["System functions", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["Clear[S,t,r,lambda,sigma,sigma0,gamma,rho];", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
drift//Clear
drift[{S_,sigma_},{t_},
\t{r_,lambda_,sigma0_,gamma_,rho_}] := {r S, lambda(sigma-sigma0)}\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? drift\)], "Input",
  FontSize->14],

Cell["Global`drift", "Print",
  CellTags->"Info3417436483-8985227"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(drift[{S_, sigma_}, {t_}, {r_, lambda_, sigma0_, gamma_, 
                        rho_}] := {r\ S, lambda\ \((sigma - sigma0)\)}\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "drift"],
      Editable->False]], "Print",
  CellTags->"Info3417436483-8985227"]
}, Open  ]],

Cell[CellGroupData[{

Cell["drift[{S,sigma},{t},{rr,lambda,sigma0,gamma,rho}]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({rr\ S, lambda\ \((sigma - sigma0)\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Q={{1,rho},{rho,1}};
Q2 = Q//CholeskyDecomposition//Transpose
Q2.Transpose[Q2]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{1, 0}, {rho, \@\(1 - rho\ Conjugate[rho]\)}}\)], "Output"],

Cell[BoxData[
    \({{1, rho}, {rho, 1 + rho\^2 - rho\ Conjugate[rho]}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
diffusion//Clear
diffusion[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}] =
   {{sigma S,0},{0,gamma}}.Q2\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{S\ sigma, 0}, {gamma\ rho, 
        gamma\ \@\(1 - rho\ Conjugate[rho]\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["diffusion[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma,rho_}]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{S_\ sigma_, 0}, {gamma\ rho_, 
        gamma\ \@\(1 - Conjugate[rho_]\ rho_\)}}\)], "Output"]
}, Open  ]],

Cell["\<\
Omega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}]:=
Module[{g},
g = diffusion[{S,sigma},{t},{r,lambda,sigma0,gamma,rho}];
g.Transpose[g]
]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
Omega[{S,sigma},{t_},{r,lambda,sigma0,gamma,rho}]//MatrixForm\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2"},
              {"1", \(S\^2\ sigma\^2\), \(gamma\ rho\ S\ sigma\)},
              {
                "2", \(gamma\ rho\ S\ sigma\), \(gamma\^2\ rho\^2 + 
                  gamma\^2\ \((1 - rho\ Conjugate[rho])\)\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{{sigma,0},{0,gamma}}.Q.Transpose[{{sigma \
S,0},{0,gamma}}]//MatrixForm\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2"},
              {"1", \(S\ sigma\^2\), \(gamma\ rho\ sigma\)},
              {"2", \(gamma\ rho\ S\ sigma\), \(gamma\^2\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell["\<\
h//Clear
h[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}] := {S};\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
R//Clear
R[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}] = {{10.^-4}}\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{0.0001`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["R[{1,2},{t_},{r_,lambda_,sigma0_,gamma_,rho_}]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{0.0001`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
M0 = { 4,.2};

S0 = {{1,0},
      {0,  .01}}//N;
      
S01 = Inverse[S0];

p0//Clear
p0[{S_,sigma_},t_,Theta_] := GaussDichte[{S,sigma},{M0,S0,S01}];

Mue[  {t_},{r_,lambda_,sigma0_,gamma_,rho_}] = M0

Sigma[{t_},{r_,lambda_,sigma0_,gamma_,rho_}] = S0\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({4, 0.2`}\)], "Output"],

Cell[BoxData[
    \({{1.`, 0.`}, {0.`, 0.01`}}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Jacobians", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Clear[Jacobif,S,sigma];
Jacobif[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}] = 
\tOuter[D,drift[{S,sigma},{t},{r,lambda,sigma0,gamma,rho}],{S,sigma}]\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{r, 0}, {0, lambda}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[DDf,S,sigma];
DDf[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}] = 
\tOuter[D,Jacobif[{S,sigma},{t},{r,lambda,sigma0,gamma,rho}],
\t\t{S,sigma}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[DDf,S,sigma];
DDf[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}] = 
\tOuter[D,Jacobif[{S,sigma},{t},{r,lambda,sigma0,gamma,rho}],
\t\t{S,sigma}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[Jacobig,S,sigma];
Jacobig[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}] = 
\tOuter[D,diffusion[{S,sigma},{t},{r,lambda,sigma0,gamma,rho}],{S,sigma}]\
\>\
", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{sigma, S}, {0, 0}}, {{0, 0}, {0, 0}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Jacobig[{S,sigma},{t},{r,lambda,sigma0,gamma,rho}][[2//Range,1,2//\
Range]]
Jacobig[{S,sigma},{t},{r,lambda,sigma0,gamma,rho}][[2//Range,2,2//Range]]\
\>\
", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{sigma, S}, {0, 0}}\)], "Output"],

Cell[BoxData[
    \({{0, 0}, {0, 0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Jacobih//Clear
Jacobih[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_,rho_}] = 
\tOuter[D,h[{S,sigma},{t},{r,lambda,sigma0,gamma,rho}],{S,sigma}]\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{1, 0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["??Jacobih", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["Global`Jacobih", "Print",
  CellTags->"Info3417436483-5913918"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(Jacobih[{S_, sigma_}, {t_}, {r_, lambda_, sigma0_, gamma_, 
                        rho_}] = {{1, 0}}\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "Jacobih"],
      Editable->False]], "Print",
  CellTags->"Info3417436483-5913918"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[TextData[{
  "SeedRandom[9999444444444];\n$RandomState\nY0 = {100,.2};\nT = 365;\ndt = \
1./365;\nTheta = {  r,lambda,sigma0,gamma, rho} = \n        {.07,    -1,    \
.2,    .2, ",
  StyleBox["0.0",
    FontColor->RGBColor[1, 0, 0]],
  "} //N\nk = 1;\np = 2;\nq = 1;\n\nX = Shape[T+1//Range,{T+1,q}];\nNonlin = \
0;\nmiss = -9;"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \(361141343544074432446210284367386309226687379198672412905268112758413728\
365000667065546912903562319580108494997078880780649173954767696300236955895346\
218845798496933524517076642244596761047326375745327294979193770271718371160919\
981678164771728664582811173657823160896341364491492339382646713246829046195467\
550800296221338325159702446242098638824217561718955502773934675460383806552828\
698470927872675866674838518118446036179601842836250135424749708969966574057457\
334892548436056600226196029016819718803568815245661474584936084340193190156469\
09580789581314041249985379431518203262\)], "Output"],

Cell[BoxData[
    \({0.07`, \(-1.`\), 0.2`, 0.2`, 0.`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
SeedRandom[9999444444444];  (*4.1.2*)
$RandomState\
\>", "Input",
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
\
173118916049880913142517558411092014055527160410716489004026222832005121507696\
880199119525866322996024802508555507355753940529951713406485583083791095142383\
220920707941166293287775576528160154722838272240532891246442559763534912279481\
015283801978136812416832339827159562219203656472730351902247033999198060956489\
248959710118428028135292259949478901618391850007539072694642387431541505856193\
470869685693895189277710044522425925228252060279503452219735470485070106681692\
340401057320410221535643563521162418811178323613426971006543366212582331980485\
4024999762887\
\>", \
"\<\
1731189160498809131425175584110920140555271604107164890040262228320051215\
076968801991195258663229960248025085555073557539405299517134064855830837910951\
423832209207079411662932877755765281601547228382722405328912464425597635349122\
794810152838019781368124168323398271595622192036564727303519022470339991980609\
564892489597101184280281352922599494789016183918500075390726946423874315415058\
561934708696856938951892777100445224259252282520602795034522197354704850701066\
816923404010573204102215356435635211624188111783236134269710065433662125823319\
804854024999762887\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
$RandomState=\
173118916049880913142517558411092014055527160410716489004026222832005121507696\
880199119525866322996024802508555507355753940529951713406485583083791095142383\
220920707941166293287775576528160154722838272240532891246442559763534912279481\
015283801978136812416832339827159562219203656472730351902247033999198060956489\
248959710118428028135292259949478901618391850007539072694642387431541505856193\
470869685693895189277710044522425925228252060279503452219735470485070106681692\
340401057320410221535643563521162418811178323613426971006543366212582331980485\
4024999762887\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    RowBox[{\($RandomState::"rndst"\), \(\(:\)\(\ \)\), \
"\<\"\\!\\(\
173118916049880913142517558411092014055527160410716489004026222832005121507696\
88019911 \\(\\(\[LeftSkeleton] 386 \[RightSkeleton]\\)\\) \
010573204102215356435635211624188111783236134269710065433662125823319804854024\
999762887\\) is not a valid random state. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"$RandomState::rndst\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(173118916049880913142517558411092014055527160410716489004026222832005121\
507696880199119525866322996024802508555507355753940529951713406485583083791095\
142383220920707941166293287775576528160154722838272240532891246442559763534912\
279481015283801978136812416832339827159562219203656472730351902247033999198060\
956489248959710118428028135292259949478901618391850007539072694642387431541505\
856193470869685693895189277710044522425925228252060279503452219735470485070106\
681692340401057320410221535643563521162418811178323613426971006543366212582331\
9804854024999762887\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{Z,Y} = NonLinStateSpace[h,{R,const},drift,diffusion,Y0,X,T,dt,
\t\t\t\t\t\t \t\tTheta,Gauss,EulerStep];//Timing\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({0.03058599999985745`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DisplayTogetherArray[
plot1[Y//AddTimeAxis],
plot1[Column[Y,{2}]//AddTimeAxis]
]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 3}\),
      SequenceForm[ "Dimension der Daten  ", {366, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 2}\),
      SequenceForm[ "Dimension der Daten  ", {366, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 0.0138583 0.00542324 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01386 -6 -4.5 ]
[-0.0125 .01386 0 4.5 ]
[-0.0125 .12232 -12 -4.5 ]
[-0.0125 .12232 0 4.5 ]
[-0.0125 .23079 -12 -4.5 ]
[-0.0125 .23079 0 4.5 ]
[-0.0125 .33925 -12 -4.5 ]
[-0.0125 .33925 0 4.5 ]
[-0.0125 .44772 -12 -4.5 ]
[-0.0125 .44772 0 4.5 ]
[-0.0125 .55618 -18 -4.5 ]
[-0.0125 .55618 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .43239 -5 -6 ]
[.97619 .43239 5 6 ]
[.97619 .01526 -5 -6 ]
[.97619 .01526 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01386 m
.00625 .01386 L
s
[(0)] -0.0125 .01386 1 0 Mshowa
0 .12232 m
.00625 .12232 L
s
[(20)] -0.0125 .12232 1 0 Mshowa
0 .23079 m
.00625 .23079 L
s
[(40)] -0.0125 .23079 1 0 Mshowa
0 .33925 m
.00625 .33925 L
s
[(60)] -0.0125 .33925 1 0 Mshowa
0 .44772 m
.00625 .44772 L
s
[(80)] -0.0125 .44772 1 0 Mshowa
0 .55618 m
.00625 .55618 L
s
[(100)] -0.0125 .55618 1 0 Mshowa
.125 Mabswid
0 .04097 m
.00375 .04097 L
s
0 .06809 m
.00375 .06809 L
s
0 .09521 m
.00375 .09521 L
s
0 .14944 m
.00375 .14944 L
s
0 .17656 m
.00375 .17656 L
s
0 .20367 m
.00375 .20367 L
s
0 .2579 m
.00375 .2579 L
s
0 .28502 m
.00375 .28502 L
s
0 .31214 m
.00375 .31214 L
s
0 .36637 m
.00375 .36637 L
s
0 .39349 m
.00375 .39349 L
s
0 .4206 m
.00375 .4206 L
s
0 .47483 m
.00375 .47483 L
s
0 .50195 m
.00375 .50195 L
s
0 .52907 m
.00375 .52907 L
s
0 .5833 m
.00375 .5833 L
s
0 .61041 m
.00375 .61041 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01386 m
1 .01386 L
s
.99375 .12232 m
1 .12232 L
s
.99375 .23079 m
1 .23079 L
s
.99375 .33925 m
1 .33925 L
s
.99375 .44772 m
1 .44772 L
s
.99375 .55618 m
1 .55618 L
s
.125 Mabswid
.99625 .04097 m
1 .04097 L
s
.99625 .06809 m
1 .06809 L
s
.99625 .09521 m
1 .09521 L
s
.99625 .14944 m
1 .14944 L
s
.99625 .17656 m
1 .17656 L
s
.99625 .20367 m
1 .20367 L
s
.99625 .2579 m
1 .2579 L
s
.99625 .28502 m
1 .28502 L
s
.99625 .31214 m
1 .31214 L
s
.99625 .36637 m
1 .36637 L
s
.99625 .39349 m
1 .39349 L
s
.99625 .4206 m
1 .4206 L
s
.99625 .47483 m
1 .47483 L
s
.99625 .50195 m
1 .50195 L
s
.99625 .52907 m
1 .52907 L
s
.99625 .5833 m
1 .5833 L
s
.99625 .61041 m
1 .61041 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .43239 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .55618 m
.02642 .55647 L
.02903 .55325 L
.03164 .55168 L
.03425 .54804 L
.03686 .55254 L
.03947 .54908 L
.04207 .54633 L
.04468 .54212 L
.04729 .54093 L
.0499 .53425 L
.05251 .53325 L
.05512 .53139 L
.05773 .53748 L
.06034 .53945 L
.06295 .53962 L
.06556 .5361 L
.06817 .5316 L
.07078 .53595 L
.07339 .52434 L
.07599 .52053 L
.0786 .51879 L
.08121 .50636 L
.08382 .49742 L
.08643 .49421 L
.08904 .49498 L
.09165 .4945 L
.09426 .49591 L
.09687 .50399 L
.09948 .5051 L
.10209 .50385 L
.1047 .49529 L
.10731 .4962 L
.10992 .50041 L
.11252 .49721 L
.11513 .49774 L
.11774 .50771 L
.12035 .51011 L
.12296 .5045 L
.12557 .50951 L
.12818 .51134 L
.13079 .52072 L
.1334 .51417 L
.13601 .50773 L
.13862 .50335 L
.14123 .51208 L
.14384 .51429 L
.14644 .51694 L
.14905 .52229 L
.15166 .53126 L
Mistroke
.15427 .53721 L
.15688 .53555 L
.15949 .53694 L
.1621 .54703 L
.16471 .5443 L
.16732 .54752 L
.16993 .545 L
.17254 .5456 L
.17515 .5358 L
.17776 .54682 L
.18037 .54946 L
.18297 .5434 L
.18558 .53938 L
.18819 .53045 L
.1908 .53994 L
.19341 .54276 L
.19602 .54819 L
.19863 .54199 L
.20124 .54468 L
.20385 .53896 L
.20646 .54198 L
.20907 .53479 L
.21168 .53293 L
.21429 .52913 L
.21689 .53796 L
.2195 .54239 L
.22211 .53579 L
.22472 .53967 L
.22733 .54575 L
.22994 .5525 L
.23255 .56055 L
.23516 .55907 L
.23777 .56341 L
.24038 .5612 L
.24299 .56345 L
.2456 .55629 L
.24821 .54633 L
.25082 .53242 L
.25342 .52472 L
.25603 .51997 L
.25864 .52555 L
.26125 .53207 L
.26386 .52577 L
.26647 .52438 L
.26908 .52345 L
.27169 .524 L
.2743 .53278 L
.27691 .54149 L
.27952 .54459 L
.28213 .54544 L
Mistroke
.28474 .54274 L
.28735 .55753 L
.28995 .56871 L
.29256 .5686 L
.29517 .56303 L
.29778 .55701 L
.30039 .56002 L
.303 .56415 L
.30561 .56663 L
.30822 .5551 L
.31083 .54551 L
.31344 .55011 L
.31605 .55457 L
.31866 .56648 L
.32127 .56844 L
.32387 .57579 L
.32648 .57862 L
.32909 .57284 L
.3317 .57684 L
.33431 .5827 L
.33692 .58518 L
.33953 .58609 L
.34214 .58955 L
.34475 .60053 L
.34736 .59873 L
.34997 .60012 L
.35258 .59576 L
.35519 .60332 L
.3578 .59812 L
.3604 .58874 L
.36301 .5904 L
.36562 .57392 L
.36823 .57146 L
.37084 .57087 L
.37345 .56837 L
.37606 .56819 L
.37867 .5663 L
.38128 .56667 L
.38389 .5626 L
.3865 .56051 L
.38911 .55686 L
.39172 .54997 L
.39432 .55701 L
.39693 .55485 L
.39954 .56512 L
.40215 .55837 L
.40476 .54425 L
.40737 .52607 L
.40998 .53341 L
.41259 .53513 L
Mistroke
.4152 .53723 L
.41781 .53971 L
.42042 .54395 L
.42303 .54241 L
.42564 .54412 L
.42825 .54982 L
.43085 .54908 L
.43346 .54689 L
.43607 .5487 L
.43868 .55549 L
.44129 .55669 L
.4439 .5455 L
.44651 .54472 L
.44912 .5417 L
.45173 .54301 L
.45434 .55111 L
.45695 .56048 L
.45956 .56666 L
.46217 .56473 L
.46477 .56799 L
.46738 .56477 L
.46999 .56009 L
.4726 .5495 L
.47521 .54596 L
.47782 .54385 L
.48043 .54457 L
.48304 .54563 L
.48565 .54843 L
.48826 .5517 L
.49087 .55284 L
.49348 .5613 L
.49609 .55367 L
.4987 .55392 L
.5013 .54784 L
.50391 .53791 L
.50652 .53563 L
.50913 .5383 L
.51174 .53715 L
.51435 .54732 L
.51696 .54225 L
.51957 .54205 L
.52218 .54011 L
.52479 .53659 L
.5274 .53441 L
.53001 .54307 L
.53262 .54504 L
.53523 .55632 L
.53783 .55017 L
.54044 .53385 L
.54305 .53112 L
Mistroke
.54566 .53401 L
.54827 .53258 L
.55088 .51227 L
.55349 .51353 L
.5561 .51355 L
.55871 .51728 L
.56132 .5246 L
.56393 .52554 L
.56654 .52252 L
.56915 .52775 L
.57175 .53682 L
.57436 .53473 L
.57697 .54495 L
.57958 .53543 L
.58219 .55067 L
.5848 .53538 L
.58741 .5412 L
.59002 .54378 L
.59263 .5437 L
.59524 .54086 L
.59785 .54634 L
.60046 .52252 L
.60307 .51521 L
.60568 .50585 L
.60828 .50277 L
.61089 .51224 L
.6135 .51935 L
.61611 .52424 L
.61872 .51872 L
.62133 .50521 L
.62394 .48911 L
.62655 .48164 L
.62916 .47759 L
.63177 .46301 L
.63438 .46364 L
.63699 .45935 L
.6396 .4677 L
.6422 .45921 L
.64481 .47107 L
.64742 .47103 L
.65003 .4726 L
.65264 .49378 L
.65525 .48668 L
.65786 .48606 L
.66047 .49327 L
.66308 .49672 L
.66569 .50055 L
.6683 .50711 L
.67091 .49989 L
.67352 .50824 L
Mistroke
.67613 .50661 L
.67873 .4986 L
.68134 .50962 L
.68395 .50964 L
.68656 .50973 L
.68917 .49966 L
.69178 .48849 L
.69439 .49157 L
.697 .49244 L
.69961 .48521 L
.70222 .47967 L
.70483 .48141 L
.70744 .48283 L
.71005 .47138 L
.71265 .46945 L
.71526 .47453 L
.71787 .47211 L
.72048 .48004 L
.72309 .48694 L
.7257 .47316 L
.72831 .47807 L
.73092 .4786 L
.73353 .4839 L
.73614 .48402 L
.73875 .47499 L
.74136 .46947 L
.74397 .4637 L
.74658 .48254 L
.74918 .48471 L
.75179 .47684 L
.7544 .47356 L
.75701 .47822 L
.75962 .47673 L
.76223 .47978 L
.76484 .47985 L
.76745 .47237 L
.77006 .46661 L
.77267 .47045 L
.77528 .46481 L
.77789 .44419 L
.7805 .457 L
.78311 .46046 L
.78571 .4618 L
.78832 .455 L
.79093 .44962 L
.79354 .4492 L
.79615 .44414 L
.79876 .44232 L
.80137 .43882 L
.80398 .42783 L
Mistroke
.80659 .43247 L
.8092 .44098 L
.81181 .43762 L
.81442 .43373 L
.81703 .44301 L
.81963 .448 L
.82224 .46056 L
.82485 .46575 L
.82746 .46806 L
.83007 .4738 L
.83268 .46425 L
.83529 .46088 L
.8379 .45025 L
.84051 .4568 L
.84312 .45118 L
.84573 .4469 L
.84834 .45379 L
.85095 .45763 L
.85356 .46219 L
.85616 .4552 L
.85877 .45358 L
.86138 .44549 L
.86399 .44689 L
.8666 .44798 L
.86921 .4503 L
.87182 .45865 L
.87443 .44829 L
.87704 .43065 L
.87965 .42681 L
.88226 .43417 L
.88487 .43744 L
.88748 .43999 L
.89008 .43457 L
.89269 .43155 L
.8953 .42891 L
.89791 .43589 L
.90052 .44284 L
.90313 .44251 L
.90574 .44409 L
.90835 .45202 L
.91096 .46048 L
.91357 .4691 L
.91618 .46615 L
.91879 .45751 L
.9214 .45808 L
.92401 .45468 L
.92661 .4489 L
.92922 .45075 L
.93183 .44951 L
.93444 .45057 L
Mistroke
.93705 .4546 L
.93966 .45451 L
.94227 .45069 L
.94488 .44904 L
.94749 .45025 L
.9501 .44604 L
.95271 .44868 L
.95532 .43898 L
.95793 .44739 L
.96053 .44497 L
.96314 .43893 L
.96575 .43145 L
.96836 .43488 L
.97097 .43738 L
.97358 .44242 L
.97619 .43239 L
Mfstroke
0 .98 .604 r
gsave
.97619 .01526 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01494 m
.02642 .0149 L
.02903 .01496 L
.03164 .01482 L
.03425 .01478 L
.03686 .01487 L
.03947 .01483 L
.04207 .01473 L
.04468 .01476 L
.04729 .01472 L
.0499 .01479 L
.05251 .01473 L
.05512 .01472 L
.05773 .01472 L
.06034 .01478 L
.06295 .01478 L
.06556 .01479 L
.06817 .01482 L
.07078 .01486 L
.07339 .01485 L
.07599 .01497 L
.0786 .01497 L
.08121 .01494 L
.08382 .01493 L
.08643 .0149 L
.08904 .01499 L
.09165 .01503 L
.09426 .01508 L
.09687 .01514 L
.09948 .01507 L
.10209 .01511 L
.1047 .01501 L
.10731 .01504 L
.10992 .01496 L
.11252 .01499 L
.11513 .01499 L
.11774 .01491 L
.12035 .01497 L
.12296 .01497 L
.12557 .01499 L
.12818 .01506 L
.13079 .0151 L
.1334 .01514 L
.13601 .01517 L
.13862 .01517 L
.14123 .01513 L
.14384 .01512 L
.14644 .01504 L
.14905 .01498 L
.15166 .01498 L
Mistroke
.15427 .01502 L
.15688 .01502 L
.15949 .0151 L
.1621 .01508 L
.16471 .01498 L
.16732 .015 L
.16993 .01494 L
.17254 .01498 L
.17515 .01491 L
.17776 .01489 L
.18037 .01487 L
.18297 .01488 L
.18558 .01494 L
.18819 .01495 L
.1908 .01489 L
.19341 .01501 L
.19602 .01494 L
.19863 .0149 L
.20124 .01484 L
.20385 .01481 L
.20646 .01489 L
.20907 .0149 L
.21168 .01481 L
.21429 .01481 L
.21689 .01489 L
.2195 .01489 L
.22211 .01485 L
.22472 .01482 L
.22733 .01488 L
.22994 .01492 L
.23255 .01492 L
.23516 .015 L
.23777 .01508 L
.24038 .01503 L
.24299 .01506 L
.2456 .01504 L
.24821 .01508 L
.25082 .01502 L
.25342 .01495 L
.25603 .0149 L
.25864 .01493 L
.26125 .01497 L
.26386 .01497 L
.26647 .01502 L
.26908 .01511 L
.27169 .01499 L
.2743 .01506 L
.27691 .01503 L
.27952 .015 L
.28213 .01511 L
Mistroke
.28474 .0151 L
.28735 .01507 L
.28995 .01505 L
.29256 .01503 L
.29517 .01508 L
.29778 .01502 L
.30039 .01498 L
.303 .01498 L
.30561 .0149 L
.30822 .01495 L
.31083 .01494 L
.31344 .01494 L
.31605 .01485 L
.31866 .01481 L
.32127 .01477 L
.32387 .01474 L
.32648 .01475 L
.32909 .01483 L
.3317 .01479 L
.33431 .01484 L
.33692 .01488 L
.33953 .0149 L
.34214 .01488 L
.34475 .01489 L
.34736 .01476 L
.34997 .01481 L
.35258 .01477 L
.35519 .01478 L
.3578 .01482 L
.3604 .01485 L
.36301 .01489 L
.36562 .01494 L
.36823 .01484 L
.37084 .01477 L
.37345 .01474 L
.37606 .01478 L
.37867 .01474 L
.38128 .0148 L
.38389 .0149 L
.3865 .01488 L
.38911 .01492 L
.39172 .01497 L
.39432 .01496 L
.39693 .01501 L
.39954 .01495 L
.40215 .01499 L
.40476 .01498 L
.40737 .015 L
.40998 .01495 L
.41259 .01495 L
Mistroke
.4152 .01498 L
.41781 .01495 L
.42042 .01498 L
.42303 .01488 L
.42564 .01492 L
.42825 .0149 L
.43085 .01487 L
.43346 .0149 L
.43607 .01499 L
.43868 .01506 L
.44129 .01502 L
.4439 .01496 L
.44651 .015 L
.44912 .0149 L
.45173 .01487 L
.45434 .01485 L
.45695 .01493 L
.45956 .01497 L
.46217 .015 L
.46477 .01501 L
.46738 .01505 L
.46999 .01511 L
.4726 .01504 L
.47521 .01506 L
.47782 .01509 L
.48043 .01513 L
.48304 .01518 L
.48565 .01524 L
.48826 .01523 L
.49087 .01519 L
.49348 .01528 L
.49609 .01526 L
.4987 .01516 L
.5013 .0152 L
.50391 .01524 L
.50652 .01524 L
.50913 .01527 L
.51174 .01536 L
.51435 .01531 L
.51696 .01529 L
.51957 .01534 L
.52218 .01544 L
.52479 .01553 L
.5274 .01561 L
.53001 .0156 L
.53262 .01563 L
.53523 .01566 L
.53783 .01561 L
.54044 .01558 L
.54305 .01559 L
Mistroke
.54566 .01548 L
.54827 .01551 L
.55088 .01554 L
.55349 .01553 L
.5561 .01555 L
.55871 .01562 L
.56132 .0155 L
.56393 .01555 L
.56654 .01553 L
.56915 .01558 L
.57175 .01566 L
.57436 .01572 L
.57697 .01569 L
.57958 .01572 L
.58219 .01568 L
.5848 .0157 L
.58741 .01569 L
.59002 .01563 L
.59263 .01557 L
.59524 .01556 L
.59785 .01557 L
.60046 .01554 L
.60307 .01551 L
.60568 .01554 L
.60828 .01552 L
.61089 .01558 L
.6135 .01554 L
.61611 .01552 L
.61872 .01545 L
.62133 .0154 L
.62394 .01542 L
.62655 .01541 L
.62916 .01539 L
.63177 .01549 L
.63438 .01547 L
.63699 .01555 L
.6396 .01551 L
.6422 .01556 L
.64481 .01558 L
.64742 .01562 L
.65003 .01566 L
.65264 .01558 L
.65525 .0156 L
.65786 .01568 L
.66047 .01567 L
.66308 .01567 L
.66569 .01568 L
.6683 .01569 L
.67091 .01569 L
.67352 .01569 L
Mistroke
.67613 .0156 L
.67873 .01564 L
.68134 .01568 L
.68395 .01567 L
.68656 .01562 L
.68917 .01556 L
.69178 .01553 L
.69439 .01546 L
.697 .01541 L
.69961 .01534 L
.70222 .01527 L
.70483 .01529 L
.70744 .01522 L
.71005 .01527 L
.71265 .01529 L
.71526 .0153 L
.71787 .01536 L
.72048 .01537 L
.72309 .01537 L
.7257 .01531 L
.72831 .01538 L
.73092 .01534 L
.73353 .01541 L
.73614 .01542 L
.73875 .01548 L
.74136 .01554 L
.74397 .01557 L
.74658 .01549 L
.74918 .01547 L
.75179 .0155 L
.7544 .0154 L
.75701 .01542 L
.75962 .01538 L
.76223 .01534 L
.76484 .01527 L
.76745 .01533 L
.77006 .0154 L
.77267 .01545 L
.77528 .01553 L
.77789 .01545 L
.7805 .01544 L
.78311 .01548 L
.78571 .01547 L
.78832 .01549 L
.79093 .01553 L
.79354 .01551 L
.79615 .01548 L
.79876 .0155 L
.80137 .01557 L
.80398 .01546 L
Mistroke
.80659 .01542 L
.8092 .01548 L
.81181 .01539 L
.81442 .01541 L
.81703 .01545 L
.81963 .01534 L
.82224 .01536 L
.82485 .01533 L
.82746 .01535 L
.83007 .01541 L
.83268 .01542 L
.83529 .01539 L
.8379 .0154 L
.84051 .01532 L
.84312 .01532 L
.84573 .01533 L
.84834 .01527 L
.85095 .01528 L
.85356 .01528 L
.85616 .01523 L
.85877 .01529 L
.86138 .0153 L
.86399 .01532 L
.8666 .01527 L
.86921 .01529 L
.87182 .01527 L
.87443 .01529 L
.87704 .01532 L
.87965 .01541 L
.88226 .01536 L
.88487 .01535 L
.88748 .01529 L
.89008 .0152 L
.89269 .01516 L
.8953 .01512 L
.89791 .01513 L
.90052 .01516 L
.90313 .01518 L
.90574 .01515 L
.90835 .01513 L
.91096 .01512 L
.91357 .01514 L
.91618 .01514 L
.91879 .01522 L
.9214 .01519 L
.92401 .0153 L
.92661 .01533 L
.92922 .0154 L
.93183 .01548 L
.93444 .0154 L
Mistroke
.93705 .01552 L
.93966 .01553 L
.94227 .01557 L
.94488 .0155 L
.94749 .01541 L
.9501 .0154 L
.95271 .01539 L
.95532 .01546 L
.95793 .01547 L
.96053 .01548 L
.96314 .01544 L
.96575 .01544 L
.96836 .0153 L
.97097 .01527 L
.97358 .01525 L
.97619 .01526 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -0.485853 3.1683 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0686 -30 -4.5 ]
[-0.0125 .0686 0 4.5 ]
[-0.0125 .14781 -18 -4.5 ]
[-0.0125 .14781 0 4.5 ]
[-0.0125 .22701 -30 -4.5 ]
[-0.0125 .22701 0 4.5 ]
[-0.0125 .30622 -24 -4.5 ]
[-0.0125 .30622 0 4.5 ]
[-0.0125 .38543 -30 -4.5 ]
[-0.0125 .38543 0 4.5 ]
[-0.0125 .46464 -18 -4.5 ]
[-0.0125 .46464 0 4.5 ]
[-0.0125 .54384 -30 -4.5 ]
[-0.0125 .54384 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33545 -5 -6 ]
[.97619 .33545 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0686 m
.00625 .0686 L
s
[(0.175)] -0.0125 .0686 1 0 Mshowa
0 .14781 m
.00625 .14781 L
s
[(0.2)] -0.0125 .14781 1 0 Mshowa
0 .22701 m
.00625 .22701 L
s
[(0.225)] -0.0125 .22701 1 0 Mshowa
0 .30622 m
.00625 .30622 L
s
[(0.25)] -0.0125 .30622 1 0 Mshowa
0 .38543 m
.00625 .38543 L
s
[(0.275)] -0.0125 .38543 1 0 Mshowa
0 .46464 m
.00625 .46464 L
s
[(0.3)] -0.0125 .46464 1 0 Mshowa
0 .54384 m
.00625 .54384 L
s
[(0.325)] -0.0125 .54384 1 0 Mshowa
.125 Mabswid
0 .08444 m
.00375 .08444 L
s
0 .10028 m
.00375 .10028 L
s
0 .11612 m
.00375 .11612 L
s
0 .13197 m
.00375 .13197 L
s
0 .16365 m
.00375 .16365 L
s
0 .17949 m
.00375 .17949 L
s
0 .19533 m
.00375 .19533 L
s
0 .21117 m
.00375 .21117 L
s
0 .24286 m
.00375 .24286 L
s
0 .2587 m
.00375 .2587 L
s
0 .27454 m
.00375 .27454 L
s
0 .29038 m
.00375 .29038 L
s
0 .32206 m
.00375 .32206 L
s
0 .33791 m
.00375 .33791 L
s
0 .35375 m
.00375 .35375 L
s
0 .36959 m
.00375 .36959 L
s
0 .40127 m
.00375 .40127 L
s
0 .41711 m
.00375 .41711 L
s
0 .43295 m
.00375 .43295 L
s
0 .4488 m
.00375 .4488 L
s
0 .48048 m
.00375 .48048 L
s
0 .49632 m
.00375 .49632 L
s
0 .51216 m
.00375 .51216 L
s
0 .528 m
.00375 .528 L
s
0 .05276 m
.00375 .05276 L
s
0 .03692 m
.00375 .03692 L
s
0 .02107 m
.00375 .02107 L
s
0 .00523 m
.00375 .00523 L
s
0 .55969 m
.00375 .55969 L
s
0 .57553 m
.00375 .57553 L
s
0 .59137 m
.00375 .59137 L
s
0 .60721 m
.00375 .60721 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0686 m
1 .0686 L
s
.99375 .14781 m
1 .14781 L
s
.99375 .22701 m
1 .22701 L
s
.99375 .30622 m
1 .30622 L
s
.99375 .38543 m
1 .38543 L
s
.99375 .46464 m
1 .46464 L
s
.99375 .54384 m
1 .54384 L
s
.125 Mabswid
.99625 .08444 m
1 .08444 L
s
.99625 .10028 m
1 .10028 L
s
.99625 .11612 m
1 .11612 L
s
.99625 .13197 m
1 .13197 L
s
.99625 .16365 m
1 .16365 L
s
.99625 .17949 m
1 .17949 L
s
.99625 .19533 m
1 .19533 L
s
.99625 .21117 m
1 .21117 L
s
.99625 .24286 m
1 .24286 L
s
.99625 .2587 m
1 .2587 L
s
.99625 .27454 m
1 .27454 L
s
.99625 .29038 m
1 .29038 L
s
.99625 .32206 m
1 .32206 L
s
.99625 .33791 m
1 .33791 L
s
.99625 .35375 m
1 .35375 L
s
.99625 .36959 m
1 .36959 L
s
.99625 .40127 m
1 .40127 L
s
.99625 .41711 m
1 .41711 L
s
.99625 .43295 m
1 .43295 L
s
.99625 .4488 m
1 .4488 L
s
.99625 .48048 m
1 .48048 L
s
.99625 .49632 m
1 .49632 L
s
.99625 .51216 m
1 .51216 L
s
.99625 .528 m
1 .528 L
s
.99625 .05276 m
1 .05276 L
s
.99625 .03692 m
1 .03692 L
s
.99625 .02107 m
1 .02107 L
s
.99625 .00523 m
1 .00523 L
s
.99625 .55969 m
1 .55969 L
s
.99625 .57553 m
1 .57553 L
s
.99625 .59137 m
1 .59137 L
s
.99625 .60721 m
1 .60721 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .33545 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .14781 m
.02642 .12401 L
.02903 .15743 L
.03164 .07728 L
.03425 .05095 L
.03686 .10322 L
.03947 .08449 L
.04207 .02616 L
.04468 .04213 L
.04729 .01472 L
.0499 .0582 L
.05251 .02193 L
.05512 .01522 L
.05773 .01689 L
.06034 .05211 L
.06295 .05093 L
.06556 .0565 L
.06817 .07722 L
.07078 .09711 L
.07339 .09327 L
.07599 .1651 L
.0786 .16323 L
.08121 .14615 L
.08382 .13911 L
.08643 .12498 L
.08904 .17713 L
.09165 .19935 L
.09426 .23043 L
.09687 .26295 L
.09948 .21984 L
.10209 .24394 L
.1047 .18469 L
.10731 .20387 L
.10992 .15755 L
.11252 .17656 L
.11513 .17498 L
.11774 .13097 L
.12035 .16397 L
.12296 .16288 L
.12557 .17523 L
.12818 .2183 L
.13079 .23842 L
.1334 .26439 L
.13601 .27855 L
.13862 .27778 L
.14123 .25542 L
.14384 .25307 L
.14644 .20654 L
.14905 .17139 L
.15166 .17184 L
Mistroke
.15427 .19012 L
.15688 .19163 L
.15949 .2379 L
.1621 .22771 L
.16471 .16791 L
.16732 .18229 L
.16993 .14698 L
.17254 .17237 L
.17515 .13057 L
.17776 .11711 L
.18037 .10753 L
.18297 .11365 L
.18558 .14531 L
.18819 .15344 L
.1908 .11862 L
.19341 .18433 L
.19602 .14702 L
.19863 .12547 L
.20124 .08639 L
.20385 .06842 L
.20646 .11632 L
.20907 .12038 L
.21168 .07065 L
.21429 .06725 L
.21689 .11943 L
.2195 .118 L
.22211 .09402 L
.22472 .07768 L
.22733 .10889 L
.22994 .13162 L
.23255 .13467 L
.23516 .18332 L
.23777 .22805 L
.24038 .19796 L
.24299 .21531 L
.2456 .20278 L
.24821 .22933 L
.25082 .19422 L
.25342 .15339 L
.25603 .12465 L
.25864 .13814 L
.26125 .16567 L
.26386 .16618 L
.26647 .19225 L
.26908 .24442 L
.27169 .17668 L
.2743 .21439 L
.27691 .19903 L
.27952 .18203 L
.28213 .24449 L
Mistroke
.28474 .24053 L
.28735 .22367 L
.28995 .21307 L
.29256 .19698 L
.29517 .22911 L
.29778 .19205 L
.30039 .17106 L
.303 .16854 L
.30561 .12272 L
.30822 .15249 L
.31083 .1468 L
.31344 .14733 L
.31605 .09256 L
.31866 .07159 L
.32127 .04568 L
.32387 .02642 L
.32648 .03801 L
.32909 .08251 L
.3317 .05992 L
.33431 .08852 L
.33692 .10861 L
.33953 .12406 L
.34214 .10871 L
.34475 .1197 L
.34736 .04089 L
.34997 .0699 L
.35258 .04957 L
.35519 .05269 L
.3578 .07691 L
.3604 .09189 L
.36301 .11499 L
.36562 .14714 L
.36823 .08543 L
.37084 .04772 L
.37345 .0318 L
.37606 .055 L
.37867 .02659 L
.38128 .06232 L
.38389 .12444 L
.3865 .11348 L
.38911 .13479 L
.39172 .16653 L
.39432 .15808 L
.39693 .18657 L
.39954 .15052 L
.40215 .17513 L
.40476 .1675 L
.40737 .17896 L
.40998 .15189 L
.41259 .14933 L
Mistroke
.4152 .1722 L
.41781 .15201 L
.42042 .17112 L
.42303 .10849 L
.42564 .13669 L
.42825 .12242 L
.43085 .10533 L
.43346 .124 L
.43607 .17789 L
.43868 .21467 L
.44129 .19498 L
.4439 .16028 L
.44651 .18094 L
.44912 .12478 L
.45173 .10726 L
.45434 .09347 L
.45695 .1381 L
.45956 .16604 L
.46217 .18354 L
.46477 .18559 L
.46738 .21318 L
.46999 .24681 L
.4726 .20523 L
.47521 .21331 L
.47782 .23342 L
.48043 .2585 L
.48304 .28383 L
.48565 .3226 L
.48826 .31619 L
.49087 .29477 L
.49348 .34263 L
.49609 .33141 L
.4987 .27295 L
.5013 .30046 L
.50391 .31989 L
.50652 .32245 L
.50913 .33724 L
.51174 .38883 L
.51435 .35981 L
.51696 .34923 L
.51957 .37709 L
.52218 .4401 L
.52479 .48992 L
.5274 .54 L
.53001 .53419 L
.53262 .54963 L
.53523 .56935 L
.53783 .53855 L
.54044 .52062 L
.54305 .52794 L
Mistroke
.54566 .46011 L
.54827 .47939 L
.55088 .49509 L
.55349 .4886 L
.5561 .50035 L
.55871 .54247 L
.56132 .474 L
.56393 .50362 L
.56654 .49145 L
.56915 .5207 L
.57175 .5665 L
.57436 .60285 L
.57697 .58645 L
.57958 .60332 L
.58219 .57617 L
.5848 .59259 L
.58741 .58547 L
.59002 .55073 L
.59263 .51706 L
.59524 .51013 L
.59785 .51287 L
.60046 .49388 L
.60307 .47859 L
.60568 .49852 L
.60828 .4829 L
.61089 .51753 L
.6135 .49435 L
.61611 .4873 L
.61872 .4466 L
.62133 .41484 L
.62394 .42622 L
.62655 .42037 L
.62916 .40991 L
.63177 .47008 L
.63438 .45598 L
.63699 .50008 L
.6396 .48031 L
.6422 .50763 L
.64481 .52001 L
.64742 .5451 L
.65003 .56952 L
.65264 .52078 L
.65525 .52998 L
.65786 .5794 L
.66047 .57162 L
.66308 .57461 L
.66569 .57814 L
.6683 .58207 L
.67091 .58576 L
.67352 .58172 L
Mistroke
.67613 .52957 L
.67873 .55302 L
.68134 .57821 L
.68395 .57484 L
.68656 .54316 L
.68917 .50756 L
.69178 .49111 L
.69439 .45141 L
.697 .41907 L
.69961 .37848 L
.70222 .33761 L
.70483 .35215 L
.70744 .30794 L
.71005 .33814 L
.71265 .35085 L
.71526 .35498 L
.71787 .38968 L
.72048 .39465 L
.72309 .39942 L
.7257 .36321 L
.72831 .40568 L
.73092 .37909 L
.73353 .42162 L
.73614 .42563 L
.73875 .46325 L
.74136 .49621 L
.74397 .51297 L
.74658 .46908 L
.74918 .45289 L
.75179 .47326 L
.7544 .41601 L
.75701 .42555 L
.75962 .40167 L
.76223 .37768 L
.76484 .3401 L
.76745 .37123 L
.77006 .41309 L
.77267 .44444 L
.77528 .49294 L
.77789 .44285 L
.7805 .44025 L
.78311 .4599 L
.78571 .45821 L
.78832 .46711 L
.79093 .49246 L
.79354 .48152 L
.79615 .46395 L
.79876 .47435 L
.80137 .5153 L
.80398 .45204 L
Mistroke
.80659 .42525 L
.8092 .45948 L
.81181 .41033 L
.81442 .42134 L
.81703 .44426 L
.81963 .37705 L
.82224 .3939 L
.82485 .37653 L
.82746 .38511 L
.83007 .41814 L
.83268 .42474 L
.83529 .40745 L
.8379 .41309 L
.84051 .36913 L
.84312 .36595 L
.84573 .37343 L
.84834 .33678 L
.85095 .34404 L
.85356 .34507 L
.85616 .31436 L
.85877 .34909 L
.86138 .35359 L
.86399 .36924 L
.8666 .34144 L
.86921 .34813 L
.87182 .33738 L
.87443 .34891 L
.87704 .37016 L
.87965 .42199 L
.88226 .39125 L
.88487 .38514 L
.88748 .35231 L
.89008 .29782 L
.89269 .27699 L
.8953 .24937 L
.89791 .2593 L
.90052 .27494 L
.90313 .28722 L
.90574 .26627 L
.90835 .25619 L
.91096 .25329 L
.91357 .26305 L
.91618 .26547 L
.91879 .31046 L
.9214 .29127 L
.92401 .35402 L
.92661 .3753 L
.92922 .41324 L
.93183 .45989 L
.93444 .41631 L
Mistroke
.93705 .48268 L
.93966 .49308 L
.94227 .51359 L
.94488 .47185 L
.94749 .4234 L
.9501 .41222 L
.95271 .40725 L
.95532 .44752 L
.95793 .45537 L
.96053 .46336 L
.96314 .43849 L
.96575 .43589 L
.96836 .35533 L
.97097 .3387 L
.97358 .3243 L
.97619 .33545 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{212.75, 65.6875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003D0000@B000`400?l00000o`00003oe?ooool0
0=Cooooo003Dooooo`00e?ooool00=Cooooo000Iooooo`;o00001?ooool3o`0000Cooooo0ol00004
ooooo`;o000000?oooooo`000?l000000ol000000ooooooo0000o`000007o`0000;ooooo2?l00000
1Ooooooo0000o`000?l0003ooooo00Go00000_ooool2o`000003ooooool0003o000000?o000000Co
ooooo`000?l0003o00001?ooool2o`0006gooooo000Hooooo`04o`000?ooooooooooo`0000;ooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo0000o`0000?ooooo00Go0000oooo
oooooooo0000ooooo`02o`0000;ooooo00Co0000oooooooooooooooo0_l000001?oooooo0000o`00
0?ooool2o`0000;ooooo0_l000001Ooooooo0000o`000?oooooo000000?ooooo00?o0000oooooooo
ool00_l000000ooooooo0000o`000002ooooo`03o`000?oooooooooo00;o000000?oooooo`000?oo
ool00_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo06[ooooo000Hooooo`04
o`000?ooooooooooo`0000Kooooo00Go0000oooooooooooo0000ooooo`02o`0000?ooooo00Go0000
oooooooooooo0000ooooo`02o`0000;ooooo00Ko0000ooooooooooooooooo`000?ooool2o`0000;o
oooo0_l00002ooooo`04o`000?oooooo0000o`0000;ooooo00Go0000ooooooooooooooooo`000002
ooooo`;o000000?oooooo`000?l000000_ooool00ol0003oooooooooo`02o`000003ooooool0003o
oooo00;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`1Zooooo`006?ooool0
1?l0003oooooooooool00006ooooo`05o`000?ooooooooooo`000?ooool00_l00003ooooo`05o`00
0?ooooooooooo`000?ooool00_l00002ooooo`05o`000?ooooooooooooooool000000_ooool00ol0
003oooooooooo`02o`0000;ooooo00Co0000oooooooooooo00000_ooool01_l0003ooooooooooooo
oooo0000ooooo`;o00000_ooool2o`0000;ooooo00Co0000ooooool0003o00000_ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo0000K?ooool001Sooooo00Co0000oooo
oooooooo00000_ooool4o`0000?ooooo00Co0000ooooool0003o00000oooool01Ol0003ooooooooo
ool0003ooooo00;o00000_ooool5o`0000;ooooo0_l000000ooooooo0000o`000002ooooo`03o`00
0?oooooooooo00;o000000?oooooo`000?l000000_l00003ooooo`;o000000?oooooo`000?l00000
0_ooool00ol0003oooooooooo`02o`000003ooooool0003o000000;o00000oooool01?l0003ooooo
ooooool0000Qooooo`;o00000_ooool3o`0000;ooooo1?l00003ooooo`Go000000?oooooo`000?l0
00001_l000000ooooooo0000o`000005o`000003ooooool0003o000000Go000000Coooooo`000?l0
003ooooo1?l00002ooooo`Co00001?ooool2o`0000Wooooo000Hooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool01?ooool4o`0000?ooooo00?o0000ooooooooool01?l00002oooo
o`05o`000?ooooooooooooooool000000_ooool2o`000003ooooool0003o000000;ooooo00?o0000
ooooooooool00_l000000ooooooo0000ooooo`02ooooo`03o`000?oooooooooo00;o000000?ooooo
o`000?l000000_ooool00ol0003oooooooooo`02o`000003ooooool0003ooooo00Gooooo00Co0000
oooooooooooo00008?ooool00ol0003oooooooooo`02o`0000?ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooo`000002ooooo`;o000000?oooooo`000?ooool00_l000001?oooooo0000
o`000?ooool2o`000003ooooool0003o000000;o000000Goooooo`000?l0003o0000ooooo`03o`00
00;ooooo00?o0000ooooooooool00_l000000ooooooo0000ooooo`03o`000004ooooool0003ooooo
o`0000;ooooo00Co0000oooooooooooo00002?ooool001Wooooo0_l00003ooooo`Go00000oooool2
o`0000Gooooo0_l00002ooooo`03o`000?oooooo000000_o00000_ooool2o`000003ooooool0003o
000000go00000_ooool2o`000003ooooool0003o000000So00000oooool2o`00027ooooo00Co0000
oooooooooooo00001?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000000;ooooo
0_l000001Ooooooo0000oooooooooooo000000;ooooo00Go0000oooooooooooo0000ooooo`02o`00
0005ooooool0003oooooooooool000000_ooool00ol0003oooooo`000002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000ooooool0003o00000_ooool00ol0003oooooo`000002ooooo`04o`00
0?ooooooooooo`0000Sooooo000Dooooo`;o0000L_ooool01?l0003oooooooooool00004ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooool000000_ooool2o`000005ooooool0003ooooo
ooooool000000_ooool2o`000003ooooool0003ooooo00;o000000Goooooo`000?l0003oooooo`00
0002ooooo`03o`000?oooooo000000?o00000_ooool00ol0003oooooooooo`02o`000007ooooool0
003oooooooooool0003oooooo`000002ooooo`04o`000?ooooooooooo`0000Sooooo000Cooooo`04
o`000?ooooooooooo`00077ooooo00?o0000ooooooooool01Ol00003ooooo`06o`000?oooooooooo
o`000?oooooo00000_ooool2o`000003ooooool0003ooooo00Co00000_ooool2o`000006ooooool0
003o0000ooooool0003ooooo1_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ool000001Ol00003ooooo`04o`000?ooooooooooo`0000Sooooo000Cooooo`04o`000?oooooooooo
o`0000;oooooCOl0000Rooooo`03o`000?oooooooooo00;o00001Oooool2o`0000;ooooo00?o0000
ooooool000000_ooool2o`000003ooooool0003ooooo00?o00000oooool2o`000006ooooool0003o
0000ooooool0003ooooo0ol000000ooooooo0000o`000003ooooo`03o`000?oooooooooo00;o0000
00?oooooo`000?ooool00ol000000ooooooo0000ooooo`03ooooo`04o`000?ooooooooooo`0000So
oooo000Cooooo`04o`000?ooooooooooo`0000;ooooo00?o0000o`3jV_l0nYX0B?l0nYX00ooooooo
0000ooooo`0Rooooo`;o000000?oooooo`000?l000000ol00002ooooo`?o00000oooool2o`000004
ooooool0003oooooooooo`Oo00000_ooool6o`0000;ooooo1ol000001?oooooo0000o`000?ooool4
o`0000;ooooo1Ol00003ooooo`;o00002Oooool001?ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`19ooooo`03o`000?oooooooooo06cooooo000Cooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0Poooood7o00002oooool0
01Cooooo0_l00003ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool08?ooool00ol0
003oooooo`000002o`00o`07o`000?oooooo0000o`000?oooooo0000ooooo`02o`000003ooooool0
003ooooo00;o000000?oooooo`000?ooool00_l000000ooooooo0000ooooo`02o`000003ooooool0
003ooooo00;o000000?oooooo`000?ooool00_l000000ooooooo0000ooooo`02o`000003ooooool0
003ooooo00;o000000?oooooo`000?ooool00_l000000ooooooo0000ooooo`02o`000003ooooool0
003ooooo00?o00002oooool001Wooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`03
ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`?o00001?ooool00ol0003oooooooooo`02
ooooo`?o00000oooool00ol0003oooooooooo`02o`00oa3ooooo00Co003ooooooooooooo003o9ooo
ool00ol0003oooooooooo`09ooooo`003?ooool5o`0000?ooooo0_l00003ooooo`03o`000?oooooo
oooo04Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00009ooooo`03o`000?oo
oooooooo00?ooooo00Go0000ooooooooooooooooo`000003ooooo`04o`000?ooooooooooo`0000;o
oooo0_l00?l@ooooo`;o003o00?oooooo`00ooooool09_ooool00ol0003oooooooooo`09ooooo`00
3Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool0BOooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`05o`000?ooooooooooo`000?ooool00ol0
0?l@ooooo`Go003o9_ooool00ol0003oooooooooo`09ooooo`003_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0BOooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00;o00000_l00?l00ooooooo003oooooo`06ooooo`?o003o
1Oooool5o`00obKooooo00?o0000ooooooooool02Oooool000oooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00009ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000000ol00003oooo
o`06o`000?oooooo003oo`00oooooooo003o1oooool3o`00o`Cooooo1_l00?l3ooooo`03o`00oooo
oooooooo023ooooo00?o0000ooooooooool02Oooool000cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0BOooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Sooooo0ol00002ooooo`06o`000?oooooo0000oooo
ool0003ooooo1Ol00002ooooo`06o`000?oooooo003oo`00oooooooo003o1_ooool4o`00o`Cooooo
00?o003oooooool00?l00ol00?l01?oooooo003oo`00ool00?lRooooo`03o`000?oooooooooo00Wo
oooo000<ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo04Wooooo00?o0000ooooooooool00oooool2o`0000Wooooo0_l000000ooo
oooo0000ooooo`05o`000003ooooool0003o000000?o00000_ooool00ol0003oooooo`00o`02oooo
o`;o003o1Oooool4o`00o`06ooooool00?ooooooooooool00?oooooo1?l00?l01?oooooo003oo`00
ool00?lRooooo`03o`000?oooooooooo00Wooooo000=ooooo`?o00001?ooool2o`0000?ooooo00?o
0000ooooooooool0BOooool00ol0003oooooooooo`0>ooooo`04o`000?ooooooooooo`0000Wooooo
00?o0000ooooooooool00_ooool00ol0003oooooo`00o`02ooooo`;o003o00Coooooo`00oooooooo
oooo0ol00?l01?oooooo003oooooool00?l2ooooo`03o`00oooooooooooo00?o003o00Coooooo`00
ool00?oo003o8_ooool00ol0003oooooooooo`09ooooo`006Oooool00ol0003oooooooooo`19oooo
o`03o`000?oooooooooo00kooooo00Co0000oooooooooooo00002_ooool01?l0003ooooooooooooo
ool2o`000003o`00oooooooooooo00Co003o0_ooool3o`00o`04ooooool00?oo003oo`00o`;ooooo
00Co003ooooooooooooooooo1_l00?lRooooo`03o`000?oooooooooo00Wooooo000Iooooo`03o`00
0?oooooooooo04Wooooo00?o0000ooooooooool03_ooool01?l0003oooooooooool00007ooooo`05
o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`02ooooo`Co003o00Koooooo`00
ool00?ooooooo`00ooooool3o`00o`03ooooool00?oo003o00Cooooo1_l00?lQooooo`03o`000?oo
oooooooo00Wooooo000>ooooo`?o00000oooool2o`0000?ooooo00?o0000ooooooooool0BOooool0
0ol0003oooooooooo`03ooooo`;o00001?ooool01?l0003oooooooooooooool5o`000003ooooool0
003o000000?o000000?oooooo`000?l000000ol00002ooooo`03o`000?oooooooooo00?ooooo0ol0
0?l01_oooooo003oo`00oooooooo003oooooo`Go003o1_ooool00ol00?ooooooo`00o`02o`00ob7o
oooo00?o0000ooooooooool02Oooool000oooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0004_ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00008
ooooo`Co00000_ooool01Ol0003oooooooooool0003ooooo00Go00000_ooool00ol0003ooooooooo
o`03ooooo`?o003o00?oooooo`00ool00?l00oooool5o`00o`Sooooo00?o003oooooool00?l08Ooo
ool00ol0003oooooooooo`09ooooo`003?ooool5o`0000;ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
2Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo
00001Oooool3o`00o`03ooooool00?oo003o00?ooooo1Ol00?l8ooooo`04o`00oooooooo003oo`00
ob3ooooo00?o0000ooooooooool02Oooool000cooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool0000:ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`02o`0000Cooooo0ol00?l00ooooooo003oo`00o`03ooooo`Go003o2_oo
ool2o`00ob3ooooo00?o0000ooooooooool02Oooool000gooooo00?o0000ooooool000000oooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00007ooooo`07o`000?ooooooooooooooool0003oooooo`000003oooo
o`03o`000?oooooo000000?o00000oooool00ol0003oooooooooo`03ooooo`;o003o00?oooooo`00
ool00?l01_ooool2o`00o`_ooooo0_l00?lIooooo`03o`00oooooooooooo00Cooooo00?o0000oooo
ooooool02Oooool000kooooo0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool0BOooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo0_l00002
ooooo`06o`000?oooooo0000ooooool0003ooooo1Ol000000ooooooo0000o`000002o`0000?ooooo
00?o0000ooooooooool00oooool01?l00?ooooooooooool00?lEooooo`03o`00oooooooooooo01Oo
oooo0ol00?l4ooooo`03o`000?oooooooooo00Wooooo000?ooooo`03o`000?oooooooooo00;ooooo
0_l00003ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool00oooool2o`0000?ooooo
00Co0000oooooooooooo00000_ooool3o`0000?ooooo1?l000000ooooooo0000o`000003o`0000;o
oooo00?o0000ooooooooool01_ooool00ol00?ooooooooooo`0Cooooo`;o003o6?ooool3o`00o`Co
oooo00?o0000ooooooooool02Oooool001Wooooo00?o0000ooooooooool0BOooool00ol0003ooooo
ooooo`08ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01Oooool01?l0003o
ooooooooool0000Nooooo`;o003o6?ooool3o`00o`Cooooo00?o0000ooooooooool02Oooool000go
oooo0ol00004ooooo`;o00000oooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo00So
oooo00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00;o00007Oooool2o`00o`cooooo00?o003oooooooooool01oooool01Ol00?ooooooo`00oooooooo
003o00Cooooo00?o0000ooooooooool02Oooool000cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0BOooool00ol0003ooooooooo
o`08ooooo`04o`000?ooooooooooo`0000Oooooo00Ko0000ooooooooooooooooo`000?ooool4o`00
00?ooooo00?o0000ooooooooool07?ooool3o`00o`_ooooo00?o003oooooooooool01oooool01Ol0
0?ooooooo`00oooooooo003o00;ooooo00?o003oooooool000002oooool000cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0BOoo
ool00ol0003oooooooooo`03ooooo`;o00000oooool2o`000003ooooool0003ooooo00Go000000Oo
ooooo`000?oooooo0000ooooool0003ooooo00Co00000oooool00ol0003oooooooooo`0Mooooo`;o
003o2oooool2o`00o`;ooooo00?o003oooooooooool00_ooool4o`00o`04ooooool00?oooooooooo
o`;o003o00?o0000ooooooooool02Oooool000cooooo1?l00003ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000?ooooo0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo0ol00002ooooo`Go00000_oo
ool00ol0003oooooooooo`0Nooooo`03o`00oooooooooooo00Wooooo0_l00?l2ooooo`03o`00oooo
oooooooo00;ooooo1?l00?l01ooooooo003ooooooooooooo003oooooool000002oooool000cooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo04Wo
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000Pooooo`03o`00oooooooo
oooo00Wooooo0ol00?l00ooooooo003oooooo`02ooooo`Go003o00Ooooooo`00ooooooooooooo`00
oooooooo000000_ooooo000=ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00002_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00_l0000Oooooo`03o`00oooooooooooo00Wooooo0ol00?l00ooooooo003oooooo`02ooooo`;o
003o00Goooooo`00ool00?ooooooo`00o`02ooooo`03o`00oooooooo000000_ooooo000>ooooo`;o
00001?ooool2o`0000?ooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooo
000000?o00000oooool00ol0003oooooooooo`0Nooooo`03o`00oooooooooooo00Wooooo0ol00?l0
0ooooooo003oooooo`02ooooo`;o003o00?oooooo`00ool00?l00_ooool3o`00o`03ooooool0003o
oooo00[ooooo000Iooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00007ooooo`07o`000?ooooooooooooooool0003oooooo`000003ooooo`03o`00
0?oooooo000000Kooooo00?o0000ooooooooool07oooool00ol00?ooooooooooo`03ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooool00?l00_l00?l2ooooo`?o003o00?oooooo`00ooooool0
0_ooool3o`00o`03ooooool0003ooooo00[ooooo000=ooooo`?o00001?ooool2o`0000?ooooo00?o
0000ooooooooool0BOooool00ol0003oooooooooo`03ooooo`;o00002Oooool3o`0000;ooooo1Ol0
00000ooooooo0000o`000003o`0000;ooooo00?o0000ooooooooool07oooool00ol00?oooooooooo
o`03ooooo`03o`00oooooooooooo00;ooooo00?o003oooooool00?l00ol00?l00ooooooo003ooooo
o`06ooooo`?o003o00?oooooo`000?ooool02_ooool000cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0>_ooool00ol00?oooooo
ooooo`03ooooo`;o003o1oooool00ol0003oooooooooo`0>ooooo`04o`000?ooooooooooo`0000Oo
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo01oooooo00?o003ooooo
ooooool00oooool2o`00o`?ooooo00So003oooooool00?oo003oooooool00?ooooooo`00o`Oooooo
0ol00?l00ooooooo0000ooooo`0:ooooo`003?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0jooooo`;o003o1?ooool3o`00o`?o
oooo0_l00?l00ooooooo0000ooooo`0?ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000oooo
ooooool00_l0000Pooooo`;o003o1?ooool2o`00o`?ooooo00Go003oooooool00?oo003oooooo`03
o`00o`Oooooo0ol00?l00ooooooo0000ooooo`0:ooooo`003Oooool3o`0000?ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`0hooooo`Co003o00?oooooo`00ool00?l00_l00?l0
0ooooooo003oo`00o`03o`00o`;ooooo00?o0000ooooooooool03_ooool01?l0003oooooooooool0
0009ooooo`;o00000oooool00ol0003oooooooooo`0Oooooo`?o003o0_ooool3o`00o`;ooooo00?o
003oooooooooool00_l00?l01?oooooo003oo`00ool00?l7ooooo`;o003o0_ooool00ol0003ooooo
ooooo`09ooooo`003?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`0]ooooo`;o003o1?ooool01Ol00?ooooooo`00ool00?oooooo
00;o003o0_ooool4o`00o`;ooooo0_l00?l5ooooo`03o`000?oooooooooo00kooooo00Co0000oooo
oooooooo00002oooool01?l0003oooooooooool0000Qooooo`?o003o0_ooool00ol00?ooooooo`00
o`02ooooo`06o`00ooooooooooooooooool00?oooooo0_l00?l8ooooo`05o`00oooooooooooooooo
ool000002oooool000cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0;Oooool2o`00o`?ooooo1ol00?l3ooooo`03o`00oooooooo
oooo00[ooooo00?o0000ooooooooool00oooool2o`0000Cooooo00?o0000ooooooooool00_ooool4
o`000003ooooool0003o000000?o000000?oooooo`000?l000000ol00002ooooo`03o`000?oooooo
oooo01oooooo0ol00?l01Ooooooo003oo`00oooooooo003o00;ooooo00Go003ooooooooooooooooo
o`00o`02ooooo`03o`00oooooooooooo00Kooooo00Go003oooooooooooooooooo`00000;ooooo`00
3Oooool3o`0000Cooooo0_l00003ooooo`03o`000?oooooooooo00?ooooo0ol00?lVooooo`04o`00
ooooooooooooo`00o`;ooooo00?o003oooooool00?l00_l00?lBooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooo`000002o`0000;ooooo00Go0000oooo
oooooooo0000ooooo`05o`0000;ooooo00?o0000ooooooooool07oooool5o`00o`;ooooo1?l00?lC
ooooo`03o`000?oooooooooo00Wooooo000Iooooo`03o`000?oooooooooo00?ooooo1Ol00?lSoooo
o`;o003o0_ooool3o`00oaOooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000;
ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`02o`00023ooooo1Ol0
0?l3ooooo`?o003o4oooool00ol0003oooooooooo`09ooooo`006Oooool00ol0003oooooooooo`02
ooooo`;o003o0_ooool3o`00o`Oooooo00?o003oooooooooool05?ooool01?l00?oooooooooooooo
ool2o`00o`Cooooo00?o003oooooooooool05Oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000Wooooo0_l00005ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00008Oooool2o`00o`03ooooool00?oo003o00?ooooo0ol00?lCooooo`03o`000?oooooooooo00Wo
oooo0007ooooo`?o00001?ooool2o`0000Cooooo0_l00003ooooo`03o`000?oooooooooo00?o003o
1Oooool01_l00?ooooooooooool00?ooooooo`00o`;ooooo0ol00?l9ooooo`03o`00oooooooooooo
00Kooooo1Ol00?l00ooooooo003oo`00o`0Looooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00002oooool00ol0003oooooo`000003ooooo`03o`000?oooooo000000?o00000oooool0
0ol0003oooooooooo`0Oooooo`03o`00oooooooooooo00;o003o0oooool3o`00oa?ooooo00?o0000
ooooooooool02Oooool000Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooool00?l00ol00?l5ooooo`Oo003o00Ko
ooooo`00oooooooo003oooooool00?l7ooooo`Co003o00?oooooo`00ool00?l01?l00?l01?oooooo
003oo`00ool00?lNooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool0
1ol0003ooooooooooooooooo0000ooooool000000oooool00ol0003oooooo`000006ooooo`03o`00
0?oooooooooo02;ooooo0_l00?l4ooooo`03o`00oooooooooooo01;ooooo00?o0000ooooooooool0
2Oooool000Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000o`00ool00?oo003o2Oooool01?l00?ooooooooooooooool2
o`00o`?ooooo0ol00?l4ooooo`;o003o00?oooooo`00ool00?l01Ol00?l2ooooo`04o`00oooooooo
ooooo`00oaoooooo00?o0000ooooooooool00oooool2o`0000Wooooo0ol00003ooooo`?o00000_oo
ool5o`0000;ooooo00?o0000ooooool000001oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00o`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool01Ol0003ooooooooooooooooo000000_ooooo
0008ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00oooooo00Co003ooooooooooooooooo1?l00?l2oooo
o`?o003o1?ooool00ol00?ooooooooooo`0Vooooo`03o`000?oooooooooo023ooooo@Ol0000;oooo
o`002?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`0Eooooo`?o003o00?oooooo`00ooooool0;_ooool0
0ol0003oooooooooo`1/ooooo`001oooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Oooooo0_l00?l`ooooo`03o`000?oo
oooooooo06cooooo0008ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00000oooool2
o`0000Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`05o`00oooooooo
ooooooooool000002Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06cooooo000I
ooooodgo0000K_ooool00=Cooooo003Dooooo`00e?ooool00001\
\>"],
  ImageRangeCache->{{{0, 211.75}, {64.6875, 0}} -> {-0.0621437, -0.0154541, \
0.0100321, 0.0100321}, {{6.1875, 105.875}, {63.125, 1.5}} -> {-135.015, \
-35.5531, 5.00663, 2.40882}, {{105.875, 205.5}, {63.125, 1.5}} -> {-829.546, \
0.0666133, 6.00279, 0.00494361}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Selektion (w\[ODoubleDot]chentlich)", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["ZM = Shape[miss,{T+1,k}];", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["tau = Range[1,T+1,7]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({1, 8, 15, 22, 29, 36, 43, 50, 57, 64, 71, 78, 85, 92, 99, 106, 113, 
      120, 127, 134, 141, 148, 155, 162, 169, 176, 183, 190, 197, 204, 211, 
      218, 225, 232, 239, 246, 253, 260, 267, 274, 281, 288, 295, 302, 309, 
      316, 323, 330, 337, 344, 351, 358, 365}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Map[(ZM[[#]]=Z[[#]])&,tau];
ZM//Dimensions
ZM//Short
ZM//Last\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({366, 1}\)], "Output"],

Cell[BoxData[
    TagBox[\({{100.00647274709044`}, {\(-9\)}, {\(-9\)}, {\(-9\)}, {\(-9\)}, \
{\(-9\)}, {\(-9\)}, \[LeftSkeleton]352\[RightSkeleton], {\(-9\)}, {\(-9\)}, {\
\(-9\)}, {\(-9\)}, {\(-9\)}, {79.02167602641913`}, {\(-9\)}}\),
      Short]], "Output"],

Cell[BoxData[
    \({\(-9\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Z//Short", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    TagBox[\({{100.00647274709044`}, {100.06627707828922`}, \
{99.46778774608588`}, \[LeftSkeleton]361\[RightSkeleton], \
{79.02167602641913`}, {77.1786294002852`}}\),
      Short]], "Output"]
}, Open  ]],

Cell[TextData[{
  "logZM=(ZM//",
  StyleBox["Log)",
    FontColor->RGBColor[1, 0, 0]],
  "/.(Log[-9]->-9);"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["plot1[Log[Z]]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 1}\),
      SequenceForm[ "Dimension der Daten  ", {366, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 2}\),
      SequenceForm[ "Dimension der Daten  ", {366, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -7.14937 1.65356 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04362 -24 -4.5 ]
[-0.0125 .04362 0 4.5 ]
[-0.0125 .1263 -18 -4.5 ]
[-0.0125 .1263 0 4.5 ]
[-0.0125 .20898 -24 -4.5 ]
[-0.0125 .20898 0 4.5 ]
[-0.0125 .29166 -18 -4.5 ]
[-0.0125 .29166 0 4.5 ]
[-0.0125 .37434 -24 -4.5 ]
[-0.0125 .37434 0 4.5 ]
[-0.0125 .45701 -18 -4.5 ]
[-0.0125 .45701 0 4.5 ]
[-0.0125 .53969 -24 -4.5 ]
[-0.0125 .53969 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .03721 -5 -6 ]
[.97619 .03721 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04362 m
.00625 .04362 L
s
[(4.35)] -0.0125 .04362 1 0 Mshowa
0 .1263 m
.00625 .1263 L
s
[(4.4)] -0.0125 .1263 1 0 Mshowa
0 .20898 m
.00625 .20898 L
s
[(4.45)] -0.0125 .20898 1 0 Mshowa
0 .29166 m
.00625 .29166 L
s
[(4.5)] -0.0125 .29166 1 0 Mshowa
0 .37434 m
.00625 .37434 L
s
[(4.55)] -0.0125 .37434 1 0 Mshowa
0 .45701 m
.00625 .45701 L
s
[(4.6)] -0.0125 .45701 1 0 Mshowa
0 .53969 m
.00625 .53969 L
s
[(4.65)] -0.0125 .53969 1 0 Mshowa
.125 Mabswid
0 .06016 m
.00375 .06016 L
s
0 .07669 m
.00375 .07669 L
s
0 .09323 m
.00375 .09323 L
s
0 .10977 m
.00375 .10977 L
s
0 .14284 m
.00375 .14284 L
s
0 .15937 m
.00375 .15937 L
s
0 .17591 m
.00375 .17591 L
s
0 .19244 m
.00375 .19244 L
s
0 .22552 m
.00375 .22552 L
s
0 .24205 m
.00375 .24205 L
s
0 .25859 m
.00375 .25859 L
s
0 .27512 m
.00375 .27512 L
s
0 .30819 m
.00375 .30819 L
s
0 .32473 m
.00375 .32473 L
s
0 .34126 m
.00375 .34126 L
s
0 .3578 m
.00375 .3578 L
s
0 .39087 m
.00375 .39087 L
s
0 .40741 m
.00375 .40741 L
s
0 .42394 m
.00375 .42394 L
s
0 .44048 m
.00375 .44048 L
s
0 .47355 m
.00375 .47355 L
s
0 .49009 m
.00375 .49009 L
s
0 .50662 m
.00375 .50662 L
s
0 .52316 m
.00375 .52316 L
s
0 .02709 m
.00375 .02709 L
s
0 .01055 m
.00375 .01055 L
s
0 .55623 m
.00375 .55623 L
s
0 .57276 m
.00375 .57276 L
s
0 .5893 m
.00375 .5893 L
s
0 .60583 m
.00375 .60583 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04362 m
1 .04362 L
s
.99375 .1263 m
1 .1263 L
s
.99375 .20898 m
1 .20898 L
s
.99375 .29166 m
1 .29166 L
s
.99375 .37434 m
1 .37434 L
s
.99375 .45701 m
1 .45701 L
s
.99375 .53969 m
1 .53969 L
s
.125 Mabswid
.99625 .06016 m
1 .06016 L
s
.99625 .07669 m
1 .07669 L
s
.99625 .09323 m
1 .09323 L
s
.99625 .10977 m
1 .10977 L
s
.99625 .14284 m
1 .14284 L
s
.99625 .15937 m
1 .15937 L
s
.99625 .17591 m
1 .17591 L
s
.99625 .19244 m
1 .19244 L
s
.99625 .22552 m
1 .22552 L
s
.99625 .24205 m
1 .24205 L
s
.99625 .25859 m
1 .25859 L
s
.99625 .27512 m
1 .27512 L
s
.99625 .30819 m
1 .30819 L
s
.99625 .32473 m
1 .32473 L
s
.99625 .34126 m
1 .34126 L
s
.99625 .3578 m
1 .3578 L
s
.99625 .39087 m
1 .39087 L
s
.99625 .40741 m
1 .40741 L
s
.99625 .42394 m
1 .42394 L
s
.99625 .44048 m
1 .44048 L
s
.99625 .47355 m
1 .47355 L
s
.99625 .49009 m
1 .49009 L
s
.99625 .50662 m
1 .50662 L
s
.99625 .52316 m
1 .52316 L
s
.99625 .02709 m
1 .02709 L
s
.99625 .01055 m
1 .01055 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57276 m
1 .57276 L
s
.99625 .5893 m
1 .5893 L
s
.99625 .60583 m
1 .60583 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .03721 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .46567 m
.02642 .46666 L
.02903 .45674 L
.03164 .45197 L
.03425 .44081 L
.03686 .45452 L
.03947 .44375 L
.04207 .43527 L
.04468 .42228 L
.04729 .41831 L
.0499 .39756 L
.05251 .39411 L
.05512 .38832 L
.05773 .40726 L
.06034 .41371 L
.06295 .41401 L
.06556 .40321 L
.06817 .38888 L
.07078 .40253 L
.07339 .36558 L
.07599 .35338 L
.0786 .34758 L
.08121 .30602 L
.08382 .27638 L
.08643 .26496 L
.08904 .26755 L
.09165 .26571 L
.09426 .27091 L
.09687 .29864 L
.09948 .30206 L
.10209 .29767 L
.1047 .2686 L
.10731 .27168 L
.10992 .28593 L
.11252 .27508 L
.11513 .27671 L
.11774 .31093 L
.12035 .3188 L
.12296 .30024 L
.12557 .31687 L
.12818 .32293 L
.13079 .35363 L
.1334 .33233 L
.13601 .3107 L
.13862 .29607 L
.14123 .32535 L
.14384 .33247 L
.14644 .34137 L
.14905 .35874 L
.15166 .38782 L
Mistroke
.15427 .40655 L
.15688 .40128 L
.15949 .40585 L
.1621 .43772 L
.16471 .42878 L
.16732 .43927 L
.16993 .43123 L
.17254 .43299 L
.17515 .40213 L
.17776 .43683 L
.18037 .44527 L
.18297 .42607 L
.18558 .41347 L
.18819 .38542 L
.1908 .41525 L
.19341 .42413 L
.19602 .44094 L
.19863 .42176 L
.20124 .43019 L
.20385 .41223 L
.20646 .42172 L
.20907 .39921 L
.21168 .39332 L
.21429 .38098 L
.21689 .40919 L
.2195 .42307 L
.22211 .40218 L
.22472 .41435 L
.22733 .43344 L
.22994 .45419 L
.23255 .47897 L
.23516 .47447 L
.23777 .4875 L
.24038 .48086 L
.24299 .48757 L
.2456 .46593 L
.24821 .43515 L
.25082 .39161 L
.25342 .36672 L
.25603 .35141 L
.25864 .36914 L
.26125 .39056 L
.26386 .36991 L
.26647 .36594 L
.26908 .36268 L
.27169 .36431 L
.2743 .39257 L
.27691 .42023 L
.27952 .43009 L
.28213 .43285 L
Mistroke
.28474 .42392 L
.28735 .4696 L
.28995 .50341 L
.29256 .50311 L
.29517 .48643 L
.29778 .46804 L
.30039 .4775 L
.303 .48983 L
.30561 .49733 L
.30822 .46233 L
.31083 .43304 L
.31344 .44677 L
.31605 .46055 L
.31866 .49667 L
.32127 .50272 L
.32387 .52443 L
.32648 .53245 L
.32909 .51555 L
.3317 .5275 L
.33431 .54454 L
.33692 .5518 L
.33953 .55433 L
.34214 .56436 L
.34475 .59539 L
.34736 .59043 L
.34997 .59432 L
.35258 .58211 L
.35519 .60332 L
.3578 .58855 L
.3604 .56182 L
.36301 .5667 L
.36562 .51896 L
.36823 .51145 L
.37084 .50986 L
.37345 .50235 L
.37606 .50176 L
.37867 .49637 L
.38128 .497 L
.38389 .48502 L
.3865 .47853 L
.38911 .46755 L
.39172 .44637 L
.39432 .46814 L
.39693 .46159 L
.39954 .49266 L
.40215 .47228 L
.40476 .4291 L
.40737 .3711 L
.40998 .39493 L
.41259 .39995 L
Mistroke
.4152 .4067 L
.41781 .4144 L
.42042 .42782 L
.42303 .42271 L
.42564 .42851 L
.42825 .44602 L
.43085 .4438 L
.43346 .43683 L
.43607 .44263 L
.43868 .46335 L
.44129 .46665 L
.4439 .43271 L
.44651 .42998 L
.44912 .42075 L
.45173 .42491 L
.45434 .44999 L
.45695 .47876 L
.45956 .49725 L
.46217 .49148 L
.46477 .5013 L
.46738 .49112 L
.46999 .47744 L
.4726 .44509 L
.47521 .43376 L
.47782 .42752 L
.48043 .42986 L
.48304 .43319 L
.48565 .44183 L
.48826 .45182 L
.49087 .45518 L
.49348 .48109 L
.49609 .45805 L
.4987 .45856 L
.5013 .43992 L
.50391 .40885 L
.50652 .40149 L
.50913 .40981 L
.51174 .40655 L
.51435 .43826 L
.51696 .42249 L
.51957 .42205 L
.52218 .41577 L
.52479 .40467 L
.5274 .39768 L
.53001 .42508 L
.53262 .43103 L
.53523 .46598 L
.53783 .44723 L
.54044 .39602 L
.54305 .38727 L
Mistroke
.54566 .39668 L
.54827 .39186 L
.55088 .32577 L
.55349 .33002 L
.5561 .33021 L
.55871 .34247 L
.56132 .36616 L
.56393 .36957 L
.56654 .35976 L
.56915 .37661 L
.57175 .40524 L
.57436 .39873 L
.57697 .43118 L
.57958 .40116 L
.58219 .4487 L
.5848 .40093 L
.58741 .41936 L
.59002 .4272 L
.59263 .42714 L
.59524 .41794 L
.59785 .43529 L
.60046 .3599 L
.60307 .33572 L
.60568 .30471 L
.60828 .29401 L
.61089 .32574 L
.6135 .34927 L
.61611 .36528 L
.61872 .34741 L
.62133 .30233 L
.62394 .2475 L
.62655 .2213 L
.62916 .20689 L
.63177 .15381 L
.63438 .1565 L
.63699 .14023 L
.6396 .17089 L
.6422 .13986 L
.64481 .18356 L
.64742 .18323 L
.65003 .18872 L
.65264 .26356 L
.65525 .23899 L
.65786 .23645 L
.66047 .26174 L
.66308 .27344 L
.66569 .28664 L
.6683 .30886 L
.67091 .28408 L
.67352 .31265 L
Mistroke
.67613 .30686 L
.67873 .28014 L
.68134 .31717 L
.68395 .31741 L
.68656 .31747 L
.68917 .28331 L
.69178 .24547 L
.69439 .25576 L
.697 .25912 L
.69961 .23391 L
.70222 .21379 L
.70483 .22025 L
.70744 .22518 L
.71005 .18445 L
.71265 .17767 L
.71526 .19555 L
.71787 .18713 L
.72048 .21514 L
.72309 .23982 L
.7257 .19109 L
.72831 .20857 L
.73092 .21062 L
.73353 .22894 L
.73614 .22975 L
.73875 .19729 L
.74136 .17736 L
.74397 .15675 L
.74658 .22443 L
.74918 .23192 L
.75179 .20404 L
.7544 .19185 L
.75701 .20888 L
.75962 .20385 L
.76223 .21454 L
.76484 .21479 L
.76745 .18813 L
.77006 .16752 L
.77267 .18123 L
.77528 .16047 L
.77789 .08308 L
.7805 .13159 L
.78311 .14445 L
.78571 .14966 L
.78832 .1241 L
.79093 .10377 L
.79354 .10233 L
.79615 .08306 L
.79876 .07597 L
.80137 .06239 L
.80398 .01895 L
Mistroke
.80659 .03753 L
.8092 .07064 L
.81181 .05775 L
.81442 .04259 L
.81703 .07867 L
.81963 .09751 L
.82224 .14471 L
.82485 .16396 L
.82746 .17243 L
.83007 .19305 L
.83268 .15872 L
.83529 .14648 L
.8379 .10609 L
.84051 .13046 L
.84312 .10997 L
.84573 .09369 L
.84834 .11953 L
.85095 .1341 L
.85356 .15093 L
.85616 .12502 L
.85877 .11881 L
.86138 .08774 L
.86399 .09338 L
.8666 .09747 L
.86921 .1066 L
.87182 .13783 L
.87443 .09847 L
.87704 .03044 L
.87965 .01472 L
.88226 .04427 L
.88487 .05684 L
.88748 .06702 L
.89008 .04593 L
.89269 .03393 L
.8953 .02337 L
.89791 .05098 L
.90052 .07799 L
.90313 .0767 L
.90574 .08263 L
.90835 .11279 L
.91096 .14461 L
.91357 .176 L
.91618 .16544 L
.91879 .13354 L
.9214 .13591 L
.92401 .12292 L
.92661 .10117 L
.92922 .10831 L
.93183 .10343 L
.93444 .10732 L
Mistroke
.93705 .12288 L
.93966 .12216 L
.94227 .10802 L
.94488 .10158 L
.94749 .10595 L
.9501 .08989 L
.95271 .10081 L
.95532 .06275 L
.95793 .09527 L
.96053 .08586 L
.96314 .06269 L
.96575 .03358 L
.96836 .04729 L
.97097 .05691 L
.97358 .07624 L
.97619 .03721 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{212.438, 131.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003D0000Pb000`400?l00000o`00003oe?ooool0
0=Cooooo003Dooooo`00e?ooool001gooooo0_l0000Booooo`?o00001?ooool2o`0000cooooo0ol0
0004ooooo`;o00001?ooool2o`0000Wooooo0ol00003ooooo`?o00001?ooool2o`0000Sooooo1Ol0
0003ooooo`;o00001?ooool2o`0000Wooooo1Ol00002ooooo`?o00001?ooool2o`0000Wooooo0ol0
0004ooooo`;o00001?ooool2o`0000Wooooo0ol00003ooooo`?o00001?ooool2o`0000Kooooo000L
ooooo`04o`000?ooooooooooo`00013ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0000Wooooo00Go0000ooooooooooooooooo`000003ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00002Oooool01_l0003oooooooooool0
003oooooo`0000?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000Oooooo00Oo0000ooooooooooooooooo`000?oooooo000000?ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`03ooooo`007?ooool01?l0003oooooooooool0000Doooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00002Oooool00ol0003ooooo
ooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00002_ooool0
0ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02Ooo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool00oooool001cooooo00Co0000oooooooooooo00005?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01Oooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Sooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`04
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01oooool2o`0000?ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool00009ooooo`;o00001_ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00?ooooo000Looooo`04o`000?ooooooooooo`00
013ooooo1?l00003ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Wooooo00Co0000oooooooooooo
oooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00002?ooool01_l0003ooooo
oooooooooooo0000ooooo`Co00000oooool01?l0003oooooooooool0000;ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooo000000?o00000oooool01?l0003oooooooooool00005ooooo`007?ooool01?l0003ooooo
ooooool0000@ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002oooool2o`00
00Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00008ooooo`;o00000ooo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00002?ooool0
1ol0003ooooooooooooooooo0000ooooool000001_ooool01?l0003oooooooooool00007ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000Oooooo00Oo0000ooooooooooooooooo`000?oooooo000000Kooooo00Co0000oooooooo
oooo00001Oooool001gooooo0_l0000Aooooo`Go00000oooool2o`0000gooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l0000:ooooo`04o`000?ooooooooooooooo`Go00000oooool2o`00
00Wooooo0ol00004ooooo`;o00001?ooool2o`0000[ooooo0ol00002ooooo`Go00000oooool2o`00
00Wooooo0ol00004ooooo`;o00001?ooool2o`0000Wooooo0ol00002ooooo`Go00000oooool2o`00
00Kooooo003Dooooo`00e?ooool00=Cooooo000JoooookWo00000Oooool001[ooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooo
oooooooo000000Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool01ol0003ooooooooo
oooooooo0000ooooool000000Oooool001[ooooo0_l0002fooooo`7o00000Oooool001[ooooo00?o
0000ooooooooool0Woooool00ol00?ooooooooooo`0Cooooo`7o00000Oooool001[ooooo00?o0000
ooooooooool0TOooool00ol00?ooooooooooo`0;ooooo`04o`00ooooooooooooo`00oa;ooooo0Ol0
0001ooooo`006_ooool2o`0009;ooooo00?o003oooooooooool02oooool01?l00?ooooooooooool0
0?lBooooo`7o00000Oooool000;ooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00003
ooooo`?o00001?ooool00ol0003oooooooooo`2Aooooo`;o003o3?ooool2o`00o`03ooooool00?oo
oooo00_ooooo00?o003oooooooooool00oooool1o`00007ooooo0003ooooo`03o`000?oooooooooo
00Kooooo00Oo0000ooooooooooooooooo`000?oooooo000000?ooooo00Go0000oooooooooooooooo
o`00002Cooooo`;o003o3?ooool2o`00o`03ooooool00?oooooo00_ooooo00?o003oooooool00?l0
0oooool1o`00007ooooo0005o`0000_ooooo00?o0000ooooooooool00oooool01?l0003ooooooooo
ooooool2o`0009;ooooo0ol00?l;ooooo`Co003o3?ooool00ol00?ooooooo`00o`02ooooo`;o0000
0Oooool00004o`000?ooooooooooo`0000[ooooo0_l00006ooooo`05o`000?ooooooooooooooool0
0000Toooool3o`00o`_ooooo1?l00?l<ooooo`03o`00oooooooo003o00?ooooo0Ol00001ooooo`00
00Coooooo`000?oooooo00003?ooool00ol0003oooooo`000003o`0000Cooooo00?o0000oooooooo
ool0TOooool3o`00o`_ooooo1?l00?l<ooooo`03o`00oooooooo003o00?ooooo0Ol00001ooooo`00
0_ooool2o`0000Sooooo00Oo0000ooooooooooooooooo`000?oooooo000000Oooooo0_l0002Boooo
o`?o003o2oooool4o`00o`cooooo0_l00?l4ooooo`7o00000Oooool000?ooooo00?o0000oooooooo
ool01oooool3o`0000;ooooo1Ol00003ooooo`03o`000?oooooooooo097ooooo1?l00?l:ooooo`05
o`00oooooooo003oooooool00?l02Oooool01?l00?ooooooo`00ool00?l4ooooo`7o00000Oooool0
01[ooooo00?o0000ooooooooool0TOooool2o`00o`03ooooool00?oooooo00Sooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`07ooooo`04o`00oooooooo003oo`00o`Cooooo0Ol00001
ooooo`006_ooool2o`00097ooooo00Go003oooooooooooooooooo`00o`09ooooo`03o`00oooooooo
oooo00;ooooo00?o003oooooooooool01oooool01?l00?ooooooo`00ool00?l4ooooo`7o00000Ooo
ool001[ooooo00?o0000ooooooooool0S?ooool01Ol00?oooooooooooooooooo003o00?ooooo00?o
003oooooooooool01oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Kooooo0_l0
0?l6ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0S?ooool01Ol00?oooooooooooooo
oooo003o00?ooooo00?o003oooooooooool01Oooool00ol00?ooooooo`00o`05ooooo`03o`00oooo
oooooooo00Kooooo0_l00?l6ooooo`7o00000Oooool001[ooooo0_l0002=ooooo`05o`00oooooooo
ooooooooool00?l00oooool00ol00?ooooooooooo`02ooooo`06o`00ooooooooooooo`00oooooooo
003o1Oooool00ol00?ooooooooooo`05ooooo`?o003o1_ooool1o`00007ooooo000Jooooo`03o`00
0?oooooooooo08cooooo00Co003ooooooooooooo003o1?ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00?o003o1Oooool00ol00?ooooooooooo`05ooooo`?o003o1_ooool1o`00007o
oooo000Jooooo`03o`000?oooooooooo08cooooo00Co003ooooooooooooo003o1?ooool01?l00?oo
ooooooooooooool2o`00o`;ooooo0ol00?l5ooooo`04o`00ooooooooooooooooo`;o003o00Cooooo
o`00ool00?oo003o1oooool1o`00007ooooo000Jooooo`;o0000SOooool2o`00o`03ooooool00?oo
oooo00?ooooo00?o003oooooooooool00ol00?l00ooooooo003oooooo`02o`00o`Gooooo00Co003o
oooooooooooooooo0_l00?l00ooooooo003oo`00o`08ooooo`7o00000Oooool000Sooooo0ol00003
ooooo`03o`000?oooooooooo00?ooooo0ol00003ooooo`03o`000?oooooooooo08cooooo0_l00?l0
0ooooooo003oooooo`03ooooo`03o`00oooooooooooo00?o003o00?oooooo`00ooooool00_l00?l5
ooooo`04o`00ooooooooooooooooo`;o003o00?oooooo`00ooooool02?ooool1o`00007ooooo0009
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2<
ooooo`?o003o1Oooool00ol00?ooooooooooo`03o`00o`03ooooool00?oooooo00;o003o1Oooool0
1?l00?ooooooooooool00?l2ooooo`03o`00oooooooooooo00Sooooo0Ol00001ooooo`001_ooool5
o`0000Oooooo1Ol00003ooooo`;o0000SOooool3o`00o`Kooooo00?o003oooooool00?l00_l00?l0
1Ooooooo003ooooooooooooo003o00Gooooo00Co003ooooooooooooo003o0_ooool00ol00?oooooo
ooooo`07ooooo`;o00000Oooool000Kooooo00Co0000oooooooooooo00002?ooool01?l0003ooooo
ooooool00004ooooo`03o`000?oooooooooo08cooooo0ol00?l6ooooo`05o`00oooooooo003oo`00
ooooool00_l00?l2ooooo`03o`00oooooooooooo00?ooooo00Co003ooooooooooooo003o3Oooool1
o`00007ooooo0007ooooo`03o`000?oooooo000000Wooooo00?o0000ooooool000001?ooool00ol0
003oooooooooo`2<ooooo`?o003o1_ooool00ol00?ooooooo`00o`02ooooo`;o003o0_ooool00ol0
0?ooooooooooo`04ooooo`?o003o3Oooool1o`00007ooooo0008ooooo`;o00002_ooool2o`0000Co
oooo0_l0001cooooo`;o003o6?ooool3o`00o`Kooooo00?o003oooooool00?l00_ooool00ol00?oo
ooooooooo`08ooooo`;o003o3_ooool1o`00007ooooo0009ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`1booooo`;o003o6?ooool3o`00o`Kooooo
00?o003oooooool00?l00_ooool00ol00?ooooooooooo`08ooooo`;o003o3_ooool1o`00007ooooo
000Jooooo`03o`000?oooooooooo077ooooo0ol00?lHooooo`03o`00oooooooo003o00Kooooo00?o
003oooooool00?l00_ooool00ol00?ooooooooooo`08ooooo`;o003o3_ooool1o`00007ooooo000J
ooooo`;o0000L_ooool3o`00oa;ooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`06
ooooo`;o003o3_ooool2o`00o`kooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`1aoooo
o`03o`00oooooooo003o01;ooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`06oooo
o`;o003o3_ooool2o`00o`kooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`1aooooo`04
o`00oooooooo003oo`00oa7ooooo00?o003oooooooooool00_ooool2o`00o`Sooooo0_l00?l>oooo
o`;o003o3_ooool1o`00007ooooo000Jooooo`;o0000L_ooool01?l00?ooooooo`00ool00?lAoooo
o`03o`00oooooooooooo00;ooooo00?o003oooooooooool01oooool2o`00o`kooooo00?o003ooooo
ooooool03Oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo077ooooo00Co003ooooooooo
oooo003o2oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00;ooooo00?o003ooooo
ooooool01oooool2o`00oakooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`1aooooo`04
o`00ooooooooooooo`00o`_ooooo00?o003oooooooooool00oooool01Ol00?oooooooooooooooooo
003o00[ooooo0_l00?lNooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0LOooool01Ol0
0?oooooooooooooooooo003o00[ooooo0_l00?l00ooooooo003oooooo`02o`00o`04ooooool00?oo
ooooo`00o`_ooooo00?o003oooooooooool07?ooool1o`00007ooooo0002ooooo`?o00000oooool0
0ol0003oooooooooo`03ooooo`?o00000_ooool3o`0000Cooooo0_l0001booooo`05o`00oooooooo
ooooooooool00?l02_ooool2o`00o`05ooooool00?ooooooo`00ooooool00_l00?l00ooooooo003o
ooooo`0:ooooo`03o`00oooooooooooo01cooooo0Ol00001ooooo`000oooool00ol0003ooooooooo
o`09ooooo`04o`000?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`00001cooooo`05
o`00ooooooooooooooooool00?l02_ooool2o`00o`05ooooool00?ooooooo`00ooooool00_l00?l0
0ooooooo003oooooo`0Yooooo`7o00000Oooool000Go00001oooool5o`0000Gooooo00Go0000oooo
ooooooooooooo`00001cooooo`05o`00ooooooooooooooooool00?l02_ooool01ol00?ooooooo`00
ool00?ooooooo`00ooooool01?l00?lZooooo`7o00000Oooool00004o`000?ooooooooooo`0000So
oooo00Co0000oooooooooooo00001_ooool01?l0003oooooooooooooool2o`0007;ooooo00Go003o
ooooooooooooooooo`00o`08ooooo`;o003o0_ooool4o`00o`03ooooool00?oo003o00;o003o:Ooo
ool2o`00007ooooo00001?oooooo0000ooooool00009ooooo`03o`000?oooooo000000;ooooo1?l0
0004ooooo`03o`000?oooooooooo073ooooo00?o003oooooooooool00_ooool00ol00?oooooooooo
o`06ooooo`;o003o0_ooool01Ol00?ooooooo`00ool00?oooooo00Co003o:_ooool1o`00007ooooo
0002ooooo`;o00002_ooool2o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`1`ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool01_ooool2o`00o`;ooooo00Ko
003oooooool00?oo003oooooool00?l]ooooo`7o00000Oooool000?ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`05o`0000?ooooo0_l0001aooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool01_ooool2o`00o`;ooooo00Ko003oooooool00?oo003oooooool00?l]oooo
o`7o00000Oooool001[ooooo00?o0000ooooooooool0L?ooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00Kooooo00Go003oooooooooooooooooo`00o`04ooooo`03o`00oooooooooooo
02_ooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`1`ooooo`03o`00oooooooooooo00;o
oooo0_l00?l7ooooo`05o`00ooooooooooooooooool00?l0<_ooool1o`00007ooooo000Jooooo`;o
0000LOooool00ol00?ooooooooooo`02ooooo`;o003o1Oooool00ol00?ooooooo`00o`0fooooo`7o
00000Oooool001[ooooo00?o0000ooooooooool0L?ooool00ol00?ooooooooooo`02ooooo`;o003o
1Oooool2o`00ocOooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`1`ooooo`03o`00oooo
oooooooo00;ooooo00?o003oooooool00?l01?ooool2o`00ocOooooo0Ol00001ooooo`006_ooool2
o`00077ooooo00?o003oooooooooool00_ooool00ol00?ooooooo`00o`04ooooo`;o003o=oooool1
o`00007ooooo000Jooooo`03o`000?oooooooooo00gooooo0_l00?mQooooo`03o`00oooooooooooo
00;ooooo00?o003oooooool00?l01?ooool00ol00?ooooooooooo`0fooooo`7o00000Oooool001[o
oooo00?o0000ooooooooool03Oooool2o`00o`03ooooool00?oo003o05kooooo00?o003ooooooooo
ool01?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo03Kooooo0Ol00001ooooo`00
2?ooool3o`0000?ooooo00?o0000ooooooooool00_ooool3o`0000Cooooo0_l0000=ooooo`04o`00
oooooooo003oooooo`?o003oGOooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00;o
oooo00?o003oooooooooool0=_ooool1o`00007ooooo0009ooooo`03o`000?oooooooooo00Kooooo
00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00cooooo00Co003oooooool0
0?oooooo0ol00?mLooooo`03o`00oooooooooooo00Kooooo0ol00?l00ooooooo003oooooo`0goooo
o`7o00000Oooool000Kooooo1Ol0000;ooooo`05o`000?ooooooooooooooool000003_ooool00ol0
0?ooooooooooo`04o`00oecooooo00?o003oooooooooool01_ooool3o`00o`03ooooool00?oooooo
03Oooooo0Ol00001ooooo`001_ooool01?l0003oooooooooool0000<ooooo`04o`000?oooooooooo
ooooo`;o00003Oooool00ol00?ooooooooooo`02o`00o`03ooooool00?oooooo05Wooooo00?o003o
ooooool00?l02?ooool3o`00o`03ooooool00?oooooo03Kooooo0_l00001ooooo`001oooool00ol0
003oooooo`000008ooooo`Co00001?ooool00ol0003oooooooooo`0<ooooo`03o`00oooooooooooo
00;o003o0_ooool01?l00?ooooooooooool00?mFooooo`03o`00oooooooo003o00Sooooo0ol00?l0
0ooooooo003oooooo`0gooooo`7o00000Oooool000Sooooo0_l00008ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool03?ooool01?l00?ooooooooooool00?l3ooooo`04o`00oooooooo
ooooo`00oeKooooo00?o003oooooool00?l02?ooool4o`00ocWooooo0Ol00001ooooo`002Oooool0
0ol0003oooooooooo`06ooooo`Go00000oooool2o`0000gooooo00?o003oooooooooool01?ooool2
o`00o`03ooooool00?oooooo05Gooooo00?o003oooooool00?l02?ooool4o`00ocWooooo0Ol00001
ooooo`006_ooool00ol0003oooooooooo`0<ooooo`03o`00oooooooooooo00Cooooo0_l00?l00ooo
oooo003oo`00o`1Eooooo`?o003o2Oooool00ol00?ooooooo`00o`0iooooo`7o00000Oooool001[o
oooo00?o0000ooooooooool03?ooool00ol00?ooooooooooo`04ooooo`;o003o00?oooooo`00ool0
0?l0EOooool3o`00o`_ooooo00?o003oooooooooool0=oooool1o`00007ooooo000Jooooo`;o0000
3Oooool00ol00?ooooooooooo`05ooooo`;o003o00?oooooo`00ooooool0BOooool00ol00?oooooo
ooooo`07ooooo`04o`00oooooooo003oo`00odGooooo0Ol00001ooooo`006_ooool00ol0003ooooo
ooooo`0;ooooo`03o`00oooooooooooo00Kooooo0_l00?l00ooooooo003oooooo`19ooooo`;o003o
2?ooool01?l00?ooooooo`00ool00?m5ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0
2oooool00ol00?ooooooooooo`06ooooo`;o003o00?oooooo`00ooooool0BOooool2o`00o`Sooooo
00Co003oooooool00?oo003oAOooool1o`00007ooooo000Jooooo`;o00003?ooool00ol00?oooooo
ooooo`07ooooo`04o`00ooooooooooooo`00odWooooo00?o003oooooool00?l01oooool01?l00?oo
ooooo`00ool00?m5ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool02oooool00ol00?oo
ooooooooo`07ooooo`04o`00ooooooooooooo`00odWooooo00?o003oooooool00?l01oooool01?l0
0?ooooooo`00ool00?m5ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool02oooool00ol0
0?ooooooooooo`07ooooo`04o`00ooooooooooooo`00oa?ooooo00?o003oooooooooool0<oooool0
0ol00?ooooooo`00o`07ooooo`04o`00oooooooo003oo`00odGooooo0Ol00001ooooo`006_ooool2
o`0000cooooo00?o003oooooooooool02_ooool00ol00?ooooooooooo`0Aooooo`03o`00oooooooo
oooo03?ooooo00Co003oooooool00?oo003o1_ooool00ol00?ooooooo`00o`16ooooo`7o00000Ooo
ool000;ooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00003ooooo`?o00001?ooool0
0ol0003oooooooooo`0:ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool04Oooool4
o`00oc;ooooo00Co003oooooool00?oo003o1_ooool00ol00?ooooooo`00o`16ooooo`7o00000Ooo
ool000?ooooo00?o0000ooooooooool01_ooool01ol0003ooooooooooooooooo0000ooooool00000
0oooool01Ol0003ooooooooooooooooo000000cooooo00?o003oooooooooool02oooool00ol00?oo
ooooooooo`0Aooooo`Co003o6?ooool00ol00?ooooooooooo`0Gooooo`03o`00oooooooo003o00;o
003o1Oooool00ol00?ooooooooooo`16ooooo`7o00000Oooool000Go00002oooool00ol0003ooooo
ooooo`03ooooo`04o`000?ooooooooooooooo`;o00002oooool00ol00?ooooooooooo`0;ooooo`03
o`00oooooooooooo017ooooo0_l00?l00ooooooo003oooooo`0Gooooo`03o`00oooooooooooo01Oo
oooo00Go003oooooooooooooooooo`00o`05ooooo`03o`00oooooooooooo04Gooooo0_l00001oooo
o`0000Co0000oooooooooooo00003?ooool00ol0003oooooooooo`03ooooo`05o`000?oooooooooo
ooooool000003?ooool00ol00?ooooooooooo`0<ooooo`03o`00oooooooooooo00Sooooo00?o003o
ooooooooool01Oooool2o`00o`03ooooool00?oooooo01Oooooo00?o003oooooooooool05oooool0
1Ol00?oooooooooooooooooo003o00Gooooo00?o003oooooooooool0A_ooool1o`00007ooooo0000
1?oooooo0000ooooool00008ooooo`Co00000_ooool4o`0000Cooooo00?o0000ooooooooool02_oo
ool00ol00?ooooooooooo`0<ooooo`03o`00oooooooooooo00Cooooo00Go003ooooooooooooooooo
o`00o`06ooooo`05o`00oooooooo003oooooool00?l06?ooool00ol00?ooooooooooo`0Fooooo`;o
003o0oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo04Kooooo0Ol00001ooooo`00
0_ooool2o`0000Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`;o0000
2?ooool01?l00?ooooooo`00ool00?l>ooooo`03o`00oooooooooooo00Cooooo00Go003ooooooooo
ooooooooo`00o`06ooooo`05o`00oooooooo003oooooool00?l06?ooool00ol00?ooooooooooo`0F
ooooo`;o003o0oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo04Kooooo0Ol00001
ooooo`000oooool00ol0003oooooooooo`06ooooo`Go000000?oooooo`000?l000000ol00003oooo
o`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo003oo`00o`0>ooooo`03o`00oooooooooooo
00Cooooo00Go003oooooooooooooooooo`00o`06ooooo`05o`00ooooooooooooooooool00?l06?oo
ool00ol00?ooooooooooo`0Cooooo`04o`00ooooooooooooo`00o`Cooooo00?o003oooooooooool0
0oooool00ol00?ooooooooooo`16ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool01_oo
ool2o`00o`03ooooool00?oo003o00kooooo0_l00?l2ooooo`04o`00oooooooo003oo`00o`;ooooo
00Co003oooooool00?oo003o1?ooool01Ol00?oooooooooooooooooo003o01Oooooo00?o003ooooo
ool00?l04?ooool01Ol00?oooooooooooooooooo003o00;ooooo00?o003oooooooooool00_ooool4
o`00o`03ooooool00?oooooo04Sooooo0Ol00001ooooo`006_ooool2o`0000Oooooo0_l00?l00ooo
oooo003oooooo`0>ooooo`;o003o0_ooool01?l00?ooooooo`00ool00?l2ooooo`04o`00oooooooo
003oo`00o`Cooooo00Go003oooooooooooooooooo`00o`0Gooooo`03o`00oooooooo003o013ooooo
0_l00?l2ooooo`04o`00ooooooooooooo`00o`Cooooo1?l00?l00ooooooo003oooooo`18ooooo`7o
00000Oooool001[ooooo00?o0000ooooooooool01_ooool00ol00?ooooooo`00o`0Aooooo`05o`00
ooooooooooooo`00ooooool00_l00?l01?oooooo003oo`00ooooool2o`00o`Cooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`0Dooooo`04o`00ooooooooooooo`00o`oooooo0_l00?l2
ooooo`;o003o00?oooooo`00ooooool01?ooool3o`00o`03ooooool00?oooooo04Sooooo0Ol00001
ooooo`006_ooool00ol0003oooooooooo`06ooooo`03o`00oooooooooooo017ooooo00Go003ooooo
oooooooo003oooooo`02o`00o`04ooooool00?oo003oooooo`;o003o1?ooool00ol00?oooooooooo
o`02ooooo`03o`00oooooooooooo01Cooooo00Co003ooooooooooooo003o3oooool2o`00o`06oooo
ool00?ooooooo`00oooooooo003o1Oooool3o`00o`03ooooool00?oooooo04Sooooo0Ol00001oooo
o`006_ooool2o`0000Kooooo00?o003oooooooooool04_ooool00ol00?ooooooooooo`07o`00o`03
ooooool00?oo003o00Cooooo00?o003oooooooooool00_ooool2o`00oaGooooo00?o003ooooooooo
ool00_l00?l4ooooo`03o`00oooooooooooo00Oooooo1?l00?l01?oooooo003oooooool00?l5oooo
o`?o003o00?oooooo`00ooooool0B?ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo00Go
oooo00?o003oooooooooool04oooool00ol00?ooooooo`00o`05o`00o`Cooooo00Go003ooooooooo
ooooooooo`00o`04ooooo`;o003o5Oooool00ol00?ooooooooooo`02o`00o`?ooooo0_l00?l4oooo
o`05o`00ooooooooooooooooool00?l00_ooool00ol00?ooooooooooo`02o`00o`Kooooo0_l00?l0
0ooooooo003oo`00o`19ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool01Oooool00ol0
0?ooooooooooo`0Cooooo`Go003o00?oooooo`00ooooool01?ooool01Ol00?oooooooooooooooooo
003o00Gooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`0>ooooo`05o`00oooooooo
ooooooooool00?l00oooool2o`00o`?ooooo00?o003oooooool00?l00_ooool01?l00?oooooooooo
ool00?l2ooooo`;o003o1_ooool2o`00o`;ooooo00?o003oooooooooool0Aoooool1o`00007ooooo
000Jooooo`;o00001?ooool00ol00?ooooooo`00o`0Eooooo`;o003o00Goooooo`00oooooooooooo
o`00o`05ooooo`05o`00ooooooooooooooooool00?l01Oooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00kooooo00?o003oooooooooool00_ooool2o`00o`04ooooool00?ooooooo`00
o`;ooooo00?o003oooooool00?l00_ooool01?l00?ooooooooooool00?l2ooooo`;o003o1oooool0
0ol00?ooooooooooo`1:ooooo`7o00000Oooool000Sooooo0ol00003ooooo`03o`000?oooooooooo
00;ooooo0ol00004ooooo`03o`000?oooooooooo00?ooooo0_l00?lIooooo`03o`00oooooooooooo
00Kooooo00Go003oooooooooooooooooo`00o`05ooooo`03o`00oooooooooooo00;ooooo0_l00?l=
ooooo`03o`00oooooooo003o00Cooooo0_l00?l01?oooooo003oooooool00?l2ooooo`03o`00oooo
oooo003o00;ooooo00?o003oooooooooool00oooool2o`00o`Oooooo00?o003oooooooooool0B_oo
ool1o`00007ooooo0009ooooo`03o`000?oooooooooo00Kooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo00?ooooo0_l00?lRooooo`05o`00ooooooooooooooooool00?l0
1_ooool01?l00?ooooooooooooooool2o`00o`gooooo00?o003oooooool00?l01Oooool01Ol00?oo
ooooo`00oooooooo003o00;ooooo00Ko003ooooooooooooo003oooooool00?l5ooooo`;o003o1ooo
ool00ol00?ooooooooooo`1:ooooo`7o00000Oooool000Kooooo1Ol00007ooooo`05o`000?oooooo
ooooooooool000000oooool2o`0000?ooooo00?o003oooooool00?l08_ooool01?l00?oooooooooo
ool00?l7ooooo`04o`00ooooooooooooooooo`;o003o3Oooool00ol00?ooooooo`00o`05ooooo`;o
003o0_ooool01?l00?ooooooooooool00?l2ooooo`03o`00oooooooo003o00Kooooo00?o003ooooo
ooooool0DOooool2o`00007ooooo0006ooooo`04o`000?ooooooooooo`0000Sooooo1?l00004oooo
o`03o`000?oooooooooo00;ooooo00?o003oooooooooool08_ooool01?l00?ooooooooooool00?l7
ooooo`04o`00ooooooooooooooooo`;o003o3Oooool3o`00o`Kooooo00Co003ooooooooooooo003o
0_ooool00ol00?ooooooooooo`03o`00o`Kooooo00?o003oooooooooool0D_ooool1o`00007ooooo
0007ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool01Oooool01?l0003ooooooooo
ooooool2o`00obCooooo00Co003ooooooooooooo003o1oooool01?l00?ooooooo`00ooooool2o`00
o`gooooo0ol00?l6ooooo`04o`00ooooooooooooo`00o`;ooooo00?o003oooooooooool00_l00?l7
ooooo`03o`00oooooooooooo05;ooooo0Ol00001ooooo`002?ooool2o`0000Wooooo00?o0000oooo
ooooool01?ooool2o`0002Wooooo00?o003oooooool00?l01oooool01?l00?ooooooo`00ooooool2
o`00o`gooooo0ol00?l9ooooo`04o`00ooooooooooooo`00o`?ooooo00?o003oooooooooool0F_oo
ool1o`00007ooooo0009ooooo`03o`000?oooooooooo00Sooooo0_l00004ooooo`03o`000?oooooo
oooo02Sooooo00?o003oooooool00?l01oooool01?l00?ooooooo`00ooooool2o`00o`cooooo00Co
003oooooool00?oo003o2Oooool01?l00?ooooooooooool00?l3ooooo`03o`00oooooooooooo05[o
oooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`0Xooooo`?o003o1oooool4o`00o`;ooooo
00?o003oooooooooool02Oooool01?l00?ooooooooooool00?l9ooooo`04o`00ooooooooooooo`00
o`?ooooo00?o003oooooooooool0F_ooool1o`00007ooooo000Jooooo`;o0000:_ooool2o`00o`Oo
oooo0_l00?l01Ooooooo003ooooooooooooo003o00_ooooo00Co003ooooooooooooo003o2Oooool0
0ol00?ooooooo`00o`1Qooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0<_ooool2o`00
o`05ooooool00?ooooooooooool00?l02oooool01?l00?ooooooooooool00?l:ooooo`;o003oHOoo
ool1o`00007ooooo000Jooooo`03o`000?oooooooooo03;ooooo0_l00?l01Ooooooo003ooooooooo
oooo003o00[ooooo00?o003oooooooooool03?ooool2o`00of7ooooo0Ol00001ooooo`006_ooool2
o`0003?ooooo0_l00?l4ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool03_ooool0
0ol00?ooooooooooo`1Oooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0>?ooool00ol0
0?ooooooooooo`06ooooo`03o`00oooooooooooo077ooooo0Ol00001ooooo`006_ooool00ol0003o
ooooooooo`0hooooo`03o`00oooooooo003o00Kooooo00?o003oooooooooool0LOooool1o`00007o
oooo000Jooooo`03o`000?oooooooooo03Wooooo0_l00?l5ooooo`03o`00oooooooooooo07;ooooo
0Ol00001ooooo`000_ooool3o`0000?ooooo00?o0000ooooooooool00_ooool3o`0000?ooooo0ol0
0004ooooo`;o0000>_ooool2o`00o`Gooooo00?o003oooooooooool0L_ooool1o`00007ooooo0003
ooooo`03o`000?oooooooooo00Kooooo00Oo0000ooooooooooooooooo`000?oooooo000000?ooooo
00Go0000ooooooooooooooooo`00000kooooo`;o003o1Oooool00ol00?ooooooooooo`1booooo`7o
00000Oooool000Go00001oooool01Ol0003ooooooooooooooooo000000Gooooo00Go0000oooooooo
ooooooooo`00000looooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool0L_ooool1o`00
007ooooo00001?l0003oooooooooool00008ooooo`Co00001_ooool01?l0003oooooooooooooool2
o`0003_ooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`1aooooo`;o00000Oooool0
0004ooooool0003oooooo`0000Sooooo00?o0000ooooooooool00oooool4o`0000Cooooo00?o0000
ooooooooool0>_ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo07;ooooo0Ol00001
ooooo`000_ooool2o`0000Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo03_ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`1boooo
o`7o00000Oooool000?ooooo00?o0000ooooooooool02?ooool2o`0000;ooooo1Ol00003ooooo`;o
0000??ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo07;ooooo0Ol00001ooooo`00
6_ooool00ol0003oooooooooo`0looooo`03o`00oooooooooooo00;o003oM?ooool1o`00007ooooo
000Jooooo`03o`000?oooooooooo03cooooo00?o003oooooooooool00_l00?mdooooo`7o00000Ooo
ool001[ooooo0_l0000mooooo`04o`00ooooooooooooo`00ogGooooo0Ol00001ooooo`006_ooool0
0ol0003oooooooooo`0looooo`04o`00oooooooo003oo`00ogGooooo0Ol00001ooooo`006_ooool0
0ol0003oooooooooo`0looooo`04o`00oooooooo003oo`00ogGooooo0Ol00001ooooo`006_ooool2
o`0003gooooo1?l00?meooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0??ooool4o`00
ogGooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`0nooooo`03o`00oooooooooooo07Co
oooo0Ol00001ooooo`006_ooool2o`000;Kooooo0Ol00001ooooo`006_ooool01Ol0003ooooooooo
oooooooo000000Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
0004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`07o`000?oooooooooooooo
ool0003oooooo`000001ooooo`006_oooonio`00007ooooo003Dooooo`00e?ooool00001\
\>"],
  ImageRangeCache->{{{0, 211.438}, {130.25, 0}} -> {-63.7651, 4.27853, \
2.07698, 0.00327741}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Data from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " version 4.1.2 (Mac OS 9)"
}], "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
Y= {{100, 0.2}, {100.41884044546586, 0.2039331723915036}, \
{100.51025580514684, 0.1999887046725265}, {99.0341674462512, \
0.212374684344604}, {100.00350847488077, 0.22349328726838383}, \
{99.6390514394419, 0.21612515489737918}, {100.91788718500852, \
0.20384842365099934}, {102.65925369591919, 0.2052248239905191}, \
{103.02075426777647, 0.21689048253707466}, {104.52653436703064, \
0.2345826254732085}, {102.43349928290911, 0.23229504838232598}, \
{103.21044915160253, 0.2325975242124864}, {101.82525407294303, \
0.26081274135646954}, {103.06866942894845, 0.2801857718278099}, \
{104.55693593861868, 0.28230309015145644}, {105.7905558877181, \
0.2801138774999928}, {106.83604543265314, 0.26615413004520594}, \
{105.92870012961131, 0.2623478771582634}, {104.13883468424201, \
0.2718036604199538}, {106.91773032263895, 0.25543102066757967}, \
{105.8304610830878, 0.25997108151464465}, {105.0313512847255, \
0.2577386617587777}, {103.59505105529365, 0.24465616267200138}, \
{104.05400787069598, 0.24641013139216272}, 

   {105.19984114396287, 0.2379349038420597}, {104.85411954636943, \
0.24631002960015008}, {105.95575151948032, 0.2418206755736186}, \
{110.24361331636419, 0.22914168389300654}, {107.79585431731263, \
0.22041120082231075}, {107.10653478545531, 0.19863858424178443}, \
{107.19145685459544, 0.19822917277227908}, {108.73241015864971, \
0.1829000308165156}, {109.61893521585958, 0.1873314716111942}, \
{108.31260517468719, 0.19723138467521228}, {108.09321426893888, \
0.18851209083196002}, {108.84329786721196, 0.18790263330643064}, \
{107.54376016678732, 0.182793188536501}, {107.94757080891867, \
0.1814108026288592}, {107.72510064499853, 0.1888670092286875}, \
{106.18599035739717, 0.19218562541571724}, {107.32511857264691, \
0.1934576268496363}, {109.09385622179049, 0.21023035551415564}, \
{109.2316620815586, 0.20625968299117475}, {107.43442379779, \
0.2132262536755454}, {107.92480644481442, 0.21235040823289156}, \
{107.07268150348098, 0.20067839913227856}, {107.58526229883036, \
0.21476911466737142}, 

   {107.39393357460665, 0.23777580167942333}, {106.26836340135277, \
0.23359911058965485}, {105.3425030870046, 0.22814843488611666}, \
{105.89189149432023, 0.216786358526991}, {106.75600712724155, \
0.2257534616673069}, {108.31606453489529, 0.21922802733939037}, \
{106.09286641100107, 0.2248227657578747}, {104.35542713336265, \
0.2138934703508376}, {104.82182735985303, 0.20854617022880007}, \
{105.27199760687495, 0.2239161825856559}, {104.80433053694689, \
0.2212570638943578}, {104.13113058998684, 0.21353436976113957}, \
{105.07266052614305, 0.22669859126550995}, {103.83933394438269, \
0.20208384232132265}, {103.71375567955691, 0.19003441268843943}, \
{104.21975053063974, 0.18686436916899857}, {103.91733458704135, \
0.17010638023190983}, {103.99596968283231, 0.15912234858621685}, \
{104.21531993346463, 0.17514208345528043}, {103.23681054682645, \
0.166537807361367}, {102.85422781006548, 0.1827139617160816}, \
{99.7095440073724, 0.17375151815849585}, {99.88893736952126, \
0.18405894880730952}, 

   {100.43307688313301, 0.1805203300349604}, {100.1751915014741, \
0.1770350183559949}, {99.93892990737065, 0.18534425443440924}, \
{100.87333356925016, 0.17425742301978628}, {101.0976951497737, \
0.18884128158402105}, {101.27812665232132, 0.19309052268794955}, \
{99.56464595938952, 0.182660211325077}, {100.8920579262063, \
0.20127389000488652}, {102.57811048157923, 0.17864757292914338}, \
{102.31441791793553, 0.1772957155542757}, {102.97303641969162, \
0.18559410861046566}, {103.0788082967922, 0.18867915024444612}, \
{100.35953742527138, 0.201387948026198}, {100.75106757766737, \
0.19153573276959787}, {100.75964046138697, 0.1799138359037718}, \
{101.30503859839271, 0.1747646927238353}, {100.87929769596231, \
0.17785876198220488}, {100.97140079584042, 0.175976285143259}, \
{101.42667049211705, 0.17243889337799642}, {100.98628600433167, \
0.18087021105851575}, {100.83503703499028, 0.17720825570056953}, \
{101.05898742434886, 0.19017670079678622}, {100.69028124414895, \
0.1921082447931128}, 

   {100.56930903880676, 0.19183580484309284}, {100.91795572116726, \
0.20894022264209133}, {101.43920382185966, 0.20328153304275265}, \
{101.73675309306978, 0.2033257168226421}, {101.26007842185231, \
0.20864871773031446}, {99.7936958560376, 0.20497540231155148}, \
{100.6684883713879, 0.2186957040414394}, {101.15258058350094, \
0.21868716859058465}, {99.71320981944936, 0.20964050791081767}, \
{98.54101764393069, 0.2008720121894506}, {99.39667909815341, \
0.1892148860245305}, {98.42153728114756, 0.18604697044502355}, \
{99.77291685102882, 0.18065865110655066}, {97.46450356323473, \
0.18194392996882094}, {97.81538456768578, 0.1805832285920268}, \
{98.57603796347178, 0.17405981641807516}, {98.91633434973832, \
0.17966820556445076}, {100.50760428890418, 0.1810089905027913}, \
{101.64683240508928, 0.18995095990413857}, {101.55756107171635, \
0.1841949057803743}, {101.13823765576015, 0.20034805248479995}, \
{102.25016351965704, 0.21313586784131905}, {101.7945768383754, \
0.20110600812925689}, 

   {104.4520714770569, 0.19791210508929144}, {103.96267131822528, \
0.19434921555407927}, {101.97581686084582, 0.20677276295855612}, \
{101.8059939140131, 0.19209891306245128}, {104.15762037179596, \
0.20534339886261718}, {103.99931114475488, 0.20601939783034784}, \
{102.76393865712897, 0.20907391083547802}, {102.61598475817144, \
0.203917522859223}, {103.15519981731958, 0.19342640773813952}, \
{104.36812580717063, 0.18635784177777479}, {104.00312253321351, \
0.1879261252052619}, {103.38793915710211, 0.20860741156025311}, \
{103.21253466512584, 0.1996650215149135}, {103.13260392422622, \
0.21432139596645494}, {102.9406295305085, 0.21638190650014896}, \
{102.02759988088339, 0.20848888833769355}, {103.48565967479871, \
0.19317490127931533}, {103.76353512925516, 0.21074953108754252}, \
{103.6247524628209, 0.2207898234439379}, {101.66392633914792, \
0.2195800580538738}, {101.70799714558247, 0.21731374892241453}, \
{100.36933206177406, 0.215471743743468}, {101.45418987091111, \
0.20705297581738136}, 

   {100.2385255370124, 0.1965942511905916}, {99.97167828715882, \
0.19959975920178885}, {100.5620107685205, 0.2150946236996269}, \
{101.48120385746678, 0.2306860104560085}, {99.9635689589437, \
0.22577921230946402}, {100.42123128772354, 0.22354434882042004}, \
{101.20205051049528, 0.2251244361506683}, {101.6431263483291, \
0.23513884471564095}, {99.89478058533844, 0.2186352612425445}, \
{98.72870591146373, 0.21458982593215634}, {99.42921593266227, \
0.2092949733617}, {98.55254293801673, 0.2134104189639549}, \
{99.73344027997747, 0.22129121256400278}, {100.2633717496965, \
0.20540982288747545}, {100.08613790319642, 0.20212584476436327}, \
{101.007930578431, 0.218528579284413}, {100.0045570897453, \
0.20655274325900377}, {100.1767794141946, 0.21877226046128678}, \
{100.8241394063897, 0.2280443858873167}, {100.4926056585295, \
0.24543684154133666}, {101.49187481648573, 0.23392228684343835}, \
{101.4637868473218, 0.24774146092593188}, {99.45441603538357, \
0.2692438038135358}, {98.13942323692207, 0.2789975790204488}, 

   {98.83118664657194, 0.27973939870750336}, {101.86061818097757, \
0.2783660093321213}, {100.68071433813127, 0.2708060276232839}, \
{100.71755174606704, 0.2743460280050434}, {98.8046256546724, \
0.2930822847347895}, {99.71563041178918, 0.30112267094916156}, \
{99.7701326833989, 0.29938905764199225}, {100.35793422161778, \
0.31581028844159187}, {98.46511431360312, 0.301763322289993}, \
{100.08987035867989, 0.30485869339070976}, {100.61808519023396, \
0.30134381330423504}, {101.89196582284876, 0.30169458977305735}, \
{103.03754906433919, 0.32363394816424174}, {100.14703327807743, \
0.32427664462139505}, {100.51613958322008, 0.3291437648566349}, \
{99.11921385348158, 0.3317861059543073}, {102.21851884442087, \
0.3245652958945882}, {102.62694896280328, 0.3434196551231713}, \
{101.9296659732986, 0.31989131105355895}, {102.79360483367668, \
0.29107883215235064}, {102.40119585133465, 0.2981154591268507}, \
{103.0437539705475, 0.29444036642989707}, {101.15746113148586, \
0.28799300019817264}, 

   {101.33411710799899, 0.2789246419997195}, {102.91912976180528, \
0.2858980467779652}, {100.47918642877445, 0.30098256394594797}, \
{103.62760131067606, 0.29410384688109614}, {102.32655287926869, \
0.30417713512861155}, {100.94139282355228, 0.2788265677341033}, \
{99.04529897179938, 0.2843981049280188}, {100.3445388619714, \
0.3093532561973218}, {101.27997050504351, 0.3099109481715407}, \
{101.43990778220603, 0.3208029618208828}, {100.1864576048859, \
0.3245905822036161}, {98.18840169186429, 0.3383296235073639}, \
{94.82833870320451, 0.3460343875769592}, {96.4001032025559, \
0.34730320761832795}, {97.225776013053, 0.32932010295722586}, \
{97.52684329642449, 0.3285041163510287}, {96.14360190264507, \
0.3404495852781511}, {97.38976345708969, 0.3505753900021997}, \
{99.54180272741176, 0.3679763168168366}, {97.27281296338764, \
0.37290639362155487}, {96.90659201716335, 0.37393659378263805}, \
{95.2907407201441, 0.378285545357085}, {91.24796805696566, \
0.3622921316005592}, {89.12641815580378, 0.3585040059114349}, 

   {90.32754826878724, 0.33345308966575454}, {92.52923146320903, \
0.3422924688029971}, {92.27346750000027, 0.3583485117233393}, \
{92.63972319972837, 0.3809662810028161}, {92.11669316697609, \
0.38579859579660486}, {92.03768018668961, 0.37737675678331595}, \
{92.19515124359211, 0.3833353319894322}, {93.75480327958948, \
0.38016732099161876}, {93.89578694092899, 0.3874087480773462}, \
{93.84431966386046, 0.3962662741880449}, {93.81029567322423, \
0.38867038095625545}, {94.6861075407277, 0.3781854270145674}, \
{94.3594434137595, 0.37560513086169545}, {94.43384365626225, \
0.3558695498897209}, {98.27273738795134, 0.36844110365072646}, \
{99.8424276040146, 0.3660003045732267}, {97.58422840444267, \
0.3811519138146996}, {98.45118684056322, 0.36274231942655283}, \
{97.97534146461724, 0.3474888459412446}, {98.46284366359893, \
0.33817819204779287}, {99.7338489884486, 0.34015984755333023}, \
{100.72218756860669, 0.34853083613614083}, {105.8508234545641, \
0.3423253160979788}, {105.39386212314287, 0.34900868237109184}, 

   {108.38463242013745, 0.35217294742420174}, {105.78193172656991, \
0.3642133140627972}, {103.28610191164952, 0.3583501134685033}, \
{102.57446224827518, 0.3501963650303395}, {103.44291574870076, \
0.36051607081005244}, {103.56263373343596, 0.36745986029120126}, \
{104.72797714798666, 0.347333771127402}, {106.25437071906609, \
0.3603951455932068}, {108.5526368588681, 0.3516704913180767}, \
{108.27514341178649, 0.343351458601513}, {111.19995903106978, \
0.3518089847039286}, {110.56534150477655, 0.36395304905987674}, \
{110.23459698292667, 0.3577697814926235}, {111.12716961828228, \
0.37430266587320754}, {107.17680948947458, 0.38175456321000817}, \
{105.33584290383439, 0.3869554038476049}, {105.78817396934112, \
0.3830560947192887}, {106.87044560035089, 0.3624629779891281}, \
{104.53953210812345, 0.37274073890404136}, {108.22850314646404, \
0.3597812278419959}, {109.04239530223366, 0.35739355969357994}, \
{111.93831984775012, 0.3624286514356032}, {112.65538807368465, \
0.3464129134697147}, 

   {110.45548808883801, 0.3459530457672531}, {114.20667990431366, \
0.36462384395122127}, {116.76165904352845, 0.3767474917257331}, \
{117.26221819852508, 0.35683930788633733}, {115.4673136449659, \
0.34920019247301914}, {115.52221170949522, 0.3429999557265864}, \
{116.95862323504389, 0.3453622750402285}, {116.98239941904926, \
0.340355254584639}, {115.95582258927212, 0.3460568374794958}, \
{114.73388753875672, 0.3322694013137987}, {112.77581942191988, \
0.3270943908643455}, {114.33753257584023, 0.32079890810440614}, \
{111.68750264284245, 0.3096917685220437}, {111.24762247771741, \
0.3198330024225417}, {109.66618299136992, 0.32791447733963347}, \
{108.82377996206544, 0.3397944041239254}, {105.71120453337716, \
0.3443177130096839}, {106.8026056998999, 0.3318619993763123}, \
{109.56283519506447, 0.32478666661751276}, {111.18669138767896, \
0.32205942883668665}, {113.45327388061101, 0.3317499899510597}, \
{116.04689529349719, 0.3393190020228495}, {114.80534707101187, \
0.34384970058917524}, 

   {113.16292391930968, 0.35975015707916824}, {110.0036402102654, \
0.36635054504325126}, {114.62427200980339, 0.3766219294858804}, \
{114.1201055598532, 0.3669211744733782}, {113.63658754957464, \
0.3629494542479627}, {111.22779134811697, 0.34677793201997353}, \
{110.84564180720807, 0.3379396449789763}, {111.65497571684611, \
0.3444881603528643}, {114.0546340267356, 0.3662442213146345}, \
{115.31464378197424, 0.387134255155745}, {118.59509436980957, \
0.39989063880196213}, {119.12455576938987, 0.3801690425575721}, \
{118.6886244770516, 0.37401847611419714}, {118.78905252787051, \
0.3932413402576836}, {119.19819967593935, 0.3923490149232174}, \
{113.30822877485295, 0.38746196508486425}, {111.77285363651808, \
0.38479266189810557}, {113.85468102884964, 0.38237229490761354}, \
{115.06079109167334, 0.38294571780314296}, {116.17896969925893, \
0.4025670350876291}, {111.35910783908183, 0.4033808667370159}, \
{109.30935549677295, 0.40133459581685116}, {109.23610607193456, \
0.3910601809701307}, 

   {106.60715484537408, 0.4103970333034993}, {107.6729948179497, \
0.3961444794423161}, {107.51620858417427, 0.39641386890213476}, \
{112.2911363554571, 0.4055278065948969}, {110.6693130242995, \
0.40098365203226793}, {113.88244003686276, 0.40746726583273374}, \
{112.65750037535074, 0.4036505311965483}, {114.57519341725285, \
0.4040550490256548}, {111.8539517972888, 0.401936717714037}, \
{110.39475572535308, 0.39983546077861676}, {108.88958715110103, \
0.4111998806727916}, {109.23739740872253, 0.40348605750927974}, \
{105.82332047946022, 0.40596492273637125}, {105.84141738049598, \
0.41624346309650423}, {102.09376157721134, 0.4163856612165356}, \
{103.14581348490606, 0.4142869834160033}, {106.22328760720505, \
0.4090132044244424}, {103.27157733628833, 0.3916650584719868}, \
{102.76866413600764, 0.4021053381197813}, {105.69083127149683, \
0.3958421376194615}, {108.94461935041386, 0.3803656899197976}, \
{111.92479261867709, 0.3718575957426026}, {114.93025835379257, \
0.36608067502002967}, 

   {116.74543668296192, 0.35577004353218605}, {112.72901590140269, \
0.34752042099778824}, {110.72790046872359, 0.3427888614335722}, \
{115.32852606122599, 0.3395544820292571}, {112.54349951936899, \
0.3332330745919483}, {109.8416961712035, 0.34901869163640564}, \
{108.87625848622908, 0.34707780812645295}, {110.59822203842093, \
0.35963692852830004}, {111.70272783908409, 0.3665500275197128}, \
{109.69394053654572, 0.3491142774085698}, {107.30745499822929, \
0.3520573114439614}, {107.81237997822129, 0.34586413032887103}, \
{106.39631507351852, 0.34107595691658465}, {106.901849716291, \
0.3495700039202882}, {105.0554015524625, 0.32100050839474215}, \
{105.32858732554321, 0.3215848429462942}, {105.81935337069372, \
0.31313345482328214}, {104.02314883543961, 0.3202210507110437}, \
{105.62809802144872, 0.33065456444511143}, {105.9728913972498, \
0.32766588671446}, {106.96789633604084, 0.33254142812610155}, \
{104.1000733591785, 0.3183288723445928}, {103.33012884854615, \
0.31033493929397876}, 

   {104.6107764155083, 0.32488620783557287}, {104.77821307505032, \
0.32817777540866555}, {103.53920174861129, 0.31458504050651886}, \
{103.27619010248591, 0.316035711002516}, {102.7530055767951, \
0.3222507530515902}, {105.84888574364055, 0.3183765409458071}, \
{101.38297861739204, 0.32255599492292636}, {103.20539649784257, \
0.32382059111415284}, {102.95913864056577, 0.307116054368137}, \
{103.43615921791765, 0.3076319852092796}, {106.20649139980287, \
0.29641278745083105}, {106.76318340773011, 0.30439206838358135}, \
{107.77111891470724, 0.28601097625665434}, {106.02042714750125, \
0.28335570631516105}, {104.46138172595694, 0.273571001812679}, \
{105.69840245463418, 0.26263011126919655}, {105.20212459160564, \
0.2697011407298415}}\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{100, 0.2`}, {100.41884044546586`, 
        0.2039331723915036`}, {100.51025580514684`, 
        0.1999887046725265`}, {99.0341674462512`, 
        0.212374684344604`}, {100.00350847488077`, 
        0.22349328726838383`}, {99.6390514394419`, 
        0.21612515489737918`}, {100.91788718500852`, 
        0.20384842365099934`}, {102.65925369591919`, 
        0.2052248239905191`}, {103.02075426777647`, 
        0.21689048253707466`}, {104.52653436703064`, 
        0.2345826254732085`}, {102.43349928290911`, 
        0.23229504838232598`}, {103.21044915160253`, 
        0.2325975242124864`}, {101.82525407294303`, 
        0.26081274135646954`}, {103.06866942894845`, 
        0.2801857718278099`}, {104.55693593861868`, 
        0.28230309015145644`}, {105.7905558877181`, 
        0.2801138774999928`}, {106.83604543265314`, 
        0.26615413004520594`}, {105.92870012961131`, 
        0.2623478771582634`}, {104.13883468424201`, 
        0.2718036604199538`}, {106.91773032263895`, 
        0.25543102066757967`}, {105.8304610830878`, 
        0.25997108151464465`}, {105.0313512847255`, 
        0.2577386617587777`}, {103.59505105529365`, 
        0.24465616267200138`}, {104.05400787069598`, 
        0.24641013139216272`}, {105.19984114396287`, 
        0.2379349038420597`}, {104.85411954636943`, 
        0.24631002960015008`}, {105.95575151948032`, 
        0.2418206755736186`}, {110.24361331636419`, 
        0.22914168389300654`}, {107.79585431731263`, 
        0.22041120082231075`}, {107.10653478545531`, 
        0.19863858424178443`}, {107.19145685459544`, 
        0.19822917277227908`}, {108.73241015864971`, 
        0.1829000308165156`}, {109.61893521585958`, 
        0.1873314716111942`}, {108.31260517468719`, 
        0.19723138467521228`}, {108.09321426893888`, 
        0.18851209083196002`}, {108.84329786721196`, 
        0.18790263330643064`}, {107.54376016678732`, 
        0.182793188536501`}, {107.94757080891867`, 
        0.1814108026288592`}, {107.72510064499853`, 
        0.1888670092286875`}, {106.18599035739717`, 
        0.19218562541571724`}, {107.32511857264691`, 
        0.1934576268496363`}, {109.09385622179049`, 
        0.21023035551415564`}, {109.2316620815586`, 
        0.20625968299117475`}, {107.43442379779`, 
        0.2132262536755454`}, {107.92480644481442`, 
        0.21235040823289156`}, {107.07268150348098`, 
        0.20067839913227856`}, {107.58526229883036`, 
        0.21476911466737142`}, {107.39393357460665`, 
        0.23777580167942333`}, {106.26836340135277`, 
        0.23359911058965485`}, {105.3425030870046`, 
        0.22814843488611666`}, {105.89189149432023`, 
        0.216786358526991`}, {106.75600712724155`, 
        0.2257534616673069`}, {108.31606453489529`, 
        0.21922802733939037`}, {106.09286641100107`, 
        0.2248227657578747`}, {104.35542713336265`, 
        0.2138934703508376`}, {104.82182735985303`, 
        0.20854617022880007`}, {105.27199760687495`, 
        0.2239161825856559`}, {104.80433053694689`, 
        0.2212570638943578`}, {104.13113058998684`, 
        0.21353436976113957`}, {105.07266052614305`, 
        0.22669859126550995`}, {103.83933394438269`, 
        0.20208384232132265`}, {103.71375567955691`, 
        0.19003441268843943`}, {104.21975053063974`, 
        0.18686436916899857`}, {103.91733458704135`, 
        0.17010638023190983`}, {103.99596968283231`, 
        0.15912234858621685`}, {104.21531993346463`, 
        0.17514208345528043`}, {103.23681054682645`, 
        0.166537807361367`}, {102.85422781006548`, 
        0.1827139617160816`}, {99.7095440073724`, 
        0.17375151815849585`}, {99.88893736952126`, 
        0.18405894880730952`}, {100.43307688313301`, 
        0.1805203300349604`}, {100.1751915014741`, 
        0.1770350183559949`}, {99.93892990737065`, 
        0.18534425443440924`}, {100.87333356925016`, 
        0.17425742301978628`}, {101.0976951497737`, 
        0.18884128158402105`}, {101.27812665232132`, 
        0.19309052268794955`}, {99.56464595938952`, 
        0.182660211325077`}, {100.8920579262063`, 
        0.20127389000488652`}, {102.57811048157923`, 
        0.17864757292914338`}, {102.31441791793553`, 
        0.1772957155542757`}, {102.97303641969162`, 
        0.18559410861046566`}, {103.0788082967922`, 
        0.18867915024444612`}, {100.35953742527138`, 
        0.201387948026198`}, {100.75106757766737`, 
        0.19153573276959787`}, {100.75964046138697`, 
        0.1799138359037718`}, {101.30503859839271`, 
        0.1747646927238353`}, {100.87929769596231`, 
        0.17785876198220488`}, {100.97140079584042`, 
        0.175976285143259`}, {101.42667049211705`, 
        0.17243889337799642`}, {100.98628600433167`, 
        0.18087021105851575`}, {100.83503703499028`, 
        0.17720825570056953`}, {101.05898742434886`, 
        0.19017670079678622`}, {100.69028124414895`, 
        0.1921082447931128`}, {100.56930903880676`, 
        0.19183580484309284`}, {100.91795572116726`, 
        0.20894022264209133`}, {101.43920382185966`, 
        0.20328153304275265`}, {101.73675309306978`, 
        0.2033257168226421`}, {101.26007842185231`, 
        0.20864871773031446`}, {99.7936958560376`, 
        0.20497540231155148`}, {100.6684883713879`, 
        0.2186957040414394`}, {101.15258058350094`, 
        0.21868716859058465`}, {99.71320981944936`, 
        0.20964050791081767`}, {98.54101764393069`, 
        0.2008720121894506`}, {99.39667909815341`, 
        0.1892148860245305`}, {98.42153728114756`, 
        0.18604697044502355`}, {99.77291685102882`, 
        0.18065865110655066`}, {97.46450356323473`, 
        0.18194392996882094`}, {97.81538456768578`, 
        0.1805832285920268`}, {98.57603796347178`, 
        0.17405981641807516`}, {98.91633434973832`, 
        0.17966820556445076`}, {100.50760428890418`, 
        0.1810089905027913`}, {101.64683240508928`, 
        0.18995095990413857`}, {101.55756107171635`, 
        0.1841949057803743`}, {101.13823765576015`, 
        0.20034805248479995`}, {102.25016351965704`, 
        0.21313586784131905`}, {101.7945768383754`, 
        0.20110600812925689`}, {104.4520714770569`, 
        0.19791210508929144`}, {103.96267131822528`, 
        0.19434921555407927`}, {101.97581686084582`, 
        0.20677276295855612`}, {101.8059939140131`, 
        0.19209891306245128`}, {104.15762037179596`, 
        0.20534339886261718`}, {103.99931114475488`, 
        0.20601939783034784`}, {102.76393865712897`, 
        0.20907391083547802`}, {102.61598475817144`, 
        0.203917522859223`}, {103.15519981731958`, 
        0.19342640773813952`}, {104.36812580717063`, 
        0.18635784177777479`}, {104.00312253321351`, 
        0.1879261252052619`}, {103.38793915710211`, 
        0.20860741156025311`}, {103.21253466512584`, 
        0.1996650215149135`}, {103.13260392422622`, 
        0.21432139596645494`}, {102.9406295305085`, 
        0.21638190650014896`}, {102.02759988088339`, 
        0.20848888833769355`}, {103.48565967479871`, 
        0.19317490127931533`}, {103.76353512925516`, 
        0.21074953108754252`}, {103.6247524628209`, 
        0.2207898234439379`}, {101.66392633914792`, 
        0.2195800580538738`}, {101.70799714558247`, 
        0.21731374892241453`}, {100.36933206177406`, 
        0.215471743743468`}, {101.45418987091111`, 
        0.20705297581738136`}, {100.2385255370124`, 
        0.1965942511905916`}, {99.97167828715882`, 
        0.19959975920178885`}, {100.5620107685205`, 
        0.2150946236996269`}, {101.48120385746678`, 
        0.2306860104560085`}, {99.9635689589437`, 
        0.22577921230946402`}, {100.42123128772354`, 
        0.22354434882042004`}, {101.20205051049528`, 
        0.2251244361506683`}, {101.6431263483291`, 
        0.23513884471564095`}, {99.89478058533844`, 
        0.2186352612425445`}, {98.72870591146373`, 
        0.21458982593215634`}, {99.42921593266227`, 
        0.2092949733617`}, {98.55254293801673`, 
        0.2134104189639549`}, {99.73344027997747`, 
        0.22129121256400278`}, {100.2633717496965`, 
        0.20540982288747545`}, {100.08613790319642`, 
        0.20212584476436327`}, {101.007930578431`, 
        0.218528579284413`}, {100.0045570897453`, 
        0.20655274325900377`}, {100.1767794141946`, 
        0.21877226046128678`}, {100.8241394063897`, 
        0.2280443858873167`}, {100.4926056585295`, 
        0.24543684154133666`}, {101.49187481648573`, 
        0.23392228684343835`}, {101.4637868473218`, 
        0.24774146092593188`}, {99.45441603538357`, 
        0.2692438038135358`}, {98.13942323692207`, 
        0.2789975790204488`}, {98.83118664657194`, 
        0.27973939870750336`}, {101.86061818097757`, 
        0.2783660093321213`}, {100.68071433813127`, 
        0.2708060276232839`}, {100.71755174606704`, 
        0.2743460280050434`}, {98.8046256546724`, 
        0.2930822847347895`}, {99.71563041178918`, 
        0.30112267094916156`}, {99.7701326833989`, 
        0.29938905764199225`}, {100.35793422161778`, 
        0.31581028844159187`}, {98.46511431360312`, 
        0.301763322289993`}, {100.08987035867989`, 
        0.30485869339070976`}, {100.61808519023396`, 
        0.30134381330423504`}, {101.89196582284876`, 
        0.30169458977305735`}, {103.03754906433919`, 
        0.32363394816424174`}, {100.14703327807743`, 
        0.32427664462139505`}, {100.51613958322008`, 
        0.3291437648566349`}, {99.11921385348158`, 
        0.3317861059543073`}, {102.21851884442087`, 
        0.3245652958945882`}, {102.62694896280328`, 
        0.3434196551231713`}, {101.9296659732986`, 
        0.31989131105355895`}, {102.79360483367668`, 
        0.29107883215235064`}, {102.40119585133465`, 
        0.2981154591268507`}, {103.0437539705475`, 
        0.29444036642989707`}, {101.15746113148586`, 
        0.28799300019817264`}, {101.33411710799899`, 
        0.2789246419997195`}, {102.91912976180528`, 
        0.2858980467779652`}, {100.47918642877445`, 
        0.30098256394594797`}, {103.62760131067606`, 
        0.29410384688109614`}, {102.32655287926869`, 
        0.30417713512861155`}, {100.94139282355228`, 
        0.2788265677341033`}, {99.04529897179938`, 
        0.2843981049280188`}, {100.3445388619714`, 
        0.3093532561973218`}, {101.27997050504351`, 
        0.3099109481715407`}, {101.43990778220603`, 
        0.3208029618208828`}, {100.1864576048859`, 
        0.3245905822036161`}, {98.18840169186429`, 
        0.3383296235073639`}, {94.82833870320451`, 
        0.3460343875769592`}, {96.4001032025559`, 
        0.34730320761832795`}, {97.225776013053`, 
        0.32932010295722586`}, {97.52684329642449`, 
        0.3285041163510287`}, {96.14360190264507`, 
        0.3404495852781511`}, {97.38976345708969`, 
        0.3505753900021997`}, {99.54180272741176`, 
        0.3679763168168366`}, {97.27281296338764`, 
        0.37290639362155487`}, {96.90659201716335`, 
        0.37393659378263805`}, {95.2907407201441`, 
        0.378285545357085`}, {91.24796805696566`, 
        0.3622921316005592`}, {89.12641815580378`, 
        0.3585040059114349`}, {90.32754826878724`, 
        0.33345308966575454`}, {92.52923146320903`, 
        0.3422924688029971`}, {92.27346750000027`, 
        0.3583485117233393`}, {92.63972319972837`, 
        0.3809662810028161`}, {92.11669316697609`, 
        0.38579859579660486`}, {92.03768018668961`, 
        0.37737675678331595`}, {92.19515124359211`, 
        0.3833353319894322`}, {93.75480327958948`, 
        0.38016732099161876`}, {93.89578694092899`, 
        0.3874087480773462`}, {93.84431966386046`, 
        0.3962662741880449`}, {93.81029567322423`, 
        0.38867038095625545`}, {94.6861075407277`, 
        0.3781854270145674`}, {94.3594434137595`, 
        0.37560513086169545`}, {94.43384365626225`, 
        0.3558695498897209`}, {98.27273738795134`, 
        0.36844110365072646`}, {99.8424276040146`, 
        0.3660003045732267`}, {97.58422840444267`, 
        0.3811519138146996`}, {98.45118684056322`, 
        0.36274231942655283`}, {97.97534146461724`, 
        0.3474888459412446`}, {98.46284366359893`, 
        0.33817819204779287`}, {99.7338489884486`, 
        0.34015984755333023`}, {100.72218756860669`, 
        0.34853083613614083`}, {105.8508234545641`, 
        0.3423253160979788`}, {105.39386212314287`, 
        0.34900868237109184`}, {108.38463242013745`, 
        0.35217294742420174`}, {105.78193172656991`, 
        0.3642133140627972`}, {103.28610191164952`, 
        0.3583501134685033`}, {102.57446224827518`, 
        0.3501963650303395`}, {103.44291574870076`, 
        0.36051607081005244`}, {103.56263373343596`, 
        0.36745986029120126`}, {104.72797714798666`, 
        0.347333771127402`}, {106.25437071906609`, 
        0.3603951455932068`}, {108.5526368588681`, 
        0.3516704913180767`}, {108.27514341178649`, 
        0.343351458601513`}, {111.19995903106978`, 
        0.3518089847039286`}, {110.56534150477655`, 
        0.36395304905987674`}, {110.23459698292667`, 
        0.3577697814926235`}, {111.12716961828228`, 
        0.37430266587320754`}, {107.17680948947458`, 
        0.38175456321000817`}, {105.33584290383439`, 
        0.3869554038476049`}, {105.78817396934112`, 
        0.3830560947192887`}, {106.87044560035089`, 
        0.3624629779891281`}, {104.53953210812345`, 
        0.37274073890404136`}, {108.22850314646404`, 
        0.3597812278419959`}, {109.04239530223366`, 
        0.35739355969357994`}, {111.93831984775012`, 
        0.3624286514356032`}, {112.65538807368465`, 
        0.3464129134697147`}, {110.45548808883801`, 
        0.3459530457672531`}, {114.20667990431366`, 
        0.36462384395122127`}, {116.76165904352845`, 
        0.3767474917257331`}, {117.26221819852508`, 
        0.35683930788633733`}, {115.4673136449659`, 
        0.34920019247301914`}, {115.52221170949522`, 
        0.3429999557265864`}, {116.95862323504389`, 
        0.3453622750402285`}, {116.98239941904926`, 
        0.340355254584639`}, {115.95582258927212`, 
        0.3460568374794958`}, {114.73388753875672`, 
        0.3322694013137987`}, {112.77581942191988`, 
        0.3270943908643455`}, {114.33753257584023`, 
        0.32079890810440614`}, {111.68750264284245`, 
        0.3096917685220437`}, {111.24762247771741`, 
        0.3198330024225417`}, {109.66618299136992`, 
        0.32791447733963347`}, {108.82377996206544`, 
        0.3397944041239254`}, {105.71120453337716`, 
        0.3443177130096839`}, {106.8026056998999`, 
        0.3318619993763123`}, {109.56283519506447`, 
        0.32478666661751276`}, {111.18669138767896`, 
        0.32205942883668665`}, {113.45327388061101`, 
        0.3317499899510597`}, {116.04689529349719`, 
        0.3393190020228495`}, {114.80534707101187`, 
        0.34384970058917524`}, {113.16292391930968`, 
        0.35975015707916824`}, {110.0036402102654`, 
        0.36635054504325126`}, {114.62427200980339`, 
        0.3766219294858804`}, {114.1201055598532`, 
        0.3669211744733782`}, {113.63658754957464`, 
        0.3629494542479627`}, {111.22779134811697`, 
        0.34677793201997353`}, {110.84564180720807`, 
        0.3379396449789763`}, {111.65497571684611`, 
        0.3444881603528643`}, {114.0546340267356`, 
        0.3662442213146345`}, {115.31464378197424`, 
        0.387134255155745`}, {118.59509436980957`, 
        0.39989063880196213`}, {119.12455576938987`, 
        0.3801690425575721`}, {118.6886244770516`, 
        0.37401847611419714`}, {118.78905252787051`, 
        0.3932413402576836`}, {119.19819967593935`, 
        0.3923490149232174`}, {113.30822877485295`, 
        0.38746196508486425`}, {111.77285363651808`, 
        0.38479266189810557`}, {113.85468102884964`, 
        0.38237229490761354`}, {115.06079109167334`, 
        0.38294571780314296`}, {116.17896969925893`, 
        0.4025670350876291`}, {111.35910783908183`, 
        0.4033808667370159`}, {109.30935549677295`, 
        0.40133459581685116`}, {109.23610607193456`, 
        0.3910601809701307`}, {106.60715484537408`, 
        0.4103970333034993`}, {107.6729948179497`, 
        0.3961444794423161`}, {107.51620858417427`, 
        0.39641386890213476`}, {112.2911363554571`, 
        0.4055278065948969`}, {110.6693130242995`, 
        0.40098365203226793`}, {113.88244003686276`, 
        0.40746726583273374`}, {112.65750037535074`, 
        0.4036505311965483`}, {114.57519341725285`, 
        0.4040550490256548`}, {111.8539517972888`, 
        0.401936717714037`}, {110.39475572535308`, 
        0.39983546077861676`}, {108.88958715110103`, 
        0.4111998806727916`}, {109.23739740872253`, 
        0.40348605750927974`}, {105.82332047946022`, 
        0.40596492273637125`}, {105.84141738049598`, 
        0.41624346309650423`}, {102.09376157721134`, 
        0.4163856612165356`}, {103.14581348490606`, 
        0.4142869834160033`}, {106.22328760720505`, 
        0.4090132044244424`}, {103.27157733628833`, 
        0.3916650584719868`}, {102.76866413600764`, 
        0.4021053381197813`}, {105.69083127149683`, 
        0.3958421376194615`}, {108.94461935041386`, 
        0.3803656899197976`}, {111.92479261867709`, 
        0.3718575957426026`}, {114.93025835379257`, 
        0.36608067502002967`}, {116.74543668296192`, 
        0.35577004353218605`}, {112.72901590140269`, 
        0.34752042099778824`}, {110.72790046872359`, 
        0.3427888614335722`}, {115.32852606122599`, 
        0.3395544820292571`}, {112.54349951936899`, 
        0.3332330745919483`}, {109.8416961712035`, 
        0.34901869163640564`}, {108.87625848622908`, 
        0.34707780812645295`}, {110.59822203842093`, 
        0.35963692852830004`}, {111.70272783908409`, 
        0.3665500275197128`}, {109.69394053654572`, 
        0.3491142774085698`}, {107.30745499822929`, 
        0.3520573114439614`}, {107.81237997822129`, 
        0.34586413032887103`}, {106.39631507351852`, 
        0.34107595691658465`}, {106.901849716291`, 
        0.3495700039202882`}, {105.0554015524625`, 
        0.32100050839474215`}, {105.32858732554321`, 
        0.3215848429462942`}, {105.81935337069372`, 
        0.31313345482328214`}, {104.02314883543961`, 
        0.3202210507110437`}, {105.62809802144872`, 
        0.33065456444511143`}, {105.9728913972498`, 
        0.32766588671446`}, {106.96789633604084`, 
        0.33254142812610155`}, {104.1000733591785`, 
        0.3183288723445928`}, {103.33012884854615`, 
        0.31033493929397876`}, {104.6107764155083`, 
        0.32488620783557287`}, {104.77821307505032`, 
        0.32817777540866555`}, {103.53920174861129`, 
        0.31458504050651886`}, {103.27619010248591`, 
        0.316035711002516`}, {102.7530055767951`, 
        0.3222507530515902`}, {105.84888574364055`, 
        0.3183765409458071`}, {101.38297861739204`, 
        0.32255599492292636`}, {103.20539649784257`, 
        0.32382059111415284`}, {102.95913864056577`, 
        0.307116054368137`}, {103.43615921791765`, 
        0.3076319852092796`}, {106.20649139980287`, 
        0.29641278745083105`}, {106.76318340773011`, 
        0.30439206838358135`}, {107.77111891470724`, 
        0.28601097625665434`}, {106.02042714750125`, 
        0.28335570631516105`}, {104.46138172595694`, 
        0.273571001812679`}, {105.69840245463418`, 
        0.26263011126919655`}, {105.20212459160564`, 
        0.2697011407298415`}}\)], "Output"]
}, Open  ]],

Cell["\<\
logZM= {{4.605302377018504}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.631323559075596}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.649748937659628}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.6543039955737875}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.680271263738077}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.690061629786308}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.693455213639548}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.657198092230358}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.656531461750432}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.643552352054873}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.609447878797682}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.614138415075883}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.612635299024988}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.615606468107348}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.603164032735582}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.602702894098439}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.620430942116992}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.623252628864524}, {-9}, 

   {-9}, {-9}, {-9}, {-9}, {-9}, {4.644234669285503}, {-9}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {4.642201707449059}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.604920869031988}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.6040586981566936}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.615181231305667}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.599845317247128}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.602228994294972}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.634999969947004}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.632564177251234}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.640779883825223}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.607055417794283}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.578759795127443}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.503469767202335}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.54072647253365}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.587721234855919}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.612351626385398}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.638882802739971}, {-9}, {-9}, {-9}, {-9}, {-9},\\
  {-9}, 
 {4.705510867830958}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.649549025688821}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.760281044054639}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.742682917366109}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.660593708170128}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.72877084730292}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.7155306057085005}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.780769486331425}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.694127687123876}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.7352680924392745}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.66193051510426}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.660513612780229}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.747897720985818}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.6756497601113605}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, \
{4.644511258402401}, {-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.651927515098823}, \
{-9}, {-9}, {-9}, {-9}, {-9}, {-9}, {4.634438809024381}, {-9}, {-9}, {-9}, \
{-9}, {-9}, {-9}, {4.66054883283335},\\
  {-9}};\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["System functions for log S", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["system matrices (S->Log S,  lambda = -Abs[lambda], rho = 0)", \
"Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontColor->RGBColor[1, 0, 0]],

Cell["Clear[S,t,r,lambda,sigma0,gamma,rho];", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
drift//Clear
drift[{S_,sigma_},{t_},
\t{r_,lambda_,sigma0_,gamma_}] := 
\t{r - sigma^2/2, -Abs[lambda](sigma-sigma0)}\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["drift[{S,sigma},{t},{rr,lambda,sigma0,gamma}]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({rr - sigma\^2\/2, \(-\((sigma - sigma0)\)\)\ Abs[lambda]}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
rho = 0
Q={{1,0.01 rho},{0.01 rho,1}};
Q2 = Q//CholeskyDecomposition//Transpose
Q2.Transpose[Q2]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \(0\)], "Output"],

Cell[BoxData[
    \({{1, 0}, {0, 1}}\)], "Output"],

Cell[BoxData[
    \({{1, 0}, {0, 1}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
diffusion//Clear
diffusion[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] =
   {{sigma,0},{0,gamma}}.Q2\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{sigma, 0}, {0, gamma}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["diffusion[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{sigma_, 0}, {0, gamma_}}\)], "Output"]
}, Open  ]],

Cell["\<\
Omega//Clear
Omega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}]:=
Module[{g},
g = diffusion[{S,sigma},{t},{r,lambda,sigma0,gamma}];
g.Transpose[g]
]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["Omega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{sigma_\^2, 0}, {0, gamma_\^2}}\)], "Output"]
}, Open  ]],

Cell["\<\
h//Clear
h[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] := {S};\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
R//Clear
R[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = {{10.^-8}}\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{1.`*^-8}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["R[{1,2},{t_},{r_,lambda_,sigma0_,gamma_}]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{1.`*^-8}}\)], "Output"]
}, Open  ]],

Cell["\<\
M0 = { 4,.2};

S0 = {{1  ,0},
      {0, .01}}//N;
      
S01 = Inverse[S0];

p0//Clear
p0[t_,Theta_,n_] := Module[{m,s,eins=Shape[1,n]},
\tm=Mue[t,Theta];
\tm=eins/. (1->m);
\ts=Sigma[t,Theta];
\ts=eins/. (1->s);
\t{m,s,1/n}//N]


Mue//Clear
Mue[  {t_},{r_,lambda_,sigma0_,gamma_}] := M0

Sigma//Clear
Sigma[{t_},{r_,lambda_,sigma0_,gamma_}] := S0\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["p0[{_},{r_,lambda_,sigma0_,gamma_},3]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{4.`, 0.2`}, {4.`, 0.2`}, {4.`, 
          0.2`}}, {{{1.`, 0.`}, {0.`, 0.01`}}, {{1.`, 0.`}, {0.`, 
            0.01`}}, {{1.`, 0.`}, {0.`, 0.01`}}}, 
      0.3333333333333333`}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Jacobi matrices", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell["\<\
Clear[Jacobif,S,sigma];
Jacobif[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tOuter[D,drift[{S,sigma},{t},{r,lambda,sigma0,gamma}],{S,sigma}]\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{0, \(-sigma\)}, {0, \(-Abs[lambda]\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[DDf,S,sigma];
DDf[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tOuter[D,Jacobif[{S,sigma},{t},{r,lambda,sigma0,gamma}],
\t\t{S,sigma}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{0, 0}, {0, \(-1\)}}, {{0, 0}, {0, 0}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[DDDf,S,sigma];
DDDf[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tOuter[D,DDf[{S,sigma},{t},{r,lambda,sigma0,gamma}],
\t\t{S,sigma}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, 
            0}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[DDDDf,S,sigma];
DDDDf[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tOuter[D,DDDf[{S,sigma},{t},{r,lambda,sigma0,gamma}],
\t\t{S,sigma}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, 
              0}}}}, {{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 
              0}}, {{0, 0}, {0, 0}}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[DOmega,S,sigma];
DOmega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tOuter[D,Omega[{S,sigma},{t},{r,lambda,sigma0,gamma}],{S,sigma}]\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{0, 2\ sigma}, {0, 0}}, {{0, 0}, {0, 0}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[DDOmega,S,sigma];
DDOmega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tOuter[D,DOmega[{S,sigma},{t},{r,lambda,sigma0,gamma}],{S,sigma}]\
\>", \
"Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{{0, 0}, {0, 2}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, 
            0}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DDO=DDOmega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tNest[Outer[D,#,{S,sigma}]&,Omega[{S,sigma},{t},{r,lambda,sigma0,gamma}],2]\
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{{0, 0}, {0, 2}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, 
            0}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DDDOmega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tNest[Outer[D,#,{S,sigma}]&,Omega[{S,sigma},{t},{r,lambda,sigma0,gamma}],3]\
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, 
              0}}}}, {{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 
              0}}, {{0, 0}, {0, 0}}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DDDDOmega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tNest[Outer[D,#,{S,sigma}]&,Omega[{S,sigma},{t},{r,lambda,sigma0,gamma}],4]\
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 
                0}, {0, 0}}}}, {{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 
                0}, {0, 0}}, {{0, 0}, {0, 0}}}}}, {{{{{0, 0}, {0, 0}}, {{0, 
                0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}}, {{{{0, 
                0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 
                0}, {0, 0}}}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Table[\"DDO\"[i][j][k][l]==DDO[[i,j,k,l]],{i,2},{j,2},{k,2},{l,2}]//\
Flatten//InputForm
\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
{\"DDO\"[1][1][1][1] == 0, \"DDO\"[1][1][1][2] == 0, \
\"DDO\"[1][1][2][1] == 0, \"DDO\"[1][1][2][2] == 2, 
 \"DDO\"[1][2][1][1] == 0, \"DDO\"[1][2][1][2] == 0, \"DDO\"[1][2][2][1] == \
0, \"DDO\"[1][2][2][2] == 0, 
 \"DDO\"[2][1][1][1] == 0, \"DDO\"[2][1][1][2] == 0, \"DDO\"[2][1][2][1] == \
0, \"DDO\"[2][1][2][2] == 0, 
 \"DDO\"[2][2][1][1] == 0, \"DDO\"[2][2][1][2] == 0, \"DDO\"[2][2][2][1] == \
0, \"DDO\"[2][2][2][2] == 0}\
\>", "Output",
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["DDOmega[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{{{0, 0}, {0, 2}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, 
            0}}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Jacobih//Clear
Jacobih[{S_,sigma_},{t_},{r_,lambda_,sigma0_,gamma_}] = 
\tOuter[D,h[{S,sigma},{t},{r,lambda,sigma0,gamma}],{S,sigma}]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{1, 0}}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["c-functions / mathlink code not released", "Subsubsection",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell["\<\
cf=      \"drift_SVol_Scott\";
cDf=     \"Ddrift_SVol_Scott\";
cDDf=    \"DDdrift_SVol_Scott\";
cg=      \"diffusion_SVol_Scott\";
cOmega=  \"Omega_SVol_Scott\";
cDDOmega=\"DDOmega_SVol_Scott\";
ch=      \"h_SVol_Scott\";
cDh=     \"Dh_SVol_Scott\";
cR=      \"R_SVol_Scott\";
cmue=    \"mue_SVol_Scott\";
csigma=  \"sigma_SVol_Scott\";
cp0=     \"p0_SVol_Scott\"\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \("p0_SVol_Scott"\)], "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["volatility  filtering", "Section",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["EKF", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[{
  "YMAX = 500;\n\n{YF,PF,lik}= EKF[{logZM,X},{0.07, -1., .2, .2},\n\t\t\t     \
{drift,Jacobif,diffusion,h,Jacobih,R,",
  StyleBox["Mue,Sigma",
    FontColor->RGBColor[1, 0, 0]],
  ",dt},{-9,2}];"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
YF//Dimensions
PF//Dimensions
lik\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({366, 2}\)], "Output",
  FontSize->14],

Cell[BoxData[
    \({366, 2, 2}\)], "Output",
  FontSize->14],

Cell[BoxData[
    \(128.89095958094936`\)], "Output",
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
s=Map[VecDiag,PF]//Sqrt;
KI=YF~ii~(YF+s)~ii~(YF-s);

SetOptions[plot1,dicke->.007];

gEKF=
DisplayTogetherArray[
plot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}]//AddTimeAxis,permute->{1,4,3,2}\
,
\t\tcolor->{10,1,2,2}],
plot1[Column[Y,{2}] ~ii~Column[KI,{1,3,5}+1]//AddTimeAxis,color->{10,1,2,2}],
\t\t\tPlotLabel->\"EKF\"];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gEKF\\)\\\" is similar to existing symbol \\\
\"\\!\\(EKF\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -11 0 ]
[.5 .32152 11 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -8.00212 1.79059 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05555 -18 -4.5 ]
[-0.0125 .05555 0 4.5 ]
[-0.0125 .14508 -24 -4.5 ]
[-0.0125 .14508 0 4.5 ]
[-0.0125 .23461 -18 -4.5 ]
[-0.0125 .23461 0 4.5 ]
[-0.0125 .32414 -24 -4.5 ]
[-0.0125 .32414 0 4.5 ]
[-0.0125 .41367 -18 -4.5 ]
[-0.0125 .41367 0 4.5 ]
[-0.0125 .5032 -24 -4.5 ]
[-0.0125 .5032 0 4.5 ]
[-0.0125 .59273 -18 -4.5 ]
[-0.0125 .59273 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33467 -5 -6 ]
[.97619 .33467 5 6 ]
[.97619 .32433 -5 -6 ]
[.97619 .32433 5 6 ]
[.97619 .36221 -5 -6 ]
[.97619 .36221 5 6 ]
[.97619 .34327 -5 -6 ]
[.97619 .34327 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05555 m
.00625 .05555 L
s
[(4.5)] -0.0125 .05555 1 0 Mshowa
0 .14508 m
.00625 .14508 L
s
[(4.55)] -0.0125 .14508 1 0 Mshowa
0 .23461 m
.00625 .23461 L
s
[(4.6)] -0.0125 .23461 1 0 Mshowa
0 .32414 m
.00625 .32414 L
s
[(4.65)] -0.0125 .32414 1 0 Mshowa
0 .41367 m
.00625 .41367 L
s
[(4.7)] -0.0125 .41367 1 0 Mshowa
0 .5032 m
.00625 .5032 L
s
[(4.75)] -0.0125 .5032 1 0 Mshowa
0 .59273 m
.00625 .59273 L
s
[(4.8)] -0.0125 .59273 1 0 Mshowa
.125 Mabswid
0 .07346 m
.00375 .07346 L
s
0 .09136 m
.00375 .09136 L
s
0 .10927 m
.00375 .10927 L
s
0 .12717 m
.00375 .12717 L
s
0 .16299 m
.00375 .16299 L
s
0 .18089 m
.00375 .18089 L
s
0 .1988 m
.00375 .1988 L
s
0 .2167 m
.00375 .2167 L
s
0 .25251 m
.00375 .25251 L
s
0 .27042 m
.00375 .27042 L
s
0 .28833 m
.00375 .28833 L
s
0 .30623 m
.00375 .30623 L
s
0 .34204 m
.00375 .34204 L
s
0 .35995 m
.00375 .35995 L
s
0 .37786 m
.00375 .37786 L
s
0 .39576 m
.00375 .39576 L
s
0 .43157 m
.00375 .43157 L
s
0 .44948 m
.00375 .44948 L
s
0 .46739 m
.00375 .46739 L
s
0 .48529 m
.00375 .48529 L
s
0 .5211 m
.00375 .5211 L
s
0 .53901 m
.00375 .53901 L
s
0 .55692 m
.00375 .55692 L
s
0 .57482 m
.00375 .57482 L
s
0 .03764 m
.00375 .03764 L
s
0 .01974 m
.00375 .01974 L
s
0 .00183 m
.00375 .00183 L
s
0 .61063 m
.00375 .61063 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05555 m
1 .05555 L
s
.99375 .14508 m
1 .14508 L
s
.99375 .23461 m
1 .23461 L
s
.99375 .32414 m
1 .32414 L
s
.99375 .41367 m
1 .41367 L
s
.99375 .5032 m
1 .5032 L
s
.99375 .59273 m
1 .59273 L
s
.125 Mabswid
.99625 .07346 m
1 .07346 L
s
.99625 .09136 m
1 .09136 L
s
.99625 .10927 m
1 .10927 L
s
.99625 .12717 m
1 .12717 L
s
.99625 .16299 m
1 .16299 L
s
.99625 .18089 m
1 .18089 L
s
.99625 .1988 m
1 .1988 L
s
.99625 .2167 m
1 .2167 L
s
.99625 .25251 m
1 .25251 L
s
.99625 .27042 m
1 .27042 L
s
.99625 .28833 m
1 .28833 L
s
.99625 .30623 m
1 .30623 L
s
.99625 .34204 m
1 .34204 L
s
.99625 .35995 m
1 .35995 L
s
.99625 .37786 m
1 .37786 L
s
.99625 .39576 m
1 .39576 L
s
.99625 .43157 m
1 .43157 L
s
.99625 .44948 m
1 .44948 L
s
.99625 .46739 m
1 .46739 L
s
.99625 .48529 m
1 .48529 L
s
.99625 .5211 m
1 .5211 L
s
.99625 .53901 m
1 .53901 L
s
.99625 .55692 m
1 .55692 L
s
.99625 .57482 m
1 .57482 L
s
.99625 .03764 m
1 .03764 L
s
.99625 .01974 m
1 .01974 L
s
.99625 .00183 m
1 .00183 L
s
.99625 .61063 m
1 .61063 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .33467 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .24387 m
.02642 .25135 L
.02903 .25298 L
.03164 .22649 L
.03425 .24393 L
.03686 .23739 L
.03947 .26023 L
.04207 .29086 L
.04468 .29716 L
.04729 .32314 L
.0499 .28692 L
.05251 .30045 L
.05512 .27625 L
.05773 .29799 L
.06034 .32366 L
.06295 .34466 L
.06556 .36227 L
.06817 .347 L
.07078 .31648 L
.07339 .36364 L
.07599 .34534 L
.0786 .33176 L
.08121 .30711 L
.08382 .31502 L
.08643 .33463 L
.08904 .32874 L
.09165 .34745 L
.09426 .41849 L
.09687 .37828 L
.09948 .3668 L
.10209 .36822 L
.1047 .39377 L
.10731 .40831 L
.10992 .38685 L
.11252 .38322 L
.11513 .3956 L
.11774 .37409 L
.12035 .3808 L
.12296 .37711 L
.12557 .35134 L
.12818 .37045 L
.13079 .39972 L
.1334 .40198 L
.13601 .37227 L
.13862 .38043 L
.14123 .36623 L
.14384 .37478 L
.14644 .3716 L
.14905 .35273 L
.15166 .33706 L
Mistroke
.15427 .34638 L
.15688 .36093 L
.15949 .38691 L
.1621 .34977 L
.16471 .3202 L
.16732 .32819 L
.16993 .33586 L
.17254 .32789 L
.17515 .31635 L
.17776 .33247 L
.18037 .31133 L
.18297 .30916 L
.18558 .31787 L
.18819 .31267 L
.1908 .31403 L
.19341 .3178 L
.19602 .30091 L
.19863 .29426 L
.20124 .23866 L
.20385 .24188 L
.20646 .2516 L
.20907 .247 L
.21168 .24277 L
.21429 .25944 L
.21689 .26341 L
.2195 .26661 L
.22211 .23605 L
.22472 .25977 L
.22733 .28945 L
.22994 .28484 L
.23255 .29633 L
.23516 .29816 L
.23777 .25029 L
.24038 .25726 L
.24299 .25742 L
.2456 .26708 L
.24821 .25954 L
.25082 .26118 L
.25342 .26923 L
.25603 .26144 L
.25864 .25876 L
.26125 .26273 L
.26386 .25618 L
.26647 .25403 L
.26908 .26023 L
.27169 .26945 L
.2743 .2747 L
.27691 .26629 L
.27952 .24017 L
.28213 .2558 L
Mistroke
.28474 .26439 L
.28735 .23872 L
.28995 .21755 L
.29256 .23303 L
.29517 .21538 L
.29778 .2398 L
.30039 .19788 L
.303 .20432 L
.30561 .21819 L
.30822 .22436 L
.31083 .25293 L
.31344 .27311 L
.31605 .27154 L
.31866 .26413 L
.32127 .28371 L
.32387 .27572 L
.32648 .32186 L
.32909 .31345 L
.3317 .2789 L
.33431 .27592 L
.33692 .31681 L
.33953 .31408 L
.34214 .29269 L
.34475 .29011 L
.34736 .29949 L
.34997 .32042 L
.35258 .31415 L
.35519 .30353 L
.3578 .30049 L
.3604 .2991 L
.36301 .29576 L
.36562 .27981 L
.36823 .30522 L
.37084 .31002 L
.37345 .30762 L
.37606 .27342 L
.37867 .27419 L
.38128 .25047 L
.38389 .26972 L
.3865 .24813 L
.38911 .24336 L
.39172 .2539 L
.39432 .27019 L
.39693 .24321 L
.39954 .25139 L
.40215 .26526 L
.40476 .27305 L
.40737 .24198 L
.40998 .22096 L
.41259 .23362 L
Mistroke
.4152 .21776 L
.41781 .23909 L
.42042 .24858 L
.42303 .24541 L
.42564 .26182 L
.42825 .24395 L
.43085 .24703 L
.43346 .25856 L
.43607 .25267 L
.43868 .27038 L
.44129 .26989 L
.4439 .23407 L
.44651 .21024 L
.44912 .22281 L
.45173 .27688 L
.45434 .25601 L
.45695 .25667 L
.45956 .22233 L
.46217 .23877 L
.46477 .23975 L
.46738 .25026 L
.46999 .21617 L
.4726 .24548 L
.47521 .2549 L
.47782 .27743 L
.48043 .29745 L
.48304 .2465 L
.48565 .25308 L
.48826 .22803 L
.49087 .28316 L
.49348 .2903 L
.49609 .27809 L
.4987 .2932 L
.5013 .28635 L
.50391 .29755 L
.50652 .26447 L
.50913 .2676 L
.51174 .29539 L
.51435 .25243 L
.51696 .30767 L
.51957 .28505 L
.52218 .26064 L
.52479 .22669 L
.5274 .25003 L
.53001 .26664 L
.53262 .26947 L
.53523 .2472 L
.53783 .21113 L
.54044 .14878 L
.54305 .17822 L
Mistroke
.54566 .19349 L
.54827 .19903 L
.55088 .17345 L
.55349 .19651 L
.5561 .23564 L
.55871 .19436 L
.56132 .1876 L
.56393 .15749 L
.56654 .07987 L
.56915 .03774 L
.57175 .06171 L
.57436 .10483 L
.57697 .09988 L
.57958 .10697 L
.58219 .09683 L
.5848 .0953 L
.58741 .09836 L
.59002 .1284 L
.59263 .13109 L
.59524 .1301 L
.59785 .12946 L
.60046 .1461 L
.60307 .13991 L
.60568 .14132 L
.60828 .21267 L
.61089 .24104 L
.6135 .20008 L
.61611 .21592 L
.61872 .20724 L
.62133 .21613 L
.62394 .23909 L
.62655 .25675 L
.62916 .34568 L
.63177 .33793 L
.63438 .38804 L
.63699 .34452 L
.6396 .30176 L
.6422 .28938 L
.64481 .30448 L
.64742 .30655 L
.65003 .32659 L
.65264 .35249 L
.65525 .39081 L
.65786 .38623 L
.66047 .43396 L
.66308 .42371 L
.66569 .41834 L
.6683 .43278 L
.67091 .36797 L
.67352 .33695 L
Mistroke
.67613 .34462 L
.67873 .36285 L
.68134 .32336 L
.68395 .38546 L
.68656 .39887 L
.68917 .44581 L
.69178 .45724 L
.69439 .42193 L
.697 .48173 L
.69961 .52135 L
.70222 .52901 L
.70483 .50138 L
.70744 .50224 L
.71005 .52436 L
.71265 .52473 L
.71526 .50894 L
.71787 .48998 L
.72048 .45915 L
.72309 .48378 L
.7257 .44179 L
.72831 .43472 L
.73092 .40909 L
.73353 .39528 L
.73614 .34332 L
.73875 .36171 L
.74136 .4074 L
.74397 .43374 L
.74658 .46988 L
.74918 .51035 L
.75179 .49109 L
.7544 .46529 L
.75701 .41459 L
.75962 .48826 L
.76223 .48037 L
.76484 .47277 L
.76745 .4344 L
.77006 .42824 L
.77267 .44127 L
.77528 .47934 L
.77789 .49902 L
.7805 .54924 L
.78311 .55722 L
.78571 .55065 L
.78832 .55217 L
.79093 .55833 L
.79354 .46759 L
.79615 .44316 L
.79876 .4762 L
.80137 .49507 L
.80398 .51239 L
Mistroke
.80659 .43652 L
.8092 .40325 L
.81181 .40205 L
.81442 .35843 L
.81703 .37624 L
.81963 .37363 L
.82224 .45144 L
.82485 .42539 L
.82746 .47664 L
.83007 .45727 L
.83268 .4875 L
.83529 .44446 L
.8379 .42094 L
.84051 .39636 L
.84312 .40207 L
.84573 .34522 L
.84834 .34552 L
.85095 .28097 L
.85356 .29933 L
.85616 .35197 L
.85877 .30151 L
.86138 .29277 L
.86399 .34297 L
.8666 .39727 L
.86921 .44559 L
.87182 .49304 L
.87443 .5211 L
.87704 .45841 L
.87965 .42634 L
.88226 .49923 L
.88487 .45546 L
.88748 .41195 L
.89008 .39614 L
.89269 .42424 L
.8953 .44203 L
.89791 .40954 L
.90052 .37015 L
.90313 .37856 L
.90574 .35488 L
.90835 .36337 L
.91096 .33217 L
.91357 .33682 L
.91618 .34515 L
.91879 .31449 L
.9214 .34191 L
.92401 .34774 L
.92661 .36448 L
.92922 .31582 L
.93183 .30252 L
.93444 .32458 L
Mistroke
.93705 .32744 L
.93966 .30614 L
.94227 .30159 L
.94488 .2925 L
.94749 .34565 L
.9501 .26846 L
.95271 .30036 L
.95532 .29608 L
.95793 .30436 L
.96053 .35169 L
.96314 .36105 L
.96575 .37787 L
.96836 .34855 L
.97097 .32202 L
.97358 .3431 L
.97619 .33467 L
Mfstroke
0 .98 .604 r
gsave
.97619 .32433 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24392 m
.02642 .2256 L
.02903 .21808 L
.03164 .21237 L
.03425 .20759 L
.03686 .20341 L
.03947 .19966 L
.04207 .29052 L
.04468 .27231 L
.04729 .26485 L
.0499 .25917 L
.05251 .25443 L
.05512 .25027 L
.05773 .24654 L
.06034 .32351 L
.06295 .30539 L
.06556 .29796 L
.06817 .29231 L
.07078 .28759 L
.07339 .28346 L
.07599 .27974 L
.0786 .33167 L
.08121 .31356 L
.08382 .30613 L
.08643 .30049 L
.08904 .29577 L
.09165 .29165 L
.09426 .28794 L
.09687 .37816 L
.09948 .36019 L
.10209 .35281 L
.1047 .34721 L
.10731 .34253 L
.10992 .33843 L
.11252 .33475 L
.11513 .39569 L
.11774 .37776 L
.12035 .3704 L
.12296 .36482 L
.12557 .36014 L
.12818 .35606 L
.13079 .35239 L
.1334 .40177 L
.13601 .38384 L
.13862 .37649 L
.14123 .3709 L
.14384 .36623 L
.14644 .36215 L
.14905 .35848 L
.15166 .33685 L
Mistroke
.15427 .3187 L
.15688 .31125 L
.15949 .30559 L
.1621 .30086 L
.16471 .29672 L
.16732 .293 L
.16993 .33565 L
.17254 .31749 L
.17515 .31004 L
.17776 .30438 L
.18037 .29964 L
.18297 .2955 L
.18558 .29178 L
.18819 .31241 L
.1908 .29416 L
.19341 .28667 L
.19602 .28098 L
.19863 .27623 L
.20124 .27206 L
.20385 .26832 L
.20646 .25135 L
.20907 .23288 L
.21168 .2253 L
.21429 .21954 L
.21689 .21472 L
.2195 .21051 L
.22211 .20672 L
.22472 .25975 L
.22733 .24131 L
.22994 .23374 L
.23255 .22798 L
.23516 .22317 L
.23777 .21896 L
.24038 .21518 L
.24299 .25705 L
.2456 .2386 L
.24821 .23103 L
.25082 .22527 L
.25342 .22046 L
.25603 .21624 L
.25864 .21246 L
.26125 .26237 L
.26386 .24394 L
.26647 .23637 L
.26908 .23062 L
.27169 .22581 L
.2743 .2216 L
.27691 .21782 L
.27952 .2401 L
.28213 .22157 L
Mistroke
.28474 .21397 L
.28735 .20819 L
.28995 .20336 L
.29256 .19913 L
.29517 .19533 L
.29778 .23927 L
.30039 .22074 L
.303 .21313 L
.30561 .20735 L
.30822 .20252 L
.31083 .19829 L
.31344 .19449 L
.31605 .27101 L
.31866 .2526 L
.32127 .24504 L
.32387 .2393 L
.32648 .2345 L
.32909 .23029 L
.3317 .22652 L
.33431 .27607 L
.33692 .25767 L
.33953 .25012 L
.34214 .24438 L
.34475 .23958 L
.34736 .23538 L
.34997 .23161 L
.35258 .31364 L
.35519 .29538 L
.3578 .28788 L
.3604 .28219 L
.36301 .27743 L
.36562 .27326 L
.36823 .26952 L
.37084 .31 L
.37345 .29172 L
.37606 .28421 L
.37867 .27851 L
.38128 .27375 L
.38389 .26957 L
.3865 .26583 L
.38911 .24324 L
.39172 .22469 L
.39432 .21707 L
.39693 .21128 L
.39954 .20644 L
.40215 .2022 L
.40476 .1984 L
.40737 .2417 L
.40998 .22313 L
.41259 .21551 L
Mistroke
.4152 .20972 L
.41781 .20488 L
.42042 .20064 L
.42303 .19683 L
.42564 .26161 L
.42825 .24313 L
.43085 .23554 L
.43346 .22977 L
.43607 .22495 L
.43868 .22073 L
.44129 .21694 L
.4439 .23415 L
.44651 .21555 L
.44912 .20792 L
.45173 .20211 L
.45434 .19726 L
.45695 .19301 L
.45956 .18919 L
.46217 .23842 L
.46477 .21984 L
.46738 .21221 L
.46999 .20641 L
.4726 .20156 L
.47521 .19731 L
.47782 .1935 L
.48043 .2971 L
.48304 .27876 L
.48565 .27123 L
.48826 .26551 L
.49087 .26072 L
.49348 .25653 L
.49609 .25277 L
.4987 .29274 L
.5013 .27437 L
.50391 .26683 L
.50652 .2611 L
.50913 .25631 L
.51174 .25212 L
.51435 .24835 L
.51696 .30745 L
.51957 .28914 L
.52218 .28162 L
.52479 .27591 L
.5274 .27113 L
.53001 .26695 L
.53262 .2632 L
.53523 .24706 L
.53783 .22848 L
.54044 .22085 L
.54305 .21506 L
Mistroke
.54566 .21021 L
.54827 .20597 L
.55088 .20215 L
.55349 .1964 L
.5561 .1776 L
.55871 .16988 L
.56132 .16401 L
.56393 .1591 L
.56654 .15481 L
.56915 .15094 L
.57175 .06159 L
.57436 .04221 L
.57697 .03425 L
.57958 .0282 L
.58219 .02313 L
.5848 .0187 L
.58741 .01472 L
.59002 .12829 L
.59263 .10921 L
.59524 .10137 L
.59785 .09542 L
.60046 .09043 L
.60307 .08607 L
.60568 .08215 L
.60828 .21244 L
.61089 .19373 L
.6135 .18604 L
.61611 .1802 L
.61872 .17532 L
.62133 .17104 L
.62394 .1672 L
.62655 .25655 L
.62916 .23802 L
.63177 .23042 L
.63438 .22464 L
.63699 .21981 L
.6396 .21558 L
.6422 .21178 L
.64481 .30405 L
.64742 .28574 L
.65003 .27822 L
.65264 .27251 L
.65525 .26773 L
.65786 .26355 L
.66047 .2598 L
.66308 .42336 L
.66569 .40557 L
.6683 .39828 L
.67091 .39274 L
.67352 .3881 L
Mistroke
.67613 .38405 L
.67873 .38041 L
.68134 .32315 L
.68395 .30488 L
.68656 .29738 L
.68917 .29169 L
.69178 .28692 L
.69439 .28275 L
.697 .27901 L
.69961 .52143 L
.70222 .50405 L
.70483 .49693 L
.70744 .49152 L
.71005 .487 L
.71265 .48305 L
.71526 .4795 L
.71787 .48992 L
.72048 .47237 L
.72309 .46517 L
.7257 .4597 L
.72831 .45513 L
.73092 .45114 L
.73353 .44755 L
.73614 .34293 L
.73875 .32465 L
.74136 .31715 L
.74397 .31145 L
.74658 .30668 L
.74918 .30251 L
.75179 .29876 L
.7544 .465 L
.75701 .44728 L
.75962 .44001 L
.76223 .43449 L
.76484 .42988 L
.76745 .42584 L
.77006 .42221 L
.77267 .4413 L
.77528 .42344 L
.77789 .41612 L
.7805 .41055 L
.78311 .4059 L
.78571 .40183 L
.78832 .39818 L
.79093 .55811 L
.79354 .5408 L
.79615 .5337 L
.79876 .52831 L
.80137 .52381 L
.80398 .51987 L
Mistroke
.80659 .51633 L
.8092 .40298 L
.81181 .38487 L
.81442 .37743 L
.81703 .37179 L
.81963 .36707 L
.82224 .36294 L
.82485 .35923 L
.82746 .47664 L
.83007 .45887 L
.83268 .45158 L
.83529 .44604 L
.8379 .44141 L
.84051 .43736 L
.84312 .43373 L
.84573 .34532 L
.84834 .32689 L
.85095 .31933 L
.85356 .31358 L
.85616 .30877 L
.85877 .30456 L
.86138 .30078 L
.86399 .34279 L
.8666 .32434 L
.86921 .31676 L
.87182 .31101 L
.87443 .3062 L
.87704 .30198 L
.87965 .2982 L
.88226 .49925 L
.88487 .48154 L
.88748 .47427 L
.89008 .46876 L
.89269 .46414 L
.8953 .46011 L
.89791 .45648 L
.90052 .36989 L
.90313 .35152 L
.90574 .34398 L
.90835 .33825 L
.91096 .33345 L
.91357 .32926 L
.91618 .32549 L
.91879 .31413 L
.9214 .29549 L
.92401 .28783 L
.92661 .28201 L
.92922 .27714 L
.93183 .27288 L
.93444 .26906 L
Mistroke
.93705 .32741 L
.93966 .30882 L
.94227 .30119 L
.94488 .2954 L
.94749 .29055 L
.9501 .2863 L
.95271 .28249 L
.95532 .2961 L
.95793 .27736 L
.96053 .26966 L
.96314 .26382 L
.96575 .25892 L
.96836 .25464 L
.97097 .2508 L
.97358 .34285 L
.97619 .32433 L
Mfstroke
gsave
.97619 .36221 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24428 m
.02642 .26309 L
.02903 .2711 L
.03164 .27731 L
.03425 .28258 L
.03686 .28725 L
.03947 .29149 L
.04207 .29088 L
.04468 .30957 L
.04729 .31753 L
.0499 .3237 L
.05251 .32894 L
.05512 .33358 L
.05773 .33781 L
.06034 .32387 L
.06295 .34248 L
.06556 .35041 L
.06817 .35655 L
.07078 .36177 L
.07339 .3664 L
.07599 .3706 L
.0786 .33202 L
.08121 .35062 L
.08382 .35855 L
.08643 .36468 L
.08904 .3699 L
.09165 .37452 L
.09426 .37872 L
.09687 .37852 L
.09948 .39699 L
.10209 .40486 L
.1047 .41096 L
.10731 .41614 L
.10992 .42074 L
.11252 .42492 L
.11513 .39605 L
.11774 .41448 L
.12035 .42234 L
.12296 .42842 L
.12557 .43359 L
.12818 .43818 L
.13079 .44235 L
.1334 .40213 L
.13601 .42055 L
.13862 .42841 L
.14123 .43449 L
.14384 .43966 L
.14644 .44424 L
.14905 .44841 L
.15166 .33721 L
Mistroke
.15427 .35585 L
.15688 .36379 L
.15949 .36995 L
.1621 .37517 L
.16471 .37981 L
.16732 .38402 L
.16993 .33601 L
.17254 .35467 L
.17515 .36262 L
.17776 .36877 L
.18037 .374 L
.18297 .37864 L
.18558 .38285 L
.18819 .31277 L
.1908 .33152 L
.19341 .3395 L
.19602 .34568 L
.19863 .35093 L
.20124 .35559 L
.20385 .35982 L
.20646 .25171 L
.20907 .27066 L
.21168 .27873 L
.21429 .28498 L
.21689 .29028 L
.2195 .29498 L
.22211 .29926 L
.22472 .2601 L
.22733 .27903 L
.22994 .28709 L
.23255 .29333 L
.23516 .29863 L
.23777 .30333 L
.24038 .3076 L
.24299 .25741 L
.2456 .27635 L
.24821 .28442 L
.25082 .29066 L
.25342 .29596 L
.25603 .30066 L
.25864 .30494 L
.26125 .26273 L
.26386 .28166 L
.26647 .28972 L
.26908 .29595 L
.27169 .30125 L
.2743 .30595 L
.27691 .31022 L
.27952 .24045 L
.28213 .25946 L
Mistroke
.28474 .26755 L
.28735 .27382 L
.28995 .27914 L
.29256 .28385 L
.29517 .28814 L
.29778 .23963 L
.30039 .25864 L
.303 .26674 L
.30561 .273 L
.30822 .27832 L
.31083 .28304 L
.31344 .28733 L
.31605 .27137 L
.31866 .29027 L
.32127 .29832 L
.32387 .30455 L
.32648 .30984 L
.32909 .31453 L
.3317 .3188 L
.33431 .27642 L
.33692 .29531 L
.33953 .30335 L
.34214 .30958 L
.34475 .31487 L
.34736 .31956 L
.34997 .32382 L
.35258 .31399 L
.35519 .33274 L
.3578 .34073 L
.3604 .34691 L
.36301 .35217 L
.36562 .35682 L
.36823 .36106 L
.37084 .31035 L
.37345 .32913 L
.37606 .33712 L
.37867 .34331 L
.38128 .34857 L
.38389 .35323 L
.3865 .35747 L
.38911 .2436 L
.39172 .26264 L
.39432 .27074 L
.39693 .27702 L
.39954 .28234 L
.40215 .28707 L
.40476 .29136 L
.40737 .24206 L
.40998 .2611 L
.41259 .26921 L
Mistroke
.4152 .27549 L
.41781 .28082 L
.42042 .28554 L
.42303 .28984 L
.42564 .26197 L
.42825 .28094 L
.43085 .28902 L
.43346 .29527 L
.43607 .30058 L
.43868 .30529 L
.44129 .30957 L
.4439 .23451 L
.44651 .2536 L
.44912 .26172 L
.45173 .26801 L
.45434 .27335 L
.45695 .27808 L
.45956 .28238 L
.46217 .23878 L
.46477 .25785 L
.46738 .26596 L
.46999 .27225 L
.4726 .27758 L
.47521 .28231 L
.47782 .28661 L
.48043 .29746 L
.48304 .31629 L
.48565 .32431 L
.48826 .33052 L
.49087 .3358 L
.49348 .34047 L
.49609 .34473 L
.4987 .2931 L
.5013 .31196 L
.50391 .31999 L
.50652 .3262 L
.50913 .33149 L
.51174 .33617 L
.51435 .34042 L
.51696 .30781 L
.51957 .32661 L
.52218 .33462 L
.52479 .34082 L
.5274 .34609 L
.53001 .35076 L
.53262 .355 L
.53523 .24742 L
.53783 .26649 L
.54044 .2746 L
.54305 .28088 L
Mistroke
.54566 .28622 L
.54827 .29095 L
.55088 .29524 L
.55349 .19676 L
.5561 .21604 L
.55871 .22424 L
.56132 .23059 L
.56393 .23598 L
.56654 .24075 L
.56915 .24509 L
.57175 .06194 L
.57436 .08179 L
.57697 .09021 L
.57958 .09673 L
.58219 .10227 L
.5848 .10717 L
.58741 .11162 L
.59002 .12865 L
.59263 .14821 L
.59524 .15652 L
.59785 .16295 L
.60046 .16841 L
.60307 .17325 L
.60568 .17765 L
.60828 .2128 L
.61089 .232 L
.6135 .24017 L
.61611 .24649 L
.61872 .25186 L
.62133 .25661 L
.62394 .26094 L
.62655 .2569 L
.62916 .27591 L
.63177 .284 L
.63438 .29027 L
.63699 .29559 L
.6396 .3003 L
.6422 .30459 L
.64481 .30441 L
.64742 .32322 L
.65003 .33122 L
.65264 .33743 L
.65525 .34269 L
.65786 .34736 L
.66047 .35161 L
.66308 .42371 L
.66569 .442 L
.6683 .4498 L
.67091 .45584 L
.67352 .46097 L
Mistroke
.67613 .46553 L
.67873 .46967 L
.68134 .32351 L
.68395 .34227 L
.68656 .35026 L
.68917 .35645 L
.69178 .36171 L
.69439 .36637 L
.697 .37061 L
.69961 .52178 L
.70222 .53967 L
.70483 .5473 L
.70744 .55322 L
.71005 .55825 L
.71265 .56271 L
.71526 .56677 L
.71787 .49028 L
.72048 .50833 L
.72309 .51604 L
.7257 .52201 L
.72831 .52708 L
.73092 .53159 L
.73353 .53568 L
.73614 .34329 L
.73875 .36206 L
.74136 .37005 L
.74397 .37625 L
.74658 .38151 L
.74918 .38617 L
.75179 .39041 L
.7544 .46536 L
.75701 .48359 L
.75962 .49136 L
.76223 .49738 L
.76484 .5025 L
.76745 .50704 L
.77006 .51117 L
.77267 .44166 L
.77528 .46001 L
.77789 .46784 L
.7805 .4739 L
.78311 .47905 L
.78571 .48362 L
.78832 .48778 L
.79093 .55847 L
.79354 .5763 L
.79615 .5839 L
.79876 .5898 L
.80137 .59482 L
.80398 .59927 L
Mistroke
.80659 .60332 L
.8092 .40333 L
.81181 .42194 L
.81442 .42987 L
.81703 .43601 L
.81963 .44122 L
.82224 .44585 L
.82485 .45005 L
.82746 .477 L
.83007 .49527 L
.83268 .50306 L
.83529 .5091 L
.8379 .51423 L
.84051 .51878 L
.84312 .52292 L
.84573 .34568 L
.84834 .3646 L
.85095 .37265 L
.85356 .37889 L
.85616 .38419 L
.85877 .38888 L
.86138 .39315 L
.86399 .34314 L
.8666 .36208 L
.86921 .37014 L
.87182 .37638 L
.87443 .38168 L
.87704 .38638 L
.87965 .39066 L
.88226 .49961 L
.88487 .51783 L
.88748 .5256 L
.89008 .53162 L
.89269 .53673 L
.8953 .54127 L
.89791 .5454 L
.90052 .37025 L
.90313 .38911 L
.90574 .39714 L
.90835 .40336 L
.91096 .40864 L
.91357 .41333 L
.91618 .41758 L
.91879 .31449 L
.9214 .33362 L
.92401 .34176 L
.92661 .34806 L
.92922 .35341 L
.93183 .35816 L
.93444 .36247 L
Mistroke
.93705 .32777 L
.93966 .34684 L
.94227 .35496 L
.94488 .36124 L
.94749 .36657 L
.9501 .3713 L
.95271 .3756 L
.95532 .29645 L
.95793 .31567 L
.96053 .32385 L
.96314 .33018 L
.96575 .33555 L
.96836 .34032 L
.97097 .34465 L
.97358 .34321 L
.97619 .36221 L
Mfstroke
0 0 1 r
gsave
.97619 .34327 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2441 m
.02642 .24435 L
.02903 .24459 L
.03164 .24484 L
.03425 .24508 L
.03686 .24533 L
.03947 .24558 L
.04207 .2907 L
.04468 .29094 L
.04729 .29119 L
.0499 .29144 L
.05251 .29168 L
.05512 .29193 L
.05773 .29218 L
.06034 .32369 L
.06295 .32394 L
.06556 .32418 L
.06817 .32443 L
.07078 .32468 L
.07339 .32493 L
.07599 .32517 L
.0786 .33185 L
.08121 .33209 L
.08382 .33234 L
.08643 .33259 L
.08904 .33284 L
.09165 .33308 L
.09426 .33333 L
.09687 .37834 L
.09948 .37859 L
.10209 .37884 L
.1047 .37909 L
.10731 .37934 L
.10992 .37959 L
.11252 .37983 L
.11513 .39587 L
.11774 .39612 L
.12035 .39637 L
.12296 .39662 L
.12557 .39687 L
.12818 .39712 L
.13079 .39737 L
.1334 .40195 L
.13601 .4022 L
.13862 .40245 L
.14123 .4027 L
.14384 .40295 L
.14644 .4032 L
.14905 .40345 L
.15166 .33703 L
Mistroke
.15427 .33728 L
.15688 .33752 L
.15949 .33777 L
.1621 .33802 L
.16471 .33826 L
.16732 .33851 L
.16993 .33583 L
.17254 .33608 L
.17515 .33633 L
.17776 .33657 L
.18037 .33682 L
.18297 .33707 L
.18558 .33732 L
.18819 .31259 L
.1908 .31284 L
.19341 .31309 L
.19602 .31333 L
.19863 .31358 L
.20124 .31382 L
.20385 .31407 L
.20646 .25153 L
.20907 .25177 L
.21168 .25201 L
.21429 .25226 L
.21689 .2525 L
.2195 .25275 L
.22211 .25299 L
.22472 .25992 L
.22733 .26017 L
.22994 .26041 L
.23255 .26066 L
.23516 .2609 L
.23777 .26115 L
.24038 .26139 L
.24299 .25723 L
.2456 .25748 L
.24821 .25772 L
.25082 .25797 L
.25342 .25821 L
.25603 .25845 L
.25864 .2587 L
.26125 .26255 L
.26386 .2628 L
.26647 .26304 L
.26908 .26329 L
.27169 .26353 L
.2743 .26377 L
.27691 .26402 L
.27952 .24027 L
.28213 .24052 L
Mistroke
.28474 .24076 L
.28735 .241 L
.28995 .24125 L
.29256 .24149 L
.29517 .24173 L
.29778 .23945 L
.30039 .23969 L
.303 .23993 L
.30561 .24018 L
.30822 .24042 L
.31083 .24066 L
.31344 .24091 L
.31605 .27119 L
.31866 .27144 L
.32127 .27168 L
.32387 .27193 L
.32648 .27217 L
.32909 .27241 L
.3317 .27266 L
.33431 .27624 L
.33692 .27649 L
.33953 .27673 L
.34214 .27698 L
.34475 .27722 L
.34736 .27747 L
.34997 .27771 L
.35258 .31381 L
.35519 .31406 L
.3578 .31431 L
.3604 .31455 L
.36301 .3148 L
.36562 .31504 L
.36823 .31529 L
.37084 .31018 L
.37345 .31042 L
.37606 .31067 L
.37867 .31091 L
.38128 .31116 L
.38389 .3114 L
.3865 .31165 L
.38911 .24342 L
.39172 .24366 L
.39432 .24391 L
.39693 .24415 L
.39954 .24439 L
.40215 .24464 L
.40476 .24488 L
.40737 .24188 L
.40998 .24212 L
.41259 .24236 L
Mistroke
.4152 .2426 L
.41781 .24285 L
.42042 .24309 L
.42303 .24333 L
.42564 .26179 L
.42825 .26204 L
.43085 .26228 L
.43346 .26252 L
.43607 .26277 L
.43868 .26301 L
.44129 .26325 L
.4439 .23433 L
.44651 .23457 L
.44912 .23482 L
.45173 .23506 L
.45434 .2353 L
.45695 .23554 L
.45956 .23579 L
.46217 .2386 L
.46477 .23884 L
.46738 .23909 L
.46999 .23933 L
.4726 .23957 L
.47521 .23981 L
.47782 .24006 L
.48043 .29728 L
.48304 .29752 L
.48565 .29777 L
.48826 .29801 L
.49087 .29826 L
.49348 .2985 L
.49609 .29875 L
.4987 .29292 L
.5013 .29316 L
.50391 .29341 L
.50652 .29365 L
.50913 .2939 L
.51174 .29414 L
.51435 .29439 L
.51696 .30763 L
.51957 .30787 L
.52218 .30812 L
.52479 .30837 L
.5274 .30861 L
.53001 .30886 L
.53262 .3091 L
.53523 .24724 L
.53783 .24749 L
.54044 .24773 L
.54305 .24797 L
Mistroke
.54566 .24821 L
.54827 .24846 L
.55088 .2487 L
.55349 .19658 L
.5561 .19682 L
.55871 .19706 L
.56132 .1973 L
.56393 .19754 L
.56654 .19778 L
.56915 .19802 L
.57175 .06176 L
.57436 .062 L
.57697 .06223 L
.57958 .06247 L
.58219 .0627 L
.5848 .06293 L
.58741 .06317 L
.59002 .12847 L
.59263 .12871 L
.59524 .12895 L
.59785 .12919 L
.60046 .12942 L
.60307 .12966 L
.60568 .1299 L
.60828 .21262 L
.61089 .21286 L
.6135 .2131 L
.61611 .21335 L
.61872 .21359 L
.62133 .21383 L
.62394 .21407 L
.62655 .25673 L
.62916 .25697 L
.63177 .25721 L
.63438 .25745 L
.63699 .2577 L
.6396 .25794 L
.6422 .25818 L
.64481 .30423 L
.64742 .30448 L
.65003 .30472 L
.65264 .30497 L
.65525 .30521 L
.65786 .30546 L
.66047 .3057 L
.66308 .42353 L
.66569 .42379 L
.6683 .42404 L
.67091 .42429 L
.67352 .42454 L
Mistroke
.67613 .42479 L
.67873 .42504 L
.68134 .32333 L
.68395 .32358 L
.68656 .32382 L
.68917 .32407 L
.69178 .32432 L
.69439 .32456 L
.697 .32481 L
.69961 .5216 L
.70222 .52186 L
.70483 .52211 L
.70744 .52237 L
.71005 .52262 L
.71265 .52288 L
.71526 .52313 L
.71787 .4901 L
.72048 .49035 L
.72309 .4906 L
.7257 .49086 L
.72831 .49111 L
.73092 .49136 L
.73353 .49161 L
.73614 .34311 L
.73875 .34336 L
.74136 .3436 L
.74397 .34385 L
.74658 .34409 L
.74918 .34434 L
.75179 .34458 L
.7544 .46518 L
.75701 .46544 L
.75962 .46569 L
.76223 .46594 L
.76484 .46619 L
.76745 .46644 L
.77006 .46669 L
.77267 .44148 L
.77528 .44173 L
.77789 .44198 L
.7805 .44223 L
.78311 .44248 L
.78571 .44273 L
.78832 .44298 L
.79093 .55829 L
.79354 .55855 L
.79615 .5588 L
.79876 .55906 L
.80137 .55931 L
.80398 .55957 L
Mistroke
.80659 .55982 L
.8092 .40316 L
.81181 .4034 L
.81442 .40365 L
.81703 .4039 L
.81963 .40415 L
.82224 .40439 L
.82485 .40464 L
.82746 .47682 L
.83007 .47707 L
.83268 .47732 L
.83529 .47757 L
.8379 .47782 L
.84051 .47807 L
.84312 .47832 L
.84573 .3455 L
.84834 .34575 L
.85095 .34599 L
.85356 .34624 L
.85616 .34648 L
.85877 .34672 L
.86138 .34697 L
.86399 .34296 L
.8666 .34321 L
.86921 .34345 L
.87182 .3437 L
.87443 .34394 L
.87704 .34418 L
.87965 .34443 L
.88226 .49943 L
.88487 .49968 L
.88748 .49993 L
.89008 .50019 L
.89269 .50044 L
.8953 .50069 L
.89791 .50094 L
.90052 .37007 L
.90313 .37031 L
.90574 .37056 L
.90835 .3708 L
.91096 .37105 L
.91357 .37129 L
.91618 .37154 L
.91879 .31431 L
.9214 .31455 L
.92401 .3148 L
.92661 .31504 L
.92922 .31528 L
.93183 .31552 L
.93444 .31576 L
Mistroke
.93705 .32759 L
.93966 .32783 L
.94227 .32807 L
.94488 .32832 L
.94749 .32856 L
.9501 .3288 L
.95271 .32905 L
.95532 .29628 L
.95793 .29652 L
.96053 .29676 L
.96314 .297 L
.96575 .29724 L
.96836 .29748 L
.97097 .29772 L
.97358 .34303 L
.97619 .34327 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -0.0755851 1.63047 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00594 -24 -4.5 ]
[-0.0125 .00594 0 4.5 ]
[-0.0125 .08746 -18 -4.5 ]
[-0.0125 .08746 0 4.5 ]
[-0.0125 .16899 -24 -4.5 ]
[-0.0125 .16899 0 4.5 ]
[-0.0125 .25051 -18 -4.5 ]
[-0.0125 .25051 0 4.5 ]
[-0.0125 .33203 -24 -4.5 ]
[-0.0125 .33203 0 4.5 ]
[-0.0125 .41356 -18 -4.5 ]
[-0.0125 .41356 0 4.5 ]
[-0.0125 .49508 -24 -4.5 ]
[-0.0125 .49508 0 4.5 ]
[-0.0125 .5766 -18 -4.5 ]
[-0.0125 .5766 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36415 -5 -6 ]
[.97619 .36415 5 6 ]
[.97619 .25386 -5 -6 ]
[.97619 .25386 5 6 ]
[.97619 .47593 -5 -6 ]
[.97619 .47593 5 6 ]
[.97619 .03178 -5 -6 ]
[.97619 .03178 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00594 m
.00625 .00594 L
s
[(0.05)] -0.0125 .00594 1 0 Mshowa
0 .08746 m
.00625 .08746 L
s
[(0.1)] -0.0125 .08746 1 0 Mshowa
0 .16899 m
.00625 .16899 L
s
[(0.15)] -0.0125 .16899 1 0 Mshowa
0 .25051 m
.00625 .25051 L
s
[(0.2)] -0.0125 .25051 1 0 Mshowa
0 .33203 m
.00625 .33203 L
s
[(0.25)] -0.0125 .33203 1 0 Mshowa
0 .41356 m
.00625 .41356 L
s
[(0.3)] -0.0125 .41356 1 0 Mshowa
0 .49508 m
.00625 .49508 L
s
[(0.35)] -0.0125 .49508 1 0 Mshowa
0 .5766 m
.00625 .5766 L
s
[(0.4)] -0.0125 .5766 1 0 Mshowa
.125 Mabswid
0 .02224 m
.00375 .02224 L
s
0 .03855 m
.00375 .03855 L
s
0 .05485 m
.00375 .05485 L
s
0 .07116 m
.00375 .07116 L
s
0 .10377 m
.00375 .10377 L
s
0 .12007 m
.00375 .12007 L
s
0 .13638 m
.00375 .13638 L
s
0 .15268 m
.00375 .15268 L
s
0 .18529 m
.00375 .18529 L
s
0 .20159 m
.00375 .20159 L
s
0 .2179 m
.00375 .2179 L
s
0 .2342 m
.00375 .2342 L
s
0 .26681 m
.00375 .26681 L
s
0 .28312 m
.00375 .28312 L
s
0 .29942 m
.00375 .29942 L
s
0 .31573 m
.00375 .31573 L
s
0 .34834 m
.00375 .34834 L
s
0 .36464 m
.00375 .36464 L
s
0 .38095 m
.00375 .38095 L
s
0 .39725 m
.00375 .39725 L
s
0 .42986 m
.00375 .42986 L
s
0 .44617 m
.00375 .44617 L
s
0 .46247 m
.00375 .46247 L
s
0 .47877 m
.00375 .47877 L
s
0 .51138 m
.00375 .51138 L
s
0 .52769 m
.00375 .52769 L
s
0 .54399 m
.00375 .54399 L
s
0 .5603 m
.00375 .5603 L
s
0 .59291 m
.00375 .59291 L
s
0 .60921 m
.00375 .60921 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00594 m
1 .00594 L
s
.99375 .08746 m
1 .08746 L
s
.99375 .16899 m
1 .16899 L
s
.99375 .25051 m
1 .25051 L
s
.99375 .33203 m
1 .33203 L
s
.99375 .41356 m
1 .41356 L
s
.99375 .49508 m
1 .49508 L
s
.99375 .5766 m
1 .5766 L
s
.125 Mabswid
.99625 .02224 m
1 .02224 L
s
.99625 .03855 m
1 .03855 L
s
.99625 .05485 m
1 .05485 L
s
.99625 .07116 m
1 .07116 L
s
.99625 .10377 m
1 .10377 L
s
.99625 .12007 m
1 .12007 L
s
.99625 .13638 m
1 .13638 L
s
.99625 .15268 m
1 .15268 L
s
.99625 .18529 m
1 .18529 L
s
.99625 .20159 m
1 .20159 L
s
.99625 .2179 m
1 .2179 L
s
.99625 .2342 m
1 .2342 L
s
.99625 .26681 m
1 .26681 L
s
.99625 .28312 m
1 .28312 L
s
.99625 .29942 m
1 .29942 L
s
.99625 .31573 m
1 .31573 L
s
.99625 .34834 m
1 .34834 L
s
.99625 .36464 m
1 .36464 L
s
.99625 .38095 m
1 .38095 L
s
.99625 .39725 m
1 .39725 L
s
.99625 .42986 m
1 .42986 L
s
.99625 .44617 m
1 .44617 L
s
.99625 .46247 m
1 .46247 L
s
.99625 .47877 m
1 .47877 L
s
.99625 .51138 m
1 .51138 L
s
.99625 .52769 m
1 .52769 L
s
.99625 .54399 m
1 .54399 L
s
.99625 .5603 m
1 .5603 L
s
.99625 .59291 m
1 .59291 L
s
.99625 .60921 m
1 .60921 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .36415 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .25051 m
.02642 .25692 L
.02903 .25049 L
.03164 .27069 L
.03425 .28881 L
.03686 .2768 L
.03947 .25678 L
.04207 .25903 L
.04468 .27805 L
.04729 .30689 L
.0499 .30316 L
.05251 .30366 L
.05512 .34966 L
.05773 .38125 L
.06034 .3847 L
.06295 .38113 L
.06556 .35837 L
.06817 .35217 L
.07078 .36758 L
.07339 .34089 L
.07599 .34829 L
.0786 .34465 L
.08121 .32332 L
.08382 .32618 L
.08643 .31236 L
.08904 .32602 L
.09165 .3187 L
.09426 .29802 L
.09687 .28379 L
.09948 .24829 L
.10209 .24762 L
.1047 .22263 L
.10731 .22985 L
.10992 .24599 L
.11252 .23178 L
.11513 .23078 L
.11774 .22245 L
.12035 .2202 L
.12296 .23236 L
.12557 .23777 L
.12818 .23984 L
.13079 .26719 L
.1334 .26071 L
.13601 .27207 L
.13862 .27065 L
.14123 .25161 L
.14384 .27459 L
.14644 .3121 L
.14905 .30529 L
.15166 .2964 L
Mistroke
.15427 .27788 L
.15688 .2925 L
.15949 .28186 L
.1621 .29098 L
.16471 .27316 L
.16732 .26444 L
.16993 .2895 L
.17254 .28517 L
.17515 .27258 L
.17776 .29404 L
.18037 .25391 L
.18297 .23426 L
.18558 .22909 L
.18819 .20177 L
.1908 .18386 L
.19341 .20998 L
.19602 .19595 L
.19863 .22232 L
.20124 .20771 L
.20385 .22452 L
.20646 .21875 L
.20907 .21307 L
.21168 .22661 L
.21429 .20854 L
.21689 .23231 L
.2195 .23924 L
.22211 .22224 L
.22472 .25259 L
.22733 .21569 L
.22994 .21349 L
.23255 .22702 L
.23516 .23205 L
.23777 .25277 L
.24038 .23671 L
.24299 .21776 L
.2456 .20936 L
.24821 .21441 L
.25082 .21134 L
.25342 .20557 L
.25603 .21932 L
.25864 .21335 L
.26125 .23449 L
.26386 .23764 L
.26647 .2372 L
.26908 .26509 L
.27169 .25586 L
.2743 .25593 L
.27691 .26461 L
.27952 .25862 L
.28213 .28099 L
Mistroke
.28474 .28098 L
.28735 .26623 L
.28995 .25193 L
.29256 .23292 L
.29517 .22776 L
.29778 .21897 L
.30039 .22107 L
.303 .21885 L
.30561 .20821 L
.30822 .21736 L
.31083 .21954 L
.31344 .23412 L
.31605 .22474 L
.31866 .25108 L
.32127 .27193 L
.32387 .25231 L
.32648 .2471 L
.32909 .2413 L
.3317 .26155 L
.33431 .23763 L
.33692 .25922 L
.33953 .26032 L
.34214 .2653 L
.34475 .2569 L
.34736 .23979 L
.34997 .22827 L
.35258 .23082 L
.35519 .26454 L
.3578 .24996 L
.3604 .27386 L
.36301 .27722 L
.36562 .26435 L
.36823 .23938 L
.37084 .26804 L
.37345 .28441 L
.37606 .28243 L
.37867 .27874 L
.38128 .27573 L
.38389 .26201 L
.3865 .24496 L
.38911 .24986 L
.39172 .27512 L
.39432 .30054 L
.39693 .29254 L
.39954 .2889 L
.40215 .29147 L
.40476 .3078 L
.40737 .28089 L
.40998 .2743 L
.41259 .26566 L
Mistroke
.4152 .27237 L
.41781 .28522 L
.42042 .25933 L
.42303 .25397 L
.42564 .28072 L
.42825 .26119 L
.43085 .28112 L
.43346 .29623 L
.43607 .32459 L
.43868 .30582 L
.44129 .32835 L
.4439 .36341 L
.44651 .37931 L
.44912 .38052 L
.45173 .37828 L
.45434 .36596 L
.45695 .37173 L
.45956 .40228 L
.46217 .41539 L
.46477 .41256 L
.46738 .43933 L
.46999 .41643 L
.4726 .42148 L
.47521 .41575 L
.47782 .41632 L
.48043 .45209 L
.48304 .45314 L
.48565 .46107 L
.48826 .46538 L
.49087 .45361 L
.49348 .48435 L
.49609 .44599 L
.4987 .39901 L
.5013 .41048 L
.50391 .40449 L
.50652 .39398 L
.50913 .37919 L
.51174 .39056 L
.51435 .41516 L
.51696 .40394 L
.51957 .42037 L
.52218 .37903 L
.52479 .38812 L
.5274 .42881 L
.53001 .42972 L
.53262 .44747 L
.53523 .45365 L
.53783 .47605 L
.54044 .48861 L
.54305 .49068 L
Mistroke
.54566 .46136 L
.54827 .46003 L
.55088 .47951 L
.55349 .49602 L
.5561 .52439 L
.55871 .53243 L
.56132 .53411 L
.56393 .5412 L
.56654 .51512 L
.56915 .50894 L
.57175 .4681 L
.57436 .48251 L
.57697 .50869 L
.57958 .54557 L
.58219 .55345 L
.5848 .53972 L
.58741 .54943 L
.59002 .54427 L
.59263 .55607 L
.59524 .57051 L
.59785 .55813 L
.60046 .54103 L
.60307 .53683 L
.60568 .50465 L
.60828 .52515 L
.61089 .52117 L
.6135 .54587 L
.61611 .51586 L
.61872 .49098 L
.62133 .4758 L
.62394 .47904 L
.62655 .49268 L
.62916 .48257 L
.63177 .49346 L
.63438 .49862 L
.63699 .51825 L
.6396 .50869 L
.6422 .4954 L
.64481 .51223 L
.64742 .52355 L
.65003 .49073 L
.65264 .51203 L
.65525 .4978 L
.65786 .48424 L
.66047 .49803 L
.66308 .51783 L
.66569 .50775 L
.6683 .5347 L
.67091 .54685 L
.67352 .55533 L
Mistroke
.67613 .54898 L
.67873 .5154 L
.68134 .53216 L
.68395 .51103 L
.68656 .50713 L
.68917 .51534 L
.69178 .48923 L
.69439 .48848 L
.697 .51892 L
.69961 .53869 L
.70222 .50623 L
.70483 .49378 L
.70744 .48367 L
.71005 .48752 L
.71265 .47935 L
.71526 .48865 L
.71787 .46617 L
.72048 .45773 L
.72309 .44747 L
.7257 .42936 L
.72831 .44589 L
.73092 .45907 L
.73353 .47844 L
.73614 .48581 L
.73875 .46551 L
.74136 .45397 L
.74397 .44952 L
.74658 .46532 L
.74918 .47766 L
.75179 .48505 L
.7544 .51098 L
.75701 .52174 L
.75962 .53849 L
.76223 .52267 L
.76484 .51619 L
.76745 .48983 L
.77006 .47542 L
.77267 .48609 L
.77528 .52156 L
.77789 .55563 L
.7805 .57642 L
.78311 .54427 L
.78571 .53424 L
.78832 .56558 L
.79093 .56413 L
.79354 .55616 L
.79615 .55181 L
.79876 .54786 L
.80137 .5488 L
.80398 .58079 L
Mistroke
.80659 .58211 L
.8092 .57878 L
.81181 .56203 L
.81442 .59355 L
.81703 .57032 L
.81963 .57076 L
.82224 .58562 L
.82485 .57821 L
.82746 .58878 L
.83007 .58255 L
.83268 .58321 L
.83529 .57976 L
.8379 .57633 L
.84051 .59486 L
.84312 .58229 L
.84573 .58633 L
.84834 .60309 L
.85095 .60332 L
.85356 .5999 L
.85616 .5913 L
.85877 .56301 L
.86138 .58004 L
.86399 .56982 L
.8666 .54459 L
.86921 .53072 L
.87182 .5213 L
.87443 .50449 L
.87704 .49104 L
.87965 .48332 L
.88226 .47805 L
.88487 .46774 L
.88748 .49348 L
.89008 .49031 L
.89269 .51079 L
.8953 .52206 L
.89791 .49363 L
.90052 .49843 L
.90313 .48834 L
.90574 .48053 L
.90835 .49438 L
.91096 .4478 L
.91357 .44875 L
.91618 .43497 L
.91879 .44653 L
.9214 .46354 L
.92401 .45866 L
.92661 .46661 L
.92922 .44344 L
.93183 .43041 L
.93444 .45413 L
Mistroke
.93705 .4595 L
.93966 .43734 L
.94227 .4397 L
.94488 .44983 L
.94749 .44352 L
.9501 .45033 L
.95271 .45239 L
.95532 .42516 L
.95793 .426 L
.96053 .40771 L
.96314 .42072 L
.96575 .39075 L
.96836 .38642 L
.97097 .37046 L
.97358 .35263 L
.97619 .36415 L
Mfstroke
0 0 1 r
gsave
.97619 .25386 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25051 m
.02642 .25051 L
.02903 .25051 L
.03164 .25051 L
.03425 .25051 L
.03686 .25051 L
.03947 .25051 L
.04207 .24846 L
.04468 .24846 L
.04729 .24847 L
.0499 .24847 L
.05251 .24848 L
.05512 .24848 L
.05773 .24849 L
.06034 .247 L
.06295 .24701 L
.06556 .24702 L
.06817 .24703 L
.07078 .24704 L
.07339 .24705 L
.07599 .24706 L
.0786 .24675 L
.08121 .24676 L
.08382 .24677 L
.08643 .24678 L
.08904 .24679 L
.09165 .2468 L
.09426 .24681 L
.09687 .24453 L
.09948 .24455 L
.10209 .24456 L
.1047 .24458 L
.10731 .2446 L
.10992 .24461 L
.11252 .24463 L
.11513 .24381 L
.11774 .24383 L
.12035 .24385 L
.12296 .24386 L
.12557 .24388 L
.12818 .2439 L
.13079 .24392 L
.1334 .2437 L
.13601 .24372 L
.13862 .24374 L
.14123 .24376 L
.14384 .24377 L
.14644 .24379 L
.14905 .24381 L
.15166 .24756 L
Mistroke
.15427 .24757 L
.15688 .24758 L
.15949 .24759 L
.1621 .2476 L
.16471 .2476 L
.16732 .24761 L
.16993 .24778 L
.17254 .24779 L
.17515 .2478 L
.17776 .24781 L
.18037 .24781 L
.18297 .24782 L
.18558 .24783 L
.18819 .24928 L
.1908 .24929 L
.19341 .24929 L
.19602 .24929 L
.19863 .2493 L
.20124 .2493 L
.20385 .2493 L
.20646 .253 L
.20907 .253 L
.21168 .25299 L
.21429 .25298 L
.21689 .25297 L
.2195 .25297 L
.22211 .25296 L
.22472 .25256 L
.22733 .25255 L
.22994 .25255 L
.23255 .25254 L
.23516 .25253 L
.23777 .25253 L
.24038 .25252 L
.24299 .25278 L
.2456 .25278 L
.24821 .25277 L
.25082 .25277 L
.25342 .25276 L
.25603 .25275 L
.25864 .25275 L
.26125 .25252 L
.26386 .25251 L
.26647 .25251 L
.26908 .2525 L
.27169 .2525 L
.2743 .25249 L
.27691 .25249 L
.27952 .25398 L
.28213 .25398 L
Mistroke
.28474 .25397 L
.28735 .25396 L
.28995 .25395 L
.29256 .25394 L
.29517 .25393 L
.29778 .25408 L
.30039 .25407 L
.303 .25406 L
.30561 .25405 L
.30822 .25404 L
.31083 .25403 L
.31344 .25402 L
.31605 .25208 L
.31866 .25207 L
.32127 .25207 L
.32387 .25206 L
.32648 .25206 L
.32909 .25206 L
.3317 .25205 L
.33431 .25183 L
.33692 .25182 L
.33953 .25182 L
.34214 .25182 L
.34475 .25181 L
.34736 .25181 L
.34997 .25181 L
.35258 .24942 L
.35519 .24942 L
.3578 .24942 L
.3604 .24942 L
.36301 .24943 L
.36562 .24943 L
.36823 .24943 L
.37084 .2498 L
.37345 .2498 L
.37606 .2498 L
.37867 .24981 L
.38128 .24981 L
.38389 .24981 L
.3865 .24981 L
.38911 .25452 L
.39172 .25451 L
.39432 .2545 L
.39693 .25449 L
.39954 .25447 L
.40215 .25446 L
.40476 .25445 L
.40737 .25466 L
.40998 .25465 L
.41259 .25464 L
Mistroke
.4152 .25463 L
.41781 .25462 L
.42042 .25461 L
.42303 .2546 L
.42564 .25332 L
.42825 .25332 L
.43085 .25331 L
.43346 .2533 L
.43607 .25329 L
.43868 .25329 L
.44129 .25328 L
.4439 .25532 L
.44651 .25531 L
.44912 .25529 L
.45173 .25528 L
.45434 .25527 L
.45695 .25525 L
.45956 .25524 L
.46217 .25505 L
.46477 .25503 L
.46738 .25502 L
.46999 .25501 L
.4726 .255 L
.47521 .25498 L
.47782 .25497 L
.48043 .2509 L
.48304 .2509 L
.48565 .2509 L
.48826 .2509 L
.49087 .2509 L
.49348 .25089 L
.49609 .25089 L
.4987 .25133 L
.5013 .25133 L
.50391 .25133 L
.50652 .25133 L
.50913 .25133 L
.51174 .25132 L
.51435 .25132 L
.51696 .25037 L
.51957 .25037 L
.52218 .25037 L
.52479 .25037 L
.5274 .25037 L
.53001 .25037 L
.53262 .25037 L
.53523 .25497 L
.53783 .25496 L
.54044 .25495 L
.54305 .25494 L
Mistroke
.54566 .25493 L
.54827 .25491 L
.55088 .2549 L
.55349 .25875 L
.5561 .25873 L
.55871 .2587 L
.56132 .25868 L
.56393 .25866 L
.56654 .25864 L
.56915 .25861 L
.57175 .26861 L
.57436 .26856 L
.57697 .26852 L
.57958 .26847 L
.58219 .26842 L
.5848 .26837 L
.58741 .26832 L
.59002 .26359 L
.59263 .26356 L
.59524 .26352 L
.59785 .26349 L
.60046 .26345 L
.60307 .26342 L
.60568 .26338 L
.60828 .25729 L
.61089 .25727 L
.6135 .25725 L
.61611 .25724 L
.61872 .25722 L
.62133 .2572 L
.62394 .25718 L
.62655 .25397 L
.62916 .25396 L
.63177 .25395 L
.63438 .25394 L
.63699 .25393 L
.6396 .25392 L
.6422 .25391 L
.64481 .2504 L
.64742 .2504 L
.65003 .2504 L
.65264 .2504 L
.65525 .2504 L
.65786 .2504 L
.66047 .2504 L
.66308 .24126 L
.66569 .24128 L
.6683 .24131 L
.67091 .24133 L
.67352 .24136 L
Mistroke
.67613 .24138 L
.67873 .24141 L
.68134 .24964 L
.68395 .24964 L
.68656 .24964 L
.68917 .24964 L
.69178 .24965 L
.69439 .24965 L
.697 .24965 L
.69961 .23416 L
.70222 .2342 L
.70483 .23425 L
.70744 .23429 L
.71005 .23434 L
.71265 .23438 L
.71526 .23442 L
.71787 .23724 L
.72048 .23727 L
.72309 .23731 L
.7257 .23735 L
.72831 .23738 L
.73092 .23742 L
.73353 .23745 L
.73614 .2498 L
.73875 .2498 L
.74136 .24981 L
.74397 .24981 L
.74658 .24981 L
.74918 .24981 L
.75179 .24981 L
.7544 .24019 L
.75701 .24022 L
.75962 .24025 L
.76223 .24028 L
.76484 .2403 L
.76745 .24033 L
.77006 .24036 L
.77267 .24249 L
.77528 .24252 L
.77789 .24254 L
.7805 .24256 L
.78311 .24258 L
.78571 .2426 L
.78832 .24263 L
.79093 .23315 L
.79354 .2332 L
.79615 .23325 L
.79876 .23329 L
.80137 .23334 L
.80398 .23339 L
Mistroke
.80659 .23343 L
.8092 .24688 L
.81181 .24689 L
.81442 .2469 L
.81703 .24691 L
.81963 .24692 L
.82224 .24693 L
.82485 .24694 L
.82746 .24104 L
.83007 .24107 L
.83268 .24109 L
.83529 .24112 L
.8379 .24114 L
.84051 .24117 L
.84312 .2412 L
.84573 .25239 L
.84834 .25238 L
.85095 .25238 L
.85356 .25237 L
.85616 .25237 L
.85877 .25236 L
.86138 .25236 L
.86399 .2527 L
.8666 .25269 L
.86921 .25268 L
.87182 .25268 L
.87443 .25267 L
.87704 .25267 L
.87965 .25266 L
.88226 .24004 L
.88487 .24006 L
.88748 .24009 L
.89008 .24012 L
.89269 .24015 L
.8953 .24018 L
.89791 .24021 L
.90052 .25139 L
.90313 .25139 L
.90574 .25138 L
.90835 .25138 L
.91096 .25138 L
.91357 .25138 L
.91618 .25137 L
.91879 .25611 L
.9214 .25609 L
.92401 .25608 L
.92661 .25606 L
.92922 .25605 L
.93183 .25603 L
.93444 .25602 L
Mistroke
.93705 .25506 L
.93966 .25505 L
.94227 .25503 L
.94488 .25502 L
.94749 .25501 L
.9501 .255 L
.95271 .25498 L
.95532 .25768 L
.95793 .25766 L
.96053 .25764 L
.96314 .25762 L
.96575 .2576 L
.96836 .25758 L
.97097 .25756 L
.97358 .25386 L
.97619 .25386 L
Mfstroke
0 .98 .604 r
gsave
.97619 .47593 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41356 m
.02642 .414 L
.02903 .41445 L
.03164 .41488 L
.03425 .41532 L
.03686 .41575 L
.03947 .41618 L
.04207 .41454 L
.04468 .41497 L
.04729 .41539 L
.0499 .41581 L
.05251 .41623 L
.05512 .41664 L
.05773 .41705 L
.06034 .41595 L
.06295 .41636 L
.06556 .41677 L
.06817 .41717 L
.07078 .41757 L
.07339 .41797 L
.07599 .41836 L
.0786 .41842 L
.08121 .41881 L
.08382 .41919 L
.08643 .41957 L
.08904 .41995 L
.09165 .42033 L
.09426 .42071 L
.09687 .41877 L
.09948 .41915 L
.10209 .41952 L
.1047 .41989 L
.10731 .42026 L
.10992 .42062 L
.11252 .42098 L
.11513 .42049 L
.11774 .42084 L
.12035 .4212 L
.12296 .42156 L
.12557 .42191 L
.12818 .42226 L
.13079 .4226 L
.1334 .42269 L
.13601 .42303 L
.13862 .42337 L
.14123 .42371 L
.14384 .42405 L
.14644 .42438 L
.14905 .42471 L
.15166 .42875 L
Mistroke
.15427 .42907 L
.15688 .42938 L
.15949 .42969 L
.1621 .43 L
.16471 .43031 L
.16732 .43061 L
.16993 .43106 L
.17254 .43136 L
.17515 .43166 L
.17776 .43196 L
.18037 .43225 L
.18297 .43254 L
.18558 .43283 L
.18819 .43455 L
.1908 .43483 L
.19341 .43511 L
.19602 .43539 L
.19863 .43567 L
.20124 .43594 L
.20385 .43621 L
.20646 .44016 L
.20907 .44042 L
.21168 .44067 L
.21429 .44093 L
.21689 .44118 L
.2195 .44144 L
.22211 .44169 L
.22472 .44151 L
.22733 .44176 L
.22994 .44201 L
.23255 .44225 L
.23516 .4425 L
.23777 .44274 L
.24038 .44298 L
.24299 .44346 L
.2456 .44369 L
.24821 .44393 L
.25082 .44416 L
.25342 .44439 L
.25603 .44462 L
.25864 .44485 L
.26125 .44483 L
.26386 .44505 L
.26647 .44528 L
.26908 .4455 L
.27169 .44572 L
.2743 .44594 L
.27691 .44616 L
.27952 .44786 L
.28213 .44807 L
Mistroke
.28474 .44828 L
.28735 .44849 L
.28995 .44869 L
.29256 .4489 L
.29517 .4491 L
.29778 .44944 L
.30039 .44964 L
.303 .44984 L
.30561 .45004 L
.30822 .45024 L
.31083 .45043 L
.31344 .45063 L
.31605 .44886 L
.31866 .44906 L
.32127 .44925 L
.32387 .44945 L
.32648 .44964 L
.32909 .44983 L
.3317 .45003 L
.33431 .44997 L
.33692 .45016 L
.33953 .45035 L
.34214 .45053 L
.34475 .45072 L
.34736 .4509 L
.34997 .45109 L
.35258 .44885 L
.35519 .44904 L
.3578 .44923 L
.3604 .44941 L
.36301 .4496 L
.36562 .44978 L
.36823 .44996 L
.37084 .45048 L
.37345 .45066 L
.37606 .45083 L
.37867 .45101 L
.38128 .45119 L
.38389 .45136 L
.3865 .45153 L
.38911 .45638 L
.39172 .45654 L
.39432 .4567 L
.39693 .45685 L
.39954 .45701 L
.40215 .45716 L
.40476 .45732 L
.40737 .45766 L
.40998 .45781 L
.41259 .45796 L
Mistroke
.4152 .45811 L
.41781 .45826 L
.42042 .45841 L
.42303 .45855 L
.42564 .45741 L
.42825 .45755 L
.43085 .4577 L
.43346 .45785 L
.43607 .45799 L
.43868 .45813 L
.44129 .45828 L
.4439 .46044 L
.44651 .46057 L
.44912 .46071 L
.45173 .46084 L
.45434 .46098 L
.45695 .46111 L
.45956 .46124 L
.46217 .46116 L
.46477 .46129 L
.46738 .46142 L
.46999 .46155 L
.4726 .46167 L
.47521 .4618 L
.47782 .46193 L
.48043 .45796 L
.48304 .4581 L
.48565 .45823 L
.48826 .45837 L
.49087 .4585 L
.49348 .45863 L
.49609 .45876 L
.4987 .45931 L
.5013 .45944 L
.50391 .45956 L
.50652 .45969 L
.50913 .45982 L
.51174 .45994 L
.51435 .46007 L
.51696 .45921 L
.51957 .45933 L
.52218 .45946 L
.52479 .45959 L
.5274 .45971 L
.53001 .45983 L
.53262 .45996 L
.53523 .46465 L
.53783 .46476 L
.54044 .46487 L
.54305 .46498 L
Mistroke
.54566 .46508 L
.54827 .46519 L
.55088 .46529 L
.55349 .46922 L
.5561 .46932 L
.55871 .46941 L
.56132 .4695 L
.56393 .4696 L
.56654 .46969 L
.56915 .46978 L
.57175 .47986 L
.57436 .47992 L
.57697 .47998 L
.57958 .48004 L
.58219 .4801 L
.5848 .48016 L
.58741 .48022 L
.59002 .47557 L
.59263 .47564 L
.59524 .47571 L
.59785 .47578 L
.60046 .47585 L
.60307 .47592 L
.60568 .47599 L
.60828 .46997 L
.61089 .47005 L
.6135 .47014 L
.61611 .47022 L
.61872 .4703 L
.62133 .47039 L
.62394 .47047 L
.62655 .46732 L
.62916 .46741 L
.63177 .4675 L
.63438 .46759 L
.63699 .46768 L
.6396 .46777 L
.6422 .46785 L
.64481 .4644 L
.64742 .4645 L
.65003 .46459 L
.65264 .46469 L
.65525 .46478 L
.65786 .46487 L
.66047 .46496 L
.66308 .45588 L
.66569 .45599 L
.6683 .45611 L
.67091 .45623 L
.67352 .45634 L
Mistroke
.67613 .45645 L
.67873 .45657 L
.68134 .46485 L
.68395 .46494 L
.68656 .46503 L
.68917 .46512 L
.69178 .46521 L
.69439 .4653 L
.697 .46539 L
.69961 .44994 L
.70222 .45007 L
.70483 .4502 L
.70744 .45033 L
.71005 .45046 L
.71265 .45058 L
.71526 .45071 L
.71787 .45357 L
.72048 .45369 L
.72309 .4538 L
.7257 .45392 L
.72831 .45404 L
.73092 .45415 L
.73353 .45427 L
.73614 .46666 L
.73875 .46674 L
.74136 .46682 L
.74397 .4669 L
.74658 .46698 L
.74918 .46706 L
.75179 .46713 L
.7544 .45755 L
.75701 .45765 L
.75962 .45776 L
.76223 .45786 L
.76484 .45796 L
.76745 .45806 L
.77006 .45816 L
.77267 .46034 L
.77528 .46043 L
.77789 .46053 L
.7805 .46062 L
.78311 .46071 L
.78571 .4608 L
.78832 .4609 L
.79093 .45146 L
.79354 .45157 L
.79615 .45169 L
.79876 .45181 L
.80137 .45192 L
.80398 .45204 L
Mistroke
.80659 .45215 L
.8092 .46563 L
.81181 .4657 L
.81442 .46578 L
.81703 .46586 L
.81963 .46593 L
.82224 .46601 L
.82485 .46608 L
.82746 .46022 L
.83007 .46031 L
.83268 .4604 L
.83529 .46049 L
.8379 .46058 L
.84051 .46067 L
.84312 .46076 L
.84573 .47197 L
.84834 .47203 L
.85095 .47209 L
.85356 .47214 L
.85616 .4722 L
.85877 .47226 L
.86138 .47231 L
.86399 .47268 L
.8666 .47273 L
.86921 .47278 L
.87182 .47284 L
.87443 .47289 L
.87704 .47294 L
.87965 .473 L
.88226 .46039 L
.88487 .46048 L
.88748 .46057 L
.89008 .46065 L
.89269 .46074 L
.8953 .46082 L
.89791 .46091 L
.90052 .47211 L
.90313 .47216 L
.90574 .47222 L
.90835 .47227 L
.91096 .47232 L
.91357 .47237 L
.91618 .47243 L
.91879 .47718 L
.9214 .47721 L
.92401 .47725 L
.92661 .47729 L
.92922 .47733 L
.93183 .47737 L
.93444 .4774 L
Mistroke
.93705 .47646 L
.93966 .4765 L
.94227 .47654 L
.94488 .47658 L
.94749 .47662 L
.9501 .47665 L
.95271 .47669 L
.95532 .4794 L
.95793 .47943 L
.96053 .47946 L
.96314 .47949 L
.96575 .47952 L
.96836 .47955 L
.97097 .47958 L
.97358 .47589 L
.97619 .47593 L
Mfstroke
gsave
.97619 .03178 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .08746 m
.02642 .08702 L
.02903 .08657 L
.03164 .08613 L
.03425 .0857 L
.03686 .08526 L
.03947 .08484 L
.04207 .08237 L
.04468 .08196 L
.04729 .08154 L
.0499 .08113 L
.05251 .08073 L
.05512 .08032 L
.05773 .07992 L
.06034 .07805 L
.06295 .07766 L
.06556 .07727 L
.06817 .07689 L
.07078 .07651 L
.07339 .07613 L
.07599 .07576 L
.0786 .07508 L
.08121 .07472 L
.08382 .07435 L
.08643 .07399 L
.08904 .07363 L
.09165 .07327 L
.09426 .07292 L
.09687 .07029 L
.09948 .06995 L
.10209 .06961 L
.1047 .06927 L
.10731 .06894 L
.10992 .06861 L
.11252 .06828 L
.11513 .06713 L
.11774 .06681 L
.12035 .06649 L
.12296 .06617 L
.12557 .06586 L
.12818 .06554 L
.13079 .06523 L
.1334 .06471 L
.13601 .0644 L
.13862 .0641 L
.14123 .0638 L
.14384 .0635 L
.14644 .06321 L
.14905 .06291 L
.15166 .06637 L
Mistroke
.15427 .06607 L
.15688 .06578 L
.15949 .06548 L
.1621 .06519 L
.16471 .0649 L
.16732 .06461 L
.16993 .06451 L
.17254 .06422 L
.17515 .06394 L
.17776 .06366 L
.18037 .06338 L
.18297 .0631 L
.18558 .06282 L
.18819 .06402 L
.1908 .06374 L
.19341 .06347 L
.19602 .0632 L
.19863 .06293 L
.20124 .06266 L
.20385 .06239 L
.20646 .06585 L
.20907 .06557 L
.21168 .0653 L
.21429 .06503 L
.21689 .06477 L
.2195 .0645 L
.22211 .06424 L
.22472 .0636 L
.22733 .06334 L
.22994 .06308 L
.23255 .06283 L
.23516 .06257 L
.23777 .06232 L
.24038 .06207 L
.24299 .06211 L
.2456 .06186 L
.24821 .06162 L
.25082 .06137 L
.25342 .06113 L
.25603 .06089 L
.25864 .06065 L
.26125 .06021 L
.26386 .05997 L
.26647 .05974 L
.26908 .0595 L
.27169 .05927 L
.2743 .05904 L
.27691 .05881 L
.27952 .06011 L
.28213 .05988 L
Mistroke
.28474 .05965 L
.28735 .05943 L
.28995 .0592 L
.29256 .05898 L
.29517 .05875 L
.29778 .05872 L
.30039 .0585 L
.303 .05828 L
.30561 .05806 L
.30822 .05784 L
.31083 .05763 L
.31344 .05741 L
.31605 .0553 L
.31866 .05509 L
.32127 .05488 L
.32387 .05468 L
.32648 .05448 L
.32909 .05428 L
.3317 .05408 L
.33431 .05369 L
.33692 .05349 L
.33953 .0533 L
.34214 .0531 L
.34475 .05291 L
.34736 .05272 L
.34997 .05253 L
.35258 .04998 L
.35519 .0498 L
.3578 .04961 L
.3604 .04944 L
.36301 .04926 L
.36562 .04908 L
.36823 .0489 L
.37084 .04912 L
.37345 .04895 L
.37606 .04877 L
.37867 .0486 L
.38128 .04843 L
.38389 .04826 L
.3865 .04809 L
.38911 .05265 L
.39172 .05247 L
.39432 .0523 L
.39693 .05212 L
.39954 .05194 L
.40215 .05176 L
.40476 .05159 L
.40737 .05167 L
.40998 .05149 L
.41259 .05132 L
Mistroke
.4152 .05115 L
.41781 .05098 L
.42042 .05081 L
.42303 .05064 L
.42564 .04924 L
.42825 .04908 L
.43085 .04892 L
.43346 .04876 L
.43607 .0486 L
.43868 .04844 L
.44129 .04828 L
.4439 .0502 L
.44651 .05004 L
.44912 .04988 L
.45173 .04972 L
.45434 .04956 L
.45695 .0494 L
.45956 .04924 L
.46217 .04894 L
.46477 .04878 L
.46738 .04863 L
.46999 .04847 L
.4726 .04832 L
.47521 .04817 L
.47782 .04802 L
.48043 .04384 L
.48304 .0437 L
.48565 .04356 L
.48826 .04343 L
.49087 .04329 L
.49348 .04316 L
.49609 .04302 L
.4987 .04336 L
.5013 .04323 L
.50391 .0431 L
.50652 .04297 L
.50913 .04283 L
.51174 .0427 L
.51435 .04257 L
.51696 .04152 L
.51957 .0414 L
.52218 .04127 L
.52479 .04115 L
.5274 .04103 L
.53001 .0409 L
.53262 .04078 L
.53523 .0453 L
.53783 .04516 L
.54044 .04503 L
.54305 .0449 L
Mistroke
.54566 .04477 L
.54827 .04464 L
.55088 .04451 L
.55349 .04827 L
.5561 .04813 L
.55871 .048 L
.56132 .04786 L
.56393 .04772 L
.56654 .04759 L
.56915 .04745 L
.57175 .05737 L
.57436 .05721 L
.57697 .05705 L
.57958 .05689 L
.58219 .05673 L
.5848 .05657 L
.58741 .05642 L
.59002 .05162 L
.59263 .05148 L
.59524 .05133 L
.59785 .05119 L
.60046 .05105 L
.60307 .05091 L
.60568 .05077 L
.60828 .04461 L
.61089 .04449 L
.6135 .04437 L
.61611 .04425 L
.61872 .04413 L
.62133 .04401 L
.62394 .04389 L
.62655 .04062 L
.62916 .04051 L
.63177 .0404 L
.63438 .04029 L
.63699 .04019 L
.6396 .04008 L
.6422 .03997 L
.64481 .0364 L
.64742 .03631 L
.65003 .03621 L
.65264 .03612 L
.65525 .03602 L
.65786 .03593 L
.66047 .03584 L
.66308 .02664 L
.66569 .02657 L
.6683 .0265 L
.67091 .02644 L
.67352 .02637 L
Mistroke
.67613 .02631 L
.67873 .02625 L
.68134 .03442 L
.68395 .03434 L
.68656 .03425 L
.68917 .03417 L
.69178 .03408 L
.69439 .034 L
.697 .03392 L
.69961 .01837 L
.70222 .01833 L
.70483 .01829 L
.70744 .01826 L
.71005 .01822 L
.71265 .01818 L
.71526 .01814 L
.71787 .02091 L
.72048 .02086 L
.72309 .02082 L
.7257 .02077 L
.72831 .02073 L
.73092 .02069 L
.73353 .02064 L
.73614 .03295 L
.73875 .03287 L
.74136 .03279 L
.74397 .03272 L
.74658 .03264 L
.74918 .03257 L
.75179 .0325 L
.7544 .02283 L
.75701 .02278 L
.75962 .02274 L
.76223 .02269 L
.76484 .02265 L
.76745 .0226 L
.77006 .02255 L
.77267 .02465 L
.77528 .0246 L
.77789 .02455 L
.7805 .0245 L
.78311 .02445 L
.78571 .0244 L
.78832 .02435 L
.79093 .01485 L
.79354 .01482 L
.79615 .0148 L
.79876 .01478 L
.80137 .01476 L
.80398 .01474 L
Mistroke
.80659 .01472 L
.8092 .02813 L
.81181 .02807 L
.81442 .02801 L
.81703 .02796 L
.81963 .0279 L
.82224 .02784 L
.82485 .02779 L
.82746 .02186 L
.83007 .02183 L
.83268 .02179 L
.83529 .02175 L
.8379 .02171 L
.84051 .02167 L
.84312 .02163 L
.84573 .0328 L
.84834 .03273 L
.85095 .03267 L
.85356 .0326 L
.85616 .03253 L
.85877 .03247 L
.86138 .0324 L
.86399 .03272 L
.8666 .03265 L
.86921 .03258 L
.87182 .03252 L
.87443 .03245 L
.87704 .03239 L
.87965 .03232 L
.88226 .01968 L
.88487 .01965 L
.88748 .01962 L
.89008 .01959 L
.89269 .01956 L
.8953 .01953 L
.89791 .01951 L
.90052 .03067 L
.90313 .03061 L
.90574 .03055 L
.90835 .0305 L
.91096 .03044 L
.91357 .03038 L
.91618 .03032 L
.91879 .03504 L
.9214 .03497 L
.92401 .0349 L
.92661 .03483 L
.92922 .03477 L
.93183 .0347 L
.93444 .03463 L
Mistroke
.93705 .03366 L
.93966 .03359 L
.94227 .03353 L
.94488 .03346 L
.94749 .0334 L
.9501 .03334 L
.95271 .03327 L
.95532 .03596 L
.95793 .03589 L
.96053 .03582 L
.96314 .03575 L
.96575 .03568 L
.96836 .03561 L
.97097 .03554 L
.97358 .03184 L
.97619 .03178 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{679.75, 210.062},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:W0000dR000`400?l00000o`00003ooooooooo
ooooojWooooo003oooooooooooooZOooool00?oooooooooooonYooooo`00ooooooooooooojWooooo
003oooooooooooooZOooool00?oooooooooooonYooooo`00ooooooooooooojWooooo003ooooooooo
ooooZOooool0053ooooo0_l0000Looooo`?o00001?ooool2o`0001Oooooo0ol00004ooooo`;o0000
1?ooool2o`0001?ooooo0ol00003ooooo`?o00001?ooool2o`0001?ooooo1Ol00003ooooo`;o0000
1?ooool2o`0001;ooooo1Ol00002ooooo`?o00001?ooool2o`0001Cooooo0ol00004ooooo`;o0000
1?ooool2o`0001?ooooo0ol00003ooooo`?o00001?ooool2o`0002[ooooo0_l0000Mooooo`?o0000
1?ooool2o`0001Kooooo0ol00004ooooo`;o00001?ooool2o`0001Cooooo0ol00003ooooo`?o0000
1?ooool2o`0001;ooooo1Ol00003ooooo`;o00001?ooool2o`0001?ooooo1Ol00002ooooo`?o0000
1?ooool2o`0001?ooooo0ol00004ooooo`;o00001?ooool2o`0001Cooooo0ol00003ooooo`?o0000
1?ooool2o`0003[ooooo001?ooooo`04o`000?ooooooooooo`0001[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0001Oooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo00Go0000oooooooooooooooo
o`000003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool04Oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_oo
ool01_l0003oooooooooool0003oooooo`0000?ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0@ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`00017ooooo00Oo0000ooooooooooooooooo`000?oooooo0000
00?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Vooooo`04o`000?oooooo
ooooo`0001_ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0001Ko
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001Cooooo00Go0000ooooooooooooooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool04?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00004oooool01_l0003oooooooooool0003oooooo`0000?ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0?ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001;ooooo00Oo
0000ooooooooooooooooo`000?oooooo000000?ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0gooooo`00Coooool01?l0003oooooooooool0000Nooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00004oooool00ol0003oooooooooo`05ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004oooool00ol0003oooooooooo`05
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool09_ooool01?l0
003oooooooooool0000Oooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00005?ooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00005?ooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool04oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`03ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0=oooool004oooooo00Co0000oooooooooooo00007_ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001?ooooo00?o0000oooooooo
ool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01?ooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
4_ooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Coooo
o`;o00001_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo02Kooooo00Co0000
oooooooooooo00007oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Cooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01Cooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo01;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool04Oooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Dooooo`;o00001_ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo03Oooooo001?ooooo`04o`000?ooooooooooo`0001[ooooo1?l00003ooooo`04o`000?oo
ooooooooo`0001Oooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001?ooooo00Co0000oooooooooooooooo1?l00003ooooo`04o`000?oooooo
ooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004Oooool01_l0003ooooooooooooooooo0000ooooo`Co00000ooo
ool01?l0003oooooooooool0000Fooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo000000?o00000oooool01?l0
003oooooooooool0000Xooooo`04o`000?ooooooooooo`0001_ooooo1?l00003ooooo`04o`000?oo
ooooooooo`0001Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001Cooooo00Co0000oooooooooooooooo1?l00003ooooo`04o`000?oooooo
ooooo`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00004_ooool01_l0003ooooooooooooooooo0000ooooo`Co00000ooo
ool01?l0003oooooooooool0000Eooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo000000?o00000oooool01?l0
003oooooooooool0000iooooo`00Coooool01?l0003oooooooooool0000Jooooo`03o`000?oooooo
oooo00Cooooo00Co0000oooooooooooo00005_ooool2o`0000Cooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000Booooo`;o00000oooool00ol0003oooooooooo`04ooooo`04
o`000?ooooooooooo`0001;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00004Oooool01ol0003ooooooooooooooooo0000oooo
ool000001_ooool01?l0003oooooooooool0000Booooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00017ooooo00Oo0000oooooooo
ooooooooo`000?oooooo000000Kooooo00Co0000oooooooooooo0000:?ooool01?l0003ooooooooo
ool0000Kooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00005Oooool2o`0000Co
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Cooooo`;o00000oooool0
0ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00017ooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00004_ooool01ol0
003ooooooooooooooooo0000ooooool000001_ooool01?l0003oooooooooool0000Aooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001;ooooo00Oo0000ooooooooooooooooo`000?oooooo000000Kooooo00Co0000oooooooooooo
0000>Oooool0053ooooo0_l0000Kooooo`Go00000oooool2o`0001Sooooo00?o0000ooooooooool0
0oooool2o`0000Cooooo0_l0000Dooooo`04o`000?ooooooooooooooo`Go00000oooool2o`0001Co
oooo0ol00004ooooo`;o00001?ooool2o`0001?ooooo0ol00002ooooo`Go00000oooool2o`0001Co
oooo0ol00004ooooo`;o00001?ooool2o`0001?ooooo0ol00002ooooo`Go00000oooool2o`0002[o
oooo0_l0000Looooo`Go00000oooool2o`0001Oooooo00?o0000ooooooooool00oooool2o`0000Co
oooo0_l0000Eooooo`04o`000?ooooooooooooooo`Go00000oooool2o`0001?ooooo0ol00004oooo
o`;o00001?ooool2o`0001Cooooo0ol00002ooooo`Go00000oooool2o`0001?ooooo0ol00004oooo
o`;o00001?ooool2o`0001Cooooo0ol00002ooooo`Go00000oooool2o`0003[ooooo003ooooooooo
ooooZOooool00?oooooooooooonYooooo`00ooooooooooooojWooooo003oooooooooooooZOooool0
0?ooooooE_ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000?ooooo0ol0003ooooo
ocoooooo001:oooooooo00003?l00002ooooo`03o`000?oooooooooo00Kooooo00Ko0000oooooooo
oooo0000ooooool00003ooooo`03o`000?oooooooooo00;oooooool0000;o`0002oooooo001:oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02o`00
00;ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool00005ooooo`03o`000?oooooo
oooo00;ooooo0ol00003ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo1?l0000_ooooo`00B_ooool00ol0
003oooooooooo`3oooooo`Oooooo0_l00002ooooo`03o`000?oooooooooo00Kooooo00Co0000oooo
oooooooo00001Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?oooooo1oooool0
0ol0003oooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`3oooooo`Oooooo0_l00002oooo
o`03o`000?oooooooooo00Kooooo00Go0000oooooooooooo0000ooooo`04o`0000Gooooo00?o0000
ooooooooool0ooooool7ooooo`03o`000?oooooooooo02gooooo001:ooooo`03o`000?oooooooooo
09Wooooo00?o0?ZJooooooooool0J_ooool2o`0000;ooooo00?o0000ooooooooool01_ooool01_l0
003oooooooooool0003oooooo`0000Sooooo00?o0000ooooooooool0]_ooool5o`3jVQ?ooooo1Ol0
nYXcooooo`03o`000?oooooooooo02gooooo001:ooooo`;o0000VOooool2o`3jVV_ooooo0_l00000
0ooooooo0000o`00000:ooooo`;o00000_ooool5o`0000Cooooo00?o0000ooooooooool0]_ooool0
0ol0nY[oooooooooo`02ooooo`Go0?ZJ3_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo1Ol0
nYX9ooooo`Ko0?ZJ6_ooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`2G
ooooo`03o`3jV_oooooo0?ZJ06cooooo00?o0000ooooooooool06?ooool2o`000;Oooooo00?o0?ZJ
ooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`[o0?ZJ1?ooool00ol0nY[oooooooooo`02
ooooo`05o`3jV_ooooooooooooooool0nYX02Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo01Oooooo0_l0000_ooooo`00B_ooool00ol0003oooooooooo`2Gooooo`03o`3jV_oooooo
0?ZJ06cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`2/ooooo`Ko0?ZJ0oooool0
0ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02oooool5
o`3jVPGooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo01Sooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000ooooooooool0Uoooool00ol0
nY[oooooo`3jVP1/ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0[?ooool00ol0
nY[oooooooooo`02ooooo`05o`3jV_ooooooooooooooool0nYX02_ooool5o`3jVQSooooo2_l0nYX4
ooooo`Go0?ZJ1oooool3o`3jVPGooooo00?o0?ZJooooooooool01?ooool00ol0003oooooooooo`0]
ooooo`00B_ooool00ol0003oooooooooo`2Fooooo`04o`3jV_ooooooooooo`3jVVcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`2Xooooo`Go0?ZJ1?ooool5o`3jVS[ooooo1ol0nYX3
ooooo`Go0?ZJ1oooool00ol0003oooooooooo`0]ooooo`00B_ooool2o`0009Gooooo00?o0000oooo
ool0nYX00_ooool00ol0nY[oooooooooo`1Yooooo`;o00006_ooool2o`0008[ooooo0_l0nYXHoooo
o`Go0?ZJGOooool2o`0002oooooo001:ooooo`03o`000?oooooooooo09Cooooo00?o0000o`3jV_oo
ool00_ooool00ol0nY[oooooooooo`1Zooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool0O?ooool=o`3jVP04ooooool0nY[oooooooooo`?o0?ZJ3_ooool5o`3jVV?ooooo00?o0000oooo
ooooool0;Oooool003Oooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03
o`000?oooooooooo09Cooooo00?o0000o`3jV_ooool00_ooool00ol0nY[oooooooooo`1Zooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool0HOooool3o`3jVPcooooo0ol0nYX6ooooo`Co
0?ZJ3_ooool3o`3jVP;ooooo1Ol0nYX9ooooo`03o`3jV_oooooooooo06Gooooo00?o0000oooooooo
ool0;Oooool003Sooooo00?o0000ooooooooool01_ooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool0U?ooool00ol0003o0?ZJooooo`02ooooo`03o`3jV_oooooooooo06[o
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1Jooooo`So0?ZJ00?oooooo`3jV_oo
ool03?l0nYX2ooooo`Ko0?ZJ6oooool00ol0nY[oooooooooo`02ooooo`Go0?ZJJ?ooool00ol0003o
ooooooooo`0]ooooo`00=Oooool5o`0000_ooooo00?o0000ooooooooool00_ooool3o`0009Cooooo
00?o0000o`3jV_ooool00_ooool00ol0nY[oooooooooo`1Xooooo`?o00006_ooool2o`0005;ooooo
2_l0nYX9ooooo`;o0?ZJ;_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo06Wooooo
0_l0000_ooooo`00=Oooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0U?ooool00ol0003o0?ZJooooo`02ooooo`03o`3jV_oooooooooo06[ooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`13ooooo`Co0?ZJ00?oooooo`3jV_l0nYX0
1ol0nYY3ooooo`Go0?ZJKOooool00ol0003oooooooooo`0]ooooo`00=_ooool00ol0003oooooo`00
0008ooooo`Co00001Oooool00ol0003oooooooooo`2Cooooo`03o`000?oooooo003o00Co003oK?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02?ooooo0ol0nYX6ooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX00_l0nYX5ooooo`[o0?ZJ1?ooool00ol0nY[oooooooooo`2looooo`03o`000?oo
oooooooo02gooooo000gooooo`;o00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo09?ooooo00?o0000ooooool00?l00oooool00ol00?ooooooooooo`1Zooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool07?ooool8o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ0oooool0
0ol0nY[oooooooooo`02ooooo`Go0?ZJcOooool00ol0003oooooooooo`0]ooooo`00>?ooool00ol0
003oooooooooo`06ooooo`Go00001?ooool00ol0003oooooooooo`2Cooooo`03o`000?oooooo003o
00?ooooo00?o003oooooooooool0J_ooool00ol0003oooooooooo`0Hooooo`;o00006?ooool5o`3j
V^Wooooo0_l0000_ooooo`00B_ooool2o`0009Cooooo00?o0000ooooool00?l00oooool00ol00?oo
ooooooooo`1Yooooo`;o00006_ooool00ol0003oooooooooo`0Booooo`Go0?ZJkoooool00ol0003o
ooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`2Cooooo`03o`000?oooooo003o00?ooooo
00?o003oooooooooool0J_ooool00ol0003oooooooooo`05ooooo`;o00001?ooool00ol0003ooooo
ooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`0=ooooo`Go0?ZJm?ooool00ol0003ooooo
ooooo`0]ooooo`00B_ooool00ol0003oooooooooo`2Cooooo`03o`000?oooooo003o00?ooooo00Go
003oooooooooooooooooo`3jVP1Xooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00002Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo1Ol0nY[iooooo`03
o`000?oooooooooo02gooooo001:ooooo`03o`000?oooooooooo09?ooooo00?o0000ooooool00?l0
0oooool01Ol00?oooooooooooooooooo0?ZJ06Sooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool00009ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool3o`3j
V_gooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000ooooooooool0Toooool01?l0003o
ooooo`00ool0nYX2ooooo`05o`00ooooooooooooooooool0nYX0J?ooool00ol0003oooooooooo`04
ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01?ooool3o`0000?ooooo0ol0
nY[nooooo`?o0000;oooool004[ooooo0_l0002Dooooo`04o`000?oooooo003oo`3jVP;ooooo00?o
003oooooooooool00_l0nYYWooooo`;o00001_ooool01?l0003oooooooooool00009ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooooooo02gooooo
001:ooooo`03o`000?oooooooooo09?ooooo00_o0000ooooool00?ooooooo`3jV_l0003o003ooooo
ool0nY[oooooo`3jVP1Xooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002?oo
ool2o`0000Kooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooooooo02gooooo001:
ooooo`03o`000?oooooooooo09?ooooo00_o0000ooooool00?oo0000o`3jV_oooooo003oooooool0
nY[oooooo`3jVP1Xooooo`03o`000?oooooooooo00Gooooo0_l0000:ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooooooo02gooooo001:ooooo`03
o`000?oooooooooo09?ooooo00_o0000ooooool00?oo0000o`3jV_oooooo003oooooool0nY[ooooo
o`3jVP1Xooooo`03o`000?oooooooooo01Sooooo0_l0003oooooo`Oooooo0_l0000_ooooo`00B_oo
ool00ol0003oooooooooo`2Cooooo`08o`000?oooooo003oooooool0003o0?ZJo`00ool0nYX2oooo
o`03o`3jV_oooooooooo06Kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooo
o`Oooooo00?o0000ooooooooool0;Oooool004[ooooo0_l0002Dooooo`03o`000?l0nY[o003o00?o
oooo00Go003oo`3jV_ooooooooooo`3jVP1Wooooo`;o00006_ooool00ol0003oooooooooo`3ooooo
o`Oooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000ooooooooool0Toooool00ol0003o
0?ZJo`00o`03ooooo`05o`00ool0nY[oooooooooool0nYX0J?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?oooooo1oooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003o
ooooooooo`2Cooooo`03o`000?l0nY[o003o00?ooooo00Go003oo`3jV_ooooooooooo`3jVP1Xoooo
o`03o`000?oooooooooo01Sooooo0_l0003oooooo`Oooooo0_l0000_ooooo`00B_ooool00ol0003o
ooooooooo`2Booooo`04o`000?oooooo0?ZJo`00o`?ooooo00Go003oooooooooooooooooo`3jVP1X
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooo
oooo02gooooo001:ooooo`;o0000Toooool01?l0003oooooo`3jV_l00?l3ooooo`05o`00oooooooo
ooooooooool0nYX0Ioooool2o`0001[ooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oo
oooooooo02gooooo001:ooooo`03o`000?oooooooooo09;ooooo00Co0000ooooool0nY[o003o0ooo
ool5o`00ofSooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3oooooo`Oooooo00?o
0000ooooooooool0;Oooool0037ooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00003
ooooo`?o00001Oooool00ol0003oooooooooo`2Booooo`04o`000?oooooo003oo`3jVP?ooooo00Go
0?ZJooooool0003oooooo`00o`1Xooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
ooooool7ooooo`03o`000?oooooooooo02gooooo000booooo`03o`000?oooooooooo00Kooooo00Oo
0000ooooooooooooooooo`000?oooooo000000?ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`2Booooo`04o`000?oooooo003oo`3jVP?ooooo00Go0?ZJooooool0003oooooo`00o`1X
ooooo`03o`000?oooooooooo01Sooooo0_l0003oooooo`Oooooo0_l0000_ooooo`00;oooool5o`00
00_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
09;ooooo00Co0000ooooool00?oo0?ZJ1?ooool01?l0nY[oooooo`000?l00?mXooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooooooo02gooooo000_
ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`02ooooo`?o0000T_ooool01?l0003oooooo`00ool0nYX4ooooo`04o`3jV_oooooo0000o`00ofKo
oooo0ol0000Jooooo`03o`000?oooooooooo0?oooooo1oooool00ol0003oooooooooo`0]ooooo`00
<?ooool00ol0003oooooo`000008ooooo`Co00000_ooool4o`0000Gooooo00?o0000ooooooooool0
S?ooool00ol0003oooooooooo`03ooooo`04o`000?oooooo003oo`3jVPCooooo00Go0?ZJoooooooo
oooo003oo`3jVP1Wooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0ooooool7oooo
o`03o`000?oooooooooo02gooooo000aooooo`;o00002?ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0S?ooool00ol0003oooooooooo`03ooooo`04
o`000?oooooo003oo`3jVPCooooo00Go0?ZJoooooooooooo003oo`3jVP1Wooooo`03o`000?oooooo
oooo01Sooooo0_l0003oooooo`Oooooo0_l0000_ooooo`00<_ooool00ol0003oooooooooo`06oooo
o`Go000000?oooooo`000?l000000ol00004ooooo`03o`000?oooooooooo08cooooo00?o0000oooo
ooooool00oooool00ol0003o0?ZJo`00o`06ooooo`04o`3jV_oooooo003oo`3jVVOooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`3oooooo`Oooooo00?o0000ooooooooool0;Oooool0
04[ooooo00?o0000ooooooooool0S?ooool00ol0003oooooooooo`03ooooo`03o`3jV_oooooo003o
00Kooooo00Co0?ZJooooool00?oo0?ZJIoooool01?l0003oooooo`000?l00004ooooo`03o`000?oo
oooooooo00;ooooo0ol00003ooooo`?o00001Oooool00ol0003oooooooooo`3oooooo`Oooooo00?o
0000ooooooooool0;Oooool004[ooooo0_l0002=ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJ
ooooool00?l01_ooool01?l0nY[oooooo`00ool0nYYVooooo`?o00000_ooool00ol0003ooooooooo
o`07ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo0?oooooo1oooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003ooooooooo
o`2<ooooo`;o00001?ooool00ol0nY[oooooo`00o`07ooooo`03o`3jV_l00?oo0?ZJ00?ooooo00?o
0?ZJooooooooool0HOooool2o`0000;ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00;ooooo0ol0003oooooo`Gooooo0ol0000_ooooo`00B_ooool0
0ol0003oooooooooo`2<ooooo`;o000000Ooooooo`000?oooooo0?ZJo`000?oooooo003o00Sooooo
00?o003oo`3jV_ooool00_ooool00ol0nY[oooooooooo`1Qooooo`;o00000_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`3oooooo`Oooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000ooooooooool0S?oo
ool2o`000007ooooool0003oooooo`3jV_l0003oooooo`00o`08ooooo`04o`3jV_l00?oooooooooo
o`;o0?ZJHoooool2o`0000;ooooo00?o0000ooooooooool01oooool01?l0003oooooooooooooool4
o`0000Gooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooooooo02gooooo001:oooo
o`;o0000SOooool2o`000007ooooool0003o0?ZJooooool0003oooooo`00o`08ooooo`06o`3jV_l0
0?ooooooo`3jV_oooooo0?ZJH_ooool3o`0000;ooooo00?o0000ooooooooool01_ooool2o`0000?o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3oooooo`Oooooo00?o0000oooooooo
ool0;Oooool004[ooooo00?o0000ooooooooool0S?ooool2o`000007ooooool0003o0?ZJooooool0
003oooooo`00o`08ooooo`06o`3jV_l00?ooooooo`3jV_oooooo0?ZJHoooool01?l0003oooooo`00
0?l0000:ooooo`04o`000?ooooooooooooooo`Go00001?ooool00ol0003oooooooooo`0`ooooo`03
o`000?oooooooooo0=?ooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000ooooooooool0
S?ooool3o`000006ooooool0nY[oooooo`000?oooooo003o2?ooool01_l0nY[o003oooooool0nY[o
ooooo`3jVV?ooooo00?o0000ooooooooool06?ooool2o`00037ooooo00?o0000ooooooooool0d_oo
ool2o`0002oooooo001:ooooo`03o`000?oooooooooo07Oooooo00?o0?ZJooooooooool04_ooool0
2Ol0003oooooo`000?oooooo0?ZJooooool0003oooooo`00o`08ooooo`06o`3jV_l00?ooooooo`3j
V_oooooo0?ZJHoooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo033ooooo00?o0000
ooooooooool0doooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`1;oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool08oooool2o`3jVPCooooo00?o0?ZJoooo
ooooool03Oooool01_l0003oooooo`000?oooooo0?ZJo`0000;ooooo00?o003oooooooooool01_oo
ool00ol0nY[o003oo`3jVP02ooooo`03o`3jV_oooooooooo067ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0_ooooo`?o0000e?ooool00ol0003oooooooooo`0]ooooo`00B_ooool2
o`0000Wooooo00?o0?ZJooooooooool0@?ooool00ol0nY[oooooo`000002ooooo`03o`3jV_oooooo
oooo01Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
0?ZJ00?ooooo0_l0nYX?ooooo`04o`000?oooooo0000ooooo`Go003o2Oooool01Ol00?oo0?ZJoooo
oooooooo0?ZJ06;ooooo0_l0000Jooooo`03o`000?oooooooooo02oooooo0ol0003Dooooo`03o`00
0?oooooooooo02gooooo001:ooooo`03o`000?oooooooooo00Oooooo0_l0nYY1ooooo`;o0?ZJ00?o
ooooo`000?ooool00_l0nYXGooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1oooool00ol0nY[ooooo
o`3jVP02ooooo`03o`3jV_oooooo0?ZJ00oooooo00Ko0000oooooooooooo0?ZJo`00ool00002oooo
o`03o`3jV_oooooooooo00Oooooo00Go003oo`3jV_l0003oooooo`3jVP1Sooooo`03o`000?oooooo
oooo01Sooooo0_l0000`ooooo`?o0000doooool2o`0002oooooo001:ooooo`03o`000?oooooooooo
00Oooooo0_l0nYX_ooooo`03o`3jV_oooooooooo00oooooo0_l0nYX01Ooooooo0000o`3jV_oooooo
0?ZJ01Kooooo0_l0nYX3ooooo`;o0?ZJ1oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooo
0?ZJ00oooooo00Ko0000ooooool0nY[oooooo`00ool00002ooooo`03o`3jV_oooooooooo00Oooooo
00Go003oooooool0003o0000o`3jVP1Sooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool0;oooool3o`0000kooooo00?o0000ooooooooool0`oooool00ol0003oooooooooo`0]ooooo`00
B_ooool00ol0003oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ02kooooo0_l0nYX@ooooo`08o`3j
V_oooooo0?ZJooooool0003o0?ZJooooool0nYXEooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooool0nYX01Oooool01Ol0003o0?ZJoooooooooooo0?ZJ00;ooooo00?o0?ZJooooool0nYX03ooo
ool01_l0003oooooo`3jV_oooooo003oo`0000;ooooo00?o0?ZJooooooooool01oooool01Ol00?oo
ooooo`000?l0003o0?ZJ06?ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0_oooo
o`;o000000?oooooo`000?ooool00_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo0000
00gooooo00?o0000ooooooooool0]Oooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003o
ooooooooo`06ooooo`03o`3jV_oooooo0?ZJ02kooooo0_l0nYX9ooooo`03o`3jV_oooooooooo00Co
oooo00So0?ZJooooool0nY[oooooo`3jV_l0003oooooo`3jVQGooooo00?o0?ZJooooool0nYX00_oo
ool00ol0nY[oooooo`3jVP05ooooo`07o`000?l0nY[oooooooooool0nY[oooooo`3jVP02ooooo`03
o`3jV_oooooooooo00gooooo00Ko0000o`3jV_ooooooooooo`00ool00002ooooo`03o`3jV_oooooo
oooo00Oooooo1Ol00?l01Ol0nY[ooooooooooooooooo0?ZJ05kooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0_ooooo`08o`000?ooooooooooo`000?oooooo0000ooooool00003oooo
o`04o`000?ooooooooooooooo`?o000000?oooooo`000?ooool02_ooool00ol0003oooooooooo`2e
ooooo`03o`000?oooooooooo02gooooo001:ooooo`;o00001_ooool01?l0nY[oooooooooool0nYX^
ooooo`;o0?ZJ1?ooool01?l0nY[oooooooooooooool2o`3jVPCooooo00[o0?ZJooooool0nY[o0000
o`3jV_oooooo0?ZJo`000?oooooo0?ZJ5Oooool02?l0nY[oooooo`3jV_oooooo0?ZJo`000?oooooo
0?ZJ1?ooool2o`3jVPCooooo0_l0nYX00ol0003oooooo`3jVP0?ooooo`05o`000?l0nY[ooooooooo
ool00?l00oooool00ol0nY[oooooooooo`07ooooo`06o`3jV_oooooo0000ooooool00?oo0?ZJ0_oo
ool2o`3jVUgooooo0_l0000Jooooo`;o0000;oooool02Ol0003ooooooooooooooooo0000ooooool0
003oooooo`000002ooooo`;o00000_ooool01?l0003oooooooooooooool2o`0000[ooooo00?o0000
ooooool00000]Oooool2o`0002oooooo001:ooooo`03o`000?oooooooooo00Gooooo00Co0?ZJoooo
oooooooo0?ZJ;Oooool00ol0nY[oooooo`3jVP03ooooo`;o0?ZJ0_ooool00ol0nY[oooooo`3jVP03
ooooo`?o0?ZJ00?oooooo`000?l000000_l0nYX00ol0003oooooo`3jVP0Eooooo`08o`3jV_oooooo
0?ZJooooool0nY[o0000ooooool0nYX3ooooo`?o0?ZJ00Wo0000oooooooooooo0000o`3jV_oooooo
0000ooooool0nYX03oooool01Ol0nY[ooooooooooooooooo003o00?ooooo00?o0?ZJooooooooool0
1oooool01_l0nY[oooooo`000?oooooo003oo`3jVP;ooooo0_l0nYYNooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`02o`00013ooooo00Co0000oooo
oooooooooooo1Ol000001?oooooo0000o`000?l00002ooooo`04o`000?ooooooooooooooo`;o0000
2Oooool2o`000003ooooool0003ooooo0;Gooooo00?o0000ooooooooool0;Oooool003Oooooo0ol0
0003ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo00Cooooo00Go
0?ZJooooooooooooooooo`3jVP0/ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJooooool0
nYX00_ooool00ol0nY[oooooo`3jVP02ooooo`05o`3jV_oooooo0?ZJo`3jV_ooool00_l00002o`3j
VP03ooooool0003o0?ZJ01Cooooo00Co0?ZJoooooooooooooooo0_l0nYX00ol0003oooooo`3jVP03
ooooo`?o0?ZJ00Wo0000oooooooooooo0000o`3jV_oooooo0000ooooool0nYX03oooool01?l0nY[o
ooooooooool00?l2o`3jVP;ooooo00?o0?ZJooooooooool01oooool02_l0003o0?ZJoooooooooooo
003oo`3jV_oooooo0?ZJooooool0nYYNooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`02o`00013ooooo00?o0000ooooooooool00_ooool01?l0003o
ooooo`000?ooool3o`000004ooooool0003oooooo`0000Cooooo00?o0000ooooooooool01oooool0
1_l0003oooooooooool0003oooooo`000;Cooooo00?o0000ooooooooool0;Oooool003Sooooo00?o
0000ooooooooool01_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
1?ooool01Ol0nY[oooooo`000?oooooo0?ZJ02cooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0
nY[oooooo`3jVP02ooooo`03o`3jV_oooooo0?ZJ00;ooooo00Go0?ZJooooool0nY[o0?ZJooooo`02
o`0000;o0?ZJ00?oooooo`000?l0nYX01?ooool00ol0nY[oooooooooo`0=ooooo`04o`3jV_oooooo
ooooooooo`;o0?ZJ00?o0000ooooool0nYX00_ooool01Ol0nY[oooooooooool0nY[o000000;ooooo
00So0000o`3jV_oooooo0000ooooool0nY[oooooo`0000Wooooo00Go0000ooooooooooooooooo`3j
VP02ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o0?ZJooooooooool02?ooool02Ol0nY[ooooooooo
ool00?oo0?ZJooooool0nY[oooooo`3jVP1Nooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool06Oooool2o`000004ooooool0003oooooo`0000oooooo00?o0000ooooooooool01?ooool0
0ol0003oooooo`000002o`000004ooooool0003oooooo`0000Cooooo00?o0000ooooooooool01_oo
ool01ol0003ooooooooooooooooo0000ooooool000002?ooool00ol0003oooooooooo`2Yooooo`03
o`000?oooooooooo02gooooo000eooooo`Go00001oooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool01?ooool01Ol0nY[oooooo`000?oooooo0?ZJ02cooooo00Ko0?ZJoooo
oooooooo0?ZJooooool0nYX2ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooool0nYX00_oo
ool01_l0nY[oooooo`000?oooooo0000o`3jVP;ooooo00?o0000o`3jV_ooool00_ooool2o`3jVPCo
oooo00?o0?ZJooooooooool02?ooool01?l0nY[oooooooooooooool2o`3jVP06ooooool0003ooooo
o`3jV_oooooo0?ZJ0_ooool03?l0nY[o0000oooooooooooo0000o`3jV_oooooo0000ooooool0nY[o
ooooo`0000Wooooo00Go0000oooooooooooo0000o`3jVP02ooooo`06o`00ool0nY[oooooo`3jV_oo
oooo0?ZJ2_ooool01?l0nY[oooooooooool00?l2o`3jVP;ooooo00?o0?ZJooooooooool0G?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Wooooo1?l000000ooooooo0000ooooo`0>
ooooo`03o`000?oooooooooo00Kooooo0ol000001?oooooo0000ooooool00004ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0LOoo
ool5o`00oc?ooooo00?o0000ooooooooool0;Oooool003Gooooo00Co0000oooooooooooo00002?oo
ool4o`0000Gooooo0ol00004ooooo`05o`3jV_oooooo0000o`000?l0nYX0;?ooool01?l0nY[ooooo
ooooool00002o`3jVP;ooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooo`3jVP02ooooo`03
o`3jV_oooooo000000;ooooo00Ko0?ZJoooooooooooo0000ooooool0nYX2ooooo`;o0?ZJ0oooool2
o`3jVPWooooo00?o0?ZJooooooooool00_ooool01Ol0nY[oooooooooool0003ooooo00;o0?ZJ0ooo
ool5o`00o`07o`3jV_l0003o0000ooooool0nY[oooooo`000009ooooo`05o`000?ooooooooooo`00
0?l0nYX00_ooool01_l00?oo0?ZJooooool0nY[oooooo`3jVP[ooooo00Co0?ZJoooooooooooo003o
0_l0nYX2ooooo`03o`3jV_oooooooooo05[ooooo0ol0000Jooooo`;o00006Oooool01?l0003ooooo
o`000?l00002ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01_ooool3o`000004
ooooool0003oooooo`0000Cooooo0ol00006ooooo`03o`000?oooooooooo00;ooooo0_l00004oooo
o`03o`000?oooooooooo00;o0000Foooool:o`00o`kooooo00Go003oooooooooooooooooo`00o`0b
ooooo`;o0000;oooool003Kooooo00?o0000ooooool000002?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Cooooo00Go0?ZJooooool0003o0000o`3jVP0Zooooo`03o`000?oooooo
0?ZJ00;ooooo00?o0000o`3jV_ooool00oooool01ol0nY[ooooooooooooooooo0?ZJooooool0nYX0
0_ooool:o`00o`05o`3jV_oooooo0?ZJooooool0nYX00_ooool00ol0nY[oooooo`3jVP09ooooo`03
o`3jV_oooooooooo00;ooooo00Go0?ZJoooooooooooo0000ooooo`02o`3jVP?ooooo00Go003oo`00
0?oooooo0000ooooo`05o`00o`03ooooool0003ooooo00Sooooo00Co0000oooooooooooo0?ZJ0ooo
ool01?l00?oo0?ZJooooooooool2o`3jVP[ooooo00Ko0000o`3jV_oooooo0000o`00ool0nYX2oooo
o`03o`3jV_oooooooooo05cooooo00?o0000ooooooooool01Oooool2o`0000Cooooo00Co0000oooo
oooooooooooo1Ol00004ooooo`03o`000?oooooooooo01Sooooo00Co0000ooooool0003o00000_oo
ool2o`0000kooooo00?o0000ooooooooool01_ooool01ol0003oooooo`000?oooooo0000ooooool0
00001_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00Ko0000oooooooo
oooo0000ooooool00002ooooo`;o00001?ooool00ol0003oooooooooo`1:ooooo`Ko003o1?ooool0
0ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00?ooooo1Ol00?l4ooooo`05o`00oooooooo
ooooooooool00?l01Oooool5o`00o`Wooooo1_l00?lJooooo`03o`000?oooooooooo02gooooo000g
ooooo`;o00002Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo1?l00?l0
0ol0nY[oooooooooo`0Xooooo`03o`000?l0nY[o000000;ooooo00?o0000o`3jV_ooool00oooool0
1?l0nY[oooooooooooooool2o`3jVP?ooooo00Ko003oooooool0003oooooo`00ool0nYX3ooooo`03
o`00ool0nY[o0?ZJ00;ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX9ooooo`[o003o0_l0nYX3
ooooo`06o`00ool0003oooooo`000?oooooo0?ZJ0_l000001?oooooo003oooooool00009ooooo`;o
000000?oooooo`3jV_ooool00_ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00Wo
oooo00Go0?ZJooooool0003o003oo`3jVP02ooooo`03o`3jV_oooooooooo05cooooo00?o0000oooo
ooooool01?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool05oooool?o`00o`Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`02o`0000Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`06o`000?oo
ooooooooo`000?oooooo00000_ooool2o`0000Cooooo00Go0000ooooooooooooooooo`000018oooo
o`03o`00oooooooooooo00;ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`06oooo
o`03o`00oooooooooooo00?ooooo00Co003ooooooooooooooooo1_l00?l4ooooo`03o`00oooooooo
oooo00;ooooo00Go003oooooooooooooooooo`00o`09ooooo`03o`00oooooooooooo00;ooooo00?o
003oooooooooool06?ooool00ol0003oooooooooo`0]ooooo`00>?ooool00ol0003oooooooooo`08
ooooo`;o00001Oooool00ol0003oooooooooo`04ooooo`05o`3jV_l0003oooooo`000?l00?l01?oo
ool00ol0nY[oooooooooo`0Sooooo`03o`000?l0nY[o000000;ooooo00?o0000o`3jV_ooool00ooo
ool01?l0nY[oooooooooooooool2o`3jVP?ooooo00?o003oooooool000000_ooool01Ol0nY[ooooo
oooooooooooo003o00;o0?ZJ0_ooool01_l0nY[oooooooooool0nY[oooooo`3jVPWooooo00?o003o
ooooool000000_ooool01Ol0nY[oooooooooool0003o003o00;o0?ZJ0oooool01_l00?oo0000oooo
ool0003oooooo`3jVP;o000000Coooooo`00ool0003o00001_ooool01_l0nY[oooooo`000?oooooo
0000ooooo`Go003o00?o0?ZJooooooooool03Oooool01Ol0nY[oooooo`000?l00?oo0?ZJ00;ooooo
00?o0?ZJooooooooool0G?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Wo
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`oo003o0_l000000ooooooo
0000ooooo`03ooooo`03o`000?oooooooooo00?ooooo2_l00?l:ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`06o`000?oooooo0000
o`000?oooooo00000_ooool2o`0000Cooooo00Go0000ooooooooooooooooo`000018ooooo`03o`00
oooooooooooo00;ooooo00Go003oooooooooooooooooo`00o`0:ooooo`05o`00oooooooooooooooo
ool00?l03_ooool5o`00o`Gooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`02oooo
o`03o`00oooooooooooo01Sooooo00?o0000ooooooooool0;Oooool004[ooooo0_l00005ooooo`05
o`3jV_l0003oooooooooool00?l00oooool2o`3jVRGooooo00?o0000o`00ool00?l00_l00?l01ol0
003o0?ZJoooooooooooo0000ooooool0nYX00oooool2o`3jVP?ooooo00?o003oo`3jV_l000000_oo
ool2o`3jVP;ooooo00?o003oo`3jV_l0nYX00_ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oo
oooooooo00Gooooo00?o0000ooooool00?l00ol000000ooooooo0?ZJooooo`02ooooo`0<o`00ool0
nY[o0?ZJooooool0003o003oo`3jV_l0003oooooo`000?oooooo0?ZJ0_l000001_oooooo003oo`00
0?l0003oooooo`3jVPCooooo00Oo0?ZJooooool0003oooooo`000?oooooo003o00?ooooo00?o0?ZJ
ooooooooool03oooool00ol0nY[oooooo`00o`03ooooo`03o`3jV_oooooooooo05Cooooo00?o0?ZJ
ooooooooool01?ooool2o`0000Kooooo00Co0000oooooooooooo00002_ooool00ol0003ooooooooo
o`03ooooo`?o00000oooool6o`00o`kooooo00?o0000ooooooooool01Oooool01Ol0003ooooooooo
oooooooo000000Wooooo00?o0000ooooool00?l01?l00?l5ooooo`ko003o0oooool00ol0003ooooo
ooooo`04oooooa?o003o00?o0000ooooooooool05Oooool?o`00oagooooo1Ol00?l4ooooo`Go003o
2_ooool5o`00oaSooooo2_l00?l4ooooo`Go003o5?ooool3o`0002oooooo001:ooooo`03o`000?oo
oooooooo00Cooooo00Go0?ZJo`000?ooooooooooo`00o`02ooooo`03o`3jV_oooooo0?ZJ02Gooooo
00?o0000o`00ooooool00_l000001ol00?oo0?ZJoooooooooooo0000ooooool0nYX00oooool00ol0
nY[o0000o`000002ooooo`03o`00ool0nY[o000000;ooooo0_l0nYX2ooooo`03o`00ool0nY[o0?ZJ
00?ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00Gooooo00Co0000ooooool00?oo0?ZJ0_l00000
0ooooooo0?ZJo`3jVP02ooooo`03o`000?l00?oooooo00;o000000?o003oo`3jV_ooool00_l00000
1_oooooo0?ZJoooooooooooo0000o`00o`;o000000?oooooo`3jV_ooool00_ooool2o`3jVP06oooo
ool0003oooooo`000?oooooo003o0oooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_l00?oooooo
00;ooooo00?o0?ZJooooooooool0Doooool2o`3jVPOooooo00?o0000ooooooooool01?ooool01?l0
003oooooooooool00007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooo0000017ooooo00?o0000ooooooooool01_ooool01?l0003ooooooooo
ool00009ooooo`03o`000?oooooooooo00Cooooo1Ol00?l;ooooo`?o00002_l00?l01?l0003ooooo
o`000?ooool2o`000004ooooool0003oooooooooo`;o000000?oooooo`000?l000000oooool00ol0
003o003oo`00o`0Go`00o`kooooo1Ol00?lCooooo`Go003oB?ooool:o`00o`Gooooo00?o003ooooo
ooooool01?ooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`04ooooo`05
o`3jV_ooooooooooooooool00?l00_ooool00ol0nY[oooooo`3jVP0Uooooo`03o`000?l00?oooooo
00;o000000Coooooo`00ool00?oooooo0_l00005o`00o`;o00000_ooool00ol00?oo0?ZJo`000002
ooooo`;o0?ZJ0_ooool00ol0003o003oo`3jVP03ooooo`05o`3jV_ooooooooooooooool0nYX01ooo
ool01?l0003oooooo`00ool0nYX2o`000003ooooool0nY[o0?ZJ00?ooooo00So003oooooool0003o
0000o`00ool0nY[oooooo`0000;ooooo00Wo0?ZJoooooooooooo0000o`00ool0003oooooo`000?l0
nYX00oooool2o`3jVP07ooooool0003oooooo`000?l0nY[o003oo`3jVP02ooooo`03o`3jV_oooooo
oooo013ooooo00?o0?ZJo`00ool00?l00ol00?l4ooooo`03o`3jV_oooooooooo04kooooo0_l0nYX7
ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool01Ol0003ooooooooo
oooooooo000000Cooooo00?o0000ooooooooool01?ooool2o`0000;ooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000oooooooo
ool05?ooool4o`0000;ooooo00?o0000ooooooooool01?ooool01?l0003oooooo`000?ooool4o`00
00;ooooo0_l000000ooooooo0000o`000003ooooo`;o00001oooool2o`0002;ooooo1Ol00?l9oooo
o`Go003oEoooool5o`00o`Oooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000oooooooo
ool01?ooool01Ol0nY[ooooooooooooooooo003o00;ooooo00?o0?ZJooooool0nYX09Oooool02?l0
nY[o003oo`3jV_oooooo0000ooooool0nY[ooooo0ol00?l01?l0nY[o0000o`000?l00006o`00o`04
o`3jV_l0003oooooooooo`;o0?ZJ0_ooool00ol0003o003oo`000003ooooo`05o`3jV_oooooooooo
ooooool0nYX01oooool2o`000005o`00ool0nY[o0000ooooool000000_l0nYX3ooooo`Go003o0_l0
nYX01?l0003oooooo`3jV_l0nYX2ooooo`04o`000?l00?oo0000ooooo`;o0?ZJ0_ooool02_l0nY[o
ooooo`3jV_oooooo0000ooooool0003o0?ZJo`00ool0nYX2ooooo`03o`3jV_oooooooooo013ooooo
0_l0nYX3ooooo`04o`00ool0nY[oooooooooo`;o0?ZJCoooool00ol0nY[oooooo`3jVP07ooooo`03
o`000?oooooooooo00Gooooo0_l00009ooooo`?o00001Oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooo000000kooooo00?o0000ooooooooool01_ooool01?l0003oooooo`000?l00009oooo
o`03o`000?oooooooooo01Cooooo00Ko0000ooooool0003o0000ooooool00007ooooo`06o`000?oo
oooo0000ooooool0003ooooo0_l00002ooooo`;o000000?oooooo`000?l000000oooool2o`0000Oo
oooo0ol0000Uooooo`03o`00oooooooooooo00;ooooo1Ol00?mXooooo`03o`000?oooooooooo02go
oooo001:ooooo`03o`000?oooooooooo00Cooooo00Oo0?ZJooooooooooooooooo`00oooooooo0?ZJ
00;ooooo00?o0?ZJooooooooool08oooool01ol0nY[o003oo`3jV_oooooo0000ooooool0nYX00_oo
ool01?l0003oooooo`3jV_ooool2o`00000<o`3jV_ooooooooooo`000?oooooo0?ZJooooool0nY[o
ooooo`3jV_oooooo0?ZJ0_ooool00ol0003o003oo`000003ooooo`05o`3jV_ooooooooooooooool0
nYX01_ooool02?l0003oooooo`000?l00?oo0?ZJo`000?oooooo00000_l0nYX3ooooo`03o`3jV_oo
oooooooo00;o000000ko0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJooooool0003o003oo`000?l0
nY[o0000o`3jVP;ooooo00[o0?ZJo`000?l0nY[oooooo`000?oooooo0?ZJo`000?l00?oo0?ZJ0_oo
ool00ol0nY[oooooooooo`0Aooooo`06o`3jV_ooooooooooooooool00?oo0?ZJ0_ooool2o`3jVToo
oooo00?o0?ZJooooool0nYX01oooool00ol0003oooooooooo`0Hooooo`;o00001oooool00ol0003o
ooooo`00000>ooooo`03o`000?oooooooooo00Kooooo00Co0000ooooool0003o00001Oooool01Ol0
003ooooooooooooooooo000001Kooooo00Ko0000ooooool0003o0000ooooool00008ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_l000000ooooooo0000o`000003ooooo`03o`00
0?oooooo000000Cooooo00?o0000ooooool000000_l0000Uooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool0JOooool2o`0002oooooo001:ooooo`;o00001_ooool01_l0nY[ooooooooo
ool00?ooooooo`3jVP;ooooo00?o0?ZJooooooooool08_ooool01?l0003o0?ZJo`00ool0nYX3oooo
o`0:o`3jV_ooooooooooo`000?oooooo0?ZJooooool0003oooooo`3jVP;ooooo00Wo0000ooooool0
nY[oooooo`3jV_oooooo0?ZJooooool0nYX00_ooool00ol0003o003oo`00o`03ooooo`05o`3jV_oo
ooooooooooooool0nYX01?ooool03?l0nY[oooooo`000?oooooo0?ZJo`00oooooooo0?ZJooooool0
nY[oooooo`3jVP?ooooo00?o0?ZJooooooooool00_l000001ol0nY[oooooo`3jV_oooooo0?ZJoooo
ool0nYX00_ooool01Ol00?oo0000o`3jV_l0003o0?ZJ00;ooooo00[o0?ZJo`000?l0nY[oooooo`00
0?oooooo0?ZJo`000?l00?oo0?ZJ0_ooool00ol0nY[oooooooooo`0Aooooo`06o`000?l0nY[ooooo
ooooool00?oo0?ZJ0_ooool2o`3jVTOooooo00?o0?ZJooooooooool00_ooool00ol0003oooooo`3j
VP02ooooo`03o`3jV_oooooooooo00Cooooo0_l0000Jooooo`03o`000?oooooooooo00Kooooo0_l0
00000ooooooo0000ooooo`0<ooooo`03o`000?oooooooooo00Oooooo0ol00005ooooo`05o`000?oo
ooooooooooooool000006Oooool00ol0003oooooo`000008ooooo`03o`000?oooooooooo00Oooooo
00Co0000ooooool0003o00000oooool00ol0003oooooo`000004ooooo`05o`000?oooooo0000oooo
ool000009Oooool5o`00ofgooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000oooooooo
ool01Oooool01Ol0nY[oooooooooool00?oo0?ZJ00?ooooo00?o0?ZJooooooooool08_ooool01?l0
003o0?ZJo`00ool0nYX3ooooo`06o`3jV_ooooooooooo`000?oooooo0?ZJ0oooool2o`3jVP;ooooo
00Ko0000o`3jV_oooooo0?ZJooooool0nYX2ooooo`05o`3jV_oooooo0000o`3jV_l000000ol00?l0
1Ol0nY[ooooooooooooooooo0?ZJ00?ooooo0_l0nYX02Ooooooo0000o`3jV_oooooo003oooooool0
nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool01_l0nY[oooooooooool0nY[o
ooooo`3jVP;ooooo00Oo0?ZJooooool00?ooooooo`3jV_l0003ooooo00;o0?ZJ0_l000002?l0nY[o
ooooo`000?oooooo0?ZJooooool00?oo0?ZJ0_ooool00ol0nY[oooooooooo`0Aooooo`0:o`000?l0
nY[oooooooooool00?oo0?ZJooooool0nY[oooooo`3jVTOooooo00?o0?ZJooooooooool00_ooool0
0ol0003oooooo`3jVP02ooooo`03o`3jV_oooooooooo00Gooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`06ooooo`;o000000?oooooo`000?ooool03?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooo000000Gooooo00Go0000ooooool0003oooooo`00000Jooooo`;o00002?oo
ool00ol0003oooooooooo`07ooooo`;o000000Goooooo`000?ooooooooooo`000002ooooo`03o`00
0?oooooooooo00;ooooo0ol000000ooooooo0000o`00002Fooooo`03o`000?oooooooooo02gooooo
001:ooooo`03o`000?oooooooooo00Kooooo00Co0?ZJooooool00?oo0?ZJ0_ooool00ol0003o0?ZJ
ooooo`0Sooooo`04o`3jV_oooooo003oo`3jVP?ooooo00?o0?ZJooooool000000_ooool01?l0nY[o
ooooooooooooool2o`3jVP?ooooo00?o0?ZJooooooooool00_l0nYX3ooooo`03o`3jV_oooooo0?ZJ
00;o000000?oooooo`000?l00?l01?l00?l01ol0nY[oooooo`3jV_oooooo0?ZJooooool0nYX00_oo
ool01Ol00?ooooooo`3jV_oooooo0?ZJ00;ooooo00Go0?ZJooooool0nY[oooooo`3jVP02ooooo`04
o`3jV_ooooooooooo`0000;o0?ZJ0_ooool01Ol0nY[oooooo`00ool0nY[ooooo00;o00000_l0nYX2
o`000004o`3jV_oooooo0000o`3jVP;ooooo00Go003oo`3jV_ooooooooooo`3jVP0Cooooo`05o`00
0?l0nY[oooooooooool00?l00_l0nYX2ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooooooo
ool0>_ooool2o`3jVPCooooo00?o0000ooooool0nYX00_ooool00ol0nY[oooooooooo`05ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool01_ooool2o`000003ooooool0003ooooo00co
oooo00?o0000ooooooooool02Oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo0000
o`0001_ooooo00?o0000ooooooooool04_ooool01?l0003oooooo`000?ooool2o`0000;ooooo00?o
0000ooooooooool00_ooool3o`000003ooooool0003o000009Kooooo00?o0000ooooooooool0;Ooo
ool004[ooooo00?o0000ooooooooool01_ooool01?l0nY[oooooo`00ool0nYX2ooooo`03o`000?l0
nY[ooooo00;ooooo00?o0?ZJooooooooool07Oooool01Ol0nY[o0000ooooool00?oo0?ZJ00;ooooo
0_l0nYX01Ooooooo0000oooooooooooo0?ZJ00?ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00;o
0?ZJ1?ooool01ol0nY[oooooo`3jV_l0003oooooo`000?l0nYX00oooool02?l00?oo0?ZJooooool0
nY[o0000o`3jV_oooooo0?ZJ0_ooool00ol00?ooooooooooo`02o`3jVP?ooooo0_l0nYX01Ooooooo
0?ZJoooooooooooo0?ZJ00Cooooo00So0?ZJooooooooooooooooo`3jV_l00?oo0?ZJooooo`;o0000
0_l0nYX3o`0000;o0?ZJ0_ooool01_l00?oo0?ZJooooool0nY[oooooo`3jVQ?ooooo00Go0000o`3j
V_ooooooooooo`00o`02o`3jVP;ooooo00?o0?ZJooooooooool01_ooool2o`3jVROooooo00?o0000
ooooooooool04Oooool00ol0nY[oooooo`3jVP04ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool01Oooool00ol0003oooooooooo`0Hooooo`;o00001oooool2o`000003ooooool0003o
oooo00cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02o`000003ooooool0003o
000000;o00006oooool00ol0003oooooooooo`0Eooooo`;o00000oooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000ooooool0003o0000UOooool2o`0002oooooo001:ooooo`03o`000?oo
oooooooo00Kooooo00?o0?ZJooooool00?l00_ooool2o`000005o`3jV_ooooooooooooooool0nYX0
7_ooool04?l0nY[oooooo`000?l00?oo0?ZJooooool0nY[oooooo`3jV_l0003o0?ZJo`000?oooooo
0?ZJooooool0nYX2ooooo`;o0?ZJ0oooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo00Oo0?ZJ
ooooool0nY[o0000ooooool0003o0?ZJ00?ooooo00So003oo`3jV_oooooo0?ZJo`000?l0nY[ooooo
o`3jVP;ooooo00?o003oooooooooool00_l0nYX3ooooo`;o0?ZJ00Goooooo`3jV_ooooooooooo`3j
VP09ooooo`03o`00ool0nY[ooooo00;o000000Go0?ZJo`000?l0003oooooo`000002o`3jVP;ooooo
00Co003oo`3jV_oooooooooo0_l0nYXCooooo`03o`000?l0nY[ooooo00;ooooo00Go003oo`3jV_oo
ooooooooo`3jVP07ooooo`03o`3jV_oooooo0?ZJ02Oooooo00?o0000ooooooooool04Oooool00ol0
nY[oooooo`3jVP04ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool01Oooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00003Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?o000000Coooooo`000?l0003o0000<ooo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0002Fooooo`03o`000?oooooooooo02gooooo001:ooooo`;o00002?ooool01?l0nY[o003o
ooooooooool2o`000003o`3jV_oooooooooo00;o0?ZJ1?ooool00ol0nY[oooooooooo`0Gooooo`05
o`3jV_oooooo0000o`00ool0nYX00_ooool2o`3jVP05o`000?l0nY[o0000ooooool0nYX00_ooool0
1Ol0nY[oooooo`3jV_oooooo0?ZJ00;ooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`0;o`3j
V_oooooo0?ZJo`000?oooooo0000o`3jV_oooooo0000ooooool00?l00_l0nYX01Ooooooo0000o`3j
V_oooooo0?ZJ00;ooooo00Go003oooooooooooooooooo`3jVP04ooooo`03o`3jV_oooooo0?ZJ00;o
oooo00?o0?ZJooooooooool01oooool01_l00?oooooooooooooooooo0000o`3jVP;o000000Cooooo
o`000?l0nY[o0?ZJ0_ooool01?l00?oo0?ZJooooooooool2o`3jVQ?ooooo00Oo0000ooooool0nY[o
ooooo`000?l00?oo0?ZJ00;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooo`3jVP0Woooo
o`03o`000?oooooooooo017ooooo00?o0?ZJooooool0nYX00oooool3o`3jVP?ooooo00?o0?ZJoooo
ooooool01?ooool2o`0001[ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool0000=
ooooo`03o`000?oooooooooo00Wooooo00Co0000ooooool0003ooooo0_l000001?oooooo0000oooo
ool0000hooooo`05o`000?oooooo0000ooooool000001Oooool00ol0003oooooooooo`2Dooooo`03
o`000?oooooooooo02gooooo001:ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJo`00ool00?l0
0ol00?l01?oooooo0?ZJooooool0nYX4ooooo`03o`3jV_oooooooooo017ooooo00_o0?ZJoooooooo
ooooooooo`3jV_oooooo0?ZJooooool0003o003oo`3jVP02ooooo`;o0?ZJ0_ooool00ol0nY[ooooo
o`3jVP02ooooo`05o`3jV_oooooo0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`08ooooo`09
o`3jV_l0003oooooo`000?l0nY[oooooo`000?oooooo003o00;o0?ZJ0_l00002o`3jVP?ooooo00Go
003oooooooooooooooooo`3jVP06ooooo`04o`3jV_ooooooooooo`3jVPWooooo00?o003ooooooooo
ool00_ooool5o`00o`;o0?ZJ0_ooool01?l00?oo0?ZJooooooooool2o`3jVQ?ooooo00Oo0000oooo
ool0nY[oooooo`000?l00?oo0?ZJ00;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooo`3j
VP0Wooooo`;o000000?oooooo`000?ooool03oooool00ol0nY[oooooo`3jVP02ooooo`04o`000?l0
nY[o0000o`3jVP?ooooo00?o0?ZJooooooooool01Oooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`04o`00
0?oooooo0000ooooo`;o00000oooool00ol0003oooooooooo`0fooooo`;o000000?oooooo`000?l0
00001_ooool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo02gooooo001:ooooo`03o`00
0?oooooooooo00Sooooo00[o0?ZJo`000?oooooo0000ooooool00?ooooooo`3jV_oooooo0?ZJ0ooo
ool2o`3jVQ;ooooo0_l0nYX3ooooo`07o`3jV_oooooo0?ZJooooool0003o003oo`3jVP02ooooo`;o
0?ZJ0_ooool00ol0nY[oooooo`3jVP02ooooo`05o`3jV_oooooo0?ZJooooool0nYX00_ooool00ol0
nY[oooooooooo`08ooooo`06o`3jV_l0003oooooo`000?l0nY[ooooo0_l000001Ol00?oo0?ZJoooo
ool0003ooooo00;o0?ZJ0oooool00ol00?ooooooooooo`09ooooo`03o`3jV_oooooo0?ZJ00Wooooo
1?l00?l01_oooooo003oooooool0003oooooo`00o`;o0?ZJ0_ooool00ol00?oo0?ZJooooo`02oooo
o`03o`3jV_oooooooooo017ooooo00Ko0000oooooooooooo0?ZJo`000?l00?l3ooooo`03o`3jV_oo
oooooooo00Cooooo00Co0?ZJoooooooooooo0?ZJ9oooool2o`000003ooooool0003ooooo00?ooooo
00?o0?ZJooooooooool02?ooool01?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooo000000Go
003o1oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0;ooooo`;o0000?oooool2o`000003ooooool0003ooooo00Ko
oooo00?o0000ooooooooool0Toooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003ooooo
ooooo`08ooooo`0:o`3jV_l0003oooooo`000?oooooo003oooooool0nY[oooooo`3jVP;ooooo00?o
0?ZJooooool0nYX04Oooool00ol0nY[oooooo`3jVP02ooooo`;o0?ZJ00Koooooo`3jV_l0003ooooo
o`00ool0nYX3ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ0oooool2o`3jVP;ooooo00?o0?ZJ
ooooool0nYX02_ooool00ol0nY[o0000o`000002o`3jVP05ooooool0003o0000ooooool00?l00_l0
00000ooooooo0?ZJo`3jVP03ooooo`03o`00oooooooooooo00[ooooo0_l0nYX9ooooo`06o`3jV_oo
ooooooooooooool00?oo0?ZJ0oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo01Ko
oooo00Ko0000oooooooooooo0?ZJooooool00?l3ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJ
oooooooooooo0?ZJ3Oooool00ol0nY[oooooooooo`0Gooooo`?o000000Co0?ZJoooooooooooooooo
0_l0nYX:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00Co0000ooooool0003o003o0oooool00ol0
0?oo0?ZJooooo`05ooooo`03o`000?oooooooooo01Sooooo0_l0000;ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02oooool2o`0003oooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`2Booooo`;o0000;oooool004[ooooo00?o0000ooooooooool02Oooool01_l0
nY[oooooo`000?oooooo003oo`3jVP;ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX@ooooo`06
o`3jV_ooooooooooo`3jV_oooooo0?ZJ0_ooool01_l0nY[oooooo`000?oooooo003oo`3jVPOooooo
0_l0nYX4ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ2oooool01Ol0nY[o0000o`3jV_l0003o
0?ZJ00;o000000?oooooo`00ooooool00_ooool00ol0nY[o0000ooooo`02ooooo`03o`00oooooooo
oooo00[ooooo0_l0nYX9ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX3ooooo`05o`00oooooooo
ooooooooool00?l06Oooool01?l0003oooooo`000?l0nYX5o`00o`Gooooo00Go0?ZJoooooooooooo
ooooo`3jVP0<ooooo`;o0?ZJ6Oooool2o`0000;o0?ZJ0oooool2o`3jVP[ooooo00Co0?ZJoooooooo
oooo00000_l0nYX01Ol0003oooooo`000?l00?oo000000;ooooo00?o003oo`3jV_ooool01Oooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0000:ooooo`03o`000?oooooo
oooo00_ooooo0_l00012ooooo`03o`000?oooooooooo00Gooooo0_l0002Dooooo`03o`000?oooooo
oooo02gooooo001:ooooo`;o00002_ooool01_l0nY[o0000oooooooooooo003oo`3jVP?ooooo0_l0
nYX2ooooo`03o`3jV_oooooooooo00kooooo00go0?ZJoooooooooooo0?ZJooooool0nY[oooooo`00
0?l0nY[oooooo`000?oooooo003o00Wooooo00?o0?ZJooooooooool01_ooool2o`3jVP_ooooo00?o
0?ZJo`000?l0nYX00_l000001?l0nY[o0000ooooool00?l3ooooo`03o`3jV_l0003ooooo00;ooooo
00?o003oooooooooool02oooool00ol0nY[oooooooooo`08ooooo`04o`3jV_ooooooooooooooo`;o
0?ZJ0oooool5o`00oaWooooo00Ko0000ooooool0003oooooo`3jV_l00002ooooo`03o`00oooooooo
oooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP0<ooooo`;o0?ZJ6Oooool2o`0000;o0?ZJ0ooo
ool2o`3jVPWooooo00Go0?ZJooooooooooooooooo`000002o`3jVP05o`000?oooooo0000o`00ool0
nYX00_ooool00ol00?oo0?ZJooooo`04ooooo`;o00006_ooool00ol0003oooooooooo`0:ooooo`;o
00002_ooool00ol0003oooooooooo`0;ooooo`;o0000@_ooool00ol0003oooooooooo`05ooooo`;o
0000U?ooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`09ooooo`06o`3j
V_l0003oooooooooool00?oo0?ZJ0oooool2o`3jVP;ooooo00?o0?ZJooooooooool03_ooool01_l0
nY[oooooooooool0nY[oooooo`3jVP;o00000ol00?l00ooooooo003oooooo`0Booooo`03o`3jV_oo
oooooooo00[ooooo0_l0nYX2o`000004o`3jV_oooooo0000o`00o`?ooooo1_l00?lHooooo`04o`3j
V_ooooooooooooooo`;o0?ZJ0oooool01Ol0nY[ooooooooooooooooo0?ZJ01Wooooo00Ko0000oooo
ool0003oooooo`3jV_l00002ooooo`03o`00oooooooooooo00?ooooo00Go0?ZJoooooooooooooooo
o`3jVP0;ooooo`03o`3jV_oooooo0?ZJ01Wooooo0_l00002o`3jVP;ooooo00?o0?ZJooooool0nYX0
2Oooool00ol0nY[oooooooooo`02o`0000;o0?ZJ0_l000000ooooooo003oo`3jVP02ooooo`03o`00
ool0nY[ooooo00Gooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00Kooooo0_l0000>ooooo`03o`000?oooooooooo04Wooooo0_l0002Dooooo`03o`00
0?oooooooooo02gooooo000aooooo`?o00000oooool00ol0003oooooooooo`02ooooo`?o00000ooo
ool3o`0000Gooooo00?o0000ooooooooool02_ooool01?l0nY[oooooooooool00?l2ooooo`04o`00
0?oooooo0?ZJo`3jVP;ooooo00?o0?ZJooooooooool03_ooool01_l0nY[oooooooooool0nY[ooooo
o`3jVP;o000000?o003oo`000?ooool00_l00?lPooooo`;o0?ZJ0_l000000ol0nY[oooooo`000005
o`00o`Cooooo00?o0?ZJooooooooool05_ooool01?l0nY[oooooooooooooool2o`3jVP?ooooo00Go
0?ZJooooooooooooooooo`3jVP0Iooooo`03o`000?oooooo000000;ooooo00Co0?ZJoooooooooooo
003o1?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Sooooo00Co0?ZJoooooooo
oooo0?ZJ6Oooool01_l0003o0?ZJo`000?l0nY[oooooo`3jVP;ooooo00?o0?ZJooooooooool01ooo
ool5o`00o`;o0?ZJ0_l000000ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo00Gooooo00?o
0000ooooooooool06?ooool2o`0000cooooo00?o0000ooooooooool01_ooool2o`0005[ooooo0_l0
002Cooooo`;o0000;oooool003;ooooo00?o0000ooooooooool01_ooool01ol0003ooooooooooooo
oooo0000ooooool000000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00[ooooo
00Co0?ZJoooooooooooo003o0_ooool01?l0003oooooo`3jV_l0nYX2ooooo`03o`3jV_oooooooooo
00gooooo00Co0?ZJoooooooooooo00000_l0nYX3o`000005o`00ool0003oooooooooool0nYX08?oo
ool00ol0003o0?ZJooooo`02ooooo`03o`3jV_l0003o0?ZJ00?ooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`0Fooooo`07o`3jV_ooooooooooooooool0nY[oooooo`3jVP02ooooo`;o
0?ZJ0_ooool00ol0nY[oooooooooo`0Gooooo`03o`000?oooooo000000;ooooo00Co0?ZJoooooooo
oooo003o1?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Sooooo00Co0?ZJoooo
oooooooo0?ZJ6Oooool01_l0nY[o0000o`000?l0nY[o0000o`3jVP;ooooo00?o0?ZJooooooooool0
1oooool01ol00?ooooooooooool0003o003oo`3jV_ooool00_l000000ol00?oo0?ZJo`3jVP02oooo
o`03o`00ool0nY[ooooo00Gooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00Kooooo0_l0001Jooooo`03o`000?oooooo000009?ooooo00?o0000oooo
ooooool0;Oooool002oooooo1Ol00007ooooo`05o`000?ooooooooooooooool000001Oooool00ol0
003oooooooooo`02ooooo`?o00002_ooool00ol0003o0?ZJooooo`04o`00o`03ooooool0nY[o0?ZJ
00;ooooo00?o0?ZJooooooooool03Oooool01?l0nY[oooooooooool00002o`3jVP;o000000?ooooo
o`00ool0nYX00_ooool00ol0nY[oooooooooo`0Nooooo`03o`000?oooooooooo00?ooooo0_l0nYX3
ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool00_l0nYX2ooooo`03o`3jV_oooooooooo01Oooooo00?o0000ooooool000000_ooool0
1?l0nY[oooooooooool00?l4ooooo`Go003o00?o0?ZJooooooooool02?ooool01?l0nY[ooooooooo
ool0nYXIooooo`05o`3jV_l0003o0000ooooool0nYX00oooool00ol0nY[oooooooooo`07ooooo`03
o`00oooooooooooo00;o000000Go003ooooooooooooo0000o`00o`02o`3jVP;ooooo00?o0000o`00
ooooool00oooool3o`000003ooooool0003o000000Cooooo00Co0000oooooooooooooooo1Ol00002
ooooo`?o00001Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooool00000F_ooool00ol0003oooooo`00002Cooooo`03o`000?oooooooooo02gooooo000_oooo
o`04o`000?ooooooooooo`0000Sooooo1?l00006ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool02oooool00ol0nY[oooooo`3jVP02ooooo`07o`000?l00?oo0?ZJooooool0003ooooo
o`3jVP0?ooooo`04o`3jV_ooooooooooo`0000;o0?ZJ00?o0000ooooool00?l00_l0nYX2ooooo`03
o`3jV_oooooooooo02Gooooo00Co0?ZJoooooooooooooooo0_l0nYX3ooooo`03o`3jV_oooooooooo
01Oooooo00?o0?ZJooooool0nYX00_ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool05oooool00ol0003oooooo`000002ooooo`04o`3jV_ooooooooooo`00o`Cooooo00?o
003oooooooooool00_ooool00ol00?ooooooooooo`08ooooo`04o`3jV_ooooooooooo`3jVQWooooo
00Go0?ZJo`000?l0003oooooo`3jVP03ooooo`03o`3jV_oooooooooo00Oooooo00Go003oo`3jV_oo
oooo0000ooooo`03o`00o`04o`000?l00?oo0?ZJo`3jVP;ooooo00?o0000o`00ooooool01Oooool2
o`0000;ooooo00?o0000ooooooooool01_ooool01_l0003oooooooooool0003oooooo`0000?ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooool00000G?ooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo02gooooo
000`ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool00oooool4o`0000Gooooo00?o
0000ooooooooool02oooool00ol0nY[oooooo`3jVP02ooooo`04o`000?oooooo003oo`00o`;o0000
00?o0?ZJooooooooool03?ooool01_l0nY[ooooooooooooooooo0000o`3jVP;o000000Coooooo`00
ool0nY[o0?ZJ0_ooool00ol0nY[oooooooooo`0Uooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0ooo
ool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooo0?ZJ00?ooooo0_l0nYX01Ooooooo0?ZJoooo
oooooooo0?ZJ01Wooooo00?o0000ooooool000000_ooool01?l0nY[oooooooooool00?l4ooooo`03
o`00oooooooooooo00;ooooo00?o003oooooooooool02?ooool01?l0nY[oooooooooool0nYXIoooo
o`05o`3jV_oooooo0000ooooool0nYX00oooool00ol0nY[oooooooooo`05ooooo`08o`000?l0nY[o
003oo`3jV_oooooo0000ooooool0nYX2ooooo`;o003o00Ko0?ZJo`000?l0nY[oooooo`000?l00?l6
ooooo`;o00000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool00_ooool3o`0000cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1L
ooooo`03o`000?oooooooooo08oooooo0ol0000_ooooo`00<Oooool2o`0000Wooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00cooooo0ol0nYX2o`00
0003ooooool0nY[o003o00?o003o1?ooool00ol0nY[oooooooooo`07ooooo`05o`3jV_oooooooooo
ooooool000000_l00?l00ol0003oooooo`00o`02o`3jVP;ooooo00?o0?ZJooooooooool09Oooool0
1?l0nY[oooooooooooooool2o`3jVP?ooooo00?o0?ZJooooooooool06?ooool2o`3jVP?ooooo0_l0
nYX01Ooooooo0?ZJoooooooooooo0?ZJ01Wooooo00?o0000ooooool000000_ooool01?l0nY[ooooo
ooooool00?l4ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oooooooooool01oooool01Ol0nY[o
oooooooooooooooo0?ZJ01Wooooo00Go0?ZJooooool0003oooooo`3jVP03ooooo`03o`3jV_oooooo
oooo00Gooooo00So0?ZJooooool00?oo0?ZJooooool0003oooooo`3jVP;ooooo00So0000ooooool0
nY[o0000ooooool0nY[o0000o`00o`Kooooo0_l00002ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo097ooooo00?o
0000ooooooooool0;Oooool003;ooooo00?o0000ooooooooool02?ooool2o`0000;ooooo1Ol00004
ooooo`03o`000?oooooooooo00gooooo0_l0nYX2o`000007ooooool0nY[oooooooooool0003o003o
o`3jVP02ooooo`;o0?ZJ2Oooool6o`00o`04ooooool00?oo003oo`00o`;o0?ZJ0_ooool00ol0nY[o
ooooooooo`0Uooooo`07o`3jV_ooooooooooooooool0nY[oooooo`3jVP02ooooo`03o`3jV_oooooo
oooo01Sooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool05oooool0
0ol0003oooooo`000002ooooo`04o`000?l0nY[oooooo`00o`;ooooo00Co0000ooooool00?oo0?ZJ
0oooool00ol00?ooooooooooo`07ooooo`05o`3jV_ooooooooooooooool0nYX06?ooool01_l0nY[o
0000ooooool0003oooooo`3jVP?ooooo00?o0?ZJooooooooool01Oooool01ol0nY[o0000o`00ool0
nY[oooooo`000?ooool00_l0nYX02Ooooooo0000o`3jV_oooooo0000ooooool0nY[oooooo`00o`06
ooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`06o`000?ooooooooooooooool0003ooooo
1?l00005ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`1Mooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0;Oooool004[ooooo0_l0
000?ooooo`04o`3jV_l0003oooooo`0000;o0?ZJ0_ooool01?l00?oo0?ZJooooooooool2o`3jVPWo
oooo00Ko003ooooooooooooo0000ooooool0nYX4ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0V
ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ0_ooool00ol0nY[oooooooooo`0Iooooo`03o`3j
V_oooooooooo00;ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYXIooooo`03o`000?oooooo0000
00?ooooo00?o0000o`3jV_l00?l00_ooool01?l0003oooooo`00ool0nYX3ooooo`03o`00oooooooo
oooo00Oooooo0_l00?l2ooooo`03o`3jV_oooooooooo01Kooooo00Go0?ZJo`000?oooooo0000oooo
o`02o`00o`;ooooo00?o0?ZJooooooooool01Oooool01Ol0nY[o0000o`00ool0003o0?ZJ00;ooooo
0_l0nYX02Ooooooo0000o`3jV_oooooo0000ooooool0nY[oooooo`00o`05ooooo`?o00000_ooool0
0ol0003oooooooooo`05ooooo`07o`000?ooooooooooooooool0003oooooo`000008ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool00_ooool2o`0005oooooo00?o0000ooooooooool0
TOooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`0>ooooo`04o`3jV_l0
003oooooo`0000;o0?ZJ0_ooool01_l00?oo0?ZJooooool0nY[oooooo`3jVPWooooo00Go003oo`00
0?oooooo0000ooooo`02o`3jVP?ooooo00Go0?ZJooooool0nY[oooooo`3jVP0Yooooo`05o`3jV_oo
oooo0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Kooooo
0_l0nYXIooooo`03o`000?oooooo000000?ooooo00Go0000o`3jV_l00?oo0?ZJooooo`02o`000003
o`00ool0nY[ooooo00;ooooo00?o003oooooooooool01oooool00ol00?ooooooo`00o`02o`00oaSo
oooo1Ol00?l00ol0nY[oooooo`00o`02o`00o`Kooooo017o0?ZJo`000?oooooo003oo`000?l0nY[o
ooooo`3jV_oooooo0?ZJooooool0003o0?ZJooooool0003oooooo`000002o`3jVPKooooo00Co0000
ooooool0003o00002Oooool3o`0000;ooooo1Ol00004ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool00_ooool2o`0005oooooo00?o0000ooooooooool0TOooool00ol0003ooooooooo
o`0]ooooo`00B_ooool00ol0003oooooooooo`0>ooooo`04o`000?l0nY[oooooo`0000;o0?ZJ0_oo
ool01_l00?oo0?ZJooooool0nY[oooooo`3jVPWooooo00Go003oo`3jV_oooooo0000ooooo`02o`3j
VP;ooooo00Co0?ZJoooooooooooooooo0_l0nYXYooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooool0nYX09?ooool2o`3jVQWooooo00?o0000ooooool000000oooool01Ol0003o0?ZJo`00ool0
nY[ooooo00;o000000?o003oooooool0nYX00_ooool00ol00?ooooooooooo`07ooooo`05o`00oooo
ooooooooooooool00?l06?ooool01_l00?ooooooooooool0003oooooo`3jVP?ooooo00?o003ooooo
ooooool01?ooool02_l0nY[o0000ooooool00?ooooooo`3jV_oooooo0?ZJooooool0nYX2ooooo`07
o`3jV_oooooo0000ooooool0003oooooo`3jVP06ooooo`03o`000?oooooooooo01Sooooo0_l0000=
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`2?
ooooo`;o0000;oooool004[ooooo00?o0000ooooooooool03_ooool01_l0003o0?ZJooooool0nY[o
ooooo`3jVP;ooooo00?o003oo`3jV_l0nYX00_ooool01_l0nY[ooooooooooooooooo0000o`3jVPCo
oooo00Go003oo`3jV_oooooo0000ooooo`02o`3jVP;ooooo00Co0?ZJoooooooooooooooo0_l0nYXY
ooooo`03o`3jV_oooooo0?ZJ00?ooooo0_l0nYXUooooo`03o`3jV_oooooooooo01Oooooo00?o0000
ooooool000000oooool01Ol0003oooooo`00ool0nY[ooooo00;o000000?o003oooooool0nYX00_oo
ool00ol00?ooooooooooo`07ooooo`05o`00ool0nY[oooooooooool00?l06?ooool01_l00?oooooo
ooooool0003oooooo`3jVP?ooooo00?o003oooooooooool00oooool01ol0nY[o0000o`000?oooooo
003oooooool000000_l0nYX02ooooooo0?ZJoooooooooooo0?ZJooooool0003oooooo`000?oooooo
0?ZJ00Kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`06o`000?oooooo
ooooo`000?oooooo0000HOooool00ol0003oooooooooo`29ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0;Oooool004[ooooo00?o0000ooooooooool03oooool01Ol0nY[oooooo`3j
V_oooooo0?ZJ00;ooooo00?o003oo`3jV_l0nYX00_ooool01?l0nY[oooooooooooooool2o`3jVPCo
oooo00Go003oo`3jV_l0003o0000ooooo`02o`3jVP;ooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`0Xooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0mooooo`03o`000?oooooo0000
00?ooooo00go0000ooooool00?oo0?ZJooooool0003oooooo`00ool0003oooooo`3jV_oooooo003o
00Wooooo00Go003oo`3jV_ooooooooooo`00o`0@ooooo`03o`000?oooooooooo00Gooooo00?o003o
o`3jV_ooool00_ooool01Ol0nY[ooooooooooooooooo003o00Gooooo00_o0?ZJo`000?l0003ooooo
o`00oooooooo0000ooooool0nY[oooooo`3jVP02ooooo`07o`3jV_oooooo0000ooooool0003ooooo
o`3jVP06ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`02o`0006;ooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo02gooooo001:ooooo`;o00004?ooool01Ol0003o0?ZJo`3jV_oooooo0?ZJ00;ooooo
00?o0000o`00ool0nYX00_ooool01?l0nY[oooooooooooooool2o`3jVP?ooooo00?o0?ZJo`00ool0
nYX00_l000001_oooooo0?ZJooooool0nY[oooooo`3jVPCooooo00?o0?ZJooooooooool0:Oooool0
0ol0nY[oooooooooo`12ooooo`03o`000?oooooo000000?ooooo00go0000ooooool00?oo0?ZJoooo
ool0003oooooo`00ool0003oooooo`3jV_oooooo003o00Wooooo00Go003oo`3jV_ooooooooooo`00
o`0@ooooo`03o`000?oooooo0?ZJ00Gooooo00?o003oo`3jV_ooool00_ooool01Ol0nY[ooooooooo
oooooooo003o00Gooooo00Wo0?ZJo`000?l0003oooooo`00oooooooo0000ooooool0nYX00_ooool0
0ol0nY[oooooo`3jVP02ooooo`;o000000?oooooo`3jV_ooool01?ooool2o`0001[ooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`02o`0006;ooooo00?o0000ooooooooool0ROooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo02gooooo001:ooooo`03o`000?oooooooooo
013ooooo0_l0nYX2ooooo`05o`3jV_oooooo0000o`00ool0nYX00_ooool01_l0nY[oooooooooool0
nY[o0000o`3jVP;ooooo00co0?ZJo`000?l00?ooooooo`3jV_l0003oooooo`3jV_oooooo0?ZJoooo
ool0nYYfooooo`;o00000oooool03Ol0003oooooo`00ool0nY[oooooo`000?oooooo003oo`000?oo
oooo0?ZJooooool00?l02Oooool01Ol00?oo0?ZJoooooooooooo003o013ooooo00?o0000ooooool0
nYX01Oooool00ol00?oo0?ZJooooo`02ooooo`05o`3jV_ooooooooooooooool00?l01?ooool02?l0
nY[oooooo`000?l0003oooooo`00oooooooo00001?ooool00ol0nY[oooooo`3jVP02ooooo`;o0000
2?ooool00ol0003oooooooooo`0Hooooo`;o00003Oooool00ol0003oooooooooo`02o`0006;ooooo
00?o0000ooooool00000R?ooool2o`0000Gooooo0_l0000_ooooo`00B_ooool00ol0003ooooooooo
o`0Aooooo`08o`3jV_ooooooooooooooool0nY[o0000o`00ool0nYX3ooooo`05o`3jV_oooooo0?ZJ
o`000?l0nYX00_ooool03?l0nY[o0000o`00oooooooo0?ZJo`000?oooooo0?ZJooooool0nY[ooooo
o`3jVWKooooo00?o0000ooooooooool00_ooool02Ol0003oooooo`3jV_l00?ooooooo`000?oooooo
003oo`000002ooooo`03o`3jV_l00?oooooo00Sooooo00Go003oo`3jV_ooooooooooo`00o`0@oooo
o`03o`000?l0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool00_ooool2o`3jVP;ooooo00?o003ooooo
ooooool00_ooool00ol00?oo0000ooooo`02ooooo`03o`00oooooooooooo00Gooooo0_l0nYX2oooo
o`;o00002?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool00_l0001Rooooo`03o`000?oooooo000008Sooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`0Aooooo`08o`3jV_oooooooooooooo
ool0nY[o0000o`00ool00003ooooo`;o0?ZJ0_l000002?l0nY[o0000ooooool0nY[o0000o`00oooo
oooo0?ZJ0_ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ07Kooooo00?o0000ooooooooool00_ooool0
2Ol0003oooooo`3jV_l00?ooooooo`000?oooooo003oo`000003ooooo`03o`00oooooooooooo00Ko
oooo00?o0000o`00ool0nYX00_ooool00ol00?ooooooooooo`0>ooooo`03o`3jV_l0003o0?ZJ00Go
oooo00Oo003oo`3jV_ooooooooooo`3jV_l0003o0?ZJ00;ooooo00?o003oooooooooool00_ooool6
o`00o`Sooooo00Go0?ZJooooooooooooooooo`000008ooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool03?ooool00ol0003oooooo`00001Tooooo`04o`000?oooooo0000o`0008Oooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003ooooooooo
o`0Fooooo`03o`3jV_l00?oo000000?ooooo0_l0nYX2o`00000;o`3jV_l0003o0?ZJo`000?oooooo
003oooooool0003o0?ZJooooool0nYX00_ooool2o`3jVWKooooo00?o0000ooooooooool00oooool0
2?l0003o0?ZJo`00oooooooo0000ooooool00?oo00000oooool00ol00?ooooooooooo`06ooooo`06
o`000?l00?oo0000o`3jV_oooooo003o4?ooool00ol0nY[o0000o`3jVP04ooooo`03o`000?l00?oo
0?ZJ00;ooooo00Ko0?ZJo`000?oooooo0?ZJooooool00?l4ooooo`03o`00ool0003ooooo00;ooooo
00?o0?ZJooooooooool01_ooool01Ol0nY[ooooooooooooooooo000000Sooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo000006Cooooo00Co0000ooooool0
003o0000Qoooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02gooooo001:ooooo`;o
00005oooool00ol0nY[o003oo`00o`03o`00o`05o`3jV_l0003oooooo`000?ooool00_l0nYX2oooo
o`04o`00oooooooo0000ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`1dooooo`03o`000?oooooo
oooo00?ooooo00So0000o`3jV_l00?ooooooo`000?oooooo003oo`0000?ooooo00?o003ooooooooo
ool01_ooool01_l0003o003oo`000?l0nY[oooooo`00oa3ooooo00?o0?ZJo`000?l0nYX01?ooool0
2ol0003o003oooooool0nY[oooooo`3jV_l0003oooooo`3jV_oooooo003o00Cooooo00?o003oo`00
0?ooool00_ooool00ol0nY[oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo0_l0000Joooo
o`;o00003Oooool00ol0003oooooo`00001Tooooo`Co00003Oooool01?l0003oooooooooool0001f
ooooo`03o`000?oooooooooo00Cooooo0_l0000_ooooo`00B_ooool00ol0003oooooooooo`0Foooo
o`07o`000?l0nY[oooooo`000?oooooo003oo`3jVP02ooooo`03o`000?oooooo0?ZJ00?ooooo00?o
003oooooool000000_ooool01Ol0nY[ooooooooooooooooo0?ZJ07Kooooo00?o0000ooooooooool0
0oooool02?l0003o0?ZJo`00oooooooo0000o`3jV_l00?oo00000oooool00ol00?ooooooooooo`06
ooooo`06o`000?l00?oo0000ooooool0nY[o003o3oooool01?l0nY[oooooo`000?l0nYX4ooooo`04
o`000?l00?ooooooooooo`;o0?ZJ00Go0000oooooooooooo0?ZJo`00o`04ooooo`03o`00ool0nY[o
oooo00;ooooo00?o0?ZJooooooooool04oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool0I_ooool00ol0003oooooooooo`0;ooooo`04o`000?oooooo
ooooo`0007Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0]ooooo`00B_ooool0
0ol0003oooooooooo`0Fooooo`03o`000?l0nY[ooooo00;o000000?o003oo`3jV_ooool00_ooool0
0ol0003o0?ZJooooo`02ooooo`03o`00oooooooo000007gooooo00?o0000ooooooooool00oooool0
2?l0003o0?ZJo`00oooooooo0?ZJooooool00?oo00000oooool00ol00?ooooooooooo`06ooooo`07
o`000?l00?oo0000ooooool0nY[o003oo`3jVP0>ooooo`04o`3jV_oooooo0000o`3jVPCooooo00Co
0000o`00oooooooooooo0_l0nYX01Ol0003oooooooooool0nY[o003o00Cooooo00?o003oo`3jV_oo
ool00_ooool00ol0nY[oooooooooo`0Cooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool0M_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;o0000M?ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo02gooooo001:ooooo`03o`000?oooooooooo01Kooooo
0_l000001Ol0nY[o0000o`000?oooooo003o00?ooooo00?o0000o`3jV_ooool00_ooool00ol00?oo
ooooooooo`23ooooo`08o`000?oooooo003oooooool0nY[oooooo`00ool00003ooooo`03o`00oooo
oooooooo00Kooooo00?o0000o`00ool000000_ooool00ol00?oo0?ZJooooo`0=ooooo`04o`3jV_oo
oooo0000o`3jVPCooooo00Co0?ZJo`00oooooooooooo0_l0nYX01Ol0003ooooooooooooooooo003o
00Cooooo00?o003oo`3jV_ooool00_ooool00ol0nY[oooooooooo`0Cooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool0Moooool00ol0003oooooooooo`09ooooo`;o00000_ooool2o`00
07Cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0]ooooo`00B_ooool2o`0001Oo
oooo0_l000001?l0nY[o0000o`000?ooool2o`00o`;ooooo00?o0000o`3jV_ooool00_ooool00ol0
0?ooooooooooo`23ooooo`09o`000?oooooo003oooooool0nY[oooooo`00oooooooo000000;ooooo
00?o003oooooooooool01_ooool00ol0003o003oo`000002ooooo`03o`00ool0nY[ooooo00cooooo
00Go0?ZJo`000?oooooo0000o`3jVP04ooooo`03o`3jV_l00?oooooo00;ooooo00?o0?ZJo`000?oo
ool00_ooool01ol00?ooooooooooool0003oooooo`00ool0nYX00oooool00ol0nY[oooooooooo`0B
ooooo`;o00006_ooool00ol0003oooooooooo`1gooooo`03o`000?oooooooooo00Wooooo0_l00002
ooooo`;o0000M?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo02gooooo001:oooo
o`03o`000?oooooooooo01Kooooo0_l000001_l0nY[o0000o`000?oooooo0?ZJooooo`?o003o00Go
0?ZJooooooooooooooooo`00o`25ooooo`09o`000?oooooo003oo`3jV_l0003oooooo`00oooooooo
000000;ooooo00?o003oooooooooool01_ooool00ol0nY[o003oo`000002ooooo`03o`00ool0nY[o
oooo00Oooooo00?o0?ZJooooooooool00_ooool01Ol0nY[o0000ooooool0003o0?ZJ00Cooooo00?o
0?ZJo`00ooooool00oooool01Ol0003ooooooooooooooooo003o00;ooooo00Go0000ooooool00?oo
ooooo`3jVP02ooooo`03o`3jV_oooooooooo01?ooooo00?o0000ooooooooool06?ooool2o`0007So
oooo00?o0000ooooooooool01oooool01?l0003oooooo`000?l00002ooooo`;o0000M?ooool00ol0
003oooooooooo`05ooooo`;o0000;oooool004[ooooo00?o0000ooooooooool05_ooool00ol0003o
ooooo`3jVP02o`000003ooooool0nY[ooooo00?ooooo1Ol00?n5ooooo`04o`000?oooooo003oo`3j
VP;ooooo00?o003oooooool000000_ooool00ol00?ooooooooooo`06ooooo`03o`3jV_l00?oo0000
00;ooooo00?o003oo`3jV_ooool01_ooool2o`3jVPCooooo1?l00?l00ol0nY[oooooooooo`02oooo
o`03o`3jV_l00?oooooo00?ooooo00[o0000ooooooooooooooooo`00ool0nY[oooooo`000?oooooo
003o0_ooool00ol0nY[oooooo`3jVP0Eooooo`03o`000?oooooooooo00Gooooo0_l00004ooooo`03
o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo07Oooooo00?o0000oooooooo
ool01oooool2o`000003ooooool0003ooooo00?o0000M?ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo02gooooo000gooooo`?o00000oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool05_ooool01ol0003oooooo`3jV_oooooo0000oooo
ool0nYX01?ooool01Ol0nY[ooooooooooooooooo0?ZJ08Gooooo00Co0000ooooool00?oo00000_oo
ool00ol00?ooooooo`000002ooooo`03o`00oooooooooooo00Kooooo00?o0?ZJo`00ool000000_oo
ool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Go003ooooooooooooo0000
o`00o`04ooooo`03o`3jV_l00?oooooo00?ooooo00Ko0000ooooooooooooooooo`00ool0nYX2o`00
0007ooooool00?ooooooooooool0nY[oooooo`3jVP0Eooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooooooo
ool0Moooool00ol0003oooooooooo`07ooooo`;o00000_ooool4o`0007;ooooo00?o0000ooooool0
00002?ooool00ol0003oooooooooo`0]ooooo`00>?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool05_ooool01ol0003oooooooooool0nY[o0000oooo
ool0nYX01?ooool01Ol0nY[ooooooooooooooooo0?ZJ08Gooooo00Co0000ooooool00?oo00000_oo
ool00ol00?ooooooo`000002ooooo`03o`00oooooooooooo00Kooooo00?o0?ZJo`00ool000000_oo
ool00ol0nY[o003oooooo`05ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Go003ooooooooooooo0000
o`00o`03ooooo`03o`000?l0nY[o003o00Cooooo00Ko0000ooooooooooooooooo`00ool0nYX2o`00
0007ooooool00?ooooooooooool0nY[oooooo`3jVP0Eooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00002oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo07Oooooo
00?o0000ooooooooool01oooool2o`0000;ooooo0ol000000ooooooo0000ooooo`1`ooooo`;o0000
2Oooool00ol0003oooooooooo`0]ooooo`00=Oooool5o`0000[ooooo00?o0000ooooooooool00ooo
ool3o`0001Kooooo00Go0000oooooooooooo0?ZJooooo`02o`3jVPCooooo00Go0?ZJoooooooooooo
ooooo`3jVP26ooooo`03o`000?l00?oo000000;ooooo00?o003oooooool000000_ooool00ol00?oo
ooooooooo`06ooooo`03o`3jV_l00?oo000000;ooooo00?o0?ZJo`00ooooool01Oooool00ol0nY[o
ooooo`3jVP04ooooo`05o`00ool0nY[oooooooooool00?l00oooool00ol0003o003oo`3jVP04oooo
o`06o`000?ooooooooooooooool00?oo0?ZJ0_l000000ooooooo003oooooo`02ooooo`;o0?ZJ4ooo
ool3o`0000Kooooo00Co0000oooooooooooo00002Oooool2o`0000Gooooo0ol00003ooooo`Co0?ZJ
00Coooooo`3jV_l0nY[o0?ZJK?ooool2o`0000Sooooo00Wo0000ooooooooooooooooo`000?oooooo
0000ooooool00000LOooool2o`0000Oooooo0ol0000_ooooo`00=Oooool01?l0003oooooooooool0
000;ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool05_ooool01?l0003ooooooooo
ooooool3o`3jVPCooooo00Go0?ZJooooooooooooooooo`3jVP26ooooo`03o`000?l00?oo000000;o
oooo00?o003oooooool000000_ooool00ol00?ooooooooooo`06ooooo`03o`3jV_l00?oo000000;o
oooo00?o0?ZJo`00ooooool01?ooool01?l0nY[oooooooooool0nYX4ooooo`05o`00ool0nY[ooooo
ooooool00?l00oooool00ol0003o003oo`3jVP04ooooo`06o`000?ooooooooooooooool00?oo0?ZJ
0_l000000ooooooo003oooooo`03ooooo`03o`3jV_oooooooooo01?ooooo00?o0000ooooooooool0
1?ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool01oooool2o`3jVP03ooooool0nY[o0?ZJ00So0?ZJ0oooool00ol0nY[oooooooooo`1Nooooo`;o
000000?oooooo`000?l000001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo0000073o
oooo00?o0000ooooool000002Oooool00ol0003oooooooooo`0]ooooo`00=_ooool00ol0003ooooo
o`00000<ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool06_ooool2o`3jVP03oooo
ool0nY[ooooo00;ooooo00Go0?ZJooooooooooooooooo`3jVP26ooooo`03o`000?l00?oo000000;o
oooo00Ko003oooooool0003oooooo`000?l00?l8ooooo`07o`00ool0nY[oooooo`000?oooooo0?ZJ
o`00o`03ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool00_ooool01_l00?oo0?ZJ
oooooooooooo003oo`3jVP;ooooo00?o0000o`00ool0nYX01?ooool01_l0003ooooooooooooooooo
003oo`3jVP;o000000?oooooo`00ooooool06Oooool00ol0003oooooooooo`04ooooo`04o`000?oo
ooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo01Co
oooo0ol0nYX00ooooooo0?ZJo`3jVP08o`3jVUKooooo0ol000000ooooooo0000ooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooool00000L?ooool00ol0003oooooo`000009ooooo`03
o`000?oooooooooo02gooooo000gooooo`;o00002?ooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool06oooool00ol0nY[oooooo`3jVP02ooooo`;o0?ZJ0oooool00ol0nY[o
ooooooooo`24ooooo`03o`000?l00?oo003o00?o003o0_ooool2o`000003o`00oooooooooooo00Go
oooo00So0000o`00ool0nY[oooooo`000?oooooo0?ZJo`00o`;ooooo0ol0nYX3ooooo`03o`3jV_oo
oooooooo00;ooooo00Ko003oo`3jV_ooooooooooo`00ool0nYX2ooooo`03o`000?l00?oo0?ZJ00Go
oooo00Go0000oooooooooooo0?ZJo`00o`02o`000003ooooool00?oooooo01Wooooo00?o0000oooo
ooooool01Oooool2o`0000Wooooo0ol00005ooooo`03o`000?oooooooooo02;ooooo1?l0nYYBoooo
o`;o00000_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0K_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo02gooooo000hooooo`03o`000?oooooooooo
00Kooooo1Ol00004ooooo`03o`000?oooooooooo01kooooo00Go0?ZJooooool0nY[oooooo`3jVP02
ooooo`03o`3jV_oooooooooo08Cooooo00?o0000o`3jV_l000000_ooool00ol0nY[oooooooooo`02
o`000003o`00oooooooooooo00Gooooo00So0000o`00ool0nY[oooooo`000?oooooo0?ZJo`00o`;o
oooo0ol0nYX3ooooo`03o`3jV_oooooooooo00;ooooo00Ko003oooooool0nY[oooooo`00ool0nYX2
ooooo`03o`000?l00?oo0?ZJ00Gooooo00Go0000oooooooooooo0?ZJo`00o`03o`000003o`00oooo
oooooooo01Sooooo00?o0000ooooooooool06?ooool2o`0002Kooooo1Ol0nYY?ooooo`04o`000?oo
ooooooooo`0000?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0aooooo`03o`00
0?oooooooooo03Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`;o0000
;oooool004[ooooo0_l0000Pooooo`;o0?ZJ00Goooooo`3jV_ooooooooooo`3jVP26ooooo`03o`00
0?l0nY[o000000;ooooo00?o0?ZJooooooooool00_l000000ol00?ooooooooooo`05ooooo`05o`00
0?l00?oo0?ZJooooool000000_ooool01_l00?ooooooooooool0nY[o0000o`3jVP?ooooo00?o0?ZJ
ooooooooool00_ooool01_l00?ooooooo`3jV_oooooo003oo`3jVP;ooooo00?o0000o`00ool0nYX0
1Oooool01Ol0003oooooooooool0nY[o003o00?o000000?o003oooooooooool05oooool2o`0001[o
oooo00?o0000ooooooooool0:_ooool5o`3jVT[ooooo00Co0000oooooooooooo00000oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0=?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0;Oooool004[o
oooo00?o0000ooooooooool07oooool2o`3jVP;ooooo00?o0?ZJooooool0nYX0Qoooool01Ol0nY[o
oooooooooooooooo0?ZJ00;ooooo0_l000000ol00?ooooooooooo`05ooooo`05o`000?l00?oo0?ZJ
ooooool000000_ooool01_l00?ooooooo`3jV_l0003oooooo`3jVP?ooooo00?o0?ZJooooooooool0
0_ooool02_l00?ooooooo`3jV_oooooo003oo`3jV_oooooo0000ooooool00?l6ooooo`05o`000?oo
ooooooooo`3jV_l00?l00_ooool00ol0003o003oooooo`0Iooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool0;oooool5o`3jVTGooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0;oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`0Oooooo`;o0?ZJ0_ooool00ol0nY[ooooo
o`3jVP27ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool2o`000003o`00oooooooooooo00Co
oooo00?o0000ooooool00?l00_ooool02?l0003oooooooooool00?oo0?ZJooooool0003ooooo0_l0
0?l2ooooo`03o`3jV_oooooooooo00;ooooo00[o003ooooooooooooo0?ZJo`00ool0nY[oooooo`00
0?l0nY[o003o1_ooool01Ol0003oooooooooool0nY[o003o00;ooooo00?o0000o`00ooooool06Ooo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03Cooooo1ol0nYXnooooo`04o`000?oo
ooooooooo`0000?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0_ooooo`03o`00
0?oooooo0000033ooooo00Co0000oooooooooooooooo0_l000001Ooooooo0000oooooooooooo0000
00cooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000ooooooooool08?ooool01?l0nY[o
ooooooooooooool2o`3jVXOooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`;o000000?o003o
ooooooooool01?ooool00ol0003oooooo`00o`02ooooo`0:o`000?ooooooooooo`00ool0nY[ooooo
o`000?oooooo003oooooo`?o003o00Goooooo`000?ooooooooooo`00o`02ooooo`07o`3jV_l0003o
003oooooool0003o0?ZJo`00o`06ooooo`05o`000?oooooo0000o`3jV_l00?l00_ooool00ol0003o
003oooooo`0Iooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0>oooool;o`3jVSKo
oooo00Go0000ooooooooooooooooo`000009ooooo`03o`000?oooooooooo02oooooo00?o0000oooo
ool00000<?ooool2o`0000;ooooo0_l000000ooooooo0000ooooo`02o`0000cooooo00?o0000oooo
ooooool0;Oooool004[ooooo0_l0000Vooooo`03o`3jV_oooooooooo08Gooooo00Go0?ZJoooooooo
ooooooooo`3jVP02ooooo`;o000000?o003oooooooooool01?ooool00ol0003oooooo`00o`02oooo
o`04o`000?ooooooooooo`00o`;ooooo00?o0000ooooool00?l00oooool00ol00?ooooooo`000002
ooooo`0:o`00ooooooooooooooooool0nY[o003oooooool0nY[oooooo`00o`Kooooo00Go0000oooo
ool0003o0000o`00o`03ooooo`03o`00oooooooooooo01Oooooo0_l0000Jooooo`;o0000Aoooool7
o`3jVPCooooo0ol0nYX6ooooo`?o0?ZJ7oooool01Ol0003ooooooooooooooooo000000Wooooo00?o
0000ooooooooool0;oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo02Wooooo0ol0
0002ooooo`;o000000?oooooo`000?l000000_l0000;ooooo`;o0000;oooool004[ooooo00?o0000
ooooooooool0[_ooool01?l0nY[oooooooooool0nYX2ooooo`;o000000?o003oooooooooool01?oo
ool00ol0003oooooo`00o`02ooooo`04o`000?ooooooooooo`00o`;ooooo00?o0000ooooool00?l0
0oooool00ol00?ooooooo`000002ooooo`0:o`00ooooooooooooooooool0nY[o003oooooool0nY[o
ooooo`00o`Kooooo00Go0000ooooool0003o0000o`00o`03ooooo`03o`00oooooooooooo01Sooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`1=ooooo`Co0?ZJ0_ooool8o`3jVP;ooooo
1ol0nYXHooooo`;o00000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02Wooooo
1Ol0nYX01?oooooo0000ooooool00003ooooo`03o`000?oooooooooo00Wooooo1Ol0nYXKooooo`03
o`000?oooooo000000;ooooo0ol000001?oooooo0000o`000?l0000<ooooo`03o`000?oooooooooo
02gooooo001:ooooo`03o`000?oooooooooo0:oooooo00?o0?ZJooooool0nYX00_ooool00ol0003o
ooooo`00o`06ooooo`03o`000?l0nY[o003o00?ooooo00So0000ooooool00?oo0000ooooool0003o
003oo`3jVP?ooooo00?o003oooooool000000_ooool02_l00?oooooooooooooooooo0?ZJo`00oooo
oooo0?ZJooooool00?l6ooooo`05o`000?oooooo0000o`000?l00?l00oooool00ol00?oooooooooo
o`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0I?ooool4o`3jVQGooooo00Co
0000ooooool0003o00002_ooool00ol0003oooooooooo`0Nooooo`Ko0?ZJ1?ooool00ol0nY[ooooo
ooooo`02ooooo`Go0?ZJ00?oooooo`000?l000002oooool01Ol0nY[ooooooooooooooooo0?ZJ01_o
oooo00?o0000ooooool000000_ooool3o`00013ooooo00?o0000ooooooooool0;Oooool004[ooooo
00?o0000ooooooooool0[oooool00ol0nY[oooooo`3jVP02ooooo`03o`000?oooooo003o00Gooooo
00Co0000o`3jV_oooooo003o0oooool02?l0003oooooo`00ool0003oooooo`000?l00?oo0?ZJ0ooo
ool00ol00?oo0000o`000002ooooo`0:o`00ooooooooooooooooool0nY[o003oo`3jV_l0003ooooo
o`00o`Kooooo00Go0000ooooool0003o0000o`00o`02ooooo`03o`3jV_l00?oooooo01Wooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`1Xooooo`ko0?ZJ1_ooool?o`3jVP04o`000?oo
ooooooooo`0001gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo00?ooooo00Wo0000ooooool0003o0?ZJooooool0003oooooo`000?ooool02_l0nYX3
ooooo`03o`3jV_oooooooooo00?ooooo1Ol0nYX9ooooo`Ko0?ZJ0_ooool00ol0003oooooooooo`02
o`0000;ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0
003oooooooooo`2_ooooo`03o`3jV_oooooo0?ZJ00Cooooo00?o003oooooooooool00oooool01?l0
003o0?ZJooooool00?l3ooooo`08o`000?oooooo003oo`000?oooooo0000o`00ool0nYX3ooooo`06
o`00ool0003oooooo`000?oooooo003o0oooool01_l0nY[o003oo`3jV_l0003oooooo`00o`Kooooo
00Wo0000ooooool0003o0000o`00oooooooo0?ZJooooool00?l06_ooool00ol0003oooooooooo`0H
ooooo`;o0000M_ooool8o`3jVP04ooooool0003o0000o`0000[ooooo00Co0?ZJooooool0003o0000
6Oooool3o`3jVP03ooooool0nY[ooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`05
o`000?oooooo0000ooooool0nYX00_ooool00ol0003oooooo`3jVP0=ooooo`03o`3jV_oooooooooo
00;ooooo00Go0?ZJooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJ
oooooooooooo00000_ooool2o`0001;ooooo0_l0000_ooooo`00B_ooool2o`000;7ooooo0_l0nYX4
ooooo`03o`00oooooooooooo00?ooooo00Co0000o`3jV_oooooo003o0oooool00ol0003oooooo`00
o`04o`00o`;o0?ZJ0_ooool01_l00?oo0000ooooool0003oooooo`00o`Cooooo00Go003oo`3jV_l0
003oooooo`00o`06ooooo`09o`000?oooooo0000ooooool00?ooooooo`3jV_oooooo003o01Wooooo
0_l0000Jooooo`03o`000?oooooooooo07kooooo0ol0000:ooooo`Go0?ZJ1?ooool00ol0003ooooo
ooooo`0<ooooo`Go0?ZJ0_ooool3o`3jVPCooooo1Ol0nYX5ooooo`05o`000?ooooooooooo`000?oo
ool01Ol0nYX>ooooo`Go0?ZJ1Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_l0003ooooo00;o
oooo00Co0?ZJoooooooooooo00000oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
02gooooo001:ooooo`03o`000?oooooooooo0;7ooooo00?o0?ZJooooooooool00_ooool00ol00?oo
ooooooooo`03ooooo`04o`000?l0nY[oooooo`00o`?ooooo00Oo0000ooooool0nY[o0000ooooool0
003ooooo00;o0?ZJ0_ooool01_l00?oo0000ooooool0003oooooo`00o`Cooooo00Go003oo`000?l0
003oooooo`00o`07ooooo`;o000000Koooooo`00oooooooo0?ZJooooool00?lJooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool0Ooooool2o`0000[ooooo00Go0000ooooool0003ooooo
o`000005o`3jVPWooooo1Ol0nYXHooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0003o
ooooooooo`0Gooooo`Co0?ZJ1Oooool00ol0nY[o0000ooooo`02ooooo`?o0?ZJ00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0]ooooo`00B_ooool00ol0003oooooooooo`2fooooo`03o`00
oooooooooooo00?ooooo00Co0?ZJo`000?oooooo003o0oooool04Ol0003oooooo`3jV_l0003ooooo
o`000?oooooo0?ZJooooool0nY[oooooo`00ool0003oooooo`000?oooooo003o00Cooooo00Go003o
o`000?l0003oooooo`00o`07ooooo`;o000000?oooooo`00ool0nYX00_ooool00ol00?oooooooooo
o`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0P?ooool00ol0003ooooooooo
o`08ooooo`05o`000?oooooo0000ooooool000001?ooool00ol0nY[oooooooooo`02ooooo`Go0?ZJ
0oooool00ol0003oooooooooo`0Gooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo01Gooooo1_l0nYX00ol0003oooooooooo`03ooooo`03
o`000?l0nY[o0?ZJ00oooooo00?o0?ZJooooooooool01?ooool00ol0003oooooooooo`0]ooooo`00
B_ooool00ol0003oooooooooo`2fooooo`0:o`00ooooooooooooooooool0nY[o0000o`3jV_l0003o
ooooo`00o`?ooooo00ko0000ooooool0nY[o0000ooooool0003o0?ZJo`000?oooooo0?ZJooooool0
0?oo0000ooooo`;o000000?o003oooooooooool00_ooool5o`00o`Oooooo0_l000000ooooooo003o
o`3jVP02ooooo`03o`00oooooooooooo01Sooooo00?o0000ooooooooool06?ooool2o`00087ooooo
00?o0000ooooooooool02?ooool01Ol0003oooooo`000?oooooo000000Cooooo00?o0?ZJo`000?oo
ool00_ooool00ol0nY[oooooooooo`05ooooo`;o00005oooool2o`0000?ooooo0_l00002ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool06_ooool2o`0000Gooooo00?o0000oooooooo
ool03ol0nYX6ooooo`;o0000;oooool004[ooooo00?o0000ooooooooool0]_ooool02_l00?oooooo
oooooooooooo0?ZJo`000?l0nY[o0000ooooool00?l3ooooo`;o000000co0?ZJo`000?l0003ooooo
o`3jV_l0003oooooo`3jV_oooooo003oo`000?ooool2o`000003o`00oooooooooooo00;ooooo00Go
0?ZJooooool0003oooooo`3jVP07ooooo`;o000000?oooooo`00ooooool00_ooool00ol00?oooooo
ooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0P?ooool00ol0003ooooo
ooooo`08ooooo`05o`000?oooooo0000ooooool000001?ooool5o`3jVPSooooo0_l000000ooooooo
0000ooooo`0Dooooo`03o`000?oooooooooo00;ooooo0_l00002ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool06_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0;Oooool004[ooooo0_l0002gooooo`0:o`00ooooooooooooo`3jV_oo
oooo0?ZJooooool0003oooooo`00o`?ooooo0_l000001_l0nY[o0000o`000?oooooo0?ZJo`0000;o
oooo00Co0?ZJo`00ool0003ooooo0_l000000ol00?ooooooooooo`02ooooo`05o`3jV_oooooo0000
ooooool0nYX01oooool2o`000003ooooool00?oooooo00;ooooo00?o003oooooooooool05oooool2
o`000003ooooool0003o000000Cooooo00?o0000ooooooooool00_ooool3o`0000?ooooo0ol00005
ooooo`03o`000?oooooooooo083ooooo00?o0000ooooooooool02Oooool2o`000003ooooool0003o
oooo00?ooooo0_l0000;ooooo`;o000000?oooooo`000?ooool01Oooool00ol0003oooooooooo`0:
ooooo`?o00001Oooool01Ol0003ooooooooooooooooo000000?ooooo0_l0000Looooo`03o`000?oo
oooo000000Cooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0]ooooo`00B_ooool0
0ol0003oooooooooo`2fooooo`05o`00ooooooooooooo`3jV_ooool01Ol00?l3ooooo`;o000000Ko
0?ZJo`000?ooooooooooo`3jV_l00003ooooo`03o`00ool0003ooooo00;o000000?o003ooooooooo
ool00oooool01?l0nY[o0000ooooool0nYX7ooooo`;o000000?oooooo`00ooooool00_ooool00ol0
0?ooooooooooo`0Hooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`07o`000?oooooooooo
ooooool0003oooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0S?oo
ool2o`0000;ooooo00Co0000oooooooooooooooo0_l0000;ooooo`04o`000?oooooo0000o`0000Co
oooo00?o0000ooooool000002?ooool2o`0000;ooooo0ol00009ooooo`04o`000?oooooooooooooo
o`;o00006oooool00ol0003oooooooooo`02o`0000;ooooo0_l0000Hooooo`03o`000?oooooooooo
02gooooo000aooooo`?o00000oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;o
oooo0ol00005ooooo`03o`000?oooooooooo0;Kooooo00?o003oooooool0nYX00_ooool01Ol00?oo
oooooooooooooooo003o00?ooooo0_l000001ooooooo0?ZJoooooooooooo0?ZJooooool000000_oo
ool00ol00?oo0000ooooo`02o`000003o`00oooooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ
1oooool2o`000003ooooool00?oooooo00;ooooo00?o003oooooooooool06?ooool2o`0000;ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0T?ooool01?l0003oooooooooooooool2o`0000_ooooo00Co0000ooooool0
003o00001?ooool2o`000003ooooool0003ooooo00Kooooo0_l00002ooooo`03o`000?oooooooooo
00Wooooo00Co0000oooooooooooooooo0_l0000Kooooo`03o`000?oooooooooo00;o000000Cooooo
o`000?l0003o00006?ooool00ol0003oooooooooo`0]ooooo`00<_ooool00ol0003oooooooooo`08
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0;Kooooo00?o003oooooool0nYX00_ooool01Ol00?oooooooooooooooooo0?ZJ00?ooooo
0_l00002ooooo`05o`3jV_oooooo0?ZJooooool000000_ooool00ol00?oo0000ooooo`02o`000003
o`00oooooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ1oooool2o`000003ooooool00?oooooo
00;ooooo00?o003oooooooooool06?ooool2o`0000;ooooo00?o0000ooooooooool01oooool2o`00
00Kooooo00?o0000ooooooooool00_ooool3o`00093ooooo00Oo0000ooooooooooooooooo`000?oo
oooo000000[ooooo00So0000ooooooooooooooooo`000?oooooo0000ooooo`;o000000?oooooo`00
0?ooool01_ooool2o`0000;ooooo00?o0000ooooooooool02Oooool01?l0003oooooooooooooool2
o`0001_ooooo00Oo0000ooooooooooooooooo`000?oooooo000001Sooooo0ol0000_ooooo`00;ooo
ool5o`0000[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0;Kooooo00Oo003oooooool0nY[oooooo`000?l00?oo0?ZJ00;ooooo00Co0?ZJoooooooo
oooooooo0_l00002ooooo`05o`3jV_oooooo0?ZJooooool000000_ooool00ol00?oo0000ooooo`02
o`000003o`00oooooooooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ1oooool2o`000003ooooool0
0?oo003o00?o003o6_ooool2o`0000;ooooo00?o0000ooooooooool02Oooool00ol0003oooooo`00
0003o`0000Gooooo00?o0000ooooooooool0T?ooool01ol0003ooooooooooooooooo0000ooooool0
00002_ooool02?l0003ooooooooooooooooo0000ooooool0003ooooo0_l000000ooooooo0000oooo
o`06ooooo`;o000000?oooooo`000?ooool03?ooool00ol0003oooooooooo`02o`0001[ooooo00?o
0000ooooooooool00_ooool00ol0003oooooo`00000Jooooo`03o`000?oooooooooo02gooooo000_
ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`02ooooo`?o0000]_ooool01ol00?oo0?ZJo`000?oooooo0000o`00ool0nYX00_ooool01Ol0nY[o
oooooooooooooooo000000Cooooo0_l0nYX01ooooooo0000oooooooooooo003oo`000?ooool00_l0
00000ol00?ooooooooooo`04ooooo`03o`3jV_oooooo0?ZJ00Oooooo0_l000000ooooooo0?ZJoooo
o`02ooooo`03o`3jV_oooooooooo01Kooooo1?l00002ooooo`03o`000?oooooooooo00Gooooo00Oo
0000ooooooooooooooooo`000?oooooo000000Sooooo00?o0000ooooooooool0T?ooool01ol0003o
oooooooooooooooo0000ooooool000001_ooool01?l0003oooooooooool00004ooooo`?o000000Go
ooooo`000?l0003oooooo`000006ooooo`05o`000?oooooo0000ooooool000003Oooool01Ol0003o
ooooo`000?oooooo000001[ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00000Joooo
o`03o`000?oooooooooo02gooooo000`ooooo`03o`000?oooooo000000cooooo00?o0000ooooool0
00000ol00005ooooo`03o`000?oooooooooo0;Kooooo00Go003oo`3jV_l0003oooooo`00o`02o`3j
VP;ooooo00Go0?ZJooooooooooooooooo`000004ooooo`;o0?ZJ00Koooooo`000?ooooooooooo`00
ool00002ooooo`03o`000?l00?oooooo00Gooooo00?o0?ZJooooool0nYX02?ooool00ol0003ooooo
o`3jVP03ooooo`03o`3jV_oooooooooo01Sooooo00Co0000ooooool0003o00002Oooool3o`0000;o
oooo1Ol00004ooooo`03o`000?oooooooooo093ooooo00Oo0000ooooooooooooooooo`000?oooooo
000000Kooooo00Co0000oooooooooooo00001?ooool2o`000005ooooool0003oooooo`000?ooool0
0_l00005ooooo`05o`000?oooooo0000ooooool000003Oooool00ol0003oooooo`000002ooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00000Jooooo`03
o`000?oooooooooo02gooooo000aooooo`;o00002?ooool01ol0003ooooooooooooooooo0000oooo
ool000002?ooool00ol0003oooooooooo`2fooooo`05o`00ool0nY[o0000ooooool00?l00_l0nYX2
ooooo`05o`3jV_ooooooooooooooool000001Oooool00ol0nY[oooooo`000002ooooo`06o`00ool0
003oooooooooool0003o003o1_ooool00ol0nY[oooooo`3jVP08ooooo`03o`000?oooooo0?ZJ00?o
oooo00?o0?ZJooooooooool06?ooool00ol0003oooooooooo`0Hooooo`;o0000TOooool01ol0003o
oooooooooooooooo0000ooooool000001_ooool01?l0003oooooooooool00005ooooo`06o`000?oo
oooo0000ooooool0003ooooo0_l00004ooooo`;o000000Coooooo`000?oooooo00003Oooool00ol0
003oooooo`000002ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool00_ooool2o`00
01[ooooo0_l0000_ooooo`00<_ooool00ol0003oooooooooo`06ooooo`Go000000?oooooo`000?l0
00000ol00004ooooo`03o`000?oooooooooo0;Kooooo00[o003oooooool0003o0000o`00ool0nY[o
ooooo`3jV_oooooo0?ZJ2oooool01?l0003oooooooooool00?l4ooooo`03o`00oooooooooooo00Go
oooo0_l0nYX8ooooo`03o`000?oooooo0?ZJ00?ooooo00?o0?ZJooooooooool06?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo093ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`04ooooo`;o000000?oooooo`000?ooool01?ooool00ol0003oooooo`000003oooo
o`;o00000oooool3o`000004ooooool0003oooooo`0000gooooo00?o0000ooooool000000_ooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00;ooooo0_l0000Kooooo`03o`000?oooooo
oooo02gooooo001:ooooo`;o0000]oooool02_l00?oo0000ooooool0003o003oo`3jV_oooooo0?ZJ
ooooool0nYX;ooooo`04o`000?ooooooooooo`00o`?ooooo00?o0?ZJo`00ooooool01oooool00ol0
nY[oooooooooo`06ooooo`03o`000?oooooo0?ZJ00?ooooo00?o0?ZJooooooooool05oooool2o`00
01[ooooo00?o0000ooooooooool0T?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Cooooo1?l00005ooooo`03o`000?oooooo000000?ooooo0_l00003ooooo`;o00000_ooool0
0ol0003oooooo`00000=ooooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool05oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0;Oooool0
04[ooooo00?o0000ooooooooool0]_ooool5o`00o`05o`3jV_oooooo0?ZJooooool0nYX02oooool0
1?l0003oooooooooool00?l2ooooo`03o`3jV_oooooo003o00Sooooo00?o0?ZJooooooooool02?oo
ool01Ol0nY[ooooooooooooooooo0?ZJ01[ooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`2@ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01?ooool4o`0000Oo
oooo00?o0000ooooooooool00oooool01?l0003oooooooooool00003ooooo`;o00003_ooool00ol0
003oooooo`000002ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo02gooooo001:ooooo`03o`000?oooooooooo0;Ko
oooo00?o0?ZJo`000?ooool00_ooool00ol0nY[oooooooooo`02o`3jVPcooooo00?o0000ooooool0
0?l00_ooool00ol0nY[oooooo`00o`0Dooooo`04o`3jV_ooooooooooo`3jVQ[ooooo00?o0000oooo
ooooool06?ooool2o`00097ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`04
ooooo`04o`000?oooooo0000o`0000gooooo00Co0000oooooooooooo00000oooool2o`0000kooooo
00?o0000ooooool000000_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01oooooo
0_l0000_ooooo`00B_ooool00ol0003oooooooooo`2fooooo`05o`3jV_l0003oooooooooool0nYX0
1?ooool00ol0nY[oooooooooo`0:ooooo`03o`000?oooooo003o00;ooooo00?o0?ZJooooool00?l0
5Oooool00ol0nY[oooooo`3jVP0Jooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
TOooool2o`0000?ooooo00?o0000ooooooooool01?ooool01?l0003oooooo`000?l0000=ooooo`04
o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool03?ooool00ol0003oooooo`000002oooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0]oooo
o`00B_ooool00ol0003oooooooooo`2gooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJoooo
ooooool02_ooool01Ol0003oooooo`00oooooooo0?ZJ00;ooooo00?o003oooooooooool04oooool0
0ol0nY[oooooo`3jVP0Jooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0T_ooool0
1Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooool000003_ooool00ol0003oooooo`00
0005ooooo`03o`000?oooooooooo00gooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0]ooooo`00B_oo
ool2o`000;Sooooo00Co0?ZJoooooooooooo0?ZJ4Oooool01Ol0003oooooo`00oooooooo0?ZJ00;o
oooo00?o003oooooooooool04oooool00ol0nY[oooooo`3jVP0Iooooo`;o00006_ooool00ol0003o
ooooooooo`2Booooo`07o`000?ooooooooooooooool0003oooooo`000004ooooo`03o`000?oooooo
000000kooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`0=ooooo`05o`000?oooooo
ooooooooool000000_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0;Oooool004[ooooo00?o0000ooooooooool0]oooool01?l0nY[oooooooooool0
nYXAooooo`04o`000?oooooo003oo`3jVP?ooooo00?o003oooooooooool05?ooool2o`3jVQ[ooooo
00?o0000ooooooooool06?ooool2o`0009?ooooo00Oo0000ooooooooooooooooo`000?oooooo0000
00?ooooo00Co0000oooooooooooo00003oooool2o`0001[ooooo0ol0000Dooooo`03o`000?oooooo
oooo023ooooo0_l0000_ooooo`00B_ooool00ol0003oooooooooo`2hooooo`03o`3jV_oooooo0?ZJ
017ooooo00Co0000ooooool00?oo0?ZJ0oooool00ol00?ooooooooooo`0Eooooo`03o`3jV_oooooo
oooo01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`2Fooooo`04o`000?oooooo
0000o`0000;ooooo00Co0000oooooooooooo00003oooool2o`0001[ooooo0ol00002ooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0]ooooo`00B_oo
ool00ol0003oooooooooo`2hooooo`03o`3jV_oooooo0?ZJ017ooooo0_l000000ol00?oo0?ZJoooo
o`02ooooo`03o`00oooooooooooo033ooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`2Fooooo`Co00000_ooool00ol0003oooooooooo`0@ooooo`;o00006_ooool3o`0000;ooooo0_l0
000@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0;Oooool004[ooooo00?o0000
ooooooooool0^?ooool00ol0nY[oooooo`3jVP0Aooooo`;o000000?o003oooooooooool00_ooool0
0ol00?ooooooooooo`0`ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0Uoooool0
0ol0003oooooooooo`02o`0001?ooooo00?o0000ooooooooool06Oooool2o`000003ooooool0003o
oooo00;o00004?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02gooooo001:oooo
o`;o0000^_ooool2o`3jVQ7ooooo00?o0000ooooool00?l00ol00?l00ooooooo003oooooo`0`oooo
o`;o00006_ooool00ol0003oooooooooo`2Jooooo`;o0000;oooool2o`000005ooooool0003o0000
ooooool000004?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02gooooo001:oooo
o`03o`000?oooooooooo0;[ooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`03o`00
oc;ooooo00?o0000ooooooooool06?ooool2o`0009_ooooo0_l0000_ooooo`;o000000Goooooo`00
0?l0003oooooo`000002ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooool000008_ooool2
o`0002oooooo001:ooooo`03o`000?oooooooooo0;[ooooo00?o0?ZJooooooooool04Oooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`2Kooooo`03o`000?oooooooooo02gooooo0_l000001Ooooooo0000oooooooooooo
000000;ooooo00?o0000ooooooooool02Oooool00ol0003oooooo`00000Sooooo`03o`000?oooooo
oooo02gooooo001:ooooo`03o`000?oooooooooo0<oooooo00Go0?ZJooooooooooooooooo`3jVP0b
ooooo`03o`000?oooooooooo00Gooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0ol00004
ooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`03
ooooo`04o`000?oooooo0000o`0000[ooooo00?o0000ooooool000008oooool00ol0003ooooooooo
o`0]ooooo`00B_ooool00ol0003oooooooooo`3?ooooo`05o`3jV_ooooooooooooooool0nYX0<_oo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo00?ooooo1Ol00009ooooo`?o0000
8oooool00ol0003oooooooooo`0]ooooo`00B_ooool2o`000=3ooooo00Go0?ZJoooooooooooooooo
o`3jVP0aooooo`;o00001_ooool01?l0003oooooooooool00007ooooo`Go00001?ooool3o`000<co
oooo00?o0000ooooooooool00oooool5o`0000Cooooo00?o0000ooooooooool00_ooool2o`0002;o
oooo0ol0000_ooooo`00B_ooool00ol0003oooooooooo`3?ooooo`05o`3jV_ooooooooooooooool0
nYX0<_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00Co0000oooo
oooooooo00001Oooool00ol0003oooooooooo`3Booooo`Co000000Coooooo`000?oooooooooo0_l0
0004ooooo`;o00009?ooool00ol0003oooooooooo`0]ooooo`00=oooool3o`0000?ooooo00?o0000
ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0d?ooool01?l0nY[oooooooooool0
nYXbooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002?ooool00ol0003ooooo
o`000005ooooo`03o`000?oooooooooo0=;ooooo00?o0000ooooool000000_ooool01?l0003ooooo
o`000?ooool2o`0000?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0]ooooo`00
>?ooool00ol0003oooooooooo`06ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003o
ooooooooo`3@ooooo`04o`3jV_ooooooooooo`3jVS;ooooo00?o0000ooooooooool01?ooool01?l0
003oooooooooool00009ooooo`;o00001Oooool00ol0003oooooooooo`3Dooooo`05o`000?oooooo
ooooooooool000000_ooool3o`0000;ooooo00?o0000ooooooooool08oooool00ol0003ooooooooo
o`0]ooooo`00=Oooool5o`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`?o0000dOoo
ool00ol0nY[oooooo`3jVP0`ooooo`?o00001oooool2o`0000_ooooo00?o0000ooooooooool00ooo
ool2o`000=Gooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000002ooooo`03o`000?oo
oooooooo02;ooooo0_l0000_ooooo`00=Oooool01?l0003oooooooooool00009ooooo`?o00001Ooo
ool00ol0003oooooooooo`3Aooooo`03o`3jV_oooooo0?ZJ03;ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`3Dooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool000000_oo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02gooooo000fooooo`03o`000?oooooo
000000Sooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0=;ooooo0_l0
nYXbooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0gOooool00ol0003oooooo`00
000Vooooo`03o`000?oooooooooo02gooooo000gooooo`;o00002?ooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0000ooooooooool0doooool00ol0nY[oooooooooo`0`ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool0gOooool2o`0002Oooooo00?o0000ooooooooool0;Ooo
ool003Sooooo00?o0000ooooooooool01oooool3o`0000Gooooo00?o0000ooooooooool0ooooool7
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooo
oooo02gooooo001:ooooo`;o00001Oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo
00gooooo0_l0000Jooooo`;o00001?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
00gooooo0_l0000_ooooo`00B_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo0000;oooool004[oooooool0000;o`0001[oooooool0000;o`00
02oooooo003oooooooooooooZOooool00?oooooooooooonYooooo`00ooooooooooooojWooooo003o
ooooooooooooZOooool00?oooooooooooonYooooo`00ooooooooooooojWooooo003ooooooooooooo
ZOooool00?oooooooooooonYooooo`00ooooooooooooojWooooo003oooooooooooooZOooool00?oo
oooooooooonYooooo`00ooooooooooooojWooooo003oooooooooooooZOooool00?oooooooooooonY
ooooo`00ooooooooooooojWooooo003oooooooooooooZOooool00?oooooooooooonYooooo`00oooo
oom;ooooo`Go000000Goooooo`000?l0003o0000ooooo`05o`000?ooooooCoooool00?ooooooC?oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool0oooooom>ooooo`00oooooom<ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool00000
0oooool00ol0003oooooooooo`3oooooodkooooo003oooooodcooooo0ol00003ooooo`;o00001?oo
ool3o`000?ooooooC_ooool00?ooooooC?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
000000?ooooo00?o0000ooooooooool0oooooom>ooooo`00oooooom<ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0003oooooodgooooo
003ooooood_ooooo1Ol000001Ooooooo0000o`000?l0003ooooo00Oo0000oooooom=ooooo`00oooo
ooooooooojWooooo003oooooooooooooZOooool00001\
\>"],
  ImageRangeCache->{{{0, 678.75}, {209.062, 0}} -> {-0.162807, -0.0154542, \
0.00342632, 0.00342632}, {{47.5, 339.375}, {204.5, 24.125}} -> {-117.541, \
4.42847, 1.44928, 0.0021119}, {{339.375, 631.188}, {204.5, 24.125}} -> \
{-540.673, 0.00180536, 1.44962, 0.00231984}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EKF4", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[{
  "YMAX = 500;\n\n{YF,PF,lik}= \n\tEKF4[{logZM,X},{0.07, -1., .2, .2},\n\t\t \
{drift,Jacobif,DDf,Omega,DDOmega,h,Jacobih,R,",
  StyleBox["Mue,Sigma",
    FontColor->RGBColor[1, 0, 0]],
  ",dt},{-9,2}];"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["SetOptions[plot1,dicke->.007];", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
s=Map[VecDiag,PF]//Sqrt;
KI=YF~ii~(YF+s)~ii~(YF-s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
gSNF=
DisplayTogetherArray[
plot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}]//AddTimeAxis,color->{10,1,2,2},\
permute->{1,4,3,2}],
plot1[    Column[Y,{2}] \
~ii~Column[KI,{1,3,5}+1]//AddTimeAxis,color->{10,1,2,2}]
,PlotLabel->\"SNF\"];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -11 0 ]
[.5 .32152 11 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(SNF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -7.95429 1.77986 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05506 -18 -4.5 ]
[-0.0125 .05506 0 4.5 ]
[-0.0125 .14405 -24 -4.5 ]
[-0.0125 .14405 0 4.5 ]
[-0.0125 .23304 -18 -4.5 ]
[-0.0125 .23304 0 4.5 ]
[-0.0125 .32204 -24 -4.5 ]
[-0.0125 .32204 0 4.5 ]
[-0.0125 .41103 -18 -4.5 ]
[-0.0125 .41103 0 4.5 ]
[-0.0125 .50002 -24 -4.5 ]
[-0.0125 .50002 0 4.5 ]
[-0.0125 .58902 -18 -4.5 ]
[-0.0125 .58902 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33251 -5 -6 ]
[.97619 .33251 5 6 ]
[.97619 .30946 -5 -6 ]
[.97619 .30946 5 6 ]
[.97619 .36615 -5 -6 ]
[.97619 .36615 5 6 ]
[.97619 .3378 -5 -6 ]
[.97619 .3378 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05506 m
.00625 .05506 L
s
[(4.5)] -0.0125 .05506 1 0 Mshowa
0 .14405 m
.00625 .14405 L
s
[(4.55)] -0.0125 .14405 1 0 Mshowa
0 .23304 m
.00625 .23304 L
s
[(4.6)] -0.0125 .23304 1 0 Mshowa
0 .32204 m
.00625 .32204 L
s
[(4.65)] -0.0125 .32204 1 0 Mshowa
0 .41103 m
.00625 .41103 L
s
[(4.7)] -0.0125 .41103 1 0 Mshowa
0 .50002 m
.00625 .50002 L
s
[(4.75)] -0.0125 .50002 1 0 Mshowa
0 .58902 m
.00625 .58902 L
s
[(4.8)] -0.0125 .58902 1 0 Mshowa
.125 Mabswid
0 .07286 m
.00375 .07286 L
s
0 .09066 m
.00375 .09066 L
s
0 .10845 m
.00375 .10845 L
s
0 .12625 m
.00375 .12625 L
s
0 .16185 m
.00375 .16185 L
s
0 .17965 m
.00375 .17965 L
s
0 .19745 m
.00375 .19745 L
s
0 .21525 m
.00375 .21525 L
s
0 .25084 m
.00375 .25084 L
s
0 .26864 m
.00375 .26864 L
s
0 .28644 m
.00375 .28644 L
s
0 .30424 m
.00375 .30424 L
s
0 .33984 m
.00375 .33984 L
s
0 .35763 m
.00375 .35763 L
s
0 .37543 m
.00375 .37543 L
s
0 .39323 m
.00375 .39323 L
s
0 .42883 m
.00375 .42883 L
s
0 .44663 m
.00375 .44663 L
s
0 .46443 m
.00375 .46443 L
s
0 .48222 m
.00375 .48222 L
s
0 .51782 m
.00375 .51782 L
s
0 .53562 m
.00375 .53562 L
s
0 .55342 m
.00375 .55342 L
s
0 .57122 m
.00375 .57122 L
s
0 .03726 m
.00375 .03726 L
s
0 .01946 m
.00375 .01946 L
s
0 .00166 m
.00375 .00166 L
s
0 .60681 m
.00375 .60681 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05506 m
1 .05506 L
s
.99375 .14405 m
1 .14405 L
s
.99375 .23304 m
1 .23304 L
s
.99375 .32204 m
1 .32204 L
s
.99375 .41103 m
1 .41103 L
s
.99375 .50002 m
1 .50002 L
s
.99375 .58902 m
1 .58902 L
s
.125 Mabswid
.99625 .07286 m
1 .07286 L
s
.99625 .09066 m
1 .09066 L
s
.99625 .10845 m
1 .10845 L
s
.99625 .12625 m
1 .12625 L
s
.99625 .16185 m
1 .16185 L
s
.99625 .17965 m
1 .17965 L
s
.99625 .19745 m
1 .19745 L
s
.99625 .21525 m
1 .21525 L
s
.99625 .25084 m
1 .25084 L
s
.99625 .26864 m
1 .26864 L
s
.99625 .28644 m
1 .28644 L
s
.99625 .30424 m
1 .30424 L
s
.99625 .33984 m
1 .33984 L
s
.99625 .35763 m
1 .35763 L
s
.99625 .37543 m
1 .37543 L
s
.99625 .39323 m
1 .39323 L
s
.99625 .42883 m
1 .42883 L
s
.99625 .44663 m
1 .44663 L
s
.99625 .46443 m
1 .46443 L
s
.99625 .48222 m
1 .48222 L
s
.99625 .51782 m
1 .51782 L
s
.99625 .53562 m
1 .53562 L
s
.99625 .55342 m
1 .55342 L
s
.99625 .57122 m
1 .57122 L
s
.99625 .03726 m
1 .03726 L
s
.99625 .01946 m
1 .01946 L
s
.99625 .00166 m
1 .00166 L
s
.99625 .60681 m
1 .60681 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 0 r
gsave
.97619 .33251 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .24225 m
.02642 .24969 L
.02903 .2513 L
.03164 .22497 L
.03425 .24231 L
.03686 .23581 L
.03947 .25851 L
.04207 .28896 L
.04468 .29522 L
.04729 .32104 L
.0499 .28504 L
.05251 .29849 L
.05512 .27444 L
.05773 .29604 L
.06034 .32156 L
.06295 .34244 L
.06556 .35994 L
.06817 .34476 L
.07078 .31443 L
.07339 .3613 L
.07599 .34311 L
.0786 .32962 L
.08121 .30511 L
.08382 .31298 L
.08643 .33247 L
.08904 .32661 L
.09165 .34521 L
.09426 .41582 L
.09687 .37586 L
.09948 .36444 L
.10209 .36585 L
.1047 .39126 L
.10731 .40571 L
.10992 .38437 L
.11252 .38076 L
.11513 .39307 L
.11774 .37169 L
.12035 .37836 L
.12296 .37469 L
.12557 .34908 L
.12818 .36807 L
.13079 .39716 L
.1334 .39941 L
.13601 .36988 L
.13862 .37799 L
.14123 .36388 L
.14384 .37238 L
.14644 .36921 L
.14905 .35046 L
.15166 .33488 L
Mistroke
.15427 .34414 L
.15688 .35861 L
.15949 .38443 L
.1621 .34752 L
.16471 .31813 L
.16732 .32606 L
.16993 .33369 L
.17254 .32577 L
.17515 .3143 L
.17776 .33032 L
.18037 .3093 L
.18297 .30715 L
.18558 .31581 L
.18819 .31064 L
.1908 .31198 L
.19341 .31573 L
.19602 .29894 L
.19863 .29234 L
.20124 .23707 L
.20385 .24027 L
.20646 .24994 L
.20907 .24536 L
.21168 .24116 L
.21429 .25772 L
.21689 .26168 L
.2195 .26485 L
.22211 .23448 L
.22472 .25805 L
.22733 .28755 L
.22994 .28297 L
.23255 .29439 L
.23516 .29622 L
.23777 .24863 L
.24038 .25556 L
.24299 .25572 L
.2456 .26532 L
.24821 .25783 L
.25082 .25945 L
.25342 .26746 L
.25603 .25971 L
.25864 .25705 L
.26125 .261 L
.26386 .25449 L
.26647 .25235 L
.26908 .25851 L
.27169 .26768 L
.2743 .27289 L
.27691 .26453 L
.27952 .23857 L
.28213 .2541 L
Mistroke
.28474 .26264 L
.28735 .23713 L
.28995 .21609 L
.29256 .23148 L
.29517 .21393 L
.29778 .2382 L
.30039 .19654 L
.303 .20293 L
.30561 .21672 L
.30822 .22285 L
.31083 .25126 L
.31344 .27132 L
.31605 .26975 L
.31866 .26239 L
.32127 .28185 L
.32387 .2739 L
.32648 .31977 L
.32909 .31141 L
.3317 .27707 L
.33431 .2741 L
.33692 .31475 L
.33953 .31204 L
.34214 .29077 L
.34475 .28821 L
.34736 .29754 L
.34997 .31834 L
.35258 .31211 L
.35519 .30155 L
.3578 .29853 L
.3604 .29715 L
.36301 .29383 L
.36562 .27797 L
.36823 .30323 L
.37084 .308 L
.37345 .30562 L
.37606 .27162 L
.37867 .27239 L
.38128 .24881 L
.38389 .26794 L
.3865 .24649 L
.38911 .24174 L
.39172 .25222 L
.39432 .26842 L
.39693 .2416 L
.39954 .24973 L
.40215 .26351 L
.40476 .27125 L
.40737 .24037 L
.40998 .21947 L
.41259 .23206 L
Mistroke
.4152 .2163 L
.41781 .2375 L
.42042 .24693 L
.42303 .24378 L
.42564 .2601 L
.42825 .24233 L
.43085 .24539 L
.43346 .25685 L
.43607 .25099 L
.43868 .2686 L
.44129 .26811 L
.4439 .23251 L
.44651 .20882 L
.44912 .22132 L
.45173 .27506 L
.45434 .25432 L
.45695 .25497 L
.45956 .22084 L
.46217 .23718 L
.46477 .23815 L
.46738 .24861 L
.46999 .21472 L
.4726 .24385 L
.47521 .25321 L
.47782 .27561 L
.48043 .29551 L
.48304 .24486 L
.48565 .25141 L
.48826 .2265 L
.49087 .2813 L
.49348 .2884 L
.49609 .27626 L
.4987 .29129 L
.5013 .28448 L
.50391 .29561 L
.50652 .26273 L
.50913 .26583 L
.51174 .29346 L
.51435 .25075 L
.51696 .30567 L
.51957 .28318 L
.52218 .25892 L
.52479 .22517 L
.5274 .24837 L
.53001 .26488 L
.53262 .26769 L
.53523 .24556 L
.53783 .20971 L
.54044 .14773 L
.54305 .17699 L
Mistroke
.54566 .19217 L
.54827 .19767 L
.55088 .17225 L
.55349 .19517 L
.5561 .23407 L
.55871 .19303 L
.56132 .18632 L
.56393 .15639 L
.56654 .07923 L
.56915 .03736 L
.57175 .06119 L
.57436 .10405 L
.57697 .09912 L
.57958 .10617 L
.58219 .0961 L
.5848 .09457 L
.58741 .09761 L
.59002 .12747 L
.59263 .13014 L
.59524 .12917 L
.59785 .12852 L
.60046 .14506 L
.60307 .13891 L
.60568 .14031 L
.60828 .21123 L
.61089 .23944 L
.6135 .19872 L
.61611 .21446 L
.61872 .20584 L
.62133 .21467 L
.62394 .2375 L
.62655 .25505 L
.62916 .34345 L
.63177 .33575 L
.63438 .38555 L
.63699 .34229 L
.6396 .29979 L
.6422 .28749 L
.64481 .30249 L
.64742 .30455 L
.65003 .32447 L
.65264 .35022 L
.65525 .38831 L
.65786 .38375 L
.66047 .4312 L
.66308 .42101 L
.66569 .41568 L
.6683 .43003 L
.67091 .36561 L
.67352 .33477 L
Mistroke
.67613 .3424 L
.67873 .36051 L
.68134 .32126 L
.68395 .38299 L
.68656 .39632 L
.68917 .44297 L
.69178 .45434 L
.69439 .41924 L
.697 .47868 L
.69961 .51806 L
.70222 .52567 L
.70483 .49822 L
.70744 .49907 L
.71005 .52106 L
.71265 .52142 L
.71526 .50573 L
.71787 .48688 L
.72048 .45624 L
.72309 .48072 L
.7257 .43898 L
.72831 .43196 L
.73092 .40648 L
.73353 .39275 L
.73614 .3411 L
.73875 .35938 L
.74136 .4048 L
.74397 .43098 L
.74658 .4669 L
.74918 .50713 L
.75179 .48799 L
.7544 .46234 L
.75701 .41194 L
.75962 .48518 L
.76223 .47733 L
.76484 .46977 L
.76745 .43164 L
.77006 .42552 L
.77267 .43846 L
.77528 .47631 L
.77789 .49587 L
.7805 .54579 L
.78311 .55372 L
.78571 .54719 L
.78832 .5487 L
.79093 .55482 L
.79354 .46462 L
.79615 .44034 L
.79876 .47319 L
.80137 .49194 L
.80398 .50916 L
Mistroke
.80659 .43374 L
.8092 .40067 L
.81181 .39948 L
.81442 .35612 L
.81703 .37383 L
.81963 .37123 L
.82224 .44858 L
.82485 .42268 L
.82746 .47362 L
.83007 .45437 L
.83268 .48442 L
.83529 .44163 L
.8379 .41826 L
.84051 .39383 L
.84312 .3995 L
.84573 .34299 L
.84834 .34329 L
.85095 .27913 L
.85356 .29737 L
.85616 .3497 L
.85877 .29954 L
.86138 .29085 L
.86399 .34076 L
.8666 .39473 L
.86921 .44276 L
.87182 .48992 L
.87443 .51781 L
.87704 .4555 L
.87965 .42362 L
.88226 .49608 L
.88487 .45257 L
.88748 .40932 L
.89008 .39361 L
.89269 .42154 L
.8953 .43922 L
.89791 .40693 L
.90052 .36778 L
.90313 .37613 L
.90574 .3526 L
.90835 .36104 L
.91096 .33002 L
.91357 .33465 L
.91618 .34292 L
.91879 .31245 L
.9214 .3397 L
.92401 .3455 L
.92661 .36213 L
.92922 .31377 L
.93183 .30055 L
.93444 .32248 L
Mistroke
.93705 .32532 L
.93966 .30415 L
.94227 .29962 L
.94488 .29058 L
.94749 .34342 L
.9501 .26669 L
.95271 .2984 L
.95532 .29415 L
.95793 .30238 L
.96053 .34942 L
.96314 .35873 L
.96575 .37545 L
.96836 .3463 L
.97097 .31993 L
.97358 .34089 L
.97619 .33251 L
Mfstroke
0 .98 .604 r
gsave
.97619 .30946 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22458 m
.02642 .21519 L
.02903 .20839 L
.03164 .20278 L
.03425 .19791 L
.03686 .19355 L
.03947 .18958 L
.04207 .26792 L
.04468 .25825 L
.04729 .25133 L
.0499 .24567 L
.05251 .24076 L
.05512 .23637 L
.05773 .23237 L
.06034 .30154 L
.06295 .29185 L
.06556 .28493 L
.06817 .27926 L
.07078 .27434 L
.07339 .26995 L
.07599 .26595 L
.0786 .31185 L
.08121 .30212 L
.08382 .29517 L
.08643 .28948 L
.08904 .28455 L
.09165 .28015 L
.09426 .27613 L
.09687 .35498 L
.09948 .34526 L
.10209 .33832 L
.1047 .33263 L
.10731 .3277 L
.10992 .3233 L
.11252 .31929 L
.11513 .37462 L
.11774 .36487 L
.12035 .35791 L
.12296 .35221 L
.12557 .34728 L
.12818 .34286 L
.13079 .33884 L
.1334 .38183 L
.13601 .37204 L
.13862 .36505 L
.14123 .35933 L
.14384 .35438 L
.14644 .34995 L
.14905 .34592 L
.15166 .32344 L
Mistroke
.15427 .31349 L
.15688 .30642 L
.15949 .30063 L
.1621 .29562 L
.16471 .29115 L
.16732 .28707 L
.16993 .31733 L
.17254 .30733 L
.17515 .30022 L
.17776 .29441 L
.18037 .28938 L
.18297 .28488 L
.18558 .28079 L
.18819 .29564 L
.1908 .28556 L
.19341 .2784 L
.19602 .27255 L
.19863 .26749 L
.20124 .26297 L
.20385 .25885 L
.20646 .23816 L
.20907 .22793 L
.21168 .22069 L
.21429 .21478 L
.21689 .20966 L
.2195 .20509 L
.22211 .20093 L
.22472 .24103 L
.22733 .23077 L
.22994 .22351 L
.23255 .21758 L
.23516 .21245 L
.23777 .20787 L
.24038 .2037 L
.24299 .2388 L
.2456 .2285 L
.24821 .22121 L
.25082 .21526 L
.25342 .21012 L
.25603 .20552 L
.25864 .20134 L
.26125 .24348 L
.26386 .23314 L
.26647 .22584 L
.26908 .21988 L
.27169 .21472 L
.2743 .21012 L
.27691 .20592 L
.27952 .2235 L
.28213 .21309 L
Mistroke
.28474 .20575 L
.28735 .19975 L
.28995 .19457 L
.29256 .18994 L
.29517 .18573 L
.29778 .22112 L
.30039 .21068 L
.303 .20331 L
.30561 .19729 L
.30822 .1921 L
.31083 .18746 L
.31344 .18323 L
.31605 .24995 L
.31866 .23953 L
.32127 .23217 L
.32387 .22617 L
.32648 .22098 L
.32909 .21634 L
.3317 .21212 L
.33431 .25688 L
.33692 .24644 L
.33953 .23907 L
.34214 .23305 L
.34475 .22786 L
.34736 .22322 L
.34997 .21899 L
.35258 .29179 L
.35519 .28138 L
.3578 .27403 L
.3604 .26803 L
.36301 .26284 L
.36562 .25822 L
.36823 .254 L
.37084 .29126 L
.37345 .28081 L
.37606 .27344 L
.37867 .26743 L
.38128 .26223 L
.38389 .25759 L
.3865 .25337 L
.38911 .23018 L
.39172 .21958 L
.39432 .21212 L
.39693 .20604 L
.39954 .20079 L
.40215 .1961 L
.40476 .19184 L
.40737 .22385 L
.40998 .21322 L
.41259 .20574 L
Mistroke
.4152 .19964 L
.41781 .19438 L
.42042 .18968 L
.42303 .1854 L
.42564 .24159 L
.42825 .23096 L
.43085 .22349 L
.43346 .2174 L
.43607 .21213 L
.43868 .20744 L
.44129 .20316 L
.4439 .21784 L
.44651 .20714 L
.44912 .19962 L
.45173 .1935 L
.45434 .18821 L
.45695 .18349 L
.45956 .17919 L
.46217 .21987 L
.46477 .20915 L
.46738 .20162 L
.46999 .19549 L
.4726 .19019 L
.47521 .18547 L
.47782 .18116 L
.48043 .27381 L
.48304 .26317 L
.48565 .25569 L
.48826 .2496 L
.49087 .24433 L
.49348 .23963 L
.49609 .23535 L
.4987 .27402 L
.5013 .26336 L
.50391 .25587 L
.50652 .24976 L
.50913 .24449 L
.51174 .23978 L
.51435 .23549 L
.51696 .28751 L
.51957 .27686 L
.52218 .26936 L
.52479 .26326 L
.5274 .25798 L
.53001 .25328 L
.53262 .24899 L
.53523 .23326 L
.53783 .22246 L
.54044 .2149 L
.54305 .20873 L
Mistroke
.54566 .20341 L
.54827 .19866 L
.55088 .19433 L
.55349 .18252 L
.5561 .17161 L
.55871 .16397 L
.56132 .15775 L
.56393 .15238 L
.56654 .1476 L
.56915 .14324 L
.57175 .05483 L
.57436 .04364 L
.57697 .03584 L
.57958 .0295 L
.58219 .02403 L
.5848 .01915 L
.58741 .01472 L
.59002 .10638 L
.59263 .09529 L
.59524 .08754 L
.59785 .08125 L
.60046 .07581 L
.60307 .07096 L
.60568 .06655 L
.60828 .18758 L
.61089 .17664 L
.6135 .16899 L
.61611 .16276 L
.61872 .15738 L
.62133 .15258 L
.62394 .14821 L
.62655 .23419 L
.62916 .22332 L
.63177 .21572 L
.63438 .20952 L
.63699 .20417 L
.6396 .1994 L
.6422 .19505 L
.64481 .28134 L
.64742 .27055 L
.65003 .26299 L
.65264 .25683 L
.65525 .25151 L
.65786 .24676 L
.66047 .24244 L
.66308 .39437 L
.66569 .3838 L
.6683 .37636 L
.67091 .37029 L
.67352 .36505 L
Mistroke
.67613 .36037 L
.67873 .35611 L
.68134 .31141 L
.68395 .30063 L
.68656 .29308 L
.68917 .28692 L
.69178 .28161 L
.69439 .27687 L
.697 .27255 L
.69961 .48659 L
.70222 .47618 L
.70483 .46882 L
.70744 .46282 L
.71005 .45763 L
.71265 .453 L
.71526 .44879 L
.71787 .47139 L
.72048 .4609 L
.72309 .45351 L
.7257 .44748 L
.72831 .44227 L
.73092 .43762 L
.73353 .43339 L
.73614 .33572 L
.73875 .32492 L
.74136 .31735 L
.74397 .31119 L
.74658 .30586 L
.74918 .30111 L
.75179 .29679 L
.7544 .43677 L
.75701 .42618 L
.75962 .41872 L
.76223 .41265 L
.76484 .4074 L
.76745 .40271 L
.77006 .39845 L
.77267 .4229 L
.77528 .41226 L
.77789 .40477 L
.7805 .39867 L
.78311 .3934 L
.78571 .3887 L
.78832 .38442 L
.79093 .52879 L
.79354 .51835 L
.79615 .51099 L
.79876 .50498 L
.80137 .49978 L
.80398 .49515 L
Mistroke
.80659 .49092 L
.8092 .39527 L
.81181 .38451 L
.81442 .37696 L
.81703 .37082 L
.81963 .36551 L
.82224 .36077 L
.82485 .35646 L
.82746 .45204 L
.83007 .44139 L
.83268 .43391 L
.83529 .42781 L
.8379 .42254 L
.84051 .41784 L
.84312 .41356 L
.84573 .33619 L
.84834 .32527 L
.85095 .31763 L
.85356 .31142 L
.85616 .30605 L
.85877 .30126 L
.86138 .2969 L
.86399 .32471 L
.8666 .31376 L
.86921 .30611 L
.87182 .29987 L
.87443 .29449 L
.87704 .28969 L
.87965 .28532 L
.88226 .46749 L
.88487 .45684 L
.88748 .44935 L
.89008 .44325 L
.89269 .43797 L
.8953 .43327 L
.89791 .42898 L
.90052 .35989 L
.90313 .34898 L
.90574 .34134 L
.90835 .33512 L
.91096 .32976 L
.91357 .32497 L
.91618 .32061 L
.91879 .30023 L
.9214 .28918 L
.92401 .28147 L
.92661 .27519 L
.92922 .26977 L
.93183 .26494 L
.93444 .26054 L
Mistroke
.93705 .30784 L
.93966 .29681 L
.94227 .28909 L
.94488 .28282 L
.94749 .27741 L
.9501 .27258 L
.95271 .26818 L
.95532 .27965 L
.95793 .26854 L
.96053 .26079 L
.96314 .25448 L
.96575 .24904 L
.96836 .24419 L
.97097 .23977 L
.97358 .32049 L
.97619 .30946 L
Mfstroke
gsave
.97619 .36615 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26017 m
.02642 .26999 L
.02903 .27724 L
.03164 .28328 L
.03425 .28859 L
.03686 .29338 L
.03947 .2978 L
.04207 .30195 L
.04468 .31206 L
.04729 .31941 L
.0499 .32552 L
.05251 .33086 L
.05512 .33569 L
.05773 .34013 L
.06034 .33556 L
.06295 .34568 L
.06556 .35304 L
.06817 .35915 L
.07078 .3645 L
.07339 .36933 L
.07599 .37377 L
.0786 .34588 L
.08121 .35604 L
.08382 .36343 L
.08643 .36956 L
.08904 .37492 L
.09165 .37977 L
.09426 .38422 L
.09687 .38901 L
.09948 .39917 L
.10209 .40655 L
.1047 .41267 L
.10731 .41803 L
.10992 .42287 L
.11252 .42732 L
.11513 .40865 L
.11774 .41883 L
.12035 .42622 L
.12296 .43236 L
.12557 .43773 L
.12818 .44258 L
.13079 .44704 L
.1334 .41586 L
.13601 .42609 L
.13862 .43351 L
.14123 .43966 L
.14384 .44505 L
.14644 .44991 L
.14905 .45438 L
.15166 .35748 L
Mistroke
.15427 .36785 L
.15688 .37535 L
.15949 .38157 L
.1621 .38701 L
.16471 .39191 L
.16732 .39642 L
.16993 .35139 L
.17254 .36182 L
.17515 .36936 L
.17776 .3756 L
.18037 .38106 L
.18297 .38598 L
.18558 .3905 L
.18819 .32972 L
.1908 .34023 L
.19341 .34781 L
.19602 .35409 L
.19863 .35957 L
.20124 .36452 L
.20385 .36907 L
.20646 .27225 L
.20907 .2829 L
.21168 .29056 L
.21429 .29689 L
.21689 .30243 L
.2195 .30742 L
.22211 .312 L
.22472 .27514 L
.22733 .28582 L
.22994 .2935 L
.23255 .29985 L
.23516 .3054 L
.23777 .3104 L
.24038 .31499 L
.24299 .27292 L
.2456 .28364 L
.24821 .29135 L
.25082 .29772 L
.25342 .30328 L
.25603 .30829 L
.25864 .3129 L
.26125 .2776 L
.26386 .28835 L
.26647 .29607 L
.26908 .30245 L
.27169 .30803 L
.2743 .31305 L
.27691 .31766 L
.27952 .25763 L
.28213 .26845 L
Mistroke
.28474 .27621 L
.28735 .28262 L
.28995 .28822 L
.29256 .29327 L
.29517 .2979 L
.29778 .25526 L
.30039 .26612 L
.303 .2739 L
.30561 .28033 L
.30822 .28594 L
.31083 .29099 L
.31344 .29563 L
.31605 .28409 L
.31866 .29493 L
.32127 .30271 L
.32387 .30913 L
.32648 .31473 L
.32909 .31978 L
.3317 .32441 L
.33431 .29102 L
.33692 .30188 L
.33953 .30967 L
.34214 .31609 L
.34475 .32171 L
.34736 .32676 L
.34997 .3314 L
.35258 .32593 L
.35519 .33676 L
.3578 .34453 L
.3604 .35094 L
.36301 .35654 L
.36562 .36158 L
.36823 .36621 L
.37084 .3254 L
.37345 .33626 L
.37606 .34405 L
.37867 .35047 L
.38128 .35609 L
.38389 .36114 L
.3865 .36578 L
.38911 .26432 L
.39172 .27533 L
.39432 .28319 L
.39693 .28968 L
.39954 .29534 L
.40215 .30044 L
.40476 .30512 L
.40737 .25801 L
.40998 .26906 L
.41259 .27694 L
Mistroke
.4152 .28345 L
.41781 .28912 L
.42042 .29423 L
.42303 .29892 L
.42564 .27576 L
.42825 .28679 L
.43085 .29467 L
.43346 .30117 L
.43607 .30685 L
.43868 .31195 L
.44129 .31664 L
.4439 .252 L
.44651 .26311 L
.44912 .27103 L
.45173 .27756 L
.45434 .28326 L
.45695 .28839 L
.45956 .29309 L
.46217 .25405 L
.46477 .26517 L
.46738 .27311 L
.46999 .27964 L
.4726 .28535 L
.47521 .29048 L
.47782 .29519 L
.48043 .30799 L
.48304 .31903 L
.48565 .32692 L
.48826 .33342 L
.49087 .33909 L
.49348 .3442 L
.49609 .34889 L
.4987 .30819 L
.5013 .31926 L
.50391 .32716 L
.50652 .33368 L
.50913 .33936 L
.51174 .34448 L
.51435 .34917 L
.51696 .32169 L
.51957 .33275 L
.52218 .34065 L
.52479 .34716 L
.5274 .35285 L
.53001 .35796 L
.53262 .36265 L
.53523 .26743 L
.53783 .27863 L
.54044 .2866 L
.54305 .29316 L
Mistroke
.54566 .29889 L
.54827 .30405 L
.55088 .30877 L
.55349 .21671 L
.5561 .22803 L
.55871 .23607 L
.56132 .24268 L
.56393 .24845 L
.56654 .25364 L
.56915 .2584 L
.57175 .08904 L
.57436 .10063 L
.57697 .10882 L
.57958 .11555 L
.58219 .12141 L
.5848 .12668 L
.58741 .13151 L
.59002 .14062 L
.59263 .15211 L
.59524 .16024 L
.59785 .16693 L
.60046 .17276 L
.60307 .178 L
.60568 .18281 L
.60828 .22181 L
.61089 .23315 L
.6135 .2412 L
.61611 .24783 L
.61872 .25361 L
.62133 .25881 L
.62394 .26357 L
.62655 .2684 L
.62916 .27966 L
.63177 .28767 L
.63438 .29427 L
.63699 .30002 L
.6396 .3052 L
.6422 .30994 L
.64481 .31554 L
.64742 .32673 L
.65003 .33469 L
.65264 .34126 L
.65525 .34698 L
.65786 .35214 L
.66047 .35686 L
.66308 .42856 L
.66569 .43953 L
.6683 .44739 L
.67091 .45386 L
.67352 .45952 L
Mistroke
.67613 .46461 L
.67873 .46928 L
.68134 .34557 L
.68395 .35674 L
.68656 .3647 L
.68917 .37126 L
.69178 .37698 L
.69439 .38213 L
.697 .38685 L
.69961 .52078 L
.70222 .53162 L
.70483 .53938 L
.70744 .5458 L
.71005 .5514 L
.71265 .55645 L
.71526 .56108 L
.71787 .50552 L
.72048 .51642 L
.72309 .52423 L
.7257 .53067 L
.72831 .53629 L
.73092 .54135 L
.73353 .546 L
.73614 .36986 L
.73875 .38106 L
.74136 .38904 L
.74397 .3956 L
.74658 .40133 L
.74918 .40648 L
.75179 .41121 L
.7544 .47096 L
.75701 .48196 L
.75962 .48982 L
.76223 .49631 L
.76484 .50197 L
.76745 .50706 L
.77006 .51174 L
.77267 .45707 L
.77528 .46812 L
.77789 .47601 L
.7805 .48252 L
.78311 .4882 L
.78571 .49331 L
.78832 .498 L
.79093 .56296 L
.79354 .57382 L
.79615 .5816 L
.79876 .58802 L
.80137 .59363 L
.80398 .59868 L
Mistroke
.80659 .60332 L
.8092 .42941 L
.81181 .44057 L
.81442 .44852 L
.81703 .45507 L
.81963 .46078 L
.82224 .46593 L
.82485 .47064 L
.82746 .48622 L
.83007 .49727 L
.83268 .50517 L
.83529 .51167 L
.8379 .51735 L
.84051 .52246 L
.84312 .52715 L
.84573 .37036 L
.84834 .38167 L
.85095 .38971 L
.85356 .39633 L
.85616 .4021 L
.85877 .40728 L
.86138 .41204 L
.86399 .35892 L
.8666 .37027 L
.86921 .37832 L
.87182 .38495 L
.87443 .39073 L
.87704 .39593 L
.87965 .4007 L
.88226 .5017 L
.88487 .51276 L
.88748 .52066 L
.89008 .52717 L
.89269 .53285 L
.8953 .53797 L
.89791 .54266 L
.90052 .39406 L
.90313 .40537 L
.90574 .41341 L
.90835 .42002 L
.91096 .42579 L
.91357 .43098 L
.91618 .43573 L
.91879 .33444 L
.9214 .34588 L
.92401 .35399 L
.92661 .36066 L
.92922 .36648 L
.93183 .3717 L
.93444 .3765 L
Mistroke
.93705 .34207 L
.93966 .3535 L
.94227 .36161 L
.94488 .36828 L
.94749 .37409 L
.9501 .37931 L
.95271 .3841 L
.95532 .31387 L
.95793 .32538 L
.96053 .33352 L
.96314 .34022 L
.96575 .34605 L
.96836 .3513 L
.97097 .35611 L
.97358 .35472 L
.97619 .36615 L
Mfstroke
0 0 1 r
gsave
.97619 .3378 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24237 m
.02642 .24259 L
.02903 .24281 L
.03164 .24303 L
.03425 .24325 L
.03686 .24347 L
.03947 .24369 L
.04207 .28493 L
.04468 .28515 L
.04729 .28537 L
.0499 .28559 L
.05251 .28581 L
.05512 .28603 L
.05773 .28625 L
.06034 .31855 L
.06295 .31877 L
.06556 .31899 L
.06817 .3192 L
.07078 .31942 L
.07339 .31964 L
.07599 .31986 L
.0786 .32886 L
.08121 .32908 L
.08382 .3293 L
.08643 .32952 L
.08904 .32974 L
.09165 .32996 L
.09426 .33017 L
.09687 .37199 L
.09948 .37221 L
.10209 .37243 L
.1047 .37265 L
.10731 .37287 L
.10992 .37309 L
.11252 .3733 L
.11513 .39163 L
.11774 .39185 L
.12035 .39207 L
.12296 .39229 L
.12557 .3925 L
.12818 .39272 L
.13079 .39294 L
.1334 .39885 L
.13601 .39906 L
.13862 .39928 L
.14123 .3995 L
.14384 .39972 L
.14644 .39993 L
.14905 .40015 L
.15166 .34046 L
Mistroke
.15427 .34067 L
.15688 .34089 L
.15949 .3411 L
.1621 .34132 L
.16471 .34153 L
.16732 .34175 L
.16993 .33436 L
.17254 .33458 L
.17515 .33479 L
.17776 .335 L
.18037 .33522 L
.18297 .33543 L
.18558 .33565 L
.18819 .31268 L
.1908 .31289 L
.19341 .31311 L
.19602 .31332 L
.19863 .31353 L
.20124 .31374 L
.20385 .31396 L
.20646 .2552 L
.20907 .25541 L
.21168 .25562 L
.21429 .25584 L
.21689 .25605 L
.2195 .25626 L
.22211 .25647 L
.22472 .25808 L
.22733 .25829 L
.22994 .2585 L
.23255 .25871 L
.23516 .25892 L
.23777 .25913 L
.24038 .25934 L
.24299 .25586 L
.2456 .25607 L
.24821 .25628 L
.25082 .25649 L
.25342 .2567 L
.25603 .25691 L
.25864 .25712 L
.26125 .26054 L
.26386 .26075 L
.26647 .26096 L
.26908 .26116 L
.27169 .26137 L
.2743 .26158 L
.27691 .26179 L
.27952 .24056 L
.28213 .24077 L
Mistroke
.28474 .24098 L
.28735 .24119 L
.28995 .2414 L
.29256 .2416 L
.29517 .24181 L
.29778 .23819 L
.30039 .2384 L
.303 .2386 L
.30561 .23881 L
.30822 .23902 L
.31083 .23923 L
.31344 .23943 L
.31605 .26702 L
.31866 .26723 L
.32127 .26744 L
.32387 .26765 L
.32648 .26785 L
.32909 .26806 L
.3317 .26827 L
.33431 .27395 L
.33692 .27416 L
.33953 .27437 L
.34214 .27457 L
.34475 .27478 L
.34736 .27499 L
.34997 .27519 L
.35258 .30886 L
.35519 .30907 L
.3578 .30928 L
.3604 .30948 L
.36301 .30969 L
.36562 .3099 L
.36823 .31011 L
.37084 .30833 L
.37345 .30854 L
.37606 .30874 L
.37867 .30895 L
.38128 .30916 L
.38389 .30937 L
.3865 .30957 L
.38911 .24725 L
.39172 .24745 L
.39432 .24766 L
.39693 .24786 L
.39954 .24807 L
.40215 .24827 L
.40476 .24848 L
.40737 .24093 L
.40998 .24114 L
.41259 .24134 L
Mistroke
.4152 .24155 L
.41781 .24175 L
.42042 .24195 L
.42303 .24216 L
.42564 .25867 L
.42825 .25888 L
.43085 .25908 L
.43346 .25929 L
.43607 .25949 L
.43868 .25969 L
.44129 .2599 L
.4439 .23492 L
.44651 .23512 L
.44912 .23533 L
.45173 .23553 L
.45434 .23573 L
.45695 .23594 L
.45956 .23614 L
.46217 .23696 L
.46477 .23716 L
.46738 .23736 L
.46999 .23757 L
.4726 .23777 L
.47521 .23797 L
.47782 .23818 L
.48043 .2909 L
.48304 .2911 L
.48565 .2913 L
.48826 .29151 L
.49087 .29171 L
.49348 .29192 L
.49609 .29212 L
.4987 .29111 L
.5013 .29131 L
.50391 .29152 L
.50652 .29172 L
.50913 .29192 L
.51174 .29213 L
.51435 .29233 L
.51696 .3046 L
.51957 .3048 L
.52218 .30501 L
.52479 .30521 L
.5274 .30541 L
.53001 .30562 L
.53262 .30582 L
.53523 .25034 L
.53783 .25055 L
.54044 .25075 L
.54305 .25095 L
Mistroke
.54566 .25115 L
.54827 .25135 L
.55088 .25155 L
.55349 .19962 L
.5561 .19982 L
.55871 .20002 L
.56132 .20022 L
.56393 .20042 L
.56654 .20062 L
.56915 .20082 L
.57175 .07194 L
.57436 .07213 L
.57697 .07233 L
.57958 .07252 L
.58219 .07272 L
.5848 .07292 L
.58741 .07311 L
.59002 .1235 L
.59263 .1237 L
.59524 .12389 L
.59785 .12409 L
.60046 .12429 L
.60307 .12448 L
.60568 .12468 L
.60828 .2047 L
.61089 .2049 L
.6135 .20509 L
.61611 .20529 L
.61872 .20549 L
.62133 .20569 L
.62394 .20589 L
.62655 .25129 L
.62916 .25149 L
.63177 .25169 L
.63438 .25189 L
.63699 .2521 L
.6396 .2523 L
.6422 .2525 L
.64481 .29844 L
.64742 .29864 L
.65003 .29884 L
.65264 .29904 L
.65525 .29925 L
.65786 .29945 L
.66047 .29965 L
.66308 .41146 L
.66569 .41167 L
.6683 .41187 L
.67091 .41208 L
.67352 .41228 L
Mistroke
.67613 .41249 L
.67873 .41269 L
.68134 .32849 L
.68395 .32869 L
.68656 .32889 L
.68917 .32909 L
.69178 .32929 L
.69439 .3295 L
.697 .3297 L
.69961 .50369 L
.70222 .5039 L
.70483 .5041 L
.70744 .50431 L
.71005 .50452 L
.71265 .50473 L
.71526 .50493 L
.71787 .48846 L
.72048 .48866 L
.72309 .48887 L
.7257 .48908 L
.72831 .48928 L
.73092 .48949 L
.73353 .48969 L
.73614 .35279 L
.73875 .35299 L
.74136 .35319 L
.74397 .3534 L
.74658 .3536 L
.74918 .3538 L
.75179 .354 L
.7544 .45386 L
.75701 .45407 L
.75962 .45427 L
.76223 .45448 L
.76484 .45468 L
.76745 .45489 L
.77006 .45509 L
.77267 .43998 L
.77528 .44019 L
.77789 .44039 L
.7805 .4406 L
.78311 .4408 L
.78571 .441 L
.78832 .44121 L
.79093 .54588 L
.79354 .54609 L
.79615 .54629 L
.79876 .5465 L
.80137 .54671 L
.80398 .54691 L
Mistroke
.80659 .54712 L
.8092 .41234 L
.81181 .41254 L
.81442 .41274 L
.81703 .41294 L
.81963 .41315 L
.82224 .41335 L
.82485 .41355 L
.82746 .46913 L
.83007 .46933 L
.83268 .46954 L
.83529 .46974 L
.8379 .46995 L
.84051 .47015 L
.84312 .47035 L
.84573 .35327 L
.84834 .35347 L
.85095 .35367 L
.85356 .35387 L
.85616 .35407 L
.85877 .35427 L
.86138 .35447 L
.86399 .34182 L
.8666 .34202 L
.86921 .34221 L
.87182 .34241 L
.87443 .34261 L
.87704 .34281 L
.87965 .34301 L
.88226 .4846 L
.88487 .4848 L
.88748 .48501 L
.89008 .48521 L
.89269 .48541 L
.8953 .48562 L
.89791 .48582 L
.90052 .37697 L
.90313 .37717 L
.90574 .37737 L
.90835 .37757 L
.91096 .37777 L
.91357 .37797 L
.91618 .37817 L
.91879 .31733 L
.9214 .31753 L
.92401 .31773 L
.92661 .31793 L
.92922 .31812 L
.93183 .31832 L
.93444 .31852 L
Mistroke
.93705 .32496 L
.93966 .32515 L
.94227 .32535 L
.94488 .32555 L
.94749 .32575 L
.9501 .32595 L
.95271 .32614 L
.95532 .29676 L
.95793 .29696 L
.96053 .29715 L
.96314 .29735 L
.96575 .29755 L
.96836 .29774 L
.97097 .29794 L
.97358 .33761 L
.97619 .3378 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -0.0810856 1.64368 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0011 -24 -4.5 ]
[-0.0125 .0011 0 4.5 ]
[-0.0125 .08328 -18 -4.5 ]
[-0.0125 .08328 0 4.5 ]
[-0.0125 .16547 -24 -4.5 ]
[-0.0125 .16547 0 4.5 ]
[-0.0125 .24765 -18 -4.5 ]
[-0.0125 .24765 0 4.5 ]
[-0.0125 .32983 -24 -4.5 ]
[-0.0125 .32983 0 4.5 ]
[-0.0125 .41202 -18 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .4942 -24 -4.5 ]
[-0.0125 .4942 0 4.5 ]
[-0.0125 .57639 -18 -4.5 ]
[-0.0125 .57639 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36222 -5 -6 ]
[.97619 .36222 5 6 ]
[.97619 .24855 -5 -6 ]
[.97619 .24855 5 6 ]
[.97619 .47265 -5 -6 ]
[.97619 .47265 5 6 ]
[.97619 .02445 -5 -6 ]
[.97619 .02445 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0011 m
.00625 .0011 L
s
[(0.05)] -0.0125 .0011 1 0 Mshowa
0 .08328 m
.00625 .08328 L
s
[(0.1)] -0.0125 .08328 1 0 Mshowa
0 .16547 m
.00625 .16547 L
s
[(0.15)] -0.0125 .16547 1 0 Mshowa
0 .24765 m
.00625 .24765 L
s
[(0.2)] -0.0125 .24765 1 0 Mshowa
0 .32983 m
.00625 .32983 L
s
[(0.25)] -0.0125 .32983 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(0.3)] -0.0125 .41202 1 0 Mshowa
0 .4942 m
.00625 .4942 L
s
[(0.35)] -0.0125 .4942 1 0 Mshowa
0 .57639 m
.00625 .57639 L
s
[(0.4)] -0.0125 .57639 1 0 Mshowa
.125 Mabswid
0 .01754 m
.00375 .01754 L
s
0 .03397 m
.00375 .03397 L
s
0 .05041 m
.00375 .05041 L
s
0 .06685 m
.00375 .06685 L
s
0 .09972 m
.00375 .09972 L
s
0 .11616 m
.00375 .11616 L
s
0 .13259 m
.00375 .13259 L
s
0 .14903 m
.00375 .14903 L
s
0 .1819 m
.00375 .1819 L
s
0 .19834 m
.00375 .19834 L
s
0 .21478 m
.00375 .21478 L
s
0 .23121 m
.00375 .23121 L
s
0 .26409 m
.00375 .26409 L
s
0 .28052 m
.00375 .28052 L
s
0 .29696 m
.00375 .29696 L
s
0 .3134 m
.00375 .3134 L
s
0 .34627 m
.00375 .34627 L
s
0 .36271 m
.00375 .36271 L
s
0 .37914 m
.00375 .37914 L
s
0 .39558 m
.00375 .39558 L
s
0 .42845 m
.00375 .42845 L
s
0 .44489 m
.00375 .44489 L
s
0 .46133 m
.00375 .46133 L
s
0 .47777 m
.00375 .47777 L
s
0 .51064 m
.00375 .51064 L
s
0 .52708 m
.00375 .52708 L
s
0 .54351 m
.00375 .54351 L
s
0 .55995 m
.00375 .55995 L
s
0 .59282 m
.00375 .59282 L
s
0 .60926 m
.00375 .60926 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0011 m
1 .0011 L
s
.99375 .08328 m
1 .08328 L
s
.99375 .16547 m
1 .16547 L
s
.99375 .24765 m
1 .24765 L
s
.99375 .32983 m
1 .32983 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .4942 m
1 .4942 L
s
.99375 .57639 m
1 .57639 L
s
.125 Mabswid
.99625 .01754 m
1 .01754 L
s
.99625 .03397 m
1 .03397 L
s
.99625 .05041 m
1 .05041 L
s
.99625 .06685 m
1 .06685 L
s
.99625 .09972 m
1 .09972 L
s
.99625 .11616 m
1 .11616 L
s
.99625 .13259 m
1 .13259 L
s
.99625 .14903 m
1 .14903 L
s
.99625 .1819 m
1 .1819 L
s
.99625 .19834 m
1 .19834 L
s
.99625 .21478 m
1 .21478 L
s
.99625 .23121 m
1 .23121 L
s
.99625 .26409 m
1 .26409 L
s
.99625 .28052 m
1 .28052 L
s
.99625 .29696 m
1 .29696 L
s
.99625 .3134 m
1 .3134 L
s
.99625 .34627 m
1 .34627 L
s
.99625 .36271 m
1 .36271 L
s
.99625 .37914 m
1 .37914 L
s
.99625 .39558 m
1 .39558 L
s
.99625 .42845 m
1 .42845 L
s
.99625 .44489 m
1 .44489 L
s
.99625 .46133 m
1 .46133 L
s
.99625 .47777 m
1 .47777 L
s
.99625 .51064 m
1 .51064 L
s
.99625 .52708 m
1 .52708 L
s
.99625 .54351 m
1 .54351 L
s
.99625 .55995 m
1 .55995 L
s
.99625 .59282 m
1 .59282 L
s
.99625 .60926 m
1 .60926 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 0 r
gsave
.97619 .36222 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .24765 m
.02642 .25412 L
.02903 .24763 L
.03164 .26799 L
.03425 .28627 L
.03686 .27415 L
.03947 .25398 L
.04207 .25624 L
.04468 .27541 L
.04729 .30449 L
.0499 .30073 L
.05251 .30123 L
.05512 .34761 L
.05773 .37945 L
.06034 .38293 L
.06295 .37933 L
.06556 .35639 L
.06817 .35013 L
.07078 .36567 L
.07339 .33876 L
.07599 .34622 L
.0786 .34255 L
.08121 .32105 L
.08382 .32393 L
.08643 .31 L
.08904 .32377 L
.09165 .31639 L
.09426 .29555 L
.09687 .2812 L
.09948 .24541 L
.10209 .24474 L
.1047 .21954 L
.10731 .22683 L
.10992 .2431 L
.11252 .22877 L
.11513 .22777 L
.11774 .21937 L
.12035 .2171 L
.12296 .22935 L
.12557 .23481 L
.12818 .2369 L
.13079 .26447 L
.1334 .25794 L
.13601 .26939 L
.13862 .26795 L
.14123 .24877 L
.14384 .27193 L
.14644 .30974 L
.14905 .30288 L
.15166 .29392 L
Mistroke
.15427 .27524 L
.15688 .28998 L
.15949 .27925 L
.1621 .28845 L
.16471 .27049 L
.16732 .2617 L
.16993 .28696 L
.17254 .28259 L
.17515 .2699 L
.17776 .29153 L
.18037 .25108 L
.18297 .23127 L
.18558 .22606 L
.18819 .19851 L
.1908 .18046 L
.19341 .20679 L
.19602 .19265 L
.19863 .21924 L
.20124 .20451 L
.20385 .22145 L
.20646 .21563 L
.20907 .2099 L
.21168 .22356 L
.21429 .20534 L
.21689 .22931 L
.2195 .23629 L
.22211 .21915 L
.22472 .24974 L
.22733 .21255 L
.22994 .21033 L
.23255 .22397 L
.23516 .22904 L
.23777 .24993 L
.24038 .23374 L
.24299 .21464 L
.2456 .20617 L
.24821 .21126 L
.25082 .20816 L
.25342 .20235 L
.25603 .21621 L
.25864 .21019 L
.26125 .2315 L
.26386 .23468 L
.26647 .23423 L
.26908 .26235 L
.27169 .25304 L
.2743 .25312 L
.27691 .26187 L
.27952 .25583 L
.28213 .27838 L
Mistroke
.28474 .27837 L
.28735 .2635 L
.28995 .24908 L
.29256 .22992 L
.29517 .22472 L
.29778 .21586 L
.30039 .21797 L
.303 .21574 L
.30561 .20501 L
.30822 .21423 L
.31083 .21644 L
.31344 .23113 L
.31605 .22167 L
.31866 .24822 L
.32127 .26924 L
.32387 .24947 L
.32648 .24422 L
.32909 .23836 L
.3317 .25878 L
.33431 .23466 L
.33692 .25643 L
.33953 .25754 L
.34214 .26256 L
.34475 .25409 L
.34736 .23685 L
.34997 .22523 L
.35258 .2278 L
.35519 .2618 L
.3578 .2471 L
.3604 .27119 L
.36301 .27458 L
.36562 .2616 L
.36823 .23643 L
.37084 .26532 L
.37345 .28182 L
.37606 .27983 L
.37867 .27611 L
.38128 .27308 L
.38389 .25924 L
.3865 .24205 L
.38911 .24699 L
.39172 .27246 L
.39432 .29809 L
.39693 .29002 L
.39954 .28635 L
.40215 .28895 L
.40476 .30541 L
.40737 .27828 L
.40998 .27163 L
.41259 .26293 L
Mistroke
.4152 .26969 L
.41781 .28265 L
.42042 .25654 L
.42303 .25114 L
.42564 .27811 L
.42825 .25842 L
.43085 .27851 L
.43346 .29375 L
.43607 .32233 L
.43868 .30341 L
.44129 .32612 L
.4439 .36146 L
.44651 .3775 L
.44912 .37872 L
.45173 .37646 L
.45434 .36403 L
.45695 .36985 L
.45956 .40065 L
.46217 .41386 L
.46477 .41101 L
.46738 .43801 L
.46999 .41492 L
.4726 .42 L
.47521 .41423 L
.47782 .4148 L
.48043 .45086 L
.48304 .45192 L
.48565 .45992 L
.48826 .46426 L
.49087 .4524 L
.49348 .48339 L
.49609 .44471 L
.4987 .39735 L
.5013 .40892 L
.50391 .40288 L
.50652 .39228 L
.50913 .37738 L
.51174 .38884 L
.51435 .41363 L
.51696 .40233 L
.51957 .41888 L
.52218 .37722 L
.52479 .38637 L
.5274 .42739 L
.53001 .42831 L
.53262 .44621 L
.53523 .45244 L
.53783 .47502 L
.54044 .48768 L
.54305 .48977 L
Mistroke
.54566 .46021 L
.54827 .45887 L
.55088 .4785 L
.55349 .49515 L
.5561 .52375 L
.55871 .53185 L
.56132 .53355 L
.56393 .54069 L
.56654 .51441 L
.56915 .50818 L
.57175 .467 L
.57436 .48153 L
.57697 .50792 L
.57958 .5451 L
.58219 .55304 L
.5848 .5392 L
.58741 .54899 L
.59002 .54379 L
.59263 .55569 L
.59524 .57025 L
.59785 .55776 L
.60046 .54053 L
.60307 .53629 L
.60568 .50385 L
.60828 .52451 L
.61089 .5205 L
.6135 .54541 L
.61611 .51515 L
.61872 .49007 L
.62133 .47477 L
.62394 .47803 L
.62655 .49179 L
.62916 .48159 L
.63177 .49257 L
.63438 .49777 L
.63699 .51756 L
.6396 .50793 L
.6422 .49452 L
.64481 .51149 L
.64742 .5229 L
.65003 .48982 L
.65264 .51129 L
.65525 .49695 L
.65786 .48327 L
.66047 .49718 L
.66308 .51714 L
.66569 .50697 L
.6683 .53415 L
.67091 .5464 L
.67352 .55494 L
Mistroke
.67613 .54854 L
.67873 .51469 L
.68134 .53158 L
.68395 .51028 L
.68656 .50635 L
.68917 .51463 L
.69178 .48831 L
.69439 .48755 L
.697 .51824 L
.69961 .53817 L
.70222 .50544 L
.70483 .49289 L
.70744 .4827 L
.71005 .48658 L
.71265 .47835 L
.71526 .48772 L
.71787 .46506 L
.72048 .45655 L
.72309 .4462 L
.7257 .42795 L
.72831 .44462 L
.73092 .4579 L
.73353 .47743 L
.73614 .48486 L
.73875 .46439 L
.74136 .45276 L
.74397 .44828 L
.74658 .4642 L
.74918 .47665 L
.75179 .48409 L
.7544 .51023 L
.75701 .52108 L
.75962 .53796 L
.76223 .52202 L
.76484 .51549 L
.76745 .48891 L
.77006 .47438 L
.77267 .48514 L
.77528 .5209 L
.77789 .55524 L
.7805 .57621 L
.78311 .54379 L
.78571 .53368 L
.78832 .56528 L
.79093 .56381 L
.79354 .55578 L
.79615 .55139 L
.79876 .54741 L
.80137 .54835 L
.80398 .58061 L
Mistroke
.80659 .58194 L
.8092 .57858 L
.81181 .56169 L
.81442 .59348 L
.81703 .57005 L
.81963 .57049 L
.82224 .58547 L
.82485 .578 L
.82746 .58866 L
.83007 .58239 L
.83268 .58305 L
.83529 .57957 L
.8379 .57612 L
.84051 .5948 L
.84312 .58212 L
.84573 .58619 L
.84834 .60309 L
.85095 .60332 L
.85356 .59987 L
.85616 .5912 L
.85877 .56269 L
.86138 .57985 L
.86399 .56955 L
.8666 .54411 L
.86921 .53013 L
.87182 .52063 L
.87443 .50369 L
.87704 .49013 L
.87965 .48235 L
.88226 .47703 L
.88487 .46664 L
.88748 .49259 L
.89008 .4894 L
.89269 .51004 L
.8953 .52141 L
.89791 .49275 L
.90052 .49758 L
.90313 .4874 L
.90574 .47953 L
.90835 .4935 L
.91096 .44654 L
.91357 .4475 L
.91618 .43361 L
.91879 .44526 L
.9214 .4624 L
.92401 .45749 L
.92661 .46551 L
.92922 .44214 L
.93183 .42901 L
.93444 .45292 L
Mistroke
.93705 .45833 L
.93966 .43599 L
.94227 .43838 L
.94488 .44859 L
.94749 .44222 L
.9501 .44909 L
.95271 .45117 L
.95532 .42371 L
.95793 .42456 L
.96053 .40612 L
.96314 .41924 L
.96575 .38902 L
.96836 .38466 L
.97097 .36858 L
.97358 .35059 L
.97619 .36222 L
Mfstroke
0 0 1 r
gsave
.97619 .24855 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24765 m
.02642 .24765 L
.02903 .24765 L
.03164 .24765 L
.03425 .24765 L
.03686 .24765 L
.03947 .24765 L
.04207 .24627 L
.04468 .24628 L
.04729 .24628 L
.0499 .24629 L
.05251 .24629 L
.05512 .24629 L
.05773 .2463 L
.06034 .24509 L
.06295 .2451 L
.06556 .24511 L
.06817 .24511 L
.07078 .24512 L
.07339 .24513 L
.07599 .24513 L
.0786 .2448 L
.08121 .2448 L
.08382 .24481 L
.08643 .24482 L
.08904 .24483 L
.09165 .24484 L
.09426 .24484 L
.09687 .24318 L
.09948 .2432 L
.10209 .24321 L
.1047 .24322 L
.10731 .24323 L
.10992 .24324 L
.11252 .24326 L
.11513 .24252 L
.11774 .24254 L
.12035 .24255 L
.12296 .24257 L
.12557 .24258 L
.12818 .24259 L
.13079 .24261 L
.1334 .24238 L
.13601 .2424 L
.13862 .24241 L
.14123 .24243 L
.14384 .24244 L
.14644 .24245 L
.14905 .24247 L
.15166 .24505 L
Mistroke
.15427 .24506 L
.15688 .24506 L
.15949 .24507 L
.1621 .24508 L
.16471 .24509 L
.16732 .24509 L
.16993 .24543 L
.17254 .24544 L
.17515 .24544 L
.17776 .24545 L
.18037 .24545 L
.18297 .24546 L
.18558 .24547 L
.18819 .2465 L
.1908 .2465 L
.19341 .2465 L
.19602 .24651 L
.19863 .24651 L
.20124 .24651 L
.20385 .24652 L
.20646 .24916 L
.20907 .24916 L
.21168 .24915 L
.21429 .24915 L
.21689 .24915 L
.2195 .24914 L
.22211 .24914 L
.22472 .24907 L
.22733 .24907 L
.22994 .24906 L
.23255 .24906 L
.23516 .24905 L
.23777 .24905 L
.24038 .24905 L
.24299 .24921 L
.2456 .24921 L
.24821 .2492 L
.25082 .2492 L
.25342 .2492 L
.25603 .24919 L
.25864 .24919 L
.26125 .24903 L
.26386 .24903 L
.26647 .24903 L
.26908 .24902 L
.27169 .24902 L
.2743 .24901 L
.27691 .24901 L
.27952 .25002 L
.28213 .25001 L
Mistroke
.28474 .25 L
.28735 .25 L
.28995 .24999 L
.29256 .24999 L
.29517 .24998 L
.29778 .25016 L
.30039 .25015 L
.303 .25014 L
.30561 .25013 L
.30822 .25013 L
.31083 .25012 L
.31344 .25011 L
.31605 .24879 L
.31866 .24878 L
.32127 .24878 L
.32387 .24878 L
.32648 .24878 L
.32909 .24877 L
.3317 .24877 L
.33431 .2485 L
.33692 .2485 L
.33953 .24849 L
.34214 .24849 L
.34475 .24849 L
.34736 .24849 L
.34997 .24849 L
.35258 .24683 L
.35519 .24684 L
.3578 .24684 L
.3604 .24684 L
.36301 .24684 L
.36562 .24684 L
.36823 .24685 L
.37084 .24695 L
.37345 .24695 L
.37606 .24695 L
.37867 .24695 L
.38128 .24696 L
.38389 .24696 L
.3865 .24696 L
.38911 .25011 L
.39172 .2501 L
.39432 .25009 L
.39693 .25009 L
.39954 .25008 L
.40215 .25007 L
.40476 .25007 L
.40737 .25045 L
.40998 .25044 L
.41259 .25044 L
Mistroke
.4152 .25043 L
.41781 .25042 L
.42042 .25041 L
.42303 .25041 L
.42564 .24957 L
.42825 .24956 L
.43085 .24956 L
.43346 .24955 L
.43607 .24955 L
.43868 .24954 L
.44129 .24954 L
.4439 .25083 L
.44651 .25082 L
.44912 .25081 L
.45173 .2508 L
.45434 .25079 L
.45695 .25078 L
.45956 .25077 L
.46217 .25073 L
.46477 .25072 L
.46738 .25072 L
.46999 .25071 L
.4726 .2507 L
.47521 .25069 L
.47782 .25068 L
.48043 .24794 L
.48304 .24794 L
.48565 .24794 L
.48826 .24794 L
.49087 .24794 L
.49348 .24794 L
.49609 .24794 L
.4987 .248 L
.5013 .248 L
.50391 .248 L
.50652 .248 L
.50913 .248 L
.51174 .248 L
.51435 .248 L
.51696 .24736 L
.51957 .24736 L
.52218 .24736 L
.52479 .24736 L
.5274 .24736 L
.53001 .24736 L
.53262 .24736 L
.53523 .25033 L
.53783 .25032 L
.54044 .25031 L
.54305 .2503 L
Mistroke
.54566 .2503 L
.54827 .25029 L
.55088 .25028 L
.55349 .25305 L
.5561 .25304 L
.55871 .25302 L
.56132 .25301 L
.56393 .253 L
.56654 .25298 L
.56915 .25297 L
.57175 .25985 L
.57436 .25981 L
.57697 .25978 L
.57958 .25975 L
.58219 .25971 L
.5848 .25968 L
.58741 .25965 L
.59002 .25694 L
.59263 .25692 L
.59524 .25689 L
.59785 .25687 L
.60046 .25684 L
.60307 .25682 L
.60568 .25679 L
.60828 .25248 L
.61089 .25247 L
.6135 .25245 L
.61611 .25244 L
.61872 .25243 L
.62133 .25242 L
.62394 .2524 L
.62655 .24994 L
.62916 .24993 L
.63177 .24993 L
.63438 .24992 L
.63699 .24991 L
.6396 .24991 L
.6422 .2499 L
.64481 .2474 L
.64742 .2474 L
.65003 .2474 L
.65264 .2474 L
.65525 .2474 L
.65786 .2474 L
.66047 .2474 L
.66308 .24126 L
.66569 .24128 L
.6683 .24129 L
.67091 .24131 L
.67352 .24133 L
Mistroke
.67613 .24135 L
.67873 .24136 L
.68134 .24608 L
.68395 .24608 L
.68656 .24609 L
.68917 .24609 L
.69178 .24609 L
.69439 .2461 L
.697 .2461 L
.69961 .23645 L
.70222 .23648 L
.70483 .23651 L
.70744 .23654 L
.71005 .23657 L
.71265 .2366 L
.71526 .23663 L
.71787 .2376 L
.72048 .23763 L
.72309 .23766 L
.7257 .23768 L
.72831 .23771 L
.73092 .23774 L
.73353 .23776 L
.73614 .24554 L
.73875 .24554 L
.74136 .24555 L
.74397 .24556 L
.74658 .24556 L
.74918 .24557 L
.75179 .24557 L
.7544 .23998 L
.75701 .24 L
.75962 .24002 L
.76223 .24004 L
.76484 .24006 L
.76745 .24008 L
.77006 .2401 L
.77267 .24099 L
.77528 .24101 L
.77789 .24103 L
.7805 .24104 L
.78311 .24106 L
.78571 .24108 L
.78832 .2411 L
.79093 .23518 L
.79354 .23521 L
.79615 .23525 L
.79876 .23528 L
.80137 .23532 L
.80398 .23535 L
Mistroke
.80659 .23538 L
.8092 .24316 L
.81181 .24317 L
.81442 .24318 L
.81703 .24319 L
.81963 .2432 L
.82224 .24322 L
.82485 .24323 L
.82746 .24008 L
.83007 .2401 L
.83268 .24012 L
.83529 .24014 L
.8379 .24016 L
.84051 .24019 L
.84312 .24021 L
.84573 .24695 L
.84834 .24695 L
.85095 .24695 L
.85356 .24696 L
.85616 .24696 L
.85877 .24696 L
.86138 .24696 L
.86399 .2477 L
.8666 .2477 L
.86921 .2477 L
.87182 .2477 L
.87443 .2477 L
.87704 .2477 L
.87965 .2477 L
.88226 .23962 L
.88487 .23964 L
.88748 .23966 L
.89008 .23968 L
.89269 .2397 L
.8953 .23973 L
.89791 .23975 L
.90052 .24607 L
.90313 .24607 L
.90574 .24608 L
.90835 .24608 L
.91096 .24608 L
.91357 .24609 L
.91618 .24609 L
.91879 .24961 L
.9214 .2496 L
.92401 .2496 L
.92661 .24959 L
.92922 .24959 L
.93183 .24958 L
.93444 .24958 L
Mistroke
.93705 .24921 L
.93966 .24921 L
.94227 .24921 L
.94488 .2492 L
.94749 .2492 L
.9501 .24919 L
.95271 .24919 L
.95532 .25089 L
.95793 .25088 L
.96053 .25087 L
.96314 .25086 L
.96575 .25085 L
.96836 .25084 L
.97097 .25083 L
.97358 .24855 L
.97619 .24855 L
Mfstroke
0 .98 .604 r
gsave
.97619 .47265 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41202 m
.02642 .41247 L
.02903 .41292 L
.03164 .41336 L
.03425 .4138 L
.03686 .41423 L
.03947 .41467 L
.04207 .41371 L
.04468 .41414 L
.04729 .41456 L
.0499 .41499 L
.05251 .41541 L
.05512 .41582 L
.05773 .41623 L
.06034 .41542 L
.06295 .41583 L
.06556 .41624 L
.06817 .41664 L
.07078 .41704 L
.07339 .41744 L
.07599 .41783 L
.0786 .41787 L
.08121 .41826 L
.08382 .41864 L
.08643 .41903 L
.08904 .41941 L
.09165 .41978 L
.09426 .42016 L
.09687 .41885 L
.09948 .41922 L
.10209 .41959 L
.1047 .41996 L
.10731 .42033 L
.10992 .42069 L
.11252 .42105 L
.11513 .42065 L
.11774 .42101 L
.12035 .42136 L
.12296 .42172 L
.12557 .42207 L
.12818 .42241 L
.13079 .42276 L
.1334 .42285 L
.13601 .42319 L
.13862 .42353 L
.14123 .42386 L
.14384 .4242 L
.14644 .42453 L
.14905 .42486 L
.15166 .42773 L
Mistroke
.15427 .42805 L
.15688 .42837 L
.15949 .42868 L
.1621 .42899 L
.16471 .4293 L
.16732 .4296 L
.16993 .43022 L
.17254 .43052 L
.17515 .43082 L
.17776 .43112 L
.18037 .43142 L
.18297 .43171 L
.18558 .432 L
.18819 .4333 L
.1908 .43358 L
.19341 .43386 L
.19602 .43414 L
.19863 .43442 L
.20124 .4347 L
.20385 .43497 L
.20646 .43787 L
.20907 .43814 L
.21168 .4384 L
.21429 .43866 L
.21689 .43892 L
.2195 .43917 L
.22211 .43943 L
.22472 .4396 L
.22733 .43985 L
.22994 .4401 L
.23255 .44035 L
.23516 .4406 L
.23777 .44084 L
.24038 .44108 L
.24299 .44148 L
.2456 .44172 L
.24821 .44196 L
.25082 .44219 L
.25342 .44243 L
.25603 .44266 L
.25864 .44289 L
.26125 .44295 L
.26386 .44318 L
.26647 .44341 L
.26908 .44363 L
.27169 .44386 L
.2743 .44408 L
.27691 .4443 L
.27952 .44552 L
.28213 .44573 L
Mistroke
.28474 .44595 L
.28735 .44616 L
.28995 .44637 L
.29256 .44658 L
.29517 .44679 L
.29778 .44716 L
.30039 .44736 L
.303 .44757 L
.30561 .44777 L
.30822 .44797 L
.31083 .44817 L
.31344 .44837 L
.31605 .44723 L
.31866 .44743 L
.32127 .44763 L
.32387 .44783 L
.32648 .44802 L
.32909 .44822 L
.3317 .44841 L
.33431 .44831 L
.33692 .44851 L
.33953 .4487 L
.34214 .44889 L
.34475 .44907 L
.34736 .44926 L
.34997 .44945 L
.35258 .44796 L
.35519 .44815 L
.3578 .44834 L
.3604 .44852 L
.36301 .44871 L
.36562 .44889 L
.36823 .44907 L
.37084 .44933 L
.37345 .44951 L
.37606 .44969 L
.37867 .44987 L
.38128 .45004 L
.38389 .45022 L
.3865 .45039 L
.38911 .45369 L
.39172 .45385 L
.39432 .45402 L
.39693 .45418 L
.39954 .45434 L
.40215 .4545 L
.40476 .45465 L
.40737 .45518 L
.40998 .45534 L
.41259 .45549 L
Mistroke
.4152 .45564 L
.41781 .4558 L
.42042 .45595 L
.42303 .4561 L
.42564 .4554 L
.42825 .45555 L
.43085 .4557 L
.43346 .45585 L
.43607 .45599 L
.43868 .45614 L
.44129 .45629 L
.4439 .4577 L
.44651 .45784 L
.44912 .45798 L
.45173 .45812 L
.45434 .45826 L
.45695 .4584 L
.45956 .45853 L
.46217 .45862 L
.46477 .45875 L
.46738 .45888 L
.46999 .45902 L
.4726 .45915 L
.47521 .45928 L
.47782 .45941 L
.48043 .45679 L
.48304 .45692 L
.48565 .45706 L
.48826 .4572 L
.49087 .45733 L
.49348 .45746 L
.49609 .4576 L
.4987 .45777 L
.5013 .4579 L
.50391 .45803 L
.50652 .45816 L
.50913 .45829 L
.51174 .45841 L
.51435 .45854 L
.51696 .45801 L
.51957 .45813 L
.52218 .45826 L
.52479 .45839 L
.5274 .45851 L
.53001 .45864 L
.53262 .45876 L
.53523 .46182 L
.53783 .46194 L
.54044 .46205 L
.54305 .46216 L
Mistroke
.54566 .46227 L
.54827 .46238 L
.55088 .46249 L
.55349 .46536 L
.5561 .46546 L
.55871 .46556 L
.56132 .46566 L
.56393 .46576 L
.56654 .46586 L
.56915 .46596 L
.57175 .47293 L
.57436 .47301 L
.57697 .47309 L
.57958 .47316 L
.58219 .47324 L
.5848 .47332 L
.58741 .47339 L
.59002 .47077 L
.59263 .47085 L
.59524 .47093 L
.59785 .47101 L
.60046 .47109 L
.60307 .47117 L
.60568 .47125 L
.60828 .46702 L
.61089 .46711 L
.6135 .4672 L
.61611 .46729 L
.61872 .46738 L
.62133 .46746 L
.62394 .46755 L
.62655 .46516 L
.62916 .46526 L
.63177 .46535 L
.63438 .46544 L
.63699 .46553 L
.6396 .46562 L
.6422 .46571 L
.64481 .46328 L
.64742 .46337 L
.65003 .46347 L
.65264 .46356 L
.65525 .46366 L
.65786 .46375 L
.66047 .46384 L
.66308 .45777 L
.66569 .45788 L
.6683 .45799 L
.67091 .45809 L
.67352 .4582 L
Mistroke
.67613 .45831 L
.67873 .45841 L
.68134 .46319 L
.68395 .46328 L
.68656 .46337 L
.68917 .46347 L
.69178 .46356 L
.69439 .46365 L
.697 .46374 L
.69961 .45414 L
.70222 .45426 L
.70483 .45437 L
.70744 .45448 L
.71005 .4546 L
.71265 .45471 L
.71526 .45482 L
.71787 .45585 L
.72048 .45596 L
.72309 .45607 L
.7257 .45617 L
.72831 .45628 L
.73092 .45639 L
.73353 .45649 L
.73614 .46432 L
.73875 .46441 L
.74136 .46449 L
.74397 .46457 L
.74658 .46465 L
.74918 .46474 L
.75179 .46482 L
.7544 .45927 L
.75701 .45937 L
.75962 .45946 L
.76223 .45956 L
.76484 .45965 L
.76745 .45975 L
.77006 .45984 L
.77267 .46078 L
.77528 .46087 L
.77789 .46096 L
.7805 .46105 L
.78311 .46114 L
.78571 .46122 L
.78832 .46131 L
.79093 .45544 L
.79354 .45554 L
.79615 .45565 L
.79876 .45575 L
.80137 .45585 L
.80398 .45595 L
Mistroke
.80659 .45605 L
.8092 .46387 L
.81181 .46395 L
.81442 .46402 L
.81703 .4641 L
.81963 .46418 L
.82224 .46426 L
.82485 .46434 L
.82746 .46123 L
.83007 .46131 L
.83268 .4614 L
.83529 .46148 L
.8379 .46157 L
.84051 .46165 L
.84312 .46173 L
.84573 .46851 L
.84834 .46858 L
.85095 .46864 L
.85356 .4687 L
.85616 .46877 L
.85877 .46883 L
.86138 .46889 L
.86399 .46966 L
.8666 .46972 L
.86921 .46978 L
.87182 .46984 L
.87443 .4699 L
.87704 .46996 L
.87965 .47001 L
.88226 .46196 L
.88487 .46204 L
.88748 .46212 L
.89008 .4622 L
.89269 .46228 L
.8953 .46236 L
.89791 .46244 L
.90052 .46878 L
.90313 .46884 L
.90574 .4689 L
.90835 .46896 L
.91096 .46902 L
.91357 .46908 L
.91618 .46914 L
.91879 .47268 L
.9214 .47273 L
.92401 .47278 L
.92661 .47282 L
.92922 .47287 L
.93183 .47292 L
.93444 .47297 L
Mistroke
.93705 .47263 L
.93966 .47267 L
.94227 .47272 L
.94488 .47277 L
.94749 .47281 L
.9501 .47286 L
.95271 .4729 L
.95532 .47463 L
.95793 .47467 L
.96053 .47471 L
.96314 .47475 L
.96575 .47479 L
.96836 .47483 L
.97097 .47487 L
.97358 .47261 L
.97619 .47265 L
Mfstroke
gsave
.97619 .02445 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .08328 m
.02642 .08283 L
.02903 .08239 L
.03164 .08194 L
.03425 .0815 L
.03686 .08107 L
.03947 .08063 L
.04207 .07884 L
.04468 .07842 L
.04729 .078 L
.0499 .07759 L
.05251 .07717 L
.05512 .07677 L
.05773 .07636 L
.06034 .07476 L
.06295 .07437 L
.06556 .07397 L
.06817 .07358 L
.07078 .0732 L
.07339 .07281 L
.07599 .07243 L
.0786 .07173 L
.08121 .07135 L
.08382 .07098 L
.08643 .07061 L
.08904 .07025 L
.09165 .06989 L
.09426 .06953 L
.09687 .06752 L
.09948 .06717 L
.10209 .06682 L
.1047 .06648 L
.10731 .06614 L
.10992 .0658 L
.11252 .06546 L
.11513 .0644 L
.11774 .06407 L
.12035 .06374 L
.12296 .06342 L
.12557 .06309 L
.12818 .06278 L
.13079 .06246 L
.1334 .06192 L
.13601 .06161 L
.13862 .0613 L
.14123 .06099 L
.14384 .06069 L
.14644 .06038 L
.14905 .06008 L
.15166 .06237 L
Mistroke
.15427 .06206 L
.15688 .06176 L
.15949 .06146 L
.1621 .06117 L
.16471 .06087 L
.16732 .06058 L
.16993 .06064 L
.17254 .06035 L
.17515 .06006 L
.17776 .05978 L
.18037 .05949 L
.18297 .05921 L
.18558 .05893 L
.18819 .0597 L
.1908 .05942 L
.19341 .05914 L
.19602 .05887 L
.19863 .0586 L
.20124 .05833 L
.20385 .05806 L
.20646 .06045 L
.20907 .06018 L
.21168 .05991 L
.21429 .05964 L
.21689 .05937 L
.2195 .05911 L
.22211 .05885 L
.22472 .05854 L
.22733 .05828 L
.22994 .05802 L
.23255 .05777 L
.23516 .05751 L
.23777 .05726 L
.24038 .05701 L
.24299 .05695 L
.2456 .0567 L
.24821 .05645 L
.25082 .05621 L
.25342 .05596 L
.25603 .05572 L
.25864 .05548 L
.26125 .05511 L
.26386 .05488 L
.26647 .05464 L
.26908 .05441 L
.27169 .05418 L
.2743 .05395 L
.27691 .05372 L
.27952 .05452 L
.28213 .05429 L
Mistroke
.28474 .05406 L
.28735 .05384 L
.28995 .05361 L
.29256 .05339 L
.29517 .05317 L
.29778 .05315 L
.30039 .05293 L
.303 .05271 L
.30561 .0525 L
.30822 .05228 L
.31083 .05207 L
.31344 .05186 L
.31605 .05035 L
.31866 .05014 L
.32127 .04994 L
.32387 .04973 L
.32648 .04953 L
.32909 .04933 L
.3317 .04913 L
.33431 .04868 L
.33692 .04849 L
.33953 .04829 L
.34214 .0481 L
.34475 .04791 L
.34736 .04771 L
.34997 .04752 L
.35258 .04571 L
.35519 .04552 L
.3578 .04534 L
.3604 .04516 L
.36301 .04498 L
.36562 .0448 L
.36823 .04462 L
.37084 .04457 L
.37345 .04439 L
.37606 .04422 L
.37867 .04404 L
.38128 .04387 L
.38389 .0437 L
.3865 .04353 L
.38911 .04653 L
.39172 .04635 L
.39432 .04617 L
.39693 .046 L
.39954 .04582 L
.40215 .04565 L
.40476 .04548 L
.40737 .04572 L
.40998 .04555 L
.41259 .04538 L
Mistroke
.4152 .04521 L
.41781 .04505 L
.42042 .04488 L
.42303 .04472 L
.42564 .04374 L
.42825 .04358 L
.43085 .04342 L
.43346 .04326 L
.43607 .0431 L
.43868 .04295 L
.44129 .04279 L
.4439 .04395 L
.44651 .04379 L
.44912 .04363 L
.45173 .04348 L
.45434 .04332 L
.45695 .04317 L
.45956 .04301 L
.46217 .04285 L
.46477 .0427 L
.46738 .04255 L
.46999 .0424 L
.4726 .04225 L
.47521 .0421 L
.47782 .04195 L
.48043 .0391 L
.48304 .03896 L
.48565 .03882 L
.48826 .03869 L
.49087 .03855 L
.49348 .03842 L
.49609 .03828 L
.4987 .03824 L
.5013 .0381 L
.50391 .03797 L
.50652 .03784 L
.50913 .03771 L
.51174 .03758 L
.51435 .03745 L
.51696 .03671 L
.51957 .03658 L
.52218 .03646 L
.52479 .03633 L
.5274 .03621 L
.53001 .03609 L
.53262 .03597 L
.53523 .03883 L
.53783 .0387 L
.54044 .03857 L
.54305 .03845 L
Mistroke
.54566 .03832 L
.54827 .03819 L
.55088 .03807 L
.55349 .04075 L
.5561 .04062 L
.55871 .04049 L
.56132 .04036 L
.56393 .04023 L
.56654 .0401 L
.56915 .03997 L
.57175 .04677 L
.57436 .04662 L
.57697 .04648 L
.57958 .04633 L
.58219 .04619 L
.5848 .04605 L
.58741 .04591 L
.59002 .04312 L
.59263 .04298 L
.59524 .04285 L
.59785 .04272 L
.60046 .04259 L
.60307 .04246 L
.60568 .04233 L
.60828 .03794 L
.61089 .03783 L
.6135 .03771 L
.61611 .03759 L
.61872 .03748 L
.62133 .03737 L
.62394 .03725 L
.62655 .03471 L
.62916 .03461 L
.63177 .0345 L
.63438 .0344 L
.63699 .0343 L
.6396 .03419 L
.6422 .03409 L
.64481 .03152 L
.64742 .03142 L
.65003 .03133 L
.65264 .03123 L
.65525 .03114 L
.65786 .03105 L
.66047 .03096 L
.66308 .02475 L
.66569 .02468 L
.6683 .0246 L
.67091 .02453 L
.67352 .02446 L
Mistroke
.67613 .02439 L
.67873 .02431 L
.68134 .02896 L
.68395 .02888 L
.68656 .0288 L
.68917 .02871 L
.69178 .02863 L
.69439 .02855 L
.697 .02847 L
.69961 .01875 L
.70222 .0187 L
.70483 .01865 L
.70744 .01859 L
.71005 .01854 L
.71265 .01849 L
.71526 .01844 L
.71787 .01935 L
.72048 .0193 L
.72309 .01924 L
.7257 .01919 L
.72831 .01914 L
.73092 .01909 L
.73353 .01903 L
.73614 .02675 L
.73875 .02668 L
.74136 .02661 L
.74397 .02654 L
.74658 .02647 L
.74918 .0264 L
.75179 .02633 L
.7544 .02068 L
.75701 .02063 L
.75962 .02057 L
.76223 .02052 L
.76484 .02047 L
.76745 .02041 L
.77006 .02036 L
.77267 .0212 L
.77528 .02115 L
.77789 .0211 L
.7805 .02104 L
.78311 .02099 L
.78571 .02094 L
.78832 .02088 L
.79093 .01492 L
.79354 .01489 L
.79615 .01485 L
.79876 .01482 L
.80137 .01478 L
.80398 .01475 L
Mistroke
.80659 .01472 L
.8092 .02244 L
.81181 .02239 L
.81442 .02234 L
.81703 .02228 L
.81963 .02223 L
.82224 .02217 L
.82485 .02212 L
.82746 .01894 L
.83007 .01889 L
.83268 .01885 L
.83529 .01881 L
.8379 .01876 L
.84051 .01872 L
.84312 .01868 L
.84573 .02539 L
.84834 .02533 L
.85095 .02527 L
.85356 .02521 L
.85616 .02515 L
.85877 .02509 L
.86138 .02503 L
.86399 .02573 L
.8666 .02567 L
.86921 .02561 L
.87182 .02556 L
.87443 .0255 L
.87704 .02544 L
.87965 .02538 L
.88226 .01727 L
.88487 .01723 L
.88748 .0172 L
.89008 .01716 L
.89269 .01713 L
.8953 .01709 L
.89791 .01706 L
.90052 .02335 L
.90313 .0233 L
.90574 .02325 L
.90835 .0232 L
.91096 .02315 L
.91357 .0231 L
.91618 .02305 L
.91879 .02654 L
.9214 .02648 L
.92401 .02642 L
.92661 .02636 L
.92922 .0263 L
.93183 .02625 L
.93444 .02619 L
Mistroke
.93705 .0258 L
.93966 .02575 L
.94227 .02569 L
.94488 .02564 L
.94749 .02558 L
.9501 .02553 L
.95271 .02547 L
.95532 .02715 L
.95793 .02709 L
.96053 .02703 L
.96314 .02697 L
.96575 .02692 L
.96836 .02686 L
.97097 .0268 L
.97358 .0245 L
.97619 .02445 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{803.312, 248.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000<S0000n2000`400?l00000o`00003oo`3ooooo
0?ooool0oooo9P3oool00?l0ooooo`3ooooo0?ooobH0oooo003o0?ooool0ooooo`3ooolV0?ooo`00
o`3ooooo0?ooool0oooo9P3oool00?l0ooooo`3ooooo0?ooobH0oooo003o0?ooool0ooooo`3ooolV
0?ooo`00o`3ooooo0?ooool0oooo9P3oool00?l0ooooo`3ooooo0?ooobH0oooo003o0?ooool0oooo
o`3ooolV0?ooo`00E`3oool2000002@0oooo0`0000040?ooo`8000007@3oool3000000@0oooo0P00
00040?ooo`8000006`3oool3000000<0oooo0`0000040?ooo`8000006P3oool5000000<0oooo0P00
00040?ooo`8000006P3oool500000080oooo0`0000040?ooo`8000006`3oool3000000@0oooo0P00
00040?ooo`8000006P3oool3000000<0oooo0`0000040?ooo`800000<03oool2000002@0oooo0`00
00040?ooo`8000007P3oool3000000@0oooo0P0000040?ooo`8000006`3oool3000000<0oooo0`00
00040?ooo`8000006@3oool5000000<0oooo0P0000040?ooo`8000006P3oool500000080oooo0`00
00040?ooo`8000006`3oool3000000@0oooo0P0000040?ooo`8000006`3oool3000000<0oooo0`00
00040?ooo`800000@`3oool005H0oooo00@000000?ooo`3oool000008P3oool01@000000oooo0?oo
o`3oool000000080oooo00@000000?ooo`3oool000007@3oool00`000000oooo0?ooo`020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000006`3oool01@000000oooo0?ooo`3o
ool0000000<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0H0?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000J
0?ooo`060000003oool0oooo0000003oool000000`3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0oooo01L0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000603oool01`000000oooo0?ooo`3oool000000?ooo`00
00000`3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo02`0oooo00@000000?oo
o`3oool000008P3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000
7P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000006`3oool01@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`0G0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000J0?ooo`060000003oool0oooo0000003oool000000`3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01L0oooo00D000000?ooo`3oool0
oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000006@3oool0
1`000000oooo0?ooo`3oool000000?ooo`0000000`3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0oooo0400oooo001F0?ooo`040000003oool0oooo000002H0oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000K0?ooo`030000003oool0oooo00D0oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0080oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000K0?ooo`030000003oool0oooo
00D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0K0?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0/0?ooo`04
0000003oool0oooo000002H0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0L
0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000K0?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000K0?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`0K0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`100?ooo`00EP3oool010000000oooo0?ooo`00000V0?oo
o`040000003oool0oooo00000080oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`02
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000006`3oool00`000000oooo
0?ooo`050?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool06P3oool01@000000
oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0J
0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?oo
o`0I0?ooo`8000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001X0
oooo0P0000060?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0;03oool01000
0000oooo0?ooo`00000V0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00006`3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool06@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`0I0?ooo`8000000`3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000001/0oooo0P0000060?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool0@03oool005H0oooo00@000000?ooo`3oool000008P3oool4000000<0oooo00@00000
0?ooo`3oool000007@3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000006`3oool010000000oooo0?ooo`3oool4000000<0oooo00@000000?oo
o`3oool000006@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`00000I0?ooo`060000003oool0oooo0?ooo`000000oooo10000003
0?ooo`040000003oool0oooo000001d0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`030000003oool0oooo01X0oooo00<000000?ooo`0000000`0000030?ooo`04
0000003oool0oooo000002h0oooo00@000000?ooo`3oool000008P3oool4000000<0oooo00@00000
0?ooo`3oool000007P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000006`3oool010000000oooo0?ooo`3oool4000000<0oooo00@000000?oo
o`3oool00000603oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`00000I0?ooo`060000003oool0oooo0?ooo`000000oooo10000003
0?ooo`040000003oool0oooo000001d0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`030000003oool0oooo01/0oooo00<000000?ooo`0000000`0000030?ooo`04
0000003oool0oooo00000480oooo001F0?ooo`040000003oool0oooo00000280oooo00<000000?oo
o`3oool0103oool010000000oooo0?ooo`00000L0?ooo`800000103oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo000001X0oooo0P0000030?ooo`030000003oool0oooo00@0oooo
00@000000?ooo`3oool000006@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`00000I0?ooo`070000003oool0oooo0?ooo`000000
oooo000000060?ooo`040000003oool0oooo000001T0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000603oool01`000000oooo
0?ooo`3oool000000?ooo`0000001P3oool010000000oooo0?ooo`00000^0?ooo`040000003oool0
oooo00000280oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`00000M0?ooo`800000
103oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000001X0oooo0P0000030?oo
o`030000003oool0oooo00@0oooo00@000000?ooo`3oool00000603oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000I0?ooo`07
0000003oool0oooo0?ooo`000000oooo000000060?ooo`040000003oool0oooo000001T0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000006@3oool01`000000oooo0?ooo`3oool000000?ooo`0000001P3oool010000000oooo0?oo
o`0000120?ooo`00E`3oool2000002<0oooo1@0000030?ooo`8000007P3oool00`000000oooo0?oo
o`030?ooo`800000103oool2000001`0oooo00@000000?ooo`3oool0oooo1@0000030?ooo`800000
6`3oool3000000@0oooo0P0000040?ooo`8000006`3oool300000080oooo1@0000030?ooo`800000
6`3oool3000000@0oooo0P0000040?ooo`8000006P3oool300000080oooo1@0000030?ooo`800000
<03oool2000002<0oooo1@0000030?ooo`8000007`3oool00`000000oooo0?ooo`030?ooo`800000
103oool2000001`0oooo00@000000?ooo`3oool0oooo1@0000030?ooo`8000006P3oool3000000@0
oooo0P0000040?ooo`8000006`3oool300000080oooo1@0000030?ooo`8000006`3oool3000000@0
oooo0P0000040?ooo`8000006`3oool300000080oooo1@0000030?ooo`800000@`3oool00?l0oooo
o`3ooooo0?ooobH0oooo003o0?ooool0ooooo`3ooolV0?ooo`00o`3ooooo0?ooool0oooo9P3oool0
0?l0ooooU03oool2000000@0oooo00<000000?ooo`3oool00`3oool2000000<0oooo0`00003o0?oo
ogd0oooo003o0?oooi<0oooo00@000000?ooo`3oool00000203oool01P000000oooo0?ooo`000000
oooo000000<0oooo00<000000?ooo`3oool0o`3ooomj0?ooo`00D03ooooo000004@000000P3oool0
0`000000oooo0?ooo`060?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool00`3o
oooo000004800000=@3oool00500oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`05
0?ooo`040000003oool0oooo0?ooo`8000000P3oool00`000000oooo0?ooo`060?ooo`040000003o
ool0oooo000000D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00D0oooo00D000000?ooo`3oool0oooo0000000e0?ooo`00D03oool00`000000oooo
0?ooo`050?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool09P3oool00`000000oooo
0?ooo`0W0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool09`3oool00`000000oooo
0?ooo`0W0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool04P3oool200000080oooo
00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`000000oooo00@000001P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool09`3oool00`000000
oooo0?ooo`0W0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool09`3oool00`000000
oooo0?ooo`0W0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`3o0?ooocl0oooo0P0000020?ooo`030000
003oool0oooo00H0oooo00H000000?ooo`3oool000000?ooo`0000090?ooo`030000003oool0oooo
0?l0oooo?P3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`3o0?ooocl0
oooo00@000000?ooo`00000000002P3oool200000080oooo1@0000050?ooo`030000003oool0oooo
0?l0oooo?P3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`2h0?ooo`80
0?ZJQ03oool00`000000oooo0?ooo`0I0?ooo`800000nP3oool7003jVQH0oooo1`00nYXO0?ooo`80
0000=@3oool00500oooo0P00002i0?ooo`800?ZJPP3oool3000001/0oooo00<000000?ooo`3oool0
g03oool=003jVP@0oooo1`00nYX50?ooo`L00?ZJ1@3oool7003jVPX0oooo1`00nYXP0?ooo`030000
003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0;P0oooo0P00nYZ40?ooo`030000003o
ool0oooo01T0oooo00<000000?ooo`3oool0g03oool=003jVP@0oooo3P00nYX30?ooo`h00?ZJ2@3o
ool3003jVP<0oooo2000nYXJ0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0
oooo0;L0oooo0`00nYZ40?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0d03oool7
003jVP@0oooo0`00nYX90?ooo`P00?ZJ103oool7003jVPD0oooo1`00nYX40?ooo`d00?ZJ1@3ooolC
003jVP80oooo1@00nYX70?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo
0;H0oooo1000nYZ40?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0d03oool=003j
VPX0oooo1`00nYXM0?ooo``00?ZJ2`3ooolD003jVPL0oooo00<000000?ooo`3oool0<`3oool00500
oooo00<000000?ooo`3oool0]P3oool4003jVX@0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`3:0?ooo`P00?ZJ103oool7003jVU40oooo1000nYX;0?ooo`030000003oool0oooo03<0
oooo001@0?ooo`030000003oool0oooo0;D0oooo1@00nYZ40?ooo`030000003oool0oooo01T0oooo
0P00002V0?ooo`<00?ZJ703oool=003jVV/0oooo0P00000e0?ooo`00D03oool200000;<0oooo0P00
0000103oool00?ZJ003jVP3oool2003jVX80oooo0`00000K0?ooo`030000003oool0oooo09H0oooo
6000nYX@0?ooo`d00?ZJLP3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?oo
o`2b0?ooo`8000000`00nYX00`3oool00?ZJ003jVP240?ooo`030000003oool0oooo01T0oooo00<0
00000?ooo`3oool0T@3ooolE003jVP030?ooo`00nYX00?ZJ00/00?ZJ2@3oool8003jVWP0oooo00<0
00000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool0/P3oool2000000800?ZJ0P3oool2
003jVX@0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`1]0?ooo``00?ZJ0`3ooolK
003jVQH0oooo1`00nYX50?ooo`L00?ZJO@3oool00`000000oooo0?ooo`0c0?ooo`00?03oool30000
00<0oooo00<000000?ooo`3oool00P3oool3000000H0oooo00<000000?ooo`3oool0/P3oool20000
00800?ZJ0P3oool2003jVX@0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`1W0?oo
ob`00?ZJ7`3oool<003jVWl0oooo00<000000?ooo`3oool0<`3oool003d0oooo00<000000?ooo`3o
ool01P3oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0/P3oool01000
00000?ZJ003jVP00nYX20?ooo`800?ZJQ03oool00`000000oooo0?ooo`0I0?ooo`800000H@3oool?
003jVPT0oooo2000nYXc0?ooo`L00?ZJPP3oool2000003D0oooo000j0?ooo`D000002`3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo0;80oooo00<00000003jVP00nYX00`3oool2003j
VX@0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`1@0?oooaP00?ZJe@3oool00`00
0000oooo0?ooo`0c0?ooo`00>P3oool010000000oooo0?ooo`00000<0?ooo`030000003oool0oooo
00<0oooo0`00002b0?ooo`0300000000nYX00?ZJ00<0oooo0P00nYZ10?ooo`@000006`3oool00`00
0000oooo0?ooo`0m0?ooo`800?ZJ1P3ooolL003jV]`0oooo00<000000?ooo`3oool0<`3oool003/0
oooo00<000000?ooo`000000203oool4000000H0oooo00<000000?ooo`3oool0/P3oool00`000000
0?ZJ003jVP030?ooo`800?ZJQ03oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo02P0
oooo1@00nYX30?ooob400?ZJk03oool00`000000oooo0?ooo`0c0?ooo`00?03oool2000000P0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2b0?ooo`0300000000nYX00?ZJ00<0oooo
0`00nYZ30?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool08@3ooolU003jV_L0oooo
00<000000?ooo`3oool0<`3oool003d0oooo00<000000?ooo`3oool01P3oool5000000D0oooo00<0
00000?ooo`3oool0/P3oool00`0000000?ZJ003jVP040?ooo`800?ZJ0`3oool2003jVWh0oooo00<0
00000?ooo`3oool06@3oool2000001`0oooo3P00nYX30?ooo`D00?ZJo`3oool<0?ooo`800000=@3o
ool00500oooo00<000000?ooo`3oool0/P3oool00`0000000?ZJ003jVP040?ooo`800?ZJ0`3oool2
003jVWh0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0G0?ooo`/00?ZJo`3ooolL
0?ooo`030000003oool0oooo03<0oooo001@0?ooo`800000/`3oool00`000000003o0000o`050000
o`03003jVP3oool0oooo00<00?ZJO03oool3000001/0oooo00<000000?ooo`3oool04@3oool;003j
V_l0oooo8P3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`2b0?ooo`03
000000000?l0003o00D0003o00<00?ZJ0?ooo`3oool00`00nYYn0?ooo`030000003oool0oooo00D0
oooo0P0000040?ooo`030000003oool0oooo0080oooo0`0000060?ooo`030000003oool0oooo00d0
oooo2`00nY[o0?ooobH0oooo00<000000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool0
/P3oool00`000000003o0000o`030?ooo`80003o00<00?ZJ0?ooo`3oool00`00nYYn0?ooo`030000
003oool0oooo00@0oooo00@000000?ooo`3oool000002@3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo00T0oooo2P00nY[o0?ooob/0oooo00<000000?ooo`3oool0<`3oool00500oooo
00<000000?ooo`3oool0/P3oool00`000000003o0000o`030?ooo`80003o00<00?ZJ0?ooo`00nYX0
0`00nYYn0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000002@3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo2P00nY[o0?oooc00oooo00<000000?ooo`3o
ool0<`3oool00500oooo00<000000?ooo`3oool0/P3oool010000000003o0000o`0000020?ooo`80
003o00<00?ZJ0?ooo`00nYX00`00nYYn0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3o
ool000002@3oool00`000000oooo0?ooo`050?ooo`<000000`3oool7003jV_l0oooo<P3oool30000
03D0oooo001@0?ooo`030000003oool0oooo0;80oooo00@000000000o`000?l000000P3oool20000
o`H00?ZJOP3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo000000T0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`030?ooo`800?ZJo`3oooli0?ooo`030000003oool0
oooo03<0oooo001@0?ooo`800000/`3oool010000000003o0000o`0000020?ooo`80003o0`00nYX0
0`3oool00?ZJ003jVP1l0?ooo`<000001P3oool010000000oooo0?ooo`0000080?ooo`8000001`3o
ool00`000000oooo0?ooo`3o0?oooch0oooo00<000000?ooo`3oool0<`3oool00500oooo00<00000
0?ooo`3oool0/P3oool010000000003o0000o`0000020?ooo`80003o0`00nYX00`3oool00?ZJ003j
VP1n0?ooo`030000003oool0oooo00D0oooo0P00000:0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0o`3oooln0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0
oooo0;80oooo00H000000000o`000?l00?ZJ0?ooo`0000020000o`800?ZJ0P3oool2003jVWh0oooo
00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`3o0?oooch0oooo00<000000?ooo`3oool0
<`3oool00500oooo00<000000?ooo`3oool0/P3oool01000nYX0003o0000o`00nYX2000000<0003o
00<00?ZJ0?ooo`3oool00P00nYYn0?ooo`030000003oool0oooo01T0oooo0P00003o0?oooch0oooo
0P00000e0?ooo`00D03oool00`000000oooo0?ooo`2b0?ooo`04003jVP000?l0003o003jVP<00000
0P000?l00`00nYX0oooo0?ooo`02003jVWh0oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`3o0?oooch0oooo00<000000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool0/P3o
ool00`00nYX0003o0000o`02003jVP8000000P000?l30?ooo`800?ZJOP3oool00`000000oooo0?oo
o`0I0?ooo`030000003oool0oooo0?l0oooo?P3oool00`000000oooo0?ooo`0c0?ooo`00D03oool2
00000;<0oooo00<00?ZJ0000o`000?l00P00nYX200000080003o0`3oool2003jVW`0oooo0`00000K
0?ooo`030000003oool0oooo0?l0oooo?P3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`00
0000oooo0?ooo`2b0?ooo`03003jVP000?l0003o00800?ZJ00@0oooo000000000?l0003o0`3oool2
003jVWh0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`3o0?oooch0oooo00<00000
0?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool0/P3oool00`00nYX0003o0000o`03003j
VP03000000000?l0003o00<0oooo0P00nYYn0?ooo`030000003oool0oooo01T0oooo0P00003o0?oo
och0oooo0P00000e0?ooo`00D03oool00`000000oooo0?ooo`2a0?ooo`0500000000nYX0003o0000
o`3oool00P00nYX00`3oool0003o0000o`030?ooo`800?ZJOP3oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo0?l0oooo?P3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000
oooo0?ooo`2a0?ooo`0500000000nYX0003o0000o`3oool00`00nYX30000o`80oooo0P00nYYn0?oo
o`030000003oool0oooo01T0oooo00<000000?ooo`3oool0o`3oooln0?ooo`030000003oool0oooo
03<0oooo001@0?ooo`800000/P3oool0100000000?ZJ0000o`000?l20?ooo`800?ZJ1`000?ml0?oo
o`<000006`3oool00`000000oooo0?ooo`3o0?oooch0oooo00<000000?ooo`3oool0<`3oool00500
oooo00<000000?ooo`3oool0/@3oool0100000000?ZJ0000o`000?l30?ooo`800?ZJ00<000000000
o`000?l00`000?l00`00nYX0oooo0?ooo`1k0?ooo`030000003oool0oooo01T0oooo00<000000?oo
o`3oool0o`3oooln0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0;40
oooo00@00000003jVP000?l0003o0`3oool2003jVP@000000P000?l00`00nYX0oooo0?ooo`1k0?oo
o`030000003oool0oooo01T0oooo0P00003o0?oooch0oooo0P00000e0?ooo`00D03oool00`000000
oooo0?ooo`2a0?ooo`0400000000nYX0003o0000o`<0oooo0P00nYX400000080003o00<00?ZJ0?oo
o`3oool0N`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0?l0oooo?P3oool00`00
0000oooo0?ooo`0c0?ooo`00=P3oool3000000<0oooo00<000000?ooo`3oool00P3oool3000000<0
oooo0`0000060?ooo`030000003oool0oooo0;40oooo00@000000000o`000?l0003o0`3oool3003j
VP030?ooo`00000000000080003o00<00?ZJ0?ooo`3oool0N`3oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo0?l0oooo?P3oool00`000000oooo0?ooo`0c0?ooo`00=`3oool00`000000
oooo0?ooo`060?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0/@3oool010000000003o0000o`00nYX40?ooo`800?ZJ0P3o
ool010000000003o0000o`00nYYm0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0
o`3oooln0?ooo`030000003oool0oooo03<0oooo000d0?ooo`D000002`3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00<0oooo0`00002a0?ooo`04000000000?l0003o003jVP@0oooo
0P00nYX20?ooo`04000000000?l0003o003jVWX0oooo1000000K0?ooo`030000003oool0oooo0?l0
oooo?P3oool00`000000oooo0?ooo`0c0?ooo`00=03oool010000000oooo0?ooo`00000<0?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2Y0?ooo`80
00001P3oool010000000003o0000o`00nYX40?ooo`800?ZJ0P3oool010000000003o0000o`00nYX3
0?ooo`800?ZJN03oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0?l0oooo?P3oool0
0`000000oooo0?ooo`0c0?ooo`00=@3oool00`000000oooo000000080?ooo`@000000P3oool40000
00H0oooo00<000000?ooo`3oool0Z@3oool2000000H0oooo00@000000000o`000?l00?ZJ103oool3
003jVP80oooo0P000?l01000nYX0oooo0?ooo`3oool2003jVWP0oooo00<000000?ooo`3oool06@3o
ool200000?l0oooo?P3oool2000003D0oooo000f0?ooo`800000203oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0Z@3oool2000000H0oooo00@00?ZJ
0000o`000?l00?ZJ1@3oool2003jVP80oooo0P000?l00`00nYX0oooo0?ooo`03003jVWP0oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`3o0?oooch0oooo00<000000?ooo`3oool0<`3o
ool003L0oooo00<000000?ooo`3oool01P3oool5000000030?ooo`000000000000<000001@3oool0
0`000000oooo0?ooo`2Y0?ooo`8000001@3oool2003jVP80003o00<00?ZJ0?ooo`3oool00`3oool2
003jVP80oooo0P000?l00`00nYX0oooo003jVP03003jVWP0oooo00@000000?ooo`0000000000103o
ool00`000000oooo0?ooo`020?ooo`<000000`3oool3000000H0oooo00<000000?ooo`3oool0o`3o
ooln0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0:T0oooo0P000005
0?ooo`800?ZJ0P000?l00`00nYX0oooo0?ooo`030?ooo`<00?ZJ00D0oooo0000o`000?l00?ZJ0?oo
o`04003jVWP0oooo0P0000020?ooo`030000003oool0oooo00L0oooo00D000000?ooo`3oool0oooo
000000030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0o`3oooln0?ooo`030000
003oool0oooo03<0oooo001@0?ooo`800000ZP3oool2000000@0oooo0`00nYX20000o`03003jVP3o
ool0oooo00@0oooo0P00nYX01@3oool0003o0000o`00nYX0oooo00@00?ZJMP3oool400000080oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool0o`3oooln0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003o
ool0oooo0:T0oooo0`0000030?ooo`800?ZJ00@000000000o`000?l00?ZJ1P3oool3003jVP<0003o
00<0oooo003jVP00nYX00P00nYYh0?ooo`8000000P3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool00`3oool300000?l0oooo?03oool3000003D0oooo
001@0?ooo`030000003oool0oooo0:T0oooo0`0000020?ooo`<00?ZJ00@000000000o`000?l00?ZJ
1`3oool2003jVP03000000000?l0003o00D00?ZJN03oool200000080oooo00<000000?ooo`3oool0
1`3oool010000000oooo0?ooo`3oool4000000H0oooo00<000000?ooo`3oool0o`3oooln0?ooo`03
0000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0:T0oooo0`0000001P3oool00000
003jVP00nYX0oooo00000080003o00<00?ZJ0?ooo`3oool01@3oool3003jVP80003o0P00nYX00`3o
ool00?ZJ003jVP1h0?ooo`8000000P3oool00`000000oooo0?ooo`060?ooo`8000000`3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo0?l0oooo?P3oool00`000000oooo0?ooo`0c0?oo
o`00D03oool00`000000oooo0?ooo`2Y0?ooo`<0000000@0oooo00000000nYX00?ZJ0P0000020000
o`03003jVP3oool0oooo00H0oooo0P00nYX20000o`800?ZJ00<0oooo003jVP00nYX0N03oool01000
0000oooo00000000000:0?ooo`040000003oool0oooo0?ooo`D000001@3oool00`000000oooo0?oo
o`3o0?oooch0oooo00<000000?ooo`3oool0<`3oool00500oooo0P00002@0?ooo`800?ZJ603oool3
000000040?ooo`00nYX00?ZJ003jVP8000000P000?l90?ooo`800?ZJ0P000?l00`00nYX0oooo0?oo
o`02003jVWH0oooo0`00000K0?ooo`030000003oool0oooo0?l0oooo?P3oool00`000000oooo0?oo
o`0c0?ooo`00D03oool00`000000oooo0?ooo`2?0?ooo`800?ZJ103oool2003jVQ40oooo10000000
103oool00?ZJ003jVP3oool200000080003o2@3oool2003jVP80003o00<00?ZJ0?ooo`3oool00P00
nYYh0?ooo`030000003oool0oooo01T0oooo0P00000j0?ooo`800000o`3oool20?ooo`800000=@3o
ool00500oooo00<000000?ooo`3oool0F`3oool2003jVP@0oooo0P00nYXQ0?ooo`800?ZJ2@3oool2
003jVP<0oooo0`00nYXA0?ooo`@0000000@0oooo003jVP00nYX0oooo0P0000020000o`X0oooo00@0
0?ZJ0000o`000?l00?ZJ0P3oool2003jVWP0oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`0i0?ooo`800000o`3oool30?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003o
ool0oooo05/0oooo0P00nYX30?ooo`<00?ZJ8@3oool2003jVPP0oooo0`00nYX30?ooo`<00?ZJ4@3o
ool5000000800?ZJ00<0oooo0000000000000P000?l:0?ooo`03003jVP000?l0003o00<0oooo0P00
nYYh0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0>@3oool200000?l0oooo0`3o
ool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`090?ooo`800?ZJC`3oool3
003jVP80oooo1000nYXK0?ooo`800?ZJ0`3oool3003jVPP0oooo0`00nYX30?ooo`<00?ZJ4@3oool2
000000030?ooo`000000000000800?ZJ00<0oooo0000000000000P000?l:0?ooo`03003jVP000?l0
003o00<0oooo0P00nYYh0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0>03oool3
00000?l0oooo0`3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`080?oo
o`<00?ZJCP3oool4003jVP80oooo1000nYXK0?ooo`800?ZJ0P3oool4003jVPL0oooo1000nYX20?oo
o`@00?ZJ4@3oool2000000030?ooo`000000000000800?ZJ0`0000020000o`X0oooo00<00?ZJ0000
o`000?l00`3oool3003jVP<0oooo0P00nYYb0?ooo`030000003oool0oooo01T0oooo00<000000?oo
o`3oool0>03oool400000?l0oooo0P3oool00`000000oooo0?ooo`0c0?ooo`00D03oool2000000P0
oooo1000nYY>0?ooo`@00?ZJ00<00000003jVP00nYX00`00nYXJ0?ooo`<00?ZJ0P3oool4003jVPL0
oooo1000nYX20?ooo`@00?ZJ4@3oool2000000030?ooo`0000000?ZJ00800?ZJ0P0000000`3oool0
003o0000o`0:0?ooo`03003jVP000?l0003o00@0oooo0P00nYX30?ooo`800?ZJL03oool3000001/0
oooo0P00000i0?ooo`@00000o`3oool10?ooo`800000=@3oool00500oooo00<000000?ooo`3oool0
1`3oool4003jVSP0oooo0P00nYX:0?ooo`800?ZJ1`3oool5003jVP0400000000nYX00?ZJ0?ooo`80
0?ZJ6@3oool4003jVP030?ooo`00nYX00?ZJ00<00?ZJ1P3oool;003jVQ40oooo0P0000020?ooo`03
003jVP000?l0003o00D0003o2P3oool00`00nYX0003o0000o`0200000080oooo0P00nYX20?ooo`<0
0?ZJLP3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo03P0oooo1000003o0?ooo`80
oooo00<000000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool01P3oool5003jVSP0oooo
0P00nYX40?ooo`800?ZJ103oool2003jVPL0oooo0P00nYX00`3oool00?ZJ003jVP03003jVP030?oo
o`00nYX00?ZJ01T0oooo1000nYX0103oool00?ZJ003jVP3oool2003jVP@0oooo1000nYX20?ooo`@0
0?ZJ00<0oooo003jVP00nYX04@3oool2000000030?ooo`00nYX00?ZJ00L0003o2P3oool01@00nYX0
003o0000o`000?l000000080oooo0P00nYX00`3oool00?ZJ003jVP02003jVW80oooo00<000000?oo
o`3oool06@3oool00`000000oooo0?ooo`0h0?ooo`H000003`3oool200000>h0oooo00<000000?oo
o`3oool0<`3oool00500oooo00<000000?ooo`3oool01P3oool2003jVP030?ooo`00nYX00?ZJ03P0
oooo0P00nYX30?ooo`<00?ZJ0`3oool3003jVP@0oooo1@00nYX00`3oool00?ZJ003jVP02003jVP80
oooo0P00nYXH0?ooo`P00?ZJ00<0oooo003jVP00nYX00`3oool5003jVP80oooo1000nYX00`3oool0
0?ZJ003jVP0A0?ooo`80000000<0oooo003jVP00nYX00P000?l2000000030?ooo`00nYX00?ZJ00/0
oooo1`000?l00`00nYX0oooo003jVP03003jVW80oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`0h0?ooo`H000000P3oool2000000P0oooo0P0000000`3oool000000000000?0?ooo`80
0000g@3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`050?ooo`<00?ZJ
00<0oooo003jVP00nYX0=`3oool3003jVP<0oooo0`00nYX20?ooo`@00?ZJ0`3oool5003jVP<0oooo
0`00nYX20?ooo`800?ZJ603oool2003jVP030?ooo`00nYX00?ZJ00800?ZJ0P3oool2003jVP<0oooo
1000nYX30?ooo`<00?ZJ0P3oool2003jVQ40oooo0P000003003jVP80003o0P0000000`3oool00?ZJ
003jVP0;0?ooo`800?ZJ1@000?l6003jVW80oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`0h0?ooo`H0000000@0oooo00000000000000000`3oool2000000<0oooo1P00000>0?ooo`80
0000g@3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`050?ooo`800?ZJ
0P3oool2003jVSL0oooo0`00nYX30?ooo`<00?ZJ0P3oool4003jVP<0oooo1@00nYX20?ooo`030000
0000nYX00?ZJ0080000000<0oooo003jVP00nYX00`3oool2003jVQ80oooo0`00nYX20?ooo`<00?ZJ
0P3oool2003jVP80oooo1@00nYX30?ooo`<00?ZJ0P3oool2003jVQ40oooo0P000002003jVP030?oo
o`000?l0003o0080000000<0oooo003jVP00nYX02`3oool2003jVP<000000P000?l3003jVP030?oo
o`00nYX00?ZJ0780oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0g0?ooo`<00000
00D0oooo00000000000000000?ooo`0300000080oooo0`0000020?ooo`L000003@3oool300000=d0
oooo00<000000?ooo`3oool0<`3oool00500oooo0P0000060?ooo`800?ZJ0P3oool2003jVSH0oooo
1000nYX30?ooo`<00?ZJ0P3oool4003jVP80oooo1P00nYX3000000800?ZJ0P0000000`3oool00?ZJ
003jVP030?ooo`800?ZJ4P3oool2003jVP<0oooo0`00nYX00`000000oooo003jVP08003jVP<0oooo
0`00nYX2000000800?ZJ4@3oool01@0000000?ZJ003jVP00nYX0oooo0080003o0P0000000`3oool0
0?ZJ003jVP0;0?ooo`800?ZJ0`0000020000o`<00?ZJ00<0oooo003jVP00nYX0L03oool3000001/0
oooo0P00000S0?ooo`8000004`3oool200000080oooo1`0000020?ooo`<000000P3oool400000003
0?ooo`000000000000/0oooo1P00003K0?ooo`800000=@3oool00500oooo00<000000?ooo`3oool0
1@3oool2003jVP80oooo0P00nYXf0?ooo`@00?ZJ0P3oool4003jVP80oooo1000nYX01@3oool00?ZJ
003jVP00nYX0oooo00<00?ZJ0`000002003jVP80000000<0oooo003jVP00nYX00`3oool2003jVP@0
oooo0P00nYX<0?ooo`800?ZJ0`3oool3003jVP030000003oool0oooo00@00?ZJ00<0oooo003jVP00
nYX00P0000020?ooo`800?ZJ00<0oooo0000000000000P00nYXA0?ooo`0300000000nYX00?ZJ0080
oooo0P000?l00`000000oooo0?ooo`02003jVP/0oooo0P00nYX300000080003o0`00nYX00`3oool0
0?ZJ003jVP1b0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool07@3oool200000080
oooo0`00000C0?ooo`8000000P3oool=000000030?ooo`000000000000<0oooo0P00000;0?ooo`H0
0000g03oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`040?ooo`<00?ZJ
0P3oool2003jVSD0oooo4@00nYX00`3oool00?ZJ003jVP020?ooo`800?ZJ00@0oooo000000000000
00000P00nYX3000000800?ZJ0P3oool3003jVP<0oooo0`00nYX<0?ooo`800?ZJ0`3oool3003jVP03
0000003oool0oooo00@00?ZJ00<0oooo003jVP00nYX00P0000001@3oool00000003jVP00nYX0oooo
008000000P00nYXA0?ooo`<00?ZJ0P3oool20000o`030000003oool0oooo00800?ZJ2`3oool2003j
VP<000000P000?l3003jVP030?ooo`00nYX00?ZJ0780oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`0M0?ooo`8000000P3oool3000001<0oooo0P0000020?ooo`d0000000<0oooo0000
000000000`3oool3000000T0oooo100000000`3oool000000000000200000=X0oooo00<000000?oo
o`3oool0<`3oool003`0oooo0`0000030?ooo`030000003oool0oooo0080oooo0`0000060?ooo`03
0000003oool0oooo00@0oooo0P00nYX2000000030?ooo`00nYX00?ZJ03D0oooo0P00nYX20?ooo`@0
0?ZJ0P3oool4003jVP030?ooo`00nYX00?ZJ00<00?ZJ0P3oool2003jVP040?ooo`00000000000000
00800?ZJ00<0oooo0000000000000P00nYX00`3oool00?ZJ003jVP02003jVP<0oooo0`00nYX<0?oo
o`800?ZJ0`3oool2003jVP8000000P3oool3003jVP80oooo100000000`3oool00000000000020?oo
o`8000000P00nYX20?ooo`8000002@3oool200000080oooo0P00nYX30?ooo`80003o00<00?ZJ0?oo
o`3oool00P00nYX;0?ooo`800?ZJ00<000000?ooo`0000000P000?l2003jVP80oooo0P00nYYb0?oo
o`030000003oool0oooo01T0oooo00<000000?ooo`3oool07@3oool3000000030?ooo`0000000000
008000004P3oool2000000@0oooo2`0000000`3oool00000000000040?ooo`8000002@3oool20000
00<0oooo100000090?ooo`800000c`3oool00`000000oooo0?ooo`0c0?ooo`00?@3oool00`000000
oooo0?ooo`060?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`040?oo
o`800?ZJ0P0000000`3oool00?ZJ003jVP0d0?ooo`<00?ZJ0P3oool4003jVP80oooo1000nYX20?oo
o`@00?ZJ103oool6000000030?ooo`000000000000800?ZJ00<0oooo003jVP00nYX00P00nYX30?oo
o`<00?ZJ2`3oool3003jVP<0oooo0P00nYX3000000040?ooo`00nYX00?ZJ003jVP80oooo10000000
0`3oool00000000000020?ooo`8000000P00nYX20?ooo`8000002@3oool200000080oooo0P00nYX3
0?ooo`80003o00<00?ZJ0?ooo`3oool00P00nYX;0?ooo`800?ZJ00<000000?ooo`0000000P000?l2
003jVP80oooo0P00nYYb0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool07@3oool8
00000180oooo0P0000080?ooo`X00000103oool2000000T0oooo0P0000040?ooo`<000002@3oool3
00000<h0oooo00<000000?ooo`3oool0<`3oool003X0oooo1@0000070?ooo`050000003oool0oooo
0?ooo`0000001@3oool00`000000oooo0?ooo`060?ooo`80000000@0oooo003jVP00nYX00?ZJ0`3o
ool2003jVRh0oooo0P00nYX30?ooo`<00?ZJ0`3oool3003jVP<0oooo1000nYX40?ooo`H0000000<0
oooo0000000000001`00nYX30?ooo`<00?ZJ2`3oool2003jVP@0oooo1@0000000`3oool00?ZJ003j
VP030?ooo`@0000000D0oooo00000000000000000?ooo`02000000<00?ZJ00<0oooo000000000000
2@3oool200000080oooo0P00nYX30?ooo`80003o00<00?ZJ0?ooo`3oool00P00nYX;0?ooo`<00?ZJ
0P3oool30000o`03003jVP3oool0oooo00800?ZJLP3oool00`000000oooo0?ooo`0I0?ooo`800000
7P3oool800000140oooo0`0000080?ooo`D0000000<0oooo0000000000000P0000040?ooo`800000
203oool3000000@0oooo0`0000090?ooo`<00000c@3oool2000003D0oooo000j0?ooo`040000003o
ool0oooo000000P0oooo100000060?ooo`<000001P3oool4000000800?ZJ0`3oool2003jVRd0oooo
0`00nYX20?ooo`0400000000nYX00?ZJ003jVP<0oooo0`00nYX30?ooo`<00?ZJ1@3oool600000003
0?ooo`000000000000@00?ZJ00<0oooo003jVP00nYX00P3oool4003jVP/0oooo0P00nYX40?ooo`D0
000000<0oooo003jVP00nYX00`3oool70000o`D000000P00nYX00`3oool0000000000002003jVP@0
oooo0P00nYX00`3oool00000000000020?ooo`800?ZJ0`3oool20000o`800?ZJ00<0oooo003jVP00
nYX0303oool2003jVP80oooo00<000000000o`000?l00`3oool2003jVVl0oooo1000000K0?ooo`03
0000003oool0oooo01`0oooo1P000000103oool0000000000000000@0?ooo`8000002@3oool50000
00030?ooo`000000000000800000103oool4000000H0oooo0P0000050?ooo`<00000103oool20000
0080oooo1000002:0?ooo`L0003o?@3oool00`000000oooo0?ooo`0c0?ooo`00>`3oool00`000000
oooo000000080?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool400000080
0?ZJ0P3oool3003jVR`0oooo00<00000003jVP00nYX00`3oool0100000000?ZJ003jVP00nYX30?oo
o`800?ZJ103oool3003jVP<0oooo100000020?ooo`H0003o0`00nYX00`3oool00?ZJ003jVP06003j
VP/0oooo0P00nYX40?ooo`80000000@0oooo000000000000oooo0P00nYX30?ooo`d0003o00@00?ZJ
0?ooo`00000000000P00nYX40?ooo`800?ZJ00D0oooo00000000000000000?ooo`02003jVP<0oooo
0P000?l2003jVP030?ooo`00nYX00?ZJ00`0oooo0P00nYX20?ooo`03000000000?l0003o00<0oooo
0P00nYYb0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0703oool600000080oooo
0`00000?0?ooo`8000002P3oool4000000030?ooo`0000000000008000001@3oool3000000H0oooo
0P0000060?ooo`<0000000<0oooo0000000000000P0000020?ooo`@000000`3oool2000006P0oooo
3@000?l@0?ooo`L0003o?@3oool00`000000oooo0?ooo`0c0?ooo`00?03oool2000000T0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`040?ooo`80003o10000002003jVP030?ooo`00
nYX00?ZJ00800?ZJ;03oool00`0000000?ZJ003jVP02000000040?ooo`0000000?ZJ003jVP@0oooo
0P00nYX40?ooo`<00?ZJ0`3oool=0000o`04003jVP3oool0oooo0?ooo`@00?ZJ00<0oooo003jVP00
nYX02`3oool2003jVP8000000P3oool70000o`04003jVP3oool0oooo0?ooo`80003o0P0000000`3o
ool0003o0000o`060000o`03003jVP000000000000<00?ZJ0`3oool3003jVP050?ooo`0000000000
0000003oool00P00nYX30?ooo`80003o1@00nYX<0?ooo`<00?ZJ00@0oooo000000000?l0003o0`3o
ool3003jVVH0oooo0P00nYX90?ooo`030000003oool0oooo00D0oooo0P0000040?ooo`040000003o
ool0oooo0?ooo`D000001@3oool00`000000oooo0?ooo`0L0?ooo`80000000<0oooo000000000000
103oool2000000l0oooo0P00000:0?ooo`@0000000<0oooo0000000000000P0000060?ooo`800000
1P3oool2000000L0oooo0P0000000`3oool000000000000200000080oooo100000030?ooo`800000
0`3oool2000005L0oooo1`000?l50?ooo`d0003o103oool>0000o`<0oooo0`000?l40?ooo`L0003o
2P3oool70000ob00oooo00<000000?ooo`3oool0<`3oool003d0oooo00<000000?ooo`3oool0203o
ool2000000H0oooo00<000000?ooo`3oool0103oool70000o`03003jVP3oool00?ZJ00<00?ZJ;03o
ool00`0000000?ZJ003jVP02000000040?ooo`0000000?ZJ003jVPX0oooo0P00nYX40?ooo`L0003o
0`3oool010000000003o0000o`00nYX30?ooo`@00?ZJ00<0oooo003jVP00nYX02P3oool3003jVP80
00000P3oool70000o`04003jVP000000oooo0?ooo`80003o0P0000000`3oool00000000000040000
0080003o00<00?ZJ00000000nYX00`00nYX20?ooo`@00?ZJ10000003003jVP<0oooo0P000?l00`3o
ool00?ZJ003jVP02003jVP`0oooo00D00000003jVP00nYX0oooo000000020000o`@0oooo0P00nYX3
0?ooo`800?ZJH03oool3003jVPT0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`00
00080?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool03`3ooolZ0000o`/0oooo
0P0000020?ooo`<000001P3oool2000000H0oooo0P0000070?ooo`L000000P3oool4000000<0oooo
0P0000030?ooo`800000E`3oool70000o`@0oooo0`000?l90?ooo`80003o103oool=0000o`D0oooo
3@000?l:0?ooo`L0003o803oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?oo
o`040?ooo`03000000000?l0003o00@0003o1P00nYX/0?ooo`0300000000nYX00?ZJ0080000000<0
oooo0000000000002`3oool2003jVP@0oooo0P000?l2000000H0oooo00@000000000o`000?l00?ZJ
0`3oool3003jVP80oooo0P00nYX:0?ooo`03003jVP000?l0003o00H0003o0P3oool00`000000003o
0000o`0200000080oooo0P000?l2000000040?ooo`00000000000?ooo`<000000P000?l00`00nYX0
0000003jVP03003jVP80oooo1000nYX4000000800?ZJ00@000000?ooo`3oool0oooo0P000?l00`3o
ool00?ZJ003jVP02003jVPd0oooo0`00nYX00`000000003o0000o`040?ooo`800?ZJ0P3oool3003j
VV00oooo0`00nYX90?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000002@3oool0
0`000000oooo0?ooo`050?ooo`<000000`3oooll0000o`D0oooo0P0000020?ooo`8000001`3oool2
000000H0oooo0P0000070?ooo`D000004P000?l00`000000oooo0?ooo`0J0?oooa80003o8P3oool8
0000o`<0oooo20000?l:0?ooo`P0003o403oool70000o`@0oooo3P000?l30?ooo`P0003o403oool3
0000o`D0oooo0`00000e0?ooo`00D03oool2000000H0oooo0P000000103oool000000000o`000?l3
003jVP030?ooo`00nYX00?ZJ02`0oooo0`00nYX600000080oooo0P00000<0?ooo`80003o0P000006
0?ooo`03000000000?l0003o00@0oooo0`00nYX20?ooo`800?ZJ203oool200000003003jVP000?l0
003o00D0003o00@000000?ooo`3oool000000P000?l400000080003o1@000000103oool000000000
000000020000o`03003jVP0000000?ZJ00<00?ZJ00<0oooo003jVP00nYX00`00nYX400000003003j
VP000?l0003o00D0003o0P3oool3003jVPh0oooo0P00nYX00`000000003o0000o`020000o`80oooo
0P00nYX00`3oool00?ZJ003jVP02003jVV00oooo0`00nYX70?ooo`<000001P3oool010000000oooo
0?ooo`00000:0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool=0000o`/0
oooo0P0000080?ooo`8000000P3oool2000000X0oooo0P0000000`3oool0003o0000o`1d0000oaH0
oooo3@000?l50?ooo`L0003o2P3oool70000oad0oooo30000?l50?oooaX0003o1`3oool00`000000
oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`050?ooo`8000000P3oool20000o`800?ZJ
0P3oool2003jVR`0oooo0P00nYX00`000000oooo0000000400000080oooo0P0000070?ooo`<00000
00@0oooo0000o`000?l0003o0P0000060?ooo`03000000000?l0003o00@0oooo0`00nYX20?ooo`80
0?ZJ103oool2003jVP80oooo0P0000000`00nYX0003o0000o`03000000030?ooo`000000000000<0
oooo0`000?l300000080003o00@0oooo00000000000000000P00nYX20?ooo`05000000000?l0003o
003jVP0000001000nYX0103oool00?ZJ003jVP3oool2003jVP<000000P00nYX70000o`80oooo0`00
nYX>0?ooo`800?ZJ00<0oooo0000o`000?l01@000?l00`00nYX0oooo003jVP03003jVUl0oooo1000
nYX90?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000001`3oool01@000000oooo
0?ooo`3oool0000000D0oooo00<000000?ooo`3oool00`3oool4000000030?ooo`00000000000140
oooo0P0000080?ooo`<0000000<0oooo0000000000002P3oool2000000L0oooo:P000?l400000005
0?ooo`00000000000000003oool00`0000030?ooo`03000000000?l0003o01d0003o403oool=0000
o`X0oooo3@000?mG0?oooa<0003o203oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000
oooo0?ooo`090?ooo`80003o0P00nYX20?ooo`800?ZJ;03oool00`00nYX0003o0000o`050000o`03
0000003oool0oooo008000001`000?l3000000050?ooo`000?l0003o003jVP0000000`3oool2003j
VP80oooo00<000000000o`000?l0103oool2003jVP<0oooo0`00nYX30?ooo`800?ZJ0P3oool00`00
00000?ZJ003jVP020000o`<0000000<0oooo000000000000103oool20000o`<000000P000?l0103o
ool00000000000000002003jVP80oooo00<000000000o`000?l02@00nYX00`3oool00?ZJ003jVP02
000000<00?ZJ0P000?l30?ooo`800?ZJ0`3oool2003jVPh0oooo0P00nYX00`3oool0000000000005
0000o`H00?ZJG`3oool4003jVPT0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`00
00070?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`040?ooo`<00000
00@0oooo0000000000000000403oool2000000T0oooo0P0000000`3oool000000000000:0?ooo`80
00006`3oool500000080oooo0P0000070?ooo`<0000000<0oooo000000000000100000001@3oool0
0000000000000000oooo00<000000`3oool3000000P0oooo0`00000X0?ooo`L0003o1@3oool<0000
ogP0oooo00<000000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool0103oool2003jVP<0
oooo0P000?l2003jVP80oooo0P00nYX/0?ooo`03003jVP000?l0003o01@0003o00D0oooo0000o`00
0?l00?ZJ000000030?ooo`800?ZJ0P3oool00`000000003o0000o`040?ooo`800?ZJ103oool2003j
VP80oooo0`00nYX20?ooo`0300000000nYX00?ZJ0080003o10000002003jVP@0oooo1`000?l01000
nYX00000000000000002003jVP80oooo00<000000000o`000?l00`00nYX00`000000oooo003jVP03
003jVP030?ooo`00nYX00?ZJ008000000P00nYX00`000000003o0000o`030?ooo`800?ZJ0`3oool2
003jVPh0oooo0`00nYX2000000<0oooo0P000?l3003jVP030?ooo`00nYX00?ZJ05H0oooo0P00nYX6
0?ooo`D00?ZJ2@3oool00`000000oooo0?ooo`050?ooo`8000002@3oool3000000H0oooo00<00000
0?ooo`3oool01@3oool600000100oooo0P0000090?ooo`80000000<0oooo0000000000002P3oool2
000001/0oooo1@000000103oool000000000000000070?ooo`<0000000<0oooo0000000000001000
00001@3oool00000000000000000oooo00<000000`3oool3000000P0oooo1@00000[0?ooo`h0003o
O@3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`040?ooo`800?ZJ0`3o
ool20000o`800?ZJ0P3oool2003jVR`0oooo00@00?ZJ0000o`000?l0oooo0`0000070000o`D00000
1`000?l00`00nYX000000?ooo`020?ooo`800?ZJ0P3oool010000000003o0000o`0000090?ooo`80
0?ZJ00<0oooo003jVP00nYX00P00nYX00`3oool00000003jVP02003jVP80003o00@000000?ooo`00
000000000P00nYX40?ooo`L0003o00@00?ZJ00000000000000000`00nYX0103oool000000000o`00
0?l3003jVP030000003oool00?ZJ00<00?ZJ00<0oooo003jVP00nYX01000nYX00`000000003o0000
o`030?ooo`800?ZJ0`3oool2003jVPl0oooo0`00nYX010000000oooo0?ooo`3oool20000o`<00?ZJ
00<0oooo003jVP00nYX0EP3oool2003jVPH0oooo0P00nYX00`3oool00?ZJ003jVP090?ooo`030000
003oool0oooo01T0oooo0P0000070?ooo`D00000403oool2000000T0oooo1P0000050?ooo`800000
0P3oool2000001/0oooo1@0000000`3oool00000000000090?ooo`80000000<0oooo000000000000
0`0000020?ooo`L000000`3oool4000000D0oooo1`00000/0?ooo`L0003oPP3oool2000003D0oooo
001@0?ooo`030000003oool0oooo00@0oooo0`00nYX20?ooo`<0003o00<00?ZJ0?ooo`3oool00P00
nYX40?ooo`800?ZJ9P3oool00`00nYX0003o0000o`020?ooo`@000000P3oool2000000030?ooo`00
0000000000<000000P3oool50000o`800?ZJ0`3oool2003jVP<0oooo0`000?l90?ooo`800?ZJ00<0
oooo003jVP00nYX00P00nYX01@3oool00000003jVP00nYX000000080003o00@000000?ooo`000000
00000`00nYX70?ooo`0400000000nYX00?ZJ003jVP<000000`00nYX00`3oool000000000o`020000
o`04003jVP00000000000?ooo`<00?ZJ0`000004003jVP8000000P000?l30?ooo`800?ZJ5@3oool2
003jVP040000003oool0oooo0?ooo`80003o0P00nYX20?ooo`800?ZJE@3oool3003jVP<0oooo0P00
0003003jVP030?ooo`00nYX00?ZJ00T0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`060?ooo`D00000403oool2000000T0oooo1P0000050?ooo`8000000P3oool2000001/0oooo1@00
00000`3oool00000000000090?ooo`800000103oool200000080oooo1`0000030?ooo`@000001@3o
ool700000;H0oooo00<000000?ooo`3oool0<`3oool00500oooo0P0000060?ooo`800?ZJ0P3oool0
0`000000003o0000o`030?ooo`<00?ZJ0P3oool3003jVRD0oooo0P00nYX20000o`<0oooo0`000002
0?ooo`80000000<0oooo0000000000000P0000040?ooo`<000000`00nYX30?ooo`800?ZJ0`3oool7
0000o`D0oooo0P00nYX00`3oool00?ZJ003jVP02003jVP050?ooo`00nYX00?ZJ003jVP0000000P00
0?l010000000oooo000000000003003jVPL0oooo00<00000003jVP00nYX00P00nYX00`000000oooo
003jVP02003jVP80oooo00@000000000o`000?l00?ZJ0P000000103oool00?ZJ003jVP00nYX30000
00@00?ZJ0P0000020000o`<0oooo0P00nYXE0?ooo`<00?ZJ0`3oool20000o`800?ZJ0P3oool2003j
VU@0oooo1000nYX30?ooo`@00?ZJ0P3oool2003jVPL0oooo0`00000K0?ooo`030000003oool0oooo
00H0oooo1P00000?0?ooo`8000002@3oool6000000@0oooo0`000000103oool0000000000000000N
0?ooo`D000002@3oool2000000X0oooo1@0000020?ooo`D00000103oool800000;H0oooo00<00000
0?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool01@3oool2003jVP80oooo00<000000000
o`000?l0103oool2003jVP80oooo0`00nYXT0?ooo`<00?ZJ0P000?l40?ooo`8000000P3oool20000
00800?ZJ00<0oooo000000000000103oool3000000<00?ZJ0`3oool3003jVP80oooo0P0000050000
o`D0oooo0P00nYX00`3oool00?ZJ003jVP02003jVP030?ooo`00nYX00?ZJ008000000P000?l01000
nYX0oooo0?ooo`000003003jVPL0oooo00<00000003jVP00nYX00P00nYX00`000000oooo003jVP03
003jVP050?ooo`000000003o0000o`00nYX00P000000103oool00?ZJ003jVP00nYX3000000<00?ZJ
0P3oool00`000000003o0000o`030?ooo`800?ZJ5P3oool2003jVP<0oooo0P000?l2003jVP80oooo
0P00nYX90?ooo`800?ZJB@3oool4003jVP<0oooo1000nYX20?ooo`800?ZJ2@3oool00`000000oooo
0?ooo`0I0?ooo`030000003oool0oooo00H0oooo0`0000000`3oool000000000000?0?ooo`800000
2P3oool5000000@0oooo0`000000103oool0000000000000000O0?ooo`@000002@3oool2000000X0
oooo1@0000020?ooo`80000000<0oooo000000000000103oool900000;D0oooo00<000000?ooo`3o
ool0<`3oool00500oooo00<000000?ooo`3oool01@3oool2003jVP80oooo00<000000000o`000?l0
0P3oool2000000800?ZJ00<0oooo003jVP00nYX00P00nYX30?ooo`800?ZJ7`3oool2003jVP030000
00000?l0003o00@0oooo0P00nYX010000000oooo000000000002003jVPP0oooo0P000003003jVP<0
oooo0`00nYX20?ooo`D0000020000?l9003jVP80oooo0P000?l01000nYX0oooo0?ooo`000003003j
VP<0oooo0P00nYX30?ooo`@00?ZJ00<00000003jVP00nYX00`00nYX01@3oool000000000o`000?l0
oooo00<000000P00nYX4000000<00?ZJ0`3oool20000o`<0oooo0P00nYXF0?ooo`<00?ZJ0P3oool2
0000o`800?ZJ0P3oool2003jVPT0oooo0P00nYY80?ooo`D00?ZJ0`3oool4003jVP80oooo0P00nYX9
0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool01P3oool3000000030?ooo`000000
000000l0oooo0P00000=0?ooo`80000000@0oooo000000000000oooo0`000000103oool000000000
0000000O0?ooo`<000005P3oool9000000030?ooo`000000000000@0oooo100000000`3oool00000
0000000200000;D0oooo00<000000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool01@3o
ool2003jVP<0oooo0P000?l20?ooo`8000001`00nYX30?ooo`800?ZJ7P3oool3003jVP0400000000
0?l0003o003jVP<0oooo0P00nYX010000000oooo000000000002003jVP@0oooo0P00nYX40?ooo`<0
0?ZJ0P3oool4003jVP@0oooo100000070000o`<00?ZJ0P000004003jVP80oooo0P000?l01000nYX0
oooo0?ooo`3oool3003jVP<0oooo0P00nYX30?ooo`L00?ZJ00D0oooo003jVP00nYX00?ZJ00000002
0000o`040?ooo`0000000000000000800?ZJ10000003003jVP<0oooo0P000?l30?ooo`800?ZJ5P3o
ool00`0000000?ZJ003jVP020?ooo`<0003o00<00?ZJ0?ooo`3oool00P00nYX90?ooo`800?ZJ<03o
ool2000001H0oooo0P00nYX00`3oool00?ZJ003jVP020?ooo`@00?ZJ0`3oool2003jVPT0oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`060?ooo`<0000000<0oooo0000000000003`3o
ool2000000d0oooo0P0000000`3oool0000000000008000001l0oooo0`00000G0?ooo`80000000<0
oooo0000000000000P0000020?ooo`8000000`3oool5000000030?ooo`000000000000800000]@3o
ool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`050?ooo`800?ZJ0`3oool2
0000o`80oooo0P000004003jVP030?ooo`00nYX00?ZJ00<0oooo0P00nYXL0?ooo`@00?ZJ0P000002
0000o`04003jVP3oool0oooo0?ooo`<00?ZJ00<0oooo0000000000000`00nYX30?ooo`800?ZJ103o
ool4003jVP030?ooo`00nYX00?ZJ00<00?ZJ0`3oool6000000<0oooo0P000?l3003jVP8000000`00
nYX00`000000oooo0000o`020000o`04003jVP3oool0oooo0?ooo`<00?ZJ0`3oool2003jVP<0oooo
0P00nYX00`3oool00?ZJ003jVP02003jVP80oooo0P00nYX010000000003o0000o`3oool400000003
0?ooo`0000000000008000000`00nYX20?ooo`<0003o0`3oool2003jVQH0oooo00<00000003jVP00
nYX00`3oool20000o`<0oooo0P00nYX80?ooo`<00?ZJ<03oool2000001D0oooo0`00nYX0103oool0
0?ZJ003jVP3oool5003jVP<0oooo0P00nYX90?ooo`030000003oool0oooo01T0oooo0P0000070?oo
o`<0000000<0oooo0000000000003`3oool2000000d0oooo0P0000000`3oool00000000000080000
01l0oooo0`00000J0?ooo`<000000`3oool2000000<0oooo0P000000103oool000000000003oool4
00000;@0oooo0P00000e0?ooo`00D03oool00`000000oooo0?ooo`050?ooo`<00?ZJ0P3oool60000
o`@00?ZJ00<0oooo003jVP00nYX00P3oool3003jVQ/0oooo1@00nYX200000080003o00@00?ZJ0?oo
o`3oool0oooo0`00nYX3000000<00?ZJ0`3oool3003jVP<0oooo1000nYX0103oool00?ZJ003jVP3o
ool5003jVPH000000`3oool20000o`800?ZJ00<0oooo0000000000000`00nYX010000000oooo0000
o`000?l2003jVP80oooo1@00nYX20?ooo`800?ZJ0`3oool2003jVP030?ooo`00nYX00?ZJ00800?ZJ
0P3oool3003jVP80003o00<0oooo0000000000001`000003003jVP80oooo0P000?l2003jVP80oooo
0P00nYXF0?ooo`0400000000nYX00?ZJ003jVP80oooo0P000?l30?ooo`800?ZJ203oool3003jVS00
oooo0P0000070?ooo`800?ZJ303oool2003jVP80oooo0P00nYX00`3oool00?ZJ003jVP02000000@0
oooo0`00nYX80?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool01`3oool200000003
0?ooo`000000000000l0oooo0P00000=0?ooo`80000000<0oooo0000000000002000000l0?ooo`80
0000103oool2000000<0oooo0P0000000`3oool00000000000030?ooo`800000]@3oool00`000000
oooo0?ooo`0c0?ooo`00D03oool2000000L0oooo0`00nYX00`3oool0003o0000o`050000o`800?ZJ
0P3oool2003jVP80oooo0`00nYXF0?ooo`800?ZJ0`3oool4003jVP030?ooo`000000003o0080003o
0P00nYX20?ooo`<00?ZJ0`000003003jVP<0oooo0`00nYX30?ooo`L00?ZJ0P3oool4003jVP030?oo
o`000000000000<000000P3oool00`000000003o0000o`02003jVP<000000`00nYX010000000oooo
0000o`000?l2003jVP80oooo0P00nYX01@3oool00?ZJ003jVP00nYX0oooo00800?ZJ0`3oool2003j
VP80oooo0`00nYX30?ooo`800?ZJ0P000?l00`3oool0000000000007000000800?ZJ00<000000?oo
o`3oool00P000?l2003jVP80oooo0P00nYXF0?ooo`8000000P00nYX0103oool000000000o`000?l3
0?ooo`800?ZJ1`3oool4003jVS00oooo0P0000070?ooo`800?ZJ2`3oool3003jVP80oooo1@00nYX2
000000D0oooo0P00nYX60?ooo`<000006`3oool00`000000oooo0?ooo`070?ooo`80000000<0oooo
0000000000003`3oool2000000d0oooo3@0000120?ooo`L000001P3oool200000;D0oooo00<00000
0?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool01`3oool2003jVP030?ooo`0000000000
00<000000P000?l2003jVP80oooo0P00nYX00`3oool00?ZJ003jVP02003jVQD0oooo0`00nYX20?oo
o`D00?ZJ00@0oooo000000000?l0003o0`00nYX20?ooo`@00?ZJ0P000004003jVP80oooo0`00nYX2
0?ooo`<00?ZJ00<0oooo003jVP00nYX00P00nYX20?ooo`D00?ZJ0`000002003jVP030?ooo`000000
00000080003o00<00?ZJ0?ooo`0000000P000002003jVP80000000<0oooo0000o`000?l00`00nYX0
0`3oool00?ZJ003jVP020?ooo`D00?ZJ0`3oool2003jVP<0oooo0P00nYX30?ooo`800?ZJ3@000?l0
1000nYX000000?ooo`3oool20000o`800?ZJ0P3oool2003jVQH0oooo0P000002003jVP040?ooo`00
0000003o0000o`<0oooo0P00nYX70?ooo`@00?ZJ<03oool5000000<0oooo0`00nYX;0?ooo`800?ZJ
0`3oool4003jVP<000001@3oool2003jVPP0oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`070?ooo`80000000@0oooo00000000000000003@3oool3000000d0oooo2P0000000`3oool0
0000000000130?ooo`H000001P3oool200000;D0oooo00<000000?ooo`3oool0<`3oool00500oooo
00<000000?ooo`3oool01`3oool3003jVPD000000P000?l01000nYX0oooo0?ooo`3oool7003jVQD0
oooo0`00nYX00`3oool00?ZJ003jVP04003jVP040?ooo`000000003o0000o`<00?ZJ0P3oool4003j
VP8000001000nYX20?ooo`@00?ZJ00<0oooo003jVP00nYX00P3oool4003jVP<0oooo1000nYX30000
00800?ZJ00<0oooo0000000000000`000?l0103oool00000000000000002003jVP030000003oool0
oooo0080003o1P00nYX20?ooo`H00?ZJ0P3oool2003jVP<0oooo0P00nYX30?ooo`800?ZJ3@000?l2
00000080oooo0P000?l3003jVP030?ooo`00nYX00?ZJ01H0oooo0P000002003jVP040?ooo`000000
003o0000o`<0oooo0P00nYX60?ooo`D00?ZJ<03oool500000080oooo1000nYX;0?ooo`800?ZJ0`3o
ool4003jVP@00000103oool2003jVPP0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`0;0?ooo`8000003@3oool2000000h0oooo1P0000050?ooo`800000@`3oool6000000H0oooo0P00
002e0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo00P0oooo0`00nYX4
00000080003o00@00?ZJ0?ooo`3oool0oooo1000nYX00`3oool00?ZJ003jVP0D0?ooo`@00?ZJ00@0
oooo003jVP00nYX0oooo0P00nYX20?ooo`03000000000?l0003o00T00?ZJ00<00000003jVP00nYX0
2@00nYX00`3oool00?ZJ003jVP030?ooo`<00?ZJ0`3oool4003jVP<000000P00nYX400000080003o
1`0000020?ooo`80003o00<00?ZJ0?ooo`00nYX00`00nYX30?ooo`D00?ZJ0P3oool2003jVP<0oooo
0P00nYX40?ooo`800?ZJ00<000000?ooo`3oool0103oool300000080003o0P0000020?ooo`80003o
0`00nYX00`3oool00?ZJ003jVP0F0?ooo`8000000P00nYX200000080003o0`3oool2003jVPH0oooo
0P00nYX00`3oool00?ZJ003jVP0@0?ooo`800?ZJ7P3oool3000000800?ZJ0P3oool4003jVPX0oooo
0`00nYX30?ooo`<00?ZJ0`0000070000o`03003jVP3oool0oooo00H0oooo00<000000?ooo`3oool0
6@3oool2000000`0oooo0P00000=0?ooo`8000003`3oool3000004`0oooo1@0000070?ooo`800000
]03oool2000003D0oooo001@0?ooo`030000003oool0oooo00T0oooo0P00nYX400000080003o00@0
0?ZJ0?ooo`3oool0oooo1000nYX00`3oool00?ZJ003jVP0C0?ooo`P00?ZJ00@0oooo003jVP00nYX0
oooo0P0000020000o`03003jVP3oool00?ZJ00<00?ZJ00<0oooo003jVP00nYX00`00nYX20?ooo`@0
0?ZJ00@0oooo003jVP00nYX0oooo0P00nYX40?ooo`800?ZJ103oool4003jVP8000000`00nYX30000
0080003o1`0000020?ooo`80003o00<00?ZJ0?ooo`00nYX00`00nYX30?ooo`H00?ZJ00<0oooo003j
VP00nYX02@3oool2003jVP030000003oool0oooo00@0oooo0P000000103oool0003o0000o`000?l3
0?ooo`80003o1P00nYXF0?ooo`8000000`00nYX00`000000003o0000o`050000o`D0oooo0`00nYX0
0`3oool00?ZJ003jVP0?0?ooo`<00?ZJ7P3oool2000000<00?ZJ00<0oooo003jVP00nYX00`00nYX:
0?ooo`800?ZJ0`3oool0100000000?ZJ003jVP00nYX3000000L0003o00<00?ZJ0?ooo`3oool01P3o
ool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00/0oooo0`00000<0?ooo`8000003`3o
ool3000004`0oooo1@0000070?ooo`800000]@3oool00`000000oooo0?ooo`0c0?ooo`00D03oool2
000000X0oooo0`00nYX2000000040?ooo`000?l0003o003jVP<0oooo0`00nYX20?ooo`800?ZJ4`3o
ool2003jVP030?ooo`00nYX00?ZJ00800?ZJ1@3oool200000080003o00<00?ZJ0?ooo`00nYX00`00
nYX20?ooo`@00?ZJ0P3oool4003jVP040?ooo`00nYX00?ZJ0?ooo`800?ZJ303oool2003jVP800000
0`00nYX300000080003o00<000000?ooo`3oool0100000020?ooo`80003o00<00?ZJ0?ooo`3oool0
0`00nYX40?ooo`800?ZJ00@0oooo003jVP00nYX0oooo0P00nYX90?ooo`<00?ZJ2P3oool30000o`80
oooo0P000?l00`00nYX0oooo003jVP03003jVQH0oooo0`000002003jVP8000001P000?l50?ooo`80
0?ZJ0P3oool2003jVPl0oooo0`00nYXN0?ooo`8000000`00nYX0103oool00?ZJ003jVP3oool2003j
VPX0oooo0P00nYX30?ooo`0400000000nYX00?ZJ003jVP<000000P000?l00`000000oooo0?ooo`02
0000o`03003jVP3oool0oooo00@0oooo0`00000K0?ooo`030000003oool0oooo00/0oooo0`00000<
0?ooo`8000003`3oool200000500oooo0P0000070?ooo`@00000/`3oool00`000000oooo0?ooo`0c
0?ooo`00D03oool00`000000oooo0?ooo`0:0?ooo`800?ZJ0P000000103oool0003o0000o`000?l3
0?ooo`<00?ZJ0P3oool2003jVQ80oooo0`00nYX00`3oool00?ZJ003jVP02003jVP030?ooo`000000
00000080oooo0P0000020000o`03003jVP3oool0oooo00<00?ZJ0P3oool4003jVP80oooo1000nYX0
103oool00?ZJ003jVP3oool2003jVP`0oooo0P00nYX2000000<00?ZJ0`0000020000o`030000003o
ool0oooo00@000000P3oool20000o`03003jVP3oool0oooo00<00?ZJ1`3oool5003jVPX0oooo0P00
nYX:0?ooo`L0003o00<00?ZJ0?ooo`3oool00`00nYXG0?ooo`8000000`00nYX300000080oooo0P00
0?l50?ooo`800?ZJ0P3oool2003jVPh0oooo1000nYXN0?ooo`0300000000nYX00?ZJ00800?ZJ00@0
oooo003jVP00nYX0oooo0P00nYX:0?ooo`800?ZJ0`3oool00`0000000?ZJ003jVP0400000080003o
00<000000?ooo`3oool00P000?l00`00nYX0oooo0?ooo`060?ooo`030000003oool0oooo01T0oooo
00<000000?ooo`3oool02`3oool3000000`0oooo0P00000?0?ooo`800000D03oool2000000L0oooo
1000002c0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo00X0oooo0`00
nYX20?ooo`03000000000?l0003o00<0oooo0`00nYX20?ooo`800?ZJ4P3oool2003jVP<0oooo0P00
nYX00`3oool000000000000500000080003o00@00?ZJ0?ooo`3oool0oooo0P00nYX30?ooo`<00?ZJ
0P3oool4003jVP030?ooo`00nYX00?ZJ00<00?ZJ303oool8003jVP8000003@000?l01000nYX0oooo
0?ooo`3oool2003jVPP0oooo1000nYX:0?ooo`800?ZJ103oool2003jVP@0oooo00<000000000o`00
0?l010000?l00`00nYX0oooo0?ooo`03003jVQL0oooo0P000000103oool00?ZJ003jVP00nYX20000
0080oooo0P000?l40?ooo`<00?ZJ0P3oool2003jVPh0oooo1000nYXN0?ooo`0300000000nYX00?ZJ
00800?ZJ00@0oooo003jVP00nYX0oooo0P00nYX:0?ooo`800?ZJ0P3oool2000000800?ZJ10000002
0000o`030000003oool0oooo0080003o0P00nYX70?ooo`030000003oool0oooo01T0oooo00<00000
0?ooo`3oool0303oool2000000T0oooo1@00000?0?ooo`800000D03oool2000000L0oooo1000002c
0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo00/0oooo0P00nYX20?oo
o`03000000000?l0003o00<0oooo0P00nYX2000000030?ooo`00nYX00?ZJ0180oooo0P00nYX30?oo
o`800?ZJ00<0oooo0000000000001`000?l01000nYX0oooo0?ooo`3oool2003jVP<0oooo0`00nYX3
0?ooo`<00?ZJ0P3oool4003jVPd0oooo1000nYX01@0000000?ZJ003jVP3oool0000000d0003o00<0
0?ZJ0?ooo`3oool02`3oool4003jVPX0oooo0P00nYX40?ooo`800?ZJ2P3oool2003jVP<0oooo0P00
nYXG0?ooo`80000000@0oooo00000000nYX00?ZJ0P0000020?ooo`80003o103oool2003jVP<0oooo
0P00nYX=0?ooo`D00?ZJ7@3oool2000000L00?ZJ00<0oooo003jVP00nYX02P3oool2003jVP80oooo
1`0000030000o`030000003oool0oooo0080003o0P00nYX70?ooo`030000003oool0oooo01T0oooo
0P00000=0?ooo`8000002@3oool400000100oooo0P00001J0?ooo`<00000/P3oool2000003D0oooo
000f0?ooo`<000000`3oool00`000000oooo0?ooo`020?ooo`<000000`3oool3000000H0oooo00<0
00000?ooo`3oool02`3oool2003jVP<0oooo0P000?l00`3oool0000000000002003jVP80000000<0
oooo003jVP00nYX04P3oool2003jVP<0oooo0P00nYX3000000L0003o00@00?ZJ0?ooo`3oool0oooo
0P00nYX30?ooo`<00?ZJ103oool2003jVP<0oooo0`00nYX=0?ooo`@00?ZJ00@00000003jVP00nYX0
0?ZJ0`00000:0?ooo`800?ZJ3P3oool3003jVPX0oooo0`00nYX30?ooo`<00?ZJ2@3oool2003jVQ`0
oooo0P0000000`3oool00000003jVP02003jVP030000003oool0oooo0080003o103oool2003jVP<0
oooo0P00nYX=0?ooo`800?ZJ00<0oooo003jVP00nYX07@3oool2000000800?ZJ00@00000003jVP00
nYX00?ZJ0P3oool2003jVPX0oooo0P00nYX20?ooo`L000000P000?l01000nYX000000?ooo`3oool2
0000o`800?ZJ1`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00`0oooo0P000009
0?ooo`@00000K03oool400000;80oooo00<000000?ooo`3oool0<`3oool003L0oooo00<000000?oo
o`3oool01P3oool01`000000oooo0?ooo`3oool000000?ooo`0000000`3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00/0oooo0P00nYX30?ooo`L0003o0P000000103oool00?ZJ003j
VP00nYX30?ooo`800?ZJ2`3oool3003jVP030?ooo`000000000000800?ZJ0`0000020000o`800000
0P3oool2003jVPT0oooo0P00nYX90?ooo`<00?ZJ3P3oool3003jVP8000000P00nYX3000000T0oooo
0`00nYX?0?ooo`800?ZJ2`3oool2003jVP<0oooo0`00nYX80?ooo`<00?ZJ703oool2000000030?oo
o`000000000000800?ZJ00<000000?ooo`3oool00P000?l40?ooo`800?ZJ0`3oool2003jVPd0oooo
0P00nYX00`3oool00?ZJ003jVP0M0?ooo`0500000000nYX00?ZJ003jVP0000000`00nYX20?ooo`80
0?ZJ2P3oool80000o`030?ooo`00000000000080003o00@00?ZJ0000003oool0oooo0`000?l00`00
nYX0oooo0?ooo`050?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0303oool20000
00P0oooo1@00001/0?ooo`@00000/P3oool00`000000oooo0?ooo`0c0?ooo`00=03oool5000000L0
oooo00D000000?ooo`3oool0oooo000000050?ooo`030000003oool0oooo00<0oooo0`00000;0?oo
o`800?ZJ0`3oool70000o`8000000P3oool2003jVP80oooo0`00nYX;0?ooo`800?ZJ0P3oool20000
00800?ZJ0`0000020000o`<0oooo0`00nYXE0?ooo`800?ZJ3P3oool00`0000000?ZJ003jVP020?oo
o`<00?ZJ00<000000?ooo`3oool0203oool2003jVQd0oooo0P00nYX30?ooo`<00?ZJ0`3oool2003j
VP<0oooo0P00nYXM0?ooo`80000000<0oooo0000000000000P00nYX00`000000oooo0?ooo`020000
o`04003jVP3oool0oooo0?ooo`800?ZJ0`3oool2003jVPd0oooo0P00nYX00`3oool00?ZJ003jVP0M
0?ooo`0300000000nYX00?ZJ008000000`00nYX20?ooo`800?ZJ2P3oool80000o`80oooo00<00000
0000o`000?l00P00nYX20?ooo`03000000000?l0003o00D0oooo100000000`3oool0000000000004
0?ooo`040000003oool0oooo0?ooo`D000000P3oool3000000H0oooo00<000000?ooo`3oool0303o
ool2000000P0oooo1@00001/0?ooo`@00000/P3oool00`000000oooo0?ooo`0c0?ooo`00=03oool0
10000000oooo0?ooo`0000080?ooo`@000001P3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo00/0oooo0`00nYX20?ooo`80000000<0oooo0000000000000P000?l4000000800?ZJ0P3o
ool3003jVP/0oooo0P00nYX20?ooo`H0000000<0oooo0000o`000?l00`3oool2003jVRL0oooo0P00
nYX30?ooo`@00?ZJ103oool2003jVP<0oooo0P00nYXM0?ooo`<00?ZJ0P3oool4003jVP80oooo0P00
nYX30?ooo`800?ZJ7@3oool5000000<00?ZJ0P3oool20000o`04003jVP3oool0oooo0?ooo`800?ZJ
0`3oool2003jVP`0oooo0`00nYX00`3oool00?ZJ003jVP0M0?ooo`<00?ZJ0P000002003jVP<0oooo
0P00nYX90?ooo`03003jVP000?l0003o0080oooo0P0000070000o`800?ZJ0P3oool00`000000003o
0000o`080?ooo`8000000P3oool00`000000oooo0?ooo`060?ooo`060000003oool0oooo0000003o
ool000000`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00`0oooo0`0000070?oo
o`@00000K@3oool400000;80oooo00<000000?ooo`3oool0<`3oool003D0oooo00<000000?ooo`00
0000203oool00`000000oooo0?ooo`030?ooo`@000001P3oool00`000000oooo0?ooo`0<0?ooo`80
0?ZJ0P3oool2000000030?ooo`000000000000H0003o0P00nYX20?ooo`<00?ZJ2`3oool2003jVP80
oooo1P0000000`3oool0003o0000o`030?ooo`800?ZJ9`3oool2003jVP<0oooo1000nYX40?ooo`80
0?ZJ0`3oool2003jVQh0oooo0P00nYX20?ooo`@00?ZJ0P3oool3003jVP80oooo0P00nYXM0?ooo`@0
00000P3oool2003jVP80oooo0P000?l01000nYX0oooo0?ooo`3oool70000o``0oooo0P00nYX20?oo
o`800?ZJ7@3oool2003jVP<000000P00nYX30?ooo`800?ZJ203oool2003jVP80003o00@000000?oo
o`00000000001`000?l2003jVP030000003oool000000080003o203oool200000080oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool03@3oool2000000L0oooo1000001_0?ooo`800000/P3oool00`000000oooo0?ooo`0c
0?ooo`00=P3oool2000000T0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00`0oooo0`00nYX00`3oool0000000000003000000L0003o00<00?ZJ0?oo
o`00nYX00`00nYX;0?ooo`800?ZJ0P3oool6000000030?ooo`000?l0003o00<0oooo0P00nYX/0?oo
o`@00?ZJ103oool2003jVP<0oooo0P00nYXN0?ooo`800?ZJ00<0oooo003jVP00nYX00`00nYX20?oo
o`<00?ZJ0P3oool2003jVQd0oooo100000020?ooo`800?ZJ0P3oool20000o`04003jVP3oool0oooo
0?ooo`L0003o2`3oool3003jVP80oooo0P00nYXM0?ooo`800?ZJ0P0000000`3oool0000000000003
0?ooo`800?ZJ203oool2003jVP80003o00@000000?ooo`0000000000103oool2000000@00?ZJ00D0
oooo000000000?l0003o000000070?ooo`8000000P3oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool3000000d0oooo0P0000070?ooo`800000
L@3oool200000;00oooo0`00000e0?ooo`00=`3oool00`000000oooo0?ooo`080?ooo`8000000P3o
ool5000000D0oooo00<000000?ooo`3oool03@3oool5003jVPD0000000<0oooo0000000000000P00
0?l00`00nYX0oooo003jVP03003jVP/0oooo0P00nYX0103oool000000000000000070000o`<0oooo
0P00nYX]0?ooo`@00?ZJ0`3oool3003jVP80oooo0P00nYXN0?ooo`D00?ZJ00<0oooo003jVP00nYX0
0P3oool3003jVP80oooo0P00nYXM0?ooo`@000000P3oool2003jVP80oooo0P000?l01000nYX0oooo
0000000000020000o`<0oooo0P000?l;0?ooo`800?ZJ0`3oool2003jVQ`0oooo0`00nYX200000003
0?ooo`000000000000<0oooo0P00nYX70?ooo`<00?ZJ0P000?l010000000oooo0000000000040?oo
o`8000001000nYX200000080003o00<000000?ooo`3oool01@3oool200000080oooo00<000000?oo
o`3oool01@3oool01P000000oooo0?ooo`3oool000000?ooo`@000001P3oool00`000000oooo0?oo
o`0=0?ooo`8000001P3oool300000740oooo0P00002b0?ooo`030000003oool0oooo03<0oooo001@
0?ooo`030000003oool0oooo00h0oooo1000nYX500000080oooo00<000000000o`000?l01P00nYX4
0?ooo`800?ZJ103oool3003jVP040?ooo`00000000000?ooo`L0003o00<00?ZJ0?ooo`3oool00P00
nYX_0?ooo`800?ZJ0`3oool3003jVP80oooo0P00nYXO0?ooo`@00?ZJ00@0oooo003jVP00nYX0oooo
1000nYX20?ooo`800?ZJ7@3oool400000080oooo0P00nYX20?ooo`80003o00@00?ZJ0?ooo`000000
00000P000?l30?ooo`80003o2`3oool2003jVP<0oooo0P00nYXL0?ooo`800?ZJ0`0000000`3oool0
0000000000030?ooo`800?ZJ1`3oool2003jVP05000000000?l0003o0000003oool00P0000040?oo
o`8000001000nYX2000000<0003o1`3oool200000080oooo00<000000?ooo`3oool01@3oool01`00
0000oooo0?ooo`3oool000000?ooo`0000002@3oool00`000000oooo0?ooo`0=0?ooo`800000103o
ool400000780oooo0P00002b0?ooo`030000003oool0oooo03<0oooo001@0?ooo`8000003`3oool4
003jVPD000000`3oool20000o`<00?ZJ00<0oooo003jVP00nYX0103oool2003jVP@0oooo00<00?ZJ
0000o`000?l01P000?l30?ooo`<00?ZJ0P3oool2003jVRl0oooo0P00nYX30?ooo`<00?ZJ0P3oool2
003jVQl0oooo1000nYX00`3oool00?ZJ003jVP05003jVP80oooo0P00nYXM0?ooo`@000000P3oool3
003jVP050?ooo`000?l0003o003jVP3oool00P0000020000o`<0oooo0P000?l;0?ooo`800?ZJ0`3o
ool2003jVQ`0oooo0P00nYX3000000030?ooo`000?l0003o0080003o00<0oooo003jVP00nYX01P3o
ool3003jVP03000000000?l0003o00@000000P00nYX20?ooo`8000001@00nYX010000000003o0000
o`000?l50?ooo`<0000000<0oooo0000000000002@3oool300000080oooo1@0000050?ooo`030000
003oool0oooo00d0oooo0P0000040?ooo`@00000LP3oool200000;80oooo00<000000?ooo`3oool0
<`3oool00500oooo00<000000?ooo`3oool03`3oool3003jVPD000000`3oool20000o`<00?ZJ00<0
oooo003jVP00nYX00`3oool3003jVP@0oooo00<00?ZJ0000o`000?l01@000?l40?ooo`<00?ZJ0P3o
ool2003jVRl0oooo0`00nYX20?ooo`@00?ZJ00<0oooo003jVP00nYX07`3oool4003jVP80oooo1P00
nYX20?ooo`800?ZJ7@3oool4000000<0oooo0P00nYX01@3oool0003o0000o`00nYX0oooo00800000
0P000?l30?ooo`80003o2`3oool2003jVP<0oooo0P00nYXL0?ooo`800?ZJ0`0000000`3oool0003o
0000o`050000o`H0oooo0P00nYX200000080003o00@00?ZJ000000000000oooo0P00nYX20?ooo`80
00000P00nYX00`0000000?ZJ003jVP03000000P0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`0=0?ooo`800000103oool400000780oooo0P00002b0?ooo`030000003oool0oooo03<0
oooo001@0?ooo`030000003oool0oooo0100oooo0P00nYX3000000800?ZJ0`3oool20000o`800?ZJ
0P3oool2003jVP80oooo1000nYX40?ooo`03003jVP000?l0003o00<000001P3oool4003jVP030?oo
o`00nYX00?ZJ0300oooo0P00nYX00`3oool00?ZJ003jVP03003jVP030?ooo`00nYX00?ZJ0200oooo
0`00nYX30?ooo`H00?ZJ00<0oooo003jVP00nYX07@3oool4000000<0oooo0`00nYX20000o`04003j
VP3oool0000000000080003o0`3oool20000o`/0oooo0P00nYX30?ooo`800?ZJ703oool2003jVP<0
000000<0oooo0000o`000?l01@000?l50?ooo`<00?ZJ0P0000020000o`04003jVP00000000000?oo
o`800?ZJ0P3oool2000000800?ZJ00@00000003jVP00nYX00?ZJ2P3oool00`000000oooo0?ooo`0I
0?ooo`8000003P3oool2000000@0oooo1000001b0?ooo`<00000/03oool2000003D0oooo001@0?oo
o`030000003oool0oooo0100oooo0P00nYX3000000800?ZJ0`3oool20000o`800?ZJ0P3oool3003j
VP030?ooo`00nYX00?ZJ00800?ZJ0`3oool2003jVP80003o0`0000000`3oool00?ZJ003jVP030?oo
o`@00?ZJ00<0oooo003jVP00nYX0<03oool5003jVP040?ooo`00nYX00?ZJ0?ooo`800?ZJ803oool3
003jVP<0oooo0`00nYX0103oool00?ZJ003jVP3oool2003jVQh0oooo0`0000030?ooo`0300000000
nYX00?ZJ0080003o00@00?ZJ0?ooo`00000000000P000?l30?ooo`80003o2`3oool2003jVP<0oooo
0P00nYXL0?ooo`800?ZJ00<0oooo0000000000000`000?l30?ooo`80003o1@3oool2003jVP<00000
0P000?l01000nYX000000000003oool3003jVP80oooo0`00nYX2000000800?ZJ2P3oool00`000000
oooo0?ooo`0I0?ooo`030000003oool0oooo00d0oooo0P0000020?ooo`D00000M03oool200000:L0
oooo0P0000080?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0100oooo
0`00nYX2000000<00?ZJ0P3oool30000o`04003jVP3oool0oooo0?ooo`800?ZJ00<0oooo003jVP00
nYX00P00nYX20?ooo`<00?ZJ0P000?l3000000030?ooo`00nYX00?ZJ00<0oooo1`00nYXa0?ooo`@0
0?ZJ00@0oooo003jVP00nYX0oooo0P00nYXQ0?ooo`800?ZJ103oool2003jVP030?ooo`00nYX00?ZJ
00<00?ZJ7P3oool3000000<0oooo00<00000003jVP00nYX00P000?l01000nYX00000000000000002
0000o`03003jVP3oool0oooo0080003o2`3oool70000oa`0oooo1`000?l010000000oooo0?ooo`3o
ool20000o`D0oooo0P00nYX2000000030?ooo`000?l0003o00800?ZJ00<000000?ooo`00nYX00P00
nYX20?ooo`800?ZJ00<0oooo0000000000001000nYX80?ooo`030000003oool0oooo01T0oooo00<0
00000?ooo`3oool03@3oool200000080oooo1000001e0?ooo`800000Y`3oool2000000P0oooo00<0
00000?ooo`3oool0<`3oool00500oooo0P00000B0?ooo`800?ZJ00<0oooo00000000nYX00P00nYX2
0?ooo`03000000000?l0003o00@0oooo0P00nYX00`3oool00?ZJ003jVP02003jVP80oooo0P00nYX0
0`000000003o0000o`03000000030?ooo`00nYX00?ZJ00<0oooo0P00nYX00`3oool00?ZJ003jVP02
003jVS40oooo1000nYX00`3oool00?ZJ003jVP03003jVR/0oooo1000nYXN0?ooo`<000000`3oool2
00000004003jVP000?l0003o003jVP80000000@0oooo0000o`000?l00?ZJ0P3oool20000o`/0oooo
1`000?lB0?ooo`80000000<0oooo003jVP00nYX01@3oool70000o`040000003oool0oooo0?ooo`80
003o1@3oool2003jVP80000000<0oooo0000o`000?l00P00nYX00`000000oooo003jVP02003jVP80
oooo0P00nYX00`3oool0000000000004003jVPH0oooo0`00000K0?ooo`030000003oool0oooo00d0
oooo0P0000020?ooo`<00000MP3oool200000:L0oooo0P0000080?ooo`030000003oool0oooo03<0
oooo001@0?ooo`030000003oool0oooo0140oooo0`00nYX0100000000?ZJ003jVP00nYX20?ooo`03
000000000?l0003o00@0oooo1`00nYX01@3oool00?ZJ003jVP00nYX000000080003o0`0000000`3o
ool00?ZJ003jVP030?ooo`800?ZJ00<0oooo003jVP00nYX00P00nYXa0?ooo`@00?ZJ0P3oool4003j
VR/0oooo1000nYXN0?ooo`<000000`3oool2000000040?ooo`000?l0003o0000o`80000000@00?ZJ
0000o`000?l00?ZJ0P3oool20000o`/0oooo0P000?l00`000000oooo0?ooo`020000oa80oooo0P00
00000`3oool00?ZJ003jVP050?ooo`80003o103oool2003jVP<0oooo0P000?l50?ooo`800?ZJ0P00
00000`3oool0003o0000o`03003jVP030?ooo`00nYX00?ZJ00800?ZJ00<0oooo003jVP00nYX00P3o
ool2000000<00?ZJ203oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00d0oooo0P00
00020?ooo`<00000MP3oool200000:L0oooo0`0000070?ooo`030000003oool0oooo03<0oooo001@
0?ooo`030000003oool0oooo0140oooo00@00000003jVP00nYX000001000nYX0103oool000000000
o`000?l40?ooo`@00?ZJ00<00000003jVP00nYX00`00nYX200000080003o0`0000000`3oool00?ZJ
003jVP030?ooo`800?ZJ0P3oool3003jVS40oooo1000nYX20?ooo`@00?ZJ;03oool3003jVQh0oooo
0`0000030?ooo`80000000@0oooo003jVP000?l0003o0P0000000`00nYX0003o0000o`02003jVP03
0?ooo`000?l0003o00/0oooo0P000?l00`000000oooo0?ooo`020000oa80oooo0P0000000`3oool0
0?ZJ003jVP050?ooo`80003o103oool2003jVP<0oooo0P000?l50?ooo`800?ZJ0P000000103oool0
003o0000o`3oool2003jVP030?ooo`00nYX00?ZJ00800?ZJ00<0oooo003jVP00nYX00P3oool30000
00<00?ZJ1`3oool00`000000oooo0?ooo`0I0?ooo`8000003P3oool200000080oooo0`00001f0?oo
o`80000000<0oooo000000000000Y03oool3000000H0oooo0P00000e0?ooo`00D03oool00`000000
oooo0?ooo`0B0?ooo`L00?ZJ00@0oooo000000000?l0003o0P0000020?ooo`@00?ZJ0P000004003j
VP8000000P000?l01000nYX000000000003oool2003jVP<0oooo0P00nYX20?ooo`<00?ZJ<P3oool3
003jVP<0oooo0`00nYX]0?ooo`800?ZJ7P3oool3000000<0oooo0P0000001@3oool00?ZJ0000o`00
0?l0000000800?ZJ0P000?l2003jVP030?ooo`000?l0003o00/0oooo0P000?l00`000000oooo0?oo
o`020000oa80oooo0P000003003jVPD0oooo0P000?l40?ooo`<00?ZJ0P3oool20000o`D0oooo0P00
nYX2000000040?ooo`000?l0003o0?ooo`L00?ZJ00<0oooo003jVP00nYX00P3oool3000000030?oo
o`00nYX00?ZJ00L0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0=0?ooo`<00000
00@0oooo0000000000000000MP3oool2000000030?ooo`00000000000:@0oooo0`0000070?ooo`03
0000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo01<0oooo1`00nYX00`000000003o
0000o`0200000080oooo0`00nYX3000000@00?ZJ0P0000020000o`04003jVP00000000000?ooo`<0
0?ZJ0P3oool2003jVP<0oooo0P00nYXc0?ooo`800?ZJ103oool2003jVTd0oooo0P0000040?ooo`80
000000@0oooo003jVP000?l0003o0`00nYX20000o`800?ZJ00<0oooo0000o`000?l02P3oool01000
0000003o0000o`0000020?ooo`80003o00<00?ZJ0?ooo`3oool03`3oool2000000<00?ZJ1@3oool2
0000o`@0oooo0`00nYX20?ooo`80003o1@3oool2003jVP<0oooo0P000?l20?ooo`T00?ZJ0P3oool3
000000030?ooo`00nYX00?ZJ00L0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0>
0?ooo`H00000MP3oool2000000040?ooo`000000000000000:<0oooo0P0000080?ooo`030000003o
ool0oooo03<0oooo001@0?ooo`030000003oool0oooo01@0oooo0`00nYX0103oool00?ZJ003jVP00
00070000o`800?ZJ0`000004003jVP06000000000?l0003o0000o`00nYX000000P3oool3003jVP80
oooo0P00nYX30?ooo`800?ZJR03oool2000000@0oooo0`0000000`00nYX0003o0000o`02003jVP03
0?ooo`000?l0003o00<00?ZJ0P000?l:0?ooo`04000000000?l0003o00000080oooo0P000?l00`00
nYX0oooo0?ooo`0?0?ooo`0300000000nYX00?ZJ00800?ZJ1@3oool20000o`@0oooo0`00nYX20?oo
o`80003o1@3oool2003jVP<0oooo0P000?l20?ooo`@00?ZJ00<0oooo003jVP00nYX00P00nYX30?oo
o`8000002P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00h0oooo1000001h0?oo
o`H00000X`3oool2000000P0oooo00<000000?ooo`3oool0<`3oool00500oooo0P00000E0?ooo`<0
0?ZJ00@0oooo003jVP00nYX00?ZJ1`000?l00`00nYX0000000000002000000<00?ZJ0P0000020000
o`800?ZJ00<000000?ooo`00nYX01000nYX00`3oool00?ZJ003jVP2=0?ooo`8000001@3oool20000
0003003jVP000?l0003o00800?ZJ00@0oooo0000o`000?l000000P00nYX20000o`X0oooo00@00000
0000o`000?l000000P3oool20000o`03003jVP3oool0oooo00l0oooo00<00000003jVP00nYX00P00
nYX40?ooo`03000000000?l0003o00@0oooo1000nYX00`3oool0003o0000o`050?ooo`800?ZJ0`3o
ool20000o`<0oooo0`00nYX00`3oool00?ZJ003jVP02003jVP<0oooo0P0000080?ooo`<000006`3o
ool00`000000oooo0?ooo`0>0?ooo`@00000N@3oool500000:<0oooo0P0000080?ooo`030000003o
ool0oooo03<0oooo001@0?ooo`030000003oool0oooo01D0oooo0P00nYX20?ooo`800?ZJ10000000
103oool0003o0000o`00nYX4000000<00?ZJ00@000000?ooo`000?l0003o0P00nYX01@000000oooo
003jVP00nYX0oooo00800?ZJ00<0oooo003jVP00nYX0S@3oool2000000D0oooo0P0000001P00nYX0
003o0000o`00nYX000000?ooo`80003o00<00000003jVP00nYX00P000?l:0?ooo`04000000000?l0
003o003jVP80oooo0P000?l00`00nYX0oooo0?ooo`0?0?ooo`D00?ZJ103oool01000nYX0003o0000
o`00nYX30?ooo`@00?ZJ00@0oooo0000o`000?l00?ZJ103oool70000o`@0oooo0P00nYX20?ooo`<0
0?ZJ0`3oool2000000X0oooo00<000000?ooo`3oool06@3oool2000000l0oooo1000001i0?ooo`D0
00003`3oool200000080oooo0P00002=0?ooo`<000001`3oool2000003D0oooo001@0?ooo`030000
003oool0oooo01T0oooo0`00nYX400000080003o1@000002003jVP80000000<0oooo0000o`000?l0
0`00nYX0103oool00?ZJ003jVP3oool5003jVXd0oooo0P0000050?ooo`80000000H00?ZJ0000o`00
0?l00?ZJ0000003oool20000o`030000003oool00?ZJ0080003o00<00?ZJ0?ooo`3oool01`3oool0
10000000003o0000o`00nYX20?ooo`80003o00<00?ZJ0?ooo`3oool03P3oool0100000000?ZJ003j
VP000002003jVP@0oooo00@00?ZJ0000o`000?l00?ZJ0`3oool4003jVP040?ooo`000?l0003o003j
VP@0oooo1`000?l90?ooo`800?ZJ3`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo
00h0oooo1000001i0?ooo`80000000<0oooo0000000000003`3oool200000080oooo0P00002=0?oo
o`8000002@3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`0J0?ooo`80
0?ZJ00@000000?ooo`00000000000`000?l010000000oooo000000000002003jVP030000003oool0
oooo0080003o0`00nYX00`3oool00?ZJ003jVP020?ooo`@00?ZJS@3oool2000000D0oooo0P000000
0`00nYX0003o0000o`02000000040?ooo`000?l0003o00000080oooo0P000?l00`00nYX0oooo0?oo
o`070?ooo`06000000000?l0003o003jVP000000oooo0P000?l00`00nYX0oooo0?ooo`070?ooo`80
0?ZJ1@3oool3003jVP0300000000nYX00?ZJ00@0oooo00@00?ZJ0000o`000?l00?ZJ0`3oool4003j
VP040?ooo`000?l0003o003jVP@0oooo0P000?l30?ooo`800?ZJ2@3oool2003jVPl0oooo00<00000
0?ooo`3oool06@3oool00`000000oooo0?ooo`0>0?ooo`@00000O03oool2000000l0oooo0`000000
103oool0000000000000002<0?ooo`8000002@3oool00`000000oooo0?ooo`0c0?ooo`00D03oool0
0`000000oooo0?ooo`0J0?ooo`<00?ZJ00@0oooo00000000000000000P000?l30?ooo`@000000P3o
ool20000o`H00?ZJ0`3oool3003jVXd0oooo0P0000050?ooo`80000000<00?ZJ0000o`000?l00P00
0000103oool0003o0000o`0000020?ooo`80003o00<00?ZJ0?ooo`3oool01`3oool00`00nYX0003o
0000o`02003jVP040?ooo`000?l0003o003jVPP0oooo0`00nYX50?ooo`800?ZJ00@0oooo00000000
nYX00?ZJ103oool00`00nYX0003o0000o`02003jVP030?ooo`00nYX00?ZJ00<00?ZJ00@0oooo0000
o`000?l00?ZJ103oool20000o`<0oooo0P00nYX90?ooo`800?ZJ3`3oool00`000000oooo0?ooo`0I
0?ooo`030000003oool0oooo00l0oooo0P00001m0?ooo`<000003@3oool4000000040?ooo`000000
0000000008/0oooo0`0000090?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0
oooo01X0oooo00@00000003jVP00nYX0oooo0`0000040000o`040?ooo`0000000000000000<0oooo
0P000?l00`00nYX0oooo003jVP03003jVP<0oooo0`00nYZD0?ooo`80000000<00?ZJ0000o`000?l0
0P000000103oool0003o0000o`0000020?ooo`80003o00<00?ZJ0?ooo`3oool01`3oool00`00nYX0
003o0000o`02003jVP040?ooo`000?l0003o003jVPP0oooo0`00nYX40?ooo`<00?ZJ00@0oooo0000
0000nYX00?ZJ103oool00`00nYX0003o0000o`02003jVP040?ooo`00nYX00?ZJ000000<00?ZJ0P00
0?l01@00nYX0oooo0?ooo`3oool000000080003o0`3oool2003jVQX0oooo00<000000?ooo`3oool0
6@3oool00`000000oooo0?ooo`2?0?ooo`8000003@3oool4000000040?ooo`0000000000000008/0
oooo0P00000:0?ooo`030000003oool0oooo03<0oooo001@0?ooo`8000006`3oool0100000000?ZJ
003jVP3oool3000000L0003o00@000000?ooo`3oool0oooo0P000?l00`00nYX0oooo0?ooo`03003j
VP@0oooo0P00nYZE0?ooo`0400000000nYX0003o0000o`80000000<0oooo0000o`000?l00P000000
103oool0003o0000o`00nYX90?ooo`03003jVP000?l0003o00800?ZJ00@0oooo0000o`000?l00?ZJ
1`3oool4003jVP@0oooo0P00nYX00`000000oooo00000002003jVP<0oooo00@00000003jVP000?l0
003o0P00nYX00`3oool00?ZJ003jVP02000000800?ZJ0P000?l01@00nYX000000000003oool00000
0080003o0`3oool2003jVQP0oooo0`00000K0?ooo`030000003oool0oooo08l0oooo0P00000=0?oo
o`@0000000@0oooo0000000000000000R`3oool2000000X0oooo00<000000?ooo`3oool0<`3oool0
0500oooo00<000000?ooo`3oool06P3oool0100000000?ZJ003jVP00nYX5000000030?ooo`000?l0
003o0080003o00@000000?ooo`3oool0oooo0P000?l00`00nYX0oooo0?ooo`03003jVY/0oooo0P00
00020000o`80000000<0oooo0000o`000?l00P000000103oool0003o0000o`00nYX90?ooo`03003j
VP000?l0003o00800?ZJ00@0oooo0000o`000?l00?ZJ0`3oool2003jVP80oooo1000nYX40?ooo`80
0?ZJ00<000000?ooo`0000000P00nYX30?ooo`0400000000nYX0003o0000o`D00?ZJ0P000002003j
VP80003o00D00?ZJ000000000000oooo003jVP020000o`<0oooo0P00nYXJ0?ooo`030000003oool0
oooo01T0oooo0P00002@0?ooo`8000002P3oool2000000030?ooo`00000000000080000000@0oooo
0000000000000000R`3oool2000000T0oooo0P00000e0?ooo`00D03oool00`000000oooo0?ooo`0J
0?ooo`8000000P00nYX3000000D0oooo20000?l01000nYX0oooo0?ooo`3oool2003jVY/0oooo0P00
00020000o`80000000<0oooo0000o`000?l00P000000103oool0003o0000o`00nYX90?ooo`03003j
VP000?l0003o00<00?ZJ0P000?l01000nYX0oooo0?ooo`3oool2003jVP030?ooo`00nYX00?ZJ00<0
0?ZJ103oool2003jVP030000003oool0000000800?ZJ0`3oool01@0000000?ZJ0000o`000?l0oooo
00@00?ZJ0P0000001@3oool00?ZJ0000o`000?l00?ZJ0080000000@0oooo003jVP000?l0003o0`3o
ool2003jVQX0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`2?0?ooo`8000002P3o
ool;000008/0oooo0P00000:0?ooo`030000003oool0oooo03<0oooo000l0?ooo`<000000`3oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool06P3oool2
000000800?ZJ00<0oooo0000000000001P3oool70000o`03003jVP3oool0oooo09h0oooo0P000002
0000o`030000003oool0oooo0080003o0P000000103oool0003o0000o`00nYX80?ooo`0500000000
nYX0003o0000o`0000000P00nYX20000o`03003jVP3oool0oooo00<00?ZJ00@0oooo003jVP00nYX0
oooo0P00nYX40?ooo`800?ZJ00<000000?ooo`0000000P00nYX30?ooo`0500000000nYX0003o0000
o`3oool01000nYX200000080oooo0P000?l01@00nYX000000000003oool00?ZJ0080003o0`3oool2
003jVQX0oooo00<000000?ooo`3oool01@3oool2000000@0oooo00<000000?ooo`3oool00P3oool3
000000H0oooo00<000000?ooo`3oool0S`3oool2000000X0oooo100000000`3oool0000000000004
000008/0oooo0P00000:0?ooo`030000003oool0oooo03<0oooo000m0?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0J0?ooo`8000000`00nYX20000
00/0oooo0`00nYZP0?ooo`8000000P000?l00`000000oooo0?ooo`020000o`80000000@0oooo0000
o`000?l00?ZJ203oool01@0000000?ZJ0000o`000?l0000000800?ZJ0`000?l00`3oool00?ZJ003j
VP05003jVP030?ooo`00nYX00?ZJ00@0oooo0P00nYX20?ooo`0400000000nYX00?ZJ003jVP80oooo
00D00000003jVP000?l0003o0?ooo`04003jVP8000000P3oool20000o`05003jVP00000000000?oo
o`00nYX00P000?l30?ooo`800?ZJ6P3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo
000000L0oooo00D000000?ooo`3oool0oooo000000050?ooo`030000003oool0oooo08l0oooo0P00
000:0?ooo`@0000000<0oooo000000000000100000290?ooo`@000002P3oool00`000000oooo0?oo
o`0c0?ooo`00>P3oool5000000X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0J
0?ooo`80000000<0oooo003jVP00nYX00P000002003jVPT0oooo0P00nYZQ0?ooo`8000000P000?l0
0`000000oooo0?ooo`020000o`80000000@0oooo0000o`000?l00?ZJ203oool0100000000?ZJ0000
o`000?l2000000800?ZJ0P000?l00`3oool00?ZJ003jVP04003jVP80oooo0P00nYX40?ooo`800?ZJ
0P3oool2000000800?ZJ0P3oool0100000000?ZJ0000o`000?l20?ooo`<00?ZJ0P0000020?ooo`80
003o00D00?ZJ0000000000000000003jVP020000o`<0oooo0P00nYXJ0?ooo`030000003oool0oooo
00@0oooo00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo08l0oooo0`0000090?ooo`@0000000<0oooo0000000000001@0000280?ooo`<000002`3oool0
0`000000oooo0?ooo`0c0?ooo`00>P3oool010000000oooo0?ooo`00000;0?ooo`030000003oool0
oooo00@0oooo0`00000J0?ooo`80000000D0oooo003jVP00nYX00?ZJ0?ooo`02003jVPT0oooo0P00
nYZR0?ooo`03000000000?l0003o00D0003o0P000000103oool0003o0000o`00nYX80?ooo`040000
0000nYX0003o0000o`8000000P00nYX20000o`L00?ZJ0P3oool2003jVP@0oooo1`000?l01@00nYX0
oooo0?ooo`0000000?ZJ0080003o0P3oool3003jVP8000000P3oool20000o`05003jVP0000000000
00000000nYX00P000?l00`00nYX0oooo0?ooo`02003jVQL0oooo100000060?ooo`040000003oool0
oooo000000T0oooo0P0000060?ooo`<000000`3oool8003jVXD0oooo0`0000080?ooo`<000000P3o
ool4000000030?ooo`000000000008P0oooo0`0000090?ooo`<00000=@3oool003/0oooo00<00000
0?ooo`000000303oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01X0oooo0P000002
0?ooo`800?ZJ00@0oooo003jVP00nYX00?ZJ0`3oool2003jVP<0oooo0P00nYZR0?ooo`0300000000
0?l0003o00D0003o0P000000103oool0003o0000o`00nYX80?ooo`0400000000nYX0003o0000o`80
000000@0oooo003jVP000?l0003o0P00nYX20?ooo`<00?ZJ0P3oool2003jVP@0oooo1`000?l01000
nYX0oooo0?ooo`0000030000o`<0oooo0P00nYX200000080oooo0`000?l300000004003jVP000?l0
003o003jVP80oooo0P00nYXJ0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool00000
2`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo4@00nYYl0?ooo`L00000
103oool2000000<0oooo100000000`3oool00000000000280?ooo`<000002`3oool00`000000oooo
0?ooo`0c0?ooo`00?03oool2000000P0oooo00D000000?ooo`3oool0oooo000000050?ooo`030000
003oool0oooo01X0oooo0P0000020?ooo`H00?ZJ0`3oool2003jVP<0oooo0P00nYZR0?ooo`040000
0000nYX00?ZJ00000080oooo0P00nYX2000000040?ooo`000?l0003o0000o`P0oooo00@00000003j
VP000?l0003o0P000000103oool00?ZJ0000o`000?l2003jVP80oooo0`00nYX20?ooo`800?ZJ103o
ool20000o`<0oooo0P000?l01000nYX0oooo0?ooo`00nYX20000o`03003jVP3oool0oooo00<0oooo
0P0000020?ooo`03003jVP000?l0003o00<0000000<00?ZJ0000o`000?l00P00nYX00`3oool00?ZJ
003jVP0J0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000001`3oool01@000000
oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool01`3ooolI003jVW40oooo1P0000040?oo
o`8000001@3oool2000000030?ooo`000000000008L0oooo1000000;0?ooo`030000003oool0oooo
03<0oooo000m0?ooo`030000003oool0oooo00H0oooo1@0000050?ooo`030000003oool0oooo01l0
oooo1@00nYX30?ooo`<00?ZJ0P3oool2003jVZ80oooo00@00000003jVP00nYX000000P3oool2003j
VP<0000000<00?ZJ0000o`000?l01`3oool200000003003jVP000?l0003o0080000000@0oooo003j
VP000?l0003o0P00nYX20?ooo`800?ZJ0`3oool2003jVP@0oooo0P000?l30?ooo`80003o00@00?ZJ
0?ooo`3oool00?ZJ0P000?l00`00nYX0oooo0?ooo`030?ooo`<0000000@0oooo003jVP000?l0003o
0`0000000`00nYX0003o0000o`02003jVP030?ooo`00nYX00?ZJ01X0oooo00<000000?ooo`3oool0
1@3oool2000000T0oooo0`0000060?ooo`030000003oool0oooo01<0oooo5P00nYYX0?ooo`H00000
103oool2000000D0oooo0P0000000`3oool00000000000270?ooo`@000002`3oool00`000000oooo
0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`0O0?ooo`H00?ZJ0P3oool3003jVP80oooo0P00
nYZR0?ooo`0400000000nYX00?ZJ00000080oooo0P00nYX0103oool0000000000000nYX20000o`L0
oooo0P0000030000o`80000000@0oooo003jVP000?l0003o0P00nYX0103oool00000003jVP00nYX3
0?ooo`800?ZJ103oool20000o`<0oooo0P000?l01000nYX0oooo0?ooo`00nYX20000o`03003jVP3o
ool0oooo00@0oooo0P000000103oool00?ZJ0000o`000?l300000003003jVP000?l0003o00D00?ZJ
6P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01l0oooo3P00nYYT0?ooo`<00000
00<0oooo000000000000103oool2000000P0oooo0P0000270?ooo`8000003@3oool00`000000oooo
0?ooo`0c0?ooo`00D03oool200000200oooo0`00nYX00`3oool00?ZJ003jVP020?ooo`<00?ZJ0P3o
ool2003jVZ80oooo00@00000003jVP00nYX000000P3oool2003jVP040?ooo`0000000000003jVP80
003o1`3oool200000080003o00D00?ZJ000000000000oooo003jVP020000o`03003jVP3oool0oooo
00800000103oool2003jVP@0oooo0P000?l30?ooo`80003o00@00?ZJ0?ooo`00nYX00?ZJ0P000?l0
0`00nYX0oooo0?ooo`040?ooo`80000000@0oooo003jVP000?l0003o0`0000001000nYX0003o0000
o`3oool4003jVQP0oooo0`00000K0?ooo`800000:@3oool;003jVUh0oooo0`0000000`3oool00000
000000040?ooo`800000203oool2000003d0oooo0P0000100?ooo`8000001P3oool2000000`0oooo
0P00000e0?ooo`00D03oool00`000000oooo0?ooo`0P0?ooo`800?ZJ00D0oooo003jVP00nYX00?ZJ
0?ooo`04003jVP030?ooo`00nYX00?ZJ0:80oooo00@00000003jVP00nYX000000P3oool2003jVP04
0?ooo`0000000000003jVP80003o1`3oool200000080003o00D00?ZJ000000000000oooo003jVP02
0000o`03003jVP3oool0000000800000103oool2003jVP@0oooo0P000?l30?ooo`80003o00@00?ZJ
0?ooo`00nYX00?ZJ0P000?l00`00nYX0oooo0?ooo`040?ooo`80000000@0oooo003jVP000?l0003o
0`0000001000nYX0003o0000o`3oool4003jVQX0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`0/0?ooo`d00?ZJF03oool200000080oooo0P0000040?ooo`800000203oool2000003d0
oooo0P0000100?ooo`8000001P3oool2000000d0oooo00<000000?ooo`3oool0<`3oool00500oooo
00<000000?ooo`3oool0903oool7003jVP030?ooo`00nYX00?ZJ0:80oooo00@00000003jVP00nYX0
00000P3oool2003jVP040?ooo`0000000000003jVP80003o1`3oool200000080003o00D00?ZJ0000
00000000oooo003jVP020000o`03003jVP3oool0000000<000000`3oool2003jVP@0oooo0P000?l3
0?ooo`80003o1000nYX20000o`03003jVP3oool0oooo00@0oooo0P000000103oool00?ZJ0000o`00
0?l200000004003jVP000?l0003o0000o`80oooo0`00nYXJ0?ooo`030000003oool0oooo01T0oooo
00<000000?ooo`3oool0<P3oool=003jVU80oooo0P0000020?ooo`<000000`3oool2000000P0oooo
0P00000m0?ooo`800000>`3oool2000000<0oooo0P0000060?ooo`8000003@3oool00`000000oooo
0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`0T0?ooo`@00?ZJ00@0oooo003jVP00nYX0oooo
0P00nYZS0?ooo`800?ZJ0`3oool2003jVP040?ooo`0000000000003jVP80003o1`3oool01@000000
0?ZJ0000o`000?l00?ZJ0080000000H0oooo003jVP000?l0003o0000003oool4000000<0oooo0P00
nYX40?ooo`80003o00<00?ZJ0?ooo`3oool00P000?l3003jVP04000000000?l0003o003jVPH0oooo
0P0000001@3oool00?ZJ0000o`000?l0000000800?ZJ0P000?l01000nYX0oooo0?ooo`3oool2003j
VQX0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0h0?ooo`/00?ZJCP3oool20000
00<0oooo0P0000030?ooo`800000203oool2000003d0oooo0`00000j0?ooo`8000000P3oool30000
00030?ooo`000000000000<0oooo0P00000=0?ooo`030000003oool0oooo03<0oooo001@0?ooo`03
0000003oool0oooo02@0oooo1000nYX0103oool00?ZJ003jVP3oool2003jVZ<0oooo0P00nYX30?oo
o`800?ZJ00@0oooo0000000000000?ZJ0P000?l70?ooo`0500000000nYX0003o0000o`00nYX00P00
00001P3oool00?ZJ0000o`000?l000000?ooo`8000001`000?l200000080oooo0P000?l00`00nYX0
oooo0?ooo`020000o`<00?ZJ00@000000000o`000?l00?ZJ1P3oool2000000050?ooo`00nYX0003o
0000o`0000000P00nYX20000o`03003jVP3oool0oooo01d0oooo00<000000?ooo`3oool06@3oool0
0`000000oooo0?ooo`0n0?ooo`l00?ZJA03oool2000000<0oooo0P0000030?ooo`800000203oool3
000003/0oooo1000000j0?ooo`<0000000D0oooo00000000000000000?ooo`0200000080oooo0`00
000=0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo02@0oooo1000nYX0
0`3oool00?ZJ003jVP03003jVZ<0oooo0P00nYX30?ooo`800?ZJ00@0oooo0000000000000?ZJ0P00
0?l70?ooo`800?ZJ0P000?l01@00nYX000000000003oool00?ZJ0080003o00@000000?ooo`000000
00001`000?l200000080oooo0P000?l00`00nYX0oooo0?ooo`030000o`03003jVP00000000000080
003o00<00?ZJ0?ooo`3oool0103oool300000003003jVP000?l0003o00<00?ZJ0P000?l00`00nYX0
oooo0?ooo`0M0?ooo`030000003oool0oooo01T0oooo0P0000130?oooa@00?ZJ@03oool2000000<0
oooo0P0000090?ooo`800000>`3oool4000003T0oooo100000000`3oool0000000000008000000d0
oooo0P00000e0?ooo`00D03oool2000002H0oooo0`00nYX20?ooo`@00?ZJX`3oool3003jVP80oooo
0P00nYX0103oool0000000000000nYX20000o`L0oooo0P00nYX20000o`03003jVP00000000000080
oooo0P000?l010000000oooo0000000000020000o`<0oooo0P000?l200000080oooo0P000?l2003j
VP050?ooo`000000003o0000o`00nYX00P0000020000o`03003jVP3oool0oooo00@0oooo0`000000
0`00nYX0003o0000o`02003jVP040?ooo`000?l0003o003jVQd0oooo0`00000K0?ooo`030000003o
ool0oooo04`0oooo7@00nYX40?ooo`<00?ZJ9P3oool2000000<0oooo0P0000090?ooo`800000>`3o
ool4000000<0oooo0P00000c0?ooo`D0000000<0oooo0000000000002000000>0?ooo`030000003o
ool0oooo03<0oooo001@0?ooo`030000003oool0oooo02H0oooo0P00nYX20?ooo`@00?ZJY03oool2
003jVP80oooo0P00nYX0103oool0000000000000nYX20000o`<0oooo0P00nYX20?ooo`800?ZJ0P00
0?l01@00nYX00000000000000000oooo0080003o0`0000030000o`<0oooo0P000?l200000080oooo
0P000?l2003jVP050?ooo`000000003o0000o`00nYX00P0000020000o`03003jVP3oool0oooo00@0
oooo0`0000000`00nYX0003o0000o`02003jVP040?ooo`000?l0003o003jVQl0oooo00<000000?oo
o`3oool06@3oool00`000000oooo0?ooo`1E0?ooob@00?ZJ7@3oool2000000<0oooo0P0000090?oo
o`800000>`3oool4000000<0oooo0P00000c0?ooo`D0000000<0oooo0000000000002000000>0?oo
o`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo02/0oooo0`00nYZT0?ooo`<0
0?ZJ00<0oooo003jVP00nYX00P3oool0100000000?ZJ0000o`000?l20?ooo`<00?ZJ00@0oooo003j
VP00nYX00?ZJ0P000?l01@00nYX0oooo000000000000oooo00@0003o00@000000000o`000?l00000
0`3oool20000o`8000000P3oool20000o`800?ZJ00@0oooo000000000?l0003o0`0000020000o`L0
oooo0`0000001000nYX0003o0000o`00nYX20?ooo`80003o00<00?ZJ0?ooo`3oool07@3oool00`00
0000oooo0?ooo`0I0?ooo`030000003oool0oooo06P0oooo1P00nYX00`3oool00?ZJ003jVP0>003j
VQL0oooo0P0000000`3oool0000000000002000000T0oooo0`00000c0?ooo`D00?ZJ00<0oooo0000
0000000010000000103oool0000000000000000c0?ooo`80000000@0oooo000000000000oooo2P00
000>0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo02`0oooo0P00nYZU
0?ooo`800?ZJ00<0oooo003jVP00nYX00P3oool0100000000?ZJ0000o`000?l20?ooo`<00?ZJ00@0
0000003jVP00nYX000000P000?l01@00nYX0oooo000000000000oooo00L0003o00@00?ZJ0?ooo`3o
ool0oooo0P000?l200000080oooo0P000?l3003jVP030?ooo`000?l0003o00<000000P000?l70?oo
o`@000000P000?l00`00nYX0oooo0?ooo`020000o`03003jVP3oool0oooo01d0oooo00<000000?oo
o`3oool06@3oool00`000000oooo0?ooo`1h0?oooa@00?ZJ2P3oool7003jVPX0oooo0P00000W0?oo
o`800?ZJ2P3oool=003jVP<000003@3oool7003jVQl0oooo0P0000000`3oool00000000000060000
01<0oooo00<000000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool0d`3oool5003jVP<0
oooo00<000000000o`000?l00P3oool6003jVP05000000000?l0003o003jVP3oool00P000000103o
ool00?ZJ003jVP0000040000o`04003jVP000000oooo0?ooo`80003o00@00?ZJ000000000000oooo
0P000?l0103oool00?ZJ003jVP00nYX20000o`<000000P000?l70?ooo`@000000P000?l00`00nYX0
oooo0?ooo`020000o`03003jVP3oool0oooo01d0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`1n0?ooobX00?ZJ00<000000?ooo`0000000P00000S0?ooo`L00?ZJ103oool3003jVP80
oooo2@00nYX4000000T00?ZJ0`3oool7003jVQl0oooo0P0000020?ooo`<0000000@0oooo00000000
000000004`3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`3D0?ooo`@0
0?ZJ0`3oool010000000003o0000o`3oool6003jVP8000000P000?l20?ooo`80000000<0oooo003j
VP00nYX00`000000103oool00?ZJ003jVP0000020?ooo`80003o00@00?ZJ000000000000oooo0P00
0?l20?ooo`800?ZJ0P000?l300000080003o1`3oool400000080003o00<00?ZJ0?ooo`3oool00P00
0?l00`00nYX0oooo0?ooo`0M0?ooo`030000003oool0oooo01T0oooo0P00002<0?ooo``00?ZJ1@00
000B003jVQ`0oooo4`00nYX50?ooo`8000000P3oool00`0000000?ZJ003jVP04000000h00?ZJ0`3o
ool4003jVP<0oooo1`00nYX:0?ooo`L00?ZJ0P3oool200000080oooo0`0000020?ooo`8000004P3o
ool2000003D0oooo001@0?ooo`800000e@3oool4003jVP<0oooo00@000000000o`000?l0oooo0P00
nYX01P3oool00?ZJ003jVP00nYX000000?ooo`80003o0P3oool2000000030?ooo`00nYX00?ZJ00<0
000000@0oooo003jVP00nYX00?ZJ0P3oool20000o`04003jVP00000000000?ooo`80003o0P3oool2
003jVP80003o0`0000020000o`L0oooo100000020000o`03003jVP3oool0oooo0080003o00<00?ZJ
0?ooo`3oool06`3oool3000001/0oooo00<000000?ooo`3oool0U`3oool6000000X0oooo3@00nYX0
0`000000oooo0?ooo`070?ooo`<00?ZJ0`3oool=003jVPD0oooo1`00nYX50?ooo`8000000P3oool0
0`0000000?ZJ003jVP06003jVPH0oooo1@00nYX50?ooo`d00?ZJ2P3oool7003jVP80oooo0P000002
0?ooo`<000005`3oool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`3E0?oo
o`<00?ZJ0`3oool00`000000003o0000o`03003jVP060?ooo`00nYX00?ZJ003jVP000000oooo0P00
0?l20?ooo`80000000<0oooo003jVP00nYX00`000000103oool00?ZJ003jVP00nYX20?ooo`80003o
00@00?ZJ000000000000oooo0P000?l30?ooo`03003jVP000?l0003o00D0003o1`3oool400000080
003o00<000000?ooo`3oool00P000?l00`00nYX0oooo0?ooo`0M0?ooo`030000003oool0oooo01T0
oooo00<000000?ooo`3oool0V03oool4000000`0oooo1@000007003jVP030000003oool0oooo00L0
oooo3@00nYXG0?ooo`8000000P3oool00`0000000?ZJ003jVP05003jVQ<0oooo1@00nYX40?ooo`h0
0?ZJ00<000000?ooo`3oool02000nYX00`3oool000000000000G0?ooo`030000003oool0oooo03<0
oooo001@0?ooo`030000003oool0oooo0=H0oooo0P00nYX30?ooo`03000000000?l0003o00800?ZJ
0P3oool2003jVP80000000<0oooo0000o`000?l00P3oool2000000030?ooo`00nYX00?ZJ00<00000
00@0oooo003jVP00nYX00?ZJ0P3oool20000o`04003jVP00000000000?ooo`80003o0`3oool00`00
nYX0003o0000o`050000o`L0oooo100000020000o`030000003oool0oooo0080003o00<00?ZJ0?oo
o`3oool07@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo09T0oooo0`00000<0?oo
o`H00000103ooolC003jVQd0oooo0P0000020?ooo`@0000000<0oooo0000000000007P3oool<003j
VP8000000`3ooolC003jVP@0oooo0`00nYX70?ooo`030000003oool0oooo03<0oooo001@0?ooo`03
0000003oool0oooo0=/0oooo00<000000000o`000?l00P00nYX20?ooo`800?ZJ0P0000000`3oool0
003o0000o`020?ooo`80000000<0oooo003jVP00nYX00`000000103oool00?ZJ003jVP00nYX20?oo
o`80003o00@00?ZJ00000000000000000P000?l30?ooo`800?ZJ0`0000000`3oool0003o0000o`07
0?ooo`@000000P000?l00`000000oooo0?ooo`020000ob00oooo00<000000?ooo`3oool06@3oool0
0`000000oooo0?ooo`2J0?ooo`800000303oool6000000D0oooo3@00nYX30?ooo`8000007@3oool2
000000<0oooo0`000000103oool000000000000000040?ooo`8000008P3oool3000000H0oooo0P00
00000`3oool00?ZJ003jVP0B003jVPL0oooo00<000000?ooo`3oool0<`3oool00500oooo00<00000
0?ooo`3oool0f`3oool010000000003o0000o`00nYX30?ooo`@0000000<0oooo0000o`000?l00P3o
ool3000000<00?ZJ00<000000?ooo`3oool00`00nYX20?ooo`80003o00@00?ZJ0000000000000000
0P000?l30?ooo`800?ZJ0`0000000`3oool00?ZJ003jVP070?ooo`@000000P000?l00`000000oooo
0?ooo`020000ob00oooo00<000000?ooo`3oool06@3oool2000009/0oooo0P00000<0?ooo`H00000
1@3oool3000000d0oooo0P00000K0?ooo`@000000`3oool300000080oooo0P0000040?ooo`800000
8P3oool3000000D0oooo0`00000=0?ooo`L00?ZJ1`3oool2000003D0oooo001@0?ooo`800000g03o
ool010000000003o0000o`00nYX30?ooo`@0000000<0oooo0000o`000?l00P3oool4000000800?ZJ
00<000000?ooo`3oool01000nYX0103oool0003o0000o`00nYX300000080003o0`3oool3003jVP80
000000<0oooo003jVP00nYX01`3oool400000080003o0`3oool20000oah0oooo0`00000K0?ooo`03
0000003oool0oooo09X0oooo0P00000<0?ooo`H000001@3oool3000000d0oooo1000000G0?ooo`D0
0000103oool2000000<0oooo0P0000040?ooo`<00000803oool5000000@0oooo0`00000L0?ooo`03
0000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0=/0oooo00@000000000o`000?l0
0?ZJ0`3oool4000000030?ooo`000?l0003o0080oooo10000002003jVP030000003oool0oooo00@0
0?ZJ00@0oooo0000o`000?l00?ZJ0`0000020000o`@0oooo0P00nYX2000000030?ooo`00nYX00?ZJ
00L0oooo100000070000ob00oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`2J0?oo
o`800000303oool6000000D0oooo0`00000<0?ooo`D000001`3oool2000000h0oooo1@0000040?oo
o`8000000`3oool2000000<0oooo1000000P0?ooo`80000000<0oooo0000000000000`3oool40000
01`0oooo00<000000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool0f`3oool00`000000
003o0000o`040?ooo`@0003o00<0oooo0000o`000?l00P3oool4000000<00?ZJ00<0oooo003jVP00
nYX01000nYX20000o`04003jVP3oool0000000000080003o103oool2003jVP80000000<0oooo003j
VP00nYX01`3oool4000000L0003o803oool010000000oooo0000000000040?ooo`030000003oool0
oooo0080oooo0`0000030?ooo`<000001P3oool00`000000oooo0?ooo`2J0?ooo`8000003@3oool6
000000@0oooo0`00000<0?ooo`D000001`3oool2000000T0oooo0`0000020?ooo`D00000103oool2
000000<0oooo0P0000030?ooo`@00000803oool2000000030?ooo`000000000000<0oooo1000000L
0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0=/0oooo00<000000000
o`000?l0103oool70000o`<0oooo0`000000103oool00?ZJ003jVP3oool2003jVP8000000P00nYX2
0000o`04003jVP3oool0000000000080003o103oool2003jVP<0oooo0P00nYX70?ooo`@000000P00
nYX30?ooo`800?ZJ803oool200000080oooo00<000000?ooo`3oool01@3oool01`000000oooo0?oo
o`3oool000000?ooo`0000000`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0:T0
oooo0`0000000`3oool00000000000030?ooo`@00000303oool6000000@0oooo100000090?ooo`<0
000000<0oooo000000000000100000090?ooo`8000000`3oool400000200oooo0P000000103oool0
00000000000000020?ooo`@00000703oool00`000000oooo0?ooo`0c0?ooo`00=P3oool3000000<0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`<000001P3oool00`000000
oooo0?ooo`3K0?ooo`03000000000?l0003o00@0oooo0P000?l00`3oool0003o0000o`020000o`<0
oooo0`000000103oool00?ZJ003jVP3oool2003jVP8000000P00nYX20000o`04003jVP3oool00000
003jVP80003o103oool3003jVP80oooo0P00nYX70?ooo`<0000000<0oooo003jVP00nYX00`3oool2
003jVR00oooo0P0000020?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`030?ooo`<00000ZP3oool2000000030?ooo`000000000000<0oooo1000000<
0?ooo`H0000000@0oooo000000000000oooo1@0000080?ooo`<0000000<0oooo0000000000003@3o
ool2000000<0oooo1000000P0?ooo`80000000<0oooo0000000000001`00000J0?ooo`<00000=@3o
ool003L0oooo00<000000?ooo`3oool0203oool01@000000oooo0?ooo`3oool0000000<0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`3K0?ooo`03000000000?l0003o008000000P3o
ool20000o`<0oooo0P00nYX30?ooo`<0000000@0oooo003jVP00nYX0oooo0P00nYX2000000030?oo
o`00nYX0003o0080003o00<0oooo00000000nYX00P000?l50?ooo`800?ZJ0P3oool2003jVPL0oooo
0`0000000`3oool00?ZJ003jVP030?ooo`800?ZJ803oool200000080oooo00<000000?ooo`3oool0
1`3oool2000000H0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2]0?ooo`800000
0`3oool4000000`0oooo0P0000020?ooo`D0000000<0oooo0000000000000`0000080?ooo`<00000
00<0oooo0000000000003@3oool2000000<0oooo1000000P0?ooo`80000000<0oooo000000000000
100000000`3oool000000000000L0?ooo`030000003oool0oooo03<0oooo000d0?ooo`D000002P3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo0`00003K0?ooo`0300000000
0?l0003o00<000000`000?l30?ooo`800?ZJ0`3oool3000000040?ooo`00nYX00?ZJ0?ooo`800?ZJ
0P0000020?ooo`04003jVP000?l0003o0?ooo`800?ZJ0P000?l50?ooo`800?ZJ0P3oool2003jVPL0
oooo0`0000000`3oool00?ZJ003jVP030?ooo`800?ZJ7@3oool500000080oooo00<000000?ooo`3o
ool02@3oool00`000000oooo00000003000000H0oooo00<000000?ooo`3oool0[@3oool2000000<0
oooo1000000<0?ooo`8000000`3oool4000000030?ooo`000000000000<00000203oool300000003
0?ooo`000000000000d0oooo0`0000020?ooo`@000007`3oool300000080oooo1@00000O0?ooo`03
0000003oool0oooo03<0oooo000d0?ooo`040000003oool0oooo000000/0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0=`0oooo1`000?l40?ooo`80
0?ZJ0`3oool200000080oooo1@00nYX200000080oooo00@00?ZJ0000o`000?l0oooo0P00nYX20000
o`D0oooo0`00nYX00`3oool00?ZJ003jVP070?ooo`<0000000<0oooo003jVP00nYX00`3oool2003j
VR00oooo0P0000020?ooo`030000003oool0oooo00D0oooo00L000000?ooo`3oool0oooo0000003o
ool0000000T0oooo00<000000?ooo`3oool0[@3oool2000000<0oooo100000080?ooo`8000000P3o
ool2000000<0oooo100000000`3oool0000000000003000000L0oooo100000000`3oool000000000
000>0?ooo`8000000P3oool4000001l0oooo0P0000030?ooo`@00000803oool00`000000oooo0?oo
o`0c0?ooo`00=@3oool00`000000oooo0000000<0?ooo`030000003oool0000000<000001P3oool0
0`000000oooo0?ooo`3L0?ooo`L0003o00@00?ZJ0?ooo`3oool0oooo0P00nYX30?ooo`8000000`3o
ool4003jVP8000000P3oool00`00nYX0003o0000o`03003jVP80003o1P3oool2003jVP030?ooo`00
nYX00?ZJ00L0oooo0`0000000`3oool00?ZJ003jVP030?ooo`800?ZJ803oool010000000oooo0000
000000090?ooo`<000000P3oool5000000D0oooo00<000000?ooo`3oool0[@3oool2000000<0oooo
100000080?ooo`80000000@0oooo00000000000000000`3oool<000000D0oooo1`00000>0?ooo`80
00000P3oool5000001h0oooo0P0000040?ooo`<00000803oool00`000000oooo0?ooo`0c0?ooo`00
=P3oool2000000P0oooo00L000000?ooo`3oool0oooo0000003oool0000000T0oooo00<000000?oo
o`3oool0g03oool2003jVP8000000`000?l01000nYX0oooo0?ooo`3oool2003jVP<0oooo0P000004
0?ooo`<00?ZJ0P0000020?ooo`03003jVP000?l0003o00800?ZJ00<000000000o`000?l01P3oool2
003jVP030?ooo`00nYX00?ZJ00P0oooo0P000000103oool00?ZJ003jVP00nYX20?ooo`800?ZJ803o
ool00`000000oooo0?ooo`0I0?ooo`800000[P3oool2000000<0oooo100000080?ooo`80000000<0
oooo000000000000103oool<000000@0oooo0`0000000`3oool0000000000002000000h0oooo0P00
00020?ooo`80000000<0oooo0000000000007P3oool2000000@0oooo0`00000O0?ooo`800000=@3o
ool003L0oooo00<000000?ooo`3oool01P3oool5000000030?ooo`000000000000<000001@3oool0
0`000000oooo0?ooo`3L0?ooo`800?ZJ10000003003jVP80oooo0P00nYX90?ooo`<00?ZJ0P000002
0?ooo`03003jVP000?l0003o00800?ZJ00<000000000o`000?l01P3oool5003jVPP0oooo0P000002
0?ooo`800?ZJ0P3oool2003jVR00oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`2]
0?ooo`<000000P3oool4000000P0oooo0P0000000`3oool00000000000050?ooo`L0000000@0oooo
0000000000000000103oool3000000030?ooo`0000000000008000003P3oool200000080oooo0P00
00000`3oool000000000000N0?ooo`800000103oool200000240oooo00<000000?ooo`3oool0<`3o
ool00500oooo00<000000?ooo`3oool0g03oool2003jVP040000003oool00000000000<00?ZJ0P3o
ool2003jVPX0oooo0P00nYX200000080oooo00@00?ZJ0000o`000?l00?ZJ0P3oool20000o`L0oooo
1000nYX80?ooo`8000000P3oool2003jVP80oooo0P00nYXP0?ooo`030000003oool0oooo01T0oooo
00<000000?ooo`3oool0[P3oool2000000030?ooo`000000000000<00000203oool2000000030?oo
o`000000000000D0oooo1`000000103oool000000000000000020?ooo`D0000000<0oooo00000000
00000P00000>0?ooo`8000000P3oool2000000030?ooo`000000000001d0oooo0`0000040?ooo`80
00008@3oool00`000000oooo0?ooo`0c0?ooo`00D03oool200000=d0oooo0P00nYX010000000oooo
000000000003003jVP80oooo0P00nYX<0?ooo`8000000P3oool01000nYX0003o0000o`00nYX20?oo
o`80003o1`3oool4003jVPP0oooo0P0000020?ooo`800?ZJ0P3oool2003jVQh0oooo0`00000K0?oo
o`030000003oool0oooo0:h0oooo0P000000103oool000000000003oool2000000P0oooo0P000000
0`3oool00000000000050?ooo`D000000`3oool300000080oooo1@0000000`3oool0000000000002
000000h0oooo0`000000103oool000000000003oool2000001d0oooo0P0000050?ooo`8000008@3o
ool00`000000oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`3L0?ooo`800?ZJ00@00000
0?ooo`00000000001000nYX00`3oool00?ZJ003jVP0<0?ooo`8000000P3oool00`00nYX0003o0000
o`030?ooo`80003o203oool3003jVPP0oooo0P0000020?ooo`800?ZJ0P3oool2003jVR00oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`2^0?ooo`80000000@0oooo000000000000oooo
0P0000070?ooo`H000001@3oool2000000030?ooo`000000000000<0oooo100000000`3oool00000
0000000200000080oooo1000000?0?ooo`D0000000<0oooo0000000000007@3oool2000000D0oooo
0P00000Q0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0=`0oooo0P00
nYX010000000oooo000000000004003jVP030?ooo`00nYX00?ZJ00`0oooo0`000000103oool00?ZJ
0000o`000?l30?ooo`80003o203oool3003jVP`0oooo0P00nYX20?ooo`800?ZJ803oool00`000000
oooo0?ooo`0I0?ooo`030000003oool0oooo0:h0oooo0P000000103oool000000000003oool20000
00L0oooo1P0000080?ooo`8000001@3oool2000000040?ooo`0000000000000000<0oooo1000000?
0?ooo`@000000P3oool2000001d0oooo0P0000050?ooo`8000008@3oool00`000000oooo0?ooo`0c
0?ooo`00D03oool00`000000oooo0?ooo`3L0?ooo`<00?ZJ0`3oool4003jVP030?ooo`00nYX00?ZJ
00d0oooo0P000000103oool00?ZJ0000o`000?l30?ooo`80003o203oool3003jVP`0oooo0`00nYX0
0`3oool00?ZJ003jVP0P0?ooo`030000003oool0oooo01T0oooo0P00002_0?ooo`80000000@0oooo
000000000000oooo0`0000060?ooo`H000003`3oool2000000040?ooo`0000000000000000<0oooo
0`00000@0?ooo`@000000P3oool2000001`0oooo0`00000W0?ooo`800000=@3oool00500oooo00<0
00000?ooo`3oool0g@3oool2003jVP<0oooo1`00nYX=0?ooo`80000000@0oooo003jVP000?l0003o
0`3oool20000o`T0oooo0P00nYX=0?ooo`800?ZJ00<0oooo003jVP00nYX0803oool00`000000oooo
0?ooo`0I0?ooo`030000003oool0oooo0:h0oooo1@0000020?ooo`8000001P3oool6000000l0oooo
0P000000103oool000000000000000030?ooo`<00000403oool400000080oooo0P00000L0?ooo`80
0000:@3oool00`000000oooo0?ooo`0c0?ooo`00D03oool200000=h0oooo0P00nYX30?ooo`800?ZJ
00<0oooo003jVP00nYX00P00nYX=0?ooo`8000000P3oool20000o`<0oooo0P000?lH0?ooo`D00?ZJ
7P3oool3000001/0oooo00<000000?ooo`3oool0[`3oool3000000<0oooo0P0000060?ooo`H00000
3`3oool6000000@0oooo0P00000A0?ooo`8000000`3oool2000000030?ooo`000000000001T0oooo
0P00000Y0?ooo`030000003oool0oooo03<0oooo001@0?ooo`030000003oool0oooo0=d0oooo0`00
nYX01@3oool00?ZJ003jVP00nYX0oooo00@00?ZJ3@3oool200000080oooo0P000?l30?ooo`80003o
6@3oool4003jVR00oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`2_0?ooo`<00000
0`3oool2000000H0oooo1@00000@0?ooo`@000001P3oool200000140oooo0P0000030?ooo`800000
00<0oooo0000000000006@3oool2000002T0oooo00<000000?ooo`3oool0<`3oool00500oooo00<0
00000?ooo`3oool0gP3oool2003jVP030?ooo`00nYX00?ZJ0080oooo1000nYX=0?ooo`8000000P3o
ool20000o`<0oooo0P000?lJ0?ooo`<00?ZJ803oool00`000000oooo0?ooo`0I0?ooo`030000003o
ool0oooo0:l0oooo0`0000030?ooo`@000000`3oool3000000030?ooo`00000000000100oooo1000
00060?ooo`8000004@3oool2000000<0oooo1@00000H0?ooo`<00000:@3oool00`000000oooo0?oo
o`0c0?ooo`00D03oool00`000000oooo0?ooo`3N0?ooo`800?ZJ00<0oooo003jVP00nYX00`3oool3
003jVPd0oooo0P0000020?ooo`80003o0`3oool20000oaX0oooo0`00nYXP0?ooo`030000003oool0
oooo01T0oooo0P00002a0?ooo`8000000`3oool6000000030?ooo`00000000000080oooo0P00000@
0?ooo`@000007`3oool4000001P0oooo0P00000Y0?ooo`800000=@3oool00500oooo00<000000?oo
o`3oool0gP3oool5003jVP<0oooo0`00nYX=0?ooo`@000001`000?lK0?ooo`800?ZJ803oool00`00
0000oooo0?ooo`0I0?ooo`030000003oool0oooo0;D0oooo1P0000000`3oool00000000000020?oo
o`8000004@3oool3000001l0oooo100000020?ooo`800000503oool2000002X0oooo00<000000?oo
o`3oool0<`3oool00500oooo00<000000?ooo`3oool0g`3oool4003jVP@0oooo0P00nYX=0?ooo`@0
00001`000?lm0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0]@3oool600000003
0?ooo`00000000000080oooo0P00000A0?ooo`<000007`3oool400000080oooo0`00000C0?ooo`80
0000:P3oool00`000000oooo0?ooo`0c0?ooo`00D03oool200000>40oooo0`00nYXC0?ooo`@00000
0P00nYX30?ooo`800?ZJ>`3oool3000001/0oooo00<000000?ooo`3oool0]P3oool8000001D0oooo
0`00000O0?ooo`D0000000@0oooo00000000000000004`3oool2000002X0oooo00<000000?ooo`3o
ool0<`3oool00500oooo00<000000?ooo`3oool0h03oool3003jVQ@0oooo0`000002003jVP<0oooo
0P00nYXm0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0]P3oool2000000030?oo
o`0000000000008000005P3oool3000001l0oooo2@00000C0?ooo`800000:P3oool00`000000oooo
0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`3P0?ooo`<00?ZJ5`3oool2003jVP<0oooo0P00
nYXm0?ooo`030000003oool0oooo01T0oooo0P00002j0?ooo`@000005P3oool200000200oooo2@00
000B0?ooo`<00000:@3oool2000003D0oooo001@0?ooo`030000003oool0oooo0>00oooo0`00nYXG
0?ooo`800?ZJ0`3oool2003jVSd0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`2i
0?ooo`@00000>03oool900000080oooo0P00000=0?ooo`<00000:`3oool00`000000oooo0?ooo`0c
0?ooo`00D03oool00`000000oooo0?ooo`3Q0?ooo`800?ZJ5`3oool2003jVP<0oooo0P00nYXm0?oo
o`030000003oool0oooo01T0oooo00<000000?ooo`3oool0^@3oool4000003P0oooo1P0000000`3o
ool00000000000020?ooo`8000003@3oool3000002/0oooo00<000000?ooo`3oool0<`3oool00500
oooo00<000000?ooo`3oool0nP3oool2003jVP<0oooo0P00nYXm0?ooo`030000003oool0oooo00D0
oooo0P0000040?ooo`030000003oool0oooo00<0oooo0`0000050?ooo`030000003oool0oooo0;X0
oooo0`00000h0?ooo`D000000P3oool3000000040?ooo`0000000000000000`0oooo0`00000[0?oo
o`030000003oool0oooo03<0oooo001@0?ooo`800000n`3oool2003jVP<0oooo0P00nYXk0?ooo`<0
00001P3oool010000000oooo0?ooo`00000:0?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0^P3oool2000003X0oooo0P0000050?ooo`L000002`3oool3000002/0oooo00<000000?oo
o`3oool0<`3oool00500oooo00<000000?ooo`3oool0nP3oool2003jVP<0oooo0P00nYXm0?ooo`03
0000003oool0oooo00@0oooo00@000000?ooo`3oool000001`3oool5000000D0oooo0`00002j0?oo
o`800000>P3oool2000000D0oooo1`0000040?ooo`8000001@3oool3000002T0oooo0`00000e0?oo
o`00D03oool00`000000oooo0?ooo`3j0?ooo`800?ZJ0`3oool2003jVSd0oooo00<000000?ooo`3o
ool0103oool010000000oooo0?ooo`0000070?ooo`040000003oool0oooo000000H0oooo00<00000
0?ooo`3oool0mP3oool2000000D0oooo2@0000020?ooo`800000103oool4000002/0oooo00<00000
0?ooo`3oool0<`3oool003`0oooo0`0000030?ooo`030000003oool0oooo0080oooo0`0000060?oo
o`030000003oool0oooo0?X0oooo0`00nYX20?ooo`800?ZJ?@3oool00`000000oooo0?ooo`040?oo
o`040000003oool0oooo000000P0oooo00<000000?ooo`0000001P3oool00`000000oooo0?ooo`3m
0?ooo`l000000P3oool4000002/0oooo00<000000?ooo`3oool0<`3oool003d0oooo00<000000?oo
o`3oool01P3oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0n`3oool2
003jVP80oooo0P00nYXm0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000002@3o
ool2000000H0oooo00<000000?ooo`3oool0o@3oool?00000080oooo1000000[0?ooo`030000003o
ool0oooo03<0oooo000j0?ooo`D000001`3oool01@000000oooo0?ooo`3oool0000000D0oooo00<0
00000?ooo`3oool0n`3oool3003jVP030?ooo`00nYX00?ZJ03d0oooo00<000000?ooo`3oool01@3o
ool2000000/0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`3o0?ooo`40oooo0P00
00000`3oool0000000000008000000030?ooo`000000000002d0oooo00<000000?ooo`3oool0<`3o
ool003X0oooo00@000000?ooo`3oool000002@3oool3000000H0oooo0`00003l0?ooo`800?ZJ00<0
oooo003jVP00nYX0>P3oool4000001/0oooo00<000000?ooo`3oool0o`3oool10?ooo`8000000`3o
ool200000080oooo100000000`3oool000000000000]0?ooo`030000003oool0oooo03<0oooo000k
0?ooo`030000003oool0000000P0oooo00D000000?ooo`3oool0oooo000000050?ooo`030000003o
ool0oooo0?`0oooo1@00nYXm0?ooo`030000003oool0oooo01T0oooo0P00003o0?ooo`80oooo0P00
00070?ooo`@0000000<0oooo000000000000;03oool2000003D0oooo000l0?ooo`800000203oool0
1@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0o@3oool4003jVSd0oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`3o0?ooo`40oooo0P0000070?ooo`L00000;@3o
ool00`000000oooo0?ooo`0c0?ooo`00?@3oool00`000000oooo0?ooo`070?ooo`<000001P3oool0
0`000000oooo0?ooo`3m0?ooo`@00?ZJ?@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0
oooo0?l0oooo303oool4000002h0oooo00<000000?ooo`3oool0<`3oool00500oooo00<000000?oo
o`3oool0oP3oool3003jVSd0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`3o0?oo
o``0oooo1000000^0?ooo`030000003oool0oooo03<0oooo001@0?ooo`800000o`3oool10?ooo`80
0?ZJ>`3oool3000001/0oooo00<000000?ooo`3oool0o`3oool<0?ooo`<00000;`3oool00`000000
oooo0?ooo`0c0?ooo`00D03oool00`000000oooo0?ooo`3o0?ooocl0oooo00<000000?ooo`3oool0
6@3oool200000?l0oooo?P3oool2000003D0oooo001@0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo02L0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo02L0oooo00<0
00000?ooo`3oool09P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01T0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo02L0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo02L0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo0140oooo00<0
00000?ooo`3oool0<`3oool00500oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`05
0?ooo`050000003oool0oooo0?ooo`0000006`3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00D0oooo00D000000?ooo`3oool0oooo0000000e0?ooo`00D03ooooo000004<000006`3o
oooo000004800000=@3oool00?l0ooooo`3ooooo0?ooobH0oooo003o0?ooool0ooooo`3ooolV0?oo
o`00o`3ooooo0?ooool0oooo9P3oool00?l0ooooo`3ooooo0?ooobH0oooo003o0?ooool0ooooo`3o
oolV0?ooo`00o`3ooooo0?ooool0oooo9P3oool00?l0ooooo`3ooooo0?ooobH0oooo003o0?ooool0
ooooo`3ooolV0?ooo`00o`3ooooo0?ooool0oooo9P3oool00?l0ooooo`3ooooo0?ooobH0oooo003o
0?ooool0ooooo`3ooolV0?ooo`00o`3ooooo0?ooool0oooo9P3oool00?l0ooooo`3ooooo0?ooobH0
oooo003o0?ooool0ooooo`3ooolV0?ooo`00o`3ooooo0?ooool0oooo9P3oool00?l0ooooo`3ooooo
0?ooobH0oooo003o0?ooool0ooooo`3ooolV0?ooo`00o`3ooooo0?ooool0oooo9P3oool00?l0oooo
o`3ooooo0?ooobH0oooo003o0?ooohX0oooo0`0000020?ooo`<0000000<0oooo0000003oool00`00
003o0?ooohd0oooo003o0?ooohX0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo0?l0ooooS03oool00?l0ooooS@3oool01@000000oooo0?oo
o`000000oooo008000000P3oool00`000000oooo0?ooo`3o0?oooh`0oooo003o0?oooh/0oooo0P00
00030?ooo`040000003oool0000000000080oooo0`00003o0?oooh`0oooo003o0?ooohX0oooo00<0
00000?ooo`3oool00`3oool2000000050?ooo`000000oooo0?ooo`000000o`3ooon>0?ooo`00o`3o
oon:0?ooo`040000003oool0oooo00000080oooo0P0000001@3oool000000?ooo`3oool000000080
oooo00<000000?ooo`3oool0o`3ooon90?ooo`00o`3ooon;0?ooo`<0000000@0oooo000000000000
oooo2000003o0?oooh/0oooo003o0?ooool0ooooo`3ooolV0?ooo`00o`3ooooo0?ooool0oooo9P3o
ool00001\
\>"],
  ImageRangeCache->{{{0, 802.312}, {247.25, 0}} -> {-0.151372, -0.0154542, \
0.00287014, 0.00287014}, {{52.6875, 401.125}, {241.812, 26.5}} -> {-105.675, \
4.43289, 1.19652, 0.00175408}, {{401.125, 749.562}, {241.812, 26.5}} -> \
{-522.586, 0.0101726, 1.19652, 0.00189941}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["HNF(2,4)", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[{
  "LINEARMESS  = True;\nYMAX = 500;\n\n{YF,PF,lik}= \n\t\
HNF24[{logZM,X},{0.07, -1., .2, .2},\n\t\t\t\t\t\t\
{drift,Jacobif,DDf,DDDf,DDDDf,Omega,DDOmega,DDDDOmega,h,Jacobih,R,",
  StyleBox["Mue,Sigma",
    FontColor->RGBColor[1, 0, 0]],
  ",dt},\n\t\t\t\t\t\t{-9,2}];"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
s=Map[VecDiag,PF]//Sqrt;
KI=YF~ii~(YF+s)~ii~(YF-s);\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
gHNF=
DisplayTogetherArray[
plot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}]//AddTimeAxis,color->{10,1,2,2}]\
,
plot1[    Column[Y,{2}] \
~ii~Column[KI,{1,3,5}+1]//AddTimeAxis,color->{10,1,2,2}]
,PlotLabel->\"HNF(2,4)\"];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(gHNF\)\" is similar to \
existing symbol \"\!\(gSNF\)\"."\)], "Message",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -26 0 ]
[.5 .32152 26 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -87 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(HNF) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.000 13.000 moveto
(H) show
87.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
99.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
105.000 13.000 moveto
(L) show
111.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -7.95428 1.77985 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05506 -18 -4.5 ]
[-0.0125 .05506 0 4.5 ]
[-0.0125 .14405 -24 -4.5 ]
[-0.0125 .14405 0 4.5 ]
[-0.0125 .23304 -18 -4.5 ]
[-0.0125 .23304 0 4.5 ]
[-0.0125 .32204 -24 -4.5 ]
[-0.0125 .32204 0 4.5 ]
[-0.0125 .41103 -18 -4.5 ]
[-0.0125 .41103 0 4.5 ]
[-0.0125 .50002 -24 -4.5 ]
[-0.0125 .50002 0 4.5 ]
[-0.0125 .58901 -18 -4.5 ]
[-0.0125 .58901 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33251 -5 -6 ]
[.97619 .33251 5 6 ]
[.97619 .3378 -5 -6 ]
[.97619 .3378 5 6 ]
[.97619 .36615 -5 -6 ]
[.97619 .36615 5 6 ]
[.97619 .30946 -5 -6 ]
[.97619 .30946 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05506 m
.00625 .05506 L
s
[(4.5)] -0.0125 .05506 1 0 Mshowa
0 .14405 m
.00625 .14405 L
s
[(4.55)] -0.0125 .14405 1 0 Mshowa
0 .23304 m
.00625 .23304 L
s
[(4.6)] -0.0125 .23304 1 0 Mshowa
0 .32204 m
.00625 .32204 L
s
[(4.65)] -0.0125 .32204 1 0 Mshowa
0 .41103 m
.00625 .41103 L
s
[(4.7)] -0.0125 .41103 1 0 Mshowa
0 .50002 m
.00625 .50002 L
s
[(4.75)] -0.0125 .50002 1 0 Mshowa
0 .58901 m
.00625 .58901 L
s
[(4.8)] -0.0125 .58901 1 0 Mshowa
.125 Mabswid
0 .07286 m
.00375 .07286 L
s
0 .09066 m
.00375 .09066 L
s
0 .10845 m
.00375 .10845 L
s
0 .12625 m
.00375 .12625 L
s
0 .16185 m
.00375 .16185 L
s
0 .17965 m
.00375 .17965 L
s
0 .19745 m
.00375 .19745 L
s
0 .21525 m
.00375 .21525 L
s
0 .25084 m
.00375 .25084 L
s
0 .26864 m
.00375 .26864 L
s
0 .28644 m
.00375 .28644 L
s
0 .30424 m
.00375 .30424 L
s
0 .33984 m
.00375 .33984 L
s
0 .35763 m
.00375 .35763 L
s
0 .37543 m
.00375 .37543 L
s
0 .39323 m
.00375 .39323 L
s
0 .42883 m
.00375 .42883 L
s
0 .44663 m
.00375 .44663 L
s
0 .46443 m
.00375 .46443 L
s
0 .48222 m
.00375 .48222 L
s
0 .51782 m
.00375 .51782 L
s
0 .53562 m
.00375 .53562 L
s
0 .55342 m
.00375 .55342 L
s
0 .57122 m
.00375 .57122 L
s
0 .03726 m
.00375 .03726 L
s
0 .01946 m
.00375 .01946 L
s
0 .00166 m
.00375 .00166 L
s
0 .60681 m
.00375 .60681 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05506 m
1 .05506 L
s
.99375 .14405 m
1 .14405 L
s
.99375 .23304 m
1 .23304 L
s
.99375 .32204 m
1 .32204 L
s
.99375 .41103 m
1 .41103 L
s
.99375 .50002 m
1 .50002 L
s
.99375 .58901 m
1 .58901 L
s
.125 Mabswid
.99625 .07286 m
1 .07286 L
s
.99625 .09066 m
1 .09066 L
s
.99625 .10845 m
1 .10845 L
s
.99625 .12625 m
1 .12625 L
s
.99625 .16185 m
1 .16185 L
s
.99625 .17965 m
1 .17965 L
s
.99625 .19745 m
1 .19745 L
s
.99625 .21525 m
1 .21525 L
s
.99625 .25084 m
1 .25084 L
s
.99625 .26864 m
1 .26864 L
s
.99625 .28644 m
1 .28644 L
s
.99625 .30424 m
1 .30424 L
s
.99625 .33984 m
1 .33984 L
s
.99625 .35763 m
1 .35763 L
s
.99625 .37543 m
1 .37543 L
s
.99625 .39323 m
1 .39323 L
s
.99625 .42883 m
1 .42883 L
s
.99625 .44663 m
1 .44663 L
s
.99625 .46443 m
1 .46443 L
s
.99625 .48222 m
1 .48222 L
s
.99625 .51782 m
1 .51782 L
s
.99625 .53562 m
1 .53562 L
s
.99625 .55342 m
1 .55342 L
s
.99625 .57122 m
1 .57122 L
s
.99625 .03726 m
1 .03726 L
s
.99625 .01946 m
1 .01946 L
s
.99625 .00166 m
1 .00166 L
s
.99625 .60681 m
1 .60681 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 0 r
gsave
.97619 .33251 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .24225 m
.02642 .24969 L
.02903 .2513 L
.03164 .22497 L
.03425 .24231 L
.03686 .23581 L
.03947 .25851 L
.04207 .28896 L
.04468 .29522 L
.04729 .32104 L
.0499 .28504 L
.05251 .29849 L
.05512 .27444 L
.05773 .29604 L
.06034 .32156 L
.06295 .34244 L
.06556 .35994 L
.06817 .34476 L
.07078 .31443 L
.07339 .3613 L
.07599 .34311 L
.0786 .32962 L
.08121 .30511 L
.08382 .31298 L
.08643 .33247 L
.08904 .32661 L
.09165 .34521 L
.09426 .41582 L
.09687 .37586 L
.09948 .36444 L
.10209 .36585 L
.1047 .39126 L
.10731 .40571 L
.10992 .38437 L
.11252 .38076 L
.11513 .39307 L
.11774 .37169 L
.12035 .37836 L
.12296 .37469 L
.12557 .34908 L
.12818 .36807 L
.13079 .39716 L
.1334 .39941 L
.13601 .36988 L
.13862 .37799 L
.14123 .36388 L
.14384 .37238 L
.14644 .36921 L
.14905 .35046 L
.15166 .33488 L
Mistroke
.15427 .34414 L
.15688 .35861 L
.15949 .38443 L
.1621 .34752 L
.16471 .31813 L
.16732 .32606 L
.16993 .33369 L
.17254 .32577 L
.17515 .3143 L
.17776 .33032 L
.18037 .3093 L
.18297 .30715 L
.18558 .31581 L
.18819 .31064 L
.1908 .31198 L
.19341 .31573 L
.19602 .29894 L
.19863 .29234 L
.20124 .23707 L
.20385 .24027 L
.20646 .24994 L
.20907 .24536 L
.21168 .24116 L
.21429 .25772 L
.21689 .26168 L
.2195 .26485 L
.22211 .23448 L
.22472 .25805 L
.22733 .28755 L
.22994 .28297 L
.23255 .29439 L
.23516 .29622 L
.23777 .24863 L
.24038 .25556 L
.24299 .25572 L
.2456 .26532 L
.24821 .25783 L
.25082 .25945 L
.25342 .26746 L
.25603 .25971 L
.25864 .25705 L
.26125 .261 L
.26386 .25449 L
.26647 .25235 L
.26908 .25851 L
.27169 .26768 L
.2743 .27289 L
.27691 .26453 L
.27952 .23857 L
.28213 .2541 L
Mistroke
.28474 .26264 L
.28735 .23713 L
.28995 .21609 L
.29256 .23148 L
.29517 .21393 L
.29778 .2382 L
.30039 .19654 L
.303 .20293 L
.30561 .21672 L
.30822 .22285 L
.31083 .25126 L
.31344 .27132 L
.31605 .26975 L
.31866 .26239 L
.32127 .28185 L
.32387 .2739 L
.32648 .31977 L
.32909 .31141 L
.3317 .27707 L
.33431 .2741 L
.33692 .31475 L
.33953 .31204 L
.34214 .29077 L
.34475 .28821 L
.34736 .29754 L
.34997 .31834 L
.35258 .31211 L
.35519 .30155 L
.3578 .29853 L
.3604 .29715 L
.36301 .29383 L
.36562 .27797 L
.36823 .30323 L
.37084 .308 L
.37345 .30562 L
.37606 .27162 L
.37867 .27239 L
.38128 .24881 L
.38389 .26794 L
.3865 .24649 L
.38911 .24174 L
.39172 .25222 L
.39432 .26842 L
.39693 .2416 L
.39954 .24973 L
.40215 .26351 L
.40476 .27125 L
.40737 .24037 L
.40998 .21947 L
.41259 .23206 L
Mistroke
.4152 .2163 L
.41781 .2375 L
.42042 .24693 L
.42303 .24378 L
.42564 .2601 L
.42825 .24233 L
.43085 .24539 L
.43346 .25685 L
.43607 .25099 L
.43868 .2686 L
.44129 .26811 L
.4439 .23251 L
.44651 .20882 L
.44912 .22132 L
.45173 .27506 L
.45434 .25432 L
.45695 .25497 L
.45956 .22084 L
.46217 .23718 L
.46477 .23815 L
.46738 .24861 L
.46999 .21472 L
.4726 .24385 L
.47521 .25321 L
.47782 .27561 L
.48043 .29551 L
.48304 .24486 L
.48565 .25141 L
.48826 .2265 L
.49087 .2813 L
.49348 .2884 L
.49609 .27626 L
.4987 .29129 L
.5013 .28448 L
.50391 .29561 L
.50652 .26273 L
.50913 .26583 L
.51174 .29346 L
.51435 .25075 L
.51696 .30567 L
.51957 .28318 L
.52218 .25892 L
.52479 .22517 L
.5274 .24837 L
.53001 .26488 L
.53262 .26769 L
.53523 .24556 L
.53783 .20971 L
.54044 .14773 L
.54305 .17699 L
Mistroke
.54566 .19217 L
.54827 .19767 L
.55088 .17225 L
.55349 .19517 L
.5561 .23407 L
.55871 .19303 L
.56132 .18632 L
.56393 .15639 L
.56654 .07923 L
.56915 .03736 L
.57175 .06119 L
.57436 .10405 L
.57697 .09912 L
.57958 .10617 L
.58219 .0961 L
.5848 .09457 L
.58741 .09761 L
.59002 .12747 L
.59263 .13014 L
.59524 .12917 L
.59785 .12852 L
.60046 .14506 L
.60307 .13891 L
.60568 .14031 L
.60828 .21123 L
.61089 .23944 L
.6135 .19872 L
.61611 .21446 L
.61872 .20584 L
.62133 .21467 L
.62394 .2375 L
.62655 .25505 L
.62916 .34345 L
.63177 .33575 L
.63438 .38555 L
.63699 .34229 L
.6396 .29979 L
.6422 .28749 L
.64481 .30249 L
.64742 .30455 L
.65003 .32447 L
.65264 .35022 L
.65525 .38831 L
.65786 .38375 L
.66047 .4312 L
.66308 .42101 L
.66569 .41568 L
.6683 .43003 L
.67091 .36561 L
.67352 .33477 L
Mistroke
.67613 .3424 L
.67873 .36051 L
.68134 .32126 L
.68395 .38299 L
.68656 .39632 L
.68917 .44297 L
.69178 .45434 L
.69439 .41924 L
.697 .47868 L
.69961 .51806 L
.70222 .52567 L
.70483 .49822 L
.70744 .49907 L
.71005 .52106 L
.71265 .52142 L
.71526 .50573 L
.71787 .48688 L
.72048 .45624 L
.72309 .48072 L
.7257 .43898 L
.72831 .43196 L
.73092 .40647 L
.73353 .39275 L
.73614 .3411 L
.73875 .35938 L
.74136 .4048 L
.74397 .43098 L
.74658 .4669 L
.74918 .50713 L
.75179 .48799 L
.7544 .46234 L
.75701 .41194 L
.75962 .48518 L
.76223 .47733 L
.76484 .46977 L
.76745 .43164 L
.77006 .42551 L
.77267 .43846 L
.77528 .47631 L
.77789 .49587 L
.7805 .54579 L
.78311 .55372 L
.78571 .54719 L
.78832 .5487 L
.79093 .55482 L
.79354 .46462 L
.79615 .44034 L
.79876 .47319 L
.80137 .49194 L
.80398 .50916 L
Mistroke
.80659 .43374 L
.8092 .40067 L
.81181 .39948 L
.81442 .35612 L
.81703 .37383 L
.81963 .37123 L
.82224 .44858 L
.82485 .42268 L
.82746 .47362 L
.83007 .45437 L
.83268 .48442 L
.83529 .44163 L
.8379 .41826 L
.84051 .39383 L
.84312 .3995 L
.84573 .34299 L
.84834 .34329 L
.85095 .27913 L
.85356 .29737 L
.85616 .3497 L
.85877 .29954 L
.86138 .29085 L
.86399 .34076 L
.8666 .39473 L
.86921 .44276 L
.87182 .48992 L
.87443 .51781 L
.87704 .4555 L
.87965 .42362 L
.88226 .49608 L
.88487 .45257 L
.88748 .40932 L
.89008 .39361 L
.89269 .42154 L
.8953 .43922 L
.89791 .40693 L
.90052 .36778 L
.90313 .37613 L
.90574 .3526 L
.90835 .36104 L
.91096 .33002 L
.91357 .33465 L
.91618 .34292 L
.91879 .31245 L
.9214 .3397 L
.92401 .3455 L
.92661 .36213 L
.92922 .31377 L
.93183 .30055 L
.93444 .32248 L
Mistroke
.93705 .32532 L
.93966 .30415 L
.94227 .29962 L
.94488 .29058 L
.94749 .34342 L
.9501 .26669 L
.95271 .2984 L
.95532 .29415 L
.95793 .30238 L
.96053 .34942 L
.96314 .35873 L
.96575 .37545 L
.96836 .3463 L
.97097 .31993 L
.97358 .34089 L
.97619 .33251 L
Mfstroke
0 0 1 r
gsave
.97619 .3378 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24237 m
.02642 .24259 L
.02903 .24281 L
.03164 .24303 L
.03425 .24325 L
.03686 .24347 L
.03947 .24369 L
.04207 .28493 L
.04468 .28515 L
.04729 .28537 L
.0499 .28559 L
.05251 .28581 L
.05512 .28603 L
.05773 .28625 L
.06034 .31855 L
.06295 .31877 L
.06556 .31899 L
.06817 .3192 L
.07078 .31942 L
.07339 .31964 L
.07599 .31986 L
.0786 .32886 L
.08121 .32908 L
.08382 .3293 L
.08643 .32952 L
.08904 .32974 L
.09165 .32996 L
.09426 .33017 L
.09687 .37199 L
.09948 .37221 L
.10209 .37243 L
.1047 .37265 L
.10731 .37287 L
.10992 .37309 L
.11252 .3733 L
.11513 .39163 L
.11774 .39185 L
.12035 .39207 L
.12296 .39229 L
.12557 .3925 L
.12818 .39272 L
.13079 .39294 L
.1334 .39885 L
.13601 .39906 L
.13862 .39928 L
.14123 .3995 L
.14384 .39971 L
.14644 .39993 L
.14905 .40015 L
.15166 .34046 L
Mistroke
.15427 .34067 L
.15688 .34089 L
.15949 .3411 L
.1621 .34132 L
.16471 .34153 L
.16732 .34175 L
.16993 .33436 L
.17254 .33458 L
.17515 .33479 L
.17776 .335 L
.18037 .33522 L
.18297 .33543 L
.18558 .33565 L
.18819 .31268 L
.1908 .31289 L
.19341 .31311 L
.19602 .31332 L
.19863 .31353 L
.20124 .31374 L
.20385 .31396 L
.20646 .2552 L
.20907 .25541 L
.21168 .25562 L
.21429 .25584 L
.21689 .25605 L
.2195 .25626 L
.22211 .25647 L
.22472 .25808 L
.22733 .25829 L
.22994 .2585 L
.23255 .25871 L
.23516 .25892 L
.23777 .25913 L
.24038 .25934 L
.24299 .25586 L
.2456 .25607 L
.24821 .25628 L
.25082 .25649 L
.25342 .2567 L
.25603 .25691 L
.25864 .25712 L
.26125 .26054 L
.26386 .26075 L
.26647 .26096 L
.26908 .26116 L
.27169 .26137 L
.2743 .26158 L
.27691 .26179 L
.27952 .24056 L
.28213 .24077 L
Mistroke
.28474 .24098 L
.28735 .24119 L
.28995 .2414 L
.29256 .2416 L
.29517 .24181 L
.29778 .23819 L
.30039 .2384 L
.303 .2386 L
.30561 .23881 L
.30822 .23902 L
.31083 .23923 L
.31344 .23943 L
.31605 .26702 L
.31866 .26723 L
.32127 .26744 L
.32387 .26765 L
.32648 .26785 L
.32909 .26806 L
.3317 .26827 L
.33431 .27395 L
.33692 .27416 L
.33953 .27437 L
.34214 .27457 L
.34475 .27478 L
.34736 .27499 L
.34997 .2752 L
.35258 .30886 L
.35519 .30907 L
.3578 .30928 L
.3604 .30948 L
.36301 .30969 L
.36562 .3099 L
.36823 .31011 L
.37084 .30833 L
.37345 .30854 L
.37606 .30874 L
.37867 .30895 L
.38128 .30916 L
.38389 .30937 L
.3865 .30957 L
.38911 .24725 L
.39172 .24745 L
.39432 .24766 L
.39693 .24786 L
.39954 .24807 L
.40215 .24827 L
.40476 .24848 L
.40737 .24093 L
.40998 .24114 L
.41259 .24134 L
Mistroke
.4152 .24155 L
.41781 .24175 L
.42042 .24195 L
.42303 .24216 L
.42564 .25867 L
.42825 .25888 L
.43085 .25908 L
.43346 .25929 L
.43607 .25949 L
.43868 .25969 L
.44129 .2599 L
.4439 .23492 L
.44651 .23512 L
.44912 .23533 L
.45173 .23553 L
.45434 .23573 L
.45695 .23594 L
.45956 .23614 L
.46217 .23696 L
.46477 .23716 L
.46738 .23736 L
.46999 .23757 L
.4726 .23777 L
.47521 .23797 L
.47782 .23818 L
.48043 .2909 L
.48304 .2911 L
.48565 .2913 L
.48826 .29151 L
.49087 .29171 L
.49348 .29192 L
.49609 .29212 L
.4987 .29111 L
.5013 .29131 L
.50391 .29152 L
.50652 .29172 L
.50913 .29192 L
.51174 .29213 L
.51435 .29233 L
.51696 .3046 L
.51957 .3048 L
.52218 .30501 L
.52479 .30521 L
.5274 .30541 L
.53001 .30562 L
.53262 .30582 L
.53523 .25034 L
.53783 .25055 L
.54044 .25075 L
.54305 .25095 L
Mistroke
.54566 .25115 L
.54827 .25135 L
.55088 .25155 L
.55349 .19962 L
.5561 .19982 L
.55871 .20002 L
.56132 .20022 L
.56393 .20042 L
.56654 .20062 L
.56915 .20082 L
.57175 .07194 L
.57436 .07213 L
.57697 .07233 L
.57958 .07252 L
.58219 .07272 L
.5848 .07292 L
.58741 .07311 L
.59002 .1235 L
.59263 .1237 L
.59524 .12389 L
.59785 .12409 L
.60046 .12429 L
.60307 .12448 L
.60568 .12468 L
.60828 .2047 L
.61089 .2049 L
.6135 .20509 L
.61611 .20529 L
.61872 .20549 L
.62133 .20569 L
.62394 .20589 L
.62655 .25129 L
.62916 .25149 L
.63177 .25169 L
.63438 .25189 L
.63699 .2521 L
.6396 .2523 L
.6422 .2525 L
.64481 .29844 L
.64742 .29864 L
.65003 .29884 L
.65264 .29904 L
.65525 .29925 L
.65786 .29945 L
.66047 .29965 L
.66308 .41146 L
.66569 .41167 L
.6683 .41187 L
.67091 .41208 L
.67352 .41228 L
Mistroke
.67613 .41249 L
.67873 .41269 L
.68134 .32849 L
.68395 .32869 L
.68656 .32889 L
.68917 .32909 L
.69178 .32929 L
.69439 .3295 L
.697 .3297 L
.69961 .50369 L
.70222 .5039 L
.70483 .5041 L
.70744 .50431 L
.71005 .50452 L
.71265 .50473 L
.71526 .50493 L
.71787 .48845 L
.72048 .48866 L
.72309 .48887 L
.7257 .48907 L
.72831 .48928 L
.73092 .48949 L
.73353 .48969 L
.73614 .35279 L
.73875 .35299 L
.74136 .35319 L
.74397 .35339 L
.74658 .3536 L
.74918 .3538 L
.75179 .354 L
.7544 .45386 L
.75701 .45407 L
.75962 .45427 L
.76223 .45448 L
.76484 .45468 L
.76745 .45489 L
.77006 .45509 L
.77267 .43998 L
.77528 .44019 L
.77789 .44039 L
.7805 .4406 L
.78311 .4408 L
.78571 .441 L
.78832 .44121 L
.79093 .54588 L
.79354 .54609 L
.79615 .54629 L
.79876 .5465 L
.80137 .54671 L
.80398 .54691 L
Mistroke
.80659 .54712 L
.8092 .41234 L
.81181 .41254 L
.81442 .41274 L
.81703 .41294 L
.81963 .41315 L
.82224 .41335 L
.82485 .41355 L
.82746 .46913 L
.83007 .46933 L
.83268 .46954 L
.83529 .46974 L
.8379 .46995 L
.84051 .47015 L
.84312 .47035 L
.84573 .35327 L
.84834 .35347 L
.85095 .35367 L
.85356 .35387 L
.85616 .35407 L
.85877 .35427 L
.86138 .35447 L
.86399 .34182 L
.8666 .34202 L
.86921 .34221 L
.87182 .34241 L
.87443 .34261 L
.87704 .34281 L
.87965 .34301 L
.88226 .4846 L
.88487 .4848 L
.88748 .48501 L
.89008 .48521 L
.89269 .48541 L
.8953 .48562 L
.89791 .48582 L
.90052 .37697 L
.90313 .37717 L
.90574 .37737 L
.90835 .37757 L
.91096 .37777 L
.91357 .37797 L
.91618 .37817 L
.91879 .31733 L
.9214 .31753 L
.92401 .31773 L
.92661 .31793 L
.92922 .31812 L
.93183 .31832 L
.93444 .31852 L
Mistroke
.93705 .32496 L
.93966 .32515 L
.94227 .32535 L
.94488 .32555 L
.94749 .32575 L
.9501 .32595 L
.95271 .32614 L
.95532 .29676 L
.95793 .29696 L
.96053 .29715 L
.96314 .29735 L
.96575 .29755 L
.96836 .29774 L
.97097 .29794 L
.97358 .33761 L
.97619 .3378 L
Mfstroke
0 .98 .604 r
gsave
.97619 .36615 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26017 m
.02642 .26999 L
.02903 .27724 L
.03164 .28328 L
.03425 .28859 L
.03686 .29338 L
.03947 .2978 L
.04207 .30195 L
.04468 .31206 L
.04729 .31941 L
.0499 .32552 L
.05251 .33086 L
.05512 .33569 L
.05773 .34013 L
.06034 .33556 L
.06295 .34568 L
.06556 .35304 L
.06817 .35915 L
.07078 .3645 L
.07339 .36933 L
.07599 .37377 L
.0786 .34588 L
.08121 .35604 L
.08382 .36343 L
.08643 .36956 L
.08904 .37492 L
.09165 .37977 L
.09426 .38422 L
.09687 .38901 L
.09948 .39917 L
.10209 .40655 L
.1047 .41267 L
.10731 .41803 L
.10992 .42287 L
.11252 .42732 L
.11513 .40865 L
.11774 .41883 L
.12035 .42622 L
.12296 .43236 L
.12557 .43773 L
.12818 .44258 L
.13079 .44704 L
.1334 .41586 L
.13601 .42609 L
.13862 .43351 L
.14123 .43966 L
.14384 .44505 L
.14644 .44991 L
.14905 .45438 L
.15166 .35748 L
Mistroke
.15427 .36785 L
.15688 .37535 L
.15949 .38157 L
.1621 .38701 L
.16471 .39191 L
.16732 .39642 L
.16993 .35139 L
.17254 .36182 L
.17515 .36936 L
.17776 .3756 L
.18037 .38106 L
.18297 .38598 L
.18558 .3905 L
.18819 .32972 L
.1908 .34023 L
.19341 .34781 L
.19602 .35409 L
.19863 .35957 L
.20124 .36452 L
.20385 .36907 L
.20646 .27225 L
.20907 .2829 L
.21168 .29056 L
.21429 .29689 L
.21689 .30243 L
.2195 .30742 L
.22211 .312 L
.22472 .27514 L
.22733 .28582 L
.22994 .2935 L
.23255 .29985 L
.23516 .3054 L
.23777 .3104 L
.24038 .31499 L
.24299 .27292 L
.2456 .28364 L
.24821 .29135 L
.25082 .29772 L
.25342 .30328 L
.25603 .30829 L
.25864 .3129 L
.26125 .2776 L
.26386 .28835 L
.26647 .29607 L
.26908 .30245 L
.27169 .30803 L
.2743 .31305 L
.27691 .31766 L
.27952 .25763 L
.28213 .26845 L
Mistroke
.28474 .27621 L
.28735 .28262 L
.28995 .28822 L
.29256 .29327 L
.29517 .2979 L
.29778 .25526 L
.30039 .26612 L
.303 .2739 L
.30561 .28033 L
.30822 .28594 L
.31083 .29099 L
.31344 .29563 L
.31605 .28409 L
.31866 .29494 L
.32127 .30271 L
.32387 .30913 L
.32648 .31473 L
.32909 .31978 L
.3317 .32441 L
.33431 .29102 L
.33692 .30188 L
.33953 .30967 L
.34214 .31609 L
.34475 .32171 L
.34736 .32676 L
.34997 .3314 L
.35258 .32593 L
.35519 .33676 L
.3578 .34453 L
.3604 .35094 L
.36301 .35654 L
.36562 .36158 L
.36823 .36621 L
.37084 .3254 L
.37345 .33626 L
.37606 .34405 L
.37867 .35047 L
.38128 .35609 L
.38389 .36114 L
.3865 .36578 L
.38911 .26432 L
.39172 .27533 L
.39432 .28319 L
.39693 .28968 L
.39954 .29534 L
.40215 .30044 L
.40476 .30512 L
.40737 .25801 L
.40998 .26906 L
.41259 .27694 L
Mistroke
.4152 .28345 L
.41781 .28912 L
.42042 .29423 L
.42303 .29892 L
.42564 .27576 L
.42825 .28679 L
.43085 .29467 L
.43346 .30117 L
.43607 .30685 L
.43868 .31195 L
.44129 .31664 L
.4439 .252 L
.44651 .26311 L
.44912 .27103 L
.45173 .27756 L
.45434 .28326 L
.45695 .28839 L
.45956 .29309 L
.46217 .25405 L
.46477 .26517 L
.46738 .27311 L
.46999 .27964 L
.4726 .28535 L
.47521 .29048 L
.47782 .29519 L
.48043 .30799 L
.48304 .31903 L
.48565 .32692 L
.48826 .33342 L
.49087 .3391 L
.49348 .3442 L
.49609 .34889 L
.4987 .30819 L
.5013 .31926 L
.50391 .32716 L
.50652 .33368 L
.50913 .33936 L
.51174 .34448 L
.51435 .34917 L
.51696 .32169 L
.51957 .33275 L
.52218 .34065 L
.52479 .34716 L
.5274 .35285 L
.53001 .35796 L
.53262 .36265 L
.53523 .26743 L
.53783 .27863 L
.54044 .2866 L
.54305 .29316 L
Mistroke
.54566 .29889 L
.54827 .30405 L
.55088 .30877 L
.55349 .21671 L
.5561 .22803 L
.55871 .23607 L
.56132 .24268 L
.56393 .24845 L
.56654 .25364 L
.56915 .2584 L
.57175 .08904 L
.57436 .10063 L
.57697 .10882 L
.57958 .11555 L
.58219 .12141 L
.5848 .12668 L
.58741 .13151 L
.59002 .14062 L
.59263 .15211 L
.59524 .16024 L
.59785 .16693 L
.60046 .17276 L
.60307 .178 L
.60568 .18281 L
.60828 .22181 L
.61089 .23315 L
.6135 .2412 L
.61611 .24783 L
.61872 .25361 L
.62133 .25881 L
.62394 .26357 L
.62655 .2684 L
.62916 .27966 L
.63177 .28767 L
.63438 .29427 L
.63699 .30002 L
.6396 .3052 L
.6422 .30994 L
.64481 .31554 L
.64742 .32673 L
.65003 .33469 L
.65264 .34126 L
.65525 .34698 L
.65786 .35214 L
.66047 .35686 L
.66308 .42856 L
.66569 .43953 L
.6683 .44739 L
.67091 .45386 L
.67352 .45952 L
Mistroke
.67613 .46461 L
.67873 .46928 L
.68134 .34557 L
.68395 .35674 L
.68656 .3647 L
.68917 .37126 L
.69178 .37698 L
.69439 .38213 L
.697 .38685 L
.69961 .52078 L
.70222 .53162 L
.70483 .53938 L
.70744 .5458 L
.71005 .5514 L
.71265 .55645 L
.71526 .56108 L
.71787 .50552 L
.72048 .51642 L
.72309 .52423 L
.7257 .53067 L
.72831 .53629 L
.73092 .54135 L
.73353 .546 L
.73614 .36986 L
.73875 .38106 L
.74136 .38904 L
.74397 .3956 L
.74658 .40133 L
.74918 .40648 L
.75179 .41121 L
.7544 .47096 L
.75701 .48196 L
.75962 .48982 L
.76223 .49631 L
.76484 .50197 L
.76745 .50706 L
.77006 .51174 L
.77267 .45707 L
.77528 .46812 L
.77789 .47601 L
.7805 .48252 L
.78311 .4882 L
.78571 .49331 L
.78832 .498 L
.79093 .56296 L
.79354 .57382 L
.79615 .5816 L
.79876 .58802 L
.80137 .59363 L
.80398 .59868 L
Mistroke
.80659 .60332 L
.8092 .42941 L
.81181 .44057 L
.81442 .44852 L
.81703 .45507 L
.81963 .46078 L
.82224 .46593 L
.82485 .47064 L
.82746 .48622 L
.83007 .49727 L
.83268 .50517 L
.83529 .51167 L
.8379 .51735 L
.84051 .52246 L
.84312 .52715 L
.84573 .37036 L
.84834 .38167 L
.85095 .38971 L
.85356 .39633 L
.85616 .4021 L
.85877 .40728 L
.86138 .41204 L
.86399 .35892 L
.8666 .37027 L
.86921 .37832 L
.87182 .38495 L
.87443 .39073 L
.87704 .39593 L
.87965 .4007 L
.88226 .5017 L
.88487 .51276 L
.88748 .52066 L
.89008 .52717 L
.89269 .53285 L
.8953 .53797 L
.89791 .54266 L
.90052 .39406 L
.90313 .40537 L
.90574 .41341 L
.90835 .42002 L
.91096 .42579 L
.91357 .43098 L
.91618 .43573 L
.91879 .33444 L
.9214 .34588 L
.92401 .35399 L
.92661 .36066 L
.92922 .36648 L
.93183 .3717 L
.93444 .3765 L
Mistroke
.93705 .34207 L
.93966 .3535 L
.94227 .36161 L
.94488 .36828 L
.94749 .37409 L
.9501 .37931 L
.95271 .38411 L
.95532 .31387 L
.95793 .32538 L
.96053 .33352 L
.96314 .34022 L
.96575 .34605 L
.96836 .3513 L
.97097 .35611 L
.97358 .35472 L
.97619 .36615 L
Mfstroke
gsave
.97619 .30946 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22458 m
.02642 .21519 L
.02903 .20839 L
.03164 .20278 L
.03425 .19791 L
.03686 .19355 L
.03947 .18958 L
.04207 .26792 L
.04468 .25825 L
.04729 .25133 L
.0499 .24567 L
.05251 .24076 L
.05512 .23637 L
.05773 .23237 L
.06034 .30154 L
.06295 .29185 L
.06556 .28493 L
.06817 .27926 L
.07078 .27434 L
.07339 .26995 L
.07599 .26595 L
.0786 .31185 L
.08121 .30212 L
.08382 .29517 L
.08643 .28948 L
.08904 .28455 L
.09165 .28015 L
.09426 .27613 L
.09687 .35498 L
.09948 .34526 L
.10209 .33832 L
.1047 .33263 L
.10731 .3277 L
.10992 .3233 L
.11252 .31929 L
.11513 .37462 L
.11774 .36487 L
.12035 .35791 L
.12296 .35221 L
.12557 .34728 L
.12818 .34286 L
.13079 .33884 L
.1334 .38183 L
.13601 .37204 L
.13862 .36505 L
.14123 .35933 L
.14384 .35438 L
.14644 .34995 L
.14905 .34592 L
.15166 .32344 L
Mistroke
.15427 .31349 L
.15688 .30642 L
.15949 .30063 L
.1621 .29562 L
.16471 .29115 L
.16732 .28707 L
.16993 .31733 L
.17254 .30733 L
.17515 .30022 L
.17776 .29441 L
.18037 .28938 L
.18297 .28488 L
.18558 .28079 L
.18819 .29564 L
.1908 .28556 L
.19341 .2784 L
.19602 .27255 L
.19863 .26749 L
.20124 .26297 L
.20385 .25885 L
.20646 .23816 L
.20907 .22793 L
.21168 .22069 L
.21429 .21478 L
.21689 .20966 L
.2195 .20509 L
.22211 .20093 L
.22472 .24103 L
.22733 .23077 L
.22994 .22351 L
.23255 .21758 L
.23516 .21245 L
.23777 .20787 L
.24038 .2037 L
.24299 .2388 L
.2456 .2285 L
.24821 .22121 L
.25082 .21526 L
.25342 .21012 L
.25603 .20552 L
.25864 .20134 L
.26125 .24348 L
.26386 .23314 L
.26647 .22584 L
.26908 .21988 L
.27169 .21472 L
.2743 .21012 L
.27691 .20592 L
.27952 .2235 L
.28213 .21309 L
Mistroke
.28474 .20575 L
.28735 .19975 L
.28995 .19457 L
.29256 .18994 L
.29517 .18573 L
.29778 .22112 L
.30039 .21068 L
.303 .20331 L
.30561 .19729 L
.30822 .1921 L
.31083 .18746 L
.31344 .18323 L
.31605 .24995 L
.31866 .23953 L
.32127 .23217 L
.32387 .22617 L
.32648 .22098 L
.32909 .21634 L
.3317 .21212 L
.33431 .25688 L
.33692 .24644 L
.33953 .23907 L
.34214 .23305 L
.34475 .22786 L
.34736 .22322 L
.34997 .21899 L
.35258 .29179 L
.35519 .28138 L
.3578 .27403 L
.3604 .26803 L
.36301 .26284 L
.36562 .25822 L
.36823 .254 L
.37084 .29126 L
.37345 .28081 L
.37606 .27344 L
.37867 .26743 L
.38128 .26223 L
.38389 .25759 L
.3865 .25337 L
.38911 .23018 L
.39172 .21958 L
.39432 .21212 L
.39693 .20604 L
.39954 .20079 L
.40215 .1961 L
.40476 .19183 L
.40737 .22385 L
.40998 .21322 L
.41259 .20574 L
Mistroke
.4152 .19964 L
.41781 .19438 L
.42042 .18968 L
.42303 .1854 L
.42564 .24159 L
.42825 .23096 L
.43085 .22349 L
.43346 .2174 L
.43607 .21213 L
.43868 .20744 L
.44129 .20316 L
.4439 .21784 L
.44651 .20714 L
.44912 .19962 L
.45173 .1935 L
.45434 .18821 L
.45695 .18349 L
.45956 .17919 L
.46217 .21987 L
.46477 .20915 L
.46738 .20162 L
.46999 .19549 L
.4726 .19019 L
.47521 .18547 L
.47782 .18116 L
.48043 .27381 L
.48304 .26317 L
.48565 .25569 L
.48826 .2496 L
.49087 .24433 L
.49348 .23963 L
.49609 .23535 L
.4987 .27402 L
.5013 .26336 L
.50391 .25587 L
.50652 .24976 L
.50913 .24449 L
.51174 .23978 L
.51435 .23549 L
.51696 .28751 L
.51957 .27686 L
.52218 .26936 L
.52479 .26326 L
.5274 .25798 L
.53001 .25328 L
.53262 .24899 L
.53523 .23326 L
.53783 .22246 L
.54044 .2149 L
.54305 .20873 L
Mistroke
.54566 .20341 L
.54827 .19866 L
.55088 .19433 L
.55349 .18252 L
.5561 .17161 L
.55871 .16397 L
.56132 .15775 L
.56393 .15238 L
.56654 .1476 L
.56915 .14324 L
.57175 .05483 L
.57436 .04364 L
.57697 .03584 L
.57958 .0295 L
.58219 .02403 L
.5848 .01915 L
.58741 .01472 L
.59002 .10638 L
.59263 .09529 L
.59524 .08754 L
.59785 .08125 L
.60046 .07581 L
.60307 .07096 L
.60568 .06655 L
.60828 .18758 L
.61089 .17664 L
.6135 .16899 L
.61611 .16276 L
.61872 .15738 L
.62133 .15258 L
.62394 .14821 L
.62655 .23419 L
.62916 .22332 L
.63177 .21572 L
.63438 .20952 L
.63699 .20417 L
.6396 .1994 L
.6422 .19505 L
.64481 .28134 L
.64742 .27055 L
.65003 .26299 L
.65264 .25683 L
.65525 .25151 L
.65786 .24676 L
.66047 .24244 L
.66308 .39437 L
.66569 .3838 L
.6683 .37636 L
.67091 .37029 L
.67352 .36505 L
Mistroke
.67613 .36037 L
.67873 .35611 L
.68134 .31141 L
.68395 .30063 L
.68656 .29308 L
.68917 .28692 L
.69178 .28161 L
.69439 .27687 L
.697 .27255 L
.69961 .48659 L
.70222 .47618 L
.70483 .46882 L
.70744 .46282 L
.71005 .45763 L
.71265 .453 L
.71526 .44879 L
.71787 .47139 L
.72048 .4609 L
.72309 .45351 L
.7257 .44748 L
.72831 .44227 L
.73092 .43762 L
.73353 .43339 L
.73614 .33572 L
.73875 .32492 L
.74136 .31735 L
.74397 .31119 L
.74658 .30586 L
.74918 .30111 L
.75179 .29679 L
.7544 .43677 L
.75701 .42618 L
.75962 .41872 L
.76223 .41265 L
.76484 .4074 L
.76745 .40271 L
.77006 .39844 L
.77267 .4229 L
.77528 .41226 L
.77789 .40477 L
.7805 .39867 L
.78311 .3934 L
.78571 .3887 L
.78832 .38442 L
.79093 .52879 L
.79354 .51835 L
.79615 .51099 L
.79876 .50498 L
.80137 .49978 L
.80398 .49515 L
Mistroke
.80659 .49092 L
.8092 .39527 L
.81181 .38451 L
.81442 .37696 L
.81703 .37082 L
.81963 .36551 L
.82224 .36077 L
.82485 .35646 L
.82746 .45204 L
.83007 .44139 L
.83268 .43391 L
.83529 .42781 L
.8379 .42254 L
.84051 .41784 L
.84312 .41356 L
.84573 .33619 L
.84834 .32527 L
.85095 .31763 L
.85356 .31141 L
.85616 .30605 L
.85877 .30126 L
.86138 .2969 L
.86399 .32471 L
.8666 .31376 L
.86921 .30611 L
.87182 .29987 L
.87443 .29449 L
.87704 .28969 L
.87965 .28532 L
.88226 .46749 L
.88487 .45684 L
.88748 .44935 L
.89008 .44325 L
.89269 .43797 L
.8953 .43327 L
.89791 .42898 L
.90052 .35989 L
.90313 .34898 L
.90574 .34134 L
.90835 .33512 L
.91096 .32976 L
.91357 .32497 L
.91618 .32061 L
.91879 .30023 L
.9214 .28918 L
.92401 .28147 L
.92661 .27519 L
.92922 .26977 L
.93183 .26494 L
.93444 .26054 L
Mistroke
.93705 .30784 L
.93966 .29681 L
.94227 .28909 L
.94488 .28282 L
.94749 .27741 L
.9501 .27258 L
.95271 .26818 L
.95532 .27965 L
.95793 .26854 L
.96053 .26079 L
.96314 .25448 L
.96575 .24904 L
.96836 .24419 L
.97097 .23977 L
.97358 .32049 L
.97619 .30946 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -0.0810857 1.64368 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0011 -24 -4.5 ]
[-0.0125 .0011 0 4.5 ]
[-0.0125 .08328 -18 -4.5 ]
[-0.0125 .08328 0 4.5 ]
[-0.0125 .16547 -24 -4.5 ]
[-0.0125 .16547 0 4.5 ]
[-0.0125 .24765 -18 -4.5 ]
[-0.0125 .24765 0 4.5 ]
[-0.0125 .32983 -24 -4.5 ]
[-0.0125 .32983 0 4.5 ]
[-0.0125 .41202 -18 -4.5 ]
[-0.0125 .41202 0 4.5 ]
[-0.0125 .4942 -24 -4.5 ]
[-0.0125 .4942 0 4.5 ]
[-0.0125 .57639 -18 -4.5 ]
[-0.0125 .57639 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36222 -5 -6 ]
[.97619 .36222 5 6 ]
[.97619 .24855 -5 -6 ]
[.97619 .24855 5 6 ]
[.97619 .47265 -5 -6 ]
[.97619 .47265 5 6 ]
[.97619 .02445 -5 -6 ]
[.97619 .02445 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0011 m
.00625 .0011 L
s
[(0.05)] -0.0125 .0011 1 0 Mshowa
0 .08328 m
.00625 .08328 L
s
[(0.1)] -0.0125 .08328 1 0 Mshowa
0 .16547 m
.00625 .16547 L
s
[(0.15)] -0.0125 .16547 1 0 Mshowa
0 .24765 m
.00625 .24765 L
s
[(0.2)] -0.0125 .24765 1 0 Mshowa
0 .32983 m
.00625 .32983 L
s
[(0.25)] -0.0125 .32983 1 0 Mshowa
0 .41202 m
.00625 .41202 L
s
[(0.3)] -0.0125 .41202 1 0 Mshowa
0 .4942 m
.00625 .4942 L
s
[(0.35)] -0.0125 .4942 1 0 Mshowa
0 .57639 m
.00625 .57639 L
s
[(0.4)] -0.0125 .57639 1 0 Mshowa
.125 Mabswid
0 .01754 m
.00375 .01754 L
s
0 .03397 m
.00375 .03397 L
s
0 .05041 m
.00375 .05041 L
s
0 .06685 m
.00375 .06685 L
s
0 .09972 m
.00375 .09972 L
s
0 .11616 m
.00375 .11616 L
s
0 .13259 m
.00375 .13259 L
s
0 .14903 m
.00375 .14903 L
s
0 .1819 m
.00375 .1819 L
s
0 .19834 m
.00375 .19834 L
s
0 .21478 m
.00375 .21478 L
s
0 .23121 m
.00375 .23121 L
s
0 .26409 m
.00375 .26409 L
s
0 .28052 m
.00375 .28052 L
s
0 .29696 m
.00375 .29696 L
s
0 .3134 m
.00375 .3134 L
s
0 .34627 m
.00375 .34627 L
s
0 .36271 m
.00375 .36271 L
s
0 .37914 m
.00375 .37914 L
s
0 .39558 m
.00375 .39558 L
s
0 .42845 m
.00375 .42845 L
s
0 .44489 m
.00375 .44489 L
s
0 .46133 m
.00375 .46133 L
s
0 .47777 m
.00375 .47777 L
s
0 .51064 m
.00375 .51064 L
s
0 .52708 m
.00375 .52708 L
s
0 .54351 m
.00375 .54351 L
s
0 .55995 m
.00375 .55995 L
s
0 .59282 m
.00375 .59282 L
s
0 .60926 m
.00375 .60926 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0011 m
1 .0011 L
s
.99375 .08328 m
1 .08328 L
s
.99375 .16547 m
1 .16547 L
s
.99375 .24765 m
1 .24765 L
s
.99375 .32983 m
1 .32983 L
s
.99375 .41202 m
1 .41202 L
s
.99375 .4942 m
1 .4942 L
s
.99375 .57639 m
1 .57639 L
s
.125 Mabswid
.99625 .01754 m
1 .01754 L
s
.99625 .03397 m
1 .03397 L
s
.99625 .05041 m
1 .05041 L
s
.99625 .06685 m
1 .06685 L
s
.99625 .09972 m
1 .09972 L
s
.99625 .11616 m
1 .11616 L
s
.99625 .13259 m
1 .13259 L
s
.99625 .14903 m
1 .14903 L
s
.99625 .1819 m
1 .1819 L
s
.99625 .19834 m
1 .19834 L
s
.99625 .21478 m
1 .21478 L
s
.99625 .23121 m
1 .23121 L
s
.99625 .26409 m
1 .26409 L
s
.99625 .28052 m
1 .28052 L
s
.99625 .29696 m
1 .29696 L
s
.99625 .3134 m
1 .3134 L
s
.99625 .34627 m
1 .34627 L
s
.99625 .36271 m
1 .36271 L
s
.99625 .37914 m
1 .37914 L
s
.99625 .39558 m
1 .39558 L
s
.99625 .42845 m
1 .42845 L
s
.99625 .44489 m
1 .44489 L
s
.99625 .46133 m
1 .46133 L
s
.99625 .47777 m
1 .47777 L
s
.99625 .51064 m
1 .51064 L
s
.99625 .52708 m
1 .52708 L
s
.99625 .54351 m
1 .54351 L
s
.99625 .55995 m
1 .55995 L
s
.99625 .59282 m
1 .59282 L
s
.99625 .60926 m
1 .60926 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 0 r
gsave
.97619 .36222 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .24765 m
.02642 .25412 L
.02903 .24763 L
.03164 .26799 L
.03425 .28627 L
.03686 .27415 L
.03947 .25398 L
.04207 .25624 L
.04468 .27541 L
.04729 .30449 L
.0499 .30073 L
.05251 .30123 L
.05512 .34761 L
.05773 .37945 L
.06034 .38293 L
.06295 .37933 L
.06556 .35639 L
.06817 .35013 L
.07078 .36567 L
.07339 .33876 L
.07599 .34622 L
.0786 .34255 L
.08121 .32105 L
.08382 .32393 L
.08643 .31 L
.08904 .32377 L
.09165 .31639 L
.09426 .29555 L
.09687 .2812 L
.09948 .24541 L
.10209 .24474 L
.1047 .21954 L
.10731 .22683 L
.10992 .2431 L
.11252 .22877 L
.11513 .22777 L
.11774 .21937 L
.12035 .2171 L
.12296 .22935 L
.12557 .23481 L
.12818 .2369 L
.13079 .26447 L
.1334 .25794 L
.13601 .26939 L
.13862 .26795 L
.14123 .24877 L
.14384 .27193 L
.14644 .30974 L
.14905 .30288 L
.15166 .29392 L
Mistroke
.15427 .27524 L
.15688 .28998 L
.15949 .27925 L
.1621 .28845 L
.16471 .27049 L
.16732 .2617 L
.16993 .28696 L
.17254 .28259 L
.17515 .2699 L
.17776 .29153 L
.18037 .25108 L
.18297 .23127 L
.18558 .22606 L
.18819 .19851 L
.1908 .18046 L
.19341 .20679 L
.19602 .19265 L
.19863 .21924 L
.20124 .20451 L
.20385 .22145 L
.20646 .21563 L
.20907 .2099 L
.21168 .22356 L
.21429 .20534 L
.21689 .22931 L
.2195 .23629 L
.22211 .21915 L
.22472 .24974 L
.22733 .21255 L
.22994 .21033 L
.23255 .22397 L
.23516 .22904 L
.23777 .24993 L
.24038 .23374 L
.24299 .21463 L
.2456 .20617 L
.24821 .21126 L
.25082 .20816 L
.25342 .20235 L
.25603 .21621 L
.25864 .21019 L
.26125 .2315 L
.26386 .23468 L
.26647 .23423 L
.26908 .26235 L
.27169 .25304 L
.2743 .25312 L
.27691 .26187 L
.27952 .25583 L
.28213 .27838 L
Mistroke
.28474 .27837 L
.28735 .2635 L
.28995 .24908 L
.29256 .22992 L
.29517 .22472 L
.29778 .21586 L
.30039 .21797 L
.303 .21574 L
.30561 .20501 L
.30822 .21423 L
.31083 .21644 L
.31344 .23113 L
.31605 .22167 L
.31866 .24822 L
.32127 .26924 L
.32387 .24947 L
.32648 .24422 L
.32909 .23836 L
.3317 .25878 L
.33431 .23466 L
.33692 .25643 L
.33953 .25754 L
.34214 .26256 L
.34475 .25409 L
.34736 .23685 L
.34997 .22523 L
.35258 .2278 L
.35519 .2618 L
.3578 .2471 L
.3604 .27119 L
.36301 .27458 L
.36562 .2616 L
.36823 .23643 L
.37084 .26532 L
.37345 .28182 L
.37606 .27983 L
.37867 .27611 L
.38128 .27308 L
.38389 .25924 L
.3865 .24205 L
.38911 .24699 L
.39172 .27246 L
.39432 .29809 L
.39693 .29002 L
.39954 .28635 L
.40215 .28895 L
.40476 .30541 L
.40737 .27828 L
.40998 .27163 L
.41259 .26293 L
Mistroke
.4152 .26969 L
.41781 .28265 L
.42042 .25654 L
.42303 .25114 L
.42564 .27811 L
.42825 .25842 L
.43085 .27851 L
.43346 .29375 L
.43607 .32233 L
.43868 .30341 L
.44129 .32612 L
.4439 .36146 L
.44651 .3775 L
.44912 .37872 L
.45173 .37646 L
.45434 .36403 L
.45695 .36985 L
.45956 .40065 L
.46217 .41386 L
.46477 .41101 L
.46738 .43801 L
.46999 .41492 L
.4726 .42 L
.47521 .41423 L
.47782 .4148 L
.48043 .45086 L
.48304 .45192 L
.48565 .45992 L
.48826 .46426 L
.49087 .4524 L
.49348 .48339 L
.49609 .44471 L
.4987 .39735 L
.5013 .40892 L
.50391 .40288 L
.50652 .39228 L
.50913 .37738 L
.51174 .38884 L
.51435 .41363 L
.51696 .40233 L
.51957 .41888 L
.52218 .37722 L
.52479 .38637 L
.5274 .42739 L
.53001 .42831 L
.53262 .44621 L
.53523 .45244 L
.53783 .47502 L
.54044 .48768 L
.54305 .48977 L
Mistroke
.54566 .46021 L
.54827 .45887 L
.55088 .4785 L
.55349 .49515 L
.5561 .52375 L
.55871 .53185 L
.56132 .53355 L
.56393 .54069 L
.56654 .51441 L
.56915 .50818 L
.57175 .467 L
.57436 .48153 L
.57697 .50792 L
.57958 .5451 L
.58219 .55304 L
.5848 .5392 L
.58741 .54899 L
.59002 .54379 L
.59263 .55569 L
.59524 .57025 L
.59785 .55776 L
.60046 .54053 L
.60307 .53629 L
.60568 .50385 L
.60828 .52451 L
.61089 .5205 L
.6135 .54541 L
.61611 .51515 L
.61872 .49007 L
.62133 .47477 L
.62394 .47803 L
.62655 .49179 L
.62916 .48159 L
.63177 .49257 L
.63438 .49777 L
.63699 .51756 L
.6396 .50793 L
.6422 .49452 L
.64481 .51149 L
.64742 .5229 L
.65003 .48982 L
.65264 .51129 L
.65525 .49695 L
.65786 .48327 L
.66047 .49718 L
.66308 .51714 L
.66569 .50697 L
.6683 .53415 L
.67091 .5464 L
.67352 .55494 L
Mistroke
.67613 .54854 L
.67873 .51469 L
.68134 .53158 L
.68395 .51028 L
.68656 .50635 L
.68917 .51463 L
.69178 .48831 L
.69439 .48755 L
.697 .51824 L
.69961 .53817 L
.70222 .50544 L
.70483 .49289 L
.70744 .4827 L
.71005 .48658 L
.71265 .47835 L
.71526 .48772 L
.71787 .46506 L
.72048 .45655 L
.72309 .4462 L
.7257 .42795 L
.72831 .44462 L
.73092 .4579 L
.73353 .47743 L
.73614 .48486 L
.73875 .46439 L
.74136 .45276 L
.74397 .44828 L
.74658 .4642 L
.74918 .47665 L
.75179 .48409 L
.7544 .51023 L
.75701 .52108 L
.75962 .53796 L
.76223 .52202 L
.76484 .51549 L
.76745 .48891 L
.77006 .47438 L
.77267 .48514 L
.77528 .5209 L
.77789 .55524 L
.7805 .57621 L
.78311 .54379 L
.78571 .53368 L
.78832 .56528 L
.79093 .56381 L
.79354 .55578 L
.79615 .55139 L
.79876 .54741 L
.80137 .54835 L
.80398 .58061 L
Mistroke
.80659 .58194 L
.8092 .57858 L
.81181 .56169 L
.81442 .59348 L
.81703 .57005 L
.81963 .57049 L
.82224 .58547 L
.82485 .578 L
.82746 .58866 L
.83007 .58239 L
.83268 .58305 L
.83529 .57957 L
.8379 .57612 L
.84051 .5948 L
.84312 .58212 L
.84573 .58619 L
.84834 .60309 L
.85095 .60332 L
.85356 .59987 L
.85616 .5912 L
.85877 .56269 L
.86138 .57985 L
.86399 .56955 L
.8666 .54411 L
.86921 .53013 L
.87182 .52063 L
.87443 .50369 L
.87704 .49013 L
.87965 .48235 L
.88226 .47703 L
.88487 .46664 L
.88748 .49259 L
.89008 .4894 L
.89269 .51004 L
.8953 .52141 L
.89791 .49275 L
.90052 .49758 L
.90313 .4874 L
.90574 .47953 L
.90835 .4935 L
.91096 .44654 L
.91357 .4475 L
.91618 .43361 L
.91879 .44526 L
.9214 .4624 L
.92401 .45749 L
.92661 .46551 L
.92922 .44214 L
.93183 .42901 L
.93444 .45292 L
Mistroke
.93705 .45833 L
.93966 .43599 L
.94227 .43838 L
.94488 .44859 L
.94749 .44222 L
.9501 .44909 L
.95271 .45117 L
.95532 .42371 L
.95793 .42456 L
.96053 .40612 L
.96314 .41924 L
.96575 .38902 L
.96836 .38466 L
.97097 .36858 L
.97358 .35059 L
.97619 .36222 L
Mfstroke
0 0 1 r
gsave
.97619 .24855 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24765 m
.02642 .24765 L
.02903 .24765 L
.03164 .24765 L
.03425 .24765 L
.03686 .24765 L
.03947 .24765 L
.04207 .24627 L
.04468 .24628 L
.04729 .24628 L
.0499 .24629 L
.05251 .24629 L
.05512 .24629 L
.05773 .2463 L
.06034 .24509 L
.06295 .2451 L
.06556 .24511 L
.06817 .24511 L
.07078 .24512 L
.07339 .24513 L
.07599 .24513 L
.0786 .2448 L
.08121 .2448 L
.08382 .24481 L
.08643 .24482 L
.08904 .24483 L
.09165 .24484 L
.09426 .24484 L
.09687 .24318 L
.09948 .2432 L
.10209 .24321 L
.1047 .24322 L
.10731 .24323 L
.10992 .24324 L
.11252 .24326 L
.11513 .24252 L
.11774 .24254 L
.12035 .24255 L
.12296 .24257 L
.12557 .24258 L
.12818 .24259 L
.13079 .24261 L
.1334 .24238 L
.13601 .2424 L
.13862 .24241 L
.14123 .24243 L
.14384 .24244 L
.14644 .24245 L
.14905 .24247 L
.15166 .24505 L
Mistroke
.15427 .24506 L
.15688 .24506 L
.15949 .24507 L
.1621 .24508 L
.16471 .24509 L
.16732 .24509 L
.16993 .24543 L
.17254 .24544 L
.17515 .24544 L
.17776 .24545 L
.18037 .24545 L
.18297 .24546 L
.18558 .24547 L
.18819 .2465 L
.1908 .2465 L
.19341 .2465 L
.19602 .24651 L
.19863 .24651 L
.20124 .24651 L
.20385 .24652 L
.20646 .24916 L
.20907 .24916 L
.21168 .24915 L
.21429 .24915 L
.21689 .24915 L
.2195 .24914 L
.22211 .24914 L
.22472 .24907 L
.22733 .24907 L
.22994 .24906 L
.23255 .24906 L
.23516 .24905 L
.23777 .24905 L
.24038 .24905 L
.24299 .24921 L
.2456 .24921 L
.24821 .2492 L
.25082 .2492 L
.25342 .2492 L
.25603 .24919 L
.25864 .24919 L
.26125 .24903 L
.26386 .24903 L
.26647 .24903 L
.26908 .24902 L
.27169 .24902 L
.2743 .24901 L
.27691 .24901 L
.27952 .25002 L
.28213 .25001 L
Mistroke
.28474 .25 L
.28735 .25 L
.28995 .24999 L
.29256 .24999 L
.29517 .24998 L
.29778 .25016 L
.30039 .25015 L
.303 .25014 L
.30561 .25013 L
.30822 .25013 L
.31083 .25012 L
.31344 .25011 L
.31605 .24879 L
.31866 .24878 L
.32127 .24878 L
.32387 .24878 L
.32648 .24878 L
.32909 .24877 L
.3317 .24877 L
.33431 .2485 L
.33692 .2485 L
.33953 .24849 L
.34214 .24849 L
.34475 .24849 L
.34736 .24849 L
.34997 .24849 L
.35258 .24683 L
.35519 .24684 L
.3578 .24684 L
.3604 .24684 L
.36301 .24684 L
.36562 .24684 L
.36823 .24685 L
.37084 .24695 L
.37345 .24695 L
.37606 .24695 L
.37867 .24695 L
.38128 .24696 L
.38389 .24696 L
.3865 .24696 L
.38911 .25011 L
.39172 .2501 L
.39432 .25009 L
.39693 .25009 L
.39954 .25008 L
.40215 .25007 L
.40476 .25007 L
.40737 .25045 L
.40998 .25044 L
.41259 .25044 L
Mistroke
.4152 .25043 L
.41781 .25042 L
.42042 .25041 L
.42303 .25041 L
.42564 .24957 L
.42825 .24956 L
.43085 .24956 L
.43346 .24955 L
.43607 .24955 L
.43868 .24954 L
.44129 .24954 L
.4439 .25083 L
.44651 .25082 L
.44912 .25081 L
.45173 .2508 L
.45434 .25079 L
.45695 .25078 L
.45956 .25077 L
.46217 .25073 L
.46477 .25072 L
.46738 .25072 L
.46999 .25071 L
.4726 .2507 L
.47521 .25069 L
.47782 .25068 L
.48043 .24794 L
.48304 .24794 L
.48565 .24794 L
.48826 .24794 L
.49087 .24794 L
.49348 .24794 L
.49609 .24794 L
.4987 .248 L
.5013 .248 L
.50391 .248 L
.50652 .248 L
.50913 .248 L
.51174 .248 L
.51435 .248 L
.51696 .24736 L
.51957 .24736 L
.52218 .24736 L
.52479 .24736 L
.5274 .24736 L
.53001 .24736 L
.53262 .24736 L
.53523 .25033 L
.53783 .25032 L
.54044 .25031 L
.54305 .2503 L
Mistroke
.54566 .2503 L
.54827 .25029 L
.55088 .25028 L
.55349 .25305 L
.5561 .25304 L
.55871 .25302 L
.56132 .25301 L
.56393 .253 L
.56654 .25298 L
.56915 .25297 L
.57175 .25985 L
.57436 .25981 L
.57697 .25978 L
.57958 .25975 L
.58219 .25971 L
.5848 .25968 L
.58741 .25965 L
.59002 .25694 L
.59263 .25692 L
.59524 .25689 L
.59785 .25687 L
.60046 .25684 L
.60307 .25682 L
.60568 .25679 L
.60828 .25248 L
.61089 .25247 L
.6135 .25245 L
.61611 .25244 L
.61872 .25243 L
.62133 .25242 L
.62394 .2524 L
.62655 .24994 L
.62916 .24993 L
.63177 .24993 L
.63438 .24992 L
.63699 .24991 L
.6396 .24991 L
.6422 .2499 L
.64481 .2474 L
.64742 .2474 L
.65003 .2474 L
.65264 .2474 L
.65525 .2474 L
.65786 .2474 L
.66047 .2474 L
.66308 .24126 L
.66569 .24128 L
.6683 .24129 L
.67091 .24131 L
.67352 .24133 L
Mistroke
.67613 .24135 L
.67873 .24136 L
.68134 .24608 L
.68395 .24608 L
.68656 .24609 L
.68917 .24609 L
.69178 .24609 L
.69439 .2461 L
.697 .2461 L
.69961 .23645 L
.70222 .23648 L
.70483 .23651 L
.70744 .23654 L
.71005 .23657 L
.71265 .2366 L
.71526 .23663 L
.71787 .2376 L
.72048 .23763 L
.72309 .23766 L
.7257 .23768 L
.72831 .23771 L
.73092 .23774 L
.73353 .23776 L
.73614 .24554 L
.73875 .24554 L
.74136 .24555 L
.74397 .24556 L
.74658 .24556 L
.74918 .24557 L
.75179 .24557 L
.7544 .23998 L
.75701 .24 L
.75962 .24002 L
.76223 .24004 L
.76484 .24006 L
.76745 .24008 L
.77006 .2401 L
.77267 .24099 L
.77528 .24101 L
.77789 .24103 L
.7805 .24104 L
.78311 .24106 L
.78571 .24108 L
.78832 .2411 L
.79093 .23518 L
.79354 .23522 L
.79615 .23525 L
.79876 .23528 L
.80137 .23532 L
.80398 .23535 L
Mistroke
.80659 .23538 L
.8092 .24316 L
.81181 .24317 L
.81442 .24318 L
.81703 .24319 L
.81963 .2432 L
.82224 .24322 L
.82485 .24323 L
.82746 .24008 L
.83007 .2401 L
.83268 .24012 L
.83529 .24014 L
.8379 .24016 L
.84051 .24019 L
.84312 .24021 L
.84573 .24695 L
.84834 .24695 L
.85095 .24695 L
.85356 .24696 L
.85616 .24696 L
.85877 .24696 L
.86138 .24696 L
.86399 .2477 L
.8666 .2477 L
.86921 .2477 L
.87182 .2477 L
.87443 .2477 L
.87704 .2477 L
.87965 .2477 L
.88226 .23962 L
.88487 .23964 L
.88748 .23966 L
.89008 .23968 L
.89269 .2397 L
.8953 .23973 L
.89791 .23975 L
.90052 .24607 L
.90313 .24607 L
.90574 .24608 L
.90835 .24608 L
.91096 .24608 L
.91357 .24609 L
.91618 .24609 L
.91879 .24961 L
.9214 .2496 L
.92401 .2496 L
.92661 .24959 L
.92922 .24959 L
.93183 .24958 L
.93444 .24958 L
Mistroke
.93705 .24921 L
.93966 .24921 L
.94227 .24921 L
.94488 .2492 L
.94749 .2492 L
.9501 .24919 L
.95271 .24919 L
.95532 .25089 L
.95793 .25088 L
.96053 .25087 L
.96314 .25086 L
.96575 .25085 L
.96836 .25084 L
.97097 .25083 L
.97358 .24855 L
.97619 .24855 L
Mfstroke
0 .98 .604 r
gsave
.97619 .47265 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41202 m
.02642 .41247 L
.02903 .41292 L
.03164 .41336 L
.03425 .4138 L
.03686 .41423 L
.03947 .41467 L
.04207 .41371 L
.04468 .41414 L
.04729 .41456 L
.0499 .41499 L
.05251 .41541 L
.05512 .41582 L
.05773 .41623 L
.06034 .41542 L
.06295 .41583 L
.06556 .41624 L
.06817 .41664 L
.07078 .41704 L
.07339 .41744 L
.07599 .41783 L
.0786 .41787 L
.08121 .41826 L
.08382 .41864 L
.08643 .41903 L
.08904 .41941 L
.09165 .41978 L
.09426 .42016 L
.09687 .41885 L
.09948 .41922 L
.10209 .41959 L
.1047 .41996 L
.10731 .42033 L
.10992 .42069 L
.11252 .42105 L
.11513 .42065 L
.11774 .42101 L
.12035 .42136 L
.12296 .42172 L
.12557 .42207 L
.12818 .42241 L
.13079 .42276 L
.1334 .42285 L
.13601 .42319 L
.13862 .42353 L
.14123 .42386 L
.14384 .4242 L
.14644 .42453 L
.14905 .42486 L
.15166 .42773 L
Mistroke
.15427 .42805 L
.15688 .42837 L
.15949 .42868 L
.1621 .42899 L
.16471 .4293 L
.16732 .4296 L
.16993 .43022 L
.17254 .43052 L
.17515 .43082 L
.17776 .43112 L
.18037 .43142 L
.18297 .43171 L
.18558 .432 L
.18819 .4333 L
.1908 .43358 L
.19341 .43386 L
.19602 .43414 L
.19863 .43442 L
.20124 .4347 L
.20385 .43497 L
.20646 .43787 L
.20907 .43814 L
.21168 .4384 L
.21429 .43866 L
.21689 .43892 L
.2195 .43917 L
.22211 .43943 L
.22472 .4396 L
.22733 .43985 L
.22994 .4401 L
.23255 .44035 L
.23516 .4406 L
.23777 .44084 L
.24038 .44108 L
.24299 .44148 L
.2456 .44172 L
.24821 .44196 L
.25082 .44219 L
.25342 .44243 L
.25603 .44266 L
.25864 .44289 L
.26125 .44295 L
.26386 .44318 L
.26647 .44341 L
.26908 .44363 L
.27169 .44386 L
.2743 .44408 L
.27691 .4443 L
.27952 .44552 L
.28213 .44573 L
Mistroke
.28474 .44595 L
.28735 .44616 L
.28995 .44637 L
.29256 .44658 L
.29517 .44679 L
.29778 .44716 L
.30039 .44736 L
.303 .44757 L
.30561 .44777 L
.30822 .44797 L
.31083 .44817 L
.31344 .44837 L
.31605 .44723 L
.31866 .44743 L
.32127 .44763 L
.32387 .44783 L
.32648 .44802 L
.32909 .44822 L
.3317 .44841 L
.33431 .44831 L
.33692 .44851 L
.33953 .4487 L
.34214 .44889 L
.34475 .44907 L
.34736 .44926 L
.34997 .44945 L
.35258 .44796 L
.35519 .44815 L
.3578 .44834 L
.3604 .44852 L
.36301 .44871 L
.36562 .44889 L
.36823 .44907 L
.37084 .44933 L
.37345 .44951 L
.37606 .44969 L
.37867 .44987 L
.38128 .45004 L
.38389 .45022 L
.3865 .45039 L
.38911 .45369 L
.39172 .45385 L
.39432 .45402 L
.39693 .45418 L
.39954 .45434 L
.40215 .4545 L
.40476 .45465 L
.40737 .45518 L
.40998 .45534 L
.41259 .45549 L
Mistroke
.4152 .45564 L
.41781 .4558 L
.42042 .45595 L
.42303 .4561 L
.42564 .4554 L
.42825 .45555 L
.43085 .4557 L
.43346 .45585 L
.43607 .45599 L
.43868 .45614 L
.44129 .45629 L
.4439 .4577 L
.44651 .45784 L
.44912 .45798 L
.45173 .45812 L
.45434 .45826 L
.45695 .4584 L
.45956 .45853 L
.46217 .45862 L
.46477 .45875 L
.46738 .45888 L
.46999 .45902 L
.4726 .45915 L
.47521 .45928 L
.47782 .45941 L
.48043 .45679 L
.48304 .45692 L
.48565 .45706 L
.48826 .4572 L
.49087 .45733 L
.49348 .45746 L
.49609 .4576 L
.4987 .45777 L
.5013 .4579 L
.50391 .45803 L
.50652 .45816 L
.50913 .45829 L
.51174 .45841 L
.51435 .45854 L
.51696 .45801 L
.51957 .45813 L
.52218 .45826 L
.52479 .45839 L
.5274 .45851 L
.53001 .45864 L
.53262 .45876 L
.53523 .46182 L
.53783 .46193 L
.54044 .46205 L
.54305 .46216 L
Mistroke
.54566 .46227 L
.54827 .46238 L
.55088 .46249 L
.55349 .46536 L
.5561 .46546 L
.55871 .46556 L
.56132 .46566 L
.56393 .46576 L
.56654 .46586 L
.56915 .46596 L
.57175 .47293 L
.57436 .47301 L
.57697 .47309 L
.57958 .47316 L
.58219 .47324 L
.5848 .47332 L
.58741 .47339 L
.59002 .47077 L
.59263 .47085 L
.59524 .47093 L
.59785 .47101 L
.60046 .47109 L
.60307 .47117 L
.60568 .47125 L
.60828 .46702 L
.61089 .46711 L
.6135 .4672 L
.61611 .46729 L
.61872 .46738 L
.62133 .46746 L
.62394 .46755 L
.62655 .46516 L
.62916 .46526 L
.63177 .46535 L
.63438 .46544 L
.63699 .46553 L
.6396 .46562 L
.6422 .46571 L
.64481 .46328 L
.64742 .46337 L
.65003 .46347 L
.65264 .46356 L
.65525 .46366 L
.65786 .46375 L
.66047 .46384 L
.66308 .45777 L
.66569 .45788 L
.6683 .45799 L
.67091 .45809 L
.67352 .4582 L
Mistroke
.67613 .45831 L
.67873 .45841 L
.68134 .46319 L
.68395 .46328 L
.68656 .46337 L
.68917 .46347 L
.69178 .46356 L
.69439 .46365 L
.697 .46374 L
.69961 .45414 L
.70222 .45426 L
.70483 .45437 L
.70744 .45448 L
.71005 .4546 L
.71265 .45471 L
.71526 .45482 L
.71787 .45585 L
.72048 .45596 L
.72309 .45607 L
.7257 .45617 L
.72831 .45628 L
.73092 .45639 L
.73353 .45649 L
.73614 .46432 L
.73875 .46441 L
.74136 .46449 L
.74397 .46457 L
.74658 .46465 L
.74918 .46474 L
.75179 .46482 L
.7544 .45927 L
.75701 .45937 L
.75962 .45946 L
.76223 .45956 L
.76484 .45965 L
.76745 .45975 L
.77006 .45984 L
.77267 .46078 L
.77528 .46087 L
.77789 .46096 L
.7805 .46105 L
.78311 .46114 L
.78571 .46122 L
.78832 .46131 L
.79093 .45544 L
.79354 .45554 L
.79615 .45565 L
.79876 .45575 L
.80137 .45585 L
.80398 .45595 L
Mistroke
.80659 .45605 L
.8092 .46387 L
.81181 .46395 L
.81442 .46402 L
.81703 .4641 L
.81963 .46418 L
.82224 .46426 L
.82485 .46434 L
.82746 .46123 L
.83007 .46131 L
.83268 .4614 L
.83529 .46148 L
.8379 .46157 L
.84051 .46165 L
.84312 .46173 L
.84573 .46851 L
.84834 .46858 L
.85095 .46864 L
.85356 .4687 L
.85616 .46877 L
.85877 .46883 L
.86138 .46889 L
.86399 .46966 L
.8666 .46972 L
.86921 .46978 L
.87182 .46984 L
.87443 .4699 L
.87704 .46996 L
.87965 .47001 L
.88226 .46196 L
.88487 .46204 L
.88748 .46212 L
.89008 .4622 L
.89269 .46228 L
.8953 .46236 L
.89791 .46244 L
.90052 .46878 L
.90313 .46884 L
.90574 .4689 L
.90835 .46896 L
.91096 .46902 L
.91357 .46908 L
.91618 .46914 L
.91879 .47268 L
.9214 .47273 L
.92401 .47278 L
.92661 .47282 L
.92922 .47287 L
.93183 .47292 L
.93444 .47297 L
Mistroke
.93705 .47263 L
.93966 .47267 L
.94227 .47272 L
.94488 .47277 L
.94749 .47281 L
.9501 .47286 L
.95271 .4729 L
.95532 .47463 L
.95793 .47467 L
.96053 .47471 L
.96314 .47475 L
.96575 .47479 L
.96836 .47483 L
.97097 .47487 L
.97358 .47261 L
.97619 .47265 L
Mfstroke
gsave
.97619 .02445 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .08328 m
.02642 .08283 L
.02903 .08239 L
.03164 .08194 L
.03425 .0815 L
.03686 .08107 L
.03947 .08063 L
.04207 .07884 L
.04468 .07842 L
.04729 .078 L
.0499 .07759 L
.05251 .07717 L
.05512 .07677 L
.05773 .07636 L
.06034 .07476 L
.06295 .07437 L
.06556 .07397 L
.06817 .07358 L
.07078 .0732 L
.07339 .07281 L
.07599 .07243 L
.0786 .07173 L
.08121 .07135 L
.08382 .07098 L
.08643 .07061 L
.08904 .07025 L
.09165 .06989 L
.09426 .06953 L
.09687 .06752 L
.09948 .06717 L
.10209 .06682 L
.1047 .06648 L
.10731 .06614 L
.10992 .0658 L
.11252 .06546 L
.11513 .0644 L
.11774 .06407 L
.12035 .06374 L
.12296 .06342 L
.12557 .06309 L
.12818 .06278 L
.13079 .06246 L
.1334 .06192 L
.13601 .06161 L
.13862 .0613 L
.14123 .06099 L
.14384 .06069 L
.14644 .06038 L
.14905 .06008 L
.15166 .06237 L
Mistroke
.15427 .06206 L
.15688 .06176 L
.15949 .06146 L
.1621 .06117 L
.16471 .06087 L
.16732 .06058 L
.16993 .06064 L
.17254 .06035 L
.17515 .06006 L
.17776 .05978 L
.18037 .05949 L
.18297 .05921 L
.18558 .05893 L
.18819 .0597 L
.1908 .05942 L
.19341 .05914 L
.19602 .05887 L
.19863 .0586 L
.20124 .05833 L
.20385 .05806 L
.20646 .06045 L
.20907 .06018 L
.21168 .05991 L
.21429 .05964 L
.21689 .05937 L
.2195 .05911 L
.22211 .05885 L
.22472 .05854 L
.22733 .05828 L
.22994 .05802 L
.23255 .05777 L
.23516 .05751 L
.23777 .05726 L
.24038 .05701 L
.24299 .05695 L
.2456 .0567 L
.24821 .05645 L
.25082 .05621 L
.25342 .05596 L
.25603 .05572 L
.25864 .05548 L
.26125 .05511 L
.26386 .05488 L
.26647 .05464 L
.26908 .05441 L
.27169 .05418 L
.2743 .05395 L
.27691 .05372 L
.27952 .05452 L
.28213 .05429 L
Mistroke
.28474 .05406 L
.28735 .05384 L
.28995 .05361 L
.29256 .05339 L
.29517 .05317 L
.29778 .05315 L
.30039 .05293 L
.303 .05271 L
.30561 .0525 L
.30822 .05228 L
.31083 .05207 L
.31344 .05186 L
.31605 .05035 L
.31866 .05014 L
.32127 .04994 L
.32387 .04973 L
.32648 .04953 L
.32909 .04933 L
.3317 .04913 L
.33431 .04868 L
.33692 .04849 L
.33953 .04829 L
.34214 .0481 L
.34475 .04791 L
.34736 .04771 L
.34997 .04752 L
.35258 .04571 L
.35519 .04552 L
.3578 .04534 L
.3604 .04516 L
.36301 .04498 L
.36562 .0448 L
.36823 .04462 L
.37084 .04457 L
.37345 .04439 L
.37606 .04422 L
.37867 .04404 L
.38128 .04387 L
.38389 .0437 L
.3865 .04353 L
.38911 .04653 L
.39172 .04635 L
.39432 .04617 L
.39693 .046 L
.39954 .04582 L
.40215 .04565 L
.40476 .04548 L
.40737 .04572 L
.40998 .04555 L
.41259 .04538 L
Mistroke
.4152 .04521 L
.41781 .04505 L
.42042 .04488 L
.42303 .04472 L
.42564 .04374 L
.42825 .04358 L
.43085 .04342 L
.43346 .04326 L
.43607 .0431 L
.43868 .04295 L
.44129 .04279 L
.4439 .04395 L
.44651 .04379 L
.44912 .04363 L
.45173 .04348 L
.45434 .04332 L
.45695 .04317 L
.45956 .04301 L
.46217 .04285 L
.46477 .0427 L
.46738 .04255 L
.46999 .0424 L
.4726 .04225 L
.47521 .0421 L
.47782 .04195 L
.48043 .0391 L
.48304 .03896 L
.48565 .03882 L
.48826 .03869 L
.49087 .03855 L
.49348 .03842 L
.49609 .03828 L
.4987 .03823 L
.5013 .0381 L
.50391 .03797 L
.50652 .03784 L
.50913 .03771 L
.51174 .03758 L
.51435 .03745 L
.51696 .03671 L
.51957 .03658 L
.52218 .03646 L
.52479 .03633 L
.5274 .03621 L
.53001 .03609 L
.53262 .03597 L
.53523 .03883 L
.53783 .0387 L
.54044 .03857 L
.54305 .03845 L
Mistroke
.54566 .03832 L
.54827 .03819 L
.55088 .03807 L
.55349 .04075 L
.5561 .04062 L
.55871 .04049 L
.56132 .04036 L
.56393 .04023 L
.56654 .0401 L
.56915 .03997 L
.57175 .04677 L
.57436 .04662 L
.57697 .04648 L
.57958 .04633 L
.58219 .04619 L
.5848 .04605 L
.58741 .04591 L
.59002 .04312 L
.59263 .04298 L
.59524 .04285 L
.59785 .04272 L
.60046 .04259 L
.60307 .04246 L
.60568 .04233 L
.60828 .03794 L
.61089 .03782 L
.6135 .03771 L
.61611 .03759 L
.61872 .03748 L
.62133 .03737 L
.62394 .03725 L
.62655 .03471 L
.62916 .03461 L
.63177 .0345 L
.63438 .0344 L
.63699 .0343 L
.6396 .03419 L
.6422 .03409 L
.64481 .03152 L
.64742 .03142 L
.65003 .03133 L
.65264 .03123 L
.65525 .03114 L
.65786 .03105 L
.66047 .03096 L
.66308 .02475 L
.66569 .02468 L
.6683 .0246 L
.67091 .02453 L
.67352 .02446 L
Mistroke
.67613 .02439 L
.67873 .02431 L
.68134 .02896 L
.68395 .02888 L
.68656 .0288 L
.68917 .02871 L
.69178 .02863 L
.69439 .02855 L
.697 .02847 L
.69961 .01875 L
.70222 .0187 L
.70483 .01865 L
.70744 .01859 L
.71005 .01854 L
.71265 .01849 L
.71526 .01844 L
.71787 .01935 L
.72048 .0193 L
.72309 .01924 L
.7257 .01919 L
.72831 .01914 L
.73092 .01909 L
.73353 .01903 L
.73614 .02675 L
.73875 .02668 L
.74136 .02661 L
.74397 .02654 L
.74658 .02647 L
.74918 .0264 L
.75179 .02633 L
.7544 .02068 L
.75701 .02063 L
.75962 .02057 L
.76223 .02052 L
.76484 .02047 L
.76745 .02041 L
.77006 .02036 L
.77267 .0212 L
.77528 .02115 L
.77789 .0211 L
.7805 .02104 L
.78311 .02099 L
.78571 .02094 L
.78832 .02088 L
.79093 .01492 L
.79354 .01489 L
.79615 .01485 L
.79876 .01482 L
.80137 .01478 L
.80398 .01475 L
Mistroke
.80659 .01472 L
.8092 .02244 L
.81181 .02239 L
.81442 .02233 L
.81703 .02228 L
.81963 .02223 L
.82224 .02217 L
.82485 .02212 L
.82746 .01894 L
.83007 .01889 L
.83268 .01885 L
.83529 .01881 L
.8379 .01876 L
.84051 .01872 L
.84312 .01868 L
.84573 .02539 L
.84834 .02533 L
.85095 .02527 L
.85356 .02521 L
.85616 .02515 L
.85877 .02509 L
.86138 .02503 L
.86399 .02573 L
.8666 .02567 L
.86921 .02561 L
.87182 .02556 L
.87443 .0255 L
.87704 .02544 L
.87965 .02538 L
.88226 .01727 L
.88487 .01723 L
.88748 .0172 L
.89008 .01716 L
.89269 .01713 L
.8953 .01709 L
.89791 .01706 L
.90052 .02335 L
.90313 .0233 L
.90574 .02325 L
.90835 .0232 L
.91096 .02315 L
.91357 .0231 L
.91618 .02305 L
.91879 .02654 L
.9214 .02648 L
.92401 .02642 L
.92661 .02636 L
.92922 .0263 L
.93183 .02625 L
.93444 .02619 L
Mistroke
.93705 .0258 L
.93966 .02575 L
.94227 .02569 L
.94488 .02564 L
.94749 .02558 L
.9501 .02553 L
.95271 .02547 L
.95532 .02715 L
.95793 .02709 L
.96053 .02703 L
.96314 .02697 L
.96575 .02692 L
.96836 .02686 L
.97097 .0268 L
.97358 .0245 L
.97619 .02445 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{545.688, 168.625},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008Q0000Z2000`400?l00000o`00003oo`3ooooo
0?ooob<0oooo003o0?ooool0oooo8`3oool00?l0ooooo`3ooolS0?ooo`00o`3ooooo0?ooob<0oooo
003o0?ooool0oooo8`3oool00?l0ooooo`3ooolS0?ooo`00o`3ooooo0?ooob<0oooo00180?ooo`80
0000503oool3000000@0oooo0P00000?0?ooo`<00000103oool2000000@0oooo0P00000;0?ooo`<0
00000`3oool3000000@0oooo0P00000;0?ooo`D000000`3oool2000000@0oooo0P00000;0?ooo`D0
00000P3oool3000000@0oooo0P00000;0?ooo`<00000103oool2000000@0oooo0P00000<0?ooo`<0
00000`3oool3000000@0oooo0P00000T0?ooo`8000005@3oool3000000@0oooo0P00000>0?ooo`<0
0000103oool2000000@0oooo0P00000<0?ooo`<000000`3oool3000000@0oooo0P00000;0?ooo`D0
00000`3oool2000000@0oooo0P00000:0?ooo`D000000P3oool3000000@0oooo0P00000<0?ooo`<0
0000103oool2000000@0oooo0P00000;0?ooo`<000000`3oool3000000@0oooo0P00000a0?ooo`00
A`3oool010000000oooo0?ooo`00000B0?ooo`050000003oool0oooo0?ooo`0000000P3oool01000
0000oooo0?ooo`00000?0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`00000;0?ooo`050000003oool0oooo0?ooo`0000000`3oool010000000
oooo0?ooo`0000020?ooo`030000003oool0oooo00T0oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000/0oooo00H000000?ooo`3oool0
00000?ooo`0000030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01`3oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000:0?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`040000003oool0
oooo00000080oooo00<000000?ooo`3oool0803oool010000000oooo0?ooo`00000C0?ooo`050000
003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`00000>0?ooo`030000003oool0oooo
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000<0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00T0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000000X0oooo00H000000?ooo`3oool000000?ooo`0000030?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool0203oool01@000000oooo0?ooo`3oool000000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000090?ooo`070000003oool0oooo0?ooo`00
0000oooo000000030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0;P3oool0
04L0oooo00@000000?ooo`3oool000005P3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000/0oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000020?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000000`0oooo00<000000?ooo`3oool01@3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo00/0oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`0000020?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool00`3oool01000
0000oooo0?ooo`0000020?ooo`030000003oool0oooo0200oooo00@000000?ooo`3oool000005`3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0
0P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000`0oooo00<000000?oo
o`3oool01@3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00X0oooo00<00000
0?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000/0oooo
00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00`0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo02h0oooo00170?ooo`040000003oool0oooo000001H0oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000;0?ooo`030000003oool0oooo00D0oooo00@000000?oo
o`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0
103oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00T0oooo0P0000030?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool00000303oool2000000H0oooo00@00000
0?ooo`3oool000000P3oool00`000000oooo0?ooo`0P0?ooo`040000003oool0oooo000001L0oooo
00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000<0?ooo`030000003oool0
oooo00D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0;0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo
00X0oooo0P0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000002`3o
ool2000000H0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0^0?ooo`00A`3o
ool010000000oooo0?ooo`00000B0?ooo`@000000`3oool010000000oooo0?ooo`00000?0?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000;
0?ooo`040000003oool0oooo0?ooo`@000000`3oool010000000oooo0?ooo`00000:0?ooo`050000
003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000000X0oooo00H000000?ooo`3oool0oooo0000003oool4000000<0oooo00@000000?ooo`3oool0
00003@3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool0303oool00`000000oooo00000003000000<0oooo00@000000?ooo`3oool000008P3o
ool010000000oooo0?ooo`00000C0?ooo`@000000`3oool010000000oooo0?ooo`00000>0?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000<
0?ooo`040000003oool0oooo0?ooo`@000000`3oool010000000oooo0?ooo`00000:0?ooo`050000
003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000000T0oooo00H000000?ooo`3oool0oooo0000003oool4000000<0oooo00@000000?ooo`3oool0
00003P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool02`3oool00`000000oooo00000003000000<0oooo00@000000?ooo`3oool00000<03o
ool004L0oooo00@000000?ooo`3oool000004P3oool00`000000oooo0?ooo`040?ooo`040000003o
ool0oooo000000h0oooo0P0000040?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000002P3oool2000000<0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`00000:
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000X0oooo00L000000?ooo`3oool0oooo0000003oool0000000H0oooo00@00000
0?ooo`3oool000002@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000:0?ooo`070000003oool0oooo0?ooo`000000oooo0000
00060?ooo`040000003oool0oooo00000280oooo00@000000?ooo`3oool000004`3oool00`000000
oooo0?ooo`040?ooo`040000003oool0oooo000000d0oooo0P0000040?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000002`3oool2000000<0oooo00<000000?ooo`3oool0103o
ool010000000oooo0?ooo`00000:0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000T0oooo00L000000?ooo`3oool0oooo0000
003oool0000000H0oooo00@000000?ooo`3oool000002P3oool01@000000oooo0?ooo`3oool00000
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000090?ooo`070000003o
ool0oooo0?ooo`000000oooo000000060?ooo`040000003oool0oooo00000300oooo00180?ooo`80
00004`3oool5000000<0oooo0P00000@0?ooo`030000003oool0oooo00<0oooo0P0000040?ooo`80
0000303oool010000000oooo0?ooo`3oool5000000<0oooo0P00000<0?ooo`<00000103oool20000
00@0oooo0P00000<0?ooo`<000000P3oool5000000<0oooo0P00000;0?ooo`<00000103oool20000
00@0oooo0P00000<0?ooo`<000000P3oool5000000<0oooo0P00000T0?ooo`800000503oool50000
00<0oooo0P00000?0?ooo`030000003oool0oooo00<0oooo0P0000040?ooo`8000003@3oool01000
0000oooo0?ooo`3oool5000000<0oooo0P00000<0?ooo`<00000103oool2000000@0oooo0P00000;
0?ooo`<000000P3oool5000000<0oooo0P00000<0?ooo`<00000103oool2000000@0oooo0P00000;
0?ooo`<000000P3oool5000000<0oooo0P00000a0?ooo`00o`3ooooo0?ooob<0oooo003o0?oooa<0
oooo0P0000040?ooo`030000003oool0oooo00<0oooo0P0000030?ooo`<00000n`3oool00?l0oooo
4P3oool010000000oooo0?ooo`0000080?ooo`060000003oool0oooo0000003oool000000`3oool0
0`000000oooo0?ooo`3h0?ooo`00A03oooo>00000080oooo00<000000?ooo`3oool01P3oool01000
0000oooo0?ooo`0000050?ooo`040000003oool0oooo0?ooold00000:P3oool004@0oooo0P000003
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`0000000P0000020?ooo`030000003oool0
oooo00H0oooo00@000000?ooo`3oool000001@3oool010000000oooo0?ooo`3oool300000080oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool00P3oool3000002X0oooo00140?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool05`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01L0oooo00<0
00000?ooo`3oool0603oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01L0oooo00<0
00000?ooo`3oool0603oool00`000000oooo0?ooo`0:0?ooo`8000000P3oool00`000000oooo0?oo
o`060?ooo`050000003oool0oooo0000003oool0100000040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo02P0oooo
00140?ooo`030000003oool0oooo07D0oooo00<00?ZJ0?ooo`3oool0D@3oool200000080oooo00<0
00000?ooo`3oool01P3oool01P000000oooo0?ooo`000000oooo000000L0oooo00<000000?ooo`3o
ool0X@3oool2003jVRH0oooo00<000000?ooo`3oool0:03oool004@0oooo0P00001e0?ooo`800?ZJ
DP3oool2000000030?ooo`000000000000X0oooo0P0000020?ooo`D000000`3oool2000008d0oooo
2000nYX;0?ooo`800?ZJ00<0oooo003jVP3oool00P3oool4003jVPL0oooo1000nYXC0?ooo`800000
:P3oool004@0oooo00<000000?ooo`3oool0M03oool2003jVU<0oooo00<000000?ooo`3oool05`3o
ool00`000000oooo0?ooo`260?ooo`<00?ZJ0`3oool00`00nYX0oooo0?ooo`040?ooo`04003jVP3o
ool0oooo0?ooo`P00?ZJ0`3oool4003jVP<0oooo00<00?ZJ0?ooo`3oool01@3oool01000nYX0oooo
0?ooo`3oool4003jVP/0oooo00<00?ZJ0?ooo`3oool00P3oool00`000000oooo0?ooo`0X0?ooo`00
A03oool00`000000oooo0?ooo`1c0?ooo`03003jVP3oool00?ZJ05<0oooo00<000000?ooo`3oool0
5`3oool00`000000oooo0?ooo`250?ooo`03003jVP3oool0oooo00@00?ZJ1`3oool5003jVQ80oooo
2000nYX70?ooo`/00?ZJ1@3oool00`000000oooo0?ooo`0X0?ooo`00A03oool00`000000oooo0?oo
o`1c0?ooo`03003jVP3oool00?ZJ05<0oooo00<000000?ooo`3oool05`3oool200000800oooo1P00
nYY30?ooo`800000:P3oool004@0oooo0P00001b0?ooo`0500000000nYX0oooo0?ooo`00nYX0DP3o
ool2000001T0oooo00<000000?ooo`3oool0G`3oool@003jVPX0oooo1P00nYY:0?ooo`030000003o
ool0oooo02P0oooo000a0?ooo`<000000`3oool00`000000oooo0?ooo`020?ooo`<000001@3oool0
0`000000oooo0?ooo`1a0?ooo`0500000000nYX0oooo0?ooo`00nYX0D`3oool00`000000oooo0?oo
o`0G0?ooo`030000003oool0oooo04X0oooo0`00nYX70?ooo``00?ZJ3P3oool4003jVP@0oooo1000
nYY?0?ooo`030000003oool0oooo02P0oooo000b0?ooo`030000003oool0oooo00H0oooo00D00000
0?ooo`3oool0oooo000000040?ooo`030000003oool0oooo0740oooo00D00000003jVP3oool0oooo
003jVP1C0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0@@3oool9003jVP<0oooo
2000nYXM0?ooo`@00?ZJD`3oool00`000000oooo0?ooo`0X0?ooo`00;`3oool5000000/0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`1a0?ooo`05003jVP3oool0oooo0?ooo`00nYX0
D`3oool00`000000oooo0?ooo`0G0?ooo`800000=P3oool<003jVXL0oooo0P00000Z0?ooo`00;`3o
ool010000000oooo0?ooo`00000<0?ooo`030000003oool0oooo0080oooo0P00001b0?ooo`05003j
VP3oool0oooo0?ooo`00nYX0D@3oool3000001T0oooo00<000000?ooo`3oool08`3oool00`00nYX0
oooo003jVP02003jVP<0oooo3@00nYZA0?ooo`030000003oool0oooo02P0oooo000`0?ooo`030000
003oool0000000P0oooo100000050?ooo`030000003oool0oooo0700oooo00<00000003jVP3oool0
0P3oool00`00nYX0oooo0?ooo`1A0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0
5P3oool@003jVP030?ooo`00nYX00?ZJ00800?ZJWP3oool00`000000oooo0?ooo`0X0?ooo`00<@3o
ool2000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`1`0?ooo`0300000000
nYX0oooo0080oooo00@00?ZJ0?ooo`3oool00?ZJD03oool00`000000oooo0?ooo`0G0?ooo`800000
4P3oool5003jV[80oooo0P00000Z0?ooo`00<P3oool00`000000oooo0?ooo`060?ooo`D00000103o
ool200000740oooo00<00000003jVP000?l00P000?l01000nYX0oooo0?ooo`00nYY?0?ooo`800000
1`3oool2000000@0oooo00<000000?ooo`3oool00P3oool3000000@0oooo00<000000?ooo`3oool0
2`3oool7003jV[L0oooo00<000000?ooo`3oool0:03oool004@0oooo00<000000?ooo`3oool0L03o
ool00`0000000?ZJ0?ooo`020?ooo`04003jVP3oool00?ZJ003jVU00oooo00<000000?ooo`3oool0
103oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool01P3oool6003jV[d0oooo00<000000?ooo`3oool0:03oool004@0oooo00<000000?ooo`3oool0
L03oool00`0000000?ZJ0?ooo`020?ooo`04003jVP3oool00?ZJ003jVU00oooo00<000000?ooo`3o
ool0103oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo00<0oooo0`0000020?oo
o`D00?ZJ`@3oool2000002X0oooo00140?ooo`030000003oool0oooo0700oooo00<00000003jVP00
00000P3oool2003jVP030?ooo`00nYX0oooo04l0oooo00<000000?ooo`3oool0103oool010000000
oooo0?ooo`0000090?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0b@3oool00`00
0000oooo0?ooo`0X0?ooo`00A03oool200000740oooo00<00000003jVP0000000P3oool2003jVP03
0?ooo`00nYX0oooo04h0oooo0P0000060?ooo`040000003oool0oooo000000T0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`390?ooo`030000003oool0oooo02P0oooo00140?ooo`03
0000003oool0oooo0700oooo00D00000003jVP000000oooo00000002003jVP030?ooo`00nYX0oooo
04l0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000080?ooo`8000001@3oool0
0`000000oooo0?ooo`390?ooo`030000003oool0oooo02P0oooo00140?ooo`030000003oool0oooo
0700oooo00D00000003jVP00nYX0oooo00000002003jVP030?ooo`00nYX0oooo04l0oooo00<00000
0?ooo`3oool01@3oool2000000X0oooo00<000000?ooo`3oool00`3oool200000<T0oooo0P00000Z
0?ooo`00A03oool00`000000oooo0?ooo`1`0?ooo`0600000000nYX00?ZJ0000003oool00?ZJ0P3o
ool00`00nYX0oooo0?ooo`1>0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0b@3o
ool00`000000oooo0?ooo`0X0?ooo`00A03oool200000740oooo00<00000003jVP00nYX00P3oool0
10000?l0oooo0?ooo`00nYY?0?ooo`8000006@3oool00`000000oooo0?ooo`390?ooo`030000003o
ool0oooo02P0oooo00140?ooo`030000003oool0oooo0700oooo00H00000003jVP3oool00?ZJ0?oo
o`000?l20?ooo`03003jVP3oool0oooo04h0oooo00<000000?ooo`3oool05`3oool200000<T0oooo
0P00000Z0?ooo`00A03oool00`000000oooo0?ooo`1`0?ooo`0600000000nYX0oooo0?ooo`00nYX0
003o0P3oool00`00nYX0oooo0?ooo`1>0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0b@3oool00`000000oooo0?ooo`0X0?ooo`00A03oool200000740oooo00D00000003jVP3oool0
oooo003jVP030000o`03003jVP3oool0oooo04d0oooo0P00000I0?ooo`030000003oool0oooo0<T0
oooo00<000000?ooo`3oool0:03oool002/0oooo0`0000030?ooo`030000003oool0oooo0080oooo
0`0000030?ooo`<000001@3oool00`000000oooo0?ooo`1`0?ooo`0300000000nYX0oooo0080oooo
00D00?ZJ000000000000003o003jVP1?0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0b@3oool00`000000oooo0?ooo`0X0?ooo`00;03oool00`000000oooo0?ooo`060?ooo`070000
003oool0oooo0?ooo`000000oooo000000030?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool0L03oool00`0000000?ZJ0?ooo`020?ooo`05003jVP3oool000000000o`00nYX0C`3oool0
0`000000oooo0?ooo`0G0?ooo`800000b@3oool2000002X0oooo000Y0?ooo`D000002`3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0L03oool00`00
00000?ZJ0?ooo`020?ooo`05003jVP3oool000000000o`00nYX0C`3oool00`000000oooo0?ooo`0G
0?ooo`030000003oool0oooo0<T0oooo00<000000?ooo`3oool0:03oool002T0oooo00@000000?oo
o`3oool00000303oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0P00001a
0?ooo`0300000000nYX0oooo0080oooo00D00?ZJ0?ooo`000000003o003jVP1=0?ooo`<000006@3o
ool00`000000oooo0?ooo`390?ooo`030000003oool0oooo02P0oooo000Z0?ooo`030000003oool0
000000P0oooo100000020?ooo`@000001@3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0
oooo0080oooo0P00nYX40?ooo`04003jVP3oool0003o003jVP80oooo00<00?ZJ0?ooo`3oool0BP3o
ool00`000000oooo0?ooo`0G0?ooo`800000b@3oool2000002X0oooo000[0?ooo`800000203oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0J`3oool0
0`000000oooo0?ooo`020?ooo`800?ZJ103oool01@00nYX0oooo0000o`00nYX0oooo00800?ZJC03o
ool010000000oooo0000000000040?ooo`030000003oool0oooo0080oooo0`0000030?ooo`<00000
103oool00`000000oooo0?ooo`390?ooo`030000003oool0oooo02P0oooo000/0?ooo`030000003o
ool0oooo00H0oooo1@0000000`3oool0000000000003000000@0oooo0P00001/0?ooo`070000003o
ool0oooo0?ooo`00nYX00000003jVP040?ooo`05003jVP3oool0003o003jVP3oool00P00nYY;0?oo
o`<000000P3oool00`000000oooo0?ooo`070?ooo`050000003oool0oooo0?ooo`0000000`3oool0
1@000000oooo0?ooo`3oool000000</0oooo00<000000?ooo`3oool0:03oool004@0oooo00<00000
0?ooo`3oool0J`3oool01`000000oooo0?ooo`3oool00?ZJ00000000nYX0103oool00`00nYX0oooo
0000o`02003jVP030?ooo`00nYX0oooo04/0oooo0P0000020?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01@3oool010000000oooo0?ooo`3oool300000<P0oooo0P00000Z0?ooo`00
A03oool00`000000oooo0?ooo`1[0?ooo`80000000D0oooo003jVP3oool00000003jVP050?ooo`06
003jVP0000000?ZJ003jVP3oool00?ZJC03oool200000080oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`050?ooo`050000003oool0oooo0?ooo`000000b`3oool00`000000oooo0?oo
o`0X0?ooo`00A03oool00`000000oooo0?ooo`1[0?ooo`<0000000@00?ZJ0000003oool00?ZJ1@3o
ool00`00nYX00000003jVP020?ooo`03003jVP3oool0oooo04X0oooo0P0000020?ooo`030000003o
ool0oooo00L0oooo00@000000?ooo`3oool0oooo100000040?ooo`030000003oool0oooo0<T0oooo
00<000000?ooo`3oool0:03oool004@0oooo0P00001L0?ooo`04003jVP3oool0oooo003jVP`0oooo
0`0000001000nYX000000?ooo`00nYX60?ooo`800?ZJ0P3oool00`00nYX0oooo0?ooo`190?ooo`<0
00000P3oool00`000000oooo0?ooo`060?ooo`8000000`3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo02@0oooo00<000000?ooo`3oool0XP3oool00`000000oooo0?ooo`0X0?ooo`00
A03oool00`000000oooo0?ooo`0i0?ooo`05003jVP3oool0oooo0?ooo`00nYX05@3oool00`00nYX0
oooo0?ooo`040?ooo`800?ZJ0P3oool00`00nYX0oooo0?ooo`090?ooo`080000003oool000000000
0000nYX000000?ooo`00nYX60?ooo`800?ZJ0P3oool00`00nYX0oooo0?ooo`1:0?ooo`040000003o
ool00000000000X0oooo00@000000?ooo`3oool0oooo1@0000030?ooo`8000009@3oool00`000000
oooo0?ooo`2Q0?ooo`800000:P3oool004@0oooo00<000000?ooo`3oool01@3oool00`00nYX0oooo
0?ooo`0`0?ooo`800?ZJ0P3oool2003jVQD0oooo00<00?ZJ0?ooo`3oool00`3oool01000nYX0oooo
003jVP3oool2003jVP/0oooo00P000000?ooo`0000000000003jVP000000oooo003jVPH0oooo0P00
nYX20?ooo`03003jVP3oool0oooo04X0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?oo
o`0T0?ooo`030000003oool0oooo0:80oooo00<000000?ooo`3oool0:03oool004@0oooo00<00000
0?ooo`3oool0103oool2003jVS80oooo0P00nYX20?ooo`800?ZJ4@3oool00`00nYX0oooo0?ooo`02
003jVPD0oooo00@00?ZJ0?ooo`00nYX0oooo0P00nYX;0?ooo`040000003oool00000003jVP800000
00<0oooo003jVP3oool01@3oool00`00nYX0003o0?ooo`020?ooo`04003jVP3oool0oooo003jVTP0
oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0T0?ooo`800000X`3oool00`000000
oooo0?ooo`0X0?ooo`00A03oool2000000D0oooo0P00nYXT0?ooo`03003jVP3oool0oooo00X0oooo
00L00?ZJ0?ooo`00nYX00000003jVP3oool00?ZJ0100oooo0P00nYX0103oool00?ZJ0?ooo`00nYX4
0?ooo`05003jVP3oool0oooo003jVP3oool00P00nYX;0?ooo`040000003oool0oooo003jVP<0003o
00<00?ZJ0?ooo`3oool0103oool00`00nYX0003o000000020?ooo`04003jVP3oool00?ZJ003jVTL0
oooo0P00000I0?ooo`8000009@3oool200000:80oooo0P00000Z0?ooo`00A03oool00`000000oooo
0?ooo`030?ooo`03003jVP3oool00?ZJ02@0oooo00D00?ZJ0?ooo`3oool0oooo003jVP020?ooo`80
0?ZJ0P3oool02@00nYX0oooo003jVP3oool00?ZJ00000000nYX0oooo003jVP0@0?ooo`800?ZJ00@0
oooo003jVP3oool00?ZJ0`3oool2003jVP80oooo0P00nYX00`3oool00?ZJ0?ooo`0:0?ooo`080000
003oool00?ZJ0?ooo`000?l000000?ooo`00nYX60?ooo`03003jVP000?l0003o0080003o00@00?ZJ
0?ooo`00nYX00?ZJB03oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo02@0oooo0`00
00020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`0000002P3oool00`000000oooo0?oo
o`2:0?ooo`030000003oool0oooo02P0oooo00140?ooo`030000003oool0oooo00<0oooo00<00?ZJ
0?ooo`00nYX08`3oool2003jVP80oooo0P00nYX20?ooo`800?ZJ0P3oool00`00nYX0oooo003jVP02
0?ooo`04003jVP000000oooo003jVQ00oooo0P00nYX0103oool00?ZJ0?ooo`00nYX20?ooo`<00?ZJ
0P3oool2003jVP030?ooo`00nYX0oooo00X0oooo00P000000?ooo`00nYX0oooo0000o`000000oooo
003jVPL0oooo00@00?ZJ000000000000003o0P00nYX00`3oool00?ZJ0?ooo`170?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool0903oool3000000030?ooo`00000000000080oooo00<0
00000?ooo`3oool0100000090?ooo`030000003oool0oooo08X0oooo00<000000?ooo`3oool0:03o
ool004@0oooo0P0000030?ooo`04003jVP3oool0oooo003jVR<0oooo0P00nYX20?ooo`800?ZJ00D0
oooo003jVP3oool00?ZJ0?ooo`03003jVP80oooo00D00000003jVP000000oooo003jVP020?ooo`03
003jVP3oool0oooo00X0oooo00@00?ZJ0?ooo`3oool00?ZJ0P3oool00`00nYX0oooo0?ooo`03003j
VP80oooo0P00nYX00`0000000?ZJ0?ooo`0:0?ooo`0800000000nYX0oooo0?ooo`000?l000000?oo
o`00nYX70?ooo`04003jVP00000000000000o`800?ZJ00<0oooo003jVP3oool0AP3oool2000001T0
oooo0P00000U0?ooo`030000003oool0000000<000000P3oool00`000000oooo0?ooo`0200000003
0?ooo`000000oooo00H0oooo0`00002;0?ooo`800000:P3oool00340oooo0`0000030?ooo`030000
003oool0oooo0080oooo0`0000050?ooo`030000003oool0oooo0080oooo00@00?ZJ0?ooo`3oool0
0?ZJ8P3oool04000nYX0oooo003jVP3oool00?ZJ0?ooo`00nYX0oooo003jVP3oool00?ZJ0?ooo`00
nYX0oooo003jVP3oool200000004003jVP000000oooo003jVP80oooo00D00?ZJ0?ooo`3oool0oooo
003jVP080?ooo`05003jVP3oool0oooo003jVP0000000P3oool2003jVP030?ooo`00nYX000000080
oooo00@00?ZJ0?ooo`0000000?ZJ2`3oool01@0000000?ZJ0?ooo`3oool00?ZJ0080oooo00<00?ZJ
0?ooo`3oool01@3oool01000nYX00000000000000?l2003jVP030?ooo`00nYX0oooo04L0oooo00<0
00000?ooo`3oool05`3oool00`000000oooo0?ooo`0C0?ooo`040000003oool00000000000`0oooo
00<000000?ooo`3oool00P0000000`3oool0000000000003000000050?ooo`000000oooo0?ooo`00
00001`3oool2000000030?ooo`000000oooo08X0oooo00<000000?ooo`3oool0:03oool00380oooo
00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3o
ool00P3oool01000nYX000000?ooo`00nYXR0?ooo`03003jVP3oool0oooo00800?ZJ00<0oooo003j
VP00nYX00P3oool01P00nYX0oooo003jVP3oool00?ZJ0?ooo`80000000D00?ZJ0?ooo`0000000?ZJ
0?ooo`02003jVP<0oooo00<00?ZJ0?ooo`3oool01P3oool01@00nYX0oooo0?ooo`00nYX000000080
oooo0P00nYX00`3oool00000000000020?ooo`040000003oool00000003jVPT0oooo00<000000?oo
o`00nYX00`3oool01000nYX0oooo0?ooo`00nYX70?ooo`05003jVP3oool000000000o`00nYX00P3o
ool00`00nYX0oooo0?ooo`160?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool04`3o
ool010000000oooo00000000000<0?ooo`060000003oool0oooo0?ooo`000000oooo1@0000000`3o
ool000000?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P0000060?oo
o`030000003oool0oooo0840oooo00<000000?ooo`3oool0:03oool002l0oooo1@0000070?ooo`05
0000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`030?ooo`030000003oool00?ZJ
0240oooo00@00?ZJ0?ooo`3oool0oooo0P00nYX00`3oool00?ZJ003jVP020?ooo`800?ZJ103oool0
1`000000oooo0000003oool00000003jVP3oool00P00nYX20?ooo`800?ZJ1`3oool01000nYX0oooo
0?ooo`3oool200000080oooo0P00nYX00`3oool00000000000020?ooo`060000003oool000000?oo
o`00nYX000001`3oool00`000000oooo003jVP020?ooo`050000o`00nYX0oooo0?ooo`00nYX01`3o
ool01@00nYX0oooo0?ooo`000?l00?ZJ0080oooo00<00?ZJ0?ooo`3oool0AP3oool00`000000oooo
0?ooo`0G0?ooo`030000003oool0oooo01<0oooo1000000<0?ooo`030000003oool0oooo00@0oooo
1@0000040?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool0oooo0P0000060?ooo`03
0000003oool0oooo0840oooo00<000000?ooo`3oool0:03oool002l0oooo00@000000?ooo`3oool0
0000203oool4000000D0oooo0P0000040?ooo`030000003oool00?ZJ00<0oooo00<00?ZJ0?ooo`3o
ool06`3oool01@00nYX0oooo0?ooo`0000000?ZJ0080oooo0P00nYX20?ooo`800?ZJ0`3oool20000
00040?ooo`000000oooo000000800?ZJ00@0oooo003jVP3oool0oooo0P00nYX70?ooo`04003jVP3o
ool0oooo0?ooo`<0000000@0oooo003jVP3oool0oooo0`000?l02@3oool00000000000000000oooo
003jVP000000oooo003jVP030?ooo`05003jVP3oool000000?ooo`00nYX00P3oool01@000?l00?ZJ
0?ooo`3oool00?ZJ00L0oooo00D00?ZJ0?ooo`3oool00000003jVP020?ooo`03003jVP3oool0oooo
04@0oooo0`0000070?ooo`800000103oool010000000oooo0?ooo`3oool5000000<0oooo0P00000C
0?ooo`<000000P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00@0oooo0P000000
0`3oool00000000000040?ooo`800000103oool010000000oooo0?ooo`3oool200000080oooo00<0
00000?ooo`3oool00P00001I0?ooo`@0003o9@3oool2000002X0oooo000`0?ooo`030000003oool0
000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`030?ooo`80000000<00?ZJ
0?ooo`3oool00P00nYXL0?ooo`0600000000nYX0oooo0?ooo`0000000?ZJ0P3oool01000nYX0oooo
0?ooo`3oool2003jVP80oooo0P0000020?ooo`<0003o0P00nYX20?ooo`800?ZJ00<0oooo003jVP3o
ool01P3oool02@00nYX0oooo0?ooo`3oool000000?ooo`000000oooo003jVP020?ooo`030000o`00
0000003o00D0003o00@00?ZJ00000000nYX00?ZJ0P3oool2003jVP040?ooo`000000oooo003jVP80
oooo00D0003o003jVP00nYX0oooo003jVP070?ooo`05003jVP3oool0oooo000000000?l00P3oool0
0`00nYX0oooo0?ooo`100?ooo`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool0103oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0
4P3oool00`000000oooo000000020?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0
103oool2000000030?ooo`000000000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`020?ooo`040000003oool0000000000080oooo0P0000020?ooo`030000003oool0oooo0440
oooo20000?l30?ooo`@0003o103oool010000?l0oooo0?ooo`000?l30?ooo`@0003o1`3oool40000
oa@0oooo00<000000?ooo`3oool0:03oool00340oooo0P0000090?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool00P3oool30000o`03003jVP3oool0oooo00800?ZJ703oool01P000000
0?ZJ0000003oool00000003jVPH0oooo00@00?ZJ0?ooo`3oool0oooo10000?l20?ooo`0300000000
nYX00?ZJ0080oooo0P00nYX00`3oool00?ZJ0?ooo`060?ooo`04003jVP3oool000000?ooo`@0003o
00P00?ZJ0000003oool0003o0000003oool000000?ooo`80000000<0003o003jVP0000000P00nYX2
0?ooo`800?ZJ0P0000001@00nYX000000?ooo`3oool0003o00800?ZJ00<0oooo003jVP3oool01`3o
ool01000nYX0oooo000000000?l20?ooo`04003jVP3oool0oooo003jVSh0oooo0P00nYX50?ooo`03
0000003oool0oooo00@0oooo00@000000?ooo`3oool000002@3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo00X0oooo5P000?l30?ooo`030000003oool0oooo00D0oooo00@000000?oo
o`3oool000001@3oool01@000000oooo0?ooo`3oool0000000D0oooo00@000000?ooo`0000000000
0P3oool200000080oooo00D000000?ooo`3oool0oooo0000000h0?ooo`@0003o0`3oool00`000?l0
oooo0?ooo`040?ooo`050000o`3oool0oooo0?ooo`000?l00`3oool40000o`<0oooo10000?l30?oo
o`030000o`3oool0oooo00D0oooo00@0003o0?ooo`3oool0003o503oool00`000000oooo0?ooo`0X
0?ooo`00<P3oool00`000000oooo0?ooo`080?ooo`8000001@3oool00`000000oooo0?ooo`020?oo
o`<0000000D00?ZJ0?ooo`00nYX0oooo003jVP0L0?ooo`0400000000nYX000000?ooo`80000000<0
oooo0000003oool01`3oool00`000?l000000?ooo`030?ooo`0300000000nYX0oooo0080oooo0P00
nYX00`3oool00?ZJ0?ooo`050?ooo`0300000000nYX0003o0080003o00@000000?ooo`3oool0003o
0P0000001P3oool0003o0000003oool000000?ooo`80000000T0003o003jVP00nYX0oooo003jVP3o
ool00?ZJ0?ooo`00nYX00P0000001`00nYX000000?ooo`3oool0003o003jVP3oool00P00nYX80?oo
o`04003jVP3oool0oooo0000o`80oooo00@00?ZJ0?ooo`3oool00?ZJ?P3oool2003jVPD0oooo00<0
00000?ooo`3oool0103oool010000000oooo0?ooo`00000:0?ooo`030000003oool0oooo0080oooo
0`0000020?ooo`P0003o203oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000D0
oooo<@000?l30?ooo`@0003o1`3oool@0000o`h0oooo20000?l30?ooo`@0003o1`3oool50000oa80
oooo20000?l30?ooo``0003o0`3oool010000?l0oooo0?ooo`3oool2000002X0oooo00140?ooo`80
0000103oool01`000000oooo003jVP3oool00?ZJ0?ooo`00nYX0703oool00`00nYX0003o0?ooo`03
000000030?ooo`000000oooo00@0oooo00D000000?ooo`000000003o000000040?ooo`0300000000
0?l0oooo0080oooo0P00nYX00`3oool00?ZJ0?ooo`020?ooo`05003jVP3oool0oooo00000000nYX0
0P0000000`3oool000000?ooo`020?ooo`050000o`0000000000003jVP3oool00P0000001000nYX0
oooo0?ooo`000?l2003jVP060?ooo`00nYX0oooo003jVP3oool00?ZJ0P0000000`00nYX0003o0000
o`020000o`04003jVP3oool00?ZJ003jVPT0oooo00<00?ZJ0?ooo`000?l00P000?l01000nYX0oooo
003jVP00nYXm0?ooo`03003jVP3oool00?ZJ00@0oooo0P0000060?ooo`040000003oool0oooo0000
00L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`000000303oool00`000000oooo0?ooo`030?ooo`030000003oool0000000L0oooo00<00000
0?ooo`3oool03`3oool200000080oooo00<000000?ooo`3oool00`3oool2000000090?ooo`000000
00000?ooo`000000oooo0000003oool0000000<0oooo0P0000020?ooo`D0003o0`3oool80000o`h0
oooo10000?l70?ooo`D0003o@P3oool40000o`D0oooo00<000000?ooo`3oool0:03oool004@0oooo
00<000000?ooo`3oool01@3oool2003jVP80oooo00<00?ZJ0?ooo`3oool06P3oool00`00nYX0003o
0000o`0:0000o`80000000<0003o003jVP0000000P3oool01000nYX0oooo000000000?l30?ooo`06
003jVP3oool0oooo0?ooo`00nYX0oooo0P00nYX20?ooo`06003jVP000?l000000?ooo`0000000?ZJ
0`3oool30000o`05003jVP3oool000000?ooo`00nYX00P3oool03@000?l00?ZJ003jVP0000000?ZJ
0?ooo`00nYX0oooo003jVP0000000?ZJ000000000?l00`3oool01000nYX0oooo0?ooo`00nYX90?oo
o`03003jVP3oool000000080oooo00@00?ZJ0?ooo`00nYX00?ZJ?@3oool00`00nYX0oooo003jVP05
0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000001`3oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool00`3oool010000000oooo00000000000;0?ooo`03
0000003oool0oooo00<0oooo0`0000070?ooo`030000003oool0oooo00l0oooo0`0000000`3oool0
00000?ooo`040?ooo`80000000<0oooo0000000000000P0000000`3oool000000?ooo`0200000080
oooo0P0000050?ooo`<00000703oool80000odl0oooo00<000000?ooo`3oool0:03oool004@0oooo
00<000000?ooo`3oool00P3oool00`00nYX0oooo0?ooo`02003jVP80oooo00<00?ZJ0?ooo`3oool0
6P3oool00`00nYX0003o0?ooo`03000000030?ooo`000000000000<0000010000?l02@00nYX00000
0?ooo`3oool00?ZJ0?ooo`000000003o000000060?ooo`06003jVP3oool00?ZJ003jVP3oool00000
0P00nYX010000000oooo00000000nYX50?ooo`0500000000nYX00?ZJ0000003oool00P00nYX01@3o
ool0003o003jVP3oool0000000800?ZJ00L000000?ooo`00nYX00000003jVP000000003o00<0oooo
00<00?ZJ0?ooo`3oool02`3oool01000nYX000000?ooo`3oool2003jVP030?ooo`00nYX0oooo03H0
oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX0oooo003jVP050?ooo`030000003oool0oooo00D0
oooo0P0000090?ooo`<00000103oool2000000D0oooo0`00000;0?ooo`030000003oool0oooo00<0
oooo100000030?ooo`040000003oool0oooo00000140oooo00D000000?ooo`000000oooo00000006
0?ooo`050000003oool0oooo0?ooo`0000000P3oool400000080oooo0P0000030?ooo`030000003o
ool0000000800000LP3oool2000002X0oooo00140?ooo`8000000`3oool01000nYX0oooo0?ooo`00
nYX30?ooo`04003jVP3oool0oooo003jVQP0oooo00<00?ZJ0?ooo`000?l00`3oool01`000000oooo
0000003oool000000?ooo`0000000P3oool200000005003jVP3oool0oooo0?ooo`00nYX00P3oool4
0000o`@0oooo0P00nYX02P3oool00?ZJ0?ooo`00nYX00000003jVP000000oooo00000000nYX50?oo
o`0500000000nYX00?ZJ0000003oool00P00nYX01@3oool00000003jVP3oool0000000800?ZJ0P00
0002003jVP030?ooo`0000000?ZJ0080oooo00<00?ZJ0?ooo`3oool03@3oool00`00nYX0oooo0?oo
o`02003jVP030?ooo`00nYX0oooo03D0oooo0P00nYX20?ooo`0300000000nYX00?ZJ0080oooo00<0
0?ZJ0?ooo`3oool00P3oool2000001T0oooo00<000000?ooo`3oool0103oool3000000X0oooo00<0
00000?ooo`3oool01@3oool3000000<0oooo00@000000?ooo`00000000004`3oool00`000000oooo
000000060?ooo`030000003oool0oooo00D0oooo0`000000103oool000000?ooo`0000030?ooo`D0
0000L`3oool00`000000oooo0?ooo`0X0?ooo`00A03oool00`000000oooo0?ooo`020?ooo`04003j
VP3oool0oooo0000o`80oooo00<00000003jVP3oool00P00nYXH0?ooo`03003jVP3oool00?ZJ00<0
oooo00@000000?ooo`0000000?ZJ1P3oool00`0000000?ZJ0?ooo`020?ooo`800?ZJ00D0oooo0000
0000000000000?ooo`030000o`080?ooo`00nYX00?ZJ0?ooo`00nYX0oooo003jVP3oool2003jVP03
0?ooo`0000000?ZJ00H0oooo0P00nYX02`000000oooo003jVP00nYX0oooo00000000nYX0oooo0000
0000nYX0oooo008000000P00nYX20?ooo`04003jVP3oool0oooo003jVPl0oooo00<00?ZJ0?ooo`3o
ool00P00nYX00`3oool00?ZJ0?ooo`060?ooo`03003jVP3oool0oooo02`0oooo0P00nYX20?ooo`<0
0?ZJ0P3oool00`00nYX0oooo0?ooo`030?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0103oool3000000X0oooo00<000000?ooo`3oool01`3oool01P000000oooo0?ooo`3oool00000
0?ooo`800000503oool00`000000oooo0?ooo`0=0?ooo`070000003oool000000?ooo`000000oooo
000000030?ooo`D00000L`3oool00`000000oooo0?ooo`0X0?ooo`00A03oool00`000000oooo0?oo
o`030?ooo`03003jVP3oool0003o0080oooo00<00000003jVP3oool00P00nYX30?ooo`03003jVP3o
ool0oooo0140oooo00@00?ZJ0000003oool00?ZJ0`3oool01000nYX0oooo00000000nYX30?ooo`04
003jVP3oool0oooo0?ooo`800?ZJ0P3oool2003jVP80oooo100000020?ooo`080000o`00nYX00?ZJ
00000000nYX0oooo003jVP3oool2003jVP80oooo0P00nYX20?ooo`0=003jVP3oool0oooo003jVP3o
ool00?ZJ0?ooo`00nYX0oooo003jVP000000003o0?ooo`02000000030?ooo`000000000000800?ZJ
0P3oool01000nYX0oooo0?ooo`00nYX?0?ooo`03003jVP3oool0oooo00800?ZJ00<0oooo003jVP3o
ool01@3oool2003jVQh0oooo00<000000?ooo`3oool03@3oool2003jVP80oooo00<00?ZJ0?ooo`00
nYX00P3oool00`00nYX0oooo0?ooo`030?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0103oool3000000X0oooo00<000000?ooo`3oool01`3oool00`000000oooo00000005000001@0
oooo00<000000?ooo`3oool03`3oool01@000000oooo0000003oool000000080oooo00<000000?oo
o`3oool00`00001c0?ooo`030000003oool0oooo02P0oooo00140?ooo`030000003oool0oooo00<0
oooo00<00?ZJ0?ooo`000?l00P3oool00`0000000?ZJ0?ooo`02003jVP80oooo0P00nYXB0?ooo`80
0?ZJ00<000000?ooo`00nYX00`3oool00`00nYX0000000000002003jVP80oooo00@00?ZJ0?ooo`3o
ool0oooo0P00nYX01P3oool00?ZJ0?ooo`00nYX0oooo003jVP@000000P3oool010000?l00?ZJ0?oo
o`000002003jVP040000003oool00?ZJ003jVP80oooo0P00nYX20?ooo`0=003jVP3oool0oooo003j
VP3oool00?ZJ0?ooo`00nYX0oooo003jVP000000003o0?ooo`05000000800?ZJ00<0oooo0000o`00
nYX00P3oool00`00nYX0oooo0?ooo`0=0?ooo`04003jVP3oool0oooo003jVP80oooo00<00?ZJ0?oo
o`3oool0103oool2003jVQh0oooo00<000000?ooo`3oool0303oool01P00nYX0oooo003jVP3oool0
0?ZJ000000@0oooo00<00?ZJ0?ooo`3oool00`3oool00`000000oooo0?ooo`0G0?ooo`8000001@3o
ool00`000000oooo0000000:0?ooo`030000003oool0oooo00L0oooo00D000000?ooo`0000000000
0?ooo`03000002H0oooo0P0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`00
0000LP3oool2000002X0oooo00140?ooo`8000001@3oool00`00nYX0003o0000o`020000o`800?ZJ
00H0oooo003jVP3oool00?ZJ0?ooo`00nYX>0?ooo`03003jVP3oool0oooo00<00?ZJ00<000000000
o`00nYX00`3oool00`00nYX0000000000002003jVP80oooo0P00nYX20?ooo`04003jVP3oool00?ZJ
003jVP80oooo0P00nYX02P3oool00000000000000000oooo000000000?l00?ZJ0?ooo`000002003j
VP060000003oool00?ZJ003jVP3oool00?ZJ0P3oool00`00nYX0oooo003jVP020?ooo`03003jVP3o
ool0oooo00800?ZJ00D0oooo003jVP000000003o0?ooo`0500000004003jVP000000oooo0000o`80
0?ZJ00<0oooo003jVP3oool03P3oool0100000000?ZJ0?ooo`000?l20?ooo`03003jVP3oool0oooo
00<0oooo00<00?ZJ0?ooo`00nYX07P3oool00`000000oooo0?ooo`030?ooo`03003jVP3oool0oooo
00H0oooo00<00?ZJ0?ooo`3oool00P00nYX2000000<0oooo00<00?ZJ0?ooo`3oool00P3oool20000
01T0oooo00<000000?ooo`3oool0103oool00`000000oooo0000000:0?ooo`030000003oool0oooo
00L0oooo10000000103oool000000?ooo`00000[0?ooo`<000001@3oool00`000000oooo0?ooo`1`
0?ooo`030000003oool0oooo02P0oooo00140?ooo`030000003oool0oooo00@0oooo00<00?ZJ0000
003oool00P000002003jVP80oooo0P00nYX00`3oool00?ZJ0?ooo`0<0?ooo`800?ZJ00<0oooo003j
VP3oool00P00nYX010000000003o003jVP00nYX20?ooo`800?ZJ00<00000003jVP00nYX00P3oool2
003jVP040?ooo`00nYX0oooo0?ooo`800?ZJ0P3oool3003jVP80000000T00?ZJ0?ooo`000000003o
003jVP3oool00000003jVP0000000P3oool01000nYX0oooo003jVP00nYX30?ooo`800?ZJ0P3oool0
1@00nYX0oooo0?ooo`3oool00?ZJ0080oooo00<00?ZJ0000o`000?l01P000?l01@000000oooo0000
o`00nYX0oooo00800?ZJ3`3oool0100000000?ZJ0?ooo`000?l20?ooo`03003jVP3oool0oooo00<0
oooo00<00?ZJ0?ooo`00nYX07P3oool300000080oooo0P00nYX80?ooo`03003jVP3oool0oooo0080
0?ZJ0`0000020?ooo`03003jVP3oool0oooo00<0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool01`3oool3000000@0
oooo00<000000?ooo`3oool0:@3oool3000000D0oooo00<000000?ooo`3oool0L03oool00`000000
oooo0?ooo`0X0?ooo`00A03oool00`000000oooo0?ooo`050?ooo`04003jVP000000000000000080
0?ZJ0P3oool2003jVP030?ooo`00nYX0oooo00`0oooo0P00nYX02@3oool00?ZJ0?ooo`00nYX0oooo
000000000?l00?ZJ0?ooo`02003jVP070?ooo`00nYX00000003jVP3oool00?ZJ0?ooo`02003jVP03
0?ooo`00nYX0oooo0080oooo00@00?ZJ0?ooo`3oool0oooo0P00nYX200000007003jVP0000000000
000000000?l000000?ooo`0200000080oooo00@00?ZJ0?ooo`00nYX00?ZJ0`3oool01@00nYX0oooo
003jVP3oool00?ZJ00H0oooo00<00?ZJ0000003oool00`3oool00`000000oooo0000o`020?ooo`03
0000o`00nYX0oooo00800?ZJ3`3oool00`0000000?ZJ000000030000o`03003jVP3oool0oooo00<0
oooo00<00?ZJ0?ooo`00nYX02P3oool00`00nYX0oooo0?ooo`0A0?ooo`80000000<00?ZJ0?ooo`3o
ool00P00nYX70?ooo`05003jVP3oool0oooo0?ooo`00nYX00`0000030000o`03003jVP3oool0oooo
00<0oooo00<000000?ooo`3oool05`3oool2000000P0oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`070?ooo`800000<@3oool3000000D0oooo00<000000?ooo`3oool0K`3oool20000
02X0oooo00140?ooo`8000001P3oool01@00nYX000000000003oool00?ZJ00<0oooo00@00?ZJ0?oo
o`3oool00?ZJ303oool01@00nYX0oooo003jVP3oool00?ZJ00<0oooo00@000000000o`00nYX0oooo
0P00nYX0103oool00?ZJ0?ooo`00nYX20?ooo`800?ZJ00<0oooo003jVP00nYX0203oool00`00nYX0
000000000002003jVP80000000<0003o0?ooo`3oool00P0000020?ooo`04003jVP3oool0oooo003j
VPD0oooo00<00?ZJ0?ooo`00nYX01P3oool00`00nYX0oooo0?ooo`050?ooo`050000o`3oool0oooo
0000o`00nYX00P3oool00`00nYX0oooo0?ooo`0=0?ooo`040000003oool00?ZJ00000080oooo00<0
0?ZJ0?ooo`3oool00P3oool01000nYX0oooo0?ooo`00nYX:0?ooo`03003jVP3oool0oooo0140oooo
0P0000000`00nYX0oooo0?ooo`02003jVPL0oooo00D00?ZJ0?ooo`3oool00000003jVP0200000005
0?ooo`000?l0oooo0?ooo`00nYX0103oool2000001T0oooo00<000000?ooo`3oool01`3oool20000
00P0oooo00<000000?ooo`3oool01`3oool2000003<0oooo00<000000?ooo`3oool00`3oool20000
0740oooo00<000000?ooo`3oool0:03oool004@0oooo00<000000?ooo`3oool01@3oool01@00nYX0
00000000003oool0003o00<0oooo00@00?ZJ0?ooo`3oool00?ZJ303oool01P00nYX0oooo003jVP00
nYX0oooo00000080oooo00<000000000o`00nYX00P3oool00`00nYX0oooo0?ooo`02003jVP80oooo
0P00nYX00`3oool00?ZJ003jVP090?ooo`07003jVP0000000?ZJ003jVP3oool000000000o`020?oo
o`@0003o00@00?ZJ0?ooo`3oool00?ZJ1P3oool2003jVPL0oooo00@00?ZJ0?ooo`3oool00?ZJ0`3o
ool40000o`04003jVP3oool0oooo003jVPl0oooo00L000000?ooo`00nYX0oooo0000003oool00?ZJ
00@0oooo00@00?ZJ0?ooo`3oool00?ZJ2@3oool2003jVQ<0oooo00L00000003jVP00nYX0oooo003j
VP3oool00?ZJ00L0oooo00D00?ZJ0?ooo`3oool00000003jVP02000000050?ooo`000?l0oooo0?oo
o`00nYX01@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00L0oooo0P0000080?oo
o`030000003oool0oooo00L0oooo0P00000c0?ooo`030000003oool0oooo00<0oooo0P00001a0?oo
o`030000003oool0oooo02P0oooo000[0?ooo`<000000`3oool00`000000oooo0?ooo`020?ooo`<0
00000`3oool3000000D0oooo00<000000?ooo`3oool01P3oool01000nYX000000?ooo`000?l30?oo
o`04003jVP000000oooo003jVP/0oooo00<00?ZJ0?ooo`3oool00P00nYX00`3oool000000000o`03
0000o`04003jVP3oool0oooo003jVP80oooo0P00nYX30?ooo`04003jVP3oool0oooo003jVPT0oooo
0P00nYX00`3oool00?ZJ0?ooo`02000000<0003o0P3oool00`000?l00?ZJ0?ooo`080?ooo`800?ZJ
1`3oool01000nYX0oooo0?ooo`00nYX70?ooo`03003jVP3oool0oooo0100oooo00L000000?ooo`00
00000?ZJ0000003oool00?ZJ00@0oooo00@00?ZJ0?ooo`3oool00?ZJ203oool00`00nYX0oooo003j
VP0C0?ooo`0400000000nYX00?ZJ003jVP80oooo00<00?ZJ0?ooo`3oool01@3oool00`00nYX0oooo
00000004000000040?ooo`00nYX0oooo0?ooo`800?ZJ103oool00`000000oooo0?ooo`0G0?ooo`80
00002@3oool00`000000oooo0?ooo`040?ooo`8000002P3oool00`000000oooo0?ooo`0h0?ooo`80
0000L03oool2000002X0oooo000/0?ooo`030000003oool0oooo00H0oooo00L000000?ooo`3oool0
oooo0000003oool0000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`060?oo
o`03003jVP000000oooo0080003o00H000000?ooo`00000000000?ooo`00nYX;0?ooo`05003jVP3o
ool00000003jVP3oool00P0000001@000?l000000?ooo`3oool00?ZJ00H0oooo00<00?ZJ0?ooo`3o
ool0103oool00`00nYX0oooo0?ooo`070?ooo`800?ZJ00@0oooo00000000nYX000001`3oool00`00
nYX0oooo0?ooo`080?ooo`03003jVP3oool0oooo00D0oooo00<00?ZJ0?ooo`3oool00P00nYX50?oo
o`03003jVP3oool0oooo0140oooo00L000000?ooo`0000000?ZJ0000003oool00?ZJ00@0oooo00@0
0?ZJ0?ooo`3oool00?ZJ203oool00`00nYX0oooo003jVP0C0?ooo`04003jVP0000000000003jVP80
oooo00<00?ZJ0?ooo`3oool01@3oool01000nYX0003o0000o`000?l3000000040000o`00nYX0oooo
0?ooo`800?ZJ103oool010000000oooo0000000000040?ooo`040000003oool0oooo0?ooo`D00000
0P3oool3000000@0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`040?ooo`800000
A@3oool200000740oooo00<000000?ooo`3oool0:03oool002T0oooo1@0000070?ooo`050000003o
ool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`020?ooo`800000203oool01000nYX0oooo
0000003oool20000o`8000000P3oool01000nYX0oooo003jVP00nYX70?ooo`03003jVP3oool00000
0080oooo0P0000001@000?l0oooo0?ooo`3oool00?ZJ01L0oooo00D00000003jVP3oool0oooo003j
VP080?ooo`03003jVP3oool0oooo0100oooo00<00?ZJ0?ooo`3oool00P00nYX20?ooo`04003jVP3o
ool0oooo003jVQ<0oooo00P000000?ooo`0000000?ZJ0000003oool0003o003jVP<0oooo00@00?ZJ
0?ooo`3oool00?ZJ203oool00`00nYX0oooo003jVP0C0?ooo`04003jVP0000000000003jVP80oooo
00<00?ZJ0?ooo`3oool01@3oool02@00nYX0oooo000000000?l000000?ooo`000000003o003jVP02
0?ooo`04003jVP3oool0oooo0?ooo`@000000P3oool00`000000oooo0?ooo`060?ooo`060000003o
ool0oooo0000003oool000000`3oool01@000000oooo0?ooo`3oool0000000X0oooo00<000000?oo
o`3oool00`3oool00`000000oooo000000150?ooo`800000L@3oool00`000000oooo0?ooo`0X0?oo
o`00:@3oool010000000oooo0?ooo`0000080?ooo`@000001P3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00L0oooo00H00?ZJ0?ooo`000000oooo000000000?l3000000030?ooo`00
nYX0oooo00800?ZJ1`3oool00`00nYX0oooo00000003000000050?ooo`000?l0oooo0?ooo`00nYX0
6@3oool01000nYX0oooo0?ooo`3oool2003jVP80oooo00D00?ZJ0?ooo`3oool0oooo003jVP0C0?oo
o`07003jVP3oool00?ZJ0?ooo`00nYX0oooo003jVP020?ooo`03003jVP3oool0oooo0140oooo00P0
00000?ooo`000000oooo003jVP3oool0003o003jVP<0oooo00@00?ZJ0?ooo`3oool00?ZJ1`3oool0
1000nYX0oooo0?ooo`00nYXC0?ooo`04003jVP0000000000003jVP80oooo00<00?ZJ0?ooo`3oool0
103oool01@00nYX0003o0?ooo`000000oooo00@0003o00@00?ZJ0?ooo`3oool0003o1@3oool20000
0080oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`050?ooo`050000003oool0oooo
0?ooo`0000002`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo04H0oooo00<00000
0?ooo`3oool0K`3oool00`000000oooo0?ooo`0X0?ooo`00:P3oool00`000000oooo000000080?oo
o`030000003oool0oooo00<0oooo100000050?ooo`030000003oool0oooo00P0oooo00D00?ZJ0000
003oool000000?ooo`040000o`800?ZJ00<0oooo003jVP3oool01P3oool02000nYX0oooo00000000
0000oooo0000003oool00?ZJ0P3oool00`00nYX0oooo0?ooo`0K0?ooo`800?ZJ0P3oool01@00nYX0
oooo0?ooo`3oool00?ZJ01<0oooo00H00?ZJ0?ooo`00nYX0oooo003jVP3oool2003jVP030?ooo`00
nYX0oooo0180oooo00P000000?ooo`000000oooo003jVP3oool0003o003jVP<0oooo00@00?ZJ0000
o`000?l00?ZJ1`3oool01000nYX0oooo0?ooo`00nYXC0?ooo`04003jVP000000oooo00000080oooo
00<00?ZJ0?ooo`3oool0103oool01000nYX0003o0000000000030?ooo`070000003oool00?ZJ003j
VP3oool0003o000000040?ooo`8000000P3oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00@0oooo00@000000?ooo`3oool0oooo0`0000090?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0AP3oool00`000000oooo0?ooo`1^0?ooo`800000:P3oool002/0oooo0P000009
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`08
0?ooo`800?ZJ0P0000001@3oool000000?ooo`000000003o00800?ZJ00<0oooo003jVP3oool01@3o
ool01000nYX000000?ooo`0000040000o`04003jVP3oool0oooo003jVQh0oooo00<00?ZJ0?ooo`3o
ool00P00nYX20?ooo`03003jVP3oool0oooo0140oooo00H00?ZJ0?ooo`00nYX0oooo003jVP3oool2
003jVP030?ooo`00nYX0oooo0180oooo0`0000002@3oool00?ZJ0?ooo`000?l00?ZJ0?ooo`000000
0?ZJ0000o`020?ooo`03003jVP3oool0oooo00D0oooo00@00?ZJ0?ooo`3oool00?ZJ4P3oool01@00
nYX000000000003oool000000080oooo00<00?ZJ0?ooo`3oool00`3oool00`00nYX00000003jVP02
000000<0oooo00D000000?ooo`00nYX00?ZJ000000020000o`@0oooo0P0000020?ooo`030000003o
ool0oooo00D0oooo00H000000?ooo`3oool0oooo0000003oool4000000@0oooo00<000000?ooo`3o
ool02@3oool01@000000oooo0?ooo`3oool0000004T0oooo00<000000?ooo`3oool0K`3oool00`00
0000oooo0?ooo`0X0?ooo`00;03oool00`000000oooo0?ooo`080?ooo`8000000P3oool5000000@0
oooo0P00000:0?ooo`04003jVP0000000000000000<0oooo00D0003o003jVP00nYX0oooo003jVP02
0?ooo`800?ZJ0P3oool00`00nYX0003o0000o`020000o`<0oooo0P00nYX00`3oool00?ZJ0?ooo`0M
0?ooo`03003jVP3oool0oooo00800?ZJ0P3oool00`00nYX0oooo0?ooo`0B0?ooo`800?ZJ0P3oool3
003jVP030?ooo`00nYX0oooo0180oooo0`0000020?ooo`07003jVP000?l00?ZJ0?ooo`0000000?ZJ
0000o`020?ooo`03003jVP3oool0oooo00D0oooo00@00?ZJ0?ooo`3oool00?ZJ4P3oool01000nYX0
00000000003oool30000o`03003jVP3oool0oooo0080oooo00@00?ZJ0?ooo`0000000?ZJ0P000000
1@3oool00?ZJ0?ooo`000000oooo00800?ZJ0P0000040?ooo`<000000P3oool00`000000oooo0?oo
o`050?ooo`070000003oool0oooo0?ooo`000000oooo000000070?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool00P0000190?ooo`030000003oool0oooo06l0oooo00<000000?ooo`3o
ool0:03oool004@0oooo00<000000?ooo`3oool02P3oool01000nYX0000000000000nYX20?ooo`09
0000o`00nYX0oooo0?ooo`00nYX0oooo003jVP3oool00?ZJ0080oooo00@00?ZJ0000o`3oool00000
103oool2003jVP030?ooo`00nYX0oooo01h0oooo00L00?ZJ0?ooo`00nYX0oooo003jVP3oool00?ZJ
01@0oooo0P00nYX20?ooo`800?ZJ00<0oooo003jVP00nYX0503oool200000080oooo00D00?ZJ0000
o`00nYX0oooo00000002003jVP80oooo00<00?ZJ0?ooo`3oool01@3oool01000nYX0oooo0?ooo`00
nYXB0?ooo`05003jVP3oool000000?ooo`000?l00P3oool00`00nYX0oooo0?ooo`020?ooo`03003j
VP3oool0000000800?ZJ00<000000?ooo`00nYX00`3oool00`00nYX00000003jVP060?ooo`040000
003oool00000000000T0oooo0`0000020?ooo`D000000`3oool2000000X0oooo00<000000?ooo`3o
ool00P00001:0?ooo`030000003oool0oooo06d0oooo0P00000Z0?ooo`00A03oool00`000000oooo
0?ooo`0:0?ooo`04003jVP0000000000003jVP80oooo00T0003o003jVP3oool0oooo003jVP3oool0
0?ZJ0?ooo`00nYX00P3oool01@00nYX0003o0?ooo`0000000?ZJ00<0oooo0P00nYX00`3oool00?ZJ
0?ooo`0N0?ooo`07003jVP3oool00?ZJ0?ooo`00nYX0oooo003jVP0E0?ooo`06003jVP3oool0oooo
0?ooo`00nYX0oooo0P00nYXD0?ooo`8000000P3oool01@0000000?ZJ003jVP3oool0000000800?ZJ
0P3oool00`00nYX0oooo0?ooo`050?ooo`04003jVP000?l0oooo003jVQ80oooo00D00?ZJ0?ooo`00
0000003o000000020?ooo`03003jVP3oool0oooo0080oooo00<00?ZJ0000003oool00P00nYX00`00
0000oooo003jVP020?ooo`04003jVP3oool00000003jVPH0oooo00<000000?ooo`3oool05`3oool0
0`000000oooo0?ooo`090?ooo`040000003oool00000000004/0oooo00<000000?ooo`3oool0J@3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo02P0oooo00140?ooo`8000002`3oool0
1000nYX0oooo00000000nYX20?ooo`0400000000nYX0oooo0?ooo`800?ZJ00L000000?ooo`00nYX0
oooo003jVP0000000?ZJ0080000000H00?ZJ0?ooo`3oool0oooo003jVP3oool2003jVR00oooo0P00
nYX20?ooo`800?ZJ703oool00`00nYX0oooo0?ooo`0B0?ooo`8000000P3oool01@0000000?ZJ003j
VP3oool0000000800?ZJ0P3oool00`00nYX0oooo0?ooo`050?ooo`04003jVP000?l0003o003jVP`0
oooo00<000000?ooo`00nYX00`3oool01@00nYX0003o0000o`000?l000000080oooo00<00?ZJ0?oo
o`3oool00P3oool00`00nYX000000?ooo`02003jVP030000003oool00?ZJ0080oooo00D00?ZJ0?oo
o`0000000000003jVP040?ooo`8000006@3oool00`000000oooo0?ooo`090?ooo`040000003oool0
0000000004/0oooo00<000000?ooo`3oool0J@3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo02P0oooo00140?ooo`030000003oool0oooo00X0oooo00@00000003jVP0000000?ZJ0P3o
ool010000000003o0?ooo`3oool2003jVP80000000D00?ZJ0?ooo`00nYX00000003jVP0200000080
0?ZJ0P3oool01000nYX0oooo003jVP00nYXP0?ooo`800?ZJ0P3oool2003jVQ`0oooo00<00?ZJ0?oo
o`3oool04P3oool200000080oooo00D00000003jVP00nYX0oooo00000002003jVP80oooo00<00?ZJ
0?ooo`3oool01@3oool01000nYX0oooo0?ooo`00nYX<0?ooo`0300000000nYX00?ZJ00<0oooo00D0
0?ZJ0?ooo`3oool0oooo003jVP020?ooo`05003jVP3oool0oooo0?ooo`00nYX00P0000000`3oool0
0?ZJ0?ooo`02003jVP050?ooo`00nYX0oooo003jVP3oool00P0000000`00nYX0oooo0?ooo`030?oo
o`030000003oool0oooo01L0oooo0P00000:0?ooo`040000003oool00000000004/0oooo00<00000
0?ooo`3oool0J@3oool010000000oooo0?ooo`3oool2000002X0oooo00140?ooo`030000003oool0
oooo00/0oooo0P00nYX01`3oool00?ZJ0?ooo`000000003o0000003oool00P00nYX2000000800?ZJ
0P0000000`00nYX0000000000002003jVP80oooo00@00?ZJ0?ooo`3oool00?ZJ8@3oool01@00nYX0
oooo0?ooo`3oool00?ZJ0340oooo00D000000?ooo`3oool0oooo00000002003jVP030?ooo`00nYX0
oooo00800?ZJ00<0oooo003jVP3oool01P3oool01000nYX0oooo0?ooo`00nYX<0?ooo`0300000000
nYX00?ZJ00<0oooo00D00?ZJ0?ooo`3oool0oooo003jVP020?ooo`06003jVP3oool0oooo0?ooo`00
nYX000000P3oool02@00nYX0oooo003jVP00nYX0oooo003jVP3oool00?ZJ0?ooo`02000000030?oo
o`00nYX0oooo00<0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`090?ooo`040000
003oool00000000004/0oooo00<000000?ooo`000000J03oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo02P0oooo00140?ooo`030000003oool0oooo00`0oooo00D00?ZJ0?ooo`00nYX0
oooo000000030000o`800?ZJ0P000002003jVP80000000P00?ZJ0000003oool00?ZJ0?ooo`00nYX0
oooo003jVP80oooo00<00?ZJ0?ooo`3oool0E@3oool01@000000oooo0?ooo`3oool0000000800?ZJ
00<0oooo003jVP3oool00P00nYX00`3oool00?ZJ0?ooo`050?ooo`0600000000nYX0oooo0?ooo`00
0?l00?ZJ2`3oool00`00nYX00000003jVP030?ooo`05003jVP3oool0oooo0?ooo`00nYX00P3oool0
1P00nYX0oooo0?ooo`3oool00?ZJ00000080oooo00P00?ZJ0?ooo`3oool00?ZJ0?ooo`00nYX0oooo
003jVP80oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0G0?ooo`030000003oool0
oooo00T0oooo0P00001=0?ooo`030000003oool0000006P0oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`0X0?ooo`00A03oool2000000d0oooo00@00?ZJ0?ooo`3oool00?ZJ0`000000
0`000?l00?ZJ00000002000000800?ZJ00X0oooo0000o`00nYX00?ZJ0?ooo`00nYX0oooo003jVP3o
ool00?ZJFP3oool01@000000oooo0?ooo`3oool0000000<00?ZJ00@000000000o`00nYX0oooo0P00
nYX60?ooo`0600000000nYX0oooo0?ooo`000?l00?ZJ2`3oool00`00nYX00000003jVP030?ooo`05
003jVP3oool0oooo0?ooo`00nYX00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ00<0003o00@00?ZJ
0?ooo`3oool00?ZJ0P3oool2003jVP80oooo00<000000?ooo`3oool00`3oool2000001T0oooo00<0
00000?ooo`3oool02@3oool2000004d0oooo0`00000:0?ooo`040000003oool0oooo000005X0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0X0?ooo`00A03oool00`000000oooo0?oo
o`0@0?ooo`0<003jVP00000000000?ooo`000?l000000?ooo`0000000?ZJ0000003oool0003o0P00
nYX0103oool00?ZJ0?ooo`3oool2003jVUX0oooo00D000000?ooo`3oool0oooo00000003003jVP04
000000000?l00?ZJ0?ooo`800?ZJ1P3oool01P0000000?ZJ0?ooo`3oool0003o003jVPX0oooo00@0
0000003jVP0000000?ZJ0`3oool2003jVP80oooo0P00nYX00`3oool0003o003jVP020?ooo`05003j
VP3oool0oooo0000o`00nYX01@3oool2003jVPT0oooo00<000000?ooo`3oool05`3oool2000000X0
oooo0P00001>0?ooo`8000002P3oool010000000oooo0?ooo`00001J0?ooo`030000003oool0oooo
0080oooo0P00000Z0?ooo`00A03oool00`000000oooo0?ooo`0@0?ooo`05003jVP00000000000000
00000?l00`3oool2000000040?ooo`000?l00?ZJ000000800?ZJ0P3oool2003jVUX0oooo00D00000
0?ooo`3oool0oooo00000003003jVP03000000000?l00?ZJ0080oooo00<00?ZJ0?ooo`3oool0103o
ool01P0000000?ZJ0000003oool0003o003jVPH0oooo00P00?ZJ0?ooo`3oool0oooo003jVP3oool0
0000003jVP<0oooo0P00nYX20?ooo`05003jVP3oool00?ZJ0000o`00nYX00P3oool01@00nYX0oooo
0?ooo`3oool00?ZJ00H0oooo00<00?ZJ0?ooo`3oool01`3oool00`000000oooo0?ooo`0G0?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`080?ooo`80
000000<0oooo0000003oool0F@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo02P0
oooo00140?ooo`030000003oool0oooo0100oooo00@00000003jVP00000000000`000?l01`3oool0
00000?ooo`3oool0003o003jVP3oool00P00nYX30?ooo`03003jVP3oool0oooo05`0oooo00L00000
003jVP00nYX00?ZJ000000000?l00?ZJ0080oooo00<00?ZJ0?ooo`3oool0103oool3003jVP030?oo
o`000?l00?ZJ00D0oooo0P00nYX30?ooo`04003jVP3oool00000003jVP<0oooo0P00nYX01`3oool0
0?ZJ0000003oool00?ZJ0000o`00nYX00P3oool01@00nYX0oooo0?ooo`3oool00?ZJ0100oooo00<0
00000?ooo`3oool05`3oool00`000000oooo0?ooo`1K0?ooo`030000003oool0oooo00L0oooo0P00
00000`3oool000000?ooo`1H0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0:03o
ool004@0oooo0P00000A0?ooo`0300000000nYX00000008000000P3oool20000o`80oooo00D0003o
003jVP3oool0oooo003jVP1S0?ooo`0900000000nYX0oooo000000000?l00?ZJ0000003oool00?ZJ
00H0oooo0`00nYX00`3oool0003o003jVP040?ooo`03003jVP3oool00?ZJ00<0oooo00@00?ZJ0?oo
o`0000000?ZJ0P3oool00`0000000?ZJ0?ooo`02003jVP030000003oool0oooo00800?ZJ00<00000
0?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`0=0?ooo`8000006@3oool2000005`0oooo00<00000
0?ooo`3oool01@3oool01P000000oooo000000000000oooo000005T0oooo00<000000?ooo`3oool0
0`3oool2000002X0oooo000a0?ooo`<000000`3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0403oool0100000000?ZJ0?ooo`0000040?ooo`@0003o
00<00?ZJ0?ooo`3oool0I03oool02@0000000?ZJ0000003oool0003o003jVP000000oooo003jVP06
0?ooo`800?ZJ00@00000003jVP000?l00?ZJ0P3oool01@00nYX0oooo003jVP3oool00?ZJ00<0oooo
00@00?ZJ0?ooo`0000000?ZJ0P3oool00`0000000?ZJ0?ooo`02003jVP030000003oool0oooo0080
0?ZJ00<000000?ooo`00nYX00`3oool00`00nYX0oooo0?ooo`0>0?ooo`030000003oool0oooo00D0
oooo0P0000040?ooo`030000003oool0oooo0080oooo0`0000040?ooo`030000003oool0oooo05/0
oooo00<000000?ooo`3oool01@3oool2000000040?ooo`0000000000000005T0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`0X0?ooo`00<P3oool00`000000oooo0?ooo`080?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0403oool010000000oooo003jVP0000080?oo
o`03003jVP3oool0oooo06@0oooo00T00000003jVP000000oooo0000o`00nYX000000?ooo`00nYX0
1P3oool2003jVP050000003oool00?ZJ003jVP3oool00`00nYX20?ooo`08003jVP3oool0oooo0?oo
o`00nYX0oooo00000000nYX20?ooo`0600000000nYX0oooo0?ooo`00nYX000000P3oool2003jVP04
0000003oool00?ZJ003jVP80oooo00<00?ZJ0?ooo`3oool03P3oool00`000000oooo0?ooo`040?oo
o`040000003oool0oooo000000L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003o
ool0oooo05/0oooo00<000000?ooo`3oool01@3oool2000000040?ooo`0000000000000005P0oooo
0P0000060?ooo`030000003oool0oooo02P0oooo000_0?ooo`D000002P3oool00`000000oooo0?oo
o`030?ooo`8000004@3oool01@000000oooo003jVP3oool00?ZJ00H0oooo00<00?ZJ0?ooo`3oool0
I@3oool02@0000000?ZJ0000o`000?l00?ZJ0?ooo`000000oooo003jVP060?ooo`800?ZJ00D00000
0?ooo`00nYX00?ZJ0?ooo`03003jVP80oooo00`00?ZJ0?ooo`3oool0oooo003jVP3oool000000?oo
o`00nYX0oooo00000000nYX20?ooo`04003jVP000000oooo0?ooo`800?ZJ0P000002003jVP80oooo
00<00?ZJ0?ooo`3oool0303oool3000000H0oooo00@000000?ooo`3oool000002`3oool010000000
oooo0?ooo`3oool300000080oooo00<00?ZJ0?ooo`3oool0E`3oool00`000000oooo0?ooo`040?oo
o`80000000D0oooo000000000000oooo0000001G0?ooo`8000001@3oool2000002X0oooo000_0?oo
o`040000003oool0oooo000000/0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0@
0?ooo`050000003oool00?ZJ0?ooo`00nYX00`3oool01000nYX0oooo0?ooo`00nYYW0?ooo`090000
0000nYX000000000o`00nYX0oooo0000003oool00?ZJ00H0oooo0P00nYX00`000000oooo003jVP02
003jVP030?ooo`00nYX00?ZJ0080oooo00D00?ZJ0?ooo`3oool0oooo003jVP030000o`04003jVP3o
ool00000003jVP<0oooo00<000000?ooo`3oool00P00nYX2000000800?ZJ0P3oool00`00nYX0oooo
0?ooo`0>0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000002@3oool2000000@0
oooo00<000000?ooo`3oool00`3oool:003jVTl0oooo100000030?ooo`030000003oool0oooo0080
000000<0oooo0000003oool0EP3oool2000000H0oooo00<000000?ooo`3oool0:03oool00300oooo
00<000000?ooo`000000303oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01<0oooo
0`00nYX20?ooo`04003jVP3oool0oooo003jVVL0oooo00H00000003jVP000000oooo003jVP3oool2
00000003003jVP3oool0oooo00@0oooo0P00nYX00`000000oooo003jVP02003jVP030?ooo`00nYX0
0?ZJ0080oooo00X00?ZJ0?ooo`3oool00000003jVP3oool000000000o`00nYX0oooo0P00nYX30?oo
o`030000003oool0oooo00800?ZJ0P0000001@00nYX0oooo003jVP3oool00?ZJ0100oooo00<00000
0?ooo`3oool0103oool010000000oooo0?ooo`00000;0?ooo`050000003oool0oooo0?ooo`000000
3P3oool;003jVTD0oooo100000030?ooo`070000003oool0oooo0?ooo`000000oooo0000001G0?oo
o`8000001P3oool00`000000oooo0?ooo`0X0?ooo`00<@3oool2000000P0oooo00D000000?ooo`3o
ool0oooo000000040?ooo`030000003oool0oooo01<0oooo0`00nYX20?ooo`800?ZJ00<0oooo003j
VP3oool0IP3oool01P0000000?ZJ0000003oool00?ZJ0?ooo`80000000<00?ZJ0?ooo`3oool00`3o
ool01@0000000?ZJ003jVP000000oooo00800?ZJ0P3oool01@00nYX0oooo0?ooo`3oool00?ZJ0080
oooo00L00000003jVP3oool000000000o`00nYX0oooo00800?ZJ103oool010000000oooo003jVP00
nYX200000003003jVP3oool0oooo00800?ZJ403oool00`000000oooo0?ooo`040?ooo`040000003o
ool0oooo000000L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01L0
oooo1P00nYXo0?ooo`80000000D0oooo0000003oool0oooo000000060?ooo`030000003oool0oooo
05@0oooo0P0000070?ooo`030000003oool0oooo02P0oooo000b0?ooo`030000003oool0oooo00H0
oooo1@0000040?ooo`8000005@3oool2003jVP80oooo0P00nYX00`3oool00?ZJ0?ooo`1V0?ooo`06
00000000nYX000000?ooo`00nYX0oooo0P0000000`00nYX0oooo0?ooo`030?ooo`0500000000nYX0
0?ZJ0000003oool00P00nYX00`3oool00000000000030?ooo`08003jVP3oool0oooo00000000nYX0
oooo000000000?l2003jVP0300000000nYX0oooo00<0oooo00@000000?ooo`00nYX00?ZJ0P000000
0`00nYX0oooo0?ooo`02003jVPl0oooo0P0000070?ooo`8000002@3oool3000000@0oooo0P00000M
0?ooo`P00?ZJ>@3oool00`000000oooo000000020?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool01@3oool2000002X0oooo00140?ooo`030000003oool0oooo01H0oooo00H00?ZJ0?oo
o`00nYX00?ZJ0?ooo`00nYYX0?ooo`05003jVP3oool0oooo003jVP3oool00P0000000`00nYX0oooo
0?ooo`030?ooo`0500000000nYX00?ZJ0000003oool00P00nYX00`3oool00000000000030?ooo`08
003jVP3oool0oooo00000000nYX0oooo000000000?l2003jVP030?ooo`00nYX0oooo00<0oooo00D0
00000?ooo`00nYX00?ZJ0?ooo`02003jVP<0oooo00<00?ZJ0?ooo`3oool03P3oool00`000000oooo
0?ooo`0G0?ooo`030000003oool0oooo02<0oooo1@00nYXe0?ooo`030000003oool000000080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo02@0oooo
00H000000?ooo`3oool000000?ooo`0000020?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0:03oool004@0oooo00<000000?ooo`3oool05P3oool01000nYX0oooo003jVP3oool2003j
VVT0oooo00@00?ZJ0?ooo`00nYX0oooo0P0000000`00nYX0oooo0?ooo`030?ooo`0900000000nYX0
0?ZJ0000003oool00?ZJ0000o`3oool0000000@0003o00`00?ZJ0000003oool00000003jVP3oool0
00000000o`00nYX000000?ooo`00nYX40?ooo`050000003oool00?ZJ003jVP3oool00P00nYXD0?oo
o`030000003oool0oooo01L0oooo00<000000?ooo`3oool09`3oool9003jVRd0oooo00<000000?oo
o`0000000P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo02@0oooo0P00000U0?oo
o`060000003oool0oooo0000003oool000000P3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo02P0oooo00140?ooo`030000003oool0oooo01L0oooo0P00nYX00`3oool00?ZJ003jVP1Y
0?ooo`04003jVP3oool00?ZJ0?ooo`80000000<00?ZJ0?ooo`3oool00`3oool01000nYX0003o003j
VP0000020?ooo`04003jVP3oool000000000o`<0oooo00H00?ZJ0000003oool00000003jVP3oool2
00000004003jVP000000oooo003jVP@0oooo00<000000?ooo`00nYX00P00nYX00`3oool00?ZJ0?oo
o`0C0?ooo`030000003oool0oooo01L0oooo0P00000`0?ooo`/00?ZJ9@3oool010000000oooo0?oo
o`0000070?ooo`030000003oool0oooo02@0oooo0P00000T0?ooo`<0000000<0oooo000000000000
0P0000000`3oool000000?ooo`060?ooo`800000:P3oool004@0oooo0P00000I0?ooo`04003jVP3o
ool0oooo003jVVT0oooo00@00?ZJ0?ooo`00nYX0oooo0P0000002P00nYX0oooo0?ooo`3oool00?ZJ
0?ooo`00nYX0003o003jVP0000020?ooo`04003jVP00000000000000o`<0oooo00<00?ZJ0000003o
ool00`00nYX200000004003jVP000000oooo003jVP@0oooo00<000000?ooo`00nYX00P00nYX00`3o
ool00?ZJ0?ooo`0B0?ooo`8000006@3oool00`000000oooo0?ooo`0j0?oooa<00?ZJ4P3oool01000
0000oooo0?ooo`0000070?ooo`030000003oool0oooo02@0oooo0P0000020?ooo`030000003oool0
oooo01l0oooo0`000000103oool000000000003oool3000000P0oooo00<000000?ooo`3oool0:03o
ool004@0oooo00<000000?ooo`3oool06`3oool00`00nYX0oooo0?ooo`1X0?ooo`800?ZJ0P3oool0
100000000?ZJ0?ooo`3oool3003jVP07000000000?l00?ZJ0?ooo`000000oooo003jVP030000o`<0
oooo00<00?ZJ0000003oool00`00nYX20?ooo`04003jVP000000oooo003jVP@0oooo00<000000?oo
o`0000000P00nYX00`3oool00?ZJ0?ooo`0C0?ooo`030000003oool0oooo01L0oooo00<000000?oo
o`3oool0C@3oool;003jVPP0oooo0`0000070?ooo`030000003oool0oooo01l0oooo1`00nYX00`3o
ool00000000000090?ooo`@00?ZJ503oool010000000oooo0000003oool2000000`0oooo00<00000
0?ooo`3oool0:03oool004@0oooo00<000000?ooo`3oool0QP3oool2003jVP<0oooo00<00?ZJ0?oo
o`3oool00`00nYX01`000000003o003jVP3oool000000?ooo`00nYX00P0000001@00nYX0oooo0?oo
o`3oool00?ZJ008000000P00nYX01`3oool00?ZJ0?ooo`000?l000000?ooo`00nYX0103oool01000
0000oooo00000000nYX20?ooo`03003jVP3oool0oooo0180oooo00<000000?ooo`3oool05`3oool0
0`000000oooo0?ooo`1H0?oooa<00?ZJ0P3oool00`000000oooo0?ooo`0E0?ooo`@00?ZJ0`3oool0
2`00nYX0oooo0?ooo`3oool000000?ooo`0000000?ZJ0000003oool0000000P00?ZJ0`3oool01000
nYX0oooo0?ooo`3oool2003jVPl0oooo00H000000?ooo`00000000000?ooo`00000<0?ooo`030000
003oool0oooo02P0oooo00140?ooo`800000R03oool02000nYX0oooo0?ooo`3oool00?ZJ0?ooo`00
nYX0oooo0P00nYX01`3oool00?ZJ0?ooo`3oool000000?ooo`00nYX00P0000001@00nYX000000?oo
o`3oool00?ZJ008000000P00nYX01`3oool00?ZJ0?ooo`000?l000000?ooo`00nYX0103oool01000
0000oooo00000000nYX20?ooo`03003jVP3oool0oooo0140oooo0P00000I0?ooo`800000HP3oool2
000000L0oooo2000nYX;0?ooo`P00?ZJ0`3oool4003jVP@0oooo00<000000?ooo`0000001@00nYX:
0?ooo`@00?ZJ00@0oooo003jVP00nYX00?ZJ1`3oool4003jVP80oooo00@000000?ooo`0000000000
3@3oool2000002X0oooo00140?ooo`030000003oool0oooo08L0oooo00`00?ZJ0?ooo`3oool0oooo
003jVP3oool00?ZJ0?ooo`00nYX000000?ooo`00nYX20?ooo`030000003oool00?ZJ008000000P00
nYX20?ooo`03003jVP000000000000800?ZJ0P3oool01@00nYX0003o0000o`000?l00?ZJ00D0oooo
0P0000001000nYX0oooo0?ooo`00nYXD0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0H@3oool2000000P0oooo00<000000?ooo`0000000`3oool00`00nYX000000?ooo`020?ooo`P0
0?ZJ4P3oool01`000000oooo0000003oool000000?ooo`0000004`3oool8003jVP030000003oool0
oooo00@00?ZJ403oool00`000000oooo0?ooo`0X0?ooo`00A03oool00`000000oooo0?ooo`2;0?oo
o`08003jVP3oool00?ZJ0?ooo`00nYX000000?ooo`00nYX20?ooo`030000003oool00?ZJ00800000
0P00nYX20?ooo`03003jVP000000000000800?ZJ0P3oool01@00nYX000000000003oool00?ZJ00D0
oooo0P0000001000nYX0oooo0?ooo`00nYXD0?ooo`030000003oool0oooo01L0oooo00<000000?oo
o`3oool0HP3oool00`000000oooo0?ooo`060?ooo`040000003oool00000000000<0oooo1000nYX2
0?ooo`800?ZJ0P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0080000000<0oooo
0000003oool00P3oool00`000000oooo0?ooo`0E0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool<003jVP@0oooo00<000000?ooo`3oool0:03oool004@0oooo00<000000?ooo`3oool0R`3oool2
003jVP80oooo0P000000103oool00?ZJ0?ooo`3oool200000003003jVP000000oooo00800?ZJ0P3o
ool00`00nYX0000000000002003jVP80oooo00D00?ZJ0?ooo`000000oooo003jVP050?ooo`800000
00@00?ZJ0?ooo`3oool00?ZJ503oool00`000000oooo0?ooo`0G0?ooo`800000H`3oool00`000000
oooo0?ooo`060?ooo`80000000<0oooo0000003oool00P3oool00`000000oooo0?ooo`070?ooo`80
00004@3oool01@000000oooo0?ooo`3oool000000080oooo00D000000?ooo`3oool0oooo0000000F
0?ooo`8000000`3oool00`000000oooo0?ooo`0?0?ooo`800000:P3oool004@0oooo0P00002<0?oo
o`800?ZJ0P3oool010000000oooo0?ooo`00nYX20?ooo`80000000P00?ZJ0000003oool00?ZJ0000
0000nYX0oooo003jVP8000000P00nYX30?ooo`04003jVP000000oooo003jVPD0oooo0P0000001000
nYX0003o0000o`00nYXC0?ooo`80000000<0oooo000000000000103oool00`000000oooo0?ooo`02
0?ooo`<000000`3oool3000000@0oooo00<000000?ooo`3oool0HP3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool01P3oool010000000oooo00000000
00040?ooo`030000003oool0oooo00P0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000
0P3oool2000001D0oooo0P0000030?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
:03oool002/0oooo0`0000030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3o
ool3000000D0oooo00<000000?ooo`3oool0R`3oool01000nYX0oooo0?ooo`3oool30000o`03003j
VP3oool0oooo0080000000P0oooo003jVP3oool00?ZJ00000000nYX0oooo003jVP8000000P00nYX3
0?ooo`04003jVP3oool0oooo003jVPD0oooo00<000000?ooo`00nYX00P3oool00`00nYX0oooo0?oo
o`0B0?ooo`8000000P3oool00`000000oooo0?ooo`050?ooo`070000003oool0oooo0?ooo`000000
oooo000000030?ooo`050000003oool0oooo0?ooo`000000KP3oool00`000000oooo000000030?oo
o`030000003oool0oooo00H0oooo00@000000?ooo`00000000000`3oool2000000H0oooo0P000002
0?ooo`8000001`3oool00`000000oooo0?ooo`02000001@0oooo00D000000?ooo`00000000000?oo
o`0200000180oooo00<000000?ooo`3oool0:03oool002`0oooo00<000000?ooo`3oool0203oool0
1@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`2;0?ooo`05003jVP3oool0oooo0?ooo`000?l00P3oool02`00nYX0oooo0?ooo`3oool000000?oo
o`00nYX0oooo003jVP000000oooo00800?ZJ0P000002003jVP<0oooo00@00?ZJ0?ooo`3oool00?ZJ
1@3oool00`000000oooo003jVP020?ooo`03003jVP3oool0oooo0180oooo0P0000020?ooo`030000
003oool0oooo00T0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`3oool3000006h0
oooo00<000000?ooo`3oool00P0000080?ooo`070000003oool000000000003oool000000?ooo`03
000000D0oooo0P0000000`3oool000000?ooo`080?ooo`030000003oool0oooo00800000503oool0
0`000000oooo0000000400000140oooo0P00000Z0?ooo`00:@3oool5000000X0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`020?ooo`800000S03oool01@00nYX0oooo0000003oool0
003o0080oooo00X00?ZJ0?ooo`3oool0oooo0000003oool00?ZJ0?ooo`00nYX000000P3oool01@00
nYX00000003jVP000?l00?ZJ00<0oooo00@00?ZJ0?ooo`3oool00?ZJ1@3oool00`000000oooo003j
VP020?ooo`03003jVP3oool0oooo0100oooo100000020?ooo`030000003oool0oooo00L0oooo0P00
00060?ooo`050000003oool0oooo0?ooo`000000L03oool01P000000oooo0?ooo`000000oooo0000
00L0oooo00@000000?ooo`3oool0oooo0P000000103oool000000000000000050?ooo`80000000<0
oooo0000003oool0203oool00`000000oooo0?ooo`02000001@0oooo00<000000?ooo`3oool00`00
000C0?ooo`030000003oool0oooo02P0oooo000Y0?ooo`040000003oool0oooo000000/0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo08/0oooo00<0
0?ZJ0000o`000?l00P000?l20?ooo`05003jVP3oool0oooo0?ooo`0000000P3oool2003jVP080000
003oool0oooo003jVP0000000?ZJ0000o`00nYX40?ooo`03003jVP3oool00?ZJ00D0oooo00<00000
0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`0B0?ooo`8000000P3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0000000<00000103oool00`000000oooo0?ooo`1^0?ooo`060000003oool0
oooo0000003oool000001@3oool00`000000oooo000000030?ooo`80000000@0oooo000000000000
00001@3oool3000000X0oooo00<000000?ooo`3oool00P00000D0?ooo`030000003oool0oooo0080
0000503oool00`000000oooo0?ooo`0X0?ooo`00:P3oool00`000000oooo0000000<0?ooo`030000
003oool0000000<000001@3oool00`000000oooo0?ooo`2;0?ooo`05003jVP3oool000000?ooo`00
nYX00P3oool01@00nYX0oooo0?ooo`3oool000000080oooo0P00nYX020000000oooo0?ooo`00nYX0
0000003jVP000?l00?ZJ103oool00`00nYX0oooo003jVP050?ooo`030000003oool00?ZJ0080oooo
00<00?ZJ0?ooo`3oool04P3oool200000080oooo00<000000?ooo`3oool01@3oool01`000000oooo
0?ooo`3oool000000?ooo`0000001`3oool00`000000oooo0?ooo`1^0?ooo`060000003oool0oooo
0000003oool000001@3oool00`000000oooo000000030?ooo`@0000000<0oooo0000000000000`3o
ool4000000X0oooo00D000000?ooo`000000oooo0000000D0?ooo`030000003oool0oooo00800000
503oool00`000000oooo0?ooo`0X0?ooo`00:`3oool2000000P0oooo00L000000?ooo`3oool0oooo
0000003oool0000000P0oooo00<000000?ooo`3oool0R`3oool01@00nYX0oooo0000000000000?ZJ
0080oooo00<00?ZJ0?ooo`3oool01@3oool01000nYX000000?ooo`3oool2003jVP030?ooo`000?l0
0?ZJ00@0oooo00<00?ZJ0?ooo`00nYX01@3oool00`000000oooo003jVP020?ooo`03003jVP3oool0
oooo0180oooo00@000000?ooo`00000000002@3oool300000080oooo1@0000030?ooo`800000L03o
ool01@000000oooo0000003oool0000000D0oooo00<000000?ooo`0000000`3oool400000080oooo
00<000000?ooo`3oool01@00000:0?ooo`050000003oool000000?ooo`000000503oool00`000000
oooo0?ooo`02000001<0oooo0P00000Z0?ooo`00;03oool00`000000oooo0?ooo`060?ooo`D00000
00<0oooo0000000000000`0000040?ooo`800000S03oool01000nYX000000?ooo`000002003jVP03
0?ooo`00nYX0oooo00L0oooo00<000000?ooo`3oool00P00nYX00`3oool00?ZJ0?ooo`050?ooo`80
0?ZJ1@3oool00`000000oooo003jVP020?ooo`03003jVP3oool0oooo0140oooo0P00000I0?ooo`03
0000003oool0oooo06l0oooo00D000000?ooo`000000oooo000000050?ooo`030000003oool00000
00<0oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`02000000030?ooo`0000000000
00/0oooo0P0000000`3oool000000?ooo`0B0?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool04P3oool00`000000oooo0?ooo`0X0?ooo`00A03oool00`000000oooo0?ooo`2;0?ooo`04
003jVP000000oooo000000800?ZJ00<0oooo003jVP3oool01`3oool00`000000oooo0?ooo`02003j
VP030?ooo`00nYX0oooo00D0oooo0P00nYX80?ooo`03003jVP3oool00?ZJ01@0oooo00<000000?oo
o`3oool05`3oool00`000000oooo0?ooo`1_0?ooo`050000003oool000000?ooo`000000103oool4
000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo000000020?ooo`8000002`3oool2
000000030?ooo`000000oooo0180oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo02P0oooo00140?ooo`030000003oool0oooo08/0oooo00@00?ZJ0000
003oool0oooo0P00nYX00`3oool00?ZJ0?ooo`080?ooo`030000003oool00?ZJ0080oooo00<00?ZJ
0?ooo`3oool01@3oool00`00nYX0oooo0?ooo`060?ooo`03003jVP3oool00?ZJ01@0oooo00<00000
0?ooo`3oool05`3oool200000700oooo00D000000?ooo`000000oooo000000040?ooo`040000003o
ool00000000000X0oooo00<000000?ooo`0000000P3oool2000000/0oooo0P0000000`3oool00000
0?ooo`0B0?ooo`030000003oool0oooo01H0oooo0P00000Z0?ooo`00A03oool00`000000oooo0?oo
o`2<0?ooo`05003jVP3oool0oooo003jVP3oool00P00nYX90?ooo`030000003oool00?ZJ0080oooo
00<00?ZJ0?ooo`3oool03`3oool2003jVQ@0oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`1_0?ooo`8000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0000000/0oooo
0`0000030?ooo`030000003oool0oooo00T0oooo00H000000?ooo`3oool000000?ooo`00000A0?oo
o`030000003oool0oooo01L0oooo00<000000?ooo`3oool0:03oool004@0oooo0P00002>0?ooo`04
003jVP3oool00?ZJ0?ooo`800?ZJ2@3oool00`000000oooo003jVP020?ooo`03003jVP3oool0oooo
00l0oooo0P00nYXC0?ooo`8000006@3oool00`000000oooo0?ooo`1`0?ooo`060000003oool0oooo
0000003oool000000P3oool00`000000oooo0000000;0?ooo`800000103oool00`000000oooo0?oo
o`090?ooo`060000003oool0oooo0000003oool000004@3oool00`000000oooo0?ooo`0G0?ooo`03
0000003oool0oooo02P0oooo00140?ooo`030000003oool0oooo08d0oooo00<00?ZJ0?ooo`00nYX0
0P3oool00`00nYX0oooo0?ooo`070?ooo`030000003oool00?ZJ0080oooo00<00?ZJ0?ooo`3oool0
403oool00`00nYX0oooo0?ooo`0B0?ooo`030000003oool0oooo01L0oooo0P00001a0?ooo`050000
003oool0oooo0000003oool00P000000103oool000000?ooo`00000;0?ooo`800000503oool20000
0100oooo00<000000?ooo`3oool05`3oool2000002X0oooo00140?ooo`030000003oool0oooo08d0
oooo00<00?ZJ0?ooo`00nYX00P3oool00`00nYX0oooo0?ooo`070?ooo`80000000@00?ZJ0000o`00
0?l00?ZJ9`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo07<0oooo10000000103o
ool000000?ooo`00000;0?ooo`800000503oool200000080oooo0P00000<0?ooo`030000003oool0
oooo01P0oooo00<000000?ooo`3oool0:03oool004@0oooo0P00002?0?ooo`800?ZJ303oool00`00
0000oooo003jVP020?ooo`03003jVP3oool0oooo02@0oooo0P00000I0?ooo`030000003oool0oooo
07@0oooo00@000000?ooo`00000000003P3oool2000001@0oooo0`0000000`3oool000000000000<
0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0:03oool004@0oooo00<000000?oo
o`3oool0SP3oool2003jVPh0oooo00@00?ZJ0?ooo`3oool00?ZJ9`3oool00`000000oooo0?ooo`0G
0?ooo`030000003oool0oooo07H0oooo0P00000?0?ooo`030000003oool0oooo0180oooo10000000
0`3oool000000?ooo`0;0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0:03oool0
04@0oooo00<000000?ooo`3oool0S`3oool00`00nYX0oooo0?ooo`0<0?ooo`04003jVP3oool0oooo
003jVRL0oooo00<000000?ooo`3oool01@3oool2000000@0oooo00<000000?ooo`3oool00`3oool3
000000<0oooo0P00001g0?ooo`800000903oool020000000oooo000000000000oooo0000003oool0
0000203oool2000001X0oooo0P00000Z0?ooo`00A03oool00`000000oooo0?ooo`2N0?ooo`04003j
VP3oool0oooo003jVRL0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`00000:0?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0M`3oool00`000000oooo0?ooo`0R0?oo
o`030000003oool000000080oooo00<000000?ooo`000000203oool2000001/0oooo00<000000?oo
o`3oool0:03oool004@0oooo0P00002P0?ooo`03003jVP3oool00?ZJ02H0oooo0P0000060?ooo`04
0000003oool0oooo000000L0oooo1@0000030?ooo`030000003oool0oooo07L0oooo00<000000?oo
o`3oool08P3oool00`000000oooo0?ooo`020?ooo`@000001`3oool2000001/0oooo00<000000?oo
o`3oool0:03oool00340oooo0`0000030?ooo`030000003oool0oooo0080oooo0`0000050?ooo`03
0000003oool0oooo09l0oooo00<00?ZJ0?ooo`00nYX09`3oool00`000000oooo0?ooo`040?ooo`04
0000003oool0oooo000000L0oooo00@000000?ooo`3oool00000103oool3000009`0oooo00<00000
0?ooo`3oool00P3oool500000080oooo00@000000?ooo`3oool0oooo0P00000J0?ooo`800000:P3o
ool00380oooo00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<0
00000?ooo`3oool0W`3oool00`00nYX0oooo003jVP0W0?ooo`030000003oool0oooo00@0oooo00@0
00000?ooo`3oool00000203oool00`000000oooo000000040?ooo`030000003oool0oooo0:40oooo
1@000000103oool000000000000000020?ooo`8000006`3oool00`000000oooo0?ooo`0X0?ooo`00
;`3oool5000000L0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo0:00
oooo0P00nYXW0?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool000002@3oool20000
00@0oooo00<000000?ooo`3oool0X`3oool01@000000oooo000000000000oooo00<0000000<0oooo
0000003oool06`3oool00`000000oooo0?ooo`0X0?ooo`00;`3oool010000000oooo0?ooo`000009
0?ooo`<000001@3oool200000:40oooo0P00nYXU0?ooo`<000001`3oool2000000/0oooo00<00000
0?ooo`3oool00P3oool200000:@0oooo00<000000?ooo`3oool00`3oool2000000030?ooo`000000
oooo01X0oooo0P00000Z0?ooo`00<03oool00`000000oooo000000080?ooo`050000003oool0oooo
0?ooo`000000103oool00`000000oooo0?ooo`2Q0?ooo`03003jVP3oool0oooo02D0oooo00<00000
0?ooo`3oool05`3oool00`000000oooo0?ooo`2Y0?ooo`80000000<0oooo0000003oool06`3oool0
0`000000oooo0?ooo`0X0?ooo`00<@3oool2000000P0oooo00D000000?ooo`3oool0oooo00000004
0?ooo`030000003oool0oooo0:40oooo00<00?ZJ0?ooo`3oool09@3oool00`000000oooo0?ooo`0G
0?ooo`030000003oool0oooo0:X0oooo0P00000M0?ooo`030000003oool0oooo02P0oooo000b0?oo
o`030000003oool0oooo00L0oooo0`0000050?ooo`800000b@3oool2000001T0oooo00<000000?oo
o`3oool0b@3oool00`000000oooo0?ooo`0X0?ooo`00A03oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo01L0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0G0?ooo`03
0000003oool0oooo01P0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0G0?ooo`03
0000003oool0oooo01P0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0G0?ooo`80
00000`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00T0oooo0P00000Z0?ooo`00
A03oooo=000001T0ooooc@00000Z0?ooo`00o`3ooooo0?ooob<0oooo003o0?ooool0oooo8`3oool0
0?l0ooooo`3ooolS0?ooo`00o`3ooooo0?ooob<0oooo003o0?ooool0oooo8`3oool00?l0ooooo`3o
oolS0?ooo`00o`3ooooo0?ooob<0oooo003o0?ooool0oooo8`3oool00?l0ooooo`3ooolS0?ooo`00
o`3ooooo0?ooob<0oooo003o0?ooool0oooo8`3oool00?l0ooooo`3ooolS0?ooo`00o`3ooooo0?oo
ob<0oooo003o0?ooo`l0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`03
0000003oool0oooo0?/0oooo003o0?ooo`h0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`080?ooo`030000003oool0oooo0?X0oooo003h0?ooo`<0000000<0oooo0000000000000`00
00000`3oool000000?ooo`03000000D0oooo00@000000?ooo`3oool0oooo1@0000040?ooo`030000
003oool0oooo0080oooo0`0000040?ooo`030000003oool0oooo0?T0oooo003i0?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool000002P3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo0?T0oooo003i0?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`00000000000P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool01`3oool5000000@0oooo00<000000?ooo`3oool0n@3oool00?T0oooo100000020?oo
o`040000003oool0000000000080oooo0`0000040?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool01P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo0?T0oooo003i
0?ooo`040000003oool0oooo00000080oooo0P0000001@3oool000000?ooo`3oool0000000L0oooo
00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`060?ooo`030000003oool0000000@0
oooo00<000000?ooo`3oool0nP3oool00?T0oooo00@000000?ooo`3oool000000P3oool200000005
0?ooo`000000oooo0?ooo`0000000P3oool00`000000oooo0?ooo`030?ooo`030000003oool00000
00<0oooo00<000000?ooo`3oool01`3oool2000000<0oooo00<000000?ooo`3oool0n`3oool00?P0
oooo0`0000000`3oool0000000000002000000030?ooo`000000000000H00000203oool3000000/0
oooo00<000000?ooo`3oool0o`3oool00?l0ooooo`3ooolS0?ooo`00o`3ooooo0?ooob<0oooo0000
\
\>"],
  ImageRangeCache->{{{0, 544.688}, {167.625, 0}} -> {-0.181598, -0.0154542, \
0.00433863, 0.00433863}, {{41.8125, 272.312}, {164.062, 21.5625}} -> \
{-137.678, 4.42053, 1.88049, 0.0027568}, {{272.312, 502.812}, {164.062, \
21.5625}} -> {-571.132, -0.0032317, 1.88049, 0.00298519}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF, kappa=0", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[{
  "{YF,PF,lik}=UKF[{logZM,X},{0.07, -1., .2, .2},\n                     \t\
{drift,diffusion,h,R,",
  StyleBox["Mue,Sigma",
    FontColor->RGBColor[1, 0, 0]],
  ",dt,kappa=0},{-9,2}];"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
s=Map[VecDiag,PF]//Sqrt;
KI=YF~ii~(YF+s)~ii~(YF-s);

SetOptions[plot1,dicke->.007];
gUKF=
DisplayTogetherArray[
plot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}]  \
//AddTimeAxis,color->{10,1,2,2},permute->{1,4,3,2}],
plot1[    Column[Y,{2}] \
~ii~Column[KI,{1,3,5}+1]//AddTimeAxis,color->{10,1,2,2}],PlotLabel->\"UKF, \
kappa=0\"];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -38 0 ]
[.5 .32152 38 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -8.00386 1.79103 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05577 -18 -4.5 ]
[-0.0125 .05577 0 4.5 ]
[-0.0125 .14532 -24 -4.5 ]
[-0.0125 .14532 0 4.5 ]
[-0.0125 .23488 -18 -4.5 ]
[-0.0125 .23488 0 4.5 ]
[-0.0125 .32443 -24 -4.5 ]
[-0.0125 .32443 0 4.5 ]
[-0.0125 .41398 -18 -4.5 ]
[-0.0125 .41398 0 4.5 ]
[-0.0125 .50353 -24 -4.5 ]
[-0.0125 .50353 0 4.5 ]
[-0.0125 .59308 -18 -4.5 ]
[-0.0125 .59308 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33497 -5 -6 ]
[.97619 .33497 5 6 ]
[.97619 .32461 -5 -6 ]
[.97619 .32461 5 6 ]
[.97619 .36243 -5 -6 ]
[.97619 .36243 5 6 ]
[.97619 .34352 -5 -6 ]
[.97619 .34352 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05577 m
.00625 .05577 L
s
[(4.5)] -0.0125 .05577 1 0 Mshowa
0 .14532 m
.00625 .14532 L
s
[(4.55)] -0.0125 .14532 1 0 Mshowa
0 .23488 m
.00625 .23488 L
s
[(4.6)] -0.0125 .23488 1 0 Mshowa
0 .32443 m
.00625 .32443 L
s
[(4.65)] -0.0125 .32443 1 0 Mshowa
0 .41398 m
.00625 .41398 L
s
[(4.7)] -0.0125 .41398 1 0 Mshowa
0 .50353 m
.00625 .50353 L
s
[(4.75)] -0.0125 .50353 1 0 Mshowa
0 .59308 m
.00625 .59308 L
s
[(4.8)] -0.0125 .59308 1 0 Mshowa
.125 Mabswid
0 .07368 m
.00375 .07368 L
s
0 .09159 m
.00375 .09159 L
s
0 .1095 m
.00375 .1095 L
s
0 .12741 m
.00375 .12741 L
s
0 .16324 m
.00375 .16324 L
s
0 .18115 m
.00375 .18115 L
s
0 .19906 m
.00375 .19906 L
s
0 .21697 m
.00375 .21697 L
s
0 .25279 m
.00375 .25279 L
s
0 .2707 m
.00375 .2707 L
s
0 .28861 m
.00375 .28861 L
s
0 .30652 m
.00375 .30652 L
s
0 .34234 m
.00375 .34234 L
s
0 .36025 m
.00375 .36025 L
s
0 .37816 m
.00375 .37816 L
s
0 .39607 m
.00375 .39607 L
s
0 .43189 m
.00375 .43189 L
s
0 .4498 m
.00375 .4498 L
s
0 .46771 m
.00375 .46771 L
s
0 .48562 m
.00375 .48562 L
s
0 .52144 m
.00375 .52144 L
s
0 .53935 m
.00375 .53935 L
s
0 .55726 m
.00375 .55726 L
s
0 .57517 m
.00375 .57517 L
s
0 .03786 m
.00375 .03786 L
s
0 .01995 m
.00375 .01995 L
s
0 .00204 m
.00375 .00204 L
s
0 .61099 m
.00375 .61099 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05577 m
1 .05577 L
s
.99375 .14532 m
1 .14532 L
s
.99375 .23488 m
1 .23488 L
s
.99375 .32443 m
1 .32443 L
s
.99375 .41398 m
1 .41398 L
s
.99375 .50353 m
1 .50353 L
s
.99375 .59308 m
1 .59308 L
s
.125 Mabswid
.99625 .07368 m
1 .07368 L
s
.99625 .09159 m
1 .09159 L
s
.99625 .1095 m
1 .1095 L
s
.99625 .12741 m
1 .12741 L
s
.99625 .16324 m
1 .16324 L
s
.99625 .18115 m
1 .18115 L
s
.99625 .19906 m
1 .19906 L
s
.99625 .21697 m
1 .21697 L
s
.99625 .25279 m
1 .25279 L
s
.99625 .2707 m
1 .2707 L
s
.99625 .28861 m
1 .28861 L
s
.99625 .30652 m
1 .30652 L
s
.99625 .34234 m
1 .34234 L
s
.99625 .36025 m
1 .36025 L
s
.99625 .37816 m
1 .37816 L
s
.99625 .39607 m
1 .39607 L
s
.99625 .43189 m
1 .43189 L
s
.99625 .4498 m
1 .4498 L
s
.99625 .46771 m
1 .46771 L
s
.99625 .48562 m
1 .48562 L
s
.99625 .52144 m
1 .52144 L
s
.99625 .53935 m
1 .53935 L
s
.99625 .55726 m
1 .55726 L
s
.99625 .57517 m
1 .57517 L
s
.99625 .03786 m
1 .03786 L
s
.99625 .01995 m
1 .01995 L
s
.99625 .00204 m
1 .00204 L
s
.99625 .61099 m
1 .61099 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .33497 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .24414 m
.02642 .25162 L
.02903 .25325 L
.03164 .22675 L
.03425 .2442 L
.03686 .23766 L
.03947 .2605 L
.04207 .29114 L
.04468 .29744 L
.04729 .32343 L
.0499 .2872 L
.05251 .30073 L
.05512 .27653 L
.05773 .29827 L
.06034 .32395 L
.06295 .34496 L
.06556 .36257 L
.06817 .34729 L
.07078 .31677 L
.07339 .36394 L
.07599 .34563 L
.0786 .33206 L
.08121 .30739 L
.08382 .31531 L
.08643 .33493 L
.08904 .32903 L
.09165 .34775 L
.09426 .4188 L
.09687 .37859 L
.09948 .3671 L
.10209 .36852 L
.1047 .39408 L
.10731 .40862 L
.10992 .38715 L
.11252 .38352 L
.11513 .39591 L
.11774 .37439 L
.12035 .38111 L
.12296 .37741 L
.12557 .35164 L
.12818 .37075 L
.13079 .40002 L
.1334 .40229 L
.13601 .37257 L
.13862 .38073 L
.14123 .36653 L
.14384 .37508 L
.14644 .3719 L
.14905 .35303 L
.15166 .33735 L
Mistroke
.15427 .34667 L
.15688 .36123 L
.15949 .38721 L
.1621 .35007 L
.16471 .32049 L
.16732 .32848 L
.16993 .33615 L
.17254 .32818 L
.17515 .31664 L
.17776 .33276 L
.18037 .31161 L
.18297 .30945 L
.18558 .31816 L
.18819 .31296 L
.1908 .31431 L
.19341 .31809 L
.19602 .30119 L
.19863 .29454 L
.20124 .23893 L
.20385 .24215 L
.20646 .25188 L
.20907 .24727 L
.21168 .24304 L
.21429 .25971 L
.21689 .26369 L
.2195 .26688 L
.22211 .23632 L
.22472 .26004 L
.22733 .28973 L
.22994 .28512 L
.23255 .29661 L
.23516 .29845 L
.23777 .25056 L
.24038 .25754 L
.24299 .25769 L
.2456 .26736 L
.24821 .25982 L
.25082 .26145 L
.25342 .26951 L
.25603 .26171 L
.25864 .25903 L
.26125 .263 L
.26386 .25646 L
.26647 .2543 L
.26908 .2605 L
.27169 .26973 L
.2743 .27498 L
.27691 .26656 L
.27952 .24044 L
.28213 .25607 L
Mistroke
.28474 .26466 L
.28735 .23899 L
.28995 .21781 L
.29256 .2333 L
.29517 .21564 L
.29778 .24006 L
.30039 .19814 L
.303 .20458 L
.30561 .21845 L
.30822 .22462 L
.31083 .2532 L
.31344 .27339 L
.31605 .27182 L
.31866 .26441 L
.32127 .28399 L
.32387 .27599 L
.32648 .32215 L
.32909 .31374 L
.3317 .27918 L
.33431 .27619 L
.33692 .31709 L
.33953 .31437 L
.34214 .29297 L
.34475 .29039 L
.34736 .29977 L
.34997 .32071 L
.35258 .31444 L
.35519 .30381 L
.3578 .30077 L
.3604 .29938 L
.36301 .29604 L
.36562 .28009 L
.36823 .3055 L
.37084 .31031 L
.37345 .30791 L
.37606 .27369 L
.37867 .27447 L
.38128 .25074 L
.38389 .26999 L
.3865 .2484 L
.38911 .24363 L
.39172 .25417 L
.39432 .27047 L
.39693 .24348 L
.39954 .25167 L
.40215 .26554 L
.40476 .27333 L
.40737 .24225 L
.40998 .22122 L
.41259 .23388 L
Mistroke
.4152 .21802 L
.41781 .23936 L
.42042 .24885 L
.42303 .24568 L
.42564 .2621 L
.42825 .24422 L
.43085 .2473 L
.43346 .25884 L
.43607 .25294 L
.43868 .27066 L
.44129 .27016 L
.4439 .23434 L
.44651 .2105 L
.44912 .22308 L
.45173 .27715 L
.45434 .25629 L
.45695 .25694 L
.45956 .2226 L
.46217 .23904 L
.46477 .24001 L
.46738 .25054 L
.46999 .21643 L
.4726 .24575 L
.47521 .25517 L
.47782 .27771 L
.48043 .29773 L
.48304 .24677 L
.48565 .25336 L
.48826 .22829 L
.49087 .28344 L
.49348 .29058 L
.49609 .27837 L
.4987 .29348 L
.5013 .28663 L
.50391 .29784 L
.50652 .26475 L
.50913 .26787 L
.51174 .29567 L
.51435 .2527 L
.51696 .30796 L
.51957 .28533 L
.52218 .26092 L
.52479 .22696 L
.5274 .2503 L
.53001 .26692 L
.53262 .26974 L
.53523 .24747 L
.53783 .21139 L
.54044 .14903 L
.54305 .17847 L
Mistroke
.54566 .19375 L
.54827 .19928 L
.55088 .1737 L
.55349 .19677 L
.5561 .23591 L
.55871 .19461 L
.56132 .18786 L
.56393 .15774 L
.56654 .0801 L
.56915 .03796 L
.57175 .06194 L
.57436 .10507 L
.57697 .10011 L
.57958 .10721 L
.58219 .09707 L
.5848 .09553 L
.58741 .09859 L
.59002 .12864 L
.59263 .13133 L
.59524 .13035 L
.59785 .1297 L
.60046 .14634 L
.60307 .14015 L
.60568 .14156 L
.60828 .21293 L
.61089 .24131 L
.6135 .20034 L
.61611 .21618 L
.61872 .2075 L
.62133 .21639 L
.62394 .23936 L
.62655 .25702 L
.62916 .34598 L
.63177 .33823 L
.63438 .38834 L
.63699 .34481 L
.6396 .30205 L
.6422 .28966 L
.64481 .30476 L
.64742 .30683 L
.65003 .32688 L
.65264 .35279 L
.65525 .39112 L
.65786 .38653 L
.66047 .43427 L
.66308 .42402 L
.66569 .41866 L
.6683 .4331 L
.67091 .36827 L
.67352 .33724 L
Mistroke
.67613 .34492 L
.67873 .36315 L
.68134 .32365 L
.68395 .38576 L
.68656 .39918 L
.68917 .44612 L
.69178 .45756 L
.69439 .42224 L
.697 .48206 L
.69961 .52168 L
.70222 .52934 L
.70483 .50172 L
.70744 .50257 L
.71005 .5247 L
.71265 .52507 L
.71526 .50928 L
.71787 .49031 L
.72048 .45948 L
.72309 .48411 L
.7257 .44211 L
.72831 .43504 L
.73092 .4094 L
.73353 .39559 L
.73614 .34361 L
.73875 .36201 L
.74136 .40771 L
.74397 .43406 L
.74658 .4702 L
.74918 .51069 L
.75179 .49142 L
.7544 .46561 L
.75701 .4149 L
.75962 .48859 L
.76223 .4807 L
.76484 .47309 L
.76745 .43472 L
.77006 .42856 L
.77267 .44159 L
.77528 .47967 L
.77789 .49935 L
.7805 .54959 L
.78311 .55757 L
.78571 .551 L
.78832 .55251 L
.79093 .55867 L
.79354 .46791 L
.79615 .44348 L
.79876 .47653 L
.80137 .4954 L
.80398 .51272 L
Mistroke
.80659 .43683 L
.8092 .40356 L
.81181 .40236 L
.81442 .35873 L
.81703 .37654 L
.81963 .37394 L
.82224 .45176 L
.82485 .4257 L
.82746 .47696 L
.83007 .4576 L
.83268 .48783 L
.83529 .44477 L
.8379 .42126 L
.84051 .39667 L
.84312 .40238 L
.84573 .34551 L
.84834 .34582 L
.85095 .28125 L
.85356 .29961 L
.85616 .35227 L
.85877 .30179 L
.86138 .29305 L
.86399 .34327 L
.8666 .39757 L
.86921 .44591 L
.87182 .49337 L
.87443 .52143 L
.87704 .45873 L
.87965 .42665 L
.88226 .49956 L
.88487 .45578 L
.88748 .41226 L
.89008 .39645 L
.89269 .42455 L
.8953 .44235 L
.89791 .40985 L
.90052 .37045 L
.90313 .37886 L
.90574 .35518 L
.90835 .36367 L
.91096 .33247 L
.91357 .33712 L
.91618 .34544 L
.91879 .31478 L
.9214 .3422 L
.92401 .34804 L
.92661 .36478 L
.92922 .3161 L
.93183 .30281 L
.93444 .32487 L
Mistroke
.93705 .32773 L
.93966 .30643 L
.94227 .30187 L
.94488 .29278 L
.94749 .34594 L
.9501 .26874 L
.95271 .30065 L
.95532 .29637 L
.95793 .30465 L
.96053 .35198 L
.96314 .36135 L
.96575 .37818 L
.96836 .34884 L
.97097 .32231 L
.97358 .34339 L
.97619 .33497 L
Mfstroke
0 .98 .604 r
gsave
.97619 .32461 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24419 m
.02642 .22584 L
.02903 .2183 L
.03164 .21256 L
.03425 .20775 L
.03686 .20355 L
.03947 .19977 L
.04207 .2908 L
.04468 .27257 L
.04729 .26507 L
.0499 .25937 L
.05251 .2546 L
.05512 .25042 L
.05773 .24666 L
.06034 .3238 L
.06295 .30565 L
.06556 .29819 L
.06817 .29251 L
.07078 .28777 L
.07339 .28361 L
.07599 .27987 L
.0786 .33196 L
.08121 .31382 L
.08382 .30637 L
.08643 .3007 L
.08904 .29595 L
.09165 .2918 L
.09426 .28806 L
.09687 .37847 L
.09948 .36046 L
.10209 .35306 L
.1047 .34743 L
.10731 .34272 L
.10992 .33859 L
.11252 .33488 L
.11513 .396 L
.11774 .37804 L
.12035 .37065 L
.12296 .36504 L
.12557 .36034 L
.12818 .35622 L
.13079 .35252 L
.1334 .40208 L
.13601 .38412 L
.13862 .37674 L
.14123 .37112 L
.14384 .36642 L
.14644 .36231 L
.14905 .35861 L
.15166 .33714 L
Mistroke
.15427 .31896 L
.15688 .31148 L
.15949 .30579 L
.1621 .30103 L
.16471 .29686 L
.16732 .29311 L
.16993 .33595 L
.17254 .31775 L
.17515 .31027 L
.17776 .30458 L
.18037 .29981 L
.18297 .29564 L
.18558 .29188 L
.18819 .3127 L
.1908 .29442 L
.19341 .2869 L
.19602 .28118 L
.19863 .27639 L
.20124 .27219 L
.20385 .26842 L
.20646 .25162 L
.20907 .23312 L
.21168 .22551 L
.21429 .21972 L
.21689 .21487 L
.2195 .21062 L
.22211 .2068 L
.22472 .26002 L
.22733 .24155 L
.22994 .23395 L
.23255 .22816 L
.23516 .22332 L
.23777 .21908 L
.24038 .21526 L
.24299 .25733 L
.2456 .23884 L
.24821 .23124 L
.25082 .22545 L
.25342 .2206 L
.25603 .21635 L
.25864 .21253 L
.26125 .26265 L
.26386 .24418 L
.26647 .23658 L
.26908 .23079 L
.27169 .22595 L
.2743 .22171 L
.27691 .21789 L
.27952 .24036 L
.28213 .22181 L
Mistroke
.28474 .21417 L
.28735 .20836 L
.28995 .20349 L
.29256 .19923 L
.29517 .19539 L
.29778 .23954 L
.30039 .22098 L
.303 .21334 L
.30561 .20752 L
.30822 .20265 L
.31083 .19839 L
.31344 .19455 L
.31605 .27129 L
.31866 .25285 L
.32127 .24526 L
.32387 .23948 L
.32648 .23464 L
.32909 .2304 L
.3317 .22659 L
.33431 .27634 L
.33692 .25792 L
.33953 .25033 L
.34214 .24456 L
.34475 .23972 L
.34736 .23549 L
.34997 .23168 L
.35258 .31392 L
.35519 .29563 L
.3578 .28811 L
.3604 .28238 L
.36301 .27759 L
.36562 .27338 L
.36823 .26961 L
.37084 .31028 L
.37345 .29197 L
.37606 .28444 L
.37867 .2787 L
.38128 .2739 L
.38389 .26969 L
.3865 .26591 L
.38911 .24351 L
.39172 .22493 L
.39432 .21728 L
.39693 .21145 L
.39954 .20657 L
.40215 .2023 L
.40476 .19846 L
.40737 .24197 L
.40998 .22337 L
.41259 .21572 L
Mistroke
.4152 .20989 L
.41781 .20501 L
.42042 .20074 L
.42303 .19689 L
.42564 .26189 L
.42825 .24337 L
.43085 .23575 L
.43346 .22995 L
.43607 .22509 L
.43868 .22083 L
.44129 .217 L
.4439 .23442 L
.44651 .21579 L
.44912 .20812 L
.45173 .20228 L
.45434 .19739 L
.45695 .1931 L
.45956 .18925 L
.46217 .23869 L
.46477 .22008 L
.46738 .21241 L
.46999 .20658 L
.4726 .20169 L
.47521 .19741 L
.47782 .19356 L
.48043 .29738 L
.48304 .27901 L
.48565 .27145 L
.48826 .26569 L
.49087 .26087 L
.49348 .25665 L
.49609 .25285 L
.4987 .29302 L
.5013 .27462 L
.50391 .26705 L
.50652 .26129 L
.50913 .25646 L
.51174 .25223 L
.51435 .24842 L
.51696 .30774 L
.51957 .2894 L
.52218 .28185 L
.52479 .2761 L
.5274 .27129 L
.53001 .26707 L
.53262 .26328 L
.53523 .24733 L
.53783 .22873 L
.54044 .22106 L
.54305 .21523 L
Mistroke
.54566 .21034 L
.54827 .20606 L
.55088 .20221 L
.55349 .19666 L
.5561 .17783 L
.55871 .17008 L
.56132 .16417 L
.56393 .15922 L
.56654 .15489 L
.56915 .15099 L
.57175 .06181 L
.57436 .04241 L
.57697 .03442 L
.57958 .02832 L
.58219 .02322 L
.5848 .01874 L
.58741 .01472 L
.59002 .12854 L
.59263 .10943 L
.59524 .10156 L
.59785 .09556 L
.60046 .09053 L
.60307 .08613 L
.60568 .08217 L
.60828 .2127 L
.61089 .19397 L
.6135 .18625 L
.61611 .18037 L
.61872 .17544 L
.62133 .17113 L
.62394 .16725 L
.62655 .25682 L
.62916 .23827 L
.63177 .23063 L
.63438 .22482 L
.63699 .21995 L
.6396 .21568 L
.6422 .21184 L
.64481 .30434 L
.64742 .286 L
.65003 .27845 L
.65264 .2727 L
.65525 .26789 L
.65786 .26367 L
.66047 .25988 L
.66308 .42367 L
.66569 .40586 L
.6683 .39854 L
.67091 .39296 L
.67352 .3883 L
Mistroke
.67613 .38421 L
.67873 .38053 L
.68134 .32344 L
.68395 .30515 L
.68656 .29762 L
.68917 .29189 L
.69178 .28708 L
.69439 .28288 L
.697 .27909 L
.69961 .52176 L
.70222 .50437 L
.70483 .49722 L
.70744 .49178 L
.71005 .48722 L
.71265 .48324 L
.71526 .47965 L
.71787 .49025 L
.72048 .47268 L
.72309 .46545 L
.7257 .45995 L
.72831 .45535 L
.73092 .45132 L
.73353 .44769 L
.73614 .34322 L
.73875 .32492 L
.74136 .31739 L
.74397 .31165 L
.74658 .30685 L
.74918 .30264 L
.75179 .29885 L
.7544 .46533 L
.75701 .44759 L
.75962 .44029 L
.76223 .43473 L
.76484 .43008 L
.76745 .42601 L
.77006 .42235 L
.77267 .44162 L
.77528 .42374 L
.77789 .41639 L
.7805 .41079 L
.78311 .4061 L
.78571 .402 L
.78832 .3983 L
.79093 .55846 L
.79354 .54113 L
.79615 .534 L
.79876 .52858 L
.80137 .52404 L
.80398 .52007 L
Mistroke
.80659 .5165 L
.8092 .40329 L
.81181 .38516 L
.81442 .37769 L
.81703 .37201 L
.81963 .36726 L
.82224 .36309 L
.82485 .35934 L
.82746 .47697 L
.83007 .45918 L
.83268 .45186 L
.83529 .44629 L
.8379 .44162 L
.84051 .43754 L
.84312 .43387 L
.84573 .34562 L
.84834 .32717 L
.85095 .31957 L
.85356 .31379 L
.85616 .30894 L
.85877 .3047 L
.86138 .30088 L
.86399 .34308 L
.8666 .32461 L
.86921 .31701 L
.87182 .31122 L
.87443 .30637 L
.87704 .30212 L
.87965 .29829 L
.88226 .49958 L
.88487 .48186 L
.88748 .47456 L
.89008 .46901 L
.89269 .46436 L
.8953 .46029 L
.89791 .45663 L
.90052 .37019 L
.90313 .3518 L
.90574 .34423 L
.90835 .33846 L
.91096 .33363 L
.91357 .3294 L
.91618 .3256 L
.91879 .31442 L
.9214 .29576 L
.92401 .28807 L
.92661 .28221 L
.92922 .27731 L
.93183 .27301 L
.93444 .26914 L
Mistroke
.93705 .3277 L
.93966 .3091 L
.94227 .30144 L
.94488 .2956 L
.94749 .29072 L
.9501 .28643 L
.95271 .28258 L
.95532 .29638 L
.95793 .27763 L
.96053 .2699 L
.96314 .26402 L
.96575 .25909 L
.96836 .25477 L
.97097 .25088 L
.97358 .34314 L
.97619 .32461 L
Mfstroke
gsave
.97619 .36243 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24455 m
.02642 .26334 L
.02903 .27133 L
.03164 .27751 L
.03425 .28276 L
.03686 .2874 L
.03947 .29163 L
.04207 .29116 L
.04468 .30983 L
.04729 .31777 L
.0499 .32391 L
.05251 .32913 L
.05512 .33374 L
.05773 .33794 L
.06034 .32416 L
.06295 .34275 L
.06556 .35065 L
.06817 .35677 L
.07078 .36196 L
.07339 .36656 L
.07599 .37074 L
.0786 .33232 L
.08121 .35089 L
.08382 .35879 L
.08643 .3649 L
.08904 .37008 L
.09165 .37468 L
.09426 .37886 L
.09687 .37882 L
.09948 .39727 L
.10209 .40511 L
.1047 .41118 L
.10731 .41634 L
.10992 .4209 L
.11252 .42505 L
.11513 .39636 L
.11774 .41476 L
.12035 .42259 L
.12296 .42865 L
.12557 .43379 L
.12818 .43834 L
.13079 .44248 L
.1334 .40244 L
.13601 .42083 L
.13862 .42866 L
.14123 .43471 L
.14384 .43985 L
.14644 .4444 L
.14905 .44854 L
.15166 .3375 L
Mistroke
.15427 .35612 L
.15688 .36403 L
.15949 .37015 L
.1621 .37534 L
.16471 .37995 L
.16732 .38413 L
.16993 .33631 L
.17254 .35493 L
.17515 .36285 L
.17776 .36897 L
.18037 .37417 L
.18297 .37877 L
.18558 .38296 L
.18819 .31306 L
.1908 .33177 L
.19341 .33972 L
.19602 .34587 L
.19863 .35109 L
.20124 .35571 L
.20385 .35991 L
.20646 .25198 L
.20907 .2709 L
.21168 .27893 L
.21429 .28515 L
.21689 .29042 L
.2195 .29509 L
.22211 .29934 L
.22472 .26038 L
.22733 .27927 L
.22994 .2873 L
.23255 .2935 L
.23516 .29877 L
.23777 .30343 L
.24038 .30767 L
.24299 .25769 L
.2456 .27659 L
.24821 .28462 L
.25082 .29083 L
.25342 .2961 L
.25603 .30076 L
.25864 .305 L
.26125 .26301 L
.26386 .2819 L
.26647 .28992 L
.26908 .29612 L
.27169 .30139 L
.2743 .30605 L
.27691 .31028 L
.27952 .24072 L
.28213 .25969 L
Mistroke
.28474 .26775 L
.28735 .27398 L
.28995 .27926 L
.29256 .28394 L
.29517 .2882 L
.29778 .2399 L
.30039 .25887 L
.303 .26693 L
.30561 .27316 L
.30822 .27844 L
.31083 .28313 L
.31344 .28738 L
.31605 .27165 L
.31866 .29051 L
.32127 .29852 L
.32387 .30471 L
.32648 .30997 L
.32909 .31462 L
.3317 .31885 L
.33431 .2767 L
.33692 .29555 L
.33953 .30355 L
.34214 .30974 L
.34475 .31499 L
.34736 .31964 L
.34997 .32386 L
.35258 .31428 L
.35519 .33299 L
.3578 .34093 L
.3604 .34708 L
.36301 .35229 L
.36562 .35691 L
.36823 .36111 L
.37084 .31064 L
.37345 .32937 L
.37606 .33732 L
.37867 .34347 L
.38128 .34869 L
.38389 .35332 L
.3865 .35752 L
.38911 .24387 L
.39172 .26286 L
.39432 .27093 L
.39693 .27716 L
.39954 .28245 L
.40215 .28713 L
.40476 .29139 L
.40737 .24232 L
.40998 .26133 L
.41259 .26939 L
Mistroke
.4152 .27563 L
.41781 .28092 L
.42042 .2856 L
.42303 .28986 L
.42564 .26225 L
.42825 .28117 L
.43085 .2892 L
.43346 .29542 L
.43607 .30068 L
.43868 .30535 L
.44129 .30959 L
.4439 .23478 L
.44651 .25382 L
.44912 .26189 L
.45173 .26814 L
.45434 .27344 L
.45695 .27813 L
.45956 .28239 L
.46217 .23905 L
.46477 .25807 L
.46738 .26614 L
.46999 .27238 L
.4726 .27767 L
.47521 .28236 L
.47782 .28662 L
.48043 .29774 L
.48304 .31652 L
.48565 .3245 L
.48826 .33067 L
.49087 .3359 L
.49348 .34053 L
.49609 .34474 L
.4987 .29338 L
.5013 .31219 L
.50391 .32017 L
.50652 .32634 L
.50913 .33158 L
.51174 .33622 L
.51435 .34044 L
.51696 .30809 L
.51957 .32684 L
.52218 .3348 L
.52479 .34096 L
.5274 .34618 L
.53001 .35081 L
.53262 .35501 L
.53523 .24769 L
.53783 .2667 L
.54044 .27477 L
.54305 .28101 L
Mistroke
.54566 .2863 L
.54827 .29099 L
.55088 .29524 L
.55349 .19701 L
.5561 .21624 L
.55871 .22439 L
.56132 .2307 L
.56393 .23604 L
.56654 .24078 L
.56915 .24508 L
.57175 .06217 L
.57436 .08195 L
.57697 .09034 L
.57958 .09681 L
.58219 .10231 L
.5848 .10717 L
.58741 .11158 L
.59002 .12889 L
.59263 .14839 L
.59524 .15666 L
.59785 .16305 L
.60046 .16846 L
.60307 .17326 L
.60568 .17762 L
.60828 .21306 L
.61089 .2322 L
.6135 .24032 L
.61611 .2466 L
.61872 .25192 L
.62133 .25663 L
.62394 .26092 L
.62655 .25718 L
.62916 .27613 L
.63177 .28417 L
.63438 .29038 L
.63699 .29566 L
.6396 .30033 L
.6422 .30457 L
.64481 .3047 L
.64742 .32344 L
.65003 .3314 L
.65264 .33755 L
.65525 .34277 L
.65786 .34739 L
.66047 .35159 L
.66308 .42403 L
.66569 .44225 L
.6683 .44999 L
.67091 .45599 L
.67352 .46107 L
Mistroke
.67613 .46557 L
.67873 .46967 L
.68134 .3238 L
.68395 .3425 L
.68656 .35044 L
.68917 .35658 L
.69178 .36179 L
.69439 .3664 L
.697 .37059 L
.69961 .52212 L
.70222 .53994 L
.70483 .54752 L
.70744 .55338 L
.71005 .55836 L
.71265 .56277 L
.71526 .56678 L
.71787 .49061 L
.72048 .5086 L
.72309 .51625 L
.7257 .52216 L
.72831 .52719 L
.73092 .53164 L
.73353 .53568 L
.73614 .34358 L
.73875 .36229 L
.74136 .37023 L
.74397 .37637 L
.74658 .38158 L
.74918 .38619 L
.75179 .39039 L
.7544 .46569 L
.75701 .48384 L
.75962 .49156 L
.76223 .49753 L
.76484 .5026 L
.76745 .50709 L
.77006 .51116 L
.77267 .44197 L
.77528 .46026 L
.77789 .46803 L
.7805 .47404 L
.78311 .47914 L
.78571 .48366 L
.78832 .48777 L
.79093 .55882 L
.79354 .57657 L
.79615 .58412 L
.79876 .58997 L
.80137 .59493 L
.80398 .59932 L
Mistroke
.80659 .60332 L
.8092 .40364 L
.81181 .42218 L
.81442 .43005 L
.81703 .43614 L
.81963 .4413 L
.82224 .44588 L
.82485 .45003 L
.82746 .47732 L
.83007 .49553 L
.83268 .50326 L
.83529 .50924 L
.8379 .51432 L
.84051 .51882 L
.84312 .52291 L
.84573 .34598 L
.84834 .36482 L
.85095 .37282 L
.85356 .37901 L
.85616 .38425 L
.85877 .3889 L
.86138 .39312 L
.86399 .34344 L
.8666 .3623 L
.86921 .37031 L
.87182 .3765 L
.87443 .38175 L
.87704 .3864 L
.87965 .39062 L
.88226 .49994 L
.88487 .51808 L
.88748 .5258 L
.89008 .53176 L
.89269 .53682 L
.8953 .54131 L
.89791 .54538 L
.90052 .37055 L
.90313 .38934 L
.90574 .39731 L
.90835 .40348 L
.91096 .40871 L
.91357 .41334 L
.91618 .41755 L
.91879 .31478 L
.9214 .33383 L
.92401 .34192 L
.92661 .34817 L
.92922 .35347 L
.93183 .35816 L
.93444 .36242 L
Mistroke
.93705 .32806 L
.93966 .34705 L
.94227 .35511 L
.94488 .36134 L
.94749 .36663 L
.9501 .37131 L
.95271 .37555 L
.95532 .29674 L
.95793 .31588 L
.96053 .324 L
.96314 .33028 L
.96575 .3356 L
.96836 .34031 L
.97097 .34459 L
.97358 .3435 L
.97619 .36243 L
Mfstroke
0 0 1 r
gsave
.97619 .34352 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24437 m
.02642 .24459 L
.02903 .24481 L
.03164 .24504 L
.03425 .24526 L
.03686 .24548 L
.03947 .2457 L
.04207 .29098 L
.04468 .2912 L
.04729 .29142 L
.0499 .29164 L
.05251 .29186 L
.05512 .29208 L
.05773 .2923 L
.06034 .32398 L
.06295 .3242 L
.06556 .32442 L
.06817 .32464 L
.07078 .32486 L
.07339 .32508 L
.07599 .3253 L
.0786 .33214 L
.08121 .33236 L
.08382 .33258 L
.08643 .3328 L
.08904 .33302 L
.09165 .33324 L
.09426 .33346 L
.09687 .37864 L
.09948 .37887 L
.10209 .37909 L
.1047 .37931 L
.10731 .37953 L
.10992 .37975 L
.11252 .37997 L
.11513 .39618 L
.11774 .3964 L
.12035 .39662 L
.12296 .39684 L
.12557 .39706 L
.12818 .39728 L
.13079 .3975 L
.1334 .40226 L
.13601 .40248 L
.13862 .4027 L
.14123 .40292 L
.14384 .40314 L
.14644 .40336 L
.14905 .40358 L
.15166 .33732 L
Mistroke
.15427 .33754 L
.15688 .33775 L
.15949 .33797 L
.1621 .33819 L
.16471 .3384 L
.16732 .33862 L
.16993 .33613 L
.17254 .33634 L
.17515 .33656 L
.17776 .33677 L
.18037 .33699 L
.18297 .33721 L
.18558 .33742 L
.18819 .31288 L
.1908 .31309 L
.19341 .31331 L
.19602 .31352 L
.19863 .31374 L
.20124 .31395 L
.20385 .31417 L
.20646 .2518 L
.20907 .25201 L
.21168 .25222 L
.21429 .25243 L
.21689 .25264 L
.2195 .25286 L
.22211 .25307 L
.22472 .2602 L
.22733 .26041 L
.22994 .26062 L
.23255 .26083 L
.23516 .26104 L
.23777 .26125 L
.24038 .26146 L
.24299 .25751 L
.2456 .25772 L
.24821 .25793 L
.25082 .25814 L
.25342 .25835 L
.25603 .25856 L
.25864 .25877 L
.26125 .26283 L
.26386 .26304 L
.26647 .26325 L
.26908 .26346 L
.27169 .26367 L
.2743 .26388 L
.27691 .26409 L
.27952 .24054 L
.28213 .24075 L
Mistroke
.28474 .24096 L
.28735 .24117 L
.28995 .24138 L
.29256 .24159 L
.29517 .24179 L
.29778 .23972 L
.30039 .23993 L
.303 .24013 L
.30561 .24034 L
.30822 .24055 L
.31083 .24076 L
.31344 .24096 L
.31605 .27147 L
.31866 .27168 L
.32127 .27189 L
.32387 .27209 L
.32648 .2723 L
.32909 .27251 L
.3317 .27272 L
.33431 .27652 L
.33692 .27673 L
.33953 .27694 L
.34214 .27715 L
.34475 .27736 L
.34736 .27756 L
.34997 .27777 L
.35258 .3141 L
.35519 .31431 L
.3578 .31452 L
.3604 .31473 L
.36301 .31494 L
.36562 .31515 L
.36823 .31536 L
.37084 .31046 L
.37345 .31067 L
.37606 .31088 L
.37867 .31109 L
.38128 .3113 L
.38389 .3115 L
.3865 .31171 L
.38911 .24369 L
.39172 .2439 L
.39432 .2441 L
.39693 .24431 L
.39954 .24451 L
.40215 .24472 L
.40476 .24492 L
.40737 .24215 L
.40998 .24235 L
.41259 .24256 L
Mistroke
.4152 .24276 L
.41781 .24297 L
.42042 .24317 L
.42303 .24337 L
.42564 .26207 L
.42825 .26227 L
.43085 .26248 L
.43346 .26268 L
.43607 .26289 L
.43868 .26309 L
.44129 .2633 L
.4439 .2346 L
.44651 .2348 L
.44912 .23501 L
.45173 .23521 L
.45434 .23541 L
.45695 .23562 L
.45956 .23582 L
.46217 .23887 L
.46477 .23907 L
.46738 .23928 L
.46999 .23948 L
.4726 .23968 L
.47521 .23989 L
.47782 .24009 L
.48043 .29756 L
.48304 .29777 L
.48565 .29797 L
.48826 .29818 L
.49087 .29838 L
.49348 .29859 L
.49609 .2988 L
.4987 .2932 L
.5013 .29341 L
.50391 .29361 L
.50652 .29382 L
.50913 .29402 L
.51174 .29423 L
.51435 .29443 L
.51696 .30791 L
.51957 .30812 L
.52218 .30833 L
.52479 .30853 L
.5274 .30874 L
.53001 .30894 L
.53262 .30915 L
.53523 .24751 L
.53783 .24772 L
.54044 .24792 L
.54305 .24812 L
Mistroke
.54566 .24832 L
.54827 .24852 L
.55088 .24873 L
.55349 .19684 L
.5561 .19703 L
.55871 .19723 L
.56132 .19743 L
.56393 .19763 L
.56654 .19783 L
.56915 .19803 L
.57175 .06199 L
.57436 .06218 L
.57697 .06238 L
.57958 .06257 L
.58219 .06276 L
.5848 .06296 L
.58741 .06315 L
.59002 .12872 L
.59263 .12891 L
.59524 .12911 L
.59785 .1293 L
.60046 .1295 L
.60307 .1297 L
.60568 .12989 L
.60828 .21288 L
.61089 .21308 L
.6135 .21328 L
.61611 .21348 L
.61872 .21368 L
.62133 .21388 L
.62394 .21408 L
.62655 .257 L
.62916 .2572 L
.63177 .2574 L
.63438 .2576 L
.63699 .2578 L
.6396 .25801 L
.6422 .25821 L
.64481 .30452 L
.64742 .30472 L
.65003 .30492 L
.65264 .30513 L
.65525 .30533 L
.65786 .30553 L
.66047 .30574 L
.66308 .42385 L
.66569 .42406 L
.6683 .42427 L
.67091 .42447 L
.67352 .42468 L
Mistroke
.67613 .42489 L
.67873 .4251 L
.68134 .32362 L
.68395 .32383 L
.68656 .32403 L
.68917 .32423 L
.69178 .32444 L
.69439 .32464 L
.697 .32484 L
.69961 .52194 L
.70222 .52215 L
.70483 .52237 L
.70744 .52258 L
.71005 .52279 L
.71265 .523 L
.71526 .52321 L
.71787 .49043 L
.72048 .49064 L
.72309 .49085 L
.7257 .49106 L
.72831 .49127 L
.73092 .49148 L
.73353 .49169 L
.73614 .3434 L
.73875 .34361 L
.74136 .34381 L
.74397 .34401 L
.74658 .34421 L
.74918 .34442 L
.75179 .34462 L
.7544 .46551 L
.75701 .46572 L
.75962 .46592 L
.76223 .46613 L
.76484 .46634 L
.76745 .46655 L
.77006 .46676 L
.77267 .4418 L
.77528 .442 L
.77789 .44221 L
.7805 .44242 L
.78311 .44262 L
.78571 .44283 L
.78832 .44303 L
.79093 .55864 L
.79354 .55885 L
.79615 .55906 L
.79876 .55927 L
.80137 .55949 L
.80398 .5597 L
Mistroke
.80659 .55991 L
.8092 .40346 L
.81181 .40367 L
.81442 .40387 L
.81703 .40408 L
.81963 .40428 L
.82224 .40448 L
.82485 .40469 L
.82746 .47714 L
.83007 .47735 L
.83268 .47756 L
.83529 .47777 L
.8379 .47797 L
.84051 .47818 L
.84312 .47839 L
.84573 .3458 L
.84834 .346 L
.85095 .3462 L
.85356 .3464 L
.85616 .3466 L
.85877 .3468 L
.86138 .347 L
.86399 .34326 L
.8666 .34346 L
.86921 .34366 L
.87182 .34386 L
.87443 .34406 L
.87704 .34426 L
.87965 .34446 L
.88226 .49976 L
.88487 .49997 L
.88748 .50018 L
.89008 .50038 L
.89269 .50059 L
.8953 .5008 L
.89791 .50101 L
.90052 .37037 L
.90313 .37057 L
.90574 .37077 L
.90835 .37097 L
.91096 .37117 L
.91357 .37137 L
.91618 .37157 L
.91879 .3146 L
.9214 .3148 L
.92401 .31499 L
.92661 .31519 L
.92922 .31539 L
.93183 .31558 L
.93444 .31578 L
Mistroke
.93705 .32788 L
.93966 .32808 L
.94227 .32828 L
.94488 .32847 L
.94749 .32867 L
.9501 .32887 L
.95271 .32907 L
.95532 .29656 L
.95793 .29675 L
.96053 .29695 L
.96314 .29715 L
.96575 .29734 L
.96836 .29754 L
.97097 .29773 L
.97358 .34332 L
.97619 .34352 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -0.074953 1.62895 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00649 -24 -4.5 ]
[-0.0125 .00649 0 4.5 ]
[-0.0125 .08794 -18 -4.5 ]
[-0.0125 .08794 0 4.5 ]
[-0.0125 .16939 -24 -4.5 ]
[-0.0125 .16939 0 4.5 ]
[-0.0125 .25084 -18 -4.5 ]
[-0.0125 .25084 0 4.5 ]
[-0.0125 .33228 -24 -4.5 ]
[-0.0125 .33228 0 4.5 ]
[-0.0125 .41373 -18 -4.5 ]
[-0.0125 .41373 0 4.5 ]
[-0.0125 .49518 -24 -4.5 ]
[-0.0125 .49518 0 4.5 ]
[-0.0125 .57663 -18 -4.5 ]
[-0.0125 .57663 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36438 -5 -6 ]
[.97619 .36438 5 6 ]
[.97619 .25354 -5 -6 ]
[.97619 .25354 5 6 ]
[.97619 .47541 -5 -6 ]
[.97619 .47541 5 6 ]
[.97619 .03167 -5 -6 ]
[.97619 .03167 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00649 m
.00625 .00649 L
s
[(0.05)] -0.0125 .00649 1 0 Mshowa
0 .08794 m
.00625 .08794 L
s
[(0.1)] -0.0125 .08794 1 0 Mshowa
0 .16939 m
.00625 .16939 L
s
[(0.15)] -0.0125 .16939 1 0 Mshowa
0 .25084 m
.00625 .25084 L
s
[(0.2)] -0.0125 .25084 1 0 Mshowa
0 .33228 m
.00625 .33228 L
s
[(0.25)] -0.0125 .33228 1 0 Mshowa
0 .41373 m
.00625 .41373 L
s
[(0.3)] -0.0125 .41373 1 0 Mshowa
0 .49518 m
.00625 .49518 L
s
[(0.35)] -0.0125 .49518 1 0 Mshowa
0 .57663 m
.00625 .57663 L
s
[(0.4)] -0.0125 .57663 1 0 Mshowa
.125 Mabswid
0 .02278 m
.00375 .02278 L
s
0 .03907 m
.00375 .03907 L
s
0 .05536 m
.00375 .05536 L
s
0 .07165 m
.00375 .07165 L
s
0 .10423 m
.00375 .10423 L
s
0 .12052 m
.00375 .12052 L
s
0 .13681 m
.00375 .13681 L
s
0 .1531 m
.00375 .1531 L
s
0 .18568 m
.00375 .18568 L
s
0 .20197 m
.00375 .20197 L
s
0 .21826 m
.00375 .21826 L
s
0 .23455 m
.00375 .23455 L
s
0 .26713 m
.00375 .26713 L
s
0 .28342 m
.00375 .28342 L
s
0 .29971 m
.00375 .29971 L
s
0 .316 m
.00375 .316 L
s
0 .34857 m
.00375 .34857 L
s
0 .36486 m
.00375 .36486 L
s
0 .38115 m
.00375 .38115 L
s
0 .39744 m
.00375 .39744 L
s
0 .43002 m
.00375 .43002 L
s
0 .44631 m
.00375 .44631 L
s
0 .4626 m
.00375 .4626 L
s
0 .47889 m
.00375 .47889 L
s
0 .51147 m
.00375 .51147 L
s
0 .52776 m
.00375 .52776 L
s
0 .54405 m
.00375 .54405 L
s
0 .56034 m
.00375 .56034 L
s
0 .59292 m
.00375 .59292 L
s
0 .60921 m
.00375 .60921 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00649 m
1 .00649 L
s
.99375 .08794 m
1 .08794 L
s
.99375 .16939 m
1 .16939 L
s
.99375 .25084 m
1 .25084 L
s
.99375 .33228 m
1 .33228 L
s
.99375 .41373 m
1 .41373 L
s
.99375 .49518 m
1 .49518 L
s
.99375 .57663 m
1 .57663 L
s
.125 Mabswid
.99625 .02278 m
1 .02278 L
s
.99625 .03907 m
1 .03907 L
s
.99625 .05536 m
1 .05536 L
s
.99625 .07165 m
1 .07165 L
s
.99625 .10423 m
1 .10423 L
s
.99625 .12052 m
1 .12052 L
s
.99625 .13681 m
1 .13681 L
s
.99625 .1531 m
1 .1531 L
s
.99625 .18568 m
1 .18568 L
s
.99625 .20197 m
1 .20197 L
s
.99625 .21826 m
1 .21826 L
s
.99625 .23455 m
1 .23455 L
s
.99625 .26713 m
1 .26713 L
s
.99625 .28342 m
1 .28342 L
s
.99625 .29971 m
1 .29971 L
s
.99625 .316 m
1 .316 L
s
.99625 .34857 m
1 .34857 L
s
.99625 .36486 m
1 .36486 L
s
.99625 .38115 m
1 .38115 L
s
.99625 .39744 m
1 .39744 L
s
.99625 .43002 m
1 .43002 L
s
.99625 .44631 m
1 .44631 L
s
.99625 .4626 m
1 .4626 L
s
.99625 .47889 m
1 .47889 L
s
.99625 .51147 m
1 .51147 L
s
.99625 .52776 m
1 .52776 L
s
.99625 .54405 m
1 .54405 L
s
.99625 .56034 m
1 .56034 L
s
.99625 .59292 m
1 .59292 L
s
.99625 .60921 m
1 .60921 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .36438 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .25084 m
.02642 .25724 L
.02903 .25082 L
.03164 .27099 L
.03425 .28911 L
.03686 .2771 L
.03947 .25711 L
.04207 .25935 L
.04468 .27835 L
.04729 .30717 L
.0499 .30344 L
.05251 .30394 L
.05512 .3499 L
.05773 .38146 L
.06034 .3849 L
.06295 .38134 L
.06556 .3586 L
.06817 .3524 L
.07078 .3678 L
.07339 .34113 L
.07599 .34853 L
.0786 .34489 L
.08121 .32358 L
.08382 .32644 L
.08643 .31263 L
.08904 .32627 L
.09165 .31896 L
.09426 .29831 L
.09687 .28409 L
.09948 .24862 L
.10209 .24795 L
.1047 .22298 L
.10731 .2302 L
.10992 .24633 L
.11252 .23212 L
.11513 .23113 L
.11774 .22281 L
.12035 .22056 L
.12296 .2327 L
.12557 .23811 L
.12818 .24018 L
.13079 .2675 L
.1334 .26103 L
.13601 .27238 L
.13862 .27096 L
.14123 .25194 L
.14384 .2749 L
.14644 .31237 L
.14905 .30557 L
.15166 .29669 L
Mistroke
.15427 .27818 L
.15688 .29279 L
.15949 .28216 L
.1621 .29127 L
.16471 .27347 L
.16732 .26476 L
.16993 .2898 L
.17254 .28546 L
.17515 .27288 L
.17776 .29433 L
.18037 .25423 L
.18297 .2346 L
.18558 .22944 L
.18819 .20214 L
.1908 .18425 L
.19341 .21034 L
.19602 .19633 L
.19863 .22268 L
.20124 .20808 L
.20385 .22487 L
.20646 .21911 L
.20907 .21343 L
.21168 .22696 L
.21429 .2089 L
.21689 .23266 L
.2195 .23958 L
.22211 .22259 L
.22472 .25291 L
.22733 .21606 L
.22994 .21385 L
.23255 .22737 L
.23516 .2324 L
.23777 .2531 L
.24038 .23705 L
.24299 .21812 L
.2456 .20973 L
.24821 .21477 L
.25082 .2117 L
.25342 .20594 L
.25603 .21968 L
.25864 .21371 L
.26125 .23484 L
.26386 .23798 L
.26647 .23754 L
.26908 .2654 L
.27169 .25618 L
.2743 .25625 L
.27691 .26493 L
.27952 .25894 L
.28213 .28129 L
Mistroke
.28474 .28128 L
.28735 .26654 L
.28995 .25226 L
.29256 .23327 L
.29517 .22811 L
.29778 .21933 L
.30039 .22142 L
.303 .21921 L
.30561 .20858 L
.30822 .21772 L
.31083 .2199 L
.31344 .23447 L
.31605 .22509 L
.31866 .2514 L
.32127 .27223 L
.32387 .25264 L
.32648 .24744 L
.32909 .24163 L
.3317 .26187 L
.33431 .23797 L
.33692 .25954 L
.33953 .26064 L
.34214 .26562 L
.34475 .25722 L
.34736 .24013 L
.34997 .22861 L
.35258 .23117 L
.35519 .26486 L
.3578 .25029 L
.3604 .27417 L
.36301 .27752 L
.36562 .26467 L
.36823 .23972 L
.37084 .26835 L
.37345 .2847 L
.37606 .28273 L
.37867 .27904 L
.38128 .27604 L
.38389 .26233 L
.3865 .24529 L
.38911 .25019 L
.39172 .27543 L
.39432 .30082 L
.39693 .29283 L
.39954 .28919 L
.40215 .29176 L
.40476 .30808 L
.40737 .28119 L
.40998 .2746 L
.41259 .26598 L
Mistroke
.4152 .27268 L
.41781 .28552 L
.42042 .25965 L
.42303 .2543 L
.42564 .28102 L
.42825 .26151 L
.43085 .28142 L
.43346 .29652 L
.43607 .32485 L
.43868 .30609 L
.44129 .32861 L
.4439 .36363 L
.44651 .37952 L
.44912 .38073 L
.45173 .37849 L
.45434 .36618 L
.45695 .37194 L
.45956 .40246 L
.46217 .41556 L
.46477 .41274 L
.46738 .43949 L
.46999 .4166 L
.4726 .42165 L
.47521 .41592 L
.47782 .41649 L
.48043 .45223 L
.48304 .45328 L
.48565 .46121 L
.48826 .46551 L
.49087 .45375 L
.49348 .48446 L
.49609 .44613 L
.4987 .3992 L
.5013 .41066 L
.50391 .40468 L
.50652 .39417 L
.50913 .3794 L
.51174 .39076 L
.51435 .41533 L
.51696 .40413 L
.51957 .42054 L
.52218 .37924 L
.52479 .38832 L
.5274 .42897 L
.53001 .42988 L
.53262 .44762 L
.53523 .45379 L
.53783 .47617 L
.54044 .48872 L
.54305 .49079 L
Mistroke
.54566 .46149 L
.54827 .46016 L
.55088 .47962 L
.55349 .49612 L
.5561 .52446 L
.55871 .53249 L
.56132 .53417 L
.56393 .54126 L
.56654 .5152 L
.56915 .50903 L
.57175 .46823 L
.57436 .48262 L
.57697 .50878 L
.57958 .54562 L
.58219 .55349 L
.5848 .53978 L
.58741 .54948 L
.59002 .54432 L
.59263 .55612 L
.59524 .57055 L
.59785 .55817 L
.60046 .54109 L
.60307 .53689 L
.60568 .50474 L
.60828 .52522 L
.61089 .52124 L
.6135 .54592 L
.61611 .51594 L
.61872 .49109 L
.62133 .47592 L
.62394 .47915 L
.62655 .49279 L
.62916 .48268 L
.63177 .49357 L
.63438 .49872 L
.63699 .51833 L
.6396 .50878 L
.6422 .4955 L
.64481 .51231 L
.64742 .52362 L
.65003 .49084 L
.65264 .51211 L
.65525 .4979 L
.65786 .48435 L
.66047 .49813 L
.66308 .51791 L
.66569 .50784 L
.6683 .53477 L
.67091 .54691 L
.67352 .55538 L
Mistroke
.67613 .54903 L
.67873 .51548 L
.68134 .53222 L
.68395 .51111 L
.68656 .50722 L
.68917 .51543 L
.69178 .48934 L
.69439 .48859 L
.697 .519 L
.69961 .53875 L
.70222 .50632 L
.70483 .49388 L
.70744 .48378 L
.71005 .48763 L
.71265 .47947 L
.71526 .48876 L
.71787 .4663 L
.72048 .45787 L
.72309 .44761 L
.7257 .42952 L
.72831 .44604 L
.73092 .4592 L
.73353 .47856 L
.73614 .48592 L
.73875 .46563 L
.74136 .45411 L
.74397 .44967 L
.74658 .46545 L
.74918 .47778 L
.75179 .48516 L
.7544 .51106 L
.75701 .52181 L
.75962 .53855 L
.76223 .52274 L
.76484 .51627 L
.76745 .48993 L
.77006 .47553 L
.77267 .4862 L
.77528 .52164 L
.77789 .55567 L
.7805 .57645 L
.78311 .54432 L
.78571 .5343 L
.78832 .56562 L
.79093 .56416 L
.79354 .5562 L
.79615 .55186 L
.79876 .54791 L
.80137 .54885 L
.80398 .58081 L
Mistroke
.80659 .58213 L
.8092 .5788 L
.81181 .56206 L
.81442 .59356 L
.81703 .57035 L
.81963 .57079 L
.82224 .58563 L
.82485 .57823 L
.82746 .58879 L
.83007 .58257 L
.83268 .58323 L
.83529 .57978 L
.8379 .57636 L
.84051 .59487 L
.84312 .58231 L
.84573 .58634 L
.84834 .60309 L
.85095 .60332 L
.85356 .5999 L
.85616 .59131 L
.85877 .56305 L
.86138 .58006 L
.86399 .56985 L
.8666 .54464 L
.86921 .53078 L
.87182 .52137 L
.87443 .50458 L
.87704 .49114 L
.87965 .48343 L
.88226 .47816 L
.88487 .46787 L
.88748 .49358 L
.89008 .49042 L
.89269 .51088 L
.8953 .52214 L
.89791 .49374 L
.90052 .49853 L
.90313 .48844 L
.90574 .48064 L
.90835 .49448 L
.91096 .44794 L
.91357 .44889 L
.91618 .43513 L
.91879 .44667 L
.9214 .46367 L
.92401 .4588 L
.92661 .46674 L
.92922 .44359 L
.93183 .43057 L
.93444 .45427 L
Mistroke
.93705 .45963 L
.93966 .43749 L
.94227 .43985 L
.94488 .44998 L
.94749 .44367 L
.9501 .45047 L
.95271 .45253 L
.95532 .42532 L
.95793 .42616 L
.96053 .40789 L
.96314 .42089 L
.96575 .39094 L
.96836 .38662 L
.97097 .37068 L
.97358 .35286 L
.97619 .36438 L
Mfstroke
0 0 1 r
gsave
.97619 .25354 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25084 m
.02642 .25084 L
.02903 .25084 L
.03164 .25084 L
.03425 .25084 L
.03686 .25084 L
.03947 .25084 L
.04207 .24878 L
.04468 .24878 L
.04729 .24879 L
.0499 .24879 L
.05251 .2488 L
.05512 .24881 L
.05773 .24881 L
.06034 .24732 L
.06295 .24733 L
.06556 .24734 L
.06817 .24735 L
.07078 .24736 L
.07339 .24737 L
.07599 .24737 L
.0786 .24706 L
.08121 .24707 L
.08382 .24708 L
.08643 .24709 L
.08904 .2471 L
.09165 .24711 L
.09426 .24712 L
.09687 .24483 L
.09948 .24485 L
.10209 .24486 L
.1047 .24488 L
.10731 .2449 L
.10992 .24491 L
.11252 .24493 L
.11513 .2441 L
.11774 .24412 L
.12035 .24413 L
.12296 .24415 L
.12557 .24417 L
.12818 .24419 L
.13079 .24421 L
.1334 .24398 L
.13601 .244 L
.13862 .24402 L
.14123 .24403 L
.14384 .24405 L
.14644 .24407 L
.14905 .24409 L
.15166 .24783 L
Mistroke
.15427 .24784 L
.15688 .24785 L
.15949 .24785 L
.1621 .24786 L
.16471 .24787 L
.16732 .24788 L
.16993 .24804 L
.17254 .24805 L
.17515 .24806 L
.17776 .24806 L
.18037 .24807 L
.18297 .24808 L
.18558 .24809 L
.18819 .24953 L
.1908 .24953 L
.19341 .24953 L
.19602 .24954 L
.19863 .24954 L
.20124 .24954 L
.20385 .24955 L
.20646 .25323 L
.20907 .25322 L
.21168 .25322 L
.21429 .25321 L
.21689 .25321 L
.2195 .2532 L
.22211 .25319 L
.22472 .25278 L
.22733 .25277 L
.22994 .25276 L
.23255 .25276 L
.23516 .25275 L
.23777 .25275 L
.24038 .25274 L
.24299 .25299 L
.2456 .25299 L
.24821 .25298 L
.25082 .25297 L
.25342 .25297 L
.25603 .25296 L
.25864 .25296 L
.26125 .25271 L
.26386 .25271 L
.26647 .2527 L
.26908 .2527 L
.27169 .25269 L
.2743 .25269 L
.27691 .25268 L
.27952 .25417 L
.28213 .25416 L
Mistroke
.28474 .25415 L
.28735 .25414 L
.28995 .25413 L
.29256 .25412 L
.29517 .25411 L
.29778 .25425 L
.30039 .25424 L
.303 .25423 L
.30561 .25422 L
.30822 .25421 L
.31083 .2542 L
.31344 .25419 L
.31605 .25223 L
.31866 .25223 L
.32127 .25223 L
.32387 .25222 L
.32648 .25222 L
.32909 .25221 L
.3317 .25221 L
.33431 .25197 L
.33692 .25197 L
.33953 .25197 L
.34214 .25196 L
.34475 .25196 L
.34736 .25196 L
.34997 .25195 L
.35258 .24955 L
.35519 .24955 L
.3578 .24955 L
.3604 .24956 L
.36301 .24956 L
.36562 .24956 L
.36823 .24957 L
.37084 .24992 L
.37345 .24992 L
.37606 .24992 L
.37867 .24992 L
.38128 .24993 L
.38389 .24993 L
.3865 .24993 L
.38911 .25462 L
.39172 .25461 L
.39432 .2546 L
.39693 .25459 L
.39954 .25458 L
.40215 .25457 L
.40476 .25456 L
.40737 .25475 L
.40998 .25474 L
.41259 .25473 L
Mistroke
.4152 .25472 L
.41781 .25471 L
.42042 .2547 L
.42303 .25469 L
.42564 .2534 L
.42825 .25339 L
.43085 .25338 L
.43346 .25338 L
.43607 .25337 L
.43868 .25336 L
.44129 .25336 L
.4439 .25538 L
.44651 .25537 L
.44912 .25535 L
.45173 .25534 L
.45434 .25533 L
.45695 .25532 L
.45956 .25531 L
.46217 .25509 L
.46477 .25508 L
.46738 .25507 L
.46999 .25506 L
.4726 .25505 L
.47521 .25503 L
.47782 .25502 L
.48043 .25093 L
.48304 .25093 L
.48565 .25093 L
.48826 .25093 L
.49087 .25093 L
.49348 .25093 L
.49609 .25093 L
.4987 .25135 L
.5013 .25135 L
.50391 .25135 L
.50652 .25135 L
.50913 .25135 L
.51174 .25135 L
.51435 .25135 L
.51696 .25037 L
.51957 .25037 L
.52218 .25037 L
.52479 .25037 L
.5274 .25038 L
.53001 .25038 L
.53262 .25038 L
.53523 .25496 L
.53783 .25495 L
.54044 .25494 L
.54305 .25493 L
Mistroke
.54566 .25492 L
.54827 .25491 L
.55088 .2549 L
.55349 .25872 L
.5561 .2587 L
.55871 .25868 L
.56132 .25866 L
.56393 .25864 L
.56654 .25862 L
.56915 .25859 L
.57175 .26857 L
.57436 .26852 L
.57697 .26847 L
.57958 .26843 L
.58219 .26838 L
.5848 .26833 L
.58741 .26828 L
.59002 .26354 L
.59263 .26351 L
.59524 .26347 L
.59785 .26344 L
.60046 .2634 L
.60307 .26337 L
.60568 .26333 L
.60828 .25723 L
.61089 .25721 L
.6135 .25719 L
.61611 .25718 L
.61872 .25716 L
.62133 .25714 L
.62394 .25712 L
.62655 .25389 L
.62916 .25388 L
.63177 .25388 L
.63438 .25387 L
.63699 .25386 L
.6396 .25385 L
.6422 .25384 L
.64481 .25031 L
.64742 .25031 L
.65003 .25031 L
.65264 .25031 L
.65525 .25031 L
.65786 .25031 L
.66047 .25032 L
.66308 .24115 L
.66569 .24117 L
.6683 .2412 L
.67091 .24122 L
.67352 .24125 L
Mistroke
.67613 .24128 L
.67873 .2413 L
.68134 .24952 L
.68395 .24952 L
.68656 .24952 L
.68917 .24953 L
.69178 .24953 L
.69439 .24954 L
.697 .24954 L
.69961 .23402 L
.70222 .23406 L
.70483 .23411 L
.70744 .23415 L
.71005 .2342 L
.71265 .23425 L
.71526 .23429 L
.71787 .23708 L
.72048 .23712 L
.72309 .23716 L
.7257 .2372 L
.72831 .23723 L
.73092 .23727 L
.73353 .23731 L
.73614 .24965 L
.73875 .24965 L
.74136 .24966 L
.74397 .24966 L
.74658 .24966 L
.74918 .24967 L
.75179 .24967 L
.7544 .24002 L
.75701 .24005 L
.75962 .24008 L
.76223 .24011 L
.76484 .24014 L
.76745 .24016 L
.77006 .24019 L
.77267 .24231 L
.77528 .24233 L
.77789 .24235 L
.7805 .24238 L
.78311 .2424 L
.78571 .24242 L
.78832 .24245 L
.79093 .23294 L
.79354 .23299 L
.79615 .23304 L
.79876 .23308 L
.80137 .23313 L
.80398 .23318 L
Mistroke
.80659 .23323 L
.8092 .24667 L
.81181 .24668 L
.81442 .24669 L
.81703 .24671 L
.81963 .24672 L
.82224 .24673 L
.82485 .24674 L
.82746 .24082 L
.83007 .24084 L
.83268 .24087 L
.83529 .2409 L
.8379 .24093 L
.84051 .24095 L
.84312 .24098 L
.84573 .25216 L
.84834 .25216 L
.85095 .25215 L
.85356 .25215 L
.85616 .25215 L
.85877 .25214 L
.86138 .25214 L
.86399 .25246 L
.8666 .25245 L
.86921 .25245 L
.87182 .25244 L
.87443 .25244 L
.87704 .25243 L
.87965 .25243 L
.88226 .23977 L
.88487 .2398 L
.88748 .23983 L
.89008 .23986 L
.89269 .23989 L
.8953 .23992 L
.89791 .23995 L
.90052 .25113 L
.90313 .25113 L
.90574 .25113 L
.90835 .25113 L
.91096 .25112 L
.91357 .25112 L
.91618 .25112 L
.91879 .25584 L
.9214 .25582 L
.92401 .25581 L
.92661 .2558 L
.92922 .25578 L
.93183 .25577 L
.93444 .25575 L
Mistroke
.93705 .25477 L
.93966 .25476 L
.94227 .25475 L
.94488 .25474 L
.94749 .25473 L
.9501 .25472 L
.95271 .25471 L
.95532 .25738 L
.95793 .25736 L
.96053 .25734 L
.96314 .25733 L
.96575 .25731 L
.96836 .25729 L
.97097 .25727 L
.97358 .25355 L
.97619 .25354 L
Mfstroke
0 .98 .604 r
gsave
.97619 .47541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41373 m
.02642 .41418 L
.02903 .41462 L
.03164 .41506 L
.03425 .4155 L
.03686 .41593 L
.03947 .41636 L
.04207 .41471 L
.04468 .41513 L
.04729 .41556 L
.0499 .41598 L
.05251 .4164 L
.05512 .41681 L
.05773 .41722 L
.06034 .41611 L
.06295 .41652 L
.06556 .41693 L
.06817 .41733 L
.07078 .41773 L
.07339 .41812 L
.07599 .41852 L
.0786 .41856 L
.08121 .41895 L
.08382 .41934 L
.08643 .41972 L
.08904 .4201 L
.09165 .42048 L
.09426 .42085 L
.09687 .41891 L
.09948 .41928 L
.10209 .41965 L
.1047 .42002 L
.10731 .42039 L
.10992 .42075 L
.11252 .42112 L
.11513 .42061 L
.11774 .42097 L
.12035 .42132 L
.12296 .42168 L
.12557 .42203 L
.12818 .42238 L
.13079 .42273 L
.1334 .4228 L
.13601 .42314 L
.13862 .42348 L
.14123 .42382 L
.14384 .42416 L
.14644 .42449 L
.14905 .42482 L
.15166 .42885 L
Mistroke
.15427 .42916 L
.15688 .42948 L
.15949 .42979 L
.1621 .4301 L
.16471 .43041 L
.16732 .43071 L
.16993 .43115 L
.17254 .43145 L
.17515 .43175 L
.17776 .43204 L
.18037 .43234 L
.18297 .43263 L
.18558 .43292 L
.18819 .43462 L
.1908 .4349 L
.19341 .43518 L
.19602 .43546 L
.19863 .43574 L
.20124 .43601 L
.20385 .43628 L
.20646 .44021 L
.20907 .44047 L
.21168 .44073 L
.21429 .44099 L
.21689 .44124 L
.2195 .44149 L
.22211 .44174 L
.22472 .44156 L
.22733 .4418 L
.22994 .44205 L
.23255 .4423 L
.23516 .44254 L
.23777 .44278 L
.24038 .44302 L
.24299 .44349 L
.2456 .44372 L
.24821 .44396 L
.25082 .44419 L
.25342 .44442 L
.25603 .44465 L
.25864 .44488 L
.26125 .44484 L
.26386 .44507 L
.26647 .44529 L
.26908 .44552 L
.27169 .44574 L
.2743 .44596 L
.27691 .44618 L
.27952 .44786 L
.28213 .44807 L
Mistroke
.28474 .44828 L
.28735 .44849 L
.28995 .44869 L
.29256 .4489 L
.29517 .4491 L
.29778 .44943 L
.30039 .44963 L
.303 .44983 L
.30561 .45003 L
.30822 .45022 L
.31083 .45042 L
.31344 .45061 L
.31605 .44883 L
.31866 .44903 L
.32127 .44923 L
.32387 .44942 L
.32648 .44962 L
.32909 .44981 L
.3317 .45 L
.33431 .44993 L
.33692 .45012 L
.33953 .45031 L
.34214 .45049 L
.34475 .45068 L
.34736 .45086 L
.34997 .45105 L
.35258 .4488 L
.35519 .44899 L
.3578 .44917 L
.3604 .44936 L
.36301 .44954 L
.36562 .44973 L
.36823 .44991 L
.37084 .45041 L
.37345 .45059 L
.37606 .45077 L
.37867 .45094 L
.38128 .45112 L
.38389 .45129 L
.3865 .45147 L
.38911 .4563 L
.39172 .45645 L
.39432 .45661 L
.39693 .45677 L
.39954 .45692 L
.40215 .45708 L
.40476 .45723 L
.40737 .45756 L
.40998 .45771 L
.41259 .45786 L
Mistroke
.4152 .45801 L
.41781 .45816 L
.42042 .45831 L
.42303 .45845 L
.42564 .45729 L
.42825 .45744 L
.43085 .45759 L
.43346 .45773 L
.43607 .45788 L
.43868 .45802 L
.44129 .45816 L
.4439 .46031 L
.44651 .46044 L
.44912 .46058 L
.45173 .46071 L
.45434 .46085 L
.45695 .46098 L
.45956 .46111 L
.46217 .46101 L
.46477 .46114 L
.46738 .46127 L
.46999 .4614 L
.4726 .46153 L
.47521 .46166 L
.47782 .46179 L
.48043 .4578 L
.48304 .45794 L
.48565 .45807 L
.48826 .45821 L
.49087 .45834 L
.49348 .45848 L
.49609 .45861 L
.4987 .45913 L
.5013 .45926 L
.50391 .45939 L
.50652 .45952 L
.50913 .45965 L
.51174 .45977 L
.51435 .4599 L
.51696 .45902 L
.51957 .45915 L
.52218 .45927 L
.52479 .4594 L
.5274 .45952 L
.53001 .45965 L
.53262 .45977 L
.53523 .46445 L
.53783 .46455 L
.54044 .46466 L
.54305 .46477 L
Mistroke
.54566 .46488 L
.54827 .46499 L
.55088 .46509 L
.55349 .469 L
.5561 .4691 L
.55871 .46919 L
.56132 .46928 L
.56393 .46938 L
.56654 .46947 L
.56915 .46956 L
.57175 .47962 L
.57436 .47968 L
.57697 .47974 L
.57958 .4798 L
.58219 .47987 L
.5848 .47993 L
.58741 .47999 L
.59002 .47532 L
.59263 .47539 L
.59524 .47546 L
.59785 .47554 L
.60046 .47561 L
.60307 .47568 L
.60568 .47575 L
.60828 .46971 L
.61089 .46979 L
.6135 .46988 L
.61611 .46996 L
.61872 .47005 L
.62133 .47013 L
.62394 .47021 L
.62655 .46705 L
.62916 .46714 L
.63177 .46723 L
.63438 .46732 L
.63699 .46741 L
.6396 .46749 L
.6422 .46758 L
.64481 .46411 L
.64742 .4642 L
.65003 .4643 L
.65264 .4644 L
.65525 .46449 L
.65786 .46459 L
.66047 .46468 L
.66308 .45557 L
.66569 .45568 L
.6683 .4558 L
.67091 .45592 L
.67352 .45603 L
Mistroke
.67613 .45615 L
.67873 .45626 L
.68134 .46453 L
.68395 .46462 L
.68656 .46471 L
.68917 .4648 L
.69178 .46489 L
.69439 .46498 L
.697 .46507 L
.69961 .4496 L
.70222 .44973 L
.70483 .44986 L
.70744 .44999 L
.71005 .45012 L
.71265 .45025 L
.71526 .45037 L
.71787 .45321 L
.72048 .45333 L
.72309 .45345 L
.7257 .45357 L
.72831 .45369 L
.73092 .4538 L
.73353 .45392 L
.73614 .4663 L
.73875 .46639 L
.74136 .46647 L
.74397 .46655 L
.74658 .46663 L
.74918 .46671 L
.75179 .46679 L
.7544 .45717 L
.75701 .45728 L
.75962 .45738 L
.76223 .45749 L
.76484 .45759 L
.76745 .45769 L
.77006 .4578 L
.77267 .45995 L
.77528 .46004 L
.77789 .46014 L
.7805 .46023 L
.78311 .46033 L
.78571 .46042 L
.78832 .46052 L
.79093 .45104 L
.79354 .45116 L
.79615 .45128 L
.79876 .4514 L
.80137 .45151 L
.80398 .45163 L
Mistroke
.80659 .45175 L
.8092 .46522 L
.81181 .4653 L
.81442 .46538 L
.81703 .46545 L
.81963 .46553 L
.82224 .46561 L
.82485 .46568 L
.82746 .45979 L
.83007 .45988 L
.83268 .45997 L
.83529 .46006 L
.8379 .46016 L
.84051 .46025 L
.84312 .46034 L
.84573 .47154 L
.84834 .4716 L
.85095 .47166 L
.85356 .47172 L
.85616 .47178 L
.85877 .47183 L
.86138 .47189 L
.86399 .47223 L
.8666 .47229 L
.86921 .47234 L
.87182 .4724 L
.87443 .47245 L
.87704 .47251 L
.87965 .47256 L
.88226 .45992 L
.88487 .46001 L
.88748 .4601 L
.89008 .46019 L
.89269 .46028 L
.8953 .46036 L
.89791 .46045 L
.90052 .47164 L
.90313 .4717 L
.90574 .47175 L
.90835 .47181 L
.91096 .47186 L
.91357 .47191 L
.91618 .47197 L
.91879 .4767 L
.9214 .47674 L
.92401 .47678 L
.92661 .47682 L
.92922 .47686 L
.93183 .4769 L
.93444 .47694 L
Mistroke
.93705 .47597 L
.93966 .47601 L
.94227 .47605 L
.94488 .47609 L
.94749 .47613 L
.9501 .47617 L
.95271 .47621 L
.95532 .47889 L
.95793 .47893 L
.96053 .47896 L
.96314 .47899 L
.96575 .47902 L
.96836 .47905 L
.97097 .47909 L
.97358 .47537 L
.97619 .47541 L
Mfstroke
gsave
.97619 .03167 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .08794 m
.02642 .0875 L
.02903 .08705 L
.03164 .08661 L
.03425 .08618 L
.03686 .08575 L
.03947 .08532 L
.04207 .08285 L
.04468 .08243 L
.04729 .08202 L
.0499 .08161 L
.05251 .0812 L
.05512 .0808 L
.05773 .0804 L
.06034 .07852 L
.06295 .07813 L
.06556 .07775 L
.06817 .07736 L
.07078 .07698 L
.07339 .07661 L
.07599 .07623 L
.0786 .07555 L
.08121 .07518 L
.08382 .07482 L
.08643 .07445 L
.08904 .0741 L
.09165 .07374 L
.09426 .07339 L
.09687 .07075 L
.09948 .07041 L
.10209 .07007 L
.1047 .06974 L
.10731 .0694 L
.10992 .06907 L
.11252 .06874 L
.11513 .06759 L
.11774 .06726 L
.12035 .06694 L
.12296 .06663 L
.12557 .06631 L
.12818 .066 L
.13079 .06569 L
.1334 .06515 L
.13601 .06485 L
.13862 .06455 L
.14123 .06425 L
.14384 .06395 L
.14644 .06365 L
.14905 .06336 L
.15166 .06681 L
Mistroke
.15427 .06651 L
.15688 .06621 L
.15949 .06592 L
.1621 .06563 L
.16471 .06533 L
.16732 .06505 L
.16993 .06493 L
.17254 .06465 L
.17515 .06437 L
.17776 .06408 L
.18037 .06381 L
.18297 .06353 L
.18558 .06325 L
.18819 .06443 L
.1908 .06416 L
.19341 .06389 L
.19602 .06361 L
.19863 .06334 L
.20124 .06308 L
.20385 .06281 L
.20646 .06625 L
.20907 .06598 L
.21168 .06571 L
.21429 .06544 L
.21689 .06517 L
.2195 .06491 L
.22211 .06464 L
.22472 .06399 L
.22733 .06374 L
.22994 .06348 L
.23255 .06322 L
.23516 .06297 L
.23777 .06272 L
.24038 .06247 L
.24299 .06249 L
.2456 .06225 L
.24821 .062 L
.25082 .06176 L
.25342 .06151 L
.25603 .06127 L
.25864 .06103 L
.26125 .06058 L
.26386 .06035 L
.26647 .06011 L
.26908 .05988 L
.27169 .05965 L
.2743 .05942 L
.27691 .05919 L
.27952 .06047 L
.28213 .06024 L
Mistroke
.28474 .06002 L
.28735 .05979 L
.28995 .05956 L
.29256 .05934 L
.29517 .05912 L
.29778 .05907 L
.30039 .05885 L
.303 .05863 L
.30561 .05841 L
.30822 .0582 L
.31083 .05798 L
.31344 .05777 L
.31605 .05563 L
.31866 .05543 L
.32127 .05522 L
.32387 .05502 L
.32648 .05482 L
.32909 .05462 L
.3317 .05442 L
.33431 .05402 L
.33692 .05382 L
.33953 .05362 L
.34214 .05343 L
.34475 .05324 L
.34736 .05305 L
.34997 .05286 L
.35258 .05029 L
.35519 .05011 L
.3578 .04993 L
.3604 .04975 L
.36301 .04958 L
.36562 .0494 L
.36823 .04922 L
.37084 .04943 L
.37345 .04925 L
.37606 .04908 L
.37867 .04891 L
.38128 .04874 L
.38389 .04857 L
.3865 .0484 L
.38911 .05294 L
.39172 .05277 L
.39432 .05259 L
.39693 .05241 L
.39954 .05223 L
.40215 .05206 L
.40476 .05188 L
.40737 .05194 L
.40998 .05177 L
.41259 .0516 L
Mistroke
.4152 .05143 L
.41781 .05126 L
.42042 .05109 L
.42303 .05092 L
.42564 .04951 L
.42825 .04935 L
.43085 .04918 L
.43346 .04902 L
.43607 .04886 L
.43868 .04871 L
.44129 .04855 L
.4439 .05045 L
.44651 .05029 L
.44912 .05013 L
.45173 .04997 L
.45434 .04981 L
.45695 .04966 L
.45956 .0495 L
.46217 .04917 L
.46477 .04902 L
.46738 .04887 L
.46999 .04871 L
.4726 .04856 L
.47521 .04841 L
.47782 .04826 L
.48043 .04406 L
.48304 .04393 L
.48565 .04379 L
.48826 .04366 L
.49087 .04352 L
.49348 .04339 L
.49609 .04325 L
.4987 .04358 L
.5013 .04344 L
.50391 .04331 L
.50652 .04318 L
.50913 .04305 L
.51174 .04292 L
.51435 .04279 L
.51696 .04172 L
.51957 .0416 L
.52218 .04147 L
.52479 .04135 L
.5274 .04123 L
.53001 .04111 L
.53262 .04099 L
.53523 .04548 L
.53783 .04535 L
.54044 .04522 L
.54305 .04509 L
Mistroke
.54566 .04496 L
.54827 .04483 L
.55088 .0447 L
.55349 .04844 L
.5561 .04831 L
.55871 .04817 L
.56132 .04803 L
.56393 .0479 L
.56654 .04776 L
.56915 .04763 L
.57175 .05753 L
.57436 .05737 L
.57697 .05721 L
.57958 .05705 L
.58219 .05689 L
.5848 .05673 L
.58741 .05658 L
.59002 .05176 L
.59263 .05162 L
.59524 .05148 L
.59785 .05134 L
.60046 .0512 L
.60307 .05106 L
.60568 .05092 L
.60828 .04475 L
.61089 .04463 L
.6135 .04451 L
.61611 .04439 L
.61872 .04427 L
.62133 .04415 L
.62394 .04403 L
.62655 .04074 L
.62916 .04063 L
.63177 .04052 L
.63438 .04042 L
.63699 .04031 L
.6396 .04021 L
.6422 .0401 L
.64481 .03651 L
.64742 .03641 L
.65003 .03632 L
.65264 .03623 L
.65525 .03614 L
.65786 .03604 L
.66047 .03595 L
.66308 .02673 L
.66569 .02666 L
.6683 .0266 L
.67091 .02653 L
.67352 .02647 L
Mistroke
.67613 .02641 L
.67873 .02634 L
.68134 .0345 L
.68395 .03442 L
.68656 .03434 L
.68917 .03425 L
.69178 .03417 L
.69439 .03409 L
.697 .03401 L
.69961 .01843 L
.70222 .01839 L
.70483 .01836 L
.70744 .01832 L
.71005 .01828 L
.71265 .01824 L
.71526 .01821 L
.71787 .02095 L
.72048 .02091 L
.72309 .02087 L
.7257 .02082 L
.72831 .02078 L
.73092 .02074 L
.73353 .0207 L
.73614 .033 L
.73875 .03292 L
.74136 .03285 L
.74397 .03277 L
.74658 .0327 L
.74918 .03263 L
.75179 .03255 L
.7544 .02286 L
.75701 .02282 L
.75962 .02277 L
.76223 .02272 L
.76484 .02268 L
.76745 .02264 L
.77006 .02259 L
.77267 .02467 L
.77528 .02462 L
.77789 .02457 L
.7805 .02452 L
.78311 .02447 L
.78571 .02443 L
.78832 .02438 L
.79093 .01484 L
.79354 .01482 L
.79615 .01479 L
.79876 .01477 L
.80137 .01475 L
.80398 .01473 L
Mistroke
.80659 .01472 L
.8092 .02813 L
.81181 .02807 L
.81442 .02801 L
.81703 .02796 L
.81963 .0279 L
.82224 .02785 L
.82485 .0278 L
.82746 .02184 L
.83007 .02181 L
.83268 .02177 L
.83529 .02173 L
.8379 .0217 L
.84051 .02166 L
.84312 .02162 L
.84573 .03278 L
.84834 .03271 L
.85095 .03265 L
.85356 .03258 L
.85616 .03252 L
.85877 .03245 L
.86138 .03239 L
.86399 .03268 L
.8666 .03262 L
.86921 .03255 L
.87182 .03249 L
.87443 .03243 L
.87704 .03236 L
.87965 .0323 L
.88226 .01962 L
.88487 .01959 L
.88748 .01957 L
.89008 .01954 L
.89269 .01951 L
.8953 .01949 L
.89791 .01946 L
.90052 .03061 L
.90313 .03056 L
.90574 .0305 L
.90835 .03045 L
.91096 .03039 L
.91357 .03033 L
.91618 .03028 L
.91879 .03498 L
.9214 .03491 L
.92401 .03484 L
.92661 .03477 L
.92922 .03471 L
.93183 .03464 L
.93444 .03457 L
Mistroke
.93705 .03358 L
.93966 .03351 L
.94227 .03345 L
.94488 .03339 L
.94749 .03333 L
.9501 .03326 L
.95271 .0332 L
.95532 .03586 L
.95793 .0358 L
.96053 .03573 L
.96314 .03566 L
.96575 .03559 L
.96836 .03553 L
.97097 .03546 L
.97358 .03173 L
.97619 .03167 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{759, 234.562},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;g0000jR000`400?l00000o`00003ooooooooo
ooooooWooooo003ooooooooooooonOooool00?oooooooooooooiooooo`00ooooooooooooooWooooo
003ooooooooooooonOooool00?oooooooooooooiooooo`00ooooooooooooooWooooo003ooooooooo
oooonOooool005Cooooo0_l0000Qooooo`?o00001?ooool2o`0001cooooo0ol00004ooooo`;o0000
1?ooool2o`0001Sooooo0ol00003ooooo`?o00001?ooool2o`0001Oooooo1Ol00003ooooo`;o0000
1?ooool2o`0001Oooooo1Ol00002ooooo`?o00001?ooool2o`0001Sooooo0ol00004ooooo`;o0000
1?ooool2o`0001Sooooo0ol00003ooooo`?o00001?ooool2o`0002kooooo0_l0000Rooooo`?o0000
1?ooool2o`0001_ooooo0ol00004ooooo`;o00001?ooool2o`0001Sooooo0ol00003ooooo`?o0000
1?ooool2o`0001Oooooo1Ol00003ooooo`;o00001?ooool2o`0001Oooooo1Ol00002ooooo`?o0000
1?ooool2o`0001Sooooo0ol00004ooooo`;o00001?ooool2o`0001Wooooo0ol00003ooooo`?o0000
1?ooool2o`00043ooooo001Cooooo`04o`000?ooooooooooo`0001oooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0001cooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Sooooo00Go0000oooooooooooooooo
o`000003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05Oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005ooo
ool01_l0003oooooooooool0003oooooo`0000?ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0001Kooooo00Oo0000ooooooooooooooooo`000?oooooo0000
00?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Zooooo`04o`000?oooooo
ooooo`00023ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0001_o
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001Sooooo00Go0000ooooooooooooooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool05Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00005oooool01_l0003oooooooooool0003oooooo`0000?ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Dooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Oooooo00Oo
0000ooooooooooooooooo`000?oooooo000000?ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0mooooo`00Doooool01?l0003oooooooooool0000Sooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00006?ooool00ol0003oooooooooo`05ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006?ooool00ol0003oooooooooo`05
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06?ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0:_ooool01?l0
003oooooooooool0000Tooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00006?ooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00006?ooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool06?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`03ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0?Oooool005?ooooo00Co0000oooooooooooo00008oooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Sooooo00?o0000oooooooo
ool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Oooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
5_ooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Hoooo
o`;o00001_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo02[ooooo00Co0000
oooooooooooo00009?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
01Sooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo01Oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool05_ooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Iooooo`;o00001_ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo03gooooo001Cooooo`04o`000?ooooooooooo`0001oooooo1?l00003ooooo`04o`000?oo
ooooooooo`0001cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001Sooooo00Co0000oooooooooooooooo1?l00003ooooo`04o`000?oooooo
ooooo`0001Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00005_ooool01_l0003ooooooooooooooooo0000ooooo`Co00000ooo
ool01?l0003oooooooooool0000Jooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo000000?o00000oooool01?l0
003oooooooooool0000/ooooo`04o`000?ooooooooooo`00023ooooo1?l00003ooooo`04o`000?oo
ooooooooo`0001_ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001Sooooo00Co0000oooooooooooooooo1?l00003ooooo`04o`000?oooooo
ooooo`0001Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00005_ooool01_l0003ooooooooooooooooo0000ooooo`Co00000ooo
ool01?l0003oooooooooool0000Jooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo000000?o00000oooool01?l0
003oooooooooool0000oooooo`00Doooool01?l0003oooooooooool0000Oooooo`03o`000?oooooo
oooo00Cooooo00Co0000oooooooooooo00006oooool2o`0000Cooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000Gooooo`;o00000oooool00ol0003oooooooooo`04ooooo`04
o`000?ooooooooooo`0001Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00005_ooool01ol0003ooooooooooooooooo0000oooo
ool000001_ooool01?l0003oooooooooool0000Fooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Kooooo00Oo0000oooooooo
ooooooooo`000?oooooo000000Kooooo00Co0000oooooooooooo0000;?ooool01?l0003ooooooooo
ool0000Pooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00006_ooool2o`0000Co
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Gooooo`;o00000oooool0
0ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0001Kooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005_ooool01ol0
003ooooooooooooooooo0000ooooool000001_ooool01?l0003oooooooooool0000Fooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001Oooooo00Oo0000ooooooooooooooooo`000?oooooo000000Kooooo00Co0000oooooooooooo
0000?oooool005Cooooo0_l0000Pooooo`Go00000oooool2o`0001gooooo00?o0000ooooooooool0
0oooool2o`0000Cooooo0_l0000Iooooo`04o`000?ooooooooooooooo`Go00000oooool2o`0001So
oooo0ol00004ooooo`;o00001?ooool2o`0001Sooooo0ol00002ooooo`Go00000oooool2o`0001So
oooo0ol00004ooooo`;o00001?ooool2o`0001Sooooo0ol00002ooooo`Go00000oooool2o`0002ko
oooo0_l0000Qooooo`Go00000oooool2o`0001cooooo00?o0000ooooooooool00oooool2o`0000Co
oooo0_l0000Iooooo`04o`000?ooooooooooooooo`Go00000oooool2o`0001Sooooo0ol00004oooo
o`;o00001?ooool2o`0001Sooooo0ol00002ooooo`Go00000oooool2o`0001Sooooo0ol00004oooo
o`;o00001?ooool2o`0001Wooooo0ol00002ooooo`Go00000oooool2o`00043ooooo003ooooooooo
oooonOooool00?oooooooooooooiooooo`00ooooooooooooooWooooo003ooooooooooooonOooool0
0?ooooooO_ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000?ooooo0ol0003ooooo
ofOooooo001>oooooooo0000;_l000001Ooooooo0000oooooooooooo000000Sooooo00Ko0000oooo
oooooooo0000ooooool00003ooooo`03o`000?oooooooooo00;oooooool0000_o`0003?ooooo001>
ooooo`;o00001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`06o`000?oooooo0000o`000?oooooo0000
0_ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00Go0000oooooooo
ooooooooo`00000cooooo`00C_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02Co
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Co
oooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Co
oooo00?o0000ooooooooool04?ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00Ko
oooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`02ooooo`?o00001?ooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool00ol0
003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo00kooooo0ol0000cooooo`00C_ooool00ol0003o
ooooooooo`3oooooob[ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`06ooooo`05
o`000?ooooooooooo`000?ooool01?l00005ooooo`03o`000?oooooooooo0?oooooo:oooool00ol0
003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`2/ooooo`;o0?ZJNoooool00ol0003o
ooooo`000002ooooo`03o`000?oooooooooo00Kooooo00Ko0000oooooooooooo0000ooooool00008
ooooo`03o`000?oooooooooo0>[ooooo1_l0nYXjooooo`03o`000?oooooooooo037ooooo001>oooo
o`03o`000?oooooooooo0:cooooo0_l0nYYkooooo`03o`000?oooooooooo00;o00002_ooool2o`00
00;ooooo1Ol00004ooooo`03o`000?oooooooooo0=?ooooo0_l0nYXEooooo`Ko0?ZJ>_ooool00ol0
003oooooooooo`0aooooo`00C_ooool2o`000:gooooo0_l0nYYjooooo`;o00006oooool00ol0003o
ooooooooo`3>ooooo`co0?ZJ3oooool3o`3jVP;ooooo0_l0nYXEooooo`Oo0?ZJ7_ooool00ol0003o
ooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`2[ooooo`?o0?ZJNoooool00ol0003ooooo
ooooo`0Iooooo`;o0000coooool<o`3jVPGooooo3?l0nYX3ooooo`?o0?ZJ1?ooool6o`3jVP[ooooo
1ol0nYXLooooo`?o0000<oooool004kooooo00?o0000ooooooooool0Zoooool3o`3jVW_ooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`33ooooo`Oo0?ZJ1?ooool2o`3jVPSooooo0_l0
nYX5ooooo`co0?ZJ1?ooool<o`3jVP[ooooo0_l0nYX3ooooo`?o0?ZJ7Oooool00ol0003ooooooooo
o`0aooooo`00C_ooool00ol0003oooooooooo`2Zooooo`Co0?ZJNoooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo0<?ooooo1ol0nYX4ooooo`;o0?ZJ2?ooool3o`3jVP?ooooo0ol0nYX>
ooooo`Oo0?ZJ0oooool3o`3jVPSooooo0ol0nYX4ooooo`Ko0?ZJ6Oooool00ol0003oooooooooo`0a
ooooo`00C_ooool00ol0003oooooooooo`2Yooooo`Go0?ZJNoooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo0<?ooooo0_l0nYX3ooooo`So0?ZJ2Oooool7o`3jVQ[ooooo3?l0nYX5oooo
o`Ko0?ZJ00?oooooo`3jV_l0nYX02?l0nYX5ooooo`;o0?ZJ1oooool00ol0003oooooooooo`0aoooo
o`00C_ooool2o`000:Sooooo0_l00002o`3jVP03ooooool0nY[o0?ZJ07[ooooo0_l0000Kooooo`03
o`000?oooooooooo0;kooooo1ol0nYX4ooooo`Oo0?ZJ2Oooool7o`3jVQ[ooooo3?l0nYX9oooooaCo
0?ZJ1oooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`2Wooooo`;o0000
0_l0nYX00ooooooo0?ZJo`3jVP1kooooo`03o`000?oooooooooo01Wooooo0_l0002Jooooo`Go0?ZJ
6_ooool=o`3jVT_ooooo0ol0nYX8ooooo`Oo0?ZJ1_ooool3o`0003?ooooo001>ooooo`03o`000?oo
oooooooo0:Oooooo0_l00002o`3jVP03ooooool0nY[o0?ZJ07_ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`2=oooooa7o0?ZJ0oooool3o`3jVPoooooo3?l0nYY[ooooo`03o`000?oo
oooooooo037ooooo000jooooo`?o00000oooool00ol0003oooooooooo`02ooooo`?o00001_ooool0
0ol0003oooooooooo`2Wooooo`;o00000_l0nYX00ooooooo0?ZJo`3jVP1kooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool0SOooool=o`3jVP;ooooo3Ol0nYX:ooooo`Oo0?ZJL?ooool0
0ol0003oooooooooo`0aooooo`00>oooool00ol0003oooooooooo`06ooooo`05o`000?oooooooooo
ooooool000001Oooool00ol0003oooooooooo`2Wooooo`;o00000_l0nYX00ooooooo0?ZJo`3jVP1k
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0I_ooool<o`3jVPOooooo5_l0nYX>
ooooo`co0?ZJ1_ooool6o`3jVWGooooo00?o0000ooooooooool0<Oooool003Sooooo1Ol0000;oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Yoooool2o`0000;o0?ZJ00?oooooo`3j
V_l0nYX0Noooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo05kooooo<?l0nYXDoooo
o`?o0?ZJ0_ooool3o`3jVP?ooooo1ol0nYYfooooo`03o`000?oooooooooo037ooooo000hooooo`04
o`000?ooooooooooo`0000cooooo00?o0000ooooooooool00oooool3o`000:Oooooo00Go0000o`3j
V_l0nY[o0?ZJooooo`02o`3jVWWooooo0ol0000Kooooo`;o0000Foooool=o`3jVP[ooooo2Ol0nYX^
ooooo`So0?ZJN?ooool3o`0003?ooooo000iooooo`03o`000?oooooo000000Sooooo1?l00006oooo
o`03o`000?oooooooooo0:Kooooo0_l00002o`3jVP;ooooo0_l0nYYkooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool0BOoooolFo`3jVTWooooo1ol0nYYkooooo`03o`000?oooooooooo
037ooooo000jooooo`;o00002?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0:Ko
oooo0_l00006o`00og_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Vooooo`Go
0?ZJ1Oooool;o`3jVPCooooo7?l0nY[?ooooo`03o`000?oooooooooo037ooooo000kooooo`03o`00
0?oooooooooo00Kooooo1Ol00005ooooo`03o`000?oooooooooo0:Kooooo0_l00006o`00og_ooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Oooooob_o0?ZJh?ooool00ol0003ooooo
ooooo`0aooooo`00C_ooool00ol0003oooooooooo`2Vooooo`;o00000_l00?l2ooooo`;o003oNooo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo3_l0nYX3ooooo`Oo0?ZJ2Ooo
ool6o`3jV^[ooooo00?o0000ooooooooool0<Oooool004kooooo0_l0002Wooooo`;o00000_l00?l2
ooooo`;o003o00?o0?ZJooooooooool0Moooool2o`0001_ooooo0_l0000Fooooo`_o0?ZJooooool9
ooooo`?o0000<oooool004kooooo00?o0000ooooooooool0Y_ooool2o`0000;o003o00Go0?ZJoooo
ool00?oo003oo`3jVP1jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool03oooool<
o`3jV_oooooo4?ooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`2Voooo
o`;o00000_l00?l01Ol0nY[oooooo`00ool00?oo0?ZJ07[ooooo00?o0000ooooooooool01_ooool2
o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool03?ooool;
o`3jV_oooooo5?ooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`2Voooo
o`;o00000_l00?l01Ol0nY[oooooo`00ool00?oo0?ZJ00?ooooo0_l0nYYeooooo`03o`000?oooooo
oooo00Gooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Wooooo1ol0nY[ooooooa_ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000
ooooooooool0Y_ooool2o`0000;o003o00Go0?ZJooooool00?oo003oo`3jVP02ooooo`?o0?ZJMOoo
ool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool0
1?ooool3o`0000?ooooo2_l0nY[ooooooacooooo0ol0000cooooo`00C_ooool00ol0003ooooooooo
o`2Vooooo`;o00000_l00?l01_l0nY[oooooo`00ool00?oo0?ZJooooo`Co0?ZJMOooool00ol0003o
ooooooooo`05ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`03ooooo`Oo0?ZJoooooolQooooo`03o`000?oooooooooo037ooooo001>ooooo`;o
0000Yoooool2o`0000;o003o00Ko0?ZJooooool00?oo003oo`3jV_ooool4o`3jVWCooooo0_l00007
ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`3oooooob_ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0Y_ooool2
o`0000;o003o0_l0nYX2o`00o`03o`3jV_oooooo0?ZJ00?o0?ZJMOooool00ol0003oooooooooo`05
ooooo`04o`000?ooooooooooo`0000Sooooo0_l00006ooooo`03o`000?oooooooooo0?oooooo:ooo
ool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`2Vooooo`;o00000_l00?l2
o`3jVP?o003o00?oooooo`3jV_l0nYX00_l0nYYeooooo`03o`000?oooooooooo00Kooooo0_l0000:
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0ooooool[ooooo`03o`000?oooooo
oooo037ooooo001>ooooo`03o`000?oooooooooo0:Kooooo0_l00002o`00o`?o0?ZJ0_l00?l5o`3j
VWGooooo00?o0000ooooooooool06Oooool2o`000?oooooo:_ooool3o`0003?ooooo001>ooooo`03
o`000?oooooooooo0:Kooooo0_l00002o`00o`03o`000?l0nY[o0?ZJ00;o003o0_l0nYX00ooooooo
0?ZJo`3jVP1eooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0ooooool[ooooo`03
o`000?oooooooooo037ooooo001>ooooo`;o0000Yoooool01?l0003o0?ZJo`00ool00?l2o`000003
o`3jV_l00?oo003o00;o0?ZJ00?oooooo`3jV_l0nYX0M?ooool2o`0001_ooooo00?o0000oooooooo
ool0ooooool[ooooo`03o`000?oooooooooo037ooooo001>ooooo`03o`000?oooooooooo0:Kooooo
00Co0000o`3jV_l00?oo003o0_ooool01?l0nY[o003oo`00ool0nYX2ooooo`;o0?ZJMOooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo0?oooooo:oooool00ol0003oooooooooo`0aoooo
o`00C_ooool00ol0003oooooooooo`2Vooooo`04o`000?l0nY[o003oo`00o`;ooooo00Co0?ZJo`00
ool00?oo0?ZJ0_ooool2o`3jVWGooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3o
ooooob_ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0YOooool2o`00
0003o`3jV_l00?oo003o00;ooooo00Co0?ZJo`00ool00?oo0?ZJ0_ooool2o`3jVWGooooo00?o0000
ooooooooool06Oooool2o`000?oooooo:_ooool3o`0003?ooooo001>ooooo`03o`000?oooooooooo
0:Gooooo0_l000000ol0nY[o003oo`00o`02ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo0_l0nYYe
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0ooooool[ooooo`03o`000?oooooo
oooo037ooooo001>ooooo`;o0000Y_ooool2o`000003o`3jV_l00?oo003o00?ooooo0_l00?l3oooo
o`;o0?ZJM?ooool2o`0001_ooooo00?o0000ooooooooool0ooooool[ooooo`03o`000?oooooooooo
037ooooo001>ooooo`03o`000?oooooooooo0:Gooooo0_l000000ol0nY[o003oo`00o`03ooooo`Oo
003oMOooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?oooooo:oooool00ol0003o
ooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`2Uooooo`;o00000ol00?l3ooooo`Oo003o
MOooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?oooooo:oooool00ol0003ooooo
ooooo`0aooooo`00=?ooool3o`0000?ooooo00?o0000ooooooooool00_ooool3o`0000?ooooo0ol0
0006ooooo`03o`000?oooooooooo0:Gooooo0_l00002o`00o`04o`3jV_ooooooooooooooo`;o0?ZJ
00?oooooo`000?l000000_l00?meooooo`03o`000?oooooooooo01Wooooo0_l0003oooooob[ooooo
0ol0000cooooo`00=Oooool00ol0003oooooooooo`06ooooo`07o`000?ooooooooooooooool0003o
ooooo`000003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0YOooool2o`0000;o
003o00Co0?ZJoooooooooooooooo0_l0nYX00ooooooo0000o`000002o`00ogGooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3oooooob_ooooo00?o0000ooooooooool0<Oooool003;o
oooo1Ol0000;ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`2Uooooo`;o00000_l00?l01?l0nY[oooooooooooooool3o`3jVP;o00000_l00?meoooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0ooooool[ooooo`03o`000?oooooooooo
037ooooo000booooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`?o0000YOooool2o`0000;o003o00?o0?ZJooooooooool00_ooool2o`3j
VP;o00000_l00?mcooooo`?o00006oooool00ol0003oooooooooo`3oooooob_ooooo00?o0000oooo
ooooool0<Oooool003?ooooo00?o0000ooooool000002?ooool4o`0000;ooooo1?l00006ooooo`03
o`000?oooooooooo09kooooo0_l00005ooooo`;o00000_l00?l00ol0nY[oooooooooo`02ooooo`;o
0?ZJ0_l00002o`00o`03o`3jV_oooooooooo07;ooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`3oooooob_ooooo00?o0000ooooooooool0<Oooool003Cooooo0_l00008ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Nooooo`;o0000
1Oooool2o`0000;o003o00?o0?ZJooooooooool00_ooool2o`3jVP;ooooo0_l00?l00ol0nY[ooooo
ooooo`1booooo`03o`000?oooooooooo01Wooooo0_l0003oooooob[ooooo0ol0000cooooo`00=Ooo
ool00ol0003oooooooooo`06ooooo`Go000000?oooooo`000?l000000ol00005ooooo`03o`000?oo
oooooooo09kooooo0_l00005ooooo`05o`000?l0nY[o003oo`00ool0nYX01?ooool3o`3jVP04oooo
ool00?oo003oo`3jVWCooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3oooooob_o
oooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0W_ooool2o`0000Gooooo
0_l0nYX2o`00o`Kooooo0_l0nYX01?oooooo003oo`00ool0nYYdooooo`03o`000?oooooooooo00;o
00001?ooool00ol0003oooooooooo`02ooooo`?o00000oooool3o`0000Gooooo00?o0000oooooooo
ool0ooooool[ooooo`03o`000?oooooooooo037ooooo001>ooooo`;o0000Woooool2o`0000Gooooo
0_l0nYX2o`00o`Kooooo0ol0nYX2o`00o`03o`3jV_oooooooooo077ooooo0_l000001Ooooooo0000
oooooooooooo000000Wooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0ooooool[ooooo`03o`000?oooooooooo037ooooo001>ooooo`03
o`000?oooooooooo09kooooo0ol00004ooooo`;o0?ZJ0_l00?l7ooooo`;o0?ZJ0_l00?l00ol0nY[o
ooooooooo`02o`3jVW3ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3oooooob_o
oooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0W_ooool3o`0000?ooooo
0ol0nYX2o`00o`Oooooo0_l0nYX2o`00o`03o`3jV_oooooooooo00;o0?ZJL?ooool00ol0003ooooo
o`000002ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`02ooooo`?o0000oooooolYooooo`?o0000<oooool004kooooo00?o0000ooooooooool0W_oo
ool3o`000003ooooool0003o000000;o0?ZJ00?o0000o`00ool00?l01oooool2o`3jVP?o003o0_oo
ool2o`3jVW3ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`07ooooo`04o`000?oo
ooooooooooooo`Co00001Oooool00ol0003oooooooooo`3oooooob_ooooo00?o0000ooooooooool0
<Oooool004kooooo00?o0000ooooooooool0W_ooool3o`000003ooooool0003o0?ZJ00;o0?ZJ00?o
0000o`00ool00?l02?ooool2o`3jVP;o003o00Coooooo`3jV_l0nY[o0?ZJL?ooool00ol0003ooooo
o`000002ooooo`03o`000?oooooooooo00Kooooo0_l00003ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0ooooool[ooooo`03o`000?oooooooooo037ooooo001>ooooo`;o0000Wooo
ool3o`000004ooooool0003o0?ZJo`3jVP;o00000_l00?l9ooooo`03o`3jV_l00?oo003o00Co0?ZJ
Koooool2o`0000;ooooo0_l0000:ooooo`04o`000?ooooooooooooooo`Go00001?ooool00ol0003o
ooooooooo`3oooooob_ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0
W_ooool3o`000004ooooool0003o0?ZJo`3jVP;o00000_l00?l9ooooo`03o`3jV_l00?oo003o00Co
0?ZJL?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03Kooooo0_l0003booooo`03
o`000?oooooooooo037ooooo001>ooooo`03o`000?oooooooooo09kooooo0ol000001?oooooo0000
o`3jV_l0nYX2o`0000;o003o2Oooool00ol0nY[o003oo`00o`04o`3jVW3ooooo00?o0000oooooooo
ool06Oooool2o`0003Oooooo0_l0003`ooooo`?o0000<oooool004kooooo00?o0000ooooooooool0
Q_ooool2o`3jVQKooooo1?l00003o`3jVP;o00000_l00?l9ooooo`05o`3jV_l00?oo003oo`3jV_oo
ool00_l0nYY`ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0=_ooool2o`000?;o
oooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0F_ooool2o`3jVRWooooo
0ol0nYX4ooooo`;o0?ZJ4?ooool4o`0000;o0?ZJ0ol00002o`00o`Wooooo00Go0?ZJo`00ool00?oo
0?ZJooooo`02o`3jVW3ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0fooooo`;o
0000l_ooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`1Eooooo`;o0?ZJ
0oooool2o`3jVQoooooo0_l0nYX8ooooo`?o0?ZJ0oooool3o`3jVQ3ooooo1?l00007o`00o`Wooooo
00Go0?ZJo`00ool00?oo0?ZJooooo`02o`3jVW3ooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`0eooooo`Co0000lOooool00ol0003oooooooooo`0aooooo`00C_ooool2o`0000Wooooo
0_l0nYY:ooooo`?o0?ZJ00?o0000ooooool0nYX00_l0nYXJooooo`;o0?ZJ0_ooool3o`3jVPSooooo
0ol0nYX3ooooo`?o0?ZJ4?ooool4o`0000Oo003o2_ooool2o`00o`04o`3jV_oooooo0?ZJo`3jVVoo
oooo0_l0000Kooooo`03o`000?oooooooooo03Gooooo1?l0003aooooo`03o`000?oooooooooo037o
oooo001>ooooo`03o`000?oooooooooo00Oooooo0ol0nYY9ooooo`Co0?ZJ0_l00003o`3jVQWooooo
0ol0nYX2ooooo`?o0?ZJ1oooool4o`3jVP;ooooo1?l0nYX@ooooo`;o000000Coooooo`000?l00?oo
003o0_l000000ooooooo0?ZJo`3jVP0:ooooo`;o003o00Co0?ZJooooool0nY[o0?ZJL?ooool00ol0
003oooooooooo`0Iooooo`;o0000=_ooool4o`000>oooooo0ol0000cooooo`00C_ooool00ol0003o
ooooooooo`06ooooo`Co0?ZJ=Oooool2o`3jVQ;ooooo1?l0nYX00ol0003o0?ZJo`3jVP02o`3jVQSo
oooo1?l0nYX2ooooo`?o0?ZJ1oooool4o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ4?ooool2o`000004
ooooool0nY[o003oo`00o`;o000000?oooooo`3jV_l0nYX02_ooool2o`00o`04o`3jV_l0003o0?ZJ
o`3jVW3ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0eooooo`Co00003oooool2
o`000>3ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool01_ooool4o`3j
VSCooooo0ol0nYXAooooo`Go0?ZJ00?o0000o`3jV_l0nYX00_l0nYXHooooo`Co0?ZJ00?oooooo`3j
V_l0nYX00_l0nYX5ooooo`03o`000?l0nY[o0?ZJ00?o0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX@
ooooo`;o00000_l0nYX2o`00o`03o`3jV_l0003ooooo00;o0?ZJ2_ooool2o`00o`;o00000_l0nYY`
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0=Oooool6o`0000;ooooo0_l00007
ooooo`Co00003_ooool2o`000=3ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000oooo
ooooool01_ooool4o`3jVSCooooo0ol0nYX9ooooo`;o0?ZJ1_ooool2o`3jVP03ooooool0nY[o0?ZJ
00Go0?ZJ5oooool5o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1Oooool01?l0003o0?ZJo`3jV_ooool5
o`3jVP03ooooool0nY[o0?ZJ013ooooo0_l00002o`3jVP;o003o00?o0?ZJo`000?ooool00_l0nYX:
ooooo`Ko003o00Co0?ZJoooooooooooooooo0_l0nYYZooooo`03o`000?oooooooooo01Wooooo00?o
0000ooooooooool0=Oooool:o`0000;ooooo0_l00003ooooo`Ko00003?ooool2o`000=3ooooo00?o
0000ooooooooool0<Oooool004kooooo0_l00007ooooo`Co0?ZJ<oooool4o`3jVP?ooooo0_l0nYX3
ooooo`?o0?ZJ0oooool2o`3jVP04ooooool0nY[o0?ZJo`0000Co0?ZJ00?o0000o`3jV_l0nYX05_oo
ool3o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ1?ooool4o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00Co
0000ooooool0nY[o0?ZJ4?ooool01?l0003o0?ZJo`3jV_l0nYX2o`00o`03o`3jV_l0003ooooo00;o
0?ZJ2_ooool6o`00o`03o`3jV_oooooooooo00?o0?ZJJOooool2o`0001_ooooo00?o0000oooooooo
ool0=Oooool2o`000003ooooool0003o000000Go00000_ooool2o`0000;ooooo1ol0000;ooooo`Co
0000coooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`05ooooo`Go0?ZJ
<_ooool5o`3jVP;ooooo0ol0nYX2ooooo`Co0?ZJ0oooool5o`3jVP03o`000?l0nY[o0?ZJ00;o0?ZJ
00?o0000o`3jV_l0nYX05_ooool2o`3jVP;ooooo1?l0nYX00ol0003o0?ZJo`3jVP03ooooo`Co0?ZJ
00?o0000ooooooooool00ol0nYX01?l0003oooooo`3jV_l0nYX@ooooo`?o0?ZJ00Coooooo`00ool0
0?oo0?ZJ0_ooool2o`3jVP[ooooo0_l0nYX2o`0000;o003o00?o0?ZJooooool0nYX00ol0nYYZoooo
o`03o`000?oooooooooo01Wooooo0_l0000Qooooo`;o00004_ooool3o`000003ooooool0003o0000
00Go00000_ooool2o`0000;ooooo1ol0000:ooooo`Ko0000c?ooool3o`0003?ooooo001>ooooo`03
o`000?oooooooooo00Gooooo0_l0nYX00ooooooo0?ZJo`3jVP0booooo`;o0?ZJ00?oooooo`3jV_l0
nYX00_ooool3o`3jVP;ooooo1?l0nYX2ooooo`Go0?ZJ0_l00003o`3jVP;o00000_l0nYXFooooo`;o
0?ZJ0_ooool4o`3jVP03o`000?l0nY[o0?ZJ00?ooooo1?l0nYX00ol0003oooooo`000003o`3jVP04
o`000?oooooo0?ZJo`3jVQ3ooooo0_l0nYX2ooooo`;o003o0_l0nYX00ooooooo0?ZJo`3jVP0:oooo
o`;o0?ZJ00Ko0000ooooool00?oo003oo`3jV_ooool4o`3jVV[ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`0Looooo`;o00000_ooool2o`0001;ooooo0_l00002ooooo`co000000?o
ooooo`000?l000000_ooool3o`0000[ooooo0ol000000ooooooo0000o`00003>ooooo`03o`000?oo
oooooooo037ooooo000jooooo`?o00000oooool00ol0003oooooooooo`02ooooo`?o00001_ooool0
0ol0003oooooooooo`04ooooo`?o0?ZJ00?o0000o`3jV_l0nYX0<_ooool2o`3jVP03ooooool0nY[o
0?ZJ00;ooooo0ol0nYX00ooooooo0?ZJo`3jVP03o`3jVP;ooooo1Ol0nYX2o`0000?o0?ZJ00Cooooo
o`000?l0nY[o0?ZJ1?ooool2o`3jVQ3ooooo0_l0nYX2ooooo`?o0?ZJ0_l00002o`3jVP;ooooo1Ol0
nYX00ol0003oooooo`000003o`3jVP04o`000?oooooo0?ZJo`3jVPcooooo0_l00002ooooo`;o0?ZJ
0_ooool2o`00o`;o0?ZJ00?oooooo`3jV_l0nYX02_ooool3o`3jVP05ooooool00?oo003oo`3jV_oo
ool01?l0nYYZooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool07?ooool2o`0000;o
oooo0_l0000Booooo`;o00000_ooool<o`000003ooooool0003o000000?ooooo0ol00008ooooo`?o
00000_ooool3o`000<gooooo00?o0000ooooooooool0<Oooool003_ooooo00?o0000ooooooooool0
1_ooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool01?ooool2o`3jVP;o
00000_l0nYXbooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo1?l0nYX01?oooooo0?ZJo`3jV_ooool2
o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ0_l00003o`3jVP04ooooool0003o0?ZJo`3jVP?ooooo0ol0
nYX@ooooo`;o0?ZJ0_ooool3o`3jVP;o00000_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP;o000000?o
ooooo`000?l0nYX00_l0nYX01Ol0003oooooo`3jV_l0nY[ooooo00;o00002Oooool2o`000004oooo
ool0003o0?ZJo`3jVP;ooooo0_l00?l5o`3jVP[ooooo00Co0000o`3jV_l0nY[ooooo0_l00?l6o`3j
VV[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Looooo`;o000000?oooooo`00
0?l000000_l0000Aooooo`;o00000oooool2o`000003ooooool0003o000000Wo00001?ooool2o`00
00Sooooo0_l00003ooooo`?o00002?ooool3o`000<;ooooo00?o0000ooooooooool0<Oooool003So
oooo1Ol00007ooooo`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`04oooo
o`;o0?ZJ0_l00002o`3jVS7ooooo0ol0nYX00ooooooo0?ZJo`3jVP05o`3jVP04ooooool0nY[o0?ZJ
ooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo0ol0nYX2o`0000?o0?ZJ00?oooooo`000?l0nYX00_l0
nYX00ooooooo0?ZJo`3jVP02o`3jVP?ooooo0_l0nYX;ooooo`;o0?ZJ0_ooool3o`3jVP;o00001Ol0
nYX00ooooooo003oo`00o`02o`000003ooooool0003o0?ZJ00;o0?ZJ0_l00002o`3jVP03ooooool0
003o000000Wooooo0_l000001?oooooo0000o`3jV_l0nYX2ooooo`;o003o00?o0000o`3jV_l0nYX0
0_l0nYX;ooooo`;o0?ZJ00?oooooo`00ool00?l00ol0nYX00ooooooo0?ZJo`3jVP1Zooooo`03o`00
0?oooooooooo01Wooooo0_l0000Mooooo`Oo00004?ooool3o`0000Oooooo2Ol00005ooooo`;o0000
1oooool3o`0000?ooooo0ol00008ooooo`?o0000I_ooool7o`00oaGooooo1_l00?lhooooo`?o0000
<oooool003Sooooo00Co0000oooooooooooo00002?ooool4o`0000Kooooo0ol00003ooooo`?o0?ZJ
0_l00002o`3jVS7ooooo0_l0nYX2ooooo`Co0?ZJ00?oooooo`3jV_l0nYX00ol0nYX00ooooooo0?ZJ
o`3jVP03o`3jVP03ooooool0nY[o0?ZJ00?o00000_l0nYX2ooooo`;o00000_l0nYX00ooooooo0?ZJ
o`3jVP02o`3jVP;ooooo0ol0nYX:ooooo`?o0?ZJ0_ooool3o`3jVP?o00001?l0nYX00ooooooo003o
o`00o`05o`00o`04o`3jV_l0003o0000o`0000;o0?ZJ00?oooooo`000?l000002Oooool2o`000004
ooooool0003o0?ZJo`3jVP;ooooo0_l00?l00ol0003o0?ZJo`3jVP02o`3jVP_ooooo0_l0nYX01?oo
oooo003oo`00ool00?l2o`3jVP03ooooool0nY[o0?ZJ06Sooooo0ol0000Kooooo`03o`000?oooooo
oooo01_ooooo1Ol000000ooooooo0000o`00000@ooooo`;o00002?ooool9o`0000Gooooo0ol00006
ooooo`;o00001?ooool3o`0000Cooooo0_l00002ooooo`?o0000I_ooool<o`00oa3ooooo1_l00?lj
ooooo`03o`000?oooooooooo037ooooo000iooooo`03o`000?oooooo000000Sooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`03ooooo`;o0?ZJ00?oooooo`000?l000000_l0nYX_oooo
o`;o00000_l0nYX2ooooo`05o`000?l0nY[o0?ZJo`3jV_ooool01?l0nYX2ooooo`Co0?ZJ0_ooool4
o`00o`03ooooool00?oo003o00Go003o1_l0nYX2ooooo`?o0?ZJ2_ooool2o`3jVP?ooooo0_l0nYX2
ooooo`;o00000ol0nYX2ooooo`go003o00?oooooo`000?l000002Oooool2o`000004ooooool0nY[o
0?ZJo`3jVP;ooooo0_l00?l00ol0003o0?ZJo`3jVP02o`3jVP_ooooo0_l0nYX01Ooooooo0000o`00
ool00?oo0?ZJ00;ooooo0_l0nYYZooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
6oooool5o`000003ooooool0003o000000;o00003_ooool2o`0000Sooooo1Ol000001?oooooo0000
o`000?l00005ooooo`?o00001_ooool2o`0000Gooooo0_l00004ooooo`;o00000_ooool3o`0000?o
oooo0_l0001Fooooo`Oo003o1?ooool2o`00o`Cooooo1_l00?l5ooooo`Ko003o1?ooool3o`00o`;o
oooo0_l00?l5ooooo`Ko003o2_ooool7o`00oakooooo00?o0000ooooooooool0<Oooool003[ooooo
0_l00009ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00oooool3o`00o`;o0000
0_l0nYX_ooooo`;o00000_l0nYX00ol0003oooooo`000002o`3jVP?ooooo0ol0nYX3ooooo`?o0?ZJ
0_ooool<o`00o`?o0?ZJ00Coooooo`3jV_l0nY[ooooo1?l0nYX:ooooo`co003o0_l0nYX2ooooo`;o
003o1?l00007o`00o`?o00002Oooool2o`000003ooooool0nY[o0?ZJ00?ooooo0_l00?l2ooooo`?o
0?ZJ2oooool2o`3jVP05ooooool0003o003oo`00ool0nYX00_ooool2o`3jVV[ooooo00?o0000oooo
ooooool01_ooool2o`0000Cooooo00Co0000oooooooooooooooo1Ol00004ooooo`03o`000?oooooo
oooo01_ooooo1?l0000<o`00o`Sooooo0_l00009ooooo`Co000000Coooooo`000?l0003o00001_oo
ool2o`0000Kooooo0_l00005ooooo`?o000000?oooooo`000?l000000_l00002ooooo`?o00000ooo
ool2o`0005Kooooo1ol00?l4ooooo`;o003o2?ooool2o`00o`Gooooo3?l00?l3ooooo`?o003o1?oo
ool6o`00o`[ooooo1ol00?lNooooo`03o`000?oooooooooo037ooooo000kooooo`03o`000?oooooo
oooo00Sooooo0_l00006ooooo`03o`000?oooooooooo00?ooooo1ol00?l00ol0nY[oooooooooo`02
o`3jVR[ooooo00Oo0000o`3jV_l0nY[o0?ZJo`000?oooooo000000;o0?ZJ0oooool3o`3jVP?ooooo
0_l0nYX3ooooo`;o003o00?o0000o`00ool00?l00_l00?l2ooooo`03o`000?l00?oo003o00?o0?ZJ
00Coooooo`3jV_l0nY[ooooo1?l0nYX:ooooo`co003o0_l0nYX2ooooo`;o003o00Co0?ZJo`000?l0
003o00000_l0nYX3o`0000;o003o0ol00008ooooo`?o000000Coooooo`00ool00?oo003o0_ooool2
o`00o`;ooooo0ol0nYX;ooooo`?o0?ZJ00Co0000o`00ool00?oo0?ZJ0_ooool2o`3jVV[ooooo00?o
0000ooooooooool01Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000Co
oooo00?o0000ooooooooool03_oooolRo`00o`;ooooo0ol0000;ooooo`;o000000Coooooo`000?l0
003o00001_ooool2o`0000Gooooo0ol00006ooooo`Oo00000_ooool3o`0000?ooooo0_l00003oooo
o`;o0000DOooool2o`00o`?ooooo0ol00?l3ooooo`;o003o2?ooool3o`00o`?ooooo0ol00?l3oooo
o`Oo003o1?ooool8o`00o`;ooooo0_l00?l:ooooo`;o003o0oooool3o`00oagooooo00?o0000oooo
ooooool0<Oooool004kooooo00?o0000ooooooooool00oooool2o`3jVPGo003o00?o0?ZJoooooooo
ool00_l0nYXZooooo`03o`000?l0nY[o0?ZJ00;o000000Goooooo`000?l0nY[o0?ZJooooo`02o`00
00?o0?ZJ0oooool2o`3jVP?ooooo0_l00?l2o`000003ooooool0nY[o0?ZJ00;ooooo00?o0000o`00
ool00?l00ol0nYX00ooooooo0?ZJo`3jVP05o`3jVPSooooo0_l00002o`00o`;o00000ol00?l2oooo
o`03o`000?l00?oo003o00;o0?ZJ0_ooool2o`00o`04o`3jV_l0003o0000o`0000;o0?ZJ0ol00002
o`00o`?o00001_ooool2o`3jVP?o000000?oooooo`00ool00?l01Ol00?l3ooooo`;o0?ZJ3?ooool2
o`3jVP04o`000?l00?oo003oo`3jVP;ooooo0_l0nYYQooooo`;o0?ZJ1oooool00ol0003ooooooooo
o`05ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01?ooool3o`0000?ooooo
7Ol00?l3ooooo`;o00001OoooolAo`00o`Gooooo0_l00002ooooo`;o00001_ooool2o`0000Gooooo
0_l00007ooooo`Oo000000?oooooo`000?l000003?l00?l00ol0003oooooooooo`0Hoooooa7o003o
8?ooool7o`00o`Cooooo1ol00?l9ooooo`Oo003o3oooool7o`00o`?ooooo0ol00?l8ooooo`?o003o
1?ooool6o`00oaOooooo0ol0000cooooo`00C_ooool2o`0000Cooooo0_l0nYX2o`000005ooooool0
0?oo003oo`3jV_ooool00ol0nYXZooooo`03o`000?l00?oo003o00Go003o00Co0?ZJooooool0003o
00000_l0nYX4ooooo`;o0?ZJ00?o0000ooooool00?l00_l00?l00ol0nY[o0000ooooo`03o`3jVP04
ooooool0003o003oo`00o`?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP08oooo
o`;o00000_l00?l3o`0000?o0?ZJ00Coooooo`000?l00?oo003o0_l0nYX2o`0000;o003o00Co0?ZJ
o`000?l0003o00000ol0nYX2o`0000;o003o0ol00002o`3jVP?ooooo0ol0nYX3o`000003ooooool0
0?oo003o00Go003o4Oooool3o`3jVP;o003o0oooool2o`3jVV7ooooo0_l0nYX6ooooo`;o00001ooo
ool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool=o`00o`[ooooo0_l00007ooooo`;o00000_ooool2o`0000KoooooBOl00?l3ooooo`03o`00
0?l00?oo003o00Go003o2_oooolAo`00oa[ooooo3Ol00?l4ooooo`Oo003o2Oooool7o`00oa[ooooo
3?l00?l5ooooo`Ko003o4?ooool2o`00o`Oooooo00?o0000ooooooooool0<Oooool004kooooo00?o
0000ooooooooool00oooool3o`3jVP06o`000?oooooo003oo`00ool0nY[ooooo0ol0nYXZooooo`03
o`000?l00?oo003o00Go003o00Co0?ZJooooool0003o00001?l00?l2ooooo`;o0?ZJ00Co0000oooo
ool00?oo003o0_l0nYX00ol0003oooooo`3jVP02o`3jVP04ooooool0003o003oo`00o`;o0?ZJ0_oo
ool4o`3jVP03ooooool0nY[o0?ZJ00Sooooo00Go0000o`3jV_l00?oo003oo`3jVP02o`0000?o0?ZJ
0_ooool3o`00o`03o`3jV_l0003o000000;o003o00Co0?ZJo`000?l0003o00000ol0nYX01?oooooo
0000o`00ool00?l2o`0000?o0?ZJ0_ooool4o`3jVP?o000000?o0?ZJo`00ool00?l00oooool2o`3j
VQ;ooooo0_l0nYX6o`00o`03o`3jV_oooooooooo05kooooo0ol0nYX7ooooo`03o`000?oooooooooo
00Gooooo00Co0000oooooooooooo00001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o
0000ooooooooool00oooool4o`000003ooooool0003o0000013ooooo0_l00007ooooo`?o000000?o
ooooo`000?l000002Oooool2o`0000Kooooo;Ol00?l7o`0000;ooooo00?o0000o`00ool00?l07?l0
0?l=ooooo`So003o3oooool<o`00oc_ooooo3?l00?l9oooooaCo003o1oooool00ol0003ooooooooo
o`0aooooo`00C_ooool00ol0003oooooooooo`04ooooo`;o0?ZJ0_ooool2o`00o`Go0?ZJ:_ooool0
0ol0003o003oo`00o`03o`0000go003o00?o0?ZJo`000?l000000_l00?l2o`3jVP03o`000?oooooo
0?ZJ00;o0?ZJ00?oooooo`000?l00?l00_l00?l00ol0nY[oooooooooo`03o`3jVP;ooooo0_l0nYX8
ooooo`05o`000?l0nY[o003oo`00ool0nYX00_l00003o`3jVP?ooooo0_l00?l3o`0000;o003o0_l0
nYX2o`0000?o0?ZJ00Goooooo`000?l00?oo003oo`000004o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ
0ol000001?l0nY[o003oo`00ool0nYX2ooooo`;o0?ZJ4oooool00ol0nY[o003oo`00o`05o`00o`03
o`3jV_oooooooooo00;o0?ZJF_ooool4o`3jVPOooooo00?o0000ooooooooool01Oooool01?l0003o
ooooooooool00007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`04
ooooo`?o000000Coooooo`000?l0003o00003oooool2o`0000Sooooo0_l000000ooooooo0000o`00
0009ooooo`;o00006Oooool5o`000003ooooool0003o000000Oooooo0ol000000ooooooo0000o`00
0004o`000003ooooool0003o000000Go00000_ooool3o`0000Cooooo1_l00?l5ooooo`co003o3ooo
ool<o`00o`[ooooo1ol00?mFoooooa;o003o2?ooool00ol0003oooooooooo`0aooooo`00C_ooool0
0ol0003oooooooooo`04ooooo`;o0?ZJ0_ooool2o`00o`Go0?ZJ:_ooool01?l0nY[o003oo`00ool0
nYX3o`00017o003o0_l0nYX00ol0003oooooo`3jVP02o`3jVP03ooooool0003o000000;o003o00?o
0?ZJooooooooool00ol0nYX2ooooo`;o0?ZJ1oooool2o`000004o`3jV_l00?oo003oo`3jVP;o0000
0ol0nYX3ooooo`Oo003o0_l0nYX00ol0003o0?ZJo`3jVP02o`3jVP05ooooool0003o003oo`00ool0
00001?l0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVP?o000000Co0?ZJo`00ool00?oo0?ZJ0_ooool2
o`3jVQ?ooooo0ol0nYX3ooooo`;o003o00?o0?ZJooooooooool00_l0nYYIooooo`Go0?ZJ1oooool0
0ol0003oooooooooo`06ooooo`;o00002Oooool3o`0000Gooooo00?o0000ooooooooool01Oooool6
o`0000oooooo0_l00008ooooo`Go00002Oooool2o`0001Wooooo1Ol000000ooooooo0000o`000007
ooooo`?o000000?oooooo`000?l000001?l000000ooooooo0000o`000005o`0000;ooooo0ol00007
ooooo`Go00008oooool7o`00o`Cooooo2?l00?meooooo`03o`000?oooooooooo037ooooo001>oooo
o`03o`000?oooooooooo00Cooooo0_l0nYX2ooooo`;o003o1Ol0nYXZooooo`04o`3jV_l00?oo003o
o`3jVP?o00000_l0nYX01Ooooooo0000o`00ool00?oo0?ZJ00Co00001_l00?l3o`3jVP03ooooool0
nY[o0?ZJ00;o0?ZJ0_l00002o`00o`03o`000?oooooooooo00?o0?ZJ0_ooool2o`3jVPOooooo0_l0
00001_l0nY[o003oo`00ool0nY[oooooo`0000Co0?ZJ0_ooool7o`00o`;o0?ZJ00?o0000o`3jV_l0
nYX00_l0nYX01Ooooooo0000o`00ool00?oo000000Oo0?ZJ00?o0000o`3jV_l0nYX00_l00002o`3j
VP;o003o00?o0?ZJooooooooool00_l0nYXDooooo`;o0?ZJ0oooool2o`00o`03o`3jV_oooooo0?ZJ
00;o0?ZJFOooool2o`3jVP03ooooool0nY[o0?ZJ00Oooooo00?o0000ooooooooool06Oooool2o`00
00Oooooo1Ol0000?ooooo`;o00002?ooool5o`0000Gooooo0_l00002ooooo`;o00006Oooool5o`00
0003ooooool0003o000000Oooooo0ol000000ooooooo0000o`000003o`0000;ooooo1ol00002oooo
o`Co00001?ooool7o`0002Sooooo0ol00?l3ooooo`Oo003oM?ooool3o`0003?ooooo001>ooooo`;o
00001Oooool3o`3jVP06ooooool00?oo003oo`00ool0nY[ooooo0_l0nYXYooooo`06o`000?l0nY[o
003oo`00ool0nY[ooooo0_l00002o`3jVP03ooooool0003o000000?o0?ZJ0ol00002o`3jVP03oooo
ool0003o000000Co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX01Ooooooo0000o`00ool00?oo000000;o
oooo0ol0nYX2ooooo`;o0?ZJ1?ooool2o`3jVP04ooooool0003o0?ZJo`3jVP;o003o00?o0?ZJoooo
ool000001?l0nYX2ooooo`;o0?ZJ0_ooool00ol0003o0?ZJo`3jVP07o`3jVP05ooooool0003o003o
o`00ool000001_l0nYX2o`0000;o0?ZJ00Co0000o`3jV_l0nY[o0?ZJ0_l00?l00ol0nY[ooooooooo
o`02o`3jVQCooooo0ol0nYX2ooooo`;o003o00?o0?ZJooooool0nYX00_l0nYYAooooo`;o0?ZJ0_oo
ool2o`0000;ooooo0_l0nYX00ooooooo0?ZJo`3jVP06ooooo`;o00006oooool00ol0003ooooooooo
o`06ooooo`Go00003_ooool3o`0000Sooooo1Ol00005ooooo`;o00000_ooool2o`0001Wooooo1Ol0
00000ooooooo0000o`000008ooooo`;o00001?ooool2o`0000;ooooo1ol00002ooooo`Co00001?oo
ool7o`0002Wooooo1ol00?mkooooo`03o`000?oooooooooo037ooooo001>ooooo`03o`000?oooooo
oooo00Gooooo0_l0nYX01_oooooo0000o`00ool00?oo0?ZJooooo`;o0?ZJ:Oooool01Ol0003o0?ZJ
o`00ool00?oo0?ZJ00?ooooo0_l0nYX00ooooooo0000o`000003o`3jVP;o000000Coooooo`3jV_l0
nY[ooooo0_l00004o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ00?o0000o`00ool00?l01Ol00?l3oooo
o`;o0?ZJ0oooool3o`3jVP;o00000_l0nYX2o`00o`03o`3jV_oooooo000000Co0?ZJ0_ooool3o`3j
VP05ooooool0003o0?ZJo`3jV_ooool01ol0nYX00ooooooo003oo`00o`07o`3jVP;o00000_l0nYX0
1?l0003o0?ZJo`3jV_l00002o`00o`03o`3jV_oooooooooo00;o0?ZJ5?ooool00ol0003o0?ZJo`3j
VP02ooooo`;o003o1Ol0nYY@ooooo`?o0?ZJ0_ooool2o`0000;ooooo0_l0nYX00ooooooo0?ZJo`3j
VP07ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool01_ooool6o`0000gooooo0_l0
000:ooooo`Co00001Oooool2o`000004ooooool0003o0000o`0001cooooo1Ol00008ooooo`;o0000
2Oooool6o`000003ooooool0003o000000?o00000oooool8o`0002Wooooo1ol00?mkooooo`03o`00
0?oooooooooo037ooooo001>ooooo`03o`000?oooooooooo00Gooooo0ol0nYX00ol0003o003oo`00
o`02ooooo`;o0?ZJ:Oooool2o`3jVP;o003o0_l0nYX2ooooo`;o0?ZJ00?oooooo`000?l000000ol0
nYX3ooooo`;o0?ZJ00?oooooo`000?l0nYX01?l0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVP03o`00
0?l00?oo003o00[o003o00?o0?ZJooooool0nYX00ol0nYX2o`0000;o0?ZJ0_l00?l2o`3jVP03oooo
ool0nY[o0?ZJ00?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2o`3jVP03ooooool0003o0?ZJ00;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_l00?l2o`3jVP03o`000?l0nY[o0?ZJ00;o0?ZJ0_l00002o`3j
VP04o`000?l0nY[o0?ZJooooo`;o003o00?o0?ZJooooooooool00_l0nYXDooooo`03o`000?l0nY[o
0?ZJ00;ooooo0_l00?l5o`3jVToooooo1?l0nYX2ooooo`;o000000Goooooo`3jV_l0nY[o0?ZJoooo
o`02o`3jVPOooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`06ooooo`?o000000?o
ooooo`000?l000003Oooool2o`0000[ooooo1?l00005ooooo`;o000000Coooooo`000?l0003o0000
7Oooool4o`0000Sooooo0_l00009ooooo`?o000000Coooooo`000?l0003ooooo0_l000000ooooooo
0000o`000003ooooo`Wo0000Z_ooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003ooooo
ooooo`06ooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool2o`3jVPCooooo0_l0nYXRooooo`?o0?ZJ
0_l00?l2o`3jVP;ooooo0_l0nYX00ooooooo0000o`000003o`3jVP?ooooo0_l0nYX01Ooooooo0000
o`3jV_l0nY[ooooo00Go0?ZJ00?oooooo`3jV_l0nYX00ol0nYX2o`000003ooooool00?oo003o00Go
003o00?o0?ZJooooool0nYX00ol0nYX00ol0003o0?ZJo`3jVP03o`00o`;o0?ZJ00Coooooo`3jV_l0
nY[ooooo1_l0nYX2ooooo`;o0?ZJ00?oooooo`000?l0nYX00_l0nYX2ooooo`;o0?ZJ0_l00?l2o`3j
VP;o00000ol0nYX2o`0000;o0?ZJ00?o0000o`3jV_l0nYX00ol00?l2o`3jVP03ooooool0nY[o0?ZJ
01Cooooo00?o0000o`3jV_l0nYX00_ooool2o`00o`Go0?ZJ2Oooool2o`3jVRgooooo0_l0000Eoooo
o`Co0?ZJ0_ooool2o`000003ooooool0nY[o0?ZJ00;ooooo0_l0nYX7ooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool01_ooool3o`000003ooooool0003o000000gooooo0_l0000<oooo
o`;o00000_ooool2o`000003ooooool0003o000000Co00007Oooool3o`0001Gooooo0_l000000ooo
oooo0000o`000003o`000003ooooool0003o000000?ooooo2Ol0002Zooooo`03o`000?oooooooooo
037ooooo001>ooooo`03o`000?oooooooooo00Kooooo0_l0nYX00ooooooo003oo`00o`02ooooo`;o
0?ZJ0oooool3o`3jVR;ooooo0_l0nYX00ol0003o003oo`00o`02o`3jVP06ooooool0nY[o0?ZJo`3j
V_oooooo00001Ol0nYX2ooooo`;o0?ZJ0_ooool2o`3jVP;ooooo1?l0nYX2ooooo`Go0?ZJ00Co0000
ooooool0nY[o0?ZJ0oooool2o`00o`Wo0?ZJ0_l00?l6o`3jVP;ooooo1Ol0nYX2ooooo`;o0?ZJ0_oo
ool3o`3jVP;ooooo0_l0nYX2o`00o`04o`3jV_l0003o0000o`0000?o0?ZJ0_l00005o`3jVP;o003o
0ol0nYX00ooooooo0?ZJo`3jVP0Dooooo`05o`000?l0nY[o0?ZJo`3jV_ooool00ol00?l01?l0nY[o
ooooo`3jV_l0nYX9ooooo`;o0?ZJ;Oooool2o`0001Cooooo1Ol0nYX2ooooo`03o`000?l0nY[o0?ZJ
00;o0?ZJ0_ooool2o`3jVPOooooo00?o0000ooooooooool06Oooool2o`0000Oooooo0ol000000ooo
oooo0000o`00000=ooooo`;o00003?ooool2o`0000;ooooo2Ol0000Mooooo`?o00006?ooool4o`00
00;ooooo0_l00003ooooo`Wo0000Z?ooool3o`0003?ooooo001>ooooo`03o`000?oooooooooo00Ko
oooo0ol0nYX2o`00o`;o00000ol0nYX00ooooooo0?ZJo`3jVP02o`3jVR7ooooo0ol0nYX3o`00o`;o
0?ZJ00?oooooo`3jV_l0nYX00_l0nYX01?l0003o0?ZJo`3jV_ooool2o`3jVP04ooooool0nY[o0?ZJ
o`3jVP;ooooo0_l0nYX3ooooo`?o0?ZJ0_ooool5o`3jVP04o`000?oooooo0?ZJo`3jVP?ooooo0_l0
0?l3o`3jVP03o`000?l0nY[o0?ZJ00;o0?ZJ00Goooooo`00ool00?oo0?ZJooooo`04o`3jVP;ooooo
1Ol0nYX2ooooo`;o0?ZJ0oooool2o`3jVP?ooooo00Co0?ZJo`00ool00?oo0?ZJ0ol00003o`3jVP03
ooooool0003o0?ZJ00?o0?ZJ00?oooooo`00ool00?l01_l0nYXDooooo`;o00000_l0nYX2ooooo`;o
003o00Co0?ZJooooool0nY[o0?ZJ2?ooool3o`3jVRgooooo0_l0000Dooooo`;o0?ZJ00?oooooo`3j
V_l0nYX00_ooool5o`3jVP;ooooo0_l0nYX7ooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool01oooool2o`000003ooooool0003o000000gooooo0_l0000<ooooo`;o00000_ooool9o`00
03Sooooo0ol00003ooooo`;o00000oooool2o`000003ooooool0003o000000;ooooo0_l0002Zoooo
o`03o`000?oooooooooo037ooooo001>ooooo`;o00002?ooool2o`3jVP;o003o0ol00002o`3jVP03
ooooool0nY[o0?ZJ00;o0?ZJ0oooool2o`3jVQcooooo0_l0nYX00ol0003o003oo`00o`08o`3jVP04
o`000?l0nY[o0?ZJooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP03oooo
o`?o0?ZJ0oooool4o`3jVP03o`000?oooooo0?ZJ00;o0?ZJ00Coooooo`000?l00?oo003o0ol0nYX0
0ol0003o0?ZJo`3jVP02o`3jVP04ooooool00?oo003oo`3jVP;ooooo0ol0nYX2ooooo`Go0?ZJ0_oo
ool2o`3jVPWooooo0_l00?l01?l0nY[o0000o`000?l00002o`3jVP03o`000?oooooo000000Co0?ZJ
00Goooooo`00ool00?oo0?ZJooooo`04o`3jVQCooooo0_l00003o`3jVP03o`000?l00?oo003o00;o
oooo0_l0nYX8ooooo`?o0?ZJ;Oooool2o`0001Cooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`Go
0?ZJ0_ooool2o`3jVPKooooo0_l0000Kooooo`03o`000?oooooooooo00Oooooo0_l000000ooooooo
0000o`00000=ooooo`;o00003?ooool2o`000003ooooool0003o000000So0000>?ooool2o`0000Co
oooo1?l000001?oooooo0000o`000?ooool2o`0000;ooooo0_l0002Zooooo`03o`000?oooooooooo
037ooooo001>ooooo`03o`000?oooooooooo00Oooooo0_l0nYX6o`00o`03o`3jV_oooooo0?ZJ00?o
0?ZJ0oooool2o`3jVQCooooo0_l0nYX4ooooo`Co0?ZJ00Go0000o`00ool00?oo0?ZJooooo`09o`3j
VP04ooooool0nY[o0?ZJooooo`Co0?ZJ00?oooooo`3jV_l0nYX01?ooool2o`3jVPGooooo0_l0nYX0
0ol0003oooooo`3jVP02o`3jVP;o00000_l00?l3o`3jVP06o`000?l0nY[o0?ZJo`3jV_l0003ooooo
0_l00?l00ol0nY[oooooooooo`03o`3jVP?ooooo1?l0nYX2ooooo`;o0?ZJ2Oooool2o`00o`;ooooo
0_l00007o`00o`03o`3jV_oooooooooo00;o003o00?o0?ZJooooooooool00ol0nYXDooooo`;o0000
00Coooooo`3jV_l0nY[o00000_l00?l2ooooo`;o0?ZJ1oooool4o`3jVRgooooo0_l000000ooooooo
0000o`00000Aooooo`;o0?ZJ00Goooooo`3jV_l0nY[oooooo`000004o`3jVP?ooooo0_l0nYX7oooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool01oooool2o`000003ooooool0003o0000
00gooooo0_l0000<ooooo`;o000000?oooooo`000?l000001Ol000000ooooooo0000o`00000ooooo
o`Ko00001Oooool2o`000:[ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000oooooooo
ool02?ooool2o`3jVPGo003o00?o0?ZJooooool0nYX00ol0nYX2ooooo`?o0?ZJ5?ooool2o`3jVP?o
oooo1?l0nYX01_oooooo0000o`00ool00?oo0?ZJooooo`Co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX0
0ooooooo0?ZJo`3jVP08o`3jVP_ooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYX2o`0000?o003o0_l0
nYX01?l0003o0?ZJo`3jV_l0nYX2ooooo`;o003o00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`?o
0?ZJ00?oooooo`3jV_l0nYX02Oooool4o`00o`;ooooo1ol00?l00ol0nY[oooooooooo`02o`00o`03
o`3jV_oooooooooo00?o0?ZJ5?ooool2o`000004ooooool0nY[o0?ZJo`0000;o003o0_ooool2o`3j
VPKooooo1Ol0nYX]ooooo`;o000000?oooooo`000?l000004?ooool3o`3jVP04ooooool0nY[o0?ZJ
ooooo`?o0?ZJ1ol00?l7ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool02_ooool2
o`0000gooooo0_l0000<ooooo`Ko00001Oooool2o`0003oooooo1_l00005ooooo`;o0000Z_ooool0
0ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0_l00002o`00
o`Ko0?ZJ00?oooooo`3jV_l0nYX00_l0nYXCooooo`?o0?ZJ0_ooool5o`3jVP;o00000_l00?l00ol0
nY[oooooooooo`03o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool4o`3jVP03ooooool0nY[o0?ZJ
00;o0?ZJ3?ooool2o`3jVP04o`000?l0nY[o0?ZJo`3jVP?o00000_l00?l00ol0nY[o0000o`000003
o`3jVP;ooooo0_l00?l00ol0nY[oooooooooo`09ooooo`Go0?ZJ2Oooool8o`00o`03o`000?oooooo
000000;o003o00?o0?ZJooooooooool00_l00?l01?l0nY[oooooooooooooool2o`3jVQCooooo0_l0
00001?oooooo0?ZJo`3jV_l0nYX2o`00o`;ooooo0_l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
3oooool2o`3jVQcooooo0ol00002o`3jVP?ooooo0_l0nYX;ooooo`;o0?ZJ0_ooool2o`3jVP04o`00
0?l0nY[o0?ZJo`0000Oo003o1oooool00ol0003oooooooooo`0Iooooo`;o00002oooool2o`0000go
oooo0_l0000=ooooo`Co0000Aoooool5o`0000Kooooo0_l0002Xooooo`?o0000<oooool004kooooo
00?o0000ooooooooool02Oooool2o`3jVP;o00000_l00?l3o`3jVP04ooooool0nY[o0?ZJooooo`Co
0?ZJ4oooool3o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ0_l00002o`00o`04o`3jV_oooooooooooooo
o`;o0?ZJ0_ooool3o`3jVP?ooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVPcooooo0_l0nYX00ol0
003o0?ZJo`3jVP02o`3jVP;o00000_l00?l00ol0nY[o0000ooooo`03o`3jVP;ooooo0_l00?l00ol0
nY[oooooooooo`0:ooooo`Co0?ZJ2Oooool2o`3jVP03ooooool00?oo003o00;o003o00Co0?ZJoooo
oooooooooooo0_l00?l3ooooo`;o003o00?o0?ZJooooooooool05oooool3o`000003ooooool0nY[o
0?ZJ00;o003o0_ooool2o`3jVPGooooo0ol0nYX00ooooooo0?ZJo`3jVP0>ooooo`?o0?ZJ7?ooool3
o`0000;o0?ZJ0_ooool3o`3jVP_ooooo0_l0nYX00ooooooo0000o`3jVP04o`3jVP04o`000?l00?oo
003oo`0000;ooooo0_l00?l7ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool02_oo
ool4o`0000_ooooo0_l0000=ooooo`Co0000Aoooool5o`0000Kooooo0_l0002Zooooo`03o`000?oo
oooooooo037ooooo001>ooooo`;o00002_ooool2o`3jVP;o00000_l00?l3o`3jVP03ooooool0nY[o
0?ZJ00Go0?ZJ4_ooool4o`3jVP04ooooool0nY[o0?ZJooooo`?o0?ZJ0_l00002o`00o`03o`3jV_oo
oooooooo00Gooooo0ol0nYX3ooooo`?o0?ZJ0_ooool3o`3jVPcooooo0_l0nYX00ol0003o0?ZJo`3j
VP02o`3jVP;o00000_l00?l00ol0nY[oooooooooo`02o`3jVP03o`000?oooooooooo00;o003o3Ooo
ool4o`3jVPWooooo0_l0nYX4ooooo`?o0?ZJ0_ooool2o`00o`?ooooo0_l00?lKooooo`;o000000?o
ooooo`000?l0nYX01_l00?l5ooooo`;o0?ZJ0_ooool2o`3jVPgooooo1?l0nYXLooooo`;o00000ol0
nYX2ooooo`?o0?ZJ2_ooool3o`3jVP03ooooool0003o0?ZJ00?o0?ZJ0_l00002o`00o`03o`000?oo
oooooooo00;o003o1_ooool2o`0001_ooooo00?o0000ooooooooool02_ooool4o`0000_ooooo0_l0
000=ooooo`?o0000Boooool2o`0000Kooooo1?l0002Xooooo`03o`000?oooooooooo037ooooo001>
ooooo`03o`000?oooooooooo00Wooooo0_l0nYX00ol0003oooooo`00o`02o`00o`03o`3jV_oooooo
oooo00Co0?ZJ00?oooooo`3jV_l0nYX04_ooool4o`3jVP03ooooool0nY[o0?ZJ00;o00000_l0nYX2
o`0000;o003o00?o0?ZJooooooooool01_ooool2o`3jVPCooooo0_l0nYX2ooooo`?o0?ZJ3?ooool8
o`3jVP04o`000?l00?oo003oo`0000;ooooo1ol00?l>ooooo`?o0?ZJ2Oooool3o`3jVP?ooooo0ol0
nYX2ooooo`Oo003o6oooool2o`000003ooooool0003o000000Ko003o1Oooool2o`3jVP;ooooo0_l0
nYX=ooooo`Co0?ZJ7?ooool00ol0003o0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2_oo
ool2o`3jVP;ooooo00?o0000o`3jV_l0nYX00_l0nYX2o`0000;o003o00?o0?ZJooooooooool00_l0
0?l7ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool02_ooool4o`0000_ooooo0_l0
000=ooooo`?o0000Boooool2o`0000Kooooo1?l0002Xooooo`03o`000?oooooooooo037ooooo001>
ooooo`03o`000?oooooooooo00Wooooo0_l0nYX00ol0003oooooo`000002o`00o`04o`3jV_oooooo
ooooooooo`?o0?ZJ00?oooooo`3jV_l0nYX04Oooool5o`3jVP03ooooool0nY[o0?ZJ00;o00001_l0
0?lDooooo`;o0?ZJ3Oooool4o`3jVP04o`000?l0nY[o0?ZJo`0000Co003o00?oooooo`00ool00?l0
1Ol00?l?ooooo`;o0?ZJ2_ooool2o`3jVP?ooooo0ol0nYX2ooooo`03o`3jV_l00?oo003o00Co003o
6oooool2o`000003ooooool0003o000000;o0?ZJ0_ooool2o`00o`Gooooo0_l0nYX2ooooo`;o0?ZJ
3?ooool5o`3jVQcooooo1Ol0nYX00ooooooo0?ZJo`3jVP02o`3jVP[ooooo0_l00?l00ooooooo0000
o`000003o`3jVP?o00000_l00?l00ol0nY[oooooooooo`02o`00o`Oooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0<ooooo`;o00002?ooool5o`0000gooooo0ol0001;ooooo`;o0000
1_ooool4o`000:Sooooo00?o0000ooooooooool0<Oooool003Cooooo0ol00003ooooo`03o`000?oo
oooooooo00;ooooo0ol00003ooooo`?o00001_ooool00ol0003oooooooooo`09ooooo`?o0?ZJ0_oo
ool2o`00o`04o`3jV_l0003o0000ooooo`;o0?ZJ00Co0000ooooool0nY[o0?ZJ4Oooool2o`3jVP03
ooooool0nY[o0?ZJ00?o0?ZJ0_l00006o`00ob?ooooo00Go0000o`3jV_l0nY[o0?ZJo`000003o`3j
VPOo003o0_ooool3o`00oa_ooooo0_l0nYX3ooooo`?o0?ZJ0_ooool2o`3jVP?ooooo0_l0nYXKoooo
o`;o000000?oooooo`000?l000000_l0nYX2ooooo`;o003o1Oooool2o`3jVP;ooooo0_l0nYX<oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX06oooool01?l0003o0?ZJo`3jV_l00007o`3jVP[ooooo1ol00?l0
0ol0nY[o0000o`000003o`00o`03o`3jV_oooooooooo00;o003o1oooool00ol0003oooooooooo`0I
ooooo`;o00003Oooool2o`0000Sooooo1?l0000>ooooo`;o0000EOooool3o`000:Kooooo0ol0000c
ooooo`00=Oooool00ol0003oooooooooo`06ooooo`07o`000?ooooooooooooooool0003oooooo`00
0003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0_l0
0?l01?oooooo0000o`000?ooool2o`3jVP04o`000?oooooo0?ZJo`3jVQ3ooooo0ol0nYX00ooooooo
0000o`3jVP02o`3jVP?o00000_l00?l01?l0003oooooo`3jV_l0nYXSooooo`06o`000?l0nY[o0?ZJ
o`3jV_l0003ooooo1?l0nYX5o`00o`?ooooo0_l0nYXKooooo`;o0?ZJ0oooool3o`3jVP;ooooo0ol0
nYX2ooooo`;o0?ZJ6oooool2o`000003ooooool0003o000000;o0?ZJ00Co0000ooooool00?oo003o
1Oooool2o`3jVP;ooooo0_l0nYX<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX06oooool01?l0003o0?ZJ
o`3jV_l00004o`3jVP03ooooool0nY[o0?ZJ00[ooooo1ol00?l00ol0nY[o0000o`000002o`00o`;o
0?ZJ0_ooool2o`00o`Oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0<ooooo`;o
00002?ooool4o`0006Gooooo1?l0002Wooooo`03o`000?oooooooooo037ooooo000booooo`Go0000
1oooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool00oooool3o`0000[o
oooo0ol0nYX00ooooooo003oo`00o`02o`00o`06o`000?oooooo0?ZJo`3jV_l0003ooooo0_l0nYX@
ooooo`;o0?ZJ0_ooool01?l0003o0?ZJo`3jV_l0nYX3o`0000;o003o00Co0000ooooool0nY[o0?ZJ
8oooool2o`0000;o0?ZJ0_ooool4o`3jVP?ooooo0ol0nYX2ooooo`;o0?ZJ6oooool3o`3jVP03oooo
ool0nY[o0?ZJ00;o0?ZJ0_ooool3o`3jVP;ooooo0_l0nYXKooooo`;o000000?oooooo`000?l00000
0_l0nYX01?l0003oooooo`00ool00?l5ooooo`Go003o00?o0?ZJooooooooool02Oooool3o`3jVP03
ooooool0nY[o0?ZJ01_ooooo00Co0000o`3jV_l0nY[o00001?l0nYX00ooooooo0?ZJo`3jVP09oooo
o`04o`3jV_l00?oo003oooooo`;o00000_l00?l00ooooooo0000o`000002o`00o`?o0?ZJ00Cooooo
o`00ool00?oo0?ZJ1?ooool3o`0000;ooooo0_l00004ooooo`04o`000?ooooooooooooooo`Go0000
0_ooool3o`0000Gooooo00?o0000ooooooooool03?ooool2o`0000Oooooo1Ol0001Uooooo`Co0000
Yoooool00ol0003oooooooooo`0aooooo`00<_ooool01?l0003oooooooooool00008ooooo`Co0000
1_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00[ooooo00Co0000o`3jV_l0nY[o
oooo1ol00?l00ol0nY[o0000ooooo`02o`3jVQ3ooooo0_l0nYX2ooooo`04o`000?l0nY[o0?ZJo`3j
VP;o00000ol00?l2ooooo`;o0?ZJ8oooool2o`0000Gooooo1?l0nYX2ooooo`?o0?ZJ0_ooool2o`3j
VQcooooo0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo0_l0nYXK
ooooo`Go00000_l0nYX01?l0003oooooo`00ool00?l5ooooo`Ko003o2oooool2o`3jVP;ooooo0_l0
nYXKooooo`?o0?ZJ0_l00002o`3jVP;ooooo0_l0nYX9ooooo`04o`3jV_l00?oo003oo`3jVP;o0000
0_l00?l2ooooo`03o`000?l00?oo003o00?o0?ZJ00Coooooo`00ool00?oo0?ZJ1_ooool00ol0003o
ooooo`000002ooooo`03o`000?oooooooooo00Kooooo00Ko0000oooooooooooo0000ooooool00003
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03?ooool2o`0000Oooooo1Ol0001U
ooooo`Co0000Yoooool00ol0003oooooooooo`0aooooo`00<oooool00ol0003oooooo`000008oooo
o`03o`000?oooooooooo00?ooooo1?l00006ooooo`03o`000?oooooooooo00_ooooo1Ol0nYX00ooo
oooo003oo`00o`02o`00o`03o`3jV_l0003o000000;o0?ZJ4?ooool2o`3jVP;ooooo00Ko0000o`3j
V_l0nY[o0?ZJo`000?ooool2o`00o`03o`3jV_oooooooooo00;o0?ZJ;?ooool2o`3jVP;ooooo0ol0
nYX2ooooo`;o0?ZJ7?ooool5o`3jVP04ooooool0nY[o0?ZJooooo`?o0?ZJ0_ooool2o`3jVQ_ooooo
1?l000001Ooooooo0?ZJo`3jV_l0nY[ooooo00;o003o1Oooool2o`00o`;ooooo0_l00?l;ooooo`;o
0?ZJ0_ooool2o`3jVQ_ooooo0_l0nYX3o`0000;o0?ZJ0_ooool2o`3jVPSooooo0_l0nYX2o`00o`03
o`3jV_l0003o000000Oo003o0ol0nYX01?oooooo003oo`00ool0nYX6ooooo`03o`000?oooooo0000
00;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool03?ooool3o`0000Kooooo1?l0001Vooooo`Co0000Yoooool00ol0
003oooooooooo`0aooooo`00=?ooool2o`0000Wooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00cooooo1?l0nYX00ooooooo0000o`000007o`00oa3o
oooo0_l0nYX2ooooo`03o`000?l0nY[o0?ZJ00;o000000Coooooo`00ool00?oo0?ZJ0_ooool2o`3j
VRcooooo0_l0nYX2ooooo`?o0?ZJ0_ooool2o`3jVQgooooo1?l0nYX00ooooooo0?ZJo`3jVP05o`3j
VP03ooooool0nY[o0?ZJ01_ooooo1?l00002ooooo`;o0?ZJ00?oooooo`00ool00?l01Oooool2o`00
o`;ooooo0_l00?l;ooooo`;o0?ZJ0_ooool2o`3jVQ_ooooo0_l0nYX2o`000003ooooool0nY[o0?ZJ
00;ooooo0_l0nYX8ooooo`;o0?ZJ0_l00?l01?l0nY[o0000o`000?l0nYX6o`00o`?o0?ZJ00Cooooo
o`00ool00?oo0?ZJ1_ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`?o00003Oooool2o`0000Kooooo0_l0
001Zooooo`;o0000YOooool3o`0003?ooooo000eooooo`03o`000?oooooooooo00Sooooo0_l00002
ooooo`Go00001Oooool00ol0003oooooooooo`0=ooooo`Co0?ZJ0_l000000ooooooo003oo`00o`04
o`00o`04o`3jV_ooooooooooooooo`;o0?ZJ2_ooool3o`00o`;o00001ol00?l00ol0nY[ooooooooo
o`02o`3jVRcooooo0_l0nYX2ooooo`Co0?ZJ00?oooooo`3jV_l0nYX07Oooool4o`3jVP;ooooo1_l0
nYX00ooooooo0?ZJo`3jVP0Kooooo`Co00000_ooool3o`3jVP;o003o0_ooool2o`000003ooooool0
0?oo003o00;ooooo0_l00?l:ooooo`?o0?ZJ0_ooool2o`3jVQ_ooooo0_l0nYX2o`000003ooooool0
nY[o0?ZJ00;ooooo0_l0nYX8ooooo`;o0?ZJ0_l00?l00ol0nY[o0000o`000002o`3jVP;ooooo0_l0
0005o`3jVP;o003o00?o0?ZJooooooooool01?ooool00ol0003oooooo`000002ooooo`03o`000?oo
oooooooo00Gooooo00Ko0000ooooooooooooooooo`000?ooool4o`0000Gooooo00?o0000oooooooo
ool03Oooool2o`0000Gooooo0ol0001Zooooo`;o0000Yoooool00ol0003oooooooooo`0aooooo`00
C_ooool00ol0003oooooooooo`0=ooooo`Co0?ZJ0_l000000ooooooo0?ZJo`3jVP02o`0000;o003o
00?o0?ZJooooooooool00ol0nYX:ooooo`co003o0_l0nYX00ooooooo0?ZJo`3jVP0/ooooo`?o0?ZJ
00?oooooo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP0Mooooo`Co0?ZJ0oooool8o`3jVQ_ooooo
1?l00002ooooo`03o`000?l0nY[o0?ZJ00;o003o0_ooool2o`000003ooooool00?oo003o00;ooooo
0_l00?l:ooooo`;o0?ZJ0oooool2o`3jVQ[ooooo0ol0nYX2o`000003ooooool0nY[o0?ZJ00;ooooo
0_l0nYX7ooooo`?o0?ZJ0_l00?l2o`3jVP06o`000?l0nY[o0?ZJo`3jV_oooooo00000ol0nYX00ol0
003o0?ZJo`3jVP02o`00o`03o`000?oooooooooo00Cooooo00?o0000ooooool000000_ooool00ol0
003oooooooooo`05ooooo`07o`000?ooooooooooooooool0003oooooo`000008ooooo`03o`000?oo
oooooooo00gooooo0_l00003ooooo`Co0000Joooool2o`000:Oooooo00?o0000ooooooooool0<Ooo
ool004kooooo0_l0000@ooooo`;o0?ZJ0ol00002o`3jVP;ooooo0_l00?l00ol0nY[oooooo`3jVP03
o`3jVP[ooooo1_l00?l00ol0nY[oooooooooo`02ooooo`?o0?ZJ00?oooooo`3jV_l0nYX0;Oooool2
o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ7_ooool3o`3jVPCooooo0_l0nYX00ooooooo0?ZJo`3jVP02
o`3jVQ_ooooo1?l00002ooooo`03o`000?l0nY[o0?ZJ00;o003o00?o0?ZJooooool000000_l00002
o`00o`;ooooo0_l00?l:ooooo`Ko003o00?o0?ZJooooooooool06?ooool2o`3jVP?o000000?ooooo
o`00ool00?l01?l00?l6ooooo`?o0?ZJ00?o0000o`00ool00?l00_l0nYX01_l0003o0?ZJo`3jV_l0
nY[oooooo`0000;o0?ZJ00Coooooo`000?l0003o0?ZJ0ol00?l5ooooo`;o00000_ooool2o`0000Wo
oooo0ol00002ooooo`Go00001?ooool00ol0003oooooooooo`0=ooooo`;o00000oooool4o`0006_o
oooo0_l0002Wooooo`03o`000?oooooooooo037ooooo001>ooooo`03o`000?oooooooooo00oooooo
0_l0nYX3o`0000;o0?ZJ0_ooool2o`00o`03o`3jV_oooooo0?ZJ00?o0?ZJ2Oooool01?l0003o003o
o`00ooooool2o`0000;o0?ZJ1?ooool6o`3jVRgooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool4o`3j
VQkooooo0ol0nYX7ooooo`Co0?ZJ6oooool4o`0000?ooooo00Ko0000o`3jV_l00?oo003oo`3jV_oo
ool3o`0000;o003o0_ooool2o`00o`[ooooo1ol00?lJooooo`co003o1_ooool2o`3jVP04o`000?l0
0?oo003oo`00o`;o0?ZJ00Koooooo`3jV_l0nY[o0?ZJooooool00002o`3jVP04ooooool0003o0000
o`0000?o003o1_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00gooooo0_l00003
ooooo`Co0000Joooool2o`000:Oooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000oooo
ooooool03oooool3o`3jVP;o00000_l0nYX2ooooo`;o003o00?o0?ZJooooool0nYX00ol0nYX9oooo
o`04o`3jV_l00?oo003oooooo`;o00000ol0nYX2ooooo`Oo0?ZJ;Oooool2o`3jVP04ooooool0nY[o
0?ZJooooo`Co0?ZJ7oooool2o`3jVPOooooo1?l0nYXKooooo`Co00000oooool2o`0000;o003o00?o
0?ZJooooool000000_l00002o`00o`04o`3jV_oooooo003oo`00o`[ooooo0_l00?l3ooooo`;o003o
6_ooool7o`00o`03o`3jV_oooooooooo00;o003o1Oooool3o`3jVP03o`000?l00?oo003o00?o0?ZJ
00Koooooo`3jV_l0nY[o0?ZJooooool00002o`3jVP04ooooool0003o0000o`0000;o0?ZJ1oooool0
0ol0003oooooooooo`0Iooooo`;o00003_ooool2o`0000?ooooo1?l0001[ooooo`?o0000Y?ooool3
o`0003?ooooo001>ooooo`03o`000?oooooooooo00oooooo00Co0000o`3jV_l0nY[o00000ol0nYX2
ooooo`;o003o1_l0nYX2ooooo`03o`000?l0nY[o0?ZJ00Cooooo00Co0?ZJo`00ool00?oooooo0_l0
0003o`3jVP;ooooo0_l0nYX2ooooo`?o0?ZJ;Oooool5o`3jVP;ooooo0ol0nYXYooooo`?o0?ZJ7?oo
ool3o`0000?ooooo0_l00002o`00o`05o`3jV_oooooo0000o`000?l0nYX00_l00?l01?l0nY[ooooo
o`00ool00?l:ooooo`;o003o0oooool2o`00oa[ooooo0_l00?l01?oooooo0000o`000?ooool2o`3j
VP;ooooo0_l00?l5ooooo`;o0?ZJ0_l00002o`00o`So0?ZJ00Coooooo`3jV_l0nY[ooooo0ol00002
o`3jVPOooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0=ooooo`;o00000_ooool4
o`0006gooooo0_l0002Mooooo`;o00001oooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0
003oooooooooo`0?ooooo`03o`000?l0nY[o0?ZJ00Go0?ZJ00?oooooo`00ool00?l00ol0nYX00ooo
oooo0?ZJo`3jVP02ooooo`03o`000?l0nY[o0?ZJ00Cooooo00?o0?ZJo`00ool00?l00ol00003o`3j
VP;ooooo0_l0nYX2ooooo`?o0?ZJ;_ooool4o`3jVP;ooooo0ol0nYXYooooo`?o0?ZJ7?ooool3o`00
00?ooooo0_l00002o`00o`05o`3jV_oooooo0000o`000?l0nYX00_l00?l2o`3jVP;o003o2_ooool2
o`00o`03o`3jV_oooooooooo00;o003o6_ooool2o`00o`04ooooool0003o0000ooooo`;o0?ZJ0_oo
ool2o`00o`Gooooo0_l0nYX2o`0000;o003o00?o0?ZJo`000?l0nYX01Ol0nYX01?oooooo0?ZJo`3j
V_ooool3o`0000?o0?ZJ1_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00gooooo
0_l00002ooooo`?o0000K_ooool2o`0009gooooo0_l00007ooooo`03o`000?oooooooooo037ooooo
001>ooooo`;o00004Oooool00ol0003o0?ZJo`3jVP04o`3jVP04ooooool00?oo003oo`00o`;o0?ZJ
00?oooooo`3jV_l0nYX00_ooool3o`3jVPCooooo00?o0?ZJo`00ool00?l00ol00003o`3jVP;ooooo
0_l0nYX3ooooo`;o0?ZJ;oooool3o`3jVP?ooooo0_l0nYXZooooo`;o0?ZJ7?ooool3o`0000?ooooo
0_l00002o`00o`05o`3jV_oooooo0000o`000?l0nYX00_l00?l2o`3jVP;o003o2_ooool2o`00o`03
o`3jV_oooooooooo00;o003o4Oooool2o`000003ooooool0nY[o0?ZJ00Cooooo0_l00?l01?l0nY[o
ooooooooooooool2o`3jVP;ooooo0_l00?l5ooooo`;o0?ZJ0_l00002o`00o`03o`3jV_l0003o0?ZJ
00Go0?ZJ00Coooooo`3jV_l0nY[ooooo1?l00002o`3jVPGooooo0_l0000Kooooo`03o`000?oooooo
oooo00gooooo0_l000000ooooooo0000o`000002o`0006kooooo0_l0002Mooooo`;o00001oooool0
0ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`0@ooooo`03o`000?l0nY[o0?ZJ
00Co0?ZJ00Goooooo`000?l00?oo003oo`3jVP02ooooo`;o0?ZJ0_ooool3o`3jVP?ooooo0_l0nYX2
o`00o`03o`3jV_l0003o0?ZJ00Co0?ZJ00?oooooo`3jV_l0nYX00oooool2o`3jVS3ooooo0_l0nYY=
ooooo`?o00000oooool2o`0000;o003o00Go0?ZJooooool0003o0000o`3jVP02o`00o`;o0?ZJ0_l0
0?l:ooooo`;o003o00?o0?ZJooooooooool00_l00?lAooooo`;o00000ol0nYX4ooooo`;o003o00Co
0?ZJoooooooooooooooo0_l0nYX2ooooo`;o003o1Oooool2o`3jVP;o00000_l00?l00ol0nY[o0000
o`000008o`3jVP03ooooool0003o000000;o00000_l0nYX6ooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool03Oooool2o`000003ooooool0003o000000;o0000K_ooool2o`0009cooooo
0ol00007ooooo`03o`000?oooooooooo037ooooo001>ooooo`03o`000?oooooooooo013ooooo00?o
0000o`3jV_l0nYX01Ol0nYX01?l0003o003oo`00ool0nYX2ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
0_l0nYX00ooooooo0000o`3jVP02o`3jVP;o003o00Go0?ZJo`000?l0nY[o0?ZJooooo`02o`3jVP03
ooooool0nY[o0?ZJ08Cooooo0ol00003ooooo`;o00000ol00?l01?oooooo0000o`000?l0nYX2o`00
o`04ooooool0nY[o003oo`00o`[ooooo0_l00?l00ol0nY[oooooooooo`02o`00oa7ooooo00?o0000
o`3jV_l0nYX00_l0nYX4ooooo`;o003o00Co0?ZJoooooooooooooooo0_l0nYX2ooooo`;o003o1Ooo
ool2o`3jVP;o00000_l00?l01?l0nY[o0000o`000?ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ
00?oooooo`000?l000000_l00002o`3jVPKooooo00?o0000ooooooooool06Oooool2o`0000kooooo
0_l000000ooooooo0000o`000002o`0006kooooo0_l000000ooooooo0000o`00002Iooooo`?o0000
1Oooool3o`0003?ooooo001>ooooo`03o`000?oooooooooo01;ooooo0ol0nYX01?oooooo0?ZJo`3j
V_l0nYX2o`00o`03o`3jV_l0003ooooo00Oo0?ZJ00Goooooo`3jV_l0nY[o0?ZJo`000002o`00o`Co
0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYZ5ooooo`;o00000oooool2o`000004o`3jV_l00?oo003o
ooooo`;o000000?o0?ZJo`00ool00?l00_ooool2o`00o`[ooooo0_l00?l2o`3jVP03ooooool00?oo
003o017ooooo00?o0000o`3jV_l0nYX00_l0nYX4ooooo`;o003o00?o0?ZJooooooooool01?l0nYX0
0ooooooo003oo`00o`05ooooo`Ko003o00?o0?ZJo`000?l000001Oooool3o`3jVP04ooooool0003o
0000o`0000Wooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0=ooooo`Oo0000K_oo
ool2o`000003ooooool0003o000009Wooooo0_l00008ooooo`03o`000?oooooooooo037ooooo001>
ooooo`03o`000?oooooooooo01?ooooo0_l0nYX2ooooo`;o0?ZJ0_l00?l01?l0nY[o0000oooooooo
ool3o`3jVP04o`000?l0nY[o0?ZJo`0000;o0?ZJ00Co0000o`00ool00?oo003o1?l0nYX00ooooooo
0?ZJo`3jVP03o`3jVXGooooo0_l00003ooooo`;o000000Co0?ZJo`00ool00?oooooo0_l000000ol0
nY[o003oo`00o`02ooooo`;o003o2Oooool00ol0003o003oo`00o`02o`3jVP03ooooool00?oo003o
017ooooo1Ol0nYX4ooooo`;o003o0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP03ooooool00?oo003o
00Gooooo1_l00?l8ooooo`?o0?ZJ00Coooooo`000?l0003o00002Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo00kooooo1?l0001`ooooo`;o000000?oooooo`000?l00000VOooool2
o`0000Sooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool05oooool2o`3j
VP;o003o0_l00002ooooo`?o0?ZJ00Co0000o`3jV_l0nY[o00000_l0nYX00ol0003o003oo`00o`05
o`3jVP;ooooo1?l0nYZ5ooooo`;o00001?ooool01Ol0003o0?ZJo`00ool00?oooooo00;o00000ol0
0?l2ooooo`;o003o2Oooool00ol0003o003oo`00o`02o`3jVP03ooooool00?oo003o017ooooo0_l0
nYX00ol0003o0?ZJo`3jVP03ooooo`03o`000?l00?oo003o00;o0?ZJ00?oooooo`3jV_l0nYX00ol0
nYX2o`00o`Gooooo0_l00?l01?oooooo003oo`00ool00?l8ooooo`?o0?ZJ0_ooool2o`0000Wooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0>ooooo`?o0000LOooool5o`0009Wooooo
0_l00008ooooo`03o`000?oooooooooo037ooooo001>ooooo`;o00006Oooool00ol0nY[o003oo`00
o`05o`00o`03o`3jV_l0003o000000Go0?ZJ00Go0000o`00ool00?oo0?ZJo`000003o`3jVP;ooooo
1?l0nYZ5ooooo`;o00001?ooool01Ol0003o0?ZJo`00ool00?oooooo00;o00000_l00?l00ol0nY[o
ooooooooo`02o`00o`Wooooo00?o0000o`00ool00?l00_l0nYX00ooooooo003oo`00o`0Aooooo`;o
0?ZJ00?o0000o`3jV_l0nYX00oooool00ol0003o003oo`00o`02o`3jVP04ooooool0nY[o0?ZJo`00
00;o0?ZJ0_l00?l5ooooo`;o003o0_ooool2o`3jVPWooooo0_l0nYX2ooooo`;o00002?ooool2o`00
01_ooooo0_l0000?ooooo`?o0000LOooool5o`0000kooooo0_l00002ooooo`;o0000Q?ooool3o`00
00Kooooo0ol0000cooooo`00C_ooool00ol0003oooooooooo`0Hooooo`03o`3jV_l00?oo003o00Go
003o00Co0?ZJo`000?oooooo00001?l0nYX01?oooooo003oo`00ool0nYX2o`0000;o0?ZJ0oooool3
o`3jVXGooooo0_l00004ooooo`07o`000?l0nY[o003oo`00oooooooo0000o`3jVP02o`00o`03o`3j
V_oooooooooo00;o003o2Oooool00ol0003o003oo`00o`03o`3jVP;o003o4?ooool3o`3jVP03o`00
0?l0nY[o0?ZJ00?ooooo00?o0000o`00ool00?l01Ol0nYX00ol0003o0?ZJo`3jVP02o`00o`Gooooo
0_l00?l2ooooo`;o0?ZJ3Oooool2o`0000Wooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0>ooooo`?o0000LOooool5o`0000kooooo0_l00002ooooo`;o0000Q?ooool2o`0000Wooooo
00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool06?ooool01?l0003o0?ZJo`3j
V_ooool2o`0000;o003o00Co0?ZJoooooooooooo00000ol0nYX2ooooo`;o003o00?o0?ZJo`000?l0
00000_l0nYX4ooooo`;o0?ZJQOooool2o`0000Cooooo00Oo0000o`3jV_l00?oo003oooooool0003o
0?ZJ00;o003o00?o0?ZJooooooooool00_l00?l9ooooo`04o`000?l00?oo003oo`0000;o0?ZJ0_l0
0?l00ol0nY[oooooooooo`0=ooooo`;o0?ZJ0_l00002o`3jVP?ooooo00Co0000o`00ool00?oooooo
1?l0nYX00ol0003oooooo`3jVP02o`00o`Gooooo0_l00?l2ooooo`;o0?ZJ6?ooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo00kooooo0ol0001dooooo`;o00003_ooool3o`000004oooo
ool0003o0000o`0008?ooooo0_l00009ooooo`03o`000?oooooooooo037ooooo001>ooooo`03o`00
0?oooooooooo01Sooooo00Co0000o`3jV_l0nY[o0?ZJ0_l00003o`00o`;ooooo00Co0000o`3jV_l0
nY[o0?ZJ0_ooool2o`00o`03o`3jV_l0003o000008gooooo0_l00004ooooo`05o`000?l0nY[o003o
o`00ooooool00_l0nYX2o`00o`03o`3jV_oooooooooo00;o003o2Oooool00ol0003o003oo`00o`02
o`000004o`3jV_l00?oo003oo`3jVPoooooo0_l0nYX2o`0000;o0?ZJ0oooool01?l0003o003oo`00
ooooool4o`3jVP03o`000?oooooo0?ZJ00;o003o1Oooool2o`00o`;ooooo0_l0nYXHooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool03_ooool2o`0007Gooooo0ol0000<ooooo`Co0000
00Coooooo`000?l0003o0000P_ooool3o`0000Wooooo00?o0000ooooooooool0<Oooool004kooooo
00?o0000ooooooooool06?ooool2o`0000;o0?ZJ0ol00002o`00o`;ooooo00Co0000o`3jV_l0nY[o
0?ZJ0_ooool2o`00o`03o`3jV_oooooooooo08gooooo0_l00004ooooo`;o00000_l00?l00ooooooo
0?ZJo`3jVP02o`00o`03o`3jV_oooooooooo00;o003o2Oooool00ol0003o003oo`00o`02o`000004
ooooool00?oo003oo`3jVPoooooo0_l0nYX2o`0000;o0?ZJ0oooool00ol0nY[o003oo`00o`02oooo
o`?o0?ZJ00?o0000ooooooooool00_l00?l4ooooo`03o`000?l00?oo003o00;ooooo0_l0nYXHoooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0Q_ooool2o`0000cooooo1?l000001?oo
oooo0000o`000?l00022ooooo`;o00002_ooool00ol0003oooooooooo`0aooooo`00C_ooool2o`00
01Wooooo0_l00002o`3jVP?o00001_l00?l2o`3jVP;ooooo0_l00?l00ol0nY[oooooooooo`2Doooo
o`04o`000?l00?oo003oooooo`;o0?ZJ0_l00?l00ol0nY[o0000ooooo`02o`00o`Wooooo00?o0?ZJ
o`00ool00?l00_l000001?oooooo003oo`00ool0nYX>ooooo`?o0?ZJ0_l00002o`3jVP;ooooo00Co
0000o`3jV_l00?oo003o0oooool2o`3jVP03o`000?oooooooooo00;o003o00Goooooo`000?l0003o
ooooo`000002o`00o`04o`3jV_oooooo0?ZJo`3jVQOooooo0_l0000Kooooo`;o0000Qoooool2o`00
00cooooo1?l000001?oooooo0000o`000?l00022ooooo`;o00002?ooool3o`0003?ooooo001>oooo
o`03o`000?oooooooooo01Sooooo0_l00002o`3jVP?o00001_l00?l01?l0nY[oooooooooooooool2
o`00oiOooooo00?o0000o`00ool00?l00ol0nYX2o`00o`03o`3jV_l0003ooooo00;o003o2Oooool0
0ol0nY[o003oo`00o`02o`000004ooooool00?oo003oo`3jVPSooooo0_l0nYX4ooooo`;o0?ZJ0ol0
0002o`3jVP;ooooo00Co0000o`3jV_l00?oo003o1?ooool2o`0000;ooooo0_l00?l01Ooooooo0000
o`000?oooooo000000;o003o00Co0?ZJooooool0nY[o0?ZJ6?ooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo08Kooooo0_l0000:ooooo`Ko000000Coooooo`000?l0003o0000P_ooool2
o`0000[ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool06?ooool2o`00
00?o0?ZJ00Co0000ooooool0nY[o0?ZJ0_ooool8o`00oiOooooo00?o0000o`00ool00?l00_l0nYX0
0ol0003o003oo`00o`02o`000004ooooool00?oo003oo`3jVPSooooo00?o0?ZJo`00ool00?l00_l0
00001?oooooo003oo`00ool0nYX7ooooo`?o0?ZJ1?ooool6o`00o`05o`3jV_ooooooooooo`000?l0
nYX00_l00?l4ooooo`;o00000_ooool2o`00o`05o`3jV_l0003o0000ooooool000000_l00?l4o`3j
VQSooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`26ooooo`;o00002_ooool:o`00
08;ooooo0_l0000:ooooo`03o`000?oooooooooo037ooooo000jooooo`?o00000oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool06?ooool2o`000005
ooooool0nY[o0?ZJo`000?ooool00_l0nYX3ooooo`Oo003oUoooool00ol0003o003oo`00o`02o`3j
VP03ooooool00?oo003o00;o000000Coooooo`00ool00?oo0?ZJ2?ooool00ol0nY[o003oo`00o`02
o`000004ooooool00?oo003oo`3jVPKooooo1?l0nYX4ooooo`Oo003o0_ooool01?l0003o0?ZJo`00
ool00?l4ooooo`;o00000_ooool2o`00o`05o`3jV_l0003o0000ooooool000000_l00?l4o`3jVQSo
oooo00?o0000ooooooooool01_ooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Go
oooo00?o0000ooooooooool0Q_ooool2o`0000[ooooo2_l00021ooooo`?o00002_ooool00ol0003o
ooooooooo`0aooooo`00>oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool06?ooool2o`000005ooooool0nY[o0?ZJo`3jV_ooool00_l0nYX3ooooo`;o
0?ZJ0oooool2o`3jVYOooooo00Ko0000o`00ool00?oo0?ZJo`000?ooool2o`00o`;o000000Cooooo
o`00ool00?oo0?ZJ2?ooool00ol0nY[o003oo`00o`02o`000004ooooool00?oo003oo`00o`Gooooo
1Ol0nYX4ooooo`;o003o00?oooooo`000?l000000_l00?l2ooooo`04o`000?l0nY[o003oo`00o`Co
oooo0_l00002ooooo`;o003o00Go0?ZJo`000?l0003oooooo`000002o`00o`Co0?ZJ6?ooool00ol0
003oooooooooo`05ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`00
0004ooooo`03o`000?oooooooooo08Kooooo0_l0000:ooooo`Co000000?oooooo`000?l000000ol0
0021ooooo`;o00002oooool00ol0003oooooooooo`0aooooo`00>?ooool5o`0000[ooooo00?o0000
ooooooooool01?ooool3o`0001Sooooo0_l00002ooooo`Go0?ZJ0oooool3o`3jVP;ooooo0_l0nYZG
ooooo`06o`000?l00?oo003oo`3jV_l0003ooooo0_l00?l2o`000004ooooool00?oo003oo`3jVPSo
oooo00?o0?ZJo`00ool00?l00_l000001?oooooo0?ZJo`00ool00?l5ooooo`;o0?ZJ00?oooooo`3j
V_l0nYX01?ooool2o`00o`03ooooool0003o000000;o003o0_ooool01?l0003o0?ZJo`00ool00?l4
ooooo`;o00000_ooool2o`00o`03o`3jV_l0003o000000;o00000_l00?l01?oooooo0?ZJo`3jV_l0
nYXFooooo`?o00001oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo
0ol00003ooooo`?o0?ZJP?ooool4o`0000Sooooo0ol00002ooooo`Ko0000P?ooool2o`0000Wooooo
0ol0000cooooo`00>?ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool06?ooool2o`0000;ooooo1Ol0nYX3ooooo`?o0?ZJ0_ooool2o`3jVYOooooo
00Ko0000o`00ool00?oo0?ZJo`000?ooool2o`00o`;o000000Coooooo`00ool00?oo0?ZJ2?ooool0
0ol0nY[o003oo`00o`02o`000004ooooool0nY[o003oo`00o`Gooooo0_l0nYX00ooooooo0?ZJo`3j
VP04ooooo`;o003o00?o0?ZJo`000?l000000_l00?l2ooooo`04o`000?l00?oo003oo`00o`Cooooo
0_l00002ooooo`;o003o00Go0?ZJo`000?l0003o0000o`3jVP02o`00o`04ooooool0nY[o0?ZJo`3j
VQSooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00009ooooo`;o00001Oooool0
0ol0003oooooooooo`03oooooa7o0?ZJLoooool7o`0000Cooooo0_l00003ooooo`?o000000?ooooo
o`000?l00000P?ooool2o`0000_ooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000oooo
ool000003?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Sooooo0_l00002oooo
o`Go0?ZJ0oooool3o`3jVP;ooooo0_l0nYZGooooo`03o`000?l00?oo003o00;o000000?oooooo`00
ool00?l00_l000001?oooooo003oo`00ool0nYX8ooooo`?o003o0_l000001?oooooo0?ZJo`00ool0
0?l5ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?ooool2o`00o`03o`3jV_oooooo000000;o003o00?o
0?ZJooooool000000_l00?l00ol0nY[oooooooooo`02ooooo`;o00000_ooool2o`00o`05o`3jV_l0
003o0000o`000?l0nYX00_l00?l2ooooo`;o0?ZJ6?ooool00ol0003oooooooooo`05ooooo`04o`00
0?ooooooooooo`0000_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`05oooooago
0?ZJIOooool7o`0000Cooooo0_l00003ooooo`?o000000?oooooo`000?l00000Ooooool3o`0000_o
oooo00?o0000ooooooooool0<Oooool003[ooooo0_l00008ooooo`05o`000?ooooooooooooooool0
00001Oooool00ol0003oooooooooo`0Hooooo`;o00000oooool5o`3jVP;ooooo0ol0nYX2ooooo`;o
0?ZJUoooool00ol0003o003oo`00o`05o`00o`;o000000Coooooo`00ool00?oo0?ZJ2?ooool2o`00
o`05o`3jV_l0003o0000ooooool0nYX00_l00?l2ooooo`Go0?ZJ00?oooooo`3jV_l0nYX00oooool0
1_l0003o003oo`00ool0nY[oooooo`0000;o003o00?o0?ZJooooool000000_l00?l00ol0nY[ooooo
ooooo`02ooooo`?o000000Coooooo`00ool00?oo003o0ol000000ol0nY[o003oo`00o`0Looooo`03
o`000?oooooooooo00Gooooo00Co0000oooooooooooo00001oooool01Ol0003ooooooooooooooooo
000000Cooooo00?o0000ooooooooool04_oooolHo`3jVUkooooo1_l00004ooooo`;o00001?ooool2
o`000003ooooool0003o000007oooooo0ol0000;ooooo`03o`000?oooooooooo037ooooo000koooo
o`03o`000?oooooooooo00Kooooo1Ol00005ooooo`03o`000?oooooooooo01gooooo1Ol0nYX00ooo
oooo0?ZJo`3jVP03o`3jVP03ooooool0nY[o0?ZJ09Oooooo00?o0000o`00ool00?l01Ol00?l3o`00
00?o003o1oooool01?l0003o003oo`00ool0nYX2o`000004ooooool0nY[o003oo`00o`;ooooo1?l0
nYX2ooooo`;o0?ZJ0oooool01_l0003o003oo`00ool0nY[oooooo`0000;o003o00?o0?ZJooooool0
00000_l00?l00ol0nY[oooooooooo`03ooooo`;o000000Coooooo`3jV_l00?oo003o0ol000000ol0
nY[o003oo`00o`0Looooo`03o`000?oooooooooo00Kooooo0_l00009ooooo`?o00001Oooool00ol0
003oooooooooo`0Pooooo`_o0?ZJGOooool6o`0000?ooooo0ol00007ooooo`;o0000O_ooool3o`00
00cooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool07_ooool7o`3jVP04
ooooool0nY[o0?ZJooooo`;o0?ZJUoooool01?l0003o0?ZJo`3jV_l00004o`00o`04ooooool0003o
0000o`3jVP;o003o1oooool01?l0003o003oo`00ool0nYX2o`000005ooooool0nY[o003oo`00oooo
ool01Ol0nYX2ooooo`;o0?ZJ0oooool00ol0003o003oo`00o`02o`3jVP06o`000?l00?oo003oo`3j
V_oooooo00000_l00?l00ol0nY[oooooooooo`03ooooo`;o000000Coooooo`3jV_l00?oo003o0ol0
00000ol0nY[o003oo`00o`0Looooo`03o`000?oooooooooo01Wooooo0_l0000Zooooo`So0?ZJEooo
ool3o`000003ooooool0003o000000?ooooo0_l00008ooooo`;o0000>Oooool2o`0003cooooo0_l0
0005ooooo`?o00002_ooool3o`0003?ooooo001>ooooo`;o00008_ooool4o`3jVP04ooooool0nY[o
0?ZJooooo`;o0?ZJUoooool00ol0003o0?ZJo`3jVP02o`000004ooooool0nY[o0?ZJooooo`;o0000
00?o0?ZJo`00ool00?l01oooool01?l0003o003oo`00ool0nYX2o`0000;ooooo0_l00?l00ooooooo
0?ZJo`3jVP03o`3jVP;ooooo0_l0nYX3ooooo`03o`000?l00?oo003o00;o0?ZJ00Ko0000o`00ool0
0?oo0?ZJooooool00002o`00o`03o`3jV_oooooooooo00?ooooo0_l000001?oooooo0?ZJo`00ool0
0?l3o`000003o`3jV_l00?oo003o01_ooooo0_l0000Kooooo`03o`000?oooooooooo02[ooooo3?l0
nYYCooooo`;o000000?oooooo`000?l000000oooool2o`0000Sooooo0_l0000iooooo`;o0000??oo
ool2o`0000Gooooo0_l0000=ooooo`03o`000?oooooooooo037ooooo001>ooooo`03o`000?oooooo
oooo02;ooooo0ol0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVYOooooo00Ko0000o`3jV_l0nY[o0?ZJ
o`000?ooool2o`3jVP04ooooool0003o0000o`3jVP;o003o1oooool01?l0003o003oo`00ool0nYX2
o`0000;ooooo0_l00?l6o`3jVP;ooooo0_l0nYX3ooooo`03o`000?l00?oo003o00;o0?ZJ00Ko0000
o`00ool00?oo0?ZJo`000?l0nYX2o`00o`03o`3jV_oooooooooo00?ooooo0_l000001?oooooo0?ZJ
o`00ool00?l3o`0000?o003o7?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo033o
oooo2ol0nYY>ooooo`;o000000Coooooo`000?l0003o00000_ooool2o`0000Sooooo0_l0000ioooo
o`;o0000=oooool2o`0000?ooooo1?l00003ooooo`;o00003Oooool00ol0003oooooooooo`0aoooo
o`00C_ooool00ol0003oooooooooo`0Rooooo`?o0?ZJ00?oooooo`3jV_l0nYX00ol0nYZIooooo`;o
0?ZJ0_ooool2o`3jVP04ooooool0003o0000o`3jVP;o003o1oooool01?l0003o003oo`00ool0nYX2
o`0000;ooooo0_l00?l2o`3jVP03o`000?l0nY[o0?ZJ00?ooooo0_l0nYX3ooooo`03o`000?l00?oo
003o00;o0?ZJ00Ko0000o`00ool00?oo0?ZJo`000?l0nYX2o`00o`Kooooo0_l000001ooooooo0?ZJ
o`00ool00?oo0000ooooool000000_l00?l00ol0nY[oooooooooo`0Jooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool0=Oooool:o`3jVT[ooooo0_l00002ooooo`;o00000_ooool2o`00
00Sooooo0ol0000gooooo`Co0000=_ooool2o`0000;ooooo1_l00002ooooo`;o00003Oooool00ol0
003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`0Sooooo`;o0?ZJ0_ooool4o`3jVYWo
oooo0_l0nYX2ooooo`;o0?ZJ00Coooooo`000?l0003o0?ZJ0_l00?l6ooooo`;o00000_l00?l00ol0
nY[o0000o`000002ooooo`;o003o00?o0?ZJooooool000001ol00?l2o`000004ooooool0003o003o
o`00o`?o0?ZJ0ol00?l01?l0003o0?ZJo`00ool00?l6ooooo`;o000000Ooooooo`3jV_l00?oo003o
o`000?oooooo000000;o003o00?o0?ZJooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo03[ooooo4?l0nYXoooooo`;o00000_ooool2o`0000;ooooo0_l00009ooooo`;o
0000=oooool4o`0003Kooooo0ol000000ooooooo0000o`000008o`0000gooooo00?o0000oooooooo
ool0<Oooool004kooooo00?o0000ooooooooool08oooool2o`3jVP?ooooo0ol0nYZIooooo`;o0?ZJ
0_ooool2o`3jVP04ooooool0003o0000o`3jVP;o003o1_ooool2o`0000;o003o00?oooooo`000?l0
00000_ooool2o`00o`03o`3jV_oooooo000000Oo003o0_l000001Ooooooo0000o`00ool00?oooooo
00?o0?ZJ0_l00?l2o`3jVP;o003o1_ooool3o`000006o`3jV_l00?oo003oo`000?oooooo00000_l0
0?l00ol0nY[oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo0_l0000noooooaGo0?ZJ>ooo
ool2o`0000;ooooo0_l00009ooooo`;o0000=oooool4o`0003Kooooo0ol000000ooooooo0000o`00
0007o`0000cooooo0ol0000cooooo`00C_ooool2o`0002Wooooo0ol0nYZIooooo`?o0?ZJ00Cooooo
o`3jV_l0nY[ooooo0_l000000ol0nY[o003oo`00o`06ooooo`;o00000_l00?l00ooooooo0000o`00
0002ooooo`;o003o0_ooool00ol0003o003oo`00o`03ooooo`;o003o0_l000001?oooooo0000o`00
ool00?l2ooooo`;o0?ZJ0_l00?l2o`3jVP;o003o1_ooool4o`0000;o003o00?o0000ooooooooool0
0_l00?l00ol0nY[oooooooooo`0Iooooo`;o00006oooool00ol0003oooooooooo`19ooooobSo0?ZJ
7?ooool2o`0000;ooooo0_l00009ooooo`;o0000<?ooool7o`3jVPCo00000oooool2o`0000cooooo
0ol0nYXQooooo`Co000000?oooooo`000?l000001ol0000>ooooo`03o`000?oooooooooo037ooooo
001>ooooo`03o`000?oooooooooo02Wooooo0_l0nYZJooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo
0ol00002o`00o`Kooooo0_l00002o`00o`05ooooool0003o0000o`000?ooool00_l00?l2ooooo`04
o`000?l00?oo003oo`3jVP;ooooo0_l00?l2o`000004ooooool0003o003oo`00o`;ooooo00Co0000
o`3jV_l00?oo003o0_l0nYX2o`00o`Kooooo1?l00002o`00o`03o`000?oooooooooo00;o003o00?o
0?ZJooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo057ooooo8Ol0
nYXKooooo`;o000000Coooooo`000?l0003o00002Oooool3o`0002oooooo3?l0nYX01?oooooo0000
o`000?l0000<ooooo`Ko0?ZJ7_ooool4o`000003ooooool0003o000000Oo00003_ooool00ol0003o
ooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`35ooooo`Go0?ZJ0_ooool2o`0000;o003o
1_ooool01?l0003o0?ZJo`00ool00?l2ooooo`;o000000?oooooo`00ool00?l00_l00003o`00o`03
o`3jV_oooooooooo00;o003o0_l000001?oooooo0000o`00ool00?l2ooooo`06o`000?l0nY[o003o
o`00ool0nY[o00000_l00?l6ooooo`Co00000_l00?l00ol0003oooooooooo`02o`00o`03o`3jV_oo
oooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`1`ooooo`Wo0?ZJ0ooo
ool4o`3jVPgooooo0_l0nYX01?oooooo0000o`000?l0000:ooooo`;o00009?ooool7o`3jVPCooooo
0_l0nYX4ooooo`Ko0?ZJ00Goooooo`000?l0003o0000ooooo`06o`3jVPCooooo1ol0nYXNooooo`[o
00000_ooool2o`0000kooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0
a_ooool4o`3jVP;ooooo0_l00002o`00o`Cooooo0_l00002o`3jVP;o003o0_ooool2o`000003oooo
ool00?oo003o00;o00000_l00?l2o`3jVP;ooooo0_l00?l2o`000004ooooool0003o003oo`00o`?o
oooo00Go0?ZJo`00ool00?oo0?ZJo`000002o`00o`Kooooo1?l00002o`00o`03o`000?oooooo0?ZJ
00;o003o00?o0?ZJooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
077ooooo6Ol0nYX3oooooa7o0?ZJ00?o0000ooooooooool00_l0000Pooooo`Oo0?ZJ1?ooool2o`3j
VPGooooo0_l000001?oooooo0?ZJo`3jV_ooool3o`000003ooooool0nY[o0?ZJ00[o0?ZJ0oooool2
o`3jVPGooooo1_l0nYX:ooooo`Oo0?ZJ0_ooool2o`000005ooooool0003o0000o`000?ooool00ol0
000Booooo`03o`000?oooooooooo037ooooo001>ooooo`03o`000?oooooooooo0<Kooooo1?l0nYX3
ooooo`03o`000?l00?oo003o00Cooooo0_l00002o`3jVP;o003o0_ooool2o`000003ooooool00?oo
003o00;o00000_l00?l2o`3jVP;ooooo0_l00?l3o`000003o`3jV_l00?oo003o00?ooooo00?o0?ZJ
o`00ool00?l00_l00002o`00o`Kooooo1?l00002o`00o`03o`000?l0nY[o0?ZJ00;o003o7Oooool0
0ol0003oooooooooo`0Iooooo`;o0000NOooool5o`3jVP;ooooo8?l0nYX01?oooooo0000o`000?l0
000Kooooo`Oo0?ZJ0oooool3o`3jVP?ooooo0_l0nYX5ooooo`;o000000Coooooo`3jV_l0nY[o0?ZJ
0ol00003o`3jVP?ooooo1ol0nYX3ooooo`?o0?ZJ1?ooool6o`3jVP[ooooo1ol0nYX2ooooo`;o0000
00Coooooo`000?l0003o00000_ooool2o`00013ooooo0ol0000cooooo`00C_ooool2o`000<Oooooo
1?l0nYX3ooooo`03o`000?l00?oo003o00Cooooo00Co0000o`3jV_l0nY[o0?ZJ0_l00?l2ooooo`;o
000000?oooooo`00ool00?l01?l00?l3o`3jVP03ooooool00?oo003o00?o000000?o0?ZJo`00ool0
0?l00oooool00ol0nY[o003oo`00o`02o`0000;o003o1_ooool4o`0000;o003o00?o0000o`3jV_l0
nYX00_l00?lLooooo`;o00006oooool00ol0003oooooooooo`29ooooo`Go0?ZJ1Ol0000:ooooo`Oo
0?ZJ5?ooool=o`3jVPCooooo1ol0nYX4ooooo`?o000000?oooooo`000?l0nYX01_l0nYX?ooooo`So
0?ZJ0_ooool2o`3jVP[ooooo0_l0nYX3ooooo`;o0?ZJ0_ooool2o`000004ooooool0003o0000o`00
01Kooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0aoooool3o`3jVP?o
oooo00?o0000o`00ool00?l01?ooool01?l0003o0?ZJo`3jV_ooool2o`00o`;ooooo0_l000000ooo
oooo003oo`00o`04o`00o`?o0?ZJ00?oooooo`00ool00?l00ol000000ol0nY[o003oo`00o`04oooo
o`;o003o0_l00002o`00o`Kooooo1?l00002o`00o`?o0?ZJ0_l00?lMooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool0Soooool3o`0000cooooo2ol0nYX00ol0003oooooooooo`07oooo
o`co0?ZJ0oooool3o`3jVPCooooo1ol0nYX4ooooo`;o00000_ooool00ol0003o0?ZJo`3jVP05o`3j
VPoooooo1ol0nYX3ooooo`?o0?ZJ2?ooool3o`3jVP03o`000?oooooooooo00?o0?ZJ00?oooooo`00
0?l000000_ooool2o`0001Kooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000oooooooo
ool0b?ooool2o`3jVP?ooooo00?o0000o`00ool00?l01?ooool3o`3jVP03ooooool00?oo003o00;o
oooo0_l000000ooooooo0?ZJo`3jVP03o`0000Co0?ZJ00?oooooo`00ool00?l00ol000000ol0nY[o
003oo`00o`04ooooo`;o003o00Co0000ooooool00?oo003o1_ooool4o`0000;o003o0_l0nYX00ooo
oooo003oo`00o`0Mooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0T?ooool2o`00
00cooooo1?l00007o`3jVP03o`000?oooooooooo00Oooooo1ol0nYXJooooo`;o00000_ooool7o`00
01_ooooo3?l0nYX2o`0000?ooooo1_l0nYXIooooo`03o`000?oooooooooo037ooooo001>ooooo`03
o`000?oooooooooo0<gooooo00?o0000o`00ool00?l01?ooool2o`3jVP04o`000?oooooo003oo`00
o`;ooooo0_l000000ooooooo0?ZJo`3jVP03o`0000Co0?ZJ00?oooooo`00ool00?l00ol000000ol0
nY[o003oo`00o`04ooooo`Ko003o1oooool3o`0000;o003o0_l0nYX00ooooooo003oo`00o`0Moooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0T?ooool2o`0000cooooo1_l00003oooo
o`?o0?ZJ0oooool8o`3jVP;ooooo0_l0000Kooooo`;o00000_ooool4o`000003ooooool0003o0000
00Cooooo0_l0000Eooooo`co0?ZJ0_l00003oooooa7o0?ZJ1Oooool2o`3jVPOooooo00?o0000oooo
ooooool0<Oooool004kooooo00?o0000ooooooooool0cOooool00ol0003o003oo`00o`03ooooo`?o
0?ZJ00Co0000ooooool00?oo003o0_ooool2o`000003ooooool0nY[o0?ZJ00;o00001_l0nYX2o`00
o`?o000000?o0?ZJo`00ool00?l01?ooool6o`00o`Oooooo0ol00002o`00o`;o0?ZJ00?oooooo`00
ool00?l07Oooool00ol0003oooooooooo`0Iooooo`;o0000TOooool2o`0000cooooo1_l00004oooo
o`co0?ZJ0oooool3o`0001Sooooo1?l00002ooooo`Co000000?oooooo`000?l000001?ooool2o`00
023ooooo0ol00004ooooo`?o000000?oooooo`3jV_l0nYX04Ol0nYX5ooooo`?o0000<oooool004ko
oooo00?o0000ooooooooool0cOooool00ol0003o003oo`00o`02ooooo`Co0?ZJ00Co0000ooooool0
0?oo003o0_ooool3o`0000;o0?ZJ0_l00002o`3jVP;o00000_l0nYX2o`00o`03o`3jV_l0003o0000
00?o003o1?ooool2o`3jVP04o`000?l00?oo003oo`00o`Oooooo0ol00002o`00o`;o0?ZJ00?ooooo
o`00ool00?l07Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo093ooooo0_l0000<
ooooo`?o000000?oooooo`000?l000001?ooool7o`3jVPSooooo1?l00007ooooo`;o00003Oooool4
o`0000?ooooo0ol00002ooooo`?o00000oooool3o`0001kooooo1Ol00003ooooo`?o00003?ooool7
o`3jVPSooooo00?o0000ooooooooool0<Oooool004kooooo0_l0003>ooooo`04o`000?l00?oo003o
ooooo`Go0?ZJ00Co0000ooooool00?oo003o0_ooool3o`0000;o0?ZJ0_l00002o`3jVP;o000000Go
ooooo`3jV_l00?oo003oo`3jVP02o`0000;o003o00?o0?ZJooooooooool00_ooool2o`3jVP04o`00
0?oooooo0?ZJo`3jVPOooooo0ol00002o`00o`03o`3jV_oooooooooo00;o003o7?ooool2o`0000;o
oooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00003ooooo`?o00001Oooool00ol0003o
ooooooooo`2@ooooo`;o00003?ooool3o`000003ooooool0003o000000Cooooo0ol0000;ooooo`Go
00001oooool2o`0000gooooo1?l00003ooooo`?o00000oooool2o`0000?ooooo0ol0000Nooooo`;o
000000?oooooo`000?l000000_ooool4o`0001_ooooo00?o0000ooooooooool0<Oooool004kooooo
00?o0000ooooooooool0cOooool01?l0003o003oo`00ooooool2o`3jVP03ooooool00?oo003o00Co
003o0_ooool3o`0000?o0?ZJ00?oooooo`3jV_l0nYX00_l00002ooooo`;o003o00?o0?ZJo`000?l0
00000_l00?l00ol0nY[oooooooooo`02ooooo`;o0?ZJ00Co0000ooooool0nY[o0?ZJ1oooool3o`00
00;o003o00?o0?ZJooooooooool00_l00?lMooooo`03o`000?oooooo000000;ooooo00?o0000oooo
ooooool01Oooool01ol0003ooooooooooooooooo0000ooooool000000oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo09oooooo0_l000000ooooooo0000o`000004ooooo`?o00002ooo
ool6o`0000?ooooo0_l000000ooooooo0000o`000008ooooo`?o000000?oooooo`000?l000000ol0
0004ooooo`;o00000oooool2o`0000?ooooo0ol0000Nooooo`;o000000?oooooo`000?l000000_oo
ool4o`0001_ooooo00?o0000ooooooooool0<Oooool004kooooo00?o0000ooooooooool0cOooool0
1?l0003o003oo`00ooooool2o`3jVP03ooooool00?oo003o00Co003o0_ooool4o`0000;o0?ZJ00?o
ooooo`3jV_l0nYX00ol000001_oooooo003oo`00ool0nY[oooooo`0000;o003o00?o0?ZJoooooooo
ool00_ooool2o`3jVP04o`000?oooooo0?ZJo`3jVPOooooo0ol00002o`00o`03o`3jV_oooooooooo
00;o003o7Oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo09oooooo0_l000000ooo
oooo0000o`000003ooooo`Co00002oooool6o`0000?ooooo1_l00007ooooo`?o000000Coooooo`00
0?l0003ooooo0_l00009ooooo`;o00000oooool3o`0001kooooo0_l000001?oooooo0000o`000?oo
ool5o`0001_ooooo00?o0000ooooooooool0<Oooool003Cooooo0ol00003ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool3o`0000Kooooo00?o0000ooooooooool0cOooool0
0ol0003o003oo`00o`03o`3jVP04ooooool00?oo003oooooo`?o003o0oooool3o`0000Go0?ZJ00Co
ooooo`000?l0003ooooo0_l00?l00ol0nY[oooooo`000002o`00o`03o`3jV_oooooooooo00;ooooo
0_l0nYX2ooooo`;o0?ZJ1oooool3o`0000;o003o0oooool2o`00oagooooo00?o0000ooooool00000
0_ooool00ol0003oooooooooo`07ooooo`;o00001_ooool00ol0003oooooooooo`02ooooo`?o0000
X_ooool2o`0000?ooooo1?l0000;ooooo`Ko000000?oooooo`000?l000001_l00007ooooo`?o0000
00?oooooo`000?l000003?ooool2o`0000?ooooo0ol0000Nooooo`;o000000Coooooo`000?l0003o
oooo1Ol0000Iooooo`?o0000<oooool003Gooooo00?o0000ooooooooool02?ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3=ooooo`03
o`000?l00?oo003o00;o0?ZJ0_ooool2o`00o`;ooooo0_l0nYX3ooooo`?o000000?oooooo`3jV_l0
nYX00_l0nYX01?oooooo0000o`000?ooool2o`00o`03o`3jV_oooooo000000;o003o00?o0?ZJoooo
ooooool00_ooool2o`3jVP;ooooo0_l0nYX7ooooo`?o00001ol00?lMooooo`03o`000?oooooo0000
00;ooooo00?o0000ooooooooool02Oooool00ol0003oooooo`000003o`0000Gooooo00?o0000oooo
ooooool0X_ooool2o`0000?ooooo1?l0000;ooooo`;o00000_ooool;o`0000Oooooo0ol000000ooo
oooo0000o`00000<ooooo`?o00000_ooool3o`0001gooooo0ol000001?oooooo0000o`000?ooool3
o`0001gooooo00?o0000ooooooooool0<Oooool003;ooooo1Ol0000:ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool00oooool3o`000<gooooo00?o0000o`00ool00?l00_l0nYX2o`00
00;o003o0_ooool2o`3jVP?ooooo0ol000000ooooooo0?ZJo`3jVP02o`3jVP04ooooool0003o0000
ooooo`?o003o00Goooooo`000?l00?oo003oo`3jVP04ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01ooo
ool3o`0000Oo003o6oooool3o`000005ooooool0003oooooooooool000001oooool01ol0003ooooo
oooooooooooo0000ooooool000002?ooool00ol0003oooooooooo`2Rooooo`;o00000oooool4o`00
00_ooooo0_l00003ooooo`[o00001oooool6o`0000gooooo0_l00002ooooo`?o00007Oooool2o`00
00;ooooo1_l0000Mooooo`03o`000?oooooooooo037ooooo000booooo`04o`000?ooooooooooo`00
00_ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
0<gooooo00Co0000o`00ool00?oo0?ZJ0ol00002o`00o`;ooooo0_l0nYX3ooooo`;o00000oooool3
o`3jVP05ooooool0003o0000ooooool0nYX00_l00?l01Ooooooo0000o`00ool00?oo0?ZJ00Gooooo
0_l0nYX00ooooooo0?ZJo`3jVP07ooooo`?o00000_l0nYX3ooooo`;o0?ZJ7Oooool00ol0003ooooo
ooooo`02o`0000Wooooo0ol00002ooooo`Go00001?ooool00ol0003oooooooooo`2Rooooo`;o0000
0oooool4o`0000Oooooo0_l000001?oooooo0000o`000?l00003ooooo`[o00001Oooool7o`0000ko
oooo0_l000000ooooooo0000o`000003o`0001cooooo0_l00003ooooo`Co00007_ooool00ol0003o
ooooooooo`0aooooo`00<oooool00ol0003oooooo`00000<ooooo`03o`000?oooooo000000?o0000
1_ooool00ol0003oooooooooo`3>ooooo`;o003o00?o0?ZJo`000?l000000ol00?l2ooooo`;o0?ZJ
0oooool2o`0000Cooooo0_l0nYX01Ooooooo0000o`000?oooooo0?ZJ00;o003o0_ooool2o`00o`Ko
oooo1Ol0nYX7ooooo`?o00000_l0nYX3ooooo`;o0?ZJ7Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo0:;ooooo0_l00003ooooo`Co00001oooool2o`000003ooooool0003o000000Co
oooo2ol00004ooooo`?o000000Coooooo`000?l0003o00003_ooool2o`000004ooooool0003o0000
ooooo`;o00007?ooool2o`0000?ooooo1?l0000Nooooo`03o`000?oooooooooo037ooooo000doooo
o`;o00002?ooool01ol0003ooooooooooooooooo0000ooooool000002Oooool00ol0003ooooooooo
o`3>ooooo`;o003o00?o0?ZJo`000?l000000_l00?l00ol0nY[oooooooooo`02o`3jVP?ooooo0_l0
0004ooooo`;o0?ZJ00Goooooo`000?l0003oooooo`3jVP02o`00o`;ooooo0_l00?l7ooooo`Co0?ZJ
2?ooool2o`0000?o0?ZJ0_ooool2o`3jVQgooooo00?o0000ooooooooool06Oooool2o`000:?ooooo
0ol00002ooooo`Co00001oooool2o`000003ooooool0003o000000Cooooo1ol000001?oooooo0000
o`000?l00004ooooo`?o000000Coooooo`000?l0003o00003_ooool2o`000004ooooool0003o0000
ooooo`;o00007?ooool2o`0000?ooooo0ol0000Mooooo`?o0000<oooool003Gooooo00?o0000oooo
ooooool01_ooool5o`000003ooooool0003o000000?o00001Oooool00ol0003oooooooooo`3>oooo
o`;o003o00?o0?ZJo`000?l000000_l00?l2o`3jVP03ooooool0nY[o0?ZJ00Wooooo0_l0nYX01Ooo
oooo0000o`000?oooooo0?ZJ00;o003o0_ooool2o`00o`Sooooo0ol0nYX8ooooo`;o000000?ooooo
o`3jV_l0nYX00_ooool2o`3jVQgooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`2S
ooooo`;o000000?oooooo`000?l000000ol00007ooooo`;o000000?oooooo`000?l000001Oooool6
o`000004ooooool0003o0000o`0000;ooooo1Ol000001?oooooo0000o`000?l0000>ooooo`;o0000
00Coooooo`000?l0003ooooo0_l0000Kooooo`?o00000oooool3o`0001oooooo00?o0000oooooooo
ool0<Oooool004kooooo00?o0000ooooooooool0c_ooool2o`00o`?o00000_l00?l2o`3jVP03oooo
ool0nY[o0?ZJ00cooooo0_l000001?oooooo0?ZJo`00ool00?l2ooooo`;o003o2?ooool3o`3jVPSo
oooo0_l000000ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ7Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo0:?ooooo0_l000001?oooooo0000o`000?ooool2o`0000Oooooo1Ol00005oooo
o`Go00000_ooool3o`0000;ooooo1Ol000001?oooooo0000o`000?l0000>ooooo`Go000000?ooooo
o`000?l000006oooool2o`0000Cooooo0ol0000Oooooo`03o`000?oooooooooo037ooooo001>oooo
o`;o0000coooool7o`00o`Go0?ZJ3?ooool2o`000006ooooool0nY[o003oo`00oooooooo0?ZJ0_l0
0?l8ooooo`?o0?ZJ2?ooool2o`000003ooooool0nY[o0?ZJ00;ooooo0_l0nYXLooooo`;o00006ooo
ool00ol0003oooooooooo`2Sooooo`;o000000Coooooo`000?l0003ooooo0_l00006ooooo`Ko0000
1Oooool2o`000003ooooool0003o000000;ooooo0ol00002ooooo`Co00000_ooool3o`0000oooooo
1?l000000ooooooo0000o`00000Kooooo`;o00001Oooool2o`0001oooooo00?o0000ooooooooool0
<Oooool004kooooo00?o0000ooooooooool0c_ooool7o`00o`Go0?ZJ3?ooool2o`000006ooooool0
nY[o003oo`00oooooooo0?ZJ0_l00?l9ooooo`;o0?ZJ2?ooool2o`000005ooooool0nY[o0?ZJo`3j
V_ooool00_l0nYXMooooo`03o`000?oooooooooo01Wooooo0_l0002Tooooo`;o000000Coooooo`00
0?l0003ooooo0_l00006ooooo`Ko00002?ooool2o`0000?ooooo0ol000001?oooooo0000o`000?l0
0003ooooo`?o00003oooool3o`0000;ooooo0_l0000Kooooo`;o00001Oooool2o`0001gooooo0ol0
000cooooo`00C_ooool00ol0003oooooooooo`3>ooooo`;o0?ZJ0ol00003o`3jVP04ooooool0nY[o
0?ZJo`3jVPcooooo0_l00002ooooo`;o003o0_l0nYX2o`00oaOooooo0_l0nYX00ooooooo0?ZJo`3j
VP0Mooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0Xoooool5o`000004ooooool0
003o0000o`0000Gooooo1_l0000>ooooo`;o000000Coooooo`000?l0003o00000oooool2o`00013o
oooo0ol00002ooooo`;o00006_ooool3o`0002Kooooo00?o0000ooooooooool0<Oooool004kooooo
00?o0000ooooooooool0c_ooool3o`3jVP;ooooo0_l0nYX2ooooo`?o0?ZJ3?ooool2o`0000;ooooo
0_l00?l2o`3jVP;o003o5oooool2o`3jVP03ooooool0nY[o0?ZJ01gooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`2Tooooo`Co00000_ooool2o`0000Gooooo0_l000001?oooooo0000
o`000?l0000>ooooo`;o000000Coooooo`000?l0003o00000oooool2o`00013ooooo0ol00002oooo
o`;o000000?oooooo`000?l000005oooool2o`0002Oooooo00?o0000ooooooooool0<Oooool004ko
oooo00?o0000ooooooooool0coooool2o`3jVP;ooooo0_l0nYX3ooooo`;o0?ZJ3?ooool2o`0000;o
oooo0_l00?l01?l0nY[oooooo`00ool00?lGooooo`Go0?ZJ7Oooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo0:Cooooo1?l00002ooooo`;o00001Oooool2o`000003ooooool0003o0000
00oooooo1_l00003ooooo`;o00004?ooool2o`0000?ooooo0_l000000ooooooo0000o`00000Goooo
o`;o00009oooool00ol0003oooooooooo`0aooooo`00C_ooool2o`000=3ooooo0_l0nYX2ooooo`;o
0?ZJ0oooool2o`3jVPcooooo0_l00002ooooo`;o003o00Co0?ZJooooool00?oo003o6?ooool4o`3j
VQcooooo0_l0000Kooooo`03o`000?oooooooooo0:Gooooo0ol00002ooooo`Co00000oooool2o`00
0003ooooool0003o000000oooooo1?l00005ooooo`;o00004?ooool2o`0000?ooooo1Ol0000Foooo
o`?o00009oooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`3?ooooo`;o
0?ZJ0_ooool2o`3jVQ7ooooo0_l00002ooooo`;o003o0_ooool2o`00oaSooooo1?l0nYXMooooo`03
o`000?oooooooooo01Wooooo0_l0002Wooooo`;o00000_ooool5o`0000;ooooo0_l000000ooooooo
0000o`00000?ooooo`Co00001Oooool2o`00013ooooo0_l00003ooooo`Go00005_ooool2o`0002Ko
oooo0ol0000cooooo`00C_ooool00ol0003oooooooooo`3?ooooo`?o0?ZJ00?oooooo`3jV_l0nYX0
4Oooool2o`0000;ooooo0_l00?l2ooooo`;o003o6Oooool3o`3jVQgooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`2Vooooo`;o00000_ooool5o`0000;ooooo0_l000000ooooooo0000
o`00000@ooooo`?o00007Oooool4o`0001Kooooo0_l0000Xooooo`03o`000?oooooooooo037ooooo
001>ooooo`03o`000?oooooooooo0=3ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Aooooo`Co00000_l0
0?l2ooooo`;o003o6_ooool2o`3jVQgooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`2Zooooo`Go00000_ooool2o`000003ooooool0003o0000013ooooo0ol0000Mooooo`Co00000_oo
ool3o`00017ooooo0_l0000Xooooo`03o`000?oooooooooo037ooooo001>ooooo`03o`000?oooooo
oooo0=3ooooo1Ol0nYXAooooo`Co00000_l00?l2ooooo`;o003o>Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo0:[ooooo2Ol0000Cooooo`?o00007Oooool9o`00017ooooo0_l0000X
ooooo`03o`000?oooooooooo037ooooo001>ooooo`;o0000d_ooool4o`3jVQ7ooooo1?l00002o`00
o`;ooooo0_l00?lhooooo`;o00006oooool00ol0003oooooooooo`2[ooooo`;o000000?oooooo`00
0?l000000_l0000Dooooo`?o00007Oooool9o`00017ooooo0_l0000Xooooo`03o`000?oooooooooo
037ooooo001>ooooo`03o`000?oooooooooo0=7ooooo1?l0nYXBooooo`?o00001_l00?liooooo`03
o`000?oooooooooo01Wooooo0_l0002_ooooo`Co00005?ooool2o`0001kooooo2Ol0000Aooooo`;o
00009_ooool3o`0003?ooooo001>ooooo`03o`000?oooooooooo0=7ooooo1?l0nYXEooooo`Ko003o
>Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0:kooooo1?l0000dooooo`Wo0000
00?oooooo`000?l000003?ooool4o`0002Sooooo00?o0000ooooooooool0<Oooool004kooooo00?o
0000ooooooooool0d_ooool3o`3jVQGooooo0_l0nYX2ooooo`;o0?ZJ>Oooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo0:kooooo1?l0000dooooo`Ko000000?oooooo`000?l000000ol0
000<ooooo`Co0000:?ooool00ol0003oooooooooo`0aooooo`00C_ooool00ol0003oooooooooo`3C
ooooo`;o0?ZJ5Oooool2o`3jVP;ooooo0_l0nYXiooooo`03o`000?oooooooooo00Kooooo0_l00004
ooooo`03o`000?oooooooooo00?ooooo0ol00004ooooo`03o`000?oooooooooo0:oooooo0_l0000e
ooooo`Go00000oooool6o`0000[ooooo1?l0000Xooooo`03o`000?oooooooooo037ooooo001>oooo
o`03o`000?oooooooooo0>[ooooo0_l0nYX2ooooo`;o0?ZJ>Oooool00ol0003oooooooooo`05oooo
o`04o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2_
ooooo`;o0000=_ooool2o`0000Gooooo1_l0000:ooooo`Co0000:?ooool00ol0003oooooooooo`0a
ooooo`00C_ooool2o`000>_ooooo0_l0nYX2ooooo`;o0?ZJ>?ooool2o`0000Oooooo00Co0000oooo
oooooooo00001oooool5o`0000Cooooo0ol0003Wooooo`;o00001Oooool6o`0000Cooooo0_l00004
ooooo`Co00009_ooool3o`0003?ooooo001>ooooo`03o`000?oooooooooo0>[ooooo0_l0nYX2oooo
o`;o0?ZJ>Oooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000Oooooo00Co0000
oooooooooooo00001Oooool00ol0003oooooooooo`3Wooooo`;o00001Oooool8o`000004ooooool0
003o0000o`0000?ooooo1?l0000Yooooo`03o`000?oooooooooo037ooooo001>ooooo`03o`000?oo
oooooooo0>[ooooo0ol0nYX00ooooooo0?ZJo`3jVP0iooooo`03o`000?oooooooooo00Gooooo00Co
0000oooooooooooo00002?ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo0>kooooo
3Ol00002ooooo`Co0000:Oooool00ol0003oooooooooo`0aooooo`00>_ooool3o`0000?ooooo00?o
0000ooooooooool00_ooool3o`0000Kooooo00?o0000ooooooooool0joooool2o`3jVP03ooooool0
nY[o0?ZJ03Wooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00009ooooo`;o0000
1Oooool00ol0003oooooooooo`3^ooooo`;o000000?oooooo`000?l000002Ol000000ooooooo0000
o`00000[ooooo`03o`000?oooooooooo037ooooo000kooooo`03o`000?oooooooooo00Kooooo00Go
0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo0>_ooooo1Ol0nYXiooooo`03o`00
0?oooooooooo00Kooooo0_l0000;ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
lOooool6o`000003ooooool0003o000000;o000000?oooooo`000?l00000:oooool00ol0003ooooo
ooooo`0aooooo`00>?ooool5o`0000Oooooo00Go0000ooooooooooooooooo`000005ooooo`?o0000
k?ooool4o`3jVSOooooo0ol0000Kooooo`;o0000l_ooool2o`0000;ooooo0_l00002ooooo`?o0000
00?oooooo`000?l00000:Oooool3o`0003?ooooo000hooooo`04o`000?ooooooooooo`0000Wooooo
0ol00006ooooo`03o`000?oooooooooo0>cooooo1?l0nYXiooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool0lOooool2o`0000Kooooo1_l0000[ooooo`03o`000?oooooooooo037ooooo
000iooooo`03o`000?oooooo000000Sooooo00Go0000ooooooooooooooooo`000005ooooo`03o`00
0?oooooooooo0>gooooo0ol0nYXiooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
nOooool6o`0002_ooooo00?o0000ooooooooool0<Oooool003[ooooo0_l00008ooooo`05o`000?oo
ooooooooooooool000001Oooool00ol0003oooooooooo`3^ooooo`;o0?ZJ>Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo0?_ooooo1?l0000[ooooo`03o`000?oooooooooo037ooooo
000kooooo`03o`000?oooooooooo00Oooooo0ol00006ooooo`03o`000?oooooooooo0>kooooo0_l0
nYXiooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0noooool3o`0002cooooo00?o
0000ooooooooool0<Oooool004kooooo0_l0003oooooob[ooooo0_l0000Kooooo`;o0000oooooolZ
ooooo`?o0000<oooool004kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`04o`000?ooooooooooo`0001_ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`05o`000?ooooooooooooooool00000<oooool004kooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0001_ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooooooool00000<oooool004koooooool0
000^o`0001_oooooool0000_o`0003?ooooo003ooooooooooooonOooool00?oooooooooooooioooo
o`00ooooooooooooooWooooo003ooooooooooooonOooool00?oooooooooooooiooooo`00oooooooo
ooooooWooooo003ooooooooooooonOooool00?oooooooooooooiooooo`00ooooooooooooooWooooo
003ooooooooooooonOooool00?oooooooooooooiooooo`00ooooooooooooooWooooo003ooooooooo
oooonOooool00?oooooooooooooiooooo`00ooooooooooooooWooooo003ooooooooooooonOooool0
0?ooooooK?ooool00ol0003oooooooooo`0Cooooo`?o00000oooool3o`000?ooooooK_ooool00?oo
ooooKOooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0oooooom]ooooo`00oooooomJooooo`;o00000_ooool3o`000003ooooool0003o000000?o0000
1_ooool00ol0003oooooooooo`06ooooo`;o000000?oooooo`000?l000000_ooool4o`0000;ooooo
0ol00003ooooo`?o00000oooool4o`0000;ooooo1?l00003ooooo`;o0000oooooomKooooo`00oooo
oomIooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooo000000;ooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003ooooo
ooooo`07ooooo`04o`000?ooooooooooo`000?ooooooF_ooool00?ooooooFOooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool03oooool2o`0000Co
oooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool3
o`0000?ooooo1?l00002ooooo`04o`000?ooooooooooo`000?ooooooF_ooool00?ooooooFOooool0
1?l0003oooooooooool00002ooooo`;o00001?ooool3o`0000oooooo00?o0000ooooool000000_oo
ool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooo
oooo0000ooooool00002ooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooo0000oooo
oomJooooo`00oooooomIooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooool000000ooo
ool00ol0003oooooooooo`0?ooooo`04o`000?oooooo0000o`0000;ooooo0_l00003ooooo`Co0000
0_ooool4o`0000?ooooo0_l0000:ooooo`04o`000?ooooooooooo`000?ooooooF_ooool00?oooooo
FOooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00003_ooool00ol0003oooooooooo`0Qooooo`04o`000?ooooooooooo`000?ooooooF_oo
ool00?ooooooF?ooool3o`000003ooooool0003o000000?o000000?oooooo`000?l000001Ol0000=
ooooo`;o00009?ooool2o`000?ooooooFoooool00?oooooooooooooiooooo`00ooooooooooooooWo
oooo0000\
\>"],
  ImageRangeCache->{{{0, 758}, {233.562, 0}} -> {-0.15498, -0.0154542, \
0.00304744, 0.00304744}, {{50.8125, 379}, {228.438, 25.6875}} -> {-109.393, \
4.43153, 1.2762, 0.00185923}, {{379, 707.125}, {228.438, 25.6875}} -> \
{-528.332, 0.00492254, 1.27646, 0.00204465}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF/Gauss-Hermite", "Subsection",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? M0\)], "Input",
  FontSize->14],

Cell["Global`M0", "Print",
  CellTags->"Info3416822704-7256049"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(M0 = {4.6`, 0.2`}\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "M0"],
      Editable->False]], "Print",
  CellTags->"Info3416822704-7256049"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "{YF,PF,lik}=GHF[Map[Take[#,366]&,{logZM,X}],{0.07, -1., .2, .2},\n         \
            \t{drift,Omega,h,R,",
  StyleBox["Mue,Sigma",
    FontColor->RGBColor[1, 0, 0]],
  ",dt,m=3},{-9,2}];"
}], "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({MessUpGHF, TimeUpGHF1}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("GHF: "\[InvisibleSpace]"m = "\[InvisibleSpace]3\),
      SequenceForm[ "GHF: ", "m = ", 3],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell["PF//Last", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{0.0001114387794950926`, \(-0.000010218385057103596`\)}, \
{\(-0.000010218385057103596`\), 0.018551844987931443`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
s=Map[VecDiag,PF]//Sqrt;
KI=YF~ii~(YF+s)~ii~(YF-s);

gGHF3=
DisplayTogetherArray[
plot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}  \
]//AddTimeAxis,color->{10,1,2,2},permute->{1,4,3,2}],
plot1[    Column[Y,{2}] \
~ii~Column[KI,{1,3,5}+1]//AddTimeAxis,color->{10,1,2,2}], 
PlotLabel->\"GHF, m=3\"
];\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -26.0625 0 ]
[.5 .32152 26.0625 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -87.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GHF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
99.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
111.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -8.00386 1.79103 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05577 -18 -4.5 ]
[-0.0125 .05577 0 4.5 ]
[-0.0125 .14533 -24 -4.5 ]
[-0.0125 .14533 0 4.5 ]
[-0.0125 .23488 -18 -4.5 ]
[-0.0125 .23488 0 4.5 ]
[-0.0125 .32443 -24 -4.5 ]
[-0.0125 .32443 0 4.5 ]
[-0.0125 .41398 -18 -4.5 ]
[-0.0125 .41398 0 4.5 ]
[-0.0125 .50353 -24 -4.5 ]
[-0.0125 .50353 0 4.5 ]
[-0.0125 .59308 -18 -4.5 ]
[-0.0125 .59308 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33497 -5 -6 ]
[.97619 .33497 5 6 ]
[.97619 .32461 -5 -6 ]
[.97619 .32461 5 6 ]
[.97619 .36243 -5 -6 ]
[.97619 .36243 5 6 ]
[.97619 .34352 -5 -6 ]
[.97619 .34352 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05577 m
.00625 .05577 L
s
[(4.5)] -0.0125 .05577 1 0 Mshowa
0 .14533 m
.00625 .14533 L
s
[(4.55)] -0.0125 .14533 1 0 Mshowa
0 .23488 m
.00625 .23488 L
s
[(4.6)] -0.0125 .23488 1 0 Mshowa
0 .32443 m
.00625 .32443 L
s
[(4.65)] -0.0125 .32443 1 0 Mshowa
0 .41398 m
.00625 .41398 L
s
[(4.7)] -0.0125 .41398 1 0 Mshowa
0 .50353 m
.00625 .50353 L
s
[(4.75)] -0.0125 .50353 1 0 Mshowa
0 .59308 m
.00625 .59308 L
s
[(4.8)] -0.0125 .59308 1 0 Mshowa
.125 Mabswid
0 .07368 m
.00375 .07368 L
s
0 .09159 m
.00375 .09159 L
s
0 .1095 m
.00375 .1095 L
s
0 .12741 m
.00375 .12741 L
s
0 .16324 m
.00375 .16324 L
s
0 .18115 m
.00375 .18115 L
s
0 .19906 m
.00375 .19906 L
s
0 .21697 m
.00375 .21697 L
s
0 .25279 m
.00375 .25279 L
s
0 .2707 m
.00375 .2707 L
s
0 .28861 m
.00375 .28861 L
s
0 .30652 m
.00375 .30652 L
s
0 .34234 m
.00375 .34234 L
s
0 .36025 m
.00375 .36025 L
s
0 .37816 m
.00375 .37816 L
s
0 .39607 m
.00375 .39607 L
s
0 .43189 m
.00375 .43189 L
s
0 .4498 m
.00375 .4498 L
s
0 .46771 m
.00375 .46771 L
s
0 .48562 m
.00375 .48562 L
s
0 .52144 m
.00375 .52144 L
s
0 .53935 m
.00375 .53935 L
s
0 .55726 m
.00375 .55726 L
s
0 .57517 m
.00375 .57517 L
s
0 .03786 m
.00375 .03786 L
s
0 .01995 m
.00375 .01995 L
s
0 .00204 m
.00375 .00204 L
s
0 .61099 m
.00375 .61099 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05577 m
1 .05577 L
s
.99375 .14533 m
1 .14533 L
s
.99375 .23488 m
1 .23488 L
s
.99375 .32443 m
1 .32443 L
s
.99375 .41398 m
1 .41398 L
s
.99375 .50353 m
1 .50353 L
s
.99375 .59308 m
1 .59308 L
s
.125 Mabswid
.99625 .07368 m
1 .07368 L
s
.99625 .09159 m
1 .09159 L
s
.99625 .1095 m
1 .1095 L
s
.99625 .12741 m
1 .12741 L
s
.99625 .16324 m
1 .16324 L
s
.99625 .18115 m
1 .18115 L
s
.99625 .19906 m
1 .19906 L
s
.99625 .21697 m
1 .21697 L
s
.99625 .25279 m
1 .25279 L
s
.99625 .2707 m
1 .2707 L
s
.99625 .28861 m
1 .28861 L
s
.99625 .30652 m
1 .30652 L
s
.99625 .34234 m
1 .34234 L
s
.99625 .36025 m
1 .36025 L
s
.99625 .37816 m
1 .37816 L
s
.99625 .39607 m
1 .39607 L
s
.99625 .43189 m
1 .43189 L
s
.99625 .4498 m
1 .4498 L
s
.99625 .46771 m
1 .46771 L
s
.99625 .48562 m
1 .48562 L
s
.99625 .52144 m
1 .52144 L
s
.99625 .53935 m
1 .53935 L
s
.99625 .55726 m
1 .55726 L
s
.99625 .57517 m
1 .57517 L
s
.99625 .03786 m
1 .03786 L
s
.99625 .01995 m
1 .01995 L
s
.99625 .00204 m
1 .00204 L
s
.99625 .61099 m
1 .61099 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .33497 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .24414 m
.02642 .25162 L
.02903 .25325 L
.03164 .22675 L
.03425 .2442 L
.03686 .23766 L
.03947 .2605 L
.04207 .29114 L
.04468 .29744 L
.04729 .32343 L
.0499 .2872 L
.05251 .30073 L
.05512 .27653 L
.05773 .29827 L
.06034 .32395 L
.06295 .34496 L
.06556 .36257 L
.06817 .34729 L
.07078 .31677 L
.07339 .36394 L
.07599 .34563 L
.0786 .33206 L
.08121 .30739 L
.08382 .31531 L
.08643 .33493 L
.08904 .32903 L
.09165 .34775 L
.09426 .4188 L
.09687 .37859 L
.09948 .3671 L
.10209 .36852 L
.1047 .39408 L
.10731 .40862 L
.10992 .38715 L
.11252 .38352 L
.11513 .39591 L
.11774 .37439 L
.12035 .38111 L
.12296 .37741 L
.12557 .35164 L
.12818 .37075 L
.13079 .40002 L
.1334 .40229 L
.13601 .37257 L
.13862 .38073 L
.14123 .36653 L
.14384 .37508 L
.14644 .3719 L
.14905 .35303 L
.15166 .33735 L
Mistroke
.15427 .34667 L
.15688 .36123 L
.15949 .38721 L
.1621 .35007 L
.16471 .32049 L
.16732 .32848 L
.16993 .33615 L
.17254 .32818 L
.17515 .31664 L
.17776 .33276 L
.18037 .31161 L
.18297 .30945 L
.18558 .31816 L
.18819 .31296 L
.1908 .31431 L
.19341 .31809 L
.19602 .30119 L
.19863 .29454 L
.20124 .23893 L
.20385 .24215 L
.20646 .25188 L
.20907 .24727 L
.21168 .24304 L
.21429 .25971 L
.21689 .26369 L
.2195 .26688 L
.22211 .23632 L
.22472 .26004 L
.22733 .28973 L
.22994 .28512 L
.23255 .29661 L
.23516 .29845 L
.23777 .25056 L
.24038 .25754 L
.24299 .25769 L
.2456 .26736 L
.24821 .25982 L
.25082 .26145 L
.25342 .26951 L
.25603 .26171 L
.25864 .25903 L
.26125 .263 L
.26386 .25646 L
.26647 .2543 L
.26908 .2605 L
.27169 .26973 L
.2743 .27498 L
.27691 .26656 L
.27952 .24044 L
.28213 .25607 L
Mistroke
.28474 .26466 L
.28735 .23899 L
.28995 .21781 L
.29256 .2333 L
.29517 .21564 L
.29778 .24006 L
.30039 .19814 L
.303 .20458 L
.30561 .21845 L
.30822 .22462 L
.31083 .2532 L
.31344 .27339 L
.31605 .27182 L
.31866 .26441 L
.32127 .28399 L
.32387 .27599 L
.32648 .32215 L
.32909 .31374 L
.3317 .27918 L
.33431 .27619 L
.33692 .31709 L
.33953 .31437 L
.34214 .29297 L
.34475 .29039 L
.34736 .29977 L
.34997 .32071 L
.35258 .31444 L
.35519 .30381 L
.3578 .30077 L
.3604 .29938 L
.36301 .29604 L
.36562 .28009 L
.36823 .3055 L
.37084 .31031 L
.37345 .30791 L
.37606 .27369 L
.37867 .27447 L
.38128 .25074 L
.38389 .26999 L
.3865 .2484 L
.38911 .24363 L
.39172 .25417 L
.39432 .27047 L
.39693 .24348 L
.39954 .25167 L
.40215 .26554 L
.40476 .27333 L
.40737 .24225 L
.40998 .22122 L
.41259 .23388 L
Mistroke
.4152 .21802 L
.41781 .23936 L
.42042 .24885 L
.42303 .24568 L
.42564 .2621 L
.42825 .24422 L
.43085 .2473 L
.43346 .25884 L
.43607 .25294 L
.43868 .27066 L
.44129 .27016 L
.4439 .23434 L
.44651 .2105 L
.44912 .22308 L
.45173 .27715 L
.45434 .25629 L
.45695 .25694 L
.45956 .2226 L
.46217 .23904 L
.46477 .24001 L
.46738 .25054 L
.46999 .21643 L
.4726 .24575 L
.47521 .25517 L
.47782 .27771 L
.48043 .29773 L
.48304 .24677 L
.48565 .25336 L
.48826 .22829 L
.49087 .28344 L
.49348 .29058 L
.49609 .27837 L
.4987 .29348 L
.5013 .28663 L
.50391 .29784 L
.50652 .26475 L
.50913 .26787 L
.51174 .29567 L
.51435 .2527 L
.51696 .30796 L
.51957 .28533 L
.52218 .26092 L
.52479 .22696 L
.5274 .2503 L
.53001 .26692 L
.53262 .26974 L
.53523 .24747 L
.53783 .21139 L
.54044 .14903 L
.54305 .17847 L
Mistroke
.54566 .19375 L
.54827 .19928 L
.55088 .1737 L
.55349 .19677 L
.5561 .23591 L
.55871 .19461 L
.56132 .18786 L
.56393 .15774 L
.56654 .0801 L
.56915 .03796 L
.57175 .06194 L
.57436 .10507 L
.57697 .10011 L
.57958 .10721 L
.58219 .09707 L
.5848 .09553 L
.58741 .09859 L
.59002 .12864 L
.59263 .13133 L
.59524 .13035 L
.59785 .1297 L
.60046 .14634 L
.60307 .14015 L
.60568 .14156 L
.60828 .21293 L
.61089 .24131 L
.6135 .20034 L
.61611 .21618 L
.61872 .2075 L
.62133 .21639 L
.62394 .23936 L
.62655 .25702 L
.62916 .34598 L
.63177 .33823 L
.63438 .38834 L
.63699 .34481 L
.6396 .30205 L
.6422 .28966 L
.64481 .30476 L
.64742 .30683 L
.65003 .32688 L
.65264 .35279 L
.65525 .39112 L
.65786 .38653 L
.66047 .43427 L
.66308 .42402 L
.66569 .41866 L
.6683 .4331 L
.67091 .36827 L
.67352 .33724 L
Mistroke
.67613 .34492 L
.67873 .36315 L
.68134 .32365 L
.68395 .38576 L
.68656 .39918 L
.68917 .44612 L
.69178 .45756 L
.69439 .42224 L
.697 .48206 L
.69961 .52168 L
.70222 .52934 L
.70483 .50172 L
.70744 .50257 L
.71005 .5247 L
.71265 .52507 L
.71526 .50928 L
.71787 .4903 L
.72048 .45948 L
.72309 .48411 L
.7257 .44211 L
.72831 .43504 L
.73092 .4094 L
.73353 .39559 L
.73614 .34361 L
.73875 .36201 L
.74136 .40771 L
.74397 .43406 L
.74658 .4702 L
.74918 .51069 L
.75179 .49142 L
.7544 .46561 L
.75701 .4149 L
.75962 .48859 L
.76223 .4807 L
.76484 .47309 L
.76745 .43472 L
.77006 .42856 L
.77267 .44159 L
.77528 .47967 L
.77789 .49935 L
.7805 .54959 L
.78311 .55757 L
.78571 .551 L
.78832 .55251 L
.79093 .55867 L
.79354 .46791 L
.79615 .44348 L
.79876 .47653 L
.80137 .4954 L
.80398 .51272 L
Mistroke
.80659 .43683 L
.8092 .40356 L
.81181 .40236 L
.81442 .35873 L
.81703 .37654 L
.81963 .37393 L
.82224 .45176 L
.82485 .4257 L
.82746 .47696 L
.83007 .4576 L
.83268 .48783 L
.83529 .44477 L
.8379 .42126 L
.84051 .39667 L
.84312 .40238 L
.84573 .34551 L
.84834 .34582 L
.85095 .28125 L
.85356 .29961 L
.85616 .35227 L
.85877 .30179 L
.86138 .29305 L
.86399 .34327 L
.8666 .39757 L
.86921 .44591 L
.87182 .49337 L
.87443 .52143 L
.87704 .45873 L
.87965 .42665 L
.88226 .49956 L
.88487 .45578 L
.88748 .41226 L
.89008 .39645 L
.89269 .42455 L
.8953 .44235 L
.89791 .40985 L
.90052 .37045 L
.90313 .37886 L
.90574 .35518 L
.90835 .36367 L
.91096 .33247 L
.91357 .33712 L
.91618 .34544 L
.91879 .31478 L
.9214 .3422 L
.92401 .34804 L
.92661 .36478 L
.92922 .3161 L
.93183 .30281 L
.93444 .32487 L
Mistroke
.93705 .32773 L
.93966 .30643 L
.94227 .30187 L
.94488 .29278 L
.94749 .34594 L
.9501 .26874 L
.95271 .30065 L
.95532 .29637 L
.95793 .30465 L
.96053 .35198 L
.96314 .36135 L
.96575 .37818 L
.96836 .34884 L
.97097 .32231 L
.97358 .34339 L
.97619 .33497 L
Mfstroke
0 .98 .604 r
gsave
.97619 .32461 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24419 m
.02642 .22584 L
.02903 .2183 L
.03164 .21256 L
.03425 .20775 L
.03686 .20355 L
.03947 .19977 L
.04207 .2908 L
.04468 .27257 L
.04729 .26507 L
.0499 .25937 L
.05251 .2546 L
.05512 .25042 L
.05773 .24666 L
.06034 .3238 L
.06295 .30565 L
.06556 .29819 L
.06817 .29251 L
.07078 .28777 L
.07339 .28361 L
.07599 .27987 L
.0786 .33196 L
.08121 .31382 L
.08382 .30637 L
.08643 .3007 L
.08904 .29595 L
.09165 .2918 L
.09426 .28806 L
.09687 .37847 L
.09948 .36046 L
.10209 .35306 L
.1047 .34743 L
.10731 .34272 L
.10992 .33859 L
.11252 .33488 L
.11513 .396 L
.11774 .37804 L
.12035 .37065 L
.12296 .36504 L
.12557 .36033 L
.12818 .35622 L
.13079 .35252 L
.1334 .40208 L
.13601 .38412 L
.13862 .37674 L
.14123 .37112 L
.14384 .36642 L
.14644 .36231 L
.14905 .35861 L
.15166 .33714 L
Mistroke
.15427 .31896 L
.15688 .31148 L
.15949 .30579 L
.1621 .30103 L
.16471 .29686 L
.16732 .29311 L
.16993 .33595 L
.17254 .31775 L
.17515 .31027 L
.17776 .30458 L
.18037 .29981 L
.18297 .29564 L
.18558 .29188 L
.18819 .3127 L
.1908 .29442 L
.19341 .2869 L
.19602 .28118 L
.19863 .27639 L
.20124 .27219 L
.20385 .26842 L
.20646 .25162 L
.20907 .23312 L
.21168 .22551 L
.21429 .21972 L
.21689 .21487 L
.2195 .21062 L
.22211 .2068 L
.22472 .26002 L
.22733 .24155 L
.22994 .23395 L
.23255 .22816 L
.23516 .22332 L
.23777 .21908 L
.24038 .21526 L
.24299 .25733 L
.2456 .23884 L
.24821 .23124 L
.25082 .22545 L
.25342 .2206 L
.25603 .21635 L
.25864 .21253 L
.26125 .26265 L
.26386 .24418 L
.26647 .23658 L
.26908 .23079 L
.27169 .22595 L
.2743 .22171 L
.27691 .21789 L
.27952 .24036 L
.28213 .22181 L
Mistroke
.28474 .21417 L
.28735 .20836 L
.28995 .20349 L
.29256 .19923 L
.29517 .19539 L
.29778 .23954 L
.30039 .22098 L
.303 .21334 L
.30561 .20752 L
.30822 .20265 L
.31083 .19839 L
.31344 .19455 L
.31605 .27129 L
.31866 .25285 L
.32127 .24525 L
.32387 .23948 L
.32648 .23464 L
.32909 .2304 L
.3317 .22659 L
.33431 .27634 L
.33692 .25792 L
.33953 .25033 L
.34214 .24456 L
.34475 .23972 L
.34736 .23549 L
.34997 .23168 L
.35258 .31392 L
.35519 .29563 L
.3578 .28811 L
.3604 .28238 L
.36301 .27759 L
.36562 .27338 L
.36823 .26961 L
.37084 .31028 L
.37345 .29197 L
.37606 .28444 L
.37867 .2787 L
.38128 .2739 L
.38389 .26969 L
.3865 .26591 L
.38911 .24351 L
.39172 .22493 L
.39432 .21728 L
.39693 .21145 L
.39954 .20657 L
.40215 .2023 L
.40476 .19846 L
.40737 .24197 L
.40998 .22337 L
.41259 .21572 L
Mistroke
.4152 .20989 L
.41781 .20501 L
.42042 .20074 L
.42303 .19689 L
.42564 .26189 L
.42825 .24337 L
.43085 .23575 L
.43346 .22995 L
.43607 .22509 L
.43868 .22083 L
.44129 .217 L
.4439 .23442 L
.44651 .21579 L
.44912 .20812 L
.45173 .20228 L
.45434 .19739 L
.45695 .1931 L
.45956 .18925 L
.46217 .23869 L
.46477 .22008 L
.46738 .21241 L
.46999 .20658 L
.4726 .20169 L
.47521 .19741 L
.47782 .19356 L
.48043 .29738 L
.48304 .27901 L
.48565 .27145 L
.48826 .26569 L
.49087 .26087 L
.49348 .25665 L
.49609 .25285 L
.4987 .29302 L
.5013 .27462 L
.50391 .26705 L
.50652 .26129 L
.50913 .25646 L
.51174 .25223 L
.51435 .24842 L
.51696 .30774 L
.51957 .2894 L
.52218 .28185 L
.52479 .2761 L
.5274 .27129 L
.53001 .26707 L
.53262 .26328 L
.53523 .24733 L
.53783 .22873 L
.54044 .22106 L
.54305 .21523 L
Mistroke
.54566 .21034 L
.54827 .20606 L
.55088 .20221 L
.55349 .19666 L
.5561 .17783 L
.55871 .17008 L
.56132 .16417 L
.56393 .15922 L
.56654 .15489 L
.56915 .15099 L
.57175 .06181 L
.57436 .04241 L
.57697 .03442 L
.57958 .02832 L
.58219 .02322 L
.5848 .01874 L
.58741 .01472 L
.59002 .12854 L
.59263 .10943 L
.59524 .10156 L
.59785 .09556 L
.60046 .09053 L
.60307 .08613 L
.60568 .08217 L
.60828 .2127 L
.61089 .19397 L
.6135 .18625 L
.61611 .18037 L
.61872 .17544 L
.62133 .17113 L
.62394 .16725 L
.62655 .25682 L
.62916 .23827 L
.63177 .23063 L
.63438 .22482 L
.63699 .21995 L
.6396 .21568 L
.6422 .21184 L
.64481 .30434 L
.64742 .286 L
.65003 .27845 L
.65264 .2727 L
.65525 .26789 L
.65786 .26367 L
.66047 .25988 L
.66308 .42367 L
.66569 .40586 L
.6683 .39854 L
.67091 .39296 L
.67352 .38829 L
Mistroke
.67613 .38421 L
.67873 .38053 L
.68134 .32344 L
.68395 .30515 L
.68656 .29762 L
.68917 .29189 L
.69178 .28708 L
.69439 .28288 L
.697 .27909 L
.69961 .52176 L
.70222 .50437 L
.70483 .49722 L
.70744 .49178 L
.71005 .48722 L
.71265 .48324 L
.71526 .47965 L
.71787 .49025 L
.72048 .47268 L
.72309 .46545 L
.7257 .45995 L
.72831 .45535 L
.73092 .45132 L
.73353 .44769 L
.73614 .34322 L
.73875 .32492 L
.74136 .31739 L
.74397 .31165 L
.74658 .30685 L
.74918 .30264 L
.75179 .29885 L
.7544 .46533 L
.75701 .44759 L
.75962 .44029 L
.76223 .43473 L
.76484 .43008 L
.76745 .42601 L
.77006 .42235 L
.77267 .44162 L
.77528 .42374 L
.77789 .41639 L
.7805 .41079 L
.78311 .4061 L
.78571 .402 L
.78832 .3983 L
.79093 .55846 L
.79354 .54113 L
.79615 .534 L
.79876 .52858 L
.80137 .52404 L
.80398 .52007 L
Mistroke
.80659 .5165 L
.8092 .40329 L
.81181 .38516 L
.81442 .37769 L
.81703 .37201 L
.81963 .36726 L
.82224 .36309 L
.82485 .35934 L
.82746 .47697 L
.83007 .45918 L
.83268 .45186 L
.83529 .44629 L
.8379 .44162 L
.84051 .43754 L
.84312 .43386 L
.84573 .34562 L
.84834 .32717 L
.85095 .31957 L
.85356 .31379 L
.85616 .30894 L
.85877 .3047 L
.86138 .30088 L
.86399 .34308 L
.8666 .32461 L
.86921 .31701 L
.87182 .31122 L
.87443 .30637 L
.87704 .30212 L
.87965 .29829 L
.88226 .49958 L
.88487 .48186 L
.88748 .47456 L
.89008 .46901 L
.89269 .46436 L
.8953 .46029 L
.89791 .45663 L
.90052 .37019 L
.90313 .3518 L
.90574 .34423 L
.90835 .33846 L
.91096 .33363 L
.91357 .3294 L
.91618 .3256 L
.91879 .31442 L
.9214 .29576 L
.92401 .28807 L
.92661 .28221 L
.92922 .27731 L
.93183 .27301 L
.93444 .26914 L
Mistroke
.93705 .3277 L
.93966 .3091 L
.94227 .30144 L
.94488 .2956 L
.94749 .29071 L
.9501 .28643 L
.95271 .28258 L
.95532 .29638 L
.95793 .27763 L
.96053 .2699 L
.96314 .26402 L
.96575 .25909 L
.96836 .25477 L
.97097 .25088 L
.97358 .34314 L
.97619 .32461 L
Mfstroke
gsave
.97619 .36243 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24455 m
.02642 .26334 L
.02903 .27133 L
.03164 .27751 L
.03425 .28276 L
.03686 .2874 L
.03947 .29163 L
.04207 .29116 L
.04468 .30983 L
.04729 .31777 L
.0499 .32391 L
.05251 .32913 L
.05512 .33374 L
.05773 .33794 L
.06034 .32416 L
.06295 .34275 L
.06556 .35065 L
.06817 .35677 L
.07078 .36196 L
.07339 .36656 L
.07599 .37074 L
.0786 .33232 L
.08121 .35089 L
.08382 .35879 L
.08643 .3649 L
.08904 .37008 L
.09165 .37468 L
.09426 .37886 L
.09687 .37882 L
.09948 .39727 L
.10209 .40511 L
.1047 .41118 L
.10731 .41634 L
.10992 .4209 L
.11252 .42505 L
.11513 .39636 L
.11774 .41476 L
.12035 .42259 L
.12296 .42865 L
.12557 .43379 L
.12818 .43834 L
.13079 .44248 L
.1334 .40244 L
.13601 .42083 L
.13862 .42866 L
.14123 .43471 L
.14384 .43985 L
.14644 .4444 L
.14905 .44854 L
.15166 .3375 L
Mistroke
.15427 .35612 L
.15688 .36403 L
.15949 .37015 L
.1621 .37534 L
.16471 .37995 L
.16732 .38413 L
.16993 .33631 L
.17254 .35493 L
.17515 .36285 L
.17776 .36897 L
.18037 .37417 L
.18297 .37877 L
.18558 .38296 L
.18819 .31306 L
.1908 .33177 L
.19341 .33972 L
.19602 .34587 L
.19863 .35109 L
.20124 .35571 L
.20385 .35991 L
.20646 .25198 L
.20907 .2709 L
.21168 .27893 L
.21429 .28515 L
.21689 .29042 L
.2195 .29509 L
.22211 .29934 L
.22472 .26038 L
.22733 .27927 L
.22994 .2873 L
.23255 .2935 L
.23516 .29877 L
.23777 .30343 L
.24038 .30767 L
.24299 .25769 L
.2456 .27659 L
.24821 .28462 L
.25082 .29083 L
.25342 .2961 L
.25603 .30076 L
.25864 .305 L
.26125 .26301 L
.26386 .2819 L
.26647 .28992 L
.26908 .29612 L
.27169 .30139 L
.2743 .30605 L
.27691 .31028 L
.27952 .24072 L
.28213 .25969 L
Mistroke
.28474 .26775 L
.28735 .27398 L
.28995 .27926 L
.29256 .28394 L
.29517 .2882 L
.29778 .2399 L
.30039 .25887 L
.303 .26693 L
.30561 .27316 L
.30822 .27844 L
.31083 .28313 L
.31344 .28738 L
.31605 .27165 L
.31866 .29051 L
.32127 .29852 L
.32387 .30471 L
.32648 .30997 L
.32909 .31462 L
.3317 .31885 L
.33431 .2767 L
.33692 .29555 L
.33953 .30355 L
.34214 .30974 L
.34475 .31499 L
.34736 .31964 L
.34997 .32386 L
.35258 .31428 L
.35519 .33299 L
.3578 .34093 L
.3604 .34708 L
.36301 .35229 L
.36562 .35691 L
.36823 .36111 L
.37084 .31064 L
.37345 .32937 L
.37606 .33732 L
.37867 .34347 L
.38128 .34869 L
.38389 .35332 L
.3865 .35752 L
.38911 .24387 L
.39172 .26286 L
.39432 .27093 L
.39693 .27716 L
.39954 .28245 L
.40215 .28713 L
.40476 .29139 L
.40737 .24232 L
.40998 .26133 L
.41259 .26939 L
Mistroke
.4152 .27563 L
.41781 .28092 L
.42042 .2856 L
.42303 .28986 L
.42564 .26225 L
.42825 .28117 L
.43085 .2892 L
.43346 .29542 L
.43607 .30068 L
.43868 .30535 L
.44129 .30959 L
.4439 .23478 L
.44651 .25382 L
.44912 .26189 L
.45173 .26814 L
.45434 .27344 L
.45695 .27813 L
.45956 .28239 L
.46217 .23905 L
.46477 .25807 L
.46738 .26614 L
.46999 .27238 L
.4726 .27768 L
.47521 .28236 L
.47782 .28662 L
.48043 .29774 L
.48304 .31652 L
.48565 .3245 L
.48826 .33067 L
.49087 .3359 L
.49348 .34053 L
.49609 .34474 L
.4987 .29338 L
.5013 .31219 L
.50391 .32017 L
.50652 .32634 L
.50913 .33158 L
.51174 .33622 L
.51435 .34044 L
.51696 .30809 L
.51957 .32684 L
.52218 .3348 L
.52479 .34096 L
.5274 .34618 L
.53001 .35081 L
.53262 .35501 L
.53523 .24769 L
.53783 .2667 L
.54044 .27477 L
.54305 .28101 L
Mistroke
.54566 .2863 L
.54827 .29099 L
.55088 .29524 L
.55349 .19701 L
.5561 .21624 L
.55871 .22439 L
.56132 .2307 L
.56393 .23604 L
.56654 .24078 L
.56915 .24508 L
.57175 .06217 L
.57436 .08195 L
.57697 .09034 L
.57958 .09681 L
.58219 .10231 L
.5848 .10717 L
.58741 .11158 L
.59002 .12889 L
.59263 .14839 L
.59524 .15666 L
.59785 .16305 L
.60046 .16846 L
.60307 .17326 L
.60568 .17762 L
.60828 .21306 L
.61089 .2322 L
.6135 .24032 L
.61611 .2466 L
.61872 .25192 L
.62133 .25663 L
.62394 .26092 L
.62655 .25718 L
.62916 .27613 L
.63177 .28417 L
.63438 .29038 L
.63699 .29566 L
.6396 .30033 L
.6422 .30457 L
.64481 .3047 L
.64742 .32344 L
.65003 .3314 L
.65264 .33755 L
.65525 .34277 L
.65786 .34739 L
.66047 .35159 L
.66308 .42403 L
.66569 .44225 L
.6683 .44999 L
.67091 .45599 L
.67352 .46107 L
Mistroke
.67613 .46557 L
.67873 .46967 L
.68134 .3238 L
.68395 .3425 L
.68656 .35044 L
.68917 .35658 L
.69178 .36179 L
.69439 .3664 L
.697 .37059 L
.69961 .52212 L
.70222 .53994 L
.70483 .54752 L
.70744 .55338 L
.71005 .55836 L
.71265 .56277 L
.71526 .56678 L
.71787 .49061 L
.72048 .5086 L
.72309 .51625 L
.7257 .52216 L
.72831 .52719 L
.73092 .53164 L
.73353 .53568 L
.73614 .34358 L
.73875 .36229 L
.74136 .37023 L
.74397 .37637 L
.74658 .38158 L
.74918 .38619 L
.75179 .39039 L
.7544 .46569 L
.75701 .48384 L
.75962 .49156 L
.76223 .49753 L
.76484 .5026 L
.76745 .50709 L
.77006 .51116 L
.77267 .44197 L
.77528 .46026 L
.77789 .46803 L
.7805 .47404 L
.78311 .47914 L
.78571 .48366 L
.78832 .48777 L
.79093 .55882 L
.79354 .57657 L
.79615 .58412 L
.79876 .58997 L
.80137 .59493 L
.80398 .59932 L
Mistroke
.80659 .60332 L
.8092 .40364 L
.81181 .42218 L
.81442 .43005 L
.81703 .43614 L
.81963 .4413 L
.82224 .44588 L
.82485 .45003 L
.82746 .47732 L
.83007 .49553 L
.83268 .50326 L
.83529 .50924 L
.8379 .51432 L
.84051 .51882 L
.84312 .52291 L
.84573 .34598 L
.84834 .36482 L
.85095 .37282 L
.85356 .37901 L
.85616 .38425 L
.85877 .3889 L
.86138 .39312 L
.86399 .34344 L
.8666 .3623 L
.86921 .37031 L
.87182 .3765 L
.87443 .38175 L
.87704 .3864 L
.87965 .39062 L
.88226 .49994 L
.88487 .51808 L
.88748 .5258 L
.89008 .53176 L
.89269 .53682 L
.8953 .54131 L
.89791 .54538 L
.90052 .37055 L
.90313 .38934 L
.90574 .39731 L
.90835 .40348 L
.91096 .40871 L
.91357 .41334 L
.91618 .41755 L
.91879 .31478 L
.9214 .33383 L
.92401 .34192 L
.92661 .34817 L
.92922 .35347 L
.93183 .35816 L
.93444 .36242 L
Mistroke
.93705 .32806 L
.93966 .34706 L
.94227 .35511 L
.94488 .36134 L
.94749 .36663 L
.9501 .37131 L
.95271 .37555 L
.95532 .29674 L
.95793 .31588 L
.96053 .324 L
.96314 .33028 L
.96575 .3356 L
.96836 .34031 L
.97097 .34459 L
.97358 .3435 L
.97619 .36243 L
Mfstroke
0 0 1 r
gsave
.97619 .34352 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24437 m
.02642 .24459 L
.02903 .24481 L
.03164 .24504 L
.03425 .24526 L
.03686 .24548 L
.03947 .2457 L
.04207 .29098 L
.04468 .2912 L
.04729 .29142 L
.0499 .29164 L
.05251 .29186 L
.05512 .29208 L
.05773 .2923 L
.06034 .32398 L
.06295 .3242 L
.06556 .32442 L
.06817 .32464 L
.07078 .32486 L
.07339 .32508 L
.07599 .3253 L
.0786 .33214 L
.08121 .33236 L
.08382 .33258 L
.08643 .3328 L
.08904 .33302 L
.09165 .33324 L
.09426 .33346 L
.09687 .37864 L
.09948 .37887 L
.10209 .37909 L
.1047 .37931 L
.10731 .37953 L
.10992 .37975 L
.11252 .37997 L
.11513 .39618 L
.11774 .3964 L
.12035 .39662 L
.12296 .39684 L
.12557 .39706 L
.12818 .39728 L
.13079 .3975 L
.1334 .40226 L
.13601 .40248 L
.13862 .4027 L
.14123 .40292 L
.14384 .40314 L
.14644 .40336 L
.14905 .40357 L
.15166 .33732 L
Mistroke
.15427 .33754 L
.15688 .33775 L
.15949 .33797 L
.1621 .33819 L
.16471 .3384 L
.16732 .33862 L
.16993 .33613 L
.17254 .33634 L
.17515 .33656 L
.17776 .33677 L
.18037 .33699 L
.18297 .33721 L
.18558 .33742 L
.18819 .31288 L
.1908 .31309 L
.19341 .31331 L
.19602 .31352 L
.19863 .31374 L
.20124 .31395 L
.20385 .31417 L
.20646 .2518 L
.20907 .25201 L
.21168 .25222 L
.21429 .25243 L
.21689 .25264 L
.2195 .25286 L
.22211 .25307 L
.22472 .2602 L
.22733 .26041 L
.22994 .26062 L
.23255 .26083 L
.23516 .26104 L
.23777 .26125 L
.24038 .26146 L
.24299 .25751 L
.2456 .25772 L
.24821 .25793 L
.25082 .25814 L
.25342 .25835 L
.25603 .25856 L
.25864 .25877 L
.26125 .26283 L
.26386 .26304 L
.26647 .26325 L
.26908 .26346 L
.27169 .26367 L
.2743 .26388 L
.27691 .26409 L
.27952 .24054 L
.28213 .24075 L
Mistroke
.28474 .24096 L
.28735 .24117 L
.28995 .24138 L
.29256 .24159 L
.29517 .24179 L
.29778 .23972 L
.30039 .23993 L
.303 .24013 L
.30561 .24034 L
.30822 .24055 L
.31083 .24076 L
.31344 .24096 L
.31605 .27147 L
.31866 .27168 L
.32127 .27189 L
.32387 .27209 L
.32648 .2723 L
.32909 .27251 L
.3317 .27272 L
.33431 .27652 L
.33692 .27673 L
.33953 .27694 L
.34214 .27715 L
.34475 .27736 L
.34736 .27756 L
.34997 .27777 L
.35258 .3141 L
.35519 .31431 L
.3578 .31452 L
.3604 .31473 L
.36301 .31494 L
.36562 .31515 L
.36823 .31536 L
.37084 .31046 L
.37345 .31067 L
.37606 .31088 L
.37867 .31109 L
.38128 .3113 L
.38389 .3115 L
.3865 .31171 L
.38911 .24369 L
.39172 .2439 L
.39432 .2441 L
.39693 .24431 L
.39954 .24451 L
.40215 .24472 L
.40476 .24492 L
.40737 .24215 L
.40998 .24235 L
.41259 .24256 L
Mistroke
.4152 .24276 L
.41781 .24297 L
.42042 .24317 L
.42303 .24337 L
.42564 .26207 L
.42825 .26227 L
.43085 .26248 L
.43346 .26268 L
.43607 .26289 L
.43868 .26309 L
.44129 .2633 L
.4439 .2346 L
.44651 .2348 L
.44912 .23501 L
.45173 .23521 L
.45434 .23541 L
.45695 .23562 L
.45956 .23582 L
.46217 .23887 L
.46477 .23907 L
.46738 .23928 L
.46999 .23948 L
.4726 .23968 L
.47521 .23989 L
.47782 .24009 L
.48043 .29756 L
.48304 .29777 L
.48565 .29797 L
.48826 .29818 L
.49087 .29838 L
.49348 .29859 L
.49609 .2988 L
.4987 .2932 L
.5013 .29341 L
.50391 .29361 L
.50652 .29382 L
.50913 .29402 L
.51174 .29423 L
.51435 .29443 L
.51696 .30791 L
.51957 .30812 L
.52218 .30833 L
.52479 .30853 L
.5274 .30874 L
.53001 .30894 L
.53262 .30915 L
.53523 .24751 L
.53783 .24772 L
.54044 .24792 L
.54305 .24812 L
Mistroke
.54566 .24832 L
.54827 .24852 L
.55088 .24873 L
.55349 .19684 L
.5561 .19704 L
.55871 .19723 L
.56132 .19743 L
.56393 .19763 L
.56654 .19783 L
.56915 .19803 L
.57175 .06199 L
.57436 .06218 L
.57697 .06238 L
.57958 .06257 L
.58219 .06276 L
.5848 .06296 L
.58741 .06315 L
.59002 .12872 L
.59263 .12891 L
.59524 .12911 L
.59785 .1293 L
.60046 .1295 L
.60307 .1297 L
.60568 .12989 L
.60828 .21288 L
.61089 .21308 L
.6135 .21328 L
.61611 .21348 L
.61872 .21368 L
.62133 .21388 L
.62394 .21408 L
.62655 .257 L
.62916 .2572 L
.63177 .2574 L
.63438 .2576 L
.63699 .2578 L
.6396 .25801 L
.6422 .25821 L
.64481 .30452 L
.64742 .30472 L
.65003 .30492 L
.65264 .30513 L
.65525 .30533 L
.65786 .30553 L
.66047 .30574 L
.66308 .42385 L
.66569 .42406 L
.6683 .42427 L
.67091 .42447 L
.67352 .42468 L
Mistroke
.67613 .42489 L
.67873 .4251 L
.68134 .32362 L
.68395 .32383 L
.68656 .32403 L
.68917 .32423 L
.69178 .32444 L
.69439 .32464 L
.697 .32484 L
.69961 .52194 L
.70222 .52215 L
.70483 .52237 L
.70744 .52258 L
.71005 .52279 L
.71265 .523 L
.71526 .52321 L
.71787 .49043 L
.72048 .49064 L
.72309 .49085 L
.7257 .49106 L
.72831 .49127 L
.73092 .49148 L
.73353 .49169 L
.73614 .3434 L
.73875 .34361 L
.74136 .34381 L
.74397 .34401 L
.74658 .34421 L
.74918 .34442 L
.75179 .34462 L
.7544 .46551 L
.75701 .46572 L
.75962 .46592 L
.76223 .46613 L
.76484 .46634 L
.76745 .46655 L
.77006 .46676 L
.77267 .4418 L
.77528 .442 L
.77789 .44221 L
.7805 .44242 L
.78311 .44262 L
.78571 .44283 L
.78832 .44303 L
.79093 .55864 L
.79354 .55885 L
.79615 .55906 L
.79876 .55927 L
.80137 .55949 L
.80398 .5597 L
Mistroke
.80659 .55991 L
.8092 .40346 L
.81181 .40367 L
.81442 .40387 L
.81703 .40408 L
.81963 .40428 L
.82224 .40448 L
.82485 .40469 L
.82746 .47714 L
.83007 .47735 L
.83268 .47756 L
.83529 .47777 L
.8379 .47797 L
.84051 .47818 L
.84312 .47839 L
.84573 .3458 L
.84834 .346 L
.85095 .3462 L
.85356 .3464 L
.85616 .3466 L
.85877 .3468 L
.86138 .347 L
.86399 .34326 L
.8666 .34346 L
.86921 .34366 L
.87182 .34386 L
.87443 .34406 L
.87704 .34426 L
.87965 .34446 L
.88226 .49976 L
.88487 .49997 L
.88748 .50018 L
.89008 .50038 L
.89269 .50059 L
.8953 .5008 L
.89791 .50101 L
.90052 .37037 L
.90313 .37057 L
.90574 .37077 L
.90835 .37097 L
.91096 .37117 L
.91357 .37137 L
.91618 .37157 L
.91879 .3146 L
.9214 .3148 L
.92401 .31499 L
.92661 .31519 L
.92922 .31539 L
.93183 .31558 L
.93444 .31578 L
Mistroke
.93705 .32788 L
.93966 .32808 L
.94227 .32828 L
.94488 .32847 L
.94749 .32867 L
.9501 .32887 L
.95271 .32907 L
.95532 .29656 L
.95793 .29675 L
.96053 .29695 L
.96314 .29715 L
.96575 .29734 L
.96836 .29754 L
.97097 .29773 L
.97358 .34332 L
.97619 .34352 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -0.0749531 1.62895 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00649 -24 -4.5 ]
[-0.0125 .00649 0 4.5 ]
[-0.0125 .08794 -18 -4.5 ]
[-0.0125 .08794 0 4.5 ]
[-0.0125 .16939 -24 -4.5 ]
[-0.0125 .16939 0 4.5 ]
[-0.0125 .25084 -18 -4.5 ]
[-0.0125 .25084 0 4.5 ]
[-0.0125 .33228 -24 -4.5 ]
[-0.0125 .33228 0 4.5 ]
[-0.0125 .41373 -18 -4.5 ]
[-0.0125 .41373 0 4.5 ]
[-0.0125 .49518 -24 -4.5 ]
[-0.0125 .49518 0 4.5 ]
[-0.0125 .57663 -18 -4.5 ]
[-0.0125 .57663 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36438 -5 -6 ]
[.97619 .36438 5 6 ]
[.97619 .25354 -5 -6 ]
[.97619 .25354 5 6 ]
[.97619 .47541 -5 -6 ]
[.97619 .47541 5 6 ]
[.97619 .03167 -5 -6 ]
[.97619 .03167 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00649 m
.00625 .00649 L
s
[(0.05)] -0.0125 .00649 1 0 Mshowa
0 .08794 m
.00625 .08794 L
s
[(0.1)] -0.0125 .08794 1 0 Mshowa
0 .16939 m
.00625 .16939 L
s
[(0.15)] -0.0125 .16939 1 0 Mshowa
0 .25084 m
.00625 .25084 L
s
[(0.2)] -0.0125 .25084 1 0 Mshowa
0 .33228 m
.00625 .33228 L
s
[(0.25)] -0.0125 .33228 1 0 Mshowa
0 .41373 m
.00625 .41373 L
s
[(0.3)] -0.0125 .41373 1 0 Mshowa
0 .49518 m
.00625 .49518 L
s
[(0.35)] -0.0125 .49518 1 0 Mshowa
0 .57663 m
.00625 .57663 L
s
[(0.4)] -0.0125 .57663 1 0 Mshowa
.125 Mabswid
0 .02278 m
.00375 .02278 L
s
0 .03907 m
.00375 .03907 L
s
0 .05536 m
.00375 .05536 L
s
0 .07165 m
.00375 .07165 L
s
0 .10423 m
.00375 .10423 L
s
0 .12052 m
.00375 .12052 L
s
0 .13681 m
.00375 .13681 L
s
0 .1531 m
.00375 .1531 L
s
0 .18568 m
.00375 .18568 L
s
0 .20197 m
.00375 .20197 L
s
0 .21826 m
.00375 .21826 L
s
0 .23455 m
.00375 .23455 L
s
0 .26713 m
.00375 .26713 L
s
0 .28342 m
.00375 .28342 L
s
0 .29971 m
.00375 .29971 L
s
0 .316 m
.00375 .316 L
s
0 .34857 m
.00375 .34857 L
s
0 .36486 m
.00375 .36486 L
s
0 .38115 m
.00375 .38115 L
s
0 .39744 m
.00375 .39744 L
s
0 .43002 m
.00375 .43002 L
s
0 .44631 m
.00375 .44631 L
s
0 .4626 m
.00375 .4626 L
s
0 .47889 m
.00375 .47889 L
s
0 .51147 m
.00375 .51147 L
s
0 .52776 m
.00375 .52776 L
s
0 .54405 m
.00375 .54405 L
s
0 .56034 m
.00375 .56034 L
s
0 .59292 m
.00375 .59292 L
s
0 .60921 m
.00375 .60921 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00649 m
1 .00649 L
s
.99375 .08794 m
1 .08794 L
s
.99375 .16939 m
1 .16939 L
s
.99375 .25084 m
1 .25084 L
s
.99375 .33228 m
1 .33228 L
s
.99375 .41373 m
1 .41373 L
s
.99375 .49518 m
1 .49518 L
s
.99375 .57663 m
1 .57663 L
s
.125 Mabswid
.99625 .02278 m
1 .02278 L
s
.99625 .03907 m
1 .03907 L
s
.99625 .05536 m
1 .05536 L
s
.99625 .07165 m
1 .07165 L
s
.99625 .10423 m
1 .10423 L
s
.99625 .12052 m
1 .12052 L
s
.99625 .13681 m
1 .13681 L
s
.99625 .1531 m
1 .1531 L
s
.99625 .18568 m
1 .18568 L
s
.99625 .20197 m
1 .20197 L
s
.99625 .21826 m
1 .21826 L
s
.99625 .23455 m
1 .23455 L
s
.99625 .26713 m
1 .26713 L
s
.99625 .28342 m
1 .28342 L
s
.99625 .29971 m
1 .29971 L
s
.99625 .316 m
1 .316 L
s
.99625 .34857 m
1 .34857 L
s
.99625 .36486 m
1 .36486 L
s
.99625 .38115 m
1 .38115 L
s
.99625 .39744 m
1 .39744 L
s
.99625 .43002 m
1 .43002 L
s
.99625 .44631 m
1 .44631 L
s
.99625 .4626 m
1 .4626 L
s
.99625 .47889 m
1 .47889 L
s
.99625 .51147 m
1 .51147 L
s
.99625 .52776 m
1 .52776 L
s
.99625 .54405 m
1 .54405 L
s
.99625 .56034 m
1 .56034 L
s
.99625 .59292 m
1 .59292 L
s
.99625 .60921 m
1 .60921 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .36438 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .25084 m
.02642 .25724 L
.02903 .25082 L
.03164 .27099 L
.03425 .28911 L
.03686 .2771 L
.03947 .25711 L
.04207 .25935 L
.04468 .27835 L
.04729 .30717 L
.0499 .30344 L
.05251 .30394 L
.05512 .3499 L
.05773 .38146 L
.06034 .3849 L
.06295 .38134 L
.06556 .3586 L
.06817 .3524 L
.07078 .3678 L
.07339 .34113 L
.07599 .34853 L
.0786 .34489 L
.08121 .32358 L
.08382 .32644 L
.08643 .31263 L
.08904 .32627 L
.09165 .31896 L
.09426 .29831 L
.09687 .28409 L
.09948 .24862 L
.10209 .24795 L
.1047 .22298 L
.10731 .2302 L
.10992 .24633 L
.11252 .23212 L
.11513 .23113 L
.11774 .22281 L
.12035 .22056 L
.12296 .2327 L
.12557 .23811 L
.12818 .24018 L
.13079 .2675 L
.1334 .26103 L
.13601 .27238 L
.13862 .27096 L
.14123 .25194 L
.14384 .2749 L
.14644 .31237 L
.14905 .30557 L
.15166 .29669 L
Mistroke
.15427 .27818 L
.15688 .29279 L
.15949 .28216 L
.1621 .29127 L
.16471 .27347 L
.16732 .26476 L
.16993 .2898 L
.17254 .28546 L
.17515 .27288 L
.17776 .29433 L
.18037 .25423 L
.18297 .2346 L
.18558 .22944 L
.18819 .20214 L
.1908 .18425 L
.19341 .21034 L
.19602 .19633 L
.19863 .22268 L
.20124 .20808 L
.20385 .22487 L
.20646 .21911 L
.20907 .21343 L
.21168 .22696 L
.21429 .2089 L
.21689 .23266 L
.2195 .23958 L
.22211 .22259 L
.22472 .25291 L
.22733 .21606 L
.22994 .21385 L
.23255 .22737 L
.23516 .2324 L
.23777 .2531 L
.24038 .23705 L
.24299 .21812 L
.2456 .20973 L
.24821 .21477 L
.25082 .2117 L
.25342 .20594 L
.25603 .21968 L
.25864 .21371 L
.26125 .23484 L
.26386 .23798 L
.26647 .23754 L
.26908 .2654 L
.27169 .25618 L
.2743 .25625 L
.27691 .26493 L
.27952 .25894 L
.28213 .28129 L
Mistroke
.28474 .28128 L
.28735 .26654 L
.28995 .25226 L
.29256 .23327 L
.29517 .22811 L
.29778 .21933 L
.30039 .22142 L
.303 .21921 L
.30561 .20858 L
.30822 .21772 L
.31083 .2199 L
.31344 .23447 L
.31605 .22509 L
.31866 .2514 L
.32127 .27223 L
.32387 .25264 L
.32648 .24744 L
.32909 .24163 L
.3317 .26187 L
.33431 .23797 L
.33692 .25954 L
.33953 .26064 L
.34214 .26562 L
.34475 .25722 L
.34736 .24013 L
.34997 .22861 L
.35258 .23117 L
.35519 .26486 L
.3578 .25029 L
.3604 .27417 L
.36301 .27752 L
.36562 .26467 L
.36823 .23972 L
.37084 .26835 L
.37345 .2847 L
.37606 .28273 L
.37867 .27904 L
.38128 .27604 L
.38389 .26233 L
.3865 .24529 L
.38911 .25019 L
.39172 .27543 L
.39432 .30082 L
.39693 .29283 L
.39954 .28919 L
.40215 .29176 L
.40476 .30808 L
.40737 .28119 L
.40998 .2746 L
.41259 .26598 L
Mistroke
.4152 .27268 L
.41781 .28552 L
.42042 .25965 L
.42303 .2543 L
.42564 .28102 L
.42825 .26151 L
.43085 .28142 L
.43346 .29652 L
.43607 .32485 L
.43868 .30609 L
.44129 .32861 L
.4439 .36363 L
.44651 .37952 L
.44912 .38073 L
.45173 .37849 L
.45434 .36618 L
.45695 .37194 L
.45956 .40246 L
.46217 .41556 L
.46477 .41274 L
.46738 .43949 L
.46999 .4166 L
.4726 .42165 L
.47521 .41592 L
.47782 .41649 L
.48043 .45223 L
.48304 .45328 L
.48565 .46121 L
.48826 .46551 L
.49087 .45375 L
.49348 .48446 L
.49609 .44613 L
.4987 .3992 L
.5013 .41066 L
.50391 .40468 L
.50652 .39417 L
.50913 .3794 L
.51174 .39076 L
.51435 .41533 L
.51696 .40413 L
.51957 .42054 L
.52218 .37924 L
.52479 .38832 L
.5274 .42897 L
.53001 .42988 L
.53262 .44762 L
.53523 .45379 L
.53783 .47617 L
.54044 .48872 L
.54305 .49079 L
Mistroke
.54566 .46149 L
.54827 .46016 L
.55088 .47962 L
.55349 .49612 L
.5561 .52446 L
.55871 .53249 L
.56132 .53417 L
.56393 .54126 L
.56654 .5152 L
.56915 .50903 L
.57175 .46823 L
.57436 .48262 L
.57697 .50878 L
.57958 .54562 L
.58219 .55349 L
.5848 .53978 L
.58741 .54948 L
.59002 .54432 L
.59263 .55612 L
.59524 .57055 L
.59785 .55817 L
.60046 .54109 L
.60307 .53689 L
.60568 .50474 L
.60828 .52522 L
.61089 .52124 L
.6135 .54592 L
.61611 .51594 L
.61872 .49109 L
.62133 .47592 L
.62394 .47915 L
.62655 .49279 L
.62916 .48268 L
.63177 .49357 L
.63438 .49872 L
.63699 .51833 L
.6396 .50878 L
.6422 .4955 L
.64481 .51231 L
.64742 .52362 L
.65003 .49084 L
.65264 .51211 L
.65525 .4979 L
.65786 .48435 L
.66047 .49813 L
.66308 .51791 L
.66569 .50784 L
.6683 .53477 L
.67091 .54691 L
.67352 .55538 L
Mistroke
.67613 .54903 L
.67873 .51548 L
.68134 .53222 L
.68395 .51111 L
.68656 .50722 L
.68917 .51543 L
.69178 .48934 L
.69439 .48859 L
.697 .519 L
.69961 .53875 L
.70222 .50632 L
.70483 .49388 L
.70744 .48378 L
.71005 .48763 L
.71265 .47947 L
.71526 .48876 L
.71787 .4663 L
.72048 .45787 L
.72309 .44761 L
.7257 .42952 L
.72831 .44604 L
.73092 .4592 L
.73353 .47856 L
.73614 .48592 L
.73875 .46563 L
.74136 .45411 L
.74397 .44967 L
.74658 .46545 L
.74918 .47778 L
.75179 .48516 L
.7544 .51106 L
.75701 .52181 L
.75962 .53855 L
.76223 .52274 L
.76484 .51627 L
.76745 .48993 L
.77006 .47553 L
.77267 .4862 L
.77528 .52164 L
.77789 .55567 L
.7805 .57645 L
.78311 .54432 L
.78571 .5343 L
.78832 .56562 L
.79093 .56416 L
.79354 .5562 L
.79615 .55186 L
.79876 .54791 L
.80137 .54885 L
.80398 .58081 L
Mistroke
.80659 .58213 L
.8092 .5788 L
.81181 .56206 L
.81442 .59356 L
.81703 .57035 L
.81963 .57079 L
.82224 .58563 L
.82485 .57823 L
.82746 .58879 L
.83007 .58257 L
.83268 .58323 L
.83529 .57978 L
.8379 .57636 L
.84051 .59487 L
.84312 .58231 L
.84573 .58634 L
.84834 .60309 L
.85095 .60332 L
.85356 .5999 L
.85616 .59131 L
.85877 .56305 L
.86138 .58006 L
.86399 .56985 L
.8666 .54464 L
.86921 .53078 L
.87182 .52137 L
.87443 .50458 L
.87704 .49114 L
.87965 .48343 L
.88226 .47816 L
.88487 .46787 L
.88748 .49358 L
.89008 .49042 L
.89269 .51088 L
.8953 .52214 L
.89791 .49374 L
.90052 .49853 L
.90313 .48844 L
.90574 .48064 L
.90835 .49448 L
.91096 .44794 L
.91357 .44889 L
.91618 .43513 L
.91879 .44667 L
.9214 .46367 L
.92401 .4588 L
.92661 .46674 L
.92922 .44359 L
.93183 .43057 L
.93444 .45427 L
Mistroke
.93705 .45963 L
.93966 .43749 L
.94227 .43985 L
.94488 .44998 L
.94749 .44367 L
.9501 .45047 L
.95271 .45253 L
.95532 .42532 L
.95793 .42616 L
.96053 .40789 L
.96314 .42089 L
.96575 .39094 L
.96836 .38662 L
.97097 .37068 L
.97358 .35286 L
.97619 .36438 L
Mfstroke
0 0 1 r
gsave
.97619 .25354 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25084 m
.02642 .25084 L
.02903 .25084 L
.03164 .25084 L
.03425 .25084 L
.03686 .25084 L
.03947 .25084 L
.04207 .24878 L
.04468 .24878 L
.04729 .24879 L
.0499 .24879 L
.05251 .2488 L
.05512 .24881 L
.05773 .24881 L
.06034 .24732 L
.06295 .24733 L
.06556 .24734 L
.06817 .24735 L
.07078 .24736 L
.07339 .24737 L
.07599 .24737 L
.0786 .24706 L
.08121 .24707 L
.08382 .24708 L
.08643 .24709 L
.08904 .2471 L
.09165 .24711 L
.09426 .24712 L
.09687 .24483 L
.09948 .24485 L
.10209 .24486 L
.1047 .24488 L
.10731 .2449 L
.10992 .24491 L
.11252 .24493 L
.11513 .2441 L
.11774 .24412 L
.12035 .24413 L
.12296 .24415 L
.12557 .24417 L
.12818 .24419 L
.13079 .24421 L
.1334 .24398 L
.13601 .244 L
.13862 .24402 L
.14123 .24403 L
.14384 .24405 L
.14644 .24407 L
.14905 .24409 L
.15166 .24783 L
Mistroke
.15427 .24784 L
.15688 .24785 L
.15949 .24785 L
.1621 .24786 L
.16471 .24787 L
.16732 .24788 L
.16993 .24804 L
.17254 .24805 L
.17515 .24806 L
.17776 .24806 L
.18037 .24807 L
.18297 .24808 L
.18558 .24809 L
.18819 .24953 L
.1908 .24953 L
.19341 .24953 L
.19602 .24954 L
.19863 .24954 L
.20124 .24954 L
.20385 .24955 L
.20646 .25323 L
.20907 .25322 L
.21168 .25322 L
.21429 .25321 L
.21689 .25321 L
.2195 .2532 L
.22211 .25319 L
.22472 .25278 L
.22733 .25277 L
.22994 .25276 L
.23255 .25276 L
.23516 .25275 L
.23777 .25275 L
.24038 .25274 L
.24299 .25299 L
.2456 .25298 L
.24821 .25298 L
.25082 .25297 L
.25342 .25297 L
.25603 .25296 L
.25864 .25296 L
.26125 .25271 L
.26386 .25271 L
.26647 .2527 L
.26908 .2527 L
.27169 .25269 L
.2743 .25269 L
.27691 .25268 L
.27952 .25417 L
.28213 .25416 L
Mistroke
.28474 .25415 L
.28735 .25414 L
.28995 .25413 L
.29256 .25412 L
.29517 .25411 L
.29778 .25425 L
.30039 .25424 L
.303 .25423 L
.30561 .25422 L
.30822 .25421 L
.31083 .2542 L
.31344 .25419 L
.31605 .25223 L
.31866 .25223 L
.32127 .25223 L
.32387 .25222 L
.32648 .25222 L
.32909 .25221 L
.3317 .25221 L
.33431 .25197 L
.33692 .25197 L
.33953 .25197 L
.34214 .25196 L
.34475 .25196 L
.34736 .25196 L
.34997 .25195 L
.35258 .24955 L
.35519 .24955 L
.3578 .24955 L
.3604 .24956 L
.36301 .24956 L
.36562 .24956 L
.36823 .24957 L
.37084 .24992 L
.37345 .24992 L
.37606 .24992 L
.37867 .24992 L
.38128 .24993 L
.38389 .24993 L
.3865 .24993 L
.38911 .25462 L
.39172 .25461 L
.39432 .2546 L
.39693 .25459 L
.39954 .25458 L
.40215 .25457 L
.40476 .25456 L
.40737 .25475 L
.40998 .25474 L
.41259 .25473 L
Mistroke
.4152 .25472 L
.41781 .25471 L
.42042 .2547 L
.42303 .25469 L
.42564 .2534 L
.42825 .25339 L
.43085 .25338 L
.43346 .25338 L
.43607 .25337 L
.43868 .25336 L
.44129 .25336 L
.4439 .25538 L
.44651 .25537 L
.44912 .25535 L
.45173 .25534 L
.45434 .25533 L
.45695 .25532 L
.45956 .2553 L
.46217 .25509 L
.46477 .25508 L
.46738 .25507 L
.46999 .25506 L
.4726 .25505 L
.47521 .25503 L
.47782 .25502 L
.48043 .25093 L
.48304 .25093 L
.48565 .25093 L
.48826 .25093 L
.49087 .25093 L
.49348 .25093 L
.49609 .25093 L
.4987 .25135 L
.5013 .25135 L
.50391 .25135 L
.50652 .25135 L
.50913 .25135 L
.51174 .25135 L
.51435 .25134 L
.51696 .25037 L
.51957 .25037 L
.52218 .25037 L
.52479 .25037 L
.5274 .25038 L
.53001 .25038 L
.53262 .25038 L
.53523 .25496 L
.53783 .25495 L
.54044 .25494 L
.54305 .25493 L
Mistroke
.54566 .25492 L
.54827 .25491 L
.55088 .2549 L
.55349 .25872 L
.5561 .2587 L
.55871 .25868 L
.56132 .25866 L
.56393 .25864 L
.56654 .25862 L
.56915 .25859 L
.57175 .26857 L
.57436 .26852 L
.57697 .26847 L
.57958 .26843 L
.58219 .26838 L
.5848 .26833 L
.58741 .26828 L
.59002 .26354 L
.59263 .26351 L
.59524 .26347 L
.59785 .26344 L
.60046 .2634 L
.60307 .26337 L
.60568 .26333 L
.60828 .25723 L
.61089 .25721 L
.6135 .25719 L
.61611 .25718 L
.61872 .25716 L
.62133 .25714 L
.62394 .25712 L
.62655 .25389 L
.62916 .25388 L
.63177 .25388 L
.63438 .25387 L
.63699 .25386 L
.6396 .25385 L
.6422 .25384 L
.64481 .25031 L
.64742 .25031 L
.65003 .25031 L
.65264 .25031 L
.65525 .25031 L
.65786 .25031 L
.66047 .25032 L
.66308 .24115 L
.66569 .24117 L
.6683 .2412 L
.67091 .24122 L
.67352 .24125 L
Mistroke
.67613 .24128 L
.67873 .2413 L
.68134 .24952 L
.68395 .24952 L
.68656 .24952 L
.68917 .24953 L
.69178 .24953 L
.69439 .24954 L
.697 .24954 L
.69961 .23402 L
.70222 .23406 L
.70483 .23411 L
.70744 .23415 L
.71005 .2342 L
.71265 .23425 L
.71526 .23429 L
.71787 .23708 L
.72048 .23712 L
.72309 .23716 L
.7257 .2372 L
.72831 .23723 L
.73092 .23727 L
.73353 .23731 L
.73614 .24965 L
.73875 .24965 L
.74136 .24966 L
.74397 .24966 L
.74658 .24966 L
.74918 .24967 L
.75179 .24967 L
.7544 .24002 L
.75701 .24005 L
.75962 .24008 L
.76223 .24011 L
.76484 .24014 L
.76745 .24016 L
.77006 .24019 L
.77267 .24231 L
.77528 .24233 L
.77789 .24235 L
.7805 .24238 L
.78311 .2424 L
.78571 .24242 L
.78832 .24245 L
.79093 .23294 L
.79354 .23299 L
.79615 .23304 L
.79876 .23308 L
.80137 .23313 L
.80398 .23318 L
Mistroke
.80659 .23323 L
.8092 .24667 L
.81181 .24668 L
.81442 .24669 L
.81703 .24671 L
.81963 .24672 L
.82224 .24673 L
.82485 .24674 L
.82746 .24082 L
.83007 .24084 L
.83268 .24087 L
.83529 .2409 L
.8379 .24093 L
.84051 .24095 L
.84312 .24098 L
.84573 .25216 L
.84834 .25216 L
.85095 .25215 L
.85356 .25215 L
.85616 .25215 L
.85877 .25214 L
.86138 .25214 L
.86399 .25246 L
.8666 .25245 L
.86921 .25245 L
.87182 .25244 L
.87443 .25244 L
.87704 .25243 L
.87965 .25243 L
.88226 .23977 L
.88487 .2398 L
.88748 .23983 L
.89008 .23986 L
.89269 .23989 L
.8953 .23992 L
.89791 .23995 L
.90052 .25113 L
.90313 .25113 L
.90574 .25113 L
.90835 .25113 L
.91096 .25112 L
.91357 .25112 L
.91618 .25112 L
.91879 .25584 L
.9214 .25582 L
.92401 .25581 L
.92661 .2558 L
.92922 .25578 L
.93183 .25577 L
.93444 .25575 L
Mistroke
.93705 .25477 L
.93966 .25476 L
.94227 .25475 L
.94488 .25474 L
.94749 .25473 L
.9501 .25472 L
.95271 .25471 L
.95532 .25738 L
.95793 .25736 L
.96053 .25734 L
.96314 .25733 L
.96575 .25731 L
.96836 .25729 L
.97097 .25727 L
.97358 .25355 L
.97619 .25354 L
Mfstroke
0 .98 .604 r
gsave
.97619 .47541 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41373 m
.02642 .41418 L
.02903 .41462 L
.03164 .41506 L
.03425 .4155 L
.03686 .41593 L
.03947 .41636 L
.04207 .41471 L
.04468 .41513 L
.04729 .41556 L
.0499 .41598 L
.05251 .4164 L
.05512 .41681 L
.05773 .41722 L
.06034 .41611 L
.06295 .41652 L
.06556 .41693 L
.06817 .41733 L
.07078 .41773 L
.07339 .41812 L
.07599 .41852 L
.0786 .41856 L
.08121 .41895 L
.08382 .41934 L
.08643 .41972 L
.08904 .4201 L
.09165 .42048 L
.09426 .42085 L
.09687 .41891 L
.09948 .41928 L
.10209 .41965 L
.1047 .42002 L
.10731 .42039 L
.10992 .42075 L
.11252 .42112 L
.11513 .42061 L
.11774 .42097 L
.12035 .42132 L
.12296 .42168 L
.12557 .42203 L
.12818 .42238 L
.13079 .42273 L
.1334 .4228 L
.13601 .42314 L
.13862 .42348 L
.14123 .42382 L
.14384 .42416 L
.14644 .42449 L
.14905 .42482 L
.15166 .42885 L
Mistroke
.15427 .42916 L
.15688 .42948 L
.15949 .42979 L
.1621 .4301 L
.16471 .43041 L
.16732 .43071 L
.16993 .43115 L
.17254 .43145 L
.17515 .43175 L
.17776 .43204 L
.18037 .43234 L
.18297 .43263 L
.18558 .43292 L
.18819 .43462 L
.1908 .4349 L
.19341 .43518 L
.19602 .43546 L
.19863 .43574 L
.20124 .43601 L
.20385 .43628 L
.20646 .44021 L
.20907 .44047 L
.21168 .44073 L
.21429 .44099 L
.21689 .44124 L
.2195 .44149 L
.22211 .44174 L
.22472 .44156 L
.22733 .4418 L
.22994 .44205 L
.23255 .4423 L
.23516 .44254 L
.23777 .44278 L
.24038 .44302 L
.24299 .44349 L
.2456 .44372 L
.24821 .44396 L
.25082 .44419 L
.25342 .44442 L
.25603 .44465 L
.25864 .44488 L
.26125 .44484 L
.26386 .44507 L
.26647 .44529 L
.26908 .44552 L
.27169 .44574 L
.2743 .44596 L
.27691 .44618 L
.27952 .44786 L
.28213 .44807 L
Mistroke
.28474 .44828 L
.28735 .44849 L
.28995 .44869 L
.29256 .4489 L
.29517 .4491 L
.29778 .44943 L
.30039 .44963 L
.303 .44983 L
.30561 .45003 L
.30822 .45022 L
.31083 .45042 L
.31344 .45061 L
.31605 .44883 L
.31866 .44903 L
.32127 .44923 L
.32387 .44942 L
.32648 .44962 L
.32909 .44981 L
.3317 .45 L
.33431 .44993 L
.33692 .45012 L
.33953 .45031 L
.34214 .45049 L
.34475 .45068 L
.34736 .45086 L
.34997 .45105 L
.35258 .4488 L
.35519 .44899 L
.3578 .44917 L
.3604 .44936 L
.36301 .44954 L
.36562 .44973 L
.36823 .44991 L
.37084 .45041 L
.37345 .45059 L
.37606 .45077 L
.37867 .45094 L
.38128 .45112 L
.38389 .45129 L
.3865 .45147 L
.38911 .4563 L
.39172 .45645 L
.39432 .45661 L
.39693 .45677 L
.39954 .45692 L
.40215 .45708 L
.40476 .45723 L
.40737 .45756 L
.40998 .45771 L
.41259 .45786 L
Mistroke
.4152 .45801 L
.41781 .45816 L
.42042 .45831 L
.42303 .45845 L
.42564 .45729 L
.42825 .45744 L
.43085 .45759 L
.43346 .45773 L
.43607 .45788 L
.43868 .45802 L
.44129 .45816 L
.4439 .46031 L
.44651 .46044 L
.44912 .46058 L
.45173 .46071 L
.45434 .46085 L
.45695 .46098 L
.45956 .46111 L
.46217 .46101 L
.46477 .46114 L
.46738 .46127 L
.46999 .4614 L
.4726 .46153 L
.47521 .46166 L
.47782 .46178 L
.48043 .4578 L
.48304 .45794 L
.48565 .45807 L
.48826 .45821 L
.49087 .45834 L
.49348 .45848 L
.49609 .45861 L
.4987 .45913 L
.5013 .45926 L
.50391 .45939 L
.50652 .45952 L
.50913 .45965 L
.51174 .45977 L
.51435 .4599 L
.51696 .45902 L
.51957 .45915 L
.52218 .45927 L
.52479 .4594 L
.5274 .45952 L
.53001 .45965 L
.53262 .45977 L
.53523 .46445 L
.53783 .46455 L
.54044 .46466 L
.54305 .46477 L
Mistroke
.54566 .46488 L
.54827 .46499 L
.55088 .46509 L
.55349 .469 L
.5561 .4691 L
.55871 .46919 L
.56132 .46928 L
.56393 .46938 L
.56654 .46947 L
.56915 .46956 L
.57175 .47962 L
.57436 .47968 L
.57697 .47974 L
.57958 .4798 L
.58219 .47987 L
.5848 .47993 L
.58741 .47999 L
.59002 .47532 L
.59263 .47539 L
.59524 .47546 L
.59785 .47554 L
.60046 .47561 L
.60307 .47568 L
.60568 .47575 L
.60828 .46971 L
.61089 .46979 L
.6135 .46988 L
.61611 .46996 L
.61872 .47005 L
.62133 .47013 L
.62394 .47021 L
.62655 .46705 L
.62916 .46714 L
.63177 .46723 L
.63438 .46732 L
.63699 .46741 L
.6396 .46749 L
.6422 .46758 L
.64481 .46411 L
.64742 .4642 L
.65003 .4643 L
.65264 .4644 L
.65525 .46449 L
.65786 .46459 L
.66047 .46468 L
.66308 .45557 L
.66569 .45568 L
.6683 .4558 L
.67091 .45592 L
.67352 .45603 L
Mistroke
.67613 .45615 L
.67873 .45626 L
.68134 .46453 L
.68395 .46462 L
.68656 .46471 L
.68917 .4648 L
.69178 .46489 L
.69439 .46498 L
.697 .46507 L
.69961 .4496 L
.70222 .44973 L
.70483 .44986 L
.70744 .44999 L
.71005 .45012 L
.71265 .45025 L
.71526 .45037 L
.71787 .45321 L
.72048 .45333 L
.72309 .45345 L
.7257 .45357 L
.72831 .45369 L
.73092 .4538 L
.73353 .45392 L
.73614 .4663 L
.73875 .46639 L
.74136 .46647 L
.74397 .46655 L
.74658 .46663 L
.74918 .46671 L
.75179 .46679 L
.7544 .45717 L
.75701 .45728 L
.75962 .45738 L
.76223 .45749 L
.76484 .45759 L
.76745 .45769 L
.77006 .4578 L
.77267 .45995 L
.77528 .46004 L
.77789 .46014 L
.7805 .46023 L
.78311 .46033 L
.78571 .46042 L
.78832 .46052 L
.79093 .45104 L
.79354 .45116 L
.79615 .45128 L
.79876 .4514 L
.80137 .45151 L
.80398 .45163 L
Mistroke
.80659 .45175 L
.8092 .46522 L
.81181 .4653 L
.81442 .46538 L
.81703 .46545 L
.81963 .46553 L
.82224 .46561 L
.82485 .46568 L
.82746 .45979 L
.83007 .45988 L
.83268 .45997 L
.83529 .46006 L
.8379 .46016 L
.84051 .46025 L
.84312 .46034 L
.84573 .47154 L
.84834 .4716 L
.85095 .47166 L
.85356 .47172 L
.85616 .47178 L
.85877 .47183 L
.86138 .47189 L
.86399 .47223 L
.8666 .47229 L
.86921 .47234 L
.87182 .4724 L
.87443 .47245 L
.87704 .47251 L
.87965 .47256 L
.88226 .45992 L
.88487 .46001 L
.88748 .4601 L
.89008 .46019 L
.89269 .46028 L
.8953 .46036 L
.89791 .46045 L
.90052 .47164 L
.90313 .4717 L
.90574 .47175 L
.90835 .47181 L
.91096 .47186 L
.91357 .47191 L
.91618 .47197 L
.91879 .4767 L
.9214 .47674 L
.92401 .47678 L
.92661 .47682 L
.92922 .47686 L
.93183 .4769 L
.93444 .47694 L
Mistroke
.93705 .47597 L
.93966 .47601 L
.94227 .47605 L
.94488 .47609 L
.94749 .47613 L
.9501 .47617 L
.95271 .47621 L
.95532 .47889 L
.95793 .47893 L
.96053 .47896 L
.96314 .47899 L
.96575 .47902 L
.96836 .47905 L
.97097 .47908 L
.97358 .47537 L
.97619 .47541 L
Mfstroke
gsave
.97619 .03167 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .08794 m
.02642 .0875 L
.02903 .08705 L
.03164 .08661 L
.03425 .08618 L
.03686 .08575 L
.03947 .08532 L
.04207 .08285 L
.04468 .08243 L
.04729 .08202 L
.0499 .08161 L
.05251 .0812 L
.05512 .0808 L
.05773 .0804 L
.06034 .07852 L
.06295 .07813 L
.06556 .07775 L
.06817 .07736 L
.07078 .07698 L
.07339 .07661 L
.07599 .07623 L
.0786 .07555 L
.08121 .07518 L
.08382 .07482 L
.08643 .07445 L
.08904 .0741 L
.09165 .07374 L
.09426 .07339 L
.09687 .07075 L
.09948 .07041 L
.10209 .07007 L
.1047 .06974 L
.10731 .0694 L
.10992 .06907 L
.11252 .06874 L
.11513 .06759 L
.11774 .06726 L
.12035 .06694 L
.12296 .06663 L
.12557 .06631 L
.12818 .066 L
.13079 .06569 L
.1334 .06515 L
.13601 .06485 L
.13862 .06455 L
.14123 .06425 L
.14384 .06395 L
.14644 .06365 L
.14905 .06336 L
.15166 .06681 L
Mistroke
.15427 .06651 L
.15688 .06621 L
.15949 .06592 L
.1621 .06563 L
.16471 .06533 L
.16732 .06505 L
.16993 .06493 L
.17254 .06465 L
.17515 .06437 L
.17776 .06408 L
.18037 .0638 L
.18297 .06353 L
.18558 .06325 L
.18819 .06443 L
.1908 .06416 L
.19341 .06389 L
.19602 .06361 L
.19863 .06334 L
.20124 .06308 L
.20385 .06281 L
.20646 .06625 L
.20907 .06598 L
.21168 .06571 L
.21429 .06544 L
.21689 .06517 L
.2195 .06491 L
.22211 .06464 L
.22472 .06399 L
.22733 .06374 L
.22994 .06348 L
.23255 .06322 L
.23516 .06297 L
.23777 .06272 L
.24038 .06247 L
.24299 .06249 L
.2456 .06225 L
.24821 .062 L
.25082 .06176 L
.25342 .06151 L
.25603 .06127 L
.25864 .06103 L
.26125 .06058 L
.26386 .06035 L
.26647 .06011 L
.26908 .05988 L
.27169 .05965 L
.2743 .05942 L
.27691 .05919 L
.27952 .06047 L
.28213 .06024 L
Mistroke
.28474 .06002 L
.28735 .05979 L
.28995 .05956 L
.29256 .05934 L
.29517 .05912 L
.29778 .05907 L
.30039 .05885 L
.303 .05863 L
.30561 .05841 L
.30822 .0582 L
.31083 .05798 L
.31344 .05777 L
.31605 .05563 L
.31866 .05543 L
.32127 .05522 L
.32387 .05502 L
.32648 .05482 L
.32909 .05462 L
.3317 .05442 L
.33431 .05402 L
.33692 .05382 L
.33953 .05362 L
.34214 .05343 L
.34475 .05324 L
.34736 .05305 L
.34997 .05286 L
.35258 .05029 L
.35519 .05011 L
.3578 .04993 L
.3604 .04975 L
.36301 .04958 L
.36562 .0494 L
.36823 .04922 L
.37084 .04943 L
.37345 .04925 L
.37606 .04908 L
.37867 .04891 L
.38128 .04874 L
.38389 .04857 L
.3865 .0484 L
.38911 .05294 L
.39172 .05276 L
.39432 .05259 L
.39693 .05241 L
.39954 .05223 L
.40215 .05206 L
.40476 .05188 L
.40737 .05194 L
.40998 .05177 L
.41259 .0516 L
Mistroke
.4152 .05143 L
.41781 .05126 L
.42042 .05109 L
.42303 .05092 L
.42564 .04951 L
.42825 .04935 L
.43085 .04918 L
.43346 .04902 L
.43607 .04886 L
.43868 .04871 L
.44129 .04855 L
.4439 .05045 L
.44651 .05029 L
.44912 .05013 L
.45173 .04997 L
.45434 .04981 L
.45695 .04965 L
.45956 .0495 L
.46217 .04917 L
.46477 .04902 L
.46738 .04887 L
.46999 .04871 L
.4726 .04856 L
.47521 .04841 L
.47782 .04826 L
.48043 .04406 L
.48304 .04393 L
.48565 .04379 L
.48826 .04366 L
.49087 .04352 L
.49348 .04339 L
.49609 .04325 L
.4987 .04358 L
.5013 .04344 L
.50391 .04331 L
.50652 .04318 L
.50913 .04305 L
.51174 .04292 L
.51435 .04279 L
.51696 .04172 L
.51957 .0416 L
.52218 .04147 L
.52479 .04135 L
.5274 .04123 L
.53001 .04111 L
.53262 .04099 L
.53523 .04548 L
.53783 .04535 L
.54044 .04522 L
.54305 .04509 L
Mistroke
.54566 .04496 L
.54827 .04483 L
.55088 .0447 L
.55349 .04844 L
.5561 .04831 L
.55871 .04817 L
.56132 .04803 L
.56393 .0479 L
.56654 .04776 L
.56915 .04763 L
.57175 .05753 L
.57436 .05737 L
.57697 .05721 L
.57958 .05705 L
.58219 .05689 L
.5848 .05673 L
.58741 .05658 L
.59002 .05176 L
.59263 .05162 L
.59524 .05148 L
.59785 .05134 L
.60046 .0512 L
.60307 .05106 L
.60568 .05092 L
.60828 .04475 L
.61089 .04463 L
.6135 .04451 L
.61611 .04439 L
.61872 .04427 L
.62133 .04415 L
.62394 .04403 L
.62655 .04074 L
.62916 .04063 L
.63177 .04052 L
.63438 .04042 L
.63699 .04031 L
.6396 .04021 L
.6422 .0401 L
.64481 .03651 L
.64742 .03641 L
.65003 .03632 L
.65264 .03623 L
.65525 .03614 L
.65786 .03604 L
.66047 .03595 L
.66308 .02673 L
.66569 .02666 L
.6683 .0266 L
.67091 .02653 L
.67352 .02647 L
Mistroke
.67613 .02641 L
.67873 .02634 L
.68134 .0345 L
.68395 .03442 L
.68656 .03434 L
.68917 .03425 L
.69178 .03417 L
.69439 .03409 L
.697 .03401 L
.69961 .01843 L
.70222 .01839 L
.70483 .01836 L
.70744 .01832 L
.71005 .01828 L
.71265 .01824 L
.71526 .01821 L
.71787 .02095 L
.72048 .02091 L
.72309 .02087 L
.7257 .02082 L
.72831 .02078 L
.73092 .02074 L
.73353 .0207 L
.73614 .033 L
.73875 .03292 L
.74136 .03285 L
.74397 .03277 L
.74658 .0327 L
.74918 .03263 L
.75179 .03255 L
.7544 .02286 L
.75701 .02281 L
.75962 .02277 L
.76223 .02272 L
.76484 .02268 L
.76745 .02264 L
.77006 .02259 L
.77267 .02467 L
.77528 .02462 L
.77789 .02457 L
.7805 .02452 L
.78311 .02447 L
.78571 .02443 L
.78832 .02438 L
.79093 .01484 L
.79354 .01482 L
.79615 .01479 L
.79876 .01477 L
.80137 .01475 L
.80398 .01473 L
Mistroke
.80659 .01472 L
.8092 .02813 L
.81181 .02807 L
.81442 .02801 L
.81703 .02796 L
.81963 .0279 L
.82224 .02785 L
.82485 .0278 L
.82746 .02184 L
.83007 .02181 L
.83268 .02177 L
.83529 .02173 L
.8379 .0217 L
.84051 .02166 L
.84312 .02162 L
.84573 .03278 L
.84834 .03271 L
.85095 .03265 L
.85356 .03258 L
.85616 .03252 L
.85877 .03245 L
.86138 .03239 L
.86399 .03268 L
.8666 .03262 L
.86921 .03255 L
.87182 .03249 L
.87443 .03243 L
.87704 .03236 L
.87965 .0323 L
.88226 .01962 L
.88487 .01959 L
.88748 .01957 L
.89008 .01954 L
.89269 .01951 L
.8953 .01949 L
.89791 .01946 L
.90052 .03061 L
.90313 .03056 L
.90574 .0305 L
.90835 .03045 L
.91096 .03039 L
.91357 .03033 L
.91618 .03028 L
.91879 .03498 L
.9214 .03491 L
.92401 .03484 L
.92661 .03477 L
.92922 .03471 L
.93183 .03464 L
.93444 .03457 L
Mistroke
.93705 .03358 L
.93966 .03351 L
.94227 .03345 L
.94488 .03339 L
.94749 .03333 L
.9501 .03326 L
.95271 .0332 L
.95532 .03586 L
.95793 .0358 L
.96053 .03573 L
.96314 .03566 L
.96575 .03559 L
.96836 .03553 L
.97097 .03546 L
.97358 .03173 L
.97619 .03167 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{591.562, 182.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009?0000]R000`400?l00000o`00003ooooooooo
oooooe7ooooo003oooooooooooooDOooool00?oooooooooooomAooooo`00oooooooooooooe7ooooo
003oooooooooooooDOooool00?oooooooooooomAooooo`00oooooooooooooe7ooooo001:ooooo`;o
00006?ooool3o`0000Cooooo0_l0000Aooooo`?o00001?ooool2o`0000Cooooo0_l0000>ooooo`?o
00000oooool3o`0000Cooooo0_l0000>ooooo`Go00000oooool2o`0000Cooooo0_l0000=ooooo`Go
00000_ooool3o`0000Cooooo0_l0000>ooooo`?o00001?ooool2o`0000Cooooo0_l0000>ooooo`?o
00000oooool3o`0000Cooooo0_l0000Wooooo`;o00005oooool3o`0000Cooooo0_l0000Booooo`?o
00001?ooool2o`0000Cooooo0_l0000>ooooo`?o00000oooool3o`0000Cooooo0_l0000=ooooo`Go
00000oooool2o`0000Cooooo0_l0000=ooooo`Go00000_ooool3o`0000Cooooo0_l0000?ooooo`?o
00001?ooool2o`0000Cooooo0_l0000>ooooo`?o00000oooool3o`0000Cooooo0_l0000dooooo`00
BOooool01?l0003oooooooooool0000Fooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool0000Aooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000>ooooo`05o`000?ooooooooooooooool000000oooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00cooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000gooooo00Ko0000oooooooooooo
0000ooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02_ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000<ooooo`07o`000?ooooooooooooooool0003oooooo`000003ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool08oooool01?l0003oooooooooool0000Eooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`05o`000?oo
ooooooooooooool000000oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00_o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000gooooo00Ko0000oooooooooooo0000ooooool00003ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool02oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000<ooooo`07o`000?ooooooooooooooool0
003oooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0<Oooool0
04Wooooo00Co0000oooooooooooo00006_ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000kooooo00?o0000ooooooooool01Oooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo00kooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool00oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo02?ooooo00Co0000oooooooooooo00006Ooo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo00?o0000oooo
ooooool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000kooooo
00?o0000ooooooooool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00oo
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo037ooooo0019ooooo`04o`000?ooooooooooo`0001[ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000>ooooo`03o`000?oooooooooo00Gooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`0>ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
1?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00cooooo0_l00003ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003_ooool2o`0000Kooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`0Sooooo`04o`000?ooooooooooo`0001Wooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>ooooo`03o`000?oooooo
oooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0=ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00gooooo0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00003_oo
ool2o`0000Kooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0aooooo`00BOoo
ool01?l0003oooooooooool0000Fooooo`Co00000oooool01?l0003oooooooooool0000Aooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>
ooooo`04o`000?ooooooooooooooo`Co00000oooool01?l0003oooooooooool0000=ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000cooooo00Ko0000ooooooooooooooooo`000?ooool4o`0000?ooooo00Co0000oooooooooooo
00004?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool03_ooool00ol0003oooooo`000003o`0000?ooooo00Co0000oooooooooooo00009Ooo
ool01?l0003oooooooooool0000Eooooo`Co00000oooool01?l0003oooooooooool0000Booooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000>
ooooo`04o`000?ooooooooooooooo`Co00000oooool01?l0003oooooooooool0000<ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000cooooo00Ko0000ooooooooooooooooo`000?ooool4o`0000?ooooo00Co0000oooooooooooo
00004Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool03_ooool00ol0003oooooo`000003o`0000?ooooo00Co0000oooooooooooo0000<ooo
ool004Wooooo00Co0000oooooooooooo00005_ooool00ol0003oooooooooo`04ooooo`04o`000?oo
ooooooooo`00013ooooo0_l00004ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00003Oooool2o`0000?ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000=
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000cooooo00Oo0000ooooooooooooooooo`000?oooooo000000Kooooo00Co0000
oooooooooooo00003?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool0000<ooooo`07o`000?ooooooooooooooool0003oooooo`00
0006ooooo`04o`000?ooooooooooo`0002Gooooo00Co0000oooooooooooo00005Oooool00ol0003o
ooooooooo`04ooooo`04o`000?ooooooooooo`00017ooooo0_l00004ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00003Oooool2o`0000?ooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool0000<ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000cooooo00Oo0000ooooooooooooooooo`00
0?oooooo000000Kooooo00Co0000oooooooooooo00003Oooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000<ooooo`07o`000?oo
ooooooooooooool0003oooooo`000006ooooo`04o`000?ooooooooooo`0003?ooooo001:ooooo`;o
00005oooool5o`0000?ooooo0_l0000Booooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o
00003oooool01?l0003oooooooooooooool5o`0000?ooooo0_l0000?ooooo`?o00001?ooool2o`00
00Cooooo0_l0000>ooooo`?o00000_ooool5o`0000?ooooo0_l0000>ooooo`?o00001?ooool2o`00
00Cooooo0_l0000>ooooo`?o00000_ooool5o`0000?ooooo0_l0000Wooooo`;o00005_ooool5o`00
00?ooooo0_l0000Cooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00003oooool01?l0
003oooooooooooooool5o`0000?ooooo0_l0000>ooooo`?o00001?ooool2o`0000Cooooo0_l0000>
ooooo`?o00000_ooool5o`0000?ooooo0_l0000?ooooo`?o00001?ooool2o`0000Cooooo0_l0000>
ooooo`?o00000_ooool5o`0000?ooooo0_l0000dooooo`00oooooooooooooe7ooooo003ooooooooo
ooooDOooool00?oooooooooooomAooooo`00oooooolZooooo`;o00001?ooool00ol0003ooooooooo
o`03ooooo`;o00000oooool3o`000?oooooo4oooool004Kooooohol00002ooooo`03o`000?oooooo
oooo00Kooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo00;ooooo
hOl0000/ooooo`00A_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_l00002ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo0000
1Oooool00ol0003oooooooooo`02ooooo`;o00000oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`?o0000
;?ooool004Kooooo00?o0000ooooooooool0g_ooool2o`0000;ooooo00?o0000ooooooooool01_oo
ool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
gOooool00ol0003oooooooooo`0Zooooo`00A_ooool00ol0003oooooooooo`21ooooo`03o`3jV_oo
oooooooo05[ooooo0_l00002ooooo`03o`000?oooooooooo00Kooooo00Go0000oooooooooooo0000
ooooo`04o`0000Gooooo00?o0000ooooooooool0[_ooool5o`3jVR[ooooo00?o0000ooooooooool0
:_ooool004Kooooo0_l00021ooooo`;o0?ZJFoooool3o`0000;ooooo00?o0000ooooooooool01_oo
ool01_l0003oooooooooool0003oooooo`0000Sooooo00?o0000ooooooooool0V_ooool4o`3jVP?o
oooo00?o0?ZJooooooooool02_ooool01Ol0nY[ooooooooooooooooo0?ZJ013ooooo1?l0nYXFoooo
o`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo083ooooo0_l0nYYLooooo`04
o`000?oooooo0000o`0000[ooooo0_l00002ooooo`Go00001?ooool00ol0003oooooooooo`2Joooo
o`04o`3jV_ooooooooooooooo`Co0?ZJ1?ooool9o`3jVP?ooooo00Co0?ZJoooooooooooooooo1Ol0
nYX8ooooo`04o`3jV_ooooooooooo`3jVQGooooo0_l0000/ooooo`00A_ooool00ol0003ooooooooo
o`1oooooo`03o`3jV_oooooo0?ZJ05cooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`2Aooooo`Go0?ZJ0oooool00ol0nY[oooooooooo`06ooooo`05o`3jV_ooooooooooooooool0nYX0
2oooool5o`3jVP?ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo01?ooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0Oooo
ool00ol0nY[oooooo`3jVP1Looooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0TOoo
ool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJooooooooool01_ooool4o`3jVQCooooo
2Ol0nYX4ooooo`Co0?ZJ1?ooool5o`3jVP?ooooo0_l0nYX4ooooo`03o`000?oooooooooo02[ooooo
0016ooooo`;o0000O_ooool01Ol0003oooooo`3jV_oooooo0?ZJ05_ooooo0_l0000Jooooo`03o`00
0?oooooooooo08gooooo1Ol0nYX4ooooo`?o0?ZJ<_ooool4o`3jVPCooooo1Ol0nYX5ooooo`03o`00
0?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo07gooooo00Go0000o`3jV_oooooooooo
o`3jVP1Looooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0Koooool6o`3jVQCooooo
1Ol0nYY>ooooo`;o0000;?ooool003?ooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol0
0005ooooo`03o`000?oooooooooo07gooooo00Go0000o`3jV_ooooooooooo`3jVP1Looooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool0J?ooool8o`3jVPGooooo1?l0nYX<ooooo`Go0?ZJ
Doooool00ol0003oooooooooo`0Zooooo`00=?ooool00ol0003oooooooooo`06ooooo`05o`000?oo
ooooooooooooool000001?ooool00ol0003oooooooooo`1mooooo`05o`000?l0nY[oooooooooool0
nYX0G?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo04cooooo2?l0nYX5oooooa3o
0?ZJ4?ooool4o`3jVPCooooo1Ol0nYYGooooo`03o`000?oooooooooo02[ooooo000aooooo`Go0000
2oooool00ol0003oooooooooo`02ooooo`;o0000O_ooool01Ol0nY[ooooooooooooooooo0?ZJ05[o
oooo0ol0000Jooooo`03o`000?oooooooooo04Cooooo2?l0nYX8ooooo`Go0?ZJ8oooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo05Sooooo0_l0000/ooooo`00<Oooool01?l0003ooooo
ooooool0000<ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0OOooool01Ol0nY[o
oooooooooooooooo0?ZJ05cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0goooo
o`go0?ZJ>Oooool4o`3jVUcooooo00?o0000ooooooooool0:_ooool003;ooooo00?o0000ooooool0
00002?ooool4o`0000Gooooo00?o0000ooooooooool0O?ooool00ol0003o003oo`00o`03o`00oeco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Kooooo`Co0?ZJ0oooool9o`3jVP;o
oooo2ol0nYZUooooo`03o`000?oooooooooo02[ooooo000cooooo`;o00002?ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo07cooooo00?o0000o`00ooooool00_ooool00ol00?oooooo
ooooo`1Jooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool05Oooool6o`3jVPCooooo
1?l0nYX8ooooo`?o0?ZJ[oooool00ol0003oooooooooo`0Zooooo`00=?ooool00ol0003ooooooooo
o`06ooooo`Go00001?ooool2o`0007gooooo00?o0000o`00ooooool00_ooool00ol00?oooooooooo
o`1Iooooo`;o00006_ooool00ol0003oooooooooo`0Aooooo`Co0?ZJaoooool2o`0002cooooo0016
ooooo`03o`000?oooooooooo07cooooo00?o0000o`00ool0nYX00_ooool00ol00?oo0?ZJooooo`1J
ooooo`03o`000?oooooooooo00Gooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00005
ooooo`03o`000?oooooooooo00[ooooo1ol0nY[<ooooo`03o`000?oooooooooo02[ooooo0016oooo
o`03o`000?oooooooooo07cooooo00?o0000o`00ool0nYX00_ooool01Ol00?oo0?ZJoooooooooooo
0?ZJ05Sooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00009ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01_ooool5o`3jV];ooooo00?o0000ooooooooool0:_oo
ool004Kooooo00?o0000ooooooooool0O?ooool00ol0003o003oo`3jVP02ooooo`03o`00ool0nY[o
oooo00;o0?ZJF?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Wooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`?o0?ZJeoooool00ol0003ooooooooo
o`0Zooooo`00A_ooool2o`0007gooooo00So0000o`00ool0003o0?ZJooooool00?oo0?ZJooooo`;o
0?ZJEoooool2o`0000Kooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`04oooo
o`;o00000oooool00ol0nY[oooooooooo`3Gooooo`;o0000;?ooool004Kooooo00?o0000oooooooo
ool0O?ooool01_l0003o003oo`000?l0nY[o0000o`00o`;o0?ZJ00?oooooo`3jV_ooool0Eoooool0
0ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`3Mooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooo
oooo07cooooo00Co0000o`00ool0003o0?ZJ0_l000001?l00?oo0?ZJooooool0nYYHooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00002?ooool2o`0000Kooooo00?o0000oooooooo
ool0gOooool00ol0003oooooooooo`0Zooooo`00A_ooool00ol0003oooooooooo`1looooo`0:o`00
0?l00?oo0000o`000?l0nY[o0000o`00ool0nY[oooooo`3jVUSooooo00?o0000ooooooooool01Ooo
ool2o`0000[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3Looooo`;o0000;?oo
ool004Kooooo0_l0001mooooo`07o`000?l00?ooooooo`000?l0nY[o0000o`00o`02ooooo`03o`3j
V_oooooooooo05Gooooo0_l0000Jooooo`03o`000?oooooooooo0=gooooo00?o0000ooooooooool0
:_ooool004Kooooo00?o0000ooooooooool0O?ooool00ol0003o003oooooo`02ooooo`05o`3jV_l0
0?ooooooooooool0nYX0F?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0=gooooo
00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0O?ooool00ol0003o003ooooo
o`02ooooo`05o`3jV_l00?ooooooooooool0nYX0F?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo0=gooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0O?oo
ool00ol0003o003oooooo`02ooooo`05o`3jV_l00?ooooooooooool0nYX0F?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo0=cooooo0_l0000/ooooo`00A_ooool2o`0007gooooo00?o
0000o`00ooooool00oooool01?l00?ooooooooooool0nYYGooooo`;o00006_ooool00ol0003ooooo
ooooo`3Mooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo07cooooo00?o
0000o`00ooooool00oooool4o`00oeSooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`3Mooooo`03o`000?oooooooooo02[ooooo000]ooooo`?o00000oooool00ol0003oooooooooo`02
ooooo`?o00000oooool3o`0000Gooooo00?o0000ooooooooool0O?ooool00ol0003o003oooooo`03
ooooo`04o`3jV_l0003oooooo`00oeSooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`3Mooooo`03o`000?oooooooooo02[ooooo000^ooooo`03o`000?oooooooooo00Kooooo00Oo0000
ooooooooooooooooo`000?oooooo000000?ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`1looooo`03o`000?l00?oooooo00?ooooo00Co0?ZJo`000?l0003o003oF?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo0=cooooo0_l0000/ooooo`00:oooool5o`0000_ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`;o0000OOooool00ol0003o003o
ooooo`03ooooo`04o`3jV_oooooo0000o`00oeKooooo0ol0000Jooooo`03o`000?oooooooooo0=go
oooo00?o0000ooooooooool0:_ooool002_ooooo00Co0000oooooooooooo00003?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0M_ooool00ol0003o
ooooooooo`03ooooo`03o`000?l00?oooooo00?ooooo00Co0?ZJooooool0003o003oF?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo0=gooooo00?o0000ooooooooool0:_ooool002co
oooo00?o0000ooooool000002?ooool4o`0000;ooooo1?l00005ooooo`03o`000?oooooooooo07Ko
oooo00?o0000ooooooooool00oooool00ol0003o003oooooo`03ooooo`05o`3jV_ooooooooooo`00
ool0nYX0Eoooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0=cooooo0_l0000/oooo
o`00;Oooool2o`0000Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo07Kooooo00?o0000ooooooooool00oooool00ol0nY[o003oooooo`04ooooo`04
o`3jV_oooooo003oo`3jVUOooooo00Co0000ooooool0003o00001?ooool00ol0003oooooooooo`02
ooooo`?o00000oooool3o`0000Gooooo00?o0000ooooooooool0gOooool00ol0003oooooooooo`0Z
ooooo`00;_ooool00ol0003oooooooooo`06ooooo`Go000000?oooooo`000?l000000ol00004oooo
o`03o`000?oooooooooo07Kooooo00?o0000ooooooooool00oooool00ol0nY[o003oooooo`04oooo
o`04o`3jV_oooooo003oo`3jVUOooooo0_l00002ooooo`03o`000?oooooooooo00Oooooo00Go0000
ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0gOoo
ool00ol0003oooooooooo`0Zooooo`00A_ooool2o`0007Oooooo0_l00003ooooo`03o`3jV_l0003o
003o00Gooooo00Co0?ZJooooool00?oo0?ZJ0_ooool00ol0nY[oooooooooo`1Aooooo`?o00000_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`3Mooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooo
oooo07Kooooo0_l00003ooooo`03o`3jV_l0003o003o00Kooooo00?o0?ZJo`00ool0nYX00_ooool0
0ol0nY[oooooooooo`1Booooo`;o00000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool00_ooool2o`000=gooooo0_l0000/ooooo`00A_ooool00ol0
003oooooooooo`1fooooo`;o000000Koooooo`000?oooooo0?ZJooooool00?l6ooooo`04o`3jV_l0
003o003oooooo`;o0?ZJE?ooool2o`0000;ooooo00?o0000ooooooooool01oooool01?l0003ooooo
ooooooooool4o`0000Gooooo00?o0000ooooooooool0gOooool00ol0003oooooooooo`0Zooooo`00
A_ooool00ol0003oooooooooo`1fooooo`;o000000Koooooo`000?l0nY[o0000ooooool00?l7oooo
o`05o`3jV_l00?oo0?ZJooooool0nYX0E?ooool2o`0000;ooooo00?o0000ooooooooool01_ooool2
o`0000?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3Mooooo`03o`000?oooooo
oooo02[ooooo0016ooooo`;o0000Moooool2o`000006ooooool0003o0?ZJo`000?oooooo003o1ooo
ool01Ol0nY[o003oo`3jV_oooooo0?ZJ05?ooooo0_l000000ooooooo0000o`00000:ooooo`04o`00
0?ooooooooooooooo`Go00001?ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo0;?o
oooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0I?ooool00ol0nY[ooooo
ooooo`0?ooooo`08o`000?oooooo0000o`000?l0nY[o0000ooooool00?l7ooooo`05o`3jV_l00?oo
0?ZJooooool0nYX0E?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool0/_ooool2o`0002cooooo0016ooooo`03o`000?oooooooooo06Cooooo00Go0?ZJ
ooooooooooooooooo`3jVP0=ooooo`08o`000?oooooo0000o`3jV_oooooo0000ooooool00?l7oooo
o`05o`3jV_l00?ooooooooooool0nYX0E?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo02Oooooo00?o0000ooooooooool0/oooool00ol0003oooooooooo`0Zooooo`00A_ooool00ol0
003oooooooooo`0oooooo`05o`3jV_oooooo0000ooooool0nYX05?ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Kooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00_ooooo00?o0000ooooool000001Ol0
0?l7ooooo`05o`3jV_l00?ooooooooooool0nYX0E?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo02Oooooo00?o0000ooooool00000/oooool00ol0003oooooooooo`0Zooooo`00A_oo
ool2o`0000Oooooo00?o0?ZJooooooooool0=_ooool00ol0nY[oooooo`000002o`3jVQ?ooooo0_l0
nYX2ooooo`;o0?ZJ1_ooool2o`3jVP;ooooo0_l0nYX=ooooo`08o`000?oooooo0000o`00oooooooo
0000ooooool0nYX8ooooo`04o`00ool0003oooooo`3jVU?ooooo0_l0000Jooooo`03o`000?oooooo
oooo02Oooooo0ol0002booooo`;o0000;?ooool004Kooooo00?o0000ooooooooool01Oooool2o`3j
VRSooooo00?o0?ZJooooooooool03?ooool2o`3jVP04ooooool0003o0?ZJo`3jVQ?ooooo0_l0nYX2
ooooo`;o0?ZJ1_ooool2o`3jVP;ooooo0_l0nYX=ooooo`08o`000?oooooo0?ZJo`00oooooooo0000
ooooool0nYX8ooooo`04o`00ool0003o0000o`3jVUCooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0Wooooo`?o00002oooool00ol0003oooooooooo`2Uooooo`03o`000?oooooooooo
02[ooooo0016ooooo`03o`000?oooooooooo00Gooooo0_l0nYXWooooo`;o0?ZJ3_ooool2o`3jVP04
ooooool0003o0?ZJo`3jVQ;ooooo00Oo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ00Cooooo00Co
0000o`3jV_oooooo0?ZJ0_ooool2o`3jVPgooooo00So0000ooooool0nY[o003oo`3jV_l0003ooooo
o`3jVPSooooo00Co003oo`000?l0003o0?ZJ0oooool00ol0nY[oooooooooo`1>ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool09oooool4o`0000;ooooo00?o0000ooooooooool01?oo
ool2o`0000_ooooo00?o0000ooooooooool0VOooool00ol0003oooooooooo`0Zooooo`00A_ooool0
0ol0003oooooooooo`04ooooo`03o`3jV_oooooo0?ZJ02Oooooo0_l0nYX3ooooo`05o`3jV_oooooo
ooooooooool0nYX01Oooool01ol0nY[oooooo`3jV_oooooo0?ZJo`000?l0nYX04_ooool01ol0nY[o
ooooo`3jV_oooooo0?ZJooooool0nYX01?ooool01?l0nY[oooooooooooooool2o`3jVP03o`000?l0
nY[ooooo00cooooo00So0000o`3jV_oooooo003oo`3jV_l0003oooooo`3jVPSooooo1?l00?l01?l0
nY[oooooooooool0nYY@ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool09oooool0
1Ol0003oooooo`000?l0003ooooo00;o00000_ooool01_l0003ooooooooooooooooo0000ooooo`;o
00002Oooool00ol0003oooooooooo`2Iooooo`03o`000?oooooooooo02[ooooo0016ooooo`;o0000
1Oooool00ol0nY[oooooo`3jVP0Vooooo`03o`3jV_oooooo0?ZJ00;ooooo0_l0nYX2ooooo`;o0?ZJ
0oooool02Ol0nY[oooooo`3jV_l0003o0?ZJooooool0nY[o0000o`3jVP0Booooo`07o`3jV_oooooo
0?ZJooooool0nY[oooooo`3jVP03ooooo`;o0?ZJ00Oo0000oooooooooooo0?ZJooooool0003o0?ZJ
00gooooo00Go0?ZJoooooooooooo003oo`3jVP02ooooo`03o`3jV_oooooooooo00Kooooo00Ko0?ZJ
o`000?oooooo003oo`3jV_ooool2o`3jVToooooo0_l0000Jooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`05o`0000;ooooo00Co0000oooooooooooo
00000_ooool2o`0000Oooooo00Co0000ooooool0003o0000VOooool2o`0002cooooo000cooooo`?o
00000oooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`04ooooo`03
o`3jV_oooooo0?ZJ02Kooooo00?o0?ZJooooool0nYX00_ooool2o`3jVP04ooooool0nY[oooooo`3j
VP?ooooo0_l0nYX00ooooooo0000o`000002o`3jVP03o`000?l0nY[ooooo013ooooo00So0?ZJoooo
ooooooooooooo`3jV_l0003oooooo`3jVP;ooooo0ol0nYX01ol0003oooooo`000?l0nY[oooooo`00
0?l0nYX03Oooool02?l0nY[oooooooooool00?oo0000o`3jV_oooooo0?ZJ2?ooool01_l0nY[ooooo
ooooool00?oo0?ZJooooo`;o0?ZJD?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
01Cooooo00?o0000ooooooooool00_l0000=ooooo`03o`000?oooooooooo00;o000000Goooooo`00
0?l0003o0000ooooo`02o`000003ooooool0003ooooo00;ooooo00?o0000ooooooooool01Oooool2
o`000004ooooool0003oooooo`0009Sooooo00?o0000ooooooooool0:_ooool003Cooooo00?o0000
ooooooooool01_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00ooo
ool01?l0nY[o0000ooooool0nYXVooooo`0;o`3jV_oooooo0?ZJooooool0nY[oooooo`3jV_oooooo
0?ZJooooool0nYX00_ooool3o`3jVP03ooooool0003o000000;o0?ZJ00?o0000o`3jV_ooool00ooo
ool00ol0nY[oooooooooo`0:ooooo`0:o`3jV_ooooooooooooooool0nY[o0000ooooool0nY[ooooo
o`3jVP;ooooo00So0?ZJo`000?oooooo0000o`3jV_oooooo0000o`3jVP;ooooo00?o0000oooooooo
ool01Oooool01?l0003oooooooooool0nYX2ooooo`05o`00ool0003o0?ZJooooool0nYX02?ooool0
1_l0nY[oooooooooool00?oo0?ZJooooo`;o0?ZJD?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo01Cooooo00?o0000ooooooooool00_l0000=ooooo`03o`000?oooooooooo00?ooooo
0ol000001Ooooooo0000o`000?oooooo000000?ooooo00?o0000ooooooooool01Oooool01_l0003o
ooooooooool0003oooooo`0000Kooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0Z
ooooo`00<Oooool5o`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooo
oooo00?ooooo00Co0?ZJo`000?oooooo0?ZJ9Oooool03_l0nY[oooooooooool0nY[oooooo`3jV_oo
oooo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ0_ooool02?l0nY[oooooo`000?l0003o0?ZJoooo
ool0003o0?ZJ0oooool2o`3jVP?ooooo00?o0?ZJooooooooool01_ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00;o000000?oooooo`3jV_l0nYX00_ooool02?l0nY[o0000ooooool0003o0?ZJooooool0
003o0?ZJ0_ooool00ol0003oooooooooo`05ooooo`04o`000?oooooo0000o`3jVP;ooooo00Go003o
o`000?l0nY[oooooo`3jVP08ooooo`04o`3jV_ooooooooooo`00o`;o0?ZJ00?oooooo`3jV_ooool0
Coooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Cooooo0ol000000ooooooo0000
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo0_l000001Ooooooo0000o`000?oooooo000000?o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`;o00001_ooool2o`0004go
oooo1?l00?l@ooooo`Go003o:_ooool00ol0003oooooooooo`0Zooooo`00<Oooool01?l0003ooooo
ooooool00008ooooo`Co00001Oooool2o`0000Cooooo00Co0?ZJo`000?l0003o0?ZJ9Oooool01?l0
nY[oooooooooool00002o`3jVP03ooooool0nY[o0?ZJ00;ooooo00?o0?ZJooooool0nYX00_ooool0
3Ol0nY[oooooo`000?oooooo0?ZJooooool0003oooooo`3jV_oooooo0?ZJooooool0nYX00_ooool2
o`3jVPOooooo00?o0?ZJooooooooool00_ooool01?l0nY[oooooo`000?ooool2o`3jVP;ooooo1Ol0
0?l2o`000004o`3jV_ooooooooooo`0000Oooooo00Co0000ooooool0003o0?ZJ0_ooool00ol00?oo
0000ooooo`02o`3jVPSooooo00Go0?ZJoooooooooooo003oo`3jVP02ooooo`03o`3jV_oooooooooo
04cooooo0ol0000Jooooo`03o`000?oooooooooo01Cooooo0ol00002ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool01?ooool3o`000004ooooool0003oooooo`0000?ooooo0_l00005
ooooo`03o`000?oooooooooo00;ooooo0_l00003ooooo`03o`000?oooooooooo00;o0000COooool0
1?l00?ooooooooooooooool4o`00o`cooooo00Go003oooooooooooooooooo`00o`0Yooooo`;o0000
;?ooool003;ooooo00?o0000ooooool000002?ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00;ooooo00Go0?ZJooooool0003o0000o`3jVP0Sooooo`;o000000Go0?ZJo`000?oooooo
0000o`3jVP03ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0_ooool8o`00o`09o`3jV_oooooo0?ZJ
ooooool0nY[oooooo`3jV_oooooo0?ZJ00Oooooo00?o0?ZJooooooooool00_ooool3o`00o`03oooo
ool0nY[o0?ZJ00;ooooo00Co003oo`000?oooooo00001?l00?l2ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooool0nYX00oooool00ol00?ooooooooooo`02o`3jVPSooooo00Go0000o`3jV_oo
oooo0000o`00o`02ooooo`03o`3jV_oooooooooo04kooooo00?o0000ooooooooool01Oooool2o`00
00Cooooo00Co0000oooooooooooooooo1Ol00004ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooool000000oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo0_l00000
1?oooooo0000ooooool00004ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool01Ol0003oooooo`000?oooooo000000;ooooo0_l00002ooooo`03o`000?oooooooooo03oooooo
1Ol00?l4ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool00_ooool9o`00o`?ooooo
00Co003ooooooooooooooooo1Ol00?l8ooooo`Co003o5_ooool00ol0003oooooooooo`0Zooooo`00
<oooool2o`0000Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`02ooooo`Go003o
0oooool00ol0nY[oooooooooo`0Mooooo`07o`000?l0nY[o0000o`000?oooooo0000o`3jVP03oooo
o`05o`3jV_ooooooooooooooool0nYX00oooool01Ol00?ooooooo`000?oooooo0?ZJ00;ooooo00?o
003oo`3jV_l0nYX00_ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00Oooooo1Ol00?l01_l0nY[ooooo
o`000?l00?oo0?ZJo`0000;ooooo00Go003oo`000?oooooo0000o`3jVP02o`000004o`00oooooooo
0000o`0000Kooooo0_l000000ooooooo003oo`00o`02ooooo`05o`00ooooooooooooooooool0nYX0
2Oooool01?l0nY[oooooo`000?l00?l2ooooo`03o`3jV_oooooooooo04kooooo00?o0000oooooooo
ool01?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ooooooooool02_oooolEo`00o`Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02
o`0000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`05o`000?oooooo
0000ooooool000000_ooool2o`0000;ooooo00Go0000ooooooooooooooooo`00000mooooo`05o`00
ooooooooooooooooool00?l00oooool00ol00?ooooooooooo`06ooooo`05o`00oooooooooooooooo
ool00?l02oooool5o`00o`?ooooo00?o003oooooooooool01_ooool01?l00?ooooooooooool00?lF
ooooo`03o`000?oooooooooo02[ooooo000dooooo`03o`000?oooooooooo00Sooooo0_l00005oooo
o`03o`000?oooooooooo00;ooooo00Oo0?ZJo`000?l0003oooooo`00ool0nY[ooooo00;o0?ZJ7ooo
ool02ol0003o003oo`00ool00?ooooooo`000?l0nY[oooooo`000?oooooo0?ZJ00?ooooo00Wo0?ZJ
ooooooooooooooooo`00oooooooo0000ooooool0nYX00_ooool00ol00?oo0?ZJo`3jVP02ooooo`;o
0?ZJ0_ooool00ol0nY[oooooooooo`04ooooo`03o`000?l00?oooooo00;o000000Ooooooo`3jV_oo
oooo0000o`00ool0nY[o000000;ooooo00Go003oo`000?oooooo0000o`3jVP02o`000004o`00ool0
nY[o0000o`0000Cooooo0_l0nYX2o`000003ooooool00?oo003o00?o003o3_ooool00ol0nY[o0000
o`00o`02ooooo`03o`3jV_oooooooooo04Oooooo00?o0?ZJooooooooool01?ooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01?ooool2o`0000?o
oooo2Ol00?l8ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool<o`00
o`Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00?ooooo4?l00?l00ol0003oooooooooo`0Aooooo`go003o6?ooool5o`00o`Cooooo1?l00?l8
ooooo`Co003o5?ooool5o`00o`?ooooo00?o003oooooooooool00_ooool4o`00oa7ooooo0_l0000/
ooooo`00A_ooool2o`0000?ooooo00Oo0?ZJooooool0003oooooo`00ool0nY[ooooo00;o0?ZJ7ooo
ool00ol0003o003oooooo`03o`00o`05o`3jV_oooooo0000ooooool0nYX00oooool01_l0nY[o0000
ooooool00?oo0?ZJo`0000;ooooo0_l0nYX01?oooooo003oo`3jV_l0nYX2ooooo`;o0?ZJ0_ooool0
0ol0nY[oooooooooo`04ooooo`03o`000?l00?oo000000;o000000Koooooo`3jV_ooooooooooo`00
ool0nYX2o`000003o`00ool0nY[ooooo00;o000000Go0?ZJoooooooooooo003oo`3jVP02o`000006
o`3jV_ooooooooooo`3jV_oooooo0?ZJ0_l000000ooooooo003oooooo`02ooooo`03o`3jV_oooooo
oooo00gooooo00Go0?ZJo`00ooooooooooooo`3jVP19ooooo`03o`3jV_oooooooooo00?ooooo0_l0
0006ooooo`04o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`02ooooo`;o00003oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000So
oooo00?o0000ooooooooool00ooooolIo`00o`;o000000Koooooo`000?l0003oooooo`000?ooool2
o`000003ooooool0003ooooo00;ooooo00?o0000o`00ool00?l04ol00?l<ooooo`Co003o4?ooool5
o`00oc7ooooo1?l00?l8ooooo`Wo003o0oooool2o`00o`Cooooo00?o0000ooooooooool0:_ooool0
04Kooooo00?o0000ooooooooool00oooool01?l0nY[oooooooooool00?l2o`3jVP03ooooool0nY[o
oooo01kooooo00?o0000o`00ooooool00_l000001Ooooooo003oo`00ool00?oo000000Co003o00Ko
0?ZJo`000?oooooo003oo`3jV_l00002ooooo`;o0?ZJ00Coooooo`000?l00?oo0?ZJ0_ooool2o`3j
VP;ooooo00?o0?ZJooooooooool01?ooool00ol0003o003oo`3jVP03o`000005o`3jV_oooooooooo
ooooool00?l00_l000000ol00?oo0?ZJooooo`02o`000006o`3jV_ooooooooooo`00ool0nY[o0000
0_l0nYX2ooooo`03o`3jV_oooooo0?ZJ00;o000000?oooooo`00ool0nYX00_ooool00ol0nY[ooooo
ooooo`0=ooooo`03o`3jV_l00?oo003o00;o003o00Co0?ZJoooooooooooo0?ZJA?ooool2o`3jVPKo
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`02ooooo`;o000000?oooooo`000?l000003?ooool0
0ol0003oooooooooo`04ooooo`?o00002?ooool00ol0003oooooooooo`0Aooooo`?o00000_ooool0
0ol0003oooooooooo`03ooooo`;o000000?oooooo`000?l000000_l000001?oooooo0000o`000?oo
ool2o`0000;ooooo0_l00006ooooo`;o00007?ooool4o`00o`Sooooo1Ol00?m9ooooo`Go003o1Ooo
ool00ol0003oooooooooo`0Zooooo`00A_ooool00ol0003oooooooooo`03ooooo`04o`3jV_oooooo
ooooo`00o`;o0?ZJ00?oooooo`3jV_ooool07_ooool02?l0003o003oo`3jV_oooooo0000ooooool0
nY[ooooo0_l00?l01?l0nY[o0000ooooool00004o`00o`04o`3jV_l0003oooooooooo`;o0?ZJ00Co
ooooo`000?l00?oo0?ZJ0_ooool2o`3jVP;ooooo00?o0?ZJooooooooool00oooool2o`000003o`00
ool0nY[o000000;o000000Co0?ZJoooooooooooooooo1?l00?l2o`3jVP03o`000?l0nY[o0?ZJ00;o
oooo00?o003oo`3jV_l000000_l0nYX2ooooo`08o`3jV_oooooo0?ZJo`000?oooooo0000o`00ool0
nYX2ooooo`03o`3jV_oooooooooo00kooooo00Go0?ZJoooooooooooo003oo`3jVP02ooooo`03o`3j
V_oooooooooo047ooooo00?o0?ZJooooool0nYX01_ooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
00Cooooo0ol0000<ooooo`03o`000?oooooooooo00Cooooo0ol00005ooooo`04o`000?oooooooooo
o`0001?ooooo00Go0000ooooool0003oooooo`000007ooooo`04o`000?oooooo0000ooooo`;o0000
00Coooooo`000?l0003ooooo0_l00002ooooo`;o00001_ooool3o`0001kooooo00?o003ooooooooo
ool00_ooool5o`00oeOooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0
0oooool01?l0nY[oooooooooool00?l2o`3jVP03ooooool0nY[ooooo01kooooo013o0000o`00ool0
nY[oooooo`000?oooooo0?ZJooooool0003oooooo`3jV_oooooo0000ooooool0nY[ooooo0_l00002
o`3jVP08ooooool0nY[oooooo`3jV_oooooo0000o`00ool00002ooooo`;o0?ZJ0_ooool02_l0nY[o
oooooooooooooooo0?ZJooooool0003o0?ZJo`00ool0nYX2o`000003o`3jV_oooooo0?ZJ00;ooooo
00Ko0?ZJoooooooooooo0000o`3jV_ooool2o`3jVP06ooooool0nY[oooooo`00ool0nY[o00000_l0
nYX02_oooooo0?ZJo`000?oooooo0?ZJo`000?oooooo0?ZJo`00ool0nYX2ooooo`03o`3jV_oooooo
oooo00kooooo00Ko0?ZJoooooooooooo003oo`3jV_ooool2o`3jVSgooooo00Co0?ZJoooooooooooo
00000_ooool00ol0nY[oooooo`3jVP06ooooo`03o`000?oooooooooo00Gooooo0_l00009ooooo`?o
00001Oooool00ol0003oooooooooo`04ooooo`?o00003?ooool00ol0003oooooooooo`04ooooo`Co
00001?ooool01?l0003oooooooooool0000Eooooo`03o`000?oooooo000000Oooooo00Go0000oooo
ooooooooooooo`000003ooooo`04o`000?oooooo0000o`0000;ooooo00?o0000ooooool000000ooo
ool00ol0003oooooo`000002o`0001oooooo1?l00?mKooooo`;o0000;?ooool004Kooooo0_l00005
ooooo`04o`3jV_oooooo0000o`00o`;ooooo00?o0?ZJooooooooool07Oooool00ol0nY[o003oo`3j
VP03ooooo`05o`3jV_oooooo0000ooooool0nYX00oooool01_l0nY[oooooo`000?l0003o0?ZJoooo
o`;o0?ZJ0_ooool00ol0nY[o0000o`00o`04o`00o`?ooooo00?o0?ZJooooooooool00_l0nYX02_oo
oooo0000o`3jV_l00?ooooooo`3jV_oooooo0?ZJooooool0nYX2ooooo`06o`3jV_ooooooooooo`00
0?l0nY[ooooo0_l0nYX2ooooo`0@o`3jV_l0003o003oo`3jV_l0003o0?ZJooooool0nY[o0000oooo
ool0nY[o0000o`3jV_oooooo003oo`3jVP;ooooo00?o0?ZJooooooooool03_ooool01_l0nY[ooooo
ooooool00?oo0?ZJooooo`;o0?ZJ??ooool2o`3jVP;ooooo00Ko0000oooooooooooo0?ZJooooool0
nYX5ooooo`;o00006_ooool00ol0003oooooooooo`04ooooo`;o000000?oooooo`000?ooool02Ooo
ool00ol0003oooooooooo`06ooooo`?o00001?ooool01?l0003oooooo`000?l0000Fooooo`;o0000
1oooool00ol0003oooooooooo`05ooooo`;o000000Coooooo`000?oooooo00000_ooool01?l0003o
ooooooooooooool5o`0007oooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000oooooooo
ool01?ooool01ol0nY[oooooooooool00?ooooooo`000?l0nYX07oooool01?l0nY[o003oooooool0
nYX2ooooo`05o`3jV_oooooo0000ooooool0nYX00oooool01_l0nY[oooooooooool0003o0?ZJoooo
o`;o0?ZJ0_ooool00ol0nY[oooooo`3jVP02o`000003ooooool00?oo003o00?o003o0_ooool2o`3j
VP0:ooooool0nY[oooooo`00oooooooo0?ZJooooool0nY[oooooo`3jVP;ooooo00Co0?ZJoooooooo
oooo0?ZJ0_ooool02?l0003o0?ZJoooooooooooo0?ZJo`000?l00?oo0?ZJ0_l00002o`3jVP;o0000
00Ko0?ZJo`000?l0nY[oooooo`00ool0nYX2ooooo`03o`3jV_oooooooooo00kooooo00Co0?ZJoooo
oooooooo003o0_l0nYX00ooooooo0?ZJooooo`0kooooo`;o0?ZJ0_ooool00ol0003oooooo`3jVP02
ooooo`03o`3jV_oooooooooo00Cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`04
ooooo`;o000000?oooooo`000?ooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
000000;ooooo00?o0000ooooool000005oooool2o`00013ooooo00Go0000ooooool0003oooooo`00
0002ooooo`04o`000?ooooooooooooooo`;o000000?oooooo`000?l00000Ooooool00ol0003ooooo
ooooo`0Zooooo`00A_ooool00ol0003oooooooooo`05ooooo`06o`3jV_oooooo003oooooool0003o
0?ZJ0oooool00ol0nY[oooooooooo`0Hooooo`06o`3jV_l0003o003oooooool0nY[ooooo0_l0nYX0
1?oooooo0000ooooool0nYX3ooooo`04o`3jV_ooooooooooo`3jVP;ooooo0_l0nYX3ooooo`;o0?ZJ
0_l000000ooooooo0?ZJooooo`02ooooo`09o`00oooooooo0?ZJo`000?l0nY[oooooo`3jV_oooooo
003o00;ooooo0_l0nYX2ooooo`?o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o
0?ZJo`00ool0nYX00_l00002o`3jVP;o00000_l0nYX2ooooo`05o`00oooooooo0?ZJooooool0nYX0
4?ooool01?l0nY[oooooooooool00?l2o`3jVP03ooooool0nY[ooooo00Kooooo0_l0nYXQooooo`03
o`000?oooooooooo00kooooo00?o0?ZJooooool0nYX00_ooool00ol0003o0?ZJo`3jVP02ooooo`03
o`3jV_oooooooooo00Cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`04ooooo`;o
000000?oooooo`000?ooool02Oooool00ol0003oooooooooo`08ooooo`05o`000?oooooo0000o`00
0?ooool00ol0000Gooooo`;o00004_ooool3o`0000;ooooo00Oo0000oooooooooooo0000ooooool0
003ooooo00;o0000O_ooool2o`0002cooooo0016ooooo`03o`000?oooooooooo00Gooooo00?o0?ZJ
ooooool00?l00_l000000ol0nY[oooooooooo`02o`3jVQWooooo00oo0?ZJooooool0003o003ooooo
ool0nY[oooooo`3jV_l0003o0?ZJo`000?l0nY[oooooo`3jV_ooool00_l0nYX2ooooo`05o`3jV_oo
ooooooooooooool0nYX00oooool01_l0nY[oooooo`3jV_l0003oooooo`3jVP?ooooo00Wo003ooooo
ool0nY[o0000o`3jV_oooooo0?ZJooooool00?l00_ooool2o`3jVP;ooooo0ol0nYX2ooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJo`00ool0nYX00_l00002o`3jVP04ooooool0003o0?ZJo`3jVP;o
oooo00?o003oooooooooool00_l0nYX@ooooo`05o`000?l0nY[oooooooooool00?l00_ooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooo0?ZJ027ooooo00?o0000ooooooooool03_ooool00ol0
nY[oooooo`3jVP02ooooo`?o0?ZJ0_ooool00ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000:ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooool000000_l000000ooooooo0000o`00000[ooooo`03o`000?oooooo
oooo00;ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo07gooooo
00?o0000ooooooooool0:_ooool004Kooooo0_l00007ooooo`03o`3jV_l00?oo003o00;o003o00Co
0?ZJooooool0nY[o0?ZJ0oooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ00?oooooo`000?l00?l0
0_ooool2o`3jVP0<o`000?l0nY[o0000o`3jV_oooooo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ
0oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_l0003ooooo00;o0?ZJ00Ko0000ooooool00?oo
0?ZJooooool00002o`3jVP03o`000?oooooo003o00?ooooo00Wo0?ZJooooooooooooooooo`3jV_oo
oooo0?ZJooooool0nYX01oooool02Ol0nY[o003oo`3jV_oooooo0000o`3jV_l0003oooooo`000002
o`3jVP;ooooo00?o003oooooooooool00_l0nYX@ooooo`05o`000?oooooo0?ZJo`000?l00?l00_oo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo0?ZJ027ooooo00?o0000ooooooooool03_oo
ool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_l0003o0?ZJ00;ooooo00?o0?ZJooooooooool00ooo
ool2o`0001[ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000:ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooool000000_l000000ooooooo0000o`00000`ooooo`Co0000
1Oooool00ol0003oooooooooo`1looooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oo
oooooooo00Oooooo00Co0?ZJo`000?l0003o003o0_l0nYX01?oooooo0?ZJooooooooool2o`3jVQ3o
oooo00?o0?ZJooooooooool00ol0nYX00ooooooo0000o`00o`02ooooo`;o0?ZJ00Coooooo`3jV_l0
003o0?ZJ0_ooool2o`3jVP04ooooool0nY[oooooo`3jVPWooooo00?o0?ZJo`000?ooool00_l0nYX0
1_l0003oooooo`00ool0nY[oooooo`0000;o0?ZJ0_ooool00ol00?ooooooooooo`07ooooo`03o`3j
V_oooooo0?ZJ00Sooooo00Co003ooooooooooooooooo1Ol00?l01?l0nY[oooooooooool00?l3oooo
o`03o`3jV_oooooooooo00kooooo00Go0000ooooool0nY[o0000o`00o`02ooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooool0nYX08Oooool3o`0000gooooo00Ko0?ZJoooooooooooo0?ZJoooo
ool0nYX2o`000004o`00ooooooooooooo`3jVPKooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool01?l0003o
ooooo`000?l00003ooooo`03o`000?oooooooooo02kooooo1?l00005ooooo`03o`000?oooooooooo
07cooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool01oooool01?l0nY[o
0000o`000?l00?l2o`3jVP06ooooool0nY[oooooo`3jV_oooooo0?ZJ3_ooool3o`3jVP;ooooo0ol0
nYX00ol0003oooooo`00o`03ooooo`03o`3jV_oooooooooo00;o0?ZJ0oooool01Ol0nY[oooooo`3j
V_oooooo0?ZJ00Wooooo00?o0?ZJo`000?l000000_l0nYX2o`000004o`00ool0nY[o0000ooooo`;o
0?ZJ0_ooool00ol00?ooooooooooo`08ooooo`;o0?ZJ2?ooool4o`00o`06o`3jV_l0003ooooooooo
ool00?oo0?ZJ0_ooool00ol00?ooooooooooo`0Booooo`05o`000?ooooooooooo`3jV_l00?l00_oo
ool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVP_ooooo00?o0?ZJooooooooool0
4oooool2o`000003o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01_ooool01_l0nY[ooooo
ooooool0nY[oooooo`3jVP;o00001?l00?l00ol0nY[oooooooooo`03ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooool00000=Oooool00ol0003oooooo`000006ooooo`03o`000?oooooooooo
07_ooooo0_l0000/ooooo`00A_ooool00ol0003oooooooooo`07ooooo`05o`3jV_l0003oooooo`00
ool0nYX00_ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00kooooo00Ko0?ZJooooool0nY[oooooo`3j
V_ooool2o`3jVP03o`000?oooooo003o00Kooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00;o0?ZJ
2_ooool01?l0nY[o0000o`3jV_l0nYX2o`000006o`00ool0nY[oooooooooool0nY[o00000_ooool0
0ol00?ooooooooooo`09ooooo`03o`3jV_oooooooooo00Kooooo00Go0?ZJooooooooooooooooo`3j
VP03ooooo`05o`00ooooooooooooooooool00?l05?ooool01?l0003oooooooooool0nYX4o`00o`Go
oooo00Co0?ZJoooooooooooo0?ZJ2_ooool2o`3jVQGooooo0_l000001?l0nY[oooooooooooooool2
o`3jVPSooooo00Wo0?ZJooooool0003o0?ZJooooool0nY[o0000ooooool00?l00_ooool00ol00?oo
0?ZJooooo`04ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool2o`0000Wo
oooo00?o0000ooooooooool02?ooool2o`0003Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1looooo`03o`000?oooooooooo02[ooooo0016ooooo`;o00002?ooool01Ol0nY[o0000
ooooool00?oo0?ZJ00?ooooo0_l0nYX00ooooooo0?ZJooooo`0=ooooo`0;o`3jV_oooooo0?ZJoooo
ool0nY[o0000o`3jV_oooooo0000ooooool00?l01oooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo00Sooooo00So0?ZJo`000?l0nY[o0000o`3jV_l0003o003oo`0000;ooooo00Go0?ZJ
o`000?ooooooooooo`00o`0;ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooooooo
0_l0nYX2ooooo`Go003o5?ooool01Ol0003oooooooooool0003o0?ZJ00;ooooo00?o003ooooooooo
ool00oooool01?l0nY[oooooooooool0nYX:ooooo`;o0?ZJ5Oooool00ol0003o0?ZJo`3jVP02oooo
o`03o`3jV_oooooo0?ZJ00Oooooo00Co0?ZJoooooooooooo00000_l0nYX2o`000006ooooool00?oo
ooooooooool00?oo0?ZJ1?ooool2o`0001[ooooo00?o0000ooooooooool01oooool2o`0000Wooooo
00?o0000ooooooooool02?ooool2o`0003Sooooo00?o0000ooooooooool01?ooool2o`0007gooooo
00?o0000ooooooooool0:_ooool002gooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol0
0003ooooo`?o00001Oooool00ol0003oooooooooo`07ooooo`05o`3jV_l0003oooooo`000?l00?l0
0oooool01?l0nY[oooooooooool0nYX=ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oooooo`000?l0
0?l01?l00?l?ooooo`03o`3jV_oooooooooo00Sooooo00Ko0?ZJo`000?l0nY[o0000o`3jV_ooool2
o`00o`;ooooo1Ol00?lEooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool01Ol0nY[ooooooooooooo
oooo0?ZJ01Cooooo00Go0000oooooooooooo0000o`3jVP02ooooo`03o`00oooooooooooo00?ooooo
00Co0?ZJoooooooooooo0?ZJ2Oooool00ol0nY[oooooo`3jVP0Eooooo`03o`000?l0nY[o0?ZJ00;o
oooo00?o0?ZJooooool0nYX01oooool01?l00?ooooooooooool00002o`3jVP;o000000Koooooo`00
ooooooooooooo`00ool0nYX5ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`05ooooo`;o00002oooool00ol0003oooooooooo`0nooooo`;o0000OOoo
ool00ol0003oooooooooo`0Zooooo`00;_ooool00ol0003oooooooooo`06ooooo`07o`000?oooooo
ooooooooool0003oooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
2?ooool02ol0nY[oooooooooool00?ooooooo`000?oooooo0?ZJo`000?oooooo0?ZJ00gooooo00?o
0?ZJooooooooool00_l0nYX01?oooooo0000o`00ool00002ooooo`03o`3jV_oooooooooo01Sooooo
00So0000o`3jV_l0nY[o0000o`3jV_oooooo0?ZJooooo`?o003o0oooool00ol0nY[oooooooooo`0C
ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo0?ZJ01Cooooo00Go
0000oooooooooooo0000o`3jVP02ooooo`03o`00oooooooooooo00;ooooo00Go0?ZJoooooooooooo
ooooo`3jVP09ooooo`03o`3jV_oooooo0?ZJ01Gooooo00Go0000o`3jV_l0nY[oooooo`3jVP02oooo
o`03o`3jV_oooooooooo00Gooooo1Ol00?l01Ol0nY[o0000o`000?l00?oo0?ZJ00;ooooo00?o003o
o`3jV_ooool01?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01Oooool2o`0004cooooo0_l0001looooo`;o0000;?ooool002_ooooo1Ol00007oooo
o`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00Sooooo00_o0?ZJoooooooooooo003oooooool0003oooooo`3jV_l0003oooooo`3jVP0=oooo
o`03o`3jV_oooooo000000;o0?ZJ00?oooooo`000?l00?l00oooool00ol0nY[oooooooooo`0Hoooo
o`03o`000?oooooooooo00;ooooo0_l0nYX3ooooo`05o`3jV_ooooooooooooooool0nYX05Oooool0
1Ol0nY[oooooo`3jV_oooooo0?ZJ00;ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo01;ooooo00So
0000oooooooooooo0000o`3jV_l0003oooooo`00o`Cooooo00Go0?ZJooooooooooooooooo`3jVP09
ooooo`03o`3jV_oooooo0?ZJ01Gooooo00Go0?ZJo`000?l0nY[o0000o`3jVP02ooooo`03o`3jV_oo
oooooooo00Gooooo00Ko003ooooooooooooo0000o`00ooooool2o`000006o`00ool0nY[ooooooooo
ool00?oo0?ZJ1Oooool01?l0003oooooo`000?l00004ooooo`04o`000?ooooooooooooooo`Go0000
0_ooool3o`0000Gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooo000004cooooo00?o0000ooooool00000O?ooool00ol0003oooooooooo`0Zooooo`00:ooo
ool01?l0003oooooooooool00008ooooo`Co00001_ooool00ol0003oooooooooo`02ooooo`;o0000
2Oooool00ol0nY[oooooooooo`04o`00o`04o`3jV_l0003oooooo`3jVPgooooo00?o0?ZJooooool0
00000_l0nYX01?l0003oooooo`00ool0nYX2ooooo`03o`3jV_oooooooooo01kooooo0_l0nYX2oooo
o`;o0?ZJ0_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooo0?ZJ00;ooooo00Co0?ZJoooo
ool0nY[o0?ZJ0_ooool00ol0nY[oooooooooo`0Booooo`08o`000?oooooo0000ooooool0nY[o0000
ooooool00?l4ooooo`Go003o2?ooool01?l0nY[oooooooooool0nYXEooooo`03o`3jV_l0003o0000
00;o0?ZJ0_ooool00ol0nY[oooooooooo`05ooooo`05o`00ooooooooooooo`000?l00?l00_ooool0
1ol0003o003oo`3jV_l0nY[oooooo`000?l00?l00oooool4o`0000;ooooo00?o0000ooooooooool0
1_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool00000C?ooool00ol0
003oooooo`00001looooo`03o`000?oooooooooo02[ooooo000/ooooo`03o`000?oooooo000000So
oooo00?o0000ooooooooool00oooool4o`0000Gooooo00?o0000ooooooooool02Oooool01ol0nY[o
ooooo`3jV_oooooo0000ooooool00?l00_l000000ol0nY[oooooooooo`0:ooooo`05o`3jV_oooooo
ooooo`000?l0nYX00_l000000ooooooo003oo`3jVP02ooooo`03o`3jV_oooooooooo01oooooo00?o
0?ZJooooooooool00_l0nYX2ooooo`03o`3jV_oooooooooo01Cooooo0_l0nYX2ooooo`04o`3jV_oo
oooo0?ZJo`3jVP;ooooo00?o0?ZJooooooooool04_ooool00ol0003oooooo`000002ooooo`03o`3j
V_oooooo003o00Cooooo00Go003oooooooooooooooooo`00o`08ooooo`04o`3jV_ooooooooooo`3j
VQGooooo00?o0?ZJo`000?ooool00_l0nYX2ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJo`00
ool0nY[oooooo`000?l0nYX4o`00o`;o0?ZJ00?oooooo`000?l00?l01Oooool2o`0000;ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;ooooo0_l0
000:ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`1iooooo`;o0000;?ooool002gooooo0_l00009ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`09ooooo`?o0?ZJ0_l000000ooooooo0?ZJo`00o`02
o`00o`?ooooo00?o0?ZJooooooooool01_ooool01?l0nY[oooooooooool00003o`00o`03ooooool0
0?oo0?ZJ00;ooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`02o`3jVP;ooooo00?o
0?ZJooooooooool05?ooool2o`3jVP?ooooo0ol0nYX2ooooo`03o`3jV_oooooooooo01;ooooo00?o
0000ooooool000000_ooool00ol0nY[oooooo`00o`04ooooo`05o`00ooooooooooooooooool00?l0
2?ooool01?l0nY[oooooooooool0nYXEooooo`03o`3jV_l0003ooooo00;o0?ZJ0_ooool00ol0nY[o
ooooooooo`04ooooo`06o`3jV_l00?oo0?ZJooooool0003o0?ZJ0_ooool01ol0003oooooo`3jV_l0
003o0?ZJo`000?l00?l01Oooool2o`0000;ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0N_ooool00ol0003ooooo
ooooo`0Zooooo`00;_ooool00ol0003oooooooooo`08ooooo`;o00000_ooool5o`0000Cooooo00?o
0000ooooooooool02_ooool2o`3jVP?o000000Go0?ZJooooool0003o003oo`3jVP02ooooo`03o`3j
V_oooooooooo00Kooooo1Ol00?l2ooooo`;o003o00Co0?ZJoooooooooooo0?ZJ8Oooool02?l0nY[o
ooooooooool0nY[oooooo`3jV_oooooo0?ZJ5oooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oo
oooo0?ZJooooool0nYX05?ooool3o`0000;ooooo00?o0000o`3jV_l00?l00_ooool01?l0003ooooo
o`00ool0nYX2ooooo`03o`00oooooooooooo00Gooooo00Go0?ZJooooooooooooooooo`3jVP0Doooo
o`05o`3jV_l0003o0000ooooool0nYX00oooool00ol0nY[oooooooooo`03ooooo`07o`3jV_l0003o
003oo`3jV_oooooo0000o`3jVP02ooooo`07o`000?l0nY[oooooo`000?oooooo0?ZJo`00o`05oooo
o`;o00000_ooool00ol0003oooooooooo`05ooooo`06o`000?ooooooooooooooool0003ooooo1?l0
0005ooooo`03o`000?oooooooooo00Wooooo00Co0000oooooooooooooooo0_l0001Aooooo`03o`00
0?oooooooooo07[ooooo00?o0000ooooooooool0:_ooool004Kooooo0_l0000<ooooo`05o`3jV_l0
003oooooo`000?l0nYX00_ooool00ol00?oo0?ZJooooo`02o`3jVPSooooo00Go003oooooool0003o
ooooo`3jVP03ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0Oooooo`08o`3jV_ooooooooooo`3j
V_oooooo0?ZJooooool0nYXGooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooool0nYX05?oo
ool3o`0000?ooooo00Co0?ZJo`00ool0nY[ooooo0_l000001Ol00?oo0?ZJoooooooooooo003o00Oo
oooo1Ol00?lDooooo`04o`3jV_l0003o0000ooooo`Go003o1?ooool01ol0nY[oooooo`000?l00?oo
0000o`3jV_ooool00_l0nYX02?oooooo0000o`3jV_oooooo0000ooooool0nY[o003o1?ooool3o`00
00;ooooo00?o0000ooooooooool01Oooool01ol0003ooooooooooooooooo0000ooooool000002?oo
ool00ol0003oooooooooo`09ooooo`04o`000?ooooooooooooooo`;o0000DOooool00ol0003ooooo
ooooo`1jooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo00_ooooo00Go
0?ZJo`000?oooooo0000o`3jVP02ooooo`03o`00ool0nY[ooooo00;o0?ZJ2?ooool01?l00?oo0000
o`000?ooool2o`3jVP;ooooo00Go0?ZJooooool0nY[oooooo`3jVP0Rooooo`03o`3jV_oooooo0?ZJ
00;ooooo0_l0nYXNooooo`03o`3jV_oooooo0?ZJ01Cooooo0ol00003ooooo`04o`000?l00?oo0?ZJ
ooooo`;o000000Go003oo`3jV_ooooooooooo`00o`07ooooo`05o`00ooooooooooooooooool00?l0
5?ooool4o`00o`05o`3jV_ooooooooooooooool00?l01?ooool01ol0nY[oooooo`000?l00?oooooo
o`3jV_ooool00_l0nYX02?oooooo0000o`3jV_oooooo0000ooooool0003o0?ZJ1Oooool01?l0003o
ooooo`000?l00009ooooo`?o00000_ooool5o`0000Cooooo00?o0000ooooooooool02Oooool01?l0
003oooooooooooooool2o`00057ooooo00?o0000ooooooooool0NOooool2o`0002cooooo0016oooo
o`03o`000?oooooooooo00_ooooo00?o0000o`3jV_ooool00_l0nYX2ooooo`05o`00ool0nY[o0?ZJ
ooooool0nYX00_ooool00ol0003o0?ZJooooo`03ooooo`04o`00ool0nY[o0000ooooo`;o0?ZJ0_oo
ool00ol0nY[oooooooooo`02o`3jVR?ooooo0_l0nYX2ooooo`;o0?ZJ7oooool2o`3jVQGooooo0_l0
0003ooooo`08o`000?l00?oo0?ZJooooool0003o0?ZJo`00ool0nYX2ooooo`03o`00oooooooooooo
00Gooooo00Go003oooooooooooooooooo`00o`0Dooooo`05o`00oooooooo0000ooooool0nYX00ooo
ool00ol00?ooooooooooo`02ooooo`06o`3jV_l0003oooooo`00oooooooo00000ol0nYX2ooooo`06
o`3jV_oooooo0000ooooool0003o0?ZJ1Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool00_l0001Booooo`03o`000?oooooooooo07Cooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`0Zooooo`00A_ooool00ol0003oooooooooo`0<oooo
o`07o`3jV_oooooo0?ZJooooool0nY[oooooo`00o`02o`3jVP06ooooool0nY[oooooooooool0003o
0?ZJ1?ooool01?l00?oo0?ZJo`000?ooool2o`3jVP;ooooo00?o0?ZJooooooooool00_l0nYXSoooo
o`;o0?ZJ0oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo01?ooooo0_l00003oooo
o`0;o`000?l00?oo0?ZJooooool0003o0?ZJo`00ool0003o0?ZJooooool00?l01oooool01Ol00?oo
0?ZJoooooooooooo003o00gooooo00?o0000ooooooooool01?ooool01?l00?ooooooooooooooool2
o`3jVP;ooooo00?o003oooooooooool00_ooool01_l0nY[o0000ooooool00?ooooooo`0000;o0?ZJ
00Woooooo`3jV_oooooo0?ZJooooool0003oooooo`000?l0nYX01Oooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00Wooooo00Co0000ooooool0003o0000Doooool00ol0003ooooooooo
o`1dooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0:_ooool004Kooooo0_l0000=
ooooo`08o`000?l0nY[o0?ZJooooool0nY[oooooo`000?l00?l2ooooo`03o`3jV_oooooooooo00;o
0?ZJ0oooool01Ol0nY[o003oo`3jV_l0003ooooo00;o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo
0?ZJ02Cooooo00?o0?ZJooooooooool0>?ooool2o`0000?ooooo00_o0000o`00ool0nY[oooooo`00
0?l0nY[o003oo`000?l0nY[oooooo`00o`07ooooo`05o`00ool0nY[oooooooooool00?l03Oooool0
0ol0003oooooo`3jVP04ooooo`04o`00ool0nY[oooooooooo`;o0?ZJ0_ooool00ol00?oooooooooo
o`02ooooo`0Ao`3jV_l0003oooooo`00oooooooo0000ooooool0nY[oooooo`3jV_oooooo0?ZJoooo
ool0003oooooo`000?l0nYX01?ooool2o`0001[ooooo00?o0000ooooooooool02Oooool01?l0003o
ooooo`000?l0001Cooooo`03o`000?oooooooooo07Cooooo0_l00004ooooo`03o`000?oooooooooo
02[ooooo0016ooooo`03o`000?oooooooooo00kooooo00Ko0?ZJooooool0nY[oooooo`000?l00?l2
ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool01_l0nY[o0000o`00ool0nY[o0000ooooo`;o0?ZJ
0_ooool00ol0nY[oooooooooo`1Rooooo`0?o`000?ooooooooooooooool0003o003oo`3jV_oooooo
0000o`3jV_l00?oo0000ooooool0nY[o003o00Oooooo00Go003oo`3jV_ooooooooooo`00o`0=oooo
o`03o`000?l0nY[o0?ZJ00Cooooo00Co003oo`3jV_oooooooooo0_l0nYX2ooooo`05o`00oooooooo
ooooooooool0nYX00_l000001?oooooo003oooooool00004ooooo`;o0?ZJ00?oooooo`000?l00000
1oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo00Co0000ooooool0003o
0000Doooool01?l0003oooooooooool0001cooooo`;o00000oooool2o`0002cooooo0016ooooo`03
o`000?oooooooooo00kooooo00Oo0?ZJoooooooooooo0?ZJo`000?l00?oo000000;ooooo0_l0nYX0
3ol0003o0?ZJoooooooooooo0?ZJo`000?l00?oo0000o`3jV_oooooo0?ZJooooool0nY[oooooo`3j
VP1Tooooo`0<o`000?ooooooooooooooool0003o0?ZJo`00oooooooo0000o`3jV_l00?oo00000_oo
ool00ol00?ooooooooooo`05ooooo`05o`00ool0003o0?ZJooooool00?l03Oooool00ol0003o0?ZJ
o`3jVP04ooooo`06o`00ool0nY[oooooo`3jV_l0003o0?ZJ0_ooool01?l00?ooooooooooooooool5
o`00o`Kooooo0_l0nYX00ooooooo0000o`000007ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool02_ooool2o`0005Cooooo00Co0000oooooooooooo0000Loooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJ
o`00ool000000_ooool2o`3jVP0;o`000?l0nY[oooooo`3jV_l0003oooooo`00ool0003o0?ZJoooo
ool0nYX00_ooool2o`3jVVCooooo00co0000ooooooooooooooooo`000?l0nY[o003oooooool0003o
0?ZJo`00ool00002ooooo`03o`00oooooooooooo00Gooooo00Go003oo`000?l0nY[oooooo`00o`0=
ooooo`03o`000?l0nY[o0?ZJ00?ooooo00[o0000o`00ool0nY[oooooo`3jV_oooooo0000o`3jV_oo
oooo003o0oooool01Ol00?oo0000oooooooooooo0?ZJ00Oooooo00Co0?ZJoooooooooooo00001ooo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0001Eooooo`?o0000Looo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02[ooooo0016ooooo`;o00004oooool0
0ol0nY[o003oo`00o`02o`00o`;o0?ZJ0_l00002o`3jVP;ooooo00?o003oooooool000000_l0nYX2
ooooo`;o0?ZJI?ooool03?l0003ooooooooooooooooo0000o`3jV_l00?ooooooo`000?l00?oo0?ZJ
o`0000;ooooo00?o003oooooooooool01Oooool01Ol00?oo0000o`3jV_oooooo003o00gooooo00?o
0?ZJo`000?l0nYX00oooool00ol0003o003oooooo`02o`3jVP05ooooool0003o0?ZJooooool00?l0
0oooool01Ol00?oo0000oooooooooooo0?ZJ00[ooooo00?o0000ooooooooool01?ooool2o`0001[o
oooo00?o0000ooooooooool02_ooool2o`0005Gooooo0ol0000;ooooo`04o`000?ooooooooooo`00
06Cooooo00?o0000ooooooooool00_ooool2o`0002cooooo0016ooooo`03o`000?oooooooooo01;o
oooo00Go0000o`3jV_oooooo0000o`00o`02o`3jVP04ooooool0003o0?ZJo`3jVP;ooooo00Go003o
ooooool0003oooooo`3jVP03ooooo`03o`3jV_oooooooooo06;ooooo00co0000oooooooooooooooo
o`000?l0nY[o003oooooool0003o003oo`3jV_l00002ooooo`03o`00oooooooooooo00Gooooo00Go
003oo`000?oooooo0?ZJo`00o`0<ooooo`04o`3jV_oooooo0000o`3jVP?ooooo00?o0000o`00oooo
ool00_l0nYX01Ooooooo0000o`3jV_oooooo003o00?ooooo00Go003oo`3jV_ooooooooooo`3jVP0B
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1F
ooooo`03o`000?oooooooooo00Wooooo00Co0000oooooooooooo0000Hoooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo01;ooooo00Go0000
o`3jV_oooooo0000o`00o`02o`3jVP04ooooool0003o0?ZJo`3jVP;ooooo00?o003oooooool00000
J_ooool03?l0003ooooooooooooooooo0000o`3jV_l00?ooooooo`3jV_l00?oo0?ZJo`0000;ooooo
00?o003oooooooooool01Oooool01Ol00?ooooooo`000?l0nY[o003o00cooooo00Co0?ZJooooool0
003o0?ZJ0oooool02_l0003o003ooooooooooooo0?ZJooooool0003oooooo`3jV_l00?l3ooooo`05
o`00ool0nY[oooooooooool0nYX04_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
06Cooooo00?o0000ooooooooool01oooool2o`0000;ooooo00?o0000ooooooooool0HOooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo01;o
oooo00?o0000o`3jV_ooool00_l000001?l00?ooooooooooool00002o`3jVP;ooooo00?o003ooooo
ooooool0K_ooool2o`000006o`00oooooooo0?ZJo`00ool0nY[o00000_ooool00ol00?oooooooooo
o`05ooooo`05o`00oooooooo0000ooooool00?l03?ooool01?l0nY[oooooo`000?l0nYX3ooooo`07
o`3jV_l00?ooooooooooool0nY[oooooo`000002ooooo`06o`00ooooooooooooooooool00?oo0?ZJ
0_ooool00ol0nY[oooooooooo`0@ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
I?ooool00ol0003oooooooooo`07ooooo`;o00000_ooool00ol0003oooooooooo`1Pooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0:_ooool004Kooooo0_l0000Cooooo`03o`000?l0
nY[ooooo00;o00001?l00?l01Ol0nY[ooooooooooooooooo003o077ooooo00Oo0000o`00ool0nY[o
0000o`00ool0nY[o000000;ooooo00?o003oooooooooool01Oooool01Ol00?ooooooo`000?oooooo
003o00Oooooo00?o0?ZJooooooooool00_ooool01?l0nY[oooooo`000?l0nYX3ooooo`03o`3jV_l0
0?oooooo00?ooooo00Wo0000oooooooooooo003oooooool0003oooooo`00ool0nYX00_ooool00ol0
nY[oooooooooo`0?ooooo`;o00006_ooool00ol0003oooooooooo`1Tooooo`03o`000?oooooooooo
00Kooooo0ol00002ooooo`03o`000?oooooooooo063ooooo00?o0000ooooooooool01?ooool2o`00
02cooooo000cooooo`?o00000oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool04_ooool01_l0003o0?ZJooooool0003oooooo`3jVP;ooooo00?o0000
o`00ool00?l00ol00?maooooo`07o`000?l00?oo0?ZJo`000?l00?ooooooo`000002ooooo`03o`00
oooooooooooo00Gooooo00Go003oooooool0003oooooo`00o`07ooooo`03o`3jV_oooooooooo00;o
oooo00Co003oooooool0003o0?ZJ0oooool00ol0nY[o003oooooo`03ooooo`0<o`000?oooooooooo
o`00oooooooo0000ooooool00?ooooooo`3jV_oooooo0?ZJ4_ooool00ol0003oooooooooo`05oooo
o`;o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`1Toooo
o`03o`000?oooooooooo00Kooooo0ol000000ooooooo0000o`00001Rooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0:_ooool003Cooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo01;ooooo00Ko0000ooooool0nY[o0000ooooool0nYX3
ooooo`05o`3jV_ooooooooooooooool0nYX0LOooool01ol0003o003oo`3jV_oooooo003oooooool0
00000_ooool00ol00?ooooooooooo`04ooooo`06o`000?l00?ooooooo`000?oooooo003o1_ooool2
o`3jVPCooooo1?l00?l3ooooo`03o`3jV_l00?oooooo00?ooooo00Co0000oooooooooooo003o0_l0
00001_oooooo003oooooool0nY[oooooo`3jVQ;ooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool00007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`1T
ooooo`03o`000?oooooooooo00Kooooo0_l000001?oooooo0000o`000?l0001Qooooo`;o00001ooo
ool00ol0003oooooooooo`0Zooooo`00<Oooool5o`0000[ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0Booooo`05o`000?ooooooooooo`3jV_ooool00_l0nYX2ooooo`05o`3jV_oo
ooooooooooooool0nYX0LOooool01ol0003o003oo`3jV_oooooo003oooooool000000_ooool00ol0
0?ooooooooooo`04ooooo`06o`000?l00?ooooooo`000?oooooo003o1Oooool00ol0nY[oooooo`3j
VP04ooooo`04o`00oooooooo0000o`00o`;ooooo00?o0000o`3jV_l00?l01?ooool01?l0003ooooo
ooooool00?l2o`000004ooooool00?ooooooooooo`;o0?ZJ4_ooool00ol0003oooooooooo`04oooo
o`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1T
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00_l000000ooooooo0000ooooo`1O
ooooo`;o00001oooool00ol0003oooooooooo`0Zooooo`00<Oooool01?l0003oooooooooool0000;
ooooo`03o`000?oooooooooo00?ooooo0_l0000Cooooo`03o`000?oooooooooo00;o0?ZJ00Cooooo
o`3jV_oooooooooo0_l0nYX2ooooo`03o`3jV_oooooooooo06oooooo00Oo0000o`00ool0nY[ooooo
o`00oooooooo000000;ooooo00?o003oooooooooool01?ooool01ol0003o003oooooool0003ooooo
o`00ool000001?ooool00ol0nY[oooooo`3jVP04ooooo`04o`00ooooooooooooo`00o`;ooooo00?o
0000o`00ool0nYX01?ooool02?l0003oooooooooool00?oo0000ooooool0003o003o0_ooool2o`3j
VQ3ooooo0ol00006ooooo`04o`000?ooooooooooo`0000Wooooo0_l00005ooooo`;o00000oooool:
o`3jVUSooooo1Ol00004ooooo`03o`000?oooooooooo00;o000000?oooooo`000?ooool0Goooool2
o`0000Kooooo0_l0000/ooooo`00<_ooool00ol0003oooooo`00000<ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool04_ooool01ol0003ooooooooooooooooo0?ZJooooool0nYX00_oo
ool2o`3jVP;ooooo00?o0?ZJooooooooool0Koooool01ol0003o003oo`000?oooooo003oooooool0
00000_ooool00ol00?ooooooooooo`04ooooo`07o`000?l00?ooooooo`000?oooooo003oo`000004
ooooo`03o`3jV_oooooo0?ZJ00Cooooo00Co003ooooooooooooo003o0_ooool00ol0003o003oo`3j
VP04ooooo`08o`000?ooooooooooo`00ool0003oooooo`000?l00?l3ooooo`03o`3jV_oooooooooo
013ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool02_ooool00ol0nY[oooooo`3jVP0<o`3jVTcooooo1?l00004
ooooo`07o`000?ooooooooooooooool0003oooooo`00001Pooooo`;o00001oooool00ol0003ooooo
ooooo`0Zooooo`00<oooool2o`0000Sooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo01Kooooo00Oo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ00;ooooo00?o0?ZJoooo
ooooool0Koooool00ol0003o003oo`00o`02o`00o`;ooooo0_l000000ol00?ooooooooooo`04oooo
o`07o`000?l00?ooooooo`000?oooooo003oo`000002ooooo`;o0?ZJ0_ooool01_l0nY[ooooooooo
oooooooo0000o`00o`;ooooo00Ko003oo`3jV_oooooo0000o`00ool0nYX4ooooo`08o`000?oooooo
ooooo`00ool0003oooooo`000?l00?lFooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooo
oooo00001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool06?ooool7
o`3jVTKooooo1?l00003ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0GOooool2
o`0000Sooooo00?o0000ooooooooool0:_ooool003Cooooo00?o0000ooooooooool01_ooool5o`00
00Cooooo00?o0000ooooooooool06Oooool2o`3jVP05ooooool0nY[oooooooooool0nYX0LOooool0
1Ol0003o0?ZJo`000?oooooo0?ZJ00;ooooo0_l000000ol00?ooooooooooo`04ooooo`08o`000?l0
0?ooooooo`000?oooooo003oo`000?ooool3o`3jVP;ooooo00ko0?ZJooooooooooooooooo`000?l0
0?oo0?ZJooooool00?oo0?ZJooooool0003o003oo`3jVPCooooo00So0000oooooooooooo003oo`00
0?oooooo0000o`00oaKooooo00?o0000ooooooooool01Oooool2o`0000Wooooo0ol00005ooooo`03
o`000?oooooooooo01oooooo0ol0nYY3ooooo`;o000000?oooooo`000?ooool00_ooool00ol0003o
ooooooooo`04ooooo`;o0000:oooool00ol0003oooooooooo`0`ooooo`;o00001oooool2o`0002co
oooo0016ooooo`;o00006_ooool2o`3jVP;ooooo00?o0?ZJooooool0nYX0LOooool01Ol0003o0?ZJ
o`000?oooooo0?ZJ00;ooooo0_l000000ol00?ooooooooooo`04ooooo`09o`000?l00?ooooooo`00
0?oooooo003oo`000?l0nY[o000000;o0?ZJ0_ooool03_l0nY[ooooooooooooooooo0000o`00ool0
nY[oooooo`00ool0nY[oooooo`000?l00?oo0?ZJ1?ooool02?l0003oooooooooool00?oo0000oooo
ool0003o003o5Oooool2o`0001[ooooo00?o0000ooooooooool08_ooool6o`3jVSkooooo00?o0000
ooooool000000oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0:_ooool004Kooooo00?o0000ooooooooool06_ooool01_l0nY[oooooooooool0nY[o
ooooo`3jVW?ooooo00?o0?ZJooooool0nYX00_ooool2o`000003o`00oooooooooooo00Cooooo00_o
0000o`00oooooooo0000ooooool00?oo0000o`3jV_l0003oooooo`3jVP02ooooo`0=o`3jV_oooooo
ooooooooool0003o003oooooool0nY[o003oo`3jV_oooooo0000o`00o`05ooooo`08o`000?oooooo
ooooo`00ool0003oooooo`000?l00?lFooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool09oooool4o`3jVS_ooooo00?o0000ooooool000000oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool09oooool01ol0003ooooooooooooooooo0000
ooooool000000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02[ooooo0016oooo
o`03o`000?oooooooooo01[ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYYcooooo`03o`3jV_oo
oooo0?ZJ00;ooooo0_l000000ol00?ooooooooooo`03ooooo`0;o`000?oooooo003oooooool0003o
ooooo`00ool0003o0?ZJo`000?ooool01?l00?l03?oooooo0000ooooool0003o003oooooool0nY[o
003oo`3jV_oooooo0?ZJo`00o`Gooooo00So0000oooooooooooo003oo`000?oooooo0000o`00oaKo
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0[ooooo`[o0?ZJ<Oooool00ol0003o
ooooo`000003ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:?ooool2o`0002Wo
oooo00?o0000ooooooooool00_l000001Ooooooo0000o`000?oooooo000000Wooooo00?o0000oooo
ooooool0:_ooool004Kooooo00?o0000ooooooooool07_ooool2o`3jVW?ooooo00?o0?ZJooooool0
nYX00_ooool2o`000003o`00oooooooooooo00?ooooo00co0000ooooool00?ooooooo`000?oooooo
003oo`3jV_oooooo0000ooooool00?l2ooooo`06o`00oooooooo0000ooooool0003o003o0_ooool0
1Ol0nY[o003oooooool0nY[o003o00Gooooo00Go0000ooooool0003o003oo`000002ooooo`03o`00
oooooooooooo01Cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0dooooo`Wo0?ZJ
:oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0:?ooool2o`0002So
oooo0ol000001?oooooo0000o`000?ooool2o`000003ooooool0003ooooo00Oooooo0_l0000/oooo
o`00A_ooool2o`00023ooooo00?o0?ZJooooooooool0LOooool00ol0nY[oooooo`3jVP02ooooo`;o
000000?o003oooooooooool00oooool03?l0003o0?ZJo`00oooooooo0000ooooool00?oo0?ZJoooo
ool0003oooooo`00o`;ooooo00Ko003oooooool0003oooooo`000?l00?l2ooooo`05o`3jV_l00?oo
0?ZJo`000?l00?l01Oooool01Ol0003oooooo`000?l00?oo000000;ooooo00?o003oooooooooool0
4oooool2o`0001[ooooo00?o0000ooooooooool0?OoooolGo`3jVQCooooo00Go0000oooooooooooo
ooooo`000007ooooo`03o`000?oooooooooo02?ooooo1?l0nYX00ooooooo0000o`000003ooooo`03
o`000?oooooooooo00Oooooo1Ol0nYXFooooo`?o000000Goooooo`000?l0003o0000ooooo`03o`00
00Wooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0U?ooool2o`3jVP;o
oooo00?o0000ooooool00?l01Oooool00ol0003o0?ZJo`00o`02ooooo`03o`000?l00?oo0?ZJ00;o
000000[oooooo`00ooooooooooooo`00oooooooo0000ooooool0003o003o0_ooool01Ol0nY[o003o
o`3jV_l0003o003o00Gooooo00Go0000ooooool0003o003oo`000002ooooo`03o`00oooooooooooo
01Cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1Dooooo`Co0?ZJ4Oooool01?l0
003oooooo`000?l00008ooooo`03o`000?oooooooooo01Wooooo1Ol0nYX4ooooo`04o`3jV_oooooo
ooooooooo`Co0?ZJ00?oooooo`000?l000002Oooool01Ol0nY[ooooooooooooooooo0?ZJ01Kooooo
00Co0000ooooool0003ooooo0ol0000=ooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`00
0?oooooooooo09Cooooo0_l0nYX2ooooo`03o`000?oooooo003o00Cooooo00Co0000o`3jV_oooooo
003o0_ooool00ol0003o003oooooo`02o`000005o`00ool0nY[oooooooooool00?l00_l000000ooo
oooo0000o`00o`02ooooo`05o`3jV_l00?ooooooo`000?l00?l01Oooool02?l0003oooooo`000?l0
0?oo0000ooooool0nY[o003o5_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo05Oo
oooo7_l0nYX01?l0003oooooo`000?l0000Hooooo`05o`3jV_ooooooooooooooool0nYX00oooool0
0ol0nY[oooooooooo`02ooooo`05o`000?ooooooooooo`3jV_ooool00_l000000ooooooo0?ZJo`3j
VP07o`3jVP?ooooo00Co0?ZJoooooooooooooooo1Ol0nYX8ooooo`Co0?ZJ0_ooool00ol0003ooooo
o`000002o`000003ooooool0003ooooo00cooooo00?o0000ooooooooool0:_ooool004Kooooo00?o
0000ooooooooool0UOooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00Co
0?ZJo`000?oooooo003o0_ooool01ol0003o003oo`00ool00?oo0000o`00ool0nYX00_ooool01_l0
0?oo0000o`000?oooooo0?ZJo`00o`;ooooo00Go0?ZJo`00oooooooo0000o`00o`05ooooo`08o`00
0?oooooo0000o`00ool0003oooooo`3jV_l00?lFooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool0Ioooool2o`3jVP04ooooool0003o0000o`0000Sooooo1?l0nYXDooooo`Go0?ZJ1?oo
ool4o`3jVPCooooo00Wo0000oooooooooooo0000o`3jV_oooooo0000ooooool0nYX02oooool5o`3j
VP?ooooo00?o0?ZJooooooooool01_ooool01?l0nY[oooooooooool0nYX2ooooo`03o`000?oooooo
000000;o00003_ooool2o`0002cooooo0016ooooo`;o0000U_ooool00ol0nY[oooooooooo`02oooo
o`03o`00oooooooooooo00;ooooo00Co0?ZJoooooooooooo003o0_ooool00ol0003o0?ZJooooo`03
o`00o`;o0?ZJ00Ooooooo`00ool0003o0000ooooool0nY[o003o00?ooooo00Co003oo`000?oooooo
003o1Oooool02?l0003oooooo`000?l00?oo0000o`3jV_oooooo003o5Oooool2o`0001[ooooo00?o
0000ooooooooool0Joooool00ol0003oooooooooo`07ooooo`04o`000?oooooo0000o`0000Co0?ZJ
00?o0000ooooooooool01Oooool9o`3jVQ3ooooo00Co0000oooooooooooo00001?l0nYXDooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJo`000?ooool00_ooool00ol0nY[oooooo`000003ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0
V_ooool00ol00?ooooooooooo`02ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o0000o`3jV_oo
ool00_l000001Ooooooo0?ZJo`3jV_oooooo003o00;o000000?oooooo`3jV_l00?l00oooool01?l0
0?oo0000ooooool00?l6ooooo`;o000000Go003oo`3jV_ooooooooooo`00o`0Fooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`07ooooo`04o`000?oo
oooo0000o`0000?ooooo00?o0?ZJo`000?ooool01_ooool00ol0nY[oooooooooo`0Fooooo`03o`00
0?oooooooooo00;o00000_ooool00ol0003oooooooooo`0Booooo`Wo0?ZJ00Co0000oooooooooooo
oooo1?l0nYXBooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo09[ooooo
00Ko003oooooooooooooooooo`000?l0nYX2ooooo`03o`00oooooooooooo00;o000000So0?ZJo`00
0?l0003oooooo`3jV_oooooo0?ZJo`00o`;o000000?oooooo`3jV_l00?l00oooool4o`00o`Kooooo
0_l000001Ol00?oo0?ZJoooooooooooo003o01Kooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`1[ooooo`03o`000?oooooooooo00Oooooo00Co0000ooooool0003o00001?ooool01?l0
nY[o0000ooooooooool5o`3jVP;ooooo0_l0000Dooooo`03o`000?oooooooooo00;o00000_ooool0
1Ol0003ooooooooooooooooo000001Wooooo00?o0000ooooooooool00oooool00ol0003oooooo`3j
VP0=o`3jVP?ooooo0_l0000/ooooo`00A_ooool00ol0003oooooooooo`2Jooooo`03o`00oooooooo
oooo00?o0?ZJ0_ooool00ol00?ooooooooooo`02o`000005o`3jV_l0003oooooo`3jV_l000000_oo
ool01_l00?oo0?ZJo`000?oooooo0?ZJo`00o`?ooooo00Co0?ZJo`000?oooooo0?ZJ1_ooool2o`00
0005o`00ool0nY[oooooooooool00?l05_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo06_ooooo00?o0000ooooooooool01oooool01?l0003oooooo`000?l00004ooooo`Co0?ZJ1ooo
ool3o`00013ooooo00?o0000ooooool000000oooool2o`0000;ooooo00Go0000oooooooooooooooo
o`00000Hooooo`;o00001?ooool2o`0001?ooooo00?o0000ooooooooool0:_ooool004Kooooo0_l0
002Kooooo`03o`00oooooooooooo00;o0?ZJ00Co0000oooooooooooo003o0_ooool2o`000005o`3j
V_l0003oooooo`3jV_l000000_ooool01_l00?oo0?ZJo`000?oooooo003oo`3jVP?ooooo00Co0?ZJ
o`000?oooooo0?ZJ1_ooool2o`000005o`00ool0nY[oooooooooool00?l05Oooool2o`000003oooo
ool0003o000000Cooooo00?o0000ooooooooool00_ooool3o`0000?ooooo0ol00005ooooo`03o`00
0?oooooooooo06_ooooo00?o0000ooooooooool02?ooool3o`0000Cooooo0_l00009ooooo`?o0000
1Oooool00ol0003oooooooooo`08ooooo`?o00001?ooool01?l0003oooooooooool00003ooooo`;o
00005oooool00ol0003oooooo`000003ooooo`;o00004oooool00ol0003oooooooooo`0Zooooo`00
;Oooool3o`0000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`?o0000
1Oooool00ol0003oooooooooo`2Jooooo`04o`00oooooooo0?ZJooooo`Go003o0_ooool2o`000005
ooooool0nY[oooooo`3jV_l000000_ooool01_l00?oo0?ZJooooool0003o003oo`3jVP?ooooo00Co
0?ZJoooooooooooo0?ZJ1_ooool2o`000005o`00ool0nY[oooooooooool00?l05_ooool2o`0000;o
oooo00?o0000ooooooooool01Oooool01ol0003ooooooooooooooooo0000ooooool000000oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo07Kooooo0_l000001ooooooo0000oooooooo
oooo0000ooooool000002Oooool3o`0000Cooooo0_l00007ooooo`06o`000?ooooooooooo`000?oo
oooo00001oooool01?l0003oooooooooooooool2o`0001Oooooo00?o0000ooooool000000_ooool0
0ol0003oooooo`00000Cooooo`03o`000?oooooooooo02[ooooo000^ooooo`03o`000?oooooooooo
00Sooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0V_ooool01Ol00?ooooooo`3jV_oooooo003o00?ooooo00?o0?ZJooooooooool00_l0
00003Ooooooo0?ZJooooool0nY[oooooo`000?oooooo003oo`3jV_oooooo0000o`00ool0nYX00ooo
ool01?l0nY[oooooooooool0nYX6ooooo`03o`000?oooooo003o00?ooooo00?o003oooooooooool0
5?ooool2o`0000;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo0_l0001jooooo`06o`000?ooooooooooo`000?oooooo00002Oooool3o`00
00;ooooo00?o0000ooooool000000_l00006ooooo`04o`000?ooooooooooo`0000Wooooo00Co0000
oooooooooooooooo0_l0000Gooooo`04o`000?oooooo0000ooooo`;o000000?oooooo`000?ooool0
4Oooool2o`0002cooooo000[ooooo`Go00002_ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0V_ooool01Ol00?oo0?ZJoooooooooooo003o00?ooooo
00?o0?ZJooooooooool00_l000003Ooooooo0?ZJooooool0nY[oooooo`000?oooooo003oo`3jV_oo
oooo0000o`00ool0nYX00oooool01?l0nY[oooooooooool0nYX6ooooo`03o`000?oooooo003o00Co
003o5_ooool2o`0000;ooooo00?o0000ooooooooool01oooool2o`0000Kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1iooooo`06o`000?ooooooooooo`000?oooooo00002Oooool0
1ol0003oooooooooool0003oooooo`000?ooool00ol00006ooooo`04o`000?ooooooooooo`0000Wo
oooo00Co0000oooooooooooooooo0_l0000Fooooo`05o`000?ooooooooooo`000?ooool00_l0000E
ooooo`03o`000?oooooooooo02[ooooo000[ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`02ooooo`;o0000Voooool01_l00?oo0?ZJo`000?oo
oooo003oo`3jVP;ooooo00Co0?ZJoooooooooooo00000oooool2o`3jVP08ooooool0003oooooo`3j
V_l00?ooooooo`000?l00?l5ooooo`03o`3jV_oooooo0?ZJ00Kooooo00?o0000ooooool0nYX00ooo
ool00ol0nY[oooooooooo`0Booooo`Co00000_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooo000000?o00001Oooool00ol0003oooooooooo`1iooooo`06o`000?ooooooooooo`000?oooooo
00001_ooool01?l0003oooooooooool00002ooooo`?o000000Coooooo`000?l0003o00001_ooool0
0ol0003oooooo`00000;ooooo`03o`000?oooooooooo00;o00005_ooool01?l0003ooooooooooooo
ool2o`0001Kooooo00?o0000ooooooooool0:_ooool002cooooo00?o0000ooooool000003?ooool0
0ol0003oooooo`000003o`0000Gooooo00?o0000ooooooooool0V_ooool01_l00?oo0?ZJo`000?oo
oooo003oo`3jVP;ooooo00Co0?ZJoooooooooooo00000oooool2o`3jVP05ooooool0003oooooo`3j
V_l00?l00_ooool00ol00?ooooooooooo`04ooooo`;o0?ZJ1_ooool00ol0003oooooo`3jVP03oooo
o`03o`3jV_oooooooooo01Cooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo00Oo0000oooo
ooooooooooooo`000?oooooo000000Sooooo00?o0000ooooooooool0NOooool01_l0003ooooooooo
ool0003oooooo`0000Kooooo00?o0000ooooool000000oooool5o`000003ooooool0003o000000Co
oooo00Co0000ooooool0003o00002oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo
01?ooooo00Co0000oooooooooooooooo0_l0000Fooooo`03o`000?oooooooooo02[ooooo000]oooo
o`;o00002?ooool01ol0003ooooooooooooooooo0000ooooool000002?ooool00ol0003ooooooooo
o`2Jooooo`06o`00ool0nY[o0000ooooool00?oo0?ZJ0_ooool01?l0nY[oooooooooool00004oooo
o`06o`3jV_oooooo0000ooooool0nY[o003o0_ooool00ol00?ooooooooooo`04ooooo`;o0?ZJ1_oo
ool01?l0003oooooooooool0nYX2ooooo`03o`3jV_oooooooooo01Cooooo00Co0000ooooool0003o
00002Oooool3o`0000;ooooo1Ol00004ooooo`03o`000?oooooooooo07Wooooo00Ko0000oooooooo
oooo0000ooooool00006ooooo`03o`000?oooooo000000Cooooo1?l000000ooooooo0000o`000003
ooooo`;o000000?oooooo`000?l000002oooool00ol0003oooooo`000002ooooo`03o`000?oooooo
oooo01?ooooo00Co0000oooooooooooooooo0_l0000Eooooo`;o0000;?ooool002kooooo00?o0000
ooooooooool01_ooool5o`000003ooooool0003o000000?o00001?ooool00ol0003oooooooooo`2J
ooooo`06o`00ool0003oooooo`000?l00?oo0?ZJ0_ooool00ol0nY[oooooooooo`07ooooo`04o`00
0?oooooo0?ZJo`00o`;ooooo00?o003oooooooooool01Oooool00ol0nY[oooooooooo`04ooooo`04
o`000?ooooooooooo`3jVP;ooooo00?o0?ZJooooooooool05?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo07Wooooo00Ko0000oooooooooooo0000ooooool00006ooooo`03o`000?oo
oooo000000Cooooo0ol00002ooooo`;o00000_ooool3o`000003ooooool0003o000000_ooooo00?o
0000ooooool000000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00;ooooo0_l0
000Fooooo`03o`000?oooooooooo02[ooooo0016ooooo`;o0000Voooool5o`00o`04ooooool0nY[o
ooooo`3jVPWooooo00Co0000ooooool0nY[o003o0_ooool00ol00?ooooooooooo`05ooooo`03o`3j
V_oooooooooo00Cooooo00Co0000oooooooooooo0?ZJ0_ooool00ol0nY[oooooooooo`0Cooooo`;o
00006_ooool00ol0003oooooooooo`1iooooo`06o`000?ooooooooooo`000?oooooo00001Oooool4
o`0000Kooooo00Go0000ooooooooooooooooo`000002ooooo`;o00000_ooool2o`0000cooooo0_l0
0002ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Dooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooooooo09[ooooo00Go0?ZJ
o`000?oooooo0000o`3jVP02ooooo`;o0?ZJ2Oooool01ol0003oooooooooool00?ooooooo`3jV_l0
0?l04Oooool01?l0nY[oooooooooool0nYXFooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool0NOooool01_l0003oooooooooool0003oooooo`0000Gooooo1?l0000;ooooo`04o`000?oo
oooo0000o`0000;ooooo0_l0000<ooooo`;o00000_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01Wooooo0_l0000/ooooo`00A_ooool00ol0003oooooooooo`2Jooooo`05o`3jV_l0
003oooooooooool0nYX00_ooool2o`3jVPWooooo00Oo0000oooooooooooo003oo`3jV_oooooo003o
01;ooooo00?o0?ZJooooool0nYX05_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
07[ooooo0_l00003ooooo`03o`000?oooooooooo00;ooooo00Co0000ooooool0003o00002oooool0
1?l0003oooooo`000?l00003ooooo`03o`000?oooooooooo00[ooooo0_l00002ooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Zooooo`00A_ooool0
0ol0003oooooooooo`2Kooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJooooooooool01ooo
ool01ol0003oooooooooool00?oo0?ZJooooool00?l04oooool2o`3jVQKooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`1kooooo`05o`000?ooooooooooooooool000001?ooool00ol0
003oooooo`00000<ooooo`;o00001Oooool00ol0003oooooooooo`0:ooooo`07o`000?oooooooooo
ooooool0003oooooo`00000Booooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0:_oo
ool004Kooooo0_l0002Looooo`04o`3jV_ooooooooooo`3jVPgooooo00Co0000oooooooooooo003o
0_ooool00ol00?ooooooooooo`0Aooooo`;o0?ZJ5Oooool2o`0001[ooooo00?o0000ooooooooool0
Noooool01?l0003oooooooooooooool2o`0000;ooooo00Co0000oooooooooooo00003?ooool2o`00
00Gooooo00?o0000ooooooooool02_ooool01ol0003ooooooooooooooooo0000ooooool000004Ooo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo02[ooooo0016ooooo`03o`000?oooooo
oooo09_ooooo00Co0?ZJoooooooooooo0?ZJ3Oooool01?l0003oooooooooool00?l2ooooo`03o`00
oooooooooooo01;ooooo00?o0?ZJooooooooool05?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo07oooooo0ol000001Ooooooo0000oooooooooooo000000cooooo0_l0000Fooooo`?o
00004Oooool00ol0003oooooooooo`0Jooooo`;o0000;?ooool004Kooooo00?o0000ooooooooool0
Voooool01?l0nY[oooooooooool0nYX=ooooo`04o`000?ooooooooooo`00o`;ooooo00?o003ooooo
ooooool0:Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo07oooooo0ol000000ooo
oooo0000ooooo`0>ooooo`;o00005_ooool3o`0000;ooooo0_l0000=ooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0W?ooool00ol0nY[o
ooooo`3jVP0=ooooo`04o`000?oooooo0000o`00o`;ooooo00?o003oooooooooool0:Oooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo07oooooo00?o0000ooooooooool00_l0000?oooo
o`;o00005_ooool2o`000005ooooool0003o0000ooooool000003Oooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo02[ooooo0016ooooo`;o0000W_ooool2o`3jVPkooooo00?o0000oooo
ool00?l00ol00?lZooooo`;o00006_ooool00ol0003oooooooooo`22ooooo`;o00004?ooool00ol0
003oooooooooo`0Dooooo`;o000000Goooooo`000?l0003oooooo`00000=ooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000ooooooooool0WOooool2o`3j
VQ3ooooo00Co0?ZJoooooooooooo003o:oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo08;ooooo0_l0000Wooooo`;o000000Ooooooo`000?l0003oooooo`000?oooooo000000Wooooo
00?o0000ooooool000007?ooool2o`0002cooooo0016ooooo`03o`000?oooooooooo09kooooo00?o
0?ZJooooooooool03_ooool01?l0nY[oooooooooool0nYX[ooooo`03o`000?oooooooooo00Gooooo
0_l00004ooooo`03o`000?oooooooooo00?ooooo0ol00004ooooo`03o`000?oooooooooo08;ooooo
00?o0000ooooooooool09_ooool2o`000007ooooool0003oooooooooool0003oooooo`000009oooo
o`03o`000?oooooo000001gooooo00?o0000ooooooooool0:_ooool004Kooooo00?o0000oooooooo
ool0[oooool01?l0nY[oooooooooool0nYX[ooooo`03o`000?oooooooooo00Cooooo00Co0000oooo
oooooooo00002_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo08;ooooo00?o0000
ooooooooool09oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000;o00001oooool0
0ol0003oooooo`00000Mooooo`03o`000?oooooooooo02[ooooo0016ooooo`;o0000/?ooool01?l0
nY[oooooooooool0nYXZooooo`;o00001_ooool01?l0003oooooooooool00007ooooo`Go00001?oo
ool2o`000:gooooo00?o0000ooooooooool00_ooool5o`0000?ooooo00Co0000oooooooooooooooo
0ol0000Looooo`;o0000;?ooool004Kooooo00?o0000ooooooooool0[oooool01?l0nY[ooooooooo
ool0nYX[ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool01?l0003o
ooooooooool00005ooooo`03o`000?oooooooooo0;7ooooo1_l000000ooooooo0000o`000003oooo
o`;o00007_ooool00ol0003oooooooooo`0Zooooo`00<oooool3o`0000?ooooo00?o0000oooooooo
ool00_ooool3o`0000Gooooo00?o0000ooooooooool0/?ooool00ol0nY[oooooo`3jVP0[ooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002?ooool00ol0003oooooo`000005oooo
o`03o`000?oooooooooo0;;ooooo0_l000000ooooooo0000o`000004o`0000;ooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`0Zooooo`00=?ooool00ol0003oooooooooo`06ooooo`05
o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`2`ooooo`03o`3jV_oooooo0?ZJ
02_ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00009ooooo`;o00001Oooool0
0ol0003oooooooooo`2cooooo`04o`000?ooooooooooo`0000;ooooo0_l00002ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0:_ooool0037ooooo1Ol00007ooooo`05o`000?oooooo
ooooooooool000001?ooool2o`000;;ooooo0_l0nYXYooooo`?o00001oooool2o`0000_ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`2cooooo`03o`000?oooooooooo00?ooooo0_l0
0002ooooo`03o`000?oooooooooo01cooooo0_l0000/ooooo`00<Oooool01?l0003oooooooooool0
0009ooooo`?o00001Oooool00ol0003oooooooooo`2booooo`03o`3jV_oooooooooo02Wooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`2kooooo`03o`000?oooooo000001oooooo00?o
0000ooooooooool0:_ooool003;ooooo00?o0000ooooool000002?ooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0000ooooooooool0/_ooool00ol0nY[oooooooooo`0Yooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool0^oooool2o`00023ooooo00?o0000ooooooooool0:_oo
ool003?ooooo0_l00008ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`3Nooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0gOooool00ol0003ooooooooo
o`0Zooooo`00=?ooool00ol0003oooooooooo`07ooooo`?o00001Oooool2o`0000?ooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0;ooooo`;o00006_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool02_ooool2o`0002cooooo0016oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool0000J
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooo`00000/
ooooo`00A_oooooRo`0001[ooooohOl0000/ooooo`00oooooooooooooe7ooooo003ooooooooooooo
DOooool00?oooooooooooomAooooo`00oooooooooooooe7ooooo003oooooooooooooDOooool00?oo
oooooooooomAooooo`00oooooooooooooe7ooooo003oooooooooooooDOooool00?oooooooooooomA
ooooo`00oooooooooooooe7ooooo003oooooooooooooDOooool00?oooooooooooomAooooo`00oooo
oooooooooe7ooooo003oooooobCooooo00?o0000ooooooooool0oooooolZooooo`00oooooolUoooo
o`03o`000?oooooooooo0?oooooo:Oooool00?oooooo4Oooool3o`0000;ooooo0ol000000ooooooo
0000o`000003o`0000Kooooo00?o0000ooooooooool01_ooool01Ol0003oooooo`000?oooooo0000
00;ooooo1?l00002ooooo`?o0000oooooolCooooo`00ooooool@ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00kooooo00Go0000
ooooool0003oooooo`000007ooooo`05o`000?ooooooooooooooool00000oooooolBooooo`00oooo
ool@ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00kooooo00Go0000ooooool0003oooooo`000002ooooo`Co00001Oooool00ol0
003oooooooooo`3ooooooa3ooooo003ooooooa3ooooo00?o0000ooooool000000ol000000ooooooo
0000o`000002o`0000;ooooo0ol0000>ooooo`05o`000?oooooo0000ooooool000002Oooool2o`00
0?oooooo4oooool00?oooooo4?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool03_ooool2o`000003ooooool0003ooooo00_ooooo00?o0000oooo
ooooool0ooooool@ooooo`00ooooool@ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Wooooo00Go0000oooooooooooooooo
o`00003ooooooa;ooooo003ooooooa7ooooo0ol00002ooooo`?o000000?oooooo`000?l000001Ol0
000Jooooo`?o0000oooooolCooooo`00oooooooooooooe7ooooo003oooooooooooooDOooool00001
\
\>"],
  ImageRangeCache->{{{0, 590.562}, {181.812, 0}} -> {-0.174081, -0.0154542, \
0.00397615, 0.00397615}, {{43.75, 295.25}, {177.875, 22.4375}} -> {-129.542, \
4.42369, 1.70663, 0.0024863}, {{295.25, 546.75}, {177.875, 22.4375}} -> \
{-558.759, -0.00364602, 1.70663, 0.00273369}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "GGHF/K=6, M=20/",
  StyleBox[" code not yet released",
    FontColor->RGBColor[1, 0, 0]]
}], "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(<< Momente.m\)], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(SetDirectory::"cdir"\), \(\(:\)\(\ \)\), "\<\"Cannot set \
current directory to \\!\\(\\\"/Mathematica 2.2.2/Packages/Hermann/\\\"\\). \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"SetDirectory::cdir\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \\!\\(text\\) is \
Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Part::"pspec"\), \(\(:\)\(\ \)\), "\<\"Part specification \
\\!\\(x\\) is neither an integer nor a list of integers. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::pspec\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Part::"pspec"\), \(\(:\)\(\ \)\), "\<\"Part specification \
\\!\\(x\\) is neither an integer nor a list of integers. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::pspec\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(Part::"pspec"\), \(\(:\)\(\ \)\), "\<\"Part specification \
\\!\\(ii$75348[1]\\) is neither an integer nor a list of integers. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::pspec\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Part :: \\\"pspec\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(SetDirectory::"cdir"\), \(\(:\)\(\ \)\), "\<\"Cannot set \
current directory to \\!\\(\\\"/Mathematica 2.2.2/Packages/Hermann/\\\"\\). \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"SetDirectory::cdir\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity,
  FontSize->14]
}, Open  ]],

Cell[BoxData[
    \(\(\(literature\)\(:\)\(\ \)\)\)], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell[CellGroupData[{

Cell["m0=GaussMomenteMulti[M0,S0,8]", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({{4, 0.2`}, {1.`, 0.`, 0.01`}, {0, 0, 0, 0}, {3.`, 0.`, 0.01`, 0.`, 
        0.0003`}, {0, 0, 0, 0, 0, 0}, {15.`, 0.`, 0.03`, 0.`, 0.0003`, 0.`, 
        0.000014999999999999999`}, {0, 0, 0, 0, 0, 0, 0, 0}, {105.`, 0.`, 
        0.15`, 0.`, 0.0009`, 0.`, 0.000014999999999999999`, 0.`, 
        1.05`*^-6}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(logZM // First\)], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \({4.605302377018504`}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\($EPS = \(-10. ^\(-1\)\);\)\), "\[IndentingNewLine]", 
    \(\($SHIFT = \ \(-10. ^\(-4\)\);\)\), "\[IndentingNewLine]", 
    \(\(TRAFO = 1;\)\)}], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell[CellGroupData[{

Cell[TextData[{
  "{M,lik}=GGHFMulti[Map[Take[#,366]&,{logZM,X}],{0.07, -1., .2, .2},\n       \
              \t{{drift,Omega},{h,R},",
  StyleBox["m0",
    FontColor->RGBColor[1, 0, 0]],
  ",dt},\n                     \t\
{K=4,miss,option=2,{TimeUpNonlinearPSDMulti,MessupHermite6Multi},\n           \
              m=9,eps=10^-16,ksigma=6}];//Timing\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({1, 8, 15, 22, 29, 36, 43, 50, 57, 64, 71, 78, 85, 92, 99, 106, 113, 
      120, 127, 134, 141, 148, 155, 162, 169, 176, 183, 190, 197, 204, 211, 
      218, 225, 232, 239, 246, 253, 260, 267, 274, 281, 288, 295, 302, 309, 
      316, 323, 330, 337, 344, 351, 358, 365}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.9999999999999842`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.9944682478000303`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0867393545632398`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.20487814172198`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.8749983885111103`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.2078466192526365`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.2614882420413849`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.5564656007104699`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.1373319709288134`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0982558339445805`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.8224846146206691`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.159696597974587`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.184276848045689`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.223063730376201`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0887612099619706`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.2834691487302672`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.884279115476645`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.297219833038744`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.5542769658723442`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.2795771435749792`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.8947806249483153`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.1533407495424135`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.1457861908866536`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0526376368441366`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.2482596157635202`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.5149146331266162`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.192950371661334`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.206044790787424`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.5456877438830592`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.926121089387607`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.049568435571323`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0206698988807374`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.9484097054584603`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0882017085214784`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0738207078518245`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.6428515219257728`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.8840795144334264`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.785091529419455`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0936146232954869`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.8502733753196794`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.9411557328803825`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.1096442296493019`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.9263524072889044`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.7927248727460315`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0477187178912337`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.8691954113577067`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.1357625013401342`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.7523233147720252`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(0.8836878252932648`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.0910596362903022`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.1689638741330397`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.160059269689377`\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermite6Multi TRAFO="\[InvisibleSpace]1\
\[InvisibleSpace]" eps="\[InvisibleSpace]\(-0.0001`\)\),
      SequenceForm[ "MessupHermite6Multi TRAFO=", 1, " eps=", -0.0001],
      Editable->False]], "Print"],

Cell[BoxData[
    \(1.1345439997623594`\)], "Print"],

Cell[BoxData[
    \({18.272751000000426`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
YF=M[[All,1]];
PF=M[[All,2]];
s=Map[Part[#,{1,3}]&,PF]//Sqrt;
KI=YF~ii~(YF+s)~ii~(YF-s);

gGHF3=
DisplayTogetherArray[
plot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}  \
]//AddTimeAxis,color->{10,1,2,2},permute->{1,4,3,2}],
plot1[    Column[Y,{2}] \
~ii~Column[KI,{1,3,5}+1]//AddTimeAxis,color->{10,1,2,2}]
,PlotLabel->\"GGHF \
{K,m,eps,ksigma}=\"<>ToString[{K,m,eps//FortranForm,ksigma}]];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -167.062 0 ]
[.5 .32152 167.062 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -228.062 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GGHF) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
93.000 13.000 moveto
(8) show
99.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(K) show
105.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
111.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
117.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
123.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(eps) show
141.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
147.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ksigma) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
183.125 13.000 moveto
(<) show
189.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
195.125 13.000 moveto
(8) show
201.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
207.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
219.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
225.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
243.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.0005328959210584741) show
369.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
381.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
387.125 13.000 moveto
(<) show
393.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -6.78623 1.52687 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .08471 -18 -4.5 ]
[-0.0125 .08471 0 4.5 ]
[-0.0125 .23739 -18 -4.5 ]
[-0.0125 .23739 0 4.5 ]
[-0.0125 .39008 -18 -4.5 ]
[-0.0125 .39008 0 4.5 ]
[-0.0125 .54277 -18 -4.5 ]
[-0.0125 .54277 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .32272 -5 -6 ]
[.97619 .32272 5 6 ]
[.97619 .30472 -5 -6 ]
[.97619 .30472 5 6 ]
[.97619 .35514 -5 -6 ]
[.97619 .35514 5 6 ]
[.97619 .32993 -5 -6 ]
[.97619 .32993 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .08471 m
.00625 .08471 L
s
[(4.5)] -0.0125 .08471 1 0 Mshowa
0 .23739 m
.00625 .23739 L
s
[(4.6)] -0.0125 .23739 1 0 Mshowa
0 .39008 m
.00625 .39008 L
s
[(4.7)] -0.0125 .39008 1 0 Mshowa
0 .54277 m
.00625 .54277 L
s
[(4.8)] -0.0125 .54277 1 0 Mshowa
.125 Mabswid
0 .11524 m
.00375 .11524 L
s
0 .14578 m
.00375 .14578 L
s
0 .17632 m
.00375 .17632 L
s
0 .20686 m
.00375 .20686 L
s
0 .26793 m
.00375 .26793 L
s
0 .29847 m
.00375 .29847 L
s
0 .32901 m
.00375 .32901 L
s
0 .35954 m
.00375 .35954 L
s
0 .42062 m
.00375 .42062 L
s
0 .45116 m
.00375 .45116 L
s
0 .48169 m
.00375 .48169 L
s
0 .51223 m
.00375 .51223 L
s
0 .05417 m
.00375 .05417 L
s
0 .02363 m
.00375 .02363 L
s
0 .57331 m
.00375 .57331 L
s
0 .60384 m
.00375 .60384 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .08471 m
1 .08471 L
s
.99375 .23739 m
1 .23739 L
s
.99375 .39008 m
1 .39008 L
s
.99375 .54277 m
1 .54277 L
s
.125 Mabswid
.99625 .11524 m
1 .11524 L
s
.99625 .14578 m
1 .14578 L
s
.99625 .17632 m
1 .17632 L
s
.99625 .20686 m
1 .20686 L
s
.99625 .26793 m
1 .26793 L
s
.99625 .29847 m
1 .29847 L
s
.99625 .32901 m
1 .32901 L
s
.99625 .35954 m
1 .35954 L
s
.99625 .42062 m
1 .42062 L
s
.99625 .45116 m
1 .45116 L
s
.99625 .48169 m
1 .48169 L
s
.99625 .51223 m
1 .51223 L
s
.99625 .05417 m
1 .05417 L
s
.99625 .02363 m
1 .02363 L
s
.99625 .57331 m
1 .57331 L
s
.99625 .60384 m
1 .60384 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .32272 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .24529 m
.02642 .25167 L
.02903 .25306 L
.03164 .23047 L
.03425 .24534 L
.03686 .23977 L
.03947 .25924 L
.04207 .28536 L
.04468 .29073 L
.04729 .31288 L
.0499 .282 L
.05251 .29354 L
.05512 .27291 L
.05773 .29144 L
.06034 .31333 L
.06295 .33124 L
.06556 .34625 L
.06817 .33323 L
.07078 .30721 L
.07339 .34742 L
.07599 .33181 L
.0786 .32024 L
.08121 .29922 L
.08382 .30597 L
.08643 .32269 L
.08904 .31766 L
.09165 .33362 L
.09426 .39419 L
.09687 .35991 L
.09948 .35011 L
.10209 .35132 L
.1047 .37312 L
.10731 .38552 L
.10992 .36721 L
.11252 .36412 L
.11513 .37467 L
.11774 .35633 L
.12035 .36206 L
.12296 .35891 L
.12557 .33693 L
.12818 .35323 L
.13079 .37819 L
.1334 .38011 L
.13601 .35478 L
.13862 .36174 L
.14123 .34963 L
.14384 .35692 L
.14644 .35421 L
.14905 .33812 L
.15166 .32476 L
Mistroke
.15427 .3327 L
.15688 .34511 L
.15949 .36726 L
.1621 .3356 L
.16471 .31038 L
.16732 .31719 L
.16993 .32374 L
.17254 .31694 L
.17515 .3071 L
.17776 .32084 L
.18037 .30281 L
.18297 .30097 L
.18558 .3084 L
.18819 .30396 L
.1908 .30511 L
.19341 .30833 L
.19602 .29393 L
.19863 .28826 L
.20124 .24085 L
.20385 .24359 L
.20646 .25189 L
.20907 .24796 L
.21168 .24436 L
.21429 .25857 L
.21689 .26196 L
.2195 .26468 L
.22211 .23863 L
.22472 .25885 L
.22733 .28415 L
.22994 .28022 L
.23255 .29002 L
.23516 .29159 L
.23777 .25077 L
.24038 .25671 L
.24299 .25684 L
.2456 .26509 L
.24821 .25866 L
.25082 .26005 L
.25342 .26692 L
.25603 .26027 L
.25864 .25799 L
.26125 .26137 L
.26386 .25579 L
.26647 .25396 L
.26908 .25924 L
.27169 .26711 L
.2743 .27158 L
.27691 .26441 L
.27952 .24214 L
.28213 .25546 L
Mistroke
.28474 .26279 L
.28735 .2409 L
.28995 .22285 L
.29256 .23605 L
.29517 .221 L
.29778 .24182 L
.30039 .20608 L
.303 .21156 L
.30561 .22339 L
.30822 .22865 L
.31083 .25302 L
.31344 .27023 L
.31605 .26889 L
.31866 .26257 L
.32127 .27927 L
.32387 .27245 L
.32648 .3118 L
.32909 .30463 L
.3317 .27516 L
.33431 .27262 L
.33692 .30749 L
.33953 .30516 L
.34214 .28692 L
.34475 .28472 L
.34736 .29272 L
.34997 .31057 L
.35258 .30522 L
.35519 .29616 L
.3578 .29357 L
.3604 .29239 L
.36301 .28954 L
.36562 .27594 L
.36823 .2976 L
.37084 .3017 L
.37345 .29965 L
.37606 .27049 L
.37867 .27115 L
.38128 .25092 L
.38389 .26733 L
.3865 .24893 L
.38911 .24486 L
.39172 .25385 L
.39432 .26774 L
.39693 .24473 L
.39954 .25171 L
.40215 .26353 L
.40476 .27017 L
.40737 .24368 L
.40998 .22575 L
.41259 .23655 L
Mistroke
.4152 .22303 L
.41781 .24121 L
.42042 .2493 L
.42303 .2466 L
.42564 .2606 L
.42825 .24536 L
.43085 .24799 L
.43346 .25782 L
.43607 .25279 L
.43868 .2679 L
.44129 .26748 L
.4439 .23694 L
.44651 .21661 L
.44912 .22734 L
.45173 .27344 L
.45434 .25565 L
.45695 .25621 L
.45956 .22693 L
.46217 .24094 L
.46477 .24178 L
.46738 .25074 L
.46999 .22167 L
.4726 .24666 L
.47521 .2547 L
.47782 .27391 L
.48043 .29098 L
.48304 .24753 L
.48565 .25315 L
.48826 .23178 L
.49087 .27879 L
.49348 .28488 L
.49609 .27447 L
.4987 .28736 L
.5013 .28152 L
.50391 .29107 L
.50652 .26286 L
.50913 .26552 L
.51174 .28922 L
.51435 .25259 L
.51696 .2997 L
.51957 .28041 L
.52218 .2596 L
.52479 .23064 L
.5274 .25054 L
.53001 .26471 L
.53262 .26712 L
.53523 .24813 L
.53783 .21737 L
.54044 .16421 L
.54305 .18931 L
Mistroke
.54566 .20233 L
.54827 .20705 L
.55088 .18524 L
.55349 .2049 L
.5561 .23828 L
.55871 .20307 L
.56132 .19731 L
.56393 .17164 L
.56654 .10544 L
.56915 .06952 L
.57175 .08996 L
.57436 .12673 L
.57697 .12251 L
.57958 .12856 L
.58219 .11991 L
.5848 .1186 L
.58741 .12121 L
.59002 .14682 L
.59263 .14912 L
.59524 .14828 L
.59785 .14773 L
.60046 .16192 L
.60307 .15664 L
.60568 .15784 L
.60828 .21869 L
.61089 .24288 L
.6135 .20795 L
.61611 .22146 L
.61872 .21406 L
.62133 .22164 L
.62394 .24122 L
.62655 .25628 L
.62916 .33211 L
.63177 .3255 L
.63438 .36823 L
.63699 .33111 L
.6396 .29466 L
.6422 .2841 L
.64481 .29697 L
.64742 .29874 L
.65003 .31582 L
.65264 .33792 L
.65525 .37059 L
.65786 .36668 L
.66047 .40738 L
.66308 .39864 L
.66569 .39407 L
.6683 .40638 L
.67091 .35112 L
.67352 .32466 L
Mistroke
.67613 .3312 L
.67873 .34675 L
.68134 .31307 L
.68395 .36603 L
.68656 .37747 L
.68917 .41749 L
.69178 .42724 L
.69439 .39712 L
.697 .44812 L
.69961 .4819 L
.70222 .48843 L
.70483 .46488 L
.70744 .46561 L
.71005 .48447 L
.71265 .48478 L
.71526 .47133 L
.71787 .45515 L
.72048 .42887 L
.72309 .44987 L
.7257 .41406 L
.72831 .40804 L
.73092 .38617 L
.73353 .3744 L
.73614 .33009 L
.73875 .34578 L
.74136 .38474 L
.74397 .4072 L
.74658 .43801 L
.74918 .47252 L
.75179 .4561 L
.7544 .4341 L
.75701 .39087 L
.75962 .45369 L
.76223 .44696 L
.76484 .44048 L
.76745 .40776 L
.77006 .40251 L
.77267 .41362 L
.77528 .44608 L
.77789 .46286 L
.7805 .50569 L
.78311 .51249 L
.78571 .50689 L
.78832 .50818 L
.79093 .51343 L
.79354 .43606 L
.79615 .41523 L
.79876 .4434 L
.80137 .45949 L
.80398 .47426 L
Mistroke
.80659 .40957 L
.8092 .3812 L
.81181 .38018 L
.81442 .34298 L
.81703 .35817 L
.81963 .35594 L
.82224 .42229 L
.82485 .40008 L
.82746 .44378 L
.83007 .42726 L
.83268 .45304 L
.83529 .41634 L
.8379 .39629 L
.84051 .37532 L
.84312 .38019 L
.84573 .33171 L
.84834 .33197 L
.85095 .27693 L
.85356 .29258 L
.85616 .33747 L
.85877 .29444 L
.86138 .28699 L
.86399 .3298 L
.8666 .3761 L
.86921 .4173 L
.87182 .45776 L
.87443 .48169 L
.87704 .42823 L
.87965 .40089 L
.88226 .46304 L
.88487 .42572 L
.88748 .38862 L
.89008 .37514 L
.89269 .3991 L
.8953 .41427 L
.89791 .38656 L
.90052 .35298 L
.90313 .36014 L
.90574 .33996 L
.90835 .34719 L
.91096 .32059 L
.91357 .32456 L
.91618 .33165 L
.91879 .30551 L
.9214 .32889 L
.92401 .33387 L
.92661 .34814 L
.92922 .30664 L
.93183 .29531 L
.93444 .31411 L
Mistroke
.93705 .31656 L
.93966 .29839 L
.94227 .29451 L
.94488 .28676 L
.94749 .33208 L
.9501 .26626 L
.95271 .29346 L
.95532 .28982 L
.95793 .29687 L
.96053 .33723 L
.96314 .34521 L
.96575 .35956 L
.96836 .33455 L
.97097 .31193 L
.97358 .32991 L
.97619 .32272 L
Mfstroke
0 .98 .604 r
gsave
.97619 .30472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24534 m
.02642 .22781 L
.02903 .22023 L
.03164 .2143 L
.03425 .20927 L
.03686 .20483 L
.03947 .20083 L
.04207 .28507 L
.04468 .26838 L
.04729 .26112 L
.0499 .25543 L
.05251 .25059 L
.05512 .24632 L
.05773 .24247 L
.06034 .3132 L
.06295 .298 L
.06556 .29136 L
.06817 .28613 L
.07078 .28169 L
.07339 .27777 L
.07599 .27423 L
.0786 .32016 L
.08121 .30681 L
.08382 .30096 L
.08643 .29635 L
.08904 .29242 L
.09165 .28895 L
.09426 .28581 L
.09687 .35981 L
.09948 .34619 L
.10209 .34007 L
.1047 .33532 L
.10731 .33129 L
.10992 .32772 L
.11252 .32447 L
.11513 .37475 L
.11774 .36311 L
.12035 .35792 L
.12296 .35387 L
.12557 .3504 L
.12818 .34733 L
.13079 .34454 L
.1334 .37994 L
.13601 .37003 L
.13862 .36558 L
.14123 .36209 L
.14384 .35915 L
.14644 .35654 L
.14905 .35414 L
.15166 .32458 L
Mistroke
.15427 .30524 L
.15688 .29681 L
.15949 .29038 L
.1621 .28493 L
.16471 .28013 L
.16732 .27578 L
.16993 .32356 L
.17254 .30601 L
.17515 .29836 L
.17776 .29239 L
.18037 .28733 L
.18297 .28286 L
.18558 .27882 L
.18819 .30374 L
.1908 .2877 L
.19341 .28074 L
.19602 .27528 L
.19863 .27066 L
.20124 .26658 L
.20385 .2629 L
.20646 .25167 L
.20907 .2344 L
.21168 .22689 L
.21429 .22099 L
.21689 .21599 L
.2195 .21158 L
.22211 .20759 L
.22472 .25883 L
.22733 .24323 L
.22994 .23643 L
.23255 .23107 L
.23516 .22652 L
.23777 .22251 L
.24038 .21887 L
.24299 .25653 L
.2456 .24262 L
.24821 .23652 L
.25082 .2317 L
.25342 .2276 L
.25603 .22397 L
.25864 .22069 L
.26125 .26107 L
.26386 .24895 L
.26647 .24361 L
.26908 .23938 L
.27169 .23578 L
.2743 .23259 L
.27691 .22968 L
.27952 .24207 L
.28213 .23121 L
Mistroke
.28474 .2263 L
.28735 .22246 L
.28995 .21922 L
.29256 .21634 L
.29517 .21371 L
.29778 .24137 L
.30039 .23228 L
.303 .22816 L
.30561 .22492 L
.30822 .22217 L
.31083 .21972 L
.31344 .21749 L
.31605 .26844 L
.31866 .25937 L
.32127 .25493 L
.32387 .25147 L
.32648 .24853 L
.32909 .24595 L
.3317 .24362 L
.33431 .27275 L
.33692 .26563 L
.33953 .26233 L
.34214 .25973 L
.34475 .2575 L
.34736 .25553 L
.34997 .25373 L
.35258 .30478 L
.35519 .29456 L
.3578 .28989 L
.3604 .28623 L
.36301 .28313 L
.36562 .28037 L
.36823 .27787 L
.37084 .30168 L
.37345 .29322 L
.37606 .28935 L
.37867 .2863 L
.38128 .28369 L
.38389 .28138 L
.3865 .27927 L
.38911 .24476 L
.39172 .22752 L
.39432 .2201 L
.39693 .2144 L
.39954 .20955 L
.40215 .20526 L
.40476 .20136 L
.40737 .24344 L
.40998 .22801 L
.41259 .22125 L
Mistroke
.4152 .21596 L
.41781 .21147 L
.42042 .20749 L
.42303 .20388 L
.42564 .26042 L
.42825 .24655 L
.43085 .24047 L
.43346 .2357 L
.43607 .23163 L
.43868 .22803 L
.44129 .22477 L
.4439 .23701 L
.44651 .2242 L
.44912 .21856 L
.45173 .21411 L
.45434 .21032 L
.45695 .20695 L
.45956 .20387 L
.46217 .24065 L
.46477 .22965 L
.46738 .22475 L
.46999 .22093 L
.4726 .21766 L
.47521 .21474 L
.47782 .21207 L
.48043 .29068 L
.48304 .2741 L
.48565 .26683 L
.48826 .26112 L
.49087 .25625 L
.49348 .25194 L
.49609 .24804 L
.4987 .28696 L
.5013 .27233 L
.50391 .2659 L
.50652 .26083 L
.50913 .25651 L
.51174 .25268 L
.51435 .24919 L
.51696 .29951 L
.51957 .28678 L
.52218 .28114 L
.52479 .27671 L
.5274 .27291 L
.53001 .26952 L
.53262 .26643 L
.53523 .24802 L
.53783 .23004 L
.54044 .22212 L
.54305 .21589 L
Mistroke
.54566 .21057 L
.54827 .20586 L
.55088 .20158 L
.55349 .20481 L
.5561 .18737 L
.55871 .17964 L
.56132 .17355 L
.56393 .16834 L
.56654 .16371 L
.56915 .15949 L
.57175 .08985 L
.57436 .06032 L
.57697 .04738 L
.57958 .0374 L
.58219 .02895 L
.5848 .02148 L
.58741 .01472 L
.59002 .14674 L
.59263 .11885 L
.59524 .10662 L
.59785 .09706 L
.60046 .08892 L
.60307 .08173 L
.60568 .07521 L
.60828 .21849 L
.61089 .19117 L
.6135 .17922 L
.61611 .16983 L
.61872 .16184 L
.62133 .15478 L
.62394 .14838 L
.62655 .2561 L
.62916 .23103 L
.63177 .22003 L
.63438 .21138 L
.63699 .20402 L
.6396 .19752 L
.6422 .19162 L
.64481 .29661 L
.64742 .27346 L
.65003 .26327 L
.65264 .25522 L
.65525 .24835 L
.65786 .24228 L
.66047 .23677 L
.66308 .39834 L
.66569 .36814 L
.6683 .35489 L
.67091 .34448 L
.67352 .33561 L
Mistroke
.67613 .32776 L
.67873 .32065 L
.68134 .3129 L
.68395 .28242 L
.68656 .26904 L
.68917 .25853 L
.69178 .24958 L
.69439 .24165 L
.697 .23448 L
.69961 .48197 L
.70222 .44099 L
.70483 .42295 L
.70744 .40904 L
.71005 .39727 L
.71265 .38689 L
.71526 .3775 L
.71787 .4551 L
.72048 .4171 L
.72309 .40053 L
.7257 .38762 L
.72831 .37667 L
.73092 .36699 L
.73353 .35822 L
.73614 .32976 L
.73875 .29001 L
.74136 .27272 L
.74397 .25922 L
.74658 .24774 L
.74918 .23759 L
.75179 .22838 L
.7544 .43386 L
.75701 .39476 L
.75962 .37774 L
.76223 .36444 L
.76484 .35313 L
.76745 .34312 L
.77006 .33405 L
.77267 .41364 L
.77528 .37797 L
.77789 .36239 L
.7805 .3502 L
.78311 .33987 L
.78571 .33076 L
.78832 .32252 L
.79093 .51325 L
.79354 .47764 L
.79615 .46206 L
.79876 .44985 L
.80137 .43948 L
.80398 .43032 L
Mistroke
.80659 .42204 L
.8092 .38096 L
.81181 .34159 L
.81442 .32439 L
.81703 .3109 L
.81963 .29944 L
.82224 .28931 L
.82485 .28014 L
.82746 .44378 L
.83007 .40681 L
.83268 .3906 L
.83529 .37787 L
.8379 .36707 L
.84051 .35752 L
.84312 .34889 L
.84573 .3318 L
.84834 .29371 L
.85095 .277 L
.85356 .26387 L
.85616 .25271 L
.85877 .24284 L
.86138 .2339 L
.86399 .32964 L
.8666 .29501 L
.86921 .27978 L
.87182 .2678 L
.87443 .25759 L
.87704 .24854 L
.87965 .24034 L
.88226 .46306 L
.88487 .42346 L
.88748 .40606 L
.89008 .39234 L
.89269 .38064 L
.8953 .37028 L
.89791 .36088 L
.90052 .35275 L
.90313 .313 L
.90574 .29552 L
.90835 .28173 L
.91096 .26997 L
.91357 .25954 L
.91618 .25009 L
.91879 .30521 L
.9214 .26889 L
.92401 .25287 L
.92661 .24022 L
.92922 .22942 L
.93183 .21985 L
.93444 .21117 L
Mistroke
.93705 .31653 L
.93966 .28425 L
.94227 .26997 L
.94488 .25864 L
.94749 .24897 L
.9501 .24039 L
.95271 .23259 L
.95532 .28983 L
.95793 .26144 L
.96053 .24884 L
.96314 .23884 L
.96575 .23028 L
.96836 .22269 L
.97097 .21579 L
.97358 .32969 L
.97619 .30472 L
Mfstroke
gsave
.97619 .35514 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24564 m
.02642 .26355 L
.02903 .27151 L
.03164 .27782 L
.03425 .28322 L
.03686 .28803 L
.03947 .29241 L
.04207 .28537 L
.04468 .30246 L
.04729 .31011 L
.0499 .31621 L
.05251 .32143 L
.05512 .32609 L
.05773 .33034 L
.06034 .31351 L
.06295 .32914 L
.06556 .3362 L
.06817 .34186 L
.07078 .34672 L
.07339 .35107 L
.07599 .35503 L
.0786 .32046 L
.08121 .33427 L
.08382 .34058 L
.08643 .34566 L
.08904 .35004 L
.09165 .35397 L
.09426 .35757 L
.09687 .36011 L
.09948 .37418 L
.10209 .38076 L
.1047 .38597 L
.10731 .39045 L
.10992 .39447 L
.11252 .39818 L
.11513 .37506 L
.11774 .3872 L
.12035 .39287 L
.12296 .39742 L
.12557 .40137 L
.12818 .40492 L
.13079 .4082 L
.1334 .38024 L
.13601 .39066 L
.13862 .39563 L
.14123 .39963 L
.14384 .40308 L
.14644 .40621 L
.14905 .40911 L
.15166 .32488 L
Mistroke
.15427 .34455 L
.15688 .35331 L
.15949 .36008 L
.1621 .36586 L
.16471 .371 L
.16732 .37568 L
.16993 .32386 L
.17254 .34178 L
.17515 .34982 L
.17776 .35616 L
.18037 .36159 L
.18297 .36643 L
.18558 .37085 L
.18819 .30405 L
.1908 .32049 L
.19341 .32787 L
.19602 .33374 L
.19863 .33877 L
.20124 .34325 L
.20385 .34734 L
.20646 .25197 L
.20907 .26962 L
.21168 .27752 L
.21429 .2838 L
.21689 .28918 L
.2195 .29397 L
.22211 .29834 L
.22472 .25913 L
.22733 .27515 L
.22994 .28238 L
.23255 .28815 L
.23516 .29311 L
.23777 .29755 L
.24038 .30159 L
.24299 .25684 L
.2456 .2712 L
.24821 .27776 L
.25082 .28303 L
.25342 .28758 L
.25603 .29165 L
.25864 .29538 L
.26125 .26138 L
.26386 .27398 L
.26647 .27981 L
.26908 .28451 L
.27169 .28859 L
.2743 .29226 L
.27691 .29565 L
.27952 .24238 L
.28213 .25374 L
Mistroke
.28474 .25916 L
.28735 .26349 L
.28995 .26723 L
.29256 .27061 L
.29517 .27374 L
.29778 .24167 L
.30039 .25129 L
.303 .25594 L
.30561 .2597 L
.30822 .26298 L
.31083 .26595 L
.31344 .2687 L
.31605 .26874 L
.31866 .27834 L
.32127 .2833 L
.32387 .28729 L
.32648 .29075 L
.32909 .29386 L
.3317 .29671 L
.33431 .27305 L
.33692 .28072 L
.33953 .28457 L
.34214 .28771 L
.34475 .29048 L
.34736 .29301 L
.34997 .29535 L
.35258 .30509 L
.35519 .31581 L
.3578 .321 L
.3604 .32516 L
.36301 .32878 L
.36562 .33204 L
.36823 .33505 L
.37084 .30198 L
.37345 .31097 L
.37606 .31538 L
.37867 .31896 L
.38128 .3221 L
.38389 .32495 L
.3865 .32759 L
.38911 .24506 L
.39172 .26268 L
.39432 .27048 L
.39693 .27658 L
.39954 .28181 L
.40215 .28648 L
.40476 .29077 L
.40737 .24374 L
.40998 .2596 L
.41259 .26677 L
Mistroke
.4152 .27249 L
.41781 .2774 L
.42042 .2818 L
.42303 .28582 L
.42564 .26073 L
.42825 .27505 L
.43085 .28158 L
.43346 .28681 L
.43607 .29132 L
.43868 .29537 L
.44129 .29907 L
.4439 .23731 L
.44651 .25059 L
.44912 .25671 L
.45173 .26162 L
.45434 .26588 L
.45695 .26972 L
.45956 .27325 L
.46217 .24095 L
.46477 .25245 L
.46738 .25784 L
.46999 .26217 L
.4726 .26593 L
.47521 .26935 L
.47782 .27251 L
.48043 .29099 L
.48304 .30796 L
.48565 .31563 L
.48826 .32174 L
.49087 .327 L
.49348 .3317 L
.49609 .336 L
.4987 .28727 L
.5013 .30234 L
.50391 .30921 L
.50652 .31471 L
.50913 .31947 L
.51174 .32373 L
.51435 .32765 L
.51696 .29981 L
.51957 .31301 L
.52218 .31912 L
.52479 .32403 L
.5274 .32829 L
.53001 .33215 L
.53262 .33571 L
.53523 .24832 L
.53783 .26667 L
.54044 .27495 L
.54305 .28155 L
Mistroke
.54566 .28722 L
.54827 .29229 L
.55088 .29694 L
.55349 .20512 L
.5561 .22294 L
.55871 .23104 L
.56132 .23751 L
.56393 .24309 L
.56654 .24809 L
.56915 .25269 L
.57175 .09016 L
.57436 .1197 L
.57697 .13266 L
.57958 .14265 L
.58219 .15111 L
.5848 .1586 L
.58741 .16537 L
.59002 .14704 L
.59263 .175 L
.59524 .1873 L
.59785 .19694 L
.60046 .20514 L
.60307 .21241 L
.60568 .219 L
.60828 .2188 L
.61089 .24621 L
.6135 .25826 L
.61611 .26774 L
.61872 .27582 L
.62133 .28298 L
.62394 .28946 L
.62655 .25641 L
.62916 .28165 L
.63177 .29281 L
.63438 .30163 L
.63699 .30915 L
.6396 .31582 L
.6422 .32187 L
.64481 .29692 L
.64742 .3203 L
.65003 .33072 L
.65264 .33899 L
.65525 .34608 L
.65786 .35238 L
.66047 .3581 L
.66308 .39865 L
.66569 .42884 L
.6683 .44207 L
.67091 .45247 L
.67352 .46132 L
Mistroke
.67613 .46916 L
.67873 .47625 L
.68134 .3132 L
.68395 .34365 L
.68656 .35701 L
.68917 .3675 L
.69178 .37643 L
.69439 .38432 L
.697 .39147 L
.69961 .48228 L
.70222 .52275 L
.70483 .54028 L
.70744 .55368 L
.71005 .56494 L
.71265 .57482 L
.71526 .5837 L
.71787 .45541 L
.72048 .49305 L
.72309 .50927 L
.7257 .52182 L
.72831 .53241 L
.73092 .54174 L
.73353 .55016 L
.73614 .33007 L
.73875 .36937 L
.74136 .38623 L
.74397 .39929 L
.74658 .41033 L
.74918 .42005 L
.75179 .42883 L
.7544 .43416 L
.75701 .47285 L
.75962 .48947 L
.76223 .50237 L
.76484 .51328 L
.76745 .52289 L
.77006 .53156 L
.77267 .41395 L
.77528 .44937 L
.77789 .46472 L
.7805 .47666 L
.78311 .48675 L
.78571 .49561 L
.78832 .5036 L
.79093 .51356 L
.79354 .54893 L
.79615 .56428 L
.79876 .57624 L
.80137 .58637 L
.80398 .59528 L
Mistroke
.80659 .60332 L
.8092 .38127 L
.81181 .42022 L
.81442 .43701 L
.81703 .45008 L
.81963 .46113 L
.82224 .47084 L
.82485 .47959 L
.82746 .44408 L
.83007 .48074 L
.83268 .49667 L
.83529 .50908 L
.8379 .51958 L
.84051 .52881 L
.84312 .53714 L
.84573 .33211 L
.84834 .36984 L
.85095 .3862 L
.85356 .39897 L
.85616 .40978 L
.85877 .41929 L
.86138 .42786 L
.86399 .32994 L
.8666 .36437 L
.86921 .37941 L
.87182 .3912 L
.87443 .40121 L
.87704 .41004 L
.87965 .41804 L
.88226 .46337 L
.88487 .50254 L
.88748 .51951 L
.89008 .5328 L
.89269 .54407 L
.8953 .55401 L
.89791 .56297 L
.90052 .35306 L
.90313 .39236 L
.90574 .40942 L
.90835 .42277 L
.91096 .43409 L
.91357 .44407 L
.91618 .45308 L
.91879 .30551 L
.9214 .34155 L
.92401 .3573 L
.92661 .36968 L
.92922 .3802 L
.93183 .38948 L
.93444 .39788 L
Mistroke
.93705 .31683 L
.93966 .34901 L
.94227 .3632 L
.94488 .37443 L
.94749 .384 L
.9501 .39247 L
.95271 .40015 L
.95532 .29013 L
.95793 .31857 L
.96053 .33122 L
.96314 .34128 L
.96575 .34988 L
.96836 .35752 L
.97097 .36446 L
.97358 .33 L
.97619 .35514 L
Mfstroke
0 0 1 r
gsave
.97619 .32993 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24549 m
.02642 .24568 L
.02903 .24587 L
.03164 .24606 L
.03425 .24624 L
.03686 .24643 L
.03947 .24662 L
.04207 .28522 L
.04468 .28542 L
.04729 .28562 L
.0499 .28582 L
.05251 .28601 L
.05512 .28621 L
.05773 .2864 L
.06034 .31335 L
.06295 .31357 L
.06556 .31378 L
.06817 .314 L
.07078 .31421 L
.07339 .31442 L
.07599 .31463 L
.0786 .32031 L
.08121 .32054 L
.08382 .32077 L
.08643 .321 L
.08904 .32123 L
.09165 .32146 L
.09426 .32169 L
.09687 .35996 L
.09948 .36019 L
.10209 .36042 L
.1047 .36064 L
.10731 .36087 L
.10992 .3611 L
.11252 .36132 L
.11513 .37491 L
.11774 .37515 L
.12035 .3754 L
.12296 .37564 L
.12557 .37589 L
.12818 .37613 L
.13079 .37637 L
.1334 .38009 L
.13601 .38035 L
.13862 .3806 L
.14123 .38086 L
.14384 .38112 L
.14644 .38137 L
.14905 .38163 L
.15166 .32473 L
Mistroke
.15427 .3249 L
.15688 .32506 L
.15949 .32523 L
.1621 .3254 L
.16471 .32556 L
.16732 .32573 L
.16993 .32371 L
.17254 .3239 L
.17515 .32409 L
.17776 .32427 L
.18037 .32446 L
.18297 .32465 L
.18558 .32483 L
.18819 .30389 L
.1908 .3041 L
.19341 .3043 L
.19602 .30451 L
.19863 .30471 L
.20124 .30492 L
.20385 .30512 L
.20646 .25182 L
.20907 .25201 L
.21168 .25221 L
.21429 .2524 L
.21689 .25259 L
.2195 .25278 L
.22211 .25297 L
.22472 .25898 L
.22733 .25919 L
.22994 .2594 L
.23255 .25961 L
.23516 .25982 L
.23777 .26003 L
.24038 .26023 L
.24299 .25669 L
.2456 .25691 L
.24821 .25714 L
.25082 .25736 L
.25342 .25759 L
.25603 .25781 L
.25864 .25804 L
.26125 .26122 L
.26386 .26147 L
.26647 .26171 L
.26908 .26195 L
.27169 .26219 L
.2743 .26243 L
.27691 .26266 L
.27952 .24223 L
.28213 .24248 L
Mistroke
.28474 .24273 L
.28735 .24298 L
.28995 .24323 L
.29256 .24348 L
.29517 .24373 L
.29778 .24152 L
.30039 .24178 L
.303 .24205 L
.30561 .24231 L
.30822 .24257 L
.31083 .24283 L
.31344 .24309 L
.31605 .26859 L
.31866 .26885 L
.32127 .26912 L
.32387 .26938 L
.32648 .26964 L
.32909 .2699 L
.3317 .27016 L
.33431 .2729 L
.33692 .27317 L
.33953 .27345 L
.34214 .27372 L
.34475 .27399 L
.34736 .27427 L
.34997 .27454 L
.35258 .30493 L
.35519 .30519 L
.3578 .30544 L
.3604 .3057 L
.36301 .30595 L
.36562 .30621 L
.36823 .30646 L
.37084 .30183 L
.37345 .3021 L
.37606 .30237 L
.37867 .30263 L
.38128 .3029 L
.38389 .30316 L
.3865 .30343 L
.38911 .24491 L
.39172 .2451 L
.39432 .24529 L
.39693 .24549 L
.39954 .24568 L
.40215 .24587 L
.40476 .24606 L
.40737 .24359 L
.40998 .2438 L
.41259 .24401 L
Mistroke
.4152 .24422 L
.41781 .24443 L
.42042 .24464 L
.42303 .24485 L
.42564 .26057 L
.42825 .2608 L
.43085 .26103 L
.43346 .26125 L
.43607 .26148 L
.43868 .2617 L
.44129 .26192 L
.4439 .23716 L
.44651 .23739 L
.44912 .23763 L
.45173 .23787 L
.45434 .2381 L
.45695 .23833 L
.45956 .23856 L
.46217 .2408 L
.46477 .24105 L
.46738 .2413 L
.46999 .24155 L
.4726 .2418 L
.47521 .24204 L
.47782 .24229 L
.48043 .29083 L
.48304 .29103 L
.48565 .29123 L
.48826 .29143 L
.49087 .29163 L
.49348 .29182 L
.49609 .29202 L
.4987 .28712 L
.5013 .28734 L
.50391 .28755 L
.50652 .28777 L
.50913 .28799 L
.51174 .28821 L
.51435 .28842 L
.51696 .29966 L
.51957 .2999 L
.52218 .30013 L
.52479 .30037 L
.5274 .3006 L
.53001 .30084 L
.53262 .30107 L
.53523 .24817 L
.53783 .24835 L
.54044 .24854 L
.54305 .24872 L
Mistroke
.54566 .2489 L
.54827 .24908 L
.55088 .24926 L
.55349 .20496 L
.5561 .20515 L
.55871 .20534 L
.56132 .20553 L
.56393 .20572 L
.56654 .2059 L
.56915 .20609 L
.57175 .09001 L
.57436 .09001 L
.57697 .09002 L
.57958 .09002 L
.58219 .09003 L
.5848 .09004 L
.58741 .09004 L
.59002 .14689 L
.59263 .14693 L
.59524 .14696 L
.59785 .147 L
.60046 .14703 L
.60307 .14707 L
.60568 .1471 L
.60828 .21865 L
.61089 .21869 L
.6135 .21874 L
.61611 .21879 L
.61872 .21883 L
.62133 .21888 L
.62394 .21892 L
.62655 .25625 L
.62916 .25634 L
.63177 .25642 L
.63438 .25651 L
.63699 .25659 L
.6396 .25667 L
.6422 .25675 L
.64481 .29676 L
.64742 .29688 L
.65003 .29699 L
.65264 .29711 L
.65525 .29722 L
.65786 .29733 L
.66047 .29744 L
.66308 .3985 L
.66569 .39849 L
.6683 .39848 L
.67091 .39848 L
.67352 .39847 L
Mistroke
.67613 .39846 L
.67873 .39845 L
.68134 .31305 L
.68395 .31304 L
.68656 .31303 L
.68917 .31302 L
.69178 .313 L
.69439 .31299 L
.697 .31297 L
.69961 .48212 L
.70222 .48187 L
.70483 .48161 L
.70744 .48136 L
.71005 .48111 L
.71265 .48085 L
.71526 .4806 L
.71787 .45525 L
.72048 .45507 L
.72309 .4549 L
.7257 .45472 L
.72831 .45454 L
.73092 .45436 L
.73353 .45419 L
.73614 .32991 L
.73875 .32969 L
.74136 .32947 L
.74397 .32925 L
.74658 .32904 L
.74918 .32882 L
.75179 .3286 L
.7544 .43401 L
.75701 .4338 L
.75962 .43361 L
.76223 .43341 L
.76484 .4332 L
.76745 .433 L
.77006 .4328 L
.77267 .4138 L
.77528 .41367 L
.77789 .41355 L
.7805 .41343 L
.78311 .41331 L
.78571 .41318 L
.78832 .41306 L
.79093 .51341 L
.79354 .51328 L
.79615 .51317 L
.79876 .51305 L
.80137 .51293 L
.80398 .5128 L
Mistroke
.80659 .51268 L
.8092 .38112 L
.81181 .3809 L
.81442 .3807 L
.81703 .38049 L
.81963 .38028 L
.82224 .38007 L
.82485 .37987 L
.82746 .44393 L
.83007 .44378 L
.83268 .44363 L
.83529 .44348 L
.8379 .44332 L
.84051 .44317 L
.84312 .44301 L
.84573 .33196 L
.84834 .33177 L
.85095 .3316 L
.85356 .33142 L
.85616 .33124 L
.85877 .33106 L
.86138 .33088 L
.86399 .32979 L
.8666 .32969 L
.86921 .3296 L
.87182 .3295 L
.87443 .3294 L
.87704 .32929 L
.87965 .32919 L
.88226 .46322 L
.88487 .463 L
.88748 .46279 L
.89008 .46257 L
.89269 .46236 L
.8953 .46214 L
.89791 .46192 L
.90052 .3529 L
.90313 .35268 L
.90574 .35247 L
.90835 .35225 L
.91096 .35203 L
.91357 .35181 L
.91618 .35159 L
.91879 .30536 L
.9214 .30522 L
.92401 .30509 L
.92661 .30495 L
.92922 .30481 L
.93183 .30467 L
.93444 .30452 L
Mistroke
.93705 .31668 L
.93966 .31663 L
.94227 .31659 L
.94488 .31654 L
.94749 .31648 L
.9501 .31643 L
.95271 .31637 L
.95532 .28998 L
.95793 .29 L
.96053 .29003 L
.96314 .29006 L
.96575 .29008 L
.96836 .2901 L
.97097 .29012 L
.97358 .32984 L
.97619 .32993 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 0.0268661 0.855113 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02687 -6 -4.5 ]
[-0.0125 .02687 0 4.5 ]
[-0.0125 .11238 -18 -4.5 ]
[-0.0125 .11238 0 4.5 ]
[-0.0125 .19789 -18 -4.5 ]
[-0.0125 .19789 0 4.5 ]
[-0.0125 .2834 -18 -4.5 ]
[-0.0125 .2834 0 4.5 ]
[-0.0125 .36891 -18 -4.5 ]
[-0.0125 .36891 0 4.5 ]
[-0.0125 .45442 -18 -4.5 ]
[-0.0125 .45442 0 4.5 ]
[-0.0125 .53993 -18 -4.5 ]
[-0.0125 .53993 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .25749 -5 -6 ]
[.97619 .25749 5 6 ]
[.97619 .23736 -5 -6 ]
[.97619 .23736 5 6 ]
[.97619 .40567 -5 -6 ]
[.97619 .40567 5 6 ]
[.97619 .06905 -5 -6 ]
[.97619 .06905 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02687 m
.00625 .02687 L
s
[(0)] -0.0125 .02687 1 0 Mshowa
0 .11238 m
.00625 .11238 L
s
[(0.1)] -0.0125 .11238 1 0 Mshowa
0 .19789 m
.00625 .19789 L
s
[(0.2)] -0.0125 .19789 1 0 Mshowa
0 .2834 m
.00625 .2834 L
s
[(0.3)] -0.0125 .2834 1 0 Mshowa
0 .36891 m
.00625 .36891 L
s
[(0.4)] -0.0125 .36891 1 0 Mshowa
0 .45442 m
.00625 .45442 L
s
[(0.5)] -0.0125 .45442 1 0 Mshowa
0 .53993 m
.00625 .53993 L
s
[(0.6)] -0.0125 .53993 1 0 Mshowa
.125 Mabswid
0 .04397 m
.00375 .04397 L
s
0 .06107 m
.00375 .06107 L
s
0 .07817 m
.00375 .07817 L
s
0 .09528 m
.00375 .09528 L
s
0 .12948 m
.00375 .12948 L
s
0 .14658 m
.00375 .14658 L
s
0 .16368 m
.00375 .16368 L
s
0 .18079 m
.00375 .18079 L
s
0 .21499 m
.00375 .21499 L
s
0 .23209 m
.00375 .23209 L
s
0 .2492 m
.00375 .2492 L
s
0 .2663 m
.00375 .2663 L
s
0 .3005 m
.00375 .3005 L
s
0 .3176 m
.00375 .3176 L
s
0 .33471 m
.00375 .33471 L
s
0 .35181 m
.00375 .35181 L
s
0 .38601 m
.00375 .38601 L
s
0 .40312 m
.00375 .40312 L
s
0 .42022 m
.00375 .42022 L
s
0 .43732 m
.00375 .43732 L
s
0 .47152 m
.00375 .47152 L
s
0 .48863 m
.00375 .48863 L
s
0 .50573 m
.00375 .50573 L
s
0 .52283 m
.00375 .52283 L
s
0 .00976 m
.00375 .00976 L
s
0 .55704 m
.00375 .55704 L
s
0 .57414 m
.00375 .57414 L
s
0 .59124 m
.00375 .59124 L
s
0 .60834 m
.00375 .60834 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02687 m
1 .02687 L
s
.99375 .11238 m
1 .11238 L
s
.99375 .19789 m
1 .19789 L
s
.99375 .2834 m
1 .2834 L
s
.99375 .36891 m
1 .36891 L
s
.99375 .45442 m
1 .45442 L
s
.99375 .53993 m
1 .53993 L
s
.125 Mabswid
.99625 .04397 m
1 .04397 L
s
.99625 .06107 m
1 .06107 L
s
.99625 .07817 m
1 .07817 L
s
.99625 .09528 m
1 .09528 L
s
.99625 .12948 m
1 .12948 L
s
.99625 .14658 m
1 .14658 L
s
.99625 .16368 m
1 .16368 L
s
.99625 .18079 m
1 .18079 L
s
.99625 .21499 m
1 .21499 L
s
.99625 .23209 m
1 .23209 L
s
.99625 .2492 m
1 .2492 L
s
.99625 .2663 m
1 .2663 L
s
.99625 .3005 m
1 .3005 L
s
.99625 .3176 m
1 .3176 L
s
.99625 .33471 m
1 .33471 L
s
.99625 .35181 m
1 .35181 L
s
.99625 .38601 m
1 .38601 L
s
.99625 .40312 m
1 .40312 L
s
.99625 .42022 m
1 .42022 L
s
.99625 .43732 m
1 .43732 L
s
.99625 .47152 m
1 .47152 L
s
.99625 .48863 m
1 .48863 L
s
.99625 .50573 m
1 .50573 L
s
.99625 .52283 m
1 .52283 L
s
.99625 .00976 m
1 .00976 L
s
.99625 .55704 m
1 .55704 L
s
.99625 .57414 m
1 .57414 L
s
.99625 .59124 m
1 .59124 L
s
.99625 .60834 m
1 .60834 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .25749 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .19789 m
.02642 .20125 L
.02903 .19788 L
.03164 .20847 L
.03425 .21798 L
.03686 .21168 L
.03947 .20118 L
.04207 .20236 L
.04468 .21233 L
.04729 .22746 L
.0499 .2255 L
.05251 .22576 L
.05512 .24989 L
.05773 .26646 L
.06034 .26827 L
.06295 .26639 L
.06556 .25446 L
.06817 .2512 L
.07078 .25929 L
.07339 .24529 L
.07599 .24917 L
.0786 .24726 L
.08121 .23607 L
.08382 .23757 L
.08643 .23033 L
.08904 .23749 L
.09165 .23365 L
.09426 .22281 L
.09687 .21534 L
.09948 .19672 L
.10209 .19637 L
.1047 .18327 L
.10731 .18706 L
.10992 .19552 L
.11252 .18807 L
.11513 .18754 L
.11774 .18317 L
.12035 .18199 L
.12296 .18837 L
.12557 .19121 L
.12818 .19229 L
.13079 .20664 L
.1334 .20324 L
.13601 .2092 L
.13862 .20845 L
.14123 .19847 L
.14384 .21052 L
.14644 .23019 L
.14905 .22662 L
.15166 .22196 L
Mistroke
.15427 .21224 L
.15688 .21991 L
.15949 .21433 L
.1621 .21911 L
.16471 .20977 L
.16732 .2052 L
.16993 .21834 L
.17254 .21607 L
.17515 .20946 L
.17776 .22072 L
.18037 .19967 L
.18297 .18937 L
.18558 .18666 L
.18819 .17233 L
.1908 .16293 L
.19341 .17663 L
.19602 .16927 L
.19863 .18311 L
.20124 .17544 L
.20385 .18426 L
.20646 .18123 L
.20907 .17825 L
.21168 .18536 L
.21429 .17588 L
.21689 .18835 L
.2195 .19198 L
.22211 .18306 L
.22472 .19898 L
.22733 .17963 L
.22994 .17847 L
.23255 .18557 L
.23516 .18821 L
.23777 .19908 L
.24038 .19065 L
.24299 .18071 L
.2456 .17631 L
.24821 .17896 L
.25082 .17735 L
.25342 .17432 L
.25603 .18153 L
.25864 .1784 L
.26125 .18949 L
.26386 .19114 L
.26647 .19091 L
.26908 .20553 L
.27169 .20069 L
.2743 .20073 L
.27691 .20528 L
.27952 .20214 L
.28213 .21388 L
Mistroke
.28474 .21387 L
.28735 .20613 L
.28995 .19863 L
.29256 .18867 L
.29517 .18596 L
.29778 .18135 L
.30039 .18245 L
.303 .18129 L
.30561 .17571 L
.30822 .1805 L
.31083 .18165 L
.31344 .1893 L
.31605 .18437 L
.31866 .19819 L
.32127 .20912 L
.32387 .19883 L
.32648 .1961 L
.32909 .19306 L
.3317 .20368 L
.33431 .19113 L
.33692 .20246 L
.33953 .20304 L
.34214 .20565 L
.34475 .20124 L
.34736 .19227 L
.34997 .18622 L
.35258 .18756 L
.35519 .20525 L
.3578 .1976 L
.3604 .21014 L
.36301 .2119 L
.36562 .20515 L
.36823 .19205 L
.37084 .20708 L
.37345 .21567 L
.37606 .21463 L
.37867 .21269 L
.38128 .21112 L
.38389 .20392 L
.3865 .19498 L
.38911 .19755 L
.39172 .2108 L
.39432 .22413 L
.39693 .21993 L
.39954 .21802 L
.40215 .21937 L
.40476 .22794 L
.40737 .21382 L
.40998 .21036 L
.41259 .20584 L
Mistroke
.4152 .20936 L
.41781 .21609 L
.42042 .20251 L
.42303 .19971 L
.42564 .21373 L
.42825 .20349 L
.43085 .21394 L
.43346 .22187 L
.43607 .23674 L
.43868 .2269 L
.44129 .23871 L
.4439 .2571 L
.44651 .26544 L
.44912 .26607 L
.45173 .2649 L
.45434 .25844 L
.45695 .26146 L
.45956 .27748 L
.46217 .28436 L
.46477 .28288 L
.46738 .29692 L
.46999 .28491 L
.4726 .28755 L
.47521 .28455 L
.47782 .28485 L
.48043 .30361 L
.48304 .30416 L
.48565 .30832 L
.48826 .31058 L
.49087 .30441 L
.49348 .32053 L
.49609 .30041 L
.4987 .27577 L
.5013 .28179 L
.50391 .27865 L
.50652 .27313 L
.50913 .26538 L
.51174 .27134 L
.51435 .28424 L
.51696 .27836 L
.51957 .28697 L
.52218 .26529 L
.52479 .27006 L
.5274 .2914 L
.53001 .29187 L
.53262 .30119 L
.53523 .30443 L
.53783 .31618 L
.54044 .32276 L
.54305 .32385 L
Mistroke
.54566 .30847 L
.54827 .30777 L
.55088 .31799 L
.55349 .32665 L
.5561 .34153 L
.55871 .34574 L
.56132 .34662 L
.56393 .35034 L
.56654 .33667 L
.56915 .33343 L
.57175 .31201 L
.57436 .31956 L
.57697 .33329 L
.57958 .35264 L
.58219 .35677 L
.5848 .34957 L
.58741 .35466 L
.59002 .35195 L
.59263 .35814 L
.59524 .36572 L
.59785 .35922 L
.60046 .35026 L
.60307 .34805 L
.60568 .33117 L
.60828 .34192 L
.61089 .33984 L
.6135 .35279 L
.61611 .33705 L
.61872 .32401 L
.62133 .31605 L
.62394 .31774 L
.62655 .3249 L
.62916 .31959 L
.63177 .32531 L
.63438 .32801 L
.63699 .33831 L
.6396 .3333 L
.6422 .32632 L
.64481 .33515 L
.64742 .34109 L
.65003 .32388 L
.65264 .33504 L
.65525 .32758 L
.65786 .32047 L
.66047 .3277 L
.66308 .33809 L
.66569 .3328 L
.6683 .34694 L
.67091 .35331 L
.67352 .35776 L
Mistroke
.67613 .35442 L
.67873 .33681 L
.68134 .3456 L
.68395 .33452 L
.68656 .33248 L
.68917 .33678 L
.69178 .32309 L
.69439 .32269 L
.697 .33866 L
.69961 .34903 L
.70222 .332 L
.70483 .32547 L
.70744 .32017 L
.71005 .32219 L
.71265 .31791 L
.71526 .32278 L
.71787 .31099 L
.72048 .30657 L
.72309 .30119 L
.7257 .29169 L
.72831 .30036 L
.73092 .30727 L
.73353 .31743 L
.73614 .3213 L
.73875 .31065 L
.74136 .3046 L
.74397 .30226 L
.74658 .31055 L
.74918 .31702 L
.75179 .3209 L
.7544 .33449 L
.75701 .34014 L
.75962 .34892 L
.76223 .34063 L
.76484 .33723 L
.76745 .3234 L
.77006 .31584 L
.77267 .32144 L
.77528 .34005 L
.77789 .35791 L
.7805 .36882 L
.78311 .35195 L
.78571 .34669 L
.78832 .36313 L
.79093 .36237 L
.79354 .35819 L
.79615 .35591 L
.79876 .35384 L
.80137 .35433 L
.80398 .37111 L
Mistroke
.80659 .3718 L
.8092 .37005 L
.81181 .36127 L
.81442 .3778 L
.81703 .36561 L
.81963 .36584 L
.82224 .37364 L
.82485 .36975 L
.82746 .3753 L
.83007 .37203 L
.83268 .37238 L
.83529 .37057 L
.8379 .36877 L
.84051 .37849 L
.84312 .37189 L
.84573 .37401 L
.84834 .3828 L
.85095 .38292 L
.85356 .38113 L
.85616 .37662 L
.85877 .36178 L
.86138 .37071 L
.86399 .36536 L
.8666 .35212 L
.86921 .34485 L
.87182 .33991 L
.87443 .33109 L
.87704 .32404 L
.87965 .31999 L
.88226 .31722 L
.88487 .31182 L
.88748 .32532 L
.89008 .32366 L
.89269 .3344 L
.8953 .34031 L
.89791 .3254 L
.90052 .32791 L
.90313 .32262 L
.90574 .31852 L
.90835 .32579 L
.91096 .30136 L
.91357 .30186 L
.91618 .29463 L
.91879 .30069 L
.9214 .30961 L
.92401 .30706 L
.92661 .31123 L
.92922 .29907 L
.93183 .29224 L
.93444 .30468 L
Mistroke
.93705 .3075 L
.93966 .29587 L
.94227 .29711 L
.94488 .30243 L
.94749 .29911 L
.9501 .30269 L
.95271 .30377 L
.95532 .28948 L
.95793 .28993 L
.96053 .28033 L
.96314 .28716 L
.96575 .27144 L
.96836 .26917 L
.97097 .2608 L
.97358 .25144 L
.97619 .25749 L
Mfstroke
0 0 1 r
gsave
.97619 .23736 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19789 m
.02642 .19789 L
.02903 .19789 L
.03164 .1979 L
.03425 .1979 L
.03686 .1979 L
.03947 .1979 L
.04207 .18688 L
.04468 .18691 L
.04729 .18695 L
.0499 .18698 L
.05251 .18701 L
.05512 .18704 L
.05773 .18708 L
.06034 .16985 L
.06295 .16993 L
.06556 .17001 L
.06817 .17009 L
.07078 .17017 L
.07339 .17025 L
.07599 .17032 L
.0786 .14914 L
.08121 .14927 L
.08382 .14941 L
.08643 .14955 L
.08904 .14968 L
.09165 .14982 L
.09426 .14995 L
.09687 .14798 L
.09948 .14811 L
.10209 .14826 L
.1047 .1484 L
.10731 .14854 L
.10992 .14867 L
.11252 .14881 L
.11513 .12787 L
.11774 .12807 L
.12035 .12826 L
.12296 .12846 L
.12557 .12865 L
.12818 .12884 L
.13079 .12903 L
.1334 .10902 L
.13601 .10926 L
.13862 .10951 L
.14123 .10975 L
.14384 .11 L
.14644 .11024 L
.14905 .11048 L
.15166 .2155 L
Mistroke
.15427 .21544 L
.15688 .21539 L
.15949 .21534 L
.1621 .21529 L
.16471 .21524 L
.16732 .21519 L
.16993 .19736 L
.17254 .19736 L
.17515 .19736 L
.17776 .19737 L
.18037 .19737 L
.18297 .19737 L
.18558 .19738 L
.18819 .18081 L
.1908 .18085 L
.19341 .18091 L
.19602 .18096 L
.19863 .18101 L
.20124 .18106 L
.20385 .1811 L
.20646 .19169 L
.20907 .19171 L
.21168 .19173 L
.21429 .19175 L
.21689 .19177 L
.2195 .19179 L
.22211 .19181 L
.22472 .17186 L
.22733 .17193 L
.22994 .17201 L
.23255 .17208 L
.23516 .17216 L
.23777 .17223 L
.24038 .1723 L
.24299 .15162 L
.2456 .15174 L
.24821 .15188 L
.25082 .15201 L
.25342 .15213 L
.25603 .15226 L
.25864 .15239 L
.26125 .13111 L
.26386 .13129 L
.26647 .13148 L
.26908 .13166 L
.27169 .13185 L
.2743 .13203 L
.27691 .13221 L
.27952 .11653 L
.28213 .11675 L
Mistroke
.28474 .11698 L
.28735 .1172 L
.28995 .11743 L
.29256 .11765 L
.29517 .11787 L
.29778 .09838 L
.30039 .09865 L
.303 .09892 L
.30561 .0992 L
.30822 .09947 L
.31083 .09974 L
.31344 .10001 L
.31605 .09531 L
.31866 .09559 L
.32127 .09587 L
.32387 .09615 L
.32648 .09643 L
.32909 .09671 L
.3317 .09699 L
.33431 .07904 L
.33692 .07936 L
.33953 .07969 L
.34214 .08002 L
.34475 .08034 L
.34736 .08067 L
.34997 .08099 L
.35258 .10826 L
.35519 .1085 L
.3578 .10875 L
.3604 .109 L
.36301 .10924 L
.36562 .10949 L
.36823 .10973 L
.37084 .09085 L
.37345 .09114 L
.37606 .09144 L
.37867 .09173 L
.38128 .09202 L
.38389 .09232 L
.3865 .09261 L
.38911 .18681 L
.39172 .18682 L
.39432 .18685 L
.39693 .18688 L
.39954 .18691 L
.40215 .18694 L
.40476 .18697 L
.40737 .16885 L
.40998 .16893 L
.41259 .16901 L
Mistroke
.4152 .16909 L
.41781 .16918 L
.42042 .16926 L
.42303 .16934 L
.42564 .15072 L
.42825 .15085 L
.43085 .15098 L
.43346 .15111 L
.43607 .15124 L
.43868 .15137 L
.44129 .1515 L
.4439 .13731 L
.44651 .13747 L
.44912 .13765 L
.45173 .13781 L
.45434 .13798 L
.45695 .13815 L
.45956 .13831 L
.46217 .11751 L
.46477 .11773 L
.46738 .11796 L
.46999 .11818 L
.4726 .1184 L
.47521 .11862 L
.47782 .11884 L
.48043 .17618 L
.48304 .17623 L
.48565 .1763 L
.48826 .17636 L
.49087 .17642 L
.49348 .17649 L
.49609 .17655 L
.4987 .15394 L
.5013 .15406 L
.50391 .15419 L
.50652 .15431 L
.50913 .15443 L
.51174 .15455 L
.51435 .15467 L
.51696 .1327 L
.51957 .13288 L
.52218 .13307 L
.52479 .13325 L
.5274 .13343 L
.53001 .1336 L
.53262 .13378 L
.53523 .18661 L
.53783 .18664 L
.54044 .18667 L
.54305 .18671 L
Mistroke
.54566 .18674 L
.54827 .18678 L
.55088 .18681 L
.55349 .17857 L
.5561 .17862 L
.55871 .17868 L
.56132 .17873 L
.56393 .17879 L
.56654 .17885 L
.56915 .1789 L
.57175 .31425 L
.57436 .31392 L
.57697 .3136 L
.57958 .31328 L
.58219 .31297 L
.5848 .31265 L
.58741 .31234 L
.59002 .29657 L
.59263 .2963 L
.59524 .29604 L
.59785 .29577 L
.60046 .29551 L
.60307 .29525 L
.60568 .29498 L
.60828 .28789 L
.61089 .28764 L
.6135 .2874 L
.61611 .28716 L
.61872 .28692 L
.62133 .28668 L
.62394 .28644 L
.62655 .26204 L
.62916 .26187 L
.63177 .2617 L
.63438 .26153 L
.63699 .26136 L
.6396 .26119 L
.6422 .26102 L
.64481 .23769 L
.64742 .23758 L
.65003 .23748 L
.65264 .23738 L
.65525 .23728 L
.65786 .23717 L
.66047 .23707 L
.66308 .31454 L
.66569 .31422 L
.6683 .31391 L
.67091 .3136 L
.67352 .31329 L
Mistroke
.67613 .31298 L
.67873 .31267 L
.68134 .31574 L
.68395 .31541 L
.68656 .3151 L
.68917 .31479 L
.69178 .31447 L
.69439 .31416 L
.697 .31384 L
.69961 .43814 L
.70222 .43748 L
.70483 .43682 L
.70744 .43616 L
.71005 .43551 L
.71265 .43486 L
.71526 .43421 L
.71787 .40672 L
.72048 .40615 L
.72309 .40558 L
.7257 .40501 L
.72831 .40445 L
.73092 .40388 L
.73353 .40332 L
.73614 .42266 L
.73875 .42204 L
.74136 .42143 L
.74397 .42083 L
.74658 .42022 L
.74918 .41961 L
.75179 .41901 L
.7544 .41387 L
.75701 .41328 L
.75962 .4127 L
.76223 .41212 L
.76484 .41154 L
.76745 .41096 L
.77006 .41038 L
.77267 .37862 L
.77528 .37812 L
.77789 .37764 L
.7805 .37715 L
.78311 .37666 L
.78571 .37618 L
.78832 .37569 L
.79093 .37375 L
.79354 .37326 L
.79615 .3728 L
.79876 .37232 L
.80137 .37185 L
.80398 .37138 L
Mistroke
.80659 .3709 L
.8092 .41357 L
.81181 .41298 L
.81442 .4124 L
.81703 .41182 L
.81963 .41124 L
.82224 .41066 L
.82485 .41008 L
.82746 .38499 L
.83007 .38448 L
.83268 .38398 L
.83529 .38347 L
.8379 .38297 L
.84051 .38247 L
.84312 .38196 L
.84573 .39434 L
.84834 .3938 L
.85095 .39327 L
.85356 .39275 L
.85616 .39222 L
.85877 .39169 L
.86138 .39116 L
.86399 .35394 L
.8666 .35351 L
.86921 .35309 L
.87182 .35268 L
.87443 .35226 L
.87704 .35184 L
.87965 .35142 L
.88226 .40353 L
.88487 .40297 L
.88748 .40242 L
.89008 .40187 L
.89269 .40132 L
.8953 .40076 L
.89791 .40021 L
.90052 .40326 L
.90313 .4027 L
.90574 .40215 L
.90835 .4016 L
.91096 .40105 L
.91357 .4005 L
.91618 .39995 L
.91879 .36457 L
.9214 .36412 L
.92401 .36368 L
.92661 .36323 L
.92922 .36278 L
.93183 .36234 L
.93444 .36189 L
Mistroke
.93705 .31835 L
.93966 .31802 L
.94227 .31771 L
.94488 .31739 L
.94749 .31706 L
.9501 .31674 L
.95271 .31642 L
.95532 .27564 L
.95793 .27543 L
.96053 .27523 L
.96314 .27502 L
.96575 .27482 L
.96836 .27461 L
.97097 .27441 L
.97358 .23747 L
.97619 .23736 L
Mfstroke
0 .98 .604 r
gsave
.97619 .40567 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2834 m
.02642 .28363 L
.02903 .28508 L
.03164 .28617 L
.03425 .28709 L
.03686 .28787 L
.03947 .28855 L
.04207 .27429 L
.04468 .27454 L
.04729 .27606 L
.0499 .27723 L
.05251 .27819 L
.05512 .27899 L
.05773 .27969 L
.06034 .25527 L
.06295 .25559 L
.06556 .25738 L
.06817 .25876 L
.07078 .25988 L
.07339 .26082 L
.07599 .26162 L
.0786 .23042 L
.08121 .23086 L
.08382 .23285 L
.08643 .23439 L
.08904 .23564 L
.09165 .23668 L
.09426 .23757 L
.09687 .23604 L
.09948 .23639 L
.10209 .23825 L
.1047 .23955 L
.10731 .2405 L
.10992 .24128 L
.11252 .24198 L
.11513 .20781 L
.11774 .20832 L
.12035 .21038 L
.12296 .21192 L
.12557 .21315 L
.12818 .21417 L
.13079 .21506 L
.1334 .18257 L
.13601 .18322 L
.13862 .18526 L
.14123 .18672 L
.14384 .18793 L
.14644 .18901 L
.14905 .19 L
.15166 .29443 L
Mistroke
.15427 .30049 L
.15688 .30446 L
.15949 .30638 L
.1621 .30775 L
.16471 .30879 L
.16732 .30958 L
.16993 .28426 L
.17254 .28448 L
.17515 .28628 L
.17776 .28743 L
.18037 .28819 L
.18297 .28872 L
.18558 .28908 L
.18819 .26487 L
.1908 .26517 L
.19341 .26675 L
.19602 .26791 L
.19863 .26889 L
.20124 .26975 L
.20385 .27051 L
.20646 .28302 L
.20907 .28322 L
.21168 .28482 L
.21429 .28588 L
.21689 .28677 L
.2195 .28753 L
.22211 .28819 L
.22472 .26151 L
.22733 .26203 L
.22994 .26401 L
.23255 .26551 L
.23516 .26671 L
.23777 .26771 L
.24038 .26856 L
.24299 .23971 L
.2456 .24022 L
.24821 .24235 L
.25082 .24389 L
.25342 .24512 L
.25603 .24612 L
.25864 .24697 L
.26125 .2149 L
.26386 .21544 L
.26647 .21773 L
.26908 .21927 L
.27169 .22049 L
.2743 .22148 L
.27691 .22236 L
.27952 .19707 L
.28213 .19758 L
Mistroke
.28474 .19957 L
.28735 .20101 L
.28995 .20214 L
.29256 .20312 L
.29517 .20403 L
.29778 .17015 L
.30039 .17109 L
.303 .17304 L
.30561 .1744 L
.30822 .17554 L
.31083 .17655 L
.31344 .1775 L
.31605 .17024 L
.31866 .17085 L
.32127 .17209 L
.32387 .17307 L
.32648 .17387 L
.32909 .17459 L
.3317 .17526 L
.33431 .14037 L
.33692 .14135 L
.33953 .14302 L
.34214 .14426 L
.34475 .14536 L
.34736 .14635 L
.34997 .14726 L
.35258 .18757 L
.35519 .18813 L
.3578 .19002 L
.3604 .19134 L
.36301 .19242 L
.36562 .19336 L
.36823 .19423 L
.37084 .16052 L
.37345 .1615 L
.37606 .16331 L
.37867 .16459 L
.38128 .16569 L
.38389 .16666 L
.3865 .16755 L
.38911 .27274 L
.39172 .27732 L
.39432 .28113 L
.39693 .28299 L
.39954 .28435 L
.40215 .28537 L
.40476 .28619 L
.40737 .26044 L
.40998 .26071 L
.41259 .26273 L
Mistroke
.4152 .26411 L
.41781 .26509 L
.42042 .26582 L
.42303 .26636 L
.42564 .23935 L
.42825 .23983 L
.43085 .24201 L
.43346 .24345 L
.43607 .24458 L
.43868 .24551 L
.44129 .24629 L
.4439 .22524 L
.44651 .22562 L
.44912 .22787 L
.45173 .22943 L
.45434 .23056 L
.45695 .23148 L
.45956 .23231 L
.46217 .1987 L
.46477 .19944 L
.46738 .20169 L
.46999 .20327 L
.4726 .20449 L
.47521 .20552 L
.47782 .20646 L
.48043 .27871 L
.48304 .27888 L
.48565 .28106 L
.48826 .28251 L
.49087 .28353 L
.49348 .28426 L
.49609 .28486 L
.4987 .25135 L
.5013 .25199 L
.50391 .25439 L
.50652 .25593 L
.50913 .25705 L
.51174 .25794 L
.51435 .25871 L
.51696 .22461 L
.51957 .22511 L
.52218 .22753 L
.52479 .22916 L
.5274 .23035 L
.53001 .23132 L
.53262 .23218 L
.53523 .30007 L
.53783 .30014 L
.54044 .30249 L
.54305 .30401 L
Mistroke
.54566 .30502 L
.54827 .3057 L
.55088 .30625 L
.55349 .29346 L
.5561 .29354 L
.55871 .29605 L
.56132 .29766 L
.56393 .29871 L
.56654 .29945 L
.56915 .30002 L
.57175 .4367 L
.57436 .43975 L
.57697 .4441 L
.57958 .44603 L
.58219 .44724 L
.5848 .44802 L
.58741 .44849 L
.59002 .42886 L
.59263 .42853 L
.59524 .43052 L
.59785 .43154 L
.60046 .43204 L
.60307 .43219 L
.60568 .43212 L
.60828 .42417 L
.61089 .42384 L
.6135 .42549 L
.61611 .42634 L
.61872 .42681 L
.62133 .42714 L
.62394 .42737 L
.62655 .39602 L
.62916 .3959 L
.63177 .3981 L
.63438 .39968 L
.63699 .40083 L
.6396 .4017 L
.6422 .40238 L
.64481 .37309 L
.64742 .37292 L
.65003 .37528 L
.65264 .37694 L
.65525 .37815 L
.65786 .37906 L
.66047 .37974 L
.66308 .46515 L
.66569 .46469 L
.6683 .46648 L
.67091 .46735 L
.67352 .46773 L
Mistroke
.67613 .46783 L
.67873 .46784 L
.68134 .47021 L
.68395 .46973 L
.68656 .47164 L
.68917 .4726 L
.69178 .47324 L
.69439 .47369 L
.697 .47399 L
.69961 .58091 L
.70222 .58148 L
.70483 .58541 L
.70744 .5873 L
.71005 .58839 L
.71265 .58899 L
.71526 .58926 L
.71787 .55085 L
.72048 .55016 L
.72309 .55198 L
.7257 .55286 L
.72831 .55321 L
.73092 .55322 L
.73353 .553 L
.73614 .57613 L
.73875 .57536 L
.74136 .57662 L
.74397 .57699 L
.74658 .5769 L
.74918 .57652 L
.75179 .57597 L
.7544 .5712 L
.75701 .57043 L
.75962 .57137 L
.76223 .5714 L
.76484 .57115 L
.76745 .57076 L
.77006 .57029 L
.77267 .52756 L
.77528 .52693 L
.77789 .52859 L
.7805 .52983 L
.78311 .5307 L
.78571 .53131 L
.78832 .53172 L
.79093 .53225 L
.79354 .53159 L
.79615 .53333 L
.79876 .53451 L
.80137 .53537 L
.80398 .53597 L
Mistroke
.80659 .53639 L
.8092 .57911 L
.81181 .57831 L
.81442 .57922 L
.81703 .57967 L
.81963 .57993 L
.82224 .58006 L
.82485 .58009 L
.82746 .55204 L
.83007 .55161 L
.83268 .55387 L
.83529 .55547 L
.8379 .55654 L
.84051 .55726 L
.84312 .55773 L
.84573 .56991 L
.84834 .56912 L
.85095 .57093 L
.85356 .5721 L
.85616 .57292 L
.85877 .57349 L
.86138 .57386 L
.86399 .52788 L
.8666 .52779 L
.86921 .53046 L
.87182 .53225 L
.87443 .53346 L
.87704 .5343 L
.87965 .53489 L
.88226 .59609 L
.88487 .59521 L
.88748 .59685 L
.89008 .59767 L
.89269 .59816 L
.8953 .59842 L
.89791 .59851 L
.90052 .59963 L
.90313 .59873 L
.90574 .60061 L
.90835 .60177 L
.91096 .60254 L
.91357 .60304 L
.91618 .60332 L
.91879 .55613 L
.9214 .55573 L
.92401 .55861 L
.92661 .56054 L
.92922 .56182 L
.93183 .56269 L
.93444 .56327 L
Mistroke
.93705 .50497 L
.93966 .50464 L
.94227 .50771 L
.94488 .50975 L
.94749 .51111 L
.9501 .51203 L
.95271 .51264 L
.95532 .4528 L
.95793 .45249 L
.96053 .45571 L
.96314 .45771 L
.96575 .45906 L
.96836 .45997 L
.97097 .46055 L
.97358 .40598 L
.97619 .40567 L
Mfstroke
gsave
.97619 .06905 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .11238 m
.02642 .11214 L
.02903 .11071 L
.03164 .10962 L
.03425 .10871 L
.03686 .10794 L
.03947 .10726 L
.04207 .09946 L
.04468 .09927 L
.04729 .09783 L
.0499 .09673 L
.05251 .09584 L
.05512 .09509 L
.05773 .09446 L
.06034 .08443 L
.06295 .08427 L
.06556 .08264 L
.06817 .08142 L
.07078 .08046 L
.07339 .07967 L
.07599 .07903 L
.0786 .06786 L
.08121 .06769 L
.08382 .06597 L
.08643 .06471 L
.08904 .06373 L
.09165 .06296 L
.09426 .06234 L
.09687 .05991 L
.09948 .05984 L
.10209 .05826 L
.1047 .05725 L
.10731 .05657 L
.10992 .05607 L
.11252 .05564 L
.11513 .04794 L
.11774 .04781 L
.12035 .04614 L
.12296 .045 L
.12557 .04415 L
.12818 .04352 L
.13079 .04301 L
.1334 .03547 L
.13601 .03531 L
.13862 .03376 L
.14123 .03279 L
.14384 .03207 L
.14644 .03147 L
.14905 .03097 L
.15166 .13657 L
Mistroke
.15427 .13039 L
.15688 .12631 L
.15949 .1243 L
.1621 .12283 L
.16471 .1217 L
.16732 .12081 L
.16993 .11045 L
.17254 .11023 L
.17515 .10844 L
.17776 .10731 L
.18037 .10655 L
.18297 .10603 L
.18558 .10568 L
.18819 .09674 L
.1908 .09654 L
.19341 .09506 L
.19602 .09401 L
.19863 .09312 L
.20124 .09236 L
.20385 .09169 L
.20646 .10037 L
.20907 .1002 L
.21168 .09864 L
.21429 .09762 L
.21689 .09678 L
.2195 .09606 L
.22211 .09543 L
.22472 .08221 L
.22733 .08184 L
.22994 .08001 L
.23255 .07866 L
.23516 .07761 L
.23777 .07676 L
.24038 .07605 L
.24299 .06352 L
.2456 .06327 L
.24821 .0614 L
.25082 .06012 L
.25342 .05915 L
.25603 .0584 L
.25864 .05781 L
.26125 .04731 L
.26386 .04714 L
.26647 .04523 L
.26908 .04406 L
.27169 .04321 L
.2743 .04258 L
.27691 .04207 L
.27952 .03599 L
.28213 .03592 L
Mistroke
.28474 .03439 L
.28735 .0334 L
.28995 .03271 L
.29256 .03218 L
.29517 .03171 L
.29778 .0266 L
.30039 .02621 L
.303 .0248 L
.30561 .02399 L
.30822 .0234 L
.31083 .02293 L
.31344 .02253 L
.31605 .02037 L
.31866 .02032 L
.32127 .01965 L
.32387 .01923 L
.32648 .01899 L
.32909 .01883 L
.3317 .01873 L
.33431 .01771 L
.33692 .01737 L
.33953 .01637 L
.34214 .01577 L
.34475 .01532 L
.34736 .01498 L
.34997 .01472 L
.35258 .02894 L
.35519 .02887 L
.3578 .02749 L
.3604 .02665 L
.36301 .02607 L
.36562 .02562 L
.36823 .02524 L
.37084 .02118 L
.37345 .02079 L
.37606 .01957 L
.37867 .01888 L
.38128 .01836 L
.38389 .01797 L
.3865 .01767 L
.38911 .10088 L
.39172 .09633 L
.39432 .09257 L
.39693 .09077 L
.39954 .08948 L
.40215 .08851 L
.40476 .08775 L
.40737 .07725 L
.40998 .07715 L
.41259 .0753 L
Mistroke
.4152 .07408 L
.41781 .07326 L
.42042 .07269 L
.42303 .07231 L
.42564 .06208 L
.42825 .06186 L
.43085 .05995 L
.43346 .05877 L
.43607 .05791 L
.43868 .05724 L
.44129 .05672 L
.4439 .04937 L
.44651 .04933 L
.44912 .04742 L
.45173 .0462 L
.45434 .04541 L
.45695 .04482 L
.45956 .04432 L
.46217 .03633 L
.46477 .03602 L
.46738 .03423 L
.46999 .03309 L
.4726 .03231 L
.47521 .03172 L
.47782 .03122 L
.48043 .07364 L
.48304 .07359 L
.48565 .07154 L
.48826 .07021 L
.49087 .06932 L
.49348 .06871 L
.49609 .06823 L
.4987 .05653 L
.5013 .05613 L
.50391 .05398 L
.50652 .05269 L
.50913 .05181 L
.51174 .05116 L
.51435 .05063 L
.51696 .0408 L
.51957 .04066 L
.52218 .0386 L
.52479 .03733 L
.5274 .0365 L
.53001 .03589 L
.53262 .03538 L
.53523 .07315 L
.53783 .07313 L
.54044 .07086 L
.54305 .06941 L
Mistroke
.54566 .06846 L
.54827 .06786 L
.55088 .06737 L
.55349 .06368 L
.5561 .0637 L
.55871 .06131 L
.56132 .05981 L
.56393 .05887 L
.56654 .05824 L
.56915 .05778 L
.57175 .19179 L
.57436 .18809 L
.57697 .18309 L
.57958 .18053 L
.58219 .17869 L
.5848 .17729 L
.58741 .17619 L
.59002 .16429 L
.59263 .16408 L
.59524 .16156 L
.59785 .16 L
.60046 .15898 L
.60307 .1583 L
.60568 .15784 L
.60828 .1516 L
.61089 .15144 L
.6135 .14932 L
.61611 .14799 L
.61872 .14704 L
.62133 .14622 L
.62394 .14551 L
.62655 .12806 L
.62916 .12784 L
.63177 .1253 L
.63438 .12338 L
.63699 .12189 L
.6396 .12068 L
.6422 .11967 L
.64481 .10229 L
.64742 .10224 L
.65003 .09969 L
.65264 .09782 L
.65525 .09641 L
.65786 .09529 L
.66047 .0944 L
.66308 .16393 L
.66569 .16376 L
.6683 .16135 L
.67091 .15985 L
.67352 .15885 L
Mistroke
.67613 .15813 L
.67873 .15749 L
.68134 .16126 L
.68395 .1611 L
.68656 .15856 L
.68917 .15698 L
.69178 .15571 L
.69439 .15463 L
.697 .15369 L
.69961 .29536 L
.70222 .29347 L
.70483 .28822 L
.70744 .28503 L
.71005 .28263 L
.71265 .28072 L
.71526 .27915 L
.71787 .26259 L
.72048 .26213 L
.72309 .25918 L
.7257 .25716 L
.72831 .25569 L
.73092 .25455 L
.73353 .25364 L
.73614 .26918 L
.73875 .26873 L
.74136 .26625 L
.74397 .26466 L
.74658 .26354 L
.74918 .26271 L
.75179 .26205 L
.7544 .25655 L
.75701 .25614 L
.75962 .25403 L
.76223 .25283 L
.76484 .25193 L
.76745 .25115 L
.77006 .25046 L
.77267 .22967 L
.77528 .22931 L
.77789 .22669 L
.7805 .22448 L
.78311 .22263 L
.78571 .22105 L
.78832 .21966 L
.79093 .21524 L
.79354 .21494 L
.79615 .21227 L
.79876 .21014 L
.80137 .20833 L
.80398 .20678 L
Mistroke
.80659 .20542 L
.8092 .24802 L
.81181 .24764 L
.81442 .24558 L
.81703 .24397 L
.81963 .24254 L
.82224 .24126 L
.82485 .24007 L
.82746 .21794 L
.83007 .21734 L
.83268 .21409 L
.83529 .21148 L
.8379 .2094 L
.84051 .20767 L
.84312 .20619 L
.84573 .21876 L
.84834 .21848 L
.85095 .21562 L
.85356 .21339 L
.85616 .21152 L
.85877 .20989 L
.86138 .20846 L
.86399 .18 L
.8666 .17923 L
.86921 .17573 L
.87182 .17311 L
.87443 .17106 L
.87704 .16938 L
.87965 .16795 L
.88226 .21098 L
.88487 .21073 L
.88748 .20799 L
.89008 .20607 L
.89269 .20448 L
.8953 .20311 L
.89791 .20192 L
.90052 .2069 L
.90313 .20667 L
.90574 .2037 L
.90835 .20144 L
.91096 .19956 L
.91357 .19796 L
.91618 .19658 L
.91879 .17302 L
.9214 .1725 L
.92401 .16874 L
.92661 .16592 L
.92922 .16374 L
.93183 .16198 L
.93444 .16051 L
Mistroke
.93705 .13173 L
.93966 .1314 L
.94227 .1277 L
.94488 .12502 L
.94749 .12302 L
.9501 .12145 L
.95271 .12021 L
.95532 .09848 L
.95793 .09837 L
.96053 .09475 L
.96314 .09234 L
.96575 .09058 L
.96836 .08926 L
.97097 .08826 L
.97358 .06896 L
.97619 .06905 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{723.625, 223.625},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;C0000gb000`400?l00000o`00003ooooooooo
ooooomGooooo003oooooooooooooeOooool00?oooooooooooooEooooo`00ooooooooooooomGooooo
003oooooooooooooeOooool00?oooooooooooooEooooo`00C?ooool2o`00023ooooo0ol00004oooo
o`;o00006_ooool3o`0000Cooooo0_l00004ooooo`;o00005oooool3o`0000?ooooo0ol00004oooo
o`;o00005_ooool5o`0000?ooooo0_l00004ooooo`;o00005_ooool5o`0000;ooooo0ol00004oooo
o`;o00005oooool3o`0000Cooooo0_l00004ooooo`;o00005_ooool3o`0000?ooooo0ol00004oooo
o`;o00009oooool2o`00023ooooo0ol00004ooooo`;o00006_ooool3o`0000Cooooo0_l00004oooo
o`;o00005oooool3o`0000?ooooo0ol00004ooooo`;o00005_ooool5o`0000?ooooo0_l00004oooo
o`;o00005_ooool5o`0000;ooooo0ol00004ooooo`;o00005oooool3o`0000Cooooo0_l00004oooo
o`;o00005_ooool3o`0000?ooooo0ol00004ooooo`;o0000?_ooool004_ooooo00Co0000oooooooo
oooo00007_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00006_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00005oooool01Ol0003ooooooooooooooooo000000?ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000Fooooo`06o`000?ooooooooooo`000?oooooo00000oooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo01?ooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005?ooool01ol0
003ooooooooooooooooo0000ooooool000000oooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo02?ooooo00Co0000oooooooooooo00007_ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00005oooool01Ol0003ooooooooooooooooo000000?o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Dooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Fooooo`06o`00
0?ooooooooooo`000?oooooo00000oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo01?ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00005?ooool01ol0003ooooooooooooooooo0000ooooool000000oooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo03_ooooo001;ooooo`04o`000?oooooo
ooooo`0002;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Goooo
o`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000Gooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`0Gooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`0Sooooo`04o`000?ooooooooooo`0002;ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Gooooo`03o`000?oooooooooo00Gooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000Gooooo`03o`000?oooooooooo00Go
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Gooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo00?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0kooooo`00Booo
ool01?l0003oooooooooool0000Rooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00005oooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool05_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`0Eooooo`;o00000oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0001Kooooo0_l00006ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool08oooool01?l0003oooooooooool0000Rooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00005oooool00ol0003oooooooooo`05ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool05_ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Eooooo`;o00000oooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Kooooo0_l00006ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool0>oooool004_ooooo00Co0000oooooooooooo
00007_ooool4o`0000?ooooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005oooool01?l0003ooooooooo
ooooool4o`0000?ooooo00Co0000oooooooooooo00005Oooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Eooooo`06o`000?oo
ooooooooooooool0003ooooo1?l00003ooooo`04o`000?ooooooooooo`0001Wooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Kooooo00?o
0000ooooool000000ol00003ooooo`04o`000?ooooooooooo`0002Gooooo00Co0000oooooooooooo
00007_ooool4o`0000?ooooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005oooool01?l0003ooooooooo
ooooool4o`0000?ooooo00Co0000oooooooooooo00005Oooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Eooooo`06o`000?oo
ooooooooooooool0003ooooo1?l00003ooooo`04o`000?ooooooooooo`0001Wooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Kooooo00?o
0000ooooool000000ol00003ooooo`04o`000?ooooooooooo`0003gooooo001;ooooo`04o`000?oo
ooooooooo`0001kooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000Iooooo`;o
00001?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Kooooo0_l00003
ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00005Oooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Eoooo
o`07o`000?ooooooooooooooool0003oooooo`000006ooooo`04o`000?ooooooooooo`0001Gooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00005?ooool01ol0003ooooooooooooooooo0000ooooool000001_ooool01?l0003ooooo
ooooool0000Uooooo`04o`000?ooooooooooo`0001kooooo00?o0000ooooooooool01?ooool01?l0
003oooooooooool0000Iooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0001Kooooo0_l00003ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00005Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Eooooo`07o`000?ooooooooooooooool0003oooooo`000006ooooo`04
o`000?ooooooooooo`0001Gooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00005?ooool01ol0003ooooooooooooooooo0000oooo
ool000001_ooool01?l0003oooooooooool0000mooooo`00C?ooool2o`0001oooooo1Ol00003oooo
o`;o00006oooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0001Sooooo00Co0000oooo
oooooooooooo1Ol00003ooooo`;o00005oooool3o`0000Cooooo0_l00004ooooo`;o00005oooool3
o`0000;ooooo1Ol00003ooooo`;o00005oooool3o`0000Cooooo0_l00004ooooo`;o00005_ooool3
o`0000;ooooo1Ol00003ooooo`;o00009oooool2o`0001oooooo1Ol00003ooooo`;o00006oooool0
0ol0003oooooooooo`03ooooo`;o00001?ooool2o`0001Sooooo00Co0000oooooooooooooooo1Ol0
0003ooooo`;o00005oooool3o`0000Cooooo0_l00004ooooo`;o00005oooool3o`0000;ooooo1Ol0
0003ooooo`;o00005oooool3o`0000Cooooo0_l00004ooooo`;o00005_ooool3o`0000;ooooo1Ol0
0003ooooo`;o0000?_ooool00?oooooooooooooEooooo`00ooooooooooooomGooooo003ooooooooo
ooooeOooool00?oooooooooooooEooooo`00ooooooooooooomGooooo0016oooooooo00009Ol0000D
oooooooo00009Ol0000aooooo`00A_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00Co0000oooooooooooo00005?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00Co0000oooooooooooo0000<Oooool004Kooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`3oooooob7ooooo00?o0000oooo
ooooool04_ooool3o`000?oooooo8?ooool2o`00037ooooo0016ooooo`03o`000?oooooooooo0:Oo
oooo0_l0nYYgooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0H?ooool4o`3jV[co
oooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0Yoooool2o`3jVWOooooo
00?o0000ooooooooool02oooool2o`0000Gooooo00?o0000ooooooooool0F_ooool:o`3jVPKooooo
1Ol0nYZaooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo0:Kooooo0ol0
nYYgooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooo
ooooo`1Gooooo`[o0?ZJ00?oooooo`3jV_l0nYX01?ooool7o`3jV[7ooooo00?o0000ooooooooool0
;oooool004Kooooo0ol0002Vooooo`?o0?ZJM_ooool2o`0000cooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooooooo`1Cooooo`So0?ZJ1oooool9o`3jVP;ooooo0_l0nYZaooooo`03o`00
0?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo0:Gooooo1?l0nYYgooooo`03o`000?oo
oooooooo00[ooooo00Co0000oooooooooooo00001?ooool3o`0005?ooooo1Ol0nYX;ooooo`Ko0?ZJ
1?ooool2o`3jVZoooooo0ol0000aooooo`00A_ooool00ol0003oooooooooo`2Uooooo`Co0?ZJMooo
ool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0
9Oooool5o`3jVRKooooo1Ol0nYX>ooooo`?o0?ZJ1oooool2o`3jVQKooooo1?l0nYZGooooo`03o`00
0?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo0:Gooooo1?l0nYYgooooo`03o`000?oo
oooooooo00[ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0Sooooo`Oo0?ZJ
9?ooool6o`3jVQWooooo0_l0nYXDooooo`Ko0?ZJ3?ooool4o`3jVXOooooo00?o0000ooooooooool0
;oooool004Kooooo00?o0000ooooooooool0YOooool4o`3jVWOooooo00?o0000ooooooooool02ooo
ool2o`0000Gooooo00?o0000ooooooooool08oooool4o`3jVP03ooooool0nY[o0?ZJ02Cooooo0ol0
nYXLooooo`;o0?ZJ5?ooool3o`3jVP03ooooool0nY[o0?ZJ00_ooooo1Ol0nYZ7ooooo`03o`000?oo
oooooooo02oooooo0016ooooo`03o`000?oooooooooo0:Gooooo1?l0nYYgooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool08_ooool3o`3jVP?ooooo0_l0nYXQooooo`Go0?ZJ7Oooool2
o`3jVQ?ooooo0ol0nYX2ooooo`;o0?ZJ2Oooool7o`3jVXOooooo00?o0000ooooooooool0;oooool0
04Kooooo00?o0000ooooooooool0Y?ooool5o`3jVWOooooo00?o0000ooooooooool04_ooool3o`00
01oooooo1Ol0nYX4ooooo`;o0?ZJ7_ooool7o`3jVQkooooo0_l0nYXAooooo`Co0?ZJ0oooool2o`3j
VPWooooo0ol0nYX2ooooo`;o0?ZJQ_ooool2o`00037ooooo0016ooooo`03o`000?oooooooooo0:Co
oooo0_l0nYX00ooooooo0?ZJo`3jVP1gooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool07_ooool5o`3jVPGooooo0_l0nYXNooooo`Go0?ZJ8?ooool2o`3jVPkooooo1ol0nYX3ooooo`;o
0?ZJ2Oooool2o`3jVP?ooooo0_l0nYZ7ooooo`03o`000?oooooooooo02oooooo0016ooooo`?o0000
Y?ooool2o`3jVP03ooooool0nY[o0?ZJ07Kooooo0_l0000Dooooo`03o`000?oooooooooo01kooooo
0ol0nYX7ooooo`;o0?ZJ7_ooool2o`3jVR?ooooo0_l0nYX>ooooo`Co0?ZJ1_ooool2o`3jVPKooooo
1Ol0nYX3ooooo`;o0?ZJQoooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003ooooooooo
o`2Sooooo`?o0?ZJ00?oooooo`3jV_l0nYX0Moooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01_ooooo1Ol0nYX8ooooo`;o0?ZJ7Oooool3o`3jVR?ooooo0_l0nYX=ooooo`?o0?ZJ2?oo
ool3o`3jVP?ooooo1_l0nYX4ooooo`?o0?ZJQ_ooool00ol0003oooooooooo`0_ooooo`00A_ooool0
0ol0003oooooooooo`2Sooooo`;o0?ZJ0_ooool2o`3jVWOooooo00?o0000ooooooooool04_ooool3
o`0001Wooooo1_l0nYX9ooooo`;o0?ZJ6oooool4o`3jVRCooooo0_l0nYX:ooooo`Go0?ZJ2_ooool2
o`3jVP?ooooo0ol0nYX8ooooo`;o0?ZJ1Oooool5o`3jVW_ooooo0_l0000aooooo`00A_ooool00ol0
003oooooooooo`2Sooooo`;o0?ZJ0_ooool2o`3jVWOooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Fooooo`Ko0?ZJ3?ooool2o`3jVQWooooo1_l0nYXTooooo`;o0?ZJ2Oooool5o`3j
VP_ooooo0_l0nYX3ooooo`;o0?ZJ2Oooool2o`3jVP?ooooo1ol0nYYlooooo`03o`000?oooooooooo
02oooooo0016ooooo`03o`000?oooooooooo0:?ooooo0_l0nYX2ooooo`;o0?ZJMoooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01?ooooo1ol0nYX>ooooo`;o0?ZJ6Oooool3o`3jVROo
oooo0_l0nYX9ooooo`?o0?ZJ3Oooool2o`3jVP;ooooo0ol0nYX9ooooo`;o0?ZJ0_ooool5o`3jVP03
ooooool0nY[o0?ZJ07cooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0
X_ooool00ol0003o0?ZJo`3jVP02ooooo`;o0?ZJMoooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01?ooooo1Ol0nYX@ooooo`;o0?ZJ6Oooool2o`3jVRSooooo0_l0nYX8ooooo`?o0?ZJ
3_ooool6o`3jVP[ooooo1_l0nYX4ooooo`;o0?ZJLoooool3o`3jVPKooooo00?o0000ooooooooool0
;oooool004Kooooo00?o0000ooooooooool0X_ooool00ol0003o0?ZJo`3jVP02ooooo`;o0?ZJMooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo0_l0nYXCooooo`;o0?ZJ6?oo
ool3o`3jVRSooooo0_l0nYX6ooooo`Co0?ZJ3oooool6o`3jVP[ooooo1Ol0nYX5ooooo`;o0?ZJLooo
ool3o`3jVPKooooo00?o0000ooooooooool0;oooool003?ooooo0ol00003ooooo`03o`000?oooooo
oooo00;ooooo0ol00005ooooo`03o`000?oooooooooo0:;ooooo0ol0nYX2ooooo`;o0?ZJ0oooool2
o`3jVW;ooooo00?o0000ooooooooool04_ooool3o`0001;ooooo0ol0nYXCooooo`;o0?ZJ5oooool3
o`3jVRWooooo0_l0nYX4ooooo`Ko0?ZJ3oooool3o`3jVPgooooo0ol0nYX7ooooo`;o0?ZJLoooool2
o`3jVPKooooo0_l0000aooooo`00=?ooool00ol0003oooooooooo`06ooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`2Rooooo`;o0?ZJ0oooool2o`3jVP;ooooo0ol0nYYb
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04?ooool4o`3jVQCooooo0_l0nYXE
ooooo`Go0?ZJ6Oooool7o`00o`Wooooo0_l0nYX4ooooo`?o0?ZJ;?ooool2o`3jVW;ooooo0ol0nYX7
ooooo`03o`000?oooooooooo02oooooo000aooooo`Go00002oooool00ol0003oooooooooo`02oooo
o`?o0000X_ooool2o`3jVP?ooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYY`ooooo`?o00005?ooool0
0ol0003oooooooooo`0>ooooo`Ko0?ZJ5?ooool2o`3jVQCooooo1?l0nYXKooooo`Oo003o2Oooool2
o`3jVP?ooooo0ol0nYX]ooooo`;o0?ZJL_ooool2o`3jVPSooooo00?o0000ooooooooool0;oooool0
037ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo0:;ooooo0_l0nYX4ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJL_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo00kooooo0ol0nYXGooooo`;o0?ZJ5?ooool2o`3jVQgooooo0_l0
0?l3ooooo`;o003o2Oooool2o`3jVP;ooooo0ol0nYX^ooooo`;o0?ZJL_ooool2o`3jVPSooooo00?o
0000ooooooooool0;oooool003;ooooo00?o0000ooooool000002?ooool4o`0000Gooooo00?o0000
ooooooooool0XOooool00ol0003o003oo`00o`05o`00o`03o`3jV_oooooo0?ZJ00;o0?ZJL_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo00gooooo0ol0nYXHooooo`;o0?ZJ3_ooool2
o`3jVP?ooooo0ol0nYXMooooo`;o003o0oooool2o`00o`Cooooo1Ol00?l2o`3jVP03ooooool0nY[o
0?ZJ00;o0?ZJ;_ooool2o`3jVW7ooooo0ol0nYX8ooooo`03o`000?oooooooooo02oooooo000coooo
o`;o00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0:7ooooo00?o0000o`00
ool00?l01Ol00?l00ol0nY[oooooo`3jVP02o`3jVW;ooooo00?o0000ooooooooool04_ooool3o`00
00cooooo0ol0nYXIooooo`;o0?ZJ2oooool5o`3jVP?ooooo0_l0nYXIooooo`;o003o0oooool2o`00
o`?ooooo0_l00?l4ooooo`Go003o1Ol0nYX`ooooo`;o0?ZJ5oooool3o`3jVUGooooo1?l0nYX8oooo
o`;o0000<Oooool003Cooooo00?o0000ooooooooool01_ooool5o`0000Cooooo00?o0000oooooooo
ool0XOooool00ol0003o003oo`00o`03ooooo`;o003o1Ol0nYYbooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool02_ooool5o`3jVQWooooo0_l0nYX9ooooo`co0?ZJ5?ooool3o`00o`;o
oooo1ol00?l3ooooo`?o003o0oooool2o`00o`;ooooo00?o003oo`3jV_l0nYX00_l0nYXaooooo`;o
0?ZJ5_ooool4o`3jVUCooooo1?l0nYX:ooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`00
0?oooooooooo0:7ooooo00?o0000o`00ool00?l00oooool2o`00o`Go0?ZJL_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo00Wooooo1Ol0nYXJooooo`;o0?ZJ2Oooool3o`3jVP;ooooo
1_l0nYXEooooo`co003o1?ooool2o`00o`?ooooo0_l00?l3ooooo`?o0?ZJ<_ooool2o`3jVQCooooo
1_l0nYYDooooo`;o0?ZJ3?ooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003ooooooooo
o`2Qooooo`03o`000?l00?oo003o00?ooooo0_l00?l5o`3jVW;ooooo00Co0000ooooool0003o0000
1?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`09ooooo`;o0?ZJ
7Oooool2o`3jVPSooooo0ol0nYX3ooooo`?o0?ZJ6?ooool6o`00o`[ooooo0_l00?l2ooooo`?o003o
0oooool2o`3jVS?ooooo0_l0nYXDooooo`?o0?ZJ00?oooooo`3jV_l0nYX0E?ooool2o`3jVPcooooo
00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0XOooool01?l0003o003oo`00
ool0nYX2ooooo`;o003o0_l0nYX00ooooooo0?ZJo`3jVP1booooo`;o00000_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool5o`3jVQSooooo
0ol00?l2ooooo`;o0?ZJ1Oooool5o`3jVQoooooo0_l00?l>ooooo`Ko003o1?ooool2o`00oc?ooooo
0_l0nYXDooooo`;o0?ZJ0_ooool2o`3jVUCooooo0_l0nYX<ooooo`03o`000?oooooooooo02oooooo
0016ooooo`03o`000?oooooooooo0:7ooooo00Co0000o`00ool00?oo0?ZJ0_ooool2o`00o`;o0?ZJ
00?oooooo`3jV_l0nYX0L_ooool2o`0000;ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`04ooooo`?o00000oooool7o`3jVQWooooo1Ol00?l2o`3jVPCooooo1_l0nYXNooooo`?o003o
3_ooool6o`00o`Cooooo0_l00?lcooooo`;o0?ZJ4oooool3o`3jVP;ooooo0_l0nYYCooooo`?o0?ZJ
2_ooool3o`00037ooooo0016ooooo`?o0000XOooool01?l0003o003oo`00ool0nYX2ooooo`;o003o
0_l0nYX00ooooooo0?ZJo`3jVP1aooooo`?o00000_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00oooool5o`3jVQ_ooooo1Ol00?l2o`3jVPCooooo
0ol0nYXQooooo`;o003o4oooool2o`00o`Cooooo0_l00?lcooooo`;o0?ZJ4oooool2o`3jVP?ooooo
0_l0nYYCooooo`;o0?ZJ3Oooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003ooooooooo
o`2Qooooo`06o`000?l00?oo003oo`3jV_oooooo00000_l00?l00ol0nY[oooooooooo`02o`3jVW;o
oooo0_l00002ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`0Sooooo`;o003o0oooool2o`3jVP?ooooo0ol0nYXNooooo`Ko003o6Oooool2o`00oaCo
oooo1_l00?lIooooo`;o0?ZJ4oooool2o`3jVP?ooooo0_l0nYYCooooo`;o0?ZJ3Oooool00ol0003o
ooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`2Qooooo`04o`000?l00?oo003oo`3jVP;o
00000ol00?l2ooooo`;o0?ZJL_ooool2o`0000;ooooo00?o0000ooooooooool01_ooool2o`0000Ko
oooo00?o0000ooooooooool08_ooool3o`00o`?ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVQoo
oooo1_l00?lIooooo`;o003o5?ooool6o`00oaWooooo0_l0nYXAooooo`Co0?ZJ0oooool2o`3jVU7o
oooo1?l0nYX=ooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo0:7ooooo
00Co0000o`00ool00?oo0?ZJ0ol00002o`00o`;ooooo0_l0nYYbooooo`04o`000?oooooo0000o`00
00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Rooooo`;o003o1?ooool7o`3j
VQoooooo0_l00?lMooooo`;o003o5?ooool2o`00o`;ooooo0_l00?lIooooo`;o0?ZJ4?ooool4o`3j
VPCooooo0_l0nYYAooooo`Co0?ZJ3Oooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003o
ooooooooo`2Qooooo`03o`000?l00?oo003o00;o0?ZJ0_l00002o`00o`;ooooo0_l0nYYbooooo`03
o`000?oooooooooo01;ooooo0ol0000Nooooo`Ko003o1?ooool5o`3jVR3ooooo0ol00?lMooooo`;o
003o5?ooool2o`00o`;ooooo0_l00?lIooooo`;o0?ZJ3_ooool5o`3jVPGooooo0_l0nYY@ooooo`?o
0?ZJ3_ooool2o`00037ooooo0016ooooo`03o`000?oooooooooo0:7ooooo00?o0000o`00ool00?l0
0_l0nYX2o`0000;o003o0_ooool2o`3jVW;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Nooooo`Ko003o1?ooool4o`3jVQcooooo1ol00?lNooooo`;o003o4oooool3o`00o`;ooooo
0_l00?l9ooooo`Go003o2oooool2o`3jVPkooooo0ol0nYX7ooooo`?o0?ZJCOooool4o`3jVQ3ooooo
00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0XOooool00ol0003o003oo`00
o`02o`3jVP04ooooool0003o003oo`00o`;ooooo0_l0nYYbooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool07_ooool2o`00o`Sooooo0ol0nYXMooooo`Oo003o7_ooool2o`00oa?ooooo
0_l00?l3ooooo`;o003o2Oooool7o`00o`Wooooo0_l0nYX>ooooo`;o0?ZJ2Oooool2o`3jVTgooooo
0ol0nYXAooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo0:7ooooo00?o
0000o`00ool00?l00ol0nYX00ooooooo003oo`00o`02ooooo`;o0?ZJL_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01kooooo0_l00?l8ooooo`;o0?ZJ7_ooool2o`00oa?ooooo0_l0
nYX>ooooo`;o003o3_ooool7o`00o`?ooooo0_l00?l9ooooo`;o003o0_ooool3o`00o`Wooooo0_l0
nYX=ooooo`?o0?ZJ2Oooool2o`3jVTgooooo0_l0nYXBooooo`03o`000?oooooooooo02oooooo0016
ooooo`03o`000?oooooooooo0:3ooooo0_l00002o`00o`04ooooool0nY[o0?ZJooooo`;o003o0_oo
ool2o`3jVW;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Mooooo`?o003o2?oo
ool2o`00oakooooo0_l00?lCooooo`Co0?ZJ3?ooool2o`00o`kooooo1ol00?l3ooooo`;o003o2Ooo
ool2o`00o`?ooooo0_l00?l9ooooo`;o0?ZJ3Oooool2o`3jVP[ooooo0_l0nYY=ooooo`;o0?ZJ4_oo
ool00ol0003oooooooooo`0_ooooo`00A_ooool3o`000:3ooooo0_l00002o`00o`04ooooool0nY[o
0?ZJooooo`Ko003oLOooool2o`0001Cooooo0ol0000Mooooo`;o003o2Oooool2o`00oagooooo0ol0
0?lCooooo`Oo0?ZJ2Oooool2o`00o`kooooo0_l00?l8ooooo`;o003o2Oooool2o`00o`?ooooo0_l0
0?l9ooooo`;o0?ZJ3?ooool3o`3jVP[ooooo0_l0nYY=ooooo`;o0?ZJ4Oooool2o`00037ooooo0016
ooooo`03o`000?oooooooooo0:3ooooo0_l00002o`00o`04ooooool0nY[o0?ZJooooo`Ko003o00Co
0?ZJoooooooooooooooo0_l0nYY/ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4oooool<o`00o`Wooooo0_l00?lMooooo`;o003o5?ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ
2Oooool2o`00o`gooooo0ol00?l8ooooo`?o003o2?ooool2o`00o`?ooooo0_l00?l9ooooo`;o0?ZJ
2_ooool5o`3jVP[ooooo0_l0nYY=ooooo`;o0?ZJ4_ooool00ol0003oooooooooo`0_ooooo`00A_oo
ool00ol0003oooooooooo`2Pooooo`;o00000_l00?l01?oooooo0?ZJo`3jV_ooool2o`3jVP;o0000
0_l00?l01?l0nY[oooooooooooooool2o`3jVVcooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Cooooo`co003o2Oooool2o`00oaWooooo1_l00?lDooooo`;o0?ZJ0oooool2o`3jVPWo
oooo0_l00?l9ooooo`Ko003o2_ooool2o`00o`?ooooo0ol00?l2ooooo`;o003o0oooool2o`00o`Wo
oooo0_l0nYX9ooooo`Co0?ZJ3?ooool2o`3jVPSooooo0_l0nYY3ooooo`;o0?ZJ4_ooool00ol0003o
ooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`2Pooooo`;o00000_l00?l01?oooooo0?ZJ
o`3jV_ooool2o`3jVP;o00000_l00?l00ol0nY[oooooooooo`03o`3jVVcooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Cooooo`;o003o4oooool2o`00oaWooooo1_l00?lDooooo`;o
0?ZJ0oooool2o`3jVPWooooo0_l00?l9ooooo`Ko003o2_ooool2o`00o`?ooooo1ol00?l3ooooo`;o
003o2Oooool2o`3jVPWooooo0ol0nYX=ooooo`;o0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ00?o
0?ZJ@oooool2o`3jVQ;ooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0
X?ooool2o`0000;o003o00?oooooo`3jV_l0nYX00ol0nYX2o`0000;o003o00?o0?ZJooooooooool0
0ol0nYY/ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool2o`00oa?ooooo
0_l00?lIooooo`;o003o6?ooool2o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ0oooool2o`00o`Wooooo
0_l00?l>ooooo`;o003o0oooool7o`00o`?ooooo0_l00?l9ooooo`;o0?ZJ1_ooool5o`3jVPkooooo
1_l0nYX00ooooooo0?ZJo`3jVP03o`3jVT?ooooo0_l0nYXBooooo`03o`000?oooooooooo02oooooo
0016ooooo`03o`000?oooooooooo09Wooooo0_l00005ooooo`04o`000?l0nY[o003oo`00o`;ooooo
1?l0nYX01_oooooo0000o`00ool00?oo0?ZJooooo`Co0?ZJK?ooool00ol0003oooooooooo`0Boooo
o`?o00004_ooool3o`00oa?ooooo0_l00?l:ooooo`;o00003Oooool2o`00oaSooooo0_l0nYX3oooo
o`;o0?ZJ1?ooool4o`3jVP03ooooool00?oo003o00Sooooo0ol00?l>ooooo`;o003o0oooool2o`00
o`Sooooo0ol00?l8ooooo`;o0?ZJ1?ooool6o`3jVPoooooo2Ol0nYX00ooooooo0?ZJo`3jVP11oooo
o`Co0?ZJ4Oooool2o`00037ooooo0016ooooo`03o`000?oooooooooo09Wooooo0_l00005ooooo`04
o`000?l0nY[o003oo`00o`;ooooo1?l0nYX01_oooooo0000o`00ool00?oo0?ZJooooo`Co0?ZJK?oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo0_l00?lDooooo`;o003o2_oo
ool2o`0000cooooo0ol00?lHooooo`;o0?ZJ0oooool2o`3jVPCooooo1ol0nYX8ooooo`;o003o3ooo
ool2o`00o`;ooooo0ol00?l9ooooo`;o003o2?ooool2o`3jVPCooooo0ol0nYXBooooo`?o0?ZJ0_oo
ool3o`3jVP;ooooo0_l0nYY0ooooo`Co0?ZJ4oooool00ol0003oooooooooo`0_ooooo`00A_ooool0
0ol0003oooooooooo`2Iooooo`;o00001Oooool2o`3jVP;o003o0oooool3o`3jVP;ooooo0_l00?l6
o`3jVVcooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0>ooooo`Ko003o5?ooool2
o`00o`Wooooo1?l0000;ooooo`;o003o3oooool3o`3jVP;ooooo0ol0nYX2ooooo`;o0?ZJ0oooool3
o`3jVP?ooooo1ol0nYX4ooooo`Ko003o3oooool2o`00o`;ooooo0_l00?l:ooooo`;o003o2?ooool2
o`3jVPCooooo0_l0nYXMooooo`;o0?ZJ<Oooool4o`3jVP_ooooo0_l0nYXEooooo`03o`000?oooooo
oooo02oooooo0016ooooo`03o`000?oooooooooo09Wooooo0_l00004ooooo`?o0?ZJ0_l00?l4oooo
o`;o0?ZJ0_ooool2o`00o`?o0?ZJ00?oooooo`3jV_l0nYX0K?ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00kooooo1_l00?lDooooo`;o003o2Oooool4o`0000Oooooo1_l00?l2oooo
o`;o00002oooool4o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX3oooo
o`;o0?ZJ1?ooool6o`00o`oooooo0_l00?l2ooooo`;o003o2_ooool2o`00o`Sooooo0_l0nYX3oooo
o`?o0?ZJ7Oooool2o`3jVS3ooooo1Ol0nYX9ooooo`Co0?ZJ5Oooool00ol0003oooooooooo`0_oooo
o`00A_ooool3o`0009Wooooo0_l00004ooooo`;o0?ZJ00?o0000o`00ool00?l01?ooool2o`3jVP;o
oooo0_l00?l3o`3jVP03ooooool0nY[o0?ZJ06_ooooo0_l0000Dooooo`03o`000?oooooooooo00ko
oooo0_l00?lHooooo`;o003o2Oooool:o`000003ooooool00?oo003o00Co003o1?l0000;ooooo`co
0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ1?ooool2o`00oa?ooooo1_l00?l:ooooo`;o
003o2?ooool2o`3jVP;ooooo0ol0nYXNooooo`;o0?ZJ<?ooool2o`3jVP03ooooool0nY[o0?ZJ00Wo
oooo0ol0nYXFooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo09Wooooo
0ol00003ooooo`;o0?ZJ00?o0000o`00ool00?l01?ooool2o`3jVP;ooooo0_l00?l3o`3jVP03oooo
ool0nY[o0?ZJ06cooooo00?o0000ooooooooool04_ooool3o`0000gooooo0ol00?lHooooo`;o003o
2Oooool7o`00o`?o000000Coooooo`00ool00?oo00000_ooool6o`0000[ooooo0_l0nYX01?l0003o
0?ZJo`3jV_l0nYX4ooooo`;o0?ZJ1?ooool2o`3jVP;ooooo0ol0nYX3ooooo`;o0?ZJ0oooool3o`00
oa?ooooo1_l00?l:ooooo`;o003o0oooool5o`00o`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXNoooo
o`;o0?ZJ;_ooool4o`3jVP03ooooool0nY[o0?ZJ00Wooooo0_l0nYXFooooo`;o0000<Oooool004Ko
oooo00?o0000ooooooooool0VOooool3o`0000?ooooo0_l0nYX00ol0003o003oo`00o`04ooooo`?o
0?ZJ00Coooooo`00ool00?oo003o0_l0nYX00ooooooo0?ZJo`3jVP1/ooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool03Oooool2o`00o`cooooo0_l00002ooooo`;o00000_ooool3o`3j
VP;ooooo0_l00?l8ooooo`03o`000?l00?oo003o00Go003o0ol00003o`00o`03o`000?oooooooooo
00?o000000?oooooo`000?l000002_ooool2o`3jVPGo00002Oooool2o`3jVP;ooooo0_l0nYX4oooo
o`;o0?ZJ0oooool2o`00obCooooo0_l00?l3ooooo`Go003o1Ol0nYXPooooo`;o0?ZJ;_ooool3o`3j
VP;ooooo0_l0nYX9ooooo`;o0?ZJ5oooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003o
ooooooooo`2Iooooo`Go00000ol0nYX00ol0003o003oo`00o`05ooooo`;o0?ZJ00Coooooo`000?l0
0?oo003o0_l0nYX00ooooooo0?ZJo`3jVP1/ooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool02Oooool6o`00o`cooooo1ol000000ooooooo0?ZJo`3jVP03o`3jVP;o003o2?ooool01?l0
003o003oo`00ooooool2o`0000;o003o0ol00002o`00o`Ko00000_ooool3o`0000Sooooo00Go0000
o`3jV_l0nY[o0000ooooo`03o`0000Sooooo00Go0000o`3jV_l0nY[o0?ZJooooo`02o`3jVPCooooo
0_l0nYX5o`00obCooooo1ol00?l3ooooo`Co0?ZJ8Oooool2o`3jVRkooooo0_l0nYX3ooooo`;o0?ZJ
2?ooool3o`3jVQOooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0VOoo
ool5o`0000;o0?ZJ00Co0000ooooool00?oo003o1Oooool2o`3jVP05ooooool0003o003oo`00ool0
nYX00_ooool2o`3jVP?ooooo0_l0nYYWooooo`04o`000?oooooo0000o`0000Cooooo00Co0000oooo
oooooooooooo1Ol00004ooooo`03o`000?oooooooooo00Wooooo1_l00?l<ooooo`So00001ol0nYX8
ooooo`?o003o0oooool7o`00o`Go00001?ooool4o`0000Gooooo00Co0000o`3jV_l0nY[o0?ZJ0_oo
ool3o`0000?ooooo0_l00003ooooo`03o`000?l0nY[o0?ZJ00Co0?ZJ1?ooool2o`3jVPGo003o9?oo
ool6o`00o`Cooooo0ol0nYXRooooo`;o0?ZJ;_ooool2o`3jVP?ooooo0_l0nYX8ooooo`;o0?ZJ6?oo
ool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`2Iooooo`Go00000_l0nYX0
1?l0003oooooo`00ool00?l5ooooo`?o0?ZJ00Coooooo`00ool00?oo0?ZJ0_ooool2o`3jVP?ooooo
0_l0nYYWooooo`;o00000_ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000Co
oooo00?o0000ooooooooool02?ooool3o`00o`oooooo1Ol00002ooooo`;o00000_l0nYX2ooooo`?o
0?ZJ2?ooool2o`00o`Cooooo1ol00?l00ol0003oooooo`000002o`0000Cooooo1?l00005ooooo`03
o`000?l0nY[o0?ZJ00?ooooo1?l000001?oooooo0000o`000?l00002ooooo`?o00001Ol0nYX4oooo
o`;o0?ZJ<oooool2o`3jVR?ooooo0_l0nYX^ooooo`;o0?ZJ0oooool2o`3jVPSooooo0_l0nYXHoooo
o`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo09Wooooo1?l00003o`3jVP04
o`000?oooooo003oo`00o`Kooooo0_l0nYX01?oooooo003oo`00ool0nYX2ooooo`;o0?ZJ0_ooool3
o`3jVVOooooo0_l00002ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool3
o`0000?ooooo1ol00?l?ooooo`Go00001?ooool00ol0003o0?ZJo`3jVP02o`000003ooooool0nY[o
0?ZJ00Cooooo1_l00?l:ooooo`;o000000Coooooo`000?l0003o00001_ooool2o`0000;ooooo0_l0
nYX01?oooooo0000o`3jV_l0nYX5ooooo`Ko00000_ooool5o`0000?o0?ZJ1?ooool2o`3jVQCooooo
0_l0nYXMooooo`;o003o8oooool2o`3jVRgooooo0ol0nYX3ooooo`;o0?ZJ2?ooool2o`3jVQKooooo
0ol0000aooooo`00A_ooool00ol0003oooooooooo`08ooooo`;o0?ZJJ?ooool2o`3jVRGooooo0ol0
0003o`3jVP;o000000?oooooo`00ool00?l01_ooool2o`3jVP04ooooool00?oo003oo`3jVP;ooooo
0_l0nYX2ooooo`?o0?ZJIoooool2o`0000;ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo1ol00?l00ol0003oooooooooo`0<ooooo`Go0000
1?ooool3o`3jVP;o000000?oooooo`3jV_l0nYX01?ooool6o`00o`[ooooo0_l000000ooooooo0000
o`000007ooooo`Co00001_l0nYX5ooooo`[o000000Coooooo`000?l0003ooooo0ol00002ooooo`03
o`000?l0nY[o0?ZJ00Sooooo0_l0000:ooooo`?o0?ZJ7?ooool2o`00ob?ooooo0_l0nYX]ooooo`;o
0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVQSooooo00?o0000oooooooo
ool0;oooool004Kooooo00?o0000ooooooooool01oooool3o`3jVVOooooo0ol0nYX3ooooo`;o0?ZJ
2Oooool2o`3jVQGooooo0ol000000ol0nY[o003oo`00o`05o`00o`Kooooo0ol0nYX2o`00o`03o`3j
V_oooooooooo00;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYYWooooo`;o00000_ooool00ol0003ooooo
ooooo`05ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`04ooooo`Oo
00003_ooool2o`0000Oooooo0_l0nYX3o`000003ooooool0nY[o0?ZJ00?ooooo00Co0000o`00ool0
0?oooooo0_l0000;ooooo`;o000000?oooooo`000?l000002?ooool3o`0000Ko0?ZJ1Oooool3o`00
0003ooooool0003o000000?o00000_ooool2o`000004ooooool0003o0000o`0000;ooooo00?o0000
o`3jV_l0nYX01Oooool7o`0000Sooooo1Ol0nYXJooooo`;o003o8oooool2o`3jVQkooooo0_l0nYX=
ooooo`;o0?ZJ1?ooool2o`3jVP03ooooool0nY[o0?ZJ00Ko0?ZJ6Oooool00ol0003oooooooooo`0_
ooooo`00A_ooool3o`0000Kooooo1?l0nYXcooooo`;o0?ZJ5Oooool2o`0001_ooooo0ol0nYX2oooo
o`?o0?ZJ2?ooool3o`3jVQGooooo0ol000000ol0nY[o003oo`00o`05o`00o`Oooooo0_l0nYX2o`00
o`03o`3jV_l0003ooooo00;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYYVooooo`?o00000_ooool00ol0
003oooooooooo`05ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`06
ooooo`Go00003_ooool2o`0000?ooooo0ol0nYX00ooooooo0?ZJo`3jVP04o`0000;o0?ZJ0oooool3
o`00o`03ooooool0003o000001Sooooo0ol00002o`3jVP04o`000?l0nY[o0?ZJo`3jVPKooooo0_l0
00000ooooooo0000o`000003o`0000;ooooo1_l00002ooooo`04o`000?l0nY[o0?ZJo`0000Cooooo
1ol00008ooooo`Ko0?ZJ6Oooool2o`00ob?ooooo0_l0nYXLooooo`Co0?ZJ1oooool3o`3jVP?ooooo
0_l0nYX4ooooo`Wo0?ZJ6oooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003ooooooooo
o`06ooooo`Co0?ZJ<_ooool3o`3jVQGooooo0_l0000Jooooo`Co0?ZJ0_ooool3o`3jVPOooooo1?l0
nYX3ooooo`;o0?ZJ4?ooool2o`0000;o0?ZJ0_l00?l2o`0000?o003o1oooool2o`3jVP;o003o0_l0
00001?oooooo0?ZJo`3jV_ooool4o`3jVU?ooooo0_l0nYXBooooo`04o`000?oooooo0000o`0000Wo
oooo0ol00005ooooo`03o`000?oooooooooo00Kooooo1Ol0000>ooooo`;o00000oooool6o`3jVPCo
00000_l0nYX00ol0003oooooo`000002o`00o`Co00006_ooool3o`3jVP;o00002?ooool2o`0000Wo
oooo2?l00002o`3jVP04o`000?ooooooooooooooo`So00002?ooool2o`3jVP;ooooo0_l0nYXIoooo
o`;o003o8oooool2o`3jVQ[ooooo1_l0nYX6ooooo`Co0?ZJ0_ooool3o`3jVPCooooo1Ol0nYX01?oo
oooo0?ZJo`3jV_l0nYXKooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo
00Kooooo1?l0nYXaooooo`Co0?ZJ4oooool2o`3jVP;o00006_ooool4o`3jVP03ooooool0nY[o0?ZJ
00;o0?ZJ1oooool4o`3jVP;ooooo0ol0nYX@ooooo`04o`000?l0nY[o0?ZJo`3jVP;o003o00?o0?ZJ
o`000?ooool00_l0nYX7ooooo`;o0?ZJ0_l00?l3o`0000;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYYC
ooooo`;o0?ZJ2?ooool2o`3jVPSooooo00?o0000ooooooooool04_ooool3o`0000Kooooo1Ol0000>
ooooo`;o00000oooool6o`3jVP;ooooo0_l00002o`3jVPGo003o1?l0000Eooooo`?o0?ZJ0_ooool2
o`3jVP?o00004oooool8o`0000;o0?ZJ00Co0000oooooooooooooooo2?l00008ooooo`;o0?ZJ0_oo
ool2o`3jVQWooooo0_l00?lSooooo`;o0?ZJ6Oooool4o`3jVP03ooooool0nY[o0?ZJ00Gooooo2_l0
nYX4ooooo`?o0?ZJ8?ooool2o`00037ooooo0016ooooo`03o`000?oooooooooo00Kooooo1?l0nYXa
ooooo`Co0?ZJ0oooool2o`3jVPgooooo0ol0nYX2o`000003ooooool0nY[o0?ZJ01Oooooo1?l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVPGooooo00?o0000o`3jV_l0nYX00ol0nYX2ooooo`?o0?ZJ4?ooool0
1?l0003o0?ZJo`3jV_ooool2o`00o`03o`3jV_l0003ooooo00;o0?ZJ1oooool2o`3jVPOo003o1Ol0
nYYBooooo`?o0?ZJ2?ooool2o`3jVPSooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`06ooooo`Go00003_ooool2o`0000?ooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`;o0000
0_l0nYX5o`00o`?o00005_ooool7o`3jVP;o00006?ooool3o`000003ooooool0nY[o0?ZJ00Ko0000
00?oooooo`000?l000000ol00007ooooo`?o0?ZJ0_ooool2o`3jVQWooooo0_l00?lSooooo`;o0?ZJ
6Oooool3o`3jVP;ooooo0_l0nYX4ooooo`?o0?ZJ0_ooool4o`3jVR[ooooo00?o0000ooooooooool0
;oooool004Kooooo00?o0000ooooooooool01Oooool5o`3jVS7ooooo1?l0nYX2ooooo`?o0?ZJ1?oo
ool2o`3jVPKooooo1?l0nYX2o`0000?o0?ZJ5_ooool:o`3jVPGooooo00Co0000o`3jV_l0nY[ooooo
0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVQ3ooooo0ol0nYX01_oooooo003oo`00ool0nY[o0000oooo
o`;o0?ZJ2?ooool00ol0nY[o003oo`00o`05o`00o`;o0?ZJ00?oooooo`3jV_l0nYX0D_ooool3o`3j
VPSooooo0_l0nYX8ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01_ooool2o`00
0004ooooool0003o0000o`0000cooooo0ol00003ooooo`;o0?ZJ1_ooool2o`0000;o0?ZJ0ol00000
0ooooooo0000o`000002o`0001Kooooo1ol0nYXNooooo`;o0?ZJ1_l00004ooooo`?o00001_ooool2
o`3jVP?ooooo0_l0nYXIooooo`;o003o8oooool2o`3jVQOooooo1?l0nYX3ooooo`;o0?ZJ1?ooool2
o`3jVP?ooooo0ol0nYX[ooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo
00Gooooo0_l0nYX00ooooooo0?ZJo`3jVP0aooooo`Co0?ZJ0_ooool3o`3jVP?ooooo0ol0nYX5oooo
o`Go0?ZJ00?o0000o`3jV_l0nYX00_l0nYXFooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX00ol0
003o0?ZJo`3jVP04ooooo`Co0?ZJ00?oooooo`3jV_l0nYX01Ol0nYX@ooooo`;o0?ZJ0_ooool2o`00
o`03o`3jV_l0003ooooo00;o0?ZJ2Oooool2o`3jVP?o00000_l00?l2o`3jVP03ooooool0nY[o0?ZJ
05;ooooo0ol0nYX8ooooo`;o0?ZJ2?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
00[ooooo1?l0000:ooooo`;o00001?ooool2o`3jVPKooooo0_l00002o`3jVP;o00001?ooool2o`00
01Kooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVQkooooo0_l0nYX6o`0000Gooooo0_l000001?oo
oooo0?ZJo`3jV_l0nYX2ooooo`;o0?ZJ0oooool2o`3jVPWooooo0ol0nYX=ooooo`;o003o8oooool2
o`3jVQKooooo1?l0nYX4ooooo`;o0?ZJ1?ooool2o`3jVS7ooooo00?o0000ooooooooool0;oooool0
03?ooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo
00Cooooo0ol0nYX00ooooooo0?ZJo`3jVP0`ooooo`Go0?ZJ0_ooool3o`3jVP;ooooo1?l0nYX3oooo
o`Co0?ZJ00?o0000o`3jV_l0nYX01Ol0nYXEooooo`?o0?ZJ0_ooool3o`3jVP03o`000?l0nY[o0?ZJ
00?ooooo1?l0nYX00ol0003oooooo`000003o`3jVP03o`000?l0nY[o0?ZJ013ooooo0_l0nYX01?oo
oooo003oo`00ool00?l2o`3jVP03ooooool0nY[o0?ZJ00Wooooo0_l0nYX3o`0000;o003o0_l0nYX0
0ooooooo0?ZJo`3jVP0Nooooo`;o0?ZJ<Oooool4o`3jVPOooooo0ol0nYX8ooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool02_ooool4o`0000[ooooo0_l00003ooooo`?o0?ZJ1oooool0
0ol0003o0?ZJo`3jVP0Nooooo`;o0?ZJ8oooool2o`3jVP;o000000?oooooo`000?l000001_ooool3
o`0000Oo0?ZJ0oooool2o`3jVPWooooo1Ol0nYX;ooooo`;o003o8oooool2o`3jVQCooooo1?l0nYX6
ooooo`;o0?ZJ1?ooool2o`3jVS7ooooo00?o0000ooooooooool0;oooool003Cooooo00?o0000oooo
ooooool01_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool01?ooool2
o`3jVP;o00000_l0nYX`ooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo1?l0nYX00ooooooo0?ZJo`3j
VP03o`3jVP;ooooo1Ol0nYX00ol0003o0?ZJo`3jVP02o`3jVP03o`000?l0nY[o0?ZJ01Gooooo0_l0
nYX3ooooo`;o0?ZJ0_l00002o`3jVP;ooooo1Ol0nYX00ol0003oooooo`000002o`3jVP;o00000_l0
nYX00ooooooo0000o`000009ooooo`;o00000_ooool2o`3jVP03ooooool00?oo003o00?o0?ZJ00?o
ooooo`3jV_l0nYX02Oooool2o`3jVP03o`000?oooooo000000;o003o00?o0?ZJooooooooool00_l0
nYXNooooo`;o0?ZJ<Oooool4o`3jVP?ooooo0_l0nYX2ooooo`?o0?ZJ2?ooool00ol0003ooooooooo
o`0Booooo`?o00002_ooool4o`0000Gooooo1?l0nYX3o`0000?ooooo0_l0nYX8ooooo`03o`000?l0
nY[o0?ZJ01gooooo0ol0nYXSooooo`;o0?ZJ0oooool2o`0000Kooooo0ol00007o`3jVP?ooooo0_l0
nYX9ooooo`Oo0?ZJ2Oooool2o`00ob?ooooo0_l0nYXDooooo`?o0?ZJ1oooool2o`3jVP?ooooo0ol0
nYX`ooooo`;o0000<Oooool0037ooooo1Ol00007ooooo`05o`000?ooooooooooooooool000001?oo
ool00ol0003oooooooooo`04ooooo`;o0?ZJ0_l00002o`3jVRoooooo0ol0nYX00ooooooo0?ZJo`3j
VP08o`3jVP04ooooool0nY[o0?ZJooooo`Go0?ZJ0ol00003o`3jVP03o`000?l0nY[o0?ZJ01Gooooo
0_l0nYX3ooooo`;o0?ZJ0_l00009o`3jVP03o`000?oooooo000000;o0?ZJ0_l00002o`3jVP03oooo
ool0003o000000Wooooo0_l000001Ooooooo0000o`3jV_l0nY[ooooo00;o003o0ol0nYX00ooooooo
0?ZJo`3jVP09ooooo`?o0?ZJ00Goooooo`000?l00?oo003oo`3jVP02ooooo`;o0?ZJ0oooool2o`3j
VPWooooo0_l0nYX=ooooo`?o0?ZJ7Oooool2o`3jVQ7ooooo1Ol0nYX3ooooo`;o0?ZJ0_ooool3o`3j
VPSooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0<ooooo`;o00001Oooool8o`3j
VP;ooooo0_l0nYX8ooooo`03o`000?l0nY[o0?ZJ01gooooo0_l0nYXTooooo`;o0?ZJ3?ooool2o`00
00;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX3ooooo`;o0?ZJ2Oooool2o`3jVP03ooooool0nY[o0?ZJ
00;o0?ZJ2Oooool2o`00ob?ooooo0_l0nYXDooooo`;o0?ZJ2?ooool2o`3jVP?ooooo0_l0nYXboooo
o`03o`000?oooooooooo02oooooo000aooooo`04o`000?ooooooooooo`0000Sooooo1?l00005oooo
o`?o00000oooool3o`3jVP;o00000_l0nYX_ooooo`;o0?ZJ0_ooool01Ol0003o0?ZJo`3jV_l0nY[o
oooo00Co0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ0ol00003o`3jVP03o`000?l0nY[o
0?ZJ01Cooooo0ol0nYX3ooooo`;o0?ZJ0ol00004o`3jVP03ooooool00?oo003o00Go003o00?o0?ZJ
o`000?l000000_l0nYX00ooooooo0000o`000009ooooo`;o000000Goooooo`000?l0nY[o0?ZJoooo
o`02o`00o`?o0?ZJ00?oooooo`3jV_l0nYX02_ooool2o`3jVP;ooooo0_l00?l00ol0nY[ooooooooo
o`02o`3jVP?ooooo0_l0nYX9ooooo`;o0?ZJ3Oooool3o`3jVQgooooo0_l0nYXAooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX00_ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1_ooool3o`0001Cooooo00?o
0000ooooooooool03?ooool2o`0000Gooooo0_l0nYX00ol0003o0?ZJo`3jVP07o`3jVPWooooo0_l0
nYXIooooo`?o0?ZJ00?oooooo`3jV_l0nYX09?ooool2o`3jVPWooooo0ol0nYX01?l0003o0?ZJo`3j
V_l0nYX8ooooo`;o0?ZJ2Oooool2o`3jVP?ooooo0_l0nYX9ooooo`;o003o5?ooool6o`00o`Wooooo
0_l0nYXDooooo`;o0?ZJ2?ooool2o`3jVP?ooooo0_l0nYXYooooo`?o003o1_ooool00ol0003ooooo
ooooo`0_ooooo`00<_ooool00ol0003oooooo`000008ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool00oooool2o`3jVP03ooooool0003o000000;o0?ZJ0oooool2o`3jVRSooooo0_l0
0002o`3jVP;ooooo00Co0000o`3jV_l0nY[o0?ZJ0_ooool3o`3jVP;ooooo1Ol0nYX00ooooooo003o
o`00o`09o`00o`Cooooo0_l0nYX>ooooo`;o0?ZJ1?ooool2o`00o`03ooooool0003o000000Co0?ZJ
00?oooooo`00ool00?l02_l00?l00ooooooo0000o`000009ooooo`?o00000ol0nYX00ooooooo003o
o`00o`06o`3jVP[ooooo0_l0nYX2ooooo`;o003o00?o0?ZJooooooooool00_l0nYX2ooooo`?o0?ZJ
2?ooool3o`3jVPgooooo0ol0nYXMooooo`;o0?ZJ1?ooool2o`3jVP_ooooo0_l0nYX00ooooooo0?ZJ
o`3jVP02ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX8ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool03?ooool2o`0000Gooooo0_l0nYX3o`0000Oo0?ZJ2Oooool2o`3jVQWooooo
0ol0nYX00ooooooo0?ZJo`3jVP0Tooooo`;o0?ZJ2Oooool6o`3jVPWooooo0_l0nYX9ooooo`;o0?ZJ
0oooool2o`3jVPWooooo0_l00?lDooooo`Ko003o2Oooool2o`3jVQ?ooooo0ol0nYX8ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX00_l0nYXYooooo`?o003o1_ooool00ol0003oooooooooo`0_ooooo`00<ooo
ool2o`0000Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`Oo003o00?o
0?ZJooooool0nYX00_l0nYXXooooo`07o`000?l0nY[o0?ZJo`3jV_l0003oooooo`000002o`3jVP?o
oooo0ol0nYX2ooooo`Co0?ZJ0_ooool;o`00o`03o`3jV_oooooooooo00?o0?ZJ3_ooool<o`00o`;o
0?ZJ0_ooool2o`00o`04o`3jV_l0003o0000o`0000Ko003o0ol00009ooooo`?o00000_l0nYX2oooo
o`;o003o00?o0?ZJooooool0nYX00ol0nYX:ooooo`;o0?ZJ0_ooool2o`00o`03o`3jV_oooooooooo
00?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ2?ooool3o`3jVPcooooo1?l0nYXMooooo`;o0?ZJ1?ooool2
o`3jVP_ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`So0?ZJ2?ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo00cooooo0_l00004ooooo`04o`000?l0nY[o0?ZJo`0000Kooooo0ol0
nYX9ooooo`;o0?ZJ6Oooool6o`3jVRCooooo0_l0nYX9ooooo`Ko0?ZJ2Oooool3o`3jVPSooooo0_l0
nYX3ooooo`;o0?ZJ2Oooool2o`00oaCooooo0_l00?l2ooooo`;o003o2Oooool2o`3jVQ?ooooo0_l0
nYX9ooooo`Ko0?ZJ:_ooool2o`00o`Oooooo00?o0000ooooooooool0;oooool003Cooooo00?o0000
ooooooooool02?ooool2o`0000Gooooo00?o0000ooooooooool00oooool7o`00o`03o`3jV_oooooo
0?ZJ00;o0?ZJ:?ooool00ol0003o0?ZJo`3jVP02o`000004ooooool0003o0?ZJo`3jVP?ooooo0ol0
nYX2ooooo`Co0?ZJ0_ooool2o`00o`;o000000Goooooo`3jV_l0nY[o0?ZJooooo`02o`00o`03o`3j
V_oooooo0?ZJ00?o0?ZJ3_ooool<o`00o`;o0?ZJ0_ooool2o`00o`04o`3jV_l0003o0000o`0000;o
0?ZJ0_l00002o`00o`?o00000_l0nYX4ooooo`;o0?ZJ1?l00006o`00o`03o`3jV_oooooo0?ZJ00?o
0?ZJ2_ooool2o`3jVP;ooooo0_l00?l4ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1oooool4o`3j
VPcooooo1?l0nYXLooooo`?o0?ZJ0oooool3o`3jVPSooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool2
o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ00?oooooo`3jV_l0nYX02?ooool00ol0003oooooooooo`0B
ooooo`?o00003?ooool2o`0000Cooooo0ol0nYXCooooo`;o0?ZJ6Oooool6o`3jVRCooooo0_l0nYX9
ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJo`000009ooooo`;o0?ZJ2?ooool2o`3jVP?ooooo0_l0
nYX9ooooo`;o003o5?ooool2o`00o`;ooooo0_l00?l9ooooo`;o0?ZJ4oooool2o`3jVPWooooo1Ol0
nYX[ooooo`;o003o1_ooool2o`00037ooooo0016ooooo`03o`000?oooooooooo00?ooooo0_l0nYX3
o`0000;o003o00?o0?ZJooooool0nYX00_l0nYXXooooo`03o`000?l00?oo003o00Go003o00Co0?ZJ
ooooool0003o00000ol0nYX2ooooo`?o0?ZJ00?o0000ooooooooool00_l00?l2o`000005ooooool0
nY[o0?ZJo`3jV_ooool00_l00?l6o`3jVP?ooooo0_l0nYX7ooooo`;o00000_l00?l3o`000005oooo
ool0nY[o0?ZJooooool000000_l00?l2o`3jVP;o00000_l00?l01?l0nY[o0000o`000?l00002o`3j
VP;o00000_l00?l00ol0nY[o0000o`000002o`3jVP?ooooo0ol0nYX4o`0000Ko003o00?o0?ZJoooo
ooooool00ol0nYX:ooooo`;o0?ZJ0_ooool2o`00o`Cooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX7
ooooo`Co0?ZJ3?ooool4o`3jVQcooooo0ol0nYX3ooooo`?o0?ZJ2?ooool2o`3jVP04ooooool0nY[o
0?ZJooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?l0nYX00ooooooo0?ZJo`3jVP08ooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool03?ooool2o`0000;ooooo0_l00002o`3jVP03o`000?oo
oooooooo017ooooo0_l0nYXIooooo`;o0?ZJ:?ooool2o`3jVPWooooo0_l0nYX3ooooo`;o00002Ooo
ool2o`3jVP?ooooo0ol0nYX2ooooo`;o0?ZJ0oooool2o`3jVPWooooo0_l00?lCooooo`?o003o0_oo
ool2o`00o`Wooooo0_l0nYX8ooooo`;o0?ZJ1_ooool5o`3jVPWooooo0ol0nYX]ooooo`;o003o1ooo
ool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`03ooooo`?o0?ZJ00Co0000
ooooool00?oo003o1Ol0nYXXooooo`03o`000?l00?oo003o00Go003o00Co0?ZJooooool0003o0000
1?l00?l01_oooooo0?ZJo`3jV_l0nY[o0000ooooo`?o003o0_l000001Ooooooo0?ZJo`3jV_l0nY[o
oooo00;o003o0ol0nYX00ooooooo0?ZJo`3jVP02ooooo`?o0?ZJ1oooool2o`0000;o003o00Co0?ZJ
o`000?l0003ooooo0_l0nYX2ooooo`?o003o00?o0?ZJo`000?l000000_l00?l2o`3jVP;o00000_l0
nYX2o`0000;o003o00?o0?ZJo`000?l0nYX00_l0nYX2ooooo`Co0?ZJ1?l00002o`00o`;ooooo0_l0
nYX4ooooo`;o0?ZJ2_ooool3o`3jVP03ooooool00?oo003o00Go003o1Ol0nYX6ooooo`Go0?ZJ2ooo
ool5o`3jVQcooooo0ol0nYX2ooooo`Co0?ZJ2?ooool2o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ
00?oooooo`3jV_l0nYX01?l0nYX00ooooooo0?ZJo`3jVP08ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool03?ooool2o`0000?o0?ZJ00?o0000o`3jV_l0nYX05?ooool2o`3jVQSooooo
0ol0nYXXooooo`;o0?ZJ2?ooool3o`3jVP?ooooo0_l00009ooooo`;o0?ZJ0oooool7o`3jVP?ooooo
0_l0nYX9ooooo`;o003o4oooool2o`00o`?ooooo0_l00?l9ooooo`;o0?ZJ1_ooool4o`3jVPCooooo
1_l0nYXjooooo`;o003o00?o0000ooooooooool01?ooool00ol0003oooooooooo`0_ooooo`00A_oo
ool00ol0003oooooooooo`04ooooo`;o0?ZJ0_ooool2o`00o`Go0?ZJ:?ooool01?l0003o003oo`00
ooooool2o`0000go003o00?o0?ZJo`000?l000000_l00?l2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ
0ol00?l2o`3jVP04ooooool0nY[o0?ZJooooo`Co0?ZJ1oooool2o`0000;o003o00Co0?ZJo`000?l0
003o00000_l0nYX3ooooo`?o003o0_l00002o`00o`;o0?ZJ00?o0000o`3jV_l0nYX00_l0nYX01Ol0
003o003oo`00ool0nY[o000000?o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX3o`000005o`3jV_l00?oo
003oo`3jV_ooool00_l0nYXAooooo`;o0?ZJ00?oooooo`00ool00?l01Ol00?l5o`3jVPKooooo0_l0
nYX00ooooooo0?ZJo`3jVP0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX06oooool4o`3jVP;ooooo1?l0
nYX8ooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3jVP03oooo
ool0nY[o0?ZJ00Sooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0<ooooo`;o0000
1_l0nYXDooooo`;o0?ZJ6?ooool2o`3jVRWooooo0_l0nYX4ooooo`;o0?ZJ0_ooool2o`3jVPCooooo
0_l000000ooooooo0000o`000006ooooo`;o0?ZJ0oooool7o`3jVP?ooooo0_l0nYX9ooooo`;o003o
4oooool2o`00o`?ooooo0_l00?l9ooooo`;o0?ZJ1Oooool5o`3jVPCooooo0ol0nYXlooooo`?o003o
00?o0000ooooooooool01?ooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003ooooooooo
o`04ooooo`;o0?ZJ0_ooool2o`00o`Go0?ZJ:?ooool01?l0003o003oo`00ool0nYX3o`0000Ko003o
00?o0?ZJo`000?l00?l02?l00?l5o`3jVP04ooooool0nY[o0?ZJo`3jVP;o003o00?o0?ZJoooooooo
ool01ol0nYX6ooooo`?o00000_l00?l01?l0nY[o0000o`000?l00002o`3jVP?ooooo1ol00?l8o`3j
VP;o003o1Ol0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVP?o000000Go0?ZJo`00ool00?oo0?ZJoooo
o`02o`3jVQ7ooooo0_l0nYX00ooooooo0?ZJo`3jVP03ooooo`;o003o1Ol0nYX6ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX02oooool2o`3jVP03ooooool0nY[o0?ZJ01_ooooo1?l0nYX2ooooo`Co0?ZJ2?oo
ool5o`3jVP04ooooool0nY[o0?ZJooooo`Go0?ZJ0_ooool2o`3jVPSooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0=ooooo`03o`000?l0nY[o0?ZJ00Co0?ZJ5?ooool2o`3jVQCooooo
0ol0nYX00ooooooo0?ZJo`3jVP0Yooooo`;o0?ZJ1?ooool6o`3jVPCooooo1_l00005ooooo`;o0?ZJ
0oooool2o`3jVP;ooooo0ol0nYX3ooooo`;o0?ZJ2Oooool2o`00o`kooooo1ol00?l3ooooo`;o003o
2Oooool2o`3jVPCooooo0ol0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00Co0?ZJ?Oooool2o`00o`So
oooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool01?ooool2o`3jVP;ooooo
0_l00?l2o`3jVP03ooooool0nY[o0?ZJ02Oooooo00Go0000o`3jV_l00?oo003oo`3jVP03o`0000;o
0?ZJ00?oooooo`000?l000000ol0nYX2o`0000Oo003o1Ol0nYX2ooooo`;o0?ZJ0_l00?l00ol0nY[o
ooooooooo`04o`3jVP03ooooool0nY[o0?ZJ00Kooooo0ol00002o`00o`04o`3jV_l0003o0000o`00
00?o0?ZJ0_ooool00ol0nY[o003oo`00o`04o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ00?oooooo`3j
V_l0nYX00_l00?l5o`3jVP04ooooool0nY[o0?ZJo`0000;o0?ZJ0ol000001Ol0nY[o003oo`00ool0
nY[ooooo00;o0?ZJ4Oooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo0_l00?l2o`3jVP03ooooool0
nY[o0?ZJ00Kooooo0_l0nYX00ooooooo0?ZJo`3jVP0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX06ooo
ool4o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ1oooool5o`3jVP;ooooo1Ol0nYX00ol0003o0?ZJo`3j
VP02ooooo`;o0?ZJ2?ooool00ol0003oooooooooo`0Booooo`?o00003Oooool01Ol0003o0?ZJo`3j
V_l0003ooooo00;o0?ZJ5?ooool2o`3jVPWooooo1?l0nYX7ooooo`Ko0?ZJ:Oooool2o`3jVPCooooo
1_l0nYX5ooooo`Go00001Oooool2o`3jVP?ooooo0_l0nYX00ooooooo0000o`000002ooooo`;o0000
00?oooooo`3jV_l0nYX02Oooool2o`00o`kooooo1ol00?l3ooooo`;o003o2Oooool2o`3jVPCooooo
0ol0nYX2ooooo`Oo0?ZJ??ooool00ol0003o003oo`00o`07ooooo`;o0000<Oooool004Kooooo0ol0
0004ooooo`?o0?ZJ00Koooooo`00ool00?oo003oo`3jV_ooool2o`3jVROooooo0_l0nYX2o`00o`04
o`3jV_oooooo0000o`0000;o0?ZJ00?oooooo`000?l000000ol0nYX2o`0000?o0?ZJ0ol00002o`3j
VP04ooooool0nY[o0?ZJo`3jVP?ooooo00?o0?ZJo`00ool00?l01Ol00?l00ol0nY[oooooooooo`02
o`3jVPKooooo0ol00002o`00o`;o0?ZJ00?o0000o`3jV_l0nYX00_l0nYX2ooooo`?o0?ZJ00Gooooo
o`000?l0nY[o0?ZJooooo`04o`3jVP;ooooo00Ko0?ZJo`00ool00?oo003oo`3jV_l00005o`3jVP03
o`000?l0nY[o0?ZJ00;o00000_l0nYX2o`00o`04o`3jV_oooooo0?ZJo`3jVQ7ooooo0_l0nYX01?oo
oooo0?ZJo`3jV_l0nYX2ooooo`;o003o0_l0nYX00ooooooo0?ZJo`3jVP06ooooo`;o0?ZJ00?ooooo
o`3jV_l0nYX02oooool2o`3jVP03ooooool0nY[o0?ZJ01_ooooo1?l0nYX01?oooooo0?ZJo`3jV_oo
ool2o`3jVPOooooo1Ol0nYX2ooooo`Co0?ZJ0_l00002o`3jVP;ooooo0_l0nYX7ooooo`;o00005?oo
ool00ol0003oooooooooo`0=ooooo`?o0?ZJ00?o0000ooooooooool05Oooool2o`3jVPWooooo1ol0
nYX4ooooo`Ko0?ZJ:Oooool2o`3jVPCooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX5ooooo`Go0000
1Oooool2o`3jVP;ooooo0ol0nYX00ooooooo0000o`000002ooooo`?o00000ol0nYX8ooooo`;o003o
3_ooool2o`00o`Sooooo0_l00?l9ooooo`;o0?ZJ1?ooool2o`3jVP?ooooo1?l0nYXoooooo`03o`00
0?l00?oo003o00Sooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool01Ooo
ool2o`3jVP06ooooool0003o003oo`00oooooooo00000_l0nYX3ooooo`;o0?ZJ8_ooool2o`3jVP;o
003o00Co0?ZJoooooooooooooooo0_l0nYX00ooooooo0000o`000003o`3jVP;ooooo0ol0nYX2o`00
00?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0oooool00ol0nY[o003oo`00o`0:o`00o`Kooooo0_l00000
0ooooooo003oo`00o`02o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ00Koooooo`3jV_l0nY[o0?ZJoooo
ool00002o`3jVP03ooooool0003o0?ZJ00;o0?ZJ0_ooool2o`3jVP;o003o00?o0?ZJo`000?l00000
1?l0nYX00ol0003o0?ZJo`3jVP02o`0000;o0?ZJ0_l00?l01?l0nY[oooooo`3jV_l0nYXAooooo`Ko
0?ZJ0_ooool2o`00o`03o`3jV_oooooooooo00;o0?ZJ1_ooool2o`3jVP03ooooool0nY[o0?ZJ00_o
oooo0_l0nYX00ooooooo0?ZJo`3jVP0Jooooo`Go0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX7oooo
o`Go0?ZJ0_ooool4o`3jVP;o00000_l0nYX2ooooo`?o0?ZJ1oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00Wooooo0_l0nYX2ooooo`;o0?ZJ00?o0000ooooooooool05_ooool2o`3j
VPWooooo1ol0nYX4ooooo`;o0?ZJ0_ooool2o`3jVRWooooo0_l0nYX4ooooo`;o0?ZJ3?ooool3o`00
00Cooooo0_l0nYX2ooooo`;o0?ZJ00?oooooo`000?l000000_l000001Ooooooo0000o`000?l0003o
oooo00;o0?ZJ2?ooool2o`00o`kooooo0_l00?l8ooooo`;o003o2Oooool2o`3jVP?ooooo0ol0nYX3
ooooo`?o0?ZJ@?ooool3o`00o`Sooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000oooo
ooooool01Oooool3o`3jVP05o`000?l00?oo003oooooool000000_l0nYX3ooooo`;o0?ZJ6Oooool2
o`3jVPKooooo0ol0nYX2o`00o`;o0?ZJ0_ooool2o`3jVP03ooooool0003o000000?o0?ZJ0_ooool3
o`3jVP04ooooool0003o0?ZJo`3jVP?ooooo0_l0nYX4ooooo`?o0?ZJ00?o0000ooooool00?l01_l0
0?l3ooooo`;o0?ZJ00Coooooo`000?l0003ooooo0_l00?l5o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ
0_ooool2o`3jVP03ooooool0003o000000;o0?ZJ0oooool01?l0nY[o003oo`00ool0nYX2o`0000?o
0?ZJ0_l00002o`3jVP03o`000?l0nY[o0?ZJ00?o003o00Co0?ZJooooool0nY[o0?ZJ4_ooool5o`3j
VP;ooooo0_l00?l00ol0nY[oooooooooo`02o`3jVPKooooo0_l0nYX00ooooooo0?ZJo`3jVP0;oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX06_ooool2o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ00?ooooo
o`3jV_l0nYX01oooool5o`3jVP;ooooo1?l0nYX2o`0000;o0?ZJ0oooool2o`3jVPOooooo00Co0000
ooooool0003o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003ooooooooo
o`09ooooo`Ko0?ZJ6Oooool2o`3jVPWooooo0_l0nYX3ooooo`;o0?ZJ0oooool3o`3jVRgooooo0ol0
nYX2ooooo`?o0?ZJ3Oooool2o`0000Cooooo0_l0nYX2ooooo`;o0?ZJ1Ol000001Ooooooo0000o`00
0?l0003ooooo00;o0?ZJ2?ooool2o`00o`gooooo0ol00?l8ooooo`;o003o2Oooool2o`3jVP?ooooo
0_l0nYY4ooooo`Ko003o2?ooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003ooooooooo
o`06ooooo`;o0?ZJ00Goooooo`00ool00?ooooooo`000003o`3jVP;ooooo0_l0nYXHooooo`?o0?ZJ
0oooool2o`3jVP04ooooool0nY[o0?ZJo`0000;o003o0_l0nYX01?oooooo0?ZJo`3jV_l0nYX2o`00
00Co0?ZJ0_ooool4o`3jVP03ooooool0nY[o0?ZJ00[ooooo0_l0nYX00ol0003oooooo`3jVP02o`3j
VP;ooooo0_l00?l00ol0nY[oooooooooo`02o`3jVP04ooooool0003o0000o`3jVP;o003o00?ooooo
o`3jV_l0nYX00_l0nYX2ooooo`Go0?ZJ0_ooool2o`3jVPSooooo00Co0?ZJo`00ool00?oo0?ZJ0_l0
0003o`3jVP;o00001Ol0nYX2o`00o`Go0?ZJ4_ooool5o`3jVP;ooooo0ol00?l2ooooo`;o0?ZJ1Ooo
ool3o`3jVP03ooooool0nY[o0?ZJ00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Cooooo`;o0?ZJ1Ooo
ool2o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ00?oooooo`3jV_l0nYX01_ooool6o`3jVP;ooooo
1?l0nYX2o`0000;o0?ZJ0oooool2o`3jVPOooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo
00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00Wooooo1_l0nYXIooooo`;o
0?ZJ2?ooool3o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ;oooool3o`3jVP03ooooool0nY[o0?ZJ00ko
oooo0_l00004ooooo`?o0?ZJ00?oooooo`3jV_l0nYX02Ol000000ooooooo0?ZJo`3jVP08ooooo`;o
003o3Oooool2o`00o`Wooooo0ol00?l8ooooo`;o0?ZJ0_ooool3o`3jVTCooooo1Ol00?l9ooooo`03
o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo00Kooooo0_l0nYX00ooooooo003o
o`00o`03o`0000;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ5oooool4o`3jVP?ooooo0_l0nYX01?oooooo
0?ZJo`3jV_l00002o`00o`Oo0?ZJ00?o0000o`3jV_l0nYX00ol0nYX00ooooooo0?ZJo`3jVP05o`3j
VP[ooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVP05o`000?l00?oo003oo`3jV_ooool00ol0nYX0
1?oooooo0000o`3jV_l0nYX2o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool5o`3jVP;ooooo0_l0
nYX8ooooo`04o`3jV_l00?oo003oo`3jVP;o00000ol0nYX2o`0000Co0?ZJ00?oooooo`00ool00?l0
1Ol0nYXBooooo`Go0?ZJ0_ooool00ol0003o003oo`00o`02ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo
0_l0nYX:ooooo`?o0?ZJ00?oooooo`3jV_l0nYX04oooool2o`3jVPGooooo0_l0nYX00ooooooo0?ZJ
o`3jVP03o`3jVP03ooooool0nY[o0?ZJ00Kooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`?o
0?ZJ00?oooooo`000?l000000_l0nYX3ooooo`;o0?ZJ1oooool2o`0000;ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`02ooooo`?o00000oooool4o`3jVP05ooooool0nY[o0?ZJo`3j
V_ooool00ol0nYXIooooo`;o0?ZJ1?ooool3o`3jVP03ooooool0nY[o0?ZJ00Cooooo1?l0nYX00ooo
oooo0?ZJo`3jVP0`ooooo`Go0?ZJ3_ooool6o`0000Ko0?ZJ0ol000000ooooooo0000o`000003o`00
0003ooooool0nY[o0?ZJ00Sooooo0_l00?l=ooooo`;o003o2_ooool2o`00o`Sooooo0_l0nYX00ooo
oooo0?ZJo`3jVP02o`3jVTCooooo0_l00?l3o`0000Oooooo0ol0000aooooo`00A_ooool00ol0003o
ooooooooo`06ooooo`?o0?ZJ1_l00?l5o`3jVPCooooo0_l0nYXAooooo`Co0?ZJ0_ooool6o`3jVP04
o`000?l00?oo003oooooo`Wo0?ZJ00?oooooo`3jV_l0nYX00ol0nYX00ooooooo0?ZJo`3jVP02o`3j
VP_ooooo0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP;o003o1Ol0nYX01?l0003o0?ZJo`3jV_l0nYX2
o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool6o`3jVP03ooooool0nY[o0?ZJ00Wooooo0_l00?l2
ooooo`03o`000?l00?oo003o00Go003o0_l0nYX00ooooooo003oo`00o`05o`3jVQ?ooooo1?l0nYX2
ooooo`03o`000?l00?oo003o00;ooooo0_l0nYX5ooooo`;o0?ZJ0_ooool2o`3jVP[ooooo0_l0nYX2
ooooo`;o0?ZJ4_ooool3o`3jVPGooooo0_l0nYX2o`0000Co0?ZJ00?oooooo`3jV_l0nYX01_ooool2
o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo0ol0nYX3o`0000;o0?ZJ0oooool2o`3jVPOooooo0_l0
0002ooooo`03o`000?oooooooooo00Oooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo1ol0
nYXNooooo`;o0?ZJ1?ooool6o`3jVPCooooo1ol0nYXaooooo`Co0?ZJ3oooool6o`000003ooooool0
nY[o0?ZJ00;o0?ZJ0_l00002ooooo`Go000000?oooooo`3jV_l0nYX02?ooool2o`00o`Wooooo1_l0
0?l:ooooo`;o003o2?ooool5o`3jVTKooooo0_l00?l2o`0000[ooooo00?o0000ooooooooool0;ooo
ool004Kooooo00?o0000ooooooooool01oooool2o`3jVPKo003o1Ol0nYX3ooooo`?o0?ZJ4Oooool4
o`3jVP;ooooo1Ol0nYX2o`0000;o003o00?oooooo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP02
o`3jVP;ooooo1?l0nYX00ooooooo0?ZJo`3jVP02o`3jVP_ooooo1Ol0nYX00ooooooo0?ZJo`3jVP03
o`00o`Oo0?ZJ00?oooooo`00ool00?l00_ooool3o`3jVP?ooooo0_l0nYX00ooooooo0?ZJo`3jVP03
o`3jVPWooooo3?l00?l00ol0nY[oooooooooo`02o`00o`03o`3jV_oooooo0?ZJ00;o0?ZJ4oooool5
o`3jVP;o00000_l00?l2ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo0_l0nYX:ooooo`;o0?ZJ0_ooool2
o`3jVQ;ooooo0ol0nYX5ooooo`;o0?ZJ0_l00004o`3jVP03ooooool0nY[o0?ZJ00Kooooo0_l0nYX0
1?oooooo0?ZJo`3jV_l0nYX2ooooo`?o0?ZJ0ol00006o`00o`03o`3jV_oooooooooo00Gooooo0_l0
0002ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`06ooooo`Co0?ZJ7_ooool2o`3jVPCooooo1_l0nYX7ooooo`Co0?ZJ<_ooool3o`3jVPoooooo1_l0
0003ooooo`?o00001?ooool5o`0000;o0?ZJ2?ooool2o`00o`Wooooo1_l00?l:ooooo`;o003o2?oo
ool4o`3jVPCooooo0_l00011ooooo`;o003o0_l0000:ooooo`03o`000?oooooooooo02oooooo0016
ooooo`03o`000?oooooooooo00Oooooo1?l0nYX2o`0000;o003o0_l0nYX00ooooooo0?ZJo`3jVP02
ooooo`Co0?ZJ4Oooool4o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ0_l00002o`00o`03ooooool0nY[o
0?ZJ00;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX3ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX;
ooooo`03o`000?l0nY[o0?ZJ00;o0?ZJ0_l00002o`3jVP;o003o00?o0?ZJo`000?l000001?l0nYX0
0ooooooo003oo`00o`03ooooo`;o0?ZJ1oooool4o`3jVPWooooo1ol00?l3o`0000;o003o00?o0?ZJ
ooooooooool00_l00?l00ol0nY[oooooo`3jVP02o`3jVQCooooo1?l0nYX2o`0000;o003o0_ooool2
o`3jVPGooooo0_l0nYX2ooooo`;o0?ZJ2_ooool2o`3jVP;ooooo0_l0nYXBooooo`?o0?ZJ1Oooool2
o`3jVP;o00000ol0nYX2ooooo`;o0?ZJ1Oooool3o`3jVP03ooooool0nY[o0?ZJ00;ooooo00Co0000
o`3jV_l0nY[o0?ZJ0ol00006o`00o`03o`3jV_oooooooooo00Gooooo0_l00002ooooo`03o`000?oo
oooooooo00Gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo02Sooooo
0_l0nYX4ooooo`;o0?ZJ0_ooool2o`3jVToooooo1_l00003ooooo`;o00001oooool3o`0000;o0?ZJ
0oooool3o`3jVP;ooooo0_l00?l7ooooo`Co003o3_ooool2o`00o`Sooooo1?l0nYX4ooooo`;o0000
=Oooool2o`0000?ooooo0_l00005ooooo`;o003o3?ooool00ol0003oooooooooo`0_ooooo`00A_oo
ool3o`0000Sooooo0ol0nYX2o`0000;o003o0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`Co0?ZJ4?oo
ool8o`3jVP06ooooool0nY[o0?ZJo`3jV_l0003ooooo0_l00?l2ooooo`?o0?ZJ0_ooool3o`3jVPCo
oooo0_l0nYX2ooooo`?o0?ZJ3?ooool01?l0003o0?ZJo`3jV_l0nYX2o`0000;o0?ZJ0_l00?l00ol0
nY[o0000o`000003o`3jVP;ooooo0_l00?l=ooooo`?o0?ZJ2Oooool2o`3jVP;ooooo0_l00?l2o`3j
VP;ooooo0_l00?l00ol0nY[oooooooooo`02o`00o`?ooooo0_l0nYXDooooo`;o00000_l0nYX2o`00
00Ko003o1Oooool2o`3jVP;ooooo0_l0nYX:ooooo`;o0?ZJ0_ooool2o`3jVQ7ooooo1?l0nYX5oooo
o`;o0?ZJ0_l00003o`3jVP;ooooo0_l0nYX5ooooo`;o0?ZJ0_ooool2o`3jVP;ooooo00Co0000o`3j
V_l0nY[o0?ZJ0ol00002o`00o`;ooooo0_l00?l00ol0nY[oooooooooo`04ooooo`;o000000?ooooo
o`000?l000002Oooool3o`0000Gooooo00?o0000ooooooooool0:?ooool2o`3jVPCooooo0_l0nYYD
ooooo`;o000000Coooooo`000?l0003o00000_ooool2o`0000Sooooo0_l00002o`3jVP?ooooo1Ol0
nYX2o`00o`Cooooo1_l00?l?ooooo`;o003o2?ooool3o`3jVPCooooo1?l0000dooooo`;o00000ooo
ool5o`0000;ooooo0_l00?l<ooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooo
oooo00Wooooo0_l0nYX2o`0000;o003o0_l0nYX00ooooooo0?ZJo`3jVP06o`3jVQ3ooooo0_l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVP04ooooool0003o0?ZJo`3jVP;o000000?oooooo`00ool00?l00ooo
ool2o`3jVP;ooooo0ol0nYX9ooooo`;o0?ZJ3?ooool2o`0000;o0?ZJ0ol000001_l0nY[o003oo`00
ool0nY[oooooo`0000?o003o0_ooool2o`00o`gooooo0ol0nYX9ooooo`?o0?ZJ0_ooool3o`3jVP;o
oooo1ol00?l3ooooo`;o0?ZJ5Oooool01Ol0003o0?ZJo`3jV_l0nY[o000000Ko003o1?ooool3o`3j
VP;ooooo0_l0nYX:ooooo`;o0?ZJ0_ooool2o`3jVQ7ooooo1?l0nYX5ooooo`;o0?ZJ0_l00003o`3j
VP;ooooo0_l0nYX5ooooo`;o0?ZJ0_ooool2o`3jVP;ooooo00Co0000o`3jV_l0nY[o0?ZJ0ol00002
o`00o`;ooooo0_l00?l00ol0nY[oooooooooo`05ooooo`03o`000?oooooooooo01;ooooo0ol0000X
ooooo`?o0?ZJ0_ooool3o`3jVUCooooo0_l00002ooooo`;o00000_ooool2o`0000Wooooo00Co0000
o`3jV_l0nY[o0?ZJ0_ooool7o`3jVPCooooo1Ol00?l@ooooo`;o003o3oooool4o`0000;ooooo0_l0
000_ooooo`Co000000?oooooo`000?l000001Ol00003o`00o`_ooooo0_l0000aooooo`00A_ooool0
0ol0003oooooooooo`09ooooo`;o0?ZJ00?o0000ooooool00?l00_l00?l00ol0nY[oooooooooo`04
o`3jVP03ooooool0nY[o0?ZJ00oooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVP;o00001ol00?l8
ooooo`;o0?ZJ5oooool8o`0000Co003o00?oooooo`00ool00?l01Ol00?l>ooooo`;o0?ZJ2_ooool2
o`3jVP;ooooo0ol0nYX2ooooo`Oo003o6_ooool2o`0000;o0?ZJ00?o0000o`3jV_l0nYX00_ooool2
o`00o`Cooooo0_l0nYX3ooooo`;o0?ZJ2_ooool2o`3jVP;ooooo0_l0nYXAooooo`Co0?ZJ1Oooool2
o`3jVP;o00000ol0nYX2ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo1ol00?l01?l0nY[o0000o`000?oo
ool2o`00o`;ooooo0_l00?l2o`3jVPKooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Yooooo`?o0?ZJ00?oooooo`3jV_l0nYX0FOooool6o`0000Wooooo00?o0000o`3jV_l0nYX01Ol0
nYX2ooooo`?o0?ZJ1?ooool2o`00oa?ooooo0_l00?l?ooooo`Co00000_ooool2o`0002oooooo1?l0
00000ooooooo0000o`000005o`0000;o003o3Oooool00ol0003oooooooooo`0_ooooo`00A_ooool0
0ol0003oooooooooo`09ooooo`;o0?ZJ00?o0000ooooooooool00_l00?l00ol0nY[o0000o`000004
o`3jVP03ooooool0nY[o0?ZJ00oooooo0_l0nYX3ooooo`?o0?ZJ0_l00007o`00ob7ooooo1_l00000
0ooooooo0000o`00o`0;o`00oa[ooooo0_l0nYX2ooooo`Co0?ZJ00?oooooo`3jV_l0nYX00oooool2
o`3jVQ[ooooo0_l00002o`3jVP05o`000?l0nY[o0?ZJo`000?ooool00_l00?l4ooooo`;o0?ZJ0ooo
ool2o`3jVP[ooooo0_l0nYX2ooooo`;o0?ZJ4Oooool4o`3jVPGooooo0_l0nYX2o`0000?o0?ZJ0_oo
ool2o`3jVPGooooo0_l0nYX2ooooo`Oo003o0ol00003o`00o`;ooooo0_l00?l2o`3jVPKooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Zooooo`Go0?ZJFOooool6o`0000[ooooo00?o
0000o`3jV_l0nYX00ol0nYX4ooooo`;o0?ZJ0oooool3o`00oa?ooooo0_l00?l?ooooo`Go000000Co
ooooo`000?l0003o0000;_ooool9o`000003ooooool0003o000000;o003o3Oooool00ol0003ooooo
ooooo`0_ooooo`00A_ooool00ol0003oooooooooo`09ooooo`?o0?ZJ0_ooool2o`00o`03ooooool0
003o000000?o0?ZJ00Co0000ooooool0nY[o0?ZJ3oooool2o`3jVP03ooooool0003o000000?o0?ZJ
0_l00002o`00o`;o000000?oooooo`3jV_l0nYX08Oooool5o`0000;ooooo00Co0000o`3jV_l0nY[o
0?ZJ0ol00?l2o`3jVP;ooooo0_l0nYXJooooo`;o0?ZJ0_ooool4o`3jVP04ooooool0nY[o0?ZJo`3j
VP;ooooo0_l0nYXJooooo`;o00001Ol0nYX01?l0003oooooo`00ool00?l4ooooo`;o0?ZJ0oooool2
o`3jVPWooooo0ol0nYX2ooooo`;o0?ZJ4Oooool4o`3jVPGooooo0_l0nYX2o`0000?o0?ZJ0_ooool2
o`3jVPGooooo0_l0nYX2ooooo`;o003o00?oooooo`000?l000000_l00?l3o`0000;o003o00?o0?ZJ
ooooooooool00ol00?l00ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool0:oooool4o`3jVU[ooooo1Ol0000:ooooo`;o000000Coooooo`000?l0nY[o0?ZJ1?oo
ool2o`3jVP;ooooo0ol00?lDooooo`;o003o0_ooool2o`00o`[ooooo0ol000000ooooooo0000o`00
0004o`0002Kooooo0_l00006ooooo`;o000000Goooooo`000?l0003o0000ooooo`02o`0000?ooooo
0_l00?l=ooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo00[ooooo0_l0
nYX2ooooo`Ko003o0_l0nYX01?l0003oooooo`3jV_l0nYX?ooooo`;o0?ZJ00?oooooo`000?l00000
0ol0nYX2o`0000;o003o00?o0?ZJooooooooool00_l0nYXQooooo`;o00001Oooool2o`0000;o0?ZJ
0_ooool4o`3jVP03ooooool0nY[o0?ZJ01[ooooo0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP04oooo
ool0nY[o0?ZJo`3jVP;ooooo0_l0nYXJooooo`;o00001Ol0nYX01?l0003oooooo`00ool00?l4oooo
o`Oo003o2Oooool2o`3jVP?ooooo0_l0nYXAooooo`Co0?ZJ1?ooool3o`3jVP;o00000ol0nYX2oooo
o`;o0?ZJ1Oooool2o`3jVP;ooooo0_l00?l00ooooooo0000o`000002o`00o`03ooooool0003o0000
00;o003o00Co0?ZJoooooooooooo00000_l00?l00ol0nY[oooooooooo`04ooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool0;Oooool2o`3jVU_ooooo1?l0000:ooooo`Ko00001?ooool2
o`3jVPGo003o2?ooool2o`0000[ooooo3?l00?l4ooooo`;o00000_ooool6o`0000Gooooo0_l0000O
ooooo`;o00001Oooool3o`000004ooooool0003o0000o`0000Kooooo0_l00?l=ooooo`03o`000?oo
oooooooo02oooooo0016ooooo`03o`000?oooooooooo00[ooooo0ol0nYX00ooooooo003oo`00o`04
o`00o`;o0?ZJ0_l00002o`3jVPkooooo0ol0nYX00ooooooo0000o`000003o`3jVP05o`000?l00?oo
003oo`00ool0nYX00_ooool2o`3jVR[ooooo0_l0nYX2ooooo`Co0?ZJ00?oooooo`3jV_l0nYX06_oo
ool2o`3jVP04ooooool0nY[o0?ZJooooo`Oo0?ZJ00?oooooo`3jV_l0nYX06_ooool3o`0000Co0?ZJ
00Go0000ooooool00?oo003oo`3jVP03ooooo`Oo003o2Oooool2o`3jVP?ooooo0_l0nYXAooooo`Co
0?ZJ1?ooool2o`3jVP?o00000_l0nYX3ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo0_l00?l3o`0000Oo
003o00Co0?ZJoooooooooooo00000_l00?l00ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo
01;ooooo0ol0002<ooooo`;o00002oooool5o`0000Cooooo0_l0nYX3o`00o`[ooooo0_l0000:oooo
o`co003o0_ooool4o`0000;ooooo1ol00004ooooo`;o00007_ooool3o`0000Cooooo0ol00006oooo
o`Oo003o3?ooool2o`00037ooooo0016ooooo`03o`000?oooooooooo00_ooooo1Ol0nYX2o`0000So
003o3_ooool2o`3jVP;ooooo0_l00002o`3jVP;o00000_l00?l2o`3jVP;ooooo0_l0nYXZooooo`;o
0?ZJ00?oooooo`3jV_l0nYX01_l0nYXJooooo`Go0?ZJ0_ooool6o`3jVP03ooooool0nY[o0?ZJ01[o
oooo0ol00004o`3jVP05o`000?oooooo003oo`00ool0nYX00_ooool00ol0nY[o003oo`00o`03oooo
o`;o003o2Oooool2o`3jVP?ooooo0_l0nYX8ooooo`;o0?ZJ1_ooool5o`3jVPCooooo0_l0nYX3o`00
00;o0?ZJ0oooool2o`3jVPGooooo0_l0nYX2o`0000;o003o0ol00007o`00o`04o`3jV_l0003ooooo
o`0000;o003o00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo08cooooo0_l0000;ooooo`Go00001?ooool2o`3jVP03o`000?oooooooooo00Wooooo1Ol00006
ooooo`;o00002Oooool01?l0003o003oo`00ooooool4o`0000?ooooo0ol00002ooooo`?o00000_oo
ool4o`0001gooooo1?l00003ooooo`?o00001_ooool7o`00o`gooooo00?o0000ooooooooool0;ooo
ool004Kooooo00?o0000ooooooooool03?ooool5o`3jVP;o00001ol00?l00ol0nY[oooooooooo`02
o`3jVPWooooo3?l00?l2o`3jVP;ooooo0_l0nYXZooooo`Go0?ZJ0_ooool4o`3jVQ_ooooo1?l0nYX2
ooooo`Wo0?ZJ6_ooool4o`0000?o0?ZJ00So0000ooooool00?oo003oo`3jV_oooooo0000o`3jVP;o
003o0oooool2o`00o`Wooooo0_l0nYX3ooooo`;o0?ZJ2?ooool2o`3jVPKooooo0_l0nYX00ooooooo
0?ZJo`3jVP04ooooo`;o0?ZJ0ol00002o`3jVP?ooooo0_l0nYX5ooooo`;o0?ZJ0_l00002o`00o`03
o`3jV_l0003o000000;o0?ZJ00Coooooo`000?l0003ooooo0_l0nYX00ol0003oooooo`000002o`00
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`2<oooo
o`;o00002oooool6o`0000?ooooo0_l0nYX00ol0003oooooooooo`09ooooo`Ko000000?oooooo`00
0?l000001?l00008ooooo`;o00000_l00?l5o`0000Cooooo0_l00003ooooo`;o00000_ooool4o`00
01cooooo2ol00006ooooo`;o003o4_ooool00ol0003oooooooooo`0_ooooo`00A_ooool3o`0000co
oooo1Ol0nYX2o`0000;o0?ZJ00?oooooo`000?l000000_l00?l00ol0nY[oooooo`3jVP02o`3jVPWo
oooo3?l00?l3o`3jVP03ooooool0nY[o0?ZJ02_ooooo1?l0nYX3ooooo`?o0?ZJ6oooool4o`3jVP?o
oooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVQ[ooooo1?l000001Ooooooo0?ZJo`3jV_l0nY[o0000
00;o003o00Co0?ZJooooool0003o0?ZJ0_l00?l3ooooo`;o003o2Oooool00ol0nY[o003oo`00o`04
o`00o`Oooooo0ol0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?ooool2o`3jVP?o00001ol00?l5
ooooo`;o0?ZJ0_l00002o`00o`03o`3jV_l0003o000000;o0?ZJ00Coooooo`000?l0003ooooo0ol0
nYX01Ooooooo0000o`00ool00?oo000000Gooooo0_l0000Dooooo`03o`000?oooooooooo09[ooooo
0_l000000ooooooo0000o`000003ooooo`;o0?ZJ0_l0000:ooooo`ko00001oooool2o`0000;o003o
0_l0000<ooooo`;o00000_ooool4o`0001cooooo0_l000000ooooooo0000o`000006o`0000Kooooo
0_l00?lBooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo00cooooo1Ol0
nYX2o`0000?o0?ZJ00Koooooo`000?l00?oo003oo`3jV_ooool3o`3jVPWooooo0_l00?l3o`000003
ooooool0nY[o0?ZJ00?ooooo1?l0nYX00ooooooo0?ZJo`3jVP0/ooooo`?o0?ZJ1?ooool2o`3jVQco
oooo0ol0nYX4ooooo`;o0?ZJ0_ooool3o`3jVQ[ooooo1?l00002ooooo`;o0?ZJ00Oo0000o`00ool0
0?oo0?ZJooooool0003o0?ZJ00;o003o00?o0?ZJooooooooool00_l00?l9ooooo`Oo003o1oooool3
o`3jVPKooooo0_l0nYX00ooooooo0?ZJo`3jVP04ooooo`co003o1Oooool2o`3jVP05o`000?l00?oo
003oo`00ool0nYX00_l00002o`3jVP04ooooool0003o0000ooooo`?o0?ZJ00?oooooo`000?l00?l0
0_l00?l6ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0WOooool2o`0000?ooooo
0_l0nYX2o`0000Kooooo0_l00002ooooo`;o00000oooool;o`0000Cooooo0ol00002o`00o`;o0000
3?ooool2o`0000;ooooo1?l0000Kooooo`?o00000_ooool5o`0000Sooooo0_l00?lBooooo`03o`00
0?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo00gooooo1?l0nYX2o`0000?o0?ZJ00Co
ooooo`000?l00?oo003o1Ol0nYX9ooooo`;o003o0ol000001?oooooo0?ZJo`3jV_l0nYX2ooooo`Co
0?ZJ00?oooooo`3jV_l0nYX0;Oooool2o`3jVR?ooooo0_l0nYX8ooooo`?o0?ZJ6_ooool4o`0000;o
oooo0_l0nYX01Ol0003o003oo`00ool0nY[ooooo00;o0?ZJ0_l00?l00ol0nY[oooooooooo`02o`00
o`Wooooo0_l00?l3ooooo`;o003o0oooool2o`3jVP;ooooo0ol0nYX5ooooo`?o0?ZJ00?oooooo`3j
V_l0nYX01?ooool6o`00o`04o`3jV_ooooooooooooooo`;o003o1?ooool3o`3jVP03o`000?l00?oo
003o00;o0?ZJ00?o0000ooooool0nYX00_l0nYX2o`000007ooooool0nY[o0?ZJo`3jV_oooooo0000
o`3jVP02o`00o`Kooooo00?o0000ooooooooool04_ooool3o`0009gooooo0_l00002ooooo`03o`00
0?l0nY[o0?ZJ00;o00001_ooool2o`000004ooooool0003o0000o`0000?ooooo2ol00003ooooo`?o
000000Coooooo`00ool00?oo00003Oooool2o`000003ooooool0003o000000?o00006oooool2o`00
00?ooooo1?l00009ooooo`;o003o4Oooool2o`00037ooooo0016ooooo`03o`000?oooooooooo00oo
oooo0_l0nYX2o`0000?o0?ZJ00Coooooo`000?l00?oo003o1Ol0nYX2ooooo`;o00001Oooool2o`00
o`04o`3jV_l0003o0000ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01_l0nYX]ooooo`;o0?ZJ8oooool2
o`3jVPWooooo0_l0nYXKooooo`?o00000_ooool3o`3jVP;o003o00Co0?ZJooooool0nY[o0?ZJ0_l0
0?l00ol0nY[oooooooooo`02o`00o`Wooooo0_l00?l3ooooo`;o003o0oooool2o`3jVP;ooooo0ol0
nYX5ooooo`;o0?ZJ0_ooool2o`3jVPCooooo0_l00?l00ooooooo0000o`000002o`3jVP?ooooo0_l0
0?l4ooooo`;o0?ZJ0_l00002o`00o`;o0?ZJ00?o0000ooooool0nYX00_l0nYX3ooooo`Co0?ZJ00?o
0000o`3jV_l0nYX01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo09gooooo0ol0
00001?oooooo0000o`3jV_l0nYX2o`0000Kooooo1Ol00004ooooo`Oo000000Goooooo`000?l0003o
0000ooooo`05o`000004ooooool00?oo003oo`0000gooooo1Ol000000ooooooo0000o`00000Joooo
o`?o00000oooool3o`0000[ooooo0_l00?lBooooo`03o`000?oooooooooo02oooooo0016ooooo`03
o`000?oooooooooo00oooooo2?l0nYX01_l0003o003oo`00ool00?oo0?ZJooooo`;o0?ZJ0_ooool2
o`0000Gooooo0_l00?l01?l0nY[o0000o`000?ooool3o`3jVP03ooooool0nY[o0?ZJ00;ooooo1?l0
nYYjooooo`?o00000oooool2o`3jVP;o003o1?l0nYX2o`00o`03o`3jV_oooooooooo00;o003o2Ooo
ool2o`00o`03o`000?oooooooooo00;o003o0_ooool3o`3jVP;ooooo0ol0nYX5ooooo`;o0?ZJ00Co
0000ooooool0nY[o0?ZJ0oooool01?l0nY[o003oo`00ooooool2o`0000;o0?ZJ0oooool2o`00o`Co
oooo0_l0nYX2o`0000;o003o0_l0nYX00ol0003oooooo`3jVP02o`3jVP?ooooo1?l0nYX00ol0003o
0?ZJo`3jVP07ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0W_ooool2o`000004
ooooool0003o0?ZJo`3jVP;o00001Oooool6o`0000Cooooo0_l000000ooooooo0000o`000003oooo
o`?o000000?oooooo`000?l000000_l00002ooooo`;o003o00?o0000ooooooooool03?ooool4o`00
0003ooooool0003o000001[ooooo0_l00004ooooo`?o00002_ooool2o`00oa;ooooo00?o0000oooo
ooooool0;oooool004Kooooo00?o0000ooooooooool03oooool00ol0003o0?ZJo`3jVP02o`3jVP05
ooooool0nY[o0?ZJo`3jV_l000000_l00?l01?l0nY[oooooo`3jV_l0nYX2ooooo`03o`000?l0nY[o
0?ZJ00Cooooo0_l00?l01?l0nY[o0000o`000?ooool3o`3jVP03ooooool0nY[o0?ZJ00?ooooo0ol0
nYYjooooo`?o00000oooool2o`3jVP;o003o0ol0nYX01?l0003o003oo`00ool0nYX2ooooo`;o003o
2?ooool01?l0nY[o003oo`00ool00002ooooo`;o003o0_ooool3o`3jVP03ooooool0nY[o0?ZJ00;o
0?ZJ1Oooool2o`3jVP04o`000?oooooo0?ZJo`3jVP?ooooo00?o0?ZJo`00ool00?l00oooool2o`3j
VP?ooooo0_l00?l4ooooo`;o0?ZJ0_l00002o`00o`;o0?ZJ00?o0000ooooool0nYX00_l0nYX3oooo
o`Co0?ZJ00Co0000o`3jV_l0nY[o0?ZJ1_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo09kooooo1?l00002o`3jVP?o00001?ooool6o`0000Oooooo0_l00004ooooo`;o000000Cooooo
o`000?l0003o00000oooool2o`00o`oooooo1?l000001?oooooo0000o`000?ooool2o`0001Oooooo
0_l00005ooooo`;o00002_ooool2o`00oa;ooooo00?o0000ooooooooool0;oooool004Kooooo00?o
0000ooooooooool03oooool2o`0000?o0?ZJ0_ooool2o`3jVP03o`000?l00?oo003o00;ooooo0_l0
nYX2ooooo`?o0?ZJ00Coooooo`000?l0003o00000_l00?l01?l0nY[o0000o`000?ooool3o`3jVP03
ooooool0nY[o0?ZJ00?ooooo0ol0nYYjooooo`?o00000oooool00ol0003o0?ZJo`00o`02o`00o`;o
0?ZJ00Co0000o`00ool00?oo0?ZJ0_ooool2o`00o`Sooooo00Co0?ZJo`00ool00?oo00000_ooool2
o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX5ooooo`;o0?ZJ00Co0000
ooooool0nY[o0?ZJ0oooool00ol0nY[o003oo`00o`03ooooo`;o0?ZJ0oooool2o`00o`Cooooo0_l0
nYX2o`0000;o003o0_l0nYX00ol0003oooooo`3jVP02o`3jVP;ooooo2Ol0nYX6ooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool0Woooool3o`0000;o0?ZJ00Coooooo`000?l0003o0000
0oooool2o`000004ooooool0003o0000o`0000gooooo0_l000001?oooooo0000o`000?l00003oooo
o`;o003o4?ooool3o`000004ooooool0003o0000ooooo`;o00005oooool2o`00017ooooo0_l00?lB
ooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo017ooooo0ol0nYX2oooo
o`?o0?ZJ0_l00?l00ol0003oooooo`3jVP06o`3jVP04ooooool0003o0000o`0000;o003o0_l0nYX0
0ol0003o0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_l0nYYkooooo`;o00000oooool0
0ol0003o0?ZJo`3jVP02o`00o`;o0?ZJ00?oooooo`00ool00?l00_l0nYX00ooooooo003oo`00o`08
ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo0_l00?l00ooooooo0?ZJo`3jVP02o`3jVP03ooooool0
nY[o0?ZJ00;o0?ZJ1Oooool2o`3jVP;o00000_l0nYX3ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo
0ol0nYX2ooooo`;o003o1?ooool6o`00o`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2o`3jVP03
ooooool0003o0?ZJ00Co0?ZJ1_ooool00ol0003oooooooooo`0Booooo`?o0000X?ooool2o`0000;o
0?ZJ00?oooooo`000?l000000ol000001?oooooo0000o`000?ooool2o`0000kooooo1Ol00004oooo
o`;o003o4?ooool2o`0000;ooooo1Ol00002ooooo`;o00004Oooool7o`00o`kooooo0_l00?lAoooo
o`;o0000<Oooool004Kooooo00?o0000ooooooooool04_ooool2o`3jVP?ooooo0_l0nYX2o`00o`03
o`000?oooooooooo00Ko0?ZJ0ol000000ol0nY[o003oo`00o`02o`3jVP03o`000?l0nY[o0?ZJ00Go
0?ZJPOooool2o`0000?ooooo00?o0000o`3jV_l0nYX00_l00?l00ol0nY[o0000ooooo`02o`00o`;o
0?ZJ00?oooooo`00ool00?l02?ooool01?l0nY[o003oo`00ool0nYX2ooooo`;o003o00?oooooo`3j
V_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPGooooo0_l0nYX2o`0000;o0?ZJ0_ooool2o`3j
VP;o003o00?o0?ZJooooooooool00ol0nYX2ooooo`;o003o00Co0?ZJoooooooooooooooo1_l00?l3
o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo0_l0nYX00ooooooo0000o`3jVP04o`3jVPKooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`2Rooooo`;o0?ZJ00?oooooo`000?l000001_l0
00000ooooooo0000o`00000?ooooo`Co00001?ooool2o`00oaGooooo2Ol0000@ooooo`Oo003o3_oo
ool2o`00oa;ooooo00?o0000ooooooooool0;oooool004Kooooo0ol0000Booooo`;o0?ZJ0oooool2
o`3jVPGo003o1_l0nYX2o`0000;o0?ZJ0_l00?l5o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJPOooool2
o`0000Cooooo0_l0nYX2o`00o`03o`3jV_l0003o003o00;o003o0_l0nYX00ooooooo003oo`00o`08
ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo0_l00?l00ooooooo0?ZJo`3jVP07o`3jVPGooooo0_l0
nYX2o`0000;o0?ZJ0_ooool2o`3jVP;o003o00?o0?ZJooooooooool00ol0nYX2ooooo`;o003o00Co
0?ZJoooooooooooo0?ZJ0_l00?l00ol0003oooooooooo`04o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ
00?oooooo`3jV_l0nYX00_ooool00ol0003o0?ZJo`3jVP02o`3jVPGooooo0_l000000ooooooo0000
o`000004ooooo`03o`000?oooooooooo00?ooooo0ol00004ooooo`03o`000?oooooooooo0:;ooooo
0_l0nYX00ooooooo0000o`000005o`0001?ooooo1?l00004ooooo`;o003o5Oooool9o`00013ooooo
0_l00?l00ol0003oooooooooo`02o`00o`kooooo0_l00?lBooooo`03o`000?oooooooooo02oooooo
0016ooooo`03o`000?oooooooooo01Oooooo00?o0000o`3jV_l00?l01Ol00?l2o`3jVP04o`000?l0
nY[o0?ZJo`0000?o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ
POooool2o`0000Cooooo00Ko0000o`3jV_l00?oo003oo`3jV_l00002o`00o`?o0?ZJ00Coooooo`00
ool00?oo0?ZJ1oooool01?l0nY[o003oo`00ool0nYX2ooooo`;o003o00?oooooo`3jV_l0nYX01?l0
nYX00ooooooo0?ZJo`3jVP04ooooo`?o0?ZJ0_l00002o`3jVP;ooooo0_l0nYX2o`00o`03o`3jV_oo
oooooooo00?o0?ZJ0_ooool2o`00o`04o`3jV_ooooooooooo`3jVP;o003o00?o0000ooooooooool0
1?l0nYX00ooooooo0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00;ooooo00?o0000o`3jV_l0nYX0
2?ooool2o`0000;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo0:;ooooo0_l0nYX4ooooo`Co00005?ooool2o`0000Gooooo0_l00?lEooooo`Wo0000
00?oooooo`000?l000003?ooool01?l0003o003oo`00ool00002ooooo`;o003o2_ooool6o`00oa;o
oooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool05oooool2o`0000;o0?ZJ
00Co0000o`00ool00?oo003o0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP04ooooool00?oo003ooooo
o`Co0?ZJ0_ooool3o`3jVX7ooooo0_l00004ooooo`06o`000?l0nY[o003oo`00ool0nY[o00000_l0
0?l3o`3jVP04ooooool00?oo003oo`3jVPOooooo00Ko0?ZJo`00ool00?oo0?ZJo`000?ooool2o`00
o`03ooooool0nY[o0?ZJ00Co0?ZJ00?oooooo`3jV_l0nYX01?ooool2o`3jVP?o00000ol0nYX00ooo
oooo0?ZJo`3jVP02o`00o`03o`3jV_oooooooooo00?o0?ZJ0_ooool2o`00o`04o`3jV_oooooo0?ZJ
o`3jVP;o003o0oooool4o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00?oooooo`3jV_l0nYX00oooool2
o`3jVPSooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo1Ol00004ooooo`03o`000?oooooo
oooo0:;ooooo0_l0nYX4ooooo`Co00006oooool2o`00oaGooooo1_l000000ooooooo0000o`000005
o`0000[ooooo00?o0000o`00ool00?l00oooool2o`00o`Wooooo1ol00?lBooooo`03o`000?oooooo
oooo02oooooo0016ooooo`03o`000?oooooooooo01Sooooo00?o0000o`3jV_l0nYX00_l00002o`00
o`;o0?ZJ00?oooooo`000?l0nYX00ol0nYX01?oooooo003oo`00ooooool4o`3jVP?ooooo0_l0nYZ1
ooooo`;o00001?ooool01_l0003o0?ZJo`00ool00?oo0?ZJo`0000;o003o0ol0nYX01?oooooo003o
o`00ool0nYX7ooooo`06o`3jV_l00?oo003oo`3jV_l0003ooooo0_l00?l00ooooooo0?ZJo`3jVP04
o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_l0nYX3o`000004ooooool0nY[o0?ZJooooo`;o0?ZJ0_l0
0?l00ol0nY[oooooooooo`03o`3jVP;ooooo0_l00?l01?l0nY[oooooo`3jV_l0nYX2o`00o`?ooooo
1?l0nYX00ooooooo0?ZJo`3jVP05o`3jVP?ooooo0_l0nYX8ooooo`;o00000_ooool00ol0003ooooo
ooooo`05ooooo`04o`000?ooooooooooo`0000Gooooo0ol0002Rooooo`;o0?ZJ1Oooool2o`0001co
oooo0_l00?lFooooo`;o00001Oooool00ol0003o003oo`00o`05o`000004ooooool0003o0000o`00
00Cooooo00?o0000o`00ool00?l00oooool2o`00o`Wooooo0_l00?lEooooo`?o0000<Oooool004Ko
oooo00?o0000ooooooooool06?ooool00ol0003o0?ZJo`3jVP02o`0000?o003o00?o0?ZJooooool0
00000ol0nYX2ooooo`;o003o0_ooool3o`3jVP?ooooo0_l0nYZ1ooooo`;o00001?ooool01_l0003o
0?ZJo`00ool00?oo0?ZJo`0000;o003o1?l0nYX2o`00o`03o`3jV_oooooooooo00Cooooo0_l0nYX2
o`00o`03o`3jV_l0003ooooo00;o003o1ol0nYX00ooooooo0?ZJo`3jVP04ooooo`;o0?ZJ0ol00000
0ooooooo0?ZJo`3jVP03o`3jVP;o003o00?o0?ZJooooooooool00ol0nYX2ooooo`;o003o00Co0?ZJ
ooooool0nY[o0?ZJ0_l00?l3ooooo`Co0?ZJ00Coooooo`3jV_l0nY[ooooo1?l0nYX=ooooo`;o0000
0_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0
X_ooool2o`3jVQCooooo0_l0nYX=ooooo`;o003o5_ooool2o`000003ooooool00?oo003o00Go003o
2ol000000ooooooo0000o`00o`02o`00o`?ooooo0_l00?l9ooooo`;o003o5oooool00ol0003ooooo
ooooo`0_ooooo`00A_ooool00ol0003oooooooooo`0Hooooo`03o`000?l0nY[o0?ZJ00?o00001_l0
0?l2o`3jVP;ooooo0_l00?l2ooooo`?o0?ZJS?ooool01_l0003o0?ZJo`00ool00?oo0?ZJo`0000;o
003o00Co0?ZJo`000?l0nY[o0?ZJ0_l00?l00ol0nY[oooooooooo`02o`3jVP;ooooo0_l0nYX2o`00
o`03o`3jV_l0003ooooo00;o003o0_l0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`;o0?ZJ1?ooool2
o`3jVP?o000000?oooooo`3jV_l0nYX00_l0nYX01?l0003o003oo`00ool0nYX2ooooo`Co0?ZJ00Go
ooooo`00ool00?oo0?ZJo`000002o`3jVP;o003o00?o0?ZJooooooooool01ol0nYX00ooooooo0?ZJ
o`3jVP02o`3jVPgooooo0_l00002ooooo`03o`000?oooooooooo00Oooooo0_l00005ooooo`03o`00
0?oooooooooo0:;ooooo0_l0nYXDooooo`Go0?ZJ2_ooool2o`00oaCooooo3?l00?l;o`000004oooo
ool0003o003oo`00o`Cooooo0_l00?l9ooooo`;o003o5oooool00ol0003oooooooooo`0_ooooo`00
<oooool3o`0000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo01Sooooo00Co0000o`3jV_l0nY[o0?ZJ0_l0000<o`00o`?ooooo0_l0nYZ<ooooo`06
o`000?l0nY[o003oo`00ool0nY[o00000_l00?l01?l0nY[o0000o`3jV_l0nYX2o`00o`03o`3jV_oo
oooooooo00;o0?ZJ0_ooool2o`3jVP;o003o0_l0nYX00ooooooo003oo`00o`02o`3jVP;ooooo0_l0
nYX2ooooo`;o0?ZJ1?ooool7o`00o`?o0?ZJ00Co0000o`00ool00?oo0?ZJ0_ooool4o`3jVP05oooo
ool00?oo003oo`3jV_l000000_l0nYX2o`00o`03o`3jV_oooooo0?ZJ00;o0?ZJ00?oooooo`3jV_l0
nYX00_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPgooooo00Co0000ooooool0003o00002oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo0:;ooooo0_l0nYXDooooo`Ko0?ZJ2Oooool2o`00
oaCooooo1_l00?l4ooooo`;o003o0_l00002ooooo`;o000000?oooooo`000?l000001?l00002o`00
o`Cooooo0_l00?l9ooooo`;o003o5oooool00ol0003oooooooooo`0_ooooo`00=?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool06?ooool2o`0000;o
0?ZJ0_l00003o`3jVP03ooooool0003o003o00Ko003oTOooool2o`0000;o003o00Ko0?ZJo`000?l0
0?oo003oo`3jV_l00002o`3jVP;o003o00?o0?ZJooooool0nYX00_l0nYX01?oooooo0?ZJo`3jV_l0
nYX2o`00o`;o0?ZJ00?oooooo`00ool00?l00_l0nYX2ooooo`;o0?ZJ0_ooool2o`3jVPCooooo1ol0
0?l3o`3jVP05o`000?l00?oo003oo`3jV_ooool01Ol0nYX01Ooooooo003oo`00ool0nY[o000000;o
0?ZJ0_l00?l01?l0nY[oooooo`3jV_l0nYX2ooooo`Co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX=oooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0X_ooool2o`3jVQCooooo0_l0nYX01?oo
oooo0?ZJo`3jV_l0nYX9ooooo`;o003o5?ooool2o`00o`Sooooo0_l00?l4ooooo`Ko003o0ol00002
o`00o`Cooooo0_l00?l9ooooo`;o003o5oooool00ol0003oooooooooo`0_ooooo`00<Oooool5o`00
00[ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Hooooo`;o00000ol0nYX01?l0
003o0?ZJo`3jV_l0nYX2ooooo`?o0?ZJ0_ooool2o`00oi7ooooo0_l00002o`00o`05o`3jV_oooooo
003oo`00ool0nYX00_l000001Ol0nY[o003oo`00ool0nY[ooooo00?o0?ZJ00Coooooo`3jV_l0nY[o
00000_l00?l2o`3jVP03ooooool00?oo003o00;o0?ZJ0_ooool2o`3jVP;ooooo0_l0nYX4ooooo`;o
003o00?oooooo`000?l000000_l00?l3o`3jVP05o`000?l00?oo003oo`3jV_ooool00_l0nYX01?l0
003o0?ZJo`3jV_ooool2o`00o`04o`3jV_l0003o0?ZJo`3jVP;o003o00Co0?ZJooooool0nY[o0?ZJ
0_ooool4o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ3Oooool00ol0003oooooooooo`0Booooo`?o0000
X_ooool2o`3jVQCooooo0_l0nYX2ooooo`;o0?ZJ2Oooool2o`00oaCooooo0_l00?l8ooooo`;o003o
1?ooool6o`00o`;o000000?oooooo`00ool00?l01?ooool2o`00o`Sooooo0ol00?lFooooo`;o0000
<Oooool0037ooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`03ooooo`?o0000
6?ooool2o`000003ooooool0nY[o0?ZJ00Co0?ZJ0_ooool3o`3jVP;ooooo0_l0nYZAooooo`;o0000
0_l00?l01Ol0003oooooo`00ool00?oo0?ZJ00;o000000Go0?ZJo`00ool00?oo0?ZJooooo`03o`3j
VP04ooooool0nY[o0?ZJo`0000;o003o0_l0nYX01?oooooo003oo`00ool0nYX3ooooo`;o0?ZJ0_oo
ool2o`3jVPCooooo0_l00?l00ooooooo0000o`000002o`00o`;o0?ZJ00Ko0000o`00ool00?oo003o
o`3jV_ooool2o`3jVP04o`000?l0nY[o0?ZJooooo`;o003o1?l0nYX2o`00o`04o`3jV_oooooo0?ZJ
o`3jVP?ooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVP_ooooo0ol0000Dooooo`03o`000?oooooo
oooo0:;ooooo0_l0nYXCooooo`?o0?ZJ0_ooool2o`3jVPWooooo0_l00?lDooooo`;o003o2?ooool2
o`00o`Cooooo0_l00?l2ooooo`?o003o0_ooool2o`00o`Cooooo0_l00?l8ooooo`;o003o6?ooool0
0ol0003oooooooooo`0_ooooo`00<_ooool00ol0003oooooo`00000<ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool06?ooool2o`0000;ooooo1Ol0nYX2ooooo`?o0?ZJ0_ooool2o`3j
VY;ooooo00Go0000o`00ool00?oo0000ooooo`02o`00o`04o`3jV_l0003o0000ooooo`;o003o00?o
0?ZJooooool0nYX00_l0nYX01?oooooo0?ZJo`3jV_l00002o`00o`;o0?ZJ00Coooooo`00ool00?oo
0?ZJ0oooool2o`3jVP;ooooo0_l0nYX4ooooo`;o003o0_ooool00ol0003o003oo`00o`02o`3jVP03
o`000?l00?oo003o00;o0?ZJ00Coooooo`3jV_l0nY[o00000_l0nYX00ooooooo003oo`00o`03o`3j
VP05o`000?l00?oo003oo`3jV_ooool00_l0nYX3ooooo`?o0?ZJ0_ooool3o`3jVPgooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`2Rooooo`;o0?ZJ4oooool2o`3jVP?ooooo0_l0nYX9
ooooo`;o003o5?ooool2o`00o`Sooooo0_l00?l4ooooo`;o003o0oooool6o`00o`Cooooo0_l00?l8
ooooo`;o003o6?ooool00ol0003oooooooooo`0_ooooo`00<oooool2o`0000Sooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo01Sooooo0_l00002ooooo`_o0?ZJ00?ooooo
o`3jV_l0nYX0T_ooool00ol0003o003oo`00o`04o`00o`04o`3jV_l0003o0000o`0000;o003o00?o
0?ZJooooool0nYX01Ol0nYX3o`00o`;o0?ZJ00Coooooo`00ool00?oo0?ZJ0oooool2o`3jVP;ooooo
0_l0nYX4ooooo`;o003o0_ooool00ol0003o003oo`00o`02o`3jVP03o`000?l00?oo003o00Go0?ZJ
00Co0000o`3jV_l0nY[o0?ZJ0ol00?l2o`3jVP05o`000?l00?oo003oo`3jV_ooool00_l0nYX3oooo
o`?o0?ZJ0_ooool3o`3jVPgooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`2Roooo
o`;o0?ZJ3_ooool4o`3jVP03ooooool0nY[o0?ZJ00?ooooo0_l0nYX9ooooo`;o003o4oooool3o`00
o`Sooooo0_l00?l4ooooo`;o003o0oooool5o`00o`Gooooo0_l00?l8ooooo`;o003o6?ooool00ol0
003oooooooooo`0_ooooo`00=?ooool00ol0003oooooooooo`06ooooo`Go00001?ooool00ol0003o
ooooooooo`0Mooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX01?oooooo0?ZJo`3jV_ooool2o`3j
VY;ooooo00?o0000o`00ool00?l01?l00?l01?oooooo0000o`000?l00003o`00o`03ooooool0nY[o
0?ZJ00?o0?ZJ00?o0000o`00ool00?l00ol0nYX01?oooooo003oo`00ool0nYX3ooooo`;o0?ZJ0_oo
ool2o`3jVPCooooo0_l00?l2ooooo`03o`000?l00?oo003o00;o0?ZJ00?o0000o`00ool00?l01Ol0
nYX2o`0000;o0?ZJ00?o0000o`00ool00?l00_l0nYX01Ol0003o003oo`00ool0nY[ooooo00;o0?ZJ
1?ooool2o`3jVP;ooooo0ol0nYX=ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
X_ooool2o`3jVPkooooo1ol0nYX3ooooo`;o0?ZJ2Oooool2o`00oa?ooooo0_l00?l9ooooo`;o003o
0oooool3o`00o`gooooo0_l00?l00ooooooo003oo`00o`07o`00oaSooooo00?o0000ooooooooool0
;oooool004Kooooo00?o0000ooooooooool08Oooool3o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJT_oo
ool01Ol0003o0?ZJo`3jV_l0003ooooo00;o0?ZJ00Goooooo`000?l0003o0000o`3jVP02o`00o`Ko
0?ZJ00?o0000o`00ool00?l00ol0nYX01?oooooo003oo`00ool0nYX2ooooo`03o`000?l0nY[o0?ZJ
00;ooooo0_l0nYX4ooooo`;o003o00?o0?ZJooooool000000_l00?l00ol0nY[oooooo`000002o`00
o`Go0?ZJ00Goooooo`000?l0nY[o0?ZJo`000002o`00o`;o0?ZJ00Go0000o`00ool00?oo0?ZJoooo
o`02o`3jVPWooooo0_l0nYX=ooooo`03o`000?oooooooooo01;ooooo0ol0002Rooooo`;o0?ZJ3_oo
ool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0oooool2o`3jVPWooooo0_l00?l5ooooo`Go003o2Ooo
ool2o`00o`Wooooo0_l00?l3ooooo`;o003o3_ooool<o`00oa3ooooo0_l0nYX5ooooo`;o0000<Ooo
ool004Kooooo00?o0000ooooooooool08_ooool2o`3jVP;ooooo1?l0nYZBooooo`05o`000?l0nY[o
0?ZJo`000?ooool00_l0nYX01Ooooooo0000o`000?l0003o0?ZJ00;o003o1_l0nYX00ol0003o003o
o`00o`04o`3jVP;o003o00Co0?ZJooooool0003o00000_l0nYX2ooooo`;o0?ZJ1?ooool2o`00o`03
o`3jV_oooooo000000;o003o00?o0?ZJooooool000000_l00?l5o`3jVP03ooooool0003o0?ZJ00;o
0?ZJ0_l00?l00ol0nY[o0000o`000002o`00o`04o`3jV_oooooo0?ZJo`3jVQSooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`2Rooooo`;o0?ZJ3_ooool2o`3jVP?ooooo0_l0nYX3oooo
o`;o0?ZJ2Oooool2o`00o`Cooooo1_l00?l9ooooo`;o003o2Oooool2o`00o`?ooooo0_l00?l>oooo
o`Co003o0_ooool3o`00oa;ooooo0ol0nYX6ooooo`03o`000?oooooooooo02oooooo0016ooooo`03
o`000?oooooooooo02;ooooo0_l0nYX3ooooo`?o0?ZJT_ooool01Ol0003o0?ZJo`3jV_l0003ooooo
00;o0?ZJ00Goooooo`000?l0003o0000o`3jVP02o`00o`Ko0?ZJ00Go0000o`00ool00?oo0?ZJo`00
0002o`3jVP;o003o00Co0?ZJooooool0003o00000_l0nYX2ooooo`;o0?ZJ1?ooool2o`00o`03o`3j
V_oooooo000000;o003o00?o0?ZJo`000?l000000_l00?l00ol0nY[oooooo`3jVP02o`3jVP03oooo
ool0003o000000;o0?ZJ0_l00?l00ol0nY[o0000o`00o`02o`00o`04o`3jV_oooooo0?ZJo`3jVQSo
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`2Rooooo`;o0?ZJ3_ooool2o`3jVPSo
oooo0_l0nYX9ooooo`;o003o1?ooool3o`00o`03ooooool00?oo003o00Oooooo1?l00?l9ooooo`Oo
003o:Oooool2o`3jVPOooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0
_Oooool3o`3jVP04ooooool0nY[o0?ZJooooo`?o000000?o0?ZJo`00ool00?l01_l0nYX01Ol0003o
003oo`00ool0nY[o000000;o0?ZJ0_l00?l01?l0nY[oooooo`000?l00006o`00o`04ooooool0003o
0000ooooo`;o003o00?o0?ZJooooool000000ol00?l2o`0000;o003o00?o0?ZJooooool0nYX00_l0
nYX00ooooooo0000o`000002o`3jVP;o003o00Co0?ZJo`000?l00?oo003o0_l0nYX00ooooooo0?ZJ
o`3jVP0Hooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0X_ooool2o`3jVPgooooo
0ol0nYX8ooooo`;o0?ZJ2Oooool2o`00o`Cooooo0_l00?l2ooooo`?o003o0oooool7o`00o`Wooooo
1ol00?lYooooo`;o0?ZJ1oooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003ooooooooo
o`2nooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo0ol000000ol0nY[o003oo`00o`06o`3jVP05o`00
0?l00?oo003oo`3jV_l000000_l0nYX2o`00o`04o`3jV_oooooo0000o`0000Ko003o00Coooooo`00
0?l0003ooooo0_l00?l01?l0nY[oooooo`000?l00002o`00o`;o00000_l00?l00ol0nY[oooooo`3j
VP02o`3jVP03ooooool0003o000000;o0?ZJ0_l00?l01?l0nY[o0000o`00ool00?l5o`3jVQSooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`2Rooooo`;o0?ZJ3Oooool2o`3jVPWooooo
0_l0nYX9ooooo`;o003o1?ooool2o`00o`?ooooo0_l00?l3ooooo`Co003o3?ooool3o`00obgooooo
0_l0nYX7ooooo`03o`000?oooooooooo02oooooo0016ooooo`?o0000__ooool2o`3jVP04ooooool0
nY[o0?ZJooooo`?o000000Co0?ZJo`00ool00?oo0?ZJ0_ooool3o`3jVP04o`000?l00?oo003oo`3j
VP;o000000Go0?ZJo`00ool00?oo0000ooooo`02o`0000;o003o0_ooool2o`00o`04o`3jV_l0003o
0000ooooo`;o003o00Co0?ZJooooool0003o00000_l00?l2o`0000;o003o00?o0?ZJooooooooool0
0_l0nYX01Ooooooo0000o`000?l0003o0?ZJ00;o003o0_ooool2o`00o`Go0?ZJ5oooool2o`0001Co
oooo0ol0002Rooooo`;o0?ZJ3Oooool2o`3jVPWooooo0_l0nYX9ooooo`;o003o1?ooool2o`00o`?o
oooo1ol00?lnooooo`;o0?ZJ1_ooool2o`00037ooooo0016ooooo`03o`000?oooooooooo0;kooooo
0_l0nYX01?oooooo0?ZJo`3jV_ooool3o`000004o`3jV_l00?oo003oo`3jVP;ooooo0ol0nYX01?l0
003o003oo`00ool0nYX2o`000003o`3jV_l00?oo003o00?o00000ol00?l2ooooo`;o003o00Co0?ZJ
o`000?l0003ooooo0_l00?l01?l0nY[oooooo`000?l00002o`00o`;o00000_l00?l00ol0nY[ooooo
ooooo`02o`3jVP05ooooool0003o0000o`000?l0nYX00_l00?l2ooooo`;o003o1Ol0nYXHooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool0X_ooool2o`3jVPWooooo1_l0nYX9ooooo`?o
0?ZJ2?ooool2o`00o`?ooooo0ol00?l3ooooo`Ko003o?oooool2o`3jVPOooooo00?o0000oooooooo
ool0;oooool004Kooooo00?o0000ooooooooool0__ooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo
0_l000001?l0nY[o003oo`00ool0nYX2ooooo`?o0?ZJ00Oo0000o`00ool00?oo0?ZJooooool0003o
0?ZJ00;o003o0ol00002o`00o`03o`3jV_oooooooooo00;o003o00Co0?ZJo`000?l0003o0?ZJ0_l0
0?l01?l0nY[oooooooooooooool2o`00o`;o00000_l00?l00ol0nY[oooooooooo`02o`3jVP05oooo
ool0003o0000o`000?l0nYX00_l00?l2ooooo`;o003o1Ol0nYXHooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0X_ooool2o`3jVPCooooo0_l0nYX3ooooo`Ko0?ZJ2_ooool2o`3jVPSo
oooo0_l00?l3ooooo`;o003oBOooool2o`3jVPOooooo00?o0000ooooooooool0;oooool004Kooooo
00?o0000ooooooooool0__ooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l000001?l0nY[o003o
o`00ool0nYX2ooooo`?o0?ZJ00Go0000o`00ool00?oo0?ZJooooo`02o`0000;o003o00?o0000o`00
ool00?l00_l00?l00ol0nY[oooooooooo`02o`00o`04o`3jV_l0003o0000o`3jVP;o003o0_l0nYX2
ooooo`;o003o0_l00002o`00o`03o`3jV_oooooooooo00;o0?ZJ00Goooooo`000?l0003o0000o`3j
VP02o`00o`;ooooo0_l00?l5o`3jVQSooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`2Rooooo`;o0?ZJ1?ooool7o`3jVP04ooooool0nY[o0?ZJo`3jVP[ooooo0_l0nYX8ooooo`;o003o
0oooool2o`00odWooooo0_l0nYX7ooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oo
oooooooo0;kooooo0_l0nYX00ooooooo0?ZJo`3jVP04ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo
0ol0nYX01Ol0003o003oo`00ool0nY[ooooo00;o00001ol00?l00ol0nY[oooooooooo`02o`00o`04
o`3jV_l0003o0000o`3jVP;o003o0_l0nYX2ooooo`;o003o0_l00002o`00o`03o`3jV_oooooooooo
00?ooooo0ol000000ol0nY[o003oo`00o`02ooooo`;o003o00?o0?ZJooooool0nYX00_l0nYXHoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0X_ooool2o`3jVPCooooo1_l0nYX?oooo
o`;o0?ZJ2?ooool2o`00o`03ooooool00?oo003o00;o003oB?ooool3o`3jVPOooooo00?o0000oooo
ooooool0;oooool004Kooooo00?o0000ooooooooool0__ooool2o`3jVP03ooooool0nY[o0?ZJ00Co
oooo00?o0?ZJo`00ool00?l00oooool3o`3jVP05ooooool00?oo003oo`3jV_ooool00_l00005o`00
o`03ooooool0nY[o0?ZJ00;ooooo0_l00?l01?l0nY[o0000o`3jV_l0nYX2o`00o`;o0?ZJ0_ooool2
o`00o`;o00000_l00?l00ol0nY[oooooooooo`03ooooo`?o000000?o0?ZJo`00ool00?l00_ooool2
o`00o`03o`3jV_oooooo0?ZJ00;o0?ZJ6?ooool00ol0003oooooooooo`0Booooo`?o0000X_ooool3
o`3jVP?ooooo0_l0nYXCooooo`;o0?ZJ2?ooool7o`00odSooooo0_l0nYX7ooooo`;o0000<Oooool0
04Kooooo00?o0000ooooooooool0__ooool2o`3jVP03ooooool0nY[o0?ZJ00Cooooo00?o0000o`00
ool00?l00oooool2o`3jVP06o`000?oooooo003oo`00ool0nY[ooooo0_l00002o`3jVP?o000000?o
ooooo`3jV_l0nYX00_ooool2o`00o`04o`3jV_l0003o0?ZJo`3jVP;o003o0_l0nYX2ooooo`Ko003o
1_ooool3o`000003o`3jV_l00?oo003o00;ooooo0_l00?l00ol0nY[oooooo`3jVP02o`3jVQSooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`2Sooooo`;o0?ZJ0_ooool3o`3jVQ?ooooo
0_l0nYX8ooooo`Co003oBoooool2o`3jVPSooooo00?o0000ooooooooool0;oooool004Kooooo00?o
0000ooooooooool0__ooool2o`3jVP03ooooool0nY[o0?ZJ00Cooooo00?o0000o`00ool00?l00ooo
ool2o`3jVP04o`000?oooooo003oo`00o`;ooooo0_l00002o`3jVP?o000000?oooooo`3jV_l0nYX0
0_ooool2o`00o`Co0?ZJ0_l00?l3o`3jVP03ooooool00?oo003o00Co003o1_ooool4o`0000;o003o
0_ooool2o`00o`03o`3jV_oooooooooo00;o0?ZJ6?ooool01?l0003oooooo`000?l00004ooooo`03
o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo0:?ooooo1_l0nYXDooooo`;o
0?ZJEoooool2o`3jVPSooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0
__ooool5o`3jVPCooooo00?o0000o`00ool00?l00oooool2o`3jVP04o`000?oooooo003oo`00o`;o
oooo0_l00002o`3jVP?o000000?oooooo`3jV_l0nYX00_ooool2o`00o`?o0?ZJ00Co0000o`00ool0
0?oooooo0_l0nYX01Ooooooo003oo`00ool00?oooooo00;o0?ZJ1_ooool4o`0000;o003o0_ooool2
o`00o`03o`3jV_oooooooooo00;o0?ZJ6?ooool2o`0000;ooooo00?o0000ooooooooool01Oooool0
1Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0Y?ooool5o`3jVQCooooo0_l0
nYYGooooo`;o0?ZJ2?ooool00ol0003oooooooooo`0_ooooo`00A_ooool3o`000;oooooo1?l0nYX4
ooooo`03o`000?l00?oo003o00?ooooo0_l0nYX01?l0003oooooo`00ool00?l2ooooo`;o00000_l0
nYX3o`000003ooooool0nY[o0?ZJ00;ooooo0_l00?l3o`3jVP04o`000?l00?oo003oooooo`;o0?ZJ
00Goooooo`3jV_l0nY[o0000ooooo`02o`3jVPKooooo1?l00002o`00o`;ooooo0_l00?l00ol0nY[o
ooooooooo`02o`3jVQOooooo0ol00002ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`2Uooooo`Co0?ZJ5?ooool2o`3jVU?ooooo0_l0nYX2ooooo`;o
0?ZJ2?ooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`2oooooo`Co0?ZJ
1?ooool00ol0003o003oo`00o`03ooooo`Ko003o0_ooool2o`0000?o0?ZJ00?o0000ooooooooool0
0_l0nYX01?l0003oooooo`00ool00?l3o`3jVP04o`000?l00?oo003oooooo`;o0?ZJ00Goooooo`3j
V_l0nY[o0000ooooo`02o`3jVPKooooo1?l00002o`00o`;ooooo0_l00?l00ol0nY[oooooooooo`02
o`3jVQSooooo0_l00002ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool3
o`000;gooooo0_l0nYYCooooo`?o0?ZJ00?oooooo`3jV_l0nYX01_ooool3o`00037ooooo0016oooo
o`03o`000?oooooooooo0;oooooo1?l0nYX4ooooo`03o`000?l00?oo003o00?ooooo1_l00?l2oooo
o`?o00000_l0nYX3ooooo`?o0?ZJ00?oooooo`00ool00?l00ol0nYX01?l0003o003oo`00ooooool2
o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l0nYX6ooooo`Co00000_l00?l2ooooo`;o003o00?o0?ZJ
ooooooooool06_ooool2o`0000;ooooo00?o0000ooooooooool01Oooool4o`0000Gooooo00?o0000
ooooooooool0_Oooool2o`3jVU?ooooo1_l0nYX8ooooo`03o`000?oooooooooo02oooooo0016oooo
o`03o`000?oooooooooo0<3ooooo0ol0nYX4ooooo`03o`000?l00?oo003o00?ooooo0_l00?l2oooo
o`;o0?ZJ0oooool2o`0000;o0?ZJ0oooool3o`3jVP03ooooool00?oo003o00?o0?ZJ00Co0000o`00
ool00?oooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ1_ooool3o`000003ooooool00?oo
003o00Co003o7Oooool2o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo0;gooooo0_l0nYYCooooo`Ko0?ZJ2?ooool00ol0003oooooooooo`0_
ooooo`00A_ooool00ol0003oooooooooo`30ooooo`?o0?ZJ1?ooool00ol0003o003oo`00o`03o`00
00;o003o0_ooool2o`3jVP?ooooo0_l00002o`3jVP?ooooo0ol0nYX01?oooooo003oo`00ool00?l2
o`3jVP04o`000?l00?oo003oooooo`Go0?ZJ0_ooool2o`3jVPKooooo0ol000000ooooooo003oo`00
o`04o`00oagooooo00Co0000ooooool0003o00002?ooool5o`0000Cooooo00?o0000ooooooooool0
_Oooool5o`3jVU3ooooo0_l0nYX<ooooo`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oo
oooooooo0<3ooooo0ol0nYX4ooooo`03o`000?l00?oo003o00;o00000ol00?l2ooooo`;o0?ZJ0ooo
ool2o`0000;o0?ZJ0oooool3o`3jVP;ooooo0_l00?l2o`3jVP04o`000?l00?oo003oooooo`Go0?ZJ
0_ooool2o`3jVPKooooo0ol000000ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ7Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo0;gooooo2?l0nYY=ooooo`;o0?ZJ3?ooool00ol0003ooooo
ooooo`0_ooooo`00A_ooool00ol0003oooooooooo`31ooooo`;o0?ZJ1Oooool2o`00o`;o00000_l0
0?l00ol0nY[oooooooooo`02o`3jVP?ooooo0_l00002o`3jVP?ooooo1?l0nYX00ooooooo003oo`00
o`02o`3jVP03o`000?l00?oo003o00;ooooo1?l0nYX2ooooo`;o0?ZJ1_ooool3o`000003ooooool0
nY[o0?ZJ00;ooooo0_l0nYXMooooo`03o`000?oooooooooo01;ooooo0ol00031ooooo`So0?ZJBOoo
ool2o`3jVP_ooooo0_l0000aooooo`00A_ooool00ol0003oooooooooo`31ooooo`;o0?ZJ1Oooool2
o`00o`;o00000_l00?l2o`3jVP03ooooool0nY[o0?ZJ00?ooooo0_l00002o`3jVP;ooooo1Ol0nYX0
1_oooooo003oo`00ool0nY[oooooo`0000;o003o0_ooool4o`3jVP;ooooo0_l0nYX7ooooo`;o0000
00?oooooo`3jV_l0nYX00_ooool2o`3jVQgooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`34ooooo`Go0?ZJBOooool2o`3jVPcooooo00?o0000ooooooooool0;oooool004Kooooo00?o
0000ooooooooool0`Oooool2o`3jVPGooooo1_l00?l2o`3jVP03ooooool0nY[o0?ZJ00Gooooo0_l0
nYX2ooooo`;o0?ZJ00Co0000o`3jV_l0nY[ooooo0_l00?l00ol0nY[oooooooooo`02o`00o`?ooooo
0ol0nYX2ooooo`;o0?ZJ1oooool2o`000003ooooool0nY[o0?ZJ00;ooooo0_l0nYXMooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0aoooool2o`3jVTWooooo0_l0nYX<ooooo`03o`00
0?oooooooooo02oooooo0016ooooo`?o0000b?ooool6o`00o`;o0?ZJ00?oooooo`3jV_l0nYX01Ooo
ool3o`3jVP04ooooool0nY[o0?ZJo`0000?o0?ZJ0_l00?l00ol0nY[oooooooooo`02o`00o`?ooooo
0ol0nYX2ooooo`;o0?ZJ1oooool2o`000003ooooool0nY[o0?ZJ00;ooooo0_l0nYXLooooo`;o0000
5?ooool00ol0003oooooooooo`37ooooo`;o0?ZJBOooool2o`3jVPcooooo00?o0000ooooooooool0
;oooool004Kooooo00?o0000ooooooooool0b?ooool3o`00o`;o00000ol0nYX00ooooooo0?ZJo`3j
VP06ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l00002o`3jVP;o003o00?o0?ZJooooooooool00_l0
0?l4ooooo`;o0?ZJ0_ooool2o`3jVPOooooo0_l000000ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ7Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0<Oooooo0_l0nYY8ooooo`?o0?ZJ3?oo
ool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`38ooooo`;o0?ZJ0oooool3
o`3jVP03ooooool0nY[o0?ZJ00Kooooo0_l0nYX01Ooooooo0?ZJo`3jV_oooooo000000;o0?ZJ0_l0
0?l00ol0nY[oooooooooo`02o`00o`Cooooo0ol0nYX00ooooooo0?ZJo`3jVP0:ooooo`;o0?ZJ0_oo
ool2o`3jVQgooooo00?o0000ooooooooool04_ooool3o`000<Oooooo0_l0nYY8ooooo`;o0?ZJ3?oo
ool2o`00037ooooo0016ooooo`03o`000?oooooooooo0<Sooooo0_l0nYX3ooooo`?o0?ZJ00?ooooo
o`3jV_l0nYX01_ooool2o`3jVP05ooooool0nY[o0?ZJooooool000000_l0nYX2o`00o`03o`3jV_oo
oooooooo00;o003o1Oooool2o`3jVP03ooooool0nY[o0?ZJ00[ooooo0_l0nYX2ooooo`;o0?ZJ7Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0<Oooooo0_l0nYY8ooooo`;o0?ZJ3Ooo
ool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`38ooooo`;o0?ZJ0oooool3
o`3jVP03ooooool0nY[o0?ZJ00Kooooo0_l0nYX01Ooooooo0?ZJo`3jV_oooooo000000;o0?ZJ0_l0
0?l00ol0nY[oooooooooo`02o`00o`Gooooo0_l0nYX00ooooooo0?ZJo`3jVP0:ooooo`;o0?ZJ0_oo
ool2o`3jVQgooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`37ooooo`;o0?ZJB?oo
ool2o`3jVPgooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0b?ooool2
o`3jVP?ooooo0ol0nYX00ooooooo0?ZJo`3jVP06ooooo`Go0?ZJ00Coooooo`000?l0nY[o0?ZJ0_l0
0?l3ooooo`;o003o1Oooool2o`3jVP03ooooool0nY[o0?ZJ00[ooooo0_l0nYX2ooooo`;o0?ZJ7Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0<Oooooo0_l0nYY8ooooo`;o0?ZJ3Ooo
ool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`38ooooo`;o0?ZJ0oooool3
o`3jVP03ooooool0nY[o0?ZJ00Oooooo1?l0nYX01?oooooo0000o`3jV_l0nYX2o`00o`?ooooo0_l0
0?l5ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02_ooool2o`3jVP;ooooo0_l0nYXMooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool0aoooool2o`3jVT?ooooo0ol0nYX2ooooo`;o0?ZJ3Ooo
ool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`38ooooo`;o0?ZJ0oooool3
o`3jVP03ooooool0nY[o0?ZJ00Oooooo1?l0nYX01?oooooo0000o`000?l0nYX2o`00o`?ooooo0_l0
0?l5ooooo`Go0?ZJ2_ooool2o`3jVP;ooooo0_l0nYXMooooo`03o`000?oooooooooo01;ooooo0ol0
0037ooooo`;o0?ZJ@oooool4o`3jVP03ooooool0nY[o0?ZJ00cooooo0_l0000aooooo`00A_ooool3
o`000<Sooooo0_l0nYX3ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01oooool4o`3jVP04ooooool0003o
0000o`3jVP;o003o0oooool2o`00o`Kooooo1?l0nYX:ooooo`;o0?ZJ0_ooool2o`3jVQcooooo0_l0
000Dooooo`03o`000?oooooooooo0<Oooooo0_l0nYY3ooooo`Oo0?ZJ3Oooool00ol0003ooooooooo
o`0_ooooo`00A_ooool00ol0003oooooooooo`38ooooo`;o0?ZJ0oooool3o`3jVP03ooooool0nY[o
0?ZJ00Oooooo1?l0nYX2ooooo`;o00001ol00?l6ooooo`Co0?ZJ2_ooool3o`3jVP03ooooool0nY[o
0?ZJ01gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`37ooooo`;o0?ZJ@oooool2
o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ3Oooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0
003oooooooooo`38ooooo`;o0?ZJ0oooool6o`3jVPOooooo1?l0nYX4ooooo`Oo003o1_ooool4o`3j
VP_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Mooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool0aoooool2o`3jVT?ooooo0_l0nYX3ooooo`;o0?ZJ3Oooool00ol0003oooooooooo`0_oooo
o`00A_ooool00ol0003oooooooooo`38ooooo`;o0?ZJ0_ooool7o`3jVPOooooo1?l0nYX4ooooo`;o
0?ZJ0oooool2o`3jVPOooooo0ol0nYX;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX07Oooool00ol0003o
ooooooooo`0Booooo`?o0000aoooool2o`3jVT?ooooo0_l0nYXAooooo`;o0000<Oooool004Kooooo
00?o0000ooooooooool0b?ooool2o`3jVP;ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPSooooo
0ol0nYX4ooooo`;o0?ZJ0oooool2o`3jVPOooooo0ol0nYX;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
7Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0<Oooooo0_l0nYY3ooooo`;o0?ZJ
4_ooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003oooooooooo`38ooooo`;o0?ZJ0_oo
ool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2?ooool3o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ1ooo
ool3o`3jVP_ooooo1Ol0nYXMooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0aooo
ool2o`3jVQCooooo0ol0nYXGooooo`?o0?ZJ4_ooool2o`3jVQ;ooooo00?o0000ooooooooool0;ooo
ool004Kooooo00?o0000ooooooooool0b?ooool2o`3jVP;ooooo0_l0nYX2ooooo`?o0?ZJ2?ooool3
o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ1oooool3o`3jVPcooooo1?l0nYXMooooo`04o`000?oooooo
0000o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0aooo
ool2o`3jVQCooooo2?l0nYXBooooo`Co0?ZJ4Oooool2o`3jVQ;ooooo00?o0000ooooooooool0;ooo
ool003?ooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooo
oooo0<Sooooo0ol0nYX00ooooooo0?ZJo`3jVP02ooooo`?o0?ZJ2Oooool2o`3jVPCooooo0ol0nYX2
ooooo`;o0?ZJ1oooool3o`3jVPcooooo1?l0nYXMooooo`;o00000_ooool00ol0003oooooooooo`05
ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`37ooooo`;o0?ZJ5?oo
ool<o`3jVPkooooo1ol0nYX>ooooo`;o0?ZJ4_ooool00ol0003oooooooooo`0_ooooo`00=?ooool0
0ol0003oooooooooo`06ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`39ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool3o`3jVQ3ooooo0_l0nYX2ooooo`;o0?ZJ2?oo
ool2o`3jVPcooooo1?l0nYXMooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`05o`000?oo
ooooooooooooool000001?ooool3o`000<Oooooo0_l0nYXDooooo`;o0?ZJ1?ooool6o`3jVPkooooo
0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPkooooo0_l0nYX@ooooo`?o0000<Oooool0037ooooo1Ol0
0007ooooo`05o`000?ooooooooooooooool000001?ooool3o`000<Wooooo0_l0nYX00ooooooo0?ZJ
o`3jVP03ooooo`;o0?ZJ4?ooool2o`3jVP;ooooo0_l0nYX8ooooo`;o0?ZJ3?ooool4o`3jVQ_ooooo
1?l00002ooooo`03o`000?oooooooooo00Gooooo1?l00005ooooo`03o`000?oooooooooo0<Oooooo
0_l0nYXDooooo`;o0?ZJ2?ooool2o`3jVPkooooo0_l0nYX3ooooo`;o0?ZJ3_ooool2o`3jVQ;ooooo
00?o0000ooooooooool0;oooool0037ooooo00Co0000oooooooooooo00002Oooool3o`0000Gooooo
00?o0000ooooooooool0bOooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo0_l0nYX@ooooo`;o0?ZJ
0_ooool2o`3jVQOooooo0ol0nYXMooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0aoooool2o`3jVQCooooo0_l0nYX8ooooo`;o0?ZJ
3_ooool2o`3jVP?ooooo0_l0nYX>ooooo`;o0?ZJ4_ooool00ol0003oooooooooo`0_ooooo`00<_oo
ool00ol0003oooooo`000008ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooo
ooooo`39ooooo`Go0?ZJ0oooool2o`3jVQ3ooooo0_l0nYX2ooooo`;o0?ZJ5oooool3o`3jVQgooooo
0_l00002ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`37ooooo`;o0?ZJ1Oooool2o`3jVPgooooo0_l0nYX8ooooo`;o0?ZJ3_ooool2o`3jVP?ooooo
0_l0nYX>ooooo`;o0?ZJ4_ooool00ol0003oooooooooo`0_ooooo`00<oooool2o`0000Sooooo00Go
0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0<[ooooo1?l0nYX3ooooo`;o0?ZJ
4?ooool2o`3jVP;ooooo0_l0nYXGooooo`?o0?ZJ7Oooool01?l0003oooooo`000?l0000:ooooo`;o
00001Oooool00ol0003oooooooooo`37ooooo`;o0?ZJ1?ooool6o`3jVPWooooo0ol0nYX8ooooo`;o
0?ZJ1?ooool3o`3jVPKooooo0ol0nYX3ooooo`;o0?ZJ3_ooool2o`3jVQ;ooooo00?o0000oooooooo
ool0;oooool003Cooooo00?o0000ooooooooool01oooool3o`0000Gooooo00?o0000ooooooooool0
b_ooool4o`3jVQGooooo0_l0nYX2ooooo`;o0?ZJ5oooool3o`3jVQgooooo00?o0000ooooooooool0
4_ooool3o`000<Oooooo0_l0nYX4ooooo`Ko0?ZJ2Oooool2o`3jVPWooooo0_l0nYX4ooooo`Go0?ZJ
1?ooool2o`3jVPCooooo0_l0nYX9ooooo`?o0?ZJ0_ooool2o`3jVQ7ooooo0_l0000aooooo`00A_oo
ool00ol0003oooooooooo`3:ooooo`Co0?ZJ5Oooool3o`3jVP03ooooool0nY[o0?ZJ01Oooooo0ol0
nYXMooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0aoooool2o`3jVPCooooo0_l0
nYX2ooooo`;o0?ZJ2Oooool2o`3jVPWooooo0_l0nYX4ooooo`Ko0?ZJ0oooool2o`3jVPCooooo0_l0
nYX9ooooo`Co0?ZJ00?oooooo`3jV_l0nYX04_ooool00ol0003oooooooooo`0_ooooo`00A_ooool0
0ol0003oooooooooo`3:ooooo`Co0?ZJ5_ooool2o`3jVP03ooooool0nY[o0?ZJ01Oooooo0ol0nYXM
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0aoooool2o`3jVPCooooo0_l0nYX2
ooooo`;o0?ZJ2Oooool2o`3jVPWooooo0_l0nYX4ooooo`;o0?ZJ0_ooool2o`3jVP?ooooo0_l0nYX4
ooooo`;o0?ZJ2Oooool7o`3jVQ;ooooo00?o0000ooooooooool0;oooool004Kooooo00?o0000oooo
ooooool0boooool3o`3jVQKooooo0_l0nYX00ooooooo0?ZJo`3jVP0Hooooo`;o0?ZJ7Oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo0<Oooooo0_l0nYX4ooooo`;o0?ZJ0_ooool3o`3j
VPSooooo0_l0nYX9ooooo`;o0?ZJ1?ooool2o`3jVP;ooooo0ol0nYX2ooooo`;o0?ZJ1?ooool2o`3j
VPWooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVQ;ooooo00?o0000ooooooooool0;oooool004Ko
oooo00?o0000ooooooooool0boooool3o`3jVQKooooo0_l0nYX00ooooooo0?ZJo`3jVP0gooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool0aoooool2o`3jVPCooooo0_l0nYX3ooooo`;o
0?ZJ1?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPWooooo0_l0nYX3ooooo`?o0?ZJ0oooool3o`3j
VP03ooooool0nY[o0?ZJ00Cooooo0_l0nYX9ooooo`;o0?ZJ5oooool00ol0003oooooooooo`0_oooo
o`00A_ooool3o`000<_ooooo0ol0nYXFooooo`;o0?ZJ00?oooooo`3jV_l0nYX0=_ooool2o`0001Co
oooo0ol00037ooooo`;o0?ZJ0oooool3o`3jVP?ooooo0_l0nYX3ooooo`Oo0?ZJ2Oooool2o`3jVP?o
oooo0_l0nYX4ooooo`Ko0?ZJ1?ooool2o`3jVPWooooo0_l0nYXFooooo`;o0000<Oooool004Kooooo
00?o0000ooooooooool0boooool3o`3jVQKooooo0_l0nYX00ooooooo0?ZJo`3jVP0gooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0aoooool2o`3jVP?ooooo0_l0nYX4ooooo`[o0?ZJ
2oooool2o`3jVP?ooooo0_l0nYX6ooooo`Co0?ZJ1?ooool2o`3jVPWooooo0_l0nYXGooooo`03o`00
0?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo0<_ooooo0ol0nYXFooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX0=oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0<Oooooo0_l0
nYX3ooooo`;o0?ZJ1?ooool7o`3jVPkooooo1ol0nYX>ooooo`;o0?ZJ2Oooool2o`3jVQOooooo00?o
0000ooooooooool0;oooool004Kooooo00?o0000ooooooooool0boooool3o`3jVQKooooo1Ol0nYXg
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0aoooool3o`3jVP;ooooo0_l0nYXI
ooooo`Oo0?ZJ3_ooool2o`3jVPSooooo0ol0nYXGooooo`03o`000?oooooooooo02oooooo0016oooo
o`03o`000?oooooooooo0<cooooo0_l0nYXGooooo`Co0?ZJ=oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo0<Sooooo1_l0nYX^ooooo`;o0?ZJ2?ooool2o`3jVQSooooo00?o0000oooo
ooooool0;oooool004Kooooo00?o0000ooooooooool0iOooool4o`3jVSOooooo00?o0000oooooooo
ool04_ooool3o`000<Wooooo1Ol0nYX^ooooo`;o0?ZJ2?ooool2o`3jVQOooooo0_l0000aooooo`00
A_ooool00ol0003oooooooooo`3Uooooo`Co0?ZJ=oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo0<[ooooo1?l0nYX^ooooo`?o0?ZJ1oooool2o`3jVQSooooo00?o0000ooooooooool0
;oooool004Kooooo00?o0000ooooooooool0i_ooool3o`3jVSOooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`3looooo`Oo0?ZJ0oooool2o`3jVQSooooo00?o0000ooooooooool0;ooo
ool004Kooooo00?o0000ooooooooool0i_ooool3o`3jVSOooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`3looooo`co0?ZJ6?ooool00ol0003oooooooooo`0_ooooo`00A_ooool3o`00
0>Kooooo0ol0nYXfooooo`;o00005?ooool00ol0003oooooooooo`3oooooo`?ooooo1_l0nYXHoooo
o`03o`000?oooooooooo02oooooo0016ooooo`03o`000?oooooooooo0>Oooooo0_l0nYXgooooo`03
o`000?oooooooooo01;ooooo0ol0003oooooo`Kooooo0ol0nYXGooooo`;o0000<Oooool004Kooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool08oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0_ooooo`00A_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00005?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo0000<Oooool004Kooooo
ool0000Uo`0001Coooooool0000Uo`00037ooooo003oooooooooooooeOooool00?oooooooooooooE
ooooo`00ooooooooooooomGooooo003oooooooooooooeOooool00?oooooooooooooEooooo`00oooo
ooooooooomGooooo003oooooooooooooeOooool00?oooooooooooooEooooo`00ooooooooooooomGo
oooo003oooooooooooooeOooool00?oooooooooooooEooooo`00ooooooooooooomGooooo003ooooo
ooooooooeOooool00?oooooooooooooEooooo`00i_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01oooool3o`0000_ooooo00?o0000ooooooooool0
5?ooool3o`0000oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo0<Oooooo003Uooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool05_oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo08gooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`36ooooo`00aOooool3o`0000?ooooo0ol00002ooooo`?o000000?ooooo
o`000?l000000ol0000<ooooo`03o`000?oooooooooo00?o000000?oooooo`000?l000000oooool0
2?l0003oooooooooool0003oooooo`000?oooooo00001?ooool01?l0003oooooooooooooool3o`00
00?ooooo0ol00002ooooo`Co00001Oooool00ol0003oooooooooo`02o`000004ooooool0003o0000
ooooo`Co00000_ooool5o`0000;ooooo1?l000001_oooooo0000ooooool0003oooooo`0000;ooooo
1?l00003ooooo`03o`000?oooooooooo00;ooooo1?l00004ooooo`03o`000?oooooooooo00;ooooo
0ol00004ooooo`03o`000?oooooooooo00Oooooo0_l00006ooooo`03o`000?oooooooooo00kooooo
0_l00004ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o00001?ooool2o`0000?ooooo
0ol00003ooooo`?o00000_ooool5o`0000;ooooo0ol00003ooooo`;o00001?ooool3o`0000?ooooo
0_l00003ooooo`Go00000_ooool3o`0000Cooooo0_l00003ooooo`?o00000oooool3o`0000Cooooo
0ol00003ooooo`03o`000?oooooooooo00?ooooo0ol00002ooooo`?o00001Oooool00ol0003ooooo
ooooo`07ooooo`?o00001?ooool00ol0003oooooooooo`36ooooo`00a?ooool01ol0003ooooooooo
oooooooo0000ooooool000000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000gooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00Go
0000ooooool0003oooooo`000007ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00001Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000Kooooo00Go0000oooooooo
ooooooooo`000003ooooo`0=o`000?ooooooooooooooool0003oooooo`000?oooooo0000ooooool0
003oooooo`000002ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool04oooool01?l0
003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
0_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooool000000oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooo
o`000002ooooo`05o`000?ooooooooooooooool000001?ooool01_l0003oooooooooool0003ooooo
o`0000?ooooo00?o0000ooooool000000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00gooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0<Kooooo0034
ooooo`07o`000?ooooooooooooooool0003oooooo`000003ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo0000
00Sooooo00Go0000ooooool0003oooooo`000007ooooo`Go00000_ooool01?l0003oooooooooool0
0002ooooo`?o00002Oooool2o`0000Cooooo0ol00004ooooo`05o`000?ooooooooooooooool00000
0oooool01ol0003oooooo`000?oooooo0000ooooool000000_ooool3o`0000Gooooo00Co0000oooo
oooooooooooo1?l00003ooooo`04o`000?ooooooooooooooo`Go00004Oooool00ol0003ooooooooo
o`0<ooooo`Co00000_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00005ooooo`03o`000?oooooo
oooo00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
1Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00Go0000oooooooooooo
ooooo`000005ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool00ol0
003oooooo`000003ooooo`03o`000?oooooo000000Co00001?ooool00ol0003oooooooooo`05o`00
00?ooooo00?o0000ooooooooool03Oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000
ooooooooool0aOooool00<Cooooo00?o0000ooooool000001?l000000ooooooo0000o`000002o`00
0003ooooool0003o000000;o00000_ooool3o`0000_ooooo00Co0000oooooooooooooooo0_l00009
ooooo`05o`000?oooooo0000ooooool000001oooool01Ol0003ooooooooooooooooo000000;ooooo
00Ko0000oooooooooooo0000ooooool0000<ooooo`03o`000?oooooo000000;ooooo00?o0000oooo
ooooool01Oooool01Ol0003ooooooooooooooooo000000?ooooo00Wo0000ooooool0003oooooo`00
0?oooooo0000ooooool000000_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00[o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0=ooooo`Co00005?ooool01?l0
003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool00005ooooo`04o`000?ooooooooooooooo`;o00001Oooool01?l0
003oooooooooooooool3o`0000?ooooo1?l00005ooooo`03o`000?oooooooooo00Co00001?ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Ooo
ool00ol0003oooooooooo`03o`0000;ooooo00Co0000oooooooooooo00001Oooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03Oooool4o`0000Co
oooo00?o0000ooooooooool0a_ooool00<Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02oooool01ol0003o
oooooooooooooooo0000ooooool000002?ooool2o`000003ooooool0003ooooo00Sooooo0ol00002
ooooo`Co00000oooool4o`0000Sooooo00Co0000ooooool0003o00000_ooool4o`000004ooooool0
003o0000o`0000Cooooo1ol000000ooooooo0000ooooo`02ooooo`;o00001Oooool00ol0003ooooo
ooooo`0:ooooo`07o`000?ooooooooooooooool0003oooooo`00000>ooooo`05o`000?oooooooooo
ooooool000005?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool01Ol0003oooooooooool0003ooooo00Co00001_ooool00ol0
003oooooo`000003ooooo`03o`000?oooooo000000?ooooo00?o0000ooooool000000oooool00ol0
003oooooo`000003o`0000;ooooo00Oo0000ooooooooooooooooo`000?oooooo000000?ooooo00Go
0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooo`000?ooool01?l00002ooooo`05
o`000?ooooooooooooooool000000_ooool00ol0003oooooo`000006ooooo`06o`000?oooooooooo
o`000?oooooo00001?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0a_ooool00<Cooooo00Oo0000ooooooooooooooooo`000?oooooo000000?ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Wooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool03?ooool01?l0003oooooooooooooool2o`0000kooooo00Go
0000ooooooooooooooooo`00000Dooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo0000
1Oooool01ol0003ooooooooooooooooo0000ooooool000000oooool00ol0003oooooo`000003oooo
o`03o`000?oooooo000000?ooooo00?o0000ooooool000001Oooool01ol0003ooooooooooooooooo
0000ooooool000000oooool00ol0003oooooooooo`02o`0000Cooooo00Ko0000oooooooooooo0000
ooooool00005ooooo`05o`000?ooooooooooooooool000000oooool2o`0000;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`;o00000oooool2o`00013ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`37ooooo`00aOooool3o`0000?ooooo0ol00002ooooo`?o000000?oooooo`00
0?l000001Ol0000=ooooo`?o000000?oooooo`000?l00000:_ooool2o`0000cooooo00?o0000oooo
ooooool0:?ooool00ol0003oooooooooo`0=ooooo`?o00005_ooool2o`0000[ooooo0_l00004oooo
o`;o00001?ooool2o`0000;ooooo1Ol00002ooooo`?o00000oooool3o`0000?ooooo0ol00003oooo
o`?o00000_ooool5o`0000;ooooo0ol00003ooooo`?o00001?ooool00ol0003oooooooooo`03oooo
o`;o00000_ooool5o`0000;ooooo0ol00005ooooo`03o`000?oooooooooo00Go00001?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00oooooo0_l0003=ooooo`00ooooooooooooomGo
oooo003oooooooooooooeOooool00001\
\>"],
  ImageRangeCache->{{{0, 722.625}, {222.625, 0}} -> {-0.158256, -0.0154542, \
0.00320569, 0.00320569}, {{49.3125, 361.312}, {217.75, 25}} -> {-102.8, \
4.4042, 1.32044, 0.0022565}, {{361.312, 673.25}, {217.75, 25}} -> {-514.884, \
-0.103527, 1.32072, 0.00403001}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Y[\([All, 2]\)] - YF[\([All, 2]\)] // TensorMS\)], "Input"],

Cell[BoxData[
    \({0.041276916890658905`, 0.08364444536847902`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "$EPS=10^-3;\n$SHIFT= 10^-3;\nTRAFO=0;\n\
{M,lik}=GGHFMulti[Map[Take[#,366]&,{logZM,X}],{0.07, -1., .2, .2},\n          \
           \t{{drift,Omega},{h,R},",
  StyleBox["m0",
    FontColor->RGBColor[1, 0, 0]],
  ",dt},\n                     \t\
{K=4,miss,option=2,{TimeUpNonlinearPSDMulti,MessupHermiteNorKorrMulti},\n     \
                    m=9,eps=10^-16,ksigma=5}];//Timing\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({1, 8, 15, 22, 29, 36, 43, 50, 57, 64, 71, 78, 85, 92, 99, 106, 113, 
      120, 127, 134, 141, 148, 155, 162, 169, 176, 183, 190, 197, 204, 211, 
      218, 225, 232, 239, 246, 253, 260, 267, 274, 281, 288, 295, 302, 309, 
      316, 323, 330, 337, 344, 351, 358, 365}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
605302370965482`, 0.1999999999999998`}, {9.999986505552062`*^-9, 
            3.330671874630692`*^-16, 0.009999999999999997`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6053023709654823, 
        0.19999999999999979}, {9.999986505552062*^-09, 3.330671874630692*^-16,
         0.0099999999999999967}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.009999999999999997`, 9.999986505552062`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
631323071375542`, 0.18487998360478963`}, {9.999810769466685`*^-9, 
            1.8147718688333715`*^-8, 0.009577959317246393`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.631323071375542, 
        0.18487998360478963}, {9.9998107694666852*^-09, 
        1.8147718688333715*^-08, 0.0095779593172463928}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.009577959317280779`, 9.999776384267652`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
649748542173836`, 0.16118617137574365`}, {9.999759436089001`*^-9, 
            1.0467913845308638`*^-8, 0.008332218215246934`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6497485421738363, 
        0.16118617137574365}, {9.9997594360890013*^-09, 
        1.0467913845308638*^-08, 0.0083322182152469337}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.008332218215260085`, 9.999746285046992`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
654303898264274`, 0.1328895962087156`}, {9.999705396813486`*^-9, 
            1.488061083200256`*^-9, 0.0069061145002237605`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6543038982642742, 
        0.1328895962087156}, {9.9997053968134858*^-09, 
        1.4880610832002561*^-09, 0.0069061145002237605}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0069061145002240806`, 9.999705076180374`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
680270304112424`, 0.1464227432160952`}, {9.999672956906579`*^-9, 
            5.3221744418670085`*^-8, 0.007444636206258699`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6802703041124243, 
        0.14642274321609519}, {9.9996729569065786*^-09, 
        5.3221744418670085*^-08, 0.0074446362062586986}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.007444636206639181`, 9.999292473857436`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
69006135138708`, 0.1226564222239711`}, {9.999676810510286`*^-9, 
            5.322492525858379`*^-9, 0.007262654024103671`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6900613513870804, 
        0.12265642222397111}, {9.9996768105102857*^-09, 
        5.3224925258583792*^-09, 0.0072626540241036708}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0072626540241075704`, 9.999672909874846`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
6934551197092045`, 0.09698229643701396`}, {9.999563910658365`*^-9, 
            1.194510781627404`*^-9, 0.0069362411327158055`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6934551197092045, 
        0.096982296437013962}, {9.9995639106583646*^-09, 
        1.194510781627404*^-09, 0.0069362411327158055}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.006936241132716011`, 9.999563704947802`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
657198150741594`, 0.2961857903956404`}, {1.0000595195448506`*^-8, 
            8.229430468447525`*^-8, \(-0.03093098691880828`\)}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6571981507415936, 
        0.29618579039564041}, {1.0000595195448506*^-08, 
        8.2294304684475254*^-08, -0.03093098691880828}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({\(-0.03093098691902723`\), 1.0000814145797928`*^-8}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Norkorr mit H, \
PO"\[InvisibleSpace]{0.007429134625454263`, 9.99968339469165`*^-9}\),
      SequenceForm[ 
      "Norkorr mit H, PO", {0.0074291346254542626, 9.9996833946916497*^-09}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
656531593438219`, 
            0.07364171243261593`}, {9.999314803176086`*^-9, \
\(-1.140817495486131`*^-9\), 0.004947411729127309`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6565315934382188, 
        0.073641712432615927}, {
        9.9993148031760859*^-09, -1.1408174954861311*^-09, 
        0.0049474117291273094}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004947411729127573`, 9.999314540115871`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
643553449613727`, 
            0.07631383992430094`}, {9.999358813862299`*^-9, \
\(-4.005878385442573`*^-8\), 0.0054802446975739365`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6435534496137274, 
        0.076313839924300936}, {
        9.999358813862299*^-09, -4.0058783854425727*^-08, 
        0.0054802446975739365}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0054802446978667535`, 9.999065996811173`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
609448330980022`, 0.1942889636357971`}, {9.999971857046714`*^-9, 
            5.038704167507728`*^-8, \(-0.009628141346286936`\)}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6094483309800216, 
        0.19428896363579709}, {9.9999718570467139*^-09, 
        5.0387041675077281*^-08, -0.0096281413462869364}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({\(-0.009628141346550627`\), 1.0000235547746767`*^-8}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Norkorr mit H, \
PO"\[InvisibleSpace]{0.006028227525371832`, 9.999551692993714`*^-9}\),
      SequenceForm[ 
      "Norkorr mit H, PO", {0.0060282275253718317, 9.9995516929937136*^-09}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
6141380779014805`, 0.05691036062379991`}, {9.998969231208149`*^-9, 
            2.366153997156693`*^-9, 0.004029675543305884`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6141380779014805, 
        0.056910360623799908}, {9.9989692312081489*^-09, 
        2.366153997156693*^-09, 0.0040296755433058837}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004029675543307272`, 9.998967841841049`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
612635596800801`, 
            0.0421295438708097`}, {9.998928161474799`*^-9, \
\(-5.720548086937964`*^-9\), 0.004783836806787726`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6126355968008008, 
        0.042129543870809701}, {
        9.9989281614747985*^-09, -5.7205480869379639*^-09, 
        0.0047838368067877257}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0047838368067945666`, 9.998921320786009`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
615606239338531`, 0.027596349109547245`}, {9.998620441985242`*^-9, 
            2.3958025391012493`*^-9, 0.004531701650801398`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6156062393385309, 
        0.027596349109547245}, {9.9986204419852416*^-09, 
        2.3958025391012493*^-09, 0.004531701650801398}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004531701650802664`, 9.998619175378807`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
603165671848994`, 
            0.04349519861112394`}, {9.999420817289652`*^-9, \
\(-4.554760572136262`*^-8\), 0.005446850059550038`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6031656718489939, 
        0.043495198611123942}, {
        9.9994208172896523*^-09, -4.5547605721362621*^-08, 
        0.0054468500595500381}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.005446850059930917`, 9.999039938768546`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
602703120523497`, 
            0.03017570296958106`}, {9.998719825341843`*^-9, \
\(-2.5177663526774486`*^-9\), 0.004784921904185032`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6027031205234969, 
        0.03017570296958106}, {
        9.9987198253418435*^-09, -2.5177663526774486*^-09, 
        0.0047849219041850317}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004784921904186357`, 9.998718500521756`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
620429392214817`, 0.04994799610507329`}, {9.99958293763678`*^-9, 
            3.928644290083642`*^-8, 0.005464089409597022`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6204293922148167, 
        0.049947996105073292}, {9.9995829376367803*^-09, 
        3.9286442900836421*^-08, 0.0054640894095970222}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.00546408940987949`, 9.999300470183453`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
623252448983508`, 0.03543562110876794`}, {9.998812569826073`*^-9, 
            1.618475324037692`*^-9, 0.004901215907449631`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6232524489835081, 
        0.03543562110876794}, {9.9988125698260731*^-09, 
        1.6184753240376919*^-09, 0.0049012159074496306}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004901215907450165`, 9.998812035373446`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
644233119059022`, 0.0751618097810684`}, {1.000020016234401`*^-8, 
            5.550797911801528`*^-8, 0.004849663351673625`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.644233119059022, 0.0751618097810684}, {
        1.000020016234401*^-08, 5.550797911801528*^-08, 
        0.0048496633516736248}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004849663352308955`, 9.99956483121371`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
6422020086998685`, 
            0.058407494159194724`}, {9.999079383426472`*^-9, \
\(-3.912491283170929`*^-9\), 0.004676889041907734`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6422020086998685, 
        0.058407494159194724}, {
        9.9990793834264715*^-09, -3.9124912831709294*^-09, 
        0.0046768890419077343}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004676889041911007`, 9.999076110391635`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
604921926000626`, 0.11317888192344444`}, {9.999014880011806`*^-9, 
            3.7510955076099193`*^-8, 0.0031052877055841137`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6049219260006264, 
        0.11317888192344444}, {9.9990148800118064*^-09, 
        3.7510955076099193*^-08, 0.0031052877055841137}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0031052877060372365`, 9.998561757333748`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
604058832488149`, 
            0.09436544064499511`}, {9.999354516907408`*^-9, \
\(-1.5837632014039425`*^-9\), 0.002569649883259496`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6040588324881488, 
        0.094365440644995108}, {
        9.9993545169074075*^-09, -1.5837632014039425*^-09, 
        0.0025696498832594962}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.002569649883260472`, 9.999353540776126`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
615180383230824`, 0.08322984729280132`}, {9.99909282036727`*^-9, 
            1.3779514201792918`*^-8, 0.0028557716073154115`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6151803832308236, 
        0.083229847292801321}, {9.9990928203672701*^-09, 
        1.3779514201792918*^-08, 0.0028557716073154115}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0028557716073819`, 9.999026331970239`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
599847267102731`, 
            0.10425115475291206`}, {9.998791661744695`*^-9, \
\(-9.740932759557678`*^-8\), 0.003528235071346187`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.5998472671027306, 
        0.10425115475291206}, {
        9.9987916617446955*^-09, -9.7409327595576782*^-08, 
        0.003528235071346187}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0035282350740355214`, 9.996102327334258`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
602228918543141`, 0.08524238871616976`}, {9.999303379237477`*^-9, 
            6.755908547741461`*^-10, 0.00333396280066427`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6022289185431413, 
        0.085242388716169765}, {9.9993033792374769*^-09, 
        6.7559085477414611*^-10, 0.0033339628006642699}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.003333962800664407`, 9.999303242336018`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
635000083812338`, 
            0.23700327971203872`}, {1.000031590030857`*^-8, \
\(-1.1987146396810957`*^-7\), \(-0.016877622929418426`\)}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6350000838123382, 
        0.23700327971203872}, {
        1.000031590030857*^-08, -1.1987146396810957*^-07, \
-0.016877622929418426}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({\(-0.0168776229302698`\), 1.000116727371697`*^-8}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Norkorr mit H, \
PO"\[InvisibleSpace]{0.003962831411628776`, 9.999520944777018`*^-9}\),
      SequenceForm[ 
      "Norkorr mit H, PO", {0.0039628314116287762, 9.9995209447770184*^-09}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
632564538236798`, 
            0.06768989409053051`}, {9.999010389979636`*^-9, \
\(-3.20603872624192`*^-9\), 0.003102884748946257`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6325645382367977, 
        0.067689894090530514}, {
        9.9990103899796357*^-09, -3.2060387262419201*^-09, 
        0.0031028847489462572}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.00310288474894957`, 9.99900707734695`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
640779027820169`, 0.055614232878405674`}, {9.998717374946208`*^-9, 
            1.2355553691220206`*^-8, 0.003467378260451395`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6407790278201686, 
        0.055614232878405674}, {9.998717374946208*^-09, 
        1.2355553691220206*^-08, 0.003467378260451395}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0034673782604954222`, 9.998673347402696`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
6070564673935746`, 0.10276556224078345`}, {9.99855714813869`*^-9, 
            4.031065914221519`*^-8, 0.0030699733498941797`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6070564673935746, 
        0.10276556224078345}, {9.9985571481386908*^-09, 
        4.0310659142215187*^-08, 0.0030699733498941797}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0030699733504234855`, 9.998027842393235`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
5787605627415005`, 
            0.26008813219636806`}, {1.0002436435649555`*^-8, \
\(-1.0213679470186344`*^-7\), \(-0.014906906893704462`\)}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.5787605627415005, 
        0.26008813219636806}, {
        1.0002436435649555*^-08, -1.0213679470186344*^-07, \
-0.014906906893704462}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({\(-0.014906906894404267`\), 1.0003136239968863`*^-8}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Norkorr mit H, \
PO"\[InvisibleSpace]{0.003708766325028375`, 9.999624405940515`*^-9}\),
      SequenceForm[ 
      "Norkorr mit H, PO", {0.0037087663250283749, 9.9996244059405146*^-09}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
503471776846812`, 0.1254597096905124`}, {9.999554058394075`*^-9, 
            5.090123541568415`*^-9, 0.004654884113652342`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.503471776846812, 0.1254597096905124}, {
        9.9995540583940745*^-09, 5.0901235415684149*^-09, 
        0.0046548841136523416}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0046548841136579075`, 9.999548492323536`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
5407257650942014`, 0.28360479340821687`}, {1.000129130789706`*^-8, 
            9.422361940348788`*^-8, \(-0.013876390025543625`\)}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.5407257650942014, 
        0.28360479340821687}, {1.000129130789706*^-08, 
        9.4223619403487881*^-08, -0.013876390025543625}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({\(-0.013876390026183422`\), 1.0001931105714644`*^-8}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Norkorr mit H, \
PO"\[InvisibleSpace]{0.0052337964958745565`, 9.99974440471324`*^-9}\),
      SequenceForm[ 
      "Norkorr mit H, PO", {0.0052337964958745565, 9.9997444047132402*^-09}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
587721344363415`, 
            0.28720749164911435`}, {9.999844834303918`*^-9, \
\(-1.1047623670216356`*^-7\), \(-0.0131842094840368`\)}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.5877213443634153, 
        0.28720749164911435}, {
        9.9998448343039182*^-09, -1.1047623670216356*^-07, \
-0.013184209484036801}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({\(-0.013184209484962527`\), 1.0000770562132551`*^-8}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Norkorr mit H, \
PO"\[InvisibleSpace]{0.005790809710297805`, 9.999758197702657`*^-9}\),
      SequenceForm[ 
      "Norkorr mit H, PO", {0.005790809710297805, 9.9997581977026573*^-09}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
61235039431922`, 0.14288788375361272`}, {9.999448636728905`*^-9, 
            6.968968844695498`*^-8, 0.006936875269021421`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6123503943192201, 
        0.14288788375361272}, {9.9994486367289051*^-09, 
        6.9689688446954978*^-08, 0.0069368752690214209}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.006936875269721542`, 9.99874851462957`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
638881798256208`, 0.1544716650996346`}, {9.99960106480536`*^-9, 
            5.487833380713015`*^-8, 0.007951888208775078`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6388817982562083, 
        0.15447166509963459}, {9.9996010648053596*^-09, 
        5.4878333807130152*^-08, 0.0079518882087750778}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.00795188820915381`, 9.999222332706843`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
705510688131204`, 
            0.26764004626677984`}, {9.999680572212107`*^-9, \
\(-6.119308046096717`*^-8\), 0.0009153096186935888`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.7055106881312039, 
        0.26764004626677984}, {
        9.9996805722121074*^-09, -6.1193080460967172*^-08, 
        0.00091530961869358877}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0009153096227847005`, 9.995589460403712`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
64954946808341`, 
            0.28470085269154416`}, {9.999947613183848`*^-9, \
\(-1.209299174097877`*^-8\), 0.004841848469206037`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6495494680834097, 
        0.28470085269154416}, {
        9.9999476131838478*^-09, -1.2092991740978769*^-08, 
        0.004841848469206037}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.00484184846923624`, 9.999917409687764`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
760280679313731`, 
            0.3754833203094264`}, {9.999976765574896`*^-9, \
\(-9.193488464360184`*^-9\), 0.0019909274895168333`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.7602806793137313, 
        0.37548332030942638}, {
        9.9999767655748963*^-09, -9.193488464360184*^-09, 
        0.0019909274895168333}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.0019909274895592863`, 9.99993431267035`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
742682991168253`, 
            0.36485145689298865`}, {9.999954313627756`*^-9, \
\(-1.1398554630747266`*^-9\), 0.002174349881620226`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.7426829911682526, 
        0.36485145689298865}, {
        9.9999543136277565*^-09, -1.1398554630747266*^-09, 
        0.0021743498816202259}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.002174349881620823`, 9.999953716080664`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
660594031883274`, 
            0.37848691793737155`}, {9.999981559808891`*^-9, \
\(-6.423295393660812`*^-9\), 0.0034380388087589986`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6605940318832744, 
        0.37848691793737155}, {
        9.9999815598088915*^-09, -6.4232953936608118*^-09, 
        0.0034380388087589986}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.003438038808770999`, 9.999969559117216`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
728770582160286`, 0.38222823040754994`}, {9.999961980803489`*^-9, 
            6.059962992616412`*^-9, 0.004138133638756049`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.7287705821602861, 
        0.38222823040754994}, {9.9999619808034885*^-09, 
        6.0599629926164121*^-09, 0.0041381336387560494}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004138133638764923`, 9.99995310645495`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
715530661487593`, 
            0.3670390484020025`}, {9.999949662596961`*^-9, \
\(-1.2297450147134572`*^-9\), 0.004283182705113761`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.7155306614875929, 
        0.36703904840200252}, {
        9.9999496625969614*^-09, -1.2297450147134572*^-09, 
        0.0042831827051137607}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.004283182705114114`, 9.999949309523923`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
780769211766919`, 0.37188008246595833`}, {9.999964388659346`*^-9, 
            7.539121606591597`*^-9, 0.005050790298454768`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.7807692117669189, 
        0.37188008246595833}, {9.999964388659346*^-09, 
        7.5391216065915968*^-09, 0.0050507902984547682}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.005050790298466021`, 9.999953135278436`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
694128009282487`, 
            0.4016696296333776`}, {9.99997655110773`*^-9, \
\(-1.1747656808279625`*^-8\), 0.005556726794847061`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6941280092824869, 
        0.4016696296333776}, {
        9.9999765511077307*^-09, -1.1747656808279625*^-08, 
        0.0055567267948470611}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.005556726794871897`, 9.999951714959771`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
735267938870525`, 0.389830474242276`}, {9.999963953360833`*^-9, 
            3.666469777590759`*^-9, 0.006020688992082518`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.7352679388705248, 
        0.38983047424227601}, {9.9999639533608326*^-09, 
        3.666469777590759*^-09, 0.0060206889920825183}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.006020688992084751`, 9.999961720556088`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
661930785418153`, 
            0.4024684335330001`}, {9.999967571941076`*^-9, \
\(-9.789333482206617`*^-9\), 0.006532211583092168`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6619307854181526, 
        0.4024684335330001}, {
        9.9999675719410756*^-09, -9.7893334822066167*^-09, 
        0.0065322115830921679}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.006532211583106838`, 9.999952901381876`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
6605136184209135`, 
            0.38213570746486014`}, {9.99995747543391`*^-9, \
\(-3.2521829830104305`*^-10\), 0.006643477561244956`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6605136184209135, 
        0.38213570746486014}, {
        9.9999574754339103*^-09, -3.2521829830104305*^-10, 
        0.006643477561244956}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.006643477561244972`, 9.99995745951347`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
74789740570579`, 0.41187627776534347`}, {9.999994301183952`*^-9, 
            1.3317606669086404`*^-8, 0.006419243558898293`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.7478974057057899, 
        0.41187627776534347}, {9.9999943011839519*^-09, 
        1.3317606669086404*^-08, 0.0064192435588982929}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.006419243558925922`, 9.999966671927941`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
67565000165512`, 
            0.4194328210161686`}, {9.99997511118209`*^-9, \
\(-8.445674452118293`*^-9\), 0.006926393141302457`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6756500016551197, 
        0.41943282101616858}, {
        9.9999751111820895*^-09, -8.4456744521182934*^-09, 
        0.006926393141302457}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.006926393141312755`, 9.999964812962154`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
644511366764425`, 
            0.4033865667832002`}, {9.999966530570242`*^-9, \
\(-3.029728888424704`*^-9\), 0.007144940570386758`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6445113667644247, 
        0.40338656678320017}, {
        9.9999665305702424*^-09, -3.0297288884247039*^-09, 
        0.0071449405703867576}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.007144940570388041`, 9.999965245847174`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
651927486633185`, 0.3821047904080499`}, {9.999950897411308`*^-9, 
            5.025315840543694`*^-10, 0.007234257355774121`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.651927486633185, 0.3821047904080499}, {
        9.9999508974113079*^-09, 5.0253158405436945*^-10, 
        0.0072342573557741211}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.007234257355774156`, 9.999950862502633`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
634438885941251`, 
            0.36235467164270085`}, {9.999944790789083`*^-9, \
\(-2.178081709438775`*^-9\), 0.007245839948581625`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6344388859412513, 
        0.36235467164270085}, {
        9.9999447907890833*^-09, -2.1780817094387749*^-09, 
        0.0072458399485816252}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.00724583994858228`, 9.999944136062162`*^-9}\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("MessupHermiteNorKorrMulti"\[InvisibleSpace]{{4.\
6605487071938585`, 0.344022060374339`}, {9.999961340032492`*^-9, 
            3.22846014163633`*^-9, 0.007396800854117955`}}\),
      SequenceForm[ 
      "MessupHermiteNorKorrMulti", {{4.6605487071938585, 
        0.34402206037433902}, {9.9999613400324921*^-09, 3.22846014163633*^-09,
         0.0073968008541179554}}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({0.007396800854119364`, 9.999959930913985`*^-9}\)], "Print"],

Cell[BoxData[
    \({18.443506000000525`\ Second, Null}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
YF=M[[All,1]];
PF=M[[All,2]];
s=Map[Part[#,{1,3}]&,PF]//Sqrt;
KI=YF~ii~(YF+s)~ii~(YF-s);

gGHF3=
DisplayTogetherArray[
plot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}  \
]//AddTimeAxis,color->{10,1,2,2},permute->{1,4,3,2}],
plot1[    Column[Y,{2}] \
~ii~Column[KI,{1,3,5}+1]//AddTimeAxis,color->{10,1,2,2}]
,PlotLabel->\"GGHF \
{K,m,eps,ksigma}=\"<>ToString[{K,m,eps//FortranForm,ksigma}]];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -119.125 0 ]
[.5 .32152 119.125 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -180.125 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GGHF) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
93.000 13.000 moveto
(8) show
99.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(K) show
105.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
111.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
117.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
123.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(eps) show
141.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
147.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ksigma) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
183.125 13.000 moveto
(<) show
189.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
195.125 13.000 moveto
(8) show
201.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
207.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
219.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
225.250 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.250 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.) show
249.250 13.000 moveto
(e) show
255.250 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
261.250 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(16) show
273.250 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.250 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
291.250 13.000 moveto
(<) show
297.250 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -7.67922 1.7151 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03874 -18 -4.5 ]
[-0.0125 .03874 0 4.5 ]
[-0.0125 .1245 -24 -4.5 ]
[-0.0125 .1245 0 4.5 ]
[-0.0125 .21025 -18 -4.5 ]
[-0.0125 .21025 0 4.5 ]
[-0.0125 .29601 -24 -4.5 ]
[-0.0125 .29601 0 4.5 ]
[-0.0125 .38176 -18 -4.5 ]
[-0.0125 .38176 0 4.5 ]
[-0.0125 .46752 -24 -4.5 ]
[-0.0125 .46752 0 4.5 ]
[-0.0125 .55327 -18 -4.5 ]
[-0.0125 .55327 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .3061 -5 -6 ]
[.97619 .3061 5 6 ]
[.97619 .2823 -5 -6 ]
[.97619 .2823 5 6 ]
[.97619 .34597 -5 -6 ]
[.97619 .34597 5 6 ]
[.97619 .31413 -5 -6 ]
[.97619 .31413 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03874 m
.00625 .03874 L
s
[(4.5)] -0.0125 .03874 1 0 Mshowa
0 .1245 m
.00625 .1245 L
s
[(4.55)] -0.0125 .1245 1 0 Mshowa
0 .21025 m
.00625 .21025 L
s
[(4.6)] -0.0125 .21025 1 0 Mshowa
0 .29601 m
.00625 .29601 L
s
[(4.65)] -0.0125 .29601 1 0 Mshowa
0 .38176 m
.00625 .38176 L
s
[(4.7)] -0.0125 .38176 1 0 Mshowa
0 .46752 m
.00625 .46752 L
s
[(4.75)] -0.0125 .46752 1 0 Mshowa
0 .55327 m
.00625 .55327 L
s
[(4.8)] -0.0125 .55327 1 0 Mshowa
.125 Mabswid
0 .05589 m
.00375 .05589 L
s
0 .07304 m
.00375 .07304 L
s
0 .0902 m
.00375 .0902 L
s
0 .10735 m
.00375 .10735 L
s
0 .14165 m
.00375 .14165 L
s
0 .1588 m
.00375 .1588 L
s
0 .17595 m
.00375 .17595 L
s
0 .1931 m
.00375 .1931 L
s
0 .2274 m
.00375 .2274 L
s
0 .24456 m
.00375 .24456 L
s
0 .26171 m
.00375 .26171 L
s
0 .27886 m
.00375 .27886 L
s
0 .31316 m
.00375 .31316 L
s
0 .33031 m
.00375 .33031 L
s
0 .34746 m
.00375 .34746 L
s
0 .36461 m
.00375 .36461 L
s
0 .39891 m
.00375 .39891 L
s
0 .41607 m
.00375 .41607 L
s
0 .43322 m
.00375 .43322 L
s
0 .45037 m
.00375 .45037 L
s
0 .48467 m
.00375 .48467 L
s
0 .50182 m
.00375 .50182 L
s
0 .51897 m
.00375 .51897 L
s
0 .53612 m
.00375 .53612 L
s
0 .02159 m
.00375 .02159 L
s
0 .00444 m
.00375 .00444 L
s
0 .57042 m
.00375 .57042 L
s
0 .58758 m
.00375 .58758 L
s
0 .60473 m
.00375 .60473 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03874 m
1 .03874 L
s
.99375 .1245 m
1 .1245 L
s
.99375 .21025 m
1 .21025 L
s
.99375 .29601 m
1 .29601 L
s
.99375 .38176 m
1 .38176 L
s
.99375 .46752 m
1 .46752 L
s
.99375 .55327 m
1 .55327 L
s
.125 Mabswid
.99625 .05589 m
1 .05589 L
s
.99625 .07304 m
1 .07304 L
s
.99625 .0902 m
1 .0902 L
s
.99625 .10735 m
1 .10735 L
s
.99625 .14165 m
1 .14165 L
s
.99625 .1588 m
1 .1588 L
s
.99625 .17595 m
1 .17595 L
s
.99625 .1931 m
1 .1931 L
s
.99625 .2274 m
1 .2274 L
s
.99625 .24456 m
1 .24456 L
s
.99625 .26171 m
1 .26171 L
s
.99625 .27886 m
1 .27886 L
s
.99625 .31316 m
1 .31316 L
s
.99625 .33031 m
1 .33031 L
s
.99625 .34746 m
1 .34746 L
s
.99625 .36461 m
1 .36461 L
s
.99625 .39891 m
1 .39891 L
s
.99625 .41607 m
1 .41607 L
s
.99625 .43322 m
1 .43322 L
s
.99625 .45037 m
1 .45037 L
s
.99625 .48467 m
1 .48467 L
s
.99625 .50182 m
1 .50182 L
s
.99625 .51897 m
1 .51897 L
s
.99625 .53612 m
1 .53612 L
s
.99625 .02159 m
1 .02159 L
s
.99625 .00444 m
1 .00444 L
s
.99625 .57042 m
1 .57042 L
s
.99625 .58758 m
1 .58758 L
s
.99625 .60473 m
1 .60473 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .3061 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .21912 m
.02642 .22629 L
.02903 .22785 L
.03164 .20248 L
.03425 .21918 L
.03686 .21292 L
.03947 .23479 L
.04207 .26413 L
.04468 .27016 L
.04729 .29505 L
.0499 .26036 L
.05251 .27332 L
.05512 .25014 L
.05773 .27096 L
.06034 .29555 L
.06295 .31567 L
.06556 .33253 L
.06817 .3179 L
.07078 .28868 L
.07339 .33384 L
.07599 .31631 L
.0786 .30331 L
.08121 .2797 L
.08382 .28728 L
.08643 .30606 L
.08904 .30042 L
.09165 .31834 L
.09426 .38638 L
.09687 .34787 L
.09948 .33687 L
.10209 .33823 L
.1047 .36271 L
.10731 .37664 L
.10992 .35607 L
.11252 .3526 L
.11513 .36446 L
.11774 .34386 L
.12035 .35028 L
.12296 .34675 L
.12557 .32206 L
.12818 .34037 L
.13079 .3684 L
.1334 .37057 L
.13601 .34211 L
.13862 .34992 L
.14123 .33633 L
.14384 .34452 L
.14644 .34146 L
.14905 .32339 L
.15166 .30839 L
Mistroke
.15427 .31731 L
.15688 .33125 L
.15949 .35613 L
.1621 .32056 L
.16471 .29224 L
.16732 .29989 L
.16993 .30724 L
.17254 .2996 L
.17515 .28855 L
.17776 .30399 L
.18037 .28374 L
.18297 .28166 L
.18558 .29001 L
.18819 .28502 L
.1908 .28632 L
.19341 .28994 L
.19602 .27376 L
.19863 .26739 L
.20124 .21413 L
.20385 .21721 L
.20646 .22653 L
.20907 .22212 L
.21168 .21807 L
.21429 .23403 L
.21689 .23784 L
.2195 .2409 L
.22211 .21164 L
.22472 .23435 L
.22733 .26278 L
.22994 .25836 L
.23255 .26937 L
.23516 .27113 L
.23777 .22528 L
.24038 .23195 L
.24299 .2321 L
.2456 .24136 L
.24821 .23414 L
.25082 .2357 L
.25342 .24342 L
.25603 .23595 L
.25864 .23338 L
.26125 .23719 L
.26386 .23092 L
.26647 .22886 L
.26908 .23479 L
.27169 .24363 L
.2743 .24865 L
.27691 .2406 L
.27952 .21558 L
.28213 .23055 L
Mistroke
.28474 .23878 L
.28735 .21419 L
.28995 .19391 L
.29256 .20874 L
.29517 .19183 L
.29778 .21522 L
.30039 .17507 L
.303 .18124 L
.30561 .19452 L
.30822 .20043 L
.31083 .2278 L
.31344 .24714 L
.31605 .24563 L
.31866 .23853 L
.32127 .25729 L
.32387 .24963 L
.32648 .29383 L
.32909 .28577 L
.3317 .25268 L
.33431 .24982 L
.33692 .28899 L
.33953 .28638 L
.34214 .26588 L
.34475 .26341 L
.34736 .2724 L
.34997 .29245 L
.35258 .28644 L
.35519 .27626 L
.3578 .27335 L
.3604 .27202 L
.36301 .26883 L
.36562 .25355 L
.36823 .27788 L
.37084 .28248 L
.37345 .28019 L
.37606 .24742 L
.37867 .24817 L
.38128 .22544 L
.38389 .24388 L
.3865 .22321 L
.38911 .21863 L
.39172 .22873 L
.39432 .24434 L
.39693 .2185 L
.39954 .22633 L
.40215 .23961 L
.40476 .24707 L
.40737 .21731 L
.40998 .19718 L
.41259 .2093 L
Mistroke
.4152 .19411 L
.41781 .21454 L
.42042 .22363 L
.42303 .2206 L
.42564 .23632 L
.42825 .2192 L
.43085 .22215 L
.43346 .2332 L
.43607 .22755 L
.43868 .24452 L
.44129 .24404 L
.4439 .20974 L
.44651 .18691 L
.44912 .19896 L
.45173 .25074 L
.45434 .23076 L
.45695 .23138 L
.45956 .1985 L
.46217 .21424 L
.46477 .21517 L
.46738 .22525 L
.46999 .19259 L
.4726 .22066 L
.47521 .22969 L
.47782 .25127 L
.48043 .27044 L
.48304 .22164 L
.48565 .22795 L
.48826 .20395 L
.49087 .25675 L
.49348 .26359 L
.49609 .2519 L
.4987 .26638 L
.5013 .25982 L
.50391 .27055 L
.50652 .23886 L
.50913 .24185 L
.51174 .26847 L
.51435 .22732 L
.51696 .28024 L
.51957 .25857 L
.52218 .23519 L
.52479 .20267 L
.5274 .22502 L
.53001 .24093 L
.53262 .24364 L
.53523 .22232 L
.53783 .18776 L
.54044 .12805 L
.54305 .15624 L
Mistroke
.54566 .17087 L
.54827 .17617 L
.55088 .15167 L
.55349 .17376 L
.5561 .21124 L
.55871 .1717 L
.56132 .16523 L
.56393 .13639 L
.56654 .06204 L
.56915 .02169 L
.57175 .04465 L
.57436 .08595 L
.57697 .0812 L
.57958 .088 L
.58219 .07829 L
.5848 .07681 L
.58741 .07975 L
.59002 .10852 L
.59263 .1111 L
.59524 .11016 L
.59785 .10953 L
.60046 .12547 L
.60307 .11954 L
.60568 .1209 L
.60828 .18924 L
.61089 .21642 L
.6135 .17718 L
.61611 .19235 L
.61872 .18404 L
.62133 .19255 L
.62394 .21455 L
.62655 .23146 L
.62916 .31664 L
.63177 .30922 L
.63438 .35721 L
.63699 .31553 L
.6396 .27457 L
.6422 .26272 L
.64481 .27718 L
.64742 .27916 L
.65003 .29835 L
.65264 .32317 L
.65525 .35987 L
.65786 .35548 L
.66047 .4012 L
.66308 .39138 L
.66569 .38624 L
.6683 .40007 L
.67091 .33799 L
.67352 .30828 L
Mistroke
.67613 .31563 L
.67873 .33308 L
.68134 .29526 L
.68395 .35474 L
.68656 .36759 L
.68917 .41255 L
.69178 .4235 L
.69439 .38967 L
.697 .44695 L
.69961 .4849 L
.70222 .49224 L
.70483 .46578 L
.70744 .4666 L
.71005 .48779 L
.71265 .48814 L
.71526 .47302 L
.71787 .45485 L
.72048 .42533 L
.72309 .44892 L
.7257 .4087 L
.72831 .40193 L
.73092 .37737 L
.73353 .36415 L
.73614 .31438 L
.73875 .332 L
.74136 .37576 L
.74397 .40099 L
.74658 .4356 L
.74918 .47437 L
.75179 .45592 L
.7544 .43121 L
.75701 .38264 L
.75962 .45321 L
.76223 .44565 L
.76484 .43837 L
.76745 .40162 L
.77006 .39572 L
.77267 .4082 L
.77528 .44467 L
.77789 .46351 L
.7805 .51162 L
.78311 .51926 L
.78571 .51297 L
.78832 .51443 L
.79093 .52032 L
.79354 .43341 L
.79615 .41001 L
.79876 .44166 L
.80137 .45973 L
.80398 .47632 L
Mistroke
.80659 .40365 L
.8092 .37178 L
.81181 .37064 L
.81442 .32885 L
.81703 .34592 L
.81963 .34342 L
.82224 .41794 L
.82485 .39299 L
.82746 .44208 L
.83007 .42353 L
.83268 .45248 L
.83529 .41125 L
.8379 .38873 L
.84051 .36519 L
.84312 .37066 L
.84573 .3162 L
.84834 .31649 L
.85095 .25466 L
.85356 .27224 L
.85616 .32267 L
.85877 .27433 L
.86138 .26596 L
.86399 .31405 L
.8666 .36605 L
.86921 .41234 L
.87182 .45779 L
.87443 .48466 L
.87704 .42462 L
.87965 .3939 L
.88226 .46372 L
.88487 .42179 L
.88748 .38012 L
.89008 .36498 L
.89269 .39189 L
.8953 .40893 L
.89791 .37781 L
.90052 .34008 L
.90313 .34813 L
.90574 .32546 L
.90835 .33359 L
.91096 .30371 L
.91357 .30816 L
.91618 .31613 L
.91879 .28677 L
.9214 .31303 L
.92401 .31862 L
.92661 .33465 L
.92922 .28804 L
.93183 .27531 L
.93444 .29643 L
Mistroke
.93705 .29917 L
.93966 .27877 L
.94227 .27441 L
.94488 .2657 L
.94749 .31661 L
.9501 .24268 L
.95271 .27323 L
.95532 .26914 L
.95793 .27706 L
.96053 .3224 L
.96314 .33136 L
.96575 .34748 L
.96836 .31939 L
.97097 .29398 L
.97358 .31417 L
.97619 .3061 L
Mfstroke
0 .98 .604 r
gsave
.97619 .2823 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21918 m
.02642 .19948 L
.02903 .19137 L
.03164 .18519 L
.03425 .18001 L
.03686 .17546 L
.03947 .17137 L
.04207 .2638 L
.04468 .24542 L
.04729 .23786 L
.0499 .2321 L
.05251 .22727 L
.05512 .22304 L
.05773 .21923 L
.06034 .29541 L
.06295 .2792 L
.06556 .27254 L
.06817 .26748 L
.07078 .26324 L
.07339 .25952 L
.07599 .25618 L
.0786 .30322 L
.08121 .28959 L
.08382 .28401 L
.08643 .27977 L
.08904 .27623 L
.09165 .27313 L
.09426 .27034 L
.09687 .34775 L
.09948 .33293 L
.10209 .32685 L
.1047 .32223 L
.10731 .31836 L
.10992 .31498 L
.11252 .31193 L
.11513 .36455 L
.11774 .35158 L
.12035 .34628 L
.12296 .34226 L
.12557 .3389 L
.12818 .33595 L
.13079 .33331 L
.1334 .37037 L
.13601 .35935 L
.13862 .35486 L
.14123 .35145 L
.14384 .34861 L
.14644 .34613 L
.14905 .3439 L
.15166 .30818 L
Mistroke
.15427 .29677 L
.15688 .29212 L
.15949 .28859 L
.1621 .28564 L
.16471 .28306 L
.16732 .28075 L
.16993 .30704 L
.17254 .29837 L
.17515 .29485 L
.17776 .29219 L
.18037 .28997 L
.18297 .28803 L
.18558 .28628 L
.18819 .28478 L
.1908 .27571 L
.19341 .27202 L
.19602 .26923 L
.19863 .2669 L
.20124 .26487 L
.20385 .26304 L
.20646 .22629 L
.20907 .21677 L
.21168 .2129 L
.21429 .20998 L
.21689 .20753 L
.2195 .2054 L
.22211 .20348 L
.22472 .23433 L
.22733 .22716 L
.22994 .22425 L
.23255 .22206 L
.23516 .22023 L
.23777 .21863 L
.24038 .2172 L
.24299 .23175 L
.2456 .22497 L
.24821 .22222 L
.25082 .22016 L
.25342 .21844 L
.25603 .21694 L
.25864 .21559 L
.26125 .23685 L
.26386 .2308 L
.26647 .22837 L
.26908 .22654 L
.27169 .22502 L
.2743 .22369 L
.27691 .2225 L
.27952 .21551 L
.28213 .2083 L
Mistroke
.28474 .20538 L
.28735 .20319 L
.28995 .20136 L
.29256 .19977 L
.29517 .19834 L
.29778 .21472 L
.30039 .20843 L
.303 .20589 L
.30561 .20398 L
.30822 .2024 L
.31083 .20102 L
.31344 .19978 L
.31605 .24512 L
.31866 .23759 L
.32127 .23454 L
.32387 .23224 L
.32648 .23033 L
.32909 .22866 L
.3317 .22716 L
.33431 .24996 L
.33692 .2434 L
.33953 .24075 L
.34214 .23876 L
.34475 .2371 L
.34736 .23566 L
.34997 .23436 L
.35258 .28595 L
.35519 .27722 L
.3578 .27367 L
.3604 .27099 L
.36301 .26876 L
.36562 .2668 L
.36823 .26505 L
.37084 .28246 L
.37345 .27487 L
.37606 .27179 L
.37867 .26947 L
.38128 .26753 L
.38389 .26584 L
.3865 .26432 L
.38911 .21852 L
.39172 .20766 L
.39432 .20322 L
.39693 .19986 L
.39954 .19705 L
.40215 .19459 L
.40476 .19238 L
.40737 .21704 L
.40998 .2079 L
.41259 .20417 L
Mistroke
.4152 .20135 L
.41781 .199 L
.42042 .19694 L
.42303 .19508 L
.42564 .23612 L
.42825 .22771 L
.43085 .22429 L
.43346 .22171 L
.43607 .21955 L
.43868 .21766 L
.44129 .21596 L
.4439 .20982 L
.44651 .19951 L
.44912 .19531 L
.45173 .19212 L
.45434 .18946 L
.45695 .18714 L
.45956 .18504 L
.46217 .2139 L
.46477 .20514 L
.46738 .20157 L
.46999 .19887 L
.4726 .19662 L
.47521 .19464 L
.47782 .19287 L
.48043 .27011 L
.48304 .26097 L
.48565 .25725 L
.48826 .25444 L
.49087 .25209 L
.49348 .25003 L
.49609 .24819 L
.4987 .26593 L
.5013 .25854 L
.50391 .25554 L
.50652 .25328 L
.50913 .25139 L
.51174 .24974 L
.51435 .24825 L
.51696 .28002 L
.51957 .27323 L
.52218 .27048 L
.52479 .26841 L
.5274 .26668 L
.53001 .26517 L
.53262 .26381 L
.53523 .22218 L
.53783 .21217 L
.54044 .20809 L
.54305 .20499 L
Mistroke
.54566 .20241 L
.54827 .20015 L
.55088 .19811 L
.55349 .17365 L
.5561 .16319 L
.55871 .15892 L
.56132 .15569 L
.56393 .15299 L
.56654 .15063 L
.56915 .1485 L
.57175 .04453 L
.57436 .03216 L
.57697 .0271 L
.57958 .02326 L
.58219 .02005 L
.5848 .01724 L
.58741 .01472 L
.59002 .10842 L
.59263 .09584 L
.59524 .09069 L
.59785 .08679 L
.60046 .08352 L
.60307 .08067 L
.60568 .0781 L
.60828 .18902 L
.61089 .17627 L
.6135 .17106 L
.61611 .1671 L
.61872 .16379 L
.62133 .16089 L
.62394 .15829 L
.62655 .23126 L
.62916 .21685 L
.63177 .21094 L
.63438 .20646 L
.63699 .2027 L
.6396 .19941 L
.6422 .19646 L
.64481 .27677 L
.64742 .26118 L
.65003 .25478 L
.65264 .24992 L
.65525 .24585 L
.65786 .24228 L
.66047 .23908 L
.66308 .39104 L
.66569 .36719 L
.6683 .35734 L
.67091 .34981 L
.67352 .34349 L
Mistroke
.67613 .33793 L
.67873 .33293 L
.68134 .29506 L
.68395 .26905 L
.68656 .25829 L
.68917 .25006 L
.69178 .24314 L
.69439 .23707 L
.697 .23159 L
.69961 .48498 L
.70222 .4512 L
.70483 .43715 L
.70744 .42639 L
.71005 .41733 L
.71265 .40936 L
.71526 .40216 L
.71787 .4548 L
.72048 .42196 L
.72309 .40831 L
.7257 .39786 L
.72831 .38906 L
.73092 .38132 L
.73353 .37433 L
.73614 .31401 L
.73875 .27978 L
.74136 .26554 L
.74397 .25464 L
.74658 .24545 L
.74918 .23737 L
.75179 .23007 L
.7544 .43094 L
.75701 .39629 L
.75962 .38187 L
.76223 .37083 L
.76484 .36152 L
.76745 .35334 L
.77006 .34595 L
.77267 .40823 L
.77528 .37493 L
.77789 .36109 L
.7805 .35049 L
.78311 .34156 L
.78571 .33371 L
.78832 .32662 L
.79093 .52012 L
.79354 .48629 L
.79615 .47223 L
.79876 .46145 L
.80137 .45238 L
.80398 .4444 L
Mistroke
.80659 .43719 L
.8092 .37152 L
.81181 .33495 L
.81442 .31973 L
.81703 .30805 L
.81963 .29821 L
.82224 .28955 L
.82485 .28173 L
.82746 .44208 L
.83007 .40653 L
.83268 .39173 L
.83529 .38039 L
.8379 .37083 L
.84051 .36242 L
.84312 .35483 L
.84573 .3163 L
.84834 .27955 L
.85095 .26425 L
.85356 .25251 L
.85616 .24262 L
.85877 .23392 L
.86138 .22606 L
.86399 .31387 L
.8666 .27893 L
.86921 .2644 L
.87182 .25326 L
.87443 .24387 L
.87704 .23562 L
.87965 .22816 L
.88226 .46374 L
.88487 .42616 L
.88748 .4105 L
.89008 .39849 L
.89269 .38837 L
.8953 .37946 L
.89791 .37141 L
.90052 .33983 L
.90313 .30151 L
.90574 .28554 L
.90835 .27329 L
.91096 .26296 L
.91357 .25387 L
.91618 .24565 L
.91879 .28642 L
.9214 .24952 L
.92401 .23416 L
.92661 .22237 L
.92922 .21244 L
.93183 .2037 L
.93444 .1958 L
Mistroke
.93705 .29914 L
.93966 .26414 L
.94227 .24958 L
.94488 .23841 L
.94749 .22901 L
.9501 .22074 L
.95271 .21327 L
.95532 .26915 L
.95793 .23591 L
.96053 .22209 L
.96314 .21151 L
.96575 .20259 L
.96836 .19476 L
.97097 .18768 L
.97358 .31393 L
.97619 .2823 L
Mfstroke
gsave
.97619 .34597 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21952 m
.02642 .23963 L
.02903 .24817 L
.03164 .25477 L
.03425 .26038 L
.03686 .26534 L
.03947 .26986 L
.04207 .26415 L
.04468 .28298 L
.04729 .291 L
.0499 .29721 L
.05251 .30249 L
.05512 .30717 L
.05773 .31143 L
.06034 .29575 L
.06295 .31246 L
.06556 .31961 L
.06817 .32517 L
.07078 .3299 L
.07339 .33411 L
.07599 .33794 L
.0786 .30356 L
.08121 .31773 L
.08382 .32386 L
.08643 .32863 L
.08904 .33272 L
.09165 .33636 L
.09426 .33969 L
.09687 .3481 L
.09948 .36344 L
.10209 .37005 L
.1047 .37519 L
.10731 .37957 L
.10992 .38348 L
.11252 .38704 L
.11513 .36489 L
.11774 .3784 L
.12035 .38426 L
.12296 .38883 L
.12557 .39275 L
.12818 .39624 L
.13079 .39944 L
.1334 .37071 L
.13601 .38231 L
.13862 .38738 L
.14123 .39136 L
.14384 .39478 L
.14644 .39785 L
.14905 .40066 L
.15166 .30853 L
Mistroke
.15427 .32051 L
.15688 .32575 L
.15949 .32985 L
.1621 .33337 L
.16471 .33652 L
.16732 .33941 L
.16993 .30738 L
.17254 .31666 L
.17515 .32079 L
.17776 .32406 L
.18037 .32689 L
.18297 .32943 L
.18558 .33178 L
.18819 .28512 L
.1908 .2948 L
.19341 .29909 L
.19602 .30249 L
.19863 .30542 L
.20124 .30805 L
.20385 .31048 L
.20646 .22663 L
.20907 .23674 L
.21168 .24122 L
.21429 .24474 L
.21689 .24778 L
.2195 .25051 L
.22211 .25303 L
.22472 .23467 L
.22733 .24247 L
.22994 .246 L
.23255 .24881 L
.23516 .25126 L
.23777 .25348 L
.24038 .25554 L
.24299 .2321 L
.2456 .23951 L
.24821 .24288 L
.25082 .24557 L
.25342 .24792 L
.25603 .25004 L
.25864 .25201 L
.26125 .23719 L
.26386 .24387 L
.26647 .24694 L
.26908 .2494 L
.27169 .25155 L
.2743 .25351 L
.27691 .25533 L
.27952 .21585 L
.28213 .22369 L
Mistroke
.28474 .22723 L
.28735 .23004 L
.28995 .23249 L
.29256 .23471 L
.29517 .23676 L
.29778 .21506 L
.30039 .22198 L
.303 .22515 L
.30561 .22769 L
.30822 .2299 L
.31083 .23191 L
.31344 .23378 L
.31605 .24546 L
.31866 .25361 L
.32127 .25728 L
.32387 .2602 L
.32648 .26273 L
.32909 .26502 L
.3317 .26714 L
.33431 .25031 L
.33692 .25749 L
.33953 .26077 L
.34214 .26339 L
.34475 .26567 L
.34736 .26775 L
.34997 .26967 L
.35258 .28629 L
.35519 .29562 L
.3578 .29978 L
.3604 .30306 L
.36301 .30591 L
.36562 .30847 L
.36823 .31083 L
.37084 .28281 L
.37345 .29102 L
.37606 .29472 L
.37867 .29766 L
.38128 .30021 L
.38389 .30252 L
.3865 .30466 L
.38911 .21887 L
.39172 .23031 L
.39432 .23533 L
.39693 .23928 L
.39954 .24267 L
.40215 .24571 L
.40476 .2485 L
.40737 .21739 L
.40998 .22713 L
.41259 .23146 L
Mistroke
.4152 .23488 L
.41781 .23784 L
.42042 .2405 L
.42303 .24296 L
.42564 .23646 L
.42825 .24548 L
.43085 .24951 L
.43346 .2527 L
.43607 .25547 L
.43868 .25797 L
.44129 .26027 L
.4439 .21016 L
.44651 .22106 L
.44912 .22585 L
.45173 .22963 L
.45434 .23288 L
.45695 .23579 L
.45956 .23847 L
.46217 .21425 L
.46477 .22362 L
.46738 .2278 L
.46999 .23111 L
.4726 .23396 L
.47521 .23654 L
.47782 .23892 L
.48043 .27045 L
.48304 .28019 L
.48565 .28452 L
.48826 .28793 L
.49087 .29088 L
.49348 .29354 L
.49609 .29599 L
.4987 .26628 L
.5013 .27429 L
.50391 .27791 L
.50652 .28079 L
.50913 .2833 L
.51174 .28557 L
.51435 .28768 L
.51696 .28036 L
.51957 .28778 L
.52218 .29116 L
.52479 .29386 L
.5274 .29621 L
.53001 .29835 L
.53262 .30033 L
.53523 .22253 L
.53783 .23314 L
.54044 .23781 L
.54305 .2415 L
Mistroke
.54566 .24467 L
.54827 .24753 L
.55088 .25015 L
.55349 .174 L
.5561 .18505 L
.55871 .1899 L
.56132 .19372 L
.56393 .19701 L
.56654 .19996 L
.56915 .20267 L
.57175 .04487 L
.57436 .0578 L
.57697 .06342 L
.57958 .06782 L
.58219 .07159 L
.5848 .07496 L
.58741 .07804 L
.59002 .10876 L
.59263 .1219 L
.59524 .12761 L
.59785 .13207 L
.60046 .13589 L
.60307 .1393 L
.60568 .14243 L
.60828 .18936 L
.61089 .20267 L
.6135 .20844 L
.61611 .21295 L
.61872 .21682 L
.62133 .22027 L
.62394 .22342 L
.62655 .23161 L
.62916 .24655 L
.63177 .25299 L
.63438 .258 L
.63699 .26228 L
.6396 .2661 L
.6422 .26958 L
.64481 .27711 L
.64742 .29321 L
.65003 .30011 L
.65264 .30548 L
.65525 .31006 L
.65786 .31413 L
.66047 .31784 L
.66308 .39139 L
.66569 .41555 L
.6683 .42573 L
.67091 .43357 L
.67352 .44021 L
Mistroke
.67613 .44608 L
.67873 .4514 L
.68134 .29541 L
.68395 .32167 L
.68656 .33269 L
.68917 .34118 L
.69178 .34835 L
.69439 .35467 L
.697 .36041 L
.69961 .48532 L
.70222 .51909 L
.70483 .53312 L
.70744 .54387 L
.71005 .55293 L
.71265 .56089 L
.71526 .56808 L
.71787 .45514 L
.72048 .488 L
.72309 .50167 L
.7257 .51215 L
.72831 .52097 L
.73092 .52874 L
.73353 .53576 L
.73614 .31435 L
.73875 .34855 L
.74136 .36275 L
.74397 .37363 L
.74658 .38279 L
.74918 .39085 L
.75179 .39812 L
.7544 .43128 L
.75701 .46588 L
.75962 .48025 L
.76223 .49125 L
.76484 .50051 L
.76745 .50865 L
.77006 .516 L
.77267 .40857 L
.77528 .44187 L
.77789 .45572 L
.7805 .46633 L
.78311 .47526 L
.78571 .48313 L
.78832 .49023 L
.79093 .52046 L
.79354 .55427 L
.79615 .56832 L
.79876 .57909 L
.80137 .58815 L
.80398 .59612 L
Mistroke
.80659 .60332 L
.8092 .37186 L
.81181 .4083 L
.81442 .42341 L
.81703 .43496 L
.81963 .44468 L
.82224 .45322 L
.82485 .46092 L
.82746 .44242 L
.83007 .47789 L
.83268 .49261 L
.83529 .50387 L
.8379 .51334 L
.84051 .52168 L
.84312 .52919 L
.84573 .31664 L
.84834 .35326 L
.85095 .36843 L
.85356 .38003 L
.85616 .38979 L
.85877 .39837 L
.86138 .40611 L
.86399 .31421 L
.8666 .34909 L
.86921 .36356 L
.87182 .37465 L
.87443 .38398 L
.87704 .39218 L
.87965 .39958 L
.88226 .46408 L
.88487 .5015 L
.88748 .51699 L
.89008 .52883 L
.89269 .53879 L
.8953 .54754 L
.89791 .55543 L
.90052 .34017 L
.90313 .37829 L
.90574 .39406 L
.90835 .40611 L
.91096 .41625 L
.91357 .42515 L
.91618 .43317 L
.91879 .28677 L
.9214 .32352 L
.92401 .33875 L
.92661 .3504 L
.92922 .3602 L
.93183 .36881 L
.93444 .37657 L
Mistroke
.93705 .29949 L
.93966 .33443 L
.94227 .34893 L
.94488 .36003 L
.94749 .36937 L
.9501 .37759 L
.95271 .38501 L
.95532 .26949 L
.95793 .30274 L
.96053 .31656 L
.96314 .32716 L
.96575 .33608 L
.96836 .34393 L
.97097 .35102 L
.97358 .31427 L
.97619 .34597 L
Mfstroke
0 0 1 r
gsave
.97619 .31413 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21935 m
.02642 .21956 L
.02903 .21977 L
.03164 .21998 L
.03425 .22019 L
.03686 .2204 L
.03947 .22061 L
.04207 .26398 L
.04468 .2642 L
.04729 .26443 L
.0499 .26465 L
.05251 .26488 L
.05512 .2651 L
.05773 .26533 L
.06034 .29558 L
.06295 .29583 L
.06556 .29607 L
.06817 .29632 L
.07078 .29657 L
.07339 .29682 L
.07599 .29706 L
.0786 .30339 L
.08121 .30366 L
.08382 .30393 L
.08643 .3042 L
.08904 .30447 L
.09165 .30474 L
.09426 .30501 L
.09687 .34793 L
.09948 .34819 L
.10209 .34845 L
.1047 .34871 L
.10731 .34897 L
.10992 .34923 L
.11252 .34949 L
.11513 .36472 L
.11774 .36499 L
.12035 .36527 L
.12296 .36555 L
.12557 .36582 L
.12818 .3661 L
.13079 .36637 L
.1334 .37054 L
.13601 .37083 L
.13862 .37112 L
.14123 .37141 L
.14384 .3717 L
.14644 .37199 L
.14905 .37228 L
.15166 .30836 L
Mistroke
.15427 .30864 L
.15688 .30893 L
.15949 .30922 L
.1621 .30951 L
.16471 .30979 L
.16732 .31008 L
.16993 .30721 L
.17254 .30752 L
.17515 .30782 L
.17776 .30812 L
.18037 .30843 L
.18297 .30873 L
.18558 .30903 L
.18819 .28495 L
.1908 .28525 L
.19341 .28556 L
.19602 .28586 L
.19863 .28616 L
.20124 .28646 L
.20385 .28676 L
.20646 .22646 L
.20907 .22676 L
.21168 .22706 L
.21429 .22736 L
.21689 .22766 L
.2195 .22796 L
.22211 .22825 L
.22472 .2345 L
.22733 .23481 L
.22994 .23512 L
.23255 .23544 L
.23516 .23575 L
.23777 .23606 L
.24038 .23637 L
.24299 .23192 L
.2456 .23224 L
.24821 .23255 L
.25082 .23286 L
.25342 .23318 L
.25603 .23349 L
.25864 .2338 L
.26125 .23702 L
.26386 .23734 L
.26647 .23765 L
.26908 .23797 L
.27169 .23828 L
.2743 .2386 L
.27691 .23891 L
.27952 .21568 L
.28213 .21599 L
Mistroke
.28474 .21631 L
.28735 .21662 L
.28995 .21693 L
.29256 .21724 L
.29517 .21755 L
.29778 .21489 L
.30039 .2152 L
.303 .21552 L
.30561 .21584 L
.30822 .21615 L
.31083 .21646 L
.31344 .21678 L
.31605 .24529 L
.31866 .2456 L
.32127 .24591 L
.32387 .24622 L
.32648 .24653 L
.32909 .24684 L
.3317 .24715 L
.33431 .25013 L
.33692 .25045 L
.33953 .25076 L
.34214 .25108 L
.34475 .25139 L
.34736 .2517 L
.34997 .25202 L
.35258 .28612 L
.35519 .28642 L
.3578 .28673 L
.3604 .28703 L
.36301 .28733 L
.36562 .28764 L
.36823 .28794 L
.37084 .28263 L
.37345 .28294 L
.37606 .28325 L
.37867 .28356 L
.38128 .28387 L
.38389 .28418 L
.3865 .28449 L
.38911 .21869 L
.39172 .21899 L
.39432 .21928 L
.39693 .21957 L
.39954 .21986 L
.40215 .22015 L
.40476 .22044 L
.40737 .21721 L
.40998 .21752 L
.41259 .21782 L
Mistroke
.4152 .21812 L
.41781 .21842 L
.42042 .21872 L
.42303 .21902 L
.42564 .23629 L
.42825 .2366 L
.43085 .2369 L
.43346 .23721 L
.43607 .23751 L
.43868 .23782 L
.44129 .23812 L
.4439 .20999 L
.44651 .21029 L
.44912 .21058 L
.45173 .21088 L
.45434 .21117 L
.45695 .21146 L
.45956 .21176 L
.46217 .21408 L
.46477 .21438 L
.46738 .21468 L
.46999 .21499 L
.4726 .21529 L
.47521 .21559 L
.47782 .2159 L
.48043 .27028 L
.48304 .27058 L
.48565 .27088 L
.48826 .27118 L
.49087 .27149 L
.49348 .27179 L
.49609 .27209 L
.4987 .2661 L
.5013 .26642 L
.50391 .26673 L
.50652 .26704 L
.50913 .26735 L
.51174 .26766 L
.51435 .26796 L
.51696 .28019 L
.51957 .28051 L
.52218 .28082 L
.52479 .28113 L
.5274 .28145 L
.53001 .28176 L
.53262 .28207 L
.53523 .22236 L
.53783 .22265 L
.54044 .22295 L
.54305 .22325 L
Mistroke
.54566 .22354 L
.54827 .22384 L
.55088 .22413 L
.55349 .17383 L
.5561 .17412 L
.55871 .17441 L
.56132 .17471 L
.56393 .175 L
.56654 .17529 L
.56915 .17559 L
.57175 .0447 L
.57436 .04498 L
.57697 .04526 L
.57958 .04554 L
.58219 .04582 L
.5848 .0461 L
.58741 .04638 L
.59002 .10859 L
.59263 .10887 L
.59524 .10915 L
.59785 .10943 L
.60046 .10971 L
.60307 .10999 L
.60568 .11026 L
.60828 .18919 L
.61089 .18947 L
.6135 .18975 L
.61611 .19003 L
.61872 .1903 L
.62133 .19058 L
.62394 .19086 L
.62655 .23144 L
.62916 .2317 L
.63177 .23196 L
.63438 .23223 L
.63699 .23249 L
.6396 .23276 L
.6422 .23302 L
.64481 .27694 L
.64742 .27719 L
.65003 .27745 L
.65264 .2777 L
.65525 .27795 L
.65786 .27821 L
.66047 .27846 L
.66308 .39121 L
.66569 .39137 L
.6683 .39153 L
.67091 .39169 L
.67352 .39185 L
Mistroke
.67613 .39201 L
.67873 .39217 L
.68134 .29524 L
.68395 .29536 L
.68656 .29549 L
.68917 .29562 L
.69178 .29574 L
.69439 .29587 L
.697 .296 L
.69961 .48515 L
.70222 .48514 L
.70483 .48514 L
.70744 .48513 L
.71005 .48513 L
.71265 .48512 L
.71526 .48512 L
.71787 .45497 L
.72048 .45498 L
.72309 .45499 L
.7257 .455 L
.72831 .45502 L
.73092 .45503 L
.73353 .45504 L
.73614 .31418 L
.73875 .31416 L
.74136 .31415 L
.74397 .31413 L
.74658 .31412 L
.74918 .31411 L
.75179 .31409 L
.7544 .43111 L
.75701 .43108 L
.75962 .43106 L
.76223 .43104 L
.76484 .43102 L
.76745 .43099 L
.77006 .43097 L
.77267 .4084 L
.77528 .4084 L
.77789 .40841 L
.7805 .40841 L
.78311 .40841 L
.78571 .40842 L
.78832 .40842 L
.79093 .52029 L
.79354 .52028 L
.79615 .52028 L
.79876 .52027 L
.80137 .52026 L
.80398 .52026 L
Mistroke
.80659 .52025 L
.8092 .37169 L
.81181 .37163 L
.81442 .37157 L
.81703 .37151 L
.81963 .37144 L
.82224 .37139 L
.82485 .37133 L
.82746 .44225 L
.83007 .44221 L
.83268 .44217 L
.83529 .44213 L
.8379 .44209 L
.84051 .44205 L
.84312 .44201 L
.84573 .31647 L
.84834 .3164 L
.85095 .31634 L
.85356 .31627 L
.85616 .31621 L
.85877 .31614 L
.86138 .31608 L
.86399 .31404 L
.8666 .31401 L
.86921 .31398 L
.87182 .31395 L
.87443 .31393 L
.87704 .3139 L
.87965 .31387 L
.88226 .46391 L
.88487 .46383 L
.88748 .46374 L
.89008 .46366 L
.89269 .46358 L
.8953 .4635 L
.89791 .46342 L
.90052 .34 L
.90313 .3399 L
.90574 .3398 L
.90835 .3397 L
.91096 .3396 L
.91357 .33951 L
.91618 .33941 L
.91879 .28659 L
.9214 .28652 L
.92401 .28646 L
.92661 .28639 L
.92922 .28632 L
.93183 .28625 L
.93444 .28619 L
Mistroke
.93705 .29931 L
.93966 .29928 L
.94227 .29925 L
.94488 .29922 L
.94749 .29919 L
.9501 .29917 L
.95271 .29914 L
.95532 .26932 L
.95793 .26932 L
.96053 .26933 L
.96314 .26933 L
.96575 .26934 L
.96836 .26934 L
.97097 .26935 L
.97358 .3141 L
.97619 .31413 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 0.0586403 1.0836 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05864 -6 -4.5 ]
[-0.0125 .05864 0 4.5 ]
[-0.0125 .167 -18 -4.5 ]
[-0.0125 .167 0 4.5 ]
[-0.0125 .27536 -18 -4.5 ]
[-0.0125 .27536 0 4.5 ]
[-0.0125 .38372 -18 -4.5 ]
[-0.0125 .38372 0 4.5 ]
[-0.0125 .49208 -18 -4.5 ]
[-0.0125 .49208 0 4.5 ]
[-0.0125 .60044 -18 -4.5 ]
[-0.0125 .60044 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .35089 -5 -6 ]
[.97619 .35089 5 6 ]
[.97619 .43099 -5 -6 ]
[.97619 .43099 5 6 ]
[.97619 .52462 -5 -6 ]
[.97619 .52462 5 6 ]
[.97619 .33737 -5 -6 ]
[.97619 .33737 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05864 m
.00625 .05864 L
s
[(0)] -0.0125 .05864 1 0 Mshowa
0 .167 m
.00625 .167 L
s
[(0.1)] -0.0125 .167 1 0 Mshowa
0 .27536 m
.00625 .27536 L
s
[(0.2)] -0.0125 .27536 1 0 Mshowa
0 .38372 m
.00625 .38372 L
s
[(0.3)] -0.0125 .38372 1 0 Mshowa
0 .49208 m
.00625 .49208 L
s
[(0.4)] -0.0125 .49208 1 0 Mshowa
0 .60044 m
.00625 .60044 L
s
[(0.5)] -0.0125 .60044 1 0 Mshowa
.125 Mabswid
0 .08031 m
.00375 .08031 L
s
0 .10198 m
.00375 .10198 L
s
0 .12366 m
.00375 .12366 L
s
0 .14533 m
.00375 .14533 L
s
0 .18867 m
.00375 .18867 L
s
0 .21034 m
.00375 .21034 L
s
0 .23202 m
.00375 .23202 L
s
0 .25369 m
.00375 .25369 L
s
0 .29703 m
.00375 .29703 L
s
0 .3187 m
.00375 .3187 L
s
0 .34038 m
.00375 .34038 L
s
0 .36205 m
.00375 .36205 L
s
0 .40539 m
.00375 .40539 L
s
0 .42706 m
.00375 .42706 L
s
0 .44874 m
.00375 .44874 L
s
0 .47041 m
.00375 .47041 L
s
0 .51375 m
.00375 .51375 L
s
0 .53542 m
.00375 .53542 L
s
0 .5571 m
.00375 .5571 L
s
0 .57877 m
.00375 .57877 L
s
0 .03697 m
.00375 .03697 L
s
0 .0153 m
.00375 .0153 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05864 m
1 .05864 L
s
.99375 .167 m
1 .167 L
s
.99375 .27536 m
1 .27536 L
s
.99375 .38372 m
1 .38372 L
s
.99375 .49208 m
1 .49208 L
s
.99375 .60044 m
1 .60044 L
s
.125 Mabswid
.99625 .08031 m
1 .08031 L
s
.99625 .10198 m
1 .10198 L
s
.99625 .12366 m
1 .12366 L
s
.99625 .14533 m
1 .14533 L
s
.99625 .18867 m
1 .18867 L
s
.99625 .21034 m
1 .21034 L
s
.99625 .23202 m
1 .23202 L
s
.99625 .25369 m
1 .25369 L
s
.99625 .29703 m
1 .29703 L
s
.99625 .3187 m
1 .3187 L
s
.99625 .34038 m
1 .34038 L
s
.99625 .36205 m
1 .36205 L
s
.99625 .40539 m
1 .40539 L
s
.99625 .42706 m
1 .42706 L
s
.99625 .44874 m
1 .44874 L
s
.99625 .47041 m
1 .47041 L
s
.99625 .51375 m
1 .51375 L
s
.99625 .53542 m
1 .53542 L
s
.99625 .5571 m
1 .5571 L
s
.99625 .57877 m
1 .57877 L
s
.99625 .03697 m
1 .03697 L
s
.99625 .0153 m
1 .0153 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .35089 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .27536 m
.02642 .27962 L
.02903 .27535 L
.03164 .28877 L
.03425 .30082 L
.03686 .29283 L
.03947 .27953 L
.04207 .28102 L
.04468 .29366 L
.04729 .31283 L
.0499 .31035 L
.05251 .31068 L
.05512 .34126 L
.05773 .36225 L
.06034 .36454 L
.06295 .36217 L
.06556 .34704 L
.06817 .34292 L
.07078 .35317 L
.07339 .33542 L
.07599 .34034 L
.0786 .33793 L
.08121 .32375 L
.08382 .32565 L
.08643 .31647 L
.08904 .32554 L
.09165 .32068 L
.09426 .30694 L
.09687 .29748 L
.09948 .27388 L
.10209 .27344 L
.1047 .25683 L
.10731 .26163 L
.10992 .27236 L
.11252 .26291 L
.11513 .26225 L
.11774 .25671 L
.12035 .25522 L
.12296 .2633 L
.12557 .26689 L
.12818 .26827 L
.13079 .28645 L
.1334 .28214 L
.13601 .28969 L
.13862 .28874 L
.14123 .27609 L
.14384 .29136 L
.14644 .31629 L
.14905 .31177 L
.15166 .30586 L
Mistroke
.15427 .29355 L
.15688 .30327 L
.15949 .2962 L
.1621 .30226 L
.16471 .29041 L
.16732 .28462 L
.16993 .30128 L
.17254 .29839 L
.17515 .29003 L
.17776 .30429 L
.18037 .27762 L
.18297 .26456 L
.18558 .26113 L
.18819 .24297 L
.1908 .23106 L
.19341 .24842 L
.19602 .2391 L
.19863 .25663 L
.20124 .24692 L
.20385 .25809 L
.20646 .25425 L
.20907 .25047 L
.21168 .25948 L
.21429 .24747 L
.21689 .26327 L
.2195 .26787 L
.22211 .25657 L
.22472 .27674 L
.22733 .25222 L
.22994 .25076 L
.23255 .25975 L
.23516 .26309 L
.23777 .27686 L
.24038 .26619 L
.24299 .25359 L
.2456 .24801 L
.24821 .25137 L
.25082 .24933 L
.25342 .24549 L
.25603 .25463 L
.25864 .25066 L
.26125 .26472 L
.26386 .26681 L
.26647 .26651 L
.26908 .28505 L
.27169 .27892 L
.2743 .27896 L
.27691 .28473 L
.27952 .28075 L
.28213 .29562 L
Mistroke
.28474 .29561 L
.28735 .28581 L
.28995 .2763 L
.29256 .26367 L
.29517 .26024 L
.29778 .2544 L
.30039 .25579 L
.303 .25432 L
.30561 .24725 L
.30822 .25333 L
.31083 .25478 L
.31344 .26447 L
.31605 .25823 L
.31866 .27574 L
.32127 .28959 L
.32387 .27656 L
.32648 .2731 L
.32909 .26924 L
.3317 .2827 L
.33431 .2668 L
.33692 .28115 L
.33953 .28188 L
.34214 .28519 L
.34475 .2796 L
.34736 .26824 L
.34997 .26058 L
.35258 .26228 L
.35519 .28469 L
.3578 .275 L
.3604 .29088 L
.36301 .29311 L
.36562 .28456 L
.36823 .26796 L
.37084 .28701 L
.37345 .29789 L
.37606 .29658 L
.37867 .29412 L
.38128 .29212 L
.38389 .283 L
.3865 .27167 L
.38911 .27493 L
.39172 .29172 L
.39432 .30861 L
.39693 .30329 L
.39954 .30087 L
.40215 .30258 L
.40476 .31344 L
.40737 .29555 L
.40998 .29117 L
.41259 .28543 L
Mistroke
.4152 .28989 L
.41781 .29843 L
.42042 .28122 L
.42303 .27766 L
.42564 .29544 L
.42825 .28246 L
.43085 .2957 L
.43346 .30575 L
.43607 .32459 L
.43868 .31212 L
.44129 .32709 L
.4439 .35039 L
.44651 .36096 L
.44912 .36177 L
.45173 .36028 L
.45434 .35208 L
.45695 .35592 L
.45956 .37622 L
.46217 .38494 L
.46477 .38306 L
.46738 .40085 L
.46999 .38563 L
.4726 .38898 L
.47521 .38518 L
.47782 .38556 L
.48043 .40933 L
.48304 .41003 L
.48565 .4153 L
.48826 .41816 L
.49087 .41034 L
.49348 .43077 L
.49609 .40527 L
.4987 .37405 L
.5013 .38168 L
.50391 .3777 L
.50652 .37071 L
.50913 .36088 L
.51174 .36844 L
.51435 .38478 L
.51696 .37733 L
.51957 .38825 L
.52218 .36078 L
.52479 .36681 L
.5274 .39385 L
.53001 .39446 L
.53262 .40626 L
.53523 .41037 L
.53783 .42525 L
.54044 .4336 L
.54305 .43498 L
Mistroke
.54566 .41549 L
.54827 .41461 L
.55088 .42755 L
.55349 .43852 L
.5561 .45738 L
.55871 .46272 L
.56132 .46384 L
.56393 .46855 L
.56654 .45122 L
.56915 .44711 L
.57175 .41997 L
.57436 .42955 L
.57697 .44695 L
.57958 .47145 L
.58219 .47669 L
.5848 .46756 L
.58741 .47402 L
.59002 .47059 L
.59263 .47844 L
.59524 .48803 L
.59785 .4798 L
.60046 .46844 L
.60307 .46564 L
.60568 .44426 L
.60828 .45788 L
.61089 .45524 L
.6135 .47166 L
.61611 .45171 L
.61872 .43518 L
.62133 .42509 L
.62394 .42724 L
.62655 .43631 L
.62916 .42958 L
.63177 .43683 L
.63438 .44025 L
.63699 .4533 L
.6396 .44695 L
.6422 .43811 L
.64481 .44929 L
.64742 .45682 L
.65003 .43501 L
.65264 .44916 L
.65525 .43971 L
.65786 .43069 L
.66047 .43986 L
.66308 .45302 L
.66569 .44632 L
.6683 .46423 L
.67091 .47231 L
.67352 .47794 L
Mistroke
.67613 .47372 L
.67873 .4514 L
.68134 .46254 L
.68395 .4485 L
.68656 .44591 L
.68917 .45137 L
.69178 .43401 L
.69439 .43351 L
.697 .45375 L
.69961 .46688 L
.70222 .44531 L
.70483 .43703 L
.70744 .43031 L
.71005 .43287 L
.71265 .42745 L
.71526 .43363 L
.71787 .41869 L
.72048 .41308 L
.72309 .40626 L
.7257 .39422 L
.72831 .40521 L
.73092 .41397 L
.73353 .42684 L
.73614 .43174 L
.73875 .41825 L
.74136 .41058 L
.74397 .40762 L
.74658 .41812 L
.74918 .42633 L
.75179 .43123 L
.7544 .44846 L
.75701 .45562 L
.75962 .46675 L
.76223 .45624 L
.76484 .45193 L
.76745 .43441 L
.77006 .42483 L
.77267 .43193 L
.77528 .4555 L
.77789 .47814 L
.7805 .49196 L
.78311 .47059 L
.78571 .46393 L
.78832 .48476 L
.79093 .48379 L
.79354 .47849 L
.79615 .4756 L
.79876 .47298 L
.80137 .4736 L
.80398 .49486 L
Mistroke
.80659 .49574 L
.8092 .49353 L
.81181 .48239 L
.81442 .50335 L
.81703 .4879 L
.81963 .48819 L
.82224 .49807 L
.82485 .49315 L
.82746 .50017 L
.83007 .49603 L
.83268 .49647 L
.83529 .49418 L
.8379 .4919 L
.84051 .50422 L
.84312 .49586 L
.84573 .49854 L
.84834 .50968 L
.85095 .50983 L
.85356 .50756 L
.85616 .50185 L
.85877 .48305 L
.86138 .49436 L
.86399 .48757 L
.8666 .4708 L
.86921 .46158 L
.87182 .45532 L
.87443 .44415 L
.87704 .43521 L
.87965 .43009 L
.88226 .42658 L
.88487 .41973 L
.88748 .43684 L
.89008 .43473 L
.89269 .44834 L
.8953 .45583 L
.89791 .43694 L
.90052 .44013 L
.90313 .43342 L
.90574 .42823 L
.90835 .43743 L
.91096 .40648 L
.91357 .40711 L
.91618 .39795 L
.91879 .40563 L
.9214 .41694 L
.92401 .4137 L
.92661 .41898 L
.92922 .40358 L
.93183 .39492 L
.93444 .41069 L
Mistroke
.93705 .41425 L
.93966 .39952 L
.94227 .4011 L
.94488 .40783 L
.94749 .40363 L
.9501 .40816 L
.95271 .40953 L
.95532 .39143 L
.95793 .39199 L
.96053 .37983 L
.96314 .38848 L
.96575 .36856 L
.96836 .36568 L
.97097 .35508 L
.97358 .34323 L
.97619 .35089 L
Mfstroke
0 0 1 r
gsave
.97619 .43099 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27536 m
.02642 .27536 L
.02903 .27536 L
.03164 .27536 L
.03425 .27536 L
.03686 .27536 L
.03947 .27536 L
.04207 .25898 L
.04468 .25902 L
.04729 .25907 L
.0499 .25911 L
.05251 .25915 L
.05512 .2592 L
.05773 .25924 L
.06034 .2333 L
.06295 .23342 L
.06556 .23353 L
.06817 .23365 L
.07078 .23376 L
.07339 .23387 L
.07599 .23399 L
.0786 .20264 L
.08121 .20284 L
.08382 .20304 L
.08643 .20324 L
.08904 .20343 L
.09165 .20363 L
.09426 .20383 L
.09687 .2173 L
.09948 .21746 L
.10209 .21762 L
.1047 .21778 L
.10731 .21794 L
.10992 .21809 L
.11252 .21825 L
.11513 .19155 L
.11774 .19178 L
.12035 .19201 L
.12296 .19224 L
.12557 .19247 L
.12818 .19269 L
.13079 .19292 L
.1334 .16373 L
.13601 .16404 L
.13862 .16434 L
.14123 .16465 L
.14384 .16495 L
.14644 .16525 L
.14905 .16555 L
.15166 .16727 L
Mistroke
.15427 .16756 L
.15688 .16786 L
.15949 .16815 L
.1621 .16845 L
.16471 .16874 L
.16732 .16903 L
.16993 .13844 L
.17254 .13881 L
.17515 .13919 L
.17776 .13956 L
.18037 .13993 L
.18297 .1403 L
.18558 .14067 L
.18819 .14133 L
.1908 .1417 L
.19341 .14207 L
.19602 .14243 L
.19863 .1428 L
.20124 .14316 L
.20385 .14352 L
.20646 .14492 L
.20907 .14527 L
.21168 .14563 L
.21429 .14598 L
.21689 .14634 L
.2195 .14669 L
.22211 .14705 L
.22472 .12031 L
.22733 .12073 L
.22994 .12116 L
.23255 .12158 L
.23516 .122 L
.23777 .12242 L
.24038 .12284 L
.24299 .10429 L
.2456 .10476 L
.24821 .10523 L
.25082 .10569 L
.25342 .10616 L
.25603 .10662 L
.25864 .10708 L
.26125 .08854 L
.26386 .08906 L
.26647 .08957 L
.26908 .09007 L
.27169 .09058 L
.2743 .09109 L
.27691 .09159 L
.27952 .10577 L
.28213 .10624 L
Mistroke
.28474 .1067 L
.28735 .10716 L
.28995 .10762 L
.29256 .10808 L
.29517 .10854 L
.29778 .09134 L
.30039 .09184 L
.303 .09235 L
.30561 .09285 L
.30822 .09335 L
.31083 .09385 L
.31344 .09434 L
.31605 .11276 L
.31866 .11321 L
.32127 .11365 L
.32387 .1141 L
.32648 .11454 L
.32909 .11498 L
.3317 .11542 L
.33431 .09704 L
.33692 .09753 L
.33953 .09801 L
.34214 .0985 L
.34475 .09898 L
.34736 .09947 L
.34997 .09995 L
.35258 .14009 L
.35519 .14046 L
.3578 .14083 L
.3604 .14119 L
.36301 .14156 L
.36562 .14193 L
.36823 .14229 L
.37084 .12193 L
.37345 .12235 L
.37606 .12277 L
.37867 .12319 L
.38128 .1236 L
.38389 .12402 L
.3865 .12444 L
.38911 .18128 L
.39172 .18154 L
.39432 .1818 L
.39693 .18205 L
.39954 .18231 L
.40215 .18256 L
.40476 .18282 L
.40737 .16089 L
.40998 .16121 L
.41259 .16152 L
Mistroke
.4152 .16183 L
.41781 .16214 L
.42042 .16245 L
.42303 .16276 L
.42564 .14883 L
.42825 .14917 L
.43085 .14952 L
.43346 .14987 L
.43607 .15021 L
.43868 .15055 L
.44129 .15089 L
.4439 .17161 L
.44651 .17189 L
.44912 .17217 L
.45173 .17246 L
.45434 .17274 L
.45695 .17302 L
.45956 .1733 L
.46217 .15101 L
.46477 .15135 L
.46738 .15169 L
.46999 .15203 L
.4726 .15237 L
.47521 .1527 L
.47782 .15304 L
.48043 .15246 L
.48304 .1528 L
.48565 .15314 L
.48826 .15347 L
.49087 .1538 L
.49348 .15414 L
.49609 .15447 L
.4987 .13199 L
.5013 .13238 L
.50391 .13277 L
.50652 .13316 L
.50913 .13355 L
.51174 .13394 L
.51435 .13433 L
.51696 .1189 L
.51957 .11933 L
.52218 .11976 L
.52479 .12019 L
.5274 .12061 L
.53001 .12104 L
.53262 .12146 L
.53523 .17 L
.53783 .17029 L
.54044 .17057 L
.54305 .17086 L
Mistroke
.54566 .17115 L
.54827 .17143 L
.55088 .17172 L
.55349 .17281 L
.5561 .17309 L
.55871 .17337 L
.56132 .17365 L
.56393 .17393 L
.56654 .17421 L
.56915 .17449 L
.57175 .19459 L
.57436 .19481 L
.57697 .19503 L
.57958 .19525 L
.58219 .19547 L
.5848 .19569 L
.58741 .19591 L
.59002 .19499 L
.59263 .19521 L
.59524 .19543 L
.59785 .19565 L
.60046 .19587 L
.60307 .19609 L
.60568 .1963 L
.60828 .19494 L
.61089 .19516 L
.6135 .19538 L
.61611 .1956 L
.61872 .19581 L
.62133 .19603 L
.62394 .19625 L
.62655 .21347 L
.62916 .21364 L
.63177 .21381 L
.63438 .21398 L
.63699 .21415 L
.6396 .21432 L
.6422 .21448 L
.64481 .22603 L
.64742 .22616 L
.65003 .2263 L
.65264 .22643 L
.65525 .22656 L
.65786 .2267 L
.66047 .22683 L
.66308 .34865 L
.66569 .34845 L
.6683 .34825 L
.67091 .34805 L
.67352 .34785 L
Mistroke
.67613 .34766 L
.67873 .34746 L
.68134 .36714 L
.68395 .36689 L
.68656 .36664 L
.68917 .36639 L
.69178 .36614 L
.69439 .36589 L
.697 .36564 L
.69961 .46551 L
.70222 .46499 L
.70483 .46447 L
.70744 .46395 L
.71005 .46344 L
.71265 .46292 L
.71526 .46241 L
.71787 .45399 L
.72048 .4535 L
.72309 .45301 L
.7257 .45253 L
.72831 .45204 L
.73092 .45156 L
.73353 .45108 L
.73614 .46877 L
.73875 .46824 L
.74136 .46771 L
.74397 .46718 L
.74658 .46666 L
.74918 .46613 L
.75179 .46561 L
.7544 .47282 L
.75701 .47228 L
.75962 .47174 L
.76223 .4712 L
.76484 .47067 L
.76745 .47013 L
.77006 .4696 L
.77267 .45636 L
.77528 .45587 L
.77789 .45537 L
.7805 .45488 L
.78311 .45439 L
.78571 .4539 L
.78832 .45341 L
.79093 .46161 L
.79354 .4611 L
.79615 .46059 L
.79876 .46008 L
.80137 .45958 L
.80398 .45907 L
Mistroke
.80659 .45857 L
.8092 .49389 L
.81181 .49329 L
.81442 .49269 L
.81703 .4921 L
.81963 .4915 L
.82224 .49091 L
.82485 .49032 L
.82746 .48106 L
.83007 .4805 L
.83268 .47993 L
.83529 .47937 L
.8379 .47881 L
.84051 .47826 L
.84312 .4777 L
.84573 .49475 L
.84834 .49415 L
.85095 .49355 L
.85356 .49296 L
.85616 .49236 L
.85877 .49177 L
.86138 .49117 L
.86399 .47272 L
.8666 .47218 L
.86921 .47164 L
.87182 .4711 L
.87443 .47057 L
.87704 .47003 L
.87965 .4695 L
.88226 .50495 L
.88487 .50432 L
.88748 .50369 L
.89008 .50307 L
.89269 .50244 L
.8953 .50182 L
.89791 .5012 L
.90052 .51314 L
.90313 .51249 L
.90574 .51184 L
.90835 .51119 L
.91096 .51054 L
.91357 .5099 L
.91618 .50925 L
.91879 .49575 L
.9214 .49515 L
.92401 .49454 L
.92661 .49394 L
.92922 .49334 L
.93183 .49275 L
.93444 .49215 L
Mistroke
.93705 .47269 L
.93966 .47215 L
.94227 .47161 L
.94488 .47107 L
.94749 .47053 L
.9501 .47 L
.95271 .46947 L
.95532 .45129 L
.95793 .4508 L
.96053 .45032 L
.96314 .44984 L
.96575 .44937 L
.96836 .44889 L
.97097 .44841 L
.97358 .43142 L
.97619 .43099 L
Mfstroke
0 .98 .604 r
gsave
.97619 .52462 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38372 m
.02642 .38402 L
.02903 .38431 L
.03164 .3846 L
.03425 .38489 L
.03686 .38518 L
.03947 .38546 L
.04207 .36502 L
.04468 .36539 L
.04729 .36574 L
.0499 .3661 L
.05251 .36645 L
.05512 .3668 L
.05773 .36715 L
.06034 .33221 L
.06295 .33271 L
.06556 .3332 L
.06817 .33368 L
.07078 .33417 L
.07339 .33465 L
.07599 .33512 L
.0786 .29269 L
.08121 .29336 L
.08382 .29402 L
.08643 .29467 L
.08904 .29532 L
.09165 .29597 L
.09426 .29661 L
.09687 .3108 L
.09948 .31139 L
.10209 .31197 L
.1047 .31256 L
.10731 .31313 L
.10992 .3137 L
.11252 .31427 L
.11513 .2839 L
.11774 .28457 L
.12035 .28524 L
.12296 .2859 L
.12557 .28656 L
.12818 .28721 L
.13079 .28786 L
.1334 .25398 L
.13601 .25475 L
.13862 .25551 L
.14123 .25627 L
.14384 .25703 L
.14644 .25777 L
.14905 .25852 L
.15166 .26067 L
Mistroke
.15427 .26139 L
.15688 .26212 L
.15949 .26284 L
.1621 .26355 L
.16471 .26426 L
.16732 .26496 L
.16993 .21466 L
.17254 .21566 L
.17515 .21666 L
.17776 .21765 L
.18037 .21863 L
.18297 .2196 L
.18558 .22056 L
.18819 .22155 L
.1908 .2225 L
.19341 .22344 L
.19602 .22437 L
.19863 .22529 L
.20124 .22621 L
.20385 .22712 L
.20646 .22905 L
.20907 .22994 L
.21168 .23082 L
.21429 .2317 L
.21689 .23257 L
.2195 .23343 L
.22211 .23428 L
.22472 .18909 L
.22733 .19026 L
.22994 .19142 L
.23255 .19256 L
.23516 .19369 L
.23777 .19481 L
.24038 .19591 L
.24299 .17924 L
.2456 .18036 L
.24821 .18147 L
.25082 .18257 L
.25342 .18365 L
.25603 .18473 L
.25864 .1858 L
.26125 .16149 L
.26386 .16268 L
.26647 .16386 L
.26908 .16503 L
.27169 .16619 L
.2743 .16733 L
.27691 .16847 L
.27952 .18574 L
.28213 .18679 L
Mistroke
.28474 .18783 L
.28735 .18886 L
.28995 .18989 L
.29256 .1909 L
.29517 .19191 L
.29778 .16629 L
.30039 .16745 L
.303 .16859 L
.30561 .16973 L
.30822 .17085 L
.31083 .17197 L
.31344 .17307 L
.31605 .19286 L
.31866 .19389 L
.32127 .19491 L
.32387 .19592 L
.32648 .19692 L
.32909 .19792 L
.3317 .1989 L
.33431 .1729 L
.33692 .17403 L
.33953 .17514 L
.34214 .17625 L
.34475 .17735 L
.34736 .17843 L
.34997 .17951 L
.35258 .21555 L
.35519 .21656 L
.3578 .21756 L
.3604 .21856 L
.36301 .21954 L
.36562 .22052 L
.36823 .22149 L
.37084 .19604 L
.37345 .19712 L
.37606 .19819 L
.37867 .19925 L
.38128 .2003 L
.38389 .20135 L
.3865 .20238 L
.38911 .24166 L
.39172 .24282 L
.39432 .24395 L
.39693 .24506 L
.39954 .24616 L
.40215 .24725 L
.40476 .24831 L
.40737 .21582 L
.40998 .21715 L
.41259 .21845 L
Mistroke
.4152 .21973 L
.41781 .22098 L
.42042 .22222 L
.42303 .22344 L
.42564 .20673 L
.42825 .20803 L
.43085 .2093 L
.43346 .21055 L
.43607 .21178 L
.43868 .21299 L
.44129 .21419 L
.4439 .23597 L
.44651 .23707 L
.44912 .23816 L
.45173 .23923 L
.45434 .24029 L
.45695 .24134 L
.45956 .24237 L
.46217 .21358 L
.46477 .21477 L
.46738 .21594 L
.46999 .2171 L
.4726 .21825 L
.47521 .21937 L
.47782 .22049 L
.48043 .22068 L
.48304 .22177 L
.48565 .22284 L
.48826 .22391 L
.49087 .22496 L
.49348 .226 L
.49609 .22702 L
.4987 .19235 L
.5013 .19364 L
.50391 .1949 L
.50652 .19615 L
.50913 .19739 L
.51174 .1986 L
.51435 .1998 L
.51696 .18271 L
.51957 .18397 L
.52218 .18521 L
.52479 .18643 L
.5274 .18764 L
.53001 .18884 L
.53262 .19002 L
.53523 .23004 L
.53783 .23123 L
.54044 .2324 L
.54305 .23355 L
Mistroke
.54566 .23468 L
.54827 .2358 L
.55088 .23691 L
.55349 .2388 L
.5561 .23987 L
.55871 .24093 L
.56132 .24197 L
.56393 .243 L
.56654 .24402 L
.56915 .24502 L
.57175 .26852 L
.57436 .2694 L
.57697 .27028 L
.57958 .27115 L
.58219 .272 L
.5848 .27285 L
.58741 .27369 L
.59002 .27339 L
.59263 .27421 L
.59524 .27503 L
.59785 .27583 L
.60046 .27663 L
.60307 .27742 L
.60568 .27821 L
.60828 .27739 L
.61089 .27817 L
.6135 .27893 L
.61611 .27969 L
.61872 .28044 L
.62133 .28119 L
.62394 .28193 L
.62655 .30372 L
.62916 .30436 L
.63177 .30499 L
.63438 .30561 L
.63699 .30623 L
.6396 .30684 L
.6422 .30745 L
.64481 .32265 L
.64742 .32319 L
.65003 .32372 L
.65264 .32425 L
.65525 .32477 L
.65786 .32529 L
.66047 .32581 L
.66308 .38144 L
.66569 .38306 L
.6683 .38458 L
.67091 .38602 L
.67352 .38738 L
Mistroke
.67613 .38867 L
.67873 .3899 L
.68134 .44254 L
.68395 .44293 L
.68656 .44332 L
.68917 .4437 L
.69178 .44406 L
.69439 .44443 L
.697 .44478 L
.69961 .51386 L
.70222 .51453 L
.70483 .51516 L
.70744 .51576 L
.71005 .51633 L
.71265 .51687 L
.71526 .5174 L
.71787 .50452 L
.72048 .50515 L
.72309 .50576 L
.7257 .50634 L
.72831 .50689 L
.73092 .50742 L
.73353 .50793 L
.73614 .5323 L
.73875 .53261 L
.74136 .5329 L
.74397 .53317 L
.74658 .53344 L
.74918 .53369 L
.75179 .53393 L
.7544 .54253 L
.75701 .54272 L
.75962 .54289 L
.76223 .54306 L
.76484 .54322 L
.76745 .54337 L
.77006 .54351 L
.77267 .52728 L
.77528 .52749 L
.77789 .5277 L
.7805 .52789 L
.78311 .52808 L
.78571 .52826 L
.78832 .52843 L
.79093 .53862 L
.79354 .53873 L
.79615 .53884 L
.79876 .53893 L
.80137 .53903 L
.80398 .53911 L
Mistroke
.80659 .53919 L
.8092 .57466 L
.81181 .57464 L
.81442 .57461 L
.81703 .57457 L
.81963 .57453 L
.82224 .57448 L
.82485 .57443 L
.82746 .56514 L
.83007 .56511 L
.83268 .56507 L
.83529 .56504 L
.8379 .56499 L
.84051 .56494 L
.84312 .56489 L
.84573 .58233 L
.84834 .58223 L
.85095 .58211 L
.85356 .582 L
.85616 .58188 L
.85877 .58176 L
.86138 .58163 L
.86399 .56104 L
.8666 .56099 L
.86921 .56093 L
.87182 .56087 L
.87443 .5608 L
.87704 .56073 L
.87965 .56066 L
.88226 .59177 L
.88487 .59164 L
.88748 .59151 L
.89008 .59137 L
.89269 .59124 L
.8953 .59109 L
.89791 .59095 L
.90052 .60332 L
.90313 .60313 L
.90574 .60294 L
.90835 .60275 L
.91096 .60256 L
.91357 .60236 L
.91618 .60216 L
.91879 .58734 L
.9214 .58719 L
.92401 .58703 L
.92661 .58687 L
.92922 .58671 L
.93183 .58655 L
.93444 .58638 L
Mistroke
.93705 .56485 L
.93966 .56476 L
.94227 .56466 L
.94488 .56456 L
.94749 .56445 L
.9501 .56434 L
.95271 .56423 L
.95532 .54353 L
.95793 .54349 L
.96053 .54345 L
.96314 .5434 L
.96575 .54335 L
.96836 .5433 L
.97097 .54325 L
.97358 .52462 L
.97619 .52462 L
Mfstroke
gsave
.97619 .33737 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .167 m
.02642 .1667 L
.02903 .16641 L
.03164 .16612 L
.03425 .16583 L
.03686 .16554 L
.03947 .16525 L
.04207 .15293 L
.04468 .15266 L
.04729 .15239 L
.0499 .15212 L
.05251 .15186 L
.05512 .1516 L
.05773 .15134 L
.06034 .13439 L
.06295 .13413 L
.06556 .13386 L
.06817 .13361 L
.07078 .13335 L
.07339 .1331 L
.07599 .13285 L
.0786 .11259 L
.08121 .11232 L
.08382 .11206 L
.08643 .1118 L
.08904 .11154 L
.09165 .11129 L
.09426 .11105 L
.09687 .12381 L
.09948 .12354 L
.10209 .12327 L
.1047 .123 L
.10731 .12274 L
.10992 .12248 L
.11252 .12223 L
.11513 .0992 L
.11774 .09899 L
.12035 .09878 L
.12296 .09858 L
.12557 .09837 L
.12818 .09818 L
.13079 .09798 L
.1334 .07348 L
.13601 .07332 L
.13862 .07317 L
.14123 .07302 L
.14384 .07287 L
.14644 .07273 L
.14905 .07259 L
.15166 .07387 L
Mistroke
.15427 .07373 L
.15688 .0736 L
.15949 .07347 L
.1621 .07335 L
.16471 .07322 L
.16732 .0731 L
.16993 .06222 L
.17254 .06196 L
.17515 .06171 L
.17776 .06147 L
.18037 .06123 L
.18297 .061 L
.18558 .06078 L
.18819 .06112 L
.1908 .0609 L
.19341 .0607 L
.19602 .0605 L
.19863 .0603 L
.20124 .06011 L
.20385 .05993 L
.20646 .06078 L
.20907 .06061 L
.21168 .06044 L
.21429 .06027 L
.21689 .06011 L
.2195 .05996 L
.22211 .05981 L
.22472 .05152 L
.22733 .0512 L
.22994 .0509 L
.23255 .0506 L
.23516 .05031 L
.23777 .05003 L
.24038 .04976 L
.24299 .02934 L
.2456 .02916 L
.24821 .02899 L
.25082 .02882 L
.25342 .02866 L
.25603 .02851 L
.25864 .02837 L
.26125 .0156 L
.26386 .01543 L
.26647 .01527 L
.26908 .01512 L
.27169 .01498 L
.2743 .01484 L
.27691 .01472 L
.27952 .0258 L
.28213 .02568 L
Mistroke
.28474 .02557 L
.28735 .02546 L
.28995 .02536 L
.29256 .02526 L
.29517 .02517 L
.29778 .01638 L
.30039 .01624 L
.303 .0161 L
.30561 .01597 L
.30822 .01584 L
.31083 .01573 L
.31344 .01562 L
.31605 .03266 L
.31866 .03253 L
.32127 .0324 L
.32387 .03227 L
.32648 .03215 L
.32909 .03204 L
.3317 .03193 L
.33431 .02118 L
.33692 .02103 L
.33953 .02089 L
.34214 .02075 L
.34475 .02062 L
.34736 .0205 L
.34997 .02039 L
.35258 .06462 L
.35519 .06435 L
.3578 .06409 L
.3604 .06383 L
.36301 .06358 L
.36562 .06334 L
.36823 .0631 L
.37084 .04783 L
.37345 .04758 L
.37606 .04735 L
.37867 .04712 L
.38128 .04691 L
.38389 .04669 L
.3865 .04649 L
.38911 .1209 L
.39172 .12026 L
.39432 .11964 L
.39693 .11904 L
.39954 .11845 L
.40215 .11788 L
.40476 .11732 L
.40737 .10596 L
.40998 .10527 L
.41259 .10459 L
Mistroke
.4152 .10394 L
.41781 .1033 L
.42042 .10269 L
.42303 .10209 L
.42564 .09092 L
.42825 .09032 L
.43085 .08974 L
.43346 .08918 L
.43607 .08864 L
.43868 .08811 L
.44129 .0876 L
.4439 .10724 L
.44651 .10671 L
.44912 .10619 L
.45173 .10568 L
.45434 .10519 L
.45695 .1047 L
.45956 .10423 L
.46217 .08844 L
.46477 .08793 L
.46738 .08743 L
.46999 .08695 L
.4726 .08649 L
.47521 .08603 L
.47782 .08559 L
.48043 .08425 L
.48304 .08383 L
.48565 .08343 L
.48826 .08304 L
.49087 .08265 L
.49348 .08228 L
.49609 .08192 L
.4987 .07163 L
.5013 .07113 L
.50391 .07064 L
.50652 .07017 L
.50913 .06972 L
.51174 .06928 L
.51435 .06885 L
.51696 .0551 L
.51957 .0547 L
.52218 .05431 L
.52479 .05394 L
.5274 .05358 L
.53001 .05323 L
.53262 .05289 L
.53523 .10996 L
.53783 .10935 L
.54044 .10875 L
.54305 .10817 L
Mistroke
.54566 .10761 L
.54827 .10706 L
.55088 .10653 L
.55349 .10682 L
.5561 .10631 L
.55871 .10582 L
.56132 .10533 L
.56393 .10486 L
.56654 .1044 L
.56915 .10395 L
.57175 .12066 L
.57436 .12021 L
.57697 .11978 L
.57958 .11935 L
.58219 .11894 L
.5848 .11853 L
.58741 .11812 L
.59002 .1166 L
.59263 .11622 L
.59524 .11584 L
.59785 .11547 L
.60046 .11511 L
.60307 .11475 L
.60568 .1144 L
.60828 .11248 L
.61089 .11214 L
.6135 .11182 L
.61611 .1115 L
.61872 .11118 L
.62133 .11087 L
.62394 .11057 L
.62655 .12322 L
.62916 .12293 L
.63177 .12264 L
.63438 .12235 L
.63699 .12207 L
.6396 .12179 L
.6422 .12152 L
.64481 .1294 L
.64742 .12913 L
.65003 .12887 L
.65264 .12861 L
.65525 .12836 L
.65786 .1281 L
.66047 .12786 L
.66308 .31587 L
.66569 .31385 L
.6683 .31193 L
.67091 .31009 L
.67352 .30833 L
Mistroke
.67613 .30664 L
.67873 .30501 L
.68134 .29174 L
.68395 .29085 L
.68656 .28996 L
.68917 .28908 L
.69178 .28821 L
.69439 .28736 L
.697 .28651 L
.69961 .41716 L
.70222 .41546 L
.70483 .41379 L
.70744 .41215 L
.71005 .41055 L
.71265 .40897 L
.71526 .40742 L
.71787 .40346 L
.72048 .40185 L
.72309 .40027 L
.7257 .39872 L
.72831 .3972 L
.73092 .3957 L
.73353 .39423 L
.73614 .40523 L
.73875 .40387 L
.74136 .40252 L
.74397 .40119 L
.74658 .39988 L
.74918 .39858 L
.75179 .39729 L
.7544 .40312 L
.75701 .40185 L
.75962 .40059 L
.76223 .39935 L
.76484 .39811 L
.76745 .39689 L
.77006 .39568 L
.77267 .38545 L
.77528 .38424 L
.77789 .38305 L
.7805 .38187 L
.78311 .38069 L
.78571 .37954 L
.78832 .37839 L
.79093 .3846 L
.79354 .38347 L
.79615 .38234 L
.79876 .38123 L
.80137 .38013 L
.80398 .37903 L
Mistroke
.80659 .37794 L
.8092 .41311 L
.81181 .41194 L
.81442 .41078 L
.81703 .40962 L
.81963 .40848 L
.82224 .40734 L
.82485 .40621 L
.82746 .39698 L
.83007 .39588 L
.83268 .39479 L
.83529 .39371 L
.8379 .39264 L
.84051 .39157 L
.84312 .39051 L
.84573 .40718 L
.84834 .40608 L
.85095 .40499 L
.85356 .40391 L
.85616 .40284 L
.85877 .40177 L
.86138 .40071 L
.86399 .3844 L
.8666 .38337 L
.86921 .38235 L
.87182 .38134 L
.87443 .38034 L
.87704 .37934 L
.87965 .37834 L
.88226 .41813 L
.88487 .417 L
.88748 .41588 L
.89008 .41476 L
.89269 .41365 L
.8953 .41255 L
.89791 .41145 L
.90052 .42295 L
.90313 .42184 L
.90574 .42073 L
.90835 .41962 L
.91096 .41853 L
.91357 .41744 L
.91618 .41635 L
.91879 .40415 L
.9214 .4031 L
.92401 .40205 L
.92661 .40101 L
.92922 .39997 L
.93183 .39894 L
.93444 .39792 L
Mistroke
.93705 .38052 L
.93966 .37954 L
.94227 .37856 L
.94488 .37758 L
.94749 .37662 L
.9501 .37566 L
.95271 .3747 L
.95532 .35905 L
.95793 .35812 L
.96053 .3572 L
.96314 .35629 L
.96575 .35538 L
.96836 .35448 L
.97097 .35358 L
.97358 .33823 L
.97619 .33737 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{747.875, 231.125},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;[0000ib000`400?l00000o`00003ooooooooo
ooooongooooo003oooooooooooookOooool00?ooooooooooooo]ooooo`00ooooooooooooongooooo
003oooooooooooookOooool00?ooooooooooooo]ooooo`00ooooooooooooongooooo003ooooooi;o
oooo0_l0000Qooooo`?o00001?ooool2o`0001_ooooo0ol00004ooooo`;o00001?ooool2o`0001Wo
oooo0ol00003ooooo`?o00001?ooool2o`0001Oooooo1Ol00003ooooo`;o00001?ooool2o`0001Oo
oooo1Ol00002ooooo`?o00001?ooool2o`0001Wooooo0ol00004ooooo`;o00001?ooool2o`0001So
oooo0ol00003ooooo`?o00001?ooool2o`0003oooooo003ooooooi7ooooo00Co0000oooooooooooo
00007oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00006oooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
6Oooool01Ol0003ooooooooooooooooo000000?ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0Eooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Gooooo`06o`000?ooooooooooo`000?oooooo00000oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo01Gooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005_ooool01ol0003o
oooooooooooooooo0000ooooool000000oooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo03cooooo001Dooooo`;o00008?ooool3o`0000Cooooo0_l0000Kooooo`?o00001?ooool2
o`0000Cooooo0_l0000Gooooo`?o00000oooool3o`0000Cooooo0_l0000Gooooo`Go00000oooool2
o`0000Cooooo0_l0000Fooooo`Go00000_ooool3o`0000Cooooo0_l0000Hooooo`?o00001?ooool2
o`0000Cooooo0_l0000Gooooo`?o00000oooool3o`0000Cooooo0_l0000Wooooo`04o`000?oooooo
ooooo`0002?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Ioooo
o`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000Hooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`0Iooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`0looooo`00Doooool01?l0003oooooooooool0000Nooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Kooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Gooooo`05o`000?oooooo
ooooooooool000000oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Gooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001Kooooo00Ko0000oooooooooooo0000ooooool00003ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool05?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000Eooooo`07o`000?ooooooooooooooool0003o
ooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool09?ooool01?l0
003oooooooooool0000Sooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00006Oooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool05oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0Gooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001Sooooo0_l00006ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool0??ooool005?ooooo00Co0000oooooooooooo00008_ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0001Oooooo00?o0000ooooooooool01Oooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Oooooo00?o0000ooooooooool01Ooo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Sooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool00oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo02Cooooo00Co0000
oooooooooooo00007oooool4o`0000?ooooo00Co0000oooooooooooo00006oooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006Oooool01?l0
003oooooooooooooool4o`0000?ooooo00Co0000oooooooooooo00005_ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Foooo
o`06o`000?ooooooooooooooool0003ooooo1?l00003ooooo`04o`000?ooooooooooo`0001_ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooool000000ol00003ooooo`04o`000?ooooooooooo`0003kooooo001Coooo
o`04o`000?ooooooooooo`0002;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0000Gooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0Gooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo01Kooooo0_l00003ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00005oooool2o`0000Kooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`0Tooooo`04o`000?ooooooooooo`0001oooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool0000Jooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0001Sooooo0_l00003ooooo`03o`000?oooooooooo00Cooooo00Co0000oooo
oooooooo00005_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0000Fooooo`07o`000?ooooooooooooooool0003oooooo`000006
ooooo`04o`000?ooooooooooo`0001Oooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005_ooool01ol0003ooooooooooooooooo
0000ooooool000001_ooool01?l0003oooooooooool0000nooooo`00Doooool01?l0003ooooooooo
ool0000Nooooo`Co00000oooool01?l0003oooooooooool0000Kooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Gooooo`04o`000?oooooo
ooooooooo`Co00000oooool01?l0003oooooooooool0000Fooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Gooooo00Ko0000
ooooooooooooooooo`000?ooool4o`0000?ooooo00Co0000oooooooooooo00006_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05oooool0
0ol0003oooooo`000003o`0000?ooooo00Co0000oooooooooooo00009oooool2o`00023ooooo1Ol0
0003ooooo`;o00007?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0001[ooooo00Co
0000oooooooooooooooo1Ol00003ooooo`;o00006?ooool3o`0000Cooooo0_l00004ooooo`;o0000
6?ooool3o`0000;ooooo1Ol00003ooooo`;o00006Oooool3o`0000Cooooo0_l00004ooooo`;o0000
6?ooool3o`0000;ooooo1Ol00003ooooo`;o0000?oooool005?ooooo00Co0000oooooooooooo0000
7_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0001[ooooo0_l00004ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005_ooool2o`0000?ooooo00?o0000
ooooooooool01?ooool01?l0003oooooooooool0000Fooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Gooooo00Oo0000oooo
ooooooooooooo`000?oooooo000000Kooooo00Co0000oooooooooooo00005_ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000E
ooooo`07o`000?ooooooooooooooool0003oooooo`000006ooooo`04o`000?ooooooooooo`000?oo
ooooP_ooool005Cooooo0_l0000Oooooo`Go00000oooool2o`0001cooooo00?o0000ooooooooool0
0oooool2o`0000Cooooo0_l0000Hooooo`04o`000?ooooooooooooooo`Go00000oooool2o`0001So
oooo0ol00004ooooo`;o00001?ooool2o`0001Oooooo0ol00002ooooo`Go00000oooool2o`0001So
oooo0ol00004ooooo`;o00001?ooool2o`0001Oooooo0ol00002ooooo`Go00000oooool2o`000?oo
ooooPoooool00?ooooooooooooo]ooooo`00ooooooooooooongooooo003oooooooooooookOooool0
0?ooooooS?ooooooo`0002oo0000<_ooool004koooooool0000Yo`0001Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0003;ooooo001>ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0000Eoooo
o`03o`000?oooooooooo0?oooooo:oooool00ol0003oooooooooo`0`ooooo`00C_ooool2o`0000Go
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Co
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0?ooooo`;o00005Oooool00ol0003o
ooooooooo`3oooooob_ooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0
oooooolUooooo`03o`000?oooooooooo01?ooooo0_l0001;ooooo`Oo0?ZJ1?ooool7o`3jV/gooooo
0_l0000booooo`00C_ooool00ol0003oooooooooo`3oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`1:ooooo`Oo0?ZJ1?ooool7o`3jV/kooooo00?o0000ooooooooool0<?oo
ool004kooooo00?o0000ooooooooool0Z?ooool3o`3jVWWooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`1:ooooo`;o0?ZJ0oooool3o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ1?ooool7
o`3jV/?ooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0Yoooool4o`3j
VWWooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1:ooooo`;o0?ZJ1?ooool7o`3j
VP?ooooo0ol0nYX3ooooo`Oo0?ZJ`oooool00ol0003oooooooooo`0`ooooo`00C_ooool2o`000:Go
oooo0_l000000ooooooo0?ZJo`3jVP02o`3jVWSooooo0_l0000Eooooo`03o`000?oooooooooo04Go
oooo1ol0nYX4ooooo`Oo0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ`oooool00ol0003o
ooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`2Tooooo`;o00001Ol0nYYiooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0AOooool7o`3jVPoooooo1ol0nYX3ooooo`;o0?ZJ
`oooool00ol0003oooooooooo`0`ooooo`00>_ooool3o`0000?ooooo00?o0000ooooooooool00_oo
ool3o`0000Kooooo00?o0000ooooooooool0Y?ooool2o`0000;o0?ZJ00?oooooo`3jV_l0nYX0NOoo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo04Gooooo0_l0nYXDooooo`Oo0?ZJ0ooo
ool2o`3jV/?ooooo00?o0000ooooooooool0<?ooool003_ooooo00?o0000ooooooooool01_ooool0
1Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool0Y?ooool01Ol0003o0?ZJo`3j
V_l0nY[ooooo00;o0?ZJNOooool00ol0003oooooooooo`0Cooooo`;o0000A_ooool2o`3jVQkooooo
0_l0nY[2ooooo`;o0000<_ooool003Sooooo1Ol0000;ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0Y?ooool00ol0003o0?ZJo`3jVP02ooooo`;o0?ZJNOooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo04Cooooo0ol0nYXNooooo`;o0?ZJ`oooool00ol0003ooooooooo
o`0`ooooo`00>?ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00?ooooo0_l0
002Uooooo`?o0?ZJ0_ooool2o`3jVWOooooo0ol0000Eooooo`03o`000?oooooooooo04Cooooo0_l0
nYXOooooo`?o0?ZJ`_ooool00ol0003oooooooooo`0`ooooo`00>Oooool00ol0003oooooo`000008
ooooo`Co00001_ooool00ol0003oooooooooo`2Tooooo`;o0?ZJ0oooool2o`3jVWWooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`14ooooo`;o0?ZJ8?ooool2o`3jVP?ooooo1ol0nYZh
ooooo`03o`000?oooooooooo033ooooo000jooooo`;o00002?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo0:?ooooo00?o0000o`00ool00?l01Ol00?miooooo`03o`000?oooooooooo
00_ooooo0_l00006ooooo`03o`000?oooooooooo03oooooo1ol0nYXPooooo`;o0?ZJ0oooool7o`3j
VR[ooooo0_l0nYZ<ooooo`03o`000?oooooooooo033ooooo000kooooo`03o`000?oooooooooo00Ko
oooo1Ol00005ooooo`03o`000?oooooooooo0:?ooooo00?o0000o`00ool00?l01Ol00?miooooo`03
o`000?oooooooooo00[ooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`0ooooo
o`Oo0?ZJ8?ooool2o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ9Oooool7o`3jVXcooooo00?o0000oooo
ooooool0<?ooool004kooooo00?o0000ooooooooool0Xoooool01?l0003o003oo`00ool0nYX2oooo
o`;o003oNOooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000Gooooo0ol0000o
ooooo`;o0?ZJ9Oooool2o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ9Oooool7o`3jVX[ooooo0ol0000b
ooooo`00C_ooool2o`000:Cooooo00Co0000o`00ool00?oo0?ZJ0_ooool2o`00ogSooooo0_l0000<
ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool0;ooooolBo`3jVRGooooo0_l0
nYX3ooooo`;o0?ZJ0oooool2o`3jVRGooooo0_l0nYX3ooooo`;o0?ZJS?ooool00ol0003ooooooooo
o`0`ooooo`00C_ooool00ol0003oooooooooo`2Sooooo`04o`000?l00?oo003oo`3jVP;ooooo0_l0
0?miooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00001Oooool00ol0003ooooo
ooooo`0_oooooa;o0?ZJ9Oooool7o`3jVP?ooooo0_l0nYXUooooo`;o0?ZJ0oooool2o`3jVXcooooo
00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0Xoooool00ol0003o003oo`00
o`02o`3jVP04ooooool00?oo003oo`3jVWSooooo00?o0000ooooooooool02_ooool01?l0003ooooo
ooooool00005ooooo`03o`000?oooooooooo02oooooo0_l0nYXeooooo`Oo0?ZJ0oooool2o`3jVRCo
oooo0ol0nYX3ooooo`;o0?ZJS?ooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003ooooo
ooooo`2Sooooo`03o`000?l00?oo003o00?o0?ZJ0_l00?l00ol0nY[oooooooooo`1fooooo`03o`00
0?oooooooooo00_ooooo0_l00006ooooo`03o`000?oooooooooo02Oooooo1?l0nYX3ooooo`?o0?ZJ
?oooool2o`3jVR3ooooo1ol0nYX3ooooo`;o0?ZJS?ooool00ol0003oooooooooo`0`ooooo`00C_oo
ool00ol0003oooooooooo`2Sooooo`04o`000?l00?oo003oo`0000;o0?ZJ0_l00?l00ol0nY[ooooo
ooooo`1fooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool09?ooool<o`3jVT3ooooo
0_l0nYXPooooo`Go0?ZJ1Oooool2o`3jVXcooooo00?o0000ooooooooool0<?ooool004kooooo0_l0
002Tooooo`04o`000?l00?oo003oo`0000;o0?ZJ0_l00?l00ol0nY[oooooooooo`1eooooo`;o0000
5Oooool00ol0003oooooooooo`0Tooooo`Co0?ZJ00?oooooo`3jV_l0nYX01Ol0nYY0ooooo`;o0?ZJ
7oooool3o`3jVPSooooo0_l0nYZ<ooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oo
oooooooo0:?ooooo00?o0000o`00ool00?l00_l000001?l0nY[o003oo`00ool0nYX2ooooo`;o0?ZJ
M?ooool00ol0003oooooooooo`0Cooooo`;o00009Oooool2o`3jVT[ooooo0_l0nYXNooooo`?o0?ZJ
2Oooool2o`3jVX_ooooo0_l0000booooo`00C_ooool00ol0003oooooooooo`2Sooooo`03o`000?l0
0?oo003o00?o00000ol00?l2ooooo`;o0?ZJM?ooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo02Cooooo0_l0nYY:ooooo`;o0?ZJ6Oooool8o`3jVPWooooo0ol0nYZ;ooooo`03o`000?oo
oooooooo033ooooo001>ooooo`03o`000?oooooooooo0:?ooooo00?o0000o`00ool00?l00ol00000
1?l0nY[o003oo`00ooooool3o`3jVWCooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Sooooo`?o0?ZJ9?ooool3o`00ob?ooooo0ol0nYX;ooooo`Go0?ZJ1?ooool:o`3jVPcooooo0_l0
nYZ;ooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo0:?ooooo00?o0000
o`00ool00?l00ol000000ol0nY[o003oo`00o`04o`3jVWCooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Sooooo`;o0?ZJ9Oooool7o`00o`Cooooo1?l00?lHooooo`;o0?ZJ2Oooool7
o`3jVPCooooo1Ol0nYXAooooo`;o0?ZJRoooool00ol0003oooooooooo`0`ooooo`00C_ooool2o`00
0:Cooooo00?o0000o`00ool00?l00ol000000ol0nY[o003oo`00o`04o`3jVW?ooooo0_l0000Eoooo
o`03o`000?oooooooooo02?ooooo0_l0nYXUooooo`Oo003o1?ooool7o`00oaGooooo0_l0nYX9oooo
o`?o0?ZJ0_ooool2o`3jVPCooooo0_l0nYXDooooo`;o0?ZJRoooool00ol0003oooooooooo`0`oooo
o`00C_ooool00ol0003oooooooooo`2Sooooo`03o`000?l00?oo003o00?ooooo00Go0?ZJo`00ool0
0?oo0?ZJooooo`02o`3jVWCooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Noooo
o`Oo0?ZJ9Oooool2o`00o`?ooooo0_l00?l4ooooo`;o003o00?oooooo`00ool00?l00_l00?l4oooo
o`Ko003o2oooool2o`3jVPSooooo0ol0nYX3ooooo`;o0?ZJ0oooool3o`3jVQCooooo0_l0nYZ;oooo
o`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo0:?ooooo00?o0000o`00ool0
0?l00oooool01Ol0003o003oo`00ool0nY[ooooo00;o0?ZJM?ooool00ol0003oooooooooo`0Coooo
o`;o00007oooool7o`3jVRGooooo0_l00?l3ooooo`?o003o0oooool2o`00o`?ooooo0_l00?l4oooo
o`Oo003o2_ooool2o`3jVPOooooo0ol0nYX4ooooo`;o0?ZJ0oooool2o`3jVQGooooo0_l0nYZ:oooo
o`;o0000<_ooool004kooooo00?o0000ooooooooool0Xoooool00ol0003o003oo`00o`04ooooo`;o
003o00Co0?ZJooooool0nY[o0?ZJM?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
01kooooo0_l0nYXUooooo`Co003o00?oooooo`00ool00?l01?ooool2o`00o`?ooooo0_l00?l3oooo
o`;o003o1?ooool2o`00o`;ooooo0ol00?l:ooooo`;o0?ZJ0oooool7o`3jVPCooooo0_l0nYX00ooo
oooo0?ZJo`3jVP02o`3jVQGooooo0_l0nYX5ooooo`Go0?ZJPOooool00ol0003oooooooooo`0`oooo
o`00C_ooool00ol0003oooooooooo`2Rooooo`;o00000_l00?l4ooooo`;o003o00Co0?ZJooooool0
nY[o0?ZJM?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01kooooo0_l0nYXUoooo
o`Oo003o1?ooool7o`00o`?ooooo0ol00?l3ooooo`;o003o0oooool2o`00o`[ooooo0_l0nYX3oooo
o`Ko0?ZJ1Oooool7o`3jVQGooooo3?l0nYZ1ooooo`03o`000?oooooooooo033ooooo001>ooooo`;o
0000Xoooool2o`0000;o003o1?ooool3o`00o`03ooooool0nY[o0?ZJ07?ooooo0_l0000Eooooo`03
o`000?oooooooooo01?ooooo1ol0nYX4ooooo`;o0?ZJ9Oooool2o`00o`03ooooool00?oo003o00;o
003o1Oooool6o`00o`Cooooo0_l00?l3ooooo`;o003o0oooool2o`00o`[ooooo0_l0nYX3ooooo`;o
0?ZJ2Oooool4o`3jVQSooooo2?l0nYX2ooooo`;o0?ZJ2_ooool7o`3jVW3ooooo00?o0000oooooooo
ool0<?ooool004kooooo00?o0000ooooooooool0X_ooool2o`0000;o003o1?ooool6o`00ogCooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`Oo0?ZJ1?ooool2o`3jVRGooooo
0_l00?lDooooo`Oo003o0oooool2o`00o`[ooooo0_l0nYX3ooooo`;o0?ZJ9Oooool2o`3jVPSooooo
0ol0nYX5ooooo`_o0?ZJL?ooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003ooooooooo
o`2Rooooo`;o00000_l00?l4ooooo`03o`3jV_l00?oo003o00?o003oM?ooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo01?ooooo0_l0nYX3ooooo`;o0?ZJ1?ooool2o`3jVRCooooo0ol0
0?lDooooo`Oo003o0oooool2o`00o`[ooooo1ol0nYXOooooo`?o003o3_ooool<o`3jVPCooooo0_l0
nYY`ooooo`03o`000?oooooooooo033ooooo000dooooo`?o00000oooool00ol0003oooooooooo`02
ooooo`?o00000oooool3o`0000Kooooo00?o0000ooooooooool0X_ooool2o`0000;o003o1?ooool3
o`3jVP03o`000?l00?oo003o07Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0C
ooooo`;o0?ZJ0oooool3o`3jVP;ooooo0ol0nYXOooooo`Oo003o7oooool2o`00o`Cooooo0ol00?l3
ooooo`Oo0?ZJ7oooool7o`00o`[ooooo2?l0nYX8ooooo`Oo0?ZJJoooool00ol0003oooooooooo`0`
ooooo`00=Oooool00ol0003oooooooooo`06ooooo`07o`000?ooooooooooooooool0003oooooo`00
0003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0X_ooool2o`0000;o003o1Ooo
ool2o`3jVP03o`000?l00?oo003o07Cooooo00?o0000ooooooooool04oooool2o`0001Cooooo0_l0
nYX4ooooo`Oo0?ZJ7oooool7o`00oaoooooo0ol00?l3ooooo`Ko003o0ol0nYXSooooo`Oo003o2_oo
ool3o`3jVPgooooo1ol0nYYZooooo`;o0000<_ooool003;ooooo1Ol0000;ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool2o`000:?ooooo0_l00002o`00o`Gooooo0_l0nYX0
0ol0003o003oo`00o`1booooo`?o00005Oooool00ol0003oooooooooo`0Cooooo`;o0?ZJ1?ooool5
o`3jVR7ooooo0_l00?l3ooooo`;o003o8?ooool2o`00o`?ooooo1ol00?lUooooo`;o003o0oooool2
o`00oa[ooooo0ol0nYX2ooooo`So0?ZJIOooool00ol0003oooooooooo`0`ooooo`00<_ooool01?l0
003oooooooooool0000<ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`2Kooooo`;o00001Oooool2o`0000;o003o1Oooool2o`3jVP03o`000?l00?oo
003o07Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`;o0?ZJ:_ooool2
o`00obGooooo0_l00?l3ooooo`;o003o0oooool2o`00ob3ooooo0ol00?l2ooooo`;o003o0oooool2
o`00ob3ooooo1ol0nYYUooooo`03o`000?oooooooooo033ooooo000cooooo`03o`000?oooooo0000
00Sooooo1?l00002ooooo`Co00001_ooool00ol0003oooooooooo`2Kooooo`;o00001Oooool2o`00
00;o003o1Oooool3o`3jVP;o003oM?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
00kooooo1ol0nYXZooooo`;o003o9Oooool2o`00o`?ooooo0_l00?l3ooooo`;o003o8?ooool7o`00
o`?ooooo0_l00?lPooooo`;o0?ZJ0oooool2o`3jVVGooooo00?o0000ooooooooool0<?ooool003Co
oooo0_l00008ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`2Kooooo`;o00001Oooool2o`0000;o003o1_ooool2o`3jVP;o003o00?o0?ZJoooooooo
ool0LOooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00kooooo1ol0nYXJooooo`?o
003o3Oooool2o`00obGooooo0_l00?l3ooooo`;o003o0oooool2o`00ob3ooooo1ol00?l3ooooo`;o
003o9Oooool2o`3jVVGooooo00?o0000ooooooooool0<?ooool003Gooooo00?o0000ooooooooool0
1_ooool5o`000003ooooool0003o000000?o00001Oooool00ol0003oooooooooo`2Kooooo`;o0000
1Oooool2o`0000;o003o1oooool01?l0nY[o003oo`00ool0nYYcooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool03_ooool2o`3jVQoooooo2_l00?l6ooooo`;o003o9Oooool7o`00o`?o
oooo0_l00?lPooooo`;o003o2?ooool2o`00obGooooo0_l0nYYUooooo`03o`000?oooooooooo033o
oooo001>ooooo`;o0000W?ooool2o`0000Gooooo0_l00002o`00o`Sooooo0_l00?l00ol0nY[ooooo
ooooo`1`ooooo`;o00005Oooool2o`0000kooooo0ol0nYXOooooo`ko003o0_ooool2o`00obGooooo
1ol00?l3ooooo`;o003o7oooool3o`00o`Sooooo0_l00?lUooooo`;o0?ZJI?ooool2o`0003;ooooo
001>ooooo`03o`000?oooooooooo09_ooooo0ol00004ooooo`;o00000_l00?l8ooooo`;o003o00?o
0?ZJooooooooool0LOooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00gooooo0_l0
nYXPooooo`;o003o1oooool9o`00oboooooo0_l00?l:ooooo`?o003o4_ooool2o`00o`Wooooo0ol0
0?lTooooo`;o0?ZJIOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`2K
ooooo`?o00001?ooool2o`0000;o003o2?ooool2o`00o`03o`3jV_oooooooooo077ooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0:ooooo`Go0?ZJ8?ooool2o`00o`_ooooo1Ol00?l_
ooooo`;o003o2_ooool7o`00o`Cooooo1ol00?l3ooooo`;o003o2_ooool2o`00obCooooo0_l0nYYU
ooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo09_ooooo1Ol00002oooo
o`;o0?ZJ0_l00?l8ooooo`?o003oLoooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
00Sooooo1ol0nYXOooooo`?o003o?oooool3o`00o`Wooooo1ol00?l4ooooo`co003o2_ooool2o`00
obCooooo0_l0nYYUooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo09_o
oooo1Ol000001?oooooo0?ZJo`3jV_l0nYX2o`00o`Sooooo00?o0?ZJo`00ool00?l0Loooool01?l0
003oooooo`000?l00004ooooo`03o`000?oooooooooo00;ooooo0ol00006ooooo`03o`000?oooooo
oooo00Sooooo0ol0nYXSooooo`;o003o@Oooool2o`00o`Sooooo0ol00?l3ooooo`;o003o1?ooool2
o`00o`;ooooo2?l00?l:ooooo`;o003o9?ooool2o`3jVVGooooo00?o0000ooooooooool0<?ooool0
04kooooo0_l0002Looooo`Go000000Coooooo`3jV_l0nY[ooooo0_l00?l8ooooo`03o`3jV_l00?oo
003o00?ooooo0_l0nYY]ooooo`?o00000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool02?ooool2o`3jVRCooooo0_l00?lJooooo`;o0?ZJ9Oooool2
o`00o`?ooooo1ol00?l4ooooo`;o003o1?ooool2o`00oaCooooo0_l00?lTooooo`;o0?ZJIOooool0
0ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`2Jooooo`Ko000000Coooooo`3j
V_l0nY[ooooo0_l00?l8ooooo`03o`3jV_l00?oo003o00;ooooo0ol0nYY^ooooo`;o00000_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool4
o`3jVQ[ooooo1ol00?l3ooooo`;o003o6_ooool5o`3jVR;ooooo0_l00?l3ooooo`Oo003o1?ooool2
o`00o`?ooooo0ol00?lDooooo`;o003o9?ooool2o`3jVVGooooo00?o0000ooooooooool0<?ooool0
04kooooo00?o0000ooooooooool0V_ooool6o`0000?o0?ZJ00?oooooo`00ool00?l02?ooool01?l0
nY[o003oo`00ooooool4o`3jVVkooooo0_l00002ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01Oooool3o`0000?ooooo1ol0nYXJooooo`co003o6_ooool7o`3jVPCooooo1?l0nYXH
ooooo`;o003o0oooool2o`00o`?ooooo0_l00?l4ooooo`;o003o0oooool2o`00oaGooooo0_l00?lT
ooooo`;o0?ZJHoooool3o`0003;ooooo001>ooooo`03o`000?oooooooooo09[ooooo0_l000001?oo
oooo0000o`000?l00002o`3jVP04o`000?oooooo003oo`00o`Sooooo00?o0?ZJo`00ool00?l01Ol0
nYY^ooooo`;o00000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool00oooool4o`3jVQgooooo0_l00?l3ooooo`Oo003o6_ooool2o`3jVP;ooooo0ol0
nYX4ooooo`Ko0?ZJ5_ooool2o`00o`?ooooo0_l00?l9ooooo`Oo003o5Oooool7o`00oaoooooo0_l0
nYYUooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo00Oooooo0_l0nYZA
ooooo`;o000000?oooooo`000?l000000ol0nYX01?l0003oooooo`00ool00?l9ooooo`;o003o0_l0
nYX00ooooooo0?ZJo`3jVP1^ooooo`;o00000_ooool00ol0003oooooooooo`06ooooo`;o00001ooo
ool00ol0003oooooooooo`0Tooooo`;o003o9?ooool2o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX00_l0nYX4ooooo`Co0?ZJ3Oooool2o`00o`?ooooo0_l00?l9ooooo`Oo003o5Ooo
ool<o`00oa[ooooo0_l0nYYUooooo`03o`000?oooooooooo033ooooo001>ooooo`;o00001oooool3
o`3jVT_ooooo0_l00014ooooo`;o000000?oooooo`000?l000001ol00?l9ooooo`;o003o0_l0nYX0
0ooooooo0?ZJo`3jVP1]ooooo`;o000000?oooooo`000?l000002_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo02Cooooo0_l00?lTooooo`;o0?ZJ0oooool3o`3jVP?ooooo0_l0nYX3
ooooo`;o0?ZJ1?ooool6o`3jVP_ooooo0_l00?l3ooooo`;o003o3Oooool3o`00oa[ooooo1ol00?lJ
ooooo`;o0?ZJIOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`06oooo
o`?o0?ZJBoooool2o`0004Cooooo0_l000000ooooooo0000o`000007o`00o`Wooooo0_l00?l00ol0
nY[o0000ooooo`02o`3jVVkooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Soooo
o`?o003o7oooool3o`3jVP;ooooo0_l0nYX4ooooo`;o0?ZJ0oooool2o`3jVP?ooooo0_l0nYX4oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX:ooooo`Oo003o;oooool2o`00oa[ooooo0_l0nYYUoooo
o`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo00Kooooo0ol0nYY;ooooo`?o
0000@oooool2o`0000?ooooo0_l00?l00ol0nY[o0000ooooo`02o`3jVPWooooo0_l00?l00ol0nY[o
0000ooooo`02o`3jVVkooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Sooooo`;o
003o8?ooool7o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ0oooool2o`3jVPCooooo0_l0nYX3ooooo`;o
0?ZJ2_ooool7o`00oaoooooo1?l0nYX<ooooo`;o003o6_ooool2o`3jVVGooooo00?o0000oooooooo
ool0<?ooool004kooooo00?o0000ooooooooool01Oooool4o`3jVT_ooooo0ol0000/ooooo`;o0?ZJ
5Oooool2o`0000?ooooo0_l00?l00ol0nY[o0000ooooo`02o`3jVPWooooo0_l00?l00ol0nY[o0000
o`000002o`3jVVkooooo00?o0000ooooooooool04oooool2o`0002Cooooo0_l00?lJooooo`;o0?ZJ
1?ooool7o`3jVPCooooo1?l0nYX00ooooooo0?ZJo`3jVP03ooooo`?o0?ZJ0oooool2o`3jVP?ooooo
0_l0nYX>ooooo`?o003o7oooool6o`3jVP[ooooo0ol00?lIooooo`;o0?ZJI?ooool2o`0003;ooooo
001>ooooo`03o`000?oooooooooo00Gooooo1?l0nYY;ooooo`?o0000:?ooool2o`000004ooooool0
nY[o0?ZJo`3jVQGooooo0_l00002ooooo`03o`3jV_l00?oo003o00;o0?ZJ00?oooooo`3jV_l0nYX0
2Oooool4o`00o`03o`000?l0nY[o0?ZJ06Cooooo0_l0nYX8ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool07_ooool7o`00oa[ooooo1?l0nYX01?oooooo0?ZJo`3jV_l0nYX:ooooo`Ko
0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ:oooool2o`3jVP?ooooo0_l0nYX00ooooooo
0?ZJo`3jVP02o`3jVP[ooooo0_l00?lIooooo`;o0?ZJIOooool00ol0003oooooooooo`0`ooooo`00
C_ooool2o`0000Gooooo1Ol0nYY:ooooo`Go00006oooool2o`3jVP[ooooo0_l00004o`3jVP04oooo
ool0003o0000ooooo`;o0?ZJ3oooool2o`0000;ooooo00?o0?ZJo`00ool00?l00_l0nYX00ooooooo
0?ZJo`3jVP09ooooo`Oo003oI?ooool2o`3jVPOooooo0_l0000Eooooo`03o`000?oooooooooo01ko
oooo1ol00?lJooooo`Oo0?ZJ3Oooool4o`3jVPCooooo0ol0nYX2ooooo`;o0?ZJ0oooool2o`3jVR_o
oooo0ol0nYX2ooooo`;o0?ZJ0oooool2o`3jVP[ooooo2_l00?l00ooooooo003oo`00o`02o`00o`co
oooo0_l0nYYUooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo00Cooooo
0_l0nYX00ooooooo0?ZJo`3jVP18ooooo`Oo00006_ooool3o`3jVP03ooooool0003o000000;o0?ZJ
1Oooool00ol0003o0?ZJo`3jVP03o`3jVP03ooooool0003o0?ZJ00?o0?ZJ3oooool2o`0000;ooooo
00?o0?ZJo`00ool00?l01Ol0nYX9ooooo`;o0?ZJ00?o0000o`00ool00?l00_l00?l3ooooo`;o0?ZJ
E?ooool2o`3jVPSooooo0ol0nYX8ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
7_ooool2o`00o`;ooooo0ol00?lJooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXEooooo`Oo0?ZJ
0oooool2o`3jVPCooooo1?l0nYXSooooo`Oo0?ZJ0oooool2o`3jVP[ooooo4_l00?l9ooooo`;o0?ZJ
IOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`03ooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX0B?ooool01?l0003o0?ZJo`3jV_l0nYX3o`0000;o0?ZJ5oooool4o`3jVP;o0000
0ol0nYX5ooooo`?o0?ZJ00Coooooo`3jV_l0nY[ooooo1Ol0nYX?ooooo`;o000000?oooooo`3jV_l0
nYX00_l00?l5o`3jVPWooooo0ol0nYX2o`0000;o003o00?o0?ZJooooool0nYX00_l0nYYDooooo`;o
0?ZJ2?ooool3o`3jVPSooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Nooooo`;o
003o7oooool2o`3jVP?ooooo0_l0nYXGooooo`Go0?ZJ0oooool3o`3jVP?ooooo1ol0nYXPooooo`Oo
0?ZJ0oooool2o`3jVPoooooo0_l00?l2ooooo`?o003o0_ooool4o`00o`Wooooo0_l0nYYUooooo`03
o`000?oooooooooo033ooooo000jooooo`?o00000oooool00ol0003oooooooooo`02ooooo`?o0000
1_ooool00ol0003oooooooooo`03ooooo`;o0?ZJ0_l00002o`3jVSCooooo0_l0nYXAooooo`Go0?ZJ
00?oooooo`000?l0nYX00_l0nYXFooooo`Go0?ZJ00?o0000o`3jV_l0nYX00_l0nYX5ooooo`;o0?ZJ
00?o0000ooooool0nYX01?l0nYX00ooooooo0?ZJo`3jVP0<ooooo`;o000000Goooooo`000?l0003o
ooooo`3jVP03o`00o`03o`000?oooooo0?ZJ00;o0?ZJ2Oooool01Ol0003o0?ZJo`3jV_oooooo0000
00;o003o00?o0?ZJooooool0nYX00_l0nYYDooooo`;o0?ZJ2?ooool3o`3jVPSooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Cooooo`Oo003o1?ooool2o`00oaoooooo0_l0nYXUoooo
o`;o0?ZJ0oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ8?ooool2o`3jVP?ooooo0_l0nYX3oooo
o`;o0?ZJ6_ooool2o`00o`Wooooo0_l0nYYUooooo`03o`000?oooooooooo033ooooo000kooooo`03
o`000?oooooooooo00Kooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo
00?ooooo0_l0nYX2o`0000;o0?ZJ<oooool3o`3jVQ7ooooo2_l0nYXFooooo`;o0?ZJ00?oooooo`3j
V_l0nYX01Ol0nYX5ooooo`;o0?ZJ00?o0000ooooool000001?l0nYX01?oooooo0?ZJo`3jV_ooool2
o`0000Wooooo0_l000000ooooooo0000o`000002o`3jVP;o003o00Co0?ZJo`000?oooooooooo0_l0
nYX9ooooo`05o`000?l0nY[o0?ZJooooool000000_l00?l5o`3jVUCooooo0_l0nYX8ooooo`?o0?ZJ
2?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo1ol00?l4ooooo`;o003o
7oooool2o`3jVRGooooo0_l0nYX3ooooo`;o0?ZJ0oooool2o`3jVP[ooooo0ol0nYXCooooo`;o0?ZJ
2?ooool2o`3jVQ[ooooo0_l00?l9ooooo`;o0?ZJIOooool00ol0003oooooooooo`0`ooooo`00>?oo
ool5o`0000Oooooo00Go0000ooooooooooooooooo`000005ooooo`;o00001?ooool2o`3jVP;o0000
0_l0nYXbooooo`Co0?ZJ4?ooool3o`3jVP03o`000?l0nY[o0?ZJ00Go0?ZJ5Oooool3o`3jVP;ooooo
0ol0nYX00ol0003o0?ZJo`3jVP05ooooo`?o003o00?oooooo`000?l0nYX00_l0nYX2o`0000;o0?ZJ
00?oooooo`000?l000002Oooool2o`000003ooooool0003o0?ZJ00;o0?ZJ0_l00?l00ol0nY[o0000
ooooo`0=ooooo`?o0?ZJ00?oooooo`00ool00?l01Ol0nYYCooooo`?o0?ZJ1oooool4o`3jVPKooooo
0ol0000Eooooo`;o00005?ooool2o`00o`?ooooo0_l00?l4ooooo`;o003o7oooool2o`3jVRGooooo
0_l0nYX3ooooo`;o0?ZJ0oooool2o`3jVP[ooooo1Ol0nYX@ooooo`?o0?ZJ2?ooool2o`3jVQ[ooooo
0_l00?l9ooooo`;o0?ZJI?ooool2o`0003;ooooo000hooooo`04o`000?ooooooooooo`0000Sooooo
1?l00006ooooo`03o`000?oooooooooo00?ooooo0_l0nYX2o`0000;o0?ZJ<Oooool5o`3jVQ3ooooo
0_l0nYX2o`0000?o0?ZJ00Coooooo`000?l0nY[o0?ZJ5Oooool2o`3jVP?ooooo0ol0nYX00ol0003o
0?ZJo`3jVP05ooooo`Ko003o0_l0nYX2o`0000;o0?ZJ00?oooooo`000?l000002Oooool2o`000005
ooooool0nY[o0?ZJo`3jV_ooool00_l00?l00ol0nY[o0000ooooo`0=ooooo`04o`000?l0nY[o0?ZJ
ooooo`;o003o1Ol0nYYCooooo`?o0?ZJ1?ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2?ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0_l00?l3ooooo`?o003o0oooool2
o`00o`oooooo0ol0nYX=ooooo`;o0?ZJ9Oooool2o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ2_ooool7
o`3jVPCooooo0ol0nYX7ooooo`;o0?ZJ2Oooool3o`3jVQWooooo1ol00?l4ooooo`;o0?ZJIOooool0
0ol0003oooooooooo`0`ooooo`00>Oooool00ol0003oooooo`000008ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool00oooool2o`3jVP;o00000_l0nYX^ooooo`;o00000ol0nYX00ooo
oooo0?ZJo`3jVP04ooooo`;o0?ZJ0_ooool3o`3jVPCooooo3?l00?lDooooo`?o0?ZJ0oooool2o`00
o`04o`3jV_l0003o0?ZJo`3jVPCooooo00?o0?ZJo`00ool00?l02_l00?l00ooooooo0000o`000009
ooooo`;o000000?oooooo`3jV_l0nYX00_ooool2o`00o`03o`3jV_l0003ooooo00gooooo00Co0000
o`3jV_l0nY[o0?ZJ0ol00?l01?l0nY[oooooo`3jV_l0nYYCooooo`?o0?ZJ1?ooool2o`3jVP03oooo
ool0nY[o0?ZJ00;o0?ZJ2?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo
0_l00?l4ooooo`Oo003o3oooool5o`3jVP_ooooo0_l0nYXUooooo`Co0?ZJ00?oooooo`3jV_l0nYX0
0oooool2o`3jVPCooooo1?l0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`?o0?ZJ1?ooool5o`3jVPGo
oooo0_l0nYX:ooooo`;o0?ZJ6Oooool7o`00o`Cooooo0_l0nYYUooooo`03o`000?oooooooooo033o
oooo000jooooo`;o00002Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00?ooooo
1_l00?l01?l0nY[oooooooooooooool2o`3jVRSooooo0_l00002o`3jVP04o`000?oooooo0?ZJo`3j
VP;ooooo1?l0nYX00ooooooo0?ZJo`3jVP02o`3jVPCooooo3?l00?lDooooo`co003o00?o0?ZJo`00
0?l0nYX00_l0nYX2o`00o`?o00001ol00?l3o`0000Wooooo0_l000000ooooooo0?ZJo`3jVP02oooo
o`;o003o4?ooool2o`0000?o0?ZJ0_l00?l2ooooo`;o0?ZJD_ooool4o`3jVP?ooooo2?l0nYX8oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool2o`00o`Cooooo1ol00?l?oooo
o`Oo0?ZJ2Oooool2o`3jVRKooooo1_l0nYX3ooooo`;o0?ZJ1?ooool7o`3jVPCooooo0_l0nYX4oooo
o`So0?ZJ0_ooool2o`3jVP[ooooo0_l0nYXNooooo`;o003o1?ooool2o`3jVVGooooo00?o0000oooo
ooooool0<?ooool003_ooooo00?o0000ooooooooool02?ooool2o`0000Kooooo00?o0000oooooooo
ool00oooool6o`00o`03o`3jV_oooooooooo00?o0?ZJ:?ooool2o`0000;o0?ZJ00?o0000ooooool0
nYX03?l0nYX3ooooo`06o`3jV_l00?oo003oo`3jV_l0003ooooo0_l00?l00ol0nY[oooooo`000002
o`00oaCooooo3?l00?l00ol0nY[o0000o`3jVP02o`3jVP;o003o0ol00003o`3jVP;o00000_l00?l3
o`0000Sooooo0ol000000ooooooo003oo`00o`04o`00oa?ooooo0_l0nYX2o`00o`;ooooo0_l0nYYB
ooooo`Co0?ZJ0oooool5o`3jVP03ooooool0nY[o0?ZJ00Sooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Cooooo`;o003o6_ooool2o`3jVP;ooooo1ol0nYX5ooooo`;o0?ZJ:?ooool4
o`3jVP?ooooo0ol0nYX3ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX4ooooo`;o0?ZJ1?ooool2
o`3jVP;ooooo2?l0nYX:ooooo`;o0?ZJ7_ooool3o`00o`?ooooo0_l0nYYUooooo`03o`000?oooooo
oooo033ooooo001>ooooo`;o00001?ooool2o`3jVP;o00000_l00?l00ol0nY[oooooo`3jVP03o`3j
VRSooooo0_l00004o`00o`03o`000?l0nY[o0?ZJ00;o0?ZJ00?o0000o`3jV_l0nYX00_l0nYX01?oo
oooo0?ZJo`3jV_ooool3o`3jVP;o003o0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP04o`000?l00?oo
003oo`3jVP?ooooo0_l0nYX<ooooo`;o00000_l00?l01?l0nY[o0000o`000?l00003o`3jVP03oooo
ool00?oo003o00Co0?ZJ0ol00?l00ol0nY[o0000o`000003o`3jVP;o00000_l00?l3o`0000Gooooo
0_l000001Ooooooo0000o`000?l0003ooooo00Ko003o5?ooool00ol0nY[o003oo`00o`02ooooo`;o
0?ZJ?oooool2o`3jVQ7ooooo1?l0nYX2ooooo`Ko0?ZJ00?oooooo`3jV_l0nYX01oooool2o`0001Go
oooo00?o0000ooooooooool04oooool2o`00oa[ooooo0_l0nYX4ooooo`Ko0?ZJ1?ooool2o`3jVS3o
oooo0_l0nYX3ooooo`;o0?ZJ0oooool2o`3jVPCooooo0_l0nYX4ooooo`;o0?ZJ1Oooool5o`3jVP[o
oooo0_l0nYXOooooo`Go003o0_l0nYYUooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`00
0?oooooooooo00?ooooo0_l0nYX01_l0003oooooo`00ool00?oo0?ZJooooo`Co0?ZJ:?ooool2o`00
00Ko003o0_l0nYX00ooooooo0000o`3jVP02o`3jVP;ooooo1Ol0nYX3o`00o`;o0?ZJ00?oooooo`3j
V_l0nYX00ol0nYX2o`00o`03o`3jV_oooooo0?ZJ00?o0?ZJ3?ooool2o`0000;o003o00Co0?ZJo`00
0?l0003o00000ol0nYX01?oooooo003oo`00ool00?l2o`3jVP03o`000?l00?oo003o00So0?ZJ00?o
0000o`00ool00?l00ol00005ooooo`;o000000Goooooo`000?l0003o0000ooooo`02o`00o`;ooooo
0_l00?lDooooo`03o`3jV_l00?oo003o00;ooooo0_l0nYXOooooo`;o0?ZJ7_ooool2o`3jVP?ooooo
0_l0nYX;ooooo`Go0?ZJ0_ooool6o`3jVP03ooooool0nY[o0?ZJ00Sooooo00?o0000ooooooooool0
4oooool2o`0001Cooooo0_l00?lJooooo`;o0?ZJ1?ooool2o`000003ooooool0nY[o0?ZJ00Co0?ZJ
00?oooooo`3jV_l0nYX0<?ooool2o`3jVP?ooooo0_l0nYX9ooooo`;o0?ZJ0oooool3o`3jVPOooooo
0ol0nYX:ooooo`?o0?ZJ7_ooool5o`00o`;o0?ZJI?ooool2o`0003;ooooo001>ooooo`03o`000?oo
oooooooo00?ooooo0_l0nYX01?l0003oooooo`00ool00?l6o`3jVRSooooo0_l00002o`00o`04o`00
0?l00?oo003oo`00o`;o0?ZJ00?oooooo`000?l00?l01_l00?l2o`3jVP03ooooool00?oo003o00Ko
0?ZJ00?oooooo`3jV_l0nYX00ol00?l5o`3jVPcooooo0_l00002o`00o`04o`3jV_l0003o0000o`00
00?o0?ZJ0_ooool2o`00o`03o`3jV_l0003o000000;o003o1Ol0nYX01?oooooo0?ZJo`3jV_l0nYX2
o`00o`?o00001Oooool2o`000005ooooool0003o0000o`000?ooool00_l00?l2ooooo`;o0?ZJ5Ooo
ool6o`00o`kooooo0_l0nYX?ooooo`;o0?ZJ7Oooool3o`3jVP?ooooo0_l0nYX;ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX00_ooool6o`3jVP03ooooool0nY[o0?ZJ00Sooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0>ooooo`Oo003o6_ooool2o`3jVPCooooo0_l00003ooooo`Oo0?ZJ<?oo
ool2o`3jVP?ooooo0_l0nYX9ooooo`;o0?ZJ0oooool2o`3jVQGooooo1Ol0nYXQooooo`;o0?ZJIOoo
ool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`03ooooo`;o0?ZJ0_ooool2
o`00o`?o0?ZJ00?oooooo`3jV_l0nYX0:?ooool2o`0000;o003o0_l0000?o`00o`05o`000?l00?oo
003oo`3jV_l000001?l0nYX2ooooo`;o0?ZJ0_l00?l2o`3jVP04ooooool0nY[o0?ZJooooo`Co0?ZJ
1oooool2o`0000;o003o0_l0nYX00ol0003o0?ZJo`3jVP03o`3jVP03ooooool00?oo003o00Go003o
00?o0?ZJo`000?l0nYX00_l0nYX01?oooooo0?ZJo`3jV_l0nYX2o`00o`?o00001Oooool2o`000003
ooooool0003o000000;o00000_l00?l2ooooo`;o0?ZJ5Oooool6o`00o`kooooo0_l0nYX>ooooo`?o
0?ZJ7Oooool3o`3jVP?ooooo0_l0nYX;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool5o`3jVP;o
oooo0_l0nYX8ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool03_ooool7o`00oa[o
oooo0_l0nYX4ooooo`;o00001_ooool4o`3jVS3ooooo0_l0nYX3ooooo`;o0?ZJ2Oooool4o`3jVP03
ooooool0nY[o0?ZJ01Kooooo1_l0nYXOooooo`;o0?ZJIOooool00ol0003oooooooooo`0`ooooo`00
C_ooool00ol0003oooooooooo`03ooooo`;o0?ZJ0_ooool2o`00o`?o0?ZJ00?oooooo`3jV_l0nYX0
:?ooool2o`0000;o003o0ol00007o`00o`04o`3jV_l0003o0000o`0000Ko003o00?o0?ZJo`000?l0
00000ol0nYX2ooooo`05o`000?l0nY[o003oo`00ool0nYX00_ooool7o`3jVPKooooo0ol00002o`00
o`Go0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1ol00?l00ooooooo0000o`3jVP02o`3jVP?ooooo00?o0?ZJ
o`00ool00?l00ol00003ooooo`Co000000?oooooo`000?l000000_l00002o`00o`04o`3jV_oooooo
0?ZJo`3jVQGooooo0_l0nYX2ooooo`;o003o00Co0?ZJoooooooooooooooo0_l0nYX8ooooo`;o0?ZJ
3_ooool3o`3jVQcooooo1?l0nYX3ooooo`;o0?ZJ2oooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo
1Ol0nYX2ooooo`;o0?ZJ2?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00kooooo
0_l00?lNooooo`?o0?ZJ0oooool5o`0003Sooooo0_l0nYX3ooooo`;o0?ZJ2Oooool7o`3jVQWooooo
1_l0nYXLooooo`;o0?ZJIOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003ooooooooo
o`03ooooo`;o0?ZJ0_ooool3o`00o`;o0?ZJ00?oooooo`3jV_l0nYX09oooool3o`0000;o003o00?o
0?ZJo`000?l000000ol0nYX00ooooooo0000o`3jVP03o`3jVP;o00000_l0nYX4o`00o`03ooooool0
003o000000Kooooo00Co0?ZJo`00ool00?oo0?ZJ0_ooool7o`3jVPKooooo0ol00002o`00o`03o`00
0?l0nY[o0?ZJ00;o0?ZJ0_ooool5o`3jVP05ooooool00?oo003oo`00ooooool00_l00002o`3jVP?o
oooo00?o0000o`00ool00?l00ol00003ooooo`Co000000?oooooo`000?l000000_l00002o`00o`Co
0?ZJ5Oooool2o`3jVP;ooooo0_l00?l00ol0nY[oooooooooo`03o`3jVPOooooo0ol0nYX=ooooo`Co
0?ZJ7?ooool4o`3jVP;ooooo0ol0nYX;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool5o`3jVP;o
oooo0_l0nYX8ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool03_ooool2o`00oako
oooo0_l0nYX4ooooo`Go00003oooool2o`0002Oooooo1?l0nYX00ooooooo0?ZJo`3jVP0<ooooo`Co
0?ZJ6oooool6o`3jVQ[ooooo0_l0nYYUooooo`03o`000?oooooooooo033ooooo001>ooooo`;o0000
1?ooool3o`3jVP04ooooool0003o003oo`00o`;o0?ZJ00?oooooo`3jV_l0nYX09oooool2o`000003
o`3jV_l00?oo003o00Ko0?ZJ00?oooooo`000?l0nYX02?l0nYX00ol0003o0?ZJo`3jVP09ooooo`03
o`000?l00?oo003o00Go003o00?o0?ZJooooooooool00_l0nYX6ooooo`?o00000_l00?l2o`0000?o
0?ZJ0oooool4o`3jVP05ooooool0003o0?ZJo`3jV_ooool00_l00006ooooo`;o003o0ol00003oooo
o`Co000000Goooooo`000?l0003oooooo`3jVP02o`00o`Co0?ZJ5Oooool2o`3jVP;ooooo0_l00?l0
0ol0nY[oooooo`3jVP03o`3jVPOooooo0ol0nYX=ooooo`Co0?ZJ7?ooool4o`3jVP;ooooo0ol0nYX9
ooooo`Co0?ZJ00Coooooo`3jV_l0nY[ooooo0ol0nYX00ol0003o0?ZJo`3jVP02ooooo`;o0?ZJ1ooo
ool2o`0001Gooooo00?o0000ooooooooool03_ooool2o`00oakooooo0_l0nYX4ooooo`Ko00000_oo
ool2o`0000Sooooo1?l0000>ooooo`;o00006?ooool6o`3jVPkooooo0_l0nYXNooooo`?o0?ZJ6_oo
ool2o`3jVVGooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool01?ooool2
o`3jVP07ooooool0003o003oo`00ool0nY[oooooo`000002o`3jVROooooo0_l000000ol0nY[o003o
o`00o`07o`3jVP04o`000?l0nY[o0?ZJooooo`Wo0?ZJ2Oooool00ol0003o003oo`00o`08o`00o`;o
0?ZJ1_ooool2o`000003ooooool00?oo003o00;ooooo0ol0nYX5ooooo`?o0?ZJ00Co0000o`3jV_l0
nY[ooooo0_l00006ooooo`;o003o0_l00003o`3jVP03ooooool0003o000000;o0?ZJ0ol000001Ooo
oooo0?ZJo`00ool00?oooooo00?o0?ZJ5Oooool2o`3jVP;ooooo0_l00?l6o`3jVPKooooo1?l0nYX=
ooooo`Co0?ZJ7?ooool4o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2Oooool4o`3jVP03ooooool0nY[o
0?ZJ00?o0?ZJ0_l00002o`3jVP;ooooo0_l0nYX8ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool03Oooool3o`00oakooooo0_l0nYX4ooooo`Ko000000Coooooo`000?l0003o00000_oo
ool3o`0000?ooooo1_l0000<ooooo`;o00006_ooool4o`3jVRoooooo0_l0nYXJooooo`;o0?ZJIOoo
ool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`04ooooo`;o0?ZJ00Oooooo
o`000?l00?oo003oo`3jV_oooooo000000;o0?ZJ9oooool2o`000004o`3jV_l00?oo003oooooo`?o
0?ZJ00?o0000o`3jV_l0nYX00ol0nYX00ooooooo0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00;o
0?ZJ2_ooool3o`3jVP03o`000?oooooo003o00Ko003o0oooool2o`000004ooooool0003o0000oooo
o`;o003o0oooool2o`3jVPKooooo1Ol0nYX00ooooooo0000o`000006ooooo`;o003o00?oooooo`3j
V_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP;o00000_ooool00ol0nY[o003oo`00o`02oooo
o`;o0?ZJ5Oooool3o`3jVP03ooooool00?oo003o00?o0?ZJ00?oooooo`3jV_l0nYX01_ooool4o`3j
VPcooooo1Ol0nYXLooooo`Co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX8ooooo`Go0?ZJ0_ooool4o`3j
VP;o00000_l0nYX2ooooo`?o0?ZJ1oooool00ol0003oooooooooo`0Cooooo`;o00003_ooool2o`00
oa7ooooo0_l00002ooooo`?o0?ZJ1oooool2o`3jVPCooooo0_l00002ooooo`Ko00000_ooool3o`00
00;ooooo1ol00009ooooo`Ko0000C?ooool2o`3jVQ[ooooo0_l0nYYTooooo`;o0000<_ooool004ko
oooo00?o0000ooooooooool01?ooool3o`3jVP06ooooool00?oo003oo`3jV_oooooo00000_l0nYX3
ooooo`;o0?ZJ8_ooool2o`000003o`3jV_l00?oo003o00;ooooo0_l0nYX2o`0000Co0?ZJ0oooool2
o`3jVP;ooooo0ol0nYX;ooooo`;o0?ZJ00?o0000ooooool0nYX00_l0nYX4o`00o`?ooooo0_l00000
1?oooooo0000o`000?ooool2o`00o`cooooo1?l0nYX9ooooo`;o003o2_l0nYX2o`0000;ooooo0ol0
0?lIooooo`04o`000?l0nY[o0?ZJooooo`?o003o0_l0nYX00ooooooo0?ZJo`3jVP05ooooo`Go0?ZJ
3?ooool2o`3jVP03ooooool0nY[o0?ZJ01_ooooo00?o0000o`3jV_l0nYX00_l0nYX00ooooooo0?ZJ
o`3jVP02o`3jVPSooooo1Ol0nYX2ooooo`Co0?ZJ0_l00002o`3jVP?ooooo0_l0nYX7ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool03Oooool2o`00o`cooooo0_l00002ooooo`?o0000
0_ooool7o`3jVP?ooooo0_l0nYX4ooooo`;o00000_ooool<o`000003ooooool0003o000000;ooooo
0ol00009ooooo`So0000B_ooool3o`3jVQWooooo0_l0nYYUooooo`03o`000?oooooooooo033ooooo
001>ooooo`03o`000?oooooooooo00Gooooo0ol0nYX2o`00o`?o00000_l0nYX2ooooo`?o0?ZJ8_oo
ool2o`0000?o003o1?ooool4o`0000;o0?ZJ2?ooool2o`3jVP_ooooo0ol0nYX00ooooooo0?ZJo`3j
VP02o`3jVP03ooooool00?oo003o00?ooooo0_l000001?oooooo0000o`000?ooool2o`00o`cooooo
1?l0nYX9ooooo`;o003o0_l0nYX00ol0003o0?ZJo`3jVP02o`3jVP03o`000?l0nY[o0?ZJ00;o0000
0_ooool2o`00o`03o`3jV_oooooooooo01Oooooo00Go0000o`3jV_l0nY[o0?ZJooooo`02o`00o`03
o`3jV_oooooooooo00;o0?ZJ1Oooool2o`3jVP03ooooool0nY[o0?ZJ00cooooo0_l0nYX00ooooooo
0?ZJo`3jVP0Kooooo`[o0?ZJ2?ooool5o`3jVP;ooooo1?l0nYX2o`0000;o0?ZJ0oooool2o`3jVPOo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`08ooooo`Oo003o3?ooool3o`000003
ooooool0003o000000;o000000?oooooo`3jV_l0nYX01ol0nYX00ooooooo0?ZJo`3jVP04ooooo`;o
00000_ooool<o`000003ooooool0003o000000?ooooo0_l00009ooooo`?o000000?oooooo`000?l0
00000_l00008ooooo`;o0000@Oooool2o`3jVQWooooo0_l0nYYUooooo`03o`000?oooooooooo033o
oooo001>ooooo`;o00001oooool2o`3jVPCo003o00Co0000o`3jV_l0nY[ooooo1?l0nYXRooooo`;o
00000_l00?l00ol0nY[oooooooooo`02ooooo`Co00006?ooool8o`3jVP;o003o00?o0?ZJooooool0
00000_l000001?oooooo0000o`000?ooool2o`00o`kooooo0_l0nYX9ooooo`;o003o00Co0?ZJo`00
0?l0003o00000ol0nYX00ooooooo0?ZJo`3jVP02o`0000;ooooo0_l00?l00ol0nY[oooooooooo`0G
ooooo`;o00000ol0nYX2o`00o`03o`3jV_oooooooooo00;o0?ZJ1Oooool2o`3jVP03ooooool0nY[o
0?ZJ00_ooooo0ol0nYX00ooooooo0?ZJo`3jVP0Kooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX0
0ooooooo0?ZJo`3jVP08ooooo`Go0?ZJ0_ooool3o`3jVP03ooooool0003o000000;o0?ZJ0oooool2
o`3jVPKooooo0_l0000Eooooo`03o`000?oooooooooo00Sooooo1ol00?l<ooooo`So000000?ooooo
o`3jV_l0nYX00oooool7o`3jVP?ooooo0ol00005ooooo`co00000oooool2o`0000Sooooo0ol00003
ooooo`?o00002?ooool3o`00043ooooo0_l0nYXIooooo`;o0?ZJIOooool00ol0003oooooooooo`0`
ooooo`00C_ooool00ol0003oooooooooo`06ooooo`;o0?ZJ1ol00?l00ooooooo0?ZJo`3jVP02o`3j
VR;ooooo0_l0nYX2o`00o`03o`3jV_oooooooooo00;ooooo1?l0000Hooooo`03o`000?l0nY[o0?ZJ
00;o0?ZJ00?oooooo`3jV_l0nYX00_l00?l00ol0nY[oooooo`000002o`3jVP;o00000_l0nYX2o`00
oaWooooo0_l00?l01?l0nY[oooooo`000?l00006o`00o`04o`3jV_l0003o0?ZJo`3jVP;o003o6_oo
ool2o`000003ooooool0nY[o0?ZJ00;o003o00?o0?ZJooooooooool00_l0nYX5ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX02oooool2o`3jVP;ooooo0_l0nYXKooooo`;o0?ZJ00?o0000o`3jV_l0nYX00_l0
nYX00ooooooo0?ZJo`3jVP08ooooo`Go0?ZJ0_ooool3o`3jVP?o00000_l0nYX3ooooo`;o0?ZJ1ooo
ool01?l0003oooooo`000?l00004ooooo`04o`000?ooooooooooooooo`Go00001Oooool00ol0003o
ooooooooo`08ooooo`;o003o4?ooool6o`000004ooooool0003o0000o`0000;o0?ZJ1_ooool4o`3j
VP?ooooo0_l00008ooooo`Go000000Coooooo`000?l0003o00001?ooool4o`0000Kooooo0_l00004
ooooo`?o00000oooool2o`0000;ooooo1?l00003ooooo`;o0000>oooool2o`3jVQWooooo0_l0nYYU
ooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo00Kooooo1?l0nYX00ol0
003o003oo`00o`02o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ0oooool2o`3jVQcooooo0ol0nYX2o`00
o`03o`3jV_oooooooooo00?ooooo0ol0000Hooooo`;o00000ol0nYX00ooooooo0?ZJo`3jVP02o`00
o`Go0?ZJ00Co0000o`3jV_l0nY[o0?ZJ0_l00?lIooooo`Go003o00?oooooo`00ool00?l01?l00?l4
o`3jVP;o003o6_ooool2o`000003ooooool0nY[o0?ZJ00;o003o00?o0?ZJooooooooool00_l0nYX5
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02oooool2o`3jVP;ooooo0_l0nYXKooooo`;o0?ZJ00?o0000
o`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP07ooooo`Ko0?ZJ0_ooool3o`3jVP?o00001_l00?l0
0ol0nY[oooooooooo`05ooooo`;o00000_ooool00ol0003oooooooooo`06ooooo`04o`000?oooooo
ooooo`0000Gooooo00?o0000ooooooooool02?ooool2o`00oa3ooooo1_l00002ooooo`;o00000_l0
nYX=ooooo`;o00002Oooool3o`0000;ooooo0ol00005ooooo`?o00001_ooool2o`0000Gooooo0ol0
00001?oooooo0000o`000?l00002ooooo`Co00000oooool2o`0000?ooooo0_l0000fooooo`Go0?ZJ
5_ooool2o`3jVVGooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool01ooo
ool3o`3jVP?o00000_l00?l5o`3jVP?ooooo0_l0nYXLooooo`;o0?ZJ00?o0000o`00ool00?l01_oo
ool3o`0001Sooooo2?l00003o`00o`Oo0?ZJ00?oooooo`00ool00?l06Oooool8o`00o`04o`3jV_oo
oooo003oo`00o`Co0?ZJ0_l00?lJooooo`;o000000?oooooo`000?l0nYX00_l00?l3ooooo`;o0?ZJ
1Oooool2o`3jVP03ooooool0nY[o0?ZJ00_ooooo0_l0nYX2ooooo`;o0?ZJ6_ooool3o`3jVP03o`00
0?l0nY[o0?ZJ00;o0?ZJ00?oooooo`3jV_l0nYX01oooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo
0ol0nYX3o`0000Ko003o00?o0?ZJooooooooool01Oooool2o`0000;ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`05ooooo`?o00000oooool7o`00oa3ooooo0_l000000ooooooo0000
o`000003ooooo`04o`000?l0nY[o0?ZJo`3jVPcooooo0ol0000:ooooo`;o00000_ooool3o`0000Ko
oooo0_l00005ooooo`?o00001_ooool6o`0000;ooooo1Ol00002ooooo`;o00000oooool3o`0003Ko
oooo2?l0nYXBooooo`;o0?ZJHoooool3o`0003;ooooo001>ooooo`03o`000?oooooooooo00Sooooo
0ol0nYX2o`0000;o003o0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`?o0?ZJ6oooool3o`3jVP03oooo
ool00?oo003o02;ooooo1ol000001Ol0nY[o003oo`00ool0nY[o000000Go0?ZJ00?oooooo`00ool0
0?l06Oooool3o`3jVP04ooooool00?oo003oo`00o`;o0?ZJ00Goooooo`00ool00?oo003oo`3jVP02
ooooo`;o003o6_ooool2o`000003ooooool0003o0?ZJ00Ko003o00?o0?ZJooooooooool00oooool2
o`3jVP03ooooool0nY[o0?ZJ00_ooooo0_l0nYX2ooooo`;o0?ZJ6_ooool2o`3jVP?o00000_l0nYX2
ooooo`;o0?ZJ1oooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo00Co0000o`3jV_l0nY[o0?ZJ0ol0
0002o`00o`;ooooo0_l00?l00ol0nY[oooooooooo`05ooooo`;o00000_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool7o`00oa3ooooo0_l0
00000ooooooo0000o`000003ooooo`04o`000?l0nY[o0?ZJooooo`;o00002_ooool2o`0000_ooooo
0_l00002ooooo`;o00001oooool3o`0000Cooooo0_l00007ooooo`Oo000000?oooooo`000?l00000
0ol000001?oooooo0000o`000?l00003ooooo`?o00002?ooool2o`0002oooooo2_l0nYX=ooooo`;o
0?ZJIOooool00ol0003oooooooooo`0`ooooo`00C_ooool2o`0000[ooooo0_l0nYX01?l0003ooooo
o`00ool00?l2o`3jVP04ooooool0nY[o0?ZJo`0000Co0?ZJ5?ooool2o`3jVP?ooooo0_l00002o`3j
VP04o`000?oooooo003oo`00ob;ooooo1ol000000ol0nY[o003oo`00o`02ooooo`04o`000?l0nY[o
0?ZJo`3jVP;ooooo0_l00?lJooooo`;o0?ZJ0oooool4o`3jVP03ooooool00?oo003o00Go003o6_oo
ool2o`000003ooooool0003o000000Oo003o1Oooool2o`3jVP03ooooool0nY[o0?ZJ00_ooooo0_l0
nYX2ooooo`;o0?ZJ6_ooool2o`3jVP?o00000_l0nYX2ooooo`;o0?ZJ1oooool2o`3jVP03ooooool0
nY[o0?ZJ00;ooooo00Co0000o`3jV_l0nY[o0?ZJ0ol00002o`00o`;ooooo0_l00?l00ol0nY[ooooo
ooooo`04ooooo`?o00000_ooool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooooooool0
00001Oooool00ol0003oooooooooo`03ooooo`?o00000_ooool2o`00013ooooo0_l00006ooooo`04
o`000?l0nY[o0?ZJooooo`;o00002_ooool2o`0000_ooooo0_l00002ooooo`;o00002?ooool5o`00
0003ooooool0003o000000Oooooo2_l000001?oooooo0000o`000?ooool3o`0000;ooooo1?l00007
ooooo`?o0000<oooool:o`3jVPWooooo0_l0nYYUooooo`03o`000?oooooooooo033ooooo001>oooo
o`03o`000?oooooooooo00Wooooo0_l0nYX01Ol0003oooooo`00ool00?oo0?ZJ00;ooooo1ol0nYXC
ooooo`?o0?ZJ0_ooool2o`0000;o003o00?o0?ZJo`000?ooool00_l00?lRooooo`So00000_l00?l2
ooooo`03o`000?l00?oo003o00Go003o6_ooool3o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ1ol00?lJ
ooooo`;o000000?oooooo`000?l000000_l0nYX00ol0003oooooooooo`02o`00o`Cooooo0ol0nYX0
0ooooooo0?ZJo`3jVP0;ooooo`;o0?ZJ0_ooool2o`3jVQ?ooooo0_l0nYX5ooooo`;o0?ZJ0ol00002
o`3jVP;ooooo0_l0nYX6ooooo`?o0?ZJ00Coooooo`3jV_l0nY[ooooo0_l00003o`3jVP?o00000_l0
0?l2ooooo`;o003o0_l0nYX6ooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`05o`000?oo
ooooooooooooool000001Oooool00ol0003oooooooooo`04ooooo`?o000000?oooooo`000?l00000
4?ooool2o`0000;ooooo1?l0nYX00ooooooo0?ZJo`3jVP03o`0000Kooooo0_l00002ooooo`;o0000
6Oooool8o`0000Oooooo0ol000000ooooooo0000o`000004o`000003ooooool0003o000000Co0000
0_ooool5o`0000Cooooo1ol0000eooooo`Ko0?ZJ2Oooool2o`3jVVGooooo00?o0000ooooooooool0
<?ooool003Cooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00003ooooo`?o00001_oo
ool00ol0003oooooooooo`09ooooo`;o0?ZJ00Go0000ooooool00?oo003oo`3jVP03ooooo`?o0?ZJ
00?oooooo`3jV_l0nYX04_ooool4o`3jVP;ooooo00?o0000o`3jV_l00?l01_l00?lRooooo`So0000
3?l00?lKooooo`Go0?ZJ0_ooool5o`3jVP04ooooool00?oo003oo`00oa[ooooo0_l000000ooooooo
0000o`000003o`3jVP;ooooo0_l00?l4ooooo`;o0?ZJ0_ooool2o`3jVP_ooooo0_l0nYX2ooooo`;o
0?ZJ4oooool2o`3jVPGooooo0_l0nYX3o`0000;o0?ZJ0_ooool2o`3jVPKooooo0_l0nYX2ooooo`Ko
003o00Co0?ZJo`000?l0003o00000ol00?l2ooooo`;o003o0_l0nYX6ooooo`04o`000?oooooo0000
o`0000Wooooo0ol00006ooooo`03o`000?oooooooooo00Gooooo0_l000000ooooooo0000o`00000?
ooooo`?o00000_ooool7o`3jVPCo00001Oooool2o`0000;ooooo0_l0000Iooooo`Oo00002?ooool3
o`000004ooooool0003o0000ooooo`;o00000_ooool6o`0000;ooooo0_l000000ooooooo0000o`00
0004ooooo`Oo0000>Oooool2o`3jVPWooooo0_l0nYX7ooooo`Co0?ZJF_ooool00ol0003ooooooooo
o`0`ooooo`00=Oooool00ol0003oooooooooo`06ooooo`07o`000?ooooooooooooooool0003ooooo
o`000003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool3o`3jVP04oooo
ool00?oo003oo`3jVP;o000000Goooooo`3jV_l0nY[o0?ZJooooo`02o`3jVQ;ooooo1?l0nYX2o`00
00;o0?ZJ1ol00?lRooooo`Ko000000?oooooo`000?l00?l01Ol00?l2o`3jVP;ooooo0_l0nYXLoooo
o`Co0?ZJ0oooool5o`3jVP03ooooool0nY[o0?ZJ01[ooooo0_l000001?oooooo0000o`000?ooool2
o`3jVP;ooooo0_l00?l4ooooo`;o0?ZJ0_ooool2o`3jVP_ooooo0_l0nYX2ooooo`;o0?ZJ4_ooool3
o`3jVPGooooo0_l0nYX3o`0000;o0?ZJ0_ooool2o`3jVPKooooo0_l0nYX2ooooo`Ko003o00Co0?ZJ
o`000?l0003o00000_l00?l00ol0nY[oooooooooo`02o`00o`;o0?ZJ1_ooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo00Gooooo1_l0000>ooooo`;o00000oooool2o`3jVP03ooooool0
nY[o0?ZJ00;o0?ZJ1?l00004ooooo`Oo00007?ooool4o`0000Sooooo0_l0000:ooooo`Go00000_oo
ool2o`000003ooooool0003o000000?ooooo2?l0000iooooo`;o0?ZJ2Oooool2o`3jVPCooooo1ol0
nYYJooooo`03o`000?oooooooooo033ooooo000booooo`Go00001oooool01Ol0003ooooooooooooo
oooo000000Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0:ooooo`;o0?ZJ00Co
ooooo`00ool00?oooooo0_l000001Ooooooo0?ZJo`3jV_l0nY[ooooo00;o0?ZJ4Oooool9o`3jVP;o
003o00?o0?ZJo`000?ooool00_l0nYXRooooo`Go00000_ooool00ol0003o0?ZJo`3jVP03ooooo`Co
0?ZJ00?oooooo`3jV_l0nYX07?ooool4o`3jVPKooooo1Ol0nYXJooooo`;o000000Coooooo`000?l0
003ooooo0_l0nYX2ooooo`;o003o1?ooool2o`00o`;ooooo0_l0nYX;ooooo`;o0?ZJ0_ooool2o`3j
VQ;ooooo0ol0nYX5ooooo`;o0?ZJ0ol00002o`3jVP;ooooo0_l0nYX6ooooo`;o0?ZJ0_ooool2o`00
o`05ooooool0003o003oo`00ool0nYX00ol00002o`00o`03o`3jV_oooooooooo00?o003o00?o0?ZJ
ooooooooool01?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Gooooo1_l00008
ooooo`Ko0?ZJ0_l00003ooooo`;o0?ZJ1Oooool4o`000004ooooool0003o0000ooooo`Oo00007Ooo
ool3o`0000Sooooo0_l0000:ooooo`Wo000000?oooooo`000?l000000oooool8o`0003Wooooo0_l0
nYX9ooooo`;o0?ZJ1?ooool4o`3jVP03ooooool0nY[o0?ZJ05[ooooo00?o0000ooooooooool0<?oo
ool003;ooooo00Co0000oooooooooooo00002?ooool4o`0000Kooooo00?o0000ooooooooool00ooo
ool2o`0000_ooooo0_l0nYX00ooooooo003oo`00o`05o`00o`;o0?ZJ00?oooooo`3jV_l0nYX04?oo
ool3o`3jVP03o`000?l0nY[o0?ZJ00?o0?ZJ00Co0000o`00ool00?oo0?ZJ0_ooool2o`3jVR;ooooo
0_l00005ooooo`03o`000?l0nY[o0?ZJ00?ooooo1?l0nYX00ooooooo0?ZJo`3jVP0Mooooo`?o0?ZJ
1oooool4o`3jVQ[ooooo0_l000001?oooooo0000o`000?ooool2o`3jVP;ooooo0_l00?l4ooooo`Ko
003o2oooool2o`3jVP;ooooo0_l0nYXBooooo`?o0?ZJ1Oooool2o`3jVP?o00000_l0nYX2ooooo`;o
0?ZJ1Oooool3o`3jVP;ooooo0_l00?l00ooooooo0000o`00o`02o`00o`03ooooool0003o000000;o
003o00Co0?ZJoooooooooooo00000_l00?l00ol0nY[oooooooooo`02ooooo`?o00005Oooool2o`00
00Kooooo1_l00008ooooo`Oo0?ZJ00Co0000oooooooooooooooo0_l0nYX7ooooo`;o000000?ooooo
o`000?l000001ol0000Nooooo`;o00005_ooool2o`000003ooooool0003o000000?o000000?ooooo
o`000?l000000_ooool9o`0003Wooooo0_l0nYX9ooooo`;o0?ZJ1?ooool2o`3jVP?ooooo0_l0nYYI
ooooo`;o0000<_ooool003?ooooo00?o0000ooooool000002?ooool00ol0003oooooooooo`03oooo
o`Co00001_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ00?oooooo`00ool00?l01Ol00?l2o`3j
VP03o`000?l0nY[o0?ZJ013ooooo0_l0nYX00ooooooo0000o`000003o`3jVP04o`000?l00?oo003o
o`00o`;o0?ZJ00?oooooo`3jV_l0nYX0:_ooool3o`3jVP03ooooool0nY[o0?ZJ00Ko0?ZJ7_ooool2
o`3jVPOooooo1?l0nYXJooooo`;o000000Coooooo`000?l0003ooooo0_l0nYX2ooooo`;o003o1?oo
ool6o`00o`[ooooo0ol0nYX2ooooo`;o0?ZJ4_ooool3o`3jVPCooooo0ol0nYX3o`0000;o0?ZJ0_oo
ool2o`3jVPGooooo0_l0nYX3ooooo`;o003o00?oooooo`000?l000001ol00?l01?l0nY[ooooooooo
ool00002o`00o`03o`3jV_oooooooooo00Cooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`06ooooo`Go00002?ooool2o`3jVP;ooooo0ol0nYX01?l0003oooooooooooooool2o`3jVPOo
oooo0_l000000ooooooo0000o`000007o`0001kooooo0_l0000Iooooo`?o00000oooool6o`0000;o
oooo1Ol0000iooooo`;o0?ZJ2Oooool2o`3jVP?ooooo0ol0nYX3ooooo`;o0?ZJF_ooool00ol0003o
ooooooooo`0`ooooo`00=?ooool2o`0000Wooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00[ooooo1Ol0nYX00ooooooo0000o`000007o`00o`oooooo
0ol0nYX00ooooooo0000o`000003o`3jVP03o`000?l00?oo003o00?o0?ZJ00?oooooo`3jV_l0nYX0
:oooool5o`3jVP;ooooo1?l0nYXYooooo`;o0?ZJ6_ooool2o`000004ooooool0003o0000ooooo`;o
0?ZJ0_ooool2o`00o`Cooooo0_l00?l2ooooo`;o003o2_ooool2o`3jVP?ooooo0_l0nYXAooooo`Co
0?ZJ1?ooool2o`3jVP?o000000?oooooo`3jV_l0nYX00_ooool2o`3jVPGooooo0_l0nYX00ooooooo
0000o`000002o`00o`?o00001ol00?l01?l0nY[o0000ooooool00002o`00o`Oooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`06ooooo`;o000000?oooooo`000?l000002?ooool2o`3j
VP?ooooo0_l0nYX01?l0003oooooooooooooool2o`3jVPOooooo3?l0000oooooo`Ko00001Oooool3
o`0003Sooooo1?l0nYX7ooooo`;o0?ZJ0oooool2o`3jVPCooooo0_l0nYYJooooo`03o`000?oooooo
oooo033ooooo000eooooo`03o`000?oooooooooo00Sooooo0_l00002ooooo`Go00001Oooool00ol0
003oooooooooo`0;ooooo`Go0?ZJ0_l000000ooooooo003oo`00o`04o`00o`oooooo0ol00?l00ooo
oooo0000o`000006o`00o`Ko0?ZJ;?ooool4o`3jVP?ooooo0ol0nYY5ooooo`;o000000Coooooo`00
0?l0003ooooo0ol0nYX01?oooooo003oo`00ooooool2o`000003ooooool00?oo003o00;ooooo0_l0
0?l:ooooo`;o0?ZJ0oooool2o`3jVQ7ooooo1?l0nYX4ooooo`;o0?ZJ0ol000000ooooooo0?ZJo`3j
VP02ooooo`;o0?ZJ1Oooool2o`3jVP03ooooool0003o000000;o003o00?o0?ZJo`000?l000000_l0
nYX01?oooooo0000o`000?ooool2o`3jVP03o`000?oooooo000000;o003o00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Wooooo0ol00007ooooo`;o0?ZJ
0oooool3o`3jVP?ooooo0_l0nYX7ooooo`So00000_ooool2o`0003oooooo1_l00006ooooo`;o0000
>?ooool7o`3jVPCooooo0_l0nYX2ooooo`?o0?ZJ1?ooool2o`3jVU[ooooo00?o0000ooooooooool0
<?ooool004kooooo00?o0000ooooooooool03?ooool4o`3jVP;o000000?oooooo`3jV_l0nYX00_l0
0002o`00o`04o`3jV_ooooooooooooooo`;o0?ZJ2Oooool<o`00o`03o`3jV_oooooo0?ZJ00?o0?ZJ
;Oooool3o`3jVT_ooooo1Ol000000ooooooo0000o`3jVP02o`3jVP;o003o00Coooooo`000?l0003o
oooo0_l00?l01?l0nY[oooooo`00ool00?l:ooooo`;o0?ZJ0oooool2o`3jVQ7ooooo1?l0nYX4oooo
o`;o0?ZJ0ol000000ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ1Oooool2o`3jVP03ooooool0003o0000
00;o003o00?o0?ZJo`000?l000000_l0nYX01?oooooo0000o`000?ooool2o`3jVP?o00000_l00?l0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool02_ooool4
o`0000Gooooo0_l0nYX3ooooo`04o`000?l0nY[o0?ZJo`3jVP;ooooo0_l0nYX8ooooo`?o0000Aooo
ool2o`000004ooooool0003o0000o`0000Kooooo0_l0000kooooo`Co0?ZJ1?ooool6o`3jVPGooooo
0_l0nYYJooooo`03o`000?oooooooooo033ooooo001>ooooo`;o00003_ooool3o`3jVP?o00000ol0
nYX01?oooooo003oo`00ool0nYX2ooooo`?o0?ZJ2Oooool7o`00o`;o0?ZJ00?oooooo`00ool00?l0
1?ooool2o`3jVRkooooo0_l0nYY;ooooo`Go000000?oooooo`000?l000000_l0nYX2o`00o`04oooo
ool0003o0000o`0000;o003o00Co0?ZJooooool00?oo003o2_ooool7o`00oa7ooooo1?l0nYX4oooo
o`;o0?ZJ0ol000000ooooooo003oo`00o`04o`00o`Gooooo0_l0nYX00ooooooo0000o`000002o`00
o`03o`3jV_l0003o000000;o0?ZJ00Coooooo`000?l0003ooooo0ol0nYX2o`0000?o003o1Oooool2
o`0001Gooooo00?o0000ooooooooool02_ooool4o`0000Gooooo0_l0nYX3ooooo`03o`000?l0nY[o
0?ZJ00Go0?ZJ2?ooool3o`0004_ooooo0_l00006ooooo`Co0000>oooool2o`3jVPCooooo1Ol0nYX6
ooooo`;o0?ZJF_ooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ0ol00003o`3jVP05ooooool00?oo003oo`3jV_ooool01?l0nYX9ooooo`;o003o00Co0?ZJ
o`000?l0003ooooo0ol0nYX00ooooooo0?ZJo`3jVP21ooooo`Go00000_ooool2o`000004o`3jV_l0
0?oo003oooooo`;o000000Go0?ZJo`00ool00?oo0?ZJooooo`02o`00o`[ooooo1ol00?l@ooooo`Go
0?ZJ1?ooool<o`00o`Gooooo0_l0nYX00ooooooo0000o`00o`02o`00o`03o`3jV_l0003ooooo00;o
0?ZJ00Coooooo`000?l0003ooooo0ol0nYX2o`0000?o003o1_ooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo00[ooooo1?l00005ooooo`;o0?ZJ00?oooooo`000?l000000_l000000ooo
oooo0?ZJo`3jVP03o`3jVPSooooo0ol0001;ooooo`;o00001_ooool4o`0003_ooooo0ol0nYX3oooo
o`?o0?ZJ2?ooool2o`3jVU[ooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000oooooooo
ool03_ooool3o`3jVP;o00000ol0nYX00ooooooo003oo`00o`06o`3jVP;ooooo0_l00005ooooo`;o
003o00Co0?ZJo`000?l0003ooooo0ol0nYX00ooooooo0?ZJo`3jVP21ooooo`Go00000_ooool2o`00
0004ooooool00?oo003oooooo`;o000000Go0?ZJo`00ool00?oo0?ZJooooo`02o`00o`[ooooo0_l0
0?l3ooooo`;o003o4?ooool2o`3jVP03ooooool0nY[o0?ZJ00Cooooo1ol00?l00ol0nY[ooooooooo
o`02o`00o`Gooooo0_l0nYX2o`0000;o003o0_l0nYX00ol0003oooooo`3jVP02o`3jVP;o000000Co
ooooo`3jV_l0nY[o0?ZJ0_l00002o`3jVPOooooo00?o0000ooooooooool04oooool2o`0000gooooo
0_l00005ooooo`;o0?ZJ00Coooooo`000?l0003o00003oooool2o`0005Gooooo0ol0000looooo`;o
0?ZJ0oooool2o`3jVPWooooo0_l0nYYIooooo`;o0000<_ooool004kooooo00?o0000ooooooooool0
3_ooool00ol0003o0?ZJo`3jVP05o`3jVP03ooooool00?oo003o00?o0?ZJ00?oooooo`3jV_l0nYX0
0_ooool2o`0000Gooooo0_l00?l01?l0nY[o0000o`000?ooool6o`3jVX;ooooo1?l00002ooooo`;o
000000Coooooo`00ool00?oooooo0_l000001Ol0nY[o003oo`00ool0nY[ooooo00;o003o2_ooool2
o`00o`03o`000?oooooooooo00;o003o4?ooool2o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_l00?l0
1?oooooo0000o`000?ooool2o`3jVP;ooooo0_l00?l4ooooo`?o0?ZJ0_l00002o`00o`;o0?ZJ00?o
0000ooooool0nYX00_l0nYX3ooooo`Co0?ZJ00?o0000o`3jV_l0nYX01oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo00cooooo0_l00005ooooo`;o0?ZJ1?l0001Vooooo`Co0000>ooo
ool6o`3jVP03o`00oooooooooooo00Oooooo0_l0nYYJooooo`03o`000?oooooooooo033ooooo001>
ooooo`03o`000?oooooooooo00kooooo0_l00007o`3jVP?o003o0_l0nYX00ooooooo0?ZJo`3jVP02
ooooo`;o00001Oooool2o`00o`;o0?ZJ00?o0000o`3jV_l0nYX01Ol0nYZ2ooooo`Co00000_ooool2
o`000004ooooool00?oo003oooooo`;o000000Go0?ZJo`00ool00?oo0?ZJooooo`02o`00o`[ooooo
0_l00?l00ol0003oooooooooo`02o`00o`Sooooo0_l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
1?ooool2o`00o`04ooooool0003o0000ooooo`;o0?ZJ0_ooool2o`00o`Cooooo0_l0nYX3o`0000;o
003o0_l0nYX00ol0003oooooo`3jVP02o`3jVP?ooooo1?l0nYX00ol0003o0?ZJo`3jVP07ooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool03?ooool2o`0000Gooooo0_l0nYX4o`0006Ko
oooo1?l0000kooooo`Oo0?ZJ2Oooool2o`3jVU[ooooo00?o0000ooooooooool0<?ooool004kooooo
0_l0000@ooooo`03o`000?l0nY[o0?ZJ00;o0?ZJ00Coooooo`3jV_l0nY[o00000_l00?l2o`3jVP03
ooooool0nY[o0?ZJ00;ooooo0_l00005ooooo`;o003o1Ol0nYX2ooooo`?o0?ZJP_ooool4o`0000;o
oooo0_l000001?oooooo003oo`00ooooool2o`000005o`3jV_l00?oo003oo`3jV_ooool00_l00?l:
ooooo`;o003o00?o0000ooooooooool00_l00?l8ooooo`;o0?ZJ1Oooool3o`3jVP03ooooool0nY[o
0?ZJ00Cooooo0_l00?l4ooooo`;o0?ZJ0_ooool2o`00o`Cooooo0_l0nYX3o`0000;o003o0_l0nYX0
0ol0003oooooo`3jVP02o`3jVP;ooooo1Ol0nYX01?l0003o0?ZJo`3jV_l0nYX5ooooo`;o00005Ooo
ool00ol0003oooooooooo`0<ooooo`;o00001Oooool2o`3jVPCo0000J?ooool2o`00043ooooo0_l0
nYX9ooooo`;o0?ZJF_ooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`0?
ooooo`03o`000?l0nY[o0?ZJ00;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_l00?l2o`3jVP03ooooool0
nY[o0?ZJ00;ooooo00?o0000o`3jV_l0nYX00oooool01?l0003o003oo`00ool00004o`3jVP?ooooo
0_l0nYZ2ooooo`Co00000_ooool2o`000004ooooool00?oo003oooooo`;o000000Go0?ZJo`00ool0
0?oo0?ZJooooo`02o`00o`[ooooo0_l00?l00ol0nY[oooooooooo`02o`00o`Sooooo0_l0nYX5oooo
o`;o0?ZJ00Co0000ooooool0nY[o0?ZJ1?ooool2o`00o`Cooooo0_l0nYX2ooooo`;o003o1?ooool2
o`3jVP?o00000_l00?l2o`3jVP03o`000?oooooo0?ZJ00;o0?ZJ0_ooool2o`3jVP03ooooool0nY[o
0?ZJ00Co0?ZJ1_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00cooooo0_l00007
o`3jVP03o`000?oooooooooo06Wooooo0_l00010ooooo`;o0?ZJ2Oooool2o`3jVU[ooooo00?o0000
ooooooooool0<?ooool004kooooo00?o0000ooooooooool03oooool2o`0000?o0?ZJ0_ooool2o`3j
VP;o003o00?o0?ZJo`000?ooool00_l0nYX00ooooooo0000o`3jVP02o`3jVP04ooooool0003o0000
o`0000;o003o00?o0000o`3jV_l0nYX00_l0nYZ7ooooo`Co00000_ooool2o`000005ooooool00?oo
003oooooool000000_l0nYX2o`00o`04o`3jV_oooooo003oo`00o`[ooooo0_l00?l00ol0nY[ooooo
ooooo`02o`00o`Sooooo0_l0nYX5ooooo`;o0?ZJ0_l00002o`3jVP?ooooo00Co0?ZJo`00ool00?oo
0?ZJ0oooool2o`3jVP;ooooo0_l00?l4ooooo`;o0?ZJ0ol00002o`00o`;o0?ZJ00?o0000ooooool0
nYX00_l0nYX2ooooo`;o0?ZJ00?oooooo`000?l0nYX01?l0nYX6ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool03?ooool2o`0000Oo0?ZJK?ooool2o`00043ooooo0_l0nYX9ooooo`;o
0?ZJDOooool3o`3jVPKooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0
4_ooool2o`3jVP?ooooo00Ko0?ZJo`00ool00?oo0?ZJo`000?ooool7o`3jVPCo00000_l00?l2o`00
00?o0?ZJR?ooool2o`0000?ooooo0_l000001Ooooooo003oo`00oooooooo000000;o0?ZJ0_l00?l2
o`3jVP;o003o2Oooool01?l0003o003oo`00ool0nYX2ooooo`;o003o1oooool3o`3jVPGooooo0_l0
nYX2o`0000;o0?ZJ0oooool01?l0nY[o003oo`00ool0nYX3ooooo`;o0?ZJ0_ooool2o`00o`Cooooo
1ol00?l2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool2o`3jVP03ooooool0003o0?ZJ00Co0?ZJ
1_ooool00ol0003oooooooooo`0Cooooo`;o00003Oooool2o`0000;o0?ZJ0_ooool3o`0006cooooo
0_l00010ooooo`;o0?ZJ2Oooool2o`3jVU7ooooo0ol0nYX5ooooo`;o0000<_ooool004kooooo00?o
0000ooooooooool05oooool01Ol0nY[o003oo`00ool0nY[o000000;ooooo1_l0nYX4o`0000;o003o
0ol00002o`3jVXSooooo0_l00003ooooo`?o00000_l00?l00ooooooo0?ZJo`3jVP03o`00o`;o0?ZJ
0_l00?l9ooooo`04o`000?l00?oo003oo`3jVP;ooooo0_l00?l3ooooo`;o0?ZJ0_ooool3o`3jVPGo
oooo0_l0nYX2o`0000;o0?ZJ0oooool01?l0nY[o003oo`00ool0nYX3ooooo`;o0?ZJ0_ooool2o`00
o`Cooooo1ol00?l2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ00?oooooo`3jV_l0nYX00_ooool5o`3j
VPKooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0<ooooo`;o00000_l0nYX5o`00
06cooooo0_l00010ooooo`;o0?ZJ2Oooool2o`3jVU7ooooo0_l0nYX7ooooo`03o`000?oooooooooo
033ooooo001>ooooo`;o00006?ooool00ol0nY[o003oo`00o`04o`00o`Ko0?ZJ0_l00002o`3jVP;o
003o00?oooooo`000?l00000R_ooool2o`0000Cooooo0_l00002o`00o`03ooooool0nY[o0?ZJ00;o
003o0ol0nYX2o`00o`Wooooo00Co0?ZJo`00ool00?oo0?ZJ0_ooool2o`00o`?ooooo0_l0nYX00ooo
oooo0?ZJo`3jVP02o`3jVPGooooo0_l0nYX2o`0000;o0?ZJ0oooool01?l0nY[o003oo`00ool0nYX3
ooooo`;o0?ZJ0_ooool2o`00o`04o`3jV_ooooooooooooooo`;o003o00Co0000oooooooooooooooo
1_l0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVP;ooooo1Ol0nYX5ooooo`;o00005Oooool00ol0003o
ooooooooo`0<ooooo`;o00000_l0nYX4o`0006gooooo0_l00010ooooo`;o0?ZJ1Ol00?l4ooooo`;o
0?ZJD?ooool3o`3jVPOooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0
5oooool00ol0003o003oo`00o`05o`00o`;o0?ZJ00Co0000o`3jV_l0nY[o00000ol0nYX2o`00o`03
ooooool0003o000008[ooooo0_l00004ooooo`;o00000_l00?l00ooooooo0?ZJo`3jVP02o`00o`03
o`3jV_l0003o0?ZJ00;o003o2Oooool01?l0nY[o003oo`00ool0nYX2ooooo`;o003o0_ooool3o`3j
VP03ooooool0nY[o0?ZJ00;o0?ZJ1Oooool2o`3jVP;o00000_l0nYX3ooooo`04o`3jV_l00?oo003o
o`3jVP?ooooo0_l0nYX2ooooo`;o003o00Co0?ZJoooooooooooooooo0_l00?l01?l0003ooooooooo
ooooool6o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ0_ooool3o`3jVPSooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0<ooooo`;o00000_l0nYX3o`0006kooooo0_l00010ooooo`;o
0?ZJ1Ol00?l4ooooo`;o0?ZJD?ooool2o`3jVP;o00001_ooool00ol0003oooooooooo`0`ooooo`00
C_ooool00ol0003oooooooooo`0Gooooo`03o`000?l0nY[o0?ZJ00?o00000_l00?l00ol0nY[o0000
o`000005o`3jVP04ooooool00?oo003oooooo`;o0000R_ooool2o`0000Cooooo0_l00002o`00o`03
ooooool0nY[o0?ZJ00;o003o00?o0?ZJo`000?l0nYX00_l00?l9ooooo`04o`3jV_l00?oo003oo`3j
VP;ooooo0_l00?l2ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX4ooooo`?o0?ZJ00Coooooo`00
0?l0nY[o0?ZJ0oooool01?l0nY[o003oo`00ool0nYX3ooooo`;o0?ZJ0_ooool2o`00o`04o`3jV_oo
ooooooooooooo`;o003o1?ooool6o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ0oooool2o`3jVPSo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0<ooooo`04o`000?l0nY[o0?ZJo`3j
VP?o0000K_ooool2o`0000;ooooo0_l0000looooo`;o0?ZJ0oooool2o`00o`Cooooo0_l0nYY?oooo
o`?o0?ZJ0_l00006ooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo01Oo
oooo00Co0000o`3jV_l0nY[o0?ZJ0_l00002o`00o`04o`3jV_oooooo0000o`0000?o0?ZJ0_ooool2
o`00o`03ooooool0003o000008[ooooo0_l00004ooooo`;o00000_l00?l3o`3jVP;o003o00?o0?ZJ
o`000?ooool00_l00?l9ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo0_l00?l2ooooo`So0?ZJ1?oo
ool2o`3jVP03o`000?oooooo000000;o0?ZJ0oooool01?l0nY[o003oo`00ool0nYX3ooooo`?o0?ZJ
00Coooooo`00ool00?oo0?ZJ0oooool2o`00o`Cooooo1_l0nYX00ooooooo0?ZJo`3jVP03o`3jVPgo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ1?l0001^ooooo`?o
000000?oooooo`000?l00000??ooool2o`3jVP?ooooo0_l00?l4ooooo`;o0?ZJC?ooool6o`3jVPSo
oooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool05oooool2o`0000;o0?ZJ
0_l00003o`00o`;ooooo00Co0000o`3jV_l0nY[o0?ZJ0_ooool2o`00ohgooooo0_l00004ooooo`;o
00000_l00?l2o`3jVP06o`000?l00?oo003oo`3jV_l0003ooooo0_l00?l00ol0nY[oooooooooo`06
ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo0_l00?l00ooooooo0?ZJo`3jVP04o`3jVP03ooooool0
nY[o0?ZJ00Cooooo0_l0nYX00ol0003oooooo`000002o`3jVP?ooooo00Co0?ZJo`00ool00?oo0?ZJ
0_ooool4o`3jVP04ooooool00?oo003oo`3jVP?ooooo0_l00?l00ol0nY[oooooooooo`03o`3jVP04
ooooool0nY[o0?ZJo`3jVP;ooooo1?l0nYX=ooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool03Oooool2o`3jVP;o0000LOooool5o`0000kooooo0_l00002ooooo`;o0000:?ooool2o`3j
VP?ooooo0ol00?l3ooooo`;o0?ZJBoooool6o`3jVP03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0<?ooool004kooooo0_l0000Hooooo`;o00000_l0nYX3o`0000Ko003o0_l0nYX2ooooo`;o
003oToooool2o`0000;o003o0_l0nYX01_l0003o003oo`00ool0nY[o0000ooooo`;o003o00?o0?ZJ
ooooooooool01_ooool01?l0nY[o003oo`00ool0nYX2ooooo`;o003o00?oooooo`3jV_l0nYX01?l0
nYX00ooooooo0?ZJo`3jVP04ooooo`;o0?ZJ00?o0000ooooool000000ol0nYX2ooooo`03o`3jV_l0
0?oo003o00;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX01?oooooo003oo`00ool0nYX2o`000004oooo
ool00?oo003oo`3jVP;ooooo0_l0nYX2ooooo`?o0?ZJ0_ooool4o`3jVPcooooo0_l0000Eooooo`;o
00002Oooool2o`3jVP?ooooo0_l0nYX2o`00077ooooo1Ol0000>ooooo`;o00000_ooool2o`0002So
oooo0_l0nYX4ooooo`;o003o0oooool2o`3jVT_ooooo0_l0nYX2ooooo`?o00001oooool2o`0003;o
oooo001>ooooo`03o`000?oooooooooo01Oooooo0_l00002o`3jVP?o00001_l00?l2o`3jVP;ooooo
0_l00?nDooooo`04o`000?l00?oo003oo`3jVP;o00000_l00?l00ol0nY[o0000ooooo`02o`00o`03
o`3jV_oooooooooo00Kooooo00Co0?ZJo`00ool00?oo0?ZJ0_ooool2o`00o`03ooooool0nY[o0?ZJ
00Co0?ZJ00?oooooo`3jV_l0nYX01?ooool2o`3jVP04o`000?oooooo0000o`0000;o0?ZJ00?ooooo
o`3jV_l0nYX00_l00?l2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00Coooooo`00ool00?oo0?ZJ0_l0
00001?oooooo003oo`00ool0nYX2ooooo`;o0?ZJ0_ooool3o`3jVP;ooooo1?l0nYX=ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool02?ooool7o`3jVP;o0000M?ooool2o`0000gooooo
1?l000001?oooooo0000o`000?l0000Wooooo`;o0?ZJ1?ooool5o`00o`;o0?ZJBoooool2o`3jVP;o
oooo0_l00009ooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo01Oooooo
0_l00003o`3jVP04o`000?oooooo0?ZJo`3jVP;ooooo2?l00?nDooooo`04o`000?l00?oo003oo`3j
VP;o00000_l00?l00ol0nY[o0000ooooo`02o`00o`03o`3jV_oooooooooo00Kooooo00?o0?ZJo`00
ool00?l00_l0nYX01?oooooo003oo`00ooooool6o`3jVP03ooooool0nY[o0?ZJ00Cooooo1ol00?l0
1?l0nY[oooooo`3jV_l0nYX2o`00o`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX2o`00o`04o`3jV_l0
003o0000ooooo`;o003o00?o0?ZJooooooooool00_l0nYX3ooooo`;o0?ZJ0_ooool4o`3jVPgooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`08ooooo`Oo0?ZJM_ooool3o`0000cooooo
1?l000001?oooooo0000o`000?l0000Wooooo`;o0?ZJ1?ooool5o`00o`;o0?ZJBoooool2o`3jVP;o
oooo0_l00009ooooo`03o`000?oooooooooo033ooooo000jooooo`?o00000oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05oooool2o`000005oooo
ool0nY[o0?ZJo`000?ooool00_l0nYX3ooooo`Oo003oU?ooool01_l0003o003oo`00ool0nY[o0000
ooooo`;o003o00?o0?ZJo`000?ooool00_l00?l00ol0nY[oooooooooo`05ooooo`04o`000?l0nY[o
003oo`00o`;o0?ZJ00Coooooo`00ool00?oooooo1Ol0nYX2ooooo`;o0?ZJ1?ooool7o`00o`04o`3j
V_oooooo0?ZJo`3jVP;o003o0_l0nYX01?oooooo0?ZJo`3jV_l00002o`3jVP;o003o00Co0?ZJo`00
0?l0003ooooo0_l00?l00ol0nY[oooooooooo`02o`3jVP?ooooo0_l0nYX2ooooo`Co0?ZJ3Oooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Sooooo0_l0nYYlooooo`;o00002_ooool6
o`000004ooooool0003o0000o`0002Oooooo0_l0nYX9ooooo`;o0?ZJBoooool2o`3jVP;ooooo0_l0
0009ooooo`03o`000?oooooooooo033ooooo000kooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`0Gooooo`;o000000?oooooo`3jV_l0nYX01?l0nYX3
ooooo`?o0?ZJ0_ooool2o`3jVYCooooo00Ko0000o`00ool00?oo0?ZJo`000?ooool2o`00o`03o`3j
V_l0003ooooo00;o003o00?o0?ZJooooooooool01Oooool01?l0003o0?ZJo`00ool00?l2o`3jVP03
ooooool00?oo003o00Ko0?ZJ0_ooool2o`3jVPCooooo0_l00?l2ooooo`03o`000?l00?oo003o00Co
0?ZJ0_l00?l5o`3jVP03o`000?l0nY[o0?ZJ00;o003o00Co0?ZJo`000?l0003o0?ZJ0_l00?l00ol0
nY[oooooooooo`02o`3jVP?ooooo0_l0nYX3ooooo`?o0?ZJ3Oooool01?l0003oooooo`000?l00004
ooooo`03o`000?oooooooooo00;ooooo0ol00006ooooo`03o`000?oooooooooo00Sooooo0_l0nYYl
ooooo`;o00002_ooool:o`0002Oooooo0_l0nYX9ooooo`;o0?ZJ6Oooool2o`3jVPCooooo0_l0nYXD
ooooo`;o0?ZJ4Oooool5o`3jVP;ooooo0_l00009ooooo`03o`000?oooooooooo033ooooo000hoooo
o`Go00002_ooool00ol0003oooooooooo`04ooooo`;o00006?ooool2o`0000;ooooo1Ol0nYX3oooo
o`?o0?ZJ0_ooool2o`3jVYCooooo00Ko0000o`00ool00?oo0?ZJo`000?ooool2o`00o`;o000000Co
ooooo`00ool00?oo0?ZJ1oooool2o`3jVP;o003o0ol0nYX2o`00o`;o0?ZJ0_ooool2o`3jVP;ooooo
0_l0nYX4ooooo`;o003o0_ooool00ol0003o003oo`00o`03o`3jVP?o003o00?oooooo`3jV_l0nYX0
0_l0nYX00ol0003o0?ZJo`3jVP02o`00o`04o`3jV_l0003o0000o`3jVP;o003o00?o0?ZJoooooooo
ool00_l0nYX3ooooo`;o0?ZJ0oooool3o`3jVP_ooooo1?l00002ooooo`03o`000?oooooooooo00Go
oooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo00Sooooo0_l0nYYloooo
o`;o00002_ooool3o`0000;ooooo1Ol0000Wooooo`;o0?ZJ2Oooool2o`3jVQSooooo0ol0nYX00ooo
oooo0?ZJo`3jVP03o`3jVQ7ooooo1Ol0nYX?ooooo`Ko0?ZJ00?oooooo`000?l000000_l00009oooo
o`03o`000?oooooooooo033ooooo000hooooo`04o`000?ooooooooooo`0000_ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0Gooooo`;o00000_ooool6o`3jVP;ooooo0ol0nYX2oooo
o`;o0?ZJUOooool2o`00o`;o000000?oooooo`00ool00?l00_l000001?oooooo003oo`00ool0nYX7
ooooo`;o0?ZJ0_l00?l00ol0003o0?ZJo`3jVP02o`00o`;o0?ZJ0_ooool2o`3jVP;ooooo0_l0nYX4
ooooo`;o003o0_ooool00ol0003o003oo`00o`03o`3jVP;o003o00?o0?ZJooooool0nYX00ol0nYX0
0ol0003oooooo`3jVP02o`00o`04o`3jV_l0003o0?ZJo`3jVP;o003o00?o0?ZJooooooooool00_l0
nYX8ooooo`?o0?ZJ3Oooool2o`0000;ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`03ooooo`?o00000oooool7o`3jVWcooooo1?l00008ooooo`?o00000_ooool6o`0002Kooooo1?l0
nYX7ooooo`;o0?ZJ5Oooool<o`3jVPoooooo1ol0nYX?ooooo`?o0?ZJ1?ooool4o`0000Oooooo0ol0
000booooo`00>Oooool00ol0003oooooo`00000<ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool05oooool2o`0000?ooooo2_l0nYX2ooooo`;o0?ZJUOooool2o`00o`;o000000?ooooo
o`00ool00?l00_l000001?oooooo003oo`00ool0nYX7ooooo`05o`3jV_l00?oo003oo`00ool00000
0_l0nYX2o`00o`;o0?ZJ0_ooool2o`3jVP;ooooo0_l0nYX4ooooo`;o003o0_ooool00ol0003o003o
o`00o`03o`3jVP;o003o00?o0?ZJooooool0nYX00ol0nYX00ol0003oooooo`3jVP02o`00o`04o`3j
V_l0003o0?ZJo`3jVP;o003o0_l0nYX00ooooooo0?ZJo`3jVP09ooooo`;o0?ZJ3Oooool2o`0000;o
oooo00?o0000ooooooooool01oooool2o`0000Kooooo00?o0000ooooooooool00oooool7o`3jVWgo
oooo1ol00004ooooo`;o00000oooool3o`000003ooooool0003o000002Oooooo1Ol0nYX5ooooo`;o
0?ZJ5?ooool5o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo0_l0nYX?ooooo`?o0?ZJ0_ooool2o`3j
VPoooooo0_l0nYX5ooooo`?o00002_ooool00ol0003oooooooooo`0`ooooo`00>_ooool2o`0000So
oooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo01gooooo0_l0nYX00ooo
oooo0?ZJo`3jVP05o`3jVP03ooooool0nY[o0?ZJ09Gooooo1ol00?l3o`0000;o003o00?o0?ZJoooo
ooooool01Oooool01?l0nY[o003oo`00ool0nYX2o`000003o`3jV_l00?oo003o00;o0?ZJ0_ooool2
o`3jVP;ooooo0_l0nYX4ooooo`;o003o00?o0?ZJooooool000000_l00?l2o`3jVP05o`000?l00?oo
003oo`3jV_ooool01?l0nYX2o`000005o`3jV_l00?oo003oo`00ool000000_l0nYX2o`00o`;o0?ZJ
00?oooooo`3jV_l0nYX06?ooool2o`0000;ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Oooooo0ol0nYYnooooo`Ko00001?ooool2o`0000Cooooo
0_l000000ooooooo0000o`00000Yooooo`Co0?ZJ1?ooool2o`3jVQCooooo0_l0nYX9ooooo`;o0?ZJ
2?ooool3o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ3_ooool3o`3jVP?ooooo1Ol0000:ooooo`03o`00
0?oooooooooo033ooooo000kooooo`03o`000?oooooooooo00Kooooo1Ol00005ooooo`03o`000?oo
oooooooo027ooooo0ol0nYX00ooooooo0?ZJo`3jVP03o`3jVYGooooo1ol00?l00ooooooo0000o`00
0003o`00o`Kooooo0_l0nYX2o`00o`04o`3jV_l0003o0000o`3jVP;o003o00Co0?ZJoooooooooooo
00000_l0nYX2ooooo`;o0?ZJ1?ooool2o`00o`03o`3jV_oooooo000000;o003o0_l0nYX01Ol0003o
003oo`00ool0nY[ooooo00Co0?ZJ0_l000001?oooooo0?ZJo`00ool00?l3o`3jVP;o003o0_l0nYX0
0ooooooo0?ZJo`3jVP0Hooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`05o`000?oooooo
ooooooooool000001Oooool00ol0003oooooooooo`28ooooo`Ko00000oooool3o`0000Oooooo0_l0
000Zooooo`?o0?ZJ1?ooool2o`3jVPKooooo0_l000000ooooooo0?ZJo`3jVP09ooooo`;o0?ZJ2Ooo
ool2o`3jVPGooooo1_l0nYX3ooooo`?o0?ZJ0oooool2o`3jVPgooooo00?o0000o`3jV_l0nYX01?oo
ool5o`0000[ooooo00?o0000ooooooooool0<?ooool004kooooo0_l0000Rooooo`?o0?ZJ0_ooool4
o`3jVYGooooo0_l0nYX2o`000004ooooool0nY[o0?ZJooooo`;o000000?o0?ZJo`00ool00?l01_oo
ool2o`3jVP;o003o00Co0?ZJo`000?l0003o0?ZJ0_l00?l01?l0nY[oooooooooool00002o`3jVP;o
oooo0_l0nYX4ooooo`;o003o00?o0?ZJooooool000000_l00?l2o`3jVP04o`000?l00?oo003oo`3j
VP;ooooo0ol0nYX2o`000004ooooool0nY[o003oo`00o`;o0?ZJ00?o0000o`00ool00?l00_l0nYX0
0ooooooo0?ZJo`3jVP0Gooooo`;o000000?oooooo`000?l000002Oooool3o`0000Kooooo00?o0000
ooooooooool0R?ooool3o`000003ooooool0003o000000?ooooo0_l00008ooooo`;o0000:oooool2
o`3jVPCooooo0_l0nYX6ooooo`03o`000?l0nY[o0?ZJ00;o0?ZJ0oooool2o`3jVP;ooooo1?l0nYX9
ooooo`;o0?ZJ1?ooool7o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ2Oooool2o`0000;ooooo00?o0000
o`3jV_l0nYX01?ooool3o`0000cooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000oooo
ooooool08_ooool2o`3jVP?ooooo0ol0nYZEooooo`;o0?ZJ0_l000001?oooooo0?ZJo`3jV_ooool2
o`000003o`3jV_l00?oo003o00?ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`04o`3jV_l0003o
0000ooooo`;o003o00Co0?ZJooooool0003o00000_l0nYX2ooooo`;o0?ZJ1?ooool2o`00o`03o`3j
V_oooooo000000;o003o0_l0nYX01?l0003o003oo`00ool0nYX2ooooo`?o0?ZJ0_l000001?oooooo
0?ZJo`00ool00?l2o`3jVP03o`000?l00?oo003o00Go0?ZJ6?ooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo08Sooooo0_l00002ooooo`;o00000oooool2o`0000Sooooo0_l0000[oooo
o`;o0?ZJ1?ooool2o`3jVPGooooo1_l0nYX00ooooooo0?ZJo`3jVP08o`3jVPWooooo0_l0nYX4oooo
o`?o0?ZJ0_ooool2o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ2Oooool2o`000003ooooool0nY[o0?ZJ
00;o0?ZJ0_l00002ooooo`;o00003Oooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003o
ooooooooo`0Xooooo`;o0?ZJUOooool3o`3jVP;ooooo0_l0nYX01?oooooo0000o`000?l0nYX2o`00
o`?ooooo1Ol0nYX2o`00o`04o`3jV_l0003o0000ooooo`;o003o00Co0?ZJooooool0003o00000_l0
nYX2ooooo`;o0?ZJ1?ooool2o`00o`03o`3jV_oooooo000000;o003o0_l0nYX01?l0003o003oo`00
ool0nYX2ooooo`?o0?ZJ0_l000001?oooooo0?ZJo`00ool00?l2o`3jVP04o`000?l00?oo003ooooo
o`Co0?ZJ6?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo08Sooooo0_l00002oooo
o`;o00000oooool2o`0000Sooooo0ol0000Zooooo`;o0?ZJ1?ooool2o`3jVPCooooo1?l0nYX00ol0
003o0?ZJo`3jVP08o`3jVPcooooo0_l0nYX3ooooo`?o0?ZJ0oooool7o`3jVPCooooo0_l0nYX8oooo
o`03o`000?l0nY[o0?ZJ00Co0?ZJ1ol0000=ooooo`03o`000?oooooooooo033ooooo001>ooooo`03
o`000?oooooooooo0<3ooooo0_l0nYX2ooooo`;o0?ZJ00Coooooo`000?l0003o0?ZJ0_l00?l2oooo
o`Go0?ZJ00Co0000o`00ool00?oo0?ZJ0_l000001Ooooooo003oo`00ool0nY[ooooo00;o00001_l0
0?l01?oooooo0000o`000?ooool2o`00o`03o`3jV_oooooo000000?o003o00Go0?ZJo`000?l00?oo
003oo`3jVP03ooooo`;o0?ZJ0_l000001?oooooo0?ZJo`00ool00?l2o`3jVP04o`000?l00?oo003o
ooooo`Co0?ZJ6?ooool00ol0003oooooooooo`0Cooooo`;o0000SOooool2o`0000?ooooo0_l00009
ooooo`;o0000:_ooool2o`3jVPCooooo0_l0nYX3ooooo`Co0?ZJ0_l00004o`3jVP03o`000?oooooo
0?ZJ00;o0?ZJ3Oooool2o`3jVP;ooooo0ol0nYX4ooooo`Ko0?ZJ1Oooool2o`3jVPOooooo0_l00004
o`3jVPWo00003?ooool2o`0003;ooooo001>ooooo`03o`000?oooooooooo0<3ooooo0_l0nYX2oooo
o`;o0?ZJ00Coooooo`000?l0003o0?ZJ0_l00?l2ooooo`Go0?ZJ00Co0000o`00ool00?oo0?ZJ0_l0
00001Ooooooo003oo`00ool0nY[ooooo00;o00001_l00?l01?oooooo0000o`000?ooool2o`00o`04
o`3jV_oooooo0000o`0000;o003o00Go0?ZJo`000?l00?oo003oo`3jVP05ooooo`;o000000Cooooo
o`3jV_l00?oo003o0_l0nYX01?l0003o003oo`00ooooool4o`3jVQSooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`2<ooooo`?o000000Coooooo`000?l0003o00002Oooool3o`0002Wo
oooo0_l0nYX4ooooo`;o0?ZJ0_ooool3o`3jVPCo00000_l0nYX3o`00017ooooo1ol0nYX4ooooo`?o
0?ZJ2?ooool2o`3jVP?ooooo0_l0nYX2ooooo`;o00000_l0nYX2ooooo`Wo00003Oooool00ol0003o
ooooooooo`0`ooooo`00C_ooool2o`000<7ooooo0_l0nYX2ooooo`;o0?ZJ00Coooooo`000?l0003o
0?ZJ0_l00?l00ooooooo0?ZJo`3jVP04o`3jVP04o`000?l00?oo003oo`3jVP;o000000Goooooo`00
ool00?oo0?ZJooooo`02o`0000;o003o0_ooool2o`00o`04ooooool0003o0000ooooo`;o003o00Co
0?ZJooooool0003o00000_l00?l01Ol0nY[o0000o`00ool00?oo0?ZJ00Gooooo0_l000001?oooooo
0?ZJo`00ool00?l2o`3jVP03ooooool00?oo003o00;ooooo0ol0nYXGooooo`;o00005Oooool00ol0
003oooooooooo`2<ooooo`?o000000Coooooo`000?l0003o00002_ooool2o`0000;ooooo0_l0000U
ooooo`;o0?ZJ1?ooool6o`3jVP03ooooool0003o000000?o000000?oooooo`000?l000000_l0000@
ooooo`Ko0?ZJ4?ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool2o`0000;o0?ZJ1_l00003
ooooo`;o00003Oooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`30oooo
o`;o0?ZJ0_ooool2o`3jVP04ooooool0003o0000o`3jVP;o003o00?oooooo`3jV_l0nYX01?l0nYX0
1?l0003o003oo`00ool0nYX2o`000003ooooool00?oo003o00Co00000_l00?l2ooooo`;o003o00Co
ooooo`000?l0003ooooo0_l00?l2o`3jVP;o00000_l00?l01Ol0nY[o0000o`00ool00?oo0?ZJ00Go
oooo0_l000001?oooooo0?ZJo`00ool00?l2o`3jVP03ooooool00?oo003o00;ooooo0ol0nYXHoooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0SOooool6o`0000[ooooo0_l000001?oo
oooo0000o`000?l0000Uooooo`;o0?ZJ1?ooool5o`3jVP;ooooo0_l000000ooooooo0000o`000005
o`00013ooooo0ol0nYXCooooo`Oo0?ZJ0_ooool01?l0003o0?ZJo`3jV_l0nYX3o`000003ooooool0
003o000001;ooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0`?ooool3
o`3jVP03ooooool0nY[o0?ZJ00;ooooo00Go0000o`3jV_l00?oo003oooooo`05o`3jVP;o00000_l0
0?l01?l0nY[o0000o`000?l00002o`00o`?o00000ol00?l2ooooo`;o003o0ol000000ooooooo003o
o`00o`02o`3jVP;o00000_l00?l01Ol0nY[o0000o`00ool00?oo0?ZJ00Gooooo0_l000001?oooooo
0?ZJo`00ool00?l2o`3jVP03ooooool00?oo003o00;ooooo0ol0nYXHooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0S_ooool5o`0000[ooooo1_l00005ooooo`;o00007_ooool3o`3j
VP?ooooo0ol0nYX3ooooo`?o000000?oooooo`000?l000000_l000000ooooooo0000o`00000Voooo
o`Co0?ZJ00?oooooo`3jV_l0nYX01_l0nYX3o`0001Gooooo00?o0000ooooooooool0<?ooool004ko
oooo00?o0000ooooooooool0`Oooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo00Co0000o`3jV_l0
0?oo003o1_l0nYX2o`0000;o003o00Co0?ZJooooool0003o00000_l00?l3o`0000;o003o00?o0?ZJ
ooooooooool00_l00?l01?l0nY[o0000o`000?ooool2o`00o`;o0?ZJ0_ooool2o`00o`05o`3jV_l0
003o003oo`00ool0nYX01Oooool2o`000005ooooool0nY[o003oo`00ool0nYX00_ooool2o`00o`;o
oooo0ol0nYXHooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0T?ooool2o`0000co
oooo1_l00004ooooo`;o00007oooool2o`3jVP?ooooo0_l00?l4ooooo`;o00000_ooool4o`000003
ooooool0003o000000Gooooo0_l0000Pooooo`;o00000oooool5o`3jVP?ooooo0_l0000Eooooo`03
o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo0<7ooooo0_l0nYX00ooooooo0?ZJ
o`3jVP03ooooo`03o`000?l00?oo003o00;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_l00002o`00o`04
o`3jV_oooooo0000o`0000;o003o0ol00002o`00o`03o`3jV_oooooooooo00;o003o00Co0?ZJo`00
0?l0003ooooo0_l00?l2o`3jVP;ooooo0_l00?l2o`0000;o003o1_ooool2o`000005ooooool0nY[o
003oo`00ool0nYX00_ooool2o`00o`;ooooo0ol0nYXHooooo`03o`000?oooooooooo01?ooooo0_l0
002Aooooo`;o00003?ooool6o`0000Cooooo0ol0000<ooooo`?o00003oooool2o`3jVP?ooooo0_l0
0?l2ooooo`Co00000oooool3o`000003ooooool0003o000000Gooooo0_l0000Oooooo`?o00000ooo
ool3o`3jVP03o`000?oooooooooo01Sooooo0_l0000booooo`00C_ooool2o`000<;ooooo1Ol0nYX3
ooooo`03o`000?l00?oo003o00;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_l00002o`00o`;ooooo0_l0
0007o`00o`03o`3jV_oooooooooo00;o003o00Co0?ZJo`000?l0003ooooo0_l00?l3o`3jVP03oooo
ool00?oo003o00;o00000_l00?l6ooooo`;o000000Goooooo`3jV_l00?oo003oo`3jVP02ooooo`;o
003o0_ooool3o`3jVQOooooo0_l0000Eooooo`03o`000?oooooooooo093ooooo0_l0000<ooooo`Ko
00001?ooool3o`0000cooooo1?l00007ooooo`;o00001Oooool2o`3jVP?ooooo0_l00?l00ooooooo
0000o`000003o`0000?ooooo0_l00002ooooo`?o00000oooool3o`0001oooooo1?l00003ooooo`?o
00004_ooool3o`00o`Kooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0
`_ooool4o`3jVP?ooooo00?o0000o`00ool00?l00_l0nYX2ooooo`;o0?ZJ00Co0000ooooool00?oo
003o0_ooool2o`0000Oo003o00?o0?ZJooooooooool00_l00?l01?l0nY[o0000o`000?ooool2o`00
o`04ooooool0nY[o0?ZJooooo`;o003o0_l00002o`00o`Kooooo1?l00002o`00o`03o`3jV_oooooo
oooo00;o003o0oooool2o`3jVQSooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2@
ooooo`;o00003?ooool3o`000003ooooool0003o000000Cooooo0ol0000;ooooo`Go00001oooool2
o`0000Gooooo0_l0nYX00ooooooo0000o`000002o`00o`03ooooool0003o000000;o00001?ooool2
o`0000?ooooo0_l00003ooooo`?o00007oooool5o`0000;ooooo0ol0000Booooo`?o003o1_ooool0
0ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`32ooooo`Co0?ZJ0oooool00ol0
003o003oo`00o`02o`3jVP;ooooo0_l0nYX01?l0003oooooo`00ool00?l2ooooo`;o00000_l0nYX3
o`000003ooooool0nY[o0?ZJ00;ooooo0_l00?l01?l0nY[o0000o`000?ooool2o`00o`04ooooool0
nY[o0?ZJooooo`;o003o00Co0000ooooool00?oo003o1oooool3o`0000;o003o00?o0?ZJoooooooo
ool00_l00?lMooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0W_ooool3o`000003
ooooool0003o000000?ooooo1?l0000;ooooo`Ko000000?oooooo`000?l000001_l00004ooooo`;o
0?ZJ00?oooooo`000?l000000_l00?l5o`0000Cooooo0_l00003ooooo`;o00000oooool3o`0001ko
oooo2ol0000Booooo`;o003o1oooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003ooooo
ooooo`32ooooo`Co0?ZJ0oooool00ol0003o003oo`00o`02o`3jVP;ooooo0_l0nYX01?l0003ooooo
o`00ool00?l2ooooo`;o00000_l0nYX3o`000003ooooool0nY[o0?ZJ00;ooooo0_l00?l01?l0nY[o
0000o`000?l0nYX2o`00o`04ooooool0nY[o0?ZJo`3jVPKo003o1oooool3o`0000;o003o00?o0?ZJ
ooooooooool00_l00?lMooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Woooool2
o`000003ooooool0003o000000?ooooo1?l0000;ooooo`oo00001?ooool2o`3jVP03ooooool0003o
000000;o003o0_l0000<ooooo`;o00000oooool3o`0001kooooo0_l000000ooooooo0000o`000006
o`0001;ooooo0_l00?l7ooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo
0<;ooooo1?l0nYX3ooooo`03o`000?l00?oo003o00;o0?ZJ0_ooool2o`3jVP04o`000?oooooo003o
o`00o`;ooooo0_l00002o`3jVP?o000000?oooooo`3jV_l0nYX00_ooool2o`00o`04o`3jV_l0003o
0000o`3jVP;o003o0_ooool2o`3jVPKo003o1oooool3o`0000;o003o00?o0?ZJooooooooool00_l0
0?lMooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0X_ooool2o`0000?ooooo1?l0
0007ooooo`;o00000_ooool2o`0000?ooooo2_l00004ooooo`Oo0?ZJ0_l0000<ooooo`?o00000_oo
ool3o`0001gooooo0ol00002ooooo`Go00004oooool3o`00o`Oooooo00?o0000ooooooooool0<?oo
ool004kooooo0_l00034ooooo`?o0?ZJ0oooool01?l0003o003oo`00ool0nYX3ooooo`;o0?ZJ00Co
0000ooooool00?oo003o0_ooool2o`0000;o0?ZJ0ol000000ooooooo0?ZJo`3jVP02ooooo`;o003o
00Co0?ZJo`000?l0003o0?ZJ0_l00?l2ooooo`Co0?ZJ00Co0000ooooool0nY[o0?ZJ1oooool3o`00
00;o003o0oooool2o`00oacooooo0_l0000Eooooo`03o`000?oooooooooo0:;ooooo0_l00003oooo
o`Co00001oooool2o`000004ooooool0003o0000o`0000?ooooo2ol00003ooooo`Oo0?ZJ00?o0000
ooooooooool03?ooool2o`000003ooooool0003o000000?o00007?ooool2o`0000Cooooo0ol0000D
ooooo`;o003o2?ooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`33oooo
o`?o0?ZJ0oooool01?l0003o003oo`00ool0nYX3ooooo`;o0?ZJ00Co0000ooooool00?oo003o0_oo
ool2o`0000?o0?ZJ0_l000001Ooooooo0?ZJo`3jV_l0nY[ooooo00;o003o00Co0?ZJo`000?l0nY[o
0?ZJ0_l00?l2ooooo`Co0?ZJ00Co0000ooooool0nY[o0?ZJ1oooool3o`0000;o003o0oooool2o`00
oagooooo00?o0000ooooooooool04oooool2o`000:?ooooo0ol000000ooooooo0000o`000003o`00
00Oooooo0_l000000ooooooo0000o`000004ooooo`Oo000000Coooooo`000?l0003o00000_ooool5
o`000004ooooool0nY[o0?ZJo`0000Sooooo0_l00?l4ooooo`;o000000Coooooo`000?l0003ooooo
0_l0000Looooo`;o00001?ooool3o`0000oooooo1ol00?l7ooooo`;o0000<_ooool004kooooo00?o
0000ooooooooool0a?ooool2o`3jVP?ooooo00Co0000o`00ool00?oo0?ZJ0oooool6o`00o`;ooooo
0ol00002o`3jVP03o`000?oooooooooo00?o0?ZJ00Goooooo`00ool00?oo0?ZJo`000002o`3jVP;o
003o0_ooool4o`3jVP04o`000?oooooo0?ZJo`3jVPOooooo0ol00002o`00o`?ooooo0_l00?lMoooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Xoooool2o`000004ooooool0003o0000
ooooo`;o00001oooool5o`0000Gooooo1_l000001?oooooo0000o`000?l00002ooooo`Go000000Co
ooooo`3jV_l0nY[o00000oooool7o`00o`Cooooo0_l000001?oooooo0000o`000?ooool2o`000004
ooooool00?oo003oo`00oaOooooo0ol00004ooooo`;o00004?ooool7o`00o`Sooooo00?o0000oooo
ooooool0<?ooool003Cooooo0ol00003ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool3o`0000Kooooo00?o0000ooooooooool0bOooool01?l0003o003oo`00ool0nYX3oooo
o`Ko003o0oooool2o`0000;o0?ZJ0oooool3o`3jVP03ooooool00?oo003o00Co0?ZJ0_l00?l2oooo
o`Co0?ZJ0_ooool2o`3jVPOooooo0ol00002o`00o`?ooooo0_l00?lMooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0Xoooool2o`000004ooooool0003o0000ooooo`;o00001_ooool6
o`0000Gooooo1Ol00002ooooo`Co000000?oooooo`000?l000000_l00002ooooo`;o0?ZJ00Co0000
oooooooooooooooo1ol00?l4ooooo`Go00001ol00?lGooooo`;o00001Oooool2o`00013ooooo0_l0
0?l=ooooo`03o`000?oooooooooo033ooooo000eooooo`03o`000?oooooooooo00Sooooo00Go0000
ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0bOoo
ool01?l0003o003oo`00ool0nYX3ooooo`;o003o0_ooool2o`3jVP?ooooo0_l00002o`3jVP?ooooo
1?l0nYX2o`00o`?o0?ZJ00?o0000o`00ool00?l00oooool4o`3jVP03ooooool0nY[o0?ZJ00Oooooo
0ol00007o`00oagooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2Sooooo`;o0000
00Coooooo`000?l0003ooooo0_l00006ooooo`Ko00002?ooool2o`0000Cooooo0_l000000ooooooo
0000o`000002o`0000;ooooo0_l0nYX00ol0003oooooooooo`03o`00o`?ooooo0_l00?l5ooooo`?o
000000?oooooo`00ool00?l02ol00?lAooooo`;o00001Oooool2o`00013ooooo0_l00?l=ooooo`03
o`000?oooooooooo033ooooo000booooo`Go00002_ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00?ooooo0_l0003:ooooo`07o`000?l00?oo003oo`3jV_l0003oooooo`000002o`00
o`;ooooo0_l0nYX3ooooo`;o00000_l0nYX2ooooo`Go0?ZJ0ol00?l2o`3jVP03o`000?l00?oo003o
00Gooooo0_l0nYX00ooooooo0?ZJo`3jVP07ooooo`?o00001ol00?lKooooo`?o00005Oooool00ol0
003oooooooooo`2Sooooo`Go000000Coooooo`000?l0003o00001Oooool2o`000004ooooool0003o
0000o`0000kooooo1_l00003ooooo`;o0?ZJ1Ol00?l4ooooo`;o003o1Oooool3o`000005ooooool0
0?oo003oo`000?ooool00_l00007o`00oa3ooooo0ol0000Gooooo`;o003o3Oooool00ol0003ooooo
ooooo`0`ooooo`00<_ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`3:ooooo`;o003o00Co0?ZJo`000?oooooo
00000_l00?l2ooooo`;o0?ZJ0oooool2o`0000;o0?ZJ0_ooool2o`3jVP04o`000?l0nY[o0?ZJoooo
o`;o003o0_l0nYX00ol0003o003oo`00o`05ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01oooool3o`00
00;o0?ZJ0oooool2o`3jVQgooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2Toooo
o`Co00000_ooool4o`0000?ooooo0_l000001?oooooo0000o`000?l0000>ooooo`Ko00000oooool2
o`3jVPGo003o1?ooool7o`00o`;o00000_ooool2o`00o`04o`000?oooooo0000o`0000;o003o0ooo
ool2o`00oa3ooooo0_l0000Hooooo`;o003o3Oooool00ol0003oooooooooo`0`ooooo`00<oooool0
0ol0003oooooo`00000<ooooo`03o`000?oooooo000000?o00001_ooool00ol0003oooooooooo`3:
ooooo`;o003o00?o0?ZJo`000?ooool00ol00?l2ooooo`;o0?ZJ0oooool2o`0000;o0?ZJ0_ooool2
o`3jVP04o`000?l0nY[o0?ZJo`3jVP;o003o0_l0nYX00ol0003o003oo`00o`05ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX01oooool3o`0000;o0?ZJ0oooool2o`3jVQgooooo00?o0000ooooooooool04ooo
ool2o`000:Kooooo0ol00002ooooo`Go00000_ooool2o`000003ooooool0003o000000oooooo1?l0
0005ooooo`;o0?ZJ00?o003oooooooooool01_ooool7o`00o`03o`000?l00?oo003o00?o003o1?l0
0005ooooo`;o003o4?ooool00ol0003o003oo`00o`03o`00oa7ooooo1Ol00?l<ooooo`;o0000<_oo
ool003Cooooo0_l00008ooooo`07o`000?ooooooooooooooool0003oooooo`000009ooooo`03o`00
0?oooooooooo0<[ooooo0_l00?l2o`000004ooooool00?oo003oo`3jVP;ooooo0_l0nYX3ooooo`;o
00000ol0nYX00ooooooo0?ZJo`3jVP02o`0000;o0?ZJ0_l00?l2o`3jVP03o`000?l00?oo003o00Go
oooo0_l0nYX00ooooooo0?ZJo`3jVP08ooooo`;o00000_l0nYX3ooooo`;o0?ZJ7Oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo0:Kooooo0_l00002ooooo`Go00000_ooool2o`000003
ooooool0003o0000013ooooo0ol00005ooooo`;o0?ZJ2Oooool3o`00o`;ooooo2?l00?l4o`0000;o
oooo0ol00002o`00o`oooooo1ol00?l?ooooo`Oo003o3Oooool00ol0003oooooooooo`0`ooooo`00
=Oooool00ol0003oooooooooo`06ooooo`Go000000?oooooo`000?l000000ol00005ooooo`03o`00
0?oooooooooo0<[ooooo0_l00?l3o`0000;o003o00?o0?ZJooooooooool00_l0nYX6ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX00_l00002o`3jVP;o003o0_l0nYX00ol0003o003oo`00o`05ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX02?ooool2o`0000;o0?ZJ0oooool2o`3jVQgooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`2Zooooo`Wo000000?oooooo`000?l000004?ooool3o`0000Gooooo
0_l0nYX?ooooo`?o003o1?ooool9o`0000;o003o2Oooool2o`00o`Cooooo0ol00?l2ooooo`;o003o
3oooool3o`00oa7ooooo00?o0000ooooooooool0<?ooool004kooooo0_l0003;ooooo`;o003o0ol0
0002o`00o`03o`3jV_oooooooooo00;o0?ZJ1_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o00000_l0
nYX2o`00o`;o0?ZJ00?oooooo`00ool00?l01Oooool2o`3jVP03ooooool0nY[o0?ZJ00Sooooo0_l0
0003o`3jVP;ooooo0_l0nYXLooooo`;o00005Oooool00ol0003oooooooooo`2[ooooo`;o000000?o
ooooo`000?l000000_l0000Eooooo`;o00001Oooool2o`3jVQKooooo2Ol00002o`00o`Cooooo1ol0
0?l4ooooo`;o003o00?o0000ooooooooool00_l00?l?ooooo`;o003o4_ooool00ol0003ooooooooo
o`0`ooooo`00C_ooool00ol0003oooooooooo`3:ooooo`Oo003o00?o0?ZJooooooooool00_l0nYX6
ooooo`Go0?ZJ0_l000001Ooooooo0?ZJo`00ool00?oo0?ZJ00;ooooo0_l00?l5ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX02?ooool2o`000003ooooool0nY[o0?ZJ00;ooooo0_l0nYXMooooo`04o`000?oo
oooo0000o`0000Cooooo00?o0000ooooooooool00oooool3o`0000Gooooo00?o0000ooooooooool0
[_ooool4o`0001cooooo0_l0nYXFooooo`Wo00000_l00?l01?l0003oooooooooooooool7o`00o`;o
oooo00Co0000o`00ool00?oo003o0oooool2o`00o`oooooo0_l00?lBooooo`03o`000?oooooooooo
033ooooo001>ooooo`03o`000?oooooooooo0<[ooooo1ol00?l00ol0nY[oooooooooo`02o`3jVPOo
oooo1?l0nYX3o`000004o`3jV_l00?oo003oo`3jVP;ooooo0_l00?l5ooooo`;o0?ZJ00?oooooo`3j
V_l0nYX02oooool2o`3jVP;ooooo0_l0nYXMooooo`;o00000_ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0[_ooool4o`0001cooooo0_l0nYXFoooo
o`Ko000000?oooooo`000?l000000_l00?l3o`0000?o003o0oooool2o`00o`;ooooo00Co0000o`00
ool00?oo00000oooool2o`00o`kooooo0ol00?lBooooo`03o`000?oooooooooo033ooooo001>oooo
o`03o`000?oooooooooo0<[ooooo0_l0nYX01?l0003oooooooooooooool2o`3jVP;ooooo0_l0nYX7
ooooo`Co0?ZJ00Coooooo`000?l0003o0?ZJ0_l00?l00ol0nY[oooooooooo`02o`00o`Gooooo0_l0
nYX00ooooooo0?ZJo`3jVP0;ooooo`;o0?ZJ0_ooool2o`3jVQgooooo0_l00002ooooo`03o`000?oo
oooooooo00Gooooo1Ol00005ooooo`03o`000?oooooooooo0:oooooo0_l0000Mooooo`;o0?ZJ5_oo
ool5o`0000?ooooo00?o0000o`00ool00?l00_l00003o`00o`Cooooo0_l00?l2ooooo`04o`000?l0
0?oo003oo`0000?ooooo0_l00?l>ooooo`;o003o4oooool00ol0003oooooooooo`0`ooooo`00C_oo
ool00ol0003oooooooooo`3:ooooo`;o0?ZJ00Co0000oooooooooooooooo0ol0nYX00ooooooo0?ZJ
o`3jVP07ooooo`Co0?ZJ00Coooooo`000?l0003o0?ZJ0_l00?l00ol0nY[oooooooooo`02o`00o`Go
oooo0_l0nYX00ooooooo0?ZJo`3jVP0;ooooo`;o0?ZJ0_ooool2o`3jVQgooooo0_l00002ooooo`03
o`000?oooooooooo00Gooooo00Co0000oooooooooooo00001_ooool3o`000:oooooo0_l0000Moooo
o`;o0?ZJ5oooool2o`0000Gooooo00?o0000o`00ool00?l01Ol00?l01?oooooo0000o`000?l00007
o`00o`04o`000?ooooooooooooooo`;o003o2oooool5o`00oa7ooooo0ol0000booooo`00C_ooool2
o`000<_ooooo0_l0nYX4ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01oooool4o`3jVP04ooooool0003o
0000o`3jVP;o003o00?o0?ZJooooooooool00_l00?l5ooooo`Go0?ZJ2oooool2o`3jVP;ooooo0_l0
nYXLooooo`?o00000_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000Kooooo00?o
0000ooooooooool0c_ooool2o`3jVQOooooo0_l00005ooooo`03o`000?l00?oo003o00Co003o1Ol0
0006o`00o`03o`000?oooooooooo00;ooooo0_l00?l9ooooo`Oo003o4oooool00ol0003ooooooooo
o`0`ooooo`00C_ooool00ol0003oooooooooo`3:ooooo`;o0?ZJ1?ooool3o`3jVP03ooooool0nY[o
0?ZJ00Oooooo1?l0nYX01?oooooo0000o`000?l0nYX2o`00o`03o`3jV_oooooooooo00;o003o1_oo
ool4o`3jVP_ooooo0_l0nYX2ooooo`;o0?ZJ7Oooool2o`0000;ooooo00?o0000ooooooooool01ooo
ool2o`0000Kooooo00?o0000ooooooooool0c_ooool2o`3jVQkooooo3?l00002o`00o`;ooooo0_l0
0005ooooo`;o003o0oooool2o`00o`Cooooo0ol00?lGooooo`03o`000?oooooooooo033ooooo001>
ooooo`03o`000?oooooooooo0<[ooooo0ol0nYX3ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01oooool4
o`3jVP04ooooool0003o0000o`3jVP;o003o00?o0?ZJooooooooool00_l00?l6ooooo`Co0?ZJ2ooo
ool2o`3jVP;ooooo0_l0nYXMooooo`04o`000?oooooo0000o`0000_ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`3>ooooo`;o0?ZJ1?ooool2o`3jVQ_ooooo1_l00002ooooo`?o0000
0_ooool2o`0000Gooooo1ol00?l4ooooo`;o003o6?ooool00ol0003oooooooooo`0`ooooo`00C_oo
ool00ol0003oooooooooo`3;ooooo`;o0?ZJ0oooool6o`3jVPSooooo0ol0nYX01?oooooo0000o`00
0?ooool2o`00o`?ooooo0_l00?l6ooooo`Co0?ZJ2oooool3o`3jVP03ooooool0nY[o0?ZJ01gooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`3>ooooo`;o0?ZJ1?ooool7o`3jVQKooooo
0_l00006ooooo`Oo00001Oooool7o`00o`Cooooo0_l00?lHooooo`03o`000?oooooooooo033ooooo
001>ooooo`03o`000?oooooooooo0<_ooooo0_l0nYX2ooooo`Oo0?ZJ2?ooool3o`3jVP04ooooool0
003o0000o`0000;o003o0oooool2o`00o`Oooooo0ol0nYX<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
7Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0<kooooo0_l0nYX4ooooo`Oo0?ZJ
8?ooool4o`0000Kooooo0_l00?l3ooooo`So003o6?ooool00ol0003oooooooooo`0`ooooo`00C_oo
ool00ol0003oooooooooo`3;ooooo`;o0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2?oo
ool3o`3jVP04ooooool0003o0000o`0000;o003o0oooool2o`00o`Oooooo0ol0nYX<ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX07Oooool00ol0003oooooooooo`0Cooooo`;o0000coooool3o`3jVP;ooooo
0ol0nYX3ooooo`;o0?ZJ8?ooool3o`0000gooooo1ol00?lGooooo`;o0000<_ooool004kooooo0_l0
003<ooooo`;o0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2Oooool2o`3jVP;ooooo0_l0
0007o`00o`Oooooo0ol0nYX<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX07?ooool2o`0001Gooooo00?o
0000ooooooooool0c_ooool7o`3jVPCooooo0_l0nYX`ooooo`?o003o7?ooool00ol0003ooooooooo
o`0`ooooo`00C_ooool00ol0003oooooooooo`3;ooooo`;o0?ZJ0_ooool2o`3jVP;ooooo0ol0nYX=
ooooo`;o00001ol00?l8ooooo`;o0?ZJ3?ooool2o`3jVP03ooooool0nY[o0?ZJ01gooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`3@ooooo`Go0?ZJ1?ooool2o`3jVToooooo00?o0000
ooooooooool0<?ooool004kooooo00?o0000ooooooooool0boooool2o`3jVP;ooooo0_l0nYX2oooo
o`?o0?ZJ3oooool2o`3jVP?ooooo0_l0nYX8ooooo`;o0?ZJ3?ooool2o`3jVP03ooooool0nY[o0?ZJ
01gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3Iooooo`;o0?ZJCoooool00ol0
003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`3;ooooo`?o0?ZJ00?oooooo`3jV_l0
nYX00_ooool3o`3jVPoooooo0_l0nYX3ooooo`;o0?ZJ2?ooool2o`3jVPcooooo0_l0nYX00ooooooo
0?ZJo`3jVP0Mooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0fOooool2o`3jVPWo
oooo1?l0nYXiooooo`?o0?ZJ1_ooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003ooooo
ooooo`3<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool3o`3jVPoooooo0_l0nYX3ooooo`;o0?ZJ
2?ooool2o`3jVPcooooo1Ol0nYXMooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
fOooool2o`3jVPWooooo1ol0nYXfooooo`?o0?ZJ1_ooool00ol0003oooooooooo`0`ooooo`00C_oo
ool2o`000<gooooo0_l0nYX00ooooooo0?ZJo`3jVP03ooooo`;o0?ZJ3oooool2o`3jVP?ooooo0_l0
nYXGooooo`Co0?ZJ7?ooool2o`0001Gooooo00?o0000ooooooooool0fOooool7o`3jVPCooooo0_l0
nYX00ooooooo0?ZJo`3jVP02o`3jVSKooooo0_l0nYX7ooooo`03o`000?oooooooooo033ooooo001>
ooooo`03o`000?oooooooooo0<cooooo0_l0nYX00ooooooo0?ZJo`3jVP03ooooo`;o0?ZJ3oooool3
o`3jVP;ooooo0_l0nYXGooooo`Co0?ZJ7Oooool00ol0003oooooooooo`0Cooooo`;o0000f_ooool7
o`3jVPCooooo0_l0nYX3ooooo`?o0?ZJ=?ooool3o`3jVPKooooo0_l0000booooo`00>_ooool3o`00
00?ooooo00?o0000ooooooooool00_ooool3o`0000Kooooo00?o0000ooooooooool0c?ooool2o`3j
VP03ooooool0nY[o0?ZJ01Gooooo0_l0nYX2ooooo`;o0?ZJ5oooool4o`3jVQgooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`3Nooooo`?o0?ZJ0oooool2o`3jVPCooooo1ol0nYX_oooo
o`;o0?ZJ2?ooool00ol0003oooooooooo`0`ooooo`00>oooool00ol0003oooooooooo`06ooooo`05
o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`3<ooooo`;o0?ZJ00?oooooo`3j
V_l0nYX05Oooool2o`3jVP;ooooo0_l0nYXHooooo`?o0?ZJ7Oooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo0=oooooo1ol0nYX4ooooo`Oo0?ZJ:_ooool7o`3jVPSooooo00?o0000oooo
ooooool0<?ooool003Sooooo1Ol00007ooooo`05o`000?ooooooooooooooool000001Oooool00ol0
003oooooooooo`3<ooooo`Go0?ZJ5Oooool2o`3jVP;ooooo0_l0nYXHooooo`?o0?ZJ7Oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo0=oooooo1ol0nYX9ooooo`;o0?ZJ:_ooool7o`3j
VPSooooo00?o0000ooooooooool0<?ooool003Sooooo00Co0000oooooooooooo00002Oooool3o`00
00Kooooo0_l0003>ooooo`Co0?ZJ5Oooool2o`3jVP;ooooo0_l0nYXHooooo`?o0?ZJ6oooool3o`00
01Gooooo00?o0000ooooooooool0koooool2o`3jVR[ooooo0_l0nYX=ooooo`03o`000?oooooooooo
033ooooo000iooooo`03o`000?oooooo000000Sooooo00Go0000ooooooooooooooooo`000005oooo
o`03o`000?oooooooooo0<gooooo1?l0nYXEooooo`;o0?ZJ0_ooool2o`3jVQWooooo0_l0nYXMoooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0koooool2o`3jVR[ooooo0_l0nYX=oooo
o`03o`000?oooooooooo033ooooo000jooooo`;o00002?ooool01Ol0003ooooooooooooooooo0000
00Gooooo00?o0000ooooooooool0cOooool4o`3jVQGooooo0_l0nYX2ooooo`;o0?ZJ>?ooool00ol0
003oooooooooo`0Cooooo`;o0000l?ooool2o`3jVR[ooooo0_l0nYX<ooooo`;o0000<_ooool003_o
oooo00?o0000ooooooooool01oooool3o`0000Kooooo00?o0000ooooooooool0c_ooool3o`3jVQGo
oooo0ol0nYX00ooooooo0?ZJo`3jVP0hooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0koooool2o`3jVPoooooo1ol0nYXDooooo`;o0?ZJ3Oooool00ol0003oooooooooo`0`ooooo`00
C_ooool00ol0003oooooooooo`3>ooooo`?o0?ZJ5_ooool2o`3jVP03ooooool0nY[o0?ZJ03Sooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`3_ooooo`;o0?ZJ3oooool7o`3jVQ?ooooo
0ol0nYX=ooooo`03o`000?oooooooooo033ooooo001>ooooo`;o0000d?ooool2o`3jVQKooooo0_l0
nYX00ooooooo0?ZJo`3jVP0gooooo`;o00005Oooool00ol0003oooooooooo`3_ooooo`;o0?ZJ1?oo
ool7o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ3oooool7o`3jVPgooooo00?o0000ooooooooool0<?oo
ool004kooooo00?o0000ooooooooool0ioooool2o`3jVP03ooooool0nY[o0?ZJ03Sooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`3_ooooo`;o0?ZJ1?ooool7o`3jVPCooooo0_l0nYX3
ooooo`;o0?ZJ3oooool5o`3jVPoooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000oooo
ooooool0ioooool2o`3jVP03ooooool0nY[o0?ZJ03Sooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`3_ooooo`;o0?ZJ0oooool3o`3jVP?ooooo0_l0nYX3ooooo`?o0?ZJ0oooool2o`3j
VPoooooo0_l0nYXBooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo0>Oo
oooo0_l0nYX00ooooooo0?ZJo`3jVP0hooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0koooool7o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ1?ooool2o`3jVPoooooo0_l0nYXBooooo`03
o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo0>Oooooo1Ol0nYXhooooo`03o`00
0?oooooooooo01?ooooo0_l0003`ooooo`Oo0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ
3_ooool3o`3jVQ7ooooo0_l0000booooo`00C_ooool2o`000>Wooooo1?l0nYXgooooo`;o00005Ooo
ool00ol0003oooooooooo`3jooooo`Oo0?ZJ1?ooool2o`3jVPkooooo0_l0nYXCooooo`03o`000?oo
oooooooo033ooooo001>ooooo`03o`000?oooooooooo0>Sooooo1?l0nYXhooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0n_ooool7o`3jVPCooooo0_l0nYX9ooooo`Oo0?ZJ4oooool0
0ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`3Xooooo`Co0?ZJ>?ooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo0?oooooo1_ooool2o`3jVP?ooooo0_l0nYX4oooo
o`Oo0?ZJ4oooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`3Yooooo`?o
0?ZJ>?ooool01?l0003oooooo`000?l00004ooooo`03o`000?oooooooooo00;ooooo0ol00006oooo
o`03o`000?oooooooooo0?oooooo1_ooool7o`3jVPCooooo0_l0nYXHooooo`03o`000?oooooooooo
033ooooo001>ooooo`03o`000?oooooooooo0>Wooooo0ol0nYXhooooo`;o00000_ooool00ol0003o
ooooooooo`05ooooo`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`3ooooo
o`Kooooo1ol0nYX4ooooo`;o0?ZJ6?ooool00ol0003oooooooooo`0`ooooo`00C_ooool2o`000>_o
oooo0_l0nYXgooooo`?o00000_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?o
oooo0ol0003oooooo`_ooooo0ol0nYX3ooooo`;o0?ZJ5_ooool3o`0003;ooooo001>ooooo`03o`00
0?oooooooooo0?oooooo9Oooool2o`0000;ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo0?oooooo3?ooool7o`3jVQSooooo00?o0000ooooooooool0
<?ooool004kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo02Cooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Tooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo013ooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo1?l00006ooooo`03o`000?oo
oooooooo0?oooooo3?ooool7o`3jVQSooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;o00000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0ooooool[
ooooo`03o`000?oooooooooo033ooooo001>oooooooo0000:Ol000000ooooooo0000o`000008oooo
o`Go00001Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02Cooooo00?o0000oooo
ooooool09?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Cooooo00?o0000oooo
ooooool09?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Cooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0`ooooo`00oooooon<ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0000booooo`00oooooon<oooooooo
0000;ol0000booooo`00ooooooooooooongooooo003oooooooooooookOooool00?ooooooooooooo]
ooooo`00ooooooooooooongooooo003oooooooooooookOooool00?ooooooooooooo]ooooo`00oooo
ooooooooongooooo003oooooooooooookOooool00?ooooooooooooo]ooooo`00ooooooooooooongo
oooo003oooooooooooookOooool00?ooooooooooooo]ooooo`00ooooooooooooongooooo003ooooo
ooooooookOooool00?oooooo8oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool01oooool3o`0000_ooooo00?o0000ooooooooool05?ooool3o`0000oo
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00oo
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo0?oo
oooo1?ooool00?oooooo8_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool03oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool0ooooool3ooooo`00ooooool2ooooo`?o00000oooool3o`0000;ooooo0ol0
00000ooooooo0000o`000003o`0000cooooo00?o0000ooooooooool00ol000000ooooooo0000o`00
0003ooooo`08o`000?ooooooooooo`000?oooooo0000ooooool00004ooooo`04o`000?oooooooooo
ooooo`?o00000oooool3o`0000;ooooo1?l00005ooooo`03o`000?oooooooooo00;o000000Cooooo
o`000?l0003ooooo1?l00002ooooo`Go00000_ooool4o`000006ooooool0003oooooo`000?oooooo
00000_ooool4o`0000?ooooo00?o0000ooooooooool00_ooool4o`0000Cooooo00?o0000oooooooo
ool00_ooool3o`0000Cooooo00?o0000ooooooooool01_ooool01Ol0003oooooo`000?oooooo0000
00Cooooo00?o0000ooooooooool01oooool3o`0000Cooooo00?o0000ooooooooool00_ooool3o`00
00Wooooo0ol00003ooooo`?o00001Oooool00ol0003oooooooooo`07ooooo`?o00001?ooool00ol0
003oooooooooo`3oooooo`?ooooo003oooooo`7ooooo00Oo0000ooooooooooooooooo`000?oooooo
000000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000=ooooo`05o`00
0?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`05o`000?oooooo0000oooo
ool000001oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000006ooooo`05o`000?ooooooooooooooool000000ooo
ool03Ol0003ooooooooooooooooo0000ooooool0003oooooo`000?oooooo0000ooooool000000_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`0<ooooo`05o`000?oooooo0000ooooool000003oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00_ooooo00Go0000ooooooooooooooooo`000003ooooo`03
o`000?oooooooooo00_ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
0?oooooo0oooool00?oooooo0Oooool01ol0003ooooooooooooooooo0000ooooool000000oooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool0
0_ooool00ol0003oooooo`000008ooooo`05o`000?oooooo0000ooooool000001oooool5o`0000;o
oooo00Co0000oooooooooooo00000_ooool3o`0000Wooooo0_l00004ooooo`?o00001?ooool01Ol0
003ooooooooooooooooo000000?ooooo00Oo0000ooooool0003oooooo`000?oooooo000000;ooooo
0ol00005ooooo`04o`000?ooooooooooooooo`Co00000oooool01?l0003oooooooooooooool5o`00
00gooooo00Go0000ooooool0003oooooo`00000?ooooo`03o`000?oooooooooo00Oooooo1Ol00002
ooooo`Co00000oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?oooooo0_ooool00?oooooo0Oooool0
0ol0003oooooo`000004o`000003ooooool0003o000000;o000000?oooooo`000?l000000_l00002
ooooo`?o00002oooool01?l0003oooooooooooooool2o`0000Wooooo00Go0000ooooool0003ooooo
o`000007ooooo`05o`000?ooooooooooooooool000000_ooool01_l0003oooooooooool0003ooooo
o`0000cooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`05ooooo`05o`000?oooooo
ooooooooool000000oooool02Ol0003oooooo`000?oooooo0000ooooool0003oooooo`000002oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00cooooo00Go0000ooooool0003oooooo`00000?ooooo`03o`000?oo
oooooooo00Oooooo00Go0000ooooooooooooooooo`000009ooooo`04o`000?ooooooooooooooo`Co
00004_ooool01Ol0003ooooooooooooooooo00000?oooooo1Oooool00?oooooo0Oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0;ooooo`07o`000?ooooooooooooooool0003oooooo`000008ooooo`;o000000?o
ooooo`000?ooool02?ooool3o`0000;ooooo1?l00003ooooo`Co00002?ooool01?l0003oooooo`00
0?l00002ooooo`Co000000Coooooo`000?l0003o00001?ooool7o`000003ooooool0003ooooo00;o
oooo0_l00005ooooo`03o`000?oooooooooo00[ooooo00Oo0000ooooooooooooooooo`000?oooooo
000000kooooo0_l000000ooooooo0000ooooo`0?ooooo`03o`000?oooooooooo00Sooooo0ol0000:
ooooo`05o`000?ooooooooooooooool000004Oooool4o`0000Cooooo00?o0000ooooooooool0oooo
ool3ooooo`00ooooool1ooooo`07o`000?ooooooooooooooool0003oooooo`000003ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`09oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo00cooooo00Co0000oooooooooooooooo0_l0000Qooooo`;o00005_oo
ool2o`0000Cooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo0?oooooo1?ooool00?oooooo0_ooool3o`0000?ooooo0ol00002ooooo`?o000000?ooooo
o`000?l000001Ol0000=ooooo`?o000000?oooooo`000?l00000:_ooool2o`0000cooooo00?o0000
ooooooooool0:?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool00oooool2o`0000kooooo1Ol0003oooooo`Wooooo003oooooooooooookOooool00?oo
ooooooooooo]ooooo`00\
\>"],
  ImageRangeCache->{{{0, 746.875}, {230.125, 0}} -> {-0.155964, -0.0154542, \
0.00309547, 0.00309547}, {{50.375, 373.438}, {225.125, 25.4375}} -> \
{-110.462, 4.43801, 1.29808, 0.00197483}, {{373.438, 696.438}, {225.125, \
25.4375}} -> {-512.139, -0.109831, 1.2728, 0.00306485}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Y[\([All, 2]\)] - YF[\([All, 2]\)] // TensorMS\)], "Input"],

Cell[BoxData[
    \({0.09791678949680459`, 0.10005248749346513`}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FIF ", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[TextData[{
  "?",
  StyleBox["FunctionalFilter",
    FontColor->RGBColor[1, 0, 0]]
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["Global`FunctionalFilter", "Print",
  PageWidth->Infinity,
  FontSize->14,
  CellTags->"Info3416806401-7520506"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(FunctionalFilter[{Z_, X_}, 
                      Theta_, {f_, g_, h_, Dh_, R_, p0_, 
                        dt_}, {{quote_, anti_, tanner_, sort_}, dW_, seed_, 
                        Generator_, miss_, option_ : 1}] := 
                    Block[{ti, T, T1, dti, dti1, n, n1, Xi, z, y0, P0, 
                        alpha0, yiiR, lik, yii, Pii, alphaii, YF, Misch, 
                        likvec, xi, dwi, yJ1, y, G, Pi1i, yi1i, liki, eps, 
                        N1, p}, {ti, T1, T, dti, dti1} = Zeiten1[Z, miss]; 
                      n = Length[dW]; n1 = 1.`\/n; 
                      Print["Monte-Carlo-Stichprobe n = ", n, "  seed = ", 
                        seed]; {y0, P0, alpha0} = 
                        p0[X\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          Theta, n]; {yiiR, lik, yii, Pii, alphaii} = 
                        MessUpOmnibus[{Z\[LeftDoubleBracket]1\
\[RightDoubleBracket], {y0, P0, alpha0}, 
                            X\[LeftDoubleBracket]1\[RightDoubleBracket]}, 
                          Theta, {h, Dh, R}, {miss, n, Generator, seed, 
                            False}]; 
                      N1 = Table[n1, {n}]; {n, p} = Dimensions[yii]; 
                      eps = zufall[Generator, n, p, seed, anti]; 
                      If[sort \[NotEqual] 0, {yii, Pii, alphaii} = 
                          Sortieren[{yii, Pii, alphaii}, sort]]; {yiiR, 
                          alphai1i} = 
                        Resampling[{yii, Pii, alphaii, N1}, eps, 
                          seed, {quote, tanner}]; YF = {}; Misch = {}; 
                      likvec = {lik}; 
                      Do[Xi = 
                          Take[X, 
                            dti\[LeftDoubleBracket]i\[RightDoubleBracket]]; 
                        xi = Last[Xi]; 
                        dwi = \((Take[#1, 
                                  dti1\[LeftDoubleBracket]
                                    i\[RightDoubleBracket]] &)\) /@ dW; {yJ1, 
                            y} = TimeUpFokker[{yiiR, Xi, dwi, dt}, 
                            Theta, {f, g}]; 
                        G = \((g[#1, xi, Theta] &)\) /@ yJ1; 
                        Pi1i = MapThread[Dot, {G, Transpose /@ G}]\ dt; 
                        yi1i = yJ1 + \((f[#1, xi, Theta] &)\) /@ yJ1\ dt; 
                        yi1i = Over[yi1i, YMAX]; 
                        If[option \[Equal] 2, YF = Join[YF, Transpose[y]]; ]; 
                        If[option \[Equal] 3, 
                          YF = Join[YF, Transpose[TensorMS[y]]]; ]; 
                        j = ti\[LeftDoubleBracket]
                            i + 1\[RightDoubleBracket]; {yiiR, liki, yii, 
                            Pii, alphaii} = 
                          MessUpOmnibus[{Z\[LeftDoubleBracket]
                                j\[RightDoubleBracket], {yi1i, Pi1i, 
                                alphai1i}, 
                              X\[LeftDoubleBracket]j\[RightDoubleBracket]}, 
                            Theta, {h, Dh, R}, {miss, n, Generator, seed, 
                              False}]; 
                        If[sort \[NotEqual] 0, {yii, Pii, alphaii} = 
                            Sortieren[{yii, Pii, alphaii}, sort]]; {yiiR, 
                            alphai1i} = 
                          Resampling[{yii, Pii, alphaii, N1}, eps, 
                            seed, {quote, tanner}]; 
                        lik += liki; , {i, 1, Length[ti] - 1}]; 
                      If[option \[Equal] 1, Return[lik]]; 
                      If[option \[Equal] 2, YF = Join[YF, {yiiR}]; 
                        Return[{YF, lik, Transpose[Misch]}]]; 
                      If[option \[Equal] 3, YF = Join[YF, {TensorMS[yiiR]}]; 
                        Return[{YF, lik, Misch}]]; ]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "FunctionalFilter"],
      Editable->False]], "Print",
  PageWidth->Infinity,
  FontSize->14,
  CellTags->"Info3416806401-7520506"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(\(TT = \(\(ZM // messind[#, miss] &\) // Delta\) // Max\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \({dt, k, p, q, r, u, T, TT, n} = {1. /365, 1, 2, 1, 2, 4, 365, TT, 
        500}\), "\n", 
    \(SeedRandom[123456789]\), "\[IndentingNewLine]", 
    \(\($dw$ = 
        Table[Random[NormalDistribution[0, 1]], {nn, n}, {t, TT}, {rr, r}]*
          Sqrt[dt];\)\ \  (*\ dW \((t)\)*) \), "\n", 
    \($dw$ // Dimensions\)}], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \(7\)], "Output",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \({0.0027397260273972603`, 1, 2, 1, 2, 4, 365, 7, 500}\)], "Output",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \({500, 7, 2}\)], "Output",
  PageWidth->Infinity,
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? cRandomC\)], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell["Global`cRandomC", "Print",
  PageWidth->Infinity,
  FontSize->14,
  CellTags->"Info3416811037-4307960"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "LINEARMESS  = True;\nYMAX = 500;\nYMAX = 10^16;\n\
generator=\"Random[NormalDistribution[0,1]]\";\n(*generator=\"Uni[]\"*)\n\n\
{YF,lik,Misch}= \n\t",
  StyleBox["FunctionalFilter",
    FontColor->RGBColor[1, 0, 0]],
  "[{logZM,X},{.07,-1,.2,.2},\n\t\t\t\t\t\t\
{drift,diffusion,h,Jacobih,R,p0,dt},\n\t\t\t\t\t\t{{1,0,0,0},Take[$dw$,200], \
seed=1234567, generator,-9, 3}];"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Monte-Carlo-Stichprobe n = "\[InvisibleSpace]200\
\[InvisibleSpace]"  seed = "\[InvisibleSpace]1234567\),
      SequenceForm[ "Monte-Carlo-Stichprobe n = ", 200, "  seed = ", 1234567],
      
      Editable->False]], "Print",
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{m,s}=YF//Transpose;
KI=m~ii~(m+s)~ii~(m-s);

G:=DisplayTogetherArray[
plot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}]//AddTimeAxis,PlotRange->{{0,\
366},All},
\t\t\t\t\tcolor->{10,1,2,2},dicke->.005],

DisplayTogether[      
\tplot1[Column[Y,{2}]//AddTimeAxis,color->10,dicke->.005,
\t      DisplayFunction->Identity],\t\t\t
\tplot1[Column[KI,{1,3,5}+1]//AddTimeAxis,PlotRange->{{0,366},All},
\t      color->{1,2,2},DisplayFunction->Identity]
],PlotLabel->\"FIF, n=200\"];
\t\t\t\t\t
G;\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 2}\),
      SequenceForm[ "Dimension der Daten  ", {366, 2}],
      Editable->False]], "Print",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 4}\),
      SequenceForm[ "Dimension der Daten  ", {366, 4}],
      Editable->False]], "Print",
  FontSize->14],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -32 0 ]
[.5 .32152 32 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -93 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(FIF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(n) show
99.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(200) show
123.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 0.00273224 -7.21187 1.62002 [
[.13661 -0.0125 -6 -9 ]
[.13661 -0.0125 6 0 ]
[.27322 -0.0125 -9 -9 ]
[.27322 -0.0125 9 0 ]
[.40984 -0.0125 -9 -9 ]
[.40984 -0.0125 9 0 ]
[.54645 -0.0125 -9 -9 ]
[.54645 -0.0125 9 0 ]
[.68306 -0.0125 -9 -9 ]
[.68306 -0.0125 9 0 ]
[.81967 -0.0125 -9 -9 ]
[.81967 -0.0125 9 0 ]
[.95628 -0.0125 -9 -9 ]
[.95628 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07821 -18 -4.5 ]
[-0.0125 .07821 0 4.5 ]
[-0.0125 .15921 -24 -4.5 ]
[-0.0125 .15921 0 4.5 ]
[-0.0125 .24022 -18 -4.5 ]
[-0.0125 .24022 0 4.5 ]
[-0.0125 .32122 -24 -4.5 ]
[-0.0125 .32122 0 4.5 ]
[-0.0125 .40222 -18 -4.5 ]
[-0.0125 .40222 0 4.5 ]
[-0.0125 .48322 -24 -4.5 ]
[-0.0125 .48322 0 4.5 ]
[-0.0125 .56422 -18 -4.5 ]
[-0.0125 .56422 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.13661 0 m
.13661 .00625 L
s
[(50)] .13661 -0.0125 0 1 Mshowa
.27322 0 m
.27322 .00625 L
s
[(100)] .27322 -0.0125 0 1 Mshowa
.40984 0 m
.40984 .00625 L
s
[(150)] .40984 -0.0125 0 1 Mshowa
.54645 0 m
.54645 .00625 L
s
[(200)] .54645 -0.0125 0 1 Mshowa
.68306 0 m
.68306 .00625 L
s
[(250)] .68306 -0.0125 0 1 Mshowa
.81967 0 m
.81967 .00625 L
s
[(300)] .81967 -0.0125 0 1 Mshowa
.95628 0 m
.95628 .00625 L
s
[(350)] .95628 -0.0125 0 1 Mshowa
.125 Mabswid
.02732 0 m
.02732 .00375 L
s
.05464 0 m
.05464 .00375 L
s
.08197 0 m
.08197 .00375 L
s
.10929 0 m
.10929 .00375 L
s
.16393 0 m
.16393 .00375 L
s
.19126 0 m
.19126 .00375 L
s
.21858 0 m
.21858 .00375 L
s
.2459 0 m
.2459 .00375 L
s
.30055 0 m
.30055 .00375 L
s
.32787 0 m
.32787 .00375 L
s
.35519 0 m
.35519 .00375 L
s
.38251 0 m
.38251 .00375 L
s
.43716 0 m
.43716 .00375 L
s
.46448 0 m
.46448 .00375 L
s
.4918 0 m
.4918 .00375 L
s
.51913 0 m
.51913 .00375 L
s
.57377 0 m
.57377 .00375 L
s
.60109 0 m
.60109 .00375 L
s
.62842 0 m
.62842 .00375 L
s
.65574 0 m
.65574 .00375 L
s
.71038 0 m
.71038 .00375 L
s
.7377 0 m
.7377 .00375 L
s
.76503 0 m
.76503 .00375 L
s
.79235 0 m
.79235 .00375 L
s
.84699 0 m
.84699 .00375 L
s
.87432 0 m
.87432 .00375 L
s
.90164 0 m
.90164 .00375 L
s
.92896 0 m
.92896 .00375 L
s
.98361 0 m
.98361 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07821 m
.00625 .07821 L
s
[(4.5)] -0.0125 .07821 1 0 Mshowa
0 .15921 m
.00625 .15921 L
s
[(4.55)] -0.0125 .15921 1 0 Mshowa
0 .24022 m
.00625 .24022 L
s
[(4.6)] -0.0125 .24022 1 0 Mshowa
0 .32122 m
.00625 .32122 L
s
[(4.65)] -0.0125 .32122 1 0 Mshowa
0 .40222 m
.00625 .40222 L
s
[(4.7)] -0.0125 .40222 1 0 Mshowa
0 .48322 m
.00625 .48322 L
s
[(4.75)] -0.0125 .48322 1 0 Mshowa
0 .56422 m
.00625 .56422 L
s
[(4.8)] -0.0125 .56422 1 0 Mshowa
.125 Mabswid
0 .01341 m
.00375 .01341 L
s
0 .02961 m
.00375 .02961 L
s
0 .04581 m
.00375 .04581 L
s
0 .06201 m
.00375 .06201 L
s
0 .09441 m
.00375 .09441 L
s
0 .11061 m
.00375 .11061 L
s
0 .12681 m
.00375 .12681 L
s
0 .14301 m
.00375 .14301 L
s
0 .17541 m
.00375 .17541 L
s
0 .19162 m
.00375 .19162 L
s
0 .20782 m
.00375 .20782 L
s
0 .22402 m
.00375 .22402 L
s
0 .25642 m
.00375 .25642 L
s
0 .27262 m
.00375 .27262 L
s
0 .28882 m
.00375 .28882 L
s
0 .30502 m
.00375 .30502 L
s
0 .33742 m
.00375 .33742 L
s
0 .35362 m
.00375 .35362 L
s
0 .36982 m
.00375 .36982 L
s
0 .38602 m
.00375 .38602 L
s
0 .41842 m
.00375 .41842 L
s
0 .43462 m
.00375 .43462 L
s
0 .45082 m
.00375 .45082 L
s
0 .46702 m
.00375 .46702 L
s
0 .49942 m
.00375 .49942 L
s
0 .51562 m
.00375 .51562 L
s
0 .53182 m
.00375 .53182 L
s
0 .54802 m
.00375 .54802 L
s
0 .58042 m
.00375 .58042 L
s
0 .59662 m
.00375 .59662 L
s
0 .61282 m
.00375 .61282 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 .61178 m
0 .61803 L
s
.13661 .61178 m
.13661 .61803 L
s
.27322 .61178 m
.27322 .61803 L
s
.40984 .61178 m
.40984 .61803 L
s
.54645 .61178 m
.54645 .61803 L
s
.68306 .61178 m
.68306 .61803 L
s
.81967 .61178 m
.81967 .61803 L
s
.95628 .61178 m
.95628 .61803 L
s
.125 Mabswid
.02732 .61428 m
.02732 .61803 L
s
.05464 .61428 m
.05464 .61803 L
s
.08197 .61428 m
.08197 .61803 L
s
.10929 .61428 m
.10929 .61803 L
s
.16393 .61428 m
.16393 .61803 L
s
.19126 .61428 m
.19126 .61803 L
s
.21858 .61428 m
.21858 .61803 L
s
.2459 .61428 m
.2459 .61803 L
s
.30055 .61428 m
.30055 .61803 L
s
.32787 .61428 m
.32787 .61803 L
s
.35519 .61428 m
.35519 .61803 L
s
.38251 .61428 m
.38251 .61803 L
s
.43716 .61428 m
.43716 .61803 L
s
.46448 .61428 m
.46448 .61803 L
s
.4918 .61428 m
.4918 .61803 L
s
.51913 .61428 m
.51913 .61803 L
s
.57377 .61428 m
.57377 .61803 L
s
.60109 .61428 m
.60109 .61803 L
s
.62842 .61428 m
.62842 .61803 L
s
.65574 .61428 m
.65574 .61803 L
s
.71038 .61428 m
.71038 .61803 L
s
.7377 .61428 m
.7377 .61803 L
s
.76503 .61428 m
.76503 .61803 L
s
.79235 .61428 m
.79235 .61803 L
s
.84699 .61428 m
.84699 .61803 L
s
.87432 .61428 m
.87432 .61803 L
s
.90164 .61428 m
.90164 .61803 L
s
.92896 .61428 m
.92896 .61803 L
s
.98361 .61428 m
.98361 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07821 m
1 .07821 L
s
.99375 .15921 m
1 .15921 L
s
.99375 .24022 m
1 .24022 L
s
.99375 .32122 m
1 .32122 L
s
.99375 .40222 m
1 .40222 L
s
.99375 .48322 m
1 .48322 L
s
.99375 .56422 m
1 .56422 L
s
.125 Mabswid
.99625 .01341 m
1 .01341 L
s
.99625 .02961 m
1 .02961 L
s
.99625 .04581 m
1 .04581 L
s
.99625 .06201 m
1 .06201 L
s
.99625 .09441 m
1 .09441 L
s
.99625 .11061 m
1 .11061 L
s
.99625 .12681 m
1 .12681 L
s
.99625 .14301 m
1 .14301 L
s
.99625 .17541 m
1 .17541 L
s
.99625 .19162 m
1 .19162 L
s
.99625 .20782 m
1 .20782 L
s
.99625 .22402 m
1 .22402 L
s
.99625 .25642 m
1 .25642 L
s
.99625 .27262 m
1 .27262 L
s
.99625 .28882 m
1 .28882 L
s
.99625 .30502 m
1 .30502 L
s
.99625 .33742 m
1 .33742 L
s
.99625 .35362 m
1 .35362 L
s
.99625 .36982 m
1 .36982 L
s
.99625 .38602 m
1 .38602 L
s
.99625 .41842 m
1 .41842 L
s
.99625 .43462 m
1 .43462 L
s
.99625 .45082 m
1 .45082 L
s
.99625 .46702 m
1 .46702 L
s
.99625 .49942 m
1 .49942 L
s
.99625 .51562 m
1 .51562 L
s
.99625 .53182 m
1 .53182 L
s
.99625 .54802 m
1 .54802 L
s
.99625 .58042 m
1 .58042 L
s
.99625 .59662 m
1 .59662 L
s
.99625 .61282 m
1 .61282 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
gsave
.99727 .33075 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.005 w
0 .24859 m
.00273 .25536 L
.00546 .25684 L
.0082 .23287 L
.01093 .24865 L
.01366 .24273 L
.01639 .26339 L
.01913 .29111 L
.02186 .2968 L
.02459 .32031 L
.02732 .28754 L
.03005 .29978 L
.03279 .27789 L
.03552 .29756 L
.03825 .32078 L
.04098 .33978 L
.04372 .35572 L
.04645 .3419 L
.04918 .31429 L
.05191 .35695 L
.05464 .34039 L
.05738 .32812 L
.06011 .30581 L
.06284 .31297 L
.06557 .33071 L
.06831 .32538 L
.07104 .34231 L
.07377 .40658 L
.0765 .3702 L
.07923 .35981 L
.08197 .3611 L
.0847 .38422 L
.08743 .39737 L
.09016 .37795 L
.0929 .37467 L
.09563 .38587 L
.09836 .36641 L
.10109 .37248 L
.10383 .36914 L
.10656 .34583 L
.10929 .36311 L
.11202 .3896 L
.11475 .39164 L
.11749 .36476 L
.12022 .37214 L
.12295 .3593 L
.12568 .36704 L
.12842 .36415 L
.13115 .34708 L
.13388 .33291 L
Mistroke
.13661 .34133 L
.13934 .3545 L
.14208 .378 L
.14481 .34441 L
.14754 .31766 L
.15027 .32488 L
.15301 .33182 L
.15574 .32461 L
.15847 .31417 L
.1612 .32875 L
.16393 .30962 L
.16667 .30766 L
.1694 .31555 L
.17213 .31084 L
.17486 .31207 L
.1776 .31548 L
.18033 .3002 L
.18306 .29418 L
.18579 .24388 L
.18852 .24679 L
.19126 .25559 L
.19399 .25143 L
.19672 .2476 L
.19945 .26268 L
.20219 .26628 L
.20492 .26917 L
.20765 .24152 L
.21038 .26298 L
.21311 .28983 L
.21585 .28566 L
.21858 .29605 L
.22131 .29772 L
.22404 .25441 L
.22678 .26071 L
.22951 .26085 L
.23224 .2696 L
.23497 .26277 L
.2377 .26425 L
.24044 .27154 L
.24317 .26449 L
.2459 .26206 L
.24863 .26566 L
.25137 .25974 L
.2541 .25779 L
.25683 .26339 L
.25956 .27174 L
.2623 .27649 L
.26503 .26888 L
.26776 .24525 L
.27049 .25938 L
Mistroke
.27322 .26716 L
.27596 .24394 L
.27869 .22478 L
.28142 .23879 L
.28415 .22282 L
.28689 .24491 L
.28962 .20699 L
.29235 .21281 L
.29508 .22536 L
.29781 .23094 L
.30055 .25679 L
.30328 .27505 L
.30601 .27363 L
.30874 .26693 L
.31148 .28464 L
.31421 .27741 L
.31694 .31916 L
.31967 .31155 L
.3224 .28029 L
.32514 .27759 L
.32787 .31458 L
.3306 .31212 L
.33333 .29276 L
.33607 .29043 L
.3388 .29892 L
.34153 .31785 L
.34426 .31218 L
.34699 .30257 L
.34973 .29982 L
.35246 .29856 L
.35519 .29554 L
.35792 .28111 L
.36066 .3041 L
.36339 .30844 L
.36612 .30627 L
.36885 .27533 L
.37158 .27603 L
.37432 .25456 L
.37705 .27198 L
.37978 .25245 L
.38251 .24813 L
.38525 .25767 L
.38798 .27241 L
.39071 .248 L
.39344 .2554 L
.39617 .26795 L
.39891 .27499 L
.40164 .24689 L
.40437 .22786 L
.4071 .23932 L
Mistroke
.40984 .22497 L
.41257 .24427 L
.4153 .25285 L
.41803 .24999 L
.42077 .26484 L
.4235 .24867 L
.42623 .25145 L
.42896 .26189 L
.43169 .25655 L
.43443 .27258 L
.43716 .27213 L
.43989 .23973 L
.44262 .21817 L
.44536 .22954 L
.44809 .27846 L
.45082 .25958 L
.45355 .26017 L
.45628 .22911 L
.45902 .24398 L
.46175 .24486 L
.46448 .25438 L
.46721 .22353 L
.46995 .25005 L
.47268 .25857 L
.47541 .27896 L
.47814 .29707 L
.48087 .25097 L
.48361 .25693 L
.48634 .23426 L
.48907 .28414 L
.4918 .2906 L
.49454 .27955 L
.49727 .29323 L
.5 .28703 L
.50273 .29717 L
.50546 .26723 L
.5082 .27006 L
.51093 .2952 L
.51366 .25634 L
.51639 .30632 L
.51913 .28585 L
.52186 .26377 L
.52459 .23305 L
.52732 .25416 L
.53005 .2692 L
.53279 .27175 L
.53552 .25161 L
.53825 .21897 L
.54098 .16257 L
.54372 .1892 L
Mistroke
.54645 .20301 L
.54918 .20802 L
.55191 .18488 L
.55464 .20574 L
.55738 .24115 L
.56011 .2038 L
.56284 .19769 L
.56557 .17045 L
.56831 .10021 L
.57104 .0621 L
.57377 .08379 L
.5765 .1228 L
.57923 .11832 L
.58197 .12474 L
.5847 .11557 L
.58743 .11418 L
.59016 .11694 L
.5929 .14412 L
.59563 .14656 L
.59836 .14567 L
.60109 .14508 L
.60383 .16013 L
.60656 .15454 L
.60929 .15581 L
.61202 .22036 L
.61475 .24604 L
.61749 .20897 L
.62022 .2233 L
.62295 .21545 L
.62568 .2235 L
.62842 .24427 L
.63115 .26025 L
.63388 .34071 L
.63661 .3337 L
.63934 .37903 L
.64208 .33965 L
.64481 .30097 L
.64754 .28977 L
.65027 .30343 L
.65301 .3053 L
.65574 .32343 L
.65847 .34687 L
.6612 .38154 L
.66393 .37739 L
.66667 .42057 L
.6694 .4113 L
.67213 .40645 L
.67486 .41951 L
.6776 .36087 L
.68033 .33281 L
Mistroke
.68306 .33975 L
.68579 .35624 L
.68852 .32051 L
.69126 .37669 L
.69399 .38883 L
.69672 .43129 L
.69945 .44164 L
.70219 .40969 L
.70492 .46379 L
.70765 .49964 L
.71038 .50657 L
.71311 .48158 L
.71585 .48235 L
.71858 .50237 L
.72131 .5027 L
.72404 .48842 L
.72678 .47126 L
.72951 .44337 L
.73224 .46565 L
.73497 .42766 L
.7377 .42127 L
.74044 .39807 L
.74317 .38558 L
.7459 .33857 L
.74863 .35521 L
.75137 .39654 L
.7541 .42038 L
.75683 .45307 L
.75956 .48969 L
.7623 .47226 L
.76503 .44892 L
.76776 .40305 L
.77049 .46971 L
.77322 .46257 L
.77596 .45569 L
.77869 .42098 L
.78142 .4154 L
.78415 .42719 L
.78689 .46164 L
.78962 .47943 L
.79235 .52488 L
.79508 .53209 L
.79781 .52615 L
.80055 .52752 L
.80328 .53309 L
.80601 .451 L
.80874 .4289 L
.81148 .45879 L
.81421 .47586 L
.81694 .49153 L
Mistroke
.81967 .42289 L
.8224 .39279 L
.82514 .39171 L
.82787 .35224 L
.8306 .36836 L
.83333 .366 L
.83607 .43639 L
.8388 .41282 L
.84153 .45919 L
.84426 .44167 L
.84699 .46901 L
.84973 .43007 L
.85246 .4088 L
.85519 .38656 L
.85792 .39173 L
.86066 .34029 L
.86339 .34056 L
.86612 .28216 L
.86885 .29877 L
.87158 .3464 L
.87432 .30074 L
.87705 .29283 L
.87978 .33826 L
.88251 .38738 L
.88525 .4311 L
.88798 .47403 L
.89071 .49941 L
.89344 .4427 L
.89617 .41368 L
.89891 .47963 L
.90164 .44003 L
.90437 .40066 L
.9071 .38636 L
.90984 .41178 L
.91257 .42788 L
.9153 .39848 L
.91803 .36285 L
.92077 .37045 L
.9235 .34903 L
.92623 .35671 L
.92896 .32849 L
.93169 .33269 L
.93443 .34022 L
.93716 .31249 L
.93989 .33729 L
.94262 .34257 L
.94536 .35771 L
.94809 .31369 L
.95082 .30166 L
.95355 .32162 L
Mistroke
.95628 .32421 L
.95902 .30494 L
.96175 .30082 L
.96448 .29259 L
.96721 .34068 L
.96995 .27084 L
.97268 .2997 L
.97541 .29583 L
.97814 .30332 L
.98087 .34614 L
.98361 .35461 L
.98634 .36983 L
.98907 .3433 L
.9918 .3193 L
.99454 .33837 L
.99727 .33075 L
Mfstroke
0 0 1 r
gsave
.99727 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24881 m
.00273 .24885 L
.00546 .24763 L
.0082 .24981 L
.01093 .24855 L
.01366 .24579 L
.01639 .246 L
.01913 .29096 L
.02186 .29233 L
.02459 .29165 L
.02732 .29416 L
.03005 .29229 L
.03279 .28977 L
.03552 .29046 L
.03825 .32081 L
.04098 .32165 L
.04372 .32104 L
.04645 .32337 L
.04918 .32188 L
.05191 .31889 L
.05464 .31949 L
.05738 .32819 L
.06011 .32911 L
.06284 .32891 L
.06557 .33061 L
.06831 .32819 L
.07104 .32561 L
.07377 .3265 L
.0765 .37026 L
.07923 .37132 L
.08197 .37074 L
.0847 .37354 L
.08743 .37161 L
.09016 .36981 L
.0929 .37043 L
.09563 .38612 L
.09836 .38734 L
.10109 .38693 L
.10383 .38869 L
.10656 .3868 L
.10929 .38466 L
.11202 .38551 L
.11475 .39161 L
.11749 .39288 L
.12022 .39256 L
.12295 .39465 L
.12568 .39309 L
.12842 .39097 L
.13115 .39171 L
.13388 .33288 L
Mistroke
.13661 .33453 L
.13934 .33354 L
.14208 .33613 L
.14481 .3337 L
.14754 .33175 L
.15027 .33257 L
.15301 .33179 L
.15574 .33296 L
.15847 .33274 L
.1612 .33473 L
.16393 .33305 L
.16667 .33166 L
.1694 .33217 L
.17213 .31077 L
.17486 .31193 L
.1776 .31129 L
.18033 .31383 L
.18306 .3124 L
.18579 .31088 L
.18852 .31176 L
.19126 .25552 L
.19399 .257 L
.19672 .25693 L
.19945 .25869 L
.20219 .25655 L
.20492 .25375 L
.20765 .25438 L
.21038 .26312 L
.21311 .26418 L
.21585 .26397 L
.21858 .26528 L
.22131 .26284 L
.22404 .26092 L
.22678 .26096 L
.22951 .26069 L
.23224 .26215 L
.23497 .26235 L
.2377 .26366 L
.24044 .26196 L
.24317 .25996 L
.2459 .2607 L
.24863 .26552 L
.25137 .26575 L
.2541 .26635 L
.25683 .26655 L
.25956 .26589 L
.2623 .26483 L
.26503 .26499 L
.26776 .24534 L
.27049 .2462 L
Mistroke
.27322 .24634 L
.27596 .24729 L
.27869 .24621 L
.28142 .24441 L
.28415 .24443 L
.28689 .24459 L
.28962 .2454 L
.29235 .24602 L
.29508 .24686 L
.29781 .24594 L
.30055 .24486 L
.30328 .24535 L
.30601 .27331 L
.30874 .27406 L
.31148 .27473 L
.31421 .27594 L
.31694 .27481 L
.31967 .27299 L
.3224 .27379 L
.32514 .27789 L
.32787 .27861 L
.3306 .2788 L
.33333 .27954 L
.33607 .2785 L
.3388 .27687 L
.34153 .2772 L
.34426 .31187 L
.34699 .31258 L
.34973 .31299 L
.35246 .31429 L
.35519 .31349 L
.35792 .3122 L
.36066 .3125 L
.36339 .30858 L
.36612 .30991 L
.36885 .31064 L
.37158 .31152 L
.37432 .31071 L
.37705 .30936 L
.37978 .31038 L
.38251 .24819 L
.38525 .24866 L
.38798 .24801 L
.39071 .24996 L
.39344 .24864 L
.39617 .24549 L
.39891 .24525 L
.40164 .24679 L
.40437 .24729 L
.4071 .247 L
Mistroke
.40984 .2484 L
.41257 .24738 L
.4153 .24444 L
.41803 .24475 L
.42077 .26481 L
.4235 .26582 L
.42623 .26578 L
.42896 .26743 L
.43169 .26625 L
.43443 .26433 L
.43716 .26507 L
.43989 .23997 L
.44262 .24085 L
.44536 .24036 L
.44809 .24189 L
.45082 .24104 L
.45355 .23879 L
.45628 .2394 L
.45902 .24383 L
.46175 .24439 L
.46448 .24465 L
.46721 .24572 L
.46995 .24495 L
.47268 .24315 L
.47541 .24371 L
.47814 .29691 L
.48087 .29756 L
.48361 .2974 L
.48634 .29929 L
.48907 .29814 L
.4918 .29605 L
.49454 .29618 L
.49727 .29297 L
.5 .29351 L
.50273 .2931 L
.50546 .29491 L
.5082 .29363 L
.51093 .29184 L
.51366 .2924 L
.51639 .30628 L
.51913 .30673 L
.52186 .30674 L
.52459 .30808 L
.52732 .30746 L
.53005 .30583 L
.53279 .30609 L
.53552 .25165 L
.53825 .25246 L
.54098 .25189 L
.54372 .25392 L
Mistroke
.54645 .25272 L
.54918 .25031 L
.55191 .25031 L
.55464 .20581 L
.55738 .20595 L
.56011 .20564 L
.56284 .20753 L
.56557 .20577 L
.56831 .20311 L
.57104 .20298 L
.57377 .08384 L
.5765 .08445 L
.57923 .08404 L
.58197 .08587 L
.5847 .08422 L
.58743 .08023 L
.59016 .07971 L
.5929 .14419 L
.59563 .14471 L
.59836 .1445 L
.60109 .14637 L
.60383 .14457 L
.60656 .14024 L
.60929 .14039 L
.61202 .22032 L
.61475 .22132 L
.61749 .22085 L
.62022 .2228 L
.62295 .22113 L
.62568 .2172 L
.62842 .21746 L
.63115 .26022 L
.63388 .26163 L
.63661 .26124 L
.63934 .26369 L
.64208 .26234 L
.64481 .25883 L
.64754 .25938 L
.65027 .30321 L
.65301 .30424 L
.65574 .30396 L
.65847 .3066 L
.6612 .3046 L
.66393 .30156 L
.66667 .30236 L
.6694 .41114 L
.67213 .41256 L
.67486 .41174 L
.6776 .41473 L
.68033 .41259 L
Mistroke
.68306 .40965 L
.68579 .40997 L
.68852 .32049 L
.69126 .32183 L
.69399 .32133 L
.69672 .32454 L
.69945 .32201 L
.70219 .31823 L
.70492 .31858 L
.70765 .49987 L
.71038 .50134 L
.71311 .4998 L
.71585 .50379 L
.71858 .50094 L
.72131 .49704 L
.72404 .49757 L
.72678 .47136 L
.72951 .47301 L
.73224 .47164 L
.73497 .47584 L
.7377 .47297 L
.74044 .469 L
.74317 .4699 L
.7459 .33838 L
.74863 .33995 L
.75137 .33891 L
.7541 .34276 L
.75683 .34002 L
.75956 .33628 L
.7623 .33714 L
.76503 .44883 L
.76776 .45053 L
.77049 .44937 L
.77322 .45288 L
.77596 .44983 L
.77869 .44575 L
.78142 .44595 L
.78415 .42738 L
.78689 .42907 L
.78962 .4276 L
.79235 .4316 L
.79508 .42854 L
.79781 .42486 L
.80055 .42541 L
.80328 .53306 L
.80601 .53397 L
.80874 .53327 L
.81148 .53646 L
.81421 .53368 L
.81694 .52962 L
Mistroke
.81967 .5299 L
.8224 .3927 L
.82514 .39459 L
.82787 .39275 L
.8306 .39737 L
.83333 .39413 L
.83607 .3905 L
.8388 .39104 L
.84153 .45935 L
.84426 .46077 L
.84699 .45912 L
.84973 .46306 L
.85246 .45959 L
.85519 .45544 L
.85792 .4555 L
.86066 .34054 L
.86339 .34185 L
.86612 .34023 L
.86885 .34429 L
.87158 .34097 L
.87432 .33682 L
.87705 .33684 L
.87978 .33825 L
.88251 .33978 L
.88525 .33842 L
.88798 .34235 L
.89071 .33898 L
.89344 .33477 L
.89617 .33468 L
.89891 .47981 L
.90164 .48103 L
.90437 .4791 L
.9071 .48282 L
.90984 .4796 L
.91257 .47578 L
.9153 .47542 L
.91803 .36277 L
.92077 .36405 L
.9235 .36232 L
.92623 .36615 L
.92896 .36215 L
.93169 .35843 L
.93443 .35806 L
.93716 .31232 L
.93989 .31372 L
.94262 .31174 L
.94536 .31539 L
.94809 .31163 L
.95082 .30732 L
.95355 .30772 L
Mistroke
.95628 .32434 L
.95902 .32591 L
.96175 .32509 L
.96448 .32881 L
.96721 .32548 L
.96995 .32132 L
.97268 .32151 L
.97541 .29601 L
.97814 .29742 L
.98087 .29624 L
.98361 .29927 L
.98634 .29594 L
.98907 .2914 L
.9918 .29149 L
.99454 .33831 L
.99727 .33854 L
Mfstroke
0 .98 .604 r
gsave
.99727 .36501 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24897 m
.00273 .26699 L
.00546 .27509 L
.0082 .2827 L
.01093 .28711 L
.01366 .29194 L
.01639 .29529 L
.01913 .29113 L
.02186 .30938 L
.02459 .31694 L
.02732 .32615 L
.03005 .32902 L
.03279 .33367 L
.03552 .33865 L
.03825 .32098 L
.04098 .33769 L
.04372 .3453 L
.04645 .35289 L
.04918 .35655 L
.05191 .35906 L
.05464 .36315 L
.05738 .32835 L
.06011 .34445 L
.06284 .35171 L
.06557 .35807 L
.06831 .36111 L
.07104 .36425 L
.07377 .36978 L
.0765 .37042 L
.07923 .38469 L
.08197 .39218 L
.0847 .39921 L
.08743 .40192 L
.09016 .40509 L
.0929 .4086 L
.09563 .38628 L
.09836 .39995 L
.10109 .40698 L
.10383 .41309 L
.10656 .41547 L
.10929 .4179 L
.11202 .4213 L
.11475 .39178 L
.11749 .40434 L
.12022 .41127 L
.12295 .41731 L
.12568 .41909 L
.12842 .41979 L
.13115 .42376 L
.13388 .33304 L
Mistroke
.13661 .34924 L
.13934 .35633 L
.14208 .36379 L
.14481 .36646 L
.14754 .3692 L
.15027 .37398 L
.15301 .33196 L
.15574 .34406 L
.15847 .351 L
.1612 .3564 L
.16393 .35802 L
.16667 .3601 L
.1694 .36229 L
.17213 .31094 L
.17486 .32524 L
.1776 .32999 L
.18033 .33656 L
.18306 .34004 L
.18579 .34236 L
.18852 .34614 L
.19126 .25569 L
.19399 .27379 L
.19672 .28042 L
.19945 .28758 L
.20219 .29024 L
.20492 .29293 L
.20765 .29933 L
.21038 .26329 L
.21311 .27758 L
.21585 .28295 L
.21858 .28828 L
.22131 .29157 L
.22404 .29366 L
.22678 .29814 L
.22951 .26085 L
.23224 .27253 L
.23497 .27718 L
.2377 .28129 L
.24044 .28204 L
.24317 .2838 L
.2459 .28716 L
.24863 .26568 L
.25137 .27161 L
.2541 .27505 L
.25683 .27606 L
.25956 .27831 L
.2623 .27864 L
.26503 .28039 L
.26776 .24551 L
.27049 .25633 L
Mistroke
.27322 .26007 L
.27596 .26414 L
.27869 .26625 L
.28142 .2668 L
.28415 .26888 L
.28689 .24476 L
.28962 .25383 L
.29235 .25799 L
.29508 .26094 L
.29781 .26337 L
.30055 .26504 L
.30328 .26713 L
.30601 .27348 L
.30874 .28381 L
.31148 .28997 L
.31421 .29423 L
.31694 .29739 L
.31967 .29813 L
.3224 .30087 L
.32514 .27805 L
.32787 .28742 L
.3306 .29255 L
.33333 .29594 L
.33607 .29922 L
.3388 .29991 L
.34153 .30243 L
.34426 .31204 L
.34699 .32164 L
.34973 .32733 L
.35246 .33173 L
.35519 .33322 L
.35792 .33432 L
.36066 .33569 L
.36339 .30875 L
.36612 .31865 L
.36885 .32437 L
.37158 .32903 L
.37432 .33087 L
.37705 .33228 L
.37978 .33482 L
.38251 .24835 L
.38525 .26602 L
.38798 .26991 L
.39071 .2769 L
.39344 .28221 L
.39617 .28401 L
.39891 .28762 L
.40164 .24696 L
.40437 .26118 L
.4071 .26798 L
Mistroke
.40984 .27401 L
.41257 .27587 L
.4153 .27662 L
.41803 .28005 L
.42077 .26497 L
.4235 .27774 L
.42623 .2847 L
.42896 .29037 L
.43169 .29321 L
.43443 .29436 L
.43716 .29827 L
.43989 .24013 L
.44262 .254 L
.44536 .25898 L
.44809 .26504 L
.45082 .26807 L
.45355 .26858 L
.45628 .27319 L
.45902 .24399 L
.46175 .2552 L
.46448 .2594 L
.46721 .26386 L
.46995 .26752 L
.47268 .26972 L
.47541 .27291 L
.47814 .29708 L
.48087 .3106 L
.48361 .3161 L
.48634 .32259 L
.48907 .3264 L
.4918 .32899 L
.49454 .33143 L
.49727 .29314 L
.5 .30606 L
.50273 .31188 L
.50546 .3172 L
.5082 .32084 L
.51093 .32302 L
.51366 .32634 L
.51639 .30645 L
.51913 .31797 L
.52186 .32266 L
.52459 .32854 L
.52732 .33289 L
.53005 .33462 L
.53279 .33684 L
.53552 .25181 L
.53825 .26793 L
.54098 .2734 L
.54372 .28006 L
Mistroke
.54645 .28479 L
.54918 .2857 L
.55191 .28975 L
.55464 .20597 L
.55738 .22236 L
.56011 .22886 L
.56284 .23583 L
.56557 .24133 L
.56831 .24374 L
.57104 .24786 L
.57377 .084 L
.5765 .10965 L
.57923 .11703 L
.58197 .12715 L
.5847 .13387 L
.58743 .13886 L
.59016 .1447 L
.5929 .14436 L
.59563 .16818 L
.59836 .17492 L
.60109 .18562 L
.60383 .19129 L
.60656 .19693 L
.60929 .20393 L
.61202 .22049 L
.61475 .24474 L
.61749 .25078 L
.62022 .26163 L
.62295 .26813 L
.62568 .27316 L
.62842 .27885 L
.63115 .26039 L
.63388 .28168 L
.63661 .29067 L
.63934 .30013 L
.64208 .30523 L
.64481 .30817 L
.64754 .31358 L
.65027 .30337 L
.65301 .32371 L
.65574 .33223 L
.65847 .34193 L
.6612 .34745 L
.66393 .35139 L
.66667 .35634 L
.6694 .41131 L
.67213 .43444 L
.67486 .44425 L
.6776 .4554 L
.68033 .46047 L
Mistroke
.68306 .46472 L
.68579 .47039 L
.68852 .32065 L
.69126 .34472 L
.69399 .35552 L
.69672 .36737 L
.69945 .37157 L
.70219 .37533 L
.70492 .38137 L
.70765 .50004 L
.71038 .52824 L
.71311 .5404 L
.71585 .55409 L
.71858 .56025 L
.72131 .5651 L
.72404 .57177 L
.72678 .47153 L
.72951 .50006 L
.73224 .51258 L
.73497 .52613 L
.7377 .53249 L
.74044 .53764 L
.74317 .54428 L
.7459 .33854 L
.74863 .3664 L
.75137 .37819 L
.7541 .39203 L
.75683 .39861 L
.75956 .40343 L
.7623 .41095 L
.76503 .44899 L
.76776 .47755 L
.77049 .48965 L
.77322 .50293 L
.77596 .50904 L
.77869 .51395 L
.78142 .52019 L
.78415 .42754 L
.78689 .45556 L
.78962 .46801 L
.79235 .48166 L
.79508 .48793 L
.79781 .49226 L
.80055 .49852 L
.80328 .53323 L
.80601 .56088 L
.80874 .57394 L
.81148 .58618 L
.81421 .59255 L
.81694 .59692 L
Mistroke
.81967 .60332 L
.8224 .39287 L
.82514 .4224 L
.82787 .43531 L
.8306 .4504 L
.83333 .45532 L
.83607 .45962 L
.8388 .46728 L
.84153 .45952 L
.84426 .48875 L
.84699 .50131 L
.84973 .51496 L
.85246 .52022 L
.85519 .52442 L
.85792 .53147 L
.86066 .34071 L
.86339 .37024 L
.86612 .38381 L
.86885 .39727 L
.87158 .40349 L
.87432 .40808 L
.87705 .41478 L
.87978 .33841 L
.88251 .36707 L
.88525 .37955 L
.88798 .39227 L
.89071 .39773 L
.89344 .40212 L
.89617 .40896 L
.89891 .47998 L
.90164 .50918 L
.90437 .52023 L
.9071 .53373 L
.90984 .54079 L
.91257 .54499 L
.9153 .55157 L
.91803 .36294 L
.92077 .39223 L
.9235 .40447 L
.92623 .41847 L
.92896 .42483 L
.93169 .42885 L
.93443 .43558 L
.93716 .31249 L
.93989 .34269 L
.94262 .35469 L
.94536 .36868 L
.94809 .37557 L
.95082 .37904 L
.95355 .38716 L
Mistroke
.95628 .3245 L
.95902 .35353 L
.96175 .36504 L
.96448 .37743 L
.96721 .38402 L
.96995 .38839 L
.97268 .39575 L
.97541 .29617 L
.97814 .32505 L
.98087 .33754 L
.98361 .34941 L
.98634 .35574 L
.98907 .35916 L
.9918 .36709 L
.99454 .33847 L
.99727 .36501 L
Mfstroke
gsave
.99727 .31208 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .24864 m
.00273 .23072 L
.00546 .22017 L
.0082 .21693 L
.01093 .20999 L
.01366 .19964 L
.01639 .1967 L
.01913 .29079 L
.02186 .27528 L
.02459 .26635 L
.02732 .26217 L
.03005 .25555 L
.03279 .24588 L
.03552 .24228 L
.03825 .32064 L
.04098 .30561 L
.04372 .29678 L
.04645 .29385 L
.04918 .2872 L
.05191 .27873 L
.05464 .27583 L
.05738 .32802 L
.06011 .31376 L
.06284 .30612 L
.06557 .30314 L
.06831 .29526 L
.07104 .28697 L
.07377 .28321 L
.0765 .37009 L
.07923 .35796 L
.08197 .34929 L
.0847 .34786 L
.08743 .34131 L
.09016 .33454 L
.0929 .33226 L
.09563 .38595 L
.09836 .37473 L
.10109 .36687 L
.10383 .36429 L
.10656 .35814 L
.10929 .35142 L
.11202 .34972 L
.11475 .39145 L
.11749 .38142 L
.12022 .37385 L
.12295 .37199 L
.12568 .36709 L
.12842 .36215 L
.13115 .35967 L
.13388 .33271 L
Mistroke
.13661 .31982 L
.13934 .31075 L
.14208 .30847 L
.14481 .30095 L
.14754 .2943 L
.15027 .29116 L
.15301 .33163 L
.15574 .32185 L
.15847 .31449 L
.1612 .31306 L
.16393 .30809 L
.16667 .30322 L
.1694 .30204 L
.17213 .31061 L
.17486 .29862 L
.1776 .29258 L
.18033 .2911 L
.18306 .28475 L
.18579 .27941 L
.18852 .27738 L
.19126 .25536 L
.19399 .24021 L
.19672 .23344 L
.19945 .22981 L
.20219 .22286 L
.20492 .21457 L
.20765 .20942 L
.21038 .26295 L
.21311 .25078 L
.21585 .24498 L
.21858 .24228 L
.22131 .2341 L
.22404 .22819 L
.22678 .22377 L
.22951 .26052 L
.23224 .25177 L
.23497 .24752 L
.2377 .24603 L
.24044 .24189 L
.24317 .23611 L
.2459 .23425 L
.24863 .26537 L
.25137 .25988 L
.2541 .25764 L
.25683 .25705 L
.25956 .25347 L
.2623 .25102 L
.26503 .24959 L
.26776 .24518 L
.27049 .23607 L
Mistroke
.27322 .23262 L
.27596 .23045 L
.27869 .22618 L
.28142 .22202 L
.28415 .21998 L
.28689 .24443 L
.28962 .23697 L
.29235 .23406 L
.29508 .23278 L
.29781 .2285 L
.30055 .22469 L
.30328 .22356 L
.30601 .27315 L
.30874 .26431 L
.31148 .25949 L
.31421 .25765 L
.31694 .25222 L
.31967 .24785 L
.3224 .24671 L
.32514 .27772 L
.32787 .2698 L
.3306 .26506 L
.33333 .26313 L
.33607 .25779 L
.3388 .25384 L
.34153 .25198 L
.34426 .31171 L
.34699 .30351 L
.34973 .29865 L
.35246 .29684 L
.35519 .29377 L
.35792 .29009 L
.36066 .28931 L
.36339 .30842 L
.36612 .30117 L
.36885 .29692 L
.37158 .29402 L
.37432 .29054 L
.37705 .28644 L
.37978 .28594 L
.38251 .24802 L
.38525 .2313 L
.38798 .22612 L
.39071 .22303 L
.39344 .21507 L
.39617 .20697 L
.39891 .20287 L
.40164 .24662 L
.40437 .23339 L
.4071 .22603 L
Mistroke
.40984 .22279 L
.41257 .21889 L
.4153 .21226 L
.41803 .20945 L
.42077 .26464 L
.4235 .2539 L
.42623 .24686 L
.42896 .2445 L
.43169 .23929 L
.43443 .2343 L
.43716 .23187 L
.43989 .2398 L
.44262 .2277 L
.44536 .22175 L
.44809 .21874 L
.45082 .21401 L
.45355 .209 L
.45628 .2056 L
.45902 .24366 L
.46175 .23359 L
.46448 .22991 L
.46721 .22758 L
.46995 .22238 L
.47268 .21658 L
.47541 .21451 L
.47814 .29675 L
.48087 .28452 L
.48361 .2787 L
.48634 .27599 L
.48907 .26987 L
.4918 .26311 L
.49454 .26093 L
.49727 .2928 L
.5 .28096 L
.50273 .27432 L
.50546 .27261 L
.5082 .26642 L
.51093 .26066 L
.51366 .25846 L
.51639 .30611 L
.51913 .2955 L
.52186 .29082 L
.52459 .28762 L
.52732 .28203 L
.53005 .27704 L
.53279 .27534 L
.53552 .25148 L
.53825 .23699 L
.54098 .23037 L
.54372 .22777 L
Mistroke
.54645 .22065 L
.54918 .21492 L
.55191 .21087 L
.55464 .20564 L
.55738 .18954 L
.56011 .18242 L
.56284 .17923 L
.56557 .17021 L
.56831 .16249 L
.57104 .1581 L
.57377 .08367 L
.5765 .05925 L
.57923 .05105 L
.58197 .04459 L
.5847 .03457 L
.58743 .02161 L
.59016 .01472 L
.5929 .14403 L
.59563 .12124 L
.59836 .11408 L
.60109 .10712 L
.60383 .09785 L
.60656 .08355 L
.60929 .07684 L
.61202 .22016 L
.61475 .1979 L
.61749 .19092 L
.62022 .18398 L
.62295 .17414 L
.62568 .16123 L
.62842 .15607 L
.63115 .26006 L
.63388 .24159 L
.63661 .2318 L
.63934 .22726 L
.64208 .21945 L
.64481 .20949 L
.64754 .20519 L
.65027 .30304 L
.65301 .28476 L
.65574 .27568 L
.65847 .27128 L
.6612 .26175 L
.66393 .25173 L
.66667 .24838 L
.6694 .41098 L
.67213 .39069 L
.67486 .37923 L
.6776 .37406 L
.68033 .36471 L
Mistroke
.68306 .35458 L
.68579 .34955 L
.68852 .32032 L
.69126 .29894 L
.69399 .28714 L
.69672 .28172 L
.69945 .27245 L
.70219 .26113 L
.70492 .25579 L
.70765 .49971 L
.71038 .47445 L
.71311 .4592 L
.71585 .45349 L
.71858 .44164 L
.72131 .42898 L
.72404 .42338 L
.72678 .4712 L
.72951 .44597 L
.73224 .43069 L
.73497 .42554 L
.7377 .41346 L
.74044 .40036 L
.74317 .39551 L
.7459 .33821 L
.74863 .31351 L
.75137 .29963 L
.7541 .29348 L
.75683 .28143 L
.75956 .26913 L
.7623 .26332 L
.76503 .44866 L
.76776 .42351 L
.77049 .40909 L
.77322 .40282 L
.77596 .39061 L
.77869 .37755 L
.78142 .37172 L
.78415 .42721 L
.78689 .40258 L
.78962 .38719 L
.79235 .38154 L
.79508 .36915 L
.79781 .35746 L
.80055 .35229 L
.80328 .5329 L
.80601 .50705 L
.80874 .4926 L
.81148 .48673 L
.81421 .47481 L
.81694 .46232 L
Mistroke
.81967 .45649 L
.8224 .39254 L
.82514 .36679 L
.82787 .35019 L
.8306 .34434 L
.83333 .33294 L
.83607 .32139 L
.8388 .31481 L
.84153 .45919 L
.84426 .43279 L
.84699 .41694 L
.84973 .41117 L
.85246 .39896 L
.85519 .38647 L
.85792 .37953 L
.86066 .34038 L
.86339 .31347 L
.86612 .29665 L
.86885 .29132 L
.87158 .27846 L
.87432 .26556 L
.87705 .25891 L
.87978 .33808 L
.88251 .31249 L
.88525 .29729 L
.88798 .29243 L
.89071 .28024 L
.89344 .26742 L
.89617 .2604 L
.89891 .47965 L
.90164 .45287 L
.90437 .43798 L
.9071 .4319 L
.90984 .4184 L
.91257 .40658 L
.9153 .39928 L
.91803 .3626 L
.92077 .33588 L
.9235 .32016 L
.92623 .31382 L
.92896 .29948 L
.93169 .28801 L
.93443 .28054 L
.93716 .31216 L
.93989 .28474 L
.94262 .26879 L
.94536 .2621 L
.94809 .24768 L
.95082 .23559 L
.95355 .22827 L
Mistroke
.95628 .32417 L
.95902 .29829 L
.96175 .28514 L
.96448 .28019 L
.96721 .26694 L
.96995 .25425 L
.97268 .24727 L
.97541 .29584 L
.97814 .2698 L
.98087 .25493 L
.98361 .24913 L
.98634 .23613 L
.98907 .22363 L
.9918 .21588 L
.99454 .33814 L
.99727 .31208 L
Mfstroke
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 0.0423349 1.29019 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04233 -6 -4.5 ]
[-0.0125 .04233 0 4.5 ]
[-0.0125 .17135 -18 -4.5 ]
[-0.0125 .17135 0 4.5 ]
[-0.0125 .30037 -18 -4.5 ]
[-0.0125 .30037 0 4.5 ]
[-0.0125 .42939 -18 -4.5 ]
[-0.0125 .42939 0 4.5 ]
[-0.0125 .55841 -18 -4.5 ]
[-0.0125 .55841 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .3903 -5 -6 ]
[.97619 .3903 5 6 ]
[.97619 .42264 -5 -6 ]
[.97619 .42264 5 6 ]
[.97619 .53802 -5 -6 ]
[.97619 .53802 5 6 ]
[.97619 .30727 -5 -6 ]
[.97619 .30727 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04233 m
.00625 .04233 L
s
[(0)] -0.0125 .04233 1 0 Mshowa
0 .17135 m
.00625 .17135 L
s
[(0.1)] -0.0125 .17135 1 0 Mshowa
0 .30037 m
.00625 .30037 L
s
[(0.2)] -0.0125 .30037 1 0 Mshowa
0 .42939 m
.00625 .42939 L
s
[(0.3)] -0.0125 .42939 1 0 Mshowa
0 .55841 m
.00625 .55841 L
s
[(0.4)] -0.0125 .55841 1 0 Mshowa
.125 Mabswid
0 .06814 m
.00375 .06814 L
s
0 .09394 m
.00375 .09394 L
s
0 .11975 m
.00375 .11975 L
s
0 .14555 m
.00375 .14555 L
s
0 .19716 m
.00375 .19716 L
s
0 .22296 m
.00375 .22296 L
s
0 .24877 m
.00375 .24877 L
s
0 .27457 m
.00375 .27457 L
s
0 .32618 m
.00375 .32618 L
s
0 .35198 m
.00375 .35198 L
s
0 .37778 m
.00375 .37778 L
s
0 .40359 m
.00375 .40359 L
s
0 .4552 m
.00375 .4552 L
s
0 .481 m
.00375 .481 L
s
0 .5068 m
.00375 .5068 L
s
0 .53261 m
.00375 .53261 L
s
0 .01653 m
.00375 .01653 L
s
0 .58421 m
.00375 .58421 L
s
0 .61002 m
.00375 .61002 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04233 m
1 .04233 L
s
.99375 .17135 m
1 .17135 L
s
.99375 .30037 m
1 .30037 L
s
.99375 .42939 m
1 .42939 L
s
.99375 .55841 m
1 .55841 L
s
.125 Mabswid
.99625 .06814 m
1 .06814 L
s
.99625 .09394 m
1 .09394 L
s
.99625 .11975 m
1 .11975 L
s
.99625 .14555 m
1 .14555 L
s
.99625 .19716 m
1 .19716 L
s
.99625 .22296 m
1 .22296 L
s
.99625 .24877 m
1 .24877 L
s
.99625 .27457 m
1 .27457 L
s
.99625 .32618 m
1 .32618 L
s
.99625 .35198 m
1 .35198 L
s
.99625 .37778 m
1 .37778 L
s
.99625 .40359 m
1 .40359 L
s
.99625 .4552 m
1 .4552 L
s
.99625 .481 m
1 .481 L
s
.99625 .5068 m
1 .5068 L
s
.99625 .53261 m
1 .53261 L
s
.99625 .01653 m
1 .01653 L
s
.99625 .58421 m
1 .58421 L
s
.99625 .61002 m
1 .61002 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .3903 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.005 w
.02381 .30037 m
.02642 .30545 L
.02903 .30036 L
.03164 .31634 L
.03425 .33068 L
.03686 .32118 L
.03947 .30534 L
.04207 .30711 L
.04468 .32216 L
.04729 .34499 L
.0499 .34204 L
.05251 .34243 L
.05512 .37883 L
.05773 .40383 L
.06034 .40656 L
.06295 .40373 L
.06556 .38572 L
.06817 .38081 L
.07078 .39301 L
.07339 .37189 L
.07599 .37775 L
.0786 .37487 L
.08121 .35799 L
.08382 .36025 L
.08643 .34932 L
.08904 .36012 L
.09165 .35433 L
.09426 .33797 L
.09687 .32671 L
.09948 .29862 L
.10209 .29809 L
.1047 .27831 L
.10731 .28403 L
.10992 .2968 L
.11252 .28555 L
.11513 .28476 L
.11774 .27817 L
.12035 .27639 L
.12296 .28601 L
.12557 .29029 L
.12818 .29193 L
.13079 .31357 L
.1334 .30845 L
.13601 .31744 L
.13862 .31631 L
.14123 .30125 L
.14384 .31943 L
.14644 .34911 L
.14905 .34372 L
.15166 .33669 L
Mistroke
.15427 .32203 L
.15688 .3336 L
.15949 .32518 L
.1621 .3324 L
.16471 .3183 L
.16732 .3114 L
.16993 .33123 L
.17254 .3278 L
.17515 .31783 L
.17776 .33482 L
.18037 .30306 L
.18297 .28752 L
.18558 .28343 L
.18819 .2618 L
.1908 .24763 L
.19341 .2683 L
.19602 .2572 L
.19863 .27807 L
.20124 .26651 L
.20385 .27981 L
.20646 .27524 L
.20907 .27074 L
.21168 .28146 L
.21429 .26716 L
.21689 .28598 L
.2195 .29146 L
.22211 .278 L
.22472 .30202 L
.22733 .27282 L
.22994 .27108 L
.23255 .28179 L
.23516 .28577 L
.23777 .30216 L
.24038 .28945 L
.24299 .27446 L
.2456 .26781 L
.24821 .27181 L
.25082 .26938 L
.25342 .26481 L
.25603 .27569 L
.25864 .27097 L
.26125 .2877 L
.26386 .29019 L
.26647 .28984 L
.26908 .31191 L
.27169 .30461 L
.2743 .30466 L
.27691 .31153 L
.27952 .30679 L
.28213 .32449 L
Mistroke
.28474 .32448 L
.28735 .31281 L
.28995 .3015 L
.29256 .28646 L
.29517 .28237 L
.29778 .27542 L
.30039 .27708 L
.303 .27532 L
.30561 .26691 L
.30822 .27414 L
.31083 .27587 L
.31344 .28741 L
.31605 .27998 L
.31866 .30082 L
.32127 .31732 L
.32387 .3018 L
.32648 .29768 L
.32909 .29308 L
.3317 .30911 L
.33431 .29018 L
.33692 .30727 L
.33953 .30814 L
.34214 .31208 L
.34475 .30543 L
.34736 .29189 L
.34997 .28277 L
.35258 .2848 L
.35519 .31148 L
.3578 .29994 L
.3604 .31885 L
.36301 .32151 L
.36562 .31133 L
.36823 .29157 L
.37084 .31424 L
.37345 .3272 L
.37606 .32563 L
.37867 .32271 L
.38128 .32033 L
.38389 .30947 L
.3865 .29598 L
.38911 .29986 L
.39172 .31985 L
.39432 .33996 L
.39693 .33363 L
.39954 .33075 L
.40215 .33279 L
.40476 .34571 L
.40737 .32442 L
.40998 .3192 L
.41259 .31237 L
Mistroke
.4152 .31767 L
.41781 .32784 L
.42042 .30735 L
.42303 .30312 L
.42564 .32428 L
.42825 .30883 L
.43085 .32459 L
.43346 .33656 L
.43607 .35899 L
.43868 .34414 L
.44129 .36197 L
.4439 .38971 L
.44651 .40229 L
.44912 .40325 L
.45173 .40148 L
.45434 .39173 L
.45695 .39629 L
.45956 .42047 L
.46217 .43084 L
.46477 .4286 L
.46738 .44979 L
.46999 .43167 L
.4726 .43566 L
.47521 .43113 L
.47782 .43158 L
.48043 .45988 L
.48304 .46071 L
.48565 .46699 L
.48826 .4704 L
.49087 .46109 L
.49348 .48541 L
.49609 .45506 L
.4987 .41788 L
.5013 .42696 L
.50391 .42222 L
.50652 .4139 L
.50913 .4022 L
.51174 .4112 L
.51435 .43066 L
.51696 .42178 L
.51957 .43478 L
.52218 .40207 L
.52479 .40926 L
.5274 .44146 L
.53001 .44218 L
.53262 .45623 L
.53523 .46112 L
.53783 .47884 L
.54044 .48878 L
.54305 .49042 L
Mistroke
.54566 .46722 L
.54827 .46617 L
.55088 .48158 L
.55349 .49464 L
.5561 .51709 L
.55871 .52345 L
.56132 .52478 L
.56393 .5304 L
.56654 .50976 L
.56915 .50487 L
.57175 .47255 L
.57436 .48396 L
.57697 .50467 L
.57958 .53385 L
.58219 .54009 L
.5848 .52922 L
.58741 .53691 L
.59002 .53282 L
.59263 .54217 L
.59524 .55359 L
.59785 .54379 L
.60046 .53027 L
.60307 .52694 L
.60568 .50147 L
.60828 .51769 L
.61089 .51454 L
.6135 .53409 L
.61611 .51034 L
.61872 .49066 L
.62133 .47865 L
.62394 .48121 L
.62655 .49201 L
.62916 .484 L
.63177 .49262 L
.63438 .4967 L
.63699 .51224 L
.6396 .50467 L
.6422 .49415 L
.64481 .50747 L
.64742 .51643 L
.65003 .49046 L
.65264 .50731 L
.65525 .49606 L
.65786 .48532 L
.66047 .49624 L
.66308 .5119 L
.66569 .50393 L
.6683 .52526 L
.67091 .53487 L
.67352 .54158 L
Mistroke
.67613 .53655 L
.67873 .50998 L
.68134 .52324 L
.68395 .50652 L
.68656 .50344 L
.68917 .50994 L
.69178 .48927 L
.69439 .48868 L
.697 .51277 L
.69961 .52841 L
.70222 .50273 L
.70483 .49287 L
.70744 .48487 L
.71005 .48792 L
.71265 .48146 L
.71526 .48881 L
.71787 .47103 L
.72048 .46435 L
.72309 .45623 L
.7257 .4419 L
.72831 .45498 L
.73092 .46541 L
.73353 .48073 L
.73614 .48657 L
.73875 .4705 L
.74136 .46137 L
.74397 .45785 L
.74658 .47036 L
.74918 .48012 L
.75179 .48597 L
.7544 .50648 L
.75701 .515 L
.75962 .52825 L
.76223 .51573 L
.76484 .51061 L
.76745 .48974 L
.77006 .47834 L
.77267 .48679 L
.77528 .51486 L
.77789 .54181 L
.7805 .55827 L
.78311 .53283 L
.78571 .52489 L
.78832 .54969 L
.79093 .54854 L
.79354 .54223 L
.79615 .53879 L
.79876 .53567 L
.80137 .53641 L
.80398 .56172 L
Mistroke
.80659 .56277 L
.8092 .56013 L
.81181 .54688 L
.81442 .57182 L
.81703 .55344 L
.81963 .55378 L
.82224 .56554 L
.82485 .55968 L
.82746 .56804 L
.83007 .56312 L
.83268 .56364 L
.83529 .56091 L
.8379 .5582 L
.84051 .57286 L
.84312 .56291 L
.84573 .56611 L
.84834 .57937 L
.85095 .57955 L
.85356 .57684 L
.85616 .57004 L
.85877 .54766 L
.86138 .56113 L
.86399 .55305 L
.8666 .53308 L
.86921 .5221 L
.87182 .51465 L
.87443 .50135 L
.87704 .4907 L
.87965 .4846 L
.88226 .48042 L
.88487 .47227 L
.88748 .49264 L
.89008 .49013 L
.89269 .50633 L
.8953 .51525 L
.89791 .49276 L
.90052 .49656 L
.90313 .48857 L
.90574 .48239 L
.90835 .49335 L
.91096 .45649 L
.91357 .45724 L
.91618 .44634 L
.91879 .45548 L
.9214 .46894 L
.92401 .46509 L
.92661 .47138 L
.92922 .45304 L
.93183 .44273 L
.93444 .4615 L
Mistroke
.93705 .46575 L
.93966 .44821 L
.94227 .45008 L
.94488 .4581 L
.94749 .4531 L
.9501 .45849 L
.95271 .46012 L
.95532 .43857 L
.95793 .43924 L
.96053 .42476 L
.96314 .43506 L
.96575 .41134 L
.96836 .40792 L
.97097 .39529 L
.97358 .38118 L
.97619 .3903 L
Mfstroke
0 0 1 r
gsave
.97619 .42264 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .2959 m
.02642 .29712 L
.02903 .29693 L
.03164 .29598 L
.03425 .29595 L
.03686 .29628 L
.03947 .2965 L
.04207 .3114 L
.04468 .31257 L
.04729 .31235 L
.0499 .31135 L
.05251 .31128 L
.05512 .31157 L
.05773 .31175 L
.06034 .29692 L
.06295 .29813 L
.06556 .29795 L
.06817 .29699 L
.07078 .29696 L
.07339 .29729 L
.07599 .29751 L
.0786 .28757 L
.08121 .28881 L
.08382 .28865 L
.08643 .28772 L
.08904 .28771 L
.09165 .28806 L
.09426 .28831 L
.09687 .26422 L
.09948 .26552 L
.10209 .26542 L
.1047 .26456 L
.10731 .26461 L
.10992 .26503 L
.11252 .26533 L
.11513 .24871 L
.11774 .25006 L
.12035 .25 L
.12296 .24918 L
.12557 .24928 L
.12818 .24973 L
.13079 .25008 L
.1334 .22292 L
.13601 .22433 L
.13862 .22435 L
.14123 .2236 L
.14384 .22376 L
.14644 .22429 L
.14905 .22471 L
.15166 .27457 L
Mistroke
.15427 .27585 L
.15688 .27572 L
.15949 .27483 L
.1621 .27485 L
.16471 .27524 L
.16732 .27552 L
.16993 .20935 L
.17254 .21081 L
.17515 .21086 L
.17776 .21014 L
.18037 .21035 L
.18297 .21091 L
.18558 .21137 L
.18819 .22777 L
.1908 .22917 L
.19341 .22918 L
.19602 .22841 L
.19863 .22856 L
.20124 .22908 L
.20385 .22948 L
.20646 .2867 L
.20907 .28794 L
.21168 .28778 L
.21429 .28686 L
.21689 .28685 L
.2195 .28721 L
.22211 .28745 L
.22472 .23769 L
.22733 .23906 L
.22994 .23904 L
.23255 .23825 L
.23516 .23838 L
.23777 .23886 L
.24038 .23924 L
.24299 .18956 L
.2456 .19107 L
.24821 .19117 L
.25082 .19051 L
.25342 .19077 L
.25603 .19139 L
.25864 .1919 L
.26125 .10356 L
.26386 .1053 L
.26647 .10564 L
.26908 .10522 L
.27169 .10571 L
.2743 .10656 L
.27691 .1073 L
.27952 .17972 L
.28213 .18125 L
Mistroke
.28474 .18139 L
.28735 .18075 L
.28995 .18104 L
.29256 .18168 L
.29517 .18222 L
.29778 .15076 L
.30039 .15238 L
.303 .15259 L
.30561 .15203 L
.30822 .1524 L
.31083 .15312 L
.31344 .15373 L
.31605 .18493 L
.31866 .18645 L
.32127 .18657 L
.32387 .18592 L
.32648 .18619 L
.32909 .18682 L
.3317 .18734 L
.33431 .17251 L
.33692 .17406 L
.33953 .17422 L
.34214 .1736 L
.34475 .1739 L
.34736 .17457 L
.34997 .17512 L
.35258 .17426 L
.35519 .1758 L
.3578 .17595 L
.3604 .17533 L
.36301 .17563 L
.36562 .17629 L
.36823 .17684 L
.37084 .16008 L
.37345 .16167 L
.37606 .16186 L
.37867 .16128 L
.38128 .16162 L
.38389 .16231 L
.3865 .1629 L
.38911 .26668 L
.39172 .26797 L
.39432 .26787 L
.39693 .267 L
.39954 .26705 L
.40215 .26745 L
.40476 .26775 L
.40737 .2463 L
.40998 .24765 L
.41259 .2476 L
Mistroke
.4152 .24679 L
.41781 .24689 L
.42042 .24735 L
.42303 .24771 L
.42564 .23273 L
.42825 .23412 L
.43085 .2341 L
.43346 .23333 L
.43607 .23347 L
.43868 .23397 L
.44129 .23436 L
.4439 .22466 L
.44651 .22607 L
.44912 .22609 L
.45173 .22533 L
.45434 .22549 L
.45695 .22601 L
.45956 .22643 L
.46217 .20151 L
.46477 .20298 L
.46738 .20306 L
.46999 .20236 L
.4726 .20259 L
.47521 .20317 L
.47782 .20365 L
.48043 .24493 L
.48304 .24628 L
.48565 .24624 L
.48826 .24543 L
.49087 .24553 L
.49348 .246 L
.49609 .24636 L
.4987 .23455 L
.5013 .23593 L
.50391 .23592 L
.50652 .23513 L
.50913 .23527 L
.51174 .23576 L
.51435 .23615 L
.51696 .21298 L
.51957 .21442 L
.52218 .21447 L
.52479 .21374 L
.5274 .21393 L
.53001 .21449 L
.53262 .21493 L
.53523 .26758 L
.53783 .26888 L
.54044 .26877 L
.54305 .2679 L
Mistroke
.54566 .26794 L
.54827 .26835 L
.55088 .26865 L
.55349 .2753 L
.5561 .27657 L
.55871 .27644 L
.56132 .27555 L
.56393 .27557 L
.56654 .27596 L
.56915 .27623 L
.57175 .39866 L
.57436 .39959 L
.57697 .39913 L
.57958 .3979 L
.58219 .39759 L
.5848 .39764 L
.58741 .39758 L
.59002 .37885 L
.59263 .37984 L
.59524 .37943 L
.59785 .37825 L
.60046 .378 L
.60307 .3781 L
.60568 .3781 L
.60828 .36713 L
.61089 .36816 L
.6135 .36778 L
.61611 .36663 L
.61872 .36641 L
.62133 .36654 L
.62394 .36657 L
.62655 .35299 L
.62916 .35405 L
.63177 .35371 L
.63438 .3526 L
.63699 .35242 L
.6396 .35259 L
.6422 .35266 L
.64481 .34417 L
.64742 .34525 L
.65003 .34494 L
.65264 .34385 L
.65525 .34369 L
.65786 .34389 L
.66047 .34398 L
.66308 .38754 L
.66569 .38851 L
.6683 .38807 L
.67091 .38687 L
.67352 .38659 L
Mistroke
.67613 .38667 L
.67873 .38665 L
.68134 .40166 L
.68395 .40259 L
.68656 .40212 L
.68917 .40088 L
.69178 .40056 L
.69439 .4006 L
.697 .40054 L
.69961 .47957 L
.70222 .48028 L
.70483 .4796 L
.70744 .47815 L
.71005 .47762 L
.71265 .47745 L
.71526 .47717 L
.71787 .4787 L
.72048 .47942 L
.72309 .47874 L
.7257 .47729 L
.72831 .47676 L
.73092 .47659 L
.73353 .47632 L
.73614 .46371 L
.73875 .46446 L
.74136 .46382 L
.74397 .46241 L
.74658 .46193 L
.74918 .4618 L
.75179 .46157 L
.7544 .479 L
.75701 .47972 L
.75962 .47903 L
.76223 .47758 L
.76484 .47705 L
.76745 .47688 L
.77006 .47661 L
.77267 .47357 L
.77528 .4743 L
.77789 .47363 L
.7805 .47219 L
.78311 .47168 L
.78571 .47153 L
.78832 .47127 L
.79093 .47721 L
.79354 .47793 L
.79615 .47725 L
.79876 .4758 L
.80137 .47528 L
.80398 .47512 L
Mistroke
.80659 .47485 L
.8092 .49539 L
.81181 .49606 L
.81442 .49533 L
.81703 .49383 L
.81963 .49326 L
.82224 .49305 L
.82485 .49273 L
.82746 .49199 L
.83007 .49267 L
.83268 .49195 L
.83529 .49047 L
.8379 .4899 L
.84051 .4897 L
.84312 .48939 L
.84573 .50004 L
.84834 .5007 L
.85095 .49996 L
.85356 .49845 L
.85616 .49787 L
.85877 .49764 L
.86138 .49731 L
.86399 .48247 L
.8666 .48318 L
.86921 .48248 L
.87182 .48102 L
.87443 .48049 L
.87704 .48031 L
.87965 .48003 L
.88226 .48578 L
.88487 .48647 L
.88748 .48577 L
.89008 .4843 L
.89269 .48375 L
.8953 .48357 L
.89791 .48328 L
.90052 .48802 L
.90313 .48871 L
.90574 .488 L
.90835 .48653 L
.91096 .48598 L
.91357 .48578 L
.91618 .48549 L
.91879 .49765 L
.9214 .49832 L
.92401 .49758 L
.92661 .49608 L
.92922 .4955 L
.93183 .49528 L
.93444 .49496 L
Mistroke
.93705 .47131 L
.93966 .47205 L
.94227 .47139 L
.94488 .46996 L
.94749 .46945 L
.9501 .4693 L
.95271 .46905 L
.95532 .46643 L
.95793 .46718 L
.96053 .46653 L
.96314 .46511 L
.96575 .46462 L
.96836 .46449 L
.97097 .46425 L
.97358 .42345 L
.97619 .42264 L
Mfstroke
0 .98 .604 r
gsave
.97619 .53802 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42198 m
.02642 .42429 L
.02903 .42657 L
.03164 .42487 L
.03425 .4226 L
.03686 .42259 L
.03947 .4255 L
.04207 .3911 L
.04468 .39271 L
.04729 .3941 L
.0499 .39189 L
.05251 .3915 L
.05512 .39234 L
.05773 .39491 L
.06034 .36925 L
.06295 .37118 L
.06556 .37443 L
.06817 .374 L
.07078 .37441 L
.07339 .37515 L
.07599 .37656 L
.0786 .36488 L
.08121 .36776 L
.08382 .36912 L
.08643 .36917 L
.08904 .36992 L
.09165 .37023 L
.09426 .37152 L
.09687 .33593 L
.09948 .33848 L
.10209 .33892 L
.1047 .33801 L
.10731 .33837 L
.10992 .33948 L
.11252 .34085 L
.11513 .32433 L
.11774 .32842 L
.12035 .32977 L
.12296 .32953 L
.12557 .3302 L
.12818 .33235 L
.13079 .33385 L
.1334 .30207 L
.13601 .3072 L
.13862 .30866 L
.14123 .30903 L
.14384 .30969 L
.14644 .31167 L
.14905 .31193 L
.15166 .36334 L
Mistroke
.15427 .36788 L
.15688 .3673 L
.15949 .36725 L
.1621 .36903 L
.16471 .37104 L
.16732 .37089 L
.16993 .31927 L
.17254 .32407 L
.17515 .32481 L
.17776 .32455 L
.18037 .32503 L
.18297 .3264 L
.18558 .32668 L
.18819 .32229 L
.1908 .32619 L
.19341 .32756 L
.19602 .32808 L
.19863 .32819 L
.20124 .32875 L
.20385 .32976 L
.20646 .38116 L
.20907 .3857 L
.21168 .38727 L
.21429 .3884 L
.21689 .38868 L
.2195 .3899 L
.22211 .39197 L
.22472 .3368 L
.22733 .34246 L
.22994 .34215 L
.23255 .34254 L
.23516 .34306 L
.23777 .34451 L
.24038 .34572 L
.24299 .28451 L
.2456 .29005 L
.24821 .29114 L
.25082 .29121 L
.25342 .29107 L
.25603 .29213 L
.25864 .29308 L
.26125 .19013 L
.26386 .19444 L
.26647 .19566 L
.26908 .19572 L
.27169 .19589 L
.2743 .19795 L
.27691 .19798 L
.27952 .26763 L
.28213 .27336 L
Mistroke
.28474 .27319 L
.28735 .27385 L
.28995 .27481 L
.29256 .2755 L
.29517 .27782 L
.29778 .23856 L
.30039 .24258 L
.303 .24344 L
.30561 .24394 L
.30822 .24407 L
.31083 .24592 L
.31344 .24854 L
.31605 .2713 L
.31866 .27544 L
.32127 .27564 L
.32387 .27523 L
.32648 .27494 L
.32909 .27616 L
.3317 .2785 L
.33431 .25081 L
.33692 .25461 L
.33953 .25575 L
.34214 .25542 L
.34475 .2556 L
.34736 .25767 L
.34997 .25915 L
.35258 .26558 L
.35519 .26958 L
.3578 .27106 L
.3604 .27051 L
.36301 .27063 L
.36562 .27221 L
.36823 .27328 L
.37084 .2533 L
.37345 .25769 L
.37606 .25923 L
.37867 .25807 L
.38128 .25867 L
.38389 .2593 L
.3865 .26093 L
.38911 .36564 L
.39172 .36944 L
.39432 .36998 L
.39693 .36993 L
.39954 .36989 L
.40215 .36864 L
.40476 .36884 L
.40737 .33882 L
.40998 .34408 L
.41259 .34353 L
Mistroke
.4152 .34476 L
.41781 .34595 L
.42042 .34637 L
.42303 .34732 L
.42564 .30925 L
.42825 .31363 L
.43085 .31486 L
.43346 .31519 L
.43607 .31417 L
.43868 .31481 L
.44129 .3166 L
.4439 .30473 L
.44651 .30789 L
.44912 .30873 L
.45173 .30931 L
.45434 .31047 L
.45695 .31156 L
.45956 .31541 L
.46217 .28284 L
.46477 .28623 L
.46738 .2882 L
.46999 .28777 L
.4726 .28851 L
.47521 .28856 L
.47782 .29161 L
.48043 .30931 L
.48304 .31394 L
.48565 .3156 L
.48826 .31505 L
.49087 .31545 L
.49348 .31618 L
.49609 .31766 L
.4987 .3072 L
.5013 .31249 L
.50391 .31304 L
.50652 .3127 L
.50913 .31338 L
.51174 .31386 L
.51435 .31541 L
.51696 .28882 L
.51957 .29286 L
.52218 .2929 L
.52479 .29311 L
.5274 .29358 L
.53001 .29579 L
.53262 .29758 L
.53523 .35774 L
.53783 .3628 L
.54044 .36459 L
.54305 .36482 L
Mistroke
.54566 .36492 L
.54827 .36577 L
.55088 .36767 L
.55349 .38632 L
.5561 .39081 L
.55871 .39191 L
.56132 .39251 L
.56393 .39264 L
.56654 .39281 L
.56915 .39424 L
.57175 .56762 L
.57436 .57005 L
.57697 .5694 L
.57958 .56875 L
.58219 .56688 L
.5848 .56686 L
.58741 .5666 L
.59002 .51914 L
.59263 .52123 L
.59524 .52049 L
.59785 .52011 L
.60046 .5188 L
.60307 .51836 L
.60568 .51813 L
.60828 .47942 L
.61089 .48221 L
.6135 .48269 L
.61611 .48235 L
.61872 .48101 L
.62133 .4796 L
.62394 .48074 L
.62655 .43973 L
.62916 .44338 L
.63177 .44538 L
.63438 .44499 L
.63699 .44423 L
.6396 .44477 L
.6422 .44668 L
.64481 .42134 L
.64742 .42421 L
.65003 .42691 L
.65264 .42555 L
.65525 .42523 L
.65786 .42629 L
.66047 .42811 L
.66308 .45339 L
.66569 .45593 L
.6683 .45792 L
.67091 .4573 L
.67352 .45611 L
Mistroke
.67613 .45748 L
.67873 .45994 L
.68134 .48155 L
.68395 .48345 L
.68656 .48462 L
.68917 .4838 L
.69178 .48297 L
.69439 .48249 L
.697 .48498 L
.69961 .50377 L
.70222 .51054 L
.70483 .51331 L
.70744 .51328 L
.71005 .51396 L
.71265 .51507 L
.71526 .5179 L
.71787 .52371 L
.72048 .52639 L
.72309 .52762 L
.7257 .52737 L
.72831 .52756 L
.73092 .52778 L
.73353 .52961 L
.73614 .51452 L
.73875 .51783 L
.74136 .51992 L
.74397 .51988 L
.74658 .52013 L
.74918 .51902 L
.75179 .52219 L
.7544 .54016 L
.75701 .54324 L
.75962 .54428 L
.76223 .54216 L
.76484 .54124 L
.76745 .5419 L
.77006 .54269 L
.77267 .53934 L
.77528 .5429 L
.77789 .54396 L
.7805 .541 L
.78311 .53989 L
.78571 .5412 L
.78832 .54334 L
.79093 .54925 L
.79354 .55123 L
.79615 .55292 L
.79876 .5522 L
.80137 .55083 L
.80398 .5511 L
Mistroke
.80659 .55292 L
.8092 .56645 L
.81181 .57094 L
.81442 .57015 L
.81703 .56896 L
.81963 .56951 L
.82224 .56962 L
.82485 .57103 L
.82746 .56703 L
.83007 .57057 L
.83268 .57141 L
.83529 .5701 L
.8379 .57014 L
.84051 .5685 L
.84312 .57074 L
.84573 .57345 L
.84834 .57727 L
.85095 .57661 L
.85356 .57625 L
.85616 .57638 L
.85877 .57706 L
.86138 .57813 L
.86399 .56402 L
.8666 .56798 L
.86921 .56878 L
.87182 .56924 L
.87443 .56799 L
.87704 .56786 L
.87965 .5691 L
.88226 .57009 L
.88487 .57399 L
.88748 .57525 L
.89008 .57415 L
.89269 .57321 L
.8953 .57365 L
.89791 .57379 L
.90052 .58634 L
.90313 .59038 L
.90574 .59112 L
.90835 .58996 L
.91096 .59018 L
.91357 .58976 L
.91618 .58966 L
.91879 .59821 L
.9214 .60168 L
.92401 .60332 L
.92661 .60157 L
.92922 .60082 L
.93183 .60101 L
.93444 .60131 L
Mistroke
.93705 .57931 L
.93966 .58288 L
.94227 .58305 L
.94488 .58286 L
.94749 .58272 L
.9501 .58358 L
.95271 .58512 L
.95532 .57676 L
.95793 .58022 L
.96053 .58182 L
.96314 .58202 L
.96575 .58114 L
.96836 .58072 L
.97097 .58243 L
.97358 .53546 L
.97619 .53802 L
Mfstroke
gsave
.97619 .30727 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16982 m
.02642 .16994 L
.02903 .1673 L
.03164 .16709 L
.03425 .1693 L
.03686 .16996 L
.03947 .1675 L
.04207 .2317 L
.04468 .23243 L
.04729 .23059 L
.0499 .23082 L
.05251 .23106 L
.05512 .23079 L
.05773 .22859 L
.06034 .22459 L
.06295 .22509 L
.06556 .22146 L
.06817 .21999 L
.07078 .21952 L
.07339 .21942 L
.07599 .21845 L
.0786 .21025 L
.08121 .20986 L
.08382 .20817 L
.08643 .20626 L
.08904 .2055 L
.09165 .20589 L
.09426 .20509 L
.09687 .1925 L
.09948 .19256 L
.10209 .19193 L
.1047 .19111 L
.10731 .19086 L
.10992 .19057 L
.11252 .18982 L
.11513 .17309 L
.11774 .17169 L
.12035 .17024 L
.12296 .16883 L
.12557 .16835 L
.12818 .16711 L
.13079 .16631 L
.1334 .14377 L
.13601 .14147 L
.13862 .14003 L
.14123 .13816 L
.14384 .13784 L
.14644 .13691 L
.14905 .13748 L
.15166 .18581 L
Mistroke
.15427 .18381 L
.15688 .18414 L
.15949 .1824 L
.1621 .18068 L
.16471 .17944 L
.16732 .18015 L
.16993 .09943 L
.17254 .09755 L
.17515 .0969 L
.17776 .09574 L
.18037 .09566 L
.18297 .09542 L
.18558 .09605 L
.18819 .13325 L
.1908 .13215 L
.19341 .13079 L
.19602 .12874 L
.19863 .12893 L
.20124 .12941 L
.20385 .12921 L
.20646 .19224 L
.20907 .19018 L
.21168 .1883 L
.21429 .18531 L
.21689 .18502 L
.2195 .18451 L
.22211 .18294 L
.22472 .13858 L
.22733 .13567 L
.22994 .13593 L
.23255 .13396 L
.23516 .13369 L
.23777 .13321 L
.24038 .13276 L
.24299 .09461 L
.2456 .09209 L
.24821 .0912 L
.25082 .08981 L
.25342 .09047 L
.25603 .09064 L
.25864 .09071 L
.26125 .01699 L
.26386 .01616 L
.26647 .01563 L
.26908 .01472 L
.27169 .01553 L
.2743 .01516 L
.27691 .01661 L
.27952 .09181 L
.28213 .08915 L
Mistroke
.28474 .08958 L
.28735 .08766 L
.28995 .08726 L
.29256 .08786 L
.29517 .08661 L
.29778 .06296 L
.30039 .06217 L
.303 .06174 L
.30561 .06013 L
.30822 .06072 L
.31083 .06031 L
.31344 .05892 L
.31605 .09856 L
.31866 .09746 L
.32127 .09749 L
.32387 .09661 L
.32648 .09744 L
.32909 .09747 L
.3317 .09618 L
.33431 .0942 L
.33692 .09351 L
.33953 .09268 L
.34214 .09178 L
.34475 .09221 L
.34736 .09146 L
.34997 .09109 L
.35258 .08293 L
.35519 .08203 L
.3578 .08085 L
.3604 .08016 L
.36301 .08064 L
.36562 .08038 L
.36823 .08041 L
.37084 .06687 L
.37345 .06565 L
.37606 .06449 L
.37867 .06449 L
.38128 .06457 L
.38389 .06533 L
.3865 .06487 L
.38911 .16771 L
.39172 .16651 L
.39432 .16576 L
.39693 .16407 L
.39954 .1642 L
.40215 .16627 L
.40476 .16667 L
.40737 .15378 L
.40998 .15122 L
.41259 .15167 L
Mistroke
.4152 .14881 L
.41781 .14783 L
.42042 .14834 L
.42303 .1481 L
.42564 .1562 L
.42825 .1546 L
.43085 .15335 L
.43346 .15146 L
.43607 .15277 L
.43868 .15312 L
.44129 .15212 L
.4439 .14459 L
.44651 .14426 L
.44912 .14344 L
.45173 .14134 L
.45434 .14051 L
.45695 .14047 L
.45956 .13745 L
.46217 .12018 L
.46477 .11973 L
.46738 .11791 L
.46999 .11695 L
.4726 .11666 L
.47521 .11779 L
.47782 .11569 L
.48043 .18054 L
.48304 .17863 L
.48565 .17688 L
.48826 .1758 L
.49087 .17561 L
.49348 .17582 L
.49609 .17506 L
.4987 .1619 L
.5013 .15937 L
.50391 .15879 L
.50652 .15756 L
.50913 .15716 L
.51174 .15766 L
.51435 .15689 L
.51696 .13714 L
.51957 .13599 L
.52218 .13603 L
.52479 .13437 L
.5274 .13429 L
.53001 .13318 L
.53262 .13229 L
.53523 .17742 L
.53783 .17496 L
.54044 .17295 L
.54305 .17097 L
Mistroke
.54566 .17096 L
.54827 .17093 L
.55088 .16962 L
.55349 .16428 L
.5561 .16233 L
.55871 .16097 L
.56132 .15858 L
.56393 .1585 L
.56654 .1591 L
.56915 .15823 L
.57175 .22969 L
.57436 .22913 L
.57697 .22885 L
.57958 .22704 L
.58219 .22829 L
.5848 .22841 L
.58741 .22856 L
.59002 .23856 L
.59263 .23845 L
.59524 .23838 L
.59785 .2364 L
.60046 .2372 L
.60307 .23784 L
.60568 .23806 L
.60828 .25485 L
.61089 .2541 L
.6135 .25287 L
.61611 .25091 L
.61872 .25181 L
.62133 .25349 L
.62394 .25241 L
.62655 .26625 L
.62916 .26472 L
.63177 .26204 L
.63438 .26021 L
.63699 .2606 L
.6396 .2604 L
.6422 .25864 L
.64481 .26699 L
.64742 .26629 L
.65003 .26296 L
.65264 .26215 L
.65525 .26215 L
.65786 .26149 L
.66047 .25985 L
.66308 .32169 L
.66569 .32108 L
.6683 .31822 L
.67091 .31644 L
.67352 .31707 L
Mistroke
.67613 .31587 L
.67873 .31335 L
.68134 .32178 L
.68395 .32173 L
.68656 .31961 L
.68917 .31796 L
.69178 .31815 L
.69439 .31872 L
.697 .31609 L
.69961 .45537 L
.70222 .45003 L
.70483 .44589 L
.70744 .44301 L
.71005 .44127 L
.71265 .43982 L
.71526 .43645 L
.71787 .43369 L
.72048 .43245 L
.72309 .42985 L
.7257 .42721 L
.72831 .42596 L
.73092 .4254 L
.73353 .42303 L
.73614 .4129 L
.73875 .4111 L
.74136 .40773 L
.74397 .40494 L
.74658 .40373 L
.74918 .40458 L
.75179 .40095 L
.7544 .41784 L
.75701 .41619 L
.75962 .41378 L
.76223 .413 L
.76484 .41287 L
.76745 .41187 L
.77006 .41054 L
.77267 .4078 L
.77528 .4057 L
.77789 .4033 L
.7805 .40339 L
.78311 .40346 L
.78571 .40185 L
.78832 .3992 L
.79093 .40516 L
.79354 .40462 L
.79615 .40158 L
.79876 .3994 L
.80137 .39973 L
.80398 .39914 L
Mistroke
.80659 .39678 L
.8092 .42432 L
.81181 .42118 L
.81442 .42051 L
.81703 .41871 L
.81963 .41702 L
.82224 .41647 L
.82485 .41444 L
.82746 .41696 L
.83007 .41477 L
.83268 .41249 L
.83529 .41083 L
.8379 .40966 L
.84051 .4109 L
.84312 .40804 L
.84573 .42663 L
.84834 .42413 L
.85095 .42331 L
.85356 .42066 L
.85616 .41935 L
.85877 .41822 L
.86138 .41649 L
.86399 .40092 L
.8666 .39837 L
.86921 .39618 L
.87182 .39281 L
.87443 .39298 L
.87704 .39276 L
.87965 .39095 L
.88226 .40147 L
.88487 .39896 L
.88748 .39629 L
.89008 .39446 L
.89269 .39429 L
.8953 .39349 L
.89791 .39276 L
.90052 .3897 L
.90313 .38704 L
.90574 .38489 L
.90835 .3831 L
.91096 .38177 L
.91357 .38181 L
.91618 .38131 L
.91879 .3971 L
.9214 .39496 L
.92401 .39185 L
.92661 .3906 L
.92922 .39019 L
.93183 .38955 L
.93444 .38861 L
Mistroke
.93705 .36332 L
.93966 .36122 L
.94227 .35972 L
.94488 .35705 L
.94749 .35618 L
.9501 .35503 L
.95271 .35298 L
.95532 .3561 L
.95793 .35414 L
.96053 .35124 L
.96314 .3482 L
.96575 .3481 L
.96836 .34825 L
.97097 .34607 L
.97358 .31144 L
.97619 .30727 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{507.625, 156.875},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007k0000W2000`400?l00000o`00003ooooooool
ooooo`00ooooooolooooo`00ooooooolooooo`00ooooooolooooo`00ooooooolooooo`00oooooolF
ooooo`;o00004oooool3o`0000Cooooo0_l0000=ooooo`?o00001?ooool2o`0000Cooooo0_l0000:
ooooo`?o00000oooool3o`0000Cooooo0_l00009ooooo`Go00000oooool2o`0000Cooooo0_l00009
ooooo`Go00000_ooool3o`0000Cooooo0_l0000:ooooo`?o00001?ooool2o`0000Cooooo0_l0000:
ooooo`?o00000oooool3o`0000Cooooo0_l0000_ooooo`00oooooolEooooo`04o`000?oooooooooo
o`00017ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000gooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00[ooooo00Go0000ooooooooooooooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool01oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00002Oooool01_l0003oooooooooool0003oooooo`0000?ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`06ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Sooooo00Oo0000
ooooooooooooooooo`000?oooooo000000?ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`0/ooooo`00E_ooool3o`0000Cooooo0_l0000>ooooo`?o00001?ooool2o`0000Cooooo
0_l0000:ooooo`?o00000oooool3o`0000Cooooo0_l0000:ooooo`Go00000oooool2o`0000Cooooo
0_l00009ooooo`Go00000_ooool3o`0000Cooooo0_l0000:ooooo`?o00001?ooool2o`0000Cooooo
0_l0000;ooooo`?o00000oooool3o`0000Cooooo0_l0000Iooooo`04o`000?ooooooooooo`0001Go
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000:ooooo`03o`000?oo
oooooooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000:oooo
o`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0:
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`0/ooooo`00EOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00003_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00002_ooool01Ol0003ooooooooooooooooo000000?ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00009ooooo`06o`000?ooooooooooo`000?oooooo
00000oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Kooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
2Oooool01ol0003ooooooooooooooooo0000ooooool000000oooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo01Kooooo00Co0000oooooooooooo00005Oooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool01Oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02?ooool2o`0000?o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000:ooooo`;o00001_ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo02cooooo001Iooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`05ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00002_ooool00ol0003ooooooooo
o`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05_ooool0
1?l0003oooooooooool0000Aooooo`Co00000oooool01?l0003oooooooooool0000=ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000:oooo
o`04o`000?ooooooooooooooo`Co00000oooool01?l0003oooooooooool00008ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00Sooooo00Ko0000ooooooooooooooooo`000?ooool4o`0000?ooooo00Co0000oooooooooooo0000
3?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooo`000003o`0000?ooooo00Co0000oooooooooooo0000;_ooool0
05Wooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000:ooooo`03o`00
0?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0:ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo00Sooooo0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00002oooool2o`0000Kooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Foooo
o`04o`000?ooooooooooo`00017ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
000<ooooo`;o00001?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Wo
oooo0_l00003ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool00008ooooo`07o`000?ooooooooooooooool0003oooooo`000006ooooo`04o`000?oooooooooo
o`0000Sooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00002?ooool01ol0003ooooooooooooooooo0000ooooool000001_ooool0
1?l0003oooooooooool0000^ooooo`00EOooool4o`0000?ooooo00Co0000oooooooooooo00003_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00002_ooool01?l0003oooooooooooooool4o`0000?ooooo00Co0000oooooooooooo00002Oooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00008ooooo`06o`000?ooooooooooooooool0003ooooo1?l00003ooooo`04o`000?oooooo
ooooo`0000cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooool000000ol00003ooooo`04o`000?ooooooooooo`00
01Wooooo0_l0000Booooo`Go00000oooool2o`0000kooooo00?o0000ooooooooool00oooool2o`00
00Cooooo0_l0000;ooooo`04o`000?ooooooooooooooo`Go00000oooool2o`0000[ooooo0ol00004
ooooo`;o00001?ooool2o`0000[ooooo0ol00002ooooo`Go00000oooool2o`0000[ooooo0ol00004
ooooo`;o00001?ooool2o`0000[ooooo0ol00002ooooo`Go00000oooool2o`0002oooooo001Eoooo
o`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool2o`0000Cooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00009ooooo`;o00000oooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Wooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00002?ooool01ol0003ooooooooo
oooooooo0000ooooool000001_ooool01?l0003oooooooooool00008ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Wooooo
00Oo0000ooooooooooooooooo`000?oooooo000000Kooooo00Co0000oooooooooooo0000ooooool0
05Gooooo1Ol00003ooooo`;o00003oooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`00
00_ooooo00Co0000oooooooooooooooo1Ol00003ooooo`;o00002oooool3o`0000Cooooo0_l00004
ooooo`;o00002_ooool3o`0000;ooooo1Ol00003ooooo`;o00002_ooool3o`0000Cooooo0_l00004
ooooo`;o00002oooool3o`0000;ooooo1Ol00003ooooo`;o0000ooooool1ooooo`00oooooooloooo
o`00oooooolBoooool7o0000:Oooool00?oooooo4_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooool00000:Oooool004;ooooo^ol0000Dooooo`03o`000?oo
oooooooo0;gooooo00?o0000ooooooooool09oooool004;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00005?oo
ool2o`00033ooooo1?l0nYZ:ooooo`03o`000?oooooooooo02Oooooo0012ooooo`;o0000]oooool2
o`0001Cooooo00?o0000ooooooooool0;oooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oo
oooooooo02Oooooo0012ooooo`03o`000?oooooooooo06_ooooo00?o0?ZJooooooooool0BOooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo02oooooo00Co0?ZJoooooooooooo0?ZJR_oo
ool00ol0003oooooooooo`0Wooooo`00@_ooool00ol0003oooooooooo`1Zooooo`;o0?ZJBoooool0
0ol0003oooooooooo`0<ooooo`;o00001?ooool00ol0003oooooooooo`0_ooooo`04o`3jV_oooooo
ooooo`3jVX[ooooo00?o0000ooooooooool09oooool004;ooooo0_l0001[ooooo`;o0?ZJB_ooool2
o`0000gooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0_ooooo`04o`3jV_oo
ooooooooo`3jVX[ooooo00?o0000ooooooooool09oooool004;ooooo00?o0000ooooooooool0J_oo
ool2o`3jVT_ooooo00?o0000ooooooooool02oooool01?l0003oooooooooool00003ooooo`;o0000
<?ooool01?l0nY[oooooooooool0nYZ9ooooo`;o0000:Oooool004;ooooo00?o0000ooooooooool0
J_ooool2o`3jVT_ooooo00?o0000ooooooooool02oooool01?l0003oooooooooool00003ooooo`03
o`000?oooooooooo02oooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0Woooo
o`00@_ooool00ol0003oooooooooo`1Yooooo`03o`3jV_oooooo0?ZJ04_ooooo00?o0000oooooooo
ool02oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo02oooooo00Co0?ZJoooo
oooooooo0?ZJR_ooool00ol0003oooooooooo`0Wooooo`00@_ooool2o`0006[ooooo00?o0?ZJoooo
ool0nYX0B_ooool2o`0000gooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0_
ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool00ol0nY[oooooooooo`21ooooo`03o`000?oo
oooooooo02Oooooo0012ooooo`03o`000?oooooooooo06Wooooo00?o0?ZJooooool0nYX0Boooool0
0ol0003oooooooooo`0<ooooo`;o00001?ooool00ol0003oooooooooo`0_ooooo`05o`3jV_oooooo
ooooooooool0nYX00_ooool4o`3jVPcooooo0_l0nYYeooooo`03o`000?oooooooooo02Oooooo0012
ooooo`03o`000?oooooooooo06Sooooo00Co0?ZJoooooooooooo0?ZJBoooool00ol0003ooooooooo
o`0Booooo`;o0000<?ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00Co0?ZJoooooooooooo
0?ZJ2oooool01?l0nY[oooooo`3jV_l0nYYdooooo`03o`000?oooooooooo02Oooooo000`ooooo`?o
00000oooool00ol0003oooooooooo`02ooooo`?o00001?ooool2o`0006Sooooo00Go0000o`3jV_oo
ooooooooo`3jVP1:ooooo`;o00005?ooool00ol0003oooooooooo`0_ooooo`05o`3jV_oooooooooo
ooooool0nYX00_ooool01?l0nY[oooooooooool0nYX;ooooo`04o`3jV_ooooooooooo`3jVWCooooo
00?o0000ooooooooool09oooool0037ooooo00?o0000ooooooooool01_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool0Ioooool01Ol0003o0?ZJoooooooooooo0?ZJ04_o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0_ooooo`05o`3jV_oooooooooooooo
ool0nYX00_ooool01?l0nY[oooooooooool0nYX8ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJ
ooooooooool0L_ooool00ol0003oooooooooo`0Wooooo`00;_ooool5o`0000_ooooo00Go0000oooo
ooooooooooooo`00001Yooooo`05o`000?l0nY[oooooooooool0nYX00_ooool00ol0nY[ooooooooo
o`16ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0;oooool01Ol0nY[ooooooooo
oooooooo0?ZJ00;ooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`Co0?ZJ0oooool00ol0nY[o
ooooooooo`1booooo`03o`000?oooooooooo02Oooooo000^ooooo`04o`000?ooooooooooo`0000co
oooo00Co0000oooooooooooooooo0_l0001Xooooo`05o`000?l0nY[oooooo`00ool0nYX00_ooool0
0ol0nY[oooooooooo`15ooooo`;o00005?ooool00ol0003oooooooooo`0]ooooo`?o0?ZJ0oooool4
o`3jVP?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo07;ooooo00?o0000ooooooooool09oooool002oooooo00?o0000ooooool000002?ooool4o`00
00Cooooo00?o0000ooooooooool0Ioooool01Ol0003o0?ZJo`00ool00?oo0?ZJ00;ooooo00?o0?ZJ
ooooooooool0A_ooool00ol0003oooooooooo`0Booooo`;o00008?ooool2o`3jVP_ooooo1?l0nYX3
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01?l0nYX7ooooo`03o`3jV_oooooo
oooo07;ooooo00?o0000ooooooooool09oooool0033ooooo0_l00008ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0Ioooool01Ol0003o0?ZJoooooooooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool0A_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01kooooo0_l0nYX0
0ooooooo0?ZJooooo`09ooooo`03o`3jV_oooooooooo00_ooooo1?l0nYX:ooooo`03o`3jV_oooooo
oooo07;ooooo00?o0000ooooooooool09oooool0037ooooo00?o0000ooooooooool01_ooool5o`00
00?ooooo0_l0001Xooooo`06o`000?l0nY[oooooooooool0nY[ooooo0_l0nYY7ooooo`;o00005?oo
ool00ol0003oooooooooo`0Nooooo`04o`3jV_ooooooooooo`3jVP[ooooo00?o0?ZJooooooooool0
0ol00?lFooooo`03o`3jV_oooooooooo07;ooooo00?o0000ooooooooool09oooool004;ooooo00?o
0000ooooooooool0Ioooool01_l0003o0?ZJoooooooooooo0?ZJooooo`;o0?ZJB?ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01kooooo00Co0?ZJoooooooooooo0?ZJ2_ooool01?l0
nY[oooooooooool00?l2ooooo`03o`00oooooooooooo01?ooooo00?o0?ZJooooooooool0L_ooool0
0ol0003oooooooooo`0Wooooo`00@_ooool00ol0003oooooooooo`1Wooooo`06o`000?l0nY[ooooo
ooooool0nY[ooooo0_l0nYY8ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool07_oo
ool01?l0nY[oooooooooool0nYX:ooooo`04o`3jV_ooooooooooo`00o`;ooooo00?o003ooooooooo
ool04oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo067ooooo00?o0000oooooooo
ool09oooool004;ooooo0_l0001Xooooo`04o`000?l0nY[oooooo`0000;o0?ZJ00?oooooo`3jV_oo
ool0A_ooool2o`0001Cooooo0_l0000Oooooo`04o`3jV_ooooooooooo`3jVPWooooo00Go0?ZJoooo
ooooooooooooo`00o`02ooooo`03o`00oooooooooooo01?ooooo00?o0?ZJooooooooool02oooool4
o`3jVV?ooooo00?o0000ooooooooool09oooool004;ooooo00?o0000ooooooooool0Ioooool01?l0
003o0?ZJo`3jV_l00002o`3jVP03ooooool0nY[ooooo04Oooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Nooooo`04o`3jV_ooooooooooo`3jVPWooooo00Go0?ZJoooooooooooooooo
o`00o`02ooooo`03o`00oooooooooooo01?ooooo00?o0?ZJooooooooool02oooool01?l0nY[ooooo
ooooool0nYYSooooo`03o`000?oooooooooo02Oooooo0012ooooo`03o`000?oooooooooo06Oooooo
0ol0nYX01Ooooooo0?ZJo`3jV_oooooo0?ZJ04Sooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Nooooo`03o`3jV_oooooooooo00Co0?ZJ1_ooool01Ol0nY[ooooooooooooooooo003o
00;ooooo00?o003oooooooooool04oooool00ol0nY[oooooooooo`0;ooooo`04o`3jV_oooooooooo
o`3jVV?ooooo00?o0000ooooooooool09oooool004;ooooo0_l0001Xooooo`?o0?ZJ00Goooooo`3j
V_l0nY[oooooo`3jVP17ooooo`;o00005?ooool00ol0003oooooooooo`0Iooooo`03o`3jV_oooooo
oooo00;ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[oooooooooo`02ooooo`?o0?ZJ0ooo
ool01?l00?ooooooooooool00?lEooooo`03o`3jV_oooooooooo00_ooooo00Co0?ZJoooooooooooo
0?ZJ1oooool4o`3jVUSooooo00?o0000ooooooooool09oooool004;ooooo00?o0000ooooooooool0
Ioooool2o`3jVP06ooooool0nY[o0?ZJo`3jV_oooooo0?ZJB?ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01Oooooo1?l0nYX3ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJoooo
ooooooooooooo`3jVP06ooooo`04o`00ooooooooooooo`00oaGooooo00?o0?ZJooooooooool02Ooo
ool3o`3jVP;ooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooool0nYYHooooo`03o`00
0?oooooooooo02Oooooo0012ooooo`03o`000?oooooooooo06Kooooo00Co0000o`3jV_l0nY[ooooo
0_l0nYX2ooooo`03o`3jV_oooooooooo04Kooooo00?o0000ooooooooool04_ooool2o`0001Sooooo
00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[oooooooooo`04ooooo`05o`3jV_oooooooooooooo
ool0nYX01_ooool01?l00?ooooooooooool00?lEooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooool0
nYYHooooo`03o`000?oooooooooo02Oooooo000Zooooo`?o00000oooool00ol0003oooooooooo`02
ooooo`?o00000oooool3o`0000Cooooo0_l0001Wooooo`03o`000?l0nY[o0?ZJ00;ooooo00Co0?ZJ
o`00ool00?oo0?ZJAoooool2o`0001Cooooo00?o0000ooooooooool05oooool01?l0nY[ooooooooo
ool0nYX2ooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`05
o`00ooooooooooooooooool00?l00_ooool3o`00o`oooooo00Co0?ZJoooooooooooooooo1?l0nYX0
0ooooooo0?ZJo`3jVP07ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3j
VP1Hooooo`03o`000?oooooooooo02Oooooo000[ooooo`03o`000?oooooooooo00Kooooo00Oo0000
ooooooooooooooooo`000?oooooo000000?ooooo00Go0000ooooooooooooooooo`00001Xooooo`03
o`000?l0nY[o0?ZJ00;ooooo00Go0?ZJooooool0003o003oo`3jVP17ooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool05oooool01?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooo
oooo00Cooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`05o`00ooooooooooooooooool00?l0
0_ooool01?l00?ooooooooooool00?l>ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool2o`3j
VP03ooooool0nY[ooooo00Kooooo00?o0?ZJooooooooool00_ooool2o`3jVP?ooooo00?o0?ZJoooo
ooooool01?ooool00ol0nY[oooooooooo`1?ooooo`03o`000?oooooooooo02Oooooo000Xooooo`Go
00002oooool00ol0003oooooooooo`03ooooo`05o`000?ooooooooooooooool00000J?ooool00ol0
003o0?ZJo`3jVP02ooooo`05o`3jV_oooooo0000o`00ool0nYX00_ooool00ol0nY[oooooooooo`12
ooooo`03o`000?oooooooooo00;o00001?ooool00ol0003oooooooooo`02ooooo`?o00001?ooool0
0ol0003oooooooooo`0Fooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[ooooooooo
o`04ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool01Ol00?oooooooooooooooooo003o00;o
oooo00Co003ooooooooooooo003o2oooool3o`00o`05o`3jV_ooooooooooooooool0nYX03Oooool0
0ol0nY[oooooooooo`02o`3jVPGooooo00Co0?ZJoooooooooooooooo1?l0nYYAooooo`03o`000?oo
oooooooo02Oooooo000Xooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool00ooo
ool01?l0003oooooooooooooool2o`0006?ooooo00Go0000ooooooooooooooooo`000002o`3jVP?o
oooo00Go0?ZJo`000?l00?oo0?ZJooooo`02o`3jVT?ooooo0_l000001Ooooooo0000oooooooooooo
000000Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`3jV_oooooo
0?ZJ00oooooo0_l0nYX3ooooo`04o`3jV_ooooooooooo`3jVPOooooo00Co0?ZJoooooooooooo0?ZJ
1_ooool01Ol00?oooooooooooooooooo003o00;ooooo00Co003ooooooooooooo003o2oooool00ol0
0?ooooooooooo`04o`3jVPkooooo00Co0?ZJoooooooooooo0?ZJ1_ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00;ooooo00?o0?ZJooooooooool0Coooool00ol0003oooooooooo`0Wooooo`00:Oooool0
0ol0003oooooo`000008ooooo`Co00000_ooool4o`0000Cooooo00?o0000ooooooooool0H_ooool0
1Ol0003ooooooooooooooooo000000;o0?ZJ0oooool01Ol0nY[oooooo`00ool0nY[ooooo00;o0?ZJ
A?ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
0oooool2o`0000?ooooo00Co0?ZJooooool0nY[o0?ZJ3Oooool3o`3jVPCooooo00Co0?ZJoooooooo
oooo0?ZJ1oooool01?l0nY[oooooooooool0nYX6ooooo`05o`00ooooooooooooooooool00?l00_oo
ool01?l00?ooooooooooool00?l3ooooo`03o`00oooooooo003o00Cooooo00Go003ooooooooooooo
ooooo`00o`0Aooooo`04o`3jV_ooooooooooo`3jVPKooooo1?l0nYX3ooooo`03o`3jV_oooooooooo
04kooooo0_l0000Yooooo`00:_ooool2o`0000Sooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo06;ooooo00Co0000oooooooooooooooo0_l0nYX4oooo
o`05o`3jV_oooooo003oo`3jV_ooool00_l0nYY4ooooo`03o`000?oooooo000000;ooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00?o0?ZJ
ooooooooool02oooool00ol0nY[oooooooooo`04ooooo`04o`3jV_ooooooooooo`3jVPOooooo00Co
0?ZJoooooooooooo0?ZJ1_ooool01Ol00?oooooooooooooooooo003o00;ooooo00Go003ooooooooo
ooooooooo`00o`02ooooo`So003o0oooool00ol00?ooooooooooo`0?ooooo`Co0?ZJ1_ooool2o`3j
VPGooooo00?o0?ZJooooooooool0Coooool00ol0003oooooooooo`0Wooooo`00:oooool00ol0003o
ooooooooo`06ooooo`Go000000?oooooo`000?l000000ol00003ooooo`;o0000Hoooool01?l0003o
ooooooooooooool2o`3jVPCooooo00Go0?ZJooooool00?oo0?ZJooooo`02o`3jVT?ooooo0_l00000
1Ooooooo0000oooooooooooo000000Wooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`05ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool01?ooool4o`3jVPOooooo00Co
0?ZJoooooooooooo0?ZJ1_ooool01?l00?ooooooooooooooool4o`00o`?ooooo00Co003ooooooooo
oooo003o2_ooool00ol00?ooooooooooo`0?ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJoooo
ooooool0Coooool00ol0003oooooooooo`0Wooooo`00@_ooool00ol0003oooooooooo`1Rooooo`06
o`000?oooooo0000o`3jV_l0003o0?ZJ1Oooool01_l0nY[o0000o`3jV_l0nY[oooooo`3jVTCooooo
00?o0000ooooool000000_ooool00ol0003oooooooooo`06ooooo`;o00001Oooool00ol0003ooooo
ooooo`05ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`08ooooo`?o0?ZJ1oooool00ol00?ooooooooooo`08ooooo`Co003o2_ooool00ol00?oooooo
ooooo`0Pooooo`03o`3jV_oooooooooo04oooooo00?o0000ooooooooool09oooool004;ooooo00?o
0000ooooooooool0H_ooool01_l0003oooooo`000?l0nY[o0000o`3jVPGooooo00Ko0?ZJo`000?l0
nY[o0?ZJooooool0nYY4ooooo`03o`000?oooooooooo00;o00002_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool02?ooool4o`3jVQ7ooooo00?o0?ZJ
ooooooooool01?ooool3o`00o`;o0?ZJ5oooool00ol00?ooooooooooo`0Pooooo`03o`3jV_oooooo
oooo04oooooo00?o0000ooooooooool09oooool004;ooooo0_l0001Rooooo`;o000000Goooooo`00
0?l0nY[o0000o`3jVP05ooooo`06o`3jV_oooooo0?ZJo`3jV_oooooo0?ZJ@oooool2o`0001Cooooo
0_l00006ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06Oooool00ol00?oooooo
ooooo`04o`3jVQGooooo00?o003oooooooooool08?ooool00ol0nY[oooooooooo`1?ooooo`03o`00
0?oooooooooo02Oooooo0012ooooo`04o`000?ooooooooooo`3jVV3ooooo00Oo0000ooooool0003o
0?ZJooooool0003o0?ZJ00Kooooo0_l0nYX2ooooo`03o`3jV_oooooooooo04;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooo
ooooool06_ooool01?l00?ooooooooooool0nYX2ooooo`03o`3jV_oooooooooo01?ooooo00?o003o
ooooooooool02oooool4o`00oa7ooooo00?o0?ZJooooooooool0Coooool00ol0003oooooooooo`0W
ooooo`00@_ooool01?l0003oooooooooool0nYXbooooo`03o`000?oooooooooo017ooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`0<ooooo`04o`000?oooooo0000o`3jVP;o003o00?o
0?ZJooooooooool01?ooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJ@Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool4o`3jVPkooooo
0_l00?l<ooooo`04o`00ooooooooooooo`3jVP;ooooo00?o0?ZJooooooooool04oooool00ol00?oo
ooooooooo`0;ooooo`04o`00ooooooooooooo`00oa7ooooo00?o0?ZJooooooooool0Coooool00ol0
003oooooooooo`0Wooooo`00@_ooool2o`0000;o0?ZJ8oooool00ol0nY[oooooooooo`0<ooooo`03
o`000?oooooooooo017ooooo00?o0?ZJooooooooool00_l0nYX5ooooo`;o0?ZJ3_ooool01ol0003o
ooooo`000?l0nY[o0000o`00ool0nYX01_ooool2o`3jVP03o`000?oooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool0?_ooool2o`0001Cooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo00oooooo1?l00?l:ooooo`04o`00ooooooooooooo`3jVP;ooooo00?o
0?ZJooooooooool04oooool00ol00?ooooooooooo`0;ooooo`04o`00ooooooooooooo`00o`Oooooo
1?l00?l6ooooo`03o`3jV_oooooooooo04oooooo00?o0000ooooooooool09oooool004;ooooo00Co
0000ooooool0nY[o0?ZJ8_ooool2o`3jVPkooooo00?o0000ooooooooool04?ooool2o`3jVP;ooooo
0_l0nYX5ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`09ooooo`03o`000?oooooo0?ZJ00;o0?ZJ
00?oooooo`3jV_ooool01_ooool01?l0nY[o0000o`00ool0nYX2ooooo`03o`3jV_oooooooooo03go
oooo00?o0?ZJooooool000005?ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo00;o
oooo0ol0nYXAooooo`04o`00ooooooooooooo`00o`Wooooo00Go003oooooooooooooooooo`3jVP02
ooooo`03o`3jV_oooooooooo01?ooooo00?o003oooooooooool02oooool01?l00?ooooooooooool0
0?l7ooooo`04o`00ooooooooooooo`00o`Kooooo00?o0?ZJooooooooool0Coooool00ol0003ooooo
ooooo`0Wooooo`00@_ooool01?l0003o0?ZJooooool0nYXRooooo`;o0?ZJ3?ooool2o`3jVP03o`00
0?oooooooooo013ooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX3ooooo`05o`000?l0nY[oooooo`3j
V_ooool00_l0nYX;ooooo`03o`000?oooooo0?ZJ00;o0?ZJ00?oooooo`3jV_ooool01_ooool01Ol0
nY[o003oo`00ool0nY[ooooo00;o0?ZJ?oooool00ol0nY[oooooo`00000Dooooo`;o00001_ooool0
1?l0nY[oooooooooooooool2o`3jVPcooooo1?l00?l3ooooo`04o`00ooooooooooooo`00o`Wooooo
00Go003oooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo01?ooooo00?o003ooooooooo
ool02?ooool4o`00o`;ooooo00?o003oooooooooool01Oooool01?l00?ooooooooooool00?l6oooo
o`03o`3jV_oooooooooo04oooooo00?o0000ooooooooool09oooool0033ooooo0ol00003ooooo`03
o`000?oooooooooo00;ooooo0ol00004ooooo`04o`000?l0nY[oooooo`3jVR;ooooo0_l0nYX2oooo
o`03o`3jV_oooooooooo00Oooooo0_l0nYX00ol0003o0?ZJo`3jVP0?ooooo`07o`3jV_oooooo0?ZJ
o`000?l0nY[oooooo`3jVP03ooooo`05o`3jV_ooooooooooo`3jV_ooool00_l0nYX;ooooo`03o`00
0?l0nY[ooooo00;o0?ZJ00?oooooo`3jV_ooool01_ooool01Ol0nY[o0000o`000?l0nY[ooooo00;o
0?ZJ>?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_l0003o000001Cooooo00?o0000oooooooo
ool01Oooool4o`3jVPkooooo00Co003ooooooooooooo003o0oooool00ol00?ooooooooooo`04o`00
o`Kooooo00Go003oooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo01?ooooo00?o003o
ooooooooool02?ooool4o`00o`?ooooo00?o003oooooooooool00oooool01Ol00?oooooooooooooo
oooo003o00Kooooo1?l0nYY>ooooo`03o`000?oooooooooo02Oooooo000aooooo`03o`000?oooooo
oooo00Kooooo00Go0000ooooooooooooooooo`000003ooooo`04o`000?l0nY[o0000o`3jVR7ooooo
00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`06ooooo`04o`3jV_l0003o0?ZJooooo`;o
0?ZJ3oooool01ol0nY[oooooooooool0nY[o0000ooooool0nYX00_ooool2o`3jVP06o`000?oooooo
0?ZJo`3jV_l0003o0?ZJ2Oooool01Ol0003oooooo`000?l0nY[ooooo00;o0?ZJ00?oooooo`3jV_oo
ool01_ooool00ol0nY[oooooo`000002o`3jVP03ooooool0nY[ooooo03Oooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooo`00000Dooooo`03o`000?oooooooooo00Gooooo0_l0nYX@ooooo`04
o`00ooooooooooooo`00o`?ooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`04oooo
o`05o`00ooooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`0Cooooo`03o`00oooooooo
oooo00Cooooo1?l00?l7ooooo`03o`00oooooooooooo00Co003o0oooool00ol00?ooooooooooo`07
ooooo`03o`3jV_oooooooooo04cooooo00?o0000ooooooooool09oooool002kooooo1Ol00007oooo
o`05o`000?ooooooooooooooool000000oooool01?l0003o0?ZJo`000?l0nYXQooooo`04o`3jV_oo
oooo0?ZJooooo`;o0?ZJ0_ooool2o`3jVP?ooooo00?o0?ZJo`000?l000000_l0nYX00ol0003o0?ZJ
ooooo`0>ooooo`04o`3jV_ooooooooooo`3jVP;o000000?o0?ZJooooool0nYX00_l0nYX02?l0003o
003oo`3jV_l0nY[o0000o`3jV_oooooo00001oooool00ol0003oooooo`3jVP02ooooo`04o`3jV_l0
003o0?ZJo`3jVPOooooo00?o0?ZJooooooooool00_l0nYX00ooooooo0?ZJooooo`0gooooo`03o`3j
V_oooooooooo00?ooooo0_l0nYX00ooooooo0000ooooo`0Cooooo`03o`000?oooooooooo01Kooooo
00Go003oooooooooooooooooo`00o`03ooooo`03o`00oooooooooooo00?ooooo00Co003ooooooooo
oooooooo1?l00?l3ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`0?
ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool02?ooool01?l00?ooooooooooool0
0?l6ooooo`03o`00oooooooooooo00Sooooo1?l0nYY:ooooo`03o`000?oooooooooo02Oooooo000^
ooooo`04o`000?ooooooooooo`0000Sooooo1?l00004ooooo`04o`3jV_l0003o0000o`3jVP?ooooo
00?o0?ZJooooooooool06Oooool01_l0003o0?ZJoooooooooooo0?ZJooooo`;o0?ZJ0_ooool2o`3j
VP?ooooo00Oo0?ZJo`000?l00?oo0?ZJooooool0003o0?ZJ00kooooo00co0?ZJoooooooooooooooo
o`3jV_oooooo003oo`3jV_oooooo0?ZJooooool0nYX2o`00o`06o`3jV_l00?oo0000o`3jV_oooooo
00001oooool00ol0003oooooo`3jVP02ooooo`04o`3jV_l0003o0?ZJo`3jVPOooooo00?o0?ZJoooo
ooooool00_l0nYX00ooooooo0?ZJooooo`0gooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX2o`00
01Cooooo00?o0000ooooooooool05_ooool01Ol00?oooooooooooooooooo003o00;ooooo00?o003o
ooooooooool01?ooool01Ol00?oooooooooooooooooo003o00Kooooo00Go0?ZJoooooooooooooooo
o`3jVP02ooooo`Co0?ZJ3_ooool01Ol00?oooooooooooooooooo003o00;ooooo00?o003ooooooooo
ool02?ooool4o`00o`Kooooo00?o003oooooooooool02oooool00ol0nY[oooooooooo`18ooooo`03
o`000?oooooooooo02Oooooo000_ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool0
1Oooool01_l0nY[o003oo`00ool00?oo0?ZJooooo`;o0?ZJ6oooool01?l0003o0?ZJo`000?ooool2
o`3jVP;ooooo0_l0nYX01?oooooo0?ZJooooooooool2o`3jVP;o003o00Co0?ZJo`00ool00?oo0?ZJ
0_ooool2o`3jVP[ooooo00Go0?ZJo`00ool00?oo003oo`3jVP02o`00o`;o0?ZJ0_ooool02Ol0nY[o
0000o`000?l0nY[o0000o`00ool0nY[oooooo`000007ooooo`03o`000?oooooo0?ZJ00;ooooo00Co
0?ZJoooooooooooo0?ZJ1oooool00ol0nY[oooooooooo`02o`3jVP03ooooool0nY[ooooo00;ooooo
00?o0?ZJooooooooool0<Oooool2o`3jVP?ooooo00Ko0?ZJooooool0nY[o0?ZJooooool0000Doooo
o`;o00005?ooool4o`00o`?ooooo00Co003ooooooooooooo003o1?ooool00ol0003oooooo`00o`03
ooooo`03o`00oooooooooooo00Cooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`04o`3jV_oo
ooooooooo`3jVP?ooooo00?o0?ZJooooooooool02?ooool01?l00?ooooooooooooooool4o`00oaCo
oooo00?o003oooooooooool02oooool00ol0nY[oooooo`3jVP18ooooo`03o`000?oooooooooo02Oo
oooo000`ooooo`;o00002Oooool00ol0003oooooooooo`04ooooo`06o`3jV_l0003oooooo`00ool0
nY[ooooo0_l0nYXKooooo`04o`000?l0nY[o0000o`00o`;o0?ZJ00?oooooo`000?l0nYX00_ooool0
0ol0nY[oooooo`3jVP02o`3jVP08o`000?oooooo0?ZJo`3jV_oooooo003oo`3jV_ooool2o`3jVP;o
oooo0_l0nYX5ooooo`08o`000?l0nY[oooooo`000?oooooo0?ZJooooool00002o`3jVP;ooooo00?o
0?ZJo`000?l000000_l0nYX01?l0003o0?ZJo`000?l00006ooooo`;o000000Goooooo`3jV_l00?oo
003oo`3jVP0;ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool00_l0nYXcooooo`;o
0?ZJ0_ooool3o`3jVP04ooooool0nY[oooooo`0001Cooooo00?o0000ooooooooool04oooool00ol0
0?ooooooooooo`04ooooo`04o`00ooooooooooooo`00o`Cooooo00?o0000ooooool00?l00oooool0
0ol00?ooooooooooo`04ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool01?l0nY[ooooooooo
ool0nYX3ooooo`?o0?ZJ1Oooool01?l0nY[oooooooooool00?l3ooooo`03o`00oooooooooooo01Go
oooo00?o003oooooooooool02oooool2o`3jVP03ooooool0nY[ooooo04Kooooo00?o0000oooooooo
ool09oooool0037ooooo00?o0000ooooooooool02?ooool2o`0000Cooooo00Ko0?ZJo`000?oooooo
003oo`3jV_ooool2o`3jVQ_ooooo00Co0000o`3jV_l00?oo003o0_l0nYX01Ooooooo003oo`3jV_oo
oooo003o00?o0?ZJ00Co003oo`3jV_l0nY[ooooo0_l0nYX02_oooooo003oo`3jV_l0nY[oooooo`3j
V_oooooo0?ZJooooool0nYX5ooooo`06o`000?l0nY[o0?ZJo`000?oooooo0?ZJ0_ooool2o`3jVP05
o`000?l00?oo0?ZJo`3jV_l000000_l0nYX01?oooooo003oo`3jV_l00004ooooo`;o0?ZJ0_l00000
1Ooooooo0?ZJoooooooooooo0?ZJ00_ooooo00?o0?ZJooooool0nYX00_ooool00ol00?oo0?ZJoooo
o`02o`3jVPKooooo00?o0?ZJooooooooool07Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo
0_l0nYX2ooooo`?o0?ZJ00Coooooo`3jV_l0003o00005?ooool00ol0003oooooooooo`0Cooooo`03
o`00oooooooooooo00Cooooo00Co003ooooooooooooo003o0oooool3o`000005ooooool00?oooooo
ooooool00?l01_ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00Co0?ZJoooooooooooo0?ZJ
0oooool01?l0nY[oooooooooool0nYX4ooooo`Co0?ZJ0_ooool00ol00?ooooooooooo`0Fooooo`03
o`00oooooooooooo00kooooo00?o0?ZJooooool0nYX00_l0nYX00ooooooo0?ZJo`3jVP10ooooo`03
o`000?oooooooooo02Oooooo0012ooooo`04o`000?l0nY[oooooo`00o`;o0?ZJ00?oooooo`3jV_oo
ool06_ooool01Ol0003o0?ZJo`000?l0003o0?ZJ00?o003o00Co0?ZJo`00ool00?oo0?ZJ0ol00?l4
o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo0ol0nYX00ooooooo0?ZJooooo`04ooooo`06o`000?l0
nY[o0?ZJooooool0003o0?ZJ0_ooool01?l0nY[o003oo`00ool00?l2o`3jVP07o`000?l0nY[ooooo
o`3jV_l00?oo0?ZJooooo`02o`3jVP;ooooo0_l0nYX01?l0003oooooo`000?l0nYX2ooooo`03o`3j
V_oooooooooo00Wooooo00?o0?ZJooooool0nYX00ol00?l01?l0nY[oooooo`3jV_l0nYX6ooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool04_ooool01Ol0nY[ooooooooooooooooo0?ZJ
00Sooooo0_l0nYX2ooooo`?o0?ZJ00Coooooo`3jV_oooooo00005?ooool00ol0003oooooooooo`0@
ooooo`Co003o1_ooool01?l00?ooooooooooool00?l3ooooo`Co000000Co003oo`000?oooooo003o
1Oooool00ol0003o0?ZJooooo`02ooooo`08o`3jV_ooooooooooo`3jV_oooooo0000ooooool0nYX2
ooooo`05o`3jV_ooooooooooooooool0nYX00oooool01Ol0nY[oooooooooool0nY[ooooo00;o003o
6?ooool00ol00?ooooooooooo`0?ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oooooo`3jV_ooool0
?oooool00ol0003oooooooooo`0Wooooo`00@_ooool01?l0003o0?ZJooooool00?l2o`3jVP03oooo
ool0nY[ooooo01[ooooo0_l0nYX00ooooooo0000o`3jVP02ooooo`04o`000?l0nY[oooooo`0000;o
0?ZJ00Co003oo`3jV_oooooo00000_l0nYX2ooooo`;o0?ZJ0_ooool2o`3jVP;ooooo00?o0?ZJoooo
ooooool00_ooool2o`0000;o0?ZJ00_oooooo`3jV_oooooo0?ZJooooool0nY[oooooo`00ool0003o
0?ZJo`000002o`3jVP05ooooool0nY[o0?ZJo`3jV_ooool00_l0nYX01_oooooo0000o`3jV_l0nY[o
0000ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ0_ooool01Ol00?oo0?ZJo`3j
V_oooooo0?ZJ00Kooooo00?o0?ZJooooooooool01oooool2o`3jVQCooooo00?o0?ZJooooooooool0
0_l0nYX7ooooo`03o`3jV_oooooo0?ZJ00;ooooo0ol0nYX01?oooooo0?ZJooooool0000Dooooo`03
o`000?oooooooooo013ooooo00?o003oooooooooool01oooool01?l00?ooooooooooool00?l3oooo
o`Co000000Go003oo`000?oooooo003oo`000002ooooo`?o000000Go0?ZJooooooooooooooooo`3j
VP02ooooo`05o`3jV_oooooo0000ooooool0nYX00_ooool01?l0nY[oooooooooooooool4o`3jVP?o
oooo00Co0?ZJo`00oooooooo003o6?ooool4o`00oaCooooo00?o0?ZJooooooooool0?_ooool00ol0
003oooooooooo`0Wooooo`00@_ooool01Ol0003o0?ZJooooool0003o0?ZJ00;ooooo00Co0?ZJoooo
oooooooo0?ZJ5oooool00ol0003o0?ZJo`3jVP02ooooo`;o0?ZJ00?oooooo`000?l0nYX00_ooool4
o`3jVPKooooo00Co0000o`3jV_l00?oo003o0_l0nYX00ooooooo003oo`3jVP04ooooo`;o000000Go
0?ZJo`000?l0nY[o0?ZJooooo`04o`3jVP06ooooool0nY[oooooo`000?oooooo0?ZJ0_ooool3o`3j
VP08o`000?l0nY[o0?ZJo`3jV_l0003o0?ZJo`000?ooool3o`3jVP03ooooool0nY[ooooo00_ooooo
0ol0nYX01_oooooo003oo`3jV_l0nY[oooooo`3jVPGooooo0_l0nYX9ooooo`;o0?ZJ4oooool2o`3j
VP;ooooo0_l0nYX7ooooo`03o`3jV_oooooo0?ZJ00;ooooo0ol0nYX01?oooooo0?ZJo`000?l0000D
ooooo`;o00004Oooool01Ol00?oooooooooooooooooo000000Gooooo1?l00?l3ooooo`09o`000?oo
oooo0000o`000?l00?oo0000ooooool00?oo000000;ooooo00Co0000ooooool0003o0?ZJ0oooool4
o`3jVP?o00001?l0nYX6ooooo`05o`3jV_ooooooooooooooool0nYX07oooool4o`00oa3ooooo00?o
0?ZJooooooooool0?_ooool00ol0003oooooooooo`0Wooooo`00@_ooool02?l0003o0?ZJoooooooo
oooo0?ZJooooool0003o0?ZJ0_ooool00ol0nY[oooooooooo`0Eooooo`05o`000?l0nY[o0?ZJo`3j
V_ooool00_l0nYX00ol0003o0?ZJooooo`03o`3jVP03ooooool0nY[o0?ZJ00Oooooo00Co0?ZJo`00
0?oooooo0?ZJ0_l00?l02_oooooo0?ZJoooooooooooo0000ooooool0003oooooo`3jV_ooool2o`3j
VP?ooooo0_l0nYX01?oooooo0?ZJooooool00004ooooo`?o0?ZJ00?o0000o`3jV_l0nYX00_l00000
1?l0nY[o0000o`3jV_ooool2o`3jVP03ooooool0nY[ooooo00cooooo0_l0nYX01_oooooo003oo`3j
V_l0nY[oooooo`3jVPGooooo0_l0nYX9ooooo`;o0?ZJ4_ooool00ol0003o0?ZJo`3jVP02ooooo`;o
0?ZJ1_ooool2o`3jVP;ooooo0_l0nYX00ol0003o0?ZJo`3jVP02ooooo`03o`3jV_l0003ooooo01?o
oooo00?o0000ooooooooool03oooool00ol00?ooooooo`000002ooooo`03o`000?oooooooooo00[o
oooo00Go0000ooooool0003o0000o`00o`02o`000005o`00ool0003o0000ooooool000000_ooool0
0ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo00;o00000_ooool01?l0nY[oooooooooool0
0007ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool04_ooool00ol00?oooooooooo
o`0>ooooo`03o`3jV_oooooooooo03kooooo00?o0000ooooooooool09oooool004;ooooo00Go0000
ooooool0nY[oooooo`3jVP02o`000004o`3jV_oooooo0?ZJo`3jVP;ooooo0_l0nYXCooooo`05o`3j
V_l00?oo0?ZJo`3jV_ooool00_l0nYX01?l0003o0?ZJooooooooool2o`3jVP[ooooo00?o0?ZJo`00
0?ooool00_l0nYX2ooooo`06o`3jV_ooooooooooo`000?oooooo00000_l0nYX2ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooool0nYX01_ooool2o`3jVP0<ooooool0003o0?ZJo`3jV_oooooo
0000o`3jV_l0003o0?ZJo`00ool0nY[ooooo0_l0nYX=ooooo`05o`000?l0nY[oooooooooool0nYX0
0_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00Wooooo0_l0nYXBooooo`03o`00
0?l0nY[o0?ZJ00;ooooo0_l0nYX6ooooo`;o0?ZJ0_ooool2o`3jVP03o`000?l0nY[ooooo00;ooooo
00Co0?ZJo`000?oooooooooo0_l00004ooooo`04o`000?ooooooooooooooo`Go00000oooool00ol0
003oooooooooo`0<ooooo`05o`00oooooooo003oo`00ooooool00ol000000ooooooo0000ooooo`09
ooooo`;o00000oooool4o`00o`?o000000Co0?ZJoooooooooooo0?ZJ1Oooool01?l0003ooooooooo
ooooool2o`0000Gooooo0_l00006ooooo`03o`3jV_oooooooooo00_ooooo0ol0nYXBooooo`03o`00
oooooooooooo00kooooo00?o0?ZJooooooooool0?_ooool00ol0003oooooooooo`0Wooooo`00@_oo
ool2o`000003ooooool0nY[o0?ZJ00;o003o00Co0?ZJooooool0nY[o0?ZJ0_ooool2o`3jVPgooooo
00?o0?ZJooooooooool00_ooool2o`3jVP03o`00ool0nY[ooooo00;o0?ZJ00?o0000o`3jV_l0nYX0
3oooool03?l0nY[oooooo`3jV_l0nY[o0000ooooool0nY[oooooo`000?l0nY[oooooo`0000;o0?ZJ
2?ooool2o`3jVPOooooo00Oo0?ZJooooool0003o0?ZJo`00oooooooo003o00;o0?ZJ00?oooooo`00
ool0nYX00_ooool00ol0nY[oooooooooo`0;ooooo`05o`000?l0nY[oooooo`000?l0nYX00_ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o0?ZJooooool0nYX04_ooool0
1ol0003o0?ZJo`3jV_oooooo0?ZJooooool0nYX01Oooool3o`3jVP;ooooo0_l0nYX02Ol0003o0?ZJ
oooooooooooo003oo`3jV_l0003oooooo`000002ooooo`03o`000?oooooooooo00Kooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`0<ooooo`;o003o00?oooooo`00ooooool00ol0
00000ooooooo0000o`000009ooooo`03o`000?oooooooooo00Cooooo0_l000000ooooooo0000o`00
0004o`3jVP03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool01?l0003oooooo`00
0?l00002ooooo`;o00000_ooool01Ol0003ooooooooooooooooo0?ZJ00gooooo00Co0?ZJooooool0
nY[o0?ZJ1oooool2o`3jVPSooooo00?o003oooooooooool03_ooool00ol0nY[oooooooooo`0noooo
o`03o`000?oooooooooo02Oooooo0012ooooo`03o`000?oooooooooo00;o0?ZJ00?o003oo`000?l0
nYX00ol0nYX2ooooo`;o0?ZJ3?ooool2o`3jVPCooooo00Go0?ZJo`000?l00?oo0?ZJooooo`02o`3j
VP03ooooool0003o0?ZJ00oooooo0ol0nYX01Ooooooo0?ZJooooool0nY[ooooo00;o0?ZJ00Co0000
o`3jV_oooooo0?ZJ2?ooool2o`3jVPOooooo00Co0?ZJo`00ool00?oo0?ZJ0ol00?l2o`3jVP03oooo
ool00?oo0?ZJ013ooooo00Go0000o`3jV_oooooo0000o`3jVP02ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooool0nYX02?ooool00ol0nY[oooooo`3jVP0Booooo`07o`3jV_l0003o0?ZJoooo
ool0nY[oooooo`3jVP05ooooo`?o0?ZJ0_ooool01?l0nY[o0000o`000?l0nYX3o`00o`04o`3jV_l0
003oooooo`0000;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo1?l00?l3ooooo`Co003o0oooool3o`0000?ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooo`000?l0nYX00oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Co0000ooooool0003o00000_ooool2o`00
00;ooooo00Go0000ooooooooooooooooo`3jVP0=ooooo`04o`3jV_ooooooooooo`3jVPOooooo00Co
0?ZJooooool0nY[o0?ZJ1_ooool00ol00?ooooooooooo`0?ooooo`03o`3jV_oooooooooo03gooooo
00?o0000ooooooooool09oooool004;ooooo00Go0000ooooooooooooooooo`3jVP02o`0000;o0?ZJ
00Koooooo`3jV_oooooo0?ZJooooool0nYX<ooooo`;o0?ZJ0_ooool3o`3jVP03o`000?l00?oo0?ZJ
00;ooooo00?o0?ZJooooooooool04Oooool00ol0003o0?ZJo`000004o`3jVP03ooooool0003o0?ZJ
00;ooooo00?o0?ZJooooooooool03oooool00ol0nY[o003oooooo`02o`3jVP;ooooo0_l0nYX00ooo
oooo0?ZJooooo`0Aooooo`07o`000?l0nY[o0000o`3jV_oooooo003oo`3jVP04ooooo`03o`3jV_oo
oooo0?ZJ00Sooooo00?o0?ZJooooool0nYX04_ooool00ol0nY[o0000o`000002o`3jVP03ooooool0
nY[ooooo00Cooooo0_l0nYX2ooooo`06o`000?l0nY[o0000o`000?l0nY[o00000_l00?l01?l0nY[o
0000ooooool00002ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_ooool2o`00
00?ooooo0_l000000ooooooo003oooooo`02ooooo`03o`00oooooooooooo00Cooooo00?o0000oooo
ooooool00oooool00ol0003o0?ZJo`000007ooooo`03o`000?oooooooooo00Gooooo00Go0000oooo
oooooooo0000o`3jVP03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool2
o`000005ooooool0003o0000o`000?ooool00_l000000ooooooo0000ooooo`02ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool01?l0nY[oooooooooool0nYX7ooooo`04o`3j
V_ooooooooooo`3jVPKooooo00?o003oooooooooool03oooool00ol0nY[oooooooooo`0looooo`;o
0000:Oooool002[ooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00003ooooo`?o0000
1?ooool2o`0000;ooooo00?o0?ZJo`000?ooool00_l0nYX2ooooo`;o0?ZJ00?oooooo`3jV_ooool0
2_ooool01_l0nY[oooooo`3jV_oooooo0?ZJo`0000;o0?ZJ00?o0000o`3jV_ooool05_ooool01Ol0
003oooooo`000?oooooo000000;o0?ZJ00?oooooo`000?l0nYX00_ooool00ol0nY[oooooooooo`0?
ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool01?l0nY[o003oo`00ool0nYXBooooo`04o`000?l0
nY[o0?ZJo`3jVP;o003o00?o0?ZJooooooooool00_ooool00ol0nY[oooooo`3jVP08ooooo`03o`3j
V_oooooo0?ZJ01;ooooo00Co0?ZJo`000?l0003o0?ZJ0_ooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ0_ooool03?l00?oo0?ZJo`000?l0003o0?ZJo`000?oooooo003oo`3jV_l0003oooooo`0000;o
oooo00?o0000ooooooooool01Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooo
ooooool00_ooool2o`000005ooooool00?ooooooooooool00?l01oooool00ol0003oooooooooo`03
ooooo`03o`000?l0nY[o0?ZJ00Oooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`02
ooooo`?o000000?oooooo`000?ooool00oooool2o`000005ooooool0003o0000o`000?ooool00_l0
00001_oooooo0000o`000?oooooo0000o`3jVPGooooo0ol00002ooooo`;o0?ZJ00?oooooo`3jV_oo
ool00_ooool01?l0nY[oooooooooool0nYX2ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool0
0ol00?ooooooooooo`0?ooooo`03o`3jV_oooooooooo03Wooooo00Go0?ZJooooooooooooooooo`00
000Yooooo`00:oooool00ol0003oooooooooo`06ooooo`07o`000?ooooooooooooooool0003ooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool00ol0nY[o0000ooooo`02o`3jVP06
o`000?oooooo0?ZJo`000?oooooo0?ZJ2oooool00ol0nY[oooooo`3jVP02o`3jVP05o`000?l0nY[o
003oo`00ool0nYX05oooool00ol0003oooooo`000002ooooo`05o`3jV_l00?oo003oo`00ool0nYX0
0_l00?l00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool01?l0nY[ooooo
ooooool0nYXBooooo`04o`000?oooooo0?ZJo`3jVP;ooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooo`3jVP07ooooo`04o`3jV_ooooooooooo`3jVQ;ooooo00Co0?ZJo`000?l0003o0?ZJ0_oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00?o003o00?o0?ZJo`000?l000000_l0
nYX01_oooooo003oo`3jV_l0003oooooo`0000;ooooo00?o0000ooooooooool01Oooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool00oooool00ol0003oooooo`00o`03o`00
o`Oooooo00?o0000ooooooooool00oooool00ol0003o0?ZJo`000002o`3jVP;ooooo00Co0000oooo
oooooooo00002oooool00ol0nY[oooooooooo`02ooooo`Co00001_ooool01_l0003ooooooooooooo
oooo0000ooooo`;o000000Koooooo`000?l0003oooooo`000?l0nYX4ooooo`;o00000ol0nYX00ooo
oooo0?ZJo`3jVP02o`3jVP?ooooo00?o0?ZJooooooooool01?l0nYX3ooooo`03o`3jV_oooooooooo
00Cooooo00?o003oooooooooool03oooool01?l0nY[oooooooooool0nYXgooooo`03o`3jV_oooooo
oooo00;ooooo00?o0000ooooooooool09oooool002Sooooo1Ol00007ooooo`05o`000?oooooooooo
ooooool000001Oooool01Ol0003ooooooooooooooooo000000Cooooo00[o0?ZJooooool0nY[ooooo
o`000?l00?oo0?ZJo`000?oooooo0?ZJ2_ooool00ol0nY[oooooo`000002o`3jVP06o`000?oooooo
0?ZJo`000?oooooo0?ZJ5oooool00ol0003oooooooooo`02ooooo`05o`3jV_ooooooooooooooool0
nYX00_ooool00ol0nY[oooooooooo`0@ooooo`06o`3jV_oooooo0?ZJooooool0nY[ooooo0_l0nYX0
0ooooooo0?ZJooooo`0Aooooo`07o`000?oooooo0000o`3jV_l0003oooooo`3jVP03ooooo`04o`3j
V_ooooooooooo`3jVPOooooo00Co0?ZJoooooooooooo0?ZJ3Oooool00ol0nY[oooooooooo`02oooo
o`04o`3jV_l0003o0000o`3jVP;ooooo00?o0?ZJooooooooool00_ooool02Ol0nY[oooooo`3jV_oo
oooo003oo`000?l0nY[oooooo`000002o`3jVP04ooooool0003o0?ZJo`0000;ooooo0_l00009oooo
o`?o00001?ooool00ol0003oooooooooo`03ooooo`;o000000?oooooo`000?ooool02?ooool00ol0
003oooooooooo`04ooooo`04o`3jV_l0003o0000o`3jVP;ooooo00Co0000o`3jV_l0003o00002ooo
ool00ol0nY[oooooooooo`04ooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`08o`000?oo
oooo0000o`000?oooooo0000o`3jV_l00002ooooo`?o00001?l0nYX3ooooo`03o`3jV_oooooooooo
00;ooooo0ol0nYX2ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool00ol00?ooooooooooo`0?
ooooo`Co0?ZJ00?oooooo`3jV_l0nYX0=?ooool00ol0nY[oooooooooo`02ooooo`03o`000?oooooo
oooo02Oooooo000Xooooo`04o`000?ooooooooooo`0000Sooooo1?l00006ooooo`04o`000?oooooo
ooooooooo`;o00000oooool00ol0nY[oooooo`3jVP03o`00o`04o`3jV_l0003o0000o`3jVP[ooooo
00?o0?ZJooooool000000_l0nYX01_l0003oooooo`3jV_l0nY[oooooo`3jVQgooooo00Oo0?ZJoooo
ool0nY[oooooo`3jV_oooooo0?ZJ01;ooooo00?o0?ZJooooool0nYX00_ooool3o`3jVP03ooooool0
nY[ooooo017ooooo0_l000001Ooooooo0?ZJo`000?oooooo0?ZJ00?ooooo00Co0?ZJo`00ool00?oo
0?ZJ1oooool01?l0nY[oooooooooool0nYX<ooooo`;o0?ZJ1?ooool01?l0nY[o0000o`000?l0nYX2
ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJooooool0nY[ooooo0_l000000ol0nY[o003oo`00
o`02o`3jVP04ooooool0003o0?ZJo`0001Cooooo00?o0000ooooooooool00oooool2o`000003oooo
ool0003ooooo00Sooooo00Co0000oooooooooooo0?ZJ0_ooool02?l0nY[oooooooooool0003o0?ZJ
o`000?oooooo00000_l0nYX00ooooooo0?ZJooooo`08ooooo`03o`3jV_oooooooooo00Gooooo0_l0
000>ooooo`03o`000?oooooo000000;o000000Co0?ZJo`000?oooooooooo0ol000000ol0nY[o0000
ooooo`0Booooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool03oooool00ol0nY[ooooo
ooooo`02o`3jVP03ooooool0nY[ooooo03?ooooo00?o0?ZJooooooooool00_ooool00ol0003ooooo
ooooo`0Wooooo`00:Oooool00ol0003oooooo`000008ooooo`03o`000?oooooooooo00?ooooo1?l0
0004ooooo`03o`000?oooooooooo00;ooooo0ol0nYX01?oooooo0000ooooool0nYX2o`00o`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooool000000_l0nYX01_l0003oooooo`3jV_l0nY[oooooo`3j
VQgooooo00Oo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ01?ooooo0_l0nYX3ooooo`04o`3jV_oo
oooo0?ZJo`3jVQ;ooooo0_l000001Ooooooo0?ZJo`000?oooooo0?ZJ00?ooooo00Co0?ZJoooooooo
oooo0?ZJ1oooool01?l0nY[oooooooooool0nYX<ooooo`;o0?ZJ0oooool01Ol0nY[o0000o`000?oo
oooo0?ZJ00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[o0000o`3jVP02o`000004ooooool0
nY[o003oo`00o`;o0?ZJ00Coooooo`000?l0nY[o00005?ooool2o`0000Gooooo00?o0000ooooool0
00002Oooool00ol0003oooooooooo`04o`3jVP;ooooo00Go0000o`3jV_l0003o0000ooooo`07o`3j
VPKooooo00?o0?ZJooooooooool05oooool2o`000003ooooool0nY[o000000;ooooo00Go0000oooo
ool0003o0?ZJo`00000Cooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool05Oooool0
0ol0nY[oooooooooo`0booooo`03o`3jV_oooooooooo00;ooooo00?o0000ooooooooool09oooool0
02[ooooo0_l00009ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`03ooooo`?o0?ZJ00Ko0000ooooool0nY[oooooo`000?l0nYX2ooooo`03o`3jV_oo
oooooooo00Gooooo00Co0?ZJo`00ool00?oo0?ZJ0ol00?l2o`3jVP03ooooool0nY[ooooo01gooooo
0_l0nYX2ooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ4_ooool2o`0000;ooooo
00?o0?ZJooooool0nYX00_ooool01Ol0003o0?ZJoooooooooooo0?ZJ00Oooooo00Co0?ZJoooooooo
oooo0?ZJ3?ooool2o`3jVP?ooooo00So0?ZJo`000?l0003oooooo`3jV_oooooo003oo`3jVP?ooooo
00?o0?ZJooooool000000_l0nYX01Ol0003oooooo`3jV_oooooo000000;o0?ZJ00Coooooo`000?l0
nY[o00005?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000Wooooo00Go0000oooo
oooooooo0?ZJooooo`02o`3jVP;ooooo00Oo0000o`3jV_l0003o0000ooooool0nY[o000000Cooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_l0003o000000;o0000
0_ooool00ol0nY[oooooo`00000Booooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool0
5Oooool00ol0nY[oooooooooo`0booooo`03o`3jV_oooooooooo00;ooooo00?o0000ooooooooool0
9oooool002_ooooo00?o0000ooooooooool02?ooool2o`0000;ooooo1Ol00003ooooo`;o00001Ooo
ool2o`3jVP;o000000Go0?ZJooooool0003o0?ZJooooo`02o`3jVPOooooo00Co0?ZJooooool0003o
0?ZJ0oooool01?l0nY[oooooo`3jV_l0nYXoooooo`03o`3jV_oooooooooo013ooooo0_l00002oooo
o`03o`3jV_oooooo0?ZJ00;ooooo00Go0000o`3jV_l0nY[oooooo`3jVP07ooooo`04o`3jV_l00?oo
003oo`3jVPcooooo0_l0nYX3ooooo`05o`3jV_l00?oo003oo`00ool0nYX00_l00?l01ol0nY[ooooo
oooooooooooo0?ZJooooool000000_l0nYX01Ol0003oooooo`3jV_oooooo000000;o0?ZJ00Cooooo
o`000?l0nY[o00005?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000o`3jV_l0nYX00_l0nYX5ooooo`03o`000?l0nY[ooooo00;ooooo00?o0?ZJooooooooool00ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool06_ooool01Ol0nY[o0000
ooooool0003o0?ZJ00;ooooo00?o0?ZJooooool000004_ooool00ol0nY[oooooooooo`04ooooo`03
o`00oooooooooooo01Gooooo00?o0?ZJooooooooool0<_ooool00ol0nY[oooooooooo`02ooooo`03
o`000?oooooooooo02Oooooo0012ooooo`03o`000?oooooooooo00Gooooo00So0?ZJo`000?l0003o
0?ZJooooool0003o0?ZJooooo`;o0?ZJ0_ooool02?l0003ooooooooooooooooo0000o`3jV_oooooo
00000_l0nYX2ooooo`04o`3jV_ooooooooooo`3jVU;ooooo0_l00002ooooo`03o`3jV_oooooo0?ZJ
00;ooooo00Go0000o`3jV_l0nY[oooooo`3jVP07ooooo`04o`3jV_l00?ooooooo`3jVP_ooooo00?o
0?ZJooooool0nYX00oooool02?l0nY[o003oo`00oooooooo0?ZJo`00oooooooo0?ZJ0oooool00ol0
nY[o0000ooooo`02o`3jVP03o`000?oooooo0?ZJ00;ooooo0_l0nYX01?oooooo0000o`3jV_l0000D
ooooo`03o`000?oooooooooo00Kooooo0_l00007ooooo`05o`000?l0nY[oooooooooool0nYX01Ooo
ool00ol0003o0?ZJooooo`02ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooooooo
1?l0nYXLooooo`04o`3jV_ooooooooooo`0000;o0?ZJ00?oooooo`3jV_ooool00_l0000Aooooo`03
o`3jV_oooooooooo00Cooooo00?o003oooooooooool02oooool4o`00o`Kooooo00?o0?ZJoooooooo
ool0<_ooool00ol0nY[oooooooooo`02ooooo`03o`000?oooooooooo02Oooooo0012ooooo`03o`00
0?oooooooooo00Gooooo00Ko0?ZJo`000?l0nY[oooooo`3jV_l00004o`3jVP;ooooo0_l0nYX2oooo
o`;o0?ZJ0_l00002o`3jVP;ooooo00?o0?ZJooooooooool0Doooool2o`0000;ooooo00Ko0000o`3j
V_l0nY[oooooo`000?ooool2o`3jVP03ooooool0nY[ooooo00Kooooo00Co0?ZJoooooooooooo0?ZJ
1_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00?ooooo00Go0?ZJoooooooooooo
ooooo`3jVP02ooooo`07o`3jV_ooooooooooooooool0nY[o0000ooooo`02o`3jVP03o`000?oooooo
0?ZJ00;ooooo00Ko0?ZJo`000?l0nY[o0000o`3jV_l0000Dooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01?ooool2o`000003o`3jV_oooooooooo00Kooooo00Go0000o`3jV_oooooo
ooooo`3jVP06ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`0Joooo
o`06o`3jV_ooooooooooo`000?l0nY[ooooo0_l0nYX00ooooooo0000o`00000Aooooo`03o`3jV_oo
oooooooo00Cooooo00?o003oooooooooool02oooool01?l00?ooooooooooool00?l6ooooo`03o`3j
V_oooooooooo033ooooo0ol0nYX4ooooo`03o`000?oooooooooo02Oooooo0012ooooo`;o00001_oo
ool01_l0003o0?ZJo`3jV_oooooo0?ZJo`0000;o0?ZJ00Coooooo`3jV_oooooooooo0_l0nYX2oooo
o`?o0?ZJ00Ko0000o`3jV_oooooo0?ZJooooool0nYYEooooo`;o00000_ooool01Ol0003oooooo`3j
V_oooooo000000?o0?ZJ00?oooooo`3jV_ooool01_ooool01?l0nY[oooooooooool0nYX5ooooo`;o
0?ZJ1?ooool00ol0nY[oooooo`3jVP03ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool01ol0
nY[ooooooooooooooooo0?ZJo`000?ooool00_l0nYX00ol0003oooooo`3jVP02ooooo`03o`3jV_oo
oooo0?ZJ00;o0?ZJ00?o0000ooooooooool04_ooool2o`0000Sooooo00?o0000ooooooooool01?oo
ool2o`000003o`3jV_oooooooooo00Oooooo00Co0?ZJoooooooooooo0?ZJ1_ooool01Ol0nY[ooooo
oooooooooooo0?ZJ01oooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`;o00004Oooool00ol0
nY[oooooooooo`04ooooo`03o`00oooooooooooo00Sooooo1?l00?l2ooooo`03o`00oooooooooooo
00Cooooo00?o0?ZJooooooooool0;_ooool3o`3jVPKooooo00?o0000ooooooooool09oooool004;o
oooo00?o0000ooooooooool01oooool00ol0nY[oooooo`3jVP03o`3jVP04ooooool0nY[oooooo`00
00;o0?ZJ00?oooooo`000?l0nYX00_l0nYX00ol0003o0?ZJooooo`03o`3jVUKooooo00So0000oooo
oooooooo0000ooooool0nY[oooooo`0000?o0?ZJ00?oooooo`3jV_ooool01_ooool01?l0nY[ooooo
ooooool0nYX5ooooo`;o0?ZJ0oooool01?l0nY[o0000ooooool0nYX3ooooo`;o0?ZJ0_ooool01?l0
nY[oooooooooool0nYX3ooooo`03o`3jV_l00?oo003o00;o0?ZJ00?oooooo`3jV_l0nYX00_ooool0
0ol0nY[oooooo`000002o`3jVP03o`000?oooooooooo01;ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`03ooooo`;o000000?o0?ZJooooooooool02?ooool01?l0nY[oooooooooool0
nYX7ooooo`04o`3jV_ooooooooooo`3jVQoooooo00Co0?ZJoooooooooooo0?ZJ1Oooool2o`00017o
oooo00?o0?ZJooooooooool01?ooool00ol00?ooooooooooo`08ooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`0/ooooo`;o0?ZJ00?oooooo`3jV_oo
ool01_ooool00ol0003oooooooooo`0Wooooo`00@_ooool00ol0003oooooooooo`07ooooo`03o`3j
V_oooooooooo00?o0?ZJ0_ooool2o`3jVP05o`000?l0nY[o0000o`3jV_l00?l01?l0nYYJooooo`08
o`000?ooooooooooooooool0003o0?ZJooooool00002o`3jVP03o`000?l0nY[o0?ZJ00Kooooo00Go
0000o`3jV_ooooooooooo`3jVP05ooooo`;o0?ZJ0oooool01?l0nY[o0000o`000?l0nYX3ooooo`;o
0?ZJ0_ooool01?l0nY[oooooooooool0nYX3ooooo`05o`3jV_l00?ooooooo`3jV_ooool00_l0nYX0
1_oooooo0?ZJooooool0nY[oooooo`0000;o0?ZJ00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`08ooooo`08o`000?ooooooooooooooool0nY[o0000ooooool0nYX:ooooo`04o`3jV_oooooo
ooooo`3jVPOooooo00Co0?ZJoooooooooooo0?ZJ7oooool01?l0nY[oooooooooool0nYX6ooooo`03
o`000?oooooooooo013ooooo0ol0nYX3ooooo`03o`00oooooooooooo00Oooooo00?o003ooooooooo
ool01?ooool00ol00?ooooooooooo`04ooooo`03o`3jV_oooooooooo02_ooooo0_l0nYX:ooooo`03
o`000?oooooooooo02Oooooo0012ooooo`;o00002oooool00ol0003o0?ZJo`00o`02o`00o`;o0?ZJ
00Oo0000o`3jV_l0nY[o0?ZJo`00ool0nY[o000000;o0?ZJF_ooool02?l0003ooooooooooooooooo
0000o`3jV_oooooo00000_l0nYX00ol0003o0?ZJo`3jVP06ooooo`;o0?ZJ0_ooool01?l0nY[ooooo
ooooool0nYX2ooooo`;o0?ZJ0oooool01?l0nY[o0000o`000?l0nYX3ooooo`;o0?ZJ0_ooool01?l0
nY[oooooooooool0nYX3ooooo`05o`3jV_ooooooooooo`3jV_ooool00_l0nYX01ooooooo0?ZJoooo
ool0nY[oooooo`000?ooool00_l0000Dooooo`03o`000?oooooooooo00Sooooo00Co0000o`3jV_oo
oooooooo1?l0nYX;ooooo`?o0?ZJ1oooool01?l0nY[oooooooooool0nYXPooooo`?o0?ZJ1_ooool0
0ol0003oooooooooo`0Booooo`05o`3jV_ooooooooooooooool00?l01_ooool4o`00o`Oooooo00?o
003oooooooooool00oooool00ol0nY[oooooooooo`0[ooooo`03o`3jV_oooooooooo00Wooooo00?o
0000ooooooooool09oooool004;ooooo00?o0000ooooooooool02_ooool01_l0003o0?ZJooooool0
003o003oo`3jVP;ooooo0_l0nYX01_oooooo003oo`3jV_l0003oooooo`3jVU[ooooo00Go0000oooo
ooooooooooooo`000003o`3jVP05ooooool0nY[o0000ooooool0nYX01_ooool3o`3jVP05ooooool0
nY[oooooooooool0nYX00_ooool2o`3jVP?ooooo00Co0?ZJooooool0003o0?ZJ0oooool2o`3jVP;o
oooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`05o`3jV_ooooooooooo`3jV_ooool00_l0nYX01?oo
oooo0?ZJooooool0nYX4ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02?ooool0
0ol0003o0?ZJo`3jVP02o`3jVQSooooo00Co0?ZJoooooooooooo0?ZJ:Oooool00ol0003ooooooooo
o`0Booooo`05o`3jV_ooooooooooooooool00?l01_ooool00ol00?ooooooooooo`08ooooo`03o`00
oooooooooooo00?ooooo00?o0?ZJooooooooool0:oooool00ol0nY[oooooooooo`09ooooo`03o`00
0?oooooooooo02Oooooo0012ooooo`03o`000?oooooooooo00_ooooo00Go0000o`3jV_l0003o0000
o`3jVP02ooooo`;o0?ZJ00?oooooo`3jV_ooool0HOooool02?l0003o0?ZJo`3jV_l0003oooooo`3j
V_l0003ooooo0_l0nYX5ooooo`?o0?ZJ00Woooooo`3jV_ooooooooooo`3jV_oooooo0?ZJooooool0
nYX00oooool01?l0nY[oooooo`000?l0nYX3ooooo`;o0?ZJ00Koooooo`3jV_l0003o0?ZJooooool0
nYX2ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYX2ooooo`;o0?ZJ1?ooool00ol0003ooooo
ooooo`0Booooo`;o00002Oooool00ol0003o0?ZJo`000002o`0001Sooooo00Co0?ZJoooooooooooo
0?ZJ:_ooool00ol0003oooooooooo`0Booooo`04o`3jV_ooooooooooo`00o`?ooooo1?l00?l:oooo
o`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool09_ooool2o`3jVP?ooooo00?o0?ZJoooo
ooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02Oooooo000`ooooo`?o
00000oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo0_l0000<ooooo`05
o`000?l0nY[o0000o`000?l0nYX00_l00?l2o`3jVP03ooooool0nY[ooooo067ooooo00So0000o`3j
V_l0nY[o0000ooooool0nY[o0000ooooo`;o0?ZJ1Oooool3o`3jVP03ooooool0nY[ooooo00;o0?ZJ
00Coooooo`3jV_oooooo0?ZJ0oooool01?l0nY[oooooo`000?l0nYX2ooooo`?o0?ZJ00Soooooo`3j
V_l0003o0?ZJooooool0nY[oooooo`0000;o0?ZJ0_ooool01?l0nY[oooooooooool0nYX2ooooo`;o
0?ZJ0oooool2o`0001Cooooo00?o0000ooooooooool02?ooool01?l0nY[oooooo`000?l0000Ioooo
o`04o`3jV_ooooooooooo`3jVR[ooooo00?o0000ooooooooool04_ooool01?l0nY[oooooooooool0
0?l3ooooo`03o`00oooooooooooo00_ooooo1?l00?l2ooooo`03o`3jV_oooooooooo02Gooooo0ol0
nYX3ooooo`03o`3jV_oooooooooo00Cooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`0Wooooo`00<Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool02oooool01Ol0003o0?ZJo`000?oooooo0?ZJ00;ooooo00Co0?ZJo`00ool00?oo0?ZJ
H_ooool00ol0003o0?ZJo`3jVP02ooooo`03o`3jV_l0003ooooo00;o0?ZJ1Oooool3o`3jVP03oooo
ool0nY[ooooo00;o0?ZJ00Coooooo`3jV_oooooo0?ZJ0oooool01?l0nY[o003oo`00ool0nYX2oooo
o`;o0?ZJ00Woooooo`3jV_l0nY[o0000o`3jV_oooooo0?ZJooooool000000_l0nYX2ooooo`03o`3j
V_oooooooooo00?ooooo0_l0nYX4ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
1Oooool01Ol0nY[oooooo`3jV_l0nY[ooooo00;o00006_ooool3o`3jVR[ooooo00?o0000ooooool0
00004_ooool2o`3jVP03ooooool00?oooooo00;ooooo00?o003oooooooooool02oooool2o`00o`03
ooooool00?oooooo00;ooooo00?o0?ZJooooooooool07oooool01Ol0nY[ooooooooooooooooo0?ZJ
00?ooooo1?l0nYX6ooooo`;o00000oooool00ol0003oooooooooo`0Wooooo`00;_ooool5o`0000[o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0;ooooo`05o`000?oooooo0?ZJoooo
ool0nYX00_ooool01?l0nY[oooooooooool0nYYRooooo`03o`000?l0nY[o0?ZJ00;ooooo00?o0?ZJ
o`000?ooool00_l0nYX5ooooo`;o0?ZJ00Co0000o`3jV_l0nY[ooooo0ol0nYX2ooooo`08o`3jV_oo
ooooooooooooool0nY[o003oo`000?l0nYX2ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0000ooooo`02
o`3jVP;o00000_l0nYX2ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Gooooo0_l0nYX00ooooooo0?ZJooooo`02
o`0004Oooooo00?o0000ooooool000004oooool3o`3jVP;ooooo00?o003oooooooooool03oooool0
1Ol00?oooooooooooooooooo0?ZJ01?ooooo00?o0?ZJooooooooool02Oooool3o`3jVP04ooooool0
nY[o0?ZJo`3jVP?ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo02Oooooo000^ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool0
0_ooool2o`0000cooooo00?o0000ooooool0nYX00_l0nYX2ooooo`;o0?ZJ00?oooooo`3jV_ooool0
H_ooool01ol0nY[o0000oooooooooooo0?ZJo`000?ooool00_l0nYX5ooooo`;o0?ZJ00Oo0000o`3j
V_l0nY[o0000o`3jV_oooooo0?ZJ00;ooooo00So0?ZJooooooooooooooooo`3jV_oooooo0000o`3j
VP;ooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0003ooooo00;o0?ZJ0_l00003o`3jVP03ooooool0nY[o
oooo00Wooooo0_l0000Dooooo`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool00_l00019
ooooo`?o00002Oooool01?l0003oooooooooool00008ooooo`04o`3jV_l00?oo003oo`00oa7ooooo
1?l00?l00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00?ooooo1Ol0nYX:ooooo`;o0?ZJ
0_ooool00ol0nY[oooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
9oooool002oooooo00?o0000ooooool000003?ooool01Ol0003ooooooooooooooooo000000gooooo
00Oo0000oooooooooooo0?ZJooooool0nY[ooooo00;o0?ZJ00?oooooo`3jV_ooool0H_ooool01ol0
nY[o0000ooooool00?oo0?ZJo`000?ooool00_l0nYX4ooooo`05o`3jV_l00?oo0?ZJo`000?ooool0
0_l0nYX2ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00So0?ZJooooool0003o0?ZJooooool0nY[o
0000o`3jVP;ooooo00Go0?ZJo`000?ooooooooooo`3jVP02o`0000?o0?ZJ00?oooooo`3jV_ooool0
2_ooool00ol0003oooooooooo`0Booooo`;o00001_ooool00ol0nY[oooooooooo`02o`0004[ooooo
0_l00009ooooo`04o`000?ooooooooooo`0000Sooooo00?o0?ZJooooooooool05Oooool00ol00?oo
0?ZJooooo`06ooooo`?o0?ZJ0oooool5o`3jVP03ooooool0nY[ooooo00Wooooo00?o0?ZJoooooooo
ool04Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02Oooooo000`ooooo`;o0000
2?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04?ooool4o`3jVP03
ooooool0nY[ooooo06;ooooo00Oo0?ZJo`00ool00?oo003oo`3jV_oooooo000000;o0?ZJ1?ooool0
1Ol0nY[o003oo`3jV_l0003ooooo00;o0?ZJ00?oooooo`000?l0nYX00_ooool03?l0nY[ooooooooo
ool0003o0?ZJooooool0003o0?ZJooooool0nY[o0000o`3jVP;ooooo00Go0?ZJooooool0003ooooo
o`3jVP02o`0000?o0?ZJ00?oooooo`3jV_ooool02_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Gooooo00?o0?ZJooooooooool0C_ooool00ol0003oooooooooo`06ooooo`;o0000
00?oooooo`000?ooool01oooool00ol0nY[oooooooooo`0Eooooo`03o`00ool0nY[ooooo00Gooooo
00Go0?ZJoooooooooooo0?ZJooooo`02o`3jVPKooooo00?o0?ZJooooooooool00_ooool3o`3jVP?o
oooo00?o0?ZJooooooooool04Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02Oo
oooo000aooooo`03o`000?oooooooooo00Kooooo1Ol00003ooooo`;o00004_ooool2o`3jVP03oooo
ool0nY[o0?ZJ06?ooooo00Oo0?ZJo`000?ooooooooooo`3jV_oooooo000000;o0?ZJ1?ooool01Ol0
nY[o003oo`3jV_l0003ooooo00;o0?ZJ00?oooooo`000?l0nYX00_ooool01ol0nY[oooooooooool0
003o0?ZJooooool000000_l0nYX00ooooooo0000o`3jVP04ooooo`06o`000?oooooo0?ZJo`000?l0
nY[o003o0_l0nYX00ooooooo0?ZJooooo`09ooooo`;o00000_ooool2o`0000Cooooo00?o0000oooo
ooooool00_ooool3o`0000Cooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`1>oooo
o`03o`000?oooooooooo00Cooooo00Ko0000ooooool0003o0000ooooool00008ooooo`03o`3jV_oo
oooooooo01Gooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`02o`3jVPWooooo00?o
0?ZJooooool0nYX00_l0nYX01?oooooo0?ZJooooooooool2o`3jVQ?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0Wooooo`00@_ooool00ol0003oooooooooo`0Eooooo`03o`3jV_oo
oooooooo06;ooooo00Ko0?ZJoooooooooooo0?ZJooooool00002o`3jVP;ooooo00Oo0?ZJooooool0
nY[o003oo`3jV_l0003ooooo00;o0?ZJ00?oooooo`000?l0nYX00_l00?l01ol0nY[oooooooooool0
003o0?ZJooooool000000_l0nYX00ol0003oooooo`3jVP04ooooo`08o`000?oooooo0?ZJo`000?l0
nY[o003oo`3jV_ooool2o`3jVP_ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`05
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`02ooooo`04o`3jV_oo
oooo0?ZJo`3jVU3ooooo00?o0000ooooooooool01?ooool2o`000004ooooool0003o0000o`0000So
oooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`07ooooo`03o`00ool0nY[ooooo00Co
oooo00?o0?ZJooooooooool03?ooool2o`3jVPGooooo0ol0nYXDooooo`03o`000?l00?oo003o00?o
oooo00?o0000ooooooooool09oooool004;ooooo00?o0000ooooooooool0N_ooool01_l0nY[ooooo
ooooool0nY[oooooo`0000;o0?ZJ00Woooooo`3jV_l0nY[o0?ZJo`000?l00?oo0?ZJo`000?ooool0
0_l0nYX00ooooooo0000o`3jVP02o`00o`03o`3jV_l0003ooooo00;o0?ZJ00Ooooooo`000?l0nY[o
0?ZJo`000?oooooo0?ZJ00Cooooo0_l000001_l0nY[o0000o`3jV_l00?oo0?ZJooooo`;o0?ZJ2ooo
ool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooooooooooo
o`000004ooooo`;o0?ZJ00?oooooo`3jV_ooool0Coooool2o`0000Gooooo0_l000001?oooooo0000
o`000?l00008ooooo`03o`3jV_oooooooooo00_ooooo1?l0nYX6ooooo`03o`00ool0nY[ooooo00?o
oooo0_l0nYX>ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool04oooool00ol0003o
ooooo`00o`04ooooo`03o`000?oooooooooo02Oooooo0012ooooo`;o0000Noooool01_l0nY[ooooo
ooooool0nY[oooooo`0000;o0?ZJ00Woooooo`3jV_l0nY[o0?ZJo`000?l00?oo0?ZJo`000?ooool0
0_l0nYX00ooooooo0000o`3jVP02ooooo`03o`3jV_l0003ooooo00?o0?ZJ00Ko0000o`3jV_l0nY[o
0000ooooool0nYX4ooooo`;o00000_l0nYX00ooooooo003oo`3jVP02ooooo`03o`3jV_oooooooooo
00Sooooo0_l000001Ooooooo0000oooooooooooo000000Wooooo0_l00004ooooo`;o0000Eoooool4
o`0000?ooooo00?o0000ooooooooool00_l000000ooooooo0000ooooo`06ooooo`03o`3jV_oooooo
oooo00_ooooo00Co0?ZJoooooooooooo0?ZJ1_ooool01?l00?oo0?ZJooooooooool2o`3jVRgooooo
00?o0000ooooool00?l00oooool2o`0002Wooooo0012ooooo`03o`000?oooooooooo07[ooooo00Ko
0?ZJoooooooooooo0?ZJooooool00002o`3jVP0:ooooool0nY[o0?ZJo`3jV_l0003o003oo`3jV_oo
oooo0000o`3jVP;o000000Oo003oo`3jV_ooooooooooo`3jV_l0003ooooo00?o0?ZJ00Koooooo`3j
V_l0nY[o0000ooooool0nYX4ooooo`;o00000_l0nYX00ooooooo003oo`3jVP0>ooooo`03o`000?oo
oooo000000;ooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000005Wooooo
0ol00003ooooo`07o`000?ooooooooooooooool0003oooooo`000007ooooo`03o`3jV_oooooooooo
00_ooooo00Co0?ZJoooooooooooo0?ZJ1_ooool01Ol00?oo0?ZJoooooooooooo0?ZJ02gooooo0_l0
00000ooooooo003oooooo`03ooooo`03o`000?oooooooooo02Oooooo0012ooooo`03o`000?oooooo
oooo07[ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0003o0?ZJooooo`03o`3jVP06o`000?l0
nY[oooooooooool0003o0?ZJ0_l000001Ol00?oo0?ZJoooooooooooo0?ZJ00;o00000ol0nYX01_oo
oooo0?ZJo`000?l0003oooooo`3jVPCooooo0_l00002o`3jVP03ooooool00?oo0?ZJ00kooooo00?o
0000ooooool000000_ooool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooooooool00000
0oooool00ol0003oooooooooo`1Gooooo`?o00000oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00Gooooo00?o0?ZJooooooooool02?ooool01?l0nY[oooooo`3jV_l0nYX3ooooo`03
o`3jV_oooooooooo00Cooooo0ol0nYX2ooooo`03o`000?oooooooooo02Cooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00?l4ooooo`03o`000?oooooooooo02Oooooo0012ooooo`;o
0000Noooool01?l0nY[oooooooooool0nYX2ooooo`04o`000?l0nY[o0?ZJooooo`;o0?ZJ00Kooooo
o`3jV_ooooooooooo`000?l0nYX2o`00o`05ooooool0nY[oooooooooool0nYX00_l00003o`3jVP03
ooooool0nY[o000000;ooooo00?o0?ZJooooooooool00_ooool2o`0000;o0?ZJ00?oooooo`00ool0
nYX03Oooool2o`0000;ooooo0_l00009ooooo`?o00001?ooool00ol0003oooooooooo`1Gooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05oooo
o`03o`3jV_oooooooooo00Sooooo1?l0nYX3ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX3oooo
o`03o`000?oooooooooo027ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`04o`000?oo
ooooooooo`00o`Cooooo00?o0000ooooooooool09oooool004;ooooo00?o0000ooooooooool0Nooo
ool00ol0nY[oooooo`3jVP02ooooo`04o`000?l0nY[o0?ZJooooo`;o0?ZJ00Koooooo`3jV_oooooo
ooooo`000?l0nYX2o`000005ooooool0nY[oooooooooool0nYX00_l00002o`3jVP07ooooool0nY[o
0?ZJo`00oooooooo003oo`3jVP04ooooo`;o00000_l0nYX00ooooooo003oo`3jVP0>ooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0Eoooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01?ooool01?l0nY[oooooooooooooool2o`00
02?ooooo00Go0000oooooooooooo0000ooooo`03o`0000?ooooo00?o003oooooooooool00_ooool0
0ol0003oooooooooo`0Wooooo`00@_ooool00ol0003oooooooooo`1looooo`;o0?ZJ0_ooool02?l0
003o0?ZJo`3jV_oooooo0?ZJo`000?oooooo0?ZJ0_ooool01_l0003o0?ZJo`000?l0003oooooo`3j
VP;ooooo00?o0?ZJo`000?l000000_l0nYX00ooooooo0?ZJo`3jVP02o`00o`03ooooool0nY[ooooo
00?ooooo0_l00002o`3jVP03ooooool0nY[ooooo00kooooo00?o0000ooooooooool04_ooool2o`00
05_ooooo00Co0000oooooooooooo00001_ooool00ol0003oooooooooo`04ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool01?ooool4o`3jVP?ooooo00Co0?ZJoooooooooooooooo0_l0
0002ooooo`03o`000?oooooooooo01gooooo0ol000000ooooooo0000o`000003o`0000?ooooo00?o
003oooooooooool00_ooool00ol0003oooooooooo`0Wooooo`00:_ooool3o`0000?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`02ooooo`?o00001?ooool2o`0007kooooo00Go0?ZJ
oooooooooooo0000o`3jVP02ooooo`04o`3jV_l0003oooooo`3jVP;ooooo0_l000000ol0nY[ooooo
ooooo`02o`3jVP04ooooool0nY[o0000o`0000;o0?ZJ0_ooool01Ol0nY[o0000oooooooooooo0?ZJ
00Cooooo0_l000001?l0nY[oooooooooool0nYX>ooooo`;o00005?ooool00ol0003oooooooooo`1J
ooooo`04o`000?oooooo0000o`0000Kooooo00?o0000ooooooooool01?ooool00ol0nY[ooooooooo
o`07ooooo`03o`3jV_oooooooooo00Sooooo00Go0?ZJooooooooooooooooo`00o`03ooooo`;o0000
00?oooooo`00ool00?l00_l00?lMooooo`03o`000?oooooo000000?o00000_ooool00ol0003ooooo
o`00o`02o`00o`Cooooo00?o0000ooooooooool09oooool002_ooooo00?o0000ooooooooool02?oo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000022ooooo`05
o`000?l0nY[oooooooooool0nYX00_l00?l00ol0nY[oooooooooo`02o`000003o`3jV_oooooooooo
00;o0?ZJ00Koooooo`3jV_l0003o0?ZJo`00ool0nYX2ooooo`05o`3jV_ooooooooooooooool0nYX0
1?ooool2o`000004o`3jV_ooooooooooo`3jVPoooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`1Kooooo`?o00001_ooool01?l0003oooooo`000?l00003ooooo`03o`3jV_oooooooooo
00Oooooo00?o0?ZJooooooooool02?ooool01Ol0nY[ooooooooooooooooo003o00?ooooo00Co0000
ooooool0003o003o0_l000000ol00?ooooooooooo`0Kooooo`07o`000?oooooo0000o`000?oooooo
0000ooooo`04o`00o`Kooooo00?o0000ooooooooool09oooool002Sooooo1Ol0000:ooooo`03o`00
0?oooooooooo00Cooooo00Go0000ooooooooooooooooo`000022ooooo`05o`000?l0nY[ooooooooo
ool0nYX00_ooool00ol0nY[oooooooooo`02o`00000;o`3jV_oooooo0?ZJooooool0nY[oooooo`3j
V_l0003o0?ZJo`00ool0nYX00oooool01?l0nY[oooooooooool0nYX4ooooo`;o000000Co0?ZJo`00
ool00?oo0?ZJ3oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo05_ooooo0_l00008
ooooo`?o00000oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Sooooo00Go0?ZJ
ooooooooooooooooo`00o`02ooooo`08o`000?ooooooooooo`00ool0003oooooo`000?l00?l3oooo
o`Co003o00?oooooo`00ool00?l03_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
o`000?ooool00_l00?l:ooooo`03o`000?oooooooooo02Oooooo000Xooooo`04o`000?oooooooooo
o`0000_ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooooooool2o`0008;ooooo00Co
0?ZJo`000?oooooo0?ZJ0_ooool04?l0nY[oooooooooool0003oooooo`3jV_oooooo0?ZJooooool0
nY[oooooo`3jV_l0003o0?ZJo`00ool0nYX3ooooo`04o`3jV_ooooooooooo`3jVPCooooo0_l00000
1?l0nY[oooooo`00ool0nYX>ooooo`;o00005?ooool00ol0003oooooooooo`1Looooo`03o`000?oo
oooooooo00Kooooo0ol00003ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJoooooooooooo0?ZJ
2_ooool01?l0nY[oooooooooooooool7o`00o`03o`000?oooooo000000Co003o0oooool4o`00o`co
oooo0_l00?l00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o003ooooooooo
ool02Oooool00ol0003oooooooooo`0Wooooo`00:Oooool00ol0003oooooo`00000<ooooo`03o`00
0?oooooo000000?o00001?ooool00ol0003oooooooooo`21ooooo`03o`3jV_l0003ooooo00;o0?ZJ
00_oooooo`3jV_ooooooooooo`000?oooooo0?ZJooooool0nY[oooooo`000002o`3jVP04o`000?l0
nY[o003oo`3jVP?ooooo00Co0?ZJoooooooooooo0?ZJ1Oooool01Ol0003o0?ZJoooooooooooo0?ZJ
00oooooo00?o0000ooooooooool04_ooool2o`0005gooooo00?o0000ooooooooool01_ooool3o`00
00?ooooo00?o0?ZJo`000?ooool01?ooool3o`3jVP;o00001Oooool01?l0003oooooooooooooool4
o`3jVP04ooooool0003o0000o`0000;ooooo0_l00002ooooo`04o`000?ooooooooooo`0000Kooooo
00?o003oooooooooool02?ooool3o`00o`03o`000?l00?oo003o00;o003o00?o0000o`00ool00?l0
0oooool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo02Oooooo000Zooooo`;o00002?oo
ool01ol0003ooooooooooooooooo0000ooooool000001oooool00ol0003oooooooooo`21ooooo`03
o`3jV_l0003o003o00;o0?ZJ00?oooooo`3jV_ooool00oooool01Ol0nY[oooooo`3jV_oooooo0000
00?o0?ZJ00?oooooo`00ool0nYX00oooool01?l0nY[oooooooooool0nYX5ooooo`05o`000?l0nY[o
ooooooooool0nYX03oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo06Gooooo0ol0
0003ooooo`03o`3jV_l0003ooooo00Cooooo00?o0?ZJooooool000000_l00003ooooo`03o`000?oo
oooo000000Gooooo00?o0000o`3jV_ooool00ol00003ooooo`04o`000?ooooooooooo`0000;ooooo
0_l00006ooooo`03o`00oooooooooooo00;ooooo0_l00?l3ooooo`07o`00ooooooooooooo`000?l0
0?oo0000ooooo`04o`00o`?ooooo00?o003oooooooooool02Oooool00ol0003oooooooooo`0Woooo
o`00:oooool00ol0003oooooooooo`06ooooo`Go000000?oooooo`000?l000000ol00003ooooo`;o
0000P_ooool00ol0nY[o003oo`00o`02o`3jVP03ooooool0nY[ooooo00Cooooo0_l0nYX00ooooooo
0000ooooo`02o`3jVP03ooooool0nY[ooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ1Oooool01Ol0
003oooooo`3jV_oooooo0?ZJ00kooooo0_l0000Dooooo`03o`000?oooooooooo06Sooooo00Go0000
oooooooooooo0?ZJo`000005ooooo`04o`3jV_oooooo0000ooooo`;o000000?oooooo`000?l00000
0_l00005ooooo`04o`000?l0nY[oooooo`0000Sooooo00?o0000ooooooooool00_l00006ooooo`Go
003o00?oooooo`00ooooool00_ooool01ol00?ooooooooooool0003oooooo`000?ooool00ol00000
0ooooooo003oo`00o`02o`00o`_ooooo00?o0000ooooooooool09oooool004;ooooo00?o0000oooo
ooooool0POooool00ol0nY[o003oooooo`02o`3jVP03ooooool0nY[ooooo00Cooooo0_l0nYX00ooo
oooo0000ooooo`02o`3jVP03ooooool0nY[ooooo00?ooooo00Co0?ZJoooooooooooo0?ZJ1oooool0
0ol0nY[oooooo`3jVP0?ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0J?ooool0
1Ol0003oooooooooool0nY[o000000Gooooo00?o0?ZJooooool000000_ooool00ol0003oooooo`00
0003o`0000Gooooo0_l000000ol0nY[o0000ooooo`07ooooo`03o`000?oooooooooo00;o00003Ooo
ool4o`00o`03ooooool0003ooooo00;ooooo0_l00003ooooo`;o003o3Oooool00ol0003ooooooooo
o`0Wooooo`00@_ooool00ol0003oooooooooo`21ooooo`03o`3jV_oooooooooo00;o0?ZJ00?ooooo
o`3jV_ooool01?ooool2o`3jVP03ooooool0003ooooo00;o0?ZJ00?oooooo`3jV_ooool01?ooool0
0ol0nY[oooooo`3jVP07ooooo`03o`3jV_oooooo0?ZJ00oooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`1Xooooo`05o`000?ooooooooooo`3jV_l000001Oooool00ol0nY[oooooo`00
0002ooooo`Go000000?oooooo`000?ooool00_ooool3o`000003o`3jV_oooooooooo00Oooooo00Go
0000ooooool0003oooooo`00000Booooo`04o`000?ooooooooooooooo`;o00004_ooool00ol0003o
ooooooooo`0Wooooo`00@_ooool2o`0008;ooooo00?o0?ZJooooooooool00_l0nYX00ooooooo0?ZJ
ooooo`05ooooo`04o`3jV_oooooo0000ooooo`;o0?ZJ00?oooooo`3jV_ooool01?ooool00ol0nY[o
ooooo`3jVP07ooooo`03o`3jV_oooooo0?ZJ00kooooo0_l0000Dooooo`;o0000JOooool01Ol0003o
ooooo`000?l0nY[o000000Gooooo00?o0?ZJooooool000000oooool4o`000004ooooool0003ooooo
ooooo`Co000000?o0?ZJooooooooool01oooool01Ol0003oooooo`000?oooooo000001;ooooo00Go
0000ooooooooooooooooo`00000Cooooo`03o`000?oooooooooo02Oooooo0012ooooo`03o`000?oo
oooooooo087ooooo00Go0?ZJoooooooooooo0?ZJooooo`02o`3jVPKooooo00Go0?ZJooooool0003o
ooooo`3jVP02ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX7ooooo`03o`3jV_oooooo0?ZJ00oo
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`1Xooooo`05o`000?oooooo0000o`3j
V_l000001?ooool01?l0003o0?ZJo`000?l00003ooooo`03o`000?oooooo000000;ooooo00?o0000
ooooooooool00_l000000ooooooo0000o`000002o`3jVPCooooo00Co0?ZJoooooooooooooooo0_l0
00000ooooooo0000ooooo`0Aooooo`05o`000?ooooooooooooooool000004oooool00ol0003ooooo
ooooo`0Wooooo`00@_ooool00ol0003oooooooooo`21ooooo`05o`3jV_ooooooooooo`3jV_ooool0
0_l0nYX8ooooo`;o000000Co0?ZJoooooooooooo0?ZJ1_ooool2o`3jVPOooooo00?o0?ZJooooool0
nYX03oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo06Sooooo00Go0000ooooool0
003o0?ZJo`000002ooooo`Co0?ZJ0_l00009ooooo`03o`000?oooooo000000;ooooo0_l00002oooo
o`04o`3jV_ooooooooooooooo`Co0?ZJ0_l000000ooooooo0000ooooo`0@ooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool09oooool004;ooooo0_l00022ooooo`05o`3jV_oooooooooo
o`3jV_ooool00_l0nYX9ooooo`05o`000?l0nY[o003oo`00ool0nYX01oooool00ol0nY[ooooooooo
o`06ooooo`;o0?ZJ3_ooool2o`0001Cooooo00?o0000ooooooooool0JOooool2o`000009o`3jV_oo
oooo0000ooooool0nY[oooooo`000?oooooo000000[ooooo0ol00003ooooo`03o`000?oooooooooo
00Co0?ZJ0oooool01ol0nY[o0000oooooooooooo0000ooooool000003oooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo02Oooooo0012ooooo`03o`000?oooooooooo08;ooooo00?o0?ZJ
ooooool0nYX00_ooool00ol0nY[oooooooooo`08ooooo`04o`3jV_oooooo003oo`3jVQ3ooooo0_l0
nYX?ooooo`03o`000?oooooooooo01;ooooo0_l0001[ooooo`03o`000?l0nY[ooooo00;o000000Go
0?ZJooooool0003oooooo`00000:ooooo`;o00001?ooool01ol0003ooooooooooooooooo0?ZJoooo
ool0nYX00oooool00ol0nY[o0000ooooo`02ooooo`;o00003oooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo02Oooooo0012ooooo`03o`000?oooooooooo08;ooooo00?o0?ZJooooool0
nYX00_ooool00ol0nY[oooooooooo`08ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo0_l0nYX?oooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0Joooool02Ol0nY[oooooo`000?l0003o
0?ZJooooool0003oooooo`00000:ooooo`;o00003_ooool00ol0nY[oooooooooo`02ooooo`;o0000
0_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool0
0_ooool00ol0003oooooooooo`0Wooooo`00<?ooool3o`0000?ooooo00?o0000ooooooooool00_oo
ool3o`0000Cooooo0_l00023ooooo`03o`3jV_oooooo0?ZJ00kooooo00?o0?ZJooooool0nYX04Ooo
ool00ol0nY[oooooooooo`0<ooooo`;o00005?ooool00ol0003oooooooooo`1[ooooo`06o`3jV_oo
oooo0000ooooool0nY[o00003_ooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooo0?ZJ00Co
0?ZJ0ol0000<ooooo`03o`000?oooooooooo017ooooo0_l0nYX3ooooo`03o`000?oooooooooo02Oo
oooo000aooooo`03o`000?oooooooooo00Kooooo00Go0000ooooooooooooooooo`000003ooooo`03
o`000?oooooooooo08;ooooo00?o0?ZJooooool0nYX03_ooool00ol0nY[oooooo`3jVP0Aooooo`03
o`3jV_oooooooooo00gooooo00?o0000ooooooooool00_l00004ooooo`03o`000?oooooooooo00?o
oooo0ol00003ooooo`03o`000?oooooooooo06_ooooo00Co0?ZJoooooooooooo0?ZJ0_l0000Noooo
o`07o`3jV_ooooooooooooooool0nY[o0000o`3jVP02o`000003ooooool0003ooooo00Oooooo0_l0
000Dooooo`03o`3jV_oooooooooo00;ooooo00?o0000ooooooooool09oooool002kooooo1Ol00007
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`23ooooo`;o0?ZJ3_oo
ool00ol0nY[oooooo`3jVP0Qooooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06_ooooo00Ko0?ZJoooooooooooo0?ZJ
ooooool0000Rooooo`03o`000?oooooo0?ZJ00?o0?ZJ0_l00007ooooo`;o00005?ooool00ol0nY[o
ooooooooo`02ooooo`03o`000?oooooooooo02Oooooo000^ooooo`04o`000?ooooooooooo`0000Wo
oooo0ol00004ooooo`;o0000Q?ooool2o`3jVPkooooo00?o0?ZJooooool0nYX08?ooool2o`000005
ooooool0003oooooooooool000001oooool5o`0000?ooooo0_l0001/ooooo`04o`3jV_oooooooooo
o`3jVRCooooo00?o0000ooooooooool00_ooool01?l0nY[o0000o`000?l00002ooooo`04o`000?oo
ooooooooooooo`;o00005?ooool01?l0nY[oooooooooooooool2o`0002Wooooo000_ooooo`03o`00
0?oooooo000000Sooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo08Co
oooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooo`3jVP0Qooooo`03o`000?oooooo000000;o
oooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo
06_ooooo00Co0?ZJoooooooooooo0?ZJ:Oooool00ol0003o0?ZJo`000005o`0000;ooooo0_l0000D
ooooo`03o`3jV_oooooooooo00;ooooo00?o0000ooooooooool09oooool0033ooooo0_l00008oooo
o`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`2Cooooo`03o`3jV_oooooo
0?ZJ027ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
000000Cooooo00?o0000ooooooooool0Joooool01?l0nY[oooooo`3jV_l0nYXZooooo`;o0?ZJ00So
0000o`3jV_ooooooooooo`3jV_l0003oooooo`0000Co0?ZJ4Oooool00ol0nY[oooooooooo`02oooo
o`03o`000?oooooooooo02Oooooo000aooooo`03o`000?oooooooooo00Oooooo0ol00004ooooo`;o
0000U?ooool00ol0nY[oooooo`3jVP0Pooooo`;o000000Goooooo`000?ooooooooooo`000009oooo
o`;o00001?ooool00ol0003oooooooooo`1/ooooo`03o`3jV_oooooooooo02[ooooo2?l0nYX01_oo
oooo0000o`3jV_oooooo0?ZJooooo`Co0?ZJ3Oooool00ol0nY[oooooooooo`02ooooo`03o`000?oo
oooooooo02Oooooo0012ooooo`03o`000?oooooooooo09Cooooo0_l0nYXQooooo`03o`000?oooooo
oooo00;o00002oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0:3ooooo1?l0nYX4
ooooo`03o`3jV_oooooo0?ZJ00Kooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0000ooooooooool09oooool004;ooooo00?o0000ooooooooool0U?ooool2
o`3jVR7ooooo00?o0000ooooooooool04_ooool2o`000:_ooooo00?o0?ZJooooooooool01?ooool8
o`3jVPCooooo00?o0000ooooooooool09oooool004;ooooo0_l0002Fooooo`03o`3jV_oooooooooo
01kooooo0_l0000Dooooo`03o`000?oooooooooo0:[ooooo00Co0?ZJooooool0nY[o0?ZJ0oooool0
1?l0nY[oooooooooool0nYX8ooooo`03o`000?oooooooooo02Oooooo0012ooooo`03o`000?oooooo
oooo09Gooooo00?o0?ZJooooooooool07oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo0:_ooooo0ol0nYX3ooooo`03o`3jV_oooooooooo00Wooooo00?o0000ooooooooool09oooool0
04;ooooo00?o0000ooooooooool0]oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
0:kooooo00Co0?ZJoooooooooooo0?ZJ2oooool00ol0003oooooooooo`0Wooooo`00@_ooool2o`00
00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo0000
o`0001Cooooo00?o0000ooooooooool0[_ooool4o`3jVP_ooooo00?o0000ooooooooool09oooool0
04;ooooo^ol0000Dooooo`;o0000__ooool00ol0003oooooooooo`0Wooooo`00oooooolBooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00000Yooooo`00
oooooolBoooool7o0000:Oooool00?ooooooo?ooool00?ooooooo?ooool00?ooooooo?ooool00?oo
ooooo?ooool00?ooooooo?ooool00?ooooooo?ooool00?ooooooo?ooool00?ooooooo?ooool00?oo
ooooo?ooool00?ooooooo?ooool00??ooooo00?o0000ooooooooool0ooooool6ooooo`00m?ooool0
0ol0003oooooooooo`3oooooo`Gooooo003Oooooo`?o00000oooool5o`000004ooooool0003o0000
o`0000Kooooo00?o0000ooooooooool01_ooool3o`000004ooooool0003o0000ooooo`Co000000?o
ooooo`000?l000000ol00003ooooo`;o00001?ooool2o`000>;ooooo003Pooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`04o`000?oooooo
ooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`000>7ooooo003Pooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`0?ooooo`04o`000?ooooooooooo`0000;ooooo1?l00003oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
003Qooooo`00h?ooool3o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000oooooo00Co0000
oooooooooooo00002_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`3Oooooo`00h?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool03_ooool4o`0000Sooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000hOooool0
0>3ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0001Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo0000hOooool00=oooooo1Ol000000ooooooo0000o`000003o`000003
ooooool0003o000000?o00006_ooool3o`0000Cooooo0_l00004ooooo`;o0000h_ooool00?oooooo
o?ooool00?ooooooo?ooool00001\
\>"],
  ImageRangeCache->{{{0, 506.625}, {155.875, 0}} -> {-0.188784, -0.0154542, \
0.00469296, 0.00469296}, {{40.1875, 253.312}, {152.562, 20.875}} -> {-130.93, \
4.39407, 1.96851, 0.00331998}, {{253.312, 466.375}, {152.562, 20.875}} -> \
{-554.822, -0.0951237, 1.99366, 0.00403194}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{" ", 
      StyleBox[\( (*\ Mathlink\ c - code\ not\ released\ *) \),
        FontColor->RGBColor[1, 0, 0]], 
      StyleBox["\[IndentingNewLine]",
        FontColor->RGBColor[1, 0, 0]], 
      StyleBox["\[IndentingNewLine]",
        FontColor->RGBColor[1, 0, 0]], 
      RowBox[{\(SetDirectory["\</Mathematica/MathLink6.0/DeveloperKit/Hermann/\
hermann.mathlink.X/build/Development/\>"]\), 
        StyleBox["\[IndentingNewLine]",
          FontColor->RGBColor[1, 0, 0]], \(link = 
          Install["\<hermann.mach\>"]\)}]}]], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \("/Mathematica/MathLink6.0/DeveloperKit/Hermann/hermann.mathlink.X/build/\
Development"\)], "Output",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(link\\)\\\" is similar to existing symbols \
\\!\\({lik, lin}\\). \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \(LinkObject["./hermann.mach", 2, 2]\)], "Output",
  PageWidth->Infinity,
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "dt", ",", "k", ",", "p", ",", "q", ",", "r", ",", "u", ",", "T", ",", 
        "TT", ",", 
        StyleBox["10000",
          FontColor->RGBColor[0, 1, 0]]}], "}"}]], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \({0.0027397260273972603`, 1, 2, 1, 2, 4, 365, 7, 10000}\)], "Output",
  PageWidth->Infinity,
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"\n", 
      RowBox[{
        RowBox[{
          RowBox[{\({cYF, clik}\), "=", 
            RowBox[{"cFunctionalFilter", "[", 
              
              RowBox[{\({logZM, X}\), 
                ",", \({ .07, \(-1. \),  .2,  .2, 10^\(-8\)}\), ",", "  ", 
                "\[IndentingNewLine]", 
                "                                                             \
             ", 
                RowBox[{"{", 
                  RowBox[{\({cf, cg, ch, cDh, cR, cp0}\), ",", 
                    RowBox[{"{", 
                      RowBox[{
                      "dt", ",", "k", ",", "p", ",", "q", ",", "r", ",", "u", 
                        ",", "T", ",", "TT", ",", 
                        StyleBox["10000",
                          FontColor->RGBColor[0, 1, 0]]}], "}"}]}], "}"}], 
                ",", "      ", "\[IndentingNewLine]", 
                "                                                             \
            ", \({{1, 0, 0, 0, 0}, {{{0}}}, CSEED, \(-9. \), 3}\)}], "]"}]}], 
          ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]"}]}]], "Input",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(clik\\)\\\" is similar to existing symbol \\\
\"\\!\\(lik\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity,
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
SetOptions[plot1,dicke->.007];

{m,s}=cYF//Transpose;
KI=m~ii~(m+s)~ii~(m-s);

gFIF10000=DisplayTogetherArray[

DisplayTogether[
\tplot1[Log[Column[Y,{1}]]~ii~Column[KI,{1,3,5}]//AddTimeAxis,color->{10,1,2,\
2}],
\tplot1[Column[KI,{1,3,5}  \
]//AddTimeAxis,PlotRange->{{0,366},All},color->{1,2,2},permute->{3,2,1}]
\t],

DisplayTogether[      
\tplot1[Column[Y,{2}]//AddTimeAxis,color->10,
\t      DisplayFunction->Identity],\t\t\t
\tplot1[Column[KI,{1,3,5}+1]//AddTimeAxis,PlotRange->{{0,366},All},
\t      color->{1,2,2},DisplayFunction->Identity]
\t]
,PlotLabel->\"FIF, n=10000\"];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 5}\),
      SequenceForm[ "Dimension der Daten  ", {366, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 4}\),
      SequenceForm[ "Dimension der Daten  ", {366, 4}],
      Editable->False]], "Print",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 2}\),
      SequenceForm[ "Dimension der Daten  ", {366, 2}],
      Editable->False]], "Print",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{366, 4}\),
      SequenceForm[ "Dimension der Daten  ", {366, 4}],
      Editable->False]], "Print",
  PageWidth->Infinity,
  FontSize->14],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -38 0 ]
[.5 .32152 38 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(FIF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(n) show
99.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10000) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -7.35025 1.64751 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06354 -18 -4.5 ]
[-0.0125 .06354 0 4.5 ]
[-0.0125 .14592 -24 -4.5 ]
[-0.0125 .14592 0 4.5 ]
[-0.0125 .22829 -18 -4.5 ]
[-0.0125 .22829 0 4.5 ]
[-0.0125 .31067 -24 -4.5 ]
[-0.0125 .31067 0 4.5 ]
[-0.0125 .39304 -18 -4.5 ]
[-0.0125 .39304 0 4.5 ]
[-0.0125 .47542 -24 -4.5 ]
[-0.0125 .47542 0 4.5 ]
[-0.0125 .55779 -18 -4.5 ]
[-0.0125 .55779 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .32036 -5 -6 ]
[.97619 .32036 5 6 ]
[.97619 .32833 -5 -6 ]
[.97619 .32833 5 6 ]
[.97619 .35894 -5 -6 ]
[.97619 .35894 5 6 ]
[.97619 .29772 -5 -6 ]
[.97619 .29772 5 6 ]
[.97619 .29772 -5 -6 ]
[.97619 .29772 5 6 ]
[.97619 .35894 -5 -6 ]
[.97619 .35894 5 6 ]
[.97619 .32833 -5 -6 ]
[.97619 .32833 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06354 m
.00625 .06354 L
s
[(4.5)] -0.0125 .06354 1 0 Mshowa
0 .14592 m
.00625 .14592 L
s
[(4.55)] -0.0125 .14592 1 0 Mshowa
0 .22829 m
.00625 .22829 L
s
[(4.6)] -0.0125 .22829 1 0 Mshowa
0 .31067 m
.00625 .31067 L
s
[(4.65)] -0.0125 .31067 1 0 Mshowa
0 .39304 m
.00625 .39304 L
s
[(4.7)] -0.0125 .39304 1 0 Mshowa
0 .47542 m
.00625 .47542 L
s
[(4.75)] -0.0125 .47542 1 0 Mshowa
0 .55779 m
.00625 .55779 L
s
[(4.8)] -0.0125 .55779 1 0 Mshowa
.125 Mabswid
0 .08002 m
.00375 .08002 L
s
0 .09649 m
.00375 .09649 L
s
0 .11297 m
.00375 .11297 L
s
0 .12944 m
.00375 .12944 L
s
0 .16239 m
.00375 .16239 L
s
0 .17887 m
.00375 .17887 L
s
0 .19534 m
.00375 .19534 L
s
0 .21182 m
.00375 .21182 L
s
0 .24477 m
.00375 .24477 L
s
0 .26124 m
.00375 .26124 L
s
0 .27772 m
.00375 .27772 L
s
0 .29419 m
.00375 .29419 L
s
0 .32714 m
.00375 .32714 L
s
0 .34362 m
.00375 .34362 L
s
0 .36009 m
.00375 .36009 L
s
0 .37657 m
.00375 .37657 L
s
0 .40952 m
.00375 .40952 L
s
0 .42599 m
.00375 .42599 L
s
0 .44247 m
.00375 .44247 L
s
0 .45894 m
.00375 .45894 L
s
0 .49189 m
.00375 .49189 L
s
0 .50837 m
.00375 .50837 L
s
0 .52484 m
.00375 .52484 L
s
0 .54132 m
.00375 .54132 L
s
0 .04707 m
.00375 .04707 L
s
0 .03059 m
.00375 .03059 L
s
0 .01412 m
.00375 .01412 L
s
0 .57427 m
.00375 .57427 L
s
0 .59074 m
.00375 .59074 L
s
0 .60722 m
.00375 .60722 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06354 m
1 .06354 L
s
.99375 .14592 m
1 .14592 L
s
.99375 .22829 m
1 .22829 L
s
.99375 .31067 m
1 .31067 L
s
.99375 .39304 m
1 .39304 L
s
.99375 .47542 m
1 .47542 L
s
.99375 .55779 m
1 .55779 L
s
.125 Mabswid
.99625 .08002 m
1 .08002 L
s
.99625 .09649 m
1 .09649 L
s
.99625 .11297 m
1 .11297 L
s
.99625 .12944 m
1 .12944 L
s
.99625 .16239 m
1 .16239 L
s
.99625 .17887 m
1 .17887 L
s
.99625 .19534 m
1 .19534 L
s
.99625 .21182 m
1 .21182 L
s
.99625 .24477 m
1 .24477 L
s
.99625 .26124 m
1 .26124 L
s
.99625 .27772 m
1 .27772 L
s
.99625 .29419 m
1 .29419 L
s
.99625 .32714 m
1 .32714 L
s
.99625 .34362 m
1 .34362 L
s
.99625 .36009 m
1 .36009 L
s
.99625 .37657 m
1 .37657 L
s
.99625 .40952 m
1 .40952 L
s
.99625 .42599 m
1 .42599 L
s
.99625 .44247 m
1 .44247 L
s
.99625 .45894 m
1 .45894 L
s
.99625 .49189 m
1 .49189 L
s
.99625 .50837 m
1 .50837 L
s
.99625 .52484 m
1 .52484 L
s
.99625 .54132 m
1 .54132 L
s
.99625 .04707 m
1 .04707 L
s
.99625 .03059 m
1 .03059 L
s
.99625 .01412 m
1 .01412 L
s
.99625 .57427 m
1 .57427 L
s
.99625 .59074 m
1 .59074 L
s
.99625 .60722 m
1 .60722 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .32036 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .23681 m
.02642 .2437 L
.02903 .2452 L
.03164 .22082 L
.03425 .23687 L
.03686 .23085 L
.03947 .25186 L
.04207 .28005 L
.04468 .28584 L
.04729 .30975 L
.0499 .27642 L
.05251 .28887 L
.05512 .26661 L
.05773 .28661 L
.06034 .31023 L
.06295 .32955 L
.06556 .34575 L
.06817 .3317 L
.07078 .30362 L
.07339 .34701 L
.07599 .33017 L
.0786 .31768 L
.08121 .295 L
.08382 .30228 L
.08643 .32033 L
.08904 .3149 L
.09165 .33212 L
.09426 .39748 L
.09687 .36049 L
.09948 .34992 L
.10209 .35122 L
.1047 .37474 L
.10731 .38812 L
.10992 .36837 L
.11252 .36503 L
.11513 .37642 L
.11774 .35663 L
.12035 .3628 L
.12296 .35941 L
.12557 .3357 L
.12818 .35328 L
.13079 .38021 L
.1334 .38229 L
.13601 .35495 L
.13862 .36246 L
.14123 .3494 L
.14384 .35727 L
.14644 .35433 L
.14905 .33697 L
.15166 .32256 L
Mistroke
.15427 .33113 L
.15688 .34452 L
.15949 .36842 L
.1621 .33425 L
.16471 .30705 L
.16732 .31439 L
.16993 .32145 L
.17254 .31412 L
.17515 .3035 L
.17776 .31833 L
.18037 .29888 L
.18297 .29689 L
.18558 .3049 L
.18819 .30012 L
.1908 .30136 L
.19341 .30483 L
.19602 .28929 L
.19863 .28318 L
.20124 .23202 L
.20385 .23498 L
.20646 .24393 L
.20907 .23969 L
.21168 .2358 L
.21429 .25114 L
.21689 .2548 L
.2195 .25773 L
.22211 .22962 L
.22472 .25144 L
.22733 .27875 L
.22994 .27451 L
.23255 .28508 L
.23516 .28677 L
.23777 .24272 L
.24038 .24914 L
.24299 .24928 L
.2456 .25817 L
.24821 .25123 L
.25082 .25274 L
.25342 .26015 L
.25603 .25298 L
.25864 .25051 L
.26125 .25417 L
.26386 .24814 L
.26647 .24616 L
.26908 .25186 L
.27169 .26035 L
.2743 .26518 L
.27691 .25744 L
.27952 .23341 L
.28213 .24779 L
Mistroke
.28474 .25569 L
.28735 .23208 L
.28995 .2126 L
.29256 .22684 L
.29517 .2106 L
.29778 .23306 L
.30039 .1945 L
.303 .20042 L
.30561 .21318 L
.30822 .21886 L
.31083 .24515 L
.31344 .26372 L
.31605 .26227 L
.31866 .25546 L
.32127 .27347 L
.32387 .26611 L
.32648 .30857 L
.32909 .30084 L
.3317 .26904 L
.33431 .2663 L
.33692 .30392 L
.33953 .30142 L
.34214 .28173 L
.34475 .27935 L
.34736 .28799 L
.34997 .30725 L
.35258 .30148 L
.35519 .2917 L
.3578 .2889 L
.3604 .28763 L
.36301 .28456 L
.36562 .26988 L
.36823 .29326 L
.37084 .29768 L
.37345 .29547 L
.37606 .264 L
.37867 .26471 L
.38128 .24288 L
.38389 .2606 L
.3865 .24074 L
.38911 .23634 L
.39172 .24604 L
.39432 .26103 L
.39693 .23621 L
.39954 .24374 L
.40215 .2565 L
.40476 .26366 L
.40737 .23508 L
.40998 .21573 L
.41259 .22738 L
Mistroke
.4152 .21279 L
.41781 .23241 L
.42042 .24114 L
.42303 .23823 L
.42564 .25333 L
.42825 .23689 L
.43085 .23972 L
.43346 .25033 L
.43607 .24491 L
.43868 .26121 L
.44129 .26075 L
.4439 .2278 L
.44651 .20587 L
.44912 .21744 L
.45173 .26718 L
.45434 .24799 L
.45695 .24859 L
.45956 .217 L
.46217 .23212 L
.46477 .23302 L
.46738 .2427 L
.46999 .21133 L
.4726 .23829 L
.47521 .24696 L
.47782 .26769 L
.48043 .28611 L
.48304 .23923 L
.48565 .24529 L
.48826 .22223 L
.49087 .27296 L
.49348 .27953 L
.49609 .2683 L
.4987 .2822 L
.5013 .2759 L
.50391 .28621 L
.50652 .25577 L
.50913 .25864 L
.51174 .28421 L
.51435 .24469 L
.51696 .29552 L
.51957 .2747 L
.52218 .25225 L
.52479 .22101 L
.5274 .24248 L
.53001 .25776 L
.53262 .26036 L
.53523 .23988 L
.53783 .20669 L
.54044 .14932 L
.54305 .17641 L
Mistroke
.54566 .19046 L
.54827 .19555 L
.55088 .17202 L
.55349 .19324 L
.5561 .22924 L
.55871 .19126 L
.56132 .18504 L
.56393 .15734 L
.56654 .08592 L
.56915 .04716 L
.57175 .06921 L
.57436 .10889 L
.57697 .10433 L
.57958 .11085 L
.58219 .10153 L
.5848 .10011 L
.58741 .10293 L
.59002 .13057 L
.59263 .13304 L
.59524 .13214 L
.59785 .13154 L
.60046 .14685 L
.60307 .14116 L
.60568 .14246 L
.60828 .2081 L
.61089 .23421 L
.6135 .19652 L
.61611 .21109 L
.61872 .20311 L
.62133 .21129 L
.62394 .23242 L
.62655 .24867 L
.62916 .33049 L
.63177 .32336 L
.63438 .36946 L
.63699 .32942 L
.6396 .29008 L
.6422 .27869 L
.64481 .29258 L
.64742 .29448 L
.65003 .31292 L
.65264 .33676 L
.65525 .37201 L
.65786 .3678 L
.66047 .41171 L
.66308 .40228 L
.66569 .39734 L
.6683 .41063 L
.67091 .351 L
.67352 .32245 L
Mistroke
.67613 .32951 L
.67873 .34628 L
.68134 .30995 L
.68395 .36709 L
.68656 .37943 L
.68917 .42261 L
.69178 .43313 L
.69439 .40064 L
.697 .45566 L
.69961 .49212 L
.70222 .49916 L
.70483 .47375 L
.70744 .47453 L
.71005 .49489 L
.71265 .49523 L
.71526 .48071 L
.71787 .46325 L
.72048 .43489 L
.72309 .45755 L
.7257 .41892 L
.72831 .41242 L
.73092 .38883 L
.73353 .37612 L
.73614 .32831 L
.73875 .34524 L
.74136 .38727 L
.74397 .41151 L
.74658 .44476 L
.74918 .482 L
.75179 .46428 L
.7544 .44054 L
.75701 .39389 L
.75962 .46168 L
.76223 .45442 L
.76484 .44742 L
.76745 .41212 L
.77006 .40645 L
.77267 .41844 L
.77528 .45347 L
.77789 .47157 L
.7805 .51778 L
.78311 .52512 L
.78571 .51908 L
.78832 .52048 L
.79093 .52614 L
.79354 .44265 L
.79615 .42018 L
.79876 .45058 L
.80137 .46794 L
.80398 .48387 L
Mistroke
.80659 .41407 L
.8092 .38346 L
.81181 .38235 L
.81442 .34222 L
.81703 .35861 L
.81963 .35621 L
.82224 .4278 L
.82485 .40383 L
.82746 .45098 L
.83007 .43316 L
.83268 .46097 L
.83529 .42137 L
.8379 .39974 L
.84051 .37712 L
.84312 .38237 L
.84573 .33006 L
.84834 .33034 L
.85095 .27095 L
.85356 .28784 L
.85616 .33628 L
.85877 .28985 L
.86138 .2818 L
.86399 .328 L
.8666 .37795 L
.86921 .42241 L
.87182 .46607 L
.87443 .49189 L
.87704 .43421 L
.87965 .4047 L
.88226 .47177 L
.88487 .4315 L
.88748 .39146 L
.89008 .37692 L
.89269 .40277 L
.8953 .41914 L
.89791 .38924 L
.90052 .35301 L
.90313 .36074 L
.90574 .33896 L
.90835 .34677 L
.91096 .31806 L
.91357 .32234 L
.91618 .33 L
.91879 .30179 L
.9214 .32702 L
.92401 .33239 L
.92661 .34778 L
.92922 .30301 L
.93183 .29078 L
.93444 .31107 L
Mistroke
.93705 .31371 L
.93966 .29411 L
.94227 .28992 L
.94488 .28155 L
.94749 .33046 L
.9501 .25944 L
.95271 .28879 L
.95532 .28485 L
.95793 .29247 L
.96053 .33602 L
.96314 .34463 L
.96575 .36011 L
.96836 .33313 L
.97097 .30872 L
.97358 .32811 L
.97619 .32036 L
Mfstroke
0 0 1 r
gsave
.97619 .32833 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23703 m
.02642 .23747 L
.02903 .23779 L
.03164 .23781 L
.03425 .23799 L
.03686 .23827 L
.03947 .23823 L
.04207 .2799 L
.04468 .28033 L
.04729 .28067 L
.0499 .28069 L
.05251 .2808 L
.05512 .28095 L
.05773 .28092 L
.06034 .31025 L
.06295 .31075 L
.06556 .31103 L
.06817 .31096 L
.07078 .31112 L
.07339 .31141 L
.07599 .31137 L
.0786 .31776 L
.08121 .31807 L
.08382 .31842 L
.08643 .31848 L
.08904 .31864 L
.09165 .31881 L
.09426 .31883 L
.09687 .36054 L
.09948 .36085 L
.10209 .36128 L
.1047 .36145 L
.10731 .36165 L
.10992 .36189 L
.11252 .36186 L
.11513 .37667 L
.11774 .37696 L
.12035 .3773 L
.12296 .37745 L
.12557 .37757 L
.12818 .37783 L
.13079 .37792 L
.1334 .38226 L
.13601 .38257 L
.13862 .38293 L
.14123 .38315 L
.14384 .38322 L
.14644 .38356 L
.14905 .38361 L
.15166 .32253 L
Mistroke
.15427 .32295 L
.15688 .3234 L
.15949 .32342 L
.1621 .32352 L
.16471 .3238 L
.16732 .32377 L
.16993 .32143 L
.17254 .32174 L
.17515 .32222 L
.17776 .32241 L
.18037 .3225 L
.18297 .32279 L
.18558 .32293 L
.18819 .30005 L
.1908 .3004 L
.19341 .30078 L
.19602 .30098 L
.19863 .30117 L
.20124 .30148 L
.20385 .30152 L
.20646 .24386 L
.20907 .2442 L
.21168 .24452 L
.21429 .2446 L
.21689 .24468 L
.2195 .24489 L
.22211 .24491 L
.22472 .25159 L
.22733 .252 L
.22994 .25245 L
.23255 .25255 L
.23516 .25267 L
.23777 .25297 L
.24038 .25297 L
.24299 .24911 L
.2456 .24948 L
.24821 .24977 L
.25082 .24992 L
.25342 .25011 L
.25603 .2504 L
.25864 .25041 L
.26125 .254 L
.26386 .25432 L
.26647 .25467 L
.26908 .25481 L
.27169 .25499 L
.2743 .25539 L
.27691 .2556 L
.27952 .23351 L
.28213 .23384 L
Mistroke
.28474 .23414 L
.28735 .23429 L
.28995 .23447 L
.29256 .23479 L
.29517 .23485 L
.29778 .23275 L
.30039 .23308 L
.303 .23339 L
.30561 .2335 L
.30822 .23364 L
.31083 .23402 L
.31344 .23416 L
.31605 .26195 L
.31866 .26237 L
.32127 .26265 L
.32387 .26288 L
.32648 .2631 L
.32909 .26347 L
.3317 .26357 L
.33431 .2666 L
.33692 .26695 L
.33953 .2673 L
.34214 .26754 L
.34475 .26783 L
.34736 .26819 L
.34997 .26834 L
.35258 .30117 L
.35519 .30152 L
.3578 .30191 L
.3604 .30213 L
.36301 .30225 L
.36562 .30256 L
.36823 .30277 L
.37084 .29782 L
.37345 .29823 L
.37606 .29851 L
.37867 .29878 L
.38128 .29901 L
.38389 .2994 L
.3865 .29949 L
.38911 .2364 L
.39172 .23678 L
.39432 .23717 L
.39693 .23729 L
.39954 .23746 L
.40215 .23766 L
.40476 .23766 L
.40737 .23498 L
.40998 .23532 L
.41259 .23574 L
Mistroke
.4152 .23584 L
.41781 .23603 L
.42042 .23629 L
.42303 .2363 L
.42564 .2533 L
.42825 .25365 L
.43085 .25395 L
.43346 .25412 L
.43607 .25431 L
.43868 .25456 L
.44129 .25464 L
.4439 .22804 L
.44651 .22842 L
.44912 .22872 L
.45173 .22889 L
.45434 .22903 L
.45695 .22931 L
.45956 .22942 L
.46217 .23197 L
.46477 .23228 L
.46738 .2327 L
.46999 .23296 L
.4726 .23313 L
.47521 .23343 L
.47782 .23354 L
.48043 .28596 L
.48304 .28627 L
.48565 .2866 L
.48826 .28672 L
.49087 .28683 L
.49348 .28711 L
.49609 .28723 L
.4987 .28194 L
.5013 .28239 L
.50391 .2828 L
.50652 .28302 L
.50913 .28311 L
.51174 .28343 L
.51435 .2835 L
.51696 .29548 L
.51957 .29582 L
.52218 .29618 L
.52479 .29641 L
.5274 .29657 L
.53001 .29687 L
.53262 .29694 L
.53523 .23992 L
.53783 .24038 L
.54044 .24072 L
.54305 .2409 L
Mistroke
.54566 .24105 L
.54827 .24133 L
.55088 .24134 L
.55349 .1933 L
.5561 .19375 L
.55871 .19411 L
.56132 .19418 L
.56393 .19434 L
.56654 .19472 L
.56915 .19479 L
.57175 .06926 L
.57436 .06961 L
.57697 .06997 L
.57958 .06998 L
.58219 .07001 L
.5848 .07024 L
.58741 .07012 L
.59002 .13064 L
.59263 .13102 L
.59524 .13136 L
.59785 .13135 L
.60046 .1314 L
.60307 .13152 L
.60568 .13132 L
.60828 .20806 L
.61089 .20843 L
.6135 .20873 L
.61611 .20865 L
.61872 .20866 L
.62133 .20878 L
.62394 .20856 L
.62655 .24864 L
.62916 .24896 L
.63177 .2493 L
.63438 .24925 L
.63699 .2493 L
.6396 .24952 L
.6422 .24941 L
.64481 .29235 L
.64742 .29289 L
.65003 .29321 L
.65264 .29328 L
.65525 .29336 L
.65786 .29353 L
.66047 .29344 L
.66308 .40212 L
.66569 .40251 L
.6683 .40275 L
.67091 .4027 L
.67352 .40273 L
Mistroke
.67613 .4028 L
.67873 .40256 L
.68134 .30993 L
.68395 .31022 L
.68656 .3105 L
.68917 .3105 L
.69178 .31044 L
.69439 .31056 L
.697 .31036 L
.69961 .49236 L
.70222 .49259 L
.70483 .49284 L
.70744 .49264 L
.71005 .49243 L
.71265 .4924 L
.71526 .49207 L
.71787 .46337 L
.72048 .4637 L
.72309 .46398 L
.7257 .46383 L
.72831 .46351 L
.73092 .46344 L
.73353 .46322 L
.73614 .32812 L
.73875 .32838 L
.74136 .32858 L
.74397 .3284 L
.74658 .32829 L
.74918 .32834 L
.75179 .32797 L
.7544 .44044 L
.75701 .44077 L
.75962 .44102 L
.76223 .44079 L
.76484 .44061 L
.76745 .44057 L
.77006 .44024 L
.77267 .41863 L
.77528 .41895 L
.77789 .41926 L
.7805 .41914 L
.78311 .41894 L
.78571 .41893 L
.78832 .41848 L
.79093 .52611 L
.79354 .52647 L
.79615 .52682 L
.79876 .52657 L
.80137 .52636 L
.80398 .52621 L
Mistroke
.80659 .52582 L
.8092 .38337 L
.81181 .38375 L
.81442 .38395 L
.81703 .38384 L
.81963 .38371 L
.82224 .3836 L
.82485 .38325 L
.82746 .45115 L
.83007 .45141 L
.83268 .45167 L
.83529 .45149 L
.8379 .4513 L
.84051 .45126 L
.84312 .45076 L
.84573 .33033 L
.84834 .33068 L
.85095 .33089 L
.85356 .33074 L
.85616 .33049 L
.85877 .33054 L
.86138 .32999 L
.86399 .32799 L
.8666 .32835 L
.86921 .32861 L
.87182 .32839 L
.87443 .32817 L
.87704 .3282 L
.87965 .32764 L
.88226 .47196 L
.88487 .47218 L
.88748 .47235 L
.89008 .47209 L
.89269 .4718 L
.8953 .47178 L
.89791 .4712 L
.90052 .35293 L
.90313 .35324 L
.90574 .35341 L
.90835 .35313 L
.91096 .35283 L
.91357 .35276 L
.91618 .3523 L
.91879 .30163 L
.9214 .30189 L
.92401 .30211 L
.92661 .3018 L
.92922 .30147 L
.93183 .30152 L
.93444 .30106 L
Mistroke
.93705 .31384 L
.93966 .31409 L
.94227 .31433 L
.94488 .31403 L
.94749 .31382 L
.9501 .3137 L
.95271 .31321 L
.95532 .28503 L
.95793 .28539 L
.96053 .2855 L
.96314 .28527 L
.96575 .28508 L
.96836 .28522 L
.97097 .28475 L
.97358 .32805 L
.97619 .32833 L
Mfstroke
0 .98 .604 r
gsave
.97619 .35894 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23719 m
.02642 .25679 L
.02903 .26522 L
.03164 .2713 L
.03425 .27678 L
.03686 .28219 L
.03947 .28587 L
.04207 .28006 L
.04468 .30028 L
.04729 .30891 L
.0499 .31561 L
.05251 .32133 L
.05512 .32644 L
.05773 .3303 L
.06034 .31042 L
.06295 .3294 L
.06556 .33737 L
.06817 .34313 L
.07078 .34841 L
.07339 .35363 L
.07599 .35739 L
.0786 .31792 L
.08121 .33444 L
.08382 .34167 L
.08643 .34689 L
.08904 .35158 L
.09165 .35573 L
.09426 .35887 L
.09687 .3607 L
.09948 .37774 L
.10209 .3852 L
.1047 .39091 L
.10731 .39582 L
.10992 .40058 L
.11252 .40382 L
.11513 .37683 L
.11774 .39258 L
.12035 .3994 L
.12296 .40437 L
.12557 .40893 L
.12818 .41312 L
.13079 .41616 L
.1334 .38243 L
.13601 .39579 L
.13862 .40175 L
.14123 .40635 L
.14384 .41031 L
.14644 .41399 L
.14905 .41677 L
.15166 .32269 L
Mistroke
.15427 .34017 L
.15688 .3478 L
.15949 .35337 L
.1621 .35832 L
.16471 .36299 L
.16732 .36661 L
.16993 .32159 L
.17254 .33759 L
.17515 .34442 L
.17776 .34979 L
.18037 .3544 L
.18297 .35872 L
.18558 .36206 L
.18819 .30021 L
.1908 .31565 L
.19341 .32223 L
.19602 .3272 L
.19863 .33157 L
.20124 .33573 L
.20385 .33866 L
.20646 .24402 L
.20907 .26161 L
.21168 .26911 L
.21429 .27478 L
.21689 .2797 L
.2195 .28441 L
.22211 .28785 L
.22472 .25175 L
.22733 .2682 L
.22994 .27546 L
.23255 .28074 L
.23516 .28549 L
.23777 .28993 L
.24038 .29292 L
.24299 .24927 L
.2456 .26418 L
.24821 .27048 L
.25082 .27514 L
.25342 .27949 L
.25603 .28368 L
.25864 .28676 L
.26125 .25417 L
.26386 .26626 L
.26647 .27151 L
.26908 .27539 L
.27169 .27884 L
.2743 .28231 L
.27691 .28493 L
.27952 .23367 L
.28213 .24669 L
Mistroke
.28474 .25216 L
.28735 .2565 L
.28995 .2604 L
.29256 .26396 L
.29517 .26663 L
.29778 .23291 L
.30039 .24394 L
.303 .24902 L
.30561 .25257 L
.30822 .2557 L
.31083 .2589 L
.31344 .26121 L
.31605 .26212 L
.31866 .27432 L
.32127 .27953 L
.32387 .28358 L
.32648 .28716 L
.32909 .29046 L
.3317 .29293 L
.33431 .26677 L
.33692 .27721 L
.33953 .28197 L
.34214 .28539 L
.34475 .28851 L
.34736 .29156 L
.34997 .29375 L
.35258 .30133 L
.35519 .31367 L
.3578 .3191 L
.3604 .32309 L
.36301 .32661 L
.36562 .33004 L
.36823 .33265 L
.37084 .29799 L
.37345 .30915 L
.37606 .31392 L
.37867 .3177 L
.38128 .32096 L
.38389 .32424 L
.3865 .32653 L
.38911 .23657 L
.39172 .25218 L
.39432 .25903 L
.39693 .26396 L
.39954 .26833 L
.40215 .27232 L
.40476 .2754 L
.40737 .23514 L
.40998 .24972 L
.41259 .25617 L
Mistroke
.4152 .26077 L
.41781 .26503 L
.42042 .26892 L
.42303 .27169 L
.42564 .25347 L
.42825 .26719 L
.43085 .27306 L
.43346 .27762 L
.43607 .28153 L
.43868 .28527 L
.44129 .28805 L
.4439 .2282 L
.44651 .24227 L
.44912 .2482 L
.45173 .25267 L
.45434 .25666 L
.45695 .2605 L
.45956 .26338 L
.46217 .23213 L
.46477 .24429 L
.46738 .2496 L
.46999 .25359 L
.4726 .25702 L
.47521 .26037 L
.47782 .26294 L
.48043 .28612 L
.48304 .3012 L
.48565 .30769 L
.48826 .31268 L
.49087 .31686 L
.49348 .32095 L
.49609 .32412 L
.4987 .28211 L
.5013 .29602 L
.50391 .30223 L
.50652 .30687 L
.50913 .31081 L
.51174 .31462 L
.51435 .31748 L
.51696 .29564 L
.51957 .30812 L
.52218 .31359 L
.52479 .31777 L
.5274 .32137 L
.53001 .32482 L
.53262 .32731 L
.53523 .24008 L
.53783 .25635 L
.54044 .26318 L
.54305 .26849 L
Mistroke
.54566 .27304 L
.54827 .2776 L
.55088 .28066 L
.55349 .19347 L
.5561 .21057 L
.55871 .21785 L
.56132 .22334 L
.56393 .22825 L
.56654 .23312 L
.56915 .23629 L
.57175 .06942 L
.57436 .09224 L
.57697 .10189 L
.57958 .10914 L
.58219 .11543 L
.5848 .12129 L
.58741 .12553 L
.59002 .1308 L
.59263 .15374 L
.59524 .1635 L
.59785 .17067 L
.60046 .17718 L
.60307 .18291 L
.60568 .18715 L
.60828 .20823 L
.61089 .23185 L
.6135 .24181 L
.61611 .24929 L
.61872 .25611 L
.62133 .2621 L
.62394 .26656 L
.62655 .24881 L
.62916 .27173 L
.63177 .28138 L
.63438 .28859 L
.63699 .29492 L
.6396 .30082 L
.6422 .30505 L
.64481 .29252 L
.64742 .31513 L
.65003 .32472 L
.65264 .33178 L
.65525 .338 L
.65786 .34365 L
.66047 .34781 L
.66308 .40229 L
.66569 .428 L
.6683 .43858 L
.67091 .44665 L
.67352 .45387 L
Mistroke
.67613 .46028 L
.67873 .46501 L
.68134 .31009 L
.68395 .33689 L
.68656 .34811 L
.68917 .3566 L
.69178 .3642 L
.69439 .37103 L
.697 .37609 L
.69961 .49252 L
.70222 .52345 L
.70483 .53635 L
.70744 .54579 L
.71005 .5541 L
.71265 .56179 L
.71526 .56746 L
.71787 .46353 L
.72048 .49372 L
.72309 .50634 L
.7257 .51555 L
.72831 .52357 L
.73092 .53103 L
.73353 .53662 L
.73614 .32829 L
.73875 .36004 L
.74136 .37322 L
.74397 .38312 L
.74658 .39161 L
.74918 .39964 L
.75179 .40543 L
.7544 .44061 L
.75701 .47298 L
.75962 .48648 L
.76223 .49633 L
.76484 .50499 L
.76745 .51283 L
.77006 .51879 L
.77267 .4188 L
.77528 .45022 L
.77789 .46334 L
.7805 .47295 L
.78311 .48131 L
.78571 .4889 L
.78832 .49469 L
.79093 .52628 L
.79354 .55813 L
.79615 .57147 L
.79876 .5811 L
.80137 .58992 L
.80398 .59766 L
Mistroke
.80659 .60332 L
.8092 .38353 L
.81181 .41737 L
.81442 .43138 L
.81703 .44197 L
.81963 .45129 L
.82224 .45959 L
.82485 .4658 L
.82746 .45131 L
.83007 .48447 L
.83268 .49832 L
.83529 .50854 L
.8379 .51753 L
.84051 .52566 L
.84312 .53167 L
.84573 .33049 L
.84834 .36475 L
.85095 .37886 L
.85356 .38935 L
.85616 .39862 L
.85877 .40705 L
.86138 .41316 L
.86399 .32815 L
.8666 .36127 L
.86921 .37493 L
.87182 .38495 L
.87443 .39376 L
.87704 .40189 L
.87965 .40791 L
.88226 .47212 L
.88487 .50692 L
.88748 .52134 L
.89008 .53201 L
.89269 .54137 L
.8953 .54992 L
.89791 .5562 L
.90052 .35309 L
.90313 .38857 L
.90574 .40311 L
.90835 .41393 L
.91096 .42336 L
.91357 .43212 L
.91618 .43859 L
.91879 .30179 L
.9214 .33622 L
.92401 .3506 L
.92661 .36123 L
.92922 .37054 L
.93183 .37929 L
.93444 .38562 L
Mistroke
.93705 .31401 L
.93966 .34713 L
.94227 .36084 L
.94488 .37084 L
.94749 .37967 L
.9501 .38784 L
.95271 .39367 L
.95532 .2852 L
.95793 .31702 L
.96053 .33015 L
.96314 .33985 L
.96575 .3484 L
.96836 .3566 L
.97097 .36234 L
.97358 .32821 L
.97619 .35894 L
Mfstroke
gsave
.97619 .29772 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23687 m
.02642 .21814 L
.02903 .21035 L
.03164 .20432 L
.03425 .19919 L
.03686 .19436 L
.03947 .1906 L
.04207 .27973 L
.04468 .26038 L
.04729 .25244 L
.0499 .24577 L
.05251 .24028 L
.05512 .23546 L
.05773 .23154 L
.06034 .31009 L
.06295 .2921 L
.06556 .28468 L
.06817 .27878 L
.07078 .27383 L
.07339 .26919 L
.07599 .26535 L
.0786 .3176 L
.08121 .3017 L
.08382 .29518 L
.08643 .29007 L
.08904 .2857 L
.09165 .28189 L
.09426 .2788 L
.09687 .36038 L
.09948 .34397 L
.10209 .33737 L
.1047 .33199 L
.10731 .32747 L
.10992 .3232 L
.11252 .31991 L
.11513 .37651 L
.11774 .36133 L
.12035 .3552 L
.12296 .35054 L
.12557 .3462 L
.12818 .34253 L
.13079 .33968 L
.1334 .3821 L
.13601 .36935 L
.13862 .3641 L
.14123 .35994 L
.14384 .35613 L
.14644 .35313 L
.14905 .35046 L
.15166 .32237 L
Mistroke
.15427 .30573 L
.15688 .29899 L
.15949 .29347 L
.1621 .28872 L
.16471 .28462 L
.16732 .28094 L
.16993 .32127 L
.17254 .3059 L
.17515 .30003 L
.17776 .29502 L
.18037 .29059 L
.18297 .28687 L
.18558 .28379 L
.18819 .29988 L
.1908 .28514 L
.19341 .27932 L
.19602 .27476 L
.19863 .27077 L
.20124 .26723 L
.20385 .26439 L
.20646 .2437 L
.20907 .2268 L
.21168 .21994 L
.21429 .21441 L
.21689 .20967 L
.2195 .20538 L
.22211 .20197 L
.22472 .25142 L
.22733 .23579 L
.22994 .22945 L
.23255 .22437 L
.23516 .21985 L
.23777 .21601 L
.24038 .21302 L
.24299 .24895 L
.2456 .23478 L
.24821 .22907 L
.25082 .2247 L
.25342 .22073 L
.25603 .21713 L
.25864 .21406 L
.26125 .25384 L
.26386 .24239 L
.26647 .23783 L
.26908 .23423 L
.27169 .23114 L
.2743 .22846 L
.27691 .22626 L
.27952 .23334 L
.28213 .22099 L
Mistroke
.28474 .21611 L
.28735 .21208 L
.28995 .20855 L
.29256 .20562 L
.29517 .20308 L
.29778 .23258 L
.30039 .22221 L
.303 .21777 L
.30561 .21443 L
.30822 .21158 L
.31083 .20913 L
.31344 .20711 L
.31605 .26179 L
.31866 .25042 L
.32127 .24576 L
.32387 .24219 L
.32648 .23905 L
.32909 .23647 L
.3317 .23421 L
.33431 .26644 L
.33692 .25669 L
.33953 .25263 L
.34214 .24969 L
.34475 .24715 L
.34736 .24482 L
.34997 .24292 L
.35258 .30101 L
.35519 .28936 L
.3578 .28473 L
.3604 .28117 L
.36301 .27789 L
.36562 .27507 L
.36823 .27289 L
.37084 .29766 L
.37345 .28731 L
.37606 .28309 L
.37867 .27985 L
.38128 .27706 L
.38389 .27455 L
.3865 .27245 L
.38911 .23624 L
.39172 .22137 L
.39432 .21532 L
.39693 .21062 L
.39954 .20659 L
.40215 .20301 L
.40476 .19992 L
.40737 .23482 L
.40998 .22092 L
.41259 .2153 L
Mistroke
.4152 .21092 L
.41781 .20702 L
.42042 .20366 L
.42303 .20092 L
.42564 .25314 L
.42825 .24012 L
.43085 .23484 L
.43346 .23062 L
.43607 .22708 L
.43868 .22385 L
.44129 .22124 L
.4439 .22788 L
.44651 .21457 L
.44912 .20924 L
.45173 .20511 L
.45434 .20141 L
.45695 .19812 L
.45956 .19546 L
.46217 .2318 L
.46477 .22027 L
.46738 .2158 L
.46999 .21233 L
.4726 .20924 L
.47521 .20649 L
.47782 .20413 L
.48043 .28579 L
.48304 .27133 L
.48565 .26551 L
.48826 .26076 L
.49087 .25681 L
.49348 .25327 L
.49609 .25035 L
.4987 .28178 L
.5013 .26875 L
.50391 .26337 L
.50652 .25917 L
.50913 .25541 L
.51174 .25223 L
.51435 .24952 L
.51696 .29531 L
.51957 .28351 L
.52218 .27878 L
.52479 .27505 L
.5274 .27178 L
.53001 .26893 L
.53262 .26656 L
.53523 .23975 L
.53783 .22442 L
.54044 .21826 L
.54305 .21331 L
Mistroke
.54566 .20907 L
.54827 .20505 L
.55088 .20202 L
.55349 .19314 L
.5561 .17693 L
.55871 .17037 L
.56132 .16502 L
.56393 .16044 L
.56654 .15632 L
.56915 .15329 L
.57175 .0691 L
.57436 .04699 L
.57697 .03805 L
.57958 .03082 L
.58219 .02458 L
.5848 .01919 L
.58741 .01472 L
.59002 .13048 L
.59263 .1083 L
.59524 .09922 L
.59785 .09204 L
.60046 .08562 L
.60307 .08012 L
.60568 .07549 L
.60828 .2079 L
.61089 .185 L
.6135 .17564 L
.61611 .168 L
.61872 .1612 L
.62133 .15546 L
.62394 .15056 L
.62655 .24848 L
.62916 .22619 L
.63177 .21722 L
.63438 .20991 L
.63699 .20368 L
.6396 .19822 L
.6422 .19376 L
.64481 .29219 L
.64742 .27065 L
.65003 .26171 L
.65264 .25478 L
.65525 .24871 L
.65786 .24341 L
.66047 .23908 L
.66308 .40196 L
.66569 .37702 L
.6683 .36692 L
.67091 .35875 L
.67352 .35158 L
Mistroke
.67613 .34532 L
.67873 .34011 L
.68134 .30976 L
.68395 .28355 L
.68656 .27289 L
.68917 .26441 L
.69178 .25667 L
.69439 .25009 L
.697 .24464 L
.69961 .49219 L
.70222 .46173 L
.70483 .44933 L
.70744 .4395 L
.71005 .43076 L
.71265 .42301 L
.71526 .41668 L
.71787 .4632 L
.72048 .43368 L
.72309 .42162 L
.7257 .4121 L
.72831 .40346 L
.73092 .39585 L
.73353 .38983 L
.73614 .32796 L
.73875 .29673 L
.74136 .28393 L
.74397 .27367 L
.74658 .26496 L
.74918 .25703 L
.75179 .25052 L
.7544 .44028 L
.75701 .40856 L
.75962 .39555 L
.76223 .38526 L
.76484 .37623 L
.76745 .36832 L
.77006 .36168 L
.77267 .41847 L
.77528 .38768 L
.77789 .37519 L
.7805 .36532 L
.78311 .35657 L
.78571 .34896 L
.78832 .34226 L
.79093 .52595 L
.79354 .49481 L
.79615 .48216 L
.79876 .47204 L
.80137 .46281 L
.80398 .45476 L
Mistroke
.80659 .44832 L
.8092 .38321 L
.81181 .35013 L
.81442 .33651 L
.81703 .32572 L
.81963 .31613 L
.82224 .3076 L
.82485 .30069 L
.82746 .45098 L
.83007 .41835 L
.83268 .40501 L
.83529 .39444 L
.8379 .38507 L
.84051 .37685 L
.84312 .36985 L
.84573 .33016 L
.84834 .29661 L
.85095 .28291 L
.85356 .27214 L
.85616 .26236 L
.85877 .25403 L
.86138 .24683 L
.86399 .32783 L
.8666 .29544 L
.86921 .28229 L
.87182 .27183 L
.87443 .26258 L
.87704 .25451 L
.87965 .24738 L
.88226 .47179 L
.88487 .43744 L
.88748 .42337 L
.89008 .41217 L
.89269 .40222 L
.8953 .39363 L
.89791 .3862 L
.90052 .35276 L
.90313 .3179 L
.90574 .3037 L
.90835 .29233 L
.91096 .28231 L
.91357 .27341 L
.91618 .26602 L
.91879 .30146 L
.9214 .26757 L
.92401 .25361 L
.92661 .24237 L
.92922 .23239 L
.93183 .22375 L
.93444 .2165 L
Mistroke
.93705 .31368 L
.93966 .28106 L
.94227 .26782 L
.94488 .25723 L
.94749 .24796 L
.9501 .23956 L
.95271 .23275 L
.95532 .28487 L
.95793 .25375 L
.96053 .24085 L
.96314 .2307 L
.96575 .22177 L
.96836 .21384 L
.97097 .20717 L
.97358 .32788 L
.97619 .29772 L
Mfstroke
gsave
.97619 .29772 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23687 m
.02642 .21814 L
.02903 .21035 L
.03164 .20432 L
.03425 .19919 L
.03686 .19436 L
.03947 .1906 L
.04207 .27973 L
.04468 .26038 L
.04729 .25244 L
.0499 .24577 L
.05251 .24028 L
.05512 .23546 L
.05773 .23154 L
.06034 .31009 L
.06295 .2921 L
.06556 .28468 L
.06817 .27878 L
.07078 .27383 L
.07339 .26919 L
.07599 .26535 L
.0786 .3176 L
.08121 .3017 L
.08382 .29518 L
.08643 .29007 L
.08904 .2857 L
.09165 .28189 L
.09426 .2788 L
.09687 .36038 L
.09948 .34397 L
.10209 .33737 L
.1047 .33199 L
.10731 .32747 L
.10992 .3232 L
.11252 .31991 L
.11513 .37651 L
.11774 .36133 L
.12035 .3552 L
.12296 .35054 L
.12557 .3462 L
.12818 .34253 L
.13079 .33968 L
.1334 .3821 L
.13601 .36935 L
.13862 .3641 L
.14123 .35994 L
.14384 .35613 L
.14644 .35313 L
.14905 .35046 L
.15166 .32237 L
Mistroke
.15427 .30573 L
.15688 .29899 L
.15949 .29347 L
.1621 .28872 L
.16471 .28462 L
.16732 .28094 L
.16993 .32127 L
.17254 .3059 L
.17515 .30003 L
.17776 .29502 L
.18037 .29059 L
.18297 .28687 L
.18558 .28379 L
.18819 .29988 L
.1908 .28514 L
.19341 .27932 L
.19602 .27476 L
.19863 .27077 L
.20124 .26723 L
.20385 .26439 L
.20646 .2437 L
.20907 .2268 L
.21168 .21994 L
.21429 .21441 L
.21689 .20967 L
.2195 .20538 L
.22211 .20197 L
.22472 .25142 L
.22733 .23579 L
.22994 .22945 L
.23255 .22437 L
.23516 .21985 L
.23777 .21601 L
.24038 .21302 L
.24299 .24895 L
.2456 .23478 L
.24821 .22907 L
.25082 .2247 L
.25342 .22073 L
.25603 .21713 L
.25864 .21406 L
.26125 .25384 L
.26386 .24239 L
.26647 .23783 L
.26908 .23423 L
.27169 .23114 L
.2743 .22846 L
.27691 .22626 L
.27952 .23334 L
.28213 .22099 L
Mistroke
.28474 .21611 L
.28735 .21208 L
.28995 .20855 L
.29256 .20562 L
.29517 .20308 L
.29778 .23258 L
.30039 .22221 L
.303 .21777 L
.30561 .21443 L
.30822 .21158 L
.31083 .20913 L
.31344 .20711 L
.31605 .26179 L
.31866 .25042 L
.32127 .24576 L
.32387 .24219 L
.32648 .23905 L
.32909 .23647 L
.3317 .23421 L
.33431 .26644 L
.33692 .25669 L
.33953 .25263 L
.34214 .24969 L
.34475 .24715 L
.34736 .24482 L
.34997 .24292 L
.35258 .30101 L
.35519 .28936 L
.3578 .28473 L
.3604 .28117 L
.36301 .27789 L
.36562 .27507 L
.36823 .27289 L
.37084 .29766 L
.37345 .28731 L
.37606 .28309 L
.37867 .27985 L
.38128 .27706 L
.38389 .27455 L
.3865 .27245 L
.38911 .23624 L
.39172 .22137 L
.39432 .21532 L
.39693 .21062 L
.39954 .20659 L
.40215 .20301 L
.40476 .19992 L
.40737 .23482 L
.40998 .22092 L
.41259 .2153 L
Mistroke
.4152 .21092 L
.41781 .20702 L
.42042 .20366 L
.42303 .20092 L
.42564 .25314 L
.42825 .24012 L
.43085 .23484 L
.43346 .23062 L
.43607 .22708 L
.43868 .22385 L
.44129 .22124 L
.4439 .22788 L
.44651 .21457 L
.44912 .20924 L
.45173 .20511 L
.45434 .20141 L
.45695 .19812 L
.45956 .19546 L
.46217 .2318 L
.46477 .22027 L
.46738 .2158 L
.46999 .21233 L
.4726 .20924 L
.47521 .20649 L
.47782 .20413 L
.48043 .28579 L
.48304 .27133 L
.48565 .26551 L
.48826 .26076 L
.49087 .25681 L
.49348 .25327 L
.49609 .25035 L
.4987 .28178 L
.5013 .26875 L
.50391 .26337 L
.50652 .25917 L
.50913 .25541 L
.51174 .25223 L
.51435 .24952 L
.51696 .29531 L
.51957 .28351 L
.52218 .27878 L
.52479 .27505 L
.5274 .27178 L
.53001 .26893 L
.53262 .26656 L
.53523 .23975 L
.53783 .22442 L
.54044 .21826 L
.54305 .21331 L
Mistroke
.54566 .20907 L
.54827 .20505 L
.55088 .20202 L
.55349 .19314 L
.5561 .17693 L
.55871 .17037 L
.56132 .16502 L
.56393 .16044 L
.56654 .15632 L
.56915 .15329 L
.57175 .0691 L
.57436 .04699 L
.57697 .03805 L
.57958 .03082 L
.58219 .02458 L
.5848 .01919 L
.58741 .01472 L
.59002 .13048 L
.59263 .1083 L
.59524 .09922 L
.59785 .09204 L
.60046 .08562 L
.60307 .08012 L
.60568 .07549 L
.60828 .2079 L
.61089 .185 L
.6135 .17564 L
.61611 .168 L
.61872 .1612 L
.62133 .15546 L
.62394 .15056 L
.62655 .24848 L
.62916 .22619 L
.63177 .21722 L
.63438 .20991 L
.63699 .20368 L
.6396 .19822 L
.6422 .19376 L
.64481 .29219 L
.64742 .27065 L
.65003 .26171 L
.65264 .25478 L
.65525 .24871 L
.65786 .24341 L
.66047 .23908 L
.66308 .40196 L
.66569 .37702 L
.6683 .36692 L
.67091 .35875 L
.67352 .35158 L
Mistroke
.67613 .34532 L
.67873 .34011 L
.68134 .30976 L
.68395 .28355 L
.68656 .27289 L
.68917 .26441 L
.69178 .25667 L
.69439 .25009 L
.697 .24464 L
.69961 .49219 L
.70222 .46173 L
.70483 .44933 L
.70744 .4395 L
.71005 .43076 L
.71265 .42301 L
.71526 .41668 L
.71787 .4632 L
.72048 .43368 L
.72309 .42162 L
.7257 .4121 L
.72831 .40346 L
.73092 .39585 L
.73353 .38983 L
.73614 .32796 L
.73875 .29673 L
.74136 .28393 L
.74397 .27367 L
.74658 .26496 L
.74918 .25703 L
.75179 .25052 L
.7544 .44028 L
.75701 .40856 L
.75962 .39555 L
.76223 .38526 L
.76484 .37623 L
.76745 .36832 L
.77006 .36168 L
.77267 .41847 L
.77528 .38768 L
.77789 .37519 L
.7805 .36532 L
.78311 .35657 L
.78571 .34896 L
.78832 .34226 L
.79093 .52595 L
.79354 .49481 L
.79615 .48216 L
.79876 .47204 L
.80137 .46281 L
.80398 .45476 L
Mistroke
.80659 .44832 L
.8092 .38321 L
.81181 .35013 L
.81442 .33651 L
.81703 .32572 L
.81963 .31613 L
.82224 .3076 L
.82485 .30069 L
.82746 .45098 L
.83007 .41835 L
.83268 .40501 L
.83529 .39444 L
.8379 .38507 L
.84051 .37685 L
.84312 .36985 L
.84573 .33016 L
.84834 .29661 L
.85095 .28291 L
.85356 .27214 L
.85616 .26236 L
.85877 .25403 L
.86138 .24683 L
.86399 .32783 L
.8666 .29544 L
.86921 .28229 L
.87182 .27183 L
.87443 .26258 L
.87704 .25451 L
.87965 .24738 L
.88226 .47179 L
.88487 .43744 L
.88748 .42337 L
.89008 .41217 L
.89269 .40222 L
.8953 .39363 L
.89791 .3862 L
.90052 .35276 L
.90313 .3179 L
.90574 .3037 L
.90835 .29233 L
.91096 .28231 L
.91357 .27341 L
.91618 .26602 L
.91879 .30146 L
.9214 .26757 L
.92401 .25361 L
.92661 .24237 L
.92922 .23239 L
.93183 .22375 L
.93444 .2165 L
Mistroke
.93705 .31368 L
.93966 .28106 L
.94227 .26782 L
.94488 .25723 L
.94749 .24796 L
.9501 .23956 L
.95271 .23275 L
.95532 .28487 L
.95793 .25375 L
.96053 .24085 L
.96314 .2307 L
.96575 .22177 L
.96836 .21384 L
.97097 .20717 L
.97358 .32788 L
.97619 .29772 L
Mfstroke
gsave
.97619 .35894 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23719 m
.02642 .25679 L
.02903 .26522 L
.03164 .2713 L
.03425 .27678 L
.03686 .28219 L
.03947 .28587 L
.04207 .28006 L
.04468 .30028 L
.04729 .30891 L
.0499 .31561 L
.05251 .32133 L
.05512 .32644 L
.05773 .3303 L
.06034 .31042 L
.06295 .3294 L
.06556 .33737 L
.06817 .34313 L
.07078 .34841 L
.07339 .35363 L
.07599 .35739 L
.0786 .31792 L
.08121 .33444 L
.08382 .34167 L
.08643 .34689 L
.08904 .35158 L
.09165 .35573 L
.09426 .35887 L
.09687 .3607 L
.09948 .37774 L
.10209 .3852 L
.1047 .39091 L
.10731 .39582 L
.10992 .40058 L
.11252 .40382 L
.11513 .37683 L
.11774 .39258 L
.12035 .3994 L
.12296 .40437 L
.12557 .40893 L
.12818 .41312 L
.13079 .41616 L
.1334 .38243 L
.13601 .39579 L
.13862 .40175 L
.14123 .40635 L
.14384 .41031 L
.14644 .41399 L
.14905 .41677 L
.15166 .32269 L
Mistroke
.15427 .34017 L
.15688 .3478 L
.15949 .35337 L
.1621 .35832 L
.16471 .36299 L
.16732 .36661 L
.16993 .32159 L
.17254 .33759 L
.17515 .34442 L
.17776 .34979 L
.18037 .3544 L
.18297 .35872 L
.18558 .36206 L
.18819 .30021 L
.1908 .31565 L
.19341 .32223 L
.19602 .3272 L
.19863 .33157 L
.20124 .33573 L
.20385 .33866 L
.20646 .24402 L
.20907 .26161 L
.21168 .26911 L
.21429 .27478 L
.21689 .2797 L
.2195 .28441 L
.22211 .28785 L
.22472 .25175 L
.22733 .2682 L
.22994 .27546 L
.23255 .28074 L
.23516 .28549 L
.23777 .28993 L
.24038 .29292 L
.24299 .24927 L
.2456 .26418 L
.24821 .27048 L
.25082 .27514 L
.25342 .27949 L
.25603 .28368 L
.25864 .28676 L
.26125 .25417 L
.26386 .26626 L
.26647 .27151 L
.26908 .27539 L
.27169 .27884 L
.2743 .28231 L
.27691 .28493 L
.27952 .23367 L
.28213 .24669 L
Mistroke
.28474 .25216 L
.28735 .2565 L
.28995 .2604 L
.29256 .26396 L
.29517 .26663 L
.29778 .23291 L
.30039 .24394 L
.303 .24902 L
.30561 .25257 L
.30822 .2557 L
.31083 .2589 L
.31344 .26121 L
.31605 .26212 L
.31866 .27432 L
.32127 .27953 L
.32387 .28358 L
.32648 .28716 L
.32909 .29046 L
.3317 .29293 L
.33431 .26677 L
.33692 .27721 L
.33953 .28197 L
.34214 .28539 L
.34475 .28851 L
.34736 .29156 L
.34997 .29375 L
.35258 .30133 L
.35519 .31367 L
.3578 .3191 L
.3604 .32309 L
.36301 .32661 L
.36562 .33004 L
.36823 .33265 L
.37084 .29799 L
.37345 .30915 L
.37606 .31392 L
.37867 .3177 L
.38128 .32096 L
.38389 .32424 L
.3865 .32653 L
.38911 .23657 L
.39172 .25218 L
.39432 .25903 L
.39693 .26396 L
.39954 .26833 L
.40215 .27232 L
.40476 .2754 L
.40737 .23514 L
.40998 .24972 L
.41259 .25617 L
Mistroke
.4152 .26077 L
.41781 .26503 L
.42042 .26892 L
.42303 .27169 L
.42564 .25347 L
.42825 .26719 L
.43085 .27306 L
.43346 .27762 L
.43607 .28153 L
.43868 .28527 L
.44129 .28805 L
.4439 .2282 L
.44651 .24227 L
.44912 .2482 L
.45173 .25267 L
.45434 .25666 L
.45695 .2605 L
.45956 .26338 L
.46217 .23213 L
.46477 .24429 L
.46738 .2496 L
.46999 .25359 L
.4726 .25702 L
.47521 .26037 L
.47782 .26294 L
.48043 .28612 L
.48304 .3012 L
.48565 .30769 L
.48826 .31268 L
.49087 .31686 L
.49348 .32095 L
.49609 .32412 L
.4987 .28211 L
.5013 .29602 L
.50391 .30223 L
.50652 .30687 L
.50913 .31081 L
.51174 .31462 L
.51435 .31748 L
.51696 .29564 L
.51957 .30812 L
.52218 .31359 L
.52479 .31777 L
.5274 .32137 L
.53001 .32482 L
.53262 .32731 L
.53523 .24008 L
.53783 .25635 L
.54044 .26318 L
.54305 .26849 L
Mistroke
.54566 .27304 L
.54827 .2776 L
.55088 .28066 L
.55349 .19347 L
.5561 .21057 L
.55871 .21785 L
.56132 .22334 L
.56393 .22825 L
.56654 .23312 L
.56915 .23629 L
.57175 .06942 L
.57436 .09224 L
.57697 .10189 L
.57958 .10914 L
.58219 .11543 L
.5848 .12129 L
.58741 .12553 L
.59002 .1308 L
.59263 .15374 L
.59524 .1635 L
.59785 .17067 L
.60046 .17718 L
.60307 .18291 L
.60568 .18715 L
.60828 .20823 L
.61089 .23185 L
.6135 .24181 L
.61611 .24929 L
.61872 .25611 L
.62133 .2621 L
.62394 .26656 L
.62655 .24881 L
.62916 .27173 L
.63177 .28138 L
.63438 .28859 L
.63699 .29492 L
.6396 .30082 L
.6422 .30505 L
.64481 .29252 L
.64742 .31513 L
.65003 .32472 L
.65264 .33178 L
.65525 .338 L
.65786 .34365 L
.66047 .34781 L
.66308 .40229 L
.66569 .428 L
.6683 .43858 L
.67091 .44665 L
.67352 .45387 L
Mistroke
.67613 .46028 L
.67873 .46501 L
.68134 .31009 L
.68395 .33689 L
.68656 .34811 L
.68917 .3566 L
.69178 .3642 L
.69439 .37103 L
.697 .37609 L
.69961 .49252 L
.70222 .52345 L
.70483 .53635 L
.70744 .54579 L
.71005 .5541 L
.71265 .56179 L
.71526 .56746 L
.71787 .46353 L
.72048 .49372 L
.72309 .50634 L
.7257 .51555 L
.72831 .52357 L
.73092 .53103 L
.73353 .53662 L
.73614 .32829 L
.73875 .36004 L
.74136 .37322 L
.74397 .38312 L
.74658 .39161 L
.74918 .39964 L
.75179 .40543 L
.7544 .44061 L
.75701 .47298 L
.75962 .48648 L
.76223 .49633 L
.76484 .50499 L
.76745 .51283 L
.77006 .51879 L
.77267 .4188 L
.77528 .45022 L
.77789 .46334 L
.7805 .47295 L
.78311 .48131 L
.78571 .4889 L
.78832 .49469 L
.79093 .52628 L
.79354 .55813 L
.79615 .57147 L
.79876 .5811 L
.80137 .58992 L
.80398 .59766 L
Mistroke
.80659 .60332 L
.8092 .38353 L
.81181 .41737 L
.81442 .43138 L
.81703 .44197 L
.81963 .45129 L
.82224 .45959 L
.82485 .4658 L
.82746 .45131 L
.83007 .48447 L
.83268 .49832 L
.83529 .50854 L
.8379 .51753 L
.84051 .52566 L
.84312 .53167 L
.84573 .33049 L
.84834 .36475 L
.85095 .37886 L
.85356 .38935 L
.85616 .39862 L
.85877 .40705 L
.86138 .41316 L
.86399 .32815 L
.8666 .36127 L
.86921 .37493 L
.87182 .38495 L
.87443 .39376 L
.87704 .40189 L
.87965 .40791 L
.88226 .47212 L
.88487 .50692 L
.88748 .52134 L
.89008 .53201 L
.89269 .54137 L
.8953 .54992 L
.89791 .5562 L
.90052 .35309 L
.90313 .38857 L
.90574 .40311 L
.90835 .41393 L
.91096 .42336 L
.91357 .43212 L
.91618 .43859 L
.91879 .30179 L
.9214 .33622 L
.92401 .3506 L
.92661 .36123 L
.92922 .37054 L
.93183 .37929 L
.93444 .38562 L
Mistroke
.93705 .31401 L
.93966 .34713 L
.94227 .36084 L
.94488 .37084 L
.94749 .37967 L
.9501 .38784 L
.95271 .39367 L
.95532 .2852 L
.95793 .31702 L
.96053 .33015 L
.96314 .33985 L
.96575 .3484 L
.96836 .3566 L
.97097 .36234 L
.97358 .32821 L
.97619 .35894 L
Mfstroke
0 0 1 r
gsave
.97619 .32833 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23703 m
.02642 .23747 L
.02903 .23779 L
.03164 .23781 L
.03425 .23799 L
.03686 .23827 L
.03947 .23823 L
.04207 .2799 L
.04468 .28033 L
.04729 .28067 L
.0499 .28069 L
.05251 .2808 L
.05512 .28095 L
.05773 .28092 L
.06034 .31025 L
.06295 .31075 L
.06556 .31103 L
.06817 .31096 L
.07078 .31112 L
.07339 .31141 L
.07599 .31137 L
.0786 .31776 L
.08121 .31807 L
.08382 .31842 L
.08643 .31848 L
.08904 .31864 L
.09165 .31881 L
.09426 .31883 L
.09687 .36054 L
.09948 .36085 L
.10209 .36128 L
.1047 .36145 L
.10731 .36165 L
.10992 .36189 L
.11252 .36186 L
.11513 .37667 L
.11774 .37696 L
.12035 .3773 L
.12296 .37745 L
.12557 .37757 L
.12818 .37783 L
.13079 .37792 L
.1334 .38226 L
.13601 .38257 L
.13862 .38293 L
.14123 .38315 L
.14384 .38322 L
.14644 .38356 L
.14905 .38361 L
.15166 .32253 L
Mistroke
.15427 .32295 L
.15688 .3234 L
.15949 .32342 L
.1621 .32352 L
.16471 .3238 L
.16732 .32377 L
.16993 .32143 L
.17254 .32174 L
.17515 .32222 L
.17776 .32241 L
.18037 .3225 L
.18297 .32279 L
.18558 .32293 L
.18819 .30005 L
.1908 .3004 L
.19341 .30078 L
.19602 .30098 L
.19863 .30117 L
.20124 .30148 L
.20385 .30152 L
.20646 .24386 L
.20907 .2442 L
.21168 .24452 L
.21429 .2446 L
.21689 .24468 L
.2195 .24489 L
.22211 .24491 L
.22472 .25159 L
.22733 .252 L
.22994 .25245 L
.23255 .25255 L
.23516 .25267 L
.23777 .25297 L
.24038 .25297 L
.24299 .24911 L
.2456 .24948 L
.24821 .24977 L
.25082 .24992 L
.25342 .25011 L
.25603 .2504 L
.25864 .25041 L
.26125 .254 L
.26386 .25432 L
.26647 .25467 L
.26908 .25481 L
.27169 .25499 L
.2743 .25539 L
.27691 .2556 L
.27952 .23351 L
.28213 .23384 L
Mistroke
.28474 .23414 L
.28735 .23429 L
.28995 .23447 L
.29256 .23479 L
.29517 .23485 L
.29778 .23275 L
.30039 .23308 L
.303 .23339 L
.30561 .2335 L
.30822 .23364 L
.31083 .23402 L
.31344 .23416 L
.31605 .26195 L
.31866 .26237 L
.32127 .26265 L
.32387 .26288 L
.32648 .2631 L
.32909 .26347 L
.3317 .26357 L
.33431 .2666 L
.33692 .26695 L
.33953 .2673 L
.34214 .26754 L
.34475 .26783 L
.34736 .26819 L
.34997 .26834 L
.35258 .30117 L
.35519 .30152 L
.3578 .30191 L
.3604 .30213 L
.36301 .30225 L
.36562 .30256 L
.36823 .30277 L
.37084 .29782 L
.37345 .29823 L
.37606 .29851 L
.37867 .29878 L
.38128 .29901 L
.38389 .2994 L
.3865 .29949 L
.38911 .2364 L
.39172 .23678 L
.39432 .23717 L
.39693 .23729 L
.39954 .23746 L
.40215 .23766 L
.40476 .23766 L
.40737 .23498 L
.40998 .23532 L
.41259 .23574 L
Mistroke
.4152 .23584 L
.41781 .23603 L
.42042 .23629 L
.42303 .2363 L
.42564 .2533 L
.42825 .25365 L
.43085 .25395 L
.43346 .25412 L
.43607 .25431 L
.43868 .25456 L
.44129 .25464 L
.4439 .22804 L
.44651 .22842 L
.44912 .22872 L
.45173 .22889 L
.45434 .22903 L
.45695 .22931 L
.45956 .22942 L
.46217 .23197 L
.46477 .23228 L
.46738 .2327 L
.46999 .23296 L
.4726 .23313 L
.47521 .23343 L
.47782 .23354 L
.48043 .28596 L
.48304 .28627 L
.48565 .2866 L
.48826 .28672 L
.49087 .28683 L
.49348 .28711 L
.49609 .28723 L
.4987 .28194 L
.5013 .28239 L
.50391 .2828 L
.50652 .28302 L
.50913 .28311 L
.51174 .28343 L
.51435 .2835 L
.51696 .29548 L
.51957 .29582 L
.52218 .29618 L
.52479 .29641 L
.5274 .29657 L
.53001 .29687 L
.53262 .29694 L
.53523 .23992 L
.53783 .24038 L
.54044 .24072 L
.54305 .2409 L
Mistroke
.54566 .24105 L
.54827 .24133 L
.55088 .24134 L
.55349 .1933 L
.5561 .19375 L
.55871 .19411 L
.56132 .19418 L
.56393 .19434 L
.56654 .19472 L
.56915 .19479 L
.57175 .06926 L
.57436 .06961 L
.57697 .06997 L
.57958 .06998 L
.58219 .07001 L
.5848 .07024 L
.58741 .07012 L
.59002 .13064 L
.59263 .13102 L
.59524 .13136 L
.59785 .13135 L
.60046 .1314 L
.60307 .13152 L
.60568 .13132 L
.60828 .20806 L
.61089 .20843 L
.6135 .20873 L
.61611 .20865 L
.61872 .20866 L
.62133 .20878 L
.62394 .20856 L
.62655 .24864 L
.62916 .24896 L
.63177 .2493 L
.63438 .24925 L
.63699 .2493 L
.6396 .24952 L
.6422 .24941 L
.64481 .29235 L
.64742 .29289 L
.65003 .29321 L
.65264 .29328 L
.65525 .29336 L
.65786 .29353 L
.66047 .29344 L
.66308 .40212 L
.66569 .40251 L
.6683 .40275 L
.67091 .4027 L
.67352 .40273 L
Mistroke
.67613 .4028 L
.67873 .40256 L
.68134 .30993 L
.68395 .31022 L
.68656 .3105 L
.68917 .3105 L
.69178 .31044 L
.69439 .31056 L
.697 .31036 L
.69961 .49236 L
.70222 .49259 L
.70483 .49284 L
.70744 .49264 L
.71005 .49243 L
.71265 .4924 L
.71526 .49207 L
.71787 .46337 L
.72048 .4637 L
.72309 .46398 L
.7257 .46383 L
.72831 .46351 L
.73092 .46344 L
.73353 .46322 L
.73614 .32812 L
.73875 .32838 L
.74136 .32858 L
.74397 .3284 L
.74658 .32829 L
.74918 .32834 L
.75179 .32797 L
.7544 .44044 L
.75701 .44077 L
.75962 .44102 L
.76223 .44079 L
.76484 .44061 L
.76745 .44057 L
.77006 .44024 L
.77267 .41863 L
.77528 .41895 L
.77789 .41926 L
.7805 .41914 L
.78311 .41894 L
.78571 .41893 L
.78832 .41848 L
.79093 .52611 L
.79354 .52647 L
.79615 .52682 L
.79876 .52657 L
.80137 .52636 L
.80398 .52621 L
Mistroke
.80659 .52582 L
.8092 .38337 L
.81181 .38375 L
.81442 .38395 L
.81703 .38384 L
.81963 .38371 L
.82224 .3836 L
.82485 .38325 L
.82746 .45115 L
.83007 .45141 L
.83268 .45167 L
.83529 .45149 L
.8379 .4513 L
.84051 .45126 L
.84312 .45076 L
.84573 .33033 L
.84834 .33068 L
.85095 .33089 L
.85356 .33074 L
.85616 .33049 L
.85877 .33054 L
.86138 .32999 L
.86399 .32799 L
.8666 .32835 L
.86921 .32861 L
.87182 .32839 L
.87443 .32817 L
.87704 .3282 L
.87965 .32764 L
.88226 .47196 L
.88487 .47218 L
.88748 .47235 L
.89008 .47209 L
.89269 .4718 L
.8953 .47178 L
.89791 .4712 L
.90052 .35293 L
.90313 .35324 L
.90574 .35341 L
.90835 .35313 L
.91096 .35283 L
.91357 .35276 L
.91618 .3523 L
.91879 .30163 L
.9214 .30189 L
.92401 .30211 L
.92661 .3018 L
.92922 .30147 L
.93183 .30152 L
.93444 .30106 L
Mistroke
.93705 .31384 L
.93966 .31409 L
.94227 .31433 L
.94488 .31403 L
.94749 .31382 L
.9501 .3137 L
.95271 .31321 L
.95532 .28503 L
.95793 .28539 L
.96053 .2855 L
.96314 .28527 L
.96575 .28508 L
.96836 .28522 L
.97097 .28475 L
.97358 .32805 L
.97619 .32833 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00260926 -0.0327632 1.34274 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15427 -0.0125 -6 -9 ]
[.15427 -0.0125 6 0 ]
[.28474 -0.0125 -9 -9 ]
[.28474 -0.0125 9 0 ]
[.4152 -0.0125 -9 -9 ]
[.4152 -0.0125 9 0 ]
[.54566 -0.0125 -9 -9 ]
[.54566 -0.0125 9 0 ]
[.67613 -0.0125 -9 -9 ]
[.67613 -0.0125 9 0 ]
[.80659 -0.0125 -9 -9 ]
[.80659 -0.0125 9 0 ]
[.93705 -0.0125 -9 -9 ]
[.93705 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .10151 -18 -4.5 ]
[-0.0125 .10151 0 4.5 ]
[-0.0125 .23578 -18 -4.5 ]
[-0.0125 .23578 0 4.5 ]
[-0.0125 .37006 -18 -4.5 ]
[-0.0125 .37006 0 4.5 ]
[-0.0125 .50433 -18 -4.5 ]
[-0.0125 .50433 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .32938 -5 -6 ]
[.97619 .32938 5 6 ]
[.97619 .42848 -5 -6 ]
[.97619 .42848 5 6 ]
[.97619 .54023 -5 -6 ]
[.97619 .54023 5 6 ]
[.97619 .31673 -5 -6 ]
[.97619 .31673 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15427 0 m
.15427 .00625 L
s
[(50)] .15427 -0.0125 0 1 Mshowa
.28474 0 m
.28474 .00625 L
s
[(100)] .28474 -0.0125 0 1 Mshowa
.4152 0 m
.4152 .00625 L
s
[(150)] .4152 -0.0125 0 1 Mshowa
.54566 0 m
.54566 .00625 L
s
[(200)] .54566 -0.0125 0 1 Mshowa
.67613 0 m
.67613 .00625 L
s
[(250)] .67613 -0.0125 0 1 Mshowa
.80659 0 m
.80659 .00625 L
s
[(300)] .80659 -0.0125 0 1 Mshowa
.93705 0 m
.93705 .00625 L
s
[(350)] .93705 -0.0125 0 1 Mshowa
.125 Mabswid
.0499 0 m
.0499 .00375 L
s
.07599 0 m
.07599 .00375 L
s
.10209 0 m
.10209 .00375 L
s
.12818 0 m
.12818 .00375 L
s
.18037 0 m
.18037 .00375 L
s
.20646 0 m
.20646 .00375 L
s
.23255 0 m
.23255 .00375 L
s
.25864 0 m
.25864 .00375 L
s
.31083 0 m
.31083 .00375 L
s
.33692 0 m
.33692 .00375 L
s
.36301 0 m
.36301 .00375 L
s
.38911 0 m
.38911 .00375 L
s
.44129 0 m
.44129 .00375 L
s
.46738 0 m
.46738 .00375 L
s
.49348 0 m
.49348 .00375 L
s
.51957 0 m
.51957 .00375 L
s
.57175 0 m
.57175 .00375 L
s
.59785 0 m
.59785 .00375 L
s
.62394 0 m
.62394 .00375 L
s
.65003 0 m
.65003 .00375 L
s
.70222 0 m
.70222 .00375 L
s
.72831 0 m
.72831 .00375 L
s
.7544 0 m
.7544 .00375 L
s
.7805 0 m
.7805 .00375 L
s
.83268 0 m
.83268 .00375 L
s
.85877 0 m
.85877 .00375 L
s
.88487 0 m
.88487 .00375 L
s
.91096 0 m
.91096 .00375 L
s
.96314 0 m
.96314 .00375 L
s
.98924 0 m
.98924 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .10151 m
.00625 .10151 L
s
[(0.1)] -0.0125 .10151 1 0 Mshowa
0 .23578 m
.00625 .23578 L
s
[(0.2)] -0.0125 .23578 1 0 Mshowa
0 .37006 m
.00625 .37006 L
s
[(0.3)] -0.0125 .37006 1 0 Mshowa
0 .50433 m
.00625 .50433 L
s
[(0.4)] -0.0125 .50433 1 0 Mshowa
.125 Mabswid
0 .12837 m
.00375 .12837 L
s
0 .15522 m
.00375 .15522 L
s
0 .18208 m
.00375 .18208 L
s
0 .20893 m
.00375 .20893 L
s
0 .26264 m
.00375 .26264 L
s
0 .28949 m
.00375 .28949 L
s
0 .31635 m
.00375 .31635 L
s
0 .3432 m
.00375 .3432 L
s
0 .39691 m
.00375 .39691 L
s
0 .42377 m
.00375 .42377 L
s
0 .45062 m
.00375 .45062 L
s
0 .47748 m
.00375 .47748 L
s
0 .07466 m
.00375 .07466 L
s
0 .0478 m
.00375 .0478 L
s
0 .02095 m
.00375 .02095 L
s
0 .53119 m
.00375 .53119 L
s
0 .55804 m
.00375 .55804 L
s
0 .5849 m
.00375 .5849 L
s
0 .61175 m
.00375 .61175 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15427 .61178 m
.15427 .61803 L
s
.28474 .61178 m
.28474 .61803 L
s
.4152 .61178 m
.4152 .61803 L
s
.54566 .61178 m
.54566 .61803 L
s
.67613 .61178 m
.67613 .61803 L
s
.80659 .61178 m
.80659 .61803 L
s
.93705 .61178 m
.93705 .61803 L
s
.125 Mabswid
.0499 .61428 m
.0499 .61803 L
s
.07599 .61428 m
.07599 .61803 L
s
.10209 .61428 m
.10209 .61803 L
s
.12818 .61428 m
.12818 .61803 L
s
.18037 .61428 m
.18037 .61803 L
s
.20646 .61428 m
.20646 .61803 L
s
.23255 .61428 m
.23255 .61803 L
s
.25864 .61428 m
.25864 .61803 L
s
.31083 .61428 m
.31083 .61803 L
s
.33692 .61428 m
.33692 .61803 L
s
.36301 .61428 m
.36301 .61803 L
s
.38911 .61428 m
.38911 .61803 L
s
.44129 .61428 m
.44129 .61803 L
s
.46738 .61428 m
.46738 .61803 L
s
.49348 .61428 m
.49348 .61803 L
s
.51957 .61428 m
.51957 .61803 L
s
.57175 .61428 m
.57175 .61803 L
s
.59785 .61428 m
.59785 .61803 L
s
.62394 .61428 m
.62394 .61803 L
s
.65003 .61428 m
.65003 .61803 L
s
.70222 .61428 m
.70222 .61803 L
s
.72831 .61428 m
.72831 .61803 L
s
.7544 .61428 m
.7544 .61803 L
s
.7805 .61428 m
.7805 .61803 L
s
.83268 .61428 m
.83268 .61803 L
s
.85877 .61428 m
.85877 .61803 L
s
.88487 .61428 m
.88487 .61803 L
s
.91096 .61428 m
.91096 .61803 L
s
.96314 .61428 m
.96314 .61803 L
s
.98924 .61428 m
.98924 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .10151 m
1 .10151 L
s
.99375 .23578 m
1 .23578 L
s
.99375 .37006 m
1 .37006 L
s
.99375 .50433 m
1 .50433 L
s
.125 Mabswid
.99625 .12837 m
1 .12837 L
s
.99625 .15522 m
1 .15522 L
s
.99625 .18208 m
1 .18208 L
s
.99625 .20893 m
1 .20893 L
s
.99625 .26264 m
1 .26264 L
s
.99625 .28949 m
1 .28949 L
s
.99625 .31635 m
1 .31635 L
s
.99625 .3432 m
1 .3432 L
s
.99625 .39691 m
1 .39691 L
s
.99625 .42377 m
1 .42377 L
s
.99625 .45062 m
1 .45062 L
s
.99625 .47748 m
1 .47748 L
s
.99625 .07466 m
1 .07466 L
s
.99625 .0478 m
1 .0478 L
s
.99625 .02095 m
1 .02095 L
s
.99625 .53119 m
1 .53119 L
s
.99625 .55804 m
1 .55804 L
s
.99625 .5849 m
1 .5849 L
s
.99625 .61175 m
1 .61175 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.97619 .32938 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.02381 .23578 m
.02642 .24107 L
.02903 .23577 L
.03164 .2524 L
.03425 .26733 L
.03686 .25744 L
.03947 .24095 L
.04207 .2428 L
.04468 .25846 L
.04729 .28222 L
.0499 .27915 L
.05251 .27955 L
.05512 .31744 L
.05773 .34345 L
.06034 .3463 L
.06295 .34336 L
.06556 .32461 L
.06817 .3195 L
.07078 .3322 L
.07339 .31021 L
.07599 .31631 L
.0786 .31331 L
.08121 .29575 L
.08382 .2981 L
.08643 .28672 L
.08904 .29797 L
.09165 .29194 L
.09426 .27491 L
.09687 .26319 L
.09948 .23396 L
.10209 .23341 L
.1047 .21282 L
.10731 .21877 L
.10992 .23207 L
.11252 .22036 L
.11513 .21954 L
.11774 .21268 L
.12035 .21082 L
.12296 .22084 L
.12557 .22529 L
.12818 .227 L
.13079 .24952 L
.1334 .24419 L
.13601 .25354 L
.13862 .25237 L
.14123 .2367 L
.14384 .25562 L
.14644 .28651 L
.14905 .2809 L
.15166 .27358 L
Mistroke
.15427 .25832 L
.15688 .27037 L
.15949 .2616 L
.1621 .26912 L
.16471 .25444 L
.16732 .24726 L
.16993 .2679 L
.17254 .26433 L
.17515 .25396 L
.17776 .27163 L
.18037 .23858 L
.18297 .2224 L
.18558 .21815 L
.18819 .19565 L
.1908 .1809 L
.19341 .20241 L
.19602 .19085 L
.19863 .21257 L
.20124 .20054 L
.20385 .21438 L
.20646 .20963 L
.20907 .20495 L
.21168 .21611 L
.21429 .20122 L
.21689 .2208 L
.2195 .22651 L
.22211 .2125 L
.22472 .2375 L
.22733 .20711 L
.22994 .2053 L
.23255 .21644 L
.23516 .22058 L
.23777 .23765 L
.24038 .22442 L
.24299 .20881 L
.2456 .2019 L
.24821 .20605 L
.25082 .20353 L
.25342 .19878 L
.25603 .2101 L
.25864 .20518 L
.26125 .22259 L
.26386 .22519 L
.26647 .22482 L
.26908 .24779 L
.27169 .24019 L
.2743 .24025 L
.27691 .2474 L
.27952 .24247 L
.28213 .26089 L
Mistroke
.28474 .26088 L
.28735 .24873 L
.28995 .23696 L
.29256 .2213 L
.29517 .21705 L
.29778 .20981 L
.30039 .21154 L
.303 .20971 L
.30561 .20095 L
.30822 .20848 L
.31083 .21028 L
.31344 .22229 L
.31605 .21456 L
.31866 .23625 L
.32127 .25342 L
.32387 .23727 L
.32648 .23298 L
.32909 .2282 L
.3317 .24488 L
.33431 .22518 L
.33692 .24296 L
.33953 .24387 L
.34214 .24797 L
.34475 .24105 L
.34736 .22696 L
.34997 .21747 L
.35258 .21957 L
.35519 .24734 L
.3578 .23534 L
.3604 .25501 L
.36301 .25778 L
.36562 .24718 L
.36823 .22662 L
.37084 .25022 L
.37345 .2637 L
.37606 .26208 L
.37867 .25903 L
.38128 .25656 L
.38389 .24526 L
.3865 .23121 L
.38911 .23525 L
.39172 .25605 L
.39432 .27699 L
.39693 .2704 L
.39954 .2674 L
.40215 .26952 L
.40476 .28297 L
.40737 .26081 L
.40998 .25538 L
.41259 .24827 L
Mistroke
.4152 .25379 L
.41781 .26437 L
.42042 .24305 L
.42303 .23864 L
.42564 .26066 L
.42825 .24458 L
.43085 .26099 L
.43346 .27344 L
.43607 .29679 L
.43868 .28133 L
.44129 .29989 L
.4439 .32876 L
.44651 .34186 L
.44912 .34285 L
.45173 .34101 L
.45434 .33086 L
.45695 .33561 L
.45956 .36077 L
.46217 .37157 L
.46477 .36924 L
.46738 .39129 L
.46999 .37243 L
.4726 .37658 L
.47521 .37186 L
.47782 .37233 L
.48043 .40179 L
.48304 .40266 L
.48565 .40919 L
.48826 .41274 L
.49087 .40304 L
.49348 .42836 L
.49609 .39677 L
.4987 .35808 L
.5013 .36753 L
.50391 .36259 L
.50652 .35394 L
.50913 .34176 L
.51174 .35112 L
.51435 .37138 L
.51696 .36214 L
.51957 .37567 L
.52218 .34163 L
.52479 .34911 L
.5274 .38262 L
.53001 .38337 L
.53262 .39799 L
.53523 .40308 L
.53783 .42153 L
.54044 .43187 L
.54305 .43357 L
Mistroke
.54566 .40943 L
.54827 .40833 L
.55088 .42437 L
.55349 .43797 L
.5561 .46133 L
.55871 .46795 L
.56132 .46934 L
.56393 .47518 L
.56654 .4537 L
.56915 .44861 L
.57175 .41498 L
.57436 .42685 L
.57697 .44841 L
.57958 .47878 L
.58219 .48526 L
.5848 .47396 L
.58741 .48196 L
.59002 .4777 L
.59263 .48743 L
.59524 .49932 L
.59785 .48912 L
.60046 .47504 L
.60307 .47158 L
.60568 .44508 L
.60828 .46196 L
.61089 .45868 L
.6135 .47902 L
.61611 .45431 L
.61872 .43382 L
.62133 .42132 L
.62394 .42398 L
.62655 .43522 L
.62916 .42689 L
.63177 .43586 L
.63438 .44011 L
.63699 .45628 L
.6396 .44841 L
.6422 .43746 L
.64481 .45132 L
.64742 .46064 L
.65003 .43362 L
.65264 .45115 L
.65525 .43944 L
.65786 .42827 L
.66047 .43962 L
.66308 .45593 L
.66569 .44763 L
.6683 .46983 L
.67091 .47983 L
.67352 .48682 L
Mistroke
.67613 .48158 L
.67873 .45393 L
.68134 .46773 L
.68395 .45033 L
.68656 .44712 L
.68917 .45388 L
.69178 .43238 L
.69439 .43176 L
.697 .45683 L
.69961 .47311 L
.70222 .44638 L
.70483 .43612 L
.70744 .4278 L
.71005 .43097 L
.71265 .42425 L
.71526 .4319 L
.71787 .41339 L
.72048 .40644 L
.72309 .39799 L
.7257 .38307 L
.72831 .39669 L
.73092 .40754 L
.73353 .42349 L
.73614 .42957 L
.73875 .41284 L
.74136 .40334 L
.74397 .39968 L
.74658 .41269 L
.74918 .42285 L
.75179 .42894 L
.7544 .45029 L
.75701 .45915 L
.75962 .47294 L
.76223 .45992 L
.76484 .45458 L
.76745 .43287 L
.77006 .421 L
.77267 .42979 L
.77528 .45901 L
.77789 .48706 L
.7805 .50419 L
.78311 .47771 L
.78571 .46945 L
.78832 .49526 L
.79093 .49406 L
.79354 .4875 L
.79615 .48391 L
.79876 .48066 L
.80137 .48143 L
.80398 .50778 L
Mistroke
.80659 .50887 L
.8092 .50612 L
.81181 .49233 L
.81442 .51829 L
.81703 .49916 L
.81963 .49952 L
.82224 .51176 L
.82485 .50565 L
.82746 .51436 L
.83007 .50923 L
.83268 .50978 L
.83529 .50693 L
.8379 .50411 L
.84051 .51937 L
.84312 .50901 L
.84573 .51234 L
.84834 .52614 L
.85095 .52633 L
.85356 .52352 L
.85616 .51644 L
.85877 .49314 L
.86138 .50716 L
.86399 .49875 L
.8666 .47797 L
.86921 .46655 L
.87182 .45879 L
.87443 .44494 L
.87704 .43387 L
.87965 .42751 L
.88226 .42317 L
.88487 .41468 L
.88748 .43588 L
.89008 .43327 L
.89269 .45014 L
.8953 .45942 L
.89791 .43601 L
.90052 .43996 L
.90313 .43164 L
.90574 .42521 L
.90835 .43662 L
.91096 .39826 L
.91357 .39904 L
.91618 .38769 L
.91879 .39721 L
.9214 .41122 L
.92401 .40721 L
.92661 .41375 L
.92922 .39467 L
.93183 .38394 L
.93444 .40347 L
Mistroke
.93705 .40789 L
.93966 .38964 L
.94227 .39159 L
.94488 .39994 L
.94749 .39473 L
.9501 .40035 L
.95271 .40204 L
.95532 .37961 L
.95793 .38031 L
.96053 .36524 L
.96314 .37596 L
.96575 .35128 L
.96836 .34771 L
.97097 .33457 L
.97358 .31988 L
.97619 .32938 L
Mfstroke
0 0 1 r
gsave
.97619 .42848 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23602 m
.02642 .23603 L
.02903 .23585 L
.03164 .23583 L
.03425 .23577 L
.03686 .23582 L
.03947 .23593 L
.04207 .2582 L
.04468 .25815 L
.04729 .25791 L
.0499 .25783 L
.05251 .25771 L
.05512 .2577 L
.05773 .25775 L
.06034 .23869 L
.06295 .23869 L
.06556 .2385 L
.06817 .23847 L
.07078 .23841 L
.07339 .23845 L
.07599 .23855 L
.0786 .19974 L
.08121 .19984 L
.08382 .19976 L
.08643 .19984 L
.08904 .19987 L
.09165 .20003 L
.09426 .20023 L
.09687 .21293 L
.09948 .213 L
.10209 .21288 L
.1047 .21293 L
.10731 .21293 L
.10992 .21305 L
.11252 .21321 L
.11513 .18684 L
.11774 .18699 L
.12035 .18694 L
.12296 .18705 L
.12557 .18712 L
.12818 .18731 L
.13079 .18755 L
.1334 .14809 L
.13601 .14833 L
.13862 .14839 L
.14123 .14861 L
.14384 .14879 L
.14644 .14908 L
.14905 .14943 L
.15166 .21993 L
Mistroke
.15427 .21998 L
.15688 .21985 L
.15949 .21987 L
.1621 .21985 L
.16471 .21995 L
.16732 .2201 L
.16993 .19486 L
.17254 .19498 L
.17515 .19491 L
.17776 .195 L
.18037 .19505 L
.18297 .19522 L
.18558 .19543 L
.18819 .18209 L
.1908 .18224 L
.19341 .18221 L
.19602 .18233 L
.19863 .18242 L
.20124 .18262 L
.20385 .18287 L
.20646 .22465 L
.20907 .22468 L
.21168 .22453 L
.21429 .22454 L
.21689 .22451 L
.2195 .2246 L
.22211 .22474 L
.22472 .20358 L
.22733 .20368 L
.22994 .20358 L
.23255 .20365 L
.23516 .20368 L
.23777 .20382 L
.24038 .20401 L
.24299 .17364 L
.2456 .17382 L
.24821 .1738 L
.25082 .17395 L
.25342 .17406 L
.25603 .17429 L
.25864 .17456 L
.26125 .12059 L
.26386 .12091 L
.26647 .12105 L
.26908 .12134 L
.27169 .12159 L
.2743 .12196 L
.27691 .12238 L
.27952 .14509 L
.28213 .14535 L
Mistroke
.28474 .14541 L
.28735 .14564 L
.28995 .14583 L
.29256 .14613 L
.29517 .14648 L
.29778 .10938 L
.30039 .10973 L
.303 .1099 L
.30561 .11022 L
.30822 .11051 L
.31083 .1109 L
.31344 .11135 L
.31605 .13506 L
.31866 .13534 L
.32127 .13544 L
.32387 .13569 L
.32648 .13591 L
.32909 .13623 L
.3317 .13661 L
.33431 .10481 L
.33692 .10518 L
.33953 .10535 L
.34214 .10569 L
.34475 .10598 L
.34736 .10639 L
.34997 .10686 L
.35258 .14074 L
.35519 .14101 L
.3578 .14109 L
.3604 .14133 L
.36301 .14153 L
.36562 .14184 L
.36823 .1422 L
.37084 .11736 L
.37345 .1177 L
.37606 .11784 L
.37867 .11814 L
.38128 .1184 L
.38389 .11878 L
.3865 .11921 L
.38911 .19551 L
.39172 .19563 L
.39432 .19555 L
.39693 .19564 L
.39954 .19569 L
.40215 .19586 L
.40476 .19607 L
.40737 .17778 L
.40998 .17794 L
.41259 .17792 L
Mistroke
.4152 .17806 L
.41781 .17816 L
.42042 .17837 L
.42303 .17863 L
.42564 .16229 L
.42825 .1625 L
.43085 .16252 L
.43346 .1627 L
.43607 .16284 L
.43868 .16309 L
.44129 .1634 L
.4439 .16749 L
.44651 .16769 L
.44912 .16769 L
.45173 .16786 L
.45434 .16799 L
.45695 .16823 L
.45956 .16852 L
.46217 .13434 L
.46477 .13462 L
.46738 .13472 L
.46999 .13498 L
.4726 .13519 L
.47521 .13552 L
.47782 .1359 L
.48043 .18913 L
.48304 .18926 L
.48565 .18921 L
.48826 .18932 L
.49087 .18938 L
.49348 .18957 L
.49609 .1898 L
.4987 .16539 L
.5013 .16559 L
.50391 .1656 L
.50652 .16578 L
.50913 .16591 L
.51174 .16615 L
.51435 .16645 L
.51696 .14109 L
.51957 .14136 L
.52218 .14144 L
.52479 .14168 L
.5274 .14187 L
.53001 .14218 L
.53262 .14255 L
.53523 .20407 L
.53783 .20417 L
.54044 .20407 L
.54305 .20414 L
Mistroke
.54566 .20417 L
.54827 .20431 L
.55088 .2045 L
.55349 .21931 L
.5561 .21936 L
.55871 .21923 L
.56132 .21925 L
.56393 .21924 L
.56654 .21934 L
.56915 .21949 L
.57175 .31087 L
.57436 .31067 L
.57697 .31029 L
.57958 .31006 L
.58219 .3098 L
.5848 .30965 L
.58741 .30955 L
.59002 .31186 L
.59263 .31166 L
.59524 .31127 L
.59785 .31104 L
.60046 .31078 L
.60307 .31063 L
.60568 .31053 L
.60828 .32438 L
.61089 .32414 L
.6135 .32372 L
.61611 .32346 L
.61872 .32316 L
.62133 .32297 L
.62394 .32284 L
.62655 .31105 L
.62916 .31085 L
.63177 .31047 L
.63438 .31024 L
.63699 .30998 L
.6396 .30983 L
.6422 .30973 L
.64481 .30245 L
.64742 .30228 L
.65003 .30191 L
.65264 .30171 L
.65525 .30147 L
.65786 .30135 L
.66047 .30127 L
.66308 .35441 L
.66569 .35409 L
.6683 .35359 L
.67091 .35324 L
.67352 .35286 L
Mistroke
.67613 .3526 L
.67873 .35238 L
.68134 .37418 L
.68395 .37381 L
.68656 .37325 L
.68917 .37285 L
.69178 .37242 L
.69439 .3721 L
.697 .37183 L
.69961 .44091 L
.70222 .44035 L
.70483 .43961 L
.70744 .43903 L
.71005 .43842 L
.71265 .43791 L
.71526 .43747 L
.71787 .42672 L
.72048 .42621 L
.72309 .4255 L
.7257 .42496 L
.72831 .42439 L
.73092 .42392 L
.73353 .42351 L
.73614 .4533 L
.73875 .45271 L
.74136 .45194 L
.74397 .45132 L
.74658 .45067 L
.74918 .45014 L
.75179 .44966 L
.7544 .4612 L
.75701 .46059 L
.75962 .45979 L
.76223 .45916 L
.76484 .45849 L
.76745 .45793 L
.77006 .45743 L
.77267 .44428 L
.77528 .44372 L
.77789 .44297 L
.7805 .44238 L
.78311 .44175 L
.78571 .44124 L
.78832 .44079 L
.79093 .45327 L
.79354 .45269 L
.79615 .45191 L
.79876 .4513 L
.80137 .45065 L
.80398 .45011 L
Mistroke
.80659 .44963 L
.8092 .4826 L
.81181 .48193 L
.81442 .48107 L
.81703 .48038 L
.81963 .47965 L
.82224 .47903 L
.82485 .47847 L
.82746 .4725 L
.83007 .47186 L
.83268 .47103 L
.83529 .47037 L
.8379 .46966 L
.84051 .46908 L
.84312 .46855 L
.84573 .4887 L
.84834 .48802 L
.85095 .48714 L
.85356 .48643 L
.85616 .48569 L
.85877 .48506 L
.86138 .48448 L
.86399 .46718 L
.8666 .46655 L
.86921 .46574 L
.87182 .46509 L
.87443 .4644 L
.87704 .46383 L
.87965 .46331 L
.88226 .49874 L
.88487 .49803 L
.88748 .49713 L
.89008 .49639 L
.89269 .49562 L
.8953 .49496 L
.89791 .49436 L
.90052 .5083 L
.90313 .50756 L
.90574 .50663 L
.90835 .50587 L
.91096 .50507 L
.91357 .50438 L
.91618 .50376 L
.91879 .49342 L
.9214 .49272 L
.92401 .49184 L
.92661 .49112 L
.92922 .49036 L
.93183 .48971 L
.93444 .48912 L
Mistroke
.93705 .46974 L
.93966 .46911 L
.94227 .46829 L
.94488 .46763 L
.94749 .46694 L
.9501 .46636 L
.95271 .46583 L
.95532 .44868 L
.95793 .4481 L
.96053 .44734 L
.96314 .44674 L
.96575 .4461 L
.96836 .44558 L
.97097 .44511 L
.97358 .42898 L
.97619 .42848 L
Mfstroke
0 .98 .604 r
gsave
.97619 .54023 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3715 m
.02642 .37189 L
.02903 .37235 L
.03164 .3726 L
.03425 .3726 L
.03686 .37301 L
.03947 .37362 L
.04207 .36693 L
.04468 .36754 L
.04729 .36792 L
.0499 .36859 L
.05251 .36883 L
.05512 .36928 L
.05773 .36992 L
.06034 .34333 L
.06295 .34392 L
.06556 .3445 L
.06817 .34509 L
.07078 .34532 L
.07339 .34599 L
.07599 .3468 L
.0786 .30476 L
.08121 .30542 L
.08382 .30634 L
.08643 .30714 L
.08904 .30782 L
.09165 .30851 L
.09426 .3095 L
.09687 .3091 L
.09948 .3101 L
.10209 .31092 L
.1047 .31161 L
.10731 .31219 L
.10992 .31327 L
.11252 .31447 L
.11513 .28342 L
.11774 .28452 L
.12035 .28539 L
.12296 .28616 L
.12557 .28684 L
.12818 .28793 L
.13079 .28904 L
.1334 .24574 L
.13601 .24679 L
.13862 .24759 L
.14123 .24845 L
.14384 .24913 L
.14644 .25029 L
.14905 .25147 L
.15166 .30975 L
Mistroke
.15427 .31063 L
.15688 .31122 L
.15949 .31189 L
.1621 .31293 L
.16471 .31389 L
.16732 .31501 L
.16993 .28724 L
.17254 .28828 L
.17515 .28907 L
.17776 .28986 L
.18037 .29084 L
.18297 .29177 L
.18558 .29296 L
.18819 .27527 L
.1908 .27619 L
.19341 .27688 L
.19602 .27773 L
.19863 .27857 L
.20124 .27954 L
.20385 .28035 L
.20646 .31136 L
.20907 .31221 L
.21168 .31305 L
.21429 .31411 L
.21689 .31484 L
.2195 .31583 L
.22211 .31702 L
.22472 .29353 L
.22733 .2947 L
.22994 .29548 L
.23255 .29664 L
.23516 .29742 L
.23777 .29852 L
.24038 .2995 L
.24299 .26895 L
.2456 .26993 L
.24821 .2708 L
.25082 .27165 L
.25342 .27246 L
.25603 .2735 L
.25864 .27468 L
.26125 .22484 L
.26386 .22581 L
.26647 .22648 L
.26908 .22741 L
.27169 .22817 L
.2743 .22899 L
.27691 .23004 L
.27952 .2338 L
.28213 .23508 L
Mistroke
.28474 .23606 L
.28735 .23692 L
.28995 .23792 L
.29256 .23892 L
.29517 .2403 L
.29778 .1977 L
.30039 .19884 L
.303 .19977 L
.30561 .2009 L
.30822 .20209 L
.31083 .20337 L
.31344 .20486 L
.31605 .21403 L
.31866 .21526 L
.32127 .21631 L
.32387 .21746 L
.32648 .21854 L
.32909 .21974 L
.3317 .22108 L
.33431 .18485 L
.33692 .1863 L
.33953 .18759 L
.34214 .18896 L
.34475 .19016 L
.34736 .19154 L
.34997 .19288 L
.35258 .21436 L
.35519 .21584 L
.3578 .21735 L
.3604 .2185 L
.36301 .21974 L
.36562 .22126 L
.36823 .22287 L
.37084 .19489 L
.37345 .19635 L
.37606 .1976 L
.37867 .19895 L
.38128 .2 L
.38389 .20152 L
.3865 .20306 L
.38911 .26574 L
.39172 .26715 L
.39432 .26844 L
.39693 .26967 L
.39954 .27094 L
.40215 .27218 L
.40476 .27334 L
.40737 .25192 L
.40998 .2531 L
.41259 .25438 L
Mistroke
.4152 .25561 L
.41781 .25666 L
.42042 .25775 L
.42303 .25907 L
.42564 .23947 L
.42825 .24072 L
.43085 .24176 L
.43346 .24287 L
.43607 .24383 L
.43868 .24507 L
.44129 .24658 L
.4439 .24162 L
.44651 .24308 L
.44912 .24433 L
.45173 .24543 L
.45434 .24633 L
.45695 .24757 L
.45956 .24905 L
.46217 .21647 L
.46477 .21784 L
.46738 .21874 L
.46999 .22006 L
.4726 .22128 L
.47521 .22271 L
.47782 .224 L
.48043 .25965 L
.48304 .26111 L
.48565 .26254 L
.48826 .26376 L
.49087 .26496 L
.49348 .26626 L
.49609 .26764 L
.4987 .24352 L
.5013 .24478 L
.50391 .24586 L
.50652 .24694 L
.50913 .24826 L
.51174 .24948 L
.51435 .25094 L
.51696 .22214 L
.51957 .22358 L
.52218 .22476 L
.52479 .22608 L
.5274 .22707 L
.53001 .22824 L
.53262 .22979 L
.53523 .27733 L
.53783 .27868 L
.54044 .27976 L
.54305 .28098 L
Mistroke
.54566 .28228 L
.54827 .28359 L
.55088 .28491 L
.55349 .29271 L
.5561 .29389 L
.55871 .29519 L
.56132 .29654 L
.56393 .29757 L
.56654 .29867 L
.56915 .29993 L
.57175 .38577 L
.57436 .38664 L
.57697 .38748 L
.57958 .38835 L
.58219 .38905 L
.5848 .3899 L
.58741 .39094 L
.59002 .39126 L
.59263 .39226 L
.59524 .39286 L
.59785 .39356 L
.60046 .39416 L
.60307 .39496 L
.60568 .39608 L
.60828 .40527 L
.61089 .40605 L
.6135 .40671 L
.61611 .40752 L
.61872 .40804 L
.62133 .40879 L
.62394 .40965 L
.62655 .39708 L
.62916 .39774 L
.63177 .39811 L
.63438 .39912 L
.63699 .39984 L
.6396 .40057 L
.6422 .40164 L
.64481 .39111 L
.64742 .39207 L
.65003 .3926 L
.65264 .39326 L
.65525 .39395 L
.65786 .39455 L
.66047 .3952 L
.66308 .43584 L
.66569 .43652 L
.6683 .43718 L
.67091 .43792 L
.67352 .43846 L
Mistroke
.67613 .43915 L
.67873 .44015 L
.68134 .45315 L
.68395 .45371 L
.68656 .45408 L
.68917 .45472 L
.69178 .45506 L
.69439 .45599 L
.697 .45681 L
.69961 .51584 L
.70222 .51604 L
.70483 .51675 L
.70744 .51723 L
.71005 .51768 L
.71265 .51814 L
.71526 .51872 L
.71787 .50864 L
.72048 .50905 L
.72309 .50951 L
.7257 .51001 L
.72831 .51037 L
.73092 .51073 L
.73353 .51126 L
.73614 .53562 L
.73875 .53583 L
.74136 .53606 L
.74397 .53658 L
.74658 .53693 L
.74918 .53729 L
.75179 .53758 L
.7544 .54523 L
.75701 .54544 L
.75962 .54562 L
.76223 .54593 L
.76484 .54607 L
.76745 .54613 L
.77006 .54667 L
.77267 .53397 L
.77528 .53396 L
.77789 .53407 L
.7805 .53433 L
.78311 .53441 L
.78571 .53464 L
.78832 .53507 L
.79093 .54225 L
.79354 .54239 L
.79615 .54282 L
.79876 .54317 L
.80137 .54309 L
.80398 .54336 L
Mistroke
.80659 .54378 L
.8092 .57161 L
.81181 .57183 L
.81442 .57207 L
.81703 .57227 L
.81963 .57226 L
.82224 .57244 L
.82485 .57281 L
.82746 .56546 L
.83007 .56552 L
.83268 .56577 L
.83529 .56575 L
.8379 .56577 L
.84051 .56595 L
.84312 .56623 L
.84573 .58093 L
.84834 .58105 L
.85095 .58105 L
.85356 .58121 L
.85616 .5813 L
.85877 .58145 L
.86138 .58191 L
.86399 .5669 L
.8666 .56681 L
.86921 .56659 L
.87182 .56668 L
.87443 .56687 L
.87704 .56706 L
.87965 .56757 L
.88226 .59134 L
.88487 .59148 L
.88748 .59142 L
.89008 .59144 L
.89269 .59157 L
.8953 .59173 L
.89791 .59204 L
.90052 .60331 L
.90313 .60332 L
.90574 .60319 L
.90835 .603 L
.91096 .60291 L
.91357 .60293 L
.91618 .60314 L
.91879 .59165 L
.9214 .59186 L
.92401 .5918 L
.92661 .59147 L
.92922 .59138 L
.93183 .59151 L
.93444 .5916 L
Mistroke
.93705 .57299 L
.93966 .57322 L
.94227 .57295 L
.94488 .57295 L
.94749 .57287 L
.9501 .57307 L
.95271 .57323 L
.95532 .55556 L
.95793 .55576 L
.96053 .55584 L
.96314 .55585 L
.96575 .55569 L
.96836 .55585 L
.97097 .55604 L
.97358 .5381 L
.97619 .54023 L
Mfstroke
gsave
.97619 .31673 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .10055 m
.02642 .10017 L
.02903 .09934 L
.03164 .09905 L
.03425 .09893 L
.03686 .09863 L
.03947 .09823 L
.04207 .14947 L
.04468 .14876 L
.04729 .14789 L
.0499 .14706 L
.05251 .14658 L
.05512 .14612 L
.05773 .14557 L
.06034 .13405 L
.06295 .13346 L
.06556 .1325 L
.06817 .13185 L
.07078 .13149 L
.07339 .13091 L
.07599 .13031 L
.0786 .09471 L
.08121 .09427 L
.08382 .09318 L
.08643 .09254 L
.08904 .09192 L
.09165 .09154 L
.09426 .09097 L
.09687 .11677 L
.09948 .11591 L
.10209 .11485 L
.1047 .11424 L
.10731 .11367 L
.10992 .11282 L
.11252 .11196 L
.11513 .09026 L
.11774 .08945 L
.12035 .08848 L
.12296 .08794 L
.12557 .08741 L
.12818 .0867 L
.13079 .08606 L
.1334 .05043 L
.13601 .04988 L
.13862 .04919 L
.14123 .04877 L
.14384 .04845 L
.14644 .04788 L
.14905 .04739 L
.15166 .13012 L
Mistroke
.15427 .12934 L
.15688 .12847 L
.15949 .12785 L
.1621 .12677 L
.16471 .12601 L
.16732 .12519 L
.16993 .10248 L
.17254 .10167 L
.17515 .10075 L
.17776 .10014 L
.18037 .09927 L
.18297 .09866 L
.18558 .0979 L
.18819 .08891 L
.1908 .0883 L
.19341 .08754 L
.19602 .08694 L
.19863 .08627 L
.20124 .0857 L
.20385 .08539 L
.20646 .13793 L
.20907 .13716 L
.21168 .13602 L
.21429 .13498 L
.21689 .13418 L
.2195 .13336 L
.22211 .13246 L
.22472 .11363 L
.22733 .11266 L
.22994 .11168 L
.23255 .11066 L
.23516 .10994 L
.23777 .10912 L
.24038 .10853 L
.24299 .07833 L
.2456 .0777 L
.24821 .07681 L
.25082 .07626 L
.25342 .07567 L
.25603 .07507 L
.25864 .07445 L
.26125 .01634 L
.26386 .01602 L
.26647 .01561 L
.26908 .01526 L
.27169 .01502 L
.2743 .01493 L
.27691 .01472 L
.27952 .05639 L
.28213 .05562 L
Mistroke
.28474 .05477 L
.28735 .05436 L
.28995 .05374 L
.29256 .05334 L
.29517 .05266 L
.29778 .02106 L
.30039 .02063 L
.303 .02002 L
.30561 .01955 L
.30822 .01892 L
.31083 .01844 L
.31344 .01785 L
.31605 .05609 L
.31866 .05543 L
.32127 .05456 L
.32387 .05392 L
.32648 .05327 L
.32909 .05272 L
.3317 .05215 L
.33431 .02477 L
.33692 .02405 L
.33953 .02311 L
.34214 .02241 L
.34475 .02181 L
.34736 .02125 L
.34997 .02083 L
.35258 .06712 L
.35519 .06619 L
.3578 .06483 L
.3604 .06416 L
.36301 .06332 L
.36562 .06242 L
.36823 .06154 L
.37084 .03983 L
.37345 .03905 L
.37606 .03808 L
.37867 .03733 L
.38128 .03681 L
.38389 .03604 L
.3865 .03536 L
.38911 .12528 L
.39172 .1241 L
.39432 .12267 L
.39693 .12161 L
.39954 .12045 L
.40215 .11954 L
.40476 .11881 L
.40737 .10364 L
.40998 .10278 L
.41259 .10146 L
Mistroke
.4152 .1005 L
.41781 .09966 L
.42042 .09899 L
.42303 .0982 L
.42564 .08511 L
.42825 .08428 L
.43085 .08328 L
.43346 .08253 L
.43607 .08185 L
.43868 .08112 L
.44129 .08022 L
.4439 .09337 L
.44651 .0923 L
.44912 .09106 L
.45173 .09029 L
.45434 .08965 L
.45695 .08888 L
.45956 .08798 L
.46217 .0522 L
.46477 .05141 L
.46738 .05069 L
.46999 .04989 L
.4726 .0491 L
.47521 .04833 L
.47782 .04781 L
.48043 .11861 L
.48304 .11742 L
.48565 .11588 L
.48826 .11487 L
.49087 .11381 L
.49348 .11287 L
.49609 .11195 L
.4987 .08727 L
.5013 .08641 L
.50391 .08534 L
.50652 .08461 L
.50913 .08356 L
.51174 .08282 L
.51435 .08196 L
.51696 .06005 L
.51957 .05915 L
.52218 .05811 L
.52479 .05727 L
.5274 .05668 L
.53001 .05612 L
.53262 .0553 L
.53523 .13081 L
.53783 .12966 L
.54044 .12839 L
.54305 .12729 L
Mistroke
.54566 .12605 L
.54827 .12503 L
.55088 .12409 L
.55349 .14591 L
.5561 .14483 L
.55871 .14326 L
.56132 .14196 L
.56393 .14091 L
.56654 .14 L
.56915 .13905 L
.57175 .23597 L
.57436 .2347 L
.57697 .23309 L
.57958 .23177 L
.58219 .23054 L
.5848 .22939 L
.58741 .22817 L
.59002 .23246 L
.59263 .23106 L
.59524 .22968 L
.59785 .22853 L
.60046 .22739 L
.60307 .2263 L
.60568 .22498 L
.60828 .24348 L
.61089 .24224 L
.6135 .24073 L
.61611 .2394 L
.61872 .23827 L
.62133 .23715 L
.62394 .23602 L
.62655 .22503 L
.62916 .22397 L
.63177 .22282 L
.63438 .22136 L
.63699 .22011 L
.6396 .21909 L
.6422 .21782 L
.64481 .2138 L
.64742 .21249 L
.65003 .21123 L
.65264 .21016 L
.65525 .20899 L
.65786 .20815 L
.66047 .20735 L
.66308 .27298 L
.66569 .27167 L
.6683 .26999 L
.67091 .26856 L
.67352 .26727 L
Mistroke
.67613 .26604 L
.67873 .26462 L
.68134 .29522 L
.68395 .29391 L
.68656 .29242 L
.68917 .29099 L
.69178 .28978 L
.69439 .28821 L
.697 .28686 L
.69961 .36597 L
.70222 .36467 L
.70483 .36247 L
.70744 .36083 L
.71005 .35916 L
.71265 .35768 L
.71526 .35621 L
.71787 .3448 L
.72048 .34336 L
.72309 .3415 L
.7257 .33992 L
.72831 .33841 L
.73092 .33711 L
.73353 .33577 L
.73614 .37098 L
.73875 .36959 L
.74136 .36781 L
.74397 .36606 L
.74658 .36442 L
.74918 .36298 L
.75179 .36174 L
.7544 .37718 L
.75701 .37574 L
.75962 .37397 L
.76223 .37239 L
.76484 .37091 L
.76745 .36973 L
.77006 .36819 L
.77267 .3546 L
.77528 .35348 L
.77789 .35186 L
.7805 .35043 L
.78311 .3491 L
.78571 .34785 L
.78832 .3465 L
.79093 .3643 L
.79354 .36298 L
.79615 .361 L
.79876 .35942 L
.80137 .3582 L
.80398 .35686 L
Mistroke
.80659 .35548 L
.8092 .39358 L
.81181 .39202 L
.81442 .39007 L
.81703 .38849 L
.81963 .38704 L
.82224 .38563 L
.82485 .38414 L
.82746 .37955 L
.83007 .3782 L
.83268 .37629 L
.83529 .37498 L
.8379 .37356 L
.84051 .37221 L
.84312 .37086 L
.84573 .39648 L
.84834 .39498 L
.85095 .39323 L
.85356 .39166 L
.85616 .39007 L
.85877 .38866 L
.86138 .38705 L
.86399 .36746 L
.8666 .36629 L
.86921 .36489 L
.87182 .36349 L
.87443 .36193 L
.87704 .3606 L
.87965 .35905 L
.88226 .40614 L
.88487 .40458 L
.88748 .40284 L
.89008 .40135 L
.89269 .39966 L
.8953 .39819 L
.89791 .39668 L
.90052 .41329 L
.90313 .4118 L
.90574 .41007 L
.90835 .40873 L
.91096 .40722 L
.91357 .40584 L
.91618 .40437 L
.91879 .3952 L
.9214 .39359 L
.92401 .39187 L
.92661 .39076 L
.92922 .38934 L
.93183 .38791 L
.93444 .38664 L
Mistroke
.93705 .3665 L
.93966 .365 L
.94227 .36362 L
.94488 .36231 L
.94749 .361 L
.9501 .35965 L
.95271 .35843 L
.95532 .34179 L
.95793 .34044 L
.96053 .33883 L
.96314 .33762 L
.96575 .33651 L
.96836 .3353 L
.97097 .33417 L
.97358 .31986 L
.97619 .31673 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{745.812, 230.438},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;Y0000iR000`400?l00000o`00003ooooooooo
ooooon_ooooo003ooooooooooooojoooool00?ooooooooooooo[ooooo`00ooooooooooooon_ooooo
003ooooooooooooojoooool00?ooooooooooooo[ooooo`00oooooonAooooo`;o00008Oooool3o`00
00Cooooo0_l0000Kooooo`?o00001?ooool2o`0000Cooooo0_l0000Hooooo`?o00000oooool3o`00
00Cooooo0_l0000Gooooo`Go00000oooool2o`0000Cooooo0_l0000Hooooo`Go00000_ooool3o`00
00Cooooo0_l0000Hooooo`?o00001?ooool2o`0000Cooooo0_l0000Hooooo`?o00000oooool3o`00
00Cooooo0_l0000oooooo`00oooooon@ooooo`04o`000?ooooooooooo`0001oooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0001_ooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Sooooo00Go0000oooooooo
ooooooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05Oooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00006?ooool01_l0003oooooooooool0003oooooo`0000?ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001Kooooo00Oo0000ooooooooooooooooo`000?oo
oooo000000?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0looooo`00E?oo
ool2o`00023ooooo0ol00004ooooo`;o00006_ooool3o`0000Cooooo0_l00004ooooo`;o00006?oo
ool3o`0000?ooooo0ol00004ooooo`;o00005_ooool5o`0000?ooooo0_l00004ooooo`;o00005_oo
ool5o`0000;ooooo0ol00004ooooo`;o00006?ooool3o`0000Cooooo0_l00004ooooo`;o00005ooo
ool3o`0000?ooooo0ol00004ooooo`;o00009oooool01?l0003oooooooooool0000Sooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006?ooool00ol0003oooooooooo`05
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006Oooool00ol0003o
ooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06?ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
??ooool005?ooooo00Co0000oooooooooooo00007_ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00006?ooool01Ol0003ooooooooooooooooo000000?ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Fooooo`06o`000?oo
ooooooooo`000?oooooo00000oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
01Cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00005Oooool01ol0003ooooooooooooooooo0000ooooool000000oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo02Cooooo00Co0000oooooooooooo00008ooo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Sooooo00?o0000oooo
ooooool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Oooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool05_ooool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000H
ooooo`;o00001_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo03cooooo001C
ooooo`04o`000?ooooooooooo`0002;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000Hooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Gooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`0Hooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00?ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`0Tooooo`04o`000?ooooooooooo`0001oooooo
1?l00003ooooo`04o`000?ooooooooooo`0001_ooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0001Sooooo00Co0000oooooooooooooooo1?l0
0003ooooo`04o`000?ooooooooooo`0001Kooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005oooool01_l0003ooooooooooooo
oooo0000ooooo`Co00000oooool01?l0003oooooooooool0000Jooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
000000?o00000oooool01?l0003oooooooooool0000nooooo`00Doooool01?l0003oooooooooool0
000Rooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00006?ooool00ol0
003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05_ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`0Fooooo`;o00000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0001Oooooo0_l00006ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool09?oo
ool01?l0003oooooooooool0000Oooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00006_ooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000G
ooooo`;o00000oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0001Kooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00005oooool01ol0003ooooooooooooooooo0000ooooool000001_ooool01?l0003ooooooooo
ool0000Fooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0001Kooooo00Oo0000ooooooooooooooooo`000?oooooo000000Kooooo
00Co0000oooooooooooo0000?_ooool005?ooooo00Co0000oooooooooooo00007_ooool4o`0000?o
oooo00Co0000oooooooooooo00006_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00006?ooool01?l0003oooooooooooooool4o`0000?ooooo
00Co0000oooooooooooo00005Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000Eooooo`06o`000?ooooooooooooooool0003o
oooo1?l00003ooooo`04o`000?ooooooooooo`0001[ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooool000000ol0
0003ooooo`04o`000?ooooooooooo`0002Oooooo0_l0000Pooooo`Go00000oooool2o`0001cooooo
00?o0000ooooooooool00oooool2o`0000Cooooo0_l0000Iooooo`04o`000?ooooooooooooooo`Go
00000oooool2o`0001Sooooo0ol00004ooooo`;o00001?ooool2o`0001Wooooo0ol00002ooooo`Go
00000oooool2o`0001Sooooo0ol00004ooooo`;o00001?ooool2o`0001Sooooo0ol00002ooooo`Go
00000oooool2o`0003oooooo001Cooooo`04o`000?ooooooooooo`0001kooooo00?o0000oooooooo
ool01?ooool01?l0003oooooooooool0000Iooooo`;o00001?ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0001Oooooo0_l00003ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00005Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Eooooo`07o`000?ooooooooooooooool0003ooooo
o`000006ooooo`04o`000?ooooooooooo`0001Kooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00005Oooool01ol0003ooooooooo
oooooooo0000ooooool000001_ooool01?l0003oooooooooool0003ooooooh7ooooo001Dooooo`;o
00007oooool5o`0000?ooooo0_l0000Kooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o
00006Oooool01?l0003oooooooooooooool5o`0000?ooooo0_l0000Gooooo`?o00001?ooool2o`00
00Cooooo0_l0000Gooooo`?o00000_ooool5o`0000?ooooo0_l0000Hooooo`?o00001?ooool2o`00
00Cooooo0_l0000Gooooo`?o00000_ooool5o`0000?ooooo0_l0003ooooooh;ooooo003ooooooooo
oooojoooool00?ooooooooooooo[ooooo`00ooooooooooooon_ooooo003ooooooh_oooooool0000^
o`0003;ooooo003ooooooh_ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`04o`000?ooooooooooo`0003;ooooo001=oooooooo0000:Ol0000Eooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
033ooooo001=ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool01?l0003o
ooooooooool0000Eooooo`03o`000?oooooooooo0?oooooo:_ooool00ol0003oooooooooo`0`oooo
o`00COooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool08oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool08oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?oooooo:_ooool00ol0003o
ooooooooo`0`ooooo`00COooool00ol0003oooooooooo`3oooooobGooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`1:ooooo`Oo0?ZJf?ooool00ol0003oooooooooo`0`ooooo`00COoo
ool3o`000:Wooooo0_l0nYYhooooo`;o00005Oooool2o`0004_ooooo1ol0nYX5ooooo`Ko0?ZJ2Ooo
ool2o`3jV/7ooooo0_l0000booooo`00COooool00ol0003oooooooooo`2Yooooo`;o0?ZJNOooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo04[ooooo0_l0nYX3ooooo`;o0?ZJ1?ooool7
o`3jVPGooooo1_l0nY[2ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo
0:Wooooo0_l0nYYiooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0B_ooool2o`3j
VP?ooooo0_l0nYX4ooooo`;o0?ZJ0oooool2o`3jVPCooooo1ol0nY[2ooooo`03o`000?oooooooooo
033ooooo001=ooooo`03o`000?oooooooooo0:Sooooo0ol0nYYiooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0B_ooool2o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ0oooool2o`3jVPCo
oooo0_l0nYX3ooooo`;o0?ZJ`_ooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003ooooo
ooooo`2Xooooo`?o0?ZJNOooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo04[ooooo
0_l0nYX3ooooo`;o0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ0oooool2o`3jV/;ooooo
00?o0000ooooooooool0<?ooool004gooooo0ol0002Wooooo`Co0?ZJN?ooool2o`0001Gooooo00?o
0000ooooooooool0B_ooool2o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ0oooool2o`3jVPCooooo0_l0
nYX3ooooo`;o0?ZJ1_ooool5o`3jV[Oooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000
ooooooooool0Yoooool4o`3jVWWooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1:
ooooo`;o0?ZJ0oooool3o`3jVP;ooooo0ol0nYX3ooooo`?o0?ZJ0oooool2o`3jVP?ooooo0_l0nYX4
ooooo`Oo0?ZJ]oooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`2Voooo
o`Go0?ZJNOooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo04[ooooo0_l0nYX4oooo
o`;o0?ZJ0_ooool2o`3jVPGooooo0_l0nYX2ooooo`?o0?ZJ0oooool2o`3jVPCooooo1?l0nYX00ooo
oooo0?ZJo`3jVP2gooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0:Ko
oooo0_l0nYX00ooooooo0?ZJo`3jVP1iooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0:?ooool2o`3jVR3ooooo0_l0nYX4ooooo`;o0?ZJ0_ooool2o`3jVPGooooo0_l0nYX2ooooo`;o
0?ZJ1?ooool2o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ]oooool00ol0003oooooooooo`0`ooooo`00
COooool00ol0003oooooooooo`2Vooooo`;o0?ZJ00?oooooo`3jV_l0nYX0NOooool00ol0003ooooo
ooooo`0Cooooo`;o00009Oooool6o`3jVQoooooo0ol0nYX4ooooo`;o0?ZJ0_ooool2o`3jVPGooooo
0_l0nYX2ooooo`;o0?ZJ1?ooool2o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ5_ooool5o`3jVY_ooooo
0_l0000booooo`00COooool3o`000:Cooooo0_l00002o`3jVP03ooooool0nY[o0?ZJ07Sooooo0_l0
000Eooooo`03o`000?oooooooooo02Cooooo1_l0nYXOooooo`;o0?ZJ1Oooool2o`3jVP04ooooool0
nY[o0?ZJo`3jVPGooooo1_l0nYX4ooooo`;o0?ZJ0oooool3o`3jVP?ooooo0_l0nYXDooooo`Oo0?ZJ
W?ooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`2Tooooo`;o00000_l0
nYX00ooooooo0?ZJo`3jVP1iooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool09?oo
ool2o`3jVP;ooooo0_l0nYXOooooo`;o0?ZJ1Oooool6o`3jVPGooooo1_l0nYX4ooooo`;o0?ZJ0ooo
ool2o`3jVPCooooo0_l0nYXDooooo`?o0?ZJ0_ooool2o`3jVPcooooo1Ol0nYZ;ooooo`03o`000?oo
oooooooo033ooooo000jooooo`?o00000oooool00ol0003oooooooooo`02ooooo`?o00001Oooool0
0ol0003oooooooooo`2Tooooo`;o00000_l0nYX00ooooooo0?ZJo`3jVP1iooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool09?ooool2o`3jVP;ooooo0_l0nYXOooooo`;o0?ZJ1Oooool4
o`3jVPOooooo0ol0nYX7ooooo`;o0?ZJ0oooool2o`3jVPCooooo0_l0nYXDooooo`;o0?ZJ0oooool2
o`3jVP[ooooo1ol0nYZ;ooooo`03o`000?oooooooooo033ooooo000kooooo`03o`000?oooooooooo
00Kooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0:Cooooo0_l00002
o`3jVP03ooooool0nY[o0?ZJ07Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0T
ooooo`;o0?ZJ0_ooool2o`3jVQoooooo0_l0nYXJooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX4
ooooo`;o0?ZJ5?ooool2o`3jVP?ooooo0_l0nYX:ooooo`?o0?ZJ0_ooool2o`3jVX_ooooo00?o0000
ooooooooool0<?ooool003Sooooo1Ol0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0Y?ooool01Ol0003o0?ZJo`3jV_l0nY[ooooo00;o0?ZJNOooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo02Cooooo0_l0nYX2ooooo`;o0?ZJ7oooool2o`3jVQ[ooooo1ol0nYX4
ooooo`;o0?ZJ5?ooool2o`3jVP?ooooo0_l0nYX:ooooo`;o0?ZJ0oooool2o`3jVX_ooooo00?o0000
ooooooooool0<?ooool003Sooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`02
ooooo`?o0000Y?ooool00ol0003o0?ZJo`3jVP02ooooo`;o0?ZJMoooool3o`0001Gooooo00?o0000
ooooooooool08oooool3o`3jVP;ooooo0_l0nYXOooooo`;o0?ZJ6_ooool4o`3jVPOooooo0_l0nYXD
ooooo`;o0?ZJ0oooool2o`3jVP[ooooo0_l0nYX3ooooo`;o0?ZJRoooool00ol0003oooooooooo`0`
ooooo`00>Oooool00ol0003oooooo`000008ooooo`Co00001Oooool00ol0003oooooooooo`2Soooo
o`;o00000ol00?l00ooooooo0?ZJo`3jVP1iooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool08oooool2o`3jVP?ooooo0_l0nYXOooooo`;o0?ZJ9Oooool2o`3jVQCooooo0_l0nYX3oooo
o`;o0?ZJ2Oooool3o`3jVP?ooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo000jooooo`;o
00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0:?ooooo0_l00006o`00ogWo
oooo00?o0000ooooooooool04oooool2o`0002Cooooo0_l0nYX3ooooo`;o0?ZJ7?ooool5o`3jVRGo
oooo0_l0nYXDooooo`;o0?ZJ0oooool2o`3jVPWooooo0_l0nYX4ooooo`;o0?ZJR_ooool2o`0003;o
oooo000kooooo`03o`000?oooooooooo00Kooooo1Ol00004ooooo`03o`000?oooooooooo0:?ooooo
0_l00006o`00o`04o`3jV_ooooooooooooooo`;o0?ZJLoooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo02?ooooo0_l0nYX3ooooo`;o0?ZJ6oooool6o`3jVRGooooo0_l0nYX>ooooo`;o
0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX9ooooo`;o0?ZJ1?ooool2o`3jVX_ooooo00?o0000oooooooo
ool0<?ooool004gooooo00?o0000ooooooooool0Xoooool2o`0000;o003o0_ooool2o`00o`04o`3j
V_ooooooooooooooo`;o0?ZJLoooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02?o
oooo0_l0nYX3ooooo`;o0?ZJ6oooool2o`3jVRWooooo0_l0nYX;ooooo`Go0?ZJ1?ooool2o`3jVP?o
oooo0_l0nYX7ooooo`Co0?ZJ1?ooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool004gooooo
0ol0002Sooooo`;o00000_l00?l01Ol0nY[oooooo`00ool00?oo0?ZJ00;ooooo0ol0nYYbooooo`;o
00005Oooool00ol0003oooooooooo`0Qooooo`Co0?ZJ0oooool2o`3jVPcooooo1Ol0nYX:ooooo`;o
0?ZJ:Oooool2o`3jVPWooooo1ol0nYX4ooooo`;o0?ZJ0oooool3o`3jVP?ooooo1ol0nYX4ooooo`;o
0?ZJRoooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`2Sooooo`;o0000
0_l00?l01_l0nY[oooooo`00ool00?oo0?ZJooooo`Co0?ZJLoooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01kooooo1ol0nYX3ooooo`?o0?ZJ2Oooool7o`3jVP[ooooo0_l0nYXYoooo
o`;o0?ZJ2Oooool3o`3jVP;ooooo2?l0nYX4ooooo`;o0?ZJ0oooool5o`3jVPKooooo0_l0nYZ;oooo
o`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0:?ooooo0_l00002o`00o`06
o`3jV_oooooo003oo`00ool0nY[ooooo1?l0nYYcooooo`04o`000?oooooo0000o`0000Cooooo00?o
0000ooooooooool00_ooool3o`0000Kooooo00?o0000ooooooooool05Oooool5o`3jVPCooooo1Ol0
nYX6ooooo`;o0?ZJ2Oooool3o`3jVP;ooooo0_l0nYX:ooooo`;o0?ZJ:Oooool2o`3jVPWooooo0_l0
nYX4ooooo`Oo0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX9ooooo`;o0?ZJRoooool00ol0003ooooooooo
o`0`ooooo`00COooool00ol0003oooooooooo`2Sooooo`;o00000_l00?l01?l0nY[oooooo`00ool0
0?l6o`3jVW?ooooo0_l00002ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`0Cooooo`Oo0?ZJ1?ooool2o`3jVPWooooo0_l0nYX8ooooo`?o0?ZJ0ooo
ool2o`3jVPWooooo0ol0nYXYooooo`;o0?ZJ2Oooool2o`3jVPCooooo0ol0nYX8ooooo`;o0?ZJ0ooo
ool2o`3jVPWooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001=ooooo`?o0000Xoooool2
o`0000;o003o00Co0?ZJooooool00?oo003o0ol0nYX00ooooooo0?ZJo`3jVP1booooo`?o00000_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00ooo
ool6o`3jVP[ooooo0ol0nYX2ooooo`;o0?ZJ1?ooool2o`3jVPWooooo0_l0nYX5ooooo`Go0?ZJ1?oo
ool2o`3jVPWooooo0_l0nYXZooooo`;o0?ZJ1_ooool5o`3jVPoooooo0_l0nYX3ooooo`;o0?ZJ2Ooo
ool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool0Xoooool2
o`0000;o003o00Co0?ZJooooool00?oo003o0ol0nYX00ooooooo0?ZJo`3jVP1cooooo`;o00000_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo0ol00003ooooo`Ko0?ZJ2_oo
ool2o`3jVP?ooooo0_l0nYX3ooooo`?o0?ZJ2Oooool2o`3jVPCooooo1_l0nYX4ooooo`;o0?ZJ2Ooo
ool2o`3jVR[ooooo0_l0nYX4ooooo`Oo0?ZJ3oooool2o`3jVP?ooooo0_l0nYX9ooooo`;o0?ZJROoo
ool3o`0003;ooooo001=ooooo`03o`000?oooooooooo0:?ooooo0_l00002o`00o`03o`3jV_l0003o
003o00;o003o0_l0nYX00ooooooo0?ZJo`3jVP1cooooo`;o00000_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01oooool2o`3jVP[ooooo0_l0nYX3
ooooo`?o0?ZJ0_ooool2o`3jVP[ooooo0_l0nYX4ooooo`;o0?ZJ2?ooool2o`3jVPWooooo0_l0nYXJ
ooooo`Oo003o2Oooool2o`3jVPCooooo0ol0nYXCooooo`;o0?ZJ0oooool2o`3jVPWooooo0_l0nYZ;
ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0:?ooooo0_l00002o`00
o`03o`3jV_l0003o000000;o003o0_l0nYX00ooooooo0?ZJo`3jVP1cooooo`;o00000_ooool00ol0
003oooooooooo`06ooooo`;o00001oooool00ol0003oooooooooo`07ooooo`;o0?ZJ2_ooool2o`3j
VPCooooo0_l0nYX2ooooo`;o0?ZJ2_ooool2o`3jVPCooooo0_l0nYX8ooooo`;o0?ZJ1_ooool5o`3j
VPoooooo1_l00?l5ooooo`Oo003o2Oooool2o`3jVPCooooo0_l0nYXDooooo`;o0?ZJ0oooool2o`3j
VPWooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0:?o
oooo0_l00002o`00o`;o0?ZJ00Co0000o`00ool00?oo0?ZJ0_ooool2o`3jVW?ooooo00Co0000oooo
ool0003o00002_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo0_l0nYX:
ooooo`;o0?ZJ1?ooool6o`3jVP[ooooo0_l0nYX4ooooo`;o0?ZJ2?ooool2o`3jVPCooooo1ol0nYX?
ooooo`Oo003o1?ooool2o`00o`?ooooo0_l00?l9ooooo`;o0?ZJ0oooool3o`3jVQCooooo0_l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVPWooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001=oooo
o`?o0000Xoooool01?l0003o0?ZJo`00ool00?l2o`3jVP04o`000?l00?oo003oo`3jVP;ooooo0_l0
nYYbooooo`;o00005Oooool00ol0003oooooooooo`07ooooo`;o0?ZJ2Oooool3o`3jVPCooooo1_l0
nYX:ooooo`;o0?ZJ0oooool3o`3jVPSooooo0ol0nYX3ooooo`Co0?ZJ4_ooool2o`00o`?ooooo0_l0
0?l4ooooo`;o003o0oooool2o`00o`Cooooo0_l00?l3ooooo`;o0?ZJ0oooool2o`3jVQGooooo1ol0
nYX9ooooo`;o0?ZJRoooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`2S
ooooo`04o`000?l0nY[o003oo`00o`?o0?ZJ0_l00?l00ol0nY[oooooooooo`02o`3jVW?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`;o0?ZJ2Oooool2o`3jVPGooooo0ol0
nYX=ooooo`;o0?ZJ0oooool2o`3jVP[ooooo0_l0nYX3ooooo`;o0?ZJ2Oooool2o`00o`Wooooo0_l0
0?l3ooooo`;o003o1?ooool2o`00o`?ooooo0_l00?l4ooooo`Go003o0_l0nYX2ooooo`?o0?ZJ5Ooo
ool4o`3jVPcooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooo
oooo0:?ooooo00Go0000o`3jV_l00?oo003oooooo`02o`3jVP;o003o00?o0?ZJooooooooool00_l0
nYYcooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool01oooool2o`3jVPWooooo0_l0
nYXEooooo`;o0?ZJ0oooool2o`3jVP[ooooo0_l0nYX3ooooo`;o0?ZJ2Oooool7o`00o`Cooooo0_l0
0?l3ooooo`;o003o0oooool3o`00o`?ooooo0_l00?l4ooooo`Go003o1ol0nYXEooooo`;o0?ZJ3_oo
ool2o`3jVP?ooooo0_l0nYZ6ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooo
oooo0:;ooooo0_l000001?l0nY[o003oo`00ooooool2o`3jVP;o003o00?o0?ZJooooooooool00_l0
nYYcooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool01oooool3o`3jVPSooooo0_l0
nYXEooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX:ooooo`;o0?ZJ0_ooool3o`3jVPWooooo1ol0
0?l4ooooo`;o003o0oooool3o`00o`;ooooo0_l00?l4ooooo`;o003o1?ooool2o`00o`?ooooo1Ol0
nYXWooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYZ6ooooo`03o`000?oooooooooo033ooooo001=
ooooo`03o`000?oooooooooo0:;ooooo0_l000000ol0nY[o003oo`00o`02ooooo`03o`3jV_l00?oo
003o00?ooooo0_l0nYYcooooo`03o`000?oooooooooo01?ooooo0_l00009ooooo`;o0?ZJ2?ooool2
o`3jVQGooooo1ol0nYX:ooooo`;o0?ZJ0_ooool2o`3jVP[ooooo0_l00?l3ooooo`;o003o0oooool3
o`00o`Cooooo0_l00?l2ooooo`;o003o1?ooool2o`00o`Cooooo0_l00?l3ooooo`;o0?ZJ:_ooool7
o`3jVXGooooo0_l0000booooo`00COooool3o`000:;ooooo0_l000000ol0nY[o003oo`00o`02oooo
o`03o`3jV_l00?oo003o00?ooooo0_l0nYYbooooo`;o00005Oooool00ol0003oooooooooo`08oooo
o`;o0?ZJ1?ooool6o`3jVQGooooo1Ol0nYX<ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ2_ooool2
o`00o`?ooooo0_l00?l3ooooo`;o003o1Oooool2o`00o`;ooooo0_l00?l4ooooo`;o003o0oooool3
o`00o`?ooooo0_l00?lZooooo`Co0?ZJ00?oooooo`3jV_l0nYX0Q_ooool00ol0003oooooooooo`0`
ooooo`00COooool00ol0003oooooooooo`2Rooooo`;o00000ol00?l3ooooo`Oo003oLoooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`Ko0?ZJ9_ooool6o`3j
VP[ooooo0_l00?l3ooooo`?o003o0_ooool2o`00o`Gooooo1_l00?l4ooooo`;o003o0oooool2o`00
o`Cooooo0_l00?lDooooo`Oo003o5?ooool3o`3jVXGooooo00?o0000ooooooooool0<?ooool003Co
oooo0ol00003ooooo`03o`000?oooooooooo00;ooooo0ol00003ooooo`?o00001Oooool00ol0003o
ooooooooo`2Rooooo`;o00000_l00?l01Ol0nY[ooooooooooooooooo0?ZJ00Ko003oLoooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;o0?ZJ:_ooool4o`3j
VPcooooo0_l00?l4ooooo`;o003o0_ooool2o`00o`Gooooo1_l00?l4ooooo`;o003o0oooool2o`00
o`Cooooo0_l00?lDooooo`Oo003o5Oooool2o`3jVP;ooooo0_l0nYZ1ooooo`03o`000?oooooooooo
033ooooo000eooooo`03o`000?oooooooooo00Kooooo00Oo0000ooooooooooooooooo`000?oooooo
000000?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Rooooo`;o00000_l00?l0
1?l0nY[oooooooooooooool2o`3jVP;o000000?oooooo`00ool00?l0Loooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo00Sooooo0_l0nYX3ooooo`?o0?ZJ:_ooool2o`3jVPkooooo0_l0
0?l4ooooo`;o003o0_ooool2o`00o`oooooo1ol00?l4ooooo`;o003o5?ooool2o`00o`?ooooo0_l0
0?l:ooooo`Oo003o1?ooool6o`3jVX7ooooo00?o0000ooooooooool0<?ooool003;ooooo1Ol0000;
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2R
ooooo`;o00000_l00?l01?l0nY[oooooooooooooool3o`3jVP;o00000_l00?mcooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool02?ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ>ooo
ool2o`00o`Cooooo1_l00?l@ooooo`Ko003o1?ooool2o`00oaCooooo0_l00?l3ooooo`;o003o2_oo
ool7o`00o`Cooooo1_l0nYZ1ooooo`03o`000?oooooooooo033ooooo000booooo`04o`000?oooooo
ooooo`0000cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`?o0000X_oo
ool2o`0000;o003o00?o0?ZJooooooooool00_ooool2o`3jVP;o00000_l00?maooooo`?o00005Ooo
ool00ol0003oooooooooo`08ooooo`Oo0?ZJ5Oooool6o`00oaoooooo0ol00?l4ooooo`Ko003o6_oo
ool2o`00oaCooooo0_l00?l3ooooo`;o003o2_ooool2o`00o`?ooooo0_l00?l4ooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX0POooool00ol0003oooooooooo`0`ooooo`00<oooool00ol0003oooooo`000008
ooooo`Co00000_ooool4o`0000Gooooo00?o0000ooooooooool0W?ooool2o`0000Cooooo0_l00002
o`00o`03o`3jV_oooooooooo00;ooooo0_l0nYX2o`0000;o003o0oooool2o`3jVVkooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`08ooooo`Co0?ZJ6?ooool6o`00oaoooooo0_l00?lU
ooooo`;o003o5?ooool2o`00o`?ooooo0_l00?l:ooooo`;o003o0oooool2o`00o`Sooooo0_l0nYZ1
ooooo`03o`000?oooooooooo033ooooo000dooooo`;o00002?ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0W?ooool2o`0000Cooooo0_l00002o`00
o`03o`3jV_oooooooooo00;ooooo0_l0nYX2ooooo`;o003o0oooool2o`3jVVkooooo00?o0000oooo
ooooool04oooool2o`0002Gooooo0_l00?l2ooooo`;o003o7oooool2o`00obGooooo0_l00?lDoooo
o`;o003o0oooool2o`00o`Wooooo0ol00?l3ooooo`;o003o2?ooool2o`3jVX3ooooo0_l0000boooo
o`00=Oooool00ol0003oooooooooo`06ooooo`Go000000?oooooo`000?l000000ol00004ooooo`03
o`000?oooooooooo09cooooo0_l00004ooooo`05o`000?l0nY[o003oo`00ool0nYX01?ooool2o`3j
VP;ooooo0_l00?l2ooooo`?o0?ZJK_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
02Cooooo0_l00?l2ooooo`;o003o7oooool2o`00obGooooo0_l00?lDooooo`;o003o0oooool2o`00
o`Wooooo0_l00?l4ooooo`;o003o2?ooool2o`3jVX7ooooo00?o0000ooooooooool0<?ooool004go
oooo00?o0000ooooooooool0W?ooool2o`0000Cooooo0_l0nYX2o`00o`Gooooo0ol0nYX00ooooooo
003oo`00o`02ooooo`?o0?ZJK_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02Co
oooo0_l00?l2ooooo`;o003o7oooool2o`00obGooooo0_l00?l9ooooo`Oo003o1?ooool2o`00o`?o
oooo0_l00?l9ooooo`;o003o1?ooool2o`00o`Sooooo0_l0nYZ1ooooo`03o`000?oooooooooo033o
oooo001=ooooo`?o0000W?ooool2o`0000Cooooo0_l0nYX2o`00o`Kooooo0_l0nYX00ooooooo003o
o`00o`02ooooo`?o0?ZJKOooool2o`0001Gooooo00?o0000ooooooooool09?ooool2o`00o`;ooooo
0_l00?lOooooo`;o003o9Oooool2o`00o`Wooooo2?l00?l3ooooo`;o003o0oooool3o`00o`?ooooo
1ol00?l4ooooo`;o003o2?ooool2o`3jVX7ooooo00?o0000ooooooooool0<?ooool004gooooo00?o
0000ooooooooool0W?ooool2o`0000Cooooo0_l0nYX2o`00o`Kooooo0_l0nYX01?oooooo003oo`00
ooooool4o`3jVVkooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Tooooo`;o003o
0_ooool2o`00oaoooooo0_l00?lUooooo`;o003o2Oooool2o`00o`Cooooo1ol00?l4ooooo`;o003o
0oooool7o`00o`Cooooo0_l00?l8ooooo`;o0?ZJPOooool00ol0003oooooooooo`0`ooooo`00COoo
ool00ol0003oooooooooo`2Looooo`;o00000oooool3o`3jVP;o003o1_ooool2o`3jVP04ooooool0
0?oo003oooooo`Co0?ZJK_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02?ooooo
0ol00?l2ooooo`;o003o6oooool6o`00obGooooo0_l00?l9ooooo`;o003o1Oooool6o`00o`Cooooo
0_l00?l3ooooo`;o003o2Oooool2o`00o`Sooooo0_l0nYZ1ooooo`03o`000?oooooooooo033ooooo
001=ooooo`03o`000?oooooooooo09cooooo0_l000000ooooooo0000o`000002o`3jVP03o`000?l0
0?oo003o00Kooooo0_l0nYX00ooooooo003oo`00o`05o`3jVVkooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Sooooo`;o003o0oooool2o`00oa_ooooo1_l00?lUooooo`;o003o2Ooo
ool2o`00o`oooooo0_l00?l3ooooo`;o003o2Oooool2o`00o`Sooooo0_l0nYZ1ooooo`03o`000?oo
oooooooo033ooooo001=ooooo`03o`000?oooooooooo09cooooo0_l000000ooooooo0000o`3jVP02
o`3jVP03o`000?l00?oo003o00Kooooo0ol0nYX2o`00o`;o0?ZJ00?oooooo`3jV_l0nYX0K_ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02?ooooo0_l00?l3ooooo`;o003o6oooool2
o`00o`04ooooool00?oo003oo`00obGooooo0_l00?l4ooooo`Oo003o3oooool2o`00o`?ooooo0_l0
0?l9ooooo`;o003o2?ooool2o`3jVX7ooooo00?o0000ooooooooool0<?ooool004gooooo0ol0002K
ooooo`?o000000Coooooo`000?l0nY[o0?ZJ0_l00002o`00o`Oooooo0_l0nYX2o`00o`;o0?ZJ00?o
ooooo`3jV_l0nYX0KOooool2o`0001Gooooo0_l0000Tooooo`;o003o0oooool2o`00o`[ooooo1ol0
0?l:ooooo`;o003o:Oooool2o`00o`Cooooo1ol00?l?ooooo`;o003o0oooool2o`00o`Wooooo0_l0
0?l8ooooo`;o0?ZJP?ooool2o`0003;ooooo001=ooooo`03o`000?oooooooooo09_ooooo0ol00000
1?oooooo0000o`3jV_l0nYX2o`0000;o003o1oooool2o`3jVP;o003o0_l0nYX00ooooooo0?ZJo`3j
VP1^ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07_ooool7o`00o`?ooooo0ol0
0?l9ooooo`Oo003o2_ooool2o`00oaWooooo0ol0nYX=ooooo`;o003o1?ooool2o`00oaCooooo0_l0
0?l3ooooo`;o003o2Oooool2o`00o`Sooooo0_l0nYZ1ooooo`03o`000?oooooooooo033ooooo001=
ooooo`03o`000?oooooooooo09_ooooo1?l00003o`3jVP;o00000_l00?l8ooooo`04o`3jV_l00?oo
003oo`3jVP;ooooo0_l0nYY^ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07_oo
ool7o`00o`Cooooo0_l00?l9ooooo`;o003o0_l000000ooooooo003oo`00o`09ooooo`?o003o6Ooo
ool5o`3jVP_ooooo0_l00?l3ooooo`?o003o5?ooool7o`00o`Wooooo0_l00?l8ooooo`?o0?ZJP?oo
ool00ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`08ooooo`;o0?ZJTOooool4
o`0000;o0?ZJ0ol00002o`00o`Wooooo0_l00?l00ol0nY[oooooooooo`02o`3jVVkooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0Nooooo`;o003o0oooool2o`00o`Cooooo0_l00?l8
ooooo`?o003o0_l000000ooooooo003oo`00o`09ooooo`;o003o6_ooool7o`3jVPWooooo0_l00?l3
ooooo`;o003o5Oooool7o`00o`Wooooo0_l00?l9ooooo`;o0?ZJP?ooool00ol0003oooooooooo`0`
ooooo`00COooool3o`0000Oooooo0ol0nYY;ooooo`;o0000A?ooool4o`0000Oo003o2Oooool2o`00
o`03o`3jV_oooooooooo00;o0?ZJ0oooool2o`3jVVSooooo0_l0000Eooooo`03o`000?oooooooooo
01kooooo0_l00?l9ooooo`;o003o1?ooool6o`00o`?o000000?oooooo`00ool00?l02Oooool2o`00
oa[ooooo0_l0nYX2ooooo`?o0?ZJ1?ooool3o`3jVP;ooooo1ol00?lUooooo`;o003o2Oooool2o`3j
VX3ooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool01oooool3o`3jVT_o
oooo0_l0000/ooooo`?o0?ZJ5Oooool4o`0000Oo003o2Oooool2o`00o`03o`3jV_l0003ooooo00;o
0?ZJ0oooool2o`3jVVWooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`Oo
003o1?ooool2o`00o`Wooooo0_l00?l4ooooo`Ko003o1?l00002o`00o`Wooooo0_l00?l2ooooo`;o
00002oooool4o`3jVPOooooo0_l0nYX3ooooo`;o0?ZJ1?ooool5o`3jVPOo003o9Oooool2o`00o`Wo
oooo0_l0nYZ0ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo00Oooooo
0ol0nYXdooooo`;o0?ZJ5Oooool3o`0001cooooo0_l0nYX3ooooo`;o0?ZJ1oooool4o`3jVQGooooo
0_l000001?oooooo0000o`00ool00?l2o`000003ooooool0nY[o0?ZJ00Wooooo0_l00?l2o`000004
ooooool0nY[o0?ZJo`3jVP;ooooo0_l0nYYYooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool04oooool7o`00o`?ooooo0ol00?l9ooooo`;o003o1?ooool2o`00o`?ooooo1Ol00002o`00
o`04ooooool0003o0000ooooo`Oo003o1?l0000;ooooo`Ko0?ZJ1Oooool2o`3jVP?ooooo0_l0nYX4
ooooo`Oo0?ZJ:_ooool5o`00o`Kooooo0_l0nYZ0ooooo`03o`000?oooooooooo033ooooo001=oooo
o`03o`000?oooooooooo00Kooooo1?l0nYXcooooo`?o0?ZJ4oooool2o`3jVP?o00006oooool3o`3j
VP;ooooo0ol0nYX6ooooo`Go0?ZJ0oooool2o`3jVQ3ooooo0_l000001ooooooo0?ZJo`00ool00?oo
0?ZJo`000?ooool00_l0nYX9ooooo`;o003o1?l00002o`3jVP04ooooool0nY[o0?ZJo`3jVVWooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`;o003o0oooool2o`00o`?ooooo
0_l00?l:ooooo`;o003o1?ooool2o`00o`?ooooo1Ol00003o`00o`;o000000?oooooo`00ool00?l0
1Ol00?l5o`0000[ooooo1ol0nYX3ooooo`?o0?ZJ0oooool2o`3jVPCooooo0_l0nYX2ooooo`?o0?ZJ
:_ooool7o`00o`Cooooo0_l0nYXIooooo`;o0?ZJIOooool00ol0003oooooooooo`0`ooooo`00COoo
ool00ol0003oooooooooo`06ooooo`Co0?ZJ<oooool3o`3jVQ;ooooo0ol0nYX3o`000003ooooool0
nY[o0?ZJ01Oooooo1?l0nYX00ooooooo0?ZJo`3jVP02o`3jVPGooooo00Co0000o`3jV_l0nY[ooooo
0_l0nYX2ooooo`?o0?ZJ4?ooool2o`000007ooooool0nY[o003oo`00ool0nY[o0000ooooo`02o`3j
VPWooooo1ol00?l00ol0nY[oooooo`3jVP02o`3jVUoooooo0_l0nYX8ooooo`03o`000?oooooooooo
01?ooooo0_l0000Dooooo`;o003o0oooool3o`00o`;ooooo0_l00?l00ooooooo0000o`000007oooo
o`;o003o0oooool3o`00o`;ooooo0ol000001?oooooo0000o`000?l00002o`00o`;o000000?ooooo
o`00ool00?l00_l00002ooooo`Ko00002_ooool2o`3jVP?o00000_l0nYX3ooooo`;o0?ZJ1?ooool2
o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ;_ooool3o`00o`Cooooo0_l0nYXGooooo`Co0?ZJI?ooool2
o`0003;ooooo001=ooooo`?o00001Oooool5o`3jVS;ooooo1?l0nYXAooooo`Co0?ZJ0_l00004o`3j
VQKooooo1Ol0nYX00ooooooo0?ZJo`3jVP02o`3jVPGooooo00Co0000o`3jV_l0nY[ooooo0_l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVQ3ooooo0_l00002o`3jVP;o003o00?o0?ZJo`000?ooool00_l0nYX9
ooooo`Oo003o1Ol0nYYOooooo`;o0?ZJ1oooool2o`0001Gooooo00?o0000ooooooooool04oooool2
o`00o`Cooooo1_l00?l3o`0000Oooooo0_l00?l3ooooo`;o003o0oooool2o`0000;ooooo0ol00002
o`00o`?o00000_l00?l2o`0000;ooooo0_l000001?oooooo0000o`000?l0000:ooooo`;o0?ZJ0ol0
0003o`3jVP;ooooo0_l0nYX4ooooo`;o0?ZJ0oooool3o`3jVP?ooooo0_l0nYX_ooooo`;o003o1?oo
ool2o`3jVQCooooo1ol0nYYUooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooo
oooo00Gooooo0_l0nYX00ooooooo0?ZJo`3jVP0booooo`Co0?ZJ0oooool2o`3jVPCooooo0_l0nYX6
ooooo`Co0?ZJ00?o0000o`3jV_l0nYX00ol0nYXFooooo`;o0?ZJ00?oooooo`3jV_l0nYX01Ol0nYX5
ooooo`?o0?ZJ00Coooooo`3jV_l0nY[ooooo1?l0nYX@ooooo`04o`000?l0nY[o0?ZJo`3jVP;o003o
00?o0?ZJooooooooool00_l0nYX9ooooo`;o0?ZJ0ol00002o`00o`Go0?ZJG_ooool3o`3jVPSooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`;o003o1?ooool6o`00o`Co0000
1_ooool2o`00o`?ooooo0_l00?l3ooooo`;o00000_ooool3o`0000;o003o0_l00003o`00o`;o0000
0_ooool2o`0000;ooooo0ol00008ooooo`05o`000?l0nY[o0?ZJo`000?ooool00_l00006o`3jVPCo
oooo1?l0nYX00ooooooo0?ZJo`3jVP04ooooo`;o0?ZJ5?ooool2o`3jVQWooooo0ol00?l3ooooo`;o
0?ZJ5?ooool4o`3jVP03ooooool0nY[o0?ZJ06Gooooo00?o0000ooooooooool0<?ooool004gooooo
00?o0000ooooooooool01?ooool3o`3jVP03ooooool0nY[o0?ZJ03;ooooo1?l0nYX2ooooo`?o0?ZJ
0oooool3o`3jVPGooooo1Ol0nYX01?l0003o0?ZJo`3jV_l00002o`3jVQKooooo0_l0nYX00ooooooo
0?ZJo`3jVP02o`3jVP03o`000?l0nY[o0?ZJ00Gooooo0_l0nYX00ol0003oooooo`3jVP06o`3jVQ3o
oooo00Co0000o`3jV_l0nY[ooooo0_l00?l2o`3jVP03ooooool0nY[o0?ZJ00Wooooo0_l0nYX3o`00
00;o003o1Ol0nYYDooooo`;o0?ZJ2?ooool3o`3jVPSooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Cooooo`;o003o1_ooool8o`0000Kooooo1ol00?l3ooooo`;o00001?ooool00ol0
003o003oo`00o`02o`0000;o003o1ol00003ooooo`;o00002?ooool00ol0003o0?ZJo`3jVP02oooo
o`;o00001_l0nYX4ooooo`Oo0?ZJ1?ooool2o`3jVQCooooo1Ol0nYXGooooo`Go003o0_l0nYXBoooo
o`Co0?ZJ0oooool2o`3jVVGooooo00?o0000ooooooooool0<?ooool003[ooooo0ol00003ooooo`03
o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo00Cooooo0_l0nYX2o`0000;o
0?ZJ<Oooool5o`3jVP;ooooo0ol0nYX2ooooo`Co0?ZJ1Oooool2o`3jVP03o`000?l0nY[o0?ZJ00?o
0?ZJ00?o0000o`3jV_l0nYX05Oooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00?o0000o`3jV_l0
nYX00oooool4o`3jVP03o`000?oooooo0?ZJ00?o0?ZJ00Co0000o`3jV_l0nY[ooooo0_l00009oooo
o`;o00000_ooool01?l0003o0?ZJo`3jV_ooool2o`00o`;o0?ZJ00?oooooo`3jV_l0nYX02Oooool3
o`3jVP04ooooool0003o003oo`00o`;o0?ZJ00?oooooo`3jV_l0nYX0E?ooool2o`3jVPSooooo0ol0
nYX8ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool3o`00o`Kooooo1Ol0
00000ooooooo0000o`000006ooooo`Oo003o0oooool2o`0000Gooooo0_l00?l01?oooooo0000o`00
ool00?l6o`0000Cooooo0_l00007ooooo`04o`000?l0nY[o0?ZJo`3jVP?ooooo0ol000001?oooooo
0?ZJo`3jV_l0nYX3ooooo`?o000000?oooooo`3jV_l0nYX00_l0nYX4ooooo`;o0?ZJ5?ooool7o`3j
VP[ooooo0ol0nYX8ooooo`Go003o0_l0nYX?ooooo`Ko0?ZJ1?ooool2o`3jVVGooooo00?o0000oooo
ooooool0<?ooool003_ooooo00?o0000ooooooooool01_ooool01Ol0003ooooooooooooooooo0000
00Cooooo00?o0000ooooooooool01?ooool2o`3jVP;o00000_l0nYXaooooo`;o0?ZJ00Coooooo`3j
V_l0nY[ooooo1?l0nYX00ooooooo0?ZJo`3jVP03o`3jVPGooooo0_l0nYX2o`0000?o0?ZJ0_l00002
o`3jVQGooooo0_l0nYX2ooooo`?o0?ZJ0_l00002o`3jVP?ooooo1?l0nYX00ol0003oooooo`3jVP02
o`3jVP;o00000_l0nYX00ooooooo0000o`000009ooooo`;o00000_ooool3o`3jVP03ooooool00?oo
003o00Go0?ZJ2Oooool01Ol0003o0?ZJo`3jV_oooooo000000;o003o0_l0nYX00ooooooo0?ZJo`3j
VP1Dooooo`;o0?ZJ2?ooool3o`3jVPSooooo00Co0000ooooool0003o00001?ooool01?l0003ooooo
ooooooooool5o`0000Gooooo00?o0000ooooooooool04_ooool2o`00o`Kooooo1Ol00002ooooo`?o
00003oooool2o`0000Gooooo1_l00?l6o`0000Cooooo1?l0nYX5ooooo`03o`000?l0nY[o0?ZJ00Co
oooo0ol00002ooooo`;o0?ZJ00?o0000ooooooooool00ol00002ooooo`?o0?ZJ1?ooool2o`3jVQCo
oooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP[ooooo1Ol0nYX:ooooo`03o`00ool0nY[o0?ZJ00Oo
oooo0ol0nYX5ooooo`Co0?ZJ1_ooool2o`3jVVGooooo00?o0000ooooooooool0<?ooool003Sooooo
1Ol00007ooooo`05o`000?ooooooooooooooool000001?ooool3o`0000Cooooo0_l0nYX2o`0000;o
0?ZJ<?ooool3o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX2oooo
o`Go0?ZJ0_l00003o`3jVP;o00000_l0nYXEooooo`;o0?ZJ0_ooool3o`3jVP;o00000ol0nYX00ooo
oooo0?ZJo`3jVP06o`00o`;o0?ZJ0_l00002o`3jVP03ooooool0003o000000Wooooo0_l000001?oo
oooo0000o`3jV_l0nYX2ooooo`;o003o00?o0000o`3jV_l0nYX00_l0nYX:ooooo`;o0?ZJ0_ooool2
o`00o`;o0?ZJ00?oooooo`3jV_l0nYX0E?ooool2o`3jVPOooooo1?l0nYX6ooooo`Co00000_ooool0
0ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool04_oo
ool2o`00o`Kooooo1Ol00002ooooo`?o00003oooool2o`0000Gooooo1_l00?l00ol0003oooooo`00
0003o`0000Cooooo1ol0nYX2ooooo`03o`000?l0nY[o0?ZJ00Gooooo0_l000000ooooooo0000o`00
0002o`0000;ooooo0ol00003ooooo`;o00001?ooool2o`3jVQCooooo0_l0nYX3ooooo`;o0?ZJ2_oo
ool7o`3jVPSooooo00Co003oo`3jV_l0nY[ooooo2Ol0nYX5ooooo`;o0?ZJ2?ooool2o`3jVVGooooo
00?o0000ooooooooool0<?ooool003Sooooo00Co0000oooooooooooo00002?ooool4o`0000Gooooo
00?o0000ooooooooool01?ooool2o`3jVP;o00000_l0nYX3ooooo`;o0?ZJ:Oooool2o`0000;o0?ZJ
0_ooool00ol0003o0?ZJo`3jVP04o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ00?oooooo`3jV_l0
nYX01?l0nYX2o`0000;o003o00?oooooo`000?l000000_l0nYXDooooo`?o0?ZJ0_ooool3o`3jVP;o
000000?oooooo`3jV_l0nYX00ol0nYX9o`00o`04o`000?l0nY[o0?ZJooooo`;o00002Oooool2o`00
0004ooooool0003o0?ZJo`3jVP;ooooo0_l00?l00ol0003o0?ZJo`3jVP02o`3jVP[ooooo0_l0nYX2
ooooo`?o003o00Co0?ZJooooool0nY[o0?ZJDoooool3o`3jVPCooooo0_l0nYX00ooooooo0?ZJo`3j
VP02o`3jVPSooooo0_l00002ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`0Booooo`;o003o1Oooool3o`000003ooooool0003o000000?ooooo0_l0
000>ooooo`?o00002_ooool2o`000003ooooool0003o000000;o00001?ooool2o`3jVP03o`000?l0
nY[o0?ZJ00?o0?ZJ00Coooooo`000?l0nY[o0?ZJ1Oooool2o`000003ooooool0003o000000;o0000
0_ooool3o`0000?ooooo0_l00004ooooo`;o0?ZJ5?ooool2o`3jVP?ooooo0_l0nYX:ooooo`;o0?ZJ
0_ooool3o`3jVPSooooo00?o003oo`3jV_l0nYX02_l0nYX4ooooo`?o0?ZJ2?ooool2o`3jVVGooooo
00?o0000ooooooooool0<?ooool003Wooooo00?o0000ooooool000002?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Cooooo0_l0nYX2o`0000;o0?ZJ0oooool2o`3jVRWooooo0_l0
0002o`3jVP03o`000?oooooo000000?o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX01?oooooo0?ZJo`3j
V_ooool3o`3jVPco003o0oooool2o`3jVPoooooo0_l0nYX3ooooo`Go003o00?oooooo`3jV_l0nYX0
0_l0nYX00ooooooo003oo`00o`03o`0000Oo003o0ol00009ooooo`?o00000ol0nYX2ooooo`;o003o
00?oooooo`3jV_l0nYX00_l0nYX:ooooo`;o0?ZJ0_ooool01Ol0003o003oo`00ool0nY[ooooo00;o
0?ZJDoooool3o`3jVPCooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPSooooo0_l00002ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool3o`0000?ooooo1_l00?l9ooooo`;o
003o1Oooool3o`000003ooooool0003o000000?ooooo0_l00002ooooo`;o00002_ooool2o`0000_o
oooo0_l00002ooooo`?o00001?ooool2o`3jVP;o00000_ooool6o`3jVPGooooo3_l000000ooooooo
0000o`000004ooooo`;o0?ZJ5?ooool2o`3jVP?ooooo0_l0nYX:ooooo`;o0?ZJ0oooool2o`3jVPSo
oooo00?o003oo`3jV_l0nYX00ol0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00?o0?ZJ0_ooool3o`3j
VPWooooo0_l0nYYSooooo`?o0000<_ooool003[ooooo0_l00009ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01?ooool6o`00o`03o`3jV_oooooooooo00;o0?ZJ:Oooool01ol0003o
0?ZJo`3jV_l0nY[o0000ooooool000000_l0nYX3ooooo`?o0?ZJ0_ooool5o`3jVP03ooooool00?oo
003o00[o003o0_ooool3o`3jVPoooooo3?l00?l2o`3jVP;ooooo0_l00?l00ol0nY[o0000o`000002
o`3jVP03o`000?l00?oo003o00;o003o0ol00008ooooo`Co00000_l0nYX3ooooo`;o003o0_ooool3
o`3jVP[ooooo0ol0nYX01_oooooo0000o`00ool00?oo0?ZJooooo`;o0?ZJ1?ooool2o`3jVTcooooo
1?l0nYX3ooooo`So0?ZJ2?ooool2o`0000;ooooo00?o0000ooooooooool01Oooool01Ol0003ooooo
oooooooooooo000000Gooooo00?o0000ooooooooool00oooool6o`00o`Gooooo1_l00?l5ooooo`;o
00001oooool3o`000003ooooool0003o000000[ooooo0_l0000;ooooo`;o00000_ooool2o`0000Go
oooo0_l0nYX4o`0000Ko0?ZJ1Oooool:o`000003ooooool0003o000000Go00000oooool2o`3jVPWo
oooo0ol0nYX8ooooo`;o0?ZJ0oooool2o`3jVPWooooo0ol0nYX3ooooo`;o0?ZJ2?ooool01?l00?oo
0?ZJo`3jV_l0nYX8ooooo`Oo0?ZJ2Oooool2o`3jVVGooooo00?o0000ooooooooool0<?ooool003_o
oooo00?o0000ooooooooool02?ooool2o`0000Gooooo00?o0000ooooooooool01?ooool6o`00o`03
o`3jV_oooooo0?ZJ00;o0?ZJ:Oooool00ol0003o0?ZJo`3jVP02o`000005ooooool0003o0?ZJo`3j
V_ooool00_l00003o`3jVP;ooooo1?l0nYX2ooooo`;o003o0_l000001_oooooo0?ZJo`3jV_l0nY[o
ooooo`0000;o003o00?oooooo`3jV_l0nYX00_l0nYX3ooooo`;o0?ZJ2?ooool2o`0000Oo003o0_oo
ool3o`00o`;o0?ZJ0_ooool2o`00o`03o`3jV_l0003o000000?o0?ZJ0_l00002o`00o`?o00002?oo
ool4o`0000Oo003o0oooool2o`3jVP_ooooo0_l0nYX01_oooooo0000o`00ool00?oo0?ZJooooo`;o
0?ZJ1?ooool2o`3jVTcooooo1?l0nYX3ooooo`Go0?ZJ00?oooooo`3jV_l0nYX02?ooool2o`0000;o
oooo00?o0000ooooooooool01Oooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000oooo
ooooool00oooool3o`000004ooooool00?oo003oo`0000Cooooo1_l00?l5ooooo`;o00002?ooool2
o`000003ooooool0003o000000[ooooo0_l0000;ooooo`;o00000_ooool2o`0000Gooooo0_l0nYX6
o`000004ooooool0nY[o0?ZJo`3jVPGooooo2_l000000ooooooo0000o`000005o`0000;ooooo00?o
0000o`3jV_l0nYX02?ooool00ol0003o0?ZJo`3jVP07o`3jVP;ooooo0_l0nYX3ooooo`?o0?ZJ0ooo
ool2o`3jVP?ooooo0_l0nYX4ooooo`;o0?ZJ2?ooool2o`00o`[ooooo1Ol0nYX;ooooo`?o0?ZJI?oo
ool00ol0003oooooooooo`0`ooooo`00COooool3o`0000Cooooo0_l0nYX2o`0000;o003o1Ol0nYXY
ooooo`03o`000?l00?oo003o00Go003o00Co0?ZJooooool0003o00000ol0nYX2ooooo`?o0?ZJ00?o
0000ooooooooool00_l00?l00ol0nY[o0000ooooo`03o`3jVP04ooooool0003o003oo`00o`Go0?ZJ
0oooool2o`3jVPSooooo0_l00002o`00o`?o00000ol0nYX01?oooooo0000o`00ool00?l2o`3jVP05
o`000?l00?oo003oo`00ool0nYX00_l00003o`3jVP;o00000_l00?l3o`0000Kooooo1_l00007o`00
oa3ooooo0_l0nYX2ooooo`;o003o0_ooool3o`3jVP;ooooo0ol0nYX9ooooo`;o0?ZJ@Oooool4o`3j
VP;ooooo1_l0nYX00ooooooo0?ZJo`3jVP07ooooo`;o000000?oooooo`000?l000002Oooool3o`00
00Kooooo00?o0000ooooooooool01?ooool3o`0000;o003o00?o0000ooooooooool00_ooool2o`00
o`Wooooo0_l00008ooooo`03o`000?l0nY[o0?ZJ00;o00001_ooool2o`0000;ooooo0_l0000Foooo
o`;o0?ZJ2Ol00006ooooo`[o000000?oooooo`000?l000001Ol00002ooooo`03o`000?l0nY[o0?ZJ
00Sooooo00?o0000o`3jV_l0nYX02ol0nYX4ooooo`;o0?ZJ0oooool7o`3jVPCooooo0_l0nYX8oooo
o`;o003o2_ooool3o`3jVPkooooo0_l0nYYTooooo`03o`000?oooooooooo033ooooo001=ooooo`03
o`000?oooooooooo00Cooooo0_l0nYX01?l0003oooooo`00ool00?l5o`3jVRWooooo00?o0000o`00
ool00?l01Ol00?l01?l0nY[oooooo`000?l00004o`00o`06ooooool0nY[o0?ZJo`3jV_l0003ooooo
0ol00?l00ol0nY[oooooooooo`04o`3jVP03o`000?l00?oo003o00;o0?ZJ00Coooooo`3jV_l0nY[o
oooo1?l0nYX8ooooo`;o00000_l00?l00ol0nY[o0000o`000003o`3jVP;ooooo0ol00?l01?l0nY[o
0000o`00ool00?l3o`3jVP03o`000?l0nY[o0?ZJ00;o0?ZJ00Co0000o`00ool00?oo0?ZJ0ol00005
ooooo`;o0?ZJ1?l00002o`00o`?ooooo0_l0nYX@ooooo`?o0?ZJ00?oooooo`00ool00?l01?l00?l0
0ol0nY[oooooo`3jVP03o`3jVPWooooo0_l0nYX^ooooo`;o0?ZJ0oooool2o`3jVPcooooo1?l0nYX2
ooooo`Ko0?ZJ00?oooooo`3jV_l0nYX02?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo00Gooooo0_l00003o`00o`Cooooo0_l00?l9ooooo`;o00002?ooool00ol0003o0?ZJo`3jVP04
o`3jVPCooooo0_l00002ooooo`;o00005_ooool2o`3jVP;o000000?oooooo`000?l000000ol00008
ooooo`;o000000Coooooo`000?l0003ooooo0ol000000ooooooo0000o`000005o`0000;ooooo00Co
0000o`3jV_l0nY[o00001?ooool2o`000006ooooool0003o0?ZJo`3jV_l0003ooooo2Ol0nYX4oooo
o`;o0?ZJ0oooool7o`3jVPCooooo0_l0nYX8ooooo`;o003o6oooool2o`3jVVCooooo00?o0000oooo
ooooool0<?ooool004gooooo00?o0000ooooooooool01?ooool2o`3jVP;ooooo0_l00?l5o`3jVRWo
oooo00Co0000o`00ool00?oooooo0_l0000=o`00o`03o`3jV_l0003o000000;o003o0_l0nYX00ooo
oooo0?ZJo`3jVP03o`3jVP03o`000?l00?oo003o00;o0?ZJ00?oooooo`3jV_l0nYX01Ol0nYX8oooo
o`;o00000_l00?l00ol0nY[o0000o`000003o`3jVP?ooooo0_l00?l2o`0000;o003o0ol0nYX00ol0
003o0?ZJo`3jVP02o`3jVP04o`000?l00?oo003oo`3jVP;o00000_l0nYX3ooooo`?o0?ZJ1?l00002
o`00o`03o`3jV_oooooooooo00;o0?ZJ4Oooool2o`3jVP03ooooool00?oo003o00Co003o00?o0?ZJ
ooooool0nYX00ol0nYX8ooooo`?o0?ZJ3_ooool2o`3jVQkooooo0_l0nYX3ooooo`;o0?ZJ2oooool5
o`3jVP;ooooo1_l0nYX00ooooooo0?ZJo`3jVP08ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool01Oooool3o`0000;o003o00?o0000ooooooooool00ol00?l9ooooo`;o00002?ooool0
0ol0003o0?ZJo`3jVP04o`3jVP?ooooo1ol0000Eooooo`?o0?ZJ0_l00002ooooo`Co00002?ooool2
o`0000Cooooo0_l00004ooooo`Go000000?oooooo`000?l000000_l0nYX01?l0003ooooooooooooo
ool3o`3jVP;o00000_l0nYX00ol0003oooooooooo`05ooooo`?o0?ZJ1?ooool2o`3jVP?ooooo0_l0
nYX00ooooooo0?ZJo`3jVP02o`3jVPCooooo0_l0nYX8ooooo`;o003o6oooool2o`3jVVCooooo00?o
0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool01?ooool2o`3jVP;ooooo0_l00?l2
o`3jVP03ooooool0nY[o0?ZJ02Wooooo00Co0000o`00ool00?oo0?ZJ0ol00006o`00o`03o`3jV_l0
0?oo003o00So003o1Ol0nYX01?oooooo0?ZJo`3jV_l0nYX2o`00o`04o`3jV_ooooooooooooooo`?o
0?ZJ00?oooooo`3jV_l0nYX01oooool3o`0000;o003o00?o0?ZJo`000?l000001?l0nYX2ooooo`Ko
003o0ol0nYX00ol0003o0?ZJo`3jVP03o`3jVP;o003o00?o0?ZJo`000?l000000_l0nYX2ooooo`Co
0?ZJ0ol000001?l0nY[o003oo`00ool0nYX2ooooo`;o0?ZJ4Oooool5o`3jVP;ooooo0_l00?l00ol0
nY[oooooo`3jVP03o`3jVPSooooo0ol0nYX>ooooo`;o0?ZJ7Oooool3o`3jVP?ooooo0_l0nYX;oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool5o`3jVP;ooooo0_l0nYX8ooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool01Oooool3o`0000;o003o00?o0000ooooooooool00_l00?l:oooo
o`;o00002Oooool2o`3jVP;o00000_l0nYX3ooooo`Oo00005Oooool2o`3jVPGooooo1?l00008oooo
o`;o00002_ooool5o`000003ooooool0003o000000;o0?ZJ00Co0000oooooooooooooooo1ol0nYX2
o`0000gooooo0_l0nYX3ooooo`;o0?ZJ0oooool2o`3jVPCooooo0_l0nYX8ooooo`;o003o6oooool2
o`3jVVCooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool01?ooool2o`3j
VP;ooooo0_l00?l2o`3jVP03ooooool0nY[o0?ZJ02Sooooo00Go0000o`3jV_l00?oo003oo`3jVP03
o`0000;o0?ZJ00?oooooo`000?l000000ol0nYX2o`0000Oo003o1Ol0nYX2ooooo`;o0?ZJ0_l00?l0
1?l0nY[oooooooooooooool3o`3jVP03ooooool0nY[o0?ZJ00Oooooo0_l000000ol0nY[o003oo`00
o`02o`3jVP03o`000?l0nY[o0?ZJ00;o0?ZJ0_ooool6o`00o`Ko0?ZJ00?oooooo`3jV_l0nYX00_l0
0?l00ol0nY[o0000o`3jVP02o`3jVP;ooooo1?l0nYX3o`000004o`3jV_l00?oo003oo`3jVP;ooooo
0_l0nYXBooooo`Co0?ZJ0_ooool2o`00o`03o`3jV_oooooo0?ZJ00?o0?ZJ1oooool4o`3jVPgooooo
0ol0nYXMooooo`?o0?ZJ0oooool2o`3jVP_ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`Go0?ZJ
0_ooool2o`3jVPSooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`05ooooo`?o0000
1ol00?l:ooooo`;o00002Oooool2o`3jVP04ooooool0003o0?ZJo`3jVP;o000000?oooooo`000?l0
00001Ol0000Eooooo`;o0?ZJ1Oooool4o`0001Cooooo2?l00002o`3jVP04o`000?oooooooooooooo
o`Oo0?ZJ0_l0000=ooooo`;o0?ZJ0oooool2o`3jVPWooooo0_l0nYX8ooooo`;o003o6oooool2o`3j
VVCooooo00?o0000ooooooooool0<?ooool004gooooo0ol00004ooooo`;o0?ZJ0_ooool3o`00o`04
o`3jV_oooooo0?ZJo`3jVRSooooo00Ko0000o`3jV_l00?oo003oo`3jV_ooool2o`0000;o0?ZJ00?o
ooooo`000?l000000ol0nYX2o`0000?o0?ZJ0_l00007o`3jVP?ooooo00?o0?ZJo`00ool00?l01?l0
0?l3o`3jVP03ooooool0nY[o0?ZJ00Oooooo0_l000000ol0nY[o003oo`00o`02o`3jVP03o`000?l0
nY[o0?ZJ00?o0?ZJ00?oooooo`3jV_l0nYX00_ooool3o`3jVP03o`000?l0nY[o0?ZJ00;o0?ZJ0_oo
ool01?l0nY[o003oo`00ool00?l4o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ0ol000000ol0nY[o003o
o`00o`02o`3jVP03ooooool0nY[o0?ZJ01;ooooo1Ol0nYX00ooooooo003oo`00o`06o`3jVPOooooo
1?l0nYX=ooooo`?o0?ZJ7?ooool4o`3jVP;ooooo0ol0nYX;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
0_ooool5o`3jVP;ooooo0_l0nYX7ooooo`;o00005Oooool2o`0000Kooooo0ol00007o`00o`[ooooo
0_l00009ooooo`;o0?ZJ00Coooooo`000?l0nY[o0?ZJ2Ol0000Fooooo`;o0?ZJ1Oooool3o`0001Ko
oooo0_l000001Ooooooo0000o`000?l0003ooooo00;o0?ZJ00Co0000oooooooooooooooo0_l0nYX2
o`0000?o0?ZJ0_l0000=ooooo`Co0?ZJ00?oooooo`3jV_l0nYX02Oooool2o`3jVPSooooo0_l00?lK
ooooo`;o0?ZJHoooool2o`0003;ooooo001=ooooo`03o`000?oooooooooo00Cooooo0ol0nYX01_oo
oooo0000o`00ool00?oo0?ZJooooo`;o0?ZJ1?ooool2o`3jVR;ooooo00Go0000o`3jV_l00?oo003o
o`3jVP03ooooo`;o0?ZJ00?oooooo`000?l000000ol0nYX2o`0000?o0?ZJ0_l00002o`3jVP;ooooo
0ol0nYX4ooooo`So003o00Co0?ZJooooool0nY[o0?ZJ1_ooool3o`000003o`3jV_l00?oo003o00;o
0?ZJ00Coooooo`3jV_l0nY[ooooo1_l0nYX01?oooooo0?ZJo`3jV_ooool2o`0000?o0?ZJ0_ooool2
o`3jVP;o003o1?l0nYX01?oooooo0?ZJo`3jV_l00002o`3jVP;o000000Coooooo`3jV_l00?oo003o
0_l0nYX00ooooooo0?ZJo`3jVP0Booooo`Go0?ZJ00?oooooo`00ool00?l00ol0nYX00ooooooo0?ZJ
o`3jVP06ooooo`Go0?ZJ3?ooool4o`3jVQcooooo1?l0nYX2ooooo`?o0?ZJ2Oooool4o`3jVP04oooo
ool0nY[o0?ZJooooo`?o0?ZJ00?o0000o`3jV_l0nYX00_ooool2o`3jVPSooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`06ooooo`;o000000?oooooo`000?l000003_ooool2o`0000Wo
oooo0_l0nYX01?oooooo0000o`3jV_l0nYX9o`0001Kooooo0_l0nYX5ooooo`?o00006Oooool3o`00
0006ooooool0nY[o0?ZJo`3jV_oooooo00000ol0nYX00ooooooo0000o`000002ooooo`;o00003_oo
ool6o`3jVPWooooo0_l0nYX8ooooo`;o003o6oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVV3ooooo
00?o0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool01Oooool2o`3jVP06ooooool0
003o003oo`00ool0nY[ooooo0_l0nYX3ooooo`?o0?ZJ8_ooool01?l0003o0?ZJo`00ool00?l2o`3j
VP;ooooo0_l0nYX00ooooooo0000o`000003o`3jVP;ooooo0ol0nYX01?oooooo0000o`3jV_l0nYX3
ooooo`;o0?ZJ1?ooool2o`3jVP;o00002?l00?l3ooooo`;o000000Goooooo`000?l0003o0000o`3j
VP02o`00o`Go0?ZJ00?oooooo`3jV_l0nYX01?l0nYX01?oooooo0?ZJo`3jV_ooool2o`000003oooo
ool0nY[o0?ZJ00?ooooo00Go0?ZJo`00ool00?oo0?ZJo`000005o`3jVP05o`000?l0nY[o0?ZJo`00
0?ooool00_l0nYX2o`00o`;o0?ZJ00?oooooo`3jV_l0nYX04oooool4o`3jVP03ooooool00?oo003o
00?o0?ZJ00?oooooo`3jV_l0nYX01_ooool2o`3jVP03ooooool0nY[o0?ZJ00cooooo1?l0nYXLoooo
o`Co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX9ooooo`Co0?ZJ00?oooooo`3jV_l0nYX00ol0nYX2o`00
00;o0?ZJ0_ooool3o`3jVPOooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`06oooo
o`;o000000?oooooo`000?l000003_ooool2o`0000Sooooo0ol0nYX01?oooooo0000o`3jV_l0nYX4
o`000003ooooool0003o000000;o00004_ooool3o`3jVP03ooooool0nY[o0?ZJ02Gooooo1ol0nYX0
1?l0003oooooo`000?l00002ooooo`?o00003oooool4o`3jVPWooooo0_l0nYX8ooooo`?o003o6_oo
ool6o`3jVV3ooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool01Oooool3
o`3jVP05ooooool00?oo003oo`3jV_ooool00ol0nYX2ooooo`?o0?ZJ8_ooool2o`3jVP;o003o0_l0
nYX01_oooooo0?ZJo`3jV_l0nY[oooooo`0000Go0?ZJ00?oooooo`3jV_l0nYX00_l0nYX00ooooooo
0?ZJo`3jVP09ooooo`?o0?ZJ0ol000000ol0nY[o003oo`00o`03o`00o`?ooooo00?o0000o`3jV_l0
nYX00_l000001Ooooooo003oo`00ool00?oooooo00Co0?ZJ0_ooool5o`3jVP04ooooool0nY[o0?ZJ
ooooo`;o00001_ooool01?l0nY[o003oo`00ool0nYX2o`0000?o0?ZJ0_l00002o`3jVP03o`000?oo
oooo0?ZJ00?o003o1Ol0nYXDooooo`04o`000?l0nY[o0?ZJooooo`?o003o00?o0?ZJooooooooool0
0_l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02oooool5o`3jVQ_ooooo00?o0000o`3jV_l0nYX0
0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPSooooo1Ol0nYX2ooooo`Co0?ZJ0_l00002o`3jVP?ooooo
0_l0nYX7ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool02Oooool3o`0000cooooo
0ol00008ooooo`;o0?ZJ0_ooool00ol0003o0?ZJo`3jVP04o`000003ooooool0003o000000;o0000
4_ooool6o`3jVROooooo1Ol0nYX00ol0003oooooooooo`04ooooo`;o00004Oooool2o`3jVPWooooo
0_l0nYX9ooooo`;o003o6_ooool6o`3jVV3ooooo00?o0000ooooooooool0<?ooool004gooooo00?o
0000ooooooooool01_ooool3o`3jVP;o003o0ol00002o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ8Ooo
ool2o`3jVP?o003o1ol0nYX01?l0003o0?ZJo`3jV_ooool2o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ
2_ooool2o`3jVP?o00000ol0nYX01?oooooo003oo`00ool0nYX2ooooo`?o0?ZJ0_l000001?l0nY[o
003oo`00ool0nYX2ooooo`?o0?ZJ0oooool4o`3jVP03ooooool0nY[o0?ZJ00Wooooo00Co0?ZJo`00
ool00?oo0?ZJ0_l00003o`3jVP;o00001Ol0nYX2o`00o`03o`3jV_oooooo0?ZJ00?o0?ZJ5?ooool0
0ol0003o0?ZJo`3jVP02ooooo`;o003o00?o0?ZJooooooooool00_l0nYX6ooooo`;o0?ZJ00?ooooo
o`3jV_l0nYX02oooool2o`3jVP03ooooool0nY[o0?ZJ01_ooooo00?o0000o`3jV_l0nYX00_l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVPSooooo1Ol0nYX2ooooo`Co0?ZJ0_l00002o`3jVP?ooooo0_l0nYX7
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool02_ooool2o`0000cooooo0_l00009
ooooo`;o0?ZJ0oooool2o`3jVP03o`000?oooooooooo00Cooooo0_l000000ooooooo0?ZJo`3jVP02
o`3jVPgooooo1_l0nYXWooooo`;o00000ol0nYX7ooooo`;o00007?ooool2o`3jVPWooooo0_l00?lJ
ooooo`;o0?ZJ0_ooool2o`3jVV3ooooo00?o0000ooooooooool0<?ooool004gooooo0ol00007oooo
o`;o0?ZJ0ol00?l2o`0000;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX3ooooo`;o0?ZJ6oooool3o`3j
VP;o003o00?o0?ZJooooool0nYX01Ol0nYX01?l0003o0?ZJo`3jV_ooool5o`3jVP03ooooool0nY[o
0?ZJ00;o0?ZJ2_ooool3o`3jVP;o00000ol0nYX01Ol0003o003oo`00ool0nY[ooooo00Co0?ZJ00?o
0000o`3jV_l0nYX00_l00?l01?l0nY[oooooooooooooool2o`3jVPGooooo1Ol0nYX9ooooo`04o`00
0?l00?oo003oo`3jVP;o00000ol0nYX3o`0000Co0?ZJ0_l00?l00ol0nY[oooooo`3jVP03o`3jVQCo
oooo00Go0000o`3jV_l0nY[oooooo`000002o`00o`03o`3jV_oooooooooo00;o0?ZJ1Oooool3o`3j
VP03ooooool0nY[o0?ZJ00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Kooooo`[o0?ZJ2?ooool5o`3j
VP;ooooo1?l0nYX2o`0000;o0?ZJ0oooool2o`3jVPKooooo0_l0000Eooooo`03o`000?oooooooooo
00[ooooo0ol0000;ooooo`;o00002Oooool2o`3jVP?ooooo0_l0nYX00ol0003oooooooooo`07oooo
o`Oo0?ZJ2_ooool2o`3jVP;ooooo0_l0nYXWooooo`Go00001oooool2o`0001cooooo1?l0nYX7oooo
o`;o003o7_ooool2o`3jVV3ooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000oooooooo
ool01oooool2o`3jVPKo003o00?o0?ZJooooool0nYX00ol0nYX2ooooo`?o0?ZJ5?ooool2o`3jVPGo
oooo0_l0nYX01Ol0003o003oo`00ool0nY[ooooo00Wo0?ZJ0_ooool4o`3jVP03ooooool0nY[o0?ZJ
00;o0?ZJ2oooool7o`3jVP05o`000?l00?oo003oo`3jV_ooool01ol0nYX2o`00o`03o`3jV_oooooo
oooo00Wooooo1?l0nYX:ooooo`;o003o00?o0?ZJooooool000001ol00?l2o`3jVP04ooooool00?oo
003oo`3jVP;ooooo0ol0nYXDooooo`05o`000?l0nY[o0?ZJooooool000000_l00?l00ol0nY[ooooo
ooooo`02o`3jVPGooooo0_l0nYX2ooooo`;o0?ZJ2oooool2o`3jVP03ooooool0nY[o0?ZJ01_ooooo
0_l0nYX00ol0003o0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00Sooooo1Ol0nYX2ooooo`?o0?ZJ
0ol00002o`3jVP?ooooo0_l0nYX7ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
2_ooool3o`0000_ooooo0_l00004ooooo`;o0?ZJ0oooool2o`3jVP?ooooo0ol0nYX9ooooo`Oo0?ZJ
2_ooool2o`3jVRkooooo0_l00007ooooo`?o00007?ooool5o`3jVPGooooo0_l00?lNooooo`?o0?ZJ
Goooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`07ooooo`?o0?ZJ1Ol0
0?l6o`3jVP;ooooo0ol0nYXCooooo`?o0?ZJ0_ooool5o`3jVP05o`000?l00?oo003oo`3jV_ooool0
1?l0nYX00ooooooo0?ZJo`3jVP02o`3jVP?ooooo0ol0nYX2ooooo`?o0?ZJ3?ooool7o`3jVP;o003o
2?l0nYX01?oooooo003oo`00ool0nYX<ooooo`?o0?ZJ2_ooool<o`00o`03o`3jV_oooooooooo00;o
003o00Co0?ZJoooooooooooooooo0_l0nYXDooooo`05o`000?l0nY[o0?ZJooooool000000_l00?l0
0ol0nY[oooooooooo`02o`3jVPGooooo0_l0nYX2ooooo`;o0?ZJ2oooool2o`3jVP03ooooool0nY[o
0?ZJ01_ooooo0_l0nYX00ol0003o0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00Sooooo1Ol0nYX2
ooooo`?o0?ZJ0ol00006o`00o`03o`3jV_oooooooooo00Gooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0:ooooo`?o00002Oooool4o`0000Cooooo1ol0nYX3ooooo`03o`000?l0nY[o
0?ZJ00Cooooo0_l0nYX2ooooo`?o0?ZJ0oooool2o`3jVPWooooo0ol0nYX^ooooo`;o00001oooool3
o`0001kooooo1?l0nYX4ooooo`;o003o7oooool2o`3jVP?ooooo0_l0nYYJooooo`03o`000?oooooo
oooo033ooooo001=ooooo`03o`000?oooooooooo00Sooooo0ol0nYX2o`0000;o003o0ol0nYX01?oo
oooo0?ZJo`3jV_ooool4o`3jVQ;ooooo1?l0nYX2ooooo`Go0?ZJ00Co0000o`00ool00?oo0?ZJ0_oo
ool3o`3jVP03ooooool0003o0?ZJ00;o0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX<ooooo`05o`000?l0
nY[o0?ZJo`3jV_l000000_l0nYX3o`00o`;o0?ZJ00?o0000o`3jV_l0nYX00_l0nYX00ooooooo003o
o`00o`0>ooooo`;o0?ZJ2_ooool7o`00o`?o00000_l00?l00ol0nY[oooooooooo`02o`00oa[ooooo
00Go0000o`3jV_l0nY[o0?ZJo`000002o`00o`?ooooo0_l0nYX5ooooo`;o0?ZJ0_ooool2o`3jVP_o
oooo0_l0nYX00ooooooo0?ZJo`3jVP0Kooooo`;o0?ZJ00?o0000o`3jV_l0nYX00_l0nYX00ooooooo
0?ZJo`3jVP07ooooo`Ko0?ZJ0_ooool3o`3jVP?o00001_l00?l00ol0nY[oooooooooo`05ooooo`03
o`000?oooooooooo01?ooooo0_l0000<ooooo`;o00002Oooool3o`0000Gooooo1ol0nYX3ooooo`03
o`000?l0nY[o0?ZJ00Cooooo1_l0nYX4ooooo`;o0?ZJ2Oooool2o`3jVSWooooo0_l0000Pooooo`;o
0?ZJ1?ooool2o`00oaoooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVUWooooo0_l0000booooo`00
COooool00ol0003oooooooooo`09ooooo`?o0?ZJ00?o0000o`00ool00?l00ol0nYX00ooooooo0?ZJ
o`3jVP05o`3jVQ7ooooo1Ol0nYX2ooooo`Go0?ZJ00Co0000o`00ool00?oo0?ZJ0oooool2o`3jVP;o
oooo0ol0nYXHooooo`?o0?ZJ0_l00002o`3jVP;o003o00Co0?ZJo`000?l0003o00000_l0nYX2oooo
o`;o003o3_ooool2o`3jVP[ooooo0_l0nYX2ooooo`;o003o0_l0nYX2ooooo`?o003o0_ooool2o`00
oa[ooooo0_l00002o`3jVP03o`000?l00?oo003o00Go003o1Oooool2o`3jVP;ooooo0_l0nYX:oooo
o`?o0?ZJ00?oooooo`3jV_l0nYX06_ooool3o`3jVP;o00000ol0nYX00ooooooo0?ZJo`3jVP07oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool01?l0003o0?ZJo`3jV_l0nYX3o`0000;o003o0_ooool2
o`00o`03o`3jV_oooooooooo00Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0;
ooooo`;o00002Oooool3o`0000Gooooo0_l0nYX2ooooo`?o0?ZJ1?ooool2o`3jVPCooooo1_l0nYX4
ooooo`;o0?ZJ1?ooool2o`3jVP?ooooo0_l0nYXiooooo`?o00007oooool4o`3jVP;ooooo0_l00?lO
ooooo`Oo0?ZJF_ooool00ol0003oooooooooo`0`ooooo`00COooool3o`0000[ooooo0_l0nYX00ol0
003o003oo`00o`02o`3jVP?ooooo1_l0nYXAooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo1_l0nYX0
1?l0003o003oo`00ool0nYX8ooooo`;o0?ZJ6?ooool00ol0003o0?ZJo`3jVP03o`000004o`3jV_l0
0?oo003oo`3jVP;ooooo00?o0000o`3jV_l0nYX00_ooool2o`00oa[ooooo0ol0nYX2ooooo`?o0?ZJ
0oooool6o`00oa_ooooo00Co0000o`3jV_l0nY[o0?ZJ1ol00?l5ooooo`;o0?ZJ0_ooool2o`3jVP[o
oooo0_l0nYX2ooooo`;o0?ZJ6_ooool2o`3jVP?o00000_l0nYX2ooooo`;o0?ZJ1oooool2o`3jVP03
ooooool0nY[o0?ZJ00;ooooo00Co0000o`3jV_l0nY[o0?ZJ0ol00002o`00o`;ooooo0_l00?l00ol0
nY[oooooooooo`04ooooo`;o00005Oooool00ol0003oooooooooo`0;ooooo`;o00001oooool5o`00
00Gooooo0_l0nYX9ooooo`;o0?ZJ1?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPCooooo0_l0nYX4
ooooo`Oo0?ZJ>Oooool3o`00023ooooo1?l0nYX00ooooooo003oo`00o`0Oooooo`Oo0?ZJF_ooool0
0ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`0:ooooo`;o0?ZJ00Goooooo`00
ool00?oo003oo`3jVP03ooooo`?o0?ZJ00?oooooo`3jV_l0nYX04Oooool2o`3jVP03ooooool0nY[o
0?ZJ00?o0?ZJ00Go0000o`00ool00?oo003oo`000002o`00ob?ooooo0_l000001Ooooooo0000o`00
0?oooooo0?ZJ00;o003o00Co0?ZJoooooooooooo00001_l00?lKooooo`;o0?ZJ0_ooool3o`3jVP?o
oooo1_l00?lKooooo`;o00001?l0nYX00ol0003oooooooooo`02o`00o`Cooooo0ol0nYX2ooooo`;o
0?ZJ2_ooool2o`3jVP;ooooo0_l0nYXCooooo`;o0?ZJ1Oooool2o`3jVP?o00000_l0nYX2ooooo`;o
0?ZJ1_ooool3o`3jVP04ooooool0nY[o0?ZJooooo`;o00000ol0nYX2o`000003ooooool00?oo003o
00;ooooo0_l00?l2o`3jVPKooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0;oooo
o`?o00001_ooool5o`0000Gooooo0_l0nYX9ooooo`;o0?ZJ1?ooool2o`3jVPSooooo0ol0nYX3oooo
o`Oo0?ZJ>Oooool3o`00027ooooo1Ol0nYX00ol00?ooooooooooo`0Mooooo`;o0?ZJ0oooool2o`3j
VU[ooooo00?o0000ooooooooool0<?ooool003Cooooo0ol00003ooooo`03o`000?oooooooooo00;o
oooo0ol00003ooooo`?o00001Oooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`00o`04
o`3jV_l0003o0000ooooo`?o0?ZJ00?oooooo`3jV_l0nYX04Oooool2o`3jVP03ooooool0nY[o0?ZJ
00;o0?ZJ0_l00006o`00ob?ooooo0_l000001Ooooooo0000o`000?oooooo000000co003o6oooool2
o`3jVP;ooooo1?l0nYX2ooooo`;o0?ZJ0_ooool2o`3jVQ_ooooo0_l00004o`3jVP03o`000?oooooo
oooo00;o003o1?ooool2o`3jVP?ooooo0_l0nYX:ooooo`;o0?ZJ0_ooool2o`3jVQ?ooooo0_l0nYX5
ooooo`;o0?ZJ0ol00002o`3jVP;ooooo0_l0nYX6ooooo`;o0?ZJ0_ooool6o`00o`04o`3jV_l0003o
0000o`0000?o003o0_ooool2o`00o`;o0?ZJ1_ooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo00cooooo0_l00006ooooo`Co00001Oooool3o`3jVPWooooo0_l0nYX3ooooo`?o0?ZJ2Ooo
ool2o`3jVP?ooooo0_l0nYX2ooooo`?o0?ZJ>_ooool2o`0002?ooooo0ol0nYX00ol00?oooooooooo
o`0Booooo`Oo003o2Oooool2o`3jVU[ooooo00?o0000ooooooooool0<?ooool003Gooooo00?o0000
ooooooooool01_ooool01ol0003ooooooooooooooooo0000ooooool000000oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00[ooooo0_l0nYX2ooooo`;o003o00Coooooo`000?l0003o
oooo0_l0nYX01?l0003oooooo`3jV_l0nYX@ooooo`?o0?ZJ00?o0000o`3jV_l0nYX00_l0nYX2o`00
00Ko003o8oooool2o`000005ooooool0003o0000ooooool000001ol00?l00ol0nY[oooooooooo`02
o`3jVQ_ooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l0nYXK
ooooo`;o000000?oooooo`3jV_l0nYX00_l0nYX01?l0003oooooo`00ool00?l4ooooo`;o0?ZJ0ooo
ool2o`3jVP[ooooo0_l0nYX2ooooo`;o0?ZJ4_ooool3o`3jVPGooooo0_l0nYX3o`0000;o0?ZJ0_oo
ool2o`3jVPKooooo0_l0nYX2ooooo`Ko003o00Co0?ZJo`000?l0003o00000_l00?l00ol0nY[ooooo
ooooo`02o`00o`;o0?ZJ1_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00cooooo
0_l00005ooooo`Go0?ZJ1Oooool2o`3jVP[ooooo0_l0nYX3ooooo`;o0?ZJ2_ooool2o`3jVP;ooooo
0ol0nYXoooooo`;o00009?ooool2o`3jVP03o`00oooooooooooo01;ooooo1ol00?l9ooooo`;o0?ZJ
F_ooool00ol0003oooooooooo`0`ooooo`00<_ooool5o`0000Oooooo00Go0000oooooooooooooooo
o`000005ooooo`03o`000?oooooooooo00;ooooo0ol0000:ooooo`;o0?ZJ0_ooool3o`00o`;o0000
00Goooooo`3jV_l0nY[o0000ooooo`02o`3jVQ3ooooo0_l0nYX00ooooooo0000o`3jVP02o`3jVP?o
00000_l00?l01?l0nY[oooooo`3jV_l0nYXSooooo`;o00001?ooool01?l0003o0?ZJo`3jV_l0nYX3
ooooo`;o0?ZJ0_ooool2o`3jVQ_ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`Go0?ZJ0_ooool2
o`3jVQ_ooooo0_l000000ooooooo0?ZJo`3jVP02o`3jVP04o`000?oooooo003oo`00o`Cooooo1ol0
0?l:ooooo`;o0?ZJ0_ooool2o`3jVQ;ooooo0ol0nYX5ooooo`;o0?ZJ0ol00002o`3jVP;ooooo0_l0
nYX6ooooo`;o0?ZJ0_ooool2o`00o`03ooooool0003o003o00;o003o00?oooooo`000?l000000_l0
0?l00ol0nY[oooooooooo`03o`00o`03o`3jV_oooooooooo00;ooooo0ol0000Eooooo`03o`000?oo
oooooooo00cooooo0_l00004ooooo`03o`000?l0nY[o0?ZJ00Ko0?ZJ0_ooool2o`3jVP[ooooo0ol0
nYX2ooooo`;o0?ZJ2_ooool2o`3jVP;ooooo0_l0nYY0ooooo`;o00009?ooool2o`3jVPKo003o0_oo
ool3o`00o`Kooooo1_l00?l3ooooo`;o003o2Oooool2o`3jVU[ooooo00?o0000ooooooooool0<?oo
ool003;ooooo00Co0000oooooooooooo00002?ooool4o`0000Kooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool7o`00o`03o`3jV_l0003o000000;o0?ZJ4?oo
ool2o`3jVP03ooooool0003o0?ZJ00;o0?ZJ0_l00003o`00o`04o`3jV_oooooo0?ZJo`3jVR?ooooo
0_l00006ooooo`;o0?ZJ0oooool3o`3jVP03ooooool0nY[o0?ZJ01_ooooo1Ol0nYX2ooooo`Ko0?ZJ
00?oooooo`3jV_l0nYX06oooool5o`0000;o0?ZJ00Co0000ooooool00?oo003o1?ooool7o`00o`[o
oooo0_l0nYX2ooooo`;o0?ZJ4_ooool3o`3jVPGooooo0_l0nYX3o`0000;o0?ZJ0_ooool2o`3jVPGo
oooo0ol0nYX2ooooo`;o003o00?oooooo`000?l000001ol00?l01?l0nY[oooooooooool00002o`00
o`03o`3jV_oooooooooo00Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0<oooo
o`;o00001?ooool01?l0003o0?ZJo`3jV_ooool9o`3jVP[ooooo1ol0nYX:ooooo`Ko0?ZJ@?ooool2
o`0002Cooooo0_l0nYX;o`00o`Gooooo1_l00?l4ooooo`;o003o2Oooool2o`3jVU[ooooo00?o0000
ooooooooool0<?ooool003?ooooo00?o0000ooooool000002?ooool00ol0003oooooooooo`03oooo
o`Co00001Oooool00ol0003oooooooooo`0:ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01Ol00?l00ol0
nY[o0000o`000002o`3jVPoooooo0ol0nYX00ooooooo0000o`3jVP02o`3jVP;o00000_l00?l2o`3j
VP03ooooool0nY[o0?ZJ02_ooooo0_l0nYX3ooooo`Ko0?ZJ7?ooool4o`3jVP;ooooo1_l0nYX00ooo
oooo0?ZJo`3jVP0Kooooo`Co000000Goooooo`3jV_l0nY[o0000ooooo`02o`00o`Cooooo0_l00?l3
ooooo`;o003o2Oooool3o`3jVP;ooooo0_l0nYXBooooo`?o0?ZJ1?ooool3o`3jVP?o00000_l0nYX2
ooooo`;o0?ZJ1Oooool2o`3jVP?ooooo0_l00?l3o`0000Oo003o00Co0?ZJo`000?oooooo00000_l0
0?l00ol0nY[oooooooooo`04ooooo`03o`000?oooooooooo01?ooooo0_l0000=ooooo`;o00001?oo
ool00ol0003o0?ZJo`3jVP05ooooo`Go0?ZJ3?ooool5o`3jVP[ooooo1_l0nYY0ooooo`?o00008ooo
ool2o`3jVP03o`00oooooooooooo00;ooooo1_l00?l5ooooo`;o003o2?ooool2o`00o`Wooooo0_l0
nYYBooooo`;o0?ZJ1Oooool2o`0003;ooooo000dooooo`;o00002Oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02oooool2o`3jVP04ooooool0nY[o
0?ZJooooo`;o00001ol00?l4ooooo`;o0?ZJ2Oooool2o`3jVP;ooooo00?o0000o`3jV_l0nYX00ol0
0002o`00o`;o0?ZJ00?oooooo`3jV_l0nYX0:oooool3o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ7Ooo
ool3o`3jVP?ooooo2?l0nYXKooooo`Co000000Goooooo`3jV_l0nY[o0000ooooo`02o`00o`Cooooo
0_l00?l3ooooo`;o003o2Oooool2o`3jVP?ooooo0_l0nYXBooooo`?o0?ZJ1?ooool2o`3jVP?o0000
00?oooooo`3jV_l0nYX00_ooool2o`3jVPGooooo0_l0nYX00ooooooo0000o`000002o`00o`?o0000
0_l0nYX01?oooooo0000o`000?ooool2o`3jVP03o`000?oooooo000000;o003o00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00cooooo0_l00002ooooo`?o
00000_l0nYX8ooooo`;o0?ZJ3oooool2o`3jVPgooooo0ol0nYY1ooooo`;o00008oooool2o`3jVPWo
oooo0ol00?l3ooooo`?o003o2?ooool2o`00o`Wooooo0_l0nYYAooooo`?o0?ZJ1_ooool00ol0003o
ooooooooo`0`ooooo`00=Oooool00ol0003oooooooooo`08ooooo`;o00000_ooool5o`0000Cooooo
00?o0000ooooooooool02oooool6o`3jVP;o000000?oooooo`00ool00?l01?l00?l00ol0nY[ooooo
ooooo`03o`3jVPWooooo3?l00?l2o`3jVP03ooooool0nY[o0?ZJ02cooooo1Ol0nYX2ooooo`?o0?ZJ
7_ooool2o`3jVPOooooo1?l0nYXKooooo`Co000000Goooooo`3jV_l0nY[o0?ZJooooo`02o`00o`04
o`3jV_oooooo0000o`0000;o003o0oooool2o`00o`Wooooo0_l0nYX3ooooo`;o0?ZJ4Oooool4o`3j
VPCooooo0_l0nYX3o`000003ooooool0nY[o0?ZJ00;ooooo0_l0nYX5ooooo`;o0?ZJ00?oooooo`00
0?l000000_l00?l00ol0nY[o0000o`000002o`3jVP04ooooool0003o0000ooooo`;o0?ZJ0ol00002
o`00o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0<
ooooo`;o00000_ooool3o`0000;o0?ZJK?ooool2o`0002?ooooo0_l0nYX:ooooo`Oo003o2Oooool2
o`00o`Wooooo0_l0nYYAooooo`;o0?ZJ1oooool00ol0003oooooooooo`0`ooooo`00COooool3o`00
00cooooo1Ol0nYX3o`0000;o0?ZJ00Koooooo`000?l00?oo003oo`3jV_ooool4o`3jVPWooooo3?l0
0?l5o`3jVRgooooo1?l0nYX2ooooo`?o0?ZJ7_ooool2o`3jVPSooooo0ol0nYXKooooo`Co00000_oo
ool2o`3jVP07o`000?l00?oo003oo`3jV_oooooo0000o`3jVP02o`00o`03o`3jV_oooooooooo00;o
003o2Oooool2o`3jVP?ooooo0_l0nYXAooooo`Co0?ZJ1?ooool2o`3jVP?o000000?oooooo`3jV_l0
nYX00_ooool2o`00o`Gooooo0_l0nYX00ooooooo0000o`000002o`00o`03o`3jV_l0003o000000;o
0?ZJ00Coooooo`000?l0003ooooo0ol0nYX2o`0000;o003o00?o0000ooooooooool00oooool2o`00
01Gooooo00?o0000ooooooooool03?ooool2o`000003ooooool0003o000000;o00000_l0nYY/oooo
o`;o00008oooool2o`3jVP[ooooo1ol00?l9ooooo`;o003o2Oooool2o`3jVU7ooooo0_l0nYX00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo00go
oooo1?l0nYX3o`0000;o0?ZJ00Koooooo`000?l00?oo003oo`3jV_ooool4o`3jVPWooooo0_l00?l3
o`0000;o0?ZJ1?ooool6o`3jVRgooooo1?l0nYX3ooooo`;o0?ZJ:?ooool3o`3jVQ_ooooo1?l00002
ooooo`;o0?ZJ00Oo0000o`00ool00?oo0?ZJooooool0003o0?ZJ00;o003o00?o0?ZJooooooooool0
0_l00?l9ooooo`Oo003o4Oooool4o`3jVPCooooo3?l00?l5ooooo`;o0?ZJ00?oooooo`000?l00?l0
0_l00?l00ol0nY[o0000ooooo`02o`3jVP04ooooool0003o0000ooooo`?o0?ZJ0_l00003o`00o`Ko
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0<ooooo`;o000000Coooooo`000?l0
003o00000ol0nYY/ooooo`;o00008oooool2o`3jVP[ooooo0ol00?l=ooooo`;o003o2Oooool3o`3j
VToooooo0ol0nYX00ol0003oooooooooo`04ooooo`03o`000?oooooooooo033ooooo001=ooooo`03
o`000?oooooooooo00gooooo1?l0nYX3o`0000;o0?ZJ00Coooooo`000?l00?oo003o1_l0nYX8oooo
o`04o`000?l00?oo003oo`3jVP;o00000ol0nYX2ooooo`Oo0?ZJ;_ooool3o`3jVT_ooooo1?l00002
ooooo`?o0?ZJ0_l00?l01?l0nY[oooooo`000?l0nYX2o`00o`03o`3jV_oooooooooo00;o003o2Ooo
ool7o`00oa3ooooo1Ol0nYX4ooooo`co003o1Oooool2o`3jVP04ooooool0003o003oo`00o`;o0?ZJ
00?o0000ooooool0nYX00_l0nYX2o`000004ooooool0nY[o0?ZJo`3jVP;o00000ol00?l6ooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool03?ooool6o`0000;o0?ZJKOooool2o`000003
ooooool0003o0000023ooooo0_l0nYXJooooo`?o003o2Oooool2o`3jVToooooo0_l0nYX2o`0000Ko
oooo00?o0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool03oooool3o`3jVP;o0000
0_l0nYX01?oooooo0000o`00ool00?l3o`3jVP04ooooool0nY[o0?ZJooooo`;o00001Oooool01?l0
003o003oo`00ool0nYX2o`0000?o0?ZJ0_ooool2o`3jVP;ooooo0ol0nYX_ooooo`;o0?ZJBoooool4
o`0000?ooooo0_l0nYX2o`00o`04o`3jV_oooooo0000o`3jVP;o003o00?o0?ZJooooooooool00_l0
0?l9ooooo`;o003o0oooool2o`00oa3ooooo0_l0nYX00ooooooo0?ZJo`3jVP04ooooo`;o003o00Co
ooooo`000?l0003ooooo0_l0nYX2ooooo`;o003o1Oooool2o`3jVP;o00000_l00?l2o`3jVP03o`00
0?oooooo0?ZJ00;o0?ZJ0oooool4o`3jVP03o`000?l0nY[o0?ZJ00Oooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0=ooooo`Go00000_l0nYY]ooooo`;o000000Coooooo`000?l0003o
00007oooool2o`3jVQ_ooooo0_l00?l9ooooo`;o0?ZJ1oooool3o`3jVTCooooo0ol0nYX8ooooo`03
o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo00oooooo00Co0000o`3jV_l0nY[o
00001?l0nYX00ol0003o003oo`00o`03o`3jVP04ooooool0nY[o0?ZJooooo`;o00000_l0nYX3oooo
o`04o`3jV_l00?oo003oo`3jVP;o00000ol0nYX2ooooo`;o0?ZJ0oooool2o`3jVWcooooo1?l00003
ooooo`;o0?ZJ0_l00?l01?l0nY[o0000o`000?l0nYX2o`00o`03o`3jV_oooooooooo00;o003o2Ooo
ool2o`00o`03o`000?oooooooooo00;o003o4?ooool2o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_l0
0?l01?oooooo0000o`000?ooool2o`3jVP;ooooo0_l00?l4ooooo`?o0?ZJ0_l00002o`00o`;o0?ZJ
00?o0000ooooool0nYX00_l0nYX3ooooo`Co0?ZJ00?o0000o`3jV_l0nYX01oooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo00gooooo1?l000000ooooooo0?ZJo`3jVP1]ooooo`Ko0000
7oooool2o`3jVQ_ooooo0_l00?l9ooooo`;o0?ZJ1Oooool5o`3jVT7ooooo1_l0nYX8ooooo`03o`00
0?oooooooooo033ooooo001=ooooo`?o00004?ooool7o`3jVP04o`000?l00?oo003oo`00o`;o0?ZJ
00Goooooo`3jV_l0nY[oooooo`000003o`3jVP?ooooo00Co0?ZJo`00ool00?oo0?ZJ0_l00004o`3j
VP03ooooool0nY[o0?ZJ00?ooooo0_l0nYYlooooo`Co00000oooool2o`3jVP;o003o00Co0?ZJo`00
0?l0003o0?ZJ0_l00?l2o`3jVP03ooooool00?oo003o00Wooooo0_l00?l00ol0003oooooooooo`02
o`00o`Sooooo0_l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?ooool2o`00o`Cooooo0_l0nYX2
ooooo`;o003o1?ooool2o`3jVP?o00000_l00?l2o`3jVP03o`000?oooooo0?ZJ00;o0?ZJ0_ooool5
o`3jVP03o`000?l0nY[o0?ZJ00Kooooo0_l0000Eooooo`;o00003_ooool01Ol0003o0?ZJo`3jV_l0
nY[ooooo00;o0?ZJK_ooool5o`0000gooooo0_l00002ooooo`;o00003?ooool2o`3jVQ_ooooo0_l0
0?l9ooooo`;o0?ZJ1?ooool6o`3jVT3ooooo1Ol0nYX2o`0000Oooooo0_l0000booooo`00COooool0
0ol0003oooooooooo`0@ooooo`03o`000?l0nY[o0?ZJ00Go0?ZJ00Co0000o`00ool00?oo0?ZJ0_oo
ool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0oooool00ol0nY[o003oo`00o`02o`3jVP03o`000?l0
nY[o0?ZJ00;o0?ZJ00?oooooo`3jV_l0nYX0POooool4o`0000?ooooo00Ko0000o`3jV_l00?oo003o
o`3jV_l00002o`3jVP;o003o0_l0nYX00ooooooo003oo`00o`09ooooo`;o003o00?o0?ZJoooooooo
ool00_l00?l8ooooo`;o0?ZJ1Oooool3o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_l00?l4ooooo`;o
0?ZJ0_ooool2o`00o`Cooooo0_l0nYX3o`0000;o003o0_l0nYX00ol0003oooooo`3jVP02o`3jVP;o
oooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3jVPKooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0=ooooo`03o`000?l0nY[o0?ZJ00Co0?ZJK_ooool5o`0000gooooo0_l00002ooooo`;o
00003?ooool3o`3jVQ[ooooo0_l00?l9ooooo`;o0?ZJ0oooool4o`3jVP03ooooool0nY[o0?ZJ00ko
oooo0_l0nYX`ooooo`;o0?ZJ0_ooool3o`0000Sooooo00?o0000ooooooooool0<?ooool004gooooo
00?o0000ooooooooool04?ooool00ol0003o0?ZJo`3jVP02o`3jVP04ooooool0nY[o0?ZJo`3jVP;o
003o00?o0?ZJo`000?ooool00_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP04ooooool0003o0000o`3j
VP;o003o0_l0nYX00ol0003o0?ZJo`3jVP05o`3jVX7ooooo1?l00003ooooo`;o00000ol00?l00ol0
003o0?ZJo`3jVP02o`00o`;o0?ZJ00?oooooo`00ool00?l02Oooool2o`00o`03o`3jV_oooooooooo
00;o003o2?ooool2o`3jVPGooooo0_l0nYX01?l0003oooooo`3jV_l0nYX4ooooo`;o003o00Co0?ZJ
oooooooooooooooo0_l0nYX2ooooo`;o003o1?ooool2o`3jVP?o00000_l00?l2o`3jVP03o`000?l0
nY[o0?ZJ00;o0?ZJ0_ooool2o`3jVP03ooooool0003o0?ZJ00Co0?ZJ1_ooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo00kooooo1_l0nYYaooooo`;o00003Oooool3o`000004ooooool0
003o0000o`0000cooooo0_l0nYXJooooo`;o003o2Oooool2o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ
3?ooool4o`3jVS3ooooo0_l0nYX2ooooo`;o00002Oooool00ol0003oooooooooo`0`ooooo`00COoo
ool00ol0003oooooooooo`0Aooooo`Co0?ZJ0_ooool2o`3jVP;o003o00?o0?ZJo`000?ooool00_l0
nYX00ooooooo0?ZJo`3jVP02o`3jVP?o000000?o0?ZJo`00ool00?l00_l0nYX01?l0003o0?ZJo`3j
V_ooool4o`3jVX;ooooo0ol00003ooooo`;o000000Co0?ZJo`00ool00?oo00000_l0nYX2o`00o`;o
0?ZJ00?oooooo`00ool00?l02Oooool2o`00o`03o`3jV_oooooooooo00;o003o2?ooool2o`3jVPGo
oooo0_l0nYX2o`0000;o0?ZJ1?ooool2o`00o`04o`3jV_ooooooooooooooo`;o0?ZJ0_ooool2o`00
o`Cooooo1ol00?l2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool2o`3jVP03ooooool0003o0?ZJ
00Co0?ZJ1_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00kooooo0_l0nYYeoooo
o`?o00003?ooool3o`000004ooooool0003o0000o`0000cooooo0_l0nYXJooooo`Ko003o1Oooool2
o`3jVP;ooooo0ol0nYX3ooooo`;o0?ZJ2_ooool6o`3jVS3ooooo0_l0nYX2ooooo`;o00002Oooool0
0ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`0Booooo`?o0?ZJ0_ooool2o`3j
VP;o003o0_l000000ooooooo0?ZJo`3jVP05o`3jVP;o000000Co0?ZJo`00ool00?oo003o1Ol0nYX2
ooooo`?o0?ZJP_ooool2o`0000Cooooo0_l000000ol0nY[o003oo`00o`02o`3jVP?o003o0_l0nYX0
0ooooooo003oo`00o`08ooooo`04o`000?l00?oo003oo`3jVP;ooooo0_l00?l7ooooo`?o0?ZJ1Ooo
ool2o`3jVP;o00000_l0nYX4ooooo`;o003o00Co0?ZJoooooooooooooooo0_l0nYX2ooooo`;o003o
1?ooool7o`00o`So0?ZJ00?oooooo`3jV_l0nYX00_ooool5o`3jVPKooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0>ooooo`;o0?ZJM_ooool2o`0000cooooo0ol000001?oooooo0000
o`000?l0000<ooooo`;o0?ZJ6_ooool6o`00o`Gooooo0_l0nYX2ooooo`;o0?ZJ1?ooool3o`3jVPWo
oooo0ol0nYX00ooooooo0?ZJo`3jVP03ooooo`?o0?ZJ:_ooool2o`3jVP;ooooo0_l00009ooooo`03
o`000?oooooooooo033ooooo001=ooooo`?o00004oooool2o`3jVP;ooooo0_l0nYX7o`00o`;o0?ZJ
00Co0000o`3jV_l0nY[o00000_l0nYX2o`00o`03o`3jV_l0003o0?ZJ00?o0?ZJ0_ooool3o`3jVX;o
oooo0_l00004ooooo`;o000000?o0?ZJo`00ool00?l00_l0nYX2o`00o`?o0?ZJ00?oooooo`00ool0
0?l02?ooool01?l0003o003oo`00ool0nYX2ooooo`;o003o0oooool2o`3jVP;ooooo0ol0nYX5oooo
o`;o0?ZJ0_l00002o`3jVPCooooo0_l00?l01?l0nY[oooooooooooooool2o`3jVP;ooooo0_l00?l4
ooooo`;o003o00Co0000oooooooooooooooo1_l0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVP;ooooo
1Ol0nYX5ooooo`;o00005Oooool00ol0003oooooooooo`0=ooooo`?o0?ZJM_ooool2o`0000Wooooo
1_l000001?oooooo0000o`000?l0000<ooooo`;o0?ZJ6_ooool2o`00o`;ooooo0_l00?l5ooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1Oooool2o`3jVPWooooo0_l0nYX2ooooo`So0?ZJ4oooool3o`3j
VQ?ooooo0ol0nYX2ooooo`;o00002Oooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003o
ooooooooo`0Gooooo`03o`000?l0nY[o003o00Ko003o00?o0?ZJo`000?l000001Ol0nYX2o`00o`03
o`3jV_l0003o0?ZJ00?o0?ZJ0_ooool3o`3jVX;ooooo0_l00004ooooo`;o000000?o0?ZJo`00ool0
0?l00_l0nYX2o`00o`Co0?ZJ0_l00?l8ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo0_l00?l3oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX5ooooo`;o0?ZJ0_l00002o`3jVPCooooo0_l00?l01?l0
nY[oooooooooooooool2o`3jVP;ooooo0_l00?l01?l0nY[oooooooooooooool2o`00o`04o`000?oo
ooooooooooooo`Ko0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX2ooooo`Go0?ZJ1_ooool01?l0003o
ooooo`000?l00004ooooo`03o`000?oooooooooo00;ooooo0ol00006ooooo`03o`000?oooooooooo
00gooooo0_l0nYYgooooo`;o00002Oooool:o`0000cooooo0_l0nYXNooooo`;o003o1Oooool6o`3j
VPGooooo0_l0nYX2ooooo`;o0?ZJ1Oooool2o`3jVP?ooooo1ol0nYXAooooo`Go0?ZJ4?ooool6o`3j
VP;ooooo0_l00009ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo01Oo
oooo0_l00002o`3jVP?o00000_l00?l01?l0nY[o0000o`000?l00003o`3jVP04ooooool00?oo003o
o`3jVP;o00000ol0nYX3ooooo`;o0?ZJP_ooool2o`0000Cooooo0_l000000ol0nY[o003oo`00o`02
o`3jVP;o003o00Co0?ZJo`000?l0nY[o0?ZJ0_l00?l8ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo
0_l00?l2ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX5ooooo`;o0?ZJ0_l00002o`3jVPCooooo
0_l00?l01?l0nY[oooooooooooooool2o`3jVP;ooooo0_l00?l01?l0nY[oooooooooooooool2o`00
o`Cooooo1_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP?ooooo0_l0nYX8ooooo`;o00000_ooool00ol0
003oooooooooo`05ooooo`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`08
ooooo`;o0?ZJ0oooool2o`3jVWOooooo0_l00009ooooo`[o00003?ooool2o`3jVQkooooo0ol00?l4
ooooo`Co0?ZJ1oooool6o`3jVPCooooo0ol0nYX3ooooo`Co0?ZJ00?oooooo`3jV_l0nYX04?ooool6
o`3jVPoooooo1Ol0nYX2ooooo`Co00002Oooool00ol0003oooooooooo`0`ooooo`00COooool00ol0
003oooooooooo`0Hooooo`04o`000?l0nY[o0?ZJo`3jVP;o00000_l00?l01?l0nY[oooooo`000?l0
0003o`3jVP04ooooool00?oo003oo`3jVP;o000000?oooooo`3jV_l0nYX0Qoooool2o`0000Cooooo
0_l000001Ol0nY[o003oo`00ool0nY[o000000;o003o00Co0?ZJo`000?l0nY[o0?ZJ0_l00?l8oooo
o`03o`3jV_l00?oo003o00;o0?ZJ00?oooooo`00ool00?l00_ooool8o`3jVPGooooo0_l0nYX01?oo
oooo0000o`3jV_l0nYX4ooooo`;o003o00Co0?ZJoooooooooooooooo0ol0nYX01?oooooo003oo`00
ool0nYX3ooooo`;o003o1?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo1?l0nYX=ooooo`;o
00000_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo0ol00008ooooo`Oo
0?ZJMoooool3o`0000Sooooo1?l000000ooooooo0000o`000004o`0000_ooooo0_l0nYXOooooo`;o
003o1?ooool2o`3jVPWooooo1_l0nYX3ooooo`?o0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX?ooooo`Co
0?ZJ00?oooooo`3jV_l0nYX03oooool3o`3jVPCooooo0ol00008ooooo`?o0000<_ooool004gooooo
00?o0000ooooooooool06?ooool2o`0000;o0?ZJ0_l00002o`00o`?ooooo00Go0000o`3jV_l0nY[o
0?ZJooooo`02o`00o`03o`3jV_oooooooooo08[ooooo0_l00004ooooo`;o000000Go0?ZJo`00ool0
0?oo0?ZJo`000002o`00o`04o`3jV_l0003oooooo`3jVP;o003o2?ooool00ol0nY[o003oo`00o`02
o`3jVP03ooooool00?oo003o00;ooooo1Ol0nYX00ooooooo0?ZJo`3jVP05ooooo`;o0?ZJ00Cooooo
o`000?l0nY[o0?ZJ1?ooool2o`00o`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX01?oooooo003oo`00
ool0nYX3ooooo`;o003o00?o0?ZJooooooooool00ol0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`Co
0?ZJ3Oooool2o`0000;ooooo00?o0000ooooooooool01oooool2o`0000Kooooo00?o0000oooooooo
ool00oooool<o`3jVWOooooo1ol00004ooooo`?o00000_ooool6o`0000_ooooo0_l0nYXOooooo`Oo
003o2_ooool3o`3jVP03ooooool0nY[o0?ZJ00Ko0?ZJ2Oooool2o`3jVPOooooo1?l0nYX4ooooo`;o
0?ZJ0oooool2o`3jVPoooooo0_l0nYX5ooooo`?o00002_ooool00ol0003oooooooooo`0`ooooo`00
COooool3o`0001Sooooo0_l00002o`3jVP;o00001ol00?l2o`3jVP03ooooool00?oo003o09Cooooo
00Co0000o`3jV_l00?oo003o0_l00002o`00o`04o`3jV_l0003o0000o`3jVP;o003o2?ooool00ol0
nY[o003oo`00o`02o`3jVP03ooooool00?oo003o00;ooooo1Ol0nYX00ooooooo0?ZJo`3jVP05oooo
o`;o0?ZJ00?oooooo`000?l0nYX00_l0nYX2ooooo`03o`3jV_l00?oo003o00;o0?ZJ00?oooooo`3j
V_l0nYX00_l0nYX01?oooooo003oo`00ool0nYX2o`000004ooooool00?oo003oo`3jVP;ooooo0_l0
nYX2ooooo`?o0?ZJ0_ooool4o`3jVPcooooo0ol00002ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`Ko0?ZJOOooool7o`0000Cooooo0_l0
0003ooooo`Ko00002oooool2o`3jVQoooooo1ol00?l:ooooo`;o0?ZJ0oooool5o`3jVP_ooooo0ol0
nYX5ooooo`Go0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX?ooooo`;o0?ZJ1?ooool4o`0000[ooooo00?o
0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool06?ooool2o`0000;o0?ZJ0_l00008
o`00o`;ooooo0_l00?nDooooo`;o00000_l00?l2o`0000;o003o00Co0?ZJo`000?l0003ooooo0_l0
0?l8ooooo`03o`3jV_l00?oo003o00;o0?ZJ00?oooooo`00ool00?l00_ooool5o`3jVP03ooooool0
nY[o0?ZJ00Gooooo0_l0nYX00ooooooo0000o`000002o`3jVP;ooooo00?o0?ZJo`00ool00?l00_l0
nYX00ooooooo0?ZJo`3jVP03o`3jVP;o003o00Co0?ZJo`000?l0003ooooo0_l00?l00ol0nY[ooooo
ooooo`02o`3jVP?ooooo0_l0nYX2ooooo`Co0?ZJ3Oooool2o`0000;ooooo00?o0000ooooooooool0
1Oooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool0Qoooool6o`0000Co
oooo0_l00005ooooo`Co00002oooool2o`3jVQoooooo0_l00?l3ooooo`;o003o3oooool3o`3jVPko
oooo0_l0nYX3ooooo`Co0?ZJ00?oooooo`3jV_l0nYX00oooool3o`3jVP?ooooo0_l0nYX>ooooo`?o
0?ZJ0oooool5o`0000[ooooo00?o0000ooooooooool0<?ooool003[ooooo0ol00003ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Hooooo`;o0000
0ol0nYX00ol0003o0?ZJo`3jVP03ooooo`03o`000?l00?oo003o00Co003oU?ooool2o`0000;o003o
0_l00002o`00o`04o`3jV_l0003o0000ooooo`;o003o2?ooool00ol0nY[o003oo`00o`02o`3jVP04
ooooool00?oo003oooooo`Ko0?ZJ00?oooooo`3jV_l0nYX01Oooool6o`00o`04o`3jV_oooooo0?ZJ
o`3jVP;o003o0_l0nYX01?oooooo0?ZJo`3jV_l00002o`3jVP;o003o00Co0?ZJo`000?l0003ooooo
0_l00?l00ol0nY[oooooooooo`02o`3jVP?ooooo0_l0nYX2ooooo`Co0?ZJ3Oooool01?l0003ooooo
o`000?l00009ooooo`?o00001_ooool00ol0003oooooooooo`27ooooo`Ko00001?ooool2o`0000Oo
oooo0ol0000:ooooo`;o0?ZJ9?ooool2o`00o`Kooooo0_l0000Hooooo`;o0?ZJ0oooool3o`3jVP;o
oooo0_l0nYX3ooooo`;o0?ZJ1?ooool2o`3jVPgooooo00?o0000o`3jV_l0nYX01?ooool3o`0000co
oooo00?o0000ooooooooool0<?ooool003_ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo01Sooooo0_l000001?oooooo0?ZJo`3jV_l00003o`3jVP?o
oooo00?o0?ZJo`00ool00?l00ol00?nDooooo`;o00000_l00?l01Ol0003oooooo`00ool00?oo0?ZJ
00;o000000?oooooo`00ool00?l02?ooool00ol0nY[o003oo`00o`02o`3jVP04ooooool00?oo003o
ooooo`Ko0?ZJ00?oooooo`3jV_l0nYX01Oooool6o`00o`04o`3jV_oooooo0?ZJo`3jVP;o003o1Ol0
nYX00ol0003o0?ZJo`3jVP02o`00o`04o`3jV_l0003o0000ooooo`;o003o00?o0?ZJooooooooool0
0_l0nYX3ooooo`;o0?ZJ0_ooool4o`3jVPgooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`28ooooo`Go00001?ooool2o`0000Oooooo0ol0000:ooooo`?o0?ZJ8oooool2o`00o`Kooooo
0_l0000Hooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX3ooooo`?o0?ZJ0_ooool2o`3jVPCooooo
0_l0nYX=ooooo`03o`000?l0nY[o0?ZJ00Cooooo0_l0000=ooooo`03o`000?oooooooooo033ooooo
000hooooo`Go00002_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Sooooo0_l0
00001?oooooo0?ZJo`3jV_l00003o`3jVP?ooooo0ol0nYX00ooooooo0?ZJo`3jVP2Dooooo`;o0000
0_l00?l01Ol0003oooooo`00ool00?oo0?ZJ00;o000000?oooooo`00ool00?l02?ooool00ol0nY[o
003oo`00o`03o`3jVP;o003o1ol0nYX00ooooooo0?ZJo`3jVP05ooooo`;o003o00Coooooo`000?l0
0?oo003o1?l0nYX2o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ00?o0000o`3jV_l0nYX00_l00?l01?l0
nY[o0000o`000?ooool2o`00o`03o`3jV_oooooooooo00;o0?ZJ2?ooool3o`3jVPgooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`28ooooo`;o000000Coooooo`000?l0003o00000ooo
ool2o`0000Sooooo0_l0000:ooooo`Ko0?ZJ8?ooool2o`00o`Kooooo0_l0000Hooooo`Ko0?ZJ1Ooo
ool2o`3jVP04ooooool0nY[o0?ZJo`3jVPCooooo0_l0nYX9ooooo`;o00000_ooool3o`3jVP;o0000
0_ooool2o`0000gooooo00?o0000ooooooooool0<?ooool003Sooooo00Co0000oooooooooooo0000
2oooool00ol0003oooooooooo`03ooooo`?o00006?ooool2o`000003ooooool0nY[o0?ZJ00Co0?ZJ
0oooool3o`3jVP03ooooool0nY[o0?ZJ09Gooooo00Go0000o`00ool00?oo0000ooooo`02o`00o`04
ooooool0003o0000ooooo`;o003o2?ooool01?l0nY[o003oo`00ool00002o`3jVP;o003o0_l0nYX2
ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01Oooool2o`00o`04ooooool0003o003oo`00o`?o0?ZJ00Co
0000o`00ool00?oooooo1?l0nYX00ol0003oooooo`3jVP02o`00o`04o`3jV_l0003o0000o`3jVP;o
003o00?o0?ZJooooooooool00_l0nYX8ooooo`?o0?ZJ2oooool3o`0001Gooooo00?o0000oooooooo
ool0R?ooool2o`0000;ooooo0_l00003ooooo`;o00002?ooool3o`0000_ooooo2?l0nYX<ooooo`Go
0?ZJ2oooool2o`00o`Kooooo0ol0000Gooooo`Co0?ZJ1oooool5o`3jVPGooooo0_l0nYX9ooooo`03
o`000?l0nY[o0?ZJ00?o0?ZJ00?oooooo`000?l000000_ooool2o`0000gooooo00?o0000oooooooo
ool0<?ooool003Wooooo00?o0000ooooool000003?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo01Sooooo0_l00002ooooo`Go0?ZJ0oooool3o`3jVP03ooooool0nY[o0?ZJ09Gooooo
00Go0000o`00ool00?oo0000ooooo`02o`00o`04ooooool0003o0000ooooo`;o003o2?ooool3o`00
o`03o`000?l0nY[o0?ZJ00;o003o0_l0nYX2ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01Oooool2o`00
o`04ooooool0003o003oo`00o`?o0?ZJ00Co0000o`00ool00?oooooo1?l0nYX00ol0003oooooo`3j
VP02o`00o`04o`3jV_l0003o0000o`3jVP;o003o0_l0nYX00ooooooo0?ZJo`3jVP09ooooo`;o0?ZJ
3Oooool00ol0003oooooooooo`0Cooooo`;o0000ROooool2o`0000;ooooo0_l00003ooooo`;o0000
2Oooool2o`0000kooooo1ol0nYX5ooooo`;o0?ZJ0oooool7o`3jVPWooooo0_l00?l6ooooo`?o0000
5oooool2o`3jVPWooooo1?l0nYX6ooooo`;o0?ZJ0oooool2o`3jVP?ooooo00?o0000o`3jV_l0nYX0
0ol0nYX8o`0000cooooo0_l0000booooo`00>_ooool2o`0000Sooooo00Go0000oooooooooooooooo
o`000004ooooo`03o`000?oooooooooo01Sooooo0_l00002ooooo`Ko0?ZJ00?oooooo`3jV_l0nYX0
0_l0nYX00ooooooo0?ZJo`3jVP2Eooooo`03o`000?l00?oo003o00Co003o00Coooooo`000?l0003o
00000_l00?l7ooooo`04o`3jV_l00?oo003oo`3jVP;o000000?o0?ZJo`00ool00?l00_l0nYX2oooo
o`?o0?ZJ00?oooooo`3jV_l0nYX01?ooool01Ol0003o003oo`00oooooooo000000;o003o0ol0nYX0
1?l0003o003oo`00ooooool4o`3jVP;o000000Go0?ZJo`00ool00?oo003oo`000002o`3jVP;o003o
0_l0nYX00ooooooo0?ZJo`3jVP0Hooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
S?ooool2o`0000?ooooo0_l00009ooooo`;o00004_ooool3o`3jVPGooooo1ol0nYX2ooooo`?o0?ZJ
2Oooool2o`00o`Kooooo0ol00003ooooo`;o00007Oooool2o`3jVPSooooo0_l0nYX2ooooo`?o0?ZJ
0_ooool2o`0000;o0?ZJ0_ooool9o`0000gooooo00?o0000ooooooooool0<?ooool003_ooooo00?o
0000ooooooooool01_ooool5o`0000Cooooo00?o0000ooooooooool07Oooool:o`3jVP03ooooool0
nY[o0?ZJ09Gooooo00?o0000o`00ool00?l01?l00?l01?oooooo0000o`000?l00002o`00o`Oooooo
00Co0?ZJo`00ool00?oo0?ZJ0_l000000ol0nY[o003oo`00o`02o`3jVP;ooooo0ol0nYX00ooooooo
0?ZJo`3jVP04ooooo`05o`000?l00?oo003oooooool000000_l00?l3o`3jVP04o`000?l00?oo003o
ooooo`Co0?ZJ0_l000001Ooooooo0?ZJo`00ool00?oo000000;o0?ZJ0_l00?l2o`3jVP03ooooool0
nY[o0?ZJ01Sooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2<ooooo`Oo00002Ooo
ool2o`0001?ooooo0ol0nYX4ooooo`Ko0?ZJ1?ooool2o`3jVPWooooo0_l00?l6ooooo`?o00000_oo
ool3o`0002Oooooo1ol0nYX2ooooo`;o00000_l0nYX2ooooo`Wo00003Oooool00ol0003ooooooooo
o`0`ooooo`00COooool00ol0003oooooooooo`0Nooooo`;o0?ZJ00?oooooo`3jV_l0nYX01ol0nYZE
ooooo`03o`000?l0nY[o003o00?o003o00?o0?ZJooooool000000_l00002o`00o`Oooooo00Co0?ZJ
o`00ool00?oo0?ZJ0_l000001?oooooo003oo`00ool0nYX2ooooo`03o`000?l0nY[o0?ZJ00;ooooo
0_l0nYX4ooooo`05o`000?l00?oo003oooooool000000_l00?l3o`3jVP03o`000?l00?oo003o00;o
oooo0ol0nYX2o`000004ooooool0nY[o003oo`00o`?o0?ZJ0_l00?l2o`3jVP03ooooool0nY[o0?ZJ
01Sooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2<ooooo`Oo00002Oooool2o`00
01Cooooo1?l0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`;o0?ZJ1?ooool2o`3jVPWooooo0_l00?l5
ooooo`Go000000Coooooo`000?l0003o00009oooool8o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1_l0
0003ooooo`;o00003Oooool00ol0003oooooooooo`0`ooooo`00COooool3o`00027ooooo1?l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVYGooooo00Go0000o`3jV_l0nY[o0000ooooo`02o`3jVP04ooooool0
003o0000o`0000;o003o1_ooool2o`3jVP;o003o00Co0?ZJo`000?l0003ooooo0_l00?l01?l0nY[o
ooooo`000?l00002o`3jVP;ooooo0_l0nYX4ooooo`05o`000?l00?oo003oooooool000000_l00?l3
o`3jVP03o`000?l00?oo003o00;ooooo0ol0nYX2o`000004ooooool0nY[o003oo`00o`;o0?ZJ00?o
0000o`00ool00?l01Ol0nYXGooooo`;o00005Oooool00ol0003oooooooooo`2=ooooo`Ko00002Ooo
ool2o`000004ooooool0003o0000o`00013ooooo1ol0nYX9ooooo`;o0?ZJ2Oooool3o`00o`Cooooo
0_l000000ooooooo0000o`000005o`0002Kooooo0ol0nYX3ooooo`Oo0?ZJ1_l0000Booooo`03o`00
0?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo027ooooo1?l0nYX2ooooo`?o0?ZJUOoo
ool01Ol0003o0?ZJo`3jV_l0003ooooo00;o0?ZJ00Coooooo`000?l0003o00000_l00?l6ooooo`;o
0?ZJ0_l00?l01?l0nY[o0000o`000?ooool2o`00o`04o`3jV_oooooo0000o`0000;o0?ZJ0_ooool2
o`3jVPCooooo00Go0000o`00ool00?ooooooo`000002o`00o`?o0?ZJ00?o0000o`00ool00?l00_oo
ool3o`3jVP;o000000Coooooo`3jV_l00?oo003o0_l0nYX01?l0003o003oo`00ooooool4o`3jVQSo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2=ooooo`Ko00002Oooool2o`000004
ooooool0003o0000o`0001?ooooo1?l0nYX9ooooo`;o0?ZJ2_ooool2o`00o`?ooooo0ol000000ooo
oooo0000o`000002o`000003ooooool0003o000002cooooo1?l0nYX00ol0003oooooo`000003o`00
0003ooooool0003o000001;ooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000oooooooo
ool08_ooool3o`3jVP?ooooo0_l0nYZFooooo`;o0?ZJ0_ooool2o`3jVP04ooooool0003o0000o`00
00;o003o0oooool5o`3jVP;o003o00Co0?ZJo`000?l0003ooooo0_l00?l01?l0nY[oooooo`000?l0
0006o`00o`Cooooo00Go0?ZJo`00ool00?ooooooo`000002o`00o`;o0?ZJ00Co0000ooooool00?oo
003o0oooool2o`3jVP;o000000Coooooo`3jV_l00?oo003o0_l0nYX01?l0003o003oo`00ooooool4
o`3jVQSooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2>ooooo`Go00002Oooool6
o`0000Gooooo0_l0000Iooooo`;o0?ZJ2_ooool2o`00o`?ooooo0_l00002ooooo`Co000000?ooooo
o`000?l000009oooool2o`0000?ooooo0ol0nYX2o`000003ooooool0003o000000;o00005Oooool0
0ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`0Xooooo`;o0?ZJU_ooool2o`3j
VP;ooooo0_l0nYX01?oooooo0000o`000?l00002o`00o`;ooooo1Ol0nYX01?l0003o003oo`00ool0
nYX2o`000005ooooool00?oo003oo`3jV_ooool00_l00006o`00o`05ooooool0003o0000ooooool0
nYX00_l00?l00ooooooo0000o`00o`02o`00o`03o`3jV_l0003ooooo00;o003o1Oooool2o`000004
ooooool0nY[o003oo`00o`;o0?ZJ00Co0000o`00ool00?oooooo1?l0nYXHooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Soooool3o`0000_ooooo1_l00004ooooo`;o00006Oooool3
o`3jVPWooooo0_l00?l3ooooo`;o00000_ooool4o`000004ooooool0003o0000o`0002Kooooo0_l0
0005ooooo`?o00006_ooool00ol0003oooooooooo`0`ooooo`00COooool3o`000<3ooooo0_l0nYX2
ooooo`;o0?ZJ00Coooooo`000?l0003o00000_l00?l2ooooo`Go0?ZJ00Co0000o`00ool00?oo0?ZJ
0_l000001Ooooooo003oo`00ool0nY[ooooo00;o00000_l00?l2ooooo`;o003o00Goooooo`000?l0
003oooooo`3jVP02o`00o`03ooooool0003o000000;o003o00?o0?ZJo`000?ooool00_l00?l5oooo
o`;o000000Coooooo`3jV_l00?oo003o0_l0nYX00ooooooo003oo`00o`02ooooo`?o0?ZJ5oooool2
o`0001Gooooo0_l0002Aooooo`;o00002oooool6o`0000Cooooo0ol0000<ooooo`?o00002_ooool2
o`3jVPWooooo0_l00?l3ooooo`;o00000_ooool3o`00o`03o`000?oooooooooo00;o00001?ooool2
o`0001oooooo0ol00005ooooo`;o00006_ooool2o`0003;ooooo001=ooooo`03o`000?oooooooooo
0<3ooooo0_l0nYX2ooooo`;o0?ZJ00Coooooo`000?l0003o00000_l00?l00ooooooo0?ZJo`3jVP04
o`3jVP04o`000?l00?oo003oo`3jVP;o000000Goooooo`00ool00?oo0?ZJooooo`02o`0000;o003o
0_ooool2o`00o`05ooooool0003o0000ooooool0nYX00_l00?l00ol0nY[o0000o`000002o`00o`03
o`3jV_l0003ooooo00;o003o1Oooool2o`000004ooooool0nY[o003oo`00o`;o0?ZJ00?oooooo`00
ool00?l00_ooool3o`3jVQSooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2@oooo
o`;o00002oooool6o`0000Cooooo0ol0000<ooooo`Co00002Oooool2o`3jVPWooooo0_l00?l2oooo
o`03o`000?l00?oo003o00Go003o00?o0000ooooooooool00_l00004ooooo`;o00007oooool3o`00
00Gooooo0_l0000Kooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0<3o
oooo0_l0nYX2ooooo`;o0?ZJ0_ooool2o`0000;o003o00?oooooo`3jV_l0nYX01?l0nYX01?l0003o
003oo`00ool0nYX3o`0000;o003o0ol00003o`00o`;ooooo0_l00?l01Ooooooo0000o`000?oooooo
0?ZJ00;o003o00?o0?ZJo`000?l000000_l00?l00ol0nY[o0000ooooo`02o`00o`Gooooo0_l00000
1?oooooo0?ZJo`00ool00?l2o`3jVP03ooooool00?oo003o00;ooooo0ol0nYXHooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0T?ooool2o`0000_ooooo1_l00004ooooo`?o00002ooo
ool5o`0000Oooooo0_l00002o`3jVPWooooo0_l00?l3o`0000Oo003o00?o0000ooooooooool00_l0
0003ooooo`Co00007_ooool4o`0000Cooooo0_l0000Booooo`?o003o1_ooool00ol0003ooooooooo
o`0`ooooo`00COooool00ol0003oooooooooo`30ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_ooool2
o`0000;o003o00?oooooo`3jV_l0nYX00ol0nYX2o`0000;o003o00Co0?ZJooooool0003o00000_l0
0?l3o`0000;o003o0_l0nYX00ooooooo003oo`00o`03o`000005ooooool0nY[o003oo`00ool0nYX0
0_ooool2o`00o`03o`3jV_l0003ooooo00;o003o1Oooool2o`000004ooooool0nY[o003oo`00o`;o
0?ZJ00?oooooo`00ool00?l00_ooool3o`3jVQSooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`2@ooooo`;o00003?ooool5o`0000Cooooo0ol0000;ooooo`Ko00001?ooool4o`0000;o
0?ZJ1_ooool3o`0000;o003o0ol00002o`00o`?ooooo0_l00?l00ol0003oooooooooo`02o`0000?o
oooo1?l0000Mooooo`Ko00000_ooool3o`0001;ooooo0ol00?l6ooooo`03o`000?oooooooooo033o
oooo001=ooooo`03o`000?oooooooooo0<7ooooo0_l0nYX00ooooooo0?ZJo`3jVP04ooooo`;o003o
00?oooooo`3jV_l0nYX00ol0nYX2o`0000;o003o0_ooool2o`0000;o003o0ol00002o`00o`;o0?ZJ
00Coooooo`00ool00?oo0?ZJ0ol000000ol0nY[o003oo`00o`02o`3jVP06ooooool00?oo003oo`3j
V_l0003ooooo0_l00?l5ooooo`;o000000Goooooo`3jV_l00?oo003oo`3jVP02ooooo`;o003o0_oo
ool3o`3jVQSooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2Nooooo`Ko00000_oo
ool4o`0000_ooooo0_l000001?oooooo0000o`000?l00004ooooo`Co00000ol0nYX5ooooo`?o0000
0_l00?l2o`0000?o003o0oooool2o`00o`?ooooo0_l00003ooooo`Co00007Oooool2o`000003oooo
ool0003o000000Ko00004_ooool2o`00o`Oooooo00?o0000ooooooooool0<?ooool004gooooo0ol0
0031ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?ooool2o`00o`03ooooool0nY[o0?ZJ00?o0?ZJ0_l0
0002o`00o`;ooooo0_l00007o`00o`;o0?ZJ00Coooooo`00ool00?oo0?ZJ0ol000000ol0nY[o003o
o`00o`02o`3jVP03ooooool00?oo003o00;o000000?oooooo`00ool00?l01Oooool2o`000005oooo
ool0nY[o003oo`00ool0nYX00_ooool2o`00o`?ooooo0_l0nYXGooooo`;o00005Oooool00ol0003o
ooooooooo`2Rooooo`;o00000_ooool5o`0000[ooooo0_l000000ooooooo0000o`000004o`000003
ooooool0003o000000;o00001_l0nYX2ooooo`?o00001_l00?l4ooooo`?o003o0_ooool2o`0000?o
oooo1?l0000Mooooo`;o000000?oooooo`000?l000001_l0000Aooooo`?o003o1oooool00ol0003o
ooooooooo`0`ooooo`00COooool00ol0003oooooooooo`31ooooo`Go0?ZJ1?ooool2o`00o`?o0?ZJ
00Goooooo`3jV_l0nY[o0000ooooo`02o`00o`;ooooo0_l00007o`00o`;o0?ZJ00Coooooo`00ool0
0?oo0?ZJ0ol000000ol0nY[o003oo`00o`02o`3jVP03ooooool00?oo003o00;o000000?oooooo`00
ool00?l01Oooool4o`0000;o003o00?o0?ZJooooooooool00_l00?lMooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0X_ooool2o`0000;ooooo0_l000000ooooooo0000o`00000:oooo
o`;o00000oooool4o`000003ooooool0003o000000?o000000?oooooo`3jV_l0nYX00_l0nYX2oooo
o`?o00001_l00?l5ooooo`;o003o0_ooool3o`0000;ooooo0_l00006o`00oaSooooo0ol00002oooo
o`Go00004oooool2o`00o`Sooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000oooooooo
ool0`_ooool4o`3jVPCooooo0_l00?l2o`3jVP;ooooo0_l0nYX01?l0003oooooo`00ool00?l2oooo
o`;o00000_l0nYX4o`0000?o0?ZJ00Coooooo`00ool00?oo0?ZJ0ol000000ol0nY[o003oo`00o`03
o`3jVP;o003o0_l000000ooooooo003oo`00o`06ooooo`?o00000_l00?l00ol0nY[oooooooooo`02
o`00oagooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2Rooooo`;o00000_ooool2
o`000003ooooool0003o000000Kooooo0_l00002ooooo`;o00000oooool4o`000003ooooool0003o
000000?o00000oooool2o`3jVP03ooooool0003o000000;o00000_l00?l9ooooo`;o003o0oooool2
o`000004ooooool0003o0000o`0000Ko003o6?ooool2o`0000Cooooo0ol0000Aooooo`Go003o2?oo
ool00ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`32ooooo`Co0?ZJ1?ooool2
o`00o`;o0?ZJ0_ooool2o`3jVP04o`000?oooooo003oo`00o`;ooooo0_l00002o`3jVPCo00000ol0
nYX01?oooooo003oo`00ool0nYX3o`000004o`3jV_l00?oo003oooooo`;o0?ZJ1ol00?l6ooooo`?o
00000_l00?l00ol0nY[oooooooooo`02o`00oagooooo00?o0000ooooooooool04oooool2o`000:?o
oooo0_l00002ooooo`;o000000?oooooo`000?l000001_ooool2o`0000;ooooo0_l00003ooooo`_o
00000_ooool3o`3jVPKo00002Oooool2o`00o`06ooooool00?oo003oo`00ool0003ooooo0_l00000
0ooooooo003oo`00o`02ooooo`?o003o00?oooooo`00ool00?l00_l00?lBooooo`;o00001?ooool3
o`0000oooooo1ol00?l7ooooo`;o0000<_ooool004gooooo00?o0000ooooooooool0`oooool3o`3j
VPCooooo0_l00?l2o`3jVP;ooooo0_l0nYX01?l0003oooooo`00ool00?l2ooooo`;o00000_l0nYX4
o`0000?o0?ZJ00Coooooo`00ool00?oo0?ZJ0_l00002o`3jVP;o003o00?oooooo`3jV_l0nYX01ol0
0?l6ooooo`?o00000_l00?l00ol0nY[oooooooooo`02o`00oagooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`2Rooooo`?o000000Coooooo`000?l0003ooooo0_l00006ooooo`;o0000
0_ooool2o`0000Cooooo1ol000000ooooooo0000o`000002ooooo`04o`000?l0nY[o0?ZJo`3jVPGo
00002Oooool6o`00o`05o`000?oooooo0000o`000?ooool00_l00?l3ooooo`Oo003o4_ooool2o`00
00Cooooo0_l0000@ooooo`?o003o3?ooool00ol0003oooooooooo`0`ooooo`00COooool3o`000<?o
oooo0ol0nYX4ooooo`;o003o0_l0nYX2ooooo`;o0?ZJ00Co0000ooooool00?oo003o0_ooool2o`00
00?o0?ZJ0_l000001Ooooooo0?ZJo`3jV_l0nY[ooooo00;o003o00Co0?ZJo`000?l0003o0?ZJ0ol0
0?l00ooooooo0?ZJo`3jVP02o`3jVP;o000000?oooooo`3jV_l0nYX01_ooool3o`0000;o003o00?o
0?ZJooooooooool00_l00?lLooooo`;o00005Oooool00ol0003oooooooooo`2Sooooo`;o000000Co
ooooo`000?l0003ooooo0_l00006ooooo`?o000000?oooooo`000?l000001?ooool7o`000003oooo
ool0003o000000;ooooo00?o0000o`3jV_l0nYX01Ol0nYX00ol0003oooooooooo`07ooooo`Ko003o
1?l00003o`00o`?ooooo1?l00?l00ooooooo003oo`00o`0Aooooo`?o00001?ooool2o`00013ooooo
0_l00?l=ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0<?ooooo0ol0
nYX4ooooo`;o003o00Co0?ZJoooooooooooooooo1_l00?l2ooooo`?o00000_l0nYX2o`000005oooo
ool0nY[o0?ZJo`3jV_ooool00_l00?l01?l0nY[o0000o`3jV_l0nYX2o`00o`03o`3jV_oooooo0?ZJ
00?o0?ZJ0_l000000ooooooo0?ZJo`3jVP06ooooo`?o00000_l00?l3ooooo`;o003o7Oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo0:?ooooo0_l000001?oooooo0000o`000?ooool2
o`0000Kooooo1_l00004ooooo`Go00000oooool2o`0000;ooooo0ol00005o`3jVP03o`000?oooooo
oooo00_ooooo2?l00?l00ol0003oooooooooo`06ooooo`;o003o4Oooool2o`0000Gooooo0_l0000@
ooooo`;o003o3Oooool00ol0003oooooooooo`0`ooooo`00=?ooool3o`0000?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`33oooo
o`?o0?ZJ1?ooool2o`00o`04o`3jV_ooooooooooooooo`Ko003o0_ooool3o`0000;o0?ZJ00?o0000
ooooooooool00ol0nYX01Ooooooo003oo`00ool0nY[o000000;o0?ZJ0_l00?l00ol0nY[oooooo`3j
VP03o`3jVP;o000000?oooooo`3jV_l0nYX01_ooool3o`0000;o003o0oooool2o`00oagooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`2Sooooo`;o000000Coooooo`000?l0003ooooo
0_l00006ooooo`Ko00001oooool2o`0000?ooooo0ol000000ooooooo0000o`000002o`0000;ooooo
0_l0nYX00ol0003oooooooooo`0<ooooo`Oo003o00?o0000ooooooooool01_ooool2o`00oa7ooooo
0_l00003o`00o`;ooooo0_l0000@ooooo`;o003o3Oooool00ol0003oooooooooo`0`ooooo`00=Ooo
ool00ol0003oooooooooo`08ooooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo0<Cooooo0_l0nYX4ooooo`;o003o00Co0?ZJoooooooooooo
oooo0ol00?l00ooooooo0?ZJo`3jVP03ooooo`;o00000_l0nYX3ooooo`Co0?ZJ0_l00?l01?l0nY[o
0000o`3jV_l0nYX2o`00o`03o`3jV_oooooooooo00?o0?ZJ0oooool2o`3jVPKooooo0ol00002o`00
o`?ooooo0_l00?lMooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Xoooool5o`00
0004ooooool0003o0000o`0000Gooooo1_l0000=ooooo`;o000000Coooooo`000?l0003o00000ooo
ool2o`3jVP03o`000?oooooooooo00cooooo0_l00?l2o`0000;ooooo0_l00008ooooo`;o003o3ooo
ool7o`00oa;ooooo1?l00?l=ooooo`03o`000?oooooooooo033ooooo000booooo`Go00002_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0b_ooool2
o`00o`04o`3jV_l0003oooooo`0000;o003o0_ooool2o`3jVP?ooooo0_l00002o`3jVP;ooooo1Ol0
nYX2o`00o`04o`3jV_l0003o0?ZJo`3jVP;o003o00Co0?ZJoooooooooooooooo0ol0nYX2ooooo`;o
0?ZJ1_ooool3o`0000Oo003o7Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0:?o
oooo1?l00003ooooo`;o00001Oooool6o`0000gooooo0_l000001?oooooo0000o`000?l00003oooo
o`;o0?ZJ00?o0000ooooooooool03Oooool3o`0000;ooooo0_l000000ooooooo0000o`000005oooo
o`?o003o1Oooool5o`00o`Cooooo1ol00?l?ooooo`Oo003o3Oooool00ol0003oooooooooo`0`oooo
o`00<_ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00_ooool3o`000<[ooooo0_l00?l01?l0nY[o0000o`000?l00002o`00o`;ooooo0_l0nYX3
ooooo`;o00000_l0nYX2ooooo`;o0?ZJ00?o0000o`3jV_l0nYX00ol00?l00ol0003o0?ZJo`3jVP02
o`00o`03o`3jV_oooooooooo00;ooooo0_l0nYX2ooooo`;o0?ZJ1_ooool3o`0000Oo003o6oooool3
o`0001Gooooo00?o0000ooooooooool0Xoooool4o`0000?ooooo0ol00004ooooo`Go00003_ooool2
o`000004ooooool0003o0000o`0000?ooooo0_l0nYX00ol0003oooooooooo`0>ooooo`;o00000_oo
ool2o`000003ooooool0003o000000Kooooo0_l00?l3ooooo`Oo003o1?ooool2o`00o`;o000000?o
ooooo`00ool00?l03oooool4o`00oa3ooooo00?o0000ooooooooool0<?ooool003?ooooo00?o0000
ooooool000003?ooool00ol0003oooooo`000003o`0000Gooooo00?o0000ooooooooool0b_ooool2
o`00o`03o`3jV_l0003o000000?o003o0_ooool2o`3jVP?ooooo0_l00002o`3jVP;ooooo0_l0nYX0
1?l0003o0?ZJo`3jV_l0nYX2o`00o`?o0?ZJ0_l00?l00ol0nY[oooooooooo`02ooooo`;o0?ZJ0_oo
ool2o`3jVPKooooo0ol00002o`3jVP?ooooo0_l0nYXMooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Y?ooool3o`0000?ooooo0ol00003ooooo`?o000000?oooooo`000?l000003_oo
ool5o`0000Cooooo0_l0nYX00ol0003oooooooooo`0>ooooo`;o00000_ooool5o`0000Kooooo0_l0
0?l3ooooo`Co003o00?oooooo`00ool00?l01?ooool2o`00o`;o000000?oooooo`00ool00?l03ooo
ool2o`00oa;ooooo00?o0000ooooooooool0<?ooool003Cooooo0_l00008ooooo`07o`000?oooooo
ooooooooool0003oooooo`000008ooooo`03o`000?oooooooooo0<[ooooo0_l00?l3o`0000;o003o
00?o0?ZJooooooooool00_l0nYX3ooooo`;o00000ol0nYX00ooooooo0?ZJo`3jVP02o`0000;o0?ZJ
0_l00?l2o`3jVP04o`000?l00?oo003oo`3jVPCooooo0_l0nYX2ooooo`;o0?ZJ1_ooool3o`0000;o
0?ZJ0oooool2o`3jVQgooooo00?o0000ooooooooool04oooool2o`000:Kooooo0_l00003ooooo`Go
000000?oooooo`000?l000000_ooool2o`0000oooooo1?l00004ooooo`;o0?ZJ5_ooool4o`0000;o
oooo0_l00002ooooo`Oo003o0oooool2o`00o`?ooooo0ol00?l00ol0003oooooooooo`02o`00o`oo
oooo0_l00?lAooooo`;o0000<_ooool003Gooooo00?o0000ooooooooool01_ooool5o`000003oooo
ool0003o000000?o00001?ooool00ol0003oooooooooo`3:ooooo`;o003o0ol00002o`00o`03o`3j
V_oooooooooo00;o0?ZJ0oooool2o`000004ooooool0nY[o0?ZJooooo`;o0?ZJ0_l00002o`3jVP;o
003o0_l0nYX01?l0003o003oo`00ool0nYX4ooooo`;o0?ZJ0_ooool2o`3jVPOooooo0_l00002o`3j
VP?ooooo0_l0nYXMooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Z_ooool5o`00
0003ooooool0003o000000;ooooo0_l0000?ooooo`Co00001?ooool2o`3jVQKooooo1?l00002oooo
o`?o000000?oooooo`00ool00?l01?l00?l4ooooo`?o003o0_ooool2o`00o`;o00000_ooool2o`00
o`kooooo0ol00?lBooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0<[o
oooo0_l00?l3o`0000;o003o00?o0?ZJooooooooool00_l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX00_l00002o`3jVP;o003o0_l0nYX01?oooooo003oo`00ool0nYX4ooooo`;o0?ZJ0_ooool2o`3j
VPOooooo0_l00002o`3jVP?ooooo0_l0nYXMooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0Z_ooool8o`0001?ooooo1?l00004ooooo`;o0?ZJ5_ooool5o`000005ooooool0003o0000
o`000?ooool00ol00?l8ooooo`Ko003o0_l00002ooooo`;o003o3_ooool2o`00oa?ooooo00?o0000
ooooooooool0<?ooool004gooooo0ol0003:ooooo`Oo003o00?o0?ZJooooooooool00_l0nYX6oooo
o`Go0?ZJ0_l000001?oooooo0?ZJo`00ool00?l2o`3jVP04ooooool00?oo003oo`3jVPCooooo0_l0
nYX2ooooo`;o0?ZJ1oooool2o`0000?o0?ZJ0_ooool2o`3jVQcooooo0_l0000Eooooo`03o`000?oo
oooooooo0:[ooooo0_l00002ooooo`?o00005Oooool2o`0000Gooooo0ol0nYXEooooo`Wo00003?oo
ool6o`00o`;o00000_ooool2o`00o`gooooo0ol00?lCooooo`03o`000?oooooooooo033ooooo001=
ooooo`03o`000?oooooooooo0<[ooooo1ol00?l00ol0nY[oooooooooo`02o`3jVPOooooo1?l0nYX3
o`000004o`3jV_l00?oo003oo`3jVP;ooooo0_l00?l00ol0nY[oooooooooo`02ooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX01oooool2o`000003ooooool0nY[o0?ZJ00;ooooo0_l0nYXMooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0[_ooool3o`0001gooooo0_l0nYXEooooo`Wo000000?o
ooooo`000?l000002Oooool2o`00o`03ooooool0003o000000?o00000_ooool2o`00o`Wooooo1ol0
0?lCooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0<[ooooo0_l0nYX4
o`0000;o0?ZJ0_ooool2o`3jVPOooooo1?l0nYX01?oooooo0000o`000?l0nYX2o`00o`03o`3jV_oo
oooooooo00;o003o1_ooool2o`3jVP03ooooool0nY[o0?ZJ00[ooooo0_l0nYX2ooooo`;o0?ZJ7Ooo
ool01?l0003oooooo`000?l00004ooooo`03o`000?oooooooooo00?ooooo0ol00005ooooo`03o`00
0?oooooooooo0:kooooo0ol0000Mooooo`;o0?ZJ5Oooool9o`000003ooooool0003o000000cooooo
1?l00003ooooo`Oo003o1?ooool5o`00oaGooooo00?o0000ooooooooool0<?ooool004gooooo00?o
0000ooooooooool0b_ooool2o`3jVP04o`000?ooooooooooooooo`?o0?ZJ00?oooooo`3jV_l0nYX0
1oooool4o`3jVP04ooooool0003o0000o`3jVP;o003o00?o0?ZJooooooooool00_l00?l6ooooo`;o
0?ZJ00?oooooo`3jV_l0nYX02_ooool2o`3jVP;ooooo0_l0nYXMooooo`;o00000_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0[_ooool2o`0001ko
oooo0_l0nYXEooooo`Ko000000?oooooo`000?l000001_l00009ooooo`Co00000oooool7o`00o`Co
oooo0_l00?lHooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0<[ooooo
0_l0nYX4ooooo`?o0?ZJ00?oooooo`3jV_l0nYX02?ooool3o`3jVP04ooooool0003o0000o`3jVP;o
003o00?o0?ZJooooooooool00_l00?l6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02_ooool2o`3jVP;o
oooo0_l0nYXMooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`Go00001Oooool00ol0003o
ooooooooo`2^ooooo`;o00007_ooool2o`3jVQKooooo0_l00005ooooo`Oo00002Oooool4o`0000?o
oooo0ol00?l2ooooo`;o003o1?ooool2o`00oaSooooo00?o0000ooooooooool0<?ooool004gooooo
0ol0003:ooooo`?o0?ZJ0oooool3o`3jVP03ooooool0nY[o0?ZJ00Sooooo0ol0nYX01?oooooo0000
o`000?l0nYX2o`00o`03o`3jV_oooooooooo00;o003o1_ooool2o`3jVP03ooooool0nY[o0?ZJ00[o
oooo0_l0nYX2ooooo`;o0?ZJ7?ooool3o`0000;ooooo00?o0000ooooooooool01Oooool01?l0003o
ooooooooool00006ooooo`?o0000c_ooool2o`3jVQKooooo0_l00005ooooo`So000000Coooooo`00
0?l0003o00001?ooool4o`0000Sooooo2?l00?lFooooo`?o0000<_ooool004gooooo00?o0000oooo
ooooool0boooool2o`3jVP?ooooo1_l0nYX8ooooo`?o0?ZJ00Coooooo`000?l0003o0?ZJ0_l00?l0
0ol0nY[oooooooooo`02o`00o`Kooooo0_l0nYX00ooooooo0?ZJo`3jVP0:ooooo`;o0?ZJ0_ooool2
o`3jVQgooooo0_l00002ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooool000001_ooool0
0ol0003oooooooooo`3>ooooo`;o0?ZJ0oooool5o`3jVPkooooo0_l00005ooooo`ko00000_ooool3
o`0000[ooooo1_l00?lIooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo
0<_ooooo0_l0nYX2ooooo`Oo0?ZJ2?ooool3o`3jVP04ooooool0003o0000ooooo`;o003o0oooool2
o`00o`Kooooo1Ol0nYX:ooooo`?o0?ZJ00?oooooo`3jV_l0nYX07Oooool2o`0000;ooooo00?o0000
ooooooooool01oooool2o`0000Kooooo00?o0000ooooooooool0c_ooool2o`3jVP?ooooo1ol0nYXC
ooooo`oo000000?oooooo`000?l000002oooool3o`00oacooooo00?o0000ooooooooool0<?ooool0
04gooooo00?o0000ooooooooool0boooool2o`3jVP;ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3j
VPSooooo0ol0nYX01?oooooo0000o`000?l00002o`00o`?ooooo0_l00?l7ooooo`Co0?ZJ2oooool2
o`3jVP03ooooool0nY[o0?ZJ01gooooo00Co0000ooooool0003o00002oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo0<kooooo1ol0nYX2ooooo`?o0?ZJ5_ooool<o`000003ooooool0
003o000002[ooooo00?o0000ooooooooool0<?ooool004gooooo0ol0003;ooooo`;o0?ZJ0_ooool2
o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2Oooool2o`3jVP04ooooool0003o0000o`0000;o003o0ooo
ool2o`00o`Oooooo1?l0nYX;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX07?ooool2o`0001Gooooo00?o
0000ooooooooool0c_ooool6o`3jVPCooooo0_l0nYXFooooo`;o00000_ooool2o`0000;ooooo1?l0
00000ooooooo0000o`00000Zooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooo
oooo0<_ooooo0_l0nYX2ooooo`;o0?ZJ0_ooool3o`3jVPgooooo0_l00007o`00o`Sooooo0ol0nYX;
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX07Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo0=7ooooo0ol0nYX4ooooo`;o0?ZJ5_ooool2o`0000Kooooo1ol0000Zooooo`03o`000?oooooo
oooo033ooooo001=ooooo`03o`000?oooooooooo0<_ooooo0_l0nYX2ooooo`;o0?ZJ0_ooool3o`3j
VPgooooo0_l00007o`00o`Sooooo0ol0nYX;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX07Oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo0=Sooooo0ol0nYXOooooo`Co0000:oooool00ol0
003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`3;ooooo`?o0?ZJ00?oooooo`3jV_l0
nYX00oooool2o`3jVPoooooo0_l0nYX3ooooo`;o0?ZJ2Oooool2o`3jVP_ooooo0_l0nYX00ooooooo
0?ZJo`3jVP0Mooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0fOooool2o`3jVQoo
oooo0ol0000/ooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo0<cooooo
0_l0nYX00ooooooo0?ZJo`3jVP03ooooo`;o0?ZJ3oooool2o`3jVP?ooooo0_l0nYXFooooo`;o0?ZJ
00?oooooo`3jV_l0nYX07Oooool00ol0003oooooooooo`0Cooooo`;o0000f_ooool2o`3jVPWooooo
0_l0nYY2ooooo`;o0000<_ooool004gooooo0ol0003<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ooo
ool2o`3jVPoooooo0_l0nYX3ooooo`;o0?ZJ5_ooool5o`3jVQcooooo0_l0000Eooooo`03o`000?oo
oooooooo0=Wooooo1_l0nYX5ooooo`Ko0?ZJ?oooool00ol0003oooooooooo`0`ooooo`00COooool0
0ol0003oooooooooo`3<ooooo`Go0?ZJ5?ooool3o`3jVP;ooooo0_l0nYXGooooo`Co0?ZJ7Oooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0=Wooooo1_l0nYX5ooooo`Ko0?ZJ=_ooool3
o`3jVPKooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool0cOooool4o`3j
VQGooooo0_l0nYX2ooooo`;o0?ZJ5oooool4o`3jVQgooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`3Mooooo`;o0?ZJ1?ooool3o`3jVP;ooooo2?l0nYX`ooooo`?o0?ZJ1_ooool00ol0
003oooooooooo`0`ooooo`00>_ooool3o`0000?ooooo00?o0000ooooooooool00_ooool3o`0000Go
oooo00?o0000ooooooooool0cOooool4o`3jVQGooooo0_l0nYX2ooooo`;o0?ZJ6?ooool3o`3jVQgo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3Mooooo`So0?ZJ1?ooool7o`3jVS3o
oooo0_l0nYX7ooooo`03o`000?oooooooooo033ooooo000kooooo`03o`000?oooooooooo00Kooooo
00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0<gooooo1?l0nYXEooooo`;o
0?ZJ0_ooool2o`3jVQSooooo0ol0nYXMooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0g_ooool7o`3jVPWooooo0_l0nYX_ooooo`?o0?ZJ1oooool00ol0003oooooooooo`0`ooooo`00
>?ooool5o`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`?o0000cOooool4o`3jVQGo
oooo0_l0nYX2ooooo`;o0?ZJ6?ooool3o`3jVQ_ooooo0ol0000Eooooo`03o`000?oooooooooo0>ko
oooo0_l0nYX_ooooo`;o0?ZJ2?ooool00ol0003oooooooooo`0`ooooo`00>?ooool01?l0003ooooo
ooooool00009ooooo`?o00001Oooool00ol0003oooooooooo`3=ooooo`Co0?ZJ5Oooool2o`3jVP;o
oooo0_l0nYXIooooo`;o0?ZJ7Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0>ko
oooo0_l0nYXZooooo`Oo0?ZJ2?ooool00ol0003oooooooooo`0`ooooo`00>Oooool00ol0003ooooo
o`000008ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`3>ooooo`?o
0?ZJ5Oooool2o`3jVP;ooooo0_l0nYXhooooo`03o`000?oooooooooo01?ooooo0_l0003_ooooo`?o
0?ZJ:Oooool7o`3jVPOooooo0_l0000booooo`00>_ooool2o`0000Sooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo0<kooooo0ol0nYXEooooo`?o0?ZJ00?oooooo`3jV_l0
nYX0>?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0>oooooo0_l0nYXYooooo`;o
0?ZJ3Oooool00ol0003oooooooooo`0`ooooo`00>oooool00ol0003oooooooooo`07ooooo`?o0000
1Oooool00ol0003oooooooooo`3?ooooo`;o0?ZJ5_ooool2o`3jVP03ooooool0nY[o0?ZJ03Sooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`3_ooooo`;o0?ZJ0oooool7o`3jVPCooooo
1_l0nYXEooooo`;o0?ZJ3Oooool00ol0003oooooooooo`0`ooooo`00COooool3o`000>Oooooo0_l0
nYX00ooooooo0?ZJo`3jVP0gooooo`;o00005Oooool00ol0003oooooooooo`3_ooooo`;o0?ZJ0ooo
ool7o`3jVPCooooo1ol0nYXDooooo`;o0?ZJ3Oooool00ol0003oooooooooo`0`ooooo`00COooool0
0ol0003oooooooooo`3Wooooo`Go0?ZJ>?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo0>oooooo1ol0nYX3ooooo`;o0?ZJ1?ooool2o`3jVP?ooooo0_l0nYX?ooooo`Oo0?ZJ3Oooool0
0ol0003oooooooooo`0`ooooo`00COooool00ol0003oooooooooo`3Xooooo`Co0?ZJ>?ooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo0>oooooo1_l0nYX4ooooo`?o0?ZJ0_ooool3o`3j
VP?ooooo0_l0nYX?ooooo`Oo0?ZJ3Oooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003o
ooooooooo`3Xooooo`Co0?ZJ>?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?[o
oooo0_l0nYX2ooooo`;o0?ZJ1?ooool2o`3jVPoooooo0_l0nYXBooooo`03o`000?oooooooooo033o
oooo001=ooooo`03o`000?oooooooooo0>Sooooo1?l0nYXhooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0n_ooool6o`3jVPCooooo0_l0nYX?ooooo`;o0?ZJ4_ooool00ol0003ooooo
ooooo`0`ooooo`00COooool3o`000>Sooooo1?l0nYXgooooo`;o00005Oooool2o`000?_ooooo1_l0
nYX4ooooo`;o0?ZJ3_ooool3o`3jVQ7ooooo0_l0000booooo`00COooool00ol0003oooooooooo`3X
ooooo`Co0?ZJ>?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?oooooo1Oooool2
o`3jVPkooooo0_l0nYXCooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo
0>Sooooo1?l0nYXhooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0ooooool5oooo
o`Oo0?ZJ1?ooool7o`3jVQ?ooooo00?o0000ooooooooool0<?ooool004gooooo00?o0000oooooooo
ool0jOooool3o`3jVSSooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3oooooo`Go
oooo1ol0nYX4ooooo`Oo0?ZJ4oooool00ol0003oooooooooo`0`ooooo`00COooool00ol0003ooooo
ooooo`3Yooooo`?o0?ZJ>?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?oooooo
2_ooool3o`3jVP?ooooo0_l0nYXHooooo`03o`000?oooooooooo033ooooo001=ooooo`?o0000j_oo
ool2o`3jVSOooooo0_l0000Eooooo`03o`000?oooooooooo0?oooooo2oooool7o`3jVQSooooo00?o
0000ooooooooool0<?ooool004gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3o
ooooo`_ooooo1ol0nYXHooooo`03o`000?oooooooooo033ooooo001=ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0000Eooooo`03o`000?oooooo
oooo0?oooooo:_ooool00ol0003oooooooooo`0`ooooo`00COooooooo`0002Wo00005Oooool2o`00
00Gooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0?ooooo`;o0000<_ooool00?oo
ooooRoooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooo
oooo0000<_ooool00?ooooooRoooooooo`0002ko0000<_ooool00?ooooooooooooo[ooooo`00oooo
ooooooooon_ooooo003ooooooooooooojoooool00?ooooooooooooo[ooooo`00ooooooooooooon_o
oooo003ooooooooooooojoooool00?ooooooooooooo[ooooo`00ooooooooooooon_ooooo003ooooo
oooooooojoooool00?ooooooooooooo[ooooo`00ooooooooooooon_ooooo003ooooooooooooojooo
ool00?ooooooooooooo[ooooo`00ooooooooooooon_ooooo003oooooofGooooo00?o0000oooooooo
ool0oooooon3ooooo`00oooooomVooooo`03o`000?oooooooooo0?ooooooP_ooool00?ooooooDOoo
ool3o`0000?ooooo1Ol000001?oooooo0000o`000?l00006ooooo`03o`000?oooooooooo00Kooooo
0ol000001?oooooo0000o`000?ooool4o`0000;ooooo0ol00004ooooo`;o00001?ooool2o`0000Co
oooo0_l00004ooooo`;o0000oooooomDooooo`00oooooomBooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`04o`000?ooooooooooo`0000Wo
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0003ooooooe?ooooo
003ooooooe;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00oooooo00Co0000oooooooooooo00000_ooool4o`0000?ooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0003ooooooe?ooooo003ooooooe;ooooo0ol00004
ooooo`03o`000?oooooooooo00;ooooo0ol0000?ooooo`04o`000?ooooooooooo`0000Wooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0003ooooooe?ooooo003ooooo
oe;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00kooooo1?l0000:ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
0000oooooomCooooo`00oooooomBooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool0000Jooooo`;o00001?ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool0003ooooooe?ooooo003ooooooe7ooooo1Ol000000ooooooo0000o`000003o`000003oooo
ool0003o000000?o00006oooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000Cooooo
0_l00004ooooo`;o0000oooooomDooooo`00ooooooooooooon_ooooo003ooooooooooooojoooool0
0001\
\>"],
  ImageRangeCache->{{{0, 744.812}, {229.438, 0}} -> {-0.156416, -0.0154542, \
0.00310526, 0.00310526}, {{50.3125, 372.375}, {224.438, 25.375}} -> \
{-110.705, 4.4203, 1.30244, 0.00206275}, {{372.375, 694.438}, {224.438, \
25.375}} -> {-512.32, -0.0206211, 1.27673, 0.00248098}}]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{41, 1440}, {0, 878}},
WindowToolbars->{},
WindowSize->{961, 825},
WindowMargins->{{29, Automatic}, {Automatic, 7}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowSelection->True,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Info3417436483-8985227"->{
    Cell[9826, 258, 67, 1, 70, "Print",
      CellTags->"Info3417436483-8985227"],
    Cell[9896, 261, 550, 14, 70, "Print",
      CellTags->"Info3417436483-8985227"]},
  "Info3417436483-5913918"->{
    Cell[17004, 566, 69, 1, 70, "Print",
      CellTags->"Info3417436483-5913918"],
    Cell[17076, 569, 525, 14, 70, "Print",
      CellTags->"Info3417436483-5913918"]},
  "Info3416822704-7256049"->{
    Cell[837880, 28814, 64, 1, 22, "Print",
      CellTags->"Info3416822704-7256049"],
    Cell[837947, 28817, 436, 13, 22, "Print",
      CellTags->"Info3416822704-7256049"]},
  "Info3416806401-7520506"->{
    Cell[1411318, 47746, 117, 3, 22, "Print",
      CellTags->"Info3416806401-7520506"],
    Cell[1411438, 47751, 4265, 76, 311, "Print",
      CellTags->"Info3416806401-7520506"]},
  "Info3416811037-4307960"->{
    Cell[1416650, 47868, 109, 3, 24, "Print",
      CellTags->"Info3416811037-4307960"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Info3417436483-8985227", 1771973, 60533},
  {"Info3417436483-5913918", 1772172, 60538},
  {"Info3416822704-7256049", 1772373, 60543},
  {"Info3416806401-7520506", 1772580, 60548},
  {"Info3416811037-4307960", 1772792, 60553}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 3221, 60, 748, "Input"],

Cell[CellGroupData[{
Cell[5000, 115, 264, 10, 159, "Section"],

Cell[CellGroupData[{
Cell[5289, 129, 69, 1, 36, "Subsection"],

Cell[CellGroupData[{
Cell[5383, 134, 54, 2, 28, "Input"],
Cell[5440, 138, 987, 16, 208, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6464, 159, 164, 9, 108, "Input"],
Cell[6631, 170, 327, 6, 24, "Message"],
Cell[6961, 178, 333, 6, 24, "Message"],
Cell[7297, 186, 334, 6, 24, "Message"],
Cell[7634, 194, 347, 6, 24, "Message"],
Cell[7984, 202, 298, 5, 24, "Message"],
Cell[8285, 209, 360, 6, 25, "Message"],
Cell[8648, 217, 294, 5, 24, "Message"],
Cell[8945, 224, 379, 6, 25, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9373, 236, 72, 1, 36, "Subsection"],
Cell[9448, 239, 110, 2, 26, "Input"],
Cell[9561, 243, 180, 7, 54, "Input"],

Cell[CellGroupData[{
Cell[9766, 254, 57, 2, 26, "Input"],
Cell[9826, 258, 67, 1, 70, "Print",
  CellTags->"Info3417436483-8985227"],
Cell[9896, 261, 550, 14, 70, "Print",
  CellTags->"Info3417436483-8985227"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10483, 280, 116, 2, 26, "Input"],
Cell[10602, 284, 71, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10710, 290, 153, 6, 54, "Input"],
Cell[10866, 298, 80, 1, 70, "Output"],
Cell[10949, 301, 85, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11071, 307, 184, 6, 54, "Input"],
Cell[11258, 315, 110, 2, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11405, 322, 126, 2, 26, "Input"],
Cell[11534, 326, 115, 2, 70, "Output"]
}, Open  ]],
Cell[11664, 331, 220, 8, 82, "Input"],

Cell[CellGroupData[{
Cell[11909, 343, 138, 5, 26, "Input"],
Cell[12050, 350, 779, 20, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12866, 375, 147, 5, 26, "Input"],
Cell[13016, 382, 687, 18, 70, "Output"]
}, Open  ]],
Cell[13718, 403, 144, 5, 40, "Input"],

Cell[CellGroupData[{
Cell[13887, 412, 151, 6, 40, "Input"],
Cell[14041, 420, 45, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14123, 426, 113, 2, 26, "Input"],
Cell[14239, 430, 45, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14321, 436, 327, 16, 194, "Input"],
Cell[14651, 454, 43, 1, 70, "Output"],
Cell[14697, 457, 60, 1, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[14806, 464, 65, 1, 28, "Subsection"],

Cell[CellGroupData[{
Cell[14896, 469, 232, 7, 54, "Input"],
Cell[15131, 478, 55, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15223, 484, 229, 7, 68, "Input"],
Cell[15455, 493, 70, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15562, 499, 229, 7, 68, "Input"],
Cell[15794, 508, 70, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15901, 514, 236, 7, 54, "Input"],
Cell[16140, 523, 74, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16251, 529, 226, 7, 40, "Input"],
Cell[16480, 538, 54, 1, 70, "Output"],
Cell[16537, 541, 50, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16624, 547, 219, 7, 54, "Input"],
Cell[16846, 556, 42, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16925, 562, 76, 2, 26, "Input"],
Cell[17004, 566, 69, 1, 70, "Print",
  CellTags->"Info3417436483-5913918"],
Cell[17076, 569, 525, 14, 70, "Print",
  CellTags->"Info3417436483-5913918"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[17650, 589, 66, 1, 28, "Subsection"],

Cell[CellGroupData[{
Cell[17741, 594, 396, 10, 208, "Input"],
Cell[18140, 606, 626, 8, 70, "Output"],
Cell[18769, 616, 68, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18874, 622, 147, 6, 40, "Input",
  Evaluatable->False],
Cell[19024, 630, 1254, 22, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20315, 657, 663, 12, 82, "Input"],
Cell[20981, 671, 516, 8, 70, "Message"],
Cell[21500, 681, 607, 8, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22144, 694, 187, 5, 40, "Input"],
Cell[22334, 701, 70, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22441, 707, 155, 7, 68, "Input"],
Cell[22599, 716, 179, 3, 70, "Print"],
Cell[22781, 721, 179, 3, 70, "Print"],
Cell[22963, 726, 53196, 2549, 70, 33272, 2298, "GraphicsData", "PostScript", \
"Graphics"],
Cell[76162, 3277, 135, 3, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[76334, 3285, 110, 2, 26, "Subsubsection"],
Cell[76447, 3289, 92, 2, 39, "Input"],

Cell[CellGroupData[{
Cell[76564, 3295, 87, 2, 39, "Input"],
Cell[76654, 3299, 303, 4, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[76994, 3308, 136, 7, 84, "Input"],
Cell[77133, 3317, 42, 1, 70, "Output"],
Cell[77178, 3320, 260, 4, 70, "Output"],
Cell[77441, 3326, 42, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[77520, 3332, 75, 2, 39, "Input"],
Cell[77598, 3336, 206, 4, 70, "Output"]
}, Open  ]],
Cell[77819, 3343, 170, 7, 39, "Input"],

Cell[CellGroupData[{
Cell[78014, 3354, 80, 2, 39, "Input"],
Cell[78097, 3358, 179, 3, 70, "Print"],
Cell[78279, 3363, 179, 3, 70, "Print"],
Cell[78461, 3368, 40233, 1307, 70, 13492, 972, "GraphicsData", "PostScript", \
"Graphics"],
Cell[118697, 4677, 130, 3, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[118876, 4686, 184, 7, 20, "Subsubsection"],

Cell[CellGroupData[{
Cell[119085, 4697, 15997, 270, 2604, "Input"],
Cell[135085, 4969, 19422, 366, 70, "Output"]
}, Open  ]],
Cell[154522, 5338, 3168, 48, 501, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[157739, 5392, 82, 1, 28, "Subsection"],

Cell[CellGroupData[{
Cell[157846, 5397, 168, 4, 28, "Subsubsection"],
Cell[158017, 5403, 104, 2, 28, "Input"],
Cell[158124, 5407, 192, 7, 76, "Input"],

Cell[CellGroupData[{
Cell[158341, 5418, 112, 2, 28, "Input"],
Cell[158456, 5422, 92, 1, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[158585, 5428, 171, 7, 76, "Input"],
Cell[158759, 5437, 35, 1, 26, "Output"],
Cell[158797, 5440, 50, 1, 26, "Output"],
Cell[158850, 5443, 50, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[158937, 5449, 177, 6, 60, "Input"],
Cell[159117, 5457, 58, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[159212, 5463, 122, 2, 28, "Input"],
Cell[159337, 5467, 60, 1, 26, "Output"]
}, Open  ]],
Cell[159412, 5471, 224, 9, 108, "Input"],

Cell[CellGroupData[{
Cell[159661, 5484, 118, 2, 28, "Input"],
Cell[159782, 5488, 66, 1, 28, "Output"]
}, Open  ]],
Cell[159863, 5492, 139, 5, 44, "Input"],

Cell[CellGroupData[{
Cell[160027, 5501, 144, 5, 44, "Input"],
Cell[160174, 5508, 45, 1, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[160256, 5514, 108, 2, 28, "Input"],
Cell[160367, 5518, 45, 1, 28, "Output"]
}, Open  ]],
Cell[160427, 5522, 422, 24, 348, "Input"],

Cell[CellGroupData[{
Cell[160874, 5550, 104, 2, 28, "Input"],
Cell[160981, 5554, 213, 4, 26, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[161243, 5564, 122, 3, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[161390, 5571, 223, 7, 69, "Input"],
Cell[161616, 5580, 74, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[161727, 5586, 220, 7, 84, "Input"],
Cell[161950, 5595, 75, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[162062, 5601, 218, 7, 84, "Input"],
Cell[162283, 5610, 123, 2, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[162443, 5617, 221, 7, 84, "Input"],
Cell[162667, 5626, 220, 3, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[162924, 5634, 221, 7, 69, "Input"],
Cell[163148, 5643, 77, 1, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[163262, 5649, 224, 7, 69, "Input"],
Cell[163489, 5658, 123, 2, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[163649, 5665, 214, 6, 54, "Input"],
Cell[163866, 5673, 123, 2, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[164026, 5680, 211, 6, 54, "Input"],
Cell[164240, 5688, 220, 3, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[164497, 5696, 212, 6, 54, "Input"],
Cell[164712, 5704, 435, 6, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[165184, 5715, 164, 6, 54, "Input"],
Cell[165351, 5723, 529, 12, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[165917, 5740, 120, 2, 39, "Input"],
Cell[166040, 5744, 123, 2, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[166200, 5751, 208, 6, 69, "Input"],
Cell[166411, 5759, 42, 1, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[166502, 5766, 147, 3, 22, "Subsubsection"],

Cell[CellGroupData[{
Cell[166674, 5773, 438, 15, 204, "Input"],
Cell[167115, 5790, 49, 1, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[167237, 5799, 90, 2, 63, "Section"],

Cell[CellGroupData[{
Cell[167352, 5805, 59, 1, 36, "Subsection"],
Cell[167414, 5808, 275, 8, 76, "Input"],

Cell[CellGroupData[{
Cell[167714, 5820, 108, 6, 60, "Input"],
Cell[167825, 5828, 58, 2, 28, "Output"],
Cell[167886, 5832, 61, 2, 28, "Output"],
Cell[167950, 5836, 69, 2, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[168056, 5843, 398, 15, 188, "Input"],
Cell[168457, 5860, 371, 6, 42, "Message"],
Cell[168831, 5868, 195, 4, 24, "Print"],
Cell[169029, 5874, 195, 4, 24, "Print"],
Cell[169227, 5880, 170600, 5733, 219, 69677, 4482, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[339876, 11619, 60, 1, 28, "Subsection"],
Cell[339939, 11622, 282, 8, 92, "Input"],
Cell[340224, 11632, 97, 2, 28, "Input"],
Cell[340324, 11636, 126, 5, 44, "Input"],

Cell[CellGroupData[{
Cell[340475, 11645, 308, 10, 92, "Input"],
Cell[340786, 11657, 195, 4, 24, "Print"],
Cell[340984, 11663, 195, 4, 24, "Print"],
Cell[341182, 11669, 176995, 5814, 257, 69706, 4484, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[518226, 17489, 64, 1, 28, "Subsection"],
Cell[518293, 17492, 348, 9, 124, "Input"],
Cell[518644, 17503, 126, 5, 44, "Input"],

Cell[CellGroupData[{
Cell[518795, 17512, 294, 10, 92, "Input"],
Cell[519092, 17524, 197, 4, 24, "Message"],
Cell[519292, 17530, 195, 4, 24, "Print"],
Cell[519490, 17536, 195, 4, 24, "Print"],
Cell[519688, 17542, 144837, 5440, 177, 70677, 4519, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[664574, 22988, 68, 1, 28, "Subsection"],
Cell[664645, 22991, 263, 8, 44, "Input"],

Cell[CellGroupData[{
Cell[664933, 23003, 404, 14, 156, "Input"],
Cell[665340, 23019, 195, 4, 24, "Print"],
Cell[665538, 23025, 195, 4, 24, "Print"],
Cell[665736, 23031, 171940, 5768, 243, 70493, 4510, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[837725, 28805, 73, 1, 28, "Subsection"],

Cell[CellGroupData[{
Cell[837823, 28810, 54, 2, 28, "Input"],
Cell[837880, 28814, 64, 1, 22, "Print",
  CellTags->"Info3416822704-7256049"],
Cell[837947, 28817, 436, 13, 22, "Print",
  CellTags->"Info3416822704-7256049"]
}, Open  ]],

Cell[CellGroupData[{
Cell[838420, 28835, 273, 8, 44, "Input"],
Cell[838696, 28845, 56, 1, 22, "Print"],
Cell[838755, 28848, 164, 3, 22, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[838956, 28856, 75, 2, 28, "Input"],
Cell[839034, 28860, 149, 2, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[839220, 28867, 371, 14, 156, "Input"],
Cell[839594, 28883, 179, 3, 22, "Print"],
Cell[839776, 28888, 179, 3, 22, "Print"],
Cell[839958, 28893, 153487, 5540, 191, 70502, 4510, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[993494, 34439, 182, 6, 28, "Subsection"],

Cell[CellGroupData[{
Cell[993701, 34449, 84, 3, 28, "Input"],
Cell[993788, 34454, 372, 7, 24, "Message"],
Cell[994163, 34463, 308, 6, 24, "Message"],
Cell[994474, 34471, 350, 7, 24, "Message"],
Cell[994827, 34480, 350, 7, 24, "Message"],
Cell[995180, 34489, 360, 7, 24, "Message"],
Cell[995543, 34498, 368, 7, 24, "Message"],
Cell[995914, 34507, 372, 7, 24, "Message"]
}, Open  ]],
Cell[996301, 34517, 101, 3, 28, "Input"],

Cell[CellGroupData[{
Cell[996427, 34524, 119, 3, 28, "Input"],
Cell[996549, 34529, 340, 5, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[996926, 34539, 86, 3, 28, "Input"],
Cell[997015, 34544, 54, 1, 26, "Output"]
}, Open  ]],
Cell[997084, 34548, 216, 5, 64, "Input"],

Cell[CellGroupData[{
Cell[997325, 34557, 440, 11, 92, "Input"],
Cell[997768, 34570, 302, 4, 37, "Print"],
Cell[998073, 34576, 248, 4, 22, "Print"],
Cell[998324, 34582, 52, 1, 22, "Print"],
Cell[998379, 34585, 248, 4, 22, "Print"],
Cell[998630, 34591, 52, 1, 22, "Print"],
Cell[998685, 34594, 248, 4, 22, "Print"],
Cell[998936, 34600, 52, 1, 22, "Print"],
Cell[998991, 34603, 248, 4, 22, "Print"],
Cell[999242, 34609, 50, 1, 22, "Print"],
Cell[999295, 34612, 248, 4, 22, "Print"],
Cell[999546, 34618, 52, 1, 22, "Print"],
Cell[999601, 34621, 248, 4, 22, "Print"],
Cell[999852, 34627, 52, 1, 22, "Print"],
Cell[999907, 34630, 248, 4, 22, "Print"],
Cell[1000158, 34636, 52, 1, 22, "Print"],
Cell[1000213, 34639, 248, 4, 22, "Print"],
Cell[1000464, 34645, 52, 1, 22, "Print"],
Cell[1000519, 34648, 248, 4, 22, "Print"],
Cell[1000770, 34654, 52, 1, 22, "Print"],
Cell[1000825, 34657, 248, 4, 22, "Print"],
Cell[1001076, 34663, 52, 1, 22, "Print"],
Cell[1001131, 34666, 248, 4, 22, "Print"],
Cell[1001382, 34672, 52, 1, 22, "Print"],
Cell[1001437, 34675, 248, 4, 22, "Print"],
Cell[1001688, 34681, 51, 1, 22, "Print"],
Cell[1001742, 34684, 248, 4, 22, "Print"],
Cell[1001993, 34690, 51, 1, 22, "Print"],
Cell[1002047, 34693, 248, 4, 22, "Print"],
Cell[1002298, 34699, 51, 1, 22, "Print"],
Cell[1002352, 34702, 248, 4, 22, "Print"],
Cell[1002603, 34708, 52, 1, 22, "Print"],
Cell[1002658, 34711, 248, 4, 22, "Print"],
Cell[1002909, 34717, 52, 1, 22, "Print"],
Cell[1002964, 34720, 248, 4, 22, "Print"],
Cell[1003215, 34726, 51, 1, 22, "Print"],
Cell[1003269, 34729, 248, 4, 22, "Print"],
Cell[1003520, 34735, 51, 1, 22, "Print"],
Cell[1003574, 34738, 248, 4, 22, "Print"],
Cell[1003825, 34744, 52, 1, 22, "Print"],
Cell[1003880, 34747, 248, 4, 22, "Print"],
Cell[1004131, 34753, 52, 1, 22, "Print"],
Cell[1004186, 34756, 248, 4, 22, "Print"],
Cell[1004437, 34762, 52, 1, 22, "Print"],
Cell[1004492, 34765, 248, 4, 22, "Print"],
Cell[1004743, 34771, 52, 1, 22, "Print"],
Cell[1004798, 34774, 248, 4, 22, "Print"],
Cell[1005049, 34780, 52, 1, 22, "Print"],
Cell[1005104, 34783, 248, 4, 22, "Print"],
Cell[1005355, 34789, 52, 1, 22, "Print"],
Cell[1005410, 34792, 248, 4, 22, "Print"],
Cell[1005661, 34798, 52, 1, 22, "Print"],
Cell[1005716, 34801, 248, 4, 22, "Print"],
Cell[1005967, 34807, 52, 1, 22, "Print"],
Cell[1006022, 34810, 248, 4, 22, "Print"],
Cell[1006273, 34816, 51, 1, 22, "Print"],
Cell[1006327, 34819, 248, 4, 22, "Print"],
Cell[1006578, 34825, 51, 1, 22, "Print"],
Cell[1006632, 34828, 248, 4, 22, "Print"],
Cell[1006883, 34834, 52, 1, 22, "Print"],
Cell[1006938, 34837, 248, 4, 22, "Print"],
Cell[1007189, 34843, 51, 1, 22, "Print"],
Cell[1007243, 34846, 248, 4, 22, "Print"],
Cell[1007494, 34852, 51, 1, 22, "Print"],
Cell[1007548, 34855, 248, 4, 22, "Print"],
Cell[1007799, 34861, 52, 1, 22, "Print"],
Cell[1007854, 34864, 248, 4, 22, "Print"],
Cell[1008105, 34870, 52, 1, 22, "Print"],
Cell[1008160, 34873, 248, 4, 22, "Print"],
Cell[1008411, 34879, 52, 1, 22, "Print"],
Cell[1008466, 34882, 248, 4, 22, "Print"],
Cell[1008717, 34888, 52, 1, 22, "Print"],
Cell[1008772, 34891, 248, 4, 22, "Print"],
Cell[1009023, 34897, 52, 1, 22, "Print"],
Cell[1009078, 34900, 248, 4, 22, "Print"],
Cell[1009329, 34906, 52, 1, 22, "Print"],
Cell[1009384, 34909, 248, 4, 22, "Print"],
Cell[1009635, 34915, 51, 1, 22, "Print"],
Cell[1009689, 34918, 248, 4, 22, "Print"],
Cell[1009940, 34924, 52, 1, 22, "Print"],
Cell[1009995, 34927, 248, 4, 22, "Print"],
Cell[1010246, 34933, 52, 1, 22, "Print"],
Cell[1010301, 34936, 248, 4, 22, "Print"],
Cell[1010552, 34942, 52, 1, 22, "Print"],
Cell[1010607, 34945, 248, 4, 22, "Print"],
Cell[1010858, 34951, 52, 1, 22, "Print"],
Cell[1010913, 34954, 248, 4, 22, "Print"],
Cell[1011164, 34960, 52, 1, 22, "Print"],
Cell[1011219, 34963, 248, 4, 22, "Print"],
Cell[1011470, 34969, 52, 1, 22, "Print"],
Cell[1011525, 34972, 248, 4, 22, "Print"],
Cell[1011776, 34978, 52, 1, 22, "Print"],
Cell[1011831, 34981, 248, 4, 22, "Print"],
Cell[1012082, 34987, 52, 1, 22, "Print"],
Cell[1012137, 34990, 248, 4, 22, "Print"],
Cell[1012388, 34996, 52, 1, 22, "Print"],
Cell[1012443, 34999, 248, 4, 22, "Print"],
Cell[1012694, 35005, 52, 1, 22, "Print"],
Cell[1012749, 35008, 248, 4, 22, "Print"],
Cell[1013000, 35014, 52, 1, 22, "Print"],
Cell[1013055, 35017, 248, 4, 22, "Print"],
Cell[1013306, 35023, 52, 1, 22, "Print"],
Cell[1013361, 35026, 248, 4, 22, "Print"],
Cell[1013612, 35032, 52, 1, 22, "Print"],
Cell[1013667, 35035, 248, 4, 22, "Print"],
Cell[1013918, 35041, 51, 1, 22, "Print"],
Cell[1013972, 35044, 248, 4, 22, "Print"],
Cell[1014223, 35050, 52, 1, 22, "Print"],
Cell[1014278, 35053, 69, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1014384, 35059, 486, 17, 172, "Input"],
Cell[1014873, 35078, 179, 3, 22, "Print"],
Cell[1015055, 35083, 179, 3, 22, "Print"],
Cell[1015237, 35088, 184045, 5893, 232, 72280, 4508, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1199319, 40986, 79, 1, 26, "Input"],
Cell[1199401, 40989, 79, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1199517, 40995, 487, 12, 140, "Input"],
Cell[1200007, 41009, 302, 4, 37, "Print"],
Cell[1200312, 41015, 444, 8, 24, "Print"],
Cell[1200759, 41025, 80, 1, 24, "Print"],
Cell[1200842, 41028, 446, 8, 24, "Print"],
Cell[1201291, 41038, 80, 1, 24, "Print"],
Cell[1201374, 41041, 447, 8, 24, "Print"],
Cell[1201824, 41051, 80, 1, 24, "Print"],
Cell[1201907, 41054, 445, 8, 24, "Print"],
Cell[1202355, 41064, 81, 1, 24, "Print"],
Cell[1202439, 41067, 446, 8, 24, "Print"],
Cell[1202888, 41077, 80, 1, 24, "Print"],
Cell[1202971, 41080, 444, 8, 24, "Print"],
Cell[1203418, 41090, 81, 1, 24, "Print"],
Cell[1203502, 41093, 448, 8, 24, "Print"],
Cell[1203953, 41103, 80, 1, 24, "Print"],
Cell[1204036, 41106, 449, 8, 24, "Print"],
Cell[1204488, 41116, 85, 1, 24, "Print"],
Cell[1204576, 41119, 258, 5, 24, "Print"],
Cell[1204837, 41126, 464, 10, 24, "Print"],
Cell[1205304, 41138, 80, 1, 24, "Print"],
Cell[1205387, 41141, 464, 10, 24, "Print"],
Cell[1205854, 41153, 81, 1, 24, "Print"],
Cell[1205938, 41156, 451, 8, 24, "Print"],
Cell[1206392, 41166, 86, 1, 24, "Print"],
Cell[1206481, 41169, 259, 5, 24, "Print"],
Cell[1206743, 41176, 447, 8, 24, "Print"],
Cell[1207193, 41186, 80, 1, 24, "Print"],
Cell[1207276, 41189, 463, 10, 24, "Print"],
Cell[1207742, 41201, 81, 1, 24, "Print"],
Cell[1207826, 41204, 448, 8, 24, "Print"],
Cell[1208277, 41214, 80, 1, 24, "Print"],
Cell[1208360, 41217, 464, 10, 24, "Print"],
Cell[1208827, 41229, 80, 1, 24, "Print"],
Cell[1208910, 41232, 464, 10, 24, "Print"],
Cell[1209377, 41244, 80, 1, 24, "Print"],
Cell[1209460, 41247, 446, 8, 24, "Print"],
Cell[1209909, 41257, 79, 1, 24, "Print"],
Cell[1209991, 41260, 446, 8, 24, "Print"],
Cell[1210440, 41270, 80, 1, 24, "Print"],
Cell[1210523, 41273, 441, 8, 24, "Print"],
Cell[1210967, 41283, 79, 1, 24, "Print"],
Cell[1211049, 41286, 466, 10, 24, "Print"],
Cell[1211518, 41298, 80, 1, 24, "Print"],
Cell[1211601, 41301, 448, 8, 24, "Print"],
Cell[1212052, 41311, 81, 1, 24, "Print"],
Cell[1212136, 41314, 465, 10, 24, "Print"],
Cell[1212604, 41326, 80, 1, 24, "Print"],
Cell[1212687, 41329, 448, 8, 24, "Print"],
Cell[1213138, 41339, 78, 1, 24, "Print"],
Cell[1213219, 41342, 462, 10, 24, "Print"],
Cell[1213684, 41354, 81, 1, 24, "Print"],
Cell[1213768, 41357, 447, 8, 24, "Print"],
Cell[1214218, 41367, 80, 1, 24, "Print"],
Cell[1214301, 41370, 461, 10, 24, "Print"],
Cell[1214765, 41382, 83, 1, 24, "Print"],
Cell[1214851, 41385, 259, 5, 24, "Print"],
Cell[1215113, 41392, 463, 10, 24, "Print"],
Cell[1215579, 41404, 78, 1, 24, "Print"],
Cell[1215660, 41407, 447, 8, 24, "Print"],
Cell[1216110, 41417, 81, 1, 24, "Print"],
Cell[1216194, 41420, 447, 8, 24, "Print"],
Cell[1216644, 41430, 81, 1, 24, "Print"],
Cell[1216728, 41433, 464, 10, 24, "Print"],
Cell[1217195, 41445, 86, 1, 24, "Print"],
Cell[1217284, 41448, 259, 5, 24, "Print"],
Cell[1217546, 41455, 443, 8, 24, "Print"],
Cell[1217992, 41465, 81, 1, 24, "Print"],
Cell[1218076, 41468, 451, 8, 24, "Print"],
Cell[1218530, 41478, 86, 1, 24, "Print"],
Cell[1218619, 41481, 259, 5, 24, "Print"],
Cell[1218881, 41488, 460, 10, 24, "Print"],
Cell[1219344, 41500, 86, 1, 24, "Print"],
Cell[1219433, 41503, 258, 5, 24, "Print"],
Cell[1219694, 41510, 445, 8, 24, "Print"],
Cell[1220142, 41520, 79, 1, 24, "Print"],
Cell[1220224, 41523, 444, 8, 24, "Print"],
Cell[1220671, 41533, 79, 1, 24, "Print"],
Cell[1220753, 41536, 465, 10, 24, "Print"],
Cell[1221221, 41548, 81, 1, 24, "Print"],
Cell[1221305, 41551, 461, 10, 24, "Print"],
Cell[1221769, 41563, 79, 1, 24, "Print"],
Cell[1221851, 41566, 462, 10, 24, "Print"],
Cell[1222316, 41578, 80, 1, 24, "Print"],
Cell[1222399, 41581, 464, 10, 24, "Print"],
Cell[1222866, 41593, 80, 1, 24, "Print"],
Cell[1222949, 41596, 464, 10, 24, "Print"],
Cell[1223416, 41608, 80, 1, 24, "Print"],
Cell[1223499, 41611, 446, 8, 24, "Print"],
Cell[1223948, 41621, 79, 1, 24, "Print"],
Cell[1224030, 41624, 463, 10, 24, "Print"],
Cell[1224496, 41636, 80, 1, 24, "Print"],
Cell[1224579, 41639, 445, 8, 24, "Print"],
Cell[1225027, 41649, 80, 1, 24, "Print"],
Cell[1225110, 41652, 461, 10, 24, "Print"],
Cell[1225574, 41664, 80, 1, 24, "Print"],
Cell[1225657, 41667, 443, 8, 24, "Print"],
Cell[1226103, 41677, 80, 1, 24, "Print"],
Cell[1226186, 41680, 461, 10, 24, "Print"],
Cell[1226650, 41692, 80, 1, 24, "Print"],
Cell[1226733, 41695, 464, 10, 24, "Print"],
Cell[1227200, 41707, 79, 1, 24, "Print"],
Cell[1227282, 41710, 446, 8, 24, "Print"],
Cell[1227731, 41720, 80, 1, 24, "Print"],
Cell[1227814, 41723, 459, 10, 24, "Print"],
Cell[1228276, 41735, 80, 1, 24, "Print"],
Cell[1228359, 41738, 462, 10, 24, "Print"],
Cell[1228824, 41750, 80, 1, 24, "Print"],
Cell[1228907, 41753, 444, 8, 24, "Print"],
Cell[1229354, 41763, 80, 1, 24, "Print"],
Cell[1229437, 41766, 463, 10, 24, "Print"],
Cell[1229903, 41778, 79, 1, 24, "Print"],
Cell[1229985, 41781, 442, 8, 24, "Print"],
Cell[1230430, 41791, 80, 1, 24, "Print"],
Cell[1230513, 41794, 69, 1, 26, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1230619, 41800, 486, 17, 169, "Input"],
Cell[1231108, 41819, 179, 3, 22, "Print"],
Cell[1231290, 41824, 179, 3, 22, "Print"],
Cell[1231472, 41829, 179316, 5887, 240, 73079, 4571, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1410825, 47721, 79, 1, 26, "Input"],
Cell[1410907, 47724, 78, 1, 26, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1411034, 47731, 83, 2, 36, "Subsection"],

Cell[CellGroupData[{
Cell[1411142, 47737, 173, 7, 28, "Input"],
Cell[1411318, 47746, 117, 3, 22, "Print",
  CellTags->"Info3416806401-7520506"],
Cell[1411438, 47751, 4265, 76, 311, "Print",
  CellTags->"Info3416806401-7520506"]
}, Closed]],

Cell[CellGroupData[{
Cell[1415740, 47832, 495, 11, 115, "Input"],
Cell[1416238, 47845, 74, 3, 26, "Output"],
Cell[1416315, 47850, 125, 3, 26, "Output"],
Cell[1416443, 47855, 84, 3, 26, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1416564, 47863, 83, 3, 25, "Input"],
Cell[1416650, 47868, 109, 3, 24, "Print",
  CellTags->"Info3416811037-4307960"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1416796, 47876, 479, 12, 172, "Input"],
Cell[1417278, 47890, 280, 6, 24, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1417595, 47901, 584, 20, 252, "Input"],
Cell[1418182, 47923, 195, 4, 24, "Print"],
Cell[1418380, 47929, 195, 4, 24, "Print"],
Cell[1418578, 47935, 195, 4, 24, "Print"],
Cell[1418776, 47941, 147545, 5389, 165, 69206, 4416, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1566358, 53335, 602, 14, 82, "Input"],
Cell[1566963, 53351, 159, 4, 28, "Output"],
Cell[1567125, 53357, 392, 7, 24, "Message"],
Cell[1567520, 53366, 107, 3, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1567664, 53374, 269, 8, 28, "Input"],
Cell[1567936, 53384, 127, 3, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1568100, 53392, 1156, 25, 118, "Input"],
Cell[1569259, 53419, 394, 7, 24, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1569690, 53431, 682, 25, 316, "Input"],
Cell[1570375, 53458, 218, 5, 24, "Print"],
Cell[1570596, 53465, 218, 5, 24, "Print"],
Cell[1570817, 53472, 218, 5, 24, "Print"],
Cell[1571038, 53479, 218, 5, 24, "Print"],
Cell[1571259, 53486, 199862, 7020, 239, 89957, 5657, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

