(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     56157,        986]*)
(*NotebookOutlinePosition[     57521,       1033]*)
(*  CellTagsIndexPosition[     57382,       1025]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[TextData[{
  "\t\t\nUnprotect[\"code`Kronecker`*\"];\nClear[    \"code`Kronecker`*\"];\n\
Remove[   \"code`Kronecker`Private`*\"];\t\t\t\t\t\t\n\n\n\
BeginPackage[\"code`Kronecker`\",\n\n\t\t\t\t   \
{\"LinearAlgebra`MatrixManipulation`\",\n\t\t\t\t    \
(*\"LinearAlgebra`Cholesky`\",*)\n\t\t\t\t\t\"Utilities`FilterOptions`\",\n\t\
\t\t\t\t\"Graphics`Graphics`\",\n\t\t\t\t\t\"Graphics`Colors`\",\n\t\t\t\t\t\
\"Statistics`Common`DistributionsCommon`\",\n\t\t\t\t\t\
\"Statistics`NormalDistribution`\",\n\t\t\t\t\t\
\"Statistics`DescriptiveStatistics`\",\n\t\t\t\t    \
\"Statistics`DataManipulation`\",\n\t\t\t\t    \"code`KernDichte`\",          \
                               \n\t\t\t\t\t\"Global`\"}]\n\n\nUni::usage = \
\"Uni[] := 3.464101615137754587 (Random[] - .5), Uniforme Verteilung\n\tmit \
Erwartung 0 und Varianz 1\"\n\t\nUniC::usage = \"UniC = \
Compile[{},3.464101615137754587 (Random[] - .5)]\"\t\n\t\nGauss::usage = \
\"Gauss[] := Apply[Plus,Table[Random[],{i,12}]] - 6; \n\tApproximative \
Normalverteilung N(0,1)\"\n\t\nGaussC::usage = \"GaussC = \
Compile[{},Random[]+Random[]+Random[]+Random[]+Random[]+Random[]+\n\t\
Random[]+Random[]+Random[]+Random[]+Random[]+Random[]-6.0]\"\n\nP2::usage = \
\"P2[] := 2 Random[Integer]-1.\"\n\nP2C::usage = \"P2C = Compile[{},2. \
Random[Integer]-1.]\"\n\nRandomGauss::usage = \
\"RandomGauss[mue_,sigma_,n_,Generator_:Gauss]\"\n\t\nWiener::usage = \
\"Wiener[Start,dt,Tp,Prozess], Wiener-Proze\[SZ]\"\n\nKroneckerProduct::usage \
= \"KroneckerProduct[A_,B_],\n\tKronecker-Produkt der Matrizen \n\tA(i x j) \
und B(k x l) mit Dimension ik x jl\"\n\nJ::usage = \"J[value_,m_,n_], \
Vorsicht! IML: J[m,m,value]\"\n\nVarianz::usage = \"Varianz[y_],\n\tGesch\
\[ADoubleDot]tzte Kovarianzmatrix SML = (1/n)y`y - mm`\n\tund S = (n/(n-1)) \
SML, Mittelwert m\"\n\t\nMS::usage = \"Mittelwert und Standardabweichung der \
Datenmatrix y\"\n\nMS1::usage = \"Mittelwert und Standardabweichung der \
Datenmatrix y\"\n\nMS2::usage = \"Mittelwert und Standardabweichung der \
Datenmatrix y,\n              mean[Map[(#-m)&,X]^2]\"\n\nmean::usage = \
\"mean[y_], Mittelwert der Datenmatrix y\"\n\nTensorMS::usage = \
\"TensorMS[X_]: Mittelwert und Standardabweichung \n\tdes Tensors X (L\
\[ADoubleDot]nge n)\"\n\nSigma2Corr::usage = \"Sigma2Corr[S_], \
Korrelationsmatrix und Standardabw.\"\n\nCorrelation::usage = \
\"Correlation[y_] oder Correlation[x_,y_,scatter_:0,opts___]\n                \
      (retourniert {corr,cov}), mit scatterplot\"\n\n\
Options[Correlation]={PlotLabel ->\"Streudiagramm\",\n                      \
PlotLabelsX->\" \",\n                      PlotLabelsY->\" \",\n              \
        GraphicsSpacing->0,\n                      color->Range[10]}\n\n\
autocorr::usage = \"autocorr[y_,tau_,scatter_:0,opts___]: \\n\n               \
    Autokorrelation (und Kov.) \\n\n                   mit lag tau und \
scatterplot\"\n\nAutokorr::usage = \"Autokorr[y_,tau_]; y = Vektor, mit \
ListCorrelate\"\n\nAutokorr1::usage = \"Autokorr[y_,tau_]\"\n\n\
AutokorrM::usage = \"AutokorrM[y_,tau_]; y = Matrix, mit ListCorrelate\"\n\n\
Autokorr1M::usage = \"Autokorr1M[y_,tau_]\"\n\n\nMahalanobisDistanz::usage = \
\"MahalanobisDistanz[X_, Sigma1_]\"\n\nSkalarProdukt::usage = \
\"SkalarProdukt[X_, G_],\n\tSkalarprodukt der Vektoren in X mit \
Gewichtsmatrix G\"\n\t\nShape::usage = \"Shape[A_,p_], Umformen auf Dimension\
\n\tp ={p1,p2,....}\"\n\nShape1::usage = \"Shape1[A_,p_,aux_], erg\
\[ADoubleDot]nzt aux, wenn zu kurz\"\n\t\nAddTimeAxis::usage = \
\"AddTimeAxis[X,{t0,t1,dt}], \n\tAnf\[UDoubleDot]gen einer ersten Spalte an \
Datenmatrix, 2. Parameter optional\"\n\nplot1::usage = \"plot1[Data_, \
PlotJoined->True,Frame->True,Axes->False,dicke->0.01,\n\t\
gestrichelt->{1,2,3..},color->{1,2,3,4,5,6,7,8,9,10,...},\n\t\
epilog->{},AspectRatio->1/GoldenRatio,\n\tDisplayFunction->$DisplayFunction], \
farbmodell->eigene, \n\ttext->{}, TEXTSHIFT->{0,0}, Mehrfacher ListPlot\"\n\t\
\t\nnnn = 1000; \n\nOptions[plot1] = {PlotJoined->True,\n                  \
Frame->True,\n                  Axes->False,\n                  dicke->.006,\n\
\t              gestrichelt->1,\n\t              color->Range[nnn],\n\t       \
       DisplayFunction->$DisplayFunction,\n\t              \
farbmodell->eigene,\n\t              text->Array[(\" \")&,nnn],\n\t           \
   TEXTSHIFT->Array[{0,0}&,nnn],\n\t              permute->Range[nnn]};\n\n\
ErrorBar::usage = \"ErrorBar[{x_,y_,dy_},dx_]\" \n    gray::usage = \
\"gray[{x_,y_,dy_},dx_]\"\n     hue::usage = \"hue[{x_,y_,dy_},dx_]\"\n\t\n\
errorlistplot::usage = \"errorlistplot[data_,opts___]\"\n\
Options[errorlistplot] = {pointsize->.02,\n                          \
barsize->.01,\n                          thickness->.001,\n                   \
       DisplayFunction->$DisplayFunction}\n\ngeneralizederrorlistplot::usage \
= \"errorlistplot[data,object,opts]\"\nOptions[generalizederrorlistplot] = \
{pointsize->.02,\n                                     barsize->.01,\n        \
                             thickness->.001,\n                               \
      DisplayFunction->$DisplayFunction}\n                                    \
               \t\nphaseplot::usage = \
\"phaseplot[Data_,join->True,dicke->0.001,\n\t\
gestrichelt->{1,2,3..},color->{1,2,3,4,5,6,7,8,9,10},epilog->{},\n\t\
AspectRatio->Automatic], Mehrfacher ListPlot im Phasenraum, \n\t{t,p,n} = \
Dimensions[Data]\"\n\t\nOptions[phaseplot] = \
{join->True,dicke->0.001,gestrichelt->Array[1&,10],\n\t\
color->Range[10],epilog->{},AspectRatio->1}\n\nQQplot::usage = \
\"QQplot[x_,Distribution_:NormalDistribution[0,1]],\n\tx-Achse: Daten\"\n\n\
QQplot2::usage = \"QQplot2[x_,Distribution_:NormalDistribution[0,1]],\n\t\
x-Achse: Daten, zus\[ADoubleDot]tzlich Lorenzkurve\"\n\nKernDichtePlot::usage \
= \"Kerndichte-Plot\"\n\nNotPosition::usage = \"NotPosition[List_,pattern_]: \
Positionen, wo\n\tpattern nicht vorkommt\"\n\t\nCompress::usage = \
\"Compress[a_,b_] := Delete[b,Position[a,False]]\"\n\nAPLExpand::usage = \
\"APLExpand[x_,y_]:= MapThread[Shape[#1,#2]&,{y,x}]\"\n\nlocate::usage = \
\"locate[b_] := Flatten@Position[b, True]\"\n\nLocate::usage = \
\"Locate[b_,what_:True] := Flatten@Position[b, what]\"\n\neq::usage = \
\"eq[x_,y_] := x == y; SetAttributes[eq,Listable];\"\nne::usage = \"ne[x_,y_] \
:= x != y; SetAttributes[ne,Listable];\"\ngr::usage = \"gr[x_,y_] := x >  y; \
SetAttributes[gr,Listable];\"\nge::usage = \"ge[x_,y_] := x >= y; \
SetAttributes[ge,Listable];\"\nlt::usage = \"lt[x_,y_] := x <  y; \
SetAttributes[lt,Listable];\"\nle::usage = \"le[x_,y_] := x <= y; \
SetAttributes[le,Listable];\"\n\nunsameq::usage = \"unsameq[x__] := \
UnsameQ[x]; SetAttributes[unsameq,{Listable}];\"\nsameq::usage = \"sameq[x__] \
:= SameQ[x]; SetAttributes[sameq,{Listable}];\"\n\nReplaceColumns::usage = \
\"ReplaceColumns[a_,i_,b_,j_], Replace Column\n\ti in A by Column j in B and \
return result\"\n\t\nColumnSelect::usage = \"ColumnSelect[a_,i_] := \
Map[Part[#,i]&,a],\n\tSpalten in i ausw\[ADoubleDot]hlen\"\n\t\n\
MatrixTrace::usage = \"MatrixTrace[A_], Spur von A\"\n\nii::usage = \
\"Horizontale Verkettung || = AppendRows\"\nvv::usage = \"Vertikale \
Verkettung   // = AppendColumns\"\n\nSpalte::usage = \"Spalte[x_]:= \
Shape[x,{Length[x],1}]\"\n\nHadamard::usage = \"Hadamard[a_,op_,b_], \
Hadamard-Produkt der Vektoren\n\ta und b mit Operator op, {a1 op \
b1,.........,an op bn}\"\n\t\nDelta::usage = \"Delta[x_,lag_:1]:=Drop[x,lag] \
- Drop[x,-lag],\n    Delta[x_,y_,op_,lag_:1]:= \
MapThread[op,{Drop[x,lag],Drop[y,-lag]}]\"\n\nlistplay::usage = \
\"listplay[list_,rate_] := \n\t\
SampledSoundList[list/(Max[list]//N),rate]//Sound//Show\"\n\t\n\
Kontingenz::usage = \"Kontingenz[h_,Hyp_,PR_:True]\"\n\nHistogramm::usage = \
\"Histogramm[x_,Klassen_], Klassen (u,o]\"\n\nHistogramm1::usage = \
\"Histogramm1[x_,Klassen_], Klassen [u,o)\"\n\nRank::usage = \"Rank[x_] := \
Map[(Apply[Plus,#]/Length[#])&,\n\tMap[Locate[Sort[x],#]&,x] ]\" \n\n\
PlatzInUngeordneterListe::usage = \"PlatzInUngeordneterListe[x_]:=\\n\n      \
Map[First,Map[Locate[x,#]&,Sort[x]]],\\n\n      \
(x//Sort)==x[[PlatzInUngeordneterListe]]\"\n\n\
PlatzInUngeordneterListe1::usage = \"Sortiert {{x1,1},{x2,2}....}} nach \
erster Komponente, retourniert 2.,\\n\n      \
(x//Sort)==x[[PlatzInUngeordneterListe]]\"\n\nGaussCumul::usage = \
\"GaussCumul[x_,mue_,sigma_], kumulierte Normalverteilung\" \n\nall::usage = \
\"all[A_] := And@@Flatten[A]\"\n\nany::usage = \"any[A_] := Or@@Flatten[A]\"\n\
\nfunk::usage = \"funk[x_]:= Par[x]\"\n\nflatten::usage = \"flatten[a,ijk], \
Flatten an den Dimensionen ijk, diese werden\n\tzusammengefa\[SZ]t\" \n\n\
FlattenSymmetric::usage  = \"obere H\[ADoubleDot]lfte von A\"\n\
FlattenSymmetric1::usage = \"obere H\[ADoubleDot]lfte von A\"\n\
FlattenSymmetric2::usage = \"obere H\[ADoubleDot]lfte von A\"\n\n\
SymmetricMatrix::usage = \"Symmetrische Matrix aus vec (obere (untere) H\
\[ADoubleDot]lfte)\"\n\nSelectIndex::usage = \"SelectIndex[a_,op_], aij f\
\[UDoubleDot]r i op j,\n\tz.B.  LessThan: obere H\[ADoubleDot]lfte von a\" \n\
\t\t\njoin::usage = \"join[x,y,axis], Klebe Tensor bzgl. Achse axis zusammen \
\n\t(laminate in APL)\"\n\nTridiagonalMatrix::usage = \
\"TridiagonalMatrix[{a1,a2,a3}]\"\n\nTridiagonalMult::usage = \
\"TridiagonalMult[{a,b,c},x,Optional: periodisch]\"\n\nVecDiag::usage = \
\"VecDiag = Transpose[#,{1,1}]&\"\n\nDyad::usage = \"Outer[Times,#,#]&\"\t \n\
\nBlockDiagonalMatrix::usage = \"BlockDiagonalMatrix[{x1,x2,...]\"\n\n\
BlockDiagTimesMatrix::usage = \"BlockDiagTimesMatrix[{a1,a2...},B_]\"\n\n\
univariatealt::usage = \"univariate[data_,opts___Rule], \n    Histogramm, \
Kernsch\[ADoubleDot]tzer, angepa\[SZ]te Normalverteilung und \n\tdiverse \
Statistiken f\[UDoubleDot]r Liste data\"\n\nOptions[univariatealt] = \
{Bars->20,Plots->{True,True,True,True},\n                       \
DisplayFunction->$DisplayFunction,\n                       Ksigma->3}\n       \
                \nunivariate::usage = \"univariate[data_,opts___Rule], \
Histogramm und \n\tdiverse Statistiken f\[UDoubleDot]r Liste data\"\n\n\
Options[univariate] = {Bars->20,Plots->{True,True,True,True},\n               \
        DisplayFunction->$DisplayFunction,\n                       \
Ksigma->3,CAT->Automatic,PR->False}\n\t\nMinMax::usage = \"Minimum und \
Maximum von Daten\"\n\t\nposition::usage = \"position[a_,cond_] := \n\t\
Position[Map[cond,a,{Depth[a]-1}],True], Positionen, wo cond \n\t(pure \
function) wahr ist\"\n\t\nStreifenDiagramm::usage = \
\"StreifenDiagramm[data_,yrange_:1,cat_]\"\n\t\nStreifenDiagrammQuer::usage = \
\"StreifenDiagrammQuer[data_,yrange_:1,cat_]\"\n\nHistogrammChart::usage = \
\"HistogrammChart[{cat_,f_,F_}]\"\n\nCumulatedBarChart::usage = \
\"CumulatedBarChart[data_]\"\n\nCuMean::usage = \"CuMean[x_,Op_:Plus]:= \n\t\
FoldList[Op, x//First, Drop[x,1]]/Range[1,Length[x]], \n\tKumulativer \
Mittelwert \"\n\nDurbinWatson::usage = \"DurbinWatson[inno_], DW-Statistik\"\n\
\t\nMultivariateRegression::usage = \"MultivariateRegression[Y,X], \n\tOut: \
{Bdach,STD,VarB,SigmadachML,n/(n-q) SigmadachML,DurbinWatsonTrace}\"\n\t\n\
EinfachRegression::usage = \"EinfachRegression[y,x]\"\t\n\n\
EinfachRegressionSequentiell::usage = \"EinfachRegressionSequentiell[y,x]\"\n\
\nmax::usage = \"max[x__] := Max[x]; SetAttributes[max,Listable]\"\n\n\
min::usage = \"min[x__] := Min[x]; SetAttributes[min,Listable]\"\n\n\
Heaviside::usage = \"Heaviside[x_] := (Sign[x]+1)/2, Sprungfunktion\"\n\n\
OrnsteinUhlenbeck::usage = \"OrnsteinUhlenbeck[y_,x_,t_,a_,omega_], Dichte \
des\n\tOrnsteinUhlenbeck-Prozesses dy = ay dt + gdW (omega = g^2)\"\n\n\
ScalarQ::usage = \"ScalarQ = (TensorRank[#]==0)&\"\n\nGaussDichte::usage = \
\"GaussDichte[x_,{mue_,sigma_,sigma1_}], Multivariate GaussDichte, \n\
GaussDichte[x_,{mue_,sigma_}], sigma = Skalar oder Matrix\"\n\nTF::usage = \
\"TF = {True->1.,False->0.}\"\n\nIndikator::usage  = \"Indikator \
[{a_,b_},x_]:= Apply[UnitStep,{x-a,b-x}//Flatten]\"\n\nIndikator1::usage = \
\"Indikator1[{a_,b_},x_]:= \
Apply[Times,ge[x,a]/.TF]*Apply[Times,le[x,b]/.TF]\"\n\nIndikator2::usage = \
\"Indikator2[{a_,b_},x_]:= Apply[And,ge[x,a]]~And~Apply[And,le[x,b]]/.TF\"\n\n\
Indikator3::usage = \"Indikator3[{a_,b_},x_]:= \
Apply[And,{ge[x,a],le[x,b]}//Flatten]/.TF\"\n\nMatrixForm2List::usage = \
\"MatrixForm2List[m_]:= m /. MatrixForm->List //First\"\n\n\
TableForm2List::usage  = \"TableForm2List[m_]:= m /. TableForm->List \
//First\"\n\npNorm::usage = \"pNorm[x_,p_:2]:= Apply[Plus,x^p]^(1/p)\"\n\n\
RandomMultinomial::usage = \"RandomMultinomial[xij_,pij_,n_], n Zufallszahlen\
\n\taus xij mit W'keiten pij\"\n\t\nRandomNumbers::usage = \
\"RandomNumbers[{x1_,x2_,dx_},density_,n_], n Zufallszahlen\n\taus Dichte auf \
Raster {x1_,x2_,dx_}\"\n\nLogistic::usage = \"Logistic[x_]:= \
Module[{xx=Exp[-x]}, 1/(1+xx)]\"\nLogit::usage = \"Logit[p_]:= Log[p/(1-p)]\"\
\nProbit::usage = \"Probit[p_]:= Quantile[NormalDistribution[0,1],p]\"\n\
Probit1::usage = \"Probit1[p_]:= Sqrt[2] InverseErf[-Infinity,2 p] //N\"\n\n\
plognormal::usage = \"plognormal[y,{nu,gamma}]; Dichte von y=Exp[X]; X ",
  StyleBox["~",
    FontWeight->"Bold"],
  " N(nu,gamma),\n                     plognormal[y,y0,{nu,gamma}]; Dichte \
von y=y0 Exp[X]; X ",
  StyleBox["~",
    FontWeight->"Bold"],
  " N(nu,gamma)\"\n\ntupel::usage = \
\"tupel[x_,n_,op_:List]:=Flatten[Outer[op,Sequence@@Table[x,{i,n}]],n-1]\"\n\n\
Einheitsvektor::usage = \"Einheitsvektor[x_]:=x/Sqrt[x.x]\"\n\n\
Eigensystem1::usage = \"{lambda,Q}=Eigensystem1[A_]; Q enth\[ADoubleDot]lt \
normierte Eigenvektoren (Spalten)\"\n\n\n\n\nBegin[\"`Private`\"]\n\n\nP2[] \
:= 2 Random[Integer]-1.\n\nP2C = Compile[{},2. Random[Integer]-1.]\n\t\t\n\
Uni[] := 3.464101615137754587 (Random[] - .5);\n\nUniC = \
Compile[{},3.464101615137754587 (Random[] - .5)]\n\nGauss[] := \
Apply[Plus,Table[Random[],{i,12}]] - 6.0;\n\nGaussC = \
Compile[{},Random[]+Random[]+Random[]+Random[]+Random[]+Random[]+\n\t\t\t\t\t\
Random[]+Random[]+Random[]+Random[]+Random[]+Random[]-6.0]\n\n\n\
(***************************************************************)\t\t\t \n\
RandomGauss//Clear;\n\
RandomGauss[X_,Theta_,{mue_,sigma_},n_?IntegerQ,Generator_:Gauss]:=\n\
(***************************************************************)\t\t\t \n\
Module[{m,s,s2},\nm =   mue[X,Theta];\ns = sigma[X,Theta];\ns2 = \
CholeskyDecomposition[s];\n\
Map[Plus[m,#]&,Table[Generator[],{n},{Length[m]}].s2]\n]\n\n\
(***************************************************************)\t\t\t \n\
RandomGauss[mue_,sigma_,n_?IntegerQ,Generator_:Gauss]:=\n\
(***************************************************************)\t\t\t \n\
Module[{s2},\ns2 = CholeskyDecomposition[sigma];\n\
Map[Plus[mue,#]&,Table[Generator[],{n},{Length[mue]}].s2]\n]\n\n\
Wiener[Start_,dt_,Tp_,Prozess_:UniC] := \n\tSqrt[dt] \
FoldList[Plus,Start,Array[Prozess[]&,Tp] ];\n    \nKroneckerProduct1[A_,B_] \
:= \n     Module[{ab},\n        ab = Outer[Times, A, B]; \n        \
Transpose[Flatten[\n        Transpose[Flatten[\n        \
Transpose[ab,{1,3,2,4}],1],{3,1,2}],1]]  \n     ]\n     \n\
KroneckerProduct[a_,b_] :=  Module[{ab,i,j,k,l},\n        ab = Outer[Times, \
a, b]; \n        {i,j,k,l} = ab//Dimensions;\n        ab = \
Transpose[ab,{1,3,2,4}]//Flatten;\n        Partition[ab,j l]\n     ] \n       \
  \nJ[value_,m_,n_] := Array[value&,{m,n}];\n\n\nVarianz[y_]:=\n      \
Module[{yy,n, SML, S, means},\n      \t If[ TensorRank[y]===1,yy = \
Spalte[y],yy = y ];\n         n = Dimensions[yy]//First;\n         means = \
mean[yy];\n         SML = (Transpose[yy] . yy)/n - Outer[Times, means, \
means];\n         S = (n/(n-1)) SML;\n         {SML, S, means}\n      ]\n     \
\nmean[y_] := (Plus @@ y)/(Dimensions[y]//First);\n\nMS[y_]:=\n     \
Module[{SML, S, means},\n     {SML, S, means} = Varianz[y];\n     \
{means,VecDiag[SML]//Sqrt}\n     ]\n\nMS1[y_]:=\n     Module[{out},\n     out \
= Map[(Part[Varianz[#],{3,1}]//Flatten)&,y//Transpose]//Transpose;\n     \
out[[2]] = out[[2]]//Sqrt;\n     out\n     ]      \n\nMS2[X_]:= \n\
Module[{m=X//mean},\n{m,mean[Map[#-m &,X]^2]//Sqrt}]\n\n\nTensorMS[X_]:=\n\
Module[{m1=X//mean},\n{m1,Sqrt[mean[Map[(#^2) &,X]] - m1 m1]}]\n\n\
Sigma2Corr//Clear\nSigma2Corr[S_]:=\nModule[{STD=VecDiag[S]//Sqrt},\n\
STD1=1/STD;\n{Transpose[Transpose[STD1 S] STD1],STD}\n]\n      \n\
Correlation[y_] := \n      Module[{Sigma},\n         Sigma = Varianz[y][[2]];\
\n         Sigma2Corr[Sigma]\n         ]\n\n\n\
Correlation[x_,y_,scatter_:0,opts___]:=\n\n\t\
Module[{n,p,q,x1,y1,xquer,yquer,M,Sx,Sy,g,xtext,ytext,R,farben},\n\t\n\t\
xtext=PlotLabelsX/.{opts}/.Options[Correlation]; (*xtext//Print;*)\n\t\
ytext=PlotLabelsY/.{opts}/.Options[Correlation]; (*ytext//Print;*)\n\t\
farben=color/.{opts}/.Options[Correlation];\n\t\n\t\
{n,p}=Dimensions[x];{n,q}=Dimensions[y];\n\txquer=x//mean;\n\tyquer=y//mean;\n\
\tx1=Transpose[x];\n\ty1=Transpose[y];\n\tM \
=(1/n)x1.y-Outer[Times,xquer,yquer];\n\t\
Sx=(1/n)x1.x-Outer[Times,xquer,xquer];\n\t\
Sy=(1/n)y1.y-Outer[Times,yquer,yquer];\n\tSx=VecDiag[Sx]^-.5;\n\t\
Sy=VecDiag[Sy]^-.5;\n\tR=Transpose[Transpose[M Sx] Sy];\n\t\n\tIf[scatter!=0,\
\n\t\tg=Table[plot1[{Column[x,i],Column[y,j]}//Transpose,\n\t\t\t\t\t\t  \
AspectRatio->1,\n\t\t\t\t\t\t  PlotJoined->False,\n\t\t\t\t\t\t  dicke->.03,\n\
\t\t\t\t\t\t  color->farben[[i]],\n\t\t\t\t\t\t  PlotRange->All,\n\t\t\t\t\t\t\
  PlotLabel ->ToString[ R[[i,j]]//N3 ],\t\t\t\t\t  \n\t                      \
DisplayFunction->Identity],\n\t      {i,1,p},{j,1,q}];\n\t    \n\t    If[ \
xtext=!=\" \", g = {Map[Graphics[Text[#,{0,0}]]&,xtext]}~vv~g];\n\t    \n\t   \
 If[ ytext=!=\" \" \n\t     && xtext=!=\" \", g = \
Spalte[Map[Graphics[Text[#,{0,0}]]&,\n\t                                      \
  {\" \",ytext}//Flatten]]~ii~g];\n\t                        \n\t    \
(*g//Dimensions//Print;*)\n\n\t    \n  ];\n\n\nIf[scatter!=0,\n\n\t\
R//MatrixForm[#,FilterOptions[MatrixForm,opts]]&//Print;\n\t\
Show[GraphicsArray[g],opts],\n\t\n     (*else*)        {R, M}]\n];\n\n\n\
autocorr[y1_,tau_,scatter_:0,opts___]:=\n\n\tModule[{mue,up,do},\n\n\t\
up=Drop[y1, tau];\n\tdo=Drop[y1,-tau];\n\n\tCorrelation[do,up,scatter,opts]\n\
\n]\n\nAutokorr//Clear\nAutokorr[x_,tau_]:=Module[{xq,sxq,T},\n         xq  = \
x-(x//mean); \n    \t sxq = xq.xq;  \n    \t \
ListCorrelate[xq,xq,{1,-tau-1},0]/sxq\n    ]\n    \nAutokorr1//Clear\n\
Autokorr1[x_,tau_]:=Module[{xq,sxq,T,lag},\n         xq = x-(x//mean); \n    \
\t sxq= xq.xq;  \n         T  = x//Length;\n    \t Table[Sum[xq[[i]] \
xq[[i+lag]],{i,1,T-lag}],{lag,0,tau}]/sxq\n    ]       \n\nAutokorrM//Clear\n\
AutokorrM[x_,tau_]:=Module[{sxq,T,m,xq,p,pad},\n\t\t m=x//mean;\n         xq  \
= Map[(#-m)&,x]; \n    \t sxq = Transpose[xq].xq //VecDiag//Sqrt;\n    \t \
p=sxq//Length;\n    \t pad=Shape[0,{1,p}];    \t   \n         \
norm=((#/sxq//Transpose)/sxq//Transpose)&;\n    \t \
ListCorrelate[xq,xq,{1,-tau-1},pad,Outer[Times,#1,#2]&,Plus,1]//Map[norm,#]&\n\
    ]\n\nAutokorr1M//Clear\nAutokorr1M[x_,tau_]:=Module[{m,xq,sxq,T,lag},\n   \
      m=x//mean;\n         xq  = Map[(#-m)&,x]; \n    \t sxq = \
Transpose[xq].xq //VecDiag//Sqrt;    \t   \n         T  = x//Length; \n    \t \
Table[(Sum[Outer[Times,xq[[i]],xq[[i+lag]]],{i,1,T-lag}]/sxq//Transpose)/sxq//\
Transpose,{lag,0,tau}]\n    ]\n               \nMahalanobisDistanz[X_, \
Sigma1_]:= \n       Module[{Skal,Diag},\n         Skal = SkalarProdukt[X, \
Sigma1];\n         Diag = Transpose[Skal,{1,1}];\n         Sqrt[Outer[Plus, \
Diag, Diag] - 2 Skal]\n         ]\n       \nSkalarProdukt[X_, G_]:= X . G . \
Transpose[X]\n\nShape[A_,p_]:= \n\tModule[{pp,prod,a},\n\t\ta = A;\n\t\t\
If[Length[a]==0, Return[Array[a&,p]]  ];  (*Skalar*)\t\t\n\t\t\
If[Length[p]==1, Return[Flatten[a] ],     (*Vektor*)\n\t\t(*else*)\n\t\t\
If[Length[p]==2, Return[Take[Partition[Flatten[a], p[[2]] ],p[[1]]]],\n\t\t\
(*else*)\n\t\tpp = Drop[p,1]; \n\t    prod = Times @@ pp;\n\t\t(*a = \
Shape[a,{p[[1]],prod}];*)\n\t\ta = Partition[Flatten[a], prod ];\n\t\t\
Map[Shape[#,pp]&, a] \n\t\t]\n\t\t]\t\t\t\n](*End Shape*)\n\n\n\
Shape1[A_,p_,aux_]:= \n\tModule[{n,pp,a},\n\tn = Flatten[A]//Length;\n\tpp = \
Apply[Times,p];\n\tIf[n < pp,a = {A,Shape[aux,{pp-n}]}//Flatten,a = A];\n\t\
Shape[a,p]\n\t]\n\t\n\t\nAddTimeAxis[X_,dt_:1.0]:= Module[{T},\n\t\t\t\t\tT = \
Length[X];\n\t\t\t\t\tAppendRows[Shape[dt Range[0,T-1],{T,1}],X]\n\t\t\t\t  ]\
\nAddTimeAxis[X_,{t0_,t1_,dt_}]:= AppendRows[Spalte[Range[t0,t1,dt] ],X]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["\n\nplot1",
    FontColor->RGBColor[1, 0, 0]],
  "[Data_List,opts___Rule]:= \n\t \n\tModule[{d,d1,dash,Datai,i,ii,gi,g,f,\n\t\
\t\tjoin1,dicke1,frame1,axes1,gestrichelt1,color1,epilog1,aspectratio1,\n\t\t\
\toptionen,display1,farbe1,text1,textcoords,textshift},\n\t     \n\t     \t\t\
\n\t{join1,     dicke1,frame1,axes1,gestrichelt1,color1,display1,       \
farbe1    ,text1,textshift,permute1} = \n\t{PlotJoined,dicke, Frame, Axes, \
gestrichelt, color, DisplayFunction,farbmodell,text, TEXTSHIFT,permute} /. \
{opts} /. Options[plot1];\n\t\t \n If[TensorRank[      dicke1]==0,      \
dicke1 = Array[dicke1&,nnn]]; \n If[TensorRank[gestrichelt1]==0,gestrichelt1 \
= Array[gestrichelt1&,nnn]];\n If[TensorRank[      color1]==0,      color1 = \
Array[color1&,nnn]];  \n  \n  \
(*Print[\"Optionen:{dicke,gestrichelt,color,epilog}\"];*)\n (* \
Print[{join1,dicke1,gestrichelt1,color1,epilog1,aspectratio1}];*)\n \n \
(*gestrichelt1//Print;*)\n \n\t     Farben = {RGBColor[.1,.1,.9],\n\t         \
      RGBColor[.1,.9,.8],\n\t               RGBColor[0.875, 0.202, 0.515],\n\t\
               RGBColor[.4,.3,.6],\n\t               RGBColor[.9,.3,.4],\n\t  \
             RGBColor[.9,.0,.2],\n\t               RGBColor[.4,.0,.9],\n\t\t\t\
       RGBColor[.6,.9,.4],\n\t\t\t       RGBColor[.6,.1,.4],\n\t\t\t       \
RGBColor[.0,.0,.0]};\n\t\t\t            \n\t     Farben = {Blue,\n\t          \
     SpringGreenMedium,\n\t               Red,            \n\t               \
Yellow,\n\t               BlueViolet,\n\t               CadmiumOrange,\n\t    \
           Magenta,\n\t               TurquoiseDark,\n\t               \
VioletRedPale,\n\t               Black};\n\t               \n\t\t If[farbe1 \
=== eigene,    Farben,\n\t\t If[farbe1 === Hue,       Farben = \
Map[Hue,Range[.1,1,.1]//Reverse],\n\t\t If[farbe1 === GrayLevel, Farben = \
Map[GrayLevel,Range[0,.9,.1] ],\n\t\t \t\t\t\t\t                    Farben = \
farbe1 ]]];\n\t     f = Length[Farben];\n\t     color1 = Mod[color1-1,f]+1; \
(* nur zul\[ADoubleDot]ssige Farben*) \n\t     \t\t                   \t\t    \
      \t\t\t\n\t\t dash = Map[Dashing,\n\t\t      \t.01{{   },\n\t\t \t\t     \
  \t{1,1},\n\t\t \t\t       \t{2,4},\n\t            {1,2},\n\t\t\t    \t     \
{4,4},\n\t           \t{4,1},\n\t           \t{1,4},\n\t\t\t   \t\t     \
{1,3,1},\n\t\t\t   \t\t     {.8},\n\t           \t{5,2}\n\t               \t\t\
}];\n\t  f = Length[dash];\n\t  gestrichelt1 = Mod[gestrichelt1-1,f]+1; (* \
nur zul\[ADoubleDot]ssige Muster *) \n\t  \n\t\t \t\t\t\t\t\n\t\t d = \
Dimensions[Data];\n\t\t Print[\"Dimension der Daten  \",d];\n\t\t\t\n\t\t\t \n\
\t\t If[Dimensions[d]=={1}, (* Vektor *)\n\t\t \n\t\t \t\t\tg = \
plot1[Data//Spalte//AddTimeAxis,opts];Return[g], (*rekursiver Aufruf*)\n\t\t \
\t\t\t\n\t\t (* else *)\n\t\t   \n\t\t If[d[[2]]===1, (* Spalten-Vektor *)\n\t\
\t \t  g = plot1[Data//AddTimeAxis,opts];Return[g],         (*rekursiver \
Aufruf*)\n\t\t \t\n\t\t (* else *)\n\t\t \n\t\t d1=d[[1]]//Range;\n\t\t g = \
{};\n\t\t \n\t\t Do[\n\t\t \n\t\t  ii = permute1[[i-1]];\n\t\t \t\n\t\t \t\
Datai = Data[[d1,{1,ii+1}]];\n\t\t \t\n\t\t \t\n\t\t \tlinks  = \
(Datai//First); \n\t\t \trechts = (Datai//Last);\n\t\t \tmitte  =  Datai[[ \
d[[1]]/2//Floor ]];\n\t\t \t\n\t\t \tIf[(text1//Last)===\"Links\", textcoords \
= links,\n\t\t \t\t\t\t\t \n\t\t \tIf[(text1//Last)===\"Rechts\",textcoords = \
rechts,\n\t\t \t\t\t\t\t\t\t\t \n\t\t \tIf[(text1//Last)===\"Mitte\",\t\
textcoords = mitte,\n\t\t \t\n\t\t \tIf[IntegerQ[(text1//Last)],\ttextcoords \
= Datai[[text1//Last]],\n\t\t \t\n\t\t \t                            \
textcoords = rechts\n\t\t \t]]]];\n\t\t \t\t\t\t\t\t\t\t \n\t\t \ttextcoords \
= textcoords + textshift[[ii]];\n\t\t \t\n\t\t \tgi = ListPlot[Datai,\n\t\t \t\
\t\t\t\t       DisplayFunction->Identity,\n\t\t \t\t\t\t  \t     \
PlotJoined->join1,\n\t\t \t\t\t\t  \t     Frame->frame1,\n\t\t \t\t\t\t  \t   \
  Axes->axes1,\n\t\t\t            PlotStyle->{Farben[[color1[[ii]] ]],\n\t\t\t\
                   \t   \tPointSize[ dicke1[[ii]] ],\n\t\t \t\t\t\t\t\t\t     \
            Thickness[ dicke1[[ii]] ],\n\t\t \t\t\t\t\t\t\t                 \
dash[[ gestrichelt1[[ii]] ]],\n\t\t \t\t\t\t\t\t\t                 \
Text[text1[[ii]],textcoords]}\n\t\t \t\t\t\t\t\t\t     \n\t\t \t\t\t\t ];\n\t\
\t \t\n\t\t   \n\t\t    g = Join[g,{gi}];\n\t\t ,{i, 2, d[[2]]}];\n\t\t \t\t \
\t\t\t\t\t\n\t\t];\n\t\t\n\t\tg = \
Show[g,DisplayFunction->display1,FilterOptions[Graphics,opts]];\n\t\n  \
Return[g];\n    \n\t\t];\n\t\t\t\n    \n](*End of plot1*)"
}], "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  CellTags->"plot1"],

Cell[TextData[StyleBox["\t\t\t\nErrorBar[{x_,y_,dy_},dx_] := \n\tModule[{},\n\
\t{\n\tPoint[{x,y}],\n\tLine[{{x,y},{x,y+dy},{x-dx,y+dy},{x+dx,y+dy}}],\n\t\
Line[{{x,y},{x,y-dy},{x-dx,y-dy},{x+dx,y-dy}}]\n\t}\n\t]\n\t\n\t\n\
errorlistplot[data_,opts___]:=\n \n\tModule[{g,dx,point,bar,thick},\n\t\t\t\
{point,bar,thick} = \
{pointsize,barsize,thickness}/.{opts}/.Options[errorlistplot];\n\t\t\tg = \
plot1[Column[data,{1,2}],DisplayFunction->Identity,opts];\n\t\t\tdx = bar \
Max[Abs[Delta[Column[data,{1}]]]];\n\t\t\t\n\t\t\t(*dx//Print;*)\n\t\n\t\t\
Show[g,Graphics[{PointSize[point],Thickness[thick],\n\t\t                 \
Map[ErrorBar[#,dx]&,data]}],\t\n\t\t    \
FilterOptions[Graphics,opts,DisplayFunction :> $DisplayFunction]]]",
  FontWeight->"Plain"]], "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\

generalizederrorlistplot[data_,object_,opts___]:= 
\tModule[{g,dx,point,bar,thick},
\t{point,bar,thick} = {pointsize,barsize,thickness}
\t                       /.{opts}
\t                       /.Options[generalizederrorlistplot];\t\t\t
\tg = plot1[Column[data,{1,2}],DisplayFunction->Identity,opts];
\tdx = .01 Max[Column[data,{1}]];
\tg1 = Graphics[{PointSize[point],Map[object[#,dx]&,data]} ];
\tShow[g,g1,
\t\tDisplayFunction->$DisplayFunction,
\t\tFilterOptions[Graphics,opts]]
\t]
\t\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain"],

Cell["\<\
gray[{x_,y_,dy_},dx_] := {GrayLevel[Mod[dy,1]],Point[{x,y}]}
 hue[{x_,y_,dy_},dx_] := {      Hue[    dy   ],Point[{x,y}]}  \
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["\t\n\t\nphaseplot[Data_List,opts___Rule]:=  \n\t\
Module[{t,p,n,dash,Datai,gi,Farben,g,f,\n\t\t\t\
join1,dicke1,gestrichelt1,color1,epilog1,aspectratio1},\n\t     \t\t\n\t\
{join1,dicke1,gestrichelt1,color1,epilog1,aspectratio1} = \n\t{join, dicke, \
gestrichelt, color, epilog, AspectRatio } /. {opts} /. Options[phaseplot];\n\n\
\tPrint[\"Optionen:  \",{ join,dicke,gestrichelt,color,epilog,AspectRatio}];\n\
  (*Print[{join1,dicke1,gestrichelt1,color1,epilog1,aspectratio1}];*)\n\t     \
Farben = {{.1,.1,.9},\n\t               {.1,.9,.8},\n\t               {0.875, \
0.202, 0.515},\n\t               {.4,.2,.9},\n\t               {.9,.3,.4},\n\t\
               {.9,.0,.2},\n\t               {.4,.0,.9},\n\t\t\t             \
{.6,.9,.4},\n\t\t\t             {.6,.1,.4},\n\t\t\t             {.1,.1,.1}};\n\
\t     f = Length[Farben];                       \t\t          \t\t\t\n\t\t \
dash = Map[Dashing,.01{{   },\n\t\t \t\t\t\t\t                  {1,1},\n\t\t \
\t\t\t\t\t                 \t{2,4},\n\t                         {1,2},\n\t\t\t\
                       {4,4},\n\t                         {4,1},\n\t          \
               {1,4},\n\t\t\t                       {1,3,1},\n\t\t\t          \
             {.1},\n\t                         {.5,2}\n\t                     \
            }];\n\t             \n\t                    \t\t      \t\t\t\t\t\t\
\t\t\n\t\t {t,p,n} = Dimensions[Data];\n\t\t Print[\"Dimension der Daten  \
\",{t,p,n}];\n\t\t g1 = {};\n\t\t Do[\n\t\t \t\n\t\t \tDo[ g = {};\n\t\t \t\t\
Do[\n\t\t \t\t\tDatann = Data[[t//Range,{pp,pp1},nn]];\n\t\t \t\t\tnnn = \
Mod[nn-1,f] + 1;\n\t\t \t\t\tgn = ListPlot[Datann,\n\t\t \t\t\t\t\t\
DisplayFunction->Identity,\n\t\t\t                \
PlotStyle->{RGBColor@@Farben[[color1[[nnn]] ]],\n\t\t\t                   \t\t\
    PointSize[dicke1],\n\t\t \t\t\t\t\t\t\t    Thickness[dicke1],\n\t\t \t\t\t\
\t\t\t\t    dash[[ gestrichelt1[[nnn]] ]] }, \n\t\t \t\t\t\t\tFrame->True,\n\t\
\t \t\t\t\t\tPlotJoined->join1];\n\t\t   \t\t\tg = Join[g,{gn}]  \n\t\t\t\t\
,{nn,1,n}];\n\t\t\t\tg = Show[g,epilog1,DisplayFunction -> $DisplayFunction,\n\
\t\t\t\t\t   \t\t\t   AspectRatio -> aspectratio1];\n\t\t\t    g1 = \
Join[g1,{g}]; \t\n\t\t\t,{pp1,pp+1,p}]\n\t\t,{pp,1,p}];\n\t\n  Return[g1]     \
\n]\n\n\nQQplot//Clear\nQQplot[x_,Distribution_:NormalDistribution[0,1]]:=\n\n\
\tModule[{rx,ry,m,s,k},\n\t\n\tPrint[\"Waehle Verteilung mit \
{E,Var}={0,1}\"];\n\tPrint[\"UniformDistribution[-.5 Sqrt[12],+.5 \
Sqrt[12]]\"];\n\n\t{m,s}=x//MS//Flatten; {m,s}//Print;\n\n\t\
rx=Rank[x]/(Length[x]+1)//N;\n\try=Quantile[Distribution,rx];\n\n\t\
plot1[{x,rx}//Transpose,PlotJoined->False,\n\t\t\t\t\t\tdicke->.01,\n\t\t\t\t\
\t\tPlotLabel->\"empirische Verteilung\"\n\t\t\t\t\t\t];\n\t\t\t\t\t\t\n\t\
k=10;\n\tplot1[{x,ry}//Transpose,PlotJoined->False,\n\t\t\t\t\t\tdicke->.01,\n\
\t\t\t\t\t\tPlotLabel->\"QQ-Plot\"Distribution,\n\t\t\t\t\t\t\
Epilog->Line[{{m-k s,-k},{m+k s,k}}]\n\t\t\t\t\t\t];\n]\n\nQQplot2//Clear\n\
QQplot2[x_,Distribution_:NormalDistribution[0,1]]:=\n\n\t\
Module[{px,qy,m,s,xs,k,n},\n\t\n\tPrint[\"Waehle Verteilung mit {E,Var}={0,1}\
\"];\n\tPrint[\"UniformDistribution[-.5 Sqrt[12],+.5 Sqrt[12]]\"];\n\n\t\
{m,s}=x//MS//Flatten; {m,s}//Print;\n\txs=Sort[x];\n\tn=Length[x];\n\t\
(*px=Range[1-.5,n]/n;*)\n\tpx=Range[1,n]/(n+1);\n\t\
qy=Quantile[Distribution,px];\n\n\t\
plot1[{xs,px}//Transpose,PlotJoined->False,\n\t\t\t\t\t\tdicke->.01,\n\t\t\t\t\
\t\tPlotLabel->\"empirische Verteilung\"\n\t\t\t\t\t\t];\n\t\t\t\t\t\t\n\t\
k=10;\n\tplot1[{xs,qy}//Transpose,PlotJoined->False,\n\t\t\t\t\t\tdicke->.01,\
\n\t\t\t\t\t\tPlotLabel->\"QQ-Plot\"Distribution,\n\t\t\t\t\t\t\
Epilog->Line[{{m-k s,-k},{m+k s,k}}]\n\t\t\t\t\t\t];\n\t\t\t\t\t\t\n\t\
plot1[{Range[1,n]/n,(xs//CumulativeSums)/(n m)}//Transpose,\n\t     \
PlotJoined->False,\n\t\t\t\t\t\tdicke->.01,\n\t\t\t\t\t\t\
PlotLabel->\"Konzentration\",\n\t\t\t\t\t\tEpilog->Line[{{0,0},{1,1}}]\n\t\t\t\
\t\t\t];\n]\n\nNotPosition[List_,pattern_] := \n\t\
Delete[List//Length//Range,Position[List,pattern]];\n\nCompress[a_,b_]:= \
Delete[b,Position[a,False]];\n\nAPLExpand[x_,y_]:= \
MapThread[Shape[#1,#2]&,{y,x}]\n\nlocate[b_] := Flatten@Position[b, True];\n\n\
Locate[b_,what_:True] := Flatten@Position[b, what];\n\neq[x_,y_]:= x == y; \
SetAttributes[eq,Listable];\nne[x_,y_]:= x != y; SetAttributes[ne,Listable];\n\
gr[x_,y_]:= x >  y; SetAttributes[gr,Listable];\nge[x_,y_]:= x >= y; \
SetAttributes[ge,Listable];\nlt[x_,y_]:= x <  y; SetAttributes[lt,Listable];\n\
le[x_,y_]:= x <= y; SetAttributes[le,Listable];\n\nunsameq[x__] := \
UnsameQ[x]; SetAttributes[unsameq,{Listable}];\n  sameq[x__] :=   SameQ[x]; \
SetAttributes[  sameq,{Listable}];\n\nReplaceColumns[a_,i_,b_,j_] :=\n\t\
Transpose @ ReplacePart[Transpose[a],Transpose[b][[j]],i]\n\t\n\
ColumnSelect[a_,i_] := Map[Part[#,i]&,a]\n\nMatrixTrace[A_] := Plus @@ \
Transpose[A,{1,1}];\n\nii := AppendRows\n\nvv := AppendColumns\n\n\
Spalte[x_]:= Shape[x,{Length[x],1}]\n\nHadamard[a_,op_,b_] := \n\t\
Module[{n,res,i},\n\t\tn = Length[a];\n\t\tres = {};\n\t\tDo[res = \
Append[res,op[a[[i]],b[[i]]]],{i,1,n}];\n\t\tres\n\t]\n\t\nDelta[x_,lag_:1] \
:= Drop[x,lag] - Drop[x,-lag]\n\nDelta[x_,y_,op_,lag_:1]:= \
MapThread[op,{Drop[x,lag],Drop[y,-lag]}]\n\nlistplay[list_,rate_] := \n\t\
SampledSoundList[list/(Max[Abs[list]]//N),SampleRate/.rate]//Sound//Show\n\t\n\
Kontingenz[h_,Hyp_,PR_:True] := \n\t\
Module[{hi,hj,n,H,F,f,hs,fij,ChiQuadrat,K,m,kmax,Kplus},\n\t\t\
hi=Apply[Plus,h,2];\n\t\thj=Apply[Plus,h];\n\t\tn = Plus @@ hi;\n\t\tH = \
Append[h,hj] ~ii~ Spalte[Append[hi,n]]; \n\t\tF = H/n//N;\n\t\tf =h/n;\n\t\t\
hs = Outer[Times,hi,hj]/n//N;\n\t\tfij = hs/n//N;\n\t\tfjbedi = h/hi;\n\t\t\
fibedj = (h//Transpose)/hj//Transpose;\n\t\tChiQuadrat = Plus @@ Plus @@ ((h \
- hs)^2/hs)//N;\n\t\tK = Sqrt[ChiQuadrat/(ChiQuadrat+n)];\n\t\tm = \
Min[Dimensions[h]];\n\t\tkmax = Sqrt[(m-1)/m];\n\t\tKplus = K/kmax//N;\n\t\t\
kappa = 1 - (Plus @@ Plus @@ (f *(1-Hyp) ))\n\t\t\t       /(Plus @@ Plus @@ \
(fij(1-Hyp) ));\n\t\t\t       \n\t\tIf[PR,\n\t\t\n\t\tPrint[\"absolute H\
\[ADoubleDot]ufigkeiten  \"];\n\t\tPrint[\"  \"];\n\t\tPrint[H//MatrixForm];\n\
\t\tPrint[\"  \"];\n\t\tPrint[\"relative H\[ADoubleDot]ufigkeiten  \"];\n\t\t\
Print[\"  \"];\n\t\tPrint[N[F,2]//MatrixForm];\n\t\tPrint[\"  \"];\n\t\t\
Print[\"Unabh\[ADoubleDot]ngigkeitstafel fi. f.j  \"];\n\t\tPrint[\"  \"];\n\t\
\tPrint[fij//MatrixForm];\n\t\tPrint[\"  \"];\n\t\tPrint[\"bedingte relative \
H\[ADoubleDot]ufigkeiten \"];\n\t\tPrint[fjbedi//N//MatrixForm,\"      \
\",fibedj//N//MatrixForm];\t\n\t\tPrint[\"  \"];\n\t\tPrint[\"ChiQuadrat,  \
Kontingenzkoeff.,  K+ \"];\n\t\tPrint[\"  \"];\n\t\tPrint[ChiQuadrat,\"      \
\",K,\"       \",Kplus];\n\t\tPrint[\"  \"];\n\t\tPrint[\"Hypothese, Cohen \
Kappa \"];\n\t\tPrint[\"  \"];\n\t\tPrint[Hyp//MatrixForm,\"      \",kappa];\n\
\t\t];\n\t\t\n\t\t{\"ChiQuadrat\"->ChiQuadrat,\n\t\t \"K\"->K,\n\t\t \
\"Kplus\"->Kplus,\n\t\t \"kappa\"->kappa}\n\n]\n\nHistogramm[x_,Klassen_]:= \n\
\tModule[{F,f,logic,xx,n},\n\t\txx = x//Flatten;\n\t\tn = xx//Length;\n\t\t\
logic={True->1,False->0};\n\t\tF = (Plus @@ (Outer[le,xx,Klassen]/.logic))/n; \
 (* Klassen ( ] *)\n\t\tf = Delta[{0} ~Join~ F,1];\n\t\t{Klassen,f,F}\n\t]\n\n\
\nHistogramm1[x_,Klassen_]:= \n\tModule[{F,f,logic,xx,n},\n\t\txx = \
x//Flatten;\n\t\tn = xx//Length;\n\t\tlogic={True->1,False->0};\n\t\tF = \
(Plus @@ (Outer[lt,xx,Klassen]/.logic))/n; (* Klassen [ ) *)\n\t\tf = \
Delta[{0} ~Join~ F,1];\n\t\t{Klassen,f,F}\n\t]\n\t\t\nRank[x_] := \
Map[(Apply[Plus,#]/Length[#])&,Map[Locate[Sort[x],#]&,x] ] \n\n\
PlatzInUngeordneterListe[x_]:=Map[First,Map[Locate[x,#]&,Sort[x]]]\n\n\
PlatzInUngeordneterListe1[x_]:=\n\t\tModule[{x1},\n\t\t\t\
x1={x,Range[x//Length]}//Transpose;\n\t\t\t\
x1=Sort[x1,Less[Part[#1,1],Part[#2,1]]&];\n\t\t\tColumn[x1,2]\n]\n\n\
GaussCumul[x_,mue_,sigma_]:= (Erf[(x-mue)/(Sqrt[2.] sigma)] + 1.)*0.5\n\n\
all[A_] := And@@Flatten[A];\n\nany[A_] := Or@@Flatten[A];\n\t\t\nfunk[x_]:= \
Par[x]\n\nflatten[a_,ijk_] := Module[{i,k,c,perm,b,p},\n\ti = ijk // First;\n\
\tk = TensorRank[a]//Range;\n\tc = Complement[k,ijk];\n\tperm = \
Map[Part[#,2]&,Sort[{Join[ijk,c],k}//Transpose]];\n\tb = \
Flatten[Transpose[a,perm],Length[ijk]-1];\n\t(* Print[b // Dimensions];*)\n\t\
p = Range[Length[c] + 1];\n\tp = Join[{i},Complement[p,{i}]];\n\t\
Transpose[b,p]\n\t]\n\t\nflatten[a_] := Flatten[a]\n\n",
    FontWeight->"Plain"],
  StyleBox["FlattenSymmetric",
    FontWeight->"Plain",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox["[A_]:= \n\tModule[{p=Length[A]//Range,ij,index},\n\tindex = \
Outer[List,p,p];\n\tij = Position[index, {i_,j_}/;i>j];\n\t\
Delete[A,ij]//Flatten]\n\t\nSelectIndex[a_,op_]:= \n\tModule[{f,a1},\n\tf = \
If[op[ #2[[1]],#2[[2]] ],#1,{}]&;\n\ta1 = MapIndexed[f, a,{2}];\n\t\
Map[Flatten,a1]\n\t]\n\t\t\t\nFlattenSymmetric1[A_]:= \
SelectIndex[A,LessEqual]//Flatten\n\nobere[p_,op_]:= Module[{i = \
Shape[Range[p^2],{p,p}]},\n\tLocate[(i~op~Transpose[i])//Flatten,True]]\n\n\
FlattenSymmetric2[A_]:= (A//Flatten)[[obere[Length[A],le]]]\t\n\n",
    FontWeight->"Plain"],
  StyleBox["SymmetricMatrix[vec_,p_,opt_:\"obere\"]:=Module[{n,A},\n\tn=0;\n\t\
A=Shape[0,{p,p}];\n    If[opt==\"obere\",\n        Do[A[[i,j]]= \
A[[j,i]]=vec[[n+=1]]; ,{i,p},{j,i,p}],\n        Do[A[[i,j]]= \
A[[j,i]]=vec[[n+=1]]; ,{i,p},{j,1,i}]\n        ];\n    A\n    ]",
    FontWeight->"Plain",
    FontVariations->{"CompatibilityType"->0}],
  StyleBox["\n\n\njoin[x_,y_,axis_:1] := Module[{perm,xy},\n\n\tperm = \
x//TensorRank//Range;\n\tperm[[1]] = axis;\n\tperm[[axis]] = 1;\n\txy = \
Join[Transpose[x,perm],Transpose[y,perm]];\n\txy = Transpose[xy,perm]\n\t]\n\t\
\nTridiagonalMatrix//Clear\nTridiagonalMatrix[{a1_,a2_,a3_}] :=\n\t\
Module[{n,i,j},\n\tn = Length[a2];\n\tTable[Switch[j-i,-1,a1[[j]],\n\t\t\t\t\t\
  0,a2[[i]],\n\t\t\t\t\t  1,a3[[i]],\n\t\t\t\t\t  _,0]     ,{i,1,n},{j,1,n}]\n\
\t]\n\nTridiagonalMult[{a_,b_,c_},x_] := \n\tModule[{xa,xc},\n\txa = \
RotateRight[x]; xa[[1]] = 0;\n\txc = RotateLeft [x]; xc[[Length[x]]] = 0;\n   \
 a xa + b x + c xc\n    ]\n\nTridiagonalMult[{a_,b_,c_},x_,periodisch_] := \n\
\ta RotateRight[x] + b x + c RotateLeft[x] \n\nVecDiag = Transpose[#,{1,1}]& \
\n\nBlockDiagonalMatrix[{a_List}] := a;\n\n\
BlockDiagonalMatrix[{a_List,b_List}] := Module[{a1,a2,null1,null2},\n\t\
{a1,a2} = Dimensions[a];\n    {b1,b2} = Dimensions[b];\n\tnull1 = \
Shape[0,{a1,b2}];\n\tnull2 = Shape[0,{b1,a2}];\n\t\
BlockMatrix[{{a,null1},{null2,b}}]]\n\t\t\nBlockDiagonalMatrix[x_List] := \
Module[{},\n\thilf = BlockDiagonalMatrix[Drop[x,-1]];\n\t\
BlockDiagonalMatrix[{hilf,x//Last}]]\n\nBlockDiagTimesMatrix[a_,B_] := \n\t\
Module[{BB,n,p,np},\n\t{n,p,p} = a//Dimensions;\n\t{np,u}  = B//Dimensions;\n\
\tBB = Shape[B,{n,p,u}];\n\tBB = MapThread[Dot,{a,BB}]; (* n x p x u *)\n\t\
flatten[BB,{1,2}]\n\t]",
    FontWeight->"Plain"]
}], "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[StyleBox["KernDichtePlot//Clear\n\
KernDichtePlot[data_,opts___]:=\n\t\n\tModule[{sm,gf,m,s,ksigma,x},\n\t\n\tsm \
= smoothQuickAndDirty[data//Spalte];\n\tgf = GaussFaktor[sm,1];(*gf//Print;*)\
\n\tm=data//Mean;\n\ts=data//StandardDeviation; \n\tPrint[\"smooth = \",sm,\" \
 mean = \",m,\"  std = \",s];\n\tksigma=5;\n\t\
Plot[KernDichte[x,data//Spalte,{GaussKernO,gf},sm,Plus]//Evaluate,\n\t\t\t    \
    {x,m-ksigma s,m+ksigma s},\n\t\t\t        opts,\n\t\t        \t\
DisplayFunction->$DisplayFunction,\n\t\t        \t\
PlotStyle->{Hue[.0],Thickness[.005]}]\n\t];\n\t",
  FontWeight->"Plain"]], "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
univariate//Clear
univariate[data_,opts___Rule] :=
\t\t\t 
\tModule[{x1,x2,dx,x,range,freq,m,out,Minimum,Maximum,mm,ss,
\t        g1,g2,g3,g4,gcum,cat,f,F,hist,
\t        bars,plots,draw,ksigma,minmax,pr,data1,y},
       
\t{bars,plots,           draw,ksigma,cat,pr} = 
\t{Bars,Plots,DisplayFunction,Ksigma,CAT,PR}
\t                            /. {opts} /. Options[univariate];
\t                            
\t{bars,plots,draw,ksigma}//Print;
\t\t
\t{Minimum,Maximum} = {data//Min,data//Max};
\t
\tIf[cat===Automatic,
\t
\t\t{x1,x2} = {Minimum,Maximum};
\t\t dx=(x2-x1)/(bars-1)//N;
\t\t cat=Range[x1-dx/2,x2+dx/2,dx]
\t\t \t\t
\t];
\t\t 
\t
   {cat,f,F}=Histogramm1[data,cat];
\t
\t
\tout = Join[ LocationReport[data],
\t\t \t\tDispersionReport[data],
\t\t \t\tShapeReport[data],
\t\t \t\t{Quartiles->Quartiles[data]},
\t\t \t\t{MinMax->{Minimum,Maximum}}   ];
\t\t \t\t
\tPrint[out//MatrixForm];
\t
\tmm = Mean/.out;
\tss = StandardDeviation/.out;
\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t
\tIf[ss == 0, 
\t\tss = .001;
\t\tg2 = Plot[PDF[NormalDistribution[mm,ss],x]//Evaluate,
\t\t\t\t\t{x,mm-10,mm+10},
\t\t\t\t\tPlotStyle->{Hue[.8]},
\t\t\t\t\tPlotRange->All,
\t\t\t\t\tPlotLabel->\"Delta function\",
\t\t\t\t\tDisplayFunction->draw];
\t\tReturn[g2]
\t];
\t
\t\t
\tIf[plots[[1]],
\t\t{g1,gcum,hist} = HistogrammChart[{cat,f,F},DisplayFunction->Identity];
\t\tIf[pr,hist//N4//Print];
\t];
\t\t\t\t\t\t\t
\t
\tIf[plots[[2]],\t\t\t\t\t
\tg2 = Plot[PDF[NormalDistribution[mm,ss],x]//Evaluate,
\t\t\t\t{x,mm-ksigma ss,mm+ksigma ss},
\t\t\t\tDisplayFunction->Identity,
\t\t\t\tPlotStyle->{{Hue[.8],Thickness[.001]}},
\t\t\t\tPlotRange->All]];
\t
\tIf[plots[[3]],\t\t\t
\tsm = smoothQuickAndDirty[data//Spalte];
\tPrint[\"smooth = \",sm];
\tgf = GaussFaktor[sm,1];(*gf//Print;*)
\t
\tg3 = Plot[KernDichte[x,data//Spalte,{GaussKernO,gf},sm,Plus]//Evaluate,
\t\t\t{x,mm-ksigma ss,mm+ksigma ss},
\t\t\tDisplayFunction->Identity,
\t\t\tPlotStyle->{{Hue[.4],Thickness[.001]}},
\t\t\tPlotRange->All]];
\t
\t
\t
\tIf[plots[[4]],
\t
\ty=0.;
\tdata1=Table[{data[[i]],If[data[[i-1]]===data[[i]],y=y+.02,
\t                                                  y=0.;y]},
\t            {i,1,Length[data]}];
\t            
\tg4=plot1[data1,FilterOptions[plot1,opts],
\t               PlotJoined->False,
\t               dicke->.02,
\t               DisplayFunction->Identity]
\t ];\t
\t \t\t\t
\tShow[Sequence[Compress[plots,{g1,g2,g3,g4}]],
\t\t\t\t\t\t\tDisplayFunction->draw,
\t\t\t\t\t\t\tFilterOptions[Graphics,opts]
\t\t]
\t(*out*)  (*returns graphics*)
]
\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain",
  CellTags->"univariate"],

Cell[TextData[StyleBox["\nunivariatealt[data_,opts___Rule] :=\n\t\t\t \n\t\
Module[{x1,x2,dx,x,range,freq,m,out,Minimum,Maximum,mm,ss,\n\t        \
g1,g2,g3,g4,\n\t        bars,plots,draw,ksigma},\n       \n\t\
{bars,plots,draw,ksigma} = {Bars,Plots,DisplayFunction,Ksigma}/. {opts} /. \
Options[univariate];\n\t{bars,plots,draw,ksigma}//Print;\t\n\t\
{Minimum,Maximum} = {data//Min,data//Max};\n\t{x1,x2} = {Minimum,Maximum};\n\t\
dx = (x2-x1)/N[bars-1];\n\tfreq = \
BinCounts[data,{x1-dx/2,x2+dx/2,dx}]/Length[data];\n\tm = Length[freq];\n\t\
range = x1 + Range[0,m-1]dx;\n\t(*\t\n\t{x1,x2,dx}//Print;\n\t\
range//Dimensions//Print;\n\tm//Print;\n\t*)\n\t\
(*Print[{range//Length,freq//Length,m}];*)\n\t\
(*Print[{range,freq,Shape[dx,{m}]}];*)\n\t\n\tout = Join[ \
LocationReport[data],\n\t\t \t\tDispersionReport[data],\n\t\t \t\t\
ShapeReport[data],\n\t\t \t\t{Quartiles->Quartiles[data]},\n\t\t \t\t\
{MinMax->{Minimum,Maximum}}   ];\n\tPrint[out//MatrixForm];\n\t\n\tmm = \
Mean/.out;\n\tss = StandardDeviation/.out;\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\
\n\tIf[ss == 0, \n\t\tss = .001;\n\t\tg2 = \
Plot[PDF[NormalDistribution[mm,ss],x]//Evaluate,\n\t\t\t\t\t{x,mm-10,mm+10},\n\
\t\t\t\t\tPlotStyle->{Hue[.8]},\n\t\t\t\t\tPlotRange->All,\n\t\t\t\t\t\
PlotLabel->\"Delta function\",\n\t\t\t\t\tDisplayFunction->draw];\n\t\t\
Return[g2]\n\t];\n\t\n\t\
(*Print[{range,freq}//N//Chop//Transpose//MatrixForm];*)\n\t\n\t\
If[plots[[1]],\n\tg1 = \
GeneralizedBarChart[{range,freq/dx,Shape[dx,{m}]}//Transpose,\t\t\t\t\t\t\n\t\
\t\t\t\t\t\tDisplayFunction->Identity,\n\t\t\t\t\t\t\tPlotRange->All,\n\t\t\t\
\t\t\t\tBarStyle->(Hue[.0]&),\n\t\t\t\t\t\t\tBarEdges->True,\n\t\t\t\t\t\t\t\
FilterOptions[Graphics,opts]\n\t\t\t\t\t\t\t]];\n\t\t\t\t\t\t\t\n\t\n\t\
If[plots[[2]],\t\t\t\t\t\n\tg2 = \
Plot[PDF[NormalDistribution[mm,ss],x]//Evaluate,\n\t\t\t\t{x,mm-ksigma \
ss,mm+ksigma ss},\n\t\t\t\tDisplayFunction->Identity,\n\t\t\t\t\
PlotStyle->{{Hue[.8],Thickness[.001]}},\n\t\t\t\tPlotRange->All]];\n\t\n\t\
If[plots[[3]],\t\t\t\n\tsm = smoothQuickAndDirty[data//Spalte];\n\t\
Print[\"smooth = \",sm];\n\tgf = GaussFaktor[sm,1];(*gf//Print;*)\n\t\n\tg3 = \
Plot[KernDichte[x,data//Spalte,{GaussKernO,gf},sm,Plus]//Evaluate,\n\t\t\t\
{x,mm-ksigma ss,mm+ksigma ss},\n\t\t\tDisplayFunction->Identity,\n\t\t\t\
PlotStyle->{{Hue[.4],Thickness[.001]}},\n\t\t\tPlotRange->All]];\n\t\t\t\n\t\
If[plots[[4]],\n\tg4=plot1[Map[{#,0}&,data],FilterOptions[plot1,opts],\n\t    \
                      PlotJoined->False,\n\t                          \
dicke->.03,\n\t                          DisplayFunction->Identity]\n\t ];\t\t\
\t\t\n\tShow[Sequence[Compress[plots,{g1,g2,g3,g4}]],\n\t\t\t\t\t\t\t\
DisplayFunction->draw,\n\t\t\t\t\t\t\tFilterOptions[Graphics,opts]\n\t\t]\n\t\
(*out*)  (*returns graphics*)\n]\n",
  FontWeight->"Plain"]], "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\

position[a_,cond_] := Position[Map[cond,a,{Depth[a]-1}],True];

StreifenDiagramm//Clear;
StreifenDiagramm[data_,yrange_:1] := 
\tModule[{n},
\t\tn = Length[data];
\t\tGeneralizedBarChart[
\t\t{Range[0,n-1],data,Shape[.3,{n}]}//Transpose,
\t\t\tPlotRange->{{-1,n+1},{0,yrange}}
\t\t\t ] 
\t]
\t
StreifenDiagramm[data_,yrange_:1,cat_] := 
\tModule[{n,breite},
\t\tn = Length[data];
\t\tbreite = Shape[.3,{n}];
\t\tGeneralizedBarChart[
\t\t\t{cat,data,breite}//Transpose,
\t\t\t\tPlotRange->{{First[cat]-1,Last[cat]+1},{0,yrange}}
\t\t\t ] 
\t]\t\t
StreifenDiagrammQuer[data_,yrange_:1,cat_] := 
\tModule[{n,breite},
\t\tn = Length[data];
\t\tbreite = Shape[.3,{n}];
\t\tGeneralizedBarChart[
\t\t\t{cat,data,breite}//Transpose,
\t\t\t\tPlotRange->{{0,yrange},{First[cat]-1,Last[cat]+1}},
\t\t\t\tBarOrientation->Horizontal
\t\t\t ] 
\t]
\t\t\t
CumulatedBarChart//Clear;
CumulatedBarChart[data_] := Module[{n},
\tn = Length[data];
\tGeneralizedBarChart[
\t\t{Range[0,n-1]+.5,data,Shape[1,{n}]}//Transpose,
\t\t\tPlotRange->{{-1,n+1},{0,1}} ] ]\
\>", "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Plain"],

Cell[TextData[StyleBox["\t\t\t\nHistogrammChart//Clear;\n\
HistogrammChart[{cat_,f_,F_},opts___] := \n\n\
Module[{breite,catmitte,hoehe,min,max,g1,g2,pr},\n\n\tbreite = cat//Delta;\n\t\
catmitte = (Drop[cat,1]+Drop[cat,-1])/2;\n\thoehe = Drop[f,1]/breite;\n\t\
range = (Max[cat]-Min[cat])/10;\n\t\n\t\
pr={Delta[cat,cat,List,-1],f//Rest,F//Rest,catmitte,hoehe,breite}\n\t    \
//Transpose//MatrixForm;\n\n\tg1=GeneralizedBarChart[\n\t\t\
{catmitte,hoehe,breite}//Transpose,\n\t\t\tPlotRange->{{min = \
Min[cat]-range,max = range+Max[cat]},\n\t\t\t\t\t\t{0,1.5 Max[hoehe]}},opts];\
\n\t\t\t\t\t\t\n\tg2=plot1[{Join[{min},cat,{max}],\n\t   \t   \
Join[{0},F,{1}]}//Transpose,\n\t   \t   dicke -> .01,PlotRange->All,opts];\n\t\
\n\tReturn[{g1,g2,pr}]   \t    \n]",
  FontWeight->"Plain"]], "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  CellTags->"HistogrammChart"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["CuMean[x_,Op_:Plus]:= \n\tFoldList[Op, x//First, \
Drop[x,1]]/Range[1,Length[x]]\n\t\nDurbinWatson[inno_]:=\n\n\
Module[{Dinno=Delta[inno],T,p},\n\n{T,p}=inno//Dimensions;\n\
MatrixTrace[Inverse[Transpose[Drop[inno,-1]].Drop[inno,-1]].\n            \
(Transpose[Dinno].Dinno)]/p\n]\n\n\t\nMultivariateRegression//Clear;\n\
MultivariateRegression[Y_,X_]:=\n \n\
Module[{XS,G,Xm,Bdach,Ydach,Udach,Sigmadach,VarB,STD,n,p,q,\n        \
D,dUdach,DurbinWatsonTrace},\n        \n{n,p} = Dimensions[Y];\n{n,q} = \
Dimensions[X];\nXS = Transpose[X];\nG = XS.X //Inverse;\nXm = G.XS;\n(*Xm = \
PseudoInverse[X]*)\n(*Q = X.Xm;*)\nBdach = Xm.Y;\nYdach = X.Bdach;\nUdach = Y \
- Ydach;\nSigmadach = (1/n)Transpose[Udach].Udach;\nVarB = \
KroneckerProduct[Sigmadach,G];  (* Var[col B] *)\nSTD = VecDiag[VarB]//Sqrt;\n\
STD = Shape[STD,{p,q}]//Transpose;\n\ndUdach = Delta[Udach,-1];\nD = \
Inverse[n Sigmadach].(Transpose[dUdach].dUdach);\nDurbinWatsonTrace=(1./p) \
MatrixTrace[D];\n\n{Bdach,STD,VarB,Sigmadach,n/(n-q) \
Sigmadach,DurbinWatsonTrace}\n]\n\nEinfachRegression//Clear;\n\
EinfachRegression[y_,x_] :=\n \n\
Module[{X,Y,Bdach,STD,VarB,Sigmadach,SigmadachU},\nX = \
{Shape[1,{x//Length}],x}//Transpose;\nY = y//Spalte;\n\
{Bdach,STD,VarB,Sigmadach,SigmadachU} = MultivariateRegression[Y,X];\n\
{Bdach//Flatten,STD//Flatten,VarB,Sigmadach[[1,1]],SigmadachU[[1,1]]}]\n\n\n\
EinfachRegressionSequentiell//Clear\nEinfachRegressionSequentiell[y_,x_]:= \n\
\tModule[{xq,yq,sxy,mxx,sxx,syy,bdach,adach,MQRml,MQRu,\n\t\t\t\t\t\t\t\t\t\
nsxx,varaml,varbml},\n\tOff[Power::infy];\n\tOff[Infinity::indet];\n\txq    = \
CuMean[x,Plus];\n\tyq    = CuMean[y,Plus];\n\tsxy   = CuMean[x y,Plus] - xq \
yq;\n\tmxx   = CuMean[x x,Plus];\n\tsxx   = mxx - xq ^2;\n\tsyy   = CuMean[y \
y,Plus] - yq ^2;\n\tbdach = sxy/sxx;\n\tadach = yq - bdach xq;\n\tMQRml = syy \
- bdach^2 sxx;\n\tMQRu  = MQRml*Table[n/(n-2),{n,1,Length[y]}];\n\tnsxx  = \
Table[n,{n,1,Length[y]}]*sxx;\n\tvaraml= MQRml mxx/nsxx;\n\tvarbml= MQRml \
/nsxx;\n\tOn[Power::infy];\n\tOn[Infinity::indet];\n\t\n\t\
{{adach,bdach},{varaml,varbml},{MQRml,MQRu}}\n\t\n\t]\n\t\nmax[x__] := \
Max[x]; SetAttributes[max,Listable];\nmin[x__] := Min[x]; \
SetAttributes[min,Listable];\n\nHeaviside//Clear\nHeaviside[x_] := \
(Sign[x]+1)/2;\nSetAttributes[Heaviside,Listable];\n\n\
OrnsteinUhlenbeck[y_,x_,t_,a_,omega_]:=\n\tModule[{m,s2},\n\tm = x Exp[a t];\n\
\ts2 = -omega/2a *(1-Exp[2 a t]);\n\tPDF[NormalDistribution[m,s2//Sqrt],y]\n\
];\n\n\nGaussDichte[x_,{mue_,sigma_,sigma1_}]:= \n\tModule[{z = x-mue}, \n\t\
Det[2 Pi sigma]^(-.5) Exp[-.5 z.sigma1.z]//N\n\t];\n\t\n\t\
GaussDichte[x_,{mue_,sigma_}]:= \n\tModule[{z = x-mue}, \n\tDet[2 Pi \
sigma]^(-.5) Exp[-.5 z.(sigma//Inverse).z]//N\n\t];\n\n\
GaussDichte[x_,{mue_,sigma_?ScalarQ}]:= \n\tModule[{z = x-mue}, \n\t(2 Pi \
sigma)^(-.5 Length[{x}//Flatten]) Exp[-.5 (z.z)/sigma]//N\n\t];\n\n\
GaussDichte[x_?ScalarQ,{mue_?ScalarQ,sigma_?ScalarQ}]:= \n\tModule[{z = \
x-mue}, \n\t(2 Pi sigma)^(-.5) Exp[-.5 (z*z)/sigma]//N\n\t];\n\nScalarQ = \
(TensorRank[#]==0)&\t\n\nDyad[x_]:= Outer[Times,x,x]\t\n\nDyad[x_,y_]:= \
Outer[Times,x,y]\t\n\t\t\t\t\nTF = {True->1.,False->0.}\n\nIndikator \
[{a_,b_},x_] := Apply[UnitStep,{x-a,b-x}//Flatten]\n\n\
Indikator1[{a_,b_},x_]:= Apply[Times,ge[x,a]/.TF]*Apply[Times,le[x,b]/.TF]\n\n\
Indikator2[{a_,b_},x_]:= Apply[And,ge[x,a]]~And~Apply[And,le[x,b]]/.TF\n\n\
Indikator3[{a_,b_},x_]:= Apply[And,{ge[x,a],le[x,b]}//Flatten]/.TF\n\n\
MatrixForm2List[m_]:= m /. MatrixForm->List //First\n\nTableForm2List[m_]:= m \
/. TableForm->List //First\n\npNorm[x_,p_:2]:= Apply[Plus,Abs[x]^p]^(1/p)\n\n\
RandomMultinomial//Clear\nRandomMultinomial[xij_,pij_,n_]:= \n\t\
Module[{u,pos,pcum},\n\tpcum = CumulativeSums[{0,pij}//Flatten];\n    pcum = \
pcum/Last[pcum]; \n    Table[\n\tu = Random[];\n\tpos = \
Position[le[u,pcum],False]//Last;\n\txij[[pos]]//Flatten,{n}]\n\t]\n\n\
RandomNumbers//Clear\n\
(***************************************************************)\t\t\t \n\
RandomNumbers[{x1_,x2_,dx_},density_,n_]:= \n\
(***************************************************************)\t\t\t \n\
Module[{range,z,xij,pij},\nrange = MapThread[Range[##]&,{x1,x2,dx}];\nxij = \
Flatten[Apply[Outer[List,##]&,range],Length[range]-1];\npij = \
Map[density[##]&,xij] Apply[Times,dx]//Chop;\n\n(*\nPrint[\"xij  \",xij];\n\
Print[\"pij  \",pij]; \n*)\n\nz = Apply[Plus,pij];\nPrint[\"RandomNumbers: \
Normierung  \",z];\nIf[z == 0,Print[\"Warnung: Gleichverteilung benutzt\"];\n\
\t\t  Print[\"pij  \",pij]; \n\t\t  pij = pij + 1./Length[pij]; z=1];\n\n\
{z,RandomMultinomial[xij,pij/z,n]}\n]\n\nLogistic[x_]:= Module[{xx=Exp[-x]}, \
1/(1+xx)]\nLogit[p_]:= Log[p/(1-p)]\nProbit[p_]:= \
Quantile[NormalDistribution[0,1],p]\nProbit1[p_]:= Sqrt[2] \
InverseErf[-Infinity,2 p] //N\n\nSetAttributes[Logistic,Listable];\n\
SetAttributes[Logit,Listable];\nSetAttributes[Probit,Listable];\n\
SetAttributes[Probit1,Listable];\n\nplognormal//Clear\n\
plognormal[y_,{nue_,gamma_}]:=(1/y) \
PDF[NormalDistribution[nue,gamma],Log[y]]/; y>0\n\
plognormal[y_,{nue_,gamma_}]:=0/; y<=0 \n \n\n\
plognormal[y_,y0_,{nue_,gamma_}]:=(1/y) \
PDF[NormalDistribution[nue,gamma],Log[y/y0]]/; y>0 \n\
plognormal[y_,y0_,{nue_,gamma_}]:=0/; y<=0 \n\n\n\
tupel[x_,n_,op_:List]:=Flatten[Outer[op,Sequence@@Table[x,{i,n}]],n-1]\n\n\
Einheitsvektor[x_]:=x/Sqrt[x.x]\n\nEigensystem1[A_]:=\n\tModule[{Q,P,lambda},\
\n\t{lambda,P}=Eigensystem[A];\n\tQ=Map[Einheitsvektor,P]//Transpose; \
(*A=Q.Lambda.Q'*)\n\t{lambda,Q}]\n\t\n\nEnd[ ] (*private*)\n \nProtect[Names[\
\"code`Kronecker`*\"]//Evaluate];\n\t\t\t\t \nEndPackage[ ]\n\n\
<<code`KernDichte` (*Da Funktionen aus Kronecker benutzt werden,\n            \
            die Anfangs noch nicht bekannt sind -\n                        \
zirkul\[ADoubleDot]re Definition*)",
  FontWeight->"Plain"]], "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[OutputFormData["\<\
EndPackage[]\
\>", "\<\
EndPackage[]\
\>"], "Output",
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Names[\"code`Kronecker`*\"]", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({"AddTimeAxis", "all", "any", "APLExpand", "autocorr", "Autokorr", 
      "Autokorr1", "Autokorr1M", "AutokorrM", "Bars", "barsize", 
      "BlockDiagonalMatrix", "BlockDiagTimesMatrix", "CAT", "color", 
      "ColumnSelect", "Compress", "Correlation", "CuMean", 
      "CumulatedBarChart", "Delta", "dicke", "DurbinWatson", "Dyad", 
      "eigene", "Eigensystem1", "EinfachRegression", 
      "EinfachRegressionSequentiell", "Einheitsvektor", "epilog", "eq", 
      "ErrorBar", "errorlistplot", "farbmodell", "flatten", 
      "FlattenSymmetric", "FlattenSymmetric1", "FlattenSymmetric2", "funk", 
      "Gauss", "GaussC", "GaussCumul", "GaussDichte", "ge", 
      "generalizederrorlistplot", "gestrichelt", "gr", "gray", "Hadamard", 
      "Heaviside", "Histogramm", "Histogramm1", "HistogrammChart", "hue", 
      "ii", "ii$", "Indikator", "Indikator1", "Indikator2", "Indikator3", 
      "J", "join", "KernDichtePlot", "Kontingenz", "KroneckerProduct", 
      "Ksigma", "le", "listplay", "locate", "Locate", "Logistic", "Logit", 
      "lt", "MahalanobisDistanz", "MatrixForm2List", "MatrixTrace", "max", 
      "max$", "mean", "min", "MinMax", "min$", "MS", "MS1", "MS2", 
      "MultivariateRegression", "ne", "nnn", "NotPosition", 
      "OrnsteinUhlenbeck", "P2", "P2C", "permute", "phaseplot", 
      "PlatzInUngeordneterListe", "PlatzInUngeordneterListe1", "plognormal", 
      "plot1", "PlotLabelsX", "PlotLabelsY", "Plots", "pNorm", "pointsize", 
      "position", "PR", "Probit", "Probit1", "QQplot", "QQplot2", 
      "RandomGauss", "RandomMultinomial", "RandomNumbers", "Rank", 
      "ReplaceColumns", "sameq", "ScalarQ", "SelectIndex", "Shape", "Shape1", 
      "Sigma2Corr", "SkalarProdukt", "Spalte", "StreifenDiagramm", 
      "StreifenDiagrammQuer", "SymmetricMatrix", "TableForm2List", 
      "TensorMS", "text", "TEXTSHIFT", "TF", "thickness", "TridiagonalMult", 
      "tupel", "Uni", "UniC", "univariate", "univariatealt", "unsameq", 
      "Varianz", "VecDiag", "vv", "Wiener"}\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{39, 1440}, {0, 878}},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{667, 739},
WindowMargins->{{Automatic, 14}, {Automatic, 10}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "plot1"->{
    Cell[22294, 352, 4687, 67, 1986, "Input",
      InitializationCell->True,
      CellTags->"plot1"]},
  "univariate"->{
    Cell[40306, 638, 2674, 101, 1356, "Input",
      InitializationCell->True,
      CellTags->"univariate"]},
  "HistogrammChart"->{
    Cell[47035, 832, 888, 15, 362, "Input",
      InitializationCell->True,
      CellTags->"HistogrammChart"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"plot1", 56987, 1009},
  {"univariate", 57110, 1013},
  {"HistogrammChart", 57244, 1017}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 20537, 299, 8188, "Input",
  InitializationCell->True],
Cell[22294, 352, 4687, 67, 1986, "Input",
  InitializationCell->True,
  CellTags->"plot1"],
Cell[26984, 421, 833, 13, 348, "Input",
  InitializationCell->True],
Cell[27820, 436, 601, 18, 208, "Input",
  InitializationCell->True],
Cell[28424, 456, 233, 6, 40, "Input",
  InitializationCell->True],
Cell[28660, 464, 10958, 159, 5122, "Input",
  InitializationCell->True],
Cell[39621, 625, 682, 11, 264, "Input",
  InitializationCell->True],
Cell[40306, 638, 2674, 101, 1356, "Input",
  InitializationCell->True,
  CellTags->"univariate"],
Cell[42983, 741, 2896, 44, 1258, "Input",
  InitializationCell->True],
Cell[45882, 787, 1150, 43, 558, "Input",
  InitializationCell->True],
Cell[47035, 832, 888, 15, 362, "Input",
  InitializationCell->True,
  CellTags->"HistogrammChart"],

Cell[CellGroupData[{
Cell[47948, 851, 5923, 88, 2938, "Input",
  InitializationCell->True],
Cell[53874, 941, 112, 5, 24, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[54023, 951, 78, 1, 26, "Input"],
Cell[54104, 954, 2037, 29, 326, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

