(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     26204,        957]*)
(*NotebookOutlinePosition[     27087,        987]*)
(*  CellTagsIndexPosition[     27043,        983]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["\<\
PAR::usage = \"System-Matrizen\"
PARD::usage = \"Ableitungen der System-Matrizen\"
PARM::usage = \"Me\[SZ]-Matrizen\"
PARMD::usage = \"Ableitungen der Me\[SZ]-Matrizen\"

Unprotect[\"code`LSD`*\"];
Clear[\"code`LSD`*\"];
Remove[\"code`LSD`Private`*\"];
Unprotect[RungeKutta];



BeginPackage[\"code`LSD`\",{\"Global`\",
\t\t\t\t\t\t\t \t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t \"code`Kronecker`\",
\t\t\t\t\t\t\t \"code`PARTest`\",
                             (*\"LinearAlgebra`Cholesky`\",*)
                             \"LinearAlgebra`MatrixManipulation`\",
                             \"Statistics`NormalDistribution`\", 
                             \"Statistics`DataManipulation`\"                 \
   
                             }]



\t
Panel::usage = \"Panel[A,B,G,Y0,X,p,q,N,T,dt,seed,Prozess], 
\tSimulation Panel-Modell; Prozess-Fehler PROZESS (Uni oder Gauss)\" \t

StateSpace1::usage = \
\"StateSpace1[H,D,R,A,B,G,Y0,X,k,p,q,N,T,dt,seed,Prozess], 
\tSimulation State-Space-Modell; Prozess- und Messfehler
\tPROZESS (Uni oder Gauss)\" 

StateSpace::usage = \"StateSpace[H,D,R,A,B,G,Y0,X,k,p,q,N,T,dt,seed,print], 
\tSimulation State-Space-Modell;\"

TimeUp::usage = \"TimeUp[Yii,Pii,Xii,Astern,Bstern,OsternN], Time-Update\"

MessUp::usage = \"MessUp[Z,Yi1i,Pi1i,X,H,D,R,{n,p}], ohne missing\"

MessUp::usage = \"MessUp[Z,Yi1i,Pi1i,X,H,D,R,miss,par], Mess-Update\"

MessUp1::usage = \"MessUp1[Z,Yi1i,Pi1i,X,H,D,R,miss,par], Mess-Update\"

TimeMessUp::usage = \"TimeMessUp[{Yii,Pii,Lik,Yi1i,Pi1i},
\t{Z,Xii,Xi1i1},Astern,Bstern,OsternN,H,D,R,miss]\"

GlattUp::usage = \"GlattUp[{YG,PG},{Yii,Pii,Yi1i,Pi1i},Astern,{p,np}], 
\tGl\[ADoubleDot]tter-Update, output = {YGneu,PGneu,Pisum}\"

GlattUp::usage = \"GlattUp[{YG,PG},{Yii,Pii,Yi1i,Pi1i},Astern], 
\tGl\[ADoubleDot]tter-Update ohne missing, output = {YGneu,PGneu,Pisum}\"
\t
GlattUp1::usage = \"GlattUp1[{YG,PG},{Yii,Pii,Yi1i,Pi1i},Astern],
\tohne missing, output = {YGneu,PGneu}\"
\t
GlattUp1::usage = \"GlattUp1[{YG,PG},{Yii,Pii,Yi1i,Pi1i},Astern,{p,np}], 
\tGl\[ADoubleDot]tter-Update, output = {YGneu,PGneu}\"
\t
MNorKorr::usage = \"MNorKorr[Z,MUEN,SIGMAN,X,H,D,R,miss], 
\tNormalkorrelation\"
\t
MFilterFold::usage = \"MFilterFold[Y0,P0,Z,X,Astern,Bstern,Ostern,H,d,R,
\tn,T,miss], Kalman-Filter mit missing data, mit FoldList\"
\t
Filter::usage = \"Filter[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,n,T],
\tKalman-Filter ohne missing data\"
    
MFilter::usage = \"MFilter[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,N,T,miss], 
\tKalman-Filter mit missing data\"
\t
MFilter1::usage = \"MFilter1[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,N,T,miss], 
\tKalman-Filter mit missing data, nur Likelihood\"
\t
Glatt::usage = \"Glatt[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R], 
\tKalman-Gl\[ADoubleDot]tter\" 

MGlattFold::usage = \
\"MGlattFold[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,N,T,miss], 
\tKalman-Gl\[ADoubleDot]tter mit missing data\"
\t
MGlattLoop::usage = \
\"MGlattLoop[Y0,P0,Z,X,Astern,Bstern,Ostern,H,D,R,N,T,miss], 
\tKalman-Gl\[ADoubleDot]tter mit missing data\"
\t
RungeKutta::usage = \"RungeKutta[f,g,Y0,X,T,dt,Theta,Prozess,
\tStep]\"\t
\t
EulerStep::usage = \"EulerStep[f,g,y,r,t,dt,dt2,Theta,Prozess]\"
           
HeunStep::usage = \"HeunStep[f,g,y,r,t,dt,dt2,Theta,Prozess]\"

RungeKutta4Step::usage = \"RungeKutta4Step[f,g,y,r,t,dt,dt2,Theta,Prozess]\"

MLSchaetzer::usage = \"MLSchaetzer[Phi0,Phi,u,y,x,g,dt]\"

DiffusionsKoeffizient::usage = \"DiffusionsKoeffizient[y,dt],
\tOmega = Summe(dy.dy`)/Tdt\"


\t
Begin[\"`Private`\"]



Panel[A_,B_,G_,Y0_,X_,p_,q_,N_,T_,dt_,seed_,Prozess_:\"Deterministic\"] := 
\tModule[{Ostern,Astern,Bstern,Omega,eps = 10.^-16,Yt,Zt,t,O2,i,j,kk},
\t\tSeedRandom[seed];
\t\tOmega = G . Transpose[G];
\t\t{Ostern,Astern,Bstern} = Stern[Omega,A,B,dt];
\t\tIf[Prozess =!= \"Deterministic\",
\t\t
\t\tO2 = CholeskyDecomposition[Ostern + eps IdentityMatrix[p]]//Transpose;
       \tFoldList[(Astern.#1 + Bstern.#2 +
       \t         O2.Table[Prozess[],{i,p},{j,N}])&, Y0, X[[T//Range]] ]
       \t         
       \t,(* else *)
       \tFoldList[(Astern.#1 + Bstern.#2 )&, Y0, X[[T//Range]] ]
       \t]
       \t              
        (*Y = NestList[(Astern.#1 +
       \t              O2.Table[Prozess[],{i,p},{j,N}])&, Y0, T ]*)
       
       ] (*Ende*)\t\t
\t
StateSpace1[H_,D_,R_,A_,B_,G_,Y0_,X_,k_,p_,q_,N_,T_,dt_,seed_,Prozess_] := 
\tModule[{Ostern,Astern,Bstern,Z,Y,Omega,eps = 10.^-16,Yt,Zt,t,O2,R2,i,j,kk},
\t\tSeedRandom[seed];
\t\tOmega = G . Transpose[G];
\t\t{Ostern,Astern,Bstern} = Stern[Omega,A,B,dt];
\t\tOstern=(Ostern+Transpose[Ostern])/2;
\t\tO2 = CholeskyDecomposition[Ostern + eps IdentityMatrix[p]]//Transpose;
        R2 = CholeskyDecomposition[R + eps IdentityMatrix[k]]//Transpose;
       
       \tY = FoldList[(Astern.#1 + Bstern.#2 +
       \t              O2.Table[Prozess[],{i,p},{j,N}])&, Y0, X[[T//Range]] \
];
        
        
        Z = H.Transpose[Y,{2,1,3}] + D.Transpose[X,{2,1,3}] 
                                   + \
R2.Table[Prozess[],{i,k},{j,T+1},{kk,1,N}];
        Z = Transpose[Z,{2,1,3}];                           
     \t{Z,Y}
\t\t
\t] (*Ende*)
\t
StateSpace[H_,D_,R_,A_,B_,G_,Y0_,X_,k_,p_,q_,N_,T_,dt_,seed_,print_] := 
\tModule[{Ostern,Astern,Bstern,Z,Y,Omega,eps = 10.^-16,Yt,Zt,t,kk},
\t\tOmega = G . Transpose[G];
\t\t{Ostern,Astern,Bstern} = Stern[Omega,A,B,dt];
\t\tO2 = CholeskyDecomposition[Ostern + eps IdentityMatrix[p]]//Transpose;
        R2 = CholeskyDecomposition[R + eps IdentityMatrix[k]]//Transpose;
       
        Y = FoldList[(Astern.#1 + Bstern.#2 +
       \t              O2.Table[Random[NormalDistribution[0,1]],
       \t                       {i,p},{j,N}])&, Y0, X[[T//Range]] ];
       \t                      
        Z = H.Transpose[Y,{2,1,3}] + D.Transpose[X,{2,1,3}] 
            + \
R2.Table[Random[NormalDistribution[0,1]],{i,k},{j,T+1},{kk,1,N}];
            
        Z = Transpose[Z,{2,1,3}];                           
     \t{Z,Y}
\t\t
\t] (*Ende*)

TimeUp[Yii_,Pii_,Xii_,Astern_,Bstern_,OsternN_] :=
\tModule[{},
\t\tYi1i = Astern.Yii + Bstern.Xii;
\t\tPi1i = Astern.Transpose[Pii,{2,1,3}].Transpose[Astern];
\t\tPi1i = Transpose[Pi1i,{2,1,3}] + OsternN;
\t\t{Yi1i,Pi1i}
\t]
\t
MNorKorr[Z_,MUEN_,SIGMAN_,X_,H_,D_,R_,miss_] := 
\tModule[{YZ,PZ,lik,k,p,q,np,n}, 
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\t{k,n} = Dimensions[Z];
\t\tnp  = Length[SIGMAN];
 \t\t{YZ,PZ,lik} = MessUp[Z,MUEN,SIGMAN,X,H,D,R,miss,{k,p,q,n,np}];
 \t \t{YZ,PZ,-.5 lik}
 \t ]
 \t 
MessUp[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,{n_,p_}] :=
\tModule[{pi1in,vint,vi1,gain,inn,ikh,Yii,Pii,lik},\t\t
\t\t
\tpi1in = Pi1i[[1]];
\tvint = H . pi1in . Transpose[H] + R;
\tvi1 = Inverse[vint];
\tgain = pi1in . Transpose[H] . vi1;
\tinn = Z - H . Yi1i - D . X;
\tlik = n Log[Det[vint]] + MatrixTrace[vi1 . (inn . Transpose[inn])];
\tYii = Yi1i + gain.inn;
\tikh = IdentityMatrix[p] - gain.H;
\tPii = {ikh.pi1in.Transpose[ikh] + gain . R . Transpose[gain]};\t\t\t\t\t\t \
\t
\t{Yii,Pii,lik}
\t   
\t](* End MessUp ohne missing *) 
\t\t \t
MessUp[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,miss_,{k_,p_,q_,n_,np_}] :=
\tModule[{nn,zmiss,lc,hnt,dnt,rnt,pi1in,vint,vi1,gain,inn,ikh,
\t        Yii,Pii,lik},
\t\t
\t\tlik = .0;
\t\tYii = Yi1i;
\t\tPii = Pi1i;
\t\t
\t\tDo[ 
\t\t\tzmiss = Z[[k//Range,nn]] ~eq~ miss; (*Print[zmiss,nn];*)\t\t
\t\t\tIf[And @@ zmiss,
\t\t\t\t(* keine Messung *)
\t\t\t\t 
\t\t\t\tIf[np == 1, Return[] ]\t
\t\t\t\t
\t\t\t,(*else*)
\t\t\t\t
\t\t\t\tlc = Locate[zmiss,False];
\t\t\t\thnt = H[[lc]];
\t\t\t\tdnt = D[[lc]]; 
\t\t\t\trnt = R[[lc,lc]];
\t\t\t\t
\t\t\t\tpi1in = Pi1i[[nn]];
\t\t\t\tvint = hnt.pi1in.Transpose[hnt] + rnt;
\t\t\t\tvi1 = Inverse[vint];
\t\t\t\tgain = pi1in.Transpose[hnt].vi1;
\t\t\t\t
\t\t\t\tIf[np == 1, (*Print[\"Messung, simultan\"];*)
\t\t\t\t
\t\t\t\t\t(* alle N simultan*)
\t\t\t\t\tinn = Z[[ lc ]] - hnt.Yi1i - dnt.X;
\t\t\t\t\tlik = n Log[Det[vint]] + MatrixTrace[vi1.
\t\t\t\t\t\t\t\t\t\t\t  (inn.Transpose[inn])];
\t\t\t\t\t\t\t\t\t\t\t 
\t\t\t\t\tYii = Yi1i + gain.inn;
\t\t\t\t\tikh = IdentityMatrix[p] - gain.hnt;
\t\t\t\t\tPii = {ikh.pi1in.Transpose[ikh] +
\t\t\t\t\t\t\t\t gain.rnt.Transpose[gain]}
\t\t\t\t\t
\t\t\t\t\t
\t\t\t\t\t
\t\t\t\t,(*else*) (*Print[\"Messung, einzeln\"];*)
\t\t\t\t
\t\t\t\t    inn = Z[[lc,nn]] - hnt.Yi1i[[Range[p],nn]] 
\t\t\t\t                     - dnt.X[[Range[q],nn]]; (*Vektor*)
\t\t\t\t\tlik += Log[Det[vint]] + inn.vi1.inn;
\t\t\t\t\t
\t\t\t\t\tYii = Yii//Transpose;
\t\t\t\t\tYii[[nn]] = Yi1i[[Range[p],nn]] + gain.inn;
\t\t\t\t\tYii = Yii//Transpose; (*wieder zur\[UDoubleDot]ck*)
\t\t\t\t\t
\t\t\t\t\tikh = IdentityMatrix[p] - gain.hnt;
\t\t\t\t\tPii[[nn]] = ikh.pi1in.Transpose[ikh] 
\t\t\t\t\t \t\t   + gain.rnt.Transpose[gain]
\t
\t\t\t\t](*end if*)
\t\t\t\t\t
\t\t\t](*end if*)
\t\t\t\t\t
\t\t,{nn,np}];
\t\t
\t   {Yii,Pii,lik}
\t   
\t](*End MessUp*)

MessUp1[Z_,Yi1i_,Pi1i_,X_,H_,D_,R_,miss_,{k_,p_,q_,n_,np_}] :=
\tModule[{nn,zmiss,lc,hnt,dnt,rnt,pi1in,vint,vi1,gain,inn,ikh,
\t        Yii,Pii,lik},
\t\t
\t\tlik = .0;
\t\tYii = Yi1i;
\t\tPii = Pi1i;
\t\t
\t\tIf[np == 1,
\t\t\tzmiss = Z[[k//Range,1]] ~eq~ miss; 
\t\t\tIf[ Not[And @@ zmiss],
\t\t\t\t(* simultane Messung*)
\t\t\t\t(* Print[\"Messung, simultan\"];*)
\t\t\t\tlc = Locate[zmiss,False]; 
\t\t\t\thnt = H[[lc]];
\t\t\t\tdnt = D[[lc]]; 
\t\t\t\trnt = R[[lc,lc]];
\t\t\t\tpi1in = Pi1i[[1]];
\t\t\t\tvint = hnt.pi1in.Transpose[hnt] + rnt;
\t\t\t\tvi1 = Inverse[vint];
\t\t\t\tgain = pi1in.Transpose[hnt].vi1;
\t\t\t\tinn = Z[[ lc,Range[n] ]] - hnt.Yi1i - dnt.X;
\t\t\t\tlik = n Log[Det[vint]] + MatrixTrace[vi1.
\t\t\t\t\t\t\t\t\t\t\t  (inn.Transpose[inn])];
\t\t\t\t\t\t\t\t\t\t\t 
\t\t\t\tYii = Yi1i + gain.inn;
\t\t\t\tikh = IdentityMatrix[p] - gain.hnt;
\t\t\t\tPii = {ikh.pi1in.Transpose[ikh] + gain.rnt.Transpose[gain]};
\t\t\t\t\t\t\t
\t\t\t  ]
\t\t
\t\t,(* np > 1 *) 
\t\t
\t\t\tDo[ 
\t\t\t\tzmiss = Z[[k//Range,nn]] ~eq~ miss; \t\t
\t\t\t\tIf[Not[And @@ zmiss], 
\t\t\t\t\t(*Print[\"Messung, einzeln\"];*)
\t\t\t\t\tlc = Locate[zmiss,False];
\t\t\t\t\thnt = H[[lc]];
\t\t\t\t\tdnt = D[[lc]]; 
\t\t\t\t\trnt = R[[lc,lc]];
\t\t\t\t\tpi1in = Pi1i[[nn]];
\t\t\t\t\tvint = hnt.pi1in.Transpose[hnt] + rnt;
\t\t\t\t\tvi1 = Inverse[vint];
\t\t\t\t\tgain = pi1in.Transpose[hnt].vi1;\t\t\t\t
\t\t\t\t\t
\t\t\t\t\t
\t\t\t\t\tinn = Z[[lc,nn]] - hnt.Yi1i[[Range[p],nn]] 
\t\t\t\t                     - dnt.X[[Range[q],nn]]; (*Vektor*)
\t\t\t    \tlik += Log[Det[vint]] + inn.vi1.inn;
\t\t\t\t\t
\t\t\t   \t    Yii = Yii//Transpose;
\t\t\t\t\tYii[[nn]] = Yi1i[[Range[p],nn]] + gain.inn;
\t\t\t    \tYii = Yii//Transpose; (*wieder zur\[UDoubleDot]ck*)
\t\t\t\t\tikh = IdentityMatrix[p] - gain.hnt;
\t\t\t\t\tPii[[nn]] = ikh.pi1in.Transpose[ikh] + 
\t\t\t\t\t\t\t\t\tgain.rnt.Transpose[gain];
\t
\t\t\t\t\t](*end if \"Not[And @@ zmiss]\" *)
\t\t\t
\t\t\t,{nn,np}];
\t\t\t\t
\t\t](*end if np = 1*);
\t
\t{Yii,Pii,lik}
\t   
\t](*End MessUp1*)


TimeMessUp[{Yii_,Pii_,Lik_,Yi1i_,Pi1i_},{Z_,Xii_,Xi1i1_},
\t\t\tAstern_,Bstern_,OsternN_,H_,D_,R_,miss_,par_] := 
\tModule[{yi1i,pi1i,yii,pii,lik},

\t\t{yi1i,pi1i}   = TimeUp[Yii,Pii,Xii,Astern,Bstern,OsternN];
\t\t{yii,pii,lik} = MessUp[Z,yi1i,pi1i,Xi1i1,H,D,R,miss,par];
\t\t{yii,pii,{lik},yi1i,pi1i}
\t]
\t
TimeMessUp1[{Yii_,Pii_,Lik_},{Z_,Xii_,Xi1i1_},
\t\t\tAstern_,Bstern_,OsternN_,H_,D_,R_,miss_,par_] := 
\tModule[{yi1i,pi1i,yii,pii,lik},

\t\t{yi1i,pi1i}   = TimeUp[Yii,Pii,Xii,Astern,Bstern,OsternN];
\t\t{yii,pii,lik} = MessUp[Z,yi1i,pi1i,Xi1i1,H,D,R,miss,par];
\t\t{yii,pii,{lik}+Lik}
\t]
\t\t\t
GlattUp[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Astern_,{p_,np_} ]:=
\tModule[{YGneu,PGneu,Pisum,nn,pp,Pistern,Piin,Pi1in},
\t\t
\t\tpp = p//Range;
\t\tYGneu = Yii//Transpose;
\t\tPGneu = Pii;
\t\tPisum = J[0.0,p,p];
\t\t
\t\tFor[nn = 1, nn <= np, nn++,
\t\t\t
\t\t\tPiin  = Pii[[nn]];\t
\t\t\tPi1in = Pi1i[[nn]];
\t\t\tPGn   = PG[[nn]];
\t\t\t
\t\t\t(*Pi1in = {{1,1},{2,2}};*)
\t\t\tCheck
\t\t\t[
\t\t\tPistern = LinearSolve[Pi1in,Astern.Piin]//Transpose;
\t\t\t
\t\t\t,Print[\"Singular Gain\"];
\t\t\tInterrupt[ ]
\t\t\t];
\t\t\t
\t\t\t(*Pistern = LinearSolve[Pi1in,Astern.Piin]//Transpose;*)
\t\t\t
\t\t\tIf[np > 1,
\t\t\t
\t\t\tYGneu[[nn]] = Yii[[pp,nn]] 
\t\t\t\t\t\t  + Pistern.(YG[[pp,nn]] - Yi1i[[pp,nn]]);
\t\t\tPGneu[[nn]] = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]
\t\t\t
\t\t\t,(* else *)
\t\t\t
\t\t\tYGneu = Transpose[Yii + Pistern.(YG - Yi1i)];
\t\t\tPGneu[[nn]] = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]
\t\t\t];
\t\t\t\t\t  
\t\t\tPisum += Pistern.PGn;
\t\t];
\t\t
\t\tYGneu = YGneu//Transpose;
\t
\t\t{YGneu,PGneu,Pisum}
\t]
\t
GlattUp[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Astern_]:=
\tModule[{YGneu,PGneu,nn,pp,Pistern,Piin,Pi1in},
\t\t
\t\t\tPiin  = Pii[[1]];\t
\t\t\tPi1in = Pi1i[[1]];
\t\t\tPGn   = PG[[1]];
\t\t\tPistern = LinearSolve[Pi1in,Astern . Piin]//Transpose;
\t\t\t
\t\t\tYGneu = Yii + Pistern.(YG - Yi1i);
\t\t\tPGneu = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern];
\t\t\tPisum = Pistern.PGn;
\t\t\t
\t\t   {YGneu,{PGneu},Pisum}
\t]
\t
GlattUp1[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Astern_]:=
\tModule[{YGneu,PGneu,nn,pp,Pistern,Piin,Pi1in},
\t\t
\t\t\tPiin  = Pii[[1]];\t
\t\t\tPi1in = Pi1i[[1]];
\t\t\tPGn   = PG[[1]];
\t\t\tPistern = LinearSolve[Pi1in,Astern . Piin]//Transpose;
\t\t\t
\t\t\tYGneu = Yii + Pistern.(YG - Yi1i);
\t\t\tPGneu = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern];
\t
\t\t   {YGneu,{PGneu}}
\t]
\t\t
GlattUp1[{YG_,PG_},{Yii_,Pii_,Yi1i_,Pi1i_},Astern_,{p_,np_}]:=
\tModule[{YGneu,PGneu,nn,pp,Pistern,Piin,Pi1in},

\t\tpp = p//Range;
\t\tYGneu = Yii//Transpose;
\t\tPGneu = Pii;
\t\t
\t\tFor[nn = 1, nn <= np, nn++,
\t\t\t
\t\t\tPiin  = Pii[[nn]];\t
\t\t\tPi1in = Pi1i[[nn]];
\t\t\tPGn   = PG[[nn]];
\t\t\tPistern = LinearSolve[Pi1in,Astern.Piin]//Transpose;
\t\t\t
\t\t\tIf[np > 1,
\t\t\t
\t\t\tYGneu[[nn]] = Yii[[pp,nn]] 
\t\t\t\t\t\t  + Pistern.(YG[[pp,nn]] - Yi1i[[pp,nn]]);
\t\t\tPGneu[[nn]] = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]
\t\t\t
\t\t\t,(* else *)
\t\t\t
\t\t\tYGneu = Transpose[Yii + Pistern.(YG - Yi1i)];
\t\t\tPGneu[[nn]] = Piin + Pistern.(PGn - Pi1in).Transpose[Pistern]
\t\t\t]
\t\t];
\t\t
\t\tYGneu = YGneu//Transpose;
\t
\t\t{YGneu,PGneu}
\t]\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{7, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
\t
MFilter[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_]:=\
 
\tModule[{np,k,p,q,Yii,Pii,YF,PF,i,ON,Yi1i,Pi1i,lik,liki},
\t
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = Length[P0];
\t\t{k,p,q,n,np}//Print;
\t\t
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tlik = 0;
\t\tON  = Array[1&,{np}] /. 1->Ostern;
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        {Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,{k,p,q,n,np}];
\t            
\t        lik += liki;
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t\t
\t\t{YF,PF,lik}
\t]\
\>", "Input",
  CellMargins->{{7, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
\t
Filter[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_]:= 
\tModule[{np,k,p,q,Yii,Pii,YF,PF,i,ON,Yi1i,Pi1i,lik,liki},
\t
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = Length[P0];
\t\t{k,p,q,n,np}//Print;
\t\t
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tlik = 0;
\t\tON  = Array[1&,{np}] /. 1->Ostern;
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        {Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];
\t          
\t        lik += liki;
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t\t
\t\t{YF,PF,lik}
\t]\
\>", "Input",
  CellMargins->{{7, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
MFilter1[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,\
T_,miss_]:= 
\tModule[{np,k,p,q,Yii,Pii,i,ON,Yi1i,Pi1i,lik,liki},
\t\t(* NUR BERECHNUNG DER LIKELIHOOD *)
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = Length[P0];
\t\t{k,p,q,n,np}//Print;
\t\t
\t\tYii = Y0;
\t\tPii = P0;
\t\tlik = 0;
\t\tON  = Array[1&,{np}] /. 1->Ostern;
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        {Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,{k,p,q,n,np}];
\t        
\t        lik += liki;
\t        
\t        \t
\t\t,{i,T}];
\t\t
\t\tlik = -.5 lik;\t\t
\t\t{lik}
\t]
\t
MFilterFold[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,d_,R_,n_,T_,\
miss_]:= 
\tModule[{YF,PF,ON,lik,par,k,p,q,np},
\t\t
\t\tnp  = Length[P0];
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[d];
\t\tpar = {k,p,q,n,np};
\t\tpar//Print;
\t\tON  = Array[1&,{np}] /. 1->Ostern;
\t\t
\t\t{YF,PF,lik}
\t\t = Fold[TimeMessUp1[#1,#2,Astern,Bstern,ON,H,d,R,miss,par]&,
\t\t\t\t\t   {Y0,P0,{0}},
\t\t\t\t\t   {Drop[Z,1],Drop[X,-1],Drop[X,1]}//Transpose];
\t\t
\t\t(*lik = Plus@@Flatten@lik;*)
\t\t
\t\tlik = -.5 lik;
\t\tlik
\t]
\t
Glatt[Y0_,P0_?Tensor3Q,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_]:= 
\tModule[{T,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
\t\t\tlik,liki},
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\t{p,n} = Dimensions[Y0];
\t\tT = Length[Z] -1;
\t\t
\t\t{k,p,q,n,T}//Print;
\t\t
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tY1  = {};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tP1  = {};
\t\tlik = 0;
\t\tON  = {Ostern};
\t
\t\tDo[ 
\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        {Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,{n,p}];
\t       
\t        lik += liki;
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        Y1 = Append[Y1,Yi1i];
\t        P1 = Append[P1,Pi1i];
\t        \t
\t\t,{i,T}];
\t\t
\t\tYGalt = YF[[T+1]];
\t\tPGalt = PF[[T+1]];
\t\tYG = {YGalt};
\t\tPG = {PGalt};
\t\t
\t\t
\t\tDo[\t(*Print[i];*)
\t\t\tYii   = YF[[i]];
\t\t\tYi1i  = Y1[[i]];
\t\t\tPii   = PF[[i]];
\t\t\tPi1i  = P1[[i]];
\t\t\t
\t\t\t{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
\t\t\t\t\t\t\t\t     {Yii,Pii,Yi1i,Pi1i},Astern];
\t\t\t
\t\t\tYG = Prepend[YG,YGalt];
\t\t\tPG = Prepend[PG,PGalt];
\t\t\t
\t\t
\t\t,{i,T,1,-1}];
\t\t
\t\tlik = -.5 lik;
\t\t{YG,PG,YF,PF,lik}
\t]
\t
MGlattLoop[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_]:= 
\tModule[{np,k,p,q,YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
\t\t\tlik,liki},
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tnp  = Length[P0];
\t\t{k,p,q,n,np}//Print;
\t\t
\t\tYii = Y0;
\t\tYF  = {Y0};
\t\tY1  = {};
\t\tPii = P0;
\t\tPF  = {P0};
\t\tP1  = {};
\t\tlik = 0;
\t\tON  = Array[1&,{np}] /. 1->Ostern;
\t
\t\tDo[ 
\t\t\t\t(*Time Update*)
\t\t\t
\t\t\t{Yi1i,Pi1i} = TimeUp[Yii,Pii,X[[i]],Astern,Bstern,ON];
\t\t\t
\t\t\t\t(*Mess-Update*)
\t\t\t\t\t
\t        {Yii,Pii,liki} = 
\t        \tMessUp[Z[[i+1]],Yi1i,Pi1i,X[[i+1]],H,D,R,miss,{k,p,q,n,np}];
\t       
\t        lik += liki;
\t        YF = Append[YF,Yii];
\t        PF = Append[PF,Pii];
\t        Y1 = Append[Y1,Yi1i];
\t        P1 = Append[P1,Pi1i];
\t        \t
\t\t,{i,T}];
\t\t
\t\tYGalt = YF[[T+1]];
\t\tPGalt = PF[[T+1]];
\t\tYG = {YGalt};
\t\tPG = {PGalt};
\t\t
\t\t
\t\tDo[\t(*Print[i];*)
\t\t\tYii   = YF[[i]];
\t\t\tYi1i  = Y1[[i]];
\t\t\tPii   = PF[[i]];
\t\t\tPi1i  = P1[[i]];
\t\t\t
\t\t\t{YGalt,PGalt} = GlattUp1[{YGalt,PGalt},
\t\t\t\t\t\t\t\t     {Yii,Pii,Yi1i,Pi1i},Astern,{p,np}];
\t\t\t
\t\t\tYG = Prepend[YG,YGalt];
\t\t\tPG = Prepend[PG,PGalt];
\t\t\t
\t\t
\t\t,{i,T,1,-1}];
\t\t
\t\tlik = -.5 lik;
\t\t{YG,PG,YF,PF,lik}
\t]
\t
MGlattFold[Y0_,P0_,Z_,X_,Astern_,Bstern_,Ostern_,H_,D_,R_,n_,T_,miss_]:= 
\tModule[{YF,PF,YG,PG,Y1,P1,YGalt,PGalt,i,ON,Yii,Pii,Yi1i,Pi1i,
\t\t\tlik,tt,ygpg,par,k,p,q,np},
\t\t
\t\tnp  = Length[P0];
\t\t{k,p} = Dimensions[H];
\t\t{k,q} = Dimensions[D];
\t\tpar = {k,p,q,n,np};
\t\tpar//Print;
\t\tON  = Array[1&,{np}] /. 1->Ostern;
\t\t
\t\t{YF,PF,lik,Y1,P1}
\t\t = FoldList[TimeMessUp[#1,#2,Astern,Bstern,ON,H,D,R,miss,par]&,
\t\t\t\t\t   {Y0,P0,{0},{0},{0}},
\t\t\t\t\t   {Drop[Z,1],Drop[X,-1],Drop[X,1]}//Transpose]
\t\t\t           //Transpose;

\t\tY1 = Drop[Y1,1];
\t\tP1 = Drop[P1,1];
\t\t
\t\tlik = Plus@@Flatten@lik;
\t\tlik = -.5 lik;
\t\tYii   = Drop[YF,-1]//Reverse; 
\t\tYi1i  = Y1//Reverse;
\t\tPii   = Drop[PF,-1]//Reverse; 
\t\tPi1i  = P1//Reverse; 
\t\t
\t\tygpg = FoldList[ GlattUp1[#1,#2,Astern,{p,np}]&, 
\t\t\t\t\t\t {YF[[T+1]],PF[[T+1]]},
\t\t\t\t\t     {Yii,Pii,Yi1i,Pi1i}//Transpose ];
\t\t\t
\t\t{YG,PG} = ygpg//Transpose;
\t\tYG = YG//Reverse;
\t\tPG = PG//Reverse;
\t\t
\t\t{YG,PG,YF,PF,lik} 
\t]
\t
RungeKutta//Clear
RungeKutta[f_,g_,Y0_,X_,T_,dt_,Theta_,Prozess_,Step_] := 
\tModule[{p,r,dt2,Y},
\t\t{p,r} = g[Y0,X[[1]],Theta]//Dimensions;
\t\tdt2 = Sqrt[dt//N];
\t\tY = FoldList[ Step[f,g,#1,r,#2,dt,dt2,Theta,Prozess]&,
                      Y0, X[[T//Range]]  ]
       
       ]
 
       
EulerStep//Clear
EulerStep[f_,g_,y_,r_,t_,dt_,dt2_,Theta_,Prozess_] :=
      y + f[y,t,Theta] dt + g[y,t,Theta].Table[Prozess[],{i,r}] dt2;
      
HeunStep//Clear
HeunStep[f_,g_,y_,r_,t_,dt_,dt2_,Theta_,Prozess_] :=
\tModule[{f1,g1,t1,f2,g2,dw},
\t\tf1 = f[y,t,Theta];
\t\tg1 = g[y,t,Theta];
\t\tdw = Table[Prozess[],{i,r}] dt2;
\t\ty1 = y + f1 dt + g1.dw; (* Euler-Pr\[ADoubleDot]diktor *)
\t\tt1 = t + dt;
\t\tf2 = f[y1,t1,Theta];
\t\tg2 = g[y1,t1,Theta];
        y + 0.5 ( (f1 + f2) dt + (g1 + g2).dw )
 \t]
 \t
RungeKutta4Step//Clear
RungeKutta4Step[f_,g_,y_,r_,t_,dt_,dt2_,Theta_,Prozess_] :=
\tModule[{f0,f1,f2,f3,g0,g1,g2,g3,t1,t3,dth,dw,dwh,y1,y2,y3},
\t\tf0 = f[y,t,Theta];
\t\tg0 = g[y,t,Theta];
\t\tdw = Table[Prozess[],{i,r}] dt2;
\t\tdwh = dw/2;
\t\tdth = dt/2;
\t\t
\t\tt1 = t + dth;
\t\ty1 = y + f0 dth + g0.dwh;
\t\tf1 = f[y1,t1,Theta];
\t\tg1 = g[y1,t1,Theta];
\t\t
\t\ty2 = y + f1 dth + g1.dwh;
\t\tf2 = f[y2,t1,Theta];
\t\tg2 = g[y2,t1,Theta];
\t\t
\t\ty3 = y + f2 dt + g2.dw;
\t\tt3 = t + dt;
\t\tf3 = f[y3,t3,Theta];
\t\tg3 = g[y3,t3,Theta];
\t\t
        y + (f0 + 2f1 + 2f2 + f3) dt/6 + (g0 + 2g1 + 2g2 + g3).dw/6 
 \t] 
      
      
       \t\t  \t\t\t\t\t\t\t\t
MLSchaetzer[Phi0_,Phi_,u_,y_,x_,g_,dt_]:= 
\tModule[{z,n,T1,fi,gi,phiomega,omega,th,Theta},
\t\t{T1,p} = Dimensions[y];
\t\tTheta = {};F = {};
\t\tn = DiagonalMatrix[Shape[10.^-12,{u}]];
\t\tz = Shape[.0,{u,1}];
\t\tDo[
\t\t
\t\tyi = y[[i]];
\t\txi = x[[i]];
\t\tfi = Phi[yi,xi];
\t\tgi = g[yi,xi];
\t\t
\t\tomega = gi.Transpose[gi];
\t\tphiomega = Transpose[LinearSolve[omega,fi]];
\t\tz += phiomega.(y[[i+1]] - yi - Phi0[yi,xi] dt);
\t\tn += phiomega.fi;
\t\tth = LinearSolve[n,z];
\t\tTheta = Append[Theta,th//Flatten];
\t\tF = Append[F,n dt]; (*n dt = Fisher-Info*)

\t\t,{i,1,T1-1}];
\t\t
\t\t{Theta/dt,F}
\t]

DiffusionsKoeffizient[y_,dt_] := 
\tModule[{dy},
\t\tdy = Delta[y,1];
\t\tCuMean[Map[Outer[Times,#,#]&,dy],Plus]/dt
\t]
\t\t
\t\t\t\t\t\t\t\t\t\t\t
End[ ]


Protect[Names[\"code`LSD`*\"]//Evaluate];


EndPackage[ ]



\t\t\t\t\t            
                  \t
\
\>", "Input",
  CellMargins->{{7, Inherited}, {Inherited, Inherited}},
  InitializationCell->True,
  CellLabelMargins->{{4, Inherited}, {Inherited, Inherited}},
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
<<code`LSD`
Names[\"code`LSD`*\"]\
\>", "Input",
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(Get::"noopen" \(\(:\)\(\ \)\) 
      "Cannot open \!\(\"Hermann`PARTest`\"\)."\)], "Message"],

Cell[BoxData[
    \(Needs::"nocont" \(\(:\)\(\ \)\) 
      "Context \!\(\"Hermann`PARTest`\"\) was not created when Needs was \
evaluated."\)], "Message"],

Cell[BoxData[
    \(Get::"noopen" \(\(:\)\(\ \)\) 
      "Cannot open \!\(\"Hermann`PARTest`\"\)."\)], "Message"],

Cell[BoxData[
    \(Needs::"nocont" \(\(:\)\(\ \)\) 
      "Context \!\(\"Hermann`PARTest`\"\) was not created when Needs was \
evaluated."\)], "Message"],

Cell[BoxData[
    \({}\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{39, 1440}, {0, 878}},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{742, 830},
WindowMargins->{{Automatic, 32}, {Automatic, 6}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 14319, 465, 6326, "Input",
  InitializationCell->True],
Cell[16076, 518, 987, 41, 502, "Input",
  InitializationCell->True],
Cell[17066, 561, 964, 40, 502, "Input",
  InitializationCell->True],
Cell[18033, 603, 7453, 322, 4767, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[25511, 929, 92, 4, 54, "Input"],
Cell[25606, 935, 113, 2, 21, "Message"],
Cell[25722, 939, 154, 3, 35, "Message"],
Cell[25879, 944, 113, 2, 21, "Message"],
Cell[25995, 948, 154, 3, 35, "Message"],
Cell[26152, 953, 36, 1, 38, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

