(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	keywords = "cHesse1";
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, R65535,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M18, N23, bold, L-5,  12, "Courier"; 
	fontset = output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M18, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Geneva"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = input; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4; plain]
(***************************************************************)
HesseTest[data_,Theta_,{system_,{Lik_,LikN_,Score_}},misc_]:=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT NUMERISCHEM SCORE:              *)
(* ZENTRALE DIFFERENZEN                                        *)
(* s_i=1/(2h_i) (l^i-l^{-i}) ; l^i=l(theta+h_i e_i)            *)
(* H_{ij} = 1/(4H_i H_j) (l^{ij}-l^{i,-j} -l^{-i,j}+l^{-i,-j}) *)


Module[{LIK,L2,INK,INK2,H4,H,
		LIJ,LIMJ,LIJM,LIMJM,L2I,LM2I,I,J,LIKI},
		
LIK  = Lik[data,Theta,{system,LikN},misc]; (*setzt FDIGITS*)
		
ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/3);
INK = INC max[Abs[Theta],Abs[TYP]];
Print["INK: ",INK];
U    = Length[Theta];
INK2 = 2 INK;
H4   = .25/Outer[Times,INK,INK];
L2   = 2 LIK;

H = Shape[0,{U,U}];

LIKI={};
Do[ 

{LIJ,LIMJ,LIJM,LIMJM} = 
	Map[Lik[data,#,{system,LikN},misc]&,
			{GRIDIJ[Theta ,I,J,  INK,  INK],
			 GRIDIJ[Theta ,I,J,  INK, -INK],
			 GRIDIJ[Theta ,I,J, -INK,  INK],
			 GRIDIJ[Theta ,I,J, -INK, -INK]
			 }];
			 
LIKI=Join[LIKI,{LIJ,LIMJ,LIJM,LIMJM}];

Return[];

{LIJ,LIMJ,LIJM,LIMJM}//NumberForm[#,30]&//Print;
	
    H[[I,J]] = LIJ - LIMJ - LIJM + LIMJM;
    
,{I,1,U},{J,I+1,U}];

H = H + Transpose[H];  Return[Join[{LIK},LIKI]]; 

Do[ 

{L2I,LM2I} = 
	Map[Lik[data,#,{system,LikN},misc]&,
			{GRIDI[Theta ,I, INK2],
			 GRIDI[Theta ,I,-INK2]
			 }];

LIKI=Join[LIKI,{L2I,LM2I}];
			 
{L2I,LM2I}//NumberForm[#,30]&//Print;

    H[[I,I]] = L2I - L2 + LM2I;
    
,{I,1,U}];

H = H H4;
{H,LIK,LIKI}
]

:[font = input; preserveAspect; leftWrapOffset = 4; leftNameWrapOffset = 4; plain; keywords = "cHesse1"]
(***************************************************************)
cHesse1Test[data_,Theta_,{system_,{Lik_,LikN_,Score_}},misc_]:=
(***************************************************************)
(* NUMERISCHE HESSE-MATRIX MIT NUMERISCHEM SCORE:              *)
(* ZENTRALE DIFFERENZEN                                        *)
(* s_i=1/(2h_i) (l^i-l^{-i}) ; l^i=l(theta+h_i e_i)            *)
(* H_{ij} = 1/(4H_i H_j) (l^{ij}-l^{i,-j} -l^{-i,j}+l^{-i,-j}) *)


Module[{LIK,L2,ETA,INC,INK,INK2,U,H4,H,
		LIJ,LIMJ,LIJM,LIMJM,L2I,LM2I,I,J,LIKI,lin,ThetaM},
		
(*LIK  = Lik[data,Theta,{system,LikN},misc];*) (*setzt FDIGITS*)
		
ETA = Max[$MachineEpsilon,10.^-FDIGITS];
INC = ETA^(1/3);
INK = INC max[Abs[Theta],Abs[TYP]];
Print["INK: ",INK];
U    = Length[Theta];
INK2 = 2 INK;
H4   = .25/Outer[Times,INK,INK];

H = Shape[0,{U,U}];

ThetaM={};

Do[ 

{LIJ,LIMJ,LIJM,LIMJM} = 
			{SCALING*GRIDIJ[Theta ,I,J,  INK,  INK],
			 SCALING*GRIDIJ[Theta ,I,J,  INK, -INK],
			 SCALING*GRIDIJ[Theta ,I,J, -INK,  INK],
			 SCALING*GRIDIJ[Theta ,I,J, -INK, -INK]};

ThetaM=Join[ThetaM,{LIJ,LIMJ,LIJM,LIMJM}];

   
,{I,1,U},{J,I+1,U}];

(*Diagonale*)

Do[ 

{LIJ,LIMJM} = 
			{SCALING*GRIDI[Theta ,I,  INK2],
			 SCALING*GRIDI[Theta ,I, -INK2]};

ThetaM=Join[ThetaM,{LIJ,LIMJM}];	
   
,{I,1,U}];

ThetaM//Dimensions//Print;

ThetaM=Join[{SCALING*Theta},ThetaM];

likvec={};
LIKI = Sum[liki=LikN[{data[[1,i]],data[[2,i]]},Take[ThetaM,anzahl],system,misc];
           liki//NumberForm[#,20]&//Print;
           likvec=Join[likvec,{liki}];
           liki,
           {i,data//First//Length}]; (* u-Vektor!!*)

Return[LIKI];

LIK =LIKI//First;
LIKI=LIKI//Rest;

L2   = 2 LIK;

lin=0;
Do[ 

LIJ  =LIKI[[lin+=1]];
LIMJ =LIKI[[lin+=1]];
LIJM =LIKI[[lin+=1]];
LIMJM=LIKI[[lin+=1]];


H[[I,J]] = LIJ - LIMJ - LIJM + LIMJM;

,{I,1,U},{J,I+1,U}];  

H = H + Transpose[H]; 


(*Diagonale*)

Do[ 


LIJ  =LIKI[[lin+=1]];
LIMJM=LIKI[[lin+=1]];


H[[I,I]] = LIJ - L2 + LIMJM;

,{I,1,U}];  

H = H H4;

{H,LIK,LIKI}
]

:[font = input; preserveAspect; startGroup]
SetDirectory["Macintosh HD:MPW.ppc:MPW:Examples:hermann.mathlink.ppc:"]
link = Install["hermann"]
:[font = output; inactive; preserveAspect]
"Macintosh HD:MPW.ppc:MPW:Examples:hermann.mathlink.ppc"
;[o]
Macintosh HD:MPW.ppc:MPW:Examples:hermann.mathlink.ppc
:[font = output; inactive; preserveAspect; endGroup]
LinkObject["hermann", 17, 15]
;[o]
LinkObject[hermann, 17, 15]
:[font = input; preserveAspect; startGroup]
THETA={-4.5576825862377195, 1.7187318382554468, -2.414054222373312, 0.2073318551884139, -4.961985585864883, -1.532155417320036, 0.02532718335774624, 0.16356084983253183, -10.166216276050223, 0.7992846831688906, 1.6177091554148857, 4.527516468050178, 4.772185442360075, 2.488790592146984, 0.3910125085177115}

:[font = output; inactive; preserveAspect; endGroup]
{-4.5576825862377195, 1.7187318382554468, -2.414054222373312, 0.2073318551884139, -4.961985585864883, -1.532155417320036, 0.02532718335774624, 0.16356084983253183, -10.166216276050223, 0.7992846831688906, 1.6177091554148857, 4.527516468050178, 4.772185442360075, 2.488790592146984, 0.3910125085177115}
;[o]
{-4.55768, 1.71873, -2.41405, 0.207332, -4.96199, -1.53216, 0.0253272, 0.163561, -10.1662, 0.799285, 1.61771, 4.52752, 4.77219, 2.48879, 0.391013}
:[font = input; preserveAspect; startGroup]
FDIGITS=16
Z1=Map[Take[#,{1,384}]&,Z];
Z1//Dimensions
:[font = output; inactive; preserveAspect]
16
;[o]
16
:[font = output; inactive; preserveAspect; endGroup]
{2, 384}
;[o]
{2, 384}
:[font = input; preserveAspect; startGroup]
LIKI1= HesseTest[Z1,THETA,{system,{Lik1,cEKF1,_}},misc={-9,1}];
:[font = print; inactive; preserveAspect; endGroup]
                                                          -6                         -6            -6            -6                          -6            -6                                                      -6
INK: {0.0000275988, 0.0000104077, 0.0000146182, 6.05545 10  , 0.0000300471, 9.2779 10  , 6.05545 10  , 6.05545 10  , 0.0000615611, 6.05545 10  , 9.79596 10  , 0.0000274162, 0.0000288978, 0.0000150708, 6.05545 10  }
:[font = input; preserveAspect; startGroup]
LIKI1
:[font = output; inactive; preserveAspect; fontLeading = 0; endGroup]
{-105363.40352204567, -105363.40352202096, -105363.40352200838, -105363.40352209598, -105363.4035220848}
;[o]
{-105363., -105363., -105363., -105363., -105363.}
:[font = input; Cclosed; preserveAspect; startGroup]
2^7
anzahl=128
LIKI3= cHesse1Test[Z1,THETA,{system,{Lik1,cEKF1,_}},misc={-9,1}];
:[font = output; inactive; preserveAspect]
128
;[o]
128
:[font = output; inactive; preserveAspect]
128
;[o]
128
:[font = print; inactive; preserveAspect; endGroup]
                                                          -6                         -6            -6            -6                          -6            -6                                                      -6
INK: {0.0000275988, 0.0000104077, 0.0000146182, 6.05545 10  , 0.0000300471, 9.2779 10  , 6.05545 10  , 6.05545 10  , 0.0000615611, 6.05545 10  , 9.79596 10  , 0.0000274162, 0.0000288978, 0.0000150708, 6.05545 10  }
{450, 15}
 {-427.6029732810597, -427.602973562453, -427.6029740371517, -427.6029725250101, -427.6029729997142, -427.6029737322636, -427.6029738673403, -427.6029726948229, -427.6029728299005, -427.602974520159, -427.6029730794531, -427.602973482716, -427.6029720420157, -427.6029829066201, -427.6029646930313, -427.6029818691791, -427.6029636555918, -427.6029738163207, -427.6029737832831, -427.6029727788805, -427.602972745843, -427.6029732959263, -427.6029743039298, -427.6029722584917, -427.602973266484, -427.602971048657, -427.602976550988, -427.6029700112169, -427.6029755135475, -427.6029820335468, -427.6029655661209, -427.6029809961068, -427.6029645286805, -427.6029080810523, -427.6030395214904, -427.6029070422958, -427.6030384853667, -427.6029813380921, -427.6029662618574, -427.6029803006768, 
  -427.6029652243922, -427.6029544459259, -427.6029931570237, -427.6029534084719, -427.6029921195975, -427.6029990244545, -427.6029485751304, -427.6029979868215, -427.602947537883, -427.6030071509806, -427.6029404484591, -427.6030061135403, -427.6029394110189, -427.6030509774908, -427.6028966214032, -427.6030499400499, -427.6028955839637, -427.6029729761709, -427.602973111248, -427.6029734508723, -427.6029735859495, -427.6029737640657, -427.6029723233615, -427.6029742387659, -427.6029727980639, -427.602982150527, -427.6029639369394, -427.6029826252286, -427.6029644116404, -427.6029730602283, -427.6029730271907, -427.6029735349296, -427.6029735018922, -427.6029725398361, -427.6029735478349, -427.6029730145384, -427.6029740225352, -427.6029702925642, -427.6029757948957, -427.6029707672661, 
  -427.6029762695965, -427.6029812774546, -427.6029648100283, -427.6029817521558, -427.6029652847297, -427.6029073243325, -427.6030387660252, -427.6029077989721, -427.6030392407883, -427.6029805820317, -427.602965505733, -427.6029810566938, -427.6029659804734, -427.6029536898286, -427.6029924009363, -427.602954164526, -427.6029928756417, -427.6029982682694, -427.6029478191306, -427.6029987429633, -427.6029482938394, -427.6030063948882, -427.6029396923664, -427.6030068695891, -427.6029401670682, -427.6030502213983, -427.6028958653107, -427.6030506960991, -427.6028963400128, -427.6029739338769, -427.6029724931736, -427.602974068954, -427.6029726282508, -427.6029823203389, -427.6029641067509, -427.602982455416, -427.6029642418279, -427.6029732300399, -427.6029731970024, -427.602973365117, 
  -427.6029733320794, -427.6029727096484, -427.602973717646, -427.6029728447253, -427.6029738527235, -427.602970462376, -427.6029759647072, -427.6029705974535}
 {-7.729627163125765, -7.729627162944158, -7.729627161671939, -7.729627164579606, -7.72962716330739, -7.729627162407324, -7.729627162208773, -7.729627164042773, -7.729627163844223, -7.729627627982667, -7.729626696651421, -7.729627629616541, -7.729626698288445, -7.729628091881128, -7.729626232739966, -7.729628093516133, -7.729626234375861, -7.729627167497575, -7.729627157118527, -7.729627169133014, -7.729627158753986, -7.729623296966586, -7.729631028350409, -7.729623298603547, -7.729631029984343, -7.729626776569721, -7.72962754805414, -7.729626778204706, -7.729627549690053, -7.729628165485038, -7.729626159136494, -7.729628167120143, -7.729626160772288, -7.72962715784972, -7.729627166768264, -7.729627159484814, -7.729627168404068, -7.729626499545589, -7.729627825094122, -7.729626501181871, 
  -7.729627826728738, -7.729629650157325, -7.72962467475396, -7.729629651795747, -7.729624676386436, -7.729627163664276, -7.729627160951831, -7.729627165299722, -7.729627162587283, -7.729633147107202, -7.729621177473562, -7.729633148742929, -7.729621179108733, -7.729642305737945, -7.729612018654265, -7.72964230737263, -7.729612020290478, -7.729627163861149, -7.729627163662599, -7.729627162588931, -7.729627162390381, -7.729627629435754, -7.729626698105983, -7.729627628163437, -7.729626696833865, -7.72962809333474, -7.729626234194005, -7.729628092062504, -7.729626232921804, -7.729627168951395, -7.729627158572356, -7.729627167679177, -7.729627157300139, -7.72962329842114, -7.729631029803504, -7.729623297148976, -7.729631028531232, -7.729626778023323, -7.729627549508187, -7.729626776751086, 
  -7.729627548235989, -7.729628166938697, -7.729626160590485, -7.729628165666466, -7.729626159318281, -7.729627159303375, -7.729627168222259, -7.729627158031143, -7.729627166950055, -7.729626500999814, -7.729627826547546, -7.729626499727629, -7.729627825275295, -7.729629651612579, -7.729624676206355, -7.729629650340476, -7.729624674934023, -7.729627165118099, -7.729627162405658, -7.729627163845882, -7.72962716113344, -7.72963314856116, -7.729621178927253, -7.729633147288953, -7.729621177655025, -7.729642307191402, -7.729612020108457, -7.729642305919156, -7.729612018836269, -7.729627628898873, -7.729626697569197, -7.729627628700317, -7.729626697370652, -7.729628092797898, -7.72962623365718, -7.729628092599346, -7.72962623345863, -7.729627168414561, -7.729627158035522, -7.729627168216011, 
  -7.729627157836973, -7.729623297884356, -7.729631029266621, -7.729623297685761, -7.729631029068115, -7.72962677748648, -7.729627548971362, -7.729626777287929}
 {-695.9074425857037, -695.9074189397161, -695.9074191634395, -695.907466008006, -695.9074662317262, -695.9074192061732, -695.9074188969841, -695.9074662744632, -695.9074659652702, -695.907421279812, -695.9074168233704, -695.9074683480793, -695.9074638916794, -695.9074253908629, -695.9074127123481, -695.9074724591494, -695.9074597806378, -695.9074190054433, -695.9074190977141, -695.9074660737313, -695.9074661660021, -695.9074451187986, -695.9073929849298, -695.9074921869439, -695.9074400533609, -695.907416490837, -695.9074216123264, -695.9074635591245, -695.907468680615, -695.9074175819255, -695.9074205212843, -695.90746465021, -695.9074675895762, -695.9072333708278, -695.9076047361838, -695.9072804364057, -695.9076518071825, -695.9074321894083, -695.9074059141713, -695.9074792577174, 
  -695.9074529824385, -695.907477903025, -695.9073602029449, -695.9075249712761, -695.90740727127, -695.9073851301507, -695.9074529738322, -695.9074321976456, -695.9075000429136, -695.9074309466833, -695.9074071564769, -695.907478014976, -695.9074542247606, -695.9074092555497, -695.907428849482, -695.907456323855, -695.9074759177528, -695.9074426284374, -695.9074423192466, -695.9074428521594, -695.9074425429684, -695.9074447020642, -695.9074402456449, -695.9074449257875, -695.9074404693655, -695.9074488131249, -695.9074361346128, -695.9074490368481, -695.9074363583333, -695.9074424277065, -695.9074425199773, -695.9074426514287, -695.9074427436993, -695.9074685409965, -695.9074164072588, -695.9074687647066, -695.9074166309925, -695.9074399131052, -695.9074450345847, -695.9074401368166, 
  -695.9074452583172, -695.9074410041874, -695.9074439435492, -695.9074412279084, -695.9074441672721, -695.9072567917528, -695.9076281597859, -695.9072570154416, -695.907628383541, -695.90745561172, -695.9074293363862, -695.907455835366, -695.907429560184, -695.907501325276, -695.9073836252206, -695.9075015489854, -695.9073838489547, -695.907408552025, -695.9074763964847, -695.9074087757318, -695.9074766202217, -695.907454368947, -695.9074305787399, -695.9074545926727, -695.907430802458, -695.9074326778172, -695.9074522717413, -695.9074329015481, -695.907452495454, -695.9074449685221, -695.9074405121015, -695.9074446593311, -695.9074402029105, -695.9074490795826, -695.9074364010694, -695.9074487703917, -695.9074360918782, -695.9074426941638, -695.9074427864346, -695.907442384973, 
  -695.9074424772436, -695.9074688074456, -695.9074166737238, -695.9074684982587, -695.9074163645288, -695.907440179557, -695.9074453010475, -695.9074398703665}
 {-340.028269909247, -340.0282713736613, -340.0282713515487, -340.0282684669474, -340.0282684448349, -340.0282713630905, -340.0282713621196, -340.0282684563765, -340.0282684554057, -340.028271381714, -340.0282713434962, -340.0282684750001, -340.0282684367823, -340.0282728602208, -340.028269864992, -340.0282699535069, -340.0282669582781, -340.0282713575623, -340.0282713676478, -340.0282684508484, -340.0282684609338, -340.0282713875105, -340.028271337706, -340.0282684807965, -340.0282684309921, -340.0282711271053, -340.0282715981068, -340.0282682203914, -340.028268691393, -340.0282726213756, -340.0282701038458, -340.0282697146618, -340.0282671971318, -340.0282703845575, -340.0282723411089, -340.0282674778413, -340.0282694343973, -340.0282714456837, -340.028271279581, -340.0282685389698, 
  -340.0282683728671, -340.0282825978304, -340.0282601279822, -340.0282796911165, -340.0282572212683, -340.0282774113633, -340.0282653138103, -340.0282745046494, -340.0282624070964, -340.0282773755316, -340.0282653496429, -340.0282744688177, -340.028262442929, -340.0282836099437, -340.0282591151767, -340.0282807032299, -340.0282562084628, -340.0282699207888, -340.0282699198178, -340.0282698986763, -340.0282698977053, -340.0282699394124, -340.0282699011945, -340.0282699172998, -340.0282698790821, -340.0282714179191, -340.0282684226902, -340.0282713958065, -340.0282684005778, -340.0282699152606, -340.0282699253461, -340.0282698931481, -340.0282699032336, -340.0282699452087, -340.0282698954044, -340.0282699230962, -340.0282698732918, -340.0282696848036, -340.0282701558051, 
  -340.0282696626911, -340.0282701336927, -340.028271179074, -340.0282686615441, -340.0282711569614, -340.0282686394315, -340.0282689422526, -340.0282708988104, -340.0282689201441, -340.0282708766939, -340.0282700033821, -340.0282698372791, -340.0282699812693, -340.028269815167, -340.0282811555287, -340.0282586856805, -340.0282811334162, -340.0282586635679, -340.0282759690614, -340.0282638715087, -340.0282759469492, -340.028263849396, -340.02827593323, -340.0282639073411, -340.0282759111172, -340.0282638852288, -340.028282167642, -340.028257672875, -340.0282821455296, -340.0282576507625, -340.0282699288415, -340.0282698906237, -340.0282699278706, -340.0282698896528, -340.0282714073482, -340.0282684121194, -340.0282714063773, -340.0282684111485, -340.0282699046898, -340.0282699147753, 
  -340.0282699037188, -340.0282699138043, -340.0282699346379, -340.0282698848334, -340.0282699336669, -340.0282698838627, -340.0282696742328, -340.0282701452343, -340.0282696732619}
 {-244.0551044679856, -244.0550921775382, -244.0550884674912, -244.0551204686503, -244.0551167585784, -244.0550908976127, -244.0550897474159, -244.0551191887188, -244.055118038509, -244.0550946881839, -244.0550859568753, -244.0551229792567, -244.0551142480019, -244.0551018565811, -244.0550787885235, -244.0551301476848, -244.055107079619, -244.0550903537328, -244.0550902912959, -244.0551186448324, -244.0551185823955, -244.055182086453, -244.0549985594042, -244.0552103774582, -244.0550268505982, -244.0550847389163, -244.0550959061695, -244.0551130300198, -244.0551241972651, -244.0550610521194, -244.0551195931165, -244.055089343217, -244.0551478842182, -244.0553209403116, -244.0548597113311, -244.0553492355298, -244.0548879983122, -244.0550712342886, -244.0551094115053, -244.055099525301, 
  -244.0551377026921, -244.0548444089697, -244.0553362423452, -244.0548727001095, -244.0553645334044, -244.0551252388673, -244.055055406475, -244.0551535291621, -244.0550836983794, -244.0551441709437, -244.055036474061, -244.0551724620518, -244.0550647651522, -244.0550339789527, -244.0551466739519, -244.0550622700617, -244.0551749650422, -244.0551068981176, -244.0551057479142, -244.0551031880582, -244.0551020378549, -244.0551106886729, -244.0551019573896, -244.0551069786121, -244.0550982473318, -244.0551178570892, -244.0550947890186, -244.0551141470208, -244.0550910789682, -244.0551063542344, -244.0551062917975, -244.055102644175, -244.0551025817382, -244.0551980869067, -244.0550145599537, -244.0551943768487, -244.0550108498929, -244.0551007394222, -244.0551119066669, -244.0550970293582, 
  -244.055108196612, -244.0550770526199, -244.0551355936193, -244.0550733425608, -244.0551318835596, -244.0553369429121, -244.0548757097339, -244.0553332327736, -244.0548719997536, -244.0550872346838, -244.0551254121133, -244.05508352475, -244.0551217019284, -244.0548604094895, -244.0553522428284, -244.0548566994339, -244.0553485327654, -244.0551412389475, -244.055071407398, -244.0551375289261, -244.0550676973006, -244.0551601714496, -244.0550524745583, -244.0551564613901, -244.055048764499, -244.0550499794571, -244.0551626744508, -244.0550462694016, -244.0551589643875, -244.0551094087437, -244.055100677462, -244.0551082585404, -244.0550995272585, -244.0551165771564, -244.0550935090945, -244.0551154269529, -244.0550923588914, -244.055105074306, -244.055105011869, -244.0551039241026, 
  -244.0551038616658, -244.0551968069768, -244.0550132800268, -244.0551956567778, -244.055012129819, -244.0550994594921, -244.05511062674, -244.0550983092874}
 {-687.4045841845148, -687.4045230684303, -687.4045466157847, -687.404621753308, -687.4046453008677, -687.404534546395, -687.4045351378092, -687.4046332313732, -687.4046338227918, -687.4045039701275, -687.4045657141197, -687.4046026552525, -687.4046643989557, -687.4044714600624, -687.4045982242798, -687.4045701450055, -687.4046969092978, -687.4045344206408, -687.4045352635632, -687.4046331056219, -687.4046339485429, -687.4045340581795, -687.4045356266206, -687.4046327431584, -687.4046343116026, -687.404534340205, -687.4045353441997, -687.4046330251909, -687.4046340291748, -687.4045401744972, -687.4045295097517, -687.4046388594783, -687.404628194732, -687.4042559153727, -687.4048137757336, -687.404354594864, -687.4049124662031, -687.4044378779795, -687.4046318069878, -687.4045365630218, 
  -687.4047304919067, -687.4045202435346, -687.4045494424375, -687.4046189284909, -687.4046481274421, -687.4044922760961, -687.4045774093046, -687.4045909595518, -687.4046760958104, -687.4044651605049, -687.4046045253936, -687.4045638454167, -687.4047032104428, -687.4045641571202, -687.404505526668, -687.4046628420958, -687.4046042116531, -687.4045721150836, -687.4045727064997, -687.4045956625404, -687.4045962539571, -687.4045415388801, -687.4046032827461, -687.4045650863553, -687.4046268301849, -687.4045090287026, -687.4046357930186, -687.4045325762208, -687.4046593404145, -687.4045719893306, -687.4045728322526, -687.404595536788, -687.4045963797093, -687.4045716268691, -687.4045731953105, -687.4045951743246, -687.4045967427688, -687.4045719088976, -687.4045729128865, -687.404595456354, 
  -687.404596460344, -687.4045777431872, -687.404567078441, -687.4046012906442, -687.4045906258982, -687.4042934816127, -687.4048513468727, -687.4043170284798, -687.4048748949197, -687.4044754467621, -687.4046693755846, -687.404498994095, -687.4046929231659, -687.4045578122157, -687.4045870111352, -687.4045813596652, -687.4046105585998, -687.4045298441712, -687.4046149786089, -687.4045533913325, -687.4046385263618, -687.4045027291588, -687.4046420941188, -687.4045262766184, -687.4046656415733, -687.4046017258078, -687.4045430953593, -687.4046252732635, -687.4045666428176, -687.4045530169039, -687.4046147607523, -687.404553608321, -687.404615352168, -687.4045205067473, -687.4046472710037, -687.4045210981653, -687.4046478624185, -687.4045834673455, -687.4045843102675, -687.4045840587624, 
  -687.4045849016836, -687.404583104871, -687.4045846733381, -687.4045836963115, -687.4045852647304, -687.404583386905, -687.4045843909085, -687.4045839783355}
 {-416.5046989137368, -416.5047012536915, -416.5047010400807, -416.5046967874149, -416.5046965738101, -416.5047011865878, -416.5047011071839, -416.5046967203147, -416.5046966409098, -416.5047002148711, -416.5047020789042, -416.504695748597, -416.5046976126311, -416.504703485965, -416.504698807833, -416.5046990196908, -416.5046943415601, -416.5047012230322, -416.5047010707395, -416.5046967567585, -416.504696604466, -416.5047085062914, -416.5046937875703, -416.5047040399957, -416.5046893213189, -416.5047028270425, -416.5046994667447, -416.5046983607693, -416.5046950004708, -416.5047041749129, -416.5046981188884, -416.5046997086388, -416.5046936526154, -416.504667455041, -416.504734840638, -416.5046629881585, -416.5047303749732, -416.50469252509, -416.5047097688979, -416.5046880588244, 
  -416.5047053026163, -416.5047363073958, -416.5046659880828, -416.5047318411146, -416.5046615218167, -416.504709296018, -416.5046929977519, -416.50470482968, -416.5046885315429, -416.5047047642854, -416.5046975295695, -416.5047002980112, -416.5046930632966, -416.5047201307273, -416.504682163119, -416.5047156644563, -416.5046776968429, -416.5046990602431, -416.5046989808388, -416.5046988466353, -416.5046987672309, -416.5046980885267, -416.5046999525588, -416.5046978749174, -416.5046997389522, -416.5047013596207, -416.5046966814875, -416.5047011460109, -416.5046964678815, -416.5046990966872, -416.5046989443947, -416.5046988830793, -416.5046987307869, -416.5047063799348, -416.504691661237, -416.5047061663282, -416.504691447628, -416.5047007006985, -416.504697340399, -416.5047004870893, 
  -416.5046971267925, -416.5047020485678, -416.5046959925437, -416.5047018349599, -416.5046957789359, -416.5046653283971, -416.504732714592, -416.5046651147785, -416.5047325009952, -416.5046903987574, -416.5047076425408, -416.504690185133, -416.5047074289494, -416.5047341810479, -416.5046638617407, -416.5047339674383, -416.5046636481346, -416.5047071696402, -416.50469087144, -416.5047069560337, -416.5046906578309, -416.5047026379408, -416.5046954032244, -416.5047024243317, -416.5046951896177, -416.5047180043831, -416.5046800367733, -416.5047177907762, -416.5046798231645, -416.5046980214241, -416.5046998854576, -416.5046979420195, -416.5046998060531, -416.5047012925179, -416.5046966143865, -416.5047012131134, -416.5046965349821, -416.5046990295854, -416.5046988772927, -416.5046989501809, 
  -416.5046987978884, -416.5047063128339, -416.5046915941342, -416.5047062334286, -416.5046915147306, -416.5047006335961, -416.5046972732976, -416.5047005541913}
 {-299.853886751758, -299.8538909010093, -299.853890929794, -299.8538825737362, -299.8538826025237, -299.8538909190172, -299.8538909117856, -299.8538825917456, -299.8538825845139, -299.8538908351143, -299.8538909956901, -299.8538825078426, -299.8538826684185, -299.8538946684837, -299.8538871623386, -299.8538863412116, -299.8538788350674, -299.8538909323027, -299.8538908985001, -299.8538826050311, -299.8538825712284, -299.8538937257991, -299.8538881050358, -299.8538853985215, -299.8538797777701, -299.8538933314363, -299.8538884993785, -299.853885004165, -299.8538801721065, -299.8538951671096, -299.8538866637324, -299.8538868398379, -299.8538783364608, -299.85389809135, -299.853883741008, -299.8538897642634, -299.8538754135513, -299.853896863323, -299.8538849676613, -299.8538885360463, 
  -299.8538766403946, -299.8538574998667, -299.8539243325765, -299.8538491725977, -299.8539160053022, -299.853902826652, -299.8538790040813, -299.8538944993745, -299.8538706768156, -299.8539023492035, -299.8538794815401, -299.8538940219316, -299.8538711542687, -299.8539110201805, -299.8538708106456, -299.8539026929094, -299.8538624833733, -299.853886740981, -299.8538867337494, -299.8538867697672, -299.8538867625355, -299.8538866570785, -299.8538868176536, -299.8538866858637, -299.8538868464405, -299.8538904904473, -299.8538829843026, -299.8538905192333, -299.8538830130888, -299.8538867542666, -299.8538867204639, -299.8538867830527, -299.85388674925, -299.8538895477608, -299.8538839270017, -299.8538895765452, -299.8538839557896, -299.8538891534004, -299.8538843213421, -299.8538891821864, 
  -299.8538843501283, -299.8538909890734, -299.8538824856962, -299.8538910178595, -299.8538825144824, -299.8538939133876, -299.8538795628979, -299.8538939422111, -299.8538795916468, -299.8538926852831, -299.8538807896288, -299.8538927140715, -299.8538808184125, -299.8538533218313, -299.8539201545394, -299.8538533506185, -299.8539201833245, -299.8538986486133, -299.8538748260477, -299.8538986773987, -299.8538748548346, -299.8538981711677, -299.8538753035034, -299.8538981999527, -299.8538753322908, -299.8539068421444, -299.8538666326092, -299.8539068709309, -299.8538666613951, -299.8538866750867, -299.8538868356627, -299.853886667855, -299.8538868284309, -299.8538905084559, -299.8538830023112, -299.8538905012242, -299.8538829950796, -299.8538867722753, -299.8538867384725, 
  -299.8538867650435, -299.8538867312408, -299.8538895657693, -299.8538839450105, -299.8538895585363, -299.8538839377803, -299.853889171409, -299.8538843393508, -299.8538891641774}
 {-234.8607256747771, -234.8607314365562, -234.8607309550097, -234.8607203945721, -234.8607199130295, -234.8607312641414, -234.8607311274235, -234.8607202221592, -234.8607200854413, -234.860730343799, -234.8607320477652, -234.8607193018152, -234.8607210057848, -234.860733359656, -234.8607290319379, -234.860722317673, -234.8607179899566, -234.860731152073, -234.8607312394917, -234.8607201100909, -234.8607201975097, -234.8607294545297, -234.860732937035, -234.8607184125526, -234.8607218950479, -234.8607365953533, -234.8607257962189, -234.8607255533714, -234.8607147542366, -234.8607281846427, -234.8607342069548, -234.8607171426607, -234.8607231649726, -234.8607431225101, -234.8607192717167, -234.8607320808227, -234.86070822944, -234.8607503275614, -234.8607120643032, -234.8607392855738, 
  -234.8607010223265, -234.860674243362, -234.8607881497528, -234.860663201381, -234.8607771077694, -234.8607567192264, -234.8607056722411, -234.8607456772096, -234.8606946302936, -234.8607231225159, -234.8607392695624, -234.8607120805331, -234.860728227581, -234.8607151532726, -234.8607472399928, -234.86070411129, -234.8607361980111, -234.8607259839089, -234.8607258471911, -234.8607255023643, -234.8607253656464, -234.8607250635668, -234.8607267675326, -234.86072458202, -234.8607262859901, -234.8607280794246, -234.8607237517043, -234.860727597877, -234.8607232701627, -234.8607258718406, -234.8607259592594, -234.860725390296, -234.8607254777148, -234.8607241743006, -234.8607276567993, -234.8607236927545, -234.8607271752563, -234.8607313151205, -234.8607205159869, -234.8607308335769, 
  -234.8607200344413, -234.8607229044103, -234.8607289267225, -234.8607224228659, -234.8607284451777, -234.8607378423877, -234.8607139913743, -234.8607373609177, -234.8607135097551, -234.8607450473213, -234.8607067840785, -234.8607445657865, -234.860706302524, -234.86066896313, -234.86078286952, -234.8606684815858, -234.860782387975, -234.8607514389743, -234.8607003920283, -234.8607509574344, -234.8606999104791, -234.8607178422838, -234.8607339893298, -234.860717360738, -234.8607335077864, -234.8607098730401, -234.8607419597605, -234.8607093914952, -234.8607414782162, -234.8607248911518, -234.8607265951197, -234.860724754434, -234.8607264584019, -234.8607279070092, -234.8607235792919, -234.8607277702913, -234.8607234425741, -234.8607256994267, -234.8607257868454, -234.8607255627088, 
  -234.8607256501276, -234.8607240018867, -234.8607274843853, -234.8607238651671, -234.8607273476692, -234.8607311427072, -234.8607203435723, -234.860731005989}
 {-302.9304401161887, -302.9304401647968, -302.9304401169862, -302.9304401153912, -302.9304400675807, -302.9304401404054, -302.9304401413776, -302.9304400909998, -302.930440091972, -302.9304405242424, -302.9304397575432, -302.9304404748348, -302.9304397081396, -302.9304446479627, -302.9304356338344, -302.9304445985571, -302.9304355844288, -302.9304401304644, -302.9304401513186, -302.9304400810588, -302.9304401019131, -302.9304401070593, -302.9304401747237, -302.9304400576538, -302.9304401253181, -302.9304400596955, -302.9304402220874, -302.93044001029, -302.9304401726818, -302.9304401532797, -302.9304401285034, -302.9304401038741, -302.9304400790978, -302.9304410663757, -302.9304392154091, -302.9304410169669, -302.9304391660069, -302.9304359898009, -302.9304442921268, -302.9304359403964, 
  -302.9304442427201, -302.9304399260333, -302.9304403557497, -302.9304398766278, -302.9304403063441, -302.9304401587665, -302.9304401230165, -302.9304401093607, -302.9304400736112, -302.9304474992408, -302.930432782555, -302.9304474498358, -302.9304327331489, -302.9304401476135, -302.9304401341696, -302.9304400982079, -302.930440084764, -302.9304401396079, -302.93044014058, -302.9304400917973, -302.9304400927695, -302.9304405234445, -302.930439756746, -302.9304404756326, -302.9304397089368, -302.9304446471652, -302.9304356330368, -302.9304445993545, -302.9304355852264, -302.9304401296668, -302.9304401505211, -302.9304400818563, -302.9304401027106, -302.9304401062618, -302.9304401739262, -302.9304400584512, -302.9304401261155, -302.930440058898, -302.9304402212899, -302.9304400110875, 
  -302.9304401734793, -302.9304401524821, -302.9304401277058, -302.9304401046716, -302.9304400798953, -302.9304410655766, -302.9304392146133, -302.930441017766, -302.9304391668027, -302.9304359890039, -302.9304442913287, -302.9304359411933, -302.9304442435182, -302.9304399252358, -302.9304403549522, -302.9304398774253, -302.9304403071416, -302.9304401579689, -302.930440122219, -302.9304401101583, -302.9304400744085, -302.9304474984435, -302.9304327817573, -302.9304474506331, -302.9304327339465, -302.9304401468159, -302.9304401333721, -302.9304400990054, -302.9304400855616, -302.9304404990524, -302.9304397323553, -302.9304405000247, -302.9304397333275, -302.9304446227738, -302.9304356086455, -302.9304446237459, -302.9304356096176, -302.9304401052754, -302.9304401261297, -302.9304401062476, 
  -302.9304401271019, -302.9304400818704, -302.9304401495348, -302.9304400828425, -302.9304401505069, -302.9304400345067, -302.9304401968985, -302.9304400354788}
 {-24.70134703214519, -24.7013470487335, -24.70134704735872, -24.70134701693171, -24.70134701555692, -24.70134704825035, -24.70134704784187, -24.70134701644856, -24.70134701604008, -24.70134856904424, -24.70134552706759, -24.7013485372386, -24.70134549526966, -24.70134746442189, -24.70134663167214, -24.70134743262044, -24.70134659987001, -24.70134706538727, -24.70134703070495, -24.70134703358546, -24.70134699890318, -24.70133939205238, -24.70135470479355, -24.70133936025911, -24.70135467298324, -24.70134748239937, -24.70134661369565, -24.70134745059786, -24.70134658189358, -24.7013479502384, -24.70134614586006, -24.70134791843614, -24.70134611405873, -24.70134719662457, -24.70134689946974, -24.70134716482205, -24.70134686766867, -24.70134498913357, -24.7013491069861, -24.70134495733291, 
  -24.70134907518317, -24.7013520817719, -24.70134201466064, -24.70135204997413, -24.70134198285483, -24.70134704990281, -24.70134704618943, -24.70134701810101, -24.70134701438764, -24.70135239065332, -24.70134170541525, -24.70135235885262, -24.70134167361235, -24.70136130402931, -24.70133279188022, -24.70136127222568, -24.70133276008027, -24.70134703303683, -24.70134703262834, -24.70134703166204, -24.70134703125356, -24.70134855382878, -24.701345511856, -24.70134855245401, -24.7013455104812, -24.70134744920854, -24.70134661645845, -24.70134744783374, -24.70134661508367, -24.70134705017374, -24.70134701549144, -24.70134704879895, -24.70134701411665, -24.7013393768432, -24.70135468957568, -24.70133937546824, -24.70135468820107, -24.70134746718598, -24.70134659848198, -24.70134746581119, 
  -24.7013465971072, -24.70134793502464, -24.70134613064677, -24.70134793364986, -24.70134612927198, -24.70134718141067, -24.70134688425658, -24.7013471800359, -24.70134688288179, -24.70134497392062, -24.70134909177199, -24.7013449725458, -24.70134909039724, -24.70135206656042, -24.70134199944507, -24.70135206518556, -24.70134199807036, -24.70134703468928, -24.7013470309759, -24.7013470333145, -24.70134702960112, -24.70135237544035, -24.70134169020116, -24.70135237406555, -24.7013416888264, -24.70136128881485, -24.70133277666763, -24.7013612874401, -24.70133277529281, -24.70134855334565, -24.70134551137284, -24.70134855293715, -24.70134551096437, -24.70134744872538, -24.7013466159753, -24.7013474483169, -24.70134661556682, -24.70134704969058, -24.70134701500828, -24.7013470492821, 
  -24.70134701459981, -24.70133937635998, -24.7013546890926, -24.70133937595146, -24.70135468868416, -24.70134746670283, -24.70134659799883, -24.70134746629435}
 {-362.9610125248072, -362.9610138118069, -362.9610138319535, -362.9610112176634, -362.9610112378106, -362.9610138808967, -362.9610137628637, -362.961011286754, -362.9610111687201, -362.9610136396698, -362.9610140040907, -362.9610110455268, -362.9610114099474, -362.9610150086319, -362.9610126351314, -362.9610124144887, -362.9610100409883, -362.9610140409007, -362.9610136028598, -362.9610114467575, -362.9610110087166, -362.961014634608, -362.9610130091591, -362.9610120404642, -362.9610104150165, -362.9610141773118, -362.9610134664501, -362.9610115831686, -362.9610108723069, -362.9610135939885, -362.9610140499327, -362.9610109998454, -362.9610114557895, -362.961010475295, -362.9610171689201, -362.9610078810699, -362.9610145748589, -362.961009582892, -362.9610180609219, -362.9610069887509, 
  -362.9610154667767, -362.9610225644506, -362.9610050796743, -362.9610199703063, -362.9610024855323, -362.9610196708422, -362.9610079728851, -362.9610170766953, -362.9610053787458, -362.9610180342091, -362.9610096095482, -362.9610154400659, -362.9610070154051, -362.9610210277518, -362.9610066160254, -362.9610184336089, -362.961004021882, -362.9610125737505, -362.961012455717, -362.9610125938975, -362.9610124758639, -362.9610123325236, -362.9610126969441, -362.9610123526704, -362.9610127170912, -362.9610137014855, -362.9610113279851, -362.9610137216324, -362.961011348132, -362.9610127337543, -362.9610122957133, -362.9610127539011, -362.9610123158604, -362.9610133274612, -362.961011702013, -362.9610133476084, -362.9610117221598, -362.9610128701653, -362.9610121593037, -362.9610128903123, 
  -362.9610121794506, -362.9610122868421, -362.9610127427862, -362.961012306989, -362.9610127629332, -362.9610091681101, -362.9610158618122, -362.9610091882521, -362.9610158819641, -362.9610082757478, -362.9610167537733, -362.9610082958924, -362.9610167739227, -362.9610212573037, -362.9610037725284, -362.9610212774505, -362.9610037926754, -362.9610183636941, -362.9610066657405, -362.9610183838408, -362.9610066858877, -362.9610167270628, -362.9610083024018, -362.9610167472096, -362.9610083225489, -362.9610197206055, -362.9610053088789, -362.9610197407524, -362.9610053290258, -362.9610124016138, -362.9610127660345, -362.9610122835802, -362.961012648001, -362.9610137705757, -362.9610113970753, -362.9610136525423, -362.9610112790418, -362.9610128028445, -362.9610123648036, -362.961012684811, 
  -362.9610122467701, -362.9610133965516, -362.9610117711032, -362.9610132785179, -362.9610116530698, -362.9610129392556, -362.9610122283939, -362.9610128212221}
 {-12.8807075476118, -12.88072544100807, -12.88072380184055, -12.88069129348109, -12.88068965433385, -12.88072477520596, -12.88072446764246, -12.88069062768727, -12.88069032012747, -12.88072419208923, -12.88072505077689, -12.88069004457127, -12.88069090326117, -12.88072558879834, -12.8807236540594, -12.8806914412809, -12.88068950654317, -12.88072460960166, -12.88072463324677, -12.88069046208483, -12.88069048572992, -12.88068995393947, -12.88075928949787, -12.88065580643908, -12.88072514196456, -12.88071977045676, -12.88072947240236, -12.88068562293904, -12.88069532488639, -12.88071959832811, -12.88072964454285, -12.8806854508115, -12.88069549702578, -12.88069256931691, -12.8807566738876, -12.88065842181182, -12.88072252635901, -12.88072530304951, -12.88072393984264, -12.88069115551064, 
  -12.88068979234782, -12.88075579621267, -12.8806934471382, -12.88072164870461, -12.88065929961257, -12.88071523797006, -12.8807340051139, -12.88068109082802, -12.88069985722224, -12.88073061959512, -12.88071862321795, -12.8806964720782, -12.88068447570118, -12.88070898375834, -12.88074026029403, -12.88067483624038, -12.88070611277831, -12.88070852097147, -12.88070821340972, -12.88070688181399, -12.88070657425243, -12.88070793785563, -12.88070879654324, -12.88070629869708, -12.88070715738703, -12.88070933456465, -12.88070739982585, -12.8807076954068, -12.88070576066894, -12.88070835536804, -12.88070837901315, -12.88070671621067, -12.88070673985577, -12.8806736997135, -12.88074303525659, -12.88067206055727, -12.88074139609806, -12.88070351622317, -12.88071321816871, -12.88070187706485, 
  -12.88071157901226, -12.88070334409456, -12.88071339030916, -12.88070170493727, -12.88071175115169, -12.88067631507987, -12.8807404196574, -12.88067467594108, -12.88073878048143, -12.88070904881625, -12.88070768560865, -12.88070740963611, -12.88070604647403, -12.88073954198341, -12.88067719290022, -12.88073790282609, -12.88067555374277, -12.88069898391428, -12.88071775070242, -12.88069734477602, -12.88071611152593, -12.88071436536153, -12.8807023689843, -12.88071272620402, -12.88070072982704, -12.88069272952378, -12.88072400606135, -12.88069109036716, -12.88072236690321, -12.8807072720571, -12.88070813074586, -12.88070696449542, -12.88070782318422, -12.88070866876646, -12.88070673402812, -12.8807083612048, -12.88070642646647, -12.88070768957008, -12.88070771321519, -12.88070738200843, 
  -12.88070740565354, -12.88067303391717, -12.880742369457, -12.8806727263534, -12.88074206189746, -12.88070285042483, -12.88071255237112, -12.88070254286299}
 {-334.4941106220189, -334.4941122099454, -334.4941126953393, -334.4941085487136, -334.4941090341114, -334.4941124450453, -334.4941124602387, -334.4941087838155, -334.4941087990089, -334.4941120076103, -334.4941128976752, -334.4941083463819, -334.4941092364438, -334.4941131399376, -334.4941117653605, -334.494109478707, -334.4941081041314, -334.4941124447754, -334.4941124605087, -334.4941087835456, -334.4941087992788, -334.4941124388537, -334.4941124664304, -334.4941087776249, -334.4941088051995, -334.4941124808944, -334.4941124243897, -334.4941088196647, -334.4941087631596, -334.4941124751152, -334.4941124301692, -334.4941088138854, -334.4941087689393, -334.4941296027444, -334.49409530375, -334.4941259418134, -334.4940916422213, -334.4941197445927, -334.4941051608251, -334.494116083361, 
  -334.4941014995971, -334.4941125409677, -334.4941123643165, -334.4941088797375, -334.4941087030869, -334.4941167449272, -334.4941081603521, -334.4941130836733, -334.4941044991462, -334.4941155700851, -334.4941093352163, -334.4941119088538, -334.494105673988, -334.494112454945, -334.4941124503392, -334.4941087937151, -334.4941087891093, -334.4941103717245, -334.4941103869179, -334.4941108571204, -334.4941108723138, -334.4941099342905, -334.4941108243533, -334.4941104196858, -334.4941113097497, -334.4941110666157, -334.4941096920407, -334.4941115520128, -334.4941101774352, -334.4941103714545, -334.494110387188, -334.4941108568504, -334.4941108725837, -334.4941103655334, -334.4941103931091, -334.4941108509293, -334.4941108785049, -334.4941104075737, -334.4941103510688, -334.4941108929696, 
  -334.4941108364646, -334.4941104017944, -334.4941103568485, -334.4941108871903, -334.4941108422442, -334.4941275295522, -334.4940932303005, -334.4941280149896, -334.4940937156548, -334.494117671267, -334.4941030875093, -334.4941181566708, -334.4941035728971, -334.4941104676467, -334.4941102909958, -334.4941109530426, -334.4941107763916, -334.4941146715976, -334.4941060870401, -334.4941151569869, -334.4941065724423, -334.494113496764, -334.4941072618957, -334.4941139821588, -334.4941077472926, -334.4941103816242, -334.4941103770183, -334.49411086702, -334.4941108624142, -334.4941101693912, -334.4941110594546, -334.4941101845846, -334.494111074648, -334.4941113017172, -334.494109927141, -334.4941113169107, -334.4941099423344, -334.4941106065555, -334.4941106222888, -334.4941106217489, 
  -334.4941106374823, -334.4941106006347, -334.4941106282097, -334.4941106158275, -334.4941106434038, -334.4941106426744, -334.4941105861699, -334.4941106578683}
 {-259.8039994016322, -259.8040002789582, -259.8040007787784, -259.803998024497, -259.8039985243236, -259.8040005202802, -259.8040005374559, -259.8039982658221, -259.803998282998, -259.8039998723054, -259.8040011854327, -259.8039976178491, -259.8039989309729, -259.8040009861212, -259.8040000716299, -259.8039987316619, -259.8039978171731, -259.8040005183096, -259.8040005394265, -259.8039982638516, -259.8039982849685, -259.8039975771056, -259.8040034806869, -259.8039953226562, -259.8040012262204, -259.8039989486019, -259.8040021091518, -259.8039966941436, -259.803999854694, -259.8040025915823, -259.8039984661735, -259.8040003371243, -259.8039962117154, -259.8040123440138, -259.80398871463, -259.8040100898731, -259.8039864598547, -259.8040051174629, -259.8039959403782, -259.8040028629986, 
  -259.8039936859264, -259.8040155450864, -259.8039855135358, -259.8040132906322, -259.803983259074, -259.8040052762634, -259.8039957814597, -259.8040030217744, -259.8039935270327, -259.8040044494131, -259.8039966083258, -259.8040021949538, -259.8039943538691, -259.8040122695967, -259.8039887880727, -259.8040100151378, -259.8039865336156, -259.8039991431329, -259.8039991603086, -259.8039996429562, -259.803999660132, -259.803998495159, -259.8039998082843, -259.8039989949822, -259.804000308108, -259.8039996089729, -259.8039986944836, -259.804000108797, -259.8039991943062, -259.8039991411623, -259.8039991622792, -259.8039996409857, -259.8039996621026, -259.8039961999622, -259.8040021035357, -259.8039966997864, -259.8040026033583, -259.8039975714543, -259.8040007320047, -259.8039980712779, 
  -259.8040012318278, -259.804001214435, -259.8039970890261, -259.8040017142584, -259.8039975888495, -259.8040109670062, -259.8039873373431, -259.8040114668676, -259.8039878371284, -259.804003740309, -259.8039945632375, -259.8040042401393, -259.803995063054, -259.8040141679403, -259.8039841363872, -259.8040146677651, -259.8039846362094, -259.8040038991037, -259.8039944043248, -259.8040043989208, -259.8039949041544, -259.8040030722654, -259.8039952311789, -259.8040035720882, -259.8039957310028, -259.8040108924492, -259.8039874109257, -259.8040113922721, -259.8039879107494, -259.8039987364825, -259.804000049608, -259.8039987536582, -259.8040000667838, -259.8039998502967, -259.8039989358067, -259.8039998674726, -259.8039989529825, -259.8039993824858, -259.8039994036027, -259.8039993996616, 
  -259.8039994207785, -259.8039964412863, -259.8040023448586, -259.8039964584617, -259.8040023620348, -259.8039978127778, -259.8040009733283, -259.8039978299538}
 {-262.9947105636098, -262.9947113082864, -262.9947120466477, -262.9947090805897, -262.9947098189583, -262.9947116927, -262.9947116622337, -262.9947094650073, -262.9947094345403, -262.9947107076595, -262.9947126472776, -262.9947084799719, -262.9947104195791, -262.9947136959046, -262.9947096590656, -262.9947114682111, -262.9947074313729, -262.99471158955, -262.9947117653837, -262.9947093618569, -262.9947095376906, -262.9947109517599, -262.9947124027155, -262.9947087241174, -262.9947101749718, -262.9947046872416, -262.9947186676733, -262.9947024595492, -262.9947164399796, -262.9946938842273, -262.9947294707311, -262.9946916565336, -262.9947272430387, -262.9947434352037, -262.9946799213566, -262.9947412079728, -262.9946776932014, -262.9947279604065, -262.9946953948529, -262.9947257327102, 
  -262.994693167163, -262.9947774462818, -262.9946459105367, -262.9947752185986, -262.9946436828336, -262.9947196276016, -262.9947037273311, -262.994717399853, -262.9947014996935, -262.994722227045, -262.994701127913, -262.9947199993484, -262.9946989002236, -262.9946198165093, -262.9948035435985, -262.994617588808, -262.9948013159138, -262.9947102096608, -262.9947101791942, -262.9947109480258, -262.9947109175591, -262.9947092246235, -262.9947111642349, -262.9947099629873, -262.9947119026011, -262.9947122128642, -262.9947081760272, -262.9947129512308, -262.9947089143905, -262.9947101065107, -262.9947102823443, -262.9947108448757, -262.9947110207092, -262.9947094687349, -262.9947109196619, -262.9947102071217, -262.9947116580049, -262.9947032042028, -262.9947171846334, -262.9947039425674, 
  -262.9947179229988, -262.9946924011878, -262.994727987692, -262.9946931395525, -262.9947287260571, -262.9947419523727, -262.9946784381089, -262.9947426907831, -262.9946791764285, -262.9947264773592, -262.9946939118215, -262.9947272157369, -262.9946946501736, -262.9947759632454, -262.9946444274943, -262.9947767016143, -262.9946451658554, -262.9947181445391, -262.9947022443149, -262.9947188828949, -262.994702982689, -262.9947207440044, -262.9946996448749, -262.9947214823683, -262.994700383241, -262.9946183334673, -262.9948020605618, -262.9946190718293, -262.9948027989298, -262.9947096090384, -262.9947115486512, -262.9947095785719, -262.9947115181843, -262.9947125972806, -262.994708560442, -262.994712566814, -262.9947085299753, -262.9947104909263, -262.99471066676, -262.9947104604597, 
  -262.9947106362932, -262.99470985316, -262.994711304068, -262.9947098226962, -262.9947112735983, -262.9947035886182, -262.9947175690493, -262.9947035581515}
 {-670.495570187247, -670.4955645070116, -670.4955643365994, -670.4955760379387, -670.4955758675249, -670.4955644219082, -670.4955644217028, -670.4955759528344, -670.4955759526293, -670.4955649230269, -670.4955639205926, -670.4955764539522, -670.4955754515197, -670.4955659052425, -670.495562938371, -670.495577436169, -670.4955744692971, -670.4955644254492, -670.4955644181621, -670.4955759563754, -670.4955759490884, -670.4955539411818, -670.4955749027223, -670.4955654721172, -670.4955864336395, -670.4955647608424, -670.4955640827703, -670.495576291768, -670.4955756136971, -670.4955665587677, -670.4955622848544, -670.495578089694, -670.4955738157805, -670.4955423400195, -670.495586504048, -670.4955538703932, -670.4955980355268, -670.4955678958609, -670.4955609478048, -670.4955794268028, 
  -670.4955724787155, -670.4955487868278, -670.4955800573859, -670.4955603177472, -670.4955915883188, -670.4955636432452, -670.4955652004531, -670.4955751739972, -670.4955767315537, -670.4955702648476, -670.4955585787306, -670.4955817957736, -670.495570109657, -670.4955738962456, -670.4955549474045, -670.4955854271711, -670.4955664783316, -670.495570272556, -670.4955702723508, -670.4955701021431, -670.4955701019378, -670.4955707736744, -670.495569771241, -670.4955706032614, -670.4955696008279, -670.4955717558906, -670.4955687890188, -670.4955715854775, -670.4955686186059, -670.4955702760969, -670.4955702688099, -670.4955701056839, -670.495570098397, -670.4955597918345, -670.4955807533653, -670.4955596214212, -670.4955805829528, -670.4955706114899, -670.4955699334187, -670.4955704410773, 
  -670.4955697630052, -670.4955724094157, -670.4955681355022, -670.4955722390027, -670.4955679650892, -670.4955481903899, -670.4955923549734, -670.4955480199795, -670.4955921845579, -670.4955737465248, -670.4955667984369, -670.4955735760956, -670.4955666280401, -670.4955546374725, -670.4955859080369, -670.4955544670591, -670.4955857376243, -670.495569493805, -670.4955710511891, -670.4955693233939, -670.4955708807743, -670.4955761154953, -670.4955644293787, -670.4955759450824, -670.4955642589655, -670.4955797468934, -670.4955607980525, -670.4955795764799, -670.49556062764, -670.4955706885706, -670.495569686137, -670.4955706883652, -670.4955696859318, -670.4955716707867, -670.495568703915, -670.4955716705816, -670.4955687037097, -670.4955701909931, -670.4955701837062, -670.4955701907878, 
  -670.4955701835009, -670.4955597067302, -670.4955806682621, -670.4955597065255, -670.4955806680563, -670.4955705263862, -670.4955698483147, -670.4955705261808}
 {-510.6839418358757, -510.6839411016557, -510.6839418744987, -510.6839417972684, -510.6839425701229, -510.6839414651263, -510.6839415110274, -510.6839421607446, -510.6839422066463, -510.6839404485756, -510.683942527582, -510.6839411441946, -510.6839432231999, -510.6839418179608, -510.6839411582087, -510.6839425135787, -510.6839418538278, -510.6839414638079, -510.6839415123458, -510.6839421594264, -510.6839422079644, -510.6839416378834, -510.6839413382706, -510.683942333503, -510.6839420338879, -510.6839415400405, -510.6839414361135, -510.6839422356595, -510.6839421317313, -510.6839415228969, -510.6839414532571, -510.6839422185156, -510.6839421488754, -510.6839267894737, -510.683956187399, -510.6839274846687, -510.683956883441, -510.6839372617967, -510.6839457144408, -510.6839379574283, 
  -510.6839464100464, -510.6839411695015, -510.6839418066526, -510.6839418651181, -510.6839425022729, -510.6839513911667, -510.6839315849539, -510.6839520867214, -510.6839322806361, -510.6839516297891, -510.6839313463273, -510.6839523254073, -510.6839320419461, -510.6839414923739, -510.68394148378, -510.6839421879924, -510.6839421793985, -510.683941426501, -510.6839414724023, -510.6839421993497, -510.6839422452511, -510.6839404099506, -510.6839424889563, -510.6839411827993, -510.6839432618052, -510.6839417793351, -510.6839411195839, -510.6839425521842, -510.6839418924324, -510.6839414251827, -510.6839414737206, -510.6839421980315, -510.6839422465693, -510.6839415992585, -510.6839412996449, -510.6839423721074, -510.6839420724933, -510.6839415014155, -510.6839413974879, -510.6839422742643, 
  -510.6839421703365, -510.6839414842717, -510.6839414146317, -510.6839422571205, -510.6839421874804, -510.6839267506547, -510.6839561489674, -510.6839275234674, -510.6839569218522, -510.6839372231827, -510.6839456758044, -510.6839379960221, -510.6839464486624, -510.6839411308753, -510.683941768028, -510.6839419037239, -510.683942540877, -510.6839513525143, -510.6839315463557, -510.6839521253535, -510.683932319214, -510.6839515911639, -510.683931307702, -510.6839523640124, -510.683932080551, -510.6839414537485, -510.6839414451548, -510.6839422265973, -510.6839422180036, -510.683940773424, -510.6839428524298, -510.6839408193254, -510.6839428983312, -510.6839421428087, -510.6839414830572, -510.68394218871, -510.6839415289585, -510.6839417886561, -510.683941837194, -510.6839418345574, 
  -510.6839418830954, -510.6839419627318, -510.6839416631185, -510.6839420086337, -510.6839417090193, -510.6839418648887, -510.6839417609615, -510.6839419107905}
 {-339.7710959029335, -339.7710969345018, -339.7710980515442, -339.7710937543433, -339.771094871387, -339.7710974818402, -339.7710975042047, -339.7710943016826, -339.7710943240466, -339.7710971601895, -339.771097825855, -339.7710939800342, -339.7710946456947, -339.7710916317289, -339.7711033543614, -339.7710884515695, -339.7711001742052, -339.7710973697641, -339.7710976162808, -339.7710941896063, -339.7710944361229, -339.7711012963479, -339.7710936898139, -339.7710981161776, -339.7710905096686, -339.7710981947836, -339.7710967913343, -339.7710950146255, -339.7710936111769, -339.7711018796888, -339.7710931063962, -339.7710986995302, -339.7710899262389, -339.7710790216517, -339.7711159657249, -339.7710758411441, -339.7711127859169, -339.7710808255533, -339.7711141607119, -339.7710776453974, 
  -339.7711109805521, -339.7711091967097, -339.7710857911393, -339.7711060165458, -339.7710826109876, -339.7711017029134, -339.7710932831278, -339.7710985227238, -339.771090103002, -339.7710959888012, -339.7710989974187, -339.7710928086416, -339.7710958172627, -339.7711188794297, -339.7710761065781, -339.771115699273, -339.7710729264192, -339.7710953332305, -339.7710953555947, -339.7710964502735, -339.7710964726377, -339.771095011579, -339.7710956772458, -339.7710961286258, -339.771096794285, -339.7710894831178, -339.7711012057528, -339.7710906001618, -339.7711023227949, -339.7710952211543, -339.771095467671, -339.7710963381973, -339.7710965847139, -339.7710991477332, -339.771091541209, -339.7711002647735, -339.7710926582548, -339.7710960461743, -339.771094642724, -339.7710971632159, 
  -339.7710957597684, -339.7710997310788, -339.7710909577865, -339.7711008481214, -339.7710920748298, -339.7710768729027, -339.7711138172542, -339.7710779898742, -339.7711149343688, -339.7710786769502, -339.7711120120952, -339.7710797939817, -339.7711131291498, -339.7711070480997, -339.7710836425296, -339.7711081651369, -339.7710847595783, -339.7710995542938, -339.7710911345278, -339.7711006713246, -339.7710922515831, -339.7710938401919, -339.7710968488082, -339.7710949572319, -339.7710979658543, -339.7711167308201, -339.771073957968, -339.7711178478638, -339.7710750750103, -339.7710955589196, -339.7710962245829, -339.7710955812842, -339.7710962469468, -339.7710900304572, -339.7711017530912, -339.7710900528214, -339.7711017754555, -339.7710957684931, -339.7710960150098, 
  -339.7710957908573, -339.771096037374, -339.7710996950714, -339.7710920885486, -339.7710997174342, -339.7710921109141, -339.7710965935121, -339.7710951900638, -339.771096615877}
 {-190.8302869288121, -190.8302857502993, -190.83028664978, -190.830287207857, -190.8302881073445, -190.8302861671502, -190.8302862329289, -190.830287624711, -190.8302876904902, -190.8302852487627, -190.830287151319, -190.8302867063304, -190.8302886088735, -190.8302871180254, -190.8302852820688, -190.8302885755867, -190.8302867396297, -190.8302861774289, -190.8302862226502, -190.83028763499, -190.8302876802112, -190.8302823563378, -190.8302900438354, -190.8302838139124, -190.8302915013829, -190.8302849224645, -190.8302874776301, -190.8302863800251, -190.8302889351916, -190.8302882368208, -190.8302841632777, -190.8302896943821, -190.8302856208386, -190.8303239276224, -190.8302484738793, -190.8303253856906, -190.8302499309332, -190.8302934268537, -190.8302789733776, -190.8302948844111, 
  -190.8302804309423, -190.8303012870646, -190.8302711139571, -190.8303027446328, -190.8302725715112, -190.830285615115, -190.8302867850466, -190.83028707259, -190.8302882426938, -190.8302890174567, -190.8302833826439, -190.8302904750142, -190.8302848402086, -190.830298115142, -190.8302742848617, -190.8302995727009, -190.8302757424249, -190.8302864461807, -190.8302865119596, -190.8302873456648, -190.8302874114437, -190.830285527797, -190.830287430346, -190.8302864272804, -190.8302883298307, -190.8302873970546, -190.8302855611009, -190.8302882965418, -190.8302864605819, -190.8302864564595, -190.8302865016808, -190.8302873559436, -190.8302874011649, -190.8302826353753, -190.8302903228591, -190.8302835348591, -190.8302912223435, -190.8302852014944, -190.8302877566614, -190.8302861009795, 
  -190.8302886561445, -190.8302885158515, -190.8302844423082, -190.8302894153356, -190.8302853417923, -190.8303242068854, -190.8302487526775, -190.8303251064118, -190.8302496521193, -190.8302937058762, -190.8302792524163, -190.8302946053729, -190.8302801518878, -190.8303015660973, -190.8302713929857, -190.8303024655843, -190.8302722924669, -190.830285894109, -190.8302870641139, -190.8302867935803, -190.8302879636108, -190.8302892964853, -190.8302836616766, -190.8302901959698, -190.8302845611603, -190.8302983941721, -190.8302745638928, -190.830299293655, -190.8302754633781, -190.8302859446491, -190.8302878471988, -190.830286010428, -190.8302879129777, -190.8302878139086, -190.8302859779518, -190.8302878796876, -190.8302860437307, -190.830286873312, -190.8302869185333, -190.8302869390909, 
  -190.8302869843122, -190.8302830522278, -190.8302907397115, -190.8302831180064, -190.8302908054908, -190.8302856183473, -190.8302881735135, -190.8302856841264}
 {-205.3028239513266, -205.3028233918311, -205.3028226356074, -205.3028252670646, -205.3028245108298, -205.3028230313623, -205.3028229960756, -205.3028249065906, -205.3028248713033, -205.3028241847272, -205.3028218427129, -205.3028260599549, -205.3028237179412, -205.3028204353416, -205.3028255921149, -205.3028223105698, -205.3028274673427, -205.3028229786322, -205.3028230488057, -205.3028248538602, -205.3028249240337, -205.3028249572129, -205.3028210703135, -205.3028268324403, -205.3028229455419, -205.3028218890512, -205.3028241384173, -205.3028237642792, -205.3028260136452, -205.3028241147371, -205.3028219127063, -205.302825989965, -205.3028237879343, -205.3028315627014, -205.3028144649712, -205.302833438125, -205.3028163400036, -205.3028187623153, -205.302827265151, -205.3028206375369, 
  -205.3028291403854, -205.3028189944292, -205.3028270333491, -205.3028208696598, -205.3028289085744, -205.3028276738893, -205.3028183535372, -205.3028295490761, -205.3028202288064, -205.3028253527456, -205.3028206747232, -205.3028272279737, -205.3028225499511, -205.3028378166352, -205.3028082105946, -205.3028396918632, -205.3028100858226, -205.302824347085, -205.3028243117981, -205.3028235908557, -205.3028235555688, -205.3028255004496, -205.3028231584357, -205.3028247442204, -205.3028224022063, -205.3028217510644, -205.3028269078374, -205.302820994835, -205.3028261516082, -205.3028242943548, -205.3028243645283, -205.3028235381255, -205.302823608299, -205.3028262729352, -205.3028223860363, -205.3028255167059, -205.302821629807, -205.3028232047738, -205.3028254541398, -205.3028224485446, 
  -205.3028246979105, -205.3028254304597, -205.3028232284289, -205.3028246742304, -205.3028224721996, -205.3028328785337, -205.3028157805842, -205.3028321222806, -205.3028150243787, -205.3028200780313, -205.3028285808802, -205.3028193218088, -205.3028278246441, -205.3028203101534, -205.3028283490701, -205.3028195539235, -205.3028275928413, -205.3028289895868, -205.3028196692851, -205.3028282333666, -205.3028189130466, -205.3028266684684, -205.3028219904457, -205.302825912239, -205.3028212342165, -205.3028391323578, -205.3028095263172, -205.3028383761286, -205.3028087700879, -205.3028251399781, -205.3028227979642, -205.3028251046912, -205.3028227626773, -205.3028213905929, -205.3028265473659, -205.3028213553059, -205.302826512079, -205.3028239338833, -205.3028240040568, -205.3028238985964, 
  -205.3028239687699, -205.3028259124637, -205.3028220255649, -205.3028258771768, -205.3028219902779, -205.3028228443023, -205.3028250936683, -205.3028228090154}
 {-192.4512191115618, -192.4512187227967, -192.4512188393673, -192.4512193837596, -192.4512195003317, -192.4512187726381, -192.4512187895258, -192.4512194336017, -192.4512194504896, -192.4512192345006, -192.4512183276641, -192.4512198954643, -192.4512189886278, -192.4512196560288, -192.4512179061363, -192.4512203169925, -192.4512185671001, -192.4512187993562, -192.4512187628078, -192.4512194603198, -192.4512194237715, -192.4512178382444, -192.4512197239483, -192.4512184992081, -192.451220384912, -192.4512185420602, -192.4512190201057, -192.4512192030239, -192.4512196810694, -192.4512191154677, -192.4512184466985, -192.4512197764314, -192.4512191076621, -192.4512221549825, -192.4512154072828, -192.4512228160226, -192.4512160681701, -192.4512166432249, -192.4512209189513, 
  -192.4512173041862, -192.4512215799174, -192.4512208802813, -192.451216682034, -192.4512215412459, -192.4512173429968, -192.4512242841362, -192.4512132780011, -192.4512249450854, -192.4512139389794, -192.4512230649524, -192.4512144972071, -192.4512237259161, -192.4512151581708, -192.4512337779933, -192.4512037839536, -192.451234438957, -192.4512044449173, -192.4512190448323, -192.4512190617201, -192.4512191614036, -192.4512191782915, -192.4512195066948, -192.4512185998583, -192.4512196232661, -192.4512187164296, -192.451219928223, -192.4512181783306, -192.4512200447944, -192.4512182949019, -192.4512190715503, -192.451219035002, -192.4512191881217, -192.4512191515733, -192.4512181104386, -192.4512199961425, -192.4512182270099, -192.4512201127138, -192.4512188142544, -192.4512192922999, 
  -192.4512189308258, -192.4512194088713, -192.4512193876619, -192.4512187188926, -192.4512195042333, -192.451218835464, -192.451222427213, -192.4512156794408, -192.4512225437882, -192.4512157960082, -192.4512169154169, -192.4512211911478, -192.4512170319903, -192.4512213077171, -192.4512211524759, -192.4512169542278, -192.4512212690474, -192.4512170707991, -192.4512245563238, -192.4512135502018, -192.4512246728938, -192.4512136667746, -192.4512233371466, -192.4512147694013, -192.4512234537179, -192.4512148859726, -192.4512340501875, -192.4512040561478, -192.4512341667588, -192.4512041727191, -192.4512195565365, -192.4512186497, -192.4512195734243, -192.4512186665878, -192.4512199780647, -192.4512182281723, -192.4512199949526, -192.4512182450601, -192.4512191213921, -192.4512190848437, 
  -192.4512191382799, -192.4512191017316, -192.4512181602803, -192.4512200459842, -192.4512181771681, -192.451220062872, -192.4512188640961, -192.4512193421417, -192.451218880984}
 {-250.9072496713231, -250.9072501728573, -250.9072390375175, -250.9072603052386, -250.907249169856, -250.9072445767204, -250.9072446336505, -250.9072547090799, -250.907254766011, -250.9072559195025, -250.9072332908833, -250.9072660517849, -250.9072434233209, -250.9072312344236, -250.9072579760536, -250.9072413667886, -250.9072681084085, -250.9072446338276, -250.9072445765433, -250.9072547661872, -250.9072547089036, -250.9072255527558, -250.9072636579772, -250.9072356852326, -250.9072737902204, -250.9072543114457, -250.9072348990526, -250.9072644438084, -250.90724503141, -250.907236048001, -250.9072531624735, -250.9072461803625, -250.907263294832, -250.9075028855491, -250.9069863332967, -250.9075130216137, -250.9069964619523, -250.907149818494, -250.9073393929096, -250.9071599508347, 
  -250.907349525289, -250.9073475555805, -250.9071416612425, -250.9073576879877, -250.9071517935553, -250.9072415003944, -250.9072477105372, -250.9072516321276, -250.9072578435241, -250.9072273904398, -250.9072618208218, -250.9072375228244, -250.9072719531573, -250.9071957817846, -250.9072934341645, -250.90720591413, -250.907303566539, -250.9072552105403, -250.907255267471, -250.9072440751793, -250.9072441321097, -250.9072665532833, -250.9072439247429, -250.9072554179233, -250.9072327893805, -250.9072418682682, -250.9072686098494, -250.9072307328632, -250.907257474532, -250.9072552676477, -250.9072552103636, -250.9072441322863, -250.9072440750026, -250.9072361866439, -250.9072742917296, -250.9072250512639, -250.9072631563872, -250.907264945263, -250.9072455328758, -250.9072538099104, 
  -250.907234397506, -250.9072466818221, -250.9072637962929, -250.9072355464608, -250.9072526609319, -250.9075135213743, -250.9069969651121, -250.9075023857078, -250.9069858300561, -250.9071604522405, -250.9073500268037, -250.9071493170074, -250.9073388913143, -250.9073581894191, -250.9071522950444, -250.9073470540684, -250.9071411596727, -250.9072521338394, -250.9072583447327, -250.9072409986019, -250.9072472092478, -250.9072380242719, -250.9072724546302, -250.9072268889115, -250.9072613192681, -250.9072064155989, -250.9073040679906, -250.907195280235, -250.9072929326321, -250.907260957136, -250.9072383285946, -250.9072610140668, -250.907238385525, -250.9072362720989, -250.9072630137231, -250.9072363290287, -250.9072630706545, -250.9072496715, -250.9072496142158, -250.9072497284304, 
  -250.9072496711465, -250.9072305904873, -250.9072686955906, -250.9072306474166, -250.9072687525224, -250.9072593491218, -250.9072399367215, -250.9072594060479}
 {-339.2979612973257, -339.2979634499474, -339.2979630021242, -339.2979595925328, -339.2979591447093, -339.2979632179261, -339.2979632341445, -339.2979593605114, -339.2979593767297, -339.2979633330269, -339.2979631190438, -339.2979594756116, -339.2979592616295, -339.2979601825186, -339.2979662695778, -339.2979563251039, -339.297962412163, -339.2979632753284, -339.2979631767422, -339.2979594179136, -339.2979593193274, -339.297963001432, -339.297963450647, -339.2979591440191, -339.2979595932304, -339.2979672402776, -339.2979592118313, -339.2979633828629, -339.2979553544164, -339.2979647312834, -339.297961720798, -339.2979608738686, -339.2979578633832, -339.2979567692895, -339.2979696834358, -339.2979529118068, -339.297965826089, -339.2979727780689, -339.2979536740792, -339.2979689206541, 
  -339.2979498166643, -339.2979458975534, -339.2979805552838, -339.2979420401383, -339.2979766978693, -339.2979689967578, -339.2979574552814, -339.2979651393421, -339.2979535978675, -339.2979635894416, -339.2979628626962, -339.297959732027, -339.2979590052812, -339.297972317793, -339.2979541343338, -339.297968460378, -339.2979502769192, -339.2979615131287, -339.2979615293471, -339.2979610653055, -339.2979610815237, -339.2979616282292, -339.2979614142466, -339.2979611804058, -339.2979609664233, -339.2979584777216, -339.29796456478, -339.2979580298975, -339.2979641169574, -339.297961570531, -339.2979614719449, -339.2979611227076, -339.2979610241215, -339.2979612966362, -339.2979617458481, -339.2979608488115, -339.297961298026, -339.29796553548, -339.2979575070341, -339.297965087657, 
  -339.2979570592103, -339.297963026486, -339.2979600160006, -339.2979625786626, -339.2979595681774, -339.2979550644336, -339.2979679786969, -339.2979546166593, -339.2979675308245, -339.2979710732745, -339.2979519692786, -339.297970625445, -339.2979515214615, -339.2979441927555, -339.297978850487, -339.2979437449329, -339.2979784026629, -339.2979672919573, -339.2979557504872, -339.2979668441392, -339.2979553026584, -339.2979618846444, -339.2979611578984, -339.2979614368207, -339.2979607100755, -339.2979706129955, -339.2979524295365, -339.2979701651721, -339.2979519817133, -339.2979613962079, -339.2979611822253, -339.2979614124262, -339.2979611984436, -339.2979582456999, -339.297964332759, -339.2979582619182, -339.2979643489773, -339.2979613385096, -339.2979612399235, -339.2979613547279, 
  -339.2979612561418, -339.2979610646144, -339.2979615138272, -339.2979610808323, -339.2979615300459, -339.2979653034589, -339.2979572750124, -339.2979653196771}
 {-58.26331030497772, -58.26333509127209, -58.2633356190854, -58.26328499106569, -58.26328551886727, -58.26333527985211, -58.26333543050369, -58.26328517964205, -58.26328533028921, -58.26334064986936, -58.26333006051099, -58.2632905496502, -58.26327996030562, -58.26334241918192, -58.26332829124924, -58.26329231896974, -58.26327819103689, -58.26333518666172, -58.26333552369408, -58.26328508644949, -58.26328542348179, -58.26336732238086, -58.26330338858663, -58.26331722212953, -58.26325328841341, -58.263330990179, -58.26333972020875, -58.26328088996936, -58.26328961999385, -58.26333904142663, -58.26333166900699, -58.26328894121366, -58.26328156879542, -58.2633605869245, -58.26331012907149, -58.26331048795201, -58.26326002761954, -58.26334872757984, -58.26332198341915, -58.2632986273182, 
  -58.26327188325624, -58.26328793681089, -58.26338277686947, -58.2632378366189, -58.26333267663692, -58.26336446755678, -58.26330624285238, -58.26331436758465, -58.26325614239996, -58.26335736806366, -58.26331334255352, -58.2633072678517, -58.26326324234097, -58.26335657481602, -58.26331413694527, -58.26330647460789, -58.26326403672887, -58.26330996575033, -58.26331011639947, -58.26331049355754, -58.26331064420714, -58.26331533576574, -58.2633047464086, -58.26331586356752, -58.26330527422171, -58.26331710507853, -58.26330297714662, -58.26331763288684, -58.2633035049532, -58.26330987255873, -58.26331020959106, -58.26331040036616, -58.26331073739853, -58.26334200825926, -58.26327807450221, -58.26334253606483, -58.26327860231155, -58.26330567607622, -58.26331440610552, -58.26330620388584, 
  -58.26331493391079, -58.26331372732328, -58.2633063549043, -58.26331425513069, -58.26330688271179, -58.2633352734279, -58.26328481436214, -58.2633358012623, -58.26328534214261, -58.26332341344751, -58.2632966693455, -58.26332394126423, -58.26329719714363, -58.26326262271867, -58.26335746275569, -58.26326315052482, -58.26335799056442, -58.26333915357837, -58.2632809286248, -58.26333968137678, -58.26328145644126, -58.26333205396191, -58.26328802844928, -58.26333258176716, -58.26328855625889, -58.26333126071577, -58.26328882283952, -58.26333178852185, -58.26328935064835, -58.26331552434114, -58.2633049349896, -58.26331567499043, -58.26330508563903, -58.26331729365714, -58.2633031657244, -58.26331744430654, -58.26330331637374, -58.26331006113691, -58.26331039816927, -58.2633102117863, 
  -58.26331054881861, -58.26334219683994, -58.26327826307792, -58.26334234748247, -58.26327841373414, -58.26330586465557, -58.26331459468254, -58.26330601530479}
 {-186.1981229892432, -186.1981162839367, -186.1981184702386, -186.1981275083415, -186.198129694664, -186.1981174713097, -186.1981172828637, -186.1981286957264, -186.1981285072772, -186.19811239247, -186.198122361715, -186.1981236169072, -186.198133586108, -186.1981127076917, -186.198122046515, -186.1981239321062, -186.1981332709307, -186.1981174139825, -186.1981173401909, -186.1981286383977, -186.1981285646059, -186.1981294218809, -186.1981053327721, -186.1981406463399, -186.1981165571433, -186.1981082299709, -186.1981265242293, -186.1981194543861, -186.1981377486444, -186.1981055962518, -186.1981291580314, -186.1981168206677, -186.1981403824456, -186.1982063710282, -186.1980283869505, -186.1982175972002, -186.1980396096088, -186.198153501046, -186.1980812535468, -186.1981647254254, 
  -186.1980924779976, -186.1981252818826, -186.1981094745971, -186.1981365063165, -186.1981206989933, -186.1981372475718, -186.1980975066778, -186.1981484716452, -186.1981087314345, -186.1981254971555, -186.1981092573064, -186.1981367215594, -186.1981204817327, -186.1979494285973, -186.1982853357566, -186.1979606530057, -186.1982965601784, -186.198121990312, -186.1981218018641, -186.1981241766239, -186.1981239881765, -186.1981169114829, -186.1981268807047, -186.1981190977939, -186.1981290670181, -186.1981172266892, -186.1981265655202, -186.1981194130085, -186.1981287518253, -186.1981219329839, -186.1981218591921, -186.198124119296, -186.1981240455044, -186.1981339409029, -186.1981098517526, -186.1981361272175, -186.1981120380624, -186.1981127489707, -186.1981310432321, -186.1981149352859, 
  -186.1981332295413, -186.1981101152534, -186.1981336770325, -186.1981123015659, -186.1981358633443, -186.1982108908421, -186.1980329051394, -186.1982130772861, -186.1980350913196, -186.1981580200079, -186.1980857725876, -186.1981602063631, -186.1980879588566, -186.1981298008919, -186.1981139935903, -186.1981319872068, -186.1981161798997, -186.1981417664167, -186.1981020258354, -186.1981439527, -186.1981042121765, -186.1981300161514, -186.198113776313, -186.1981322024631, -186.1981159626256, -186.197953947597, -186.1982898547597, -186.1979561339059, -186.1982920410751, -186.1981180988614, -186.1981280680842, -186.1981179104136, -186.1981278796367, -186.1981184140717, -186.1981277528957, -186.1981182256241, -186.1981275644479, -186.1981231203628, -186.1981230465712, -186.1981229319152, 
  -186.1981228581235, -186.1981351282839, -186.1981110391297, -186.1981349398347, -186.1981108506836, -186.1981139363508, -186.19813223061, -186.198113747904}
 {-54.47284440253457, -54.47284909904658, -54.47284929860054, -54.47283950655113, -54.47283970609035, -54.47284923381103, -54.47284916383561, -54.47283964130688, -54.47283957133412, -54.47284998840017, -54.47284840925485, -54.47284039588313, -54.47283881676625, -54.47285122990938, -54.47284716775338, -54.47284163741275, -54.47283757524438, -54.47284925190625, -54.47284914574039, -54.47283965940334, -54.47283955323767, -54.47283539270073, -54.47286300496552, -54.47282580033728, -54.47285341232332, -54.47285313527381, -54.47284526236214, -54.47284354276908, -54.47283566986122, -54.4728432208924, -54.47285517676098, -54.47283362839278, -54.47284558425496, -54.47283645367856, -54.47286194508285, -54.47282686151717, -54.47285235223861, -54.47284317285055, -54.47285522492213, 
  -54.47283358033464, -54.47284563243239, -54.47290201905863, -54.47279637951718, -54.47289242657003, -54.47278678700012, -54.47285454584302, -54.47284385177985, -54.47284495339343, -54.47283425922381, -54.47285441029634, -54.47284398732927, -54.47284481779528, -54.4728343948247, -54.47281786559796, -54.47288053396905, -54.4728082730793, -54.47287094148207, -54.47284433774852, -54.47284426777453, -54.47284453729521, -54.47284446732104, -54.47284509233206, -54.47284351319938, -54.47284529187707, -54.47284371274757, -54.47284633385046, -54.47284227168873, -54.47284653339749, -54.47284247123488, -54.47284435584441, -54.47284424967866, -54.47284455539101, -54.47284444922524, -54.4728304967125, -54.47285810883017, -54.47283069625135, -54.47285830838451, -54.47284823921168, -54.4728403663007, 
  -54.47284843875705, -54.4728405658485, -54.47283832483234, -54.47285028069746, -54.47283852437868, -54.47285048024431, -54.47283155780487, -54.47285704883297, -54.47283175731671, -54.47285724841433, -54.47283827678456, -54.47285032886453, -54.47283847632646, -54.47285052841583, -54.47289712300469, -54.47279148344753, -54.47289732254981, -54.4727916829956, -54.47284964980943, -54.47283895568987, -54.47284984935285, -54.47283915523963, -54.47284951423616, -54.47283909126589, -54.47284971378131, -54.47283929081392, -54.47281296952726, -54.47287563791618, -54.47281316907585, -54.47287583746078, -54.47284522709142, -54.47284364796023, -54.47284515711724, -54.47284357798624, -54.47284646861075, -54.47284240644865, -54.47284639863674, -54.47284233647448, -54.47284449060453, -54.47284438443876, 
  -54.47284442063043, -54.47284431446467, -54.47283063146999, -54.47285824359288, -54.47283056149336, -54.47285817362133, -54.47284837397115, -54.47284050106143, -54.47284830399711}
 {-256.649200035091, -256.6491999921566, -256.649199942227, -256.6492001279564, -256.6492000780263, -256.6491999252281, -256.6492000091555, -256.6492000610273, -256.6492001449554, -256.6492000016932, -256.6491999326904, -256.6492001374928, -256.64920006849, -256.649200062123, -256.6491998722609, -256.6492001979225, -256.6492000080605, -256.6491999821138, -256.6491999522698, -256.6492001179134, -256.6492000880694, -256.6491999674749, -256.6491999669086, -256.6492001032745, -256.6492001027082, -256.649199967101, -256.6491999672825, -256.6492001029006, -256.6492001030821, -256.6491999686604, -256.6491999657232, -256.64920010446, -256.6492001015227, -256.6492017540751, -256.6491981803757, -256.6492018899115, -256.6491983161385, -256.6491996286465, -256.649200305745, -256.649199764445, 
  -256.6492004415455, -256.649199987343, -256.6491999470406, -256.6492001231429, -256.6492000828398, -256.6492057497185, -256.6491941846333, -256.6492058855131, -256.6491943204379, -256.6492059753423, -256.6491939590053, -256.6492061111419, -256.6491940948049, -256.6491999672696, -256.6491999671138, -256.6492001030692, -256.6492001029134, -256.6492000180922, -256.6492001020199, -256.6491999681623, -256.64920005209, -256.6492000945575, -256.6492000255547, -256.6492000446276, -256.6491999756248, -256.6492001549873, -256.6491999651252, -256.6492001050573, -256.6491999151953, -256.649200074978, -256.6492000451341, -256.6492000250482, -256.6491999952042, -256.6492000603392, -256.6492000597729, -256.6492000104093, -256.649200009843, -256.6492000599653, -256.6492000601468, -256.6492000100354, 
  -256.6492000102169, -256.6492000615246, -256.6492000585874, -256.6492000115947, -256.6492000086575, -256.6492018469588, -256.6491982732206, -256.649201797027, -256.6491982232926, -256.6491997215095, -256.6492003986104, -256.649199671581, -256.6492003486791, -256.6492000802074, -256.6492000399047, -256.6492000302775, -256.6491999899748, -256.6492058425799, -256.6491942775004, -256.6492057926506, -256.6491942275699, -256.6492060682067, -256.6491940518696, -256.6492060182767, -256.6491940019397, -256.6492000601339, -256.6492000599781, -256.649200010204, -256.6492000100483, -256.6492000276287, -256.649199958626, -256.6492001115564, -256.6492000425536, -256.6492000880585, -256.6491998981964, -256.6492001719862, -256.6491999821241, -256.6492000080493, -256.6491999782053, -256.649200091977, 
  -256.649200062133, -256.6491999934104, -256.6491999928441, -256.6492000773381, -256.6492000767718, -256.6491999930365, -256.649199993218, -256.6492000769641}
 {-177.1821134884977, -177.1821086580975, -177.1821080644462, -177.1821189126006, -177.1821183189444, -177.1821084140611, -177.1821083084824, -177.1821186685623, -177.1821185629825, -177.1821113744548, -177.1821053480982, -177.1821216289504, -177.1821156026039, -177.1821118877455, -177.1821048348109, -177.182122142247, -177.1821150893108, -177.1821083062894, -177.1821084162541, -177.1821185607901, -177.1821186707547, -177.182114432463, -177.1821022902354, -177.1821246869593, -177.1821125447405, -177.1821084143645, -177.182108308181, -177.1821186688654, -177.1821185626815, -177.1821098739452, -177.182106848609, -177.1821201284455, -177.18211710311, -177.1821540896019, -177.1820626341364, -177.1821643450742, -177.1820728876654, -177.1820954661228, -177.1821212565607, -177.1821057205994, 
  -177.1821315110854, -177.1820955311073, -177.1821211920952, -177.1821057856149, -177.1821314465889, -177.182111255548, -177.1821054670891, -177.1821215098349, -177.1821157218036, -177.1821134367695, -177.182103285829, -177.1821236912714, -177.1821135403284, -177.1821200136355, -177.1820967088464, -177.1821302681367, -177.1821069633464, -177.1821138381143, -177.182113732535, -177.1821132444605, -177.1821131388813, -177.1821167985052, -177.1821107721535, -177.1821162048513, -177.1821101784999, -177.1821173117992, -177.1821102588629, -177.1821167181446, -177.1821096652101, -177.1821137303423, -177.1821138403069, -177.1821131366885, -177.1821132466532, -177.1821198565143, -177.1821077142899, -177.1821192628594, -177.1821071206373, -177.1821138384176, -177.1821137322337, -177.1821132447636, 
  -177.1821131385801, -177.1821152979978, -177.182112272662, -177.1821147043441, -177.1821116790083, -177.1821595141461, -177.1820680576979, -177.1821589204813, -177.1820674640552, -177.182100890149, -177.1821266806402, -177.1821002965246, -177.1821260869571, -177.1821009551634, -177.1821266161447, -177.18210036151, -177.1821260224906, -177.1821166794908, -177.182110891252, -177.1821160858434, -177.182110297592, -177.182118860823, -177.1821087098812, -177.1821182671692, -177.1821081162275, -177.1821254376884, -177.1821021328992, -177.1821248440351, -177.182101539245, -177.1821165544678, -177.1821105281163, -177.1821164488886, -177.182110422537, -177.1821170677615, -177.182110014826, -177.1821169621822, -177.1821099092468, -177.182113486305, -177.1821135962696, -177.1821133807257, 
  -177.1821134906904, -177.1821196124754, -177.182107470254, -177.182119506898, -177.182107364673, -177.1821135943803, -177.1821134881963, -177.1821134888008}
 {-324.351523241483, -324.3515237482778, -324.351523709645, -324.3515227733217, -324.3515227346885, -324.3515237254477, -324.351523732475, -324.3515227504914, -324.3515227575188, -324.3515237566601, -324.3515237012627, -324.3515227817038, -324.3515227263064, -324.3515241257479, -324.3515233321761, -324.3515231507915, -324.3515223572198, -324.3515237361021, -324.3515237218206, -324.3515227611458, -324.3515227468643, -324.3515234007722, -324.3515240571527, -324.3515224258159, -324.3515230821963, -324.3515241715881, -324.3515232863366, -324.3515231966318, -324.3515223113802, -324.351524213463, -324.3515232444637, -324.3515232385067, -324.3515222695073, -324.3515249019437, -324.3515225561476, -324.3515239270123, -324.3515215811662, -324.3515226172882, -324.351524840655, -324.3515216423313, 
  -324.3515238656992, -324.3515289631888, -324.3515184949825, -324.3515279882327, -324.3515175200259, -324.3515297246507, -324.3515177332365, -324.3515287496935, -324.351516758281, -324.3515296148009, -324.3515178430884, -324.3515286398446, -324.351516868132, -324.3515374826612, -324.3515099751022, -324.3515365077049, -324.3515090001459, -324.3515232572859, -324.3515232643132, -324.3515232186529, -324.3515232256803, -324.3515232884983, -324.3515232331009, -324.3515232498653, -324.3515231944679, -324.3515236575861, -324.3515228640143, -324.351523618953, -324.3515228253814, -324.3515232679403, -324.3515232536588, -324.3515232293073, -324.3515232150258, -324.3515229326104, -324.3515235889908, -324.3515228939774, -324.3515235503578, -324.3515237034263, -324.3515228181748, -324.3515236647933, 
  -324.3515227795418, -324.3515237453012, -324.351522776302, -324.3515237066682, -324.3515227376689, -324.3515244337967, -324.3515220879709, -324.351524395159, -324.3515220493426, -324.3515221491255, -324.3515243724941, -324.3515221104937, -324.3515243338599, -324.3515284950272, -324.3515180268205, -324.3515284563941, -324.3515179881876, -324.3515292564882, -324.3515172650754, -324.3515292178556, -324.3515172264419, -324.351529146639, -324.3515173749265, -324.351529108006, -324.3515173362935, -324.3515370144994, -324.3515095069404, -324.3515369758664, -324.3515094683075, -324.3515232656681, -324.3515232102707, -324.3515232726955, -324.351523217298, -324.3515236347558, -324.3515228411842, -324.3515236417832, -324.3515228482115, -324.3515232451101, -324.3515232308286, -324.3515232521375, 
  -324.351523237856, -324.3515229097802, -324.3515235661606, -324.3515229168076, -324.351523573188, -324.351523680596, -324.3515227953446, -324.3515236876235}
 {-21.24580186679194, -21.24580244379407, -21.2458024579119, -21.2458012756726, -21.24580128979041, -21.24580245832969, -21.24580244337628, -21.24580129020821, -21.24580127525481, -21.24581432002808, -21.24579058169576, -21.245813151885, -21.24578941359589, -21.24579845679099, -21.24580644491992, -21.2457972886702, -21.24580527679776, -21.24580275600347, -21.2458021457025, -21.24580158788197, -21.24580097758106, -21.24586119656615, -21.24574370583971, -21.24586002832836, -21.24574253783453, -21.24579709367695, -21.24580780803289, -21.24579592555622, -21.24580663991067, -21.24581308117018, -21.24579182057334, -21.24581191304802, -21.24579065245255, -21.24580743980018, -21.24579746190788, -21.24580627166931, -21.24579629379578, -21.24579091049558, -21.24581399123783, -21.24578974237518, 
  -21.24581282311527, -21.24576126396625, -21.24584363808004, -21.24576009584878, -21.24584246995456, -21.24580243027822, -21.24580247142763, -21.24580126215679, -21.2458013033061, -21.24576446798081, -21.24584043448799, -21.24576329986789, -21.24583926635795, -21.24574501053537, -21.24585989431604, -21.245743842428, -21.24585872618046, -21.24580186720974, -21.24580185225633, -21.24580188132756, -21.24580186637415, -21.24581372889722, -21.24578999058674, -21.24581374301526, -21.24579000470432, -21.2457978656714, -21.24580585379963, -21.2457978797892, -21.24580586791745, -21.24580216488351, -21.24580155458257, -21.24580217900133, -21.24580156870039, -21.24586060538722, -21.24574311477875, -21.2458606195067, -21.24574312889489, -21.24579650255737, -21.24580721691257, -21.24579651667519, 
  -21.24580723103038, -21.24581249004989, -21.24579122945374, -21.24581250416771, -21.24579124357155, -21.24580684867553, -21.24579687079263, -21.24580686279335, -21.24579688491044, -21.24579031937647, -21.24581340011704, -21.24579033349369, -21.24581341423545, -21.24576067284834, -21.24584304695806, -21.2457606869661, -21.24584306107594, -21.2458018391583, -21.24580188030765, -21.24580185327611, -21.24580189442547, -21.2457638768652, -21.2458398433637, -21.24576389098291, -21.24583985748163, -21.24574441942259, -21.24585930318894, -21.24574443354019, -21.24585931730697, -21.24581374343308, -21.2457900051221, -21.2458137284794, -21.24578999016896, -21.245797880207, -21.24580586833525, -21.2457978652536, -21.24580585338183, -21.24580217941912, -21.24580156911819, -21.24580216446572, 
  -21.24580155416478, -21.24586061992443, -21.24574312931276, -21.24586060496949, -21.24574311436089, -21.24579651709298, -21.24580723144819, -21.24579650213958}
 {-350.4889353752839, -350.488945085665, -350.4889448321468, -350.488925918475, -350.4889256649626, -350.4889449278983, -350.4889449899125, -350.4889257607108, -350.4889258227259, -350.4889452455742, -350.4889446722418, -350.4889260783837, -350.4889255050583, -350.4889549908363, -350.4889349270301, -350.4889358236478, -350.4889157598448, -350.4889449613429, -350.4889449564679, -350.4889257941559, -350.4889257892809, -350.4889387103178, -350.4889512075046, -350.4889195431645, -350.4889320402839, -350.4889433960812, -350.4889465217309, -350.4889242288944, -350.4889273545436, -350.4889454282117, -350.4889444896599, -350.4889262610256, -350.488925322472, -350.4889669930052, -350.4889229293598, -350.4889478262206, -350.4889037617706, -350.4889473966049, -350.4889425217051, -350.488928229416, 
  -350.48892335452, -350.489014716993, -350.4888752042482, -350.4889955498117, -350.4888560370554, -350.4889676680259, -350.488922249666, -350.4889485008221, -350.4889030824958, -350.4889688261271, -350.4889210915455, -350.488949658938, -350.4889019243605, -350.4889455612046, -350.4889443584785, -350.4889263940134, -350.4889251912957, -350.4889354710348, -350.4889355330493, -350.4889352175193, -350.4889352795342, -350.488935788711, -350.4889352153783, -350.4889355351919, -350.488934961867, -350.488945533973, -350.4889254701669, -350.4889452804561, -350.4889252166531, -350.4889355044796, -350.4889354996046, -350.4889352509642, -350.4889352460894, -350.4889292534703, -350.4889417506254, -350.488928999957, -350.4889414971082, -350.4889339392169, -350.4889370648686, -350.488933685704, 
  -350.4889368113511, -350.4889359713487, -350.4889350327963, -350.4889357178337, -350.4889347792807, -350.4889575363228, -350.4889134723158, -350.4889572828482, -350.4889132187598, -350.4889379397362, -350.4889330648472, -350.4889376862298, -350.488932811323, -350.4890052601314, -350.4888657473832, -350.4890050066185, -350.4888654938655, -350.4889582111536, -350.4889127928116, -350.4889579576395, -350.4889125392952, -350.4889593692643, -350.4889116346816, -350.488959115746, -350.4889113811694, -350.4889361043403, -350.4889349016163, -350.488935850823, -350.488934648103, -350.4889356309438, -350.4889350576148, -350.4889356929583, -350.4889351196295, -350.4889453762067, -350.4889253124021, -350.4889454382213, -350.4889253744169, -350.488935346714, -350.4889353418392, -350.4889354087287, 
  -350.4889354038538, -350.488929095708, -350.488941592857, -350.4889291577187, -350.4889416548756, -350.4889337814527, -350.4889369071019, -350.488933843467}
 {-393.3224213917612, -393.3224243871432, -393.3224242816958, -393.322418501845, -393.3224183964003, -393.3224243369762, -393.3224243318624, -393.3224184516791, -393.3224184465656, -393.3224245170244, -393.3224241518168, -393.322418631724, -393.3224182665234, -393.3224279987287, -393.3224206701484, -393.3224221134307, -393.3224147848527, -393.3224243453937, -393.3224243234449, -393.3224184600968, -393.322418438148, -393.3224241994401, -393.3224244693987, -393.3224183141455, -393.3224185840994, -393.3224242465151, -393.3224244223235, -393.3224183612184, -393.3224185370265, -393.3224243241797, -393.3224243446587, -393.322418438883, -393.3224184593617, -393.3224192030603, -393.3224294672029, -393.3224133176876, -393.3224235819817, -393.3224280579109, -393.3224206112214, -393.3224221726154, 
  -393.3224147259232, -393.322424334419, -393.3224243344196, -393.3224184491221, -393.3224184491227, -393.3224302164982, -393.3224184523072, -393.3224243311996, -393.322412567012, -393.3224314451787, -393.3224172236783, -393.3224255598813, -393.3224113383818, -393.322424345327, -393.3224243235118, -393.32241846003, -393.3224184382149, -393.3224214470413, -393.3224214419275, -393.3224213415952, -393.3224213364815, -393.3224216270889, -393.3224212618825, -393.3224215216407, -393.3224211564388, -393.3224251087939, -393.3224177802136, -393.3224250033467, -393.3224176747687, -393.3224214554587, -393.32242143351, -393.3224213500127, -393.322421328064, -393.3224213095062, -393.3224215794627, -393.3224212040604, -393.3224214740163, -393.3224213565802, -393.3224215323885, -393.3224212511343, 
  -393.3224214269424, -393.3224214342449, -393.3224214547238, -393.3224213287989, -393.3224213492777, -393.3224163130977, -393.3224265772957, -393.3224162076313, -393.3224264718701, -393.3224251679769, -393.3224177212856, -393.3224250625305, -393.32241761584, -393.3224214444841, -393.3224214444847, -393.3224213390381, -393.3224213390387, -393.3224273265623, -393.3224155623733, -393.3224272211166, -393.3224154569269, -393.3224285552443, -393.3224143337428, -393.3224284497967, -393.3224142282982, -393.322421455392, -393.3224214335769, -393.322421349946, -393.3224213281309, -393.3224215769214, -393.3224212117172, -393.3224215718077, -393.3224212066036, -393.322425058627, -393.3224177300477, -393.3224250535132, -393.3224177249341, -393.3224214052924, -393.3224213833436, -393.3224214001788, 
  -393.3224213782299, -393.3224212593406, -393.3224215292955, -393.3224212542257, -393.3224215241832, -393.322421306414, -393.3224214822221, -393.3224213013001}
 {-410.5680303436377, -410.5680306054144, -410.568030028529, -410.5680306587523, -410.5680300818635, -410.5680303019862, -410.5680303319569, -410.5680303553224, -410.5680303852933, -410.5680308889713, -410.5680297449725, -410.5680309423073, -410.568029798309, -410.5680295844732, -410.5680310494774, -410.5680296378095, -410.5680311028136, -410.5680303394835, -410.5680302944597, -410.5680303928197, -410.568030347796, -410.5680302934796, -410.5680303404635, -410.568030346816, -410.5680303937996, -410.5680303153244, -410.5680303186188, -410.5680303686605, -410.568030371955, -410.5680303135246, -410.5680303204185, -410.568030366861, -410.5680303737547, -410.5680184168089, -410.568042217465, -410.5680184699496, -410.5680422709969, -410.5680353627757, -410.5680252712061, -410.5680354161157, 
  -410.5680253245386, -410.5680303901788, -410.5680302437646, -410.5680304435142, -410.5680302971017, -410.5680342225161, -410.5680264114295, -410.5680342758253, -410.5680264647927, -410.5680332347687, -410.5680273991949, -410.568033288105, -410.568027452531, -410.5680303194719, -410.5680303144713, -410.568030372808, -410.5680303678076, -410.5680306170959, -410.5680306470667, -410.5680300402089, -410.5680300701796, -410.5680312040809, -410.5680300600823, -410.5680306271938, -410.5680294831953, -410.568029899583, -410.5680313645871, -410.5680293226958, -410.5680307877002, -410.5680306545931, -410.5680306095694, -410.5680300777061, -410.5680300326823, -410.5680306085894, -410.5680306555731, -410.5680300317023, -410.5680300786862, -410.568030630434, -410.5680306337286, -410.568030053547, 
  -410.5680300568414, -410.5680306286343, -410.5680306355281, -410.5680300517474, -410.5680300586411, -410.5680187318122, -410.5680425326812, -410.5680181549423, -410.5680419557769, -410.5680356778916, -410.5680255863096, -410.5680351009958, -410.5680250094314, -410.568030705288, -410.5680305588749, -410.5680301284012, -410.5680299819875, -410.5680345376088, -410.5680267265561, -410.5680339607287, -410.5680261496621, -410.5680335498785, -410.5680277143044, -410.5680329729914, -410.5680271374174, -410.5680306345816, -410.568030629581, -410.5680300576945, -410.568030052694, -410.5680309006519, -410.5680297566533, -410.5680309306226, -410.5680297866241, -410.5680295961539, -410.5680310611581, -410.5680296261246, -410.5680310911288, -410.5680303511641, -410.5680303061404, -410.5680303811349, 
  -410.5680303361112, -410.5680303051604, -410.5680303521442, -410.5680303351312, -410.5680303821148, -410.5680303270051, -410.5680303302994, -410.5680303569757}
 {-323.8114897452272, -323.8114878683775, -323.8114910473637, -323.8114884431182, -323.8114916221272, -323.8114893854116, -323.8114895303273, -323.8114899601631, -323.8114901050798, -323.811484517788, -323.8114943979549, -323.8114850925747, -323.8114949726723, -323.8114782660067, -323.8115006498199, -323.811478840752, -323.8115012245788, -323.811489292668, -323.8114896230707, -323.8114898674202, -323.8114901978228, -323.8114844570136, -323.8114944589336, -323.8114850317969, -323.8114950336546, -323.8114856384585, -323.8114932773635, -323.8114862132086, -323.8114938521176, -323.8114934526561, -323.8114854631199, -323.8114940274079, -323.8114860378723, -323.8115379459116, -323.8114409725013, -323.8115385215841, -323.811441546333, -323.8115298914797, -323.8114490246994, -323.8115304662286, 
  -323.8114495994546, -323.811512241671, -323.8114666757584, -323.8115128164405, -323.8114672504931, -323.8114936867372, -323.81148522907, -323.8114942613578, -323.8114858039536, -323.8114860519272, -323.8114928641665, -323.8114866266624, -323.8114934389355, -323.8115161715035, -323.8114627439514, -323.8115167462506, -323.8114633187084, -323.8114880832716, -323.8114882281876, -323.811491262269, -323.8114914071853, -323.8114832156639, -323.8114930957993, -323.8114863946646, -323.8114962747937, -323.8114769638619, -323.8114993476851, -323.8114801428625, -323.8115025266795, -323.8114879905283, -323.811488320931, -323.8114911695258, -323.8114914999285, -323.8114831548875, -323.8114931567803, -323.811486333889, -323.8114963357738, -323.8114843363177, -323.8114919752248, -323.8114875153154, 
  -323.8114951542221, -323.8114921505162, -323.8114841609803, -323.8114953295137, -323.8114873399779, -323.8115366441628, -323.8114396699705, -323.8115398232987, -323.8114428488297, -323.8115285893245, -323.8114477225749, -323.8115317683496, -323.8114509015448, -323.8115109395376, -323.8114653736122, -323.8115141185397, -323.8114685526052, -323.8114923845505, -323.811483926977, -323.8114955635103, -323.8114871060124, -323.8114847497807, -323.8114915620334, -323.8114879287747, -323.8114947410344, -323.8115148693618, -323.8114614418133, -323.8115180483581, -323.8114646208122, -323.8114847327049, -323.8114946128374, -323.8114848776213, -323.8114947577533, -323.811478480903, -323.8115008647231, -323.8114786258193, -323.8115010096392, -323.8114895075678, -323.8114898379705, -323.8114896524839, 
  -323.8114899828866, -323.8114846719294, -323.8114946738174, -323.8114848168448, -323.8114948187344, -323.8114858533568, -323.8114934922648, -323.811485998274}
 {-356.8072060914224, -356.8072078761348, -356.8072078493652, -356.8072043334833, -356.8072043067136, -356.8072078644573, -356.8072078610426, -356.8072043218057, -356.8072043183911, -356.8072079008829, -356.8072078246173, -356.8072043582313, -356.8072042819658, -356.8072096866458, -356.8072060388583, -356.8072061439942, -356.8072024962067, -356.8072078693062, -356.8072078561936, -356.8072043266547, -356.807204313542, -356.8072076767117, -356.8072080487975, -356.8072041340606, -356.8072045061454, -356.8072082152655, -356.8072075102371, -356.8072046726139, -356.8072039675856, -356.8072094517736, -356.8072062737387, -356.807205909122, -356.807202731087, -356.8072091668749, -356.807206559198, -356.8072056242218, -356.8072030165479, -356.8072092197093, -356.8072065058588, -356.8072056770582, 
  -356.8072029632066, -356.8071953375431, -356.8072203886641, -356.8071917948912, -356.8072168460128, -356.8072139018919, -356.8072018235716, -356.8072103592406, -356.8071982809199, -356.8072138891453, -356.807201836319, -356.8072103464937, -356.8071982936674, -356.8072198497958, -356.8071958756264, -356.8072163071442, -356.8071923329749, -356.8072061065146, -356.8072061030999, -356.8072060797449, -356.8072060763304, -356.8072061429403, -356.8072060666746, -356.8072061161705, -356.8072060399052, -356.8072079287031, -356.8072042809156, -356.8072079019335, -356.807204254146, -356.8072061113635, -356.807206098251, -356.807206084594, -356.8072060714813, -356.8072059187693, -356.8072062908545, -356.8072058919996, -356.807206264085, -356.8072064573228, -356.8072057522945, -356.8072064305531, 
  -356.8072057255249, -356.8072076938309, -356.807204515796, -356.8072076670613, -356.8072044890263, -356.8072074089292, -356.8072048012583, -356.8072073821641, -356.8072047744843, -356.8072074617667, -356.8072047479159, -356.8072074349974, -356.807204721146, -356.8071935796002, -356.8072186307215, -356.8071935528307, -356.8072186039519, -356.8072121439492, -356.8072000656289, -356.80721211718, -356.8072000388592, -356.8072121312027, -356.8072000783762, -356.8072121044328, -356.8072000516069, -356.8072180918532, -356.8071941176838, -356.8072180650836, -356.8071940909141, -356.8072061312627, -356.8072060549972, -356.807206127848, -356.8072060515825, -356.8072079170256, -356.8072042692381, -356.807207913611, -356.8072042658234, -356.807206099686, -356.8072060865735, -356.8072060962714, 
  -356.8072060831588, -356.8072059070919, -356.8072062791769, -356.807205903677, -356.8072062757625, -356.8072064456453, -356.807205740617, -356.8072064422306}
 {-119.6603144090222, -119.660300633801, -119.6603017613576, -119.6603270567784, -119.6603281843503, -119.6603014652329, -119.6603009299257, -119.6603278882213, -119.6603273529072, -119.6603010750121, -119.6603013201666, -119.6603274979944, -119.6603277431542, -119.6603050202367, -119.6602973749358, -119.6603314432203, -119.6603237979221, -119.6603012365921, -119.6603011585665, -119.6603276595771, -119.6603275815515, -119.6603593320464, -119.660243063692, -119.660385754946, -119.6602694867624, -119.6603066125284, -119.6602957826227, -119.6603330355173, -119.6603222056038, -119.66028780609, -119.6603145890937, -119.6603142290735, -119.6603410120801, -119.6603611012242, -119.6602412951338, -119.6603875255619, -119.6602677167661, -119.6603035250679, -119.6602988702329, -119.6603299480167, 
  -119.660325293254, -119.6602145681661, -119.6603878284431, -119.6602409911679, -119.6604142514112, -119.6602976138939, -119.6603047814755, -119.6603240364668, -119.6603312048726, -119.6603120691226, -119.6602903259862, -119.6603384921081, -119.6603167489707, -119.66025003356, -119.6603523649212, -119.6602764565528, -119.6603787878984, -119.6603141128955, -119.6603135775849, -119.6603152404598, -119.660314705149, -119.6603137226714, -119.6603139678291, -119.6603148502362, -119.6603150953928, -119.6603176678966, -119.6603100225977, -119.6603187954615, -119.6603111501612, -119.660313884253, -119.6603138062274, -119.6603150118172, -119.6603149337916, -119.6603719796665, -119.6602557113936, -119.6603731072269, -119.6602568389618, -119.6603192601932, -119.6603084302797, -119.6603203877536, 
  -119.6603095578479, -119.6603004537501, -119.6603272367554, -119.6603015813144, -119.6603283643195, -119.6603737495474, -119.6602539421324, -119.6603748771397, -119.6602550696685, -119.6603161726926, -119.66031151793, -119.6603173002931, -119.660312645458, -119.6602272158343, -119.6604004760966, -119.6602283434007, -119.6604016036587, -119.6603102613562, -119.660317429335, -119.6603113889056, -119.6603185569141, -119.6603247167843, -119.6603029736463, -119.6603258443475, -119.6603041012116, -119.6602626812231, -119.66036501258, -119.6602638087908, -119.6603661401407, -119.6603145541091, -119.6603147992663, -119.6603140187984, -119.6603142639555, -119.6603184993343, -119.6603108540348, -119.6603179640237, -119.6603103187241, -119.6603147156904, -119.6603146376648, -119.6603141803797, 
  -119.6603141023541, -119.6603728111009, -119.660256542834, -119.6603722757924, -119.6602560075212, -119.6603200916286, -119.6603092617192, -119.6603195563181}
 {-387.377862287091, -387.3778653671835, -387.3778649937886, -387.3778595804121, -387.3778592070184, -387.3778651915142, -387.3778651694574, -387.3778594047435, -387.3778593826866, -387.3778654902322, -387.3778648707402, -387.3778597034582, -387.3778590839726, -387.3778663580545, -387.3778640029353, -387.377860571283, -387.3778582161653, -387.377865156573, -387.3778652043987, -387.3778593698022, -387.3778594176279, -387.3778658297424, -387.3778645312503, -387.3778600429696, -387.3778587444816, -387.3778638696528, -387.3778664913321, -387.3778580828822, -387.3778607045611, -387.3778671473716, -387.3778632136188, -387.3778613606008, -387.377857426848, -387.3778536149187, -387.3778767474788, -387.3778478280575, -387.3778709607984, -387.3778744630497, -387.3778558980744, -387.3778686762792, 
  -387.3778501113031, -387.3778814537902, -387.3778489081241, -387.3778756670183, -387.3778431213545, -387.3778707856589, -387.3778595752843, -387.3778649988851, -387.3778537885165, -387.3778675756756, -387.3778627853277, -387.3778617889048, -387.3778569985569, -387.3778763573297, -387.3778540036012, -387.3778705705593, -387.37784821683, -387.3778624848169, -387.37786246276, -387.3778621114225, -387.3778620893658, -387.377862783534, -387.3778621640436, -387.3778624101381, -387.3778617906508, -387.3778636513576, -387.3778612962374, -387.3778632779615, -387.3778609228449, -387.3778624498756, -387.3778624977013, -387.3778620764813, -387.3778621243069, -387.3778631230442, -387.3778618245538, -387.3778627496496, -387.3778614511598, -387.3778611629557, -387.3778637846345, -387.3778607895611, 
  -387.3778634112404, -387.3778644406742, -387.3778605069214, -387.3778640672798, -387.377860133527, -387.3778509081608, -387.3778740408419, -387.377850534797, -387.3778736674169, -387.3778717563546, -387.3778531913747, -387.377871382956, -387.3778528179845, -387.3778787470926, -387.377846201427, -387.3778783736976, -387.3778458280333, -387.377868078958, -387.3778568685903, -387.3778677055675, -387.3778564951922, -387.3778648689789, -387.3778600786297, -387.3778644955832, -387.3778597052366, -387.3778736506323, -387.3778512969038, -387.3778732772384, -387.377850923509, -387.3778626078642, -387.3778619883753, -387.3778625858074, -387.3778619663186, -387.3778634756877, -387.3778611205693, -387.3778634536309, -387.3778610985126, -387.3778622742067, -387.3778623220323, -387.3778622521498, 
  -387.3778622999756, -387.3778629473756, -387.3778616488844, -387.3778629253176, -387.3778616268287, -387.3778609872866, -387.3778636089655, -387.3778609652297}
 {-338.9758116668253, -338.9758142245701, -338.9758120559796, -338.9758112777015, -338.975809109107, -338.9758131726771, -338.9758131078717, -338.9758102258065, -338.9758101610012, -338.9758151047348, -338.9758111758161, -338.9758121578512, -338.9758082289587, -338.9758121126692, -338.9758141679101, -338.9758091657972, -338.9758112210411, -338.9758130928143, -338.9758131877346, -338.9758101459436, -338.9758102408641, -338.9758139183304, -338.9758123622403, -338.9758109714594, -338.9758094153704, -338.9758111896355, -338.9758150909371, -338.9758082427652, -338.9758121440664, -338.9758150116319, -338.9758112689343, -338.9758120647615, -338.9758083220636, -338.9757491255001, -338.9758771574945, -338.9757461779171, -338.9758742113365, -338.9758373755142, -338.975788905304, -338.9758344286451, 
  -338.9757859584319, -338.975827906371, -338.9757983750994, -338.9758249594997, -338.9757954282295, -338.9758151048132, -338.9758111758445, -338.9758121578359, -338.9758082290807, -338.9758133115412, -338.9758129691516, -338.9758103646746, -338.9758100222772, -338.9758250310633, -338.9758012494126, -338.9758220841932, -338.9757983025417, -338.9758127835248, -338.9758127187194, -338.9758106149321, -338.975810550127, -338.9758147155767, -338.9758107866695, -338.9758125469827, -338.9758086180787, -338.9758117235205, -338.9758137787541, -338.9758095549193, -338.9758116101704, -338.9758127036619, -338.9758127985822, -338.9758105350693, -338.9758106299898, -338.9758135291773, -338.9758119730888, -338.9758113605859, -338.9758098044952, -338.9758108004833, -338.9758147017846, -338.9758086318907, 
  -338.9758125331922, -338.9758146224794, -338.9758108797819, -338.9758124538871, -338.9758087111893, -338.975748735951, -338.9758767687389, -338.9757465674395, -338.9758746000653, -338.9758369863765, -338.9757885161369, -338.9758348177563, -338.9757863475722, -338.9758275172183, -338.9757979859473, -338.9758253486258, -338.9757958173548, -338.9758147155957, -338.9758107867572, -338.9758125470267, -338.9758086181413, -338.975812922391, -338.975812579997, -338.975810753798, -338.975810411405, -338.975824641911, -338.9758008602602, -338.9758224733188, -338.9757986916673, -338.9758136636819, -338.9758097347762, -338.9758135988767, -338.975809669971, -338.9758106716222, -338.9758127268644, -338.9758106068167, -338.9758126620593, -338.9758116517678, -338.9758117466882, -338.9758115869625, 
  -338.975811681883, -338.975812477284, -338.975810921194, -338.9758124124783, -338.9758108563891, -338.9758097485898, -338.9758136498901, -338.9758096837833}
 {-199.8228251092119, -199.8228240289182, -199.8228241042429, -199.82282611419, -199.8228261895156, -199.8228240475824, -199.8228240855787, -199.8228261328544, -199.8228261708512, -199.8228240378053, -199.8228240953575, -199.8228261230775, -199.8228261806298, -199.822824877828, -199.8228232553338, -199.8228269631002, -199.822825340606, -199.8228240658252, -199.8228240673359, -199.8228261510975, -199.8228261526081, -199.8228240867477, -199.8228240464134, -199.8228261720202, -199.8228261316854, -199.8228240641686, -199.8228240689924, -199.8228261494409, -199.8228261542647, -199.8228240726332, -199.8228240605279, -199.8228261579055, -199.8228261458001, -199.8228329607694, -199.8228151726256, -199.8228350462425, -199.8228172576969, -199.8228236544542, -199.8228244787342, -199.8228257397209, 
  -199.822826564012, -199.8228242310352, -199.8228239021261, -199.822826316309, -199.8228259873967, -199.8228280425638, -199.8228200905984, -199.8228301277924, -199.8228221759143, -199.8228301191592, -199.8228180139653, -199.8228322044314, -199.8228200992376, -199.8228240677981, -199.822824065363, -199.8228261530704, -199.8228261506353, -199.822825052551, -199.8228250905476, -199.8228251278762, -199.8228251658727, -199.822825042774, -199.8228251003263, -199.8228251180992, -199.8228251756514, -199.8228258827967, -199.8228242603025, -199.8228259581219, -199.8228243356277, -199.8228250707939, -199.8228250723046, -199.8228251461191, -199.8228251476298, -199.8228250917166, -199.822825051382, -199.8228251670417, -199.8228251267072, -199.8228250691374, -199.8228250739611, -199.8228251444626, 
  -199.8228251492863, -199.822825077602, -199.8228250654966, -199.8228251529272, -199.8228251408218, -199.8228339658375, -199.8228161774949, -199.8228340411648, -199.8228162528179, -199.822824659417, -199.8228254837089, -199.8228247347485, -199.8228255590277, -199.8228252360047, -199.822824907094, -199.82282531133, -199.8228249824191, -199.8228290475112, -199.8228210955885, -199.8228291228354, -199.8228211709146, -199.8228311241279, -199.822819018934, -199.8228311994531, -199.8228190942593, -199.8228250727669, -199.8228250703318, -199.822825148092, -199.8228251456569, -199.8228250614384, -199.8228251189905, -199.8228250994349, -199.8228251569871, -199.822825901461, -199.8228242789668, -199.8228259394576, -199.8228243169634, -199.8228250894582, -199.8228250909689, -199.8228251274548, 
  -199.8228251289655, -199.8228251103807, -199.8228250700464, -199.8228251483776, -199.8228251080427, -199.8228250878017, -199.8228250926255, -199.8228251257983}
 {-345.7755108193326, -345.7755108250366, -345.775510817182, -345.7755108214831, -345.7755108136286, -345.7755108217525, -345.7755108204661, -345.7755108181991, -345.7755108169127, -345.775510847238, -345.7755107949812, -345.7755108436845, -345.7755107914279, -345.7755119550253, -345.775509687198, -345.775511951472, -345.7755096836446, -345.7755108511783, -345.7755107910403, -345.7755108476249, -345.7755107874868, -345.7755110042248, -345.7755106380171, -345.7755110006706, -345.7755106344645, -345.7755114006135, -345.7755102416109, -345.7755113970601, -345.7755102380575, -345.7755120364884, -345.7755096057522, -345.775512032935, -345.7755096021986, -345.7755109070233, -345.7755107351981, -345.7755109034696, -345.7755107316449, -345.775508603984, -345.7755130382874, -345.7755086004305, 
  -345.7755130347341, -345.775517310428, -345.7755043323931, -345.7755173068745, -345.7755043288397, -345.7755108279415, -345.7755108142772, -345.775510824388, -345.7755108107237, -345.7755164759631, -345.7755051662263, -345.7755164724097, -345.7755051626729, -345.7755251497082, -345.7754964923244, -345.7755251461548, -345.7754964887708, -345.7755108239031, -345.7755108226166, -345.7755108160485, -345.7755108147622, -345.7755108493886, -345.7755107971317, -345.7755108415339, -345.7755107892774, -345.7755119571759, -345.7755096893486, -345.7755119493213, -345.7755096814941, -345.7755108533289, -345.7755107931908, -345.7755108454744, -345.7755107853363, -345.7755110063753, -345.7755106401676, -345.7755109985201, -345.775510632314, -345.775511402764, -345.7755102437614, -345.7755113949095, 
  -345.7755102359069, -345.775512038639, -345.7755096079027, -345.7755120307845, -345.7755096000481, -345.7755109091737, -345.7755107373488, -345.7755109013192, -345.7755107294942, -345.7755086061345, -345.7755130404379, -345.7755085982799, -345.7755130325835, -345.7755173125786, -345.7755043345435, -345.7755173047238, -345.7755043266893, -345.775510830092, -345.7755108164277, -345.7755108222375, -345.7755108085732, -345.7755164781137, -345.7755051683768, -345.7755164702591, -345.7755051605224, -345.7755251518587, -345.7754964944749, -345.7755251440043, -345.7754964866203, -345.7755108461045, -345.7755107938477, -345.775510844818, -345.7755107925613, -345.7755119538918, -345.7755096860645, -345.7755119526054, -345.7755096847781, -345.7755108500449, -345.7755107899068, -345.7755108487585, 
  -345.7755107886204, -345.7755110030909, -345.775510636884, -345.7755110018046, -345.7755106355976, -345.77551139948, -345.7755102404774, -345.7755113981936}
 {-245.9769498083068, -245.9769369492435, -245.9769384811895, -245.976961135485, -245.9769626674552, -245.9769378533709, -245.9769375770619, -245.9769620396261, -245.9769617633138, -245.9769376026408, -245.976937827812, -245.9769617889019, -245.976962014058, -245.9769463858376, -245.9769290446656, -245.9769705720875, -245.9769532309227, -245.976937688282, -245.9769377421508, -245.9769618745356, -245.9769619284043, -245.9769663425919, -245.9769090884259, -245.9769905287868, -245.976933274738, -245.9769473408964, -245.9769280895792, -245.9769715271508, -245.976952275832, -245.9769400646702, -245.9769353658429, -245.9769642509222, -245.976959552098, -245.9771035522578, -245.9767718829566, -245.9771277412362, -245.9767960664855, -245.976938311641, -245.9769371193244, -245.9769624978652, 
  -245.9769613056073, -245.9768741901548, -245.9770012442045, -245.9768983764433, -245.9770254304231, -245.9769336502664, -245.976941780602, -245.9769578359515, -245.976965967424, -245.9769458868033, -245.9769295438487, -245.9769700730507, -245.9769537301083, -245.9769489153973, -245.9769265169049, -245.9769731016559, -245.9769507031534, -245.9769491804832, -245.9769489041725, -245.9769507124413, -245.9769504361305, -245.9769489297566, -245.9769491549191, -245.9769504617135, -245.9769506868783, -245.976957712947, -245.9769403717791, -245.9769592449055, -245.9769419037368, -245.9769490153934, -245.9769490692622, -245.9769505473515, -245.9769506012203, -245.9769776696761, -245.9769204155646, -245.9769792016301, -245.9769219475267, -245.9769586680094, -245.9769394166892, -245.9769601999652, 
  -245.9769409486496, -245.976951391781, -245.9769466929551, -245.9769529237389, -245.9769482249133, -245.9771148806927, -245.9767832087447, -245.9771164127287, -245.9767847406248, -245.9769496387, -245.9769484464884, -245.9769511707337, -245.9769499783708, -245.9768855172789, -245.9770125713033, -245.9768870492466, -245.9770141032517, -245.9769449771067, -245.9769531079846, -245.9769465090386, -245.9769546399688, -245.9769572139111, -245.9769408709637, -245.9769587458703, -245.9769424029207, -245.9769602425104, -245.9769378440147, -245.9769617744703, -245.976939375971, -245.9769498338902, -245.976950059054, -245.9769495575797, -245.9769497827432, -245.9769586170814, -245.9769412759131, -245.9769583407708, -245.9769409996023, -245.9769499195277, -245.9769499733965, -245.9769496432171, 
  -245.9769496970858, -245.9769785738074, -245.9769213197018, -245.9769782974984, -245.9769210433893, -245.9769595721425, -245.9769403208246, -245.9769592958318}
 {-229.6674868413056, -229.6674895725762, -229.6674885996023, -229.667485083011, -229.667484110038, -229.6674891355257, -229.6674890366527, -229.667484645961, -229.6674845470879, -229.6674882982953, -229.6674898738831, -229.6674838087307, -229.6674853843183, -229.6674866115153, -229.6674915606673, -229.6674821219505, -229.6674870711025, -229.6674890135344, -229.6674891586439, -229.6674845239697, -229.6674846690792, -229.6674837960286, -229.6674943761473, -229.6674793064647, -229.6674898865816, -229.6674838433068, -229.6674943288754, -229.6674793537419, -229.6674898393107, -229.6674863719113, -229.6674918002763, -229.6674818823465, -229.6674873107115, -229.6674623818527, -229.6675157905604, -229.6674578920541, -229.6675113012295, -229.6674974389742, -229.6674807332326, -229.6674929494074, 
  -229.6674762436699, -229.6675290934588, -229.6674490790599, -229.6675246038949, -229.6674445894943, -229.6674823238012, -229.6674958485732, -229.6674778342724, -229.6674913589724, -229.6674754221154, -229.6675027503846, -229.6674709325506, -229.6674982608199, -229.6674326485731, -229.6675455267049, -229.6674281590083, -229.6675410371402, -229.667487377229, -229.6674872783559, -229.6674864042554, -229.6674863053823, -229.6674865399987, -229.6674881155861, -229.6674855670249, -229.6674871426129, -229.6674848532186, -229.6674898023705, -229.6674838802449, -229.667488829397, -229.6674872552376, -229.6674874003472, -229.6674862822641, -229.6674864273736, -229.6674820377327, -229.6674926178496, -229.6674810647583, -229.667491644877, -229.6674820850102, -229.6674925705783, -229.6674811120361, 
  -229.6674915976054, -229.6674846136145, -229.6674900419795, -229.6674836406409, -229.6674890690059, -229.6674606234341, -229.6675140323855, -229.6674596504705, -229.667513059402, -229.6674956806847, -229.6674789749285, -229.6674947076945, -229.6674780019717, -229.6675273351624, -229.6674473207627, -229.667526362189, -229.6674463477891, -229.6674805655166, -229.6674940902641, -229.6674795925547, -229.667493117279, -229.6674736638186, -229.6675009920877, -229.667472690845, -229.6675000191143, -229.667430890276, -229.6675437684084, -229.6674299173031, -229.6675427954343, -229.6674861029483, -229.667487678536, -229.6674860040752, -229.667487579663, -229.6674844161683, -229.6674893653203, -229.6674843172952, -229.6674892664472, -229.6674868181874, -229.6674869632969, -229.6674867193143, 
  -229.6674868644238, -229.6674816006822, -229.6674921807995, -229.6674815018086, -229.6674920819269, -229.6674816479597, -229.6674921335284, -229.6674815490866}
 {-298.4622265379851, -298.4622289389505, -298.4622289066864, -298.4622241692906, -298.4622241370263, -298.46222895658, -298.4622288890568, -298.4622241869206, -298.4622241193963, -298.4622287100678, -298.4622291355698, -298.4622239404081, -298.4622243659097, -298.4622321775664, -298.4622256680755, -298.4622274079065, -298.4622208984155, -298.4622289797307, -298.4622288659061, -298.4622242100708, -298.4622240962461, -298.4622411892225, -298.4622166564177, -298.4622364195551, -298.4622118867652, -298.4622294800194, -298.4622283656135, -298.4622247103598, -298.4622235959533, -298.4622079624242, -298.4622498832749, -298.4622031927642, -298.4622451136151, -298.4622390475651, -298.4622187989244, -298.4622342780759, -298.4622140290937, -298.4622370418074, -298.4622208039394, -298.4622322721417, 
  -298.4622160342853, -298.4621356621917, -298.4623221846889, -298.4621308925342, -298.4623174150265, -298.4622407668675, -298.4622170787008, -298.4622359971988, -298.4622123090496, -298.4622459991541, -298.4622118463925, -298.4622412294942, -298.4622070767325, -298.4621171457407, -298.462340706522, -298.4621123760816, -298.4623359368614, -298.4622265878792, -298.4622265203554, -298.462226555615, -298.4622264880913, -298.462226341367, -298.4622267668684, -298.4622263091026, -298.4622267346046, -298.4622298088653, -298.4622232993744, -298.4622297766013, -298.4622232671102, -298.4622266110296, -298.462226497205, -298.4622265787655, -298.4622264649408, -298.4622388205172, -298.4622142877208, -298.4622387882539, -298.4622142554558, -298.4622271113185, -298.4622259969121, -298.4622270790542, 
  -298.4622259646482, -298.4622055937231, -298.462247514574, -298.4622055614589, -298.4622474823098, -298.4622366789497, -298.4622164301375, -298.4622366466848, -298.4622163978742, -298.4622346731014, -298.4622184352433, -298.4622346408414, -298.462218402975, -298.4621332934918, -298.4623198159865, -298.4621332612277, -298.4623197837224, -298.4622383981619, -298.4622147100041, -298.4622383658981, -298.4622146777396, -298.4622436304532, -298.4622094776912, -298.4622435981886, -298.4622094454274, -298.46211477704, -298.4623383378207, -298.4621147447759, -298.4623383055564, -298.4622263589966, -298.4622267844984, -298.4622262914729, -298.4622267169747, -298.4622298264951, -298.4622233170042, -298.4622297589713, -298.4622232494804, -298.4622266286594, -298.4622265148348, -298.4622265611356, 
  -298.462226447311, -298.4622388381475, -298.46221430535, -298.4622387706236, -298.4622142378264, -298.4622271289483, -298.4622260145419, -298.4622270614244}
 {-604.7020624179693, -604.7020580026794, -604.7020568660683, -604.7020679699062, -604.702066833285, -604.7020574726032, -604.7020573961443, -604.7020674398253, -604.7020673633655, -604.7020566205296, -604.7020582482236, -604.7020665877517, -604.7020682154452, -604.7020598015718, -604.7020550671861, -604.7020697687941, -604.7020650344074, -604.7020574504877, -604.7020574182598, -604.7020674177095, -604.7020673854815, -604.7020576103755, -604.702057258372, -604.7020675775988, -604.7020672255923, -604.7020573658619, -604.7020575028855, -604.7020673330833, -604.7020674701078, -604.7020574069241, -604.7020574618232, -604.7020673741455, -604.7020674290453, -604.7020361672987, -604.7020787018424, -604.7020461340388, -604.7020886695459, -604.702056429714, -604.7020584390792, -604.7020663969482, 
  -604.7020684062886, -604.7020570250558, -604.7020578436919, -604.7020669922746, -604.7020678109165, -604.7020561061858, -604.7020587626588, -604.7020660732565, -604.7020687300318, -604.7020627780497, -604.7020520906739, -604.7020727452711, -604.702062057896, -604.7020574346187, -604.7020574341287, -604.7020674018404, -604.7020674013505, -604.7020630245072, -604.7020629480478, -604.702061887891, -604.7020618114317, -604.7020621724334, -604.7020638001273, -604.7020610358175, -604.7020626635112, -604.702065353476, -604.7020606190894, -604.7020642168595, -604.7020594824737, -604.7020630023915, -604.7020629701636, -604.7020618657753, -604.7020618335474, -604.7020631622801, -604.7020628102749, -604.7020620256639, -604.702061673659, -604.7020629177655, -604.7020630547896, -604.7020617811493, 
  -604.7020619181734, -604.7020629588276, -604.702063013727, -604.7020618222116, -604.702061877111, -604.7020417189518, -604.7020842539967, -604.7020405823554, -604.7020831173611, -604.7020619816324, -604.7020639909684, -604.7020608449996, -604.702062854369, -604.7020625769579, -604.7020633955972, -604.7020614403421, -604.7020622589807, -604.7020616580073, -604.7020643146449, -604.7020605214048, -604.7020631780153, -604.7020683299534, -604.7020576425778, -604.7020671933373, -604.7020565059617, -604.7020629865225, -604.7020629860326, -604.7020618499063, -604.7020618494164, -604.702061642355, -604.7020632700487, -604.7020615658957, -604.7020631935895, -604.7020648233973, -604.7020600890111, -604.7020647469379, -604.7020600125518, -604.702062472313, -604.702062440085, -604.7020623958536, 
  -604.7020623636255, -604.7020626322007, -604.7020622801972, -604.702062555743, -604.7020622037364, -604.7020623876872, -604.7020625247107, -604.7020623112273}
 {-183.3349148230212, -183.3349075253129, -183.3349076095289, -183.3349220365942, -183.3349221208142, -183.3349074624131, -183.3349076724289, -183.3349219736949, -183.3349221837137, -183.3349066160111, -183.3349085188505, -183.3349211272891, -183.334923030139, -183.3349176321674, -183.3348975027125, -183.3349321434493, -183.3349120139972, -183.3349076081549, -183.3349075266872, -183.3349221194382, -183.3349220379705, -183.3349107601484, -183.3349043752018, -183.334925271488, -183.3349188864288, -183.3349065793525, -183.3349085555031, -183.3349210906353, -183.3349230667869, -183.3349123218842, -183.3349028130213, -183.334926833168, -183.3349173243041, -183.3350207709866, -183.3347943675589, -183.3350352843654, -183.3348088767467, -183.3349030649308, -183.334912070335, -183.3349175761749, 
  -183.3349265816575, -183.3349231303889, -183.3348920075054, -183.3349376416999, -183.3349065187609, -183.3349159055718, -183.3348992295558, -183.3349304164529, -183.3349137412414, -183.3349426629788, -183.3348724717363, -183.334957174261, -183.3348869830206, -183.3348565766923, -183.334958562913, -183.3348710879683, -183.3349730742035, -183.3349146759034, -183.3349148859207, -183.3349147601214, -183.3349149701388, -183.3349138295002, -183.3349157323435, -183.3349139137169, -183.3349158165628, -183.3349248456584, -183.3349047162037, -183.3349249298752, -183.3349048004229, -183.334914821646, -183.3349147401782, -183.3349149058639, -183.3349148243963, -183.3349179736684, -183.334911588664, -183.3349180578849, -183.3349116728834, -183.3349137928414, -183.3349157689964, -183.3349138770633, 
  -183.3349158532104, -183.3349195353754, -183.3349100265123, -183.3349196195937, -183.33491011073, -183.3350279855197, -183.334801580008, -183.3350280697492, -183.3348016642145, -183.3349102783728, -183.3349192838751, -183.3349103626497, -183.3349193680342, -183.3349303438909, -183.3348992209855, -183.3349304281147, -183.3348993051976, -183.3349231188647, -183.3349064432451, -183.3349232030769, -183.3349065274689, -183.334949876468, -183.3348796852291, -183.3349499606886, -183.3348797694445, -183.3348637901815, -183.334965776406, -183.334863874396, -183.3349658606274, -183.3349137666, -183.3349156694446, -183.3349139766173, -183.3349158794619, -183.3349247827582, -183.3349046533048, -183.3349249927755, -183.3349048633221, -183.3349147587464, -183.3349146772787, -183.3349149687637, 
  -183.3349148872961, -183.3349179107676, -183.3349115257657, -183.334918120786, -183.3349117357819, -183.3349137299438, -183.3349157060949, -183.3349139399612}
 {-228.6683000468441, -228.6683001963906, -228.6682999974637, -228.6683000962346, -228.6682998973048, -228.6683001441407, -228.6683000497136, -228.6683000439839, -228.6682999495555, -228.668300473078, -228.6682997207778, -228.6683003729204, -228.6682996206205, -228.6683008187782, -228.6682993750791, -228.6683007186209, -228.6682992749216, -228.6683000488693, -228.668300144985, -228.6682999487119, -228.6683000448275, -228.6683083861613, -228.6682918077439, -228.668308286, -228.6682917075902, -228.6682981105034, -228.6683020833537, -228.6682980103461, -228.6683019831961, -228.6682947509153, -228.6683054429729, -228.6682946507577, -228.6683053428155, -228.6683085639161, -228.6682916302702, -228.6683084639398, -228.6682915299315, -228.668299220279, -228.6683009736153, -228.6682991201156, 
  -228.6683008734637, -228.6682754994773, -228.6683246948419, -228.6682753993222, -228.668324594682, -228.6683053307856, -228.6682948630469, -228.6683052306029, -228.6682947629147, -228.6683055937138, -228.668294600114, -228.6683054935565, -228.6682944999564, -228.6682954205888, -228.6683047739613, -228.6682953204316, -228.6683046738035, -228.6683001935223, -228.6683000990944, -228.6682999945938, -228.6682999001661, -228.6683005224591, -228.6682997701591, -228.6683003235307, -228.6682995712307, -228.6683008681595, -228.6682994244602, -228.6683006692311, -228.6682992255319, -228.6683000982505, -228.6683001943662, -228.6682998993222, -228.6682999954378, -228.6683084355405, -228.668291857127, -228.6683082366122, -228.6682916581985, -228.6682981598848, -228.6683021327347, -228.6682979609563, 
  -228.6683019338065, -228.6682948002964, -228.6683054923541, -228.6682946013681, -228.6683052934257, -228.6683086133925, -228.6682916795562, -228.6683084144548, -228.6682914806371, -228.6682992696545, -228.6683010230021, -228.6682990707315, -228.6683008240684, -228.6682755488598, -228.6683247442218, -228.6682753499313, -228.6683245452936, -228.668305380153, -228.6682949124418, -228.668305181227, -228.6682947135112, -228.6683056430951, -228.6682946494951, -228.6683054441667, -228.6682944505669, -228.66829546997, -228.6683048233424, -228.6682952710418, -228.6683046244139, -228.6683004702088, -228.6682997179087, -228.668300375781, -228.668299623481, -228.6683008159091, -228.6682993722099, -228.6683007214814, -228.6682992777821, -228.6683000460001, -228.6683001421158, -228.6682999515724, 
  -228.6683000476881, -228.6683083832902, -228.6682918048766, -228.6683082888625, -228.6682917104488, -228.6682981076344, -228.6683020804845, -228.6682980132066}
 {-222.2437666493849, -222.2437665109927, -222.2437667097922, -222.2437665889815, -222.243766787784, -222.2437666367186, -222.2437665840663, -222.2437667147092, -222.2437666620562, -222.2437663707953, -222.2437668499905, -222.2437664487856, -222.2437669279807, -222.2437668371274, -222.2437663836612, -222.2437669151176, -222.2437664616514, -222.2437666400668, -222.2437665807181, -222.2437667180571, -222.2437666587084, -222.2437527956541, -222.2437804251585, -222.2437528736465, -222.2437805031467, -222.243761200331, -222.2437720204572, -222.2437612783212, -222.2437720984476, -222.2437769955178, -222.2437562252982, -222.243777073508, -222.2437563032885, -222.2437683893767, -222.2437648316099, -222.2437684674821, -222.243764909485, -222.2437652716522, -222.243767949157, -222.2437653496387, 
  -222.243768027151, -222.2438067467456, -222.2437264743344, -222.2438068247374, -222.2437265523232, -222.2437721086457, -222.2437611121125, -222.2437721866195, -222.2437611901193, -222.2437722721, -222.243760948655, -222.2437723500902, -222.2437610266454, -222.2436983861744, -222.2438348382579, -222.2436984641645, -222.2438349162483, -222.2437665763108, -222.2437665236581, -222.2437667751119, -222.2437667224591, -222.2437663103873, -222.2437667895824, -222.2437665091884, -222.2437669883835, -222.2437667767193, -222.2437663232532, -222.2437669755204, -222.2437665220542, -222.2437665796588, -222.2437665203101, -222.2437667784599, -222.2437667191111, -222.2437527352471, -222.2437803647495, -222.2437529340483, -222.2437805635504, -222.243761139923, -222.2437719600493, -222.2437613387241, 
  -222.2437721588503, -222.2437769351098, -222.2437561648902, -222.2437771339109, -222.2437563636912, -222.2437683290216, -222.243764771149, -222.243768527832, -222.2437649699406, -222.243765211241, -222.2437678887522, -222.2437654100447, -222.2437680875507, -222.2438066863383, -222.2437264139258, -222.2438068851396, -222.2437266127266, -222.2437720482307, -222.2437610517116, -222.2437722470294, -222.2437612505151, -222.243772211692, -222.2437608882471, -222.243772410493, -222.2437610870482, -222.2436983257663, -222.24383477785, -222.2436985245674, -222.2438349766511, -222.2437664361141, -222.2437669153093, -222.2437663834615, -222.2437668626566, -222.2437669024462, -222.24376644898, -222.2437668497935, -222.2437663963273, -222.2437667053856, -222.2437666460369, -222.2437666527329, 
  -222.2437665933843, -222.2437528609742, -222.243780490476, -222.2437528083211, -222.2437804378238, -222.2437612656498, -222.2437720857761, -222.2437612129972}
 {-157.9530919180034, -157.9530865505799, -157.9530889287865, -157.9530949072534, -157.9530972854962, -157.9530876733956, -157.9530878059691, -157.9530960300862, -157.9530961626617, -157.9530844635001, -157.9530910158734, -157.9530928201922, -157.9530993725645, -157.9530821873755, -157.953093292041, -157.9530905440666, -157.9531016487331, -157.953087642526, -157.9530878368387, -157.9530959992176, -157.9530961935303, -157.9530824037762, -157.953093075936, -157.953090760469, -157.9531014326265, -157.9530851527889, -157.95309032666, -157.9530935094805, -157.9530986833517, -157.9530911542139, -157.9530843251703, -157.9530995109055, -157.9530926818618, -157.9531089279292, -157.9530665521396, -157.9531172852824, -157.9530749081697, -157.9530956414003, -157.9530798380495, -157.9531039980699, 
  -157.9530881947631, -157.953098455744, -157.9530770246417, -157.9531068124444, -157.9530853813246, -157.9531007612359, -157.9530747181122, -157.9531091177715, -157.9530830749599, -157.9530984396055, -157.953077039785, -157.9531067962967, -157.953085396477, -157.9531328518997, -157.953042626808, -157.9531412085912, -157.9530509834998, -157.9530906626047, -157.953090795179, -157.9530930408292, -157.9530931734039, -157.9530874527099, -157.9530940050827, -157.9530898309346, -157.9530963833073, -157.9530851765847, -157.9530962812509, -157.9530875548096, -157.9530986594754, -157.9530906317355, -157.9530908260482, -157.9530930099603, -157.9530932042729, -157.9530853929862, -157.953096065145, -157.953087771211, -157.9530984433696, -157.9530881419984, -157.9530933158696, -157.9530905202231, 
  -157.9530956940943, -157.9530941434234, -157.9530873143797, -157.9530965216481, -157.9530896926045, -157.9531119174351, -157.9530695410528, -157.9531142957286, -157.9530719192087, -157.953098630592, -157.9530828272768, -157.9531010088303, -157.953085205488, -157.953101444957, -157.9530800138477, -157.9531038231835, -157.9530823920707, -157.9531037503818, -157.9530777073854, -157.9531061285777, -157.9530800856389, -157.9531014288149, -157.9530800289947, -157.9531038070395, -157.9530824072195, -157.9531358411092, -157.9530456160176, -157.9531382193339, -157.9530479942424, -157.9530885755341, -157.9530951279069, -157.9530887081086, -157.9530952604814, -157.953086299409, -157.953097404075, -157.9530864319835, -157.9530975366495, -157.9530917545598, -157.9530919488724, -157.9530918871343, 
  -157.9530920814469, -157.9530865158105, -157.9530971879693, -157.953086648385, -157.9530973205437, -157.9530892648226, -157.9530944386939, -157.9530893973972}
 {-40.47777779866687, -40.47778773939145, -40.47778877075561, -40.4777668266863, -40.47776785804293, -40.47778816418938, -40.47778834595748, -40.47776725148191, -40.47776743324712, -40.47779083634664, -40.477785673823, -40.47776992362046, -40.47776476113135, -40.47779158423366, -40.47778492593037, -40.47777067152717, -40.47776401321904, -40.47778817515704, -40.47778833498985, -40.47776726244825, -40.47776742228082, -40.47782282646324, -40.47775368445722, -40.47780191368692, -40.47773277181572, -40.47778807406717, -40.47778843609668, -40.47776716135915, -40.47776752338685, -40.47778787707145, -40.47778863313012, -40.47776696436245, -40.47776772042129, -40.47774364951958, -40.4778328622087, -40.47772273658666, -40.47781194972382, -40.47778224110899, -40.477794269237, -40.47776132838957, 
  -40.47777335653858, -40.47778038375673, -40.47779612835636, -40.47775947106198, -40.47777521563328, -40.4777967129773, -40.47777979723469, -40.47777580040706, -40.4777588843871, -40.47780989523725, -40.47776661480932, -40.47778898253346, -40.47774570209528, -40.47781258040513, -40.47776393052792, -40.47779166770502, -40.4777430178102, -40.47777719210345, -40.47777737387007, -40.47777822346381, -40.4777784052305, -40.47777986425332, -40.47777470174298, -40.47778089560975, -40.47777573310734, -40.47778061214723, -40.47777395384346, -40.47778164350956, -40.4777749852019, -40.47777720307039, -40.47777736290317, -40.47777823443086, -40.47777839426347, -40.47781185434199, -40.47774271240513, -40.47781288570411, -40.47774374376378, -40.4777771019805, -40.47777746401, -40.47777813334177, 
  -40.47777849536949, -40.47777690498477, -40.47777766104345, -40.47777793634508, -40.47777869240393, -40.47773267734215, -40.47782189021282, -40.47773370866006, -40.47782292161568, -40.47777126903064, -40.477783297142, -40.47777230036388, -40.47778432852955, -40.47776941167855, -40.47778515626118, -40.4777704430361, -40.47778618762441, -40.47778574096688, -40.47776882507177, -40.47778677231344, -40.47776985644598, -40.47779892315289, -40.47775564272034, -40.47779995451378, -40.47775667408023, -40.47780160832342, -40.47775295843629, -40.47780263968269, -40.47775398979779, -40.47778028904804, -40.4777751265418, -40.47778047081485, -40.47777530830833, -40.47778103694498, -40.47777437863926, -40.47778121871163, -40.47777456040591, -40.4777776278672, -40.47777778769991, -40.47777780963385, 
  -40.47777796946655, -40.47781227914166, -40.477743137199, -40.47781246090425, -40.47774331896973, -40.47777752677757, -40.47777788880647, -40.4777777085445}
 {-530.3828352227559, -530.3828280481667, -530.3828280158586, -530.3828424296858, -530.382842397387, -530.3828280257579, -530.3828280382679, -530.3828424072814, -530.3828424197921, -530.3828284744648, -530.3828275895714, -530.3828428559823, -530.3828419711015, -530.3828328015703, -530.3828232625134, -530.3828471830911, -530.3828376440404, -530.3828279817928, -530.382828082233, -530.3828423633168, -530.3828424637569, -530.3828264913333, -530.3828295730346, -530.3828408728494, -530.3828439545664, -530.3828247050809, -530.3828313589812, -530.3828390866048, -530.3828457405048, -530.3828341517411, -530.3828219123412, -530.3828485332652, -530.3828362938649, -530.3827174585344, -530.3829386083432, -530.3827318387725, -530.3829529911529, -530.3828452006864, -530.3828108637893, -530.3828595822146, 
  -530.3828252453087, -530.3828476133029, -530.3828084535498, -530.3828619948104, -530.3828228350902, -530.3828128262966, -530.3828432381467, -530.3828272075002, -530.3828576199908, -530.3828373298987, -530.3828187341759, -530.3828517114221, -530.3828331157002, -530.3828627207244, -530.3827933431243, -530.3828771022485, -530.382807724648, -530.3828352326521, -530.3828352451626, -530.3828352003487, -530.382835212859, -530.3828356813581, -530.3828347964672, -530.3828356490508, -530.3828347641676, -530.3828400084646, -530.3828304694084, -530.3828399761587, -530.3828304371072, -530.3828351886875, -530.3828352891276, -530.3828351563839, -530.3828352568241, -530.3828336982243, -530.3828367799328, -530.3828336659199, -530.3828367476301, -530.3828319119755, -530.3828385658757, -530.382831879672, 
  -530.382838533572, -530.3828413586357, -530.3828291192357, -530.3828413263322, -530.3828290869321, -530.3827246647891, -530.3829458158778, -530.3827246324796, -530.3829457835802, -530.3828524076034, -530.3828180706612, -530.3828523752592, -530.3828180383984, -530.3828548201922, -530.3828156604497, -530.3828547878826, -530.3828156281522, -530.3828200330344, -530.382850445198, -530.3828200007241, -530.3828504129013, -530.3828445367914, -530.3828259410722, -530.382844504491, -530.3828259087656, -530.3828699276194, -530.3828005500185, -530.3828698953152, -530.3828005177155, -530.3828356589495, -530.3828347740624, -530.3828356714599, -530.3828347865728, -530.3828399860568, -530.3828304470026, -530.382839998567, -530.3828304595132, -530.3828351662808, -530.3828352667209, -530.3828351787911, 
  -530.3828352792313, -530.3828336758174, -530.3828367575263, -530.3828336883274, -530.3828367700371, -530.382831889569, -530.3828385434688, -530.3828319020791}
 {-42.49201007135435, -42.49200763232203, -42.49200174905765, -42.49201839370898, -42.49201251043116, -42.49200457191356, -42.49200480946532, -42.49201533329298, -42.49201557084638, -42.49201078643487, -42.49199859494963, -42.49202154777691, -42.49200935636805, -42.49200078395551, -42.49200859753971, -42.49201154533311, -42.4920193589226, -42.49200495846293, -42.49200442291597, -42.49201571984304, -42.49201518429633, -42.49198906886821, -42.49202031299691, -42.49199983029419, -42.4920310743314, -42.49202087167406, -42.4919885098136, -42.49203163305594, -42.49199927119219, -42.49201873953018, -42.4919906419696, -42.49202950091144, -42.49200140334881, -42.4918268300357, -42.49218255679414, -42.49183758922411, -42.49219332036629, -42.49211728960553, -42.49189209292551, -42.49212805099617, 
  -42.49190285429535, -42.49187477119142, -42.49213461677311, -42.49188553254955, -42.49214537817546, -42.49199403749051, -42.49201534436986, -42.4920047984425, -42.49202610617834, -42.49199772045097, -42.49201166163297, -42.49200848184044, -42.49202242300396, -42.49207228394569, -42.49193709763606, -42.4920830453188, -42.49194785902342, -42.49201289421391, -42.49201313176663, -42.49200701094294, -42.49200724849541, -42.49201910871561, -42.49200691727056, -42.49201322544652, -42.49200103399746, -42.49200910626771, -42.49201691982918, -42.49200322297123, -42.49201103658347, -42.49201328076373, -42.49201274521683, -42.49200739749257, -42.4920068619458, -42.49199739120597, -42.49202863526081, -42.49199150790675, -42.49202275201784, -42.49202919397137, -42.49199683211794, -42.49202331070896, 
  -42.49199094883816, -42.4920270618315, -42.49199896426992, -42.49202117856044, -42.49199308099882, -42.49183515116324, -42.49219088026829, -42.49182926804688, -42.49218499684246, -42.49212561194842, -42.49190041518427, -42.49211972860361, -42.4918945319869, -42.49188309348371, -42.49214293908248, -42.49187721020759, -42.49213705581643, -42.49200235954591, -42.49202366691612, -42.49199647633742, -42.49201778358242, -42.49200604275605, -42.49201998392954, -42.4920001594857, -42.49201410065771, -42.49208060624461, -42.4919454199388, -42.49207472297021, -42.49193953667103, -42.49201604830439, -42.4920038568573, -42.49201628585695, -42.49200409440993, -42.49200604584301, -42.49201385942943, -42.49200628339517, -42.49201409698243, -42.4920102203515, -42.4920096848046, -42.49201045790401, 
  -42.49200992235726, -42.49199433078045, -42.49202557486186, -42.49199456833148, -42.492025812416, -42.49202613356442, -42.49199377170043, -42.49202637111512}
 {-295.9217557312862, -295.9217585592794, -295.9217584362055, -295.9217530263832, -295.9217529033107, -295.9217585185869, -295.9217584768976, -295.9217529856916, -295.9217529440019, -295.9217586233151, -295.9217583721711, -295.9217530904181, -295.921752839277, -295.9217614275695, -295.9217555679323, -295.9217558946737, -295.9217500350371, -295.9217585194929, -295.9217584759917, -295.9217529865974, -295.9217529430962, -295.9217615923783, -295.9217554030599, -295.9217560594669, -295.9217498701803, -295.9217591224774, -295.9217578729946, -295.921753589582, -295.921752340099, -295.9217534361583, -295.9217635593377, -295.9217479032624, -295.9217580264426, -295.9217677035508, -295.921749293207, -295.9217621707758, -295.9217437601911, -295.921761634908, -295.9217553607171, -295.9217561020117, 
  -295.9217498278225, -295.9217072533481, -295.9218097430774, -295.9217017204544, -295.9218042101801, -295.9217642598887, -295.9217527355646, -295.9217587269885, -295.9217472026737, -295.9217644843508, -295.9217525110986, -295.9217589514551, -295.9217469782035, -295.9217307526939, -295.9217862445448, -295.9217252198005, -295.9217807116472, -295.9217558136677, -295.9217557719782, -295.9217556905946, -295.921755648905, -295.9217559183957, -295.9217556672519, -295.9217557953213, -295.9217555441799, -295.9217587226504, -295.9217528630128, -295.9217585995766, -295.9217527399403, -295.9217558145736, -295.9217557710724, -295.9217556915005, -295.9217556479992, -295.9217588874513, -295.9217526981483, -295.9217587643777, -295.9217525750756, -295.9217564175586, -295.9217551680749, 
  -295.9217562944846, -295.9217550450025, -295.9217507312388, -295.9217608544186, -295.9217506081656, -295.9217607313454, -295.9217649986896, -295.9217465882297, -295.9217648756208, -295.9217464651522, -295.9217589299868, -295.9217526557998, -295.9217588069166, -295.9217525327236, -295.9217045484294, -295.9218070381575, -295.9217044253567, -295.9218069150838, -295.9217615549666, -295.921750030648, -295.9217614318944, -295.921749907574, -295.9217617794321, -295.9217498061788, -295.9217616563575, -295.9217496831071, -295.9217280477753, -295.9217835396248, -295.9217279247029, -295.9217834165509, -295.9217558777031, -295.9217556265605, -295.9217558360136, -295.921755584871, -295.9217586819581, -295.9217528223212, -295.9217586402686, -295.9217527806317, -295.9217557738816, -295.9217557303804, 
  -295.9217557321922, -295.9217556886909, -295.9217588467599, -295.9217526574558, -295.9217588050689, -295.9217526157678, -295.9217563768663, -295.9217551273832, -295.9217563351766}
 {-318.7213684760334, -318.7213693563865, -318.7213697067913, -318.7213672452774, -318.7213675956841, -318.7213695465417, -318.7213695166359, -318.7213674354335, -318.7213674055276, -318.7213692765734, -318.7213697866043, -318.7213671654654, -318.721367675496, -318.7213688992621, -318.7213701639252, -318.7213667881537, -318.7213680528171, -318.7213695696093, -318.7213694935682, -318.7213674585012, -318.72136738246, -318.7213708304585, -318.7213682327303, -318.7213687193497, -318.7213661216227, -318.7213714922854, -318.7213675709068, -318.7213693811772, -318.7213654597985, -318.721370709763, -318.7213683534235, -318.7213685986548, -318.7213662423154, -318.7213760197971, -318.7213630438064, -318.7213739088091, -318.7213609325781, -318.7213746979291, -318.7213643652996, -318.7213725868189, 
  -318.7213622541933, -318.7213575836713, -318.7213814800775, -318.7213554725639, -318.7213793689685, -318.7213748705724, -318.7213641925815, -318.7213727594568, -318.7213620814808, -318.7213725795667, -318.7213664836292, -318.7213704684584, -318.7213643725211, -318.7213807895168, -318.7213582736171, -318.7213786784087, -318.7213561625088, -318.7213683157836, -318.7213682858778, -318.7213686661894, -318.7213686362835, -318.7213680458155, -318.7213685558461, -318.7213683962211, -318.721368906252, -318.7213676685038, -318.7213689331672, -318.7213680189097, -318.7213692835729, -318.7213683388513, -318.7213682628101, -318.721368689257, -318.7213686132158, -318.7213695997001, -318.7213670019724, -318.7213699501058, -318.7213673523782, -318.7213702615273, -318.7213663401486, -318.721370611933, 
  -318.7213666905545, -318.7213694790049, -318.7213671226655, -318.7213698294106, -318.7213674730712, -318.721374789088, -318.7213618129993, -318.7213751395159, -318.721362163383, -318.7213734671681, -318.7213631345443, -318.7213738175776, -318.7213634849463, -318.7213563529133, -318.7213802493193, -318.7213567033196, -318.7213805997245, -318.7213736398128, -318.721362961825, -318.7213739902142, -318.721363312235, -318.7213713488087, -318.721365252871, -318.7213716992142, -318.721365603277, -318.7213795587586, -318.721357042859, -318.7213799091645, -318.7213573932647, -318.7213682359711, -318.7213687460018, -318.7213682060652, -318.721368716096, -318.7213678586596, -318.7213691233228, -318.7213678287537, -318.721369093417, -318.7213685290069, -318.7213684529657, -318.721368499101, 
  -318.7213684230599, -318.7213697898557, -318.721367192128, -318.7213697599498, -318.7213671622223, -318.7213704516829, -318.7213665303043, -318.7213704217771}
 {-375.6448504700085, -375.6448573332123, -375.6448575465116, -375.6448433935484, -375.6448436068551, -375.6448574683197, -375.6448574114033, -375.6448435286596, -375.6448434717429, -375.6448572317035, -375.6448576480234, -375.6448432920426, -375.6448437083638, -375.6448634592921, -375.6448514204782, -375.6448495196302, -375.6448374808195, -375.6448574850344, -375.6448573946885, -375.6448435453741, -375.6448434550282, -375.6448622927794, -375.6448525870063, -375.6448483531022, -375.644838647363, -375.6448599959396, -375.6448548837989, -375.6448460562797, -375.6448409441381, -375.6448614182537, -375.6448534615021, -375.644847478593, -375.6448395218423, -375.6448852904632, -375.6448295928201, -375.6448713512062, -375.6448156527567, -375.6448628050848, -375.6448520750316, -375.6448488654202, 
  -375.6448381353757, -375.6448213926465, -375.6448934889407, -375.6448074529921, -375.6448795492743, -375.644873531521, -375.6448413481299, -375.6448595918262, -375.6448274085042, -375.6448713567131, -375.6448435229812, -375.6448574170509, -375.644829583323, -375.6448772508789, -375.6448376288803, -375.6448633112208, -375.6448236892179, -375.644850391816, -375.6448503348993, -375.6448506051188, -375.6448505482022, -375.6448501552009, -375.6448505715185, -375.6448503685009, -375.6448507848243, -375.6448563827875, -375.644844343975, -375.6448565960904, -375.6448445572781, -375.6448504085306, -375.6448503181846, -375.6448506218335, -375.6448505314876, -375.6448552162682, -375.64484551051, -375.644855429569, -375.6448457238148, -375.6448529194365, -375.6448478072943, -375.6448531327384, 
  -375.6448480205982, -375.6448543417497, -375.6448463849985, -375.6448545550525, -375.6448465983015, -375.6448782141472, -375.6448225161285, -375.6448784274776, -375.6448227294039, -375.6448557285735, -375.6448449985353, -375.644855941887, -375.6448452118276, -375.6448143161445, -375.644886412435, -375.6448145294497, -375.6448866257357, -375.644866455002, -375.6448342716412, -375.6448666683007, -375.6448344849484, -375.6448642802099, -375.6448364464768, -375.6448644935096, -375.644836659783, -375.6448701743756, -375.6448305523759, -375.6448703876797, -375.6448307656777, -375.6448502903086, -375.6448507066291, -375.644850233392, -375.6448506497126, -375.6448565178967, -375.6448444790844, -375.6448564609801, -375.6448444221677, -375.6448505436399, -375.6448504532939, -375.6448504867232, 
  -375.6448503963772, -375.6448553513776, -375.6448456456189, -375.6448552944584, -375.6448455887049, -375.6448530545452, -375.644847942404, -375.6448529976286}
 {-368.579328283537, -368.5793314947627, -368.5793313305858, -368.5793252364947, -368.5793250723169, -368.5793314798957, -368.5793313454528, -368.5793252216278, -368.5793250871838, -368.5793315029692, -368.57933132238, -368.5793252447006, -368.5793250641117, -368.5793352341072, -368.5793275912471, -368.5793289758388, -368.5793213329787, -368.5793314168655, -368.5793314084832, -368.579325158597, -368.5793251502147, -368.5793313674256, -368.5793314579227, -368.5793251091575, -368.5793251996542, -368.5793313762623, -368.579331449086, -368.5793251179939, -368.5793251908176, -368.5793313925752, -368.5793314327731, -368.5793251343063, -368.5793251745052, -368.5793201147314, -368.5793427117321, -368.5793138562406, -368.5793364536861, -368.5793330659572, -368.5793297595214, -368.5793268076937, 
  -368.5793235012479, -368.5793313263312, -368.5793314990174, -368.5793250680622, -368.5793252407495, -368.5793485333998, -368.5793142918575, -368.5793422751201, -368.5793080336005, -368.5793493797033, -368.579313445539, -368.5793431214349, -368.5793071872707, -368.579331426924, -368.5793313984246, -368.5793251686556, -368.5793251401562, -368.5793284328477, -368.5793282984041, -368.5793282686701, -368.5793281342266, -368.5793284559209, -368.5793282753316, -368.5793282917432, -368.5793281111542, -368.5793321870588, -368.5793245441987, -368.5793320228812, -368.5793243800212, -368.579328369817, -368.5793283614348, -368.5793282056395, -368.5793281972573, -368.5793283203773, -368.5793284108743, -368.5793281561998, -368.5793282466968, -368.579328329214, -368.5793284020376, -368.5793281650366, 
  -368.5793282378602, -368.5793283455267, -368.579328385725, -368.5793281813492, -368.5793282215475, -368.5793170675664, -368.5793396648005, -368.5793169033999, -368.5793395006119, -368.5793300189156, -368.5793267124661, -368.5793298547295, -368.5793265482972, -368.5793282792825, -368.5793284519694, -368.5793281151051, -368.5793282877917, -368.579345486345, -368.5793112448157, -368.5793453221692, -368.5793110806364, -368.5793463326551, -368.5793103984905, -368.5793461684772, -368.5793102343133, -368.5793283798756, -368.5793283513762, -368.5793282156981, -368.5793281871987, -368.5793284410537, -368.5793282604647, -368.5793283066103, -368.5793281260212, -368.5793321721918, -368.5793245293317, -368.5793320377484, -368.5793243948882, -368.5793283549501, -368.5793283465678, -368.5793282205065, 
  -368.5793282121243, -368.5793283055106, -368.5793283960071, -368.5793281710666, -368.579328261564, -368.5793283143469, -368.5793283871706, -368.5793281799035}
 {-4.919071637491605, -4.919070989296864, -4.919071055350582, -4.919072219630054, -4.919072285683555, -4.919071009761874, -4.919071034885569, -4.919072240095012, -4.919072265218595, -4.919066409905811, -4.919075634765587, -4.919067640268869, -4.919076865068691, -4.919067760748584, -4.919074283928282, -4.919068991074374, -4.919075514268656, -4.919070799222991, -4.919071245424499, -4.919072029555876, -4.91907247575778, -4.919071683394511, -4.919070361253317, -4.919072913724692, -4.919071591589299, -4.919071116558523, -4.91907092808894, -4.919072346891767, -4.919072158421859, -4.919071270304925, -4.919070774344993, -4.91907250063824, -4.919072004677841, -4.919069871429917, -4.919072173218948, -4.919071101770664, -4.919073403544365, -4.919080224857848, -4.919061819880497, -4.919081455203601, 
  -4.919063050200906, -4.919071225452527, -4.91907081919496, -4.919072455785813, -4.91907204952784, -4.91907102310445, -4.919071021542997, -4.919072253437497, -4.919072251876115, -4.919071435207787, -4.919070609505106, -4.919072665525833, -4.919071839853222, -4.91907102266561, -4.919071021981837, -4.91907225299868, -4.919072252314932, -4.919071591902982, -4.919071617026621, -4.919071657956591, -4.919071683080231, -4.919066992061061, -4.919076216892497, -4.919067058116307, -4.91907628294447, -4.919068342886261, -4.919074866072765, -4.919068408939385, -4.919074932126861, -4.919071381363976, -4.919071827565676, -4.919071447417581, -4.91907189361929, -4.91907226553421, -4.919070943395777, -4.919072331587682, -4.919071009449526, -4.919071698699678, -4.919071510229945, -4.9190717647533, 
  -4.919071576283542, -4.919071852446114, -4.919071356485965, -4.919071918499741, -4.919071422539558, -4.919070453574866, -4.91907275535616, -4.919070519628402, -4.919072821409842, -4.919080807004446, -4.91906240201606, -4.919080873059693, -4.919062468068031, -4.919071807593705, -4.919071401335945, -4.919071873647322, -4.919071467389545, -4.919071605245514, -4.919071603684094, -4.919071671299122, -4.919071669737706, -4.91907201734189, -4.919071191653165, -4.91907208339442, -4.919071257707853, -4.919071604806685, -4.919071604122925, -4.919071670860294, -4.919071670176534, -4.919067012526553, -4.919076237356974, -4.919067037650813, -4.919076262479992, -4.91906836335107, -4.919074886537925, -4.919068388474574, -4.919074911661699, -4.919071401828959, -4.91907184803066, -4.919071426952595, 
  -4.919071873154303, -4.919072285999029, -4.919070963860928, -4.919072311122861, -4.919070988984373, -4.919071719164648, -4.919071530694943, -4.919071744288328}
 {-338.1539133300737, -338.1539245519439, -338.1539244326497, -338.1539022275377, -338.1539021082502, -338.1539245226141, -338.1539244619781, -338.1539021982108, -338.1539021375757, -338.1539241911076, -338.1539247934882, -338.1539018667033, -338.1539024690868, -338.1539339045065, -338.1539150801357, -338.1539115801023, -338.1538927557342, -338.1539244575322, -338.1539245270601, -338.1539021331294, -338.1539022026574, -338.1539188339296, -338.1539301507096, -338.1538965095352, -338.1539078262982, -338.1539215222584, -338.1539274623584, -338.1538991978554, -338.1539051379557, -338.153923958526, -338.1539250261852, -338.1539016341234, -338.1539027017821, -338.1539130847453, -338.1539359042293, -338.1538907599818, -338.1539135801871, -338.1539092591574, -338.1539397259367, 
  -338.1538869347634, -338.153917401525, -338.1539096066812, -338.1539393823435, -338.153887282274, -338.1539170579451, -338.1539648198195, -338.1538841645539, -338.1539424954024, -338.1538618401652, -338.1539569984108, -338.1538919861074, -338.1539346740069, -338.1538696617057, -338.1539359807388, -338.1539130066658, -338.1539136563352, -338.1538906822636, -338.1539134200376, -338.1539133594019, -338.1539133007466, -338.1539132401111, -338.153913088532, -338.1539136909112, -338.1539129692382, -338.1539135716231, -338.15392280193, -338.1539039775594, -338.1539226826381, -338.1539038582697, -338.1539133549558, -338.1539134244837, -338.1539132356649, -338.1539133051929, -338.153907731358, -338.1539190481282, -338.1539076120661, -338.1539189288387, -338.1539104196816, -338.1539163597822, 
  -338.1539103003912, -338.1539162404911, -338.1539128559496, -338.1539139236087, -338.1539127366589, -338.1539138043179, -338.1539019820311, -338.1539248017904, -338.153901862655, -338.153924682585, -338.153898156588, -338.1539286233532, -338.1538980372919, -338.1539285040676, -338.1538985041036, -338.1539282797684, -338.1538983848109, -338.1539281604795, -338.1539537172359, -338.1538730619845, -338.1539535979452, -338.1538729426937, -338.153945895835, -338.1538808835301, -338.1539457765416, -338.1538807642421, -338.1539248781619, -338.1539019040897, -338.1539247588711, -338.153901784799, -338.1539130592023, -338.1539136615844, -338.1539129985667, -338.1539136009488, -338.1539227726013, -338.1539039482317, -338.1539227119656, -338.1539038875962, -338.1539133256275, -338.1539133951556, 
  -338.153913264992, -338.15391333452, -338.1539077020309, -338.1539190187989, -338.153907641392, -338.1539189581668, -338.1539103903537, -338.1539163304539, -338.153910329718}
 {-456.1511923340946, -456.1511965900567, -456.1511946461357, -456.1511900221003, -456.1511880781691, -456.1511956618071, -456.1511955743843, -456.1511890938457, -456.1511890064227, -456.1511975242215, -456.1511937119749, -456.1511909562535, -456.1511871440199, -456.1511992390145, -456.1511919972191, -456.1511926710535, -456.151185429257, -456.1511955786592, -456.1511956575323, -456.1511890106976, -456.1511890895708, -456.1511903953585, -456.1512008409187, -456.1511838273999, -456.1511942729545, -456.1511971912428, -456.1511940449707, -456.1511906232811, -456.1511874770096, -456.1512010034429, -456.1511902328081, -456.1511944354812, -456.1511836648468, -456.1511784448124, -456.1512127943415, -456.151171876378, -456.1512062268529, -456.151200944258, -456.1511902922725, -456.1511943763078, 
  -456.1511837242998, -456.1511560381829, -456.1512352009426, -456.1511494702161, -456.1512286329865, -456.1512132829955, -456.151177953168, -456.1512067149275, -456.1511713853129, -456.1512198883177, -456.1511713478002, -456.151213320357, -456.1511647798379, -456.1511572517092, -456.1512339886461, -456.1511506837481, -456.1512274206842, -456.1511933497696, -456.1511932623468, -456.1511914058435, -456.1511913184207, -456.1511952121817, -456.15119139994, -456.1511932682539, -456.1511894560153, -456.1511969269789, -456.1511896851798, -456.1511949830496, -456.1511877412569, -456.1511932666217, -456.1511933454948, -456.1511913226956, -456.1511914015687, -456.1511880833235, -456.1511985288792, -456.1511861393956, -456.1511965849546, -456.1511948792053, -456.1511917329334, -456.151192935279, 
  -456.1511897890073, -456.1511986914054, -456.1511879207708, -456.1511967474792, -456.1511859768446, -456.1511761325265, -456.1512104825526, -456.1511741886245, -456.1512085386022, -456.1511986322351, -456.1511879802206, -456.1511966882912, -456.1511860363122, -456.1511537261424, -456.1512328889083, -456.151151782217, -456.1512309449812, -456.1512109708938, -456.1511756411949, -456.1512090269897, -456.1511736972465, -456.1512175762816, -456.1511690357615, -456.1512156323536, -456.1511670918371, -456.1511549396716, -456.1512316766088, -456.1511529957461, -456.151229732682, -456.1511942839287, -456.1511904716886, -456.1511941965057, -456.1511903842657, -456.1511959987253, -456.1511887569291, -456.1511959113022, -456.1511886695063, -456.1511923383695, -456.1511924172426, -456.1511922509466, 
  -456.1511923298197, -456.1511871550717, -456.1511976006265, -456.1511870676462, -456.1511975132062, -456.1511939509534, -456.151190804681, -456.1511938635299}
 {-382.2093401952932, -382.2093429001835, -382.2093429017487, -382.2093374888551, -382.2093374904234, -382.2093428956157, -382.2093429063161, -382.2093374842888, -382.2093374949894, -382.2093428490048, -382.2093429529284, -382.2093374376775, -382.209337541602, -382.2093451504045, -382.2093406515457, -382.209339739077, -382.2093352402196, -382.2093428916188, -382.209342910313, -382.209337480292, -382.2093374989862, -382.209341780529, -382.2093440214308, -382.2093363692074, -382.2093386100987, -382.2093421722665, -382.2093436296745, -382.2093367609396, -382.2093382183476, -382.2093450449974, -382.2093407569533, -382.2093396336706, -382.2093353456263, -382.2093339427697, -382.2093518605746, -382.2093285312961, -382.2093464493945, -382.2093380306599, -382.2093477714235, -382.2093326193339, 
  -382.2093423600958, -382.2093281980285, -382.2093576048461, -382.2093227866996, -382.2093521935213, -382.2093484583343, -382.2093373435701, -382.2093430470014, -382.2093319322492, -382.209347677136, -382.2093381247839, -382.2093422658081, -382.2093327134581, -382.2093548782819, -382.2093309235724, -382.2093494669544, -382.2093255122461, -382.2093401891598, -382.2093401998603, -382.2093401907265, -382.209340201427, -382.2093401425494, -382.2093402464721, -382.2093401441148, -382.2093402480402, -382.2093424439485, -382.20933794509, -382.2093424455149, -382.2093379466572, -382.2093401851629, -382.2093402038571, -382.2093401867297, -382.2093402054239, -382.2093390740757, -382.2093413149723, -382.2093390756425, -382.209341316539, -382.2093394658104, -382.2093409232187, -382.2093394673776, 
  -382.2093409247851, -382.2093423385415, -382.2093380504973, -382.2093423401083, -382.209338052064, -382.2093312362519, -382.2093491541806, -382.2093312377957, -382.2093491557703, -382.209335324206, -382.2093450649656, -382.2093353257697, -382.2093450665354, -382.2093254915719, -382.2093548983909, -382.2093254931379, -382.2093548999584, -382.2093457518757, -382.2093346371169, -382.2093457534417, -382.2093346386843, -382.2093449706801, -382.209335418328, -382.2093449722458, -382.2093354198959, -382.2093521718258, -382.2093282171166, -382.2093521733923, -382.2093282186836, -382.2093401379816, -382.2093402419056, -382.2093401486821, -382.2093402526062, -382.2093424393812, -382.2093379405231, -382.2093424500816, -382.2093379512236, -382.2093401805958, -382.2093401992901, -382.2093401912964, 
  -382.2093402099906, -382.2093390695092, -382.2093413104047, -382.2093390802087, -382.2093413211063, -382.2093394612436, -382.2093409186515, -382.209339471944}
 {-435.5582034334128, -435.5582098852547, -435.5582044858805, -435.55820238098, -435.5581969816025, -435.5582070860471, -435.5582072850752, -435.5581995817706, -435.5581997807992, -435.5582084154549, -435.558205955668, -435.5582009111727, -435.5581984513975, -435.5581376794758, -435.5582766920288, -435.5581301751994, -435.5582691877528, -435.558207816206, -435.5582065549163, -435.5582003119297, -435.55819905064, -435.5582030071754, -435.5582113639593, -435.55819550292, -435.5582038596622, -435.5582516180094, -435.5581627536819, -435.5582441137337, -435.558155249405, -435.5582024714899, -435.5582118996721, -435.5581949672138, -435.5582043953957, -435.5582559191705, -435.5581584540685, -435.5582484154146, -435.5581509492718, -435.5581617586672, -435.5582526126905, -435.558154254388, 
  -435.558245108417, -435.5582788917689, -435.5581354812389, -435.5582713874973, -435.5581279769579, -435.5582197619912, -435.558194609122, -435.5582122576792, -435.5581871048815, -435.5581020501647, -435.5583123230863, -435.5580945458895, -435.5583048188088, -435.5581763486758, -435.5582380253085, -435.5581688443969, -435.558230521035, -435.5582060335927, -435.5582062326219, -435.5582006342177, -435.5582008332451, -435.5582073629984, -435.5582049032167, -435.558201963622, -435.5581995038413, -435.5581366270246, -435.5582756395723, -435.5581312276432, -435.558270240202, -435.558206763752, -435.5582055024625, -435.5582013643762, -435.5582001030866, -435.5582019547366, -435.5582103114904, -435.5581965553515, -435.5582049121238, -435.5582505655542, -435.5581617012294, -435.5582451661816, 
  -435.5581563018502, -435.5582014190363, -435.558210847218, -435.5581960196601, -435.5582054478424, -435.558254867076, -435.5581574012554, -435.5582494675018, -435.5581520020778, -435.5581607061955, -435.5582515602544, -435.5581553068523, -435.5582461608458, -435.5582778393184, -435.5581344287815, -435.5582724399404, -435.5581290294078, -435.5582187094875, -435.558193556718, -435.5582133101756, -435.5581881572782, -435.5581009977117, -435.5583112706317, -435.5580955983354, -435.5583058712562, -435.5581752962213, -435.5582369728554, -435.5581698968443, -435.5582315734806, -435.5582045637895, -435.5582021040084, -435.5582047628179, -435.5582023030367, -435.5581338278133, -435.5582728403665, -435.5581340268417, -435.5582730393949, -435.5582039645435, -435.5582027032538, -435.5582041635718, 
  -435.5582029022822, -435.558199155524, -435.5582075122857, -435.5581993545512, -435.5582077113153, -435.5582477663476, -435.5581589020188, -435.5582479653752}
 {-840.809872788958, -840.809844448301, -840.809840679037, -840.809904898871, -840.809901129594, -840.809842721986, -840.809842405354, -840.80990317255, -840.809902855916, -840.809848112867, -840.809837014501, -840.809908563383, -840.809897465111, -840.809843314135, -840.809841813227, -840.809903764705, -840.809902263783, -840.80984251548, -840.809842611859, -840.809902966043, -840.809903062422, -840.809866516943, -840.809818611236, -840.809926967302, -840.809879062003, -840.809839003814, -840.809846123553, -840.809899454381, -840.809906574112, -840.809846154989, -840.809838972384, -840.809906605551, -840.809899422948, -840.809735050761, -840.809950077818, -840.809795499679, -840.810010530026, -840.809860293749, -840.80982483378, -840.809920744318, -840.809885284338, -840.809876376622, 
  -840.80980875243, -840.809936827141, -840.809869203036, -840.80979582396, -840.809889304297, -840.809856273697, -840.809949755686, -840.809848008215, -840.80983711917, -840.809908458793, -840.809897569718, -840.809862610092, -840.809822517273, -840.809923060678, -840.809882967813, -840.80987483191, -840.809874515276, -840.809871062639, -840.809870746005, -840.809880222766, -840.809869124449, -840.809876453497, -840.809865355176, -840.809875424066, -840.809873923143, -840.809871654787, -840.80987015388, -840.809874625404, -840.809874721783, -840.809870856133, -840.809870952512, -840.809898626764, -840.809850721263, -840.809894857494, -840.80984695199, -840.809871113741, -840.809878233473, -840.809867344467, -840.809874464205, -840.809878264912, -840.809871082307, -840.809874495641, 
  -840.809867313036, -840.809767159843, -840.809982188583, -840.80976339061, -840.809978419274, -840.809892403709, -840.809856943668, -840.809888634372, -840.809853174463, -840.809908486525, -840.809840862374, -840.809904717251, -840.809837093105, -840.80982793345, -840.809921414653, -840.80982416422, -840.809917645342, -840.809880118145, -840.809869229087, -840.809876348877, -840.809865459814, -840.809894720025, -840.809854627186, -840.809890950757, -840.809850857912, -840.809878496449, -840.809867398129, -840.809878179815, -840.809867081496, -840.809873697744, -840.809872196829, -840.80987338111, -840.809871880195, -840.809872899085, -840.809872995464, -840.809872582452, -840.809872678831, -840.809896900444, -840.809848994946, -840.809896583815, -840.809848678308, -840.809869387422, 
  -840.809876507155, -840.809869070787}
 {-162.2369187439016, -162.236914322597, -162.2369148520649, -162.2369226357676, -162.2369231652412, -162.2369146865493, -162.2369144881125, -162.236922999724, -162.2369228012847, -162.2369150534636, -162.2369141212058, -162.236923366634, -162.2369224343822, -162.2369173056061, -162.2369118690679, -162.2369256187783, -162.2369201822426, -162.2369145764281, -162.2369145982337, -162.2369228896015, -162.2369229114071, -162.2369386021146, -162.2368905726921, -162.2369469152214, -162.2368988859321, -162.2369170884101, -162.2369120862422, -162.236925401586, -162.2369203994132, -162.2369091005414, -162.2369200741263, -162.2369174137138, -162.2369283873008, -162.2369479514104, -162.2368812240975, -162.2369562652657, -162.2368895365891, -162.236914211187, -162.2369149635733, -162.2369225243463, 
  -162.2369232767608, -162.2368640707266, -162.2369651048002, -162.2368723839084, -162.2369734179652, -162.2369139247036, -162.2369152500429, -162.2369222377158, -162.2369235633775, -162.2369205583624, -162.2369086162652, -162.2369288715365, -162.2369169294379, -162.2368838182324, -162.2369453583268, -162.2368921314125, -162.2369536714936, -162.2369185783852, -162.2369183799472, -162.236919107856, -162.2369189094179, -162.2369189452973, -162.2369180130426, -162.2369194747683, -162.2369185425132, -162.2369211974404, -162.2369157609042, -162.236921726912, -162.2369162903742, -162.2369184682634, -162.236918490069, -162.2369189977342, -162.2369190195398, -162.2369424939191, -162.2368944645582, -162.2369430233849, -162.2368949940339, -162.2369209802482, -162.2369159780748, -162.2369215097158, 
  -162.2369165075487, -162.2369129923763, -162.2369239659621, -162.2369135218469, -162.236924495433, -162.236951843577, -162.2368851156015, -162.236952373067, -162.2368856450531, -162.2369181030062, -162.2369188554247, -162.236918632495, -162.2369193848774, -162.2368679625652, -162.2369689966322, -162.2368684920378, -162.2369695261011, -162.236917816462, -162.2369191419551, -162.2369183459253, -162.2369196714333, -162.2369244501986, -162.2369125080997, -162.2369249796683, -162.2369130375714, -162.2368877100695, -162.2369492501604, -162.2368882395433, -162.236949779628, -162.2369193092518, -162.2369183769969, -162.2369191108137, -162.2369181785588, -162.2369215613952, -162.2369161248583, -162.2369213629571, -162.2369159264202, -162.2369188322178, -162.2369188540234, -162.2369186337797, 
  -162.2369186555853, -162.2369428578707, -162.2368948285154, -162.2369426594333, -162.2368946300766, -162.2369213442009, -162.2369163420309, -162.236921145763}
 {-620.988277835825, -620.9882778924882, -620.9882778448749, -620.9882778267753, -620.9882777791622, -620.9882778699798, -620.9882778673833, -620.9882778042671, -620.9882778016705, -620.9882780571932, -620.9882776801725, -620.988277991478, -620.988277614462, -620.9882802580499, -620.9882754793321, -620.9882801923366, -620.9882754136197, -620.9882778935245, -620.9882778438386, -620.9882778278118, -620.9882777781258, -620.9882784118132, -620.9882773255964, -620.9882783460936, -620.9882772598905, -620.9882790135818, -620.9882767237872, -620.9882789478691, -620.9882766580745, -620.9882796845014, -620.988276052879, -620.9882796187886, -620.9882759871663, -620.9882778686815, -620.9882778686815, -620.9882778029688, -620.9882778029688, -620.9882713671495, -620.9882843703637, -620.9882713014364, 
  -620.9882843046509, -620.9882973073176, -620.9882584309874, -620.9882972416045, -620.9882583652749, -620.9882778990128, -620.9882778383504, -620.9882778332995, -620.9882777726382, -620.9882825845209, -620.9882731528303, -620.9882825188084, -620.9882730871173, -620.9882869822023, -620.9882687552144, -620.9882869164902, -620.988268689501, -620.9882778609299, -620.9882778583333, -620.9882778133167, -620.9882778107201, -620.9882780481427, -620.9882776711231, -620.9882780005283, -620.988277623511, -620.9882802489998, -620.988275470282, -620.9882802013863, -620.9882754226693, -620.9882778844745, -620.9882778347886, -620.9882778368613, -620.9882777871754, -620.9882784027612, -620.9882773165485, -620.9882783551452, -620.9882772689381, -620.9882790045319, -620.9882767147372, -620.9882789569186, 
  -620.9882766671241, -620.9882796754514, -620.988276043829, -620.9882796278382, -620.9882759962158, -620.9882778596316, -620.9882778596316, -620.9882778120184, -620.9882778120184, -620.9882713580995, -620.9882843613136, -620.9882713104861, -620.9882843137007, -620.9882972982676, -620.9882584219374, -620.9882972506541, -620.9882583743246, -620.9882778899627, -620.9882778293007, -620.9882778423495, -620.9882777816875, -620.9882825754711, -620.98827314378, -620.9882825278578, -620.9882730961671, -620.9882869731525, -620.9882687461644, -620.9882869255397, -620.9882686985507, -620.9882780256338, -620.9882776486154, -620.9882780230371, -620.9882776460188, -620.9882802264914, -620.9882754477739, -620.9882802238948, -620.9882754451774, -620.9882778619662, -620.9882778122803, -620.9882778593697, 
  -620.9882778096837, -620.9882783802517, -620.9882772940413, -620.9882783776548, -620.9882772914453, -620.9882789820235, -620.9882766922289, -620.9882789794269}
 {-9.09092458567387, -9.09092542486687, -9.09092537871615, -9.09092379263472, -9.09092374648421, -9.0909254052016, -9.09092539838141, -9.09092377296954, -9.09092376614938, -9.09093410686045, -9.09091669675531, -9.09093247459127, -9.0909150645604, -9.09093007836287, -9.09092072522916, -9.09092844613089, -9.09091909299705, -9.0909254759641, -9.09092532761892, -9.09092384373203, -9.0909236953869, -9.09093647213689, -9.09091433266762, -9.0909348397594, -9.090912700581, -9.09092436457416, -9.09092643901765, -9.09092273234217, -9.09092480678556, -9.09092876863523, -9.09092203496573, -9.09092713640244, -9.09092040273443, -9.09092799416145, -9.09092280942503, -9.09092636191516, -9.09092117720724, -9.09091416563001, -9.0909366380329, -9.09091253340481, -9.09093500579402, -9.09090930376775, 
  -9.09094150075803, -9.09090767155854, -9.09093986850315, -9.09092539582187, -9.09092540776111, -9.09092376358992, -9.09092377552897, -9.09092368727711, -9.09092711648363, -9.09092205505834, -9.09092548423832, -9.09094727915592, -9.09090352436878, -9.09094564693997, -9.09090189212064, -9.09092461215926, -9.09092460533909, -9.09092456600865, -9.09092455918847, -9.09093331380019, -9.09091590373091, -9.0909332676483, -9.09091585758157, -9.09092928532059, -9.09091993218678, -9.09092923916994, -9.0909198860362, -9.09092468292176, -9.0909245345766, -9.09092463677114, -9.09092448842598, -9.09093567902296, -9.09091353969688, -9.09093563287009, -9.09091349354851, -9.09092357153187, -9.09092564597528, -9.09092352538123, -9.09092559982469, -9.09092797559255, -9.09092124192376, -9.0909279294419, 
  -9.09092119577317, -9.09092720111202, -9.0909220163898, -9.09092715496136, -9.09092197023924, -9.09091337259152, -9.09093584498673, -9.09091332644007, -9.09093579883696, -9.0909085107366, -9.09094070770451, -9.09090846458645, -9.09094066155343, -9.09092460277958, -9.09092461471873, -9.09092455662897, -9.09092456856812, -9.09092289424124, -9.09092632343484, -9.09092284809097, -9.09092627728388, -9.09094648612152, -9.09090273131852, -9.09094643997113, -9.09090268516767, -9.0909332941344, -9.09091588406626, -9.09093328731409, -9.09091587724622, -9.09092926565535, -9.09091991252157, -9.09092925883518, -9.0909199057014, -9.09092466325653, -9.09092451491138, -9.09092465643636, -9.0909245080912, -9.09093565935703, -9.09091352003236, -9.09093565253602, -9.09091351321303, -9.09092355186664, 
  -9.09092562631007, -9.09092354504646}
 {-637.2959886252282, -637.2959792614212, -637.2959802755551, -637.2959969749299, -637.2959979890741, -637.2959798752176, -637.2959796617586, -637.2959975887333, -637.2959973752709, -637.2959789450652, -637.2959805919221, -637.2959966585798, -637.2959983054354, -637.2959818709595, -637.2959776660307, -637.2959995844712, -637.295995379547, -637.2959797985892, -637.2959797383872, -637.2959975121031, -637.295997451901, -637.2960106000461, -637.2959489371315, -637.2960283134455, -637.2959666507601, -637.2959837952266, -637.2959757417372, -637.2960015087433, -637.2959934552485, -637.2959744422731, -637.2959850947203, -637.2959921557852, -637.2960028082362, -637.2959304169465, -637.2960291210282, -637.2959481295124, -637.2960468354902, -637.2959763783651, -637.2959831587256, -637.2959940918933, 
  -637.2960008722254, -637.2960350359426, -637.2959245019435, -637.2960527494451, -637.2959422154689, -637.29597220708, -637.2959873301052, -637.2959899203128, -637.2960050439003, -637.2959853751494, -637.2959741617997, -637.2960030886619, -637.2959918753152, -637.295942083214, -637.2960174559764, -637.29595979674, -637.2960351694784, -637.2959882248891, -637.2959880114283, -637.295989239028, -637.2959890255673, -637.2959872947355, -637.2959889415929, -637.2959883088757, -637.2959899557307, -637.2959902206279, -637.2959860157034, -637.2959912347689, -637.2959870298405, -637.2959881482596, -637.2959880880577, -637.2959891623988, -637.2959891021965, -637.2960189496618, -637.2959572868568, -637.2960199637959, -637.2959583010008, -637.2959921449015, -637.2959840914035, -637.2959931590344, 
  -637.2959851055485, -637.2959827919429, -637.2959934443917, -637.2959838060815, -637.295994458531, -637.2959387661571, -637.2960374711588, -637.2959397802681, -637.2960384853258, -637.2959847280558, -637.2959915083759, -637.2959857421686, -637.2959925225411, -637.2960433856089, -637.2959328516183, -637.2960443997449, -637.2959338657601, -637.2959805566173, -637.2959956799091, -637.2959815707416, -637.2959966940625, -637.2959937248197, -637.2959825114704, -637.2959947389576, -637.2959835256105, -637.295950432888, -637.2960258056436, -637.2959514470322, -637.2960268197774, -637.2959879085361, -637.2959895553922, -637.2959876950754, -637.2959893419314, -637.2959908344288, -637.2959866295024, -637.2959906209681, -637.2959864160416, -637.2959887620597, -637.2959887018575, -637.2959885485988, 
  -637.2959884883968, -637.2960195634586, -637.2959579006599, -637.2960193499991, -637.2959576871979, -637.2959927586983, -637.2959847052065, -637.2959925452379}
 {-25.56606239963414, -25.5660572820015, -25.56605866853566, -25.56606613074627, -25.56606751729052, -25.56605800412421, -25.56605794641285, -25.56606685287438, -25.56606679516231, -25.56605312990504, -25.56606282067491, -25.56606197872285, -25.56607166935672, -25.56605629345785, -25.56605965716153, -25.56606514219395, -25.56606850592505, -25.56605790138629, -25.5660580491508, -25.56606675013602, -25.56606689790069, -25.56604828623298, -25.56606766586946, -25.56605713493545, -25.56607651466659, -25.56606051724494, -25.56605543339572, -25.5660693659823, -25.56606428215799, -25.56606813220017, -25.56604781841053, -25.56607698094401, -25.56605666716631, -25.56611174989613, -25.56600420227188, -25.56612059943128, -25.56601305023638, -25.56608133069291, -25.56603462024831, -25.56609017945741, 
  -25.56604346898344, -25.56605426865447, -25.56606168559444, -25.56606311748225, -25.56607053426629, -25.56605857855847, -25.56605737211262, -25.56606742714548, -25.56606622102524, -25.56607482821045, -25.56604112246093, -25.56608367692655, -25.56604997124446, -25.56611680328279, -25.56599914739334, -25.5661256520327, -25.56600799614306, -25.56606173522042, -25.56606167750874, -25.56606312175966, -25.5660630640479, -25.56605686103296, -25.56606655173908, -25.56605824757642, -25.56606793827403, -25.56606002454614, -25.56606338826533, -25.56606141108715, -25.56606477480273, -25.56606163248229, -25.5660617802469, -25.56606301902151, -25.56606316678608, -25.56605201731238, -25.56607139698215, -25.56605340383754, -25.56607278353539, -25.56606424833664, -25.56605916449612, -25.56606563487208, 
  -25.56606055103908, -25.56607186329354, -25.56605154950926, -25.56607324983213, -25.56605293604906, -25.56611548136197, -25.56600793299815, -25.56611686794692, -25.5660093194916, -25.56608506178395, -25.56603835134936, -25.56608644834785, -25.56603973786386, -25.56605799978476, -25.56606541665624, -25.56605938633344, -25.56606680318597, -25.56606230958191, -25.56606110328128, -25.56606369610352, -25.56606248983806, -25.56607855929109, -25.56604485357237, -25.56607994582738, -25.56604624011449, -25.56612053437731, -25.56600287849093, -25.56612192091967, -25.56600426502696, -25.56605758316025, -25.56606727386262, -25.56605752544903, -25.5660672161504, -25.56606074667246, -25.56606411038984, -25.56606068896073, -25.56606405267812, -25.5660623546077, -25.56606250237231, -25.566062296896, 
  -25.56606244466058, -25.56605273943151, -25.56607211911385, -25.56605268171832, -25.56607206140359, -25.5660649704601, -25.56605988662347, -25.56606491274851}
 {-434.8237092471764, -434.8237115829002, -434.823711912289, -434.8237065820785, -434.8237069114763, -434.8237117367287, -434.8237117584587, -434.8237067359114, -434.8237067576417, -434.8237105610612, -434.8237129341244, -434.82370556025, -434.8237079333012, -434.823703899182, -434.8237195960094, -434.8236988983624, -434.8237145951947, -434.8237116456223, -434.8237118495648, -434.8237066448053, -434.8237068487477, -434.8237106922744, -434.8237128029514, -434.823705691462, -434.8237078021296, -434.8237098281138, -434.8237136671266, -434.8237048272965, -434.8237086663095, -434.823714062019, -434.823709433188, -434.823709061202, -434.8237044323708, -434.8237098967539, -434.8237135996706, -434.8237048957419, -434.8237085990485, -434.823693644493, -434.8237298508318, -434.8236886436786, 
  -434.8237248500119, -434.8237010273176, -434.823722468809, -434.8236960264977, -434.8237174679948, -434.8237175841992, -434.8237059109549, -434.8237125833758, -434.8237009101441, -434.8237019998654, -434.8237214955732, -434.8236969990451, -434.8237164947595, -434.8237254830459, -434.8236980119819, -434.8237204822282, -434.8236930111655, -434.8237090716156, -434.8237090933456, -434.8237094010087, -434.823709422739, -434.8237078959505, -434.8237102690088, -434.823708225345, -434.823710598401, -434.8237012340678, -434.8237169308974, -434.8237015634608, -434.8237172602909, -434.8237089805094, -434.8237091844518, -434.8237093099026, -434.823709513845, -434.8237080271632, -434.8237101378364, -434.8237083565574, -434.8237104672288, -434.8237071630005, -434.8237110020136, -434.823707492394, 
  -434.8237113314068, -434.8237113969059, -434.823706768075, -434.8237117262993, -434.8237070974681, -434.8237072315864, -434.8237109346121, -434.8237075608937, -434.8237112640914, -434.8236909793814, -434.8237271857171, -434.8236913087744, -434.8237275151108, -434.8236983622039, -434.8237198036967, -434.8236986915957, -434.8237201330914, -434.8237149190846, -434.8237032458433, -434.8237152484744, -434.82370357524, -434.8236993347518, -434.8237188304608, -434.823699664143, -434.8237191598561, -434.8237228179327, -434.8236953468691, -434.8237231473258, -434.8236956762626, -434.8237080497817, -434.823710422839, -434.823708071512, -434.823710444569, -434.8237013878984, -434.8237170847282, -434.8237014096284, -434.8237171064584, -434.8237091343401, -434.8237093382825, -434.8237091560701, 
  -434.8237093600126, -434.8237081809947, -434.8237102916664, -434.8237082027241, -434.8237103133972, -434.8237073168313, -434.8237111558444, -434.8237073385615}
 {-22.15934004019205, -22.15935463803829, -22.15935520895497, -22.15932487154602, -22.15932544245931, -22.15935480285796, -22.15935504413568, -22.15932503636519, -22.15932527764052, -22.1593572664043, -22.15935258059655, -22.15932749989602, -22.15932281411691, -22.1593569053492, -22.15935294165412, -22.15932713885612, -22.15932317515928, -22.1593548704917, -22.15935497650196, -22.15932510399782, -22.1593252100079, -22.15935748293741, -22.15935236412925, -22.15932771643001, -22.15932259764872, -22.15935437804914, -22.15935546895093, -22.15932461155616, -22.15932570245598, -22.15935684484136, -22.15935300216651, -22.15932707834634, -22.1593232356736, -22.15930111919662, -22.15940872866214, -22.15927135248461, -22.15937896238623, -22.15935233769815, -22.15935750939619, -22.15932257118403, 
  -22.15932774292239, -22.15934023971099, -22.15936960815538, -22.15931047322823, -22.15933984165021, -22.15933908496747, -22.15937076238357, -22.15930931876801, -22.15934099559509, -22.15935853213602, -22.15935131486308, -22.15932876564666, -22.1593215483645, -22.15936707225415, -22.15934277465319, -22.15933730576258, -22.15931300815682, -22.1593396340961, -22.15933987537261, -22.15934020501107, -22.15934044628762, -22.15934209763842, -22.15933741183751, -22.15934266854593, -22.15933798275998, -22.15934173658655, -22.15933777289185, -22.15934230750279, -22.15933834380559, -22.15933970172923, -22.15933980773951, -22.15934027264433, -22.15934037865439, -22.1593423141679, -22.15933719537384, -22.15934288508355, -22.15933776628817, -22.15933920928649, -22.15934030018866, -22.15933978020284, 
  -22.15934087110228, -22.15934167607844, -22.15933783340451, -22.1593422469933, -22.15933840431963, -22.15928595033229, -22.15939356000155, -22.15928652123297, -22.15939413093085, -22.15933716894272, -22.15934234062672, -22.15933773982351, -22.1593429115759, -22.15932507095542, -22.15935443938604, -22.15932564186784, -22.15935501030359, -22.15932391635705, -22.15935559346907, -22.15932448726247, -22.15935616439361, -22.15934336337473, -22.15933614609944, -22.15934393429198, -22.15933671701217, -22.15935190349352, -22.15932760588889, -22.15935247440724, -22.15932817680514, -22.1593422624541, -22.15933757666068, -22.15934250373064, -22.15933781793719, -22.1593419014066, -22.15933793771065, -22.15934214268313, -22.15933817898716, -22.15933986654869, -22.15933997255888, -22.15934010782524, 
  -22.15934021383539, -22.15934247899199, -22.15933736018859, -22.15934272025985, -22.15933760147379, -22.15933937410665, -22.15934046500734, -22.15933961538306}
 {-186.0834635895346, -186.0834506197855, -186.0834475188714, -186.0834796602897, -186.0834765593506, -186.0834489190539, -186.0834492196026, -186.0834779595443, -186.0834782600957, -186.0834530918478, -186.0834450468264, -186.0834821323289, -186.0834740873288, -186.0834501761042, -186.0834479625779, -186.0834792165999, -186.0834770030655, -186.083449166301, -186.0834489723555, -186.0834782067926, -186.0834780128473, -186.0834289228351, -186.0834692163901, -186.0834579633668, -186.0834982568418, -186.0834532955349, -186.0834448431494, -186.0834823360253, -186.0834738836423, -186.0834528048607, -186.0834453338284, -186.0834818453531, -186.0834743743194, -186.0835310785836, -186.0833670617797, -186.0835601207809, -186.083396100566, -186.0834291932016, -186.0834689456557, -186.0834582336575, 
  -186.0834979861832, -186.0834881228403, -186.083410017751, -186.0835171633514, -186.0834390582233, -186.083443760796, -186.0834543781754, -186.0834728008153, -186.0834834191396, -186.083459166696, -186.0834389719955, -186.0834882071893, -186.0834680124857, -186.0834835656874, -186.0834145728036, -186.0835126061749, -186.0834436132995, -186.083464989723, -186.0834652902731, -186.0834618887965, -186.0834621893463, -186.0834691625117, -186.0834611175022, -186.0834660615863, -186.0834580165743, -186.0834662467784, -186.0834640332433, -186.083463145847, -186.0834609323214, -186.0834652369707, -186.0834650430254, -186.0834621360441, -186.0834619420987, -186.0834449935265, -186.0834852870383, -186.0834418925966, -186.0834821861149, -186.0834693662027, -186.0834609138212, -186.0834662652788, 
  -186.0834578128918, -186.0834688755309, -186.0834614044978, -186.0834657746041, -186.0834583035713, -186.083547150135, -186.083383131568, -186.0835440491508, -186.0833800306989, -186.0834452638254, -186.0834850163716, -186.0834421629551, -186.0834819153886, -186.083504193519, -186.0834260884119, -186.083501092594, -186.0834229874837, -186.0834598312119, -186.0834704490991, -186.0834567303206, -186.0834673481371, -186.0834752373658, -186.0834550426653, -186.0834721364407, -186.0834519417371, -186.083499636356, -186.0834306434745, -186.0834965354275, -186.0834275425497, -186.0834674617738, -186.083459416763, -186.0834677623238, -186.083459717313, -186.0834645460375, -186.0834623325071, -186.0834648465875, -186.0834626330572, -186.0834635362323, -186.0834633422868, -186.0834638367823, 
  -186.0834636428368, -186.083443292785, -186.0834835863029, -186.0834435933378, -186.08348388685, -186.083467665466, -186.0834592130809, -186.0834679660152}
 {-334.7488651581107, -334.7488676150465, -334.7488666701882, -334.7488636460442, -334.7488627011849, -334.7488671944491, -334.7488670907852, -334.7488632254465, -334.7488631217822, -334.7488671732402, -334.7488671119955, -334.7488632042372, -334.7488631429929, -334.7488704648533, -334.7488638203998, -334.7488664958509, -334.7488598513967, -334.7488671484724, -334.7488671367619, -334.7488631794697, -334.7488631677591, -334.7488703514964, -334.748863933781, -334.7488663824893, -334.7488599647825, -334.7488653824361, -334.7488689028133, -334.7488614134335, -334.7488649338103, -334.7488696474129, -334.7488646378448, -334.74886567841, -334.7488606688421, -334.748842342646, -334.7488919436672, -334.7488383732642, -334.7488879750434, -334.7488671660331, -334.7488671193285, -334.7488631970353, 
  -334.7488631503208, -334.7488888803918, -334.7488454061042, -334.7488849113863, -334.7488414371041, -334.7488759699924, -334.7488583152281, -334.7488720009597, -334.7488543462552, -334.7488792142963, -334.7488550708666, -334.7488752452935, -334.7488511018638, -334.7488920194183, -334.7488422656189, -334.748888050416, -334.7488382966156, -334.7488656823724, -334.7488655787082, -334.7488647375135, -334.7488646338494, -334.7488656611636, -334.7488655999184, -334.7488647163041, -334.7488646550601, -334.7488689527775, -334.7488623083218, -334.748868007917, -334.7488613634648, -334.7488656363955, -334.748865624685, -334.7488646915367, -334.7488646798261, -334.7488688394165, -334.7488624217071, -334.7488678945594, -334.7488614768467, -334.7488638703595, -334.748867390736, -334.7488629255003, 
  -334.7488664458777, -334.7488681353359, -334.748863125768, -334.7488671904772, -334.7488621809091, -334.7488408303613, -334.7488904317981, -334.7488398855389, -334.7488894869028, -334.7488656539674, -334.7488656072405, -334.7488647090912, -334.748864662399, -334.7488873683135, -334.7488438940287, -334.7488864234548, -334.7488429491698, -334.748874457895, -334.7488568031717, -334.7488735130472, -334.7488558583018, -334.7488777022197, -334.7488535587894, -334.7488767573603, -334.7488526139311, -334.7488905073415, -334.7488407535418, -334.748889562483, -334.7488398086828, -334.7488652405656, -334.7488651793211, -334.7488651369015, -334.748865075657, -334.748868532179, -334.7488618877251, -334.7488684285149, -334.748861784061, -334.7488652157979, -334.7488652040874, -334.7488651121338, 
  -334.7488651004233, -334.74886841882, -334.7488620011084, -334.7488683151554, -334.7488618974448, -334.7488634497619, -334.7488669701384, -334.7488633460974}
 {-222.586495309525, -222.5864950172028, -222.5864960276389, -222.5864945914225, -222.5864956018736, -222.586495524401, -222.5864955204395, -222.5864950986281, -222.5864950946667, -222.5864939720642, -222.5864970727789, -222.5864935462942, -222.5864966470033, -222.5864920739199, -222.5864989709485, -222.5864916481449, -222.5864985451778, -222.5864955281554, -222.5864955166851, -222.5864951023826, -222.5864950909123, -222.5864957063132, -222.5864953385273, -222.5864952805413, -222.5864949127536, -222.5864956602892, -222.5864953845514, -222.5864952345171, -222.5864949587778, -222.586495505101, -222.5864955397394, -222.586495079328, -222.5864951139666, -222.5865072568745, -222.5864837887195, -222.586506831465, -222.5864833625834, -222.5865039182568, -222.5864871266705, -222.5865034924747, 
  -222.5864867009068, -222.5864958520144, -222.5864951928262, -222.5864954262427, -222.5864947670522, -222.5865000165703, -222.5864910282618, -222.5864995907513, -222.5864906025351, -222.5864956215867, -222.5864954233256, -222.5864951958124, -222.5864949975543, -222.5864955210712, -222.5864955237693, -222.5864950952983, -222.5864950979966, -222.5864948062846, -222.5864948023231, -222.5864958167282, -222.5864958127667, -222.5864932539491, -222.5864963546612, -222.5864942643929, -222.5864973651046, -222.586491355802, -222.5864982528336, -222.5864923662464, -222.5864992632764, -222.586494810039, -222.5864947985687, -222.5864958204826, -222.5864958090123, -222.5864949881971, -222.5864946204106, -222.586495998641, -222.586495630854, -222.586494942173, -222.5864946664347, -222.5864959526168, 
  -222.586495676878, -222.5864947869845, -222.586494821623, -222.586495797428, -222.5864958320666, -222.5865065389109, -222.5864830704503, -222.5865075494122, -222.5864840808362, -222.5865032001326, -222.5864864085618, -222.5865042105824, -222.5864874189991, -222.5864951338984, -222.5864944747094, -222.5864961443423, -222.5864954851526, -222.5864992984369, -222.5864903101623, -222.5865003088682, -222.5864913206182, -222.5864949034698, -222.5864947052096, -222.5864959139128, -222.5864957156539, -222.5864948029547, -222.5864948056529, -222.5864958133983, -222.5864958160965, -222.5864937611512, -222.586496861863, -222.5864937571897, -222.5864968579016, -222.5864918630043, -222.5864987600351, -222.5864918590429, -222.5864987560736, -222.586495317241, -222.5864953057706, -222.5864953132795, 
  -222.5864953018091, -222.5864954953991, -222.5864951276125, -222.5864954914378, -222.5864951236509, -222.5864954493748, -222.5864951736368, -222.5864954454139}
 {-274.8476916144312, -274.8476974444874, -274.8476974898012, -274.8476857390932, -274.8476857844139, -274.8476974672724, -274.8476974670152, -274.8476857618816, -274.8476857616244, -274.8476969877799, -274.8476979465097, -274.8476852823912, -274.8476862411168, -274.8476998033474, -274.8476951309704, -274.8476880979554, -274.847683425581, -274.8476974766634, -274.8476974576242, -274.8476857712727, -274.8476857522333, -274.8476981559468, -274.8476967783886, -274.847686450554, -274.8476850729999, -274.8476979563085, -274.8476969780044, -274.8476862509178, -274.8476852726136, -274.8477014125895, -274.8476935217333, -274.8476897071986, -274.8476818163426, -274.8477053989283, -274.8476895380354, -274.8476936938156, -274.8476778323666, -274.8477149108809, -274.847680023702, -274.8477032054867, 
  -274.8476683183147, -274.8476946359531, -274.8477003002172, -274.847682930567, -274.8476885948217, -274.8477148349016, -274.8476800992907, -274.8477031295063, -274.8476683939046, -274.8477090453101, -274.8476858889902, -274.8476973399165, -274.8476741836023, -274.8477185108418, -274.8476764234245, -274.8477068054513, -274.8476647180336, -274.8476915919016, -274.8476915916444, -274.8476916372188, -274.8476916369618, -274.847691112411, -274.8476920711368, -274.8476911577264, -274.8476921164559, -274.8476939279763, -274.8476892556001, -274.847693973293, -274.8476893009179, -274.8476916012927, -274.8476915822534, -274.84769164661, -274.8476916275707, -274.8476922805748, -274.847690903019, -274.8476923258924, -274.847690948336, -274.8476920809377, -274.8476911026336, -274.8476921262551, 
  -274.8476911479508, -274.8476955372187, -274.8476876463625, -274.847695582536, -274.8476876916798, -274.8476995236616, -274.8476836625605, -274.8476995690488, -274.8476837078079, -274.8477090355072, -274.847674148334, -274.8477090808267, -274.8476741936491, -274.847688760584, -274.8476944248447, -274.8476888059027, -274.8476944701607, -274.8477089595293, -274.8476742239215, -274.8477090048451, -274.8476742692402, -274.8477031699392, -274.8476800136195, -274.8477032152538, -274.8476800589394, -274.8477126354711, -274.8476705480536, -274.8477126807884, -274.8476705933709, -274.8476911351968, -274.8476920939244, -274.8476911349397, -274.8476920936673, -274.8476939507627, -274.847689278387, -274.8476939505055, -274.8476892781299, -274.8476916240794, -274.8476916050401, -274.8476916238222, 
  -274.8476916047829, -274.8476923033626, -274.8476909258046, -274.8476923031035, -274.8476909255493, -274.8476921037245, -274.8476911254202, -274.8476921034674}
 {-34.469020240556, -34.46905281731827, -34.46905225620166, -34.46898822496101, -34.46898766384587, -34.4690525724718, -34.46905250104837, -34.46898798011504, -34.46898790869207, -34.46905279313798, -34.46905228039001, -34.46898820078114, -34.46898768803379, -34.46905417224285, -34.46905090127863, -34.46898957988631, -34.4689863089221, -34.4690525410106, -34.46905253250959, -34.46898794865406, -34.46898794015306, -34.46906717762892, -34.46903789616086, -34.46900258527298, -34.46897330380374, -34.46905252882772, -34.46905254469296, -34.46898793647136, -34.46898795233626, -34.46905567660439, -34.4690493969234, -34.46899108424787, -34.46898480456685, -34.46898286548422, -34.46912220849602, -34.46891827249445, -34.46905761677273, -34.4690569177064, -34.46904815587049, -34.46899232533714, 
  -34.46898356352669, -34.46904979188115, -34.46905528231974, -34.46898519952944, -34.46899068995838, -34.46893268940946, -34.46917238630354, -34.46886809774045, -34.46910779325949, -34.46906455922105, -34.46904051422584, -34.46899996686478, -34.46897592186905, -34.46905443109674, -34.46905064329357, -34.46898983874011, -34.46898605093716, -34.4690205568254, -34.4690204854022, -34.46901999570953, -34.46901992428633, -34.46902077749242, -34.46902026474302, -34.4690202163748, -34.4690197036289, -34.46902215659659, -34.46901888563234, -34.46902159548068, -34.4690183245165, -34.46902052536433, -34.46902051686329, -34.46901996424843, -34.46901995574746, -34.46903516198275, -34.46900588051447, -34.46903460086726, -34.46900531939824, -34.46902051318109, -34.46902052904702, -34.46901995206609, 
  -34.46901996793029, -34.4690236609581, -34.46901738127712, -34.46902309984225, -34.46901682016124, -34.46895084951957, -34.46909019316811, -34.4689502884072, -34.46908963204875, -34.46902490207934, -34.46901614020499, -34.46902434091232, -34.46901557914029, -34.46901777623742, -34.4690232666709, -34.46901721512128, -34.46902270555532, -34.46890067410423, -34.4691403703162, -34.46890011299378, -34.46913980919493, -34.46903254357425, -34.46900849858007, -34.46903198245968, -34.46900793746292, -34.46902241545076, -34.46901862764699, -34.46902185433419, -34.46901806653183, -34.46902053264532, -34.46902001989767, -34.46902046122212, -34.46901994847448, -34.46902191175035, -34.46901864078613, -34.46902184032717, -34.46901856936293, -34.4690202805181, -34.46902027201708, -34.46902020909489, 
  -34.46902020059389, -34.46903491713824, -34.46900563566656, -34.469034845712, -34.4690055642464, -34.46902026833532, -34.46902028420035, -34.4690201969121}
 {-208.8561327593004, -208.8561371930156, -208.8561371188539, -208.8561283997662, -208.8561283256075, -208.8561371657273, -208.8561371461418, -208.8561283724794, -208.8561283528938, -208.8561373204974, -208.8561369913733, -208.8561285272479, -208.856128198127, -208.8561413086166, -208.8561330032741, -208.8561325153679, -208.856124210027, -208.8561371598169, -208.8561371520522, -208.856128366569, -208.8561283588044, -208.8561389170438, -208.8561353948471, -208.8561301237935, -208.8561266016015, -208.8561388431136, -208.8561354687631, -208.8561300498659, -208.8561266755149, -208.856140155993, -208.8561341559037, -208.8561313627451, -208.8561253626559, -208.8561287209453, -208.8561455928186, -208.8561199275753, -208.8561367996928, -208.8561329412793, -208.8561413707986, -208.8561241480339, 
  -208.8561325775482, -208.8561693311697, -208.8561049822451, -208.8561605379202, -208.8560961889987, -208.856155114567, -208.8561191971962, -208.8561463213164, -208.8561104039509, -208.8561514486096, -208.8561228632218, -208.856142655361, -208.8561140699746, -208.8561576870375, -208.8561166248352, -208.8561488937899, -208.8561078315869, -208.8561328061735, -208.856132786588, -208.8561327320133, -208.8561327124278, -208.8561329609436, -208.8561326318195, -208.8561328867818, -208.8561325576608, -208.8561369490629, -208.8561286437204, -208.8561368749018, -208.8561285695609, -208.8561328002631, -208.8561327924984, -208.8561327261028, -208.8561327183382, -208.8561345574889, -208.8561310352944, -208.8561344833284, -208.8561309611344, -208.85613448356, -208.8561311092091, -208.8561344093996, 
  -208.856131035049, -208.8561357964392, -208.85612979635, -208.856135722279, -208.8561297221898, -208.8561243613439, -208.8561412333124, -208.8561242871567, -208.8561411591792, -208.8561285817278, -208.8561370112426, -208.8561285075656, -208.8561369370843, -208.8561649716154, -208.8561006226918, -208.8561648974546, -208.8561005485322, -208.8561507550117, -208.8561148376439, -208.8561506808518, -208.8561147634834, -208.8561470890562, -208.8561185036677, -208.8561470148945, -208.8561184295089, -208.8561533274838, -208.8561122652814, -208.8561532533237, -208.8561121911209, -208.8561329336552, -208.8561326045327, -208.8561329140697, -208.8561325849472, -208.8561369217749, -208.8561286164332, -208.8561369021894, -208.8561285968477, -208.8561327729755, -208.8561327652109, -208.85613275339, 
  -208.8561327456254, -208.8561345302018, -208.8561310080062, -208.8561345106151, -208.856130988422, -208.8561344562724, -208.8561310819215, -208.8561344366867}
 {-356.800492969211, -356.8004957324465, -356.8004957077434, -356.8004902306964, -356.8004902059962, -356.8004957304753, -356.8004957097143, -356.8004902287266, -356.8004902079657, -356.8004957035561, -356.800495736635, -356.8004902018063, -356.8004902348874, -356.8004981070715, -356.8004933331371, -356.8004926053221, -356.8004878313892, -356.8004957441372, -356.8004956960524, -356.8004902423885, -356.8004901943037, -356.8004972575282, -356.8004941826811, -356.8004917557748, -356.8004886809373, -356.8004969086199, -356.8004945315757, -356.8004914068713, -356.8004890298269, -356.8004975227356, -356.8004939174711, -356.8004920209868, -356.8004884157226, -356.8004854307913, -356.8005060108194, -356.8004799289086, -356.8005005092048, -356.8004896482041, -356.8005017921377, -356.8004841464565, 
  -356.8004962903879, -356.8005154032432, -356.8004760378892, -356.8005099014928, -356.8004705361422, -356.8005012865167, -356.8004901536454, -356.8004957847623, -356.8004846519024, -356.8005005724276, -356.800490867749, -356.8004950706781, -356.8004853660012, -356.8005046569275, -356.8004867833246, -356.8004991551795, -356.8004812815753, -356.8004929919424, -356.8004929711815, -356.8004929672408, -356.8004929464799, -356.8004929650235, -356.8004929981021, -356.8004929403204, -356.8004929734018, -356.8004953685386, -356.8004905946043, -356.8004953438363, -356.8004905699033, -356.8004930056044, -356.8004929575197, -356.8004929809027, -356.800492932818, -356.8004945189931, -356.8004914441507, -356.8004944942913, -356.8004914194491, -356.8004941700873, -356.8004917930427, -356.8004941453853, 
  -356.8004917683414, -356.8004947842028, -356.8004911789383, -356.8004947595011, -356.8004911542367, -356.8004826922011, -356.8005032723439, -356.8004826674802, -356.8005032476616, -356.8004869096733, -356.8004990536028, -356.8004868849686, -356.8004990289042, -356.8005126647098, -356.8004732993568, -356.8005126400075, -356.8004732746559, -356.8004985479812, -356.8004874151153, -356.8004985232791, -356.800487390414, -356.8004978338951, -356.8004881292159, -356.8004978091921, -356.8004881045157, -356.8005019183948, -356.8004840447917, -356.8005018936935, -356.8004840200897, -356.8004929630522, -356.8004929961321, -356.8004929422913, -356.8004929753713, -356.8004953665677, -356.800490592634, -356.8004953458068, -356.8004905718732, -356.8004930036338, -356.800492955549, -356.8004929828729, 
  -356.8004929347881, -356.8004945170231, -356.8004914421796, -356.8004944962611, -356.8004914214198, -356.8004941681166, -356.8004917910722, -356.8004941473556}
 {-90.9095968794836, -90.9096238487518, -90.9096356453379, -90.9095581136979, -90.9095699102955, -90.90962986582, -90.9096296282678, -90.9095641307732, -90.9095638932183, -90.9096287752851, -90.9096307188135, -90.9095630402429, -90.9095649837594, -90.9096232114014, -90.909636282758, -90.9095574763493, -90.909570547714, -90.9096298563873, -90.9096296377005, -90.9095641213393, -90.9095639026523, -90.9096402407346, -90.9096192536011, -90.9095745056026, -90.9095535186369, -90.9096450118175, -90.9096144823398, -90.90957927677, -90.909548747291, -90.9096265496872, -90.9096329444226, -90.9095608146373, -90.9095672093764, -90.9094723515029, -90.9097871450269, -90.909406614461, -90.9097214119725, -90.9096124466498, -90.9096470477109, -90.9095467116086, -90.9095813126558, -90.9097241319768, 
  -90.9095353642053, -90.909658396919, -90.9094696291668, -90.9093546169209, -90.9099048820425, -90.9092888824227, -90.9098391464444, -90.9096336325258, -90.9096258617129, -90.9095678974738, -90.9095601266686, -90.9095966418784, -90.9096628551646, -90.9095309068403, -90.9095971201066, -90.9095910999653, -90.9095908624119, -90.9096028965573, -90.9096026590036, -90.9095900094343, -90.9095919529537, -90.9096018060232, -90.9096037495486, -90.9095844455426, -90.9095975169063, -90.9095962421375, -90.9096093134951, -90.909591090532, -90.9095908718452, -90.909602887124, -90.909602668437, -90.90960147484, -90.9095804877851, -90.9096132714267, -90.9095922843823, -90.9096062459664, -90.9095757164803, -90.9096180425506, -90.9095875130799, -90.9095877838313, -90.909594178568, -90.9095995804226, 
  -90.9096059751605, -90.9094335847099, -90.9097483801094, -90.9094453811835, -90.9097601768195, -90.9095736808433, -90.9096082818067, -90.9095854773444, -90.9096200784894, -90.9096853661196, -90.9094965983518, -90.9096971627056, -90.9095083949496, -90.9093158514111, -90.9098661158417, -90.9093276478619, -90.9098779125746, -90.9095948666691, -90.909587095859, -90.9096066632599, -90.909598892452, -90.9095578760248, -90.9096240893077, -90.9095696726233, -90.909635885893, -90.9095960265046, -90.909597970027, -90.909595788951, -90.9095977324734, -90.9095904626159, -90.9096035339766, -90.9095902250624, -90.9096032964229, -90.9095971076038, -90.909596888917, -90.9095968700503, -90.9095966513634, -90.9096074919116, -90.9095865048572, -90.9096072543532, -90.9095862673084, -90.9096122630341, 
  -90.9095817335562, -90.909612025481}
 {-47.06395252165839, -47.06393496496173, -47.06392983519765, -47.06397520821239, -47.06397007840607, -47.0639324794506, -47.06393232070857, -47.06397272268076, -47.06397256393748, -47.06394381479345, -47.06392098540845, -47.06398405795214, -47.06396122870885, -47.06392443404169, -47.06394036616817, -47.06396467727872, -47.06398060939023, -47.06393245611825, -47.06393234404091, -47.06397269934762, -47.06397258727063, -47.06392318204861, -47.06394161941224, -47.0639634253741, -47.06398186254582, -47.06393825710999, -47.06392654313051, -47.06397850034257, -47.06396678635701, -47.06393977079713, -47.06392502942693, -47.0639800140261, -47.06396527265702, -47.06408797044302, -47.06377683279269, -47.06412821602057, -47.06381707367429, -47.06388510278591, -47.06397969779625, -47.06392534599194, 
  -47.06401994104932, -47.06394233554581, -47.06392246798537, -47.06398257882907, -47.0639627111612, -47.06390704914757, -47.06395775168502, -47.06394729169061, -47.06399799560105, -47.06391705360334, -47.063947747124, -47.063957296856, -47.06398799033039, -47.06397171107536, -47.06389308917019, -47.06401195428972, -47.06393333241492, -47.0639551659224, -47.0639550071798, -47.06395003613723, -47.06394987739453, -47.06396650122964, -47.0639436719153, -47.06396137144424, -47.06393854213029, -47.06394712052372, -47.06396305262916, -47.06394199072498, -47.06395792285751, -47.06395514258972, -47.06395503051246, -47.06395001280444, -47.06394990072735, -47.06394586857186, -47.063964305832, -47.06394073877915, -47.06395917605432, -47.06396094358274, -47.06394922960079, -47.06395581379811, 
  -47.06394409981502, -47.06396245726837, -47.06394771589872, -47.06395732748317, -47.0639425861135, -47.06411065813385, -47.06379951804495, -47.06410552825805, -47.06379438835034, -47.0639077892085, -47.0640023843167, -47.06390265949764, -47.06399725445715, -47.06396502204059, -47.06394515443362, -47.06395989226259, -47.06394002464123, -47.0639297352492, -47.06398043852641, -47.06392460551724, -47.06397530868797, -47.06393974008408, -47.06397043358627, -47.06393461030355, -47.0639653037964, -47.06399439753883, -47.06391577564975, -47.06398926775454, -47.06391064586365, -47.06396401570805, -47.06394118639409, -47.06396385696559, -47.06394102765127, -47.06394463499564, -47.06396056711445, -47.06394447625281, -47.063960408372, -47.06395265706832, -47.06395254499107, -47.0639524983256, 
  -47.06395238624851, -47.06394338304521, -47.06396182031588, -47.06394322430556, -47.06396166157023, -47.0639584580621, -47.06394674407863, -47.06395829931852}
 {-488.9207403465964, -488.9207404675472, -488.9207408519253, -488.9207398412799, -488.9207402256636, -488.9207406933869, -488.9207406260852, -488.920740067123, -488.9207399998203, -488.9207405088655, -488.9207408106093, -488.920739882601, -488.9207401843448, -488.9207425438217, -488.9207387756615, -488.9207419175566, -488.9207381493978, -488.9207406802003, -488.9207406392718, -488.9207400539358, -488.9207400130074, -488.9207558773486, -488.9207254421466, -488.9207552510557, -488.9207248159108, -488.9207454617615, -488.920735857705, -488.9207448354985, -488.9207352314394, -488.9207360642978, -488.9207452551941, -488.920735438033, -488.92074462893, -488.9207247190717, -488.9207566011066, -488.9207240924742, -488.9207559751753, -488.9207372040597, -488.9207441154955, -488.9207365778039, 
  -488.9207434892225, -488.9207932477753, -488.9206880724952, -488.9207926215066, -488.920687446235, -488.9207451145198, -488.9207362049445, -488.9207444882116, -488.920735578724, -488.9207465540006, -488.9207347654379, -488.9207459277363, -488.9207341391733, -488.92070197877, -488.9207793429677, -488.9207013525083, -488.9207787167006, -488.9207401880571, -488.920740120755, -488.9207405724381, -488.9207405051359, -488.9207400035356, -488.9207403052792, -488.9207403879163, -488.9207406896603, -488.9207420384913, -488.920738270332, -488.9207424228725, -488.9207386547126, -488.9207401748703, -488.9207401339418, -488.9207405592512, -488.9207405183226, -488.920755372006, -488.9207249368293, -488.9207557563836, -488.9207253212136, -488.9207449564329, -488.9207353523738, -488.9207453408126, 
  -488.9207357367559, -488.9207355589678, -488.9207447498642, -488.9207359433486, -488.9207451342451, -488.920724213587, -488.9207560959314, -488.9207245979443, -488.920756480336, -488.9207366987379, -488.9207436101573, -488.9207370831111, -488.920743994546, -488.9207927424437, -488.9206875671668, -488.9207931268236, -488.9206879515488, -488.9207446091705, -488.9207356996339, -488.9207449935463, -488.9207360840199, -488.920746048671, -488.9207342601074, -488.9207464330513, -488.920734644489, -488.9207014734408, -488.920778837637, -488.920701857823, -488.9207792220167, -488.9207402293769, -488.9207405311207, -488.9207401620747, -488.9207404638185, -488.9207422643328, -488.9207384961733, -488.9207421970307, -488.9207384288712, -488.9207404007117, -488.9207403597832, -488.9207403334096, 
  -488.920740292481, -488.9207555978463, -488.9207251626719, -488.9207555305431, -488.9207250953707, -488.9207451822736, -488.9207355782158, -488.9207451149715}
 {-230.369177970387, -230.3691779680485, -230.3691779174512, -230.369178023322, -230.369177972725, -230.3691779415404, -230.3691779439593, -230.3691779968141, -230.3691779992329, -230.3691782518152, -230.3691776336872, -230.369178307084, -230.3691776889658, -230.3691804264774, -230.3691754590405, -230.3691804817507, -230.3691755143145, -230.3691780080685, -230.3691778774312, -230.3691780633421, -230.3691779327049, -230.369176475227, -230.3691794101128, -230.3691765305472, -230.3691794653399, -230.3691802784917, -230.3691756069944, -230.3691803337665, -230.369175662267, -230.36917210297, -230.3691837825387, -230.3691721582441, -230.369183837812, -230.3691778136149, -230.369178071885, -230.3691778688926, -230.3691781271546, -230.3691700784893, -230.3691858071494, -230.3691701337662, 
  -230.3691858624199, -230.3692314821455, -230.369124404295, -230.3692315374235, -230.3691244595643, -230.3691779624323, -230.3691779230674, -230.3691780177057, -230.3691779783414, -230.369182531685, -230.3691733538029, -230.3691825869604, -230.3691734090748, -230.3691461577517, -230.3692097296842, -230.3691462130182, -230.3692097849651, -230.3691779944761, -230.369177996895, -230.369177943879, -230.3691779462978, -230.369178304749, -230.3691776866248, -230.3691782541507, -230.3691776360288, -230.3691804794131, -230.3691755119761, -230.3691804288156, -230.3691754613793, -230.3691780610042, -230.3691779303669, -230.369178010407, -230.3691778797698, -230.3691765281873, -230.3691794630239, -230.3691764775876, -230.3691794124293, -230.3691803314279, -230.3691756599296, -230.3691802808309, 
  -230.3691756093323, -230.3691721559059, -230.3691838354742, -230.3691721053088, -230.369183784877, -230.3691778665526, -230.3691781248187, -230.3691778159555, -230.3691780742215, -230.3691701314263, -230.3691858600839, -230.3691700808298, -230.3691858094861, -230.3692315350834, -230.3691244572285, -230.3692314844862, -230.3691244066314, -230.3691780153679, -230.3691779760033, -230.3691779647707, -230.3691779254061, -230.3691825846216, -230.3691734067377, -230.3691825340244, -230.3691733561406, -230.3691462106838, -230.3692097826236, -230.3691461600867, -230.3692097320263, -230.3691782782405, -230.3691776601173, -230.3691782806593, -230.3691776625363, -230.3691804529049, -230.3691754854683, -230.3691804553238, -230.3691754878872, -230.3691780344962, -230.3691779038589, -230.369178036915, 
  -230.3691779062778, -230.3691765016773, -230.3691794365179, -230.3691765040976, -230.3691794389353, -230.36918030492, -230.3691756334215, -230.3691803073388}
 {-315.2940938717797, -315.2940964897433, -315.2940957804987, -315.2940919630698, -315.2940912538215, -315.2940961117559, -315.2940961584853, -315.2940915850804, -315.2940916318101, -315.2940968798624, -315.2940953903793, -315.2940923531859, -315.2940908637051, -315.2940937418292, -315.2940985284341, -315.2940892151542, -315.2940940017583, -315.2940962352429, -315.2940960349984, -315.2940917085676, -315.2940915083229, -315.294093641685, -315.2940986285774, -315.2940891150143, -315.2940941018974, -315.2941004167817, -315.2940918534905, -315.2940958901063, -315.2940873268151, -315.294098092433, -315.2940941778254, -315.2940935657578, -315.29408965115, -315.2941096778652, -315.2940825932915, -315.2941051514037, -315.2940780664024, -315.2940816046296, -315.2941106657204, -315.2940770779505, 
  -315.2941061390487, -315.2941215206404, -315.2940707507244, -315.2941169939671, -315.294066224047, -315.294107291844, -315.2940849783413, -315.2941027651559, -315.2940804516787, -315.2940974148013, -315.2940948555638, -315.2940928881264, -315.294090328888, -315.2941177183082, -315.2940745518884, -315.2941131916323, -315.2940700252135, -315.2940942030384, -315.2940942497681, -315.2940934937922, -315.2940935405216, -315.2940949711446, -315.2940934816625, -315.2940942618981, -315.2940927724162, -315.2940918331125, -315.2940966197161, -315.2940911238653, -315.2940959104707, -315.2940943265256, -315.294094126281, -315.2940936172793, -315.2940934170346, -315.2940917329706, -315.2940967198573, -315.2940910237231, -315.294096010612, -315.2940985080641, -315.2940899447734, -315.2940977988182, 
  -315.2940892355265, -315.2940961837158, -315.294092269108, -315.2940954744694, -315.2940915598617, -315.2941077692797, -315.2940806844424, -315.2941070599836, -315.2940799752459, -315.294079695905, -315.2941087570103, -315.2940789866694, -315.2941080477532, -315.2941196119245, -315.2940688420057, -315.2941189026774, -315.29406813276, -315.2941053831161, -315.2940830696346, -315.2941046738781, -315.2940823603799, -315.2940955060844, -315.294092946846, -315.2940947968377, -315.2940922376, -315.2941158095907, -315.2940726431713, -315.2941151003441, -315.2940719339252, -315.2940945931562, -315.2940931036742, -315.2940946398856, -315.2940931504038, -315.2940914551237, -315.2940962417282, -315.2940915018533, -315.2940962884577, -315.2940939485372, -315.2940937482926, -315.2940939952669, 
  -315.2940937950222, -315.2940913549819, -315.2940963418693, -315.294091401711, -315.2940963885992, -315.2940981300761, -315.2940895667848, -315.2940981768054}
 {-16.34282270873375, -16.34282259017133, -16.34282257492903, -16.34282284253835, -16.3428228272961, -16.34282258285742, -16.34282258224294, -16.34282283522446, -16.34282283460999, -16.34282288868161, -16.34282227644588, -16.34282314104086, -16.34282252882072, -16.34282474832504, -16.3428204167817, -16.3428250006912, -16.34282066914962, -16.34282258879154, -16.34282257630884, -16.3428228411585, -16.34282282867596, -16.34281223860804, -16.34283292720303, -16.34281249103116, -16.34283317951398, -16.34282230524175, -16.34282285986284, -16.34282255760803, -16.34282311223063, -16.34282422876933, -16.34282093634758, -16.34282448113455, -16.34282118871644, -16.34282230845384, -16.34282285664896, -16.3428225608208, -16.34282310901607, -16.34282147210474, -16.34282369307324, -16.3428217244799, 
  -16.34282394543215, -16.34283394927523, -16.34281121660828, -16.34283420166523, -16.34281146895236, -16.34282259540659, -16.34282256969386, -16.34282284777352, -16.342822822061, -16.342828623826, -16.34281654123833, -16.34282887619384, -16.34281679360457, -16.34283545145096, -16.34280971353072, -16.34283570380805, -16.34280996590771, -16.34282271666212, -16.34282271604765, -16.34282270141985, -16.34282270080537, -16.3428230224827, -16.3428224102542, -16.34282300723986, -16.34282239501248, -16.34282488212933, -16.34282055058681, -16.342824866887, -16.34282053534459, -16.3428227225962, -16.34282271011358, -16.34282270735393, -16.3428226948713, -16.3428123724406, -16.34283306097987, -16.34281235719869, -16.34283304573723, -16.34282243904609, -16.3428229936679, -16.34282242380378, 
  -16.34282297842566, -16.34282436257313, -16.34282107015318, -16.34282434733083, -16.34282105491093, -16.34282244225851, -16.34282299045369, -16.34282242701622, -16.34282297521142, -16.34282160591339, -16.342823826874, -16.34282159067135, -16.34282381163148, -16.34283408309129, -16.34281135040162, -16.34283406784925, -16.3428113351591, -16.34282272921124, -16.34282270349861, -16.34282271396896, -16.34282268825634, -16.3428287576311, -16.34281667504263, -16.34282874238882, -16.34281665980036, -16.34283558525073, -16.34280984734036, -16.34283557000837, -16.34280983209816, -16.34282301516853, -16.34282240294057, -16.34282301455402, -16.34282240232612, -16.34282487481541, -16.34282054327294, -16.34282487420093, -16.34282054265846, -16.3428227152823, -16.34282270279968, -16.34282271466782, 
  -16.3428227021852, -16.34281236512695, -16.34283305366572, -16.34281236451234, -16.34283305305137, -16.34282243173218, -16.34282298635402, -16.34282243111769}
 {-17.4448374743913, -17.44483741166646, -17.44483740267555, -17.44483754610702, -17.44483753711614, -17.44483740746251, -17.44483740687948, -17.4448375419031, -17.44483754132007, -17.4448379007725, -17.44483691360427, -17.4448380352064, -17.44483704805153, -17.44483982242171, -17.44483499192373, -17.44483995686162, -17.44483512636499, -17.44483741788623, -17.44483739645579, -17.44483755232671, -17.44483753089646, -17.44484005669847, -17.44483475890031, -17.44484019116169, -17.44483489331824, -17.44483740001893, -17.44483741432625, -17.44483753445897, -17.44483754876738, -17.44484185987117, -17.44483295450441, -17.4448419943092, -17.44483308894754, -17.44483759590497, -17.4448372184405, -17.44483773034467, -17.44483735288197, -17.44483670083599, -17.44483811358591, -17.4448368352838, 
  -17.44483824801927, -17.44483939903666, -17.4448354162481, -17.4448395335002, -17.44483555066572, -17.44483742097322, -17.44483739336886, -17.4448375554137, -17.44483752780955, -17.44484948114647, -17.44482533312313, -17.44484961558772, -17.44482546756305, -17.44486411115645, -17.44481070290398, -17.44486424559114, -17.44481083735046, -17.44483747917827, -17.44483747859523, -17.44483747018737, -17.44483746960433, -17.44483797248509, -17.44483698532319, -17.44483796349384, -17.44483697633263, -17.44483989413713, -17.44483506363981, -17.44483988514621, -17.44483505464893, -17.44483748960193, -17.44483746817159, -17.44483748061103, -17.44483745918069, -17.44484012842544, -17.44483483060482, -17.44484011943472, -17.44483482161374, -17.44483747173442, -17.44483748604226, -17.4448374627435, 
  -17.44483747705138, -17.44484193158565, -17.44483302622142, -17.44484192259473, -17.44483301723054, -17.44483766762028, -17.44483729015669, -17.44483765862937, -17.4448372811658, -17.44483677255527, -17.44483818529813, -17.44483676356454, -17.44483817630706, -17.4448394707638, -17.44483548795246, -17.44483946177309, -17.44483547896138, -17.44483749268892, -17.44483746508466, -17.44483748369802, -17.44483745609377, -17.44484955286255, -17.44482540483855, -17.44484954387165, -17.44482539584765, -17.44486418286928, -17.44481077462266, -17.44486417387833, -17.4448107656318, -17.444837968281, -17.4448369811194, -17.44483796769793, -17.44483698053642, -17.44483988993319, -17.44483505943589, -17.44483988935016, -17.44483505885286, -17.444837485398, -17.44483746396765, -17.44483748481497, 
  -17.44483746338462, -17.4448401242217, -17.4448348264007, -17.44484012363846, -17.44483482581787, -17.44483746753048, -17.44483748183834, -17.44483746694744}
 {-342.3853520067933, -342.3853539882304, -342.3853541251012, -342.3853498884879, -342.3853500253585, -342.3853540209836, -342.3853540923477, -342.3853499212409, -342.3853499926051, -342.3853547825653, -342.3853533307663, -342.3853506828222, -342.3853492310241, -342.3853545149662, -342.3853535983846, -342.3853504152235, -342.3853494986418, -342.3853541961847, -342.3853539171466, -342.385350096442, -342.385349817404, -342.3853526597866, -342.3853554535634, -342.3853485600451, -342.3853513538195, -342.3853574505439, -342.3853506628162, -342.3853533508012, -342.3853465630734, -342.3853588790893, -342.3853492342802, -342.3853547793466, -342.3853451345375, -342.3853654438906, -342.385342670147, -342.3853613442941, -342.3853385702581, -342.3853378636053, -342.3853702498386, -342.3853337638602, 
  -342.3853661500984, -342.3853690231446, -342.3853390915482, -342.3853649234032, -342.3853349918043, -342.3853714460928, -342.3853366671428, -342.3853673463443, -342.3853325674058, -342.3853576012315, -342.3853505123289, -342.3853535014891, -342.3853464125862, -342.3854068573901, -342.3853012554066, -342.3854027576473, -342.385297155664, -342.385351902676, -342.3853519740403, -342.3853520395467, -342.385352110911, -342.3853526642576, -342.385351212459, -342.3853528011282, -342.3853513493297, -342.3853523966586, -342.385351480077, -342.3853525335293, -342.3853516169477, -342.3853520778771, -342.385351798839, -342.3853522147478, -342.3853519357098, -342.3853505414801, -342.3853533352549, -342.3853506783499, -342.3853534721265, -342.3853553322363, -342.3853485445086, -342.385355469107, 
  -342.3853486813793, -342.3853567607816, -342.3853471159726, -342.3853568976523, -342.3853472528433, -342.3853633256537, -342.3853405517688, -342.3853634625293, -342.3853406886346, -342.3853357452936, -342.3853681315352, -342.3853358821701, -342.3853682684, -342.3853669048375, -342.3853369732401, -342.3853670417083, -342.3853371101107, -342.3853693277832, -342.3853345488372, -342.3853694646522, -342.3853346857096, -342.3853554829242, -342.3853483940213, -342.3853556197948, -342.3853485308921, -342.3854047390824, -342.3852991370991, -342.3854048759532, -342.3852992739697, -342.3853526970107, -342.385351245212, -342.3853527683748, -342.3853513165763, -342.3853524294117, -342.38535151283, -342.3853525007759, -342.3853515841942, -342.3853521106302, -342.3853518315922, -342.3853521819944, 
  -342.3853519029564, -342.3853505742328, -342.3853533680083, -342.3853506455969, -342.3853534393727, -342.3853553649894, -342.3853485772617, -342.3853554363537}
 {-241.2932909921933, -241.2932905161244, -241.2932905270585, -241.2932914573462, -241.2932914682791, -241.2932904142467, -241.2932906289362, -241.2932913554665, -241.2932915701588, -241.2932920232022, -241.2932890199836, -241.2932929644218, -241.2932899612064, -241.2932931433608, -241.2932878998296, -241.293294084582, -241.2932888410509, -241.293290700466, -241.2932903427168, -241.2932916416873, -241.2932912839381, -241.2932709831622, -241.2933100600515, -241.2932719244082, -241.293311001248, -241.2932883049982, -241.2932927381671, -241.2932892462184, -241.2932936793894, -241.2932802345546, -241.2933008087071, -241.293281175776, -241.293301749928, -241.2933085553919, -241.2932724885414, -241.2933094970575, -241.2932734293182, -241.2932779349839, -241.2933031082888, -241.2932788761932, 
  -241.293304049522, -241.2933504893089, -241.2932305548731, -241.2933514305352, -241.2932314960892, -241.2932995010043, -241.293281542162, -241.2933004421574, -241.2932824834514, -241.2932968992933, -241.2932841439174, -241.2932978405146, -241.2932850851385, -241.2931769024943, -241.2934041469089, -241.2931778437133, -241.2934050881323, -241.2932908793811, -241.293291094072, -241.2932908903147, -241.2932911050055, -241.2932924883367, -241.2932894851193, -241.2932924992699, -241.2932894960532, -241.2932936084959, -241.2932883649648, -241.2932936194294, -241.2932883758983, -241.2932911656012, -241.293290807852, -241.2932911765346, -241.2932908187855, -241.2932714483073, -241.2933105251766, -241.2932714592456, -241.2933105361054, -241.293288770132, -241.2932932033034, -241.293288781067, 
  -241.2932932142355, -241.2932806996898, -241.293301273842, -241.2932807106233, -241.2933012847756, -241.2933090207498, -241.2932729534538, -241.2933090316822, -241.2932729643884, -241.2932784001061, -241.2933035734368, -241.2932784110534, -241.2933035843566, -241.2933509544463, -241.2932310200059, -241.2933509653803, -241.2932310309389, -241.2932999661054, -241.2932820073311, -241.2932999770388, -241.2932820182648, -241.2932973644282, -241.2932846090526, -241.2932973753621, -241.2932846199857, -241.2931773676293, -241.2934046120442, -241.2931773785609, -241.2934046229796, -241.2932923864577, -241.2932893832408, -241.2932926011487, -241.2932895979316, -241.2932935066172, -241.293288263086, -241.2932937213081, -241.293288477777, -241.2932910637225, -241.2932907059733, -241.2932912784133, 
  -241.2932909206641, -241.2932713464317, -241.2933104232948, -241.293271561121, -241.2933106379872, -241.293288668254, -241.293293101424, -241.293288882945}
 {-356.0659257196754, -356.0659268859762, -356.0659268615755, -356.0659245777769, -356.065924553376, -356.0659268771134, -356.0659268704383, -356.065924568914, -356.0659245622388, -356.0659268997119, -356.0659268478399, -356.0659245915125, -356.0659245396405, -356.0659280959956, -356.0659256515577, -356.0659257877962, -356.0659233433583, -356.0659268689161, -356.0659268786355, -356.0659245607167, -356.0659245704362, -356.0659272961122, -356.065926451445, -356.0659249879124, -356.0659241432457, -356.0659266687536, -356.0659270787995, -356.0659243605542, -356.0659247706002, -356.0659279673742, -356.0659257801869, -356.0659256591747, -356.0659234719875, -356.065924871135, -356.0659288767803, -356.0659225629055, -356.0659265686111, -356.0659270132986, -356.0659267342968, -356.0659247051001, 
  -356.0659244260965, -356.0659363070909, -356.0659174409632, -356.0659339988911, -356.0659151327641, -356.0659328949343, -356.0659208525814, -356.0659305867342, -356.0659185443826, -356.0659328874915, -356.0659208600245, -356.0659305792921, -356.0659185518251, -356.0659396117653, -356.0659141356742, -356.0659373035658, -356.0659118274747, -356.0659257352135, -356.0659257285383, -356.0659257108127, -356.0659257041375, -356.0659257578119, -356.0659257059399, -356.065925733411, -356.0659256815391, -356.0659269540956, -356.0659245096578, -356.0659269296948, -356.065924485257, -356.0659257270161, -356.0659257367356, -356.0659257026153, -356.0659257123348, -356.0659261542121, -356.0659253095451, -356.0659261298112, -356.0659252851443, -356.0659255268537, -356.0659259368996, -356.0659255024528, 
  -356.0659259124988, -356.0659268254742, -356.065924638287, -356.0659268010734, -356.0659246138862, -356.0659237292184, -356.065927734897, -356.0659237048208, -356.0659277104931, -356.0659258713997, -356.0659255923958, -356.0659258469978, -356.0659255679961, -356.0659351651908, -356.0659162990634, -356.06593514079, -356.0659162746626, -356.0659317530338, -356.0659197106819, -356.0659317286333, -356.0659196862808, -356.0659317455916, -356.0659197181245, -356.0659317211907, -356.0659196937237, -356.0659384698653, -356.0659129937742, -356.0659384454645, -356.0659129693734, -356.0659257489491, -356.0659256970771, -356.0659257422739, -356.0659256904019, -356.0659269452328, -356.065924500795, -356.0659269385576, -356.0659244941197, -356.0659257181533, -356.0659257278728, -356.0659257114781, 
  -356.0659257211976, -356.0659261453492, -356.0659253006823, -356.0659261386739, -356.0659252940071, -356.0659255179908, -356.0659259280368, -356.0659255113156}
 {-374.0832527587568, -374.083252748773, -374.0832527318107, -374.0832527857031, -374.0832527687406, -374.0832527432377, -374.0832527373461, -374.0832527801676, -374.0832527742761, -374.0832527571702, -374.0832527234135, -374.0832527941002, -374.0832527603435, -374.0832526382849, -374.0832528422994, -374.0832526752148, -374.0832528792294, -374.0832527325029, -374.0832527480809, -374.0832527694329, -374.0832527850108, -374.0832510258518, -374.0832544547326, -374.0832510627817, -374.0832544916626, -374.0832548284693, -374.0832506521154, -374.0832548653993, -374.0832506890453, -374.0832579899224, -374.0832474906671, -374.0832580268524, -374.083247527597, -374.0832531634107, -374.0832523172069, -374.0832532003329, -374.0832523541447, -374.083253924115, -374.0832515564729, -374.0832539610451, 
  -374.0832515934026, -374.0832371949213, -374.0832682857133, -374.0832372318512, -374.0832683226434, -374.083258771728, -374.0832467088195, -374.0832588086575, -374.0832467457499, -374.0832586824333, -374.0832467981158, -374.0832587193633, -374.0832468350457, -374.083194436288, -374.0833110474843, -374.083194473218, -374.0833110844142, -374.0832527701838, -374.0832527642922, -374.0832527532214, -374.0832527473299, -374.0832527841165, -374.0832527503597, -374.083252767154, -374.0832527333972, -374.083252665231, -374.0832528692456, -374.0832526482686, -374.0832528522831, -374.083252759449, -374.083252775027, -374.0832527424867, -374.0832527580646, -374.0832510527979, -374.0832544816787, -374.0832510358355, -374.0832544647164, -374.0832548554155, -374.0832506790615, -374.083254838453, 
  -374.0832506620991, -374.0832580168686, -374.0832475176133, -374.0832579999061, -374.0832475006509, -374.0832531903521, -374.0832523441578, -374.0832531733913, -374.0832523271938, -374.0832539510613, -374.0832515834188, -374.0832539340986, -374.0832515664567, -374.0832372218674, -374.0832683126595, -374.083237204905, -374.083268295697, -374.0832587986739, -374.083246735766, -374.0832587817116, -374.0832467188034, -374.0832587093794, -374.0832468250621, -374.083258692417, -374.0832468080996, -374.0831944632342, -374.0833110744304, -374.0831944462718, -374.083311057468, -374.083252778581, -374.0832527448242, -374.0832527726894, -374.0832527389327, -374.0832526596956, -374.0832528637102, -374.083252653804, -374.0832528578186, -374.0832527539136, -374.0832527694915, -374.0832527480221, 
  -374.0832527636, -374.0832510472624, -374.0832544761433, -374.0832510413709, -374.0832544702518, -374.08325484988, -374.0832506735261, -374.0832548439884}
 {-545.043653472108, -545.0436481632236, -545.0436484163347, -545.0436585279236, -545.043658781038, -545.043648247793, -545.0436483317653, -545.0436586124941, -545.0436586964673, -545.0436469802623, -545.0436495993042, -545.0436573449639, -545.0436599640061, -545.0436516241929, -545.0436449553719, -545.0436619888942, -545.0436553200737, -545.043648260994, -545.0436483185643, -545.0436586256956, -545.0436586832659, -545.0436470068148, -545.0436495727446, -545.0436573715193, -545.0436599374433, -545.0436485118748, -545.0436480676837, -545.0436588765764, -545.043658432385, -545.0436493654475, -545.0436472141107, -545.0436597301494, -545.043657578812, -545.0436134526234, -545.043683127868, -545.0436238164938, -545.0436934934009, -545.0436457347108, -545.0436508449562, -545.0436560994338, 
  -545.0436612096363, -545.0436443806654, -545.0436521988974, -545.0436547453635, -545.0436625636025, -545.043657478412, -545.0436391011992, -545.0436678429197, -545.0436494660947, -545.0436622340172, -545.0436343455078, -545.0436725987183, -545.0436447102099, -545.0436473087668, -545.0436492707796, -545.043657673468, -545.0436596354815, -545.0436533035653, -545.043653387538, -545.0436535566782, -545.0436536406508, -545.0436520360349, -545.0436546550769, -545.0436522891477, -545.0436549081896, -545.0436566799651, -545.0436500111446, -545.0436569330781, -545.0436502642572, -545.0436533167665, -545.0436533743369, -545.0436535698794, -545.0436536274496, -545.0436520625887, -545.0436546285157, -545.0436523157014, -545.0436548816286, -545.0436535676473, -545.043653123456, -545.04365382076, 
  -545.0436533765688, -545.0436544212202, -545.043652269883, -545.0436546743331, -545.0436525229958, -545.0436185079845, -545.0436881840521, -545.0436187610891, -545.043688437173, -545.0436507905065, -545.0436559007054, -545.0436510435942, -545.0436561538432, -545.0436494364361, -545.0436572546717, -545.043649689549, -545.0436575077845, -545.0436625340892, -545.043644157067, -545.0436627871985, -545.0436444101832, -545.0436672897895, -545.0436394012804, -545.0436675429022, -545.0436396543934, -545.0436523645391, -545.0436543265523, -545.0436526176519, -545.043654579665, -545.0436521206049, -545.0436547396469, -545.0436522045775, -545.0436548236196, -545.0436567645352, -545.0436500957145, -545.0436568485079, -545.0436501796871, -545.0436534013365, -545.0436534589069, -545.0436534853092, 
  -545.0436535428796, -545.0436521471575, -545.0436547130868, -545.0436522311328, -545.0436547970571, -545.0436536522172, -545.0436532080262, -545.0436537361901}
 {-140.7823249622052, -140.7823015757328, -140.7823090755224, -140.7823408489404, -140.7823483488028, -140.7823053847704, -140.7823052664821, -140.7823446580161, -140.7823445397243, -140.782295792307, -140.7823148589706, -140.7823350655888, -140.7823541321767, -140.7822945872215, -140.78231606409, -140.7823338604516, -140.782355337348, -140.782305397742, -140.7823052535105, -140.7823446709861, -140.7823445267543, -140.7823391503816, -140.7822715015087, -140.7823784234445, -140.7823107749337, -140.7823182824038, -140.7822923689352, -140.7823575556477, -140.7823316421791, -140.7823047924355, -140.7823058588727, -140.7823440656753, -140.7823451321209, -140.7824226109139, -140.7821880433352, -140.7824618866179, -140.7822273141191, -140.7823370792663, -140.7822735723259, -140.782376352475, 
  -140.7823128456051, -140.7822386548176, -140.7823719990674, -140.7822779280938, -140.7824112722791, -140.7822936901412, -140.7823169615384, -140.7823329627367, -140.7823562354308, -140.7823019709919, -140.7823086805436, -140.7823412442161, -140.7823479538073, -140.7822858760815, -140.7823247774893, -140.7823251493454, -140.7823640507133, -140.7823212714385, -140.7823211531486, -140.7823287712647, -140.7823286529745, -140.7823116789904, -140.7823307456218, -140.7823191788221, -140.7823382454422, -140.7823104738732, -140.782331950773, -140.7823179737165, -140.7823394505818, -140.7823212844093, -140.7823211401779, -140.7823287842356, -140.7823286400036, -140.782355036966, -140.782287388259, -140.7823625367769, -140.7822948881001, -140.7823341690763, -140.7823082555974, -140.782341668892, 
  -140.7823157554338, -140.7823206791014, -140.7823217455415, -140.7823281789262, -140.7823292453688, -140.782438498709, -140.7822039288747, -140.7824459987395, -140.7822114284964, -140.7823529658873, -140.7822894590395, -140.7823604657708, -140.7822969588082, -140.7822545414963, -140.7823878857234, -140.7822620413319, -140.7823953855398, -140.782309576532, -140.7823328484823, -140.7823170762626, -140.7823403484037, -140.7823178576506, -140.7823245672196, -140.7823253574742, -140.782332067048, -140.7823017627545, -140.782340664151, -140.7823092625891, -140.7823481639684, -140.7823154880496, -140.7823345546759, -140.7823153697601, -140.7823344363853, -140.7823142829383, -140.7823357598212, -140.7823141646487, -140.7823356415307, -140.782325093466, -140.7823249492344, -140.782324975176, 
  -140.7823248309443, -140.7823588460132, -140.782291197325, -140.7823587277268, -140.7822910790313, -140.7823379781265, -140.7823120646604, -140.7823378598389}
 {-220.0065168101381, -220.0065165517633, -220.0065176434163, -220.0065159768773, -220.0065170685528, -220.0065170414795, -220.0065171536983, -220.0065164666037, -220.0065165788248, -220.0065127359093, -220.0065214592721, -220.0065121610391, -220.0065208843928, -220.0065074706479, -220.0065267245686, -220.0065068957706, -220.0065261496964, -220.0065168193546, -220.0065173758233, -220.0065162444798, -220.0065168009485, -220.0065025678076, -220.0065316274894, -220.0065019929578, -220.0065310525896, -220.0065057551643, -220.0065284400762, -220.0065051802883, -220.0065278652027, -220.0065126624966, -220.0065215327069, -220.0065120876223, -220.0065209578317, -220.0065251235297, -220.0065090726141, -220.006524549137, -220.0065084972572, -220.0065355414952, -220.006498653797, -220.0065349666054, 
  -220.0064980789373, -220.006564555741, -220.0064696405895, -220.006563980873, -220.006469065708, -220.0065274286613, -220.0065067664751, -220.006526853727, -220.0065061916599, -220.0064982670475, -220.0065359286183, -220.0064976921702, -220.0065353537462, -220.0065151906441, -220.0065190055745, -220.006514615767, -220.0065184307021, -220.006516208197, -220.0065163204167, -220.006517299861, -220.0065174120813, -220.0065119026294, -220.0065206259878, -220.0065129942938, -220.0065217176519, -220.0065066373643, -220.006525891288, -220.0065077290291, -220.0065269829518, -220.0065159860725, -220.0065165425412, -220.0065170777368, -220.0065176342055, -220.0065017345366, -220.0065307941963, -220.0065028262038, -220.0065318858576, -220.0065049218814, -220.0065276067949, -220.006506013546, 
  -220.0065286984588, -220.0065118292147, -220.0065206994247, -220.0065129208791, -220.0065217910888, -220.0065242904507, -220.0065082391288, -220.0065253821909, -220.0065093307173, -220.006534708202, -220.006497820526, -220.0065357998734, -220.0064989121832, -220.0065637224615, -220.006468807305, -220.0065648141275, -220.0064698989675, -220.006526595356, -220.0065059332162, -220.0065276870072, -220.0065070248936, -220.0064974337644, -220.0065350953373, -220.0064985254282, -220.0065361870021, -220.0065143573612, -220.0065181722932, -220.0065154490248, -220.0065192639582, -220.0065123923507, -220.006521115709, -220.0065125045708, -220.006521227929, -220.0065071270859, -220.0065263810091, -220.0065072393058, -220.0065264932291, -220.0065164757938, -220.0065170322625, -220.0065165880138, 
  -220.0065171444825, -220.0065022242595, -220.006531283916, -220.0065023364792, -220.0065313961361, -220.0065054116028, -220.0065280965162, -220.006505523823}
 {-271.8574109999651, -271.8574109669453, -271.8574109452487, -271.8574110546813, -271.8574110329848, -271.8574109572171, -271.8574109549768, -271.8574110449532, -271.8574110427129, -271.8574107804054, -271.8574111317898, -271.8574108681422, -271.8574112195251, -271.8574129980357, -271.8574089141631, -271.8574130857718, -271.8574090018992, -271.8574109563499, -271.8574109558441, -271.8574110440859, -271.8574110435802, -271.8574087422756, -271.8574131699517, -271.8574088300243, -271.857413257675, -271.8574112064998, -271.8574107056959, -271.8574112942359, -271.857410793432, -271.8574130536751, -271.8574088585333, -271.8574131414111, -271.8574089462694, -271.8574098722247, -271.8574120399719, -271.8574099599663, -271.8574121277025, -271.8574127561605, -271.8574091560993, -271.8574128438974, 
  -271.8574092438344, -271.8574289781372, -271.8573929347639, -271.8574290658756, -271.8573930224976, -271.8574109614841, -271.85741095071, -271.85741104922, -271.857411038446, -271.8574162776441, -271.8574056345267, -271.8574163653797, -271.8574057222632, -271.8574194539973, -271.8574024582803, -271.8574195417316, -271.8574025460181, -271.8574110119335, -271.8574110096932, -271.857410990237, -271.8574109879968, -271.8574108351224, -271.8574111865055, -271.8574108134254, -271.8574111648095, -271.8574130527521, -271.8574089688794, -271.8574130310555, -271.8574089471829, -271.8574110110662, -271.8574110105605, -271.8574109893697, -271.857410988864, -271.8574087969989, -271.857413224661, -271.8574087753011, -271.8574132029658, -271.8574112612162, -271.8574107604122, -271.8574112395197, 
  -271.8574107387157, -271.8574131083915, -271.8574089132496, -271.857413086695, -271.8574088915531, -271.8574099269438, -271.8574120946855, -271.8574099052473, -271.857412072989, -271.8574128108771, -271.8574092108154, -271.8574127891809, -271.8574091891186, -271.8574290328549, -271.857392989479, -271.8574290111582, -271.8573929677827, -271.8574110162004, -271.8574110054264, -271.8574109945039, -271.8574109837298, -271.8574163323602, -271.8574056892432, -271.8574163106638, -271.8574056675467, -271.8574195087127, -271.8574025129976, -271.8574194870164, -271.857402491301, -271.857410825394, -271.8574111767777, -271.8574108231538, -271.8574111745374, -271.8574130430239, -271.8574089591513, -271.8574130407836, -271.8574089569111, -271.8574110013381, -271.8574110008324, -271.8574109990978, 
  -271.8574109985921, -271.8574087872704, -271.8574132149333, -271.8574087850296, -271.8574132126935, -271.8574112514881, -271.8574107506841, -271.8574112492478}
 {-50.25900780486902, -50.25894429331858, -50.25895763654532, -50.2590579735318, -50.25907131684344, -50.25895083604245, -50.25895109382191, -50.25906451629825, -50.25906477407743, -50.25895020190887, -50.25895172802011, -50.25906388215319, -50.25906540828711, -50.25893583477258, -50.25896609519288, -50.25904951500522, -50.25907977547158, -50.25895042575724, -50.25895150410733, -50.25906410601308, -50.25906518436281, -50.25899997505239, -50.25890195574128, -50.25911365521634, -50.25901563608866, -50.25894514309331, -50.25895678685137, -50.25905882335413, -50.25907046710186, -50.25894244324595, -50.258959486663, -50.25905612350664, -50.25907316691367, -50.25882901819737, -50.25907291607952, -50.25894269627299, -50.2591865985153, -50.25890586751016, -50.25899606286755, -50.25901954777512, 
  -50.25910974311391, -50.25885150957828, -50.25905042262702, -50.25896518985279, -50.25916410286382, -50.25876178884842, -50.2591401447201, -50.25887546746921, -50.25925382661067, -50.25892889653588, -50.25897303407642, -50.25904257678289, -50.25908671434072, -50.25891544353586, -50.25898648938991, -50.25902912380298, -50.25910016963413, -50.25900100434451, -50.25900126212349, -50.25901434761336, -50.25901460539299, -50.25900037021393, -50.25900189631867, -50.2590137134653, -50.25901523960571, -50.25898600305522, -50.25901626351384, -50.25899934633968, -50.25902960676773, -50.25900059405906, -50.25900167240914, -50.2590139373284, -50.25901501567818, -50.2590501433105, -50.25895212408683, -50.25906348657541, -50.25896546736027, -50.25899531139975, -50.25900695514857, -50.25900865466488, 
  -50.25902029842184, -50.25899261155, -50.2590096549626, -50.25900595481973, -50.25902299823124, -50.25887918552558, -50.25912308535502, -50.25889252856198, -50.25913642885697, -50.25895603585801, -50.25904623112335, -50.25896937904446, -50.25905957447527, -50.25890167788804, -50.25910059092089, -50.2589150211602, -50.25911393418709, -50.25881195642574, -50.25919031374643, -50.25882529950904, -50.25920365720149, -50.25897906482454, -50.25902320239141, -50.25899240811138, -50.2590365456429, -50.25896561184124, -50.25903665768816, -50.25897895511473, -50.25905000095303, -50.25900691295012, -50.25900843907282, -50.25900717072957, -50.259008696852, -50.25899254580791, -50.25902280625151, -50.25899280358747, -50.25902306403053, -50.25900713680424, -50.25900821515429, -50.25900739458368, 
  -50.25900847293347, -50.25905668604632, -50.25895866684133, -50.25905694384002, -50.25895892460625, -50.2590018541385, -50.25901349790014, -50.25900211192655}
 {-465.6037042298754, -465.6037039455369, -465.6037037211323, -465.6037047386336, -465.6037045142292, -465.603703850702, -465.6037038159672, -465.6037046437989, -465.6037046090638, -465.6037032663463, -465.6037044003258, -465.603704059444, -465.6037051934215, -465.603706450578, -465.603701216101, -465.6037072436751, -465.6037020091974, -465.6037038495603, -465.603703817109, -465.6037046426571, -465.6037046102057, -465.6037039348957, -465.6037037317736, -465.6037047279933, -465.6037045248694, -465.6037037662952, -465.603703900374, -465.6037045593918, -465.6037046934709, -465.603703802562, -465.6037038641069, -465.6037045956587, -465.6037046572037, -465.6036849422543, -465.603722725192, -465.6036857349316, -465.6037235187082, -465.6037012064132, -465.6037064603452, -465.6037019995182, 
  -465.6037072534337, -465.6037036060451, -465.6037040606242, -465.6037043991409, -465.6037048537218, -465.6037068317469, -465.603700834941, -465.6037076247809, -465.6037016281005, -465.6037089606412, -465.6036987060086, -465.603709753737, -465.6036994991061, -465.6037038366134, -465.6037038300559, -465.6037046297101, -465.6037046231527, -465.6037043594452, -465.6037043247103, -465.6037041350407, -465.6037041003058, -465.6037037750901, -465.6037049090683, -465.6037035506853, -465.6037046846642, -465.6037069593216, -465.6037017248437, -465.6037067349165, -465.6037015004396, -465.6037043583034, -465.6037043258521, -465.6037041338989, -465.6037041014477, -465.6037044436393, -465.6037042405163, -465.6037042192348, -465.6037040161118, -465.6037042750382, -465.6037044091172, -465.6037040506338, 
  -465.6037041847126, -465.6037043113051, -465.6037043728501, -465.6037040869006, -465.6037041484455, -465.6036854507853, -465.6037232341474, -465.6036852263857, -465.603723009738, -465.603701715167, -465.6037069690777, -465.6037014907495, -465.6037067446862, -465.6037041147878, -465.6037045693679, -465.6037038903834, -465.6037043449632, -465.6037073404576, -465.6037013437166, -465.6037071160553, -465.6037011193098, -465.6037094693839, -465.603699214752, -465.6037092449792, -465.6036989903477, -465.6037043453565, -465.603704338799, -465.603704120952, -465.6037041143945, -465.6037036802551, -465.6037048142336, -465.6037036455202, -465.6037047794987, -465.6037068644865, -465.6037016300091, -465.6037068297516, -465.6037015952743, -465.6037042634686, -465.6037042310173, -465.6037042287336, 
  -465.6037041962824, -465.6037043488042, -465.6037041456817, -465.6037043140698, -465.6037041109464, -465.6037041802035, -465.6037043142822, -465.6037041454685}
 {-270.5301383241674, -270.5301410085137, -270.5301415887759, -270.5301350595754, -270.5301356398492, -270.5301412911622, -270.5301413061265, -270.5301353422295, -270.5301353571941, -270.5301402547126, -270.5301423425788, -270.5301343057816, -270.5301363936448, -270.5301423665425, -270.5301402307726, -270.5301364176087, -270.5301342818414, -270.5301412969949, -270.5301413002938, -270.5301353480623, -270.5301353513613, -270.5301465998206, -270.5301359975493, -270.5301406508956, -270.5301300486094, -270.5301438732371, -270.530138724083, -270.5301379243044, -270.5301327751507, -270.530142850284, -270.5301397470475, -270.5301369013514, -270.530133798115, -270.5301550579827, -270.5301275408214, -270.5301491094927, -270.5301215914464, -270.5301515991408, -270.5301309983262, -270.5301456501953, 
  -270.5301250494066, -270.5301255436967, -270.5301570553382, -270.5301195947704, -270.5301511063994, -270.5301582935713, -270.5301243036287, -270.5301523446044, -270.5301183547306, -270.5301558776186, -270.5301267196263, -270.5301499286849, -270.5301207706948, -270.5300929382937, -270.5301896626779, -270.5300869893604, -270.5301837137461, -270.5301380265518, -270.5301380415162, -270.5301386068197, -270.5301386217842, -270.5301369901033, -270.5301390779675, -270.5301375703708, -270.5301396582359, -270.5301391019314, -270.530136966163, -270.5301396821996, -270.5301375464308, -270.5301380323845, -270.5301380356834, -270.5301386126525, -270.5301386159515, -270.5301433352135, -270.5301327329357, -270.5301439154824, -270.5301333132028, -270.5301406086266, -270.5301354594728, 
  -270.5301411888947, -270.5301360397407, -270.5301395856735, -270.530136482437, -270.5301401659416, -270.5301370627051, -270.530151793561, -270.5301242760223, -270.5301523738942, -270.5301248562252, -270.5301483345204, -270.5301277337258, -270.5301489147955, -270.5301283139868, -270.5301222790887, -270.5301537907255, -270.5301228593583, -270.5301543709919, -270.5301550289474, -270.5301210390319, -270.5301556092082, -270.5301216193072, -270.5301526130081, -270.5301234550159, -270.5301531932752, -270.530124035285, -270.530089673683, -270.5301863980677, -270.5300902539508, -270.5301869783359, -270.5301372727543, -270.530139360619, -270.5301372877187, -270.5301393755835, -270.5301393845827, -270.5301372488142, -270.5301393995472, -270.5301372637787, -270.5301383150359, -270.5301383183347, 
  -270.5301383300003, -270.5301383332992, -270.5301436178659, -270.530133015586, -270.5301436328292, -270.5301330305517, -270.5301408912779, -270.5301357421241, -270.5301409062425}
 {-194.0754979499619, -194.0754975814257, -194.0754978629356, -194.0754980370049, -194.0754983185196, -194.0754976939438, -194.0754977504174, -194.0754981495249, -194.0754982059994, -194.0754980635271, -194.0754973808374, -194.0754985191078, -194.07549783642, -194.0754999927766, -194.075495451593, -194.0755004483576, -194.0754959071751, -194.0754977363967, -194.0754977079644, -194.0754981919783, -194.0754981635461, -194.0754934788125, -194.0755019656551, -194.075493934401, -194.0755024212298, -194.0754970456023, -194.0754983987649, -194.0754975011837, -194.0754988543467, -194.0754992742344, -194.0754961701418, -194.0754997298161, -194.0754966257233, -194.0755101434295, -194.0754853015597, -194.0755105993628, -194.0754857567896, -194.0754947788431, -194.0755006655924, -194.0754952344144, 
  -194.0755011211844, -194.0755098779783, -194.0754855671313, -194.0755103335648, -194.075486022708, -194.0755022074428, -194.0754932369102, -194.0755026629731, -194.0754936925431, -194.0755035720533, -194.0754918722753, -194.0755040276349, -194.0754923278569, -194.0755101804051, -194.0754852638565, -194.0755106359861, -194.0754857194387, -194.0754977809689, -194.0754978374429, -194.0754980624812, -194.0754981189552, -194.075498150552, -194.0754974678631, -194.0754984320642, -194.0754977493756, -194.0755000798015, -194.0754955386187, -194.075500361314, -194.0754958201308, -194.075497823422, -194.0754977949898, -194.0754981049343, -194.0754980765021, -194.075493565841, -194.0755020526772, -194.0754938473538, -194.0755023341891, -194.0754971326274, -194.0754984857904, -194.07549741414, 
  -194.0754987673025, -194.0754993612598, -194.075496257167, -194.075499642772, -194.0754965386794, -194.0755102306226, -194.0754853884173, -194.0755105121511, -194.0754856699134, -194.0754948658594, -194.0755007526268, -194.0754951473794, -194.0755010341313, -194.0755099650057, -194.0754856541546, -194.0755102465188, -194.0754859356661, -194.0755022944442, -194.0754933239594, -194.0755025759529, -194.0754936054753, -194.0755036590787, -194.0754919593005, -194.0755039405908, -194.075492240813, -194.0755102674303, -194.075485350882, -194.0755105489423, -194.0754856323946, -194.075498263071, -194.0754975803823, -194.075498319545, -194.0754976368563, -194.0755001923207, -194.0754956511376, -194.0755002487947, -194.0754957076116, -194.0754979359411, -194.0754979075088, -194.075497992415, 
  -194.0754979639828, -194.0754936783603, -194.0755021651961, -194.0754937348344, -194.07550222167, -194.0754972451466, -194.0754985983094, -194.0754973016207}
 {-236.8171648595301, -236.817163016671, -236.817163633332, -236.8171660857419, -236.8171667024085, -236.8171632957506, -236.8171633542523, -236.8171663648241, -236.8171664233261, -236.817163258713, -236.8171633912898, -236.8171663277857, -236.8171664603645, -236.8171631615238, -236.8171634884783, -236.8171662305958, -236.8171665575537, -236.8171633213255, -236.8171633286773, -236.8171663903992, -236.817166397751, -236.8171633977392, -236.8171632522636, -236.817166466814, -236.8171663213362, -236.8171633613483, -236.8171632886545, -236.8171664304223, -236.8171663577278, -236.8171633516479, -236.8171632983551, -236.8171664207218, -236.8171663674286, -236.8171865579476, -236.8171400927209, -236.8171896274855, -236.8171431613302, -236.8171625396685, -236.8171641103351, -236.817165608737, 
  -236.817167179414, -236.8171635387926, -236.8171631112103, -236.8171666078675, -236.8171661802827, -236.8171644624435, -236.8171621876112, -236.8171675314316, -236.8171652567705, -236.8171633325568, -236.817163317446, -236.8171664016299, -236.8171663865203, -236.8171633255897, -236.8171633244132, -236.8171663946633, -236.8171663934869, -236.8171645219474, -236.8171645804492, -236.8171651386112, -236.8171651971131, -236.817164484909, -236.8171646174876, -236.8171651015735, -236.8171652341507, -236.817164387719, -236.8171647146769, -236.8171650043846, -236.817165331339, -236.8171645475224, -236.8171645548742, -236.8171651641862, -236.817165171538, -236.8171646239366, -236.81716447846, -236.8171652406005, -236.8171650951238, -236.8171645875454, -236.8171645148512, -236.8171652042093, 
  -236.817165131515, -236.8171645778449, -236.8171645245519, -236.8171651945087, -236.8171651412157, -236.8171877843646, -236.8171413186977, -236.8171884010525, -236.8171419353374, -236.8171637658583, -236.817165336539, -236.8171643825311, -236.817165953194, -236.8171647649901, -236.8171643374065, -236.8171653816538, -236.8171649540705, -236.8171656886017, -236.8171634138467, -236.8171663052572, -236.817164030519, -236.8171645587535, -236.8171645436431, -236.8171651754171, -236.8171651603071, -236.8171645517865, -236.81716455061, -236.8171651684503, -236.8171651672739, -236.8171647639902, -236.8171648965681, -236.8171648224921, -236.81716495507, -236.8171646668007, -236.8171649937569, -236.8171647253026, -236.8171650522588, -236.8171648266033, -236.8171648339551, -236.8171648851051, 
  -236.8171648924569, -236.8171649030171, -236.8171647575412, -236.8171649615198, -236.8171648160423, -236.817164866626, -236.8171647939323, -236.8171649251283}
 {-603.4421332934337, -603.4421252862693, -603.4421263403028, -603.4421402466043, -603.4421413006572, -603.4421258186351, -603.4421258079354, -603.4421407789798, -603.4421407682798, -603.442124713405, -603.4421269131746, -603.4421396737408, -603.4421418735282, -603.4421168820648, -603.4421347445647, -603.4421318424043, -603.4421497049144, -603.4421259284918, -603.4421256980786, -603.4421408888365, -603.4421406584234, -603.4421334308729, -603.4421181960314, -603.4421483912094, -603.442133156384, -603.4421355164185, -603.4421161102341, -603.4421504767653, -603.4421310705767, -603.4421292083266, -603.4421224182705, -603.4421441686712, -603.4421373786151, -603.4420416176213, -603.4422100112145, -603.4420565766256, -603.4422249728996, -603.4421339064812, -603.4421177203397, -603.4421488668443, 
  -603.442132680666, -603.4421306766238, -603.4421209517543, -603.4421456369512, -603.4421359121163, -603.442118978564, -603.4421326482741, -603.4421339385953, -603.442147608932, -603.4421154657771, -603.4421361611262, -603.4421304261238, -603.4421511214686, -603.4421398707666, -603.4421117561051, -603.4421548311106, -603.4421267164502, -603.4421327717628, -603.4421327610632, -603.4421338258062, -603.4421338151062, -603.4421316665286, -603.4421338663066, -603.4421327205711, -603.4421349203504, -603.4421238351909, -603.4421416976939, -603.4421248892322, -603.4421427517391, -603.4421328816196, -603.4421326512065, -603.4421339356627, -603.4421337052496, -603.4421403839987, -603.442125149161, -603.4421414380377, -603.4421262032081, -603.4421424695465, -603.4421230633616, -603.4421435235911, 
  -603.4421241174033, -603.4421361614544, -603.4421293713982, -603.4421372154976, -603.4421304254414, -603.4420485700976, -603.4422169649934, -603.4420496241032, -603.4422180190745, -603.4421408596363, -603.4421246734401, -603.4421419136431, -603.4421257275197, -603.4421376297461, -603.4421279048875, -603.4421386837829, -603.4421289589371, -603.4421259315435, -603.4421396015502, -603.4421269855699, -603.4421406556103, -603.4421224189051, -603.4421431142535, -603.4421234729499, -603.4421441682952, -603.4421468238945, -603.4421187092327, -603.4421478779368, -603.4421197632765, -603.4421321988988, -603.4421343986776, -603.4421321881991, -603.4421343879776, -603.4421243675605, -603.4421422300655, -603.4421243568609, -603.4421422193658, -603.4421334139902, -603.442133183577, 
  -603.4421334032904, -603.4421331728772, -603.4421409163667, -603.4421256815342, -603.442140905668, -603.4421256708333, -603.4421430019175, -603.4421235957318, -603.4421429912184}
 {-173.3240407616196, -173.3240369734143, -173.3240359845917, -173.3240455386793, -173.3240445498512, -173.3240363472938, -173.3240366107126, -173.324044912555, -173.324045175976, -173.3240384220049, -173.3240345360097, -173.3240469872559, -173.3240431012832, -173.3240414581156, -173.3240314999292, -173.3240500233776, -173.3240400651916, -173.324036579267, -173.3240363787395, -173.3240451445292, -173.3240449440018, -173.3240179839355, -173.3240549742226, -173.3240265492743, -173.3240635394085, -173.3240393560354, -173.3240336019642, -173.3240479212983, -173.3240421672259, -173.3240327341222, -173.324040223915, -173.3240412993861, -173.3240487891756, -173.3241322053322, -173.3239407555228, -173.324140771749, -173.3239493196306, -173.3240183004472, -173.3240546578639, -173.3240268657012, 
  -173.3240632231344, -173.3241074224933, -173.3239655373985, -173.3241159877716, -173.3239741026448, -173.3240275883715, -173.3240453699392, -173.3240361533855, -173.3240539354497, -173.3240449631757, -173.3240279948154, -173.3240535284409, -173.3240365600748, -173.3240164800417, -173.3240564798359, -173.3240250452935, -173.3240650451087, -173.324041124322, -173.324041387742, -173.3240401354967, -173.3240403989166, -173.3240431990293, -173.3240393130428, -173.3240422102014, -173.32403832422, -173.3240462351457, -173.3240362769565, -173.3240452463173, -173.3240352881342, -173.3240413562957, -173.3240411557682, -173.3240403674703, -173.324040166943, -173.3240227610018, -173.3240597512139, -173.3240217721779, -173.3240587623871, -173.3240441330606, -173.3240383789965, -173.324043144243, 
  -173.3240373901635, -173.3240375111516, -173.3240450009432, -173.3240365223266, -173.3240440121174, -173.3241369829426, -173.3239455319699, -173.3241359941083, -173.3239445431535, -173.3240230774549, -173.3240594349137, -173.3240220886634, -173.3240584460544, -173.3241121995266, -173.3239703144227, -173.3241112107082, -173.3239693255905, -173.324032365273, -173.3240501470951, -173.3240313764538, -173.3240491582636, -173.3240497402036, -173.324032771845, -173.324048751383, -173.324031783015, -173.3240212570686, -173.3240612568665, -173.3240202682365, -173.3240602680479, -173.3240425729056, -173.3240386869217, -173.3240428363256, -173.3240389503416, -173.3240456090218, -173.3240356508356, -173.3240458724417, -173.3240359142556, -173.3240407301733, -173.3240405296459, -173.3240409935933, 
  -173.3240407930658, -173.3240221348806, -173.3240591250904, -173.3240223982997, -173.3240593885111, -173.3240435069421, -173.3240377528703, -173.324043770362}
 {-16.73125543885785, -16.73125471358056, -16.73125473045802, -16.73125614725462, -16.73125616413207, -16.73125472013292, -16.73125472390566, -16.73125615380699, -16.7312561575797, -16.73125058439099, -16.7312588596712, -16.7312520180909, -16.73126029331939, -16.7312544649549, -16.7312549790982, -16.73125589862512, -16.73125641277608, -16.73125466364118, -16.73125478039741, -16.73125609731517, -16.73125621407152, -16.73124712645889, -16.7312623181331, -16.73124856018974, -16.73126375175034, -16.73125345753967, -16.73125598651786, -16.73125489121035, -16.73125742019528, -16.73125662641853, -16.73125281763854, -16.73125806009077, -16.73125425131442, -16.73125341258762, -16.73125603145294, -16.73125484627029, -16.73125746511838, -16.731262393414, -16.73124705071756, -16.73126382709935, 
  -16.73124848438032, -16.73126597695371, -16.73124346794101, -16.73126741065551, -16.73124490158731, -16.73125472489148, -16.73125471914712, -16.73125615856545, -16.73125615282126, -16.73125627156625, -16.73125317251777, -16.73125770522685, -16.73125460620529, -16.73126803001451, -16.73124141388485, -16.73126946367815, -16.73124284756931, -16.73125542853276, -16.73125543230548, -16.73125544541022, -16.73125544918294, -16.73125129280364, -16.73125956805821, -16.73125130968131, -16.73125958493546, -16.73125517335289, -16.73125568749987, -16.73125519023019, -16.73125570437748, -16.73125537204098, -16.73125548879727, -16.73125538891844, -16.73125550567472, -16.73124783488637, -16.73126302650527, -16.73124785176532, -16.73126304338124, -16.73125416593788, -16.7312566949193, -16.7312541828152, 
  -16.73125671179691, -16.73125733481749, -16.73125352603925, -16.73125735169487, -16.73125354291678, -16.73125412099177, -16.73125673984845, -16.7312541378692, -16.73125675672593, -16.73126310181888, -16.73124775911235, -16.73126311869753, -16.73124777598861, -16.73126668536697, -16.73124417632742, -16.73126670224532, -16.73124419320397, -16.73125543329127, -16.73125542754699, -16.73125545016872, -16.73125544442446, -16.73125697995955, -16.73125388092414, -16.73125699683662, -16.73125389780199, -16.73126873840928, -16.73124212228974, -16.73126875528644, -16.7312421391675, -16.73125129935606, -16.73125957461052, -16.73125130312889, -16.73125957838315, -16.73125517990518, -16.7312556940523, -16.7312551836779, -16.73125569782504, -16.73125537859335, -16.73125549534963, -16.73125538236607, 
  -16.73125549912236, -16.73124784143947, -16.73126303305691, -16.73124784521223, -16.7312630368296, -16.73125417249019, -16.73125670147174, -16.7312541762629}
 {-364.8338725663269, -364.8338765482269, -364.8338768286751, -364.8338683039964, -364.8338685844557, -364.8338766956697, -364.8338766812297, -364.8338684514447, -364.8338684370046, -364.8338754244135, -364.8338779524844, -364.8338671801905, -364.8338697082575, -364.8338650854521, -364.8338882914866, -364.8338568412252, -364.8338800472634, -364.833876742923, -364.8338766339762, -364.833868498698, -364.8338683897512, -364.8338778823795, -364.8338754945529, -364.8338696381491, -364.8338672503331, -364.8338788665332, -364.8338745104619, -364.8338706223085, -364.8338662662366, -364.8338805556714, -364.8338728212542, -364.8338723114462, -364.8338645770294, -364.8338753852651, -364.8338779933198, -364.8338671408377, -364.833869749297, -364.8338508765397, -364.833902500551, -364.8338426323197, 
  -364.8338942563209, -364.8338879073033, -364.8338654711375, -364.8338796630757, -364.833857226915, -364.833888513503, -364.8338648633281, -364.8338802692736, -364.8338566191074, -364.8338672763889, -364.8338861008294, -364.8338590321623, -364.8338778566058, -364.8338945412664, -364.8338588357588, -364.8338862970418, -364.8338505915333, -364.8338724333214, -364.8338724188814, -364.8338727137753, -364.8338726993352, -364.8338711620659, -364.8338736901356, -364.8338714425205, -364.8338739705885, -364.8338608231033, -364.8338840291391, -364.8338611035565, -364.8338843095933, -364.8338724805748, -364.833872371628, -364.8338727610286, -364.8338726520817, -364.8338736200301, -364.8338712322057, -364.8338739004807, -364.8338715126626, -364.8338746041852, -364.8338702481135, -364.8338748846389, 
  -364.8338705285673, -364.8338762933231, -364.833868558906, -364.8338765737767, -364.8338688393598, -364.8338711228799, -364.8338737310085, -364.8338714032052, -364.8338740115908, -364.8338466141928, -364.8338982382013, -364.8338468946489, -364.8338985186528, -364.833883644955, -364.8338612087894, -364.8338839254063, -364.8338614892455, -364.8338842511541, -364.8338606009805, -364.8338845316047, -364.8338608814374, -364.833863014041, -364.8338818384808, -364.8338632944925, -364.8338821189368, -364.8338902789181, -364.8338545734107, -364.8338905593724, -364.8338548538639, -364.8338713095118, -364.8338738375807, -364.8338712950717, -364.8338738231407, -364.8338609705484, -364.8338841765848, -364.8338609561085, -364.8338841621448, -364.8338726280203, -364.8338725190734, -364.8338726135803, 
  -364.8338725046334, -364.8338737674746, -364.8338713796521, -364.8338737530333, -364.8338713652134, -364.8338747516306, -364.833870395559, -364.8338747371907}
 {-303.4142386566917, -303.4142342878123, -303.4142306296405, -303.4142466837878, -303.4142430255953, -303.4142325279176, -303.4142323895344, -303.4142449238832, -303.4142447854991, -303.4142364138215, -303.4142285036376, -303.414248809771, -303.4142408996185, -303.4142298500682, -303.4142350674139, -303.4142422460376, -303.4142474633749, -303.414232404598, -303.414232512854, -303.4142448005631, -303.4142449088193, -303.4142378444614, -303.4142270731498, -303.4142502404111, -303.4142394691303, -303.4142303354291, -303.4142345820512, -303.4142427313946, -303.4142469780161, -303.4142345350194, -303.4142303824506, -303.4142469309843, -303.4142427784161, -303.4143138100205, -303.4141511092789, -303.4143262072969, -303.4141635039329, -303.4142084520668, -303.414256465597, -303.4142208480161, 
  -303.4142688615781, -303.414218634767, -303.4142462836278, -303.4142310307391, -303.414258679586, -303.4142254586303, -303.4142394590931, -303.4142378543188, -303.414251855335, -303.4142316158702, -303.4142333017438, -303.4142440118402, -303.4142456977041, -303.4142447564583, -303.4142201609022, -303.4142571524252, -303.4142325568656, -303.414240554975, -303.4142404165913, -303.4142368967928, -303.4142367584092, -303.4142444408707, -303.4142365307027, -303.4142407826887, -303.4142328725203, -303.4142378771317, -303.4142430944648, -303.4142342189411, -303.414239436291, -303.4142404316551, -303.4142405399112, -303.4142367734729, -303.414236881729, -303.414245871511, -303.4142351002145, -303.4142422133285, -303.4142314420326, -303.4142383624866, -303.4142426091079, -303.4142347043039, 
  -303.4142389509263, -303.4142425620763, -303.4142384095079, -303.4142389038943, -303.4142347513257, -303.4143218377724, -303.4141591356414, -303.414318179512, -303.4141554775373, -303.4142164790914, -303.4142644926868, -303.4142128209585, -303.4142608344554, -303.4142266618271, -303.414254310682, -303.4142230036459, -303.4142506524987, -303.4142334855283, -303.4142474863093, -303.4142298273877, -303.4142438280857, -303.4142396429295, -303.4142413287987, -303.4142359847478, -303.4142376706161, -303.4142527835159, -303.4142281879588, -303.4142491253346, -303.4142245297758, -303.4142426809711, -303.414234770803, -303.4142425425876, -303.4142346324193, -303.4142361172279, -303.4142413345692, -303.4142359788441, -303.4142411961858, -303.4142386717555, -303.4142387800115, -303.4142385333719, 
  -303.414238641628, -303.4142441116099, -303.4142333403163, -303.4142439732288, -303.4142332019301, -303.4142366025876, -303.4142408492077, -303.4142364642022}
 {-303.5999371521068, -303.5999399250433, -303.5999399129707, -303.5999343912612, -303.599934379191, -303.5999399289394, -303.5999399090743, -303.5999343951585, -303.5999343752934, -303.5999399133522, -303.5999399246631, -303.5999343795698, -303.5999343908836, -303.5999422685266, -303.5999375695051, -303.5999367347451, -303.5999320357248, -303.5999399422666, -303.5999398957472, -303.5999344084856, -303.5999343619662, -303.599941439538, -303.5999383984956, -303.5999359057533, -303.5999328647184, -303.5999411217893, -303.5999387162304, -303.5999355880086, -303.5999331824493, -303.5999417264578, -303.5999381115732, -303.5999361926768, -303.5999325777923, -303.5999296956696, -303.5999501437394, -303.5999241617554, -303.5999446100917, -303.5999339176322, -303.599945920532, -303.5999283838521, 
  -303.5999403867502, -303.599959608079, -303.5999202308775, -303.5999540742968, -303.5999146970979, -303.5999454814209, -303.5999343565654, -303.5999399476347, -303.5999288227898, -303.5999447834112, -303.5999350545894, -303.5999392496296, -303.5999295208092, -303.5999488485428, -303.5999309895337, -303.5999433147625, -303.5999254557523, -303.5999371680752, -303.5999371482101, -303.5999371560038, -303.5999371361387, -303.599937152488, -303.5999371637989, -303.5999371404153, -303.5999371517288, -303.5999395076623, -303.599934808641, -303.5999394955905, -303.59993479657, -303.5999371814024, -303.599937134883, -303.599937169331, -303.5999371228116, -303.5999386786721, -303.5999356376331, -303.5999386666004, -303.599935625562, -303.5999383609254, -303.5999359553659, -303.5999383488536, 
  -303.599935943295, -303.5999389655936, -303.599935350709, -303.5999389535221, -303.5999353386377, -303.5999269347491, -303.5999473829315, -303.5999269226571, -303.5999473708807, -303.59993115677, -303.5999431596657, -303.5999311446953, -303.5999431475976, -303.5999568472146, -303.5999174700136, -303.5999568351424, -303.599917457943, -303.5999427205543, -303.5999315957036, -303.5999427084824, -303.5999315836327, -303.5999420225474, -303.5999322937248, -303.5999420104746, -303.5999322816548, -303.5999460876787, -303.5999282286695, -303.5999460756078, -303.5999282165977, -303.5999371563839, -303.5999371676962, -303.5999371365189, -303.5999371478312, -303.5999395115588, -303.5999348125379, -303.5999394916937, -303.5999347926728, -303.599937185299, -303.5999371387796, -303.599937165434, 
  -303.5999371189146, -303.5999386825691, -303.5999356415293, -303.5999386627029, -303.5999356216654, -303.5999383648219, -303.5999359592627, -303.5999383449568}
 {-536.1321080638546, -536.1321035118033, -536.1321023594481, -536.1321137682793, -536.132112615917, -536.1321028909638, -536.132102980288, -536.132113147436, -536.1321132367609, -536.132104780574, -536.1321010906829, -536.1321150370352, -536.1321113471666, -536.1321044455931, -536.1321014256784, -536.1321147020654, -536.132111682151, -536.1321029733968, -536.132102897855, -536.1321132298693, -536.1321131543276, -536.1320965965359, -536.1321092748779, -536.1321068530328, -536.1321195313259, -536.1321042730095, -536.1321015982518, -536.1321145294825, -536.1321118547238, -536.1321049866901, -536.1321008845798, -536.1321152431632, -536.1321111410517, -536.1320384553698, -536.1321674173078, -536.1320487110989, -536.1321776745237, -536.1321156141701, -536.1320902572343, -536.1321258706484, 
  -536.1321005137009, -536.1320861141875, -536.1321197580073, -536.1320963706497, -536.1321300144898, -536.1320917811634, -536.1321140903611, -536.1321020374364, -536.132124347033, -536.132104600105, -536.1321012711862, -536.1321148565812, -536.1321115276551, -536.1321138013818, -536.1320920698437, -536.1321240578509, -536.1321023263197, -536.1321085953714, -536.1321086846959, -536.1321074430127, -536.1321075323372, -536.1321104849768, -536.1321067950954, -536.1321093326164, -536.1321056427384, -536.1321101500025, -536.1321071300843, -536.1321089976402, -536.1321059777294, -536.1321086778046, -536.1321086022627, -536.1321075254458, -536.1321074499041, -536.1321023009562, -536.132114979273, -536.1321011485967, -536.1321138269151, -536.1321099774161, -536.1321073026606, -536.1321088250602, 
  -536.1321061502991, -536.132110691098, -536.1321065889873, -536.1321095387394, -536.1321054366284, -536.1320441593982, -536.1321731220949, -536.1320430070547, -536.132171969721, -536.1321213185918, -536.1320959616279, -536.1321201662107, -536.1320948092916, -536.1320918185923, -536.1321254624178, -536.1320906662291, -536.1321243100635, -536.1320974854666, -536.1321197948731, -536.1320963331174, -536.132118642505, -536.1321103045128, -536.1321069755938, -536.1321091521576, -536.1321058232316, -536.132119505789, -536.132097774252, -536.132118353428, -536.1320966218956, -536.1321098641347, -536.132106174255, -536.1321099534591, -536.1321062635794, -536.1321095291594, -536.1321065092449, -536.1321096184838, -536.1321065985694, -536.1321080569633, -536.1321079814216, -536.1321081462878, 
  -536.132108070746, -536.1321016801144, -536.1321143584322, -536.1321017694392, -536.1321144477564, -536.1321093565762, -536.1321066818179, -536.1321094459006}
 {-145.7748752561546, -145.7748633873588, -145.774863134775, -145.7748873776078, -145.7748871250216, -145.7748631486231, -145.7748633735108, -145.7748871388698, -145.7748873637598, -145.7748648011442, -145.7748617210045, -145.7748887913886, -145.7748857112558, -145.7748661096586, -145.7748604124818, -145.7748900999065, -145.7748844027294, -145.7748632961387, -145.7748632259952, -145.7748872863865, -145.774887216243, -145.7748506113671, -145.7748759112745, -145.7748746016302, -145.7748999015071, -145.7748637132517, -145.7748628088864, -145.774887703499, -145.7748867991348, -145.7748657644101, -145.7748607577457, -145.7748897546582, -145.7748847479932, -145.7749128107848, -145.7748137122713, -145.7749368021457, -145.7748377014061, -145.774855108546, -145.7748714136976, -145.7748790987661, 
  -145.7748954039731, -145.7748834741261, -145.7748430491582, -145.7749074643867, -145.7748670393932, -145.774859100553, -145.7748674218024, -145.7748830904422, -145.7748914124088, -145.7748742449789, -145.7748522771016, -145.7748982352268, -145.7748762673494, -145.774889039364, -145.774837482531, -145.7749130296103, -145.7748614727803, -145.7748752700027, -145.7748754948915, -145.7748750174176, -145.7748752423065, -145.7748769225224, -145.7748738423866, -145.7748766699378, -145.7748735898011, -145.7748782310389, -145.7748725338618, -145.7748779784536, -145.7748722812769, -145.7748754175189, -145.7748753473754, -145.7748751649338, -145.7748750947903, -145.7748627327552, -145.7748880326467, -145.7748624801695, -145.7748877800623, -145.7748758346312, -145.7748749302673, -145.774875582047, 
  -145.7748746776813, -145.7748778857904, -145.7748728791257, -145.7748776332053, -145.7748726265407, -145.7749249327225, -145.774825833094, -145.7749246801354, -145.7748255805109, -145.7748672298951, -145.7748835351088, -145.7748669773444, -145.7748832824894, -145.7748955955121, -145.7748551705326, -145.7748953429282, -145.7748549179463, -145.7748712217529, -145.774879543363, -145.7748709691699, -145.7748792907758, -145.7748863663588, -145.7748643984821, -145.7748861137744, -145.7748641458964, -145.7749011607438, -145.7748496039116, -145.774900908158, -145.7748493513273, -145.7748766837858, -145.7748736036495, -145.7748769086746, -145.7748738285383, -145.7748779923019, -145.774872295125, -145.7748782171907, -145.7748725200138, -145.774875178782, -145.7748751086384, -145.7748754036708, 
  -145.7748753335273, -145.7748624940172, -145.7748877939109, -145.7748627189076, -145.7748880187982, -145.7748755958947, -145.7748746915299, -145.7748758207836}
 {-367.1790464864868, -367.1790472957137, -367.1790472646123, -367.179045708362, -367.1790456772608, -367.1790472524641, -367.179047307862, -367.1790456651128, -367.1790457205101, -367.1790472183177, -367.1790473420082, -367.1790456309662, -367.1790457546567, -367.1790477642229, -367.1790467961043, -367.1790461768713, -367.1790452087528, -367.1790473971428, -367.1790471631833, -367.1790458097912, -367.1790455758317, -367.1790472763016, -367.1790472840244, -367.17904568895, -367.1790456966728, -367.1790472781634, -367.1790472821626, -367.1790456908119, -367.1790456948109, -367.1790472521496, -367.1790473081763, -367.179045664798, -367.1790457208247, -367.1790490524854, -367.1790455080742, -367.1790474651367, -367.1790439207197, -367.1790452145977, -367.1790493457555, -367.1790436272469, 
  -367.1790477584032, -367.1790471774904, -367.1790473828357, -367.1790455901386, -367.1790457954843, -367.1790532861015, -367.1790412741886, -367.1790516987508, -367.1790396868363, -367.179052423659, -367.1790421366468, -367.1790508363075, -367.1790405492953, -367.179047281506, -367.1790472788198, -367.1790456941545, -367.1790456914683, -367.1790464743387, -367.1790465297364, -367.1790464432375, -367.179046498635, -367.1790464401924, -367.1790465638828, -367.179046409091, -367.1790465327816, -367.1790469860974, -367.1790460179789, -367.1790469549961, -367.1790459868776, -367.1790466190173, -367.1790463850579, -367.1790465879161, -367.1790463539566, -367.1790464981761, -367.1790465058989, -367.1790464670748, -367.1790464747976, -367.179046500038, -367.1790465040371, -367.1790464689367, 
  -367.1790464729358, -367.1790464740242, -367.1790465300508, -367.1790464429229, -367.1790464989495, -367.1790482743639, -367.1790447299449, -367.1790482432577, -367.1790446988484, -367.1790444364721, -367.1790485676303, -367.179044405372, -367.1790485365278, -367.1790463993649, -367.1790466047104, -367.1790463682636, -367.1790465736091, -367.1790525079763, -367.179040496063, -367.1790524768754, -367.1790404649614, -367.1790516455336, -367.1790413585214, -367.1790516144323, -367.1790413274201, -367.1790465033806, -367.1790465006945, -367.1790464722793, -367.1790464695932, -367.1790463969429, -367.1790465206334, -367.1790464523405, -367.1790465760311, -367.179046942848, -367.1790459747295, -367.1790469982456, -367.1790460301271, -367.179046575768, -367.1790463418084, -367.1790466311656, 
  -367.179046397206, -367.1790464549268, -367.1790464626495, -367.1790465103243, -367.1790465180472, -367.1790464567886, -367.1790464607876, -367.1790465121862}
 {-311.6849489654276, -311.6849344386946, -311.6849370305999, -311.6849609002939, -311.6849634922193, -311.6849358026031, -311.6849356666914, -311.6849622642134, -311.6849621283, -311.6849334968037, -311.6849379725097, -311.6849599584238, -311.6849644341082, -311.6849419348434, -311.684929534499, -311.6849683964495, -311.6849559961117, -311.6849357715755, -311.6849356977192, -311.6849622331849, -311.6849621593287, -311.6849548600902, -311.6849166095542, -311.6849813216137, -311.6849430712496, -311.6849391362293, -311.684932333079, -311.6849655978394, -311.6849587946877, -311.684939382428, -311.6849320869006, -311.6849658440355, -311.684958548512, -311.6847927768975, -311.6850786961334, -311.6848192362919, -311.6851051599579, -311.6849260611377, -311.6849454085668, -311.6849525227664, 
  -311.6849718701569, -311.6849781448613, -311.6848933263191, -311.6850046064505, -311.6849197879487, -311.6849205537933, -311.6849509159915, -311.6849470148781, -311.6849773781255, -311.684951376242, -311.6849200929892, -311.6849778378438, -311.6849465546064, -311.6849511409781, -311.6849203285541, -311.6849776025966, -311.6849467901546, -311.684947737426, -311.6849476015135, -311.6849503293414, -311.6849501934287, -311.6849454316311, -311.6849499073269, -311.684948023547, -311.6849524992417, -311.6849538696604, -311.6849414693269, -311.6849564615833, -311.6849440612345, -311.6849477063979, -311.6849476325417, -311.6849502983132, -311.6849502244569, -311.6849667948729, -311.6849285444165, -311.6849693867819, -311.6849311363379, -311.6849510710549, -311.6849442678983, -311.6849536629646, 
  -311.6849468598191, -311.6849513172498, -311.6849440217237, -311.6849539091645, -311.6849466136395, -311.6848047106593, -311.6850906320165, -311.6848073024808, -311.6850932240255, -311.684937996, -311.6849573433494, -311.684940587855, -311.684959935325, -311.6849900796769, -311.6849052611483, -311.6849926715856, -311.6849078530702, -311.6849324883729, -311.6849628510567, -311.6849350802493, -311.6849654430109, -311.6849633110601, -311.6849320278161, -311.6849659029765, -311.6849346197303, -311.684963075803, -311.6849322633743, -311.6849656677225, -311.6849348552853, -311.6849467955455, -311.6849512712408, -311.684946659633, -311.6849511353281, -311.6849552335782, -311.6849428332372, -311.6849550976659, -311.6849426973245, -311.6849490703119, -311.6849489964557, -311.6849489343994, 
  -311.6849488605431, -311.6849681587817, -311.6849299083358, -311.6849680228733, -311.684929772419, -311.6849524349655, -311.6849456318157, -311.6849522990541}
 {-231.7285396578451, -231.7285390724928, -231.728538222233, -231.7285410934717, -231.7285402432035, -231.7285384830842, -231.7285388116411, -231.7285405040574, -231.7285408326173, -231.7285385580475, -231.7285387366795, -231.7285405790222, -231.7285407576542, -231.7285398705719, -231.7285374241689, -231.7285418915467, -231.7285394451434, -231.728538615274, -231.7285386794514, -231.7285406362486, -231.7285407004261, -231.7285386737379, -231.7285386209874, -231.7285406947129, -231.7285406419617, -231.728538619815, -231.7285386749103, -231.7285406407894, -231.7285406958852, -231.7285387176077, -231.7285385771178, -231.728540738583, -231.7285405980919, -231.7285484217109, -231.7285288732806, -231.7285504429045, -231.7285308940364, -231.7285384461583, -231.728538848598, -231.7285404671272, 
  -231.7285408695786, -231.728538835318, -231.7285384594075, -231.7285408562943, -231.7285404803806, -231.7285424642209, -231.7285348305083, -231.72854448515, -231.7285368515286, -231.7285446646519, -231.7285326300374, -231.7285466856266, -231.7285346510122, -231.7285386488186, -231.7285386459067, -231.7285406697933, -231.7285406668813, -231.728539918698, -231.7285402472568, -231.7285390684344, -231.7285393969925, -231.7285399936623, -231.7285401722942, -231.7285391433983, -231.7285393220302, -231.7285413061868, -231.7285388597834, -231.7285404559227, -231.7285380095196, -231.7285400508887, -231.7285401150662, -231.7285392006247, -231.7285392648022, -231.7285401093528, -231.7285400566019, -231.7285392590887, -231.728539206338, -231.7285400554295, -231.7285401105251, -231.7285392051656, 
  -231.7285392602611, -231.7285401532227, -231.7285400127322, -231.7285393029587, -231.7285391624683, -231.7285498574463, -231.7285303087746, -231.7285490071598, -231.7285294585331, -231.7285398817658, -231.72854028422, -231.7285390315104, -231.7285394339474, -231.7285402709337, -231.7285398950212, -231.7285394206693, -231.7285390447576, -231.7285438998076, -231.7285362661509, -231.7285430495539, -231.7285354158768, -231.7285461002666, -231.7285340656521, -231.7285452500026, -231.7285332153882, -231.7285400844333, -231.7285400815214, -231.7285392341694, -231.7285392312574, -231.7285394042508, -231.7285395828828, -231.7285397328093, -231.7285399114412, -231.7285407167753, -231.7285382703721, -231.7285410453337, -231.7285385989305, -231.7285394614772, -231.7285395256548, -231.7285397900357, 
  -231.7285398542132, -231.7285395199412, -231.7285394671907, -231.7285398485, -231.7285397957488, -231.7285394660183, -231.7285395211136, -231.7285397945765}
 {-24.06924823033513, -24.06924823335168, -24.06924823331581, -24.06924822735444, -24.06924822731857, -24.06924823335627, -24.06924823331122, -24.06924822735903, -24.06924822731397, -24.06924899140652, -24.06924747527128, -24.06924898540864, -24.06924746927468, -24.06924834052071, -24.06924812614744, -24.06924833452353, -24.06924812015014, -24.06924824125996, -24.06924822540753, -24.06924823526272, -24.06924821941029, -24.0692446000751, -24.06925186700642, -24.06924459407901, -24.06925186100803, -24.06924841879499, -24.06924804787365, -24.06924841279779, -24.06924804187636, -24.06924856574736, -24.06924790092234, -24.06924855975004, -24.06924789492518, -24.06924831428696, -24.06924815238164, -24.06924830828959, -24.06924814638453, -24.0692473092074, -24.069249157472, -24.06924730321033, 
  -24.06924915147458, -24.06925036847563, -24.06924609834323, -24.06925036247903, -24.06924609234534, -24.06924823359826, -24.06924823306923, -24.06924822760102, -24.06924822707199, -24.0692539514922, -24.06924251514476, -24.06925394549514, -24.06924250914734, -24.06926322106548, -24.06923324538535, -24.06926321506795, -24.06923323938839, -24.06924823037559, -24.06924823033053, -24.06924823033971, -24.06924823029466, -24.06924898842551, -24.06924747229092, -24.06924898838965, -24.06924747225504, -24.06924833754005, -24.06924812316673, -24.06924833750418, -24.06924812313085, -24.06924823827928, -24.06924822242685, -24.0692482382434, -24.06924822239097, -24.069244597095, -24.06925186402515, -24.06924459705911, -24.0692518639893, -24.06924841581433, -24.06924804489294, -24.06924841577845, 
  -24.06924804485707, -24.06924856276663, -24.0692478979417, -24.06924856273076, -24.06924789790582, -24.0692483113062, -24.06924814940102, -24.06924831127033, -24.06924814936515, -24.0692473062268, -24.06924915449122, -24.06924730619092, -24.06924915445535, -24.06925036549527, -24.06924609536222, -24.06925036545938, -24.06924609532635, -24.06924823061757, -24.06924823008855, -24.0692482305817, -24.06924823005267, -24.0692539485116, -24.06924251216398, -24.06925394847573, -24.06924251212812, -24.06926321808465, -24.06923324240481, -24.06926321804878, -24.06923324236893, -24.06924898843011, -24.06924747229551, -24.06924898838505, -24.06924747225045, -24.06924833754464, -24.06924812317132, -24.06924833749959, -24.06924812312627, -24.06924823828386, -24.06924822243144, -24.06924823823881, 
  -24.06924822238638, -24.06924459709959, -24.06925186402975, -24.06924459705453, -24.0692518639847, -24.06924841581891, -24.06924804489753, -24.06924841577386}
 {-237.3005092898068, -237.3005089136131, -237.3005092698494, -237.3005093097807, -237.3005096660237, -237.3005090475303, -237.300509135932, -237.3005094437007, -237.3005095321035, -237.3005075279064, -237.3005106555583, -237.3005079240809, -237.3005110517256, -237.300507916738, -237.3005102667375, -237.3005083129084, -237.3005106629089, -237.300509039257, -237.3005091442054, -237.3005094354279, -237.3005095403763, -237.3005038474327, -237.3005143361485, -237.3005042436094, -237.3005147323137, -237.3005079229157, -237.3005102605629, -237.300508319086, -237.3005106567343, -237.3005116945869, -237.3005064888968, -237.3005120907579, -237.3005068850676, -237.3005264025443, -237.3004917818075, -237.3005267992002, -237.3004921774934, -237.3005165529218, -237.3005016306462, -237.3005169490801, 
  -237.3005020268298, -237.3005275446027, -237.3004906399666, -237.3005279407793, -237.3004910361318, -237.3005182953183, -237.3004998881231, -237.3005186914206, -237.3005002843628, -237.3005010396653, -237.3005171440902, -237.3005014358344, -237.3005175402629, -237.300535642252, -237.3004825409352, -237.3005360384223, -237.3004829371067, -237.300509067486, -237.3005091558882, -237.3005094237256, -237.3005095121279, -237.3005075478646, -237.300510675512, -237.3005079041033, -237.3005110317525, -237.3005079366936, -237.3005102866939, -237.3005082929335, -237.3005106429331, -237.3005090592129, -237.3005091641613, -237.3005094154526, -237.300509520401, -237.300503867392, -237.3005143561012, -237.3005042236308, -237.3005147123417, -237.3005079428713, -237.3005102805193, -237.3005082991111, 
  -237.3005106367587, -237.3005117145429, -237.3005065088527, -237.3005120707826, -237.3005068650924, -237.3005264227326, -237.3004918015312, -237.3005267789925, -237.3004921577504, -237.300516572865, -237.3005016506151, -237.3005169291177, -237.3005020068416, -237.3005275645613, -237.30049065992, -237.3005279208014, -237.3004910161591, -237.3005183152424, -237.300499908111, -237.3005186714772, -237.3005002643556, -237.3005010596204, -237.3005171640471, -237.30050141586, -237.3005175202866, -237.3005356622077, -237.3004825608914, -237.3005360184473, -237.3004829171312, -237.3005076817827, -237.300510809431, -237.300507770185, -237.3005108978332, -237.3005080706123, -237.3005104206123, -237.3005081590144, -237.3005105090145, -237.3005091931315, -237.3005092980799, -237.3005092815338, 
  -237.3005093864821, -237.3005040013101, -237.3005144900202, -237.3005040897123, -237.3005145784224, -237.30050807679, -237.3005104144377, -237.3005081651921}
 {-410.5386424725758, -410.5386456798884, -410.53864398552, -410.5386409597034, -410.5386392653376, -410.5386447333576, -410.5386449320497, -410.5386400131731, -410.538640211867, -410.5386450898197, -410.5386445755981, -410.5386403696348, -410.5386398554158, -410.5386549022072, -410.5386347632542, -410.5386501820227, -410.5386300430713, -410.5386449030362, -410.5386447623712, -410.5386401828525, -410.5386400421875, -410.5386381090506, -410.538651556482, -410.5386333888764, -410.5386468362887, -410.5386444479185, -410.5386452175042, -410.538639727735, -410.5386404973205, -410.538648627576, -410.5386410378625, -410.5386439073929, -410.5386363176783, -410.5385575433736, -410.5387321265455, -410.5385528215798, -410.5387274079719, -410.5386499250789, -410.5386397408354, -410.5386452049228, 
  -410.5386350206241, -410.5386182926546, -410.5386713744238, -410.5386135724634, -410.5386666542477, -410.5386560656889, -410.5386336001005, -410.5386513452821, -410.5386288801401, -410.5386654127973, -410.5386242528248, -410.5386606926116, -410.5386195326433, -410.5386848794146, -410.538604785572, -410.5386801592302, -410.538600065389, -410.5386432204133, -410.5386434191064, -410.5386415260462, -410.5386417247393, -410.5386435768766, -410.5386430626536, -410.5386418825067, -410.5386413682891, -410.5386533892633, -410.5386332503106, -410.5386516948956, -410.5386315559439, -410.5386433900923, -410.5386432494274, -410.5386416957252, -410.5386415550602, -410.5386365961114, -410.5386500435336, -410.5386349017445, -410.5386483491661, -410.5386429349744, -410.5386437045607, -410.5386412406078, 
  -410.538642010193, -410.5386471146324, -410.5386395249186, -410.5386454202653, -410.5386378305512, -410.5385560296388, -410.5387306143928, -410.5385543352439, -410.5387289200534, -410.5386484121759, -410.5386382278509, -410.5386467177547, -410.5386365335375, -410.5386167797072, -410.5386698614838, -410.5386150853397, -410.5386681671167, -410.5386545526244, -410.5386320872775, -410.5386528582755, -410.538630392892, -410.5386638998534, -410.5386227398812, -410.5386622054842, -410.538621045516, -410.5386833664708, -410.5386032726285, -410.5386816721031, -410.5386015782615, -410.5386426303447, -410.5386421161242, -410.5386428290378, -410.5386423148174, -410.5386524427324, -410.5386323037801, -410.5386526414255, -410.5386325024733, -410.5386424435617, -410.5386423028968, -410.5386426422548, 
  -410.5386425015899, -410.5386356495814, -410.5386490970021, -410.5386358482734, -410.5386492956964, -410.5386419884443, -410.5386427580295, -410.538642187137}
 {-417.4420577157293, -417.4420588915213, -417.4420589850714, -417.4420564463897, -417.4420565399439, -417.442058939463, -417.4420589371292, -417.4420564943334, -417.4420564919997, -417.4420578581378, -417.4420600184545, -417.4420554130088, -417.4420575733244, -417.4420540153743, -417.4420638612323, -417.4420515702446, -417.442061416103, -417.4420589423887, -417.4420589342034, -417.4420564972592, -417.442056489074, -417.4420568644822, -417.4420610121297, -417.442054419354, -417.4420585669989, -417.442056307345, -417.4420615692723, -417.4420538622154, -417.4420591241429, -417.4420610630587, -417.4420568135433, -417.4420586179291, -417.4420543684138, -417.4420608063764, -417.4420570706416, -417.4420583611619, -417.4420546255972, -417.4420479649713, -417.442069911672, -417.4420455198453, 
  -417.4420674665389, -417.4420447980028, -417.4420730791607, -417.4420423528717, -417.4420706340326, -417.4420649362134, -417.442052940343, -417.4420624910807, -417.4420504952167, -417.4420473571678, -417.4420705197083, -417.442044912038, -417.442068074579, -417.442069664758, -417.4420482118149, -417.4420672196284, -417.4420457666855, -417.4420576701205, -417.4420576677866, -417.4420577636725, -417.4420577613387, -417.4420565887956, -417.4420587491115, -417.4420566823473, -417.4420588426638, -417.4420527460317, -417.4420625918899, -417.4420528395837, -417.4420626854419, -417.4420576730462, -417.4420576648609, -417.4420577665982, -417.4420577584129, -417.4420555951405, -417.4420597427863, -417.4420556886922, -417.4420598363387, -417.4420550380024, -417.4420602999298, -417.4420551315544, 
  -417.4420603934818, -417.4420597937162, -417.4420555442008, -417.4420598872682, -417.4420556377529, -417.4420595370053, -417.4420558013277, -417.4420596305295, -417.4420558949075, -417.4420466956303, -417.4420686423278, -417.4420467891826, -417.4420687358795, -417.4420435286597, -417.4420718098186, -417.4420436222112, -417.4420719033712, -417.4420636668699, -417.4420516710014, -417.4420637604206, -417.4420517645547, -417.4420460878252, -417.4420692503658, -417.4420461813772, -417.4420693439179, -417.4420683954154, -417.4420469424724, -417.4420684889675, -417.4420470360245, -417.4420566367382, -417.4420587970543, -417.4420566344043, -417.4420587947205, -417.4420527939743, -417.4420626398326, -417.4420527916405, -417.4420626374987, -417.4420577209888, -417.4420577128036, 
  -417.4420577186551, -417.4420577104697, -417.4420556430832, -417.442059790729, -417.4420556407491, -417.4420597883955, -417.442055085945, -417.4420603478724, -417.4420550836112}
 {-195.8145905689645, -195.8145737832594, -195.8145714273567, -195.8146097106802, -195.8146073547618, -195.8145724485071, -195.8145727621082, -195.8146083759191, -195.8146086895221, -195.8145772811763, -195.8145679294627, -195.8146132085817, -195.8146038568833, -195.8145749343173, -195.8145702763735, -195.8146108617348, -195.814606203782, -195.814572735929, -195.8145724746863, -195.8146086633419, -195.8146084020994, -195.8145639048643, -195.8145813064559, -195.8145998323239, -195.8146172338224, -195.8145779648245, -195.8145672458498, -195.8146138922374, -195.8146031732629, -195.814579423061, -195.8145657876156, -195.8146153504744, -195.8146017150282, -195.8147218619028, -195.8144233523312, -195.8147577919488, -195.8144592771112, -195.8145611376004, -195.8145840735676, -195.8145970649733, 
  -195.8146200010207, -195.814603561323, -195.8145416528932, -195.814639488765, -195.8145775802771, -195.8145596860157, -195.8145855251234, -195.8145956127707, -195.8146214531944, -195.8145828485935, -195.8145623622, -195.8146187760048, -195.8145982896146, -195.8146130725266, -195.814532138122, -195.8146489999332, -195.8145680655415, -195.8145915901191, -195.8145919037212, -195.8145892342086, -195.8145895478105, -195.8145964227852, -195.8145870710788, -195.8145940668743, -195.8145847151686, -195.8145940759342, -195.8145894179817, -195.8145917200195, -195.8145870620753, -195.8145918775414, -195.8145916162989, -195.8145895216309, -195.8145892603882, -195.814583046502, -195.8146004480432, -195.8145806905876, -195.8145980921365, -195.8145971064356, -195.8145863874637, -195.8145947505277, 
  -195.8145840315505, -195.814598564674, -195.8145849292276, -195.8145962087628, -195.8145825733176, -195.8147410048393, -195.8144424926197, -195.8147386489138, -195.8144401367241, -195.8145802791517, -195.8146032152413, -195.8145779233234, -195.8146008592484, -195.8146227029479, -195.8145607944933, -195.8146203470416, -195.8145584385784, -195.814578827288, -195.8146046670762, -195.8145764713998, -195.8146023111432, -195.814601990204, -195.8145815038145, -195.8145996342958, -195.8145791479015, -195.8146322141368, -195.8145512797369, -195.8146298582245, -195.8145489238281, -195.8145950880284, -195.8145857363224, -195.8145954016303, -195.8145860499243, -195.8145927411755, -195.8145880832272, -195.8145930547775, -195.8145883968291, -195.8145905427849, -195.8145902815422, -195.8145908563868, 
  -195.8145905951442, -195.8145817117412, -195.8145991132908, -195.8145820253477, -195.8145994268882, -195.8145957716804, -195.8145850527057, -195.8145960852822}
 {-92.0468509749066, -92.0468742466274, -92.0468793384652, -92.0468226114541, -92.0468277032587, -92.0468767644977, -92.0468768205943, -92.0468251293068, -92.0468251854054, -92.0468753336815, -92.0468782514208, -92.0468236984912, -92.0468266162313, -92.0468825653897, -92.0468710197379, -92.0468309302015, -92.0468193845463, -92.0468767640453, -92.0468768210467, -92.0468251288553, -92.046825185857, -92.0469327657395, -92.0468208195231, -92.0468811305015, -92.0467691843813, -92.0468588951422, -92.0468946899641, -92.0468072599546, -92.046843054772, -92.0468712925951, -92.0468822926669, -92.0468196574052, -92.046830657477, -92.0468197908622, -92.0469337953839, -92.046768155263, -92.0468821606033, -92.04688603811, -92.0468675471217, -92.0468344029013, -92.0468159119506, -92.046797205874, 
  -92.0469563808415, -92.0467455706919, -92.0469047456438, -92.0468509318414, -92.0469026539948, -92.0467992971683, -92.046851018288, -92.0468971202796, -92.0468564647285, -92.0468454850906, -92.0468048295376, -92.0467019540496, -92.0470516410628, -92.046650318864, -92.0470000058686, -92.0468484009476, -92.046848457045, -92.0468534927686, -92.0468535488664, -92.0468469701335, -92.0468498878695, -92.046852061951, -92.0468549796944, -92.0468542018396, -92.0468426561886, -92.0468592936633, -92.0468477480073, -92.0468484004957, -92.046848457497, -92.0468534923166, -92.0468535493184, -92.0469044021608, -92.0467924560025, -92.046909493992, -92.0467975478137, -92.0468305315907, -92.0468663264162, -92.0468356234178, -92.0468714182316, -92.0468429290454, -92.0468539291173, -92.0468480208667, 
  -92.0468590209384, -92.046791427137, -92.0469054320097, -92.0467965189, -92.0469105238892, -92.0468576745709, -92.0468391835615, -92.0468627663522, -92.0468442754226, -92.0467688423295, -92.0469280172867, -92.0467739341481, -92.0469331091105, -92.0468225685811, -92.0468742901557, -92.0468276603403, -92.0468793820389, -92.0468687567287, -92.04682810118, -92.0468738485532, -92.0468331929979, -92.0466735905052, -92.0470232775078, -92.0466786823201, -92.0470283693353, -92.0468494879931, -92.0468524057328, -92.0468495440908, -92.0468524618304, -92.0468567197023, -92.0468451740488, -92.0468567758, -92.0468452301465, -92.046850918357, -92.0468509753586, -92.0468509744547, -92.0468510314563, -92.0469069200317, -92.0467949738545, -92.0469069761204, -92.0467950299611, -92.0468330494544, 
  -92.0468688442755, -92.0468331055534}
 {-274.3113978295724, -274.3114065069881, -274.3114056668708, -274.311389992322, -274.3113891522035, -274.3114060615986, -274.3114061122593, -274.3113895469315, -274.3113895975931, -274.3114076554602, -274.3114045184023, -274.3113911407856, -274.3113880037435, -274.3114143385805, -274.3113978353283, -274.3113978239133, -274.311381320662, -274.3114061724702, -274.311406001388, -274.3113896578034, -274.3113894867213, -274.3114013523658, -274.311410821593, -274.3113848377153, -274.3113943069101, -274.311408203014, -274.3114039708687, -274.3113916883472, -274.3113874562021, -274.3114128040256, -274.3113993698932, -274.3113962893591, -274.3113828552262, -274.3114455281015, -274.3113666496958, -274.3114290140992, -274.3113501343648, -274.3113822446818, -274.3114299296198, -274.3113657300045, 
  -274.3114134149638, -274.311441311117, -274.3113708662102, -274.311424796459, -274.3113543515347, -274.3114280038698, -274.3113841698837, -274.311411489162, -274.3113676552581, -274.3114241439267, -274.3113880299006, -274.3114076292609, -274.311371515233, -274.3114481846376, -274.3113639891792, -274.3114316699695, -274.3113474745139, -274.3113982243013, -274.3113982749624, -274.3113973841834, -274.3113974348446, -274.3113998181607, -274.3113966811074, -274.3113989780396, -274.3113958409928, -274.3114065012844, -274.3113899980298, -274.3114056611638, -274.3113891579148, -274.3113983351729, -274.3113981640907, -274.311397495055, -274.3113973239729, -274.3113935150767, -274.3114029842876, -274.3113926749587, -274.3114021441699, -274.3114003657165, -274.311396133572, -274.3113995255993, 
  -274.3113952934534, -274.3114049667286, -274.3113915325958, -274.3114041266106, -274.3113906924781, -274.3114376911616, -274.3113588120414, -274.3114368509935, -274.3113579719737, -274.3113744073685, -274.3114220923387, -274.3113735672722, -274.3114212521993, -274.3114334738233, -274.3113630289094, -274.3114326337071, -274.3113621887898, -274.3114201665479, -274.3113763326113, -274.3114193264385, -274.311375492485, -274.3114163066312, -274.3113801926017, -274.3114154665109, -274.3113793524864, -274.3114403473399, -274.3113561518825, -274.3114395072216, -274.311355311765, -274.3113993727691, -274.311396235719, -274.3113994234302, -274.3113962863803, -274.311406055893, -274.3113895526412, -274.3114061065541, -274.3113896033024, -274.3113978897829, -274.3113977187007, -274.311397940444, 
  -274.3113977693619, -274.3113930696878, -274.3114025388966, -274.3113931203466, -274.31140258956, -274.3113999203269, -274.3113956881815, -274.3113999709878}
 {-285.630309045701, -285.6303112270533, -285.6303116396526, -285.6303064517663, -285.6303068643725, -285.6303114324628, -285.6303114342423, -285.6303066571791, -285.6303066589589, -285.6303106459157, -285.6303122207884, -285.6303058706353, -285.6303074455017, -285.6303085812338, -285.6303142854878, -285.6303038059493, -285.6303095102053, -285.6303114245502, -285.6303114421548, -285.6303066492667, -285.6303066668713, -285.6303114333824, -285.6303114333226, -285.6303066581, -285.630306658038, -285.6303115089084, -285.6303113577966, -285.6303067336252, -285.6303065825127, -285.6303114393191, -285.6303114273859, -285.6303066640356, -285.6303066521024, -285.6303232914844, -285.6302995766452, -285.6303185164085, -285.630294801154, -285.6303279127788, -285.6302949540774, -285.6303231374932, 
  -285.630290178796, -285.6303114333607, -285.6303114333444, -285.6303066580771, -285.6303066580609, -285.630316590831, -285.6303062758533, -285.630311815535, -285.6303015005822, -285.6303060634805, -285.6303168033959, -285.6303012881945, -285.6303120281149, -285.6303114265349, -285.6303114401701, -285.6303066512512, -285.6303066648866, -285.6303088385103, -285.63030884029, -285.6303092511131, -285.6303092528928, -285.6303080519655, -285.6303096268337, -285.630308464567, -285.6303100394379, -285.6303059872805, -285.6303116915362, -285.630306399884, -285.6303121041384, -285.6303088305978, -285.6303088482024, -285.6303092432006, -285.6303092608052, -285.6303088394304, -285.6303088393698, -285.6303092520335, -285.6303092519723, -285.6303089149561, -285.6303087638441, -285.6303093275591, 
  -285.6303091764468, -285.6303088453668, -285.6303088334335, -285.6303092579696, -285.6303092460363, -285.6303206976061, -285.6302969826187, -285.6303211102682, -285.6302973951621, -285.6303253188238, -285.6302923601277, -285.6303257314297, -285.6302927727273, -285.6303088394083, -285.630308839392, -285.630309252011, -285.6303092519948, -285.6303139968753, -285.6303036819042, -285.6303144094723, -285.6303040945127, -285.6303034695275, -285.6303142094442, -285.6303038821291, -285.6303146220482, -285.6303088325824, -285.6303088462177, -285.6303092451852, -285.6303092588205, -285.630308257376, -285.6303098322455, -285.6303082591556, -285.6303098340252, -285.6303061926919, -285.630311896947, -285.6303061944717, -285.6303118987267, -285.6303090360089, -285.6303090536135, -285.6303090377886, 
  -285.6303090553932, -285.6303090448422, -285.6303090447803, -285.6303090466208, -285.630309046561, -285.6303091203672, -285.6303089692553, -285.6303091221471}
 {-251.9895046035122, -251.9895049372875, -251.9895052939637, -251.9895039130716, -251.9895042697528, -251.9895051191733, -251.9895051120776, -251.98950409496, -251.9895040878641, -251.9895042514853, -251.9895059797677, -251.9895032272736, -251.9895049555525, -251.9895059412718, -251.9895042899893, -251.9895049170578, -251.9895032657764, -251.9895051252113, -251.9895051060396, -251.9895041009979, -251.9895040818262, -251.9895100000352, -251.989500231275, -251.9895089758109, -251.9894992070725, -251.9895069752967, -251.9895032559632, -251.9895059510836, -251.9895022317494, -251.9895073620006, -251.9895028692688, -251.9895063377871, -251.9895018450555, -251.989519911159, -251.989490320871, -251.9895188872847, -251.9894892963184, -251.9895119520787, -251.9894982792634, -251.9895109278581, 
  -251.9894972550572, -251.989486346508, -251.9895238855794, -251.9894853222985, -251.9895228613621, -251.9895093165585, -251.9895009146894, -251.989508292304, -251.9894998905172, -251.9895081159374, -251.9895021153333, -251.9895070917231, -251.9895010911208, -251.9895136158902, -251.989496615444, -251.9895125916778, -251.9894955912295, -251.9895044287209, -251.9895044216251, -251.9895047853996, -251.9895047783039, -251.9895035610338, -251.9895052893142, -251.9895039177122, -251.9895056459933, -251.9895052508188, -251.9895035995372, -251.989505607498, -251.9895039562156, -251.9895044347588, -251.9895044155871, -251.9895047914376, -251.9895047722659, -251.9895093095773, -251.989499540828, -251.989509666256, -251.9894998975068, -251.9895062848446, -251.9895025655102, -251.9895066415228, 
  -251.9895029221895, -251.9895066715481, -251.9895021788163, -251.9895070282268, -251.9895025354951, -251.9895192208651, -251.9894896302599, -251.9895195775658, -251.9894899869167, -251.9895112616182, -251.989497588819, -251.9895116183057, -251.9894979454889, -251.989485656057, -251.9895231951254, -251.9894860127367, -251.9895235518033, -251.9895086260878, -251.9895002242552, -251.9895089827619, -251.9895005809386, -251.9895074254848, -251.989501424881, -251.9895077821629, -251.9895017815603, -251.989512925438, -251.9894959249912, -251.9895132821171, -251.9894962816695, -251.9895037429207, -251.9895054712015, -251.9895037358251, -251.9895054641057, -251.9895054327061, -251.9895037814242, -251.9895054256104, -251.9895037743284, -251.989504616646, -251.9895045974743, -251.9895046095502, 
  -251.9895045903785, -251.9895094914646, -251.9894997227149, -251.9895094843684, -251.9894997156196, -251.9895064667314, -251.9895027473976, -251.9895064596357}
 {-397.458278130914, -397.458280923667, -397.458281241349, -397.4582750205101, -397.4582753382, -397.4582810420148, -397.458281122999, -397.4582751388616, -397.4582752198464, -397.4582806571549, -397.4582815078602, -397.4582747539993, -397.4582756047098, -397.4582743927637, -397.4582877722891, -397.4582684896079, -397.4582818691391, -397.458281030394, -397.4582811346198, -397.458275127241, -397.4582752314669, -397.4582765030048, -397.4582856621084, -397.4582705998698, -397.4582797589375, -397.4582806999275, -397.4582814651564, -397.4582747967749, -397.4582755620033, -397.4582853931859, -397.4582767718652, -397.4582794900334, -397.458270868712, -397.4582399351986, -397.4583222323021, -397.4582340314115, -397.4583163297834, -397.458277208745, -397.4582849565419, -397.4582713055987, 
  -397.4582790533822, -397.4582534393813, -397.4583087274966, -397.4582475362209, -397.4583028243514, -397.4582880544818, -397.4582741105509, -397.4582821512636, -397.4582682074634, -397.4582756920408, -397.4582864732182, -397.4582697888871, -397.458280570066, -397.4583053711509, -397.4582567936915, -397.4582994679958, -397.4582508905409, -397.4582779315798, -397.4582780125643, -397.4582782492656, -397.4582783302504, -397.4582775467191, -397.4582783974263, -397.4582778644044, -397.458278715113, -397.4582712823283, -397.458284661855, -397.4582716000127, -397.4582849795424, -397.4582779199592, -397.458278024185, -397.4582782376451, -397.458278341871, -397.4582733925784, -397.4582825516652, -397.4582737102655, -397.45828286935, -397.458277589492, -397.4582783547224, -397.4582779071797, 
  -397.4582786724066, -397.4582822827513, -397.4582736614303, -397.4582826004374, -397.4582739791161, -397.4582368244787, -397.4583191221523, -397.4582371421006, -397.4583194399023, -397.4582740983214, -397.4582818460958, -397.4582744159916, -397.4582821637975, -397.4582503289449, -397.4583056170635, -397.4582506466266, -397.4583059347537, -397.4582849440169, -397.4582710001462, -397.4582852616977, -397.4582713178373, -397.4582725816063, -397.458283362783, -397.4582728992909, -397.4582836804704, -397.4583022607158, -397.458253683257, -397.4583025784002, -397.4582540009446, -397.4582776650684, -397.4582785157763, -397.458277746053, -397.4582785967608, -397.4582714006772, -397.4582847802054, -397.4582714816616, -397.45828486119, -397.4582780383089, -397.4582781425346, -397.4582781192934, 
  -397.4582782235191, -397.4582735109293, -397.4582826700136, -397.4582735919125, -397.4582827509995, -397.4582777078424, -397.4582784730713, -397.4582777888272}
 {-468.6734441624778, -468.6734441323673, -468.6734441123517, -468.6734442126037, -468.673444192588, -468.6734441218901, -468.6734441228289, -468.6734442021264, -468.6734442030653, -468.6734440382748, -468.6734442064465, -468.673444118513, -468.6734442866812, -468.67344617255, -468.6734420721841, -468.673446252786, -468.6734421524209, -468.6734441219763, -468.6734441227427, -468.6734442022127, -468.673444202979, -468.6734441515332, -468.6734440931858, -468.6734442317693, -468.6734441734225, -468.6734440878309, -468.673444156888, -468.6734441680673, -468.6734442371244, -468.6734441281391, -468.6734441165799, -468.6734442083755, -468.6734441968163, -468.6734444229446, -468.673443821775, -468.6734445031767, -468.6734439020155, -468.6734393527863, -468.6734488920592, -468.6734394330192, 
  -468.673448972299, -468.6734440862224, -468.6734441584965, -468.6734441664588, -468.6734442387329, -468.6734441374844, -468.6734441072347, -468.6734442177205, -468.6734441874712, -468.6734490720742, -468.6734391726281, -468.6734491523094, -468.6734392528656, -468.6734441274488, -468.6734441172701, -468.6734442076853, -468.6734441975066, -468.6734441720163, -468.6734441729551, -468.6734441520007, -468.6734441529394, -468.6734440884022, -468.6734442565716, -468.673444068386, -468.6734442365566, -468.6734462226761, -468.6734421223103, -468.6734462026602, -468.6734421022949, -468.6734441721025, -468.6734441728688, -468.6734441520869, -468.6734441528531, -468.6734442016592, -468.6734441433122, -468.6734441816436, -468.6734441232964, -468.6734441379572, -468.6734442070142, -468.6734441179415, 
  -468.6734441869985, -468.6734441782653, -468.6734441667062, -468.6734441582497, -468.6734441466905, -468.6734444730686, -468.6734438719033, -468.673444453053, -468.6734438518876, -468.6734394029112, -468.6734489421867, -468.6734393828947, -468.6734489221719, -468.6734441363486, -468.6734442086228, -468.6734441163329, -468.6734441886071, -468.6734441876105, -468.673444157361, -468.6734441675948, -468.6734441373454, -468.6734491222, -468.6734392227548, -468.673449102184, -468.6734392027394, -468.6734441775751, -468.6734441673964, -468.6734441575593, -468.6734441473807, -468.6734440779247, -468.6734442460947, -468.6734440788636, -468.6734442470335, -468.6734462121988, -468.6734421118333, -468.6734462131376, -468.6734421127721, -468.6734441616253, -468.6734441623916, -468.6734441625641, 
  -468.6734441633304, -468.673444191182, -468.6734441328349, -468.6734441921208, -468.6734441337737, -468.6734441274799, -468.673444196537, -468.6734441284187}
 {-417.1717422316785, -417.1717432201886, -417.171743263225, -417.1717412001383, -417.1717412431754, -417.1717432064026, -417.1717432770109, -417.1717411863524, -417.1717412569613, -417.1717435786183, -417.1717429047961, -417.171741558568, -417.1717408847467, -417.1717452862029, -417.1717411972155, -417.171743266153, -417.1717391771656, -417.1717432835111, -417.1717431999023, -417.1717412634613, -417.1717411798524, -417.1717420053437, -417.1717444781036, -417.1717399852955, -417.1717424580521, -417.1717432026969, -417.1717432807196, -417.171741182647, -417.1717412606698, -417.1717448275361, -417.1717416558987, -417.1717428074863, -417.1717396358487, -417.1717336694782, -417.1717528145082, -417.1717316492301, -417.1717507946567, -417.1717471791919, -417.1717393042896, -417.1717451591467, 
  -417.1717372842351, -417.171736280972, -417.1717502031487, -417.1717342609201, -417.1717481831009, -417.1717483852534, -417.1717380981399, -417.1717463651852, -417.1717360781083, -417.171748445462, -417.1717380379307, -417.1717464254123, -417.1717360178807, -417.1717576241909, -417.171728859034, -417.1717556041409, -417.1717268389843, -417.171742174856, -417.1717422454646, -417.1717422178926, -417.1717422885012, -417.1717425470717, -417.1717418732497, -417.1717425901081, -417.1717419162866, -417.1717442546564, -417.171740165669, -417.1717442976931, -417.1717402087056, -417.1717422519647, -417.1717421683558, -417.1717422950013, -417.1717422113924, -417.171740973798, -417.1717434465565, -417.1717410168348, -417.1717434895929, -417.1717421711504, -417.1717422491732, -417.1717422141871, 
  -417.1717422922098, -417.1717437959897, -417.1717406243521, -417.1717438390262, -417.1717406673888, -417.1717326378351, -417.1717517830585, -417.1717326808666, -417.1717518261001, -417.1717461476509, -417.1717382727378, -417.1717461906814, -417.1717383157805, -417.1717352494247, -417.1717491716031, -417.171735292461, -417.1717492146401, -417.1717473536981, -417.1717370666022, -417.1717473967341, -417.1717371096396, -417.1717474139157, -417.171737006384, -417.1717474569522, -417.1717370494209, -417.1717565926444, -417.1717278274875, -417.171756635681, -417.1717278705243, -417.1717425332856, -417.1717418594638, -417.1717426038941, -417.1717419300724, -417.1717442408704, -417.171740151883, -417.171744311479, -417.1717402224916, -417.1717422381787, -417.1717421545698, -417.1717423087872, 
  -417.1717422251784, -417.1717409600122, -417.1717434327703, -417.1717410306206, -417.171743503379, -417.1717421573645, -417.1717422353872, -417.171742227973}
 {-381.8753966003269, -381.8753994558882, -381.8753991547733, -381.8753940458991, -381.875393744785, -381.8753992967573, -381.875399313904, -381.8753938867685, -381.8753939039154, -381.8753996503078, -381.8753989603549, -381.8753942403161, -381.8753935503692, -381.87540172859, -381.8753968820904, -381.8753963186007, -381.8753914721022, -381.8753993314092, -381.8753992792521, -381.8753939214205, -381.8753938692634, -381.8753979434168, -381.8754006672661, -381.8753925334344, -381.875395257271, -381.875400362304, -381.8753982483632, -381.8753949523154, -381.8753928383744, -381.8754011338745, -381.8753974768042, -381.8753957238859, -381.8753920668154, -381.8754125269676, -381.8753860850902, -381.8754071171274, -381.8753806749531, -381.8753922627677, -381.875406348044, -381.8753868527784, 
  -381.875400938056, -381.8754184333314, -381.8753801782726, -381.8754130233445, -381.8753747682822, -381.8754045762071, -381.8753940344318, -381.8753991662116, -381.8753886244501, -381.8754039736662, -381.8753946369847, -381.8753985636774, -381.875389226996, -381.87540869367, -381.8753899170331, -381.8754032836806, -381.8753845070451, -381.8753967423108, -381.8753967594576, -381.8753964411963, -381.8753964583432, -381.8753970958606, -381.8753964059093, -381.8753967947446, -381.8753961047963, -381.875399174144, -381.8753943276435, -381.875398873028, -381.8753940265304, -381.8753967769628, -381.8753967248057, -381.8753964758483, -381.8753964236912, -381.8753953889734, -381.8753981128167, -381.8753950878592, -381.8753978117019, -381.8753978078572, -381.8753956939172, -381.8753975067435, 
  -381.8753953928019, -381.8753985794281, -381.8753949223579, -381.8753982783137, -381.8753946212433, -381.8754099726023, -381.8753835305627, -381.875409671474, -381.875383229462, -381.8753897083184, -381.8754037936006, -381.8753894072093, -381.8754034924807, -381.8754158788855, -381.8753776238258, -381.8754155777719, -381.8753773227104, -381.8754020217558, -381.8753914799903, -381.8754017206443, -381.875391178873, -381.8754014192202, -381.8753920825379, -381.8754011181048, -381.8753917814242, -381.8754061392235, -381.8753873625867, -381.8754058381084, -381.8753870614729, -381.875396936729, -381.8753962467792, -381.8753969538759, -381.8753962639261, -381.8753990150124, -381.8753941685133, -381.8753990321593, -381.8753941856603, -381.8753966178319, -381.8753965656749, -381.8753966349788, 
  -381.8753965828217, -381.8753952298432, -381.8753979536852, -381.875395246989, -381.8753979708331, -381.8753976487268, -381.8753955347859, -381.8753976658736}
 {-276.377285125377, -276.3772864905581, -276.3772863806794, -276.3772838700806, -276.3772837601998, -276.3772864321111, -276.3772864391262, -276.3772838116325, -276.3772838186478, -276.3772866763641, -276.3772861948739, -276.3772840558853, -276.3772835743957, -276.3772875281244, -276.3772853431183, -276.3772849076459, -276.3772827226396, -276.3772864473101, -276.3772864239272, -276.3772838268316, -276.3772838034487, -276.3772863949701, -276.3772864762672, -276.3772837744919, -276.3772838557884, -276.3772864235793, -276.377286447658, -276.3772838031008, -276.3772838271795, -276.3772864307389, -276.3772864404983, -276.3772838102605, -276.3772838200198, -276.3772902046096, -276.3772826671462, -276.3772875842434, -276.3772800465555, -276.3772838264777, -276.37728904482, -276.377281205995, 
  -276.3772864243455, -276.3772863738947, -276.3772864973428, -276.377283753417, -276.3772838768634, -276.3772984122684, -276.3772744588981, -276.3772957917843, -276.3772718384252, -276.3772979446546, -276.3772749265204, -276.3772953241762, -276.3772723060419, -276.3772864407501, -276.3772864304872, -276.3772838202716, -276.3772838100087, -276.3772851768093, -276.3772851838245, -276.3772850669294, -276.3772850739447, -276.3772854210623, -276.3772849395722, -276.3772853111824, -276.3772848296925, -276.3772862728227, -276.3772840878164, -276.3772861629428, -276.3772839779367, -276.3772851920083, -276.3772851686254, -276.3772850821286, -276.3772850587456, -276.3772851396685, -276.3772852209653, -276.3772850297887, -276.3772851110855, -276.3772851682775, -276.3772851923561, 
  -276.3772850583978, -276.3772850824764, -276.3772851754371, -276.3772851851966, -276.3772850655574, -276.3772850753168, -276.3772889493709, -276.3772814117814, -276.3772888394771, -276.3772813019155, -276.3772825711723, -276.3772877895217, -276.3772824612956, -276.377287679639, -276.3772851185935, -276.3772852420405, -276.3772850087134, -276.3772851321609, -276.3772971569632, -276.3772732035997, -276.3772970470847, -276.3772730937187, -276.377296689353, -276.3772736712185, -276.377296579473, -276.377273561339, -276.3772851854484, -276.3772851751855, -276.3772850755686, -276.3772850653057, -276.3772853626147, -276.3772848811247, -276.3772853696299, -276.37728488814, -276.377286214375, -276.3772840293689, -276.3772862213903, -276.3772840363841, -276.3772851335607, -276.3772851101778, 
  -276.377285140576, -276.3772851171931, -276.3772850812211, -276.3772851625176, -276.377285088236, -276.377285169533, -276.37728510983, -276.3772851339086, -276.3772851168452}
 {-312.1833617934706, -312.1833674070199, -312.1833662290058, -312.183357357974, -312.1833561799589, -312.1833668095744, -312.1833668264501, -312.1833567605278, -312.1833567774042, -312.1833682532027, -312.1833653828234, -312.1833582041442, -312.1833553337893, -312.1833694276741, -312.1833642084061, -312.1833593786265, -312.183354159361, -312.1833669640805, -312.1833666719442, -312.1833569150341, -312.1833566228979, -312.1833591862906, -312.1833744497095, -312.1833491372787, -312.1833644006288, -312.1833760881956, -312.1833575478477, -312.1833660391501, -312.1833474988004, -312.1833665026333, -312.1833671334296, -312.1833564535878, -312.1833570843827, -312.1833382810203, -312.1833953580001, -312.1833282317255, -312.1833853092024, -312.1833974459264, -312.1833361905401, -312.1833873968797, 
  -312.1833261414942, -312.1833032803111, -312.1834303578024, -312.1832932312604, -312.1834203087605, -312.1833801010961, -312.1833535349075, -312.1833700520152, -312.1833434858957, -312.1833785090678, -312.1833551271082, -312.1833684600241, -312.1833450780591, -312.1833520986414, -312.183381539489, -312.1833420495907, -312.183371490447, -312.1833623740404, -312.1833623909166, -312.1833611960258, -312.1833612129017, -312.1833638176646, -312.1833609472939, -312.1833626396463, -312.183359769283, -312.1833649921421, -312.1833597728705, -312.1833638141227, -312.1833585948607, -312.1833625285466, -312.1833622364103, -312.1833613505319, -312.1833610583957, -312.1833547507733, -312.1833700141591, -312.1833535727599, -312.1833688361433, -312.1833716526603, -312.1833531123154, -312.1833704746495, 
  -312.1833519342968, -312.1833620670998, -312.1833626978956, -312.1833608890853, -312.1833615198807, -312.1833338453131, -312.1833909226397, -312.1833326673968, -312.1833897445268, -312.1833930103991, -312.1833317549997, -312.183391832371, -312.1833305769986, -312.1832988447758, -312.1834259222703, -312.18329766676, -312.1834247442568, -312.1833756655388, -312.1833490993971, -312.1833744875365, -312.1833479213702, -312.1833740735355, -312.1833506915729, -312.1833728955207, -312.1833495135584, -312.1833476631068, -312.1833771039558, -312.1833464850892, -312.1833759259441, -312.1833632202168, -312.1833603498499, -312.183363237093, -312.1833603667258, -312.1833643946937, -312.183359175427, -312.1833644115698, -312.1833591923031, -312.1833619311007, -312.1833616389643, -312.1833619479767, 
  -312.1833616558405, -312.1833541533294, -312.1833694167112, -312.1833541702028, -312.18336943359, -312.1833710552165, -312.1833525148673, -312.183371072092}
 {-225.5859338781648, -225.5859293938214, -225.585930435179, -225.5859373211857, -225.5859383625567, -225.5859298677188, -225.5859299612811, -225.5859377950895, -225.5859378886526, -225.5859285531836, -225.5859312758255, -225.5859364805633, -225.5859392031877, -225.5859326027786, -225.5859272262534, -225.5859405301485, -225.5859351536256, -225.5859299272921, -225.5859299017078, -225.5859378546632, -225.5859378290788, -225.5859260102709, -225.5859338188198, -225.5859339376449, -225.585941746188, -225.5859308836246, -225.5859289453802, -225.5859388109964, -225.5859368727504, -225.5859310943704, -225.5859287346404, -225.5859390217414, -225.5859366620114, -225.5859950758166, -225.5858647553787, -225.5860030044206, -225.5858726815167, -225.5859355792561, -225.58592424999, -225.585943506608, 
  -225.58593217738, -225.5859413428576, -225.5859184867136, -225.5859492702315, -225.5859264140818, -225.5859355662155, -225.5859242629001, -225.585943493357, -225.5859321905008, -225.5859434247731, -225.5859164042012, -225.5859513521395, -225.5859243315768, -225.5859419301715, -225.5859178987492, -225.5859498575419, -225.5859258261208, -225.5859333107015, -225.5859334042642, -225.5859343520658, -225.5859344456286, -225.5859319961711, -225.5859347188038, -225.585933037535, -225.5859357601685, -225.58593604576, -225.5859306692379, -225.5859370871262, -225.5859317106003, -225.5859333702751, -225.5859333446907, -225.5859344116395, -225.585934386055, -225.5859294532552, -225.5859372618014, -225.5859304946197, -225.5859383031655, -225.5859343266078, -225.5859323883629, -225.5859353679723, 
  -225.5859334297269, -225.5859345373533, -225.5859321776233, -225.5859355787176, -225.5859332189876, -225.5859985193928, -225.5858681977684, -225.5859995608035, -225.5858692390862, -225.5859390222126, -225.5859276929993, -225.5859400636107, -225.5859287343299, -225.5859447858421, -225.585921929695, -225.5859458272062, -225.5859229710595, -225.5859390090912, -225.5859277059904, -225.5859400504405, -225.5859287473696, -225.5859468677536, -225.5859198471865, -225.5859479091181, -225.5859208885506, -225.5859453731542, -225.5859213417323, -225.5859464145183, -225.5859223830968, -225.5859324700714, -225.5859351927046, -225.5859325636342, -225.5859352862672, -225.5859365196614, -225.5859311431375, -225.5859366132243, -225.5859312367002, -225.5859338441757, -225.5859338185913, 
  -225.5859339377384, -225.585933912154, -225.5859299271547, -225.585937735703, -225.5859300207197, -225.5859378292634, -225.5859348005081, -225.5859328622637, -225.5859348940715}
 {-37.14352890206144, -37.14352870688546, -37.1435286895074, -37.14352911461531, -37.14352909723726, -37.14352869723927, -37.14352869915359, -37.14352910496912, -37.14352910688344, -37.14352745868301, -37.14352993772949, -37.14352786641368, -37.14353034545852, -37.14353009953975, -37.14352729685788, -37.14353050727012, -37.14352770458722, -37.14352867336836, -37.14352872302451, -37.14352908109819, -37.14352913075438, -37.14348555082164, -37.14357184630692, -37.1434859586269, -37.14357225396137, -37.14353262665925, -37.14352476973862, -37.14353303438946, -37.14352517746812, -37.14352393087343, -37.14353346553448, -37.1435243386023, -37.14353387326531, -37.14352699857479, -37.14353039782016, -37.14352740630724, -37.14353080554739, -37.14352844486638, -37.14352895155392, -37.14352885259738, 
  -37.14352935928262, -37.14355800360555, -37.14349939312763, -37.14355841133943, -37.14349980085346, -37.14352869736303, -37.14352869902982, -37.14352910509288, -37.14352910675967, -37.14353428399161, -37.143523112373, -37.14353469172058, -37.14352352010374, -37.14350541551018, -37.14355198244262, -37.14350582322965, -37.14355239018285, -37.14352890979331, -37.14352891170763, -37.14352889241525, -37.14352889432958, -37.14352767123751, -37.14353015028308, -37.14352765385936, -37.1435301329051, -37.14353031209407, -37.14352750941166, -37.14353029471598, -37.14352749203362, -37.14352888592239, -37.14352893557856, -37.14352886854434, -37.1435289182005, -37.14348576341481, -37.14357205882183, -37.1434857460339, -37.14357204144663, -37.14353283921347, -37.14352498229248, -37.1435328218354, 
  -37.14352496491443, -37.14352414342696, -37.14353367808903, -37.14352412604895, -37.14353366071093, -37.14352721113012, -37.1435306103729, -37.14352719375208, -37.14353059299482, -37.14352865742092, -37.14352916410747, -37.14352864004302, -37.14352914672925, -37.14355821616168, -37.14349960567959, -37.14355819878347, -37.14349958830168, -37.14352890991707, -37.14352891158387, -37.14352889253902, -37.14352889420581, -37.14353449654519, -37.1435233249275, -37.14353447916717, -37.14352330754941, -37.14350562805884, -37.14355219500205, -37.14350561068117, -37.1435521776236, -37.14352766159126, -37.14353014063692, -37.14352766350559, -37.14353014255125, -37.14353030244786, -37.14352749976547, -37.14353030436219, -37.1435275016798, -37.1435288762762, -37.14352892593237, -37.14352887819052, 
  -37.1435289278467, -37.14348575376702, -37.14357204917724, -37.14348575568169, -37.14357205109122, -37.14353282956727, -37.14352497264629, -37.1435328314816}
 {-397.8817724215246, -397.8817743298414, -397.8817743372363, -397.8817705058181, -397.8817705132142, -397.8817743255968, -397.8817743414807, -397.881770501574, -397.8817705174581, -397.8817735842762, -397.881775082802, -397.8817697602537, -397.881771258779, -397.8817770412377, -397.8817716258466, -397.8817732172148, -397.881767801824, -397.881774287924, -397.8817743791535, -397.8817704639013, -397.8817705551307, -397.8817743592127, -397.8817743078648, -397.8817705351902, -397.8817704838418, -397.8817743039555, -397.881774363122, -397.8817704799329, -397.8817705390992, -397.8817743597902, -397.8817743072874, -397.8817705357676, -397.8817704832646, -397.8817704897563, -397.8817781780428, -397.8817666655661, -397.8817743541876, -397.8817655651259, -397.8817831020359, -397.8817617411084, 
  -397.8817792780078, -397.881773796286, -397.8817748707917, -397.8817699722624, -397.8817710467699, -397.8817860682931, -397.8817625987179, -397.8817822442605, -397.881758774705, -397.8817755150073, -397.8817731521957, -397.8817716909844, -397.8817693281731, -397.8817743378311, -397.8817743292465, -397.8817705138083, -397.8817705052238, -397.8817724098849, -397.8817724257689, -397.8817724172804, -397.8817724331644, -397.8817716685646, -397.8817731670899, -397.8817716759598, -397.8817731744856, -397.8817751255258, -397.8817697101348, -397.8817751329212, -397.8817697175303, -397.8817723722122, -397.8817724634416, -397.8817723796077, -397.8817724708371, -397.881772443501, -397.8817723921529, -397.8817724508964, -397.8817723995483, -397.8817723882438, -397.88177244741, -397.8817723956393, 
  -397.8817724548056, -397.8817724440785, -397.8817723915755, -397.881772451474, -397.881772398971, -397.8817685739656, -397.8817762624099, -397.8817685813514, -397.8817762698151, -397.8817636494186, -397.8817811863195, -397.8817636568103, -397.8817811937188, -397.8817718805737, -397.8817729550803, -397.8817718879692, -397.8817729624758, -397.8817841525765, -397.8817606830108, -397.8817841599717, -397.8817606904066, -397.8817735992954, -397.8817712364838, -397.8817736066907, -397.8817712438795, -397.8817724221192, -397.8817724135347, -397.8817724295147, -397.8817724209301, -397.8817716643201, -397.8817731628458, -397.8817716802042, -397.8817731787298, -397.8817751212814, -397.8817697058905, -397.8817751371655, -397.8817697217745, -397.8817723679678, -397.8817724591972, -397.8817723838519, 
  -397.8817724750813, -397.8817724392568, -397.8817723879084, -397.8817724551406, -397.8817724037927, -397.8817723839994, -397.8817724431657, -397.8817723998834}
 {-310.4835337698806, -310.4835355566178, -310.4835355183139, -310.4835320214509, -310.4835319831476, -310.4835355381343, -310.4835355367972, -310.4835320029677, -310.4835320016307, -310.4835356147709, -310.483535460161, -310.4835320796043, -310.4835319249945, -310.4835377230706, -310.483533351868, -310.4835341879039, -310.4835298167014, -310.4835355407284, -310.4835355342032, -310.4835320055618, -310.4835319990366, -310.4835364335678, -310.4835346413718, -310.4835328984004, -310.483531106206, -310.4835366601713, -310.4835344147642, -310.4835331250048, -310.4835308795976, -310.483537860804, -310.4835332141422, -310.4835343256374, -310.4835296789757, -310.4835368365472, -310.4835342389575, -310.4835333014061, -310.4835307037653, -310.483535023811, -310.4835360511887, -310.4835314886429, 
  -310.4835325160236, -310.4835175643073, -310.4835535113315, -310.4835140291413, -310.4835499761644, -310.4835415827258, -310.4835294921693, -310.4835380475593, -310.4835259570027, -310.4835414036914, -310.4835296712074, -310.4835378685248, -310.4835261360408, -310.4835440058072, -310.4835270692097, -310.4835404706407, -310.483523534043, -310.483533789701, -310.483533788364, -310.4835337513974, -310.4835337500604, -310.4835338663378, -310.4835337117277, -310.4835338280338, -310.4835336734244, -310.4835359746373, -310.4835316034346, -310.4835359363336, -310.4835315651311, -310.4835337922951, -310.4835337857699, -310.4835337539915, -310.4835337474663, -310.4835346851345, -310.4835328929385, -310.48353464683, -310.4835328546358, -310.4835349117381, -310.483532666331, -310.4835348734345, 
  -310.4835326280273, -310.4835361123707, -310.483531465709, -310.4835360740671, -310.4835314274054, -310.48353508812, -310.483532490518, -310.4835350498298, -310.4835324522011, -310.4835332753773, -310.4835343027558, -310.483533237073, -310.483534264453, -310.4835158158742, -310.4835517628981, -310.4835157775709, -310.4835517245941, -310.4835398342924, -310.4835277437362, -310.4835397959891, -310.4835277054323, -310.4835396552583, -310.483527922774, -310.4835396169544, -310.4835278844706, -310.4835422573739, -310.4835253207765, -310.4835422190704, -310.4835252824727, -310.4835338478542, -310.4835336932444, -310.4835338465172, -310.4835336919074, -310.4835359561539, -310.4835315849513, -310.4835359548169, -310.4835315836143, -310.4835337738117, -310.4835337672865, -310.4835337724747, 
  -310.4835337659495, -310.4835346666509, -310.4835328744553, -310.4835346653135, -310.4835328731188, -310.4835348932547, -310.4835326478475, -310.4835348919177}
 {-224.4526956344945, -224.4526982498706, -224.4526983598124, -224.4526929091938, -224.45269301913, -224.4526983317998, -224.4526982778825, -224.4526929911195, -224.4526929372037, -224.4526989019938, -224.4526977076895, -224.4526935613104, -224.4526923670136, -224.4526974988318, -224.4526991108676, -224.4526921581536, -224.4526937701866, -224.4526985113021, -224.4526980983803, -224.4526931706225, -224.4526927577007, -224.4526904769407, -224.4527061325948, -224.4526851363132, -224.4527007918632, -224.452710986513, -224.4526856231423, -224.4527056458324, -224.4526802824637, -224.4526750669226, -224.4527215427279, -224.4526697262439, -224.4527162020473, -224.4526918437754, -224.4527047668146, -224.4526865031692, -224.4526994260617, -224.4526853461298, -224.4527112636575, -224.4526800054454, 
  -224.4527059229827, -224.4527840674787, -224.4526125430897, -224.4527787268027, -224.4526072024065, -224.4527042169428, -224.4526923927055, -224.4526988762694, -224.4526870520197, -224.4526993945814, -224.4526972151511, -224.4526940539025, -224.4526918744707, -224.452584262387, -224.4528123530374, -224.4525789217017, -224.4528070123635, -224.4526956064835, -224.4526955525672, -224.4526957164228, -224.452695662506, -224.4526961766762, -224.4526949823754, -224.452696286615, -224.4526950923147, -224.4526947735168, -224.452696385551, -224.4526948834556, -224.4526964954903, -224.4526957859863, -224.4526953730645, -224.4526958959253, -224.4526954830035, -224.4526877516543, -224.4527034072497, -224.4526878615866, -224.4527035171954, -224.4527082611968, -224.452682897827, -224.4527083711357, 
  -224.4526830077661, -224.4526723416075, -224.4527188174115, -224.4526724515462, -224.4527189273508, -224.4526891185187, -224.4527020414398, -224.452689228413, -224.4527021514235, -224.4526826208118, -224.452708538344, -224.4526827307505, -224.4527086482833, -224.4527813421652, -224.4526098177717, -224.4527814521033, -224.4526099277116, -224.452701491631, -224.4526896673857, -224.4527016015682, -224.4526897773266, -224.4526966692664, -224.4526944898344, -224.4526967792045, -224.4526945997744, -224.4525815370679, -224.4528096277249, -224.4525816470079, -224.4528097376631, -224.4526962586035, -224.452695064303, -224.452696204687, -224.4526950103864, -224.4526948554441, -224.4526964674787, -224.4526948015276, -224.452696413562, -224.4526958679137, -224.452695454992, -224.4526958139971, 
  -224.4526954010754, -224.4526878335788, -224.4527034891801, -224.4526877796615, -224.4527034352642, -224.4527083431243, -224.4526829797544, -224.4527082892075}
 {-342.5530768253667, -342.5530767684907, -342.5530769562782, -342.5530766944557, -342.5530768822425, -342.5530768639017, -342.5530768608672, -342.5530767898663, -342.5530767868319, -342.5530770175751, -342.5530767071921, -342.5530769435382, -342.5530766331583, -342.5530642510329, -342.5530894738013, -342.5530641769977, -342.5530893997657, -342.5530768412334, -342.5530768835355, -342.5530767671981, -342.5530768095001, -342.5530769500706, -342.5530767747353, -342.5530768760326, -342.5530767007025, -342.5530737039465, -342.5530800209335, -342.5530736299113, -342.5530799468979, -342.5530791850394, -342.553074539745, -342.553079111004, -342.5530744657097, -342.5530792905597, -342.5530744342117, -342.5530792165104, -342.5530743601902, -342.5530638540766, -342.5530898707641, -342.5530637800412, 
  -342.5530897967288, -342.5530671039424, -342.553086621575, -342.5530670299076, -342.553086547539, -342.5530768482384, -342.5530768765304, -342.5530767742031, -342.553076802495, -342.5530671182358, -342.5530866067832, -342.553067044201, -342.5530865327473, -342.5530906671263, -342.5530630574804, -342.5530905930911, -342.5530629834448, -342.5530767329904, -342.5530767299558, -342.5530769207775, -342.553076917743, -342.5530768866607, -342.5530765762839, -342.5530770744525, -342.5530767640665, -342.5530641201221, -342.5530893428894, -342.5530643079084, -342.5530895306774, -342.5530767103221, -342.5530767526241, -342.5530768981092, -342.5530769404113, -342.5530768191548, -342.5530766438284, -342.5530770069483, -342.5530768316092, -342.5530735730357, -342.5530798900216, -342.5530737608219, 
  -342.5530800778096, -342.5530790541281, -342.5530744088336, -342.5530792419151, -342.5530745966209, -342.5530791596414, -342.5530743033074, -342.5530793474287, -342.5530744910944, -342.5530637231662, -342.5530897398519, -342.5530639109515, -342.5530899276409, -342.5530669730326, -342.5530864906621, -342.5530671608173, -342.5530866784517, -342.5530767173271, -342.553076745619, -342.5530769051143, -342.5530769334062, -342.5530669873258, -342.5530864758706, -342.5530671751109, -342.5530866636599, -342.5530905362154, -342.5530629265685, -342.5530907240018, -342.5530631143565, -342.5530769820738, -342.5530766716924, -342.5530769790393, -342.5530766686579, -342.5530642155324, -342.5530894383006, -342.553064212498, -342.5530894352661, -342.553076805733, -342.553076848035, -342.5530768026984, 
  -342.5530768450005, -342.553076914569, -342.5530767392358, -342.5530769115341, -342.5530767362018, -342.553073668446, -342.5530799854329, -342.5530736654116}
 {-153.9590747862299, -153.9590627404424, -153.9590613208056, -153.9590882517476, -153.9590868320958, -153.9590619969754, -153.9590620642725, -153.9590875082727, -153.9590875755705, -153.9590641348636, -153.9590599264002, -153.9590896461596, -153.9590854376996, -153.9590640140718, -153.9590600471842, -153.9590895253701, -153.9590855584813, -153.9590620448658, -153.9590620163821, -153.9590875561635, -153.9590875276798, -153.95905721089, -153.9590668509525, -153.9590827221816, -153.9590923622564, -153.9590626747362, -153.9590613865216, -153.9590881860342, -153.959086897819, -153.9590664101919, -153.9590576510767, -153.9590919214895, -153.9590831623743, -153.959113516952, -153.9590105452216, -153.9591390294183, -153.9590360553508, -153.9590532226794, -153.9590708386799, -153.9590787339446, 
  -153.95909635001, -153.9590693110898, -153.9590547514413, -153.959094822401, -153.9590802627255, -153.9590633291667, -153.9590607322773, -153.9590888400829, -153.9590862439564, -153.9590785086116, -153.9590455525573, -153.9591040199095, -153.9590710638547, -153.9590853337878, -153.9590387278153, -153.959110845086, -153.9590642391125, -153.9590754624034, -153.9590755297009, -153.9590740427591, -153.9590741100566, -153.9590776002909, -153.9590733918294, -153.9590761806468, -153.9590719721849, -153.9590774795006, -153.9590735126119, -153.9590760598557, -153.9590720929681, -153.959075510294, -153.9590754818103, -153.9590740906497, -153.959074062166, -153.9590706763154, -153.9590803163837, -153.9590692566707, -153.9590788967397, -153.9590761401648, -153.9590748519495, -153.9590747205201, 
  -153.9590734323055, -153.9590798756201, -153.9590711165049, -153.9590784559758, -153.9590696968606, -153.9591269829768, -153.9590240100534, -153.959125563308, -153.9590225904335, -153.9590666880725, -153.9590843041432, -153.9590652684659, -153.9590828844611, -153.9590827765247, -153.9590682168628, -153.9590813568805, -153.9590667972185, -153.9590767943958, -153.9590741979046, -153.9590753747683, -153.9590727782435, -153.95909197404, -153.9590590179854, -153.9590905543956, -153.9590575983411, -153.9590987992162, -153.9590521932434, -153.9590973795721, -153.9590507735988, -153.9590768568201, -153.9590726483584, -153.9590769241175, -153.9590727156558, -153.9590767360294, -153.9590727691412, -153.9590768033268, -153.9590728364386, -153.9590747668231, -153.9590747383394, -153.9590748341205, 
  -153.9590748056368, -153.9590699328439, -153.9590795729132, -153.9590700001419, -153.9590796402101, -153.9590753966938, -153.9590741084787, -153.959075463991}
 {-425.0968866780243, -425.0968886498812, -425.0968884081555, -425.0968849479113, -425.0968847061867, -425.0968885509172, -425.0968885071193, -425.096884848948, -425.0968848051498, -425.0968888299959, -425.0968882280427, -425.0968851280236, -425.0968845260763, -425.0968914620858, -425.0968855959696, -425.0968877601157, -425.0968818940009, -425.096888528946, -425.0968885290905, -425.0968848269766, -425.0968848271212, -425.0968912627573, -425.0968857953152, -425.0968875607773, -425.0968820933567, -425.0968883663957, -425.0968886916454, -425.0968846644264, -425.096884989676, -425.0968903946686, -425.0968866633857, -425.096886692699, -425.0968829614166, -425.0968634835314, -425.0969135759297, -425.0968597812809, -425.0969098742416, -425.0968907127507, -425.096886345438, -425.0968870107835, 
  -425.0968826434667, -425.0969068456689, -425.0968702133102, -425.0969031436958, -425.0968665113446, -425.096892094544, -425.0968849635007, -425.0968883925461, -425.09688126156, -425.0968944578707, -425.0968826001333, -425.0968907559014, -425.0968788981639, -425.0968983930676, -425.0968786649887, -425.0968946910997, -425.0968749630179, -425.0968868207861, -425.0968867769879, -425.0968865790609, -425.0968865352629, -425.096887099864, -425.0968864979123, -425.0968868581374, -425.0968862561886, -425.0968897319548, -425.0968838658381, -425.0968894902285, -425.0968836241142, -425.0968867988147, -425.0968867989593, -425.0968865570897, -425.0968865572342, -425.0968895326212, -425.0968840651891, -425.0968892908953, -425.0968838234646, -425.096886636265, -425.0968869615138, -425.096886394539, 
  -425.0968867197896, -425.0968886645373, -425.0968849332546, -425.0968884228121, -425.0968846915296, -425.0968617532584, -425.0969118459404, -425.0968615115357, -425.0969116042129, -425.0968889826248, -425.0968846153016, -425.0968887408912, -425.096884373585, -425.0969051155367, -425.09686848318, -425.09690487381, -425.0968682414567, -425.0968903643976, -425.0968832333847, -425.0968901226743, -425.0968829916578, -425.0968927277401, -425.0968808700016, -425.0968924860139, -425.0968806282776, -425.0968966629367, -425.0968769348573, -425.0968964212126, -425.0968766931313, -425.0968870008997, -425.0968863989494, -425.0968869571015, -425.0968863551513, -425.0968896329907, -425.0968837668752, -425.0968895891925, -425.096883723077, -425.0968866998512, -425.0968866999957, -425.0968866560531, 
  -425.0968866561976, -425.0968894336577, -425.0968839662254, -425.0968893898586, -425.0968839224281, -425.0968865373009, -425.0968868625505, -425.0968864935027}
 {-115.9319394606498, -115.9319266407562, -115.9319252587484, -115.9319536626308, -115.931952280611, -115.9319258186865, -115.9319260808186, -115.9319528405538, -115.9319531026886, -115.9319275841411, -115.9319243153802, -115.9319546060019, -115.9319513372566, -115.9319300702641, -115.9319218292645, -115.9319570921327, -115.9319488511331, -115.9319259933356, -115.9319259061695, -115.9319530152042, -115.9319529280382, -115.9319092434841, -115.9319426565937, -115.9319362653816, -115.9319696784335, -115.9319278599396, -115.931924039577, -115.9319548818083, -115.9319510614456, -115.9319296975542, -115.9319222019836, -115.9319567194235, -115.9319492238516, -115.9320193342972, -115.9318325672003, -115.9320463576299, -115.931859587605, -115.9319127303497, -115.9319391693762, -115.9319397521917, 
  -115.9319661912714, -115.9319591895253, -115.9318927117277, -115.9319862114125, -115.9319197335779, -115.9319166292772, -115.9319352706139, -115.9319436507006, -115.9319622929277, -115.9319416293799, -115.9319102700569, -115.9319686512505, -115.9319372919235, -115.9319630117678, -115.9318888874527, -115.9319900336324, -115.9319159093253, -115.9319400205897, -115.9319402827232, -115.9319386385759, -115.9319389007093, -115.9319417860417, -115.9319385172873, -115.9319404040266, -115.9319371352748, -115.931944272169, -115.9319360311673, -115.9319428901531, -115.9319346491556, -115.9319401952395, -115.9319401080734, -115.9319388132257, -115.9319387260596, -115.9319234454029, -115.9319568584827, -115.9319220633881, -115.9319554764699, -115.931942061842, -115.9319382414824, -115.9319406798312, 
  -115.9319368594656, -115.9319438994583, -115.9319364038873, -115.9319425174447, -115.9319350218734, -115.9320335369417, -115.9318467683636, -115.9320321549108, -115.931845386367, -115.9319269322177, -115.9319533713159, -115.931925550249, -115.931951989257, -115.9319733914363, -115.9319069136245, -115.9319720094269, -115.9319055316064, -115.9319308309523, -115.9319494727465, -115.9319294489508, -115.9319480907204, -115.9319558312831, -115.9319244719615, -115.9319544492726, -115.9319230899443, -115.931977213671, -115.9319030893573, -115.9319758316546, -115.9319017073461, -115.9319409639676, -115.9319376952146, -115.9319412261011, -115.9319379573481, -115.9319434500946, -115.931935209095, -115.931943712228, -115.9319354712285, -115.9319393731661, -115.931939286, -115.9319396352995, 
  -115.9319395481335, -115.9319226233287, -115.9319560364101, -115.9319228854628, -115.931956298543, -115.9319412397701, -115.9319374194075, -115.9319415019036}
 {-297.2164678044381, -297.2164740992734, -297.2164742886046, -297.2164613203065, -297.2164615096449, -297.2164741225861, -297.216474265291, -297.2164613436219, -297.2164614863287, -297.2164736286008, -297.2164747592804, -297.2164608496377, -297.216461980317, -297.2164805955379, -297.2164677923759, -297.2164678165733, -297.2164550134139, -297.2164741382423, -297.2164742496349, -297.216461359279, -297.2164614706717, -297.2164598438424, -297.2164885440316, -297.2164470649088, -297.2164757650388, -297.2164699522416, -297.2164784356306, -297.2164571732775, -297.2164656566683, -297.2164580432024, -297.2164903447315, -297.2164452642396, -297.2164775657678, -297.2164987726608, -297.2164496183988, -297.216485994315, -297.2164368388182, -297.2164772381222, -297.2164711501137, -297.2164644591471, 
  -297.2164583711622, -297.2165887510373, -297.2163596397622, -297.2165759720817, -297.2163468607912, -297.2164963054776, -297.2164520822911, -297.2164835264753, -297.2164393033668, -297.216494851647, -297.2164535361474, -297.2164820726817, -297.2164407571862, -297.216408670911, -297.216539721905, -297.2163958919446, -297.2165269429447, -297.2164676384182, -297.2164677811239, -297.216467827753, -297.2164679704589, -297.2164671444345, -297.2164682751116, -297.2164673337671, -297.2164684644487, -297.2164741113699, -297.2164613082088, -297.2164743007044, -297.2164614975441, -297.2164676540747, -297.2164677654674, -297.2164678434096, -297.2164679548022, -297.2164533596893, -297.2164820598497, -297.216453549025, -297.2164822491838, -297.2164634680728, -297.2164719514644, -297.2164636574093, 
  -297.2164721407976, -297.2164515590352, -297.2164838605638, -297.2164517483701, -297.2164840498987, -297.2164922887788, -297.2164431339457, -297.21649247816, -297.2164433232343, -297.216470753941, -297.2164646659598, -297.2164709432913, -297.2164648552793, -297.2165822668726, -297.2163531555919, -297.2165824562095, -297.2163533449247, -297.2164898212923, -297.2164455981413, -297.2164900106237, -297.2164457874796, -297.2164883674793, -297.2164470519801, -297.2164885568125, -297.2164472413166, -297.2164021867426, -297.2165332377383, -297.2164023760761, -297.2165334270746, -297.2164671677475, -297.2164682984269, -297.2164673104534, -297.2164684411327, -297.2164741346838, -297.2164613315232, -297.2164742773897, -297.2164614742291, -297.216467677389, -297.2164677887815, -297.2164678200948, 
  -297.2164679314873, -297.2164533830051, -297.2164820831622, -297.2164535257085, -297.2164822258704, -297.2164634913879, -297.2164719747777, -297.2164636340936}
 {-46.72333318721511, -46.72336629353918, -46.72336424415606, -46.72330213033692, -46.72330008100605, -46.72336578018832, -46.72336475750143, -46.72330161701231, -46.7233005943252, -46.72336403310493, -46.72336650459272, -46.72329986992777, -46.72330234141763, -46.72333130933938, -46.72339922854111, -46.72326714616246, -46.72333506536576, -46.72336624826157, -46.72336428942821, -46.72330208508545, -46.72330012625208, -46.72335825870318, -46.72337227927076, -46.72329409553238, -46.7233081160893, -46.72338191560636, -46.72334862237967, -46.72331775243007, -46.72328445920369, -46.72335471770865, -46.72337582006425, -46.72329055453254, -46.72331165688807, -46.72327641594533, -46.72345412307157, -46.72321225158944, -46.72338996107524, -46.72331731425523, -46.72341322359559, -46.72325315107967, 
  -46.72334906041887, -46.72344218776259, -46.72328835183089, -46.72337802458613, -46.7232241886551, -46.72326170302399, -46.72346883684208, -46.72319754048189, -46.7234046730319, -46.72328075645733, -46.72344978313352, -46.72321659328164, -46.72338561995693, -46.72336701467616, -46.7233635253244, -46.72330285149991, -46.72329936214837, -46.72333472323954, -46.72333370055311, -46.72333267388312, -46.72333165119556, -46.72333297615848, -46.72333544764206, -46.72333092679624, -46.72333339829033, -46.72330025239092, -46.72336817159247, -46.72329820303297, -46.72336612223646, -46.72333519131302, -46.72333323247968, -46.72333314195606, -46.72333118312267, -46.72332720175509, -46.72334122232175, -46.72332515240251, -46.72333917296035, -46.72335085865917, -46.72331756542976, -46.72334880929929, 
  -46.72331551607566, -46.72332366076005, -46.72334476311574, -46.72332161140319, -46.72334271375865, -46.72324535847512, -46.72342306664471, -46.72324330898173, -46.72342101742413, -46.72328625733772, -46.72338216661598, -46.72328420791921, -46.72338011732052, -46.72341113081589, -46.72325729488052, -46.7234090814549, -46.72325524552752, -46.72323064638194, -46.72343777958702, -46.723228597046, -46.72343573020899, -46.72324969950812, -46.72341872618562, -46.72324765015288, -46.72341667682687, -46.72333595772651, -46.72333246837693, -46.72333390837159, -46.72333041901789, -46.72333246281817, -46.72333493430693, -46.72333144013111, -46.72333391161998, -46.72329973905271, -46.72336765825523, -46.72329871636572, -46.72336663556823, -46.72333467797527, -46.72333271914195, -46.7233336552883, 
  -46.72333169645492, -46.72332668842292, -46.72334070897847, -46.72332566572924, -46.72333968629816, -46.72335034532058, -46.7233170520929, -46.72334932263244}
 {-328.8669084850582, -328.8669113717488, -328.8669111107306, -328.8669058594045, -328.8669055983881, -328.866911254956, -328.866911227523, -328.8669057426127, -328.8669057151795, -328.8669116817458, -328.8669108007381, -328.8669061693973, -328.8669052883999, -328.8669171110809, -328.8669053714358, -328.8669115987363, -328.8668998590935, -328.8669112540588, -328.8669112284202, -328.8669057417154, -328.8669057160769, -328.8669128971415, -328.8669095854157, -328.8669073847889, -328.8669040730814, -328.8669114097893, -328.8669110726994, -328.8669058974461, -328.8669055603559, -328.8669151793387, -328.8669073031762, -328.866909666995, -328.866901790833, -328.8668979433159, -328.8669245405889, -328.8668924308333, -328.8669190283847, -328.8669153227794, -328.8669071600019, -328.8669098104368, 
  -328.8669016476577, -328.8669126390028, -328.8669098453609, -328.8669071266574, -328.8669043330194, -328.8669166387136, -328.8669058437415, -328.8669111263629, -328.8669003314055, -328.8669231347066, -328.8668993477056, -328.8669176223633, -328.8668938353621, -328.8669321547292, -328.8668903277343, -328.8669266423869, -328.86688481539, -328.8669086292836, -328.8669086018505, -328.8669083682662, -328.8669083408332, -328.8669090560721, -328.8669081750668, -328.8669087950521, -328.8669079140523, -328.8669144854087, -328.866902745763, -328.8669142243897, -328.8669024847473, -328.8669086283862, -328.8669086027478, -328.866908367369, -328.8669083417305, -328.8669102714651, -328.866906959747, -328.8669100104464, -328.8669066987312, -328.8669087841171, -328.8669084470265, -328.8669085230993, 
  -328.8669081860097, -328.8669125536661, -328.8669046775038, -328.8669122926488, -328.8669044164865, -328.8668953175713, -328.8669219149885, -328.8668950565591, -328.8669216539661, -328.8669126971096, -328.8669045343268, -328.8669124360878, -328.8669042733139, -328.8669100133296, -328.8669072196889, -328.8669097523116, -328.8669069586724, -328.8669140130365, -328.8669032180736, -328.866913752021, -328.8669029570545, -328.8669205090348, -328.8668967220323, -328.8669202480161, -328.8668964610165, -328.8669295290569, -328.8668877020616, -328.8669292680403, -328.8668874410438, -328.8669089392785, -328.8669080582758, -328.8669089118454, -328.8669080308428, -328.8669143686156, -328.8669026289715, -328.8669143411825, -328.8669026015385, -328.866908511594, -328.8669084859555, -328.8669084841609, 
  -328.8669084585224, -328.8669101546728, -328.8669068429548, -328.8669101272383, -328.8669068155232, -328.8669086673247, -328.8669083302344, -328.8669086398915}
 {-37.25402093262952, -37.25402595521072, -37.25402585274754, -37.25401601254625, -37.25401591008957, -37.25402588381608, -37.25402592414131, -37.25401594115441, -37.25401598148054, -37.25402596291511, -37.2540258450469, -37.25401602025139, -37.25401590238817, -37.25403135442891, -37.2540204535838, -37.2540214117657, -37.25401051092459, -37.25402581216701, -37.25402599579039, -37.25401586950578, -37.25401605312919, -37.2540205350814, -37.25403127294064, -37.25401059244178, -37.2540213302578, -37.25401956237588, -37.25403224560008, -37.25400961971466, -37.25402230293885, -37.25402493908844, -37.25402686892247, -37.25401499642771, -37.25401692626074, -37.25405316644564, -37.25399864433645, -37.25404322416355, -37.25398870129614, -37.25402171920935, -37.25403008920106, -37.25401177654512, 
  -37.25402014654284, -37.25404579333274, -37.25400601745199, -37.25403585067526, -37.25399607478701, -37.25403608368743, -37.2540157242315, -37.25402614100349, -37.25400578159301, -37.25403762133642, -37.25401418662891, -37.25402767867303, -37.25400424396986, -37.25402441229787, -37.25402739715142, -37.25401446963365, -37.25401745449319, -37.25402096369717, -37.25402100402271, -37.2540208612371, -37.25402090156291, -37.25402104279699, -37.25402092492749, -37.25402094033328, -37.25402082247135, -37.25402643430995, -37.25401553346524, -37.25402633184841, -37.25401543100692, -37.25402089204827, -37.25402107567163, -37.2540207895883, -37.25402097321172, -37.25401561497278, -37.25402635281174, -37.25401551251417, -37.25402625035047, -37.25401464225649, -37.25402732548195, -37.25401453979781, 
  -37.25402722302076, -37.25402001896987, -37.25402194880352, -37.25401991651006, -37.25402184634346, -37.25404824650609, -37.25399372403851, -37.25404814406688, -37.25399362155785, -37.25401679908445, -37.25402516908844, -37.25401669663378, -37.25402506661924, -37.25404087321516, -37.25400109733205, -37.25404077075662, -37.25400099487072, -37.25403116355765, -37.25401080412377, -37.25403106109704, -37.25401070166451, -37.25403270121756, -37.25400926651027, -37.25403259875566, -37.25400916405229, -37.25401949217825, -37.25402247703353, -37.25401938971705, -37.25402237457486, -37.25402097140193, -37.25402085353609, -37.25402101172747, -37.25402089386189, -37.25402636291597, -37.25401546207277, -37.25402640324154, -37.25401550239853, -37.25402082065501, -37.25402100427841, 
  -37.25402086098069, -37.25402104460408, -37.25401554358168, -37.25402628141636, -37.2540155839044, -37.25402632174499, -37.25401457086397, -37.25402725408799, -37.25401461118946}
 {-202.6825771252704, -202.6825768111812, -202.6825755460213, -202.68257870455, -202.6825774393841, -202.6825763044237, -202.6825760527789, -202.6825781977903, -202.6825779461437, -202.6825778903408, -202.682574466868, -202.682579783693, -202.6825763602472, -202.6825807639657, -202.6825715932749, -202.6825826573307, -202.6825734866413, -202.6825761186408, -202.6825762385618, -202.6825780120065, -202.6825781319276, -202.6825920066741, -202.682560350611, -202.6825938999688, -202.6825622440477, -202.6825727508564, -202.6825796063461, -202.6825746442222, -202.6825814997116, -202.6825733419898, -202.6825790152445, -202.682575235354, -202.6825809086117, -202.6826617868099, -202.6824905732121, -202.6826636811674, -202.682492465586, -202.6825631918417, -202.6825891656636, -202.6825650852027, 
  -202.6825910590341, -202.6825098623214, -202.6826424967667, -202.6825117557008, -202.6826443901187, -202.6825740284875, -202.6825783288976, -202.6825759216774, -202.6825802224392, -202.6825848968918, -202.6825674603019, -202.6825867902611, -202.682569353664, -202.6825613042178, -202.6825910546199, -202.6825631975927, -202.6825929479763, -202.6825778836748, -202.682577632029, -202.6825766185118, -202.6825763668661, -202.6825794695858, -202.6825760461242, -202.6825782044205, -202.6825747809635, -202.6825823432182, -202.6825731725236, -202.6825810780508, -202.6825719073651, -202.6825776978914, -202.6825778178124, -202.6825764327284, -202.6825765526495, -202.6825935858913, -202.682561929895, -202.6825923207242, -202.6825606647363, -202.6825743301101, -202.6825811855935, -202.6825730649411, 
  -202.6825799204366, -202.6825749212398, -202.6825805944957, -202.6825736560765, -202.6825793293331, -202.6826633665682, -202.682492151955, -202.6826621013817, -202.6824908868156, -202.6825647710749, -202.6825907449317, -202.6825635059421, -202.6825894797386, -202.682511441576, -202.6826440760132, -202.6825101764187, -202.6826428108447, -202.6825756076447, -202.6825799082416, -202.6825743424927, -202.6825786430678, -202.682586476145, -202.6825690395499, -202.6825852109805, -202.6825677743886, -202.6825628834701, -202.6825926338687, -202.6825616183129, -202.6825913687001, -202.682578962826, -202.6825755393667, -202.6825787111803, -202.6825752877211, -202.6825818364574, -202.6825726657672, -202.6825815848116, -202.6825724141216, -202.6825771911328, -202.6825773110538, -202.6825769394871, 
  -202.6825770594082, -202.6825930791313, -202.6825614231378, -202.6825928274842, -202.6825611714936, -202.6825738233486, -202.6825806788378, -202.6825735717026}
 {-188.790810714327, -188.790806063309, -188.7908016414553, -188.7908197872394, -188.790815365353, -188.7908038757725, -188.7908038289898, -188.7908175996862, -188.7908175529041, -188.790809640025, -188.7907980647416, -188.7908233639125, -188.7908117886822, -188.7907889618699, -188.7908187429209, -188.7908026857911, -188.7908324668278, -188.7908038323785, -188.7908038723839, -188.7908175562925, -188.7908175962979, -188.7907922654199, -188.7908154395452, -188.7908059893783, -188.7908291634148, -188.7908115144698, -188.7907961903734, -188.7908252383838, -188.7908099142874, -188.7908063147859, -188.7908013900042, -188.7908200387005, -188.7908151139177, -188.7908522325098, -188.7907554731984, -188.7908659572715, -188.7907691962647, -188.7907781974229, -188.7908295074484, -188.7907919213249, 
  -188.7908432313745, -188.7908281094158, -188.7907795962437, -188.7908418333401, -188.7907933201474, -188.7907969780176, -188.7908107269412, -188.790810701697, -188.7908244510898, -188.7907811464211, -188.790826558824, -188.790794870344, -188.7908402827291, -188.7908087841124, -188.7907989208976, -188.7908225080216, -188.7908126448165, -188.7908129486541, -188.7908129018717, -188.7908085267841, -188.7908084800018, -188.7908187128921, -188.790807137638, -188.7908142910249, -188.7908027157653, -188.790798034761, -188.7908278157934, -188.7907936128795, -188.7908233939348, -188.7908129052603, -188.7908129452655, -188.7908084833901, -188.7908085233958, -188.790801338326, -188.7908245124026, -188.7907969164517, -188.790820090537, -188.7908205873496, -188.7908052632572, -188.7908161654835, 
  -188.7908008413832, -188.7908153876678, -188.7908104628858, -188.7908109657982, -188.7908060410155, -188.7908613058593, -188.7907645456124, -188.7908568839016, -188.7907601238302, -188.7907872702834, -188.7908385803514, -188.7907828484439, -188.790834158451, -188.7908371823021, -188.7907886691208, -188.7908327604332, -188.7907842472498, -188.790806050756, -188.7908197999662, -188.790801628938, -188.7908153780443, -188.7907902193066, -188.790835631702, -188.790785797438, -188.7908312098306, -188.7908178569928, -188.7908079937808, -188.7908134351208, -188.7908035719128, -188.7908165253486, -188.7908049500921, -188.7908164785665, -188.7908049033093, -188.7907958472106, -188.7908256282542, -188.790795800428, -188.790825581472, -188.7908107177155, -188.7908107577208, -188.790810670933, 
  -188.7908107109385, -188.7907991507784, -188.7908223248607, -188.7907991039974, -188.7908222780769, -188.7908183998075, -188.7908030757098, -188.7908183530237}
 {-559.3891167578933, -559.3891136097525, -559.3891146554017, -559.3891188604196, -559.3891199060811, -559.3891140874346, -559.3891141777194, -559.3891193381077, -559.3891194283926, -559.3891131901967, -559.3891150749645, -559.3891184408703, -559.3891203256371, -559.3891174809961, -559.389110784173, -559.3891227316685, -559.3891160348467, -559.3891141317772, -559.3891141333766, -559.3891193824502, -559.3891193840498, -559.3891153287568, -559.389112936635, -559.3891205794258, -559.3891181873126, -559.3891143428099, -559.3891139223592, -559.3891195934832, -559.3891191730321, -559.3891194951423, -559.3891087700449, -559.3891247458155, -559.3891140207181, -559.3890761096644, -559.3891521568422, -559.3890813594352, -559.3891574084175, -559.3891114528721, -559.3891168124433, -559.3891167035689, 
  -559.3891220630928, -559.3891148662277, -559.3891134006578, -559.3891201168905, -559.3891186513414, -559.389120461058, -559.3891078042011, -559.3891257115657, -559.3891130550395, -559.3891313717639, -559.3890968932977, -559.3891366224366, -559.3891021439714, -559.389145796628, -559.389082468492, -559.3891510473016, -559.3890877191649, -559.3891161899234, -559.3891162802081, -559.3891172355788, -559.3891173258635, -559.3891152926858, -559.3891171774531, -559.3891163383408, -559.3891182231086, -559.3891195834842, -559.3891128866622, -559.3891206291401, -559.3891139323173, -559.389116234266, -559.3891162358656, -559.3891172799213, -559.3891172815209, -559.3891174312439, -559.3891150391259, -559.3891184768988, -559.3891160847816, -559.3891164452987, -559.389116024848, -559.3891174909542, 
  -559.3891170705032, -559.3891215976313, -559.3891108725337, -559.3891226432866, -559.3891119181891, -559.3890782117209, -559.389154259763, -559.3890792573383, -559.3891553054565, -559.3891135553856, -559.3891189149074, -559.3891146010153, -559.3891199605886, -559.389116968712, -559.3891155031512, -559.3891180143659, -559.3891165488079, -559.3891225634705, -559.389109906766, -559.389123609113, -559.3891109524344, -559.3891334742527, -559.3890989957865, -559.3891345199077, -559.3891000414423, -559.3891478991171, -559.3890845709806, -559.3891489447723, -559.3890856166361, -559.3891157703707, -559.3891176551383, -559.3891158606556, -559.389117745423, -559.3891200611697, -559.3891133643472, -559.3891201514543, -559.3891134546319, -559.3891167119511, -559.3891167135506, -559.389116802236, 
  -559.3891168038355, -559.3891179089289, -559.389115516811, -559.3891179992133, -559.3891156070962, -559.3891169229838, -559.389116502533, -559.3891170132687}
 {-15.88200203046571, -15.88200201834773, -15.88200201654388, -15.88200204438755, -15.8820020425837, -15.88200201754271, -15.88200201734891, -15.88200204358253, -15.88200204338873, -15.88200238559021, -15.88200164932121, -15.88200241162819, -15.88200167536288, -15.88200287002766, -15.88200116486462, -15.88200289606739, -15.88200119090454, -15.88200202163862, -15.882002013253, -15.88200204767843, -15.88200203929284, -15.88199582123917, -15.88200821441269, -15.88199584728475, -15.88200824044674, -15.88200192153442, -15.88200211335806, -15.88200194757412, -15.88200213939801, -15.88200303008574, -15.88200100481227, -15.8820030561251, -15.88200103085256, -15.88200191282273, -15.88200212207096, -15.88200193886227, -15.88200214811107, -15.88200135917973, -15.88200267573933, -15.88200138522069, 
  -15.88200270177801, -15.88200616719249, -15.88199786803945, -15.88200619323634, -15.88199789407524, -15.88200201930779, -15.88200201558384, -15.88200204534761, -15.88200204162366, -15.88200803386194, -15.88199600099378, -15.88200805990203, -15.88199602703334, -15.88201669798174, -15.88198733670748, -15.88201672402008, -15.88198736274879, -15.88200203146454, -15.88200203127073, -15.88200202966069, -15.88200202946688, -15.88200239951115, -15.88200166324393, -15.88200239770724, -15.88200166144014, -15.88200288394945, -15.8820011787865, -15.88200288214559, -15.88200117698265, -15.88200203556044, -15.88200202717484, -15.88200203375659, -15.88200202537099, -15.88199583516386, -15.88200822833165, -15.88199583336004, -15.88200822652777, -15.88200193545619, -15.88200212727995, 
  -15.88200193365233, -15.8820021254761, -15.88200304400734, -15.88200101873434, -15.88200304220348, -15.88200101693049, -15.88200192674442, -15.88200213599293, -15.88200192494056, -15.88200213418909, -15.88200137310212, -15.8820026896606, -15.88200137129829, -15.88200268785672, -15.88200618111632, -15.88199788195928, -15.88200617931249, -15.8819978801554, -15.88200203322962, -15.88200202950567, -15.88200203142577, -15.88200202770182, -15.8820080477839, -15.88199601491548, -15.88200804598005, -15.88199601311163, -15.88201671190283, -15.88198735063005, -15.88201671009897, -15.8819873488262, -15.8820023987061, -15.88200166243893, -15.88200239851229, -15.88200166224514, -15.88200288314442, -15.88200117798148, -15.88200288295062, -15.88200117778767, -15.88200203475542, -15.88200202636981, 
  -15.88200203456161, -15.88200202617601, -15.88199583435888, -15.88200822752659, -15.88199583416502, -15.88200822733283, -15.88200193465116, -15.88200212647493, -15.88200193445736}
 {-216.0423279669866, -216.0423290243465, -216.0423291132423, -216.042326820736, -216.0423269096404, -216.0423290744379, -216.0423290631503, -216.0423268708322, -216.0423268595435, -216.0423283068115, -216.0423298307779, -216.0423261032057, -216.0423276271715, -216.042327381408, -216.0423307561997, -216.0423251778015, -216.0423285525939, -216.0423291575365, -216.0423289800515, -216.0423269539304, -216.0423267764454, -216.042340088796, -216.0423180488008, -216.0423378851835, -216.042315845201, -216.0423379031244, -216.042320234474, -216.0423356995184, -216.0423180308678, -216.0423257943202, -216.0423323432858, -216.0423235907137, -216.0423301396801, -216.0423312566592, -216.0423268813224, -216.0423290531746, -216.0423246775947, -216.042335778416, -216.0423223592184, -216.0423335748037, 
  -216.0423201556185, -216.0422915566066, -216.0423665812462, -216.0422893530043, -216.0423643776362, -216.0423350905458, -216.0423230470062, -216.0423328869353, -216.0423208434044, -216.0423321356824, -216.042326001923, -216.0423299320763, -216.0423237983169, -216.042295339019, -216.0423627991859, -216.0422931354164, -216.0423605955763, -216.0423279281809, -216.0423279168929, -216.0423280170812, -216.0423280057929, -216.0423271605546, -216.0423286845206, -216.0423272494547, -216.0423287734208, -216.0423262351507, -216.0423296099427, -216.0423263240507, -216.0423296988429, -216.0423280112794, -216.0423278337944, -216.0423281001795, -216.0423279226945, -216.0423389425363, -216.0423169025463, -216.0423390314353, -216.0423169914476, -216.0423367568674, -216.0423190882168, -216.0423368457675, 
  -216.042319177117, -216.0423246480629, -216.0423311970288, -216.0423247369629, -216.0423312859291, -216.042330110447, -216.0423257350203, -216.0423301993788, -216.0423258238888, -216.0423346321563, -216.0423212129639, -216.0423347210554, -216.042321301865, -216.0422904103509, -216.0423654349878, -216.0422904992521, -216.0423655238867, -216.0423339442871, -216.0423219007507, -216.0423340331861, -216.042321989652, -216.0423309894254, -216.0423248556658, -216.0423310783254, -216.042324944566, -216.0422941927632, -216.0423616529275, -216.0422942816643, -216.0423617418266, -216.0423272106484, -216.0423287346144, -216.0423271993602, -216.0423287233263, -216.0423262852444, -216.0423296600366, -216.0423262739563, -216.0423296487484, -216.0423280613732, -216.0423278838882, -216.0423280500851, 
  -216.0423278726001, -216.0423389926298, -216.0423169526404, -216.0423389813412, -216.0423169413527, -216.0423368069612, -216.0423191383106, -216.042336795673}
 {-198.1494409326299, -198.1494406143197, -198.1494410928625, -198.1494407724074, -198.1494412509589, -198.1494408328224, -198.1494408743594, -198.1494409909141, -198.1494410324517, -198.1494400523001, -198.1494416548841, -198.1494402103925, -198.1494418129757, -198.1494404666474, -198.1494412405469, -198.1494406247391, -198.1494413986394, -198.1494408204587, -198.1494408867231, -198.1494409785508, -198.1494410448151, -198.1494380984475, -198.1494436088224, -198.1494382565415, -198.1494437669125, -198.1494396243587, -198.1494420828421, -198.1494397824506, -198.1494422409342, -198.1494423635822, -198.1494393436119, -198.1494425216743, -198.1494395017039, -198.1494477287843, -198.1494339788234, -198.1494478871208, -198.149434136671, -198.1494436710184, -198.1494380362145, 
  -198.1494438291022, -198.1494381943148, -198.1494487210798, -198.1494329866733, -198.1494488791752, -198.1494331447619, -198.1494459371954, -198.1494357699674, -198.1494460952528, -198.1494359280941, -198.1494451775947, -198.1494365295821, -198.1494453356865, -198.1494366876744, -198.149454826351, -198.1494268806612, -198.1494549844429, -198.1494270387534, -198.149440672588, -198.1494407141252, -198.149441151135, -198.1494411926725, -198.149439892066, -198.1494414946496, -198.1494403706131, -198.1494419731968, -198.1494403064129, -198.1494410803129, -198.1494407849602, -198.1494415588599, -198.1494406602244, -198.1494407264888, -198.1494411387716, -198.1494412050359, -198.1494379382141, -198.1494434485872, -198.1494384167614, -198.1494439271342, -198.1494394641243, -198.1494419226079, 
  -198.1494399426715, -198.149442401155, -198.1494422033479, -198.1494391833776, -198.149442681895, -198.1494396619247, -198.1494475686595, -198.1494338184796, -198.1494480472321, -198.1494342970013, -198.1494435107777, -198.1494378759865, -198.1494439893293, -198.1494383545293, -198.1494485608468, -198.1494328264376, -198.1494490393947, -198.1494333049841, -198.1494457769466, -198.1494356097475, -198.149446255488, -198.1494360883005, -198.1494450173604, -198.1494363693479, -198.1494454959074, -198.1494368478952, -198.1494546661167, -198.1494267204269, -198.1494551446638, -198.1494271989741, -198.1494401105707, -198.1494417131544, -198.149440152108, -198.1494417546917, -198.1494405249176, -198.1494412988176, -198.1494405664549, -198.1494413403549, -198.1494408787291, -198.1494409449935, 
  -198.1494409202664, -198.1494409865308, -198.1494381567189, -198.1494436670918, -198.1494381982562, -198.1494437086291, -198.1494396826291, -198.1494421411126, -198.1494397241664}
 {-269.1064190580335, -269.1064190624387, -269.1064190609485, -269.1064190551185, -269.1064190536282, -269.106419062346, -269.1064190610413, -269.1064190550257, -269.106419053721, -269.106419171316, -269.1064189520717, -269.1064191639954, -269.1064189447517, -269.1064197712961, -269.1064183520934, -269.1064197639759, -269.106418344773, -269.106419111772, -269.1064190116153, -269.1064191044517, -269.1064190042951, -269.1064190563435, -269.1064190670437, -269.1064190490233, -269.1064190597234, -269.1064190585997, -269.1064190647875, -269.1064190512794, -269.1064190574673, -269.1064190435055, -269.1064190798817, -269.1064190361852, -269.1064190725614, -269.106419273819, -269.1064188495696, -269.1064192664983, -269.1064188422498, -269.1064180830742, -269.106420040343, -269.1064180757541, 
  -269.1064200330225, -269.106419002676, -269.1064191207113, -269.1064189953557, -269.106419113391, -269.1064190631328, -269.1064190602544, -269.1064190558125, -269.1064190529342, -269.1064249134536, -269.1064132099005, -269.1064249061335, -269.1064132025802, -269.1064190627655, -269.1064190606217, -269.1064190554453, -269.1064190533015, -269.106419059431, -269.1064190581262, -269.1064190579407, -269.106419056636, -269.1064191684009, -269.1064189491568, -269.1064191669105, -269.1064189476666, -269.1064197683811, -269.1064183491783, -269.1064197668909, -269.1064183476881, -269.106419108857, -269.1064190087004, -269.1064191073667, -269.1064190072101, -269.1064190534285, -269.1064190641287, -269.1064190519382, -269.1064190626384, -269.1064190556846, -269.1064190618726, -269.1064190541943, 
  -269.1064190603823, -269.1064190405905, -269.1064190769667, -269.1064190391002, -269.1064190754764, -269.1064192709038, -269.1064188466548, -269.1064192694135, -269.1064188451646, -269.1064180801593, -269.1064200374279, -269.106418078669, -269.1064200359377, -269.106418999761, -269.1064191177962, -269.1064189982708, -269.106419116306, -269.1064190602177, -269.1064190573395, -269.1064190587275, -269.1064190558492, -269.1064249105387, -269.1064132069855, -269.1064249090484, -269.1064132054953, -269.1064190598505, -269.1064190577067, -269.1064190583602, -269.1064190562165, -269.1064191683081, -269.106418949064, -269.1064191670033, -269.1064189477594, -269.1064197682884, -269.1064183490856, -269.1064197669836, -269.1064183477808, -269.1064191087642, -269.1064190086076, -269.1064191074595, 
  -269.1064190073029, -269.1064190533357, -269.1064190640359, -269.106419052031, -269.1064190627312, -269.1064190555919, -269.1064190617798, -269.1064190542872}
 {-294.404749134559, -294.4047503462174, -294.4047504063123, -294.4047478628063, -294.4047479229043, -294.4047503737936, -294.4047503787356, -294.4047478903839, -294.4047478953261, -294.4047502294642, -294.4047505230652, -294.4047477460547, -294.4047480396555, -294.4047500971041, -294.4047506554441, -294.4047476136945, -294.4047481720345, -294.4047503519421, -294.404750400587, -294.4047478685325, -294.4047479171774, -294.4047495809895, -294.4047511715499, -294.40474709758, -294.4047486881402, -294.4047487319152, -294.4047520206443, -294.4047462485057, -294.4047495372346, -294.4047520917774, -294.4047486607623, -294.4047496083678, -294.4047461773527, -294.4047501987559, -294.4047505541765, -294.4047477153962, -294.404748070717, -294.4047523533253, -294.4047483992527, -294.4047498699133, 
  -294.4047459158455, -294.4047581227742, -294.4047426303438, -294.4047556393655, -294.4047401469333, -294.4047624728933, -294.4047382795628, -294.4047599894826, -294.4047357961543, -294.4047609891039, -294.4047397633793, -294.4047585056943, -294.4047372799697, -294.4047798489271, -294.4047209031921, -294.4047773655175, -294.4047184197825, -294.4047491020401, -294.404749106982, -294.4047491621364, -294.4047491670786, -294.4047489577108, -294.4047492513116, -294.4047490178072, -294.4047493114081, -294.4047488253505, -294.4047493836906, -294.4047488854471, -294.404749443787, -294.4047490801886, -294.4047491288335, -294.4047491402851, -294.4047491889301, -294.4047483092359, -294.4047498997964, -294.4047483693326, -294.4047499598928, -294.4047474601617, -294.4047507488906, -294.4047475202582, 
  -294.4047508089871, -294.4047508200238, -294.4047473890088, -294.4047508801203, -294.4047474491053, -294.4047489270118, -294.4047492824134, -294.4047489871394, -294.4047493424789, -294.4047510815711, -294.4047471274997, -294.4047511416665, -294.4047471875975, -294.4047568510208, -294.4047413585903, -294.404756911118, -294.404741418686, -294.4047612011395, -294.4047370078095, -294.4047612612353, -294.4047370679067, -294.4047597173504, -294.4047384916257, -294.4047597774469, -294.4047385517223, -294.4047785771735, -294.4047196314385, -294.40477863727, -294.4047196915351, -294.4047489852877, -294.4047492788885, -294.4047489902297, -294.4047492838306, -294.4047488529275, -294.4047494112675, -294.4047488578695, -294.4047494162096, -294.4047491077655, -294.4047491564104, -294.4047491127076, 
  -294.4047491613525, -294.4047483368129, -294.4047499273733, -294.404748341755, -294.4047499323153, -294.4047474877387, -294.4047507764676, -294.4047474926807}
 {-213.296844554488, -213.2968474447364, -213.2968467642145, -213.2968423447809, -213.2968416642583, -213.2968471100336, -213.2968470989167, -213.2968420100778, -213.2968419989608, -213.2968477308823, -213.2968464780679, -213.2968426309211, -213.2968413781175, -213.2968465977623, -213.2968476112063, -213.2968414978056, -213.2968425112512, -213.2968471042293, -213.296847104721, -213.2968420042734, -213.2968420047652, -213.2968469479372, -213.2968472610132, -213.2968418479838, -213.2968421610548, -213.2968470787989, -213.2968471301514, -213.2968419788431, -213.2968420301955, -213.2968471008844, -213.2968471080658, -213.2968420009286, -213.29684200811, -213.2968664143325, -213.2968277960424, -213.2968613145548, -213.2968226959084, -213.2968328977975, -213.2968613113041, -213.2968277978406, 
  -213.2968562113492, -213.2968471044752, -213.2968471044752, -213.2968420045193, -213.2968420045193, -213.2968518063938, -213.296842402544, -213.296846706426, -213.2968373026002, -213.2968456176261, -213.2968485914252, -213.2968405176711, -213.2968434914685, -213.2968471117682, -213.2968470971822, -213.2968420118123, -213.2968419972264, -213.296844900308, -213.2968448891909, -213.2968442197856, -213.2968442086686, -213.2968455211548, -213.2968442683441, -213.2968448406308, -213.2968435878234, -213.2968443880376, -213.2968454014795, -213.2968437075124, -213.2968447209601, -213.2968448945036, -213.2968448949954, -213.2968442139812, -213.296844214473, -213.2968447382127, -213.2968450512863, -213.2968440576905, -213.2968443707639, -213.2968448690732, -213.2968449204258, -213.296844188551, 
  -213.2968442399032, -213.2968448911587, -213.2968448983402, -213.2968442106365, -213.2968442178178, -213.2968642047161, -213.2968255862074, -213.2968635241533, -213.2968249057255, -213.2968306880676, -213.2968591015826, -213.2968300075526, -213.2968584210529, -213.2968448947495, -213.2968448947495, -213.2968442142271, -213.2968442142271, -213.2968495966585, -213.296840192828, -213.2968489161435, -213.2968395122984, -213.2968434079013, -213.2968463816986, -213.296842727378, -213.2968457011772, -213.2968449020425, -213.2968448874565, -213.2968442215201, -213.2968442069342, -213.296845186451, -213.296843933642, -213.296845175334, -213.296843922525, -213.2968440533332, -213.296845066778, -213.2968440422162, -213.2968450556611, -213.2968445598006, -213.2968445602923, -213.2968445486836, 
  -213.2968445491754, -213.2968444035104, -213.2968447165827, -213.2968443923922, -213.2968447054669, -213.2968445343705, -213.2968445857225, -213.2968445232531}
 {-412.0724781916643, -412.0724827808513, -412.0724822414739, -412.0724741419159, -412.0724736025428, -412.0724823853512, -412.0724826369734, -412.0724737464165, -412.0724739980415, -412.0724835099976, -412.0724815123383, -412.0724748710567, -412.0724728734126, -412.0724945809519, -412.0724704414551, -412.0724859420173, -412.0724618025231, -412.0724825139286, -412.072482508396, -412.0724738749952, -412.0724738694628, -412.0724625014612, -412.0725025211066, -412.0724538625945, -412.0724938821068, -412.0724806340272, -412.0724843883279, -412.0724719950936, -412.0724757493949, -412.0724870882979, -412.0724779341252, -412.0724784493662, -412.0724692951903, -412.0724761567558, -412.0724888705007, -412.0724675177252, -412.0724802316649, -412.072459365412, -412.0725056576385, -412.0724507264792, 
  -412.0724970187048, -412.0724276285071, -412.07253739905, -412.0724189895724, -412.072528760118, -412.0724939970801, -412.0724710253278, -412.0724853579895, -412.0724623865519, -412.0725130288949, -412.0724519933132, -412.0725043899605, -412.0724433543811, -412.0725158383211, -412.0724491853148, -412.0725071993792, -412.0724405463902, -412.0724783355405, -412.072478587164, -412.0724777961652, -412.072478047789, -412.0724794601862, -412.0724774625296, -412.0724789208062, -412.0724769231593, -412.0724905311422, -412.0724663916446, -412.0724899917652, -412.0724658522714, -412.0724784641186, -412.0724784585861, -412.0724779247434, -412.0724779192109, -412.0724584516834, -412.0724984712645, -412.0724579123104, -412.072497931887, -412.0724765842139, -412.0724803385214, -412.0724760448452, 
  -412.0724797991396, -412.0724830384885, -412.0724738843146, -412.0724824991138, -412.0724733449391, -412.0724721069388, -412.0724848206978, -412.0724715674803, -412.072484281406, -412.0724553155998, -412.0725016078308, -412.0724547762295, -412.0725010684508, -412.0724235786981, -412.0725333492391, -412.0724230393198, -412.0725328098672, -412.0724899471904, -412.0724669755974, -412.0724894078172, -412.0724664362204, -412.0725089790843, -412.0724479435039, -412.0725084397092, -412.0724474041285, -412.0725117885097, -412.0724451355061, -412.0725112491286, -412.072444596137, -412.072479064684, -412.0724770670323, -412.0724793163076, -412.0724773186559, -412.0724901356416, -412.0724659961459, -412.0724903872651, -412.0724662477696, -412.0724780686189, -412.0724780630864, -412.0724783202425, 
  -412.0724783147099, -412.0724580561865, -412.0724980757619, -412.0724583078065, -412.072498327389, -412.0724761887176, -412.0724799430183, -412.0724764403408}
 {-296.0559958619115, -296.0559987501013, -296.0559984123312, -296.0559933115104, -296.0559929737412, -296.0559985935901, -296.0559985688421, -296.0559931549997, -296.0559931302516, -296.0559989102212, -296.0559982522127, -296.0559934716276, -296.0559928136254, -296.0560019054961, -296.0559952569558, -296.0559964669049, -296.0559898183662, -296.0559985675089, -296.0559985949232, -296.0559931289185, -296.0559931563328, -296.055998868672, -296.0559982937993, -296.0559934300799, -296.0559928552106, -296.0559976976437, -296.055999464798, -296.0559922590535, -296.0559940262073, -296.0560016803353, -296.0559954821232, -296.0559962417447, -296.0559900435329, -296.0560126215359, -296.0559845423243, -296.056007183086, -296.0559791035934, -296.0559926628338, -296.0560044997857, -296.0559872242425, 
  -296.0559990611961, -296.0559910526009, -296.0560061111992, -296.0559856140128, -296.0560006726065, -296.0560038679809, -296.0559932944285, -296.0559984293834, -296.0559878558453, -296.0560092525839, -296.0559879098031, -296.0560038139934, -296.0559824712127, -296.0560235316164, -296.055973630615, -296.0560180930263, -296.0559681920241, -296.0559960431705, -296.0559960184225, -296.0559957054008, -296.0559956806528, -296.0559963598008, -296.0559957017939, -296.0559960220295, -296.0559953640257, -296.0559993550769, -296.0559927065358, -296.0559990173056, -296.0559923687677, -296.0559960170894, -296.0559960445036, -296.0559956793197, -296.0559957067339, -296.0559963182517, -296.0559957433805, -296.0559959804818, -296.055995405611, -296.0559951472244, -296.0559969143781, -296.0559948094544, 
  -296.0559965766088, -296.0559991299156, -296.0559929317037, -296.0559987921459, -296.055992593934, -296.0560100711956, -296.0559819918256, -296.056009733408, -296.0559816540738, -296.0559901124112, -296.0560019493691, -296.0559897746466, -296.0560016115943, -296.0559885021821, -296.0560035607789, -296.0559881644133, -296.0560032230083, -296.0560013175562, -296.0559907440142, -296.0560009797898, -296.0559904062413, -296.056006702165, -296.0559853593828, -296.056006364394, -296.0559850216145, -296.0560209811968, -296.0559710801954, -296.0560206434275, -296.0559707424253, -296.0559962032891, -296.0559955452837, -296.055996178541, -296.0559955205357, -296.0559991985651, -296.0559925500256, -296.0559991738171, -296.0559925252775, -296.0559958605784, -296.0559958879926, -296.0559958358304, 
  -296.0559958632445, -296.0559961617412, -296.0559955868691, -296.055996136992, -296.0559955621222, -296.0559949907133, -296.0559967578673, -296.0559949659652}
 {-198.3878286555616, -198.3878298627429, -198.387829676044, -198.3878276350854, -198.3878274483874, -198.387829753387, -198.3878297853999, -198.3878275257305, -198.3878275577424, -198.3878312945827, -198.3878282442054, -198.3878290669255, -198.3878260165485, -198.3878313688313, -198.3878281699569, -198.3878291411743, -198.3878259422999, -198.3878295879282, -198.3878299508587, -198.3878273602712, -198.3878277232017, -198.3878306385926, -198.3878289002406, -198.3878284109357, -198.3878266725835, -198.3878307920927, -198.3878287466959, -198.3878285644358, -198.3878265190389, -198.3878304704064, -198.3878290684104, -198.3878282427494, -198.3878268407534, -198.3878308620094, -198.3878286770474, -198.3878286344229, -198.3878264493199, -198.3878220602473, -198.3878374785723, -198.3878198325853, 
  -198.3878352509202, -198.3878286502772, -198.3878308889096, -198.3878264226222, -198.3878286612506, -198.3878400212124, -198.3878195175349, -198.387837793563, -198.3878172898702, -198.387829468342, -198.387830070597, -198.387827240685, -198.38782784294, -198.3878485646973, -198.3878109741756, -198.3878463370403, -198.3878087465186, -198.3878287329046, -198.3878287649171, -198.3878285462063, -198.3878285782186, -198.3878302741001, -198.3878272237228, -198.3878300874016, -198.3878270370244, -198.3878303483488, -198.3878271494743, -198.3878301616503, -198.3878269627759, -198.3878285674456, -198.3878289303761, -198.3878283807471, -198.3878287436777, -198.3878296181101, -198.387827879758, -198.3878294314116, -198.3878276930595, -198.3878297716101, -198.3878277262133, -198.3878295849117, 
  -198.3878275395148, -198.3878294499238, -198.3878280479278, -198.3878292632253, -198.3878278612294, -198.3878298415609, -198.3878276565306, -198.3878296548647, -198.3878274698299, -198.3878210397626, -198.3878364580918, -198.3878208530634, -198.3878362713941, -198.3878276297956, -198.3878298684261, -198.3878274430973, -198.3878296817275, -198.3878390007325, -198.3878184970497, -198.3878388140363, -198.387818310349, -198.3878284478595, -198.3878290501144, -198.387828261161, -198.387828863416, -198.3878475442148, -198.387809953693, -198.3878473575162, -198.3878097669946, -198.3878301647446, -198.3878271143674, -198.387830196757, -198.3878271463798, -198.3878302389933, -198.3878270401189, -198.3878302710057, -198.3878270721313, -198.3878284580901, -198.3878288210207, -198.3878284901025, 
  -198.3878288530331, -198.3878295087546, -198.3878277704025, -198.387829540767, -198.387827802415, -198.3878296622547, -198.3878276168579, -198.3878296942671}
 {-416.3697171034163, -416.3697203537874, -416.3697197009539, -416.3697145058969, -416.3697138530645, -416.3697200334748, -416.3697200212652, -416.3697141855848, -416.3697141733754, -416.3697203818531, -416.3697196728846, -416.3697145339574, -416.3697138250005, -416.3697142335603, -416.3697258211827, -416.3697083856691, -416.3697199732941, -416.3697200106123, -416.3697200441277, -416.3697141627223, -416.3697141962378, -416.3697198811365, -416.3697201736036, -416.369714033249, -416.3697143257112, -416.3697201364952, -416.3697199182447, -416.3697142886055, -416.3697140703546, -416.3697200359431, -416.369720018797, -416.3697141880532, -416.3697141709069, -416.3697069090572, -416.3697331470307, -416.3697010610791, -416.3697272992289, -416.3697398782906, -416.3697001765951, -416.3697340304001, 
  -416.3696943287058, -416.3697200565347, -416.3697199982055, -416.3697142086447, -416.3697141503154, -416.3697255527275, -416.3697145019849, -416.3697197048348, -416.3697086540977, -416.3697101674035, -416.3697298875894, -416.3697043195148, -416.369724039698, -416.369720026223, -416.3697200285169, -416.369714178333, -416.3697141806271, -416.3697174359382, -416.3697174237287, -416.3697167831052, -416.3697167708957, -416.3697177843137, -416.369717075351, -416.3697171314807, -416.369716422518, -416.3697116360249, -416.369723223645, -416.3697109831884, -416.3697225708156, -416.3697174130757, -416.3697174465911, -416.3697167602428, -416.3697167937582, -416.3697172836011, -416.3697175760657, -416.369716630768, -416.3697169232329, -416.3697175389586, -416.3697173207082, -416.369716886126, 
  -416.3697166678749, -416.3697174384065, -416.3697174212603, -416.3697167855736, -416.3697167684274, -416.3697043114405, -416.3697305495742, -416.3697036586796, -416.3697298966693, -416.3697372807567, -416.3696975790559, -416.3697366279179, -416.3696969262288, -416.369717458998, -416.3697174006688, -416.3697168061652, -416.3697167478358, -416.3697229551856, -416.3697119044537, -416.3697223023606, -416.3697112516129, -416.3697075698684, -416.3697272900513, -416.3697069170338, -416.3697266372201, -416.3697174286865, -416.3697174309804, -416.3697167758535, -416.3697167781475, -416.3697174640014, -416.3697167550386, -416.3697174517917, -416.3697167428291, -416.3697113157109, -416.3697229033344, -416.3697113035012, -416.3697228911249, -416.3697170927634, -416.3697171262788, 
  -416.3697170805539, -416.3697171140692, -416.3697169632894, -416.3697172557528, -416.3697169510786, -416.3697172435445, -416.3697172186467, -416.3697170003955, -416.3697172064367}
 {-279.8078398473007, -279.8078455530301, -279.8078450940333, -279.8078346006035, -279.8078341416108, -279.8078452915926, -279.8078453554697, -279.8078343391677, -279.8078344030456, -279.8078455785304, -279.8078450685332, -279.8078346261033, -279.8078341161112, -279.8078474921318, -279.8078431549802, -279.8078365397055, -279.8078322025574, -279.8078453546144, -279.8078452924479, -279.8078344021899, -279.8078343400234, -279.8078402108917, -279.8078504362129, -279.8078292584945, -279.8078394837611, -279.8078470656183, -279.8078435814677, -279.8078361131942, -279.8078326290429, -279.807843801547, -279.8078468455659, -279.8078328491229, -279.8078358931408, -279.8078524164218, -279.8078382334644, -279.807841464196, -279.807827280841, -279.8078640088953, -279.8078266386042, -279.8078530564704, 
  -279.8078156861799, -279.8078941659964, -279.8077964838892, -279.8078832135774, -279.8077855314591, -279.8078563420564, -279.8078343049522, -279.8078453896216, -279.8078233525379, -279.8078512957379, -279.8078393514353, -279.8078403433117, -279.8078283990125, -279.807836087809, -279.8078545611023, -279.8078251353804, -279.8078436086818, -279.80784004486, -279.8078401087374, -279.8078395858652, -279.8078396497427, -279.8078403317974, -279.8078398218012, -279.807839872801, -279.8078393628081, -279.8078422453998, -279.8078379082471, -279.8078417864022, -279.8078374492552, -279.807840107882, -279.8078400457155, -279.8078396488871, -279.8078395867207, -279.807834964172, -279.8078451894677, -279.807834505179, -279.8078447304712, -279.8078418188848, -279.8078383347363, -279.8078413598924, 
  -279.8078378757392, -279.8078385548147, -279.8078415988332, -279.80783809582, -279.8078411398384, -279.8078471697621, -279.8078329866591, -279.8078467108206, -279.8078325276112, -279.8078587621611, -279.8078213918734, -279.8078583031694, -279.8078209328756, -279.8078889192653, -279.8077912371554, -279.8078884602734, -279.8077907781578, -279.8078510953165, -279.8078290582272, -279.8078506363264, -279.8078285992278, -279.8078460490058, -279.8078341047026, -279.8078455900087, -279.8078336457102, -279.8078308410756, -279.8078493143707, -279.8078303820787, -279.8078488553783, -279.8078400703599, -279.8078395603654, -279.8078401342376, -279.8078396242428, -279.8078419839617, -279.8078376468118, -279.8078420478392, -279.8078377106894, -279.8078398464453, -279.8078397842788, -279.8078399103228, 
  -279.8078398481564, -279.8078347027378, -279.8078449280286, -279.8078347666121, -279.8078449919092, -279.8078415574495, -279.8078380732982, -279.8078416213268}
 {-139.8110447601623, -139.8110446600268, -139.8110445541727, -139.8110449661764, -139.8110448603181, -139.8110446248429, -139.8110445893566, -139.8110449309911, -139.8110448955033, -139.8110451956722, -139.8110440185313, -139.8110455018193, -139.811044324679, -139.8110451730813, -139.8110440411204, -139.8110454792288, -139.8110443472678, -139.8110445782192, -139.8110446359802, -139.8110448843667, -139.8110449421277, -139.8110424220824, -139.8110467922675, -139.8110427282306, -139.8110470984142, -139.8110449122234, -139.8110443019793, -139.8110452183709, -139.8110446081268, -139.8110469799918, -139.8110422342274, -139.8110472861391, -139.8110425403749, -139.8110483870125, -139.8110408274544, -139.811048693355, -139.8110411334068, -139.8110425579759, -139.8110466562559, -139.8110428641143, 
  -139.8110469624124, -139.8110480899456, -139.8110411246377, -139.8110483960967, -139.8110414307815, -139.8110503710346, -139.8110388431335, -139.8110506771572, -139.8110391493058, -139.811050130219, -139.8110390839536, -139.8110504363665, -139.8110393901011, -139.8110595797396, -139.8110296342439, -139.811059885887, -139.8110299403914, -139.811044830834, -139.8110447953469, -139.8110447249778, -139.8110446894907, -139.8110454016627, -139.8110442245221, -139.8110452958065, -139.8110441186659, -139.811045379072, -139.811044247111, -139.8110452732158, -139.8110441412549, -139.8110447842099, -139.8110448419709, -139.8110446783538, -139.8110447361148, -139.8110426280734, -139.8110469982577, -139.8110425222172, -139.8110468924016, -139.8110451182141, -139.81104450797, -139.811045012358, 
  -139.8110444021138, -139.8110471859824, -139.8110424402181, -139.8110470801262, -139.8110423343619, -139.8110485931044, -139.8110410333439, -139.8110484872409, -139.8110409274951, -139.8110427639605, -139.8110468622526, -139.8110426581074, -139.8110467563934, -139.8110482959381, -139.8110413306265, -139.8110481900818, -139.8110412247705, -139.8110505770122, -139.8110390491372, -139.8110504711573, -139.8110389432798, -139.8110503362097, -139.8110392899443, -139.8110502303535, -139.8110391840882, -139.8110597857303, -139.8110298402346, -139.8110596798741, -139.8110297343785, -139.8110453664781, -139.8110441893375, -139.8110453309911, -139.8110441538504, -139.8110453438874, -139.8110442119264, -139.8110453084003, -139.8110441764394, -139.8110447490253, -139.8110448067863, 
  -139.8110447135383, -139.8110447712993, -139.8110425928888, -139.8110469630732, -139.8110425574018, -139.8110469275861, -139.8110450830295, -139.8110444727854, -139.8110450475425}
 {-453.9757325348262, -453.975732910695, -453.9757331754939, -453.9757318941663, -453.9757321589686, -453.9757329797714, -453.9757331064173, -453.9757319632438, -453.9757320898911, -453.9757327148188, -453.9757333713715, -453.9757316982922, -453.9757323548441, -453.975734254159, -453.9757318320362, -453.9757332376317, -453.9757308155094, -453.9757329895057, -453.9757330966832, -453.9757319729786, -453.9757320801561, -453.9757243519757, -453.9757417342498, -453.9757233354588, -453.9757407177127, -453.9757302304206, -453.9757358557712, -453.9757292138932, -453.9757348392447, -453.9757266118325, -453.9757394743817, -453.9757255953057, -453.9757384578545, -453.9757254050052, -453.9757406817282, -453.9757243882358, -453.9757396654437, -453.9757331828487, -453.975732903405, -453.9757321663282, 
  -453.9757318868714, -453.975698176753, -453.9757679101197, -453.9756971602232, -453.9757668935955, -453.9757379573659, -453.9757281288068, -453.9757369408109, -453.9757271123078, -453.9757385535842, -453.9757275325774, -453.9757375370568, -453.9757265160508, -453.9757215678672, -453.9757445193307, -453.9757205513393, -453.9757435028045, -453.9757323391028, -453.9757324657493, -453.9757326039033, -453.97573273055, -453.9757320741507, -453.9757327307028, -453.9757323389511, -453.9757329955036, -453.9757336134905, -453.975731191368, -453.9757338782913, -453.9757314561685, -453.9757323488372, -453.9757324560147, -453.9757326136379, -453.9757327208154, -453.975723711312, -453.9757410935767, -453.9757239761132, -453.9757413583767, -453.9757295897518, -453.9757352151033, -453.9757298545529, 
  -453.9757354799034, -453.9757259711642, -453.9757388337131, -453.9757262359648, -453.9757390985137, -453.9757247642235, -453.9757400411731, -453.9757250290082, -453.9757403059896, -453.9757325421867, -453.9757322627302, -453.9757328069811, -453.975732527537, -453.9756975360835, -453.9757672694525, -453.9756978008835, -453.9757675342536, -453.9757373166852, -453.9757274881508, -453.9757375814825, -453.9757277529548, -453.9757379129157, -453.9757268919091, -453.9757381777163, -453.9757271567099, -453.9757209271986, -453.9757438786625, -453.9757211919988, -453.9757441434635, -453.9757321432274, -453.9757327997799, -453.9757322698742, -453.9757329264265, -453.9757336825675, -453.9757312604448, -453.9757338092141, -453.9757313870915, -453.9757324179142, -453.9757325250917, 
  -453.9757325445608, -453.9757326517384, -453.9757237803892, -453.9757411626534, -453.975723907036, -453.9757412892999, -453.975729658829, -453.97573528418, -453.9757297854756}
 {-267.3368588389248, -267.3368570446634, -267.3368580709071, -267.336859606981, -267.3368606332366, -267.336857584732, -267.3368575308376, -267.3368601470559, -267.3368600931608, -267.3368561510844, -267.3368589644924, -267.336858713412, -267.3368615268118, -267.3368611085235, -267.336854007084, -267.336863670846, -267.3368565694084, -267.336857677964, -267.3368574376057, -267.3368602402875, -267.3368599999292, -267.336876221236, -267.3368388945366, -267.3368787835247, -267.3368414568948, -267.3368600868149, -267.3368550287853, -267.3368626491395, -267.3368575911078, -267.3368694510216, -267.336845664616, -267.336872013344, -267.3368482269403, -267.3369221114162, -267.3367930065995, -267.3369246750144, -267.3367955676484, -267.3368689443156, -267.3368461715392, -267.3368715066149, 
  -267.3368487338868, -267.336790977824, -267.3369241402395, -267.336793540162, -267.3369267025483, -267.3368669874323, -267.3368481282591, -267.3368695495565, -267.3368506907818, -267.3368756349759, -267.3368394805613, -267.336878197297, -267.3368420428872, -267.336886142957, -267.3368289729263, -267.336888705285, -267.3368315352452, -267.3368583527477, -267.3368582988532, -267.3368593789974, -267.3368593251026, -267.3368569191026, -267.3368597325053, -267.3368579453511, -267.3368607587561, -267.3368618765385, -267.3368547751001, -267.3368629027883, -267.3368558013495, -267.3368584459795, -267.3368582056212, -267.3368594722292, -267.3368592318709, -267.336876989234, -267.3368396625698, -267.3368780154841, -267.3368406888189, -267.336860854832, -267.3368557967994, -267.3368618810797, 
  -267.3368568230509, -267.3368702190367, -267.336846432632, -267.3368712452862, -267.3368474588815, -267.3369228800475, -267.3367937739993, -267.3369239063403, -267.3367948002057, -267.3368697122994, -267.3368469395866, -267.3368707385885, -267.3368479657966, -267.3367917458459, -267.3369249082486, -267.3367927720974, -267.3369259344964, -267.3368677553551, -267.3368488963675, -267.3368687815911, -267.3368499226307, -267.336876402991, -267.3368402485774, -267.3368774292392, -267.3368412748284, -267.3368869109745, -267.33682974094, -267.336887937225, -267.3368307671887, -267.3368574591738, -267.3368602725776, -267.3368574052791, -267.336860218683, -267.3368624166103, -267.3368553151717, -267.3368623627156, -267.3368552612771, -267.3368589860512, -267.336858745693, -267.3368589321566, 
  -267.3368586917984, -267.336877529307, -267.3368402026402, -267.3368774754102, -267.3368401487476, -267.3368613949027, -267.3368563368722, -267.3368613410081}
 {-1826.641659719267, -1826.641672584942, -1826.641673928934, -1826.641645509798, -1826.64164685374, -1826.641673251473, -1826.6416732624, -1826.641646176305, -1826.641646187231, -1826.641680760254, -1826.641665753633, -1826.641653685025, -1826.641638678525, -1826.64166036802, -1826.641686145898, -1826.641633292865, -1826.641659070716, -1826.641672853669, -1826.641673660204, -1826.6416457785, -1826.641646585036, -1826.641692783056, -1826.641653730864, -1826.641665707741, -1826.641626655842, -1826.641645535745, -1826.64170097821, -1826.64161846058, -1826.641673903038, -1826.641647062667, -1826.64169945127, -1826.641619987496, -1826.641672376104, -1826.641683035088, -1826.64166348036, -1826.641655959497, -1826.641636405615, -1826.641692480634, -1826.641654033421, -1826.64166540549, 
  -1826.641626958229, -1826.641786022223, -1826.64156049325, -1826.641758947035, -1826.641533418101, -1826.641680858994, -1826.641665654885, -1826.641653784021, -1826.641638579522, -1826.641662095846, -1826.641684418372, -1826.641635020697, -1826.641657343184, -1826.641575307639, -1826.641771211718, -1826.64154823249, -1826.64174413653, -1826.641659041822, -1826.641659052748, -1826.641660385789, -1826.641660396716, -1826.641666550574, -1826.64165154401, -1826.641667894538, -1826.641652887981, -1826.641646158374, -1826.641671936242, -1826.641647502345, -1826.641673280205, -1826.641658644018, -1826.641659450554, -1826.641659987984, -1826.641660794521, -1826.641678573327, -1826.64163952129, -1826.641679917302, -1826.641640865249, -1826.641631326094, -1826.641686768558, -1826.641632670063, 
  -1826.641688112523, -1826.641632853015, -1826.64168524162, -1826.641634196982, -1826.641686585587, -1826.641668825162, -1826.641649270984, -1826.641670169257, -1826.641650614824, -1826.641678270992, -1826.641639823761, -1826.641679614965, -1826.641641167722, -1826.641771812561, -1826.64154628361, -1826.641773156531, -1826.641547627574, -1826.641666649449, -1826.641651445129, -1826.641667993399, -1826.641652789112, -1826.641647886205, -1826.641670208711, -1826.641649230172, -1826.641671552678, -1826.641561097999, -1826.641757002056, -1826.641562441963, -1826.641758346026, -1826.641667217092, -1826.641652210531, -1826.641667228018, -1826.641652221458, -1826.641646824894, -1826.641672602759, -1826.641646835821, -1826.641672613685, -1826.641659310537, -1826.641660117072, -1826.641659321463, 
  -1826.641660127999, -1826.641679239854, -1826.641640187801, -1826.641679250773, -1826.641640198735, -1826.641631992614, -1826.641687435076, -1826.641632003541}
 {-339.5523093750234, -339.5523119984523, -339.5523120360082, -339.552306714043, -339.5523067515989, -339.5523120006679, -339.5523120337923, -339.5523067162586, -339.5523067493831, -339.5523120442717, -339.552311990189, -339.5523067598623, -339.5523067057796, -339.5523138466751, -339.552310187794, -339.5523085622658, -339.5523049033847, -339.5523119215106, -339.5523121129496, -339.5523066371014, -339.5523068285403, -339.5523114477295, -339.5523125867206, -339.5523061633198, -339.5523073023118, -339.5523074962823, -339.5523165381829, -339.5523022118731, -339.5523112537737, -339.5523009788479, -339.5523230556664, -339.5522956944386, -339.5523177712572, -339.5523134687863, -339.5523105665143, -339.552308184341, -339.552305282141, -339.5523112137441, -339.5523128208164, -339.5523059293351, 
  -339.5523075364069, -339.5522554994683, -339.5523685360829, -339.552250215059, -339.5523632516736, -339.5523240507593, -339.5522999836289, -339.5523187663501, -339.5522946992195, -339.5523230786689, -339.552300955737, -339.5523177942595, -339.5522956713278, -339.5522981965363, -339.5523258395204, -339.5522929121271, -339.552320555111, -339.5523093396834, -339.5523093728077, -339.5523093772392, -339.5523094103638, -339.5523093832871, -339.5523093292043, -339.5523094208428, -339.5523093667605, -339.5523111856906, -339.5523075268095, -339.5523112232465, -339.5523075643653, -339.5523092605261, -339.5523094519651, -339.552309298082, -339.5523094895209, -339.5523087867443, -339.5523099257367, -339.552308824301, -339.5523099632919, -339.5523048352977, -339.5523138771985, -339.5523048728538, 
  -339.5523139147544, -339.5522983178633, -339.5523203946819, -339.5522983554193, -339.5523204322378, -339.5523108077957, -339.5523079055359, -339.5523108453278, -339.5523079431156, -339.5523085527601, -339.5523101598315, -339.5523085903155, -339.552310197388, -339.552252838484, -339.5523658750981, -339.5522528760394, -339.5523659126546, -339.5523213897751, -339.552297322644, -339.5523214273305, -339.5522973602005, -339.5523204176844, -339.5522982947523, -339.5523204552401, -339.5522983323086, -339.5522955355518, -339.5523231785357, -339.5522955731077, -339.5523232160919, -339.5523093855027, -339.5523093314201, -339.5523094186272, -339.5523093645444, -339.5523111879062, -339.5523075290251, -339.5523112210306, -339.5523075621495, -339.5523092627418, -339.5523094541807, -339.5523092958662, 
  -339.5523094873051, -339.5523087889604, -339.552309927952, -339.5523088220848, -339.5523099610764, -339.5523048375135, -339.552313879414, -339.5523048706379}
 {-314.6732735316553, -314.6732783468441, -314.6732779612185, -314.6732691021285, -314.6732687165059, -314.6732781311649, -314.6732781768971, -314.6732688864504, -314.6732689321833, -314.6732786141953, -314.6732776938699, -314.6732693694763, -314.6732684491606, -314.6732824347269, -314.6732738733726, -314.6732731900114, -314.6732646286599, -314.6732781903746, -314.6732781176875, -314.6732689456603, -314.6732688729733, -314.6732745935605, -314.6732817145637, -314.6732653488633, -314.6732724698328, -314.6732795053727, -314.6732768027049, -314.6732702606589, -314.6732675579904, -314.6732820754996, -314.6732742325982, -314.6732728307857, -314.6732649878837, -314.6732874915803, -314.6732688193325, -314.6732782470208, -314.6732595744639, -314.6732889629916, -314.6732673453752, 
  -314.6732797182758, -314.6732581006626, -314.673277292518, -314.6732790174293, -314.673268047806, -314.6732697727131, -314.6732873516194, -314.6732689564222, -314.6732781068727, -314.6732597117404, -314.673286570275, -314.6732697377826, -314.6732773255603, -314.673260493069, -314.673298815976, -314.6732574920825, -314.6732895712599, -314.6732482473704, -314.6732737016014, -314.6732737473339, -314.6732733159773, -314.6732733617099, -314.673274184631, -314.6732732643075, -314.673273799004, -314.6732728786863, -314.673278005164, -314.6732694438089, -314.6732776195377, -314.673269058187, -314.6732737608112, -314.6732736881241, -314.6732733751871, -314.6732733025, -314.6732701640055, -314.6732772849922, -314.6732697783817, -314.6732768993677, -314.6732750758088, -314.6732723731422, 
  -314.6732746901864, -314.6732719875164, -314.6732776459364, -314.6732698030347, -314.6732772603123, -314.6732694174106, -314.6732830620747, -314.6732643897116, -314.6732826764899, -314.6732640040482, -314.6732845334262, -314.6732629158139, -314.6732841478046, -314.6732625301873, -314.6732728629554, -314.6732745878654, -314.6732724773321, -314.6732742022404, -314.6732829220384, -314.6732645268765, -314.6732825364171, -314.6732641412496, -314.6732821407121, -314.6732653082188, -314.6732817550866, -314.6732649225962, -314.6732943864124, -314.6732530625195, -314.6732940007869, -314.6732526768968, -314.673273968951, -314.6732730486303, -314.6732740146835, -314.6732730943628, -314.6732777894843, -314.6732692281313, -314.6732778352168, -314.6732692738639, -314.6732735451326, 
  -314.6732734724455, -314.6732735908651, -314.6732735181781, -314.6732699483279, -314.6732770693124, -314.6732699940586, -314.6732771150469, -314.6732748601311, -314.6732721574627, -314.6732749058634}
 {-412.6076697946444, -412.6076701823195, -412.6076701242215, -412.6076694650695, -412.6076694069709, -412.6076701618637, -412.6076701446773, -412.6076694446136, -412.6076694274269, -412.6076700545771, -412.6076702519642, -412.6076693373268, -412.6076695347139, -412.6076709767625, -412.6076693297793, -412.6076702595123, -412.6076686125289, -412.6076701621049, -412.6076701444362, -412.6076694448545, -412.6076694271859, -412.6076712408453, -412.6076690657085, -412.6076705235948, -412.6076683484583, -412.607669897571, -412.6076704089712, -412.6076691803206, -412.6076696917209, -412.6076708228155, -412.6076694837305, -412.6076701055651, -412.6076687664802, -412.607666900536, -412.6076734062067, -412.6076661832116, -412.6076726890306, -412.6076691280797, -412.6076711784857, -412.6076684108315, 
  -412.6076704612332, -412.6076755374244, -412.6076647694118, -412.6076748201733, -412.6076640521624, -412.6076759002544, -412.6076644062556, -412.6076751829972, -412.6076636890122, -412.6076759950793, -412.607664311429, -412.607675277829, -412.6076635941788, -412.6076840274123, -412.6076562789637, -412.607683310162, -412.6076555617134, -412.6076698322869, -412.6076698151003, -412.6076697741885, -412.607669757002, -412.6076697250001, -412.6076699223874, -412.6076696669019, -412.607669864289, -412.6076706471856, -412.6076690002024, -412.6076705890873, -412.6076689421041, -412.607669832528, -412.6076698148593, -412.6076697744296, -412.607669756761, -412.6076709112683, -412.6076687361317, -412.60767085317, -412.6076686780333, -412.607669567994, -412.6076700793943, -412.6076695098957, 
  -412.607670021296, -412.6076704932386, -412.6076691541536, -412.6076704351403, -412.6076690960553, -412.6076665709203, -412.6076730766686, -412.6076665128254, -412.6076730185669, -412.6076687985051, -412.6076708489064, -412.6076687404042, -412.6076707908107, -412.6076752078471, -412.6076644398354, -412.6076751497489, -412.607664381737, -412.6076755706736, -412.6076640766824, -412.607675512576, -412.6076640185834, -412.6076756655023, -412.6076639818521, -412.607675607404, -412.6076639237538, -412.6076836978354, -412.6076559493868, -412.6076836397371, -412.6076558912885, -412.6076697045443, -412.6076699019315, -412.6076696873577, -412.6076698847449, -412.6076706267297, -412.6076689797465, -412.6076706095432, -412.60766896256, -412.607669812072, -412.6076697944034, -412.6076697948855, 
  -412.6076697772168, -412.6076708908125, -412.6076687156758, -412.6076708736259, -412.6076686984892, -412.6076695475382, -412.6076700589384, -412.6076695303516}
 {-482.0543611291964, -482.0543592957813, -482.0543592533295, -482.0543630050748, -482.0543629626219, -482.0543592605057, -482.0543592886052, -482.054362969799, -482.054362997898, -482.0543597224655, -482.0543588266498, -482.0543634317554, -482.0543625359461, -482.0543621590677, -482.0543563900611, -482.0543658683606, -482.0543600993544, -482.0543592801882, -482.0543592689226, -482.0543629894813, -482.0543629782157, -482.0543593211128, -482.0543592279982, -482.0543630304067, -482.0543629372905, -482.0543592227909, -482.05435932632, -482.054362932084, -482.054363035613, -482.0543592938529, -482.0543592552584, -482.0543630031458, -482.0543629645515, -482.0543169315999, -482.0544016188271, -482.0543206402744, -482.0544053287388, -482.0543633322346, -482.0543552170195, -482.0543670415295, 
  -482.0543589263106, -482.0543592343894, -482.0543593147216, -482.054362943683, -482.054363024014, -482.0543572456517, -482.054361303568, -482.0543609548276, -482.0543650129782, -482.0543650141682, -482.0543535349114, -482.0543687234616, -482.054357244204, -482.0543592813102, -482.0543592678008, -482.0543629906032, -482.0543629770938, -482.0543611363729, -482.0543611644721, -482.0543610939206, -482.0543611220197, -482.0543615983312, -482.0543607025184, -482.0543615558784, -482.0543606600664, -482.0543640349346, -482.0543582659285, -482.0543639924825, -482.0543582234758, -482.0543611560553, -482.0543611447897, -482.054361113603, -482.0543611023373, -482.0543611969803, -482.0543611038649, -482.0543611545278, -482.0543610614125, -482.054361098658, -482.054361202187, -482.0543610562057, 
  -482.0543611597347, -482.0543611697199, -482.0543611311255, -482.0543611272675, -482.0543610886732, -482.0543188071621, -482.054403494999, -482.0543187647009, -482.0544034525556, -482.0543652081116, -482.0543570928765, -482.0543651656412, -482.0543570504422, -482.0543611102567, -482.0543611905883, -482.0543610678046, -482.0543611481358, -482.054359121461, -482.0543631794927, -482.0543590790069, -482.0543631370422, -482.0543668900352, -482.0543554107784, -482.0543668475833, -482.0543553683256, -482.0543611571773, -482.0543611436678, -482.0543611147249, -482.0543611012154, -482.0543615630553, -482.0543606672429, -482.0543615911545, -482.054360695342, -482.054363999659, -482.0543582306525, -482.0543640277582, -482.0543582587517, -482.0543611207795, -482.054361109514, -482.0543611488787, 
  -482.0543611376132, -482.0543611617039, -482.0543610685897, -482.0543611898043, -482.0543610966878, -482.0543610633822, -482.0543611669113, -482.0543610914815}
 {-300.5419187953792, -300.5419194225369, -300.5419193133918, -300.5419182774073, -300.5419181682638, -300.541919359616, -300.5419193763125, -300.541918214487, -300.5419182311839, -300.5419202205453, -300.5419185153902, -300.541919075413, -300.5419173702649, -300.5419254623217, -300.5419132736347, -300.5419243171924, -300.5419121285063, -300.5419194188178, -300.5419193171107, -300.541918273689, -300.541918171982, -300.5419140499719, -300.5419246861489, -300.5419129048394, -300.5419235410238, -300.541920111269, -300.5419186246696, -300.5419189661398, -300.5419174795411, -300.5419247667189, -300.541913969251, -300.5419236215899, -300.5419128241223, -300.5419793454293, -300.5418593930571, -300.5419782012989, -300.54185824693, -300.5419122298417, -300.5419265063734, -300.5419110846948, 
  -300.5419253612627, -300.5419340797113, -300.5419046585296, -300.541932934595, -300.5419035133882, -300.541928916343, -300.5419098196312, -300.5419277710718, -300.5419086746449, -300.541935429751, -300.5419033061079, -300.5419342846217, -300.5419021609794, -300.5419484436067, -300.5418902924071, -300.5419472984787, -300.5418891472774, -300.5419188416031, -300.5419188582999, -300.5419187324587, -300.5419187491555, -300.5419197025316, -300.5419179973783, -300.5419195933855, -300.5419178882356, -300.541924944309, -300.5419127556219, -300.5419248351641, -300.5419126464781, -300.5419189008051, -300.541918799098, -300.5419187916607, -300.5419186899536, -300.5419135319577, -300.5419241681376, -300.5419134228124, -300.5419240589941, -300.5419195932564, -300.5419181066567, -300.5419194841112, 
  -300.5419179975131, -300.5419242487061, -300.5419134512382, -300.5419241395615, -300.541913342094, -300.5419788279107, -300.5418588745503, -300.5419787187765, -300.5418587653957, -300.5419117118054, -300.5419259883841, -300.5419116026901, -300.5419258792108, -300.5419335617032, -300.5419041405122, -300.541933452562, -300.5419040313646, -300.5419283982595, -300.5419093016893, -300.5419282891143, -300.5419091925456, -300.5419349117385, -300.5419027880948, -300.5419348025931, -300.5419026789514, -300.541947925594, -300.5418897743942, -300.5419478164504, -300.5418896652492, -300.5419196396101, -300.5419179344584, -300.5419196563068, -300.5419179511553, -300.541924881388, -300.5419126927015, -300.5419248980848, -300.5419127093983, -300.5419188378844, -300.5419187361773, -300.5419188545812, 
  -300.541918752874, -300.541913469037, -300.5419241052169, -300.5419134857329, -300.5419241219145, -300.5419195303353, -300.5419180437364, -300.541919547032}
 {-530.1674710443315, -530.1674705987129, -530.1674699942632, -530.1674720944144, -530.1674714899567, -530.1674703123168, -530.1674702806589, -530.1674718080145, -530.1674717763563, -530.1674711546802, -530.1674694382973, -530.1674726503776, -530.167470933995, -530.1674688805732, -530.1674717124148, -530.1674703762709, -530.1674732081121, -530.1674702707847, -530.1674703221911, -530.1674717664822, -530.1674718178885, -530.1674702759342, -530.1674703170415, -530.167471771632, -530.1674718127388, -530.1674702999211, -530.1674702930546, -530.1674717956185, -530.1674717887524, -530.1674702996392, -530.1674702933366, -530.1674717953365, -530.1674717890341, -530.1674622406783, -530.1674783525312, -530.1674637361922, -530.1674798484124, -530.1674740193611, -530.1674665736419, -530.1674755150644, 
  -530.1674680693337, -530.1674703762571, -530.1674702167187, -530.167471871953, -530.1674717124179, -530.1674749907916, -530.1674656021722, -530.1674764864525, -530.1674670979062, -530.1674738788976, -530.1674667140865, -530.1674753745951, -530.1674682097839, -530.1674702978667, -530.1674702951091, -530.1674717935642, -530.1674717908066, -530.1674713623876, -530.1674713307294, -530.1674707579339, -530.1674707262758, -530.1674722047507, -530.167470488368, -530.1674716002972, -530.1674698839143, -530.167469930644, -530.1674727624853, -530.1674693261903, -530.1674721580317, -530.1674713208553, -530.1674713722617, -530.1674707164016, -530.167470767808, -530.167471326005, -530.1674713671121, -530.1674707215513, -530.1674707626583, -530.1674713499916, -530.1674713431254, -530.1674707455381, 
  -530.1674707386717, -530.1674713497097, -530.1674713434073, -530.1674707452561, -530.1674707389536, -530.1674632906474, -530.1674794027033, -530.167462686213, -530.1674787982304, -530.1674750694377, -530.1674676237066, -530.1674744649777, -530.1674670192593, -530.1674714263267, -530.1674712667904, -530.1674708218735, -530.1674706623364, -530.1674760408404, -530.1674666522647, -530.167475436394, -530.1674660478037, -530.1674749289682, -530.1674677641571, -530.1674743245146, -530.1674671597034, -530.1674713479374, -530.1674713451797, -530.1674707434836, -530.167470740726, -530.1674719183528, -530.16747020197, -530.1674718866948, -530.1674701703119, -530.167469644246, -530.1674724760874, -530.1674696125879, -530.1674724444293, -530.1674710344573, -530.1674710858636, -530.1674710027991, 
  -530.1674710542057, -530.1674710396069, -530.1674710807141, -530.167471007949, -530.1674710490558, -530.1674710635937, -530.1674710567274, -530.1674710319356}
 {-340.6525303597961, -340.6525365682818, -340.6525360870108, -340.6525246326181, -340.652524151351, -340.652536352846, -340.6525363024457, -340.6525244171841, -340.652524366784, -340.6525366508293, -340.6525360044639, -340.6525247151633, -340.6525240688064, -340.6525396054194, -340.652533049909, -340.652527669756, -340.6525211142488, -340.6525362572107, -340.6525363980809, -340.652524321549, -340.6525244624192, -340.652537123942, -340.6525355313056, -340.6525251882789, -340.6525235956452, -340.6525314692407, -340.6525411860507, -340.6525195335793, -340.6525292503887, -340.6525310161786, -340.6525416391284, -340.6525190805169, -340.6525297034666, -340.6525256532127, -340.6525470049111, -340.6525137174716, -340.6525350693287, -340.6525385324142, -340.65253412318, -340.6525265967528, 
  -340.6525221875178, -340.6525869265926, -340.6524857296417, -340.6525749909304, -340.6524737939804, -340.6525480917792, -340.6525245634451, -340.652536156117, -340.6525126277838, -340.6525433025454, -340.6525293527678, -340.6525313668827, -340.652517417107, -340.6525102525838, -340.6525624043852, -340.6524983169227, -340.6525504687227, -340.6525306256312, -340.652530575231, -340.6525301443621, -340.6525300939619, -340.652530923614, -340.6525302772498, -340.6525304423419, -340.6525297959837, -340.6525338782051, -340.6525273226937, -340.6525333969334, -340.6525268414273, -340.652530529996, -340.6525306708662, -340.6525300487269, -340.6525301895971, -340.6525313967264, -340.6525298040917, -340.6525309154576, -340.6525293228223, -340.6525257420265, -340.6525354588354, -340.6525252607567, 
  -340.6525349775671, -340.6525252889639, -340.6525359119136, -340.6525248076949, -340.6525354306445, -340.6525199259499, -340.6525412777444, -340.6525194446977, -340.6525407964584, -340.6525328052013, -340.6525283959634, -340.6525323239289, -340.6525279146975, -340.6525811993778, -340.652480002427, -340.6525807181084, -340.6524795211582, -340.6525423645619, -340.6525188362329, -340.6525418832975, -340.6525183549592, -340.6525375753317, -340.652523625552, -340.6525370940597, -340.6525231442858, -340.652504525369, -340.6525566771705, -340.6525040441007, -340.6525561959005, -340.6525307081777, -340.6525300618163, -340.6525306577772, -340.6525300114163, -340.652533662769, -340.6525271072601, -340.6525336123686, -340.65252705686, -340.6525303145611, -340.6525304554312, -340.6525302641609, 
  -340.6525304050311, -340.6525311812931, -340.6525295886552, -340.6525311308899, -340.6525295382579, -340.6525255265914, -340.6525352434007, -340.6525254761909}
 {-336.0621947018049, -336.0621947016947, -336.0621947026938, -336.062194700916, -336.0621947019151, -336.0621947022818, -336.0621947021067, -336.0621947015031, -336.062194701328, -336.0621947286221, -336.0621946757665, -336.0621947278434, -336.0621946749878, -336.0621943654098, -336.0621950389846, -336.0621943646312, -336.0621950382058, -336.062194610586, -336.0621947938026, -336.0621946098072, -336.062194793024, -336.0621946257388, -336.0621947786504, -336.0621946249601, -336.0621947778716, -336.062195313208, -336.0621940911822, -336.0621953124293, -336.0621940904035, -336.0622000930297, -336.0621893113648, -336.0622000922511, -336.0621893105861, -336.0621943981474, -336.0621950062425, -336.0621943973692, -336.0621950054633, -336.0621969689069, -336.0621924355043, -336.0621969681282, 
  -336.0621924347257, -336.0621913888734, -336.0621980155662, -336.0621913880947, -336.0621980147875, -336.0621947030663, -336.0621947013222, -336.0621947022877, -336.0621947005435, -336.0621996142338, -336.0621897901388, -336.0621996134552, -336.0621897893601, -336.0621967285956, -336.0621926758169, -336.0621967278169, -336.0621926750382, -336.062194701393, -336.0621947012179, -336.062194702392, -336.0621947022169, -336.0621947277332, -336.0621946748777, -336.0621947287323, -336.0621946758767, -336.0621943645209, -336.0621950380956, -336.06219436552, -336.0621950390948, -336.0621946096971, -336.0621947929137, -336.0621946106961, -336.0621947939129, -336.0621946248501, -336.0621947777613, -336.0621946258489, -336.0621947787608, -336.0621953123191, -336.0621940902932, -336.0621953133182, 
  -336.0621940912923, -336.0622000921409, -336.0621893104759, -336.0622000931399, -336.0621893114749, -336.0621943972588, -336.0621950053533, -336.0621943982578, -336.0621950063525, -336.062196968018, -336.0621924346155, -336.0621969690171, -336.0621924356145, -336.0621913879845, -336.0621980146773, -336.0621913889836, -336.0621980156763, -336.0621947021774, -336.0621947004334, -336.0621947031766, -336.0621947014324, -336.062199613345, -336.0621897892499, -336.0621996143441, -336.062189790249, -336.0621967277067, -336.062192674928, -336.0621967287058, -336.0621926759271, -336.0621947283203, -336.0621946754647, -336.0621947281452, -336.0621946752896, -336.062194365108, -336.0621950386828, -336.0621943649329, -336.0621950385076, -336.0621946102841, -336.0621947935009, -336.062194610109, 
  -336.0621947933257, -336.0621946254373, -336.0621947783484, -336.0621946252617, -336.0621947781737, -336.0621953129062, -336.0621940908804, -336.0621953127311}
 {-225.7344630453389, -225.734458299466, -225.7344556241467, -225.7344704665732, -225.7344677912342, -225.7344570293257, -225.734456894286, -225.7344691964236, -225.7344690613828, -225.734454433641, -225.7344594899767, -225.7344666007403, -225.7344716570721, -225.7344644317464, -225.734449491907, -225.7344765988452, -225.734461659003, -225.7344570288326, -225.7344568947791, -225.73446919593, -225.7344690618764, -225.7344618025955, -225.7344521212397, -225.7344739696882, -225.7344642883415, -225.7344549402434, -225.7344589834078, -225.7344671073406, -225.7344711505052, -225.7344585030155, -225.734455420609, -225.7344706701128, -225.7344675877063, -225.7344829251304, -225.7344309989377, -225.7344950927966, -225.7344431654662, -225.7344631957736, -225.7344507278928, -225.7344753628576, 
  -225.7344628950034, -225.7344502123598, -225.7344637118543, -225.7344623794631, -225.7344758789459, -225.7344529663451, -225.7344609574123, -225.7344651332608, -225.7344731246912, -225.7344565643202, -225.7344573593723, -225.7344687314164, -225.7344695264707, -225.7344708348527, -225.7344430885937, -225.7344830019504, -225.7344552556907, -225.7344644505241, -225.7344643154838, -225.7344617751949, -225.7344616401547, -225.7344618548403, -225.7344669111736, -225.7344591795107, -225.7344642358449, -225.7344718529461, -225.7344569131036, -225.7344691776152, -225.7344542377761, -225.7344644500308, -225.7344643159772, -225.7344617747016, -225.734461640648, -225.7344692237908, -225.7344595424405, -225.7344665484626, -225.7344568671104, -225.7344623614415, -225.7344664046059, 
  -225.7344596861122, -225.7344637292769, -225.7344659242136, -225.7344628418071, -225.7344632488845, -225.7344601664779, -225.7344903466343, -225.7344384198299, -225.7344876712624, -225.7344357445436, -225.7344706169541, -225.7344581491084, -225.7344679416468, -225.7344554737575, -225.7344576335613, -225.7344711330492, -225.7344549582314, -225.7344684577208, -225.7344603874365, -225.7344683787171, -225.7344577121391, -225.7344657033561, -225.7344639855176, -225.7344647805711, -225.7344613101888, -225.7344621052416, -225.734478256051, -225.7344505097917, -225.7344755807219, -225.7344478344624, -225.7344605846951, -225.7344656410289, -225.7344604496549, -225.7344655059887, -225.7344705828003, -225.7344556429595, -225.73447044776, -225.7344555079192, -225.7344631798857, -225.7344630458322, 
  -225.7344630448455, -225.734462910792, -225.7344679536461, -225.7344582722953, -225.7344678186063, -225.7344581372545, -225.7344610912968, -225.7344651344606, -225.7344609562559}
 {-10.67128900738464, -10.67129615361322, -10.67129451662867, -10.67128349821176, -10.67128186125546, -10.671295370459, -10.6712952997817, -10.67128271507111, -10.67128264439492, -10.67129304542434, -10.67129762481935, -10.67128039005264, -10.67128496941638, -10.67129127657045, -10.67129939368472, -10.67127862117371, -10.67128673830679, -10.67129527295284, -10.67129539728785, -10.67128261756559, -10.67128274190043, -10.6712936437307, -10.67129702655603, -10.67128098837552, -10.67128437113654, -10.67129310616326, -10.6712975641169, -10.67128045077561, -10.67128490872987, -10.67129731060259, -10.67129335965751, -10.67128465521581, -10.67128070426961, -10.67126657231804, -10.67132409911553, -10.67125391709199, -10.67131144356694, -10.67130994310182, -10.6712807272723, -10.6712972877041, 
  -10.67126807189535, -10.67130844274256, -10.67128222843481, -10.67129578736758, -10.67126957303512, -10.67129801277095, -10.67129265749361, -10.67128535747891, -10.67128000201098, -10.67129216420511, -10.67129850616774, -10.67127950880761, -10.67128585079056, -10.67130801978196, -10.67128265034849, -10.67129536439114, -10.67126999496465, -10.67128986120889, -10.67128979053204, -10.67128822423836, -10.67128815356172, -10.67128753618431, -10.67129211555961, -10.67128589920982, -10.67129047859325, -10.67128576731927, -10.67129388443614, -10.67128413034203, -10.67129224747252, -10.671289763703, -10.67128988803792, -10.67128812673257, -10.6712882510675, -10.6712881344954, -10.67129151729156, -10.67128649752796, -10.67128988031814, -10.67128759691337, -10.671292054867, -10.67128595994263, 
  -10.67129041789689, -10.67129180135294, -10.67128785040739, -10.6712901643826, -10.67128621343687, -10.671261063114, -10.67131858981982, -10.67125942621316, -10.6713169527798, -10.67130443385413, -10.67127521802022, -10.67130279686893, -10.67127358106457, -10.67130293349912, -10.67127671917848, -10.67130129652816, -10.67127508220858, -10.67129250355903, -10.67128714820576, -10.67129086660797, -10.67128551121597, -10.67128665495081, -10.67129299692227, -10.67128501797906, -10.67129135995317, -10.67130251053006, -10.67127714110062, -10.67130087356018, -10.67127550412965, -10.67128675303491, -10.67129133241413, -10.67128668235801, -10.67129126173753, -10.67128498416851, -10.67129310129201, -10.67128491349159, -10.67129303061543, -10.67128898055557, -10.67128910489048, -10.6712889098788, 
  -10.67128903421374, -10.67128735135138, -10.67129073414071, -10.67128728067079, -10.6712906634678, -10.67128681376613, -10.67129127171937, -10.67128674308867}
 {-325.5198541844135, -325.5198547870887, -325.5198548852648, -325.519853483581, -325.5198535817591, -325.5198548612027, -325.5198548111507, -325.5198535576961, -325.5198535076439, -325.5198547440226, -325.5198549283353, -325.5198534405148, -325.5198536248296, -325.5198597952365, -325.5198498771377, -325.5198584917294, -325.5198485736315, -325.5198548482487, -325.5198548241048, -325.5198535447421, -325.5198535205981, -325.5198514682037, -325.51985820426, -325.5198501646796, -325.5198569007709, -325.5198553271467, -325.519854345212, -325.5198540236396, -325.5198530417059, -325.519859837426, -325.5198498349535, -325.5198585339191, -325.519848531447, -325.5198939467463, -325.519815727338, -325.5198926437588, -325.5198144233121, -325.5198567414447, -325.5198529311214, -325.5198554379321, 
  -325.5198516276208, -325.5198728826624, -325.5198367913533, -325.5198715791665, -325.519835487836, -325.5198603421738, -325.5198493302259, -325.5198590385863, -325.5198480268002, -325.5198709922953, -325.519838679986, -325.5198696887879, -325.51983737648, -325.5198693632389, -325.5198403098761, -325.5198680597347, -325.5198390063671, -325.5198541603511, -325.519854110299, -325.5198542585283, -325.5198542084761, -325.519854043171, -325.5198542274834, -325.5198541413467, -325.5198543256619, -325.5198590943847, -325.5198491762861, -325.5198591925616, -325.5198492744634, -325.5198541473971, -325.5198541232531, -325.5198542455742, -325.5198542214302, -325.5198507673441, -325.5198575034163, -325.5198508655196, -325.519857601595, -325.5198546262954, -325.5198536443601, -325.5198547244713, 
  -325.5198537425384, -325.5198591365743, -325.5198491341018, -325.5198592347513, -325.519849232279, -325.5198932461501, -325.5198150262309, -325.5198933443356, -325.5198151243996, -325.5198560405808, -325.5198522302821, -325.5198561387765, -325.5198523284406, -325.519872181815, -325.5198360904973, -325.5198722799943, -325.5198361886722, -325.519859641283, -325.5198486294133, -325.5198597394575, -325.5198487275931, -325.5198702914434, -325.5198379791345, -325.5198703896202, -325.519838077312, -325.5198686623879, -325.5198396090238, -325.5198687605661, -325.5198397071998, -325.519854117285, -325.5198543015987, -325.5198540672327, -325.5198542515465, -325.5198591684992, -325.5198492504008, -325.519859118447, -325.5198492003486, -325.5198542215116, -325.5198541973677, -325.5198541714594, 
  -325.5198541473155, -325.5198508414584, -325.5198575775314, -325.5198507914053, -325.5198575274799, -325.5198547004094, -325.5198537184752, -325.5198546503572}
 {-320.4291617136312, -320.429173171488, -320.4291720847453, -320.4291513425805, -320.429150255841, -320.4291726343949, -320.4291726218369, -320.4291508054887, -320.4291507929311, -320.4291733508693, -320.4291719053584, -320.429151521962, -320.4291500764539, -320.4291732584106, -320.4291719979371, -320.4291514295029, -320.429150169033, -320.429172859503, -320.4291723967289, -320.429151030597, -320.4291505678229, -320.4291780133816, -320.4291672426935, -320.4291561844452, -320.429145413818, -320.4291818439221, -320.4291634123977, -320.4291600150152, -320.4291415834925, -320.4291715376529, -320.4291737186881, -320.4291497087475, -320.4291518897817, -320.4292252173366, -320.4291200442992, -320.4292033892028, -320.4290982146214, -320.42912738105, -320.4292178759842, -320.4291055521337, 
  -320.4291960470886, -320.4291808343906, -320.4291644279208, -320.4291590054903, -320.4291425990094, -320.4292047607226, -320.4291404953659, -320.4291829317616, -320.4291186665151, -320.4291756838226, -320.4291695729394, -320.4291538549129, -320.4291477440374, -320.4291675100032, -320.42917775026, -320.4291456811011, -320.4291559213504, -320.4291622632816, -320.4291622507236, -320.4291611765403, -320.4291611639826, -320.4291629797551, -320.4291615342461, -320.4291618930145, -320.4291604475044, -320.4291628872989, -320.4291616268223, -320.4291618005527, -320.4291605400861, -320.4291624883898, -320.4291620256156, -320.4291614016486, -320.4291609388743, -320.4291676422681, -320.4291568715804, -320.4291665554969, -320.4291557848693, -320.4291714728086, -320.4291530412844, -320.4291703860668, 
  -320.4291519545439, -320.4291611665396, -320.4291633475749, -320.4291600797988, -320.4291622608333, -320.4292148466272, -320.4291096727822, -320.4292137598505, -320.4291085860767, -320.4291170099198, -320.4292075048879, -320.4291159232021, -320.4292064181232, -320.4291704632809, -320.4291540568039, -320.4291693765382, -320.4291529700645, -320.4291943895762, -320.4291301242858, -320.4291933028462, -320.4291290375335, -320.4291653127108, -320.4291592018247, -320.429164225963, -320.4291581150902, -320.42915713889, -320.4291673791467, -320.4291560521527, -320.4291662924016, -320.4291624426631, -320.4291609971532, -320.4291624301049, -320.4291609845959, -320.429162350204, -320.4291610897324, -320.4291623376462, -320.4291610771746, -320.4291619512973, -320.429161488523, -320.4291619387394, 
  -320.4291614759652, -320.429167105162, -320.4291563345018, -320.4291670926016, -320.4291563219465, -320.429170935716, -320.429152504192, -320.4291709231578}
 {-133.7075456169135, -133.7075389569079, -133.7075411520464, -133.7075500818145, -133.7075522769821, -133.7075401657696, -133.7075399431835, -133.7075512906924, -133.707551068103, -133.7075377949704, -133.7075423139924, -133.7075489198944, -133.7075534389107, -133.7075376648805, -133.7075424441073, -133.707548789799, -133.7075535690311, -133.7075401556233, -133.7075399533298, -133.7075512805445, -133.707551078251, -133.707562574285, -133.7075175349431, -133.7075736991533, -133.7075286599172, -133.7075489764862, -133.7075311325039, -133.7075601014089, -133.7075422574235, -133.7075375661719, -133.7075425427951, -133.7075486910927, -133.7075536677166, -133.707566908483, -133.707513201126, -133.7075780340701, -133.7075243253811, -133.7075470965999, -133.7075330124326, -133.7075582215026, 
  -133.7075441373722, -133.7075040070408, -133.7075761027424, -133.7075151319717, -133.7075872276538, -133.7075395399175, -133.7075405691181, -133.7075506646557, -133.7075516942223, -133.7075486274953, -133.7075314814489, -133.7075597524151, -133.7075426063715, -133.7074934925584, -133.7075866195083, -133.7075046174848, -133.7075977444242, -133.7075446306313, -133.7075444080438, -133.7075468257845, -133.7075466031966, -133.7075422598326, -133.7075467788521, -133.707544454986, -133.7075489740047, -133.7075421297395, -133.7075469089702, -133.7075443248937, -133.707549104122, -133.7075446204843, -133.7075444181908, -133.7075468156373, -133.7075466133438, -133.7075670391223, -133.7075219998278, -133.7075692342699, -133.7075241949862, -133.7075534413487, -133.7075355973633, -133.7075556365001, 
  -133.7075377925179, -133.7075420310327, -133.7075470076563, -133.7075442261857, -133.7075492028093, -133.7075713736492, -133.7075176656817, -133.7075735688577, -133.7075198607792, -133.707551561444, -133.7075374773105, -133.7075537566123, -133.7075396724482, -133.7075084719057, -133.7075805675995, -133.7075106670606, -133.7075827627506, -133.7075440047005, -133.7075450340571, -133.7075461998265, -133.7075472292371, -133.707553092356, -133.7075359463102, -133.7075552875083, -133.7075381414639, -133.707497957421, -133.7075910843676, -133.7075001525759, -133.7075932795187, -133.7075434687026, -133.7075479877217, -133.7075432461149, -133.707547765134, -133.7075433386099, -133.7075481178394, -133.7075431160222, -133.7075478952516, -133.7075458293541, -133.7075456270606, -133.7075456067664, 
  -133.7075454044728, -133.7075682479892, -133.7075232087005, -133.7075680254018, -133.7075229861124, -133.7075546502175, -133.7075368062341, -133.7075544276302}
 {-10.83240688534389, -10.83240589113571, -10.83240595408222, -10.83240781660117, -10.83240787954746, -10.83240591357728, -10.83240593164066, -10.83240783904266, -10.83240785710597, -10.83240342672243, -10.83240841852057, -10.83240535219905, -10.83241034397463, -10.83240653165283, -10.8324053135821, -10.83240845711348, -10.83240723905213, -10.83240583377306, -10.83240601144491, -10.83240775923818, -10.83240793691048, -10.83237397581815, -10.83243786987315, -10.83237590157769, -10.83243979504429, -10.83240049430837, -10.83241135092095, -10.8324024197706, -10.8324132763894, -10.832399043033, -10.83241280219435, -10.83240096849418, -10.83241472766385, -10.83240430220655, -10.83240754301337, -10.83240622768402, -10.83240946846658, -10.83240821632622, -10.83240362898469, -10.83241014180311, 
  -10.8324055544385, -10.83244820638669, -10.83236363968738, -10.83245013188008, -10.83236556512468, -10.83240591371309, -10.8324059315048, -10.83240783917845, -10.83240785697012, -10.83241061154934, -10.83240123365607, -10.83241253700731, -10.83240315912879, -10.83238951591831, -10.83242233053193, -10.83239144134219, -10.83242425603874, -10.83240684483902, -10.83240686290236, -10.83240690778542, -10.83240692584876, -10.83240435798977, -10.83240934977667, -10.83240442093621, -10.83240941272303, -10.83240746291229, -10.83240624484608, -10.83240752585852, -10.83240630779265, -10.83240676503467, -10.83240694270674, -10.83240682798107, -10.83240700565316, -10.83237490722038, -10.83243880099436, -10.83237497017997, -10.83243886392758, -10.83240142556857, -10.83241228218419, -10.8324014885149, 
  -10.83241234513067, -10.83239997429275, -10.83241373345803, -10.83240003723893, -10.83241379640467, -10.83240523347435, -10.832408474269, -10.83240529642072, -10.83240853721545, -10.83240914759287, -10.83240456024149, -10.83240921054096, -10.8324046231862, -10.83244913766176, -10.83236457093575, -10.83244920060951, -10.83236463388081, -10.83240684497482, -10.83240686276651, -10.83240690792122, -10.83240692571291, -10.83241154280752, -10.83240216492133, -10.83241160575363, -10.83240222786803, -10.83239044716028, -10.8324232618134, -10.83239051010472, -10.83242332476177, -10.83240438043126, -10.83240937221824, -10.83240439849472, -10.83240939028147, -10.83240748535376, -10.83240626728767, -10.83240750341706, -10.83240628535106, -10.8324067874762, -10.83240696514828, -10.83240680553954, 
  -10.83240698321162, -10.83237492966703, -10.83243882343077, -10.83237494773332, -10.83243884149116, -10.83240144801007, -10.83241230462575, -10.8324014660734}
 {-407.4142261849519, -407.4142295988823, -407.4142311789318, -407.4142211910036, -407.4142227710742, -407.4142303602851, -407.4142304175251, -407.4142219524166, -407.4142220096574, -407.4142266073634, -407.4142341704391, -407.4142181995209, -407.4142257625452, -407.4142084857029, -407.4142522921718, -407.414200077829, -407.4142438843095, -407.4142301551226, -407.4142306226877, -407.4142217472544, -407.4142222148195, -407.4142266848009, -407.4142340931884, -407.4142182769537, -407.4142256852992, -407.4142245824915, -407.4142361954882, -407.4142161746212, -407.4142277876224, -407.4142372388357, -407.414223539034, -407.4142288309673, -407.414215131166, -407.414213750498, -407.4142470300855, -407.4142053421072, -407.41423862274, -407.4141808632531, -407.4142799149366, -407.4141724553888, 
  -407.4142715070648, -407.4141996358192, -407.4142611447535, -407.4141912279366, -407.4142527368998, -407.4142409348985, -407.4142198428646, -407.4142325270016, -407.4142114350253, -407.4142050475055, -407.4142557309856, -407.4141966396246, -407.4142473231303, -407.4142719802412, -407.4141887970727, -407.4142635723697, -407.414180389208, -407.4142253663039, -407.4142254235439, -407.4142269463636, -407.4142270036043, -407.4142216133923, -407.4142291764476, -407.4142231934577, -407.4142307565023, -407.4142034917183, -407.4142472981939, -407.4142050717792, -407.4142488782532, -407.4142251611414, -407.4142256287063, -407.4142267412014, -407.4142272087665, -407.4142216908269, -407.4142290991998, -407.4142232708932, -407.4142306792535, -407.4142195885093, -407.414231201508, -407.4142211685691, 
  -407.4142327815683, -407.4142322448543, -407.4142185450528, -407.4142338249144, -407.4142201251129, -407.4142087563495, -407.4142420362716, -407.4142103362215, -407.4142436165197, -407.4141758692774, -407.41427492095, -407.4141774493302, -407.4142765010171, -407.414194641834, -407.4142561507762, -407.4141962218874, -407.4142577308428, -407.4142359409112, -407.4142148488893, -407.4142375209544, -407.4142164289663, -407.4142000535205, -407.4142507370082, -407.4142016335752, -407.4142523170734, -407.414266986259, -407.4141838030925, -407.4142685663176, -407.414185383154, -407.4142223748028, -407.414229937853, -407.4142224320434, -407.4142299950931, -407.4142042531267, -407.4142480596014, -407.414204310367, -407.4142481168418, -407.4142259225493, -407.4142263901143, -407.4142259797897, 
  -407.4142264473547, -407.4142224522388, -407.4142298606036, -407.4142225094775, -407.4142299178458, -407.4142203499169, -407.4142319629163, -407.4142204071578}
 {-312.900785949802, -312.9007883592523, -312.9007883829592, -312.9007835166549, -312.9007835403635, -312.9007883734404, -312.9007883687708, -312.9007835308439, -312.9007835261742, -312.9007882973585, -312.9007884448536, -312.900783454762, -312.900783602257, -312.9007901562764, -312.9007865859474, -312.9007853136796, -312.9007817433511, -312.9007883824157, -312.9007883597955, -312.9007835398192, -312.900783517199, -312.9007897291722, -312.9007870130568, -312.9007848865722, -312.9007821704637, -312.9007898377991, -312.9007869044198, -312.9007849952028, -312.9007820618231, -312.9007905769161, -312.9007861653148, -312.9007857343195, -312.9007813227183, -312.900792983709, -312.900783759466, -312.900788141219, -312.900778916763, -312.9007934114614, -312.9007833308607, -312.9007885688628, 
  -312.9007784882662, -312.9007701945382, -312.9008065485747, -312.9007653519429, -312.9008017059769, -312.9007942663101, -312.9007824758674, -312.9007894237103, -312.9007776332743, -312.9007933797342, -312.9007833624605, -312.9007885371375, -312.9007785198643, -312.9007979787867, -312.9007787634563, -312.9007931361905, -312.9007739208595, -312.9007859402832, -312.9007859356135, -312.9007859639909, -312.9007859593212, -312.9007858642016, -312.9007860116961, -312.9007858879086, -312.9007860354044, -312.9007877231191, -312.9007841527902, -312.9007877468267, -312.900784176498, -312.9007859492584, -312.9007859266383, -312.9007859729661, -312.900785950346, -312.9007872960137, -312.9007845799008, -312.9007873197204, -312.9007846036095, -312.900787404642, -312.9007844712624, -312.9007874283496, 
  -312.9007844949702, -312.9007881437588, -312.9007837321576, -312.9007881674665, -312.9007837558654, -312.9007905505932, -312.9007813262675, -312.9007905743247, -312.9007813499514, -312.9007909783023, -312.9007808977053, -312.9007910020117, -312.9007809214113, -312.9007677613813, -312.9008041154171, -312.9007677850896, -312.9008041391242, -312.9007918331515, -312.9007800427116, -312.9007918568586, -312.9007800664199, -312.9007909465773, -312.900780929303, -312.9007909702842, -312.9007809530115, -312.9007955456296, -312.9007763302991, -312.9007955693374, -312.9007763540065, -312.9007858783898, -312.900786025885, -312.9007858737201, -312.9007860212152, -312.9007877373076, -312.9007841669788, -312.9007877326379, -312.9007841623091, -312.9007859634469, -312.9007859408268, -312.9007859587772, 
  -312.9007859361571, -312.9007873102022, -312.9007845940894, -312.9007873055316, -312.9007845894206, -312.9007874188305, -312.900784485451, -312.9007874141608}
 {-194.4031464003529, -194.4031430804204, -194.4031446264329, -194.4031481742887, -194.4031497203074, -194.4031438569932, -194.4031438498598, -194.4031489508644, -194.4031489437314, -194.4031427771858, -194.4031449296721, -194.4031478710659, -194.4031500235348, -194.4031456654208, -194.4031420414655, -194.4031507592904, -194.4031471353387, -194.4031438902002, -194.4031438166527, -194.4031489840717, -194.4031489105242, -194.4031455642612, -194.4031421426408, -194.4031506581016, -194.4031472365432, -194.4031457256259, -194.4031419812374, -194.4031508194966, -194.4031470751095, -194.4031458251511, -194.4031418817186, -194.4031509190225, -194.4031469755901, -194.4031905727454, -194.4030971355351, -194.4031956672317, -194.4031022287918, -194.403158860756, -194.4031288463713, 
  -194.4031639546288, -194.4031339402415, -194.4031255419695, -194.4031621658253, -194.403130635846, -194.4031672596917, -194.4031402610387, -194.403147445952, -194.4031453547792, -194.4031525399543, -194.4031500271021, -194.403137679785, -194.403155120968, -194.4031427736619, -194.4031534556058, -194.4031342512778, -194.4031585494813, -194.4031393451452, -194.4031456309119, -194.4031456237787, -194.4031471769275, -194.4031471697943, -194.4031445511094, -194.4031467035862, -194.4031460971242, -194.4031482496026, -194.4031474393368, -194.4031438153872, -194.4031489853563, -194.4031453613989, -194.4031456641191, -194.4031455905716, -194.4031472101346, -194.4031471365872, -194.4031473381665, -194.4031439165732, -194.4031488841782, -194.4031454625927, -194.4031474995447, -194.4031437551563, 
  -194.4031490455597, -194.4031453011724, -194.40314759907, -194.4031436556374, -194.4031491450855, -194.4031452016531, -194.4031923469445, -194.4030989091738, -194.4031938930144, -194.403100455135, -194.4031606346638, -194.4031306203012, -194.4031621807029, -194.4031321662934, -194.4031273158904, -194.4031639397421, -194.4031288619069, -194.4031654857568, -194.4031420349025, -194.4031492199258, -194.4031435808972, -194.4031507659623, -194.4031518010183, -194.4031394537064, -194.4031533470336, -194.4031409997222, -194.4031552295263, -194.403136025195, -194.4031567755426, -194.4031375712098, -194.4031453276832, -194.4031474801607, -194.40314532055, -194.4031474730277, -194.4031482159129, -194.4031445919595, -194.4031482087799, -194.4031445848263, -194.4031464406932, -194.4031463671458, 
  -194.4031464335601, -194.4031463600126, -194.4031481147384, -194.4031446931498, -194.403148107606, -194.4031446860158, -194.4031482761181, -194.4031445317313, -194.403148268986}
 {-156.017810994091, -156.0177994102519, -156.0178017696803, -156.0178202185255, -156.0178225779707, -156.0178005248627, -156.0178006550699, -156.0178213331442, -156.0178214633524, -156.017798503088, -156.0178026768545, -156.0178193113818, -156.0178234851247, -156.0178017087231, -156.017799471229, -156.0178225170052, -156.0178202795109, -156.0178005680012, -156.0178006119314, -156.0178213762832, -156.0178214202134, -156.0178061755592, -156.0177950047304, -156.0178269838569, -156.0178158129968, -156.0178018966258, -156.0177992833294, -156.0178227049072, -156.0178200916121, -156.0178043495372, -156.017796830419, -156.0178251578195, -156.0178176387008, -156.0178809253593, -156.0177202562328, -156.0179017347736, -156.0177410633826, -156.0178083458984, -156.017792834215, -156.0178291541658, 
  -156.0178136425116, -156.0177962741307, -156.017804907085, -156.0178170824275, -156.0178257153521, -156.0177886288544, -156.0178125514377, -156.0178094367996, -156.0178333600564, -156.0178091840775, -156.0177919958415, -156.0178299923542, -156.0178128041288, -156.0178118749535, -156.0177893054116, -156.0178326832323, -156.0178101136968, -156.0178097492685, -156.0178098794762, -156.0178121087053, -156.017812238913, -156.0178077275001, -156.0178119012545, -156.0178100869367, -156.0178142606916, -156.017810933126, -156.0178086956383, -156.0178132925693, -156.0178110550686, -156.0178097924072, -156.0178098363374, -156.0178121518441, -156.0178121957743, -156.017815399974, -156.0178042291278, -156.0178177594091, -156.0178065885663, -156.0178111210309, -156.0178085077365, -156.017813480469, 
  -156.017810867172, -156.0178135739434, -156.017806054825, -156.0178159333802, -156.0178084142618, -156.0178901503019, -156.0177294801023, -156.0178925097979, -156.01773183948, -156.0178175702819, -156.0178020586435, -156.0178199297491, -156.0178044180499, -156.0178054985415, -156.0178141314863, -156.0178078579836, -156.0178164909178, -156.0177978531088, -156.0178217759954, -156.0178002125121, -156.0178241354657, -156.0178184084791, -156.017801220252, -156.0178207679196, -156.0178035796852, -156.0178210993589, -156.0177985298183, -156.0178234587938, -156.017800889257, -156.0178088421147, -156.0178130158694, -156.0178089723224, -156.0178131460771, -156.0178120477439, -156.0178098102498, -156.0178121779517, -156.0178099404574, -156.017810907022, -156.0178109509522, -156.0178110372297, 
  -156.0178110811599, -156.0178165145873, -156.0178053437439, -156.0178166447961, -156.0178054739506, -156.017812235646, -156.0178096223509, -156.0178123658543}
 {-32.82350604542653, -32.8235063420449, -32.82350610240993, -32.8235059884964, -32.82350574886427, -32.82350617156088, -32.8235062728936, -32.82350581801282, -32.8235059193475, -32.82350658157613, -32.82350586289024, -32.8235062280235, -32.8235055093487, -32.82351088011624, -32.82350156436235, -32.8235105265689, -32.82350121081553, -32.82350625698847, -32.82350618746603, -32.82350590344126, -32.82350583391906, -32.82349731222864, -32.82351513241365, -32.82349695873628, -32.82351477881184, -32.82350664449902, -32.82350579996516, -32.82350629095139, -32.82350544641862, -32.8235095125717, -32.82350293191283, -32.82350915902617, -32.8235025783642, -32.82353489410767, -32.82347755229836, -32.82353454151885, -32.82347719779305, -32.82349914522531, -32.82351329945103, -32.82349879166209, 
  -32.82351294592009, -32.82353810960491, -32.82347433660036, -32.82353775607768, -32.82347398303342, -32.82351546155546, -32.82349698287789, -32.82351510789541, -32.82349662944378, -32.8235163042882, -32.82349614013121, -32.82351595073926, -32.82349578658598, -32.82352813630517, -32.8234843080887, -32.82352778275134, -32.82348395454837, -32.82350611457665, -32.82350621591034, -32.82350587494309, -32.8235059762768, -32.82350652458936, -32.82350580590949, -32.82350628495629, -32.82350556627547, -32.82351082313276, -32.82350150737833, -32.8235105834984, -32.82350126774559, -32.82350620000464, -32.82350613048236, -32.82350596037113, -32.82350589084878, -32.82349725527242, -32.82351507540236, -32.82349701563854, -32.82351483576916, -32.82350658751446, -32.82350574298222, -32.82350634788198, 
  -32.8235055033476, -32.82350945558875, -32.82350287492827, -32.82350921595514, -32.82350263529479, -32.8235348376014, -32.82347749483713, -32.82353459797114, -32.8234772552003, -32.82349908822513, -32.82351324248372, -32.8234988486083, -32.82351300283344, -32.82353805263035, -32.82347427960741, -32.82353781299827, -32.82347403997241, -32.82351540451428, -32.82349692595156, -32.82351516488261, -32.82349668631614, -32.82351624730397, -32.82349608314794, -32.82351600766952, -32.82349584351529, -32.82352807931848, -32.82348425110789, -32.82352783968405, -32.82348401147522, -32.82350635410581, -32.82350563542546, -32.82350645543951, -32.82350573675917, -32.82351065264856, -32.82350133689493, -32.82351075398226, -32.82350143822864, -32.82350602952087, -32.82350595999854, -32.82350613085456, 
  -32.82350606133225, -32.82349708478793, -32.82351490491927, -32.82349718612269, -32.82351500625192, -32.82350641703123, -32.82350557249786, -32.82350651836487}
 {-492.5304959078384, -492.5304957953946, -492.5304948607122, -492.5304969549851, -492.530496020293, -492.5304953367945, -492.5304953193121, -492.5304964963802, -492.5304964788974, -492.5304977164645, -492.530492939644, -492.5304988760441, -492.5304940992353, -492.5304924721127, -492.5304981840071, -492.5304936316993, -492.5304993435915, -492.5304953119094, -492.5304953441971, -492.5304964714949, -492.5304965037826, -492.5305001643707, -492.5304904918219, -492.5305013239458, -492.530491651418, -492.5304929801148, -492.5304976760144, -492.5304941397009, -492.5304988355993, -492.5304975125412, -492.5304931435828, -492.5304986721268, -492.5304943031684, -492.5304725146174, -492.5305181421955, -492.5304736737966, -492.5305193021873, -492.5305086694088, -492.5304819867809, -492.5305098290034, 
  -492.5304831463574, -492.5305115909678, -492.530479065937, -492.5305127505486, -492.5304802255274, -492.5304982701543, -492.5304923859717, -492.5304994296729, -492.5304935456241, -492.5304881878823, -492.5305024684279, -492.5304893474698, -492.5305036280114, -492.530505937148, -492.5304847189445, -492.5305070967346, -492.530485878529, -492.5304963839236, -492.5304963664409, -492.5304954492363, -492.5304954317538, -492.5304987635906, -492.5304939867757, -492.5304978289031, -492.5304930520888, -492.5304935192428, -492.5304992311349, -492.5304925845545, -492.5304982964489, -492.5304963590383, -492.5304963913261, -492.5304954243512, -492.5304954566389, -492.5305012114949, -492.5304915389557, -492.5305002768068, -492.5304906042694, -492.5304940272442, -492.5304987231428, -492.5304930925567, 
  -492.5304977884561, -492.5304985596703, -492.5304941907118, -492.530497624983, -492.5304932560246, -492.5304735615275, -492.5305191895433, -492.5304726268717, -492.5305182548247, -492.5305097165493, -492.5304830338983, -492.5305087818481, -492.5304820992252, -492.5305126380946, -492.5304801130683, -492.530511703407, -492.5304791783814, -492.5304993172444, -492.5304934331395, -492.5304983825681, -492.5304924984415, -492.5304892350124, -492.5305035155557, -492.5304883003249, -492.5305025808688, -492.5305069842771, -492.5304857660732, -492.5305060495906, -492.5304848313854, -492.530498304988, -492.5304935281734, -492.5304982875053, -492.5304935106907, -492.5304930606397, -492.530498772533, -492.5304930431571, -492.5304987550503, -492.5304959004359, -492.5304959327237, -492.5304958829533, 
  -492.530495915241, -492.530500752892, -492.5304910803536, -492.5305007354093, -492.530491062871, -492.5304935686416, -492.5304982645405, -492.5304935511589}
 {-221.1211038563083, -221.12110084014, -221.1211035370789, -221.1211041755644, -221.1211068725375, -221.1211021115446, -221.121102265672, -221.1211054469852, -221.1211056011144, -221.1210985529994, -221.1211058242241, -221.1211018884478, -221.1211091596586, -221.1210951442835, -221.1211092329879, -221.12109847972, -221.1211125684344, -221.1211020534616, -221.121102323755, -221.1211053889031, -221.1211056591964, -221.121095659792, -221.1211087176653, -221.1210989952467, -221.1211120530935, -221.1210983104099, -221.1211060668956, -221.1211016458509, -221.1211094023375, -221.1211060755986, -221.1210983016545, -221.1211094110404, -221.1211016370958, -221.1211333775803, -221.1210710011372, -221.121136713906, -221.1210743356945, -221.1211174213506, -221.1210869560419, -221.121120756771, 
  -221.1210902915044, -221.1211230362766, -221.1210813425715, -221.1211263717288, -221.1210846780022, -221.121108891533, -221.121095485708, -221.121112226834, -221.12109882129, -221.1211024108622, -221.1211019664977, -221.1211057462996, -221.1211053019432, -221.1211295376261, -221.1210748392781, -221.1211328730662, -221.121078174721, -221.1211024307675, -221.1211025848955, -221.1211051277231, -221.1211052818517, -221.1210988722257, -221.1211061434441, -221.1211015691823, -221.1211088403995, -221.1210954635028, -221.1211095522149, -221.1210981604614, -221.1211122491682, -221.1211023726848, -221.1211026429782, -221.1211050696407, -221.1211053399341, -221.1210959790212, -221.1211090368824, -221.1210986759784, -221.1211117338372, -221.1210986296327, -221.1211063861191, -221.1211013265889, 
  -221.1211090830748, -221.1211063948219, -221.1210986208775, -221.1211090917778, -221.1211013178334, -221.1211336971878, -221.121071319976, -221.1211363942593, -221.1210740168165, -221.1211177405541, -221.1210872752846, -221.1211204375282, -221.1210899722225, -221.1211233555034, -221.1210816617911, -221.1211260524629, -221.1210843587435, -221.1211092107023, -221.121095804985, -221.1211119076254, -221.1210985019738, -221.1211027300838, -221.1211022857224, -221.1211054270388, -221.1211049826793, -221.1211298568489, -221.1210751585016, -221.1211325538041, -221.1210778554583, -221.1211001436387, -221.1211074148565, -221.121100297767, -221.1211075689847, -221.1210967349168, -221.1211108236262, -221.1210968890451, -221.1211109777545, -221.1211036440974, -221.1211039143908, -221.1211037982257, 
  -221.1211040685191, -221.1210972504343, -221.1211103082947, -221.1210974045629, -221.1211104624226, -221.1210999010451, -221.1211076575321, -221.1211000551741}
 {-452.2137942990372, -452.213796484831, -452.2137955566804, -452.2137930414142, -452.2137921132648, -452.2137960359023, -452.2137960056089, -452.2137925924859, -452.2137925621927, -452.2137969377643, -452.2137951037498, -452.2137934943378, -452.2137916603437, -452.2137983860632, -452.2137936554905, -452.213794942646, -452.2137902120751, -452.2137959968434, -452.2137960446678, -452.2137925534271, -452.2137926012514, -452.2137956087922, -452.2137964327817, -452.2137921653735, -452.2137929893677, -452.2137943145265, -452.2137977270022, -452.2137908711101, -452.2137942835859, -452.2137979386196, -452.2137941029102, -452.2137944952034, -452.2137906594937, -452.2137648450654, -452.2138271978701, -452.213761401354, -452.2138237547487, -452.2138198225272, -452.2137722193518, -452.2138163791088, 
  -452.2137687759376, -452.2138113213865, -452.2137807210684, -452.2138078779707, -452.2137772776515, -452.2137983497078, -452.2137936918339, -452.2137949062573, -452.2137902484518, -452.2138050696677, -452.2137869718991, -452.2138016262536, -452.2137835284805, -452.2138077242591, -452.2137843171878, -452.2138042808431, -452.2137808737709, -452.2137947782591, -452.2137947479657, -452.2137938501091, -452.2137938198158, -452.2137956801162, -452.2137938461117, -452.2137947519658, -452.2137929179619, -452.2137971284216, -452.2137923978457, -452.2137962002675, -452.2137914696998, -452.2137947392004, -452.2137947870245, -452.2137938110503, -452.2137938588745, -452.2137943511449, -452.2137951751427, -452.2137934230007, -452.2137942469869, -452.2137930568833, -452.2137964693592, 
  -452.2137921287333, -452.2137955412091, -452.2137966809765, -452.213792845267, -452.2137957528265, -452.2137919171168, -452.2137635872553, -452.2138259403939, -452.2137626591443, -452.2138250122049, -452.2138185648892, -452.2137709617035, -452.2138176367268, -452.2137700335658, -452.2138100637426, -452.213779463426, -452.2138091355946, -452.2137785352738, -452.2137970920421, -452.2137924342132, -452.2137961639029, -452.2137915060524, -452.2138038120266, -452.213785714254, -452.2138028838747, -452.2137847861056, -452.2138064666166, -452.2137830595439, -452.2138055384657, -452.2137821313946, -452.2137952311875, -452.2137933971832, -452.2137952008942, -452.2137933668899, -452.213796679491, -452.2137919489191, -452.2137966491976, -452.2137919186259, -452.2137942902718, -452.213794338096, 
  -452.2137942599785, -452.2137943078027, -452.2137939022199, -452.2137947262106, -452.2137938719253, -452.2137946959184, -452.2137926079551, -452.2137960204303, -452.2137925776612}
 {-154.5567147975441, -154.5566842355275, -154.556691348134, -154.5567382470317, -154.5567453597002, -154.5566877765215, -154.5566878071391, -154.5567417880571, -154.5567418186738, -154.5566813749955, -154.5566942086948, -154.5567353865634, -154.5567482201972, -154.5566862612767, -154.5566893224332, -154.5567402728073, -154.5567433339729, -154.5566877584492, -154.5566878252114, -154.5567417699845, -154.5567418367465, -154.5566968183783, -154.5566787662713, -154.5567508298657, -154.5567327778542, -154.5566898032776, -154.5566857804617, -154.556743814813, -154.5567397919966, -154.5566951908224, -154.5566803928927, -154.5567492023568, -154.5567344044287, -154.5568385394394, -154.5565370474626, -154.5568925538118, -154.5565910561605, -154.5567063845053, -154.5566691995212, -154.5567603959945, 
  -154.5567232111024, -154.5566777139249, -154.5566978726825, -154.556731725496, -154.5567518841818, -154.5566674254032, -154.5567081589141, -154.5567214360988, -154.5567621712889, -154.5566991657777, -154.5566764179668, -154.5567531772972, -154.5567304295176, -154.55672148139, -154.5566541026171, -154.5567754929273, -154.5567081141502, -154.5567112259173, -154.5567112565345, -154.5567183385548, -154.5567183691719, -154.5567048244057, -154.5567176580757, -154.5567119370467, -154.5567247707098, -154.5567097106618, -154.5567127718391, -154.5567168233156, -154.5567198844604, -154.5567112078447, -154.556711274607, -154.5567183204823, -154.5567183872444, -154.5567202677538, -154.556702215687, -154.5567273803837, -154.5567093283321, -154.5567132526746, -154.5567092298559, -154.5567203653095, 
  -154.556716342496, -154.5567186402178, -154.5567038422886, -154.556725752855, -154.5567109549263, -154.5568619901692, -154.5565604955239, -154.5568691029754, -154.5565676079926, -154.5567298338413, -154.5566926489764, -154.556736946552, -154.5566997615406, -154.5567011633333, -154.5567213220652, -154.5567082759809, -154.5567284346926, -154.5566908744255, -154.5567316086829, -154.5566979869698, -154.5567387214135, -154.5567226151639, -154.5566998673717, -154.5567297278044, -154.5567069800062, -154.5567449307861, -154.5566775520121, -154.5567520434247, -154.5566846646486, -154.556708365417, -154.5567211990838, -154.5567083960343, -154.5567212297007, -154.5567132516795, -154.5567163128409, -154.5567132822969, -154.5567163434577, -154.5567147488545, -154.5567148156167, -154.5567147794716, 
  -154.5567148462337, -154.5567238087571, -154.5567057567031, -154.5567238393794, -154.556705787315, -154.5567167936819, -154.5567127708679, -154.5567168243012}
 {-390.3713122003123, -390.3713124014518, -390.3713122913048, -390.371312109321, -390.371311999173, -390.3713123358541, -390.3713123569024, -390.3713120437227, -390.3713120647711, -390.3713124296208, -390.3713122631358, -390.3713121374895, -390.3713119710043, -390.3713121617474, -390.3713125310121, -390.3713118696161, -390.3713122388807, -390.3713123667033, -390.3713123260532, -390.371312074572, -390.3713120339218, -390.3713140783376, -390.3713106144225, -390.3713137862061, -390.3713103222912, -390.3713103412879, -390.3713143514734, -390.3713100491566, -390.371314059342, -390.3713156985786, -390.3713089941879, -390.3713154064473, -390.3713087020565, -390.3713097021732, -390.3713149906847, -390.3713094100063, -390.3713146985889, -390.3713127532908, -390.371311939478, -390.3713124611603, 
  -390.3713116473458, -390.3713236939753, -390.3713009989326, -390.3713234018436, -390.3713007068016, -390.3713182103535, -390.3713064823698, -390.3713179182192, -390.3713061902415, -390.3713179263234, -390.371306766405, -390.371317634192, -390.3713064742737, -390.3713147401708, -390.3713099529541, -390.3713144480395, -390.3713096608227, -390.371312244862, -390.3713122659103, -390.3713121347145, -390.3713121557627, -390.3713123386287, -390.3713121721437, -390.3713122284812, -390.371312061996, -390.3713120707553, -390.37131244002, -390.3713119606077, -390.3713123298724, -390.3713122757112, -390.3713122350611, -390.3713121655637, -390.3713121249135, -390.3713139873454, -390.3713105234304, -390.3713138771979, -390.3713104132829, -390.3713102502958, -390.3713142604813, -390.3713101401483, 
  -390.3713141503337, -390.3713156075865, -390.3713089031958, -390.371315497439, -390.3713087930482, -390.3713096111602, -390.3713148997134, -390.3713095010188, -390.3713147895597, -390.3713126622999, -390.3713118484846, -390.3713125521507, -390.3713117383388, -390.371323602983, -390.3713009079406, -390.3713234928356, -390.371300797793, -390.3713181193591, -390.3713063913799, -390.371318009213, -390.371306281231, -390.3713178353313, -390.3713066754129, -390.3713177251838, -390.3713065652654, -390.3713146491787, -390.371309861962, -390.3713145390311, -390.3713097518144, -390.3713122730308, -390.3713121065456, -390.3713122940791, -390.371312127594, -390.3713120051573, -390.371312374422, -390.3713120262056, -390.3713123954702, -390.3713122101133, -390.3713121694631, -390.3713122311616, 
  -390.3713121905114, -390.3713139217474, -390.3713104578325, -390.3713139427958, -390.3713104788808, -390.3713101846979, -390.3713141948833, -390.3713102057461}
 {-505.1408358998537, -505.1408346041525, -505.1408331716341, -505.1408386280951, -505.1408371955671, -505.1408339368345, -505.1408338389517, -505.1408379607727, -505.140837862889, -505.1408357996543, -505.1408319761356, -505.140839823583, -505.1408360000825, -505.1408330027478, -505.140834773052, -505.1408370266878, -505.1408387969875, -505.1408338374237, -505.1408339383626, -505.1408378613614, -505.1408379623004, -505.1408389377538, -505.1408288381434, -505.1408429616723, -505.1408328621003, -505.1408319617329, -505.1408358140744, -505.1408359856713, -505.1408398380114, -505.140835688452, -505.1408320873504, -505.1408397123895, -505.1408361112886, -505.1407994509099, -505.1408683258403, -505.1408034742535, -505.1408723503722, -505.1408448007296, -505.1408229751674, -505.1408488246757, 
  -505.140826999097, -505.1408493429724, -505.1408184337156, -505.1408533669031, -505.1408224576605, -505.1408336449517, -505.1408341309115, -505.1408376687748, -505.1408381549639, -505.1408341743065, -505.1408336015489, -505.1408381982472, -505.1408376254837, -505.1408452518515, -505.1408225238857, -505.1408492757913, -505.1408265478213, -505.1408366650572, -505.1408365671739, -505.1408352325339, -505.1408351346508, -505.1408385278719, -505.1408347043628, -505.1408370953491, -505.1408332718391, -505.1408357309731, -505.1408375012715, -505.1408342984463, -505.1408360687519, -505.1408365656461, -505.1408366665849, -505.1408351331228, -505.1408352340617, -505.1408416659667, -505.1408315663752, -505.1408402334433, -505.1408301338522, -505.1408346899559, -505.1408385422961, -505.140833257432, 
  -505.1408371097737, -505.1408384166741, -505.140834815573, -505.1408369841511, -505.1408333830499, -505.140802178816, -505.140871054379, -505.1408007463312, -505.1408696218173, -505.1408475289662, -505.1408257033756, -505.140846096423, -505.1408242708726, -505.1408520711917, -505.140821161941, -505.1408506386675, -505.1408197294188, -505.1408363731086, -505.1408368591994, -505.1408349406016, -505.1408354266599, -505.1408369025306, -505.1408363297694, -505.140835470007, -505.1408348972467, -505.1408479800744, -505.1408252521075, -505.1408465475522, -505.1408238195834, -505.140837860552, -505.1408340370424, -505.1408377626688, -505.1408339391591, -505.1408350636512, -505.1408368339531, -505.1408349657679, -505.1408367360699, -505.140835898326, -505.1408359992648, -505.1408358004426, 
  -505.1408359013815, -505.1408409986461, -505.1408308990554, -505.1408409007634, -505.1408308011716, -505.1408340226356, -505.1408378749761, -505.1408339247519}
 {-231.9062593886931, -231.9062591139981, -231.9062588215787, -231.9062599558118, -231.9062596633895, -231.9062589599627, -231.906258975614, -231.9062598017749, -231.9062598174264, -231.9062592474146, -231.9062586881626, -231.9062600892269, -231.9062595299748, -231.9062581550974, -231.9062597804848, -231.9062589969096, -231.9062606222971, -231.9062589790512, -231.9062589565255, -231.9062598208634, -231.9062597983377, -231.9062578493199, -231.9062600862759, -231.9062586911321, -231.9062609280881, -231.9062597455787, -231.9062581900071, -231.906260587391, -231.9062590318194, -231.906258973525, -231.906258962053, -231.9062598153372, -231.9062598038653, -231.90626192256, -231.9062560130843, -231.9062627644329, -231.906256854836, -231.9062575201591, -231.9062604154257, -231.9062583619698, 
  -231.9062612572396, -231.9062615252978, -231.9062564103803, -231.9062623671106, -231.9062572521919, -231.906264310009, -231.9062536255439, -231.9062651518077, -231.9062544673697, -231.9062640129808, -231.9062539225776, -231.906264854793, -231.9062547643898, -231.9062734305319, -231.9062445048525, -231.9062742723441, -231.9062453466648, -231.906259527078, -231.9062595427293, -231.9062592346571, -231.9062592503085, -231.9062598145299, -231.9062592552779, -231.906259522109, -231.906258962857, -231.9062587222127, -231.9062603476001, -231.9062584297918, -231.9062600551793, -231.9062595461665, -231.9062595236408, -231.9062592537457, -231.9062592312199, -231.9062584164352, -231.9062606533912, -231.9062581240143, -231.9062603609704, -231.9062603126941, -231.9062587571224, -231.9062600202732, 
  -231.9062584647015, -231.9062595406403, -231.9062595291684, -231.9062592482194, -231.9062592367475, -231.9062624897091, -231.9062565801658, -231.9062621972813, -231.9062562877519, -231.9062580872724, -231.9062609825431, -231.906257794854, -231.9062606901197, -231.9062620924135, -231.9062569774952, -231.9062617999925, -231.9062566850745, -231.9062648771158, -231.9062541926678, -231.9062645846985, -231.9062539002434, -231.9062645800961, -231.9062544896929, -231.9062642876752, -231.9062541972721, -231.9062739976471, -231.9062450719679, -231.9062737052263, -231.906244779547, -231.9062596604937, -231.9062591012417, -231.9062596761451, -231.906259116893, -231.9062585681765, -231.9062601935639, -231.9062585838279, -231.9062602092153, -231.9062593921303, -231.9062593696045, -231.9062594077817, 
  -231.906259385256, -231.906258262399, -231.906260499355, -231.9062582780504, -231.9062605150064, -231.9062601586578, -231.9062586030862, -231.9062601743092}
 {-425.9961447995506, -425.9961462434978, -425.9961461845498, -425.9961434145576, -425.9961433556088, -425.9961462068999, -425.9961462211477, -425.9961433779592, -425.9961433922073, -425.9961470033998, -425.9961454246481, -425.9961441744583, -425.9961425957085, -425.9961472796103, -425.9961451484427, -425.9961444506699, -425.9961423195021, -425.996146273151, -425.9961461548965, -425.9961434442105, -425.996143325956, -425.9961385209126, -425.9961539071175, -425.9961356919815, -425.9961510781674, -425.9961482270661, -425.9961442009741, -425.9961453981252, -425.9961413720339, -425.9961459614775, -425.9961464665688, -425.9961431325374, -425.9961436376278, -425.9961430200736, -425.9961494085173, -425.9961401910102, -425.9961465796996, -425.9961576118858, -425.9961348162259, -425.9961547829495, 
  -425.9961319872811, -425.996097696057, -425.9961947325034, -425.9960948671138, -425.9961919035655, -425.9961521030236, -425.9961403249905, -425.9961492740764, -425.9961374960564, -425.9961450342498, -425.9961473938915, -425.9961422053094, -425.9961445649507, -425.9961034465272, -425.996188983105, -425.9961006175841, -425.996186154167, -425.9961448219009, -425.9961448361488, -425.9961447629526, -425.9961447772005, -425.9961456184007, -425.9961440396495, -425.9961455594519, -425.9961439807016, -425.9961458946115, -425.9961437634437, -425.996145835663, -425.9961437044954, -425.9961448881521, -425.9961447698975, -425.9961448292038, -425.9961447109492, -425.996137135917, -425.9961525221152, -425.9961370769714, -425.996152463164, -425.9961468420668, -425.9961428159754, -425.9961467831188, 
  -425.9961427570268, -425.9961445764788, -425.9961450815696, -425.9961445175304, -425.9961450226213, -425.996141635011, -425.996148023582, -425.9961415760671, -425.9961479646292, -425.9961562268904, -425.9961334312234, -425.9961561679392, -425.996133372278, -425.9960963110568, -425.9961933475059, -425.9960962521084, -425.9961932885576, -425.996150718021, -425.9961389399951, -425.9961506590733, -425.9961388810462, -425.996143649251, -425.9961460088925, -425.9961435903026, -425.9961459499442, -425.9961020615271, -425.9961875981071, -425.9961020025785, -425.9961875391591, -425.9961455818022, -425.9961440030516, -425.9961455960503, -425.9961440172995, -425.9961458580133, -425.9961437268455, -425.9961458722612, -425.9961437410935, -425.996144851554, -425.9961447332993, -425.996144865802, 
  -425.9961447475474, -425.9961370993211, -425.9961524855147, -425.9961371135674, -425.9961524997643, -425.9961468054689, -425.9961427793771, -425.9961468197168}
 {-166.8683878703758, -166.8683864973686, -166.8683868957264, -166.8683888450577, -166.8683892434191, -166.8683865821277, -166.8683868109671, -166.8683889298164, -166.8683891586603, -166.8683837656439, -166.8683896274564, -166.8683861133376, -166.8683919751446, -166.8683856636776, -166.8683877294273, -166.8683880113682, -166.8683900771185, -166.8683864355573, -166.8683869575376, -166.8683887832482, -166.8683893052285, -166.8683649744035, -166.8684084189075, -166.8683673220987, -166.8684107665941, -166.8683903568031, -166.8683830363007, -166.8683927044936, -166.868385383992, -166.8683732835611, -166.868400109633, -166.8683756312523, -166.8684024573236, -166.8683985028956, -166.8683748909203, -166.8684008510943, -166.8683772381033, -166.8683955423067, -166.8683778508747, -166.8683978899803, 
  -166.8683801985828, -166.8684279527445, -166.8683454413224, -166.8684303004427, -166.8683477890061, -166.8683955531818, -166.8683778398987, -166.8683979007903, -166.868380187672, -166.8683789751164, -166.8683944182653, -166.8683813228059, -166.8683967659577, -166.868335559508, -166.8684378369191, -166.8683379071985, -166.8684401846104, -166.8683875567753, -166.8683877856169, -166.8683879551349, -166.8683881839765, -166.8683847402942, -166.8683906021035, -166.8683851386532, -166.8683910004636, -166.868386638326, -166.8683887040762, -166.8683870366858, -166.8683891024356, -166.868387410206, -166.8683879321863, -166.8683878085655, -166.8683883305458, -166.8683659490544, -166.868409393554, -166.8683663474139, -166.8684097919136, -166.8683913314515, -166.8683840109496, -166.8683917298111, 
  -166.8683844093092, -166.8683742582099, -166.8684010842815, -166.8683746565695, -166.868401482641, -166.868399477794, -166.8683758653192, -166.8683998761619, -166.8683762636705, -166.8683965169409, -166.8683788255378, -166.8683969153121, -166.8683792238858, -166.8684289273967, -166.8683464159675, -166.8684293257565, -166.8683468143269, -166.8683965277918, -166.8683788145859, -166.8683969261462, -166.8683792129507, -166.8683799497643, -166.8683953929148, -166.8683803481239, -166.8683957912743, -166.8683365341565, -166.868438811568, -166.868336932516, -166.8684392099276, -166.8683848250528, -166.8683906868627, -166.8683850538945, -166.8683909157042, -166.868386723085, -166.868388788835, -166.8683869519266, -166.8683890176766, -166.8683874949649, -166.8683880169452, -166.8683877238065, 
  -166.8683882457868, -166.8683660338133, -166.8684094783129, -166.8683662626548, -166.8684097071545, -166.8683914162105, -166.8683840957084, -166.8683916450519}
 {-366.6775704866431, -366.677576684737, -366.6775764049773, -366.6775645683315, -366.6775642885738, -366.6775765406082, -366.6775765491057, -366.6775644242036, -366.6775644327012, -366.677576701268, -366.6775763884478, -366.6775645848622, -366.6775642720445, -366.6775819307551, -366.6775711589882, -366.6775698143502, -366.6775590425841, -366.6775765553183, -366.6775765343955, -366.6775644389138, -366.677564417991, -366.6775757022146, -366.6775773875298, -366.6775635858137, -366.6775652711216, -366.6775766016364, -366.677576488092, -366.6775644852321, -366.6775643716873, -366.6775824423461, -366.67757064741, -366.6775703259417, -366.6775585310055, -366.6775860068765, -366.6775670851531, -366.6775738905926, -366.677554968628, -366.6775726299188, -366.6775804600597, -366.6775605135147, 
  -366.6775683436548, -366.6775979427655, -366.6775551491656, -366.6775858263617, -366.6775430327605, -366.6775943808953, -366.6775587087149, -366.6775822644895, -366.6775465923116, -366.6775935319104, -366.6775595577171, -366.6775814155055, -366.677547441313, -366.6776021295476, -366.6775509604135, -366.6775900131428, -366.6775388440093, -366.6775706222741, -366.6775706307716, -366.6775703425154, -366.6775703510129, -366.677570782934, -366.6775704701135, -366.6775705031738, -366.6775701903565, -366.6775760124213, -366.6775652406539, -366.6775757326616, -366.6775649608961, -366.6775706369842, -366.6775706160614, -366.6775703572255, -366.6775703363028, -366.6775697838829, -366.6775714691933, -366.6775695041231, -366.6775711894357, -366.6775706833023, -366.677570569758, -366.6775704035439, 
  -366.6775702899989, -366.677576524012, -366.6775647290759, -366.6775762442533, -366.6775644493173, -366.6775800886147, -366.6775611667467, -366.677579808832, -366.6775608870119, -366.6775667115817, -366.6775745417287, -366.6775664318295, -366.6775742619634, -366.6775920244318, -366.6775492308311, -366.6775917446729, -366.6775489510727, -366.6775884625593, -366.6775527903828, -366.6775881828031, -366.6775525106214, -366.6775876135769, -366.6775536393824, -366.6775873338166, -366.6775533596252, -366.6775962112133, -366.6775450420795, -366.6775959314545, -366.6775447623209, -366.6775706388049, -366.677570325986, -366.6775706473024, -366.6775703344835, -366.6775758682924, -366.6775650965259, -366.6775758767899, -366.6775651050235, -366.6775704928558, -366.6775704719329, -366.6775705013534, 
  -366.6775704804306, -366.6775696397548, -366.6775713250645, -366.6775696482505, -366.677571333564, -366.677570539174, -366.6775704256294, -366.6775705476714}
 {-231.941301049068, -231.9413001907035, -231.9413010730307, -231.9413010251164, -231.9413019074505, -231.9413005825255, -231.9413006812083, -231.9413014169418, -231.9413015156247, -231.941299602168, -231.9413016615687, -231.9413004365913, -231.9413024959781, -231.941301227757, -231.9413000359898, -231.9413020621723, -231.9413008704073, -231.9413005848319, -231.9413006789019, -231.9413014192483, -231.9413015133182, -231.9412970766345, -231.9413041871863, -231.9412979110661, -231.9413050215875, -231.9412993266203, -231.9413019371299, -231.9413001610362, -231.9413027715467, -231.9413026637158, -231.9412986000366, -231.9413034981322, -231.9412994344529, -231.9413301012673, -231.9412711637638, -231.9413309362043, -231.9412719976595, -231.9413072091687, -231.9412940547078, -231.9413080435825, 
  -231.9412948891267, -231.941315594794, -231.9412856698815, -231.9413164292172, -231.941286504291, -231.9413020435973, -231.9412992201834, -231.9413028779367, -231.9413000546766, -231.9413036876705, -231.9412975760812, -231.9413045220829, -231.9412984105013, -231.9413126135895, -231.9412886500659, -231.9413134480036, -231.9412894844846, -231.9413005585615, -231.9413006572443, -231.9413014408921, -231.941301539575, -231.9412995782074, -231.9413016376013, -231.9413004605382, -231.9413025199318, -231.941301203791, -231.9413000120279, -231.9413020861246, -231.9413008943555, -231.9413005608679, -231.9413006549379, -231.9413014431986, -231.9413015372685, -231.941297052678, -231.9413041632148, -231.9412979350089, -231.9413050455452, -231.9412993026557, -231.9413019131665, -231.9413001849871, 
  -231.9413027954963, -231.9413026397518, -231.9412985760726, -231.9413035220824, -231.9412994584032, -231.9413300775408, -231.9412711395623, -231.9413309599171, -231.9412720218473, -231.941307185197, -231.9412940307515, -231.9413080675405, -231.9412949130693, -231.9413155708322, -231.9412856459153, -231.9413164531653, -231.9412865282435, -231.9413020196007, -231.9412991962519, -231.9413029019195, -231.9413000785944, -231.9413036637047, -231.941297552119, -231.941304546035, -231.9412984344498, -231.9413125896249, -231.9412886261026, -231.9413134719545, -231.9412895084342, -231.9412999700311, -231.941302029425, -231.9413000687141, -231.9413021281076, -231.9413015956162, -231.9413004038501, -231.941301694299, -231.9413005025329, -231.9413009526916, -231.9413010467616, -231.9413010513744, 
  -231.9413011454444, -231.9412974445017, -231.9413045550385, -231.9412975431848, -231.9413046537211, -231.9412996944796, -231.94130230499, -231.9412997931628}
 {-18.48399034930736, -18.48399018148899, -18.48399016061398, -18.4839905379998, -18.48399051712486, -18.4839901722637, -18.48399016983926, -18.48399052877455, -18.48399052635011, -18.48399065636126, -18.48398968577553, -18.48399101286482, -18.48399004229368, -18.48399343176777, -18.48398691034491, -18.48399378827725, -18.48398726685713, -18.48399017169276, -18.48399017041022, -18.48399052820358, -18.48399052692109, -18.48399432921367, -18.48398601395838, -18.48399468579387, -18.48398637039988, -18.48399001895991, -18.48399032314843, -18.48399037547034, -18.4839906796597, -18.48399286961387, -18.48398747251269, -18.48399322612478, -18.48398782902347, -18.48399038927157, -18.4839899528345, -18.48399074578309, -18.48399030934468, -18.48398935550183, -18.48399098672115, -18.48398971202581, 
  -18.48399134321888, -18.48399739596096, -18.48398294733843, -18.48399775250429, -18.4839833038168, -18.48399019281995, -18.48399014928314, -18.48399054933055, -18.48399050579425, -18.48400222685598, -18.48397811517511, -18.48400258336726, -18.48397847168554, -18.48401366400962, -18.48396667795998, -18.48401402050815, -18.48396703448315, -18.48399036095707, -18.48399035853263, -18.4839903400821, -18.48399033765766, -18.48399084505137, -18.48398987447216, -18.48399082417562, -18.48398985359796, -18.48399362046051, -18.48398709903892, -18.48399359958543, -18.48398707816405, -18.48399036038612, -18.4839903591036, -18.48399033951114, -18.48399033822863, -18.4839945179413, -18.48398620261748, -18.48399449706715, -18.48398618174168, -18.4839902076531, -18.48399051184199, -18.48399018677808, 
  -18.48399049096706, -18.48399305830728, -18.48398766120602, -18.48399303743229, -18.48398764033105, -18.48399057796528, -18.48399014152753, -18.48399055709029, -18.48399012065257, -18.48398954420152, -18.4839911754082, -18.48398952332704, -18.48399115453274, -18.48399758467036, -18.48398313601577, -18.48399756379581, -18.48398311514038, -18.48399038151319, -18.48399033797664, -18.48399036063822, -18.48399031710166, -18.48400241554958, -18.48397830386826, -18.48400239467459, -18.4839782829933, -18.48401385269691, -18.48396686665944, -18.48401383182178, -18.48396684578461, -18.48399083582571, -18.48398986524728, -18.48399083340128, -18.48398986282284, -18.48399361123519, -18.4839870898137, -18.48399360881075, -18.48398708738926, -18.48399035116085, -18.48399034987833, -18.48399034873641, 
  -18.48399034745389, -18.48399450871668, -18.48398619339157, -18.48399450629178, -18.4839861909676, -18.48399019842781, -18.48399050261674, -18.48399019600336}
 {-296.1311265262396, -296.1311271639952, -296.1311272184728, -296.1311258340097, -296.1311258884874, -296.1311272019007, -296.1311271805673, -296.1311258719153, -296.1311258505818, -296.1311278312787, -296.1311265511896, -296.1311265012928, -296.1311252212046, -296.1311290341087, -296.1311253483628, -296.1311277041234, -296.1311240183774, -296.1311271605525, -296.1311272219155, -296.131125830567, -296.1311258919301, -296.1311271472141, -296.1311272352539, -296.1311258172288, -296.1311259052683, -296.1311271675463, -296.1311272149217, -296.1311258375609, -296.1311258849362, -296.1311272033011, -296.131127179167, -296.1311258733156, -296.1311258491816, -296.1311378651629, -296.1311165176988, -296.1311365353352, -296.1311151875556, -296.1311193776959, -296.131135004818, -296.1311180477075, 
  -296.1311336748355, -296.1311269602482, -296.1311274222199, -296.1311256302634, -296.1311260922339, -296.1311320264608, -296.1311223559927, -296.1311306964604, -296.1311210260221, -296.1311260186383, -296.1311283639244, -296.131124688653, -296.1311270339388, -296.1311271935327, -296.1311271889353, -296.1311258635472, -296.1311258589499, -296.1311265096676, -296.1311264883341, -296.1311265641452, -296.1311265428118, -296.1311271390455, -296.1311258589566, -296.1311271935228, -296.1311259134345, -296.1311283418756, -296.1311246561297, -296.1311283963533, -296.1311247106073, -296.1311264683193, -296.1311265296824, -296.131126522797, -296.13112658416, -296.131126454981, -296.1311265430207, -296.1311265094587, -296.1311265974984, -296.1311264753132, -296.1311265226885, -296.1311265297908, 
  -296.1311265771662, -296.1311265110679, -296.1311264869338, -296.1311265655456, -296.1311265414115, -296.1311371730069, -296.1311158253886, -296.131137227488, -296.1311158798627, -296.1311186854582, -296.1311343125895, -296.131118739942, -296.131134367061, -296.1311262680154, -296.1311267299865, -296.131126322493, -296.1311267844641, -296.1311313342207, -296.1311216637666, -296.1311313886974, -296.131121718245, -296.1311253264053, -296.1311276716912, -296.1311253808829, -296.1311277261689, -296.1311265012996, -296.1311264967022, -296.1311265557772, -296.1311265511798, -296.1311271769509, -296.1311258968623, -296.1311271556174, -296.1311258755288, -296.1311283797812, -296.1311246940353, -296.1311283584478, -296.1311246727018, -296.1311265062249, -296.1311265675879, -296.1311264848914, 
  -296.1311265462545, -296.1311264928866, -296.1311265809262, -296.1311264715531, -296.1311265595928, -296.1311265132187, -296.1311265605941, -296.1311264918853}
 {-357.0724184477827, -357.0724202756603, -357.0724201012953, -357.0724167942737, -357.0724166199086, -357.0724201774131, -357.0724201995424, -357.0724166960265, -357.0724167181557, -357.0724202371937, -357.072420139762, -357.072416755807, -357.0724166583754, -357.0724215479607, -357.0724188290011, -357.0724180665741, -357.0724153476145, -357.0724202081229, -357.0724201688326, -357.0724167267363, -357.0724166874459, -357.0724199848522, -357.0724203921114, -357.0724165034661, -357.0724169107242, -357.0724213946212, -357.0724189823403, -357.0724179132346, -357.0724155009536, -357.0724214741697, -357.0724189027977, -357.0724179927831, -357.072415421411, -357.0724253666303, -357.0724150108982, -357.0724218853106, -357.0724115294447, -357.0724166311357, -357.072423745888, -357.072413149749, 
  -357.0724202645013, -357.0724351581125, -357.0724052195503, -357.072431676726, -357.0724017381635, -357.0724259263845, -357.0724144505401, -357.0724224449973, -357.072410969154, -357.0724256972582, -357.0724146796709, -357.0724222158716, -357.0724111982842, -357.072430701261, -357.0724096756853, -357.0724272198743, -357.0724061942987, -357.0724185239006, -357.07241854603, -357.0724183495356, -357.0724183716648, -357.0724185836814, -357.0724184862494, -357.0724184093161, -357.0724183118847, -357.0724198944483, -357.0724171754886, -357.0724197200831, -357.0724170011238, -357.0724185546105, -357.0724185153201, -357.0724183802455, -357.0724183409551, -357.0724183313401, -357.0724187385986, -357.0724181569749, -357.0724185642338, -357.0724197411086, -357.0724173288279, -357.0724195667438, 
  -357.0724171544627, -357.0724198206572, -357.0724172492852, -357.0724196462922, -357.0724170749202, -357.0724237131587, -357.072413357345, -357.072423538779, -357.0724131829947, -357.072414977621, -357.0724220923778, -357.0724148032605, -357.0724219180082, -357.0724335046002, -357.0724035660376, -357.072433330235, -357.0724033916728, -357.0724242728708, -357.072412797029, -357.0724240985078, -357.072412622662, -357.0724240437459, -357.0724130261584, -357.0724238693806, -357.0724128517937, -357.0724290477485, -357.0724080221727, -357.0724288733834, -357.0724078478078, -357.072418485434, -357.0724183880024, -357.0724185075633, -357.0724184101317, -357.072419796201, -357.0724170772415, -357.0724198183303, -357.0724170993707, -357.0724184563633, -357.0724184170729, -357.0724184784925, 
  -357.0724184392021, -357.072418233093, -357.0724186403513, -357.0724182552219, -357.0724186624808, -357.0724196428615, -357.0724172305805, -357.0724196649908}
 {-260.3758988648139, -260.3758998361942, -260.3758996963089, -260.3758980333304, -260.375897893439, -260.3758997333365, -260.3758997991662, -260.3758979304698, -260.3758979962993, -260.3759015910126, -260.3758979414904, -260.3758997881445, -260.375896138625, -260.3759008944478, -260.3758986380715, -260.3758990915811, -260.3758968352046, -260.3758999823696, -260.3758995501329, -260.3758981795028, -260.3758977472662, -260.3759109874416, -260.375888545084, -260.3759091845704, -260.3758867422217, -260.3758922456658, -260.3759072868495, -260.3758904427994, -260.3759054839824, -260.3759021933705, -260.3758973391436, -260.3759003905035, -260.3758955362771, -260.375912883078, -260.3758866499887, -260.3759110804236, -260.3758848469096, -260.3758904260276, -260.3759091065421, -260.3758886231536, 
  -260.3759073036826, -260.3758509652962, -260.3759485677198, -260.3758491624332, -260.3759467648492, -260.3759097933581, -260.3758897391088, -260.3759079904683, -260.3758879362651, -260.3758608975166, -260.3759386358383, -260.3758590946504, -260.375936832971, -260.3758707771992, -260.3759287569463, -260.375868974334, -260.375926954078, -260.3758989018435, -260.375898967673, -260.3758987619551, -260.3758988277847, -260.3759007595193, -260.3758971099975, -260.37590061963, -260.3758969701101, -260.3759000629548, -260.3758978065783, -260.3758999230664, -260.3758976666901, -260.3758991508765, -260.3758987186398, -260.3758990109882, -260.3758985787516, -260.3759101559466, -260.3758877135927, -260.3759100160575, -260.3758875737053, -260.3758914141729, -260.3759064553561, -260.3758912742844, 
  -260.3759063154681, -260.3759013618772, -260.3758965076507, -260.375901221989, -260.3758963677623, -260.375912051703, -260.3758858183773, -260.3759119117906, -260.3758856785132, -260.3758895945274, -260.3759082750561, -260.375889454646, -260.3759081351609, -260.3758501338053, -260.3759477362244, -260.3758499939163, -260.3759475963368, -260.3759089618528, -260.3758889076278, -260.3759088219658, -260.3758887677383, -260.3758600660238, -260.375937804345, -260.3758599261355, -260.3759376644565, -260.375869945707, -260.3759279254523, -260.3758698058185, -260.3759277855642, -260.3759006566597, -260.3758970071388, -260.3759007224892, -260.3758970729685, -260.3758999600956, -260.3758977037192, -260.3759000259252, -260.3758977695488, -260.3758990480174, -260.3758986157807, -260.375899113847, 
  -260.3758986816104, -260.3759100530876, -260.3758876107334, -260.3759101189162, -260.3758876765641, -260.3758913113136, -260.3759063524973, -260.3758913771435}
 {-601.5522123236931, -601.5522205150797, -601.5522321872197, -601.5521924603474, -601.5522041326706, -601.5522258941668, -601.552226808113, -601.5521978395197, -601.5521987534787, -601.5522056057043, -601.5522470966003, -601.552177551127, -601.552219041896, -601.552164123561, -601.5522885790821, -601.552136068889, -601.5522605244731, -601.5522252347161, -601.5522274675639, -601.5521971800753, -601.5521994129228, -601.5521561560278, -601.5522965468487, -601.5521281015093, -601.5522684920855, -601.5521888444722, -601.5522638581135, -601.5521607898292, -601.5522358034747, -601.5522021722889, -601.5522505302166, -601.5521741176517, -601.5522224755723, -601.5520531542448, -601.5523995626277, -601.5520250941542, -601.5523715134374, -601.5520851718374, -601.5523675321549, -601.5520571173146, 
  -601.5523394773963, -601.5519635974173, -601.5524891142019, -601.5519355427282, -601.5524610596094, -601.5523115020237, -601.552141200025, -601.5522834467991, -601.552113145968, -601.5522169153054, -601.5522357885352, -601.5521888606295, -601.5522077339296, -601.5521414007958, -601.5523113106481, -601.5521133461432, -601.5522832560195, -601.5522060306122, -601.552206944563, -601.5522177028417, -601.5522186167964, -601.5521857421813, -601.5522272330185, -601.5521974144174, -601.5522389052455, -601.5521442599879, -601.5522687155506, -601.5521559322299, -601.5522803877714, -601.5522053711635, -601.5522076040114, -601.5522170433949, -601.5522192762429, -601.5521362925282, -601.5522766832437, -601.5521479647767, -601.5522883554583, -601.552168980915, -601.5522439945658, -601.5521806531539, 
  -601.5522556667899, -601.5521823087376, -601.552230666663, -601.5521939809704, -601.5522423388935, -601.5520332884357, -601.5523797013319, -601.5520449597305, -601.5523913745003, -601.5520653083926, -601.5523476684948, -601.5520769805269, -601.5523593408236, -601.551943733848, -601.5524692506661, -601.5519554060648, -601.5524809229122, -601.55229163825, -601.5521213366937, -601.5523033103402, -601.5521330090665, -601.5521970517413, -601.5522159249945, -601.552208723961, -601.5522275972377, -601.5521215372409, -601.552291447098, -601.5521332094652, -601.5523031193372, -601.552191121313, -601.5522326121459, -601.5521920352661, -601.5522335260981, -601.5521496391227, -601.5522740946748, -601.5521505530755, -601.5522750086279, -601.5522107502932, -601.5522129831411, -601.5522116642459, 
  -601.5522138970935, -601.552141671668, -601.5522820623632, -601.5521425856173, -601.5522829763195, -601.5521743600452, -601.5522493736945, -601.5521752740041}
 {-91.4581843456228, -91.4581606926021, -91.4581613072907, -91.4582073840952, -91.4582079987922, -91.4581608464195, -91.4581611534735, -91.458207537915, -91.4582078449725, -91.4581611631707, -91.4581608367504, -91.4582078546661, -91.4582075282495, -91.4581641205615, -91.458157879337, -91.4582108120586, -91.4582045708346, -91.4581610042047, -91.4581609956883, -91.4582076957019, -91.4582076871856, -91.458145262566, -91.4581767383291, -91.4581919540768, -91.4582234298128, -91.4581605749444, -91.4581614249535, -91.458207266441, -91.4582081164514, -91.4581639574302, -91.4581580424878, -91.4582106489278, -91.4582047339848, -91.4582230492536, -91.4580989515521, -91.4582697422398, -91.4581456415604, -91.4581559125165, -91.4581660874857, -91.4582026039728, -91.458212779024, -91.4581799135036, 
  -91.4581420875944, -91.4582266050185, -91.458188779074, -91.4581466025653, -91.4581753977351, -91.4581932934281, -91.4582220898669, -91.4581730745599, -91.4581489252599, -91.4582197660562, -91.4581956167581, -91.4581879162662, -91.4581340833352, -91.4582346077621, -91.4581807748338, -91.4581838847485, -91.4581841918042, -91.4581844994413, -91.4581848064971, -91.4581842014993, -91.4581838750815, -91.4581848161928, -91.4581844897736, -91.4581871588912, -91.4581809176671, -91.4581877735842, -91.4581815323598, -91.4581840425345, -91.4581840340182, -91.4581846572274, -91.458184648711, -91.4581683009032, -91.4581997766516, -91.4581689155949, -91.4582003913455, -91.4581836132736, -91.458184463284, -91.4581842279671, -91.4581850779762, -91.4581869957603, -91.4581810808175, -91.458187610453, 
  -91.4581816955104, -91.4582460883225, -91.4581219891429, -91.4582467030261, -91.4581226038249, -91.4581789508039, -91.4581891258581, -91.4581795655407, -91.4581897405069, -91.4582029518416, -91.4581651259161, -91.4582035665358, -91.4581657406076, -91.4581696405821, -91.458198436378, -91.4581702552665, -91.4581990510792, -91.4581961128889, -91.4581719635906, -91.4581967275824, -91.4581725782827, -91.4582109545957, -91.4581571216654, -91.4582115692879, -91.4581577363588, -91.4581843553182, -91.4581840288997, -91.458184662374, -91.4581843359555, -91.4581873127099, -91.4581810714856, -91.4581876197656, -91.4581813785414, -91.4581841963531, -91.4581841878367, -91.4581845034089, -91.4581844948925, -91.4581684547201, -91.4581999304719, -91.4581687617781, -91.4582002375254, -91.4581837670925, 
  -91.4581846171023, -91.4581840741483}
 {-358.3232031352074, -358.3232047127729, -358.3232045991704, -358.3232016712479, -358.3232015576448, -358.3232046642685, -358.3232046476746, -358.3232016227433, -358.3232016061493, -358.323204629983, -358.3232046819604, -358.3232015884577, -358.3232016404351, -358.3232066687056, -358.3232026432436, -358.3232036271804, -358.3231996017183, -358.3232046700309, -358.3232046419123, -358.3232016285057, -358.323201600387, -358.3232053827155, -358.3232039292377, -358.3232023411894, -358.3232008877134, -358.3232039479348, -358.3232053640133, -358.3232009064095, -358.3232023224881, -358.3232059992107, -358.3232033127453, -358.3232029576854, -358.3232002712201, -358.3232009367727, -358.3232083756862, -358.3231978951793, -358.3232053342291, -358.3232027122329, -358.3232065997718, -358.3231996707091, 
  -358.323203558245, -358.3232161795272, -358.3231931330748, -358.3232131380012, -358.3231900915502, -358.3232105616784, -358.3231987502308, -358.3232075201509, -358.3231957087078, -358.3232104927827, -358.3231988191282, -358.3232074512574, -358.323195777603, -358.323216900775, -358.3231924110787, -358.3232138592498, -358.3231893695533, -358.3232032003059, -358.3232031837119, -358.323203086703, -358.3232030701091, -358.3232031660204, -358.3232032179976, -358.3232030524174, -358.3232031043951, -358.3232052047431, -358.3232011792809, -358.3232050911401, -358.3232010656782, -358.3232032060682, -358.3232031779496, -358.3232030924654, -358.3232030643468, -358.3232039187521, -358.3232024652757, -358.3232038051499, -358.3232023516724, -358.3232024839721, -358.3232039000507, -358.3232023703693, 
  -358.3232037864479, -358.323204535248, -358.3232018487826, -358.3232044216452, -358.3232017351798, -358.3231994727695, -358.3232069117641, -358.3231993591795, -358.3232067981484, -358.3232012482725, -358.3232051358068, -358.3232011346666, -358.3232050222071, -358.323214715564, -358.3231916691126, -358.3232146019615, -358.3231915555095, -358.323209097714, -358.3231972862699, -358.3232089841125, -358.3231971726659, -358.3232090288202, -358.3231973551654, -358.3232089152171, -358.3231972415629, -358.3232154368123, -358.3231909471159, -358.3232153232096, -358.3231908335132, -358.3232031175159, -358.3232031694933, -358.3232031009218, -358.3232031528993, -358.3232051562385, -358.3232011307764, -358.3232051396445, -358.3232011141825, -358.3232031575638, -358.3232031294451, -358.3232031409698, 
  -358.3232031128512, -358.3232038702481, -358.3232024167709, -358.3232038536538, -358.3232024001771, -358.3232024354676, -358.3232038515463, -358.3232024188736}
 {-314.7626017510953, -314.7626054926544, -314.7626055502148, -314.762597951981, -314.7625980095428, -314.7626055032128, -314.7626055396564, -314.7625979625398, -314.7625979989838, -314.7626056001568, -314.7626054427131, -314.7625980594841, -314.7625979020404, -314.7626102063144, -314.7626008365628, -314.7626026656416, -314.7625932958902, -314.7626055307046, -314.7626055121644, -314.7625979900319, -314.7625979714918, -314.7626029352795, -314.762608107617, -314.762595394608, -314.7626005669432, -314.7626043988518, -314.762606644025, -314.7625968581791, -314.7625991033524, -314.7626094583843, -314.7626015845174, -314.7626019177117, -314.7625940438447, -314.7626111265398, -314.7625999175867, -314.7626035860483, -314.7625923767328, -314.7626024320111, -314.7626086110093, -314.7625948913328, 
  -314.7626010703422, -314.7626366696161, -314.7625743749978, -314.7626291289456, -314.7625668343228, -314.762629484391, -314.7625815583363, -314.7626219437116, -314.7625740176703, -314.762629165384, -314.7625818773498, -314.7626216247112, -314.762574336677, -314.7626588463055, -314.7625521960044, -314.7626513056327, -314.7625446553319, -314.762601704093, -314.7626017405368, -314.762601761654, -314.7626017980979, -314.7626018010373, -314.7626016435932, -314.7626018585981, -314.7626017011545, -314.7626064071945, -314.7625970374431, -314.7626064647557, -314.7625970950043, -314.762601731585, -314.7626017130447, -314.762601789146, -314.7626017706059, -314.7625991361602, -314.762604308497, -314.7625991937217, -314.7626043660576, -314.7626005997321, -314.7626028449054, -314.7626006572933, 
  -314.7626029024664, -314.7626056592646, -314.7625977853977, -314.7626057168257, -314.7625978429589, -314.7626073275014, -314.7625961183857, -314.7626073850812, -314.7625961759281, -314.7625986328865, -314.7626048118945, -314.7625986904517, -314.7626048694515, -314.7626328704972, -314.7625705758772, -314.7626329280589, -314.7625706334378, -314.7626256852683, -314.7625777592195, -314.7626257428287, -314.7625778167814, -314.7626253662644, -314.7625780782298, -314.7626254238251, -314.7625781357913, -314.7626550471858, -314.7625483968847, -314.7626551047468, -314.7625484544459, -314.7626018115957, -314.7626016541519, -314.7626018480395, -314.7626016905957, -314.7626064177532, -314.7625970480016, -314.7626064541969, -314.7625970844454, -314.7626017421435, -314.7626017236033, 
  -314.7626017785873, -314.7626017600471, -314.7625991467191, -314.7626043190552, -314.7625991831626, -314.7626043554993, -314.7626006102906, -314.7626028554638, -314.7626006467345}
 {-9.74205313948427, -9.74205320461653, -9.74205314378483, -9.74205313518422, -9.74205307435297, -9.74205317423127, -9.74205317417008, -9.74205310479918, -9.742053104738, -9.74205325706283, -9.74205309133974, -9.74205318763226, -9.74205302190614, -9.74205463983209, -9.74205170858674, -9.74205457040012, -9.74205163915453, -9.74205326296634, -9.74205308543503, -9.7420531935343, -9.7420530160029, -9.7420545511897, -9.74205179704487, -9.74205448171752, -9.74205172765289, -9.74205751424931, -9.7420488341419, -9.74205744481526, -9.74204876471177, -9.74204796015366, -9.74205838825879, -9.74204789072065, -9.74205831882762, -9.74205316768246, -9.74205318071889, -9.74205309825037, -9.74205311128682, -9.74206432762119, -9.74204202092956, -9.74206425819191, -9.74204195149466, -9.74200037364708, 
  -9.7421059756962, -9.74200030421837, -9.74210590626073, -9.74205320108226, -9.74205314731926, -9.74205313164969, -9.74205307788765, -9.74205578514649, -9.74205056327885, -9.74205571571252, -9.74205049384863, -9.74202261249675, -9.74208373778418, -9.74202254307079, -9.74208366834596, -9.74205316993061, -9.74205316986942, -9.74205310909913, -9.74205310903794, -9.74205325276319, -9.74205308703804, -9.74205319193117, -9.74205302620712, -9.74205463553174, -9.74205170428574, -9.74205457469974, -9.74205164345481, -9.7420532586657, -9.74205308113434, -9.74205319783422, -9.74205302030287, -9.74205454687432, -9.74205179275892, -9.74205448603218, -9.74205173193812, -9.74205750994772, -9.74204882984215, -9.74205744911612, -9.7420487690108, -9.74204795585254, -9.74205838395857, -9.74204789502105, 
  -9.74205832312712, -9.74205316338179, -9.74205317641823, -9.74205310255031, -9.74205311558676, -9.74206432332182, -9.74204201662759, -9.74206426249056, -9.74204195579591, -9.74200036934774, -9.7421059713942, -9.74200030851699, -9.74210591056201, -9.74205319678135, -9.74205314301883, -9.74205313594988, -9.74205308218736, -9.74205578084506, -9.74205055897893, -9.74205572001323, -9.74205049814783, -9.74202260819847, -9.74208373348112, -9.74202254736835, -9.7420836726483, -9.74205322237783, -9.74205305665312, -9.74205322231653, -9.74205305659203, -9.74205460514633, -9.74205167390087, -9.74205460508515, -9.74205167383968, -9.74205322828055, -9.74205305074919, -9.74205322821936, -9.74205305068801, -9.74205451648342, -9.74205176237953, -9.74205451642307, -9.7420517623175, -9.74205747956253, 
  -9.74204879945705, -9.74205747950131}
 {-698.8155838236381, -698.8155644461271, -698.8155666347315, -698.8156010126282, -698.8156032012592, -698.8155654665971, -698.8155656142615, -698.8156020331104, -698.8156021807768, -698.815563422504, -698.8155676583799, -698.8155999890205, -698.815604224892, -698.8155689987403, -698.815562082144, -698.8156055652499, -698.8155986486629, -698.8155655295472, -698.8155655513114, -698.8156020960614, -698.8156021178257, -698.815556945394, -698.8155741360954, -698.815593511952, -698.8156107025658, -698.815563561026, -698.8155675198401, -698.815600127539, -698.8156040863556, -698.8155632765418, -698.8155678043586, -698.8155998430568, -698.8156043708722, -698.81548707143, -698.8156440111986, -698.815523636118, -698.8156805795393, -698.8155652385585, -698.8155658425049, -698.8156018051089, 
  -698.8156024089834, -698.8155406047818, -698.8155904778303, -698.8155771712728, -698.8156270443679, -698.8155542876203, -698.8155767935868, -698.8155908535818, -698.815613360654, -698.815576590127, -698.8155544906748, -698.8156131566356, -698.8155910571946, -698.8155509754901, -698.8155801069913, -698.8155875419992, -698.8156166735112, -698.8155826554967, -698.815582803162, -698.8155848441141, -698.8155849917794, -698.8155806114039, -698.81558484728, -698.8155828000238, -698.8155870358952, -698.8155861876362, -698.8155792710481, -698.8155883762571, -698.8155814596622, -698.8155827184473, -698.8155827402115, -698.8155849070647, -698.8155849288288, -698.8155741343164, -698.8155913249732, -698.8155763229331, -698.8155935135914, -698.8155807499251, -698.8155847087413, -698.8155829385436, 
  -698.8155868973578, -698.8155804654423, -698.8155849932582, -698.8155826540597, -698.8155871818758, -698.8155042594457, -698.8156612009831, -698.8155064480057, -698.8156633896582, -698.8155824275005, -698.8155830313633, -698.8155846160704, -698.8155852200284, -698.8155577936723, -698.8156076667397, -698.8155599822854, -698.8156098553619, -698.8155714762584, -698.8155939827489, -698.8155736648468, -698.8155961713957, -698.8155937790234, -698.8155716795784, -698.8155959676424, -698.8155738681945, -698.8155681643882, -698.8155972958934, -698.8155703530045, -698.8155994845124, -698.8155816318812, -698.8155858677549, -698.8155817795464, -698.8155860154203, -698.815587208114, -698.8155802915223, -698.8155873557792, -698.8155804391876, -698.8155837389232, -698.8155837606874, 
  -698.8155838865886, -698.8155839083528, -698.81557515479, -698.8155923454515, -698.8155753024595, -698.8155924931126, -698.8155817704012, -698.8155857292172, -698.8155819180672}
 {-278.8292020225591, -278.8292055556396, -278.8292045966202, -278.8291994485179, -278.8291984895017, -278.8292050704574, -278.8292050817997, -278.8291989633373, -278.8291989746797, -278.8292049134811, -278.8292052387642, -278.8291988063572, -278.829199131648, -278.8291827069191, -278.8292274453526, -278.8291765997974, -278.8292213382342, -278.8292051786822, -278.8292049735748, -278.8291990715622, -278.8291988664548, -278.8292055350682, -278.8292046171919, -278.8291994279521, -278.8291985100678, -278.8292143792085, -278.8291957731512, -278.8292082720891, -278.8291896660305, -278.8292066385763, -278.8292035136945, -278.8292005314562, -278.8291974065744, -278.829218451762, -278.8291917019207, -278.829212344678, -278.8291855947647, -278.8291674059301, -278.8292427464793, -278.8291612988108, 
  -278.8292366393585, -278.8292310778092, -278.8291790753906, -278.8292249706898, -278.8291729682698, -278.8292106338578, -278.8291995183703, -278.8292045267386, -278.8291934112493, -278.8291577949785, -278.8292523582093, -278.8291516878587, -278.8292462510888, -278.8292086461094, -278.8292015064557, -278.8292025389888, -278.8291953993363, -278.829202496398, -278.8292025077404, -278.8292015373803, -278.8292015487226, -278.8292023394211, -278.8292026647057, -278.829201380401, -278.8292017056903, -278.8291801328616, -278.8292248712916, -278.8291791738386, -278.829223912279, -278.8292026046229, -278.8292023995155, -278.8292016456051, -278.8292014404977, -278.8292029610103, -278.8292020431312, -278.8292020019936, -278.8292010841122, -278.8292118051486, -278.8291931990925, -278.8292108461327, 
  -278.8291922400729, -278.829204064517, -278.8292009396352, -278.8292031054993, -278.8291999806174, -278.8292158777783, -278.829189127786, -278.8292149186455, -278.8291881688832, -278.8291648318679, -278.829240172423, -278.8291638728568, -278.8292392133985, -278.82922850375, -278.8291765013311, -278.8292275447327, -278.829175542313, -278.8292080597936, -278.8291969443159, -278.8292071007864, -278.8291959852875, -278.8291552209196, -278.8292497841495, -278.8291542619013, -278.8292488251323, -278.8292060720504, -278.8291989323962, -278.8292051130315, -278.8291979733795, -278.8292018542385, -278.8292021795256, -278.829201865581, -278.8292021908678, -278.8291796476776, -278.8292243861128, -278.8291796590199, -278.8292243974551, -278.8292021194415, -278.8292019143341, -278.8292021307838, 
  -278.8292019256765, -278.8292024758301, -278.8292015579485, -278.8292024871712, -278.8292015692921, -278.8292113199682, -278.8291927139101, -278.8292113313104}
 {-387.6714404694521, -387.6714446030901, -387.6714433190777, -387.671437619864, -387.6714363358624, -387.6714439480714, -387.6714439740941, -387.67143696485, -387.6714369908741, -387.6714437462377, -387.6714441759222, -387.6714367630184, -387.6714371927002, -387.6714306384598, -387.6714572837212, -387.6714236552358, -387.6714503005039, -387.671443746766, -387.6714441753994, -387.6714367635453, -387.6714371921788, -387.671436426922, -387.6714514952458, -387.6714294437305, -387.671444511996, -387.6714347488016, -387.6714531734031, -387.6714277655806, -387.6714461901828, -387.671439726354, -387.6714481958317, -387.6714327431343, -387.6714412126101, -387.671467824059, -387.6714201008483, -387.6714608409115, -387.6714131175546, -387.6714036644443, -387.6714842580166, -387.6713966812268, 
  -387.6714772747928, -387.671398437911, -387.6714894851971, -387.6713914546859, -387.6714825019809, -387.6714491330602, -387.6714387891547, -387.6714421497837, -387.6714318059899, -387.6714206051704, -387.6714673175631, -387.6714136219467, -387.6714603343456, -387.6714265063354, -387.6714614171086, -387.6714195231113, -387.6714544338914, -387.6714410984452, -387.6714411244684, -387.671439814438, -387.6714398404617, -387.6714408966134, -387.6714413262948, -387.6714396126047, -387.6714400422896, -387.6714277888361, -387.6714544340933, -387.6714265048214, -387.6714531500939, -387.6714408971402, -387.6714413257734, -387.6714396131331, -387.6714400417666, -387.6714335773104, -387.6714486456057, -387.6714322933042, -387.671447361598, -387.6714318991746, -387.6714503237783, -387.6714306151696, 
  -387.6714490397694, -387.6714368767284, -387.6714453462056, -387.6714355927218, -387.6714440621982, -387.6714649745453, -387.6714172511104, -387.6714636903871, -387.6714159672545, -387.6714008148137, -387.6714814083955, -387.6713995308193, -387.6714801243758, -387.6713955882837, -387.6714866355726, -387.671394304275, -387.6714853515674, -387.6714462833996, -387.6714359395636, -387.6714449994063, -387.6714346555429, -387.6714177555437, -387.6714644679382, -387.6714164715354, -387.6714631839325, -387.6714236567085, -387.6714585674837, -387.6714223727001, -387.6714572834781, -387.6714402415961, -387.6714406712792, -387.6714402676195, -387.6714406973027, -387.671427133816, -387.6714537790805, -387.6714271598392, -387.6714538051042, -387.6714402421237, -387.671440670757, -387.671440268147, 
  -387.6714406967805, -387.6714329222955, -387.6714479905877, -387.6714329483167, -387.6714480166135, -387.6714312441598, -387.6714496687603, -387.6714312701819}
 {-414.0096170422926, -414.0096415355184, -414.0096632227686, -414.0095708618385, -414.00959254907, -414.0096514777371, -414.0096532805482, -414.0095808040487, -414.0095826068583, -414.0096317704549, -414.009672987833, -414.0095610967612, -414.0096023141483, -414.0097467844159, -414.009557973931, -414.0096761107267, -414.009487300242, -414.0096548362093, -414.0096499220759, -414.0095841625202, -414.0095792483867, -414.0096576098354, -414.0096471484553, -414.0095869361472, -414.0095764747652, -414.009648086237, -414.009656672052, -414.009577412548, -414.0095859983627, -414.0096510972851, -414.0096536610057, -414.009580423596, -414.0095829873164, -414.0095739693725, -414.0097307890032, -414.0095032949455, -414.0096601160519, -414.0097073426129, -414.0095974156841, -414.0096366689202, 
  -414.0095267419984, -414.0096506337505, -414.009654124539, -414.009579960063, -414.0095834508482, -414.0092662380026, -414.0100385259013, -414.0091955649172, -414.0099678516084, -414.0082161714774, -414.0110886130449, -414.00814549779, -414.0110179393538, -414.0096498422855, -414.0096549159678, -414.0095791685967, -414.0095842422783, -414.0096052972678, -414.009607100078, -414.0096269845084, -414.0096287873192, -414.0095855899828, -414.0096268073655, -414.0096072772237, -414.0096484946063, -414.0097006039461, -414.0095117934615, -414.0097222911871, -414.0095334807021, -414.0096086557397, -414.0096037416063, -414.0096303429805, -414.0096254288471, -414.0096114293662, -414.009600967985, -414.009633116607, -414.009622655226, -414.0096019057673, -414.0096104915822, -414.0096235930081, 
  -414.009632178823, -414.0096049168156, -414.0096074805359, -414.0096266040563, -414.0096291677769, -414.0095277885449, -414.0096846088914, -414.0095494757637, -414.0097062961543, -414.009661162165, -414.0095512351927, -414.0096828493588, -414.0095729224806, -414.009604453282, -414.0096079440683, -414.0096261405222, -414.0096296313097, -414.0092200579452, -414.0099923450194, -414.0092417449652, -414.010014032481, -414.0081699910086, -414.0110424325743, -414.0081916782494, -414.011064119815, -414.0096036618161, -414.0096087354978, -414.0096253490567, -414.0096304227388, -414.0095955321973, -414.00963674958, -414.0095973350078, -414.0096385523902, -414.0097105461606, -414.0095217356757, -414.0097123489712, -414.0095235384861, -414.0096185979541, -414.0096136838206, -414.0096204007645, 
  -414.0096154866312, -414.009621371579, -414.0096109102012, -414.0096231743927, -414.0096127130083, -414.0096118479831, -414.0096204337953, -414.0096136507909}
 {-148.1431457251312, -148.1431199724367, -148.1431184860356, -148.1431729643935, -148.1431714779831, -148.1431193211205, -148.1431191373515, -148.1431723130738, -148.1431721293026, -148.1431205154123, -148.1431179430944, -148.143173507368, -148.1431709350431, -148.1431236178551, -148.1431148406469, -148.1431766098076, -148.1431678325988, -148.1431192513698, -148.1431192071022, -148.1431722433221, -148.1431721990543, -148.1431368433466, -148.1431016162514, -148.143189835246, -148.1431546082565, -148.1431202406172, -148.1431182178787, -148.1431732325701, -148.1431712098301, -148.1431265778096, -148.1431118807083, -148.1431795697606, -148.1431648726615, -148.1432369258888, -148.1430015350272, -148.1432899204486, -148.1430545243719, -148.1431142262434, -148.1431242325146, -148.1431672181361, 
  -148.1431772245263, -148.1430897215211, -148.1431487396801, -148.1431427135055, -148.1432017316, -148.1431082050659, -148.1431302538979, -148.1431611962072, -148.1431832466611, -148.14313761986, -148.1431008385728, -148.1431906118076, -148.1431538305295, -148.1431554608256, -148.1430829978777, -148.1432084527829, -148.1431359898247, -148.1431465602192, -148.1431463764491, -148.1431450738134, -148.1431448900433, -148.1431477545115, -148.1431451821915, -148.1431462681072, -148.1431436957843, -148.1431508569536, -148.1431420797446, -148.1431493705473, -148.1431405933394, -148.143146490468, -148.1431464462003, -148.1431450040623, -148.1431449597945, -148.143164082419, -148.1431288553754, -148.143162596012, -148.1431273689709, -148.1431474797168, -148.1431454569753, -148.1431459933088, 
  -148.1431439705718, -148.1431538169072, -148.1431391198069, -148.1431523305013, -148.1431376334012, -148.143264166295, -148.1430287728173, -148.1432626798807, -148.1430272864201, -148.1431414652734, -148.1431514716809, -148.1431399789444, -148.1431499851983, -148.143116960634, -148.1431759787634, -148.143115474231, -148.143174492355, -148.1431354437509, -148.1431574934092, -148.1431339573605, -148.1431560069881, -148.1431648589558, -148.1431280776732, -148.14316337255, -148.1431265912675, -148.1431826999254, -148.1431102369741, -148.1431812135213, -148.1431087505667, -148.1431471031942, -148.1431445308729, -148.1431469194242, -148.1431443471027, -148.1431502056354, -148.1431414284269, -148.1431500218653, -148.1431412446569, -148.1431458391501, -148.1431457948823, -148.14314565538, 
  -148.1431456111122, -148.1431634310986, -148.1431282040599, -148.1431632473322, -148.1431280202862, -148.1431468283979, -148.1431448056583, -148.1431466446275}
 {-406.2607204670959, -406.2607241021037, -406.2607237114205, -406.2607172227819, -406.2607168320958, -406.2607239606332, -406.2607238528907, -406.2607170813103, -406.2607169735672, -406.2607248986362, -406.2607229148886, -406.2607180193124, -406.260716035566, -406.260726339713, -406.2607214738253, -406.2607194603901, -406.260714594502, -406.2607237634801, -406.2607240500438, -406.2607168841569, -406.2607171707205, -406.2607278516285, -406.2607199619236, -406.2607209723054, -406.2607130826002, -406.2607262177231, -406.2607215958145, -406.2607193383999, -406.2607147164913, -406.2607254384583, -406.2607223751196, -406.2607185591349, -406.2607154957965, -406.2607039507123, -406.2607438641685, -406.2606970710656, -406.2607369851689, -406.2607335214782, -406.2607142922089, -406.2607266421631, 
  -406.2607074128776, -406.260760608503, -406.2606872069036, -406.2607537291764, -406.2606803275839, -406.2607423822341, -406.2607054312474, -406.2607355028875, -406.2606985519476, -406.2607397811844, -406.2607080323445, -406.2607329018614, -406.2607011530211, -406.2607127290043, -406.2607350869533, -406.2607058496812, -406.2607282076302, -406.2607207163099, -406.2607206085669, -406.2607203256252, -406.2607202178823, -406.2607216543126, -406.2607196705653, -406.2607212636276, -406.260719279881, -406.2607230953897, -406.2607182295015, -406.2607227047048, -406.2607178388171, -406.2607205191567, -406.2607208057202, -406.2607201284719, -406.2607204150355, -406.2607246073056, -406.2607167175994, -406.2607242166197, -406.2607163269159, -406.2607229733995, -406.2607183514912, -406.260722582715, 
  -406.2607179608063, -406.2607221941347, -406.2607191307962, -406.26072180345, -406.2607187401115, -406.2607007062196, -406.2607406200144, -406.26070031555, -406.2607402293144, -406.2607302771646, -406.2607110478755, -406.2607298864682, -406.2607106572026, -406.2607573641778, -406.2606839625819, -406.2607569734931, -406.2606835718972, -406.2607391378967, -406.2607021869378, -406.2607387472164, -406.2607017962486, -406.2607365368612, -406.2607047880208, -406.2607361461762, -406.2607043973363, -406.2607094846809, -406.2607318426298, -406.2607090939961, -406.2607314519452, -406.2607215128414, -406.2607195290943, -406.2607214050984, -406.2607194213514, -406.2607229539185, -406.2607180880305, -406.2607228461756, -406.2607179802877, -406.2607203776855, -406.2607206642491, -406.2607202699426, 
  -406.2607205565063, -406.2607244658345, -406.2607165761285, -406.2607243580906, -406.2607164683866, -406.2607228319285, -406.26071821002, -406.2607227241857}
 {-236.1161484575887, -236.1161540903449, -236.1161544960367, -236.1161424191667, -236.11614282488, -236.1161542826095, -236.1161543037693, -236.1161426114415, -236.1161426326025, -236.116151953146, -236.1161566332342, -236.1161402819844, -236.1161449620609, -236.116145920987, -236.1161626654439, -236.1161342498159, -236.1161509942802, -236.1161540668784, -236.1161545195004, -236.116142395711, -236.116142848333, -236.1161463779708, -236.1161622084445, -236.116134706828, -236.1161505372525, -236.116142202044, -236.116166384404, -236.1161305308759, -236.1161547132373, -236.1161512404386, -236.1161573459749, -236.1161395692716, -236.116145674807, -236.1161541218805, -236.1161544668968, -236.116142451179, -236.1161427952636, -236.116179445878, -236.1161291407778, -236.1161677746952, 
  -236.1161174696258, -236.1162157765186, -236.1160928116557, -236.1162041053579, -236.1160811404816, -236.116172127418, -236.116136458856, -236.1161604562345, -236.1161247877047, -236.1161525747306, -236.1161560118998, -236.1161409035597, -236.1161443407359, -236.1161461767407, -236.1161624109626, -236.1161345055709, -236.1161507397976, -236.1161482441588, -236.1161482653189, -236.116148649861, -236.1161486710217, -236.1161459146984, -236.1161505947806, -236.1161463204008, -236.1161510004833, -236.1161398825349, -236.1161566269947, -236.1161402882368, -236.1161570326981, -236.1161480284277, -236.1161484810498, -236.1161484341303, -236.1161488867524, -236.1161403395301, -236.116156169984, -236.1161407452376, -236.1161565756817, -236.116136163593, -236.1161603459538, -236.1161365692957, 
  -236.1161607516563, -236.1161452019881, -236.1161513075242, -236.1161456076909, -236.1161517132266, -236.1161480835883, -236.116148428288, -236.1161484894401, -236.1161488338413, -236.1161734074199, -236.1161231023346, -236.116173813122, -236.1161235080377, -236.1162097380702, -236.1160867732028, -236.116210143775, -236.1160871789033, -236.1161660889617, -236.1161304204111, -236.1161664946596, -236.1161308261184, -236.1161465362794, -236.1161499734498, -236.1161469419796, -236.1161503791548, -236.1161401382891, -236.116156372513, -236.1161405439912, -236.1161567782161, -236.116146106968, -236.1161507870503, -236.1161461281283, -236.1161508082108, -236.1161400748043, -236.1161568192648, -236.1161400959646, -236.1161568404253, -236.1161482206975, -236.1161486733196, -236.1161482418578, 
  -236.1161486944799, -236.1161405318032, -236.1161563622504, -236.1161405529617, -236.1161563834127, -236.1161363558627, -236.1161605382236, -236.1161363770232}
 {-76.18380680564758, -76.18381361409459, -76.18381095167488, -76.18380265967955, -76.1837999972591, -76.18381225007001, -76.18381231569643, -76.183801295654, -76.18380136128161, -76.18381251882712, -76.1838120469386, -76.18380156440234, -76.18380109253256, -76.18380312641581, -76.18382143945664, -76.18379217199926, -76.18381048504237, -76.18381200023182, -76.18381256553457, -76.18380104581638, -76.1838016111192, -76.18380320919333, -76.18382135668805, -76.18379225481002, -76.18381040224054, -76.1838077534407, -76.18381681241905, -76.18379679902558, -76.18380585800336, -76.18381426839275, -76.18381029744775, -76.18380331397813, -76.18379934303157, -76.18373412443498, -76.18389044583006, -76.18372316882954, -76.18387949260469, -76.18382466602331, -76.18379990025041, -76.18381371162212, 
  -76.18378894582077, -76.18374708037296, -76.18387748899218, -76.1837361259431, -76.18386653459124, -76.18382656101498, -76.18379800478273, -76.18381560647476, -76.18378705049214, -76.18378204773833, -76.18384251894352, -76.18377109332378, -76.18383156452728, -76.18382424500173, -76.18380032211188, -76.18381329058252, -76.18378936770029, -76.18380810404579, -76.18380816967255, -76.18380544162544, -76.18380550725273, -76.1838083728008, -76.1838079009168, -76.18380571037588, -76.18380523850156, -76.18379898039514, -76.18381729342919, -76.18379631796715, -76.18381463101703, -76.18380785420777, -76.18380841951053, -76.18380519178767, -76.18380575709045, -76.18379906318796, -76.1838172106453, -76.1837964007626, -76.18381454823049, -76.18380360741581, -76.18381266639585, -76.1838009449977, 
  -76.1838100039738, -76.18381012236901, -76.18380615142341, -76.1838074599491, -76.18380348900312, -76.18372997778437, -76.18388630043259, -76.18372731542739, -76.1838836379494, -76.1838205200273, -76.18379575419832, -76.18381785756537, -76.18379309182008, -76.18374293434313, -76.18387334297394, -76.18374027192016, -76.18387068055671, -76.1838224149143, -76.18379385883531, -76.18381975252268, -76.18379119638679, -76.18377790171524, -76.18383837291852, -76.18377523929406, -76.18383571049952, -76.1838200989759, -76.1837961760896, -76.18381743655556, -76.18379351366977, -76.18380700877333, -76.18380653689412, -76.18380707440032, -76.1838066025212, -76.18379761636623, -76.18381592940793, -76.183797681993, -76.18381599503524, -76.18380649018268, -76.18380705548544, -76.18380655580969, 
  -76.18380712111251, -76.18379769916173, -76.18381584662139, -76.18379776478579, -76.18381591225138, -76.18380224339234, -76.18381130236915, -76.18380230901813}
 {-311.4104058723679, -311.4104097193505, -311.4104100358767, -311.4104017088787, -311.4104020254126, -311.4104098763941, -311.4104098788318, -311.410401865926, -311.4104018683641, -311.410409149034, -311.4104106061905, -311.4104011385684, -311.4104025957203, -311.4104069897559, -311.4104127654928, -311.4103989792868, -311.410404755026, -311.4104097613692, -311.4104099938567, -311.4104017509014, -311.4104019833888, -311.4104106618937, -311.4104090932897, -311.4104026514381, -311.4104010828096, -311.4104077012322, -311.4104120540184, -311.4103996907642, -311.4104040435505, -311.4104015502198, -311.4104182050409, -311.4103935397522, -311.4104101945727, -311.4104189834217, -311.4104007736863, -311.410410973181, -311.4103927629912, -311.4104304109591, -311.4103893444739, -311.4104224004872, 
  -311.4103813340099, -311.4104114577439, -311.4104082990272, -311.4104034472789, -311.4104002885564, -311.4104214268071, -311.4103983283547, -311.4104134163309, -311.410390317895, -311.4104089986005, -311.4104107567868, -311.4104009881303, -311.4104027463211, -311.4103455674155, -311.4104741917379, -311.410337556946, -311.4104661812716, -311.4104057128845, -311.4104057153224, -311.4104060294145, -311.4104060318526, -311.4104049855263, -311.4104064426792, -311.4104053020551, -311.4104067592107, -311.4104028262458, -311.4104086019838, -311.4104031427758, -311.410408918514, -311.4104055978598, -311.4104058303472, -311.4104059143899, -311.4104061468772, -311.4104064983906, -311.4104049297739, -311.4104068149202, -311.4104052463045, -311.4104035377225, -311.4104078905092, -311.4104038542529, 
  -311.4104082070388, -311.4103973867103, -311.4104140415313, -311.4103977032407, -311.4104143580613, -311.4104148199845, -311.4103966101045, -311.4104151365971, -311.4103969265521, -311.4104262474464, -311.4103851809676, -311.410426563979, -311.4103854974952, -311.4104072942353, -311.4104041355169, -311.4104076107666, -311.4104044520457, -311.4104172632957, -311.410394164847, -311.4104175798213, -311.4103944813817, -311.4104048350906, -311.4104065932777, -311.4104051516192, -311.4104069098092, -311.4103414039054, -311.4104700282291, -311.4103417204352, -311.4104703447594, -311.4104051425711, -311.4104065997252, -311.4104051450089, -311.4104066021634, -311.4104029832912, -311.4104087590293, -311.4104029857292, -311.4104087614673, -311.4104057549052, -311.4104059873926, -311.4104057573432, 
  -311.4104059898305, -311.4104066554369, -311.4104050868185, -311.4104066578725, -311.4104050892586, -311.4104036947682, -311.4104080475544, -311.410403697206}
 {-578.8497538937328, -578.8497478769695, -578.8497464991528, -578.8497612883805, -578.8497599105575, -578.849747285097, -578.8497470910248, -578.8497606965056, -578.849760502432, -578.849747921072, -578.8497464550644, -578.849761332461, -578.8497598664911, -578.8497528254224, -578.8497415507349, -578.8497662368313, -578.8497549621418, -578.8497472137067, -578.8497471624152, -578.8497606251146, -578.8497605738231, -578.8497544496916, -578.8497399268961, -578.8497678610512, -578.8497533383524, -578.8497444471453, -578.8497499290058, -578.849757858554, -578.8497633404131, -578.8497537931983, -578.8497405829849, -578.8497672046058, -578.8497539943931, -578.8496652965852, -578.8498290820338, -578.8496787064041, -578.8498424950309, -578.8497594404911, -578.8497349359547, -578.8497728519271, 
  -578.8497483473343, -578.849771430593, -578.849722948503, -578.8497848419714, -578.8497363599407, -578.849749511044, -578.8497448652546, -578.849762922121, -578.8497582769935, -578.849760309766, -578.849734066412, -578.8497737211795, -578.8497474778142, -578.8497933927976, -578.8497009830929, -578.8498068042118, -578.8497143944946, -578.8497546796792, -578.8497544856064, -578.8497533018593, -578.8497531077866, -578.8497553156446, -578.8497538496555, -578.8497539378243, -578.8497524718363, -578.8497602200058, -578.8497489453154, -578.8497588421842, -578.8497475674975, -578.8497546082885, -578.8497545569969, -578.8497532304689, -578.8497531791772, -578.8497618442491, -578.8497473215026, -578.8497604664301, -578.8497459436822, -578.8497518417278, -578.8497573235873, -578.8497504639075, 
  -578.849755945768, -578.84976118778, -578.8497479775669, -578.8497598099603, -578.8497465997473, -578.8496726903552, -578.8498364774279, -578.8496713125705, -578.8498350995731, -578.8497668351138, -578.8497423304959, -578.8497654572408, -578.8497409527293, -578.849778825161, -578.8497303430989, -578.8497774473394, -578.8497289652812, -578.8497569054529, -578.8497522600094, -578.8497555276482, -578.8497508821748, -578.8497677043511, -578.8497414609909, -578.8497663265308, -578.8497400831716, -578.8498007873828, -578.8497083776718, -578.8497994095633, -578.8497069998519, -578.8497547237709, -578.8497532577821, -578.8497545296979, -578.8497530637092, -578.8497596281312, -578.8497483534426, -578.8497594340583, -578.84974815937, -578.8497540164149, -578.8497539651233, -578.8497538223423, 
  -578.8497537710505, -578.8497612523757, -578.8497467296288, -578.8497610583031, -578.8497465355556, -578.8497512498539, -578.8497567317135, -578.8497510557811}
 {-266.6594213815158, -266.6594225962972, -266.6594182803099, -266.6594244827628, -266.6594201667477, -266.6594205252386, -266.6594203513653, -266.6594224116909, -266.6594222378165, -266.6594245071482, -266.6594163694582, -266.6594263935854, -266.6594182559245, -266.6594059179073, -266.6594349587609, -266.6594078043645, -266.6594368452071, -266.6594202715014, -266.6594206051026, -266.6594221579531, -266.6594224915543, -266.6594254319802, -266.6594154447705, -266.6594273184162, -266.6594173312378, -266.6594157411668, -266.6594251355607, -266.6594176276194, -266.6594270220114, -266.6594246250471, -266.6594162515927, -266.6594265114987, -266.6594181380446, -266.6594757827702, -266.6593650954823, -266.6594776701128, -266.6593669810433, -266.659391877447, -266.6594489993492, 
  -266.6593937638849, -266.6594508858148, -266.6594002007752, -266.6594406775415, -266.6594020872368, -266.6594425639833, -266.6594238895912, -266.6594169870955, -266.6594257759018, -266.6594188736884, -266.6594085241097, -266.6594323528587, -266.6594104105665, -266.6594342393052, -266.659447855515, -266.659393020774, -266.6594497419685, -266.6593949072239, -266.6594236264551, -266.6594234525809, -266.6594193104536, -266.6594191365801, -266.6594276083561, -266.6594194706825, -266.6594232923568, -266.6594151546795, -266.6594090191308, -266.6594380599695, -266.6594047031202, -266.6594337439776, -266.6594233727174, -266.6594237063186, -266.6594190567162, -266.6594193903175, -266.6594285331878, -266.659418545995, -266.6594242171878, -266.6594142299926, -266.6594188423834, -266.6594282367762, 
  -266.6594145263821, -266.6594239207752, -266.659427726263, -266.6594193528089, -266.6594234102621, -266.6594150368075, -266.6594788845022, -266.6593681961826, -266.6594745683601, -266.6593638803223, -266.6593949786376, -266.6594521005907, -266.6593906626734, -266.6594477845525, -266.6594033019964, -266.6594437787523, -266.6593989859948, -266.6594394627516, -266.6594269907109, -266.659420088408, -266.6594226747614, -266.6594157723551, -266.659411625329, -266.6594354540715, -266.6594073093265, -266.6594311380717, -266.6594509567316, -266.6593961219895, -266.6594466407311, -266.6593918059876, -266.6594255372917, -266.6594173996164, -266.6594253634179, -266.6594172257424, -266.659406948061, -266.6594359889088, -266.6594067741869, -266.6594358150352, -266.6594213016522, -266.6594216352534, 
  -266.6594211277782, -266.6594214613795, -266.659426462123, -266.6594164749293, -266.6594262882494, -266.6594163010552, -266.6594167713187, -266.6594261657104, -266.6594165974435}
 {-358.2400122921283, -358.2400149003849, -358.2400147975648, -358.2400097867021, -358.2400096838824, -358.2400148438092, -358.2400148541403, -358.2400097301265, -358.2400097404579, -358.2400149529424, -358.240014745008, -358.2400098392593, -358.240009631326, -358.2400174923638, -358.2400122055972, -358.2400123786813, -358.2400070919147, -358.2400148688582, -358.2400148290913, -358.2400097551756, -358.2400097154088, -358.2400134745386, -358.2400162233728, -358.2400083608628, -358.2400111096836, -358.2400155224312, -358.240014175508, -358.2400104087485, -358.2400090618255, -358.2400095285919, -358.2400201693657, -358.2400044149094, -358.240015055683, -358.2400148401151, -358.2400148588159, -358.2400097263805, -358.2400097451855, -358.2400184754367, -358.2400112226254, -358.2400133617549, 
  -358.2400061089422, -358.2399651268634, -358.240064571992, -358.2399600131802, -358.2400594583102, -358.2400208447928, -358.2400088531212, -358.2400157311098, -358.2400037394392, -358.2400208004337, -358.2400088974806, -358.240015686751, -358.2400037837981, -358.2399881578628, -358.2400415417943, -358.2399830441795, -358.2400364281124, -358.2400123383727, -358.240012348704, -358.2400122355528, -358.240012245884, -358.2400124475061, -358.2400122395716, -358.2400123446855, -358.2400121367524, -358.2400149869275, -358.2400097001607, -358.2400148841073, -358.2400095973411, -358.2400123634218, -358.2400123236549, -358.2400122606019, -358.240012220835, -358.2400109691058, -358.2400137179329, -358.2400108662855, -358.2400136151133, -358.2400130169945, -358.2400116700718, -358.240012914175, 
  -358.2400115672514, -358.2400070231556, -358.2400176639292, -358.2400069203356, -358.2400175611093, -358.240012334651, -358.2400123534073, -358.2400122318344, -358.240012250584, -358.2400159700015, -358.2400087171878, -358.24001586718, -358.2400086143696, -358.2399626214267, -358.240062066556, -358.2399625186066, -358.2400619637362, -358.2400183393557, -358.2400063476855, -358.2400182365366, -358.2400062448647, -358.2400182949975, -358.2400063920439, -358.2400181921769, -358.2400062892246, -358.2399856524261, -358.2400390363581, -358.2399855496059, -358.2400389335384, -358.2400123909301, -358.2400121829962, -358.2400124012613, -358.2400121933274, -358.2400149303517, -358.2400096435852, -358.240014940683, -358.2400096539164, -358.2400123068461, -358.2400122670792, -358.2400123171774, 
  -358.2400122774105, -358.2400109125304, -358.2400136613569, -358.2400109228607, -358.2400136716891, -358.2400129604191, -358.2400116134958, -358.2400129707502}
 {-28.15263595998535, -28.15264134499158, -28.15264143144535, -28.15263048863772, -28.15263057508097, -28.15264140570444, -28.15264137073224, -28.15263054934429, -28.15263051437414, -28.15264334430163, -28.15263943214954, -28.1526324879244, -28.15262857580852, -28.15264321895929, -28.15263955748798, -28.15263236260305, -28.15262870112598, -28.15264142582213, -28.15264135061455, -28.1526305694629, -28.15263049425554, -28.15263306907557, -28.15264970757788, -28.1526222127665, -28.15263885116869, -28.15264249266875, -28.15264028377433, -28.15263163630862, -28.15262942741621, -28.15264295083666, -28.15263982561472, -28.15263209447863, -28.15262896925451, -28.15263220545578, -28.15265057194335, -28.15262134955909, -28.15263971512182, -28.15263568033579, -28.15264709621174, -28.15262482395447, 
  -28.15263623987482, -28.15265806180327, -28.15262471553515, -28.15264720545991, -28.15261385916025, -28.1526468423749, -28.15263593403614, -28.15263598608325, -28.15262507760954, -28.15264586425573, -28.15263691217428, -28.1526350079001, -28.15262605581167, -28.15265184255895, -28.15263093387046, -28.1526409861952, -28.15262007751597, -28.15263593424681, -28.15263589927566, -28.15263602069534, -28.15263598572414, -28.1526378728363, -28.15263396070065, -28.15263795928314, -28.15263404715083, -28.15263774750352, -28.15263408602954, -28.15263783395222, -28.15263417247784, -28.15263595436497, -28.1526358791575, -28.15263604081347, -28.15263596560601, -28.15262759764368, -28.15264423609555, -28.1526276840918, -28.15264432254444, -28.1526370212113, -28.15263481231757, -28.15263710765949, 
  -28.15263489876639, -28.15263747938012, -28.15263435415706, -28.15263756582859, -28.15263444060559, -28.15262673423917, -28.15264510024576, -28.15262682066912, -28.15264518671282, -28.15263020887001, -28.15264162476331, -28.15263029531367, -28.15264171121666, -28.15265259035441, -28.15261924406979, -28.15265267680218, -28.15261933051903, -28.15264137095224, -28.15263046254459, -28.15264145739933, -28.1526305489945, -28.1526403928008, -28.152631440715, -28.15264047924844, -28.15263152716436, -28.15264637109936, -28.15262546241583, -28.15264645754819, -28.15262554886401, -28.15263793354522, -28.15263402141116, -28.15263789857396, -28.15263398644007, -28.15263780821332, -28.15263414673916, -28.15263777324217, -28.15263411176796, -28.15263601507468, -28.15263593986721, -28.15263598010351, 
  -28.15263590489604, -28.15262765835424, -28.1526442968044, -28.15262762338098, -28.15264426183532, -28.15263708192085, -28.15263487302744, -28.15263704694969}
 {-555.954866272372, -555.9548540465886, -555.954842847031, -555.9548896978017, -555.9548784981867, -555.9548491300869, -555.9548477635295, -555.9548847812756, -555.9548834147097, -555.9548611314377, -555.954835762196, -555.9548967825516, -555.9548714134509, -555.9548286441733, -555.9548682495332, -555.9548642953712, -555.954903900704, -555.9548476140124, -555.9548492796042, -555.9548832651967, -555.9548849307888, -555.9549050284838, -555.9547918654287, -555.9549406794359, -555.9548275168457, -555.9548203737417, -555.9548765199649, -555.9548560249303, -555.9549121711454, -555.9548309298905, -555.9548659637334, -555.9548665810686, -555.9549016149243, -555.9546558712414, -555.9550410264107, -555.9546915195249, -555.9550766804962, -555.9549098247184, -555.9547870693988, -555.9549454759297, 
  -555.9548227205562, -555.9549959038933, -555.9547009925391, -555.9550315550499, -555.9547366437514, -555.9548268346619, -555.9548700596316, -555.9548624851292, -555.9549057115332, -555.9548338626809, -555.9548630315692, -555.9548695138906, -555.9548986827284, -555.9547763560107, -555.9549205423607, -555.9548120072231, -555.9549561935171, -555.954872555448, -555.9548711888851, -555.9548613558609, -555.9548599893, -555.9548845567575, -555.9548591875928, -555.9548733571778, -555.9548479880002, -555.9548520695541, -555.9548916748688, -555.9548408699364, -555.9548804753144, -555.9548710393708, -555.9548727049624, -555.9548598397844, -555.9548615053765, -555.9549284537207, -555.9548152909089, -555.9549172541453, -555.954804091312, -555.9548437991087, -555.9548999453146, -555.9548325995093, 
  -555.9548887457419, -555.9548543552448, -555.9548893890955, -555.9548431556602, -555.9548781895082, -555.954679295029, -555.9550644533399, -555.9546680956831, -555.9550532535132, -555.9549332501438, -555.9548104946901, -555.9549220504505, -555.954799295211, -555.9550193292402, -555.9547244179091, -555.9550081296491, -555.9547132183274, -555.9548502595964, -555.9548934854138, -555.9548390601408, -555.954882285697, -555.9548572880539, -555.954886456913, -555.9548460884635, -555.9548752573306, -555.9547997813772, -555.9549439677108, -555.9547885818025, -555.9549327681131, -555.9548796402466, -555.9548542710763, -555.9548782736857, -555.9548529045136, -555.9548471530251, -555.9548867583703, -555.9548457864624, -555.9548853918097, -555.9548661228571, -555.9548677884488, -555.9548647562951, 
  -555.9548664218871, -555.9549235372094, -555.9548103743928, -555.9549221706535, -555.9548090078249, -555.9548388825911, -555.9548950288049, -555.9548375160238}
 {-15.58629718726577, -15.58630338718452, -15.58630295971309, -15.58629141485537, -15.58629098738744, -15.5863031926292, -15.58630315426761, -15.58629122030176, -15.58629118194025, -15.58630353019651, -15.58630281670273, -15.58629155786458, -15.58629084437986, -15.58630770204928, -15.58629864488436, -15.58629572972039, -15.58628667255844, -15.58630315597707, -15.58630319091975, -15.58629118364965, -15.58629121859236, -15.58630410884797, -15.58630223802274, -15.58629213651961, -15.58629026569629, -15.58630125754509, -15.58630508935217, -15.58628928521798, -15.58629311702448, -15.58630016886628, -15.58630617806264, -15.58628819653886, -15.58629420573525, -15.58631327366287, -15.58629307608543, -15.5863013013904, -15.58628110370312, -15.58629221572354, -15.586314131478, -15.58628024339605, 
  -15.58630215915069, -15.58627310038301, -15.58633324839917, -15.58626112805628, -15.5863212760711, -15.58631502180109, -15.58629132502727, -15.58630304947353, -15.58627935270003, -15.58631250375583, -15.58629384312022, -15.58630053142763, -15.58628187079362, -15.58628794855292, -15.58631839999513, -15.58627597622596, -15.58630642766729, -15.58629742018184, -15.58629738182021, -15.58629699271209, -15.5862969543506, -15.5862977577483, -15.58629704425618, -15.58629733027575, -15.58629661678937, -15.58630192960234, -15.58629287243653, -15.58630150213028, -15.58629244496923, -15.58629738352968, -15.58629741847238, -15.58629695606, -15.5862969910027, -15.58629833639996, -15.58629646557599, -15.58629790893058, -15.586296038106, -15.58629548509805, -15.58629931690445, -15.58629505762797, 
  -15.58629888943517, -15.58629439641888, -15.58630040561527, -15.58629396894922, -15.58629997814557, -15.58630750126294, -15.5862873035906, -15.58630707375327, -15.58628687616091, -15.58628644327425, -15.58630835903252, -15.58628601580828, -15.58630793155912, -15.58626732793578, -15.58632747595163, -15.58626690046646, -15.58632704848158, -15.58630924935163, -15.58628555258197, -15.58630882188595, -15.58628512510828, -15.58630673130946, -15.58628807067182, -15.58630630383696, -15.58628764320497, -15.5862821761055, -15.58631262754778, -15.58628174863633, -15.58631220007759, -15.58629756319244, -15.58629684970312, -15.58629752483081, -15.58629681134164, -15.58630173504673, -15.58629267788322, -15.5863016966851, -15.58629263952173, -15.58629718897522, -15.58629722391792, -15.58629715061366, 
  -15.58629718555636, -15.58629814184707, -15.58629627101995, -15.58629810348267, -15.58629623266123, -15.58629529054355, -15.58629912235004, -15.58629525218169}
 {-127.8554102127064, -127.855401383892, -127.8553997998457, -127.8554206256302, -127.8554190415672, -127.8554006245969, -127.8554005591407, -127.855419866327, -127.8554198008702, -127.8554043340952, -127.8553968496537, -127.8554235758173, -127.8554160913912, -127.8553992618409, -127.8554019219068, -127.8554185035726, -127.8554211636348, -127.8554005658972, -127.8554006178404, -127.855419807627, -127.8554198595703, -127.8554005649693, -127.8554006187685, -127.8554198067038, -127.8554198604937, -127.8554005625277, -127.85540062121, -127.8554198042568, -127.8554198629405, -127.8554005894672, -127.8554005942704, -127.8554198311967, -127.8554198360006, -127.8554385896048, -127.8553625947592, -127.8554578321397, -127.855381835684, -127.8553892169215, -127.8554119668887, -127.8554084586322, 
  -127.8554312086376, -127.8554006270254, -127.8554005567123, -127.8554198687582, -127.8554197984393, -127.8553942168473, -127.8554069670787, -127.8554134582962, -127.8554262090895, -127.8553990614541, -127.8554021223841, -127.8554183031859, -127.855421364112, -127.8554005979882, -127.8554005857495, -127.8554198397181, -127.8554198274793, -127.8554110374621, -127.8554109720056, -127.8554094534074, -127.855409387951, -127.855414746956, -127.8554072625228, -127.855413162902, -127.8554056784676, -127.8554096747077, -127.85541233477, -127.8554080906513, -127.8554107507172, -127.8554109787622, -127.8554110307054, -127.8554093947075, -127.8554094466508, -127.8554109778367, -127.8554110316311, -127.8554093937819, -127.8554094475767, -127.8554109753923, -127.8554110340753, -127.8554093913377, 
  -127.8554094500206, -127.855411002332, -127.8554110071356, -127.8554094182774, -127.8554094230809, -127.855449002885, -127.855373007209, -127.855447418805, -127.8553714231797, -127.8553996297641, -127.855422379776, -127.8553980457351, -127.8554207956957, -127.8554110398921, -127.8554109695757, -127.855409455837, -127.8554093855215, -127.8554046295627, -127.8554173800933, -127.8554030455263, -127.8554157960204, -127.8554094743199, -127.8554125352484, -127.8554078902657, -127.8554109511933, -127.8554110108532, -127.8554109986145, -127.8554094267986, -127.8554094145599, -127.8554139876572, -127.8554065032234, -127.8554139222007, -127.8554064377668, -127.8554089154077, -127.8554115754717, -127.8554088499512, -127.8554115100153, -127.855410219463, -127.8554102714063, -127.8554101540065, 
  -127.8554102059498, -127.8554102185354, -127.8554102723341, -127.855410153083, -127.8554102068735, -127.8554102160935, -127.8554102747758, -127.8554101506364}
 {-439.6850395235814, -439.6850419544015, -439.6850424862777, -439.6850365609164, -439.6850370928003, -439.6850422401691, -439.6850422005095, -439.685036846688, -439.6850368070281, -439.6850416270808, -439.6850428136024, -439.6850362336016, -439.6850374201189, -439.6850466308824, -439.6850378098305, -439.6850412373997, -439.6850324163507, -439.6850422479988, -439.68504219268, -439.6850368545175, -439.6850367991987, -439.6850460444425, -439.6850383962797, -439.6850406509442, -439.6850330028153, -439.6850436012511, -439.6850408394341, -439.6850382077701, -439.6850354459524, -439.685044011943, -439.685040428752, -439.6850386184614, -439.6850350352711, -439.6849952450593, -439.6850891982891, -439.6849898508835, -439.6850838055022, -439.6850327010099, -439.6850517399581, -439.6850273075338, 
  -439.6850463464717, -439.6850623494156, -439.6850220922028, -439.6850569559295, -439.6850166987262, -439.685049112953, -439.6850353277465, -439.6850437193958, -439.6850299343411, -439.6850521922121, -439.6850322484344, -439.6850467987278, -439.6850268549562, -439.6850507622971, -439.6850336784625, -439.6850453688179, -439.685028284979, -439.6850392774716, -439.6850392378119, -439.6850398093517, -439.685039769692, -439.6850386643853, -439.6850398509029, -439.6850391962634, -439.6850403827847, -439.6850436681835, -439.6850348471342, -439.6850442000647, -439.6850353790131, -439.6850392853011, -439.6850392299823, -439.6850398171812, -439.6850397618625, -439.6850430817371, -439.68503543359, -439.6850436136158, -439.6850359654713, -439.6850406385542, -439.6850378767359, -439.6850411704333, 
  -439.6850384086169, -439.6850410492453, -439.6850374660547, -439.6850415811253, -439.6850379979347, -439.6849922820405, -439.6850862359127, -439.6849928138685, -439.6850867678447, -439.6850297383237, -439.6850487772491, -439.6850302701862, -439.6850493091468, -439.6850593867164, -439.6850191295068, -439.6850599185949, -439.6850196613885, -439.6850461502217, -439.6850323650826, -439.6850466820933, -439.6850328969712, -439.685049229514, -439.6850292857374, -439.6850497613921, -439.6850298176194, -439.6850477996002, -439.6850307157643, -439.6850483314811, -439.6850312476433, -439.6850389501539, -439.6850401366733, -439.6850389104942, -439.6850400970136, -439.6850439539536, -439.6850351329033, -439.685043914294, -439.6850350932435, -439.6850395710707, -439.685039515752, -439.6850395314109, 
  -439.6850394760923, -439.6850433675065, -439.6850357193596, -439.6850433278457, -439.685035679701, -439.6850409243232, -439.6850381625059, -439.6850408846636}
 {-517.6131997807785, -517.6132009777112, -517.6132014288538, -517.613198132705, -517.6131985838701, -517.6132012098037, -517.6132011967572, -517.613198364809, -517.6131983517619, -517.6131990761064, -517.6132033304556, -517.6131962311119, -517.6132004854603, -517.6131824628479, -517.6132199438355, -517.6131796178526, -517.6132170988408, -517.613201332304, -517.6132010742569, -517.613198487309, -517.6131982292619, -517.6132080861434, -517.6131943204731, -517.6132052411473, -517.6131914754793, -517.6132145845908, -517.6131878221689, -517.613211739596, -517.6131849771739, -517.6132017733668, -517.6132006332047, -517.6131989283719, -517.6131977882098, -517.613200811413, -517.6132015956824, -517.6131979662591, -517.6131987508464, -517.6131856431647, -517.6132167634607, -517.6131827981773, 
  -517.6132139184582, -517.6132260918162, -517.6131763155103, -517.6132232468182, -517.6131734705185, -517.6132132322031, -517.613189174286, -517.6132103872006, -517.6131863292986, -517.6131929330859, -517.6132094737722, -517.6131900880907, -517.6132066287773, -517.6132183705687, -517.6131840361533, -517.6132155255738, -517.6131811911582, -517.6131995617269, -517.6131995486804, -517.6132000128811, -517.6131999998339, -517.6131974280297, -517.6132016823788, -517.6131978791839, -517.6132021335325, -517.613180814771, -517.6132182957588, -517.6131812659248, -517.6132187469128, -517.6131996842271, -517.6131994261802, -517.613200135381, -517.6131998773341, -517.6132064380665, -517.6131926723965, -517.6132068892197, -517.6131931235512, -517.6132129365141, -517.6131861740921, -517.613213387668, 
  -517.613186625246, -517.61320012529, -517.6131989851278, -517.6132005764439, -517.6131994362818, -517.6131991633035, -517.6131999476384, -517.613199614364, -517.6132003988857, -517.6131839950898, -517.613215115382, -517.6131844462475, -517.6132155665321, -517.6132244437389, -517.613174667434, -517.6132248948907, -517.61317511859, -517.6132115841252, -517.6131875262103, -517.6132120352738, -517.6131879773694, -517.613191285009, -517.6132078256954, -517.6131917361628, -517.6132082768494, -517.6132167224919, -517.6131823880764, -517.613217173646, -517.6131828392304, -517.6131976601281, -517.6132019144768, -517.6131976470812, -517.6132019014301, -517.6131810468693, -517.6132185278571, -517.6131810338225, -517.6132185148104, -517.6131999163253, -517.6131996582784, -517.6131999032785, 
  -517.6131996452316, -517.6132066701643, -517.6131929044951, -517.6132066571175, -517.6131928914483, -517.6132131686123, -517.6131864061904, -517.6132131555655}
 {-348.3854691922163, -348.3854754560035, -348.385474932163, -348.385463452306, -348.3854629284755, -348.3854751829632, -348.3854752051992, -348.3854631792707, -348.385463201507, -348.3854741458817, -348.3854762422706, -348.3854621421898, -348.3854642385777, -348.3854510748621, -348.3854993133526, -348.385439071168, -348.3854873096619, -348.385475330792, -348.3854750573703, -348.3854633270996, -348.3854630536779, -348.3854774186265, -348.3854729695692, -348.3854654149388, -348.3854609658719, -348.3854968492056, -348.3854535391095, -348.3854848455136, -348.3854415354166, -348.3854746299403, -348.3854757582601, -348.385462626248, -348.3854637545677, -348.3854733102979, -348.385477080803, -348.385461306407, -348.385465077309, -348.3854288187756, -348.3855215697031, -348.3854168150858, 
  -348.385509566008, -348.3855116486758, -348.3854387415235, -348.3854996449803, -348.3854267378342, -348.3854926953036, -348.3854576927598, -348.3854806916072, -348.3854456890713, -348.3854351470477, -348.3855152420625, -348.3854231433527, -348.3855032383728, -348.3854414513251, -348.3855089398368, -348.385429447632, -348.3854969361452, -348.3854694430179, -348.3854694652541, -348.3854689191824, -348.3854689414185, -348.3854684059382, -348.3854705023236, -348.3854678820997, -348.3854699784911, -348.3854453349175, -348.3854935734066, -348.3854448110789, -348.3854930495742, -348.3854695908468, -348.3854693174251, -348.3854690670113, -348.3854687935896, -348.3854716786829, -348.3854672296221, -348.3854711548487, -348.3854667057853, -348.3854911092597, -348.3854477991648, -348.3854905854257, 
  -348.3854472753277, -348.3854688899951, -348.3854700183148, -348.3854683661595, -348.3854694944792, -348.3854675703348, -348.3854713408756, -348.3854670463366, -348.3854708172029, -348.3854230788301, -348.385515829758, -348.3854225549977, -348.3855153059194, -348.3855059087298, -348.385433001579, -348.3855053848927, -348.3854324777449, -348.3854869553538, -348.3854519528191, -348.3854864315234, -348.3854514289784, -348.3854294071022, -348.3855095021175, -348.3854288832645, -348.385508978284, -348.38543571138, -348.3855031998915, -348.3854351875434, -348.385502676057, -348.3854681328989, -348.3854702292874, -348.3854681551351, -348.3854702515234, -348.3854450618781, -348.3854933003703, -348.3854450841143, -348.3854933226065, -348.385469317809, -348.3854690443873, -348.3854693400452, 
  -348.3854690666234, -348.3854714056468, -348.3854669565825, -348.3854714278807, -348.3854669788209, -348.3854908362228, -348.3854475261261, -348.3854908584588}
 {-192.2704209873889, -192.2704205700116, -192.27042048864, -192.2704214861565, -192.2704214047838, -192.2704205517421, -192.2704205069095, -192.2704214678868, -192.2704214230535, -192.270421912995, -192.2704191456597, -192.2704228291374, -192.270420061806, -192.2704221245732, -192.2704189340829, -192.2704230407176, -192.2704198502272, -192.2704204904503, -192.2704205682013, -192.2704214065947, -192.2704214843456, -192.270425301074, -192.2704157576852, -192.2704262172126, -192.2704166738353, -192.2704203104709, -192.2704207481834, -192.2704212266155, -192.2704216643273, -192.2704221221895, -192.2704189364736, -192.2704230383338, -192.2704198526181, -192.2704348355384, -192.270406223658, -192.2704357520141, -192.2704071394708, -192.2704144195362, -192.2704266391803, -192.2704153356704, 
  -192.2704275553348, -192.2704078603822, -192.2704331989533, -192.2704087765311, -192.2704341150931, -192.2704249173185, -192.2704161413266, -192.2704258334099, -192.2704170575239, -192.2704229285124, -192.2704181301695, -192.2704238446574, -192.2704190463131, -192.2704324591171, -192.2704085994596, -192.2704333752619, -192.2704095156034, -192.2704210504915, -192.2704210056585, -192.2704209691193, -192.2704209242863, -192.2704224117433, -192.2704196444098, -192.2704223303709, -192.2704195630379, -192.2704226233225, -192.270419432832, -192.2704225419502, -192.2704193514599, -192.2704209891996, -192.2704210669504, -192.2704209078274, -192.2704209855783, -192.2704257998207, -192.2704162564369, -192.2704257184478, -192.2704161750655, -192.2704208092204, -192.2704212469323, 
  -192.2704207278479, -192.2704211655603, -192.2704226209387, -192.2704194352229, -192.2704225395665, -192.2704193538507, -192.2704353344541, -192.2704067222406, -192.2704352530803, -192.27040664087, -192.270414918276, -192.2704271379389, -192.2704148369123, -192.2704270565581, -192.2704083591335, -192.2704336977004, -192.2704082777617, -192.2704336163279, -192.2704254160409, -192.2704166401027, -192.2704253346694, -192.2704165587297, -192.2704234272621, -192.2704186289182, -192.2704233458897, -192.2704185475462, -192.2704329578664, -192.2704090982086, -192.2704328764945, -192.2704090168362, -192.2704223934736, -192.2704196261403, -192.2704223486406, -192.2704195813073, -192.2704226050528, -192.2704194145624, -192.2704225602198, -192.2704193697295, -192.2704209709299, -192.2704210486808, 
  -192.2704209260969, -192.2704210038479, -192.2704257815507, -192.2704162381677, -192.2704257367177, -192.2704161933347, -192.2704207909506, -192.2704212286628, -192.2704207461177}
 {-280.5774880408591, -280.577488880641, -280.5774894550405, -280.5774866267053, -280.5774872011091, -280.5774890342486, -280.5774893014327, -280.5774867803135, -280.5774870475008, -280.5774890575201, -280.5774892781656, -280.5774868035856, -280.577487024233, -280.5774934930946, -280.5774848426046, -280.5774912391609, -280.5774825886712, -280.5774891906787, -280.5774891450026, -280.5774869367451, -280.5774868910691, -280.5774592343604, -280.5775191014226, -280.5774569804458, -280.5775168474702, -280.5774819618878, -280.5774963737837, -280.5774797079533, -280.577494119851, -280.5774630232135, -280.5775153125833, -280.5774607692803, -280.5775130586494, -280.5775128278695, -280.5774655094287, -280.5775105747028, -280.5774632547283, -280.5774838800016, -280.577494455874, -280.5774816260453, 
  -280.5774922019633, -280.5776053797976, -280.5773729581097, -280.5776031258736, -280.5773707041666, -280.5775137618249, -280.5774645737756, -280.5775115077938, -280.5774623199397, -280.5774875627892, -280.5774907732859, -280.5774853088556, -280.5774885193525, -280.5772638164361, -280.5777145320952, -280.5772615625008, -280.5777122781634, -280.5774876200656, -280.5774878872513, -280.5774881944672, -280.5774884616529, -280.577487643338, -280.5774878639834, -280.5774882177386, -280.577488438386, -280.5774920789121, -280.5774834284225, -280.5774926533139, -280.5774840028239, -280.5774877764965, -280.5774877308204, -280.5774883508981, -280.577488305222, -280.5774578201896, -280.577517687229, -280.5774583945874, -280.5775182616345, -280.5774805477051, -280.577494959602, -280.5774811221069, 
  -280.5774955340034, -280.5774616090316, -280.5775138984008, -280.577462183433, -280.5775144728025, -280.577511414059, -280.5774640948746, -280.5775119884839, -280.577464669253, -280.5774824657976, -280.5774930417135, -280.57748304022, -280.5774936160945, -280.5776039656196, -280.5773715439232, -280.5776045400223, -280.5773721183238, -280.5775123475978, -280.5774631596384, -280.5775129219917, -280.5774637340477, -280.577486148607, -280.5774893591037, -280.5774867230086, -280.5774899335054, -280.5772624022529, -280.577713117914, -280.5772629766548, -280.5777136923152, -280.5774877969454, -280.5774880175917, -280.5774880641308, -280.5774882847774, -280.5774922325202, -280.5774835820303, -280.5774924997057, -280.5774838492159, -280.5774879301043, -280.5774878844283, -280.5774881972899, 
  -280.5774881516139, -280.5774579737962, -280.5775178408381, -280.5774582409805, -280.5775181080251, -280.5774807013129, -280.5774951132098, -280.5774809684988}
 {-352.3866736339302, -352.38667441976, -352.3866741266134, -352.3866731412487, -352.3866728481009, -352.3866743276986, -352.3866742186745, -352.386673049187, -352.3866729401624, -352.3866744214121, -352.3866741249609, -352.3866731429003, -352.386672846449, -352.3866728282408, -352.3866757181445, -352.386671549729, -352.3866744396326, -352.3866740563498, -352.3866744900233, -352.3866727778379, -352.3866732115115, -352.3866742629131, -352.3866742834598, -352.3866729844014, -352.3866730049479, -352.3866742826637, -352.3866742637092, -352.3866730041518, -352.3866729851974, -352.3866743240343, -352.3866742223389, -352.3866730455223, -352.3866729438272, -352.3866699481521, -352.3866785984546, -352.3866686695824, -352.3866773200005, -352.386677814727, -352.3866707316734, -352.386676536216, 
  -352.3866694531605, -352.3866744213619, -352.3866741250112, -352.3866731428498, -352.3866728464996, -352.3866800054908, -352.3866685408515, -352.3866787269759, -352.3866672623426, -352.3866777822853, -352.3866707640972, -352.3866765037734, -352.3866694855853, -352.3866742744334, -352.3866742719395, -352.3866729959217, -352.3866729934277, -352.3866738350164, -352.3866737259918, -352.3866735418689, -352.3866734328449, -352.3866739287296, -352.3866736322784, -352.3866736355825, -352.3866733391313, -352.3866723355583, -352.3866752254619, -352.3866720424111, -352.3866749323149, -352.3866735636672, -352.3866739973408, -352.3866732705201, -352.3866737041937, -352.3866737702307, -352.3866737907773, -352.3866734770836, -352.3866734976302, -352.3866737899811, -352.3866737710268, 
  -352.3866734968341, -352.3866734778797, -352.3866738313516, -352.3866737296565, -352.3866735382046, -352.3866734365092, -352.386669455431, -352.3866781058106, -352.3866691623032, -352.3866778126442, -352.3866773220468, -352.3866702389886, -352.3866770288959, -352.3866699458451, -352.3866739286792, -352.386673632329, -352.3866736355323, -352.3866733391815, -352.386679512805, -352.3866680481722, -352.3866792196614, -352.3866677550215, -352.3866772896028, -352.3866702714147, -352.3866769964557, -352.3866699782676, -352.3866737817509, -352.386673779257, -352.3866734886038, -352.3866734861099, -352.386673836668, -352.3866735402168, -352.3866737276438, -352.3866734311925, -352.3866722434968, -352.3866751334004, -352.3866721344724, -352.3866750243761, -352.3866734716057, -352.3866739052793, 
  -352.3866733625814, -352.386673796255, -352.3866736781692, -352.3866736987157, -352.3866735691448, -352.3866735896914, -352.3866736979197, -352.3866736789652, -352.3866735888953}
 {-303.7389508662753, -303.7389537256257, -303.738953696439, -303.7389480361289, -303.7389480069455, -303.7389537181184, -303.7389537039458, -303.7389480286232, -303.7389480144507, -303.7389536096083, -303.7389538124568, -303.7389479201129, -303.7389481229618, -303.7389551176867, -303.7389523043976, -303.7389494281908, -303.7389466149031, -303.7389537439199, -303.7389536781443, -303.7389480544248, -303.7389479886492, -303.7389549080145, -303.7389525140689, -303.7389492185151, -303.7389468245778, -303.7389554537571, -303.7389519683175, -303.7389497642621, -303.7389462788222, -303.7389556859627, -303.7389517361185, -303.7389499964673, -303.7389460466235, -303.7389596022871, -303.7389478211596, -303.7389539129006, -303.7389421315557, -303.7389634401857, -303.7389439820281, 
  -303.7389577506899, -303.7389382925335, -303.7389352388059, -303.7389721842012, -303.7389295493122, -303.7389664947045, -303.7389595406407, -303.7389478813912, -303.7389538511426, -303.7389421918989, -303.738956342323, -303.7389510797685, -303.7389506528267, -303.7389453902745, -303.7389633586818, -303.7389440634121, -303.7389576691872, -303.7389383739163, -303.7389508879544, -303.7389508737818, -303.7389508587694, -303.7389508445968, -303.738950779445, -303.7389509822921, -303.7389507502584, -303.7389509531086, -303.7389522875227, -303.7389494742336, -303.738952258337, -303.7389494450492, -303.7389509137559, -303.7389508479803, -303.7389508845708, -303.7389508187953, -303.7389520778482, -303.7389496839071, -303.7389520486635, -303.7389496547218, -303.7389526235932, -303.7389491381534, 
  -303.738952594408, -303.7389491089684, -303.7389528557985, -303.7389489059545, -303.7389528266135, -303.7389488767695, -303.7389567721632, -303.7389449909555, -303.7389567430067, -303.7389449617419, -303.7389606100206, -303.7389411518652, -303.7389605808371, -303.7389411226785, -303.7389324086424, -303.7389693540366, -303.7389323794577, -303.7389693248512, -303.7389567104754, -303.7389450512285, -303.7389566812901, -303.7389450220437, -303.7389535121591, -303.7389482496045, -303.7389534829727, -303.7389482204206, -303.738960528518, -303.7389412332479, -303.7389604993331, -303.7389412040627, -303.7389507719377, -303.7389509747864, -303.7389507577652, -303.7389509606139, -303.7389522800158, -303.7389494667274, -303.7389522658433, -303.7389494525549, -303.7389509062494, -303.7389508404739, 
  -303.7389508920769, -303.7389508263013, -303.7389520703424, -303.7389496763999, -303.7389520561688, -303.7389496622284, -303.7389526160867, -303.7389491306469, -303.738952601914}
 {-165.2368871476855, -165.2368852985001, -165.2368850208259, -165.2368892745621, -165.2368889968847, -165.2368852041389, -165.236885115187, -165.2368891801999, -165.2368890912469, -165.2368855848975, -165.2368847344311, -165.2368895609579, -165.2368887104917, -165.2368855667985, -165.2368847525289, -165.236889542859, -165.2368887285893, -165.2368851395386, -165.2368851797872, -165.2368891155991, -165.2368891558477, -165.2369019204088, -165.2368683990206, -165.2369058964666, -165.2368723750839, -165.2368828567457, -165.2368874625814, -165.2368868328064, -165.2368914386417, -165.2368808720714, -165.2368894472662, -165.2368848481319, -165.2368934233267, -165.2368965156614, -165.2368738038662, -165.2369004919466, -165.2368777797019, -165.2368849548638, -165.2368853644865, -165.2368889309176, 
  -165.2368893405536, -165.2368574288134, -165.2369128908077, -165.2368614048765, -165.2369168668655, -165.2368884619002, -165.236881857439, -165.2368924378967, -165.2368858335634, -165.2368908205836, -165.2368794987128, -165.2368947966442, -165.2368834747731, -165.2368599337221, -165.2369103872545, -165.2368639097828, -165.2369143633147, -165.2368873309997, -165.2368872420472, -165.2368870533238, -165.2368869643714, -165.236887711758, -165.2368868612917, -165.2368874340822, -165.2368865836159, -165.2368876936591, -165.2368868793894, -165.2368874159832, -165.2368866017137, -165.2368872663992, -165.2368873066478, -165.2368869887233, -165.236887028972, -165.236904047268, -165.2368705258825, -165.2369037695922, -165.2368702482067, -165.2368849836065, -165.2368895894418, -165.2368847059305, 
  -165.2368893117661, -165.2368829989319, -165.2368915741268, -165.2368827212561, -165.236891296451, -165.2368986426372, -165.2368759306115, -165.2368983649556, -165.2368756529414, -165.2368870817173, -165.236887491354, -165.2368868040488, -165.2368872136709, -165.2368595556753, -165.2369150176668, -165.2368592779994, -165.2369147399911, -165.2368905887271, -165.2368839843331, -165.2368903110546, -165.236883706654, -165.2368929474442, -165.2368816255732, -165.2368926697684, -165.2368813478975, -165.2368620605827, -165.236912514115, -165.236861782907, -165.236912236439, -165.2368876173963, -165.23688676693, -165.2368875284439, -165.2368866779775, -165.2368875992973, -165.2368867850277, -165.2368875103449, -165.2368866960753, -165.2368871720375, -165.236887212286, -165.236887083085, 
  -165.2368871233336, -165.2369039529063, -165.2368704315208, -165.2369038639538, -165.2368703425684, -165.2368848892447, -165.2368894950802, -165.2368848002922}
 {-483.4915669607698, -483.4915655374134, -483.4915665197615, -483.4915674018101, -483.4915683841693, -483.4915660180186, -483.4915660391561, -483.4915678824207, -483.4915679035584, -483.491565072357, -483.4915669848245, -483.4915669367622, -483.4915688492238, -483.4915700230188, -483.4915620341858, -483.4915718874194, -483.4915638985896, -483.4915660336667, -483.491566023508, -483.4915678980688, -483.4915678879103, -483.4915662456062, -483.4915658115685, -483.4915681100107, -483.4915676759685, -483.491566022514, -483.4915660346606, -483.491567886917, -483.4915678990622, -483.4915660374728, -483.4915660197019, -483.4915679018751, -483.4915678841041, -483.4915076768288, -483.4916243826564, -483.4915095402819, -483.491626248008, -483.4915596191398, -483.4915724382872, -483.4915614835547, 
  -483.4915743026769, -483.4915660285327, -483.4915660286418, -483.4915678929351, -483.4915678930441, -483.4915687446157, -483.4915633126548, -483.4915706088667, -483.4915651772084, -483.4915763362186, -483.4915557209156, -483.4915782006179, -483.4915575853209, -483.491566031095, -483.4915660260795, -483.4915678954972, -483.4915678904819, -483.4915664590244, -483.4915664801619, -483.491567441378, -483.4915674625156, -483.4915655133649, -483.4915674258282, -483.4915664957173, -483.4915684081831, -483.4915704640228, -483.4915624751934, -483.4915714463786, -483.491563457545, -483.4915664746725, -483.4915664645139, -483.4915674570262, -483.4915674468674, -483.4915666866131, -483.4915662525733, -483.491567668967, -483.4915672349267, -483.4915664635202, -483.4915664756661, -483.4915674458739, 
  -483.4915674580198, -483.4915664784786, -483.4915664607077, -483.4915674608323, -483.4915674430614, -483.4915081173863, -483.4916248241107, -483.4915090996875, -483.4916258065168, -483.4915600601645, -483.4915728792741, -483.491561042493, -483.491573861653, -483.4915664695385, -483.4915664696477, -483.4915674518923, -483.4915674520014, -483.4915691855531, -483.4915637537292, -483.4915701678925, -483.4915647360971, -483.4915767772232, -483.4915561619228, -483.4915777595763, -483.4915571442769, -483.4915664721009, -483.4915664670855, -483.4915674544545, -483.4915674494392, -483.4915659939722, -483.4915679064368, -483.4915660151097, -483.4915679275742, -483.4915709446316, -483.4915629558003, -483.4915709657692, -483.4915629769378, -483.4915669552804, -483.4915669451218, -483.4915669764179, 
  -483.4915669662592, -483.4915671672205, -483.4915667331818, -483.4915671883591, -483.491566754318, -483.4915669441277, -483.4915669562744, -483.4915669652659}
 {-288.2099786617927, -288.2099769573739, -288.209978742491, -288.2099785811769, -288.2099803663154, -288.2099781900989, -288.209977509765, -288.209979813916, -288.2099791335753, -288.2099757241066, -288.2099799757732, -288.2099773479212, -288.209981599586, -288.2099873356188, -288.2099683643096, -288.2099889594296, -288.2099699881264, -288.2099780246283, -288.2099776752354, -288.2099796484423, -288.209979299049, -288.2100242292382, -288.2099314708682, -288.2100258529532, -288.2099330947807, -288.2099847618188, -288.2099709380532, -288.2099863856348, -288.2099725618647, -288.2099631810292, -288.2099925188931, -288.2099648048396, -288.2099941427101, -288.2101019052608, -288.2098537996966, -288.2101035314008, -288.2098554211839, -288.2099983027158, -288.2099573977281, -288.2099999264839, 
  -288.2099590215876, -288.209812125551, -288.210143578297, -288.2098137493871, -288.2101452020883, -288.2100085359489, -288.2099471639425, -288.2100101594093, -288.2099487881096, -288.2100018926172, -288.2099538074005, -288.2100035164281, -288.2099554312171, -288.2099204048364, -288.210035300072, -288.209922028661, -288.2100369238748, -288.209978109398, -288.209977429061, -288.2099798945261, -288.2099792141884, -288.2099756434058, -288.2099798950692, -288.2099774285314, -288.2099816801991, -288.2099872549136, -288.20996828361, -288.2099890400441, -288.2099700687352, -288.209977943926, -288.2099775945329, -288.2099797290538, -288.2099793796608, -288.2100241484904, -288.2099313902113, -288.2100259336104, -288.2099331753468, -288.2099846811204, -288.2099708573467, -288.2099864662423, 
  -288.2099726424804, -288.2099631003253, -288.209992438192, -288.2099648854527, -288.2099942233203, -288.2101018256706, -288.2098537178818, -288.2101036109001, -288.209855502908, -288.2099982219584, -288.2099573170806, -288.2100000071504, -288.2099591021443, -288.209812044857, -288.2101434975859, -288.2098138299901, -288.2101452827085, -288.2100084550824, -288.2099470834042, -288.2100102401851, -288.2099488685571, -288.210001811915, -288.2099537266979, -288.2100035970393, -288.2099555118291, -288.2099203241366, -288.210035219367, -288.2099221092701, -288.2100370044892, -288.2099768761366, -288.2099811278022, -288.2099761957993, -288.2099804474649, -288.2099884876469, -288.2099695163408, -288.2099878073097, -288.2099688360032, -288.209979176658, -288.2099788272649, -288.2099784963207, 
  -288.2099781469276, -288.2100253812185, -288.2099326229471, -288.210024700881, -288.20993194261, -288.2099859138493, -288.2099720900818, -288.2099852335123}
 {-190.3427208017909, -190.342701678296, -190.342709400665, -190.3427322030043, -190.3427399254647, -190.3427053279419, -190.3427057510155, -190.3427358526933, -190.3427362757722, -190.3426956553373, -190.3427154236426, -190.3427261801099, -190.3427459483781, -190.342691814266, -190.3427192648023, -190.3427223390172, -190.3427497895591, -190.3427052812314, -190.3427057977259, -190.3427358059856, -190.3427363224798, -190.3426881525617, -190.3427229273363, -190.3427186773335, -190.3427534520726, -190.3426980038347, -190.3427130753147, -190.3427285285875, -190.3427436000699, -190.3427149909829, -190.3426960880407, -190.3427455157372, -190.3427266127944, -190.3428133021422, -190.3425977798709, -190.3428438291839, -190.3426283023373, -190.3427369024179, -190.3426741768883, -190.3427674271165, 
  -190.3427047016978, -190.3427445699751, -190.3426665122293, -190.3427750947587, -190.3426970369538, -190.3427204983806, -190.342690580815, -190.3427510225751, -190.3427211061285, -190.3427183743029, -190.3426927049326, -190.3427488990478, -190.3427232296958, -190.3428077951061, -190.3426032824557, -190.3428383198572, -190.3426338072126, -190.3427167290475, -190.3427171521233, -190.3427244514618, -190.3427248745384, -190.3427070564535, -190.3427268247399, -190.3427147788679, -190.3427345471549, -190.342703215367, -190.3427306659146, -190.3427109377902, -190.3427383883208, -190.3427166823382, -190.3427171988326, -190.342724404753, -190.3427249212473, -190.3426995536778, -190.3427343284338, -190.3427072760916, -190.3427420508493, -190.3427094049404, -190.3427244764224, -190.3427171273558, 
  -190.3427321988363, -190.3427263920899, -190.3427074891473, -190.3427341145045, -190.342715211562, -190.3428247042861, -190.3426091799405, -190.3428324269142, -190.3426169021418, -190.3427483034704, -190.3426855780494, -190.342756025938, -190.3426933004111, -190.3427559710927, -190.3426779133252, -190.3427636935152, -190.342685635732, -190.3427318992561, -190.342701982153, -190.3427396215738, -190.3427097046646, -190.3427297754043, -190.3427041060447, -190.3427374978206, -190.3427118284579, -190.3428191962121, -190.3426146835631, -190.3428269186252, -190.3426224059793, -190.3427107061208, -190.3427304744075, -190.342711129197, -190.3427308974837, -190.3427068650386, -190.3427343155779, -190.342707288115, -190.342734738654, -190.3427203320057, -190.3427208485001, -190.342720755082, 
  -190.3427212715763, -190.3427032033444, -190.3427379781021, -190.3427036264214, -190.3427384011774, -190.3427130546078, -190.3427281260899, -190.3427134776849}
 {-353.917025305129, -353.9170266035383, -353.9170284411226, -353.9170221691654, -353.9170240067671, -353.9170275293672, -353.9170275152921, -353.9170230950021, -353.9170230809288, -353.9170250155302, -353.9170300291299, -353.9170205811793, -353.9170255947524, -353.9170228642164, -353.9170321804672, -353.9170184298499, -353.9170277461053, -353.9170275251057, -353.9170275195537, -353.9170230907415, -353.9170230851894, -353.9170248744814, -353.9170301702795, -353.917020440126, -353.9170257359063, -353.9170256823483, -353.9170293623603, -353.9170212479835, -353.9170249279966, -353.9170297584088, -353.9170252862694, -353.9170253240454, -353.9170208519044, -353.9169927056643, -353.9170623416917, -353.916988270639, -353.9170579079886, -353.9170040850466, -353.9170509599052, -353.9169996506852, 
  -353.9170465255383, -353.9170167726997, -353.9170382729018, -353.9170123383296, -353.9170338385433, -353.9170338660684, -353.9170211786208, -353.9170294316217, -353.917016744339, -353.9170216938687, -353.9170333510437, -353.9170172594966, -353.9170289166874, -353.9170413146247, -353.9170137298721, -353.9170368802592, -353.9170092955093, -353.9170243933704, -353.9170243792961, -353.9170262309633, -353.9170262168891, -353.917021879541, -353.9170268931264, -353.9170237171329, -353.9170287307203, -353.9170197282163, -353.9170290444746, -353.9170215658145, -353.9170308820624, -353.9170243891093, -353.9170243835572, -353.9170262267022, -353.9170262211502, -353.9170217384895, -353.9170270342785, -353.9170235760822, -353.9170288718716, -353.9170225463514, -353.9170262263643, -353.9170243839448, 
  -353.9170280639568, -353.9170266224128, -353.9170221502727, -353.9170284600059, -353.9170239878655, -353.9169895693919, -353.9170592059713, -353.9169914068759, -353.9170610436732, -353.9170009490587, -353.9170478239003, -353.9170027866375, -353.9170496615076, -353.9170136367018, -353.9170351369068, -353.917015474292, -353.9170369745026, -353.9170307300428, -353.9170180426537, -353.9170325676118, -353.9170198802705, -353.9170185578692, -353.9170302150505, -353.9170203954605, -353.9170320526451, -353.917038178628, -353.9170105938761, -353.9170400162202, -353.9170124314698, -353.9170228053735, -353.9170278189594, -353.9170227912988, -353.9170278048856, -353.9170206540517, -353.9170299703048, -353.9170206399775, -353.9170299562305, -353.917025314942, -353.9170253093901, -353.9170253008679, 
  -353.9170252953157, -353.9170226643229, -353.9170279601108, -353.9170226502472, -353.9170279460379, -353.9170234721841, -353.9170271521972, -353.9170234581104}
 {-433.0326611863076, -433.0326624930814, -433.0326622812995, -433.0326600913291, -433.0326598795459, -433.0326623478355, -433.0326624265453, -433.0326599460822, -433.0326600247927, -433.032662305571, -433.0326624688132, -433.0326599038196, -433.0326600670587, -433.0326671651695, -433.0326576092235, -433.0326647634164, -433.0326552074705, -433.032662400529, -433.0326623738519, -433.0326599987759, -433.0326599720989, -433.0326624487848, -433.032662325596, -433.0326600470326, -433.0326599238424, -433.0326623195853, -433.0326624547955, -433.0326599178322, -433.0326600530425, -433.032662423197, -433.0326623511842, -433.0326600214445, -433.0326599494309, -433.0326440874094, -433.0326806879425, -433.0326416852468, -433.0326782865991, -433.0326604793639, -433.0326642952028, -433.0326580776195, 
  -433.0326618934413, -433.0326622951793, -433.0326624792018, -433.0326598934251, -433.03266007745, -433.0326723034108, -433.0326524709367, -433.0326699016133, -433.0326500692282, -433.0326786491115, -433.0326461251941, -433.0326762473577, -433.0326437234421, -433.0326624014843, -433.0326623728967, -433.0326599997314, -433.0326599711438, -433.0326612528438, -433.032661331554, -433.0326610410613, -433.0326611197714, -433.0326612105806, -433.0326613738206, -433.0326609987975, -433.0326611620388, -433.032666070178, -433.0326565142319, -433.0326658583953, -433.0326563024496, -433.0326613055375, -433.0326612788603, -433.032661093755, -433.0326610670778, -433.0326613537936, -433.0326612306041, -433.0326611420112, -433.0326610188217, -433.0326612245938, -433.0326613598039, -433.0326610128113, 
  -433.0326611480215, -433.0326613282057, -433.0326612561925, -433.0326611164232, -433.03266104441, -433.0326429922094, -433.0326795931595, -433.0326427804343, -433.0326793813695, -433.0326593843836, -433.0326632002, -433.0326591725872, -433.0326629884313, -433.0326612001871, -433.0326613842108, -433.0326609884047, -433.0326611724282, -433.032671208396, -433.0326513759685, -433.0326709966156, -433.0326511641838, -433.0326775541198, -433.0326450302028, -433.0326773423369, -433.0326448184207, -433.0326613064927, -433.0326612779052, -433.0326610947102, -433.0326610661227, -433.032661065334, -433.0326612285745, -433.0326611440441, -433.0326613072847, -433.0326659249315, -433.0326563689856, -433.0326660036416, -433.0326564476957, -433.0326611602912, -433.032661133614, -433.0326612390012, 
  -433.0326612123241, -433.0326612085472, -433.032661085358, -433.0326612872575, -433.0326611640678, -433.0326610793475, -433.0326612145576, -433.0326611580575}
 {-248.4033386714115, -248.4033386990363, -248.4033385572455, -248.4033387855823, -248.40333864379, -248.4033386436466, -248.4033386126351, -248.4033387301921, -248.4033386991802, -248.4033388113109, -248.4033384449715, -248.4033388978562, -248.4033385315168, -248.4033390859897, -248.4033381702935, -248.403339172535, -248.4033382568387, -248.4033386186398, -248.403338637642, -248.403338705185, -248.4033387241872, -248.4033296496095, -248.4033476066956, -248.4033297361563, -248.4033476932393, -248.4033410351236, -248.403336221159, -248.4033411216688, -248.4033363077043, -248.4033433544133, -248.4033339018801, -248.4033434409586, -248.4033339884254, -248.4033422139006, -248.4033350425828, -248.4033423005609, -248.4033351290131, -248.4033355669648, -248.4033416893413, -248.4033356535068, 
  -248.4033417758899, -248.4033684461086, -248.4033088104684, -248.4033685326552, -248.4033088970123, -248.4033439393424, -248.4033333169161, -248.4033440258711, -248.403333403478, -248.4033443772769, -248.4033328789736, -248.4033444638222, -248.4033329655189, -248.4033075292093, -248.4033697289959, -248.4033076157544, -248.4033698155414, -248.4033387578132, -248.4033387268014, -248.4033386160216, -248.4033385850098, -248.4033389254773, -248.403338559138, -248.4033387836857, -248.4033384173463, -248.4033392001562, -248.4033382844599, -248.4033390583645, -248.4033381426683, -248.4033387328062, -248.4033387518084, -248.4033385910146, -248.4033386100168, -248.4033297637768, -248.4033477208612, -248.4033296219851, -248.4033475790697, -248.40334114929, -248.4033363353255, -248.4033410074984, 
  -248.4033361935338, -248.4033434685798, -248.4033340160466, -248.4033433267881, -248.4033338742549, -248.4033423281273, -248.403335156689, -248.4033421863301, -248.4033350149029, -248.4033356811276, -248.4033418035114, -248.4033355393399, -248.4033416617158, -248.4033685602757, -248.4033089246341, -248.403368418484, -248.4033087828426, -248.4033440534997, -248.4033334310917, -248.4033439117098, -248.4033332892984, -248.4033444914433, -248.4033329931401, -248.4033443496517, -248.4033328513484, -248.4033076433757, -248.4033698431624, -248.403307501584, -248.4033697013708, -248.4033388700873, -248.403338503748, -248.4033388390757, -248.4033384727363, -248.4033391447662, -248.4033382290699, -248.4033391137545, -248.4033381980582, -248.4033386774162, -248.4033386964184, -248.4033386464045, 
  -248.4033386654067, -248.4033297083868, -248.4033476654712, -248.4033296773749, -248.4033476344597, -248.4033410939, -248.4033362799355, -248.4033410628883}
 {-707.0888364433522, -707.0888290613366, -707.0888297999218, -707.0888430868441, -707.0888438254409, -707.0888294326551, -707.0888294286034, -707.0888434581683, -707.0888434541165, -707.0888287340466, -707.0888301272239, -707.0888427595598, -707.0888441527373, -707.0888311406245, -707.0888277206396, -707.0888451661375, -707.0888417461529, -707.0888294330191, -707.0888294282393, -707.0888434585325, -707.0888434537525, -707.0888343536804, -707.0888245080384, -707.0888483791919, -707.0888385335532, -707.0888298859297, -707.0888289753351, -707.0888439114431, -707.088843000848, -707.0888328827344, -707.0888259785354, -707.0888469082476, -707.0888400040488, -707.0888032690578, -707.0888555928005, -707.0888172938552, -707.0888696190295, -707.0888290458262, -707.0888298155046, 
  -707.0888430713628, -707.0888438409943, -707.0888340807251, -707.0888247813841, -707.0888481062288, -707.0888388069068, -707.0888342447515, -707.0888246165661, -707.0888482700477, -707.0888386422965, -707.0888413025513, -707.0888175586385, -707.0888553280642, -707.0888315841517, -707.0888379654297, -707.0888208963906, -707.0888519909429, -707.0888349219037, -707.0888360760827, -707.0888360720309, -707.0888368146735, -707.0888368106219, -707.0888353774743, -707.0888367706518, -707.0888361160651, -707.0888375092425, -707.0888377840518, -707.0888343640673, -707.0888385226428, -707.0888351026579, -707.0888360764466, -707.0888360716668, -707.0888368150375, -707.0888368102577, -707.0888409971073, -707.0888311514667, -707.0888417356978, -707.0888318900577, -707.0888365293575, 
  -707.0888356187626, -707.0888372679482, -707.0888363573536, -707.0888395261621, -707.0888326219629, -707.0888402647529, -707.0888333605538, -707.0888099121364, -707.0888622365773, -707.0888106507097, -707.0888629751854, -707.0888356892747, -707.0888364589114, -707.0888364278474, -707.0888371975204, -707.0888407241483, -707.0888314248161, -707.0888414627385, -707.0888321634075, -707.0888408880751, -707.0888312600978, -707.0888416266568, -707.0888319986977, -707.0888479459787, -707.088824202066, -707.0888486845694, -707.088824940657, -707.0888446088572, -707.0888275398181, -707.0888453474483, -707.0888282784088, -707.0888357487954, -707.088837141973, -707.0888357447437, -707.0888371379212, -707.0888381553732, -707.0888347353884, -707.0888381513216, -707.0888347313368, -707.088836447768, 
  -707.0888364429882, -707.0888364437162, -707.0888364389364, -707.0888413684284, -707.088831522788, -707.0888413643766, -707.0888315187362, -707.0888369006786, -707.0888359900839, -707.088836896627}
 {-17.76284596614865, -17.76284618128654, -17.76284617513775, -17.7628457571599, -17.76284575101111, -17.76284617631721, -17.76284618010707, -17.76284575219059, -17.76284575598044, -17.76284679974448, -17.76284555670278, -17.76284637561483, -17.76284513257916, -17.7628472833667, -17.76284507305871, -17.76284685923992, -17.76284464893223, -17.76284616014718, -17.76284619627713, -17.7628457360206, -17.76284577215044, -17.76288223990062, -17.76281011735137, -17.76288181567361, -17.76280969332511, -17.76284685925321, -17.76284549717075, -17.76284643512662, -17.76284507304408, -17.76284037514975, -17.76285198130513, -17.76283995102512, -17.7628515571765, -17.76284747479063, -17.76284488163603, -17.76284705066005, -17.76284445751334, -17.76284695821747, -17.76284539824179, -17.76284653409264, 
  -17.76284497411333, -17.76282048174344, -17.76287187510615, -17.76282005762325, -17.76287145097307, -17.7628461789856, -17.76284617743869, -17.76284575485897, -17.76284575331205, -17.76285214443492, -17.76284021195426, -17.76285172030884, -17.76283978782707, -17.76283772204919, -17.76285463524624, -17.76283729793424, -17.76285421110791, -17.76284596732812, -17.76284597111798, -17.76284596117932, -17.76284596496918, -17.76284659075393, -17.76284534771512, -17.76284658460501, -17.76284534156646, -17.76284707437753, -17.76284486406969, -17.76284706822873, -17.7628448579209, -17.76284595115811, -17.762845987288, -17.76284594500932, -17.76284598113921, -17.76288203086166, -17.76280990841213, -17.76288202471222, -17.76280990226399, -17.76284665026413, -17.76284528818163, -17.76284664411535, 
  -17.76284528203284, -17.76284016616165, -17.76285177231504, -17.76284016001287, -17.76285176616624, -17.76284726579956, -17.76284467264891, -17.76284725965076, -17.76284466650012, -17.76284674922938, -17.76284518925168, -17.76284674308038, -17.76284518310309, -17.76282027275755, -17.76287166611385, -17.76282026660879, -17.76287165996502, -17.76284596999651, -17.76284596844959, -17.76284596384771, -17.7628459623008, -17.7628519354461, -17.76284000296489, -17.76285192929731, -17.76283999681609, -17.7628375130659, -17.76285442625133, -17.76283750691717, -17.76285442010246, -17.76284658578453, -17.76284534274588, -17.76284658957442, -17.7628453465357, -17.7628470694082, -17.76284485910037, -17.76284707319806, -17.76284486289022, -17.76284594618879, -17.76284598231868, -17.76284594997864, 
  -17.76284598610854, -17.76288202589157, -17.76280990344357, -17.76288202968231, -17.76280990723255, -17.76284664529481, -17.76284528321231, -17.76284664908466}
 {-325.8676386626976, -325.867645944482, -325.8676433881484, -325.8676339373309, -325.8676313809997, -325.8676446490179, -325.8676446836102, -325.8676326418681, -325.8676326764602, -325.867647130455, -325.867642202184, -325.8676351232846, -325.867630195055, -325.8676532410668, -325.86763609166, -325.867641233918, -325.867624084509, -325.8676448514957, -325.8676444811323, -325.8676328443458, -325.8676324739825, -325.8676473160175, -325.8676420170416, -325.8676353088649, -325.8676300098944, -325.8676460125367, -325.8676433201887, -325.867634005389, -325.8676313130366, -325.8676606142624, -325.8676287185181, -325.8676486071129, -325.8676167113678, -325.8677853735597, -325.8675039658745, -325.8677733690196, -325.8674919561153, -325.8676200425877, -325.867669290832, -325.8676080353818, 
  -325.867657283738, -325.8676369665336, -325.8676523735538, -325.8676249594159, -325.8676403663718, -325.8677204950826, -325.8675688373386, -325.8677084876015, -325.86755683052, -325.867704623563, -325.8675847091499, -325.8676926164195, -325.8675727019936, -325.867730226439, -325.8675591084405, -325.8677182192887, -325.8675471012911, -325.8676399235689, -325.8676399581611, -325.8676373672365, -325.8676374018286, -325.8676424049973, -325.867637476744, -325.8676398486617, -325.8676349204146, -325.8676485156241, -325.8676313662046, -325.86764595928, -325.8676288098839, -325.8676401260467, -325.8676397556832, -325.8676375697144, -325.8676371993508, -325.8676425905662, -325.8676372915947, -325.8676400342355, -325.8676347352607, -325.8676412870876, -325.8676385947396, -325.8676387307575, 
  -325.867636038405, -325.8676558888136, -325.8676239930689, -325.8676533324813, -325.8676214367363, -325.8677806494151, -325.8674992391211, -325.8677780930835, -325.867496682788, -325.8676153170735, -325.867664565448, -325.8676127608153, -325.8676620090414, -325.8676322410972, -325.8676476480921, -325.8676296847715, -325.8676450917527, -325.8677157694548, -325.8675641120685, -325.8677132131486, -325.8675615557096, -325.8676998981171, -325.8675799836978, -325.8676973417848, -325.8675774273653, -325.8677255009904, -325.8675543829911, -325.8677229446566, -325.8675518266597, -325.8676411095323, -325.8676361812819, -325.8676411441243, -325.8676362158742, -325.8676472201549, -325.8676300707467, -325.8676472547469, -325.8676301053391, -325.8676388305832, -325.8676384602198, -325.8676388651755, 
  -325.8676384948119, -325.8676412951045, -325.8676359961294, -325.8676413296948, -325.8676360307237, -325.8676399916257, -325.8676372992744, -325.8676400262169}
 {-296.8995287919193, -296.8995309863462, -296.8995305861478, -296.899526997702, -296.8995265975004, -296.8995308424278, -296.899530730066, -296.8995268537825, -296.8995267414194, -296.8995302437827, -296.8995313287126, -296.8995262551369, -296.8995273400666, -296.8995344635912, -296.8995271089138, -296.8995304749455, -296.8995231202679, -296.8995308766446, -296.8995306958491, -296.8995268879988, -296.8995267072033, -296.8995357043211, -296.8995258682143, -296.8995317156734, -296.8995218795704, -296.8995281438232, -296.899533428682, -296.8995241551773, -296.8995294400362, -296.8995287840553, -296.8995327884833, -296.8995247954093, -296.8995287998377, -296.8995396733208, -296.8995219000634, -296.8995356849303, -296.8995179111623, -296.8995364499558, -296.8995251226466, -296.899532461301, 
  -296.8995211340096, -296.899505941831, -296.8995556317262, -296.8995019531884, -296.899551643077, -296.8995480282337, -296.8995135441669, -296.8995440395677, -296.8995095555412, -296.8995420865885, -296.8995194859934, -296.8995380979425, -296.8995154973477, -296.8995482472052, -296.8995133254364, -296.8995442585596, -296.8995093367904, -296.8995290482007, -296.8995289358381, -296.8995286480006, -296.8995285356382, -296.8995284495553, -296.899529534485, -296.8995280493552, -296.8995291342852, -296.8995326693639, -296.8995253146863, -296.8995322691637, -296.8995249144862, -296.8995290824172, -296.8995289016216, -296.8995286822171, -296.8995285014215, -296.8995339100927, -296.8995240739878, -296.8995335098927, -296.8995236737877, -296.8995263495958, -296.8995316344547, -296.8995259493957, 
  -296.8995312342545, -296.8995269898277, -296.8995309942559, -296.8995265896277, -296.8995305940559, -296.8995378792287, -296.8995201057006, -296.8995374790132, -296.899519705516, -296.8995346557202, -296.8995233284273, -296.8995342555275, -296.8995229282199, -296.8995041476053, -296.8995538374968, -296.8995037474049, -296.8995534372972, -296.8995462339938, -296.8995117499519, -296.8995458337985, -296.8995113497471, -296.899540292361, -296.899517691766, -296.8995398921609, -296.899517291566, -296.8995464529779, -296.8995115312089, -296.8995460527778, -296.8995111310089, -296.8995283056363, -296.8995293905662, -296.8995281932739, -296.8995292782036, -296.8995325254448, -296.8995251707674, -296.8995324130824, -296.899525058405, -296.8995289384982, -296.8995287577027, -296.8995288261358, 
  -296.8995286453403, -296.8995337661739, -296.8995239300688, -296.8995336538112, -296.8995238177064, -296.8995262056769, -296.8995314905357, -296.8995260933143}
 {-422.5742524003903, -422.5742524435577, -422.5742524010097, -422.574252399771, -422.5742523572231, -422.5742524235688, -422.5742524209986, -422.5742523797821, -422.5742523772119, -422.5742524757417, -422.5742523688281, -422.5742524319552, -422.5742523250413, -422.5742546298328, -422.5742502147507, -422.5742545860458, -422.5742501709644, -422.5742524457912, -422.5742523987763, -422.5742524020045, -422.5742523549895, -422.5742536048498, -422.5742512397624, -422.5742535610429, -422.5742511959959, -422.5742537185399, -422.5742511260339, -422.5742536747528, -422.5742510822477, -422.5742542417208, -422.5742506028633, -422.574254197934, -422.5742505590768, -422.5742525005002, -422.5742523440678, -422.574252456713, -422.5742523002816, -422.5742465956129, -422.5742582490879, -422.5742465518245, 
  -422.5742582053031, -422.5742720599359, -422.5742327855698, -422.574272016146, -422.5742327417864, -422.574252450424, -422.5742523941436, -422.5742524066369, -422.5742523503573, -422.5742573464924, -422.5742474980593, -422.5742573027051, -422.5742474542733, -422.5742613752238, -422.5742434694048, -422.5742613314396, -422.5742434256157, -422.5742524229493, -422.5742524203792, -422.5742523804014, -422.5742523778313, -422.5742524751228, -422.5742523682082, -422.574252432574, -422.574252325661, -422.5742546292133, -422.5742502141312, -422.574254586665, -422.5742501715836, -422.5742524451717, -422.5742523981568, -422.5742524026238, -422.5742523556088, -422.5742536042224, -422.5742512391507, -422.5742535616701, -422.5742511966073, -422.5742537179203, -422.5742511254146, -422.5742536753721, 
  -422.5742510828669, -422.5742542411013, -422.5742506022439, -422.5742541985533, -422.5742505596959, -422.5742524998803, -422.5742523434485, -422.5742524573325, -422.5742523009005, -422.5742465949928, -422.5742582484691, -422.5742465524444, -422.5742582059216, -422.5742720593152, -422.5742327849515, -422.5742720167665, -422.5742327424045, -422.5742524498044, -422.5742523935243, -422.5742524072563, -422.5742523509764, -422.5742573458727, -422.5742474974401, -422.5742573033246, -422.5742474548922, -422.5742613746052, -422.5742434687843, -422.5742613320579, -422.574243426236, -422.5742524551334, -422.5742523482197, -422.5742524525633, -422.5742523456495, -422.5742546092242, -422.5742501941424, -422.574254606654, -422.5742501915724, -422.5742524251828, -422.5742523781678, -422.5742524226127, 
  -422.5742523755978, -422.5742535842314, -422.574251219164, -422.5742535816611, -422.5742512165941, -422.5742536979313, -422.5742511054257, -422.5742536953611}
 {-141.932534492842, -141.932524683954, -141.9325251719477, -141.9325438137954, -141.9325443017989, -141.9325247375068, -141.9325251183948, -141.9325438673508, -141.9325442482435, -141.932523956369, -141.9325258995462, -141.9325430862206, -141.9325450293872, -141.9325267034024, -141.9325231525115, -141.9325458332479, -141.9325422823586, -141.9325249112076, -141.9325249446941, -141.9325440410539, -141.9325440745404, -141.9325034020339, -141.9325464542728, -141.9325225319431, -141.9325655840563, -141.9325212980841, -141.9325285578178, -141.9325404279278, -141.9325476876668, -141.9325220696269, -141.9325277863093, -141.9325411994742, -141.9325469161546, -141.9325679767594, -141.932481880179, -141.932587107674, -141.9325010089571, -141.9325239324119, -141.9325259236118, -141.9325430622328, 
  -141.9325450534835, -141.9325658412816, -141.9324840158073, -141.932584971141, -141.9325031456405, -141.9325246828301, -141.9325251732216, -141.9325438123781, -141.9325443033662, -141.932528102397, -141.9325217535907, -141.9325472322388, -141.9325408834414, -141.9325171092005, -141.9325327480143, -141.9325362390403, -141.9325518778671, -141.9325340583976, -141.9325344392879, -141.9325345463961, -141.9325349272865, -141.9325332772634, -141.9325352204356, -141.9325337652623, -141.9325357084339, -141.9325360242936, -141.932532473404, -141.9325365122927, -141.9325329614022, -141.9325342320995, -141.932534265586, -141.9325347200981, -141.9325347535846, -141.9325127229589, -141.9325557751317, -141.9325132109542, -141.9325562631335, -141.9325306189733, -141.9325378787125, -141.9325311069747, 
  -141.9325383667083, -141.9325313905193, -141.9325371072007, -141.9325318785179, -141.9325375951993, -141.9325772981774, -141.9324912005448, -141.932577786192, -141.9324916885274, -141.9325332532763, -141.9325352445313, -141.9325337413046, -141.9325357325001, -141.9325751621793, -141.9324933366934, -141.9325756501794, -141.9324938246905, -141.9325340035765, -141.932534494259, -141.9325344915678, -141.9325349822649, -141.932537423286, -141.9325310744855, -141.9325379112859, -141.9325315624827, -141.9325264300902, -141.9325420689083, -141.9325269180867, -141.9325425569091, -141.9325333308177, -141.9325352739896, -141.932533711708, -141.9325356548799, -141.932536077848, -141.9325325269579, -141.9325364587383, -141.9325329078483, -141.9325342856536, -141.9325343191401, -141.932534666544, 
  -141.9325347000305, -141.9325127765106, -141.9325558286882, -141.9325131574026, -141.932556209577, -141.9325306725289, -141.9325379322651, -141.9325310534191}
 {-360.4587412090049, -360.4587426114514, -360.4587426006547, -360.4587398173559, -360.4587398065595, -360.4587426061495, -360.4587426059564, -360.4587398120542, -360.4587398118611, -360.4587425856319, -360.4587426264741, -360.4587397915366, -360.4587398323788, -360.458743651963, -360.4587415601465, -360.4587408578676, -360.4587387660512, -360.4587425891375, -360.4587426229684, -360.4587397950424, -360.458739828873, -360.4587423976543, -360.4587428144559, -360.458739603559, -360.4587400203606, -360.4587418591127, -360.4587433529987, -360.4587390650173, -360.4587405589034, -360.458744407686, -360.4587408044297, -360.4587416135907, -360.4587380103344, -360.4587437080956, -360.4587415044462, -360.4587409139918, -360.4587387103594, -360.4587411741251, -360.4587440380334, -360.4587383800304, 
  -360.4587412439376, -360.4587330226208, -360.4587521901174, -360.4587302285253, -360.4587493960223, -360.4587547139177, -360.4587304981149, -360.4587519198225, -360.4587277040197, -360.4587542490819, -360.4587309629594, -360.4587514549866, -360.4587281688642, -360.4587713901949, -360.4587138215329, -360.4587685960996, -360.4587110274378, -360.4587412144999, -360.4587412143066, -360.4587412037032, -360.4587412035102, -360.4587411939822, -360.4587412348244, -360.4587411831857, -360.4587412240278, -360.4587422603132, -360.4587401684968, -360.4587422495167, -360.4587401577002, -360.4587411974879, -360.4587412313186, -360.4587411866913, -360.4587412205221, -360.4587410060046, -360.4587414228062, -360.458740995208, -360.4587414120096, -360.4587404674629, -360.458741961349, -360.4587404566664, 
  -360.4587419505524, -360.4587430160363, -360.4587394127799, -360.4587430052398, -360.4587394019833, -360.4587423164479, -360.4587401127946, -360.4587423056389, -360.4587401020104, -360.4587397824753, -360.4587426463838, -360.4587397716795, -360.4587426355865, -360.4587316309711, -360.4587507984677, -360.4587316201743, -360.4587507876714, -360.4587533222679, -360.4587291064653, -360.4587533114715, -360.4587290956686, -360.4587528574322, -360.4587295713097, -360.4587528466355, -360.4587295605132, -360.4587699985451, -360.4587124298833, -360.4587699877487, -360.4587124190867, -360.4587411886804, -360.4587412295226, -360.4587411884873, -360.4587412293294, -360.4587422550114, -360.458740163195, -360.4587422548183, -360.4587401630019, -360.4587411921861, -360.4587412260169, -360.458741191993, 
  -360.4587412258237, -360.4587410007029, -360.4587414175044, -360.4587410005097, -360.4587414173113, -360.4587404621611, -360.4587419560472, -360.458740461968}
 {-301.0758626251971, -301.0758609426369, -301.0758598538221, -301.0758653965865, -301.0758643077701, -301.0758604460748, -301.0758603503841, -301.0758649000235, -301.075864804333, -301.075859368222, -301.0758614282394, -301.0758638221728, -301.0758658821863, -301.0758644533284, -301.0758563431482, -301.0758689072781, -301.0758607970962, -301.0758604425123, -301.0758603539465, -301.0758648964612, -301.0758648078953, -301.0758535051611, -301.0758672913888, -301.0758579591222, -301.0758717453253, -301.0758618034333, -301.0758589930302, -301.0758662573815, -301.0758634469797, -301.0758635269904, -301.0758572694964, -301.0758679809392, -301.0758617234452, -301.0758880744719, -301.0758327226677, -301.0758925289495, -301.0758371760879, -301.075863655074, -301.0758571414652, -301.0758681090148, 
  -301.075861595422, -301.0758826996761, -301.0758380975659, -301.0758871536293, -301.0758425515105, -301.0758582591059, -301.0758625374645, -301.0758627129536, -301.0758669915145, -301.0758635163158, -301.0758572801591, -301.0758679702632, -301.0758617341092, -301.0758667886034, -301.0758540080362, -301.0758712425509, -301.0758584619864, -301.0758632174503, -301.0758631217596, -301.0758621286347, -301.0758620329441, -301.0758621395989, -301.0758641996136, -301.0758610507826, -301.0758631107989, -301.0758672247051, -301.0758591145225, -301.075866135888, -301.0758580257086, -301.075863213888, -301.0758631253219, -301.0758621250723, -301.0758620365065, -301.0758562765444, -301.0758700627565, -301.0758551877256, -301.0758689739443, -301.0758645748079, -301.0758617644067, -301.0758634859936, 
  -301.0758606755899, -301.0758662983658, -301.075860040872, -301.0758652095505, -301.0758589520564, -301.0758908461223, -301.0758354937684, -301.0758897572858, -301.0758344049739, -301.0758664264348, -301.0758599128554, -301.0758653376407, -301.0758588240185, -301.0758854710537, -301.0758408689394, -301.0758843822384, -301.0758397801237, -301.0758610304248, -301.0758653088967, -301.0758599416213, -301.0758642200691, -301.0758662876902, -301.0758600515357, -301.0758651988755, -301.0758589627193, -301.0758695599786, -301.0758567794121, -301.0758684711624, -301.0758556905972, -301.0758616430361, -301.0758637030515, -301.0758615473453, -301.0758636073608, -301.0758667281418, -301.0758586179608, -301.0758666324512, -301.0758585222701, -301.0758627173254, -301.0758626287595, 
  -301.0758626216347, -301.0758625330689, -301.0758557799805, -301.0758695661955, -301.0758556842894, -301.0758694705051, -301.0758640782464, -301.0758612678432, -301.0758639825551}
 {-24.70134703214519, -24.7013470487335, -24.70134704735872, -24.70134701693171, -24.70134701555692, -24.70134704825035, -24.70134704784187, -24.70134701644856, -24.70134701604008, -24.70134856904424, -24.70134552706759, -24.7013485372386, -24.70134549526966, -24.70134746442189, -24.70134663167214, -24.70134743262044, -24.70134659987001, -24.70134706538727, -24.70134703070495, -24.70134703358546, -24.70134699890318, -24.70133939205238, -24.70135470479355, -24.70133936025911, -24.70135467298324, -24.70134748239937, -24.70134661369565, -24.70134745059786, -24.70134658189358, -24.7013479502384, -24.70134614586006, -24.70134791843614, -24.70134611405873, -24.70134719662457, -24.70134689946974, -24.70134716482205, -24.70134686766867, -24.70134498913357, -24.7013491069861, -24.70134495733291, 
  -24.70134907518317, -24.7013520817719, -24.70134201466064, -24.70135204997413, -24.70134198285483, -24.70134704990281, -24.70134704618943, -24.70134701810101, -24.70134701438764, -24.70135239065332, -24.70134170541525, -24.70135235885262, -24.70134167361235, -24.70136130402931, -24.70133279188022, -24.70136127222568, -24.70133276008027, -24.70134703303683, -24.70134703262834, -24.70134703166204, -24.70134703125356, -24.70134855382878, -24.701345511856, -24.70134855245401, -24.7013455104812, -24.70134744920854, -24.70134661645845, -24.70134744783374, -24.70134661508367, -24.70134705017374, -24.70134701549144, -24.70134704879895, -24.70134701411665, -24.7013393768432, -24.70135468957568, -24.70133937546824, -24.70135468820107, -24.70134746718598, -24.70134659848198, -24.70134746581119, 
  -24.7013465971072, -24.70134793502464, -24.70134613064677, -24.70134793364986, -24.70134612927198, -24.70134718141067, -24.70134688425658, -24.7013471800359, -24.70134688288179, -24.70134497392062, -24.70134909177199, -24.7013449725458, -24.70134909039724, -24.70135206656042, -24.70134199944507, -24.70135206518556, -24.70134199807036, -24.70134703468928, -24.7013470309759, -24.7013470333145, -24.70134702960112, -24.70135237544035, -24.70134169020116, -24.70135237406555, -24.7013416888264, -24.70136128881485, -24.70133277666763, -24.7013612874401, -24.70133277529281, -24.70134855334565, -24.70134551137284, -24.70134855293715, -24.70134551096437, -24.70134744872538, -24.7013466159753, -24.7013474483169, -24.70134661556682, -24.70134704969058, -24.70134701500828, -24.7013470492821, 
  -24.70134701459981, -24.70133937635998, -24.7013546890926, -24.70133937595146, -24.70135468868416, -24.70134746670283, -24.70134659799883, -24.70134746629435}
 {-181.0947474010351, -181.0947477634799, -181.0947477873986, -181.0947470146745, -181.0947470385929, -181.0947477732322, -181.0947477776464, -181.0947470244267, -181.0947470288408, -181.0947487695679, -181.094746781316, -181.0947480207528, -181.0947460325199, -181.0947511692284, -181.0947443816745, -181.0947504204233, -181.0947436328684, -181.0947477318178, -181.0947478190608, -181.0947469830123, -181.0947470702552, -181.0947587581283, -181.094736792739, -181.094758009216, -181.0947360440401, -181.094743323901, -181.0947522269851, -181.0947425750958, -181.0947514781791, -181.0947459188508, -181.0947496320674, -181.0947451700454, -181.0947488832615, -181.094749762959, -181.0947457879219, -181.0947490141339, -181.0947450391358, -181.0947418609671, -181.0947536901291, -181.0947411121644, 
  -181.0947529413207, -181.0946849469124, -181.0948106057286, -181.094684198116, -181.0948098569139, -181.0947477740083, -181.0947477768702, -181.0947470252028, -181.0947470280646, -181.094757498829, -181.0947380520191, -181.0947567500263, -181.0947373032107, -181.0947322409207, -181.0947633116256, -181.0947314921286, -181.0947625628066, -181.0947473868688, -181.0947473912829, -181.0947474107873, -181.0947474152014, -181.0947483832, -181.0947463949569, -181.0947484071178, -181.0947464188762, -181.0947507828653, -181.0947439953106, -181.0947508067836, -181.0947440192294, -181.0947473454544, -181.0947474326973, -181.0947473693729, -181.0947474566158, -181.0947583717058, -181.0947364064345, -181.0947583956357, -181.0947364303417, -181.0947429375377, -181.0947518406214, -181.0947429614562, 
  -181.09475186454, -181.0947455324875, -181.0947492457037, -181.094745556406, -181.0947492696224, -181.0947493765858, -181.0947454015681, -181.0947494005043, -181.0947454254867, -181.0947414746065, -181.0947533037628, -181.0947414985221, -181.0947533276843, -181.0946845605544, -181.0948102193597, -181.0946845844711, -181.09481024328, -181.0947473876449, -181.0947473905068, -181.0947474115634, -181.0947474144253, -181.0947571124672, -181.094737665654, -181.0947571363853, -181.0947376895729, -181.0947318545648, -181.0947629252546, -181.0947318784817, -181.0947629491748, -181.0947483929518, -181.0947464047096, -181.094748397366, -181.0947464091236, -181.0947507926174, -181.0947440050629, -181.0947507970315, -181.094744009477, -181.0947473552066, -181.0947474424495, -181.0947473596207, 
  -181.0947474468636, -181.0947583814637, -181.094736416181, -181.0947583858777, -181.0947364205952, -181.0947429472899, -181.0947518503736, -181.094742951704}
 {-175.2206410471716, -175.2206407959469, -175.2206408930885, -175.2206412012588, -175.2206412984025, -175.2206408496931, -175.2206408393422, -175.2206412550062, -175.2206412446551, -175.2206406778042, -175.220641011232, -175.2206410831172, -175.220641416545, -175.2206409129796, -175.2206407760574, -175.2206413182926, -175.2206411813704, -175.2206408497463, -175.220640839289, -175.2206412550593, -175.220641244602, -175.2206425436882, -175.2206391453837, -175.2206429490011, -175.2206395506968, -175.2206413121561, -175.220640376882, -175.2206417174691, -175.220640782195, -175.2206410747181, -175.220640614319, -175.2206414800311, -175.220641019632, -175.2206429827976, -175.220638706339, -175.2206433881813, -175.2206391115814, -175.2206415090264, -175.2206401800211, -175.2206419143367, 
  -175.2206405853369, -175.2206374811016, -175.2206442080851, -175.2206378864157, -175.220644613397, -175.2206466329322, -175.2206350560712, -175.2206470382337, -175.2206354613957, -175.2206467139305, -175.2206349750715, -175.2206471192435, -175.2206353803845, -175.2206551010553, -175.2206265877972, -175.2206555063683, -175.2206269931103, -175.2206410037758, -175.2206409934248, -175.2206411009185, -175.2206410905674, -175.2206408318868, -175.2206411653146, -175.2206409290296, -175.2206412624573, -175.2206410670622, -175.22064093014, -175.2206411642049, -175.2206410272827, -175.2206410038289, -175.2206409933716, -175.2206411009716, -175.2206410905143, -175.2206426977708, -175.2206392994664, -175.2206427949135, -175.2206393966091, -175.2206414662387, -175.2206405309646, -175.2206415633814, 
  -175.2206406281073, -175.2206412288007, -175.2206407684016, -175.2206413259434, -175.2206408655443, -175.2206431369132, -175.2206388603887, -175.2206432340606, -175.2206389575267, -175.2206416631071, -175.2206403341058, -175.220641760251, -175.2206404312472, -175.2206376351847, -175.2206443621672, -175.2206377323275, -175.2206444593098, -175.2206467870097, -175.220635210159, -175.2206468841512, -175.2206353073029, -175.2206468680131, -175.2206351291541, -175.2206469651558, -175.2206352262968, -175.220655255138, -175.2206267418799, -175.2206553522806, -175.2206268390226, -175.2206408856337, -175.2206412190614, -175.2206408752826, -175.2206412087104, -175.220641120809, -175.2206409838869, -175.220641110458, -175.2206409735359, -175.2206410575757, -175.2206410471184, -175.2206410472247, 
  -175.2206410367674, -175.2206427515176, -175.2206393532132, -175.2206427411666, -175.2206393428622, -175.2206415199856, -175.2206405847114, -175.2206415096345}
 {-14.1565069524807, -14.15650616801333, -14.1565062104355, -14.15650769452165, -14.15650773694365, -14.15650618692513, -14.1565061915237, -14.15650771343337, -14.15650771803192, -14.15650360591965, -14.15650877256728, -14.15650513244072, -14.15651029906267, -14.15650960485288, -14.15650277362808, -14.15651113135308, -14.15650430014433, -14.156506151592, -14.15650622685685, -14.15650767810005, -14.15650775336527, -14.15649187868101, -14.15652050085237, -14.15649340533505, -14.15652202721478, -14.15650319345395, -14.15650918503258, -14.15650471995606, -14.15651071154693, -14.15651107846934, -14.15650130002604, -14.15651260497319, -14.15650282653865, -14.15650504484095, -14.1565073336109, -14.15650657135767, -14.15650886011064, -14.15651003179722, -14.15650234685712, -14.15651155832777, 
  -14.15650387334303, -14.15653653513083, -14.15647584547227, -14.15653806169866, -14.1564773719209, -14.15650622448007, -14.15650615396897, -14.1565077509878, -14.1565076804777, -14.15652154175001, -14.15649083664077, -14.156523068249, -14.15649236315824, -14.15654588894801, -14.15646648909379, -14.15654741543202, -14.15646801562623, -14.15650692897038, -14.15650693356894, -14.15650697139246, -14.15650697599102, -14.15650434797158, -14.15650951460583, -14.15650439039313, -14.15650955702845, -14.15651034689436, -14.15650351567708, -14.15651038931594, -14.15650355809966, -14.15650689363716, -14.15650696890218, -14.15650693605923, -14.15650701132428, -14.15649262079416, -14.15652124282969, -14.15649266322623, -14.15652128524179, -14.15650393549634, -14.15650992708068, -14.15650397791801, 
  -14.15650996950317, -14.15651182051254, -14.15650204207332, -14.15651186293433, -14.1565020844957, -14.15650578689049, -14.15650807565183, -14.15650582931246, -14.15650811807404, -14.15651077385231, -14.15650308889251, -14.15651081627701, -14.15650313131198, -14.156537277204, -14.15647658748959, -14.15653731962984, -14.15647662990791, -14.15650696652506, -14.15650689601446, -14.15650700894714, -14.15650693843655, -14.15652228379085, -14.15649157869042, -14.1565223262125, -14.15649162111293, -14.15654663098193, -14.15646723115035, -14.15654667340245, -14.156467273574, -14.15650436688305, -14.15650953351789, -14.15650437148166, -14.15650953811639, -14.15651036580589, -14.15650353458906, -14.1565103704044, -14.15650353918767, -14.15650691254891, -14.15650698781395, -14.15650691714747, 
  -14.15650699241251, -14.15649263971077, -14.1565212617366, -14.15649264430962, -14.15652126633488, -14.15650395440791, -14.15650994599263, -14.15650395900644}
 {-318.5502458153542, -318.5502523952228, -318.5502510619512, -318.5502405687936, -318.5502392355271, -318.5502517520352, -318.5502517051361, -318.5502399256084, -318.5502398787095, -318.5502519286621, -318.5502515285033, -318.5502401022304, -318.5502397020817, -318.5502384426045, -318.5502650145838, -318.5502266161753, -318.5502531881598, -318.5502515939201, -318.5502518632511, -318.5502397674934, -318.5502400368245, -318.5502519427114, -318.5502515145083, -318.5502401162847, -318.5502396880817, -318.5502476138082, -318.5502558434569, -318.5502357873821, -318.5502440170298, -318.5502562882868, -318.5502471689238, -318.5502444618602, -318.550235342497, -318.5502772618536, -318.5502261980274, -318.5502654355374, -318.5502143714904, -318.5502110794532, -318.550292378012, -318.5501992530281, 
  -318.5502805515839, -318.5502285825595, -318.5502748764958, -318.5502167561339, -318.5502630500682, -318.5502627535052, -318.5502407036112, -318.5502509270775, -318.5502288771855, -318.5502289189613, -318.5502745387732, -318.5502170925344, -318.5502627123468, -318.5502785156928, -318.5502249411916, -318.5502666892665, -318.5502131147646, -318.5502465054397, -318.5502464585406, -318.5502451721705, -318.5502451252717, -318.5502466820647, -318.5502462819098, -318.5502453487946, -318.5502449486418, -318.5502331960114, -318.5502597679861, -318.5502318627351, -318.5502584347243, -318.5502463473247, -318.5502466166557, -318.5502450140556, -318.5502452833866, -318.5502466961156, -318.5502462679132, -318.5502453628471, -318.5502449346435, -318.550242367213, -318.5502505968612, -318.550241033944, 
  -318.5502492635921, -318.5502510416913, -318.5502419223283, -318.5502497084225, -318.5502405890591, -318.5502720153881, -318.5502209513019, -318.5502706819694, -318.5502196181826, -318.5502058328527, -318.5502871314217, -318.5502044995953, -318.5502857981409, -318.5502233359645, -318.5502696298999, -318.5502220026955, -318.5502682966307, -318.5502575069014, -318.550235457024, -318.550256173648, -318.5502341237394, -318.5502236723674, -318.5502692921763, -318.550222339095, -318.5502679589105, -318.5502732690973, -318.5502196945962, -318.5502719358287, -318.5502183613267, -318.5502460388778, -318.550245638724, -318.5502459919788, -318.550245591825, -318.5502325528215, -318.5502591248032, -318.5502325059223, -318.5502590779044, -318.5502457041383, -318.5502459734692, -318.5502456572393, 
  -318.5502459265703, -318.5502460529306, -318.5502456247254, -318.5502460060294, -318.5502455778286, -318.550241724027, -318.5502499536745, -318.5502416771274}
 {-391.8226827296006, -391.822685785889, -391.8226856651553, -391.8226797940643, -391.8226796733328, -391.822685732488, -391.822685718556, -391.8226797406643, -391.8226797267324, -391.8226858016045, -391.8226856494405, -391.8226798097787, -391.8226796576189, -391.8226872674462, -391.822684183617, -391.8226812756218, -391.8226781917942, -391.8226858155324, -391.8226856355115, -391.8226798237087, -391.8226796436879, -391.8226870313064, -391.8226844196828, -391.8226810394826, -391.8226784278591, -391.8226899914363, -391.8226814595977, -391.8226839996129, -391.8226754677737, -391.8226804675422, -391.8226909835122, -391.8226744757185, -391.8226849916885, -391.8226884195309, -391.8226830329338, -391.8226824277392, -391.8226770410783, -391.8226968790013, -391.8226745721947, -391.8226908871771, 
  -391.8226685803716, -391.822632951468, -391.8227385005186, -391.8226269596445, -391.8227325086948, -391.8226917237449, -391.8226797272636, -391.8226857319214, -391.8226737354399, -391.8226883528872, -391.8226830981821, -391.8226823610631, -391.8226771063588, -391.8226551994743, -391.8227162534516, -391.8226492076506, -391.822710261628, -391.8226827969331, -391.8226827830013, -391.8226826762005, -391.8226826622686, -391.8226828660494, -391.822682713886, -391.8226827453152, -391.8226825931549, -391.8226843318916, -391.8226812480621, -391.822684211158, -391.8226811273304, -391.8226828799776, -391.8226826999567, -391.822682759245, -391.8226825792241, -391.8226840957511, -391.8226814841284, -391.8226839750194, -391.8226813633949, -391.8226870558816, -391.8226785240429, -391.8226869351491, 
  -391.8226784033101, -391.8226775319874, -391.8226880479573, -391.8226774112547, -391.8226879272248, -391.8226854839792, -391.8226800973761, -391.8226853632724, -391.8226799766175, -391.8226939434463, -391.8226716366402, -391.8226938227135, -391.8226715159077, -391.8226300159133, -391.8227355649638, -391.8226298951807, -391.822735444231, -391.8226887881898, -391.8226767917093, -391.822688667458, -391.8226766709758, -391.8226854173328, -391.8226801626269, -391.8226852965989, -391.8226800418955, -391.8226522639196, -391.8227133178967, -391.8226521431868, -391.8227131971643, -391.822682812648, -391.8226826604863, -391.8226827987161, -391.8226826465542, -391.8226842784905, -391.822681194662, -391.8226842645586, -391.8226811807301, -391.822682826577, -391.8226826465562, -391.8226828126451, 
  -391.8226826326243, -391.8226840423519, -391.8226814307265, -391.8226840284182, -391.8226814167963, -391.8226870024812, -391.8226784706421, -391.822686988549}
 {-287.899975712111, -287.8998647321469, -287.8998602122779, -287.9000912119638, -287.9000866920541, -287.8998624110944, -287.8998625333425, -287.9000888908919, -287.9000890131382, -287.899874019657, -287.8998509248454, -287.9001004993937, -287.9000774047018, -287.8998658849039, -287.8998590595914, -287.900092364698, -287.9000855393904, -287.8998625334108, -287.8998624110266, -287.9000890132069, -287.9000888908235, -287.8998623691032, -287.8998625753833, -287.9000888489065, -287.9000890551731, -287.8998638272516, -287.8998611171954, -287.9000903070477, -287.9000875969924, -287.8998644948624, -287.8998604495921, -287.9000909746587, -287.9000869293891, -287.8995699710567, -287.9001549775767, -287.8997964472429, -287.9003814609838, -287.8999071090462, -287.8998178358407, -287.900133588855, 
  -287.900044315625, -287.8998448652644, -287.8998800801155, -287.9000713450563, -287.9001065599168, -287.8996300714677, -287.9000948773574, -287.8998565482793, -287.9003213601391, -287.8998609669416, -287.8998639776932, -287.9000874467632, -287.9000904574647, -287.8998726992295, -287.8998522452057, -287.9000991790233, -287.900078725005, -287.8999779109253, -287.8999780331731, -287.8999733910366, -287.8999735132832, -287.8999895194588, -287.8999664247051, -287.8999849995675, -287.8999619048177, -287.8999813847416, -287.8999745594153, -287.899976864836, -287.899970039542, -287.8999780332414, -287.8999779108574, -287.8999735133519, -287.8999733909683, -287.8999778689378, -287.8999780752102, -287.8999733490476, -287.8999735553218, -287.8999793270827, -287.8999766170257, -287.8999748071922, 
  -287.8999720971377, -287.8999799946932, -287.899975949423, -287.8999754748036, -287.8999714295339, -287.8996854690639, -287.9002704792311, -287.8996809492114, -287.9002659593051, -287.9000226089394, -287.8999333356091, -287.9000180889374, -287.8999288158324, -287.8999603650938, -287.8999955799477, -287.8999558452024, -287.8999910600604, -287.8997455698067, -287.9002103786801, -287.8997410499159, -287.9002058587922, -287.8999764667593, -287.8999794775369, -287.899971946921, -287.8999749575966, -287.8999881990594, -287.8999677450373, -287.899983679169, -287.8999632251491, -287.8999871983955, -287.899964103644, -287.8999873206429, -287.899964225891, -287.8999790636714, -287.899972238361, -287.8999791859183, -287.8999723606085, -287.8999757121792, -287.8999755897953, -287.8999758344262, 
  -287.8999757120426, -287.8999755478508, -287.8999757541729, -287.8999756701468, -287.8999758763713, -287.8999770060206, -287.8999742959636, -287.8999771282664}
 {-581.398449192889, -581.3984444528264, -581.398445305493, -581.3984530802911, -581.398453932964, -581.3984449178069, -581.3984448405124, -581.3984535452752, -581.39845346798, -581.3984440545399, -581.3984457037858, -581.3984526820126, -581.3984543312489, -581.3984469557933, -581.3984428025423, -581.3984555832599, -581.3984514300115, -581.3984448985648, -581.3984448597544, -581.3984535260329, -581.3984534872223, -581.3984532434056, -581.3984365150549, -581.3984618708277, -581.3984451425688, -581.3984464916778, -581.3984432666481, -581.3984551191455, -581.3984518941162, -581.3984466715091, -581.3984430868267, -581.3984552989759, -581.3984517142957, -581.3983983478844, -581.3984914117145, -581.3984069745861, -581.3985000399486, -581.3984413219819, -581.3984484364785, -581.3984499494539, 
  -581.3984570639425, -581.3984657520335, -581.3984240072268, -581.3984743794911, -581.3984326347052, -581.3984407599329, -581.3984489985328, -581.3984493872262, -581.3984576261754, -581.3984501217552, -581.3984396365433, -581.39845874922, -581.3984482640144, -581.3984527815228, -581.3984369769063, -581.3984614089958, -581.398445604369, -581.3984488052014, -581.3984487279066, -581.3984496578712, -581.3984495805763, -581.3984479419362, -581.3984495911783, -581.3984487946068, -581.3984504438471, -581.3984508431855, -581.3984466899387, -581.3984516958582, -581.3984475426055, -581.3984487859593, -581.3984487471489, -581.398449638629, -581.3984495998185, -581.3984571307787, -581.3984404024707, -581.3984579834452, -581.3984412551436, -581.3984503790734, -581.3984471540413, -581.3984512317406, 
  -581.3984480067136, -581.3984505589031, -581.3984469742215, -581.3984514115726, -581.3984478268914, -581.3984022349124, -581.3984952994754, -581.3984030875488, -581.3984961521784, -581.3984452093884, -581.3984523238608, -581.398446062038, -581.3984531765507, -581.3984696394245, -581.3984278946249, -581.3984704920908, -581.3984287472978, -581.3984446472464, -581.3984528860082, -581.3984454999032, -581.3984537386907, -581.3984540091481, -581.3984435239392, -581.3984548618178, -581.398444376609, -581.3984566689186, -581.3984408642993, -581.3984575215906, -581.3984417169668, -581.3984484069189, -581.3984500561601, -581.3984483296243, -581.3984499788653, -581.3984513081692, -581.3984471549196, -581.3984512308745, -581.3984470776247, -581.3984492509415, -581.398449212131, -581.3984491736468, 
  -581.3984491348362, -581.3984575957587, -581.3984408674552, -581.3984575184652, -581.3984407901591, -581.3984508440543, -581.398447619025, -581.3984507667597}
 {-235.8618577754994, -235.8618577965678, -235.8618579478678, -235.8618576031337, -235.8618577544355, -235.8618577877433, -235.8618579566924, -235.8618575943091, -235.8618577632601, -235.8618580477961, -235.8618576966401, -235.8618578543628, -235.8618575032069, -235.8618588900678, -235.8618568543702, -235.8618586966347, -235.861856660937, -235.8618579363334, -235.8618578081023, -235.8618577429002, -235.8618576146691, -235.8618578683796, -235.861857876056, -235.8618576749465, -235.8618576826227, -235.861857869665, -235.8618578747706, -235.8618576762319, -235.8618576813373, -235.8618578772935, -235.8618578671421, -235.8618576838605, -235.8618576737087, -235.8618624203283, -235.8618533243081, -235.8618622269976, -235.8618531307723, -235.8618565283039, -235.8618592161551, -235.8618563348677, 
  -235.861859022725, -235.8618578791877, -235.861857865248, -235.8618576857554, -235.8618576718139, -235.8618633671521, -235.861852377257, -235.8618631737056, -235.8618521838371, -235.8618636062695, -235.8618521381353, -235.8618634128363, -235.861851944702, -235.8618578732962, -235.8618578711394, -235.861857679863, -235.8618576777062, -235.8618576153741, -235.861857784324, -235.8618577666749, -235.8618579356251, -235.8618578754272, -235.8618575242713, -235.8618580267282, -235.8618576755723, -235.861858717699, -235.8618566820014, -235.861858869, -235.8618568333023, -235.8618577639646, -235.8618576357335, -235.8618579152655, -235.8618577870344, -235.8618576960108, -235.8618577036871, -235.8618578473118, -235.8618578549881, -235.8618576972963, -235.8618577024017, -235.8618578485972, 
  -235.8618578537027, -235.8618577049248, -235.8618576947732, -235.8618578562258, -235.8618578460741, -235.8618622480071, -235.8618531518916, -235.8618623993153, -235.8618533031853, -235.8618563559323, -235.8618590437892, -235.8618565072359, -235.8618591950874, -235.8618577068193, -235.8618576928789, -235.8618578581204, -235.8618578441797, -235.8618631947776, -235.8618522048939, -235.8618633460767, -235.8618523561967, -235.8618634339007, -235.8618519657664, -235.8618635852017, -235.8618521170674, -235.8618577009274, -235.8618576987705, -235.8618578522284, -235.8618578500715, -235.8618578666027, -235.8618575154468, -235.8618580355528, -235.8618576843968, -235.8618587088745, -235.8618566731768, -235.8618588778246, -235.8618568421269, -235.8618577551401, -235.861857626909, 
  -235.8618579240901, -235.861857795859, -235.8618576871863, -235.8618576948627, -235.8618578561364, -235.8618578638127, -235.8618576884717, -235.8618576935772, -235.8618578574218}
 {-386.8217338546701, -386.8217364247686, -386.8217360586803, -386.821731650664, -386.8217312845763, -386.8217362100784, -386.8217362733705, -386.8217314359741, -386.8217314992661, -386.8217359861187, -386.8217364973305, -386.8217312120146, -386.821731723226, -386.8217382436798, -386.8217342397752, -386.8217334695754, -386.8217294656709, -386.8217362610827, -386.8217362223661, -386.8217314869784, -386.8217314482619, -386.8217383910149, -386.8217340924478, -386.8217336169097, -386.8217293183445, -386.8217378620989, -386.8217346213557, -386.8217330879948, -386.8217298472513, -386.8217390995576, -386.8217333839088, -386.8217343254534, -386.8217286098046, -386.821745629611, -386.8217268546273, -386.8217408555758, -386.8217220804541, -386.8217278970066, -386.821744586537, -386.821723122905, 
  -386.8217398124301, -386.8217666604791, -386.8217058240434, -386.8217618863738, -386.8217010499401, -386.8217453357715, -386.8217271476587, -386.8217405616635, -386.8217223735583, -386.821745243475, -386.8217272399572, -386.8217404693708, -386.821722465853, -386.8217526105416, -386.821719873105, -386.8217478364374, -386.8217150990007, -386.821734006068, -386.8217340693602, -386.8217336399801, -386.8217337032722, -386.8217337821086, -386.82173429332, -386.8217334160204, -386.8217339272324, -386.8217360396694, -386.8217320357648, -386.8217356735813, -386.821731669677, -386.8217340570724, -386.8217340183558, -386.8217336909844, -386.8217336522679, -386.821736187004, -386.8217318884381, -386.8217358209162, -386.8217315223499, -386.8217356580885, -386.8217324173454, -386.8217352920007, 
  -386.8217320512572, -386.8217368955474, -386.8217311798985, -386.8217365294593, -386.8217308138105, -386.8217434256425, -386.8217246505753, -386.82174305954, -386.8217242845019, -386.8217256929937, -386.8217423825293, -386.8217253269134, -386.8217420164336, -386.8217644564684, -386.8217036200335, -386.8217640903803, -386.8217032539457, -386.8217431317571, -386.8217249436525, -386.8217427656734, -386.8217245775602, -386.8217430394648, -386.8217250359469, -386.8217426733767, -386.821724669859, -386.8217504065315, -386.8217176690946, -386.8217500404433, -386.8217173030068, -386.8217335674183, -386.82173407863, -386.8217336307105, -386.8217341419221, -386.8217358249793, -386.8217318210748, -386.8217358882715, -386.8217318843669, -386.8217338423823, -386.8217338036656, -386.8217339056743, 
  -386.8217338669578, -386.8217359723142, -386.8217316737476, -386.8217360356058, -386.8217317370402, -386.8217354433985, -386.8217322026551, -386.8217355066906}
 {-161.046753715567, -161.0467502280886, -161.0467496362015, -161.0467577949704, -161.0467572030766, -161.0467500531627, -161.0467498111273, -161.0467576200425, -161.0467573780044, -161.0467510490235, -161.0467488152733, -161.0467586158995, -161.0467563821542, -161.0467511618382, -161.0467487024579, -161.0467587287174, -161.0467562693355, -161.046749870005, -161.046749994285, -161.0467574368835, -161.0467575611633, -161.0467525861759, -161.0467472783364, -161.0467601530505, -161.0467548452187, -161.0467496563173, -161.0467502079798, -161.0467572231959, -161.046757774858, -161.0467516230241, -161.0467482412991, -161.046759189902, -161.046755808178, -161.0467735277982, -161.0467263370926, -161.0467810952296, -161.0467339034181, -161.0467453620307, -161.0467545023305, -161.0467529288943, 
  -161.0467620692239, -161.0467452895896, -161.046754575429, -161.0467528564751, -161.0467621423005, -161.0467508426663, -161.0467490216803, -161.0467584094081, -161.0467565886953, -161.0467548647157, -161.0467449995584, -161.0467624315946, -161.0467525664365, -161.0467648868053, -161.0467349772697, -161.0467724536841, -161.0467425441477, -161.0467541325307, -161.0467538904938, -161.0467535406402, -161.0467532986035, -161.0467551283894, -161.0467528946419, -161.0467545364993, -161.0467523027513, -161.0467552412062, -161.0467527818244, -161.0467546493151, -161.0467521899346, -161.0467539493723, -161.0467540736521, -161.0467533574819, -161.0467534817618, -161.0467566655414, -161.0467513577053, -161.0467560736507, -161.0467507658153, -161.0467537356846, -161.0467542873469, 
  -161.0467531437941, -161.0467536954566, -161.046755702391, -161.0467523206666, -161.0467551105008, -161.0467517287761, -161.0467776074489, -161.0467304161764, -161.0467770155446, -161.0467298243, -161.0467494413825, -161.0467585817133, -161.0467488495082, -161.0467579898068, -161.0467493689602, -161.0467586547929, -161.0467487770702, -161.0467580629023, -161.0467549219618, -161.0467531011192, -161.0467543300782, -161.0467525092221, -161.0467589440832, -161.0467490789254, -161.0467583521928, -161.0467484870351, -161.0467689661726, -161.0467390566368, -161.0467683742824, -161.0467384647463, -161.0467549534626, -161.0467527197149, -161.0467547114259, -161.0467524776781, -161.046755066279, -161.0467526068978, -161.0467548242422, -161.0467523648611, -161.0467537744454, -161.0467538987253, 
  -161.0467535324087, -161.0467536566885, -161.046756490614, -161.0467511827791, -161.046756248578, -161.0467509407415, -161.0467535607578, -161.04675411242, -161.0467533187209}
 {-334.6745588710079, -334.674560434545, -334.6745602980492, -334.67455744397, -334.674557307474, -334.674560353478, -334.6745603791162, -334.6745573629029, -334.6745573885413, -334.6745607227697, -334.6745600098273, -334.674557732192, -334.6745570192548, -334.6745640741095, -334.6745566585073, -334.674561083534, -334.6745536679327, -334.6745604301061, -334.6745603024881, -334.6745574395311, -334.6745573119129, -334.6745601608357, -334.6745605718147, -334.6745571702546, -334.6745575812457, -334.674562049748, -334.674558682855, -334.6745590591727, -334.6745556922801, -334.6745634144061, -334.6745573182174, -334.6745604238309, -334.6745543276424, -334.674567006693, -334.6745537264168, -334.6745640162149, -334.6745507357449, -334.6745481956597, -334.674572537146, -334.6745452050833, 
  -334.6745695465724, -334.6745927862223, -334.6745279479726, -334.6745897956475, -334.6745249573972, -334.6745659871142, -334.6745547454519, -334.6745629965349, -334.6745517548811, -334.6745689455339, -334.6745517870518, -334.6745659549592, -334.6745487964764, -334.6745808580069, -334.6745398745917, -334.6745778674323, -334.674536884016, -334.6745589264367, -334.674558952075, -334.6745587899408, -334.6745588155792, -334.6745592957278, -334.6745585827867, -334.6745591592306, -334.6745584462921, -334.6745626470683, -334.6745552314661, -334.6745625105719, -334.6745550949707, -334.6745590030649, -334.6745588754468, -334.6745588665691, -334.674558738951, -334.6745587337927, -334.6745591447752, -334.6745585972942, -334.6745590082818, -334.6745606227066, -334.6745572558139, -334.6745604862107, 
  -334.674557119318, -334.6745619873648, -334.6745558911762, -334.6745618508689, -334.6745557546804, -334.6745655797027, -334.6745522993248, -334.674565443202, -334.6745521628338, -334.6745467686155, -334.6745711101077, -334.6745466321241, -334.6745709736074, -334.6745913591813, -334.6745265209311, -334.6745912226852, -334.6745263844355, -334.6745645600704, -334.6745533184133, -334.6745644235755, -334.6745531819165, -334.674567518493, -334.6745503600103, -334.6745673819968, -334.6745502235147, -334.6745794309658, -334.6745384475503, -334.6745792944701, -334.6745383110541, -334.67455921466, -334.6745585017202, -334.6745592402983, -334.6745585273585, -334.6745625660009, -334.6745551503992, -334.6745625916392, -334.6745551760375, -334.6745589219978, -334.6745587943796, -334.6745589476361, 
  -334.674558820018, -334.6745586527246, -334.674559063709, -334.6745586783623, -334.6745590893479, -334.6745605416395, -334.6745571747467, -334.6745605672778}
 {-30.53281772276446, -30.53283281845758, -30.53283372898652, -30.53280171667084, -30.53280262718557, -30.53283314243862, -30.53283340500543, -30.53280204064651, -30.53280230320985, -30.53283566583358, -30.53283088162675, -30.53280456403259, -30.53279977984006, -30.53283425454512, -30.53283229290533, -30.53280315275285, -30.53280119110991, -30.53283322267157, -30.53283332477249, -30.53280212087773, -30.53280222297865, -30.53286510308507, -30.53280144472796, -30.53283400124054, -30.5327703429848, -30.53282984804335, -30.53283669940063, -30.53279874625197, -30.53280559760432, -30.53282797954723, -30.53283856790999, -30.53279687775258, -30.53280746611695, -30.53280257568148, -30.53286397235875, -30.53277147396345, -30.5328328704891, -30.53283363015752, -30.53283291735782, -30.53280252833758, 
  -30.53280181559007, -30.53278852598572, -30.53287802218704, -30.53275742420365, -30.53284692038142, -30.5328275539713, -30.53283899364701, -30.53279645250069, -30.53280789152992, -30.53283785081231, -30.53282869661947, -30.53280674902129, -30.5327975948228, -30.53280790539049, -30.5328586437049, -30.5327768036017, -30.532827541906, -30.53281713622107, -30.53281739878608, -30.53281804674284, -30.53281830930797, -30.53281965961287, -30.53281487541055, -30.53282057013206, -30.53281578593503, -30.53281824832697, -30.53281628668657, -30.53281915884977, -30.53281719720743, -30.53281721645313, -30.53281731855403, -30.53281812697494, -30.53281822907588, -30.53284909684049, -30.53278543853564, -30.53285000736389, -30.5327863490559, -30.53281384182503, -30.53282069318203, -30.53281475234905, 
  -30.53282160370168, -30.53281197332841, -30.53282256169191, -30.53281288385018, -30.5328234722138, -30.53278656950976, -30.53284796609357, -30.53278748001394, -30.53284887663305, -30.53281762393723, -30.5328169111412, -30.53281853443663, -30.53281782168546, -30.5327725197738, -30.53286201596206, -30.53277343029435, -30.53286292648518, -30.53281154792026, -30.53282298726113, -30.5328124584305, -30.53282389779456, -30.53282184459476, -30.53281269040011, -30.53282275511761, -30.53281360092093, -30.53279189917557, -30.53284263748291, -30.53279280969539, -30.53284354800676, -30.53281998358992, -30.53281519939023, -30.53282024615497, -30.53281546195531, -30.53281857230581, -30.53281661066445, -30.53281883487089, -30.53281687322952, -30.53281754043147, -30.53281764253241, -30.53281780299655, 
  -30.53281790509747, -30.53284942082194, -30.53278576251091, -30.5328496833824, -30.53278602508059, -30.5328141658044, -30.53282101715938, -30.53281442836965}
 {-292.610737592058, -292.6107367684357, -292.610726083441, -292.610749100765, -292.6107384156956, -292.6107312700408, -292.6107315818254, -292.6107436023316, -292.6107439141184, -292.6107362397091, -292.6107266121584, -292.6107485720045, -292.6107389444469, -292.6106776781437, -292.6107851740996, -292.6106900104377, -292.6107975063894, -292.6107313515619, -292.6107315003043, -292.6107436838537, -292.6107438325961, -292.6107071601719, -292.6107556919764, -292.6107194924729, -292.610768024259, -292.6107722401009, -292.6106906122526, -292.6107845723921, -292.6107029445451, -292.6107315601976, -292.6107312917068, -292.6107438924897, -292.6107436239985, -292.6107937285816, -292.6106691246799, -292.6108060620808, -292.6106814557644, -292.6107054232186, -292.6107574288157, -292.610717755483, 
  -292.6107697611351, -292.6107949298005, -292.6106679240296, -292.610807262104, -292.6106802563099, -292.6107452223215, -292.6107176296596, -292.6107575543574, -292.6107299622076, -292.6104489234049, -292.6110139339582, -292.6104612556951, -292.6110262662519, -292.6106869953655, -292.6107758609569, -292.6106993276563, -292.6107881932497, -292.6107427786861, -292.6107430904724, -292.6107320936546, -292.6107324054398, -292.6107477483603, -292.6107381207996, -292.6107370633217, -292.610727435774, -292.6106891867926, -292.6107966827431, -292.6106785017573, -292.6107859977142, -292.6107428602081, -292.6107430089504, -292.610732175176, -292.6107323239183, -292.6107186688238, -292.6107672006167, -292.6107079837894, -292.610756515587, -292.6107837487462, -292.6107021208996, -292.6107730637153, 
  -292.6106914358665, -292.6107430688439, -292.6107428003529, -292.6107323838118, -292.6107321153209, -292.6108052379456, -292.6106806326083, -292.6107945526851, -292.6106699478045, -292.6107169318223, -292.6107689375044, -292.6107062468478, -292.6107582524148, -292.6108064384551, -292.6106794326673, -292.6107957534177, -292.6106687476406, -292.6107567307766, -292.6107291384968, -292.6107460458707, -292.6107184533386, -292.6104604320488, -292.6110254426067, -292.6104497470196, -292.6110147575717, -292.6106985040113, -292.6107873696034, -292.6106878189789, -292.6107766845717, -292.6107422499427, -292.6107326223889, -292.6107425617287, -292.6107329341743, -292.6106836883769, -292.6107911843306, -292.6106840001625, -292.6107914961162, -292.6107373617938, -292.6107375105362, 
  -292.6107376735796, -292.610737822322, -292.6107131704085, -292.6107617022037, -292.6107134821941, -292.6107620139895, -292.6107782503331, -292.6106966224843, -292.6107785621177}
 {-327.5582904188641, -327.558299679272, -327.5582988109424, -327.5582820268417, -327.5582811585169, -327.5582992936297, -327.5582991965832, -327.5582816412019, -327.5582815441554, -327.5582998466275, -327.5582986435876, -327.5582821941923, -327.5582809911671, -327.5583035770642, -327.5582949132013, -327.558285924634, -327.5582772607758, -327.558299081623, -327.5582994085899, -327.5582814291952, -327.558281756162, -327.5583010663033, -327.5582974238424, -327.5582834138696, -327.5582797714203, -327.558288946101, -327.5583095441188, -327.5582712936734, -327.5582918916906, -327.5582905630242, -327.5583079272379, -327.5582729105964, -327.5582902748101, -327.5582709152123, -327.5583275792767, -327.5582532626186, -327.5583099270147, -327.5583197771731, -327.5582787134969, -327.5583021247458, 
  -327.5582610610685, -327.5584176548143, -327.5581808382265, -327.5584000023847, -327.5581631858006, -327.5583164986618, -327.5582819914568, -327.5582988462297, -327.5582643390334, -327.5583088886909, -327.5582896015693, -327.5582912362619, -327.5582719491426, -327.5582577730337, -327.5583407205151, -327.5582401206073, -327.5583230680859, -327.5582909015518, -327.5582908045051, -327.5582900332244, -327.5582899361781, -327.558291454548, -327.5582902515112, -327.5582905862164, -327.5582893831883, -327.5582951849874, -327.5582865211223, -327.5582943166557, -327.5582856527996, -327.558290689545, -327.5582910165119, -327.5582898212179, -327.5582901481847, -327.5582926742224, -327.5582890317673, -327.5582918058952, -327.5582881634401, -327.558280554024, -327.5583011520398, -327.5582796856951, 
  -327.5583002837144, -327.5582821709462, -327.55829953516, -327.5582813026191, -327.5582986668327, -327.5582625230083, -327.5583191873247, -327.5582616547672, -327.5583183189114, -327.5583113851002, -327.5582703214138, -327.5583105167634, -327.5582694530962, -327.5584092627359, -327.558172446149, -327.5584083944078, -327.5581715778228, -327.5583081065774, -327.5582735993853, -327.5583072382588, -327.5582727310495, -327.5583004966146, -327.5582812094896, -327.5582996282829, -327.558280341167, -327.5582493809556, -327.5583323284373, -327.5582485126302, -327.5583314601082, -327.5582910689048, -327.5582898658721, -327.5582909718581, -327.5582897688258, -327.5582947993441, -327.5582861354834, -327.5582947022975, -327.5582860384371, -327.558290303904, -327.5582906308709, -327.5582902068575, 
  -327.5582905338243, -327.5582922885836, -327.558288646124, -327.5582921915325, -327.558288549082, -327.5582801683824, -327.5583007663993, -327.5582800713353}
 {-311.8118241049893, -311.8118302688338, -311.8118294278742, -311.8118187821421, -311.8118179411844, -311.8118298621858, -311.8118298345211, -311.811818375495, -311.8118183478305, -311.811830535731, -311.8118291609766, -311.8118190490335, -311.8118176742927, -311.811830979569, -311.8118287171737, -311.8118194928767, -311.8118172304847, -311.8118298250799, -311.811829871627, -311.8118183383892, -311.8118183849364, -311.8118301135733, -311.8118295831542, -311.8118186268839, -311.8118180964622, -311.8118285107659, -311.8118311859545, -311.8118170240755, -311.8118196992635, -311.8118318148895, -311.8118278818362, -311.8118203281988, -311.8118163951455, -311.8118060684745, -311.8118536310818, -311.8117945815972, -311.8118421445776, -311.8118520567001, -311.8118076403104, -311.8118405700102, 
  -311.8117961536189, -311.8118460656935, -311.8118136319562, -311.811834579002, -311.8118021452663, -311.811840917848, -311.8118187788043, -311.8118294311504, -311.8118072921205, -311.8118319056399, -311.811827791179, -311.8118204189493, -311.8118163044882, -311.8118410691338, -311.8118186275308, -311.8118295824433, -311.8118071408398, -311.8118245393016, -311.8118245116369, -311.8118236983428, -311.8118236706783, -311.8118252128448, -311.8118238380942, -311.8118243718831, -311.8118229971386, -311.8118256566859, -311.8118233942884, -311.8118248157233, -311.8118225533336, -311.8118245021956, -311.8118245487428, -311.8118236612369, -311.8118237077841, -311.8118247906896, -311.8118242602693, -311.8118239497309, -311.8118234193106, -311.8118231878817, -311.8118258630701, -311.8118223469231, 
  -311.8118250221114, -311.8118264920052, -311.811822558952, -311.8118256510466, -311.8118217179933, -311.8118007454622, -311.8118483083256, -311.8117999045732, -311.8118474672972, -311.8118467338207, -311.8118023174213, -311.8118458928531, -311.8118014764716, -311.8118407428091, -311.811808309072, -311.8118399018499, -311.8118074681139, -311.811835594956, -311.8118134559279, -311.811834754006, -311.8118126149604, -311.8118265827569, -311.8118224682934, -311.8118257417958, -311.8118216273372, -311.8118357462495, -311.8118133046466, -311.8118349052911, -311.8118124636876, -311.8118248061958, -311.8118234314482, -311.8118247785312, -311.8118234037836, -311.8118252500364, -311.8118229876427, -311.8118252223717, -311.8118229599782, -311.811824095548, -311.8118241420952, -311.8118240678835, 
  -311.8118241144306, -311.8118243840432, -311.8118238536205, -311.8118243563763, -311.8118238259583, -311.8118227812344, -311.8118254564222, -311.8118227535693}
 {-334.4811112966332, -334.481113431705, -334.481113916386, -334.4811086768979, -334.4811091615816, -334.4811136543992, -334.481113693691, -334.4811088995935, -334.4811089388854, -334.4811132943357, -334.4811140537574, -334.4811085395334, -334.4811092989484, -334.481115373628, -334.4811119745076, -334.4811106188213, -334.4811072197028, -334.4811135831306, -334.4811137649597, -334.481108828325, -334.481109010154, -334.481112605526, -334.4811147426669, -334.4811078507324, -334.481109987849, -334.4811110309676, -334.4811163171618, -334.4811062761615, -334.4811115623563, -334.481117166054, -334.4811101820759, -334.4811124112481, -334.4811054272705, -334.4811230900361, -334.4811042594471, -334.481118335452, -334.4810995044198, -334.48112719525, -334.4811001531194, -334.4811224404446, 
  -334.4810953983134, -334.4811381326887, -334.4810892171159, -334.4811333778884, -334.4810844623048, -334.4811191118822, -334.4811082361828, -334.4811143570646, -334.481103481389, -334.4811265025421, -334.481100845536, -334.4811217477341, -334.4810960907325, -334.4811392771466, -334.4810880707121, -334.4811345223389, -334.4810833159084, -334.4811110346464, -334.4811110739382, -334.4811115193287, -334.4811115586206, -334.4811106745844, -334.4811114340032, -334.4811111592672, -334.4811119186851, -334.4811127538746, -334.4811093547553, -334.481113238557, -334.4811098394376, -334.4811109633778, -334.4811111452069, -334.4811114480601, -334.4811116298892, -334.4811099857759, -334.4811121229113, -334.4811104704649, -334.4811126075869, -334.4811084112147, -334.4811136974091, -334.4811088958969, 
  -334.4811141820915, -334.4811145463011, -334.4811075623232, -334.4811150309835, -334.4811080470056, -334.4811204703658, -334.4811016396117, -334.4811209551047, -334.4811021242375, -334.4811245754936, -334.4810975333702, -334.4811250601834, -334.481098018045, -334.481135512937, -334.4810865973621, -334.4811359976227, -334.481087082041, -334.4811164921262, -334.4811056164333, -334.4811169768032, -334.4811061011209, -334.4811238827889, -334.4810982257836, -334.4811243674698, -334.4810987104674, -334.4811366573933, -334.4810854509597, -334.4811371420745, -334.4810859356431, -334.4811108972793, -334.481111656698, -334.4811109365715, -334.4811116959896, -334.4811129765696, -334.4811095774502, -334.4811130158614, -334.481109616742, -334.4811111860726, -334.4811113679018, -334.4811112253646, 
  -334.4811114071937, -334.4811102084745, -334.4811123456024, -334.4811102477656, -334.4811123848952, -334.4811086339094, -334.4811139201041, -334.4811086732014}
 {-332.4790540466616, -332.4790617902415, -332.4790613450825, -332.4790467482799, -332.4790463031246, -332.4790615643669, -332.4790615709561, -332.479046522407, -332.4790465289966, -332.4790619171737, -332.4790612181519, -332.4790468752094, -332.4790461761965, -332.47906655729, -332.4790565780769, -332.4790515153288, -332.4790415361186, -332.4790616430131, -332.47906149231, -332.4790466010533, -332.4790464503502, -332.4790614082926, -332.4790617270698, -332.4790463663369, -332.4790466851059, -332.4790654838181, -332.4790576515265, -332.4790504418588, -332.4790426095664, -332.4790665380077, -332.4790565973607, -332.4790514960481, -332.4790415554009, -332.4790662789003, -332.4790568597431, -332.479051237021, -332.4790418177031, -332.4790620446424, -332.4790610910424, -332.4790470026819, 
  -332.4790460490835, -332.4790759327557, -332.4790472050845, -332.4790608907968, -332.4790321631239, -332.4790795327989, -332.4790436024185, -332.4790644908392, -332.4790285604586, -332.4790744715604, -332.4790486637517, -332.4790594296, -332.4790336217927, -332.4790915852452, -332.4790315501184, -332.4790765432851, -332.4790165081589, -332.4790542659458, -332.4790542725354, -332.4790538207888, -332.4790538273781, -332.4790546187521, -332.4790539197316, -332.4790541735918, -332.4790534745776, -332.4790592588695, -332.4790492796555, -332.4790588137101, -332.4790488345007, -332.4790543445922, -332.4790541938891, -332.4790538994351, -332.479053748732, -332.4790541098736, -332.479054428647, -332.4790536647168, -332.4790539834896, -332.479058185397, -332.4790503531058, -332.4790577402406, 
  -332.479049907948, -332.479059239587, -332.4790492989398, -332.4790587944297, -332.4790488537827, -332.4790589805203, -332.4790495612815, -332.4790585353618, -332.4790491161257, -332.4790547462197, -332.4790537926233, -332.4790543010656, -332.4790533474633, -332.4790686343352, -332.4790399066631, -332.479068189178, -332.479039461506, -332.4790722343759, -332.4790363039996, -332.479071789223, -332.4790358588383, -332.4790671731405, -332.4790413653299, -332.4790667279808, -332.4790409201754, -332.4790842868244, -332.4790242516975, -332.4790838416669, -332.4790238065408, -332.4790543928767, -332.4790536938594, -332.4790543994661, -332.4790537004488, -332.4790590329946, -332.4790490537829, -332.479059039584, -332.4790490603723, -332.4790541187185, -332.4790539680154, -332.4790541253078, 
  -332.4790539746048, -332.4790538840013, -332.4790542027718, -332.4790538905882, -332.4790542093638, -332.4790579595238, -332.4790501272317, -332.4790579661129}
 {-372.1117068653327, -372.1117081544038, -372.1117081553798, -372.1117055752902, -372.1117055762664, -372.1117081248455, -372.1117081849381, -372.1117055457317, -372.1117056058249, -372.1117080380891, -372.111708271695, -372.1117054589756, -372.1117056925816, -372.1117113638424, -372.1117049459458, -372.1117087847289, -372.1117023668323, -372.1117081227914, -372.1117081869922, -372.1117055436779, -372.1117056078788, -372.1117060389128, -372.1117102708982, -372.1117034598005, -372.1117076917837, -372.111708160669, -372.1117081491173, -372.1117055815554, -372.1117055700039, -372.1117105649792, -372.1117057448201, -372.1117079858657, -372.1117031657066, -372.1116968184103, -372.1117194920358, -372.111694239056, -372.1117169131632, -372.111705834923, -372.1117104749403, -372.1117032558143, 
  -372.1117078958221, -372.1116922775123, -372.1117240331929, -372.111689698397, -372.1117214540814, -372.1117186452688, -372.1116976644709, -372.1117160661346, -372.1116950853781, -372.1117081581892, -372.1117081517414, -372.1117055790756, -372.1117055726279, -372.1117351838531, -372.1116811256339, -372.1117326047394, -372.1116785465206, -372.1117068347983, -372.1117068948912, -372.1117068357743, -372.1117068958672, -372.1117067480422, -372.1117069816478, -372.1117067490179, -372.1117069826242, -372.1117100737952, -372.1117036558987, -372.1117100747713, -372.1117036568748, -372.1117068327443, -372.1117068969452, -372.1117068337203, -372.1117068979213, -372.1117047488664, -372.1117089808506, -372.1117047498423, -372.1117089818267, -372.1117068706218, -372.1117068590703, 
  -372.1117068715979, -372.1117068600463, -372.1117092749321, -372.1117044547731, -372.1117092759081, -372.1117044557491, -372.1116955282434, -372.1117182021085, -372.1116955292183, -372.1117182030857, -372.1117045448831, -372.1117091848862, -372.1117045458497, -372.1117091858717, -372.1116909874644, -372.1117227431468, -372.1116909884403, -372.111722744123, -372.1117173552115, -372.1116963744341, -372.1117173561873, -372.1116963754104, -372.1117068681421, -372.1117068616943, -372.1117068691181, -372.1117068626704, -372.1117338938059, -372.1116798355869, -372.1117338947819, -372.111679836563, -372.1117067184836, -372.1117069520896, -372.1117067785765, -372.1117070121825, -372.1117100442368, -372.1117036263402, -372.1117101043298, -372.1117036864332, -372.1117068031858, -372.1117068673867, 
  -372.1117068632787, -372.1117069274796, -372.1117047193079, -372.111708951292, -372.1117047794008, -372.1117090113851, -372.1117068410634, -372.1117068295118, -372.1117069011564}
 {-296.8539369743439, -296.8539371608035, -296.8539375878941, -296.85393636081, -296.8539367879054, -296.8539373507596, -296.8539373979378, -296.8539365507683, -296.853936597947, -296.8539369874173, -296.8539377612828, -296.8539361874281, -296.8539369612898, -296.8539395507803, -296.853935197935, -296.8539387507886, -296.8539343979446, -296.8539373664108, -296.8539373822866, -296.8539365664197, -296.8539365822955, -296.8539343203555, -296.8539404284147, -296.8539335203759, -296.8539396284121, -296.8539366390888, -296.8539381096185, -296.8539358390976, -296.8539373096275, -296.8539395463335, -296.8539352023829, -296.8539387463426, -296.8539344023916, -296.8539047526837, -296.8539699974395, -296.8539039522715, -296.8539691978695, -296.853933437939, -296.8539413109108, -296.8539326379515, 
  -296.8539405109161, -296.8539232349768, -296.8539515146633, -296.8539224349799, -296.853950714678, -296.8539385455194, -296.8539362032292, -296.8539377454677, -296.8539354032987, -296.8539422380202, -296.8539325106623, -296.8539414380271, -296.8539317106731, -296.8539496730983, -296.8539250755063, -296.8539488731056, -296.8539242755168, -296.8539367372083, -296.8539367843868, -296.8539371643012, -296.8539372114797, -296.8539363738677, -296.8539371477301, -296.8539368009595, -296.8539375748242, -296.8539389372283, -296.8539345843847, -296.8539393643224, -296.8539350114765, -296.8539367528597, -296.8539367687354, -296.8539371799526, -296.8539371958284, -296.8539337068101, -296.8539398148577, -296.8539341339029, -296.8539402419508, -296.8539360255371, -296.8539374960678, -296.853936452631, 
  -296.8539379231598, -296.8539389327824, -296.8539345888316, -296.8539393598754, -296.8539350159245, -296.8539041389361, -296.8539693840847, -296.8539045660008, -296.8539698112059, -296.853932824395, -296.8539406973524, -296.8539332514771, -296.8539411244562, -296.853922621424, -296.8539509011138, -296.8539230485145, -296.8539513282092, -296.8539379319413, -296.8539355897049, -296.8539383590275, -296.8539360168046, -296.853941624468, -296.8539318971121, -296.853942051561, -296.853932324205, -296.8539490595468, -296.8539244619554, -296.8539494866389, -296.8539248890494, -296.8539365638243, -296.8539373376878, -296.8539366110027, -296.8539373848663, -296.853939127186, -296.8539347743413, -296.8539391743645, -296.8539348215197, -296.8539369428168, -296.8539369586925, -296.8539369899953, 
  -296.853937005871, -296.8539338967674, -296.8539400048146, -296.8539339439453, -296.8539400519937, -296.8539362154947, -296.8539376860246, -296.8539362626732}
 {-275.1164000796886, -275.1164024597826, -275.1164023357824, -275.1163978236054, -275.1163976996037, -275.1164024031677, -275.116402392397, -275.11639776699, -275.1163977562189, -275.1164027190009, -275.1164020765648, -275.1163980828216, -275.1163974403882, -275.1164040639501, -275.1164007316251, -275.1163994277726, -275.1163960954468, -275.116402362455, -275.1164024331097, -275.1163977262772, -275.1163977969317, -275.1164034853123, -275.1164013102753, -275.1163988491303, -275.1163966741014, -275.1164016403685, -275.1164031552052, -275.1163970041908, -275.1163985190271, -275.1164041128714, -275.1164006827082, -275.1163994766933, -275.1163960465305, -275.1164061817519, -275.1163986146801, -275.1164015456761, -275.1163939784, -275.1163987965902, -275.1164059990752, -275.116394160409, 
  -275.1164013629006, -275.1163898212561, -275.1164149751813, -275.1163851850804, -275.1164103390011, -275.1164083950868, -275.1163964004424, -275.1164037589063, -275.116391764267, -275.1164074383865, -275.1163973571611, -275.1164028022089, -275.1163927209828, -275.1164151040045, -275.1163896914492, -275.116410467827, -275.1163850552708, -275.1164001470747, -275.1164001363038, -275.1164000230736, -275.1164000123028, -275.1164004629073, -275.1163998204721, -275.1164003389058, -275.1163996964715, -275.1164018078573, -275.1163984755315, -275.116401683856, -275.1163983515309, -275.1164001063619, -275.1164001770165, -275.1163999823609, -275.1164000530155, -275.1164012292169, -275.1163990541843, -275.1164011052162, -275.116398930183, -275.1163993842754, -275.1164008991119, -275.1163992602744, 
  -275.116400775111, -275.1164018567781, -275.1163984266152, -275.1164017327772, -275.1163983026141, -275.1164039257201, -275.1163963585255, -275.1164038016985, -275.1163962345451, -275.1163965404943, -275.1164037429849, -275.1163964164955, -275.1164036189816, -275.1163875651642, -275.1164127190869, -275.1163874411629, -275.1164125950861, -275.1164061389917, -275.1163941443512, -275.116406014992, -275.1163940203489, -275.1164051822938, -275.1163951010674, -275.1164050582921, -275.1163949770672, -275.1164128479116, -275.1163874353558, -275.1164127239106, -275.1163873113547, -275.1164004062918, -275.1163997638571, -275.116400395521, -275.1163997530862, -275.116401751242, -275.1163984189165, -275.1164017404711, -275.1163984081456, -275.1164000497467, -275.1164001204013, -275.1164000389758, 
  -275.1164001096304, -275.1164011726021, -275.1163989975687, -275.1164011618308, -275.1163989867982, -275.1163993276602, -275.1164008424967, -275.1163993168893}
 {-375.2406502966055, -375.2406533284049, -375.2406507381947, -375.240649855039, -375.2406472648122, -375.2406519886033, -375.2406520779862, -375.2406485152287, -375.2406486046122, -375.2406537660502, -375.240650300538, -375.2406502926728, -375.2406468271669, -375.240600896163, -375.240703170708, -375.24059742279, -375.2406996973325, -375.2406524391462, -375.2406516274431, -375.240648965772, -375.2406481540689, -375.2406477105182, -375.2406563560809, -375.24064423715, -375.2406528827007, -375.2406896419119, -375.2406144251384, -375.2406861685377, -375.2406109517641, -375.2406458508039, -375.2406582158065, -375.2406423774296, -375.2406547424322, -375.2406663782226, -375.2406376890547, -375.2406629050419, -375.240634215487, -375.2406218007063, -375.2406822659656, -375.2406183273283, 
  -375.240678792595, -375.2407023354216, -375.2406017320946, -375.2406988620494, -375.2405982587183, -375.2406629389306, -375.2406411276071, -375.2406594655447, -375.2406376542446, -375.2406084275404, -375.2406956399874, -375.2406049541674, -375.240692166612, -375.2406140712075, -375.240689998102, -375.2406105978327, -375.2406865247285, -375.240651547028, -375.2406516364117, -375.2406489568102, -375.2406490461927, -375.2406533244732, -375.2406498589655, -375.240650734256, -375.2406472687456, -375.24060045459, -375.2407027291313, -375.2405978643691, -375.2407001389154, -375.2406519975714, -375.2406511858683, -375.240649407353, -375.2406485956498, -375.240647268948, -375.2406559145014, -375.2406446787263, -375.2406533242862, -375.2406892003366, -375.240613983564, -375.2406866101191, 
  -375.2406113933447, -375.2406454092292, -375.2406577742316, -375.2406428190105, -375.2406551840134, -375.240665936828, -375.2406372472998, -375.2406633464427, -375.2406346572481, -375.2406213591211, -375.2406818244012, -375.2406187689197, -375.2406792341656, -375.2407018938496, -375.240601290517, -375.2406993036276, -375.240598700302, -375.2406624973341, -375.240640686054, -375.2406599071473, -375.2406380958039, -375.2406079859666, -375.2406951984118, -375.2406053957474, -375.2406926081939, -375.2406136296325, -375.2406895565277, -375.240611039414, -375.2406869663092, -375.2406519846679, -375.2406485191588, -375.240652074051, -375.2406486085421, -375.2405991147829, -375.2407013893267, -375.240599204166, -375.2407014787097, -375.2406506577655, -375.2406498460624, -375.2406507471486, 
  -375.2406499354455, -375.2406459291405, -375.2406545746972, -375.2406460185236, -375.2406546640803, -375.2406878605313, -375.2406126437575, -375.2406879499142}
 {-228.8211940103906, -228.821193480124, -228.8211931182417, -228.8211949025727, -228.8211945406893, -228.8211933392714, -228.821193259094, -228.8211947617199, -228.8211946815418, -228.8211946517213, -228.8211919466506, -228.8211960741622, -228.821193369106, -228.821198785787, -228.8211878126022, -228.8212002082351, -228.8211892350504, -228.821193290326, -228.8211933080395, -228.8211947127741, -228.8211947304876, -228.8212036114279, -228.8211829870776, -228.8212050338518, -228.8211844095499, -228.8211939744183, -228.8211926239576, -228.8211953968671, -228.8211940464051, -228.8211975626496, -228.8211890357434, -228.8211989850973, -228.8211904581921, -228.8212462495585, -228.8211403507755, -228.8212476729675, -228.8211417722629, -228.8211842179991, -228.8212023805911, -228.8211856404312, 
  -228.8212038030554, -228.8211590042339, -228.8212275956409, -228.8211604266932, -228.821229018078, -228.8212037692003, -228.8211828291942, -228.821205191499, -228.8211842517918, -228.8212090371568, -228.8211775611447, -228.8212104596069, -228.8211789835909, -228.8212106002999, -228.8211759982194, -228.8212120227509, -228.8211774206647, -228.8211942314211, -228.8211941512433, -228.8211938695382, -228.8211937893605, -228.8211955438675, -228.8211928388034, -228.821195181984, -228.8211924769213, -228.8211996779371, -228.821188704751, -228.821199316053, -228.8211883428695, -228.8211941824755, -228.8211942001889, -228.8211938205927, -228.8211938383061, -228.8212045035663, -228.8211838792381, -228.8212041416814, -228.8211835173575, -228.8211948665688, -228.8211935161062, -228.8211945046847, 
  -228.8211931542246, -228.8211984547989, -228.8211899278932, -228.8211980929161, -228.8211895660104, -228.8212471421908, -228.8211412424423, -228.8212467803032, -228.8211408805642, -228.821185110126, -228.8212032727632, -228.8211847482723, -228.8212029108513, -228.8211598963879, -228.8212284877859, -228.8211595345072, -228.8212281259009, -228.8212046612737, -228.8211837214198, -228.8212042993937, -228.8211833595342, -228.8212099293077, -228.8211784532928, -228.821209567424, -228.8211780914108, -228.8212114924502, -228.8211768903681, -228.8212111305687, -228.821176528484, -228.8211954030145, -228.8211926979511, -228.8211953228367, -228.8211926177733, -228.8211995370839, -228.821188563899, -228.821199456906, -228.8211884837212, -228.8211940416228, -228.8211940593363, -228.821193961445, 
  -228.8211939791585, -228.8212043627126, -228.8211837383865, -228.8212042825348, -228.8211836582088, -228.8211947257156, -228.8211933752541, -228.8211946455376}
 {-34.53941864341562, -34.53943681707778, -34.53943951055341, -34.5393977763803, -34.53940046984575, -34.53943833054814, -34.53943799708405, -34.53939928984408, -34.53939895638298, -34.53943981580538, -34.53943651183086, -34.53940077509765, -34.53939747113344, -34.5394393068648, -34.53943702077527, -34.53940026616337, -34.53939798007156, -34.53943821044027, -34.53943811719197, -34.53939916973762, -34.5393990764895, -34.5394406699305, -34.53943565773763, -34.53940162921902, -34.53939661704398, -34.53943673263897, -34.53943959500118, -34.53939769193695, -34.53940055429807, -34.53944132553244, -34.53943500212654, -34.53940228483022, -34.53939596142362, -34.53934581032255, -34.53953051796034, -34.53930676879294, -34.53949147808486, -34.53944103403386, -34.53943529367577, -34.53940199331488, 
  -34.53939625298962, -34.53941759684155, -34.53945873155729, -34.5393785561462, -34.53941969084752, -34.53936163944307, -34.53951468963456, -34.5393225991514, -34.53947564852108, -34.53944302082111, -34.53943330678963, -34.53940398012082, -34.53939426608479, -34.53944652573605, -34.5394298019845, -34.53940748503487, -34.53939076128056, -34.53941746341107, -34.53941712994853, -34.53942015688167, -34.53941982341903, -34.53941894867107, -34.53941564469259, -34.53942164213249, -34.53941833817225, -34.53941843972758, -34.53941615363992, -34.53942113320113, -34.53941884710744, -34.53941734330406, -34.53941725005561, -34.53942003677436, -34.5394199435264, -34.53941980278911, -34.53941479060644, -34.53942249626094, -34.5394174840757, -34.53941586550167, -34.5394187278659, -34.53941855897477, 
  -34.53942142133389, -34.53942045839617, -34.53941413499023, -34.53942315186703, -34.53941682846046, -34.5393249427842, -34.53950965122613, -34.53932763623182, -34.53951234471961, -34.53942016692055, -34.5394144265165, -34.53942286032872, -34.53941712004942, -34.53939672971057, -34.5394378644157, -34.53939942317773, -34.53944055788964, -34.53934077253108, -34.53949382227397, -34.53934346596394, -34.5394965157822, -34.53942215368309, -34.53941243965507, -34.53942484715938, -34.53941513311988, -34.53942565860173, -34.53940893484626, -34.53942835206973, -34.53941162831934, -34.53942046213366, -34.53941715816414, -34.53942012867091, -34.53941682470171, -34.53941995319613, -34.53941766710551, -34.53941961973359, -34.53941733364287, -34.53941885677101, -34.53941876352281, -34.53941852330843, 
  -34.5394184300602, -34.5394213162631, -34.53941630406659, -34.53942098278796, -34.53941597061656, -34.5394173789697, -34.53942024133201, -34.53941704550775}
 {-193.1297110860515, -193.1297067769608, -193.129707987928, -193.1297141842034, -193.1297153951849, -193.1297072571104, -193.129707507778, -193.1297146643588, -193.1297149150291, -193.1297061214507, -193.1297086434443, -193.1297135287009, -193.1297160506934, -193.1297080928801, -193.129706672022, -193.1297155001292, -193.1297140792723, -193.1297073055471, -193.1297074593413, -193.1297147127968, -193.129714866591, -193.1296918670706, -193.1297228980542, -193.1296992743246, -193.1297303052996, -193.1297033009551, -193.129711463952, -193.1297107082046, -193.1297188712019, -193.1297047965563, -193.1297099683739, -193.1297122038062, -193.1297173756234, -193.1297315974606, -193.1296831681488, -193.1297390053455, -193.1296905747633, -193.1297086050705, -193.1297061599044, -193.1297160123027, 
  -193.1297135671716, -193.1297392857471, -193.1296754801134, -193.1297466930042, -193.1296828873557, -193.1297131657443, -193.1297015991856, -193.1297205728494, -193.1297090065799, -193.1297179379879, -193.1296968268555, -193.129725345237, -193.1297042341058, -193.1297021869007, -193.1297125791873, -193.12970959415, -193.1297199864374, -193.1297103552301, -193.129710605899, -193.1297115662043, -193.1297118168735, -193.1297092195713, -193.1297117415643, -193.1297104305457, -193.1297129525386, -193.1297111909999, -193.1297097701429, -193.1297124019747, -193.1297109811168, -193.1297104036674, -193.1297105574617, -193.1297116146418, -193.129711768436, -193.1296949651931, -193.1297259961724, -193.1296961761674, -193.1297272071468, -193.1297063990753, -193.1297145620725, -193.1297076100498, 
  -193.1297157730467, -193.1297078946768, -193.1297130664941, -193.1297091056511, -193.1297142774686, -193.1297346958819, -193.1296862659682, -193.1297359068895, -193.1296874769093, -193.1297117031734, -193.1297092580422, -193.1297129141651, -193.1297104689992, -193.1297423838705, -193.1296785782306, -193.1297435948461, -193.1296797892038, -193.1297162637998, -193.1297046973708, -193.1297174747593, -193.12970590836, -193.129721036108, -193.1296999249761, -193.1297222470823, -193.1297011359506, -193.129705285021, -193.1297156773078, -193.1297064959952, -193.1297168882823, -193.1297096997238, -193.1297122217168, -193.1297099503928, -193.1297124723858, -193.1297116711526, -193.1297102502952, -193.1297119218216, -193.1297105009642, -193.12971088382, -193.1297110376142, -193.129711134489, 
  -193.1297112882832, -193.1296954453455, -193.129726476325, -193.1296956960146, -193.1297267269938, -193.1297068792278, -193.129715042225, -193.1297071298969}
 {-887.037805976613, -887.037712108682, -887.037714180179, -887.037897773048, -887.037899844533, -887.037713113161, -887.037713175709, -887.037898777522, -887.037898840069, -887.037716526062, -887.037709762863, -887.037902190413, -887.037895427233, -887.037718728658, -887.037707560248, -887.037904393021, -887.037893224605, -887.037713158646, -887.037713130224, -887.037898823007, -887.037898794585, -887.037721953307, -887.037704337364, -887.037907617583, -887.037890001808, -887.037713532094, -887.037712756785, -887.037899196453, -887.037898421147, -887.037717159722, -887.037709129184, -887.037902824081, -887.037894793546, -887.037405292665, -887.038020999057, -887.037590953371, -887.038206667072, -887.037729295133, -887.037696994042, -887.037914959522, -887.037882658374, -887.037721559381, 
  -887.037704731375, -887.037907223692, -887.037890395784, -887.0375257417, -887.037900550678, -887.037711403659, -887.03808621744, -887.037722420909, -887.037703867902, -887.037908085275, -887.037889532257, -887.037733744551, -887.037692544314, -887.037919408915, -887.03787820867, -887.037804909588, -887.037804972136, -887.037806981079, -887.037807043626, -887.037808322484, -887.037801559295, -887.037810393975, -887.037803630786, -887.037810525081, -887.037799356678, -887.037812596583, -887.037801428158, -887.037804955073, -887.037804926651, -887.037807026564, -887.037806998142, -887.037813749704, -887.037796133821, -887.037815821171, -887.037798205335, -887.037805328524, -887.03780455321, -887.037807400009, -887.037806624707, -887.037808956149, -887.037800925612, -887.037811027639, 
  -887.037802997103, -887.037497087292, -887.038112797283, -887.037499158728, -887.03811486883, -887.037821091627, -887.037788790403, -887.037823163013, -887.037790861998, -887.037813355794, -887.037796527816, -887.037815427264, -887.037798599328, -887.037617536961, -887.037992348271, -887.037619608382, -887.037994419832, -887.037814217319, -887.037795664346, -887.03781628885, -887.037797735797, -887.037825540978, -887.03778434074, -887.037827612472, -887.037786412228, -887.037809326961, -887.037802563772, -887.037809389509, -887.037802626319, -887.037811529563, -887.03780036115, -887.037811592111, -887.037800423697, -887.03780595955, -887.037805931128, -887.037806022098, -887.037805993676, -887.037814754161, -887.037797138317, -887.037814816724, -887.037797200849, -887.037806332997, 
  -887.037805557691, -887.037806395546}
 {-289.1446795049178, -289.1446814400695, -289.144681445627, -289.1446775642167, -289.1446775697761, -289.1446814529226, -289.1446814327737, -289.1446775770708, -289.1446775569218, -289.144680905518, -289.144681980179, -289.1446770296674, -289.1446781043259, -289.1446828082979, -289.144680077409, -289.144678932446, -289.1446762015572, -289.1446814954562, -289.1446813902401, -289.1446776196043, -289.1446775143883, -289.1446835542055, -289.1446793315153, -289.1446796783486, -289.1446754556686, -289.1446825627401, -289.1446803229625, -289.1446786868884, -289.1446764471105, -289.1446830881143, -289.1446797975954, -289.1446792122624, -289.1446759217436, -289.1446860311813, -289.1446768553169, -289.1446821554843, -289.1446729793103, -289.1446904015754, -289.1446724842145, -289.1446865257197, 
  -289.1446686083666, -289.1446654704995, -289.1446974160436, -289.1446615946498, -289.1446935401896, -289.1446872362013, -289.1446756494632, -289.1446833603417, -289.1446717736191, -289.1446827319943, -289.1446801537527, -289.1446788561418, -289.1446762779016, -289.1446919009182, -289.1446709847708, -289.1446880250668, -289.1446671089184, -289.1446795122131, -289.1446794920642, -289.1446795177716, -289.1446794976226, -289.1446789648095, -289.1446800394684, -289.1446789703671, -289.1446800450277, -289.1446808675884, -289.1446781366995, -289.1446808731468, -289.144678142258, -289.1446795547467, -289.1446794495307, -289.1446795603051, -289.1446794550891, -289.144681613493, -289.144677390809, -289.1446816190524, -289.1446773963663, -289.1446806220308, -289.1446783822528, -289.144680627589, 
  -289.1446783878114, -289.1446811474048, -289.1446778568859, -289.1446811529632, -289.1446778624443, -289.1446840905436, -289.1446749145357, -289.1446840961133, -289.1446749200829, -289.1446884608625, -289.1446705435085, -289.1446884664239, -289.1446705490639, -289.1446635297911, -289.1446954753331, -289.1446635353497, -289.1446954808914, -289.1446852954882, -289.1446737087573, -289.1446853010462, -289.1446737143162, -289.1446807912847, -289.1446782130434, -289.1446807968427, -289.1446782186023, -289.1446899602089, -289.144669044061, -289.1446899657674, -289.1446690496195, -289.1446789776627, -289.1446800523224, -289.1446789575138, -289.1446800321735, -289.144680880442, -289.1446781495531, -289.1446808602931, -289.1446781294042, -289.1446795676003, -289.1446794623842, -289.1446795474513, 
  -289.1446794422353, -289.1446816263473, -289.1446774036618, -289.1446816061979, -289.1446773835133, -289.1446806348843, -289.1446783951065, -289.1446806147353}
 {-9.61192246208227, -9.61192206989567, -9.61192348353889, -9.61192144063967, -9.61192285429615, -9.61192276872595, -9.61192278470761, -9.61192213947647, -9.61192215545835, -9.61192079746995, -9.61192475596265, -9.61192016823112, -9.61192412670274, -9.61191752209867, -9.61192803134986, -9.61191689284824, -9.61192740210155, -9.61192275964583, -9.6119227937877, -9.61192213039653, -9.61192216453826, -9.6119229782714, -9.61192257516201, -9.61192234902163, -9.61192194591304, -9.61192295184934, -9.6119226015842, -9.61192232260061, -9.61192197233419, -9.61192279254476, -9.61192276088888, -9.6119221632954, -9.6119221316395, -9.61195223948413, -9.61189331537396, -9.61195161066417, -9.61189268569519, -9.61194155793421, -9.61190399565061, -9.61194092868096, -9.61190336640513, -9.61192277671678, 
  -9.61192277671678, -9.61192214746741, -9.61192214746741, -9.61192443291284, -9.6119211205626, -9.61192380360377, -9.61192049137294, -9.61191324917994, -9.61193230449959, -9.61191261992509, -9.6119316752557, -9.61192275449767, -9.61192279893554, -9.61192212524817, -9.61192216968631, -9.61192174726697, -9.61192176324872, -9.6119231609168, -9.6119231768986, -9.61191977601677, -9.61192373449795, -9.61192118966565, -9.61192514814879, -9.61191650063724, -9.61192700989342, -9.61191791429103, -9.61192842353934, -9.61192173818692, -9.61192177232874, -9.6119231518368, -9.61192318597857, -9.6119219568121, -9.61192155370344, -9.61192337046228, -9.61192296735297, -9.61192193039069, -9.61192158012497, -9.61192334404061, -9.61192299377477, -9.61192177108583, -9.61192173942994, -9.61192318473568, 
  -9.6119231530798, -9.61195121820316, -9.61189229373706, -9.61195263192649, -9.61189370731344, -9.61194053646885, -9.6119029741981, -9.61194195012767, -9.61190438783899, -9.61192175525784, -9.61192175525784, -9.6119231689077, -9.6119231689077, -9.6119234114333, -9.61192009912428, -9.61192482506467, -9.61192151279262, -9.61191222771851, -9.61193128304314, -9.61191364136787, -9.6119326966935, -9.61192173303869, -9.61192177747665, -9.61192314668851, -9.61192319112655, -9.61192047484983, -9.61192443333199, -9.6119204908316, -9.61192444931376, -9.61191719947269, -9.61192770872506, -9.61191721545458, -9.61192772470671, -9.61192243702046, -9.61192247116229, -9.61192245300226, -9.61192248714403, -9.61192265564585, -9.61192225253677, -9.61192267162753, -9.61192226851863, -9.61192262922388, 
  -9.61192227895887, -9.61192264520642}
 {-409.642267437824, -409.642272265289, -409.6422708198101, -409.6422640558627, -409.6422626103747, -409.6422715462372, -409.6422715388604, -409.6422633368064, -409.6422633294297, -409.6422728753078, -409.6422702097918, -409.6422646658731, -409.642262000365, -409.6422716598707, -409.6422714252633, -409.6422634504413, -409.6422632158311, -409.642271552296, -409.6422715328017, -409.6422633428652, -409.642263323371, -409.6422689743707, -409.6422741107554, -409.6422607649495, -409.6422659013152, -409.6422742721343, -409.6422688129828, -409.6422660627031, -409.6422606035524, -409.6422736245652, -409.642269460551, -409.6422654151344, -409.64226125112, -409.6422397083499, -409.6423033787401, -409.6422314983674, -409.6422951698609, -409.6422904871238, -409.6422525982051, -409.6422822777026, 
  -409.6422443887647, -409.6422524869576, -409.6422905990827, -409.6422442775237, -409.6422823896551, -409.6422870383598, -409.6422560466764, -409.6422788288866, -409.6422478372881, -409.6422820784466, -409.6422610066806, -409.6422738690169, -409.6422527972487, -409.6422808894368, -409.6422621957058, -409.642272680005, -409.6422539862759, -409.6422681642546, -409.6422681568779, -409.6422667187712, -409.6422667113946, -409.6422694933234, -409.6422668278111, -409.6422680478397, -409.642265382328, -409.64226827789, -409.6422680432788, -409.6422668324042, -409.6422665977978, -409.6422681703135, -409.6422681508192, -409.64226672483, -409.6422667053357, -409.6422655923936, -409.6422707287676, -409.6422641469089, -409.6422692832853, -409.642270890151, -409.6422654310011, -409.6422694446685, 
  -409.6422639855166, -409.6422702425826, -409.6422660785684, -409.6422687970993, -409.6422646330849, -409.6422363260474, -409.6422999970775, -409.6422348806522, -409.6422985515058, -409.6422871051577, -409.6422492162061, -409.642285659651, -409.6422477707459, -409.6422491049735, -409.6422872171017, -409.6422476594901, -409.6422857716183, -409.6422836563475, -409.6422526647236, -409.6422822108811, -409.6422512192232, -409.642278696465, -409.642257624697, -409.6422772509807, -409.6422561792145, -409.6422775074539, -409.6422588137235, -409.6422760619701, -409.6422573682405, -409.6422687742693, -409.6422661087573, -409.6422687668925, -409.6422661013805, -409.6422675588348, -409.6422673242261, -409.6422675514581, -409.6422673168492, -409.6422674512595, -409.6422674317652, -409.6422674438827, 
  -409.6422674243884, -409.6422648733395, -409.6422700097138, -409.6422648659618, -409.6422700023378, -409.642270171098, -409.6422647119462, -409.6422701637204}
 {-65.62385175246267, -65.62388831705787, -65.62388878337826, -65.62381472158984, -65.62381518791732, -65.62388913296667, -65.62388796746893, -65.62381553750043, -65.62381437200621, -65.62388405509279, -65.62389304535058, -65.62381045962764, -65.62381944988677, -65.62389158528288, -65.62388551517659, -65.6238179898178, -65.62381191971267, -65.62388831019031, -65.62388879024533, -65.62381471472579, -65.62381519478085, -65.62390802602662, -65.62386907470719, -65.62383443057124, -65.62379547923359, -65.62388609220688, -65.62389100825693, -65.62381249674226, -65.62381741279258, -65.62390285719147, -65.62387424331456, -65.62382926172719, -65.62380064784987, -65.62383566563031, -65.62394143641288, -65.62376206990697, -65.62386784120726, -65.62389903453162, -65.62387806609745, 
  -65.62382543904684, -65.62380447065323, -65.62389422700079, -65.62388287555754, -65.62382063154456, -65.62380928008477, -65.62370585022788, -65.62407125348559, -65.62363225541894, -65.62399765736549, -65.62388663939693, -65.62389046144004, -65.62381304393256, -65.62381686597542, -65.62391253335117, -65.62386456836748, -65.62383893788568, -65.62379097290398, -65.62385210204904, -65.62385093655294, -65.62385256837286, -65.623851402877, -65.62384702417633, -65.62385601443341, -65.62384749049889, -65.62385648075872, -65.62385455436567, -65.62384848426014, -65.62385502068979, -65.62384895058389, -65.62385127927348, -65.6238517593285, -65.62385174559739, -65.62385222565245, -65.62387099511362, -65.62383204378653, -65.62387146143901, -65.623832510109, -65.62384906128959, -65.62385397734059, 
  -65.62384952761432, -65.62385444366373, -65.62386582627473, -65.62383721239767, -65.62386629259871, -65.62383767872154, -65.62379863455879, -65.62390440565077, -65.62379910093329, -65.62390487192417, -65.62386200362499, -65.62384103517042, -65.62386246990828, -65.62384150153503, -65.62385719608739, -65.62384584463729, -65.62385766241275, -65.62384631095981, -65.62366881964204, -65.62403422223776, -65.62366928595956, -65.6240346885681, -65.62384960848004, -65.62385343052327, -65.62385007480425, -65.62385389684692, -65.62387550243426, -65.62382753745072, -65.62387596875735, -65.62382800377549, -65.62384784008532, -65.6238568303438, -65.62384667458936, -65.62385566484781, -65.62385537027547, -65.62384930016973, -65.62385420477947, -65.62384813467377, -65.62385209518316, -65.6238525752382, 
  -65.62385092968718, -65.62385140974223, -65.62387181102487, -65.62383285969466, -65.62387064552723, -65.62383169420036, -65.62384987719954, -65.62385479325002, -65.62384871170384}
 {-184.5930591411637, -184.5930590325841, -184.5930590491994, -184.5930592331284, -184.5930592497442, -184.5930590430793, -184.5930590387043, -184.5930592436238, -184.5930592392488, -184.5930579267285, -184.5930601550603, -184.5930581272756, -184.5930603556023, -184.5930585788933, -184.5930595029384, -184.5930587794354, -184.5930597034853, -184.5930590193046, -184.5930590624789, -184.5930592198491, -184.5930592630235, -184.5930554421575, -184.5930626397911, -184.5930556427163, -184.5930628403215, -184.5930555793318, -184.5930625025018, -184.5930557798749, -184.5930627030478, -184.593063281948, -184.5930547998694, -184.5930634824922, -184.5930550004143, -184.5930574669993, -184.5930606147868, -184.5930576675508, -184.5930608153244, -184.59306025164, -184.5930578303606, -184.5930604521867, 
  -184.593058030903, -184.5930570912104, -184.5930609922438, -184.5930572917611, -184.5930611927822, -184.5930590586289, -184.5930590231547, -184.5930592591731, -184.5930592236996, -184.59306495334, -184.5930531284834, -184.5930651538825, -184.5930533290301, -184.5930829160903, -184.5930351655414, -184.5930831166325, -184.5930353660881, -184.5930591350434, -184.5930591306684, -184.593059151659, -184.593059147284, -184.5930580186941, -184.593060247023, -184.5930580353093, -184.593060263639, -184.5930586708567, -184.5930595949033, -184.5930586874714, -184.5930596115198, -184.5930591112688, -184.5930591544431, -184.5930591278843, -184.5930591710587, -184.5930555341263, -184.5930627317507, -184.5930555507469, -184.5930627483612, -184.5930556712955, -184.5930625944665, -184.5930556879106, 
  -184.5930626110825, -184.593063373912, -184.5930548918337, -184.5930633905275, -184.5930549084494, -184.593057558967, -184.5930607067474, -184.5930575755825, -184.5930607233631, -184.593060343605, -184.5930579223239, -184.5930603602211, -184.593057938939, -184.5930571831771, -184.5930610842054, -184.5930571997937, -184.59306110082, -184.5930591505929, -184.5930591151191, -184.5930591672084, -184.5930591317347, -184.5930650453035, -184.5930532204483, -184.5930650619184, -184.5930532370645, -184.5930830080536, -184.5930352575063, -184.5930830246685, -184.5930352741226, -184.5930580291892, -184.5930602575185, -184.5930580248142, -184.5930602531435, -184.5930586813515, -184.593059605399, -184.5930586769765, -184.593059601024, -184.5930591217641, -184.5930591649384, -184.593059117389, 
  -184.5930591605634, -184.5930555446245, -184.5930627422431, -184.5930555402487, -184.5930627378689, -184.5930556817905, -184.593062604962, -184.5930556774155}
 {-348.8660927344226, -348.8660926785215, -348.8660927154299, -348.8660927534151, -348.8660927903231, -348.8660926933206, -348.8660927006308, -348.866092768214, -348.8660927755242, -348.8660926760313, -348.8660927179212, -348.8660927509254, -348.8660927928138, -348.866093560227, -348.8660918337412, -348.8660936351201, -348.8660919086348, -348.8660926213286, -348.8660927726228, -348.8660926962221, -348.8660928475162, -348.866090637088, -348.8660947567372, -348.8660907120066, -348.8660948316052, -348.8660878486034, -348.8660975453485, -348.866087923497, -348.8660976202417, -348.8660874324624, -348.8660979615049, -348.8660875073557, -348.8660980363984, -348.8660926969757, -348.8660926969757, -348.8660927718691, -348.8660927718691, -348.866100276549, -348.8660851175523, -348.8661003514444, 
  -348.8660851924438, -348.8661430497432, -348.86604234515, -348.8661431246394, -348.8660424200407, -348.8660926552625, -348.8660927386886, -348.8660927301566, -348.8660928135813, -348.8660949755126, -348.8660904184691, -348.8660950504051, -348.8660904933633, -348.8660671022441, -348.8661182933582, -348.8660671771334, -348.8661183682557, -348.8660927123134, -348.8660927196237, -348.8660927492217, -348.8660927565319, -348.8660926950247, -348.8660927369134, -348.8660927319326, -348.8660927738219, -348.8660935792196, -348.8660918527342, -348.8660936161279, -348.8660918896424, -348.8660926403214, -348.8660927916155, -348.8660926772297, -348.8660928285237, -348.8660906560877, -348.866094775723, -348.8660906930074, -348.8660948126198, -348.8660878675962, -348.8660975643414, -348.8660879045047, 
  -348.8660976012492, -348.8660874514552, -348.8660979804977, -348.8660874883634, -348.866098017406, -348.8660927159684, -348.8660927159684, -348.8660927528767, -348.8660927528767, -348.866100295542, -348.866085136545, -348.8661003324518, -348.8660851734516, -348.8661430687368, -348.8660423641421, -348.8661431056463, -348.8660424010491, -348.8660926742557, -348.8660927576811, -348.8660927111639, -348.8660927945893, -348.8660949945051, -348.8660904374622, -348.8660950314131, -348.8660904743706, -348.8660671212359, -348.8661183123521, -348.8660671581421, -348.8661183492623, -348.8660927098234, -348.8660927517127, -348.8660927171337, -348.8660927590227, -348.8660935940187, -348.8660918675332, -348.8660936013288, -348.8660918748434, -348.8660926551205, -348.8660928064145, -348.8660926624307, 
  -348.8660928137248, -348.866090670892, -348.8660947905168, -348.8660906782032, -348.866094797826, -348.8660878823953, -348.8660975791402, -348.8660878897055}
 {-16.34268110903565, -16.3426812099934, -16.34268120804081, -16.34268101003063, -16.34268100807804, -16.34268120953751, -16.3426812084967, -16.34268100957474, -16.34268100853393, -16.342685444057, -16.34267697399671, -16.34268524408564, -16.34267677404253, -16.34268171473099, -16.34268070330398, -16.34268151476839, -16.34268050334105, -16.3426812579565, -16.3426811600777, -16.34268105799373, -16.34268096011495, -16.34267426597936, -16.34268815281147, -16.34267406602363, -16.34268795284167, -16.34268134311365, -16.34268107492138, -16.34268114315096, -16.34268087495854, -16.34268215920467, -16.34268025883595, -16.34268195924144, -16.34268005887366, -16.34268208518687, -16.34268033284942, -16.3426818852221, -16.34268013288865, -16.34267603256799, -16.34268638549366, -16.34267583260635, 
  -16.34268618552976, -16.34268547146458, -16.34267694690995, -16.34268527150583, -16.34267674694316, -16.34268121023605, -16.34268120779816, -16.34268101027329, -16.34268100783539, -16.34268172401393, -16.34268069408429, -16.34268152405423, -16.34268049411846, -16.34269569261641, -16.34266672522451, -16.34269549265199, -16.3426665252634, -16.34268111053236, -16.34268110949154, -16.34268110857977, -16.34268110753895, -16.34268534504758, -16.34267687499583, -16.34268534309494, -16.34267687304329, -16.34268161572592, -16.34268060429874, -16.34268161377333, -16.34268060234616, -16.34268115895135, -16.34268106107256, -16.34268115699876, -16.34268105911997, -16.34267416697773, -16.3426880538028, -16.34267416502513, -16.34268805185022, -16.34268124410854, -16.34268097591619, -16.34268124215595, 
  -16.3426809739636, -16.34268206019929, -16.34268015983104, -16.3426820582467, -16.34268015787845, -16.34268198618071, -16.34268023384526, -16.34268198422812, -16.34268023189267, -16.34267593356345, -16.34268628648789, -16.34267593161076, -16.3426862845354, -16.34268537246144, -16.34267684790278, -16.34268537050885, -16.3426768459502, -16.3426811112309, -16.342681108793, -16.34268110927831, -16.34268110684042, -16.34268162501031, -16.3426805950776, -16.34268162305772, -16.34268059312502, -16.34269559361043, -16.34266662622019, -16.34269559165784, -16.3426666242676, -16.34268534459168, -16.34267687453995, -16.34268534355083, -16.34267687349916, -16.34268161527003, -16.34268060384286, -16.34268161422922, -16.34268060280204, -16.34268115849546, -16.34268106061667, -16.34268115745465, 
  -16.34268105957586, -16.34267416652186, -16.34268805334689, -16.342674165481, -16.34268805230612, -16.34268124365265, -16.3426809754603, -16.34268124261184}
 {-401.8900326314203, -401.8900386642725, -401.8900382799567, -401.8900269829014, -401.8900265985837, -401.8900385066361, -401.8900384375923, -401.8900268252645, -401.8900267562201, -401.8900388613504, -401.8900380828828, -401.8900271799765, -401.8900264015128, -401.8900466751116, -401.8900302691598, -401.8900349937395, -401.890018587788, -401.8900384317528, -401.8900385124757, -401.8900267503808, -401.8900268311038, -401.89003799802, -401.8900389463049, -401.8900263166438, -401.8900272649372, -401.8900378451919, -401.8900390990583, -401.89002616382, -401.8900274176862, -401.8900529091924, -401.8900240350881, -401.8900412278204, -401.8900123537163, -401.8900268917156, -401.8900500546374, -401.8900152100564, -401.8900383735529, -401.8900365985925, -401.89004034603, -401.8900249172265, 
  -401.8900286646518, -401.8900206736554, -401.8900562737645, -401.8900089922782, -401.8900445923978, -401.8900682308904, -401.8900087131651, -401.8900565495064, -401.8899970318051, -401.8900728656757, -401.8900040783705, -401.8900611843035, -401.8899923969987, -401.8900938880575, -401.8899830560558, -401.8900822066855, -401.889971374684, -401.8900328581011, -401.8900327890569, -401.890032473784, -401.8900324047403, -401.8900332128153, -401.8900324343475, -401.8900328284964, -401.8900320500327, -401.8900410265767, -401.8900246206242, -401.8900406422593, -401.8900242363081, -401.8900327832177, -401.8900328639406, -401.8900323989008, -401.8900324796236, -401.8900323494817, -401.8900332977728, -401.8900319651668, -401.890032913454, -401.8900321966568, -401.8900334505229, -401.8900318123398, 
  -401.8900330662063, -401.8900472606572, -401.8900183865529, -401.8900468763404, -401.8900180022362, -401.890021243025, -401.8900444062576, -401.8900208587317, -401.8900440219174, -401.8900309500653, -401.8900346974867, -401.8900305657384, -401.89003431318, -401.8900150251175, -401.890050625232, -401.8900146408008, -401.890050240915, -401.8900625823472, -401.8900030646378, -401.8900621980341, -401.8900026803172, -401.890067217141, -401.8899984298347, -401.890066832823, -401.8899980455192, -401.8900882395223, -401.8899774075207, -401.8900878552055, -401.8899770232037, -401.8900330551775, -401.8900322767117, -401.8900329861336, -401.8900322076678, -401.8900408689396, -401.8900244629878, -401.8900407998958, -401.890024393944, -401.8900326255809, -401.8900327063038, -401.890032556537, 
  -401.8900326372598, -401.8900321918467, -401.8900331401343, -401.8900321228012, -401.8900330710919, -401.89003203902, -401.8900332928864, -401.890031969976}
 {-441.6764498846895, -441.6764498708626, -441.6764498724388, -441.6764498969401, -441.6764498985161, -441.6764498689648, -441.6764498743366, -441.6764498950423, -441.676449900414, -441.6764499678786, -441.6764497754251, -441.6764499939552, -441.6764498015032, -441.6764519529719, -441.676447790347, -441.6764519790491, -441.6764478164247, -441.676449830771, -441.6764499125303, -441.6764498568485, -441.6764499386078, -441.6764484020924, -441.6764513410884, -441.6764484281886, -441.676451367147, -441.6764467873257, -441.6764529559707, -441.6764468134032, -441.6764529820479, -441.6764450827304, -441.676454660586, -441.6764451088078, -441.6764546866635, -441.6764498716507, -441.6764498716507, -441.6764498977281, -441.6764498977281, -441.6764458289456, -441.6764539145058, -441.6764458550213, 
  -441.6764539405849, -441.6764006004532, -441.6764991437901, -441.6764006265283, -441.6764991698697, -441.6764498524854, -441.6764498908158, -441.6764498785632, -441.6764499168929, -441.6764544056326, -441.6764453376584, -441.6764544317098, -441.6764453637359, -441.6764258734504, -441.6764738714287, -441.6764258995245, -441.6764738975091, -441.6764498812155, -441.6764498865872, -441.6764498827917, -441.6764498881634, -441.6764499801293, -441.6764497876757, -441.6764499817047, -441.6764497892528, -441.6764519652226, -441.6764478025978, -441.6764519667986, -441.676447804174, -441.6764498430218, -441.676449924781, -441.6764498445979, -441.6764499263572, -441.6764484143488, -441.6764513533336, -441.6764484159325, -441.6764513549022, -441.6764467995764, -441.6764529682214, -441.6764468011528, 
  -441.6764529697973, -441.6764450949811, -441.6764546728368, -441.6764450965571, -441.676454674413, -441.6764498839013, -441.6764498839013, -441.6764498854776, -441.6764498854776, -441.6764458411961, -441.6764539267566, -441.6764458427711, -441.676453928334, -441.6764006127032, -441.6764991560415, -441.6764006142784, -441.6764991576185, -441.6764498647363, -441.6764499030664, -441.6764498663126, -441.6764499046424, -441.6764544178832, -441.6764453499091, -441.6764544194594, -441.6764453514853, -441.6764258857002, -441.6764738836802, -441.6764258872749, -441.6764738852578, -441.6764499782311, -441.6764497857784, -441.6764499836029, -441.6764497911501, -441.6764519633248, -441.6764478007001, -441.6764519686965, -441.6764478060718, -441.676449841124, -441.6764499228832, -441.6764498464957, 
  -441.676449928255, -441.6764484124544, -441.6764513514325, -441.6764484178269, -441.6764513568032, -441.6764467976787, -441.6764529663235, -441.6764468030504}
 {-86.199321197736, -86.1993531892871, -86.1993452343692, -86.1992971612777, -86.1992892063586, -86.199349226124, -86.1993491975222, -86.1992931981141, -86.199293169512, -86.1993527513284, -86.1993456723221, -86.1992967232983, -86.1992896443321, -86.1993286052345, -86.199369818653, -86.199272577218, -86.1993137906494, -86.1993495092804, -86.1993489143658, -86.1992934812702, -86.1992928863559, -86.1993498189502, -86.1993486046777, -86.1992937910326, -86.1992925765753, -86.1993644369126, -86.1993339870188, -86.1993084089054, -86.1992779590059, -86.1993548900338, -86.1993435338455, -86.1992988620233, -86.1992875058359, -86.1993140391655, -86.1993843986184, -86.1992580104236, -86.1993283713405, -86.1993143215595, -86.1993841039774, -86.1992582935765, -86.1993280759404, -86.1994473524115, 
  -86.1992510840787, -86.1993913244157, -86.1991950560545, -86.1994092432496, -86.1992891801857, -86.199353215117, -86.1992331522983, -86.1993433803156, -86.1993550445399, -86.199287352304, -86.1992990165315, -86.1993669161655, -86.1993315133045, -86.19931088814, -86.19927548531, -86.1993251895014, -86.1993251608994, -86.1993172345829, -86.1993172059809, -86.1993287146973, -86.1993216357078, -86.1993207597756, -86.1993136807925, -86.1993045686246, -86.1993457820175, -86.199296613674, -86.1993378271311, -86.1993254726576, -86.1993248777431, -86.1993175177392, -86.1993169228246, -86.199325782382, -86.1993245680005, -86.1993178274469, -86.1993166130987, -86.1993404002891, -86.1993099503969, -86.199332445375, -86.199301995474, -86.199330853411, -86.1993194972228, -86.1993228984922, 
  -86.1993115423046, -86.1992900022685, -86.1993603622701, -86.1992820471668, -86.1993524075348, -86.1992902849547, -86.1993600673369, -86.1992823300275, -86.199352112427, -86.1994233157986, -86.1992270474462, -86.1994153608748, -86.1992190925331, -86.1993852065197, -86.1992651436702, -86.199377251693, -86.19925718866, -86.1993193436988, -86.1993310079113, -86.1993113887669, -86.1993230530062, -86.1993428795351, -86.1993074766896, -86.1993349246166, -86.1992995217711, -86.1993247515325, -86.1993176725458, -86.1993247229301, -86.1993176439444, -86.1993006054454, -86.19934181887, -86.199300576843, -86.1993417902684, -86.1993215094943, -86.1993209145797, -86.1993214808922, -86.1993208859779, -86.1993218192152, -86.1993206048406, -86.1993217906035, -86.1993205762484, -86.1993364371295, 
  -86.1993059872298, -86.1993364085244}
 {-22.26647768574787, -22.26650269554276, -22.26649843526886, -22.26645693635157, -22.26645267610892, -22.26650076035505, -22.26650037045555, -22.26645500117853, -22.26645461128093, -22.26649977906437, -22.26650135175961, -22.26645401988304, -22.26645559258981, -22.26650221801802, -22.26649891284577, -22.26645645883801, -22.26645315367464, -22.26650045196327, -22.26650067884736, -22.26645469278766, -22.26645491967184, -22.2665006699046, -22.2665004611074, -22.26645491072457, -22.26645470193628, -22.266494600728, -22.26650653012403, -22.26644884155235, -22.26646077094855, -22.26649876197457, -22.26650236887974, -22.26645300279896, -22.26645660970421, -22.26646314565338, -22.26653798765501, -22.26641738646886, -22.26649222848843, -22.26650593524651, -22.26649519584422, -22.26646017604546, 
  -22.26644943669414, -22.26646770558455, -22.26653342748989, -22.2664219464226, -22.26648766830071, -22.26648989852823, -22.26651123269006, -22.26644413974821, -22.26646547311893, -22.26651371083441, -22.26648741995843, -22.26646795165896, -22.26644166078275, -22.26650282066945, -22.26649831146112, -22.26645706149581, -22.26645255228362, -22.2664800108269, -22.26647962092814, -22.26647575056842, -22.26647536067009, -22.26647902953725, -22.26648060223118, -22.2664747692719, -22.26647634198, -22.2664814684912, -22.26647816331703, -22.26647720822657, -22.26647390306513, -22.26647970243548, -22.2664799293196, -22.26647544217718, -22.26647566906136, -22.2664799203736, -22.26647971158283, -22.26647566011732, -22.26647545132259, -22.2664738512016, -22.26648578059486, -22.2664695909405, 
  -22.26648152033945, -22.2664780124467, -22.26648161935205, -22.26647375218856, -22.26647735909364, -22.26644239609881, -22.26651723815403, -22.26643813588517, -22.26651297785115, -22.26648518572319, -22.26647444631199, -22.26648092543053, -22.26647018608811, -22.26644695606319, -22.26651267795569, -22.2664426958057, -22.26650841769666, -22.26646914917404, -22.26649048298868, -22.26646488896415, -22.26648622268204, -22.26649296130708, -22.26646667043019, -22.26648870104802, -22.26646241017272, -22.2664820711412, -22.26647756193381, -22.2664778108858, -22.26647330167268, -22.26647709435341, -22.26647866705428, -22.26647670445472, -22.26647827715587, -22.26647953330773, -22.26647622813977, -22.26647914340904, -22.26647583824137, -22.2664777672551, -22.26647799413924, -22.26647737735655, 
  -22.26647760424071, -22.26647798519887, -22.26647777639683, -22.26647759529103, -22.26647738650759, -22.26647191602047, -22.26648384541526, -22.2664715261206}
 {-327.4894155785797, -327.4894173839428, -327.4894169953398, -327.4894141618232, -327.4894137732202, -327.4894172801846, -327.4894170990977, -327.4894140580651, -327.489413876978, -327.4894171245842, -327.489417254698, -327.4894139024648, -327.4894140325783, -327.4894214806479, -327.4894128986559, -327.4894182585284, -327.4894096765363, -327.4894174763015, -327.4894169029808, -327.4894142541819, -327.4894136808612, -327.4894177003389, -327.489416678948, -327.4894144782184, -327.4894134568293, -327.4894149990478, -327.4894193802456, -327.4894117769281, -327.4894161581261, -327.4894133705632, -327.4894210088964, -327.4894101484436, -327.4894177867768, -327.4894115251083, -327.4894228547171, -327.4894083029028, -327.4894196326835, -327.4894111951265, -327.4894231842198, -327.4894079730075, 
  -327.4894199620996, -327.4894322691033, -327.4894021106917, -327.4894290469835, -327.4893988885724, -327.4894228048059, -327.4894115744476, -327.4894195826844, -327.48940835233, -327.4894202584867, -327.4894141208134, -327.489417036367, -327.4894108986939, -327.4894232773875, -327.489411101975, -327.4894200552679, -327.4894078798554, -327.4894158634253, -327.4894156823378, -327.4894154748218, -327.4894152937352, -327.489415707825, -327.4894158379381, -327.4894153192213, -327.4894154493357, -327.4894200638885, -327.489411481896, -327.489419675285, -327.4894110932935, -327.4894160595418, -327.4894154862211, -327.4894156709388, -327.4894150976182, -327.4894162835778, -327.4894152621898, -327.4894158949769, -327.4894148735848, -327.4894135822882, -327.489417963486, -327.489413193685, 
  -327.4894175748831, -327.4894119538036, -327.4894195921367, -327.4894115652006, -327.4894192035338, -327.4894101082906, -327.4894214380157, -327.489409719718, -327.4894210493822, -327.4894097783702, -327.4894217674569, -327.4894093897612, -327.4894213788598, -327.489430852343, -327.4894006939328, -327.4894304637411, -327.4894003053286, -327.4894213880431, -327.4894101576912, -327.4894209994446, -327.4894097690837, -327.4894188417271, -327.4894127040538, -327.4894184531239, -327.4894123154509, -327.489421860628, -327.4894096852152, -327.4894214720247, -327.4894092966125, -327.4894156040666, -327.4894157341802, -327.4894154229794, -327.4894155530932, -327.4894199601301, -327.4894113781381, -327.489419779043, -327.4894111970511, -327.4894159557837, -327.4894153824631, -327.4894157746966, 
  -327.489415201376, -327.4894161798206, -327.4894151584307, -327.4894159987337, -327.4894149773435, -327.48941347853, -327.4894178597279, -327.4894132974429}
 {-10.96241773218477, -10.96241707240672, -10.96241712472565, -10.96241833964094, -10.96241839195968, -10.96241709620817, -10.9624171009242, -10.96241836344231, -10.96241836815831, -10.96241497034371, -10.96241922682541, -10.96241623760788, -10.96242049402949, -10.96241747523797, -10.96241672194081, -10.96241874246582, -10.96241798918121, -10.96241704408445, -10.96241715304793, -10.96241831131858, -10.96241842028204, -10.96241339838116, -10.9624207995858, -10.962414665614, -10.96242206682121, -10.96241537313468, -10.96241882402428, -10.96241664036796, -10.96242009125925, -10.96242030206976, -10.96241389508853, -10.96242156930332, -10.96241516232323, -10.96241645183722, -10.96241774529811, -10.96241771907913, -10.96241901252445, -10.96243272895844, -10.96240146842368, -10.96243399620622, 
  -10.96240273564415, -10.96243588321029, -10.96239831520436, -10.96243715045053, -10.96239958243237, -10.9624171038914, -10.962417093241, -10.96241837112542, -10.96241836047523, -10.96242344357667, -10.96241075366044, -10.96242471079517, -10.96241202091019, -10.96244358121673, -10.96239061564288, -10.9624448484494, -10.96239188287845, -10.96241770366735, -10.96241770838337, -10.96241775598618, -10.9624177607022, -10.96241557781747, -10.96241983427001, -10.96241563013719, -10.96241988658794, -10.96241808269431, -10.96241732940282, -10.96241813501253, -10.96241738172226, -10.96241765154363, -10.9624177605071, -10.96241770386246, -10.96241781282593, -10.96241400583854, -10.96242140704678, -10.96241405815968, -10.96242145936329, -10.96241598059351, -10.96241943148381, -10.96241603291219, 
  -10.96241948380279, -10.96242090952869, -10.96241450254796, -10.96242096184745, -10.96241455486686, -10.96241705930033, -10.96241835275336, -10.96241711161908, -10.96241840507227, -10.96243333642315, -10.96240207587733, -10.96243338874457, -10.96240212819356, -10.9624364906719, -10.9623989226611, -10.96243654299198, -10.96239897497869, -10.96241771135053, -10.96241770070023, -10.96241776366935, -10.96241775301906, -10.96242405102866, -10.96241136112681, -10.96242410334624, -10.96241141344688, -10.96244418867541, -10.96239122310255, -10.96244424099379, -10.96239127542183, -10.96241560161924, -10.96241985807105, -10.96241560633541, -10.9624198627869, -10.96241810649543, -10.96241735320451, -10.96241811121141, -10.96241735792056, -10.96241767534504, -10.96241778430851, -10.96241768006105, 
  -10.96241778902452, -10.96241402964125, -10.96242143084688, -10.96241403435697, -10.96242143556319, -10.96241600439484, -10.96241945528529, -10.96241600911086}
 {-17.26069976969575, -17.26069952631134, -17.26069953347028, -17.26070000592102, -17.26070001307995, -17.26069952916045, -17.26069953062116, -17.26070000877013, -17.26070001023083, -17.26069211325779, -17.26070694654337, -17.26069259287918, -17.26070742614132, -17.26069730380522, -17.26070175598068, -17.26069778341428, -17.26070223559098, -17.26069944697456, -17.26069961280706, -17.26069992658422, -17.26070009241675, -17.26069483697469, -17.26070422357437, -17.26069531658754, -17.26070470318085, -17.26069911745333, -17.26069994233484, -17.26069959706247, -17.26070042194505, -17.26070066436525, -17.26069839542271, -17.26070114397447, -17.26069887503284, -17.26069746368205, -17.26070159610164, -17.26069794329486, -17.26070207570818, -17.26070790799081, -17.26069115181825, 
  -17.26070838760164, -17.26069163142676, -17.2607034542359, -17.26069560588604, -17.26070393384961, -17.26069608549168, -17.26069952801722, -17.26069953176438, -17.2607000076269, -17.26070001137405, -17.26068872572213, -17.26071033432906, -17.26068920532643, -17.26071081394411, -17.26071453750926, -17.26068452205471, -17.26071501711779, -17.26068500166552, -17.26069976538593, -17.26069976684663, -17.26069977254486, -17.26069977400557, -17.26069234948903, -17.26070718276306, -17.26069235664814, -17.26070718992182, -17.26069754003039, -17.26070199220646, -17.26069754718931, -17.26070199936541, -17.26069968320002, -17.26069984903254, -17.26069969035895, -17.26069985619147, -17.26069507320172, -17.26070445979827, -17.26069508036071, -17.26070446695715, -17.26069935367854, -17.26070017856058, 
  -17.26069936083746, -17.26070018571952, -17.2607009005905, -17.2606986316484, -17.26070090774942, -17.26069863880734, -17.2606976999091, -17.26070183232554, -17.26069770706802, -17.26070183948448, -17.26070814421673, -17.26069138804327, -17.26070815137592, -17.26069139520195, -17.26070369046335, -17.26069584210953, -17.26070369762236, -17.26069584926839, -17.2606997642427, -17.26069976798986, -17.26069977140163, -17.26069977514879, -17.26068896194497, -17.26071057055717, -17.2606889691038, -17.2607105777162, -17.26071477373417, -17.26068475828074, -17.26071478089309, -17.26068476543969, -17.26069235233821, -17.26070718561211, -17.26069235379896, -17.26070718707278, -17.2606975428795, -17.26070199505558, -17.2606975443402, -17.26070199651629, -17.26069968604914, -17.26069985188165, 
  -17.26069968750984, -17.26069985334236, -17.26069507605089, -17.26070446264733, -17.26069507751154, -17.26070446410809, -17.26069935652764, -17.2607001814097, -17.26069935798835}
 {-713.5331976874474, -713.533181888494, -713.5331803054451, -713.5332150694362, -713.5332134863776, -713.5331810358695, -713.5331811580711, -713.5332142168062, -713.5332143390089, -713.5331838265779, -713.5331783673754, -713.5332170074976, -713.5332115483303, -713.5331826621351, -713.5331795318237, -713.5332158430714, -713.5332127127619, -713.5331811383256, -713.533181055615, -713.5332143192628, -713.5332142365525, -713.5331721916943, -713.5331900025966, -713.533205372666, -713.5332231834992, -713.5331822952111, -713.5331798987389, -713.5332154761494, -713.5332130796749, -713.5331831678914, -713.5331790260676, -713.5332163488298, -713.5332122070038, -713.5330934153531, -713.5332687799263, -713.5331265950538, -713.5333019621001, -713.5331950666163, -713.5331671274704, -713.5332282475571, 
  -713.5332003084042, -713.5331649542655, -713.5331972406176, -713.5331981351859, -713.5332304215716, -713.5331532584795, -713.5332089360335, -713.5331864389377, -713.5332421174494, -713.5331822812094, -713.5331799127755, -713.5332154621537, -713.5332130937056, -713.533192432112, -713.5331697617803, -713.5332256130431, -713.5332029427238, -713.5331984178725, -713.5331985400748, -713.5331968348188, -713.533196957021, -713.533201208571, -713.5331957493889, -713.5331996255202, -713.5331941663324, -713.5332000441411, -713.5331969138242, -713.533198461081, -713.5331953307771, -713.5331985203289, -713.5331984376184, -713.5331969372752, -713.5331968545648, -713.5331895737165, -713.5332073845808, -713.5331879906593, -713.5332058015306, -713.533199677213, -713.5331972807434, -713.5331980941631, 
  -713.533195697686, -713.5332005498951, -713.5331964080704, -713.5331989668416, -713.5331948250166, -713.5331107967327, -713.5332861625531, -713.5331092136899, -713.5332845794889, -713.5332124486396, -713.5331845094536, -713.5332108655494, -713.5331829264365, -713.5331823362632, -713.5332146226264, -713.533180753204, -713.5332130395784, -713.5331706402376, -713.533226318282, -713.5331690571952, -713.5332247352167, -713.5331996632127, -713.5331972947787, -713.5331980801661, -713.5331957117179, -713.5332098141137, -713.5331871437852, -713.5332082310571, -713.5331855607345, -713.5332003559452, -713.5331948967604, -713.5332004781475, -713.5331950189626, -713.5331991915106, -713.5331960612002, -713.5331993137127, -713.5331961834024, -713.5331976677017, -713.5331975849911, -713.5331977899037, 
  -713.5331977071933, -713.5331887210853, -713.5332065319576, -713.533188843292, -713.5332066541553, -713.5331988245878, -713.5331964281141, -713.5331989467898}
 {-394.925176770297, -394.9251768051273, -394.9251773243487, -394.9251762162612, -394.9251767354878, -394.9251769905665, -394.9251771389092, -394.9251764017023, -394.9251765500465, -394.9251765509338, -394.9251775785446, -394.9251759620731, -394.9251769896784, -394.9251796510782, -394.9251744784164, -394.925179062214, -394.9251738895535, -394.9251770259677, -394.925177103508, -394.9251764371043, -394.9251765146445, -394.925168366898, -394.9251857625983, -394.9251677780785, -394.9251851736909, -394.925170926123, -394.9251832033523, -394.9251703372593, -394.9251826144891, -394.9251734705329, -394.9251806589597, -394.9251728816703, -394.9251800700954, -394.9251450084587, -394.9252091224435, -394.9251444191661, -394.9252085340093, -394.9251723737393, -394.9251817558967, -394.9251717848796, 
  -394.9251811670295, -394.9251454716458, -394.925208658874, -394.9251448827762, -394.9252080700165, -394.9251782012052, -394.925175928322, -394.9251776122806, -394.9251753395196, -394.9251870535134, -394.925167075924, -394.9251864646475, -394.9251664870629, -394.9251258350127, -394.925228297789, -394.9251252461434, -394.9252277089313, -394.9251764365134, -394.9251765848568, -394.9251769557374, -394.9251771040809, -394.9251759968829, -394.92517702449, -394.9251765161058, -394.925177543715, -394.9251790970243, -394.9251739243648, -394.9251796162499, -394.9251744435871, -394.925176471915, -394.9251765494552, -394.925176991139, -394.9251770686793, -394.9251678128664, -394.9251852085245, -394.9251683320922, -394.9251857277469, -394.9251703720684, -394.9251826493015, -394.9251708912961, 
  -394.9251831685219, -394.9251729164804, -394.9251801049066, -394.9251734357047, -394.9251806241305, -394.9251444542073, -394.9252085685894, -394.9251449733995, -394.9252090878453, -394.9251718196938, -394.9251812018368, -394.9251723389071, -394.9251817210714, -394.9251449175913, -394.925208104823, -394.9251454368127, -394.9252086240496, -394.9251776471258, -394.9251753742959, -394.925178166342, -394.9251758935277, -394.9251864994589, -394.925166521873, -394.9251870186839, -394.925167041096, -394.9251252809588, -394.9252277437374, -394.9251258001794, -394.925228262965, -394.9251761823226, -394.9251772099307, -394.925176330666, -394.9251773582741, -394.9251792824653, -394.9251741098041, -394.9251794308087, -394.9251742581475, -394.9251766573552, -394.9251767348954, -394.9251768056986, 
  -394.9251768832389, -394.925167998308, -394.9251853939633, -394.9251681466504, -394.9251855423078, -394.9251705575104, -394.9251828347399, -394.9251707058539}
 {-301.0128596331815, -301.0128697425835, -301.0128732275969, -301.0128460388608, -301.0128495239223, -301.0128711677444, -301.0128718024304, -301.012847464042, -301.0128480987356, -301.0128656740347, -301.0128772961469, -301.0128419703663, -301.0128535924181, -301.0128634755822, -301.0128794946852, -301.012839771874, -301.0128557909963, -301.0128708600931, -301.0128721100817, -301.0128471563943, -301.0128484063833, -301.0128199792164, -301.0129229906172, -301.0127962757256, -301.0128992867108, -301.0128389501625, -301.0129040200114, -301.0128152464598, -301.0128803163169, -301.0128015638927, -301.0129414063202, -301.0127778601986, -301.0129177026172, -301.0129492296034, -301.0127937489559, -301.0129255279637, -301.0127700431986, -301.0129281235621, -301.0128148475425, -301.0129044198398, 
  -301.0127911438675, -301.0131252130095, -301.01261776274, -301.0131015093351, -301.0125940590171, -301.0129052405588, -301.0128377295114, -301.012881536696, -301.012814025977, -301.0128760021258, -301.012866968462, -301.0128522984076, -301.0128432647829, -301.0125376406047, -301.0132053478178, -301.0125139368814, -301.0131816441439, -301.0128575733213, -301.0128582080099, -301.0128610583577, -301.0128616930486, -301.0128520796284, -301.0128637017095, -301.0128555646649, -301.012867186748, -301.0128498811518, -301.012865900272, -301.0128533661969, -301.0128693853021, -301.0128572656712, -301.01285851566, -301.0128607507088, -301.0128620006975, -301.0128063848888, -301.0129093961011, -301.0128098699456, -301.0129128811195, -301.0128253557336, -301.0128904255965, -301.0128288407811, 
  -301.0128939106242, -301.0127879694724, -301.0129278118969, -301.0127914545114, -301.0129312969331, -301.012935636027, -301.0127801536888, -301.0129391214327, -301.0127836383581, -301.0129145291097, -301.0128012531512, -301.0129180141846, -301.0128047381514, -301.0131116185952, -301.0126041683106, -301.0131151036419, -301.0126076533389, -301.0128916460768, -301.0128241351498, -301.0128951310707, -301.0128276202311, -301.0128624076966, -301.0128533740475, -301.0128658927292, -301.01285685909, -301.0125240461761, -301.0131917534028, -301.0125275312024, -301.0131952384516, -301.0128535047988, -301.0128651268814, -301.0128541394891, -301.0128657615707, -301.0128513063268, -301.0128673254393, -301.0128519410163, -301.0128679601292, -301.0128586908423, -301.0128599408312, -301.0128593255321, 
  -301.0128605755209, -301.012807810073, -301.0129108212593, -301.012808444756, -301.0129114559559, -301.0128267809092, -301.0128918507633, -301.0128274156}
 {-422.637809596965, -422.6378164989559, -422.6378163383051, -422.6378028556503, -422.6378026950024, -422.6378164436328, -422.6378163936273, -422.6378028003286, -422.6378027503232, -422.6378170054958, -422.6378158317672, -422.63780336219, -422.6378021884646, -422.6378257687229, -422.6378070685802, -422.6378121254185, -422.637793425276, -422.6378164653608, -422.6378163718993, -422.6378028220568, -422.6378027285951, -422.6378167500116, -422.6378160872968, -422.6378031067012, -422.6378024439986, -422.6378099378131, -422.637822899472, -422.637796294509, -422.6378092561674, -422.6378168077275, -422.6378160296067, -422.6378031644233, -422.6378023863026, -422.6377902607654, -422.6378425792552, -422.6377766169817, -422.6378289364304, -422.6378247237395, -422.6378081138439, -422.6378110804449, 
  -422.63779447053, -422.6378277317271, -422.6378051085525, -422.6378140884178, -422.6377914652533, -422.6378384812743, -422.6377943558786, -422.637824837942, -422.6377807126024, -422.6378394401984, -422.6377933969393, -422.6378257968944, -422.637779753635, -422.6378294852038, -422.6378033533609, -422.6378158419003, -422.637789710056, -422.6378097022931, -422.6378096522875, -422.6378095416435, -422.6378094916383, -422.637810264156, -422.6378090904272, -422.6378101035049, -422.6378089297797, -422.6378190273833, -422.63780032724, -422.6378188667334, -422.6378001665912, -422.637809724021, -422.6378096305594, -422.6378095633717, -422.6378094699102, -422.6378100086675, -422.6378093459614, -422.6378098480207, -422.6378091853094, -422.6378031964735, -422.6378161581318, -422.6378030358238, 
  -422.6378159974828, -422.6378100663876, -422.637809288267, -422.6378099057383, -422.6378091276176, -422.6377835191984, -422.6378358381425, -422.6377833585238, -422.6378356775184, -422.6378179824116, -422.637801372492, -422.6378178217479, -422.637801211857, -422.6378209903856, -422.6377983672144, -422.6378208297346, -422.6377982065666, -422.63783173992, -422.6377876145534, -422.6378315792717, -422.6377874539028, -422.6378326988596, -422.6377866555985, -422.6378325382084, -422.637786494951, -422.6378227438643, -422.6377966120208, -422.6378225832151, -422.6377964513714, -422.6378102088328, -422.6378090351057, -422.6378101588272, -422.6378089851003, -422.6378189720607, -422.6378002719179, -422.6378189220551, -422.6378002219124, -422.6378096686987, -422.6378095752371, -422.6378096186932, 
  -422.6378095252316, -422.6378099533475, -422.6378092906366, -422.6378099033398, -422.6378092406331, -422.6378031411509, -422.6378161028096, -422.6378030911453}
 {-24.59815461599978, -24.59815462860024, -24.59815462770595, -24.59815460429365, -24.59815460339935, -24.59815462829999, -24.59815462800619, -24.5981546039934, -24.5981546036996, -24.59815598334919, -24.59815327297471, -24.59815595903973, -24.59815324867099, -24.59815497089695, -24.59815428541073, -24.59815494659061, -24.5981542611039, -24.59815464328519, -24.598154613021, -24.59815461897858, -24.59815458871442, -24.59814786983685, -24.59816138715976, -24.5981478455363, -24.59816136284712, -24.59815500196757, -24.59815425434101, -24.59815497766119, -24.5981542300342, -24.59815541668691, -24.59815383962446, -24.59815539237997, -24.59815381531821, -24.59815476307702, -24.59815449323106, -24.59815473876987, -24.59815446892502, -24.5981528412594, -24.5981564150704, -24.59815281695364, 
  -24.59815639076298, -24.59815894474386, -24.59815031185752, -24.59815892044023, -24.59815028754796, -24.59815462949821, -24.59815462680799, -24.59815460519161, -24.5981546025014, -24.59816005706721, -24.59814919921373, -24.59816003276143, -24.59814917490633, -24.59816907078819, -24.59814018532664, -24.59816904648026, -24.59814016102139, -24.59815461659383, -24.59815461630003, -24.59815461569954, -24.59815461540574, -24.59815597164158, -24.59815326127, -24.5981559707473, -24.59815326037568, -24.59815495919092, -24.59815427370445, -24.59815495829662, -24.59815427281016, -24.59815463157902, -24.59815460131485, -24.59815463068472, -24.59815460042055, -24.59814785813377, -24.59816137545051, -24.59814785723935, -24.59816137455634, -24.59815499026151, -24.59815424263474, -24.59815498936721, 
  -24.59815424174045, -24.59815540498057, -24.59815382791847, -24.59815540408628, -24.59815382702417, -24.59815475137058, -24.59815448152517, -24.59815475047629, -24.59815448063087, -24.59815282955366, -24.59815640336381, -24.59815282865934, -24.59815640246954, -24.5981589330392, -24.59815030014985, -24.59815893214485, -24.59815029925561, -24.59815461779204, -24.59815461510183, -24.59815461689774, -24.59815461420753, -24.59816004536147, -24.59814918750716, -24.59816004446715, -24.59814918661288, -24.59816905908135, -24.59814017362116, -24.59816905818708, -24.59814017272684, -24.59815597134135, -24.59815326096973, -24.59815597104754, -24.59815326067595, -24.59815495889067, -24.5981542734042, -24.59815495859687, -24.5981542731104, -24.59815463127877, -24.5981546010146, -24.59815463098497, 
  -24.5981546007208, -24.59814785783347, -24.59816137515031, -24.59814785753965, -24.59816137485654, -24.59815498996126, -24.59815424233449, -24.59815498966746}
 {-326.8317963529547, -326.8317968949043, -326.8317968693209, -326.8317958365886, -326.8317958110054, -326.831796879855, -326.8317968843701, -326.8317958215394, -326.8317958260545, -326.8317968705651, -326.83179689366, -326.8317958122496, -326.8317958353445, -326.8317970252657, -326.8317967389622, -326.8317959669501, -326.8317956806467, -326.8317969014075, -326.8317968628176, -326.831795843092, -326.831795804502, -326.8317974191563, -326.8317963450665, -326.8317963608408, -326.8317952867509, -326.8318004681372, -326.8317932960915, -326.8317994098216, -326.831792237776, -326.8317926531155, -326.8318011111193, -326.8317915947998, -326.8318000528038, -326.831797569342, -326.8317961950517, -326.8317965110232, -326.8317951367392, -326.8317995952599, -326.8317941689856, -326.8317985369443, 
  -326.8317931106702, -326.8317699435895, -326.8318238208842, -326.831768885274, -326.8318227625686, -326.8318029273273, -326.8317908368614, -326.8318018690118, -326.8317897785457, -326.8318025225766, -326.8317912416193, -326.8318014642611, -326.8317901833036, -326.8317668375766, -326.8318269285233, -326.831765779261, -326.8318258702077, -326.8317963634888, -326.831796368004, -326.8317963379055, -326.8317963424206, -326.831796354199, -326.8317963772938, -326.8317963286156, -326.8317963517105, -326.8317965088996, -326.831796222596, -326.8317964833162, -326.8317961970128, -326.8317963850413, -326.8317963464514, -326.8317963594581, -326.831796320868, -326.8317969027902, -326.8317958287002, -326.8317968772068, -326.831795803117, -326.831799951771, -326.8317927797254, -326.8317999261877, 
  -326.831792754142, -326.8317921367493, -326.8318005947531, -326.8317921111659, -326.8318005691698, -326.8317970529703, -326.8317956786909, -326.8317970273947, -326.8317956530999, -326.8317990788941, -326.831793652619, -326.83179905331, -326.8317936270365, -326.8317694272233, -326.831823304518, -326.8317694016402, -326.8318232789345, -326.831802410961, -326.8317903204953, -326.8318023853779, -326.8317902949117, -326.8318020062105, -326.8317907252531, -326.8318019806272, -326.8317906996698, -326.8317663212104, -326.8318264121571, -326.8317662956272, -326.8318263865738, -326.8317963391497, -326.8317963622446, -326.8317963436648, -326.8317963667597, -326.8317964938503, -326.8317962075468, -326.8317964983654, -326.8317962120619, -326.831796369992, -326.8317963314021, -326.8317963745072, 
  -326.8317963359173, -326.8317968877409, -326.831795813651, -326.831796892256, -326.8317958181662, -326.8317999367217, -326.8317927646761, -326.8317999412369}
 {-267.2657389625468, -267.2657414928205, -267.2657408786792, -267.2657370464368, -267.2657364322965, -267.2657413835433, -267.2657409879563, -267.2657369371611, -267.2657365415721, -267.265740089249, -267.265742282253, -267.265735642861, -267.2657378358746, -267.2657426618856, -267.2657397096385, -267.2657382155017, -267.265735263256, -267.2657413669037, -267.2657410045958, -267.2657369205206, -267.2657365582126, -267.2657536466051, -267.2657287243988, -267.265749200156, -267.2657242780816, -267.265734870261, -267.2657475012072, -267.2657304238771, -267.2657430548249, -267.2657110452358, -267.265771326354, -267.2657065988527, -267.2657668799707, -267.265773340068, -267.2657090330998, -267.265768894053, -267.2657045863484, -267.2657490318369, -267.2657333398973, -267.2657445854487, 
  -267.2657288935192, -267.265613928978, -267.2658684444053, -267.2656094826016, -267.2658639980154, -267.2657497617496, -267.2657326097384, -267.2657453153249, -267.2657281633967, -267.2657226375134, -267.2657597345401, -267.2657181911307, -267.2657552881565, -267.2656393401413, -267.2658430374771, -267.2656348937675, -267.2658385910846, -267.2657394674114, -267.2657390718233, -267.2657388532705, -267.2657384576827, -267.265738173115, -267.2657403661223, -267.2657375589726, -267.2657397519831, -267.2657407457536, -267.2657377935057, -267.2657401316114, -267.2657371793664, -267.2657394507713, -267.2657390884634, -267.2657388366306, -267.2657384743227, -267.2657517304363, -267.2657268083028, -267.2657511163025, -267.2657261941553, -267.2657329541296, -267.265745585074, -267.2657323399863, 
  -267.2657449709358, -267.2657091291035, -267.2657694102215, -267.2657085149628, -267.2657687960808, -267.2657714241331, -267.2657071167698, -267.2657708099655, -267.265706502656, -267.2657471156934, -267.265731423776, -267.2657465015698, -267.2657308096182, -267.2656120128489, -267.2658665282696, -267.2656113987084, -267.2658659141287, -267.265747845593, -267.2657306936302, -267.2657472314591, -267.2657300794826, -267.2657207213819, -267.2657578184068, -267.2657201072399, -267.2657572042674, -267.265637424013, -267.2658411213407, -267.2656368098735, -267.2658405071987, -267.2657380638376, -267.2657402568465, -267.2657376682497, -267.2657398612587, -267.2657406364764, -267.2657376842299, -267.2657402408883, -267.265737288642, -267.2657393414948, -267.2657389791869, -267.2657389459069, 
  -267.265738583599, -267.2657516211639, -267.2657266990222, -267.2657512255746, -267.2657263034357, -267.2657328448519, -267.2657454757986, -267.2657324492635}
 {-373.4426851730139, -373.4426874494159, -373.442686267595, -373.4426840784529, -373.4426828966284, -373.4426868412709, -373.4426868757395, -373.4426834703059, -373.4426835047749, -373.4426880804142, -373.4426856365956, -373.4426847094403, -373.4426822656398, -373.4426844725586, -373.44268924447, -373.4426811015926, -373.4426858735061, -373.442686911799, -373.4426868052114, -373.4426835408341, -373.4426834342466, -373.4426840352604, -373.4426896817859, -373.4426806643095, -373.442686310807, -373.4426899718188, -373.4426837452157, -373.4426866008546, -373.4426803742502, -373.4426888085171, -373.4426849085101, -373.4426854375525, -373.442681537545, -373.4426570541606, -373.442716664273, -373.4426536828933, -373.4427132936106, -373.4427057638631, -373.4426679532996, -373.4427023929, 
  -373.4426645823329, -373.4426674858806, -373.4427062320724, -373.4426641149117, -373.4427028611118, -373.4426894853268, -373.4426842317085, -373.4426861143281, -373.4426808607775, -373.442680752074, -373.4426929651202, -373.4426773811117, -373.4426895941529, -373.4426959629582, -373.442677754107, -373.4426925919916, -373.4426743831438, -373.4426857466911, -373.44268578116, -373.4426845648684, -373.4426845993373, -373.4426869858309, -373.4426845420195, -373.4426858040064, -373.4426833601987, -373.4426833779807, -373.4426881498885, -373.4426821961533, -373.4426869680704, -373.4426858172193, -373.4426857106317, -373.4426846353966, -373.4426845288091, -373.4426829406876, -373.4426885871994, -373.4426817588653, -373.4426874053764, -373.4426888772384, -373.4426826506367, -373.4426876954178, 
  -373.442681468812, -373.4426877139375, -373.4426838139304, -373.4426865321149, -373.4426826321076, -373.4426559594056, -373.4427155698687, -373.4426547776312, -373.4427143879977, -373.4427046692899, -373.4426668587134, -373.442703487456, -373.4426656769019, -373.4426663912999, -373.4427051374939, -373.4426652094753, -373.442703955673, -373.4426883907238, -373.4426831371522, -373.442687208914, -373.4426819553167, -373.4426796574955, -373.4426918705394, -373.4426784756729, -373.4426906887166, -373.4426948683783, -373.4426766595275, -373.4426936865543, -373.4426754777062, -373.4426863776839, -373.4426839338744, -373.4426864121528, -373.4426839683432, -373.4426827698324, -373.4426875417447, -373.4426828043012, -373.4426875762136, -373.4426852090733, -373.4426851024857, -373.4426852435421, 
  -373.4426851369546, -373.4426823325422, -373.4426879790527, -373.4426823670101, -373.4426880135225, -373.4426882690935, -373.4426820424896, -373.4426883035622}
 {-252.3459684691062, -252.3459487559386, -252.3459486616549, -252.345988276732, -252.3459881824595, -252.3459483638137, -252.345949053778, -252.3459878846094, -252.3459885745805, -252.3459498902427, -252.3459475273852, -252.3459894110421, -252.345987048184, -252.3459580668431, -252.3459393508478, -252.3459975876419, -252.3459788716471, -252.3459487857413, -252.3459486318503, -252.3459883065404, -252.3459881526495, -252.3459096150865, -252.3459878037131, -252.3459491359694, -252.3460273244282, -252.3459517850283, -252.3459456326619, -252.3459913058238, -252.3459851534644, -252.3459636208877, -252.345933796832, -252.3460031416875, -252.3459733176304, -252.3461634197839, -252.3457340046372, -252.3462029449812, -252.3457735210381, -252.3459369901826, -252.3459604282078, -252.3459765108969, 
  -252.3459999490915, -252.346038180378, -252.3458592442778, -252.3460777012354, -252.3458987650185, -252.3459702061678, -252.3459272118367, -252.3460097260585, -252.3459667335441, -252.3459944515473, -252.3459029660933, -252.3460339723393, -252.3459424868995, -252.3460990813034, -252.3457983350508, -252.3461386020926, -252.3458378558597, -252.3459681712624, -252.34596886123, -252.3459680769843, -252.3459687669519, -252.3459696976937, -252.345967334835, -252.3459696034147, -252.3459672405577, -252.3459778742944, -252.3459591582971, -252.3459777800141, -252.3459590640212, -252.3459685931916, -252.3459684393008, -252.3459684989137, -252.3459683450225, -252.3459294225806, -252.3460076111196, -252.3459293282988, -252.3460075168452, -252.3459715924749, -252.3459654401157, -252.3459714982006, 
  -252.3459653458339, -252.3459834283387, -252.3459536042817, -252.3459833340601, -252.3459535100041, -252.346183229403, -252.3457538099186, -252.3461831351854, -252.3457537155802, -252.3459567975247, -252.3459802357663, -252.3459567033783, -252.3459801413565, -252.3460579878527, -252.3458790517035, -252.3460578935841, -252.3458789574161, -252.3459900131663, -252.3459470197387, -252.3459899188834, -252.3459469254655, -252.3460142589936, -252.3459227735476, -252.3460141647165, -252.3459226792686, -252.3461188887503, -252.3458181425044, -252.3461187944691, -252.3458180482295, -252.3459693055695, -252.3459669427117, -252.3459699955372, -252.3459676326793, -252.3459774821695, -252.3459587661744, -252.3459781721372, -252.3459594561421, -252.345968201068, -252.345968047177, -252.3459688910356, 
  -252.3459687371446, -252.3459290304535, -252.3460072189994, -252.3459297204243, -252.3460079089637, -252.3459712003532, -252.3459650479899, -252.3459718903206}
 {-361.1605071939084, -361.160508062148, -361.1605078923231, -361.1605064954952, -361.1605063256693, -361.1605079723609, -361.1605079821101, -361.1605064057076, -361.1605064154568, -361.1605081656142, -361.1605077888567, -361.1605065989609, -361.1605062222035, -361.1605066675403, -361.1605092869379, -361.160505100887, -361.1605077202846, -361.1605080059424, -361.1605079485285, -361.1605064392891, -361.1605063818752, -361.1605078591047, -361.1605080953663, -361.1605062924513, -361.1605065287129, -361.1605081945281, -361.1605077599428, -361.1605066278748, -361.1605061932895, -361.1605084908748, -361.1605074635958, -361.1605069242215, -361.1605058969424, -361.1605038624653, -361.1605120923058, -361.1605022957589, -361.1605105257056, -361.1605131548649, -361.1605027996411, -361.1605115882127, 
  -361.1605012329868, -361.160506684222, -361.1605092702502, -361.1605051175684, -361.1605077035971, -361.1605199079962, -361.1604960464047, -361.1605183413407, -361.1604944797536, -361.1605156197142, -361.1605003347646, -361.1605140530609, -361.1604987681112, -361.1605075433566, -361.1605084111082, -361.1605059767034, -361.1605068444549, -361.1605072739466, -361.1605072836959, -361.1605071041212, -361.1605071138704, -361.1605074672, -361.1605070904425, -361.1605072973745, -361.1605069206171, -361.1605059691262, -361.1605085885237, -361.1605057993007, -361.1605084186982, -361.1605073075282, -361.1605072501143, -361.1605071377027, -361.1605070802888, -361.1605071606904, -361.1605073969521, -361.160506990865, -361.1605072271266, -361.1605074961139, -361.1605070615286, -361.1605073262884, 
  -361.1605068917032, -361.1605077924607, -361.1605067651816, -361.1605076226352, -361.1605065953562, -361.1605031640162, -361.1605113939264, -361.1605029942073, -361.1605112240845, -361.1605124564527, -361.1605021012248, -361.1605122866242, -361.1605019314025, -361.1605059858074, -361.1605085718362, -361.1605058159823, -361.1605084020105, -361.1605192095799, -361.1604953479925, -361.1605190397564, -361.1604951781651, -361.1605149213001, -361.1604996363503, -361.1605147514747, -361.1604994665249, -361.1605068449424, -361.160507712694, -361.160506675117, -361.1605075428685, -361.1605073774125, -361.1605070006552, -361.1605073871617, -361.1605070104043, -361.1605058793386, -361.1605084987362, -361.1605058890879, -361.1605085084854, -361.1605072177407, -361.1605071603268, -361.1605072274899, 
  -361.1605071700761, -361.160507070903, -361.1605073071645, -361.1605070806521, -361.1605073169139, -361.1605074063264, -361.1605069717411, -361.1605074160757}
 {-195.0601784541622, -195.0601801334056, -195.0601804575876, -195.0601764507513, -195.0601767749377, -195.0601803108182, -195.0601802801745, -195.0601766281662, -195.0601765975223, -195.0601798046997, -195.0601807862943, -195.060176122051, -195.060177103639, -195.060181500948, -195.0601790900611, -195.0601778182957, -195.0601754074092, -195.0601803247725, -195.0601802662202, -195.0601766421205, -195.0601765835681, -195.0601833357254, -195.0601772553031, -195.0601796530589, -195.0601735726655, -195.060182185723, -195.0601784052804, -195.0601785030706, -195.0601747226286, -195.0601822749407, -195.060178316069, -195.0601785922882, -195.0601746334173, -195.0602000773751, -195.0601605150281, -195.060196395011, -195.0601568320882, -195.0601894079679, -195.0601711831763, -195.0601857253144, 
  -195.0601675005256, -195.0601614219012, -195.0601991700343, -195.0601577392533, -195.0601954873779, -195.0601845542057, -195.060176036783, -195.060180871527, -195.0601723541574, -195.0601831495771, -195.0601774414389, -195.0601794669226, -195.0601737587892, -195.0601896431125, -195.0601709479236, -195.0601859604622, -195.0601672652697, -195.0601783073922, -195.0601782767484, -195.0601786315764, -195.0601786009326, -195.0601778012757, -195.0601787828662, -195.0601781254591, -195.0601791070513, -195.0601794975214, -195.0601770866356, -195.0601798217064, -195.060177410819, -195.0601783213465, -195.0601782627941, -195.0601786455307, -195.0601785869783, -195.0601813322925, -195.0601752518839, -195.060181656476, -195.0601755760689, -195.0601801822972, -195.060176401854, -195.0601805064805, 
  -195.0601767260392, -195.0601802715145, -195.0601763126431, -195.0601805956986, -195.0601766368274, -195.0601980740753, -195.0601585114759, -195.060198398295, -195.0601588356246, -195.0601874045379, -195.0601691797542, -195.0601877287285, -195.060169503932, -195.0601594184764, -195.0601971666068, -195.0601597426622, -195.0601974907895, -195.0601825507687, -195.0601740333677, -195.0601828749481, -195.0601743575567, -195.0601811461505, -195.0601754380133, -195.0601814703334, -195.0601757621989, -195.0601876396869, -195.0601689444969, -195.0601879638719, -195.0601692686804, -195.0601779786891, -195.0601789602804, -195.0601779480453, -195.0601789296366, -195.0601796749356, -195.060177264049, -195.0601796442918, -195.0601772334051, -195.0601784987602, -195.0601784402079, -195.0601784681165, 
  -195.0601784095641, -195.0601815097064, -195.0601754292976, -195.0601814790617, -195.0601753986547, -195.0601803597105, -195.0601765792683, -195.0601803290667}
 {-480.5488998846879, -480.5488928097623, -480.548891320179, -480.5489084492219, -480.5489069596377, -480.5488921243259, -480.5488920056161, -480.5489077637854, -480.5489076450749, -480.5488948051168, -480.5488893248361, -480.5489104445569, -480.5489049643141, -480.5488953548428, -480.5488887751557, -480.5489109943001, -480.5489044146166, -480.5488919738663, -480.5488921560759, -480.5489076133252, -480.548907795535, -480.5488999170084, -480.5488842130963, -480.5489155564318, -480.548899852591, -480.5488919827629, -480.5488921471832, -480.5489076222222, -480.548907786642, -480.5488939697858, -480.5488901601742, -480.5489096092442, -480.5489057996339, -480.5487731838663, -480.5490109488977, -480.548788821937, -480.5490265897452, -480.5489139310255, -480.548870199299, -480.5489295704868, 
  -480.5488858387561, -480.5489114960119, -480.5488726348728, -480.5489271354605, -480.5488882743425, -480.5488753392202, -480.5489087911665, -480.5488909783365, -480.5489244309686, -480.5489027912516, -480.548881338714, -480.5489184307169, -480.548896978167, -480.5489011878818, -480.5488829421146, -480.5489168273454, -480.5488985815693, -480.5489006888346, -480.5489005701243, -480.5488991992508, -480.5488990805405, -480.5489033696163, -480.5488978893534, -480.5489018800314, -480.5488963997708, -480.5489039193541, -480.5488973396614, -480.5489024297628, -480.5488958500851, -480.5489005383746, -480.5489007205844, -480.5488990487908, -480.5488992310005, -480.5489084815004, -480.5488927776211, -480.5489069919138, -480.5488912880402, -480.5489005472728, -480.54890071169, -480.5488990576862, 
  -480.5488992221091, -480.548902534294, -480.5488987246829, -480.54890104471, -480.5488972350992, -480.5487817476708, -480.54901951411, -480.5487802581064, -480.549018024507, -480.5489224955565, -480.548878763785, -480.54892100593, -480.5488772742439, -480.5489200605173, -480.5488811993844, -480.5489185709292, -480.5488797098049, -480.5488839035517, -480.548917355852, -480.548882413979, -480.5489158662572, -480.5489113557622, -480.5488899032204, -480.5489098661804, -480.5488884136347, -480.5489097523912, -480.5488915066221, -480.5489082628101, -480.5488900170357, -480.5489026841792, -480.5488972039177, -480.5489025654692, -480.5488970852072, -480.5489032339141, -480.5488966542286, -480.5489031152035, -480.5488965355186, -480.5488998529382, -480.5489000351479, -480.5488997342279, 
  -480.5488999164377, -480.5489077960619, -480.5488920921867, -480.548907677353, -480.5488919734752, -480.5488998618354, -480.5489000262546, -480.5488997431242}
 {-20.07398568707148, -20.07399206986614, -20.07399227838271, -20.0739790958916, -20.07397930443527, -20.07399217578834, -20.07399217245939, -20.07397920182758, -20.07397919849816, -20.0739927637126, -20.07399158455586, -20.07397978973892, -20.07397861060755, -20.07399952318122, -20.07398482512435, -20.07398654921288, -20.0739718511707, -20.07399218472135, -20.07399216352639, -20.07397921076037, -20.07397918956539, -20.07400206490936, -20.07398228359293, -20.07398909090023, -20.07396930968006, -20.07399342649493, -20.07399092175935, -20.07398045253643, -20.07397794779586, -20.07399435405758, -20.07398999420698, -20.07398138009543, -20.07397702024716, -20.07403511981086, -20.07394923227006, -20.07402214705036, -20.07393625710864, -20.07400026244945, -20.07398408621502, -20.07398728846309, 
  -20.07397111227939, -20.07397274857122, -20.07401160058966, -20.07395977462721, -20.07399862661168, -20.07400626038991, -20.07397808782158, -20.073993286375, -20.0739651139145, -20.07400677376896, -20.07397757443631, -20.07399379980696, -20.07396460047631, -20.07400128022345, -20.0739830680799, -20.07398830626846, -20.0739700941129, -20.0739855844716, -20.0739855811424, -20.07398579300171, -20.07398578967254, -20.07398617239132, -20.0739849932434, -20.07398638091758, -20.07398520177739, -20.07399293186078, -20.07397823381106, -20.07399314039071, -20.07397844234138, -20.07398559340449, -20.07398557220952, -20.07398580193462, -20.07398578073965, -20.07399547356977, -20.07397569229879, -20.0739956820972, -20.07397590083159, -20.07398683517917, -20.07398433044139, -20.07398704370959, 
  -20.07398453897121, -20.07398776274016, -20.07398340289068, -20.07398797127024, -20.07398361142085, -20.07402852905471, -20.07394264039251, -20.07402873766389, -20.07394284884358, -20.07399367111334, -20.0739774949174, -20.07399387965659, -20.07397770343439, -20.0739661572624, -20.07400500926476, -20.07396636579343, -20.07400521779398, -20.07399966904861, -20.07397149652915, -20.07399987757369, -20.07397170506432, -20.07400018245288, -20.07397098311865, -20.07400039098043, -20.07397119165136, -20.07399468890942, -20.07397647676021, -20.07399489743988, -20.07397668528999, -20.0739862783185, -20.07398509917442, -20.07398627498929, -20.07398509584526, -20.07399303778976, -20.07397833974026, -20.0739930344606, -20.07397833641106, -20.07398569933358, -20.07398567813862, -20.07398569600441, 
  -20.07398567480942, -20.07399557949873, -20.073975798228, -20.07399557616712, -20.07397579490125, -20.07398694110836, -20.07398443637038, -20.07398693777926}
 {-172.7359149350898, -172.7359110275301, -172.7359114200881, -172.7359184501053, -172.735918842666, -172.7359111783127, -172.7359112693059, -172.7359186008888, -172.7359186918828, -172.7359111880751, -172.7359112595487, -172.7359186106525, -172.7359186821242, -172.7359140437243, -172.7359084039123, -172.7359214663006, -172.735915826489, -172.7359112289927, -172.7359112186259, -172.7359186515692, -172.7359186412024, -172.7359056251456, -172.7359168226171, -172.7359130477422, -172.7359242451736, -172.7359108743718, -172.7359115732531, -172.7359182969482, -172.7359189958297, -172.7359131893205, -172.735909258317, -172.7359206118974, -172.7359166808931, -172.73596616109, -172.7358562879533, -172.7359735843438, -172.7358637098525, -172.7359101172193, -172.7359123305516, -172.7359175397907, 
  -172.7359197531333, -172.7359276311089, -172.7358948174524, -172.7359350536946, -172.7359022400197, -172.7359041356932, -172.7359183121249, -172.7359115581094, -172.7359257348618, -172.7359171189289, -172.7359053286535, -172.7359245415042, -172.7359127512313, -172.7359224334212, -172.7359000141547, -172.7359298559946, -172.7359074367343, -172.7359146933131, -172.7359147843068, -172.7359150858725, -172.7359151768662, -172.7359147030767, -172.7359147745484, -172.7359150956351, -172.7359151671087, -172.7359175587242, -172.7359119189138, -172.7359179512849, -172.7359123114718, -172.7359147439934, -172.7359147336266, -172.7359151365528, -172.7359151261859, -172.7359091401567, -172.7359203376075, -172.7359095327154, -172.7359207301675, -172.7359143893715, -172.7359150882548, 
  -172.7359147819327, -172.7359154808122, -172.7359167043213, -172.7359127733175, -172.7359170968808, -172.7359131658768, -172.7359696764192, -172.7358598026254, -172.7359700689987, -172.7358601951646, -172.7359136322081, -172.7359158455642, -172.7359140247861, -172.7359162381049, -172.7359311461122, -172.7358983324505, -172.7359315386755, -172.7358987250059, -172.7359076506178, -172.7359218272017, -172.735908043169, -172.7359222197692, -172.7359206339279, -172.735908843656, -172.7359210264894, -172.7359092362131, -172.7359259484213, -172.735903529156, -172.7359263409787, -172.7359039217172, -172.7359148538593, -172.7359149253319, -172.7359149448529, -172.7359150163256, -172.7359177095079, -172.7359120696962, -172.7359178005016, -172.7359121606898, -172.7359148947765, -172.7359148844096, 
  -172.7359149857701, -172.7359149754032, -172.7359092909393, -172.7359204883909, -172.7359093819331, -172.7359205793844, -172.7359145401554, -172.735915239037, -172.7359146311492}
 {-237.2042598090665, -237.2042594316732, -237.2042559193351, -237.2042636989009, -237.2042601865415, -237.2042577918022, -237.2042575592045, -237.2042620590199, -237.2042618264209, -237.2042625685502, -237.2042527824678, -237.2042668357447, -237.2042570497074, -237.2042579786955, -237.2042573723578, -237.204262245912, -237.2042616395754, -237.2042574654874, -237.2042578855192, -237.2042617327044, -237.2042621527364, -237.2042663176488, -237.2042490338238, -237.2042705847995, -237.2042533011073, -237.204248087916, -237.2042672631553, -237.2042523551337, -237.2042715303716, -237.2042650271645, -237.2042503239215, -237.2042692943808, -237.2042545911393, -237.2043766662973, -237.2041386890243, -237.2043809353921, -237.2041429543638, -237.2042142832864, -237.2043010682629, -237.2042185504663, 
  -237.2043053355172, -237.2041870902811, -237.2043282654527, -237.2041913575266, -237.2043325326415, -237.2042878017742, -237.2042275492698, -237.204292068663, -237.2042318168151, -237.2042849845685, -237.2042303666046, -237.2042892517924, -237.2042346338148, -237.2043033424633, -237.204212010723, -237.2043076096895, -237.204216277931, -237.2042616815409, -237.2042614489424, -237.204258169192, -237.2042579365938, -237.2042664582783, -237.2042566722162, -237.2042629459272, -237.2042531598698, -237.2042618684373, -237.2042612620926, -237.204258356081, -237.2042577497513, -237.2042613552257, -237.2042617752576, -237.2042578428769, -237.2042582629088, -237.2042702073545, -237.2042529235947, -237.2042666950046, -237.2042494112472, -237.2042519776563, -237.2042711528915, -237.2042484653042, 
  -237.2042676405461, -237.2042689169024, -237.2042542136602, -237.2042654045536, -237.2042507013114, -237.2043805570417, -237.2041425777565, -237.2043770445584, -237.2041390655424, -237.2042181729708, -237.2043049580551, -237.2042146606926, -237.2043014456358, -237.2041909800328, -237.2043321551777, -237.2041874676857, -237.2043286428273, -237.2042916913283, -237.2042314391924, -237.2042881790198, -237.2042279268034, -237.2042888743115, -237.2042342563381, -237.2042853619602, -237.204230743992, -237.2043072322044, -237.2042159004585, -237.2043037198591, -237.2042123881064, -237.2042648184013, -237.2042550323413, -237.2042645858027, -237.204254799743, -237.2042602285576, -237.2042596222202, -237.204259995959, -237.2042593896221, -237.2042597153497, -237.2042601353816, -237.2042594827513, 
  -237.2042599027832, -237.2042685674791, -237.2042512837182, -237.2042683348783, -237.2042510511222, -237.204250337779, -237.2042695130169, -237.2042501051799}
 {-431.3197267052304, -431.3197298469081, -431.3197294505319, -431.3197239599477, -431.3197235635725, -431.3197296444306, -431.3197296530087, -431.3197237574707, -431.319723766049, -431.319729953889, -431.3197293435503, -431.3197240669257, -431.3197234565939, -431.3197292912354, -431.3197300062227, -431.3197234042747, -431.3197241192638, -431.3197296960733, -431.319729601366, -431.3197238091135, -431.3197237144061, -431.3197291351345, -431.3197301623189, -431.3197232481793, -431.3197242753544, -431.3197323612236, -431.3197269362317, -431.3197264742642, -431.3197210492715, -431.3197313968498, -431.3197279006061, -431.3197255098901, -431.3197220136461, -431.3197387944529, -431.3197205044121, -431.319732907564, -431.3197146173814, -431.3197151174909, -431.3197441801009, -431.3197092305307, 
  -431.3197382931413, -431.3197505899582, -431.3197087084238, -431.3197447029995, -431.3197028214629, -431.3197353755863, -431.3197239218225, -431.3197294886249, -431.3197180348642, -431.3197284048469, -431.3197308926894, -431.3197225178871, -431.3197250057295, -431.3197376839594, -431.319721613584, -431.319731796999, -431.3197157266247, -431.3197268991294, -431.3197269077077, -431.3197265027537, -431.3197265113319, -431.3197272085869, -431.3197265982501, -431.3197268122097, -431.3197262018759, -431.3197265459347, -431.319727260921, -431.3197261495571, -431.3197268645473, -431.3197269507722, -431.3197268560648, -431.3197265543964, -431.3197264596892, -431.3197263898354, -431.3197274170157, -431.3197259934602, -431.3197270206396, -431.3197296159222, -431.3197241909308, -431.3197292195474, 
  -431.3197237945543, -431.3197286515488, -431.3197251553049, -431.319728255173, -431.3197247589292, -431.3197360492074, -431.3197177590554, -431.3197356527914, -431.31971736272, -431.3197123721876, -431.3197414348018, -431.319711975816, -431.3197410384221, -431.3197478446574, -431.3197059631223, -431.3197474482822, -431.3197055667461, -431.3197326302824, -431.3197211765241, -431.3197322339108, -431.3197207801443, -431.3197256595463, -431.3197281473878, -431.3197252631696, -431.319727751013, -431.3197349386583, -431.3197188682828, -431.319734542282, -431.3197184719077, -431.3197270061089, -431.3197263957736, -431.3197270146871, -431.3197264043518, -431.3197263434565, -431.3197270584448, -431.3197263520347, -431.319727067023, -431.319726748295, -431.3197266535876, -431.3197267568731, 
  -431.3197266621659, -431.3197261873589, -431.3197272145376, -431.319726195936, -431.319727223117, -431.3197294134455, -431.3197239884531, -431.3197294220235}
 {-271.1505846222243, -271.1505884986587, -271.1505899506623, -271.1505792938135, -271.1505807458402, -271.1505891306266, -271.1505893186918, -271.1505799257917, -271.1505801138591, -271.1505868235958, -271.1505916257261, -271.1505776187676, -271.1505824208869, -271.1505831584287, -271.1505952909552, -271.1505739535915, -271.1505860861249, -271.1505889012522, -271.1505895480661, -271.1505796964185, -271.1505803432324, -271.1505881220714, -271.1505903273317, -271.1505789172407, -271.1505811224951, -271.15058822854, -271.1505902208564, -271.1505790237065, -271.1505810160225, -271.1505968192147, -271.150581630221, -271.1505876143812, -271.1505724253871, -271.15061121294, -271.1505672389624, -271.1506020087947, -271.1505580334404, -271.1506123836146, -271.1505660659982, -271.1506031787665, 
  -271.1505568611788, -271.150596360017, -271.1505820907379, -271.1505871551893, -271.1505728858984, -271.1506055027765, -271.1505729464658, -271.1505962978909, -271.1505637416841, -271.1505931244845, -271.1505853249849, -271.1505839196473, -271.1505761201547, -271.1506155798145, -271.1505628692243, -271.1506063749807, -271.1505536643908, -271.1505838021854, -271.150583990251, -271.1505852541998, -271.1505854422668, -271.1505814951577, -271.1505862972824, -271.1505829471727, -271.1505877492975, -271.1505778299855, -271.1505899625165, -271.1505792820018, -271.1505914145304, -271.1505835728112, -271.1505842196252, -271.1505850248263, -271.1505856716402, -271.1505827936318, -271.1505849988895, -271.1505842456473, -271.1505864509042, -271.1505829000991, -271.1505848924153, -271.1505843521143, 
  -271.1505863444303, -271.1505914907737, -271.1505763017801, -271.1505929427889, -271.1505777537951, -271.1506058847683, -271.1505619102524, -271.1506073369334, -271.1505633621174, -271.1506070551615, -271.1505607375692, -271.1506085071863, -271.1505621895746, -271.1505910315777, -271.1505767622955, -271.1505924835955, -271.1505782143078, -271.1506001743186, -271.150567618042, -271.1506016263159, -271.1505690700749, -271.150587796043, -271.1505799965445, -271.1505892480556, -271.150581448562, -271.1506102513736, -271.1505575407835, -271.1506117033885, -271.1505589927987, -271.1505821271304, -271.1505869292556, -271.150582315197, -271.1505871173215, -271.1505784619591, -271.150590594489, -271.1505786500253, -271.1505907825553, -271.1505842047843, -271.1505848515982, -271.1505843928506, 
  -271.1505850396644, -271.150583425606, -271.1505856308613, -271.1505836136703, -271.1505858189296, -271.150583532072, -271.1505855243884, -271.1505837201386}
 {-313.8095800174034, -313.8095831179212, -313.8095830224209, -313.8095770124027, -313.8095769169052, -313.8095830719869, -313.8095830683544, -313.8095769664698, -313.8095769628375, -313.8095829803989, -313.8095831599431, -313.8095768748819, -313.8095770544261, -313.8095838296489, -313.8095823107073, -313.809577724131, -313.809576205191, -313.8095830424192, -313.8095830979222, -313.8095769369021, -313.8095769924051, -313.8095824016038, -313.8095837387602, -313.8095762960905, -313.8095776332394, -313.8095815020663, -313.8095846382917, -313.8095753965493, -313.8095785327746, -313.8095851608903, -313.8095809794713, -313.8095790553733, -313.8095748739542, -313.8095818950094, -313.8095842467075, -313.809575789562, -313.8095781411209, -313.8095916280199, -313.8095745124733, -313.8095855225019, 
  -313.8095684069572, -313.8096005245923, -313.8095656167924, -313.8095944190765, -313.8095595112741, -313.8095951258804, -313.8095710143887, -313.8095890203634, -313.8095649088716, -313.8095916954883, -313.8095744448447, -313.8095855899703, -313.8095683393286, -313.8096096200754, -313.8095565199907, -313.809603514558, -313.8095504144741, -313.8095800669694, -313.809580063337, -313.8095799714704, -313.8095799678381, -313.8095799753819, -313.8095801549253, -313.8095798798821, -313.8095800594271, -313.8095808246314, -313.8095793056899, -313.8095807291317, -313.8095792101917, -313.8095800374018, -313.8095800929047, -313.8095799419028, -313.8095799974058, -313.8095793965879, -313.8095807337411, -313.8095793010896, -313.8095806382416, -313.8095784970488, -313.8095816332743, -313.80957840155, 
  -313.8095815377752, -313.8095821558728, -313.8095779744538, -313.809582060374, -313.8095778789549, -313.809578890006, -313.809581241676, -313.8095787945486, -313.8095811461357, -313.8095886230023, -313.809571507456, -313.8095885275027, -313.8095714119576, -313.8095975195752, -313.8095626117746, -313.8095974240768, -313.8095625162752, -313.8095921208625, -313.8095680093716, -313.8095920253645, -313.8095679138718, -313.809588690471, -313.8095714398269, -313.8095885949707, -313.8095713443295, -313.8096066150577, -313.8095535149734, -313.8096065195588, -313.8095534194745, -313.8095799294478, -313.809580108992, -313.8095799258155, -313.8095801053598, -313.8095807786974, -313.8095792597566, -313.8095807750651, -313.8095792561243, -313.8095799914681, -313.8095800469711, -313.8095799878358, 
  -313.8095800433387, -313.8095793506552, -313.8095806878067, -313.8095793470217, -313.8095806841755, -313.8095784511153, -313.8095815873406, -313.8095784474829}
 {-262.0498017183546, -262.0498028945081, -262.0498023032143, -262.049801133507, -262.0498005422075, -262.0498026296002, -262.0498025681218, -262.0498008685967, -262.0498008071174, -262.0498037355532, -262.0498014621696, -262.049801974547, -262.0497997011682, -262.0498011683329, -262.0498040294013, -262.0497994073296, -262.0498022683967, -262.04980252713, -262.049802670592, -262.049800766126, -262.049800909588, -262.0498119460348, -262.0497932516943, -262.0498101850125, -262.0497914907087, -262.0497960432701, -262.0498091544632, -262.0497942822669, -262.0498073934585, -262.0497990551168, -262.0498061426283, -262.0497972941127, -262.0498043816245, -262.049818764625, -262.0497864337517, -262.0498170038728, -262.049784672496, -262.0497953942604, -262.049809803539, -262.0497936332506, 
  -262.0498080425409, -262.0497567602457, -262.0498484382429, -262.0497549992448, -262.049846677236, -262.0498073616649, -262.0497978360435, -262.049805600633, -262.0497960750675, -262.0498020209253, -262.0498031768806, -262.0498002599224, -262.0498014158755, -262.0497763545127, -262.0498288449006, -262.0497745935106, -262.0498270838949, -262.0498020447426, -262.0498019832636, -262.0498014534458, -262.0498013919671, -262.0498031506943, -262.0498008773129, -262.0498025593974, -262.0498002860164, -262.0498005834757, -262.0498034445428, -262.0497999921783, -262.0498028532468, -262.0498019422721, -262.0498020857341, -262.0498013509755, -262.0498014944375, -262.0498113611677, -262.0497926668456, -262.0498107698711, -262.0497920755489, -262.0497954584131, -262.0498085696045, -262.0497948671154, 
  -262.0498079783088, -262.0497984702588, -262.0498055577705, -262.0497978789622, -262.0498049664739, -262.0498181799081, -262.0497858487529, -262.0498175885813, -262.0497852574863, -262.049794809395, -262.0498092186886, -262.0497942181077, -262.0498086273827, -262.0497561753893, -262.0498478533835, -262.0497555840926, -262.0498472620869, -262.0498067767897, -262.0497972512031, -262.0498061854999, -262.0497966598994, -262.0498014360683, -262.0498025920218, -262.049800844771, -262.0498020007259, -262.0497757696552, -262.0498282600423, -262.0497751783595, -262.0498276687447, -262.0498028857851, -262.0498006124039, -262.0498028243062, -262.0498005509251, -262.0498003185662, -262.049803179634, -262.0498002570874, -262.0498031181552, -262.049801677363, -262.049801820825, -262.0498016158842, 
  -262.0498017593461, -262.049811096259, -262.049792401936, -262.0498110347794, -262.0497923404581, -262.0497951935035, -262.0498083046958, -262.0497951320246}
 {-292.6795779456516, -292.6795809218549, -292.6795812205644, -292.6795746707492, -292.6795749694649, -292.6795810605256, -292.679581081893, -292.679574809423, -292.6795748307905, -292.6795800482746, -292.6795820941461, -292.6795737971721, -292.6795758430433, -292.6795820052678, -292.6795801371707, -292.679575754165, -292.6795738860683, -292.6795811021419, -292.6795810402769, -292.6795748510393, -292.6795747891743, -292.6795830745341, -292.6795790679358, -292.6795768234346, -292.6795728168301, -292.6795832010106, -292.6795789414209, -292.679576949908, -292.6795726903184, -292.679584868681, -292.6795772737599, -292.6795786175784, -292.6795710226572, -292.6795934450518, -292.6795686987247, -292.6795871943239, -292.6795624472472, -292.6795918497708, -292.6795702928092, -292.6795855986571, 
  -292.6795640417177, -292.6795714641976, -292.6795906796235, -292.6795652130995, -292.6795844285164, -292.6796042892824, -292.6795578530078, -292.6795980381533, -292.6795516019319, -292.6795964513958, -292.6795656910376, -292.679590200293, -292.6795594399351, -292.6796068578209, -292.6795552848379, -292.6796006067181, -292.6795490337355, -292.6795777856118, -292.6795778069793, -292.6795780843246, -292.6795781056919, -292.679576773361, -292.6795788192321, -292.6795770720734, -292.6795791179451, -292.6795787303539, -292.6795768622569, -292.6795790290667, -292.6795771609696, -292.6795778272281, -292.679577765363, -292.6795781259407, -292.6795780640757, -292.6795797996217, -292.6795757930206, -292.6795800983347, -292.6795760917329, -292.6795799260968, -292.6795756665071, -292.6795802248096, 
  -292.6795759652197, -292.6795815937672, -292.679573998846, -292.6795818924798, -292.6795742975587, -292.6795901703059, -292.679565423643, -292.6795904690575, -292.6795657223166, -292.6795885748475, -292.6795670179049, -292.6795888735682, -292.6795673166097, -292.6795681892855, -292.6795874047079, -292.6795684879993, -292.6795877034197, -292.6796010143573, -292.6795545781055, -292.6796013130663, -292.679554876822, -292.6795931764822, -292.6795624161236, -292.6795934751944, -292.6795627148367, -292.6796035829072, -292.6795520099241, -292.6796038816196, -292.679552308637, -292.6795769120332, -292.6795789579046, -292.6795769334007, -292.679578979272, -292.6795788690263, -292.6795770009293, -292.6795788903937, -292.6795770222967, -292.6795779659003, -292.6795779040353, -292.6795779872679, 
  -292.6795779254028, -292.6795799382944, -292.6795759316926, -292.6795799596614, -292.6795759530605, -292.6795800647691, -292.6795758051794, -292.6795800861366}
 {-35.0523230177801, -35.05235216879202, -35.0523511072147, -35.05229492842048, -35.05229386687132, -35.05235180787641, -35.05235146812918, -35.05229456751823, -35.05229422777242, -35.05234863881859, -35.05235463720146, -35.05229139846819, -35.05229739683694, -35.05235006638183, -35.0523532096541, -35.05229282602139, -35.0522959692996, -35.05235164661146, -35.05235162939414, -35.05229440625404, -35.05229438903663, -35.05236026783648, -35.05234300867428, -35.05230302749104, -35.05228576830478, -35.0523577925844, -35.05234548347005, -35.05230055222661, -35.05228824311291, -35.05235156422437, -35.05235171182534, -35.05229432386713, -35.05229447146763, -35.05232633036434, -35.05237694749844, -35.05226909027527, -35.05231970687262, -35.05237198743207, -35.05233128878915, -35.05231474704796, 
  -35.05227404845834, -35.0523190132248, -35.05238426473601, -35.0522617728821, -35.05232702436376, -35.05228619976143, -35.0524170776409, -35.052228959933, -35.05235983675438, -35.05236737780675, -35.05233589820615, -35.05231013744529, -35.05227865785265, -35.05234858363144, -35.0523546944315, -35.05229134327233, -35.05229745407569, -35.05232371843557, -35.05232337868903, -35.05232265687231, -35.05232231712578, -35.05232054938205, -35.05232654775702, -35.05231948781796, -35.0523254861946, -35.0523219769386, -35.05232512021634, -35.05232091537783, -35.05232405865061, -35.05232355717101, -35.0523235399536, -35.05232249560772, -35.05232247839039, -35.05233217840151, -35.05231491922827, -35.05233111683925, -35.05231385766403, -35.05232970314359, -35.05231739402986, -35.05232864158065, 
  -35.05231633246632, -35.05232347478394, -35.05232362238477, -35.05232241322078, -35.05232256082144, -35.05229824101112, -35.0523488579707, -35.05229717954172, -35.05234779631359, -35.0523438979915, -35.05230319934873, -35.05234283640175, -35.05230213781199, -35.05229092379027, -35.05235617528954, -35.05228986222986, -35.05235511372345, -35.05225811058028, -35.05238898794103, -35.05225704902737, -35.05238792636747, -35.05233928836436, -35.05230780876753, -35.05233822680091, -35.0523067472045, -35.0523204941904, -35.05232660499155, -35.0523194326266, -35.05232554342886, -35.05232018847275, -35.05232618684845, -35.05231984872611, -35.05232584710204, -35.05232161603088, -35.05232475930618, -35.05232127628441, -35.0523244195596, -35.05232319626205, -35.05232317904469, -35.05232285651553, 
  -35.05232283929816, -35.05233181749426, -35.05231455831765, -35.05233147774535, -35.0523142185735, -35.05232934223462, -35.05231703312097, -35.05232900248848}
 {-173.2066266922966, -173.2066194951089, -173.2066190619091, -173.2066343227541, -173.2066338895487, -173.2066194818396, -173.2066190751782, -173.2066343094846, -173.2066339028179, -173.2066229163881, -173.2066156406421, -173.2066377440295, -173.2066304682855, -173.2066196688982, -173.2066188881299, -173.2066344965406, -173.2066337157724, -173.2066190590222, -173.2066194979956, -173.2066338866647, -173.2066343256379, -173.2066433001547, -173.2065952572428, -173.2066581277834, -173.2066100848988, -173.2066197237562, -173.2066188332703, -173.2066345513994, -173.2066336609118, -173.2066144954808, -173.2066240615623, -173.2066293231218, -173.2066388892061, -173.2066644760082, -173.2065740820304, -173.2066793046501, -173.2065889086733, -173.2066079070852, -173.2066306500548, 
  -173.206622734698, -173.2066454777268, -173.2065781559984, -173.2066604022299, -173.2065929836509, -173.2066752298621, -173.2066396592266, -173.2065988977873, -173.2066544866147, -173.206613725684, -173.2066344242136, -173.206604132896, -173.2066492518561, -173.2066189605383, -173.2066116306611, -173.2066269276696, -173.2066264583048, -173.2066417553106, -173.20662711223, -173.2066267055659, -173.2066266790274, -173.2066262723634, -173.2066305467766, -173.2066232710317, -173.2066301135741, -173.2066228378291, -173.2066272992872, -173.206626518519, -173.2066268660847, -173.2066260853164, -173.2066266894113, -173.2066271283846, -173.2066262562087, -173.2066266951821, -173.2066509305372, -173.2066028876384, -173.206650497334, -173.2066024544364, -173.2066273541459, -173.2066264636585, 
  -173.2066269209427, -173.2066260304567, -173.2066221258692, -173.2066316919521, -173.2066216926666, -173.2066312587495, -173.2066721069025, -173.2065817119142, -173.2066716736888, -173.2065812787227, -173.2066155374448, -173.2066382804733, -173.2066151042715, -173.2066378472414, -173.2065857863925, -173.2066680326138, -173.2065853531899, -173.2066675994112, -173.2066472894861, -173.2066065283059, -173.2066468562884, -173.2066060950985, -173.2066420546029, -173.2066117632848, -173.2066416214, -173.2066113300825, -173.2066192610505, -173.2066345580583, -173.2066188278486, -173.2066341248551, -173.2066305335073, -173.2066232577623, -173.2066301268433, -173.2066228510983, -173.2066272860179, -173.2066265052497, -173.2066268793539, -173.2066260985856, -173.2066266761419, -173.2066271151152, 
  -173.2066262694779, -173.2066267084512, -173.2066509172668, -173.20660287437, -173.2066505106042, -173.2066024677045, -173.2066273408762, -173.2066264503896, -173.2066269342122}
 {-275.5110726143958, -275.5110750532376, -275.5110750861823, -275.5110701426237, -275.5110701755723, -275.5110750839491, -275.5110750554704, -275.5110701733373, -275.5110701448584, -275.511074707129, -275.5110754322916, -275.5110697965191, -275.5110705216777, -275.5110765601967, -275.5110735792422, -275.5110716495843, -275.5110686686308, -275.5110751144969, -275.5110750249226, -275.511070203885, -275.5110701143107, -275.5110770847437, -275.5110730547004, -275.5110721741217, -275.5110681440986, -275.5110767518772, -275.5110733875522, -275.5110718412653, -275.5110684769402, -275.5110769370342, -275.5110732023994, -275.511072026422, -275.5110682917878, -275.5110837986451, -275.5110663420195, -275.5110788882284, -275.5110614312124, -275.5110843966243, -275.5110657429333, -275.5110794860108, 
  -275.5110608323231, -275.5110567112969, -275.5110934290624, -275.5110518006879, -275.5110885184475, -275.5110806519407, -275.511069487451, -275.5110757413188, -275.511064576849, -275.5110776249738, -275.5110725144742, -275.5110727143602, -275.511067603864, -275.5110847231693, -275.5110654162795, -275.5110798125586, -275.5110605056664, -275.5110726121621, -275.5110725836833, -275.5110726451087, -275.5110726166299, -275.5110722353436, -275.5110729605028, -275.5110722682889, -275.5110729934509, -275.5110740884095, -275.5110711074552, -275.5110741213558, -275.5110711404023, -275.5110726427099, -275.5110725531355, -275.5110726756565, -275.5110725860822, -275.5110746129513, -275.5110705829187, -275.5110746458986, -275.5110706158647, -275.5110742800903, -275.5110709157649, -275.5110743130367, 
  -275.5110709487119, -275.511074465247, -275.5110707306125, -275.5110744981936, -275.5110707635591, -275.5110813269433, -275.5110638701471, -275.5110813599146, -275.5110639030692, -275.5110819248346, -275.5110632711488, -275.5110819577849, -275.511063304092, -275.5110542395111, -275.511090957274, -275.5110542724582, -275.5110909902202, -275.5110781801491, -275.5110670156683, -275.5110782130947, -275.5110670486161, -275.5110751531865, -275.5110700426874, -275.511075186132, -275.5110700756352, -275.5110822513828, -275.5110629444919, -275.5110822843296, -275.5110629774384, -275.5110722660555, -275.511072991216, -275.5110722375766, -275.5110729627372, -275.5110741191219, -275.511071138168, -275.5110740906431, -275.5110711096891, -275.5110726734224, -275.5110725838481, -275.5110726449435, 
  -275.5110725553693, -275.5110746436645, -275.5110706136306, -275.5110746151849, -275.5110705851524, -275.5110743108028, -275.5110709464776, -275.5110742823238}
 {-454.3609475786082, -454.3608491736707, -454.3608472072428, -454.3610479502506, -454.3610459838314, -454.3608480824378, -454.3608482984816, -454.361046859022, -454.361047075066, -454.3608512226712, -454.3608451583149, -454.3610499992282, -454.3610439349267, -454.3608537649736, -454.3608426159698, -454.3610525415597, -454.3610413925521, -454.3608482035366, -454.360848177383, -454.3610469801208, -454.3610469539674, -454.3608505676145, -454.3608458133073, -454.3610493442289, -454.3610445898615, -454.3608479436595, -454.3608484372601, -454.3610467202438, -454.3610472138444, -454.3608482806928, -454.3608481002276, -454.3610470572777, -454.3610468768112, -454.3606681755885, -454.3610282072764, -454.3608669486631, -454.3612269873704, -454.3608623011782, -454.3608340799613, -454.3610610778101, 
  -454.361032856498, -454.3608470618755, -454.3608493190442, -454.3610458384599, -454.3610480956284, -454.360608043374, -454.3610883420286, -454.3608068174301, -454.3612871211412, -454.3608586208395, -454.3608377600134, -454.3610573974211, -454.3610365366005, -454.3608480813278, -454.3608482995902, -454.3610468579108, -454.3610470761758, -454.3609484537946, -454.3609486698388, -454.3609464873713, -454.360946703415, -454.3609515940175, -454.3609455296825, -454.3609496275879, -454.3609435632652, -454.3609541363348, -454.3609429873222, -454.3609521699045, -454.3609410209056, -454.3609485748935, -454.3609485487401, -454.3609466084701, -454.3609465823165, -454.3609509389858, -454.3609461846499, -454.3609489725636, -454.3609442182251, -454.360948315017, -454.3609488086164, -454.3609463485923, 
  -454.3609468421941, -454.3609486520502, -454.3609484715842, -454.3609466856266, -454.3609465051608, -454.3607685451926, -454.3611285803864, -454.3607665787652, -454.3611266139666, -454.3609626726156, -454.3609344512379, -454.3609607060787, -454.3609324849276, -454.3609474332318, -454.3609496904019, -454.3609454668098, -454.3609477239769, -454.3607084134682, -454.3611887146483, -454.360706447042, -454.3611867482276, -454.360958992183, -454.3609381313839, -454.3609570257838, -454.3609361649361, -454.3609484526842, -454.3609486709478, -454.3609464862606, -454.3609467045242, -454.3609505027836, -454.3609444384549, -454.3609507188276, -454.3609446544988, -454.3609530451007, -454.3609418960948, -454.3609532611446, -454.3609421121389, -454.3609474836627, -454.3609474575093, -454.3609476997068, 
  -454.3609476735533, -454.3609498477386, -454.3609450934355, -454.3609500638167, -454.3609453094453, -454.3609472237866, -454.3609477173853, -454.3609474398288}
 {-397.2001457298254, -397.2001505893256, -397.200149933086, -397.2001415266112, -397.2001408703723, -397.2001502698656, -397.2001502525455, -397.2001412071514, -397.2001411898315, -397.2001511915235, -397.2001493308952, -397.2001421288036, -397.200140268187, -397.2001601837424, -397.2001403387152, -397.2001511210281, -397.2001312760013, -397.2001502836458, -397.2001502387653, -397.2001412209318, -397.2001411760512, -397.2001513007538, -397.2001492216653, -397.2001422380423, -397.2001401589488, -397.2001496653317, -397.2001508570813, -397.2001406026178, -397.2001417943672, -397.2001522680087, -397.2001482544149, -397.2001432052948, -397.2001391917009, -397.200079577811, -397.2002209484988, -397.2000705139212, -397.2002118869607, -397.2001586902826, -397.2001418325666, -397.2001496275796, 
  -397.2001327698416, -397.2001679594466, -397.2001325636232, -397.2001588967323, -397.2001235009095, -397.2001659623481, -397.2001345600702, -397.2001568995027, -397.2001254974875, -397.2001739298626, -397.2001265924137, -397.2001648671487, -397.2001175296995, -397.2001584067105, -397.2001421158025, -397.2001493439965, -397.2001330530885, -397.2001460666052, -397.2001460492852, -397.200145410366, -397.200145393046, -397.2001469882615, -397.2001451276366, -397.2001463320198, -397.2001444713999, -397.2001559804831, -397.2001361354538, -397.2001553242414, -397.200135479217, -397.2001460803855, -397.200146035505, -397.2001454241462, -397.2001453792656, -397.2001470974946, -397.2001450184038, -397.2001464412556, -397.2001443621645, -397.2001454620714, -397.200146653821, -397.2001448058323, 
  -397.2001459975816, -397.2001480647484, -397.2001440511546, -397.2001474085091, -397.2001433949153, -397.2000753739577, -397.2002167458316, -397.2000747177287, -397.2002160895821, -397.2001544870459, -397.2001376292828, -397.2001538307706, -397.2001369730796, -397.2001637561861, -397.2001283603631, -397.200163099947, -397.2001277041237, -397.2001617590196, -397.200130356878, -397.2001611027855, -397.2001297006337, -397.2001697266033, -397.2001223891524, -397.2001690703622, -397.200121732915, -397.2001542034502, -397.2001379125422, -397.200153547211, -397.200137256303, -397.2001466688004, -397.200144808178, -397.2001466514804, -397.200144790858, -397.2001556610221, -397.200135815995, -397.200155643702, -397.2001357986751, -397.2001457609257, -397.2001457160451, -397.2001457436056, 
  -397.2001456987251, -397.2001467780353, -397.2001446989436, -397.2001467607145, -397.2001446816242, -397.2001451426118, -397.2001463343609, -397.2001451252913}
 {-16.86624289638912, -16.86624271346409, -16.86624269386401, -16.86624309891373, -16.86624307931373, -16.86624270461429, -16.86624270271381, -16.86624309006396, -16.8662430881635, -16.86624290277333, -16.86624250457898, -16.86624328821464, -16.86624289003703, -16.86624514613556, -16.8662402612018, -16.86624553158395, -16.86624064665277, -16.86624270964549, -16.86624269768262, -16.86624309509513, -16.86624308313234, -16.86623200233332, -16.86625340551998, -16.8662323878696, -16.86625379088305, -16.86624230852368, -16.86624309880933, -16.86624269397261, -16.86624348425977, -16.86624469825255, -16.86624070909447, -16.86624508370144, -16.86624109454495, -16.86624238406199, -16.86624302326809, -16.86624276951251, -16.86624340871693, -16.86624154595701, -16.86624386146406, -16.8662419314176, 
  -16.86624424690284, -16.86625738567487, -16.86622802250936, -16.86625777115195, -16.86622840793165, -16.8662427201959, -16.86624268713229, -16.86624310564541, -16.86624307258215, -16.8662487532143, -16.86623665407767, -16.86624913866471, -16.86623703952662, -16.8662542243201, -16.86623118295142, -16.86625460975578, -16.8662315684151, -16.86624290713937, -16.8662429052389, -16.86624288753933, -16.86624288563886, -16.86624310529459, -16.86624270710788, -16.86624308569382, -16.86624268750858, -16.86624534866005, -16.86624046372748, -16.86624532905991, -16.86624044412755, -16.86624291217056, -16.86624290020772, -16.86624289257052, -16.86624288060768, -16.86623220490131, -16.86625360800215, -16.86623218530206, -16.86625358840132, -16.86624251104842, -16.86624330133477, -16.86624249144833, 
  -16.86624328173478, -16.86624490077725, -16.86624091161995, -16.8662448811772, -16.86624089201993, -16.8662425865875, -16.86624322579275, -16.86624256698745, -16.86624320619272, -16.86624174848736, -16.86624406398389, -16.86624172888771, -16.86624404438346, -16.86625758821347, -16.86622822502094, -16.8662575686138, -16.86622820542053, -16.8662429227209, -16.86624288965746, -16.86624290312087, -16.86624287005743, -16.86624895573975, -16.86623685660238, -16.86624893613971, -16.86623683700236, -16.86625442683826, -16.86623138548343, -16.86625440723807, -16.86623136588353, -16.86624309644444, -16.86624269825846, -16.86624309454397, -16.866242696358, -16.86624533981022, -16.86624045487775, -16.86624533790975, -16.86624045297728, -16.86624290332077, -16.86624289135793, -16.8662429014203, 
  -16.86624288945747, -16.8662321960521, -16.8662535991518, -16.86623219415126, -16.86625359725168, -16.86624250219861, -16.86624329248501, -16.86624250029813}
 {-336.1653693755984, -336.1653729772981, -336.1653725775926, -336.1653661736102, -336.1653657739046, -336.1653727765056, -336.1653727783843, -336.1653659728177, -336.1653659746963, -336.1653728890151, -336.1653726658747, -336.1653660853268, -336.1653658621871, -336.1653710551201, -336.1653744997909, -336.1653642514322, -336.165367696103, -336.1653727600694, -336.1653727948205, -336.1653659563815, -336.1653659911326, -336.165372529736, -336.1653730251625, -336.1653657260494, -336.1653662214732, -336.1653757801427, -336.1653697747789, -336.1653689764547, -336.1653629710909, -336.1653773419668, -336.1653682129477, -336.165370538279, -336.1653614092597, -336.1653635812194, -336.1653819747678, -336.1653567774558, -336.1653751711556, -336.1653856211824, -336.1653599338386, -336.1653788174941, 
  -336.165353130151, -336.1653642410525, -336.165381315265, -336.1653574373644, -336.1653745115771, -336.1653906332907, -336.1653549214949, -336.1653838296024, -336.1653481178074, -336.1653748864076, -336.1653706686644, -336.1653680827198, -336.1653638649764, -336.1653975070241, -336.165348048154, -336.1653907033359, -336.1653412444663, -336.1653695745123, -336.165369576391, -336.1653691748067, -336.1653691766854, -336.1653696870218, -336.1653694638814, -336.1653692873159, -336.1653690641762, -336.165367853127, -336.1653712977974, -336.1653674534209, -336.1653708980923, -336.165369558076, -336.1653695928273, -336.1653691583705, -336.1653691931217, -336.1653693277437, -336.1653698231682, -336.1653689280375, -336.1653694234632, -336.1653725781493, -336.1653665727857, -336.165372178444, 
  -336.1653661730799, -336.1653741399736, -336.1653650109544, -336.1653737402681, -336.1653646112488, -336.1653603791629, -336.1653787728377, -336.165359979508, -336.1653783730814, -336.1653824191926, -336.1653567318418, -336.1653820194796, -336.1653563321437, -336.1653610390587, -336.1653781132721, -336.1653606393539, -336.1653777135658, -336.1653874312948, -336.1653517195041, -336.1653870315939, -336.1653513197939, -336.1653716844145, -336.1653674666708, -336.1653712847087, -336.1653670669657, -336.1653943050307, -336.1653448461607, -336.1653939053251, -336.1653444464552, -336.1653694862291, -336.1653692630891, -336.1653694881078, -336.1653692649678, -336.1653676523343, -336.165371097005, -336.1653676542129, -336.1653710988838, -336.1653693572836, -336.1653693920347, -336.1653693591622, 
  -336.1653693939134, -336.1653691269512, -336.1653696223756, -336.1653691288292, -336.1653696242551, -336.1653723773569, -336.165366371993, -336.1653723792355}
 {-51.15449364184906, -51.15449510276022, -51.15449412714088, -51.15449315663291, -51.15449218100593, -51.15449448083339, -51.15449474906725, -51.1544925347, -51.15449280293838, -51.15449547843728, -51.15449375151526, -51.15449353229225, -51.15449180539803, -51.15450423011533, -51.1544849998192, -51.15450228397945, -51.15448305369285, -51.15449472906731, -51.15449450083338, -51.15449278293597, -51.15449255470244, -51.15445993107131, -51.1545293007522, -51.15445798508704, -51.15452735447418, -51.15449680324264, -51.1544924267058, -51.15449485710672, -51.15449048057945, -51.15450672538941, -51.15448250460328, -51.15450477925291, -51.15448055847752, -51.1545439948168, -51.15444523803892, -51.15454205015949, -51.15444329043401, -51.1544748826952, -51.15451434763171, -51.15447293653041, 
  -51.15451240153425, -51.15458305600745, -51.15440617897474, -51.15458110995331, -51.15440423276661, -51.15453712082708, -51.15445210888915, -51.15453517452325, -51.15445016293075, -51.15456942152281, -51.1544198080468, -51.15456747539345, -51.15441786191392, -51.15468645589819, -51.15430277180354, -51.15468450974295, -51.15430082569654, -51.15449399554279, -51.15449426377899, -51.15449301991974, -51.15449328815576, -51.15449499314154, -51.15449326623214, -51.15449401751711, -51.1544922906103, -51.1545037448237, -51.15448451453195, -51.1545027692002, -51.15448353890918, -51.15449424377778, -51.15449401554405, -51.15449326815463, -51.1544930399209, -51.15445944585217, -51.15452881539243, -51.15445847023527, -51.15452783976304, -51.15449631795075, -51.15449194141883, -51.15449534232772, 
  -51.15449096579557, -51.15450624009744, -51.1544820193164, -51.15450526447399, -51.15448104369355, -51.15454351028133, -51.15444475199554, -51.15454253462406, -51.15444377640649, -51.15447439736888, -51.15451386237917, -51.15447342178583, -51.15451288671591, -51.15458257075548, -51.15440569364783, -51.15458159513439, -51.15440471802264, -51.15453663544544, -51.15445162369192, -51.15453565983401, -51.15445064805709, -51.15456893623435, -51.1544193227564, -51.15456796061104, -51.15441834713343, -51.15468597059736, -51.15430228652553, -51.15468499497291, -51.15430131090368, -51.15449437121109, -51.15449264430287, -51.15449463944712, -51.15449291253908, -51.15450312289367, -51.15448389260228, -51.15450339112977, -51.15448416083841, -51.15449362184792, -51.1544933936142, -51.15449389008402, 
  -51.1544936618503, -51.15445882392538, -51.15452819345953, -51.15445909216161, -51.15452846169551, -51.154495696021, -51.15449131948889, -51.15449596425703}
 {-10.17076875971198, -10.17076859918735, -10.17076860901913, -10.17076891040471, -10.17076892023649, -10.17076860367344, -10.17076860453304, -10.1707689148908, -10.1707689157504, -10.17076390833555, -10.17077329989083, -10.17076421955987, -10.17077361110121, -10.17076659618573, -10.17077061202827, -10.17076690740228, -10.17077092324642, -10.17076855088744, -10.17076865731904, -10.17076886210478, -10.17076896853641, -10.17076463664579, -10.17077257233102, -10.17076494786484, -10.17077288354668, -10.17076811691959, -10.1707690912994, -10.1707684281362, -10.1707694025175, -10.1707697893241, -10.17076741888891, -10.17077010054099, -10.17076773010672, -10.1707672654858, -10.17076994272277, -10.17076757670501, -10.17077025393826, -10.17077386466667, -10.17076334356725, -10.17077417588518, 
  -10.17076365478346, -10.17077175717002, -10.17076545137679, -10.17077206839142, -10.1707657625901, -10.17076860440075, -10.17076860380574, -10.1707689156181, -10.17076891502309, -10.17076791587399, -10.17076929241836, -10.17076822708795, -10.17076960363911, -10.17078374909399, -10.17075345888851, -10.17078406031038, -10.17075377010683, -10.17076875436629, -10.17076875522589, -10.17076876419807, -10.17076876505767, -10.17076405903178, -10.1707734505803, -10.17076406886377, -10.17077346041187, -10.17076674687819, -10.1707707627215, -10.17076675670994, -10.17077077255331, -10.17076870158028, -10.1707688080119, -10.17076871141206, -10.17076881784368, -10.17076478733946, -10.17077272302305, -10.17076479717129, -10.17077273285477, -10.17076826761208, -10.1707692419926, -10.17076827744383, 
  -10.17076925182441, -10.17076994001672, -10.17076756958198, -10.17076994984848, -10.17076757941378, -10.17076741617959, -10.17077009341467, -10.17076742601135, -10.17077010324647, -10.17077401536, -10.17076349425962, -10.17077402519198, -10.17076350409121, -10.17077190786481, -10.17076560206769, -10.17077191769675, -10.17076561189932, -10.1707687550936, -10.17076875449858, -10.17076876492538, -10.17076876433036, -10.17076806656521, -10.17076944311284, -10.17076807639686, -10.17076945294475, -10.17078389978638, -10.17075360958182, -10.17078390961812, -10.17075361941364, -10.17076406351796, -10.1707734550663, -10.17076406437759, -10.17077345592587, -10.17076675136427, -10.1707707672076, -10.17076675222387, -10.1707707680672, -10.17076870606637, -10.17076881249799, -10.17076870692597, 
  -10.17076881335759, -10.1707647918256, -10.17077272750908, -10.17076479268515, -10.17077272836874, -10.17076827209816, -10.17076924647871, -10.17076827295776}
 {-615.8279997143444, -615.8279908125911, -615.8279917782723, -615.8280076504299, -615.8280086161176, -615.8279914662765, -615.8279911245877, -615.82800830412, -615.8280079624283, -615.8279905247745, -615.8279920660973, -615.8280073626198, -615.8280089039359, -615.8279936788619, -615.827988912021, -615.8280105167033, -615.8280057498635, -615.8279913406793, -615.827991250185, -615.8280081785214, -615.828008088027, -615.8280179537339, -615.8279646372616, -615.8280347914653, -615.8279814752142, -615.8279947115161, -615.8279878793327, -615.8280115493578, -615.828004717175, -615.8279853071763, -615.8279972836961, -615.8280021450159, -615.8280141215405, -615.8279161705418, -615.828066421748, -615.8279330075031, -615.828083260471, -615.8279866404697, -615.827995950547, -615.8280034783191, 
  -615.8280127883817, -615.8280468781165, -615.8279357136903, -615.8280637159469, -615.8279525515441, -615.8279744262228, -615.8280081650163, -615.827991263785, -615.8280250031383, -615.8279965317433, -615.8279860591002, -615.8280133695831, -615.8280028969445, -615.8279551156585, -615.8280274773474, -615.8279719535138, -615.828044315176, -615.8279994023469, -615.8279990606567, -615.8280003680314, -615.8280000263411, -615.8279984608463, -615.8280000021648, -615.8279994265298, -615.8280009678502, -615.8280016149299, -615.8279968480922, -615.8280025806171, -615.827997813774, -615.8279992767488, -615.8279991862547, -615.8280002424336, -615.828000151939, -615.828025889751, -615.8279725733839, -615.8280268554302, -615.8279735390737, -615.8280026475906, -615.8279958153973, -615.828003613265, 
  -615.827996781092, -615.8279932432452, -615.8280052197665, -615.8279942089289, -615.8280061854518, -615.827924106186, -615.8280743582433, -615.8279250718408, -615.8280753239576, -615.8279945765551, -615.8280038866008, -615.8279955422152, -615.8280048523098, -615.8280548141829, -615.8279436497634, -615.8280557798624, -615.8279446154529, -615.8279823621611, -615.8280161012174, -615.8279833278285, -615.8280170669191, -615.8280044678118, -615.8279939951711, -615.8280054334965, -615.8279949608554, -615.8279630517305, -615.8280354134147, -615.8279640174235, -615.8280363790906, -615.8279991145336, -615.8280006558531, -615.8279987728433, -615.8280003141628, -615.828002268619, -615.8279975017787, -615.8280019269288, -615.8279971600884, -615.8279999304368, -615.8279998399424, -615.8279995887464, 
  -615.8279994982521, -615.8280265434361, -615.8279732270743, -615.8280262017458, -615.827972885384, -615.8280033012734, -615.8279964690902, -615.8280029595831}
 {-404.1127855663697, -404.1127944546767, -404.1127940404528, -404.1127770923286, -404.1127766781095, -404.1127943381785, -404.1127941569486, -404.1127769758338, -404.112776794602, -404.1127937228105, -404.1127947723157, -404.1127763604647, -404.1127774099705, -404.1127916546279, -404.112796840568, -404.1127742922805, -404.112779478224, -404.1127943678711, -404.1127941272559, -404.1127770055256, -404.1127767649104, -404.1128071654589, -404.1127813296944, -404.1127898030724, -404.11276396739, -404.1127969162866, -404.112791578917, -404.1127795539412, -404.1127742165712, -404.1127917892088, -404.1127967060161, -404.1127744268626, -404.1127793436713, -404.1128073574287, -404.1127811415838, -404.1127899950568, -404.1127637792645, -404.1127558103686, -404.1128326852162, -404.1127384480246, 
  -404.112815322869, -404.1128295510138, -404.1127589481109, -404.1128121886684, -404.112741585765, -404.1128267289174, -404.1127617660588, -404.1128093665395, -404.1127444037457, -404.1128085114823, -404.112779983901, -404.1127911491349, -404.112762621557, -404.1127957815872, -404.1127927168067, -404.1127784192469, -404.112775354456, -404.1127858640971, -404.1127856828662, -404.1127854498757, -404.1127852686447, -404.1127852487297, -404.1127862982329, -404.1127848345058, -404.1127858840137, -404.1127831805467, -404.1127883664855, -404.1127827663222, -404.1127879522667, -404.1127858937894, -404.112785653174, -404.1127854795678, -404.1127852389525, -404.1127986913578, -404.112772855632, -404.1127982771338, -404.1127724414128, -404.1127884422062, -404.1127831048335, -404.1127880279817, 
  -404.112782690615, -404.1127833151267, -404.1127882319346, -404.1127829009049, -404.1127878177134, -404.1127988833868, -404.1127726674618, -404.1127984690588, -404.1127722533467, -404.1127473362867, -404.1128242111343, -404.1127469220668, -404.1128237969112, -404.112821076932, -404.112750474029, -404.1128206627104, -404.1127500598073, -404.1128182548176, -404.1127532919949, -404.1128178405996, -404.1127528777699, -404.112800037401, -404.1127715098185, -404.1127996231767, -404.1127710955998, -404.1127873075065, -404.1127842427236, -404.112786893288, -404.1127838284993, -404.112785132232, -404.1127861817376, -404.112784951001, -404.1127860005068, -404.1127830640488, -404.1127882499905, -404.1127828828179, -404.1127880687595, -404.112785777293, -404.1127855366775, -404.1127855960619, 
  -404.1127853554467, -404.1127985748615, -404.1127727391354, -404.1127983936278, -404.1127725579072, -404.1127883257084, -404.1127829883385, -404.1127881444771}
 {-400.5564946163285, -400.5565009078044, -400.5565006717013, -400.5564885609741, -400.5564883248678, -400.5565007361163, -400.5565008433888, -400.5564883892845, -400.5564884965568, -400.5565015944125, -400.5564999850935, -400.5564892475796, -400.5564876382626, -400.5565052821907, -400.5564962973416, -400.5564929353589, -400.5564839505094, -400.5565008872161, -400.556500692289, -400.5564885403841, -400.5564883454571, -400.55649959639, -400.5565019831592, -400.5564872495595, -400.5564896363259, -400.5565016975329, -400.556499881996, -400.5564893507009, -400.5564875351642, -400.5565078096187, -400.5564937699447, -400.5564954627868, -400.5564814231128, -400.5564968728545, -400.5565047088435, -400.5564845258851, -400.556492362149, -400.5565072117556, -400.5564943680095, -400.5564948649273, 
  -400.5564820211738, -400.5564513908992, -400.5565501912677, -400.5564390440659, -400.5565378444372, -400.5565212875427, -400.5564802918833, -400.5565089406985, -400.5564679450638, -400.5565133657116, -400.5564882138602, -400.5565010188799, -400.5564758670281, -400.5565481488399, -400.5564534303818, -400.5565358020079, -400.55644108355, -400.5564946807449, -400.5564947880172, -400.5564944446403, -400.5564945519127, -400.5564955390414, -400.5564939297218, -400.5564953029351, -400.5564936936187, -400.5564992268193, -400.55649024197, -400.5564989907144, -400.5564900058656, -400.5564948318447, -400.5564946369176, -400.5564945957399, -400.5564944008129, -400.5564935410196, -400.5564959277867, -400.5564933049142, -400.5564956916828, -400.5564956421615, -400.5564938266245, -400.5564954060567, 
  -400.55649359052, -400.5565017542473, -400.5564877145732, -400.5565015181426, -400.5564874784686, -400.5564908174107, -400.5564986535445, -400.5564905813133, -400.5564984174325, -400.5565011563887, -400.5564883126334, -400.5565009202786, -400.5564880765343, -400.5564453355268, -400.5565441358972, -400.5564450994227, -400.556543899792, -400.5565152321641, -400.556474236519, -400.5565149960614, -400.5564740004123, -400.5565073103408, -400.5564821584882, -400.5565070742351, -400.5564819223845, -400.5565420934682, -400.5564473750105, -400.5565418573639, -400.5564471389055, -400.5564953673519, -400.5564937580337, -400.5564954746241, -400.5564938653062, -400.5564990551305, -400.5564900702812, -400.5564991624029, -400.5564901775536, -400.5564946601558, -400.5564944652288, -400.5564947674282, 
  -400.5564945725012, -400.5564933693313, -400.5564957560975, -400.5564934766019, -400.5564958633715, -400.5564954704726, -400.5564936549358, -400.5564955777452}
 {-233.5519021500001, -233.5519024934397, -233.5519035471564, -233.5519007528577, -233.5519018065847, -233.5519029978174, -233.5519030427779, -233.5519012572403, -233.5519013022013, -233.5519015450163, -233.5519044955786, -233.5518998044481, -233.5519027549931, -233.5518998821648, -233.5519061584449, -233.5518981415874, -233.5519044178685, -233.5519029706319, -233.5519030699634, -233.551901230055, -233.5519013293864, -233.551900336047, -233.5519057046169, -233.5518985954791, -233.5519039640311, -233.551901027093, -233.5519050135359, -233.5518992865156, -233.5519032729595, -233.5519051348842, -233.551900905731, -233.5519033943075, -233.551899165154, -233.5519284217176, -233.5518776203013, -233.5519266815247, -233.5518758793405, -233.5519184223303, -233.5518876184172, -233.5519166817503, 
  -233.5518858778435, -233.5519166877244, -233.5518893538135, -233.5519149471528, -233.5518876132314, -233.5519056683546, -233.5519003722649, -233.5519039277311, -233.5518986317346, -233.551897833562, -233.5519082072009, -233.5518960929805, -233.5519064666287, -233.5519156274512, -233.5518904130363, -233.551913886873, -233.5518886724609, -233.5519016006592, -233.5519016456199, -233.551902654381, -233.5519026993418, -233.5519001478629, -233.5519030984158, -233.551901201584, -233.5519041521386, -233.551898485005, -233.5519047612886, -233.5518995387299, -233.5519058150074, -233.5519015734739, -233.5519016728053, -233.5519026271957, -233.5519027265271, -233.5518989388935, -233.5519043074543, -233.5518999926152, -233.5519053611764, -233.5518996299344, -233.5519036163783, -233.5519006836568, 
  -233.5519046700997, -233.5519037377262, -233.5518995085729, -233.5519047914481, -233.5519005622947, -233.5519270247194, -233.5518762229834, -233.5519280785055, -233.551877276641, -233.5519170251667, -233.5518862212647, -233.5519180788965, -233.5518872749787, -233.5519152905679, -233.5518879566539, -233.5519163442919, -233.5518890103736, -233.5519042711801, -233.5518989751232, -233.5519053248881, -233.5519000288589, -233.5518964364018, -233.5519068100449, -233.5518974901232, -233.5519078637673, -233.5519142302928, -233.5518890158787, -233.551915284014, -233.5518900696012, -233.5519006522427, -233.5519036027964, -233.5519006972034, -233.5519036477572, -233.5518989893866, -233.5519052656672, -233.5518990343474, -233.551905310628, -233.551902077854, -233.5519021771854, -233.5519021228148, 
  -233.5519022221462, -233.5518994432739, -233.5519048118342, -233.551899488234, -233.5519048567956, -233.5519001343147, -233.5519041207584, -233.5519001792757}
 {-9.46819038398044, -9.4681986275237, -9.46819795605633, -9.46818281200947, -9.46818214056183, -9.46819829801819, -9.46819828556149, -9.46818248251351, -9.46818247005745, -9.46819945013681, -9.46819713345636, -9.46818363461837, -9.46818131796606, -9.46820171662213, -9.4681948669793, -9.46818590111207, -9.46817905148063, -9.46819830321279, -9.4681982803669, -9.46818248770832, -9.46818246486265, -9.46820628247935, -9.46819030127385, -9.46819046693422, -9.46817448581026, -9.46819957103786, -9.46819701254819, -9.46818375553555, -9.46818119704178, -9.46820075532314, -9.4681958282787, -9.46818493981827, -9.46818001277486, -9.46818137918, -9.46821520537983, -9.46816556403118, -9.46819938951994, -9.46819804801666, -9.46819853567569, -9.46818223249031, -9.46818272019331, -9.46817843258085, 
  -9.46821815190478, -9.46816261709169, -9.46820233638522, -9.46820224419824, -9.46819433938279, -9.46818642881749, -9.46817852375481, -9.46820411958838, -9.46819246395912, -9.46818830408677, -9.46817664845201, -9.46820721143821, -9.46818937220506, -9.46819139593908, -9.46817355669547, -9.46819072593756, -9.46819071348116, -9.46819005448004, -9.46819004202367, -9.4681918780513, -9.46818956138091, -9.46819120658978, -9.46818888992741, -9.46819414453979, -9.46818729490068, -9.46819347308031, -9.46818662344515, -9.46819073113228, -9.46819070828645, -9.46819005967473, -9.46819003682899, -9.46819871037953, -9.46818272921272, -9.46819803891995, -9.46818205775729, -9.4681919989579, -9.4681894404672, -9.46819132750141, -9.46818876900867, -9.46819318324239, -9.4681882561985, -9.46819251178492, 
  -9.46818758474095, -9.46817380726343, -9.46820763313544, -9.46817313583364, -9.46820696165022, -9.46819047593112, -9.46819096360027, -9.46818980446175, -9.46819029215463, -9.46817086050801, -9.46821057981667, -9.46817018905044, -9.46820990835923, -9.46819467217596, -9.46818676724411, -9.46819400072567, -9.46818609577939, -9.46819654750932, -9.46818489187722, -9.46819587605172, -9.46818422041981, -9.46819963936052, -9.46818180012179, -9.46819896790267, -9.46818112866463, -9.46819154854861, -9.46818923188213, -9.46819153609213, -9.46818921942585, -9.46819381503809, -9.46818696540091, -9.46819380258166, -9.46818695294457, -9.46819040163153, -9.46819037878574, -9.46819038917514, -9.46819036632936, -9.46819838087975, -9.46818239971103, -9.46819836841938, -9.46818238725863, -9.4681916694579, 
  -9.46818911096573, -9.46819165700106}
 {-225.1102565912492, -225.1102582016177, -225.1102588243593, -225.1102543581536, -225.1102549809027, -225.1102585095219, -225.1102585164542, -225.1102546660616, -225.1102546729939, -225.1102581176486, -225.1102589083269, -225.110254274194, -225.1102550648608, -225.110258745093, -225.110258280901, -225.1102549016326, -225.1102544374407, -225.1102585169426, -225.1102585090334, -225.1102546734824, -225.1102546655731, -225.1102584862452, -225.1102585397309, -225.1102546427851, -225.1102546962703, -225.1102585169382, -225.1102585090379, -225.1102546734782, -225.1102546655773, -225.110258514979, -225.1102585109972, -225.1102546715186, -225.1102546675368, -225.1102760759625, -225.1102409514305, -225.1102722327786, -225.1102371076937, -225.1102686283796, -225.1102483977737, -225.1102647849178, 
  -225.1102445543149, -225.1102585184456, -225.1102585075305, -225.1102546749852, -225.1102546640703, -225.1102630557411, -225.1102539702253, -225.110259212258, -225.1102501267877, -225.1102508819439, -225.110266144318, -225.11024703848, -225.1102623008611, -225.1102585101923, -225.1102585157838, -225.1102546667319, -225.1102546723235, -225.1102562764109, -225.1102562833431, -225.1102568991562, -225.1102569060885, -225.1102558845409, -225.1102566752124, -225.1102565072852, -225.1102572979589, -225.110256511981, -225.1102560477908, -225.1102571347281, -225.1102566705344, -225.1102562838316, -225.1102562759224, -225.110256906577, -225.1102568986677, -225.1102562531341, -225.1102563066198, -225.1102568758797, -225.110256929365, -225.1102562838272, -225.1102562759268, -225.1102569065727, 
  -225.110256898672, -225.1102562818679, -225.1102562778862, -225.1102569046133, -225.1102569006315, -225.1102738429585, -225.1102387182123, -225.1102744657661, -225.1102393408954, -225.1102663952654, -225.1102461646659, -225.1102670180156, -225.1102467874063, -225.1102562853346, -225.1102562744195, -225.1102569080799, -225.1102568971648, -225.1102608226228, -225.1102517371214, -225.1102614453598, -225.1102523598752, -225.1102486488316, -225.1102639112081, -225.1102492715759, -225.1102645339545, -225.1102562770813, -225.1102562826727, -225.1102568998266, -225.1102569054181, -225.1102561924465, -225.1102569831191, -225.1102561993787, -225.1102569900513, -225.110256819888, -225.1102563556961, -225.1102568268203, -225.1102563626283, -225.1102565917377, -225.1102565838285, -225.11025659867, 
  -225.1102565907607, -225.1102565610407, -225.1102566145254, -225.1102565679722, -225.1102566214584, -225.1102565917332, -225.110256583833, -225.1102565986659}
 {-299.6036640972582, -299.6036653438968, -299.6036654491248, -299.6036627453935, -299.6036628506245, -299.6036653966635, -299.6036653963573, -299.6036627981617, -299.6036627978556, -299.6036651063784, -299.6036656866427, -299.6036625078767, -299.6036630881408, -299.6036632223707, -299.6036675706715, -299.6036606238688, -299.6036649721698, -299.6036653920772, -299.6036654009436, -299.6036627935755, -299.6036628024418, -299.6036640177588, -299.6036667752726, -299.6036614192575, -299.6036641767703, -299.6036621536438, -299.6036686394105, -299.603659555142, -299.6036660409087, -299.6036673098421, -299.6036634831886, -299.6036647113403, -299.6036608846868, -299.6036647334892, -299.6036660599576, -299.6036621350433, -299.6036634613998, -299.603669913677, -299.6036608793948, -299.6036673151731, 
  -299.6036582808953, -299.6036798243588, -299.6036509692332, -299.6036772258579, -299.6036483707306, -299.6036714153031, -299.6036593776818, -299.6036688167998, -299.6036567791815, -299.60366780369, -299.6036629893606, -299.6036652051882, -299.6036603908589, -299.6036755543886, -299.6036552386395, -299.6036729558869, -299.6036526401377, -299.603664044797, -299.6036640444907, -299.6036641500265, -299.6036641497203, -299.6036637545118, -299.603664334776, -299.6036638597414, -299.6036644400056, -299.603661870504, -299.6036662188049, -299.6036619757335, -299.6036663240345, -299.6036640402107, -299.603664049077, -299.6036641454402, -299.6036641543065, -299.6036626658922, -299.603665423406, -299.6036627711222, -299.603665528635, -299.6036608017771, -299.6036672875439, -299.6036609070067, 
  -299.6036673927734, -299.6036659579755, -299.603662131322, -299.603666063205, -299.6036622365515, -299.6036633816333, -299.6036647080802, -299.6036634868974, -299.6036648132753, -299.6036685618098, -299.6036595275289, -299.6036686670384, -299.6036596327593, -299.6036784724923, -299.6036496173666, -299.6036785777226, -299.6036497225954, -299.6036700634363, -299.6036580258153, -299.6036701686646, -299.6036581310461, -299.6036664518235, -299.6036616374939, -299.6036665570529, -299.6036617427237, -299.603674202522, -299.6036538867728, -299.6036743077515, -299.6036539920025, -299.6036638072794, -299.6036643875435, -299.6036638069731, -299.6036643872373, -299.6036619232715, -299.6036662715725, -299.6036619229653, -299.6036662712663, -299.6036640929781, -299.6036641018445, -299.6036640926719, 
  -299.6036641015382, -299.6036627186601, -299.6036654761731, -299.6036627183536, -299.6036654758671, -299.6036608545447, -299.6036673403114, -299.6036608542385}
 {-281.4884190744729, -281.4884224634586, -281.4884225753347, -281.4884155736395, -281.4884156855198, -281.4884224993337, -281.4884225394591, -281.4884156095165, -281.4884156496423, -281.4884228688571, -281.4884221699414, -281.4884159790373, -281.4884152801273, -281.4884295449737, -281.4884154938653, -281.4884226551555, -281.4884086040496, -281.4884225123047, -281.488422526488, -281.4884156224877, -281.4884156366711, -281.4884207474707, -281.488424291422, -281.4884138576601, -281.4884174015986, -281.4884210401376, -281.4884239986733, -281.4884141503206, -281.4884171088564, -281.4884268080487, -281.4884182307815, -281.488419918232, -281.4884113409643, -281.4883910684147, -281.488453972648, -281.48838417808, -281.4884470833488, -281.4884162381969, -281.4884288009947, -281.4884093483861, 
  -281.4884219111716, -281.488393036829, -281.4884520038484, -281.4883861470073, -281.4884451140361, -281.4884317498379, -281.4884132889342, -281.4884248599749, -281.4884063991632, -281.4884375416218, -281.4884074971202, -281.4884306518038, -281.4884006073043, -281.4884464267146, -281.4883986119249, -281.4884395368965, -281.4883917221091, -281.4884189984712, -281.4884190385968, -281.4884191103494, -281.488419150475, -281.4884193679948, -281.488418669079, -281.4884194798702, -281.4884187809601, -281.4884260441109, -281.4884119930034, -281.4884261559888, -281.4884121048819, -281.4884190114423, -281.4884190256257, -281.4884191233205, -281.4884191375039, -281.4884172466109, -281.488420790557, -281.4884173584903, -281.488420902434, -281.4884175392749, -281.4884204978112, -281.4884176511537, 
  -281.488420609689, -281.4884233071864, -281.488414729919, -281.4884234190647, -281.4884148417972, -281.488387567309, -281.488450472029, -281.4883876791562, -281.4884505839382, -281.4884127373451, -281.4884253001217, -281.4884128492083, -281.4884254120149, -281.4883895359652, -281.4884485029874, -281.4883896478415, -281.4884486148675, -281.488428248954, -281.4884097880934, -281.4884283608292, -281.4884098999745, -281.4884340407596, -281.4884039962576, -281.4884341526364, -281.4884041081373, -281.488442925852, -281.4883951110628, -281.4884430377295, -281.4883952229417, -281.4884194038694, -281.4884187049565, -281.488419443995, -281.4884187450821, -281.4884260799868, -281.4884120288796, -281.4884261201124, -281.4884120690053, -281.4884190473184, -281.4884190615017, -281.488419087444, 
  -281.4884191016273, -281.4884172824884, -281.4884208264316, -281.4884173226123, -281.4884208665588, -281.4884175751513, -281.4884205336871, -281.488417615277}
 {-30.78439310003724, -30.78439628042137, -30.7843988199565, -30.78438738023004, -30.78438991976248, -30.78439764340643, -30.7843974569718, -30.78438874321334, -30.78438855677954, -30.78439839526992, -30.78439670510934, -30.78438949505496, -30.78438780493895, -30.78439655622629, -30.78439854416527, -30.7843876560359, -30.78438964397031, -30.78439761615018, -30.78439748422808, -30.78438871595735, -30.78438858403554, -30.78440175247714, -30.78439334796369, -30.78439285231968, -30.78438444773579, -30.78440077378577, -30.78439432661031, -30.7843918735935, -30.78438542641723, -30.78439897124306, -30.7843961291469, -30.78439007105172, -30.78438722895289, -30.78432818922647, -30.78446691233474, -30.78431928845313, -30.78445801272276, -30.78438741877665, -30.78440768173412, -30.78437851857866, 
  -30.78439878154675, -30.7844188492613, -30.78437625205288, -30.78440994907429, -30.78436735185454, -30.78437811147366, -30.78441698932639, -30.78436921131411, -30.78440808910059, -30.78439671682787, -30.78439838363797, -30.78438781664127, -30.78438948343923, -30.78440466261345, -30.78439043790956, -30.78439576241804, -30.78438153771962, -30.7843919234872, -30.78439173705308, -30.78439446302107, -30.78439427658677, -30.78439267534491, -30.7843909851964, -30.78439521486848, -30.7843935247404, -30.78439083630468, -30.78439282424893, -30.78439337584602, -30.78439536377517, -30.78439189623114, -30.78439176430916, -30.7843944357649, -30.78439430384297, -30.78439603257654, -30.78438762802633, -30.78439857210879, -30.78439016756165, -30.7843950538693, -30.78438860668883, -30.78439759339847, 
  -30.78439114622722, -30.78439325132488, -30.78439040922713, -30.78439579085841, -30.78439294876117, -30.78432246904371, -30.78446119267955, -30.78432500852438, -30.78446373226645, -30.78438169887194, -30.78440196180087, -30.78438423837188, -30.7844045013685, -30.78441312934746, -30.78437053212876, -30.78441566887663, -30.78437307166717, -30.78437239158902, -30.78441126937308, -30.78437493108726, -30.7844138089424, -30.78439099691094, -30.78439266371695, -30.78439353644671, -30.78439520324876, -30.78439894269149, -30.78438471799357, -30.78440148222851, -30.78438725752412, -30.78439403832414, -30.78439234818553, -30.78439385188962, -30.78439216175163, -30.78439219929255, -30.78439418722942, -30.78439201285852, -30.78439400079504, -30.78439325921529, -30.78439312729337, -30.78439307278111, 
  -30.78439294085913, -30.78439739556403, -30.78438899100721, -30.78439720912166, -30.78438880458115, -30.78439641685088, -30.78438996967561, -30.78439623041726}
 {-28.16325799844387, -28.16324544772496, -28.16324452990108, -28.16327146703551, -28.16327054920907, -28.16324505554059, -28.16324492208604, -28.16327107485028, -28.16327094139488, -28.16324648622211, -28.16324349142623, -28.16327250551358, -28.16326951075328, -28.16325293669586, -28.1632370409804, -28.16327895600324, -28.16326306029155, -28.16324501024793, -28.16324496737874, -28.16327102955714, -28.16327098668807, -28.16325439271671, -28.16323558538777, -28.16328041200997, -28.16326160471303, -28.16324485093933, -28.16324512670276, -28.16327087025028, -28.16327114601033, -28.16325068985497, -28.16323928782117, -28.16327670916431, -28.16326530713036, -28.16337946008873, -28.16311052123058, -28.16340548161982, -28.16313653831807, -28.16323180442049, -28.16325817361224, 
  -28.16325782370867, -28.16328419294258, -28.16322892512004, -28.1632610552886, -28.16325494446391, -28.16328707456324, -28.16323255688812, -28.16325742117926, -28.16325857567266, -28.16328344101327, -28.16326057376416, -28.16322940380008, -28.16328659307673, -28.16325542310604, -28.16327664638906, -28.16321333120166, -28.16330266569823, -28.16323935051103, -28.16325852408364, -28.16325839062867, -28.16325760625848, -28.16325747280351, -28.16325995475539, -28.16325695997862, -28.16325903693156, -28.16325604215215, -28.16326640523935, -28.16325050952259, -28.163265487411, -28.16324959170062, -28.16325847879075, -28.1632584359216, -28.16325756096557, -28.16325751809646, -28.16326786125307, -28.16324905393708, -28.16326694342486, -28.16324813611497, -28.16325831948426, -28.1632585952435, 
  -28.1632574016566, -28.16325767742083, -28.16326415839789, -28.16325275636392, -28.16326324057264, -28.16325183853886, -28.16339292974, -28.16312398866501, -28.1633920119198, -28.16312307083488, -28.16324527292372, -28.16327164219467, -28.16324435515669, -28.1632707243114, -28.16324239367592, -28.16327452381839, -28.16324147585929, -28.1632736059847, -28.16324602516667, -28.16327088998639, -28.16324510734536, -28.16326997215738, -28.1632740423078, -28.16324287234212, -28.16327312448434, -28.16324195451526, -28.16329011493082, -28.16322679974559, -28.16328919710773, -28.16322588191835, -28.16325956257122, -28.1632565677932, -28.16325942911631, -28.16325643433815, -28.16326601305298, -28.16325011733935, -28.16326587959794, -28.16324998388444, -28.16325808660595, -28.1632580437368, 
  -28.16325795315096, -28.16325791028184, -28.16326746906489, -28.16324866175565, -28.16326733561361, -28.16324852829698, -28.16325792729831, -28.16325820305985, -28.16325779384313}
 {-190.85403919638, -190.8540334387941, -190.8540330139126, -190.8540453788824, -190.8540449540008, -190.8540329771008, -190.8540334756061, -190.8540449171866, -190.8540454156969, -190.8540359940037, -190.8540304587137, -190.8540479340826, -190.8540423988113, -190.8540384674816, -190.8540279852523, -190.8540504075697, -190.8540399253409, -190.8540334037739, -190.854033048933, -190.8540453438621, -190.8540449890214, -190.8539948184792, -190.8540716343352, -190.8540067587274, -190.8540835742637, -190.854036182221, -190.8540302704436, -190.8540481223078, -190.8540422105333, -190.8540142892059, -190.8540521635153, -190.8540262292972, -190.8540641036005, -190.8540969361873, -190.853969518399, -190.8541088775238, -190.8539814572391, -190.8540123317888, -190.8540541211328, -190.8540242718599, 
  -190.8540660612383, -190.8541335856884, -190.8539328687521, -190.8541455257921, -190.8539448088249, -190.8540308990683, -190.8540355538253, -190.8540428388989, -190.8540474941713, -190.8540385334846, -190.8540279192601, -190.8540504735742, -190.8540398593471, -190.8539375899491, -190.8541288681188, -190.853949530018, -190.8541408082265, -190.8540391595668, -190.8540396580746, -190.8540387346852, -190.854039233193, -190.8540421764663, -190.8540366411854, -190.8540417515845, -190.8540362163041, -190.8540446499497, -190.8540341677187, -190.8540442250661, -190.8540337428391, -190.8540395862412, -190.8540392314002, -190.8540391613595, -190.8540388065187, -190.8540010010259, -190.8540778167231, -190.8540005761453, -190.8540773918405, -190.8540423646821, -190.854036452917, -190.8540419398113, 
  -190.8540360280245, -190.8540204716745, -190.8540583459811, -190.8540200467932, -190.8540579210992, -190.8541031192767, -190.853975700244, -190.854102694399, -190.8539752753586, -190.8540185142293, -190.8540603036267, -190.854018089384, -190.8540598787089, -190.8541397681613, -190.8539390512135, -190.8541393432837, -190.853938626328, -190.8540370814056, -190.8540417364224, -190.8540366565261, -190.8540413115388, -190.8540447159502, -190.854034101729, -190.8540442910732, -190.8540336768428, -190.8539437724113, -190.8541350505911, -190.8539433475204, -190.8541346257188, -190.8540417147716, -190.854036179491, -190.8540422132794, -190.8540366779988, -190.8540441882541, -190.8540337060251, -190.8540446867619, -190.8540342045329, -190.8540391245465, -190.8540387697057, -190.8540396230543, 
  -190.8540392682135, -190.8540005393315, -190.8540773550282, -190.8540010378398, -190.8540778535356, -190.8540419029929, -190.8540359912169, -190.8540424015008}
 {-369.9850384383053, -369.9850311955829, -369.9850305290141, -369.9850463476534, -369.9850456810895, -369.9850307695517, -369.9850309550453, -369.9850459216238, -369.9850461071192, -369.98502783446, -369.9850338901493, -369.9850429865224, -369.9850490422327, -369.9850335960659, -369.9850281285676, -369.9850487481385, -369.9850432806408, -369.9850307984823, -369.9850309261148, -369.9850459505551, -369.9850460781877, -369.9850230543412, -369.9850386704726, -369.9850382064396, -369.98505382252, -369.9850323766233, -369.9850293479837, -369.9850475286971, -369.9850445000558, -369.9850334510695, -369.9850282735481, -369.9850486031431, -369.9850434256203, -369.9849496308871, -369.9851120961868, -369.9849647816596, -369.9851272495602, -369.9850286627831, -369.9850330620894, -369.9850438148796, 
  -369.9850482141388, -369.9850091961557, -369.985052529585, -369.985024348214, -369.9850676816725, -369.985036939548, -369.985024785302, -369.9850520912825, -369.9850399377134, -369.9850273015572, -369.985034423468, -369.9850424536334, -369.9850495755376, -369.9850563770204, -369.9850053473495, -369.98507152909, -369.9850204994259, -369.9850386788412, -369.9850388643358, -369.9850380122748, -369.9850381977694, -369.9850357437455, -369.9850417994436, -369.9850350771773, -369.9850411328792, -369.9850415053576, -369.9850360378558, -369.9850408387876, -369.9850353712931, -369.9850387077723, -369.9850388354047, -369.985038041206, -369.9850381688385, -369.9850309636441, -369.9850465797495, -369.9850302970773, -369.9850459131837, -369.9850402859123, -369.9850372572747, -369.9850396193489, 
  -369.9850365907055, -369.9850413603598, -369.9850361828378, -369.9850406937936, -369.9850355162713, -369.9849575395361, -369.985120006118, -369.9849568729514, -369.9851193395698, -369.9850365721034, -369.9850409713492, -369.9850359055001, -369.9850403048197, -369.9850171054407, -369.9850604388799, -369.9850164388697, -369.9850597723183, -369.985044848667, -369.9850326947631, -369.9850441821043, -369.9850320281931, -369.9850352108474, -369.985042332758, -369.9850345442839, -369.9850416661886, -369.98506428631, -369.9850132566401, -369.9850636197413, -369.985012590076, -369.9850353177141, -369.9850413734141, -369.9850355032088, -369.9850415589087, -369.9850410793254, -369.9850356118272, -369.9850412648198, -369.9850357973219, -369.9850382817418, -369.9850384093743, -369.9850384672364, 
  -369.985038594869, -369.9850305376132, -369.9850461537197, -369.9850307231082, -369.9850463392138, -369.9850398598834, -369.985036831243, -369.9850400453779}
 {-8.07364023055126, -8.07364001578193, -8.07364003022748, -8.07364043087483, -8.07364044532036, -8.07364002101309, -8.07364002499632, -8.07364043610598, -8.07364044008921, -8.07363834525808, -8.07364170077467, -8.07363876035284, -8.07364211586568, -8.07364004744411, -8.07363999857457, -8.07364046253583, -8.07364041366863, -8.07363996718142, -8.07364007882802, -8.07364038227425, -8.07364049392097, -8.07361297919646, -8.07366706767141, -8.07361339434911, -8.07366748270452, -8.07363665183034, -8.07364339419282, -8.07363706692196, -8.07364380928697, -8.07363575121007, -8.0736442948387, -8.07363616630085, -8.0736447099337, -8.07363873615915, -8.07364130985263, -8.07363915125442, -8.07364172494314, -8.07364094183259, -8.07363910421179, -8.07364135692735, -8.0736395193028, -8.07365932457401, 
  -8.07362072186071, -8.07365973967338, -8.07362113694712, -8.07364002386708, -8.07364002214234, -8.07364043895996, -8.07364043723523, -8.07364534742654, -8.0736346985595, -8.07364576251782, -8.07363511365399, -8.0736421653954, -8.07363788099337, -8.07364258047951, -8.07363829609504, -8.07364022133688, -8.07364022532011, -8.07364023578242, -8.07364023976565, -8.07363854558281, -8.07364190109751, -8.07363856002833, -8.07364191554306, -8.07364024776734, -8.07364019889892, -8.07364026221283, -8.07364021334451, -8.07364016750518, -8.07364027915184, -8.07364018195072, -8.07364029359738, -8.07361317954885, -8.07366726796659, -8.07361319399695, -8.07366728240957, -8.07363685215352, -8.07364359451721, -8.073636866599, -8.0736436089628, -8.07363595153285, -8.0736444951635, -8.0736359659783, 
  -8.07364450960913, -8.07363893648415, -8.07364151017521, -8.07363895092966, -8.07364152462078, -8.07364114215717, -8.07363930453479, -8.073641156603, -8.07363931898003, -8.07365952490089, -8.0736209221814, -8.07365953934672, -8.07362093662666, -8.07364022419086, -8.07364022246613, -8.07364023863641, -8.07364023691167, -8.07364554774956, -8.07363489888405, -8.07364556219503, -8.07363491332966, -8.07364236571499, -8.07363808132136, -8.07364238016015, -8.07363809576728, -8.07363855081395, -8.07364190632868, -8.0736385547972, -8.07364191031189, -8.07364025299848, -8.07364020413009, -8.07364025698169, -8.07364020811334, -8.07364017273633, -8.07364028438299, -8.07364017671956, -8.07364028836622, -8.07361318478102, -8.07366727319673, -8.07361318876478, -8.07366727717943, -8.07363685738465, 
  -8.07364359974839, -8.07363686136787}
 {-232.5196496329105, -232.5196488084479, -232.519648141649, -232.5196511241905, -232.5196504573892, -232.5196485107782, -232.5196484393188, -232.5196508265198, -232.51965075506, -232.5196494057239, -232.5196475443764, -232.5196517214587, -232.5196498601245, -232.5196508351454, -232.5196461149704, -232.5196531508864, -232.5196484307123, -232.5196484630361, -232.5196484870609, -232.5196507787775, -232.5196508028024, -232.5196530043913, -232.519643945795, -232.5196553201135, -232.5196462615557, -232.51964780969, -232.5196491404143, -232.5196501254317, -232.5196514561555, -232.519650556419, -232.519646393696, -232.51965287216, -232.5196487094379, -232.5196959058995, -232.5196010456232, -232.519698222173, -232.5196033608326, -232.5196412609267, -232.5196556893226, -232.519643576664, 
  -232.5196580050682, -232.5196324292099, -232.5196645218297, -232.5196347449585, -232.519666837564, -232.5196455627694, -232.519651387452, -232.5196478784073, -232.5196537032969, -232.5196528452703, -232.5196441048217, -232.5196551610133, -232.5196464205615, -232.5196596032812, -232.5196373467773, -232.519661919025, -232.5196396625163, -232.5196500020403, -232.5196499305807, -232.5196493352402, -232.5196492637806, -232.5196508969833, -232.5196490356409, -232.5196502301818, -232.5196483688424, -232.5196523264085, -232.5196476062314, -232.5196516596059, -232.5196469394339, -232.519649954298, -232.5196499783229, -232.519649287498, -232.5196493115228, -232.5196544956445, -232.5196454370658, -232.5196538288427, -232.5196447702674, -232.519649300953, -232.5196506316753, -232.5196486341513, 
  -232.519649964877, -232.5196520476808, -232.5196478849581, -232.5196513808806, -232.5196472181582, -232.5196973974329, -232.5196025366138, -232.5196967306221, -232.5196018698245, -232.5196427521786, -232.5196571805948, -232.5196420853946, -232.5196565137785, -232.519633920474, -232.5196660130897, -232.519633253677, -232.5196653462865, -232.5196470539769, -232.5196528787685, -232.5196463871823, -232.5196522119629, -232.519654336533, -232.5196455960829, -232.519653669733, -232.5196449292827, -232.5196610945436, -232.5196388380389, -232.5196604277452, -232.5196381712372, -232.5196505993124, -232.5196487379715, -232.5196505278528, -232.5196486665119, -232.5196520287371, -232.5196473085625, -232.5196519572774, -232.5196472371029, -232.5196496566279, -232.5196496806527, -232.5196495851683, 
  -232.5196496091931, -232.5196541979737, -232.5196451393962, -232.5196541265136, -232.5196450679371, -232.5196490032821, -232.5196503340059, -232.5196489318223}
 {-373.1561510460946, -373.1561511094775, -373.1561510527738, -373.1561510394156, -373.1561509827122, -373.1561510815972, -373.1561510806541, -373.1561510115354, -373.1561510105924, -373.1561512076018, -373.1561509546499, -373.1561511375379, -373.1561508845903, -373.1561513906159, -373.1561507716541, -373.1561513205537, -373.1561507015928, -373.1561511969987, -373.1561509652527, -373.1561511269368, -373.1561508951909, -373.1561523179299, -373.156149844151, -373.1561522478586, -373.1561497740988, -373.1561569438149, -373.1561452184297, -373.156156873753, -373.1561451483681, -373.1561457478077, -373.1561564144532, -373.1561456777458, -373.1561563443916, -373.1561510730525, -373.1561510891988, -373.156151002991, -373.1561510191368, -373.15616539809, -373.1561367643111, -373.1561653280283, 
  -373.1561366942492, -373.1560976765603, -373.1562044866328, -373.1560976064988, -373.1562044165708, -373.1561511103853, -373.1561510518661, -373.1561510403231, -373.1561509818049, -373.1561509767173, -373.156151185607, -373.1561509066557, -373.156151115545, -373.156119318001, -373.156182846185, -373.1561192479402, -373.1561827761223, -373.1561510749179, -373.1561510739748, -373.1561510182143, -373.1561510172712, -373.1561512009216, -373.1561509479716, -373.1561511442178, -373.1561508912682, -373.1561513839367, -373.1561507649748, -373.1561513272325, -373.1561507082717, -373.1561511903193, -373.1561509585734, -373.1561511336158, -373.1561509018698, -373.1561523112519, -373.1561498374705, -373.1561522545362, -373.156149780779, -373.1561569371357, -373.1561452117505, -373.1561568804319, 
  -373.156145155047, -373.1561457411284, -373.156156407774, -373.1561456844248, -373.1561563510704, -373.1561510663733, -373.1561510825195, -373.1561510096697, -373.1561510258158, -373.1561653914106, -373.1561367576319, -373.1561653347073, -373.156136700928, -373.1560976698808, -373.1562044799538, -373.156097613178, -373.1562044232494, -373.1561511037059, -373.1561510451871, -373.1561510470023, -373.1561509884835, -373.1561509700383, -373.1561511789273, -373.1561509133343, -373.1561511222242, -373.1561193113214, -373.156182839506, -373.1561192546194, -373.1561827828009, -373.1561511730412, -373.1561509200914, -373.156151172098, -373.1561509191484, -373.1561513560561, -373.1561507370948, -373.1561513551131, -373.1561507361517, -373.156151162439, -373.1561509306931, -373.156151161496, 
  -373.1561509297501, -373.1561522833651, -373.1561498095966, -373.1561522824229, -373.1561498086527, -373.1561569092553, -373.1561451838702, -373.1561569083122}
 {-243.171163392061, -243.1711615435172, -243.1711608430316, -243.171165941123, -243.1711652406345, -243.1711611285532, -243.1711612579956, -243.1711655261569, -243.1711656556007, -243.1711625012877, -243.1711598852698, -243.1711668988843, -243.1711642828819, -243.1711674981014, -243.171154888487, -243.1711718957049, -243.1711592860922, -243.1711612406734, -243.1711611458755, -243.1711656382777, -243.17116554348, -243.1711520235525, -243.171170363187, -243.1711564211791, -243.1711747607691, -243.1711622574864, -243.1711601290697, -243.171166655091, -243.1711645266739, -243.1711642308925, -243.1711581556842, -243.1711686284974, -243.1711625532881, -243.1712186264416, -243.1711037619326, -243.171223024871, -243.1711081587121, -243.1711448322553, -243.171177554643, -243.1711492298463, 
  -243.1711819522607, -243.1711899198588, -243.1711324681991, -243.1711943174741, -243.1711368657926, -243.1711682143858, -243.1711541722543, -243.1711726118337, -243.1711585700152, -243.17116819791, -243.1711541888034, -243.1711725955156, -243.1711585864066, -243.1711992863219, -243.1711230998948, -243.1712036839234, -243.1711274975021, -243.1711636775829, -243.1711638070261, -243.1711629770959, -243.1711631065391, -243.1711650503151, -243.1711624343024, -243.1711643498256, -243.171161733818, -243.1711700471322, -243.1711574375162, -243.1711693466428, -243.1711567370316, -243.1711637897035, -243.1711636949055, -243.1711630892164, -243.1711629944186, -243.1711545725938, -243.1711729122058, -243.1711538721065, -243.1711722117189, -243.1711648065154, -243.1711626781008, -243.1711641060307, 
  -243.1711619776114, -243.1711667799228, -243.171160704714, -243.1711660794359, -243.1711600042269, -243.1712211758893, -243.1711063105452, -243.1712204753921, -243.1711056100684, -243.1711473812666, -243.1711801036918, -243.1711466808037, -243.1711794031806, -243.1711924688927, -243.1711350172253, -243.171191768409, -243.171134316735, -243.1711707633349, -243.1711567213653, -243.1711700628532, -243.1711560208729, -243.17117074694, -243.1711567378335, -243.1711700464543, -243.1711560373452, -243.1712018353514, -243.1711256489254, -243.1712011348625, -243.1711249484402, -243.1711646353488, -243.1711620193387, -243.171164764792, -243.1711621487818, -243.171169632166, -243.1711570225525, -243.1711697616091, -243.1711571519956, -243.1711633747384, -243.1711632799406, -243.1711635041816, 
  -243.1711634093837, -243.1711541576288, -243.1711724972407, -243.1711542870716, -243.1711726266842, -243.1711643915516, -243.1711622631346, -243.1711645209946}
 {-15.11310612053935, -15.11312716830921, -15.11312428329301, -15.113087957889, -15.11308507289953, -15.11312583998855, -15.11312561161334, -15.11308662958053, -15.11308640120767, -15.11312185605813, -15.11312959555879, -15.11308264565271, -15.11309038515051, -15.11312320573689, -15.11312824588207, -15.11308399532802, -15.11308903547725, -15.11312565269643, -15.11312579890547, -15.11308644228958, -15.11308658849863, -15.11311996788219, -15.11313148412071, -15.11308075748533, -15.11309227370388, -15.11312435070936, -15.11312710092048, -15.11308514030207, -15.11308789051407, -15.11312748136089, -15.11312397025729, -15.11308827095426, -15.11308475985022, -15.11307837409494, -15.1131730780463, -15.11303916359753, -15.11313386773003, -15.11313618659556, -15.1131152650712, -15.11309697616387, 
  -15.1130760546892, -15.11313290355299, -15.11311854873287, -15.11309369315673, -15.11307933831545, -15.11310907424439, -15.11314237772682, -15.1130698642658, -15.11310316689172, -15.11312495283759, -15.11312649885147, -15.11308574242956, -15.11308728844581, -15.11313991670728, -15.11311153471494, -15.11310070629986, -15.11307232430867, -15.11310767722798, -15.11310744885387, -15.11310479222507, -15.11310456385112, -15.1131036933005, -15.11311143279638, -15.11310080829432, -15.1131085477969, -15.11310504297684, -15.11311008312208, -15.11310215797205, -15.1131071981212, -15.11310748993642, -15.11310763614544, -15.11310460493357, -15.11310475114263, -15.11310180512648, -15.11311332135638, -15.11309892012501, -15.11311043635219, -15.11310618794924, -15.11310893816055, -15.11310330294616, 
  -15.11310605315797, -15.1131093186009, -15.11310580749723, -15.11310643359822, -15.11310292249425, -15.11306021127337, -15.11315491534783, -15.11305732630307, -15.11315203031248, -15.11311802383961, -15.11309710230711, -15.11311513880379, -15.11309421733727, -15.11311474079851, -15.11310038596732, -15.11311185579518, -15.11309750096498, -15.11309091168177, -15.11312421476939, -15.1130880267124, -15.11312132973312, -15.11310679007666, -15.11310833609235, -15.11310390507446, -15.1131054510889, -15.11312175394676, -15.11309337195542, -15.11311886894436, -15.11309048695216, -15.11310236498428, -15.11311010448347, -15.11310213661022, -15.11310987610947, -15.11310371466131, -15.11310875480848, -15.11310348628725, -15.11310852643448, -15.11310616162185, -15.11310630783088, -15.11310593324781, 
  -15.11310607945686, -15.11310047681512, -15.11311199303862, -15.11310024843605, -15.11311176466963, -15.11310485963472, -15.11310760984595, -15.11310463126036}
 {-163.6654717433054, -163.6654676486474, -163.6654686038215, -163.6654748828182, -163.6654758380048, -163.6654680702937, -163.6654681821749, -163.66547530447, -163.6654754163527, -163.6654670938311, -163.6654691586439, -163.6654743280083, -163.6654763928207, -163.6654687665152, -163.6654674859633, -163.665476000692, -163.6654747201406, -163.6654680951774, -163.6654681572913, -163.6654753293544, -163.6654753914683, -163.6654624782252, -163.6654737744878, -163.6654697124039, -163.6654810086631, -163.6654668096243, -163.6654694428596, -163.6654740438012, -163.6654766770368, -163.6654703201033, -163.66546593238, -163.6654775542804, -163.665473166557, -163.6654876053269, -163.6654486476767, -163.6654948400253, -163.6654558813323, -163.6654695273744, -163.6654667251588, -163.6654767615354, 
  -163.6654739593518, -163.6654790701687, -163.6654571830675, -163.6654863043522, -163.6654644172381, -163.6654752511353, -163.6654610013506, -163.6654824851827, -163.6654682356572, -163.6654791921741, -163.6654570602404, -163.6654864263509, -163.6654642944176, -163.6654969773817, -163.6654392747058, -163.6655042115586, -163.6654465088829, -163.6654712097744, -163.6654713216563, -163.6654721649547, -163.6654722768367, -163.6654702333122, -163.6654722981248, -163.6654711884926, -163.6654732533052, -163.665471905996, -163.6654706254445, -163.6654728611765, -163.6654715806247, -163.6654712346584, -163.6654712967723, -163.6654721898388, -163.6654722519526, -163.665465617707, -163.665476913968, -163.6654665728874, -163.6654778691483, -163.6654699491052, -163.6654725823407, -163.6654709042856, 
  -163.665473537521, -163.6654734595843, -163.665469071861, -163.6654744147647, -163.6654700270414, -163.6654907450562, -163.6654517869094, -163.6654917002613, -163.6654527420651, -163.6654726668406, -163.6654698646547, -163.6654736220347, -163.6654708198213, -163.6654822096526, -163.6654603225456, -163.6654831648337, -163.6654612777253, -163.6654783905573, -163.6654641408905, -163.6654793457261, -163.6654650960826, -163.665482331655, -163.6654601997214, -163.6654832868353, -163.6654611549019, -163.6655001168627, -163.6654424141868, -163.665501072043, -163.6654433693673, -163.6654706549612, -163.6654727197738, -163.6654707668432, -163.6654728316558, -163.6654723276451, -163.6654710470934, -163.6654724395271, -163.6654711589754, -163.6654716563074, -163.6654717184213, -163.6654717681894, 
  -163.6654718303033, -163.665466039356, -163.665477335617, -163.6654661512381, -163.6654774474989, -163.6654703707543, -163.6654730039898, -163.6654704826363}
 {-374.763935470959, -374.7639381537617, -374.7639374756429, -374.7639334662943, -374.7639327881744, -374.76393780291, -374.7639378264941, -374.7639331154419, -374.7639331390263, -374.7639385286334, -374.7639371007712, -374.7639338411596, -374.763932413309, -374.7639379740237, -374.7639376553994, -374.7639332865551, -374.7639329679322, -374.7639378563013, -374.7639377731029, -374.7639331688333, -374.7639330856349, -374.7639359220334, -374.7639397073978, -374.7639312345753, -374.7639350199198, -374.7639400086327, -374.763935620786, -374.7639353211652, -374.7639309333177, -374.7639397948809, -374.7639358345403, -374.7639351074132, -374.7639311470722, -374.7639168778259, -374.7639587530039, -374.7639121901442, -374.7639540657497, -374.763951772487, -374.7639238570695, -374.7639470850204, 
  -374.7639191696002, -374.7639192681122, -374.7639563622347, -374.7639145806413, -374.7639516747697, -374.7639421387785, -374.7639334906203, -374.7639374512938, -374.7639288031691, -374.7639374064228, -374.7639382230626, -374.7639327189559, -374.7639335355935, -374.7639474798942, -374.7639281495388, -374.7639427924251, -374.7639234620721, -374.7639357982268, -374.763935821811, -374.7639351201074, -374.7639351436916, -374.7639365239482, -374.76393509609, -374.7639358458271, -374.7639344179723, -374.7639359693416, -374.7639356507152, -374.7639352912194, -374.7639349725985, -374.7639358516182, -374.7639357684196, -374.7639351734988, -374.7639350903003, -374.763933917355, -374.7639377027097, -374.7639332392359, -374.76393702459, -374.763938003949, -374.7639336161034, -374.763937325831, 
  -374.7639329379827, -374.7639377901979, -374.763933829857, -374.7639371120785, -374.7639331517376, -374.7639148730185, -374.763956748445, -374.763914194934, -374.7639560702909, -374.7639497678084, -374.7639218523817, -374.7639490896812, -374.7639211742702, -374.7639172634282, -374.7639543575523, -374.7639165853074, -374.7639536794343, -374.7639401340833, -374.7639314859491, -374.7639394559711, -374.7639308078225, -374.7639354017404, -374.7639362183786, -374.7639347236206, -374.7639355402597, -374.7639454752109, -374.7639261448558, -374.7639447970907, -374.7639254667374, -374.7639361730953, -374.7639347452389, -374.7639361966795, -374.7639347688231, -374.7639356184882, -374.7639352998645, -374.7639356420724, -374.7639353234488, -374.7639355007661, -374.7639354175676, -374.7639355243503, 
  -374.7639354411518, -374.7639335665036, -374.7639373518571, -374.7639335900868, -374.7639373754423, -374.7639376530977, -374.7639332652505, -374.7639376766818}
 {-47.21505262258209, -47.21507429641941, -47.21507426658645, -47.21503097876012, -47.21503094898802, -47.21507445572941, -47.21507410727305, -47.21503113810094, -47.21503078964382, -47.21507112876528, -47.21507743426775, -47.21502781114193, -47.21503411663337, -47.21507650983584, -47.21507205329106, -47.21503319219876, -47.2150287356704, -47.21507452263416, -47.2150740403683, -47.21503120500534, -47.21503072273938, -47.21509404404758, -47.21505451970009, -47.21505072632411, -47.21501120216582, -47.2150861597321, -47.21506240334882, -47.21504284210525, -47.21501908571794, -47.21507346770582, -47.21507509534909, -47.21503015007484, -47.21503177772234, -47.21511749650558, -47.21503107273629, -47.21507418069717, -47.21498775328711, -47.21510059410498, -47.21504796960408, -47.2150572764207, 
  -47.21500465203063, -47.21499180914898, -47.2151567570561, -47.21494849154984, -47.21511343939751, -47.21509021164942, -47.21505835157013, -47.21504689414725, -47.21501503381457, -47.21506876158029, -47.21507980203986, -47.2150254439449, -47.21503648441755, -47.21507393736318, -47.21507462755544, -47.21503061974501, -47.21503130991589, -47.21505281171335, -47.21505246325683, -47.21505278191104, -47.2150524334541, -47.21504948475438, -47.21505579024633, -47.21504945494686, -47.21505576044883, -47.21505486581525, -47.21505040927935, -47.21505483601343, -47.21505037947614, -47.21505287861802, -47.21505239635215, -47.21505284881555, -47.21505236654959, -47.21507239998771, -47.21503287572767, -47.21507237017804, -47.21503284593231, -47.2150645157189, -47.21504075932971, -47.21506448591251, 
  -47.21504072953108, -47.21505182368885, -47.21505345133377, -47.21505179388587, -47.21505342153171, -47.2150958533027, -47.21500942790695, -47.21509582369409, -47.21500939791053, -47.2150789500556, -47.21502632562118, -47.21507892026415, -47.2150262958076, -47.21497016514506, -47.21513511302774, -47.21497013534782, -47.21513508321993, -47.21506856769887, -47.2150367074884, -47.21506853789187, -47.21503667769035, -47.21504711756296, -47.21505815802492, -47.2150470877563, -47.21505812822655, -47.21505229335029, -47.21505298353605, -47.21505226355196, -47.21505295372934, -47.2150496440773, -47.21505594957424, -47.21504929562056, -47.21505560111753, -47.21505502514094, -47.21505056860447, -47.21505467668432, -47.21505022014763, -47.21505303794344, -47.21505255567753, -47.21505268948672, 
  -47.21505220722081, -47.21507255931195, -47.21503303505425, -47.2150722108504, -47.21503268660234, -47.21506467504229, -47.21504091865715, -47.21506432658572}
 {-101.4320844426795, -101.432072777144, -101.4320748241667, -101.4320940612474, -101.4320961082948, -101.432073719556, -101.4320738817542, -101.4320950036708, -101.4320951658709, -101.4320716606123, -101.4320759407116, -101.4320929447298, -101.4320972248257, -101.4320733484218, -101.4320742529061, -101.4320946325354, -101.4320955370241, -101.4320737616589, -101.4320738396513, -101.4320950457746, -101.4320951237671, -101.4320676247866, -101.4320799769791, -101.4320889089111, -101.4321012610862, -101.4320725013367, -101.4320750999986, -101.432093785452, -101.4320963841148, -101.432075666769, -101.432071934558, -101.4320969508849, -101.4320932186736, -101.4321068806951, -101.432040721216, -101.432128165633, -101.4320620045097, -101.4320760900353, -101.4320715113462, -101.4320973741297, 
  -101.4320927954833, -101.432083000328, -101.4320646017109, -101.4321042844536, -101.4320858858169, -101.4320676518519, -101.4320799496427, -101.4320889356678, -101.4321012340583, -101.4320778675793, -101.43206973373, -101.432099151693, -101.4320910178478, -101.432087796668, -101.4320598044712, -101.4321090807828, -101.4320810885879, -101.4320833380627, -101.4320835002618, -101.4320853850976, -101.4320855472969, -101.43208127912, -101.4320855592183, -101.4320833261556, -101.4320876062527, -101.4320829669271, -101.4320838714151, -101.4320850139636, -101.4320859184486, -101.432083380166, -101.4320834581585, -101.4320854272011, -101.4320855051935, -101.4320772432983, -101.4320895954817, -101.4320792903329, -101.4320916425171, -101.4320821198435, -101.4320847185061, -101.4320841668788, 
  -101.4320867655409, -101.4320852852762, -101.4320815530651, -101.4320873323112, -101.4320836001002, -101.4321164995948, -101.4320503393306, -101.4321185466668, -101.4320523863286, -101.4320857085209, -101.4320811298749, -101.4320877555777, -101.4320831768882, -101.4320926188392, -101.432074220214, -101.432094665876, -101.4320762672474, -101.4320772702219, -101.4320895682871, -101.4320793172314, -101.4320916153476, -101.4320874860853, -101.4320793522384, -101.4320895331207, -101.432081399273, -101.4320974151749, -101.4320694229786, -101.4320994622095, -101.432071470014, -101.432082221538, -101.4320865016356, -101.4320823837372, -101.4320866638348, -101.4320839093455, -101.4320848138321, -101.4320840715447, -101.4320849760312, -101.4320843225837, -101.4320844005762, -101.4320844847829, 
  -101.4320845627754, -101.432078185715, -101.4320905379004, -101.4320783479158, -101.432090700098, -101.4320830622611, -101.4320856609239, -101.4320832244607}
 {-233.0811272624751, -233.0811310253169, -233.0811296003883, -233.0811249246074, -233.0811234996711, -233.0811305806811, -233.0811300450235, -233.0811244799703, -233.0811239443076, -233.0811321403639, -233.081128485346, -233.0811260396408, -233.0811223846425, -233.0811351649597, -233.0811254607806, -233.0811290642468, -233.0811193600668, -233.0811300642611, -233.0811305614435, -233.0811239635479, -233.0811244607302, -233.0811643541742, -233.0810962714092, -233.0811582533507, -233.0810901708062, -233.0811186372038, -233.0811419884622, -233.0811125364922, -233.0811358877472, -233.0810967004985, -233.0811639252215, -233.081090599783, -233.0811578245105, -233.0811982910554, -233.0810623376055, -233.0811921912542, -233.0810562359801, -233.0811210941849, -233.0811395318513, -233.0811149934562, 
  -233.0811334311533, -233.080961231599, -233.081299396703, -233.0809551308978, -233.0812932959776, -233.0811409044548, -233.081119721275, -233.0811348036281, -233.0811136206751, -233.0811444759343, -233.0811161497337, -233.0811383752236, -233.0811100490176, -233.0809930326844, -233.0812676007813, -233.0809869319844, -233.0812615000547, -233.081128242772, -233.0811277071115, -233.0811268178392, -233.0811262821793, -233.0811298024494, -233.0811261474393, -233.0811283775149, -233.0811247225088, -233.0811328270515, -233.0811231228676, -233.0811314021147, -233.0811216979395, -233.0811277263506, -233.081128223533, -233.0811263014181, -233.0811267986005, -233.0811620162083, -233.081093933554, -233.0811605912762, -233.0810925086211, -233.0811162992986, -233.0811396505463, -233.0811148743572, 
  -233.0811382256228, -233.0810943625869, -233.081161587312, -233.0810929376543, -233.0811601623797, -233.0811959536302, -233.0810599992096, -233.0811945286392, -233.0810585743357, -233.0811187562524, -233.0811371939626, -233.0811173313484, -233.0811357690016, -233.0809588936932, -233.0812970587876, -233.0809574687632, -233.0812956338527, -233.08113856648, -233.0811173834287, -233.0811371415626, -233.0811159584811, -233.0811421380272, -233.0811138118197, -233.0811407130905, -233.0811123868913, -233.0809906947767, -233.0812652628679, -233.0809892698519, -233.0812638379278, -233.081129357812, -233.081125702804, -233.0811288221518, -233.0811251671437, -233.0811323824131, -233.0811226782333, -233.0811318467527, -233.0811221425733, -233.0811272817142, -233.0811277788965, -233.0811267460539, 
  -233.0811272432364, -233.0811615715731, -233.0810934889164, -233.081161035911, -233.0810929532581, -233.0811158546581, -233.081139205914, -233.0811153189971}
 {-23.02558189726699, -23.0256036069991, -23.02560298544987, -23.02556080918653, -23.02556018763954, -23.02560346522919, -23.02560312722038, -23.02556066741674, -23.02556032940993, -23.02560370836944, -23.0256028840887, -23.02556091055434, -23.02556008628091, -23.02560531181752, -23.02560128063722, -23.02556251400586, -23.02555848282597, -23.02560329981012, -23.02560329263948, -23.02556050199864, -23.02556049482806, -23.0255971379064, -23.02560945469587, -23.02555434011095, -23.02556665686842, -23.0256030654924, -23.02560352696044, -23.02556026768038, -23.02556072914955, -23.02560466790619, -23.02560192455844, -23.0255618700951, -23.02555912674664, -23.02553241730936, -23.02567417576395, -23.02548961904389, -23.02563137840654, -23.02560667974399, -23.02559991277998, -23.02556388191165, 
  -23.02555711498942, -23.02561463450338, -23.02559195869469, -23.02557183670115, -23.02554916087402, -23.02556144365345, -23.02564514961874, -23.02551864630501, -23.02560235134428, -23.02560929664002, -23.02559729577271, -23.0255664988296, -23.02555449796022, -23.02561545835104, -23.02559113401206, -23.02557266053868, -23.02554833620154, -23.02558237704464, -23.02558203903682, -23.02558175549652, -23.02558141748871, -23.02558262018675, -23.02558179590329, -23.02558199863226, -23.02558117436154, -23.02558422363352, -23.02558019245311, -23.02558360208509, -23.0255795709053, -23.02558221162607, -23.02558220445543, -23.02558159007792, -23.02558158290735, -23.0255760497297, -23.02558836650446, -23.02557542818288, -23.02558774495505, -23.02558197730878, -23.02558243877594, -23.02558135575922, 
  -23.02558181722927, -23.02558357972222, -23.02558083637431, -23.02558295817429, -23.025580214826, -23.02551132889719, -23.02565308780802, -23.02551070735128, -23.0256524662577, -23.0255855915734, -23.02557882458246, -23.02558496997746, -23.02557820308217, -23.02559354632495, -23.02557087050501, -23.0255929247748, -23.02557024895892, -23.02554035569864, -23.02562406120544, -23.02553973415504, -23.0256234396528, -23.02558820845548, -23.02557620758913, -23.02558758690936, -23.02557558603902, -23.02559437016592, -23.02557004582908, -23.02559374861902, -23.02556942427974, -23.02558247841375, -23.02558165413658, -23.02558214040586, -23.02558131612884, -23.02558408186351, -23.02558005068341, -23.0255837438557, -23.0255797126756, -23.02558206985619, -23.0255820626856, -23.02558173184838, 
  -23.02558172467777, -23.02557590796494, -23.02558822472951, -23.02557556994823, -23.02558788673059, -23.02558183553828, -23.02558229700673, -23.02558149753032}
 {-321.0702955481473, -321.0702949788588, -321.0702933532342, -321.0702977430711, -321.0702961174503, -321.0702942029316, -321.070294129161, -321.0702969671461, -321.070296893375, -321.070293455678, -321.0702948764175, -321.0702962198952, -321.0702976406288, -321.0702990836889, -321.0702892484453, -321.0703018479051, -321.0702920126577, -321.0702941907614, -321.0702941413312, -321.0702969549756, -321.0702969055454, -321.0702987185751, -321.0702896136019, -321.0703014827715, -321.0702923778341, -321.0702931141443, -321.0702952179567, -321.0702958783588, -321.0702979821706, -321.0702960815587, -321.070292250552, -321.0702988457727, -321.0702950147664, -321.0703292796475, -321.0702590534601, -321.0703320444387, -321.0702618170973, -321.0702988015391, -321.0702895306697, -321.0703015657484, 
  -321.0702922948887, -321.0702789155094, -321.0703094174964, -321.0702816797293, -321.070312181705, -321.0702926643478, -321.0702956678445, -321.0702954284655, -321.0702984321553, -321.0702985857397, -321.0702897463471, -321.0703013499521, -321.0702925105632, -321.0703052980013, -321.0702830340524, -321.0703080622173, -321.0702857982648, -321.0702963978444, -321.0702963240735, -321.0702947722216, -321.0702946984507, -321.0702956505929, -321.0702970713279, -321.0702940249686, -321.0702954457067, -321.0703012786058, -321.0702914433536, -321.0702996529764, -321.0702898177375, -321.070296385674, -321.0702963362438, -321.0702947600512, -321.0702947106211, -321.0703009134764, -321.0702918085258, -321.0702992878584, -321.0702901828983, -321.0702953090576, -321.0702974128687, -321.0702936834338, 
  -321.0702957872469, -321.0702982764712, -321.0702944454646, -321.0702966508485, -321.0702928198419, -321.0703314748681, -321.0702612480647, -321.0703298492063, -321.070259622481, -321.0703009964384, -321.0702917255954, -321.0702993708372, -321.0702900999512, -321.0702811104247, -321.0703116124063, -321.0702794848022, -321.0703099867833, -321.0702948592032, -321.0702978628144, -321.0702932335984, -321.0702962371736, -321.0703007806511, -321.0702919412608, -321.0702991550287, -321.0702903156377, -321.0703074929145, -321.0702852289643, -321.0703058672924, -321.070283603341, -321.0702948746659, -321.0702962954025, -321.0702948008952, -321.0702962216317, -321.0703005026764, -321.0702906674308, -321.0703004289054, -321.0702905936601, -321.0702956097478, -321.0702955603177, -321.070295535977, 
  -321.0702954865469, -321.0703001375526, -321.0702910325973, -321.0703000637818, -321.0702909588265, -321.0702945331316, -321.0702966369422, -321.0702944593593}
 {-54.46336495605488, -54.46337299440699, -54.46337479242638, -54.46335511981362, -54.46335691778892, -54.46337392983682, -54.46337385699492, -54.46335605522053, -54.46335598238035, -54.46337906747535, -54.46336871936693, -54.4633611928308, -54.46335084478063, -54.46336616117384, -54.46338162568352, -54.46334828656815, -54.46336375105838, -54.46337398339293, -54.46337380343879, -54.46335610877737, -54.4633559288235, -54.46336393864277, -54.46338384836111, -54.4633460640816, -54.46336597369144, -54.46337940791624, -54.46336837896905, -54.46336153329969, -54.46335050435477, -54.46337521155495, -54.46337257528802, -54.46335733694067, -54.46335470067146, -54.46335400654514, -54.46339378117238, -54.46333613218296, -54.46337590630375, -54.46335900362802, -54.46338878330659, -54.46334112899054, 
  -54.46337090871324, -54.46339412409462, -54.46335366361687, -54.46337624949331, -54.46333578898734, -54.46337655792968, -54.46337122892645, -54.46335868346396, -54.46335335416133, -54.46336624616547, -54.46338154087938, -54.46334837155895, -54.46336366625505, -54.46338136674149, -54.46336642021992, -54.46336349212137, -54.46334854560919, -54.46336409347749, -54.46336402063656, -54.46336589147496, -54.46336581863379, -54.46336923110259, -54.463358883022, -54.46337102909864, -54.46336068102065, -54.46335632481858, -54.4633717893211, -54.46335812281849, -54.46337358731588, -54.46336414703402, -54.46336396708001, -54.46336594503138, -54.46336576507736, -54.46335410231257, -54.46337401197363, -54.46335590030688, -54.46337580997402, -54.46336957155731, -54.4633585426103, -54.4633713695537, 
  -54.46336034060861, -54.46336537519675, -54.46336273892854, -54.46336717319396, -54.46336453692602, -54.46334417035044, -54.46338394464941, -54.46334596827275, -54.46338574272181, -54.46334916726332, -54.46337894695362, -54.46335096525033, -54.4633807449613, -54.46338428774396, -54.46334382724984, -54.46338608573905, -54.46334562524946, -54.46336672165664, -54.4633613924818, -54.46336851963208, -54.46336319050106, -54.46335640981164, -54.46337170451552, -54.46335820780787, -54.46337350251399, -54.46337153037982, -54.46335658386391, -54.46337332837813, -54.46335838186029, -54.46337016652038, -54.46335981844097, -54.46337009367921, -54.46335974560005, -54.46335726023819, -54.46337272473824, -54.46335718739724, -54.4633726518971, -54.46336508245239, -54.4633649024984, -54.46336500961136, 
  -54.46336482965734, -54.46335503773138, -54.46337494739156, -54.46335496488643, -54.46337487455443, -54.46337050697492, -54.46335947802945, -54.46337043413446}
 {-273.406456640271, -273.4064572257497, -273.4064572474613, -273.4064560330824, -273.4064560547933, -273.4064572371501, -273.4064572360608, -273.4064560444825, -273.4064560433932, -273.4064573252595, -273.4064571479517, -273.4064561325919, -273.4064559552841, -273.4064576130731, -273.4064568601391, -273.4064564204055, -273.4064556674714, -273.4064572386202, -273.4064572345907, -273.4064560459526, -273.4064560419231, -273.4064603317615, -273.4064541414578, -273.4064591390935, -273.4064529487905, -273.4064558556043, -273.4064586176083, -273.4064546629368, -273.4064574249406, -273.406458627744, -273.406455845469, -273.4064574350764, -273.4064546528015, -273.4064575367802, -273.4064569365991, -273.4064563441313, -273.4064557439129, -273.4064574371499, -273.4064570360814, -273.4064562444806, 
  -273.4064558434155, -273.4064404613333, -273.4064740121261, -273.4064392686664, -273.4064728194578, -273.4064632664791, -273.4064512066956, -273.4064620738133, -273.4064500140263, -273.4064630863332, -273.4064513868447, -273.4064618936657, -273.4064501941771, -273.4064553561926, -273.4064591175851, -273.406454163525, -273.4064579249175, -273.40645662996, -273.4064566288708, -273.4064566516712, -273.406456650582, -273.4064567180694, -273.4064565407615, -273.4064567397806, -273.4064565624728, -273.406457005883, -273.4064562529489, -273.4064570275943, -273.4064562746602, -273.4064566314301, -273.4064566274006, -273.4064566531413, -273.4064566491118, -273.4064597245712, -273.4064535342678, -273.4064597462825, -273.4064535559791, -273.4064552484143, -273.4064580104181, -273.4064552701255, 
  -273.4064580321294, -273.406458020554, -273.4064552382789, -273.4064580422652, -273.4064552599902, -273.4064569296019, -273.4064563293973, -273.4064569513083, -273.4064563511133, -273.4064568299591, -273.406456428892, -273.40645685167, -273.4064564506036, -273.4064398541436, -273.4064734049356, -273.4064398758547, -273.406473426647, -273.40646265929, -273.4064505995045, -273.406462681001, -273.406450621216, -273.4064624791432, -273.4064507796546, -273.4064625008544, -273.4064508013659, -273.4064547490025, -273.406458510395, -273.4064547707137, -273.4064585321062, -273.4064567294696, -273.4064565521618, -273.4064567283804, -273.4064565510725, -273.4064570172833, -273.4064562643492, -273.406457016194, -273.4064562632599, -273.4064566428303, -273.4064566388008, -273.4064566417411, 
  -273.4064566377116, -273.4064597359715, -273.406453545668, -273.4064597348822, -273.4064535445788, -273.4064552598145, -273.4064580218184, -273.4064552587252}
 {-10.22872208406718, -10.22872228396449, -10.22872223235976, -10.22872193577693, -10.22872188417266, -10.22872225894519, -10.22872225737906, -10.22872191075784, -10.22872190919174, -10.22872288349982, -10.2287216328299, -10.22872253529966, -10.2287212846554, -10.22872524165097, -10.22871927469383, -10.22872489346199, -10.22871892650814, -10.22872227043314, -10.22872224589113, -10.22872192224573, -10.22872189770386, -10.2287221344656, -10.22872238185893, -10.22872178628071, -10.22872203366916, -10.2287221902123, -10.22872232611197, -10.22872184202507, -10.22872197792453, -10.2287222461516, -10.22872227017251, -10.22872189796436, -10.22872192198509, -10.22872236150892, -10.22872215481545, -10.22872201331899, -10.22872180663072, -10.22871876829151, -10.22872574817353, -10.22871842011602, 
  -10.22872539997435, -10.22872224879289, -10.22872226753135, -10.22872190060563, -10.22872191934395, -10.22872227703977, -10.2287222392846, -10.22872192885213, -10.22872189109757, -10.22872776856139, -10.22871674773605, -10.228727420378, -10.22871639954477, -10.22872226400441, -10.22872225231993, -10.22872191581708, -10.22872190413259, -10.22872211065249, -10.22872210908637, -10.22872205904799, -10.22872205748187, -10.22872273520158, -10.22872148454274, -10.22872268359534, -10.22872143294, -10.22872509335768, -10.22871912640172, -10.22872504175271, -10.22871907479769, -10.22872212214041, -10.22872209759846, -10.2287220705359, -10.22872204599397, -10.22872198617402, -10.22872223356512, -10.22872193456974, -10.22872218196041, -10.22872204191965, -10.22872217781922, -10.22872199031517, 
  -10.22872212621472, -10.22872209785894, -10.22872212187977, -10.22872204625446, -10.22872207027527, -10.22872221321495, -10.22872200652403, -10.22872216161041, -10.22872195491958, -10.22871862000468, -10.22872559987496, -10.22871856840029, -10.22872554827036, -10.22872210050023, -10.22872211923863, -10.22872204889574, -10.22872206763412, -10.22872212874692, -10.22872209099205, -10.22872207714242, -10.22872203938756, -10.2287276202706, -10.22871659944143, -10.22872756866622, -10.22871654783682, -10.22872211571171, -10.22872210402723, -10.22872206410722, -10.22872205242274, -10.22872271018154, -10.2287214595244, -10.22872270861537, -10.22872145795834, -10.22872506833826, -10.22871910138276, -10.22872506677213, -10.22871909981665, -10.22872209712121, -10.22872207257927, -10.2287220955551, 
  -10.22872207101316, -10.22872196115499, -10.22872220854577, -10.22872195958876, -10.22872220697976, -10.22872201690048, -10.22872215280001, -10.22872201533433}
 {-231.5899798671432, -231.5899796225017, -231.5899805197199, -231.5899792145829, -231.5899801118142, -231.5899800886076, -231.5899800536134, -231.5899796806955, -231.589979645701, -231.5899786504775, -231.5899814917472, -231.5899782425663, -231.589981083834, -231.589979946559, -231.589980195682, -231.589979538646, -231.5899797877705, -231.5899800956359, -231.5899800465851, -231.5899796877236, -231.5899796386728, -231.5899796891693, -231.5899804531794, -231.5899792812568, -231.5899800452674, -231.5899804221432, -231.5899797201044, -231.5899800142309, -231.5899793121921, -231.5899856825435, -231.5899744597103, -231.5899852746312, -231.5899740517981, -231.5899971266025, -231.5899630165611, -231.5899967191847, -231.5899626081544, -231.5899869470558, -231.589973195278, -231.5899865391287, 
  -231.5899727873805, -231.5899821968304, -231.5899779466247, -231.5899817889243, -231.5899775387062, -231.5899897978392, -231.5899703443517, -231.58998938986, -231.5899699365063, -231.5899882364713, -231.5899719057484, -231.5899878285585, -231.5899714978367, -231.589989507769, -231.5899706349705, -231.5899890998568, -231.5899702270583, -231.5899794360283, -231.589979401034, -231.589980333253, -231.5899802982587, -231.5899779978988, -231.5899808391673, -231.5899788951234, -231.5899817363921, -231.5899792939791, -231.5899795431032, -231.5899801912042, -231.5899804403275, -231.5899794430566, -231.5899793940058, -231.5899803402813, -231.5899802912305, -231.5899790365898, -231.5899798006002, -231.5899799338146, -231.5899806978249, -231.5899797695638, -231.589979067525, -231.5899806667885, 
  -231.5899799647497, -231.5899850299641, -231.589973807131, -231.5899859271888, -231.5899747043558, -231.5899964742473, -231.5899623637576, -231.5899973715182, -231.5899632609362, -231.5899862944636, -231.5899725427115, -231.5899871916992, -231.5899734399253, -231.5899815442535, -231.5899772940429, -231.5899824414795, -231.5899781912663, -231.589989145232, -231.5899696918003, -231.5899900424456, -231.589970589036, -231.5899875838919, -231.5899712531691, -231.5899884811162, -231.5899721503943, -231.5899888551897, -231.5899699823912, -231.5899897524144, -231.589970879616, -231.5899784640079, -231.5899813052765, -231.5899784290136, -231.5899812702822, -231.5899797600885, -231.5899800092122, -231.5899797250942, -231.5899799742179, -231.5899799091657, -231.5899798601149, -231.5899798741714, 
  -231.5899798251206, -231.5899795026994, -231.5899802667091, -231.5899794677044, -231.5899802317154, -231.5899802356729, -231.5899795336343, -231.5899802006788}
 {-334.4192410592679, -334.4192441457642, -334.4192439305071, -334.419238188046, -334.4192379727908, -334.4192440431759, -334.4192440330948, -334.4192380854587, -334.4192380753776, -334.4192441251675, -334.4192439511038, -334.4192381674488, -334.419237993388, -334.419244901481, -334.4192431748037, -334.4192389437631, -334.4192372170871, -334.4192440101578, -334.4192440661129, -334.4192380524406, -334.4192381083957, -334.4192439357414, -334.4192441405496, -334.4192379780252, -334.4192381828313, -334.4192426870175, -334.4192453892675, -334.4192367293004, -334.4192394315503, -334.4192459985352, -334.419242077754, -334.419240040818, -334.4192361200368, -334.4192389648872, -334.4192491127056, -334.4192330071686, -334.4192431549899, -334.4192525182764, -334.4192355581391, -334.4192465605586, 
  -334.4192296004224, -334.4192600187553, -334.4192280584575, -334.4192540610383, -334.4192221007402, -334.4192500028057, -334.41923807343, -334.4192440450892, -334.4192321157121, -334.419246696173, -334.4192413801244, -334.4192407384553, -334.4192354224077, -334.4192553934361, -334.4192326827856, -334.4192494357189, -334.4192267250683, -334.4192411719368, -334.4192411618558, -334.4192409566806, -334.4192409465997, -334.4192412539281, -334.419241079865, -334.4192410386711, -334.4192408646099, -334.4192420302421, -334.4192403035643, -334.4192418149849, -334.4192400883094, -334.4192411389187, -334.4192411948738, -334.4192409236626, -334.4192409796177, -334.4192410645026, -334.4192412693102, -334.419240849247, -334.4192410540536, -334.4192398157786, -334.4192425180284, -334.4192396005224, 
  -334.4192423027723, -334.419243127296, -334.4192392065149, -334.41924291204, -334.4192389912588, -334.4192360936292, -334.4192462414856, -334.4192358784097, -334.4192460261928, -334.419249647038, -334.4192326868993, -334.4192494317798, -334.4192324716452, -334.4192571475163, -334.4192251872185, -334.4192569322603, -334.4192249719621, -334.4192471315658, -334.4192352021917, -334.419246916312, -334.4192349869334, -334.4192438249344, -334.4192385088848, -334.4192436096768, -334.4192382936303, -334.419252522197, -334.4192298115466, -334.4192523069409, -334.4192295962904, -334.4192411513399, -334.4192409772776, -334.4192411412588, -334.4192409671966, -334.4192419276537, -334.4192402009771, -334.4192419175727, -334.419240190896, -334.4192410363309, -334.4192410922859, -334.4192410262499, 
  -334.419241082205, -334.4192409619156, -334.4192411667215, -334.4192409518335, -334.4192411566417, -334.4192397131907, -334.4192424154405, -334.4192397031096}
 {-426.4190286243482, -426.4190419353185, -426.4190423115464, -426.4190149372128, -426.4190153134526, -426.4190421277273, -426.4190421191356, -426.4190151296273, -426.4190151210359, -426.4190406139508, -426.4190436329155, -426.419013615859, -426.4190166348076, -426.4190464206215, -426.4190378263354, -426.4190194225178, -426.4190108282392, -426.4190420425534, -426.4190422043096, -426.4190150444534, -426.4190152062097, -426.4190385002951, -426.4190457467009, -426.4190115022175, -426.4190187485787, -426.4190374637026, -426.4190467832353, -426.4190104656022, -426.4190197851359, -426.4190503869521, -426.4190338599811, -426.4190233888523, -426.4190068618812, -426.4190214431638, -426.4190628095291, -426.4189944443062, -426.4190358121872, -426.4190074670668, -426.4190767805335, 
  -426.4189804689785, -426.4190497824221, -426.4189903257352, -426.4190939247227, -426.4189633276255, -426.4190669266325, -426.4190763324588, -426.4190079142224, -426.4190493343277, -426.4189809161538, -426.4190632900202, -426.4190209569763, -426.4190362919145, -426.4189939588825, -426.4190927381387, -426.4189915082897, -426.4190657400361, -426.4189645101926, -426.4190284405283, -426.4190284319365, -426.4190288167619, -426.4190288081705, -426.419026926756, -426.4190299457119, -426.419027302989, -426.4190303219467, -426.4190327334207, -426.4190241391377, -426.4190331096541, -426.4190245153722, -426.4190283553542, -426.4190285171104, -426.4190287315881, -426.4190288933444, -426.4190248131037, -426.419032059494, -426.4190251893444, -426.419032435721, -426.4190237765031, -426.4190330960366, 
  -426.4190241527372, -426.4190334722702, -426.4190366997529, -426.419020172782, -426.4190370759868, -426.4190205490157, -426.4190077556658, -426.4190491226289, -426.4190081317394, -426.419049499023, -426.41899377988, -426.4190630933221, -426.4189941561009, -426.4190634695689, -426.4189766385333, -426.4190802375263, -426.4189770147629, -426.4190806137645, -426.4190626452465, -426.4189942270365, -426.4190630214754, -426.4189946032751, -426.4190496028211, -426.4190072697772, -426.4190499790489, -426.4190076460172, -426.4190790509387, -426.4189778210913, -426.4190794271714, -426.4189781973263, -426.4190271191673, -426.419030138124, -426.4190271105758, -426.4190301295324, -426.4190329258321, -426.4190243315497, -426.4190329172404, -426.4190243229582, -426.4190285477659, -426.4190287095221, 
  -426.4190285391742, -426.4190287009304, -426.419025005521, -426.4190322519001, -426.419024996925, -426.4190322433129, -426.4190239689146, -426.4190332884481, -426.4190239603233}
 {-232.2374484870442, -232.2374491957112, -232.237448606702, -232.2374483674049, -232.2374477783945, -232.2374489304209, -232.2374488719924, -232.2374481021141, -232.2374480436852, -232.2374496547345, -232.2374481476813, -232.2374488264218, -232.2374473193801, -232.2374512463266, -232.2374465561054, -232.2374504180192, -232.237445727799, -232.2374488896912, -232.237448912722, -232.2374480613843, -232.2374480844151, -232.2374523910967, -232.237445411379, -232.2374515627754, -232.2374445830865, -232.237448220622, -232.2374495817988, -232.2374473923154, -232.2374487534917, -232.2374509923161, -232.2374468101152, -232.2374501640089, -232.2374459818086, -232.2374869141146, -232.2374108897244, -232.2374860862276, -232.2374100609975, -232.237442072698, -232.2374557298675, -232.2374412443879, 
  -232.2374549015639, -232.2374330796582, -232.2374647236976, -232.237432251357, -232.2374638953851, -232.2374492613835, -232.2374485410955, -232.2374484330118, -232.2374477128533, -232.2374533583944, -232.2374444440126, -232.2374525300886, -232.2374436157046, -232.2374601783863, -232.2374376239816, -232.2374593500812, -232.2374367956728, -232.2374488107635, -232.2374487523347, -232.2374482217537, -232.237448163325, -232.2374495350748, -232.2374480280259, -232.2374489460636, -232.2374474390176, -232.2374511266701, -232.237446436447, -232.2374505376579, -232.2374458474396, -232.2374487700337, -232.2374487930645, -232.2374481810239, -232.2374482040547, -232.2374522714326, -232.2374452917281, -232.2374516824216, -232.2374447027196, -232.2374481009652, -232.2374494621406, -232.2374475119543, 
  -232.2374488731321, -232.2374508726586, -232.2374466904578, -232.2374502836487, -232.2374461014481, -232.2374867946734, -232.2374107698505, -232.2374862056509, -232.2374101808536, -232.2374419530324, -232.2374556102182, -232.2374413640356, -232.2374550211954, -232.2374329600023, -232.2374646040386, -232.237432370995, -232.2374640150263, -232.237449141691, -232.237448421473, -232.2374485526864, -232.2374478324579, -232.2374532387377, -232.2374443243543, -232.2374526497274, -232.2374437353451, -232.2374600587291, -232.2374375043238, -232.2374594697206, -232.2374369153128, -232.2374492697835, -232.2374477627361, -232.2374492113548, -232.2374477043074, -232.2374508613783, -232.2374461711576, -232.2374508029496, -232.237446112729, -232.2374485047431, -232.2374485277739, -232.2374484463144, 
  -232.2374484693453, -232.2374520061418, -232.2374450264378, -232.2374519477123, -232.2374449680098, -232.2374478356742, -232.2374491968505, -232.2374477772453}
 {-166.2468885187678, -166.2468828529807, -166.2468835947216, -166.2468934428264, -166.246894184571, -166.2468831638668, -166.2468832838356, -166.246893753714, -166.2468938736835, -166.2468831132703, -166.2468833344398, -166.2468937031175, -166.2468939242877, -166.2468857978341, -166.2468806498846, -166.2468963876798, -166.246891239734, -166.2468832257971, -166.2468832219053, -166.2468938156447, -166.2468938117528, -166.2468771886573, -166.2468892592257, -166.2468877785314, -166.2468998490467, -166.2468827472397, -166.2468837004698, -166.246893337087, -166.2468942903177, -166.2468851267423, -166.2468813209779, -166.2468957165904, -166.246891910825, -166.2469280776234, -166.2468383712723, -166.2469386682901, -166.2468489603007, -166.2468808684728, -166.246885579363, -166.2468914583138, 
  -166.2468961692171, -166.246899061032, -166.2468673876071, -166.2469096508904, -166.2468779774438, -166.2468787284801, -166.2468877193756, -166.246889318133, -166.2468983094178, -166.2468892085631, -166.2468772391026, -166.246899798409, -166.2468878289517, -166.2468947301442, -166.2468717175021, -166.246905319988, -166.2468823073534, -166.2468880879118, -166.2468882078809, -166.2468888296545, -166.2468889496237, -166.2468880373148, -166.2468882584856, -166.2468887790585, -166.2468890002274, -166.2468907218769, -166.2468855739321, -166.2468914636225, -166.2468863156721, -166.2468881498422, -166.2468881459504, -166.2468888915851, -166.2468888876932, -166.2468821127157, -166.2468941832576, -166.2468828544585, -166.2468949250004, -166.246887671284, -166.2468886245158, -166.2468884130282, 
  -166.2468893662572, -166.2468900507877, -166.2468862450228, -166.2468907925305, -166.2468869867656, -166.246933002064, -166.2468432949219, -166.2469337438349, -166.2468440366366, -166.2468857925036, -166.2468905034225, -166.2468865342685, -166.2468912451431, -166.2469039850809, -166.2468723116485, -166.246904726827, -166.2468730533879, -166.2468836524335, -166.2468926435125, -166.2468843941651, -166.2468933852665, -166.2468941326068, -166.2468821631491, -166.2468948743508, -166.2468829048906, -166.2468996541882, -166.2468766415483, -166.2469003959294, -166.2468773832927, -166.2468883482021, -166.246888569372, -166.2468884681713, -166.2468886893411, -166.2468910327652, -166.2468858848176, -166.2468911527343, -166.2468860047866, -166.2468884607291, -166.2468884568373, -166.2468885806982, 
  -166.2468885768064, -166.2468824236016, -166.2468944941454, -166.2468825435726, -166.2468946141126, -166.2468879821713, -166.2468889354023, -166.246888102141}
 {-14.9136241424593, -14.91363829171819, -14.91363807030005, -14.91361021474602, -14.91360999333231, -14.91363808598094, -14.91363827603732, -14.91361000901283, -14.91361019906553, -14.91364300065153, -14.91363336138582, -14.91361492367273, -14.91360528442472, -14.91364049373248, -14.9136358682919, -14.91361241676237, -14.91360779132211, -14.91363807546272, -14.91363828655554, -14.91360999849283, -14.91361020958553, -14.91364616327341, -14.91363019928869, -14.91361808629583, -14.91360212232636, -14.91363822248507, -14.91363813953571, -14.91361014551602, -14.91361006256486, -14.91363956380424, -14.91363679823021, -14.91361148683366, -14.91360872126089, -14.9136139116742, -14.91366245088339, -14.9135858348762, -14.91363437374151, -14.91363201284132, -14.9136443492418, -14.91360393584408, 
  -14.91361627229914, -14.91362754138338, -14.91364882131884, -14.91359946442528, -14.91362074433704, -14.91363611780491, -14.91364024432183, -14.91360804112646, -14.91361216706036, -14.91363753796886, -14.91363882413427, -14.91360946100183, -14.91361074716139, -14.91365156027033, -14.91362480160544, -14.91362348330144, -14.91359672463442, -14.91362415813998, -14.91362434819453, -14.91362393672406, -14.91362412677859, -14.91362907280637, -14.91361943354722, -14.91362885138815, -14.91361921213359, -14.91362656589053, -14.91362194045009, -14.91362634447458, -14.91362171903419, -14.91362414762085, -14.91362435871365, -14.91362392620497, -14.91362413729768, -14.91363223542775, -14.91361627145059, -14.91363201401175, -14.91361605003473, -14.91362429464345, -14.91362421169357, 
  -14.9136240732279, -14.91362399027726, -14.91362563596208, -14.91362287038861, -14.91362541454608, -14.91362264897276, -14.91359998391696, -14.91364852295688, -14.9135997625037, -14.91364830153829, -14.91361808499519, -14.91363042140417, -14.91361786356047, -14.91363020000704, -14.91361361354762, -14.91363489347084, -14.9136133921313, -14.9136346720553, -14.91362219010777, -14.91362631633521, -14.91362196869388, -14.91362609491725, -14.91362361012827, -14.9136248962911, -14.91362338871269, -14.91362467487482, -14.91363763242909, -14.91361087376291, -14.91363741101293, -14.91361065234721, -14.91362886706996, -14.91361922781318, -14.91362905712458, -14.91361941786765, -14.9136263601553, -14.91362173471488, -14.91362655020984, -14.91362192476942, -14.91362394188565, -14.91362415297841, 
  -14.9136241319402, -14.91362434303294, -14.91363202969402, -14.91361606571387, -14.9136322197455, -14.91361625577147, -14.91362408890855, -14.91362400595803, -14.91362427896283}
 {-10.46556989585281, -10.46556949293036, -10.46556951921501, -10.4655702724846, -10.46557029876867, -10.46556950490116, -10.46556950724421, -10.46557028445514, -10.46557028679812, -10.46556878192417, -10.46557023022256, -10.46556956149569, -10.46557100975894, -10.46557028860102, -10.46556872355778, -10.46557106815555, -10.46556950311114, -10.4655694758895, -10.46556953625588, -10.46557025544349, -10.46557031580978, -10.46556845036536, -10.46557056185524, -10.46556922995462, -10.46557134137387, -10.46556817323696, -10.46557083892355, -10.46556895279056, -10.46557161847785, -10.46557146445469, -10.46556754770915, -10.4655722440088, -10.46556832726292, -10.4655692913712, -10.46556972077424, -10.4655700709307, -10.46557050032262, -10.46557766312815, -10.46556134916277, -10.46557844269286, 
  -10.46556212870595, -10.46558505697995, -10.46555395610739, -10.46558583654809, -10.46555473564714, -10.46556951277033, -10.46556949937509, -10.46557029232411, -10.4655702789292, -10.4655723356731, -10.46556667649452, -10.46557311521957, -10.46556745605594, -10.46558106504552, -10.46555794704093, -10.4655818445929, -10.46555872660145, -10.46556988153913, -10.46556988388214, -10.46556990782349, -10.4655699101665, -10.46556915857058, -10.46557060685204, -10.46556918485558, -10.46557063313576, -10.46557066523928, -10.46556910019541, -10.4655706915236, -10.46556912647981, -10.46556985252747, -10.46556991289381, -10.46556987881183, -10.46556993917816, -10.4655688270191, -10.46557093847739, -10.46556885330718, -10.46557096475803, -10.4655685498748, -10.4655712155616, -10.46556857615902, 
  -10.4655712418461, -10.46557184109275, -10.46556792434699, -10.46557186737706, -10.46556795063139, -10.46556966801188, -10.46557009740945, -10.46556969429633, -10.46557012369372, -10.46557803977065, -10.46556172579616, -10.46557806605667, -10.46556175207886, -10.46558543362423, -10.465554332739, -10.46558545991012, -10.46555435902183, -10.46556988940819, -10.46556987601312, -10.46556991569255, -10.46556990229748, -10.46557271230763, -10.46556705313589, -10.46557273859136, -10.46556707942088, -10.4655814416805, -10.46555832368184, -10.46558146796422, -10.46555834996685, -10.46556917054153, -10.46557061882245, -10.46556917288464, -10.46557062116535, -10.46557067720994, -10.4655691121661, -10.46557067955294, -10.46556911450911, -10.46556986449815, -10.46556992486448, -10.46556986684115, 
  -10.46556992720749, -10.4655688389916, -10.46557095044624, -10.46556884133468, -10.46557095278918, -10.4655685618454, -10.46557122753236, -10.46556856418843}
 {-221.1636483425097, -221.1636469955595, -221.1636473310507, -221.1636493539827, -221.1636496894781, -221.1636472314175, -221.1636470951926, -221.1636495898436, -221.1636494536171, -221.1636451026201, -221.1636492239927, -221.1636474610458, -221.1636515824176, -221.1636478798843, -221.1636464467307, -221.1636502383096, -221.1636488051561, -221.1636473181823, -221.1636470084277, -221.1636496766077, -221.163649366853, -221.1636572098334, -221.1636371168819, -221.1636595682563, -221.1636394753095, -221.1636471359884, -221.1636471906265, -221.1636494944138, -221.1636495490517, -221.1636448963283, -221.1636494303116, -221.1636472547536, -221.163651788737, -221.1636598758997, -221.1636344511468, -221.1636622346523, -221.1636368092448, -221.1636566167082, -221.1636377099546, -221.1636589751238, 
  -221.1636400683896, -221.163623313874, -221.1636710133717, -221.1636256723032, -221.163673371793, -221.1636566615705, -221.1636376650137, -221.1636590199332, -221.1636400235015, -221.1636453756361, -221.1636489511532, -221.1636477340612, -221.1636513095786, -221.1636353012661, -221.1636590268531, -221.1636376596916, -221.1636613852782, -221.163648242876, -221.1636481066503, -221.1636485783693, -221.1636484421436, -221.1636461140785, -221.1636502354505, -221.1636464495716, -221.1636505709439, -221.1636488913424, -221.1636474581889, -221.1636492268357, -221.1636477936821, -221.1636483296405, -221.1636480198859, -221.1636486651337, -221.1636483553792, -221.16365822129, -221.1636381283416, -221.163658556784, -221.163638463834, -221.1636481474466, -221.1636482020845, -221.1636484829397, 
  -221.163648537578, -221.1636459077864, -221.1636504417698, -221.1636462432797, -221.163650777263, -221.1636608875163, -221.1636354624466, -221.16366122302, -221.1636357979293, -221.1636576281568, -221.1636387214223, -221.1636579636594, -221.1636390569062, -221.1636243253339, -221.163672024828, -221.1636246608275, -221.163672360321, -221.1636576729994, -221.1636386765011, -221.1636580084886, -221.1636390119984, -221.1636463870942, -221.1636499626114, -221.1636467225873, -221.1636502981047, -221.1636363127243, -221.1636600383112, -221.1636366482176, -221.1636603738044, -221.1636463499379, -221.1636504713101, -221.1636462137122, -221.1636503350843, -221.1636491272018, -221.1636476940483, -221.1636489909761, -221.1636475578226, -221.1636485654999, -221.1636482557453, -221.1636484292742, 
  -221.1636481195196, -221.1636584571498, -221.1636383642006, -221.163658320924, -221.163638227975, -221.163648383306, -221.163648437944, -221.1636482470802}
 {-265.268940668874, -265.2689424284496, -265.2689416607369, -265.2689396770249, -265.2689389093104, -265.268942017219, -265.268942071967, -265.2689392657932, -265.2689393205415, -265.268942412433, -265.268941676755, -265.268939661005, -265.2689389253319, -265.2689441406868, -265.2689399485185, -265.2689413892626, -265.2689371970915, -265.2689420644918, -265.2689420246941, -265.2689393130662, -265.2689392732685, -265.2689390245313, -265.2689450646949, -265.2689362731215, -265.2689423132534, -265.2689437942616, -265.2689402949342, -265.268941042836, -265.2689375435086, -265.2689437290197, -265.2689403601789, -265.2689409775944, -265.268937608753, -265.2689595153138, -265.2689245749476, -265.2689567642185, -265.2689218231916, -265.2689371079983, -265.2689469813097, -265.2689343565693, 
  -265.2689442298875, -265.2689611289134, -265.2689229611962, -265.2689583774924, -265.268920209766, -265.26894630559, -265.2689377835919, -265.268943554132, -265.2689350321986, -265.2689475654893, -265.2689365236703, -265.2689448140639, -265.2689337722443, -265.2689514258562, -265.268932663372, -265.2689486744287, -265.2689299119483, -265.268941025357, -265.2689410801052, -265.2689402576434, -265.2689403123916, -265.26894142057, -265.2689406848943, -265.2689406528563, -265.2689399171808, -265.2689431488273, -265.2689389566544, -265.2689423811105, -265.268938188944, -265.26894107263, -265.2689410328323, -265.2689403049164, -265.2689402651187, -265.268938032679, -265.2689440728234, -265.2689372649621, -265.2689433051132, -265.2689428023992, -265.2689393030729, -265.2689420346868, 
  -265.2689385353582, -265.2689427371581, -265.2689393683169, -265.2689419694444, -265.2689386006034, -265.2689585236359, -265.2689235829018, -265.2689577558847, -265.2689228152257, -265.2689361161293, -265.2689459894551, -265.2689353484267, -265.2689452217305, -265.2689601370539, -265.268921969332, -265.2689593693403, -265.2689212016185, -265.2689453137076, -265.2689367917504, -265.2689445460026, -265.2689360240283, -265.2689465736278, -265.268935531808, -265.2689458059137, -265.2689347640949, -265.2689504339936, -265.2689316715109, -265.2689496662797, -265.2689309037977, -265.2689410093389, -265.2689402736632, -265.268941064087, -265.2689403284114, -265.2689427375946, -265.2689385454249, -265.2689427923427, -265.268938600173, -265.2689406613988, -265.2689406216012, -265.268940716147, 
  -265.2689406763493, -265.2689376214463, -265.2689436615939, -265.2689376761943, -265.2689437163422, -265.2689423911689, -265.268938891841, -265.2689424459165}
 {-213.4687616168353, -213.468759614708, -213.4687593620451, -213.4687638716521, -213.4687636189865, -213.4687595226531, -213.4687594540999, -213.4687637795962, -213.4687637110423, -213.468759899644, -213.4687590771136, -213.4687641565859, -213.4687633340572, -213.4687616714003, -213.4687573053564, -213.4687659283431, -213.468761562299, -213.4687594605062, -213.4687595162469, -213.468763717449, -213.4687637731896, -213.468769455059, -213.4687495218132, -213.4687737119969, -213.4687537787608, -213.468758777518, -213.4687601992372, -213.468763034461, -213.4687644561797, -213.4687645172067, -213.4687544595559, -213.4687687741494, -213.4687587164988, -213.4687830750214, -213.4687359023911, -213.4687873324773, -213.4687401588208, -213.4687578193609, -213.4687611574706, -213.4687620762892, 
  -213.4687654144278, -213.4687364003132, -213.4687825770854, -213.4687406572628, -213.4687868340213, -213.4687671445378, -213.4687518322227, -213.4687714013771, -213.468756089269, -213.4687661421403, -213.4687528346389, -213.4687703990834, -213.4687570915813, -213.468767565123, -213.4687514115384, -213.4687718220672, -213.4687556684797, -213.4687617774442, -213.4687617088907, -213.46876152478, -213.4687614562264, -213.4687621544345, -213.4687613319048, -213.4687619017702, -213.4687610792407, -213.4687639261913, -213.4687595601471, -213.4687636735269, -213.468759307483, -213.4687617152971, -213.4687617710378, -213.4687614626329, -213.4687615183736, -213.4687717098475, -213.4687517766065, -213.4687714571831, -213.4687515239424, -213.4687610323091, -213.4687624540279, -213.4687607796447, 
  -213.4687622013639, -213.4687667719975, -213.4687567143469, -213.4687665193334, -213.4687564616826, -213.4687853300721, -213.4687381569223, -213.4687850774014, -213.4687379042645, -213.4687600741366, -213.4687634122768, -213.4687598214884, -213.4687631595964, -213.4687386551075, -213.468784831873, -213.4687384024434, -213.4687845792086, -213.4687693992756, -213.4687540870668, -213.4687691466142, -213.4687538343997, -213.4687683969315, -213.4687550894296, -213.4687681442671, -213.4687548367655, -213.4687698199146, -213.4687536663287, -213.4687695672505, -213.4687534136643, -213.4687620623791, -213.4687612398495, -213.4687619938255, -213.468761171296, -213.4687638341359, -213.4687594680918, -213.4687637655823, -213.4687593995383, -213.4687616232417, -213.4687616789824, -213.4687615546881, 
  -213.4687616104288, -213.4687716177923, -213.468751684551, -213.4687715492383, -213.4687516159979, -213.4687609402537, -213.4687623619727, -213.4687608717001}
 {-315.6428704026647, -315.6428810996217, -315.6428817875196, -315.6428590178717, -315.6428597057939, -315.6428814223607, -315.6428814647767, -315.6428593406223, -315.6428593830394, -315.6428793422717, -315.6428835448719, -315.642857260537, -315.6428614631309, -315.6428791198209, -315.6428837674243, -315.6428570380795, -315.6428616856902, -315.6428814745859, -315.6428814125515, -315.6428593928481, -315.6428593308137, -315.6428835757961, -315.6428793114311, -315.6428614940533, -315.642857229698, -315.642888801046, -315.6428740861876, -315.6428667193081, -315.6428520044499, -315.6428841686536, -315.6428787185662, -315.6428620869155, -315.6428566368285, -315.6429349632901, -315.6428279296119, -315.6429128826725, -315.642805846754, -315.6429091089161, -315.6428537788656, -315.6428870271595, 
  -315.6428316971466, -315.6428502482332, -315.642912643283, -315.6428281665098, -315.6428905615308, -315.6429186886535, -315.6428441983204, -315.6428966068376, -315.6428221166609, -315.6429032798631, -315.642859607394, -315.6428811981204, -315.642837525661, -315.6428916772671, -315.6428712117734, -315.6428695955301, -315.6428491300348, -315.6428700375034, -315.6428700799197, -315.6428707254133, -315.6428707678301, -315.6428679574173, -315.642872160012, -315.6428686453252, -315.6428728479245, -315.6428677349615, -315.6428723825696, -315.6428684228727, -315.6428730704787, -315.6428700897288, -315.6428700276944, -315.6428707776389, -315.6428707156045, -315.6428721909365, -315.6428679265762, -315.6428728788465, -315.6428686144865, -315.6428774161887, -315.6428627013307, -315.6428781040991, 
  -315.6428633892406, -315.6428727837965, -315.6428673337091, -315.6428734717065, -315.6428680216194, -315.6429235789039, -315.6428165442839, -315.6429242669925, -315.6428172320157, -315.6428977240396, -315.6428423940278, -315.6428984119697, -315.6428430819181, -315.6428388633802, -315.6429012584216, -315.6428395512965, -315.6429019463258, -315.6429073037624, -315.6428328134973, -315.6429079916623, -315.6428335014177, -315.6428918950058, -315.6428482225371, -315.6428925829114, -315.6428489104517, -315.6428802924105, -315.6428598269158, -315.6428809803206, -315.642860514826, -315.642868280161, -315.642872482758, -315.6428683225776, -315.6428725251745, -315.6428680577068, -315.642872705314, -315.6428681001233, -315.6428727477304, -315.6428704124736, -315.6428703504392, -315.6428704548901, 
  -315.6428703928558, -315.6428725136833, -315.6428682493191, -315.6428725560958, -315.6428682917398, -315.6428777389336, -315.6428630240756, -315.6428777813503}
 {-291.9634296336159, -291.9634322031283, -291.9634323195619, -291.9634269476875, -291.963427064125, -291.9634322543643, -291.9634322683255, -291.9634269989252, -291.9634270128868, -291.963432025183, -291.9634324975076, -291.9634267697445, -291.9634272420684, -291.9634333596056, -291.9634311631018, -291.9634281041659, -291.9634259076638, -291.963432238468, -291.9634322842217, -291.9634269830291, -291.9634270287829, -291.9634308504028, -291.9634336723167, -291.9634255949698, -291.963428416872, -291.963430957162, -291.9634335655418, -291.9634257017232, -291.963428310103, -291.9634342565015, -291.9634302662073, -291.9634290010627, -291.9634250107683, -291.9634418861497, -291.9634226379658, -291.9634366308727, -291.963417382365, -291.963440676279, -291.9634238465631, -291.9634354208386, 
  -291.9634185911258, -291.9634480299963, -291.9634164936361, -291.9634427745597, -291.963411238195, -291.9634377127618, -291.9634268099021, -291.9634324573154, -291.9634215544708, -291.9634348582234, -291.9634296644937, -291.9634296027832, -291.9634244090562, -291.9634437626295, -291.9634207600043, -291.96343850719, -291.963415504566, -291.9634295684177, -291.963429582379, -291.9634296848532, -291.9634296988146, -291.9634293392373, -291.9634298115602, -291.9634294556716, -291.9634299279971, -291.9634306736588, -291.9634284771557, -291.9634307900942, -291.9634285935914, -291.9634295525215, -291.9634295982752, -291.9634296689571, -291.9634297147108, -291.9634281644592, -291.9634309863673, -291.9634282808948, -291.9634311028029, -291.9634282712154, -291.9634308795955, -291.9634283876513, 
  -291.9634309960307, -291.963431570555, -291.9634275802608, -291.9634316869906, -291.9634276966963, -291.9634392002664, -291.963419951956, -291.9634393167373, -291.9634200683563, -291.9634379903302, -291.9634211606188, -291.9634381067688, -291.9634212770514, -291.9634453440505, -291.9634138076889, -291.963445460487, -291.9634139241236, -291.9634350268126, -291.9634241239584, -291.9634351432461, -291.963424240396, -291.9634321722768, -291.9634269785473, -291.9634322887113, -291.963427094984, -291.9634410766828, -291.963418074058, -291.9634411931181, -291.9634181904939, -291.9634293904736, -291.9634298627977, -291.9634294044349, -291.9634298767591, -291.9634307248955, -291.9634285283926, -291.9634307388569, -291.963428542354, -291.9634296037584, -291.9634296495121, -291.9634296177197, 
  -291.9634296634734, -291.9634282156966, -291.9634310376036, -291.963428229657, -291.9634310515661, -291.9634283224524, -291.9634309308322, -291.9634283364137}
 {-15.95781699688266, -15.95781698040291, -15.95781697794832, -15.95781701581702, -15.95781701336243, -15.95781697930151, -15.95781697904972, -15.95781701471563, -15.95781701446383, -15.95781737106876, -15.95781658730397, -15.95781740648055, -15.95781662272041, -15.95781795355539, -15.95781600479674, -15.95781798896937, -15.95781604021098, -15.95781698378223, -15.95781697456901, -15.95781701919632, -15.95781700998313, -15.95781009825052, -15.9578238609129, -15.95781013367247, -15.95782389631917, -15.95781686994655, -15.95781708840575, -15.95781690536049, -15.95781712382004, -15.95781810120716, -15.95781585715158, -15.95781813662068, -15.95781589256629, -15.95781685789448, -15.957817100459, -15.95781689330824, -15.95781713587345, -15.95781625045417, -15.95781770792829, -15.95781628586976, 
  -15.95781774334092, -15.95782172342516, -15.95781223530981, -15.95782175884447, -15.95781227071873, -15.95781698161072, -15.95781697674052, -15.95781701702483, -15.95781701215464, -15.95782299435565, -15.95781096395972, -15.95782302977009, -15.95781099937351, -15.95783153136336, -15.95780242679143, -15.95783156677553, -15.95780246220748, -15.95781699823586, -15.95781699798406, -15.95781699578126, -15.95781699552946, -15.95781739000199, -15.95781660623943, -15.9578173875473, -15.95781660378493, -15.95781797248967, -15.95781602373114, -15.95781797003507, -15.95781602127655, -15.95781700271656, -15.95781699350336, -15.95781700026197, -15.95781699104876, -15.95781011718876, -15.95782387984334, -15.95781011473421, -15.95782387738871, -15.9578168888808, -15.95781710734018, -15.95781688642621, 
  -15.95781710488559, -15.95781812014121, -15.95781587608622, -15.95781811768661, -15.95781587363163, -15.95781687682865, -15.95781711939351, -15.95781687437405, -15.95781711693892, -15.95781626938924, -15.9578177268619, -15.95781626693467, -15.95781772440728, -15.95782174236208, -15.95781225424157, -15.95782173990753, -15.95781225178694, -15.95781700054506, -15.95781699567487, -15.95781699809047, -15.95781699322027, -15.95782301329016, -15.9578109828939, -15.95782301083557, -15.95781098043931, -15.95783155029673, -15.95780244572674, -15.95783154784213, -15.95780244327215, -15.95781738890055, -15.95781660513808, -15.95781738864874, -15.95781660488629, -15.95781797138827, -15.95781602262974, -15.95781797113647, -15.95781602237795, -15.95781700161516, -15.95781699240196, -15.95781700136337, 
  -15.95781699215016, -15.95781011608742, -15.9578238787419, -15.95781011583556, -15.95782387849016, -15.95781688777941, -15.95781710623878, -15.95781688752761}
 {-339.5767851462403, -339.5767874072958, -339.5767875558289, -339.5767827366571, -339.576782885191, -339.5767874672885, -339.576787495836, -339.5767827966501, -339.5767828251977, -339.5767874215925, -339.5767875415326, -339.5767827509542, -339.5767828708942, -339.5767904049602, -339.5767845581737, -339.5767857343218, -339.5767798875355, -339.5767873996758, -339.5767875634488, -339.5767827290374, -339.5767828928104, -339.5767866739361, -339.5767882892061, -339.5767820032989, -339.5767836185667, -339.5767868442044, -339.5767881189291, -339.576782173566, -339.5767834482908, -339.5767899606569, -339.5767850024858, -339.5767852900188, -339.5767803318474, -339.5767831727226, -339.5767917912512, -339.5767785019574, -339.5767871207398, -339.5767783687704, -339.5767965944548, -339.5767736981337, 
  -339.5767919238149, -339.5767703647278, -339.5768045994286, -339.5767656940887, -339.576799928791, -339.5767990717518, -339.576775891309, -339.5767944011085, -339.5767712206756, -339.5767811989831, -339.5767937644029, -339.5767765283446, -339.5767890937647, -339.5768144509756, -339.5767605118549, -339.5768097803372, -339.5767558412166, -339.5767850576999, -339.5767850862474, -339.5767852062334, -339.5767852347809, -339.5767850120041, -339.5767851319437, -339.5767851605372, -339.5767852804776, -339.5767879953715, -339.5767821485852, -339.5767881439051, -339.5767822971186, -339.5767849900872, -339.5767851538602, -339.5767851386207, -339.5767853023936, -339.576784264348, -339.5767858796171, -339.5767844128817, -339.5767860281504, -339.5767844346158, -339.5767857093405, -339.5767845831493, 
  -339.576785857874, -339.5767875510684, -339.5767825928972, -339.576787699602, -339.5767827414306, -339.5767807630786, -339.576789381718, -339.5767809115961, -339.5767895302676, -339.5767759591848, -339.5767941848632, -339.5767761077139, -339.5767943334012, -339.576767955139, -339.5768021898401, -339.576768103672, -339.5768023383742, -339.5767966621617, -339.5767734817218, -339.5767968106932, -339.5767736302573, -339.5767787893946, -339.5767913548141, -339.5767789379279, -339.576791503348, -339.576812041387, -339.5767581022663, -339.5768121899204, -339.5767582507999, -339.5767850719968, -339.5767851919368, -339.5767851005444, -339.5767852204843, -339.5767880553644, -339.576782208578, -339.576788083912, -339.5767822371256, -339.5767850500801, -339.576785213853, -339.5767850786276, 
  -339.5767852424005, -339.5767843243411, -339.5767859396097, -339.5767843528883, -339.5767859681576, -339.5767844946086, -339.5767857693334, -339.5767845231562}
 {-253.9213637003017, -253.921363760169, -253.9213631818456, -253.9213642187685, -253.9213636404402, -253.9213634414204, -253.921363500594, -253.9213639000172, -253.9213639591913, -253.9213646324642, -253.9213623095515, -253.9213650910602, -253.9213627681495, -253.9213622611909, -253.9213646808313, -253.9213627197882, -253.9213651394281, -253.921363533351, -253.9213634086634, -253.9213639919481, -253.9213638672604, -253.921359943675, -253.9213669983908, -253.9213604022749, -253.921367456985, -253.921365232287, -253.9213617097394, -253.921365690884, -253.9213621683365, -253.9213644959985, -253.921362446026, -253.9213649545956, -253.921362904623, -253.9213768717894, -253.921350070651, -253.92137733064, -253.9213505289944, -253.921354944241, -253.9213719978245, -253.921355402832, 
  -253.9213724564275, -253.9213756437324, -253.9213512988532, -253.9213761023321, -253.9213517574477, -253.921367350707, -253.9213595913102, -253.9213678092652, -253.9213600499461, -253.9213631303154, -253.9213638117786, -253.9213635889128, -253.9213642703753, -253.9213747384182, -253.9213522035522, -253.9213751970149, -253.9213526621494, -253.9213639598779, -253.9213640190517, -253.921363381552, -253.9213634407258, -253.9213651509213, -253.9213628280095, -253.9213645725953, -253.9213622496837, -253.9213627796487, -253.9213651992886, -253.9213622013226, -253.921364620963, -253.9213640518086, -253.921363927121, -253.9213634734828, -253.9213633487951, -253.921360462134, -253.9213675168469, -253.9213598838082, -253.9213669385211, -253.9213657507444, -253.9213622281971, -253.9213651724189, 
  -253.9213616498711, -253.9213650144561, -253.9213629644836, -253.9213644361302, -253.9213623861578, -253.9213773903832, -253.9213505889722, -253.9213768120384, -253.9213500106654, -253.9213554626906, -253.92137251629, -253.9213548843746, -253.9213719379543, -253.9213761621914, -253.9213518173094, -253.9213755838654, -253.9213512389837, -253.9213678691417, -253.9213601097906, -253.9213672908228, -253.9213595314579, -253.9213636487731, -253.921364330236, -253.9213630704473, -253.9213637519102, -253.9213752568757, -253.9213527220097, -253.9213746785497, -253.9213521436841, -253.9213648321713, -253.9213625092596, -253.9213648913451, -253.9213625684334, -253.9213624608986, -253.9213648805387, -253.9213625200724, -253.9213649397126, -253.9213637330587, -253.9213636083709, -253.9213637922324, 
  -253.9213636675448, -253.9213601433841, -253.921367198097, -253.9213602025579, -253.9213672572708, -253.9213654319946, -253.9213619094471, -253.9213654911684}
 {-15.45043761243047, -15.45044005800299, -15.45043961782973, -15.45043560704838, -15.45043516687543, -15.45043984125447, -15.45043983457782, -15.45043539029997, -15.45043538362341, -15.45043812881083, -15.45044154704709, -15.45043367786248, -15.45043709608654, -15.4504419407078, -15.45043773515971, -15.4504374897481, -15.4504332842105, -15.45043981088581, -15.45043986494649, -15.45043535993126, -15.45043541399213, -15.45043186383893, -15.45044781255122, -15.45042741294443, -15.45044336153681, -15.45043853827738, -15.45044113757361, -15.4504340873197, -15.45043668662239, -15.45044167431583, -15.45043800153513, -15.4504372233595, -15.45043355058255, -15.45042333938825, -15.45045633787053, -15.45041888828793, -15.45045188706197, -15.4504536143559, -15.45042606172063, -15.45044916341351, 
  -15.45042161075411, -15.45045089437169, -15.45042878231672, -15.45044644344507, -15.45042433133444, -15.45044497534062, -15.45043470047185, -15.45044052437772, -15.45043024952584, -15.4504470232977, -15.45043265255205, -15.4504425723366, -15.45042820160426, -15.45045315074632, -15.45042652494718, -15.45044869978142, -15.45042207400317, -15.45043783585555, -15.45043782917892, -15.45043739568243, -15.45043738900584, -15.45043612341581, -15.45043954164431, -15.45043568324104, -15.45043910147287, -15.4504399353074, -15.4504357297623, -15.45043949513204, -15.45043528959146, -15.45043780548686, -15.45043785954763, -15.45043736531374, -15.45043741937454, -15.45042985846875, -15.45044580712359, -15.45042941829815, -15.45044536694799, -15.45043653287687, -15.45043913217631, -15.45043609270375, 
  -15.45043869200323, -15.45043966891603, -15.45043599613712, -15.45043922874285, -15.4504355559641, -15.45042133390252, -15.45045433255846, -15.4504208937572, -15.45045389235758, -15.45045160896542, -15.4504240563133, -15.45045116878753, -15.45042361614498, -15.45044888898607, -15.45042677690453, -15.45044844881423, -15.45042633673016, -15.45044296993514, -15.45043269507952, -15.45044252976674, -15.45043225490172, -15.45044501789616, -15.45043064715578, -15.45044457772168, -15.45043020698407, -15.45045114534241, -15.45042451955328, -15.45045070516887, -15.45042407938062, -15.45043590666651, -15.45043932489669, -15.45043589998992, -15.45043931822006, -15.45043971855785, -15.45043551301494, -15.45043971188117, -15.4504355063384, -15.4504375887384, -15.45043764279917, -15.45043758206178, 
  -15.45043763612257, -15.45042964172214, -15.45044559037328, -15.45042963504433, -15.45044558369787, -15.45043631612855, -15.45043891542771, -15.45043630945165}
 {-215.6443200651155, -215.6443223970061, -215.6443222795986, -215.6443178506485, -215.6443177332377, -215.6443223417328, -215.6443223348717, -215.6443177953737, -215.6443177885122, -215.6443228853798, -215.6443217912265, -215.644318339018, -215.6443172448697, -215.6443239830884, -215.6443206935266, -215.6443194367299, -215.6443161471665, -215.6443223197649, -215.6443223568396, -215.6443177734057, -215.6443178104802, -215.6443245491833, -215.6443201274581, -215.6443200028156, -215.6443155811071, -215.6443214692325, -215.6443232073808, -215.6443169228735, -215.6443186610212, -215.6443242872376, -215.6443203893827, -215.6443197408781, -215.6443158430235, -215.6443259662554, -215.6443187112163, -215.6443214200648, -215.6443141646884, -215.6443187291231, -215.6443259475821, 
  -215.6443141827575, -215.6443214012291, -215.6443081530208, -215.6443365244564, -215.6443036066656, -215.6443319780931, -215.6443283429524, -215.6443163336164, -215.6443237965889, -215.6443117872614, -215.6443273254228, -215.6443173511655, -215.6443227790643, -215.6443128048054, -215.6443342977703, -215.6443103787576, -215.644329751412, -215.6443058323974, -215.6443201272509, -215.6443201203896, -215.6443200098416, -215.6443200029804, -215.6443206708967, -215.6443195767455, -215.6443205534871, -215.6443194593368, -215.644321768607, -215.644318479044, -215.6443216511974, -215.6443183616351, -215.644320105283, -215.6443201423575, -215.6443199878737, -215.6443200249483, -215.6443223346969, -215.6443179129804, -215.644322217288, -215.6443177955709, -215.6443192547507, -215.6443209928987, 
  -215.6443191373414, -215.6443208754895, -215.6443220727555, -215.6443181749008, -215.6443219553463, -215.6443180574915, -215.6443237518681, -215.6443164966398, -215.6443236344383, -215.644316379251, -215.6443165146369, -215.6443237331043, -215.6443163972298, -215.644323615693, -215.6443059385409, -215.6443343099723, -215.6443058211315, -215.6443341925633, -215.6443261284677, -215.6443141191372, -215.6443260110597, -215.6443140017267, -215.6443251109416, -215.6443151366827, -215.6443249935317, -215.6443150192742, -215.6443320832888, -215.6443081642752, -215.6443319658796, -215.644308046866, -215.6443206156224, -215.6443195214717, -215.6443206087611, -215.6443195146104, -215.6443217133327, -215.6443184237701, -215.6443217064714, -215.6443184169088, -215.6443200500089, -215.6443200870835, 
  -215.6443200431476, -215.6443200802221, -215.6443222794233, -215.6443178577059, -215.6443222725614, -215.6443178508451, -215.6443191994766, -215.6443209376246, -215.6443191926152}
 {-335.2429002968445, -335.2429010817697, -335.2429010323249, -335.2428995613645, -335.2428995119198, -335.2429010484292, -335.2429010656652, -335.2428995280241, -335.2428995452602, -335.2429010691508, -335.2429010449439, -335.2428995487457, -335.2428995245388, -335.2429039759021, -335.2428981381967, -335.242902455497, -335.2428966177915, -335.2429009497595, -335.2429011643351, -335.2428994293545, -335.2428996439299, -335.2429010938807, -335.2429010202136, -335.2428995734756, -335.2428994998083, -335.2429034799429, -335.242898634155, -335.2429019595378, -335.24289711375, -335.2428923919417, -335.2429097222122, -335.2428908715365, -335.2429082018072, -335.2429029970491, -335.2428991172822, -335.2429014766298, -335.2428975968913, -335.24289926011, -335.2429028540403, -335.2428977397049, 
  -335.2429013336352, -335.2428629990375, -335.2429391157377, -335.2428614786324, -335.2429375953326, -335.2429070839731, -335.2428950300852, -335.242905563568, -335.2428935096801, -335.2429090952495, -335.2428930188457, -335.2429075748444, -335.2428914984405, -335.2428996557607, -335.2429024593572, -335.2428981353556, -335.2429009389521, -335.2429003129488, -335.242900330185, -335.2429002635041, -335.2429002807401, -335.2429003336706, -335.2429003094635, -335.2429002842256, -335.2429002600188, -335.2429032404218, -335.2428974027162, -335.2429031909769, -335.2428973532715, -335.2429002142792, -335.2429004288548, -335.2429001648344, -335.2429003794099, -335.2429003584008, -335.2429002847329, -335.2429003089552, -335.2429002352888, -335.2429027444626, -335.2428978986747, -335.2429026950178, 
  -335.2428978492299, -335.2428916564613, -335.2429089867319, -335.2428916070166, -335.2429089372871, -335.2429022615574, -335.2428983818133, -335.2429022121211, -335.2428983323598, -335.2428985246304, -335.2429021185593, -335.2428984751842, -335.2429020691158, -335.242862263557, -335.2429383802575, -335.2428622141125, -335.2429383308125, -335.2429063484926, -335.2428942946052, -335.2429062990482, -335.2428942451598, -335.2429083597692, -335.2428922833653, -335.2429083103244, -335.2428922339205, -335.2428989202803, -335.2429017238769, -335.2428988708355, -335.242901674432, -335.24290030033, -335.242900276123, -335.2429003175661, -335.2429002933591, -335.2429032070812, -335.2428973693757, -335.2429032243173, -335.2428973866118, -335.2429001809387, -335.2429003955142, -335.2429001981748, 
  -335.2429004127502, -335.2429003250597, -335.2429002513929, -335.2429003422962, -335.2429002686286, -335.2429027111222, -335.2428978653342, -335.2429027283582}
 {-349.3001531361955, -349.3001547520162, -349.3001547457651, -349.3001515266287, -349.3001515203778, -349.3001547482676, -349.3001547495136, -349.3001515228802, -349.3001515241262, -349.3001547497724, -349.300154748009, -349.300151524385, -349.3001515226216, -349.3001558803389, -349.3001536174483, -349.3001526549515, -349.3001503920609, -349.300154742255, -349.3001547555262, -349.3001515168676, -349.3001515301388, -349.3001537809017, -349.3001557168545, -349.3001505555144, -349.300152491467, -349.3001508554667, -349.3001586423112, -349.3001476300793, -349.3001554169239, -349.3001547929862, -349.3001547047967, -349.300151567599, -349.3001514794093, -349.3001572101652, -349.3001522881303, -349.3001539847607, -349.30014906276, -349.3001550079845, -349.3001544898573, -349.3001517825976, 
  -349.3001512644695, -349.3001083614713, -349.300201136775, -349.3001051360836, -349.3001979113878, -349.3001607847511, -349.3001487129936, -349.3001575593637, -349.3001454876063, -349.3001602250483, -349.3001492727062, -349.3001569996609, -349.3001460473188, -349.30011551036, -349.3001939887603, -349.3001122849725, -349.3001907633732, -349.3001531386981, -349.3001531399442, -349.3001531324471, -349.3001531336931, -349.300153140203, -349.3001531384395, -349.3001531339518, -349.3001531321887, -349.3001542707694, -349.3001520078788, -349.3001542645184, -349.3001520016278, -349.3001531326855, -349.3001531459568, -349.3001531264345, -349.3001531397057, -349.3001521713319, -349.3001541072854, -349.3001521650817, -349.3001541010337, -349.3001492458972, -349.3001570327418, -349.3001492396461, 
  -349.3001570264909, -349.3001531834167, -349.3001530952272, -349.3001531771658, -349.3001530889762, -349.3001556005946, -349.3001506785619, -349.3001555943287, -349.3001506723259, -349.3001533984151, -349.3001528802878, -349.3001533921645, -349.3001528740364, -349.3001067519019, -349.3001995272054, -349.3001067456504, -349.3001995209549, -349.3001591751816, -349.3001471034242, -349.3001591689307, -349.3001470971732, -349.3001586154789, -349.3001476631366, -349.3001586092277, -349.3001476568859, -349.3001139007907, -349.3001923791907, -349.3001138945393, -349.3001923729402, -349.3001531364543, -349.300153134691, -349.3001531377003, -349.300153135937, -349.3001542670208, -349.3001520041302, -349.3001542682669, -349.3001520053762, -349.3001531289369, -349.3001531422082, -349.300153130183, 
  -349.3001531434542, -349.3001521675843, -349.3001541035357, -349.300152168829, -349.3001541047831, -349.3001492421486, -349.3001570289932, -349.3001492433946}
 {-532.7174082323983, -532.7174061163432, -532.7174038418319, -532.7174126229769, -532.7174103484564, -532.7174049929454, -532.7174049652295, -532.7174114995747, -532.7174114718586, -532.7174076319855, -532.7174023261917, -532.7174141385951, -532.7174088328404, -532.7174023583491, -532.7174075998391, -532.717408864976, -532.7174141064705, -532.7174049754897, -532.7174049826853, -532.7174114821187, -532.7174114893146, -532.71740482227, -532.7174051359053, -532.7174113289019, -532.7174116425315, -532.7174049217137, -532.7174050364613, -532.7174114283427, -532.7174115430906, -532.7174049718177, -532.7174049863572, -532.7174114784469, -532.7174114929862, -532.7173471551024, -532.717462804459, -532.7173536610502, -532.7174693117693, -532.717424283412, -532.7173856749117, -532.7174307900426, 
  -532.7173921815394, -532.7174049717323, -532.7174049864427, -532.7174114783618, -532.7174114930712, -532.7173976945115, -532.717412263866, -532.7174042009818, -532.717418770654, -532.7173982711711, -532.7174116871968, -532.7174047778077, -532.7174181938185, -532.7174049891966, -532.7174049689786, -532.7174114958257, -532.7174114756078, -532.7174093835142, -532.7174093557984, -532.7174071089983, -532.7174070812825, -532.7174120225448, -532.71740671677, -532.7174097480285, -532.7174044422547, -532.7174067489215, -532.7174119904043, -532.7174044743962, -532.7174097158981, -532.7174093660585, -532.7174093732542, -532.7174070915426, -532.7174070987384, -532.7174092128403, -532.7174095264725, -532.7174069383243, -532.717407251957, -532.7174093122824, -532.7174094270305, -532.7174070377668, 
  -532.7174071525143, -532.7174093623865, -532.717409376926, -532.7174070878708, -532.7174071024102, -532.7173515453073, -532.7174671953918, -532.717349270838, -532.7174649208294, -532.7174286739928, -532.7173900654687, -532.7174263994546, -532.7173877909752, -532.7174093623013, -532.7174093770113, -532.7174070877857, -532.7174071024954, -532.7174020849888, -532.7174166545262, -532.7173998104971, -532.7174143799863, -532.717402661743, -532.7174160777628, -532.7174003872288, -532.7174138032453, -532.7174093797653, -532.7174093595475, -532.7174071052495, -532.7174070850316, -532.7174108991445, -532.7174055933702, -532.7174108714287, -532.7174055656544, -532.7174056255169, -532.717410867009, -532.7174055978007, -532.7174108392934, -532.7174082426584, -532.7174082498541, -532.7174082149425, 
  -532.7174082221384, -532.7174080894393, -532.7174084030734, -532.7174080617251, -532.717408375356, -532.717408188883, -532.7174083036295, -532.7174081611658}
 {-360.5073053648461, -360.5073054041283, -360.5073053695042, -360.5073053601879, -360.5073053255642, -360.507305387656, -360.5073053859765, -360.5073053437158, -360.5073053420362, -360.5073055397297, -360.5073052339052, -360.5073054957877, -360.5073051899667, -360.5073076862347, -360.5073030874176, -360.5073076422939, -360.507303043478, -360.5073053777114, -360.5073053959212, -360.5073053337712, -360.5073053519809, -360.5073054125968, -360.5073053610985, -360.5073053686545, -360.5073053171602, -360.5073046821354, -360.5073060915059, -360.5073046381951, -360.5073060475657, -360.5073075227658, -360.5073032508854, -360.5073074788255, -360.5073032069453, -360.5073054160289, -360.5073053576036, -360.5073053720874, -360.5073053136646, -360.5073000999944, -360.5073106737875, -360.5073000560532, 
  -360.5073106298482, -360.5072904500151, -360.5073203245594, -360.5072904060738, -360.5073202806203, -360.5073054038892, -360.5073053697434, -360.5073053599487, -360.5073053258034, -360.5073100401572, -360.5073007334646, -360.507309996217, -360.5073006895243, -360.5073172019023, -360.5072935716596, -360.507317157962, -360.5072935277194, -360.5073053829977, -360.5073053813181, -360.5073053483738, -360.5073053466943, -360.5073055350712, -360.5073052292473, -360.5073055004461, -360.5073051946245, -360.5073076815763, -360.5073030827594, -360.507307646952, -360.507303048136, -360.5073053730531, -360.5073053912629, -360.5073053384293, -360.507305356639, -360.5073054079371, -360.5073053564416, -360.507305373314, -360.5073053218168, -360.5073046774772, -360.5073060868476, -360.5073046428531, 
  -360.5073060522238, -360.5073075181075, -360.5073032462271, -360.5073074834835, -360.5073032116032, -360.5073054113701, -360.5073053529459, -360.5073053767461, -360.507305318322, -360.507300095336, -360.5073106691294, -360.5073000607114, -360.5073106345061, -360.5072904453566, -360.5073203199014, -360.5072904107321, -360.507320285278, -360.5073053992307, -360.5073053650853, -360.5073053646068, -360.5073053304614, -360.507310035499, -360.5073007288063, -360.507310000875, -360.5073006941824, -360.5073171972441, -360.5072935670012, -360.5073171626201, -360.5072935323775, -360.5073055185984, -360.5073052127756, -360.5073055169188, -360.5073052110961, -360.507307665104, -360.5073030662874, -360.5073076634243, -360.5073030646079, -360.507305356581, -360.5073053747907, -360.5073053549013, 
  -360.5073053731111, -360.5073053914655, -360.5073053399688, -360.5073053897855, -360.5073053382897, -360.5073046610049, -360.5073060703755, -360.5073046593254}
 {-199.936708961008, -199.9367067079759, -199.9367080039157, -199.93670991811, -199.9367112140589, -199.9367073467585, -199.9367073651327, -199.9367105568971, -199.9367105752714, -199.9367058602716, -199.9367088516222, -199.9367090704208, -199.9367120617502, -199.9367069148598, -199.9367077970448, -199.9367101249991, -199.9367110071829, -199.9367073514932, -199.9367073603981, -199.9367105616319, -199.9367105705367, -199.9367075917687, -199.9367071201225, -199.9367108019058, -199.9367103302627, -199.9367074371037, -199.9367072747875, -199.9367106472427, -199.9367104849258, -199.936707366581, -199.9367073453104, -199.9367105767196, -199.9367105554491, -199.936748845918, -199.9366658673884, -199.9367520566256, -199.9366690769581, -199.9367179312386, -199.9366967808034, -199.9367211413741, 
  -199.9366999909452, -199.936707363384, -199.9367073485073, -199.9367105735224, -199.9367105586462, -199.9367054760787, -199.9367092359183, -199.9367086861107, -199.9367124461636, -199.9367077368935, -199.9367069750635, -199.9367109470271, -199.9367101852072, -199.9367073435899, -199.9367073683011, -199.9367105537285, -199.9367105784399, -199.9367083038488, -199.9367083222231, -199.9367095997932, -199.9367096181674, -199.9367068173673, -199.9367098087071, -199.9367081133114, -199.9367111046516, -199.9367078719482, -199.9367087541371, -199.936709167897, -199.9367100500769, -199.9367083085835, -199.9367083174884, -199.9367096045279, -199.9367096134327, -199.9367085488582, -199.9367080772136, -199.9367098448025, -199.9367093731579, -199.9367083941943, -199.9367082318776, -199.9367096901385, 
  -199.936709527822, -199.9367083236713, -199.9367083024007, -199.9367096196156, -199.9367095983451, -199.9367498032665, -199.9366668242205, -199.9367510992634, -199.9366681201123, -199.9367188883203, -199.9366977379023, -199.9367201842787, -199.9366990338326, -199.9367083204742, -199.9367083055978, -199.9367096164185, -199.9367096015421, -199.9367064331246, -199.9367101930531, -199.9367077290512, -199.9367114890152, -199.9367086939812, -199.9367079321565, -199.9367099899256, -199.9367092281006, -199.9367083006802, -199.9367083253915, -199.9367095966245, -199.9367096213359, -199.936707456152, -199.9367104474921, -199.9367074745263, -199.9367104658663, -199.9367085107352, -199.9367093929197, -199.9367085291096, -199.9367094112939, -199.9367089473684, -199.9367089562733, -199.9367089657427, 
  -199.9367089746475, -199.9367091876426, -199.9367087159989, -199.9367092060178, -199.9367087343723, -199.9367090329787, -199.9367088706629, -199.9367090513538}
 {-380.192207996361, -380.1922180754627, -380.1922157895309, -380.1922002032288, -380.1921979172882, -380.192216999627, -380.1922168653638, -380.192199127389, -380.1921989931253, -380.1922186210561, -380.1922152439361, -380.1922007488118, -380.192197371704, -380.1922135535973, -380.1922203114633, -380.1921956813608, -380.1922024392235, -380.1922167874171, -380.1922170775737, -380.1921989151788, -380.1921992053355, -380.1922192736258, -380.1922145913927, -380.1922014013765, -380.1921967191655, -380.192211933436, -380.1922219316444, -380.1921940611982, -380.1922040594057, -380.192218564258, -380.1922153008126, -380.1922006920196, -380.1921974285745, -380.1921663166816, -380.1922675518961, -380.19214844378, -380.1922496803216, -380.1922512047816, -380.1921826606287, -380.1922333325516, 
  -380.1921647883823, -380.1922550631714, -380.1921788056974, -380.1922371909269, -380.1921609334655, -380.1922441070546, -380.1921897578088, -380.1922262347814, -380.1921718856057, -380.1922298136638, -380.1922040514621, -380.1922119414275, -380.1921861792221, -380.1922372311587, -380.1921966352733, -380.1922193589222, -380.1921787630337, -380.1922092064623, -380.1922090721987, -380.1922069205259, -380.1922067862628, -380.1922108278886, -380.192207450774, -380.1922085419516, -380.1922051648385, -380.1922057604357, -380.1922125182951, -380.1922034744945, -380.192210232364, -380.1922089942522, -380.1922092844089, -380.1922067083159, -380.1922069984727, -380.1922114804536, -380.1922067982351, -380.192209194521, -380.1922045122955, -380.1922041402717, -380.192214138479, -380.1922018543348, 
  -380.1922118525437, -380.1922107710929, -380.1922075076479, -380.192208485157, -380.1922052217114, -380.1921585230964, -380.1922597591518, -380.1921562373376, -380.1922574730382, -380.1922434116379, -380.1921748674427, -380.1922411256675, -380.1921725815406, -380.1922472700026, -380.1921710125364, -380.1922449840679, -380.1921687265987, -380.1922363138587, -380.192181964675, -380.1922340279496, -380.1921796787116, -380.1922220205014, -380.192196258295, -380.1922197345622, -380.1921939723617, -380.1922294379943, -380.192188842108, -380.1922271520588, -380.1921865561712, -380.1922097520504, -380.1922063749366, -380.1922096177871, -380.1922062406733, -380.1922046845955, -380.1922114424598, -380.192204550332, -380.1922113081967, -380.1922079184144, -380.192208208571, -380.192207784151, 
  -380.1922080743077, -380.192210404619, -380.192205722394, -380.1922102703528, -380.1922055881336, -380.1922030644339, -380.1922130626413, -380.1922029301699}
 {-20.70909807075418, -20.70909525056753, -20.7090946253525, -20.709101516178, -20.70910089095982, -20.70909489731517, -20.7090949786053, -20.70910116292367, -20.70910124421459, -20.70910238646133, -20.70908748949719, -20.70910865199533, -20.70909375518097, -20.70909889640138, -20.70909097955313, -20.70910516201167, -20.70909724516063, -20.70909510910002, -20.70909476682049, -20.70910137470869, -20.7091010324296, -20.70907018087364, -20.70911969646359, -20.70907644664638, -20.70912596190861, -20.70909727209717, -20.70909260384802, -20.70910353770841, -20.70909886945457, -20.70910027855525, -20.70908959741428, -20.70910654416065, -20.70909586302667, -20.7091539149386, -20.70903596241126, -20.70916018121507, -20.70904222735259, -20.70906955920971, -20.7091203169951, -20.70907582482632, 
  -20.70912658259628, -20.70913765845673, -20.70905221995107, -20.70914392411864, -20.70905848550696, -20.70908687818178, -20.70910299795615, -20.70909314362487, -20.70910926373084, -20.70910476097743, -20.70908511505469, -20.70911102661313, -20.70909138063677, -20.70914444828134, -20.7090454272548, -20.7091507138644, -20.70905169288954, -20.70909834271698, -20.70909842400752, -20.70909771750039, -20.7090977987909, -20.70910583182711, -20.70909093493543, -20.70910520660807, -20.70909030972126, -20.70910234180512, -20.70909442495341, -20.70910171658645, -20.70909379973887, -20.70909855450194, -20.70909821222259, -20.7090979292853, -20.70909758700603, -20.70907362635777, -20.70912314178348, -20.70907300114078, -20.70912251656726, -20.70910071749908, -20.70909604925014, -20.70910009228502, 
  -20.70909542403098, -20.70910372395546, -20.7090930428181, -20.70910309873897, -20.70909241760138, -20.7091573606767, -20.70903940747719, -20.7091567354555, -20.70903878226519, -20.70907300460602, -20.70912376240282, -20.70907237940854, -20.7091231371671, -20.70914110388306, -20.70905566532878, -20.70914047867084, -20.70905504010778, -20.70909032349914, -20.70910644344281, -20.70908969828604, -20.7091058182227, -20.70910820639142, -20.70908856044472, -20.70910758117765, -20.70908793522528, -20.70914789367159, -20.70904887266859, -20.70914726845268, -20.70904824745429, -20.70910547857275, -20.70909058168311, -20.70910555986289, -20.70909066297403, -20.70910198855076, -20.7090940717011, -20.70910206984127, -20.70909415299164, -20.70909820124859, -20.70909785896927, -20.7090982825391, 
  -20.7090979402598, -20.70907327310407, -20.70912278853049, -20.70907335439492, -20.70912286982069, -20.70910036424702, -20.70909569599551, -20.70910044553754}
 {-13.36996986753684, -13.36997150958086, -13.36997114709433, -13.36996858799014, -13.36996822550171, -13.36997130953713, -13.36997134713787, -13.36996838794528, -13.36996842554637, -13.36997190199224, -13.36997075468531, -13.36996898039554, -13.36996783309867, -13.36997377830152, -13.36996887839314, -13.36997085670938, -13.36996595680195, -13.36997135601606, -13.36997130065894, -13.36996843442436, -13.36996837906731, -13.36996846391817, -13.36997419279825, -13.36996554234462, -13.36997127118845, -13.36997229989028, -13.36997035679056, -13.36996937829932, -13.36996743519818, -13.36997315949083, -13.36996949720164, -13.36997023789971, -13.36996657560942, -13.36999547427464, -13.36994718381542, -13.36999255301718, -13.36994426188955, -13.36996372148113, -13.36997893534561, 
  -13.36996079988904, -13.36997601375437, -13.36999010124154, -13.36995255637618, -13.36998717965624, -13.36994963477815, -13.36997488728084, -13.36996776940262, -13.36997196565113, -13.36996484784899, -13.36997584128213, -13.36996681538465, -13.36997291969212, -13.36996389379133, -13.36998097759971, -13.36996167910507, -13.3699780560052, -13.36995875751624, -13.36997002998022, -13.36997006758115, -13.36996966749274, -13.36996970509366, -13.36997062243328, -13.36996947513064, -13.36997025994506, -13.36996911264389, -13.36997249874506, -13.36996759883597, -13.36997213625639, -13.36996723634967, -13.36997007645923, -13.36997002110214, -13.36996971397174, -13.36996965861467, -13.36996718437022, -13.36997291323256, -13.36996682188313, -13.36997255074469, -13.36997102033317, 
  -13.36996907723405, -13.369970657847, -13.36996871474526, -13.36997187993426, -13.36996821764458, -13.36997151744685, -13.36996785515703, -13.36999419488949, -13.36994590408695, -13.36999383239289, -13.36994554160858, -13.36996244191961, -13.3699776557935, -13.36996207944111, -13.36997729329704, -13.36998882168701, -13.36995127681709, -13.36998845920133, -13.3699509143278, -13.3699736077034, -13.36996648986643, -13.36997324521913, -13.36996612737574, -13.36997456172629, -13.36996553582687, -13.36997419923852, -13.36996517333967, -13.36997969804202, -13.36996039954913, -13.36997933555345, -13.36996003706274, -13.36997042238861, -13.36996927508671, -13.36997045998954, -13.36996931268762, -13.36997229870017, -13.36996739879226, -13.36997233630108, -13.36996743639319, -13.36996987641493, 
  -13.36996982105785, -13.36996991401584, -13.36996985865877, -13.36996698432638, -13.3699727131878, -13.36996702192676, -13.36997275078926, -13.36997082028955, -13.36996887718907, -13.36997085789041}
 {-300.5685290529511, -300.5685296153498, -300.5685296259472, -300.5685284799558, -300.5685284905534, -300.568529616359, -300.5685296249379, -300.5685284809651, -300.5685284895441, -300.5685296066472, -300.5685296346499, -300.5685284712533, -300.568528499256, -300.5685302983257, -300.5685289429717, -300.5685291629318, -300.5685278075778, -300.5685296180779, -300.568529623219, -300.568528482684, -300.5685284878252, -300.568529057824, -300.5685301834779, -300.5685279224302, -300.5685290480839, -300.5685294957104, -300.5685297455872, -300.5685283603165, -300.5685286101933, -300.5685303148943, -300.5685289264076, -300.5685291795004, -300.5685277910138, -300.5685308261707, -300.5685284153279, -300.5685296908152, -300.5685272798956, -300.5685294832583, -300.568529758063, -300.5685283478633, 
  -300.5685286226703, -300.5685350202053, -300.5685242213868, -300.568533884812, -300.5685230859925, -300.568535600528, -300.5685236407337, -300.5685344651322, -300.5685225053416, -300.5685356606812, -300.5685235805795, -300.5685345252873, -300.5685224451856, -300.5685436045164, -300.5685156366105, -300.5685424691225, -300.5685145012166, -300.568529043363, -300.5685290519418, -300.5685290539605, -300.5685290625393, -300.5685290336511, -300.5685290616539, -300.5685290442486, -300.5685290722513, -300.5685297253296, -300.5685283699757, -300.5685297359271, -300.5685283805732, -300.5685290450818, -300.568529050223, -300.5685290556793, -300.5685290608205, -300.568528484828, -300.5685296104818, -300.5685284954255, -300.5685296210793, -300.5685289227143, -300.5685291725912, -300.5685289333118, 
  -300.5685291831886, -300.5685297418982, -300.5685283534116, -300.5685297524958, -300.5685283640091, -300.568530253193, -300.5685278423136, -300.5685302637922, -300.5685278529092, -300.5685289102611, -300.5685291850681, -300.5685289208596, -300.5685291956645, -300.5685344472095, -300.5685236483906, -300.568534457807, -300.568523658988, -300.5685350275311, -300.5685230677384, -300.5685350381284, -300.5685230783361, -300.5685350876851, -300.5685230075834, -300.5685350982826, -300.5685230181809, -300.5685430315203, -300.5685150636145, -300.5685430421178, -300.568515074212, -300.5685290346603, -300.5685290626632, -300.5685290432393, -300.568529071242, -300.5685297263389, -300.568528370985, -300.5685297349178, -300.5685283795639, -300.5685290460911, -300.5685290512323, -300.56852905467, 
  -300.5685290598112, -300.5685284858372, -300.5685296114911, -300.5685284944161, -300.56852962007, -300.5685289237236, -300.5685291736004, -300.5685289323025}
 {-222.2691315254528, -222.2691295123386, -222.2691305220051, -222.269132528915, -222.2691335385898, -222.2691299812126, -222.2691300531309, -222.2691329977928, -222.2691330697118, -222.2691290461034, -222.2691309882445, -222.2691320626895, -222.2691340048196, -222.269132094703, -222.2691279396752, -222.2691351112826, -222.2691309562568, -222.2691299724662, -222.2691300618774, -222.2691329890468, -222.2691330784579, -222.269125612289, -222.269134422226, -222.2691286288847, -222.2691374387913, -222.2691274487666, -222.2691325856064, -222.2691304653466, -222.2691356021875, -222.2691340429197, -222.2691259914622, -222.2691370595004, -222.2691290080426, -222.2691726043389, -222.2690874314304, -222.2691756214738, -222.2690904474566, -222.2691458910176, -222.2691141436282, -222.2691489075947, 
  -222.2691171602123, -222.2691609984613, -222.2690990377668, -222.2691640150512, -222.269102054338, -222.2691277418119, -222.2691322926446, -222.2691307582874, -222.2691353093303, -222.2691352985658, -222.2691247358276, -222.2691383151423, -222.2691277524122, -222.2691533248165, -222.2691067094003, -222.2691563413943, -222.2691097259835, -222.2691309846583, -222.2691310565769, -222.2691319943289, -222.2691320662476, -222.2691300495527, -222.269131991687, -222.2691310592219, -222.269133001359, -222.2691330981469, -222.269128943123, -222.2691341078204, -222.2691299527908, -222.269130975912, -222.2691310653231, -222.2691319855827, -222.2691320749938, -222.2691266157415, -222.2691354256653, -222.2691276254141, -222.2691364353339, -222.2691284522116, -222.269133589053, -222.2691294618833, 
  -222.2691345987227, -222.2691350463657, -222.2691269949079, -222.2691360560362, -222.2691280045786, -222.2691736080407, -222.2690884346203, -222.2691746177538, -222.2690894442485, -222.2691468944542, -222.2691151470834, -222.2691479041399, -222.2691161567389, -222.2691620019097, -222.2691000412101, -222.2691630115846, -222.2691010508765, -222.2691287452125, -222.2691332961357, -222.2691297548686, -222.269134305821, -222.2691363020094, -222.2691257392758, -222.2691373116805, -222.2691267489458, -222.2691543282618, -222.2691077128466, -222.2691553379307, -222.2691087225189, -222.2691305184279, -222.2691324605635, -222.2691305903466, -222.2691325324822, -222.2691335670242, -222.2691294119975, -222.2691336389429, -222.2691294839161, -222.269131444788, -222.2691315341991, -222.2691315167066, 
  -222.2691316061177, -222.2691270846186, -222.2691358945398, -222.2691271565367, -222.2691359664591, -222.2691289210879, -222.2691340579285, -222.2691289930068}
 {-17.92061165759942, -17.92062812641039, -17.92062721397006, -17.92059610134985, -17.92059518892321, -17.92062774528716, -17.92062759509329, -17.92059572023206, -17.920595570041, -17.9206288443961, -17.9206264960007, -17.92059681933583, -17.92059447095359, -17.92063103433692, -17.9206243060534, -17.92059900928184, -17.92059228100109, -17.92062769023644, -17.92062765014402, -17.9205956651827, -17.92059562509037, -17.92061831343855, -17.92063702731944, -17.92058628840505, -17.92060500224553, -17.92062687888257, -17.92062846150486, -17.92059485382841, -17.92059643645163, -17.92063000807452, -17.92062533232848, -17.92059798302124, -17.92059330727437, -17.92059619678038, -17.92065914448547, -17.92056417190739, -17.92062711925109, -17.92062654635091, -17.92062879413531, -17.92059452126804, 
  -17.92059676911079, -17.92064440116079, -17.92061094032665, -17.92061237612039, -17.92057891525965, -17.92062593758283, -17.92062940297307, -17.9205939128467, -17.9205973776018, -17.92063940971673, -17.92061593059758, -17.9206073846644, -17.92058390554253, -17.92065435170205, -17.92060098839753, -17.92062232664702, -17.92056896334518, -17.92061218891241, -17.9206120387199, -17.92061127647888, -17.92061112628646, -17.92061328802058, -17.92061093962808, -17.92061237558342, -17.92061002719828, -17.92061547796259, -17.92060874967959, -17.92061456552824, -17.92060783724698, -17.92061213386236, -17.92061209376996, -17.92061122142886, -17.9206111813365, -17.92060275707372, -17.92062147093612, -17.92060184464195, -17.92062055850092, -17.92061132250858, -17.92061290513071, -17.92061041007447, 
  -17.92061199269786, -17.9206144517006, -17.92060977595426, -17.92061353926723, -17.92060886352067, -17.92058064048846, -17.92064358802925, -17.92057972807138, -17.92064267557937, -17.92061098997296, -17.92061323776512, -17.92061007751806, -17.92061232535305, -17.9206288447937, -17.92059538394558, -17.92062793235954, -17.92059447151278, -17.92061038136255, -17.9206138464452, -17.92060946893905, -17.92061293400174, -17.92062385334324, -17.92060037422294, -17.92062294090997, -17.92059946178924, -17.92063879532706, -17.92058543202439, -17.92063788289409, -17.92058451959039, -17.92061290689827, -17.92061055850938, -17.92061275670574, -17.92061040831699, -17.92061509684166, -17.92060836855951, -17.92061494664918, -17.92060821836706, -17.92061175274184, -17.92061171264947, -17.92061160254938, 
  -17.920611562457, -17.92060237595661, -17.92062108981222, -17.92060222575907, -17.92062093962483, -17.92061094138796, -17.92061252401032, -17.9206107911951}
 {-533.1214478028871, -533.1214484311386, -533.1214493954462, -533.1214462103495, -533.1214471746735, -533.1214487728996, -533.1214490536842, -533.1214465521173, -533.1214468329049, -533.1214468289721, -533.1214509976163, -533.1214446082017, -533.1214487768248, -533.1214497575185, -533.1214480691019, -533.121447536735, -533.1214458483235, -533.121448703475, -533.121449123109, -533.1214464826941, -533.1214469023282, -533.121428212805, -533.1214696138213, -533.1214259921144, -533.1214673929502, -533.1214394327775, -533.1214583938181, -533.1214372119953, -533.1214561730386, -533.121438787968, -533.1214590386346, -533.121436567189, -533.1214568178519, -533.1214140012048, -533.1214838276464, -533.1214117795868, -533.1214816077026, -533.121438500621, -533.1214593262173, -533.1214362798489, 
  -533.1214571054277, -533.1213552571255, -533.1215425713059, -533.1213530363332, -533.1215403505364, -533.1214561540639, -533.1214416725337, -533.1214539331866, -533.1214394518494, -533.1214531880721, -533.1214446385767, -533.121450967285, -533.1214424178022, -533.1214081895737, -533.1214896398383, -533.1214059687817, -533.1214874190684, -533.1214471803366, -533.1214474611225, -533.1214481446525, -533.1214484254387, -533.1214452364154, -533.1214494050482, -533.1214462007305, -533.1214503693651, -533.1214481649543, -533.1214464765414, -533.1214491292714, -533.1214474408561, -533.1214471109126, -533.1214475305467, -533.1214480752287, -533.1214484948625, -533.1214266202879, -533.1214680212139, -533.1214275846039, -533.1214689855297, -533.1214378402125, -533.1214568012586, 
  -533.1214388045324, -533.1214577655705, -533.1214371954064, -533.1214574460715, -533.1214381597226, -533.1214584103871, -533.1214124082586, -533.121482235468, -533.1214133725053, -533.1214831998531, -533.1214369080728, -533.1214577336409, -533.1214378723693, -533.1214586979761, -533.1213536645588, -533.1215409787478, -533.1213546288718, -533.1215419430666, -533.1214545614601, -533.121440080013, -533.1214555257627, -533.1214410443422, -533.1214515955065, -533.1214430460176, -533.1214525598227, -533.1214440103334, -533.1214065970077, -533.1214880472798, -533.1214075613199, -533.1214890115993, -533.1214455781795, -533.1214497468132, -533.1214458589657, -533.1214500275992, -533.1214485067193, -533.1214468183052, -533.1214487875053, -533.1214470990913, -533.1214474526771, -533.121447872311, 
  -533.1214477334632, -533.1214481530971, -533.1214269620522, -533.1214683629783, -533.1214272428385, -533.1214686437646, -533.1214381819789, -533.121457143021, -533.1214384627652}
 {-293.2155056011793, -293.2155056641944, -293.2155056207488, -293.2155055816099, -293.2155055381644, -293.215505642036, -293.2155056429073, -293.2155055594515, -293.2155055603229, -293.2155059486132, -293.2155053363315, -293.215505866026, -293.2155052537497, -293.2155082065984, -293.2155030783599, -293.2155081240138, -293.2155029957755, -293.2155056426318, -293.2155056423115, -293.2155055600473, -293.215505559727, -293.215505600086, -293.2155056848573, -293.2155055175019, -293.2155056022725, -293.2155055812289, -293.2155057037144, -293.2155054986444, -293.21550562113, -293.215505648456, -293.2155056364874, -293.2155055658716, -293.2155055539029, -293.215506275048, -293.2155050098963, -293.2155061924569, -293.2155049273185, -293.2154992121731, -293.2155120728775, -293.2154991295893, 
  -293.2155119902924, -293.215505546657, -293.2155057382863, -293.2155054640726, -293.2155056557018, -293.2155056515361, -293.2155056334072, -293.2155055689516, -293.2155055508229, -293.2155093555958, -293.2155019293531, -293.2155092730122, -293.2155018467679, -293.2155056459674, -293.2155056389759, -293.2155055633829, -293.2155055563915, -293.2155056224664, -293.2155056233377, -293.2155055790208, -293.2155055798922, -293.2155059290429, -293.2155053167626, -293.2155058855961, -293.2155052733183, -293.2155081870288, -293.2155030587902, -293.2155081435831, -293.2155030153449, -293.2155056230622, -293.2155056227419, -293.2155055796167, -293.2155055792963, -293.2155055805165, -293.2155056652876, -293.2155055370711, -293.2155056218419, -293.2155055616592, -293.2155056841448, 
  -293.2155055182138, -293.2155056406993, -293.2155056288864, -293.2155056169178, -293.2155055854409, -293.2155055734722, -293.2155062554751, -293.21550499033, -293.2155062120295, -293.2155049468846, -293.215499192604, -293.2155120533075, -293.2154991491581, -293.2155120098623, -293.2155055270874, -293.2155057187166, -293.2155054836419, -293.2155056752711, -293.2155056319665, -293.2155056138376, -293.215505588521, -293.2155055703921, -293.2155093360266, -293.2155019097832, -293.2155092925812, -293.2155018663376, -293.2155056263978, -293.2155056194063, -293.2155055829522, -293.2155055759608, -293.2155059068838, -293.2155052946048, -293.2155059077552, -293.2155052954761, -293.2155081648703, -293.2155030366319, -293.2155081657417, -293.2155030375032, -293.2155056009038, -293.2155056005835, 
  -293.2155056017751, -293.2155056014548, -293.2155055583581, -293.2155056431291, -293.2155055592294, -293.2155056440005, -293.2155055395008, -293.2155056619863, -293.2155055403722}
 {-402.2687227540193, -402.2687282364664, -402.2687284735794, -402.2687170344762, -402.2687172715962, -402.2687283810371, -402.2687283290078, -402.2687171790507, -402.2687171270206, -402.2687272895312, -402.2687294205109, -402.2687160875495, -402.268718218519, -402.2687267366484, -402.2687299734509, -402.2687155346608, -402.268718771465, -402.2687284859241, -402.2687282241206, -402.2687172839374, -402.2687170221339, -402.2687351609489, -402.2687215491574, -402.26872395895, -402.2687103471826, -402.2687355165274, -402.2687211935635, -402.2687243145407, -402.2687099915764, -402.268733348471, -402.2687233616194, -402.2687221464842, -402.2687121596328, -402.26871847727, -402.2687382349026, -402.2687072749613, -402.2687270332379, -402.2687235229037, -402.2687331875591, -402.2687123209285, 
  -402.2687219855607, -402.268791238492, -402.2686654744125, -402.2687800365, -402.268654272431, -402.2687521717984, -402.2687045381069, -402.2687409697999, -402.2686933361318, -402.2687199379622, -402.2687367726755, -402.2687087359727, -402.2687255706916, -402.2687832126307, -402.2686734972602, -402.2687720106451, -402.2686622952722, -402.2687226614765, -402.268722609447, -402.268722898593, -402.2687228465633, -402.268721569973, -402.2687237009475, -402.2687218070894, -402.2687239380641, -402.2687210170874, -402.2687242538905, -402.2687212542037, -402.2687244910072, -402.2687227663636, -402.2687225045598, -402.26872300348, -402.2687227416763, -402.2687294413823, -402.2687158296025, -402.2687296784984, -402.2687160667194, -402.2687297969666, -402.2687154740025, -402.2687300340831, 
  -402.2687157111191, -402.2687276289103, -402.2687176420587, -402.2687278660268, -402.2687178791752, -402.2687127575862, -402.2687325154648, -402.2687129946266, -402.2687327526573, -402.2687178033498, -402.2687274679915, -402.2687180404641, -402.2687277051101, -402.2687855189294, -402.2686597548537, -402.2687857560443, -402.2686599919716, -402.2687464522333, -402.2686988185505, -402.2687466893467, -402.2686990556699, -402.268714218401, -402.2687310531153, -402.2687144555157, -402.2687312902336, -402.2687774930705, -402.2686677776987, -402.268777730187, -402.2686680148152, -402.2687217145455, -402.2687238455201, -402.2687216625158, -402.2687237934905, -402.2687211616597, -402.2687243984632, -402.2687211096302, -402.2687243464335, -402.268722910936, -402.2687226491323, -402.2687228589064, 
  -402.2687225971028, -402.268729585955, -402.2687159741748, -402.2687295339246, -402.268715922146, -402.2687299415392, -402.268715618575, -402.2687298895096}
 {-398.9488903610687, -398.9488940323204, -398.9488940635224, -398.9488866586275, -398.9488866898306, -398.9488941459619, -398.9488939498806, -398.94888677227, -398.9488865761878, -398.9488937974367, -398.9488942984072, -398.9488864237443, -398.948886924715, -398.9488985300821, -398.9488895657935, -398.9488911563892, -398.9488821921017, -398.948894175726, -398.9488939201165, -398.9488868020337, -398.9488865464242, -398.9489021194642, -398.9488859764389, -398.948894745753, -398.9488786027655, -398.9488936793101, -398.9488944165517, -398.9488863056178, -398.9488870428594, -398.948875153498, -398.9489129424393, -398.9488677798052, -398.9489055687473, -398.9488791620619, -398.9489089352229, -398.9488717881106, -398.9489015617895, -398.9488960757391, -398.9488920204228, -398.9488887020531, 
  -398.9488846467241, -398.9489657496751, -398.9488223487611, -398.9489583759809, -398.9488149750706, -398.9489089922004, -398.9488791035912, -398.9489016184946, -398.9488717299123, -398.9489096513981, -398.9488784444551, -398.9489022777049, -398.9488710707636, -398.9488250425573, -398.9489630584016, -398.9488176688668, -398.9489556847074, -398.9488904435085, -398.9488902474267, -398.948890474711, -398.9488902786293, -398.9488900949835, -398.9488905959531, -398.9488901261851, -398.9488906271566, -398.9488948276285, -398.9488858633398, -398.9488948588305, -398.9488858945429, -398.9488904732723, -398.9488902176629, -398.9488905044748, -398.9488902488655, -398.9488984170033, -398.9488822739925, -398.9488984482015, -398.9488823051995, -398.9488899768568, -398.9488907140976, 
  -398.9488900080586, -398.9488907453009, -398.9488714510441, -398.9489092399859, -398.9488714822466, -398.9489092711884, -398.9488754594794, -398.9489052328982, -398.9488754906807, -398.9489052641018, -398.9488923732921, -398.9488883179626, -398.9488924044879, -398.9488883491719, -398.9489620472201, -398.9488186463087, -398.9489620784236, -398.9488186775104, -398.9489052897406, -398.9488754011437, -398.9489053209421, -398.9488754323473, -398.9489059489448, -398.948874742001, -398.9489059801458, -398.9488747732051, -398.9488213401041, -398.9489593559475, -398.9488213713076, -398.9489593871492, -398.9488902086252, -398.9488907095956, -398.9488900125432, -398.948890513514, -398.9488949412702, -398.9488859769822, -398.9488947451885, -398.9488857809003, -398.9488905869144, -398.9488903313049, 
  -398.9488903908325, -398.9488901352232, -398.9488985306435, -398.9488823876364, -398.948898334561, -398.9488821915553, -398.9488900904986, -398.94889082774, -398.9488898944167}
 {-303.802162735746, -303.8021635340947, -303.8021635863521, -303.8021618851457, -303.8021619374029, -303.8021635540436, -303.8021635664033, -303.8021619050943, -303.8021619174542, -303.8021642137198, -303.8021629067277, -303.8021625647698, -303.8021612577793, -303.8021657030633, -303.8021614173901, -303.8021640541141, -303.802159768441, -303.8021635766348, -303.802163543812, -303.8021619276857, -303.8021618948629, -303.8021607177638, -303.8021664027089, -303.8021590688181, -303.8021647537563, -303.8021635887354, -303.8021635317133, -303.8021619397861, -303.8021618827642, -303.8021655400148, -303.8021615804464, -303.8021638910656, -303.8021599314972, -303.8021776838842, -303.8021494371356, -303.8021760351671, -303.8021477879545, -303.8021548009839, -303.8021723195311, -303.802153152031, 
  -303.8021706705858, -303.802180838226, -303.802146282928, -303.8021791892787, -303.8021446339771, -303.8021677115851, -303.8021594088596, -303.8021660626131, -303.8021577599333, -303.8021649261348, -303.8021621943607, -303.8021632771859, -303.8021605454114, -303.8021723180983, -303.8021548024205, -303.8021706691489, -303.8021531534716, -303.8021627034376, -303.8021627157973, -303.8021627556948, -303.8021627680546, -303.8021633631136, -303.8021620561218, -303.8021634153703, -303.8021621083796, -303.8021648524572, -303.8021605667841, -303.8021649047146, -303.8021606190413, -303.8021627260288, -303.802162693206, -303.8021627782861, -303.8021627454633, -303.8021598671589, -303.8021655521017, -303.8021599194173, -303.8021656043579, -303.8021627381291, -303.8021626811075, -303.8021627903868, 
  -303.8021627333644, -303.8021646894088, -303.8021607298403, -303.802164741666, -303.8021607820976, -303.8021768333921, -303.8021485864158, -303.8021768856536, -303.8021486386688, -303.8021539503715, -303.8021714689315, -303.8021540026377, -303.8021715211798, -303.8021799876206, -303.8021454323215, -303.8021800398785, -303.8021454845782, -303.8021668609681, -303.8021585582646, -303.8021669132245, -303.8021586105228, -303.8021640755288, -303.8021613437546, -303.8021641277862, -303.8021613960118, -303.8021714674923, -303.8021539518144, -303.8021715197492, -303.8021540040721, -303.802163383062, -303.8021620760708, -303.8021633954218, -303.8021620884305, -303.802164872406, -303.8021605867328, -303.8021648847658, -303.8021605990925, -303.8021627459776, -303.8021627131548, -303.8021627583373, 
  -303.8021627255144, -303.8021598871084, -303.8021655720497, -303.8021598994677, -303.8021655844098, -303.802162758078, -303.8021627010561, -303.8021627704379}
 {-446.0810054975305, -446.0810094521496, -446.0810072844248, -446.0810037106773, -446.0810015429383, -446.0810085556318, -446.0810081809411, -446.0810028141539, -446.0810024394602, -446.0810092252323, -446.0810075113447, -446.0810034837463, -446.0810017698719, -446.0810112882625, -446.081005448358, -446.081005546784, -446.0809997068779, -446.0810082307132, -446.0810085058597, -446.0810024892341, -446.0810027643804, -446.0810082434849, -446.0810084930882, -446.0810025020085, -446.0810027516059, -446.0810082134863, -446.0810085230865, -446.0810024720061, -446.0810027816082, -446.0810083432706, -446.0810083933022, -446.0810026017898, -446.0810026518244, -446.0809636865447, -446.0810530524706, -446.0809579442477, -446.081047311809, -446.0810178440186, -446.0809988928301, -446.0810121025533, 
  -446.0809931513366, -446.0810083259576, -446.0810084106154, -446.081002584477, -446.0810026691375, -446.0810271286374, -446.0809896078878, -446.0810213870649, -446.0809838665016, -446.0810130962388, -446.0810036405425, -446.0810073547611, -446.0809978990616, -446.0810083880036, -446.0810083485695, -446.0810026465243, -446.0810026070902, -446.0810067687436, -446.0810063940509, -446.0810046010113, -446.0810042263196, -446.0810074383401, -446.0810057244584, -446.0810052706075, -446.0810035567273, -446.0810095013757, -446.0810036614666, -446.0810073336402, -446.0810014937384, -446.0810064438242, -446.0810067189704, -446.0810042760923, -446.0810045512387, -446.0810064565972, -446.0810067061973, -446.0810042888651, -446.0810045384657, -446.0810064265964, -446.081006736198, -446.0810042588649, 
  -446.0810045684658, -446.0810065563805, -446.081006606414, -446.0810043886491, -446.0810044386817, -446.0809618991993, -446.0810512660376, -446.0809597315622, -446.081049098211, -446.0810160571521, -446.0809971059181, -446.0810138893887, -446.0809949382177, -446.0810065390675, -446.0810066237271, -446.0810043713361, -446.0810044559947, -446.0810253416889, -446.0809878210578, -446.0810231739824, -446.0809856533006, -446.081011309351, -446.0810018536518, -446.081009141618, -446.0809996859213, -446.0810066011144, -446.0810065616803, -446.0810044333826, -446.0810043939484, -446.0810065418192, -446.0810048279383, -446.0810061671271, -446.081004453246, -446.0810086048534, -446.0810027649478, -446.081008230161, -446.0810023902559, -446.0810055473036, -446.0810058224498, -446.0810051726114, 
  -446.0810054477578, -446.0810055600767, -446.0810058096768, -446.0810051853842, -446.0810054349848, -446.0810055300769, -446.0810058396765, -446.0810051553832}
 {-232.6023165826306, -232.602316794416, -232.6023174324, -232.6023157328772, -232.6023163708678, -232.6023171100145, -232.6023171168011, -232.6023160484789, -232.6023160552657, -232.6023163834508, -232.602317843367, -232.6023153219189, -232.6023167818279, -232.6023182224326, -232.6023160044007, -232.6023171608963, -232.6023149428659, -232.6023171149667, -232.602317111849, -232.6023160534311, -232.6023160503135, -232.6023171700995, -232.6023170567161, -232.6023161085648, -232.6023159951799, -232.6023171220088, -232.6023171048069, -232.6023160604736, -232.602316043271, -232.6023171146532, -232.6023171121625, -232.6023160531177, -232.6023160506269, -232.6023484783572, -232.6022857498831, -232.6023474172323, -232.6022846879369, -232.6023251839485, -232.6023090430184, -232.6023241224096, 
  -232.6023079814863, -232.6023171134079, -232.6023171134079, -232.6023160518723, -232.6023160518723, -232.6023186523753, -232.6023155744849, -232.6023175907824, -232.6023145130066, -232.6023199225489, -232.6023143042893, -232.6023188610107, -232.6023132427564, -232.6023171108296, -232.602317115986, -232.602316049294, -232.6023160544506, -232.6023162602438, -232.6023162670305, -232.6023168982311, -232.6023169050178, -232.6023155336824, -232.6023169935939, -232.6023161716686, -232.6023176315824, -232.6023173726607, -232.6023151546312, -232.6023180106497, -232.6023157926168, -232.602316265196, -232.6023162620783, -232.6023169031833, -232.6023169000656, -232.6023163203291, -232.6023162069452, -232.6023169583167, -232.6023168449323, -232.6023162722382, -232.602316255036, -232.6023169102256, 
  -232.6023168930234, -232.6023162648825, -232.6023162623918, -232.6023169028698, -232.6023169003791, -232.6023476287726, -232.6022848999262, -232.6023482667983, -232.6022855378752, -232.602324334171, -232.6023081932545, -232.6023249721685, -232.6023088312317, -232.6023162636371, -232.6023162636371, -232.6023169016245, -232.6023169016245, -232.6023178025806, -232.6023147247382, -232.6023184405587, -232.6023153627347, -232.6023190727771, -232.6023134545197, -232.602319710764, -232.6023140925074, -232.6023162610589, -232.6023162662154, -232.6023168990462, -232.6023169042027, -232.602315849282, -232.6023173091946, -232.6023158560687, -232.6023173159814, -232.6023176882616, -232.6023154702304, -232.6023176950484, -232.6023154770172, -232.6023165807961, -232.6023165776784, -232.6023165875828, 
  -232.6023165844652, -232.6023166359295, -232.6023165225451, -232.602316642716, -232.602316529332, -232.6023165878382, -232.6023165706363, -232.6023165946252}
 {-22.73236412592951, -22.73236412477309, -22.73236619775179, -22.73236205413423, -22.73236412713179, -22.73236517025601, -22.73236515226737, -22.73236309962665, -22.73236308163786, -22.73236023748006, -22.73237008507023, -22.73235816687015, -22.73236801442126, -22.73235958367377, -22.73237073889205, -22.73235751304192, -22.73236866826503, -22.73236521348738, -22.732365109036, -22.73236314285795, -22.73236303840656, -22.73232849155746, -22.73240183192125, -22.73232642104456, -22.73239976117527, -22.73236620156596, -22.73236412100988, -22.73236413093354, -22.73236205038343, -22.73235687584096, -22.73237344673347, -22.7323548052085, -22.73237137610706, -22.73241650405876, -22.7323138213133, -22.73241443418978, -22.73231174992343, -22.73239915343677, -22.73233116943687, -22.73239708280462, 
  -22.73232909881016, -22.73235587897421, -22.73237444597247, -22.73235380836558, -22.73237237532223, -22.73236978171865, -22.73236054086576, -22.73236771098668, -22.73235847033885, -22.73236020667097, -22.73237011616193, -22.73235813603007, -22.73236804554395, -22.73232919617692, -22.73240112943354, -22.73232712553023, -22.73239905882135, -22.73236309843054, -22.73236308044187, -22.73236517141871, -22.73236515342994, -22.73235816566517, -22.73236801323414, -22.73236023865163, -22.73237008622393, -22.73235751184418, -22.73236866707066, -22.73235958483808, -22.732370740053, -22.73236314166188, -22.73236303721052, -22.73236521465003, -22.73236511019862, -22.73232641978732, -22.73239976004041, -22.73232849278128, -22.73240183302269, -22.73236412973975, -22.7323620491851, -22.73236620272633, 
  -22.73236412217478, -22.73235480401413, -22.73237137490933, -22.73235687700191, -22.73237344789779, -22.73241443255254, -22.73231174916856, -22.73241650566259, -22.73231382203476, -22.73239708160157, -22.73232909762109, -22.7323991546064, -22.73233117059253, -22.73235380715681, -22.73237237413889, -22.73235588014956, -22.73237444712239, -22.73236770985545, -22.73235846907797, -22.73236978281646, -22.73236054209323, -22.73235813484063, -22.73236804434129, -22.732360207827, -22.73237011733118, -22.73232712434293, -22.73239905761655, -22.73232919733081, -22.73240113060492, -22.73235921115195, -22.7323690587227, -22.73235919316335, -22.73236904073388, -22.73235855733467, -22.73236971255553, -22.73235853934612, -22.73236969456664, -22.73236418714955, -22.7323640826982, -22.73236416916087, 
  -22.73236406470946, -22.73232746527855, -22.73240080552452, -22.73232744728856, -22.73240078753709, -22.73236517522651, -22.7323630946737, -22.73236515723808}
 {-350.907398714135, -350.9074012272875, -350.9074009970051, -350.9073964312822, -350.907396201002, -350.9074011019638, -350.9074011223286, -350.9073963059594, -350.9073963263245, -350.9074013560111, -350.9074008682832, -350.9073965600046, -350.9073960722811, -350.9074040900195, -350.9073981342917, -350.9073992940144, -350.9073933382884, -350.9074011248226, -350.9074010994697, -350.9073963288184, -350.9073963034655, -350.9073994436208, -350.9074027807022, -350.9073946476242, -350.9073979846902, -350.90740143709, -350.9074007872074, -350.907396641086, -350.9073959912028, -350.9074031958248, -350.9073990284857, -350.9073983998208, -350.9073942324814, -350.907384480617, -350.9074177450472, -350.9073796843985, -350.9074129492572, -350.907404116826, -350.9073981076151, -350.9073993208223, 
  -350.9073933116102, -350.9073848011214, -350.9074174241138, -350.9073800051146, -350.907412628112, -350.9074058570852, -350.9073963671944, -350.907401061067, -350.907391571204, -350.9074070632184, -350.9073951610403, -350.9074022672139, -350.9073903650363, -350.9074122110909, -350.9073900131644, -350.9074074150857, -350.9073852171611, -350.9073988190933, -350.9073988394583, -350.907398588812, -350.907398609177, -350.9073990731403, -350.9073985854132, -350.9073988428575, -350.9073983551333, -350.9074018071495, -350.907395851421, -350.9074015768667, -350.9073956211412, -350.9073988419523, -350.9073988165993, -350.907398611671, -350.907398586318, -350.9073971607544, -350.9074004978277, -350.9073969304727, -350.9074002675467, -350.9073991542194, -350.9073985043372, -350.9073989239388, 
  -350.9073982740551, -350.9074009129545, -350.9073967456153, -350.9074006826732, -350.907396515334, -350.9073821976376, -350.9074154622859, -350.9073819673601, -350.9074152320006, -350.9074018339593, -350.9073958247411, -350.9074016036712, -350.9073955944665, -350.9073825182502, -350.9074151412442, -350.9073822879679, -350.9074149109638, -350.9074035742068, -350.907394084332, -350.9074033439275, -350.9073938540487, -350.9074047803483, -350.9073928781697, -350.9074045500661, -350.9073926478892, -350.9074099282203, -350.9073877302943, -350.9074096979384, -350.9073875000134, -350.9073989478163, -350.9073984600906, -350.9073989681812, -350.9073984804556, -350.9074016818254, -350.9073957260985, -350.9074017021903, -350.9073957464635, -350.907398716629, -350.907398691276, -350.907398736994, 
  -350.907398711641, -350.9073970354315, -350.9074003725041, -350.9073970557954, -350.9074003928701, -350.9073990288965, -350.9073983790135, -350.9073990492613}
 {-329.5858862952103, -329.5858861082574, -329.5858862750163, -329.5858863154037, -329.5858864821613, -329.5858861904033, -329.5858861928706, -329.5858863975488, -329.5858864000161, -329.5858854737919, -329.5858869094722, -329.5858856809465, -329.5858871166088, -329.5858768528018, -329.5858955304849, -329.5858770599476, -329.5858957376302, -329.5858861126125, -329.5858862706613, -329.5858863197581, -329.5858864778068, -329.5858856619273, -329.5858867214227, -329.5858858690765, -329.5858869285648, -329.5858836385047, -329.5858887448285, -329.5858838456494, -329.5858889519751, -329.5858883706507, -329.5858840126434, -329.585888577796, -329.5858842197892, -329.5858861739324, -329.5858862093413, -329.585886381079, -329.585886416486, -329.5859102984885, -329.5858620849351, -329.585910505637, 
  -329.5858622920778, -329.585898746129, -329.5858736380866, -329.5858989532785, -329.5858738452283, -329.5858861115216, -329.5858862717517, -329.5858863186685, -329.5858864788959, -329.5858677069396, -329.5859046767417, -329.5858679140808, -329.5859048838916, -329.585899244901, -329.585873138244, -329.5858994520455, -329.5858733453907, -329.5858862105975, -329.5858862130648, -329.5858863773558, -329.585886379823, -329.5858854939885, -329.5858869296642, -329.5858856607511, -329.585887096418, -329.585876872996, -329.5858955506792, -329.5858770397547, -329.585895717437, -329.5858861328067, -329.5858862908555, -329.585886299565, -329.5858864576137, -329.585885682121, -329.5858867416178, -329.585885848884, -329.585886908371, -329.5858836586988, -329.585888765023, -329.5858838254564, 
  -329.5858889317818, -329.5858883908449, -329.5858840328377, -329.585888557603, -329.585884199596, -329.5858861941272, -329.5858862295352, -329.5858863608854, -329.5858863962933, -329.5859103186831, -329.5858621051291, -329.5859104854436, -329.585862271885, -329.5858987663241, -329.5858736582802, -329.5858989330848, -329.5858738250359, -329.5858861317166, -329.5858862919453, -329.5858862984748, -329.5858864587035, -329.5858677271328, -329.585904696937, -329.5858678938887, -329.5859048636975, -329.5858992650952, -329.5858731584384, -329.5858994318526, -329.5858733251975, -329.5858855761361, -329.5858870118075, -329.5858855786035, -329.5858870142747, -329.5858769551417, -329.5858956328245, -329.585876957609, -329.5858956352917, -329.5858862149522, -329.585886373001, -329.5858862174195, 
  -329.5858863754683, -329.5858857642691, -329.5858868237606, -329.585885766736, -329.5858868262282, -329.5858837408439, -329.5858888471687, -329.5858837433113}
 {-28.19126347670959, -28.19127887983115, -28.19127769408438, -28.19124925946254, -28.19124807373432, -28.19127827463624, -28.19127829927916, -28.19124865427483, -28.1912486789219, -28.19127813675345, -28.19127843719015, -28.19124851639001, -28.19124881683492, -28.19128427128504, -28.19127230264932, -28.19125465092469, -28.19124268229101, -28.1912782939597, -28.19127827995572, -28.19124867360031, -28.19124865959644, -28.19125849959478, -28.1912980753006, -28.19122887927341, -28.1912684549033, -28.19127668435985, -28.19127988957345, -28.19124706399946, -28.19125026921519, -28.19128373083238, -28.19127284312928, -28.19125411047287, -28.19124322277013, -28.19129036685645, -28.19126620879451, -28.19126074752308, -28.19123658740926, -28.19127508234145, -28.19128149179107, -28.19124546193628, 
  -28.19125187147759, -28.19131385955887, -28.19124271667653, -28.19128423922677, -28.19121309628998, -28.19123890243696, -28.19131767236938, -28.19120928228323, -28.19128805180445, -28.19130172701509, -28.1912548467679, -28.19127210665585, -28.19122522640848, -28.19133159924538, -28.19122497411078, -28.19130197888138, -28.19119535375612, -28.19126405725596, -28.19126408190088, -28.19126287151838, -28.19126289616346, -28.19126391937264, -28.19126421981239, -28.19126273363409, -28.19126303407596, -28.19127005390519, -28.1912580852706, -28.19126886816781, -28.191256899533, -28.19126407658038, -28.19126406257647, -28.1912628908429, -28.19126287683896, -28.19124428223397, -28.19128385790285, -28.1912430964975, -28.19128267216433, -28.19126246697969, -28.19126567219504, -28.19126128124288, 
  -28.19126448645687, -28.19126951345306, -28.19125862575005, -28.19126832771547, -28.19125744001265, -28.19127614997402, -28.19125199091839, -28.19127496426877, -28.19125080514865, -28.191260864936, -28.19126727443795, -28.19125967920499, -28.19126608869398, -28.19129964219214, -28.19122849928469, -28.19129845645676, -28.19122731354509, -28.19122468515434, -28.19130345489343, -28.19122349942911, -28.19130226914368, -28.19128750963559, -28.19124062938883, -28.19128632389861, -28.19123944365082, -28.19131738186417, -28.19121075673343, -28.19131619612587, -28.19120957099675, -28.19126331418081, -28.1912636146216, -28.19126333882579, -28.19126363926661, -28.19126944871393, -28.19125748007923, -28.19126947335893, -28.19125750472423, -28.19126347138908, -28.19126345738515, -28.19126349603407, 
  -28.19126348203015, -28.19124367704344, -28.19128325271076, -28.19124370168789, -28.1912832773563, -28.19126186178868, -28.19126506700344, -28.19126188643378}
 {-214.6341513964287, -214.6341514317745, -214.6341517875578, -214.6341510053043, -214.6341513610941, -214.6341515717338, -214.6341516475981, -214.6341511452662, -214.6341512211318, -214.6341514252819, -214.6341517940514, -214.634150998815, -214.6341513675844, -214.6341520580331, -214.6341511613115, -214.634151631566, -214.6341507348447, -214.634151582642, -214.6341516366899, -214.6341511561752, -214.634151210223, -214.634144734926, -214.6341584844531, -214.6341443084613, -214.6341580579839, -214.6341473503969, -214.6341558689534, -214.6341469239299, -214.6341554424866, -214.6341468712896, -214.6341563480804, -214.6341464448227, -214.6341559216133, -214.634155197678, -214.6341480219539, -214.6341547713615, -214.6341475953365, -214.6341511110857, -214.6341521082824, -214.6341506846134, 
  -214.6341516818208, -214.6341725257493, -214.6341306940079, -214.6341720992845, -214.6341302675389, -214.6341571590724, -214.6341460602321, -214.634156732587, -214.6341456337836, -214.634157496197, -214.6341457231013, -214.63415706973, -214.6341452966344, -214.6341514423381, -214.6341517774805, -214.634151015871, -214.6341513510138, -214.6341511806033, -214.634151256468, -214.6341515363896, -214.6341516122548, -214.6341510341515, -214.634151402921, -214.6341513899381, -214.6341517587076, -214.6341516669027, -214.6341507701813, -214.6341520226893, -214.6341511259678, -214.6341511915117, -214.6341512455596, -214.6341515472983, -214.6341516013461, -214.6341443437965, -214.6341580933219, -214.6341446995836, -214.634158449108, -214.6341469592665, -214.6341554778232, -214.6341473150531, 
  -214.6341558336097, -214.6341464801593, -214.6341559569501, -214.6341468359458, -214.6341563127366, -214.634154806612, -214.6341476307591, -214.6341551624202, -214.634147986524, -214.6341507199515, -214.6341517171559, -214.6341510757404, -214.6341520729401, -214.6341721346197, -214.6341303028768, -214.6341724904069, -214.6341306586629, -214.6341567679349, -214.6341456691088, -214.6341571237172, -214.6341460248997, -214.6341571050667, -214.634145331971, -214.6341574608532, -214.6341456877576, -214.6341510512077, -214.6341513863503, -214.6341514069941, -214.6341517421369, -214.6341511741122, -214.6341515428817, -214.6341512499771, -214.6341516187466, -214.6341518068633, -214.6341509101419, -214.6341518827283, -214.6341509860068, -214.6341513314723, -214.6341513855202, -214.6341514073373, 
  -214.6341514613851, -214.6341444837573, -214.6341582332822, -214.6341445596224, -214.6341583091472, -214.6341470992271, -214.6341556177838, -214.6341471750921}
 {-251.1605039133725, -251.1605041476468, -251.1605041807776, -251.1605036459708, -251.1605036791021, -251.1605041744322, -251.1605041539922, -251.1605036727566, -251.1605036523163, -251.1605041462416, -251.1605041821833, -251.1605036445659, -251.1605036805077, -251.1605049744638, -251.1605033539612, -251.1605044727881, -251.1605028522855, -251.1605041655543, -251.1605041628701, -251.1605036638785, -251.1605036611944, -251.1605058322783, -251.1605024961705, -251.1605053306022, -251.1605019944952, -251.1605043441421, -251.160503984283, -251.1605038424665, -251.1605034826072, -251.1605050121498, -251.1605033162797, -251.1605045104741, -251.1605028146039, -251.1605087918344, -251.1604995368247, -251.1605082902652, -251.1604990350424, -251.1605044186719, -251.1605039097808, 
  -251.1605039169929, -251.1605034081084, -251.1604978140114, -251.1605105147534, -251.160497312337, -251.1605100130763, -251.160509732969, -251.1604985954276, -251.1605092312808, -251.1604980937643, -251.1605102190662, -251.1604981093216, -251.1605097173905, -251.1604976076459, -251.160517742992, -251.1604905852812, -251.1605172413163, -251.1604900836054, -251.1605039070271, -251.1605038865869, -251.1605039401582, -251.160503919718, -251.1605038788364, -251.1605039147782, -251.1605039119675, -251.1605039479092, -251.1605047070586, -251.160503086556, -251.1605047401897, -251.1605031196871, -251.1605038981491, -251.1605038954649, -251.1605039312802, -251.160503928596, -251.1605055648729, -251.1605022287655, -251.160505598004, -251.1605022618967, -251.160504076737, -251.1605037168777, 
  -251.1605041098681, -251.1605037500089, -251.1605047447446, -251.1605030488744, -251.1605047778757, -251.1605030820055, -251.1605085244814, -251.1604992693672, -251.1605085576146, -251.1604993024963, -251.1605041512635, -251.1605036423788, -251.1605041843977, -251.1605036755069, -251.1604975466068, -251.1605102473475, -251.160497579738, -251.1605102804785, -251.1605094655577, -251.1604983280284, -251.1605094986884, -251.1604983611599, -251.160509951661, -251.1604978419164, -251.160509984792, -251.1604978750476, -251.1605174755867, -251.160490317876, -251.1605175087179, -251.1604903510071, -251.160503905622, -251.1605039415638, -251.1605038851819, -251.1605039211236, -251.1605047338443, -251.1605031133416, -251.1605047134041, -251.1605030929014, -251.1605039249347, -251.1605039222505, 
  -251.1605039044945, -251.1605039018103, -251.1605055916585, -251.1605022555512, -251.1605055712184, -251.160502235111, -251.1605041035226, -251.1605037436634, -251.1605040830824}
 {-154.7125383941416, -154.7125343281942, -154.7125337662328, -154.7125430220862, -154.7125424601186, -154.7125340905631, -154.7125340038638, -154.7125427844526, -154.7125426977522, -154.712534944233, -154.7125331502, -154.712543638121, -154.71254184409, -154.7125349541761, -154.7125331402548, -154.7125436480654, -154.7125418341435, -154.7125340287942, -154.7125340656327, -154.7125427226831, -154.7125427595217, -154.7125403278757, -154.7125277667737, -154.71254902176, -154.7125364606673, -154.7125332989077, -154.7125347955243, -154.7125419927969, -154.7125434894131, -154.712535416648, -154.7125326777888, -154.712544110537, -154.7125413716778, -154.7125553318127, -154.7125127630401, -154.7125640261773, -154.7125214564535, -154.7125309183031, -154.7125371761749, -154.7125396121788, 
  -154.7125458700771, -154.7125241590396, -154.7125439359585, -154.7125328529343, -154.7125526298418, -154.7125342889063, -154.7125338055894, -154.7125429826565, -154.7125424996171, -154.7125393174261, -154.7125287769787, -154.7125480113152, -154.7125374708675, -154.7125467370524, -154.7125213572644, -154.7125554309418, -154.712530051153, -154.7125387184739, -154.7125386317739, -154.7125381565093, -154.7125380698095, -154.7125395721429, -154.712537778111, -154.7125390101785, -154.7125372161464, -154.7125395820869, -154.712537768165, -154.712539020122, -154.7125372062007, -154.7125386567046, -154.7125386935432, -154.7125380947401, -154.7125381315787, -154.7125449557839, -154.7125323946864, -154.7125443938193, -154.712531832722, -154.7125379268184, -154.7125394234345, -154.7125373648537, 
  -154.7125388614703, -154.7125400445585, -154.7125373056993, -154.712539482594, -154.7125367437348, -154.7125599599665, -154.7125173907072, -154.712559397991, -154.7125168287537, -154.7125355461995, -154.7125418040994, -154.7125349842499, -154.71254124212, -154.7125287869529, -154.7125485638662, -154.7125282249884, -154.7125480019016, -154.7125389167441, -154.7125384335726, -154.7125383547862, -154.7125378716014, -154.7125439453367, -154.7125334048891, -154.7125433833721, -154.7125328429246, -154.712551364963, -154.7125259851748, -154.7125508029987, -154.71252542321, -154.7125393345106, -154.7125375404786, -154.7125392478108, -154.7125374537787, -154.7125393444544, -154.7125375305328, -154.7125392577545, -154.7125374438329, -154.7125384190722, -154.7125384559108, -154.7125383323724, 
  -154.712538369211, -154.7125447181513, -154.7125321570543, -154.7125446314518, -154.7125320703541, -154.712537689186, -154.7125391858023, -154.712537602486}
 {-494.5711579935268, -494.571183981192, -494.5711849590184, -494.5711310281913, -494.5711320060553, -494.571184336431, -494.5711846037742, -494.5711313834472, -494.5711316507942, -494.5711818584935, -494.5711870817237, -494.5711289055195, -494.5711341287341, -494.571197342606, -494.5711715977563, -494.5711443896168, -494.5711186447818, -494.5711842424817, -494.5711846977236, -494.5711312894999, -494.5711317447417, -494.5711643775796, -494.5712045627753, -494.5711114246744, -494.5711516097171, -494.5711728343179, -494.571196105965, -494.5711198813354, -494.5711431529838, -494.5711757573195, -494.5711931830556, -494.5711228043391, -494.5711402300722, -494.5711022971081, -494.5712666565354, -494.5710493421119, -494.5712137055681, -494.5711167596374, -494.5712521820597, -494.5710638066849, 
  -494.5711992290486, -494.5710718068996, -494.5712971431526, -494.5710188538909, -494.5712441901977, -494.5712498596315, -494.5711190802649, -494.5711969065274, -494.5710661274056, -494.571228259789, -494.5711406805068, -494.5711753067948, -494.5710877275372, -494.5711769216738, -494.5711920241076, -494.5711239686831, -494.5711390711344, -494.5711573709346, -494.5711576382791, -494.5711583487794, -494.5711586161249, -494.5711548930059, -494.57116011622, -494.5711558708429, -494.5711610940732, -494.5711703771072, -494.571144632264, -494.5711713549514, -494.5711456101099, -494.5711572769861, -494.571157732228, -494.5711582548311, -494.571158710073, -494.5711374121201, -494.5711775972436, -494.5711383899694, -494.5711785750845, -494.5711458688197, -494.5711691404718, -494.571146846669, 
  -494.5711701183127, -494.5711487918244, -494.5711662175594, -494.5711497696699, -494.5711671954039, -494.5710753307885, -494.5712396918637, -494.5710763082671, -494.5712406700754, -494.5710897941735, -494.571225216532, -494.5710907719844, -494.5712261944117, -494.5710448413953, -494.5712701776656, -494.5710458192309, -494.5712711555204, -494.5712228940828, -494.5710921148222, -494.5712238719115, -494.5710930926838, -494.5712012942924, -494.5711137150119, -494.571202272127, -494.5711146928676, -494.5711499561756, -494.5711650586142, -494.5711509340168, -494.5711660364633, -494.5711552482491, -494.5711604714715, -494.5711555155942, -494.5711607388167, -494.5711707323541, -494.5711449875115, -494.571170999699, -494.5711452548569, -494.5711576322334, -494.5711580874753, -494.5711578995785, 
  -494.5711583548202, -494.5711377673743, -494.5711779524841, -494.5711380347101, -494.5711782198385, -494.5711462240692, -494.571169495717, -494.5711464914142}
 {-33.92544678633632, -33.92545210772715, -33.92545325160595, -33.925440321096, -33.92544146499825, -33.92545266763524, -33.92545269169536, -33.92544088101572, -33.92544090507604, -33.92545008091957, -33.92545527841257, -33.92543829432367, -33.92544349176961, -33.92545006016176, -33.92545529922246, -33.92543827354054, -33.92544351260482, -33.9254526450924, -33.92545271423818, -33.92544085847311, -33.92544092761862, -33.92545617686957, -33.92544918258209, -33.9254443902403, -33.92543739597251, -33.92545494235407, -33.92545041705143, -33.9254431557349, -33.92543863043174, -33.92545954776065, -33.92544581162845, -33.92544776114109, -33.92543402500915, -33.92548000682898, -33.9254253560814, -33.92546822101206, -33.92541356865954, -33.92548341554086, -33.92542194419054, -33.92547162891083, 
  -33.92541015758171, -33.92543070823395, -33.92547465406937, -33.9254189216289, -33.92546286743556, -33.92547484250262, -33.92543051671852, -33.92546305582594, -33.92541873015634, -33.92546040032097, -33.92544495916625, -33.92544861369053, -33.92543317255783, -33.92549818953938, -33.92540716959068, -33.92548640291952, -33.92539538297168, -33.92544620236226, -33.92544622642241, -33.92544734625271, -33.925447370313, -33.92544361565867, -33.92544881312753, -33.92544475954858, -33.92544995701866, -33.92544359488721, -33.92544883395106, -33.92544473877909, -33.92544997784023, -33.92544617981949, -33.92544624896516, -33.92544732371004, -33.92544739285565, -33.92544971159382, -33.9254427173119, -33.92545085548006, -33.9254438612067, -33.92544847708128, -33.92544395177828, -33.9254496209717, 
  -33.9254450956689, -33.92545308248767, -33.92543934635549, -33.92545422637808, -33.92544049024612, -33.92547354187747, -33.92541889048701, -33.92547468592758, -33.92542003421793, -33.92547695025764, -33.92541547892782, -33.92547809415805, -33.92541662280845, -33.92542424296624, -33.92546818879114, -33.92542538686061, -33.92546933267782, -33.92546837720854, -33.92542405146666, -33.92546952108403, -33.9254251953722, -33.92545393504418, -33.9254384938971, -33.92545507893133, -33.92543963779099, -33.92549172426594, -33.92540070431818, -33.92549286815698, -33.92540184820818, -33.92544417557223, -33.92544937304176, -33.92544419963252, -33.9254493971019, -33.92544415480177, -33.9254493938643, -33.92544417886203, -33.92544941792449, -33.9254467397334, -33.92544680887905, -33.92544676379364, 
  -33.92544683293926, -33.92545027150645, -33.92544327722708, -33.92545029556494, -33.92544330128903, -33.92544903699498, -33.92544451169238, -33.9254490610555}
 {-7.736757725477674, -7.736757443805629, -7.736757630077413, -7.736757820875091, -7.736758007145355, -7.736757530714891, -7.736757543168166, -7.736757907783637, -7.736757920236826, -7.736756903449731, -7.736758170427006, -7.736757280529672, -7.736758547484463, -7.736751751916588, -7.736763321977967, -7.736752128986656, -7.736763699045304, -7.736757359547561, -7.736757714335486, -7.736757736616283, -7.736758091404171, -7.736754120784111, -7.736760953003746, -7.736754497895693, -7.736761330029567, -7.736748258701659, -7.736766815214495, -7.73674863577022, -7.736767192283341, -7.736752623592014, -7.736762450310018, -7.736753000660616, -7.736762827378818, -7.736757523035415, -7.736757550847643, -7.736757900104942, -7.73675792791552, -7.736775813768286, -7.736739260264685, -7.736776190840742, 
  -7.736739637329637, -7.736805470065124, -7.736709604759821, -7.736805847138716, -7.736709981823629, -7.736757417102586, -7.736757656779763, -7.736757794173324, -7.736758033846429, -7.736747048404385, -7.736768025739874, -7.736747425468457, -7.736768402813202, -7.73673623756577, -7.736778837769953, -7.736736614627374, -7.736779214845752, -7.736757626115534, -7.736757638568769, -7.73675781238656, -7.736757824839793, -7.73675699885442, -7.736758265823565, -7.736757185128556, -7.736758452091476, -7.736751847317518, -7.736763417378287, -7.7367520335893, -7.736763603648558, -7.7367574549482, -7.736757809736099, -7.736757641219219, -7.736757996007131, -7.736754216195658, -7.736761048393452, -7.73675440248772, -7.736761234643437, -7.736748354102139, -7.736766910615267, -7.736748540373312, 
  -7.736767096886143, -7.736752718992657, -7.736762545710623, -7.736752905263544, -7.736762731981783, -7.736757618436436, -7.736757646247875, -7.736757804707488, -7.736757832518865, -7.736775909169551, -7.736739355664671, -7.736776095443051, -7.736739541933223, -7.73680556546702, -7.73670970015917, -7.736805751740392, -7.73670988642785, -7.736757512504231, -7.736757752179368, -7.736757698775249, -7.736757938450395, -7.736747143803437, -7.73676812114207, -7.736747330072975, -7.736768307414576, -7.736736332964566, -7.736778933172409, -7.73673651923215, -7.736779119446868, -7.736757085764755, -7.736758352731034, -7.736757098218237, -7.736758365184019, -7.736751934226802, -7.73676350428681, -7.736751946680032, -7.736763516740051, -7.7367575418571, -7.736757896645007, -7.736757554310335, 
  -7.736757909098238, -7.736754303114535, -7.73676113529238, -7.736754315568862, -7.736761147744521, -7.736748441011096, -7.736766997524117, -7.736748453464372}
 {-541.0134318039983, -541.0134188281197, -541.0134167703132, -541.0134468377531, -541.0134447799402, -541.0134175246484, -541.0134180737843, -541.013445534277, -541.013446083416, -541.0134217891196, -541.0134138093402, -541.0134497987213, -541.0134418189989, -541.0134281017354, -541.0134074967909, -541.0134561113646, -541.0134355064218, -541.0134178827162, -541.0134177157164, -541.0134458923462, -541.013445725347, -541.0133833742682, -541.013452224653, -541.013411384065, -541.0134802341166, -541.0134190771783, -541.0134165212868, -541.0134470868085, -541.013444530917, -541.0134212317113, -541.0134143668061, -541.013449241345, -541.0134423764329, -541.0131807704031, -541.0136548354916, -541.0132087761737, -541.0136828489813, -541.0134525680169, -541.0133830312423, -541.0134805776671, 
  -541.0134110408527, -541.0133059439509, -541.0135296591837, -541.0133339535408, -541.0135576688544, -541.0134055356804, -541.0134300634068, -541.013433544552, -541.0134580737956, -541.0134397020927, -541.0133958963727, -541.013467711728, -541.0134239059979, -541.0134395150656, -541.0133960847388, -541.0134675246733, -541.0134240943917, -541.0134325583345, -541.0134331074719, -541.0134305005248, -541.0134310496622, -541.0134368227917, -541.0134288430418, -541.0134347649828, -541.0134267852313, -541.0134431354257, -541.0134225304743, -541.013441077608, -541.0134204726724, -541.013432916403, -541.0134327494035, -541.0134308585934, -541.0134306915937, -541.0133984080383, -541.0134672582565, -541.0133963502285, -541.0134652004469, -541.0134341108593, -541.0134315549795, -541.0134320530612, 
  -541.013429497158, -541.0134362653999, -541.0134294004913, -541.0134342075903, -541.0134273426813, -541.0131958021653, -541.0136698711026, -541.0131937443451, -541.0136678133038, -541.0134676017701, -541.0133980648629, -541.0134655438476, -541.013396007166, -541.0133209776239, -541.0135446928845, -541.0133189198016, -541.0135426350873, -541.0134205689813, -541.0134450974793, -541.0134185111847, -541.0134430396567, -541.013454735779, -541.01341093006, -541.0134526779755, -541.0134088722443, -541.0134545487466, -541.0134111184318, -541.0134524909266, -541.0134090606324, -541.0134355193184, -541.0134275395677, -541.0134360684561, -541.0134280887052, -541.0134418319482, -541.0134212270045, -541.0134423810855, -541.0134217761421, -541.0134316129295, -541.0134314459297, -541.0134321620668, 
  -541.0134319950673, -541.0133971045623, -541.0134659547854, -541.0133976537046, -541.0134665039179, -541.0134328073919, -541.0134302514997, -541.0134333565286}
 {-300.8670911577644, -300.8670914257526, -300.8670921027589, -300.8670902127752, -300.8670908897888, -300.8670917951119, -300.8670917333993, -300.8670905821381, -300.8670905204255, -300.8670911090823, -300.8670924194304, -300.8670898961086, -300.8670912064565, -300.8670919999999, -300.8670915285252, -300.8670907870261, -300.8670903155514, -300.8670917708853, -300.8670917576257, -300.8670905579117, -300.867090544652, -300.8670908307771, -300.8670926977664, -300.867089617802, -300.8670914847939, -300.8670923541354, -300.8670911743903, -300.8670911411618, -300.8670899614165, -300.8671009574528, -300.8670825711029, -300.867099744479, -300.8670813581291, -300.8671048290611, -300.8670787001228, -300.8671036163982, -300.8670774868382, -300.8670962052546, -300.8670873233378, -300.8670949922723, 
  -300.8670861103727, -300.8670849450548, -300.8670985844434, -300.8670837320845, -300.8670973714663, -300.8671138501579, -300.8670696782453, -300.8671126371486, -300.8670684653071, -300.8671127981671, -300.8670707302547, -300.8671115851933, -300.867069517281, -300.8665893689545, -300.8675941848113, -300.8665881559808, -300.8675929718375, -300.8670908501159, -300.8670907884032, -300.8670915271259, -300.8670914654133, -300.8670901640863, -300.8670914744343, -300.8670908410964, -300.8670921514443, -300.8670910550038, -300.8670905835292, -300.867091732014, -300.8670912605391, -300.8670908258893, -300.8670908126297, -300.8670915028994, -300.8670914896398, -300.8670898857805, -300.867091752771, -300.8670905627903, -300.8670924297813, -300.8670914091396, -300.8670902293942, -300.8670920861495, 
  -300.8670909064044, -300.8671000124568, -300.8670816261069, -300.8671006894668, -300.8670823031169, -300.8671038842037, -300.8670777549883, -300.8671045612474, -300.8670784319646, -300.8670952602503, -300.8670863783503, -300.8670959372685, -300.8670870553522, -300.8670840000601, -300.8670976394462, -300.867084677071, -300.8670983164554, -300.8671129051483, -300.8670687332629, -300.8671135821501, -300.8670694102813, -300.8671118531713, -300.8670697852586, -300.8671125301811, -300.8670704622689, -300.8665884239585, -300.8675932398153, -300.8665891009686, -300.8675939168252, -300.8670905334474, -300.8670918437955, -300.8670904717349, -300.8670917820828, -300.867091424365, -300.8670909528902, -300.8670913626525, -300.8670908911776, -300.8670911952506, -300.8670911819908, -300.8670911335379, 
  -300.8670911202782, -300.8670902551419, -300.8670921221319, -300.8670901934285, -300.8670920604199, -300.8670917785006, -300.8670905987555, -300.867091716788}
 {-317.4210456389557, -317.4210494418532, -317.4210497596071, -317.421041518328, -317.4210418360867, -317.4210495399888, -317.4210496614709, -317.4210416164654, -317.4210417379485, -317.4210493050835, -317.4210498963785, -317.4210413815605, -317.4210419728557, -317.4210529136587, -317.4210462878238, -317.4210449901351, -317.4210383643016, -317.4210495186599, -317.4210496827999, -317.421041595137, -317.4210417592771, -317.4210430616065, -317.4210561398573, -317.4210351381033, -317.4210482163148, -317.4210458089056, -317.4210533925588, -317.4210378853823, -317.4210454690362, -317.4210465145657, -317.4210526869277, -317.421038591043, -317.4210447634045, -317.4210322383859, -317.4210669650463, -317.4210243144876, -317.4210590418988, -317.4210445312007, -317.4210546704809, -317.4210366076827, 
  -317.4210467469531, -317.4209925274548, -317.4211066757137, -317.420984603928, -317.4210987521947, -317.4210602411728, -317.42103896024, -317.4210523176286, -317.4210310367386, -317.4210597137377, -317.4210394876843, -317.4210517902136, -317.4210315641627, -317.4210405309747, -317.4210586718524, -317.4210326074497, -317.4210507483317, -317.4210454193367, -317.4210455408191, -317.4210457370928, -317.4210458585756, -317.4210451844322, -317.4210457757259, -317.4210455021872, -317.4210460934835, -317.4210487930061, -317.4210421671725, -317.421049110763, -317.4210424849282, -317.4210453980079, -317.421045562148, -317.4210457157641, -317.4210458799042, -317.4210389409633, -317.4210520191966, -317.4210392587218, -317.4210523369506, -317.4210416882525, -317.4210492719079, -317.4210420060105, 
  -317.4210495896623, -317.4210423939137, -317.4210485662757, -317.4210427116701, -317.4210488840317, -317.4210281175701, -317.4210628445581, -317.4210284352786, -317.4210631623621, -317.4210404105559, -317.4210505498217, -317.4210407283028, -317.4210508675873, -317.4209884068018, -317.4211025550628, -317.4209887245563, -317.4211028728209, -317.4210561205124, -317.4210348395965, -317.4210564382641, -317.4210351573573, -317.4210555930856, -317.4210353670325, -317.4210559108409, -317.4210356847897, -317.4210364103226, -317.4210545512007, -317.4210367280771, -317.4210548689587, -317.421045282568, -317.4210458738632, -317.4210454040507, -317.4210459953457, -317.421048891143, -317.4210422653088, -317.4210490126255, -317.4210423867914, -317.4210454961444, -317.4210456602845, -317.421045617627, 
  -317.4210457817671, -317.4210390391016, -317.4210521173313, -317.4210391605828, -317.4210522388153, -317.42104178639, -317.4210493700435, -317.4210419078725}
 {-23.55312938525252, -23.55314431450256, -23.55314367674116, -23.55311509387609, -23.55311445612918, -23.55314406243289, -23.55314392881088, -23.5531148418128, -23.55311470819253, -23.55314666793508, -23.5531413233166, -23.55311744729559, -23.55311210271765, -23.55315002147666, -23.55313796979409, -23.55312080085408, -23.55310874917823, -23.55314405546977, -23.55314393577403, -23.5531148348504, -23.55311471515495, -23.55314234555084, -23.5531456457012, -23.5531131249536, -23.55311642505999, -23.5531446343761, -23.55314335687253, -23.55311541375775, -23.55311413625244, -23.55314704748169, -23.55314094377729, -23.55311782686377, -23.55311172315678, -23.55309818521558, -23.55318980769365, -23.55306896443975, -23.55316058723107, -23.55313946859171, -23.55314852284693, -23.55311024795827, 
  -23.55311930224193, -23.553147085505, -23.55314090701787, -23.55311786489021, -23.55311168639421, -23.55315481633447, -23.55313317500398, -23.5531255959452, -23.5531039541548, -23.55316104078438, -23.55312695044256, -23.553131820171, -23.5530977298175, -23.55315591977324, -23.55313207187468, -23.55312669915338, -23.5531028512561, -23.55312977094013, -23.55312963731901, -23.55312913318598, -23.55312899956483, -23.55313237643673, -23.5531270318303, -23.55313173867436, -23.55312639408436, -23.55313572998372, -23.55312367830237, -23.55313509222742, -23.55312304055037, -23.5531297639774, -23.55312964428175, -23.55312912622318, -23.55312900652765, -23.55312805406856, -23.55313135419881, -23.55312741631629, -23.55313071644278, -23.55313034288446, -23.55312906537952, -23.55312970512981, 
  -23.55312842762586, -23.55313275599005, -23.55312665228429, -23.55313211823582, -23.5531260145302, -23.5530838936496, -23.553175516275, -23.55308325588614, -23.55317487853015, -23.55312517710593, -23.55313423134806, -23.55312453932446, -23.55313359362121, -23.55313279401503, -23.55312661552318, -23.55313215626059, -23.55312597776931, -23.55314052495447, -23.55311888339933, -23.55313988720561, -23.55311824563986, -23.55314674929446, -23.55311265894783, -23.55314611154134, -23.55311202119263, -23.55314162828047, -23.5531177803828, -23.55314099052657, -23.55311714262839, -23.55313212436626, -23.55312677976781, -23.55313199074489, -23.55312664614691, -23.55313547791621, -23.55312342623693, -23.553135344295, -23.55312329261587, -23.55312951191088, -23.55312939221531, -23.55312937828976, 
  -23.55312925859415, -23.55312780200757, -23.55313110212685, -23.55312766837734, -23.55313096851481, -23.55313009081824, -23.55312881331278, -23.55312995719609}
 {-381.691603401983, -381.6916081053509, -381.6916055364805, -381.6916012675231, -381.6915986986468, -381.6916068382935, -381.6916068035364, -381.6916000004626, -381.6915999657058, -381.6916096484952, -381.6916039933334, -381.691602810643, -381.691597155524, -381.6915970958787, -381.6916165460047, -381.6915902580471, -381.6916097081747, -381.6916067892758, -381.6916068525542, -381.6915999514448, -381.6916000147235, -381.6916068288371, -381.6916068131091, -381.6915999910031, -381.6915999752815, -381.6916052889259, -381.6916083530042, -381.6915984510967, -381.6916015151719, -381.6916130151046, -381.6916006267812, -381.6916061772742, -381.69159378895, -381.6915450455634, -381.6916685989741, -381.6915382071135, -381.6916617617626, -381.6916514222829, -381.6915622199262, -381.6916445844537, 
  -381.6915553820939, -381.6916161770128, -381.6915974675259, -381.6916093391721, -381.691590629705, -381.6916119717924, -381.6916016700888, -381.6916051338934, -381.6915948323263, -381.6915945875779, -381.6916190546952, -381.6915877497535, -381.691612216858, -381.6916396136706, -381.691574028071, -381.6916327758404, -381.6915671902397, -381.691604703799, -381.691604669042, -381.6916021349256, -381.6916021001687, -381.69160751399, -381.6916018588496, -381.6916049451166, -381.6915992899764, -381.6915949613896, -381.6916144115048, -381.6915923925047, -381.691611842643, -381.6916046547813, -381.6916047180597, -381.6916020859079, -381.6916021491865, -381.6916046943389, -381.6916046786182, -381.6916021254697, -381.6916021097408, -381.6916031544316, -381.6916062185095, -381.6916005855595, 
  -381.6916036496352, -381.6916108806102, -381.6915984922865, -381.6916083117371, -381.6915959234132, -381.6915429107047, -381.6916664648439, -381.6915403419408, -381.6916638958612, -381.6916492878009, -381.6915600854192, -381.6916467189041, -381.6915575165694, -381.6916140425138, -381.6915953330358, -381.6916114736396, -381.6915927641635, -381.6916098372489, -381.6915995356433, -381.6916072684053, -381.6915969667402, -381.6915924530876, -381.6916169201964, -381.6915898842121, -381.6916143513252, -381.6916374791768, -381.6915718935757, -381.6916349103026, -381.6915693247034, -381.6916062469311, -381.6916005917907, -381.6916062121741, -381.6916005570337, -381.691593694325, -381.6916131444516, -381.6915936595678, -381.6916131096948, -381.6916033877224, -381.6916034510008, 
  -381.6916033529653, -381.6916034162439, -381.6916034272833, -381.691603411556, -381.6916033925239, -381.6916033768015, -381.6916018873736, -381.6916049514496, -381.6916018526159}
 {-302.1898325505483, -302.1898369334891, -302.1898366430794, -302.1898284580352, -302.189828167629, -302.1898368088249, -302.189836767743, -302.1898283333733, -302.1898282922903, -302.1898363169856, -302.1898372595838, -302.1898278415329, -302.1898287841322, -302.1898371273195, -302.1898364492758, -302.1898286518672, -302.189827973824, -302.1898369713967, -302.1898366051713, -302.1898284959446, -302.1898281297191, -302.1898422756629, -302.1898313008767, -302.1898338001884, -302.1898228254469, -302.1898385966862, -302.1898349798873, -302.1898301212344, -302.1898265044348, -302.1898329713475, -302.1898406052581, -302.1898244958948, -302.1898321298065, -302.1898461898147, -302.1898273885099, -302.1898377145698, -302.1898189128505, -302.1898520971086, -302.1898214796594, -302.1898436216527, 
  -302.189813004211, -302.1897763017709, -302.1898972764189, -302.1897678263222, -302.1898888009634, -302.1898481200954, -302.1898254564133, -302.1898396446344, -302.18981698097, -302.1898362456983, -302.1898373310271, -302.1898277702457, -302.1898288555755, -302.1898220484396, -302.1898515297577, -302.1898135729903, -302.1898430543028, -302.1898327162938, -302.1898326752114, -302.1898324258859, -302.1898323848034, -302.1898322244547, -302.189833167052, -302.1898319340453, -302.1898328766455, -302.1898330347886, -302.1898323567441, -302.1898327443797, -302.1898320663372, -302.1898328788653, -302.1898325126399, -302.1898325884574, -302.1898322222319, -302.189838183119, -302.1898272083578, -302.1898378927138, -302.1898269179472, -302.1898345041556, -302.1898308873552, -302.1898342137464, 
  -302.1898305969485, -302.1898288788159, -302.189836512727, -302.1898285884078, -302.1898362223191, -302.1898420973758, -302.189823295886, -302.1898418069902, -302.1898230054558, -302.1898480045739, -302.1898173871313, -302.1898477141687, -302.1898170967206, -302.1897722092409, -302.1898931838862, -302.1897719188336, -302.1898928934776, -302.1898440275582, -302.1898213638878, -302.1898437371531, -302.189821073477, -302.1898321531675, -302.1898332384952, -302.189831862758, -302.1898329480889, -302.1898179559093, -302.1898474372252, -302.1898176655021, -302.1898471468166, -302.1898320997909, -302.1898330423896, -302.1898320587083, -302.1898330013072, -302.189832910125, -302.1898322320816, -302.1898328690425, -302.1898321909991, -302.1898327542023, -302.1898323879769, -302.1898327131198, 
  -302.1898323468944, -302.1898380584584, -302.1898270836923, -302.1898380173737, -302.1898270426122, -302.1898343794921, -302.1898307626927, -302.1898343384094}
 {-437.7239498091965, -437.7239504623494, -437.7239506553396, -437.7239489630584, -437.7239491560513, -437.7239505131177, -437.723950604571, -437.7239490138274, -437.7239491052821, -437.7239503088062, -437.7239508088836, -437.7239488095167, -437.7239493095937, -437.7239515721377, -437.7239495455563, -437.723950072848, -437.7239480462668, -437.7239505153591, -437.7239506023296, -437.7239490160695, -437.7239491030401, -437.7239364664324, -437.723964651237, -437.7239349671541, -437.7239631519361, -437.7239449209462, -437.7239561967348, -437.723943421656, -437.7239546974456, -437.7239325967331, -437.7239685209894, -437.7239310974436, -437.7239670216996, -437.7239476491433, -437.7239534690018, -437.7239461496812, -437.7239519698848, -437.7239525614629, -437.7239485562806, -437.7239510621781, 
  -437.723947056986, -437.7238852456713, -437.72401587262, -437.7238837463795, -437.7240143733324, -437.7239559632185, -437.7239451544453, -437.7239544639125, -437.723943655172, -437.723956077251, -437.7239450404092, -437.723954577961, -437.72394354112, -437.7238574489787, -437.7240436735041, -437.7238559496881, -437.7240421742155, -437.7239496669738, -437.7239497584277, -437.7239498599653, -437.7239499514195, -437.7239494626627, -437.7239499627398, -437.7239496556543, -437.7239501557314, -437.7239507259939, -437.7239486994128, -437.7239509189856, -437.7239488924043, -437.7239496692154, -437.7239497561861, -437.723949862207, -437.7239499491777, -437.723935620294, -437.7239638050883, -437.7239358132865, -437.723963998079, -437.7239440748021, -437.7239553505915, -437.7239442677942, 
  -437.7239555435827, -437.7239317505895, -437.7239676748456, -437.7239319435811, -437.7239678678372, -437.7239468029203, -437.7239526229376, -437.7239469958981, -437.723952815943, -437.7239517153237, -437.7239477101325, -437.7239519083112, -437.7239479031283, -437.7238843995268, -437.7240150264773, -437.723884592518, -437.7240152194693, -437.7239551170678, -437.7239443083086, -437.7239553100571, -437.7239445013027, -437.7239552311072, -437.7239441942658, -437.7239554240989, -437.7239443872574, -437.7238566028348, -437.7240428273607, -437.7238567958259, -437.7240430203528, -437.7239495134314, -437.7239500135086, -437.7239496048854, -437.7239501049626, -437.7239507767627, -437.7239487501815, -437.7239508682168, -437.7239488416356, -437.7239497199842, -437.7239498069548, -437.7239498114382, 
  -437.7239498984089, -437.7239356710635, -437.7239638558562, -437.723935762517, -437.7239639473109, -437.723944125571, -437.7239554013601, -437.7239442170251}
 {-280.133224821045, -280.1332252909586, -280.1332241329697, -280.1332255091325, -280.1332243511343, -280.1332247652175, -280.1332246587098, -280.1332249833873, -280.1332248768786, -280.1332257471732, -280.1332236767551, -280.1332259653417, -280.1332238949252, -280.1332205287199, -280.1332288952368, -280.1332207468896, -280.1332291134057, -280.1332246014529, -280.1332248224744, -280.1332248196222, -280.1332250406436, -280.1332334720374, -280.1332159519216, -280.1332336902, -280.1332161700976, -280.1332151783965, -280.133234245576, -280.1332153965661, -280.133234463745, -280.133220139273, -280.1332292846747, -280.1332203574423, -280.133229502844, -280.1332394770535, -280.1332099472689, -280.1332396954516, -280.1332101652093, -280.133219245401, -280.1332301785737, -280.133219463565, 
  -280.1332303967484, -280.1331917066754, -280.1332577177898, -280.133191924847, -280.1332579359568, -280.1332287693023, -280.1332206546245, -280.1332289874374, -280.133220872828, -280.1332247909266, -280.1332246330728, -280.1332250090963, -280.1332248512417, -280.1332093349675, -280.1332400901514, -280.1332095531375, -280.13324030832, -280.1332254532964, -280.1332253467881, -280.1332242953027, -280.1332241887947, -280.1332264352514, -280.1332243648341, -280.1332252772579, -280.1332232068405, -280.133221216799, -280.133229583315, -280.1332200588049, -280.133228425322, -280.1332252895315, -280.133225510553, -280.133224131538, -280.1332243525594, -280.1332341601121, -280.1332166400041, -280.1332330021196, -280.1332154820095, -280.1332158664755, -280.1332349336543, -280.1332147084814, 
  -280.1332337756612, -280.1332208273516, -280.1332299727533, -280.1332196693581, -280.1332288147596, -280.1332401652662, -280.1332106352133, -280.1332390072331, -280.1332094772592, -280.1332199334718, -280.1332308666601, -280.1332187754885, -280.1332297086562, -280.1331923947555, -280.1332584058669, -280.1331912367612, -280.133257247874, -280.1332294573568, -280.1332213427273, -280.1332282993772, -280.1332201847196, -280.1332254790055, -280.133225321151, -280.1332243210116, -280.1332241631578, -280.1332100230463, -280.1332407782298, -280.133208865053, -280.1332396202359, -280.1332259095082, -280.1332238390909, -280.133225803, -280.1332237325827, -280.1332206910555, -280.133229057572, -280.1332205845473, -280.1332289510639, -280.1332247637883, -280.1332249848098, -280.1332246572802, 
  -280.1332248783016, -280.1332336343695, -280.1332161142603, -280.1332335278612, -280.1332160077522, -280.1332153407321, -280.1332344079112, -280.1332152342238}
 {-407.5075776337282, -407.5075762867474, -407.5075748782207, -407.5075803892551, -407.5075789807203, -407.5075755032877, -407.5075756616799, -407.5075796057908, -407.5075797641843, -407.5075765378491, -407.5075746271214, -407.507580640352, -407.5075787296259, -407.5075761716811, -407.5075749932989, -407.5075802741853, -407.507579095802, -407.5075756411655, -407.5075755238023, -407.5075797436692, -407.507579626306, -407.5075573460195, -407.5075938190283, -407.5075614485386, -407.5075979215166, -407.5075829337655, -407.5075682312127, -407.5075870362684, -407.507572333717, -407.5075717008537, -407.5075794641335, -407.5075758033575, -407.507583566637, -407.507545631431, -407.5076055342578, -407.5075497333609, -407.5076096373353, -407.507586171605, -407.5075649934492, -407.5075902741194, 
  -407.5075690959422, -407.5075165964144, -407.5076345695253, -407.5075206989133, -407.5076386720337, -407.5075789960007, -407.5075721690515, -407.5075830983996, -407.5075762716599, -407.5075854172711, -407.5075657476636, -407.5075895197747, -407.5075698501673, -407.5075511010028, -407.5076000660566, -407.507555203505, -407.5076041685618, -407.5075782587972, -407.5075784171903, -407.5075768502666, -407.5075770086594, -407.5075792933586, -407.5075773826318, -407.5075778848277, -407.507575974101, -407.5075789271916, -407.5075777488083, -407.5075775186602, -407.5075763402781, -407.5075783966754, -407.5075782793122, -407.5075769881446, -407.5075768707814, -407.5075601015377, -407.5075965745301, -407.5075586930057, -407.5075951660004, -407.5075856892743, -407.5075709867236, -407.5075842807449, 
  -407.5075695781915, -407.5075744563638, -407.5075822196433, -407.507573047833, -407.5075808111126, -407.507548386639, -407.5076082900697, -407.5075469781384, -407.5076068815087, -407.5075889271325, -407.5075677489416, -407.5075875185773, -407.5075663404353, -407.5075193519218, -407.5076373250377, -407.5075179433914, -407.5076359165068, -407.5075817514499, -407.5075749246222, -407.5075803429359, -407.5075735160747, -407.5075881727808, -407.5075685031736, -407.5075867642504, -407.5075670946426, -407.5075538565124, -407.5076028215667, -407.5075524479807, -407.5076014130369, -407.5075785098965, -407.5075765991697, -407.5075786682895, -407.5075767575626, -407.5075781437294, -407.5075769653465, -407.5075783021222, -407.5075771237395, -407.5075776132134, -407.5075774958502, -407.5075777716063, 
  -407.5075776542431, -407.5075593180752, -407.5075957910685, -407.5075594764679, -407.5075959494615, -407.5075849058131, -407.5075702032608, -407.5075850642058}
 {-5.682311298923135, -5.682310969204237, -5.682311006431728, -5.682311591414022, -5.682311628641482, -5.682310987055197, -5.682310988580767, -5.682311609264967, -5.682311610790536, -5.682306818461323, -5.682315157202957, -5.68230744068307, -5.682315779400749, -5.682308019728151, -5.68231395593939, -5.682308641933836, -5.682314578153242, -5.68231093376328, -5.68231104187269, -5.682311555973001, -5.682311664082508, -5.6823063533256, -5.682315623263476, -5.682306975539412, -5.682316245469195, -5.682309963996765, -5.682312011688282, -5.682310586202832, -5.682312633901754, -5.682312921660555, -5.682309053990604, -5.682313543868855, -5.682309676201842, -5.682309777434726, -5.682312198203926, -5.682310399647747, -5.682312820410445, -5.682316428914827, -5.682305546773911, -5.682317051128782, 
  -5.682306168979495, -5.682315341296463, -5.682306634941993, -5.682315963519764, -5.68230725713823, -5.682310991074617, -5.682310984561367, -5.682311613284361, -5.68231160677116, -5.682313235564676, -5.68230874010395, -5.682313857767914, -5.68230936232025, -5.682326045845324, -5.68229592957069, -5.682326668052468, -5.682296551783082, -5.682311279546614, -5.682311281072183, -5.682311316774089, -5.682311318299659, -5.682307110958398, -5.682315449688716, -5.682307148186535, -5.68231548691553, -5.682308312217671, -5.682314248432702, -5.682308349444854, -5.682314285660469, -5.682311226254674, -5.682311334364128, -5.682311263482147, -5.682311371591608, -5.682306645818909, -5.682315915752996, -5.682306683046642, -5.682315952980214, -5.682310256486472, -5.682312304181407, -5.682310293713664, 
  -5.682312341409166, -5.682313214151291, -5.682309346482699, -5.682313251378657, -5.682309383710285, -5.682310069927818, -5.682312490693668, -5.682310107155194, -5.682312527921242, -5.68231672140802, -5.682305839263551, -5.682316758636129, -5.682305876490394, -5.682315633794144, -5.682306927427144, -5.682315671022621, -5.682306964653619, -5.682311283566021, -5.682311277052795, -5.682311320793497, -5.682311314280271, -5.682313528053067, -5.682309032598392, -5.682313565280063, -5.682309069826347, -5.682326338335521, -5.682296222063324, -5.68232637556281, -5.682296259290988, -5.682307128809656, -5.682315467539363, -5.682307130335275, -5.682315469064882, -5.682308330068485, -5.682314266283792, -5.682308331594038, -5.682314267809378, -5.682311244105625, -5.682311352215082, -5.682311245631194, 
  -5.682311353740652, -5.682306663670083, -5.682315933603727, -5.682306665195467, -5.682315935129482, -5.682310274337287, -5.682312322032496, -5.682310275862847}
 {-221.9235248498431, -221.9235225915921, -221.9235223689644, -221.9235273307502, -221.9235271081212, -221.9235224179468, -221.9235225426095, -221.9235271571035, -221.9235272817676, -221.9235189655687, -221.9235259949919, -221.9235237047268, -221.9235307341487, -221.9235189112424, -221.9235260493235, -221.9235236503999, -221.923530788481, -221.9235223481425, -221.9235226124138, -221.9235270872999, -221.9235273515712, -221.9235147764031, -221.9235301843468, -221.9235195155623, -221.9235349235025, -221.9235229667093, -221.9235219938589, -221.9235277058666, -221.9235267330165, -221.9235249660084, -221.9235199945654, -221.9235297051659, -221.9235247337228, -221.923541353188, -221.9235036080724, -221.923546092903, -221.9235083466724, -221.9235343975009, -221.9235105631406, -221.923539136642, 
  -221.9235153023143, -221.9235423279724, -221.923502633605, -221.9235470671364, -221.9235073727559, -221.923535788142, -221.9235091723923, -221.9235405271873, -221.923513911662, -221.9234753846644, -221.9235695769675, -221.9234801238215, -221.9235743161254, -221.9235638186799, -221.9234811413945, -221.9235685578371, -221.9234858805521, -221.9235248988256, -221.923525023489, -221.9235246761973, -221.9235248008607, -221.9235214464485, -221.9235284758706, -221.9235212238197, -221.9235282532427, -221.9235213921217, -221.9235285302027, -221.9235211694933, -221.9235283075744, -221.9235248290217, -221.923525093293, -221.9235246063934, -221.9235248706647, -221.9235172572833, -221.923532665225, -221.9235170346546, -221.923532442597, -221.9235254475883, -221.9235244747382, -221.9235252249601, 
  -221.9235242521098, -221.9235274468877, -221.9235224754446, -221.9235272242593, -221.9235222528163, -221.9235438343478, -221.923506088671, -221.9235436117157, -221.9235058660464, -221.9235368783632, -221.9235130440366, -221.9235366557523, -221.9235128213908, -221.9235448088548, -221.9235051144809, -221.9235445862265, -221.9235048918526, -221.923538268964, -221.9235116533289, -221.923538046338, -221.9235114306981, -221.9234778655433, -221.923572057847, -221.9234776429151, -221.9235718352186, -221.923566299559, -221.9234836222737, -221.9235660769306, -221.9234833996454, -221.9235212728022, -221.9235283022248, -221.9235213974657, -221.9235284268882, -221.9235212184757, -221.9235283565568, -221.9235213431391, -221.9235284812202, -221.9235246553757, -221.923524919647, -221.9235247800391, 
  -221.9235250443104, -221.9235170836371, -221.9235324915792, -221.9235172083006, -221.9235326162425, -221.9235252739424, -221.9235243010921, -221.9235253986057}
 {-392.6238400821377, -392.6238430164231, -392.6238425435097, -392.6238376207848, -392.6238371478717, -392.6238427949117, -392.6238427650207, -392.6238373992736, -392.6238373693825, -392.6238432150832, -392.6238423448498, -392.6238378194411, -392.6238369492157, -392.6238439739426, -392.623841586008, -392.6238385783037, -392.6238361903707, -392.6238427558199, -392.6238428041124, -392.6238373601818, -392.6238374084743, -392.6238439140487, -392.6238416459073, -392.6238385184066, -392.6238362502732, -392.6238414689391, -392.6238440910063, -392.6238360733012, -392.6238386953679, -392.6238447407385, -392.6238408192125, -392.6238393451003, -392.6238354235745, -392.623826505426, -392.6238590559321, -392.6238211096414, -392.6238536604404, -392.6238522553363, -392.6238333047484, -392.6238468596991, 
  -392.6238279091093, -392.6238591654156, -392.6238263954595, -392.6238537697755, -392.6238209998233, -392.6238479074311, -392.6238376524812, -392.6238425117849, -392.6238322568513, -392.6238451250357, -392.6238404349292, -392.6238397293979, -392.6238350392908, -392.6238538826516, -392.6238316772434, -392.6238484870142, -392.6238262816046, -392.6238403335402, -392.6238403036491, -392.6238398606269, -392.6238398307359, -392.6238407537105, -392.6238398834796, -392.6238402807956, -392.6238394105678, -392.6238415125717, -392.6238391246359, -392.6238410396563, -392.6238386517246, -392.6238402944483, -392.6238403427409, -392.6238398215351, -392.6238398698276, -392.6238414526754, -392.6238391845376, -392.6238409797617, -392.6238387116247, -392.6238390075679, -392.6238416296344, 
  -392.6238385346542, -392.6238411567216, -392.6238422793669, -392.623838357841, -392.6238418064536, -392.6238378849278, -392.6238240439664, -392.6238565946486, -392.6238235710828, -392.6238561217057, -392.6238497939681, -392.6238308433735, -392.623849321049, -392.623830370466, -392.6238567040434, -392.6238239340885, -392.6238562311293, -392.6238234611761, -392.623845446053, -392.6238351911162, -392.6238449731447, -392.623834718198, -392.623842663665, -392.6238379735569, -392.6238421907504, -392.6238375006449, -392.6238514212802, -392.6238292158718, -392.6238509483674, -392.6238287429579, -392.6238405321983, -392.6238396619689, -392.6238405023073, -392.6238396320779, -392.6238412910593, -392.6238389031254, -392.6238412611683, -392.6238388732345, -392.623840072937, -392.6238401212295, 
  -392.6238400430459, -392.6238400913386, -392.6238412311643, -392.6238389630259, -392.6238412012723, -392.6238389331361, -392.6238387860564, -392.6238414081232, -392.6238387561652}
 {-158.7599212663827, -158.7599198161518, -158.7599197175023, -158.7599228152826, -158.7599227166316, -158.7599196039161, -158.759919929738, -158.7599226030439, -158.7599229288703, -158.7599211195572, -158.7599184141001, -158.7599241186867, -158.7599214132307, -158.7599204915884, -158.7599190420669, -158.7599234907185, -158.7599220411969, -158.759920004194, -158.7599195294601, -158.759923003324, -158.7599225285903, -158.7599197291213, -158.7599198045327, -158.7599227282521, -158.759922803662, -158.7599197602611, -158.7599197733929, -158.7599227593911, -158.759922772523, -158.7599197353059, -158.759919798348, -158.759922734437, -158.7599227974771, -158.7599307696888, -158.7599087642638, -158.7599337690855, -158.7599117631272, -158.7599148470665, -158.7599246866223, -158.759917846188, 
  -158.759927685761, -158.7599196795067, -158.7599198541475, -158.759922678639, -158.7599228532753, -158.7599238096519, -158.7599157240019, -158.7599268087218, -158.7599187231921, -158.7599224598567, -158.7599170738216, -158.7599254589869, -158.7599200729516, -158.7599197689148, -158.7599197647393, -158.7599227680448, -158.7599227638693, -158.7599211527958, -158.75992147862, -158.7599210541456, -158.7599213799697, -158.7599226684378, -158.7599199629812, -158.7599225697875, -158.759919864331, -158.7599220404693, -158.7599205909477, -158.759921941819, -158.7599204922975, -158.7599215530748, -158.759921078341, -158.7599214544246, -158.7599209796907, -158.7599212780025, -158.7599213534132, -158.7599211793523, -158.7599212547629, -158.7599213091419, -158.7599213222738, -158.7599212104917, 
  -158.7599212236235, -158.7599212841873, -158.7599213472283, -158.759921185537, -158.7599212485781, -158.7599323187042, -158.75991031301, -158.7599322200514, -158.7599102143623, -158.7599163959393, -158.7599262355112, -158.7599162972964, -158.7599261368536, -158.7599212283887, -158.7599214030271, -158.7599211297384, -158.759921304377, -158.7599253585021, -158.7599172729134, -158.759925259853, -158.759917174262, -158.7599240087376, -158.7599186227024, -158.7599239100873, -158.7599185240522, -158.7599213177956, -158.7599213136201, -158.7599212191454, -158.7599212149698, -158.7599224562006, -158.759919750744, -158.7599227820247, -158.7599200765682, -158.7599218282321, -158.7599203787106, -158.7599221540562, -158.7599207045347, -158.7599213408377, -158.7599208661038, -158.7599216666618, 
  -158.759921191928, -158.7599210657651, -158.7599211411763, -158.7599213915897, -158.7599214669999, -158.7599210969048, -158.7599211100366, -158.7599214227289}
:[font = input; preserveAspect; startGroup]
l1=Sum[(likvec)[[i]],{i,384}]
l2=Sum[(likvec)[[i]],{i,384,1,-1}]
l3=Sum[(likvec)[[i]]//Sort,{i,384}]
l4=Sum[(likvec)[[i]]//Sort,{i,384,1,-1}]
:[font = output; inactive; preserveAspect; fontLeading = 0]
 {-105363.40352204577, -105363.4035220211, -105363.4035220084, -105363.40352209605, -105363.40352208471, -105363.40352198498, -105363.4035220442, -105363.40352206062, -105363.40352211992, -105363.40352201246, -105363.40352201977, -105363.40352208736, -105363.40352209595, -105363.40352204074, -105363.40352200021, -105363.40352211599, -105363.40352207625, -105363.40352198492, -105363.40352204445, -105363.40352206022, -105363.40352211993, -105363.40352196994, -105363.40352213237, -105363.4035220465, -105363.40352220726, -105363.4035219931, -105363.40352204641, -105363.40352206859, -105363.4035221218, -105363.40352202885, -105363.40352201209, -105363.40352210435, -105363.4035220876, -105363.40352226184, -105363.40352237906, -105363.40352236644, -105363.40352242568, -105363.40352209155, 

   -105363.40352201644, -105363.40352216584, -105363.40352209352, -105363.40352245887, -105363.40352210037, -105363.4035225359, -105363.4035221745, -105363.4035220564, -105363.40352202897, -105363.40352209407, -105363.4035221423, -105363.40352202006, -105363.40352207834, -105363.40352209538, -105363.4035221542, -105363.40352216981, -105363.40352222367, -105363.40352224521, -105363.4035222996, -105363.40352202245, -105363.40352208156, -105363.4035220104, -105363.40352206962, -105363.40352204962, -105363.40352205715, -105363.40352203744, -105363.40352204554, -105363.40352207815, -105363.40352203776, -105363.4035220659, -105363.40352202604, -105363.40352202211, -105363.40352208175, -105363.40352201025, -105363.40352206986, -105363.40352200772, -105363.4035221694, -105363.40352199576, 

   -105363.4035221575, -105363.40352203033, -105363.40352208356, -105363.40352201846, -105363.4035220716, -105363.40352206613, -105363.40352204932, -105363.40352205432, -105363.40352203752, -105363.40352231397, -105363.40352240155, -105363.40352230148, -105363.40352239025, -105363.40352212824, -105363.40352205448, -105363.40352211644, -105363.40352204248, -105363.40352249684, -105363.40352213707, -105363.40352248512, -105363.40352212501, -105363.40352207504, -105363.40352208505, -105363.4035220625, -105363.40352207373, -105363.40352205737, -105363.40352211572, -105363.40352204534, -105363.40352210395, -105363.40352220704, -105363.40352226113, -105363.40352219516, -105363.40352224917, -105363.40352201367, -105363.40352202156, -105363.40352207291, -105363.40352208084, -105363.40352204231, 

   -105363.40352200209, -105363.40352210142, -105363.40352206127, -105363.40352198642, -105363.40352204596, -105363.40352204576, -105363.40352210529, -105363.40352197201, -105363.40352213354, -105363.40352203119, -105363.40352219307, -105363.40352199475, -105363.40352204793, -105363.403522054}
;[o]
 {-105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., 
  -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363.}
:[font = output; inactive; preserveAspect; fontLeading = 0]
 {-105363.40352204577, -105363.4035220211, -105363.4035220084, -105363.40352209605, -105363.40352208471, -105363.40352198498, -105363.4035220442, -105363.40352206062, -105363.40352211992, -105363.40352201246, -105363.40352201977, -105363.40352208736, -105363.40352209595, -105363.40352204074, -105363.40352200021, -105363.40352211599, -105363.40352207625, -105363.40352198492, -105363.40352204445, -105363.40352206022, -105363.40352211993, -105363.40352196994, -105363.40352213237, -105363.4035220465, -105363.40352220726, -105363.4035219931, -105363.40352204641, -105363.40352206859, -105363.4035221218, -105363.40352202885, -105363.40352201209, -105363.40352210435, -105363.4035220876, -105363.40352226184, -105363.40352237906, -105363.40352236644, -105363.40352242568, -105363.40352209155, 

   -105363.40352201644, -105363.40352216584, -105363.40352209352, -105363.40352245887, -105363.40352210037, -105363.4035225359, -105363.4035221745, -105363.4035220564, -105363.40352202897, -105363.40352209407, -105363.4035221423, -105363.40352202006, -105363.40352207834, -105363.40352209538, -105363.4035221542, -105363.40352216981, -105363.40352222367, -105363.40352224521, -105363.4035222996, -105363.40352202245, -105363.40352208156, -105363.4035220104, -105363.40352206962, -105363.40352204962, -105363.40352205715, -105363.40352203744, -105363.40352204554, -105363.40352207815, -105363.40352203776, -105363.4035220659, -105363.40352202604, -105363.40352202211, -105363.40352208175, -105363.40352201025, -105363.40352206986, -105363.40352200772, -105363.4035221694, -105363.40352199576, 

   -105363.4035221575, -105363.40352203033, -105363.40352208356, -105363.40352201846, -105363.4035220716, -105363.40352206613, -105363.40352204932, -105363.40352205432, -105363.40352203752, -105363.40352231397, -105363.40352240155, -105363.40352230148, -105363.40352239025, -105363.40352212824, -105363.40352205448, -105363.40352211644, -105363.40352204248, -105363.40352249684, -105363.40352213707, -105363.40352248512, -105363.40352212501, -105363.40352207504, -105363.40352208505, -105363.4035220625, -105363.40352207373, -105363.40352205737, -105363.40352211572, -105363.40352204534, -105363.40352210395, -105363.40352220704, -105363.40352226113, -105363.40352219516, -105363.40352224917, -105363.40352201367, -105363.40352202156, -105363.40352207291, -105363.40352208084, -105363.40352204231, 

   -105363.40352200209, -105363.40352210142, -105363.40352206127, -105363.40352198642, -105363.40352204596, -105363.40352204576, -105363.40352210529, -105363.40352197201, -105363.40352213354, -105363.40352203119, -105363.40352219307, -105363.40352199475, -105363.40352204793, -105363.403522054}
;[o]
 {-105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., 
  -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363.}
:[font = output; inactive; preserveAspect; fontLeading = 0]
 {-105363.42810599352, -105363.42631094059, -105363.42572980995, -105363.42449939938, -105363.41738734936, -105363.41643483436, -105363.4158205689, -105363.41503176076, -105363.41228512909, -105363.41170815809, -105363.4112656066, -105363.4108525003, -105363.41006361591, -105363.40973900861, -105363.40933871358, -105363.4090878993, -105363.40860568943, -105363.4083869465, -105363.40802051635, -105363.40782442123, -105363.40760451186, -105363.40744626276, -105363.40723167376, -105363.40710137355, -105363.40693120442, -105363.40680995223, -105363.40664333287, -105363.40652820992, -105363.40638919502, -105363.4062881541, -105363.40614573055, -105363.40599813689, -105363.40572624527, -105363.40560555803, -105363.40545853377, -105363.40534012609, -105363.40522351023, -105363.40511365727, 

   -105363.4049960999, -105363.40488995788, -105363.40474978319, -105363.40466894339, -105363.40456890188, -105363.40449027186, -105363.40441967128, -105363.4043434131, -105363.4042608158, -105363.40419493138, -105363.40413112973, -105363.4040693666, -105363.40401953533, -105363.40396294935, -105363.40391256473, -105363.40386340971, -105363.40382083744, -105363.40378135897, -105363.40374277039, -105363.40369267862, -105363.40366080937, -105363.4036293311, -105363.40360134022, -105363.40357097001, -105363.40354373104, -105363.40352738035, -105363.40351283227, -105363.40349668563, -105363.40347431668, -105363.40344333446, -105363.40341365163, -105363.4033853108, -105363.40334264498, -105363.40330642214, -105363.40326197911, -105363.40321853489, -105363.4031745304, -105363.40312784759, 

   -105363.40307653628, -105363.40302874456, -105363.40296984494, -105363.40291489988, -105363.40284799306, -105363.40277435635, -105363.40270386172, -105363.4026325342, -105363.40255457223, -105363.40247158743, -105363.40236975325, -105363.40229619079, -105363.40215951441, -105363.40204362829, -105363.4019223838, -105363.40181488704, -105363.40169386863, -105363.40158159973, -105363.40143664995, -105363.40131332655, -105363.40105589142, -105363.40090522615, -105363.40076825753, -105363.40065478956, -105363.40054036047, -105363.40040845794, -105363.4002404065, -105363.40011503983, -105363.39994623075, -105363.39981182183, -105363.39959718626, -105363.39943827203, -105363.39921867017, -105363.39902367414, -105363.39865645685, -105363.398437989, -105363.39795612996, -105363.39770486936, 

   -105363.39730523138, -105363.3969806471, -105363.39619177893, -105363.3957787016, -105363.39533612847, -105363.39475919884, -105363.39201268708, -105363.39122390558, -105363.39060965534, -105363.38965713745, -105363.38254525844, -105363.38131492567, -105363.38073381546, -105363.37893885063}
;[o]
 {-105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., 
  -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363.}
:[font = output; inactive; preserveAspect; fontLeading = 0; endGroup]
 {-105363.42810599352, -105363.42631094059, -105363.42572980995, -105363.42449939938, -105363.41738734936, -105363.41643483436, -105363.4158205689, -105363.41503176076, -105363.41228512909, -105363.41170815809, -105363.4112656066, -105363.4108525003, -105363.41006361591, -105363.40973900861, -105363.40933871358, -105363.4090878993, -105363.40860568943, -105363.4083869465, -105363.40802051635, -105363.40782442123, -105363.40760451186, -105363.40744626276, -105363.40723167376, -105363.40710137355, -105363.40693120442, -105363.40680995223, -105363.40664333287, -105363.40652820992, -105363.40638919502, -105363.4062881541, -105363.40614573055, -105363.40599813689, -105363.40572624527, -105363.40560555803, -105363.40545853377, -105363.40534012609, -105363.40522351023, -105363.40511365727, 

   -105363.4049960999, -105363.40488995788, -105363.40474978319, -105363.40466894339, -105363.40456890188, -105363.40449027186, -105363.40441967128, -105363.4043434131, -105363.4042608158, -105363.40419493138, -105363.40413112973, -105363.4040693666, -105363.40401953533, -105363.40396294935, -105363.40391256473, -105363.40386340971, -105363.40382083744, -105363.40378135897, -105363.40374277039, -105363.40369267862, -105363.40366080937, -105363.4036293311, -105363.40360134022, -105363.40357097001, -105363.40354373104, -105363.40352738035, -105363.40351283227, -105363.40349668563, -105363.40347431668, -105363.40344333446, -105363.40341365163, -105363.4033853108, -105363.40334264498, -105363.40330642214, -105363.40326197911, -105363.40321853489, -105363.4031745304, -105363.40312784759, 

   -105363.40307653628, -105363.40302874456, -105363.40296984494, -105363.40291489988, -105363.40284799306, -105363.40277435635, -105363.40270386172, -105363.4026325342, -105363.40255457223, -105363.40247158743, -105363.40236975325, -105363.40229619079, -105363.40215951441, -105363.40204362829, -105363.4019223838, -105363.40181488704, -105363.40169386863, -105363.40158159973, -105363.40143664995, -105363.40131332655, -105363.40105589142, -105363.40090522615, -105363.40076825753, -105363.40065478956, -105363.40054036047, -105363.40040845794, -105363.4002404065, -105363.40011503983, -105363.39994623075, -105363.39981182183, -105363.39959718626, -105363.39943827203, -105363.39921867017, -105363.39902367414, -105363.39865645685, -105363.398437989, -105363.39795612996, -105363.39770486936, 

   -105363.39730523138, -105363.3969806471, -105363.39619177893, -105363.3957787016, -105363.39533612847, -105363.39475919884, -105363.39201268708, -105363.39122390558, -105363.39060965534, -105363.38965713745, -105363.38254525844, -105363.38131492567, -105363.38073381546, -105363.37893885063}
;[o]
 {-105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., 
  -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363.}
:[font = input; preserveAspect; startGroup]
l1-l2
l1-l3
l1-l4
:[font = output; inactive; preserveAspect; fontLeading = 0]
{0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}
;[o]
{0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}
:[font = output; inactive; preserveAspect; fontLeading = 0]
 {0.024583947742939927, 0.02278891949390527, 0.022207801550393924, 0.020977303327526897, 0.013865264641935937, 0.012912849386339076, 0.01229852469987236, 0.011509700139868073, 0.008763009172980674, 0.008186145627405494, 0.007743586829747073, 0.007330412932788022, 0.006541519964230247, 0.0062169678712962195, 0.005816713368403725, 0.005565783314523287, 0.0050836131849791855, 0.004864961578277871, 0.004498471898841672, 0.004302361005102284, 0.004082391926203854, 0.0039242928178282455, 0.0037095413863426074, 0.0035793270508293062, 0.0034089971595676616, 0.0032879591308301315, 0.0031212864560075104, 0.003006141327205114, 0.0028670732281170785, 0.0027661252534016967, 0.0026237184647470713, 0.002476032546837814, 0.0022041576739866287, 0.002083296189084649, 0.001936154716531746, 

   0.0018177596502937376, 0.001701084547676146, 0.0015915657131699845, 0.001474083459470421, 0.0013677920360350981, 0.0012276896741241217, 0.0011464845156297088, 0.0010468015098012984, 0.0009677359630586579, 0.0008974967786343768, 0.0008213567052735016, 0.000738786839065142, 0.0006728373118676245, 0.0006089874368626624, 0.0005473465425893664, 0.0004974569892510772, 0.0004408539680298418, 0.0003904105251422152, 0.00034123989462386817, 0.0002986137697007507, 0.00025911375996656716, 0.00022047078527975827, 0.0001706561743048951, 0.0001387278171023354, 0.00010732069495134056, 0.00007927059778012335, 0.00004892039578408003, 0.0000216738844756037, 5.34291029907763*^-6, -9.213268640451133*^-6, -0.00002539252454880625, -0.00004772107058670372, -0.00007873143476899713, -0.00010837441368494183, 

   -0.00013671131455339491, -0.0001794367708498612, -0.0002155881084036082, -0.00026009074645116925, -0.00030347282881848514, -0.0003476390120340511, -0.000394148170016706, -0.00044562121911440045, -0.0004932857700623572, -0.000552238620002754, -0.000607118578045629, -0.0006740785465808585, -0.000747709782444872, -0.0008181876037269831, -0.0008895201171981171, -0.0009674652974354103, -0.0010507265396881849, -0.0011526482994668186, -0.0012261106894584373, -0.001362875831546262, -0.0014784999511903152, -0.0015996706788428128, -0.0017072293994715437, -0.0018281738593941554, -0.0019408971129450947, -0.002085487125441432, -0.002209158570622094, -0.0024662335927132517, -0.002616848883917555, -0.0027538275171536952, -0.0028672729386016726, -0.0029817132599418983, -0.003113599435891956, 

   -0.0032817092287587, -0.003407005511689931, -0.003575873197405599, -0.0037103852082509547, -0.003925074866856448, -0.004083923136931844, -0.0043035790004068986, -0.004498339534620754, -0.004865564711508341, -0.005084083910332993, -0.005565950879827142, -0.005817172946990468, -0.00621677070739679, -0.006541454320540652, -0.0073302823439007625, -0.007743284819298424, -0.00818591749703046, -0.008762846919125877, -0.011509418211062439, -0.012298066430957988, -0.01291247819608543, -0.013864893742720596, -0.020976934625650756, -0.022207069079740904, -0.022788232468883507, -0.02458320336882025}
;[o]
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          -6             -6
 {0.0245839, 0.0227889, 0.0222078, 0.0209773, 0.0138653, 0.0129128, 0.0122985, 0.0115097, 0.00876301, 0.00818615, 0.00774359, 0.00733041, 0.00654152, 0.00621697, 0.00581671, 0.00556578, 0.00508361, 0.00486496, 0.00449847, 0.00430236, 0.00408239, 0.00392429, 0.00370954, 0.00357933, 0.003409, 0.00328796, 0.00312129, 0.00300614, 0.00286707, 0.00276613, 0.00262372, 0.00247603, 0.00220416, 0.0020833, 0.00193615, 0.00181776, 0.00170108, 0.00159157, 0.00147408, 0.00136779, 0.00122769, 0.00114648, 0.0010468, 0.000967736, 0.000897497, 0.000821357, 0.000738787, 0.000672837, 0.000608987, 0.000547347, 0.000497457, 0.000440854, 0.000390411, 0.00034124, 0.000298614, 0.000259114, 0.000220471, 0.000170656, 0.000138728, 0.000107321, 0.0000792706, 0.0000489204, 0.0000216739, 5.34291 10  , -9.21327 10  , 
  -0.0000253925, -0.0000477211, -0.0000787314, -0.000108374, -0.000136711, -0.000179437, -0.000215588, -0.000260091, -0.000303473, -0.000347639, -0.000394148, -0.000445621, -0.000493286, -0.000552239, -0.000607119, -0.000674079, -0.00074771, -0.000818188, -0.00088952, -0.000967465, -0.00105073, -0.00115265, -0.00122611, -0.00136288, -0.0014785, -0.00159967, -0.00170723, -0.00182817, -0.0019409, -0.00208549, -0.00220916, -0.00246623, -0.00261685, -0.00275383, -0.00286727, -0.00298171, -0.0031136, -0.00328171, -0.00340701, -0.00357587, -0.00371039, -0.00392507, -0.00408392, -0.00430358, -0.00449834, -0.00486556, -0.00508408, -0.00556595, -0.00581717, -0.00621677, -0.00654145, -0.00733028, -0.00774328, -0.00818592, -0.00876285, -0.0115094, -0.0122981, -0.0129125, -0.0138649, -0.0209769, 
  -0.0222071, -0.0227882, -0.0245832}
:[font = output; inactive; preserveAspect; fontLeading = 0; endGroup]
 {0.024583947742939927, 0.02278891949390527, 0.022207801550393924, 0.020977303327526897, 0.013865264641935937, 0.012912849386339076, 0.01229852469987236, 0.011509700139868073, 0.008763009172980674, 0.008186145627405494, 0.007743586829747073, 0.007330412932788022, 0.006541519964230247, 0.0062169678712962195, 0.005816713368403725, 0.005565783314523287, 0.0050836131849791855, 0.004864961578277871, 0.004498471898841672, 0.004302361005102284, 0.004082391926203854, 0.0039242928178282455, 0.0037095413863426074, 0.0035793270508293062, 0.0034089971595676616, 0.0032879591308301315, 0.0031212864560075104, 0.003006141327205114, 0.0028670732281170785, 0.0027661252534016967, 0.0026237184647470713, 0.002476032546837814, 0.0022041576739866287, 0.002083296189084649, 0.001936154716531746, 

   0.0018177596502937376, 0.001701084547676146, 0.0015915657131699845, 0.001474083459470421, 0.0013677920360350981, 0.0012276896741241217, 0.0011464845156297088, 0.0010468015098012984, 0.0009677359630586579, 0.0008974967786343768, 0.0008213567052735016, 0.000738786839065142, 0.0006728373118676245, 0.0006089874368626624, 0.0005473465425893664, 0.0004974569892510772, 0.0004408539680298418, 0.0003904105251422152, 0.00034123989462386817, 0.0002986137697007507, 0.00025911375996656716, 0.00022047078527975827, 0.0001706561743048951, 0.0001387278171023354, 0.00010732069495134056, 0.00007927059778012335, 0.00004892039578408003, 0.0000216738844756037, 5.34291029907763*^-6, -9.213268640451133*^-6, -0.00002539252454880625, -0.00004772107058670372, -0.00007873143476899713, -0.00010837441368494183, 

   -0.00013671131455339491, -0.0001794367708498612, -0.0002155881084036082, -0.00026009074645116925, -0.00030347282881848514, -0.0003476390120340511, -0.000394148170016706, -0.00044562121911440045, -0.0004932857700623572, -0.000552238620002754, -0.000607118578045629, -0.0006740785465808585, -0.000747709782444872, -0.0008181876037269831, -0.0008895201171981171, -0.0009674652974354103, -0.0010507265396881849, -0.0011526482994668186, -0.0012261106894584373, -0.001362875831546262, -0.0014784999511903152, -0.0015996706788428128, -0.0017072293994715437, -0.0018281738593941554, -0.0019408971129450947, -0.002085487125441432, -0.002209158570622094, -0.0024662335927132517, -0.002616848883917555, -0.0027538275171536952, -0.0028672729386016726, -0.0029817132599418983, -0.003113599435891956, 

   -0.0032817092287587, -0.003407005511689931, -0.003575873197405599, -0.0037103852082509547, -0.003925074866856448, -0.004083923136931844, -0.0043035790004068986, -0.004498339534620754, -0.004865564711508341, -0.005084083910332993, -0.005565950879827142, -0.005817172946990468, -0.00621677070739679, -0.006541454320540652, -0.0073302823439007625, -0.007743284819298424, -0.00818591749703046, -0.008762846919125877, -0.011509418211062439, -0.012298066430957988, -0.01291247819608543, -0.013864893742720596, -0.020976934625650756, -0.022207069079740904, -0.022788232468883507, -0.02458320336882025}
;[o]
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          -6             -6
 {0.0245839, 0.0227889, 0.0222078, 0.0209773, 0.0138653, 0.0129128, 0.0122985, 0.0115097, 0.00876301, 0.00818615, 0.00774359, 0.00733041, 0.00654152, 0.00621697, 0.00581671, 0.00556578, 0.00508361, 0.00486496, 0.00449847, 0.00430236, 0.00408239, 0.00392429, 0.00370954, 0.00357933, 0.003409, 0.00328796, 0.00312129, 0.00300614, 0.00286707, 0.00276613, 0.00262372, 0.00247603, 0.00220416, 0.0020833, 0.00193615, 0.00181776, 0.00170108, 0.00159157, 0.00147408, 0.00136779, 0.00122769, 0.00114648, 0.0010468, 0.000967736, 0.000897497, 0.000821357, 0.000738787, 0.000672837, 0.000608987, 0.000547347, 0.000497457, 0.000440854, 0.000390411, 0.00034124, 0.000298614, 0.000259114, 0.000220471, 0.000170656, 0.000138728, 0.000107321, 0.0000792706, 0.0000489204, 0.0000216739, 5.34291 10  , -9.21327 10  , 
  -0.0000253925, -0.0000477211, -0.0000787314, -0.000108374, -0.000136711, -0.000179437, -0.000215588, -0.000260091, -0.000303473, -0.000347639, -0.000394148, -0.000445621, -0.000493286, -0.000552239, -0.000607119, -0.000674079, -0.00074771, -0.000818188, -0.00088952, -0.000967465, -0.00105073, -0.00115265, -0.00122611, -0.00136288, -0.0014785, -0.00159967, -0.00170723, -0.00182817, -0.0019409, -0.00208549, -0.00220916, -0.00246623, -0.00261685, -0.00275383, -0.00286727, -0.00298171, -0.0031136, -0.00328171, -0.00340701, -0.00357587, -0.00371039, -0.00392507, -0.00408392, -0.00430358, -0.00449834, -0.00486556, -0.00508408, -0.00556595, -0.00581717, -0.00621677, -0.00654145, -0.00733028, -0.00774328, -0.00818592, -0.00876285, -0.0115094, -0.0122981, -0.0129125, -0.0138649, -0.0209769, 
  -0.0222071, -0.0227882, -0.0245832}
:[font = input; preserveAspect; startGroup]
LIKI3
:[font = output; inactive; preserveAspect; endGroup]
{-105363.40352204567, -105363.40352202096, -105363.40352200838, -105363.40352209598, -105363.4035220848}
;[o]
{-105363., -105363., -105363., -105363., -105363.}
:[font = input; preserveAspect; startGroup]
LIKI3
:[font = output; inactive; preserveAspect; fontLeading = 0; endGroup]
 {-105363.40352204567, -105363.40352202096, -105363.40352200838, -105363.40352209598, -105363.4035220848, -105363.40352198496, -105363.40352204429, -105363.40352206047, -105363.40352211983, -105363.40352201248, -105363.40352201964, -105363.40352208732, -105363.40352209598, -105363.40352204081, -105363.40352200023, -105363.403522116, -105363.4035220763, -105363.40352198487, -105363.40352204446, -105363.40352206033, -105363.40352212, -105363.40352196996, -105363.40352213242, -105363.40352204643, -105363.40352220717, -105363.40352199308, -105363.40352204628, -105363.40352206868, -105363.40352212178, -105363.40352202884, -105363.40352201207, -105363.40352210435, -105363.40352208765, -105363.40352226188, -105363.40352237914, -105363.40352236647, -105363.40352242556, -105363.40352209163, 

   -105363.40352201642, -105363.40352216587, -105363.40352209346, -105363.40352245877, -105363.40352210042, -105363.40352253604, -105363.40352217457, -105363.40352205632, -105363.40352202905, -105363.40352209416, -105363.40352214228, -105363.40352202006, -105363.40352207834, -105363.40352209535, -105363.40352215421, -105363.40352216977, -105363.40352222369, -105363.40352224516, -105363.40352229954, -105363.4035220225, -105363.40352208156, -105363.40352201043, -105363.40352206973, -105363.40352204957, -105363.40352205715, -105363.40352203736, -105363.40352204558, -105363.40352207815, -105363.40352203765, -105363.40352206587, -105363.40352202604, -105363.40352202216, -105363.40352208167, -105363.40352201024, -105363.40352206986, -105363.40352200775, -105363.40352216938, -105363.40352199573,\
  
 -105363.40352215759, -105363.40352203045, -105363.40352208365, -105363.40352201852, -105363.40352207156, -105363.40352206619, -105363.4035220494, -105363.40352205434, -105363.40352203748, -105363.40352231395, -105363.40352240161, -105363.40352230152, -105363.40352239016, -105363.40352212824, -105363.40352205443, -105363.40352211636, -105363.40352204251, -105363.40352249698, -105363.40352213704, -105363.40352248507, -105363.40352212501, -105363.40352207496, -105363.40352208499, -105363.40352206245, -105363.40352207367, -105363.40352205731, -105363.40352211578, -105363.40352204534, -105363.403522104, -105363.40352220718, -105363.40352226117, -105363.40352219503, -105363.40352224922, -105363.4035220137, -105363.40352202156, -105363.40352207294, -105363.40352208087, -105363.4035220422, 

   -105363.40352200212, -105363.4035221016, -105363.40352206132, -105363.4035219864, -105363.40352204595, -105363.40352204569, -105363.40352210528, -105363.40352197202, -105363.4035221336, -105363.4035220312, -105363.40352219305, -105363.40352199471, -105363.40352204793}
;[o]
 {-105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., 
  -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363.}
:[font = input; preserveAspect; startGroup]
LIKI3
:[font = output; inactive; preserveAspect; fontLeading = 0; endGroup]
 {-105363.40352204577, -105363.4035220211, -105363.4035220084, -105363.40352209605, -105363.40352208471, -105363.40352198498, -105363.4035220442, -105363.40352206062, -105363.40352211992, -105363.40352201246, -105363.40352201977, -105363.40352208736, -105363.40352209595, -105363.40352204074, -105363.40352200021, -105363.40352211599, -105363.40352207625, -105363.40352198492, -105363.40352204445, -105363.40352206022, -105363.40352211993, -105363.40352196994, -105363.40352213237, -105363.4035220465, -105363.40352220726, -105363.4035219931, -105363.40352204641, -105363.40352206859, -105363.4035221218, -105363.40352202885, -105363.40352201209, -105363.40352210435, -105363.4035220876, -105363.40352226184, -105363.40352237906, -105363.40352236644, -105363.40352242568, -105363.40352209155, 

   -105363.40352201644, -105363.40352216584, -105363.40352209352, -105363.40352245887, -105363.40352210037, -105363.4035225359, -105363.4035221745, -105363.4035220564, -105363.40352202897, -105363.40352209407, -105363.4035221423, -105363.40352202006, -105363.40352207834, -105363.40352209538, -105363.4035221542, -105363.40352216981, -105363.40352222367, -105363.40352224521, -105363.4035222996, -105363.40352202245, -105363.40352208156, -105363.4035220104, -105363.40352206962, -105363.40352204962, -105363.40352205715, -105363.40352203744, -105363.40352204554, -105363.40352207815, -105363.40352203776, -105363.4035220659, -105363.40352202604, -105363.40352202211, -105363.40352208175, -105363.40352201025, -105363.40352206986, -105363.40352200772, -105363.4035221694, -105363.40352199576, 

   -105363.4035221575, -105363.40352203033, -105363.40352208356, -105363.40352201846, -105363.4035220716, -105363.40352206613, -105363.40352204932, -105363.40352205432, -105363.40352203752, -105363.40352231397, -105363.40352240155, -105363.40352230148, -105363.40352239025, -105363.40352212824, -105363.40352205448, -105363.40352211644, -105363.40352204248, -105363.40352249684, -105363.40352213707, -105363.40352248512, -105363.40352212501, -105363.40352207504, -105363.40352208505, -105363.4035220625, -105363.40352207373, -105363.40352205737, -105363.40352211572, -105363.40352204534, -105363.40352210395, -105363.40352220704, -105363.40352226113, -105363.40352219516, -105363.40352224917, -105363.40352201367, -105363.40352202156, -105363.40352207291, -105363.40352208084, -105363.40352204231, 

   -105363.40352200209, -105363.40352210142, -105363.40352206127, -105363.40352198642, -105363.40352204596, -105363.40352204576, -105363.40352210529, -105363.40352197201, -105363.40352213354, -105363.40352203119, -105363.40352219307, -105363.40352199475, -105363.40352204793, -105363.403522054}
;[o]
 {-105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., 
  -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363., -105363.}
:[font = input; preserveAspect; startGroup]
LIKI1-Take[LIKI3,5]
:[font = output; inactive; preserveAspect; endGroup]
{1.0186340659856796*^-10, 1.3096723705530167*^-10, 2.9103830456733704*^-11, 7.275957614183426*^-11, -8.731149137020111*^-11}
;[o]
           -10            -10            -11            -11             -11
{1.01863 10   , 1.30967 10   , 2.91038 10   , 7.27596 10   , -8.73115 10   }
:[font = input; Cclosed; preserveAspect; startGroup]
{F1,LIKELI1,LIKI1} = HesseTest[Z1,THETA,{system,{Lik1,cEKF1,_}},misc={-9,1}];
:[font = print; inactive; preserveAspect; endGroup]
                                                          -6                         -6            -6            -6                          -6            -6                                                      -6
INK: {0.0000275988, 0.0000104077, 0.0000146182, 6.05545 10  , 0.0000300471, 9.2779 10  , 6.05545 10  , 6.05545 10  , 0.0000615611, 6.05545 10  , 9.79596 10  , 0.0000274162, 0.0000288978, 0.0000150708, 6.05545 10  }
{-105363.403522021, -105363.4035220084, -105363.403522096, -105363.4035220848}
{-105363.403521985, -105363.4035220443, -105363.4035220605, -105363.4035221198}
{-105363.4035220125, -105363.4035220196, -105363.4035220873, -105363.403522096}
{-105363.4035220408, -105363.4035220002, -105363.403522116, -105363.4035220763}
{-105363.4035219849, -105363.4035220445, -105363.4035220603, -105363.40352212}
{-105363.40352197, -105363.4035221324, -105363.4035220464, -105363.4035222072}
{-105363.4035219931, -105363.4035220463, -105363.4035220687, -105363.4035221218}
{-105363.4035220288, -105363.4035220121, -105363.4035221043, -105363.4035220877}
{-105363.4035222619, -105363.4035223791, -105363.4035223665, -105363.4035224256}
{-105363.4035220916, -105363.4035220164, -105363.4035221659, -105363.4035220935}
{-105363.4035224588, -105363.4035221004, -105363.403522536, -105363.4035221746}
{-105363.4035220563, -105363.4035220291, -105363.4035220942, -105363.4035221423}
{-105363.40352202, -105363.4035220783, -105363.4035220953, -105363.4035221542}
{-105363.4035221698, -105363.4035222237, -105363.4035222452, -105363.4035222995}
{-105363.4035220225, -105363.4035220816, -105363.4035220104, -105363.4035220697}
{-105363.4035220496, -105363.4035220572, -105363.4035220374, -105363.4035220456}
{-105363.4035220782, -105363.4035220377, -105363.4035220659, -105363.403522026}
{-105363.4035220222, -105363.4035220817, -105363.4035220102, -105363.4035220699}
{-105363.4035220077, -105363.4035221694, -105363.4035219957, -105363.4035221576}
{-105363.4035220304, -105363.4035220836, -105363.4035220185, -105363.4035220716}
{-105363.4035220662, -105363.4035220494, -105363.4035220544, -105363.4035220375}
{-105363.403522314, -105363.4035224016, -105363.4035223015, -105363.4035223902}
{-105363.4035221282, -105363.4035220544, -105363.4035221164, -105363.4035220425}
{-105363.403522497, -105363.403522137, -105363.4035224851, -105363.403522125}
{-105363.403522075, -105363.403522085, -105363.4035220625, -105363.4035220737}
{-105363.4035220573, -105363.4035221158, -105363.4035220453, -105363.403522104}
{-105363.4035222072, -105363.4035222612, -105363.403522195, -105363.4035222492}
{-105363.4035220137, -105363.4035220216, -105363.4035220729, -105363.4035220809}
{-105363.4035220422, -105363.4035220021, -105363.4035221016, -105363.4035220613}
{-105363.4035219864, -105363.4035220459, -105363.4035220457, -105363.4035221053}
{-105363.403521972, -105363.4035221336, -105363.4035220312, -105363.403522193}
{-105363.4035219947, -105363.4035220479, -105363.403522054, -105363.4035221071}
{-105363.4035220304, -105363.4035220136, -105363.4035220896, -105363.4035220729}
{-105363.403522278, -105363.4035223662, -105363.4035223372, -105363.4035224253}
{-105363.4035220925, -105363.4035220188, -105363.4035221518, -105363.4035220781}
{-105363.4035224612, -105363.4035221014, -105363.4035225207, -105363.4035221604}
{-105363.403522039, -105363.4035220494, -105363.4035220984, -105363.4035221088}
{-105363.4035220216, -105363.40352208, -105363.4035220808, -105363.4035221393}
{-105363.4035221712, -105363.4035222254, -105363.4035222307, -105363.4035222847}
{-105363.4035220704, -105363.4035220282, -105363.4035220763, -105363.403522038}
{-105363.4035220136, -105363.4035220732, -105363.4035220213, -105363.4035220811}
{-105363.403521999, -105363.4035221608, -105363.4035220071, -105363.4035221687}
{-105363.4035220218, -105363.403522075, -105363.4035220297, -105363.4035220829}
{-105363.4035220576, -105363.4035220407, -105363.4035220654, -105363.4035220487}
{-105363.4035223073, -105363.403522391, -105363.4035223108, -105363.4035224034}
{-105363.4035221163, -105363.4035220492, -105363.403522131, -105363.4035220505}
{-105363.4035224879, -105363.403522129, -105363.4035224968, -105363.4035221358}
{-105363.4035220661, -105363.4035220765, -105363.4035220739, -105363.4035220846}
{-105363.4035220494, -105363.4035221065, -105363.4035220559, -105363.4035221158}
{-105363.4035221985, -105363.4035222525, -105363.4035222063, -105363.4035222606}
{-105363.4035220422, -105363.4035221016, -105363.4035220018, -105363.4035220615}
{-105363.4035220277, -105363.4035221893, -105363.4035219874, -105363.4035221491}
{-105363.4035220505, -105363.4035221033, -105363.4035220103, -105363.4035220634}
{-105363.4035220861, -105363.4035220692, -105363.403522046, -105363.4035220293}
{-105363.4035223337, -105363.4035224218, -105363.4035222934, -105363.4035223815}
{-105363.4035221484, -105363.4035220743, -105363.4035221078, -105363.4035220345}
{-105363.4035225169, -105363.403522157, -105363.4035224768, -105363.4035221169}
{-105363.4035220948, -105363.4035221051, -105363.4035220545, -105363.403522065}
{-105363.4035220993, -105363.4035221136, -105363.4035220149, -105363.4035221177}
{-105363.4035222271, -105363.4035222809, -105363.4035221865, -105363.4035222411}
{-105363.4035219719, -105363.4035221335, -105363.4035220314, -105363.4035221931}
{-105363.4035219945, -105363.4035220477, -105363.403522054, -105363.4035221074}
{-105363.4035220303, -105363.4035220135, -105363.4035220899, -105363.4035220731}
{-105363.4035222778, -105363.403522366, -105363.4035223375, -105363.4035224257}
{-105363.4035220922, -105363.4035220187, -105363.403522152, -105363.4035220781}
{-105363.4035224611, -105363.4035221011, -105363.4035225207, -105363.4035221608}
{-105363.403522039, -105363.4035220494, -105363.4035220985, -105363.4035221089}
{-105363.4035220216, -105363.4035220799, -105363.403522081, -105363.4035221396}
{-105363.403522171, -105363.4035222253, -105363.4035222307, -105363.4035222849}
{-105363.4035219844, -105363.4035220291, -105363.4035221376, -105363.4035221991}
{-105363.403522019, -105363.4035219959, -105363.4035221744, -105363.4035221638}
{-105363.4035222687, -105363.4035223463, -105363.4035224198, -105363.4035225184}
{-105363.4035220816, -105363.4035220006, -105363.403522236, -105363.4035221695}
{-105363.4035223798, -105363.4035221535, -105363.4035226751, -105363.4035221817}
{-105363.4035220239, -105363.4035220355, -105363.4035221867, -105363.4035221961}
{-105363.4035220071, -105363.4035220655, -105363.4035221685, -105363.4035222273}
{-105363.4035221593, -105363.4035222083, -105363.4035223159, -105363.403522375}
{-105363.4035220401, -105363.4035220202, -105363.4035220901, -105363.4035220764}
{-105363.403522286, -105363.4035223743, -105363.4035223394, -105363.4035224274}
{-105363.4035221006, -105363.4035220269, -105363.4035221538, -105363.4035220798}
{-105363.4035224693, -105363.4035221094, -105363.4035225227, -105363.4035221625}
{-105363.4035220471, -105363.4035220577, -105363.4035221002, -105363.4035221107}
{-105363.4035220294, -105363.4035220885, -105363.4035220831, -105363.4035221411}
{-105363.4035221815, -105363.4035222314, -105363.4035222303, -105363.4035222889}
{-105363.403522322, -105363.4035224098, -105363.403522305, -105363.4035223933}
{-105363.4035221365, -105363.4035220625, -105363.4035221195, -105363.403522046}
{-105363.4035225021, -105363.403522148, -105363.4035224913, -105363.4035221253}
{-105363.4035220829, -105363.4035220934, -105363.403522066, -105363.4035220766}
{-105363.4035220653, -105363.4035221239, -105363.4035220485, -105363.4035221073}
{-105363.4035222729, -105363.4035222115, -105363.4035221407, -105363.4035223103}
{-105363.4035223461, -105363.403522348, -105363.4035225097, -105363.4035223606}
{-105363.4035227337, -105363.4035224115, -105363.4035228597, -105363.403522462}
{-105363.4035223307, -105363.4035223407, -105363.4035224182, -105363.4035224295}
{-105363.4035223123, -105363.403522372, -105363.4035224017, -105363.403522459}
{-105363.4035224627, -105363.4035225169, -105363.403522551, -105363.403522605}
{-105363.4035225445, -105363.4035222299, -105363.4035225162, -105363.4035221108}
{-105363.403522145, -105363.4035221554, -105363.4035220711, -105363.4035220818}
{-105363.4035221275, -105363.403522186, -105363.4035220538, -105363.4035221122}
{-105363.4035222775, -105363.4035223311, -105363.4035222032, -105363.4035222579}
{-105363.4035225135, -105363.4035225244, -105363.4035221539, -105363.4035221642}
{-105363.4035224964, -105363.4035225547, -105363.403522136, -105363.403522195}
{-105363.4035226434, -105363.4035227028, -105363.4035222887, -105363.4035223374}
{-105363.4035220744, -105363.4035221321, -105363.4035220842, -105363.4035221432}
{-105363.4035222239, -105363.4035222778, -105363.4035222341, -105363.4035222884}
{-105363.4035222067, -105363.4035222599, -105363.4035222645, -105363.4035223193}
{-105363.4035219965, -105363.4035221477}
{-105363.4035220583, -105363.4035220345}
{-105363.4035219867, -105363.4035221051}
{-105363.4035220437, -105363.4035220596}
{-105363.4035221098, -105363.4035220294}
{-105363.4035219862, -105363.4035221054}
{-105363.4035220306, -105363.4035223539}
{-105363.4035220129, -105363.4035221191}
{-105363.4035220859, -105363.4035220523}
{-105363.403523181, -105363.4035233573}
{-105363.4035222774, -105363.40352213}
{-105363.4035234662, -105363.4035227461}
{-105363.4035221476, -105363.4035221683}
{-105363.4035221257, -105363.4035222429}
{-105363.4035227202, -105363.4035228286}
:[font = input; output; Cclosed; preserveAspect; startGroup]
Map[NumberForm[#,30]&,LIKI1]//MatrixForm
;[o]

 (#1 & ) /@ LIKI1
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
 MatrixForm[{NumberForm[-105363.40352202096, 30], NumberForm[-105363.40352200838, 30], NumberForm[-105363.40352209598, 30], NumberForm[-105363.4035220848, 30], NumberForm[-105363.40352198496, 30], NumberForm[-105363.40352204429, 30], NumberForm[-105363.40352206047, 30], NumberForm[-105363.40352211983, 30], NumberForm[-105363.40352201248, 30], NumberForm[-105363.40352201964, 30], NumberForm[-105363.40352208732, 30], NumberForm[-105363.40352209598, 30], NumberForm[-105363.40352204081, 30], NumberForm[-105363.40352200023, 30], NumberForm[-105363.403522116, 30], NumberForm[-105363.4035220763, 30], NumberForm[-105363.40352198487, 30], NumberForm[-105363.40352204446, 30], NumberForm[-105363.40352206033, 30], NumberForm[-105363.40352212, 30], NumberForm[-105363.40352196996, 30], 

    NumberForm[-105363.40352213242, 30], NumberForm[-105363.40352204643, 30], NumberForm[-105363.40352220717, 30], NumberForm[-105363.40352199308, 30], NumberForm[-105363.40352204628, 30], NumberForm[-105363.40352206868, 30], NumberForm[-105363.40352212178, 30], NumberForm[-105363.40352202884, 30], NumberForm[-105363.40352201207, 30], NumberForm[-105363.40352210435, 30], NumberForm[-105363.40352208765, 30], NumberForm[-105363.40352226188, 30], NumberForm[-105363.40352237914, 30], NumberForm[-105363.40352236647, 30], NumberForm[-105363.40352242556, 30], NumberForm[-105363.40352209163, 30], NumberForm[-105363.40352201642, 30], NumberForm[-105363.40352216587, 30], NumberForm[-105363.40352209346, 30], NumberForm[-105363.40352245877, 30], NumberForm[-105363.40352210042, 30], 

    NumberForm[-105363.40352253604, 30], NumberForm[-105363.40352217457, 30], NumberForm[-105363.40352205632, 30], NumberForm[-105363.40352202905, 30], NumberForm[-105363.40352209416, 30], NumberForm[-105363.40352214228, 30], NumberForm[-105363.40352202006, 30], NumberForm[-105363.40352207834, 30], NumberForm[-105363.40352209535, 30], NumberForm[-105363.40352215421, 30], NumberForm[-105363.40352216977, 30], NumberForm[-105363.40352222369, 30], NumberForm[-105363.40352224516, 30], NumberForm[-105363.40352229954, 30], NumberForm[-105363.4035220225, 30], NumberForm[-105363.40352208156, 30], NumberForm[-105363.40352201043, 30], NumberForm[-105363.40352206973, 30], NumberForm[-105363.40352204957, 30], NumberForm[-105363.40352205715, 30], NumberForm[-105363.40352203736, 30], 

    NumberForm[-105363.40352204558, 30], NumberForm[-105363.40352207815, 30], NumberForm[-105363.40352203765, 30], NumberForm[-105363.40352206587, 30], NumberForm[-105363.40352202604, 30], NumberForm[-105363.40352202216, 30], NumberForm[-105363.40352208167, 30], NumberForm[-105363.40352201024, 30], NumberForm[-105363.40352206986, 30], NumberForm[-105363.40352200775, 30], NumberForm[-105363.40352216938, 30], NumberForm[-105363.40352199573, 30], NumberForm[-105363.40352215759, 30], NumberForm[-105363.40352203045, 30], NumberForm[-105363.40352208365, 30], NumberForm[-105363.40352201852, 30], NumberForm[-105363.40352207156, 30], NumberForm[-105363.40352206619, 30], NumberForm[-105363.4035220494, 30], NumberForm[-105363.40352205434, 30], NumberForm[-105363.40352203748, 30], 

    NumberForm[-105363.40352231395, 30], NumberForm[-105363.40352240161, 30], NumberForm[-105363.40352230152, 30], NumberForm[-105363.40352239016, 30], NumberForm[-105363.40352212824, 30], NumberForm[-105363.40352205443, 30], NumberForm[-105363.40352211636, 30], NumberForm[-105363.40352204251, 30], NumberForm[-105363.40352249698, 30], NumberForm[-105363.40352213704, 30], NumberForm[-105363.40352248507, 30], NumberForm[-105363.40352212501, 30], NumberForm[-105363.40352207496, 30], NumberForm[-105363.40352208499, 30], NumberForm[-105363.40352206245, 30], NumberForm[-105363.40352207367, 30], NumberForm[-105363.40352205731, 30], NumberForm[-105363.40352211578, 30], NumberForm[-105363.40352204534, 30], NumberForm[-105363.403522104, 30], NumberForm[-105363.40352220718, 30], 

    NumberForm[-105363.40352226117, 30], NumberForm[-105363.40352219503, 30], NumberForm[-105363.40352224922, 30], NumberForm[-105363.4035220137, 30], NumberForm[-105363.40352202156, 30], NumberForm[-105363.40352207294, 30], NumberForm[-105363.40352208087, 30], NumberForm[-105363.4035220422, 30], NumberForm[-105363.40352200212, 30], NumberForm[-105363.4035221016, 30], NumberForm[-105363.40352206132, 30], NumberForm[-105363.4035219864, 30], NumberForm[-105363.40352204595, 30], NumberForm[-105363.40352204569, 30], NumberForm[-105363.40352210528, 30], NumberForm[-105363.40352197202, 30], NumberForm[-105363.4035221336, 30], NumberForm[-105363.4035220312, 30], NumberForm[-105363.40352219305, 30], NumberForm[-105363.40352199471, 30], NumberForm[-105363.40352204793, 30], 

    NumberForm[-105363.40352205397, 30], NumberForm[-105363.40352210711, 30], NumberForm[-105363.40352203039, 30], NumberForm[-105363.40352201361, 30], NumberForm[-105363.40352208965, 30], NumberForm[-105363.4035220729, 30], NumberForm[-105363.40352227796, 30], NumberForm[-105363.40352236624, 30], NumberForm[-105363.40352233722, 30], NumberForm[-105363.40352242532, 30], NumberForm[-105363.40352209256, 30], NumberForm[-105363.40352201881, 30], NumberForm[-105363.40352215184, 30], NumberForm[-105363.40352207814, 30], NumberForm[-105363.40352246122, 30], NumberForm[-105363.40352210143, 30], NumberForm[-105363.40352252075, 30], NumberForm[-105363.40352216046, 30], NumberForm[-105363.40352203904, 30], NumberForm[-105363.40352204944, 30], NumberForm[-105363.40352209838, 30], 

    NumberForm[-105363.40352210883, 30], NumberForm[-105363.40352202162, 30], NumberForm[-105363.40352208004, 30], NumberForm[-105363.40352208076, 30], NumberForm[-105363.4035221393, 30], NumberForm[-105363.40352217118, 30], NumberForm[-105363.40352222537, 30], NumberForm[-105363.40352223067, 30], NumberForm[-105363.40352228476, 30], NumberForm[-105363.40352207041, 30], NumberForm[-105363.40352202821, 30], NumberForm[-105363.4035220763, 30], NumberForm[-105363.40352203799, 30], NumberForm[-105363.40352201361, 30], NumberForm[-105363.40352207317, 30], NumberForm[-105363.40352202131, 30], NumberForm[-105363.40352208106, 30], NumberForm[-105363.40352199905, 30], NumberForm[-105363.40352216084, 30], NumberForm[-105363.40352200714, 30], NumberForm[-105363.40352216874, 30], 

    NumberForm[-105363.40352202176, 30], NumberForm[-105363.40352207502, 30], NumberForm[-105363.40352202971, 30], NumberForm[-105363.40352208292, 30], NumberForm[-105363.40352205763, 30], NumberForm[-105363.40352204068, 30], NumberForm[-105363.40352206539, 30], NumberForm[-105363.40352204868, 30], NumberForm[-105363.40352230727, 30], NumberForm[-105363.40352239105, 30], NumberForm[-105363.40352231076, 30], NumberForm[-105363.40352240339, 30], NumberForm[-105363.40352211629, 30], NumberForm[-105363.4035220492, 30], NumberForm[-105363.403522131, 30], NumberForm[-105363.40352205047, 30], NumberForm[-105363.40352248792, 30], NumberForm[-105363.40352212897, 30], NumberForm[-105363.40352249681, 30], NumberForm[-105363.40352213582, 30], NumberForm[-105363.40352206612, 30], 

    NumberForm[-105363.40352207652, 30], NumberForm[-105363.40352207395, 30], NumberForm[-105363.40352208463, 30], NumberForm[-105363.40352204944, 30], NumberForm[-105363.40352210648, 30], NumberForm[-105363.40352205586, 30], NumberForm[-105363.40352211584, 30], NumberForm[-105363.40352219854, 30], NumberForm[-105363.40352225247, 30], NumberForm[-105363.40352220625, 30], NumberForm[-105363.40352226056, 30], NumberForm[-105363.40352204216, 30], NumberForm[-105363.40352210158, 30], NumberForm[-105363.40352200184, 30], NumberForm[-105363.40352206152, 30], NumberForm[-105363.4035220277, 30], NumberForm[-105363.4035221893, 30], NumberForm[-105363.40352198743, 30], NumberForm[-105363.4035221491, 30], NumberForm[-105363.40352205046, 30], NumberForm[-105363.40352210334, 30], 

    NumberForm[-105363.4035220103, 30], NumberForm[-105363.4035220634, 30], NumberForm[-105363.40352208605, 30], NumberForm[-105363.40352206922, 30], NumberForm[-105363.40352204596, 30], NumberForm[-105363.40352202933, 30], NumberForm[-105363.40352233373, 30], NumberForm[-105363.40352242178, 30], NumberForm[-105363.4035222934, 30], NumberForm[-105363.40352238147, 30], NumberForm[-105363.40352214842, 30], NumberForm[-105363.40352207428, 30], NumberForm[-105363.40352210782, 30], NumberForm[-105363.40352203447, 30], NumberForm[-105363.40352251688, 30], NumberForm[-105363.40352215696, 30], NumberForm[-105363.40352247677, 30], NumberForm[-105363.40352211686, 30], NumberForm[-105363.40352209478, 30], NumberForm[-105363.40352210509, 30], NumberForm[-105363.40352205453, 30], 

    NumberForm[-105363.40352206501, 30], NumberForm[-105363.40352209927, 30], NumberForm[-105363.40352211363, 30], NumberForm[-105363.40352201488, 30], NumberForm[-105363.40352211773, 30], NumberForm[-105363.40352222712, 30], NumberForm[-105363.40352228087, 30], NumberForm[-105363.4035221865, 30], NumberForm[-105363.40352224107, 30], NumberForm[-105363.4035219719, 30], NumberForm[-105363.40352213346, 30], NumberForm[-105363.40352203143, 30], NumberForm[-105363.40352219308, 30], NumberForm[-105363.40352199452, 30], NumberForm[-105363.40352204772, 30], NumberForm[-105363.40352205401, 30], NumberForm[-105363.40352210737, 30], NumberForm[-105363.40352203026, 30], NumberForm[-105363.40352201353, 30], NumberForm[-105363.40352208992, 30], NumberForm[-105363.40352207309, 30], 

    NumberForm[-105363.40352227783, 30], NumberForm[-105363.40352236603, 30], NumberForm[-105363.40352233745, 30], NumberForm[-105363.40352242568, 30], NumberForm[-105363.40352209221, 30], NumberForm[-105363.40352201868, 30], NumberForm[-105363.403522152, 30], NumberForm[-105363.40352207814, 30], NumberForm[-105363.40352246114, 30], NumberForm[-105363.40352210107, 30], NumberForm[-105363.40352252072, 30], NumberForm[-105363.40352216075, 30], NumberForm[-105363.40352203895, 30], NumberForm[-105363.40352204937, 30], NumberForm[-105363.4035220985, 30], NumberForm[-105363.40352210894, 30], NumberForm[-105363.40352202156, 30], NumberForm[-105363.40352207988, 30], NumberForm[-105363.40352208096, 30], NumberForm[-105363.4035221396, 30], NumberForm[-105363.40352217102, 30], 

    NumberForm[-105363.40352222527, 30], NumberForm[-105363.40352223068, 30], NumberForm[-105363.4035222849, 30], NumberForm[-105363.4035219844, 30], NumberForm[-105363.40352202907, 30], NumberForm[-105363.40352213764, 30], NumberForm[-105363.40352219908, 30], NumberForm[-105363.40352201906, 30], NumberForm[-105363.40352199592, 30], NumberForm[-105363.40352217438, 30], NumberForm[-105363.40352216379, 30], NumberForm[-105363.4035222687, 30], NumberForm[-105363.40352234629, 30], NumberForm[-105363.40352241979, 30], NumberForm[-105363.40352251843, 30], NumberForm[-105363.40352208159, 30], NumberForm[-105363.40352200063, 30], NumberForm[-105363.40352223603, 30], NumberForm[-105363.40352216948, 30], NumberForm[-105363.4035223798, 30], NumberForm[-105363.40352215344, 30], 

    NumberForm[-105363.4035226751, 30], NumberForm[-105363.40352218164, 30], NumberForm[-105363.40352202386, 30], NumberForm[-105363.40352203549, 30], NumberForm[-105363.4035221867, 30], NumberForm[-105363.40352219608, 30], NumberForm[-105363.40352200708, 30], NumberForm[-105363.40352206549, 30], NumberForm[-105363.40352216848, 30], NumberForm[-105363.40352222727, 30], NumberForm[-105363.40352215928, 30], NumberForm[-105363.40352220835, 30], NumberForm[-105363.40352231587, 30], NumberForm[-105363.40352237497, 30], NumberForm[-105363.40352204007, 30], NumberForm[-105363.40352202022, 30], NumberForm[-105363.40352209011, 30], NumberForm[-105363.40352207642, 30], NumberForm[-105363.40352228601, 30], NumberForm[-105363.4035223743, 30], NumberForm[-105363.4035223394, 30], 

    NumberForm[-105363.4035224274, 30], NumberForm[-105363.40352210059, 30], NumberForm[-105363.40352202687, 30], NumberForm[-105363.4035221538, 30], NumberForm[-105363.40352207983, 30], NumberForm[-105363.40352246932, 30], NumberForm[-105363.40352210945, 30], NumberForm[-105363.40352252267, 30], NumberForm[-105363.4035221625, 30], NumberForm[-105363.4035220471, 30], NumberForm[-105363.40352205774, 30], NumberForm[-105363.40352210023, 30], NumberForm[-105363.40352211072, 30], NumberForm[-105363.40352202945, 30], NumberForm[-105363.4035220885, 30], NumberForm[-105363.40352208306, 30], NumberForm[-105363.4035221411, 30], NumberForm[-105363.40352218154, 30], NumberForm[-105363.40352223141, 30], NumberForm[-105363.40352223035, 30], NumberForm[-105363.40352228886, 30], 

    NumberForm[-105363.40352232195, 30], NumberForm[-105363.40352240985, 30], NumberForm[-105363.40352230503, 30], NumberForm[-105363.40352239329, 30], NumberForm[-105363.40352213653, 30], NumberForm[-105363.40352206246, 30], NumberForm[-105363.40352211951, 30], NumberForm[-105363.40352204596, 30], NumberForm[-105363.40352250208, 30], NumberForm[-105363.40352214804, 30], NumberForm[-105363.40352249131, 30], NumberForm[-105363.40352212531, 30], NumberForm[-105363.40352208287, 30], NumberForm[-105363.40352209336, 30], NumberForm[-105363.40352206603, 30], NumberForm[-105363.40352207658, 30], NumberForm[-105363.40352206535, 30], NumberForm[-105363.4035221239, 30], NumberForm[-105363.40352204854, 30], NumberForm[-105363.40352210728, 30], NumberForm[-105363.4035222729, 30], 

    NumberForm[-105363.40352221153, 30], NumberForm[-105363.40352214067, 30], NumberForm[-105363.40352231028, 30], NumberForm[-105363.40352234611, 30], NumberForm[-105363.40352234802, 30], NumberForm[-105363.40352250973, 30], NumberForm[-105363.40352236056, 30], NumberForm[-105363.4035227337, 30], NumberForm[-105363.40352241152, 30], NumberForm[-105363.40352285969, 30], NumberForm[-105363.40352246196, 30], NumberForm[-105363.40352233073, 30], NumberForm[-105363.40352234065, 30], NumberForm[-105363.40352241823, 30], NumberForm[-105363.40352242945, 30], NumberForm[-105363.40352231229, 30], NumberForm[-105363.40352237204, 30], NumberForm[-105363.4035224017, 30], NumberForm[-105363.40352245896, 30], NumberForm[-105363.40352246264, 30], NumberForm[-105363.40352251695, 30], 

    NumberForm[-105363.40352255099, 30], NumberForm[-105363.403522605, 30], NumberForm[-105363.40352254453, 30], NumberForm[-105363.40352222993, 30], NumberForm[-105363.40352251624, 30], NumberForm[-105363.40352211078, 30], NumberForm[-105363.403522145, 30], NumberForm[-105363.40352215544, 30], NumberForm[-105363.40352207112, 30], NumberForm[-105363.40352208179, 30], NumberForm[-105363.40352212751, 30], NumberForm[-105363.40352218604, 30], NumberForm[-105363.40352205378, 30], NumberForm[-105363.40352211225, 30], NumberForm[-105363.40352227751, 30], NumberForm[-105363.40352233112, 30], NumberForm[-105363.40352220324, 30], NumberForm[-105363.40352225787, 30], NumberForm[-105363.4035225135, 30], NumberForm[-105363.40352252436, 30], NumberForm[-105363.40352215388, 30], 

    NumberForm[-105363.4035221642, 30], NumberForm[-105363.40352249643, 30], NumberForm[-105363.4035225547, 30], NumberForm[-105363.403522136, 30], NumberForm[-105363.40352219497, 30], NumberForm[-105363.40352264335, 30], NumberForm[-105363.40352270276, 30], NumberForm[-105363.40352228866, 30], NumberForm[-105363.40352233741, 30], NumberForm[-105363.4035220744, 30], NumberForm[-105363.40352213214, 30], NumberForm[-105363.40352208419, 30], NumberForm[-105363.40352214321, 30], NumberForm[-105363.40352222386, 30], NumberForm[-105363.40352227783, 30], NumberForm[-105363.4035222341, 30], NumberForm[-105363.40352228844, 30], NumberForm[-105363.40352220669, 30], NumberForm[-105363.40352225988, 30], NumberForm[-105363.40352226445, 30], NumberForm[-105363.40352231934, 30], 

    NumberForm[-105363.40352199649, 30], NumberForm[-105363.40352214768, 30], NumberForm[-105363.40352205829, 30], NumberForm[-105363.40352203448, 30], NumberForm[-105363.40352198666, 30], NumberForm[-105363.40352210515, 30], NumberForm[-105363.40352204374, 30], NumberForm[-105363.40352205957, 30], NumberForm[-105363.4035221098, 30], NumberForm[-105363.40352202937, 30], NumberForm[-105363.40352198623, 30], NumberForm[-105363.4035221054, 30], NumberForm[-105363.40352203055, 30], NumberForm[-105363.40352235387, 30], NumberForm[-105363.40352201294, 30], NumberForm[-105363.40352211914, 30], NumberForm[-105363.40352208591, 30], NumberForm[-105363.40352205232, 30], NumberForm[-105363.40352318106, 30], NumberForm[-105363.40352335731, 30], NumberForm[-105363.40352227741, 30], 

    NumberForm[-105363.40352213001, 30], NumberForm[-105363.4035234662, 30], NumberForm[-105363.40352274608, 30], NumberForm[-105363.40352214758, 30], NumberForm[-105363.40352216833, 30], NumberForm[-105363.40352212568, 30], NumberForm[-105363.4035222429, 30], NumberForm[-105363.40352272015, 30], NumberForm[-105363.40352282856, 30]}]
;[o]

1     -105363.403522021
2     -105363.4035220084
3     -105363.403522096
4     -105363.4035220848
5     -105363.403521985
6     -105363.4035220443
7     -105363.4035220605
8     -105363.4035221198
9     -105363.4035220125
10    -105363.4035220196
11    -105363.4035220873
12    -105363.403522096
13    -105363.4035220408
14    -105363.4035220002
15    -105363.403522116
16    -105363.4035220763
17    -105363.4035219849
18    -105363.4035220445
19    -105363.4035220603
20    -105363.40352212
21    -105363.40352197
22    -105363.4035221324
23    -105363.4035220464
24    -105363.4035222072
25    -105363.4035219931
26    -105363.4035220463
27    -105363.4035220687
28    -105363.4035221218
29    -105363.4035220288
30    -105363.4035220121
31    -105363.4035221043
32    -105363.4035220877
33    -105363.4035222619
34    -105363.4035223791
35    -105363.4035223665
36    -105363.4035224256
37    -105363.4035220916
38    -105363.4035220164
39    -105363.4035221659
40    -105363.4035220935
41    -105363.4035224588
42    -105363.4035221004
43    -105363.403522536
44    -105363.4035221746
45    -105363.4035220563
46    -105363.4035220291
47    -105363.4035220942
48    -105363.4035221423
49    -105363.40352202
50    -105363.4035220783
51    -105363.4035220953
52    -105363.4035221542
53    -105363.4035221698
54    -105363.4035222237
55    -105363.4035222452
56    -105363.4035222995
57    -105363.4035220225
58    -105363.4035220816
59    -105363.4035220104
60    -105363.4035220697
61    -105363.4035220496
62    -105363.4035220572
63    -105363.4035220374
64    -105363.4035220456
65    -105363.4035220782
66    -105363.4035220377
67    -105363.4035220659
68    -105363.403522026
69    -105363.4035220222
70    -105363.4035220817
71    -105363.4035220102
72    -105363.4035220699
73    -105363.4035220077
74    -105363.4035221694
75    -105363.4035219957
76    -105363.4035221576
77    -105363.4035220304
78    -105363.4035220836
79    -105363.4035220185
80    -105363.4035220716
81    -105363.4035220662
82    -105363.4035220494
83    -105363.4035220544
84    -105363.4035220375
85    -105363.403522314
86    -105363.4035224016
87    -105363.4035223015
88    -105363.4035223902
89    -105363.4035221282
90    -105363.4035220544
91    -105363.4035221164
92    -105363.4035220425
93    -105363.403522497
94    -105363.403522137
95    -105363.4035224851
96    -105363.403522125
97    -105363.403522075
98    -105363.403522085
99    -105363.4035220625
100   -105363.4035220737
101   -105363.4035220573
102   -105363.4035221158
103   -105363.4035220453
104   -105363.403522104
105   -105363.4035222072
106   -105363.4035222612
107   -105363.403522195
108   -105363.4035222492
109   -105363.4035220137
110   -105363.4035220216
111   -105363.4035220729
112   -105363.4035220809
113   -105363.4035220422
114   -105363.4035220021
115   -105363.4035221016
116   -105363.4035220613
117   -105363.4035219864
118   -105363.4035220459
119   -105363.4035220457
120   -105363.4035221053
121   -105363.403521972
122   -105363.4035221336
123   -105363.4035220312
124   -105363.403522193
125   -105363.4035219947
126   -105363.4035220479
127   -105363.403522054
128   -105363.4035221071
129   -105363.4035220304
130   -105363.4035220136
131   -105363.4035220896
132   -105363.4035220729
133   -105363.403522278
134   -105363.4035223662
135   -105363.4035223372
136   -105363.4035224253
137   -105363.4035220925
138   -105363.4035220188
139   -105363.4035221518
140   -105363.4035220781
141   -105363.4035224612
142   -105363.4035221014
143   -105363.4035225207
144   -105363.4035221604
145   -105363.403522039
146   -105363.4035220494
147   -105363.4035220984
148   -105363.4035221088
149   -105363.4035220216
150   -105363.40352208
151   -105363.4035220808
152   -105363.4035221393
153   -105363.4035221712
154   -105363.4035222254
155   -105363.4035222307
156   -105363.4035222847
157   -105363.4035220704
158   -105363.4035220282
159   -105363.4035220763
160   -105363.403522038
161   -105363.4035220136
162   -105363.4035220732
163   -105363.4035220213
164   -105363.4035220811
165   -105363.403521999
166   -105363.4035221608
167   -105363.4035220071
168   -105363.4035221687
169   -105363.4035220218
170   -105363.403522075
171   -105363.4035220297
172   -105363.4035220829
173   -105363.4035220576
174   -105363.4035220407
175   -105363.4035220654
176   -105363.4035220487
177   -105363.4035223073
178   -105363.403522391
179   -105363.4035223108
180   -105363.4035224034
181   -105363.4035221163
182   -105363.4035220492
183   -105363.403522131
184   -105363.4035220505
185   -105363.4035224879
186   -105363.403522129
187   -105363.4035224968
188   -105363.4035221358
189   -105363.4035220661
190   -105363.4035220765
191   -105363.4035220739
192   -105363.4035220846
193   -105363.4035220494
194   -105363.4035221065
195   -105363.4035220559
196   -105363.4035221158
197   -105363.4035221985
198   -105363.4035222525
199   -105363.4035222063
200   -105363.4035222606
201   -105363.4035220422
202   -105363.4035221016
203   -105363.4035220018
204   -105363.4035220615
205   -105363.4035220277
206   -105363.4035221893
207   -105363.4035219874
208   -105363.4035221491
209   -105363.4035220505
210   -105363.4035221033
211   -105363.4035220103
212   -105363.4035220634
213   -105363.4035220861
214   -105363.4035220692
215   -105363.403522046
216   -105363.4035220293
217   -105363.4035223337
218   -105363.4035224218
219   -105363.4035222934
220   -105363.4035223815
221   -105363.4035221484
222   -105363.4035220743
223   -105363.4035221078
224   -105363.4035220345
225   -105363.4035225169
226   -105363.403522157
227   -105363.4035224768
228   -105363.4035221169
229   -105363.4035220948
230   -105363.4035221051
231   -105363.4035220545
232   -105363.403522065
233   -105363.4035220993
234   -105363.4035221136
235   -105363.4035220149
236   -105363.4035221177
237   -105363.4035222271
238   -105363.4035222809
239   -105363.4035221865
240   -105363.4035222411
241   -105363.4035219719
242   -105363.4035221335
243   -105363.4035220314
244   -105363.4035221931
245   -105363.4035219945
246   -105363.4035220477
247   -105363.403522054
248   -105363.4035221074
249   -105363.4035220303
250   -105363.4035220135
251   -105363.4035220899
252   -105363.4035220731
253   -105363.4035222778
254   -105363.403522366
255   -105363.4035223375
256   -105363.4035224257
257   -105363.4035220922
258   -105363.4035220187
259   -105363.403522152
260   -105363.4035220781
261   -105363.4035224611
262   -105363.4035221011
263   -105363.4035225207
264   -105363.4035221608
265   -105363.403522039
266   -105363.4035220494
267   -105363.4035220985
268   -105363.4035221089
269   -105363.4035220216
270   -105363.4035220799
271   -105363.403522081
272   -105363.4035221396
273   -105363.403522171
274   -105363.4035222253
275   -105363.4035222307
276   -105363.4035222849
277   -105363.4035219844
278   -105363.4035220291
279   -105363.4035221376
280   -105363.4035221991
281   -105363.403522019
282   -105363.4035219959
283   -105363.4035221744
284   -105363.4035221638
285   -105363.4035222687
286   -105363.4035223463
287   -105363.4035224198
288   -105363.4035225184
289   -105363.4035220816
290   -105363.4035220006
291   -105363.403522236
292   -105363.4035221695
293   -105363.4035223798
294   -105363.4035221535
295   -105363.4035226751
296   -105363.4035221817
297   -105363.4035220239
298   -105363.4035220355
299   -105363.4035221867
300   -105363.4035221961
301   -105363.4035220071
302   -105363.4035220655
303   -105363.4035221685
304   -105363.4035222273
305   -105363.4035221593
306   -105363.4035222083
307   -105363.4035223159
308   -105363.403522375
309   -105363.4035220401
310   -105363.4035220202
311   -105363.4035220901
312   -105363.4035220764
313   -105363.403522286
314   -105363.4035223743
315   -105363.4035223394
316   -105363.4035224274
317   -105363.4035221006
318   -105363.4035220269
319   -105363.4035221538
320   -105363.4035220798
321   -105363.4035224693
322   -105363.4035221094
323   -105363.4035225227
324   -105363.4035221625
325   -105363.4035220471
326   -105363.4035220577
327   -105363.4035221002
328   -105363.4035221107
329   -105363.4035220294
330   -105363.4035220885
331   -105363.4035220831
332   -105363.4035221411
333   -105363.4035221815
334   -105363.4035222314
335   -105363.4035222303
336   -105363.4035222889
337   -105363.403522322
338   -105363.4035224098
339   -105363.403522305
340   -105363.4035223933
341   -105363.4035221365
342   -105363.4035220625
343   -105363.4035221195
344   -105363.403522046
345   -105363.4035225021
346   -105363.403522148
347   -105363.4035224913
348   -105363.4035221253
349   -105363.4035220829
350   -105363.4035220934
351   -105363.403522066
352   -105363.4035220766
353   -105363.4035220653
354   -105363.4035221239
355   -105363.4035220485
356   -105363.4035221073
357   -105363.4035222729
358   -105363.4035222115
359   -105363.4035221407
360   -105363.4035223103
361   -105363.4035223461
362   -105363.403522348
363   -105363.4035225097
364   -105363.4035223606
365   -105363.4035227337
366   -105363.4035224115
367   -105363.4035228597
368   -105363.403522462
369   -105363.4035223307
370   -105363.4035223407
371   -105363.4035224182
372   -105363.4035224295
373   -105363.4035223123
374   -105363.403522372
375   -105363.4035224017
376   -105363.403522459
377   -105363.4035224627
378   -105363.4035225169
379   -105363.403522551
380   -105363.403522605
381   -105363.4035225445
382   -105363.4035222299
383   -105363.4035225162
384   -105363.4035221108
385   -105363.403522145
386   -105363.4035221554
387   -105363.4035220711
388   -105363.4035220818
389   -105363.4035221275
390   -105363.403522186
391   -105363.4035220538
392   -105363.4035221122
393   -105363.4035222775
394   -105363.4035223311
395   -105363.4035222032
396   -105363.4035222579
397   -105363.4035225135
398   -105363.4035225244
399   -105363.4035221539
400   -105363.4035221642
401   -105363.4035224964
402   -105363.4035225547
403   -105363.403522136
404   -105363.403522195
405   -105363.4035226434
406   -105363.4035227028
407   -105363.4035222887
408   -105363.4035223374
409   -105363.4035220744
410   -105363.4035221321
411   -105363.4035220842
412   -105363.4035221432
413   -105363.4035222239
414   -105363.4035222778
415   -105363.4035222341
416   -105363.4035222884
417   -105363.4035222067
418   -105363.4035222599
419   -105363.4035222645
420   -105363.4035223193
421   -105363.4035219965
422   -105363.4035221477
423   -105363.4035220583
424   -105363.4035220345
425   -105363.4035219867
426   -105363.4035221051
427   -105363.4035220437
428   -105363.4035220596
429   -105363.4035221098
430   -105363.4035220294
431   -105363.4035219862
432   -105363.4035221054
433   -105363.4035220306
434   -105363.4035223539
435   -105363.4035220129
436   -105363.4035221191
437   -105363.4035220859
438   -105363.4035220523
439   -105363.403523181
440   -105363.4035233573
441   -105363.4035222774
442   -105363.40352213
443   -105363.4035234662
444   -105363.4035227461
445   -105363.4035221476
446   -105363.4035221683
447   -105363.4035221257
448   -105363.4035222429
449   -105363.4035227202
450   -105363.4035228286
:[font = input; preserveAspect; startGroup]
{F3,LIKELI3,LIKI3} = cHesse1Test[Z1,THETA,{system,{Lik1,cEKF1,_}},misc={-9,1}];
:[font = print; inactive; preserveAspect; endGroup]
                                                          -6                         -6            -6            -6                          -6            -6                                                      -6
INK: {0.0000275988, 0.0000104077, 0.0000146182, 6.05545 10  , 0.0000300471, 9.2779 10  , 6.05545 10  , 6.05545 10  , 0.0000615611, 6.05545 10  , 9.79596 10  , 0.0000274162, 0.0000288978, 0.0000150708, 6.05545 10  }
{450, 15}
:[font = input; preserveAspect; startGroup]
LIKELI3
:[font = output; inactive; preserveAspect; fontLeading = 0; endGroup]
-105363.40352204577
;[o]
-105363.
:[font = input; Cclosed; preserveAspect; startGroup]
Map[NumberForm[#,30]&,LIKI3]//MatrixForm
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
 MatrixForm[{NumberForm[-105363.4035220211, 30], NumberForm[-105363.4035220084, 30], NumberForm[-105363.40352209605, 30], NumberForm[-105363.40352208471, 30], NumberForm[-105363.40352198498, 30], NumberForm[-105363.4035220442, 30], NumberForm[-105363.40352206062, 30], NumberForm[-105363.40352211992, 30], NumberForm[-105363.40352201246, 30], NumberForm[-105363.40352201977, 30], NumberForm[-105363.40352208736, 30], NumberForm[-105363.40352209595, 30], NumberForm[-105363.40352204074, 30], NumberForm[-105363.40352200021, 30], NumberForm[-105363.40352211599, 30], NumberForm[-105363.40352207625, 30], NumberForm[-105363.40352198492, 30], NumberForm[-105363.40352204445, 30], NumberForm[-105363.40352206022, 30], NumberForm[-105363.40352211993, 30], NumberForm[-105363.40352196994, 30], 

    NumberForm[-105363.40352213237, 30], NumberForm[-105363.4035220465, 30], NumberForm[-105363.40352220726, 30], NumberForm[-105363.4035219931, 30], NumberForm[-105363.40352204641, 30], NumberForm[-105363.40352206859, 30], NumberForm[-105363.4035221218, 30], NumberForm[-105363.40352202885, 30], NumberForm[-105363.40352201209, 30], NumberForm[-105363.40352210435, 30], NumberForm[-105363.4035220876, 30], NumberForm[-105363.40352226184, 30], NumberForm[-105363.40352237906, 30], NumberForm[-105363.40352236644, 30], NumberForm[-105363.40352242568, 30], NumberForm[-105363.40352209155, 30], NumberForm[-105363.40352201644, 30], NumberForm[-105363.40352216584, 30], NumberForm[-105363.40352209352, 30], NumberForm[-105363.40352245887, 30], NumberForm[-105363.40352210037, 30], 

    NumberForm[-105363.4035225359, 30], NumberForm[-105363.4035221745, 30], NumberForm[-105363.4035220564, 30], NumberForm[-105363.40352202897, 30], NumberForm[-105363.40352209407, 30], NumberForm[-105363.4035221423, 30], NumberForm[-105363.40352202006, 30], NumberForm[-105363.40352207834, 30], NumberForm[-105363.40352209538, 30], NumberForm[-105363.4035221542, 30], NumberForm[-105363.40352216981, 30], NumberForm[-105363.40352222367, 30], NumberForm[-105363.40352224521, 30], NumberForm[-105363.4035222996, 30], NumberForm[-105363.40352202245, 30], NumberForm[-105363.40352208156, 30], NumberForm[-105363.4035220104, 30], NumberForm[-105363.40352206962, 30], NumberForm[-105363.40352204962, 30], NumberForm[-105363.40352205715, 30], NumberForm[-105363.40352203744, 30], 

    NumberForm[-105363.40352204554, 30], NumberForm[-105363.40352207815, 30], NumberForm[-105363.40352203776, 30], NumberForm[-105363.4035220659, 30], NumberForm[-105363.40352202604, 30], NumberForm[-105363.40352202211, 30], NumberForm[-105363.40352208175, 30], NumberForm[-105363.40352201025, 30], NumberForm[-105363.40352206986, 30], NumberForm[-105363.40352200772, 30], NumberForm[-105363.4035221694, 30], NumberForm[-105363.40352199576, 30], NumberForm[-105363.4035221575, 30], NumberForm[-105363.40352203033, 30], NumberForm[-105363.40352208356, 30], NumberForm[-105363.40352201846, 30], NumberForm[-105363.4035220716, 30], NumberForm[-105363.40352206613, 30], NumberForm[-105363.40352204932, 30], NumberForm[-105363.40352205432, 30], NumberForm[-105363.40352203752, 30], 

    NumberForm[-105363.40352231397, 30], NumberForm[-105363.40352240155, 30], NumberForm[-105363.40352230148, 30], NumberForm[-105363.40352239025, 30], NumberForm[-105363.40352212824, 30], NumberForm[-105363.40352205448, 30], NumberForm[-105363.40352211644, 30], NumberForm[-105363.40352204248, 30], NumberForm[-105363.40352249684, 30], NumberForm[-105363.40352213707, 30], NumberForm[-105363.40352248512, 30], NumberForm[-105363.40352212501, 30], NumberForm[-105363.40352207504, 30], NumberForm[-105363.40352208505, 30], NumberForm[-105363.4035220625, 30], NumberForm[-105363.40352207373, 30], NumberForm[-105363.40352205737, 30], NumberForm[-105363.40352211572, 30], NumberForm[-105363.40352204534, 30], NumberForm[-105363.40352210395, 30], NumberForm[-105363.40352220704, 30], 

    NumberForm[-105363.40352226113, 30], NumberForm[-105363.40352219516, 30], NumberForm[-105363.40352224917, 30], NumberForm[-105363.40352201367, 30], NumberForm[-105363.40352202156, 30], NumberForm[-105363.40352207291, 30], NumberForm[-105363.40352208084, 30], NumberForm[-105363.40352204231, 30], NumberForm[-105363.40352200209, 30], NumberForm[-105363.40352210142, 30], NumberForm[-105363.40352206127, 30], NumberForm[-105363.40352198642, 30], NumberForm[-105363.40352204596, 30], NumberForm[-105363.40352204576, 30], NumberForm[-105363.40352210529, 30], NumberForm[-105363.40352197201, 30], NumberForm[-105363.40352213354, 30], NumberForm[-105363.40352203119, 30], NumberForm[-105363.40352219307, 30], NumberForm[-105363.40352199475, 30], NumberForm[-105363.40352204793, 30], 

    NumberForm[-105363.403522054, 30], NumberForm[-105363.40352210711, 30], NumberForm[-105363.40352203055, 30], NumberForm[-105363.40352201361, 30], NumberForm[-105363.40352208965, 30], NumberForm[-105363.40352207293, 30], NumberForm[-105363.40352227804, 30], NumberForm[-105363.40352236628, 30], NumberForm[-105363.40352233728, 30], NumberForm[-105363.40352242542, 30], NumberForm[-105363.40352209257, 30], NumberForm[-105363.40352201885, 30], NumberForm[-105363.40352215183, 30], NumberForm[-105363.40352207818, 30], NumberForm[-105363.40352246123, 30], NumberForm[-105363.40352210145, 30], NumberForm[-105363.40352252059, 30], NumberForm[-105363.40352216052, 30], NumberForm[-105363.40352203907, 30], NumberForm[-105363.4035220495, 30], NumberForm[-105363.4035220984, 30], 

    NumberForm[-105363.4035221089, 30], NumberForm[-105363.4035220216, 30], NumberForm[-105363.4035220801, 30], NumberForm[-105363.40352208083, 30], NumberForm[-105363.40352213934, 30], NumberForm[-105363.40352217117, 30], NumberForm[-105363.40352222542, 30], NumberForm[-105363.40352223054, 30], NumberForm[-105363.40352228482, 30], NumberForm[-105363.40352207041, 30], NumberForm[-105363.40352202833, 30], NumberForm[-105363.40352207626, 30], NumberForm[-105363.40352203803, 30], NumberForm[-105363.40352201363, 30], NumberForm[-105363.40352207319, 30], NumberForm[-105363.40352202144, 30], NumberForm[-105363.40352208112, 30], NumberForm[-105363.40352199899, 30], NumberForm[-105363.40352216078, 30], NumberForm[-105363.40352200705, 30], NumberForm[-105363.40352216859, 30], 

    NumberForm[-105363.4035220218, 30], NumberForm[-105363.40352207508, 30], NumberForm[-105363.40352202971, 30], NumberForm[-105363.40352208285, 30], NumberForm[-105363.4035220575, 30], NumberForm[-105363.4035220406, 30], NumberForm[-105363.40352206542, 30], NumberForm[-105363.4035220487, 30], NumberForm[-105363.40352230737, 30], NumberForm[-105363.40352239094, 30], NumberForm[-105363.40352231078, 30], NumberForm[-105363.40352240334, 30], NumberForm[-105363.40352211634, 30], NumberForm[-105363.40352204909, 30], NumberForm[-105363.40352213077, 30], NumberForm[-105363.40352205052, 30], NumberForm[-105363.40352248779, 30], NumberForm[-105363.40352212892, 30], NumberForm[-105363.40352249675, 30], NumberForm[-105363.40352213585, 30], NumberForm[-105363.40352206616, 30], 

    NumberForm[-105363.4035220765, 30], NumberForm[-105363.40352207396, 30], NumberForm[-105363.40352208458, 30], NumberForm[-105363.4035220495, 30], NumberForm[-105363.40352210662, 30], NumberForm[-105363.40352205581, 30], NumberForm[-105363.40352211584, 30], NumberForm[-105363.4035221985, 30], NumberForm[-105363.4035222524, 30], NumberForm[-105363.40352220624, 30], NumberForm[-105363.40352226057, 30], NumberForm[-105363.40352204221, 30], NumberForm[-105363.40352210168, 30], NumberForm[-105363.40352200186, 30], NumberForm[-105363.40352206156, 30], NumberForm[-105363.40352202767, 30], NumberForm[-105363.40352218917, 30], NumberForm[-105363.4035219875, 30], NumberForm[-105363.40352214908, 30], NumberForm[-105363.40352205055, 30], NumberForm[-105363.40352210338, 30], 

    NumberForm[-105363.40352201027, 30], NumberForm[-105363.40352206347, 30], NumberForm[-105363.40352208621, 30], NumberForm[-105363.4035220692, 30], NumberForm[-105363.40352204605, 30], NumberForm[-105363.40352202924, 30], NumberForm[-105363.40352233364, 30], NumberForm[-105363.40352242166, 30], NumberForm[-105363.40352229339, 30], NumberForm[-105363.40352238163, 30], NumberForm[-105363.40352214841, 30], NumberForm[-105363.40352207422, 30], NumberForm[-105363.4035221077, 30], NumberForm[-105363.40352203444, 30], NumberForm[-105363.40352251685, 30], NumberForm[-105363.40352215696, 30], NumberForm[-105363.40352247682, 30], NumberForm[-105363.40352211676, 30], NumberForm[-105363.40352209473, 30], NumberForm[-105363.40352210503, 30], NumberForm[-105363.40352205452, 30], 

    NumberForm[-105363.40352206508, 30], NumberForm[-105363.40352209924, 30], NumberForm[-105363.40352211353, 30], NumberForm[-105363.4035220148, 30], NumberForm[-105363.40352211778, 30], NumberForm[-105363.40352222712, 30], NumberForm[-105363.4035222808, 30], NumberForm[-105363.40352218658, 30], NumberForm[-105363.40352224113, 30], NumberForm[-105363.40352197182, 30], NumberForm[-105363.40352213343, 30], NumberForm[-105363.40352203141, 30], NumberForm[-105363.40352219304, 30], NumberForm[-105363.40352199465, 30], NumberForm[-105363.40352204758, 30], NumberForm[-105363.40352205398, 30], NumberForm[-105363.4035221073, 30], NumberForm[-105363.40352203014, 30], NumberForm[-105363.40352201347, 30], NumberForm[-105363.40352208994, 30], NumberForm[-105363.40352207303, 30], 

    NumberForm[-105363.40352227789, 30], NumberForm[-105363.403522366, 30], NumberForm[-105363.40352233747, 30], NumberForm[-105363.40352242553, 30], NumberForm[-105363.40352209222, 30], NumberForm[-105363.40352201865, 30], NumberForm[-105363.40352215206, 30], NumberForm[-105363.4035220782, 30], NumberForm[-105363.40352246113, 30], NumberForm[-105363.40352210094, 30], NumberForm[-105363.40352252066, 30], NumberForm[-105363.4035221607, 30], NumberForm[-105363.40352203888, 30], NumberForm[-105363.40352204935, 30], NumberForm[-105363.40352209848, 30], NumberForm[-105363.40352210894, 30], NumberForm[-105363.40352202154, 30], NumberForm[-105363.40352207987, 30], NumberForm[-105363.40352208087, 30], NumberForm[-105363.40352213968, 30], NumberForm[-105363.40352217102, 30], 

    NumberForm[-105363.40352222526, 30], NumberForm[-105363.40352223068, 30], NumberForm[-105363.40352228489, 30], NumberForm[-105363.4035219844, 30], NumberForm[-105363.40352202911, 30], NumberForm[-105363.40352213752, 30], NumberForm[-105363.40352219912, 30], NumberForm[-105363.40352201897, 30], NumberForm[-105363.40352199586, 30], NumberForm[-105363.40352217425, 30], NumberForm[-105363.40352216373, 30], NumberForm[-105363.40352226862, 30], NumberForm[-105363.40352234618, 30], NumberForm[-105363.4035224198, 30], NumberForm[-105363.40352251849, 30], NumberForm[-105363.40352208154, 30], NumberForm[-105363.40352200059, 30], NumberForm[-105363.40352223601, 30], NumberForm[-105363.40352216958, 30], NumberForm[-105363.40352237991, 30], NumberForm[-105363.40352215344, 30], 

    NumberForm[-105363.4035226751, 30], NumberForm[-105363.40352218163, 30], NumberForm[-105363.40352202389, 30], NumberForm[-105363.40352203562, 30], NumberForm[-105363.40352218664, 30], NumberForm[-105363.40352219605, 30], NumberForm[-105363.40352200708, 30], NumberForm[-105363.40352206545, 30], NumberForm[-105363.40352216859, 30], NumberForm[-105363.40352222734, 30], NumberForm[-105363.40352215918, 30], NumberForm[-105363.40352220829, 30], NumberForm[-105363.40352231602, 30], NumberForm[-105363.40352237494, 30], NumberForm[-105363.40352204008, 30], NumberForm[-105363.4035220202, 30], NumberForm[-105363.40352209014, 30], NumberForm[-105363.40352207642, 30], NumberForm[-105363.40352228597, 30], NumberForm[-105363.40352237434, 30], NumberForm[-105363.40352233931, 30], 

    NumberForm[-105363.40352242744, 30], NumberForm[-105363.40352210063, 30], NumberForm[-105363.40352202691, 30], NumberForm[-105363.40352215378, 30], NumberForm[-105363.40352207999, 30], NumberForm[-105363.40352246937, 30], NumberForm[-105363.40352210945, 30], NumberForm[-105363.40352252264, 30], NumberForm[-105363.40352216245, 30], NumberForm[-105363.40352204717, 30], NumberForm[-105363.40352205768, 30], NumberForm[-105363.40352210027, 30], NumberForm[-105363.40352211062, 30], NumberForm[-105363.40352202936, 30], NumberForm[-105363.40352208853, 30], NumberForm[-105363.40352208298, 30], NumberForm[-105363.40352214104, 30], NumberForm[-105363.40352218162, 30], NumberForm[-105363.40352223149, 30], NumberForm[-105363.40352223036, 30], NumberForm[-105363.40352228876, 30], 

    NumberForm[-105363.40352232201, 30], NumberForm[-105363.40352240983, 30], NumberForm[-105363.40352230496, 30], NumberForm[-105363.40352239327, 30], NumberForm[-105363.4035221365, 30], NumberForm[-105363.40352206258, 30], NumberForm[-105363.40352211952, 30], NumberForm[-105363.403522046, 30], NumberForm[-105363.40352250206, 30], NumberForm[-105363.40352214812, 30], NumberForm[-105363.40352249125, 30], NumberForm[-105363.40352212529, 30], NumberForm[-105363.40352208281, 30], NumberForm[-105363.40352209329, 30], NumberForm[-105363.403522066, 30], NumberForm[-105363.40352207664, 30], NumberForm[-105363.4035220654, 30], NumberForm[-105363.40352212393, 30], NumberForm[-105363.40352204863, 30], NumberForm[-105363.40352210728, 30], NumberForm[-105363.40352227296, 30], 

    NumberForm[-105363.40352221153, 30], NumberForm[-105363.40352214062, 30], NumberForm[-105363.40352231015, 30], NumberForm[-105363.40352234615, 30], NumberForm[-105363.40352234797, 30], NumberForm[-105363.40352250973, 30], NumberForm[-105363.4035223606, 30], NumberForm[-105363.40352273385, 30], NumberForm[-105363.40352241158, 30], NumberForm[-105363.40352285968, 30], NumberForm[-105363.4035224619, 30], NumberForm[-105363.40352233085, 30], NumberForm[-105363.40352234058, 30], NumberForm[-105363.40352241829, 30], NumberForm[-105363.40352242958, 30], NumberForm[-105363.40352231229, 30], NumberForm[-105363.40352237219, 30], NumberForm[-105363.40352240174, 30], NumberForm[-105363.40352245903, 30], NumberForm[-105363.40352246255, 30], NumberForm[-105363.40352251694, 30], 

    NumberForm[-105363.40352255086, 30], NumberForm[-105363.40352260486, 30], NumberForm[-105363.40352254453, 30], NumberForm[-105363.40352222991, 30], NumberForm[-105363.40352251624, 30], NumberForm[-105363.40352211068, 30], NumberForm[-105363.40352214508, 30], NumberForm[-105363.40352215536, 30], NumberForm[-105363.40352207118, 30], NumberForm[-105363.40352208176, 30], NumberForm[-105363.4035221275, 30], NumberForm[-105363.40352218608, 30], NumberForm[-105363.40352205375, 30], NumberForm[-105363.40352211228, 30], NumberForm[-105363.40352227748, 30], NumberForm[-105363.40352233111, 30], NumberForm[-105363.40352220325, 30], NumberForm[-105363.4035222578, 30], NumberForm[-105363.40352251352, 30], NumberForm[-105363.40352252431, 30], NumberForm[-105363.40352215376, 30], 

    NumberForm[-105363.40352216404, 30], NumberForm[-105363.40352249629, 30], NumberForm[-105363.40352255465, 30], NumberForm[-105363.40352213591, 30], NumberForm[-105363.40352219503, 30], NumberForm[-105363.40352264329, 30], NumberForm[-105363.40352270284, 30], NumberForm[-105363.40352228862, 30], NumberForm[-105363.40352233736, 30], NumberForm[-105363.40352207435, 30], NumberForm[-105363.40352213223, 30], NumberForm[-105363.40352208407, 30], NumberForm[-105363.40352214327, 30], NumberForm[-105363.40352222386, 30], NumberForm[-105363.4035222778, 30], NumberForm[-105363.40352223403, 30], NumberForm[-105363.4035222884, 30], NumberForm[-105363.40352220664, 30], NumberForm[-105363.40352225993, 30], NumberForm[-105363.40352226433, 30], NumberForm[-105363.4035223193, 30], 

    NumberForm[-105363.40352199657, 30], NumberForm[-105363.40352214771, 30], NumberForm[-105363.40352205833, 30], NumberForm[-105363.40352203447, 30], NumberForm[-105363.40352198658, 30], NumberForm[-105363.40352210504, 30], NumberForm[-105363.40352204377, 30], NumberForm[-105363.40352205955, 30], NumberForm[-105363.4035221098, 30], NumberForm[-105363.40352202937, 30], NumberForm[-105363.40352198624, 30], NumberForm[-105363.40352210533, 30], NumberForm[-105363.40352203071, 30], NumberForm[-105363.4035223539, 30], NumberForm[-105363.40352201281, 30], NumberForm[-105363.40352211923, 30], NumberForm[-105363.40352208592, 30], NumberForm[-105363.40352205234, 30], NumberForm[-105363.4035231811, 30], NumberForm[-105363.40352335734, 30], NumberForm[-105363.40352227738, 30], 

    NumberForm[-105363.40352213003, 30], NumberForm[-105363.40352346601, 30], NumberForm[-105363.40352274604, 30], NumberForm[-105363.40352214756, 30], NumberForm[-105363.40352216843, 30], NumberForm[-105363.40352212559, 30], NumberForm[-105363.40352224285, 30], NumberForm[-105363.40352272023, 30], NumberForm[-105363.4035228285, 30]}]
;[o]

1     -105363.4035220211
2     -105363.4035220084
3     -105363.403522096
4     -105363.4035220847
5     -105363.403521985
6     -105363.4035220442
7     -105363.4035220606
8     -105363.4035221199
9     -105363.4035220125
10    -105363.4035220198
11    -105363.4035220874
12    -105363.4035220959
13    -105363.4035220407
14    -105363.4035220002
15    -105363.403522116
16    -105363.4035220762
17    -105363.4035219849
18    -105363.4035220445
19    -105363.4035220602
20    -105363.4035221199
21    -105363.4035219699
22    -105363.4035221324
23    -105363.4035220465
24    -105363.4035222073
25    -105363.4035219931
26    -105363.4035220464
27    -105363.4035220686
28    -105363.4035221218
29    -105363.4035220288
30    -105363.4035220121
31    -105363.4035221043
32    -105363.4035220876
33    -105363.4035222618
34    -105363.403522379
35    -105363.4035223664
36    -105363.4035224257
37    -105363.4035220915
38    -105363.4035220164
39    -105363.4035221658
40    -105363.4035220935
41    -105363.4035224589
42    -105363.4035221004
43    -105363.4035225359
44    -105363.4035221745
45    -105363.4035220564
46    -105363.403522029
47    -105363.4035220941
48    -105363.4035221423
49    -105363.40352202
50    -105363.4035220783
51    -105363.4035220954
52    -105363.4035221542
53    -105363.4035221698
54    -105363.4035222237
55    -105363.4035222452
56    -105363.4035222996
57    -105363.4035220224
58    -105363.4035220816
59    -105363.4035220104
60    -105363.4035220696
61    -105363.4035220496
62    -105363.4035220572
63    -105363.4035220374
64    -105363.4035220455
65    -105363.4035220782
66    -105363.4035220377
67    -105363.4035220659
68    -105363.403522026
69    -105363.4035220221
70    -105363.4035220818
71    -105363.4035220103
72    -105363.4035220699
73    -105363.4035220077
74    -105363.4035221694
75    -105363.4035219958
76    -105363.4035221575
77    -105363.4035220303
78    -105363.4035220836
79    -105363.4035220185
80    -105363.4035220716
81    -105363.4035220661
82    -105363.4035220493
83    -105363.4035220543
84    -105363.4035220375
85    -105363.403522314
86    -105363.4035224015
87    -105363.4035223015
88    -105363.4035223902
89    -105363.4035221282
90    -105363.4035220545
91    -105363.4035221164
92    -105363.4035220425
93    -105363.4035224968
94    -105363.4035221371
95    -105363.4035224851
96    -105363.403522125
97    -105363.403522075
98    -105363.403522085
99    -105363.4035220625
100   -105363.4035220737
101   -105363.4035220574
102   -105363.4035221157
103   -105363.4035220453
104   -105363.403522104
105   -105363.403522207
106   -105363.4035222611
107   -105363.4035221952
108   -105363.4035222492
109   -105363.4035220137
110   -105363.4035220216
111   -105363.4035220729
112   -105363.4035220808
113   -105363.4035220423
114   -105363.4035220021
115   -105363.4035221014
116   -105363.4035220613
117   -105363.4035219864
118   -105363.403522046
119   -105363.4035220458
120   -105363.4035221053
121   -105363.403521972
122   -105363.4035221335
123   -105363.4035220312
124   -105363.4035221931
125   -105363.4035219948
126   -105363.4035220479
127   -105363.403522054
128   -105363.4035221071
129   -105363.4035220306
130   -105363.4035220136
131   -105363.4035220896
132   -105363.4035220729
133   -105363.403522278
134   -105363.4035223663
135   -105363.4035223373
136   -105363.4035224254
137   -105363.4035220926
138   -105363.4035220189
139   -105363.4035221518
140   -105363.4035220782
141   -105363.4035224612
142   -105363.4035221015
143   -105363.4035225206
144   -105363.4035221605
145   -105363.4035220391
146   -105363.4035220495
147   -105363.4035220984
148   -105363.4035221089
149   -105363.4035220216
150   -105363.4035220801
151   -105363.4035220808
152   -105363.4035221393
153   -105363.4035221712
154   -105363.4035222254
155   -105363.4035222305
156   -105363.4035222848
157   -105363.4035220704
158   -105363.4035220283
159   -105363.4035220762
160   -105363.403522038
161   -105363.4035220136
162   -105363.4035220732
163   -105363.4035220214
164   -105363.4035220811
165   -105363.403521999
166   -105363.4035221608
167   -105363.4035220071
168   -105363.4035221686
169   -105363.4035220218
170   -105363.4035220751
171   -105363.4035220297
172   -105363.4035220828
173   -105363.4035220575
174   -105363.4035220406
175   -105363.4035220654
176   -105363.4035220487
177   -105363.4035223074
178   -105363.403522391
179   -105363.4035223108
180   -105363.4035224033
181   -105363.4035221163
182   -105363.4035220491
183   -105363.4035221308
184   -105363.4035220505
185   -105363.4035224878
186   -105363.4035221289
187   -105363.4035224968
188   -105363.4035221358
189   -105363.4035220662
190   -105363.4035220765
191   -105363.403522074
192   -105363.4035220846
193   -105363.4035220495
194   -105363.4035221066
195   -105363.4035220558
196   -105363.4035221158
197   -105363.4035221985
198   -105363.4035222524
199   -105363.4035222062
200   -105363.4035222606
201   -105363.4035220422
202   -105363.4035221017
203   -105363.4035220019
204   -105363.4035220616
205   -105363.4035220277
206   -105363.4035221892
207   -105363.4035219875
208   -105363.4035221491
209   -105363.4035220505
210   -105363.4035221034
211   -105363.4035220103
212   -105363.4035220635
213   -105363.4035220862
214   -105363.4035220692
215   -105363.403522046
216   -105363.4035220292
217   -105363.4035223336
218   -105363.4035224217
219   -105363.4035222934
220   -105363.4035223816
221   -105363.4035221484
222   -105363.4035220742
223   -105363.4035221077
224   -105363.4035220344
225   -105363.4035225169
226   -105363.403522157
227   -105363.4035224768
228   -105363.4035221167
229   -105363.4035220947
230   -105363.403522105
231   -105363.4035220545
232   -105363.4035220651
233   -105363.4035220992
234   -105363.4035221135
235   -105363.4035220148
236   -105363.4035221178
237   -105363.4035222271
238   -105363.4035222808
239   -105363.4035221866
240   -105363.4035222411
241   -105363.4035219718
242   -105363.4035221334
243   -105363.4035220314
244   -105363.403522193
245   -105363.4035219946
246   -105363.4035220476
247   -105363.403522054
248   -105363.4035221073
249   -105363.4035220302
250   -105363.4035220135
251   -105363.40352209
252   -105363.403522073
253   -105363.4035222779
254   -105363.403522366
255   -105363.4035223375
256   -105363.4035224255
257   -105363.4035220922
258   -105363.4035220187
259   -105363.403522152
260   -105363.4035220782
261   -105363.4035224611
262   -105363.4035221009
263   -105363.4035225207
264   -105363.4035221607
265   -105363.4035220389
266   -105363.4035220494
267   -105363.4035220985
268   -105363.4035221089
269   -105363.4035220215
270   -105363.4035220799
271   -105363.4035220809
272   -105363.4035221397
273   -105363.403522171
274   -105363.4035222253
275   -105363.4035222307
276   -105363.4035222849
277   -105363.4035219844
278   -105363.4035220291
279   -105363.4035221375
280   -105363.4035221991
281   -105363.403522019
282   -105363.4035219959
283   -105363.4035221743
284   -105363.4035221637
285   -105363.4035222686
286   -105363.4035223462
287   -105363.4035224198
288   -105363.4035225185
289   -105363.4035220815
290   -105363.4035220006
291   -105363.403522236
292   -105363.4035221696
293   -105363.4035223799
294   -105363.4035221535
295   -105363.4035226751
296   -105363.4035221816
297   -105363.4035220239
298   -105363.4035220356
299   -105363.4035221866
300   -105363.403522196
301   -105363.4035220071
302   -105363.4035220655
303   -105363.4035221686
304   -105363.4035222273
305   -105363.4035221592
306   -105363.4035222083
307   -105363.403522316
308   -105363.4035223749
309   -105363.4035220401
310   -105363.4035220202
311   -105363.4035220901
312   -105363.4035220764
313   -105363.403522286
314   -105363.4035223743
315   -105363.4035223393
316   -105363.4035224274
317   -105363.4035221006
318   -105363.4035220269
319   -105363.4035221538
320   -105363.40352208
321   -105363.4035224694
322   -105363.4035221094
323   -105363.4035225226
324   -105363.4035221624
325   -105363.4035220472
326   -105363.4035220577
327   -105363.4035221003
328   -105363.4035221106
329   -105363.4035220294
330   -105363.4035220885
331   -105363.403522083
332   -105363.403522141
333   -105363.4035221816
334   -105363.4035222315
335   -105363.4035222304
336   -105363.4035222888
337   -105363.403522322
338   -105363.4035224098
339   -105363.403522305
340   -105363.4035223933
341   -105363.4035221365
342   -105363.4035220626
343   -105363.4035221195
344   -105363.403522046
345   -105363.4035225021
346   -105363.4035221481
347   -105363.4035224913
348   -105363.4035221253
349   -105363.4035220828
350   -105363.4035220933
351   -105363.403522066
352   -105363.4035220766
353   -105363.4035220654
354   -105363.4035221239
355   -105363.4035220486
356   -105363.4035221073
357   -105363.403522273
358   -105363.4035222115
359   -105363.4035221406
360   -105363.4035223102
361   -105363.4035223461
362   -105363.403522348
363   -105363.4035225097
364   -105363.4035223606
365   -105363.4035227339
366   -105363.4035224116
367   -105363.4035228597
368   -105363.4035224619
369   -105363.4035223308
370   -105363.4035223406
371   -105363.4035224183
372   -105363.4035224296
373   -105363.4035223123
374   -105363.4035223722
375   -105363.4035224017
376   -105363.403522459
377   -105363.4035224626
378   -105363.4035225169
379   -105363.4035225508
380   -105363.4035226048
381   -105363.4035225445
382   -105363.4035222299
383   -105363.4035225162
384   -105363.4035221107
385   -105363.4035221451
386   -105363.4035221554
387   -105363.4035220712
388   -105363.4035220818
389   -105363.4035221275
390   -105363.4035221861
391   -105363.4035220538
392   -105363.4035221123
393   -105363.4035222775
394   -105363.4035223311
395   -105363.4035222033
396   -105363.4035222578
397   -105363.4035225135
398   -105363.4035225243
399   -105363.4035221538
400   -105363.403522164
401   -105363.4035224963
402   -105363.4035225546
403   -105363.4035221359
404   -105363.403522195
405   -105363.4035226433
406   -105363.4035227028
407   -105363.4035222886
408   -105363.4035223374
409   -105363.4035220744
410   -105363.4035221322
411   -105363.4035220841
412   -105363.4035221433
413   -105363.4035222239
414   -105363.4035222778
415   -105363.403522234
416   -105363.4035222884
417   -105363.4035222067
418   -105363.4035222599
419   -105363.4035222643
420   -105363.4035223193
421   -105363.4035219966
422   -105363.4035221477
423   -105363.4035220583
424   -105363.4035220345
425   -105363.4035219866
426   -105363.403522105
427   -105363.4035220438
428   -105363.4035220596
429   -105363.4035221098
430   -105363.4035220294
431   -105363.4035219862
432   -105363.4035221053
433   -105363.4035220307
434   -105363.4035223539
435   -105363.4035220128
436   -105363.4035221192
437   -105363.4035220859
438   -105363.4035220523
439   -105363.4035231811
440   -105363.4035233573
441   -105363.4035222774
442   -105363.40352213
443   -105363.403523466
444   -105363.403522746
445   -105363.4035221476
446   -105363.4035221684
447   -105363.4035221256
448   -105363.4035222428
449   -105363.4035227202
450   -105363.4035228285
:[font = input; preserveAspect; startGroup]
LIKI1[[1]]//NumberForm[#,30]&
LIKI3[[1]]//NumberForm[#,30]&
:[font = output; output; inactive; preserveAspect]
NumberForm[-105363.40352202096, 30]
;[o]
-105363.403522021
:[font = output; output; inactive; preserveAspect; endGroup]
NumberForm[-105363.4035220211, 30]
;[o]
-105363.4035220211
:[font = input; preserveAspect; startGroup]
Map[NumberForm[#,30]&,{LIKI1,LIKI3,LIKI1-LIKI3}//Transpose]//MatrixForm
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup]
 MatrixForm[{NumberForm[{-105363.40352202096, -105363.4035220211, 1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352200838, -105363.4035220084, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352209598, -105363.40352209605, 7.275957614183426*^-11}, 30], NumberForm[{-105363.4035220848, -105363.40352208471, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352198496, -105363.40352198498, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352204429, -105363.4035220442, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352206047, -105363.40352206062, 1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352211983, -105363.40352211992, 8.731149137020111*^-11}, 30], NumberForm[{-105363.40352201248, -105363.40352201246, -1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352201964, -105363.40352201977, 1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352208732, -105363.40352208736, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352209598, -105363.40352209595, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352204081, -105363.40352204074, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352200023, -105363.40352200021, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.403522116, -105363.40352211599, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.4035220763, -105363.40352207625, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352198487, -105363.40352198492, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352204446, -105363.40352204445, -1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352206033, -105363.40352206022, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352212, -105363.40352211993, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352196996, -105363.40352196994, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352213242, -105363.40352213237, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352204643, -105363.4035220465, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352220717, -105363.40352220726, 8.731149137020111*^-11}, 30], NumberForm[{-105363.40352199308, -105363.4035219931, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352204628, -105363.40352204641, 1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352206868, -105363.40352206859, -8.731149137020111*^-11}, 30], 

    NumberForm[{-105363.40352212178, -105363.4035221218, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352202884, -105363.40352202885, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352201207, -105363.40352201209, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352210435, -105363.40352210435, 0.}, 30], NumberForm[{-105363.40352208765, -105363.4035220876, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352226188, -105363.40352226184, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352237914, -105363.40352237906, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352236647, -105363.40352236644, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352242556, -105363.40352242568, 1.1641532182693481*^-10}, 30], 

    NumberForm[{-105363.40352209163, -105363.40352209155, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352201642, -105363.40352201644, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352216587, -105363.40352216584, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352209346, -105363.40352209352, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352245877, -105363.40352245887, 1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352210042, -105363.40352210037, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352253604, -105363.4035225359, -1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352217457, -105363.4035221745, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352205632, -105363.4035220564, 7.275957614183426*^-11}, 30], 

    NumberForm[{-105363.40352202905, -105363.40352202897, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352209416, -105363.40352209407, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352214228, -105363.4035221423, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352202006, -105363.40352202006, 0.}, 30], NumberForm[{-105363.40352207834, -105363.40352207834, 0.}, 30], NumberForm[{-105363.40352209535, -105363.40352209538, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352215421, -105363.4035221542, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352216977, -105363.40352216981, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352222369, -105363.40352222367, -1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352224516, -105363.40352224521, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352229954, -105363.4035222996, 5.820766091346741*^-11}, 30], NumberForm[{-105363.4035220225, -105363.40352202245, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352208156, -105363.40352208156, 0.}, 30], NumberForm[{-105363.40352201043, -105363.4035220104, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352206973, -105363.40352206962, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352204957, -105363.40352204962, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352205715, -105363.40352205715, 0.}, 30], NumberForm[{-105363.40352203736, -105363.40352203744, 7.275957614183426*^-11}, 30], 

    NumberForm[{-105363.40352204558, -105363.40352204554, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352207815, -105363.40352207815, 0.}, 30], NumberForm[{-105363.40352203765, -105363.40352203776, 1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352206587, -105363.4035220659, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352202604, -105363.40352202604, 0.}, 30], NumberForm[{-105363.40352202216, -105363.40352202211, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352208167, -105363.40352208175, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352201024, -105363.40352201025, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352206986, -105363.40352206986, 0.}, 30], NumberForm[{-105363.40352200775, -105363.40352200772, -2.9103830456733704*^-11}, 30], 

    NumberForm[{-105363.40352216938, -105363.4035221694, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352199573, -105363.40352199576, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352215759, -105363.4035221575, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352203045, -105363.40352203033, -1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352208365, -105363.40352208356, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352201852, -105363.40352201846, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352207156, -105363.4035220716, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352206619, -105363.40352206613, -5.820766091346741*^-11}, 30], NumberForm[{-105363.4035220494, -105363.40352204932, -7.275957614183426*^-11}, 30], 

    NumberForm[{-105363.40352205434, -105363.40352205432, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352203748, -105363.40352203752, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352231395, -105363.40352231397, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352240161, -105363.40352240155, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352230152, -105363.40352230148, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352239016, -105363.40352239025, 8.731149137020111*^-11}, 30], NumberForm[{-105363.40352212824, -105363.40352212824, 0.}, 30], NumberForm[{-105363.40352205443, -105363.40352205448, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352211636, -105363.40352211644, 7.275957614183426*^-11}, 30], 

    NumberForm[{-105363.40352204251, -105363.40352204248, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352249698, -105363.40352249684, -1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352213704, -105363.40352213707, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352248507, -105363.40352248512, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352212501, -105363.40352212501, 0.}, 30], NumberForm[{-105363.40352207496, -105363.40352207504, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352208499, -105363.40352208505, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352206245, -105363.4035220625, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352207367, -105363.40352207373, 5.820766091346741*^-11}, 30], 

    NumberForm[{-105363.40352205731, -105363.40352205737, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352211578, -105363.40352211572, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352204534, -105363.40352204534, 0.}, 30], NumberForm[{-105363.403522104, -105363.40352210395, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352220718, -105363.40352220704, -1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352226117, -105363.40352226113, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352219503, -105363.40352219516, 1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352224922, -105363.40352224917, -5.820766091346741*^-11}, 30], NumberForm[{-105363.4035220137, -105363.40352201367, -2.9103830456733704*^-11}, 30], 

    NumberForm[{-105363.40352202156, -105363.40352202156, 0.}, 30], NumberForm[{-105363.40352207294, -105363.40352207291, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352208087, -105363.40352208084, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.4035220422, -105363.40352204231, 1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352200212, -105363.40352200209, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.4035221016, -105363.40352210142, -1.7462298274040222*^-10}, 30], NumberForm[{-105363.40352206132, -105363.40352206127, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035219864, -105363.40352198642, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352204595, -105363.40352204596, 1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352204569, -105363.40352204576, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352210528, -105363.40352210529, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352197202, -105363.40352197201, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.4035221336, -105363.40352213354, -5.820766091346741*^-11}, 30], NumberForm[{-105363.4035220312, -105363.40352203119, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352219305, -105363.40352219307, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352199471, -105363.40352199475, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352204793, -105363.40352204793, 0.}, 30], NumberForm[{-105363.40352205397, -105363.403522054, 2.9103830456733704*^-11}, 30], 

    NumberForm[{-105363.40352210711, -105363.40352210711, 0.}, 30], NumberForm[{-105363.40352203039, -105363.40352203055, 1.6007106751203537*^-10}, 30], NumberForm[{-105363.40352201361, -105363.40352201361, 0.}, 30], NumberForm[{-105363.40352208965, -105363.40352208965, 0.}, 30], NumberForm[{-105363.4035220729, -105363.40352207293, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352227796, -105363.40352227804, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352236624, -105363.40352236628, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352233722, -105363.40352233728, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352242532, -105363.40352242542, 1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352209256, -105363.40352209257, 1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352201881, -105363.40352201885, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352215184, -105363.40352215183, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352207814, -105363.40352207818, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352246122, -105363.40352246123, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352210143, -105363.40352210145, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352252075, -105363.40352252059, -1.6007106751203537*^-10}, 30], NumberForm[{-105363.40352216046, -105363.40352216052, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352203904, -105363.40352203907, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352204944, -105363.4035220495, 5.820766091346741*^-11}, 30], 

    NumberForm[{-105363.40352209838, -105363.4035220984, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352210883, -105363.4035221089, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352202162, -105363.4035220216, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352208004, -105363.4035220801, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352208076, -105363.40352208083, 7.275957614183426*^-11}, 30], NumberForm[{-105363.4035221393, -105363.40352213934, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352217118, -105363.40352217117, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352222537, -105363.40352222542, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352223067, -105363.40352223054, -1.3096723705530167*^-10}, 30], 

    NumberForm[{-105363.40352228476, -105363.40352228482, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352207041, -105363.40352207041, 0.}, 30], NumberForm[{-105363.40352202821, -105363.40352202833, 1.1641532182693481*^-10}, 30], NumberForm[{-105363.4035220763, -105363.40352207626, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352203799, -105363.40352203803, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352201361, -105363.40352201363, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352207317, -105363.40352207319, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352202131, -105363.40352202144, 1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352208106, -105363.40352208112, 5.820766091346741*^-11}, 30], 

    NumberForm[{-105363.40352199905, -105363.40352199899, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352216084, -105363.40352216078, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352200714, -105363.40352200705, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352216874, -105363.40352216859, -1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352202176, -105363.4035220218, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352207502, -105363.40352207508, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352202971, -105363.40352202971, 0.}, 30], NumberForm[{-105363.40352208292, -105363.40352208285, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352205763, -105363.4035220575, -1.3096723705530167*^-10}, 30], 

    NumberForm[{-105363.40352204068, -105363.4035220406, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352206539, -105363.40352206542, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352204868, -105363.4035220487, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352230727, -105363.40352230737, 1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352239105, -105363.40352239094, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352231076, -105363.40352231078, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352240339, -105363.40352240334, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352211629, -105363.40352211634, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035220492, -105363.40352204909, -1.0186340659856796*^-10}, 30], 

    NumberForm[{-105363.403522131, -105363.40352213077, -2.3283064365386963*^-10}, 30], NumberForm[{-105363.40352205047, -105363.40352205052, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352248792, -105363.40352248779, -1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352212897, -105363.40352212892, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352249681, -105363.40352249675, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352213582, -105363.40352213585, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352206612, -105363.40352206616, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352207652, -105363.4035220765, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352207395, -105363.40352207396, 1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352208463, -105363.40352208458, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352204944, -105363.4035220495, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352210648, -105363.40352210662, 1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352205586, -105363.40352205581, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352211584, -105363.40352211584, 0.}, 30], NumberForm[{-105363.40352219854, -105363.4035221985, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352225247, -105363.4035222524, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352220625, -105363.40352220624, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352226056, -105363.40352226057, 1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352204216, -105363.40352204221, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352210158, -105363.40352210168, 1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352200184, -105363.40352200186, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352206152, -105363.40352206156, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035220277, -105363.40352202767, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.4035221893, -105363.40352218917, -1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352198743, -105363.4035219875, 5.820766091346741*^-11}, 30], NumberForm[{-105363.4035221491, -105363.40352214908, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352205046, -105363.40352205055, 8.731149137020111*^-11}, 30], 

    NumberForm[{-105363.40352210334, -105363.40352210338, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035220103, -105363.40352201027, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.4035220634, -105363.40352206347, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352208605, -105363.40352208621, 1.6007106751203537*^-10}, 30], NumberForm[{-105363.40352206922, -105363.4035220692, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352204596, -105363.40352204605, 8.731149137020111*^-11}, 30], NumberForm[{-105363.40352202933, -105363.40352202924, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352233373, -105363.40352233364, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352242178, -105363.40352242166, -1.1641532182693481*^-10}, 30], 

    NumberForm[{-105363.4035222934, -105363.40352229339, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352238147, -105363.40352238163, 1.6007106751203537*^-10}, 30], NumberForm[{-105363.40352214842, -105363.40352214841, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352207428, -105363.40352207422, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352210782, -105363.4035221077, -1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352203447, -105363.40352203444, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352251688, -105363.40352251685, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352215696, -105363.40352215696, 0.}, 30], NumberForm[{-105363.40352247677, -105363.40352247682, 4.3655745685100555*^-11}, 30], 

    NumberForm[{-105363.40352211686, -105363.40352211676, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352209478, -105363.40352209473, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352210509, -105363.40352210503, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352205453, -105363.40352205452, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352206501, -105363.40352206508, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352209927, -105363.40352209924, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352211363, -105363.40352211353, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352201488, -105363.4035220148, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352211773, -105363.40352211778, 4.3655745685100555*^-11}, 30], 

    NumberForm[{-105363.40352222712, -105363.40352222712, 0.}, 30], NumberForm[{-105363.40352228087, -105363.4035222808, -7.275957614183426*^-11}, 30], NumberForm[{-105363.4035221865, -105363.40352218658, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352224107, -105363.40352224113, 5.820766091346741*^-11}, 30], NumberForm[{-105363.4035219719, -105363.40352197182, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352213346, -105363.40352213343, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352203143, -105363.40352203141, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352219308, -105363.40352219304, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352199452, -105363.40352199465, 1.3096723705530167*^-10}, 30], 

    NumberForm[{-105363.40352204772, -105363.40352204758, -1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352205401, -105363.40352205398, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352210737, -105363.4035221073, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352203026, -105363.40352203014, -1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352201353, -105363.40352201347, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352208992, -105363.40352208994, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352207309, -105363.40352207303, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352227783, -105363.40352227789, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352236603, -105363.403522366, -2.9103830456733704*^-11}, 30], 

    NumberForm[{-105363.40352233745, -105363.40352233747, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352242568, -105363.40352242553, -1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352209221, -105363.40352209222, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352201868, -105363.40352201865, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.403522152, -105363.40352215206, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352207814, -105363.4035220782, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352246114, -105363.40352246113, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352210107, -105363.40352210094, -1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352252072, -105363.40352252066, -5.820766091346741*^-11}, 30], 

    NumberForm[{-105363.40352216075, -105363.4035221607, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352203895, -105363.40352203888, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352204937, -105363.40352204935, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.4035220985, -105363.40352209848, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352210894, -105363.40352210894, 0.}, 30], NumberForm[{-105363.40352202156, -105363.40352202154, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352207988, -105363.40352207987, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352208096, -105363.40352208087, -8.731149137020111*^-11}, 30], NumberForm[{-105363.4035221396, -105363.40352213968, 7.275957614183426*^-11}, 30], 

    NumberForm[{-105363.40352217102, -105363.40352217102, 0.}, 30], NumberForm[{-105363.40352222527, -105363.40352222526, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352223068, -105363.40352223068, 0.}, 30], NumberForm[{-105363.4035222849, -105363.40352228489, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.4035219844, -105363.4035219844, 0.}, 30], NumberForm[{-105363.40352202907, -105363.40352202911, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352213764, -105363.40352213752, -1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352219908, -105363.40352219912, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352201906, -105363.40352201897, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352199592, -105363.40352199586, -5.820766091346741*^-11}, 30], 

    NumberForm[{-105363.40352217438, -105363.40352217425, -1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352216379, -105363.40352216373, -5.820766091346741*^-11}, 30], NumberForm[{-105363.4035222687, -105363.40352226862, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352234629, -105363.40352234618, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352241979, -105363.4035224198, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352251843, -105363.40352251849, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352208159, -105363.40352208154, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352200063, -105363.40352200059, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352223603, -105363.40352223601, -1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352216948, -105363.40352216958, 1.0186340659856796*^-10}, 30], NumberForm[{-105363.4035223798, -105363.40352237991, 1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352215344, -105363.40352215344, 0.}, 30], NumberForm[{-105363.4035226751, -105363.4035226751, 0.}, 30], NumberForm[{-105363.40352218164, -105363.40352218163, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352202386, -105363.40352202389, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352203549, -105363.40352203562, 1.3096723705530167*^-10}, 30], NumberForm[{-105363.4035221867, -105363.40352218664, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352219608, -105363.40352219605, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352200708, -105363.40352200708, 0.}, 30], 

    NumberForm[{-105363.40352206549, -105363.40352206545, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352216848, -105363.40352216859, 1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352222727, -105363.40352222734, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352215928, -105363.40352215918, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352220835, -105363.40352220829, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352231587, -105363.40352231602, 1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352237497, -105363.40352237494, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352204007, -105363.40352204008, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352202022, -105363.4035220202, -1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352209011, -105363.40352209014, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352207642, -105363.40352207642, 0.}, 30], NumberForm[{-105363.40352228601, -105363.40352228597, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035223743, -105363.40352237434, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035223394, -105363.40352233931, -8.731149137020111*^-11}, 30], NumberForm[{-105363.4035224274, -105363.40352242744, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352210059, -105363.40352210063, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352202687, -105363.40352202691, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035221538, -105363.40352215378, -2.9103830456733704*^-11}, 30], 

    NumberForm[{-105363.40352207983, -105363.40352207999, 1.6007106751203537*^-10}, 30], NumberForm[{-105363.40352246932, -105363.40352246937, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352210945, -105363.40352210945, 0.}, 30], NumberForm[{-105363.40352252267, -105363.40352252264, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.4035221625, -105363.40352216245, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035220471, -105363.40352204717, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352205774, -105363.40352205768, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352210023, -105363.40352210027, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352211072, -105363.40352211062, -1.0186340659856796*^-10}, 30], 

    NumberForm[{-105363.40352202945, -105363.40352202936, -8.731149137020111*^-11}, 30], NumberForm[{-105363.4035220885, -105363.40352208853, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352208306, -105363.40352208298, -7.275957614183426*^-11}, 30], NumberForm[{-105363.4035221411, -105363.40352214104, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352218154, -105363.40352218162, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352223141, -105363.40352223149, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352223035, -105363.40352223036, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352228886, -105363.40352228876, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352232195, -105363.40352232201, 5.820766091346741*^-11}, 30], 

    NumberForm[{-105363.40352240985, -105363.40352240983, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352230503, -105363.40352230496, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352239329, -105363.40352239327, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352213653, -105363.4035221365, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352206246, -105363.40352206258, 1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352211951, -105363.40352211952, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352204596, -105363.403522046, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352250208, -105363.40352250206, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352214804, -105363.40352214812, 7.275957614183426*^-11}, 30], 

    NumberForm[{-105363.40352249131, -105363.40352249125, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352212531, -105363.40352212529, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352208287, -105363.40352208281, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352209336, -105363.40352209329, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352206603, -105363.403522066, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352207658, -105363.40352207664, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352206535, -105363.4035220654, 5.820766091346741*^-11}, 30], NumberForm[{-105363.4035221239, -105363.40352212393, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352204854, -105363.40352204863, 8.731149137020111*^-11}, 30], 

    NumberForm[{-105363.40352210728, -105363.40352210728, 0.}, 30], NumberForm[{-105363.4035222729, -105363.40352227296, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352221153, -105363.40352221153, 0.}, 30], NumberForm[{-105363.40352214067, -105363.40352214062, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352231028, -105363.40352231015, -1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352234611, -105363.40352234615, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352234802, -105363.40352234797, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352250973, -105363.40352250973, 0.}, 30], NumberForm[{-105363.40352236056, -105363.4035223606, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035227337, -105363.40352273385, 1.4551915228366852*^-10}, 30], 

    NumberForm[{-105363.40352241152, -105363.40352241158, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352285969, -105363.40352285968, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352246196, -105363.4035224619, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352233073, -105363.40352233085, 1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352234065, -105363.40352234058, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352241823, -105363.40352241829, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352242945, -105363.40352242958, 1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352231229, -105363.40352231229, 0.}, 30], NumberForm[{-105363.40352237204, -105363.40352237219, 1.4551915228366852*^-10}, 30], 

    NumberForm[{-105363.4035224017, -105363.40352240174, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352245896, -105363.40352245903, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352246264, -105363.40352246255, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352251695, -105363.40352251694, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352255099, -105363.40352255086, -1.3096723705530167*^-10}, 30], NumberForm[{-105363.403522605, -105363.40352260486, -1.4551915228366852*^-10}, 30], NumberForm[{-105363.40352254453, -105363.40352254453, 0.}, 30], NumberForm[{-105363.40352222993, -105363.40352222991, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352251624, -105363.40352251624, 0.}, 30], 

    NumberForm[{-105363.40352211078, -105363.40352211068, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.403522145, -105363.40352214508, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352215544, -105363.40352215536, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352207112, -105363.40352207118, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352208179, -105363.40352208176, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352212751, -105363.4035221275, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352218604, -105363.40352218608, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352205378, -105363.40352205375, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352211225, -105363.40352211228, 2.9103830456733704*^-11}, 30], 

    NumberForm[{-105363.40352227751, -105363.40352227748, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352233112, -105363.40352233111, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352220324, -105363.40352220325, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352225787, -105363.4035222578, -7.275957614183426*^-11}, 30], NumberForm[{-105363.4035225135, -105363.40352251352, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352252436, -105363.40352252431, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352215388, -105363.40352215376, -1.1641532182693481*^-10}, 30], NumberForm[{-105363.4035221642, -105363.40352216404, -1.6007106751203537*^-10}, 30], NumberForm[{-105363.40352249643, -105363.40352249629, -1.4551915228366852*^-10}, 30], 

    NumberForm[{-105363.4035225547, -105363.40352255465, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.403522136, -105363.40352213591, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352219497, -105363.40352219503, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352264335, -105363.40352264329, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352270276, -105363.40352270284, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352228866, -105363.40352228862, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352233741, -105363.40352233736, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.4035220744, -105363.40352207435, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352213214, -105363.40352213223, 8.731149137020111*^-11}, 30], 

    NumberForm[{-105363.40352208419, -105363.40352208407, -1.1641532182693481*^-10}, 30], NumberForm[{-105363.40352214321, -105363.40352214327, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352222386, -105363.40352222386, 0.}, 30], NumberForm[{-105363.40352227783, -105363.4035222778, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.4035222341, -105363.40352223403, -7.275957614183426*^-11}, 30], NumberForm[{-105363.40352228844, -105363.4035222884, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352220669, -105363.40352220664, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352225988, -105363.40352225993, 5.820766091346741*^-11}, 30], NumberForm[{-105363.40352226445, -105363.40352226433, -1.1641532182693481*^-10}, 30], 

    NumberForm[{-105363.40352231934, -105363.4035223193, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352199649, -105363.40352199657, 8.731149137020111*^-11}, 30], NumberForm[{-105363.40352214768, -105363.40352214771, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352205829, -105363.40352205833, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352203448, -105363.40352203447, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352198666, -105363.40352198658, -8.731149137020111*^-11}, 30], NumberForm[{-105363.40352210515, -105363.40352210504, -1.0186340659856796*^-10}, 30], NumberForm[{-105363.40352204374, -105363.40352204377, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352205957, -105363.40352205955, -1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.4035221098, -105363.4035221098, 0.}, 30], NumberForm[{-105363.40352202937, -105363.40352202937, 0.}, 30], NumberForm[{-105363.40352198623, -105363.40352198624, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.4035221054, -105363.40352210533, -5.820766091346741*^-11}, 30], NumberForm[{-105363.40352203055, -105363.40352203071, 1.6007106751203537*^-10}, 30], NumberForm[{-105363.40352235387, -105363.4035223539, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352201294, -105363.40352201281, -1.3096723705530167*^-10}, 30], NumberForm[{-105363.40352211914, -105363.40352211923, 8.731149137020111*^-11}, 30], NumberForm[{-105363.40352208591, -105363.40352208592, 1.4551915228366852*^-11}, 30], 

    NumberForm[{-105363.40352205232, -105363.40352205234, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352318106, -105363.4035231811, 4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352335731, -105363.40352335734, 2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352227741, -105363.40352227738, -2.9103830456733704*^-11}, 30], NumberForm[{-105363.40352213001, -105363.40352213003, 1.4551915228366852*^-11}, 30], NumberForm[{-105363.4035234662, -105363.40352346601, -1.8917489796876907*^-10}, 30], NumberForm[{-105363.40352274608, -105363.40352274604, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352214758, -105363.40352214756, -1.4551915228366852*^-11}, 30], NumberForm[{-105363.40352216833, -105363.40352216843, 1.0186340659856796*^-10}, 30], 

    NumberForm[{-105363.40352212568, -105363.40352212559, -8.731149137020111*^-11}, 30], NumberForm[{-105363.4035222429, -105363.40352224285, -4.3655745685100555*^-11}, 30], NumberForm[{-105363.40352272015, -105363.40352272023, 7.275957614183426*^-11}, 30], NumberForm[{-105363.40352282856, -105363.4035228285, -5.820766091346741*^-11}, 30]}]
;[o]

                                                                    -10
1     {-105363.403522021, -105363.4035220211, 1.309672370553017 x 10   }
                                                                    -11
2     {-105363.4035220084, -105363.4035220084, 2.91038304567337 x 10   }
                                                                   -11
3     {-105363.403522096, -105363.403522096, 7.275957614183426 x 10   }
                                                                     -11
4     {-105363.4035220848, -105363.4035220847, -8.73114913702011 x 10   }
                                                                   -11
5     {-105363.403521985, -105363.403521985, 1.455191522836685 x 10   }
                                                                     -11
6     {-105363.4035220443, -105363.4035220442, -8.73114913702011 x 10   }
                                                                     -10
7     {-105363.4035220605, -105363.4035220606, 1.455191522836685 x 10   }
                                                                    -11
8     {-105363.4035221198, -105363.4035221199, 8.73114913702011 x 10   }
                                                                      -11
9     {-105363.4035220125, -105363.4035220125, -1.455191522836685 x 10   }
                                                                     -10
10    {-105363.4035220196, -105363.4035220198, 1.309672370553017 x 10   }
                                                                     -11
11    {-105363.4035220873, -105363.4035220874, 4.365574568510056 x 10   }
                                                                    -11
12    {-105363.403522096, -105363.4035220959, -2.91038304567337 x 10   }
                                                                      -11
13    {-105363.4035220408, -105363.4035220407, -7.275957614183426 x 10   }
                                                                      -11
14    {-105363.4035220002, -105363.4035220002, -1.455191522836685 x 10   }
                                                                    -11
15    {-105363.403522116, -105363.403522116, -1.455191522836685 x 10   }
                                                                      -11
16    {-105363.4035220763, -105363.4035220762, -5.820766091346741 x 10   }
                                                                     -11
17    {-105363.4035219849, -105363.4035219849, 4.365574568510056 x 10   }
                                                                      -11
18    {-105363.4035220445, -105363.4035220445, -1.455191522836685 x 10   }
                                                                     -10
19    {-105363.4035220603, -105363.4035220602, -1.01863406598568 x 10   }
                                                                    -11
20    {-105363.40352212, -105363.4035221199, -7.275957614183426 x 10   }
                                                                    -11
21    {-105363.40352197, -105363.4035219699, -1.455191522836685 x 10   }
                                                                      -11
22    {-105363.4035221324, -105363.4035221324, -4.365574568510056 x 10   }
                                                                     -11
23    {-105363.4035220464, -105363.4035220465, 7.275957614183426 x 10   }
                                                                    -11
24    {-105363.4035222072, -105363.4035222073, 8.73114913702011 x 10   }
                                                                     -11
25    {-105363.4035219931, -105363.4035219931, 1.455191522836685 x 10   }
                                                                     -10
26    {-105363.4035220463, -105363.4035220464, 1.309672370553017 x 10   }
                                                                     -11
27    {-105363.4035220687, -105363.4035220686, -8.73114913702011 x 10   }
                                                                     -11
28    {-105363.4035221218, -105363.4035221218, 1.455191522836685 x 10   }
                                                                     -11
29    {-105363.4035220288, -105363.4035220288, 1.455191522836685 x 10   }
                                                                     -11
30    {-105363.4035220121, -105363.4035220121, 1.455191522836685 x 10   }

31    {-105363.4035221043, -105363.4035221043, 0.}
                                                                      -11
32    {-105363.4035220877, -105363.4035220876, -5.820766091346741 x 10   }
                                                                      -11
33    {-105363.4035222619, -105363.4035222618, -4.365574568510056 x 10   }
                                                                    -11
34    {-105363.4035223791, -105363.403522379, -8.73114913702011 x 10   }
                                                                     -11
35    {-105363.4035223665, -105363.4035223664, -2.91038304567337 x 10   }
                                                                     -10
36    {-105363.4035224256, -105363.4035224257, 1.164153218269348 x 10   }
                                                                      -11
37    {-105363.4035220916, -105363.4035220915, -7.275957614183426 x 10   }
                                                                     -11
38    {-105363.4035220164, -105363.4035220164, 1.455191522836685 x 10   }
                                                                     -11
39    {-105363.4035221659, -105363.4035221658, -2.91038304567337 x 10   }
                                                                     -11
40    {-105363.4035220935, -105363.4035220935, 5.820766091346741 x 10   }
                                                                    -10
41    {-105363.4035224588, -105363.4035224589, 1.01863406598568 x 10   }
                                                                      -11
42    {-105363.4035221004, -105363.4035221004, -4.365574568510056 x 10   }
                                                                     -10
43    {-105363.403522536, -105363.4035225359, -1.455191522836685 x 10   }
                                                                      -11
44    {-105363.4035221746, -105363.4035221745, -7.275957614183426 x 10   }
                                                                     -11
45    {-105363.4035220563, -105363.4035220564, 7.275957614183426 x 10   }
                                                                    -11
46    {-105363.4035220291, -105363.403522029, -8.73114913702011 x 10   }
                                                                     -11
47    {-105363.4035220942, -105363.4035220941, -8.73114913702011 x 10   }
                                                                     -11
48    {-105363.4035221423, -105363.4035221423, 1.455191522836685 x 10   }

49    {-105363.40352202, -105363.40352202, 0.}

50    {-105363.4035220783, -105363.4035220783, 0.}
                                                                    -11
51    {-105363.4035220953, -105363.4035220954, 2.91038304567337 x 10   }
                                                                      -11
52    {-105363.4035221542, -105363.4035221542, -1.455191522836685 x 10   }
                                                                     -11
53    {-105363.4035221698, -105363.4035221698, 4.365574568510056 x 10   }
                                                                      -11
54    {-105363.4035222237, -105363.4035222237, -1.455191522836685 x 10   }
                                                                     -11
55    {-105363.4035222452, -105363.4035222452, 4.365574568510056 x 10   }
                                                                     -11
56    {-105363.4035222995, -105363.4035222996, 5.820766091346741 x 10   }
                                                                      -11
57    {-105363.4035220225, -105363.4035220224, -5.820766091346741 x 10   }

58    {-105363.4035220816, -105363.4035220816, 0.}
                                                                     -11
59    {-105363.4035220104, -105363.4035220104, -2.91038304567337 x 10   }
                                                                     -10
60    {-105363.4035220697, -105363.4035220696, -1.01863406598568 x 10   }
                                                                     -11
61    {-105363.4035220496, -105363.4035220496, 4.365574568510056 x 10   }

62    {-105363.4035220572, -105363.4035220572, 0.}
                                                                     -11
63    {-105363.4035220374, -105363.4035220374, 7.275957614183426 x 10   }
                                                                      -11
64    {-105363.4035220456, -105363.4035220455, -4.365574568510056 x 10   }

65    {-105363.4035220782, -105363.4035220782, 0.}
                                                                    -10
66    {-105363.4035220377, -105363.4035220377, 1.01863406598568 x 10   }
                                                                    -11
67    {-105363.4035220659, -105363.4035220659, 2.91038304567337 x 10   }

68    {-105363.403522026, -105363.403522026, 0.}
                                                                      -11
69    {-105363.4035220222, -105363.4035220221, -4.365574568510056 x 10   }
                                                                     -11
70    {-105363.4035220817, -105363.4035220818, 7.275957614183426 x 10   }
                                                                     -11
71    {-105363.4035220102, -105363.4035220103, 1.455191522836685 x 10   }

72    {-105363.4035220699, -105363.4035220699, 0.}
                                                                     -11
73    {-105363.4035220077, -105363.4035220077, -2.91038304567337 x 10   }
                                                                    -11
74    {-105363.4035221694, -105363.4035221694, 2.91038304567337 x 10   }
                                                                    -11
75    {-105363.4035219957, -105363.4035219958, 2.91038304567337 x 10   }
                                                                     -11
76    {-105363.4035221576, -105363.4035221575, -8.73114913702011 x 10   }
                                                                      -10
77    {-105363.4035220304, -105363.4035220303, -1.164153218269348 x 10   }
                                                                     -11
78    {-105363.4035220836, -105363.4035220836, -8.73114913702011 x 10   }
                                                                      -11
79    {-105363.4035220185, -105363.4035220185, -5.820766091346741 x 10   }
                                                                     -11
80    {-105363.4035220716, -105363.4035220716, 4.365574568510056 x 10   }
                                                                      -11
81    {-105363.4035220662, -105363.4035220661, -5.820766091346741 x 10   }
                                                                      -11
82    {-105363.4035220494, -105363.4035220493, -7.275957614183426 x 10   }
                                                                     -11
83    {-105363.4035220544, -105363.4035220543, -2.91038304567337 x 10   }
                                                                     -11
84    {-105363.4035220375, -105363.4035220375, 4.365574568510056 x 10   }
                                                                   -11
85    {-105363.403522314, -105363.403522314, 1.455191522836685 x 10   }
                                                                      -11
86    {-105363.4035224016, -105363.4035224015, -5.820766091346741 x 10   }
                                                                      -11
87    {-105363.4035223015, -105363.4035223015, -4.365574568510056 x 10   }
                                                                    -11
88    {-105363.4035223902, -105363.4035223902, 8.73114913702011 x 10   }

89    {-105363.4035221282, -105363.4035221282, 0.}
                                                                     -11
90    {-105363.4035220544, -105363.4035220545, 4.365574568510056 x 10   }
                                                                     -11
91    {-105363.4035221164, -105363.4035221164, 7.275957614183426 x 10   }
                                                                     -11
92    {-105363.4035220425, -105363.4035220425, -2.91038304567337 x 10   }
                                                                     -10
93    {-105363.403522497, -105363.4035224968, -1.455191522836685 x 10   }
                                                                   -11
94    {-105363.403522137, -105363.4035221371, 2.91038304567337 x 10   }
                                                                     -11
95    {-105363.4035224851, -105363.4035224851, 5.820766091346741 x 10   }

96    {-105363.403522125, -105363.403522125, 0.}
                                                                   -11
97    {-105363.403522075, -105363.403522075, 7.275957614183426 x 10   }
                                                                   -11
98    {-105363.403522085, -105363.403522085, 5.820766091346741 x 10   }
                                                                     -11
99    {-105363.4035220625, -105363.4035220625, 4.365574568510056 x 10   }
                                                                     -11
100   {-105363.4035220737, -105363.4035220737, 5.820766091346741 x 10   }
                                                                     -11
101   {-105363.4035220573, -105363.4035220574, 5.820766091346741 x 10   }
                                                                      -11
102   {-105363.4035221158, -105363.4035221157, -5.820766091346741 x 10   }

103   {-105363.4035220453, -105363.4035220453, 0.}
                                                                    -11
104   {-105363.403522104, -105363.403522104, -4.365574568510056 x 10   }
                                                                     -10
105   {-105363.4035222072, -105363.403522207, -1.455191522836685 x 10   }
                                                                      -11
106   {-105363.4035222612, -105363.4035222611, -4.365574568510056 x 10   }
                                                                    -10
107   {-105363.403522195, -105363.4035221952, 1.309672370553017 x 10   }
                                                                      -11
108   {-105363.4035222492, -105363.4035222492, -5.820766091346741 x 10   }
                                                                     -11
109   {-105363.4035220137, -105363.4035220137, -2.91038304567337 x 10   }

110   {-105363.4035220216, -105363.4035220216, 0.}
                                                                     -11
111   {-105363.4035220729, -105363.4035220729, -2.91038304567337 x 10   }
                                                                     -11
112   {-105363.4035220809, -105363.4035220808, -2.91038304567337 x 10   }
                                                                     -10
113   {-105363.4035220422, -105363.4035220423, 1.164153218269348 x 10   }
                                                                     -11
114   {-105363.4035220021, -105363.4035220021, -2.91038304567337 x 10   }
                                                                      -10
115   {-105363.4035221016, -105363.4035221014, -1.746229827404022 x 10   }
                                                                      -11
116   {-105363.4035220613, -105363.4035220613, -4.365574568510056 x 10   }
                                                                     -11
117   {-105363.4035219864, -105363.4035219864, 1.455191522836685 x 10   }
                                                                    -11
118   {-105363.4035220459, -105363.403522046, 1.455191522836685 x 10   }
                                                                     -11
119   {-105363.4035220457, -105363.4035220458, 7.275957614183426 x 10   }
                                                                     -11
120   {-105363.4035221053, -105363.4035221053, 1.455191522836685 x 10   }
                                                                    -11
121   {-105363.403521972, -105363.403521972, -1.455191522836685 x 10   }
                                                                      -11
122   {-105363.4035221336, -105363.4035221335, -5.820766091346741 x 10   }
                                                                      -11
123   {-105363.4035220312, -105363.4035220312, -1.455191522836685 x 10   }
                                                                    -11
124   {-105363.403522193, -105363.4035221931, 1.455191522836685 x 10   }
                                                                     -11
125   {-105363.4035219947, -105363.4035219948, 4.365574568510056 x 10   }

126   {-105363.4035220479, -105363.4035220479, 0.}
                                                                  -11
127   {-105363.403522054, -105363.403522054, 2.91038304567337 x 10   }

128   {-105363.4035221071, -105363.4035221071, 0.}
                                                                     -10
129   {-105363.4035220304, -105363.4035220306, 1.600710675120354 x 10   }

130   {-105363.4035220136, -105363.4035220136, 0.}

131   {-105363.4035220896, -105363.4035220896, 0.}
                                                                    -11
132   {-105363.4035220729, -105363.4035220729, 2.91038304567337 x 10   }
                                                                   -11
133   {-105363.403522278, -105363.403522278, 7.275957614183426 x 10   }
                                                                     -11
134   {-105363.4035223662, -105363.4035223663, 4.365574568510056 x 10   }
                                                                     -11
135   {-105363.4035223372, -105363.4035223373, 5.820766091346741 x 10   }
                                                                    -10
136   {-105363.4035224253, -105363.4035224254, 1.01863406598568 x 10   }
                                                                     -11
137   {-105363.4035220925, -105363.4035220926, 1.455191522836685 x 10   }
                                                                     -11
138   {-105363.4035220188, -105363.4035220189, 4.365574568510056 x 10   }
                                                                      -11
139   {-105363.4035221518, -105363.4035221518, -1.455191522836685 x 10   }
                                                                     -11
140   {-105363.4035220781, -105363.4035220782, 4.365574568510056 x 10   }
                                                                     -11
141   {-105363.4035224612, -105363.4035224612, 1.455191522836685 x 10   }
                                                                     -11
142   {-105363.4035221014, -105363.4035221015, 1.455191522836685 x 10   }
                                                                      -10
143   {-105363.4035225207, -105363.4035225206, -1.600710675120354 x 10   }
                                                                     -11
144   {-105363.4035221604, -105363.4035221605, 5.820766091346741 x 10   }
                                                                   -11
145   {-105363.403522039, -105363.4035220391, 2.91038304567337 x 10   }
                                                                     -11
146   {-105363.4035220494, -105363.4035220495, 5.820766091346741 x 10   }
                                                                     -11
147   {-105363.4035220984, -105363.4035220984, 1.455191522836685 x 10   }
                                                                     -11
148   {-105363.4035221088, -105363.4035221089, 7.275957614183426 x 10   }
                                                                      -11
149   {-105363.4035220216, -105363.4035220216, -1.455191522836685 x 10   }
                                                                   -11
150   {-105363.40352208, -105363.4035220801, 5.820766091346741 x 10   }
                                                                     -11
151   {-105363.4035220808, -105363.4035220808, 7.275957614183426 x 10   }
                                                                     -11
152   {-105363.4035221393, -105363.4035221393, 4.365574568510056 x 10   }
                                                                      -11
153   {-105363.4035221712, -105363.4035221712, -1.455191522836685 x 10   }
                                                                     -11
154   {-105363.4035222254, -105363.4035222254, 4.365574568510056 x 10   }
                                                                      -10
155   {-105363.4035222307, -105363.4035222305, -1.309672370553017 x 10   }
                                                                     -11
156   {-105363.4035222847, -105363.4035222848, 5.820766091346741 x 10   }

157   {-105363.4035220704, -105363.4035220704, 0.}
                                                                     -10
158   {-105363.4035220282, -105363.4035220283, 1.164153218269348 x 10   }
                                                                      -11
159   {-105363.4035220763, -105363.4035220762, -4.365574568510056 x 10   }
                                                                   -11
160   {-105363.403522038, -105363.403522038, 4.365574568510056 x 10   }
                                                                     -11
161   {-105363.4035220136, -105363.4035220136, 1.455191522836685 x 10   }
                                                                     -11
162   {-105363.4035220732, -105363.4035220732, 1.455191522836685 x 10   }
                                                                     -10
163   {-105363.4035220213, -105363.4035220214, 1.309672370553017 x 10   }
                                                                     -11
164   {-105363.4035220811, -105363.4035220811, 5.820766091346741 x 10   }
                                                                    -11
165   {-105363.403521999, -105363.403521999, -5.820766091346741 x 10   }
                                                                      -11
166   {-105363.4035221608, -105363.4035221608, -5.820766091346741 x 10   }
                                                                     -11
167   {-105363.4035220071, -105363.4035220071, -8.73114913702011 x 10   }
                                                                      -10
168   {-105363.4035221687, -105363.4035221686, -1.455191522836685 x 10   }
                                                                     -11
169   {-105363.4035220218, -105363.4035220218, 4.365574568510056 x 10   }
                                                                    -11
170   {-105363.403522075, -105363.4035220751, 5.820766091346741 x 10   }

171   {-105363.4035220297, -105363.4035220297, 0.}
                                                                      -11
172   {-105363.4035220829, -105363.4035220828, -7.275957614183426 x 10   }
                                                                      -10
173   {-105363.4035220576, -105363.4035220575, -1.309672370553017 x 10   }
                                                                     -11
174   {-105363.4035220407, -105363.4035220406, -8.73114913702011 x 10   }
                                                                    -11
175   {-105363.4035220654, -105363.4035220654, 2.91038304567337 x 10   }
                                                                     -11
176   {-105363.4035220487, -105363.4035220487, 1.455191522836685 x 10   }
                                                                    -10
177   {-105363.4035223073, -105363.4035223074, 1.01863406598568 x 10   }
                                                                   -10
178   {-105363.403522391, -105363.403522391, -1.01863406598568 x 10   }
                                                                     -11
179   {-105363.4035223108, -105363.4035223108, 1.455191522836685 x 10   }
                                                                      -11
180   {-105363.4035224034, -105363.4035224033, -4.365574568510056 x 10   }
                                                                     -11
181   {-105363.4035221163, -105363.4035221163, 4.365574568510056 x 10   }
                                                                     -10
182   {-105363.4035220492, -105363.4035220491, -1.01863406598568 x 10   }
                                                                     -10
183   {-105363.403522131, -105363.4035221308, -2.328306436538696 x 10   }
                                                                     -11
184   {-105363.4035220505, -105363.4035220505, 4.365574568510056 x 10   }
                                                                      -10
185   {-105363.4035224879, -105363.4035224878, -1.309672370553017 x 10   }
                                                                     -11
186   {-105363.403522129, -105363.4035221289, -4.365574568510056 x 10   }
                                                                      -11
187   {-105363.4035224968, -105363.4035224968, -5.820766091346741 x 10   }
                                                                    -11
188   {-105363.4035221358, -105363.4035221358, 2.91038304567337 x 10   }
                                                                     -11
189   {-105363.4035220661, -105363.4035220662, 4.365574568510056 x 10   }
                                                                      -11
190   {-105363.4035220765, -105363.4035220765, -1.455191522836685 x 10   }
                                                                    -11
191   {-105363.4035220739, -105363.403522074, 1.455191522836685 x 10   }
                                                                      -11
192   {-105363.4035220846, -105363.4035220846, -4.365574568510056 x 10   }
                                                                     -11
193   {-105363.4035220494, -105363.4035220495, 5.820766091346741 x 10   }
                                                                     -10
194   {-105363.4035221065, -105363.4035221066, 1.309672370553017 x 10   }
                                                                      -11
195   {-105363.4035220559, -105363.4035220558, -4.365574568510056 x 10   }

196   {-105363.4035221158, -105363.4035221158, 0.}
                                                                      -11
197   {-105363.4035221985, -105363.4035221985, -4.365574568510056 x 10   }
                                                                      -11
198   {-105363.4035222525, -105363.4035222524, -7.275957614183426 x 10   }
                                                                      -11
199   {-105363.4035222063, -105363.4035222062, -1.455191522836685 x 10   }
                                                                     -11
200   {-105363.4035222606, -105363.4035222606, 1.455191522836685 x 10   }
                                                                     -11
201   {-105363.4035220422, -105363.4035220422, 4.365574568510056 x 10   }
                                                                    -10
202   {-105363.4035221016, -105363.4035221017, 1.01863406598568 x 10   }
                                                                     -11
203   {-105363.4035220018, -105363.4035220019, 1.455191522836685 x 10   }
                                                                     -11
204   {-105363.4035220615, -105363.4035220616, 4.365574568510056 x 10   }
                                                                     -11
205   {-105363.4035220277, -105363.4035220277, -2.91038304567337 x 10   }
                                                                      -10
206   {-105363.4035221893, -105363.4035221892, -1.309672370553017 x 10   }
                                                                     -11
207   {-105363.4035219874, -105363.4035219875, 5.820766091346741 x 10   }
                                                                     -11
208   {-105363.4035221491, -105363.4035221491, -2.91038304567337 x 10   }
                                                                    -11
209   {-105363.4035220505, -105363.4035220505, 8.73114913702011 x 10   }
                                                                     -11
210   {-105363.4035221033, -105363.4035221034, 4.365574568510056 x 10   }
                                                                     -11
211   {-105363.4035220103, -105363.4035220103, -2.91038304567337 x 10   }
                                                                     -11
212   {-105363.4035220634, -105363.4035220635, 7.275957614183426 x 10   }
                                                                     -10
213   {-105363.4035220861, -105363.4035220862, 1.600710675120354 x 10   }
                                                                      -11
214   {-105363.4035220692, -105363.4035220692, -1.455191522836685 x 10   }
                                                                  -11
215   {-105363.403522046, -105363.403522046, 8.73114913702011 x 10   }
                                                                     -11
216   {-105363.4035220293, -105363.4035220292, -8.73114913702011 x 10   }
                                                                     -11
217   {-105363.4035223337, -105363.4035223336, -8.73114913702011 x 10   }
                                                                      -10
218   {-105363.4035224218, -105363.4035224217, -1.164153218269348 x 10   }
                                                                      -11
219   {-105363.4035222934, -105363.4035222934, -1.455191522836685 x 10   }
                                                                     -10
220   {-105363.4035223815, -105363.4035223816, 1.600710675120354 x 10   }
                                                                      -11
221   {-105363.4035221484, -105363.4035221484, -1.455191522836685 x 10   }
                                                                      -11
222   {-105363.4035220743, -105363.4035220742, -5.820766091346741 x 10   }
                                                                      -10
223   {-105363.4035221078, -105363.4035221077, -1.164153218269348 x 10   }
                                                                     -11
224   {-105363.4035220345, -105363.4035220344, -2.91038304567337 x 10   }
                                                                     -11
225   {-105363.4035225169, -105363.4035225169, -2.91038304567337 x 10   }

226   {-105363.403522157, -105363.403522157, 0.}
                                                                     -11
227   {-105363.4035224768, -105363.4035224768, 4.365574568510056 x 10   }
                                                                     -10
228   {-105363.4035221169, -105363.4035221167, -1.01863406598568 x 10   }
                                                                      -11
229   {-105363.4035220948, -105363.4035220947, -5.820766091346741 x 10   }
                                                                     -11
230   {-105363.4035221051, -105363.403522105, -5.820766091346741 x 10   }
                                                                      -11
231   {-105363.4035220545, -105363.4035220545, -1.455191522836685 x 10   }
                                                                    -11
232   {-105363.403522065, -105363.4035220651, 7.275957614183426 x 10   }
                                                                     -11
233   {-105363.4035220993, -105363.4035220992, -2.91038304567337 x 10   }
                                                                     -10
234   {-105363.4035221136, -105363.4035221135, -1.01863406598568 x 10   }
                                                                      -11
235   {-105363.4035220149, -105363.4035220148, -7.275957614183426 x 10   }
                                                                     -11
236   {-105363.4035221177, -105363.4035221178, 4.365574568510056 x 10   }

237   {-105363.4035222271, -105363.4035222271, 0.}
                                                                      -11
238   {-105363.4035222809, -105363.4035222808, -7.275957614183426 x 10   }
                                                                     -11
239   {-105363.4035221865, -105363.4035221866, 7.275957614183426 x 10   }
                                                                     -11
240   {-105363.4035222411, -105363.4035222411, 5.820766091346741 x 10   }
                                                                      -11
241   {-105363.4035219719, -105363.4035219718, -7.275957614183426 x 10   }
                                                                     -11
242   {-105363.4035221335, -105363.4035221334, -2.91038304567337 x 10   }
                                                                      -11
243   {-105363.4035220314, -105363.4035220314, -1.455191522836685 x 10   }
                                                                     -11
244   {-105363.4035221931, -105363.403522193, -4.365574568510056 x 10   }
                                                                     -10
245   {-105363.4035219945, -105363.4035219946, 1.309672370553017 x 10   }
                                                                      -10
246   {-105363.4035220477, -105363.4035220476, -1.455191522836685 x 10   }
                                                                   -11
247   {-105363.403522054, -105363.403522054, -2.91038304567337 x 10   }
                                                                      -11
248   {-105363.4035221074, -105363.4035221073, -7.275957614183426 x 10   }
                                                                      -10
249   {-105363.4035220303, -105363.4035220302, -1.164153218269348 x 10   }
                                                                      -11
250   {-105363.4035220135, -105363.4035220135, -5.820766091346741 x 10   }
                                                                   -11
251   {-105363.4035220899, -105363.40352209, 1.455191522836685 x 10   }
                                                                     -11
252   {-105363.4035220731, -105363.403522073, -5.820766091346741 x 10   }
                                                                     -11
253   {-105363.4035222778, -105363.4035222779, 5.820766091346741 x 10   }
                                                                   -11
254   {-105363.403522366, -105363.403522366, -2.91038304567337 x 10   }
                                                                     -11
255   {-105363.4035223375, -105363.4035223375, 1.455191522836685 x 10   }
                                                                      -10
256   {-105363.4035224257, -105363.4035224255, -1.455191522836685 x 10   }
                                                                     -11
257   {-105363.4035220922, -105363.4035220922, 1.455191522836685 x 10   }
                                                                     -11
258   {-105363.4035220187, -105363.4035220187, -2.91038304567337 x 10   }
                                                                   -11
259   {-105363.403522152, -105363.403522152, 5.820766091346741 x 10   }
                                                                     -11
260   {-105363.4035220781, -105363.4035220782, 5.820766091346741 x 10   }
                                                                      -11
261   {-105363.4035224611, -105363.4035224611, -1.455191522836685 x 10   }
                                                                      -10
262   {-105363.4035221011, -105363.4035221009, -1.309672370553017 x 10   }
                                                                      -11
263   {-105363.4035225207, -105363.4035225207, -5.820766091346741 x 10   }
                                                                      -11
264   {-105363.4035221608, -105363.4035221607, -4.365574568510056 x 10   }
                                                                     -11
265   {-105363.403522039, -105363.4035220389, -7.275957614183426 x 10   }
                                                                      -11
266   {-105363.4035220494, -105363.4035220494, -1.455191522836685 x 10   }
                                                                      -11
267   {-105363.4035220985, -105363.4035220985, -1.455191522836685 x 10   }

268   {-105363.4035221089, -105363.4035221089, 0.}
                                                                      -11
269   {-105363.4035220216, -105363.4035220215, -1.455191522836685 x 10   }
                                                                      -11
270   {-105363.4035220799, -105363.4035220799, -1.455191522836685 x 10   }
                                                                    -11
271   {-105363.403522081, -105363.4035220809, -8.73114913702011 x 10   }
                                                                     -11
272   {-105363.4035221396, -105363.4035221397, 7.275957614183426 x 10   }

273   {-105363.403522171, -105363.403522171, 0.}
                                                                      -11
274   {-105363.4035222253, -105363.4035222253, -1.455191522836685 x 10   }

275   {-105363.4035222307, -105363.4035222307, 0.}
                                                                      -11
276   {-105363.4035222849, -105363.4035222849, -1.455191522836685 x 10   }

277   {-105363.4035219844, -105363.4035219844, 0.}
                                                                     -11
278   {-105363.4035220291, -105363.4035220291, 4.365574568510056 x 10   }
                                                                      -10
279   {-105363.4035221376, -105363.4035221375, -1.164153218269348 x 10   }
                                                                     -11
280   {-105363.4035221991, -105363.4035221991, 4.365574568510056 x 10   }
                                                                   -11
281   {-105363.403522019, -105363.403522019, -8.73114913702011 x 10   }
                                                                      -11
282   {-105363.4035219959, -105363.4035219959, -5.820766091346741 x 10   }
                                                                      -10
283   {-105363.4035221744, -105363.4035221743, -1.309672370553017 x 10   }
                                                                      -11
284   {-105363.4035221638, -105363.4035221637, -5.820766091346741 x 10   }
                                                                      -11
285   {-105363.4035222687, -105363.4035222686, -7.275957614183426 x 10   }
                                                                     -10
286   {-105363.4035223463, -105363.4035223462, -1.01863406598568 x 10   }
                                                                     -11
287   {-105363.4035224198, -105363.4035224198, 1.455191522836685 x 10   }
                                                                     -11
288   {-105363.4035225184, -105363.4035225185, 5.820766091346741 x 10   }
                                                                      -11
289   {-105363.4035220816, -105363.4035220815, -4.365574568510056 x 10   }
                                                                      -11
290   {-105363.4035220006, -105363.4035220006, -4.365574568510056 x 10   }
                                                                    -11
291   {-105363.403522236, -105363.403522236, -1.455191522836685 x 10   }
                                                                    -10
292   {-105363.4035221695, -105363.4035221696, 1.01863406598568 x 10   }
                                                                     -10
293   {-105363.4035223798, -105363.4035223799, 1.164153218269348 x 10   }

294   {-105363.4035221535, -105363.4035221535, 0.}

295   {-105363.4035226751, -105363.4035226751, 0.}
                                                                      -11
296   {-105363.4035221817, -105363.4035221816, -1.455191522836685 x 10   }
                                                                    -11
297   {-105363.4035220239, -105363.4035220239, 2.91038304567337 x 10   }
                                                                     -10
298   {-105363.4035220355, -105363.4035220356, 1.309672370553017 x 10   }
                                                                      -11
299   {-105363.4035221867, -105363.4035221866, -5.820766091346741 x 10   }
                                                                    -11
300   {-105363.4035221961, -105363.403522196, -2.91038304567337 x 10   }

301   {-105363.4035220071, -105363.4035220071, 0.}
                                                                      -11
302   {-105363.4035220655, -105363.4035220655, -4.365574568510056 x 10   }
                                                                     -10
303   {-105363.4035221685, -105363.4035221686, 1.164153218269348 x 10   }
                                                                     -11
304   {-105363.4035222273, -105363.4035222273, 7.275957614183426 x 10   }
                                                                     -10
305   {-105363.4035221593, -105363.4035221592, -1.01863406598568 x 10   }
                                                                      -11
306   {-105363.4035222083, -105363.4035222083, -5.820766091346741 x 10   }
                                                                    -10
307   {-105363.4035223159, -105363.403522316, 1.455191522836685 x 10   }
                                                                    -11
308   {-105363.403522375, -105363.4035223749, -2.91038304567337 x 10   }
                                                                     -11
309   {-105363.4035220401, -105363.4035220401, 1.455191522836685 x 10   }
                                                                      -11
310   {-105363.4035220202, -105363.4035220202, -1.455191522836685 x 10   }
                                                                    -11
311   {-105363.4035220901, -105363.4035220901, 2.91038304567337 x 10   }

312   {-105363.4035220764, -105363.4035220764, 0.}
                                                                    -11
313   {-105363.403522286, -105363.403522286, -4.365574568510056 x 10   }
                                                                     -11
314   {-105363.4035223743, -105363.4035223743, 4.365574568510056 x 10   }
                                                                     -11
315   {-105363.4035223394, -105363.4035223393, -8.73114913702011 x 10   }
                                                                     -11
316   {-105363.4035224274, -105363.4035224274, 4.365574568510056 x 10   }
                                                                     -11
317   {-105363.4035221006, -105363.4035221006, 4.365574568510056 x 10   }
                                                                     -11
318   {-105363.4035220269, -105363.4035220269, 4.365574568510056 x 10   }
                                                                     -11
319   {-105363.4035221538, -105363.4035221538, -2.91038304567337 x 10   }
                                                                   -10
320   {-105363.4035220798, -105363.40352208, 1.600710675120354 x 10   }
                                                                     -11
321   {-105363.4035224693, -105363.4035224694, 4.365574568510056 x 10   }

322   {-105363.4035221094, -105363.4035221094, 0.}
                                                                     -11
323   {-105363.4035225227, -105363.4035225226, -2.91038304567337 x 10   }
                                                                      -11
324   {-105363.4035221625, -105363.4035221624, -4.365574568510056 x 10   }
                                                                     -11
325   {-105363.4035220471, -105363.4035220472, 7.275957614183426 x 10   }
                                                                      -11
326   {-105363.4035220577, -105363.4035220577, -5.820766091346741 x 10   }
                                                                     -11
327   {-105363.4035221002, -105363.4035221003, 4.365574568510056 x 10   }
                                                                     -10
328   {-105363.4035221107, -105363.4035221106, -1.01863406598568 x 10   }
                                                                     -11
329   {-105363.4035220294, -105363.4035220294, -8.73114913702011 x 10   }
                                                                    -11
330   {-105363.4035220885, -105363.4035220885, 2.91038304567337 x 10   }
                                                                     -11
331   {-105363.4035220831, -105363.403522083, -7.275957614183426 x 10   }
                                                                     -11
332   {-105363.4035221411, -105363.403522141, -5.820766091346741 x 10   }
                                                                     -11
333   {-105363.4035221815, -105363.4035221816, 7.275957614183426 x 10   }
                                                                     -11
334   {-105363.4035222314, -105363.4035222315, 7.275957614183426 x 10   }
                                                                     -11
335   {-105363.4035222303, -105363.4035222304, 1.455191522836685 x 10   }
                                                                     -10
336   {-105363.4035222889, -105363.4035222888, -1.01863406598568 x 10   }
                                                                   -11
337   {-105363.403522322, -105363.403522322, 5.820766091346741 x 10   }
                                                                      -11
338   {-105363.4035224098, -105363.4035224098, -1.455191522836685 x 10   }
                                                                    -11
339   {-105363.403522305, -105363.403522305, -7.275957614183426 x 10   }
                                                                      -11
340   {-105363.4035223933, -105363.4035223933, -1.455191522836685 x 10   }
                                                                     -11
341   {-105363.4035221365, -105363.4035221365, -2.91038304567337 x 10   }
                                                                     -10
342   {-105363.4035220625, -105363.4035220626, 1.164153218269348 x 10   }
                                                                     -11
343   {-105363.4035221195, -105363.4035221195, 1.455191522836685 x 10   }
                                                                   -11
344   {-105363.403522046, -105363.403522046, 4.365574568510056 x 10   }
                                                                      -11
345   {-105363.4035225021, -105363.4035225021, -1.455191522836685 x 10   }
                                                                    -11
346   {-105363.403522148, -105363.4035221481, 7.275957614183426 x 10   }
                                                                      -11
347   {-105363.4035224913, -105363.4035224913, -5.820766091346741 x 10   }
                                                                     -11
348   {-105363.4035221253, -105363.4035221253, -2.91038304567337 x 10   }
                                                                      -11
349   {-105363.4035220829, -105363.4035220828, -5.820766091346741 x 10   }
                                                                      -11
350   {-105363.4035220934, -105363.4035220933, -7.275957614183426 x 10   }
                                                                   -11
351   {-105363.403522066, -105363.403522066, -2.91038304567337 x 10   }
                                                                     -11
352   {-105363.4035220766, -105363.4035220766, 5.820766091346741 x 10   }
                                                                     -11
353   {-105363.4035220653, -105363.4035220654, 5.820766091346741 x 10   }
                                                                    -11
354   {-105363.4035221239, -105363.4035221239, 2.91038304567337 x 10   }
                                                                    -11
355   {-105363.4035220485, -105363.4035220486, 8.73114913702011 x 10   }

356   {-105363.4035221073, -105363.4035221073, 0.}
                                                                    -11
357   {-105363.4035222729, -105363.403522273, 5.820766091346741 x 10   }

358   {-105363.4035222115, -105363.4035222115, 0.}
                                                                      -11
359   {-105363.4035221407, -105363.4035221406, -4.365574568510056 x 10   }
                                                                      -10
360   {-105363.4035223103, -105363.4035223102, -1.309672370553017 x 10   }
                                                                     -11
361   {-105363.4035223461, -105363.4035223461, 4.365574568510056 x 10   }
                                                                    -11
362   {-105363.403522348, -105363.403522348, -4.365574568510056 x 10   }

363   {-105363.4035225097, -105363.4035225097, 0.}
                                                                     -11
364   {-105363.4035223606, -105363.4035223606, 4.365574568510056 x 10   }
                                                                     -10
365   {-105363.4035227337, -105363.4035227339, 1.455191522836685 x 10   }
                                                                     -11
366   {-105363.4035224115, -105363.4035224116, 5.820766091346741 x 10   }
                                                                      -11
367   {-105363.4035228597, -105363.4035228597, -1.455191522836685 x 10   }
                                                                     -11
368   {-105363.403522462, -105363.4035224619, -5.820766091346741 x 10   }
                                                                     -10
369   {-105363.4035223307, -105363.4035223308, 1.164153218269348 x 10   }
                                                                      -11
370   {-105363.4035223407, -105363.4035223406, -7.275957614183426 x 10   }
                                                                     -11
371   {-105363.4035224182, -105363.4035224183, 5.820766091346741 x 10   }
                                                                     -10
372   {-105363.4035224295, -105363.4035224296, 1.309672370553017 x 10   }

373   {-105363.4035223123, -105363.4035223123, 0.}
                                                                    -10
374   {-105363.403522372, -105363.4035223722, 1.455191522836685 x 10   }
                                                                     -11
375   {-105363.4035224017, -105363.4035224017, 4.365574568510056 x 10   }
                                                                   -11
376   {-105363.403522459, -105363.403522459, 7.275957614183426 x 10   }
                                                                     -11
377   {-105363.4035224627, -105363.4035224626, -8.73114913702011 x 10   }
                                                                      -11
378   {-105363.4035225169, -105363.4035225169, -1.455191522836685 x 10   }
                                                                     -10
379   {-105363.403522551, -105363.4035225508, -1.309672370553017 x 10   }
                                                                     -10
380   {-105363.403522605, -105363.4035226048, -1.455191522836685 x 10   }

381   {-105363.4035225445, -105363.4035225445, 0.}
                                                                      -11
382   {-105363.4035222299, -105363.4035222299, -1.455191522836685 x 10   }

383   {-105363.4035225162, -105363.4035225162, 0.}
                                                                     -10
384   {-105363.4035221108, -105363.4035221107, -1.01863406598568 x 10   }
                                                                    -11
385   {-105363.403522145, -105363.4035221451, 7.275957614183426 x 10   }
                                                                      -11
386   {-105363.4035221554, -105363.4035221554, -7.275957614183426 x 10   }
                                                                     -11
387   {-105363.4035220711, -105363.4035220712, 5.820766091346741 x 10   }
                                                                     -11
388   {-105363.4035220818, -105363.4035220818, -2.91038304567337 x 10   }
                                                                      -11
389   {-105363.4035221275, -105363.4035221275, -1.455191522836685 x 10   }
                                                                    -11
390   {-105363.403522186, -105363.4035221861, 4.365574568510056 x 10   }
                                                                     -11
391   {-105363.4035220538, -105363.4035220538, -2.91038304567337 x 10   }
                                                                    -11
392   {-105363.4035221122, -105363.4035221123, 2.91038304567337 x 10   }
                                                                     -11
393   {-105363.4035222775, -105363.4035222775, -2.91038304567337 x 10   }
                                                                      -11
394   {-105363.4035223311, -105363.4035223311, -1.455191522836685 x 10   }
                                                                     -11
395   {-105363.4035222032, -105363.4035222033, 1.455191522836685 x 10   }
                                                                      -11
396   {-105363.4035222579, -105363.4035222578, -7.275957614183426 x 10   }
                                                                     -11
397   {-105363.4035225135, -105363.4035225135, 1.455191522836685 x 10   }
                                                                      -11
398   {-105363.4035225244, -105363.4035225243, -4.365574568510056 x 10   }
                                                                      -10
399   {-105363.4035221539, -105363.4035221538, -1.164153218269348 x 10   }
                                                                     -10
400   {-105363.4035221642, -105363.403522164, -1.600710675120354 x 10   }
                                                                      -10
401   {-105363.4035224964, -105363.4035224963, -1.455191522836685 x 10   }
                                                                      -11
402   {-105363.4035225547, -105363.4035225546, -4.365574568510056 x 10   }
                                                                    -11
403   {-105363.403522136, -105363.4035221359, -8.73114913702011 x 10   }
                                                                   -11
404   {-105363.403522195, -105363.403522195, 5.820766091346741 x 10   }
                                                                      -11
405   {-105363.4035226434, -105363.4035226433, -5.820766091346741 x 10   }
                                                                     -11
406   {-105363.4035227028, -105363.4035227028, 7.275957614183426 x 10   }
                                                                      -11
407   {-105363.4035222887, -105363.4035222886, -4.365574568510056 x 10   }
                                                                      -11
408   {-105363.4035223374, -105363.4035223374, -4.365574568510056 x 10   }
                                                                      -11
409   {-105363.4035220744, -105363.4035220744, -4.365574568510056 x 10   }
                                                                    -11
410   {-105363.4035221321, -105363.4035221322, 8.73114913702011 x 10   }
                                                                      -10
411   {-105363.4035220842, -105363.4035220841, -1.164153218269348 x 10   }
                                                                     -11
412   {-105363.4035221432, -105363.4035221433, 5.820766091346741 x 10   }

413   {-105363.4035222239, -105363.4035222239, 0.}
                                                                     -11
414   {-105363.4035222778, -105363.4035222778, -2.91038304567337 x 10   }
                                                                     -11
415   {-105363.4035222341, -105363.403522234, -7.275957614183426 x 10   }
                                                                      -11
416   {-105363.4035222884, -105363.4035222884, -4.365574568510056 x 10   }
                                                                      -11
417   {-105363.4035222067, -105363.4035222067, -4.365574568510056 x 10   }
                                                                     -11
418   {-105363.4035222599, -105363.4035222599, 5.820766091346741 x 10   }
                                                                      -10
419   {-105363.4035222645, -105363.4035222643, -1.164153218269348 x 10   }
                                                                     -11
420   {-105363.4035223193, -105363.4035223193, -2.91038304567337 x 10   }
                                                                    -11
421   {-105363.4035219965, -105363.4035219966, 8.73114913702011 x 10   }
                                                                    -11
422   {-105363.4035221477, -105363.4035221477, 2.91038304567337 x 10   }
                                                                     -11
423   {-105363.4035220583, -105363.4035220583, 4.365574568510056 x 10   }
                                                                      -11
424   {-105363.4035220345, -105363.4035220345, -1.455191522836685 x 10   }
                                                                     -11
425   {-105363.4035219867, -105363.4035219866, -8.73114913702011 x 10   }
                                                                    -10
426   {-105363.4035221051, -105363.403522105, -1.01863406598568 x 10   }
                                                                    -11
427   {-105363.4035220437, -105363.4035220438, 2.91038304567337 x 10   }
                                                                      -11
428   {-105363.4035220596, -105363.4035220596, -1.455191522836685 x 10   }

429   {-105363.4035221098, -105363.4035221098, 0.}

430   {-105363.4035220294, -105363.4035220294, 0.}
                                                                     -11
431   {-105363.4035219862, -105363.4035219862, 1.455191522836685 x 10   }
                                                                      -11
432   {-105363.4035221054, -105363.4035221053, -5.820766091346741 x 10   }
                                                                     -10
433   {-105363.4035220306, -105363.4035220307, 1.600710675120354 x 10   }
                                                                    -11
434   {-105363.4035223539, -105363.4035223539, 2.91038304567337 x 10   }
                                                                      -10
435   {-105363.4035220129, -105363.4035220128, -1.309672370553017 x 10   }
                                                                    -11
436   {-105363.4035221191, -105363.4035221192, 8.73114913702011 x 10   }
                                                                     -11
437   {-105363.4035220859, -105363.4035220859, 1.455191522836685 x 10   }
                                                                     -11
438   {-105363.4035220523, -105363.4035220523, 1.455191522836685 x 10   }
                                                                    -11
439   {-105363.403523181, -105363.4035231811, 4.365574568510056 x 10   }
                                                                    -11
440   {-105363.4035233573, -105363.4035233573, 2.91038304567337 x 10   }
                                                                     -11
441   {-105363.4035222774, -105363.4035222774, -2.91038304567337 x 10   }
                                                                 -11
442   {-105363.40352213, -105363.40352213, 1.455191522836685 x 10   }
                                                                     -10
443   {-105363.4035234662, -105363.403523466, -1.891748979687691 x 10   }
                                                                     -11
444   {-105363.4035227461, -105363.403522746, -4.365574568510056 x 10   }
                                                                      -11
445   {-105363.4035221476, -105363.4035221476, -1.455191522836685 x 10   }
                                                                    -10
446   {-105363.4035221683, -105363.4035221684, 1.01863406598568 x 10   }
                                                                     -11
447   {-105363.4035221257, -105363.4035221256, -8.73114913702011 x 10   }
                                                                      -11
448   {-105363.4035222429, -105363.4035222428, -4.365574568510056 x 10   }
                                                                     -11
449   {-105363.4035227202, -105363.4035227202, 7.275957614183426 x 10   }
                                                                      -11
450   {-105363.4035228286, -105363.4035228285, -5.820766091346741 x 10   }
^*)
