(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    393092,       8272]*)
(*NotebookOutlinePosition[    397404,       8395]*)
(*  CellTagsIndexPosition[    396673,       8373]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Momenten-Glg. Allg. Form", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["<<HermiteExpansion.m", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["SetDelayed::write: Tag He in He[n_, z_] is Protected.", "Message",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["Set::wrsym: Symbol phi is Protected.", "Message",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["Set::wrsym: Symbol Phi is Protected.", "Message",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[TextData[{
  "(***************************************************************)\t\t\t ",
  StyleBox["\n",
    FontColor->RGBColor[1, 0, 0]],
  "GaussMomente[mue_,Sigma_,K_]:=\n\
(***************************************************************)\t\t\t ",
  StyleBox["\n",
    FontColor->RGBColor[1, 0, 0]],
  "Module[{m},\nm=Table[If[EvenQ[k],(k-1)!!Sigma^(k/2),0],{k,2,K}];\n\
{mue,m}//Flatten\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[TextData[{
  "GaussMomenteMulti//Clear\n\
(***************************************************************)\t\t\t ",
  StyleBox["\n",
    FontColor->RGBColor[1, 0, 0]],
  "GaussMomenteMulti[mue_,Sigma_,K_,flat_:flattensymmetric]:=\n\
(***************************************************************)\t\t\t ",
  StyleBox["\n",
    FontColor->RGBColor[1, 0, 0]],
  "Module[{m},\nm=Table[GaussMoment[k,Sigma]//flat,{k,2,K}];\nJoin[{mue},m]\n\
]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["\<\
GaussMomenteMulti[{1,1},I2,4]
GaussMomenteMulti[{1,1},I2,4,#&]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1, 1}, {1, 0, 1}, {0, 0, 0, 0}, {3, 0, 1, 0, 3}}\
\
\>", "\<\
{{1, 1}, {1, 0, 1}, {0, 0, 0, 0}, {3, 0, 1, 0, 3}}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{1, 1}, {{1, 0}, {0, 1}}, {{{0, 0}, {0, 0}}, {{0, \
0}, {0, 0}}}, 

   {{{{3, 0}, {0, 1}}, {{0, 1}, {1, 0}}}, {{{0, 1}, {1, 0}}, {{1, 0}, {0, \
3}}}}}\
\>", "\<\
 {{1, 1}, {{1, 0}, {0, 1}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}, 
  {{{{3, 0}, {0, 1}}, {{0, 1}, {1, 0}}}, {{{0, 1}, {1, 0}}, {{1, 0}, {0, \
3}}}}}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell["\<\
psi//Clear
(***************************************************************)\t\t\t 
psi[t_,mue_,Sigma_]:=Exp[I t.mue-(1/2)t.Sigma.t]
(***************************************************************)\t\t\t 
\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
GaussMoment//Clear
(***************************************************************)\t\t\t 
GaussMoment[k_,Sigma_]:=
(***************************************************************)\t\t\t 
Module[{p,t,tt,rule,iter,ttt,i,j,psi0},

p=Sigma//Length;
psi0=psi[tt=Array[t,p],Shape[0,p],Sigma];
rule=Map[(#->0)&,tt];
iter=Sequence@@Table[{i[j],p},{j,1,k}];
ttt =Sequence@@Table[t[i[j]],{j,1,k}];
(I)^(-k) Table[D[psi0,ttt//Evaluate]/.rule,iter//Evaluate]
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
(***************************************************************)\t\
\t\t 
ArraySymmetric[s_,p_]:=
(***************************************************************)\t\t\t 
Module[{S},
S=Table[s[[i,j]],{i,p},{j,i,p}];
SymmetricMatrix[S//Flatten,p]
]
\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
MOMENTanalytisch//Clear
(***************************************************************)\t\t\t 
MOMENTanalytisch[k_,p_,s_]:=Module[{MAnal,S},
(***************************************************************)\t\t\t 
S=ArraySymmetric[s,p];
MAnal=GaussMoment[k,S];
{MAnal,S}]

MMnum//Clear
(***************************************************************)\t\t\t 
MMnum[MAnal_,S_,Snum_]:=Module[{r},
(***************************************************************)\t\t\t 
r=MapThread[Rule,{S//Flatten,Snum//Flatten}];
MAnal/.r]
\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
Clear[GaussMomentM,S]
Do[
(***************************************************************)\t\t\t 
GaussMomentM[k,S_,p]=GaussMoment[k,ArraySymmetric[S,p]]
(***************************************************************)\t\t\t 
,{p,1,3},{k,1,8}]\
\>", "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
Clear[GaussMomentMflat,S]
Do[
(***************************************************************)\t\t\t 
GaussMomentMflat[k,S_,p]=GaussMomentM[k,ArraySymmetric[S,p],p]//\
flattensymmetric
(***************************************************************)\t\t\t 
,{p,1,3},{k,1,8}]\
\>", "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
SetDirectory[\"/Mathematica 2.2.2/Packages/Hermann/\"];
Save[\"GaussMomente\",{GaussMomentM,GaussMomentMflat}];\
\>", "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
SetDirectory[\"/Mathematica 2.2.2/Packages/Hermann/\"];
Get[\"GaussMomente\"];\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["??GaussMomentMflat", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["Global`GaussMomentMflat", "Print",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(GaussMomentMflat[1, S_, 1] = {0}\)},
                {" "},
                {\(GaussMomentMflat[2, S_, 
                      1] = {S\[LeftDoubleBracket]1, 
                        1\[RightDoubleBracket]}\)},
                {" "},
                {\(GaussMomentMflat[3, S_, 1] = {0}\)},
                {" "},
                {\(GaussMomentMflat[4, S_, 
                      1] = {3\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\
\^2}\)},
                {" "},
                {\(GaussMomentMflat[5, S_, 1] = {0}\)},
                {" "},
                {\(GaussMomentMflat[6, S_, 
                      1] = {15\ S\[LeftDoubleBracket]1, \
1\[RightDoubleBracket]\^3}\)},
                {" "},
                {\(GaussMomentMflat[7, S_, 1] = {0}\)},
                {" "},
                {\(GaussMomentMflat[8, S_, 
                      1] = {105\ S\[LeftDoubleBracket]1, 1\
\[RightDoubleBracket]\^4}\)},
                {" "},
                {\(GaussMomentMflat[1, S_, 2] = {0, 0}\)},
                {" "},
                {\(GaussMomentMflat[2, S_, 
                      2] = {S\[LeftDoubleBracket]1, 1\[RightDoubleBracket], 
                      S\[LeftDoubleBracket]1, 2\[RightDoubleBracket], 
                      S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]}\)},
                {" "},
                {\(GaussMomentMflat[3, S_, 2] = {0, 0, 0, 0}\)},
                {" "},
                {\(GaussMomentMflat[4, S_, 
                      2] = {3\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\
\^2, 3\ S\[LeftDoubleBracket]1, 
                          1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                          2\[RightDoubleBracket], 
                      2\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2 + 
                        S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket], 
                      3\ S\[LeftDoubleBracket]1, 
                          2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                          2\[RightDoubleBracket], 
                      3\ S\[LeftDoubleBracket]2, \
2\[RightDoubleBracket]\^2}\)},
                {" "},
                {\(GaussMomentMflat[5, S_, 2] = {0, 0, 0, 0, 0, 0}\)},
                {" "},
                {\(GaussMomentMflat[6, S_, 
                      2] = {15\ S\[LeftDoubleBracket]1, \
1\[RightDoubleBracket]\^3, 
                      15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 2\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^2 + 
                        3\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^3 + 
                        9\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2, 
                      15\ S\[LeftDoubleBracket]1, 
                          2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2, 
                      15\ S\[LeftDoubleBracket]2, \
2\[RightDoubleBracket]\^3}\)},
                {" "},
                {\(GaussMomentMflat[7, S_, 2] = {0, 0, 0, 0, 0, 0, 0, 0}\)},
                {" "},
                {\(GaussMomentMflat[8, S_, 
                      2] = {105\ S\[LeftDoubleBracket]1, 1\
\[RightDoubleBracket]\^4, 
                      105\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]1, 2\[RightDoubleBracket], 
                      90\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^3\
\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket], 
                      60\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^3 + 
                        45\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^4 + 
                        72\ S\[LeftDoubleBracket]1, 
                            
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2, 
                      60\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        45\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2, 
                      90\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^3, 
                      105\ S\[LeftDoubleBracket]1, 
                          2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^3, 
                      105\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^4}\
\)},
                {" "},
                {\(GaussMomentMflat[1, S_, 3] = {0, 0, 0}\)},
                {" "},
                {\(GaussMomentMflat[2, S_, 
                      3] = {S\[LeftDoubleBracket]1, 1\[RightDoubleBracket], 
                      S\[LeftDoubleBracket]1, 2\[RightDoubleBracket], 
                      S\[LeftDoubleBracket]1, 3\[RightDoubleBracket], 
                      S\[LeftDoubleBracket]2, 2\[RightDoubleBracket], 
                      S\[LeftDoubleBracket]2, 3\[RightDoubleBracket], 
                      S\[LeftDoubleBracket]3, 3\[RightDoubleBracket]}\)},
                {" "},
                {\(GaussMomentMflat[3, S_, 3] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 
                      0}\)},
                {" "},
                {\(GaussMomentMflat[4, S_, 
                      3] = {3\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\
\^2, 3\ S\[LeftDoubleBracket]1, 
                          1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                          2\[RightDoubleBracket], 
                      3\ S\[LeftDoubleBracket]1, 
                          1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                          3\[RightDoubleBracket], 
                      2\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2 + 
                        S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket], 
                      2\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket] + 
                        S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket], 
                      2\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2 + 
                        S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      3\ S\[LeftDoubleBracket]1, 
                          2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                          2\[RightDoubleBracket], 
                      S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket] + 
                        2\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket], 
                      2\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      3\ S\[LeftDoubleBracket]1, 
                          3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                          3\[RightDoubleBracket], 
                      3\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2, 
                      3\ S\[LeftDoubleBracket]2, 
                          2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                          3\[RightDoubleBracket], 
                      2\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^2 + 
                        S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      3\ S\[LeftDoubleBracket]2, 
                          3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                          3\[RightDoubleBracket], 
                      3\ S\[LeftDoubleBracket]3, \
3\[RightDoubleBracket]\^2}\)},
                {" "},
                {\(GaussMomentMflat[5, S_, 3] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 
                      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}\)},
                {" "},
                {\(GaussMomentMflat[6, S_, 
                      3] = {15\ S\[LeftDoubleBracket]1, \
1\[RightDoubleBracket]\^3, 
                      15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 2\[RightDoubleBracket], 
                      15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 3\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^2 + 
                        3\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2 + 
                        3\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^3 + 
                        9\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ S\
\[LeftDoubleBracket]1, 3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket] + 
                        6\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2 + 
                        6\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^3 + 
                        9\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2, 
                      6\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket] + 
                        6\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket], 
                      2\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\ S\
\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        8\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        2\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        2\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\ S\
\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
                        6\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      15\ S\[LeftDoubleBracket]1, 
                          
                          2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2, 
                      3\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2 + 
                        12\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        6\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        3\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        3\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        6\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      15\ S\[LeftDoubleBracket]1, 
                          3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      15\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^3, 
                      15\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        3\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^3 + 
                        9\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      12\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      15\ S\[LeftDoubleBracket]2, 
                          3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      15\ S\[LeftDoubleBracket]3, \
3\[RightDoubleBracket]\^3}\)},
                {" "},
                {\(GaussMomentMflat[7, S_, 3] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 
                      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                      0, 0, 0, 0, 0, 0, 0, 0, 0}\)},
                {" "},
                {\(GaussMomentMflat[8, S_, 
                      3] = {105\ S\[LeftDoubleBracket]1, 1\
\[RightDoubleBracket]\^4, 
                      105\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]1, 2\[RightDoubleBracket], 
                      105\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]1, 3\[RightDoubleBracket], 
                      90\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^3\
\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket], 
                      90\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket] + 
                        15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^3\
\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket], 
                      90\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^3\
\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket], 
                      60\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^3 + 
                        45\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket], 
                      60\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket] + 
                        15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket] + 
                        30\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket], 
                      60\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2 + 
                        30\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        15\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      60\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^3 + 
                        45\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^4 + 
                        72\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2, 
                      24\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]1, 3\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2 + 
                        12\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        48\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        6\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^2 + 
                        12\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^3 + 
                        36\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^4 + 
                        72\ S\[LeftDoubleBracket]1, 
                            
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 1\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket]\^2, 
                      60\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        45\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2, 
                      36\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2 + 
                        24\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^3\
\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket], 
                      18\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        18\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        18\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        6\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^3\ S\
\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
                        18\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        18\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        18\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      60\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        45\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      90\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^3, 
                      30\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2 + 
                        60\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        15\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket], 
                      6\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\ S\
\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2 + 
                        48\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        24\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^2 + 
                        12\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        12\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket], 
                      18\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        6\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^3 + 
                        18\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        18\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^2 + 
                        12\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        48\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        12\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        6\ S\[LeftDoubleBracket]1, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket]\^2 + 
                        3\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      60\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        30\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      90\ S\[LeftDoubleBracket]1, 3\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 
                            1\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^3, 
                      105\ S\[LeftDoubleBracket]1, 
                          2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^3, 
                      15\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^3 + 
                        90\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket], 
                      30\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
                        60\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket], 
                      36\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2 + 
                        24\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^3 + 
                        9\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 2\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^3 + 
                        36\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket] + 
                        36\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      60\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        15\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2 + 
                        30\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      90\ S\[LeftDoubleBracket]1, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]1, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^3, 
                      105\ S\[LeftDoubleBracket]1, 
                          3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^3, 
                      105\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^4, 
                      105\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket], 
                      90\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^3\
\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket], 
                      60\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^3 + 
                        45\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2\
\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 
                            3\[RightDoubleBracket], 
                      24\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^4 + 
                        72\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 3\
\[RightDoubleBracket]\^2\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        9\ S\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket]\^2, 
                      60\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^3\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket] + 
                        45\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]2, 
                            3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^2, 
                      90\ S\[LeftDoubleBracket]2, 3\[RightDoubleBracket]\^2\ \
S\[LeftDoubleBracket]3, 3\[RightDoubleBracket]\^2 + 
                        15\ S\[LeftDoubleBracket]2, 
                            2\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^3, 
                      105\ S\[LeftDoubleBracket]2, 
                          3\[RightDoubleBracket]\ S\[LeftDoubleBracket]3, 3\
\[RightDoubleBracket]\^3, 
                      105\ S\[LeftDoubleBracket]3, 3\[RightDoubleBracket]\^4}\
\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "GaussMomentMflat"],
      Editable->False]], "Print",
  PageWidth->Infinity,
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
GaussMomentM[4,S,2]
GaussMomentMflat[4,S,2]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{{{3*S[[1,1]]^2, 3*S[[1,2]]*S[[1,1]]}, \
{S[[1,2]]*S[[1,1]] + 2*S[[1,1]]*S[[1,2]], 

      S[[2,2]]*S[[1,1]] + 2*S[[1,2]]^2}}, 

    {{S[[1,2]]*S[[1,1]] + 2*S[[1,1]]*S[[1,2]], S[[2,2]]*S[[1,1]] + \
2*S[[1,2]]^2}, 

     {2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]], 2*S[[2,2]]*S[[1,2]] + \
S[[1,2]]*S[[2,2]]}}}, 

   {{{S[[1,2]]*S[[1,1]] + 2*S[[1,1]]*S[[1,2]], S[[2,2]]*S[[1,1]] + \
2*S[[1,2]]^2}, 

     {2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]], 2*S[[2,2]]*S[[1,2]] + \
S[[1,2]]*S[[2,2]]}}, 

    {{2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]], 2*S[[2,2]]*S[[1,2]] + \
S[[1,2]]*S[[2,2]]}, 

     {3*S[[1,2]]*S[[2,2]], 3*S[[2,2]]^2}}}}\
\>", "\<\
               2
 {{{{3 S[[1,1]] , 3 S[[1,2]] S[[1,1]]}, 
                                                                          2
  {S[[1,2]] S[[1,1]] + 2 S[[1,1]] S[[1,2]], S[[2,2]] S[[1,1]] + 2 S[[1,2]] \
}}, 
                                                                           2
  {{S[[1,2]] S[[1,1]] + 2 S[[1,1]] S[[1,2]], S[[2,2]] S[[1,1]] + 2 S[[1,2]] \
}, 
             2
  {2 S[[1,2]]  + S[[1,1]] S[[2,2]], 2 S[[2,2]] S[[1,2]] + S[[1,2]] \
S[[2,2]]}}}, 
                                                                            2
  {{{S[[1,2]] S[[1,1]] + 2 S[[1,1]] S[[1,2]], S[[2,2]] S[[1,1]] + 2 S[[1,2]] \
}, 
             2
  {2 S[[1,2]]  + S[[1,1]] S[[2,2]], 2 S[[2,2]] S[[1,2]] + S[[1,2]] \
S[[2,2]]}}, 
              2
  {{2 S[[1,2]]  + S[[1,1]] S[[2,2]], 2 S[[2,2]] S[[1,2]] + S[[1,2]] \
S[[2,2]]}, 
                                  2
  {3 S[[1,2]] S[[2,2]], 3 S[[2,2]] }}}}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {3*S[[1,1]]^2, 3*S[[1,2]]*S[[1,1]], \
S[[2,2]]*S[[1,1]] + 2*S[[1,2]]^2, 

   2*S[[2,2]]*S[[1,2]] + S[[1,2]]*S[[2,2]], 3*S[[2,2]]^2}\
\>", "\<\
         \
   2                                                     2
 {3 S[[1,1]] , 3 S[[1,2]] S[[1,1]], S[[2,2]] S[[1,1]] + 2 S[[1,2]] , 
                                                     2
  2 S[[2,2]] S[[1,2]] + S[[1,2]] S[[2,2]], 3 S[[2,2]] }\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Closed]],

Cell[TextData[{
  "GaussMomenteMultianalytisch//Clear\n\
(***************************************************************)\t\t\t ",
  StyleBox["\n",
    FontColor->RGBColor[1, 0, 0]],
  "GaussMomenteMultianalytisch[mue_,Sigma_,K_,flat_:flattensymmetric]:=\n\
(***************************************************************)\t\t\t ",
  StyleBox["\n",
    FontColor->RGBColor[1, 0, 0]],
  "Module[{m},\nm=Table[GaussMoment[k,Sigma]//flat,{k,2,K}];\nJoin[{mue},m]\n\
]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[TextData[{
  "\n",
  StyleBox["TimeUpNonlinear//Clear\n",
    FontColor->RGBColor[1, 0, 0]],
  "(***************************************************************)\t\t\t ",
  StyleBox["\nTimeUpNonlinear",
    FontColor->RGBColor[1, 0, 0]],
  "[{mi_,X_,dt_},Theta_,{F_,system_},Gauss_:True]:=\n\
(***************************************************************)\t\t\t \n\
Block[{T,m,M},\n\nT=Length[X]-1; (*T//Print;*)\nm=mi;\nM=Shape[0,T+1];\n\
M[[1]]=mi;\n\nDo[\n\nm = m + F[{m,X[[i]]},Theta,system,Gauss] dt;\n\n\
M[[i+1]]=m;\n\n,{i,1,T}];\n\n{m,M}\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["TimeUpNonlinearPSD//Clear\n",
    FontColor->RGBColor[1, 0, 0]],
  "(***************************************************************)\t\t\t ",
  StyleBox["\nTimeUpNonlinearPSD",
    FontColor->RGBColor[1, 0, 0]],
  "[{mi_,X_,dt_},Theta_,{f_,Omega_},{MkSymb_,A_,B_,DT_}]:=\n\
(***************************************************************)\t\t\t \n\
Block[{T,m,M,y,K,rule,mue,Sigma,vals,H,Hl,fl,Ef,Mk,a,b,x,eps},\n\n\
T=Length[X]-1; (*T//Print;*)\nm=mi;\nM=Shape[0,T+1];\nM[[1]]=mi;\n\n\
K=mi//Length;\n\nDo[\n\nxi=X[[i]];\nmue  = m[[1]];\nSigma= m[[2]];  \n\n\
(*Sigma//Print;*)\n\n(*Sigma=Shift[{{Sigma}}, 10^-8];*)\n\nvals = \
TrafoMueSigma[VALS,{{mue},{{Sigma}}}]; \n\n\
H[y_]=HermiteExpansionOhnePhi[y,m];\n\n\nHl=Map[H[#]&,vals]//Flatten;\n\n\
eps=10^-1;\ntrafo=(x=(#-eps);x*Heaviside[x]+eps)&;\nHl=trafo[Hl];\n\n(*Hl=Hl \
Logistic[100 Hl];*)\n\n\nc=WEIGHT.Hl; (* Normierung von p=phi*H  *)\nHl=Hl/c;\
\n\n\n(*{i,Hl}//Print;*)\n(*Print[i,\"  \",c,\"  \",m];*)\n\n\n\n\
fl=Map[f[#,xi,Theta]&,vals];\nEf = WEIGHT.(Hl fl);\nm[[1]] = mue + Ef \
dt//First;\n\na = vals + fl dt - m[[1]];\nb = Map[Omega[#,xi,Theta]&,vals];\n\
\n\nDo[\n\n\tMk=MkSymb[k]/.{A->a,B->b,DT->dt};\n\n\tm[[k]]=WEIGHT.(Hl \
Mk)//First,\n\n\t{k,2,K}];\n\t\n\nM[[i+1]]=m;\n\n(*Print[i,m//Chop];*)\n\n\
,{i,1,T}];\n\n{m,M}\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"TimeUpNonlinearPSD"],

Cell[CellGroupData[{

Cell[TextData[{
  "{VALS,WEIGHT}=GaussHermitePointsMulti2[3,1];\n{m,M}=",
  StyleBox["TimeUpNonlinearPSD",
    FontColor->RGBColor[1, 0, 0]],
  "[{{1,2,3,4},{1,2,3},dt},Theta,{f1,g1,MkSymb,A,B,DT}]\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^5
                               -16
Stuetzstellen:3  groesser 1. 10    :3\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{0.970181461380186, 3.9939064031472506, \
-1.9744737388611073, 40.189963955967805}, {{1, 2, 3, 4}, {1., \
3.2684000000000006, -0.8262809999999979, 22.561748370000007}, 

    {0.970181461380186, 3.9939064031472506, -1.9744737388611073, \
40.189963955967805}}}\
\>", "\<\
{{0.970181, 3.99391, -1.97447, 40.19}, {{1, \
2, 3, 4}, {1., 3.2684, -0.826281, 22.5617}, {0.970181, 3.99391, -1.97447, \
40.19}}}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
rule=MapThread[Rule[#1,#2]&,
\t\t{Table[C^k,{k,1,6}],GaussMomente[0,DT,6]}]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{C -> 0, C^2 -> DT, C^3 -> 0, C^4 -> 3*DT^2, C^5 -> \
0, C^6 -> 15*DT^3}\
\>", "\<\
          2         3        4        2   5     \
   6         3
{C -> 0, C  -> DT, C  -> 0, C  -> 3 DT , C  -> 0, C  -> 15 DT }\
\>"], \
"Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
((A + (B//Sqrt) C)^6//Expand)
((A + (B//Sqrt) C)^6//Expand)/.rule/.{B->Omeg}\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
A^6 + 6*A^5*Sqrt[B]*C + 15*A^4*B*C^2 + \
20*A^3*B^(3/2)*C^3 + 15*A^2*B^2*C^4 + 6*A*B^(5/2)*C^5 + B^3*C^6\
\>", "\<\
 6 \
     5                 4    2       3  3/2  3       2  2  4        5/2  5    \
3  6
A  + 6 A  Sqrt[B] C + 15 A  B C  + 20 A  B    C  + 15 A  B  C  + 6 A B    C  \
+ B  C\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
A^6 + 15*A^4*DT*Omeg + 45*A^2*DT^2*Omeg^2 + \
15*DT^3*Omeg^3\
\>", "\<\
 6       4               2   2     2        3     3
A  + 15 A  DT Omeg + 45 A  DT  Omeg  + 15 DT  Omeg\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[TextData[{
  StyleBox["TimeUpNonlinearPSDMulti4//Clear\n",
    FontColor->RGBColor[1, 0, 0]],
  "(***************************************************************)\t\t\t ",
  StyleBox["\nTimeUpNonlinearPSDMulti4",
    FontColor->RGBColor[1, 0, 0]],
  "[{mi_,X_,dt_},Theta_,{f_,Omega_}]:=\n\
(***************************************************************)\t\t\t \n\
Block[{T,m,mm,M,y,y1,y2,K,rule,mue,Sigma,vals,H,Hl,fl,Ef,eta,Mk,x,eps,p,a,o,\
ind},\n\nT=Length[X]-1; (*T//Print;*)\nm=mi;\nM=Shape[0,T+1];\nM[[1]]=mi;\n\n\
K=mi//Length;\np=mi//First//Length;\n\n\
ind=Table[indexflattensymmetric[k,p],{k,1,K}];\n\nDo[\n\nxi=X[[i]];\nmue  = \
m[[1]];\nSigma= m[[2]];\nSigma= momentexp2index[Sigma,k=2,p]; \n\n\
(*Sigma//Print;*)\n(*Sigma=Shift[{{Sigma}}, 10^-8];*)\n\nvals = \
TrafoMueSigma[VALS,{mue,Sigma}]; \n\n\
(*H[{y1_,y2_}]=HermiteExpansionMultiStand[{y1,y2},m,\"{d,H}\"];*)\n\
(*H[{y1_,y2_}]=HermiteExpansionMultipStand[{y1,y2},m,\"H\"];*)\n\nOff[",
  StyleBox["Part::partd",
    FontColor->RGBColor[1, 0, 0]],
  "];\nH[y_]=HermiteExpansionMultipStand[Table[y[[j]],{j,p}],m,\"H\"];\n\n\n\
(*H[{y1,y2}]//Print;*)\n\nHl=Map[H[#]&,vals]; \n\neps=10^-1;\n\
trafo=(x=(#-eps);x*Heaviside[x]+eps)&;\nHl=trafo[Hl];\n\n(*Hl=Hl Logistic[100 \
Hl];*)\n\n\nc=WEIGHT.Hl; (* Normierung von p=phi*H  *)\nHl=Hl/c;\nWH=WEIGHT \
Hl;    \n\n(*{i,Hl,vals}//Print;*)  \n(*Print[i,\"  \",c,\"  \",m];*)\n\n\
fl=Map[f[#,xi,Theta]&,vals];\nEf = WH.fl; \nm[[1]] = mue + Ef dt;  \n\
eta=vals+fl dt;\n\na = Map[(#-m[[1]])&,eta];\no = \
Map[Omega[#,xi,Theta]&,vals]dt; \nao={a,o}//Transpose;\n\nDo[\n \n\
mm=Outer[momentk[k][#1,#2]&,ind[[k]],ao,1];  \nm[[k]]=WH.(mm//Transpose)\n\n\
,{k,2,K}];\n\nM[[i+1]]=m;\n\n(*Print[i,m//Chop];*)\n\n,{i,1,T}];\n\n{m,M}\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"TimeUpNonlinearPSDMulti4"],

Cell["\<\
momentk//Clear
momentk[2][{i_,j_},{a_,Omega_}]:=a[[i]]a[[j]]+Omega[[i,j]]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
momentk[3][{i_,j_,k_},{a_,Omega_}]:=
     a[[i]]a[[j]]a[[k]]+
     a[[i]]Omega[[j,k]]+
     a[[j]]Omega[[i,k]]+
     a[[k]]Omega[[i,j]]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\

momentk[4][{i_,j_,k_,l_},{a_,Omega_}]:=
Module[{ai=a[[i]],aj=a[[j]],ak=a[[k]],al=a[[l]]},

     ai aj ak al+
     
     (ai aj Omega[[k,l]]+
      ai ak Omega[[j,l]]+
      ai al Omega[[j,k]]+
      aj ak Omega[[i,l]]+
      aj al Omega[[i,k]]+
      ak al Omega[[i,j]])+
     
     (Omega[[i,j]] Omega[[k,l]]+
      Omega[[i,k]] Omega[[j,l]]+
      Omega[[i,l]] Omega[[j,k]])
  ]   
    \
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["??momentk", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Global`momentk
momentk[2][{i_, j_}, {a_, Omega_}] := a[[i]]*a[[j]] + Omega[[i,j]]
 
momentk[3][{i_, j_, k_}, {a_, Omega_}] := a[[i]]*a[[j]]*a[[k]] + 
    a[[i]]*Omega[[j,k]] + a[[j]]*Omega[[i,k]] + a[[k]]*Omega[[i,j]]
 
momentk[4][{i_, j_, k_, l_}, {a_, Omega_}] := 
   Module[{ai = a[[i]], aj = a[[j]], ak = a[[k]], al = a[[l]]}, 
    ai*aj*ak*al + (ai*aj*Omega[[k,l]] + ai*ak*Omega[[j,l]] + \
ai*al*Omega[[j,k]] + 
      aj*ak*Omega[[i,l]] + aj*al*Omega[[i,k]] + ak*al*Omega[[i,j]]) + 
     (Omega[[i,j]]*Omega[[k,l]] + Omega[[i,k]]*Omega[[j,l]] + 
      Omega[[i,l]]*Omega[[j,k]])]\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell["\<\
PotenzMenge//Clear
(***************************************************************)\t\t\t 
PotenzMenge[A_,Origin_:1]:=Module[{k,exp},
(***************************************************************)\t\t\t 
k=A//Length;
exp=Table[IntegerDigits[i,2,k],{i,Origin,2^k-1}]; 
Map[DeleteCases[#,0]&,Map[(A*#)&,exp]]//Sort
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
gammarule//Clear
(***************************************************************)\t\t\t 
gammarule[gamma_,m_,i_,K_]:=Module[{ivec,rule},
(***************************************************************)\t\t\t 
Unprotect[Times];
ClearAll[Times];
SetAttributes[Times,{Flat,Listable,OneIdentity}];

ivec=Array[i,K]; 
ivec=PotenzMenge[ivec]//Reverse;
ivec=Flatten[Map[Permutations,ivec],1]; 
rule=Map[(Times@@Map[gamma,#]->
          If[EvenQ[Length[#]],m[Length[#],Sequence@@#],0])&,ivec,{1}];

SetAttributes[Times,{Flat, Listable, NumericFunction, OneIdentity, Orderless, \
Protected}];

rule
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["gammarule[ga,mmm,i,4]", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \({ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[1], i[2], i[3], i[4]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[1], i[2], i[4], i[3]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[1], i[3], i[2], i[4]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[1], i[3], i[4], i[2]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[1], i[4], i[2], i[3]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[1], i[4], i[3], i[2]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[2], i[1], i[3], i[4]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[2], i[1], i[4], i[3]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[2], i[3], i[1], i[4]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[2], i[3], i[4], i[1]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[2], i[4], i[1], i[3]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[2], i[4], i[3], i[1]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[3], i[1], i[2], i[4]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[3], i[1], i[4], i[2]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[3], i[2], i[1], i[4]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[3], i[2], i[4], i[1]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[3], i[4], i[1], i[2]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[3], i[4], i[2], i[1]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[4], i[1], i[2], i[3]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[4], i[1], i[3], i[2]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[4], i[2], i[1], i[3]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[4], i[2], i[3], i[1]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[4], i[3], i[1], i[2]], 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 
        mmm[4, i[4], i[3], i[2], i[1]], 
      ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[2]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[3]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[4]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]] \[Rule] 0, 
      ga[i[1]]\ ga[i[2]]\ ga[i[3]] \[Rule] 0, 
      ga[i[3]]\ ga[i[4]] \[Rule] mmm[2, i[3], i[4]], 
      ga[i[3]]\ ga[i[4]] \[Rule] mmm[2, i[4], i[3]], 
      ga[i[2]]\ ga[i[4]] \[Rule] mmm[2, i[2], i[4]], 
      ga[i[2]]\ ga[i[4]] \[Rule] mmm[2, i[4], i[2]], 
      ga[i[2]]\ ga[i[3]] \[Rule] mmm[2, i[2], i[3]], 
      ga[i[2]]\ ga[i[3]] \[Rule] mmm[2, i[3], i[2]], 
      ga[i[1]]\ ga[i[4]] \[Rule] mmm[2, i[1], i[4]], 
      ga[i[1]]\ ga[i[4]] \[Rule] mmm[2, i[4], i[1]], 
      ga[i[1]]\ ga[i[3]] \[Rule] mmm[2, i[1], i[3]], 
      ga[i[1]]\ ga[i[3]] \[Rule] mmm[2, i[3], i[1]], 
      ga[i[1]]\ ga[i[2]] \[Rule] mmm[2, i[1], i[2]], 
      ga[i[1]]\ ga[i[2]] \[Rule] mmm[2, i[2], i[1]], ga[i[4]] \[Rule] 0, 
      ga[i[3]] \[Rule] 0, ga[i[2]] \[Rule] 0, ga[i[1]] \[Rule] 0}\)], "Output"]
}, Open  ]],

Cell["\<\
momentsymb//Clear
(***************************************************************)\t\t\t 
momentsymb[K_,i_,a_,m_]:=
(***************************************************************)\t\t\t 
Module[{rule,gamma},

rule=gammarule[gamma,m,i,K]; 
(*rule//Print*);   
(Product[a[i[j]]+gamma[i[j]],{j,1,K}]//Expand)//.rule
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["\<\
Clear[i,a,m,x,p]
mom=momentsymb[6,i,a,m]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \(a[i[1]]\ a[i[2]]\ a[i[3]]\ a[i[4]]\ a[i[5]]\ a[i[6]] + 
      a[i[3]]\ a[i[4]]\ a[i[5]]\ a[i[6]]\ m[2, i[1], i[2]] + 
      a[i[2]]\ a[i[4]]\ a[i[5]]\ a[i[6]]\ m[2, i[1], i[3]] + 
      a[i[2]]\ a[i[3]]\ a[i[5]]\ a[i[6]]\ m[2, i[1], i[4]] + 
      a[i[2]]\ a[i[3]]\ a[i[4]]\ a[i[6]]\ m[2, i[1], i[5]] + 
      a[i[2]]\ a[i[3]]\ a[i[4]]\ a[i[5]]\ m[2, i[1], i[6]] + 
      a[i[1]]\ a[i[4]]\ a[i[5]]\ a[i[6]]\ m[2, i[2], i[3]] + 
      a[i[1]]\ a[i[3]]\ a[i[5]]\ a[i[6]]\ m[2, i[2], i[4]] + 
      a[i[1]]\ a[i[3]]\ a[i[4]]\ a[i[6]]\ m[2, i[2], i[5]] + 
      a[i[1]]\ a[i[3]]\ a[i[4]]\ a[i[5]]\ m[2, i[2], i[6]] + 
      a[i[1]]\ a[i[2]]\ a[i[5]]\ a[i[6]]\ m[2, i[3], i[4]] + 
      a[i[1]]\ a[i[2]]\ a[i[4]]\ a[i[6]]\ m[2, i[3], i[5]] + 
      a[i[1]]\ a[i[2]]\ a[i[4]]\ a[i[5]]\ m[2, i[3], i[6]] + 
      a[i[1]]\ a[i[2]]\ a[i[3]]\ a[i[6]]\ m[2, i[4], i[5]] + 
      a[i[1]]\ a[i[2]]\ a[i[3]]\ a[i[5]]\ m[2, i[4], i[6]] + 
      a[i[1]]\ a[i[2]]\ a[i[3]]\ a[i[4]]\ m[2, i[5], i[6]] + 
      a[i[5]]\ a[i[6]]\ m[4, i[1], i[2], i[3], i[4]] + 
      a[i[4]]\ a[i[6]]\ m[4, i[1], i[2], i[3], i[5]] + 
      a[i[4]]\ a[i[5]]\ m[4, i[1], i[2], i[3], i[6]] + 
      a[i[3]]\ a[i[6]]\ m[4, i[1], i[2], i[4], i[5]] + 
      a[i[3]]\ a[i[5]]\ m[4, i[1], i[2], i[4], i[6]] + 
      a[i[3]]\ a[i[4]]\ m[4, i[1], i[2], i[5], i[6]] + 
      a[i[2]]\ a[i[6]]\ m[4, i[1], i[3], i[4], i[5]] + 
      a[i[2]]\ a[i[5]]\ m[4, i[1], i[3], i[4], i[6]] + 
      a[i[2]]\ a[i[4]]\ m[4, i[1], i[3], i[5], i[6]] + 
      a[i[2]]\ a[i[3]]\ m[4, i[1], i[4], i[5], i[6]] + 
      a[i[1]]\ a[i[6]]\ m[4, i[2], i[3], i[4], i[5]] + 
      a[i[1]]\ a[i[5]]\ m[4, i[2], i[3], i[4], i[6]] + 
      a[i[1]]\ a[i[4]]\ m[4, i[2], i[3], i[5], i[6]] + 
      a[i[1]]\ a[i[3]]\ m[4, i[2], i[4], i[5], i[6]] + 
      a[i[1]]\ a[i[2]]\ m[4, i[3], i[4], i[5], i[6]] + 
      m[6, i[1], i[2], i[3], i[4], i[5], i[6]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["((a+m)^6//Expand)", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
a^6 + 6*a^5*m + 15*a^4*m^2 + 20*a^3*m^3 + 15*a^2*m^4 \
+ 6*a*m^5 + m^6\
\>", "\<\
 6      5         4  2       3  3       2  4       \
 5    6
a  + 6 a  m + 15 a  m  + 20 a  m  + 15 a  m  + 6 a m  + m\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[BoxData[
    \(g // Clear\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((\((y + f\ dT\  + \ g\ \ dT^\((1/2)\))\)^6 // Expand)\)\  + 
        O[g]^3*O[dT]^2 // Normal\)], "Input"],

Cell[BoxData[
    \(6\ \@dT\ g\ y\^5 + y\^6 + 
      dT\^\(3/2\)\ \((20\ g\^3\ y\^3 + 30\ f\ g\ y\^4)\) + 
      dT\ \((15\ g\^2\ y\^4 + 6\ f\ y\^5)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
((mom/.{a[x_]->a[[x]]})/.m[x_,y__]->m[[x,\"linposindex\"[{y},p]]])/.\
i[x_]->i[[x]]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 a[[i[[1]]]]*a[[i[[2]]]]*a[[i[[3]]]]*a[[i[[4]]]] + 

   a[[i[[3]]]]*a[[i[[4]]]]*m[[2,\"linposindex\"[{i[[1]], i[[2]]}, p]]] + 

   a[[i[[2]]]]*a[[i[[4]]]]*m[[2,\"linposindex\"[{i[[1]], i[[3]]}, p]]] + 

   a[[i[[2]]]]*a[[i[[3]]]]*m[[2,\"linposindex\"[{i[[1]], i[[4]]}, p]]] + 

   a[[i[[1]]]]*a[[i[[4]]]]*m[[2,\"linposindex\"[{i[[2]], i[[3]]}, p]]] + 

   a[[i[[1]]]]*a[[i[[3]]]]*m[[2,\"linposindex\"[{i[[2]], i[[4]]}, p]]] + 

   a[[i[[1]]]]*a[[i[[2]]]]*m[[2,\"linposindex\"[{i[[3]], i[[4]]}, p]]] + 

   m[[4,\"linposindex\"[{i[[1]], i[[2]], i[[3]], i[[4]]}, p]]]\
\>", "\<\
 \
a[[i[[1]]]] a[[i[[2]]]] a[[i[[3]]]] a[[i[[4]]]] + 
  a[[i[[3]]]] a[[i[[4]]]] m[[2,linposindex[{i[[1]], i[[2]]}, p]]] + 
  a[[i[[2]]]] a[[i[[4]]]] m[[2,linposindex[{i[[1]], i[[3]]}, p]]] + 
  a[[i[[2]]]] a[[i[[3]]]] m[[2,linposindex[{i[[1]], i[[4]]}, p]]] + 
  a[[i[[1]]]] a[[i[[4]]]] m[[2,linposindex[{i[[2]], i[[3]]}, p]]] + 
  a[[i[[1]]]] a[[i[[3]]]] m[[2,linposindex[{i[[2]], i[[4]]}, p]]] + 
  a[[i[[1]]]] a[[i[[2]]]] m[[2,linposindex[{i[[3]], i[[4]]}, p]]] + 
  m[[4,linposindex[{i[[1]], i[[2]], i[[3]], i[[4]]}, p]]]\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[momentflat,k,i,a,m,x,p,text]
Do[

(***************************************************************)\t\t\t 
momentflat[k,i_,{a_,m_},{text_,p_}]=Module[{mom,ii,aa,mm,x,y},
(***************************************************************)\t\t\t 
mom=momentsymb[k,ii,aa,mm];
(mom/.{aa[x_]->a[[x]],mm[x_,y__]->m[[x,text[{y},p] ]]})/.ii[x_]->i[[x]]
]
,{k,1,6}]
\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \\!\\(text\\) is \
Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message",
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["??momentflat", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["Global`momentflat", "Print",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(momentflat[1, i_, {a_, m_}, {text_, p_}] = 
                    a\[LeftDoubleBracket]
                      i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(momentflat[2, i_, {a_, m_}, {text_, p_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      m\[LeftDoubleBracket]2, 
                        text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]2\[RightDoubleBracket]}, 
                          p]\[RightDoubleBracket]\)},
                {" "},
                {\(momentflat[3, i_, {a_, m_}, {text_, p_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket]\)},
                {" "},
                {\(momentflat[4, i_, {a_, m_}, {text_, p_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, text[{i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      m\[LeftDoubleBracket]4, 
                        text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                          p]\[RightDoubleBracket]\)},
                {" "},
                {\(momentflat[5, i_, {a_, m_}, {text_, p_}] = 
                    a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket]\)},
                {" "},
                {\(momentflat[6, i_, {a_, m_}, {text_, p_}] = 
                    a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          text[{i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]4, text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]4, text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]4, text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          text[{i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                              i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                            p]\[RightDoubleBracket] + 
                      m\[LeftDoubleBracket]6, 
                        text[{i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                            i\[LeftDoubleBracket]6\[RightDoubleBracket]}, 
                          p]\[RightDoubleBracket]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "momentflat"],
      Editable->False]], "Print",
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
momentflat[2,{1,2},{{a1,a2},{0,{s11,s12,s22}}},{linposindex1,2}]
    moment[2,{1,2},{{a1,a2},{0,{{s11,s12},{s12,s22}}}}]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \(a1\ a2 + s12\)], "Output",
  FontSize->14],

Cell[BoxData[
    \(a1\ a2 + s12\)], "Output",
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
momentflat[4,ind={2,2,2,2},{{a1,a2},MMMM},{linposindex1,p=2}]
    moment[4,    {2,2,2,2},{{a1,a2},MMMM}]
    
linposindex1[ind,2]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \(a2\^4 + 6\ a2\^2\ MMMM\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
      MMMM\[LeftDoubleBracket]4, 5\[RightDoubleBracket]\)], "Output",
  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \(a2\^4 + 
      6\ a2\^2\ MMMM\[LeftDoubleBracket]2, 2, 2\[RightDoubleBracket] + 
      MMMM\[LeftDoubleBracket]4, 2, 2, 2, 2\[RightDoubleBracket]\)], "Output",\

  PageWidth->Infinity,
  FontSize->14],

Cell[BoxData[
    \(5\)], "Output",
  PageWidth->Infinity,
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["kexp[4,2]", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{4, 0}, {3, 1}, {2, 2}, {1, 3}, {0, 4}}\
\>", \
"\<\
{{4, 0}, {3, 1}, {2, 2}, {1, 3}, {0, 4}}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[TextData[{
  StyleBox["Off[RuleDelayed::rhs];\n",
    FontWeight->"Plain",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox["(***************************************************************)\
\t\t\t \nmoment[k_,i_,{a_,m_},{mom_,ii_,aa_,mm_}]:=Module[{x},\n\
(***************************************************************)\t\t\t \n\
(mom/.{aa[x_]->a[[x]],mm[x__]->m[[x]]})/.ii[x_]->i[[x]]\n]",
    FontWeight->"Plain"]
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[TextData[{
  "Clear[moment,k,i,a,m,x]\n\nDo[\n\n\
(***************************************************************)\t\t\t \n\
moment[k,i_,{a_,m_}]=Module[{mom,ii,aa,mm,x},\n\
(***************************************************************)\t\t\t \n\
mom=momentsymb[k,ii,aa,mm];\n\
(mom/.{aa[x_]->a[[x]],mm[x__]->m[[x]]})/.ii[x_]->i[[x]]\n]\n\n,{k,1,8}]\n\n\n\
",
  StyleBox["Off[",
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox["RuleDelayed::rhs",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox["];\n",
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  "(***************************************************************)\t\t\t \n\
moment[k_,i_,{a_,m_},{mom_,ii_,aa_,mm_}]:=Module[{x},\n\
(***************************************************************)\t\t\t \n\
(mom/.{aa[x_]->a[[x]],mm[x__]->m[[x]]})/.ii[x_]->i[[x]]\n]"
}], "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["\<\
SetDirectory[\"/Mathematica 2.2.2/Packages/Hermann/\"];
Get[\"momentformel\"];\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    RowBox[{\(SetDirectory::"cdir"\), \(\(:\)\(\ \)\), "\<\"Cannot set \
current directory to \\!\\(\\\"/Mathematica 2.2.2/Packages/Hermann/\\\"\\). \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"SetDirectory::cdir\\\"]\\)\"\>"}]], \
"Message"]
}, Open  ]],

Cell["(*Save[\"momentformel\",moment];*)", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["??moment", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["Global`moment", "Print",
  CellTags->"Info3417436417-6139240"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(moment[1, i_, {a_, m_}] = 
                    a\[LeftDoubleBracket]
                      i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(moment[2, i_, {a_, m_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      m\[LeftDoubleBracket]2, 
                        i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(moment[3, i_, {a_, m_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(moment[4, i_, {a_, m_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      m\[LeftDoubleBracket]4, 
                        i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(moment[5, i_, {a_, m_}] = 
                    a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(moment[6, i_, {a_, m_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      m\[LeftDoubleBracket]6, 
                        i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(moment[7, i_, {a_, m_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                                        i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]4, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(moment[8, i_, {a_, m_}] = 
                    a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]2, i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]2, 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]4\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]8\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]4, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]8\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]4, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]7\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]4, i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ a\
\[LeftDoubleBracket]i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]5\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]6\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]3\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]4, 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]8\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]8\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]5\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]8\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]6\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]4\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]2\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]3\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]7\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]6\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]5\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]4\[RightDoubleBracket]\
\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]
                          i\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket]\ m\[LeftDoubleBracket]6, 
                          i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      a\[LeftDoubleBracket]i\[LeftDoubleBracket]1\
\[RightDoubleBracket]\[RightDoubleBracket]\ a\[LeftDoubleBracket]i\
\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\ m\
\[LeftDoubleBracket]6, i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                          i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket] + 
                      m\[LeftDoubleBracket]8, 
                        i\[LeftDoubleBracket]1\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]2\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]3\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]4\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]5\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]6\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]7\[RightDoubleBracket], 
                        i\[LeftDoubleBracket]8\[RightDoubleBracket]\
\[RightDoubleBracket]\)},
                {" "},
                {\(moment[k_, i_, {a_, m_}, {mom_, ii_, aa_, mm_}] := 
                    Module[{x}, \(mom /. \[InvisibleSpace]{aa[x_] \[Rule] 
                              a\[LeftDoubleBracket]x\[RightDoubleBracket], 
                            mm[x__] \[Rule] 
                              m\[LeftDoubleBracket]
                                x\[RightDoubleBracket]}\) \
/. \[InvisibleSpace]ii[x_] \[Rule] 
                          i\[LeftDoubleBracket]x\[RightDoubleBracket]]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "moment"],
      Editable->False]], "Print",
  CellTags->"Info3417436417-6139240"]
}, Closed]],

Cell["x//Clear", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["??GaussMomentMflat", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Global`GaussMomentMflat
GaussMomentMflat[1, S_, 1] = {0}
 
GaussMomentMflat[2, S_, 1] = {S[[1,1]]}
 
GaussMomentMflat[3, S_, 1] = {0}
 
GaussMomentMflat[4, S_, 1] = {3*S[[1,1]]^2}
 
GaussMomentMflat[1, S_, 2] = {0, 0}
 
GaussMomentMflat[2, S_, 2] = {S[[1,1]], S[[1,2]], S[[2,2]]}
 
GaussMomentMflat[3, S_, 2] = {0, 0, 0, 0}
 
GaussMomentMflat[4, S_, 2] = {3*S[[1,1]]^2, 3*S[[1,1]]*S[[1,2]], 
    2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]], 3*S[[1,2]]*S[[2,2]], \
3*S[[2,2]]^2}\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(a2\)], "Input"],

Cell[BoxData[
    \(a2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
moment[3,{1,1,2},{{a1,a2},MM}]
momentflat[3,{1,1,2},{{a1,a2},MM},{linposindex,2}]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \(a1\^2\ a2 + a2\ MM\[LeftDoubleBracket]2, 1, 1\[RightDoubleBracket] + 
      2\ a1\ MM\[LeftDoubleBracket]2, 1, 2\[RightDoubleBracket]\)], "Output"],

Cell[BoxData[
    \(a1\^2\ a2 + a2\ MM\[LeftDoubleBracket]2, 1\[RightDoubleBracket] + 
      2\ a1\ MM\[LeftDoubleBracket]2, 2\[RightDoubleBracket]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((moment[3, {1, 2, 2}, {{y1 + f1\ Dt, y2 + f2\ Dt}, MM}])\) + 
      O[Dt]^2\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{\((y1\ y2\^2 + 
            2\ y2\ MM\[LeftDoubleBracket]2, 1, 2\[RightDoubleBracket] + 
            y1\ MM\[LeftDoubleBracket]2, 2, 2\[RightDoubleBracket])\), 
        "+", \(\((2\ f2\ y1\ y2 + f1\ y2\^2 + 
              2\ f2\ MM\[LeftDoubleBracket]2, 1, 2\[RightDoubleBracket] + 
              f1\ MM\[LeftDoubleBracket]2, 2, 2\[RightDoubleBracket])\)\ Dt\),
         "+", 
        InterpretationBox[\(O[Dt]\^2\),
          SeriesData[ Dt, 0, {}, 0, 2, 1],
          Editable->False]}],
      SeriesData[ Dt, 0, {
        Plus[ 
          Times[ y1, 
            Power[ y2, 2]], 
          Times[ 2, y2, 
            Part[ MM, 2, 1, 2]], 
          Times[ y1, 
            Part[ MM, 2, 2, 2]]], 
        Plus[ 
          Times[ 2, f2, y1, y2], 
          Times[ f1, 
            Power[ y2, 2]], 
          Times[ 2, f2, 
            Part[ MM, 2, 1, 2]], 
          Times[ f1, 
            Part[ MM, 2, 2, 2]]]}, 0, 2, 1],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
moment[3,{1,2,3},{{a1,a2,a3},MM}]
momentflat[3,{1,2,3},{{a1,a2,a3},MM},{linposindex2,p=3}]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[BoxData[
    \(a1\ a2\ a3 + a3\ MM\[LeftDoubleBracket]2, 1, 2\[RightDoubleBracket] + 
      a2\ MM\[LeftDoubleBracket]2, 1, 3\[RightDoubleBracket] + 
      a1\ MM\[LeftDoubleBracket]2, 2, 3\[RightDoubleBracket]\)], "Output"],

Cell[BoxData[
    \(a1\ a2\ a3 + a3\ MM\[LeftDoubleBracket]2, 2\[RightDoubleBracket] + 
      a2\ MM\[LeftDoubleBracket]2, 3\[RightDoubleBracket] + 
      a1\ MM\[LeftDoubleBracket]2, 5\[RightDoubleBracket]\)], "Output"]
}, Open  ]],

Cell["\<\
trafo//Clear
(***************************************************************)\t\t\t 
trafo[Hl_,eps_:0]:=Block[{mini},
(***************************************************************)\t\t\t 
mini=Min[Hl]; mini//Print;
If[mini<0,Hl-mini+eps,Hl]
];

\
\>", "Input",
  InitializationCell->True,
  FontSize->14,
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[CellGroupData[{

Cell["trafo[{1,-1,3}]", "Input",
  FontSize->14],

Cell[BoxData[
    \(\(-1\)\)], "Print",
  FontSize->14],

Cell[BoxData[
    \({2, 0, 4}\)], "Output",
  FontSize->14]
}, Open  ]],

Cell[TextData[{
  StyleBox["TimeUpNonlinearPSDMultialt//Clear\n",
    FontColor->RGBColor[1, 0, 0]],
  "(***************************************************************)\t\t\t ",
  StyleBox["\nTimeUpNonlinearPSDMultialt",
    FontColor->RGBColor[1, 0, 0]],
  "[{mi_,X_,dt_},Theta_,{f_,Omega_}]:=\n\
(***************************************************************)\t\t\t \n\
Block[{T,m,M,y,y1,y2,K,k,p,mue,Sigma,vals,H,Hl,c,WH,fl,Ef,x,\n       \
eps,mini,a,o,mk,mkl,ind,MomenteDW,t},\n\nT=Length[X]-1; (*T//Print;*)\nm=mi;\n\
M=Shape[0,T+1];\nM[[1]]=mi;\n\nK=mi//Length;\np=mi//First//Length;\n\n\
ind=Table[indexflattensymmetric[k,p],{k,1,K}];\n\nDo[\n\nt=X[[i]];\nmue  = \
m[[1]];\nSigma= m[[2]];\nSigma= momentexp2index[Sigma,k=2,p]; \n\nvals = \
TrafoMueSigma[VALS,{mue,Sigma},10^-16];\n\nOff[",
  StyleBox["Part::partd",
    FontColor->RGBColor[1, 0, 0]],
  "];\nH[y_]=HermiteExpansionMultipStand[Table[y[[j]],{j,p}],m,\"H\"];\n\n\
(*H[{y1,y2}]//Print;*)\n\nHl=Map[H[#]&,vals];\n\n(*Hl//Print;*)\n\n\
maxi=Hl//Max;\neps=10^-3 maxi;\neps//Print;\n\
trafo=(x=(#-eps);x*Heaviside[x]+eps)&;\n\nIf[TRAFO,Hl = trafo[Hl]];\n\n\n\
(*Hl=Hl Logistic[100 Hl];*)\n\n\nc=WEIGHT.Hl; (* Normierung von p=phi*H  *)\n\
Hl=Hl/c;\nWH=WEIGHT Hl;\n\nfl=Map[f[#,t,Theta]&,vals];\nEf = WH.fl;\nm[[1]] = \
mue + Ef dt;\n\na = Map[(#-m[[1]])&,vals+fl dt];\no = \
Map[Omega[#,t,Theta]&,vals]dt;\n\n\n\
MomenteDW=Table[If[EvenQ[k],GaussMomentM[k,o[[j]],p],{0}],\n               \
{j,1,vals//Length},{k,1,K}];\n\n(*\n\
MomenteDW=Table[If[EvenQ[k],GaussMomentMflat[k,o[[j]],p],{0}],\n              \
 {j,1,vals//Length},{k,1,K}];*)\n\naMomenteDW={a,MomenteDW}//Transpose;\n\n\
(*Goto[label];*)\nOff[",
  StyleBox["Part::pspec];\n",
    FontColor->RGBColor[1, 0, 0]],
  "\nDo[\n\nmk=moment[k,#1,#2]&;\n\n\
(*mk=momentflat[k,#1,#2,{linposindex2,p}]&;*)\n\n(*\nMap[ \
linposindex[#,p]&,ind[[k]]]//Print;\nMap[linposindex1[#,p]&,ind[[k]]]//Print;\
\nMap[linposindex2[#,p]&,ind[[k]]]//Print;\n*)\n\n\n\
mkl=Outer[mk,ind[[k]],aMomenteDW,1];(*alle Indices und \
St\[UDoubleDot]tzstellen*)\n\n(*Print[{i,k},ind[[k]],mkl];*)\n\n\
m[[k]]=WH.(mkl//Transpose);\n\n(*Print[{i,k},m[[k]]];*)\n\n,{k,2,K}];\n\n\
M[[i+1]]=m;\n\nPrint[i,m[[{1,2}]]//Chop];\n\n,{i,1,T}];\n\nLabel[label];\n\n\
{m,M}\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["??Shift", "Input",
  FontSize->14],

Cell["Global`Shift", "Print",
  FontSize->14],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(Shift[H_, BOUND_, Text_ : \*"\<\"\"\>"] := 
                    Module[{H1, EIGEN, MINI, COND, minabs}, 
                      EIGEN = Eigenvalues[H]; MINI = Min[EIGEN]; 
                      minabs = Min[Abs[EIGEN]]; 
                      COND = If[minabs =!= 0, 
                          Max[Abs[EIGEN]]\/minabs, \[Infinity]]; 
                      If[MINI < BOUND, 
                        Print[Text, i, 
                          "Shift:Warnung:kleine EIGENWERTE der \
Kovarianz-MATRIX: ", EIGEN, "  BOUND  ", N[BOUND]]; 
                        H1 = H + 
                            DiagonalMatrix[
                              Array[BOUND - MINI &, {Length[H]}]], H1 = H]; 
                      Return[H1]]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "Shift"],
      Editable->False]], "Print",
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? Shift\)], "Input"],

Cell["Global`Shift", "Print",
  CellTags->"Info3416764132-1117871"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(Shift[H_, BOUND_, Text_ : \*"\<\"\"\>"] := 
                    Module[{H1, EIGEN, MINI, COND, minabs}, 
                      EIGEN = Eigenvalues[H]; MINI = Min[EIGEN]; 
                      minabs = Min[Abs[EIGEN]]; 
                      COND = If[minabs =!= 0, 
                          Max[Abs[EIGEN]]\/minabs, \[Infinity]]; 
                      If[MINI < BOUND, 
                        Print[Text, i, 
                          "Shift:Warnung:kleine EIGENWERTE der \
Kovarianz-MATRIX: ", EIGEN, "  BOUND  ", N[BOUND]]; 
                        H1 = H + 
                            DiagonalMatrix[
                              Array[BOUND - MINI &, {Length[H]}]], H1 = H]; 
                      Return[H1]]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "Shift"],
      Editable->False]], "Print",
  CellTags->"Info3416764132-1117871"]
}, Open  ]],

Cell[TextData[{
  StyleBox["TimeUpNonlinearPSDMulti//Clear\n",
    FontColor->RGBColor[1, 0, 0]],
  "(***************************************************************)\t\t\t ",
  StyleBox["\nTimeUpNonlinearPSDMulti",
    FontColor->RGBColor[1, 0, 0]],
  "[{mi_,X_,dt_},Theta_,{f_,Omega_}]:=\n\
(***************************************************************)\t\t\t \n\
Block[{T,m,M,y,z,y1,y2,K,k,p,mue,Sigma,H,c,WH,fl,Ef,x,\n       \
eps,maxi,a,o,mk,mkl,ind,MomenteDW,t,phi,phi2,DT},\n\n(*Print[\"",
  StyleBox["TimeUpNonlinearPSDMulti",
    FontColor->RGBColor[1, 0, 0]],
  "\"];*)\n\nT=Length[X]-1; (*T//Print;*)\nm=mi;\nM=Shape[0,T+1];\nM[[1]]=mi;\
\n\nK=mi//Length;\np=mi//First//Length;\n\n\
ind=Table[indexflattensymmetric[k,p],{k,1,K}];\n\nDo[\n\nt=X[[i]];\n\nmue  = \
m[[1]];\nSigma= m[[2]];\nSigma= momentexp2index[Sigma,k=2,p];\n \nscale1=1.0;\
\nscale2=1.0;\nSigma2=Sigma*scale1;\nmue2  =  mue*scale2;\n\n\
Sigma2=Shift[Sigma2,",
  StyleBox["10^-14",
    FontColor->RGBColor[1, 0, 0]],
  ",\"TimeUpNonlinearPSDMulti\"];\n\nm[[2]]=flattensymmetric[Sigma2];\nvals = \
TrafoMueSigma[VALS,{mue2,Sigma2},0];\n\n(*\nOff[",
  StyleBox["Part::partd",
    FontColor->RGBColor[1, 0, 0]],
  "]; \nH[y_]=HermiteExpansionMultipStand[Table[y[[j]],{j,p}],m,\"H\"];\n\
Hl=Map[H[#]&,vals];\n*)\n\n\nOff[",
  StyleBox["Part::partd",
    FontColor->RGBColor[1, 0, 0]],
  "];\nH[z_]=HermiteExpansionMultipStandz[Table[z[[j]],{j,p}],m,\"H\"];\n\
Hl=Map[H[#]&,VALS];\n\n\n(*\npos=Position[Hl,Hl//Max]//First;\n\
mue2=Extract[vals,pos];  mue2//Print;\nvals = \
TrafoMueSigma[VALS,{mue2,Sigma2}]; \nHl=Map[H[#]&,vals];\n*)\n\n\nIf[TRAFO>0,\
\n\nWhich[\n\n\tTRAFO==1,\n\tmaxi=Hl//Max;\n\teps=$SHIFT maxi,\n\n\tTRAFO==2,\
\n\teps=$EPS\n];\n\n(*eps//Print;*)\nHl=Map[Max[#,eps]&,Hl]\n];\n\n\n\n\
c=WEIGHT.Hl; (* Normierung von p=phi*H  *)\nHl=Hl/c;\nWH=WEIGHT Hl;\n\n",
  StyleBox["(*importance sampling*)\n(*\nSigmaInv = Sigma//Inverse;\nphi = \
GaussDichte1[#,{mue,Sigma,SigmaInv}]&;\nphil = Map[phi,vals];\n\nSigma2Inv = \
Sigma2//Inverse;\nphi2 = GaussDichte1[#,{mue2,Sigma2,Sigma2Inv}]&;\nphi2l = \
Map[phi2,vals];\nWH=WH (phil/phi2l);\n*)",
    FontColor->GrayLevel[0.666667],
    Background->GrayLevel[1]],
  StyleBox["\n(*{i,Hl,vals,c}//Print;**)",
    FontColor->GrayLevel[0.666667]],
  "\n\nfl=Map[f[#,t,Theta]&,vals];\nEf = WH.fl;\nm[[1]] = mue + Ef dt;\n\n\na \
= Map[(#-m[[1]])&,vals+fl dt];\no = Map[Omega[#,t,Theta]&,vals]dt;\n\n\
MomenteDW=Table[If[EvenQ[k],GaussMomentM[k,o[[j]],p],{0}],\n             \
{j,1,vals//Length},{k,1,K}];\n\naMomenteDW={a,MomenteDW}//Transpose;\n        \
  \n(*MomenteDW//Print;*)\n\n\n(*Goto[label];*)\nOff[",
  StyleBox["Part::pspec];\n",
    FontColor->RGBColor[1, 0, 0]],
  "\nDo[\n\nmk=moment[k,#1,#2]&;\n\n\
(*mk=momentflat[k,#1,#2,{linposindex2,p}]&;*)\n\n(*\nMap[ \
linposindex[#,p]&,ind[[k]]]//Print;\nMap[linposindex1[#,p]&,ind[[k]]]//Print;\
\nMap[linposindex2[#,p]&,ind[[k]]]//Print;\n*)\n\n\n\
mkl=Outer[mk,ind[[k]],aMomenteDW,1];(*alle Indices und \
St\[UDoubleDot]tzstellen*)\n\n(*Print[{i,k},ind[[k]],mkl];*)\n\n\
m[[k]]=WH.(mkl//Transpose);\n\n(*Print[{i,k},m[[k]]];*)\n\n,{k,2,K}];\n\n\
M[[i+1]]=m;\n\n(*Print[{i,m[[{1,2}]]//Chop}];*)\n\
(*{i,momentexp2index[m[[2]],2,p]//Eigenvalues}//Print;*)\n\n,{i,1,T}];\n\n\
Label[label];\n\n{m,M}\n]"
}], "Input",
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"TimeUpNonlinearPSDMulti"],

Cell[CellGroupData[{

Cell["??flattensymmetric", "Input",
  FontSize->14],

Cell["Global`flattensymmetric", "Print",
  CellTags->"Info3416814232-9536192"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(flattensymmetric[m_] := 
                    Module[{kvec, dim, p, k}, dim = Dimensions[m]; 
                      p = First[dim]; k = Length[dim]; 
                      kvec = kexp[k, 
                          p]; \((m\[LeftDoubleBracket]
                              Sequence @@ 
                                exp2index[#1]\[RightDoubleBracket] &)\) /@ 
                        kvec]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "flattensymmetric"],
      Editable->False]], "Print",
  CellTags->"Info3416814232-9536192"]
}, Open  ]],

Cell[CellGroupData[{

Cell["??min", "Input",
  FontSize->14],

Cell[BoxData[
    \("min[x__] := Min[x]; SetAttributes[min,Listable]"\)], "Print",
  CellTags->"Info3416814239-9199848"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(Attributes[min] = {Listable, Protected}\)},
          {" "},
          {GridBox[{
                {\(min[code`Kronecker`Private`x__] := 
                    Min[code`Kronecker`Private`x]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "min"],
      Editable->False]], "Print",
  CellTags->"Info3416814239-9199848"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Min[{1,2,3,-.5}]", "Input",
  FontSize->14],

Cell[BoxData[
    \(\(-0.5`\)\)], "Output",
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["??GaussMomentM", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Global`GaussMomentM
GaussMomentM[1, S_, 1] = {0}
 
GaussMomentM[2, S_, 1] = {{S[[1,1]]}}
 
GaussMomentM[3, S_, 1] = {{{0}}}
 
GaussMomentM[4, S_, 1] = {{{{3*S[[1,1]]^2}}}}
 
GaussMomentM[5, S_, 1] = {{{{{0}}}}}
 
GaussMomentM[6, S_, 1] = {{{{{{15*S[[1,1]]^3}}}}}}
 
GaussMomentM[7, S_, 1] = {{{{{{{0}}}}}}}
 
GaussMomentM[8, S_, 1] = {{{{{{{{105*S[[1,1]]^4}}}}}}}}
 
GaussMomentM[1, S_, 2] = {0, 0}
 
GaussMomentM[2, S_, 2] = {{S[[1,1]], S[[1,2]]}, {S[[1,2]], S[[2,2]]}}
 
GaussMomentM[3, S_, 2] = {{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}
 
GaussMomentM[4, S_, 2] = {{{{3*S[[1,1]]^2, 3*S[[1,1]]*S[[1,2]]}, 
      {3*S[[1,1]]*S[[1,2]], 2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]]}}, 
     {{3*S[[1,1]]*S[[1,2]], 2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]]}, 
      {2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]], 3*S[[1,2]]*S[[2,2]]}}}, 
    {{{3*S[[1,1]]*S[[1,2]], 2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]]}, 
      {2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]], 3*S[[1,2]]*S[[2,2]]}}, 
     {{2*S[[1,2]]^2 + S[[1,1]]*S[[2,2]], 3*S[[1,2]]*S[[2,2]]}, 
      {3*S[[1,2]]*S[[2,2]], 3*S[[2,2]]^2}}}}
 
GaussMomentM[5, S_, 2] = {{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, 
     {{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}}, {{{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}, 
     {{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}}}
 
GaussMomentM[6, S_, 2] = 
   {{{{{{15*S[[1,1]]^3, 15*S[[1,1]]^2*S[[1,2]]}, {15*S[[1,1]]^2*S[[1,2]], 
         12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]]}}, 
       {{15*S[[1,1]]^2*S[[1,2]], 12*S[[1,1]]*S[[1,2]]^2 + \
3*S[[1,1]]^2*S[[2,2]]}, 
        {12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}}}, 
      {{{15*S[[1,1]]^2*S[[1,2]], 12*S[[1,1]]*S[[1,2]]^2 + \
3*S[[1,1]]^2*S[[2,2]]}, 
        {12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}}, 
       {{12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}, {6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*
           S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2}}}}, 
     {{{{15*S[[1,1]]^2*S[[1,2]], 12*S[[1,1]]*S[[1,2]]^2 + \
3*S[[1,1]]^2*S[[2,2]]}, 
        {12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}}, 
       {{12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}, {6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*
           S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2}}}, 
      {{{12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}, {6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*
           S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2}}, 
       {{6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] \
+ 
          3*S[[1,1]]*S[[2,2]]^2}, {12*S[[1,2]]^2*S[[2,2]] + \
3*S[[1,1]]*S[[2,2]]^2, 
         15*S[[1,2]]*S[[2,2]]^2}}}}}, 
    {{{{{15*S[[1,1]]^2*S[[1,2]], 12*S[[1,1]]*S[[1,2]]^2 + \
3*S[[1,1]]^2*S[[2,2]]}, 
        {12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}}, 
       {{12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}, {6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*
           S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2}}}, 
      {{{12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}, {6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*
           S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2}}, 
       {{6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] \
+ 
          3*S[[1,1]]*S[[2,2]]^2}, {12*S[[1,2]]^2*S[[2,2]] + \
3*S[[1,1]]*S[[2,2]]^2, 
         15*S[[1,2]]*S[[2,2]]^2}}}}, 
     {{{{12*S[[1,1]]*S[[1,2]]^2 + 3*S[[1,1]]^2*S[[2,2]], 6*S[[1,2]]^3 + 
          9*S[[1,1]]*S[[1,2]]*S[[2,2]]}, {6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*
           S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2}}, 
       {{6*S[[1,2]]^3 + 9*S[[1,1]]*S[[1,2]]*S[[2,2]], 12*S[[1,2]]^2*S[[2,2]] \
+ 
          3*S[[1,1]]*S[[2,2]]^2}, {12*S[[1,2]]^2*S[[2,2]] + \
3*S[[1,1]]*S[[2,2]]^2, 
         15*S[[1,2]]*S[[2,2]]^2}}}, {{{6*S[[1,2]]^3 + \
9*S[[1,1]]*S[[1,2]]*S[[2,2]], 
         12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2}, 
        {12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2, \
15*S[[1,2]]*S[[2,2]]^2}}, 
       {{12*S[[1,2]]^2*S[[2,2]] + 3*S[[1,1]]*S[[2,2]]^2, \
15*S[[1,2]]*S[[2,2]]^2}, 
        {15*S[[1,2]]*S[[2,2]]^2, 15*S[[2,2]]^3}}}}}}
 
GaussMomentM[7, S_, 2] = 
   {{{{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}}, 
      {{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}}}, 
     {{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}}, 
      {{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}}}}, 
    {{{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}}, 
      {{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}}}, 
     {{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}}, 
      {{{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {0, \
0}}}}}}}
 
GaussMomentM[8, S_, 2] = 
   {{{{{{{{105*S[[1,1]]^4, 105*S[[1,1]]^3*S[[1,2]]}, \
{105*S[[1,1]]^3*S[[1,2]], 
           90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]]}}, 
         {{105*S[[1,1]]^3*S[[1,2]], 90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*
             S[[2,2]]}, {90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}}}, 
        {{{105*S[[1,1]]^3*S[[1,2]], 90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*
             S[[2,2]]}, {90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}}, 
         {{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}}}, {{{{105*S[[1,1]]^3*S[[1,2]], \
90*S[[1,1]]^2*S[[1,2]]^2 + 
            15*S[[1,1]]^3*S[[2,2]]}, {90*S[[1,1]]^2*S[[1,2]]^2 + 
            15*S[[1,1]]^3*S[[2,2]], 60*S[[1,1]]*S[[1,2]]^3 + \
45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]]}}, {{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], \

           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}}, {{{90*S[[1,1]]^2*S[[1,2]]^2 + \
15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}}}, 
      {{{{{105*S[[1,1]]^3*S[[1,2]], 90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*
             S[[2,2]]}, {90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}}, 
         {{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}}, {{{90*S[[1,1]]^2*S[[1,2]]^2 + \
15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}}, 
       {{{{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}, 
        {{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}}}}, 
     {{{{{{105*S[[1,1]]^3*S[[1,2]], 90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*
             S[[2,2]]}, {90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}}, 
         {{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}}, {{{90*S[[1,1]]^2*S[[1,2]]^2 + \
15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}}, 
       {{{{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}, 
        {{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}}}, 
      {{{{{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}, 
        {{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}}, 
       {{{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}, 
        {{{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + \
9*S[[1,1]]^2*S[[2,2]]^2, 
           60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}, 
          {60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}, 
         {{60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}, 
          {90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3, 
           105*S[[1,2]]*S[[2,2]]^3}}}}}}}, 
    {{{{{{{105*S[[1,1]]^3*S[[1,2]], 90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*
             S[[2,2]]}, {90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}}, 
         {{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}}, {{{90*S[[1,1]]^2*S[[1,2]]^2 + \
15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}}, 
       {{{{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}, 
        {{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}}}, 
      {{{{{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}, 
        {{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}}, 
       {{{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}, 
        {{{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + \
9*S[[1,1]]^2*S[[2,2]]^2, 
           60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}, 
          {60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}, 
         {{60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}, 
          {90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3, 
           105*S[[1,2]]*S[[2,2]]^3}}}}}}, 
     {{{{{{90*S[[1,1]]^2*S[[1,2]]^2 + 15*S[[1,1]]^3*S[[2,2]], 
           60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]]}, 
          {60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}}, {{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*
             S[[2,2]], 24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2}, {24*S[[1,2]]^4 + \
72*S[[1,1]]*S[[1,2]]^2*
             S[[2,2]] + 9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + 
            45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}}}, 
        {{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}}, 
       {{{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}, 
        {{{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + \
9*S[[1,1]]^2*S[[2,2]]^2, 
           60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}, 
          {60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}, 
         {{60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}, 
          {90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3, 
           105*S[[1,2]]*S[[2,2]]^3}}}}}, 
      {{{{{60*S[[1,1]]*S[[1,2]]^3 + 45*S[[1,1]]^2*S[[1,2]]*S[[2,2]], 
           24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 9*S[[1,1]]^2*
             S[[2,2]]^2}, {24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}}, {{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] \
+ 
            9*S[[1,1]]^2*S[[2,2]]^2, 60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*
             S[[2,2]]^2}, {60*S[[1,2]]^3*S[[2,2]] + \
45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}}, 
        {{{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + \
9*S[[1,1]]^2*S[[2,2]]^2, 
           60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}, 
          {60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}, 
         {{60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}, 
          {90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3, 
           105*S[[1,2]]*S[[2,2]]^3}}}}, 
       {{{{24*S[[1,2]]^4 + 72*S[[1,1]]*S[[1,2]]^2*S[[2,2]] + \
9*S[[1,1]]^2*S[[2,2]]^2, 
           60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2}, 
          {60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}}, 
         {{60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}, 
          {90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3, 
           105*S[[1,2]]*S[[2,2]]^3}}}, 
        {{{60*S[[1,2]]^3*S[[2,2]] + 45*S[[1,1]]*S[[1,2]]*S[[2,2]]^2, 
           90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3}, 
          {90*S[[1,2]]^2*S[[2,2]]^2 + 15*S[[1,1]]*S[[2,2]]^3, 
           105*S[[1,2]]*S[[2,2]]^3}}, {{90*S[[1,2]]^2*S[[2,2]]^2 + 
            15*S[[1,1]]*S[[2,2]]^3, 105*S[[1,2]]*S[[2,2]]^3}, 
          {105*S[[1,2]]*S[[2,2]]^3, 105*S[[2,2]]^4}}}}}}}}\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
??linposindex
??linposindex1\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Global`linposindex
linposindex[ind_, p_] := linpos[index2exp[ind, p], p]
Global`linposindex1
linposindex1[ind_, p_] := Block[{ivec, i, tab}, k = Length[ind]; ivec = \
Array[i, k]; 
     tab = Table[ivec, Evaluate[iter[i, Flatten[{1, Drop[ivec, -1]}], \
Shape[p, k]]]]; 
     tab = Flatten[tab, k - 1]; Position[tab, ind][[1,1]]]\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[TextData[{
  "\nF//Unprotect;\nF//Clear\n\
(***************************************************************)\t\t\t \n",
  StyleBox["F",
    FontColor->RGBColor[1, 0, 0]],
  "[{m_,t_},Theta_,{f_,Omega_},Gauss_:True]:=\n\
(***************************************************************)\t\t\t \n\
(*Taylor-Entwicklung*)\n(*f={f[0],f[1],...}*)\n(*d/dt m_k = k \
E[f*(M_{k-1}-m_{k-1})] + k(k-1)/2 E[Omega M_{k-2}]*)\n\n\
Block[{K,L,mue,mm,fL,OmegaL,muep,mkp,k1},\n\nL=(f//Length)-1;\n\t\t\
(*m//Print;*)\nK=(m//Length); \n\n(*{K,L}//Print;*)\n\nmue=m[[1]];\n\
mm=Shape[0,{K+L}];\n\nmm[[Range[2,K+1] ]]=m;\nmm[[{1,2}]]={1,0};       \
(*mm={m0,m1=0,m2...mK}*)\n\nIf[Gauss,Do[ \
mm[[k+1]]=If[EvenQ[k],(k-1)!!m[[2]]^(k/2),0],{k,K+1,K+L-1}]];\n\nfL    \
=Table[    f[[l+1]][mue,t,Theta],{l,0,L}];\n\
OmegaL=Table[Omega[[l+1]][mue,t,Theta],{l,0,L}];\n\nmuep = Sum[    \
fL[[l+1]]/l! mm[[l+1]],{l,0,L}];\n\nmkp=Table[ k        Sum[    fL[[l+1]]/l! \
(mm[[k-1+l+1]]-mm[[l+1]]mm[[k-1+1]]),{l,1,L}] +\n           k(k-1)/2 \
Sum[OmegaL[[l+1]]/l!  mm[[k-2+l+1]],{l,0,L}], \n       \n       {k,2,K}];\n   \
    \n{muep,mkp}//Flatten\n\n ]\n \nProtect[F];\n"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\

FGaussHermite//Clear
(***************************************************************)\t\t\t 
FGaussHermite[{m_,t_},Theta_,{f_,Omega_},_]:=
(***************************************************************)\t\t\t 

(* E[f] = Int f(y) phi(y,mue,sigma) H(y) dy *)
(* d/dt m_k = k E[f*(M_{k-1}-m_{k-1})] + k(k-1)/2 E[Omega M_{k-2}]*)

Block[{K,mue,Sigma,H,y,fl,Omegal,Hl,muep,mkp1,mkp2,vals,vals1,vals10,vals1k,k}\
,

K=(m//Length);  

mue  = {m[[1]]};
Sigma={{m[[2]]}};

Sigma=Shift[Sigma,10^-8];

vals = TrafoMueSigma[VALS,{mue,Sigma}];

H[y_]=HermiteExpansionOhnePhi[y,m];

fl     = Map[    f[#,t,Theta]&,vals];
Omegal = Map[Omega[#,t,Theta]&,vals];
Hl     = Map[            H[#]&,vals];

If[Gauss,Hl=1];

muep = WEIGHT.(Hl fl); (* E[f]*)

vals1 = Map[(#-mue)&,vals]; (*zentrierte Gewichte*)


vals10=Table[{1},{i,vals//Length}];
vals1k=Join[{vals10},Table[vals10=vals10 vals1,{k,1,K}]];

(*vals1k[[k]]=vals1^(k-1)*)

mm = {1,0,m//Rest}//Flatten;  (* {m0,m1=0,m2,...} *)

(*
mkp1 = Table[ WEIGHT.(Hl*(k*fl*(vals1k[[k]] - mm[[k]])   + 
                          k(k-1)/2 Omegal vals1k[[k-1]])),{k,2,K}];
*)

mkp2 = Table[ WEIGHT.(Hl*(k (fl-muep[[1]])*(vals1k[[k]]) + 
                          k(k-1)/2 Omegal vals1k[[k-1]])),{k,2,K}];
      
{muep,mkp2}//Flatten

 ]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["\<\
{VALS,WEIGHT}=GaussHermitePointsMulti2[8,1];

FGaussHermite[{m={1,4,1,3 2^3},t},Theta,{f1,Omega1},False]

            F[{m,t},Theta,
                  {{f1,Df1,DDf1,DDDf1},
                  {Omega1,DOmega1,DDOmega1,DDDOmega1}},True]
                  
            F[{m,t},Theta,
                  {{f1,Df1,DDf1},
                  {Omega1,DOmega1,DDOmega1}},True]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^15
                               -16
Stuetzstellen:8  groesser 1. 10    :8
{4, 3}
{1, 0, 4, 1, 24, 0, 960}
{4, 2}
{1, 0, 4, 1, 24, 0}\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{-0.39999999999999986, 4.200000000000082, \
-15.899999999999695, 312.40000000001254}\
\>", "\<\
{-0.4, 4.2, -15.9, 312.4}\
\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{-0.4000000000000002, 4.199999999999999, \
-3.900000000000001, -215.60000000000008}\
\>", "\<\
{-0.4, 4.2, -3.9, -215.6}\
\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{-0.30000000000000016, 9., -5.100000000000001, 168.}\
\
\>", "\<\
{-0.3, 9., -5.1, 168.}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["m[[1]]", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
1\
\>", "\<\
1\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
       f[{1},t,Theta]+
1/2  DDf[{1},t,Theta]m[[2]]+
1/6 DDDf[{1},t,Theta]m[[3]]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{{{-0.4000000000000002}}}}\
\>", \
"\<\
{{{{-0.4}}}}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
       f[{1},t,Theta]+
1/2  DDf[{1},t,Theta]m[[2]]+
1/6 DDDf[{1},t,Theta] 0\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{{{-0.30000000000000016}}}}\
\>", "\<\
{{{{-0.3}}}}\
\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussHermite[f[{#},t,Theta]&,99,{{1},{{4}}}]", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{-0.300000000000062}}\
\>", "\<\
{{-0.3}}\
\>"], \
"Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "LikHermite//Clear\n\
(***************************************************************)\t\t\t \n\
LikHermite[{Y_,X_},Theta_,{System_,dt_},{{K_,L_},Gauss_,miss_,option_:1}]:=\n\
(***************************************************************)\t\t\t \n(* \
Likelihood mit Momentenglg. und Hermite-Entw.*)\n\n\
Block[{ti,T1,dti,dti1,Null,Xi,mii,mi1i,Mi1i,M,j,pi1i,liki,lik,SystemL},\n\nti \
  = messind[Y,miss]; (*Indices mit mind. einer Messung*)\nT1   = Length[Y];\n\
ti   = Union[ti,{1,T1}]; \ndti  = Delta[ti,ti,List,-1]; \ndti1 = Delta[ti]+1;\
\n\nNull=Shape[0,{K-1}]; \n \nSystemL=Map[Take[#,L+1]&,System];\n\
(*SystemL//Print;*)\n\nlik=0;\nM={};\n\nDo[ (*Print[i];*)\n\n\t\n\n\tXi  = \
Take[ X,dti[[i]] ];\n\tmii={Y[[ti[[i]] ]],Null}//Flatten;\n\t\n\t\n\t\
{mi1i,Mi1i} = ",
  StyleBox["TimeUpNonlinear",
    FontColor->RGBColor[1, 0, 0]],
  "[{mii,Xi,dt},Theta,{F,SystemL},Gauss];\n\n  (*mi1i//Print;*)\n  \
(*Mi1i//Print;*)\n\t\n\tIf[option==2, \tM = Join[M,Drop[Mi1i,-1]] ];\n\t\n\t\n\
\tj = ti[[i+1]];\n\t\n\t  (* {i,j}//Print; *)\n\t\n\t  \n\tIf[Y[[j,1]]!=miss,\
\n\t\t\t\t(*\n\t\t\t\tpi1i[y_] = HermiteExpansion[y,mi1i];\n\t\t\t\t\
liki=pi1i[Y[[j,1]]]//Log;\n\t\t\t\t*)\n\t\t\t\t\
liki=LogHermiteExpansion[Y[[j,1]],mi1i];\n\t\t\t\t(*{j,Y[[j]],liki}//Print;*)\
\n\t\t\t\tlik +=liki;\n\t];\n\t\n\t(*\n\tIf[i==1,\n\t\t  \n\t\t  (*\n\t\t  \
Mi1i//MatrixForm//Print;\n\t\t  mi1i//Print;\n\t\t  M//MatrixForm//Print;\n\t\
\t  *)\n\t\t  {mue,alpha,sigma}=Theta;\n\t\t\t\t\
Plot[{CEVDichteExakt[(dti1[[i]]-1) dt,y,mii[[1]],{mue,sigma^2,alpha}]-\n\t\t\t\
\tpi1i[y]}//Evaluate,{y,0.5,1.5}];\n\t\t\t\tReturn[];\n\t\t\t];\n\t*)\n\t\n\
,{i,1,Length[ti]-1}];\n\nIf[option==2,\n\n\tM = Join[M,{{Y[[ti//Last \
]],Null}//Flatten}];\n\tReturn[{M,lik}//N]];\n\t\n\
If[option==1,Return[lik//N]];\n\n\n];"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
 General::spell1: 
   Possible spelling error: new symbol name \"mi1i\" is similar to existing \
symbol \"mii\".\
\>", "Message",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
 General::spell1: 
   Possible spelling error: new symbol name \"Mi1i\" is similar to existing \
symbol \"mi1i\".\
\>", "Message",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
 General::spell1: 
   Possible spelling error: new symbol name \"pi1i\" is similar to existing \
symbol \"mi1i\".\
\>", "Message",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
 General::stop: Further output of General::spell1
    will be suppressed during this calculation.\
\>", "Message",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell["\<\
LikCEV//Clear
(***************************************************************)\t\t\t 
LikCEV[{Y_,X_},Theta_,{Dichte_,dt_,Restrik_},miss_]:=
(***************************************************************)\t\t\t 
(* exakte Likelihood *)
(* Dichte = CEVDichteExakt oder CEVDichteGauss *)

Block[{ti,T1,dti,dti1,Xi,ji,ji1,liki,lik,mue,alpha,sigma,sigmaq},

ti   = messind[Y,miss]; (*Indices mit mind. einer Messung*)
T1   = Length[Y];
ti   = Union[ti,{1,T1}]; 
dti  = Delta[ti,ti,List,-1]; 
dti1 = Delta[ti]+1;

(*dti1//Print;*)

lik=0;

{mue,alpha,sigma}=Restrik[Theta];

sigmaq=sigma^2;

Do[ (*Print[i];*)

\t
\tji1 = ti[[i+1]];
\tji  = ti[[i]];
\t
\t
\t  (*{i,ji}//Print; *)
\t
\t  
\tIf[Y[[ji1,1]]!=miss,
\t
\t\t \tliki=Dichte[(dti1[[i]]-1) dt,
\t\t \t             Y[[ji1,1]], Y[[ji,1]],
\t                {mue,sigmaq,alpha}]//Log;
      
\t\t\t\t(*{j,Y[[j]],liki}//Print;*)
\t\t\t\t
\t\t\t\tlik +=liki;
\t];
\t
\t(*
\tIf[i==1,
\t\t  
\t\t\t\tPlot[{Dichte[(dti1[[i]]-1) dt,
\t\t\t\t        y, Y[[ji,1]],{mue,sigmaq,alpha}]}//Evaluate,{y,0.5,1.5}]
\t\t\t\t
\t\t\t\t];
\t*)
\t\t\t\t
\t\t
\t
,{i,1,Length[ti]-1}];


Return[lik//N];


];\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["Test", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
F[{{mue,m2,m3,m4},t},Th,{{f,f1,f2,f3,f4},{Om,Om1,Om2,Om3,Om4}},\
False]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {f[mue, t, Th] + (m2*f2[mue, t, Th])/2 + \
(m3*f3[mue, t, Th])/6 + 

    (m4*f4[mue, t, Th])/24, 2*(m2*f1[mue, t, Th] + (m3*f2[mue, t, Th])/2 + 

      (m4*f3[mue, t, Th])/6) + Om[mue, t, Th] + (m2*Om2[mue, t, Th])/2 + 

    (m3*Om3[mue, t, Th])/6 + (m4*Om4[mue, t, Th])/24, 

   3*(m3*f1[mue, t, Th] + ((-m2^2 + m4)*f2[mue, t, Th])/2 - (m2*m3*f3[mue, t, \
Th])/6 - 

      (m2*m4*f4[mue, t, Th])/24) + 3*(m2*Om1[mue, t, Th] + (m3*Om2[mue, t, \
Th])/2 + 

      (m4*Om3[mue, t, Th])/6), 

   4*(m4*f1[mue, t, Th] - (m2*m3*f2[mue, t, Th])/2 - (m3^2*f3[mue, t, Th])/6 \
- 

      (m3*m4*f4[mue, t, Th])/24) + 6*(m2*Om[mue, t, Th] + m3*Om1[mue, t, Th] \
+ 

      (m4*Om2[mue, t, Th])/2)}\
\>", "\<\
                  m2 f2[mue, t, Th] \
  m3 f3[mue, t, Th]   m4 f4[mue, t, Th]
 {f[mue, t, Th] + ----------------- + ----------------- + -----------------, 
                          2                   6                  24
                         m3 f2[mue, t, Th]   m4 f3[mue, t, Th]
  2 (m2 f1[mue, t, Th] + ----------------- + -----------------) + Om[mue, t, \
Th] + 
                                 2                   6
  m2 Om2[mue, t, Th]   m3 Om3[mue, t, Th]   m4 Om4[mue, t, Th]
  ------------------ + ------------------ + ------------------, 
          2                    6                    24
                             2
                         (-m2  + m4) f2[mue, t, Th]   m2 m3 f3[mue, t, Th]
  3 (m3 f1[mue, t, Th] + -------------------------- - -------------------- - 
                                     2                         6
  m2 m4 f4[mue, t, Th]                            m3 Om2[mue, t, Th]
  --------------------) + 3 (m2 Om1[mue, t, Th] + ------------------ + 
           24                                             2
  m4 Om3[mue, t, Th]                          m2 m3 f2[mue, t, Th]
  ------------------), 4 (m4 f1[mue, t, Th] - -------------------- - 
          6                                            2
    2
  m3  f3[mue, t, Th]   m3 m4 f4[mue, t, Th]
  ------------------ - --------------------) + 
          6                     24
                                              m4 Om2[mue, t, Th]
  6 (m2 Om[mue, t, Th] + m3 Om1[mue, t, Th] + ------------------)}
                                                      2\
\>"], "Output",
  PageWidth->Infinity,
  CellMargins->{{6, Inherited}, {Inherited, Inherited}},
  CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
  ShowCellLabel->False,
  CellLabelMargins->{{12, Inherited}, {Inherited, Inherited}},
  ShowSpecialCharacters->False,
  AllowInlineCells->False,
  AutoItalicWords->{},
  ScriptMinSize->9,
  ImageRegion->{{-0, 1}, {0, 1}},
  StyleMenuListing->None,
  FontSize->14,
  Background->GrayLevel[1]]
}, Open  ]],

Cell["\<\
pmess//Clear
(***************************************************************)\t\t\t 
pmess[{z_,y_,t_},Theta_,{h_,R_}]:=
(***************************************************************)
(*z=h(y)+eps; eps~N(0,R)*)\t
\t\t 
Block[{sigma,mue},

sigma=R[y, t, Theta]//Sqrt;
  mue=h[y, t, Theta]; 
 
PDF[NormalDistribution[mue,sigma],z]
]

pmess//Protect;\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
(***************************************************************)\t\
\t\t 
Momente//Clear
Momente[p_,y_,K_,Range_:{-Infinity,Infinity}]:=
(***************************************************************)\t\t\t 
Block[{mue,m,k},
\t\t
mue=NIntegrate[y p,{y,Range}//Flatten//Evaluate]; 
m[k_]:=NIntegrate[(y-mue)^k p,{y,Range}//Flatten//Evaluate];
{mue,Table[m[k],{k,2,K}]}//Flatten
]
\t\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
MessupHermite//Clear
(***************************************************************)\t\t\t 
MessupHermite[{z_,t_,py_,y_,K_},Theta_,{h_,R_},miss_]:=
(***************************************************************)\t\t\t 
Module[{pyz,myz,pyzu,Likeli},

pyzu=py[y]*pmess[{z,y,t},Theta,{h,R}];
Likeli=NIntegrate[pyzu,{y,-Infinity,Infinity}];
pyz=pyzu/Likeli;

(*a post. Momente*)

myz=Momente[pyz,y,K];

{pyz,myz,Likeli//Log}
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
MessupHermite1//Clear
(***************************************************************)\t\t\t 
MessupHermite1[{z_,t_,my_},Theta_,{h_,R_},miss_,
               IntegrationsBereich_:{-Infinity,Infinity}]:=
(***************************************************************)\t\t\t 

Module[{py,pyz,myz,pyzu,Likeli,y},

If[z==miss,Return[{my,0}]];

py[y_]=HermiteExpansion[y,my]; 
\t
pyzu=py[y]*pmess[{z,y,t},Theta,{h,R}]; (*unnormiert*)

Likeli=NIntegrate[pyzu,{y,IntegrationsBereich}//Flatten//Evaluate,
\t\t\t      Method->GaussKronrod];
(*pyz=pyzu/Likeli;*)

(*a post. Momente*) 

myz=Momente[pyzu,y,my//Length]/Likeli;

{myz,Likeli//Log}
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["??h1", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Global`h1
h1 = h[{#1}, #2, #3][[1]] & \
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["Theta", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{-1., 0.1, 2., 0.0001, -3., 3.}\
\>", "\<\
{-1., \
0.1, 2., 0.0001, -3., 3.}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{myz,lik}=MessupHermite1[{2,xx,{1,.1,.1,.1}},Theta,{h1,R1},miss,{-\
10,10}]
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.0680778410789236, 0.16558973136900185, \
0.13222887156095514, 0.12679872546934048}, -1.4544113950927562}\
\>", \
"\<\
{{1.06808, 0.16559, 0.132229, 0.126799}, -1.45441}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell["\<\
MessupHermite2alt//Clear
(***************************************************************)\t\t\t 
MessupHermite2alt[{z_,t_,my_},Theta_,{h_,R_},miss_]:=
(***************************************************************)\t\t\t 

Module[{myz,mueyz,pyzu,Likeli,y,k,vals,H},

If[z==miss,Return[{my,0}]];

H[y_]=HermiteExpansionOhnePhi[y,my]; 
\t
pyzu=H[#]*pmess[{z,#,t},Theta,{h,R}]&; (*unnormiert*)

mue  = {my[[1]]};
Sigma={{my[[2]]}};

vals=TrafoMueSigma[VALS,{mue,Sigma}];

(*{WEIGHT,vals//Flatten}//Transpose//MatrixForm//Print;*)

Likeli=GaussHermite2[pyzu,{vals,WEIGHT}];

(*a post. Momente*) 

L1=1/Likeli;

mueyz=L1 GaussHermite2[(pyzu[#]#)&,{vals,WEIGHT}];

myz=Table[L1 \
GaussHermite2[(pyzu[#](#-mueyz)^k)&,{vals,WEIGHT}],{k,2,my//Length}];

{{mueyz,myz}//Flatten,Likeli//Log}
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell["\<\
{VALS,WEIGHT}=GaussHermitePointsMulti2[50,p=1,10^-12];
{myz,lik}=MessupHermite2alt[{2,t,{1,.1,.1,.1}},Theta,{h1,R1},miss]
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^99
                                -12
Stuetzstellen:50  groesser 1. 10    :32\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.0680778391104295, 0.1655897312599817, \
0.13222887225421773, 0.12679872582358004}, {-1.4544113951320523}}\
\>", \
"\<\
{{1.06808, 0.16559, 0.132229, 0.126799}, {-1.45441}}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell["\<\
MessupHermite2//Clear
(***************************************************************)\t\t\t 
MessupHermite2[{z_,t_,my_},Theta_,{h_,R_},miss_]:=
(***************************************************************)\t\t\t 

Module[{myz,mueyz,pzyHl,Likeli,L1,y,k,vals,H,mue,Sigma,x,eps},

If[z==miss,Return[{my,0}]];

H[y_]=HermiteExpansionOhnePhi[y,my]; 
\t
mue  = {my[[1]]};
Sigma={{my[[2]]}};

vals=TrafoMueSigma[VALS,{mue,Sigma}]//Flatten;

pzyHl=Map[H[#]*pmess[{z,#,t},Theta,{h,R}]&,vals]//Flatten;

eps=10^-3;
trafo=(x=(#-eps);x*Heaviside[x]+eps)&;
pzyHl=trafo[pzyHl];

(*{vals//Flatten,WEIGHT,pzyHl}//Transpose//MatrixForm//Print;*)

Likeli=WEIGHT.pzyHl;

(*plot1[{vals,pzyHl}//Transpose,PlotRange->All,PlotJoined->False];*)

(*a post. Momente*) 

L1=1/Likeli;

mueyz=L1 WEIGHT.(vals pzyHl); 

myz=L1 Table[WEIGHT.((vals-mueyz)^k pzyHl),{k,2,my//Length}];

(*
Plot[HermiteExpansion[y,{mueyz,myz}//Flatten]//Evaluate,{y,-10,10}];
Plot[pmess[{z,y,t},Theta,{h,R}]//Evaluate,{y,-10,10},PlotRange->{0,10}];
*)

{{mueyz,myz}//Flatten,Likeli//Log}
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"MessupHermite2"],

Cell[CellGroupData[{

Cell["\<\
{VALS,WEIGHT}=GaussHermitePointsMulti2[50,p=1,10^-12];
{myz,lik}=MessupHermite2[{2,t,{1,.1,.1,.1}},Theta,{h1,R1},miss]
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^99
                                -12
Stuetzstellen:50  groesser 1. 10    :32\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.0680778391104295, 0.1655897312599817, \
0.13222887225421773, 0.12679872582358004}, -1.4544113951320523}\
\>", \
"\<\
{{1.06808, 0.16559, 0.132229, 0.126799}, -1.45441}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell["\<\
MessupHermite3//Clear
(***************************************************************)\t\t\t 
MessupHermite3[{z_,t_,my_},Theta_,{h_,R_},miss_]:=
(***************************************************************)\t\t\t 

Module[{H,myz,mueyz,lik,L,y,k,vals,vals1,mue,Sigma,eps,x,phi,phil},

If[z==miss,Return[{my,0}]];

H[y_]=HermiteExpansionOhnePhi[y,my]; 
\t
mue  = {my[[1]]};
Sigma={{my[[2]]}};
vals=TrafoMueSigma[VALS,{mue,Sigma}];

(*Normal-Korrelation mit H*)

Hl   = Map[H,vals]//Flatten;

(*trafo=(x=(#-eps);x*Logistic[50 x]+eps)&;*)
(*trafo=(# Heaviside[#]+eps)&;*) (*alt*)
(*Hl=trafo[Hl];*)
(*plot1[{vals//Flatten,(Hl//Flatten)}//Transpose,PlotJoined->False];*)
(*Hl=Hl Logistic[50 Hl]; Hl//N5//Print;*)

c=WEIGHT.Hl;  
Hl=Hl/c;

hl   = Map[h[#,t,Theta]&,vals];
vals1= Map[(#-mue)&,vals];

covyz   = WEIGHT.(vals1 hl Hl)//First;
Eh      = WEIGHT.(hl Hl)//First;
covzz   = WEIGHT.(hl^2 Hl) - Eh^2 + R[mue,t,Theta]//First;
covzz1  = covzz^-1;
inn     = z-Eh;
mue0yz  = my[[1]] + covyz covzz1 inn;
sigma0yz= my[[2]] - covyz covzz1 covyz; 
 
(*a post. Momente*) 

vals = TrafoMueSigma[VALS,{{mue0yz},{{sigma0yz}}}]; (*Int. bzgl. phi0*)

Hl   = Map[H,vals];\t(*bei mue0mue0yz, sigma0yz*)

eps=10^-1;
trafo=(x=(#-eps);x*Heaviside[x]+eps)&;
Hl=trafo[Hl];

phi0=PDF[NormalDistribution[mue0yz,sigma0yz//Sqrt],#]&;  (* a post norkorr*)
phi0l = Map[phi0[#]&,vals];

phi=PDF[NormalDistribution[my[[1]],my[[2]]//Sqrt],#]&; (* a priori Gauss-D.*)
phil = Map[phi[#]&,vals];

pzyl=Map[pmess[{z,#,t},Theta,{h,R}]&,vals]//Flatten;

(*plot1[{vals//Flatten,(Hl//Flatten) WEIGHT}//Transpose,PlotJoined->False];*)

pyz=(pzyl phil Hl)/phi0l; (* a post unnormiert; Int. bzgl. phi0*)
\t   
L=WEIGHT.pyz; 

lik = Log[L];

mueyz=1/L WEIGHT.(vals pyz);
vals1=Map[(#-mueyz)&,vals];

myz=Table[1/L WEIGHT.(vals1^k pyz),{k,2,my//Length}];

{{mueyz,myz}//Flatten,lik}
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"MessupHermite3"],

Cell["\<\
MessupHermite4//Clear
(***************************************************************)\t\t\t 
MessupHermite4[{z_,t_,my_},Theta_,{h_,R_},miss_]:=
(***************************************************************)\t\t\t 

Module[{H,myz,mueyz,lik,L,y,k,vals,vals1,mue,Sigma,eps,x,phi,phil,c},

If[z==miss,Return[{my,0}]];

H[y_]=HermiteExpansionOhnePhi[y,my]; 
\t
mue  = {my[[1]]};
Sigma={{my[[2]]}};
vals=TrafoMueSigma[VALS,{mue,Sigma}]//Flatten;

Hl=1;     (*Print[\"Hl \",Hl];*)

(*Normal-Korrelation mit H=1 !!; sigma0yz>0*)

hl   = Map[h[#,t,Theta]&,vals];  
vals1= Map[(#-mue[[1]])&,vals]; 

covyz   = WEIGHT.(vals1 hl Hl);
Eh      = WEIGHT.(hl Hl);
covzz   = WEIGHT.(hl^2 Hl) - Eh^2 + R[mue,t,Theta];
covzz1  = covzz^-1;
inn     = z-Eh;  
mue0yz  = my[[1]] + covyz covzz1 inn;
sigma0yz= my[[2]] - covyz covzz1 covyz; 

Print[\"{z,mue0yz,sigma0yz}\",{z,mue0yz,sigma0yz}]; 
 
 
 
(*a post. Momente*) 

c=1;
sigma0yz = c^2*sigma0yz; (* Optimierung des Integrationsbereichs*)

vals = TrafoMueSigma[VALS,{{mue0yz},{{sigma0yz}}}]//Flatten; (*Int. bzgl. \
phi0*)

eps=10^-1;
trafo=(x=(#-eps);x*Heaviside[x]+eps)&;

Hl   = Map[H,vals];\t(*bei mue0yz, sigma0yz*)
Hl=trafo[Hl];

phi0=PDF[NormalDistribution[mue0yz,sigma0yz//Sqrt],#]&;  (* a post norkorr*)
phi0l = Map[phi0[#]&,vals];

phi=PDF[NormalDistribution[my[[1]],my[[2]]//Sqrt],#]&; (* a priori Gauss-D.*)
phil = Map[phi[#]&,vals];

pzyl=Map[pmess[{z,#,t},Theta,{h,R}]&,vals]//Flatten;

pyz=(pzyl phil Hl)/phi0l//N; (* a post unnormiert; Int. bzgl. phi0*)

L=WEIGHT.pyz; 
lik = Log[L];

(*plot1[{vals,Hl}//Transpose,PlotJoined->False];*)
(*plot1[{vals,pyz \
WEIGHT/L,phi0l,phil}//Transpose,PlotJoined->True,PlotRange->{All,All}];*)

(*Print[\" L \",L ,\" L0 \",L0=Exp[-.5(Log[2Pi covzz] + inn covzz1 inn)],
            \" L1 \",L1=WEIGHT.Hl, L1*L0, pzyl phil/phi0l];*)

mueyz=1/L WEIGHT.(vals pyz);
vals1=Map[(#-mueyz)&,vals];

myz=Table[1/L WEIGHT.(vals1^k pyz),{k,2,my//Length}];

{{mueyz,myz}//Flatten,lik}
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"MessupHermite4"],

Cell[CellGroupData[{

Cell["??GaussDichte1", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Global`GaussDichte1
GaussDichte1[x_, {mue_, sigma_, sigma1_}] := Module[{z = x - mue}, 
    N[Exp[-0.5*z . sigma1 . z]/Det[2*Pi*sigma]^0.5]]\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[TextData[{
  "MessupHermite4Multi//Clear\n\
(*****************************************************************************\
*)\t\t\t \nMessupHermite4Multi[{Z_,X_,my_},Theta_,{h_,R_},{miss_}]:=\n\
(*****************************************************************************\
*)\t\t\t \n(* Bayes-Formel mit Normal-Korrelation mit \
Gauss-Hermite-Integral*) \n\t\n\
Module[{zmiss,lc,Y0,P0,P01,lik0,vals,vals2,H,Hl,\n        \
phi,phi0,pmess,Lik,Yi1i,Pi1i,Pi1i1,m,k,K,p,r,r1,pl,WH,y,eps,m2,eigm2},\n\t\n\
zmiss = Map[SameQ[miss,#]&,Z];\t\t\nlc = Locate[zmiss,False]; \n\t    \nIf[lc \
== {},Return[{my,0}]]; (*keine Messung*)\n\t\nYi1i  = my[[1]];\nPi1i  = \
my[[2]];\nPi1i  = momentexp2index[Pi1i,k=2,p=Yi1i//Length];\n\n(*\n\
Pi1i//Print;\nPi1i//Eigenvalues//Print;\n*)\n\n\
(*{Y0,P0,lik0}=MessUpGHF[{Z,{Yi1i,Pi1i},X,m},Theta,{h,R},{miss,zweipi=True}];*\
)\n\n{Y0,P0,lik0}=MessUpGHFBayes[{Z,{Yi1i,Pi1i},X,m},Theta,{h,R},{miss}];\n\n\
(*P0//Eigenvalues//Print;*)\n\n(* d.h. H=1*)\n\nvals  = \
TrafoMueSigma[VALS,{Y0,P0},0]; (*nach Norkorr*)\n\nOff[",
  StyleBox["Part::partd",
    FontColor->RGBColor[1, 0, 0]],
  "];\nH[y_]=HermiteExpansionMultipStand[Table[y[[j]],{j,p}],my,\"H\"];\n\nHl \
= Map[H,vals];\t(*bei mue0yz, sigma0yz*)\n\nIf[TRAFO>0,\n\nWhich[\n\n  \
TRAFO==1,\n\tmaxi=Hl//Max;\n\teps=$SHIFT maxi,\n\n  TRAFO==2,\n\teps=$EPS\n];\
\n\n(*Print[\"MessupHermite4Multi TRAFO=\",TRAFO,\" eps=\",eps];*)\n\
(*trafo=(x=(#-eps);x*Heaviside[x]+eps)&;*)\n(*Hl = trafo[Hl,eps]*)\n\n\
Hl=Map[Max[#,eps]&,Hl]\n];\n\n(*\nPi1i1=Pi1i//Inverse;\nphi  \
=GaussDichte1[#,{Yi1i,Pi1i,Pi1i1}]&;\n\nr=R[Yi1i,X,Theta][[lc,lc]]; \n\
r1=r//Inverse;\npmess=GaussDichte1[Z,{h[#,X,Theta][[lc]],r,r1}]&;\n\n\
P01=P0//Inverse;\nphi0 =GaussDichte1[#,{Y0,P0,P01}]&;\n\npl = Map[(pmess[#] \
phi[#]/phi0[#])&,vals];\n*)\n\nPi1i1=Pi1i//Inverse;\nP01=P0//Inverse;\n\
pl=pzypyp0[Z,lc,vals,X,Theta,h,R,Yi1i,Pi1i1,Y0,P01];\n\nWH=WEIGHT Hl;\n\nLik= \
WH.pl; \n\nm=Shape[0,K=my//Length];\nm[[1]]= (WH.(pl vals))/Lik; \n\n\
vals=Map[(#-m[[1]])&,vals];  \n\nDo[\n\nind=kexp[k,p]; \n\
mk=Outer[MM[#1,#2]&,vals,ind,1]; \nm[[k]] = WH.(pl mk)/Lik;\n\n,{k,2,K}];\n\n\
Take[m,2]//Print[\"MessupHermite4Multi: m1, m2\",#]&;\n\n(*m2 psd?*)\n\
m2=momentexp2index[m[[2]],2,p];\neigm2=m2//Eigenvalues;\n\nIf[Min[eigm2]<0, \
(*GHF update*)\n\nPrint[\"Min[eigm2]<0, use GHF update\"];\n\
{GaussMomenteMulti[Y0,P0,K],lik0},\n\n{m,Lik//Log}]\n\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"MessupHermite4Multi"],

Cell[TextData[{
  "MessupHermiteNorKorrMulti//Clear\n\
(*****************************************************************************\
*)\t\t\t \n\
MessupHermiteNorKorrMulti[{Z_,X_,my_},Theta_,{h_,R_},{miss_,option_:1}]:=\n\
(*****************************************************************************\
*)\t\t\t \n(* Bayes-Formel mit Normal-Korrelation / Gauss-Hermite-Integral*) \
\n\t\nModule[{zmiss,lc,Y0,P0,l0,vals,H,Hl,hl,hl1,\n        \
lik,Lik1,Yi1i,Pi1i,m,k,K,p,WH,y,covzz,covzz1,covyh,inn,gain,Eh},\n\t\nzmiss = \
Map[SameQ[miss,#]&,Z];\t\t\nlc = Locate[zmiss,False]; \n\t    \nIf[lc == \
{},Return[{my,0}]]; (*keine Messung*)\n\nK=my//Length;\n\nYi1i  = my[[1]];\n\
Pi1i  = my[[2]];\nPi1i  = momentexp2index[Pi1i,k=2,p=Yi1i//Length];\n\n\
vals=TrafoMueSigma[VALS,{Yi1i,Pi1i}];\n\nOff[",
  StyleBox["Part::partd",
    FontColor->RGBColor[1, 0, 0]],
  "]; Clear[y];\nH[y_]=HermiteExpansionMultipStand[Table[y[[j]],{j,p}],my,\"H\
\"]//Chop;\n\nIf[option==1,\nHl=1,\nHl = Map[H,vals]];\t(*bei Yi1i, Pi1i*) \n\
\nIf[TRAFO>0,\n\nWhich[\n\n\tTRAFO==1,\n\tmaxi=Hl//Max;\n\teps=$SHIFT maxi,\n\
\n\tTRAFO==2,\n\teps=$EPS\n];\n\nPrint[\"MessupHermiteNorKorrMulti \
TRAFO=\",TRAFO,\" eps=\",eps];\n(*trafo=(x=(#-eps);x*Heaviside[x]+eps)&;*)\n\
(*Hl = trafo[Hl,eps]*)\n\nHl=Map[Max[#,eps]&,Hl]\n];\n \n\nWH=WEIGHT Hl;\n\n\
hl=Map[h[#,X,Theta][[lc]]&,vals];\n\nEh=WH.hl;\n\n(*hl1=Map[(#-Eh)&,hl];*)\n\
(*covyh=WH.MapThread[Dyad,{vals,hl1}];*)\n\
(*covzz=WH.Map[Dyad[#,#]&,hl1]+R[Yi1i,X,Theta][[lc,lc]];*)\n\n\
covyh=WH.MapThread[Dyad,{vals,hl}]-Dyad[Yi1i,Eh];\n\
covzz=WH.Map[Dyad[#,#]&,hl] - Dyad[Eh,Eh] + R[Yi1i,X,Theta][[lc,lc]];\n\n\
covzz1=covzz//Inverse;\n\ngain=covyh.covzz1;\n\ninn=Z[[lc]]-Eh;\n\
Y0=Yi1i+gain.inn;\nP0=Pi1i-gain.Transpose[covyh];\n\n\nl0= -.5(Log[Det[2Pi \
covzz]] + inn.covzz1.inn);\t(*mit 2Pi*)\n\n(*Print[Y0,P0];*)\n\nvals  = \
TrafoMueSigma[VALS,{Y0,P0}]; (*nach Norkorr*)\n\n\
(*Print[valsi1i~ii~vals//Transpose//MatrixForm];*)\n\nHl = Map[H,vals];\t\
(*bei mue0yz, sigma0yz*)\n\nIf[TRAFO>0,\n\nWhich[\n\n\tTRAFO==1,\n\t\
maxi=Hl//Max;\n\teps=$SHIFT maxi,\n\n\tTRAFO==2,\n\teps=$EPS\n];\n\n\
Hl=Map[Max[#,eps]&,Hl]\n];\n\nWH=WEIGHT Hl;\n\nLik1=WEIGHT.Hl; \n\n(*   \
p(z|y)phi(y)H(y) = L0 phi0 H(y); L = L0 * \\int phi0 H = L0 L1 *)\n(*   \
p(y|z) = phi0 H(y)/L1*)\n\nlik=l0+Log[Lik1];\n\nm=Shape[0,K];\n\nm[[1]]= \
(WH.vals)/Lik1;\n\nvals=Map[(#-m[[1]])&,vals]; \n\nDo[\n\nind=kexp[k,p]; \n\
mk=Outer[MM[#1,#2]&,vals,ind,1]; \nm[[k]] = (WH.mk)/Lik1; \n\n,{k,2,K}];\n\n\
Take[m,2]//Print[\"MessupHermiteNorKorrMulti\",#]&;\n\n(*m2 psd?*)\n\n\
m2=momentexp2index[m[[2]],2,p];\neigm2=m2//Eigenvalues;\neigm2//Print;\n\n\
If[Min[eigm2]<0, (*Norkorr mit H*)\nPrint[\"Norkorr mit H, PO\", \
P0//Eigenvalues];\n{GaussMomenteMulti[Y0,P0,K],lik0},\n{m,lik}]\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"MessupHermiteNorKorrMulti"],

Cell[TextData[{
  "MessupHermite5Multi//Clear\n\
(*****************************************************************************\
*)\t\t\t \n\
MessupHermite5Multi[{Z_,X_,my_},Theta_,{h_,R_},{miss_,option_:0}]:=\n\
(*****************************************************************************\
*)\t\t\t \n(* Bayes-Formel mit Normal-Korrelation mit \
Gauss-Hermite-Integral*) \n\t\nModule[{zmiss,lc,Y0,P0,l0,vals,H,Hl,hl,hl1,\n  \
      lik,Lik1,Yi1i,Pi1i,m,k,K,p,WH,y,covzz,covzz1,covyh,inn,gain,Eh},\n\t\n\
zmiss = Map[SameQ[miss,#]&,Z];\t\t\nlc = Locate[zmiss,False]; \n\t    \nIf[lc \
== {},Return[{my,0}]]; (*keine Messung*)\n\n\nYi1i  = my[[1]];\nPi1i  = \
my[[2]];\nPi1i  = momentexp2index[Pi1i,k=2,p=Yi1i//Length];\n\
Pi1i1=Pi1i//Inverse;\n\n(*Normalkorrelation, Stochastische Linearisierung SL: \
       *) \n(* z = Eh + (h,y)(y,y)^-1 (y-mue) + eps                      *)\n\
(* E[y|z]= mue + (y,h)[(h,y)(y,y)^-1(y,h)+R]^-1 (z-Ez)       *)\n\n\
Pi1i=Shift[Pi1i,10^-16,\"MessupHermite5Multi\"];\n\
vals=TrafoMueSigma[VALS,{Yi1i,Pi1i},0];\n\nOff[",
  StyleBox["Part::partd",
    FontColor->RGBColor[1, 0, 0]],
  "]; \nClear[y];\nH[y_]=HermiteExpansionMultipStand[Table[y[[j]],{j,p}],\n\t\
\t\t               \t       my/.my[[2]]->flattensymmetric[Pi1i],\"H\"]//Chop;\
\n\nIf[option==1,(*nur Gauss-Anteil phi*)\nHl=1,\nHl = Map[H,vals]];\t(*bei \
Yi1i,Pi1i *) \n\nHl//Print[\"Hl\",#]&;\n\nIf[TRAFO>0,\n\nWhich[\n\n\t\
TRAFO==1,\n\tmaxi=Hl//Max;\n\teps=$SHIFT maxi,\n\n\tTRAFO==2,\n\teps=$EPS\n];\
\n\nPrint[\"MessupHermite5Multi TRAFO=\",TRAFO,\" eps=\",eps];\n\
(*trafo=(x=(#-eps);x*Heaviside[x]+eps)&;*)\n(*Hl = trafo[Hl,eps]*)\n\n\
Hl=Map[Max[#,eps]&,Hl]\n];\n \n\nWH=WEIGHT Hl;\n\n\
hl=Map[h[#,X,Theta][[lc]]&,vals];\n\nEh=WH.hl;\n\n(*hl1=Map[(#-Eh)&,hl];*)\n\
(*covyh=WH.MapThread[Dyad,{vals,hl1}];*)\n\
(*covzz=+R[Yi1i,X,Theta][[lc,lc]];*)\n\n\
covyh=WH.MapThread[Dyad,{vals,hl}]-Dyad[Yi1i,Eh];\ncovhy=Transpose[covyh];\n\
HH=covhy.Pi1i1; \nRR=R[Yi1i,X,Theta][[lc,lc]];                                \
(*=H=hy bei EKF*)\ncovzz=HH.covyh + RR; \n                                    \
                        (*(h,y)(y,y)^-1(y,h)+R*)\ncovzz1=covzz//Inverse;\n\
gain=covyh.covzz1;\n\nZlc=Z[[lc]];\ninn=Zlc-Eh;\nY0=Yi1i+gain.inn;\n\
P0=Pi1i-gain.covhy;\n\n\nl0= -.5(Log[Det[2Pi covzz]] + inn.covzz1.inn);\t\
(*mit 2Pi*)\n\nPrint[Y0,P0];\n\n(*nach Norkorr*)\n\nvals  = \
TrafoMueSigma[VALS,{Y0,P0},10^-16]; \n\nHl = Map[H,vals];\t(*bei mue0yz, \
sigma0yz*)\n\nIf[TRAFO>0,\n\nWhich[\n\n\tTRAFO==1,\n\tmaxi=Hl//Max;\n\t\
eps=$SHIFT maxi,\n\n\tTRAFO==2,\n\teps=$EPS\n];\n\nHl=Map[Max[#,eps]&,Hl]\n];\
\n\n\npl = pzypzySL[Zlc,lc,vals,X,Theta,inn,h,HH,RR,Yi1i];\n\n\n\
(*{Zlc,lc,vals,X,Theta,inn,h,HH,RR,Yi1i}//Print;*)\n\n(*pl//Print;*)\n\n\
Hlpl=Hl pl;\n\nWH=WEIGHT Hlpl;\n\nLik1=WEIGHT.Hlpl; \n\nLik1//Print;\n\n\n\n\
(*   p(z|y)phi(y)H(y) = L0 [p(z|y)/pLin(z|y)] H(y) phi0; *)\n(*   L = L0 * \
\\int p(z|y)/pLin(z|y) H phi0 = L0 L1       *)\n(*   p(y|z) = \
p(z|y)/pLin(z|y) H(y) phi0 /L1             *)\n\nlik=l0+Log[Lik1];\n\n\
m=Shape[0,K=my//Length];\n\nm[[1]]= (WH.vals)/Lik1;\n\n\
vals=Map[(#-m[[1]])&,vals]; \n\nDo[\n\nind=kexp[k,p]; \n\
mk=Outer[MM[#1,#2]&,vals,ind,1]; \nm[[k]] = (WH.mk)/Lik1; \n\n,{k,2,K}];\n\n\
Take[m,2]//Print[\"MessupHermite5Multi\",#]&;\n\n(*m2 psd?*)\n\n\
m2=momentexp2index[m[[2]],2,p];\neigm2=m2//Eigenvalues;\neigm2//Print;\n\n\
If[Min[eigm2]<0, (*Norkorr mit H*)\nPrint[\"Min[eigm2]<0: Norkorr mit H, \
P0=\", P0//Eigenvalues];\n{GaussMomenteMulti[Y0,P0,K],lik0},\n{m,lik}]\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"MessupHermite5Multi"],

Cell["\<\
(*******************************************************************\
***********)\tpzypzySL//Clear
pzypzySL[z_,lc_,y_,t_,Theta_,inn_,h_,H_,R_,mue_]:=
(*****************************************************************************\
*)\t\t\t 
Block[{R1,zhl,Q1,zhl2,Q2},

R1   = Inverse[R]; (*R1//Print;*)
zhl  = Map[(z-h[#,t,Theta][[lc]])&,y];
Q1   = Map[(#1.R1.#1)&,zhl];

zhl2 = Map[inn-H.(#-mue)&,y];
Q2   = Map[(#1.R1.#1)&,zhl2];

H//Print;
Q1/Q2//Print;

Exp[-.5(Q1-Q2)]

]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  FontSize->14,
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell["\<\
(*******************************************************************\
***********)\t\t\t 
pzypzySLS//Clear
pzypzySLS[z_,lc_,y_,t_,Theta_,inn_,h_,hh_,hyyyyh_,H_,R_,mue_]:=
(*****************************************************************************\
*)\t\t\t 
Block[{R1,RS,RS1,zhl,Q1,zhl2,Q2},

R1=R//Inverse;
RS=R+hh-hyyyyh;
RS1=RS//Inverse;
 
zhl  = Map[(z-h[#,t,Theta][[lc]])&,y];
Q1   = Map[(#1.R1.#1)&,zhl];

zhl2 = Map[inn-H.(#-mue)&,y];
Q2   = Map[(#1.RS1.#1)&,zhl2];

(Det[RS]/Det[R])^.5 Exp[-.5(Q1-Q2)]

]\
\>", "Input",
  InitializationCell->True,
  FontSize->14,
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[TextData[{
  "MessupHermite6Multi//Clear\n\
(*****************************************************************************\
*)\t\t\t \n\
MessupHermite6Multi[{Z_,X_,my_},Theta_,{h_,R_},{miss_,option_:1}]:=\n\
(*****************************************************************************\
*)\t\t\t \n(* Bayes-Formel/ IS mit modifizierter Normalkorrelation*) \n\t\n\
Module[{zmiss,lc,Y0,P0,l0,vals,H,Hl,hl,hl1,\n        \
lik,Lik1,Yi1i,Pi1i,Pi1i1,m,k,K,p,WH,y,covzz,covzz1,covyh,inn,gain,Eh},\n\t\n\
zmiss = Map[SameQ[miss,#]&,Z];\t\t\nlc = Locate[zmiss,False]; \n\t    \nIf[lc \
== {},Return[{my,0}]]; (*keine Messung*)\n\n\nYi1i  = my[[1]];\nPi1i  = \
my[[2]];\nPi1i  = momentexp2index[Pi1i,k=2,p=Yi1i//Length];\n\
Pi1i1=Pi1i//Inverse;\nPi1i=Shift[Pi1i,10^-16,\"MessupHermite6Multi\"];\n\
vals=TrafoMueSigma[VALS,{Yi1i,Pi1i},0];\n\nOff[",
  StyleBox["Part::partd",
    FontColor->RGBColor[1, 0, 0]],
  "]; \nClear[y];\nH[y_]=HermiteExpansionMultipStand[Table[y[[j]],{j,p}],\n\t\
\t\t               \t       my/.my[[2]]->flattensymmetric[Pi1i],\"H\"]//Chop;\
\n\nIf[option==1,       (*Norkorr mit H=1, nur Gauss-Anteil phi*)\nHl=1,\nHl \
= Map[H,vals]];\t(*bei Yi1i,Pi1i; volle apriori-Dichte phi*H *) \n\n\
If[TRAFO>0,\n\nWhich[\n\n\tTRAFO==1,\n\tmaxi=Hl//Max;\n\teps=$SHIFT maxi,\n\n\
\tTRAFO==2,\n\teps=$EPS\n];\n\nPrint[\"MessupHermite6Multi TRAFO=\",TRAFO,\" \
eps=\",eps];\nHl=Map[Max[#,eps]&,Hl]\n];\n \n(* Normalkorrelation mit \
Pseudo-Messmodell                   *) \n(* z = Eh + (h,y)(y,y)^-1 (y-mue) + \
epsschlange              *)\n(* RS= R  + (h,h) - (h,y)(y,y)^-1(y,h)           \
            *)\n(* E[y|z]= mue + (y,h)[(h,h)+R]^-1 (z-Ez)                    \
*)\n\nWH=WEIGHT Hl;\n\nhl=Map[h[#,X,Theta][[lc]]&,vals];\n\nEh=WH.hl;\n\n\
covhh=WH.Map[Dyad[#,#]&,hl] - Dyad[Eh,Eh];\n\
covyh=WH.MapThread[Dyad,{vals,hl}]-Dyad[Yi1i,Eh];\ncovhy=Transpose[covyh];\n\
HH=covhy.Pi1i1;                                             (*==H=dh/dy bei \
EKF*)\nhyyyyh=HH.covyh;\n\nRR=R[Yi1i,X,Theta][[lc,lc]];                       \
         \ncovzz=covhh + RR; \n                                               \
             (*(h,y)(y,y)^-1(y,h)+R*)\ncovzz1=covzz//Inverse;\n\
gain=covyh.covzz1;\n\nZlc=Z[[lc]];\ninn=Zlc-Eh;\nY0=Yi1i+gain.inn;\n\
P0=Pi1i-gain.covhy;\n\n\nl0= -.5(Log[Det[2Pi covzz]] + inn.covzz1.inn);\t\
(*mit 2Pi*)\n\n(*Print[Y0,P0];*) \n\n\n\n(*nach Norkorr*)\n\nvals  = \
TrafoMueSigma[VALS,{Y0,P0},0]; \n\nHl = Map[H,vals];\t(*bei mue0yz, \
sigma0yz*)\n\n(*Hl//Print;*)\n\nIf[TRAFO>0,\n\nWhich[\n\n\tTRAFO==1,\n\t\
maxi=Hl//Max;\n\teps=$SHIFT maxi,\n\n\tTRAFO==2,\n\teps=$EPS\n];\n\n\
Hl=Map[Max[#,eps]&,Hl]\n];\n\npl = \
pzypzySLS[Zlc,lc,vals,X,Theta,inn,h,covhh,hyyyyh,HH,RR,Yi1i];\n\n\
(*pl//Print;*)\n\n\nHlpl=Hl pl;\n\nWH=WEIGHT Hlpl;\n\nLik1=WEIGHT.Hlpl; \n\n\
Lik1//Print;\n\n(*Lik1//Print;*)\n\n\n\n(*   p(z|y)phi(y)H(y) = L0 \
[p(z|y)/pLin(z|y)] H(y) phi0; *)\n(*   L = L0 * \\int p(z|y)/pLin(z|y) H phi0 \
= L0 L1       *)\n(*   p(y|z) = p(z|y)/pLin(z|y) H(y) phi0 /L1             *)\
\n\nlik=l0+Log[Lik1];\n\nm=Shape[0,K=my//Length];\n\nm[[1]]= (WH.vals)/Lik1;\n\
\nvals=Map[(#-m[[1]])&,vals]; \n\nDo[\n\nind=kexp[k,p]; \n\
mk=Outer[MM[#1,#2]&,vals,ind,1]; \nm[[k]] = (WH.mk)/Lik1; \n\n,{k,2,K}];\n\n\
(*Take[m,2]//Print[\"MessupHermite6Multi\",#]&;*)\n\n(*m2 psd?*)\n\n\
m2=momentexp2index[m[[2]],2,p];\neigm2=m2//Eigenvalues;\n(*eigm2//Print;*)\n\n\
If[Min[eigm2]<0, (*Norkorr mit H*)\nPrint[P0//MatrixForm,m2//MatrixForm, \
\"Norkorr mit H, P0=\", P0//Eigenvalues];\n{GaussMomenteMulti[Y0,P0,K],lik0},\
\n\n{m,lik}]\n]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"MessupHermite6Multi"],

Cell[CellGroupData[{

Cell["\<\
{VALS,WEIGHT}=GaussHermitePointsMulti2[m=5,p=2,eps=10^-16,ksigma=2];\

MessupHermiteNorKorrMulti[{{2},_,{{1,1},{1,0,2}}},Theta,{h,R},{miss}]
MessUpGHF[{{2},{{1,1},{{1,0},{0,2}}},_,_},Theta,{h,R},{miss}]
MessupHermite4Multi[{{2},_,{{1,1},{1,0,2}}},Theta,{h,R},{miss}]
MessUpGHFBayes[{{2},{{1,1},{{1,0},{0,2}}},_,_},Theta,{h,R},{miss}]
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^9
                                -16
Stuetzstellen:25; weight > 1. 10    und |vals| < 2: 9\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{{1.8930513630690065, 0.9999999999999999}, \
{0.21232836617173315, 

     -3.1464648670358253*^-18, 1.670056559290662}}, \
-1.4200924655892107}\
\>", "\<\
                                       -18
{{{1.89305, 1.}, {0.212328, -3.14646 10   , 1.67006}}, -1.42009}\
\>"], \
"Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{1.8930513630690065, 1.}, {{0.25427685666157007, \
0.}, {0., 2.}},\\
  -0.5011539323845379}\
\>", "\<\
{{1.89305, 1.}, {{0.254277, 0.}, {0., 2.}}, \
-0.501154}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{{1.9044234114382652, 1.0000000000000002}, \
{0.06463750534657582, 

     1.5851528195092224*^-17, 1.670056559290662}}, -1.3649114305509784}\
\>", \
"\<\
                                       -17
{{{1.90442, 1.}, {0.0646375, 1.58515 10   , 1.67006}}, -1.36491}\
\>"], \
"Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{1.9044234114382652, 1.0000000000000002}, 

   {{0.06463750534657509, -6.661338147750939*^-16}, {-6.661338147750939*^-16, \


     1.670056559290662}}, -1.3649114305509784}\
\>", "\<\
                    \
                    -16               -16
{{1.90442, 1.}, {{0.0646375, -6.66134 10   }, {-6.66134 10   , 1.67006}}, \
-1.36491}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{VALS,WEIGHT}=GaussHermitePointsMulti2[m=5,p=2,eps=10^-16,ksigma=3];\

MessupHermiteNorKorrMulti[{{2},_,{{1,1},{1,0,2}}},Theta,{h,R},{miss}]
MessUpGHF[{{2},{{1,1},{{1,0},{0,2}}},_,_},Theta,{h,R},{miss}]
MessupHermite4Multi[{{2},_,{{1,1},{1,0,2}}},Theta,{h,R},{miss}]
MessUpGHFBayes[{{2},{{1,1},{{1,0},{0,2}}},_,_},Theta,{h,R},{miss}]
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^9
                                -16
Stuetzstellen:25; weight > 1. 10    und |vals| < 3: 25\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{{1.9090909090909092, 1.}, {0.0909090909090905, \
1.050926698424473*^-16, 

     2.0000000000000004}}, -1.4211390776522896}\
\>", "\<\
                   \
                    -16
{{{1.90909, 1.}, {0.0909091, 1.05093 10   , 2.}}, -1.42114}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{1.9090909090909092, 0.9999999999999999}, 

   {{0.0909090909090905, 1.0092936587501423*^-16}, {1.0092936587501423*^-16, \
2.}}, 

   -0.502200544447617}\
\>", "\<\
                                       -16  \
            -16
{{1.90909, 1.}, {{0.0909091, 1.00929 10   }, {1.00929 10   , 2.}}, -0.502201}\
\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{{1.9090909090909092, 0.9999999999999998}, \
{0.09090909090909087, 

     -2.0250553880344914*^-18, 2.}}, -1.4211390776522899}\
\>", "\<\
         \
                               -18
{{{1.90909, 1.}, {0.0909091, -2.02506 10   , 2.}}, -1.42114}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
 {{1.9090909090909092, 0.9999999999999998}, 

   {{0.09090909090909172, -2.220446049250313*^-16}, {-2.220446049250313*^-16, \
2.}}, 

   -1.4211390776522899}\
\>", "\<\
                                        \
-16               -16
{{1.90909, 1.}, {{0.0909091, -2.22045 10   }, {-2.22045 10   , 2.}}, \
-1.42114}\
\>"], "Output",
  PageWidth->Infinity,
  LineSpacing->{1, 0},
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell["\<\
MessupHermite2NorKorralt//Clear
(***************************************************************)\t\t\t 
MessupHermite2NorKorralt[{z_,t_,my_},Theta_,{h_,R_},miss_]:=
(***************************************************************)\t\t\t 
(*ohne H bei NorKorr!*)

Module[{H,myz,mueyz,pyzu,Likeli,y,k,vals,mue,Sigma},

If[z==miss,Return[{my,0}]];

H[y_]=HermiteExpansionOhnePhi[y,my]; 
\t
mue  = {my[[1]]};
Sigma={{my[[2]]}};
vals=TrafoMueSigma[VALS,{mue,Sigma}];

(*Normal-Korrelation = MessupGHF*)

hl = Map[h[#,t,Theta]&,vals];
vals1=Map[(#-mue)&,vals];

covyz   = WEIGHT.(vals1 hl)//First;
Eh      = WEIGHT.hl//First;
covzz   = WEIGHT.(hl^2) - Eh^2 + R[mue,t,Theta]//First;
covzz1  = covzz^-1;
inn     = z-Eh;
mue0yz  = my[[1]] + covyz covzz1 (z-Eh);
sigma0yz= my[[2]] - covyz covzz1 covyz; 
l0      = -.5(Log[2Pi covzz] + inn covzz1 inn);\t
 
(*{z,covyz,Eh,covzz,mue0yz,sigma0yz}//Print; *)
 
(*a post. Momente*) 

vals=TrafoMueSigma[VALS,{{mue0yz},{{sigma0yz}}}]; (*Int. bzgl. phi0*)

L1=GaussHermite2[H[#]&,{vals,WEIGHT}];

lik = l0 + Log[L1];

mueyz=1/L1 GaussHermite2[# H[#]&,{vals,WEIGHT}];

myz=Table[1/L1 GaussHermite2[((#-mueyz)^k \
H[#])&,{vals,WEIGHT}],{k,2,my//Length}];

{{mueyz,myz}//Flatten,lik}
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
(* m2 gross, da Integrand p[z|y] ~ exp[-.5(z-y)^2]; kein Polynom *)\
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[CellGroupData[{

Cell["\<\
{VALS,WEIGHT}=GaussHermitePointsMulti2[m1=3,p=1,10^-12];
{myz,lik}=MessupHermite2NorKorralt[{2,t,{0,10,0,300}},Theta,{h1,R1},miss]

{VALS,WEIGHT}=GaussHermitePointsMulti2[m2=200,p=1,10^-12];
{myz,lik}=MessupHermite2alt[{2,t,{0,10,0,300}},Theta,{h1,R1},miss]

{VALS,WEIGHT}=GaussHermitePointsMulti2[m1,p=1,10^-12];
{myz,lik}=MessupHermite2NorKorr[{2,t,{0,10,0,300}},Theta,{h1,R1},miss]

{VALS,WEIGHT}=GaussHermitePointsMulti2[m2,p=1,10^-12];
{myz,lik}=MessupHermite2[{2,t,{0,10,0,300}},Theta,{h1,R1},miss]

\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^5
                               -12
Stuetzstellen:3  groesser 1. 10    :3
Genauigkeit x^399
                                 -12
Stuetzstellen:200  groesser 1. 10    :64
Genauigkeit x^5
                               -12
Stuetzstellen:3  groesser 1. 10    :3
Genauigkeit x^399
                                 -12
Stuetzstellen:200  groesser 1. 10    :64\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.8181818181818181, 0.9090909090909061, \
2.5438963273378583*^-16, 2.4793388429751912}, -2.2997043514220397}\
\>", \
"\<\
                              -16
{{1.81818, 0.909091, 2.5439 10   , 2.47934}, -2.2997}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.8181818181818523, 0.9090909090909127, \
9.25792453584917*^-14, 2.4793388429761314}, {-2.2997043514220192}}\
\>", \
"\<\
                               -14
{{1.81818, 0.909091, 9.25792 10   , 2.47934}, {-2.2997}}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.8181818181818181, 0.9090909090909061, \
2.5438963273378583*^-16, 2.4793388429751912}, -2.2997043514220397}\
\>", \
"\<\
                              -16
{{1.81818, 0.909091, 2.5439 10   , 2.47934}, -2.2997}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.8181818181818523, 0.9090909090909127, \
9.25792453584917*^-14, 2.4793388429761314}, -2.2997043514220192}\
\>", "\<\
  \
                             -14
{{1.81818, 0.909091, 9.25792 10   , 2.47934}, -2.2997}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell["\<\
MessupHermite2NorKorr//Clear
(***************************************************************)\t\t\t 
MessupHermite2NorKorr[{z_,t_,my_},Theta_,{h_,R_},miss_]:=
(***************************************************************)\t\t\t 

Module[{H,myz,mueyz,lik,l0,L1,y,k,vals,vals1,mue,Sigma,eps,x},

If[z==miss,Return[{my,0}]];

H[y_]=HermiteExpansionOhnePhi[y,my]; 
\t
mue  = {my[[1]]};
Sigma={{my[[2]]}};

vals=TrafoMueSigma[VALS,{mue,Sigma}];

(*Normal-Korrelation = MessupGHF*)

Hl = Map[H,vals]//Flatten;

eps=10^-1;
trafo=(x=(#-eps);x*Heaviside[x]+eps)&;

(*trafo=(x=(#-eps);x*Logistic[50 x]+eps)&;*)
(*trafo=(# Heaviside[#]+eps)&;*) (*alt*)
(*Hl=trafo[Hl];*)
(*plot1[{vals//Flatten,(Hl//Flatten)}//Transpose,PlotJoined->False];*)
(*Hl=Hl Logistic[50 Hl]; Hl//N5//Print;*)

c=WEIGHT.Hl;  
Hl=Hl/c;

(*Hl=1;*)

hl   = Map[h[#,t,Theta]&,vals];
vals1= Map[(#-mue)&,vals];

covyz   = WEIGHT.(vals1 hl Hl)//First;
Eh      = WEIGHT.(hl Hl)//First;
covzz   = WEIGHT.(hl^2 Hl) - Eh^2 + R[mue,t,Theta]//First;
covzz1  = covzz^-1;
inn     = z-Eh;
mue0yz  = my[[1]] + covyz covzz1 inn;
sigma0yz= my[[2]] - covyz covzz1 covyz; 
l0      = -.5(Log[2Pi covzz] + inn covzz1 inn);\t
 
{my[[2]],covyz ,covzz, covyz}//Print; 
{z,mue0yz,sigma0yz,l0}//Print; 

 
(*a post. Momente*) 

vals = TrafoMueSigma[VALS,{{mue0yz},{{sigma0yz}}}]//Flatten; (*Int. bzgl. \
phi0*)

Hl   = Map[H,vals];\t(*bei mue0mue0yz, sigma0yz*) 

(*plot1[{vals//Flatten,(Hl//Flatten) WEIGHT}//Transpose,PlotJoined->False];*)
 \t   
Hl=trafo[Hl];

L1=WEIGHT.Hl; 

lik = l0 + Log[L1];

mueyz=1/L1 WEIGHT.(vals Hl);
vals1=Map[(#-mueyz)&,vals];

myz=Table[1/L1 WEIGHT.(vals1^k Hl),{k,2,my//Length}];

{{mueyz,myz}//Flatten,lik}
]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"MessupHermite2Norkorr"],

Cell[CellGroupData[{

Cell["\<\
{VALS,WEIGHT}=GaussHermitePointsMulti2[20,p=1,10^-12];
{myz,lik}=MessupHermite2NorKorr[{2,t,{1,.1,.1,.1}},Theta,{h1,R1},miss]
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^39
                                -12
Stuetzstellen:20  groesser 1. 10    :18
{2, 0.1, 1., 1.1, 1.09091, 0.0909091, -1.42114}\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.1045956888373143, 0.16448059399252063, \
0.08782004731428279, 0.09897653327909728}, {-1.2595940294220729}}\
\>", \
"\<\
{{1.1046, 0.164481, 0.08782, 0.0989765}, {-1.25959}}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{VALS,WEIGHT}=GaussHermitePointsMulti2[10,p=1,10^-12];
{myz,lik}=MessupHermite2NorKorr[{2,t,{1,.1,.1,.1}},Theta,{h1,R1},miss]
\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Genauigkeit x^19
                                -12
Stuetzstellen:10  groesser 1. 10    :10
{2, 0.1, 1., 1.1, 1.09091, 0.0909091, -1.42114}\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
{{1.096847680468555, 0.18062717789832913, \
0.09831686774933099, 0.11038608254021876}, {-1.3082668000086148}}\
\>", \
"\<\
{{1.09685, 0.180627, 0.0983169, 0.110386}, {-1.30827}}\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[TextData[{
  "HermiteFilter//Clear\n\
(***************************************************************)\t\t\t \n\
HermiteFilter[{Z_,X_},Theta_,{System_,Messmodell_,p0_,dt_},\n             \
{{K_,L_},Gauss_,miss_,option_:1}]:=\n\
(***************************************************************)\t\t\t \n(* \
Likelihood mit Momentenglg. und Hermite-Entw.*)\n\n\
Block[{ti,T1,dti,dti1,Null,Xi,mii,mi1i,Mi1i,M,j,pi1i,pii,liki,lik,SystemL,y},\
\n\nti   = messind[Z,miss]; (*Indices mit mind. einer Messung*)\nT1   = \
Length[Z];\nti   = Union[ti,{1,T1}]; \ndti  = Delta[ti,ti,List,-1]; \ndti1 = \
Delta[ti]+1;\n \nSystemL=Map[Take[#,L+1]&,System];\n(*SystemL//Print;*)\n\n\
(*Anfangsbedingung*)\n\n\
{pii[y_],mii,liki}=MessupHermite[{Z[[1,1]],X[[1]],p0,y,K},Theta,Messmodell,\
miss];\nlik = liki;\n\nM={}; mii//Print;\n\nDo[ (*Print[i];*)\n\n\t\n\n\tXi  \
= Take[ X,dti[[i]] ];\n\t\n\t{mi1i,Mi1i} = ",
  StyleBox["TimeUpNonlinear",
    FontColor->RGBColor[1, 0, 0]],
  "[{mii,Xi,dt},Theta,{F,SystemL},Gauss];\n\n  (*mi1i//Print;*)\n  \
(*Mi1i//MatrixForm//Print;*)\n\t\n\tIf[option==2, \tM = Join[M,Drop[Mi1i,-1]] \
];\n\t\n\t\n\tj = ti[[i+1]];\n\t\n\t  (* {i,j}//Print; *)\n\t\n \t\
pi1i[y_]=HermiteExpansion[y,mi1i]; \n \t\n \tIf[Z[[j,1]]=!=miss,\n\t\t\
{pii[y_],mii,liki}=MessupHermite[{Z[[j,1]],X[[j]],pi1i,y,K},Theta,Messmodell,\
miss],\n\t\t(*else*)\n\t\t{pii[y_],mii,liki}={pi1i[y],mi1i,0}\n\t\t];\n\t\t\n\
\t\tlik +=liki;\n\t\t\n\t\tmii//Print;\n\n\t\n,{i,1,Length[ti]-1}];\n\n\
If[option==2,\n\n\tM = Join[M,{mii}];\n\tReturn[{M,lik}//N]];\n\t\n\
If[option==1,Return[lik//N]];\n\n\n];"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[TextData[{
  "HermiteFilter1//Clear\n\
(***************************************************************)\t\t\t \n\
HermiteFilter1[{Z_,X_},Theta_,{System_,Messmodell_,m0_,dt_},\n                \
{{K_,L_},Gauss_,miss_,option_,\n                 \
IntegrationsBereich_:{-Infinity,Infinity}}]:=\n\
(***************************************************************)\t\t\t \n(* \
Likelihood mit Momentenglg. und Hermite-Entw.*)\n\n\
Block[{i,ti,T1,dti,dti1,Null,Xi,mii,mi1i,Mi1i,M,j,pi1i,pii,liki,lik,SystemL,y}\
,\n\nti   = messind[Z,miss]; (*Indices mit mind. einer Messung*) \nti//Print;\
\nT1   = Length[Z];\nti   = Union[ti,{1,T1}]; \ndti  = Delta[ti,ti,List,-1]; \
\ndti1 = Delta[ti]+1;\n \nSystemL=Map[Take[#,L+1]&,System];\n\
(*SystemL//Print;*)\n\n(*Anfangsbedingung*)\n\n\
{mii,liki}=MessupHermite1[{Z[[1,1]],X[[1]],Take[m0,K]},Theta,Messmodell,miss,\
\n                          IntegrationsBereich];\nlik = liki;\n\nM={};  \n\n\
Do[ (*Print[i];*)\n\n\t\n\n\tXi  = Take[ X,dti[[i]] ];\n\t\n\t{mi1i,Mi1i} = \
",
  StyleBox["TimeUpNonlinear",
    FontColor->RGBColor[1, 0, 0]],
  "[{mii,Xi,dt},Theta,{F,SystemL},Gauss];\n\n  (*mi1i//Print;*)\n  \
(*Mi1i//MatrixForm//Print;*)\n\t\n\tIf[option==2, \tM = Join[M,Drop[Mi1i,-1]] \
];\n\t\n\t\n\tj = ti[[i+1]];\n\t\n\t  (*{i,j}//Print;*) \n\t\n \t\
{mii,liki}=MessupHermite1[{Z[[j,1]],X[[j]],mi1i},Theta,Messmodell,miss,\n \t  \
                         IntegrationsBereich];\n\t\t\n\t\tlik +=liki;\n  \n\t\
\n,{i,1,Length[ti]-1}];\n\nIf[option==2,\n\n\tM = Join[M,{mii}];\n\t\
Return[{M,lik}//N]];\n\t\nIf[option==1,Return[lik//N]];\n\n\n];"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[TextData[{
  "HermiteFilter2//Clear\n\
(***************************************************************)\t\t\t \n\
HermiteFilter2[{Z_,X_},Theta_,{System_,Messmodell_,m0_,dt_},\n                \
{{K_,L_},Gauss_,miss_,option_,messoption_,m_,eps_:10^-16}]:=\n\
(***************************************************************)\t\t\t \n(* \
Likelihood mit Momentenglg. und Hermite-Entw.*)\n(* \
Gauss-Hermite-Integration*)\n\n\
Block[{i,ti,T1,dti,dti1,Null,Xi,mii,mi1i,Mi1i,M,j,pi1i,pii,liki,lik,SystemL,y}\
,\n\nti   = messind[Z,miss]; (*Indices mit mind. einer Messung*) \nti//Print;\
\nT1   = Length[Z];\nti   = Union[ti,{1,T1}]; \ndti  = Delta[ti,ti,List,-1]; \
\ndti1 = Delta[ti]+1;\n \nSystemL=Map[Take[#,L+1]&,System];\n\
(*SystemL//Print;*)\n\n(*Anfangsbedingung*)\n\n\
{VALS,WEIGHT}=GaussHermitePointsMulti2[m,p=1,eps];\n\n\
{mii,liki}=If[messoption=!=\"Norkorr\",\n           MessupHermite2       \
[{Z[[1,1]],X[[1]],Take[m0,K]},Theta,Messmodell,miss],\n           \
MessupHermite2NorKorr[{Z[[1,1]],X[[1]],Take[m0,K]},Theta,Messmodell,miss]\n   \
        ];\n           \nmessoption=!=\"Norkorr\"//Print;          \n         \
  \nlik = liki;\n\nM={};  \n\nDo[ (*Print[i];*)\n\n\t\n\n\tXi  = Take[ \
X,dti[[i]] ];\n\t\n\t{mi1i,Mi1i} = ",
  StyleBox["TimeUpNonlinear",
    FontColor->RGBColor[1, 0, 0]],
  "[{mii,Xi,dt},Theta,{F,SystemL},Gauss];\n\n  (*mi1i//Print;*)\n  \
(*Mi1i//MatrixForm//Print;*)\n\t\n\tIf[option==2, \tM = Join[M,Drop[Mi1i,-1]] \
];\n\t\n\t\n\tj = ti[[i+1]];\n\t\n\t  (*{i,j}//Print;*) \n\t\n \t\
{mii,liki}=If[messoption=!=\"Norkorr\",\n \t              MessupHermite2      \
 [{Z[[j,1]],X[[j]],mi1i},Theta,Messmodell,miss],\n \t              \
MessupHermite2NorKorr[{Z[[j,1]],X[[1]],mi1i},Theta,Messmodell,miss]\n         \
       ];\n           \n          \n\t\t\n\t\tlik +=liki;\n  \n\t\n\
,{i,1,Length[ti]-1}];\n\nIf[option==2,\n\n\tM = Join[M,{mii}];\n\t\
Return[{M,lik}//N]];\n\t\nIf[option==1,Return[lik//N]];\n\n\n];"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell["\<\
MomenteSymbolisch//Clear
MomenteSymbolisch[A_,B_,DT_,K_]:=

Module[{rule,C},

rule=MapThread[Rule[#1,#2]&,{Table[C^k,{k,1,K}],GaussMomente[0,DT,K]}];

Do[

MkSymb[k]=((A + (B//Sqrt) C)^k//Expand)/.rule; (* B = Omega, C = dW*)

MkSymb[k]//Print;

MkSymb[k]

,{k,2,K}];

MkSymb

]\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["mks=MomenteSymbolisch[A,Omega,DT,6];\n\n",
  FontWeight->"Plain"]], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
 2
A  + DT Omega
 3
A  + 3 A DT Omega
 4      2                2      2
A  + 6 A  DT Omega + 3 DT  Omega
 5       3                   2      2
A  + 10 A  DT Omega + 15 A DT  Omega
 6       4                2   2      2        3      3
A  + 15 A  DT Omega + 45 A  DT  Omega  + 15 DT  Omega\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["??mks", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell["\<\
Global`mks
mks = MkSymb\
\>", "Print",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["mks[3]", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14],

Cell[OutputFormData["\<\
A^3 + 3*A*B*DT\
\>", "\<\
 3
A  + 3 A B DT\
\>"], "Output",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14]
}, Open  ]],

Cell[TextData[{
  "GGHF//Clear\n\
(***************************************************************)\t\t\t \n\
GGHF[{Z_,X_},Theta_,{System_,Messmodell_,m0_,dt_},\n     \
{K_,miss_,option_,{timeoption_,messoption_},m_,eps_:10^-16,ksigma_:Infinity}]:\
=\n(***************************************************************)\t\t\t \n\
(* Likelihood mit Momentenglg. und Hermite-Entw.*)\n(* \
Gauss-Hermite-Integration*)\n\n\
Block[{i,ti,T1,dti,dti1,Null,Xi,mii,mi1i,Mi1i,M,j,pi1i,pii,liki,lik,y,\n      \
 rule,A,B,C,DT,MkSymb},\n\nti   = messind[Z,miss]; (*Indices mit mind. einer \
Messung*) \nti//Print;\nT1   = Length[Z];\nti   = Union[ti,{1,T1}]; \ndti  = \
Delta[ti,ti,List,-1]; \ndti1 = Delta[ti]+1;\n\n\
MkSymb=MomenteSymbolisch[A,B,DT,K];\n \n(*Anfangsbedingung*)\n\n\
{VALS,WEIGHT}=GaussHermitePointsMulti2[m,p=1,eps,ksigma];\n\n\
{mii,liki}=messoption[{Z[[1,1]],X[[1]],Take[m0,K]},Theta,Messmodell,miss];\n \
\n(*\npm=.001 pmess[{Z[[1,1]],y,t},Theta,Messmodell]//Evaluate;\t\n\
post=HermiteExpansion[y,mii]//Evaluate;\n\
pri=HermiteExpansion[y,Take[m0,2]]//Evaluate;\n\n\
Plot[{pri,post,.01pm},{y,-10,10}];\n\nmii//Print; \n\
{lik,NIntegrate[post,{y,-10,10}]}//Print;\n*)\n(*Return[];*)\n              \n\
lik = liki; \n\nM={}; \n \n\nDo[ (*Print[i];*)\n\n\t\n\n  \tXi  = Take[ \
X,dti[[i]] ];\n\t \n \t If[timeoption=!=\"psd\",\n\t \n  \t\t\t\t{mi1i,Mi1i} \
= ",
  StyleBox["TimeUpNonlinear",
    FontColor->RGBColor[1, 0, 0]],
  "[{mii,Xi,dt},Theta,{",
  StyleBox["FGaussHermite",
    FontColor->RGBColor[0, 0, 1]],
  ",System},_];\n\t\n \t\t\t\t\t(*",
  StyleBox["FGaussHermite",
    FontColor->RGBColor[0, 0, 1]],
  "=Momentengleichungen O(dt)*)\n\n  \t\t\t\t(*mii//Print;*)\n  \t\t\t\n\t  \
,(*else*)\n\t  \n   \t\t\t{mi1i,Mi1i} =\t",
  StyleBox["TimeUpNonlinearPSD",
    FontColor->RGBColor[1, 0, 0]],
  "[{mii,Xi,dt},Theta,System,{MkSymb,A,B,DT}];\n   \n   \t\t\t(* (a + bc)^k; \
O(dt^k) *)\n  \t];\n\n  (*mi1i//Print;*)\n  (*Mi1i//MatrixForm//Print;*)\n\t\n\
\t If[option==2, \tM = Join[M,Drop[Mi1i,-1]] ];\n\t\n\t\n\t j = ti[[i+1]];\n\t\
\n\t  (*{i,j}//Print;*) \n           \n  \
{mii,liki}=messoption[{Z[[j,1]],X[[j]],mi1i},Theta,Messmodell,miss];        \n\
\t\t\n\t\tlik +=liki;\n  \n\t\n,{i,1,Length[ti]-1}];\n\nIf[option==2,\n\n\tM \
= Join[M,{mii}];\n\tReturn[{M,lik}//N]];\n\t\nIf[option==1,Return[lik//N]];\n\
\n\n];"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"GGHF"],

Cell["\<\
GGHFMulti//Clear
(***************************************************************)\t\t\t 
GGHFMulti[{Z_,X_},Theta_,{System_,Messmodell_,m0_,dt_},
          {K_,miss_,option_,{timeoption_,messoption_},
           m_,eps_:10^-16,ksigma_:Infinity}]:=
(***************************************************************)\t\t\t 
(* Likelihood mit Momentenglg. und Hermite-Entw.*)
(* Gauss-Hermite-Integration*)

Module[{i,ti,T1,dti,dti1,p,Null,Xi,mii,mi1i,Mi1i,M,j,pi1i,pii,liki,lik,y,
        ind,mom,ii,aa,mm},

ti   = messind[Z,miss]; (*Indices mit mind. einer Messung*) 
ti//Print;
T1   = Length[Z];
ti   = Union[ti,{1,T1}]; 
dti  = Delta[ti,ti,List,-1]; 
dti1 = Delta[ti]+1;
p=m0[[1]]//Length; 
 
(*Anfangsbedingung*)

{VALS,WEIGHT}=GaussHermitePointsMulti2[m,p,eps,ksigma];

{mii,liki}=messoption[{Z[[1]],X[[1]],Take[m0,K]},Theta,Messmodell,{miss}];
  
(*mii//Print;*) 

(*
pm=.001 pmess[{Z,y,t},Theta,Messmodell]//Evaluate;\t
post=HermiteExpansion[y,mii]//Evaluate;
pri=HermiteExpansion[y,Take[m0,2]]//Evaluate;

Plot[{pri,post,.01pm},{y,-10,10}];

mii//Print; 
{lik,NIntegrate[post,{y,-10,10}]}//Print;
*)
              
lik = liki; 

M={}; 
 

Do[ (*Print[i];*)

  \tXi  = Take[ X,dti[[i]] ]; 

 \t{mi1i,Mi1i} = timeoption[{mii,Xi,dt},Theta,System];
 \t
     (*mi1i//Print;*)
     (*Mi1i//MatrixForm//Print;*)
\t
\tIf[option==2, \tM = Join[M,Drop[Mi1i,-1]] ];
\t
\tj = ti[[i+1]];
\t
\t \t (*{i,j}//Print;*) 
           
    {mii,liki}=messoption[{Z[[j]],X[[j]],mi1i},Theta,Messmodell,{miss}];   
    
    (*mii//Print[\"apost\",#]&;*)
\t\t
    lik +=liki;
  
\t
,{i,1,Length[ti]-1}];

If[option==2,

\tM = Join[M,{mii}];
\tReturn[{M,lik}//N]];
\t
If[option==1,Return[lik//N]];


];\
\>", "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontSize->14,
  FontWeight->"Plain",
  CellTags->"GGHFMulti"]
}, Open  ]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{41, 1440}, {0, 878}},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{741, 833},
WindowMargins->{{Automatic, 8}, {Automatic, 6}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowSelection->True,
ShowCellLabel->True,
ShowCellTags->True,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
Magnification->1
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "TimeUpNonlinearPSD"->{
    Cell[57659, 1172, 1497, 28, 1160, "Input",
      InitializationCell->True,
      CellTags->"TimeUpNonlinearPSD"]},
  "TimeUpNonlinearPSDMulti4"->{
    Cell[61667, 1301, 1921, 35, 1256, "Input",
      InitializationCell->True,
      CellTags->"TimeUpNonlinearPSDMulti4"]},
  "Info3417436417-6139240"->{
    Cell[116298, 2443, 68, 1, 34, "Print",
      CellTags->"Info3417436417-6139240"],
    Cell[116369, 2446, 175479, 2907, 3679, "Print",
      CellTags->"Info3417436417-6139240"]},
  "Info3416764132-1117871"->{
    Cell[299482, 5598, 67, 1, 34, "Print",
      CellTags->"Info3416764132-1117871"],
    Cell[299552, 5601, 1141, 26, 113, "Print",
      CellTags->"Info3416764132-1117871"]},
  "TimeUpNonlinearPSDMulti"->{
    Cell[300708, 5630, 3441, 65, 2344, "Input",
      InitializationCell->True,
      CellTags->"TimeUpNonlinearPSDMulti"]},
  "Info3416814232-9536192"->{
    Cell[304228, 5702, 78, 1, 34, "Print",
      CellTags->"Info3416814232-9536192"],
    Cell[304309, 5705, 823, 20, 49, "Print",
      CellTags->"Info3416814232-9536192"]},
  "Info3416814239-9199848"->{
    Cell[305210, 5733, 120, 2, 34, "Print",
      CellTags->"Info3416814239-9199848"],
    Cell[305333, 5737, 579, 16, 64, "Print",
      CellTags->"Info3416814239-9199848"]},
  "MessupHermite2"->{
    Cell[348819, 6930, 1223, 50, 669, "Input",
      InitializationCell->True,
      CellTags->"MessupHermite2"]},
  "MessupHermite3"->{
    Cell[350804, 7015, 2024, 79, 1176, "Input",
      InitializationCell->True,
      CellTags->"MessupHermite3"]},
  "MessupHermite4"->{
    Cell[352831, 7096, 2141, 82, 1192, "Input",
      InitializationCell->True,
      CellTags->"MessupHermite4"]},
  "MessupHermite4Multi"->{
    Cell[355357, 7197, 2577, 43, 1720, "Input",
      InitializationCell->True,
      CellTags->"MessupHermite4Multi"]},
  "MessupHermiteNorKorrMulti"->{
    Cell[357937, 7242, 2958, 48, 2136, "Input",
      InitializationCell->True,
      CellTags->"MessupHermiteNorKorrMulti"]},
  "MessupHermite5Multi"->{
    Cell[360898, 7292, 3690, 59, 2568, "Input",
      InitializationCell->True,
      CellTags->"MessupHermite5Multi"]},
  "MessupHermite6Multi"->{
    Cell[365883, 7409, 3732, 59, 2520, "Input",
      InitializationCell->True,
      CellTags->"MessupHermite6Multi"]},
  "MessupHermite2Norkorr"->{
    Cell[378108, 7796, 1868, 79, 1018, "Input",
      InitializationCell->True,
      CellTags->"MessupHermite2Norkorr"]},
  "GGHF"->{
    Cell[388721, 8134, 2496, 49, 1464, "Input",
      InitializationCell->True,
      CellTags->"GGHF"]},
  "GGHFMulti"->{
    Cell[391220, 8185, 1856, 84, 1256, "Input",
      InitializationCell->True,
      CellTags->"GGHFMulti"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"TimeUpNonlinearPSD", 393971, 8297},
  {"TimeUpNonlinearPSDMulti4", 394122, 8301},
  {"Info3417436417-6139240", 394277, 8305},
  {"Info3416764132-1117871", 394489, 8310},
  {"TimeUpNonlinearPSDMulti", 394697, 8315},
  {"Info3416814232-9536192", 394852, 8319},
  {"Info3416814239-9199848", 395057, 8324},
  {"MessupHermite2", 395255, 8329},
  {"MessupHermite3", 395392, 8333},
  {"MessupHermite4", 395530, 8337},
  {"MessupHermite4Multi", 395673, 8341},
  {"MessupHermiteNorKorrMulti", 395827, 8345},
  {"MessupHermite5Multi", 395981, 8349},
  {"MessupHermite6Multi", 396129, 8353},
  {"MessupHermite2Norkorr", 396279, 8357},
  {"GGHF", 396414, 8361},
  {"GGHFMulti", 396537, 8365}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 145, 4, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1946, 61, 138, 4, 28, "Input",
  InitializationCell->True],
Cell[2087, 67, 145, 3, 24, "Message"],
Cell[2235, 72, 128, 3, 24, "Message"],
Cell[2366, 77, 128, 3, 24, "Message"]
}, Open  ]],
Cell[2509, 83, 538, 15, 124, "Input",
  InitializationCell->True],
Cell[3050, 100, 584, 16, 140, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[3659, 120, 160, 6, 44, "Input"],
Cell[3822, 128, 252, 9, 26, "Output"],
Cell[4077, 139, 452, 15, 40, "Output"]
}, Open  ]],
Cell[4544, 157, 355, 11, 92, "Input",
  InitializationCell->True],
Cell[4902, 170, 600, 19, 220, "Input",
  InitializationCell->True],
Cell[5505, 191, 398, 15, 140, "Input",
  InitializationCell->True],
Cell[5906, 208, 675, 21, 252, "Input",
  InitializationCell->True],
Cell[6584, 231, 416, 13, 108, "Input",
  Evaluatable->False,
  InitializationCell->True],
Cell[7003, 246, 447, 14, 108, "Input",
  Evaluatable->False,
  InitializationCell->True],
Cell[7453, 262, 259, 8, 44, "Input",
  Evaluatable->False,
  InitializationCell->True],
Cell[7715, 272, 204, 7, 44, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[7944, 283, 108, 3, 28, "Input"],
Cell[8055, 288, 79, 2, 24, "Print"],
Cell[8137, 292, 45826, 761, 903, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[54000, 1058, 141, 6, 44, "Input"],
Cell[54144, 1066, 1661, 49, 220, "Output"],
Cell[55808, 1117, 532, 15, 64, "Output"]
}, Closed]],
Cell[56355, 1135, 604, 16, 137, "Input",
  InitializationCell->True],
Cell[56962, 1153, 694, 17, 364, "Input",
  InitializationCell->True],
Cell[57659, 1172, 1497, 28, 1160, "Input",
  InitializationCell->True,
  CellTags->"TimeUpNonlinearPSD"],

Cell[CellGroupData[{
Cell[59181, 1204, 286, 8, 60, "Input"],
Cell[59470, 1214, 186, 7, 56, "Print"],
Cell[59659, 1223, 540, 15, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[60236, 1243, 173, 6, 44, "Input"],
Cell[60412, 1251, 329, 11, 36, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[60778, 1267, 174, 6, 44, "Input"],
Cell[60955, 1275, 405, 12, 36, "Output"],
Cell[61363, 1289, 289, 9, 36, "Output"]
}, Open  ]],
Cell[61667, 1301, 1921, 35, 1256, "Input",
  InitializationCell->True,
  CellTags->"TimeUpNonlinearPSDMulti4"],
Cell[63591, 1338, 222, 8, 44, "Input",
  InitializationCell->True],
Cell[63816, 1348, 284, 11, 92, "Input",
  InitializationCell->True],
Cell[64103, 1361, 538, 24, 300, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[64666, 1389, 99, 3, 28, "Input"],
Cell[64768, 1394, 682, 17, 200, "Print"]
}, Open  ]],
Cell[65465, 1414, 467, 14, 140, "Input",
  InitializationCell->True],
Cell[65935, 1430, 742, 25, 300, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[66702, 1459, 111, 3, 28, "Input"],
Cell[66816, 1464, 4170, 85, 656, "Output"]
}, Open  ]],
Cell[71001, 1552, 466, 16, 172, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[71492, 1572, 138, 6, 44, "Input"],
Cell[71633, 1580, 1906, 32, 371, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[73576, 1617, 107, 3, 28, "Input"],
Cell[73686, 1622, 338, 11, 40, "Output"]
}, Open  ]],
Cell[74039, 1636, 43, 1, 26, "Input"],

Cell[CellGroupData[{
Cell[74107, 1641, 128, 2, 26, "Input"],
Cell[74238, 1645, 164, 3, 30, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[74439, 1653, 181, 6, 28, "Input"],
Cell[74623, 1661, 1240, 30, 124, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[75900, 1696, 510, 17, 188, "Input",
  InitializationCell->True],
Cell[76413, 1715, 285, 5, 24, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[76735, 1725, 102, 3, 28, "Input"],
Cell[76840, 1730, 50, 1, 24, "Print"],
Cell[76893, 1733, 35502, 564, 1264, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[112432, 2302, 218, 6, 41, "Input"],
Cell[112653, 2310, 62, 2, 28, "Output"],
Cell[112718, 2314, 62, 2, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[112817, 2321, 227, 8, 76, "Input"],
Cell[113047, 2331, 199, 4, 30, "Output"],
Cell[113249, 2337, 220, 6, 30, "Output"],
Cell[113472, 2345, 74, 3, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[113583, 2353, 99, 3, 28, "Input"],
Cell[113685, 2358, 209, 8, 26, "Output"]
}, Open  ]],
Cell[113909, 2369, 535, 13, 108, "Input",
  InitializationCell->True],
Cell[114447, 2384, 1021, 26, 332, "Input",
  Evaluatable->False,
  InitializationCell->True],

Cell[CellGroupData[{
Cell[115493, 2414, 204, 7, 44, "Input",
  InitializationCell->True],
Cell[115700, 2423, 333, 5, 21, "Message"]
}, Open  ]],
Cell[116048, 2431, 124, 3, 28, "Input"],

Cell[CellGroupData[{
Cell[116197, 2438, 98, 3, 28, "Input"],
Cell[116298, 2443, 68, 1, 34, "Print",
  CellTags->"Info3417436417-6139240"],
Cell[116369, 2446, 175479, 2907, 3679, "Print",
  CellTags->"Info3417436417-6139240"]
}, Closed]],
Cell[291863, 5356, 98, 3, 25, "Input"],

Cell[CellGroupData[{
Cell[291986, 5363, 108, 3, 28, "Input"],
Cell[292097, 5368, 564, 22, 263, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[292698, 5395, 35, 1, 23, "Input"],
Cell[292736, 5398, 36, 1, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[292809, 5404, 179, 6, 44, "Input"],
Cell[292991, 5412, 167, 2, 28, "Output"],
Cell[293161, 5416, 161, 2, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[293359, 5423, 110, 2, 26, "Input"],
Cell[293472, 5427, 1010, 28, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[294519, 5460, 188, 6, 44, "Input"],
Cell[294710, 5468, 229, 3, 26, "Output"],
Cell[294942, 5473, 220, 3, 26, "Output"]
}, Open  ]],
Cell[295177, 5479, 385, 14, 156, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[295587, 5497, 48, 1, 28, "Input"],
Cell[295638, 5500, 55, 2, 24, "Print"],
Cell[295696, 5504, 59, 2, 28, "Output"]
}, Open  ]],
Cell[295770, 5509, 2396, 45, 1660, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[298191, 5558, 40, 1, 28, "Input"],
Cell[298234, 5561, 45, 1, 24, "Print"],
Cell[298282, 5564, 1119, 26, 129, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[299438, 5595, 41, 1, 26, "Input"],
Cell[299482, 5598, 67, 1, 34, "Print",
  CellTags->"Info3416764132-1117871"],
Cell[299552, 5601, 1141, 26, 113, "Print",
  CellTags->"Info3416764132-1117871"]
}, Open  ]],
Cell[300708, 5630, 3441, 65, 2344, "Input",
  InitializationCell->True,
  CellTags->"TimeUpNonlinearPSDMulti"],

Cell[CellGroupData[{
Cell[304174, 5699, 51, 1, 28, "Input"],
Cell[304228, 5702, 78, 1, 34, "Print",
  CellTags->"Info3416814232-9536192"],
Cell[304309, 5705, 823, 20, 49, "Print",
  CellTags->"Info3416814232-9536192"]
}, Open  ]],

Cell[CellGroupData[{
Cell[305169, 5730, 38, 1, 28, "Input"],
Cell[305210, 5733, 120, 2, 34, "Print",
  CellTags->"Info3416814239-9199848"],
Cell[305333, 5737, 579, 16, 64, "Print",
  CellTags->"Info3416814239-9199848"]
}, Open  ]],

Cell[CellGroupData[{
Cell[305949, 5758, 49, 1, 28, "Input"],
Cell[306001, 5761, 59, 2, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[306097, 5768, 104, 3, 28, "Input"],
Cell[306204, 5773, 24116, 439, 70, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[330357, 6217, 126, 6, 41, "Input"],
Cell[330486, 6225, 426, 12, 104, "Print"]
}, Open  ]],
Cell[330927, 6240, 1283, 25, 684, "Input",
  InitializationCell->True],
Cell[332213, 6267, 1415, 58, 828, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[333653, 6329, 462, 15, 188, "Input"],
Cell[334118, 6346, 246, 11, 120, "Print"],
Cell[334367, 6359, 238, 9, 26, "Output"],
Cell[334608, 6370, 237, 9, 26, "Output"],
Cell[334848, 6381, 203, 8, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[335088, 6394, 96, 3, 28, "Input"],
Cell[335187, 6399, 129, 7, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[335353, 6411, 177, 7, 60, "Input"],
Cell[335533, 6420, 168, 8, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[335738, 6433, 173, 7, 60, "Input"],
Cell[335914, 6442, 169, 8, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[336120, 6455, 134, 3, 28, "Input"],
Cell[336257, 6460, 159, 8, 26, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[336453, 6473, 1949, 34, 1276, "Input",
  InitializationCell->True],
Cell[338405, 6509, 212, 7, 70, "Message"],
Cell[338620, 6518, 213, 7, 70, "Message"],
Cell[338836, 6527, 213, 7, 70, "Message"],
Cell[339052, 6536, 197, 6, 70, "Message"]
}, Open  ]],
Cell[339264, 6545, 1285, 68, 70, "Input",
  InitializationCell->True],
Cell[340552, 6615, 94, 3, 70, "Input"],

Cell[CellGroupData[{
Cell[340671, 6622, 169, 6, 70, "Input"],
Cell[340843, 6630, 2756, 67, 70, "Output"]
}, Open  ]],
Cell[343614, 6700, 499, 21, 70, "Input",
  InitializationCell->True],
Cell[344116, 6723, 533, 18, 70, "Input",
  InitializationCell->True],
Cell[344652, 6743, 575, 22, 70, "Input",
  InitializationCell->True],
Cell[345230, 6767, 787, 30, 70, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[346042, 6801, 94, 3, 27, "Input"],
Cell[346139, 6806, 136, 6, 70, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[346312, 6817, 95, 3, 27, "Input"],
Cell[346410, 6822, 191, 8, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[346638, 6835, 174, 7, 42, "Input"],
Cell[346815, 6844, 310, 10, 25, "Output"]
}, Open  ]],
Cell[347140, 6857, 933, 39, 492, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[348098, 6900, 220, 7, 57, "Input"],
Cell[348321, 6909, 190, 7, 53, "Print"],
Cell[348514, 6918, 290, 9, 25, "Output"]
}, Open  ]],
Cell[348819, 6930, 1223, 50, 669, "Input",
  InitializationCell->True,
  CellTags->"MessupHermite2"],

Cell[CellGroupData[{
Cell[350067, 6984, 217, 7, 57, "Input"],
Cell[350287, 6993, 190, 7, 56, "Print"],
Cell[350480, 7002, 309, 10, 26, "Output"]
}, Open  ]],
Cell[350804, 7015, 2024, 79, 1176, "Input",
  InitializationCell->True,
  CellTags->"MessupHermite3"],
Cell[352831, 7096, 2141, 82, 1192, "Input",
  InitializationCell->True,
  CellTags->"MessupHermite4"],

Cell[CellGroupData[{
Cell[354997, 7182, 104, 3, 28, "Input"],
Cell[355104, 7187, 238, 7, 56, "Print"]
}, Open  ]],
Cell[355357, 7197, 2577, 43, 1720, "Input",
  InitializationCell->True,
  CellTags->"MessupHermite4Multi"],
Cell[357937, 7242, 2958, 48, 2136, "Input",
  InitializationCell->True,
  CellTags->"MessupHermiteNorKorrMulti"],
Cell[360898, 7292, 3690, 59, 2568, "Input",
  InitializationCell->True,
  CellTags->"MessupHermite5Multi"],
Cell[364591, 7353, 635, 26, 300, "Input",
  InitializationCell->True],
Cell[365229, 7381, 651, 26, 348, "Input",
  InitializationCell->True],
Cell[365883, 7409, 3732, 59, 2520, "Input",
  InitializationCell->True,
  CellTags->"MessupHermite6Multi"],

Cell[CellGroupData[{
Cell[369640, 7472, 432, 11, 108, "Input"],
Cell[370075, 7485, 203, 7, 56, "Print"],
Cell[370281, 7494, 381, 13, 36, "Output"],
Cell[370665, 7509, 276, 10, 26, "Output"],
Cell[370944, 7521, 380, 13, 36, "Output"],
Cell[371327, 7536, 450, 15, 36, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[371814, 7556, 432, 11, 108, "Input"],
Cell[372249, 7569, 204, 7, 56, "Print"],
Cell[372456, 7578, 379, 13, 40, "Output"],
Cell[372838, 7593, 446, 16, 40, "Output"],
Cell[373287, 7611, 384, 13, 40, "Output"],
Cell[373674, 7626, 451, 16, 40, "Output"]
}, Open  ]],
Cell[374140, 7645, 1364, 53, 748, "Input",
  InitializationCell->True],
Cell[375507, 7700, 167, 6, 26, "Input"],

Cell[CellGroupData[{
Cell[375699, 7710, 604, 17, 194, "Input"],
Cell[376306, 7729, 467, 16, 176, "Print"],
Cell[376776, 7747, 326, 10, 33, "Output"],
Cell[377105, 7759, 330, 10, 33, "Output"],
Cell[377438, 7771, 326, 10, 33, "Output"],
Cell[377767, 7783, 326, 10, 33, "Output"]
}, Open  ]],
Cell[378108, 7796, 1868, 79, 1018, "Input",
  InitializationCell->True,
  CellTags->"MessupHermite2Norkorr"],

Cell[CellGroupData[{
Cell[380001, 7879, 224, 7, 57, "Input"],
Cell[380228, 7888, 238, 8, 68, "Print"],
Cell[380469, 7898, 291, 9, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[380797, 7912, 224, 7, 57, "Input"],
Cell[381024, 7921, 238, 8, 68, "Print"],
Cell[381265, 7931, 292, 9, 25, "Output"]
}, Open  ]],
Cell[381572, 7943, 1732, 31, 1084, "Input",
  InitializationCell->True],
Cell[383307, 7976, 1732, 31, 957, "Input",
  InitializationCell->True],
Cell[385042, 8009, 2098, 36, 1196, "Input",
  InitializationCell->True],
Cell[387143, 8047, 427, 26, 332, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[387595, 8077, 173, 4, 60, "Input"],
Cell[387771, 8083, 386, 14, 168, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[388194, 8102, 95, 3, 28, "Input"],
Cell[388292, 8107, 121, 6, 40, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[388450, 8118, 96, 3, 28, "Input"],
Cell[388549, 8123, 157, 8, 36, "Output"]
}, Open  ]],
Cell[388721, 8134, 2496, 49, 1464, "Input",
  InitializationCell->True,
  CellTags->"GGHF"],
Cell[391220, 8185, 1856, 84, 1256, "Input",
  InitializationCell->True,
  CellTags->"GGHFMulti"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

