(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      8992,        265]*)
(*NotebookOutlinePosition[     10080,        299]*)
(*  CellTagsIndexPosition[     10036,        295]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
  "User ",
  StyleBox["Mathematica\[Trademark]",
    FontSlant->"Italic"],
  " \nInitialization File"
}], "Title",
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[{
  "     This file is read in every time the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " kernel is started up.  You can insert anything you like in the following \
cell(s).  For example, if you have defined a function you use very often, you \
can put it in this file, and it will be loaded every time you use ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ".\n     You can also add new folders to the kernel search path.  If you \
have several Notebook you want to be able to load in using the kernel file \
reading function \"<<",
  StyleBox["filename ",
    FontSlant->"Italic"],
  "\", you can put them together in a folder and add its path name to the \
list below."
}], "Text",
  CellMargins->{{Inherited, 129}, {Inherited, Inherited}},
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Path", "Subsubsection",
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[{
  "To add a folder to the kernel search path, put a line like the following \
in the initialization cell below.\n\n$Path = Join[$Path, {\"",
  StyleBox["HD20:Mathematica\[Trademark] Data:My Notebooks ",
    FontSlant->"Italic"],
  "\"}]\n\nAdd one such line for each folder you want to add to the path.  \
The path name in quotes must be the complete path name of the folder.  The \
example given is for a folder named \"My Notebooks\" which is in another \
folder named \"Mathematica\[Trademark] Data\" on a disk named \"HD20\".  Note \
the colons between disk/folder names."
}], "Text",
  InitializationCell->True,
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[" ", "Input",
  PageWidth->PaperWidth,
  InitializationCell->True,
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Default ViewPoint", "Subsubsection",
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[TextData[{
  "     If you want to permanently change the default viewpoint for 3D \
graphics, you can do it by editing the cell below, and then making the cell \
active (use the ",
  StyleBox["Inactive",
    FontWeight->"Bold"],
  " command in the Cell menu).  To adjust the default viewpoint, do the \
following:\n     \n     1) Select the text \"ViewPoint->{x, y, z}\" in the \
cell below.\n     2) Bring up the 3D ViewPoint Selector dialog box (using the \
command in the Prepare Input submenu of the Action menu).\n     3) Use the \
mouse to select the viewpoint you want in the dialog box.\n     4) Click the \
Paste Button.\n     5) Choose ",
  StyleBox["Inactive",
    FontWeight->"Bold"],
  " from the Cell menu (if it is not currently checked, then don't choose \
it).\n     6) Choose ",
  StyleBox["Save",
    FontWeight->"Bold"],
  " from the file menu.\n     \n     The next time you restart ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", the cell below will be evaluated, which will reset the default viewpoint \
for that session."
}], "Text",
  InitializationCell->True,
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
SetOptions[
   {Plot3D, ListPlot3D, Graphics3D, SurfaceGraphics},
   ViewPoint->{x, y, z}];\
\>", "Input",
  PageWidth->PaperWidth,
  Evaluatable->False,
  InitializationCell->True,
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Closed]],

Cell[CellGroupData[{

Cell["User Initialization", "Subsubsection",
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \($Path\)], "Input"],

Cell[BoxData[
    \({"Macintosh HD:Mathematica 4.2 Files:AddOns:JLink", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Kernel", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Autoload", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Applications", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Kernel", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Autoload", 
      "Macintosh HD:Systemordner:Preferences:Mathematica:Applications", ":", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:StandardPackages", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:StandardPackages:StartUp", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:Autoload", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:Applications", 
      "Macintosh HD:Mathematica 4.2 Files:AddOns:ExtraPackages", 
      "Macintosh HD:Mathematica 4.2 Files:SystemFiles:Graphics:Packages", 
      "Macintosh HD:Mathematica 4.2 Files:Configuration:Kernel", 
      "Macintosh HD:Mathematica 2.2.2:Hermann.Notebooks:SDE", 
      "Macintosh HD:Mathematica 2.2.2:Hermann.Notebooks:SDE:code", 
      "Macintosh HD:Mathematica \
2.2.2:Hermann.Notebooks:SDE:applications"}\)], "Output"]
}, Open  ]],

Cell["\<\
Insert anything you would like to be evaluated every time the \
kernel is started up in the initialization cell below:\
\>", "Text",
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
  "$Path = Join[$Path,{\"Macintosh HD:",
  StyleBox["Mathematica ",
    FontSlant->"Italic"],
  "2.2.2:Hermann.Notebooks:SDE\"}]\n$Path = Join[$Path,{\"Macintosh HD:",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 2.2.2:Hermann.Notebooks:SDE:code\"}] \n$Path = Join[$Path,{\"Macintosh \
HD:",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 2.2.2:Hermann.Notebooks:SDE:applications\"}] \n\n",
  StyleBox["(*or any other paths*)   ",
    FontColor->RGBColor[1, 0, 0]],
  "\n   \n\nN2  = N[#,2]&\nN3  = N[#,3]&\nN4  = N[#,4]&\nN5  = N[#,5]&\nN6  = \
N[#,6]&\nN7  = N[#,7]&\nN8  = N[#,8]&\nN9  = N[#,9]&\nN10 = N[#,10]&\nN16 = \
N[#,16]&\n\n\nI1=IdentityMatrix[1];\nI2=IdentityMatrix[2];\n\
I3=IdentityMatrix[3];\nI4=IdentityMatrix[4];\nI5=IdentityMatrix[5];\n\n\n\
Tensor3Q = TensorRank[#]===3 &\nTensor2Q = TensorRank[#]===2 &"
}], "Input",
  PageWidth->PaperWidth,
  CellMargins->{{41, -333}, {Inherited, Inherited}},
  InitializationCell->True,
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\





<<code`Kronecker`
<<code`LSD`




 
SetOptions[ListPlot,PlotRange \
->All,Axes->False,Frame->True,PlotJoined->True]; 
\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t
SetOptions[Plot,PlotStyle->Table[{Hue[i],Thickness[.007]},{i,0,1,.1}],
\t\t\t\tPlotRange->All,
\t\t\t\tFrame    ->True,
\t\t\t\tAxes     ->False];
\t\t\t\t\t\t\t\t\t
SetOptions[TableForm, TableDirections->{Column,Column,Row},
\t\t\t\t\t  TableSpacing->{1,0,1},
\t\t\t\t\t  TableHeadings->Automatic];
\t\t\t\t\t \t\t\t\t\t\t\t\t\t\t\t\t\t\t\t 
SetOptions[MatrixForm,TableSpacing->{0,1},
\t\t\t\t      TableHeadings->Automatic];\t
\t\t\t\t      \t\t
SetOptions[Graphics,PlotRange->All];\t\t \t\t\t\t\t\t\t\t\t\t\t\t

SetOptions[GraphicsArray,GraphicsSpacing->0];
\t\t   
Format[LineBreak[_]] = \"\"
Format[Indent[_]] = \" \"\
\>", "Input",
  PageWidth->Infinity,
  CellMargins->{{41, -146}, {Inherited, Inherited}},
  InitializationCell->True,
  AspectRatioFixed->False,
  ImageRegion->{{-0, 1}, {0, 1}}]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
AutoGeneratedPackage->Automatic,
WindowToolbars->"RulerBar",
CellGrouping->Manual,
WindowSize->{914, 691},
WindowMargins->{{36, Automatic}, {Automatic, 3}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
MacintoshSystemPageSetup->"\<\
00<0001804P000000`d26_oQon@3:`8g0dL5N`?P0080001804P000000]P2:001
0000I00000400`<30?l00BL?00400@0000000000000006P801T1T00000000000
00000000004000000000000000000000\>"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 191, 7, 156, "Title"],
Cell[1970, 62, 843, 19, 84, "Text"],

Cell[CellGroupData[{
Cell[2838, 85, 90, 2, 42, "Subsubsection"],
Cell[2931, 89, 693, 13, 112, "Text",
  InitializationCell->True],
Cell[3627, 104, 132, 4, 27, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3796, 113, 103, 2, 28, "Subsubsection"],
Cell[3902, 117, 1163, 26, 198, "Text",
  InitializationCell->True],
Cell[5068, 145, 252, 9, 57, "Input",
  Evaluatable->False,
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[5357, 159, 105, 2, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[5487, 165, 38, 1, 39, "Input"],
Cell[5528, 168, 1196, 18, 233, "Output"]
}, Open  ]],
Cell[6739, 189, 203, 5, 30, "Text"]
}, Open  ]]
}, Open  ]],
Cell[6969, 198, 1040, 24, 432, "Input",
  InitializationCell->True],
Cell[8012, 224, 976, 39, 492, "Input",
  InitializationCell->True]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

